webpackJsonp([173],[
/* 0 */,
/* 1 */,
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__sites_factory__ = __webpack_require__(345);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_13_ts_md5_dist_md5__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__angular_common__ = __webpack_require__(14);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















/*
 * Service to manage and interact with sites.
 * It allows creating tables in the databases of all sites. Each service or component should be responsible of creating
 * their own database tables. Example:
 *
 * constructor(sitesProvider: CoreSitesProvider) {
 *     this.sitesProvider.createTableFromSchema(this.tableSchema);
 *
 * This provider will automatically create the tables in the databases of all the instantiated sites, and also to the
 * databases of sites instantiated from now on.
*/
var CoreSitesProvider = /** @class */ (function () {
    function CoreSitesProvider(logger, http, sitesFactory, appProvider, translate, urlUtils, eventsProvider, textUtils, location, utils) {
        this.http = http;
        this.sitesFactory = sitesFactory;
        this.appProvider = appProvider;
        this.translate = translate;
        this.urlUtils = urlUtils;
        this.eventsProvider = eventsProvider;
        this.textUtils = textUtils;
        this.location = location;
        this.utils = utils;
        // Variables for the database.
        this.SITES_TABLE = 'sites';
        this.CURRENT_SITE_TABLE = 'current_site';
        this.SCHEMA_VERSIONS_TABLE = 'schema_versions';
        this.appTablesSchema = [
            {
                name: this.SITES_TABLE,
                columns: [
                    {
                        name: 'id',
                        type: 'TEXT',
                        primaryKey: true
                    },
                    {
                        name: 'siteUrl',
                        type: 'TEXT',
                        notNull: true
                    },
                    {
                        name: 'token',
                        type: 'TEXT'
                    },
                    {
                        name: 'info',
                        type: 'TEXT'
                    },
                    {
                        name: 'privateToken',
                        type: 'TEXT'
                    },
                    {
                        name: 'config',
                        type: 'TEXT'
                    },
                    {
                        name: 'loggedOut',
                        type: 'INTEGER'
                    }
                ]
            },
            {
                name: this.CURRENT_SITE_TABLE,
                columns: [
                    {
                        name: 'id',
                        type: 'INTEGER',
                        primaryKey: true
                    },
                    {
                        name: 'siteId',
                        type: 'TEXT',
                        notNull: true,
                        unique: true
                    }
                ]
            }
        ];
        // Constants to validate a site version.
        this.VALID_VERSION = 1;
        this.LEGACY_APP_VERSION = 0;
        this.INVALID_VERSION = -1;
        this.services = {};
        this.sessionRestored = false;
        this.sites = {};
        this.siteSchemasMigration = {};
        // Schemas for site tables. Other providers can add schemas in here.
        this.siteSchemas = {};
        this.siteTablesSchemas = [
            {
                name: this.SCHEMA_VERSIONS_TABLE,
                columns: [
                    {
                        name: 'name',
                        type: 'TEXT',
                        primaryKey: true,
                    },
                    {
                        name: 'version',
                        type: 'INTEGER'
                    }
                ]
            }
        ];
        // Site schema for this provider.
        this.siteSchema = {
            name: 'CoreSitesProvider',
            version: 1,
            canBeCleared: [__WEBPACK_IMPORTED_MODULE_12__classes_site__["a" /* CoreSite */].WS_CACHE_TABLE],
            tables: [
                {
                    name: __WEBPACK_IMPORTED_MODULE_12__classes_site__["a" /* CoreSite */].WS_CACHE_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'TEXT',
                            primaryKey: true
                        },
                        {
                            name: 'data',
                            type: 'TEXT'
                        },
                        {
                            name: 'key',
                            type: 'TEXT'
                        },
                        {
                            name: 'expirationTime',
                            type: 'INTEGER'
                        }
                    ]
                },
                {
                    name: __WEBPACK_IMPORTED_MODULE_12__classes_site__["a" /* CoreSite */].CONFIG_TABLE,
                    columns: [
                        {
                            name: 'name',
                            type: 'TEXT',
                            unique: true,
                            notNull: true
                        },
                        {
                            name: 'value'
                        }
                    ]
                }
            ]
        };
        this.logger = logger.getInstance('CoreSitesProvider');
        this.appDB = appProvider.getDB();
        this.appDB.createTablesFromSchema(this.appTablesSchema);
        this.registerSiteSchema(this.siteSchema);
    }
    /**
     * Get the demo data for a certain "name" if it is a demo site.
     *
     * @param {string} name Name of the site to check.
     * @return {any} Site data if it's a demo site, undefined otherwise.
     */
    CoreSitesProvider.prototype.getDemoSiteData = function (name) {
        var demoSites = __WEBPACK_IMPORTED_MODULE_11__configconstants__["a" /* CoreConfigConstants */].demo_sites;
        if (typeof demoSites != 'undefined' && typeof demoSites[name] != 'undefined') {
            return demoSites[name];
        }
    };
    /**
     * Check if a site is valid and if it has specifics settings for authentication (like force to log in using the browser).
     * It will test both protocols if the first one fails: http and https.
     *
     * @param {string} siteUrl URL of the site to check.
     * @param {string} [protocol=https://] Protocol to use first.
     * @return {Promise<CoreSiteCheckResponse>} A promise resolved when the site is checked.
     */
    CoreSitesProvider.prototype.checkSite = function (siteUrl, protocol) {
        var _this = this;
        if (protocol === void 0) { protocol = 'https://'; }
        // The formatURL function adds the protocol if is missing.
        siteUrl = this.urlUtils.formatURL(siteUrl);
        if (!this.urlUtils.isHttpURL(siteUrl)) {
            return Promise.reject(this.translate.instant('core.login.invalidsite'));
        }
        else if (!this.appProvider.isOnline()) {
            return Promise.reject(this.translate.instant('core.networkerrormsg'));
        }
        else {
            return this.checkSiteWithProtocol(siteUrl, protocol).catch(function (error) {
                // Do not continue checking if a critical error happened.
                if (error.critical) {
                    return Promise.reject(error.error);
                }
                // Retry with the other protocol.
                protocol = protocol == 'https://' ? 'http://' : 'https://';
                return _this.checkSiteWithProtocol(siteUrl, protocol).catch(function (secondError) {
                    if (secondError.critical) {
                        return Promise.reject(secondError.error);
                    }
                    // Site doesn't exist. Return the error message.
                    return Promise.reject(_this.textUtils.getErrorMessageFromError(error) ||
                        _this.textUtils.getErrorMessageFromError(secondError) ||
                        _this.translate.instant('core.cannotconnect'));
                });
            });
        }
    };
    /**
     * Helper function to check if a site is valid and if it has specifics settings for authentication.
     *
     * @param {string} siteUrl URL of the site to check.
     * @param {string} protocol Protocol to use.
     * @return {Promise<CoreSiteCheckResponse>} A promise resolved when the site is checked.
     */
    CoreSitesProvider.prototype.checkSiteWithProtocol = function (siteUrl, protocol) {
        var _this = this;
        var publicConfig;
        // Now, replace the siteUrl with the protocol.
        siteUrl = siteUrl.replace(/^http(s)?\:\/\//i, protocol);
        return this.siteExists(siteUrl).catch(function (error) {
            // Do not continue checking if WS are not enabled.
            if (error.errorcode == 'enablewsdescription') {
                return rejectWithCriticalError(error.error, error.errorcode);
            }
            // Site doesn't exist. Try to add or remove 'www'.
            var treatedUrl = _this.urlUtils.addOrRemoveWWW(siteUrl);
            return _this.siteExists(treatedUrl).then(function () {
                // Success, use this new URL as site url.
                siteUrl = treatedUrl;
            }).catch(function (secondError) {
                // Do not continue checking if WS are not enabled.
                if (secondError.errorcode == 'enablewsdescription') {
                    return rejectWithCriticalError(secondError.error, secondError.errorcode);
                }
                // Return the error message.
                return Promise.reject(_this.textUtils.getErrorMessageFromError(error) ||
                    _this.textUtils.getErrorMessageFromError(secondError));
            });
        }).then(function () {
            // Create a temporary site to check if local_mobile is installed.
            var temporarySite = _this.sitesFactory.makeSite(undefined, siteUrl);
            return temporarySite.checkLocalMobilePlugin().then(function (data) {
                data.service = data.service || __WEBPACK_IMPORTED_MODULE_11__configconstants__["a" /* CoreConfigConstants */].wsservice;
                _this.services[siteUrl] = data.service; // No need to store it in DB.
                if (data.coreSupported ||
                    (data.code != __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].LOGIN_SSO_CODE && data.code != __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].LOGIN_SSO_INAPP_CODE)) {
                    // SSO using local_mobile not needed, try to get the site public config.
                    return temporarySite.getPublicConfig().then(function (config) {
                        publicConfig = config;
                        // Check that the user can authenticate.
                        if (!config.enablewebservices) {
                            return rejectWithCriticalError(_this.translate.instant('core.login.webservicesnotenabled'));
                        }
                        else if (!config.enablemobilewebservice) {
                            return rejectWithCriticalError(_this.translate.instant('core.login.mobileservicesnotenabled'));
                        }
                        else if (config.maintenanceenabled) {
                            var message = _this.translate.instant('core.sitemaintenance');
                            if (config.maintenancemessage) {
                                message += config.maintenancemessage;
                            }
                            return rejectWithCriticalError(message);
                        }
                        // Everything ok.
                        if (data.code === 0) {
                            data.code = config.typeoflogin;
                        }
                        return data;
                    }, function (error) {
                        // Error, check if not supported.
                        if (error.available === 1) {
                            // Service supported but an error happened. Return error.
                            return Promise.reject({ error: error.error });
                        }
                        return data;
                    });
                }
                return data;
            }).then(function (data) {
                siteUrl = temporarySite.getURL();
                return { siteUrl: siteUrl, code: data.code, warning: data.warning, service: data.service, config: publicConfig };
            });
        });
        // Return a rejected promise with a "critical" error.
        function rejectWithCriticalError(message, errorCode) {
            return Promise.reject({
                error: message,
                errorcode: errorCode,
                critical: true
            });
        }
    };
    /**
     * Check if a site exists.
     *
     * @param  {string} siteUrl URL of the site to check.
     * @return {Promise} A promise to be resolved if the site exists.
     */
    CoreSitesProvider.prototype.siteExists = function (siteUrl) {
        var _this = this;
        return this.http.post(siteUrl + '/login/token.php', {}).timeout(__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].WS_TIMEOUT).toPromise().catch(function () {
            // Default error messages are kinda bad, return our own message.
            return Promise.reject({ error: _this.translate.instant('core.cannotconnect') });
        }).then(function (data) {
            if (data.errorcode && (data.errorcode == 'enablewsdescription' || data.errorcode == 'requirecorrectaccess')) {
                return Promise.reject({ errorcode: data.errorcode, error: data.error });
            }
            else if (data.error && data.error == 'Web services must be enabled in Advanced features.') {
                return Promise.reject({ errorcode: 'enablewsdescription', error: data.error });
            }
            // Other errors are not being checked because invalid login will be always raised and we cannot differ them.
        });
    };
    /**
     * Gets a user token from the server.
     *
     * @param {string} siteUrl The site url.
     * @param {string} username User name.
     * @param {string} password Password.
     * @param {string} [service] Service to use. If not defined, it will be searched in memory.
     * @param {boolean} [retry] Whether we are retrying with a prefixed URL.
     * @return {Promise<CoreSiteUserTokenResponse>} A promise resolved when the token is retrieved.
     */
    CoreSitesProvider.prototype.getUserToken = function (siteUrl, username, password, service, retry) {
        var _this = this;
        if (!this.appProvider.isOnline()) {
            return Promise.reject(this.translate.instant('core.networkerrormsg'));
        }
        if (!service) {
            service = this.determineService(siteUrl);
        }
        var params = {
            username: username,
            password: password,
            service: service
        }, loginUrl = siteUrl + '/login/token.php', promise = this.http.post(loginUrl, params).timeout(__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].WS_TIMEOUT).toPromise();
        return promise.then(function (data) {
            if (typeof data == 'undefined') {
                return Promise.reject(_this.translate.instant('core.cannotconnect'));
            }
            else {
                if (typeof data.token != 'undefined') {
                    return { token: data.token, siteUrl: siteUrl, privateToken: data.privatetoken };
                }
                else {
                    if (typeof data.error != 'undefined') {
                        // We only allow one retry (to avoid loops).
                        if (!retry && data.errorcode == 'requirecorrectaccess') {
                            siteUrl = _this.urlUtils.addOrRemoveWWW(siteUrl);
                            return _this.getUserToken(siteUrl, username, password, service, true);
                        }
                        else if (data.errorcode == 'missingparam') {
                            // It seems the server didn't receive all required params, it could be due to a redirect.
                            return _this.utils.checkRedirect(loginUrl).then(function (redirect) {
                                if (redirect) {
                                    return Promise.reject({ error: _this.translate.instant('core.login.sitehasredirect') });
                                }
                                else {
                                    return Promise.reject({ error: data.error, errorcode: data.errorcode });
                                }
                            });
                        }
                        else if (typeof data.errorcode != 'undefined') {
                            return Promise.reject({ error: data.error, errorcode: data.errorcode });
                        }
                        else {
                            return Promise.reject(data.error);
                        }
                    }
                    else {
                        return Promise.reject(_this.translate.instant('core.login.invalidaccount'));
                    }
                }
            }
        }, function () {
            return Promise.reject(_this.translate.instant('core.cannotconnect'));
        });
    };
    /**
     * Add a new site to the site list and authenticate the user in this site.
     *
     * @param {string} siteUrl The site url.
     * @param {string} token User's token.
     * @param {string} [privateToken=''] User's private token.
     * @param {boolean} [login=true] Whether to login the user in the site. Defaults to true.
     * @return {Promise<string>} A promise resolved with siteId when the site is added and the user is authenticated.
     */
    CoreSitesProvider.prototype.newSite = function (siteUrl, token, privateToken, login) {
        var _this = this;
        if (privateToken === void 0) { privateToken = ''; }
        if (login === void 0) { login = true; }
        if (typeof login != 'boolean') {
            login = true;
        }
        // Create a "candidate" site to fetch the site info.
        var candidateSite = this.sitesFactory.makeSite(undefined, siteUrl, token, undefined, privateToken), isNewSite = true;
        return candidateSite.fetchSiteInfo().then(function (info) {
            var result = _this.isValidMoodleVersion(info);
            if (result == _this.VALID_VERSION) {
                var siteId_1 = _this.createSiteID(info.siteurl, info.username);
                // Check if the site already exists.
                return _this.getSite(siteId_1).catch(function () {
                    // Not exists.
                }).then(function (site) {
                    if (site) {
                        // Site already exists, update its data and use it.
                        isNewSite = false;
                        candidateSite = site;
                        candidateSite.setToken(token);
                        candidateSite.setPrivateToken(privateToken);
                        candidateSite.setInfo(info);
                    }
                    else {
                        // New site, set site ID and info.
                        isNewSite = true;
                        candidateSite.setId(siteId_1);
                        candidateSite.setInfo(info);
                        // Create database tables before login and before any WS call.
                        return _this.migrateSiteSchemas(candidateSite);
                    }
                }).then(function () {
                    // Try to get the site config.
                    return _this.getSiteConfig(candidateSite).catch(function (error) {
                        // Ignore errors if it's not a new site, we'll use the config already stored.
                        if (isNewSite) {
                            return Promise.reject(error);
                        }
                    }).then(function (config) {
                        if (typeof config != 'undefined') {
                            candidateSite.setConfig(config);
                        }
                        // Add site to sites list.
                        _this.addSite(siteId_1, siteUrl, token, info, privateToken, config);
                        _this.sites[siteId_1] = candidateSite;
                        // Turn candidate site into current site.
                        _this.currentSite = candidateSite;
                        // Store session.
                        _this.login(siteId_1);
                        _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */].SITE_ADDED, info, siteId_1);
                        return siteId_1;
                    });
                });
            }
            else if (result == _this.LEGACY_APP_VERSION) {
                var errorKey = 'core.login.legacymoodleversion', params = void 0;
                if (_this.appProvider.isDesktop()) {
                    errorKey += 'desktop';
                    params = { $a: siteUrl };
                }
                var error = _this.translate.instant(errorKey, params);
                if (_this.appProvider.isWindows() || _this.appProvider.isLinux()) {
                    error += _this.translate.instant('core.login.legacymoodleversiondesktopdownloadold');
                }
                return Promise.reject({
                    error: error,
                    errorcode: 'legacymoodleversion'
                });
            }
            else {
                return Promise.reject({
                    error: _this.translate.instant('core.login.invalidmoodleversion'),
                    errorcode: 'invalidmoodleversion'
                });
            }
        });
    };
    /**
     * Create a site ID based on site URL and username.
     *
     * @param {string} siteUrl The site url.
     * @param {string} username Username.
     * @return {string} Site ID.
     */
    CoreSitesProvider.prototype.createSiteID = function (siteUrl, username) {
        return __WEBPACK_IMPORTED_MODULE_13_ts_md5_dist_md5__["Md5"].hashAsciiStr(siteUrl + username);
    };
    /**
     * Function for determine which service we should use (default or extended plugin).
     *
     * @param {string} siteUrl The site URL.
     * @return {string} The service shortname.
     */
    CoreSitesProvider.prototype.determineService = function (siteUrl) {
        // We need to try siteUrl in both https or http (due to loginhttps setting).
        // First http://
        siteUrl = siteUrl.replace('https://', 'http://');
        if (this.services[siteUrl]) {
            return this.services[siteUrl];
        }
        // Now https://
        siteUrl = siteUrl.replace('http://', 'https://');
        if (this.services[siteUrl]) {
            return this.services[siteUrl];
        }
        // Return default service.
        return __WEBPACK_IMPORTED_MODULE_11__configconstants__["a" /* CoreConfigConstants */].wsservice;
    };
    /**
     * Check for the minimum required version.
     *
     * @param {any} info Site info.
     * @return {number} Either VALID_VERSION, LEGACY_APP_VERSION or INVALID_VERSION.
     */
    CoreSitesProvider.prototype.isValidMoodleVersion = function (info) {
        if (!info) {
            return this.INVALID_VERSION;
        }
        var version24 = 2012120300, // Moodle 2.4 version.
        release24 = '2.4', version31 = 2016052300, release31 = '3.1';
        // Try to validate by version.
        if (info.version) {
            var version = parseInt(info.version, 10);
            if (!isNaN(version)) {
                if (version >= version31) {
                    return this.VALID_VERSION;
                }
                else if (version >= version24) {
                    return this.LEGACY_APP_VERSION;
                }
                else {
                    return this.INVALID_VERSION;
                }
            }
        }
        // We couldn't validate by version number. Let's try to validate by release number.
        var release = this.getReleaseNumber(info.release || '');
        if (release) {
            if (release >= release31) {
                return this.VALID_VERSION;
            }
            if (release >= release24) {
                return this.LEGACY_APP_VERSION;
            }
        }
        // Couldn't validate it.
        return this.INVALID_VERSION;
    };
    /**
     * Returns the release number from site release info.
     *
     * @param  {string}  rawRelease Raw release info text.
     * @return {string}   Release number or empty.
     */
    CoreSitesProvider.prototype.getReleaseNumber = function (rawRelease) {
        var matches = rawRelease.match(/^\d(\.\d(\.\d+)?)?/);
        if (matches) {
            return matches[0];
        }
        return '';
    };
    /**
     * Check if site info is valid. If it's not, return error message.
     *
     * @param {any} info Site info.
     * @return {any} True if valid, object with error message to show and its params if not valid.
     */
    CoreSitesProvider.prototype.validateSiteInfo = function (info) {
        if (!info.firstname || !info.lastname) {
            var moodleLink = "<a core-link href=\"" + info.siteurl + "\">" + info.siteurl + "</a>";
            return { error: 'core.requireduserdatamissing', params: { $a: moodleLink } };
        }
        return true;
    };
    /**
     * Saves a site in local DB.
     *
     * @param {string} id Site ID.
     * @param {string} siteUrl Site URL.
     * @param {string} token User's token in the site.
     * @param {any} info Site's info.
     * @param {string} [privateToken=''] User's private token.
     * @param {any} [config] Site config (from tool_mobile_get_config).
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitesProvider.prototype.addSite = function (id, siteUrl, token, info, privateToken, config) {
        if (privateToken === void 0) { privateToken = ''; }
        var entry = {
            id: id,
            siteUrl: siteUrl,
            token: token,
            info: info ? JSON.stringify(info) : info,
            privateToken: privateToken,
            config: config ? JSON.stringify(config) : config,
            loggedOut: 0
        };
        return this.appDB.insertRecord(this.SITES_TABLE, entry);
    };
    /**
     * Login a user to a site from the list of sites.
     *
     * @param {string} siteId ID of the site to load.
     * @param {string} [pageName] Name of the page to go once authenticated if logged out. If not defined, site initial page.
     * @param {any} [params] Params of the page to go once authenticated if logged out.
     * @return {Promise<boolean>} Promise resolved with true if site is loaded, resolved with false if cannot login.
     */
    CoreSitesProvider.prototype.loadSite = function (siteId, pageName, params) {
        var _this = this;
        this.logger.debug("Load site " + siteId);
        return this.getSite(siteId).then(function (site) {
            _this.currentSite = site;
            if (site.isLoggedOut()) {
                // Logged out, trigger session expired event and stop.
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */].SESSION_EXPIRED, {
                    pageName: pageName,
                    params: params
                }, site.getId());
                return false;
            }
            // Check if local_mobile was installed to Moodle.
            return site.checkIfLocalMobileInstalledAndNotUsed().then(function () {
                // Local mobile was added. Throw invalid session to force reconnect and create a new token.
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */].SESSION_EXPIRED, {
                    pageName: pageName,
                    params: params
                }, siteId);
                return false;
            }, function () {
                _this.login(siteId);
                // Update site info. We don't block the UI.
                _this.updateSiteInfo(siteId);
                return true;
            });
        });
    };
    /**
     * Get current site.
     *
     * @return {CoreSite} Current site.
     */
    CoreSitesProvider.prototype.getCurrentSite = function () {
        return this.currentSite;
    };
    /**
     * Get the site home ID of the current site.
     *
     * @return {number} Current site home ID.
     */
    CoreSitesProvider.prototype.getCurrentSiteHomeId = function () {
        if (this.currentSite) {
            return this.currentSite.getSiteHomeId();
        }
        else {
            return 1;
        }
    };
    /**
     * Get current site ID.
     *
     * @return {string} Current site ID.
     */
    CoreSitesProvider.prototype.getCurrentSiteId = function () {
        if (this.currentSite) {
            return this.currentSite.getId();
        }
        else {
            return '';
        }
    };
    /**
     * Get current site User ID.
     *
     * @return {number} Current site User ID.
     */
    CoreSitesProvider.prototype.getCurrentSiteUserId = function () {
        if (this.currentSite) {
            return this.currentSite.getUserId();
        }
        else {
            return 0;
        }
    };
    /**
     * Check if the user is logged in a site.
     *
     * @return {boolean} Whether the user is logged in a site.
     */
    CoreSitesProvider.prototype.isLoggedIn = function () {
        return typeof this.currentSite != 'undefined' && typeof this.currentSite.token != 'undefined' &&
            this.currentSite.token != '';
    };
    /**
     * Delete a site from the sites list.
     *
     * @param {string} siteId ID of the site to delete.
     * @return {Promise<any>} Promise to be resolved when the site is deleted.
     */
    CoreSitesProvider.prototype.deleteSite = function (siteId) {
        var _this = this;
        this.logger.debug("Delete site " + siteId);
        if (typeof this.currentSite != 'undefined' && this.currentSite.id == siteId) {
            this.logout();
        }
        return this.getSite(siteId).then(function (site) {
            return site.deleteDB().then(function () {
                // Site DB deleted, now delete the app from the list of sites.
                delete _this.sites[siteId];
                return _this.appDB.deleteRecords(_this.SITES_TABLE, { id: siteId }).then(function () {
                    // Site deleted from sites list, now delete the folder.
                    return site.deleteFolder();
                }, function () {
                    // DB remove shouldn't fail, but we'll go ahead even if it does.
                    return site.deleteFolder();
                }).then(function () {
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */].SITE_DELETED, site, siteId);
                });
            });
        });
    };
    /**
     * Check if there are sites stored.
     *
     * @return {Promise<boolean>} Promise resolved with true if there are sites and false if there aren't.
     */
    CoreSitesProvider.prototype.hasSites = function () {
        return this.appDB.countRecords(this.SITES_TABLE).then(function (count) {
            return count > 0;
        });
    };
    /**
     * Returns a site object.
     *
     * @param {string} [siteId] The site ID. If not defined, current site (if available).
     * @return {Promise<CoreSite>} Promise resolved with the site.
     */
    CoreSitesProvider.prototype.getSite = function (siteId) {
        var _this = this;
        if (!siteId) {
            return this.currentSite ? Promise.resolve(this.currentSite) : Promise.reject(null);
        }
        else if (this.currentSite && this.currentSite.getId() == siteId) {
            return Promise.resolve(this.currentSite);
        }
        else if (typeof this.sites[siteId] != 'undefined') {
            return Promise.resolve(this.sites[siteId]);
        }
        else {
            // Retrieve and create the site.
            return this.appDB.getRecord(this.SITES_TABLE, { id: siteId }).then(function (data) {
                return _this.makeSiteFromSiteListEntry(data);
            });
        }
    };
    /**
     * Create a site from an entry of the sites list DB. The new site is added to the list of "cached" sites: this.sites.
     *
     * @param {any} entry Site list entry.
     * @return {Promise<CoreSite>} Promised resolved with the created site.
     */
    CoreSitesProvider.prototype.makeSiteFromSiteListEntry = function (entry) {
        var _this = this;
        var site, info = entry.info, config = entry.config;
        // Parse info and config.
        info = info ? this.textUtils.parseJSON(info) : info;
        config = config ? this.textUtils.parseJSON(config) : config;
        site = this.sitesFactory.makeSite(entry.id, entry.siteUrl, entry.token, info, entry.privateToken, config, entry.loggedOut == 1);
        return this.migrateSiteSchemas(site).then(function () {
            // Set site after migrating schemas, or a call to getSite could get the site while tables are being created.
            _this.sites[entry.id] = site;
            return site;
        });
    };
    /**
     * Returns if the site is the current one.
     *
     * @param {string|CoreSite} [site] Site object or siteId to be compared. If not defined, use current site.
     * @return {boolean} Whether site or siteId is the current one.
     */
    CoreSitesProvider.prototype.isCurrentSite = function (site) {
        if (!site || !this.currentSite) {
            return !!this.currentSite;
        }
        var siteId = typeof site == 'object' ? site.getId() : site;
        return this.currentSite.getId() === siteId;
    };
    /**
     * Returns the database object of a site.
     *
     * @param {string} [siteId] The site ID. If not defined, current site (if available).
     * @return {Promise<SQLiteDB>} Promise resolved with the database.
     */
    CoreSitesProvider.prototype.getSiteDb = function (siteId) {
        return this.getSite(siteId).then(function (site) {
            return site.getDb();
        });
    };
    /**
     * Returns the site home ID of a site.
     *
     * @param  {number} [siteId] The site ID. If not defined, current site (if available).
     * @return {Promise}         Promise resolved with site home ID.
     */
    CoreSitesProvider.prototype.getSiteHomeId = function (siteId) {
        return this.getSite(siteId).then(function (site) {
            return site.getSiteHomeId();
        });
    };
    /**
     * Get the list of sites stored.
     *
     * @param {String[]} [ids] IDs of the sites to get. If not defined, return all sites.
     * @return {Promise<CoreSiteBasicInfo[]>} Promise resolved when the sites are retrieved.
     */
    CoreSitesProvider.prototype.getSites = function (ids) {
        var _this = this;
        return this.appDB.getAllRecords(this.SITES_TABLE).then(function (sites) {
            var formattedSites = [];
            sites.forEach(function (site) {
                if (!ids || ids.indexOf(site.id) > -1) {
                    // Parse info.
                    var siteInfo = site.info ? _this.textUtils.parseJSON(site.info) : site.info, basicInfo = {
                        id: site.id,
                        siteUrl: site.siteUrl,
                        fullName: siteInfo && siteInfo.fullname,
                        siteName: __WEBPACK_IMPORTED_MODULE_11__configconstants__["a" /* CoreConfigConstants */].sitename ? __WEBPACK_IMPORTED_MODULE_11__configconstants__["a" /* CoreConfigConstants */].sitename : siteInfo && siteInfo.sitename,
                        avatar: siteInfo && siteInfo.userpictureurl
                    };
                    formattedSites.push(basicInfo);
                }
            });
            return formattedSites;
        });
    };
    /**
     * Get the list of sites stored, sorted by URL and full name.
     *
     * @param {String[]} [ids] IDs of the sites to get. If not defined, return all sites.
     * @return {Promise<CoreSiteBasicInfo[]>} Promise resolved when the sites are retrieved.
     */
    CoreSitesProvider.prototype.getSortedSites = function (ids) {
        return this.getSites(ids).then(function (sites) {
            // Sort sites by url and ful lname.
            sites.sort(function (a, b) {
                // First compare by site url without the protocol.
                var compareA = a.siteUrl.replace(/^https?:\/\//, '').toLowerCase(), compareB = b.siteUrl.replace(/^https?:\/\//, '').toLowerCase();
                var compare = compareA.localeCompare(compareB);
                if (compare !== 0) {
                    return compare;
                }
                // If site url is the same, use fullname instead.
                compareA = a.fullName.toLowerCase().trim();
                compareB = b.fullName.toLowerCase().trim();
                return compareA.localeCompare(compareB);
            });
            return sites;
        });
    };
    /**
     * Get the list of IDs of sites stored and not logged out.
     *
     * @return {Promise<string[]>} Promise resolved when the sites IDs are retrieved.
     */
    CoreSitesProvider.prototype.getLoggedInSitesIds = function () {
        return this.appDB.getRecords(this.SITES_TABLE, { loggedOut: 0 }).then(function (sites) {
            return sites.map(function (site) {
                return site.id;
            });
        });
    };
    /**
     * Get the list of IDs of sites stored.
     *
     * @return {Promise<string[]>} Promise resolved when the sites IDs are retrieved.
     */
    CoreSitesProvider.prototype.getSitesIds = function () {
        return this.appDB.getAllRecords(this.SITES_TABLE).then(function (sites) {
            return sites.map(function (site) {
                return site.id;
            });
        });
    };
    /**
     * Login the user in a site.
     *
     * @param {string} siteid ID of the site the user is accessing.
     * @return {Promise<void>} Promise resolved when current site is stored.
     */
    CoreSitesProvider.prototype.login = function (siteId) {
        var _this = this;
        var entry = {
            id: 1,
            siteId: siteId
        };
        return this.appDB.insertRecord(this.CURRENT_SITE_TABLE, entry).then(function () {
            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */].LOGIN, {}, siteId);
        });
    };
    /**
     * Logout the user.
     *
     * @return {Promise<any>} Promise resolved when the user is logged out.
     */
    CoreSitesProvider.prototype.logout = function () {
        var _this = this;
        if (!this.currentSite) {
            // Already logged out.
            return Promise.resolve();
        }
        var siteId = this.currentSite.getId(), siteConfig = this.currentSite.getStoredConfig(), promises = [];
        this.currentSite = undefined;
        if (siteConfig && siteConfig.tool_mobile_forcelogout == '1') {
            promises.push(this.setSiteLoggedOut(siteId, true));
        }
        promises.push(this.appDB.deleteRecords(this.CURRENT_SITE_TABLE, { id: 1 }));
        return Promise.all(promises).finally(function () {
            // Due to DeepLinker, we need to remove the path from the URL, otherwise some pages are re-created when they shouldn't.
            _this.location.replaceState('');
            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */].LOGOUT, {}, siteId);
        });
    };
    /**
     * Restores the session to the previous one so the user doesn't has to login everytime the app is started.
     *
     * @return {Promise<any>} Promise resolved if a session is restored.
     */
    CoreSitesProvider.prototype.restoreSession = function () {
        var _this = this;
        if (this.sessionRestored) {
            return Promise.reject(null);
        }
        this.sessionRestored = true;
        return this.appDB.getRecord(this.CURRENT_SITE_TABLE, { id: 1 }).then(function (currentSite) {
            var siteId = currentSite.siteId;
            _this.logger.debug("Restore session in site " + siteId);
            return _this.loadSite(siteId);
        }).catch(function () {
            // No current session.
        });
    };
    /**
     * Mark or unmark a site as logged out so the user needs to authenticate again.
     *
     * @param {string} siteId ID of the site.
     * @param {boolean} loggedOut True to set the site as logged out, false otherwise.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitesProvider.prototype.setSiteLoggedOut = function (siteId, loggedOut) {
        var _this = this;
        return this.getSite(siteId).then(function (site) {
            var newValues = {
                token: '',
                loggedOut: loggedOut ? 1 : 0
            };
            site.setLoggedOut(loggedOut);
            return _this.appDB.updateRecords(_this.SITES_TABLE, newValues, { id: siteId });
        });
    };
    /**
     * Unset current site.
     */
    CoreSitesProvider.prototype.unsetCurrentSite = function () {
        this.currentSite = undefined;
    };
    /**
     * Updates a site's token.
     *
     * @param {string} siteUrl Site's URL.
     * @param {string} username Username.
     * @param {string} token User's new token.
     * @param {string} [privateToken=''] User's private token.
     * @return {Promise<any>} A promise resolved when the site is updated.
     */
    CoreSitesProvider.prototype.updateSiteToken = function (siteUrl, username, token, privateToken) {
        var _this = this;
        if (privateToken === void 0) { privateToken = ''; }
        var siteId = this.createSiteID(siteUrl, username);
        return this.updateSiteTokenBySiteId(siteId, token, privateToken).then(function () {
            return _this.login(siteId);
        });
    };
    /**
     * Updates a site's token using siteId.
     *
     * @param {string} siteId Site Id.
     * @param {string} token User's new token.
     * @param {string} [privateToken=''] User's private token.
     * @return {Promise<any>} A promise resolved when the site is updated.
     */
    CoreSitesProvider.prototype.updateSiteTokenBySiteId = function (siteId, token, privateToken) {
        var _this = this;
        if (privateToken === void 0) { privateToken = ''; }
        return this.getSite(siteId).then(function (site) {
            var newValues = {
                token: token,
                privateToken: privateToken,
                loggedOut: 0
            };
            site.token = token;
            site.privateToken = privateToken;
            site.setLoggedOut(false); // Token updated means the user authenticated again, not logged out anymore.
            return _this.appDB.updateRecords(_this.SITES_TABLE, newValues, { id: siteId });
        });
    };
    /**
     * Updates a site's info.
     *
     * @param {string} siteid Site's ID.
     * @return {Promise<any>} A promise resolved when the site is updated.
     */
    CoreSitesProvider.prototype.updateSiteInfo = function (siteId) {
        var _this = this;
        return this.getSite(siteId).then(function (site) {
            return site.fetchSiteInfo().then(function (info) {
                site.setInfo(info);
                if (_this.isLegacyMoodleByInfo(info)) {
                    // The Moodle version is not supported, reject.
                    return Promise.reject(_this.translate.instant('core.login.legacymoodleversion'));
                }
                // Try to get the site config.
                return _this.getSiteConfig(site).catch(function () {
                    // Error getting config, keep the current one.
                }).then(function (config) {
                    var newValues = {
                        info: JSON.stringify(info),
                        loggedOut: site.isLoggedOut() ? 1 : 0
                    };
                    if (typeof config != 'undefined') {
                        site.setConfig(config);
                        newValues.config = JSON.stringify(config);
                    }
                    return _this.appDB.updateRecords(_this.SITES_TABLE, newValues, { id: siteId }).finally(function () {
                        _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */].SITE_UPDATED, info, siteId);
                    });
                });
            });
        });
    };
    /**
     * Updates a site's info.
     *
     * @param {string} siteUrl  Site's URL.
     * @param {string} username Username.
     * @return {Promise<any>} A promise to be resolved when the site is updated.
     */
    CoreSitesProvider.prototype.updateSiteInfoByUrl = function (siteUrl, username) {
        var siteId = this.createSiteID(siteUrl, username);
        return this.updateSiteInfo(siteId);
    };
    /**
     * Get the site IDs a URL belongs to.
     * Someone can have more than one account in the same site, that's why this function returns an array of IDs.
     *
     * @param {string} url URL to check.
     * @param {boolean} [prioritize] True if it should prioritize current site. If the URL belongs to current site then it won't
     *                               check any other site, it will only return current site.
     * @param {string} [username] If set, it will return only the sites where the current user has this username.
     * @return {Promise<string[]>} Promise resolved with the site IDs (array).
     */
    CoreSitesProvider.prototype.getSiteIdsFromUrl = function (url, prioritize, username) {
        var _this = this;
        // If prioritize is true, check current site first.
        if (prioritize && this.currentSite && this.currentSite.containsUrl(url)) {
            if (!username || this.currentSite.getInfo().username == username) {
                return Promise.resolve([this.currentSite.getId()]);
            }
        }
        // Check if URL has http(s) protocol.
        if (!url.match(/^https?:\/\//i)) {
            // URL doesn't have http(s) protocol. Check if it has any protocol.
            if (this.urlUtils.isAbsoluteURL(url)) {
                // It has some protocol. Return empty array.
                return Promise.resolve([]);
            }
            else {
                // No protocol, probably a relative URL. Return current site.
                if (this.currentSite) {
                    return Promise.resolve([this.currentSite.getId()]);
                }
                else {
                    return Promise.resolve([]);
                }
            }
        }
        return this.appDB.getAllRecords(this.SITES_TABLE).then(function (siteEntries) {
            var ids = [];
            var promises = [];
            siteEntries.forEach(function (site) {
                if (!_this.sites[site.id]) {
                    promises.push(_this.makeSiteFromSiteListEntry(site));
                }
                if (_this.sites[site.id].containsUrl(url)) {
                    if (!username || _this.sites[site.id].getInfo().username == username) {
                        ids.push(site.id);
                    }
                }
            });
            return Promise.all(promises).then(function () {
                return ids;
            });
        }).catch(function () {
            // Shouldn't happen.
            return [];
        });
    };
    /**
     * Get the site ID stored in DB as current site.
     *
     * @return {Promise<string>} Promise resolved with the site ID.
     */
    CoreSitesProvider.prototype.getStoredCurrentSiteId = function () {
        return this.appDB.getRecord(this.CURRENT_SITE_TABLE, { id: 1 }).then(function (currentSite) {
            return currentSite.siteId;
        });
    };
    /**
     * Get the public config of a certain site.
     *
     * @param {string} siteUrl URL of the site.
     * @return {Promise<any>} Promise resolved with the public config.
     */
    CoreSitesProvider.prototype.getSitePublicConfig = function (siteUrl) {
        var temporarySite = this.sitesFactory.makeSite(undefined, siteUrl);
        return temporarySite.getPublicConfig();
    };
    /**
     * Get site config.
     *
     * @param {any} site The site to get the config.
     * @return {Promise<any>} Promise resolved with config if available.
     */
    CoreSitesProvider.prototype.getSiteConfig = function (site) {
        if (!site.wsAvailable('tool_mobile_get_config')) {
            // WS not available, cannot get config.
            return Promise.resolve();
        }
        return site.getConfig(undefined, true);
    };
    /**
     * Check if a certain feature is disabled in a site.
     *
     * @param {string} name Name of the feature to check.
     * @param {string} [siteId] The site ID. If not defined, current site (if available).
     * @return {Promise<boolean>} Promise resolved with true if disabled.
     */
    CoreSitesProvider.prototype.isFeatureDisabled = function (name, siteId) {
        return this.getSite(siteId).then(function (site) {
            return site.isFeatureDisabled(name);
        });
    };
    /**
     * Create a table in all the sites databases.
     *
     * @param {SQLiteDBTamableSchema} table Table schema.
     */
    CoreSitesProvider.prototype.createTableFromSchema = function (table) {
        this.createTablesFromSchema([table]);
    };
    /**
     * Create several tables in all the sites databases.
     *
     * @param {SQLiteDBTamableSchema[]} tables List of tables schema.
     */
    CoreSitesProvider.prototype.createTablesFromSchema = function (tables) {
        // Add the tables to the list of schemas. This list is to create all the tables in new sites.
        this.siteTablesSchemas = this.siteTablesSchemas.concat(tables);
        // Now create these tables in current sites.
        for (var id in this.sites) {
            this.sites[id].getDb().createTablesFromSchema(tables);
        }
    };
    /**
     * Check if a WS is available in the current site, if any.
     *
     * @param {string} method WS name.
     * @param {boolean} [checkPrefix=true] When true also checks with the compatibility prefix.
     * @return {boolean} Whether the WS is available.
     */
    CoreSitesProvider.prototype.wsAvailableInCurrentSite = function (method, checkPrefix) {
        if (checkPrefix === void 0) { checkPrefix = true; }
        var site = this.getCurrentSite();
        return site && site.wsAvailable(method, checkPrefix);
    };
    /**
     * Check if a site is a legacy site by its info.
     *
     * @param {any} info The site info.
     * @return {boolean} Whether it's a legacy Moodle.
     */
    CoreSitesProvider.prototype.isLegacyMoodleByInfo = function (info) {
        return this.isValidMoodleVersion(info) == this.LEGACY_APP_VERSION;
    };
    /**
     * Register a site schema.
     */
    CoreSitesProvider.prototype.registerSiteSchema = function (schema) {
        this.siteSchemas[schema.name] = schema;
    };
    /**
     * Install and upgrade all the registered schemas and tables.
     *
     * @param {CoreSite} site Site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitesProvider.prototype.migrateSiteSchemas = function (site) {
        var _this = this;
        var db = site.getDb();
        if (this.siteSchemasMigration[site.id]) {
            return this.siteSchemasMigration[site.id];
        }
        this.logger.debug("Migrating all schemas of " + site.id);
        // First create tables not registerd with name/version.
        var promise = db.createTablesFromSchema(this.siteTablesSchemas).then(function () {
            // Fetch installed versions of the schema.
            return db.getAllRecords(_this.SCHEMA_VERSIONS_TABLE).then(function (records) {
                var versions = {};
                records.forEach(function (record) {
                    versions[record.name] = record.version;
                });
                var promises = [];
                var _loop_1 = function (name_1) {
                    var schema = _this.siteSchemas[name_1];
                    var oldVersion = versions[name_1] || 0;
                    if (oldVersion >= schema.version) {
                        return "continue";
                    }
                    _this.logger.debug("Migrating schema '" + name_1 + "' of " + site.id + " from version " + oldVersion + " to " + schema.version);
                    var promise_1 = Promise.resolve();
                    if (schema.tables) {
                        promise_1 = promise_1.then(function () { return db.createTablesFromSchema(schema.tables); });
                    }
                    if (schema.migrate) {
                        promise_1 = promise_1.then(function () { return schema.migrate(db, oldVersion, site.id); });
                    }
                    // Set installed version.
                    promise_1 = promise_1.then(function () { return db.insertRecord(_this.SCHEMA_VERSIONS_TABLE, { name: name_1, version: schema.version }); });
                    promises.push(promise_1);
                };
                for (var name_1 in _this.siteSchemas) {
                    _loop_1(name_1);
                }
                return Promise.all(promises);
            });
        });
        this.siteSchemasMigration[site.id] = promise;
        return promise.finally(function () {
            delete _this.siteSchemasMigration[site.id];
        });
    };
    /**
     * Check if a URL is the root URL of any of the stored sites.
     *
     * @param {string} url URL to check.
     * @param {string} [username] Username to check.
     * @return {Promise<{site: CoreSite, siteIds: string[]}>} Promise resolved with site to use and the list of sites that have
     *                                   the URL. Site will be undefined if it isn't the root URL of any stored site.
     */
    CoreSitesProvider.prototype.isStoredRootURL = function (url, username) {
        var _this = this;
        // Check if the site is stored.
        return this.getSiteIdsFromUrl(url, true, username).then(function (siteIds) {
            var result = {
                siteIds: siteIds,
                site: undefined
            };
            if (siteIds.length > 0) {
                // If more than one site is returned it usually means there are different users stored. Use any of them.
                return _this.getSite(siteIds[0]).then(function (site) {
                    var siteUrl = _this.textUtils.removeEndingSlash(_this.urlUtils.removeProtocolAndWWW(site.getURL())), treatedUrl = _this.textUtils.removeEndingSlash(_this.urlUtils.removeProtocolAndWWW(url));
                    if (siteUrl == treatedUrl) {
                        result.site = site;
                    }
                    return result;
                });
            }
            return result;
        });
    };
    /**
     * Returns the Site Schema names that can be cleared on space storage.
     *
     * @return {string[]} Name of the site schemas.
     */
    CoreSitesProvider.prototype.getSiteTableSchemasToClear = function () {
        var reset = [];
        for (var name_2 in this.siteSchemas) {
            if (this.siteSchemas[name_2].canBeCleared) {
                reset = reset.concat(this.siteSchemas[name_2].canBeCleared);
            }
        }
        return reset;
    };
    CoreSitesProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_6__sites_factory__["a" /* CoreSitesFactoryProvider */],
            __WEBPACK_IMPORTED_MODULE_3__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_8__utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_7__utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_14__angular_common__["Location"],
            __WEBPACK_IMPORTED_MODULE_9__utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreSitesProvider);
    return CoreSitesProvider;
}());

//# sourceMappingURL=sites.js.map

/***/ }),
/* 3 */,
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUtilsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_in_app_browser__ = __webpack_require__(249);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_clipboard__ = __webpack_require__(343);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_opener__ = __webpack_require__(250);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_web_intent__ = __webpack_require__(744);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















/*
 * "Utils" service with helper functions.
 */
var CoreUtilsProvider = /** @class */ (function () {
    function CoreUtilsProvider(iab, appProvider, clipboard, domUtils, logger, translate, platform, langProvider, eventsProvider, fileOpener, mimetypeUtils, webIntent, wsProvider, zone) {
        this.iab = iab;
        this.appProvider = appProvider;
        this.clipboard = clipboard;
        this.domUtils = domUtils;
        this.translate = translate;
        this.platform = platform;
        this.langProvider = langProvider;
        this.eventsProvider = eventsProvider;
        this.fileOpener = fileOpener;
        this.mimetypeUtils = mimetypeUtils;
        this.webIntent = webIntent;
        this.wsProvider = wsProvider;
        this.zone = zone;
        this.uniqueIds = {};
        this.logger = logger.getInstance('CoreUtilsProvider');
    }
    /**
     * Similar to Promise.all, but if a promise fails this function's promise won't be rejected until ALL promises have finished.
     *
     * @param {Promise<any>[]} promises Promises.
     * @return {Promise<any>} Promise resolved if all promises are resolved and rejected if at least 1 promise fails.
     */
    CoreUtilsProvider.prototype.allPromises = function (promises) {
        if (!promises || !promises.length) {
            return Promise.resolve();
        }
        return new Promise(function (resolve, reject) {
            var total = promises.length;
            var count = 0, hasFailed = false, error;
            promises.forEach(function (promise) {
                promise.catch(function (err) {
                    hasFailed = true;
                    error = err;
                }).finally(function () {
                    count++;
                    if (count === total) {
                        // All promises have finished, reject/resolve.
                        if (hasFailed) {
                            reject(error);
                        }
                        else {
                            resolve();
                        }
                    }
                });
            });
        });
    };
    /**
     * Converts an array of objects to an object, using a property of each entry as the key.
     * E.g. [{id: 10, name: 'A'}, {id: 11, name: 'B'}] => {10: {id: 10, name: 'A'}, 11: {id: 11, name: 'B'}}
     *
     * @param {any[]} array The array to convert.
     * @param {string} propertyName The name of the property to use as the key.
     * @param {any} [result] Object where to put the properties. If not defined, a new object will be created.
     * @return {any} The object.
     */
    CoreUtilsProvider.prototype.arrayToObject = function (array, propertyName, result) {
        result = result || {};
        array.forEach(function (entry) {
            result[entry[propertyName]] = entry;
        });
        return result;
    };
    /**
     * Compare two objects. This function won't compare functions and proto properties, it's a basic compare.
     * Also, this will only check if itemA's properties are in itemB with same value. This function will still
     * return true if itemB has more properties than itemA.
     *
     * @param {any} itemA First object.
     * @param {any} itemB Second object.
     * @param {number} [maxLevels=0] Number of levels to reach if 2 objects are compared.
     * @param {number} [level=0] Current deep level (when comparing objects).
     * @param {boolean} [undefinedIsNull=true] True if undefined is equal to null. Defaults to true.
     * @return {boolean} Whether both items are equal.
     */
    CoreUtilsProvider.prototype.basicLeftCompare = function (itemA, itemB, maxLevels, level, undefinedIsNull) {
        if (maxLevels === void 0) { maxLevels = 0; }
        if (level === void 0) { level = 0; }
        if (undefinedIsNull === void 0) { undefinedIsNull = true; }
        if (typeof itemA == 'function' || typeof itemB == 'function') {
            return true; // Don't compare functions.
        }
        else if (typeof itemA == 'object' && typeof itemB == 'object') {
            if (level >= maxLevels) {
                return true; // Max deep reached.
            }
            var equal = true;
            for (var name_1 in itemA) {
                var value = itemA[name_1];
                if (name_1 == '$$hashKey') {
                    // Ignore $$hashKey property since it's a "calculated" property.
                    return;
                }
                if (!this.basicLeftCompare(value, itemB[name_1], maxLevels, level + 1)) {
                    equal = false;
                }
            }
            return equal;
        }
        else {
            if (undefinedIsNull && ((typeof itemA == 'undefined' && itemB === null) || (itemA === null && typeof itemB == 'undefined'))) {
                return true;
            }
            // We'll treat "2" and 2 as the same value.
            var floatA = parseFloat(itemA), floatB = parseFloat(itemB);
            if (!isNaN(floatA) && !isNaN(floatB)) {
                return floatA == floatB;
            }
            return itemA === itemB;
        }
    };
    /**
     * Blocks leaving a view.
     * @deprecated, use ionViewCanLeave instead.
     */
    CoreUtilsProvider.prototype.blockLeaveView = function () {
        return;
    };
    /**
     * Check if a URL has a redirect.
     *
     * @param {string} url The URL to check.
     * @return {Promise<boolean>} Promise resolved with boolean_ whether there is a redirect.
     */
    CoreUtilsProvider.prototype.checkRedirect = function (url) {
        if (window.fetch) {
            var win = window, // Convert to <any> to be able to use AbortController (not supported by our TS version).
            initOptions = {
                redirect: 'follow'
            };
            var controller_1;
            // Some browsers implement fetch but no AbortController.
            if (win.AbortController) {
                controller_1 = new win.AbortController();
                initOptions.signal = controller_1.signal;
            }
            return this.timeoutPromise(window.fetch(url, initOptions), __WEBPACK_IMPORTED_MODULE_14__core_constants__["a" /* CoreConstants */].WS_TIMEOUT).then(function (response) {
                return response.redirected;
            }).catch(function (error) {
                if (error.timeout && controller_1) {
                    // Timeout, abort the request.
                    controller_1.abort();
                }
                // There was a timeout, cannot determine if there's a redirect. Assume it's false.
                return false;
            });
        }
        else {
            // Cannot check if there is a redirect, assume it's false.
            return Promise.resolve(false);
        }
    };
    /**
     * Close the InAppBrowser window.
     *
     * @param {boolean} [closeAll] Desktop only. True to close all secondary windows, false to close only the "current" one.
     */
    CoreUtilsProvider.prototype.closeInAppBrowser = function (closeAll) {
        if (this.iabInstance) {
            this.iabInstance.close();
            if (closeAll && this.appProvider.isDesktop()) {
                __webpack_require__(70).ipcRenderer.send('closeSecondaryWindows');
            }
        }
    };
    /**
     * Clone a variable. It should be an object, array or primitive type.
     *
     * @param {any} source The variable to clone.
     * @return {any} Cloned variable.
     */
    CoreUtilsProvider.prototype.clone = function (source) {
        if (Array.isArray(source)) {
            // Clone the array and all the entries.
            var newArray = [];
            for (var i = 0; i < source.length; i++) {
                newArray[i] = this.clone(source[i]);
            }
            return newArray;
        }
        else if (typeof source == 'object' && source !== null) {
            // Clone the object and all the subproperties.
            var newObject = {};
            for (var name_2 in source) {
                newObject[name_2] = this.clone(source[name_2]);
            }
            return newObject;
        }
        else {
            // Primitive type or unknown, return it as it is.
            return source;
        }
    };
    /**
     * Copy properties from one object to another.
     *
     * @param {any} from Object to copy the properties from.
     * @param {any} to Object where to store the properties.
     * @param {boolean} [clone=true] Whether the properties should be cloned (so they are different instances).
     */
    CoreUtilsProvider.prototype.copyProperties = function (from, to, clone) {
        if (clone === void 0) { clone = true; }
        for (var name_3 in from) {
            if (clone) {
                to[name_3] = this.clone(from[name_3]);
            }
            else {
                to[name_3] = from[name_3];
            }
        }
    };
    /**
     * Copies a text to clipboard and shows a toast message.
     *
     * @param {string} text Text to be copied
     * @return {Promise<any>} Promise resolved when text is copied.
     */
    CoreUtilsProvider.prototype.copyToClipboard = function (text) {
        var _this = this;
        return this.clipboard.copy(text).then(function () {
            // Show toast using ionicLoading.
            return _this.domUtils.showToast('core.copiedtoclipboard', true);
        }).catch(function () {
            // Ignore errors.
        });
    };
    /**
     * Create a "fake" WS error for local errors.
     *
     * @param {string} message The message to include in the error.
     * @param {boolean} [needsTranslate] If the message needs to be translated.
     * @return {CoreWSError} Fake WS error.
     */
    CoreUtilsProvider.prototype.createFakeWSError = function (message, needsTranslate) {
        return this.wsProvider.createFakeWSError(message, needsTranslate);
    };
    /**
     * Empties an array without losing its reference.
     *
     * @param {any[]} array Array to empty.
     */
    CoreUtilsProvider.prototype.emptyArray = function (array) {
        array.length = 0; // Empty array without losing its reference.
    };
    /**
     * Removes all properties from an object without losing its reference.
     *
     * @param {object} object Object to remove the properties.
     */
    CoreUtilsProvider.prototype.emptyObject = function (object) {
        for (var key in object) {
            if (object.hasOwnProperty(key)) {
                delete object[key];
            }
        }
    };
    /**
     * Execute promises one depending on the previous.
     *
     * @param {any[]} orderedPromisesData Data to be executed including the following values:
     *                                 - func: Function to be executed.
     *                                 - context: Context to pass to the function. This allows using "this" inside the function.
     *                                 - params: Array of data to be sent to the function.
     *                                 - blocking: Boolean. If promise should block the following.
     * @return {Promise<any>} Promise resolved when all promises are resolved.
     */
    CoreUtilsProvider.prototype.executeOrderedPromises = function (orderedPromisesData) {
        var _this = this;
        var promises = [];
        var dependency = Promise.resolve();
        var _loop_1 = function (i) {
            var data = orderedPromisesData[i];
            var promise = void 0;
            // Add the process to the dependency stack.
            promise = dependency.finally(function () {
                var prom;
                try {
                    prom = data.func.apply(data.context, data.params || []);
                }
                catch (e) {
                    _this.logger.error(e.message);
                    return;
                }
                return prom;
            });
            promises.push(promise);
            // If the new process is blocking, we set it as the dependency.
            if (data.blocking) {
                dependency = promise;
            }
        };
        // Execute all the processes in order.
        for (var i in orderedPromisesData) {
            _loop_1(i);
        }
        // Return when all promises are done.
        return this.allPromises(promises);
    };
    /**
     * Flatten an object, moving subobjects' properties to the first level using dot notation. E.g.:
     * {a: {b: 1, c: 2}, d: 3} -> {'a.b': 1, 'a.c': 2, d: 3}
     *
     * @param {object} obj Object to flatten.
     * @return {object} Flatten object.
     */
    CoreUtilsProvider.prototype.flattenObject = function (obj) {
        var toReturn = {};
        for (var name_4 in obj) {
            if (!obj.hasOwnProperty(name_4)) {
                continue;
            }
            var value = obj[name_4];
            if (typeof value == 'object' && !Array.isArray(value)) {
                var flatObject = this.flattenObject(value);
                for (var subName in flatObject) {
                    if (!flatObject.hasOwnProperty(subName)) {
                        continue;
                    }
                    toReturn[name_4 + '.' + subName] = flatObject[subName];
                }
            }
            else {
                toReturn[name_4] = value;
            }
        }
        return toReturn;
    };
    /**
     * Given an array of strings, return only the ones that match a regular expression.
     *
     * @param {string[]} array Array to filter.
     * @param {RegExp} regex RegExp to apply to each string.
     * @return {string[]} Filtered array.
     */
    CoreUtilsProvider.prototype.filterByRegexp = function (array, regex) {
        if (!array || !array.length) {
            return [];
        }
        return array.filter(function (entry) {
            var matches = entry.match(regex);
            return matches && matches.length;
        });
    };
    /**
     * Filter the list of site IDs based on a isEnabled function.
     *
     * @param {string[]} siteIds Site IDs to filter.
     * @param {Function} isEnabledFn Function to call for each site. Must return true or a promise resolved with true if enabled.
     *                    It receives a siteId param and all the params sent to this function after 'checkAll'.
     * @param {boolean} [checkAll] True if it should check all the sites, false if it should check only 1 and treat them all
     *                   depending on this result.
     * @param {any} ...args All the params sent after checkAll will be passed to isEnabledFn.
     * @return {Promise<string[]>} Promise resolved with the list of enabled sites.
     */
    CoreUtilsProvider.prototype.filterEnabledSites = function (siteIds, isEnabledFn, checkAll) {
        var args = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            args[_i - 3] = arguments[_i];
        }
        var promises = [], enabledSites = [];
        var _loop_2 = function (i) {
            var siteId = siteIds[i];
            if (checkAll || !promises.length) {
                promises.push(Promise.resolve(isEnabledFn.apply(isEnabledFn, [siteId].concat(args))).then(function (enabled) {
                    if (enabled) {
                        enabledSites.push(siteId);
                    }
                }));
            }
        };
        for (var i in siteIds) {
            _loop_2(i);
        }
        return this.allPromises(promises).catch(function () {
            // Ignore errors.
        }).then(function () {
            if (!checkAll) {
                // Checking 1 was enough, so it will either return all the sites or none.
                return enabledSites.length ? siteIds : [];
            }
            else {
                return enabledSites;
            }
        });
    };
    /**
     * Given a float, prints it nicely. Localized floats must not be used in calculations!
     * Based on Moodle's format_float.
     *
     * @param {any} float The float to print.
     * @return {string} Locale float.
     */
    CoreUtilsProvider.prototype.formatFloat = function (float) {
        if (typeof float == 'undefined' || float === null || typeof float == 'boolean') {
            return '';
        }
        var localeSeparator = this.translate.instant('core.decsep');
        // Convert float to string.
        float += '';
        return float.replace('.', localeSeparator);
    };
    /**
     * Returns a tree formatted from a plain list.
     * List has to be sorted by depth to allow this function to work correctly. Errors can be thrown if a child node is
     * processed before a parent node.
     *
     * @param {any[]} list List to format.
     * @param {string} [parentFieldName=parent] Name of the parent field to match with children.
     * @param {string} [idFieldName=id] Name of the children field to match with parent.
     * @param {number} [rootParentId=0] The id of the root.
     * @param {number} [maxDepth=5] Max Depth to convert to tree. Children found will be in the last level of depth.
     * @return {any[]} Array with the formatted tree, children will be on each node under children field.
     */
    CoreUtilsProvider.prototype.formatTree = function (list, parentFieldName, idFieldName, rootParentId, maxDepth) {
        if (parentFieldName === void 0) { parentFieldName = 'parent'; }
        if (idFieldName === void 0) { idFieldName = 'id'; }
        if (rootParentId === void 0) { rootParentId = 0; }
        if (maxDepth === void 0) { maxDepth = 5; }
        var map = {}, mapDepth = {}, tree = [];
        var parent, id;
        list.forEach(function (node, index) {
            id = node[idFieldName];
            parent = node[parentFieldName];
            node.children = [];
            // Use map to look-up the parents.
            map[id] = index;
            if (parent != rootParentId) {
                var parentNode = list[map[parent]];
                if (parentNode) {
                    if (mapDepth[parent] == maxDepth) {
                        // Reached max level of depth. Proceed with flat order. Find parent object of the current node.
                        var parentOfParent = parentNode[parentFieldName];
                        if (parentOfParent) {
                            // This element will be the child of the node that is two levels up the hierarchy
                            // (i.e. the child of node.parent.parent).
                            list[map[parentOfParent]].children.push(node);
                            // Assign depth level to the same depth as the parent (i.e. max depth level).
                            mapDepth[id] = mapDepth[parent];
                            // Change the parent to be the one that is two levels up the hierarchy.
                            node.parent = parentOfParent;
                        }
                    }
                    else {
                        parentNode.children.push(node);
                        // Increase the depth level.
                        mapDepth[id] = mapDepth[parent] + 1;
                    }
                }
            }
            else {
                tree.push(node);
                // Root elements are the first elements in the tree structure, therefore have the depth level 1.
                mapDepth[id] = 1;
            }
        });
        return tree;
    };
    /**
     * Get country name based on country code.
     *
     * @param {string} code Country code (AF, ES, US, ...).
     * @return {string} Country name. If the country is not found, return the country code.
     */
    CoreUtilsProvider.prototype.getCountryName = function (code) {
        var countryKey = 'assets.countries.' + code, countryName = this.translate.instant(countryKey);
        return countryName !== countryKey ? countryName : code;
    };
    /**
     * Get list of countries with their code and translated name.
     *
     * @return {Promise<any>} Promise resolved with the list of countries.
     */
    CoreUtilsProvider.prototype.getCountryList = function () {
        var _this = this;
        // Get the keys of the countries.
        return this.getCountryKeysList().then(function (keys) {
            // Now get the code and the translated name.
            var countries = {};
            keys.forEach(function (key) {
                if (key.indexOf('assets.countries.') === 0) {
                    var code = key.replace('assets.countries.', '');
                    countries[code] = _this.translate.instant(key);
                }
            });
            return countries;
        });
    };
    /**
     * Get the list of language keys of the countries.
     *
     * @return {Promise<string[]>} Promise resolved with the countries list. Rejected if not translated.
     */
    CoreUtilsProvider.prototype.getCountryKeysList = function () {
        var _this = this;
        // It's possible that the current language isn't translated, so try with default language first.
        var defaultLang = this.langProvider.getDefaultLanguage();
        return this.getCountryKeysListForLanguage(defaultLang).catch(function () {
            // Not translated, try to use the fallback language.
            var fallbackLang = _this.langProvider.getFallbackLanguage();
            if (fallbackLang === defaultLang) {
                // Same language, just reject.
                return Promise.reject('Countries not found.');
            }
            return _this.getCountryKeysListForLanguage(fallbackLang);
        });
    };
    /**
     * Get the list of language keys of the countries, based on the translation table for a certain language.
     *
     * @param {string} lang Language to check.
     * @return {Promise<string[]>} Promise resolved with the countries list. Rejected if not translated.
     */
    CoreUtilsProvider.prototype.getCountryKeysListForLanguage = function (lang) {
        // Get the translation table for the language.
        return this.langProvider.getTranslationTable(lang).then(function (table) {
            // Gather all the keys for countries,
            var keys = [];
            for (var name_5 in table) {
                if (name_5.indexOf('assets.countries.') === 0) {
                    keys.push(name_5);
                }
            }
            if (keys.length === 0) {
                // Not translated, reject.
                return Promise.reject('Countries not found.');
            }
            return keys;
        });
    };
    /**
     * Get the mimetype of a file given its URL. It'll try to guess it using the URL, if that fails then it'll
     * perform a HEAD request to get it. It's done in this order because pluginfile.php can return wrong mimetypes.
     * This function is in here instead of MimetypeUtils to prevent circular dependencies.
     *
     * @param {string} url The URL of the file.
     * @return {Promise<string>} Promise resolved with the mimetype.
     */
    CoreUtilsProvider.prototype.getMimeTypeFromUrl = function (url) {
        // First check if it can be guessed from the URL.
        var extension = this.mimetypeUtils.guessExtensionFromUrl(url), mimetype = this.mimetypeUtils.getMimeType(extension);
        if (mimetype) {
            return Promise.resolve(mimetype);
        }
        // Can't be guessed, get the remote mimetype.
        return this.wsProvider.getRemoteFileMimeType(url).then(function (mimetype) {
            return mimetype || '';
        });
    };
    /**
     * Get a unique ID for a certain name.
     *
     * @param {string} name The name to get the ID for.
     * @return {number} Unique ID.
     */
    CoreUtilsProvider.prototype.getUniqueId = function (name) {
        if (!this.uniqueIds[name]) {
            this.uniqueIds[name] = 0;
        }
        return ++this.uniqueIds[name];
    };
    /**
     * Given a list of files, check if there are repeated names.
     *
     * @param {any[]} files List of files.
     * @return {string|boolean} String with error message if repeated, false if no repeated.
     */
    CoreUtilsProvider.prototype.hasRepeatedFilenames = function (files) {
        if (!files || !files.length) {
            return false;
        }
        var names = [];
        // Check if there are 2 files with the same name.
        for (var i = 0; i < files.length; i++) {
            var name_6 = files[i].filename || files[i].name;
            if (names.indexOf(name_6) > -1) {
                return this.translate.instant('core.filenameexist', { $a: name_6 });
            }
            else {
                names.push(name_6);
            }
        }
        return false;
    };
    /**
     * Gets the index of the first string that matches a regular expression.
     *
     * @param {string[]} array Array to search.
     * @param {RegExp} regex RegExp to apply to each string.
     * @return {number} Index of the first string that matches the RegExp. -1 if not found.
     */
    CoreUtilsProvider.prototype.indexOfRegexp = function (array, regex) {
        if (!array || !array.length) {
            return -1;
        }
        for (var i = 0; i < array.length; i++) {
            var entry = array[i], matches = entry.match(regex);
            if (matches && matches.length) {
                return i;
            }
        }
        return -1;
    };
    /**
     * Return true if the param is false (bool), 0 (number) or "0" (string).
     *
     * @param {any} value Value to check.
     * @return {boolean} Whether the value is false, 0 or "0".
     */
    CoreUtilsProvider.prototype.isFalseOrZero = function (value) {
        return typeof value != 'undefined' && (value === false || value === 'false' || parseInt(value, 10) === 0);
    };
    /**
     * Return true if the param is true (bool), 1 (number) or "1" (string).
     *
     * @param {any} value Value to check.
     * @return {boolean} Whether the value is true, 1 or "1".
     */
    CoreUtilsProvider.prototype.isTrueOrOne = function (value) {
        return typeof value != 'undefined' && (value === true || value === 'true' || parseInt(value, 10) === 1);
    };
    /**
     * Given an error returned by a WS call, check if the error is generated by the app or it has been returned by the WebSwervice.
     *
     * @param {any} error Error to check.
     * @return {boolean} Whether the error was returned by the WebService.
     */
    CoreUtilsProvider.prototype.isWebServiceError = function (error) {
        return error && (typeof error.warningcode != 'undefined' || (typeof error.errorcode != 'undefined' &&
            error.errorcode != 'invalidtoken' && error.errorcode != 'userdeleted' && error.errorcode != 'upgraderunning' &&
            error.errorcode != 'forcepasswordchangenotice' && error.errorcode != 'usernotfullysetup' &&
            error.errorcode != 'sitepolicynotagreed' && error.errorcode != 'sitemaintenance' &&
            (error.errorcode != 'accessexception' || error.message.indexOf('Invalid token - token expired') == -1)));
    };
    /**
     * Given a list (e.g. a,b,c,d,e) this function returns an array of 1->a, 2->b, 3->c etc.
     * Taken from make_menu_from_list on moodlelib.php (not the same but similar).
     *
     * @param {string} list The string to explode into array bits
     * @param {string} [defaultLabel] Element that will become default option, if not defined, it won't be added.
     * @param {string} [separator] The separator used within the list string. Default ','.
     * @param {any}  [defaultValue] Element that will become default option value. Default 0.
     * @return {any[]} The now assembled array
     */
    CoreUtilsProvider.prototype.makeMenuFromList = function (list, defaultLabel, separator, defaultValue) {
        if (separator === void 0) { separator = ','; }
        // Split and format the list.
        var split = list.split(separator).map(function (label, index) {
            return {
                label: label.trim(),
                value: index + 1
            };
        });
        if (defaultLabel) {
            split.unshift({
                label: defaultLabel,
                value: defaultValue || 0
            });
        }
        return split;
    };
    /**
     * Merge two arrays, removing duplicate values.
     *
     * @param {any[]} array1 The first array.
     * @param {any[]} array2 The second array.
     * @param [key] Key of the property that must be unique. If not specified, the whole entry.
     * @return {any[]} Merged array.
     */
    CoreUtilsProvider.prototype.mergeArraysWithoutDuplicates = function (array1, array2, key) {
        return this.uniqueArray(array1.concat(array2), key);
    };
    /**
     * Open a file using platform specific method.
     *
     * @param {string} path The local path of the file to be open.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUtilsProvider.prototype.openFile = function (path) {
        var _this = this;
        var extension = this.mimetypeUtils.getFileExtension(path), mimetype = this.mimetypeUtils.getMimeType(extension);
        // Path needs to be decoded, the file won't be opened if the path has %20 instead of spaces and so.
        try {
            path = decodeURIComponent(path);
        }
        catch (ex) {
            // Error, use the original path.
        }
        return this.fileOpener.open(path, mimetype).catch(function (error) {
            _this.logger.error('Error opening file ' + path + ' with mimetype ' + mimetype);
            _this.logger.error('Error: ', JSON.stringify(error));
            if (!extension || extension.indexOf('/') > -1 || extension.indexOf('\\') > -1) {
                // Extension not found.
                error = _this.translate.instant('core.erroropenfilenoextension');
            }
            else {
                error = _this.translate.instant('core.erroropenfilenoapp');
            }
            return Promise.reject(error);
        });
    };
    /**
     * Open a URL using InAppBrowser.
     * Do not use for files, refer to {@link openFile}.
     *
     * @param {string} url The URL to open.
     * @param {any} [options] Override default options passed to InAppBrowser.
     * @return {InAppBrowserObject} The opened window.
     */
    CoreUtilsProvider.prototype.openInApp = function (url, options) {
        var _this = this;
        if (!url) {
            return;
        }
        options = options || {};
        if (!options.enableViewPortScale) {
            options.enableViewPortScale = 'yes'; // Enable zoom on iOS.
        }
        if (!options.location && this.platform.is('ios') && url.indexOf('file://') === 0) {
            // The URL uses file protocol, don't show it on iOS.
            // In Android we keep it because otherwise we lose the whole toolbar.
            options.location = 'no';
        }
        options.toolbar = 'yes';
        options.toolbarposition = 'top';
        options.closebuttoncaption = '关闭';
        options.toolbarcolor = '#336efa';
        options.closebuttoncolor = '#ffffff';
        options.navigationbuttoncolor = '#ffffff';
        options.toolbartranslucent = 'no';
        options.hideurlbar = 'yes';
        // location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,
        // closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no
        this.iabInstance = this.iab.create(url, '_blank', options);
        if (this.appProvider.isDesktop() || this.appProvider.isMobile()) {
            var loadStopSubscription_1;
            var loadStartUrls_1 = [];
            // Trigger global events when a url is loaded or the window is closed. This is to make it work like in Ionic 1.
            var loadStartSubscription_1 = this.iabInstance.on('loadstart').subscribe(function (event) {
                // Execute the callback in the Angular zone, so change detection doesn't stop working.
                _this.zone.run(function () {
                    // Store the last loaded URLs (max 10).
                    loadStartUrls_1.push(event.url);
                    if (loadStartUrls_1.length > 10) {
                        loadStartUrls_1.shift();
                    }
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_9__events__["a" /* CoreEventsProvider */].IAB_LOAD_START, event);
                });
            });
            if (this.platform.is('android')) {
                // Load stop is needed with InAppBrowser v3. Custom URL schemes no longer trigger load start, simulate it.
                loadStopSubscription_1 = this.iabInstance.on('loadstop').subscribe(function (event) {
                    // Execute the callback in the Angular zone, so change detection doesn't stop working.
                    _this.zone.run(function () {
                        if (loadStartUrls_1.indexOf(event.url) == -1) {
                            // The URL was stopped but not started, probably a custom URL scheme.
                            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_9__events__["a" /* CoreEventsProvider */].IAB_LOAD_START, event);
                        }
                    });
                });
            }
            var exitSubscription_1 = this.iabInstance.on('exit').subscribe(function (event) {
                // Execute the callback in the Angular zone, so change detection doesn't stop working.
                _this.zone.run(function () {
                    loadStartSubscription_1.unsubscribe();
                    loadStopSubscription_1 && loadStopSubscription_1.unsubscribe();
                    exitSubscription_1.unsubscribe();
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_9__events__["a" /* CoreEventsProvider */].IAB_EXIT, event);
                });
            });
        }
        return this.iabInstance;
    };
    /**
     * Open a URL using a browser.
     * Do not use for files, refer to {@link openFile}.
     *
     * @param {string} url The URL to open.
     */
    CoreUtilsProvider.prototype.openInBrowser = function (url) {
        if (this.appProvider.isDesktop()) {
            // It's a desktop app, use Electron shell library to open the browser.
            var shell = __webpack_require__(70).shell;
            if (!shell.openExternal(url)) {
                // Open browser failed, open a new window in the app.
                window.open(url, '_system');
            }
        }
        else {
            window.open(url, '_system');
        }
    };
    /**
     * Open an online file using platform specific method.
     * Specially useful for audio and video since they can be streamed.
     *
     * @param {string} url The URL of the file.
     * @return {Promise<void>} Promise resolved when opened.
     */
    CoreUtilsProvider.prototype.openOnlineFile = function (url) {
        var _this = this;
        if (this.platform.is('android')) {
            // In Android we need the mimetype to open it.
            return this.getMimeTypeFromUrl(url).catch(function () {
                // Error getting mimetype, return undefined.
            }).then(function (mimetype) {
                if (!mimetype) {
                    // Couldn't retrieve mimetype. Return error.
                    return Promise.reject(_this.translate.instant('core.erroropenfilenoextension'));
                }
                var options = {
                    action: _this.webIntent.ACTION_VIEW,
                    url: url,
                    type: mimetype
                };
                return _this.webIntent.startActivity(options).catch(function (error) {
                    _this.logger.error('Error opening online file ' + url + ' with mimetype ' + mimetype);
                    _this.logger.error('Error: ', JSON.stringify(error));
                    return Promise.reject(_this.translate.instant('core.erroropenfilenoapp'));
                });
            });
        }
        // In the rest of platforms we need to open them in InAppBrowser.
        this.openInApp(url);
        return Promise.resolve();
    };
    /**
     * Converts an object into an array, losing the keys.
     *
     * @param {object} obj Object to convert.
     * @return {any[]} Array with the values of the object but losing the keys.
     */
    CoreUtilsProvider.prototype.objectToArray = function (obj) {
        return Object.keys(obj).map(function (key) {
            return obj[key];
        });
    };
    /**
     * Converts an object into an array of objects, where each entry is an object containing
     * the key and value of the original object.
     * For example, it can convert {size: 2} into [{name: 'size', value: 2}].
     *
     * @param {object} obj Object to convert.
     * @param {string} keyName Name of the properties where to store the keys.
     * @param {string} valueName Name of the properties where to store the values.
     * @param {boolean} [sortByKey] True to sort keys alphabetically, false otherwise. Has priority over sortByValue.
     * @param {boolean} [sortByValue] True to sort values alphabetically, false otherwise.
     * @return {any[]} Array of objects with the name & value of each property.
     */
    CoreUtilsProvider.prototype.objectToArrayOfObjects = function (obj, keyName, valueName, sortByKey, sortByValue) {
        // Get the entries from an object or primitive value.
        var getEntries = function (elKey, value) {
            if (typeof value == 'undefined' || value == null) {
                // Filter undefined and null values.
                return;
            }
            else if (typeof value == 'object') {
                // It's an object, return at least an entry for each property.
                var keys = Object.keys(value);
                var entries_1 = [];
                keys.forEach(function (key) {
                    var newElKey = elKey ? elKey + '[' + key + ']' : key, subEntries = getEntries(newElKey, value[key]);
                    if (subEntries) {
                        entries_1 = entries_1.concat(subEntries);
                    }
                });
                return entries_1;
            }
            else {
                // Not an object, return a single entry.
                var entry = {};
                entry[keyName] = elKey;
                entry[valueName] = value;
                return entry;
            }
        };
        if (!obj) {
            return [];
        }
        // "obj" will always be an object, so "entries" will always be an array.
        var entries = getEntries('', obj);
        if (sortByKey || sortByValue) {
            return entries.sort(function (a, b) {
                if (sortByKey) {
                    return a[keyName] >= b[keyName] ? 1 : -1;
                }
                else {
                    return a[valueName] >= b[valueName] ? 1 : -1;
                }
            });
        }
        return entries;
    };
    /**
     * Converts an array of objects into an object with key and value. The opposite of objectToArrayOfObjects.
     * For example, it can convert [{name: 'size', value: 2}] into {size: 2}.
     *
     * @param {object[]} objects List of objects to convert.
     * @param {string} keyName Name of the properties where the keys are stored.
     * @param {string} valueName Name of the properties where the values are stored.
     * @param {string} [keyPrefix] Key prefix if neededs to delete it.
     * @return {object} Object.
     */
    CoreUtilsProvider.prototype.objectToKeyValueMap = function (objects, keyName, valueName, keyPrefix) {
        if (!objects) {
            return;
        }
        var prefixSubstr = keyPrefix ? keyPrefix.length : 0, mapped = {};
        objects.forEach(function (item) {
            var key = prefixSubstr > 0 ? item[keyName].substr(prefixSubstr) : item[keyName];
            mapped[key] = item[valueName];
        });
        return mapped;
    };
    /**
     * Add a prefix to all the keys in an object.
     *
     * @param {any} data Object.
     * @param {string} prefix Prefix to add.
     * @return {any} Prefixed object.
     */
    CoreUtilsProvider.prototype.prefixKeys = function (data, prefix) {
        var newObj = {}, keys = Object.keys(data);
        keys.forEach(function (key) {
            newObj[prefix + key] = data[key];
        });
        return newObj;
    };
    /**
     * Similar to AngularJS $q.defer().
     *
     * @return {PromiseDefer} The deferred promise.
     */
    CoreUtilsProvider.prototype.promiseDefer = function () {
        var deferred = {};
        deferred.promise = new Promise(function (resolve, reject) {
            deferred.resolve = resolve;
            deferred.reject = reject;
        });
        return deferred;
    };
    /**
     * Given a promise, returns true if it's rejected or false if it's resolved.
     *
     * @param {Promise<any>} promise Promise to check
     * @return {Promise<boolean>} Promise resolved with boolean: true if the promise is rejected or false if it's resolved.
     */
    CoreUtilsProvider.prototype.promiseFails = function (promise) {
        return promise.then(function () {
            return false;
        }).catch(function () {
            return true;
        });
    };
    /**
     * Given a promise, returns true if it's resolved or false if it's rejected.
     *
     * @param {Promise<any>} promise Promise to check
     * @return {Promise<boolean>} Promise resolved with boolean: true if the promise it's resolved or false if it's rejected.
     */
    CoreUtilsProvider.prototype.promiseWorks = function (promise) {
        return promise.then(function () {
            return true;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Tests to see whether two arrays or objects have the same value at a particular key.
     * Missing values are replaced by '', and the values are compared with ===.
     * Booleans and numbers are cast to string before comparing.
     *
     * @param {any} obj1 The first object or array.
     * @param {any} obj2 The second object or array.
     * @param {string} key Key to check.
     * @return {boolean} Whether the two objects/arrays have the same value (or lack of one) for a given key.
     */
    CoreUtilsProvider.prototype.sameAtKeyMissingIsBlank = function (obj1, obj2, key) {
        var value1 = typeof obj1[key] != 'undefined' ? obj1[key] : '', value2 = typeof obj2[key] != 'undefined' ? obj2[key] : '';
        if (typeof value1 == 'number' || typeof value1 == 'boolean') {
            value1 = '' + value1;
        }
        if (typeof value2 == 'number' || typeof value2 == 'boolean') {
            value2 = '' + value2;
        }
        return value1 === value2;
    };
    /**
     * Stringify an object, sorting the properties. It doesn't sort arrays, only object properties. E.g.:
     * {b: 2, a: 1} -> '{"a":1,"b":2}'
     *
     * @param {object} obj Object to stringify.
     * @return {string} Stringified object.
     */
    CoreUtilsProvider.prototype.sortAndStringify = function (obj) {
        return JSON.stringify(this.sortProperties(obj));
    };
    /**
     * Given an object, sort its properties and the properties of all the nested objects.
     *
     * @param {object} obj The object to sort. If it isn't an object, the original value will be returned.
     * @return {object} Sorted object.
     */
    CoreUtilsProvider.prototype.sortProperties = function (obj) {
        var _this = this;
        if (typeof obj == 'object' && !Array.isArray(obj)) {
            // It's an object, sort it.
            return Object.keys(obj).sort().reduce(function (accumulator, key) {
                // Always call sort with the value. If it isn't an object, the original value will be returned.
                accumulator[key] = _this.sortProperties(obj[key]);
                return accumulator;
            }, {});
        }
        else {
            return obj;
        }
    };
    /**
     * Given an object, sort its values. Values need to be primitive values, it cannot have subobjects.
     *
     * @param {object} obj The object to sort. If it isn't an object, the original value will be returned.
     * @return {object} Sorted object.
     */
    CoreUtilsProvider.prototype.sortValues = function (obj) {
        if (typeof obj == 'object' && !Array.isArray(obj)) {
            // It's an object, sort it. Convert it to an array to be able to sort it and then convert it back to object.
            var array = this.objectToArrayOfObjects(obj, 'name', 'value', false, true);
            return this.objectToKeyValueMap(array, 'name', 'value');
        }
        else {
            return obj;
        }
    };
    /**
     * Sum the filesizes from a list of files checking if the size will be partial or totally calculated.
     *
     * @param {any[]} files List of files to sum its filesize.
     * @return {{size: number, total: boolean}} File size and a boolean to indicate if it is the total size or only partial.
     */
    CoreUtilsProvider.prototype.sumFileSizes = function (files) {
        var result = {
            size: 0,
            total: true
        };
        files.forEach(function (file) {
            if (typeof file.filesize == 'undefined') {
                // We don't have the file size, cannot calculate its total size.
                result.total = false;
            }
            else {
                result.size += file.filesize;
            }
        });
        return result;
    };
    /**
     * Set a timeout to a Promise. If the time passes before the Promise is resolved or rejected, it will be automatically
     * rejected.
     *
     * @param {Promise<T>} promise The promise to timeout.
     * @param {number} time Number of milliseconds of the timeout.
     * @return {Promise<T>} Promise with the timeout.
     */
    CoreUtilsProvider.prototype.timeoutPromise = function (promise, time) {
        return new Promise(function (resolve, reject) {
            var timeout = setTimeout(function () {
                reject({ timeout: true });
            }, time);
            promise.then(resolve).catch(reject).finally(function () {
                clearTimeout(timeout);
            });
        });
    };
    /**
     * Converts locale specific floating point/comma number back to standard PHP float value.
     * Do NOT try to do any math operations before this conversion on any user submitted floats!
     * Based on Moodle's unformat_float function.
     *
     * @param {any} localeFloat Locale aware float representation.
     * @param {boolean} [strict] If true, then check the input and return false if it is not a valid number.
     * @return {any} False if bad format, empty string if empty value or the parsed float if not.
     */
    CoreUtilsProvider.prototype.unformatFloat = function (localeFloat, strict) {
        // Bad format on input type number.
        if (typeof localeFloat == 'undefined') {
            return false;
        }
        // Empty (but not zero).
        if (localeFloat == null) {
            return '';
        }
        // Convert float to string.
        localeFloat += '';
        localeFloat = localeFloat.trim();
        if (localeFloat == '') {
            return '';
        }
        localeFloat = localeFloat.replace(' ', ''); // No spaces - those might be used as thousand separators.
        localeFloat = localeFloat.replace(this.translate.instant('core.decsep'), '.');
        var parsedFloat = parseFloat(localeFloat);
        // Bad format.
        if (strict && (!isFinite(localeFloat) || isNaN(parsedFloat))) {
            return false;
        }
        return parsedFloat;
    };
    /**
     * Return an array without duplicate values.
     *
     * @param {any[]} array The array to treat.
     * @param [key] Key of the property that must be unique. If not specified, the whole entry.
     * @return {any[]} Array without duplicate values.
     */
    CoreUtilsProvider.prototype.uniqueArray = function (array, key) {
        var filtered = [], unique = {}; // Use an object to make it faster to check if it's duplicate.
        array.forEach(function (entry) {
            var value = key ? entry[key] : entry;
            if (!unique[value]) {
                unique[value] = true;
                filtered.push(entry);
            }
        });
        return filtered;
    };
    CoreUtilsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ionic_native_in_app_browser__["a" /* InAppBrowser */], __WEBPACK_IMPORTED_MODULE_6__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__ionic_native_clipboard__["a" /* Clipboard */],
            __WEBPACK_IMPORTED_MODULE_7__dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_10__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_11__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_12__lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_9__events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_opener__["a" /* FileOpener */], __WEBPACK_IMPORTED_MODULE_8__mimetype__["a" /* CoreMimetypeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__ionic_native_web_intent__["a" /* WebIntent */],
            __WEBPACK_IMPORTED_MODULE_13__ws__["a" /* CoreWSProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"]])
    ], CoreUtilsProvider);
    return CoreUtilsProvider;
}());

//# sourceMappingURL=utils.js.map

/***/ }),
/* 5 */,
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLoggerProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_moment__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Helper service to display messages in the console.
 *
 * @description
 * This service is meant to improve log messages, adding a timestamp and a name to all log messages.
 *
 * In your class constructor, call getInstance to configure your class name:
 * this.logger = logger.getInstance('InitPage');
 *
 * Then you can call the log function you want to use in this logger instance.
 */
var CoreLoggerProvider = /** @class */ (function () {
    function CoreLoggerProvider() {
        /** Whether the logging is enabled. */
        this.enabled = true;
        // Nothing to do.
    }
    /**
     * Get a logger instance for a certain class, service or component.
     *
     * @param {string} className Name to use in the messages.
     * @return {ant} Instance.
     */
    CoreLoggerProvider.prototype.getInstance = function (className) {
        className = className || '';
        /* tslint:disable no-console */
        return {
            log: this.prepareLogFn(console.log.bind(console), className),
            info: this.prepareLogFn(console.info.bind(console), className),
            warn: this.prepareLogFn(console.warn.bind(console), className),
            debug: this.prepareLogFn(console.debug.bind(console), className),
            error: this.prepareLogFn(console.error.bind(console), className)
        };
    };
    /**
     * Prepare a logging function, concatenating the timestamp and class name to all messages.
     *
     * @param {Function} logFn Log function to use.
     * @param {string} className Name to use in the messages.
     * @return {Function} Prepared function.
     */
    CoreLoggerProvider.prototype.prepareLogFn = function (logFn, className) {
        var _this = this;
        // Return our own function that will call the logging function with the treated message.
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (_this.enabled) {
                var now = __WEBPACK_IMPORTED_MODULE_1_moment__().format('l LTS');
                args[0] = now + ' ' + className + ': ' + args[0]; // Prepend timestamp and className to the original message.
                logFn.apply(null, args);
            }
        };
    };
    CoreLoggerProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], CoreLoggerProvider);
    return CoreLoggerProvider;
}());

//# sourceMappingURL=logger.js.map

/***/ }),
/* 7 */,
/* 8 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreAppProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_keyboard__ = __webpack_require__(339);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_status_bar__ = __webpack_require__(183);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__db__ = __webpack_require__(340);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__configconstants__ = __webpack_require__(66);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Factory to provide some global functionalities, like access to the global app database.
 * @description
 * Each service or component should be responsible of creating their own database tables. Example:
 *
 * constructor(appProvider: CoreAppProvider) {
 *     this.appDB = appProvider.getDB();
 *     this.appDB.createTableFromSchema(this.tableSchema);
 * }
 */
var CoreAppProvider = /** @class */ (function () {
    function CoreAppProvider(dbProvider, platform, keyboard, appCtrl, network, logger, events, zone, menuCtrl, statusBar) {
        var _this = this;
        this.platform = platform;
        this.keyboard = keyboard;
        this.appCtrl = appCtrl;
        this.network = network;
        this.events = events;
        this.menuCtrl = menuCtrl;
        this.statusBar = statusBar;
        this.DBNAME = 'MoodleMobile';
        this.isKeyboardShown = false;
        this.backActions = [];
        this.mainMenuId = 0;
        this.forceOffline = false;
        this.logger = logger.getInstance('CoreAppProvider');
        this.db = dbProvider.getDB(this.DBNAME);
        this.keyboard.onKeyboardShow().subscribe(function (data) {
            // Execute the callback in the Angular zone, so change detection doesn't stop working.
            zone.run(function () {
                document.body.classList.add('keyboard-is-open');
                _this.isKeyboardShown = true;
                // Error on iOS calculating size.
                // More info: https://github.com/ionic-team/ionic-plugin-keyboard/issues/276 .
                events.trigger(__WEBPACK_IMPORTED_MODULE_7__events__["a" /* CoreEventsProvider */].KEYBOARD_CHANGE, data.keyboardHeight);
            });
        });
        this.keyboard.onKeyboardHide().subscribe(function (data) {
            // Execute the callback in the Angular zone, so change detection doesn't stop working.
            zone.run(function () {
                document.body.classList.remove('keyboard-is-open');
                _this.isKeyboardShown = false;
                events.trigger(__WEBPACK_IMPORTED_MODULE_7__events__["a" /* CoreEventsProvider */].KEYBOARD_CHANGE, 0);
            });
        });
        this.platform.registerBackButtonAction(function () {
            _this.backButtonAction();
        }, 100);
        // Export the app provider so Behat tests can change the forceOffline flag.
        window.appProvider = this;
    }
    /**
     * Check if the browser supports mediaDevices.getUserMedia.
     *
     * @return {boolean} Whether the function is supported.
     */
    CoreAppProvider.prototype.canGetUserMedia = function () {
        return !!(navigator && navigator.mediaDevices && navigator.mediaDevices.getUserMedia);
    };
    /**
     * Check if the browser supports MediaRecorder.
     *
     * @return {boolean} Whether the function is supported.
     */
    CoreAppProvider.prototype.canRecordMedia = function () {
        return !!window.MediaRecorder;
    };
    /**
     * Closes the keyboard.
     */
    CoreAppProvider.prototype.closeKeyboard = function () {
        if (this.isMobile()) {
            this.keyboard.hide();
        }
    };
    /**
     * Get the application global database.
     *
     * @return {SQLiteDB} App's DB.
     */
    CoreAppProvider.prototype.getDB = function () {
        return this.db;
    };
    /**
     * Get an ID for a main menu.
     *
     * @return {number} Main menu ID.
     */
    CoreAppProvider.prototype.getMainMenuId = function () {
        return this.mainMenuId++;
    };
    /**
     * Get the app's root NavController.
     *
     * @return {NavController} Root NavController.
     */
    CoreAppProvider.prototype.getRootNavController = function () {
        // Function getRootNav is deprecated. Get the first root nav, there should always be one.
        return this.appCtrl.getRootNavs()[0];
    };
    /**
     * Checks if the app is running in a 64 bits desktop environment (not browser).
     *
     * @return {boolean} Whether the app is running in a 64 bits desktop environment (not browser).
     */
    CoreAppProvider.prototype.is64Bits = function () {
        var process = window.process;
        return this.isDesktop() && process.arch == 'x64';
    };
    /**
     * Checks if the app is running in a desktop environment (not browser).
     *
     * @return {boolean} Whether the app is running in a desktop environment (not browser).
     */
    CoreAppProvider.prototype.isDesktop = function () {
        var process = window.process;
        return !!(process && process.versions && typeof process.versions.electron != 'undefined');
    };
    /**
     * Check if the keyboard is visible.
     *
     * @return {boolean} Whether keyboard is visible.
     */
    CoreAppProvider.prototype.isKeyboardVisible = function () {
        return this.isKeyboardShown;
    };
    /**
     * Check if the app is running in a Linux environment.
     *
     * @return {boolean} Whether it's running in a Linux environment.
     */
    CoreAppProvider.prototype.isLinux = function () {
        if (!this.isDesktop()) {
            return false;
        }
        try {
            return __webpack_require__(341).platform().indexOf('linux') === 0;
        }
        catch (ex) {
            return false;
        }
    };
    /**
     * Check if the app is running in a Mac OS environment.
     *
     * @return {boolean} Whether it's running in a Mac OS environment.
     */
    CoreAppProvider.prototype.isMac = function () {
        if (!this.isDesktop()) {
            return false;
        }
        try {
            return __webpack_require__(341).platform().indexOf('darwin') === 0;
        }
        catch (ex) {
            return false;
        }
    };
    /**
     * Check if the main menu is open.
     *
     * @return {boolean} Whether the main menu is open.
     */
    CoreAppProvider.prototype.isMainMenuOpen = function () {
        return typeof this.mainMenuOpen != 'undefined';
    };
    /**
     * Checks if the app is running in a mobile or tablet device (Cordova).
     *
     * @return {boolean} Whether the app is running in a mobile or tablet device.
     */
    CoreAppProvider.prototype.isMobile = function () {
        return this.platform.is('cordova');
    };
    /**
     * Checks if the current window is wider than a mobile.
     *
     * @return {boolean} Whether the app the current window is wider than a mobile.
     */
    CoreAppProvider.prototype.isWide = function () {
        return this.platform.width() > 768;
    };
    /**
     * Returns whether we are online.
     *
     * @return {boolean} Whether the app is online.
     */
    CoreAppProvider.prototype.isOnline = function () {
        if (this.forceOffline) {
            return false;
        }
        var online = this.network.type !== null && this.network.type != Connection.NONE && this.network.type != Connection.UNKNOWN;
        // Double check we are not online because we cannot rely 100% in Cordova APIs. Also, check it in browser.
        if (!online && navigator.onLine) {
            online = true;
        }
        return online;
    };
    /**
     * Check if device uses a limited connection.
     *
     * @return {boolean} Whether the device uses a limited connection.
     */
    CoreAppProvider.prototype.isNetworkAccessLimited = function () {
        var type = this.network.type;
        if (type === null) {
            // Plugin not defined, probably in browser.
            return false;
        }
        var limited = [Connection.CELL_2G, Connection.CELL_3G, Connection.CELL_4G, Connection.CELL];
        return limited.indexOf(type) > -1;
    };
    /**
     * Check if device uses a wifi connection.
     *
     * @return {boolean} Whether the device uses a wifi connection.
     */
    CoreAppProvider.prototype.isWifi = function () {
        return this.isOnline() && !this.isNetworkAccessLimited();
    };
    /**
     * Check if the app is running in a Windows environment.
     *
     * @return {boolean} Whether it's running in a Windows environment.
     */
    CoreAppProvider.prototype.isWindows = function () {
        if (!this.isDesktop()) {
            return false;
        }
        try {
            return __webpack_require__(341).platform().indexOf('win') === 0;
        }
        catch (ex) {
            return false;
        }
    };
    /**
     * Open the keyboard.
     */
    CoreAppProvider.prototype.openKeyboard = function () {
        // Open keyboard is not supported in desktop and in iOS.
        if (this.isMobile() && !this.platform.is('ios')) {
            this.keyboard.show();
        }
    };
    /**
     * Set a main menu as open or not.
     *
     * @param {number} id Main menu ID.
     * @param {boolean} open Whether it's open or not.
     */
    CoreAppProvider.prototype.setMainMenuOpen = function (id, open) {
        if (open) {
            this.mainMenuOpen = id;
            this.events.trigger(__WEBPACK_IMPORTED_MODULE_7__events__["a" /* CoreEventsProvider */].MAIN_MENU_OPEN);
        }
        else if (this.mainMenuOpen == id) {
            delete this.mainMenuOpen;
        }
    };
    /**
     * Start an SSO authentication process.
     * Please notice that this function should be called when the app receives the new token from the browser,
     * NOT when the browser is opened.
     */
    CoreAppProvider.prototype.startSSOAuthentication = function () {
        var _this = this;
        var cancelTimeout, resolvePromise;
        this.ssoAuthenticationPromise = new Promise(function (resolve, reject) {
            resolvePromise = resolve;
            // Resolve it automatically after 10 seconds (it should never take that long).
            cancelTimeout = setTimeout(function () {
                _this.finishSSOAuthentication();
            }, 10000);
        });
        // Store the resolve function in the promise itself.
        this.ssoAuthenticationPromise.resolve = resolvePromise;
        // If the promise is resolved because finishSSOAuthentication is called, stop the cancel promise.
        this.ssoAuthenticationPromise.then(function () {
            clearTimeout(cancelTimeout);
        });
    };
    /**
     * Finish an SSO authentication process.
     */
    CoreAppProvider.prototype.finishSSOAuthentication = function () {
        if (this.ssoAuthenticationPromise) {
            this.ssoAuthenticationPromise.resolve && this.ssoAuthenticationPromise.resolve();
            this.ssoAuthenticationPromise = undefined;
        }
    };
    /**
     * Check if there's an ongoing SSO authentication process.
     *
     * @return {boolean} Whether there's a SSO authentication ongoing.
     */
    CoreAppProvider.prototype.isSSOAuthenticationOngoing = function () {
        return !!this.ssoAuthenticationPromise;
    };
    /**
     * Returns a promise that will be resolved once SSO authentication finishes.
     *
     * @return {Promise<any>} Promise resolved once SSO authentication finishes.
     */
    CoreAppProvider.prototype.waitForSSOAuthentication = function () {
        return this.ssoAuthenticationPromise || Promise.resolve();
    };
    /**
     * Retrieve redirect data.
     *
     * @return {CoreRedirectData} Object with siteid, state, params and timemodified.
     */
    CoreAppProvider.prototype.getRedirect = function () {
        if (localStorage && localStorage.getItem) {
            try {
                var data = {
                    siteId: localStorage.getItem('CoreRedirectSiteId'),
                    page: localStorage.getItem('CoreRedirectState'),
                    params: localStorage.getItem('CoreRedirectParams'),
                    timemodified: parseInt(localStorage.getItem('CoreRedirectTime'), 10)
                };
                if (data.params) {
                    data.params = JSON.parse(data.params);
                }
                return data;
            }
            catch (ex) {
                this.logger.error('Error loading redirect data:', ex);
            }
        }
        return {};
    };
    /**
     * Store redirect params.
     *
     * @param {string} siteId Site ID.
     * @param {string} page Page to go.
     * @param {any} params Page params.
     */
    CoreAppProvider.prototype.storeRedirect = function (siteId, page, params) {
        if (localStorage && localStorage.setItem) {
            try {
                localStorage.setItem('CoreRedirectSiteId', siteId);
                localStorage.setItem('CoreRedirectState', page);
                localStorage.setItem('CoreRedirectParams', JSON.stringify(params));
                localStorage.setItem('CoreRedirectTime', String(Date.now()));
            }
            catch (ex) {
                // Ignore errors.
            }
        }
    };
    /**
     * Implement the backbutton actions pile.
     */
    CoreAppProvider.prototype.backButtonAction = function () {
        var x = 0;
        for (; x < this.backActions.length; x++) {
            if (this.backActions[x].priority < 1000) {
                break;
            }
            // Stop in the first action taken.
            if (this.backActions[x].fn()) {
                return;
            }
        }
        // Close open modals if any.
        if (this.menuCtrl && this.menuCtrl.isOpen()) {
            this.menuCtrl.close();
            return;
        }
        // Remaining actions will have priority less than 1000.
        for (; x < this.backActions.length; x++) {
            if (this.backActions[x].priority < 500) {
                break;
            }
            // Stop in the first action taken.
            if (this.backActions[x].fn()) {
                return;
            }
        }
        // Nothing found, go back.
        var navPromise = this.appCtrl.navPop();
        if (navPromise) {
            return;
        }
        // No views to go back to.
        // Remaining actions will have priority less than 500.
        for (; x < this.backActions.length; x++) {
            // Stop in the first action taken.
            if (this.backActions[x].fn()) {
                return;
            }
        }
        // Ionic will decide (exit the app).
        this.appCtrl.goBack();
    };
    /**
     * The back button event is triggered when the user presses the native
     * platform's back button, also referred to as the "hardware" back button.
     * This event is only used within Cordova apps running on Android and
     * Windows platforms. This event is not fired on iOS since iOS doesn't come
     * with a hardware back button in the same sense an Android or Windows device
     * does.
     *
     * Registering a hardware back button action and setting a priority allows
     * apps to control which action should be called when the hardware back
     * button is pressed. This method decides which of the registered back button
     * actions has the highest priority and should be called.
     *
     * @param {Function} fn Called when the back button is pressed,
     * if this registered action has the highest priority.
     * @param {number} priority Set the priority for this action. All actions sorted by priority will be executed since one of
     * them returns true.
     *   * Priorities higher or equal than 1000 will go before closing modals
     *   * Priorities lower than 500 will only be executed if you are in the first state of the app (before exit).
     * @returns {Function} A function that, when called, will unregister
     * the back button action.
     */
    CoreAppProvider.prototype.registerBackButtonAction = function (fn, priority) {
        var _this = this;
        if (priority === void 0) { priority = 0; }
        var action = { fn: fn, priority: priority };
        this.backActions.push(action);
        this.backActions.sort(function (a, b) {
            return b.priority - a.priority;
        });
        return function () {
            var index = _this.backActions.indexOf(action);
            return index >= 0 && !!_this.backActions.splice(index, 1);
        };
    };
    /**
     * Set StatusBar color depending on platform.
     */
    CoreAppProvider.prototype.setStatusBarColor = function () {
        if (typeof __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgios == 'string' && this.platform.is('ios')) {
            // IOS Status bar properties.
            this.statusBar.overlaysWebView(false);
            this.statusBar.backgroundColorByHexString(__WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgios);
            __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarlighttextios ? this.statusBar.styleLightContent() : this.statusBar.styleDefault();
        }
        else if (typeof __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgandroid == 'string' && this.platform.is('android')) {
            // Android Status bar properties.
            this.statusBar.backgroundColorByHexString(__WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgandroid);
            __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarlighttextandroid ? this.statusBar.styleLightContent() : this.statusBar.styleDefault();
        }
        else if (typeof __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbg == 'string') {
            // Generic Status bar properties.
            this.platform.is('ios') && this.statusBar.overlaysWebView(false);
            this.statusBar.backgroundColorByHexString(__WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbg);
            __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarlighttext ? this.statusBar.styleLightContent() : this.statusBar.styleDefault();
        }
        else {
            // Default Status bar properties.
            this.platform.is('android') ? this.statusBar.styleLightContent() : this.statusBar.styleDefault();
        }
    };
    /**
     * Reset StatusBar color if any was set.
     */
    CoreAppProvider.prototype.resetStatusBarColor = function () {
        if (typeof __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgremotetheme == 'string' &&
            ((typeof __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgios == 'string' && this.platform.is('ios')) ||
                (typeof __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgandroid == 'string' && this.platform.is('android')) ||
                typeof __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbg == 'string')) {
            // If the status bar has been overriden and there's a fallback color for remote themes, use it now.
            this.platform.is('ios') && this.statusBar.overlaysWebView(false);
            this.statusBar.backgroundColorByHexString(__WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarbgremotetheme);
            __WEBPACK_IMPORTED_MODULE_8__configconstants__["a" /* CoreConfigConstants */].statusbarlighttextremotetheme ?
                this.statusBar.styleLightContent() : this.statusBar.styleDefault();
        }
    };
    /**
     * Set value of forceOffline flag. If true, the app will think the device is offline.
     *
     * @param {boolean} value Value to set.
     */
    CoreAppProvider.prototype.setForceOffline = function (value) {
        this.forceOffline = !!value;
    };
    CoreAppProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__db__["a" /* CoreDbProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_2__ionic_native_keyboard__["a" /* Keyboard */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["c" /* App */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_network__["a" /* Network */], __WEBPACK_IMPORTED_MODULE_6__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_7__events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["q" /* MenuController */], __WEBPACK_IMPORTED_MODULE_4__ionic_native_status_bar__["a" /* StatusBar */]])
    ], CoreAppProvider);
    return CoreAppProvider;
}());

//# sourceMappingURL=app.js.map

/***/ }),
/* 9 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDomUtilsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_platform_browser__ = __webpack_require__(83);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_bs_tooltip_bs_tooltip__ = __webpack_require__(743);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_12_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/*
 * "Utils" service with helper functions for UI, DOM elements and HTML code.
 */
var CoreDomUtilsProvider = /** @class */ (function () {
    function CoreDomUtilsProvider(translate, loadingCtrl, toastCtrl, alertCtrl, textUtils, appProvider, platform, configProvider, urlUtils, modalCtrl, sanitizer, popoverCtrl, fileProvider) {
        var _this = this;
        this.translate = translate;
        this.loadingCtrl = loadingCtrl;
        this.toastCtrl = toastCtrl;
        this.alertCtrl = alertCtrl;
        this.textUtils = textUtils;
        this.appProvider = appProvider;
        this.platform = platform;
        this.configProvider = configProvider;
        this.urlUtils = urlUtils;
        this.modalCtrl = modalCtrl;
        this.sanitizer = sanitizer;
        this.popoverCtrl = popoverCtrl;
        this.fileProvider = fileProvider;
        // List of input types that support keyboard.
        this.INPUT_SUPPORT_KEYBOARD = ['date', 'datetime', 'datetime-local', 'email', 'month', 'number', 'password',
            'search', 'tel', 'text', 'time', 'url', 'week'];
        this.INSTANCE_ID_ATTR_NAME = 'core-instance-id';
        this.template = document.createElement('template'); // A template element to convert HTML to element.
        this.instances = {}; // Store component/directive instances by id.
        this.lastInstanceId = 0;
        this.debugDisplay = false; // Whether to display debug messages. Store it in a variable to make it synchronous.
        this.displayedAlerts = {}; // To prevent duplicated alerts.
        // Check if debug messages should be displayed.
        configProvider.get(__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].SETTINGS_DEBUG_DISPLAY, false).then(function (debugDisplay) {
            _this.debugDisplay = !!debugDisplay;
        });
    }
    /**
     * Equivalent to element.closest(). If the browser doesn't support element.closest, it will
     * traverse the parents to achieve the same functionality.
     * Returns the closest ancestor of the current element (or the current element itself) which matches the selector.
     *
     * @param {HTMLElement} element DOM Element.
     * @param {string} selector Selector to search.
     * @return {Element} Closest ancestor.
     */
    CoreDomUtilsProvider.prototype.closest = function (element, selector) {
        var _this = this;
        // Try to use closest if the browser supports it.
        if (typeof element.closest == 'function') {
            return element.closest(selector);
        }
        if (!this.matchesFn) {
            // Find the matches function supported by the browser.
            ['matches', 'webkitMatchesSelector', 'mozMatchesSelector', 'msMatchesSelector', 'oMatchesSelector'].some(function (fn) {
                if (typeof document.body[fn] == 'function') {
                    _this.matchesFn = fn;
                    return true;
                }
                return false;
            });
            if (!this.matchesFn) {
                return;
            }
        }
        // Traverse parents.
        while (element) {
            if (element[this.matchesFn](selector)) {
                return element;
            }
            element = element.parentElement;
        }
    };
    /**
     * If the download size is higher than a certain threshold shows a confirm dialog.
     *
     * @param {any} size Object containing size to download and a boolean to indicate if its totally or partialy calculated.
     * @param {string} [message] Code of the message to show. Default: 'core.course.confirmdownload'.
     * @param {string} [unknownMessage] ID of the message to show if size is unknown.
     * @param {number} [wifiThreshold] Threshold to show confirm in WiFi connection. Default: CoreWifiDownloadThreshold.
     * @param {number} [limitedThreshold] Threshold to show confirm in limited connection. Default: CoreDownloadThreshold.
     * @param {boolean} [alwaysConfirm] True to show a confirm even if the size isn't high, false otherwise.
     * @return {Promise<void>} Promise resolved when the user confirms or if no confirm needed.
     */
    CoreDomUtilsProvider.prototype.confirmDownloadSize = function (size, message, unknownMessage, wifiThreshold, limitedThreshold, alwaysConfirm) {
        var _this = this;
        var readableSize = this.textUtils.bytesToSize(size.size, 2);
        var getAvailableBytes = new Promise(function (resolve) {
            if (_this.appProvider.isDesktop()) {
                // Free space calculation is not supported on desktop.
                resolve(null);
            }
            else {
                _this.fileProvider.calculateFreeSpace().then(function (availableBytes) {
                    if (_this.platform.is('android')) {
                        return availableBytes;
                    }
                    else {
                        // Space calculation is not accurate on iOS, but it gets more accurate when space is lower.
                        // We'll only use it when space is <500MB, or we're downloading more than twice the reported space.
                        if (availableBytes < __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].IOS_FREE_SPACE_THRESHOLD || size.size > availableBytes / 2) {
                            return availableBytes;
                        }
                        else {
                            return null;
                        }
                    }
                }).then(function (availableBytes) {
                    resolve(availableBytes);
                });
            }
        });
        var getAvailableSpace = getAvailableBytes.then(function (availableBytes) {
            if (availableBytes === null) {
                return '';
            }
            else {
                var availableSize = _this.textUtils.bytesToSize(availableBytes, 2);
                if (_this.platform.is('android') && size.size > availableBytes - __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].MINIMUM_FREE_SPACE) {
                    return Promise.reject(_this.translate.instant('core.course.insufficientavailablespace', { size: readableSize }));
                }
                return _this.translate.instant('core.course.availablespace', { available: availableSize });
            }
        });
        return getAvailableSpace.then(function (availableSpace) {
            wifiThreshold = typeof wifiThreshold == 'undefined' ? __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].WIFI_DOWNLOAD_THRESHOLD : wifiThreshold;
            limitedThreshold = typeof limitedThreshold == 'undefined' ? __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].DOWNLOAD_THRESHOLD : limitedThreshold;
            var wifiPrefix = '';
            if (_this.appProvider.isNetworkAccessLimited()) {
                wifiPrefix = _this.translate.instant('core.course.confirmlimiteddownload');
            }
            if (size.size < 0 || (size.size == 0 && !size.total)) {
                // Seems size was unable to be calculated. Show a warning.
                unknownMessage = unknownMessage || 'core.course.confirmdownloadunknownsize';
                return _this.showConfirm(wifiPrefix + _this.translate.instant(unknownMessage, { availableSpace: availableSpace }));
            }
            else if (!size.total) {
                // Filesize is only partial.
                return _this.showConfirm(wifiPrefix + _this.translate.instant('core.course.confirmpartialdownloadsize', { size: readableSize, availableSpace: availableSpace }));
            }
            else if (alwaysConfirm || size.size >= wifiThreshold ||
                (_this.appProvider.isNetworkAccessLimited() && size.size >= limitedThreshold)) {
                message = message || 'core.course.confirmdownload';
                return _this.showConfirm(wifiPrefix + _this.translate.instant(message, { size: readableSize, availableSpace: availableSpace }));
            }
            return Promise.resolve();
        });
    };
    /**
     * Convert some HTML as text into an HTMLElement. This HTML is put inside a div or a body.
     *
     * @param {string} html Text to convert.
     * @return {HTMLElement} Element.
     */
    CoreDomUtilsProvider.prototype.convertToElement = function (html) {
        // Add a div to hold the content, that's the element that will be returned.
        this.template.innerHTML = '<div>' + html + '</div>';
        return this.template.content.children[0];
    };
    /**
     * Create a "cancelled" error. These errors won't display an error message in showErrorModal functions.
     *
     * @return {any} The error object.
     */
    CoreDomUtilsProvider.prototype.createCanceledError = function () {
        return { coreCanceled: true };
    };
    /**
     * Given a list of changes for a component input detected by a KeyValueDiffers, create an object similar to the one
     * passed to the ngOnChanges functions.
     *
     * @param {any} changes Changes detected by KeyValueDiffer.
     * @return {{[name: string]: SimpleChange}} Changes in a format like ngOnChanges.
     */
    CoreDomUtilsProvider.prototype.createChangesFromKeyValueDiff = function (changes) {
        var newChanges = {};
        // Added items are considered first change.
        changes.forEachAddedItem(function (item) {
            newChanges[item.key] = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["SimpleChange"](item.previousValue, item.currentValue, true);
        });
        // Changed or removed items aren't first change.
        changes.forEachChangedItem(function (item) {
            newChanges[item.key] = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["SimpleChange"](item.previousValue, item.currentValue, false);
        });
        changes.forEachRemovedItem(function (item) {
            newChanges[item.key] = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["SimpleChange"](item.previousValue, item.currentValue, true);
        });
        return newChanges;
    };
    /**
     * Extract the downloadable URLs from an HTML code.
     *
     * @param {string} html HTML code.
     * @return {string[]} List of file urls.
     */
    CoreDomUtilsProvider.prototype.extractDownloadableFilesFromHtml = function (html) {
        var urls = [];
        var elements;
        var element = this.convertToElement(html);
        elements = element.querySelectorAll('a, img, audio, video, source, track');
        for (var i = 0; i < elements.length; i++) {
            var element_1 = elements[i];
            var url = element_1.tagName === 'A' ? element_1.href : element_1.src;
            if (url && this.urlUtils.isDownloadableUrl(url) && urls.indexOf(url) == -1) {
                urls.push(url);
            }
            // Treat video poster.
            if (element_1.tagName == 'VIDEO' && element_1.getAttribute('poster')) {
                url = element_1.getAttribute('poster');
                if (url && this.urlUtils.isDownloadableUrl(url) && urls.indexOf(url) == -1) {
                    urls.push(url);
                }
            }
        }
        return urls;
    };
    /**
     * Extract the downloadable URLs from an HTML code and returns them in fake file objects.
     *
     * @param {string} html HTML code.
     * @return {any[]} List of fake file objects with file URLs.
     */
    CoreDomUtilsProvider.prototype.extractDownloadableFilesFromHtmlAsFakeFileObjects = function (html) {
        var urls = this.extractDownloadableFilesFromHtml(html);
        // Convert them to fake file objects.
        return urls.map(function (url) {
            return {
                fileurl: url
            };
        });
    };
    /**
     * Search all the URLs in a CSS file content.
     *
     * @param {string} code CSS code.
     * @return {string[]} List of URLs.
     */
    CoreDomUtilsProvider.prototype.extractUrlsFromCSS = function (code) {
        // First of all, search all the url(...) occurrences that don't include "data:".
        var urls = [], matches = code.match(/url\(\s*["']?(?!data:)([^)]+)\)/igm);
        if (!matches) {
            return urls;
        }
        // Extract the URL form each match.
        matches.forEach(function (match) {
            var submatches = match.match(/url\(\s*['"]?([^'"]*)['"]?\s*\)/im);
            if (submatches && submatches[1]) {
                urls.push(submatches[1]);
            }
        });
        return urls;
    };
    /**
     * Focus an element and open keyboard.
     *
     * @param {HTMLElement} el HTML element to focus.
     */
    CoreDomUtilsProvider.prototype.focusElement = function (el) {
        if (el && el.focus) {
            el.focus();
            if (this.platform.is('android') && this.supportsInputKeyboard(el)) {
                // On some Android versions the keyboard doesn't open automatically.
                this.appProvider.openKeyboard();
            }
        }
    };
    /**
     * Formats a size to be used as width/height of an element.
     * If the size is already valid (like '500px' or '50%') it won't be modified.
     * Returned size will have a format like '500px'.
     *
     * @param {any} size Size to format.
     * @return {string} Formatted size. If size is not valid, returns an empty string.
     */
    CoreDomUtilsProvider.prototype.formatPixelsSize = function (size) {
        if (typeof size == 'string' && (size.indexOf('px') > -1 || size.indexOf('%') > -1)) {
            // It seems to be a valid size.
            return size;
        }
        size = parseInt(size, 10);
        if (!isNaN(size)) {
            return size + 'px';
        }
        return '';
    };
    /**
     * Returns the contents of a certain selection in a DOM element.
     *
     * @param {HTMLElement} element DOM element to search in.
     * @param {string} selector Selector to search.
     * @return {string} Selection contents. Undefined if not found.
     */
    CoreDomUtilsProvider.prototype.getContentsOfElement = function (element, selector) {
        if (element) {
            var selected = element.querySelector(selector);
            if (selected) {
                return selected.innerHTML;
            }
        }
    };
    /**
     * Get the data from a form. It will only collect elements that have a name.
     *
     * @param {HTMLFormElement} form The form to get the data from.
     * @return {any} Object with the data. The keys are the names of the inputs.
     */
    CoreDomUtilsProvider.prototype.getDataFromForm = function (form) {
        if (!form || !form.elements) {
            return {};
        }
        var data = {};
        for (var i = 0; i < form.elements.length; i++) {
            var element = form.elements[i], name_1 = element.name || '';
            // Ignore submit inputs.
            if (!name_1 || element.type == 'submit' || element.tagName == 'BUTTON') {
                continue;
            }
            // Get the value.
            if (element.type == 'checkbox') {
                data[name_1] = !!element.checked;
            }
            else if (element.type == 'radio') {
                if (element.checked) {
                    data[name_1] = element.value;
                }
            }
            else {
                data[name_1] = element.value;
            }
        }
        return data;
    };
    /**
     * Returns the attribute value of a string element. Only the first element will be selected.
     *
     * @param  {string} html      HTML element in string.
     * @param  {string} attribute Attribute to get.
     * @return {string}           Attribute value.
     */
    CoreDomUtilsProvider.prototype.getHTMLElementAttribute = function (html, attribute) {
        return this.convertToElement(html).children[0].getAttribute('src');
    };
    /**
     * Returns height of an element.
     *
     * @param {any} element DOM element to measure.
     * @param {boolean} [usePadding] Whether to use padding to calculate the measure.
     * @param {boolean} [useMargin] Whether to use margin to calculate the measure.
     * @param {boolean} [useBorder] Whether to use borders to calculate the measure.
     * @param {boolean} [innerMeasure] If inner measure is needed: padding, margin or borders will be substracted.
     * @return {number} Height in pixels.
     */
    CoreDomUtilsProvider.prototype.getElementHeight = function (element, usePadding, useMargin, useBorder, innerMeasure) {
        return this.getElementMeasure(element, false, usePadding, useMargin, useBorder, innerMeasure);
    };
    /**
     * Returns height or width of an element.
     *
     * @param {any} element DOM element to measure.
     * @param {boolean} [getWidth] Whether to get width or height.
     * @param {boolean} [usePadding] Whether to use padding to calculate the measure.
     * @param {boolean} [useMargin] Whether to use margin to calculate the measure.
     * @param {boolean} [useBorder] Whether to use borders to calculate the measure.
     * @param {boolean} [innerMeasure] If inner measure is needed: padding, margin or borders will be substracted.
     * @return {number} Measure in pixels.
     */
    CoreDomUtilsProvider.prototype.getElementMeasure = function (element, getWidth, usePadding, useMargin, useBorder, innerMeasure) {
        var offsetMeasure = getWidth ? 'offsetWidth' : 'offsetHeight', measureName = getWidth ? 'width' : 'height', clientMeasure = getWidth ? 'clientWidth' : 'clientHeight', priorSide = getWidth ? 'Left' : 'Top', afterSide = getWidth ? 'Right' : 'Bottom';
        var measure = element[offsetMeasure] || element[measureName] || element[clientMeasure] || 0;
        // Measure not correctly taken.
        if (measure <= 0) {
            var style = getComputedStyle(element);
            if (style && style.display == '') {
                element.style.display = 'inline-block';
                measure = element[offsetMeasure] || element[measureName] || element[clientMeasure] || 0;
                element.style.display = '';
            }
        }
        if (usePadding || useMargin || useBorder) {
            var computedStyle = getComputedStyle(element);
            var surround = 0;
            if (usePadding) {
                surround += this.getComputedStyleMeasure(computedStyle, 'padding' + priorSide) +
                    this.getComputedStyleMeasure(computedStyle, 'padding' + afterSide);
            }
            if (useMargin) {
                surround += this.getComputedStyleMeasure(computedStyle, 'margin' + priorSide) +
                    this.getComputedStyleMeasure(computedStyle, 'margin' + afterSide);
            }
            if (useBorder) {
                surround += this.getComputedStyleMeasure(computedStyle, 'border' + priorSide + 'Width') +
                    this.getComputedStyleMeasure(computedStyle, 'border' + afterSide + 'Width');
            }
            if (innerMeasure) {
                measure = measure > surround ? measure - surround : 0;
            }
            else {
                measure += surround;
            }
        }
        return measure;
    };
    /**
     * Returns the computed style measure or 0 if not found or NaN.
     *
     * @param  {any}    style   Style from getComputedStyle.
     * @param  {string} measure Measure to get.
     * @return {number}         Result of the measure.
     */
    CoreDomUtilsProvider.prototype.getComputedStyleMeasure = function (style, measure) {
        return parseInt(style[measure], 10) || 0;
    };
    /**
     * Get the HTML code to render a connection warning icon.
     *
     * @return {string} HTML Code.
     */
    CoreDomUtilsProvider.prototype.getConnectionWarningIconHtml = function () {
        return '<div text-center><span class="core-icon-with-badge">' +
            '<ion-icon role="img" class="icon fa fa-wifi" aria-label="wifi"></ion-icon>' +
            '<ion-icon class="icon fa fa-exclamation-triangle core-icon-badge"></ion-icon>' +
            '</span></div>';
    };
    /**
     * Returns width of an element.
     *
     * @param {any} element DOM element to measure.
     * @param {boolean} [usePadding] Whether to use padding to calculate the measure.
     * @param {boolean} [useMargin] Whether to use margin to calculate the measure.
     * @param {boolean} [useBorder] Whether to use borders to calculate the measure.
     * @param {boolean} [innerMeasure] If inner measure is needed: padding, margin or borders will be substracted.
     * @return {number} Width in pixels.
     */
    CoreDomUtilsProvider.prototype.getElementWidth = function (element, usePadding, useMargin, useBorder, innerMeasure) {
        return this.getElementMeasure(element, true, usePadding, useMargin, useBorder, innerMeasure);
    };
    /**
     * Retrieve the position of a element relative to another element.
     *
     * @param {HTMLElement} container Element to search in.
     * @param {string} [selector] Selector to find the element to gets the position.
     * @param {string} [positionParentClass] Parent Class where to stop calculating the position. Default scroll-content.
     * @return {number[]} positionLeft, positionTop of the element relative to.
     */
    CoreDomUtilsProvider.prototype.getElementXY = function (container, selector, positionParentClass) {
        var element = (selector ? container.querySelector(selector) : container), offsetElement, positionTop = 0, positionLeft = 0;
        if (!positionParentClass) {
            positionParentClass = 'scroll-content';
        }
        if (!element) {
            return null;
        }
        while (element) {
            positionLeft += (element.offsetLeft - element.scrollLeft + element.clientLeft);
            positionTop += (element.offsetTop - element.scrollTop + element.clientTop);
            offsetElement = element.offsetParent;
            element = element.parentElement;
            // Every parent class has to be checked but the position has to be got form offsetParent.
            while (offsetElement != element && element) {
                // If positionParentClass element is reached, stop adding tops.
                if (element.className.indexOf(positionParentClass) != -1) {
                    element = null;
                }
                else {
                    element = element.parentElement;
                }
            }
            // Finally, check again.
            if (element && element.className.indexOf(positionParentClass) != -1) {
                element = null;
            }
        }
        return [positionLeft, positionTop];
    };
    /**
     * Given an error message, return a suitable error title.
     *
     * @param {string} message The error message.
     * @return {any} Title.
     */
    CoreDomUtilsProvider.prototype.getErrorTitle = function (message) {
        if (message == this.translate.instant('core.networkerrormsg') ||
            message == this.translate.instant('core.fileuploader.errormustbeonlinetoupload')) {
            return this.sanitizer.bypassSecurityTrustHtml(this.getConnectionWarningIconHtml());
        }
        return this.textUtils.decodeHTML(this.translate.instant('core.error'));
    };
    /**
     * Retrieve component/directive instance.
     * Please use this function only if you cannot retrieve the instance using parent/child methods: ViewChild (or similar)
     * or Angular's injection.
     *
     * @param {Element} element The root element of the component/directive.
     * @return {any} The instance, undefined if not found.
     */
    CoreDomUtilsProvider.prototype.getInstanceByElement = function (element) {
        var id = element.getAttribute(this.INSTANCE_ID_ATTR_NAME);
        return this.instances[id];
    };
    /**
     * Handle bootstrap tooltips in a certain element.
     *
     * @param {HTMLElement} element Element to check.
     */
    CoreDomUtilsProvider.prototype.handleBootstrapTooltips = function (element) {
        var _this = this;
        var els = Array.from(element.querySelectorAll('[data-toggle="tooltip"]'));
        els.forEach(function (el) {
            var content = el.getAttribute('title') || el.getAttribute('data-original-title'), trigger = el.getAttribute('data-trigger') || 'hover focus', treated = el.getAttribute('data-bstooltip-treated');
            if (!content || treated === 'true' ||
                (trigger.indexOf('hover') == -1 && trigger.indexOf('focus') == -1 && trigger.indexOf('click') == -1)) {
                return;
            }
            el.setAttribute('data-bstooltip-treated', 'true'); // Mark it as treated.
            // Store the title in data-original-title instead of title, like BS does.
            el.setAttribute('data-original-title', content);
            el.setAttribute('title', '');
            el.addEventListener('click', function (e) {
                var html = el.getAttribute('data-html');
                var popover = _this.popoverCtrl.create(__WEBPACK_IMPORTED_MODULE_10__components_bs_tooltip_bs_tooltip__["a" /* CoreBSTooltipComponent */], {
                    content: content,
                    html: html === 'true'
                });
                popover.present({
                    ev: e
                });
            });
        });
    };
    /**
     * Check if an element is outside of screen (viewport).
     *
     * @param {HTMLElement} scrollEl The element that must be scrolled.
     * @param {HTMLElement} element DOM element to check.
     * @return {boolean} Whether the element is outside of the viewport.
     */
    CoreDomUtilsProvider.prototype.isElementOutsideOfScreen = function (scrollEl, element) {
        var elementRect = element.getBoundingClientRect();
        var elementMidPoint, scrollElRect, scrollTopPos = 0;
        if (!elementRect) {
            return false;
        }
        elementMidPoint = Math.round((elementRect.bottom + elementRect.top) / 2);
        scrollElRect = scrollEl.getBoundingClientRect();
        scrollTopPos = (scrollElRect && scrollElRect.top) || 0;
        return elementMidPoint > window.innerHeight || elementMidPoint < scrollTopPos;
    };
    /**
     * Check if rich text editor is enabled.
     *
     * @return {Promise<boolean>} Promise resolved with boolean: true if enabled, false otherwise.
     */
    CoreDomUtilsProvider.prototype.isRichTextEditorEnabled = function () {
        if (this.isRichTextEditorSupported()) {
            return this.configProvider.get(__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].SETTINGS_RICH_TEXT_EDITOR, true).then(function (enabled) {
                return !!enabled;
            });
        }
        return Promise.resolve(false);
    };
    /**
     * Check if rich text editor is supported in the platform.
     *
     * @return {boolean} Whether it's supported.
     */
    CoreDomUtilsProvider.prototype.isRichTextEditorSupported = function () {
        return true;
    };
    /**
     * Move children from one HTMLElement to another.
     *
     * @param {HTMLElement} oldParent The old parent.
     * @param {HTMLElement} newParent The new parent.
     * @return {Node[]} List of moved children.
     */
    CoreDomUtilsProvider.prototype.moveChildren = function (oldParent, newParent) {
        var movedChildren = [];
        while (oldParent.childNodes.length > 0) {
            var child = oldParent.childNodes[0];
            movedChildren.push(child);
            newParent.appendChild(child);
        }
        return movedChildren;
    };
    /**
     * Search and remove a certain element from inside another element.
     *
     * @param {HTMLElement} element DOM element to search in.
     * @param {string} selector Selector to search.
     */
    CoreDomUtilsProvider.prototype.removeElement = function (element, selector) {
        if (element) {
            var selected = element.querySelector(selector);
            if (selected) {
                selected.remove();
            }
        }
    };
    /**
     * Search and remove a certain element from an HTML code.
     *
     * @param {string} html HTML code to change.
     * @param {string} selector Selector to search.
     * @param {boolean} [removeAll] True if it should remove all matches found, false if it should only remove the first one.
     * @return {string} HTML without the element.
     */
    CoreDomUtilsProvider.prototype.removeElementFromHtml = function (html, selector, removeAll) {
        var selected;
        var element = this.convertToElement(html);
        if (removeAll) {
            selected = element.querySelectorAll(selector);
            for (var i = 0; i < selected.length; i++) {
                selected[i].remove();
            }
        }
        else {
            selected = element.querySelector(selector);
            if (selected) {
                selected.remove();
            }
        }
        return element.innerHTML;
    };
    /**
     * Remove a component/directive instance using the DOM Element.
     *
     * @param {Element} element The root element of the component/directive.
     */
    CoreDomUtilsProvider.prototype.removeInstanceByElement = function (element) {
        var id = element.getAttribute(this.INSTANCE_ID_ATTR_NAME);
        delete this.instances[id];
    };
    /**
     * Remove a component/directive instance using the ID.
     *
     * @param {string} id The ID to remove.
     */
    CoreDomUtilsProvider.prototype.removeInstanceById = function (id) {
        delete this.instances[id];
    };
    /**
     * Search for certain classes in an element contents and replace them with the specified new values.
     *
     * @param {HTMLElement} element DOM element.
     * @param {any} map Mapping of the classes to replace. Keys must be the value to replace, values must be
     *            the new class name. Example: {'correct': 'core-question-answer-correct'}.
     */
    CoreDomUtilsProvider.prototype.replaceClassesInElement = function (element, map) {
        for (var key in map) {
            var foundElements = element.querySelectorAll('.' + key);
            for (var i = 0; i < foundElements.length; i++) {
                var foundElement = foundElements[i];
                foundElement.className = foundElement.className.replace(key, map[key]);
            }
        }
    };
    /**
     * Given an HTML, search all links and media and tries to restore original sources using the paths object.
     *
     * @param {string} html HTML code.
     * @param {object} paths Object linking URLs in the html code with the real URLs to use.
     * @param {Function} [anchorFn] Function to call with each anchor. Optional.
     * @return {string} Treated HTML code.
     */
    CoreDomUtilsProvider.prototype.restoreSourcesInHtml = function (html, paths, anchorFn) {
        var _this = this;
        var media, anchors;
        var element = this.convertToElement(html);
        // Treat elements with src (img, audio, video, ...).
        media = Array.from(element.querySelectorAll('img, video, audio, source, track'));
        media.forEach(function (media) {
            var newSrc = paths[_this.textUtils.decodeURIComponent(media.getAttribute('src'))];
            if (typeof newSrc != 'undefined') {
                media.setAttribute('src', newSrc);
            }
            // Treat video posters.
            if (media.tagName == 'VIDEO' && media.getAttribute('poster')) {
                newSrc = paths[_this.textUtils.decodeURIComponent(media.getAttribute('poster'))];
                if (typeof newSrc !== 'undefined') {
                    media.setAttribute('poster', newSrc);
                }
            }
        });
        // Now treat links.
        anchors = Array.from(element.querySelectorAll('a'));
        anchors.forEach(function (anchor) {
            var href = _this.textUtils.decodeURIComponent(anchor.getAttribute('href')), newUrl = paths[href];
            if (typeof newUrl != 'undefined') {
                anchor.setAttribute('href', newUrl);
                if (typeof anchorFn == 'function') {
                    anchorFn(anchor, href);
                }
            }
        });
        return element.innerHTML;
    };
    /**
     * Scroll to somehere in the content.
     * Checks hidden property _scroll to avoid errors if view is not active.
     *
     * @param {Content} content Content where to execute the function.
     * @param {number} x  The x-value to scroll to.
     * @param {number} y  The y-value to scroll to.
     * @param {number} [duration]  Duration of the scroll animation in milliseconds. Defaults to `300`.
     * @returns {Promise} Returns a promise which is resolved when the scroll has completed.
     */
    CoreDomUtilsProvider.prototype.scrollTo = function (content, x, y, duration, done) {
        return content && content._scroll && content.scrollTo(x, y, duration, done);
    };
    /**
     * Scroll to Bottom of the content.
     * Checks hidden property _scroll to avoid errors if view is not active.
     *
     * @param {Content} content Content where to execute the function.
     * @param {number} [duration]  Duration of the scroll animation in milliseconds. Defaults to `300`.
     * @returns {Promise} Returns a promise which is resolved when the scroll has completed.
     */
    CoreDomUtilsProvider.prototype.scrollToBottom = function (content, duration) {
        return content && content._scroll && content.scrollToBottom(duration);
    };
    /**
     * Scroll to Top of the content.
     * Checks hidden property _scroll to avoid errors if view is not active.
     *
     * @param {Content} content Content where to execute the function.
     * @param {number} [duration]  Duration of the scroll animation in milliseconds. Defaults to `300`.
     * @returns {Promise} Returns a promise which is resolved when the scroll has completed.
     */
    CoreDomUtilsProvider.prototype.scrollToTop = function (content, duration) {
        return content && content._scroll && content.scrollToTop(duration);
    };
    /**
     * Returns contentHeight of the content.
     * Checks hidden property _scroll to avoid errors if view is not active.
     *
     * @param {Content} content Content where to execute the function.
     * @return {number}         Content contentHeight or 0.
     */
    CoreDomUtilsProvider.prototype.getContentHeight = function (content) {
        return (content && content._scroll && content.contentHeight) || 0;
    };
    /**
     * Returns scrollHeight of the content.
     * Checks hidden property _scroll to avoid errors if view is not active.
     *
     * @param {Content} content Content where to execute the function.
     * @return {number}         Content scrollHeight or 0.
     */
    CoreDomUtilsProvider.prototype.getScrollHeight = function (content) {
        return (content && content._scroll && content.scrollHeight) || 0;
    };
    /**
     * Returns scrollTop of the content.
     * Checks hidden property _scroll to avoid errors if view is not active.
     *
     * @param {Content} content Content where to execute the function.
     * @return {number}         Content scrollTop or 0.
     */
    CoreDomUtilsProvider.prototype.getScrollTop = function (content) {
        return (content && content._scroll && content.scrollTop) || 0;
    };
    /**
     * Scroll to a certain element.
     *
     * @param {Content} content The content that must be scrolled.
     * @param {HTMLElement} element The element to scroll to.
     * @param {string} [scrollParentClass] Parent class where to stop calculating the position. Default scroll-content.
     * @return {boolean} True if the element is found, false otherwise.
     */
    CoreDomUtilsProvider.prototype.scrollToElement = function (content, element, scrollParentClass) {
        var position = this.getElementXY(element, undefined, scrollParentClass);
        if (!position) {
            return false;
        }
        this.scrollTo(content, position[0], position[1]);
        return true;
    };
    /**
     * Scroll to a certain element using a selector to find it.
     *
     * @param {Content} content The content that must be scrolled.
     * @param {string} selector Selector to find the element to scroll to.
     * @param {string} [scrollParentClass] Parent class where to stop calculating the position. Default scroll-content.
     * @return {boolean} True if the element is found, false otherwise.
     */
    CoreDomUtilsProvider.prototype.scrollToElementBySelector = function (content, selector, scrollParentClass) {
        var position = this.getElementXY(content.getScrollElement(), selector, scrollParentClass);
        if (!position) {
            return false;
        }
        this.scrollTo(content, position[0], position[1]);
        return true;
    };
    /**
     * Search for an input with error (core-input-error directive) and scrolls to it if found.
     *
     * @param {Content} content The content that must be scrolled.
     * @param [scrollParentClass] Parent class where to stop calculating the position. Default scroll-content.
     * @return {boolean} True if the element is found, false otherwise.
     */
    CoreDomUtilsProvider.prototype.scrollToInputError = function (content, scrollParentClass) {
        if (!content) {
            return false;
        }
        return this.scrollToElementBySelector(content, '.core-input-error', scrollParentClass);
    };
    /**
     * Set whether debug messages should be displayed.
     *
     * @param {boolean} value Whether to display or not.
     */
    CoreDomUtilsProvider.prototype.setDebugDisplay = function (value) {
        this.debugDisplay = value;
    };
    /**
     * Show an alert modal with a button to close it.
     *
     * @param {string} title Title to show.
     * @param {string} message Message to show.
     * @param {string} [buttonText] Text of the button.
     * @param {number} [autocloseTime] Number of milliseconds to wait to close the modal. If not defined, modal won't be closed.
     * @return {Promise<CoreAlert>} Promise resolved with the alert modal.
     */
    CoreDomUtilsProvider.prototype.showAlert = function (title, message, buttonText, autocloseTime) {
        var _this = this;
        var hasHTMLTags = this.textUtils.hasHTMLTags(message);
        var promise;
        if (hasHTMLTags) {
            // Format the text.
            promise = this.textUtils.formatText(message);
        }
        else {
            promise = Promise.resolve(message);
        }
        return promise.then(function (message) {
            var alertId = __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__["Md5"].hashAsciiStr((title || '') + '#' + (message || ''));
            if (_this.displayedAlerts[alertId]) {
                // There's already an alert with the same message and title. Return it.
                return _this.displayedAlerts[alertId];
            }
            var alert = _this.alertCtrl.create({
                title: title,
                message: message,
                buttons: [buttonText || _this.translate.instant('core.ok')]
            });
            alert.present().then(function () {
                if (hasHTMLTags) {
                    // Treat all anchors so they don't override the app.
                    var alertMessageEl = alert.pageRef().nativeElement.querySelector('.alert-message');
                    _this.treatAnchors(alertMessageEl);
                }
            });
            // Store the alert and remove it when dismissed.
            _this.displayedAlerts[alertId] = alert;
            // Define the observables to extend the Alert class. This will allow several callbacks instead of just one.
            alert.didDismiss = new __WEBPACK_IMPORTED_MODULE_12_rxjs__["Subject"]();
            alert.willDismiss = new __WEBPACK_IMPORTED_MODULE_12_rxjs__["Subject"]();
            // Set the callbacks to trigger an observable event.
            alert.onDidDismiss(function (data, role) {
                delete _this.displayedAlerts[alertId];
                alert.didDismiss.next({ data: data, role: role });
            });
            alert.onWillDismiss(function (data, role) {
                alert.willDismiss.next({ data: data, role: role });
            });
            if (autocloseTime > 0) {
                setTimeout(function () {
                    alert.dismiss();
                }, autocloseTime);
            }
            return alert;
        });
    };
    /**
     * Show an alert modal with a button to close it, translating the values supplied.
     *
     * @param {string} title Title to show.
     * @param {string} message Message to show.
     * @param {string} [buttonText] Text of the button.
     * @param {number} [autocloseTime] Number of milliseconds to wait to close the modal. If not defined, modal won't be closed.
     * @return {Promise<Alert>} Promise resolved with the alert modal.
     */
    CoreDomUtilsProvider.prototype.showAlertTranslated = function (title, message, buttonText, autocloseTime) {
        title = title ? this.translate.instant(title) : title;
        message = message ? this.translate.instant(message) : message;
        buttonText = buttonText ? this.translate.instant(buttonText) : buttonText;
        return this.showAlert(title, message, buttonText, autocloseTime);
    };
    /**
     * Show a confirm modal.
     *
     * @param {string} message Message to show in the modal body.
     * @param {string} [title] Title of the modal.
     * @param {string} [okText] Text of the OK button.
     * @param {string} [cancelText] Text of the Cancel button.
     * @param {any} [options] More options. See https://ionicframework.com/docs/v3/api/components/alert/AlertController/
     * @return {Promise<any>} Promise resolved if the user confirms and rejected with a canceled error if he cancels.
     */
    CoreDomUtilsProvider.prototype.showConfirm = function (message, title, okText, cancelText, options) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var hasHTMLTags = _this.textUtils.hasHTMLTags(message);
            var promise;
            if (hasHTMLTags) {
                // Format the text.
                promise = _this.textUtils.formatText(message);
            }
            else {
                promise = Promise.resolve(message);
            }
            promise.then(function (message) {
                options = options || {};
                options.message = message;
                options.title = title;
                if (!title) {
                    options.cssClass = 'core-nohead';
                }
                options.buttons = [
                    {
                        text: cancelText || _this.translate.instant('core.cancel'),
                        role: 'cancel',
                        handler: function () {
                            reject(_this.createCanceledError());
                        }
                    },
                    {
                        text: okText || _this.translate.instant('core.ok'),
                        handler: function (data) {
                            resolve(data);
                        }
                    }
                ];
                var alert = _this.alertCtrl.create(options);
                alert.present().then(function () {
                    if (hasHTMLTags) {
                        // Treat all anchors so they don't override the app.
                        var alertMessageEl = alert.pageRef().nativeElement.querySelector('.alert-message');
                        _this.treatAnchors(alertMessageEl);
                    }
                });
            });
        });
    };
    /**
     * Show an alert modal with an error message.
     *
     * @param {any} error Message to show.
     * @param {boolean} [needsTranslate] Whether the error needs to be translated.
     * @param {number} [autocloseTime] Number of milliseconds to wait to close the modal. If not defined, modal won't be closed.
     * @return {Promise<Alert>} Promise resolved with the alert modal.
     */
    CoreDomUtilsProvider.prototype.showErrorModal = function (error, needsTranslate, autocloseTime) {
        var extraInfo = '';
        if (typeof error == 'object') {
            if (this.debugDisplay) {
                // Get the debug info. Escape the HTML so it is displayed as it is in the view.
                if (error.debuginfo) {
                    extraInfo = '<br><br>' + this.textUtils.escapeHTML(error.debuginfo);
                }
                if (error.backtrace) {
                    extraInfo += '<br><br>' + this.textUtils.replaceNewLines(this.textUtils.escapeHTML(error.backtrace), '<br>');
                }
                // tslint:disable-next-line
                console.error(error);
            }
            // We received an object instead of a string. Search for common properties.
            if (error.coreCanceled) {
                // It's a canceled error, don't display an error.
                return;
            }
            error = this.textUtils.getErrorMessageFromError(error);
            if (!error) {
                // No common properties found, just stringify it.
                error = JSON.stringify(error);
                extraInfo = ''; // No need to add extra info because it's already in the error.
            }
            // Try to remove tokens from the contents.
            var matches = error.match(/token"?[=|:]"?(\w*)/, '');
            if (matches && matches[1]) {
                error = error.replace(new RegExp(matches[1], 'g'), 'secret');
            }
        }
        if (error == __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].DONT_SHOW_ERROR) {
            // The error shouldn't be shown, stop.
            return;
        }
        var message = this.textUtils.decodeHTML(needsTranslate ? this.translate.instant(error) : error);
        if (extraInfo) {
            message += extraInfo;
        }
        return this.showAlert(this.getErrorTitle(message), message, undefined, autocloseTime);
    };
    /**
     * Show an alert modal with an error message. It uses a default message if error is not a string.
     *
     * @param {any} error Message to show.
     * @param {any} [defaultError] Message to show if the error is not a string.
     * @param {boolean} [needsTranslate] Whether the error needs to be translated.
     * @param {number} [autocloseTime] Number of milliseconds to wait to close the modal. If not defined, modal won't be closed.
     * @return {Promise<Alert>} Promise resolved with the alert modal.
     */
    CoreDomUtilsProvider.prototype.showErrorModalDefault = function (error, defaultError, needsTranslate, autocloseTime) {
        if (error && error.coreCanceled) {
            // It's a canceled error, don't display an error.
            return;
        }
        var errorMessage = error;
        if (error && typeof error != 'string') {
            errorMessage = this.textUtils.getErrorMessageFromError(error);
        }
        return this.showErrorModal(typeof errorMessage == 'string' ? error : defaultError, needsTranslate, autocloseTime);
    };
    /**
     * Show an alert modal with the first warning error message. It uses a default message if error is not a string.
     *
     * @param {any} warnings Warnings returned.
     * @param {any} [defaultError] Message to show if the error is not a string.
     * @param {boolean} [needsTranslate] Whether the error needs to be translated.
     * @param {number} [autocloseTime] Number of milliseconds to wait to close the modal. If not defined, modal won't be closed.
     * @return {Promise<Alert>} Promise resolved with the alert modal.
     */
    CoreDomUtilsProvider.prototype.showErrorModalFirstWarning = function (warnings, defaultError, needsTranslate, autocloseTime) {
        var error = warnings && warnings.length && warnings[0].message;
        return this.showErrorModalDefault(error, defaultError, needsTranslate, autocloseTime);
    };
    /**
     * Displays a loading modal window.
     *
     * @param {string} [text] The text of the modal window. Default: core.loading.
     * @param {boolean} [needsTranslate] Whether the 'text' needs to be translated.
     * @return {Loading} Loading modal instance.
     * @description
     * Usage:
     *     let modal = domUtils.showModalLoading(myText);
     *     ...
     *     modal.dismiss();
     */
    CoreDomUtilsProvider.prototype.showModalLoading = function (text, needsTranslate) {
        if (!text) {
            text = this.translate.instant('core.loading');
        }
        else if (needsTranslate) {
            text = this.translate.instant(text);
        }
        var loader = this.loadingCtrl.create({
            content: text
        }), dismiss = loader.dismiss.bind(loader);
        var isPresented = false, isDismissed = false;
        // Override dismiss to prevent dismissing a modal twice (it can throw an error and cause problems).
        loader.dismiss = function (data, role, navOptions) {
            if (!isPresented || isDismissed) {
                isDismissed = true;
                return Promise.resolve();
            }
            isDismissed = true;
            return dismiss(data, role, navOptions);
        };
        // Wait a bit before presenting the modal, to prevent it being displayed if dissmiss is called fast.
        setTimeout(function () {
            if (!isDismissed) {
                isPresented = true;
                loader.present();
            }
        }, 40);
        return loader;
    };
    /**
     * Show a prompt modal to input some data.
     *
     * @param {string} message Modal message.
     * @param {string} [title] Modal title.
     * @param {string} [placeholder] Placeholder of the input element. By default, "Password".
     * @param {string} [type] Type of the input element. By default, password.
     * @return {Promise<any>} Promise resolved with the input data if the user clicks OK, rejected if cancels.
     */
    CoreDomUtilsProvider.prototype.showPrompt = function (message, title, placeholder, type) {
        var _this = this;
        if (type === void 0) { type = 'password'; }
        return new Promise(function (resolve, reject) {
            var hasHTMLTags = _this.textUtils.hasHTMLTags(message);
            var promise;
            if (hasHTMLTags) {
                // Format the text.
                promise = _this.textUtils.formatText(message);
            }
            else {
                promise = Promise.resolve(message);
            }
            promise.then(function (message) {
                var alert = _this.alertCtrl.create({
                    message: message,
                    title: title,
                    inputs: [
                        {
                            name: 'promptinput',
                            placeholder: placeholder || _this.translate.instant('core.login.password'),
                            type: type
                        }
                    ],
                    buttons: [
                        {
                            text: _this.translate.instant('core.cancel'),
                            role: 'cancel',
                            handler: function () {
                                reject();
                            }
                        },
                        {
                            text: _this.translate.instant('core.ok'),
                            handler: function (data) {
                                resolve(data.promptinput);
                            }
                        }
                    ]
                });
                alert.present().then(function () {
                    if (hasHTMLTags) {
                        // Treat all anchors so they don't override the app.
                        var alertMessageEl = alert.pageRef().nativeElement.querySelector('.alert-message');
                        _this.treatAnchors(alertMessageEl);
                    }
                });
            });
        });
    };
    /**
     * Displays an autodimissable toast modal window.
     *
     * @param {string} text The text of the toast.
     * @param {boolean} [needsTranslate] Whether the 'text' needs to be translated.
     * @param {number} [duration=2000] Duration in ms of the dimissable toast.
     * @param {string} [cssClass=""] Class to add to the toast.
     * @return {Toast} Toast instance.
     */
    CoreDomUtilsProvider.prototype.showToast = function (text, needsTranslate, duration, cssClass) {
        if (duration === void 0) { duration = 2000; }
        if (cssClass === void 0) { cssClass = ''; }
        if (needsTranslate) {
            text = this.translate.instant(text);
        }
        var loader = this.toastCtrl.create({
            message: text,
            duration: duration,
            position: 'bottom',
            cssClass: cssClass,
            dismissOnPageChange: true
        });
        loader.present();
        return loader;
    };
    /**
     * Stores a component/directive instance.
     *
     * @param {Element} element The root element of the component/directive.
     * @param {any} instance The instance to store.
     * @return {string} ID to identify the instance.
     */
    CoreDomUtilsProvider.prototype.storeInstanceByElement = function (element, instance) {
        var id = String(this.lastInstanceId++);
        element.setAttribute(this.INSTANCE_ID_ATTR_NAME, id);
        this.instances[id] = instance;
        return id;
    };
    /**
     * Check if an element supports input via keyboard.
     *
     * @param {any} el HTML element to check.
     * @return {boolean} Whether it supports input using keyboard.
     */
    CoreDomUtilsProvider.prototype.supportsInputKeyboard = function (el) {
        return el && !el.disabled && (el.tagName.toLowerCase() == 'textarea' ||
            (el.tagName.toLowerCase() == 'input' && this.INPUT_SUPPORT_KEYBOARD.indexOf(el.type) != -1));
    };
    /**
     * Converts HTML formatted text to DOM element(s).
     *
     * @param {string} text HTML text.
     * @return {HTMLCollection} Same text converted to HTMLCollection.
     */
    CoreDomUtilsProvider.prototype.toDom = function (text) {
        var element = this.convertToElement(text);
        return element.children;
    };
    /**
     * Treat anchors inside alert/modals.
     *
     * @param {HTMLElement} container The HTMLElement that can contain anchors.
     */
    CoreDomUtilsProvider.prototype.treatAnchors = function (container) {
        var _this = this;
        var anchors = Array.from(container.querySelectorAll('a'));
        anchors.forEach(function (anchor) {
            anchor.addEventListener('click', function (event) {
                if (event.defaultPrevented) {
                    // Stop.
                    return;
                }
                var href = anchor.getAttribute('href');
                if (href) {
                    event.preventDefault();
                    event.stopPropagation();
                    // We cannot use CoreDomUtilsProvider.openInBrowser due to circular dependencies.
                    if (_this.appProvider.isDesktop()) {
                        // It's a desktop app, use Electron shell library to open the browser.
                        var shell = __webpack_require__(70).shell;
                        if (!shell.openExternal(href)) {
                            // Open browser failed, open a new window in the app.
                            window.open(href, '_system');
                        }
                    }
                    else {
                        window.open(href, '_system');
                    }
                }
            });
        });
    };
    /**
     * View an image in a new page or modal.
     *
     * @param {string} image URL of the image.
     * @param {string} title Title of the page or modal.
     * @param {string} [component] Component to link the image to if needed.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     */
    CoreDomUtilsProvider.prototype.viewImage = function (image, title, component, componentId) {
        if (image) {
            var params = {
                title: title,
                image: image,
                component: component,
                componentId: componentId
            }, modal = this.modalCtrl.create('CoreViewerImagePage', params);
            modal.present();
        }
    };
    /**
     * Wait for images to load.
     *
     * @param {HTMLElement} element The element to search in.
     * @return {Promise<boolean>} Promise resolved with a boolean: whether there was any image to load.
     */
    CoreDomUtilsProvider.prototype.waitForImages = function (element) {
        var imgs = Array.from(element.querySelectorAll('img')), promises = [];
        var hasImgToLoad = false;
        imgs.forEach(function (img) {
            if (img && !img.complete) {
                hasImgToLoad = true;
                // Wait for image to load or fail.
                promises.push(new Promise(function (resolve, reject) {
                    var imgLoaded = function () {
                        resolve();
                        img.removeEventListener('load', imgLoaded);
                        img.removeEventListener('error', imgLoaded);
                    };
                    img.addEventListener('load', imgLoaded);
                    img.addEventListener('error', imgLoaded);
                }));
            }
        });
        return Promise.all(promises).then(function () {
            return hasImgToLoad;
        });
    };
    /**
     * Wrap an HTMLElement with another element.
     *
     * @param {HTMLElement} el The element to wrap.
     * @param {HTMLElement} wrapper Wrapper.
     */
    CoreDomUtilsProvider.prototype.wrapElement = function (el, wrapper) {
        // Insert the wrapper before the element.
        el.parentNode.insertBefore(wrapper, el);
        // Now move the element into the wrapper.
        wrapper.appendChild(el);
    };
    CoreDomUtilsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["o" /* LoadingController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["E" /* ToastController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */], __WEBPACK_IMPORTED_MODULE_4__text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_6__config__["a" /* CoreConfigProvider */], __WEBPACK_IMPORTED_MODULE_7__url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_2__angular_platform_browser__["c" /* DomSanitizer */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["x" /* PopoverController */],
            __WEBPACK_IMPORTED_MODULE_8__providers_file__["a" /* CoreFileProvider */]])
    ], CoreDomUtilsProvider);
    return CoreDomUtilsProvider;
}());

//# sourceMappingURL=dom.js.map

/***/ }),
/* 10 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__course_offline__ = __webpack_require__(253);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_siteplugins_providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__format_delegate__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_oucrest_oucrest__ = __webpack_require__(90);
/*
 * @Description: In User Settings Edit
 * @Author: your name
 * @Date: 2019-07-25 13:24:31
 * @LastEditTime: 2019-11-04 16:15:38
 * @LastEditors: Please set LastEditors
 */
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/**
 * Service that provides some features regarding a course.
 */
var CoreCourseProvider = /** @class */ (function () {
    function CoreCourseProvider(logger, sitesProvider, eventsProvider, utils, timeUtils, translate, courseOffline, appProvider, rest, courseFormatDelegate, sitePluginsProvider, domUtils, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.eventsProvider = eventsProvider;
        this.utils = utils;
        this.timeUtils = timeUtils;
        this.translate = translate;
        this.courseOffline = courseOffline;
        this.appProvider = appProvider;
        this.rest = rest;
        this.courseFormatDelegate = courseFormatDelegate;
        this.sitePluginsProvider = sitePluginsProvider;
        this.domUtils = domUtils;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.ROOT_CACHE_KEY = 'mmCourse:';
        // Variables for database.
        this.COURSE_STATUS_TABLE = 'course_status';
        this.siteSchema = {
            name: 'CoreCourseProvider',
            version: 1,
            tables: [
                {
                    name: this.COURSE_STATUS_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'status',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'previous',
                            type: 'TEXT'
                        },
                        {
                            name: 'updated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'downloadTime',
                            type: 'INTEGER'
                        },
                        {
                            name: 'previousDownloadTime',
                            type: 'INTEGER'
                        }
                    ]
                }
            ]
        };
        this.CORE_MODULES = [
            'assign', 'assignment', 'book', 'chat', 'choice', 'data', 'database', 'date', 'external-tool',
            'feedback', 'file', 'folder', 'forum', 'glossary', 'ims', 'imscp', 'label', 'lesson', 'lti', 'page', 'quiz',
            'resource', 'scorm', 'survey', 'url', 'wiki', 'workshop'
        ];
        this.logger = logger.getInstance('CoreCourseProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    CoreCourseProvider_1 = CoreCourseProvider;
    /**
     * Check if the get course blocks WS is available in current site.
     *
     * @return {boolean} Whether it's available.
     * @since 3.3
     */
    CoreCourseProvider.prototype.canGetCourseBlocks = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_block_get_course_blocks');
    };
    /**
     * Check whether the site supports requesting stealth modules.
     *
     * @param {CoreSite} [site] Site. If not defined, current site.
     * @return {boolean} Whether the site supports requesting stealth modules.
     * @since 3.4.6, 3.5.3, 3.6
     */
    CoreCourseProvider.prototype.canRequestStealthModules = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isVersionGreaterEqualThan(['3.4.6', '3.5.3']);
    };
    /**
     * Check if module completion could have changed. If it could have, trigger event. This function must be used,
     * for example, after calling a "module_view" WS since it can change the module completion.
     *
     * @param {number} courseId Course ID.
     * @param {any} completion Completion status of the module.
     */
    CoreCourseProvider.prototype.checkModuleCompletion = function (courseId, completion) {
        var _this = this;
        if (completion && completion.tracking === 2 && completion.state === 0) {
            this.invalidateSections(courseId).finally(function () {
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].COMPLETION_MODULE_VIEWED, { courseId: courseId });
            });
        }
    };
    /**
     * Clear all courses status in a site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<void>} Promise resolved when all status are cleared.
     */
    CoreCourseProvider.prototype.clearAllCoursesStatus = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            _this.logger.debug('Clear all course status for site ' + site.id);
            return site.getDb().deleteRecords(_this.COURSE_STATUS_TABLE).then(function () {
                _this.triggerCourseStatusChanged(CoreCourseProvider_1.ALL_COURSES_CLEARED, __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADED, site.id);
            });
        });
    };
    /**
     * Get completion status of all the activities in a course for a certain user.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user.
     * @param {boolean} [forceCache] True if it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {boolean} [includeOffline=true] True if it should load offline data in the completion status.
     * @return {Promise<any>} Promise resolved with the completion statuses: object where the key is module ID.
     */
    CoreCourseProvider.prototype.getActivitiesCompletionStatus = function (courseId, siteId, userId, forceCache, ignoreCache, includeOffline) {
        var _this = this;
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        if (includeOffline === void 0) { includeOffline = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug("Getting completion status for user " + userId + " in course " + courseId);
            var params = {
                courseid: courseId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getActivitiesCompletionCacheKey(courseId, userId)
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('core_completion_get_activities_completion_status', params, preSets).then(function (data) {
                if (data && data.statuses) {
                    return _this.utils.arrayToObject(data.statuses, 'cmid');
                }
                return Promise.reject(null);
            }).then(function (completionStatus) {
                if (!includeOffline) {
                    return completionStatus;
                }
                // Now get the offline completion (if any).
                return _this.courseOffline.getCourseManualCompletions(courseId, site.id).then(function (offlineCompletions) {
                    offlineCompletions.forEach(function (offlineCompletion) {
                        if (offlineCompletion && typeof completionStatus[offlineCompletion.cmid] != 'undefined') {
                            var onlineCompletion = completionStatus[offlineCompletion.cmid];
                            // If the activity uses manual completion, override the value with the offline one.
                            if (onlineCompletion.tracking === 1) {
                                onlineCompletion.state = offlineCompletion.completed;
                                onlineCompletion.offline = true;
                            }
                        }
                    });
                    return completionStatus;
                }).catch(function () {
                    // Ignore errors.
                    return completionStatus;
                });
            });
        });
    };
    /**
     * Get cache key for activities completion WS calls.
     *
     * @param {number} courseId Course ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    CoreCourseProvider.prototype.getActivitiesCompletionCacheKey = function (courseId, userId) {
        return this.ROOT_CACHE_KEY + 'activitiescompletion:' + courseId + ':' + userId;
    };
    /**
     * Get course blocks.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of blocks.
     * @since 3.3
     */
    CoreCourseProvider.prototype.getCourseBlocks = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseid: courseId
            }, preSets = {
                cacheKey: _this.getCourseBlocksCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_block_get_course_blocks', params, preSets).then(function (result) {
                return result.blocks || [];
            });
        });
    };
    /**
     * Get cache key for course blocks WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    CoreCourseProvider.prototype.getCourseBlocksCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'courseblocks:' + courseId;
    };
    /**
     * Get the data stored for a course.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the data.
     */
    CoreCourseProvider.prototype.getCourseStatusData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(_this.COURSE_STATUS_TABLE, { id: courseId }).then(function (entry) {
                if (!entry) {
                    return Promise.reject(null);
                }
                return entry;
            });
        });
    };
    /**
     * Get a course status.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the status.
     */
    CoreCourseProvider.prototype.getCourseStatus = function (courseId, siteId) {
        return this.getCourseStatusData(courseId, siteId).then(function (entry) {
            return entry.status || __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        }).catch(function () {
            return __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        });
    };
    /**
     * Get a module from Moodle.
     *
     * @param {number} moduleId The module ID.
     * @param {number} [courseId] The course ID. Recommended to speed up the process and minimize data usage.
     * @param {number} [sectionId] The section ID.
     * @param {boolean} [preferCache] True if shouldn't call WS if data is cached, false otherwise.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {string} [modName] If set, the app will retrieve all modules of this type with a single WS call. This reduces the
     *                           number of WS calls, but it isn't recommended for modules that can return a lot of contents.
     * @return {Promise<any>} Promise resolved with the module.
     */
    CoreCourseProvider.prototype.getModule = function (moduleId, courseId, sectionId, preferCache, ignoreCache, siteId, modName) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Helper function to do the WS request without processing the result.
        var doRequest = function (site, moduleId, modName, includeStealth, preferCache) {
            var params = {
                courseid: courseId,
                options: []
            };
            var preSets = {
                omitExpires: preferCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (includeStealth) {
                params.options.push({
                    name: 'includestealthmodules',
                    value: 1
                });
            }
            // If modName is set, retrieve all modules of that type. Otherwise get only the module.
            if (modName) {
                params.options.push({
                    name: 'modname',
                    value: modName
                });
                preSets.cacheKey = _this.getModuleByModNameCacheKey(modName);
            }
            else {
                params.options.push({
                    name: 'cmid',
                    value: moduleId
                });
                preSets.cacheKey = _this.getModuleCacheKey(moduleId);
            }
            if (!preferCache && ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            // return site.read('core_course_get_contents', params, preSets).catch(() => {
            //     // The module might still be cached by a request with different parameters.
            //     if (!ignoreCache && !this.appProvider.isOnline()) {
            //         if (includeStealth) {
            //             // Older versions didn't include the includestealthmodules option.
            //             return doRequest(site, moduleId, modName, false, true);
            //         } else if (modName) {
            //             // Falback to the request for the given moduleId only.
            //             return doRequest(site, moduleId, undefined, this.canRequestStealthModules(site), true);
            //         }
            //     }
            return Promise.reject(null);
            // });
        };
        var promise;
        if (!courseId) {
            // No courseId passed, try to retrieve it.
            promise = this.getModuleBasicInfo(moduleId, siteId).then(function (module) {
                courseId = module.course;
            });
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function () {
            return _this.sitesProvider.getSite(siteId);
        }).then(function (site) {
            // We have courseId, we can use core_course_get_contents for compatibility.
            _this.logger.debug("Getting module " + moduleId + " in course " + courseId);
            return doRequest(site, moduleId, modName, _this.canRequestStealthModules(site), preferCache);
        }).catch(function () {
            // Error getting the module. Try to get all contents (without filtering by module).
            var preSets = {
                omitExpires: preferCache
            };
            if (!preferCache && ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return _this.getSections(courseId, false, false, preSets, siteId);
        }).then(function (sections) {
            for (var i = 0; i < sections.length; i++) {
                var section = sections[i];
                if (sectionId != null && !isNaN(sectionId) && section.id != CoreCourseProvider_1.STEALTH_MODULES_SECTION_ID &&
                    sectionId != section.id) {
                    continue;
                }
                for (var j = 0; j < section.modules.length; j++) {
                    var module_1 = section.modules[j];
                    if (module_1.id == moduleId) {
                        module_1.course = courseId;
                        return module_1;
                    }
                }
            }
            return Promise.reject(null);
        });
    };
    /**
     * Gets a module basic info by module ID.
     *
     * @param {number} moduleId Module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the module's info.
     */
    CoreCourseProvider.prototype.getModuleBasicInfo = function (moduleId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                cmid: moduleId
            }, preSets = {
                cacheKey: _this.getModuleCacheKey(moduleId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_course_get_course_module', params, preSets).then(function (response) {
                if (response.warnings && response.warnings.length) {
                    return Promise.reject(response.warnings[0]);
                }
                else if (response.cm) {
                    return response.cm;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Gets a module basic grade info by module ID.
     *
     * If the user does not have permision to manage the activity false is returned.
     *
     * @param {number} moduleId Module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the module's grade info.
     */
    CoreCourseProvider.prototype.getModuleBasicGradeInfo = function (moduleId, siteId) {
        return this.getModuleBasicInfo(moduleId, siteId).then(function (info) {
            var grade = {
                advancedgrading: info.advancedgrading || false,
                grade: info.grade || false,
                gradecat: info.gradecat || false,
                gradepass: info.gradepass || false,
                outcomes: info.outcomes || false,
                scale: info.scale || false
            };
            if (grade.grade !== false || grade.advancedgrading !== false || grade.outcomes !== false) {
                return grade;
            }
            return false;
        });
    };
    /**
     * Gets a module basic info by instance.
     *
     * @param {number} id Instance ID.
     * @param {string} module Name of the module. E.g. 'glossary'.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the module's info.
     */
    CoreCourseProvider.prototype.getModuleBasicInfoByInstance = function (id, module, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                instance: id,
                module: module
            }, preSets = {
                cacheKey: _this.getModuleBasicInfoByInstanceCacheKey(id, module),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_course_get_course_module_by_instance', params, preSets).then(function (response) {
                if (response.warnings && response.warnings.length) {
                    return Promise.reject(response.warnings[0]);
                }
                else if (response.cm) {
                    return response.cm;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get module by instance WS calls.
     *
     * @param {number} id Instance ID.
     * @param {string} module Name of the module. E.g. 'glossary'.
     * @return {string} Cache key.
     */
    CoreCourseProvider.prototype.getModuleBasicInfoByInstanceCacheKey = function (id, module) {
        return this.ROOT_CACHE_KEY + 'moduleByInstance:' + module + ':' + id;
    };
    /**
     * Get cache key for module WS calls.
     *
     * @param {number} moduleId Module ID.
     * @return {string} Cache key.
     */
    CoreCourseProvider.prototype.getModuleCacheKey = function (moduleId) {
        return this.ROOT_CACHE_KEY + 'module:' + moduleId;
    };
    /**
     * Get cache key for module by modname WS calls.
     *
     * @param {string} modName Name of the module.
     * @return {string} Cache key.
     */
    CoreCourseProvider.prototype.getModuleByModNameCacheKey = function (modName) {
        return this.ROOT_CACHE_KEY + 'module:modName:' + modName;
    };
    /**
     * Returns the source to a module icon.
     *
     * @param {string} moduleName The module name.
     * @param {string} [modicon] The mod icon string to use in case we are not using a core activity.
     * @return {string} The IMG src.
     */
    CoreCourseProvider.prototype.getModuleIconSrc = function (moduleName, modicon) {
        // @TODO: Check modicon url theme to apply other theme icons.
        // Use default icon on core themes.
        if (this.CORE_MODULES.indexOf(moduleName) < 0) {
            if (modicon) {
                return modicon;
            }
            moduleName = 'external-tool';
        }
        return 'assets/img/mod/' + moduleName + '.svg';
    };
    /**
     * Get the section ID a module belongs to.
     *
     * @param {number} moduleId The module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the section ID.
     */
    CoreCourseProvider.prototype.getModuleSectionId = function (moduleId, siteId) {
        // Try to get the section using getModuleBasicInfo.
        return this.getModuleBasicInfo(moduleId, siteId).then(function (module) {
            return module.section;
        });
    };
    /**
     * Return a specific section.
     *
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @param {boolean} [excludeModules] Do not return modules, return only the sections structure.
     * @param {boolean} [excludeContents] Do not return module contents (i.e: files inside a resource).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the section.
     */
    CoreCourseProvider.prototype.getSection = function (courseId, sectionId, excludeModules, excludeContents, siteId) {
        if (sectionId < 0) {
            return Promise.reject('Invalid section ID');
        }
        return this.getSections(courseId, excludeModules, excludeContents, undefined, siteId).then(function (sections) {
            for (var i = 0; i < sections.length; i++) {
                if (sections[i].id == sectionId) {
                    return sections[i];
                }
            }
            return Promise.reject('Unkown section');
        });
    };
    /**
     * Get the course sections.
     *
     * @param {number} courseId The course ID.
     * @param {boolean} [excludeModules] Do not return modules, return only the sections structure.
     * @param {boolean} [excludeContents] Do not return module contents (i.e: files inside a resource).
     * @param {CoreSiteWSPreSets} [preSets] Presets to use.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [includeStealthModules] Whether to include stealth modules. Defaults to true.
     * @return {Promise}                The reject contains the error message, else contains the sections.
     */
    CoreCourseProvider.prototype.getSections = function (courseId, excludeModules, excludeContents, preSets, siteId, includeStealthModules) {
        var _this = this;
        if (includeStealthModules === void 0) { includeStealthModules = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            preSets = preSets || {};
            preSets.cacheKey = _this.getSectionsCacheKey(courseId);
            preSets.updateFrequency = preSets.updateFrequency || __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY;
            var params = {
                courseid: courseId,
                options: [
                    {
                        name: 'excludemodules',
                        value: excludeModules ? 1 : 0
                    },
                    {
                        name: 'excludecontents',
                        value: excludeContents ? 1 : 0
                    }
                ]
            };
            if (_this.canRequestStealthModules(site)) {
                params.options.push({
                    name: 'includestealthmodules',
                    value: includeStealthModules ? 1 : 0
                });
            }
            return site.read('core_course_get_contents', params, preSets).catch(function () {
                // Error getting the data, it could fail because we added a new parameter and the call isn't cached.
                // Retry without the new parameter and forcing cache.
                preSets.omitExpires = true;
                params.options.splice(-1, 1);
                return site.read('core_course_get_contents', params, preSets);
            }).then(function (sections) {
                var siteHomeId = site.getSiteHomeId();
                var showSections = true;
                if (courseId == siteHomeId) {
                    showSections = site.getStoredConfig('numsections');
                }
                if (typeof showSections != 'undefined' && !showSections && sections.length > 0) {
                    // Get only the last section (Main menu block section).
                    sections.pop();
                }
                return sections;
            });
        });
    };
    /**
     * Get cache key for section WS call.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    CoreCourseProvider.prototype.getSectionsCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'sections:' + courseId;
    };
    /**
     * Given a list of sections, returns the list of modules in the sections.
     *
     * @param {any[]} sections Sections.
     * @return {any[]} Modules.
     */
    CoreCourseProvider.prototype.getSectionsModules = function (sections) {
        if (!sections || !sections.length) {
            return [];
        }
        var modules = [];
        sections.forEach(function (section) {
            if (section.modules) {
                modules = modules.concat(section.modules);
            }
        });
        return modules;
    };
    /**
     * Invalidates course blocks WS call.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseProvider.prototype.invalidateCourseBlocks = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCourseBlocksCacheKey(courseId));
        });
    };
    /**
     * Invalidates module WS call.
     *
     * @param {number} moduleId Module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {string} [modName] Module name. E.g. 'label', 'url', ...
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseProvider.prototype.invalidateModule = function (moduleId, siteId, modName) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = [];
            if (modName) {
                promises.push(site.invalidateWsCacheForKey(_this.getModuleByModNameCacheKey(modName)));
            }
            promises.push(site.invalidateWsCacheForKey(_this.getModuleCacheKey(moduleId)));
            return Promise.all(promises);
        });
    };
    /**
     * Invalidates module WS call.
     *
     * @param {number} id Instance ID.
     * @param {string} module Name of the module. E.g. 'glossary'.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseProvider.prototype.invalidateModuleByInstance = function (id, module, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getModuleBasicInfoByInstanceCacheKey(id, module));
        });
    };
    /**
     * Invalidates sections WS call.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseProvider.prototype.invalidateSections = function (courseId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = [], siteHomeId = site.getSiteHomeId();
            userId = userId || site.getUserId();
            promises.push(site.invalidateWsCacheForKey(_this.getSectionsCacheKey(courseId)));
            promises.push(site.invalidateWsCacheForKey(_this.getActivitiesCompletionCacheKey(courseId, userId)));
            if (courseId == siteHomeId) {
                promises.push(site.invalidateConfig());
            }
            return Promise.all(promises);
        });
    };
    /**
     * Load module contents into module.contents if they aren't loaded already.
     *
     * @param {any} module Module to load the contents.
     * @param {number} [courseId] The course ID. Recommended to speed up the process and minimize data usage.
     * @param {number} [sectionId] The section ID.
     * @param {boolean} [preferCache] True if shouldn't call WS if data is cached, false otherwise.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {string} [modName] If set, the app will retrieve all modules of this type with a single WS call. This reduces the
     *                           number of WS calls, but it isn't recommended for modules that can return a lot of contents.
     * @return {Promise<void>} Promise resolved when loaded.
     */
    CoreCourseProvider.prototype.loadModuleContents = function (module, courseId, sectionId, preferCache, ignoreCache, siteId, modName) {
        if (!ignoreCache && module.contents && module.contents.length) {
            // Already loaded.
            return Promise.resolve();
        }
        return this.getModule(module.id, courseId, sectionId, preferCache, ignoreCache, siteId, modName).then(function (mod) {
            module.contents = mod.contents;
        });
    };
    /**
     * Report a course and section as being viewed.
     *
     * @param {number} courseId  Course ID.
     * @param {number} [sectionNumber] Section number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {string} [name] Name of the course.
     * @return {Promise<void>} Promise resolved when the WS call is successful.
     */
    CoreCourseProvider.prototype.logView = function (courseId, sectionNumber, siteId, name) {
        var _this = this;
        var params = {
            courseid: courseId
        }, wsName = 'core_course_view_course';
        if (typeof sectionNumber != 'undefined') {
            params.sectionnumber = sectionNumber;
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            _this.pushNotificationsProvider.logViewEvent(courseId, name, 'course', wsName, { sectionnumber: sectionNumber }, siteId);
            return site.write('core_course_view_course', params).then(function (response) {
                if (!response.status) {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Offline version for manually marking a module as completed.
     *
     * @param {number} cmId The module ID.
     * @param {number} completed Whether the module is completed or not.
     * @param {number} courseId Course ID the module belongs to.
     * @param {string} [courseName] Course name. Recommended, it is used to display a better warning message.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when completion is successfully sent or stored.
     */
    CoreCourseProvider.prototype.markCompletedManually = function (cmId, completed, courseId, courseName, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a completion to be synchronized later.
        var storeOffline = function () {
            return _this.courseOffline.markCompletedManually(cmId, completed, courseId, courseName, siteId);
        };
        // The offline function requires a courseId and it could be missing because it's a calculated field.
        if (!this.appProvider.isOnline() && courseId) {
            // App is offline, store the action.
            return storeOffline();
        }
        // Try to send it to server.
        return this.markCompletedManuallyOnline(cmId, completed, siteId).then(function (result) {
            // Data sent to server, if there is some offline data delete it now.
            return _this.courseOffline.deleteManualCompletion(cmId, siteId).catch(function () {
                // Ignore errors, shouldn't happen.
            }).then(function () {
                return result;
            });
        }).catch(function (error) {
            if (_this.utils.isWebServiceError(error) || !courseId) {
                // The WebService has thrown an error, this means that responses cannot be submitted.
                return Promise.reject(error);
            }
            else {
                // Couldn't connect to server, store it offline.
                return storeOffline();
            }
        });
    };
    /**
     * Offline version for manually marking a module as completed.
     *
     * @param {number} cmId The module ID.
     * @param {number} completed Whether the module is completed or not.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when completion is successfully sent.
     */
    CoreCourseProvider.prototype.markCompletedManuallyOnline = function (cmId, completed, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                cmid: cmId,
                completed: completed
            };
            return site.write('core_completion_update_activity_completion_status_manually', params);
        });
    };
    /**
     * Check if a module has a view page. E.g. labels don't have a view page.
     *
     * @param {any} module The module object.
     * @return {boolean} Whether the module has a view page.
     */
    CoreCourseProvider.prototype.moduleHasView = function (module) {
        return !!module.url;
    };
    /**
     * Wait for any course format plugin to load, and open the course page.
     *
     * If the plugin's promise is resolved, the course page will be opened.  If it is rejected, they will see an error.
     * If the promise for the plugin is still in progress when the user tries to open the course, a loader
     * will be displayed until it is complete, before the course page is opened.  If the promise is already complete,
     * they will see the result immediately.
     *
     * This function must be in here instead of course helper to prevent circular dependencies.
     *
     * @param {NavController} navCtrl The nav controller to use. If not defined, the course will be opened in main menu.
     * @param {any} course Course to open
     * @param {any} [params] Other params to pass to the course page.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseProvider.prototype.openCourse = function (navCtrl, course, params) {
        var _this = this;
        var loading = this.domUtils.showModalLoading();
        // Wait for site plugins to be fetched.
        return this.sitePluginsProvider.waitFetchPlugins().then(function () {
            if (_this.sitePluginsProvider.sitePluginPromiseExists('format_' + course.format)) {
                // This course uses a custom format plugin, wait for the format plugin to finish loading.
                return _this.sitePluginsProvider.sitePluginLoaded('format_' + course.format).then(function () {
                    // The format loaded successfully, but the handlers wont be registered until all site plugins have loaded.
                    if (_this.sitePluginsProvider.sitePluginsFinishedLoading) {
                        return _this.courseFormatDelegate.openCourse(navCtrl, course, params);
                    }
                    else {
                        // Wait for plugins to be loaded.
                        var deferred_1 = _this.utils.promiseDefer(), observer_1 = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SITE_PLUGINS_LOADED, function () {
                            observer_1 && observer_1.off();
                            _this.courseFormatDelegate.openCourse(navCtrl, course, params).then(function (response) {
                                deferred_1.resolve(response);
                            }).catch(function (error) {
                                deferred_1.reject(error);
                            });
                        });
                        return deferred_1.promise;
                    }
                }).catch(function () {
                    // The site plugin failed to load. The user needs to restart the app to try loading it again.
                    _this.domUtils.showErrorModal('core.courses.errorloadplugins', true);
                });
            }
            else {
                // No custom format plugin. We don't need to wait for anything.
                return _this.courseFormatDelegate.openCourse(navCtrl, course, params);
            }
        }).finally(function () {
            loading.dismiss();
        });
    };
    /**
     * Change the course status, setting it to the previous status.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved when the status is changed. Resolve param: new status.
     */
    CoreCourseProvider.prototype.setCoursePreviousStatus = function (courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        this.logger.debug("Set previous status for course " + courseId + " in site " + siteId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var db = site.getDb(), newData = {};
            // Get current stored data.
            return _this.getCourseStatusData(courseId, siteId).then(function (entry) {
                _this.logger.debug("Set previous status '" + entry.status + "' for course " + courseId);
                newData.status = entry.previous || __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
                newData.updated = Date.now();
                if (entry.status == __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADING) {
                    // Going back from downloading to previous status, restore previous download time.
                    newData.downloadTime = entry.previousDownloadTime;
                }
                return db.updateRecords(_this.COURSE_STATUS_TABLE, newData, { id: courseId }).then(function () {
                    // Success updating, trigger event.
                    _this.triggerCourseStatusChanged(courseId, newData.status, siteId);
                    return newData.status;
                });
            });
        });
    };
    /**
     * Store course status.
     *
     * @param {number} courseId Course ID.
     * @param {string} status New course status.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<void>} Promise resolved when the status is stored.
     */
    CoreCourseProvider.prototype.setCourseStatus = function (courseId, status, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        this.logger.debug("Set status '" + status + "' for course " + courseId + " in site " + siteId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var downloadTime, previousDownloadTime;
            if (status == __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADING) {
                // Set download time if course is now downloading.
                downloadTime = _this.timeUtils.timestamp();
            }
            // Search current status to set it as previous status.
            return _this.getCourseStatusData(courseId, siteId).then(function (entry) {
                if (typeof downloadTime == 'undefined') {
                    // Keep previous download time.
                    downloadTime = entry.downloadTime;
                    previousDownloadTime = entry.previousDownloadTime;
                }
                else {
                    // The downloadTime will be updated, store current time as previous.
                    previousDownloadTime = entry.downloadTime;
                }
                return entry.status;
            }).catch(function () {
                // No previous status.
            }).then(function (previousStatus) {
                if (previousStatus != status) {
                    // Status has changed, update it.
                    var data = {
                        id: courseId,
                        status: status,
                        previous: previousStatus,
                        updated: new Date().getTime(),
                        downloadTime: downloadTime,
                        previousDownloadTime: previousDownloadTime
                    };
                    return site.getDb().insertRecord(_this.COURSE_STATUS_TABLE, data);
                }
            }).then(function () {
                // Success inserting, trigger event.
                _this.triggerCourseStatusChanged(courseId, status, siteId);
            });
        });
    };
    /**
     * Translate a module name to current language.
     *
     * @param {string} moduleName The module name.
     * @return {string} Translated name.
     */
    CoreCourseProvider.prototype.translateModuleName = function (moduleName) {
        if (this.CORE_MODULES.indexOf(moduleName) < 0) {
            moduleName = 'external-tool';
        }
        var langKey = 'core.mod_' + moduleName, translated = this.translate.instant(langKey);
        return translated !== langKey ? translated : moduleName;
    };
    /**
     * Trigger COURSE_STATUS_CHANGED with the right data.
     *
     * @param {number} courseId Course ID.
     * @param {string} status New course status.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreCourseProvider.prototype.triggerCourseStatusChanged = function (courseId, status, siteId) {
        this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].COURSE_STATUS_CHANGED, {
            courseId: courseId,
            status: status
        }, siteId);
    };
    CoreCourseProvider.ALL_SECTIONS_ID = -2;
    CoreCourseProvider.STEALTH_MODULES_SECTION_ID = -1;
    CoreCourseProvider.ACCESS_GUEST = 'courses_access_guest';
    CoreCourseProvider.ACCESS_DEFAULT = 'courses_access_default';
    CoreCourseProvider.ALL_COURSES_CLEARED = -1;
    CoreCourseProvider.COMPLETION_TRACKING_NONE = 0;
    CoreCourseProvider.COMPLETION_TRACKING_MANUAL = 1;
    CoreCourseProvider.COMPLETION_TRACKING_AUTOMATIC = 2;
    CoreCourseProvider.COMPLETION_INCOMPLETE = 0;
    CoreCourseProvider.COMPLETION_COMPLETE = 1;
    CoreCourseProvider.COMPLETION_COMPLETE_PASS = 2;
    CoreCourseProvider.COMPLETION_COMPLETE_FAIL = 3;
    CoreCourseProvider.COMPONENT = 'CoreCourse';
    CoreCourseProvider = CoreCourseProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_11__course_offline__["a" /* CoreCourseOfflineProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_15__providers_oucrest_oucrest__["a" /* OucrestProvider */],
            __WEBPACK_IMPORTED_MODULE_13__format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_12__core_siteplugins_providers_siteplugins__["a" /* CoreSitePluginsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_14__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], CoreCourseProvider);
    return CoreCourseProvider;
    var CoreCourseProvider_1;
}());

//# sourceMappingURL=course.js.map

/***/ }),
/* 11 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreTextUtilsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__ = __webpack_require__(83);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__lang__ = __webpack_require__(112);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/*
 * "Utils" service with helper functions for text.
*/
var CoreTextUtilsProvider = /** @class */ (function () {
    function CoreTextUtilsProvider(translate, langProvider, modalCtrl, sanitizer, platform) {
        this.translate = translate;
        this.langProvider = langProvider;
        this.modalCtrl = modalCtrl;
        this.sanitizer = sanitizer;
        this.platform = platform;
        // List of regular expressions to convert the old nomenclature to new nomenclature for disabled features.
        this.DISABLED_FEATURES_COMPAT_REGEXPS = [
            { old: /\$mmLoginEmailSignup/g, new: 'CoreLoginEmailSignup' },
            { old: /\$mmSideMenuDelegate/g, new: 'CoreMainMenuDelegate' },
            { old: /\$mmCoursesDelegate/g, new: 'CoreCourseOptionsDelegate' },
            { old: /\$mmUserDelegate/g, new: 'CoreUserDelegate' },
            { old: /\$mmCourseDelegate/g, new: 'CoreCourseModuleDelegate' },
            { old: /_mmCourses/g, new: '_CoreCourses' },
            { old: /_mmaFrontpage/g, new: '_CoreSiteHome' },
            { old: /_mmaGrades/g, new: '_CoreGrades' },
            { old: /_mmaCompetency/g, new: '_AddonCompetency' },
            { old: /_mmaNotifications/g, new: '_AddonNotifications' },
            { old: /_mmaMessages/g, new: '_AddonMessages' },
            { old: /_mmaCalendar/g, new: '_AddonCalendar' },
            { old: /_mmaFiles/g, new: '_AddonFiles' },
            { old: /_mmaParticipants/g, new: '_CoreUserParticipants' },
            { old: /_mmaCourseCompletion/g, new: '_AddonCourseCompletion' },
            { old: /_mmaNotes/g, new: '_AddonNotes' },
            { old: /_mmaBadges/g, new: '_AddonBadges' },
            { old: /files_privatefiles/g, new: 'AddonFilesPrivateFiles' },
            { old: /files_sitefiles/g, new: 'AddonFilesSiteFiles' },
            { old: /files_upload/g, new: 'AddonFilesUpload' },
            { old: /_mmaModAssign/g, new: '_AddonModAssign' },
            { old: /_mmaModBook/g, new: '_AddonModBook' },
            { old: /_mmaModChat/g, new: '_AddonModChat' },
            { old: /_mmaModChoice/g, new: '_AddonModChoice' },
            { old: /_mmaModData/g, new: '_AddonModData' },
            { old: /_mmaModFeedback/g, new: '_AddonModFeedback' },
            { old: /_mmaModFolder/g, new: '_AddonModFolder' },
            { old: /_mmaModForum/g, new: '_AddonModForum' },
            { old: /_mmaModGlossary/g, new: '_AddonModGlossary' },
            { old: /_mmaModImscp/g, new: '_AddonModImscp' },
            { old: /_mmaModLabel/g, new: '_AddonModLabel' },
            { old: /_mmaModLesson/g, new: '_AddonModLesson' },
            { old: /_mmaModLti/g, new: '_AddonModLti' },
            { old: /_mmaModPage/g, new: '_AddonModPage' },
            { old: /_mmaModQuiz/g, new: '_AddonModQuiz' },
            { old: /_mmaModResource/g, new: '_AddonModResource' },
            { old: /_mmaModScorm/g, new: '_AddonModScorm' },
            { old: /_mmaModSurvey/g, new: '_AddonModSurvey' },
            { old: /_mmaModUrl/g, new: '_AddonModUrl' },
            { old: /_mmaModWiki/g, new: '_AddonModWiki' },
            { old: /_mmaModWorkshop/g, new: '_AddonModWorkshop' },
            { old: /remoteAddOn_/g, new: 'sitePlugin_' },
        ];
        this.template = document.createElement('template'); // A template element to convert HTML to element.
    }
    /**
     * Given an address as a string, return a URL to open the address in maps.
     *
     * @param {string} address The address.
     * @return {SafeUrl} URL to view the address.
     */
    CoreTextUtilsProvider.prototype.buildAddressURL = function (address) {
        return this.sanitizer.bypassSecurityTrustUrl((this.platform.is('android') ? 'geo:0,0?q=' : 'http://maps.google.com?q=') +
            encodeURIComponent(address));
    };
    /**
     * Given a list of sentences, build a message with all of them wrapped in <p>.
     *
     * @param {string[]} messages Messages to show.
     * @return {string} Message with all the messages.
     */
    CoreTextUtilsProvider.prototype.buildMessage = function (messages) {
        var result = '';
        messages.forEach(function (message) {
            if (message) {
                result += "<p>" + message + "</p>";
            }
        });
        return result;
    };
    /**
     * Convert size in bytes into human readable format
     *
     * @param {number} bytes Number of bytes to convert.
     * @param {number} [precision=2] Number of digits after the decimal separator.
     * @return {string} Size in human readable format.
     */
    CoreTextUtilsProvider.prototype.bytesToSize = function (bytes, precision) {
        if (precision === void 0) { precision = 2; }
        if (typeof bytes == 'undefined' || bytes === null || bytes < 0) {
            return this.translate.instant('core.notapplicable');
        }
        if (precision < 0) {
            precision = 2;
        }
        var keys = ['core.sizeb', 'core.sizekb', 'core.sizemb', 'core.sizegb', 'core.sizetb'], units = this.translate.instant(keys);
        var pos = 0;
        if (bytes >= 1024) {
            while (bytes >= 1024) {
                pos++;
                bytes = bytes / 1024;
            }
            // Round to "precision" decimals if needed.
            bytes = Number(Math.round(parseFloat(bytes + 'e+' + precision)) + 'e-' + precision);
        }
        return this.translate.instant('core.humanreadablesize', { size: bytes, unit: units[keys[pos]] });
    };
    /**
     * Clean HTML tags.
     *
     * @param {string} text The text to be cleaned.
     * @param {boolean} [singleLine] True if new lines should be removed (all the text in a single line).
     * @return {string} Clean text.
     */
    CoreTextUtilsProvider.prototype.cleanTags = function (text, singleLine) {
        if (typeof text != 'string') {
            return text;
        }
        if (!text) {
            return '';
        }
        // First, we use a regexpr.
        text = text.replace(/(<([^>]+)>)/ig, '');
        // Then, we rely on the browser. We need to wrap the text to be sure is HTML.
        var element = this.convertToElement(text);
        text = element.textContent;
        // Recover or remove new lines.
        text = this.replaceNewLines(text, singleLine ? ' ' : '<br>');
        return text;
    };
    /**
     * Concatenate two paths, adding a slash between them if needed.
     *
     * @param {string} leftPath Left path.
     * @param {string} rightPath Right path.
     * @return {string} Concatenated path.
     */
    CoreTextUtilsProvider.prototype.concatenatePaths = function (leftPath, rightPath) {
        if (!leftPath) {
            return rightPath;
        }
        else if (!rightPath) {
            return leftPath;
        }
        var lastCharLeft = leftPath.slice(-1), firstCharRight = rightPath.charAt(0);
        if (lastCharLeft === '/' && firstCharRight === '/') {
            return leftPath + rightPath.substr(1);
        }
        else if (lastCharLeft !== '/' && firstCharRight !== '/') {
            return leftPath + '/' + rightPath;
        }
        else {
            return leftPath + rightPath;
        }
    };
    /**
     * Convert some HTML as text into an HTMLElement. This HTML is put inside a div or a body.
     * This function is the same as in DomUtils, but we cannot use that one because of circular dependencies.
     *
     * @param {string} html Text to convert.
     * @return {HTMLElement} Element.
     */
    CoreTextUtilsProvider.prototype.convertToElement = function (html) {
        // Add a div to hold the content, that's the element that will be returned.
        this.template.innerHTML = '<div>' + html + '</div>';
        return this.template.content.children[0];
    };
    /**
     * Count words in a text.
     *
     * @param {string} text Text to count.
     * @return {number} Number of words.
     */
    CoreTextUtilsProvider.prototype.countWords = function (text) {
        if (!text || typeof text != 'string') {
            return 0;
        }
        var blockTags = ['address', 'article', 'aside', 'blockquote', 'br', ' details', 'dialog', 'dd', 'div', 'dl', 'dt',
            'fieldset', 'figcaption', 'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'header', 'hgroup', 'hr',
            'li', 'main', 'nav', 'ol', 'p', 'pre', 'section', 'table', 'ul'];
        // Clean HTML scripts and tags.
        text = text.replace(/<script[^>]*>([\S\s]*?)<\/script>/gmi, '');
        // Replace block tags by space to get word count aware of line break and remove inline tags.
        text = text.replace(/<(\/[ ]*)?([a-zA-Z0-9]+)[^>]*>/gi, function (str, p1, match) {
            if (blockTags.indexOf(match) >= 0) {
                return ' ';
            }
            return '';
        });
        // Decode HTML entities.
        text = this.decodeHTMLEntities(text);
        // Replace underscores (which are classed as word characters) with spaces.
        text = text.replace(/_/gi, ' ');
        // This RegEx will detect any word change including Unicode chars. Some languages without spaces won't be counted fine.
        return text.match(/\S+/gi).length;
    };
    /**
     * Decode an escaped HTML text. This implementation is based on PHP's htmlspecialchars_decode.
     *
     * @param {string|number} text Text to decode.
     * @return {string} Decoded text.
     */
    CoreTextUtilsProvider.prototype.decodeHTML = function (text) {
        if (typeof text == 'undefined' || text === null || (typeof text == 'number' && isNaN(text))) {
            return '';
        }
        else if (typeof text != 'string') {
            return '' + text;
        }
        return text
            .replace(/&amp;/g, '&')
            .replace(/&lt;/g, '<')
            .replace(/&gt;/g, '>')
            .replace(/&quot;/g, '"')
            .replace(/&#039;/g, '\'')
            .replace(/&nbsp;/g, ' ');
    };
    /**
     * Decode HTML entities in a text. Equivalent to PHP html_entity_decode.
     *
     * @param {string} text Text to decode.
     * @return {string} Decoded text.
     */
    CoreTextUtilsProvider.prototype.decodeHTMLEntities = function (text) {
        if (text) {
            var element = this.convertToElement(text);
            text = element.textContent;
        }
        return text;
    };
    /**
     * Same as Javascript's decodeURI, but if an exception is thrown it will return the original URI.
     *
     * @param {string} uri URI to decode.
     * @return {string} Decoded URI, or original URI if an exception is thrown.
     */
    CoreTextUtilsProvider.prototype.decodeURI = function (uri) {
        try {
            return decodeURI(uri);
        }
        catch (ex) {
            // Error, use the original URI.
        }
        return uri;
    };
    /**
     * Same as Javascript's decodeURIComponent, but if an exception is thrown it will return the original URI.
     *
     * @param {string} uri URI to decode.
     * @return {string} Decoded URI, or original URI if an exception is thrown.
     */
    CoreTextUtilsProvider.prototype.decodeURIComponent = function (uri) {
        try {
            return decodeURIComponent(uri);
        }
        catch (ex) {
            // Error, use the original URI.
        }
        return uri;
    };
    /**
     * Escapes some characters in a string to be used as a regular expression.
     *
     * @param {string} text Text to escape.
     * @return {string} Escaped text.
     */
    CoreTextUtilsProvider.prototype.escapeForRegex = function (text) {
        if (!text || typeof text != 'string') {
            return '';
        }
        return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&');
    };
    /**
     * Escape an HTML text. This implementation is based on PHP's htmlspecialchars.
     *
     * @param {string|number} text Text to escape.
     * @return {string} Escaped text.
     */
    CoreTextUtilsProvider.prototype.escapeHTML = function (text) {
        if (typeof text == 'undefined' || text === null || (typeof text == 'number' && isNaN(text))) {
            return '';
        }
        else if (typeof text != 'string') {
            return '' + text;
        }
        return text
            .replace(/&/g, '&amp;')
            .replace(/</g, '&lt;')
            .replace(/>/g, '&gt;')
            .replace(/"/g, '&quot;')
            .replace(/'/g, '&#039;');
    };
    /**
     * Shows a text on a new page.
     *
     * @param {string} title Title of the new state.
     * @param {string} text Content of the text to be expanded.
     * @param {string} [component] Component to link the embedded files to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {any[]} [files] List of files to display along with the text.
     */
    CoreTextUtilsProvider.prototype.expandText = function (title, text, component, componentId, files) {
        if (text.length > 0) {
            var params = {
                title: title,
                content: text,
                component: component,
                componentId: componentId,
                files: files
            };
            // Open a modal with the contents.
            params.isModal = true;
            var modal = this.modalCtrl.create('CoreViewerTextPage', params);
            modal.present();
        }
    };
    /**
     * Formats a text, in HTML replacing new lines by correct html new lines.
     *
     * @param {string} text Text to format.
     * @return {string} Formatted text.
     */
    CoreTextUtilsProvider.prototype.formatHtmlLines = function (text) {
        var hasHTMLTags = this.hasHTMLTags(text);
        if (text.indexOf('<p>') == -1) {
            // Wrap the text in <p> tags.
            text = '<p>' + text + '</p>';
        }
        if (!hasHTMLTags) {
            // The text doesn't have HTML, replace new lines for <br>.
            return this.replaceNewLines(text, '<br>');
        }
        return text;
    };
    /**
     * Formats a text, treating multilang tags and cleaning HTML if needed.
     *
     * @param {string} text Text to format.
     * @param {boolean} [clean] Whether HTML tags should be removed.
     * @param {boolean} [singleLine] Whether new lines should be removed. Only valid if clean is true.
     * @param {number} [shortenLength] Number of characters to shorten the text.
     * @param {number} [highlight] Text to highlight.
     * @return {Promise<string>} Promise resolved with the formatted text.
     */
    CoreTextUtilsProvider.prototype.formatText = function (text, clean, singleLine, shortenLength, highlight) {
        var _this = this;
        return this.treatMultilangTags(text).then(function (formatted) {
            if (clean) {
                formatted = _this.cleanTags(formatted, singleLine);
            }
            if (shortenLength > 0) {
                formatted = _this.shortenText(formatted, shortenLength);
            }
            if (highlight) {
                formatted = _this.highlightText(formatted, highlight);
            }
            return formatted;
        });
    };
    /**
     * Get the error message from an error object.
     *
     * @param {any} error Error object.
     * @return {string} Error message, undefined if not found.
     */
    CoreTextUtilsProvider.prototype.getErrorMessageFromError = function (error) {
        if (typeof error == 'string') {
            return error;
        }
        return error && (error.message || error.error || error.content || error.body);
    };
    /**
     * Get the pluginfile URL to replace @@PLUGINFILE@@ wildcards.
     *
     * @param {any[]} files Files to extract the URL from. They need to have the URL in a 'url' or 'fileurl' attribute.
     * @return {string} Pluginfile URL, undefined if no files found.
     */
    CoreTextUtilsProvider.prototype.getTextPluginfileUrl = function (files) {
        if (files && files.length) {
            var fileURL = files[0].url || files[0].fileurl;
            // Remove text after last slash (encoded or not).
            return fileURL.substr(0, Math.max(fileURL.lastIndexOf('/'), fileURL.lastIndexOf('%2F')));
        }
        return undefined;
    };
    /**
     * Check if a text contains HTML tags.
     *
     * @param {string} text Text to check.
     * @return {boolean} Whether it has HTML tags.
     */
    CoreTextUtilsProvider.prototype.hasHTMLTags = function (text) {
        return /<[a-z][\s\S]*>/i.test(text);
    };
    /**
     * Highlight all occurrences of a certain text inside another text. It will add some HTML code to highlight it.
     *
     * @param {string} text Full text.
     * @param {string} searchText Text to search and highlight.
     * @return {string} Highlighted text.
     */
    CoreTextUtilsProvider.prototype.highlightText = function (text, searchText) {
        if (!text || typeof text != 'string') {
            return '';
        }
        else if (!searchText) {
            return text;
        }
        var regex = new RegExp('(' + searchText + ')', 'gi');
        return text.replace(regex, '<span class="matchtext">$1</span>');
    };
    /**
     * Check if HTML content is blank.
     *
     * @param {string} content HTML content.
     * @return {boolean} True if the string does not contain actual content: text, images, etc.
     */
    CoreTextUtilsProvider.prototype.htmlIsBlank = function (content) {
        if (!content) {
            return true;
        }
        var div = document.createElement('div');
        div.innerHTML = content;
        return div.textContent === '' && div.querySelector('img, object, hr') === null;
    };
    /**
     * Check if a text contains Unicode long chars.
     * Using as threshold Hex value D800
     *
     * @param {string} text Text to check.
     * @return {boolean} True if has Unicode chars, false otherwise.
     */
    CoreTextUtilsProvider.prototype.hasUnicode = function (text) {
        for (var x = 0; x < text.length; x++) {
            if (text.charCodeAt(x) > 55295) {
                return true;
            }
        }
        return false;
    };
    /**
     * Check if an object has any long Unicode char.
     *
     * @param {object} data Object to be checked.
     * @return {boolean} If the data has any long Unicode char on it.
     */
    CoreTextUtilsProvider.prototype.hasUnicodeData = function (data) {
        for (var el in data) {
            if (typeof data[el] == 'object') {
                if (this.hasUnicodeData(data[el])) {
                    return true;
                }
            }
            else if (typeof data[el] == 'string' && this.hasUnicode(data[el])) {
                return true;
            }
        }
        return false;
    };
    /**
     * Same as Javascript's JSON.parse, but it will handle errors.
     *
     * @param {string} json JSON text.
     * @param {any} [defaultValue] Default value t oreturn if the parse fails. Defaults to the original value.
     * @param {Function} [logErrorFn] An error to call with the exception to log the error. If not supplied, no error.
     * @return {any} JSON parsed as object or what it gets.
     */
    CoreTextUtilsProvider.prototype.parseJSON = function (json, defaultValue, logErrorFn) {
        try {
            return JSON.parse(json);
        }
        catch (ex) {
            // Error, log the error if needed.
            if (logErrorFn) {
                logErrorFn(ex);
            }
        }
        // Error parsing, return the default value or the original value.
        return typeof defaultValue != 'undefined' ? defaultValue : json;
    };
    /**
     * Remove ending slash from a path or URL.
     *
     * @param {string} text Text to treat.
     * @return {string} Treated text.
     */
    CoreTextUtilsProvider.prototype.removeEndingSlash = function (text) {
        if (!text) {
            return '';
        }
        if (text.slice(-1) == '/') {
            return text.substr(0, text.length - 1);
        }
        return text;
    };
    /**
     * Replace all characters that cause problems with files in Android and iOS.
     *
     * @param {string} text Text to treat.
     * @return {string} Treated text.
     */
    CoreTextUtilsProvider.prototype.removeSpecialCharactersForFiles = function (text) {
        if (!text || typeof text != 'string') {
            return '';
        }
        return text.replace(/[#:\/\?\\]+/g, '_');
    };
    /**
     * Replace all the new lines on a certain text.
     *
     * @param {string} text The text to be treated.
     * @param {string} newValue Text to use instead of new lines.
     * @return {string} Treated text.
     */
    CoreTextUtilsProvider.prototype.replaceNewLines = function (text, newValue) {
        if (!text || typeof text != 'string') {
            return '';
        }
        return text.replace(/(?:\r\n|\r|\n)/g, newValue);
    };
    /**
     * Replace @@PLUGINFILE@@ wildcards with the real URL in a text.
     *
     * @param {string} Text to treat.
     * @param {any[]} files Files to extract the pluginfile URL from. They need to have the URL in a url or fileurl attribute.
     * @return {string} Treated text.
     */
    CoreTextUtilsProvider.prototype.replacePluginfileUrls = function (text, files) {
        if (text && typeof text == 'string') {
            var fileURL = this.getTextPluginfileUrl(files);
            if (fileURL) {
                return text.replace(/@@PLUGINFILE@@/g, fileURL);
            }
        }
        return text;
    };
    /**
     * Replace pluginfile URLs with @@PLUGINFILE@@ wildcards.
     *
     * @param {string} text Text to treat.
     * @param {any[]} files Files to extract the pluginfile URL from. They need to have the URL in a url or fileurl attribute.
     * @return {string} Treated text.
     */
    CoreTextUtilsProvider.prototype.restorePluginfileUrls = function (text, files) {
        if (text && typeof text == 'string') {
            var fileURL = this.getTextPluginfileUrl(files);
            if (fileURL) {
                return text.replace(new RegExp(this.escapeForRegex(fileURL), 'g'), '@@PLUGINFILE@@');
            }
        }
        return text;
    };
    /**
     * Rounds a number to use a certain amout of decimals or less.
     * Difference between this function and float's toFixed:
     * 7.toFixed(2) -> 7.00
     * roundToDecimals(7, 2) -> 7
     *
     * @param {number} num Number to round.
     * @param {number} [decimals=2] Number of decimals. By default, 2.
     * @return {number} Rounded number.
     */
    CoreTextUtilsProvider.prototype.roundToDecimals = function (num, decimals) {
        if (decimals === void 0) { decimals = 2; }
        var multiplier = Math.pow(10, decimals);
        return Math.round(num * multiplier) / multiplier;
    };
    /**
     * Add quotes to HTML characters.
     *
     * Returns text with HTML characters (like "<", ">", etc.) properly quoted.
     * Based on Moodle's s() function.
     *
     * @param {string} text Text to treat.
     * @return {string} Treated text.
     */
    CoreTextUtilsProvider.prototype.s = function (text) {
        if (!text) {
            return '';
        }
        return this.escapeHTML(text).replace(/&amp;#(\d+|x[0-9a-f]+);/i, '&#$1;');
    };
    /**
     * Shortens a text to length and adds an ellipsis.
     *
     * @param {string} text The text to be shortened.
     * @param {number} length The desired length.
     * @return {string} Shortened text.
     */
    CoreTextUtilsProvider.prototype.shortenText = function (text, length) {
        if (text.length > length) {
            text = text.substr(0, length);
            // Now, truncate at the last word boundary (if exists).
            var lastWordPos = text.lastIndexOf(' ');
            if (lastWordPos > 0) {
                text = text.substr(0, lastWordPos);
            }
            text += '&hellip;';
        }
        return text;
    };
    /**
     * Strip Unicode long char of a given text.
     * Using as threshold Hex value D800
     *
     * @param {string} text Text to check.
     * @return {string} Without the Unicode chars.
     */
    CoreTextUtilsProvider.prototype.stripUnicode = function (text) {
        var stripped = '';
        for (var x = 0; x < text.length; x++) {
            if (text.charCodeAt(x) <= 55295) {
                stripped += text.charAt(x);
            }
        }
        return stripped;
    };
    /**
     * Treat the list of disabled features, replacing old nomenclature with the new one.
     *
     * @param {string} features List of disabled features.
     * @return {string} Treated list.
     */
    CoreTextUtilsProvider.prototype.treatDisabledFeatures = function (features) {
        if (!features) {
            return '';
        }
        for (var i = 0; i < this.DISABLED_FEATURES_COMPAT_REGEXPS.length; i++) {
            var entry = this.DISABLED_FEATURES_COMPAT_REGEXPS[i];
            features = features.replace(entry.old, entry.new);
        }
        return features;
    };
    /**
     * Treat the multilang tags from a HTML code, leaving only the current language.
     *
     * @param {string} text The text to be treated.
     * @return {Promise<string>} Promise resolved with the formatted text.
     */
    CoreTextUtilsProvider.prototype.treatMultilangTags = function (text) {
        if (!text || typeof text != 'string') {
            return Promise.resolve('');
        }
        return this.langProvider.getCurrentLanguage().then(function (language) {
            // Match the current language.
            var anyLangRegEx = /<(?:lang|span)[^>]+lang="[a-zA-Z0-9_-]+"[^>]*>(.*?)<\/(?:lang|span)>/g;
            var currentLangRegEx = new RegExp('<(?:lang|span)[^>]+lang="' + language + '"[^>]*>(.*?)<\/(?:lang|span)>', 'g');
            if (!text.match(currentLangRegEx)) {
                // Current lang not found. Try to find the first language.
                var matches = text.match(anyLangRegEx);
                if (matches && matches[0]) {
                    language = matches[0].match(/lang="([a-zA-Z0-9_-]+)"/)[1];
                    currentLangRegEx = new RegExp('<(?:lang|span)[^>]+lang="' + language + '"[^>]*>(.*?)<\/(?:lang|span)>', 'g');
                }
                else {
                    // No multi-lang tag found, stop.
                    return text;
                }
            }
            // Extract contents of current language.
            text = text.replace(currentLangRegEx, '$1');
            // Delete the rest of languages
            text = text.replace(anyLangRegEx, '');
            return text;
        });
    };
    /**
     * If a number has only 1 digit, add a leading zero to it.
     *
     * @param {string|number} num Number to convert.
     * @return {string} Number with leading zeros.
     */
    CoreTextUtilsProvider.prototype.twoDigits = function (num) {
        if (num < 10) {
            return '0' + num;
        }
        else {
            return '' + num; // Convert to string for coherence.
        }
    };
    /**
     * Make a string's first character uppercase.
     *
     * @param {string} text Text to treat.
     * @return {string} Treated text.
     */
    CoreTextUtilsProvider.prototype.ucFirst = function (text) {
        return text.charAt(0).toUpperCase() + text.slice(1);
    };
    /**
     * Unserialize Array from PHP.
     * Taken from: https://github.com/kvz/locutus/blob/master/src/php/var/unserialize.js
     *
     * @param  {string} data String to unserialize.
     * @param {Function} [logErrorFn] An error to call with the exception to log the error. If not supplied, no error.
     * @return {any}         Unserialized data.
     */
    CoreTextUtilsProvider.prototype.unserialize = function (data, logErrorFn) {
        //  Discuss at: http://locutus.io/php/unserialize/
        // Original by: Arpad Ray (mailto:arpad@php.net)
        // Improved by: Pedro Tainha (http://www.pedrotainha.com)
        // Improved by: Kevin van Zonneveld (http://kvz.io)
        // Improved by: Kevin van Zonneveld (http://kvz.io)
        // Improved by: Chris
        // Improved by: James
        // Improved by: Le Torbi
        // Improved by: Eli Skeggs
        // Bugfixed by: dptr1988
        // Bugfixed by: Kevin van Zonneveld (http://kvz.io)
        // Bugfixed by: Brett Zamir (http://brett-zamir.me)
        // Bugfixed by: philippsimon (https://github.com/philippsimon/)
        //  Revised by: d3x
        //    Input by: Brett Zamir (http://brett-zamir.me)
        //    Input by: Martin (http://www.erlenwiese.de/)
        //    Input by: kilops
        //    Input by: Jaroslaw Czarniak
        //    Input by: lovasoa (https://github.com/lovasoa/)
        //      Note 1: We feel the main purpose of this function should be
        //      Note 1: to ease the transport of data between php & js
        //      Note 1: Aiming for PHP-compatibility, we have to translate objects to arrays
        //   Example 1: unserialize('a:3:{i:0;s:5:"Kevin";i:1;s:3:"van";i:2;s:9:"Zonneveld";}')
        //   Returns 1: ['Kevin', 'van', 'Zonneveld']
        //   Example 2: unserialize('a:2:{s:9:"firstName";s:5:"Kevin";s:7:"midName";s:3:"van";}')
        //   Returns 2: {firstName: 'Kevin', midName: 'van'}
        //   Example 3: unserialize('a:3:{s:2:"ü";s:2:"ü";s:3:"四";s:3:"四";s:4:"𠜎";s:4:"𠜎";}')
        //   Returns 3: {'ü': 'ü', '四': '四', '𠜎': '𠜎'}
        var utf8Overhead = function (str) {
            var s = str.length;
            for (var i = str.length - 1; i >= 0; i--) {
                var code = str.charCodeAt(i);
                if (code > 0x7f && code <= 0x7ff) {
                    s++;
                }
                else if (code > 0x7ff && code <= 0xffff) {
                    s += 2;
                }
                // Trail surrogate.
                if (code >= 0xDC00 && code <= 0xDFFF) {
                    i--;
                }
            }
            return s - 1;
        };
        var error = function (type, msg) {
            if (logErrorFn) {
                logErrorFn(type + msg);
            }
        };
        var readUntil = function (data, offset, stopchr) {
            var i = 2;
            var buf = [];
            var chr = data.slice(offset, offset + 1);
            while (chr !== stopchr) {
                if ((i + offset) > data.length) {
                    error('Error', 'Invalid');
                }
                buf.push(chr);
                chr = data.slice(offset + (i - 1), offset + i);
                i += 1;
            }
            return [buf.length, buf.join('')];
        };
        var readChrs = function (data, offset, length) {
            var chr;
            var buf = [];
            for (var i = 0; i < length; i++) {
                chr = data.slice(offset + (i - 1), offset + i);
                buf.push(chr);
                length -= utf8Overhead(chr);
            }
            return [buf.length, buf.join('')];
        };
        var _unserialize = function (data, offset) {
            var dtype, dataoffset, keyandchrs, keys, contig, length, array, readdata, readData, ccount, stringlength, i, key, kprops, kchrs, vprops, vchrs, value, chrs = 0, typeconvert = function (x) {
                return x;
            };
            if (!offset) {
                offset = 0;
            }
            dtype = (data.slice(offset, offset + 1)).toLowerCase();
            dataoffset = offset + 2;
            switch (dtype) {
                case 'i':
                    typeconvert = function (x) {
                        return parseInt(x, 10);
                    };
                    readData = readUntil(data, dataoffset, ';');
                    chrs = readData[0];
                    readdata = readData[1];
                    dataoffset += chrs + 1;
                    break;
                case 'b':
                    typeconvert = function (x) {
                        return parseInt(x, 10) !== 0;
                    };
                    readData = readUntil(data, dataoffset, ';');
                    chrs = readData[0];
                    readdata = readData[1];
                    dataoffset += chrs + 1;
                    break;
                case 'd':
                    typeconvert = function (x) {
                        return parseFloat(x);
                    };
                    readData = readUntil(data, dataoffset, ';');
                    chrs = readData[0];
                    readdata = readData[1];
                    dataoffset += chrs + 1;
                    break;
                case 'n':
                    readdata = null;
                    break;
                case 's':
                    ccount = readUntil(data, dataoffset, ':');
                    chrs = ccount[0];
                    stringlength = ccount[1];
                    dataoffset += chrs + 2;
                    readData = readChrs(data, dataoffset + 1, parseInt(stringlength, 10));
                    chrs = readData[0];
                    readdata = readData[1];
                    dataoffset += chrs + 2;
                    if (chrs !== parseInt(stringlength, 10) && chrs !== readdata.length) {
                        error('SyntaxError', 'String length mismatch');
                    }
                    break;
                case 'a':
                    readdata = {};
                    keyandchrs = readUntil(data, dataoffset, ':');
                    chrs = keyandchrs[0];
                    keys = keyandchrs[1];
                    dataoffset += chrs + 2;
                    length = parseInt(keys, 10);
                    contig = true;
                    for (var i_1 = 0; i_1 < length; i_1++) {
                        kprops = _unserialize(data, dataoffset);
                        kchrs = kprops[1];
                        key = kprops[2];
                        dataoffset += kchrs;
                        vprops = _unserialize(data, dataoffset);
                        vchrs = vprops[1];
                        value = vprops[2];
                        dataoffset += vchrs;
                        if (key !== i_1) {
                            contig = false;
                        }
                        readdata[key] = value;
                    }
                    if (contig) {
                        array = new Array(length);
                        for (i = 0; i < length; i++) {
                            array[i] = readdata[i];
                        }
                        readdata = array;
                    }
                    dataoffset += 1;
                    break;
                default:
                    error('SyntaxError', 'Unknown / Unhandled data type(s): ' + dtype);
                    break;
            }
            return [dtype, dataoffset - offset, typeconvert(readdata)];
        };
        return _unserialize((data + ''), 0)[2];
    };
    CoreTextUtilsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_4__lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["r" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__["c" /* DomSanitizer */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["w" /* Platform */]])
    ], CoreTextUtilsProvider);
    return CoreTextUtilsProvider;
}());

//# sourceMappingURL=text.js.map

/***/ }),
/* 12 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreEventsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/*
 * Service to send and listen to events.
 */
var CoreEventsProvider = /** @class */ (function () {
    function CoreEventsProvider(logger) {
        this.observables = {};
        this.uniqueEvents = {};
        this.logger = logger.getInstance('CoreEventsProvider');
    }
    /**
     * Listen for a certain event. To stop listening to the event:
     * let observer = eventsProvider.on('something', myCallBack);
     * ...
     * observer.off();
     *
     * @param {string} eventName Name of the event to listen to.
     * @param {Function} callBack Function to call when the event is triggered.
     * @param {string} [siteId] Site where to trigger the event. Undefined won't check the site.
     * @return {CoreEventObserver} Observer to stop listening.
     */
    CoreEventsProvider.prototype.on = function (eventName, callBack, siteId) {
        var _this = this;
        // If it's a unique event and has been triggered already, call the callBack.
        // We don't need to create an observer because the event won't be triggered again.
        if (this.uniqueEvents[eventName]) {
            callBack(this.uniqueEvents[eventName].data);
            // Return a fake observer to prevent errors.
            return {
                off: function () {
                    // Nothing to do.
                }
            };
        }
        this.logger.debug("New observer listening to event '" + eventName + "'");
        if (typeof this.observables[eventName] == 'undefined') {
            // No observable for this event, create a new one.
            this.observables[eventName] = new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Subject"]();
        }
        var subscription = this.observables[eventName].subscribe(function (value) {
            if (!siteId || value.siteId == siteId) {
                callBack(value);
            }
        });
        // Create and return a CoreEventObserver.
        return {
            off: function () {
                _this.logger.debug("Stop listening to event '" + eventName + "'");
                subscription.unsubscribe();
            }
        };
    };
    /**
     * Triggers an event, notifying all the observers.
     *
     * @param {string} event Name of the event to trigger.
     * @param {any} [data] Data to pass to the observers.
     * @param {string} [siteId] Site where to trigger the event. Undefined means no Site.
     */
    CoreEventsProvider.prototype.trigger = function (eventName, data, siteId) {
        this.logger.debug("Event '" + eventName + "' triggered.");
        if (this.observables[eventName]) {
            if (siteId) {
                if (!data) {
                    data = {};
                }
                data.siteId = siteId;
            }
            this.observables[eventName].next(data);
        }
    };
    /**
     * Triggers a unique event, notifying all the observers. If the event has already been triggered, don't do anything.
     *
     * @param {string} event Name of the event to trigger.
     * @param {any} data Data to pass to the observers.
     * @param {string} [siteId] Site where to trigger the event. Undefined means no Site.
     */
    CoreEventsProvider.prototype.triggerUnique = function (eventName, data, siteId) {
        if (this.uniqueEvents[eventName]) {
            this.logger.debug("Unique event '" + eventName + "' ignored because it was already triggered.");
        }
        else {
            this.logger.debug("Unique event '" + eventName + "' triggered.");
            if (siteId) {
                if (!data) {
                    data = {};
                }
                data.siteId = siteId;
            }
            // Store the data so it can be passed to observers that register from now on.
            this.uniqueEvents[eventName] = {
                data: data
            };
            // Now pass the data to observers.
            if (this.observables[eventName]) {
                this.observables[eventName].next(data);
            }
        }
    };
    CoreEventsProvider.SESSION_EXPIRED = 'session_expired';
    CoreEventsProvider.PASSWORD_CHANGE_FORCED = 'password_change_forced';
    CoreEventsProvider.USER_NOT_FULLY_SETUP = 'user_not_fully_setup';
    CoreEventsProvider.SITE_POLICY_NOT_AGREED = 'site_policy_not_agreed';
    CoreEventsProvider.LOGIN = 'login';
    CoreEventsProvider.LOGOUT = 'logout';
    CoreEventsProvider.LANGUAGE_CHANGED = 'language_changed';
    CoreEventsProvider.NOTIFICATION_SOUND_CHANGED = 'notification_sound_changed';
    CoreEventsProvider.SITE_ADDED = 'site_added';
    CoreEventsProvider.SITE_UPDATED = 'site_updated';
    CoreEventsProvider.SITE_DELETED = 'site_deleted';
    CoreEventsProvider.COMPLETION_MODULE_VIEWED = 'completion_module_viewed';
    CoreEventsProvider.USER_DELETED = 'user_deleted';
    CoreEventsProvider.PACKAGE_STATUS_CHANGED = 'package_status_changed';
    CoreEventsProvider.COURSE_STATUS_CHANGED = 'course_status_changed';
    CoreEventsProvider.SECTION_STATUS_CHANGED = 'section_status_changed';
    CoreEventsProvider.SITE_PLUGINS_LOADED = 'site_plugins_loaded';
    CoreEventsProvider.LOGIN_SITE_CHECKED = 'login_site_checked';
    CoreEventsProvider.LOGIN_SITE_UNCHECKED = 'login_site_unchecked';
    CoreEventsProvider.IAB_LOAD_START = 'inappbrowser_load_start';
    CoreEventsProvider.IAB_EXIT = 'inappbrowser_exit';
    CoreEventsProvider.APP_LAUNCHED_URL = 'app_launched_url'; // App opened with a certain URL (custom URL scheme).
    CoreEventsProvider.FILE_SHARED = 'file_shared';
    CoreEventsProvider.KEYBOARD_CHANGE = 'keyboard_change';
    CoreEventsProvider.CORE_LOADING_CHANGED = 'core_loading_changed';
    CoreEventsProvider.ORIENTATION_CHANGE = 'orientation_change';
    CoreEventsProvider.LOAD_PAGE_MAIN_MENU = 'load_page_main_menu';
    CoreEventsProvider.SEND_ON_ENTER_CHANGED = 'send_on_enter_changed';
    CoreEventsProvider.MAIN_MENU_OPEN = 'main_menu_open';
    CoreEventsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */]])
    ], CoreEventsProvider);
    return CoreEventsProvider;
}());

//# sourceMappingURL=events.js.map

/***/ }),
/* 13 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__loading_loading__ = __webpack_require__(1344);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__mark_required_mark_required__ = __webpack_require__(1345);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__input_errors_input_errors__ = __webpack_require__(1346);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__show_password_show_password__ = __webpack_require__(1347);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__split_view_split_view__ = __webpack_require__(121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__iframe_iframe__ = __webpack_require__(1348);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__progress_bar_progress_bar__ = __webpack_require__(1349);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__empty_box_empty_box__ = __webpack_require__(1350);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__search_box_search_box__ = __webpack_require__(1351);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__file_file__ = __webpack_require__(1352);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__icon_icon__ = __webpack_require__(1353);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__context_menu_context_menu__ = __webpack_require__(750);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__context_menu_context_menu_item__ = __webpack_require__(1354);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__context_menu_context_menu_popover__ = __webpack_require__(751);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__course_picker_menu_course_picker_menu_popover__ = __webpack_require__(992);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__chart_chart__ = __webpack_require__(1355);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__chrono_chrono__ = __webpack_require__(1402);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__download_refresh_download_refresh__ = __webpack_require__(1403);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__local_file_local_file__ = __webpack_require__(1404);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__site_picker_site_picker__ = __webpack_require__(1405);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__tabs_tabs__ = __webpack_require__(151);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__tabs_tab__ = __webpack_require__(752);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__rich_text_editor_rich_text_editor__ = __webpack_require__(993);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__navbar_buttons_navbar_buttons__ = __webpack_require__(1406);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__dynamic_component_dynamic_component__ = __webpack_require__(162);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__send_message_form_send_message_form__ = __webpack_require__(1407);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__timer_timer__ = __webpack_require__(1408);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__recaptcha_recaptcha__ = __webpack_require__(1409);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__recaptcha_recaptchamodal__ = __webpack_require__(757);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__navigation_bar_navigation_bar__ = __webpack_require__(1410);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__attachments_attachments__ = __webpack_require__(1411);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__ion_tabs_ion_tabs__ = __webpack_require__(417);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__ion_tabs_ion_tab__ = __webpack_require__(1412);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__infinite_loading_infinite_loading__ = __webpack_require__(994);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__user_avatar_user_avatar__ = __webpack_require__(1413);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__style_style__ = __webpack_require__(1414);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__bs_tooltip_bs_tooltip__ = __webpack_require__(743);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__ouc_progress_bar_ouc_progress_bar__ = __webpack_require__(1415);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__ouc_home_banner_ouc_home_banner__ = __webpack_require__(1416);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_44__ouc_home_circle_ouc_home_circle__ = __webpack_require__(1417);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_45__ouc_home_line_card_ouc_home_line_card__ = __webpack_require__(1418);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_46__ouc_home_list_card_ouc_home_list_card__ = __webpack_require__(1419);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_47__ouc_home_image_ouc_home_image__ = __webpack_require__(1420);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_48__ouc_home_notice_ouc_home_notice__ = __webpack_require__(1421);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_49__ngx_extended_pdf_viewer_ngx_extended_pdf_viewer_component__ = __webpack_require__(1422);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_50__ouc_credit_progress_bar_ouc_credit_progress_bar__ = __webpack_require__(1426);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_51__ouc_home_big_banner_ouc_home_big_banner__ = __webpack_require__(1427);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




















































var CoreComponentsModule = /** @class */ (function () {
    function CoreComponentsModule() {
    }
    CoreComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__loading_loading__["a" /* CoreLoadingComponent */],
                __WEBPACK_IMPORTED_MODULE_6__mark_required_mark_required__["a" /* CoreMarkRequiredComponent */],
                __WEBPACK_IMPORTED_MODULE_7__input_errors_input_errors__["a" /* CoreInputErrorsComponent */],
                __WEBPACK_IMPORTED_MODULE_8__show_password_show_password__["a" /* CoreShowPasswordComponent */],
                __WEBPACK_IMPORTED_MODULE_9__split_view_split_view__["a" /* CoreSplitViewComponent */],
                __WEBPACK_IMPORTED_MODULE_10__iframe_iframe__["a" /* CoreIframeComponent */],
                __WEBPACK_IMPORTED_MODULE_11__progress_bar_progress_bar__["a" /* CoreProgressBarComponent */],
                __WEBPACK_IMPORTED_MODULE_12__empty_box_empty_box__["a" /* CoreEmptyBoxComponent */],
                __WEBPACK_IMPORTED_MODULE_13__search_box_search_box__["a" /* CoreSearchBoxComponent */],
                __WEBPACK_IMPORTED_MODULE_14__file_file__["a" /* CoreFileComponent */],
                __WEBPACK_IMPORTED_MODULE_15__icon_icon__["a" /* CoreIconComponent */],
                __WEBPACK_IMPORTED_MODULE_16__context_menu_context_menu__["a" /* CoreContextMenuComponent */],
                __WEBPACK_IMPORTED_MODULE_17__context_menu_context_menu_item__["a" /* CoreContextMenuItemComponent */],
                __WEBPACK_IMPORTED_MODULE_18__context_menu_context_menu_popover__["a" /* CoreContextMenuPopoverComponent */],
                __WEBPACK_IMPORTED_MODULE_19__course_picker_menu_course_picker_menu_popover__["a" /* CoreCoursePickerMenuPopoverComponent */],
                __WEBPACK_IMPORTED_MODULE_20__chart_chart__["a" /* CoreChartComponent */],
                __WEBPACK_IMPORTED_MODULE_21__chrono_chrono__["a" /* CoreChronoComponent */],
                __WEBPACK_IMPORTED_MODULE_22__download_refresh_download_refresh__["a" /* CoreDownloadRefreshComponent */],
                __WEBPACK_IMPORTED_MODULE_23__local_file_local_file__["a" /* CoreLocalFileComponent */],
                __WEBPACK_IMPORTED_MODULE_24__site_picker_site_picker__["a" /* CoreSitePickerComponent */],
                __WEBPACK_IMPORTED_MODULE_25__tabs_tabs__["a" /* CoreTabsComponent */],
                __WEBPACK_IMPORTED_MODULE_26__tabs_tab__["a" /* CoreTabComponent */],
                __WEBPACK_IMPORTED_MODULE_27__rich_text_editor_rich_text_editor__["a" /* CoreRichTextEditorComponent */],
                __WEBPACK_IMPORTED_MODULE_28__navbar_buttons_navbar_buttons__["a" /* CoreNavBarButtonsComponent */],
                __WEBPACK_IMPORTED_MODULE_29__dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */],
                __WEBPACK_IMPORTED_MODULE_30__send_message_form_send_message_form__["a" /* CoreSendMessageFormComponent */],
                __WEBPACK_IMPORTED_MODULE_31__timer_timer__["a" /* CoreTimerComponent */],
                __WEBPACK_IMPORTED_MODULE_32__recaptcha_recaptcha__["a" /* CoreRecaptchaComponent */],
                __WEBPACK_IMPORTED_MODULE_33__recaptcha_recaptchamodal__["a" /* CoreRecaptchaModalComponent */],
                __WEBPACK_IMPORTED_MODULE_34__navigation_bar_navigation_bar__["a" /* CoreNavigationBarComponent */],
                __WEBPACK_IMPORTED_MODULE_35__attachments_attachments__["a" /* CoreAttachmentsComponent */],
                __WEBPACK_IMPORTED_MODULE_36__ion_tabs_ion_tabs__["a" /* CoreIonTabsComponent */],
                __WEBPACK_IMPORTED_MODULE_37__ion_tabs_ion_tab__["a" /* CoreIonTabComponent */],
                __WEBPACK_IMPORTED_MODULE_38__infinite_loading_infinite_loading__["a" /* CoreInfiniteLoadingComponent */],
                __WEBPACK_IMPORTED_MODULE_39__user_avatar_user_avatar__["a" /* CoreUserAvatarComponent */],
                __WEBPACK_IMPORTED_MODULE_40__style_style__["a" /* CoreStyleComponent */],
                __WEBPACK_IMPORTED_MODULE_41__bs_tooltip_bs_tooltip__["a" /* CoreBSTooltipComponent */],
                __WEBPACK_IMPORTED_MODULE_42__ouc_progress_bar_ouc_progress_bar__["a" /* OucProgressBarComponent */],
                __WEBPACK_IMPORTED_MODULE_43__ouc_home_banner_ouc_home_banner__["a" /* OucHomeBannerComponent */],
                __WEBPACK_IMPORTED_MODULE_44__ouc_home_circle_ouc_home_circle__["a" /* OucHomeCircleComponent */],
                __WEBPACK_IMPORTED_MODULE_45__ouc_home_line_card_ouc_home_line_card__["a" /* OucHomeLineCardComponent */],
                __WEBPACK_IMPORTED_MODULE_46__ouc_home_list_card_ouc_home_list_card__["a" /* OucHomeListCardComponent */],
                __WEBPACK_IMPORTED_MODULE_47__ouc_home_image_ouc_home_image__["a" /* OucHomeImageComponent */],
                __WEBPACK_IMPORTED_MODULE_48__ouc_home_notice_ouc_home_notice__["a" /* OucHomeNoticeComponent */],
                __WEBPACK_IMPORTED_MODULE_49__ngx_extended_pdf_viewer_ngx_extended_pdf_viewer_component__["a" /* NgxExtendedPdfViewerComponent */],
                __WEBPACK_IMPORTED_MODULE_50__ouc_credit_progress_bar_ouc_credit_progress_bar__["a" /* OucCreditProgressBarComponent */],
                __WEBPACK_IMPORTED_MODULE_51__ouc_home_big_banner_ouc_home_big_banner__["a" /* OucHomeBigBannerComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_18__context_menu_context_menu_popover__["a" /* CoreContextMenuPopoverComponent */],
                __WEBPACK_IMPORTED_MODULE_19__course_picker_menu_course_picker_menu_popover__["a" /* CoreCoursePickerMenuPopoverComponent */],
                __WEBPACK_IMPORTED_MODULE_33__recaptcha_recaptchamodal__["a" /* CoreRecaptchaModalComponent */],
                __WEBPACK_IMPORTED_MODULE_41__bs_tooltip_bs_tooltip__["a" /* CoreBSTooltipComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_3__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_4__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__loading_loading__["a" /* CoreLoadingComponent */],
                __WEBPACK_IMPORTED_MODULE_6__mark_required_mark_required__["a" /* CoreMarkRequiredComponent */],
                __WEBPACK_IMPORTED_MODULE_7__input_errors_input_errors__["a" /* CoreInputErrorsComponent */],
                __WEBPACK_IMPORTED_MODULE_8__show_password_show_password__["a" /* CoreShowPasswordComponent */],
                __WEBPACK_IMPORTED_MODULE_9__split_view_split_view__["a" /* CoreSplitViewComponent */],
                __WEBPACK_IMPORTED_MODULE_10__iframe_iframe__["a" /* CoreIframeComponent */],
                __WEBPACK_IMPORTED_MODULE_11__progress_bar_progress_bar__["a" /* CoreProgressBarComponent */],
                __WEBPACK_IMPORTED_MODULE_12__empty_box_empty_box__["a" /* CoreEmptyBoxComponent */],
                __WEBPACK_IMPORTED_MODULE_13__search_box_search_box__["a" /* CoreSearchBoxComponent */],
                __WEBPACK_IMPORTED_MODULE_14__file_file__["a" /* CoreFileComponent */],
                __WEBPACK_IMPORTED_MODULE_15__icon_icon__["a" /* CoreIconComponent */],
                __WEBPACK_IMPORTED_MODULE_16__context_menu_context_menu__["a" /* CoreContextMenuComponent */],
                __WEBPACK_IMPORTED_MODULE_17__context_menu_context_menu_item__["a" /* CoreContextMenuItemComponent */],
                __WEBPACK_IMPORTED_MODULE_20__chart_chart__["a" /* CoreChartComponent */],
                __WEBPACK_IMPORTED_MODULE_21__chrono_chrono__["a" /* CoreChronoComponent */],
                __WEBPACK_IMPORTED_MODULE_22__download_refresh_download_refresh__["a" /* CoreDownloadRefreshComponent */],
                __WEBPACK_IMPORTED_MODULE_23__local_file_local_file__["a" /* CoreLocalFileComponent */],
                __WEBPACK_IMPORTED_MODULE_24__site_picker_site_picker__["a" /* CoreSitePickerComponent */],
                __WEBPACK_IMPORTED_MODULE_25__tabs_tabs__["a" /* CoreTabsComponent */],
                __WEBPACK_IMPORTED_MODULE_26__tabs_tab__["a" /* CoreTabComponent */],
                __WEBPACK_IMPORTED_MODULE_27__rich_text_editor_rich_text_editor__["a" /* CoreRichTextEditorComponent */],
                __WEBPACK_IMPORTED_MODULE_28__navbar_buttons_navbar_buttons__["a" /* CoreNavBarButtonsComponent */],
                __WEBPACK_IMPORTED_MODULE_29__dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */],
                __WEBPACK_IMPORTED_MODULE_30__send_message_form_send_message_form__["a" /* CoreSendMessageFormComponent */],
                __WEBPACK_IMPORTED_MODULE_31__timer_timer__["a" /* CoreTimerComponent */],
                __WEBPACK_IMPORTED_MODULE_32__recaptcha_recaptcha__["a" /* CoreRecaptchaComponent */],
                __WEBPACK_IMPORTED_MODULE_34__navigation_bar_navigation_bar__["a" /* CoreNavigationBarComponent */],
                __WEBPACK_IMPORTED_MODULE_35__attachments_attachments__["a" /* CoreAttachmentsComponent */],
                __WEBPACK_IMPORTED_MODULE_36__ion_tabs_ion_tabs__["a" /* CoreIonTabsComponent */],
                __WEBPACK_IMPORTED_MODULE_37__ion_tabs_ion_tab__["a" /* CoreIonTabComponent */],
                __WEBPACK_IMPORTED_MODULE_38__infinite_loading_infinite_loading__["a" /* CoreInfiniteLoadingComponent */],
                __WEBPACK_IMPORTED_MODULE_39__user_avatar_user_avatar__["a" /* CoreUserAvatarComponent */],
                __WEBPACK_IMPORTED_MODULE_40__style_style__["a" /* CoreStyleComponent */],
                __WEBPACK_IMPORTED_MODULE_41__bs_tooltip_bs_tooltip__["a" /* CoreBSTooltipComponent */],
                __WEBPACK_IMPORTED_MODULE_42__ouc_progress_bar_ouc_progress_bar__["a" /* OucProgressBarComponent */],
                __WEBPACK_IMPORTED_MODULE_43__ouc_home_banner_ouc_home_banner__["a" /* OucHomeBannerComponent */],
                __WEBPACK_IMPORTED_MODULE_44__ouc_home_circle_ouc_home_circle__["a" /* OucHomeCircleComponent */],
                __WEBPACK_IMPORTED_MODULE_45__ouc_home_line_card_ouc_home_line_card__["a" /* OucHomeLineCardComponent */],
                __WEBPACK_IMPORTED_MODULE_46__ouc_home_list_card_ouc_home_list_card__["a" /* OucHomeListCardComponent */],
                __WEBPACK_IMPORTED_MODULE_47__ouc_home_image_ouc_home_image__["a" /* OucHomeImageComponent */],
                __WEBPACK_IMPORTED_MODULE_48__ouc_home_notice_ouc_home_notice__["a" /* OucHomeNoticeComponent */],
                __WEBPACK_IMPORTED_MODULE_49__ngx_extended_pdf_viewer_ngx_extended_pdf_viewer_component__["a" /* NgxExtendedPdfViewerComponent */],
                __WEBPACK_IMPORTED_MODULE_50__ouc_credit_progress_bar_ouc_credit_progress_bar__["a" /* OucCreditProgressBarComponent */],
                __WEBPACK_IMPORTED_MODULE_51__ouc_home_big_banner_ouc_home_big_banner__["a" /* OucHomeBigBannerComponent */]
            ]
        })
    ], CoreComponentsModule);
    return CoreComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 14 */,
/* 15 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDirectivesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__auto_focus__ = __webpack_require__(1318);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__download_file__ = __webpack_require__(1325);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_content__ = __webpack_require__(745);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__fab__ = __webpack_require__(1326);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__format_text__ = __webpack_require__(1327);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__link__ = __webpack_require__(748);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__keep_keyboard__ = __webpack_require__(1328);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__user_link__ = __webpack_require__(1329);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__auto_rows__ = __webpack_require__(1330);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__long_press__ = __webpack_require__(1331);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__back_button__ = __webpack_require__(1333);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__supress_events__ = __webpack_require__(1334);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};













var CoreDirectivesModule = /** @class */ (function () {
    function CoreDirectivesModule() {
    }
    CoreDirectivesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_1__auto_focus__["a" /* CoreAutoFocusDirective */],
                __WEBPACK_IMPORTED_MODULE_2__download_file__["a" /* CoreDownloadFileDirective */],
                __WEBPACK_IMPORTED_MODULE_3__external_content__["a" /* CoreExternalContentDirective */],
                __WEBPACK_IMPORTED_MODULE_4__fab__["a" /* CoreFabDirective */],
                __WEBPACK_IMPORTED_MODULE_5__format_text__["a" /* CoreFormatTextDirective */],
                __WEBPACK_IMPORTED_MODULE_7__keep_keyboard__["a" /* CoreKeepKeyboardDirective */],
                __WEBPACK_IMPORTED_MODULE_6__link__["a" /* CoreLinkDirective */],
                __WEBPACK_IMPORTED_MODULE_8__user_link__["a" /* CoreUserLinkDirective */],
                __WEBPACK_IMPORTED_MODULE_9__auto_rows__["a" /* CoreAutoRowsDirective */],
                __WEBPACK_IMPORTED_MODULE_10__long_press__["a" /* CoreLongPressDirective */],
                __WEBPACK_IMPORTED_MODULE_11__back_button__["a" /* CoreBackButtonDirective */],
                __WEBPACK_IMPORTED_MODULE_12__supress_events__["a" /* CoreSupressEventsDirective */]
            ],
            imports: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_1__auto_focus__["a" /* CoreAutoFocusDirective */],
                __WEBPACK_IMPORTED_MODULE_2__download_file__["a" /* CoreDownloadFileDirective */],
                __WEBPACK_IMPORTED_MODULE_3__external_content__["a" /* CoreExternalContentDirective */],
                __WEBPACK_IMPORTED_MODULE_4__fab__["a" /* CoreFabDirective */],
                __WEBPACK_IMPORTED_MODULE_5__format_text__["a" /* CoreFormatTextDirective */],
                __WEBPACK_IMPORTED_MODULE_7__keep_keyboard__["a" /* CoreKeepKeyboardDirective */],
                __WEBPACK_IMPORTED_MODULE_6__link__["a" /* CoreLinkDirective */],
                __WEBPACK_IMPORTED_MODULE_8__user_link__["a" /* CoreUserLinkDirective */],
                __WEBPACK_IMPORTED_MODULE_9__auto_rows__["a" /* CoreAutoRowsDirective */],
                __WEBPACK_IMPORTED_MODULE_10__long_press__["a" /* CoreLongPressDirective */],
                __WEBPACK_IMPORTED_MODULE_11__back_button__["a" /* CoreBackButtonDirective */],
                __WEBPACK_IMPORTED_MODULE_12__supress_events__["a" /* CoreSupressEventsDirective */]
            ]
        })
    ], CoreDirectivesModule);
    return CoreDirectivesModule;
}());

//# sourceMappingURL=directives.module.js.map

/***/ }),
/* 16 */,
/* 17 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreTimeUtilsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_moment__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/*
 * "Utils" service with helper functions for date and time.
*/
var CoreTimeUtilsProvider = /** @class */ (function () {
    function CoreTimeUtilsProvider(translate) {
        this.translate = translate;
        this.FORMAT_REPLACEMENTS = {
            '%a': 'ddd',
            '%A': 'dddd',
            '%d': 'DD',
            '%e': 'D',
            '%j': 'DDDD',
            '%u': 'E',
            '%w': 'e',
            '%U': 'ww',
            '%V': 'WW',
            '%W': 'ww',
            '%b': 'MMM',
            '%B': 'MMMM',
            '%h': 'MMM',
            '%m': 'MM',
            '%C': '',
            '%g': 'GG',
            '%G': 'GGGG',
            '%y': 'YY',
            '%Y': 'YYYY',
            '%H': 'HH',
            '%k': 'H',
            '%I': 'hh',
            '%l': 'h',
            '%M': 'mm',
            '%p': 'A',
            '%P': 'a',
            '%r': 'hh:mm:ss A',
            '%R': 'HH:mm',
            '%S': 'ss',
            '%T': 'HH:mm:ss',
            '%X': 'LTS',
            '%z': 'ZZ',
            '%Z': 'ZZ',
            '%c': 'LLLL',
            '%D': 'MM/DD/YY',
            '%F': 'YYYY-MM-DD',
            '%s': 'X',
            '%x': 'L',
            '%n': '\n',
            '%t': '\t',
            '%%': '%'
        };
    }
    /**
     * Convert a PHP format to a Moment format.
     *
     * @param {string} format PHP format.
     * @return {string} Converted format.
     */
    CoreTimeUtilsProvider.prototype.convertPHPToMoment = function (format) {
        if (typeof format != 'string') {
            // Not valid.
            return '';
        }
        var converted = '', escaping = false;
        for (var i = 0; i < format.length; i++) {
            var char = format[i];
            if (char == '%') {
                // It's a PHP format, try to convert it.
                i++;
                char += format[i] || '';
                if (escaping) {
                    // We were escaping some characters, stop doing it now.
                    escaping = false;
                    converted += ']';
                }
                converted += typeof this.FORMAT_REPLACEMENTS[char] != 'undefined' ? this.FORMAT_REPLACEMENTS[char] : char;
            }
            else {
                // Not a PHP format. We need to escape them, otherwise the letters could be confused with Moment formats.
                if (!escaping) {
                    escaping = true;
                    converted += '[';
                }
                converted += char;
            }
        }
        if (escaping) {
            // Finish escaping.
            converted += ']';
        }
        return converted;
    };
    /**
     * Returns hours, minutes and seconds in a human readable format
     *
     * @param {number} seconds A number of seconds
     * @return {string} Seconds in a human readable format.
     */
    CoreTimeUtilsProvider.prototype.formatTime = function (seconds) {
        var totalSecs, years, days, hours, mins, secs, remainder;
        totalSecs = Math.abs(seconds);
        years = Math.floor(totalSecs / __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_YEAR);
        remainder = totalSecs - (years * __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_YEAR);
        days = Math.floor(remainder / __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_DAY);
        remainder = totalSecs - (days * __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_DAY);
        hours = Math.floor(remainder / __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_HOUR);
        remainder = remainder - (hours * __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_HOUR);
        mins = Math.floor(remainder / __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_MINUTE);
        secs = remainder - (mins * __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_MINUTE);
        var ss = this.translate.instant('core.' + (secs == 1 ? 'sec' : 'secs')), sm = this.translate.instant('core.' + (mins == 1 ? 'min' : 'mins')), sh = this.translate.instant('core.' + (hours == 1 ? 'hour' : 'hours')), sd = this.translate.instant('core.' + (days == 1 ? 'day' : 'days')), sy = this.translate.instant('core.' + (years == 1 ? 'year' : 'years'));
        var oyears = '', odays = '', ohours = '', omins = '', osecs = '';
        if (years) {
            oyears = years + ' ' + sy;
        }
        if (days) {
            odays = days + ' ' + sd;
        }
        if (hours) {
            ohours = hours + ' ' + sh;
        }
        if (mins) {
            omins = mins + ' ' + sm;
        }
        if (secs) {
            osecs = secs + ' ' + ss;
        }
        if (years) {
            return oyears + ' ' + odays;
        }
        if (days) {
            return odays + ' ' + ohours;
        }
        if (hours) {
            return ohours + ' ' + omins;
        }
        if (mins) {
            return omins + ' ' + osecs;
        }
        if (secs) {
            return osecs;
        }
        return this.translate.instant('core.now');
    };
    /**
     * Returns hours, minutes and seconds in a human readable format.
     *
     * @param {number} duration Duration in seconds
     * @param {number} [precision] Number of elements to have in precission. 0 or undefined to full precission.
     * @return {string} Duration in a human readable format.
     */
    CoreTimeUtilsProvider.prototype.formatDuration = function (duration, precision) {
        precision = precision || 5;
        var eventDuration = __WEBPACK_IMPORTED_MODULE_2_moment__["duration"](duration, 'seconds');
        var durationString = '';
        if (precision && eventDuration.years() > 0) {
            durationString += ' ' + __WEBPACK_IMPORTED_MODULE_2_moment__["duration"](eventDuration.years(), 'years').humanize();
            precision--;
        }
        if (precision && eventDuration.months() > 0) {
            durationString += ' ' + __WEBPACK_IMPORTED_MODULE_2_moment__["duration"](eventDuration.months(), 'months').humanize();
            precision--;
        }
        if (precision && eventDuration.days() > 0) {
            durationString += ' ' + __WEBPACK_IMPORTED_MODULE_2_moment__["duration"](eventDuration.days(), 'days').humanize();
            precision--;
        }
        if (precision && eventDuration.hours() > 0) {
            durationString += ' ' + __WEBPACK_IMPORTED_MODULE_2_moment__["duration"](eventDuration.hours(), 'hours').humanize();
            precision--;
        }
        if (precision && eventDuration.minutes() > 0) {
            durationString += ' ' + __WEBPACK_IMPORTED_MODULE_2_moment__["duration"](eventDuration.minutes(), 'minutes').humanize();
            precision--;
        }
        return durationString.trim();
    };
    /**
     * Return the current timestamp in a "readable" format: YYYYMMDDHHmmSS.
     *
     * @return {string} The readable timestamp.
     */
    CoreTimeUtilsProvider.prototype.readableTimestamp = function () {
        return __WEBPACK_IMPORTED_MODULE_2_moment__(Date.now()).format('YYYYMMDDHHmmSS');
    };
    /**
     * Return the current timestamp (UNIX format, seconds).
     *
     * @return {number} The current timestamp in seconds.
     */
    CoreTimeUtilsProvider.prototype.timestamp = function () {
        return Math.round(Date.now() / 1000);
    };
    /**
     * Convert a timestamp into a readable date.
     *
     * @param {number} timestamp Timestamp in milliseconds.
     * @param {string} [format] The format to use (lang key). Defaults to core.strftimedaydatetime.
     * @param {boolean} [convert=true] If true (default), convert the format from PHP to Moment. Set it to false for Moment formats.
     * @param {boolean} [fixDay=true] If true (default) then the leading zero from %d is removed.
     * @param {boolean} [fixHour=true] If true (default) then the leading zero from %I is removed.
     * @return {string} Readable date.
     */
    CoreTimeUtilsProvider.prototype.userDate = function (timestamp, format, convert, fixDay, fixHour) {
        if (convert === void 0) { convert = true; }
        if (fixDay === void 0) { fixDay = true; }
        if (fixHour === void 0) { fixHour = true; }
        format = this.translate.instant(format ? format : 'core.strftimedaydatetime');
        if (fixDay) {
            format = format.replace(/%d/g, '%e');
        }
        if (fixHour) {
            format = format.replace('%I', '%l');
        }
        // Format could be in PHP format, convert it to moment.
        if (convert) {
            format = this.convertPHPToMoment(format);
        }
        return __WEBPACK_IMPORTED_MODULE_2_moment__(timestamp).format(format);
    };
    /**
     * Convert a text into user timezone timestamp.
     *
     * @param {number} date To convert to timestamp.
     * @return {number} Converted timestamp.
     */
    CoreTimeUtilsProvider.prototype.convertToTimestamp = function (date) {
        return __WEBPACK_IMPORTED_MODULE_2_moment__(date).unix() - (__WEBPACK_IMPORTED_MODULE_2_moment__().utcOffset() * 60);
    };
    /**
     * Return the localized ISO format (i.e DDMMYY) from the localized moment format. Useful for translations.
     * DO NOT USE this function for ion-datetime format. Moment escapes characters with [], but ion-datetime doesn't support it.
     *
     * @param {any} localizedFormat Format to use.
     * @return {string} Localized ISO format
     */
    CoreTimeUtilsProvider.prototype.getLocalizedDateFormat = function (localizedFormat) {
        return __WEBPACK_IMPORTED_MODULE_2_moment__["localeData"]().longDateFormat(localizedFormat);
    };
    /**
     * For a given timestamp get the midnight value in the user's timezone.
     *
     * The calculation is performed relative to the user's midnight timestamp
     * for today to ensure that timezones are preserved.
     *
     * @param {number} [timestamp] The timestamp to calculate from. If not defined, return today's midnight.
     * @return {number} The midnight value of the user's timestamp.
     */
    CoreTimeUtilsProvider.prototype.getMidnightForTimestamp = function (timestamp) {
        if (timestamp) {
            return __WEBPACK_IMPORTED_MODULE_2_moment__(timestamp * 1000).startOf('day').unix();
        }
        else {
            return __WEBPACK_IMPORTED_MODULE_2_moment__().startOf('day').unix();
        }
    };
    CoreTimeUtilsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], CoreTimeUtilsProvider);
    return CoreTimeUtilsProvider;
}());

//# sourceMappingURL=time.js.map

/***/ }),
/* 18 */,
/* 19 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContentLinksHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_siteplugins_providers_siteplugins__ = __webpack_require__(45);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/**
 * Service that provides some features regarding content links.
 */
var CoreContentLinksHelperProvider = /** @class */ (function () {
    function CoreContentLinksHelperProvider(logger, sitesProvider, loginHelper, contentLinksDelegate, appProvider, domUtils, urlUtils, translate, initDelegate, eventsProvider, textUtils, sitePluginsProvider, zone, utils) {
        this.sitesProvider = sitesProvider;
        this.loginHelper = loginHelper;
        this.contentLinksDelegate = contentLinksDelegate;
        this.appProvider = appProvider;
        this.domUtils = domUtils;
        this.urlUtils = urlUtils;
        this.translate = translate;
        this.initDelegate = initDelegate;
        this.textUtils = textUtils;
        this.sitePluginsProvider = sitePluginsProvider;
        this.zone = zone;
        this.utils = utils;
        this.logger = logger.getInstance('CoreContentLinksHelperProvider');
    }
    /**
     * Check whether a link can be handled by the app.
     *
     * @param {string} url URL to handle.
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @param {string} [username] Username to use to filter sites.
     * @param {boolean} [checkRoot] Whether to check if the URL is the root URL of a site.
     * @return {Promise<boolean>} Promise resolved with a boolean: whether the URL can be handled.
     */
    CoreContentLinksHelperProvider.prototype.canHandleLink = function (url, courseId, username, checkRoot) {
        var _this = this;
        var promise;
        if (checkRoot) {
            promise = this.sitesProvider.isStoredRootURL(url, username);
        }
        else {
            promise = Promise.resolve({});
        }
        return promise.then(function (data) {
            if (data.site) {
                // URL is the root of the site, can handle it.
                return true;
            }
            return _this.contentLinksDelegate.getActionsFor(url, undefined, username).then(function (actions) {
                return !!_this.getFirstValidAction(actions);
            });
        }).catch(function () {
            return false;
        });
    };
    /**
     * Get the first valid action in a list of actions.
     *
     * @param {CoreContentLinksAction[]} actions List of actions.
     * @return {CoreContentLinksAction} First valid action. Returns undefined if no valid action found.
     */
    CoreContentLinksHelperProvider.prototype.getFirstValidAction = function (actions) {
        if (actions) {
            for (var i = 0; i < actions.length; i++) {
                var action = actions[i];
                if (action && action.sites && action.sites.length) {
                    return action;
                }
            }
        }
    };
    /**
     * Goes to a certain page in a certain site. If the site is current site it will perform a regular navigation,
     * otherwise it will 'redirect' to the other site.
     *
     * @param {NavController} navCtrl The NavController instance to use.
     * @param {string} pageName Name of the page to go.
     * @param {any} [pageParams] Params to send to the page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreContentLinksHelperProvider.prototype.goInSite = function (navCtrl, pageName, pageParams, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var deferred = this.utils.promiseDefer();
        // Execute the code in the Angular zone, so change detection doesn't stop working.
        this.zone.run(function () {
            if (navCtrl && siteId == _this.sitesProvider.getCurrentSiteId()) {
                navCtrl.push(pageName, pageParams).then(deferred.resolve, deferred.reject);
            }
            else {
                _this.loginHelper.redirect(pageName, pageParams, siteId).then(deferred.resolve, deferred.reject);
            }
        });
        return deferred.promise;
    };
    /**
     * Go to the page to choose a site.
     *
     * @param {string} url URL to treat.
     */
    CoreContentLinksHelperProvider.prototype.goToChooseSite = function (url) {
        this.appProvider.getRootNavController().setRoot('CoreContentLinksChooseSitePage', { url: url });
    };
    /**
     * Handle a URL received by Custom URL Scheme.
     *
     * @param {string} url URL to handle.
     * @return {boolean} True if the URL should be handled by this component, false otherwise.
     * @deprecated Please use CoreCustomURLSchemesProvider.handleCustomURL instead.
     */
    CoreContentLinksHelperProvider.prototype.handleCustomUrl = function (url) {
        var _this = this;
        var contentLinksScheme = __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://link';
        if (url.indexOf(contentLinksScheme) == -1) {
            return false;
        }
        var modal = this.domUtils.showModalLoading();
        var username;
        url = this.textUtils.decodeURIComponent(url);
        // App opened using custom URL scheme.
        this.logger.debug('Treating custom URL scheme: ' + url);
        // Delete the scheme from the URL.
        url = url.replace(contentLinksScheme + '=', '');
        // Detect if there's a user specified.
        username = this.urlUtils.getUsernameFromUrl(url);
        if (username) {
            url = url.replace(username + '@', ''); // Remove the username from the URL.
        }
        // Wait for the app to be ready.
        this.initDelegate.ready().then(function () {
            // Check if it's the root URL.
            return _this.sitesProvider.isStoredRootURL(url, username);
        }).then(function (data) {
            if (data.site) {
                // Root URL.
                modal.dismiss();
                return _this.handleRootURL(data.site, false);
            }
            else if (data.siteIds.length > 0) {
                modal.dismiss(); // Dismiss modal so it doesn't collide with confirms.
                return _this.handleLink(url, username).then(function (treated) {
                    if (!treated) {
                        _this.domUtils.showErrorModal('core.contentlinks.errornoactions', true);
                    }
                });
            }
            else {
                // Get the site URL.
                var siteUrl = _this.contentLinksDelegate.getSiteUrl(url), urlToOpen_1 = url;
                if (!siteUrl) {
                    // Site URL not found, use the original URL since it could be the root URL of the site.
                    siteUrl = url;
                    urlToOpen_1 = undefined;
                }
                // Check that site exists.
                return _this.sitesProvider.checkSite(siteUrl).then(function (result) {
                    // Site exists. We'll allow to add it.
                    var ssoNeeded = _this.loginHelper.isSSOLoginNeeded(result.code), pageName = 'CoreLoginCredentialsPage', pageParams = {
                        siteUrl: result.siteUrl,
                        username: username,
                        urlToOpen: urlToOpen_1,
                        siteConfig: result.config
                    };
                    var promise, hasSitePluginsLoaded = false;
                    modal.dismiss(); // Dismiss modal so it doesn't collide with confirms.
                    if (!_this.sitesProvider.isLoggedIn()) {
                        // Not logged in, no need to confirm. If SSO the confirm will be shown later.
                        promise = Promise.resolve();
                    }
                    else {
                        // Ask the user before changing site.
                        var confirmMsg = _this.translate.instant('core.contentlinks.confirmurlothersite');
                        promise = _this.domUtils.showConfirm(confirmMsg).then(function () {
                            if (!ssoNeeded) {
                                hasSitePluginsLoaded = _this.sitePluginsProvider.hasSitePluginsLoaded;
                                if (hasSitePluginsLoaded) {
                                    // Store the redirect since logout will restart the app.
                                    _this.appProvider.storeRedirect(__WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].NO_SITE_ID, pageName, pageParams);
                                }
                                return _this.sitesProvider.logout().catch(function () {
                                    // Ignore errors (shouldn't happen).
                                });
                            }
                        });
                    }
                    return promise.then(function () {
                        if (ssoNeeded) {
                            _this.loginHelper.confirmAndOpenBrowserForSSOLogin(result.siteUrl, result.code, result.service, result.config && result.config.launchurl);
                        }
                        else if (!hasSitePluginsLoaded) {
                            return _this.loginHelper.goToNoSitePage(undefined, pageName, pageParams);
                        }
                    });
                }).catch(function (error) {
                    _this.domUtils.showErrorModalDefault(error, _this.translate.instant('core.login.invalidsite'));
                });
            }
        }).finally(function () {
            modal.dismiss();
        });
        return true;
    };
    /**
     * Handle a link.
     *
     * @param {string} url URL to handle.
     * @param {string} [username] Username related with the URL. E.g. in 'http://myuser@m.com', url would be 'http://m.com' and
     *                            the username 'myuser'. Don't use it if you don't want to filter by username.
     * @param {NavController} [navCtrl] Nav Controller to use to navigate.
     * @param {boolean} [checkRoot] Whether to check if the URL is the root URL of a site.
     * @param {boolean} [openBrowserRoot] Whether to open in browser if it's root URL and it belongs to current site.
     * @return {Promise<boolean>} Promise resolved with a boolean: true if URL was treated, false otherwise.
     */
    CoreContentLinksHelperProvider.prototype.handleLink = function (url, username, navCtrl, checkRoot, openBrowserRoot) {
        var _this = this;
        var promise;
        if (checkRoot) {
            promise = this.sitesProvider.isStoredRootURL(url, username);
        }
        else {
            promise = Promise.resolve({});
        }
        return promise.then(function (data) {
            if (data.site) {
                // URL is the root of the site.
                _this.handleRootURL(data.site, openBrowserRoot);
                return true;
            }
            // Check if the link should be treated by some component/addon.
            return _this.contentLinksDelegate.getActionsFor(url, undefined, username).then(function (actions) {
                var action = _this.getFirstValidAction(actions);
                if (action) {
                    if (!_this.sitesProvider.isLoggedIn()) {
                        // No current site. Perform the action if only 1 site found, choose the site otherwise.
                        if (action.sites.length == 1) {
                            action.action(action.sites[0], navCtrl);
                        }
                        else {
                            _this.goToChooseSite(url);
                        }
                    }
                    else if (action.sites.length == 1 && action.sites[0] == _this.sitesProvider.getCurrentSiteId()) {
                        // Current site.
                        action.action(action.sites[0], navCtrl);
                    }
                    else {
                        // Not current site or more than one site. Ask for confirmation.
                        _this.domUtils.showConfirm(_this.translate.instant('core.contentlinks.confirmurlothersite')).then(function () {
                            if (action.sites.length == 1) {
                                action.action(action.sites[0], navCtrl);
                            }
                            else {
                                _this.goToChooseSite(url);
                            }
                        }).catch(function () {
                            // User canceled.
                        });
                    }
                    return true;
                }
                return false;
            }).catch(function () {
                return false;
            });
        });
    };
    /**
     * Handle a root URL of a site.
     *
     * @param {CoreSite} site Site to handle.
     * @param {boolean} [openBrowserRoot] Whether to open in browser if it's root URL and it belongs to current site.
     * @param {boolean} [checkToken] Whether to check that token is the same to verify it's current site. If false or not defined,
     *                               only the URL will be checked.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreContentLinksHelperProvider.prototype.handleRootURL = function (site, openBrowserRoot, checkToken) {
        var currentSite = this.sitesProvider.getCurrentSite();
        if (currentSite && currentSite.getURL() == site.getURL() && (!checkToken || currentSite.getToken() == site.getToken())) {
            // Already logged in.
            if (openBrowserRoot) {
                return site.openInBrowserWithAutoLogin(site.getURL());
            }
            return Promise.resolve();
        }
        else {
            // Login in the site.
            return this.loginHelper.redirect('', {}, site.getId());
        }
    };
    CoreContentLinksHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_11__core_login_providers_helper__["a" /* CoreLoginHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_12__delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__providers_init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_15__core_siteplugins_providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"], __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreContentLinksHelperProvider);
    return CoreContentLinksHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 20 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_file_helper__ = __webpack_require__(252);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_sitehome_providers_sitehome__ = __webpack_require__(171);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__course_offline__ = __webpack_require__(253);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_21_moment__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






















/**
 * Helper to gather some common course functions.
 */
var CoreCourseHelperProvider = /** @class */ (function () {
    function CoreCourseHelperProvider(courseProvider, domUtils, moduleDelegate, prefetchDelegate, filepoolProvider, sitesProvider, textUtils, timeUtils, utils, translate, loginHelper, courseOptionsDelegate, siteHomeProvider, eventsProvider, fileHelper, appProvider, fileProvider, injector, coursesProvider, courseOffline) {
        this.courseProvider = courseProvider;
        this.domUtils = domUtils;
        this.moduleDelegate = moduleDelegate;
        this.prefetchDelegate = prefetchDelegate;
        this.filepoolProvider = filepoolProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.timeUtils = timeUtils;
        this.utils = utils;
        this.translate = translate;
        this.loginHelper = loginHelper;
        this.courseOptionsDelegate = courseOptionsDelegate;
        this.siteHomeProvider = siteHomeProvider;
        this.eventsProvider = eventsProvider;
        this.fileHelper = fileHelper;
        this.appProvider = appProvider;
        this.fileProvider = fileProvider;
        this.injector = injector;
        this.coursesProvider = coursesProvider;
        this.courseOffline = courseOffline;
        this.courseDwnPromises = {};
    }
    /**
     * This function treats every module on the sections provided to load the handler data, treat completion
     * and navigate to a module page if required. It also returns if sections has content.
     *
     * @param {any[]} sections List of sections to treat modules.
     * @param {number} courseId Course ID of the modules.
     * @param {any[]} [completionStatus] List of completion status.
     * @param {string} [courseName] Course name. Recommended if completionStatus is supplied.
     * @return {boolean} Whether the sections have content.
     */
    CoreCourseHelperProvider.prototype.addHandlerDataForModules = function (sections, courseId, completionStatus, courseName) {
        var _this = this;
        var hasContent = false;
        sections.forEach(function (section) {
            if (!section || !_this.sectionHasContent(section) || !section.modules) {
                return;
            }
            hasContent = true;
            section.modules.forEach(function (module) {
                module.handlerData = _this.moduleDelegate.getModuleDataFor(module.modname, module, courseId, section.id);
                if (module.completiondata && module.completion > 0) {
                    module.completiondata.courseId = courseId;
                    module.completiondata.courseName = courseName;
                    module.completiondata.tracking = module.completion;
                    module.completiondata.cmid = module.id;
                    // Use of completionstatus is deprecated, use completiondata instead.
                    module.completionstatus = module.completiondata;
                }
                else if (completionStatus && typeof completionStatus[module.id] != 'undefined') {
                    // Should not happen on > 3.6. Check if activity has completions and if it's marked.
                    module.completiondata = completionStatus[module.id];
                    module.completiondata.courseId = courseId;
                    module.completiondata.courseName = courseName;
                    // Use of completionstatus is deprecated, use completiondata instead.
                    module.completionstatus = module.completiondata;
                }
                // Check if the module is stealth.
                module.isStealth = module.visibleoncoursepage === 0 || (module.visible && !section.visible);
            });
        });
        return hasContent;
    };
    /**
     * Calculate the status of a section.
     *
     * @param {any} section Section to calculate its status. It can't be "All sections".
     * @param {number} courseId Course ID the section belongs to.
     * @param {boolean} [refresh] True if it shouldn't use module status cache (slower).
     * @return {Promise<any>} Promise resolved when the status is calculated.
     */
    CoreCourseHelperProvider.prototype.calculateSectionStatus = function (section, courseId, refresh) {
        var _this = this;
        if (section.id == __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
            return Promise.reject(null);
        }
        // Get the status of this section.
        return this.prefetchDelegate.getModulesStatus(section.modules, courseId, section.id, refresh, true).then(function (result) {
            // Check if it's being downloaded.
            var downloadId = _this.getSectionDownloadId(section);
            if (_this.prefetchDelegate.isBeingDownloaded(downloadId)) {
                result.status = __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING;
            }
            section.downloadStatus = result.status;
            section.canCheckUpdates = _this.prefetchDelegate.canCheckUpdates();
            // Set this section data.
            if (result.status !== __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING || !_this.prefetchDelegate.isBeingDownloaded(section.id)) {
                section.isDownloading = false;
                section.total = 0;
            }
            else {
                // Section is being downloaded.
                section.isDownloading = true;
                _this.prefetchDelegate.setOnProgress(downloadId, function (data) {
                    section.count = data.count;
                    section.total = data.total;
                });
            }
            return result;
        });
    };
    /**
     * Calculate the status of a list of sections, setting attributes to determine the icons/data to be shown.
     *
     * @param {any[]} sections Sections to calculate their status.
     * @param {number} courseId Course ID the sections belong to.
     * @param {boolean} [refresh] True if it shouldn't use module status cache (slower).
     * @return {Promise<void>} Promise resolved when the states are calculated.
     */
    CoreCourseHelperProvider.prototype.calculateSectionsStatus = function (sections, courseId, refresh) {
        var _this = this;
        var promises = [];
        var allSectionsSection, allSectionsStatus;
        sections.forEach(function (section) {
            if (section.id === __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
                // "All sections" section status is calculated using the status of the rest of sections.
                allSectionsSection = section;
                section.isCalculating = true;
            }
            else {
                section.isCalculating = true;
                promises.push(_this.calculateSectionStatus(section, courseId, refresh).then(function (result) {
                    // Calculate "All sections" status.
                    allSectionsStatus = _this.filepoolProvider.determinePackagesStatus(allSectionsStatus, result.status);
                }).finally(function () {
                    section.isCalculating = false;
                }));
            }
        });
        return Promise.all(promises).then(function () {
            if (allSectionsSection) {
                // Set "All sections" data.
                allSectionsSection.downloadStatus = allSectionsStatus;
                allSectionsSection.canCheckUpdates = _this.prefetchDelegate.canCheckUpdates();
                allSectionsSection.isDownloading = allSectionsStatus === __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING;
            }
        }).finally(function () {
            if (allSectionsSection) {
                allSectionsSection.isCalculating = false;
            }
        });
    };
    /**
     * Show a confirm and prefetch a course. It will retrieve the sections and the course options if not provided.
     * This function will set the icon to "spinner" when starting and it will also set it back to the initial icon if the
     * user cancels. All the other updates of the icon should be made when CoreEventsProvider.COURSE_STATUS_CHANGED is received.
     *
     * @param {any} data An object where to store the course icon and title: "prefetchCourseIcon", "title" and "downloadSucceeded".
     * @param {any} course Course to prefetch.
     * @param {any[]} [sections] List of course sections.
     * @param {CoreCourseOptionsHandlerToDisplay[]} courseHandlers List of course handlers.
     * @param {CoreCourseOptionsMenuHandlerToDisplay[]} menuHandlers List of course menu handlers.
     * @return {Promise<boolean>} Promise resolved when the download finishes, rejected if an error occurs or the user cancels.
     */
    CoreCourseHelperProvider.prototype.confirmAndPrefetchCourse = function (data, course, sections, courseHandlers, menuHandlers) {
        var _this = this;
        var initialIcon = data.prefetchCourseIcon, initialTitle = data.title, siteId = this.sitesProvider.getCurrentSiteId();
        var promise;
        data.downloadSucceeded = false;
        data.prefetchCourseIcon = 'spinner';
        data.title = 'core.downloading';
        // Get the sections first if needed.
        if (sections) {
            promise = Promise.resolve(sections);
        }
        else {
            promise = this.courseProvider.getSections(course.id, false, true);
        }
        return promise.then(function (sections) {
            // Confirm the download.
            return _this.confirmDownloadSizeSection(course.id, undefined, sections, true).then(function () {
                // User confirmed, get the course handlers if needed.
                var subPromises = [];
                if (!courseHandlers) {
                    subPromises.push(_this.courseOptionsDelegate.getHandlersToDisplay(_this.injector, course)
                        .then(function (cHandlers) {
                        courseHandlers = cHandlers;
                    }));
                }
                if (!menuHandlers) {
                    subPromises.push(_this.courseOptionsDelegate.getMenuHandlersToDisplay(_this.injector, course)
                        .then(function (mHandlers) {
                        menuHandlers = mHandlers;
                    }));
                }
                return Promise.all(subPromises).then(function () {
                    // Now we have all the data, download the course.
                    return _this.prefetchCourse(course, sections, courseHandlers, menuHandlers, siteId);
                }).then(function () {
                    // Download successful.
                    data.downloadSucceeded = true;
                    return true;
                });
            }, function (error) {
                // User cancelled or there was an error calculating the size.
                data.prefetchCourseIcon = initialIcon;
                data.title = initialTitle;
                return Promise.reject(error);
            });
        });
    };
    /**
     * Confirm and prefetches a list of courses.
     *
     * @param {any[]} courses List of courses to download.
     * @param {Function} [onProgress] Function to call everytime a course is downloaded.
     * @return {Promise<boolean>} Resolved when downloaded, rejected if error or canceled.
     */
    CoreCourseHelperProvider.prototype.confirmAndPrefetchCourses = function (courses, onProgress) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        // Confirm the download without checking size because it could take a while.
        return this.domUtils.showConfirm(this.translate.instant('core.areyousure')).then(function () {
            var promises = [], total = courses.length;
            var count = 0;
            courses.forEach(function (course) {
                var subPromises = [];
                var sections, handlers, menuHandlers, success = true;
                // Get the sections and the handlers.
                subPromises.push(_this.courseProvider.getSections(course.id, false, true).then(function (courseSections) {
                    sections = courseSections;
                }));
                subPromises.push(_this.courseOptionsDelegate.getHandlersToDisplay(_this.injector, course).then(function (cHandlers) {
                    handlers = cHandlers;
                }));
                subPromises.push(_this.courseOptionsDelegate.getMenuHandlersToDisplay(_this.injector, course).then(function (mHandlers) {
                    menuHandlers = mHandlers;
                }));
                promises.push(Promise.all(subPromises).then(function () {
                    return _this.prefetchCourse(course, sections, handlers, menuHandlers, siteId);
                }).catch(function (error) {
                    success = false;
                    return Promise.reject(error);
                }).finally(function () {
                    // Course downloaded or failed, notify the progress.
                    count++;
                    if (onProgress) {
                        onProgress({ count: count, total: total, courseId: course.id, success: success });
                    }
                }));
            });
            if (onProgress) {
                // Notify the start of the download.
                onProgress({ count: 0, total: total, success: true });
            }
            return _this.utils.allPromises(promises);
        });
    };
    /**
     * Show confirmation dialog and then remove a module files.
     *
     * @param {any} module Module to remove the files.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.confirmAndRemoveFiles = function (module, courseId) {
        var _this = this;
        return this.domUtils.showConfirm(this.translate.instant('core.course.confirmdeletemodulefiles')).then(function () {
            return _this.prefetchDelegate.removeModuleFiles(module, courseId);
        }).catch(function (error) {
            if (error) {
                _this.domUtils.showErrorModal(error);
            }
        });
    };
    /**
     * Calculate the size to download a section and show a confirm modal if needed.
     *
     * @param {number} courseId Course ID the section belongs to.
     * @param {any} [section] Section. If not provided, all sections.
     * @param {any[]} [sections] List of sections. Used when downloading all the sections.
     * @param {boolean} [alwaysConfirm] True to show a confirm even if the size isn't high, false otherwise.
     * @return {Promise<any>} Promise resolved if the user confirms or there's no need to confirm.
     */
    CoreCourseHelperProvider.prototype.confirmDownloadSizeSection = function (courseId, section, sections, alwaysConfirm) {
        var _this = this;
        var sizePromise, haveEmbeddedFiles = false;
        // Calculate the size of the download.
        if (section && section.id != __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
            sizePromise = this.prefetchDelegate.getDownloadSize(section.modules, courseId);
            // Check if the section has embedded files in the description.
            haveEmbeddedFiles = this.domUtils.extractDownloadableFilesFromHtml(section.summary).length > 0;
        }
        else {
            var promises_1 = [], results_1 = {
                size: 0,
                total: true
            };
            sections.forEach(function (s) {
                if (s.id != __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
                    promises_1.push(_this.prefetchDelegate.getDownloadSize(s.modules, courseId).then(function (sectionSize) {
                        results_1.total = results_1.total && sectionSize.total;
                        results_1.size += sectionSize.size;
                    }));
                    // Check if the section has embedded files in the description.
                    if (!haveEmbeddedFiles && _this.domUtils.extractDownloadableFilesFromHtml(s.summary).length > 0) {
                        haveEmbeddedFiles = true;
                    }
                }
            });
            sizePromise = Promise.all(promises_1).then(function () {
                return results_1;
            });
        }
        return sizePromise.then(function (size) {
            if (haveEmbeddedFiles) {
                size.total = false;
            }
            // Show confirm modal if needed.
            return _this.domUtils.confirmDownloadSize(size, undefined, undefined, undefined, undefined, alwaysConfirm);
        });
    };
    /**
     * Helper function to prefetch a module, showing a confirmation modal if the size is big.
     * This function is meant to be called from a context menu option. It will also modify some data like the prefetch icon.
     *
     * @param {any} instance The component instance that has the context menu. It should have prefetchStatusIcon and isDestroyed.
     * @param {any} module Module to be prefetched
     * @param {number} courseId Course ID the module belongs to.
     * @param {Function} [done] Function to call when done. It will close the context menu.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.contextMenuPrefetch = function (instance, module, courseId, done) {
        var _this = this;
        var initialIcon = instance.prefetchStatusIcon;
        instance.prefetchStatusIcon = 'spinner'; // Show spinner since this operation might take a while.
        // We need to call getDownloadSize, the package might have been updated.
        return this.prefetchDelegate.getModuleDownloadSize(module, courseId, true).then(function (size) {
            return _this.domUtils.confirmDownloadSize(size).then(function () {
                return _this.prefetchDelegate.prefetchModule(module, courseId, true);
            });
        }).then(function () {
            // Success, close menu.
            done && done();
        }).catch(function (error) {
            instance.prefetchStatusIcon = initialIcon;
            if (!instance.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
            }
        });
    };
    /**
     * Determine the status of a list of courses.
     *
     * @param {any[]} courses Courses
     * @return {Promise<string>} Promise resolved with the status.
     */
    CoreCourseHelperProvider.prototype.determineCoursesStatus = function (courses) {
        var _this = this;
        // Get the status of each course.
        var promises = [], siteId = this.sitesProvider.getCurrentSiteId();
        courses.forEach(function (course) {
            promises.push(_this.courseProvider.getCourseStatus(course.id, siteId));
        });
        return Promise.all(promises).then(function (statuses) {
            // Now determine the status of the whole list.
            var status = statuses[0];
            for (var i = 1; i < statuses.length; i++) {
                status = _this.filepoolProvider.determinePackagesStatus(status, statuses[i]);
            }
            return status;
        });
    };
    /**
     * Convenience function to open a module main file, downloading the package if needed.
     * This is meant for modules like mod_resource.
     *
     * @param {any} module The module to download.
     * @param {number} courseId The course ID of the module.
     * @param {string} [component] The component to link the files to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {any[]} [files] List of files of the module. If not provided, use module.contents.
     * @param {string} [siteId] The site ID. If not defined, current site.
     * @return {Promise<any>} Resolved on success.
     */
    CoreCourseHelperProvider.prototype.downloadModuleAndOpenFile = function (module, courseId, component, componentId, files, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promise;
        if (files) {
            promise = Promise.resolve(files);
        }
        else {
            promise = this.courseProvider.loadModuleContents(module, courseId).then(function () {
                files = module.contents;
            });
        }
        // Make sure that module contents are loaded.
        return promise.then(function () {
            if (!files || !files.length) {
                return Promise.reject(_this.utils.createFakeWSError('core.filenotfound', true));
            }
            return _this.sitesProvider.getSite(siteId);
        }).then(function (site) {
            var mainFile = files[0], fileUrl = _this.fileHelper.getFileUrl(mainFile);
            // Check if the file should be opened in browser.
            if (_this.fileHelper.shouldOpenInBrowser(mainFile)) {
                if (_this.appProvider.isOnline()) {
                    // Open in browser.
                    var fixedUrl = site.fixPluginfileURL(fileUrl).replace('&offline=1', '');
                    // Remove forcedownload when followed by another param.
                    fixedUrl = fixedUrl.replace(/forcedownload=\d+&/, '');
                    // Remove forcedownload when not followed by any param.
                    fixedUrl = fixedUrl.replace(/[\?|\&]forcedownload=\d+/, '');
                    _this.utils.openInBrowser(fixedUrl);
                    if (_this.fileProvider.isAvailable()) {
                        // Download the file if needed (file outdated or not downloaded).
                        // Download will be in background, don't return the promise.
                        _this.downloadModule(module, courseId, component, componentId, files, siteId);
                    }
                    return;
                }
                else {
                    // Not online, get the offline file. It will fail if not found.
                    return _this.filepoolProvider.getInternalUrlByUrl(siteId, fileUrl).then(function (path) {
                        return _this.utils.openFile(path);
                    }).catch(function (error) {
                        return Promise.reject(_this.translate.instant('core.networkerrormsg'));
                    });
                }
            }
            // File shouldn't be opened in browser. Download the module if it needs to be downloaded.
            return _this.downloadModuleWithMainFileIfNeeded(module, courseId, component, componentId, files, siteId)
                .then(function (result) {
                if (result.path.indexOf('http') === 0) {
                    /* In iOS, if we use the same URL in embedded browser and background download then the download only
                       downloads a few bytes (cached ones). Add a hash to the URL so both URLs are different. */
                    result.path = result.path + '#moodlemobile-embedded';
                    return _this.utils.openOnlineFile(result.path).catch(function (error) {
                        // Error opening the file, some apps don't allow opening online files.
                        if (!_this.fileProvider.isAvailable()) {
                            return Promise.reject(error);
                        }
                        else if (result.status === __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
                            return Promise.reject(_this.translate.instant('core.erroropenfiledownloading'));
                        }
                        var promise;
                        if (result.status === __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
                            // Not downloaded, download it now and return the local file.
                            promise = _this.downloadModule(module, courseId, component, componentId, files, siteId).then(function () {
                                return _this.filepoolProvider.getInternalUrlByUrl(siteId, fileUrl);
                            });
                        }
                        else {
                            // File is outdated or stale and can't be opened in online, return the local URL.
                            promise = _this.filepoolProvider.getInternalUrlByUrl(siteId, fileUrl);
                        }
                        return promise.then(function (path) {
                            return _this.utils.openFile(path);
                        });
                    });
                }
                else {
                    return _this.utils.openFile(result.path);
                }
            });
        });
    };
    /**
     * Convenience function to download a module that has a main file and return the local file's path and other info.
     * This is meant for modules like mod_resource.
     *
     * @param {any} module The module to download.
     * @param {number} courseId The course ID of the module.
     * @param {string} [component] The component to link the files to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {any[]} [files] List of files of the module. If not provided, use module.contents.
     * @param {string} [siteId] The site ID. If not defined, current site.
     * @return {Promise<{fixedUrl: string, path: string, status: string}>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.downloadModuleWithMainFileIfNeeded = function (module, courseId, component, componentId, files, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!files || !files.length) {
            // Module not valid, stop.
            return Promise.reject(null);
        }
        var mainFile = files[0], fileUrl = this.fileHelper.getFileUrl(mainFile), timemodified = this.fileHelper.getFileTimemodified(mainFile), result = {
            fixedUrl: undefined,
            path: undefined,
            status: undefined
        };
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var fixedUrl = site.fixPluginfileURL(fileUrl);
            result.fixedUrl = fixedUrl;
            if (_this.fileProvider.isAvailable()) {
                // The file system is available.
                return _this.filepoolProvider.getPackageStatus(siteId, component, componentId).then(function (status) {
                    result.status = status;
                    var isWifi = _this.appProvider.isWifi(), isOnline = _this.appProvider.isOnline();
                    if (status === __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADED) {
                        // Get the local file URL.
                        return _this.filepoolProvider.getInternalUrlByUrl(siteId, fileUrl).catch(function (error) {
                            // File not found, mark the module as not downloaded and reject.
                            return _this.filepoolProvider.storePackageStatus(siteId, __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED, component, componentId).then(function () {
                                return Promise.reject(error);
                            });
                        });
                    }
                    else if (status === __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING && !_this.appProvider.isDesktop()) {
                        // Return the online URL.
                        return fixedUrl;
                    }
                    else {
                        if (!isOnline && status === __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
                            // Not downloaded and we're offline, reject.
                            return Promise.reject(_this.translate.instant('core.networkerrormsg'));
                        }
                        return _this.filepoolProvider.shouldDownloadBeforeOpen(fixedUrl, mainFile.filesize).then(function () {
                            // Download and then return the local URL.
                            return _this.downloadModule(module, courseId, component, componentId, files, siteId).then(function () {
                                return _this.filepoolProvider.getInternalUrlByUrl(siteId, fileUrl);
                            });
                        }, function () {
                            // Start the download if in wifi, but return the URL right away so the file is opened.
                            if (isWifi) {
                                _this.downloadModule(module, courseId, component, componentId, files, siteId);
                            }
                            if (!_this.fileHelper.isStateDownloaded(status) || isOnline) {
                                // Not downloaded or online, return the online URL.
                                return fixedUrl;
                            }
                            else {
                                // Outdated but offline, so we return the local URL. Use getUrlByUrl so it's added to the queue.
                                return _this.filepoolProvider.getUrlByUrl(siteId, fileUrl, component, componentId, timemodified, false, false, mainFile);
                            }
                        });
                    }
                }).then(function (path) {
                    result.path = path;
                    return result;
                });
            }
            else {
                // We use the live URL.
                result.path = fixedUrl;
                return result;
            }
        });
    };
    /**
     * Convenience function to download a module.
     *
     * @param {any} module The module to download.
     * @param {number} courseId The course ID of the module.
     * @param {string} [component] The component to link the files to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {any[]} [files] List of files of the module. If not provided, use module.contents.
     * @param {string} [siteId] The site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.downloadModule = function (module, courseId, component, componentId, files, siteId) {
        var prefetchHandler = this.prefetchDelegate.getPrefetchHandlerFor(module);
        if (prefetchHandler) {
            // Use the prefetch handler to download the module.
            if (prefetchHandler.download) {
                return prefetchHandler.download(module, courseId);
            }
            else {
                return prefetchHandler.prefetch(module, courseId, true);
            }
        }
        // There's no prefetch handler for the module, just download the files.
        files = files || module.contents;
        return this.filepoolProvider.downloadOrPrefetchFiles(siteId, files, false, false, component, componentId);
    };
    /**
     * Fill the Context Menu for a certain module.
     *
     * @param {any} instance The component instance that has the context menu.
     * @param {any} module Module to be prefetched
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [invalidateCache] Invalidates the cache first.
     * @param {string} [component] Component of the module.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.fillContextMenu = function (instance, module, courseId, invalidateCache, component) {
        var _this = this;
        return this.getModulePrefetchInfo(module, courseId, invalidateCache, component).then(function (moduleInfo) {
            instance.size = moduleInfo.size > 0 ? moduleInfo.sizeReadable : 0;
            instance.prefetchStatusIcon = moduleInfo.statusIcon;
            instance.prefetchStatus = moduleInfo.status;
            if (moduleInfo.status != __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE) {
                // Module is downloadable, get the text to display to prefetch.
                if (moduleInfo.downloadTime > 0) {
                    instance.prefetchText = _this.translate.instant('core.lastdownloaded') + ': ' + moduleInfo.downloadTimeReadable;
                }
                else {
                    // Module not downloaded, show a default text.
                    instance.prefetchText = _this.translate.instant('core.download');
                }
            }
            if (typeof instance.contextMenuStatusObserver == 'undefined' && component) {
                instance.contextMenuStatusObserver = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].PACKAGE_STATUS_CHANGED, function (data) {
                    if (data.componentId == module.id && data.component == component) {
                        _this.fillContextMenu(instance, module, courseId, false, component);
                    }
                }, _this.sitesProvider.getCurrentSiteId());
            }
        });
    };
    /**
     * Get a course. It will first check the user courses, and fallback to another WS if not enrolled.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{enrolled: boolean, course: any}>} Promise resolved with the course.
     */
    CoreCourseHelperProvider.prototype.getCourse = function (courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Try with enrolled courses first.
        return this.coursesProvider.getUserCourse(courseId, false, siteId).then(function (course) {
            return { enrolled: true, course: course };
        }).catch(function () {
            // Not enrolled or an error happened. Try to use another WebService.
            return _this.coursesProvider.isGetCoursesByFieldAvailableInSite(siteId).then(function (available) {
                if (available) {
                    return _this.coursesProvider.getCourseByField('id', courseId, siteId);
                }
                else {
                    return _this.coursesProvider.getCourse(courseId, siteId);
                }
            }).then(function (course) {
                return { enrolled: false, course: course };
            });
        });
    };
    /**
     * Get a course, wait for any course format plugin to load, and open the course page. It basically chains the functions
     * getCourse and openCourse.
     *
     * @param {NavController} navCtrl The nav controller to use. If not defined, the course will be opened in main menu.
     * @param {number} courseId Course ID.
     * @param {any} [params] Other params to pass to the course page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreCourseHelperProvider.prototype.getAndOpenCourse = function (navCtrl, courseId, params, siteId) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        return this.getCourse(courseId, siteId).then(function (data) {
            return data.course;
        }).catch(function () {
            // Cannot get course, return a "fake".
            return { id: courseId };
        }).then(function (course) {
            modal.dismiss();
            return _this.openCourse(navCtrl, course, params, siteId);
        });
    };
    /**
     * Check if the course has a block with that name.
     *
     * @param {number} courseId Course ID.
     * @param {string} name     Block name to search.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if the block exists or false otherwise.
     * @since 3.3
     */
    CoreCourseHelperProvider.prototype.hasABlockNamed = function (courseId, name, siteId) {
        return this.courseProvider.getCourseBlocks(courseId, siteId).then(function (blocks) {
            return blocks.some(function (block) {
                return block.name == name;
            });
        }).catch(function () {
            return false;
        });
    };
    /**
     * Initialize the prefetch icon for selected courses.
     *
     * @param  {any[]}        courses  Courses array to get info from.
     * @param  {any}          prefetch Prefetch information.
     * @param  {number}       [minCourses=2] Min course to show icon.
     * @return {Promise<any>}          Resolved with the prefetch information updated when done.
     */
    CoreCourseHelperProvider.prototype.initPrefetchCoursesIcons = function (courses, prefetch, minCourses) {
        var _this = this;
        if (minCourses === void 0) { minCourses = 2; }
        if (!courses || courses.length < minCourses) {
            // Not enough courses.
            prefetch.icon = '';
            return Promise.resolve(prefetch);
        }
        return this.determineCoursesStatus(courses).then(function (status) {
            var icon = _this.getCourseStatusIconAndTitleFromStatus(status).icon;
            if (icon == 'spinner') {
                // It seems all courses are being downloaded, show a download button instead.
                icon = 'cloud-download';
            }
            prefetch.icon = icon;
            return prefetch;
        });
    };
    /**
     * Load offline completion into a list of sections.
     * This should be used in 3.6 sites or higher, where the course contents already include the completion.
     *
     * @param {number} courseId The course to get the completion.
     * @param {any[]} sections List of sections of the course.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.loadOfflineCompletion = function (courseId, sections, siteId) {
        var _this = this;
        return this.courseOffline.getCourseManualCompletions(courseId, siteId).then(function (offlineCompletions) {
            if (!offlineCompletions || !offlineCompletions.length) {
                // No offline completion.
                return;
            }
            var totalOffline = offlineCompletions.length;
            var loaded = 0;
            offlineCompletions = _this.utils.arrayToObject(offlineCompletions, 'cmid');
            // Load the offline data in the modules.
            for (var i = 0; i < sections.length; i++) {
                var section = sections[i];
                if (!section.modules || !section.modules.length) {
                    // Section has no modules, ignore it.
                    continue;
                }
                for (var j = 0; j < section.modules.length; j++) {
                    var module_1 = section.modules[j], offlineCompletion = offlineCompletions[module_1.id];
                    if (offlineCompletion && typeof module_1.completiondata != 'undefined' &&
                        offlineCompletion.timecompleted >= module_1.completiondata.timecompleted * 1000) {
                        // The module has offline completion. Load it.
                        module_1.completiondata.state = offlineCompletion.completed;
                        module_1.completiondata.offline = true;
                        // If all completions have been loaded, stop.
                        loaded++;
                        if (loaded == totalOffline) {
                            break;
                        }
                    }
                }
            }
        });
    };
    /**
     * Prefetch all the courses in the array.
     *
     * @param  {any[]}        courses  Courses array to prefetch.
     * @param  {any}          prefetch Prefetch information to be updated.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.prefetchCourses = function (courses, prefetch) {
        prefetch.icon = 'spinner';
        prefetch.badge = '';
        return this.confirmAndPrefetchCourses(courses, function (progress) {
            prefetch.badge = progress.count + ' / ' + progress.total;
        }).then(function () {
            prefetch.icon = 'refresh';
        }).finally(function () {
            prefetch.badge = '';
        });
    };
    /**
     * Get a course download promise (if any).
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Download promise, undefined if not found.
     */
    CoreCourseHelperProvider.prototype.getCourseDownloadPromise = function (courseId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.courseDwnPromises[siteId] && this.courseDwnPromises[siteId][courseId];
    };
    /**
     * Get a course status icon and the langkey to use as a title.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{icon: string, title: string}>} Promise resolved with the icon name and the title key.
     */
    CoreCourseHelperProvider.prototype.getCourseStatusIconAndTitle = function (courseId, siteId) {
        var _this = this;
        return this.courseProvider.getCourseStatus(courseId, siteId).then(function (status) {
            return _this.getCourseStatusIconAndTitleFromStatus(status);
        });
    };
    /**
     * Get a course status icon and the langkey to use as a title from status.
     *
     * @param {string} status Course status.
     * @return {{icon: string, title: string}} Title and icon name.
     */
    CoreCourseHelperProvider.prototype.getCourseStatusIconAndTitleFromStatus = function (status) {
        if (status == __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADED) {
            // Always show refresh icon, we cannot know if there's anything new in course options.
            return {
                icon: 'refresh',
                title: 'core.course.refreshcourse'
            };
        }
        else if (status == __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
            return {
                icon: 'spinner',
                title: 'core.downloading'
            };
        }
        else {
            return {
                icon: 'cloud-download',
                title: 'core.course.downloadcourse'
            };
        }
    };
    /**
     * Get the course ID from a module instance ID, showing an error message if it can't be retrieved.
     *
     * @param {number} id Instance ID.
     * @param {string} module Name of the module. E.g. 'glossary'.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the module's course ID.
     */
    CoreCourseHelperProvider.prototype.getModuleCourseIdByInstance = function (id, module, siteId) {
        var _this = this;
        return this.courseProvider.getModuleBasicInfoByInstance(id, module, siteId).then(function (cm) {
            return cm.course;
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.course.errorgetmodule', true);
            return Promise.reject(null);
        });
    };
    /**
     * Get prefetch info for a module.
     *
     * @param {any} module Module to get the info from.
     * @param {number} courseId Course ID the section belongs to.
     * @param {boolean} [invalidateCache] Invalidates the cache first.
     * @param {string} [component] Component of the module.
     * @return {Promise<CoreCourseModulePrefetchInfo>} Promise resolved with the info.
     */
    CoreCourseHelperProvider.prototype.getModulePrefetchInfo = function (module, courseId, invalidateCache, component) {
        var _this = this;
        var moduleInfo = {}, siteId = this.sitesProvider.getCurrentSiteId(), promises = [];
        if (invalidateCache) {
            this.prefetchDelegate.invalidateModuleStatusCache(module);
        }
        promises.push(this.prefetchDelegate.getModuleDownloadedSize(module, courseId).then(function (moduleSize) {
            moduleInfo.size = moduleSize;
            moduleInfo.sizeReadable = _this.textUtils.bytesToSize(moduleSize, 2);
        }));
        promises.push(this.prefetchDelegate.getModuleStatus(module, courseId).then(function (moduleStatus) {
            moduleInfo.status = moduleStatus;
            switch (moduleStatus) {
                case __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED:
                    moduleInfo.statusIcon = 'cloud-download';
                    break;
                case __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING:
                    moduleInfo.statusIcon = 'spinner';
                    break;
                case __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].OUTDATED:
                    moduleInfo.statusIcon = 'refresh';
                    break;
                case __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADED:
                    if (!_this.prefetchDelegate.canCheckUpdates()) {
                        moduleInfo.statusIcon = 'refresh';
                        break;
                    }
                default:
                    moduleInfo.statusIcon = '';
                    break;
            }
        }));
        // Get the time it was downloaded (if it was downloaded).
        promises.push(this.filepoolProvider.getPackageData(siteId, component, module.id).then(function (data) {
            if (data && data.downloadTime && (data.status == __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].OUTDATED || data.status == __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADED)) {
                var now = _this.timeUtils.timestamp();
                moduleInfo.downloadTime = data.downloadTime;
                if (now - data.downloadTime < 7 * 86400) {
                    moduleInfo.downloadTimeReadable = __WEBPACK_IMPORTED_MODULE_21_moment__(data.downloadTime * 1000).fromNow();
                }
                else {
                    moduleInfo.downloadTimeReadable = __WEBPACK_IMPORTED_MODULE_21_moment__(data.downloadTime * 1000).calendar();
                }
            }
        }).catch(function () {
            // Not downloaded.
            moduleInfo.downloadTime = 0;
        }));
        return Promise.all(promises).then(function () {
            return moduleInfo;
        });
    };
    /**
     * Get the download ID of a section. It's used to interact with CoreCourseModulePrefetchDelegate.
     *
     * @param {any} section Section.
     * @return {string} Section download ID.
     */
    CoreCourseHelperProvider.prototype.getSectionDownloadId = function (section) {
        return 'Section-' + section.id;
    };
    /**
     * Navigate to a module.
     *
     * @param {number} moduleId Module's ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [courseId] Course ID. If not defined we'll try to retrieve it from the site.
     * @param {number} [sectionId] Section the module belongs to. If not defined we'll try to retrieve it from the site.
     * @param {string} [modName] If set, the app will retrieve all modules of this type with a single WS call. This reduces the
     *                           number of WS calls, but it isn't recommended for modules that can return a lot of contents.
     * @param {any} [modParams] Params to pass to the module
     * @return {Promise<void>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.navigateToModule = function (moduleId, siteId, courseId, sectionId, modName, modParams) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var modal = this.domUtils.showModalLoading();
        var promise, site;
        if (courseId && sectionId) {
            // No need to retrieve more data.
            promise = Promise.resolve();
        }
        else if (!courseId) {
            // We don't have courseId.
            promise = this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
                courseId = module.course;
                sectionId = module.section;
            });
        }
        else {
            // We don't have sectionId but we have courseId.
            promise = this.courseProvider.getModuleSectionId(moduleId, siteId).then(function (id) {
                sectionId = id;
            });
        }
        return promise.then(function () {
            // Make sure they're numbers.
            courseId = Number(courseId);
            sectionId = Number(sectionId);
            // Get the site.
            return _this.sitesProvider.getSite(siteId);
        }).then(function (s) {
            site = s;
            // Get the module.
            return _this.courseProvider.getModule(moduleId, courseId, sectionId, false, false, siteId, modName);
        }).then(function (module) {
            var params = {
                course: { id: courseId },
                module: module,
                sectionId: sectionId,
                modParams: modParams
            };
            module.handlerData = _this.moduleDelegate.getModuleDataFor(module.modname, module, courseId, sectionId);
            if (courseId == site.getSiteHomeId()) {
                // Check if site home is available.
                return _this.siteHomeProvider.isAvailable().then(function () {
                    _this.loginHelper.redirect('CoreSiteHomeIndexPage', params, siteId);
                }).finally(function () {
                    modal.dismiss();
                });
            }
            else {
                modal.dismiss();
                return _this.getAndOpenCourse(undefined, courseId, params, siteId);
            }
        }).catch(function (error) {
            modal.dismiss();
            _this.domUtils.showErrorModalDefault(error, 'core.course.errorgetmodule', true);
        });
    };
    /**
     * Open a module.
     *
     * @param {NavController} navCtrl The NavController to use.
     * @param {any} module The module to open.
     * @param {number} courseId The course ID of the module.
     * @param {number} [sectionId] The section ID of the module.
     * @param {any} [modParams] Params to pass to the module
     * @param {boolean} True if module can be opened, false otherwise.
     */
    CoreCourseHelperProvider.prototype.openModule = function (navCtrl, module, courseId, sectionId, modParams) {
        if (!module.handlerData) {
            module.handlerData = this.moduleDelegate.getModuleDataFor(module.modname, module, courseId, sectionId);
        }
        if (module.handlerData && module.handlerData.action) {
            module.handlerData.action(new Event('click'), navCtrl, module, courseId, { animate: false }, modParams);
            return true;
        }
        return false;
    };
    /**
     * Prefetch all the activities in a course and also the course addons.
     *
     * @param {any} course The course to prefetch.
     * @param {any[]} sections List of course sections.
     * @param {CoreCourseOptionsHandlerToDisplay[]} courseHandlers List of course options handlers.
     * @param {CoreCourseOptionsMenuHandlerToDisplay[]} courseMenuHandlers List of course menu handlers.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise}                Promise resolved when the download finishes.
     */
    CoreCourseHelperProvider.prototype.prefetchCourse = function (course, sections, courseHandlers, courseMenuHandlers, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.courseDwnPromises[siteId] && this.courseDwnPromises[siteId][course.id]) {
            // There's already a download ongoing for this course, return the promise.
            return this.courseDwnPromises[siteId][course.id];
        }
        else if (!this.courseDwnPromises[siteId]) {
            this.courseDwnPromises[siteId] = {};
        }
        // First of all, mark the course as being downloaded.
        this.courseDwnPromises[siteId][course.id] = this.courseProvider.setCourseStatus(course.id, __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING, siteId).then(function () {
            var promises = [];
            var allSectionsSection = sections[0];
            // Prefetch all the sections. If the first section is "All sections", use it. Otherwise, use a fake "All sections".
            if (sections[0].id != __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
                allSectionsSection = { id: __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID };
            }
            promises.push(_this.prefetchSection(allSectionsSection, course.id, sections));
            // Prefetch course options.
            courseHandlers.forEach(function (handler) {
                if (handler.prefetch) {
                    promises.push(handler.prefetch(course));
                }
            });
            courseMenuHandlers.forEach(function (handler) {
                if (handler.prefetch) {
                    promises.push(handler.prefetch(course));
                }
            });
            // Prefetch other data needed to render the course.
            if (_this.coursesProvider.isGetCoursesByFieldAvailable()) {
                promises.push(_this.coursesProvider.getCoursesByField('id', course.id));
            }
            var sectionWithModules = sections.find(function (section) {
                return section.modules && section.modules.length > 0;
            });
            if (!sectionWithModules || typeof sectionWithModules.modules[0].completion == 'undefined') {
                promises.push(_this.courseProvider.getActivitiesCompletionStatus(course.id));
            }
            return _this.utils.allPromises(promises);
        }).then(function () {
            // Download success, mark the course as downloaded.
            return _this.courseProvider.setCourseStatus(course.id, __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADED, siteId);
        }).catch(function (error) {
            // Error, restore previous status.
            return _this.courseProvider.setCoursePreviousStatus(course.id, siteId).then(function () {
                return Promise.reject(error);
            });
        }).finally(function () {
            delete _this.courseDwnPromises[siteId][course.id];
        });
        return this.courseDwnPromises[siteId][course.id];
    };
    /**
     * Helper function to prefetch a module, showing a confirmation modal if the size is big
     * and invalidating contents if refreshing.
     *
     * @param {handler} handler Prefetch handler to use. Must implement 'prefetch' and 'invalidateContent'.
     * @param {any} module Module to download.
     * @param {any} size Object containing size to download (in bytes) and a boolean to indicate if its totally calculated.
     * @param {number} courseId Course ID of the module.
     * @param {boolean} [refresh] True if refreshing, false otherwise.
     * @return {Promise<any>} Promise resolved when downloaded.
     */
    CoreCourseHelperProvider.prototype.prefetchModule = function (handler, module, size, courseId, refresh) {
        var _this = this;
        // Show confirmation if needed.
        return this.domUtils.confirmDownloadSize(size).then(function () {
            // Invalidate content if refreshing and download the data.
            var promise = refresh ? handler.invalidateContent(module.id, courseId) : Promise.resolve();
            return promise.catch(function () {
                // Ignore errors.
            }).then(function () {
                return _this.prefetchDelegate.prefetchModule(module, courseId, true);
            });
        });
    };
    /**
     * Prefetch one section or all the sections.
     * If the section is "All sections" it will prefetch all the sections.
     *
     * @param {any} section Section.
     * @param {number} courseId Course ID the section belongs to.
     * @param {any[]} [sections] List of sections. Used when downloading all the sections.
     * @return {Promise<any>} Promise resolved when the prefetch is finished.
     */
    CoreCourseHelperProvider.prototype.prefetchSection = function (section, courseId, sections) {
        var _this = this;
        if (section.id != __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
            // Download only this section.
            return this.prefetchSingleSectionIfNeeded(section, courseId).finally(function () {
                // Calculate the status of the section that finished.
                return _this.calculateSectionStatus(section, courseId);
            });
        }
        else {
            // Download all the sections except "All sections".
            var promises_2 = [];
            var allSectionsStatus_1;
            section.isDownloading = true;
            sections.forEach(function (section) {
                if (section.id != __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
                    promises_2.push(_this.prefetchSingleSectionIfNeeded(section, courseId).finally(function () {
                        // Calculate the status of the section that finished.
                        return _this.calculateSectionStatus(section, courseId).then(function (result) {
                            // Calculate "All sections" status.
                            allSectionsStatus_1 = _this.filepoolProvider.determinePackagesStatus(allSectionsStatus_1, result.status);
                        });
                    }));
                }
            });
            return this.utils.allPromises(promises_2).then(function () {
                // Set "All sections" data.
                section.downloadStatus = allSectionsStatus_1;
                section.canCheckUpdates = _this.prefetchDelegate.canCheckUpdates();
                section.isDownloading = allSectionsStatus_1 === __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING;
            }).finally(function () {
                section.isDownloading = false;
            });
        }
    };
    /**
     * Prefetch a certain section if it needs to be prefetched.
     * If the section is "All sections" it will be ignored.
     *
     * @param {any} section Section to prefetch.
     * @param {number} courseId Course ID the section belongs to.
     * @return {Promise<any>} Promise resolved when the section is prefetched.
     */
    CoreCourseHelperProvider.prototype.prefetchSingleSectionIfNeeded = function (section, courseId) {
        var _this = this;
        if (section.id == __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
            return Promise.resolve();
        }
        if (section.hiddenbynumsections) {
            // Hidden section.
            return Promise.resolve();
        }
        var promises = [];
        section.isDownloading = true;
        // Sync the modules first.
        promises.push(this.prefetchDelegate.syncModules(section.modules, courseId).then(function () {
            // Validate the section needs to be downloaded and calculate amount of modules that need to be downloaded.
            return _this.prefetchDelegate.getModulesStatus(section.modules, courseId, section.id).then(function (result) {
                if (result.status == __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADED || result.status == __WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE) {
                    // Section is downloaded or not downloadable, nothing to do.
                    return;
                }
                return _this.prefetchSingleSection(section, result, courseId);
            }, function (error) {
                section.isDownloading = false;
                return Promise.reject(error);
            });
        }));
        // Download the files in the section description.
        var introFiles = this.domUtils.extractDownloadableFilesFromHtmlAsFakeFileObjects(section.summary), siteId = this.sitesProvider.getCurrentSiteId();
        promises.push(this.filepoolProvider.addFilesToQueue(siteId, introFiles, __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].COMPONENT, courseId)
            .catch(function () {
            // Ignore errors.
        }));
        return Promise.all(promises);
    };
    /**
     * Start or restore the prefetch of a section.
     * If the section is "All sections" it will be ignored.
     *
     * @param {any} section Section to download.
     * @param {any} result Result of CoreCourseModulePrefetchDelegate.getModulesStatus for this section.
     * @param {number} courseId Course ID the section belongs to.
     * @return {Promise<any>} Promise resolved when the section has been prefetched.
     */
    CoreCourseHelperProvider.prototype.prefetchSingleSection = function (section, result, courseId) {
        if (section.id == __WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID) {
            return Promise.resolve();
        }
        if (section.total > 0) {
            // Already being downloaded.
            return Promise.resolve();
        }
        // We only download modules with status notdownloaded, downloading or outdated.
        var modules = result[__WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].OUTDATED].concat(result[__WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED])
            .concat(result[__WEBPACK_IMPORTED_MODULE_20__core_constants__["a" /* CoreConstants */].DOWNLOADING]), downloadId = this.getSectionDownloadId(section);
        section.isDownloading = true;
        // Prefetch all modules to prevent incoeherences in download count and to download stale data not marked as outdated.
        return this.prefetchDelegate.prefetchModules(downloadId, modules, courseId, function (data) {
            section.count = data.count;
            section.total = data.total;
        });
    };
    /**
     * Check if a section has content.
     *
     * @param {any} section Section to check.
     * @return {boolean} Whether the section has content.
     */
    CoreCourseHelperProvider.prototype.sectionHasContent = function (section) {
        if (section.hiddenbynumsections) {
            return false;
        }
        return (typeof section.availabilityinfo != 'undefined' && section.availabilityinfo != '') ||
            section.summary != '' || (section.modules && section.modules.length > 0);
    };
    /**
     * Wait for any course format plugin to load, and open the course page.
     *
     * If the plugin's promise is resolved, the course page will be opened.  If it is rejected, they will see an error.
     * If the promise for the plugin is still in progress when the user tries to open the course, a loader
     * will be displayed until it is complete, before the course page is opened.  If the promise is already complete,
     * they will see the result immediately.
     *
     * @param {NavController} navCtrl The nav controller to use. If not defined, the course will be opened in main menu.
     * @param {any} course Course to open
     * @param {any} [params] Params to pass to the course page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseHelperProvider.prototype.openCourse = function (navCtrl, course, params, siteId) {
        if (!siteId || siteId == this.sitesProvider.getCurrentSiteId()) {
            // Current site, we can open the course.
            return this.courseProvider.openCourse(navCtrl, course, params);
        }
        else {
            // We need to load the site first.
            params = params || {};
            Object.assign(params, { course: course });
            return this.loginHelper.redirect(__WEBPACK_IMPORTED_MODULE_19__core_login_providers_helper__["a" /* CoreLoginHelperProvider */].OPEN_COURSE, params, siteId);
        }
    };
    CoreCourseHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_15__course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_17__module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_18__module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
            __WEBPACK_IMPORTED_MODULE_5__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_19__core_login_providers_helper__["a" /* CoreLoginHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_12__options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_13__core_sitehome_providers_sitehome__["a" /* CoreSiteHomeProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_file_helper__["a" /* CoreFileHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_14__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_16__course_offline__["a" /* CoreCourseOfflineProvider */]])
    ], CoreCourseHelperProvider);
    return CoreCourseHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 21 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreConstants; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Static class to contain all the core constants.
 */
var CoreConstants = /** @class */ (function () {
    function CoreConstants() {
    }
    CoreConstants.SECONDS_YEAR = 31536000;
    CoreConstants.SECONDS_WEEK = 604800;
    CoreConstants.SECONDS_DAY = 86400;
    CoreConstants.SECONDS_HOUR = 3600;
    CoreConstants.SECONDS_MINUTE = 60;
    CoreConstants.WIFI_DOWNLOAD_THRESHOLD = 104857600; // 100MB.
    CoreConstants.DOWNLOAD_THRESHOLD = 10485760; // 10MB.
    CoreConstants.MINIMUM_FREE_SPACE = 10485760; // 10MB.
    CoreConstants.IOS_FREE_SPACE_THRESHOLD = 524288000; // 500MB.
    CoreConstants.DONT_SHOW_ERROR = 'CoreDontShowError';
    CoreConstants.NO_SITE_ID = 'NoSite';
    // Settings constants.
    CoreConstants.SETTINGS_RICH_TEXT_EDITOR = 'CoreSettingsRichTextEditor';
    CoreConstants.SETTINGS_NOTIFICATION_SOUND = 'CoreSettingsNotificationSound';
    CoreConstants.SETTINGS_SYNC_ONLY_ON_WIFI = 'CoreSettingsSyncOnlyOnWifi';
    CoreConstants.SETTINGS_DEBUG_DISPLAY = 'CoreSettingsDebugDisplay';
    CoreConstants.SETTINGS_REPORT_IN_BACKGROUND = 'CoreSettingsReportInBackground'; // @deprecated since 3.5.0
    CoreConstants.SETTINGS_SEND_ON_ENTER = 'CoreSettingsSendOnEnter';
    // WS constants.
    CoreConstants.WS_TIMEOUT = 30000;
    CoreConstants.WS_PREFIX = 'local_mobile_';
    // Login constants.
    CoreConstants.LOGIN_SSO_CODE = 2; // SSO in browser window is required.
    CoreConstants.LOGIN_SSO_INAPP_CODE = 3; // SSO in embedded browser is required.
    CoreConstants.LOGIN_LAUNCH_DATA = 'CoreLoginLaunchData';
    // Download status constants.
    CoreConstants.DOWNLOADED = 'downloaded';
    CoreConstants.DOWNLOADING = 'downloading';
    CoreConstants.NOT_DOWNLOADED = 'notdownloaded';
    CoreConstants.OUTDATED = 'outdated';
    CoreConstants.NOT_DOWNLOADABLE = 'notdownloadable';
    // Constants from Moodle's resourcelib.
    CoreConstants.RESOURCELIB_DISPLAY_AUTO = 0; // Try the best way.
    CoreConstants.RESOURCELIB_DISPLAY_EMBED = 1; // Display using object tag.
    CoreConstants.RESOURCELIB_DISPLAY_FRAME = 2; // Display inside frame.
    CoreConstants.RESOURCELIB_DISPLAY_NEW = 3; // Display normal link in new window.
    CoreConstants.RESOURCELIB_DISPLAY_DOWNLOAD = 4; // Force download of file instead of display.
    CoreConstants.RESOURCELIB_DISPLAY_OPEN = 5; // Open directly.
    CoreConstants.RESOURCELIB_DISPLAY_POPUP = 6; // Open in "emulated" pop-up without navigation.
    // Feature constants. Used to report features that are, or are not, supported by a module.
    CoreConstants.FEATURE_GRADE_HAS_GRADE = 'grade_has_grade'; // True if module can provide a grade.
    CoreConstants.FEATURE_GRADE_OUTCOMES = 'outcomes'; // True if module supports outcomes.
    CoreConstants.FEATURE_ADVANCED_GRADING = 'grade_advanced_grading'; // True if module supports advanced grading methods.
    CoreConstants.FEATURE_CONTROLS_GRADE_VISIBILITY = 'controlsgradevisbility'; // True if module controls grade visibility over gradebook.
    CoreConstants.FEATURE_PLAGIARISM = 'plagiarism'; // True if module supports plagiarism plugins.
    CoreConstants.FEATURE_COMPLETION_TRACKS_VIEWS = 'completion_tracks_views'; // True if module tracks whether somebody viewed it.
    CoreConstants.FEATURE_COMPLETION_HAS_RULES = 'completion_has_rules'; // True if module has custom completion rules.
    CoreConstants.FEATURE_NO_VIEW_LINK = 'viewlink'; // True if module has no 'view' page (like label).
    CoreConstants.FEATURE_IDNUMBER = 'idnumber'; // True if module wants support for setting the ID number for grade calculation purposes.
    CoreConstants.FEATURE_GROUPS = 'groups'; // True if module supports groups.
    CoreConstants.FEATURE_GROUPINGS = 'groupings'; // True if module supports groupings.
    CoreConstants.FEATURE_MOD_ARCHETYPE = 'mod_archetype'; // Type of module.
    CoreConstants.FEATURE_MOD_INTRO = 'mod_intro'; // True if module supports intro editor.
    CoreConstants.FEATURE_MODEDIT_DEFAULT_COMPLETION = 'modedit_default_completion'; // True if module has default completion.
    CoreConstants.FEATURE_COMMENT = 'comment';
    CoreConstants.FEATURE_RATE = 'rate';
    CoreConstants.FEATURE_BACKUP_MOODLE2 = 'backup_moodle2'; // True if module supports backup/restore of moodle2 format.
    CoreConstants.FEATURE_SHOW_DESCRIPTION = 'showdescription'; // True if module can show description on course main page.
    CoreConstants.FEATURE_USES_QUESTIONS = 'usesquestions'; // True if module uses the question bank.
    // Pssobile archetypes for modules.
    CoreConstants.MOD_ARCHETYPE_OTHER = 0; // Unspecified module archetype.
    CoreConstants.MOD_ARCHETYPE_RESOURCE = 1; // Resource-like type module.
    CoreConstants.MOD_ARCHETYPE_ASSIGNMENT = 2; // Assignment module archetype.
    CoreConstants.MOD_ARCHETYPE_SYSTEM = 3; // System (not user-addable) module archetype.
    return CoreConstants;
}());

//# sourceMappingURL=constants.js.map

/***/ }),
/* 22 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFilepoolProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__plugin_file_delegate__ = __webpack_require__(177);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















/*
 * Factory for handling downloading files and retrieve downloaded files.
 *
 * @description
 * This factory is responsible for handling downloading files.
 *
 * The two main goals of this is to keep the content available offline, and improve the user experience by caching
 * the content locally.
 */
var CoreFilepoolProvider = /** @class */ (function () {
    function CoreFilepoolProvider(logger, appProvider, fileProvider, sitesProvider, wsProvider, textUtils, utils, mimeUtils, urlUtils, timeUtils, eventsProvider, initDelegate, network, pluginFileDelegate, domUtils, zone) {
        var _this = this;
        this.appProvider = appProvider;
        this.fileProvider = fileProvider;
        this.sitesProvider = sitesProvider;
        this.wsProvider = wsProvider;
        this.textUtils = textUtils;
        this.utils = utils;
        this.mimeUtils = mimeUtils;
        this.urlUtils = urlUtils;
        this.timeUtils = timeUtils;
        this.eventsProvider = eventsProvider;
        this.pluginFileDelegate = pluginFileDelegate;
        this.domUtils = domUtils;
        // Constants.
        this.QUEUE_PROCESS_INTERVAL = 0;
        this.FOLDER = 'filepool';
        this.WIFI_DOWNLOAD_THRESHOLD = 20971520; // 20MB.
        this.DOWNLOAD_THRESHOLD = 2097152; // 2MB.
        this.QUEUE_RUNNING = 'CoreFilepool:QUEUE_RUNNING';
        this.QUEUE_PAUSED = 'CoreFilepool:QUEUE_PAUSED';
        this.ERR_QUEUE_IS_EMPTY = 'CoreFilepoolError:ERR_QUEUE_IS_EMPTY';
        this.ERR_FS_OR_NETWORK_UNAVAILABLE = 'CoreFilepoolError:ERR_FS_OR_NETWORK_UNAVAILABLE';
        this.ERR_QUEUE_ON_PAUSE = 'CoreFilepoolError:ERR_QUEUE_ON_PAUSE';
        // Variables for database.
        this.QUEUE_TABLE = 'filepool_files_queue'; // Queue of files to download.
        this.FILES_TABLE = 'filepool_files'; // Downloaded files.
        this.LINKS_TABLE = 'filepool_files_links'; // Links between downloaded files and components.
        this.PACKAGES_TABLE = 'filepool_packages'; // Downloaded packages (sets of files).
        this.appTablesSchema = [
            {
                name: this.QUEUE_TABLE,
                columns: [
                    {
                        name: 'siteId',
                        type: 'TEXT'
                    },
                    {
                        name: 'fileId',
                        type: 'TEXT'
                    },
                    {
                        name: 'added',
                        type: 'INTEGER'
                    },
                    {
                        name: 'priority',
                        type: 'INTEGER'
                    },
                    {
                        name: 'url',
                        type: 'TEXT'
                    },
                    {
                        name: 'revision',
                        type: 'INTEGER'
                    },
                    {
                        name: 'timemodified',
                        type: 'INTEGER'
                    },
                    {
                        name: 'isexternalfile',
                        type: 'INTEGER'
                    },
                    {
                        name: 'repositorytype',
                        type: 'TEXT'
                    },
                    {
                        name: 'path',
                        type: 'TEXT'
                    },
                    {
                        name: 'links',
                        type: 'TEXT'
                    }
                ],
                primaryKeys: ['siteId', 'fileId']
            }
        ];
        this.siteSchema = {
            name: 'CoreFilepoolProvider',
            version: 1,
            tables: [
                {
                    name: this.FILES_TABLE,
                    columns: [
                        {
                            name: 'fileId',
                            type: 'TEXT',
                            primaryKey: true
                        },
                        {
                            name: 'url',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'revision',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'stale',
                            type: 'INTEGER'
                        },
                        {
                            name: 'downloadTime',
                            type: 'INTEGER'
                        },
                        {
                            name: 'isexternalfile',
                            type: 'INTEGER'
                        },
                        {
                            name: 'repositorytype',
                            type: 'TEXT'
                        },
                        {
                            name: 'path',
                            type: 'TEXT'
                        },
                        {
                            name: 'extension',
                            type: 'TEXT'
                        }
                    ]
                },
                {
                    name: this.LINKS_TABLE,
                    columns: [
                        {
                            name: 'fileId',
                            type: 'TEXT'
                        },
                        {
                            name: 'component',
                            type: 'TEXT'
                        },
                        {
                            name: 'componentId',
                            type: 'TEXT'
                        }
                    ],
                    primaryKeys: ['fileId', 'component', 'componentId']
                },
                {
                    name: this.PACKAGES_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'TEXT',
                            primaryKey: true
                        },
                        {
                            name: 'component',
                            type: 'TEXT'
                        },
                        {
                            name: 'componentId',
                            type: 'TEXT'
                        },
                        {
                            name: 'status',
                            type: 'TEXT'
                        },
                        {
                            name: 'previous',
                            type: 'TEXT'
                        },
                        {
                            name: 'updated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'downloadTime',
                            type: 'INTEGER'
                        },
                        {
                            name: 'previousDownloadTime',
                            type: 'INTEGER'
                        },
                        {
                            name: 'extra',
                            type: 'TEXT'
                        }
                    ]
                }
            ]
        };
        this.tokenRegex = new RegExp('(\\?|&)token=([A-Za-z0-9]*)');
        this.urlAttributes = [
            this.tokenRegex,
            new RegExp('(\\?|&)forcedownload=[0-1]'),
            new RegExp('(\\?|&)preview=[A-Za-z0-9]+'),
            new RegExp('(\\?|&)offline=[0-1]', 'g')
        ];
        this.queueDeferreds = {}; // To handle file downloads using the queue.
        this.sizeCache = {}; // A "cache" to store file sizes to prevent performing too many HEAD requests.
        // Variables to prevent downloading packages/files twice at the same time.
        this.packagesPromises = {};
        this.filePromises = {};
        this.logger = logger.getInstance('CoreFilepoolProvider');
        this.appDB = this.appProvider.getDB();
        this.appDB.createTablesFromSchema(this.appTablesSchema);
        this.sitesProvider.registerSiteSchema(this.siteSchema);
        initDelegate.ready().then(function () {
            // Waiting for the app to be ready to start processing the queue.
            _this.checkQueueProcessing();
            // Start queue when device goes online.
            network.onConnect().subscribe(function () {
                // Execute the callback in the Angular zone, so change detection doesn't stop working.
                zone.run(function () {
                    _this.checkQueueProcessing();
                });
            });
        });
    }
    /**
     * Link a file with a component.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<any>} Promise resolved on success.
     */
    CoreFilepoolProvider.prototype.addFileLink = function (siteId, fileId, component, componentId) {
        var _this = this;
        if (!component) {
            return Promise.reject(null);
        }
        componentId = this.fixComponentId(componentId);
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            var newEntry = {
                fileId: fileId,
                component: component,
                componentId: componentId || ''
            };
            return db.insertRecord(_this.LINKS_TABLE, newEntry);
        });
    };
    /**
     * Link a file with a component by URL.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file Url.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<any>} Promise resolved on success.
     * @description
     * Use this method to create a link between a URL and a component. You usually do not need to call this manually since
     * downloading a file automatically does this. Note that this method does not check if the file exists in the pool.
     */
    CoreFilepoolProvider.prototype.addFileLinkByUrl = function (siteId, fileUrl, component, componentId) {
        var _this = this;
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
            var fileId = _this.getFileIdByUrl(fileUrl);
            return _this.addFileLink(siteId, fileId, component, componentId);
        });
    };
    /**
     * Link a file with several components.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {any[]} links Array of objects containing the component and optionally componentId.
     * @return {Promise<any>} Promise resolved on success.
     */
    CoreFilepoolProvider.prototype.addFileLinks = function (siteId, fileId, links) {
        var _this = this;
        var promises = [];
        links.forEach(function (link) {
            promises.push(_this.addFileLink(siteId, fileId, link.component, link.componentId));
        });
        return Promise.all(promises);
    };
    /**
     * Add files to queue using a URL.
     *
     * @param {string} siteId The site ID.
     * @param {any[]} files Array of files to add.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component (optional).
     * @return {Promise<any>} Resolved on success.
     */
    CoreFilepoolProvider.prototype.addFilesToQueue = function (siteId, files, component, componentId) {
        return this.downloadOrPrefetchFiles(siteId, files, true, false, component, componentId);
    };
    /**
     * Add a file to the pool.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {any} data Additional information to store about the file (timemodified, url, ...). See FILES_TABLE schema.
     * @return {Promise<any>} Promise resolved on success.
     */
    CoreFilepoolProvider.prototype.addFileToPool = function (siteId, fileId, data) {
        var _this = this;
        var values = Object.assign({}, data);
        values.fileId = fileId;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.insertRecord(_this.FILES_TABLE, values);
        });
    };
    /**
     * Adds a hash to a filename if needed.
     *
     * @param {string} url The URL of the file, already treated (decoded, without revision, etc.).
     * @param {string} filename The filename.
     * @return {string} The filename with the hash.
     */
    CoreFilepoolProvider.prototype.addHashToFilename = function (url, filename) {
        // Check if the file already has a hash. If a file is downloaded and re-uploaded with the app it will have a hash already.
        var matches = filename.match(/_[a-f0-9]{32}/g);
        if (matches && matches.length) {
            // There is at least 1 match. Get the last one.
            var hash = matches[matches.length - 1], treatedUrl = url.replace(hash, ''); // Remove the hash from the URL.
            // Check that the hash is valid.
            if ('_' + __WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5__["Md5"].hashAsciiStr('url:' + treatedUrl) == hash) {
                // The data found is a hash of the URL, don't need to add it again.
                return filename;
            }
        }
        return filename + '_' + __WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5__["Md5"].hashAsciiStr('url:' + url);
    };
    /**
     * Add a file to the queue.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {string} url The absolute URL to the file.
     * @param {number} priority The priority this file should get in the queue (range 0-999).
     * @param {number} revision The revision of the file.
     * @param {number} timemodified The time this file was modified. Can be used to check file state.
     * @param {string} [filePath] Filepath to download the file to. If not defined, download to the filepool folder.
     * @param {any} options Extra options (isexternalfile, repositorytype).
     * @param {any} [link] The link to add for the file.
     * @return {Promise<any>} Promise resolved when the file is downloaded.
     */
    CoreFilepoolProvider.prototype.addToQueue = function (siteId, fileId, url, priority, revision, timemodified, filePath, onProgress, options, link) {
        var _this = this;
        if (options === void 0) { options = {}; }
        this.logger.debug("Adding " + fileId + " to the queue");
        return this.appDB.insertRecord(this.QUEUE_TABLE, {
            siteId: siteId,
            fileId: fileId,
            url: url,
            priority: priority,
            revision: revision,
            timemodified: timemodified,
            path: filePath,
            isexternalfile: options.isexternalfile ? 1 : 0,
            repositorytype: options.repositorytype,
            links: JSON.stringify(link ? [link] : []),
            added: Date.now()
        }).then(function () {
            // Check if the queue is running.
            _this.checkQueueProcessing();
            _this.notifyFileDownloading(siteId, fileId);
            return _this.getQueuePromise(siteId, fileId, true, onProgress);
        });
    };
    /**
     * Add an entry to queue using a URL.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The absolute URL to the file.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component (optional).
     * @param {number} [timemodified=0] The time this file was modified. Can be used to check file state.
     * @param {string} [filePath] Filepath to download the file to. If not defined, download to the filepool folder.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {number} [priority=0] The priority this file should get in the queue (range 0-999).
     * @param {any} [options] Extra options (isexternalfile, repositorytype).
     * @param {number} [revision] File revision. If not defined, it will be calculated using the URL.
     * @return {Promise} Resolved on success.
     */
    CoreFilepoolProvider.prototype.addToQueueByUrl = function (siteId, fileUrl, component, componentId, timemodified, filePath, onProgress, priority, options, revision) {
        var _this = this;
        if (timemodified === void 0) { timemodified = 0; }
        if (priority === void 0) { priority = 0; }
        if (options === void 0) { options = {}; }
        var fileId, link, queueDeferred;
        if (!this.fileProvider.isAvailable()) {
            return Promise.reject(null);
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.canDownloadFiles()) {
                return Promise.reject(null);
            }
            return _this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
                var primaryKey = { siteId: siteId, fileId: fileId };
                revision = revision || _this.getRevisionFromUrl(fileUrl);
                fileId = _this.getFileIdByUrl(fileUrl);
                // Set up the component.
                if (typeof component != 'undefined') {
                    link = {
                        component: component,
                        componentId: _this.fixComponentId(componentId)
                    };
                }
                // Retrieve the queue deferred now if it exists.
                // This is to prevent errors if file is removed from queue while we're checking if the file is in queue.
                queueDeferred = _this.getQueueDeferred(siteId, fileId, false, onProgress);
                return _this.hasFileInQueue(siteId, fileId).then(function (entry) {
                    var newData = {};
                    var foundLink = false;
                    if (entry) {
                        // We already have the file in queue, we update the priority and links.
                        if (entry.priority < priority) {
                            newData.priority = priority;
                        }
                        if (revision && entry.revision !== revision) {
                            newData.revision = revision;
                        }
                        if (timemodified && entry.timemodified !== timemodified) {
                            newData.timemodified = timemodified;
                        }
                        if (filePath && entry.path !== filePath) {
                            newData.path = filePath;
                        }
                        if (entry.isexternalfile !== options.isexternalfile && (entry.isexternalfile || options.isexternalfile)) {
                            newData.isexternalfile = options.isexternalfile;
                        }
                        if (entry.repositorytype !== options.repositorytype && (entry.repositorytype || options.repositorytype)) {
                            newData.repositorytype = options.repositorytype;
                        }
                        if (link) {
                            // We need to add the new link if it does not exist yet.
                            if (entry.links && entry.links.length) {
                                for (var i in entry.links) {
                                    var fileLink = entry.links[i];
                                    if (fileLink.component == link.component && fileLink.componentId == link.componentId) {
                                        foundLink = true;
                                        break;
                                    }
                                }
                            }
                            if (!foundLink) {
                                newData.links = entry.links || [];
                                newData.links.push(link);
                                newData.links = JSON.stringify(entry.links);
                            }
                        }
                        if (Object.keys(newData).length) {
                            // Update only when required.
                            _this.logger.debug("Updating file " + fileId + " which is already in queue");
                            return _this.appDB.updateRecords(_this.QUEUE_TABLE, newData, primaryKey).then(function () {
                                return _this.getQueuePromise(siteId, fileId, true, onProgress);
                            });
                        }
                        _this.logger.debug("File " + fileId + " already in queue and does not require update");
                        if (queueDeferred) {
                            // If we were able to retrieve the queue deferred before, we use that one.
                            return queueDeferred.promise;
                        }
                        else {
                            // Create a new deferred and return its promise.
                            return _this.getQueuePromise(siteId, fileId, true, onProgress);
                        }
                    }
                    else {
                        return _this.addToQueue(siteId, fileId, fileUrl, priority, revision, timemodified, filePath, onProgress, options, link);
                    }
                }, function () {
                    // Unsure why we could not get the record, let's add to the queue anyway.
                    return _this.addToQueue(siteId, fileId, fileUrl, priority, revision, timemodified, filePath, onProgress, options, link);
                });
            });
        });
    };
    /**
     * Adds a file to the queue if the size is allowed to be downloaded.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The absolute URL to the file.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [timemodified=0] The time this file was modified.
     * @param {boolean} [checkSize=true] True if we shouldn't download files if their size is big, false otherwise.
     * @param {boolean} [downloadUnknown] True to download file in WiFi if their size is unknown, false otherwise.
     *                                    Ignored if checkSize=false.
     * @param {any} [options] Extra options (isexternalfile, repositorytype).
     * @param {number} [revision] File revision. If not defined, it will be calculated using the URL.
     * @return {Promise<any>} Promise resolved when the file is downloaded.
     */
    CoreFilepoolProvider.prototype.addToQueueIfNeeded = function (siteId, fileUrl, component, componentId, timemodified, checkSize, downloadUnknown, options, revision) {
        var _this = this;
        if (timemodified === void 0) { timemodified = 0; }
        if (checkSize === void 0) { checkSize = true; }
        if (options === void 0) { options = {}; }
        var promise;
        if (checkSize) {
            if (typeof this.sizeCache[fileUrl] != 'undefined') {
                promise = Promise.resolve(this.sizeCache[fileUrl]);
            }
            else {
                if (!this.appProvider.isOnline()) {
                    // Cannot check size in offline, stop.
                    return Promise.reject(null);
                }
                promise = this.wsProvider.getRemoteFileSize(fileUrl);
            }
            // Calculate the size of the file.
            return promise.then(function (size) {
                var isWifi = _this.appProvider.isWifi(), sizeUnknown = size <= 0;
                if (!sizeUnknown) {
                    // Store the size in the cache.
                    _this.sizeCache[fileUrl] = size;
                }
                // Check if the file should be downloaded.
                if (sizeUnknown) {
                    if (downloadUnknown && isWifi) {
                        return _this.addToQueueByUrl(siteId, fileUrl, component, componentId, timemodified, undefined, undefined, 0, options, revision);
                    }
                }
                else if (size <= _this.DOWNLOAD_THRESHOLD || (isWifi && size <= _this.WIFI_DOWNLOAD_THRESHOLD)) {
                    return _this.addToQueueByUrl(siteId, fileUrl, component, componentId, timemodified, undefined, undefined, 0, options, revision);
                }
            });
        }
        else {
            // No need to check size, just add it to the queue.
            return this.addToQueueByUrl(siteId, fileUrl, component, componentId, timemodified, undefined, undefined, 0, options, revision);
        }
    };
    /**
     * Check the queue processing.
     *
     * @description
     * In mose cases, this will enable the queue processing if it was paused.
     * Though, this will disable the queue if we are missing network or if the file system
     * is not accessible. Also, this will have no effect if the queue is already running.
     */
    CoreFilepoolProvider.prototype.checkQueueProcessing = function () {
        if (!this.fileProvider.isAvailable() || !this.appProvider.isOnline()) {
            this.queueState = this.QUEUE_PAUSED;
            return;
        }
        else if (this.queueState === this.QUEUE_RUNNING) {
            return;
        }
        this.queueState = this.QUEUE_RUNNING;
        this.processQueue();
    };
    /**
     * Clear all packages status in a site.
     *
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when all status are cleared.
     */
    CoreFilepoolProvider.prototype.clearAllPackagesStatus = function (siteId) {
        var _this = this;
        this.logger.debug('Clear all packages status for site ' + siteId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Get all the packages to be able to "notify" the change in the status.
            return site.getDb().getAllRecords(_this.PACKAGES_TABLE).then(function (entries) {
                // Delete all the entries.
                return site.getDb().deleteRecords(_this.PACKAGES_TABLE).then(function () {
                    entries.forEach(function (entry) {
                        // Trigger module status changed, setting it as not downloaded.
                        _this.triggerPackageStatusChanged(siteId, __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED, entry.component, entry.componentId);
                    });
                });
            });
        });
    };
    /**
     * Clears the filepool. Use it only when all the files from a site are deleted.
     *
     * @param  {string} siteId ID of the site to clear.
     * @return {Promise<any>} Promise resolved when the filepool is cleared.
     */
    CoreFilepoolProvider.prototype.clearFilepool = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return Promise.all([
                db.deleteRecords(_this.FILES_TABLE),
                db.deleteRecords(_this.LINKS_TABLE)
            ]);
        });
    };
    /**
     * Returns whether a component has files in the pool.
     *
     * @param {string} siteId The site ID.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<void>} Resolved means yes, rejected means no.
     */
    CoreFilepoolProvider.prototype.componentHasFiles = function (siteId, component, componentId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            var conditions = {
                component: component,
                componentId: componentId || ''
            };
            return db.countRecords(_this.LINKS_TABLE, conditions).then(function (count) {
                if (count <= 0) {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Given the current status of a list of packages and the status of one of the packages,
     * determine the new status for the list of packages. The status of a list of packages is:
     *     - CoreConstants.NOT_DOWNLOADABLE if there are no downloadable packages.
     *     - CoreConstants.NOT_DOWNLOADED if at least 1 package has status CoreConstants.NOT_DOWNLOADED.
     *     - CoreConstants.DOWNLOADED if ALL the downloadable packages have status CoreConstants.DOWNLOADED.
     *     - CoreConstants.DOWNLOADING if ALL the downloadable packages have status CoreConstants.DOWNLOADING or
     *                                     CoreConstants.DOWNLOADED, with at least 1 package with CoreConstants.DOWNLOADING.
     *     - CoreConstants.OUTDATED if ALL the downloadable packages have status CoreConstants.OUTDATED or CoreConstants.DOWNLOADED
     *                                     or CoreConstants.DOWNLOADING, with at least 1 package with CoreConstants.OUTDATED.
     *
     * @param {string} current Current status of the list of packages.
     * @param {string} packagestatus Status of one of the packages.
     * @return {string} New status for the list of packages;
     */
    CoreFilepoolProvider.prototype.determinePackagesStatus = function (current, packageStatus) {
        if (!current) {
            current = __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE;
        }
        if (packageStatus === __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
            // If 1 package is not downloaded the status of the whole list will always be not downloaded.
            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        }
        else if (packageStatus === __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADED && current === __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE) {
            // If all packages are downloaded or not downloadable with at least 1 downloaded, status will be downloaded.
            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADED;
        }
        else if (packageStatus === __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADING &&
            (current === __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE || current === __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADED)) {
            // If all packages are downloading/downloaded/notdownloadable with at least 1 downloading, status will be downloading.
            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADING;
        }
        else if (packageStatus === __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].OUTDATED && current !== __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
            // If there are no packages notdownloaded and there is at least 1 outdated, status will be outdated.
            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].OUTDATED;
        }
        // Status remains the same.
        return current;
    };
    /**
     * Downloads a URL and update or add it to the pool.
     *
     * This uses the file system, you should always make sure that it is accessible before calling this method.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @param {any} [options] Extra options (revision, timemodified, isexternalfile, repositorytype).
     * @param {string} [filePath] Filepath to download the file to. If defined, no extension will be added.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {CoreFilepoolFileEntry} [poolFileObject] When set, the object will be updated, a new entry will not be created.
     * @return {Promise<any>} Resolved with internal URL on success, rejected otherwise.
     */
    CoreFilepoolProvider.prototype.downloadForPoolByUrl = function (siteId, fileUrl, options, filePath, onProgress, poolFileObject) {
        var _this = this;
        if (options === void 0) { options = {}; }
        var fileId = this.getFileIdByUrl(fileUrl), extension = this.mimeUtils.guessExtensionFromUrl(fileUrl), addExtension = typeof filePath == 'undefined', pathPromise = filePath ? filePath : this.getFilePath(siteId, fileId, extension);
        return Promise.resolve(pathPromise).then(function (filePath) {
            if (poolFileObject && poolFileObject.fileId !== fileId) {
                _this.logger.error('Invalid object to update passed');
                return Promise.reject(null);
            }
            var downloadId = _this.getFileDownloadId(fileUrl, filePath);
            if (_this.filePromises[siteId] && _this.filePromises[siteId][downloadId]) {
                // There's already a download ongoing for this file in this location, return the promise.
                return _this.filePromises[siteId][downloadId];
            }
            else if (!_this.filePromises[siteId]) {
                _this.filePromises[siteId] = {};
            }
            _this.filePromises[siteId][downloadId] = _this.sitesProvider.getSite(siteId).then(function (site) {
                if (!site.canDownloadFiles()) {
                    return Promise.reject(null);
                }
                return _this.wsProvider.downloadFile(fileUrl, filePath, addExtension, onProgress).then(function (fileEntry) {
                    var data = poolFileObject || {};
                    data.downloadTime = Date.now();
                    data.stale = 0;
                    data.url = fileUrl;
                    data.revision = options.revision;
                    data.timemodified = options.timemodified;
                    data.isexternalfile = options.isexternalfile ? 1 : 0;
                    data.repositorytype = options.repositorytype;
                    data.path = fileEntry.path;
                    data.extension = fileEntry.extension;
                    return _this.addFileToPool(siteId, fileId, data).then(function () {
                        return fileEntry.toURL();
                    });
                });
            }).finally(function () {
                // Download finished, delete the promise.
                delete _this.filePromises[siteId][downloadId];
            });
            return _this.filePromises[siteId][downloadId];
        });
    };
    /**
     * Download or prefetch several files into the filepool folder.
     *
     * @param {string} siteId The site ID.
     * @param {any[]} files Array of files to download.
     * @param {boolean} prefetch True if should prefetch the contents (queue), false if they should be downloaded right now.
     * @param {boolean} [ignoreStale] True if 'stale' should be ignored. Only if prefetch=false.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {string} [dirPath] Name of the directory where to store the files (inside filepool dir). If not defined, store
     *                           the files directly inside the filepool folder.
     * @return {Promise<any>} Resolved on success.
     */
    CoreFilepoolProvider.prototype.downloadOrPrefetchFiles = function (siteId, files, prefetch, ignoreStale, component, componentId, dirPath) {
        var _this = this;
        var promises = [];
        // Download files.
        files.forEach(function (file) {
            var url = file.url || file.fileurl, timemodified = file.timemodified, options = {
                isexternalfile: file.isexternalfile,
                repositorytype: file.repositorytype
            };
            var path;
            if (dirPath) {
                // Calculate the path to the file.
                path = file.filename;
                if (file.filepath !== '/') {
                    path = file.filepath.substr(1) + path;
                }
                path = _this.textUtils.concatenatePaths(dirPath, path);
            }
            if (prefetch) {
                promises.push(_this.addToQueueByUrl(siteId, url, component, componentId, timemodified, path, undefined, 0, options));
            }
            else {
                promises.push(_this.downloadUrl(siteId, url, ignoreStale, component, componentId, timemodified, path, undefined, options));
            }
        });
        return this.utils.allPromises(promises);
    };
    /**
     * Downloads or prefetches a list of files as a "package".
     *
     * @param {string} siteId The site ID.
     * @param {any[]} fileList List of files to download.
     * @param {boolean} [prefetch] True if should prefetch the contents (queue), false if they should be downloaded right now.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId]  An ID to use in conjunction with the component.
     * @param {string} [extra] Extra data to store for the package.
     * @param {string} [dirPath] Name of the directory where to store the files (inside filepool dir). If not defined, store
     *                           the files directly inside the filepool folder.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved when the package is downloaded.
     */
    CoreFilepoolProvider.prototype.downloadOrPrefetchPackage = function (siteId, fileList, prefetch, component, componentId, extra, dirPath, onProgress) {
        var _this = this;
        var packageId = this.getPackageId(component, componentId);
        var promise;
        if (this.packagesPromises[siteId] && this.packagesPromises[siteId][packageId]) {
            // There's already a download ongoing for this package, return the promise.
            return this.packagesPromises[siteId][packageId];
        }
        else if (!this.packagesPromises[siteId]) {
            this.packagesPromises[siteId] = {};
        }
        // Set package as downloading.
        promise = this.storePackageStatus(siteId, __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADING, component, componentId).then(function () {
            var promises = [];
            var packageLoaded = 0;
            fileList.forEach(function (file) {
                var fileUrl = file.url || file.fileurl, options = {
                    isexternalfile: file.isexternalfile,
                    repositorytype: file.repositorytype
                };
                var path, promise, fileLoaded = 0, onFileProgress;
                if (onProgress) {
                    // There's a onProgress event, create a function to receive file download progress events.
                    onFileProgress = function (progress) {
                        if (progress && progress.loaded) {
                            // Add the new size loaded to the package loaded.
                            packageLoaded = packageLoaded + (progress.loaded - fileLoaded);
                            fileLoaded = progress.loaded;
                            onProgress({
                                packageDownload: true,
                                loaded: packageLoaded,
                                fileProgress: progress
                            });
                        }
                    };
                }
                if (dirPath) {
                    // Calculate the path to the file.
                    path = file.filename;
                    if (file.filepath !== '/') {
                        path = file.filepath.substr(1) + path;
                    }
                    path = _this.textUtils.concatenatePaths(dirPath, path);
                }
                if (prefetch) {
                    promise = _this.addToQueueByUrl(siteId, fileUrl, component, componentId, file.timemodified, path, undefined, 0, options);
                }
                else {
                    promise = _this.downloadUrl(siteId, fileUrl, false, component, componentId, file.timemodified, onFileProgress, path, options);
                }
                // Using undefined for success & fail will pass the success/failure to the parent promise.
                promises.push(promise);
            });
            return Promise.all(promises).then(function () {
                // Success prefetching, store package as downloaded.
                return _this.storePackageStatus(siteId, __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADED, component, componentId, extra);
            }).catch(function (error) {
                // Error downloading, go back to previous status and reject the promise.
                return _this.setPackagePreviousStatus(siteId, component, componentId).then(function () {
                    return Promise.reject(error);
                });
            });
        }).finally(function () {
            // Download finished, delete the promise.
            delete _this.packagesPromises[siteId][packageId];
        });
        this.packagesPromises[siteId][packageId] = promise;
        return promise;
    };
    /**
     * Downloads a list of files.
     *
     * @param {string} siteId The site ID.
     * @param {any[]} fileList List of files to download.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to identify the download.
     * @param {string} [extra] Extra data to store for the package.
     * @param {string} [dirPath] Name of the directory where to store the files (inside filepool dir). If not defined, store
     *                           the files directly inside the filepool folder.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>}  Promise resolved when all files are downloaded.
     */
    CoreFilepoolProvider.prototype.downloadPackage = function (siteId, fileList, component, componentId, extra, dirPath, onProgress) {
        return this.downloadOrPrefetchPackage(siteId, fileList, false, component, componentId, extra, dirPath, onProgress);
    };
    /**
     * Downloads a file on the spot.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @param {boolean} [ignoreStale] Whether 'stale' should be ignored.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [timemodified=0] The time this file was modified. Can be used to check file state.
     * @param {string} [filePath] Filepath to download the file to. If not defined, download to the filepool folder.
     * @param {any} [options] Extra options (isexternalfile, repositorytype).
     * @param {number} [revision] File revision. If not defined, it will be calculated using the URL.
     * @return {Promise<any>} Resolved with internal URL on success, rejected otherwise.
     * @description
     * Downloads a file on the spot.
     *
     * This will also take care of adding the file to the pool if it's missing. However, please note that this will
     * not force a file to be re-downloaded if it is already part of the pool. You should mark a file as stale using
     * invalidateFileByUrl to trigger a download.
     */
    CoreFilepoolProvider.prototype.downloadUrl = function (siteId, fileUrl, ignoreStale, component, componentId, timemodified, onProgress, filePath, options, revision) {
        var _this = this;
        if (timemodified === void 0) { timemodified = 0; }
        if (options === void 0) { options = {}; }
        var fileId, promise;
        if (this.fileProvider.isAvailable()) {
            return this.fixPluginfileURL(siteId, fileUrl).then(function (fixedUrl) {
                fileUrl = fixedUrl;
                options = Object.assign({}, options); // Create a copy to prevent modifying the original object.
                options.timemodified = timemodified || 0;
                options.revision = revision || _this.getRevisionFromUrl(fileUrl);
                fileId = _this.getFileIdByUrl(fileUrl);
                return _this.hasFileInPool(siteId, fileId).then(function (fileObject) {
                    if (typeof fileObject === 'undefined') {
                        // We do not have the file, download and add to pool.
                        _this.notifyFileDownloading(siteId, fileId);
                        return _this.downloadForPoolByUrl(siteId, fileUrl, options, filePath, onProgress);
                    }
                    else if (_this.isFileOutdated(fileObject, options.revision, options.timemodified) &&
                        _this.appProvider.isOnline() && !ignoreStale) {
                        // The file is outdated, force the download and update it.
                        _this.notifyFileDownloading(siteId, fileId);
                        return _this.downloadForPoolByUrl(siteId, fileUrl, options, filePath, onProgress, fileObject);
                    }
                    // Everything is fine, return the file on disk.
                    if (filePath) {
                        promise = _this.getInternalUrlByPath(filePath);
                    }
                    else {
                        promise = _this.getInternalUrlById(siteId, fileId);
                    }
                    return promise.then(function (response) {
                        return response;
                    }, function () {
                        // The file was not found in the pool, weird.
                        _this.notifyFileDownloading(siteId, fileId);
                        return _this.downloadForPoolByUrl(siteId, fileUrl, options, filePath, onProgress, fileObject);
                    });
                }, function () {
                    // The file is not in the pool just yet.
                    _this.notifyFileDownloading(siteId, fileId);
                    return _this.downloadForPoolByUrl(siteId, fileUrl, options, filePath, onProgress);
                }).then(function (response) {
                    if (typeof component != 'undefined') {
                        _this.addFileLink(siteId, fileId, component, componentId).catch(function () {
                            // Ignore errors.
                        });
                    }
                    _this.notifyFileDownloaded(siteId, fileId);
                    return response;
                }, function (err) {
                    _this.notifyFileDownloadError(siteId, fileId);
                    return Promise.reject(err);
                });
            });
        }
        else {
            return Promise.reject(null);
        }
    };
    /**
     * Fill Missing Extension In the File Object if needed.
     * This is to migrate from old versions.
     *
     * @param {CoreFilepoolFileEntry} fileObject File object to be migrated.
     * @param {string} siteId SiteID to get migrated.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFilepoolProvider.prototype.fillExtensionInFile = function (entry, siteId) {
        var _this = this;
        if (typeof entry.extension != 'undefined') {
            // Already filled.
            return Promise.resolve();
        }
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            var extension = _this.mimeUtils.getFileExtension(entry.path);
            if (!extension) {
                // Files does not have extension. Invalidate file (stale = true).
                // Minor problem: file will remain in the filesystem once downloaded again.
                _this.logger.debug('Staled file with no extension ' + entry.fileId);
                return db.updateRecords(_this.FILES_TABLE, { stale: 1 }, { fileId: entry.fileId });
            }
            // File has extension. Save extension, and add extension to path.
            var fileId = entry.fileId;
            entry.fileId = _this.mimeUtils.removeExtension(fileId);
            entry.extension = extension;
            return db.updateRecords(_this.FILES_TABLE, entry, { fileId: fileId }).then(function () {
                if (entry.fileId == fileId) {
                    // File ID hasn't changed, we're done.
                    _this.logger.debug('Removed extesion ' + extension + ' from file ' + entry.fileId);
                    return;
                }
                // Now update the links.
                return db.updateRecords(_this.LINKS_TABLE, { fileId: entry.fileId }, { fileId: fileId });
            });
        });
    };
    /**
     * Fill Missing Extension In Files, used to migrate from previous file handling.
     * Reserved for core use, please do not call.
     *
     * @param {string} siteId SiteID to get migrated
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFilepoolProvider.prototype.fillMissingExtensionInFiles = function (siteId) {
        var _this = this;
        this.logger.debug('Fill missing extensions in files of ' + siteId);
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getAllRecords(_this.FILES_TABLE).then(function (entries) {
                var promises = [];
                entries.forEach(function (entry) {
                    promises.push(_this.fillExtensionInFile(entry, siteId));
                });
                return Promise.all(promises);
            });
        });
    };
    /**
     * Fix a component ID to always be a Number if possible.
     *
     * @param {string|number} componentId The component ID.
     * @return {string|number} The normalised component ID. -1 when undefined was passed.
     */
    CoreFilepoolProvider.prototype.fixComponentId = function (componentId) {
        if (typeof componentId == 'number') {
            return componentId;
        }
        // Try to convert it to a number.
        var id = parseInt(componentId, 10);
        if (isNaN(id)) {
            // Not a number.
            if (typeof componentId == 'undefined' || componentId === null) {
                return -1;
            }
            else {
                return componentId;
            }
        }
        return id;
    };
    /**
     * Add the wstoken url and points to the correct script.
     *
     * @param {string} siteId  The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise}       Resolved with fixed URL on success, rejected otherwise.
     */
    CoreFilepoolProvider.prototype.fixPluginfileURL = function (siteId, fileUrl) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.fixPluginfileURL(fileUrl);
        });
    };
    /**
     * Convenience function to get component files.
     *
     * @param {SQLiteDB} db Site's DB.
     * @param {string} component The component to get.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    CoreFilepoolProvider.prototype.getComponentFiles = function (db, component, componentId) {
        var conditions = {
            component: component,
            componentId: componentId || ''
        };
        return db.getRecords(this.LINKS_TABLE, conditions);
    };
    /**
     * Returns the local URL of a directory.
     *
     * @param {string} siteId  The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise}       Resolved with the URL. Rejected otherwise.
     */
    CoreFilepoolProvider.prototype.getDirectoryUrlByUrl = function (siteId, fileUrl) {
        var _this = this;
        if (this.fileProvider.isAvailable()) {
            return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
                var fileId = _this.getFileIdByUrl(fileUrl), filePath = _this.getFilePath(siteId, fileId, ''); // No extension, the function will return a string.
                return _this.fileProvider.getDir(filePath).then(function (dirEntry) {
                    return dirEntry.toURL();
                });
            });
        }
        return Promise.reject(null);
    };
    /**
     * Get the ID of a file download. Used to keep track of filePromises.
     *
     * @param {string} fileUrl  The file URL.
     * @param {string} filePath The file destination path.
     * @return {string}         File download ID.
     */
    CoreFilepoolProvider.prototype.getFileDownloadId = function (fileUrl, filePath) {
        return __WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5__["Md5"].hashAsciiStr(fileUrl + '###' + filePath);
    };
    /**
     * Get the name of the event used to notify download events (CoreEventsProvider).
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @return {string} Event name.
     */
    CoreFilepoolProvider.prototype.getFileEventName = function (siteId, fileId) {
        return 'CoreFilepoolFile:' + siteId + ':' + fileId;
    };
    /**
     * Get the name of the event used to notify download events (CoreEventsProvider).
     *
     * @param {string} siteId  The site ID.
     * @param {string} fileUrl The absolute URL to the file.
     * @return {Promise}       Promise resolved with event name.
     */
    CoreFilepoolProvider.prototype.getFileEventNameByUrl = function (siteId, fileUrl) {
        var _this = this;
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
            var fileId = _this.getFileIdByUrl(fileUrl);
            return _this.getFileEventName(siteId, fileId);
        });
    };
    /**
     * Creates a unique ID based on a URL.
     *
     * This has a minimal handling of pluginfiles in order to generate a clean file ID which will not change if
     * pointing to the same pluginfile URL even if the token or extra attributes have changed.
     *
     * @param {string} fileUrl The absolute URL to the file.
     * @return {string} The file ID.
     */
    CoreFilepoolProvider.prototype.getFileIdByUrl = function (fileUrl) {
        var url = this.removeRevisionFromUrl(fileUrl), filename;
        // Decode URL.
        url = this.textUtils.decodeHTML(this.textUtils.decodeURIComponent(url));
        if (url.indexOf('/webservice/pluginfile') !== -1) {
            // Remove attributes that do not matter.
            this.urlAttributes.forEach(function (regex) {
                url = url.replace(regex, '');
            });
        }
        // Try to guess the filename the target file should have.
        // We want to keep the original file name so people can easily identify the files after the download.
        filename = this.guessFilenameFromUrl(url);
        return this.addHashToFilename(url, filename);
    };
    /**
     * Get the links of a file.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @return {Promise<any[]>} Promise resolved with the links.
     */
    CoreFilepoolProvider.prototype.getFileLinks = function (siteId, fileId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getRecords(_this.LINKS_TABLE, { fileId: fileId });
        });
    };
    /**
     * Get the path to a file. This does not check if the file exists or not.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {string} [extension] Previously calculated extension. Empty to not add any. Undefined to calculate it.
     * @return {string|Promise<string>} The path to the file relative to storage root.
     */
    CoreFilepoolProvider.prototype.getFilePath = function (siteId, fileId, extension) {
        var path = this.getFilepoolFolderPath(siteId) + '/' + fileId;
        if (typeof extension == 'undefined') {
            // We need the extension to be able to open files properly.
            return this.hasFileInPool(siteId, fileId).then(function (entry) {
                if (entry.extension) {
                    path += '.' + entry.extension;
                }
                return path;
            }).catch(function () {
                // If file not found, use the path without extension.
                return path;
            });
        }
        else {
            if (extension) {
                path += '.' + extension;
            }
            return path;
        }
    };
    /**
     * Get the path to a file from its URL. This does not check if the file exists or not.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise<string>} Promise resolved with the path to the file relative to storage root.
     */
    CoreFilepoolProvider.prototype.getFilePathByUrl = function (siteId, fileUrl) {
        var _this = this;
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
            var fileId = _this.getFileIdByUrl(fileUrl);
            return _this.getFilePath(siteId, fileId);
        });
    };
    /**
     * Get site Filepool Folder Path
     *
     * @param {string} siteId The site ID.
     * @return {string} The root path to the filepool of the site.
     */
    CoreFilepoolProvider.prototype.getFilepoolFolderPath = function (siteId) {
        return this.fileProvider.getSiteFolder(siteId) + '/' + this.FOLDER;
    };
    /**
     * Get all the matching files from a component. Returns objects containing properties like path, extension and url.
     *
     * @param {string} siteId The site ID.
     * @param {string} component The component to get.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<any[]>} Promise resolved with the files on success.
     */
    CoreFilepoolProvider.prototype.getFilesByComponent = function (siteId, component, componentId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return _this.getComponentFiles(db, component, componentId).then(function (items) {
                var promises = [], files = [];
                items.forEach(function (item) {
                    promises.push(db.getRecord(_this.FILES_TABLE, { fileId: item.fileId }).then(function (fileEntry) {
                        if (!fileEntry) {
                            return;
                        }
                        files.push({
                            url: fileEntry.url,
                            path: fileEntry.path,
                            extension: fileEntry.extension,
                            revision: fileEntry.revision,
                            timemodified: fileEntry.timemodified
                        });
                    }).catch(function () {
                        // File not found, ignore error.
                    }));
                });
                return Promise.all(promises).then(function () {
                    return files;
                });
            });
        });
    };
    /**
     * Get the size of all the files from a component.
     *
     * @param {string} siteId The site ID.
     * @param {string} component    The component to get.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<number>} Promise resolved with the size on success.
     */
    CoreFilepoolProvider.prototype.getFilesSizeByComponent = function (siteId, component, componentId) {
        var _this = this;
        return this.getFilesByComponent(siteId, component, componentId).then(function (files) {
            var promises = [];
            var size = 0;
            files.forEach(function (file) {
                promises.push(_this.fileProvider.getFileSize(file.path).then(function (fs) {
                    size += fs;
                }).catch(function () {
                    // Ignore failures, maybe some file was deleted.
                }));
            });
            return Promise.all(promises).then(function () {
                return size;
            });
        });
    };
    /**
     * Returns the file state: mmCoreDownloaded, mmCoreDownloading, mmCoreNotDownloaded or mmCoreOutdated.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl File URL.
     * @param {number} [timemodified=0] The time this file was modified.
     * @param {string} [filePath] Filepath to download the file to. If defined, no extension will be added.
     * @param {number} [revision] File revision. If not defined, it will be calculated using the URL.
     * @return {Promise<string>} Promise resolved with the file state.
     */
    CoreFilepoolProvider.prototype.getFileStateByUrl = function (siteId, fileUrl, timemodified, filePath, revision) {
        var _this = this;
        if (timemodified === void 0) { timemodified = 0; }
        var fileId;
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fixedUrl) {
            fileUrl = fixedUrl;
            revision = revision || _this.getRevisionFromUrl(fileUrl);
            fileId = _this.getFileIdByUrl(fileUrl);
            // Check if the file is in queue (waiting to be downloaded).
            return _this.hasFileInQueue(siteId, fileId).then(function () {
                return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADING;
            }).catch(function () {
                // Check if the file is being downloaded right now.
                var extension = _this.mimeUtils.guessExtensionFromUrl(fileUrl), path = filePath ? filePath : _this.getFilePath(siteId, fileId, extension);
                return Promise.resolve(path).then(function (filePath) {
                    var downloadId = _this.getFileDownloadId(fileUrl, filePath);
                    if (_this.filePromises[siteId] && _this.filePromises[siteId][downloadId]) {
                        return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADING;
                    }
                    // File is not being downloaded. Check if it's downloaded and if it's outdated.
                    return _this.hasFileInPool(siteId, fileId).then(function (entry) {
                        if (_this.isFileOutdated(entry, revision, timemodified)) {
                            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].OUTDATED;
                        }
                        else {
                            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADED;
                        }
                    }).catch(function () {
                        return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
                    });
                });
            });
        });
    };
    /**
     * Returns an absolute URL to access the file URL.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The absolute URL to the file.
     * @param {string} [mode=url] The type of URL to return. Accepts 'url' or 'src'.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [timemodified=0] The time this file was modified.
     * @param {boolean} [checkSize=true] True if we shouldn't download files if their size is big, false otherwise.
     * @param {boolean} [downloadUnknown] True to download file in WiFi if their size is unknown, false otherwise.
     *                                    Ignored if checkSize=false.
     * @param {any} [options] Extra options (isexternalfile, repositorytype).
     * @param {number} [revision] File revision. If not defined, it will be calculated using the URL.
     * @return {Promise<string>} Resolved with the URL to use.
     * @description
     * This will return a URL pointing to the content of the requested URL.
     *
     * This handles the queue and validity of the file. If there is a local file and it's valid, return the local URL.
     * If the file isn't downloaded or it's outdated, return the online URL and add it to the queue to be downloaded later.
     */
    CoreFilepoolProvider.prototype.getFileUrlByUrl = function (siteId, fileUrl, component, componentId, mode, timemodified, checkSize, downloadUnknown, options, revision) {
        var _this = this;
        if (mode === void 0) { mode = 'url'; }
        if (timemodified === void 0) { timemodified = 0; }
        if (checkSize === void 0) { checkSize = true; }
        if (options === void 0) { options = {}; }
        var fileId;
        var addToQueue = function (fileUrl) {
            // Add the file to queue if needed and ignore errors.
            _this.addToQueueIfNeeded(siteId, fileUrl, component, componentId, timemodified, checkSize, downloadUnknown, options, revision).catch(function () {
                // Ignore errors.
            });
        };
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fixedUrl) {
            fileUrl = fixedUrl;
            revision = revision || _this.getRevisionFromUrl(fileUrl);
            fileId = _this.getFileIdByUrl(fileUrl);
            return _this.hasFileInPool(siteId, fileId).then(function (entry) {
                var response;
                if (typeof entry === 'undefined') {
                    // We do not have the file, add it to the queue, and return real URL.
                    addToQueue(fileUrl);
                    response = fileUrl;
                }
                else if (_this.isFileOutdated(entry, revision, timemodified) && _this.appProvider.isOnline()) {
                    // The file is outdated, we add to the queue and return real URL.
                    addToQueue(fileUrl);
                    response = fileUrl;
                }
                else {
                    // We found the file entry, now look for the file on disk.
                    if (mode === 'src') {
                        response = _this.getInternalSrcById(siteId, fileId);
                    }
                    else {
                        response = _this.getInternalUrlById(siteId, fileId);
                    }
                    response = response.then(function (internalUrl) {
                        // The file is on disk.
                        return internalUrl;
                    }).catch(function () {
                        // We could not retrieve the file, delete the entries associated with that ID.
                        _this.logger.debug('File ' + fileId + ' not found on disk');
                        _this.removeFileById(siteId, fileId);
                        addToQueue(fileUrl);
                        if (_this.appProvider.isOnline()) {
                            // We still have a chance to serve the right content.
                            return fileUrl;
                        }
                        return Promise.reject(null);
                    });
                }
                return response;
            }, function () {
                // We do not have the file in store yet. Add to queue and return the fixed URL.
                addToQueue(fileUrl);
                return fileUrl;
            });
        });
    };
    /**
     * Returns the internal SRC of a file.
     *
     * The returned URL from this method is typically used with IMG tags.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @return {Promise<string>} Resolved with the internal URL. Rejected otherwise.
     */
    CoreFilepoolProvider.prototype.getInternalSrcById = function (siteId, fileId) {
        var _this = this;
        if (this.fileProvider.isAvailable()) {
            return Promise.resolve(this.getFilePath(siteId, fileId)).then(function (path) {
                return _this.fileProvider.getFile(path).then(function (fileEntry) {
                    // We use toInternalURL so images are loaded in iOS8 using img HTML tags.
                    return _this.fileProvider.getInternalURL(fileEntry);
                });
            });
        }
        return Promise.reject(null);
    };
    /**
     * Returns the local URL of a file.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @return {Promise<string>} Resolved with the URL. Rejected otherwise.
     */
    CoreFilepoolProvider.prototype.getInternalUrlById = function (siteId, fileId) {
        var _this = this;
        if (this.fileProvider.isAvailable()) {
            return Promise.resolve(this.getFilePath(siteId, fileId)).then(function (path) {
                return _this.fileProvider.getFile(path).then(function (fileEntry) {
                    // This URL is usually used to launch files or put them in HTML. In desktop we need the internal URL.
                    if (_this.appProvider.isDesktop()) {
                        return fileEntry.toInternalURL();
                    }
                    else {
                        return fileEntry.toURL();
                    }
                });
            });
        }
        return Promise.reject(null);
    };
    /**
     * Returns the local URL of a file.
     *
     * @param {string} filePath The file path.
     * @return {Promise<string>} Resolved with the URL.
     */
    CoreFilepoolProvider.prototype.getInternalUrlByPath = function (filePath) {
        if (this.fileProvider.isAvailable()) {
            return this.fileProvider.getFile(filePath).then(function (fileEntry) {
                return fileEntry.toURL();
            });
        }
        return Promise.reject(null);
    };
    /**
     * Returns the local URL of a file.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise<string>} Resolved with the URL. Rejected otherwise.
     */
    CoreFilepoolProvider.prototype.getInternalUrlByUrl = function (siteId, fileUrl) {
        var _this = this;
        if (this.fileProvider.isAvailable()) {
            return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
                var fileId = _this.getFileIdByUrl(fileUrl);
                return _this.getInternalUrlById(siteId, fileId);
            });
        }
        return Promise.reject(null);
    };
    /**
     * Get the data stored for a package.
     *
     * @param {string} siteId Site ID.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<CoreFilepoolPackageEntry>} Promise resolved with the data.
     */
    CoreFilepoolProvider.prototype.getPackageData = function (siteId, component, componentId) {
        var _this = this;
        componentId = this.fixComponentId(componentId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var packageId = _this.getPackageId(component, componentId);
            return site.getDb().getRecord(_this.PACKAGES_TABLE, { id: packageId });
        });
    };
    /**
     * Creates the name for a package directory (hash).
     *
     * @param {string} url An URL to identify the package.
     * @return {string} The directory name.
     */
    CoreFilepoolProvider.prototype.getPackageDirNameByUrl = function (url) {
        var candidate, extension = '';
        url = this.removeRevisionFromUrl(url);
        if (url.indexOf('/webservice/pluginfile') !== -1) {
            // Remove attributes that do not matter.
            this.urlAttributes.forEach(function (regex) {
                url = url.replace(regex, '');
            });
            // Guess the extension of the URL. This is for backwards compatibility.
            candidate = this.mimeUtils.guessExtensionFromUrl(url);
            if (candidate && candidate !== 'php') {
                extension = '.' + candidate;
            }
        }
        return __WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5__["Md5"].hashAsciiStr('url:' + url) + extension;
    };
    /**
     * Get the path to a directory to store a package files. This does not check if the file exists or not.
     *
     * @param {string} siteId The site ID.
     * @param {string} url An URL to identify the package.
     * @return {Promise<string>} Promise resolved with the path of the package.
     */
    CoreFilepoolProvider.prototype.getPackageDirPathByUrl = function (siteId, url) {
        var _this = this;
        return this.fixPluginfileURL(siteId, url).then(function (fixedUrl) {
            var dirName = _this.getPackageDirNameByUrl(fixedUrl);
            return _this.getFilePath(siteId, dirName, '');
        });
    };
    /**
     * Returns the local URL of a package directory.
     *
     * @param {string} siteId The site ID.
     * @param {string} url An URL to identify the package.
     * @return {Promise<string>} Resolved with the URL.
     */
    CoreFilepoolProvider.prototype.getPackageDirUrlByUrl = function (siteId, url) {
        var _this = this;
        if (this.fileProvider.isAvailable()) {
            return this.fixPluginfileURL(siteId, url).then(function (fixedUrl) {
                var dirName = _this.getPackageDirNameByUrl(fixedUrl), dirPath = _this.getFilePath(siteId, dirName, ''); // No extension, the function will return a string.
                return _this.fileProvider.getDir(dirPath).then(function (dirEntry) {
                    return dirEntry.toURL();
                });
            });
        }
        return Promise.reject(null);
    };
    /**
     * Get a download promise. If the promise is not set, return undefined.
     *
     * @param {string} siteId Site ID.
     * @param {string} component The component of the package.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<any>} Download promise or undefined.
     */
    CoreFilepoolProvider.prototype.getPackageDownloadPromise = function (siteId, component, componentId) {
        var packageId = this.getPackageId(component, componentId);
        if (this.packagesPromises[siteId] && this.packagesPromises[siteId][packageId]) {
            return this.packagesPromises[siteId][packageId];
        }
    };
    /**
     * Get a package extra data.
     *
     * @param {string} siteId Site ID.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<string>} Promise resolved with the extra data.
     */
    CoreFilepoolProvider.prototype.getPackageExtra = function (siteId, component, componentId) {
        return this.getPackageData(siteId, component, componentId).then(function (entry) {
            return entry.extra;
        });
    };
    /**
     * Get the ID of a package.
     *
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {string} Package ID.
     */
    CoreFilepoolProvider.prototype.getPackageId = function (component, componentId) {
        return __WEBPACK_IMPORTED_MODULE_17_ts_md5_dist_md5__["Md5"].hashAsciiStr(component + '#' + this.fixComponentId(componentId));
    };
    /**
     * Get a package previous status.
     *
     * @param {string} siteId Site ID.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<string>} Promise resolved with the status.
     */
    CoreFilepoolProvider.prototype.getPackagePreviousStatus = function (siteId, component, componentId) {
        return this.getPackageData(siteId, component, componentId).then(function (entry) {
            return entry.previous || __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        }).catch(function () {
            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        });
    };
    /**
     * Get a package status.
     *
     * @param {string} siteId Site ID.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<string>} Promise resolved with the status.
     */
    CoreFilepoolProvider.prototype.getPackageStatus = function (siteId, component, componentId) {
        return this.getPackageData(siteId, component, componentId).then(function (entry) {
            return entry.status || __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        }).catch(function () {
            return __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        });
    };
    /**
     * Return the array of arguments of the pluginfile url.
     *
     * @param {string} url URL to get the args.
     * @return {string[]} The args found, undefined if not a pluginfile.
     */
    CoreFilepoolProvider.prototype.getPluginFileArgs = function (url) {
        if (!this.urlUtils.isPluginFileUrl(url)) {
            // Not pluginfile, return.
            return;
        }
        var relativePath = url.substr(url.indexOf('/pluginfile.php') + 16), args = relativePath.split('/');
        if (args.length < 3) {
            // To be a plugin file it should have at least contextId, Component and Filearea.
            return;
        }
        return args;
    };
    /**
     * Get the deferred object for a file in the queue.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {boolean} [create=true] True if it should create a new deferred if it doesn't exist.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {any} Deferred.
     */
    CoreFilepoolProvider.prototype.getQueueDeferred = function (siteId, fileId, create, onProgress) {
        if (create === void 0) { create = true; }
        if (!this.queueDeferreds[siteId]) {
            if (!create) {
                return;
            }
            this.queueDeferreds[siteId] = {};
        }
        if (!this.queueDeferreds[siteId][fileId]) {
            if (!create) {
                return;
            }
            this.queueDeferreds[siteId][fileId] = this.utils.promiseDefer();
        }
        if (onProgress) {
            this.queueDeferreds[siteId][fileId].onProgress = onProgress;
        }
        return this.queueDeferreds[siteId][fileId];
    };
    /**
     * Get the on progress for a file in the queue.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @return {Function} On progress function, undefined if not found.
     */
    CoreFilepoolProvider.prototype.getQueueOnProgress = function (siteId, fileId) {
        var deferred = this.getQueueDeferred(siteId, fileId, false);
        if (deferred) {
            return deferred.onProgress;
        }
    };
    /**
     * Get the promise for a file in the queue.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {boolean} [create=true] True if it should create a new promise if it doesn't exist.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise.
     */
    CoreFilepoolProvider.prototype.getQueuePromise = function (siteId, fileId, create, onProgress) {
        if (create === void 0) { create = true; }
        return this.getQueueDeferred(siteId, fileId, create, onProgress).promise;
    };
    /**
     * Get a revision number from a list of files (highest revision).
     *
     * @param {any[]} files Package files.
     * @return {number} Highest revision.
     */
    CoreFilepoolProvider.prototype.getRevisionFromFileList = function (files) {
        var _this = this;
        var revision = 0;
        files.forEach(function (file) {
            if (file.url || file.fileurl) {
                var r = _this.getRevisionFromUrl(file.url || file.fileurl);
                if (r > revision) {
                    revision = r;
                }
            }
        });
        return revision;
    };
    /**
     * Get the revision number from a file URL.
     *
     * @param {string} url URL to get the revision number.
     * @return {number} Revision number.
     */
    CoreFilepoolProvider.prototype.getRevisionFromUrl = function (url) {
        var args = this.getPluginFileArgs(url);
        if (!args) {
            // Not a pluginfile, no revision will be found.
            return 0;
        }
        var revisionRegex = this.pluginFileDelegate.getComponentRevisionRegExp(args);
        if (!revisionRegex) {
            return 0;
        }
        var matches = url.match(revisionRegex);
        if (matches && typeof matches[1] != 'undefined') {
            return parseInt(matches[1], 10);
        }
        return 0;
    };
    /**
     * Returns an absolute URL to use in IMG tags.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The absolute URL to the file.
     * @param {string} [mode=url] The type of URL to return. Accepts 'url' or 'src'.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [timemodified=0] The time this file was modified.
     * @param {boolean} [checkSize=true] True if we shouldn't download files if their size is big, false otherwise.
     * @param {boolean} [downloadUnknown] True to download file in WiFi if their size is unknown, false otherwise.
     *                                    Ignored if checkSize=false.
     * @param {any} [options] Extra options (isexternalfile, repositorytype).
     * @param {number} [revision] File revision. If not defined, it will be calculated using the URL.
     * @return {Promise<string>} Resolved with the URL to use.
     * @description
     * This will return a URL pointing to the content of the requested URL.
     * The URL returned is compatible to use with IMG tags.
     */
    CoreFilepoolProvider.prototype.getSrcByUrl = function (siteId, fileUrl, component, componentId, timemodified, checkSize, downloadUnknown, options, revision) {
        if (timemodified === void 0) { timemodified = 0; }
        if (checkSize === void 0) { checkSize = true; }
        if (options === void 0) { options = {}; }
        return this.getFileUrlByUrl(siteId, fileUrl, component, componentId, 'src', timemodified, checkSize, downloadUnknown, options, revision);
    };
    /**
     * Get time modified from a list of files.
     *
     * @param {any[]} files List of files.
     * @return {number} Time modified.
     */
    CoreFilepoolProvider.prototype.getTimemodifiedFromFileList = function (files) {
        var timemodified = 0;
        files.forEach(function (file) {
            if (file.timemodified > timemodified) {
                timemodified = file.timemodified;
            }
        });
        return timemodified;
    };
    /**
     * Returns an absolute URL to access the file.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The absolute URL to the file.
     * @param {string} [mode=url] The type of URL to return. Accepts 'url' or 'src'.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [timemodified=0] The time this file was modified.
     * @param {boolean} [checkSize=true] True if we shouldn't download files if their size is big, false otherwise.
     * @param {boolean} [downloadUnknown] True to download file in WiFi if their size is unknown, false otherwise.
     *                                    Ignored if checkSize=false.
     * @param {any} [options] Extra options (isexternalfile, repositorytype).
     * @param {number} [revision] File revision. If not defined, it will be calculated using the URL.
     * @return {Promise<string>} Resolved with the URL to use.
     * @description
     * This will return a URL pointing to the content of the requested URL.
     * The URL returned is compatible to use with a local browser.
     */
    CoreFilepoolProvider.prototype.getUrlByUrl = function (siteId, fileUrl, component, componentId, timemodified, checkSize, downloadUnknown, options, revision) {
        if (timemodified === void 0) { timemodified = 0; }
        if (checkSize === void 0) { checkSize = true; }
        if (options === void 0) { options = {}; }
        return this.getFileUrlByUrl(siteId, fileUrl, component, componentId, 'url', timemodified, checkSize, downloadUnknown, options, revision);
    };
    /**
     * Guess the filename of a file from its URL. This is very weak and unreliable.
     *
     * @param {string} fileUrl The file URL.
     * @return {string}        The filename treated so it doesn't have any special character.
     */
    CoreFilepoolProvider.prototype.guessFilenameFromUrl = function (fileUrl) {
        var filename = '';
        if (fileUrl.indexOf('/webservice/pluginfile') !== -1) {
            // It's a pluginfile URL. Search for the 'file' param to extract the name.
            var params = this.urlUtils.extractUrlParams(fileUrl);
            if (params.file) {
                filename = params.file.substr(params.file.lastIndexOf('/') + 1);
            }
            else {
                // 'file' param not found. Extract what's after the last '/' without params.
                filename = this.urlUtils.getLastFileWithoutParams(fileUrl);
            }
        }
        else if (this.urlUtils.isGravatarUrl(fileUrl)) {
            // Extract gravatar ID.
            filename = 'gravatar_' + this.urlUtils.getLastFileWithoutParams(fileUrl);
        }
        else if (this.urlUtils.isThemeImageUrl(fileUrl)) {
            // Extract user ID.
            var matches = fileUrl.match(/\/core\/([^\/]*)\//);
            if (matches && matches[1]) {
                filename = matches[1];
            }
            // Attach a constant and the image type.
            filename = 'default_' + filename + '_' + this.urlUtils.getLastFileWithoutParams(fileUrl);
        }
        else {
            // Another URL. Just get what's after the last /.
            filename = this.urlUtils.getLastFileWithoutParams(fileUrl);
        }
        // Remove the extension from the filename.
        filename = this.mimeUtils.removeExtension(filename);
        return this.textUtils.removeSpecialCharactersForFiles(filename);
    };
    /**
     * Check if the file is already in the pool. This does not check if the file is on the disk.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise<CoreFilepoolFileEntry>} Resolved with file object from DB on success, rejected otherwise.
     */
    CoreFilepoolProvider.prototype.hasFileInPool = function (siteId, fileId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getRecord(_this.FILES_TABLE, { fileId: fileId }).then(function (entry) {
                if (typeof entry === 'undefined') {
                    return Promise.reject(null);
                }
                return entry;
            });
        });
    };
    /**
     * Check if the file is in the queue.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise} Resolved with file object from DB on success, rejected otherwise.
     */
    CoreFilepoolProvider.prototype.hasFileInQueue = function (siteId, fileId) {
        var _this = this;
        return this.appDB.getRecord(this.QUEUE_TABLE, { siteId: siteId, fileId: fileId }).then(function (entry) {
            if (typeof entry === 'undefined') {
                return Promise.reject(null);
            }
            // Convert the links to an object.
            entry.links = _this.textUtils.parseJSON(entry.links, []);
            return entry;
        });
    };
    /**
     * Invalidate all the files in a site.
     *
     * @param {string} siteId The site ID.
     * @param {boolean} [onlyUnknown=true] True to only invalidate files from external repos or without revision/timemodified.
     *                                     It is advised to set it to true to reduce the performance and data usage of the app.
     * @return {Promise<any>} Resolved on success.
     */
    CoreFilepoolProvider.prototype.invalidateAllFiles = function (siteId, onlyUnknown) {
        var _this = this;
        if (onlyUnknown === void 0) { onlyUnknown = true; }
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            var where, whereParams;
            if (onlyUnknown) {
                where = 'isexternalfile = ? OR (revision < ? AND timemodified = ?)';
                whereParams = [0, 1, 0];
            }
            return db.updateRecordsWhere(_this.FILES_TABLE, { stale: 1 }, where, whereParams);
        });
    };
    /**
     * Invalidate a file by URL.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise<any>} Resolved on success.
     * @description
     * Invalidates a file by marking it stale. It will not be added to the queue automatically, but the next time this file
     * is requested it will be added to the queue.
     * You can manully call addToQueueByUrl to add this file to the queue immediately.
     * Please note that, if a file is stale, the user will be presented the stale file if there is no network access.
     */
    CoreFilepoolProvider.prototype.invalidateFileByUrl = function (siteId, fileUrl) {
        var _this = this;
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
            var fileId = _this.getFileIdByUrl(fileUrl);
            return _this.sitesProvider.getSiteDb(siteId).then(function (db) {
                return db.updateRecords(_this.FILES_TABLE, { stale: 1 }, { fileId: fileId });
            });
        });
    };
    /**
     * Invalidate all the matching files from a component.
     *
     * @param {string} siteId The site ID.
     * @param {string} component The component to invalidate.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {boolean} [onlyUnknown=true] True to only invalidate files from external repos or without revision/timemodified.
     *                                     It is advised to set it to true to reduce the performance and data usage of the app.
     * @return {Promise<any>} Resolved when done.
     */
    CoreFilepoolProvider.prototype.invalidateFilesByComponent = function (siteId, component, componentId, onlyUnknown) {
        var _this = this;
        if (onlyUnknown === void 0) { onlyUnknown = true; }
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return _this.getComponentFiles(db, component, componentId).then(function (items) {
                var fileIds = items.map(function (item) {
                    return item.fileId;
                }), whereAndParams = db.getInOrEqual(fileIds);
                whereAndParams[0] = 'fileId ' + whereAndParams[0];
                if (onlyUnknown) {
                    whereAndParams[0] += ' AND (isexternalfile = ? OR (revision < ? AND timemodified = ?))';
                    whereAndParams[1] = whereAndParams[1].concat([0, 1, 0]);
                }
                return db.updateRecordsWhere(_this.FILES_TABLE, { stale: 1 }, whereAndParams[0], whereAndParams[1]);
            });
        });
    };
    /**
     * Check if a file is downloading.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl File URL.
     * @param {Promise<any>} Promise resolved if file is downloading, rejected otherwise.
     */
    CoreFilepoolProvider.prototype.isFileDownloadingByUrl = function (siteId, fileUrl) {
        var _this = this;
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
            var fileId = _this.getFileIdByUrl(fileUrl);
            return _this.hasFileInQueue(siteId, fileId);
        });
    };
    /**
     * Check if a file is outdated.
     *
     * @param {CoreFilepoolFileEntry} entry Filepool entry.
     * @param {number} [revision]  File revision number.
     * @param {number} [timemodified] The time this file was modified.
     * @param {boolean} Whether the file is outdated.
     */
    CoreFilepoolProvider.prototype.isFileOutdated = function (entry, revision, timemodified) {
        return !!entry.stale || revision > entry.revision || timemodified > entry.timemodified;
    };
    /**
     * Check if cannot determine if a file has been updated.
     *
     * @param {CoreFilepoolFileEntry} entry Filepool entry.
     * @return {boolean} Whether it cannot determine updates.
     */
    CoreFilepoolProvider.prototype.isFileUpdateUnknown = function (entry) {
        return !!entry.isexternalfile || (entry.revision < 1 && !entry.timemodified);
    };
    /**
     * Notify a file has been deleted.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     */
    CoreFilepoolProvider.prototype.notifyFileDeleted = function (siteId, fileId) {
        this.eventsProvider.trigger(this.getFileEventName(siteId, fileId), { action: 'deleted' });
    };
    /**
     * Notify a file has been downloaded.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     */
    CoreFilepoolProvider.prototype.notifyFileDownloaded = function (siteId, fileId) {
        this.eventsProvider.trigger(this.getFileEventName(siteId, fileId), { action: 'download', success: true });
    };
    /**
     * Notify error occurred while downloading a file.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     */
    CoreFilepoolProvider.prototype.notifyFileDownloadError = function (siteId, fileId) {
        this.eventsProvider.trigger(this.getFileEventName(siteId, fileId), { action: 'download', success: false });
    };
    /**
     * Notify a file starts being downloaded or added to queue.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     */
    CoreFilepoolProvider.prototype.notifyFileDownloading = function (siteId, fileId) {
        this.eventsProvider.trigger(this.getFileEventName(siteId, fileId), { action: 'downloading' });
    };
    /**
     * Notify a file has been outdated.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     */
    CoreFilepoolProvider.prototype.notifyFileOutdated = function (siteId, fileId) {
        this.eventsProvider.trigger(this.getFileEventName(siteId, fileId), { action: 'outdated' });
    };
    /**
     * Prefetches a list of files.
     *
     * @param {string} siteId The site ID.
     * @param {any[]} fileList List of files to download.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to identify the download.
     * @param {string} [extra] Extra data to store for the package.
     * @param {string} [dirPath] Name of the directory where to store the files (inside filepool dir). If not defined, store
     *                           the files directly inside the filepool folder.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>}  Promise resolved when all files are downloaded.
     */
    CoreFilepoolProvider.prototype.prefetchPackage = function (siteId, fileList, component, componentId, extra, dirPath, onProgress) {
        return this.downloadOrPrefetchPackage(siteId, fileList, true, component, componentId, extra, dirPath, onProgress);
    };
    /**
     * Process the queue.
     *
     * @description
     * This loops over itself to keep on processing the queue in the background.
     * The queue process is site agnostic.
     */
    CoreFilepoolProvider.prototype.processQueue = function () {
        var _this = this;
        var promise;
        if (this.queueState !== this.QUEUE_RUNNING) {
            // Silently ignore, the queue is on pause.
            promise = Promise.reject(this.ERR_QUEUE_ON_PAUSE);
        }
        else if (!this.fileProvider.isAvailable() || !this.appProvider.isOnline()) {
            promise = Promise.reject(this.ERR_FS_OR_NETWORK_UNAVAILABLE);
        }
        else {
            promise = this.processImportantQueueItem();
        }
        promise.then(function () {
            // All good, we schedule next execution.
            setTimeout(function () {
                _this.processQueue();
            }, _this.QUEUE_PROCESS_INTERVAL);
        }, function (error) {
            // We had an error, in which case we pause the processing.
            if (error === _this.ERR_FS_OR_NETWORK_UNAVAILABLE) {
                _this.logger.debug('Filesysem or network unavailable, pausing queue processing.');
            }
            else if (error === _this.ERR_QUEUE_IS_EMPTY) {
                _this.logger.debug('Queue is empty, pausing queue processing.');
            }
            _this.queueState = _this.QUEUE_PAUSED;
        });
    };
    /**
     * Process the most important queue item.
     *
     * @return {Promise} Resolved on success. Rejected on failure.
     */
    CoreFilepoolProvider.prototype.processImportantQueueItem = function () {
        var _this = this;
        return this.appDB.getRecords(this.QUEUE_TABLE, undefined, 'priority DESC, added ASC', undefined, 0, 1).then(function (items) {
            var item = items.pop();
            if (!item) {
                return Promise.reject(_this.ERR_QUEUE_IS_EMPTY);
            }
            // Convert the links to an object.
            item.links = _this.textUtils.parseJSON(item.links, []);
            return _this.processQueueItem(item);
        }, function () {
            return Promise.reject(_this.ERR_QUEUE_IS_EMPTY);
        });
    };
    /**
     * Process a queue item.
     *
     * @param {CoreFilepoolQueueEntry} item The object from the queue store.
     * @return {Promise<any>} Resolved on success. Rejected on failure.
     */
    CoreFilepoolProvider.prototype.processQueueItem = function (item) {
        var _this = this;
        // Cast optional fields to undefined instead of null.
        var siteId = item.siteId, fileId = item.fileId, fileUrl = item.url, options = {
            revision: item.revision || undefined,
            timemodified: item.timemodified || undefined,
            isexternalfile: item.isexternalfile || undefined,
            repositorytype: item.repositorytype || undefined
        }, filePath = item.path || undefined, links = item.links || [];
        this.logger.debug('Processing queue item: ' + siteId + ', ' + fileId);
        // Check if the file is already in pool.
        return this.hasFileInPool(siteId, fileId).catch(function () {
            // File not in pool.
        }).then(function (entry) {
            if (entry && !options.isexternalfile && !_this.isFileOutdated(entry, options.revision, options.timemodified)) {
                // We have the file, it is not stale, we can update links and remove from queue.
                _this.logger.debug('Queued file already in store, ignoring...');
                _this.addFileLinks(siteId, fileId, links).catch(function () {
                    // Ignore errors.
                });
                _this.removeFromQueue(siteId, fileId).catch(function () {
                    // Ignore errors.
                }).finally(function () {
                    _this.treatQueueDeferred(siteId, fileId, true);
                });
                _this.notifyFileDownloaded(siteId, fileId);
                return;
            }
            // The file does not exist, or is stale, ... download it.
            var onProgress = _this.getQueueOnProgress(siteId, fileId);
            return _this.downloadForPoolByUrl(siteId, fileUrl, options, filePath, onProgress, entry).then(function () {
                // Success, we add links and remove from queue.
                _this.addFileLinks(siteId, fileId, links).catch(function () {
                    // Ignore errors.
                });
                _this.treatQueueDeferred(siteId, fileId, true);
                _this.notifyFileDownloaded(siteId, fileId);
                // Wait for the item to be removed from queue before resolving the promise.
                // If the item could not be removed from queue we still resolve the promise.
                return _this.removeFromQueue(siteId, fileId).catch(function () {
                    // Ignore errors.
                });
            }, function (errorObject) {
                // Whoops, we have an error...
                var dropFromQueue = false;
                if (errorObject && errorObject.source === fileUrl) {
                    // This is most likely a FileTransfer error.
                    if (errorObject.code === 1) {
                        // The file was not found, most likely a 404, we remove from queue.
                        dropFromQueue = true;
                    }
                    else if (errorObject.code === 2) {
                        // The URL is invalid, we drop the file from the queue.
                        dropFromQueue = true;
                    }
                    else if (errorObject.code === 3) {
                        // If there was an HTTP status, then let's remove from the queue.
                        dropFromQueue = true;
                    }
                    else if (errorObject.code === 4) {
                        // The transfer was aborted, we will keep the file in queue.
                    }
                    else if (errorObject.code === 5) {
                        // We have the latest version of the file, HTTP 304 status.
                        dropFromQueue = true;
                    }
                    else {
                        // Unknown error, let's remove the file from the queue to avoi locking down the queue.
                        dropFromQueue = true;
                    }
                }
                else {
                    dropFromQueue = true;
                }
                var errorMessage = null;
                // Some Android devices restrict the amount of usable storage using quotas.
                // If this quota would be exceeded by the download, it throws an exception.
                // We catch this exception here, and report a meaningful error message to the user.
                if (errorObject instanceof FileTransferError && errorObject.exception && errorObject.exception.includes('EDQUOT')) {
                    errorMessage = 'core.course.insufficientavailablequota';
                }
                if (dropFromQueue) {
                    _this.logger.debug('Item dropped from queue due to error: ' + fileUrl, errorObject);
                    return _this.removeFromQueue(siteId, fileId).catch(function () {
                        // Consider this as a silent error, never reject the promise here.
                    }).then(function () {
                        _this.treatQueueDeferred(siteId, fileId, false, errorMessage);
                        _this.notifyFileDownloadError(siteId, fileId);
                    });
                }
                else {
                    // We considered the file as legit but did not get it, failure.
                    _this.treatQueueDeferred(siteId, fileId, false, errorMessage);
                    _this.notifyFileDownloadError(siteId, fileId);
                    return Promise.reject(errorObject);
                }
            });
        });
    };
    /**
     * Remove a file from the queue.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @return {Promise<any>} Resolved on success. Rejected on failure. It is advised to silently ignore failures.
     */
    CoreFilepoolProvider.prototype.removeFromQueue = function (siteId, fileId) {
        return this.appDB.deleteRecords(this.QUEUE_TABLE, { siteId: siteId, fileId: fileId });
    };
    /**
     * Remove a file from the pool.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @return {Promise<any>} Resolved on success.
     */
    CoreFilepoolProvider.prototype.removeFileById = function (siteId, fileId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            // Get the path to the file first since it relies on the file object stored in the pool.
            return Promise.resolve(_this.getFilePath(siteId, fileId)).then(function (path) {
                var promises = [];
                // Remove entry from filepool store.
                promises.push(db.deleteRecords(_this.FILES_TABLE, { fileId: fileId }));
                // Remove links.
                promises.push(db.deleteRecords(_this.LINKS_TABLE, { fileId: fileId }));
                // Remove the file.
                if (_this.fileProvider.isAvailable()) {
                    promises.push(_this.fileProvider.removeFile(path).catch(function (error) {
                        if (error && error.code == 1) {
                            // Not found, ignore error since maybe it was deleted already.
                        }
                        else {
                            return Promise.reject(error);
                        }
                    }));
                }
                return Promise.all(promises).then(function () {
                    _this.notifyFileDeleted(siteId, fileId);
                });
            });
        });
    };
    /**
     * Delete all the matching files from a component.
     *
     * @param {string} siteId The site ID.
     * @param {string} component The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<any>} Resolved on success.
     */
    CoreFilepoolProvider.prototype.removeFilesByComponent = function (siteId, component, componentId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return _this.getComponentFiles(db, component, componentId);
        }).then(function (items) {
            return Promise.all(items.map(function (item) {
                return _this.removeFileById(siteId, item.fileId);
            }));
        });
    };
    /**
     * Remove a file from the pool.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileUrl The file URL.
     * @return {Promise<any>} Resolved on success, rejected on failure.
     */
    CoreFilepoolProvider.prototype.removeFileByUrl = function (siteId, fileUrl) {
        var _this = this;
        return this.fixPluginfileURL(siteId, fileUrl).then(function (fileUrl) {
            var fileId = _this.getFileIdByUrl(fileUrl);
            return _this.removeFileById(siteId, fileId);
        });
    };
    /**
     * Removes the revision number from a file URL.
     *
     * @param {string} url URL to remove the revision number.
     * @return {string} URL without revision number.
     * @description
     * The revision is used to know if a file has changed. We remove it from the URL to prevent storing a file per revision.
     */
    CoreFilepoolProvider.prototype.removeRevisionFromUrl = function (url) {
        var args = this.getPluginFileArgs(url);
        if (!args) {
            // Not a pluginfile, no revision will be found.
            return url;
        }
        return this.pluginFileDelegate.removeRevisionFromUrl(url, args);
    };
    /**
     * Change the package status, setting it to the previous status.
     *
     * @param {string} siteId Site ID.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<string>} Promise resolved when the status is changed. Resolve param: new status.
     */
    CoreFilepoolProvider.prototype.setPackagePreviousStatus = function (siteId, component, componentId) {
        var _this = this;
        componentId = this.fixComponentId(componentId);
        this.logger.debug("Set previous status for package " + component + " " + componentId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var packageId = _this.getPackageId(component, componentId);
            // Get current stored data, we'll only update 'status' and 'updated' fields.
            return site.getDb().getRecord(_this.PACKAGES_TABLE, { id: packageId }).then(function (entry) {
                var newData = {};
                if (entry.status == __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
                    // Going back from downloading to previous status, restore previous download time.
                    newData.downloadTime = entry.previousDownloadTime;
                }
                newData.status = entry.previous || __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
                newData.updated = Date.now();
                _this.logger.debug("Set previous status '" + entry.status + "' for package " + component + " " + componentId);
                return site.getDb().updateRecords(_this.PACKAGES_TABLE, newData, { id: packageId }).then(function () {
                    // Success updating, trigger event.
                    _this.triggerPackageStatusChanged(site.id, newData.status, component, componentId);
                    return newData.status;
                });
            });
        });
    };
    /**
     * Convenience function to check if a file should be downloaded before opening it.
     *
     * @param {string} url File online URL.
     * @param {number} size File size.
     * @return {Promise}     Promise resolved if should download before open, rejected otherwise.
     * @description
     * Convenience function to check if a file should be downloaded before opening it.
     *
     * The default behaviour in the app is to download first and then open the local file in the following cases:
     *     - The file is small (less than DOWNLOAD_THRESHOLD).
     *     - The file cannot be streamed.
     * If the file is big and can be streamed, the promise returned by this function will be rejected.
     */
    CoreFilepoolProvider.prototype.shouldDownloadBeforeOpen = function (url, size) {
        if (size >= 0 && size <= this.DOWNLOAD_THRESHOLD) {
            // The file is small, download it.
            return Promise.resolve();
        }
        if (this.appProvider.isDesktop()) {
            // In desktop always download first.
            return Promise.resolve();
        }
        return this.utils.getMimeTypeFromUrl(url).then(function (mimetype) {
            // If the file is streaming (audio or video) we reject.
            if (mimetype.indexOf('video') != -1 || mimetype.indexOf('audio') != -1) {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Store package status.
     *
     * @param {string} siteId Site ID.
     * @param {string} status New package status.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {string} [extra] Extra data to store for the package. If you want to store more than 1 value, use JSON.stringify.
     * @return {Promise<any>} Promise resolved when status is stored.
     */
    CoreFilepoolProvider.prototype.storePackageStatus = function (siteId, status, component, componentId, extra) {
        var _this = this;
        this.logger.debug("Set status '" + status + "' for package " + component + " " + componentId);
        componentId = this.fixComponentId(componentId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var packageId = _this.getPackageId(component, componentId);
            var downloadTime, previousDownloadTime;
            if (status == __WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
                // Set download time if package is now downloading.
                downloadTime = _this.timeUtils.timestamp();
            }
            // Search current status to set it as previous status.
            return site.getDb().getRecord(_this.PACKAGES_TABLE, { id: packageId }).then(function (entry) {
                if (typeof extra == 'undefined' || extra === null) {
                    extra = entry.extra;
                }
                if (typeof downloadTime == 'undefined') {
                    // Keep previous download time.
                    downloadTime = entry.downloadTime;
                    previousDownloadTime = entry.previousDownloadTime;
                }
                else {
                    // The downloadTime will be updated, store current time as previous.
                    previousDownloadTime = entry.downloadTime;
                }
                return entry.status;
            }).catch(function () {
                // No previous status.
            }).then(function (previousStatus) {
                var packageEntry = {
                    id: packageId,
                    component: component,
                    componentId: componentId,
                    status: status,
                    previous: previousStatus,
                    updated: Date.now(),
                    downloadTime: downloadTime,
                    previousDownloadTime: previousDownloadTime,
                    extra: extra
                };
                var promise;
                if (previousStatus === status) {
                    // The package already has this status, no need to change it.
                    promise = Promise.resolve();
                }
                else {
                    promise = site.getDb().insertRecord(_this.PACKAGES_TABLE, packageEntry);
                }
                return promise.then(function () {
                    // Success inserting, trigger event.
                    _this.triggerPackageStatusChanged(siteId, status, component, componentId);
                });
            });
        });
    };
    /**
     * Search for files in a CSS code and try to download them. Once downloaded, replace their URLs
     * and store the result in the CSS file.
     *
     * @param {string} siteId  Site ID.
     * @param {string} fileUrl CSS file URL.
     * @param {string} cssCode CSS code.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [revision] Revision to use in all files. If not defined, it will be calculated using the URL of each file.
     * @return {Promise<string>} Promise resolved with the CSS code.
     */
    CoreFilepoolProvider.prototype.treatCSSCode = function (siteId, fileUrl, cssCode, component, componentId, revision) {
        var _this = this;
        var urls = this.domUtils.extractUrlsFromCSS(cssCode), promises = [];
        var filePath, updated = false;
        // Get the path of the CSS file.
        promises.push(this.getFilePathByUrl(siteId, fileUrl).then(function (path) {
            filePath = path;
        }));
        urls.forEach(function (url) {
            // Download the file only if it's an online URL.
            if (url.indexOf('http') == 0) {
                promises.push(_this.downloadUrl(siteId, url, false, component, componentId, 0, undefined, undefined, undefined, revision).then(function (fileUrl) {
                    if (fileUrl != url) {
                        cssCode = cssCode.replace(new RegExp(_this.textUtils.escapeForRegex(url), 'g'), fileUrl);
                        updated = true;
                    }
                }).catch(function (error) {
                    // It shouldn't happen. Ignore errors.
                    _this.logger.warn('Error treating file ', url, error);
                }));
            }
        });
        return Promise.all(promises).then(function () {
            // All files downloaded. Store the result if it has changed.
            if (updated) {
                return _this.fileProvider.writeFile(filePath, cssCode);
            }
        }).then(function () {
            return cssCode;
        });
    };
    /**
     * Remove extension from fileId in queue, used to migrate from previous file handling.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFilepoolProvider.prototype.treatExtensionInQueue = function () {
        var _this = this;
        this.logger.debug('Treat extensions in queue');
        return this.appDB.getAllRecords(this.QUEUE_TABLE).then(function (entries) {
            var promises = [];
            entries.forEach(function (entry) {
                // For files in the queue, we only need to remove the extension from the fileId.
                // After downloading, additional info will be added.
                var fileId = entry.fileId;
                entry.fileId = _this.mimeUtils.removeExtension(fileId);
                if (fileId == entry.fileId) {
                    return;
                }
                promises.push(_this.appDB.updateRecords(_this.QUEUE_TABLE, { fileId: entry.fileId }, { fileId: fileId }));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Resolves or rejects a queue deferred and removes it from the list.
     *
     * @param {string} siteId The site ID.
     * @param {string} fileId The file ID.
     * @param {boolean} resolve True if promise should be resolved, false if it should be rejected.
     * @param {string} error String identifier for error message, if rejected.
     */
    CoreFilepoolProvider.prototype.treatQueueDeferred = function (siteId, fileId, resolve, error) {
        if (this.queueDeferreds[siteId] && this.queueDeferreds[siteId][fileId]) {
            if (resolve) {
                this.queueDeferreds[siteId][fileId].resolve();
            }
            else {
                this.queueDeferreds[siteId][fileId].reject(error);
            }
            delete this.queueDeferreds[siteId][fileId];
        }
    };
    /**
     * Trigger mmCoreEventPackageStatusChanged with the right data.
     *
     * @param {string} siteId Site ID.
     * @param {string} status New package status.
     * @param {string} component  Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     */
    CoreFilepoolProvider.prototype.triggerPackageStatusChanged = function (siteId, status, component, componentId) {
        var data = {
            component: component,
            componentId: this.fixComponentId(componentId),
            status: status
        };
        this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__events__["a" /* CoreEventsProvider */].PACKAGE_STATUS_CHANGED, data, siteId);
    };
    /**
     * Update the download time of a package. This doesn't modify the previous download time.
     * This function should be used if a package generates some new data during a download. Calling this function
     * right after generating the data in the download will prevent detecting this data as an update.
     *
     * @param {string} siteId Site ID.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @return {Promise<any>} Promise resolved when status is stored.
     */
    CoreFilepoolProvider.prototype.updatePackageDownloadTime = function (siteId, component, componentId) {
        var _this = this;
        componentId = this.fixComponentId(componentId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var packageId = _this.getPackageId(component, componentId);
            return site.getDb().updateRecords(_this.PACKAGES_TABLE, { downloadTime: _this.timeUtils.timestamp() }, { id: packageId });
        });
    };
    CoreFilepoolProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_4__file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_8__sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_9__ws__["a" /* CoreWSProvider */], __WEBPACK_IMPORTED_MODULE_12__utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_15__utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_11__utils_mimetype__["a" /* CoreMimetypeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_14__utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_5__init__["a" /* CoreInitDelegate */],
            __WEBPACK_IMPORTED_MODULE_1__ionic_native_network__["a" /* Network */], __WEBPACK_IMPORTED_MODULE_7__plugin_file_delegate__["a" /* CorePluginFileDelegate */], __WEBPACK_IMPORTED_MODULE_10__utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"]])
    ], CoreFilepoolProvider);
    return CoreFilepoolProvider;
}());

//# sourceMappingURL=filepool.js.map

/***/ }),
/* 23 */,
/* 24 */,
/* 25 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSite; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_db__ = __webpack_require__(340);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_15_ts_md5_dist_md5__);
/*
 * @Description: In User Settings Edit
 * @Author: your name
 * @Date: 2019-07-25 13:24:30
 * @LastEditTime: 2019-10-10 10:49:39
 * @LastEditors: Please set LastEditors
 */
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
















/**
 * Class that represents a site (combination of site + user).
 * It will have all the site data and provide utility functions regarding a site.
 * To add tables to the site's database, please use CoreSitesProvider.createTablesFromSchema. This will make sure that
 * the tables are created in all the sites, not just the current one.
 */
var CoreSite = /** @class */ (function () {
    /**
     * Create a site.
     *
     * @param {Injector} injector Angular injector to prevent having to pass all the required services.
     * @param {string} id Site ID.
     * @param {string} siteUrl Site URL.
     * @param {string} [token] Site's WS token.
     * @param {any} [info] Site info.
     * @param {string} [privateToken] Private token.
     * @param {any} [config] Site public config.
     * @param {boolean} [loggedOut] Whether user is logged out.
     */
    function CoreSite(injector, id, siteUrl, token, infos, privateToken, config, loggedOut) {
        this.id = id;
        this.siteUrl = siteUrl;
        this.token = token;
        this.infos = infos;
        this.privateToken = privateToken;
        this.config = config;
        this.loggedOut = loggedOut;
        // Versions of Moodle releases.
        this.MOODLE_RELEASES = {
            3.1: 2016052300,
            3.2: 2016120500,
            3.3: 2017051503,
            3.4: 2017111300,
            3.5: 2018051700,
            3.6: 2018120300,
            3.7: 2019052000
        };
        // Possible cache update frequencies.
        this.UPDATE_FREQUENCIES = [
            __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].cache_update_frequency_usually || 420000,
            __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].cache_update_frequency_often || 1200000,
            __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].cache_update_frequency_sometimes || 3600000,
            __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].cache_update_frequency_rarely || 43200000
        ];
        this.cleanUnicode = false;
        this.lastAutoLogin = 0;
        this.offlineDisabled = false;
        this.ongoingRequests = {};
        this.requestQueue = [];
        this.requestQueueTimeout = null;
        // Inject the required services.
        var logger = injector.get(__WEBPACK_IMPORTED_MODULE_6__providers_logger__["a" /* CoreLoggerProvider */]);
        this.appProvider = injector.get(__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */]);
        this.dbProvider = injector.get(__WEBPACK_IMPORTED_MODULE_3__providers_db__["a" /* CoreDbProvider */]);
        this.domUtils = injector.get(__WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__["a" /* CoreDomUtilsProvider */]);
        this.eventsProvider = injector.get(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */]);
        this.fileProvider = injector.get(__WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */]);
        this.http = injector.get(__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]);
        this.textUtils = injector.get(__WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */]);
        this.timeUtils = injector.get(__WEBPACK_IMPORTED_MODULE_10__providers_utils_time__["a" /* CoreTimeUtilsProvider */]);
        this.translate = injector.get(__WEBPACK_IMPORTED_MODULE_0__ngx_translate_core__["c" /* TranslateService */]);
        this.utils = injector.get(__WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__["a" /* CoreUtilsProvider */]);
        this.urlUtils = injector.get(__WEBPACK_IMPORTED_MODULE_11__providers_utils_url__["a" /* CoreUrlUtilsProvider */]);
        this.wsProvider = injector.get(__WEBPACK_IMPORTED_MODULE_7__providers_ws__["a" /* CoreWSProvider */]);
        this.logger = logger.getInstance('CoreWSProvider');
        this.setInfo(infos);
        this.calculateOfflineDisabled();
        if (this.id) {
            this.initDB();
        }
    }
    /**
     * Initialize the database.
     */
    CoreSite.prototype.initDB = function () {
        this.db = this.dbProvider.getDB('Site-' + this.id);
    };
    /**
     * Get site ID.
     *
     * @return {string} Site ID.
     */
    CoreSite.prototype.getId = function () {
        return this.id;
    };
    /**
     * Get site URL.
     *
     * @return {string} Site URL.
     */
    CoreSite.prototype.getURL = function () {
        return this.siteUrl;
    };
    /**
     * Get site token.
     *
     * @return {string} Site token.
     */
    CoreSite.prototype.getToken = function () {
        return this.token;
    };
    /**
     * Get site info.
     *
     * @return {any} Site info.
     */
    CoreSite.prototype.getInfo = function () {
        return this.infos;
    };
    /**
     * Get site private token.
     *
     * @return {string} Site private token.
     */
    CoreSite.prototype.getPrivateToken = function () {
        return this.privateToken;
    };
    /**
     * Get site DB.
     *
     * @return {SQLiteDB} Site DB.
     */
    CoreSite.prototype.getDb = function () {
        return this.db;
    };
    /**
     * Get site user's ID.
     *
     * @return {number} User's ID.
     */
    CoreSite.prototype.getUserId = function () {
        if (typeof this.infos != 'undefined' && typeof this.infos.userid != 'undefined') {
            return this.infos.userid;
        }
    };
    /**
     * Get site Course ID for frontpage course. If not declared it will return 1 as default.
     *
     * @return {number} Site Home ID.
     */
    CoreSite.prototype.getSiteHomeId = function () {
        return this.infos && this.infos.siteid || 1;
    };
    /**
     * Get site name.
     *
     * @return {string} Site name.
     */
    CoreSite.prototype.getSiteName = function () {
        if (__WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].sitename) {
            // Overridden by config.
            return __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].sitename;
        }
        else {
            return this.infos && this.infos.sitename || '';
        }
    };
    /**
     * Set site ID.
     *
     * @param {string} New ID.
     */
    CoreSite.prototype.setId = function (id) {
        this.id = id;
        this.initDB();
    };
    /**
     * Set site token.
     *
     * @param {string} New token.
     */
    CoreSite.prototype.setToken = function (token) {
        this.token = token;
    };
    /**
     * Set site private token.
     *
     * @param {string} privateToken New private token.
     */
    CoreSite.prototype.setPrivateToken = function (privateToken) {
        this.privateToken = privateToken;
    };
    /**
     * Check if user logged out from the site and needs to authenticate again.
     *
     * @return {boolean} Whether is logged out.
     */
    CoreSite.prototype.isLoggedOut = function () {
        return !!this.loggedOut;
    };
    /**
     * Set site info.
     *
     * @param {any} New info.
     */
    CoreSite.prototype.setInfo = function (infos) {
        this.infos = infos;
        // Index function by name to speed up wsAvailable method.
        if (infos && infos.functions) {
            infos.functionsByName = {};
            infos.functions.forEach(function (func) {
                infos.functionsByName[func.name] = func;
            });
        }
    };
    /**
     * Set site config.
     *
     * @param {any} Config.
     */
    CoreSite.prototype.setConfig = function (config) {
        if (config) {
            config.tool_mobile_disabledfeatures = this.textUtils.treatDisabledFeatures(config.tool_mobile_disabledfeatures);
        }
        this.config = config;
        this.calculateOfflineDisabled();
    };
    /**
     * Set site logged out.
     *
     * @param {boolean} loggedOut True if logged out and needs to authenticate again, false otherwise.
     */
    CoreSite.prototype.setLoggedOut = function (loggedOut) {
        this.loggedOut = !!loggedOut;
    };
    /**
     * Can the user access their private files?
     *
     * @return {boolean} Whether can access my files.
     */
    CoreSite.prototype.canAccessMyFiles = function () {
        var infos = this.getInfo();
        return infos && (typeof infos.usercanmanageownfiles === 'undefined' || infos.usercanmanageownfiles);
    };
    /**
     * Can the user download files?
     *
     * @return {boolean} Whether can download files.
     */
    CoreSite.prototype.canDownloadFiles = function () {
        var infos = this.getInfo();
        return infos && infos.downloadfiles;
    };
    /**
     * Can the user use an advanced feature?
     *
     * @param {string} feature The name of the feature.
     * @param {boolean} [whenUndefined=true] The value to return when the parameter is undefined.
     * @return {boolean} Whether can use advanced feature.
     */
    CoreSite.prototype.canUseAdvancedFeature = function (feature, whenUndefined) {
        if (whenUndefined === void 0) { whenUndefined = true; }
        var infos = this.getInfo();
        var canUse = true;
        if (typeof infos.advancedfeatures === 'undefined') {
            canUse = whenUndefined;
        }
        else {
            for (var i in infos.advancedfeatures) {
                var item = infos.advancedfeatures[i];
                if (item.name === feature && parseInt(item.value, 10) === 0) {
                    canUse = false;
                }
            }
        }
        return canUse;
    };
    /**
     * Can the user upload files?
     *
     * @return {boolean} Whether can upload files.
     */
    CoreSite.prototype.canUploadFiles = function () {
        var infos = this.getInfo();
        return infos && infos.uploadfiles;
    };
    /**
     * Fetch site info from the Moodle site.
     *
     * @return {Promise<any>} A promise to be resolved when the site info is retrieved.
     */
    CoreSite.prototype.fetchSiteInfo = function () {
        // The get_site_info WS call won't be cached.
        var preSets = {
            getFromCache: false,
            saveToCache: false,
            skipQueue: true
        };
        // Reset clean Unicode to check if it's supported again.
        this.cleanUnicode = false;
        return this.read('core_webservice_get_site_info', {}, preSets);
    };
    /**
     * Read some data from the Moodle site using WS. Requests are cached by default.
     *
     * @param {string} method WS method to use.
     * @param {any} data Data to send to the WS.
     * @param {CoreSiteWSPreSets} [preSets] Extra options.
     * @return {Promise<any>} Promise resolved with the response, rejected with CoreWSError if it fails.
     */
    CoreSite.prototype.read = function (method, data, preSets) {
        preSets = preSets || {};
        if (typeof preSets.getFromCache == 'undefined') {
            preSets.getFromCache = true;
        }
        if (typeof preSets.saveToCache == 'undefined') {
            preSets.saveToCache = true;
        }
        if (typeof preSets.reusePending == 'undefined') {
            preSets.reusePending = true;
        }
        return this.request(method, data, preSets);
    };
    /**
     * Sends some data to the Moodle site using WS. Requests are NOT cached by default.
     *
     * @param {string} method  WS method to use.
     * @param {any} data Data to send to the WS.
     * @param {CoreSiteWSPreSets} [preSets] Extra options.
     * @return {Promise<any>} Promise resolved with the response, rejected with CoreWSError if it fails.
     */
    CoreSite.prototype.write = function (method, data, preSets) {
        preSets = preSets || {};
        if (typeof preSets.getFromCache == 'undefined') {
            preSets.getFromCache = false;
        }
        if (typeof preSets.saveToCache == 'undefined') {
            preSets.saveToCache = false;
        }
        if (typeof preSets.emergencyCache == 'undefined') {
            preSets.emergencyCache = false;
        }
        return this.request(method, data, preSets);
    };
    /**
     * WS request to the site.
     *
     * @param {string} method The WebService method to be called.
     * @param {any} data Arguments to pass to the method.
     * @param {CoreSiteWSPreSets} preSets Extra options.
     * @param {boolean} [retrying] True if we're retrying the call for some reason. This is to prevent infinite loops.
     * @return {Promise<any>} Promise resolved with the response, rejected with CoreWSError if it fails.
     * @description
     *
     * Sends a webservice request to the site. This method will automatically add the
     * required parameters and pass it on to the low level API in CoreWSProvider.call().
     *
     * Caching is also implemented, when enabled this method will returned a cached version of the request if the
     * data hasn't expired.
     *
     * This method is smart which means that it will try to map the method to a compatibility one if need be, usually this
     * means that it will fallback on the 'local_mobile_' prefixed function if it is available and the non-prefixed is not.
     */
    CoreSite.prototype.request = function (method, data, preSets, retrying) {
        var _this = this;
        var initialToken = this.token;
        data = data || {};
        if (!this.appProvider.isOnline() && this.offlineDisabled) {
            return Promise.reject(this.wsProvider.createFakeWSError('core.errorofflinedisabled', true));
        }
        // Check if the method is available, use a prefixed version if possible.
        // We ignore this check when we do not have the site info, as the list of functions is not loaded yet.
        if (this.getInfo() && !this.wsAvailable(method, false)) {
            var compatibilityMethod = __WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].WS_PREFIX + method;
            if (this.wsAvailable(compatibilityMethod, false)) {
                this.logger.info("Using compatibility WS method '" + compatibilityMethod + "'");
                method = compatibilityMethod;
            }
            else {
                this.logger.error("WS function '" + method + "' is not available, even in compatibility mode.");
                return Promise.reject(this.utils.createFakeWSError('core.wsfunctionnotavailable', true));
            }
        }
        var wsPreSets = {
            wsToken: this.token,
            siteUrl: this.siteUrl,
            cleanUnicode: this.cleanUnicode,
            typeExpected: preSets.typeExpected,
            responseExpected: preSets.responseExpected
        };
        if (wsPreSets.cleanUnicode && this.textUtils.hasUnicodeData(data)) {
            // Data will be cleaned, notify the user.
            this.domUtils.showToast('core.unicodenotsupported', true, 3000);
        }
        else {
            // No need to clean data in this call.
            wsPreSets.cleanUnicode = false;
        }
        if (this.offlineDisabled) {
            // Offline is disabled, don't use cache.
            preSets.getFromCache = false;
            preSets.saveToCache = false;
            preSets.emergencyCache = false;
        }
        // Enable text filtering by default.
        data.moodlewssettingfilter = preSets.filter === false ? false : true;
        data.moodlewssettingfileurl = preSets.rewriteurls === false ? false : true;
        var originalData = data;
        // Convert arguments to strings before starting the cache process.
        data = this.wsProvider.convertValuesToString(data, wsPreSets.cleanUnicode);
        if (data == null) {
            // Empty cleaned text found.
            return Promise.reject(this.utils.createFakeWSError('core.unicodenotsupportedcleanerror', true));
        }
        var cacheId = this.getCacheId(method, data);
        // Check for an ongoing identical request if we're not ignoring cache.
        if (preSets.getFromCache && this.ongoingRequests[cacheId]) {
            return this.ongoingRequests[cacheId].then(function (response) {
                // Clone the data, this may prevent errors if in the callback the object is modified.
                return _this.utils.clone(response);
            });
        }
        if (method == 'core_course_get_contents') {
            return this.callOrEnqueueRequest(method, data, preSets, wsPreSets);
        }
        var promise = this.getFromCache(method, data, preSets, false, originalData).catch(function () {
            // Do not pass those options to the core WS factory.
            return _this.callOrEnqueueRequest(method, data, preSets, wsPreSets).then(function (response) {
                if (preSets.saveToCache) {
                    _this.saveToCache(method, data, response, preSets);
                }
                return response;
            }).catch(function (error) {
                if (error.errorcode == 'invalidtoken' ||
                    (error.errorcode == 'accessexception' && error.message.indexOf('Invalid token - token expired') > -1)) {
                    if (initialToken !== _this.token && !retrying) {
                        // Token has changed, retry with the new token.
                        preSets.getFromCache = false; // Don't check cache now. Also, it will skip ongoingRequests.
                        return _this.request(method, data, preSets, true);
                    }
                    else if (_this.appProvider.isSSOAuthenticationOngoing()) {
                        // There's an SSO authentication ongoing, wait for it to finish and try again.
                        return _this.appProvider.waitForSSOAuthentication().then(function () {
                            return _this.request(method, data, preSets, true);
                        });
                    }
                    // Session expired, trigger event.
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].SESSION_EXPIRED, {}, _this.id);
                    // Change error message. Try to get data from cache, the event will handle the error.
                    error.message = _this.translate.instant('core.lostconnection');
                }
                else if (error.errorcode === 'userdeleted') {
                    // User deleted, trigger event.
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].USER_DELETED, { params: data }, _this.id);
                    error.message = _this.translate.instant('core.userdeleted');
                    return Promise.reject(error);
                }
                else if (error.errorcode === 'forcepasswordchangenotice') {
                    // Password Change Forced, trigger event. Try to get data from cache, the event will handle the error.
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].PASSWORD_CHANGE_FORCED, {}, _this.id);
                    error.message = _this.translate.instant('core.forcepasswordchangenotice');
                }
                else if (error.errorcode === 'usernotfullysetup') {
                    // User not fully setup, trigger event. Try to get data from cache, the event will handle the error.
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].USER_NOT_FULLY_SETUP, {}, _this.id);
                    error.message = _this.translate.instant('core.usernotfullysetup');
                }
                else if (error.errorcode === 'sitepolicynotagreed') {
                    // Site policy not agreed, trigger event.
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].SITE_POLICY_NOT_AGREED, {}, _this.id);
                    error.message = _this.translate.instant('core.login.sitepolicynotagreederror');
                    return Promise.reject(error);
                }
                else if (error.errorcode === 'dmlwriteexception' && _this.textUtils.hasUnicodeData(data)) {
                    if (!_this.cleanUnicode) {
                        // Try again cleaning unicode.
                        _this.cleanUnicode = true;
                        return _this.request(method, data, preSets);
                    }
                    // This should not happen.
                    error.message = _this.translate.instant('core.unicodenotsupported');
                    return Promise.reject(error);
                }
                else if (error.exception === 'required_capability_exception' || error.errorcode === 'nopermission' ||
                    error.errorcode === 'notingroup') {
                    // Translate error messages with missing strings.
                    if (error.message === 'error/nopermission') {
                        error.message = _this.translate.instant('core.nopermissionerror');
                    }
                    else if (error.message === 'error/notingroup') {
                        error.message = _this.translate.instant('core.notingroup');
                    }
                    // Save the error instead of deleting the cache entry so the same content is displayed in offline.
                    _this.saveToCache(method, data, error, preSets);
                    return Promise.reject(error);
                }
                else if (typeof preSets.emergencyCache !== 'undefined' && !preSets.emergencyCache) {
                    _this.logger.debug("WS call '" + method + "' failed. Emergency cache is forbidden, rejecting.");
                    return Promise.reject(error);
                }
                else if (preSets.cacheErrors && preSets.cacheErrors.indexOf(error.errorcode) != -1) {
                    // Save the error instead of deleting the cache entry so the same content is displayed in offline.
                    _this.saveToCache(method, data, error, preSets);
                    return Promise.reject(error);
                }
                if (preSets.deleteCacheIfWSError && _this.utils.isWebServiceError(error)) {
                    // Delete the cache entry and return the entry. Don't block the user with the delete.
                    _this.deleteFromCache(method, data, preSets).catch(function () {
                        // Ignore errors.
                    });
                    return Promise.reject(error);
                }
                _this.logger.debug("WS call '" + method + "' failed. Trying to use the emergency cache.");
                preSets.omitExpires = true;
                preSets.getFromCache = true;
                return _this.getFromCache(method, data, preSets, true, originalData).catch(function () {
                    return Promise.reject(error);
                });
            });
        }).then(function (response) {
            // Check if the response is an error, this happens if the error was stored in the cache.
            if (response && (typeof response.exception != 'undefined' || typeof response.errorcode != 'undefined')) {
                return Promise.reject(response);
            }
            return response;
        });
        this.ongoingRequests[cacheId] = promise;
        // Clear ongoing request after setting the promise (just in case it's already resolved).
        return promise.finally(function () {
            // Make sure we don't clear the promise of a newer request that ignores the cache.
            if (_this.ongoingRequests[cacheId] === promise) {
                delete _this.ongoingRequests[cacheId];
            }
        }).then(function (response) {
            // We pass back a clone of the original object, this may prevent errors if in the callback the object is modified.
            return _this.utils.clone(response);
        });
    };
    /**
     * Adds a request to the queue or calls it immediately when not using the queue.
     *
     * @param {string} method The WebService method to be called.
     * @param {any} data Arguments to pass to the method.
     * @param {CoreSiteWSPreSets} preSets Extra options related to the site.
     * @param {CoreWSPreSets} wsPreSets Extra options related to the WS call.
     * @returns {Promise<any>} Promise resolved with the response when the WS is called.
     */
    CoreSite.prototype.callOrEnqueueRequest = function (method, data, preSets, wsPreSets) {
        if (preSets.skipQueue || !this.wsAvailable('tool_mobile_call_external_functions')) {
            return this.wsProvider.call(method, data, wsPreSets);
        }
        var cacheId = this.getCacheId(method, data);
        // Check if there is an identical request waiting in the queue (read requests only by default).
        if (preSets.reusePending) {
            var request_1 = this.requestQueue.find(function (request) { return request.cacheId == cacheId; });
            if (request_1) {
                return request_1.deferred.promise;
            }
        }
        var request = {
            cacheId: cacheId,
            method: method,
            data: data,
            preSets: preSets,
            wsPreSets: wsPreSets,
            deferred: {}
        };
        request.deferred.promise = new Promise(function (resolve, reject) {
            request.deferred.resolve = resolve;
            request.deferred.reject = reject;
        });
        return this.enqueueRequest(request);
    };
    /**
     * Adds a request to the queue.
     *
     * @param {RequestQueueItem} request The request to enqueue.
     * @returns {Promise<any>} Promise resolved with the response when the WS is called.
     */
    CoreSite.prototype.enqueueRequest = function (request) {
        this.requestQueue.push(request);
        if (this.requestQueue.length >= CoreSite.REQUEST_QUEUE_LIMIT) {
            this.processRequestQueue();
        }
        else if (!this.requestQueueTimeout) {
            this.requestQueueTimeout = setTimeout(this.processRequestQueue.bind(this), CoreSite.REQUEST_QUEUE_DELAY);
        }
        return request.deferred.promise;
    };
    /**
     * Call the enqueued web service requests.
     */
    CoreSite.prototype.processRequestQueue = function () {
        var _this = this;
        this.logger.debug("Processing request queue (" + this.requestQueue.length + " requests)");
        // Clear timeout if set.
        if (this.requestQueueTimeout) {
            clearTimeout(this.requestQueueTimeout);
            this.requestQueueTimeout = null;
        }
        // Extract all requests from the queue.
        var requests = this.requestQueue;
        this.requestQueue = [];
        if (requests.length == 1 && !CoreSite.REQUEST_QUEUE_FORCE_WS) {
            // Only one request, do a regular web service call.
            this.wsProvider.call(requests[0].method, requests[0].data, requests[0].wsPreSets).then(function (data) {
                requests[0].deferred.resolve(data);
            }).catch(function (error) {
                requests[0].deferred.reject(error);
            });
            return;
        }
        var data = {
            requests: requests.map(function (request) {
                var args = {};
                var settings = {};
                // Separate WS settings from function arguments.
                Object.keys(request.data).forEach(function (key) {
                    var value = request.data[key];
                    var match = /^moodlews(setting.*)$/.exec(key);
                    if (match) {
                        if (match[1] == 'settingfilter' || match[1] == 'settingfileurl') {
                            // Undo special treatment of these settings in CoreWSProvider.convertValuesToString.
                            value = (value == 'true' ? '1' : '0');
                        }
                        settings[match[1]] = value;
                    }
                    else {
                        args[key] = value;
                    }
                });
                return __assign({ function: request.method, arguments: JSON.stringify(args) }, settings);
            })
        };
        var wsPresets = {
            siteUrl: this.siteUrl,
            wsToken: this.token,
        };
        this.wsProvider.call('tool_mobile_call_external_functions', data, wsPresets).then(function (data) {
            if (!data || !data.responses) {
                return Promise.reject(null);
            }
            requests.forEach(function (request, i) {
                var response = data.responses[i];
                if (!response) {
                    // Request not executed, enqueue again.
                    _this.enqueueRequest(request);
                }
                else if (response.error) {
                    request.deferred.reject(_this.textUtils.parseJSON(response.exception));
                }
                else {
                    var responseData = _this.textUtils.parseJSON(response.data);
                    // Match the behaviour of CoreWSProvider.call when no response is expected.
                    var responseExpected = typeof wsPresets.responseExpected == 'undefined' || wsPresets.responseExpected;
                    if (!responseExpected && (responseData == null || responseData === '')) {
                        responseData = {};
                    }
                    request.deferred.resolve(responseData);
                }
            });
        }).catch(function (error) {
            // Error not specific to a single request, reject all promises.
            requests.forEach(function (request) {
                request.deferred.reject(error);
            });
        });
    };
    /**
     * Check if a WS is available in this site.
     *
     * @param {string} method WS name.
     * @param {boolean} [checkPrefix=true] When true also checks with the compatibility prefix.
     * @return {boolean} Whether the WS is available.
     */
    CoreSite.prototype.wsAvailable = function (method, checkPrefix) {
        if (checkPrefix === void 0) { checkPrefix = true; }
        if (typeof this.infos == 'undefined') {
            return false;
        }
        if (this.infos.functionsByName[method]) {
            return true;
        }
        // Let's try again with the compatibility prefix.
        if (checkPrefix) {
            return this.wsAvailable(__WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].WS_PREFIX + method, false);
        }
        return false;
    };
    /**
     * Get cache ID.
     *
     * @param {string} method The WebService method.
     * @param {any} data Arguments to pass to the method.
     * @return {string} Cache ID.
     */
    CoreSite.prototype.getCacheId = function (method, data) {
        return __WEBPACK_IMPORTED_MODULE_15_ts_md5_dist_md5__["Md5"].hashAsciiStr(method + ':' + this.utils.sortAndStringify(data));
    };
    /**
     * Get the cache ID used in Ionic 1 version of the app.
     *
     * @param {string} method The WebService method.
     * @param {any} data Arguments to pass to the method.
     * @return {string} Cache ID.
     */
    CoreSite.prototype.getCacheOldId = function (method, data) {
        return __WEBPACK_IMPORTED_MODULE_15_ts_md5_dist_md5__["Md5"].hashAsciiStr(method + ':' + JSON.stringify(data));
    };
    /**
     * Get a WS response from cache.
     *
     * @param {string} method The WebService method to be called.
     * @param {any} data Arguments to pass to the method.
     * @param {CoreSiteWSPreSets} preSets Extra options.
     * @param {boolean} [emergency] Whether it's an "emergency" cache call (WS call failed).
     * @param {any} [originalData] Arguments to pass to the method before being converted to strings.
     * @return {Promise<any>} Promise resolved with the WS response.
     */
    CoreSite.prototype.getFromCache = function (method, data, preSets, emergency, originalData) {
        var _this = this;
        if (!this.db || !preSets.getFromCache) {
            return Promise.reject(null);
        }
        var id = this.getCacheId(method, data);
        var promise;
        if (preSets.getCacheUsingCacheKey || (emergency && preSets.getEmergencyCacheUsingCacheKey)) {
            promise = this.db.getRecords(CoreSite.WS_CACHE_TABLE, { key: preSets.cacheKey }).then(function (entries) {
                if (!entries.length) {
                    // Cache key not found, get by params sent.
                    return _this.db.getRecord(CoreSite.WS_CACHE_TABLE, { id: id });
                }
                else if (entries.length > 1) {
                    // More than one entry found. Search the one with same ID as this call.
                    for (var i = 0, len = entries.length; i < len; i++) {
                        var entry = entries[i];
                        if (entry.id == id) {
                            return entry;
                        }
                    }
                }
                return entries[0];
            });
        }
        else {
            promise = this.db.getRecord(CoreSite.WS_CACHE_TABLE, { id: id }).catch(function () {
                // Entry not found, try to get it using the old ID.
                var oldId = _this.getCacheOldId(method, originalData || {});
                return _this.db.getRecord(CoreSite.WS_CACHE_TABLE, { id: oldId }).then(function (entry) {
                    // Update the entry ID to use the new one.
                    _this.db.updateRecords(CoreSite.WS_CACHE_TABLE, { id: id }, { id: oldId });
                    return entry;
                });
            });
        }
        return promise.then(function (entry) {
            var now = Date.now();
            var expirationTime;
            preSets.omitExpires = preSets.omitExpires || !_this.appProvider.isOnline();
            if (!preSets.omitExpires) {
                var expirationDelay = _this.UPDATE_FREQUENCIES[preSets.updateFrequency] ||
                    _this.UPDATE_FREQUENCIES[CoreSite.FREQUENCY_USUALLY];
                if (_this.appProvider.isNetworkAccessLimited()) {
                    // Not WiFi, increase the expiration delay a 50% to decrease the data usage in this case.
                    expirationDelay *= 1.5;
                }
                expirationTime = entry.expirationTime + expirationDelay;
                if (now > expirationTime) {
                    _this.logger.debug('Cached element found, but it is expired');
                    return Promise.reject(null);
                }
            }
            if (typeof entry != 'undefined' && typeof entry.data != 'undefined') {
                if (!expirationTime) {
                    _this.logger.info("Cached element found, id: " + id + ". Expiration time ignored.");
                }
                else {
                    var expires = (expirationTime - now) / 1000;
                    _this.logger.info("Cached element found, id: " + id + ". Expires in expires in " + expires + " seconds");
                }
                return _this.textUtils.parseJSON(entry.data, {});
            }
            return Promise.reject(null);
        });
    };
    /**
     * Save a WS response to cache.
     *
     * @param {string} method The WebService method.
     * @param {any} data Arguments to pass to the method.
     * @param {any} response The WS response.
     * @param {CoreSiteWSPreSets} preSets Extra options.
     * @return {Promise<any>} Promise resolved when the response is saved.
     */
    CoreSite.prototype.saveToCache = function (method, data, response, preSets) {
        var _this = this;
        if (!this.db) {
            return Promise.reject(null);
        }
        var promise;
        if (preSets.uniqueCacheKey) {
            // Cache key must be unique, delete all entries with same cache key.
            promise = this.deleteFromCache(method, data, preSets, true).catch(function () {
                // Ignore errors.
            });
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function () {
            // Since 3.7, the expiration time contains the time the entry is modified instead of the expiration time.
            // We decided to reuse this field to prevent modifying the database table.
            var id = _this.getCacheId(method, data), entry = {
                id: id,
                data: JSON.stringify(response),
                expirationTime: Date.now()
            };
            if (preSets.cacheKey) {
                entry.key = preSets.cacheKey;
            }
            return _this.db.insertRecord(CoreSite.WS_CACHE_TABLE, entry);
        });
    };
    /**
     * Delete a WS cache entry or entries.
     *
     * @param {string} method The WebService method to be called.
     * @param {any} data Arguments to pass to the method.
     * @param {CoreSiteWSPreSets} preSets Extra options.
     * @param {boolean} [allCacheKey] True to delete all entries with the cache key, false to delete only by ID.
     * @return {Promise<any>} Promise resolved when the entries are deleted.
     */
    CoreSite.prototype.deleteFromCache = function (method, data, preSets, allCacheKey) {
        if (!this.db) {
            return Promise.reject(null);
        }
        var id = this.getCacheId(method, data);
        if (allCacheKey) {
            return this.db.deleteRecords(CoreSite.WS_CACHE_TABLE, { key: preSets.cacheKey });
        }
        return this.db.deleteRecords(CoreSite.WS_CACHE_TABLE, { id: id });
    };
    /*
     * Uploads a file using Cordova File API.
     *
     * @param {string} filePath File path.
     * @param {CoreWSFileUploadOptions} options File upload options.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved when uploaded.
     */
    CoreSite.prototype.uploadFile = function (filePath, options, onProgress) {
        if (!options.fileArea) {
            options.fileArea = 'draft';
        }
        return this.wsProvider.uploadFile(filePath, options, {
            siteUrl: this.siteUrl,
            wsToken: this.token
        }, onProgress);
    };
    /**
     * Invalidates all the cache entries.
     *
     * @return {Promise<any>} Promise resolved when the cache entries are invalidated.
     */
    CoreSite.prototype.invalidateWsCache = function () {
        if (!this.db) {
            return Promise.reject(null);
        }
        this.logger.debug('Invalidate all the cache for site: ' + this.id);
        return this.db.updateRecords(CoreSite.WS_CACHE_TABLE, { expirationTime: 0 });
    };
    /**
     * Invalidates all the cache entries with a certain key.
     *
     * @param {string} key Key to search.
     * @return {Promise<any>} Promise resolved when the cache entries are invalidated.
     */
    CoreSite.prototype.invalidateWsCacheForKey = function (key) {
        if (!this.db) {
            return Promise.reject(null);
        }
        if (!key) {
            return Promise.resolve();
        }
        this.logger.debug('Invalidate cache for key: ' + key);
        return this.db.updateRecords(CoreSite.WS_CACHE_TABLE, { expirationTime: 0 }, { key: key });
    };
    /**
     * Invalidates all the cache entries in an array of keys.
     *
     * @param {string[]} keys Keys to search.
     * @return {Promise<any>} Promise resolved when the cache entries are invalidated.
     */
    CoreSite.prototype.invalidateMultipleWsCacheForKey = function (keys) {
        var _this = this;
        if (!this.db) {
            return Promise.reject(null);
        }
        if (!keys || !keys.length) {
            return Promise.resolve();
        }
        var promises = [];
        this.logger.debug('Invalidating multiple cache keys');
        keys.forEach(function (key) {
            promises.push(_this.invalidateWsCacheForKey(key));
        });
        return Promise.all(promises);
    };
    /**
     * Invalidates all the cache entries whose key starts with a certain value.
     *
     * @param {string} key Key to search.
     * @return {Promise}    Promise resolved when the cache entries are invalidated.
     */
    CoreSite.prototype.invalidateWsCacheForKeyStartingWith = function (key) {
        if (!this.db) {
            return Promise.reject(null);
        }
        if (!key) {
            return Promise.resolve();
        }
        this.logger.debug('Invalidate cache for key starting with: ' + key);
        var sql = 'UPDATE ' + CoreSite.WS_CACHE_TABLE + ' SET expirationTime=0 WHERE key LIKE ?';
        return this.db.execute(sql, [key + '%']);
    };
    /**
     * Generic function for adding the wstoken to Moodle urls and for pointing to the correct script.
     * Uses CoreUtilsProvider.fixPluginfileURL, passing site's token.
     *
     * @param {string} url The url to be fixed.
     * @return {string} Fixed URL.
     */
    CoreSite.prototype.fixPluginfileURL = function (url) {
        return this.urlUtils.fixPluginfileURL(url, this.token, this.siteUrl);
    };
    /**
     * Deletes site's DB.
     *
     * @return {Promise<any>} Promise to be resolved when the DB is deleted.
     */
    CoreSite.prototype.deleteDB = function () {
        return this.dbProvider.deleteDB('Site-' + this.id);
    };
    /**
     * Deletes site's folder.
     *
     * @return {Promise<any>} Promise to be resolved when the DB is deleted.
     */
    CoreSite.prototype.deleteFolder = function () {
        if (this.fileProvider.isAvailable()) {
            var siteFolder = this.fileProvider.getSiteFolder(this.id);
            return this.fileProvider.removeDir(siteFolder).catch(function () {
                // Ignore any errors, CoreFileProvider.removeDir fails if folder doesn't exists.
            });
        }
        else {
            return Promise.resolve();
        }
    };
    /**
     * Get space usage of the site.
     *
     * @return {Promise<number>} Promise resolved with the site space usage (size).
     */
    CoreSite.prototype.getSpaceUsage = function () {
        if (this.fileProvider.isAvailable()) {
            var siteFolderPath = this.fileProvider.getSiteFolder(this.id);
            return this.fileProvider.getDirectorySize(siteFolderPath).catch(function () {
                return 0;
            });
        }
        else {
            return Promise.resolve(0);
        }
    };
    /**
     * Returns the URL to the documentation of the app, based on Moodle version and current language.
     *
     * @param {string} [page] Docs page to go to.
     * @return {Promise<string>} Promise resolved with the Moodle docs URL.
     */
    CoreSite.prototype.getDocsUrl = function (page) {
        var release = this.infos.release ? this.infos.release : undefined;
        return this.urlUtils.getDocsUrl(release, page);
    };
    /**
     * Check if the local_mobile plugin is installed in the Moodle site.
     *
     * @param {boolean} [retrying] True if we're retrying the check.
     * @return {Promise<LocalMobileResponse>} Promise resolved when the check is done.
     */
    CoreSite.prototype.checkLocalMobilePlugin = function (retrying) {
        var _this = this;
        var checkUrl = this.siteUrl + '/local/mobile/check.php', service = __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].wsextservice;
        if (!service) {
            // External service not defined.
            return Promise.resolve({ code: 0 });
        }
        var promise = this.http.post(checkUrl, { service: service }).timeout(__WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].WS_TIMEOUT).toPromise();
        return promise.then(function (data) {
            if (typeof data != 'undefined' && data.errorcode === 'requirecorrectaccess') {
                if (!retrying) {
                    _this.siteUrl = _this.urlUtils.addOrRemoveWWW(_this.siteUrl);
                    return _this.checkLocalMobilePlugin(true);
                }
                else {
                    return Promise.reject(data.error);
                }
            }
            else if (typeof data == 'undefined' || typeof data.code == 'undefined') {
                // The local_mobile returned something we didn't expect. Let's assume it's not installed.
                return { code: 0, warning: 'core.login.localmobileunexpectedresponse' };
            }
            var code = parseInt(data.code, 10);
            if (data.error) {
                switch (code) {
                    case 1:
                        // Site in maintenance mode.
                        return Promise.reject(_this.translate.instant('core.login.siteinmaintenance'));
                    case 2:
                        // Web services not enabled.
                        return Promise.reject(_this.translate.instant('core.login.webservicesnotenabled'));
                    case 3:
                        // Extended service not enabled, but the official is enabled.
                        return { code: 0 };
                    case 4:
                        // Neither extended or official services enabled.
                        return Promise.reject(_this.translate.instant('core.login.mobileservicesnotenabled'));
                    default:
                        return Promise.reject(_this.translate.instant('core.unexpectederror'));
                }
            }
            else {
                return { code: code, service: service, coreSupported: !!data.coresupported };
            }
        }, function () {
            return { code: 0 };
        });
    };
    /**
     * Check if local_mobile has been installed in Moodle.
     *
     * @return {boolean} Whether the App is able to use local_mobile plugin for this site.
     */
    CoreSite.prototype.checkIfAppUsesLocalMobile = function () {
        var appUsesLocalMobile = false;
        if (!this.infos || !this.infos.functions) {
            return appUsesLocalMobile;
        }
        this.infos.functions.forEach(function (func) {
            if (func.name.indexOf(__WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].WS_PREFIX) != -1) {
                appUsesLocalMobile = true;
            }
        });
        return appUsesLocalMobile;
    };
    /**
     * Check if local_mobile has been installed in Moodle but the app is not using it.
     *
     * @return {Promise<any>} Promise resolved it local_mobile was added, rejected otherwise.
     */
    CoreSite.prototype.checkIfLocalMobileInstalledAndNotUsed = function () {
        var appUsesLocalMobile = this.checkIfAppUsesLocalMobile();
        if (appUsesLocalMobile) {
            // App already uses local_mobile, it wasn't added.
            return Promise.reject(null);
        }
        return this.checkLocalMobilePlugin().then(function (data) {
            if (typeof data.service == 'undefined') {
                // The local_mobile NOT installed. Reject.
                return Promise.reject(null);
            }
            return data;
        });
    };
    /**
     * Check if a URL belongs to this site.
     *
     * @param {string} url URL to check.
     * @return {boolean} Whether the URL belongs to this site.
     */
    CoreSite.prototype.containsUrl = function (url) {
        if (!url) {
            return false;
        }
        var siteUrl = this.textUtils.removeEndingSlash(this.urlUtils.removeProtocolAndWWW(this.siteUrl));
        url = this.urlUtils.removeProtocolAndWWW(url);
        return url.indexOf(siteUrl) == 0;
    };
    /**
     * Get the public config of this site.
     *
     * @return {Promise<any>} Promise resolved with public config. Rejected with an object if error, see CoreWSProvider.callAjax.
     */
    CoreSite.prototype.getPublicConfig = function () {
        var _this = this;
        return this.wsProvider.callAjax('tool_mobile_get_public_config', {}, { siteUrl: this.siteUrl }).then(function (config) {
            // Use the wwwroot returned by the server.
            if (config.httpswwwroot) {
                _this.siteUrl = config.httpswwwroot;
            }
            return config;
        });
    };
    /**
     * Open a URL in browser using auto-login in the Moodle site if available.
     *
     * @param {string} url The URL to open.
     * @param {string} [alertMessage] If defined, an alert will be shown before opening the browser.
     * @return {Promise<any>} Promise resolved when done, rejected otherwise.
     */
    CoreSite.prototype.openInBrowserWithAutoLogin = function (url, alertMessage) {
        return this.openWithAutoLogin(true, url, undefined, alertMessage);
    };
    /**
     * Open a URL in browser using auto-login in the Moodle site if available and the URL belongs to the site.
     *
     * @param {string} url The URL to open.
     * @param {string} [alertMessage] If defined, an alert will be shown before opening the browser.
     * @return {Promise<any>} Promise resolved when done, rejected otherwise.
     */
    CoreSite.prototype.openInBrowserWithAutoLoginIfSameSite = function (url, alertMessage) {
        return this.openWithAutoLoginIfSameSite(true, url, undefined, alertMessage);
    };
    /**
     * Open a URL in inappbrowser using auto-login in the Moodle site if available.
     *
     * @param {string} url The URL to open.
     * @param {any} [options] Override default options passed to InAppBrowser.
     * @param {string} [alertMessage] If defined, an alert will be shown before opening the inappbrowser.
     * @return {Promise<InAppBrowserObject|void>} Promise resolved when done.
     */
    CoreSite.prototype.openInAppWithAutoLogin = function (url, options, alertMessage) {
        return this.openWithAutoLogin(true, url, options, alertMessage);
    };
    /**
     * Open a URL in inappbrowser using auto-login in the Moodle site if available and the URL belongs to the site.
     *
     * @param {string} url The URL to open.
     * @param {object} [options] Override default options passed to inappbrowser.
     * @param {string} [alertMessage] If defined, an alert will be shown before opening the inappbrowser.
     * @return {Promise<InAppBrowserObject|void>} Promise resolved when done.
     */
    CoreSite.prototype.openInAppWithAutoLoginIfSameSite = function (url, options, alertMessage) {
        return this.openWithAutoLoginIfSameSite(true, url, options, alertMessage);
    };
    /**
     * Open a URL in browser or InAppBrowser using auto-login in the Moodle site if available.
     *
     * @param {boolean} inApp True to open it in InAppBrowser, false to open in browser.
     * @param {string} url The URL to open.
     * @param {object} [options] Override default options passed to $cordovaInAppBrowser#open.
     * @param {string} [alertMessage] If defined, an alert will be shown before opening the browser/inappbrowser.
     * @return {Promise<InAppBrowserObject|void>} Promise resolved when done. Resolve param is returned only if inApp=true.
     */
    CoreSite.prototype.openWithAutoLogin = function (inApp, url, options, alertMessage) {
        var _this = this;
        // Get the URL to open.
        return this.getAutoLoginUrl(url).then(function (url) {
            if (!alertMessage) {
                // Just open the URL.
                if (inApp) {
                    return _this.utils.openInApp(url, options);
                }
                else {
                    return _this.utils.openInBrowser(url);
                }
            }
            // Show an alert first.
            return _this.domUtils.showAlert(_this.translate.instant('core.notice'), alertMessage, undefined, 3000).then(function (alert) {
                return new Promise(function (resolve, reject) {
                    var subscription = alert.didDismiss.subscribe(function () {
                        subscription && subscription.unsubscribe();
                        if (inApp) {
                            resolve(_this.utils.openInApp(url, options));
                        }
                        else {
                            resolve(_this.utils.openInBrowser(url));
                        }
                    });
                });
            });
        });
    };
    /**
     * Open a URL in browser or InAppBrowser using auto-login in the Moodle site if available and the URL belongs to the site.
     *
     * @param {boolean} inApp True to open it in InAppBrowser, false to open in browser.
     * @param {string} url The URL to open.
     * @param {object} [options] Override default options passed to inappbrowser.
     * @param {string} [alertMessage] If defined, an alert will be shown before opening the browser/inappbrowser.
     * @return {Promise<InAppBrowserObject|void>} Promise resolved when done. Resolve param is returned only if inApp=true.
     */
    CoreSite.prototype.openWithAutoLoginIfSameSite = function (inApp, url, options, alertMessage) {
        if (this.containsUrl(url)) {
            return this.openWithAutoLogin(inApp, url, options, alertMessage);
        }
        else {
            if (inApp) {
                this.utils.openInApp(url, options);
            }
            else {
                this.utils.openInBrowser(url);
            }
            return Promise.resolve(null);
        }
    };
    /**
     * Get the config of this site.
     * It is recommended to use getStoredConfig instead since it's faster and doesn't use network.
     *
     * @param {string} [name] Name of the setting to get. If not set or false, all settings will be returned.
     * @param {boolean} [ignoreCache] True if it should ignore cached data.
     * @return {Promise<any>} Promise resolved with site config.
     */
    CoreSite.prototype.getConfig = function (name, ignoreCache) {
        var preSets = {
            cacheKey: this.getConfigCacheKey()
        };
        if (ignoreCache) {
            preSets.getFromCache = false;
            preSets.emergencyCache = false;
        }
        return this.read('tool_mobile_get_config', {}, preSets).then(function (config) {
            if (name) {
                // Return the requested setting.
                for (var x in config.settings) {
                    if (config.settings[x].name == name) {
                        return config.settings[x].value;
                    }
                }
                return Promise.reject(null);
            }
            else {
                // Return all settings in the same array.
                var settings_1 = {};
                config.settings.forEach(function (setting) {
                    settings_1[setting.name] = setting.value;
                });
                return settings_1;
            }
        });
    };
    /**
     * Invalidates config WS call.
     *
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreSite.prototype.invalidateConfig = function () {
        return this.invalidateWsCacheForKey(this.getConfigCacheKey());
    };
    /**
     * Get cache key for getConfig WS calls.
     *
     * @return {string} Cache key.
     */
    CoreSite.prototype.getConfigCacheKey = function () {
        return 'tool_mobile_get_config';
    };
    /**
     * Get the stored config of this site.
     *
     * @param {string} [name] Name of the setting to get. If not set, all settings will be returned.
     * @return {any} Site config or a specific setting.
     */
    CoreSite.prototype.getStoredConfig = function (name) {
        if (!this.config) {
            return;
        }
        if (name) {
            return this.config[name];
        }
        else {
            return this.config;
        }
    };
    /**
     * Check if a certain feature is disabled in the site.
     *
     * @param {string} name Name of the feature to check.
     * @return {boolean} Whether it's disabled.
     */
    CoreSite.prototype.isFeatureDisabled = function (name) {
        var disabledFeatures = this.getStoredConfig('tool_mobile_disabledfeatures');
        if (!disabledFeatures) {
            return false;
        }
        var regEx = new RegExp('(,|^)' + this.textUtils.escapeForRegex(name) + '(,|$)', 'g');
        return !!disabledFeatures.match(regEx);
    };
    /**
     * Calculate if offline is disabled in the site.
     */
    CoreSite.prototype.calculateOfflineDisabled = function () {
        this.offlineDisabled = this.isFeatureDisabled('NoDelegate_CoreOffline');
    };
    /**
     * Get whether offline is disabled in the site.
     *
     * @return {boolean} Whether it's disabled.
     */
    CoreSite.prototype.isOfflineDisabled = function () {
        return this.offlineDisabled;
    };
    /**
     * Check if the site version is greater than one or several versions.
     * This function accepts a string or an array of strings. If array, the last version must be the highest.
     *
     * @param {string | string[]} versions Version or list of versions to check.
     * @return {boolean} Whether it's greater or equal, false otherwise.
     * @description
     * If a string is supplied (e.g. '3.2.1'), it will check if the site version is greater or equal than this version.
     *
     * If an array of versions is supplied, it will check if the site version is greater or equal than the last version,
     * or if it's higher or equal than any of the other releases supplied but lower than the next major release. The last
     * version of the array must be the highest version.
     * For example, if the values supplied are ['3.0.5', '3.2.3', '3.3.1'] the function will return true if the site version
     * is either:
     *     - Greater or equal than 3.3.1.
     *     - Greater or equal than 3.2.3 but lower than 3.3.
     *     - Greater or equal than 3.0.5 but lower than 3.1.
     *
     * This function only accepts versions from 2.4.0 and above. If any of the versions supplied isn't found, it will assume
     * it's the last released major version.
     */
    CoreSite.prototype.isVersionGreaterEqualThan = function (versions) {
        var siteVersion = parseInt(this.getInfo().version, 10);
        if (Array.isArray(versions)) {
            if (!versions.length) {
                return false;
            }
            for (var i = 0; i < versions.length; i++) {
                var versionNumber = this.getVersionNumber(versions[i]);
                if (i == versions.length - 1) {
                    // It's the last version, check only if site version is greater than this one.
                    return siteVersion >= versionNumber;
                }
                else {
                    // Check if site version if bigger than this number but lesser than next major.
                    if (siteVersion >= versionNumber && siteVersion < this.getNextMajorVersionNumber(versions[i])) {
                        return true;
                    }
                }
            }
        }
        else if (typeof versions == 'string') {
            // Compare with this version.
            return siteVersion >= this.getVersionNumber(versions);
        }
        return false;
    };
    /**
     * Given a URL, convert it to a URL that will auto-login if supported.
     *
     * @param {string} url The URL to convert.
     * @param {boolean} [showModal=true] Whether to show a loading modal.
     * @return {Promise<string>} Promise resolved with the converted URL.
     */
    CoreSite.prototype.getAutoLoginUrl = function (url, showModal) {
        var _this = this;
        if (showModal === void 0) { showModal = true; }
        if (!this.privateToken || !this.wsAvailable('tool_mobile_get_autologin_key') ||
            (this.lastAutoLogin && this.timeUtils.timestamp() - this.lastAutoLogin < __WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].SECONDS_MINUTE * 6)) {
            // No private token, WS not available or last auto-login was less than 6 minutes ago. Don't change the URL.
            return Promise.resolve(url);
        }
        var userId = this.getUserId(), params = {
            privatetoken: this.privateToken
        };
        var modal;
        if (showModal) {
            modal = this.domUtils.showModalLoading();
        }
        // Use write to not use cache.
        return this.write('tool_mobile_get_autologin_key', params).then(function (data) {
            if (!data.autologinurl || !data.key) {
                // Not valid data, return the same URL.
                return url;
            }
            _this.lastAutoLogin = _this.timeUtils.timestamp();
            return data.autologinurl + '?userid=' + userId + '&key=' + data.key + '&urltogo=' + url;
        }).catch(function () {
            // Couldn't get autologin key, return the same URL.
            return url;
        }).finally(function () {
            modal && modal.dismiss();
        });
    };
    /**
     * Get a version number from a release version.
     * If release version is valid but not found in the list of Moodle releases, it will use the last released major version.
     *
     * @param {string} version Release version to convert to version number.
     * @return {number} Version number, 0 if invalid.
     */
    CoreSite.prototype.getVersionNumber = function (version) {
        var data = this.getMajorAndMinor(version);
        if (!data) {
            // Invalid version.
            return 0;
        }
        if (typeof this.MOODLE_RELEASES[data.major] == 'undefined') {
            // Major version not found. Use the last one.
            data.major = Object.keys(this.MOODLE_RELEASES).slice(-1);
        }
        return this.MOODLE_RELEASES[data.major] + data.minor;
    };
    /**
     * Given a release version, return the major and minor versions.
     *
     * @param {string} version Release version (e.g. '3.1.0').
     * @return {object} Object with major and minor. Returns false if invalid version.
     */
    CoreSite.prototype.getMajorAndMinor = function (version) {
        var match = version.match(/(\d)+(?:\.(\d)+)?(?:\.(\d)+)?/);
        if (!match || !match[1]) {
            // Invalid version.
            return false;
        }
        return {
            major: match[1] + '.' + (match[2] || '0'),
            minor: parseInt(match[3], 10) || 0
        };
    };
    /**
     * Given a release version, return the next major version number.
     *
     * @param {string} version Release version (e.g. '3.1.0').
     * @return {number} Next major version number.
     */
    CoreSite.prototype.getNextMajorVersionNumber = function (version) {
        var data = this.getMajorAndMinor(version), releases = Object.keys(this.MOODLE_RELEASES);
        var position;
        if (!data) {
            // Invalid version.
            return 0;
        }
        position = releases.indexOf(data.major);
        if (position == -1 || position == releases.length - 1) {
            // Major version not found or it's the last one. Use the last one.
            return this.MOODLE_RELEASES[releases[position]];
        }
        return this.MOODLE_RELEASES[releases[position + 1]];
    };
    /**
     * Deletes a site setting.
     *
     * @param {string} name The config name.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSite.prototype.deleteSiteConfig = function (name) {
        return this.db.deleteRecords(CoreSite.CONFIG_TABLE, { name: name });
    };
    /**
     * Get a site setting on local device.
     *
     * @param {string} name The config name.
     * @param {any} [defaultValue] Default value to use if the entry is not found.
     * @return {Promise<any>} Resolves upon success along with the config data. Reject on failure.
     */
    CoreSite.prototype.getLocalSiteConfig = function (name, defaultValue) {
        return this.db.getRecord(CoreSite.CONFIG_TABLE, { name: name }).then(function (entry) {
            return entry.value;
        }).catch(function (error) {
            if (typeof defaultValue != 'undefined') {
                return defaultValue;
            }
            return Promise.reject(error);
        });
    };
    /**
     * Set a site setting on local device.
     *
     * @param {string} name The config name.
     * @param {number|string} value The config value. Can only store number or strings.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSite.prototype.setLocalSiteConfig = function (name, value) {
        return this.db.insertRecord(CoreSite.CONFIG_TABLE, { name: name, value: value });
    };
    CoreSite.REQUEST_QUEUE_DELAY = 50; // Maximum number of miliseconds to wait before processing the queue.
    CoreSite.REQUEST_QUEUE_LIMIT = 10; // Maximum number of requests allowed in the queue.
    CoreSite.REQUEST_QUEUE_FORCE_WS = false; // Use "tool_mobile_call_external_functions" even for calling a single function.
    // Constants for cache update frequency.
    CoreSite.FREQUENCY_USUALLY = 0;
    CoreSite.FREQUENCY_OFTEN = 1;
    CoreSite.FREQUENCY_SOMETIMES = 2;
    CoreSite.FREQUENCY_RARELY = 3;
    // Variables for the database.
    CoreSite.WS_CACHE_TABLE = 'wscache';
    CoreSite.CONFIG_TABLE = 'core_site_config';
    return CoreSite;
}());

//# sourceMappingURL=site.js.map

/***/ }),
/* 26 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(349);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service to provide user functionalities.
 */
var CoreUserProvider = /** @class */ (function () {
    function CoreUserProvider(logger, sitesProvider, utils, filepoolProvider, appProvider, userOffline, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.filepoolProvider = filepoolProvider;
        this.appProvider = appProvider;
        this.userOffline = userOffline;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.ROOT_CACHE_KEY = 'mmUser:';
        // Variables for database.
        this.USERS_TABLE = 'users';
        this.siteSchema = {
            name: 'CoreUserProvider',
            version: 1,
            canBeCleared: [this.USERS_TABLE],
            tables: [
                {
                    name: this.USERS_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'fullname',
                            type: 'TEXT'
                        },
                        {
                            name: 'profileimageurl',
                            type: 'TEXT'
                        }
                    ],
                }
            ]
        };
        this.logger = logger.getInstance('CoreUserProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    CoreUserProvider_1 = CoreUserProvider;
    /**
     * Change the given user profile picture.
     *
     * @param  {number} draftItemId New picture draft item id.
     * @param  {number} userId      User ID.
     * @return {Promise<string>}       Promise resolve with the new profileimageurl
     */
    CoreUserProvider.prototype.changeProfilePicture = function (draftItemId, userId) {
        var data = {
            draftitemid: draftItemId,
            delete: 0,
            userid: userId
        };
        return this.sitesProvider.getCurrentSite().write('core_user_update_picture', data).then(function (result) {
            if (!result.success) {
                return Promise.reject(null);
            }
            return result.profileimageurl;
        });
    };
    /**
     * Store user basic information in local DB to be retrieved if the WS call fails.
     *
     * @param  {number} userId  User ID.
     * @param {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>}   Promise resolve when the user is deleted.
     */
    CoreUserProvider.prototype.deleteStoredUser = function (userId, siteId) {
        var _this = this;
        if (isNaN(userId)) {
            return Promise.reject(null);
        }
        var promises = [];
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Invalidate WS calls.
        promises.push(this.invalidateUserCache(userId, siteId));
        promises.push(this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(_this.USERS_TABLE, { id: userId });
        }));
        return Promise.all(promises);
    };
    /**
     * Get participants for a certain course.
     *
     * @param  {number} courseId    ID of the course.
     * @param  {number} limitFrom   Position of the first participant to get.
     * @param  {number} limitNumber Number of participants to get.
     * @param  {string} [siteId]    Site Id. If not defined, use current site.
     * @param  {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<{participants: any[], canLoadMore: boolean}>} Promise resolved when the participants are retrieved.
     */
    CoreUserProvider.prototype.getParticipants = function (courseId, limitFrom, limitNumber, siteId, ignoreCache) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNumber === void 0) { limitNumber = CoreUserProvider_1.PARTICIPANTS_LIST_LIMIT; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            _this.logger.debug("Get participants for course '" + courseId + "' starting at '" + limitFrom + "'");
            var data = {
                courseid: courseId,
                options: [
                    {
                        name: 'limitfrom',
                        value: limitFrom
                    },
                    {
                        name: 'limitnumber',
                        value: limitNumber
                    },
                    {
                        name: 'sortby',
                        value: 'siteorder'
                    }
                ]
            }, preSets = {
                cacheKey: _this.getParticipantsListCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('core_enrol_get_enrolled_users', data, preSets).then(function (users) {
                var canLoadMore = users.length >= limitNumber;
                _this.storeUsers(users, siteId);
                return { participants: users, canLoadMore: canLoadMore };
            });
        });
    };
    /**
     * Get cache key for participant list WS calls.
     *
     * @param  {number} courseId Course ID.
     * @return {string}          Cache key.
     */
    CoreUserProvider.prototype.getParticipantsListCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'list:' + courseId;
    };
    /**
     * Get user profile. The type of profile retrieved depends on the params.
     *
     * @param  {number} userId      User's ID.
     * @param  {number} [courseId]  Course ID to get course profile, undefined or 0 to get site profile.
     * @param  {boolean} [forceLocal] True to retrieve the user data from local DB, false to retrieve it from WS.
     * @param {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>}            Promise resolved with the user data.
     */
    CoreUserProvider.prototype.getProfile = function (userId, courseId, forceLocal, siteId) {
        var _this = this;
        if (forceLocal === void 0) { forceLocal = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (forceLocal) {
            return this.getUserFromLocalDb(userId, siteId).catch(function () {
                return _this.getUserFromWS(userId, courseId, siteId);
            });
        }
        return this.getUserFromWS(userId, courseId, siteId).catch(function () {
            return _this.getUserFromLocalDb(userId, siteId);
        });
    };
    /**
     * Get cache key for a user WS call.
     *
     * @param  {number} userId User ID.
     * @return {string}        Cache key.
     */
    CoreUserProvider.prototype.getUserCacheKey = function (userId) {
        return this.ROOT_CACHE_KEY + 'data:' + userId;
    };
    /**
     * Get user basic information from local DB.
     *
     * @param {number} userId User ID.
     * @param {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>}   Promise resolve when the user is retrieved.
     */
    CoreUserProvider.prototype.getUserFromLocalDb = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(_this.USERS_TABLE, { id: userId });
        });
    };
    /**
     * Get user profile from WS.
     *
     * @param {number} userId         User ID.
     * @param {number} [courseId] Course ID to get course profile, undefined or 0 to get site profile.
     * @param {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>}           Promise resolve when the user is retrieved.
     */
    CoreUserProvider.prototype.getUserFromWS = function (userId, courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var presets = {
                cacheKey: _this.getUserCacheKey(userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            var wsName, data;
            // Determine WS and data to use.
            if (courseId && courseId != site.getSiteHomeId()) {
                _this.logger.debug("Get participant with ID '" + userId + "' in course '" + courseId);
                wsName = 'core_user_get_course_user_profiles';
                data = {
                    userlist: [
                        {
                            userid: userId,
                            courseid: courseId
                        }
                    ]
                };
            }
            else {
                _this.logger.debug("Get user with ID '" + userId + "'");
                wsName = 'core_user_get_users_by_field';
                data = {
                    field: 'id',
                    values: [userId]
                };
            }
            return site.read(wsName, data, presets).then(function (users) {
                if (users.length == 0) {
                    return Promise.reject('Cannot retrieve user info.');
                }
                var user = users.shift();
                if (user.country) {
                    user.country = _this.utils.getCountryName(user.country);
                }
                _this.storeUser(user.id, user.fullname, user.profileimageurl);
                return user;
            });
        });
    };
    /**
     * Get a user preference (online or offline).
     *
     * @param {string} name Name of the preference.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {string} Preference value or null if preference not set.
     */
    CoreUserProvider.prototype.getUserPreference = function (name, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.userOffline.getPreference(name, siteId).catch(function () {
            return null;
        }).then(function (preference) {
            if (preference && !_this.appProvider.isOnline()) {
                // Offline, return stored value.
                return preference.value;
            }
            return _this.getUserPreferenceOnline(name, siteId).then(function (wsValue) {
                if (preference && preference.value != preference.onlinevalue && preference.onlinevalue == wsValue) {
                    // Sync is pending for this preference, return stored value.
                    return preference.value;
                }
                return _this.userOffline.setPreference(name, wsValue, wsValue).then(function () {
                    return wsValue;
                });
            });
        });
    };
    /**
     * Get cache key for a user preference WS call.
     *
     * @param {string} name Preference name.
     * @return {string} Cache key.
     */
    CoreUserProvider.prototype.getUserPreferenceCacheKey = function (name) {
        return this.ROOT_CACHE_KEY + 'preference:' + name;
    };
    /**
     * Get a user preference online.
     *
     * @param {string} name Name of the preference.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {string} Preference value or null if preference not set.
     */
    CoreUserProvider.prototype.getUserPreferenceOnline = function (name, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = { name: name };
            var preSets = {
                cacheKey: _this.getUserPreferenceCacheKey(data.name),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('core_user_get_user_preferences', data, preSets).then(function (result) {
                return result.preferences[0] ? result.preferences[0].value : null;
            });
        });
    };
    /**
     * Invalidates user WS calls.
     *
     * @param {number} userId User ID.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>}       Promise resolved when the data is invalidated.
     */
    CoreUserProvider.prototype.invalidateUserCache = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUserCacheKey(userId));
        });
    };
    /**
     * Invalidates participant list for a certain course.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>}         Promise resolved when the list is invalidated.
     */
    CoreUserProvider.prototype.invalidateParticipantsList = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getParticipantsListCacheKey(courseId));
        });
    };
    /**
     * Invalidate user preference.
     *
     * @param {string} name Name of the preference.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreUserProvider.prototype.invalidateUserPreference = function (name, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUserPreferenceCacheKey(name));
        });
    };
    /**
     * Check if course participants is disabled in a certain site.
     *
     * @param  {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>}     Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreUserProvider.prototype.isParticipantsDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isParticipantsDisabledInSite(site);
        });
    };
    /**
     * Check if course participants is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreUserProvider.prototype.isParticipantsDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreCourseOptionsDelegate_CoreUserParticipants');
    };
    /**
     * Returns whether or not participants is enabled for a certain course.
     *
     * @param {number} courseId Course ID.
     * @param  {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>}    Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    CoreUserProvider.prototype.isPluginEnabledForCourse = function (courseId, siteId) {
        if (!courseId) {
            return Promise.reject(null);
        }
        // Retrieving one participant will fail if browsing users is disabled by capabilities.
        return this.utils.promiseWorks(this.getParticipants(courseId, 0, 1, siteId));
    };
    /**
     * Check if update profile picture is disabled in a certain site.
     *
     * @param  {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean}       True if disabled, false otherwise.
     */
    CoreUserProvider.prototype.isUpdatePictureDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreUserDelegate_picture');
    };
    /**
     * Log User Profile View in Moodle.
     * @param  {number}       userId   User ID.
     * @param  {number}       [courseId] Course ID.
     * @param  {string}       [name] Name of the user.
     * @return {Promise<any>}          Promise resolved when done.
     */
    CoreUserProvider.prototype.logView = function (userId, courseId, name) {
        var params = {
            userid: userId
        }, wsName = 'core_user_view_user_profile';
        if (courseId) {
            params['courseid'] = courseId;
        }
        this.pushNotificationsProvider.logViewEvent(userId, name, 'user', wsName, { courseid: courseId });
        return this.sitesProvider.getCurrentSite().write(wsName, params);
    };
    /**
     * Log Participants list view in Moodle.
     * @param  {number}       courseId Course ID.
     * @return {Promise<any>}          Promise resolved when done.
     */
    CoreUserProvider.prototype.logParticipantsView = function (courseId) {
        var params = {
            courseid: courseId
        };
        this.pushNotificationsProvider.logViewListEvent('user', 'core_user_view_user_list', params);
        return this.sitesProvider.getCurrentSite().write('core_user_view_user_list', params);
    };
    /**
     * Prefetch user profiles and their images from a certain course. It prevents duplicates.
     *
     * @param {number[]} userIds List of user IDs.
     * @param {number} [courseId] Course the users belong to.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when prefetched.
     */
    CoreUserProvider.prototype.prefetchProfiles = function (userIds, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var treated = {}, promises = [];
        userIds.forEach(function (userId) {
            if (userId === null) {
                return;
            }
            userId = Number(userId); // Make sure it's a number.
            // Prevent repeats and errors.
            if (!isNaN(userId) && !treated[userId] && userId > 0) {
                treated[userId] = true;
                promises.push(_this.getProfile(userId, courseId, false, siteId).then(function (profile) {
                    if (profile.profileimageurl) {
                        _this.filepoolProvider.addToQueueByUrl(siteId, profile.profileimageurl);
                    }
                }));
            }
        });
        return Promise.all(promises);
    };
    /**
     * Store user basic information in local DB to be retrieved if the WS call fails.
     *
     * @param {number} userId   User ID.
     * @param {string} fullname User full name.
     * @param {string} avatar   User avatar URL.
     * @param  {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>}         Promise resolve when the user is stored.
     */
    CoreUserProvider.prototype.storeUser = function (userId, fullname, avatar, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var userRecord = {
                id: userId,
                fullname: fullname,
                profileimageurl: avatar
            };
            return site.getDb().insertRecord(_this.USERS_TABLE, userRecord);
        });
    };
    /**
     * Store users basic information in local DB.
     *
     * @param  {any[]} users     Users to store. Fields stored: id, fullname, profileimageurl.
     * @param  {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>}        Promise resolve when the user is stored.
     */
    CoreUserProvider.prototype.storeUsers = function (users, siteId) {
        var _this = this;
        var promises = [];
        users.forEach(function (user) {
            if (typeof user.id != 'undefined' && !isNaN(parseInt(user.id, 10))) {
                promises.push(_this.storeUser(parseInt(user.id, 10), user.fullname, user.profileimageurl, siteId));
            }
        });
        return Promise.all(promises);
    };
    /**
     * Set a user preference (online or offline).
     *
     * @param {string} name Name of the preference.
     * @param {string} value Value of the preference.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved on success.
     */
    CoreUserProvider.prototype.setUserPreference = function (name, value, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var isOnline = this.appProvider.isOnline();
        var promise;
        if (isOnline) {
            var preferences = [{ type: name, value: value }];
            promise = this.updateUserPreferences(preferences, undefined, undefined, siteId).catch(function (error) {
                // Preference not saved online.
                isOnline = false;
                return Promise.reject(error);
            });
        }
        else {
            promise = Promise.resolve();
        }
        return promise.finally(function () {
            // Update stored online value if saved online.
            var onlineValue = isOnline ? value : undefined;
            return Promise.all([
                _this.userOffline.setPreference(name, value, onlineValue),
                _this.invalidateUserPreference(name).catch(function () {
                    // Ignore error.
                })
            ]);
        });
    };
    /**
     * Update a preference for a user.
     *
     * @param  {string} name     Preference name.
     * @param  {any} value       Preference new value.
     * @param  {number} [userId] User ID. If not defined, site's current user.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if success.
     */
    CoreUserProvider.prototype.updateUserPreference = function (name, value, userId, siteId) {
        var preferences = [
            {
                type: name,
                value: value
            }
        ];
        return this.updateUserPreferences(preferences, undefined, userId, siteId);
    };
    /**
     * Update some preferences for a user.
     *
     * @param  {{name: string, value: string}[]} preferences List of preferences.
     * @param  {boolean} [disableNotifications] Whether to disable all notifications. Undefined to not update this value.
     * @param  {number} [userId]                User ID. If not defined, site's current user.
     * @param  {string} [siteId]                Site ID. If not defined, current site.
     * @return {Promise<any>}                   Promise resolved if success.
     */
    CoreUserProvider.prototype.updateUserPreferences = function (preferences, disableNotifications, userId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var data = {
                userid: userId,
                preferences: preferences
            }, preSets = {
                responseExpected: false
            };
            if (typeof disableNotifications != 'undefined') {
                data['emailstop'] = disableNotifications ? 1 : 0;
            }
            return site.write('core_user_update_user_preferences', data, preSets);
        });
    };
    CoreUserProvider.PARTICIPANTS_LIST_LIMIT = 50; // Max of participants to retrieve in each WS call.
    CoreUserProvider.PROFILE_REFRESHED = 'CoreUserProfileRefreshed';
    CoreUserProvider.PROFILE_PICTURE_UPDATED = 'CoreUserProfilePictureUpdated';
    CoreUserProvider = CoreUserProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* CoreUserOfflineProvider */], __WEBPACK_IMPORTED_MODULE_8__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], CoreUserProvider);
    return CoreUserProvider;
    var CoreUserProvider_1;
}());

//# sourceMappingURL=user.js.map

/***/ }),
/* 27 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModulePrefetchDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__classes_cache__ = __webpack_require__(759);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_12_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__classes_delegate__ = __webpack_require__(62);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Delegate to register module prefetch handlers.
 */
var CoreCourseModulePrefetchDelegate = /** @class */ (function (_super) {
    __extends(CoreCourseModulePrefetchDelegate, _super);
    function CoreCourseModulePrefetchDelegate(loggerProvider, sitesProvider, utils, courseProvider, filepoolProvider, timeUtils, fileProvider, eventsProvider) {
        var _this = _super.call(this, 'CoreCourseModulePrefetchDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.sitesProvider = sitesProvider;
        _this.utils = utils;
        _this.courseProvider = courseProvider;
        _this.filepoolProvider = filepoolProvider;
        _this.timeUtils = timeUtils;
        _this.fileProvider = fileProvider;
        _this.eventsProvider = eventsProvider;
        // Variables for database.
        _this.CHECK_UPDATES_TIMES_TABLE = 'check_updates_times';
        _this.siteSchema = {
            name: 'CoreCourseModulePrefetchDelegate',
            version: 1,
            tables: [
                {
                    name: _this.CHECK_UPDATES_TIMES_TABLE,
                    columns: [
                        {
                            name: 'courseId',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'time',
                            type: 'INTEGER',
                            notNull: true
                        }
                    ]
                }
            ]
        };
        _this.ROOT_CACHE_KEY = 'mmCourse:';
        _this.statusCache = new __WEBPACK_IMPORTED_MODULE_9__classes_cache__["a" /* CoreCache */]();
        _this.handlerNameProperty = 'modName';
        // Promises for check updates, to prevent performing the same request twice at the same time.
        _this.courseUpdatesPromises = {};
        // Promises and observables for prefetching, to prevent downloading same section twice at the same time and notify progress.
        _this.prefetchData = {};
        _this.sitesProvider.registerSiteSchema(_this.siteSchema);
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */].LOGOUT, _this.clearStatusCache.bind(_this));
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */].PACKAGE_STATUS_CHANGED, function (data) {
            _this.updateStatusCache(data.status, data.component, data.componentId);
        }, _this.sitesProvider.getCurrentSiteId());
        return _this;
    }
    /**
     * Check if current site can check updates using core_course_check_updates.
     *
     * @return {boolean} True if can check updates, false otherwise.
     */
    CoreCourseModulePrefetchDelegate.prototype.canCheckUpdates = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_course_check_updates');
    };
    /**
     * Check if a certain module can use core_course_check_updates.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<boolean>} Promise resolved with boolean: whether the module can use check updates WS.
     */
    CoreCourseModulePrefetchDelegate.prototype.canModuleUseCheckUpdates = function (module, courseId) {
        var handler = this.getPrefetchHandlerFor(module);
        if (!handler) {
            // Module not supported, cannot use check updates.
            return Promise.resolve(false);
        }
        if (handler.canUseCheckUpdates) {
            return Promise.resolve(handler.canUseCheckUpdates(module, courseId));
        }
        // By default, modules can use check updates.
        return Promise.resolve(true);
    };
    /**
     * Clear the status cache.
     */
    CoreCourseModulePrefetchDelegate.prototype.clearStatusCache = function () {
        this.statusCache.clear();
    };
    /**
     * Creates the list of modules to check for get course updates.
     *
     * @param {any[]} modules List of modules.
     * @param {number} courseId Course ID the modules belong to.
     * @return {Promise<{toCheck: any[], cannotUse: any[]}>} Promise resolved with the lists.
     */
    CoreCourseModulePrefetchDelegate.prototype.createToCheckList = function (modules, courseId) {
        var _this = this;
        var result = {
            toCheck: [],
            cannotUse: []
        }, promises = [];
        modules.forEach(function (module) {
            promises.push(_this.getModuleStatusAndDownloadTime(module, courseId).then(function (data) {
                if (data.status == __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADED) {
                    // Module is downloaded and not outdated. Check if it can check updates.
                    return _this.canModuleUseCheckUpdates(module, courseId).then(function (canUse) {
                        if (canUse) {
                            // Can use check updates, add it to the tocheck list.
                            result.toCheck.push({
                                contextlevel: 'module',
                                id: module.id,
                                since: data.downloadTime || 0
                            });
                        }
                        else {
                            // Cannot use check updates, add it to the cannotUse array.
                            result.cannotUse.push(module);
                        }
                    });
                }
            }).catch(function () {
                // Ignore errors.
            }));
        });
        return Promise.all(promises).then(function () {
            // Sort toCheck list.
            result.toCheck.sort(function (a, b) {
                return a.id >= b.id ? 1 : -1;
            });
            return result;
        });
    };
    /**
     * Determines a module status based on current status, restoring downloads if needed.
     *
     * @param {any} module Module.
     * @param {string} status Current status.
     * @param {boolean} [canCheck] True if updates can be checked using core_course_check_updates.
     * @return {string} Module status.
     */
    CoreCourseModulePrefetchDelegate.prototype.determineModuleStatus = function (module, status, canCheck) {
        var handler = this.getPrefetchHandlerFor(module), siteId = this.sitesProvider.getCurrentSiteId();
        if (handler) {
            if (status == __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADING) {
                // Check if the download is being handled.
                if (!this.filepoolProvider.getPackageDownloadPromise(siteId, handler.component, module.id)) {
                    // Not handled, the app was probably restarted or something weird happened.
                    // Re-start download (files already on queue or already downloaded will be skipped).
                    handler.prefetch(module);
                }
            }
            else if (handler.determineStatus) {
                // The handler implements a determineStatus function. Apply it.
                canCheck = canCheck || this.canCheckUpdates();
                return handler.determineStatus(module, status, canCheck);
            }
        }
        return status;
    };
    /**
     * Check for updates in a course.
     *
     * @param {any[]} modules List of modules.
     * @param {number} courseId  Course ID the modules belong to.
     * @return {Promise<any>} Promise resolved with the updates. If a module is set to false, it means updates cannot be
     *                        checked for that module in the current site.
     */
    CoreCourseModulePrefetchDelegate.prototype.getCourseUpdates = function (modules, courseId) {
        var _this = this;
        if (!this.canCheckUpdates()) {
            return Promise.reject(null);
        }
        // Check if there's already a getCourseUpdates in progress.
        var id = __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__["Md5"].hashAsciiStr(courseId + '#' + JSON.stringify(modules)), siteId = this.sitesProvider.getCurrentSiteId();
        if (this.courseUpdatesPromises[siteId] && this.courseUpdatesPromises[siteId][id]) {
            // There's already a get updates ongoing, return the promise.
            return this.courseUpdatesPromises[siteId][id];
        }
        else if (!this.courseUpdatesPromises[siteId]) {
            this.courseUpdatesPromises[siteId] = {};
        }
        this.courseUpdatesPromises[siteId][id] = this.createToCheckList(modules, courseId).then(function (data) {
            var result = {};
            // Mark as false the modules that cannot use check updates WS.
            data.cannotUse.forEach(function (module) {
                result[module.id] = false;
            });
            if (!data.toCheck.length) {
                // Nothing to check, no need to call the WS.
                return result;
            }
            // Get the site, maybe the user changed site.
            return _this.sitesProvider.getSite(siteId).then(function (site) {
                var params = {
                    courseid: courseId,
                    tocheck: data.toCheck
                }, preSets = {
                    cacheKey: _this.getCourseUpdatesCacheKey(courseId),
                    emergencyCache: false,
                    uniqueCacheKey: true
                };
                return site.read('core_course_check_updates', params, preSets).then(function (response) {
                    if (!response || typeof response.instances == 'undefined') {
                        return Promise.reject(null);
                    }
                    // Store the last execution of the check updates call.
                    var entry = {
                        courseId: courseId,
                        time: _this.timeUtils.timestamp()
                    };
                    site.getDb().insertRecord(_this.CHECK_UPDATES_TIMES_TABLE, entry).catch(function () {
                        // Ignore errors.
                    });
                    return _this.treatCheckUpdatesResult(data.toCheck, response, result);
                }).catch(function (error) {
                    // Cannot get updates.
                    // Get cached entries but discard modules with a download time higher than the last execution of check updates.
                    return site.getDb().getRecord(_this.CHECK_UPDATES_TIMES_TABLE, { courseId: courseId }).then(function (entry) {
                        preSets.getCacheUsingCacheKey = true;
                        preSets.omitExpires = true;
                        return site.read('core_course_check_updates', params, preSets).then(function (response) {
                            if (!response || typeof response.instances == 'undefined') {
                                return Promise.reject(error);
                            }
                            return _this.treatCheckUpdatesResult(data.toCheck, response, result, entry.time);
                        });
                    }, function () {
                        // No previous executions, return result as it is.
                        return result;
                    });
                });
            });
        }).finally(function () {
            // Get updates finished, delete the promise.
            delete _this.courseUpdatesPromises[siteId][id];
        });
        return this.courseUpdatesPromises[siteId][id];
    };
    /**
     * Check for updates in a course.
     *
     * @param {number} courseId Course ID the modules belong to.
     * @return {Promise<any>} Promise resolved with the updates.
     */
    CoreCourseModulePrefetchDelegate.prototype.getCourseUpdatesByCourseId = function (courseId) {
        var _this = this;
        if (!this.canCheckUpdates()) {
            return Promise.reject(null);
        }
        // Get course sections and all their modules.
        return this.courseProvider.getSections(courseId, false, true, { omitExpires: true }).then(function (sections) {
            return _this.getCourseUpdates(_this.courseProvider.getSectionsModules(sections), courseId);
        });
    };
    /**
     * Get cache key for course updates WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    CoreCourseModulePrefetchDelegate.prototype.getCourseUpdatesCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'courseUpdates:' + courseId;
    };
    /**
     * Get modules download size. Only treat the modules with status not downloaded or outdated.
     *
     * @param {any[]} modules List of modules.
     * @param {number} courseId Course ID the modules belong to.
     * @return {Promise<{size: number, total: boolean}>} Promise resolved with the size and a boolean indicating if it was able
     *                                                   to calculate the total size.
     */
    CoreCourseModulePrefetchDelegate.prototype.getDownloadSize = function (modules, courseId) {
        var _this = this;
        // Get the status of each module.
        return this.getModulesStatus(modules, courseId).then(function (data) {
            var downloadableModules = data[__WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADED].concat(data[__WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].OUTDATED]), promises = [], result = {
                size: 0,
                total: true
            };
            downloadableModules.forEach(function (module) {
                promises.push(_this.getModuleDownloadSize(module, courseId).then(function (size) {
                    result.total = result.total && size.total;
                    result.size += size.size;
                }));
            });
            return Promise.all(promises).then(function () {
                return result;
            });
        });
    };
    /**
     * Get the download size of a module.
     *
     * @param {any} module Module to get size.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<{size: number, total: boolean}>} Promise resolved with the size and a boolean indicating if it was able
     *                                                   to calculate the total size.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModuleDownloadSize = function (module, courseId, single) {
        var _this = this;
        var handler = this.getPrefetchHandlerFor(module);
        var downloadSize, packageId;
        // Check if the module has a prefetch handler.
        if (handler) {
            return this.isModuleDownloadable(module, courseId).then(function (downloadable) {
                if (!downloadable) {
                    return { size: 0, total: true };
                }
                packageId = _this.filepoolProvider.getPackageId(handler.component, module.id);
                downloadSize = _this.statusCache.getValue(packageId, 'downloadSize');
                if (typeof downloadSize != 'undefined') {
                    return downloadSize;
                }
                return Promise.resolve(handler.getDownloadSize(module, courseId, single)).then(function (size) {
                    return _this.statusCache.setValue(packageId, 'downloadSize', size);
                }).catch(function (error) {
                    var cachedSize = _this.statusCache.getValue(packageId, 'downloadSize', true);
                    if (cachedSize) {
                        return cachedSize;
                    }
                    return Promise.reject(error);
                });
            });
        }
        return Promise.resolve({ size: 0, total: false });
    };
    /**
     * Get the download size of a module.
     *
     * @param {any} module Module to get size.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<number>} Promise resolved with the size.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModuleDownloadedSize = function (module, courseId) {
        var _this = this;
        var handler = this.getPrefetchHandlerFor(module);
        var downloadedSize, packageId, promise;
        // Check if the module has a prefetch handler.
        if (handler) {
            return this.isModuleDownloadable(module, courseId).then(function (downloadable) {
                if (!downloadable) {
                    return 0;
                }
                packageId = _this.filepoolProvider.getPackageId(handler.component, module.id);
                downloadedSize = _this.statusCache.getValue(packageId, 'downloadedSize');
                if (typeof downloadedSize != 'undefined') {
                    return downloadedSize;
                }
                if (handler.getDownloadedSize) {
                    // Handler implements a method to calculate the downloaded size, use it.
                    promise = Promise.resolve(handler.getDownloadedSize(module, courseId));
                }
                else {
                    // Handler doesn't implement it, get the module files and check if they're downloaded.
                    promise = _this.getModuleFiles(module, courseId).then(function (files) {
                        var siteId = _this.sitesProvider.getCurrentSiteId(), promises = [];
                        var size = 0;
                        // Retrieve file size if it's downloaded.
                        files.forEach(function (file) {
                            var fileUrl = file.url || file.fileurl;
                            promises.push(_this.filepoolProvider.getFilePathByUrl(siteId, fileUrl).then(function (path) {
                                return _this.fileProvider.getFileSize(path).catch(function () {
                                    // Error getting size. Check if the file is being downloaded.
                                    return _this.filepoolProvider.isFileDownloadingByUrl(siteId, fileUrl).then(function () {
                                        // If downloading, count as downloaded.
                                        return file.filesize;
                                    }).catch(function () {
                                        // Not downloading and not found in disk.
                                        return 0;
                                    });
                                }).then(function (fs) {
                                    size += fs;
                                });
                            }));
                        });
                        return Promise.all(promises).then(function () {
                            return size;
                        });
                    });
                }
                return promise.then(function (size) {
                    return _this.statusCache.setValue(packageId, 'downloadedSize', size);
                }).catch(function () {
                    return _this.statusCache.getValue(packageId, 'downloadedSize', true);
                });
            });
        }
        return Promise.resolve(0);
    };
    /**
     * Get module files.
     *
     * @param {any} module Module to get the files.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModuleFiles = function (module, courseId) {
        var handler = this.getPrefetchHandlerFor(module);
        if (handler.getFiles) {
            // The handler defines a function to get files, use it.
            return Promise.resolve(handler.getFiles(module, courseId));
        }
        else if (handler.loadContents) {
            // The handler defines a function to load contents, use it before returning module contents.
            return handler.loadContents(module, courseId).then(function () {
                return module.contents;
            });
        }
        else {
            return Promise.resolve(module.contents || []);
        }
    };
    /**
     * Get the module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {any} [updates] Result of getCourseUpdates for all modules in the course. If not provided, it will be
     *                        calculated (slower). If it's false it means the site doesn't support check updates.
     * @param {boolean} [refresh] True if it should ignore the cache.
     * @param {number} [sectionId] ID of the section the module belongs to.
     * @return {Promise<string>} Promise resolved with the status.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModuleStatus = function (module, courseId, updates, refresh, sectionId) {
        var _this = this;
        var handler = this.getPrefetchHandlerFor(module), siteId = this.sitesProvider.getCurrentSiteId(), canCheck = this.canCheckUpdates();
        if (handler) {
            // Check if the status is cached.
            var component_1 = handler.component, packageId_1 = this.filepoolProvider.getPackageId(component_1, module.id);
            var status_1 = this.statusCache.getValue(packageId_1, 'status'), updateStatus_1 = true, promise_1;
            if (!refresh && typeof status_1 != 'undefined') {
                this.storeCourseAndSection(packageId_1, courseId, sectionId);
                return Promise.resolve(this.determineModuleStatus(module, status_1, canCheck));
            }
            // Check if the module is downloadable.
            return this.isModuleDownloadable(module, courseId).then(function (downloadable) {
                if (!downloadable) {
                    return __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE;
                }
                // Get the saved package status.
                return _this.filepoolProvider.getPackageStatus(siteId, component_1, module.id).then(function (currentStatus) {
                    status_1 = handler.determineStatus ? handler.determineStatus(module, currentStatus, canCheck) : currentStatus;
                    if (status_1 != __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADED) {
                        return status_1;
                    }
                    // Module is downloaded. Determine if there are updated in the module to show them outdated.
                    if (typeof updates == 'undefined') {
                        // We don't have course updates, calculate them.
                        promise_1 = _this.getCourseUpdatesByCourseId(courseId);
                    }
                    else if (updates === false) {
                        // Cannot check updates.
                        return status_1;
                    }
                    else {
                        promise_1 = Promise.resolve(updates);
                    }
                    return promise_1.then(function (updates) {
                        if (!updates || updates[module.id] === false) {
                            // Cannot check updates, always show outdated.
                            return __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].OUTDATED;
                        }
                        // Check if the module has any update.
                        return _this.moduleHasUpdates(module, courseId, updates).then(function (hasUpdates) {
                            if (!hasUpdates) {
                                // No updates, keep current status.
                                return status_1;
                            }
                            // Has updates, mark the module as outdated.
                            status_1 = __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].OUTDATED;
                            return _this.filepoolProvider.storePackageStatus(siteId, status_1, component_1, module.id).catch(function () {
                                // Ignore errors.
                            }).then(function () {
                                return status_1;
                            });
                        }).catch(function () {
                            // Error checking if module has updates.
                            var status = _this.statusCache.getValue(packageId_1, 'status', true);
                            return _this.determineModuleStatus(module, status, canCheck);
                        });
                    }, function () {
                        // Error getting updates, show the stored status.
                        updateStatus_1 = false;
                        _this.storeCourseAndSection(packageId_1, courseId, sectionId);
                        return currentStatus;
                    });
                });
            }).then(function (status) {
                if (updateStatus_1) {
                    _this.updateStatusCache(status, component_1, module.id, courseId, sectionId);
                }
                return _this.determineModuleStatus(module, status, canCheck);
            });
        }
        // No handler found, module not downloadable.
        return Promise.resolve(__WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE);
    };
    /**
     * Get the status of a list of modules, along with the lists of modules for each status.
     * @see {@link CoreFilepoolProvider.determinePackagesStatus}
     *
     * @param {any[]} modules List of modules to prefetch.
     * @param {number} courseId Course ID the modules belong to.
     * @param {number} [sectionId] ID of the section the modules belong to.
     * @param {boolean} [refresh] True if it should always check the DB (slower).
     * @param {boolean} [onlyToDisplay] True if the status will only be used to determine which button should be displayed.
     * @return {Promise<any>} Promise resolved with an object with the following properties:
     *                                - status (string) Status of the module.
     *                                - total (number) Number of modules.
     *                                - CoreConstants.NOT_DOWNLOADED (any[]) Modules with state NOT_DOWNLOADED.
     *                                - CoreConstants.DOWNLOADED (any[]) Modules with state DOWNLOADED.
     *                                - CoreConstants.DOWNLOADING (any[]) Modules with state DOWNLOADING.
     *                                - CoreConstants.OUTDATED (any[]) Modules with state OUTDATED.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModulesStatus = function (modules, courseId, sectionId, refresh, onlyToDisplay) {
        var _this = this;
        var promises = [], result = {
            total: 0
        };
        var status = __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE;
        // Init result.
        result[__WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADED] = [];
        result[__WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADED] = [];
        result[__WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADING] = [];
        result[__WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].OUTDATED] = [];
        // Check updates in course. Don't use getCourseUpdates because the list of modules might not be the whole course list.
        return this.getCourseUpdatesByCourseId(courseId).catch(function () {
            // Cannot get updates.
            return false;
        }).then(function (updates) {
            modules.forEach(function (module) {
                // Check if the module has a prefetch handler.
                var handler = _this.getPrefetchHandlerFor(module);
                if (handler) {
                    if (onlyToDisplay && handler.skipListStatus) {
                        // Skip this module.
                        return;
                    }
                    var packageId_2 = _this.filepoolProvider.getPackageId(handler.component, module.id);
                    promises.push(_this.getModuleStatus(module, courseId, updates, refresh).then(function (modStatus) {
                        if (result[modStatus]) {
                            status = _this.filepoolProvider.determinePackagesStatus(status, modStatus);
                            result[modStatus].push(module);
                            result.total++;
                        }
                    }).catch(function (error) {
                        var cacheStatus = _this.statusCache.getValue(packageId_2, 'status', true);
                        if (typeof cacheStatus == 'undefined') {
                            return Promise.reject(error);
                        }
                        if (result[cacheStatus]) {
                            status = _this.filepoolProvider.determinePackagesStatus(status, cacheStatus);
                            result[cacheStatus].push(module);
                            result.total++;
                        }
                    }));
                }
            });
            return Promise.all(promises).then(function () {
                result.status = status;
                return result;
            });
        });
    };
    /**
     * Get a module status and download time. It will only return the download time if the module is downloaded or outdated.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<{status: string, downloadTime?: number}>} Promise resolved with the data.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModuleStatusAndDownloadTime = function (module, courseId) {
        var _this = this;
        var handler = this.getPrefetchHandlerFor(module), siteId = this.sitesProvider.getCurrentSiteId();
        if (handler) {
            // Get the status from the cache.
            var packageId = this.filepoolProvider.getPackageId(handler.component, module.id), status_2 = this.statusCache.getValue(packageId, 'status');
            if (typeof status_2 != 'undefined' && status_2 != __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADED && status_2 != __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].OUTDATED) {
                // Module isn't downloaded, just return the status.
                return Promise.resolve({
                    status: status_2
                });
            }
            // Check if the module is downloadable.
            return this.isModuleDownloadable(module, courseId).then(function (downloadable) {
                if (!downloadable) {
                    return {
                        status: __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE
                    };
                }
                // Get the stored data to get the status and downloadTime.
                return _this.filepoolProvider.getPackageData(siteId, handler.component, module.id).then(function (data) {
                    return {
                        status: data.status,
                        downloadTime: data.downloadTime || 0
                    };
                });
            });
        }
        // No handler found, module not downloadable.
        return Promise.resolve({
            status: __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE
        });
    };
    /**
     * Get updates for a certain module.
     * It will only return the updates if the module can use check updates and it's downloaded or outdated.
     *
     * @param {any} module Module to check.
     * @param {number} courseId Course the module belongs to.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the updates.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModuleUpdates = function (module, courseId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Get the status and download time of the module.
            return _this.getModuleStatusAndDownloadTime(module, courseId).then(function (data) {
                if (data.status != __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].DOWNLOADED && data.status != __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].OUTDATED) {
                    // Not downloaded, no updates.
                    return {};
                }
                // Module is downloaded. Check if it can check updates.
                return _this.canModuleUseCheckUpdates(module, courseId).then(function (canUse) {
                    if (!canUse) {
                        // Can't use check updates, no updates.
                        return {};
                    }
                    var params = {
                        courseid: courseId,
                        tocheck: [
                            {
                                contextlevel: 'module',
                                id: module.id,
                                since: data.downloadTime || 0
                            }
                        ]
                    }, preSets = {
                        cacheKey: _this.getModuleUpdatesCacheKey(courseId, module.id),
                    };
                    if (ignoreCache) {
                        preSets.getFromCache = false;
                        preSets.emergencyCache = false;
                    }
                    return site.read('core_course_check_updates', params, preSets).then(function (response) {
                        if (!response || !response.instances || !response.instances[0]) {
                            return Promise.reject(null);
                        }
                        return response.instances[0];
                    });
                });
            });
        });
    };
    /**
     * Get cache key for module updates WS calls.
     *
     * @param {number} courseId Course ID.
     * @param {number} moduleId Module ID.
     * @return {string} Cache key.
     */
    CoreCourseModulePrefetchDelegate.prototype.getModuleUpdatesCacheKey = function (courseId, moduleId) {
        return this.getCourseUpdatesCacheKey(courseId) + ':' + moduleId;
    };
    /**
     * Get a prefetch handler.
     *
     * @param {any} module The module to work on.
     * @return {CoreCourseModulePrefetchHandler} Prefetch handler.
     */
    CoreCourseModulePrefetchDelegate.prototype.getPrefetchHandlerFor = function (module) {
        return this.getHandler(module.modname, true);
    };
    /**
     * Invalidate check updates WS call.
     *
     * @param {number} courseId Course ID.
     * @return {Promise<any>} Promise resolved when data is invalidated.
     */
    CoreCourseModulePrefetchDelegate.prototype.invalidateCourseUpdates = function (courseId) {
        return this.sitesProvider.getCurrentSite().invalidateWsCacheForKey(this.getCourseUpdatesCacheKey(courseId));
    };
    /**
     * Invalidate a list of modules in a course. This should only invalidate WS calls, not downloaded files.
     *
     * @param {any[]} modules List of modules.
     * @param {number} courseId Course ID.
     * @return {Promise<any>} Promise resolved when modules are invalidated.
     */
    CoreCourseModulePrefetchDelegate.prototype.invalidateModules = function (modules, courseId) {
        var _this = this;
        var promises = [];
        modules.forEach(function (module) {
            var handler = _this.getPrefetchHandlerFor(module);
            if (handler) {
                if (handler.invalidateModule) {
                    promises.push(handler.invalidateModule(module, courseId).catch(function () {
                        // Ignore errors.
                    }));
                }
                // Invalidate cache.
                _this.invalidateModuleStatusCache(module);
            }
        });
        promises.push(this.invalidateCourseUpdates(courseId));
        return Promise.all(promises);
    };
    /**
     * Invalidates the cache for a given module.
     *
     * @param {any} module Module to be invalidated.
     */
    CoreCourseModulePrefetchDelegate.prototype.invalidateModuleStatusCache = function (module) {
        var handler = this.getPrefetchHandlerFor(module);
        if (handler) {
            this.statusCache.invalidate(this.filepoolProvider.getPackageId(handler.component, module.id));
        }
    };
    /**
     * Invalidate check updates WS call for a certain module.
     *
     * @param {number} courseId Course ID.
     * @param {number} moduleId Module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data is invalidated.
     */
    CoreCourseModulePrefetchDelegate.prototype.invalidateModuleUpdates = function (courseId, moduleId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getModuleUpdatesCacheKey(courseId, moduleId));
        });
    };
    /**
     * Check if a list of modules is being downloaded.
     *
     * @param {string} id An ID to identify the download.
     * @return {boolean} True if it's being downloaded, false otherwise.
     */
    CoreCourseModulePrefetchDelegate.prototype.isBeingDownloaded = function (id) {
        var siteId = this.sitesProvider.getCurrentSiteId();
        return !!(this.prefetchData[siteId] && this.prefetchData[siteId][id]);
    };
    /**
     * Check if a module is downloadable.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @return {Promise<boolean>} Promise resolved with true if downloadable, false otherwise.
     */
    CoreCourseModulePrefetchDelegate.prototype.isModuleDownloadable = function (module, courseId) {
        var _this = this;
        if (module.uservisible === false) {
            // Module isn't visible by the user, cannot be downloaded.
            return Promise.resolve(false);
        }
        var handler = this.getPrefetchHandlerFor(module);
        if (handler) {
            if (typeof handler.isDownloadable == 'function') {
                var packageId_3 = this.filepoolProvider.getPackageId(handler.component, module.id), downloadable = this.statusCache.getValue(packageId_3, 'downloadable');
                if (typeof downloadable != 'undefined') {
                    return Promise.resolve(downloadable);
                }
                else {
                    return Promise.resolve(handler.isDownloadable(module, courseId)).then(function (downloadable) {
                        return _this.statusCache.setValue(packageId_3, 'downloadable', downloadable);
                    }).catch(function () {
                        // Something went wrong, assume it's not downloadable.
                        return false;
                    });
                }
            }
            else {
                // Function not defined, assume it's not downloadable.
                return Promise.resolve(true);
            }
        }
        else {
            // No handler for module, so it's not downloadable.
            return Promise.resolve(false);
        }
    };
    /**
     * Check if a module has updates based on the result of getCourseUpdates.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {any} updates Result of getCourseUpdates.
     * @return {Promise<boolean>} Promise resolved with boolean: whether the module has updates.
     */
    CoreCourseModulePrefetchDelegate.prototype.moduleHasUpdates = function (module, courseId, updates) {
        var handler = this.getPrefetchHandlerFor(module), moduleUpdates = updates[module.id];
        if (handler && handler.hasUpdates) {
            // Handler implements its own function to check the updates, use it.
            return Promise.resolve(handler.hasUpdates(module, courseId, moduleUpdates));
        }
        else if (!moduleUpdates || !moduleUpdates.updates || !moduleUpdates.updates.length) {
            // Module doesn't have any update.
            return Promise.resolve(false);
        }
        else if (handler && handler.updatesNames && handler.updatesNames.test) {
            // Check the update names defined by the handler.
            for (var i = 0, len = moduleUpdates.updates.length; i < len; i++) {
                if (handler.updatesNames.test(moduleUpdates.updates[i].name)) {
                    return Promise.resolve(true);
                }
            }
            return Promise.resolve(false);
        }
        // Handler doesn't define hasUpdates or updatesNames and there is at least 1 update. Assume it has updates.
        return Promise.resolve(true);
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module to prefetch.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any>} Promise resolved when finished.
     */
    CoreCourseModulePrefetchDelegate.prototype.prefetchModule = function (module, courseId, single) {
        var handler = this.getPrefetchHandlerFor(module);
        // Check if the module has a prefetch handler.
        if (handler) {
            return this.syncModule(module, courseId).then(function () {
                return handler.prefetch(module, courseId, single);
            });
        }
        return Promise.resolve();
    };
    /**
     * Sync a group of modules.
     *
     * @param  {any[]}        modules Array of modules to sync.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>}         Promise resolved when finished.
     */
    CoreCourseModulePrefetchDelegate.prototype.syncModules = function (modules, courseId) {
        var _this = this;
        return Promise.all(modules.map(function (module) {
            return _this.syncModule(module, courseId).then(function () {
                // Invalidate course updates.
                return _this.invalidateCourseUpdates(courseId).catch(function () {
                    // Ignore errors.
                });
            });
        }));
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module to sync.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when finished.
     */
    CoreCourseModulePrefetchDelegate.prototype.syncModule = function (module, courseId) {
        var _this = this;
        var handler = this.getPrefetchHandlerFor(module);
        if (handler && handler.sync) {
            return handler.sync(module, courseId).then(function (result) {
                // Always invalidate status cache for this module. We cannot know if data was sent to server or not.
                _this.invalidateModuleStatusCache(module);
                return result;
            }).catch(function () {
                // Ignore errors.
            });
        }
        return Promise.resolve();
    };
    /**
     * Prefetches a list of modules using their prefetch handlers.
     * If a prefetch already exists for this site and id, returns the current promise.
     *
     * @param {string} id An ID to identify the download. It can be used to retrieve the download promise.
     * @param {any[]} modules List of modules to prefetch.
     * @param {number} courseId Course ID the modules belong to.
     * @param {CoreCourseModulesProgressFunction} [onProgress] Function to call everytime a module is downloaded.
     * @return {Promise<any>} Promise resolved when all modules have been prefetched.
     */
    CoreCourseModulePrefetchDelegate.prototype.prefetchModules = function (id, modules, courseId, onProgress) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId(), currentData = this.prefetchData[siteId] && this.prefetchData[siteId][id];
        if (currentData) {
            // There's a prefetch ongoing, return the current promise.
            if (onProgress) {
                currentData.subscriptions.push(currentData.observable.subscribe(onProgress));
            }
            return currentData.promise;
        }
        var count = 0;
        var promises = [], total = modules.length, moduleIds = modules.map(function (module) {
            return module.id;
        }), prefetchData = {
            observable: new __WEBPACK_IMPORTED_MODULE_12_rxjs__["BehaviorSubject"]({ count: count, total: total }),
            promise: undefined,
            subscriptions: []
        };
        if (onProgress) {
            prefetchData.observable.subscribe(onProgress);
        }
        modules.forEach(function (module) {
            // Check if the module has a prefetch handler.
            var handler = _this.getPrefetchHandlerFor(module);
            if (handler) {
                promises.push(_this.isModuleDownloadable(module, courseId).then(function (downloadable) {
                    if (!downloadable) {
                        return;
                    }
                    return handler.prefetch(module, courseId).then(function () {
                        var index = moduleIds.indexOf(module.id);
                        if (index > -1) {
                            // It's one of the modules we were expecting to download.
                            moduleIds.splice(index, 1);
                            count++;
                            prefetchData.observable.next({ count: count, total: total });
                        }
                    });
                }));
            }
        });
        // Set the promise.
        prefetchData.promise = this.utils.allPromises(promises).finally(function () {
            // Unsubscribe all observers.
            prefetchData.subscriptions.forEach(function (subscription) {
                subscription.unsubscribe();
            });
            delete _this.prefetchData[siteId][id];
        });
        // Store the prefetch data in the list.
        if (!this.prefetchData[siteId]) {
            this.prefetchData[siteId] = {};
        }
        this.prefetchData[siteId][id] = prefetchData;
        return prefetchData.promise;
    };
    /**
     * Remove module Files from handler.
     *
     * @param {any} module Module to remove the files.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<void>} Promise resolved when done.
     */
    CoreCourseModulePrefetchDelegate.prototype.removeModuleFiles = function (module, courseId) {
        var _this = this;
        var handler = this.getPrefetchHandlerFor(module), siteId = this.sitesProvider.getCurrentSiteId();
        var promise;
        if (handler && handler.removeFiles) {
            // Handler implements a method to remove the files, use it.
            promise = handler.removeFiles(module, courseId);
        }
        else {
            // No method to remove files, use get files to try to remove the files.
            promise = this.getModuleFiles(module, courseId).then(function (files) {
                var promises = [];
                files.forEach(function (file) {
                    promises.push(_this.filepoolProvider.removeFileByUrl(siteId, file.url || file.fileurl).catch(function () {
                        // Ignore errors.
                    }));
                });
                return Promise.all(promises);
            });
        }
        return promise.then(function () {
            if (handler) {
                // Update status of the module.
                var packageId = _this.filepoolProvider.getPackageId(handler.component, module.id);
                _this.statusCache.setValue(packageId, 'downloadedSize', 0);
                return _this.filepoolProvider.storePackageStatus(siteId, __WEBPACK_IMPORTED_MODULE_10__constants__["a" /* CoreConstants */].NOT_DOWNLOADED, handler.component, module.id);
            }
        });
    };
    /**
     * Set an on progress function for the download of a list of modules.
     *
     * @param {string} id An ID to identify the download.
     * @param {CoreCourseModulesProgressFunction} onProgress Function to call everytime a module is downloaded.
     */
    CoreCourseModulePrefetchDelegate.prototype.setOnProgress = function (id, onProgress) {
        var siteId = this.sitesProvider.getCurrentSiteId(), currentData = this.prefetchData[siteId] && this.prefetchData[siteId][id];
        if (currentData) {
            // There's a prefetch ongoing, return the current promise.
            currentData.subscriptions.push(currentData.observable.subscribe(onProgress));
        }
    };
    /**
     * If courseId or sectionId is set, save them in the cache.
     *
     * @param {string} packageId The package ID.
     * @param {number} [courseId] Course ID.
     * @param {number} [sectionId] Section ID.
     */
    CoreCourseModulePrefetchDelegate.prototype.storeCourseAndSection = function (packageId, courseId, sectionId) {
        if (courseId) {
            this.statusCache.setValue(packageId, 'courseId', courseId);
        }
        if (sectionId && sectionId > 0) {
            this.statusCache.setValue(packageId, 'sectionId', sectionId);
        }
    };
    /**
     * Treat the result of the check updates WS call.
     *
     * @param {any[]} toCheckList List of modules to check (from createToCheckList).
     * @param {any} response WS call response.
     * @param {any} result Object where to store the result.
     * @param {number} [previousTime] Time of the previous check updates execution. If set, modules downloaded
     *                                after this time will be ignored.
     * @return {any} Result.
     */
    CoreCourseModulePrefetchDelegate.prototype.treatCheckUpdatesResult = function (toCheckList, response, result, previousTime) {
        // Format the response to index it by module ID.
        this.utils.arrayToObject(response.instances, 'id', result);
        // Treat warnings, adding the not supported modules.
        response.warnings.forEach(function (warning) {
            if (warning.warningcode == 'missingcallback') {
                result[warning.itemid] = false;
            }
        });
        if (previousTime) {
            // Remove from the list the modules downloaded after previousTime.
            toCheckList.forEach(function (entry) {
                if (result[entry.id] && entry.since > previousTime) {
                    delete result[entry.id];
                }
            });
        }
        return result;
    };
    /**
     * Update the status of a module in the "cache".
     *
     * @param {string} status New status.
     * @param {string} component Package's component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [courseId] Course ID of the module.
     * @param {number} [sectionId] Section ID of the module.
     */
    CoreCourseModulePrefetchDelegate.prototype.updateStatusCache = function (status, component, componentId, courseId, sectionId) {
        var packageId = this.filepoolProvider.getPackageId(component, componentId), cachedStatus = this.statusCache.getValue(packageId, 'status', true);
        var notify;
        // If the status has changed, notify that the section has changed.
        notify = typeof cachedStatus != 'undefined' && cachedStatus !== status;
        // If courseId/sectionId is set, store it.
        this.storeCourseAndSection(packageId, courseId, sectionId);
        if (notify) {
            if (!courseId) {
                courseId = this.statusCache.getValue(packageId, 'courseId', true);
            }
            if (!sectionId) {
                sectionId = this.statusCache.getValue(packageId, 'sectionId', true);
            }
            // Invalidate and set again.
            this.statusCache.invalidate(packageId);
            this.statusCache.setValue(packageId, 'status', status);
            if (sectionId) {
                this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */].SECTION_STATUS_CHANGED, {
                    sectionId: sectionId,
                    courseId: courseId
                }, this.sitesProvider.getCurrentSiteId());
            }
        }
        else {
            this.statusCache.setValue(packageId, 'status', status);
        }
    };
    CoreCourseModulePrefetchDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreCourseModulePrefetchDelegate);
    return CoreCourseModulePrefetchDelegate;
}(__WEBPACK_IMPORTED_MODULE_13__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=module-prefetch-delegate.js.map

/***/ }),
/* 28 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContentLinksHandlerBase; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base handler to be registered in CoreContentLinksHandler. It is useful to minimize the amount of
 * functions that handlers need to implement.
 *
 * It allows you to specify a "pattern" (RegExp) that will be used to check if the handler handles a URL and to get its site URL.
 */
var CoreContentLinksHandlerBase = /** @class */ (function () {
    function CoreContentLinksHandlerBase() {
        /**
         * A name to identify the handler.
         * @type {string}
         */
        this.name = 'CoreContentLinksHandlerBase';
        /**
         * Handler's priority. The highest priority is treated first.
         * @type {number}
         */
        this.priority = 0;
        /**
         * Whether the isEnabled function should be called for all the users in a site. It should be true only if the isEnabled call
         * can return different values for different users in same site.
         * @type {boolean}
         */
        this.checkAllUsers = false;
        /**
         * Name of the feature this handler is related to.
         * It will be used to check if the feature is disabled (@see CoreSite.isFeatureDisabled).
         * @type {string}
         */
        this.featureName = '';
        // Nothing to do.
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreContentLinksHandlerBase.prototype.getActions = function (siteIds, url, params, courseId) {
        return [];
    };
    /**
     * Check if a URL is handled by this handler.
     *
     * @param {string} url The URL to check.
     * @return {boolean} Whether the URL is handled by this handler
     */
    CoreContentLinksHandlerBase.prototype.handles = function (url) {
        return this.pattern && url.search(this.pattern) >= 0;
    };
    /**
     * If the URL is handled by this handler, return the site URL.
     *
     * @param {string} url The URL to check.
     * @return {string} Site URL if it is handled, undefined otherwise.
     */
    CoreContentLinksHandlerBase.prototype.getSiteUrl = function (url) {
        if (this.pattern) {
            var position = url.search(this.pattern);
            if (position > -1) {
                return url.substr(0, position);
            }
        }
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreContentLinksHandlerBase.prototype.isEnabled = function (siteId, url, params, courseId) {
        return true;
    };
    return CoreContentLinksHandlerBase;
}());

//# sourceMappingURL=base-handler.js.map

/***/ }),
/* 29 */,
/* 30 */,
/* 31 */,
/* 32 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service that provides some features regarding lists of courses and categories.
 */
var CoreCoursesProvider = /** @class */ (function () {
    function CoreCoursesProvider(logger, sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.ROOT_CACHE_KEY = 'mmCourses:';
        this.logger = logger.getInstance('CoreCoursesProvider');
    }
    CoreCoursesProvider_1 = CoreCoursesProvider;
    /**
     * Whether current site supports getting course options.
     *
     * @return {boolean} Whether current site supports getting course options.
     */
    CoreCoursesProvider.prototype.canGetAdminAndNavOptions = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_course_get_user_navigation_options') &&
            this.sitesProvider.wsAvailableInCurrentSite('core_course_get_user_administration_options');
    };
    /**
     * Get categories. They can be filtered by id.
     *
     * @param {number} categoryId Category ID to get.
     * @param {boolean} [addSubcategories] If it should add subcategories to the list.
     * @param {string} [siteId] Site to get the courses from. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved with the categories.
     */
    CoreCoursesProvider.prototype.getCategories = function (categoryId, addSubcategories, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Get parent when id is the root category.
            var criteriaKey = categoryId == 0 ? 'parent' : 'id', data = {
                criteria: [
                    { key: criteriaKey, value: categoryId }
                ],
                addsubcategories: addSubcategories ? 1 : 0
            }, preSets = {
                cacheKey: _this.getCategoriesCacheKey(categoryId, addSubcategories),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_course_get_categories', data, preSets);
        });
    };
    /**
     * Get cache key for get categories methods WS call.
     *
     * @param {number} categoryId Category ID to get.
     * @param {boolean} [addSubcategories] If add subcategories to the list.
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getCategoriesCacheKey = function (categoryId, addSubcategories) {
        return this.ROOT_CACHE_KEY + 'categories:' + categoryId + ':' + !!addSubcategories;
    };
    /**
     * Given a list of course IDs to get course admin and nav options, return the list of courseIds to use.
     *
     * @param {number[]} courseIds Course IDs.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise}            Promise resolved with the list of course IDs.
     */
    CoreCoursesProvider.prototype.getCourseIdsForAdminAndNavOptions = function (courseIds, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var siteHomeId = site.getSiteHomeId();
            if (courseIds.length == 1) {
                // Only 1 course, check if it belongs to the user courses. If so, use all user courses.
                return _this.getUserCourses(true, siteId).then(function (courses) {
                    var courseId = courseIds[0];
                    var useAllCourses = false;
                    if (courseId == siteHomeId) {
                        // It's site home, use all courses.
                        useAllCourses = true;
                    }
                    else {
                        for (var i = 0; i < courses.length; i++) {
                            if (courses[i].id == courseId) {
                                useAllCourses = true;
                                break;
                            }
                        }
                    }
                    if (useAllCourses) {
                        // User is enrolled, retrieve all the courses.
                        courseIds = courses.map(function (course) {
                            return course.id;
                        });
                        // Always add the site home ID.
                        courseIds.push(siteHomeId);
                        // Sort the course IDs.
                        courseIds.sort(function (a, b) {
                            return b - a;
                        });
                    }
                    return courseIds;
                }).catch(function () {
                    // Ignore errors.
                    return courseIds;
                });
            }
            else {
                if (courseIds.length > 1 && courseIds.indexOf(siteHomeId) == -1) {
                    courseIds.push(siteHomeId);
                }
                // Sort the course IDs.
                courseIds.sort(function (a, b) {
                    return b - a;
                });
                return courseIds;
            }
        });
    };
    /**
     * Check if download a whole course is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreCoursesProvider.prototype.isDownloadCourseDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isDownloadCoursesDisabledInSite(site);
        });
    };
    /**
     * Check if download a whole course is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreCoursesProvider.prototype.isDownloadCourseDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isOfflineDisabled() || site.isFeatureDisabled('NoDelegate_CoreCourseDownload');
    };
    /**
     * Check if download all courses is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreCoursesProvider.prototype.isDownloadCoursesDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isDownloadCoursesDisabledInSite(site);
        });
    };
    /**
     * Check if download all courses is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreCoursesProvider.prototype.isDownloadCoursesDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isOfflineDisabled() || site.isFeatureDisabled('NoDelegate_CoreCoursesDownload');
    };
    /**
     * Check if My Courses is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreCoursesProvider.prototype.isMyCoursesDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isMyCoursesDisabledInSite(site);
        });
    };
    /**
     * Check if My Courses is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreCoursesProvider.prototype.isMyCoursesDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreMainMenuDelegate_CoreCourses');
    };
    /**
     * Check if Search Courses is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreCoursesProvider.prototype.isSearchCoursesDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isSearchCoursesDisabledInSite(site);
        });
    };
    /**
     * Check if Search Courses is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreCoursesProvider.prototype.isSearchCoursesDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreCourseOptionsDelegate_search');
    };
    /**
     * Get course.
     *
     * @param {number} id ID of the course to get.
     * @param {string} [siteId] Site to get the courses from. If not defined, use current site.
     * @return {Promise<any>} Promise resolved with the course.
     */
    CoreCoursesProvider.prototype.getCourse = function (id, siteId) {
        return this.getCourses([id], siteId).then(function (courses) {
            if (courses && courses.length > 0) {
                return courses[0];
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get the enrolment methods from a course.
     *
     * @param {number} id ID of the course.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any[]} Promise resolved with the methods.
     */
    CoreCoursesProvider.prototype.getCourseEnrolmentMethods = function (id, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseid: id
            }, preSets = {
                cacheKey: _this.getCourseEnrolmentMethodsCacheKey(id),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_enrol_get_course_enrolment_methods', params, preSets);
        });
    };
    /**
     * Get cache key for get course enrolment methods WS call.
     *
     * @param {number} id Course ID.
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getCourseEnrolmentMethodsCacheKey = function (id) {
        return this.ROOT_CACHE_KEY + 'enrolmentmethods:' + id;
    };
    /**
     * Get info from a course guest enrolment method.
     *
     * @param {number} instanceId Guest instance ID.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the info is retrieved.
     */
    CoreCoursesProvider.prototype.getCourseGuestEnrolmentInfo = function (instanceId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                instanceid: instanceId
            }, preSets = {
                cacheKey: _this.getCourseGuestEnrolmentInfoCacheKey(instanceId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('enrol_guest_get_instance_info', params, preSets).then(function (response) {
                return response.instanceinfo;
            });
        });
    };
    /**
     * Get cache key for get course guest enrolment methods WS call.
     *
     * @param {number} instanceId Guest instance ID.
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getCourseGuestEnrolmentInfoCacheKey = function (instanceId) {
        return this.ROOT_CACHE_KEY + 'guestinfo:' + instanceId;
    };
    /**
     * Get courses.
     * Warning: if the user doesn't have permissions to view some of the courses passed the WS call will fail.
     * The user must be able to view ALL the courses passed.
     *
     * @param {number[]} ids List of IDs of the courses to get.
     * @param {string} [siteId] Site to get the courses from. If not defined, use current site.
     * @return {Promise<any[]>}  Promise resolved with the courses.
     */
    CoreCoursesProvider.prototype.getCourses = function (ids, siteId) {
        var _this = this;
        if (!Array.isArray(ids)) {
            return Promise.reject(null);
        }
        else if (ids.length === 0) {
            return Promise.resolve([]);
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                options: {
                    ids: ids
                }
            }, preSets = {
                cacheKey: _this.getCoursesCacheKey(ids),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_course_get_courses', data, preSets);
        });
    };
    /**
     * Get cache key for get courses WS call.
     *
     * @param {number[]} ids Courses IDs.
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getCoursesCacheKey = function (ids) {
        return this.ROOT_CACHE_KEY + 'course:' + JSON.stringify(ids);
    };
    /**
     * This function is meant to decrease WS calls.
     * When requesting a single course that belongs to enrolled courses, request all enrolled courses because
     * the WS call is probably cached.
     *
     * @param {string} [field] The field to search.
     * @param {any} [value] The value to match.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{field: string, value: any}>} Promise resolved with the field and value to use.
     */
    CoreCoursesProvider.prototype.fixCoursesByFieldParams = function (field, value, siteId) {
        if (field == 'id' || field == 'ids') {
            var courseIds = String(value).split(',');
            // Use the same optimization as in get admin and nav options. This will return the course IDs to use.
            return this.getCourseIdsForAdminAndNavOptions(courseIds, siteId).then(function (courseIds) {
                if (courseIds.length > 1) {
                    return { field: 'ids', value: courseIds.join(',') };
                }
                else {
                    return { field: 'id', value: Number(courseIds[0]) };
                }
            });
        }
        else {
            // Nothing to do.
            return Promise.resolve({ field: field, value: value });
        }
    };
    /**
     * Get the first course returned by getCoursesByField.
     *
     * @param {string} [field] The field to search. Can be left empty for all courses or:
     *                             id: course id.
     *                             ids: comma separated course ids.
     *                             shortname: course short name.
     *                             idnumber: course id number.
     *                             category: category id the course belongs to.
     * @param {any} [value] The value to match.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved with the first course.
     * @since 3.2
     */
    CoreCoursesProvider.prototype.getCourseByField = function (field, value, siteId) {
        return this.getCoursesByField(field, value, siteId).then(function (courses) {
            if (courses && courses.length > 0) {
                return courses[0];
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get courses. They can be filtered by field.
     *
     * @param {string} [field] The field to search. Can be left empty for all courses or:
     *                             id: course id.
     *                             ids: comma separated course ids.
     *                             shortname: course short name.
     *                             idnumber: course id number.
     *                             category: category id the course belongs to.
     * @param {any} [value] The value to match.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved with the courses.
     * @since 3.2
     */
    CoreCoursesProvider.prototype.getCoursesByField = function (field, value, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var originalValue = value;
        var hasChanged = false;
        return this.fixCoursesByFieldParams(field, value, siteId).then(function (result) {
            hasChanged = result.field != field || result.value != value;
            field = result.field;
            value = result.value;
            return _this.sitesProvider.getSite(siteId);
        }).then(function (site) {
            var data = {
                field: field || '',
                value: field ? value : ''
            }, preSets = {
                cacheKey: _this.getCoursesByFieldCacheKey(field, value),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_course_get_courses_by_field', data, preSets).then(function (courses) {
                if (courses.courses) {
                    if (field == 'ids' && hasChanged) {
                        // The list of courses requestes was changed to optimize it.
                        // Return only the ones that were being requested.
                        var courseIds_1 = String(originalValue).split(','), finalCourses_1 = [];
                        courses.courses.forEach(function (course) {
                            var position = courseIds_1.indexOf(String(course.id));
                            if (position != -1) {
                                // Course is in the original list, take it.
                                finalCourses_1.push(course);
                                courseIds_1.splice(position, 1);
                            }
                        });
                        courses.courses = finalCourses_1;
                    }
                    // Courses will be sorted using sortorder if avalaible.
                    return courses.courses.sort(function (a, b) {
                        if (typeof a.sortorder == 'undefined' && typeof b.sortorder == 'undefined') {
                            return b.id - a.id;
                        }
                        if (typeof a.sortorder == 'undefined') {
                            return 1;
                        }
                        if (typeof b.sortorder == 'undefined') {
                            return -1;
                        }
                        return a.sortorder - b.sortorder;
                    });
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get courses WS call.
     *
     * @param {string} [field] The field to search.
     * @param {any} [value] The value to match.
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getCoursesByFieldCacheKey = function (field, value) {
        field = field || '';
        value = field ? value : '';
        return this.ROOT_CACHE_KEY + 'coursesbyfield:' + field + ':' + value;
    };
    /**
     * Check if get courses by field WS is available in a certain site.
     *
     * @param {CoreSite} [site] Site to check.
     * @return {boolean} Whether get courses by field is available.
     * @since 3.2
     */
    CoreCoursesProvider.prototype.isGetCoursesByFieldAvailable = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.wsAvailable('core_course_get_courses_by_field');
    };
    /**
     * Check if get courses by field WS is available in a certain site, by site ID.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether get courses by field is available.
     * @since 3.2
     */
    CoreCoursesProvider.prototype.isGetCoursesByFieldAvailableInSite = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isGetCoursesByFieldAvailable(site);
        });
    };
    /**
     * Get the navigation and administration options for the given courses.
     *
     * @param {number[]} courseIds IDs of courses to get.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{navOptions: any, admOptions: any}>} Promise resolved with the options for each course.
     */
    CoreCoursesProvider.prototype.getCoursesAdminAndNavOptions = function (courseIds, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Get the list of courseIds to use based on the param.
        return this.getCourseIdsForAdminAndNavOptions(courseIds, siteId).then(function (courseIds) {
            var promises = [];
            var navOptions, admOptions;
            // Get user navigation and administration options.
            promises.push(_this.getUserNavigationOptions(courseIds, siteId).catch(function () {
                // Couldn't get it, return empty options.
                return {};
            }).then(function (options) {
                navOptions = options;
            }));
            promises.push(_this.getUserAdministrationOptions(courseIds, siteId).catch(function () {
                // Couldn't get it, return empty options.
                return {};
            }).then(function (options) {
                admOptions = options;
            }));
            return Promise.all(promises).then(function () {
                return { navOptions: navOptions, admOptions: admOptions };
            });
        });
    };
    /**
     * Get the common part of the cache keys for user administration options WS calls.
     *
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getUserAdministrationOptionsCommonCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'administrationOptions:';
    };
    /**
     * Get cache key for get user administration options WS call.
     *
     * @param {number[]} courseIds IDs of courses to get.
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getUserAdministrationOptionsCacheKey = function (courseIds) {
        return this.getUserAdministrationOptionsCommonCacheKey() + courseIds.join(',');
    };
    /**
     * Get user administration options for a set of courses.
     *
     * @param {number[]} courseIds IDs of courses to get.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with administration options for each course.
     */
    CoreCoursesProvider.prototype.getUserAdministrationOptions = function (courseIds, siteId) {
        var _this = this;
        if (!courseIds || courseIds.length == 0) {
            return Promise.resolve({});
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: courseIds
            }, preSets = {
                cacheKey: _this.getUserAdministrationOptionsCacheKey(courseIds),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_course_get_user_administration_options', params, preSets).then(function (response) {
                // Format returned data.
                return _this.formatUserAdminOrNavOptions(response.courses);
            });
        });
    };
    /**
     * Get the common part of the cache keys for user navigation options WS calls.
     *
     * @param {number[]} courseIds IDs of courses to get.
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getUserNavigationOptionsCommonCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'navigationOptions:';
    };
    /**
     * Get cache key for get user navigation options WS call.
     *
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getUserNavigationOptionsCacheKey = function (courseIds) {
        return this.getUserNavigationOptionsCommonCacheKey() + courseIds.join(',');
    };
    /**
     * Get user navigation options for a set of courses.
     *
     * @param {number[]} courseIds IDs of courses to get.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with navigation options for each course.
     */
    CoreCoursesProvider.prototype.getUserNavigationOptions = function (courseIds, siteId) {
        var _this = this;
        if (!courseIds || courseIds.length == 0) {
            return Promise.resolve({});
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: courseIds
            }, preSets = {
                cacheKey: _this.getUserNavigationOptionsCacheKey(courseIds),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_course_get_user_navigation_options', params, preSets).then(function (response) {
                // Format returned data.
                return _this.formatUserAdminOrNavOptions(response.courses);
            });
        });
    };
    /**
     * Format user navigation or administration options.
     *
     * @param {any[]} courses Navigation or administration options for each course.
     * @return {any} Formatted options.
     */
    CoreCoursesProvider.prototype.formatUserAdminOrNavOptions = function (courses) {
        var result = {};
        courses.forEach(function (course) {
            var options = {};
            if (course.options) {
                course.options.forEach(function (option) {
                    options[option.name] = option.available;
                });
            }
            result[course.id] = options;
        });
        return result;
    };
    /**
     * Get a course the user is enrolled in. This function relies on getUserCourses.
     * preferCache=true will try to speed up the response, but the data returned might not be updated.
     *
     * @param {number} id ID of the course to get.
     * @param {boolean} [preferCache] True if shouldn't call WS if data is cached, false otherwise.
     * @param {string} [siteId] Site to get the courses from. If not defined, use current site.
     * @return {Promise<any>} Promise resolved with the course.
     */
    CoreCoursesProvider.prototype.getUserCourse = function (id, preferCache, siteId) {
        if (!id) {
            return Promise.reject(null);
        }
        return this.getUserCourses(preferCache, siteId).then(function (courses) {
            var course;
            for (var i in courses) {
                if (courses[i].id == id) {
                    course = courses[i];
                    break;
                }
            }
            return course ? course : Promise.reject(null);
        });
    };
    /**
     * Get user courses.
     *
     * @param {boolean} [preferCache] True if shouldn't call WS if data is cached, false otherwise.
     * @param {string} [siteId] Site to get the courses from. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved with the courses.
     */
    CoreCoursesProvider.prototype.getUserCourses = function (preferCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var userId = site.getUserId(), data = {
                userid: userId
            }, preSets = {
                cacheKey: _this.getUserCoursesCacheKey(),
                getCacheUsingCacheKey: true,
                omitExpires: !!preferCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (site.isVersionGreaterEqualThan('3.7')) {
                data.returnusercount = 0;
            }
            return site.read('core_enrol_get_users_courses', data, preSets);
        });
    };
    /**
     * Get cache key for get user courses WS call.
     *
     * @return {string} Cache key.
     */
    CoreCoursesProvider.prototype.getUserCoursesCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'usercourses';
    };
    /**
     * Invalidates get categories WS call.
     *
     * @param {number} categoryId Category ID to get.
     * @param {boolean} [addSubcategories] If it should add subcategories to the list.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateCategories = function (categoryId, addSubcategories, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCategoriesCacheKey(categoryId, addSubcategories));
        });
    };
    /**
     * Invalidates get course WS call.
     *
     * @param {number} id Course ID.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateCourse = function (id, siteId) {
        return this.invalidateCourses([id], siteId);
    };
    /**
     * Invalidates get course enrolment methods WS call.
     *
     * @param {number} id Course ID.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateCourseEnrolmentMethods = function (id, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCourseEnrolmentMethodsCacheKey(id));
        });
    };
    /**
     * Invalidates get course guest enrolment info WS call.
     *
     * @param {number} instanceId Guest instance ID.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateCourseGuestEnrolmentInfo = function (instanceId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCourseGuestEnrolmentInfoCacheKey(instanceId));
        });
    };
    /**
     * Invalidates the navigation and administration options for the given courses.
     *
     * @param {number[]} courseIds IDs of courses to get.
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateCoursesAdminAndNavOptions = function (courseIds, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getCourseIdsForAdminAndNavOptions(courseIds, siteId).then(function (ids) {
            var promises = [];
            promises.push(_this.invalidateUserAdministrationOptionsForCourses(ids, siteId));
            promises.push(_this.invalidateUserNavigationOptionsForCourses(ids, siteId));
            return Promise.all(promises);
        });
    };
    /**
     * Invalidates get courses WS call.
     *
     * @param {number[]} ids Courses IDs.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateCourses = function (ids, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCoursesCacheKey(ids));
        });
    };
    /**
     * Invalidates get courses by field WS call.
     *
     * @param {string} [field] See getCoursesByField for info.
     * @param {any} [value] The value to match.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateCoursesByField = function (field, value, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.fixCoursesByFieldParams(field, value, siteId).then(function (result) {
            field = result.field;
            value = result.value;
            return _this.sitesProvider.getSite(siteId);
        }).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCoursesByFieldCacheKey(field, value));
        });
    };
    /**
     * Invalidates all user administration options.
     *
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateUserAdministrationOptions = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getUserAdministrationOptionsCommonCacheKey());
        });
    };
    /**
     * Invalidates user administration options for certain courses.
     *
     * @param {number[]} courseIds IDs of courses.
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateUserAdministrationOptionsForCourses = function (courseIds, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUserAdministrationOptionsCacheKey(courseIds));
        });
    };
    /**
     * Invalidates get user courses WS call.
     *
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateUserCourses = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUserCoursesCacheKey());
        });
    };
    /**
     * Invalidates all user navigation options.
     *
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateUserNavigationOptions = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getUserNavigationOptionsCommonCacheKey());
        });
    };
    /**
     * Invalidates user navigation options for certain courses.
     *
     * @param {number[]} courseIds IDs of courses.
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesProvider.prototype.invalidateUserNavigationOptionsForCourses = function (courseIds, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUserNavigationOptionsCacheKey(courseIds));
        });
    };
    /**
     * Check if WS to retrieve guest enrolment data is available.
     *
     * @return {boolean} Whether guest WS is available.
     */
    CoreCoursesProvider.prototype.isGuestWSAvailable = function () {
        var currentSite = this.sitesProvider.getCurrentSite();
        return currentSite && currentSite.wsAvailable('enrol_guest_get_instance_info');
    };
    /**
     * Search courses.
     *
     * @param {string} text Text to search.
     * @param {number} [page=0] Page to get.
     * @param {number} [perPage] Number of courses per page. Defaults to CoreCoursesProvider.SEARCH_PER_PAGE.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{total: number, courses: any[]}>} Promise resolved with the courses and the total of matches.
     */
    CoreCoursesProvider.prototype.search = function (text, page, perPage, siteId) {
        if (page === void 0) { page = 0; }
        perPage = perPage || CoreCoursesProvider_1.SEARCH_PER_PAGE;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                criterianame: 'search',
                criteriavalue: text,
                page: page,
                perpage: perPage
            }, preSets = {
                getFromCache: false
            };
            return site.read('core_course_search_courses', params, preSets).then(function (response) {
                return { total: response.total, courses: response.courses };
            });
        });
    };
    /**
     * Self enrol current user in a certain course.
     *
     * @param {number} courseId Course ID.
     * @param {string} [password] Password to use.
     * @param {number} [instanceId] Enrol instance ID.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved if the user is enrolled. If the password is invalid, the promise is rejected
     *                        with an object with code = CoreCoursesProvider.ENROL_INVALID_KEY.
     */
    CoreCoursesProvider.prototype.selfEnrol = function (courseId, password, instanceId, siteId) {
        if (password === void 0) { password = ''; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseid: courseId,
                password: password
            };
            if (instanceId) {
                params.instanceid = instanceId;
            }
            return site.write('enrol_self_enrol_user', params).then(function (response) {
                if (response) {
                    if (response.status) {
                        return true;
                    }
                    else if (response.warnings && response.warnings.length) {
                        var message_1;
                        response.warnings.forEach(function (warning) {
                            // Invalid password warnings.
                            if (warning.warningcode == '2' || warning.warningcode == '3' || warning.warningcode == '4') {
                                message_1 = warning.message;
                            }
                        });
                        if (message_1) {
                            return Promise.reject({ code: CoreCoursesProvider_1.ENROL_INVALID_KEY, message: message_1 });
                        }
                        else {
                            return Promise.reject(response.warnings[0]);
                        }
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Set favourite property on a course.
     *
     * @param {number} courseId   Course ID.
     * @param {boolean} favourite If favourite or unfavourite.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCoursesProvider.prototype.setFavouriteCourse = function (courseId, favourite, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courses: [
                    {
                        id: courseId,
                        favourite: favourite ? 1 : 0
                    }
                ]
            };
            return site.write('core_course_set_favourite_courses', params);
        });
    };
    CoreCoursesProvider.SEARCH_PER_PAGE = 20;
    CoreCoursesProvider.ENROL_INVALID_KEY = 'CoreCoursesEnrolInvalidKey';
    CoreCoursesProvider.EVENT_MY_COURSES_UPDATED = 'courses_my_courses_updated';
    CoreCoursesProvider.EVENT_MY_COURSES_REFRESHED = 'courses_my_courses_refreshed';
    CoreCoursesProvider.EVENT_DASHBOARD_DOWNLOAD_ENABLED_CHANGED = 'dashboard_download_enabled_changed';
    CoreCoursesProvider = CoreCoursesProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreCoursesProvider);
    return CoreCoursesProvider;
    var CoreCoursesProvider_1;
}());

//# sourceMappingURL=courses.js.map

/***/ }),
/* 33 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_file__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_zip__ = __webpack_require__(342);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Factory to interact with the file system.
 */
var CoreFileProvider = /** @class */ (function () {
    function CoreFileProvider(logger, platform, file, appProvider, textUtils, zip, mimeUtils) {
        this.platform = platform;
        this.file = file;
        this.appProvider = appProvider;
        this.textUtils = textUtils;
        this.zip = zip;
        this.mimeUtils = mimeUtils;
        this.initialized = false;
        this.basePath = '';
        this.isHTMLAPI = false;
        this.CHUNK_SIZE = 10485760; // 10 MB.
        this.logger = logger.getInstance('CoreFileProvider');
        if (platform.is('android') && !Object.getOwnPropertyDescriptor(FileReader.prototype, 'onloadend')) {
            // Cordova File plugin creates some getters and setter for FileReader, but Ionic's polyfills override them in Android.
            // Create the getters and setters again. This code comes from FileReader.js in cordova-plugin-file.
            this.defineGetterSetter(FileReader.prototype, 'readyState', function () {
                return this._localURL ? this._readyState : this._realReader.readyState;
            });
            this.defineGetterSetter(FileReader.prototype, 'error', function () {
                return this._localURL ? this._error : this._realReader.error;
            });
            this.defineGetterSetter(FileReader.prototype, 'result', function () {
                return this._localURL ? this._result : this._realReader.result;
            });
            this.defineEvent('onloadstart');
            this.defineEvent('onprogress');
            this.defineEvent('onload');
            this.defineEvent('onerror');
            this.defineEvent('onloadend');
            this.defineEvent('onabort');
        }
    }
    CoreFileProvider_1 = CoreFileProvider;
    /**
     * Define an event for FileReader.
     *
     * @param {string} eventName Name of the event.
     */
    CoreFileProvider.prototype.defineEvent = function (eventName) {
        this.defineGetterSetter(FileReader.prototype, eventName, function () {
            return this._realReader[eventName] || null;
        }, function (value) {
            this._realReader[eventName] = value;
        });
    };
    /**
     * Define a getter and, optionally, a setter for a certain property in an object.
     *
     * @param {any} obj Object to set the getter/setter for.
     * @param {string} key Name of the property where to set them.
     * @param {Function} getFunc The getter function.
     * @param {Function} [setFunc] The setter function.
     */
    CoreFileProvider.prototype.defineGetterSetter = function (obj, key, getFunc, setFunc) {
        if (Object.defineProperty) {
            var desc = {
                get: getFunc,
                configurable: true
            };
            if (setFunc) {
                desc.set = setFunc;
            }
            Object.defineProperty(obj, key, desc);
        }
        else {
            obj.__defineGetter__(key, getFunc);
            if (setFunc) {
                obj.__defineSetter__(key, setFunc);
            }
        }
    };
    /**
     * Sets basePath to use with HTML API. Reserved for core use.
     *
     * @param {string} path Base path to use.
     */
    CoreFileProvider.prototype.setHTMLBasePath = function (path) {
        this.isHTMLAPI = true;
        this.basePath = path;
    };
    /**
     * Checks if we're using HTML API.
     *
     * @return {boolean} True if uses HTML API, false otherwise.
     */
    CoreFileProvider.prototype.usesHTMLAPI = function () {
        return this.isHTMLAPI;
    };
    /**
     * Initialize basePath based on the OS if it's not initialized already.
     *
     * @return {Promise<void>} Promise to be resolved when the initialization is finished.
     */
    CoreFileProvider.prototype.init = function () {
        var _this = this;
        if (this.initialized) {
            return Promise.resolve();
        }
        return this.platform.ready().then(function () {
            if (_this.platform.is('android')) {
                _this.basePath = _this.file.externalApplicationStorageDirectory || _this.basePath;
            }
            else if (_this.platform.is('ios')) {
                _this.basePath = _this.file.documentsDirectory || _this.basePath;
            }
            else if (!_this.isAvailable() || _this.basePath === '') {
                _this.logger.error('Error getting device OS.');
                return Promise.reject(null);
            }
            _this.initialized = true;
            _this.logger.debug('FS initialized: ' + _this.basePath);
        });
    };
    /**
     * Check if the plugin is available.
     *
     * @return {boolean} Whether the plugin is available.
     */
    CoreFileProvider.prototype.isAvailable = function () {
        return typeof window.resolveLocalFileSystemURL !== 'undefined';
    };
    /**
     * Get a file.
     *
     * @param {string} path Relative path to the file.
     * @return {Promise<FileEntry>} Promise resolved when the file is retrieved.
     */
    CoreFileProvider.prototype.getFile = function (path) {
        var _this = this;
        return this.init().then(function () {
            _this.logger.debug('Get file: ' + path);
            return _this.file.resolveLocalFilesystemUrl(_this.addBasePathIfNeeded(path));
        }).then(function (entry) {
            return entry;
        });
    };
    /**
     * Get a directory.
     *
     * @param {string} path Relative path to the directory.
     * @return {Promise<DirectoryEntry>} Promise resolved when the directory is retrieved.
     */
    CoreFileProvider.prototype.getDir = function (path) {
        var _this = this;
        return this.init().then(function () {
            _this.logger.debug('Get directory: ' + path);
            return _this.file.resolveDirectoryUrl(_this.addBasePathIfNeeded(path));
        });
    };
    /**
     * Get site folder path.
     *
     * @param {string} siteId Site ID.
     * @return {string} Site folder path.
     */
    CoreFileProvider.prototype.getSiteFolder = function (siteId) {
        return CoreFileProvider_1.SITESFOLDER + '/' + siteId;
    };
    /**
     * Create a directory or a file.
     *
     * @param {boolean} isDirectory True if a directory should be created, false if it should create a file.
     * @param {string} path Relative path to the dir/file.
     * @param {boolean} [failIfExists] True if it should fail if the dir/file exists, false otherwise.
     * @param {string} [base] Base path to create the dir/file in. If not set, use basePath.
     * @return {Promise<any>} Promise to be resolved when the dir/file is created.
     */
    CoreFileProvider.prototype.create = function (isDirectory, path, failIfExists, base) {
        var _this = this;
        return this.init().then(function () {
            // Remove basePath if it's in the path.
            path = _this.removeStartingSlash(path.replace(_this.basePath, ''));
            base = base || _this.basePath;
            if (path.indexOf('/') == -1) {
                if (isDirectory) {
                    _this.logger.debug('Create dir ' + path + ' in ' + base);
                    return _this.file.createDir(base, path, !failIfExists);
                }
                else {
                    _this.logger.debug('Create file ' + path + ' in ' + base);
                    return _this.file.createFile(base, path, !failIfExists);
                }
            }
            else {
                // The file plugin doesn't allow creating more than 1 level at a time (e.g. tmp/folder).
                // We need to create them 1 by 1.
                var firstDir_1 = path.substr(0, path.indexOf('/')), restOfPath_1 = path.substr(path.indexOf('/') + 1);
                _this.logger.debug('Create dir ' + firstDir_1 + ' in ' + base);
                return _this.file.createDir(base, firstDir_1, true).then(function (newDirEntry) {
                    return _this.create(isDirectory, restOfPath_1, failIfExists, newDirEntry.toURL());
                }).catch(function (error) {
                    _this.logger.error('Error creating directory ' + firstDir_1 + ' in ' + base);
                    return Promise.reject(error);
                });
            }
        });
    };
    /**
     * Create a directory.
     *
     * @param {string} path Relative path to the directory.
     * @param {boolean} [failIfExists] True if it should fail if the directory exists, false otherwise.
     * @return {Promise<DirectoryEntry>} Promise to be resolved when the directory is created.
     */
    CoreFileProvider.prototype.createDir = function (path, failIfExists) {
        return this.create(true, path, failIfExists);
    };
    /**
     * Create a file.
     *
     * @param {string} path Relative path to the file.
     * @param {boolean} [failIfExists] True if it should fail if the file exists, false otherwise..
     * @return {Promise<FileEntry>} Promise to be resolved when the file is created.
     */
    CoreFileProvider.prototype.createFile = function (path, failIfExists) {
        return this.create(false, path, failIfExists);
    };
    /**
     * Removes a directory and all its contents.
     *
     * @param {string} path Relative path to the directory.
     * @return {Promise<any>} Promise to be resolved when the directory is deleted.
     */
    CoreFileProvider.prototype.removeDir = function (path) {
        var _this = this;
        return this.init().then(function () {
            // Remove basePath if it's in the path.
            path = _this.removeStartingSlash(path.replace(_this.basePath, ''));
            _this.logger.debug('Remove directory: ' + path);
            return _this.file.removeRecursively(_this.basePath, path);
        });
    };
    /**
     * Removes a file and all its contents.
     *
     * @param {string} path Relative path to the file.
     * @return {Promise<any>} Promise to be resolved when the file is deleted.
     */
    CoreFileProvider.prototype.removeFile = function (path) {
        var _this = this;
        return this.init().then(function () {
            // Remove basePath if it's in the path.
            path = _this.removeStartingSlash(path.replace(_this.basePath, ''));
            _this.logger.debug('Remove file: ' + path);
            return _this.file.removeFile(_this.basePath, path).catch(function (error) {
                // The delete can fail if the path has encoded characters. Try again if that's the case.
                var decodedPath = decodeURI(path);
                if (decodedPath != path) {
                    return _this.file.removeFile(_this.basePath, decodedPath);
                }
                else {
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Removes a file given its FileEntry.
     *
     * @param {FileEntry} fileEntry File Entry.
     * @return {Promise<any>} Promise resolved when the file is deleted.
     */
    CoreFileProvider.prototype.removeFileByFileEntry = function (fileEntry) {
        return new Promise(function (resolve, reject) {
            fileEntry.remove(resolve, reject);
        });
    };
    /**
     * Retrieve the contents of a directory (not subdirectories).
     *
     * @param {string} path Relative path to the directory.
     * @return {Promise<any>} Promise to be resolved when the contents are retrieved.
     */
    CoreFileProvider.prototype.getDirectoryContents = function (path) {
        var _this = this;
        return this.init().then(function () {
            // Remove basePath if it's in the path.
            path = _this.removeStartingSlash(path.replace(_this.basePath, ''));
            _this.logger.debug('Get contents of dir: ' + path);
            return _this.file.listDir(_this.basePath, path);
        });
    };
    /**
     * Calculate the size of a directory or a file.
     *
     * @param {any} entry Directory or file.
     * @return {Promise<number>} Promise to be resolved when the size is calculated.
     */
    CoreFileProvider.prototype.getSize = function (entry) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (entry.isDirectory) {
                var directoryReader = entry.createReader();
                directoryReader.readEntries(function (entries) {
                    var promises = [];
                    for (var i = 0; i < entries.length; i++) {
                        promises.push(_this.getSize(entries[i]));
                    }
                    Promise.all(promises).then(function (sizes) {
                        var directorySize = 0;
                        for (var i = 0; i < sizes.length; i++) {
                            var fileSize = parseInt(sizes[i]);
                            if (isNaN(fileSize)) {
                                reject();
                                return;
                            }
                            directorySize += fileSize;
                        }
                        resolve(directorySize);
                    }, reject);
                }, reject);
            }
            else if (entry.isFile) {
                entry.file(function (file) {
                    resolve(file.size);
                }, reject);
            }
        });
    };
    /**
     * Calculate the size of a directory.
     *
     * @param {string} path Relative path to the directory.
     * @return {Promise<number>} Promise to be resolved when the size is calculated.
     */
    CoreFileProvider.prototype.getDirectorySize = function (path) {
        var _this = this;
        // Remove basePath if it's in the path.
        path = this.removeStartingSlash(path.replace(this.basePath, ''));
        this.logger.debug('Get size of dir: ' + path);
        return this.getDir(path).then(function (dirEntry) {
            return _this.getSize(dirEntry);
        });
    };
    /**
     * Calculate the size of a file.
     *
     * @param {string} path Relative path to the file.
     * @return {Promise<number>} Promise to be resolved when the size is calculated.
     */
    CoreFileProvider.prototype.getFileSize = function (path) {
        var _this = this;
        // Remove basePath if it's in the path.
        path = this.removeStartingSlash(path.replace(this.basePath, ''));
        this.logger.debug('Get size of file: ' + path);
        return this.getFile(path).then(function (fileEntry) {
            return _this.getSize(fileEntry);
        });
    };
    /**
     * Get file object from a FileEntry.
     *
     * @param {FileEntry} path Relative path to the file.
     * @return {Promise<any>} Promise to be resolved when the file is retrieved.
     */
    CoreFileProvider.prototype.getFileObjectFromFileEntry = function (entry) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.logger.debug('Get file object of: ' + entry.fullPath);
            entry.file(resolve, reject);
        });
    };
    /**
     * Calculate the free space in the disk.
     * Please notice that this function isn't reliable and it's not documented in the Cordova File plugin.
     *
     * @return {Promise<number>} Promise resolved with the estimated free space in bytes.
     */
    CoreFileProvider.prototype.calculateFreeSpace = function () {
        var _this = this;
        return this.file.getFreeDiskSpace().then(function (size) {
            if (_this.platform.is('ios')) {
                // In iOS the size is in bytes.
                return Number(size);
            }
            // The size is in KB, convert it to bytes.
            return Number(size) * 1024;
        });
    };
    /**
     * Normalize a filename that usually comes URL encoded.
     *
     * @param {string} filename The file name.
     * @return {string} The file name normalized.
     */
    CoreFileProvider.prototype.normalizeFileName = function (filename) {
        filename = this.textUtils.decodeURIComponent(filename);
        return filename;
    };
    /**
     * Read a file from local file system.
     *
     * @param {string} path Relative path to the file.
     * @param {number} [format=FORMATTEXT] Format to read the file. Must be one of:
     *                                  FORMATTEXT
     *                                  FORMATDATAURL
     *                                  FORMATBINARYSTRING
     *                                  FORMATARRAYBUFFER
     * @return {Promise<any>} Promise to be resolved when the file is read.
     */
    CoreFileProvider.prototype.readFile = function (path, format) {
        if (format === void 0) { format = CoreFileProvider_1.FORMATTEXT; }
        // Remove basePath if it's in the path.
        path = this.removeStartingSlash(path.replace(this.basePath, ''));
        this.logger.debug('Read file ' + path + ' with format ' + format);
        switch (format) {
            case CoreFileProvider_1.FORMATDATAURL:
                return this.file.readAsDataURL(this.basePath, path);
            case CoreFileProvider_1.FORMATBINARYSTRING:
                return this.file.readAsBinaryString(this.basePath, path);
            case CoreFileProvider_1.FORMATARRAYBUFFER:
                return this.file.readAsArrayBuffer(this.basePath, path);
            default:
                return this.file.readAsText(this.basePath, path);
        }
    };
    /**
     * Read file contents from a file data object.
     *
     * @param {any} fileData File's data.
     * @param {number} [format=FORMATTEXT] Format to read the file. Must be one of:
     *                                  FORMATTEXT
     *                                  FORMATDATAURL
     *                                  FORMATBINARYSTRING
     *                                  FORMATARRAYBUFFER
     * @return {Promise<any>} Promise to be resolved when the file is read.
     */
    CoreFileProvider.prototype.readFileData = function (fileData, format) {
        if (format === void 0) { format = CoreFileProvider_1.FORMATTEXT; }
        format = format || CoreFileProvider_1.FORMATTEXT;
        this.logger.debug('Read file from file data with format ' + format);
        return new Promise(function (resolve, reject) {
            var reader = new FileReader();
            reader.onloadend = function (evt) {
                var target = evt.target; // Convert to <any> to be able to use non-standard properties.
                if (target.result !== undefined || target.result !== null) {
                    resolve(target.result);
                }
                else if (target.error !== undefined || target.error !== null) {
                    reject(target.error);
                }
                else {
                    reject({ code: null, message: 'READER_ONLOADEND_ERR' });
                }
            };
            // Check if the load starts. If it doesn't start in 3 seconds, reject.
            // Sometimes in Android the read doesn't start for some reason, so the promise never finishes.
            var hasStarted = false;
            reader.onloadstart = function (evt) {
                hasStarted = true;
            };
            setTimeout(function () {
                if (!hasStarted) {
                    reject('Upload cannot start.');
                }
            }, 3000);
            switch (format) {
                case CoreFileProvider_1.FORMATDATAURL:
                    reader.readAsDataURL(fileData);
                    break;
                case CoreFileProvider_1.FORMATBINARYSTRING:
                    reader.readAsBinaryString(fileData);
                    break;
                case CoreFileProvider_1.FORMATARRAYBUFFER:
                    reader.readAsArrayBuffer(fileData);
                    break;
                default:
                    reader.readAsText(fileData);
            }
        });
    };
    /**
     * Writes some data in a file.
     *
     * @param {string} path Relative path to the file.
     * @param {any} data Data to write.
     * @param {boolean} [append] Whether to append the data to the end of the file.
     * @return {Promise<any>} Promise to be resolved when the file is written.
     */
    CoreFileProvider.prototype.writeFile = function (path, data, append) {
        var _this = this;
        return this.init().then(function () {
            // Remove basePath if it's in the path.
            path = _this.removeStartingSlash(path.replace(_this.basePath, ''));
            _this.logger.debug('Write file: ' + path);
            // Create file (and parent folders) to prevent errors.
            return _this.createFile(path).then(function (fileEntry) {
                if (_this.isHTMLAPI && !_this.appProvider.isDesktop() &&
                    (typeof data == 'string' || data.toString() == '[object ArrayBuffer]')) {
                    // We need to write Blobs.
                    var type = _this.mimeUtils.getMimeType(_this.mimeUtils.getFileExtension(path));
                    data = new Blob([data], { type: type || 'text/plain' });
                }
                return _this.file.writeFile(_this.basePath, path, data, { replace: !append, append: !!append }).then(function () {
                    return fileEntry;
                });
            });
        });
    };
    /**
     * Write some file data into a filesystem file.
     * It's done in chunks to prevent crashing the app for big files.
     *
     * @param {any} file The data to write.
     * @param {string} path Path where to store the data.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {number} [offset=0] Offset where to start reading from.
     * @param {boolean} [append] Whether to append the data to the end of the file.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileProvider.prototype.writeFileDataInFile = function (file, path, onProgress, offset, append) {
        var _this = this;
        if (offset === void 0) { offset = 0; }
        offset = offset || 0;
        // Get the chunk to read.
        var blob = file.slice(offset, Math.min(offset + this.CHUNK_SIZE, file.size));
        return this.writeFileDataInFileChunk(blob, path, append).then(function (fileEntry) {
            offset += _this.CHUNK_SIZE;
            onProgress && onProgress({
                lengthComputable: true,
                loaded: offset,
                total: file.size
            });
            if (offset >= file.size) {
                // Done, stop.
                return fileEntry;
            }
            // Read the next chunk.
            return _this.writeFileDataInFile(file, path, onProgress, offset, true);
        });
    };
    /**
     * Write a chunk of data into a file.
     *
     * @param {any} chunkData The chunk of data.
     * @param {string} path Path where to store the data.
     * @param {boolean} [append] Whether to append the data to the end of the file.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileProvider.prototype.writeFileDataInFileChunk = function (chunkData, path, append) {
        var _this = this;
        // Read the chunk data.
        return this.readFileData(chunkData, CoreFileProvider_1.FORMATARRAYBUFFER).then(function (fileData) {
            // Write the data in the file.
            return _this.writeFile(path, fileData, append);
        });
    };
    /**
     * Gets a file that might be outside the app's folder.
     *
     * @param {string} fullPath Absolute path to the file.
     * @return {Promise<FileEntry>} Promise to be resolved when the file is retrieved.
     */
    CoreFileProvider.prototype.getExternalFile = function (fullPath) {
        return this.file.resolveLocalFilesystemUrl(fullPath).then(function (entry) {
            return entry;
        });
    };
    /**
     * Removes a file that might be outside the app's folder.
     *
     * @param {string} fullPath Absolute path to the file.
     * @return {Promise<any>} Promise to be resolved when the file is removed.
     */
    CoreFileProvider.prototype.removeExternalFile = function (fullPath) {
        var directory = fullPath.substring(0, fullPath.lastIndexOf('/')), filename = fullPath.substr(fullPath.lastIndexOf('/') + 1);
        return this.file.removeFile(directory, filename);
    };
    /**
     * Get the base path where the application files are stored.
     *
     * @return {Promise<string>} Promise to be resolved when the base path is retrieved.
     */
    CoreFileProvider.prototype.getBasePath = function () {
        var _this = this;
        return this.init().then(function () {
            if (_this.basePath.slice(-1) == '/') {
                return _this.basePath;
            }
            else {
                return _this.basePath + '/';
            }
        });
    };
    /**
     * Get the base path where the application files are stored in the format to be used for downloads.
     * iOS: Internal URL (cdvfile://).
     * Others: basePath (file://)
     *
     * @return {Promise<string>} Promise to be resolved when the base path is retrieved.
     */
    CoreFileProvider.prototype.getBasePathToDownload = function () {
        var _this = this;
        return this.init().then(function () {
            if (_this.platform.is('ios')) {
                // In iOS we want the internal URL (cdvfile://localhost/persistent/...).
                return _this.file.resolveDirectoryUrl(_this.basePath).then(function (dirEntry) {
                    return dirEntry.toInternalURL();
                });
            }
            else {
                // In the other platforms we use the basePath as it is (file://...).
                return _this.basePath;
            }
        });
    };
    /**
     * Get the base path where the application files are stored. Returns the value instantly, without waiting for it to be ready.
     *
     * @return {string} Base path. If the service hasn't been initialized it will return an invalid value.
     */
    CoreFileProvider.prototype.getBasePathInstant = function () {
        if (!this.basePath) {
            return this.basePath;
        }
        else if (this.basePath.slice(-1) == '/') {
            return this.basePath;
        }
        else {
            return this.basePath + '/';
        }
    };
    /**
     * Move a file.
     *
     * @param {string} [originalPath] Path to the file to move.
     * @param {string} [newPath] New path of the file.
     * @return {Promise<any>} Promise resolved when the entry is moved.
     */
    CoreFileProvider.prototype.moveFile = function (originalPath, newPath) {
        var _this = this;
        return this.init().then(function () {
            // Remove basePath if it's in the paths.
            originalPath = _this.removeStartingSlash(originalPath.replace(_this.basePath, ''));
            newPath = _this.removeStartingSlash(newPath.replace(_this.basePath, ''));
            if (_this.isHTMLAPI) {
                // In Cordova API we need to calculate the longest matching path to make it work.
                // The function this.file.moveFile('a/', 'b/c.ext', 'a/', 'b/d.ext') doesn't work.
                // The function this.file.moveFile('a/b/', 'c.ext', 'a/b/', 'd.ext') works.
                var dirsA = originalPath.split('/'), dirsB = newPath.split('/');
                var commonPath = _this.basePath;
                for (var i = 0; i < dirsA.length; i++) {
                    var dir = dirsA[i];
                    if (dirsB[i] === dir) {
                        // Found a common folder, add it to common path and remove it from each specific path.
                        dir = dir + '/';
                        commonPath = _this.textUtils.concatenatePaths(commonPath, dir);
                        originalPath = originalPath.replace(dir, '');
                        newPath = newPath.replace(dir, '');
                    }
                    else {
                        // Folder doesn't match, stop searching.
                        break;
                    }
                }
                return _this.file.moveFile(commonPath, originalPath, commonPath, newPath);
            }
            else {
                return _this.file.moveFile(_this.basePath, originalPath, _this.basePath, newPath).catch(function (error) {
                    // The move can fail if the path has encoded characters. Try again if that's the case.
                    var decodedOriginal = decodeURI(originalPath), decodedNew = decodeURI(newPath);
                    if (decodedOriginal != originalPath || decodedNew != newPath) {
                        return _this.file.moveFile(_this.basePath, decodedOriginal, _this.basePath, decodedNew);
                    }
                    else {
                        return Promise.reject(error);
                    }
                });
            }
        });
    };
    /**
     * Copy a file.
     *
     * @param {string} from Path to the file to move.
     * @param {string} to New path of the file.
     * @return {Promise<any>} Promise resolved when the entry is copied.
     */
    CoreFileProvider.prototype.copyFile = function (from, to) {
        var _this = this;
        var fromFileAndDir, toFileAndDir;
        return this.init().then(function () {
            // Paths cannot start with "/". Remove basePath if present.
            from = _this.removeStartingSlash(from.replace(_this.basePath, ''));
            to = _this.removeStartingSlash(to.replace(_this.basePath, ''));
            fromFileAndDir = _this.getFileAndDirectoryFromPath(from);
            toFileAndDir = _this.getFileAndDirectoryFromPath(to);
            if (toFileAndDir.directory) {
                // Create the target directory if it doesn't exist.
                return _this.createDir(toFileAndDir.directory);
            }
        }).then(function () {
            if (_this.isHTMLAPI) {
                // In HTML API, the file name cannot include a directory, otherwise it fails.
                var fromDir = _this.textUtils.concatenatePaths(_this.basePath, fromFileAndDir.directory), toDir = _this.textUtils.concatenatePaths(_this.basePath, toFileAndDir.directory);
                return _this.file.copyFile(fromDir, fromFileAndDir.name, toDir, toFileAndDir.name);
            }
            else {
                return _this.file.copyFile(_this.basePath, from, _this.basePath, to).catch(function (error) {
                    // The copy can fail if the path has encoded characters. Try again if that's the case.
                    var decodedFrom = decodeURI(from), decodedTo = decodeURI(to);
                    if (from != decodedFrom || to != decodedTo) {
                        return _this.file.copyFile(_this.basePath, decodedFrom, _this.basePath, decodedTo);
                    }
                    else {
                        return Promise.reject(error);
                    }
                });
            }
        });
    };
    /**
     * Extract the file name and directory from a given path.
     *
     * @param {string} path Path to be extracted.
     * @return {any} Plain object containing the file name and directory.
     * @description
     * file.pdf         -> directory: '', name: 'file.pdf'
     * /file.pdf        -> directory: '', name: 'file.pdf'
     * path/file.pdf    -> directory: 'path', name: 'file.pdf'
     * path/            -> directory: 'path', name: ''
     * path             -> directory: '', name: 'path'
     */
    CoreFileProvider.prototype.getFileAndDirectoryFromPath = function (path) {
        var file = {
            directory: '',
            name: ''
        };
        file.directory = path.substring(0, path.lastIndexOf('/'));
        file.name = path.substr(path.lastIndexOf('/') + 1);
        return file;
    };
    /**
     * Get the internal URL of a file.
     *
     * @param {FileEntry} fileEntry File Entry.
     * @return {string} Internal URL.
     */
    CoreFileProvider.prototype.getInternalURL = function (fileEntry) {
        if (!fileEntry.toInternalURL) {
            // File doesn't implement toInternalURL, use toURL.
            return fileEntry.toURL();
        }
        return fileEntry.toInternalURL();
    };
    /**
     * Adds the basePath to a path if it doesn't have it already.
     *
     * @param {string} path Path to treat.
     * @return {string} Path with basePath added.
     */
    CoreFileProvider.prototype.addBasePathIfNeeded = function (path) {
        if (path.indexOf(this.basePath) > -1) {
            return path;
        }
        else {
            return this.textUtils.concatenatePaths(this.basePath, path);
        }
    };
    /**
     * Remove the base path from a path. If basePath isn't found, return false.
     *
     * @param {string} path Path to treat.
     * @return {string} Path without basePath if basePath was found, undefined otherwise.
     */
    CoreFileProvider.prototype.removeBasePath = function (path) {
        if (path.indexOf(this.basePath) > -1) {
            return path.replace(this.basePath, '');
        }
    };
    /**
     * Unzips a file.
     *
     * @param {string} path Path to the ZIP file.
     * @param {string} [destFolder] Path to the destination folder. If not defined, a new folder will be created with the
     *                     same location and name as the ZIP file (without extension).
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved when the file is unzipped.
     */
    CoreFileProvider.prototype.unzipFile = function (path, destFolder, onProgress) {
        var _this = this;
        // Get the source file.
        return this.getFile(path).then(function (fileEntry) {
            // If destFolder is not set, use same location as ZIP file. We need to use absolute paths (including basePath).
            destFolder = _this.addBasePathIfNeeded(destFolder || _this.mimeUtils.removeExtension(path));
            return _this.zip.unzip(fileEntry.toURL(), destFolder, onProgress);
        }).then(function (result) {
            if (result == -1) {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Search a string or regexp in a file contents and replace it. The result is saved in the same file.
     *
     * @param {string} path Path to the file.
     * @param {string|RegExp} search Value to search.
     * @param {string} newValue New value.
     * @return {Promise<any>} Promise resolved in success.
     */
    CoreFileProvider.prototype.replaceInFile = function (path, search, newValue) {
        var _this = this;
        return this.readFile(path).then(function (content) {
            if (typeof content == 'undefined' || content === null || !content.replace) {
                return Promise.reject(null);
            }
            if (content.match(search)) {
                content = content.replace(search, newValue);
                return _this.writeFile(path, content);
            }
        });
    };
    /**
     * Get a file/dir metadata given the file's entry.
     *
     * @param {Entry} fileEntry FileEntry retrieved from getFile or similar.
     * @return {Promise<any>} Promise resolved with metadata.
     */
    CoreFileProvider.prototype.getMetadata = function (fileEntry) {
        if (!fileEntry || !fileEntry.getMetadata) {
            return Promise.reject(null);
        }
        return new Promise(function (resolve, reject) {
            fileEntry.getMetadata(resolve, reject);
        });
    };
    /**
     * Get a file/dir metadata given the path.
     *
     * @param {string} path Path to the file/dir.
     * @param {boolean} [isDir] True if directory, false if file.
     * @return {Promise<any>} Promise resolved with metadata.
     */
    CoreFileProvider.prototype.getMetadataFromPath = function (path, isDir) {
        var _this = this;
        var promise;
        if (isDir) {
            promise = this.getDir(path);
        }
        else {
            promise = this.getFile(path);
        }
        return promise.then(function (entry) {
            return _this.getMetadata(entry);
        });
    };
    /**
     * Remove the starting slash of a path if it's there. E.g. '/sites/filepool' -> 'sites/filepool'.
     *
     * @param {string} path Path.
     * @return {string} Path without a slash in the first position.
     */
    CoreFileProvider.prototype.removeStartingSlash = function (path) {
        if (path[0] == '/') {
            return path.substr(1);
        }
        return path;
    };
    /**
     * Convenience function to copy or move an external file.
     *
     * @param {string} from Absolute path to the file to copy/move.
     * @param {string} to Relative new path of the file (inside the app folder).
     * @param {boolean} copy True to copy, false to move.
     * @return {Promise<any>} Promise resolved when the entry is copied/moved.
     */
    CoreFileProvider.prototype.copyOrMoveExternalFile = function (from, to, copy) {
        var _this = this;
        // Get the file to copy/move.
        return this.getExternalFile(from).then(function (fileEntry) {
            // Create the destination dir if it doesn't exist.
            var dirAndFile = _this.getFileAndDirectoryFromPath(to);
            return _this.createDir(dirAndFile.directory).then(function (dirEntry) {
                // Now copy/move the file.
                return new Promise(function (resolve, reject) {
                    if (copy) {
                        fileEntry.copyTo(dirEntry, dirAndFile.name, resolve, reject);
                    }
                    else {
                        fileEntry.moveTo(dirEntry, dirAndFile.name, resolve, reject);
                    }
                });
            });
        });
    };
    /**
     * Copy a file from outside of the app folder to somewhere inside the app folder.
     *
     * @param {string} from Absolute path to the file to copy.
     * @param {string} to Relative new path of the file (inside the app folder).
     * @return {Promise<any>} Promise resolved when the entry is copied.
     */
    CoreFileProvider.prototype.copyExternalFile = function (from, to) {
        return this.copyOrMoveExternalFile(from, to, true);
    };
    /**
     * Move a file from outside of the app folder to somewhere inside the app folder.
     *
     * @param {string} from Absolute path to the file to move.
     * @param {string} to Relative new path of the file (inside the app folder).
     * @return {Promise<any>} Promise resolved when the entry is moved.
     */
    CoreFileProvider.prototype.moveExternalFile = function (from, to) {
        return this.copyOrMoveExternalFile(from, to, false);
    };
    /**
     * Get a unique file name inside a folder, adding numbers to the file name if needed.
     *
     * @param {string} dirPath Path to the destination folder.
     * @param {string} fileName File name that wants to be used.
     * @param {string} [defaultExt] Default extension to use if no extension found in the file.
     * @return {Promise<string>} Promise resolved with the unique file name.
     */
    CoreFileProvider.prototype.getUniqueNameInFolder = function (dirPath, fileName, defaultExt) {
        var _this = this;
        // Get existing files in the folder.
        return this.getDirectoryContents(dirPath).then(function (entries) {
            var files = {};
            var num = 1, fileNameWithoutExtension = _this.mimeUtils.removeExtension(fileName), extension = _this.mimeUtils.getFileExtension(fileName) || defaultExt, newName;
            // Clean the file name.
            fileNameWithoutExtension = _this.textUtils.removeSpecialCharactersForFiles(_this.textUtils.decodeURIComponent(fileNameWithoutExtension));
            // Index the files by name.
            entries.forEach(function (entry) {
                files[entry.name.toLowerCase()] = entry;
            });
            // Format extension.
            if (extension) {
                extension = '.' + extension;
            }
            else {
                extension = '';
            }
            newName = fileNameWithoutExtension + extension;
            if (typeof files[newName.toLowerCase()] == 'undefined') {
                // No file with the same name.
                return newName;
            }
            else {
                // Repeated name. Add a number until we find a free name.
                do {
                    newName = fileNameWithoutExtension + '(' + num + ')' + extension;
                    num++;
                } while (typeof files[newName] != 'undefined');
                // Ask the user what he wants to do.
                return newName;
            }
        }).catch(function () {
            // Folder doesn't exist, name is unique. Clean it and return it.
            return _this.textUtils.removeSpecialCharactersForFiles(_this.textUtils.decodeURIComponent(fileName));
        });
    };
    /**
     * Remove app temporary folder.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileProvider.prototype.clearTmpFolder = function () {
        return this.removeDir(CoreFileProvider_1.TMPFOLDER).catch(function () {
            // Ignore errors because the folder might not exist.
        });
    };
    /**
     * Given a folder path and a list of used files, remove all the files of the folder that aren't on the list of used files.
     *
     * @param {string} dirPath Folder path.
     * @param {any[]} files List of used files.
     * @return {Promise<any>} Promise resolved when done, rejected if failure.
     */
    CoreFileProvider.prototype.removeUnusedFiles = function (dirPath, files) {
        var _this = this;
        // Get the directory contents.
        return this.getDirectoryContents(dirPath).then(function (contents) {
            if (!contents.length) {
                return;
            }
            var filesMap = {}, promises = [];
            // Index the received files by fullPath and ignore the invalid ones.
            files.forEach(function (file) {
                if (file.fullPath) {
                    filesMap[file.fullPath] = file;
                }
            });
            // Check which of the content files aren't used anymore and delete them.
            contents.forEach(function (file) {
                if (!filesMap[file.fullPath]) {
                    // File isn't used, delete it.
                    promises.push(_this.removeFileByFileEntry(file));
                }
            });
            return Promise.all(promises);
        }).catch(function () {
            // Ignore errors, maybe it doesn't exist.
        });
    };
    /**
     * Check if a file is inside the app's folder.
     *
     * @param {string} path The absolute path of the file to check.
     * @return {boolean} Whether the file is in the app's folder.
     */
    CoreFileProvider.prototype.isFileInAppFolder = function (path) {
        return path.indexOf(this.basePath) != -1;
    };
    // Formats to read a file.
    CoreFileProvider.FORMATTEXT = 0;
    CoreFileProvider.FORMATDATAURL = 1;
    CoreFileProvider.FORMATBINARYSTRING = 2;
    CoreFileProvider.FORMATARRAYBUFFER = 3;
    // Folders.
    CoreFileProvider.SITESFOLDER = 'sites';
    CoreFileProvider.TMPFOLDER = 'tmp';
    CoreFileProvider = CoreFileProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_2__ionic_native_file__["a" /* File */], __WEBPACK_IMPORTED_MODULE_3__app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__ionic_native_zip__["a" /* Zip */], __WEBPACK_IMPORTED_MODULE_5__utils_mimetype__["a" /* CoreMimetypeUtilsProvider */]])
    ], CoreFileProvider);
    return CoreFileProvider;
    var CoreFileProvider_1;
}());

//# sourceMappingURL=file.js.map

/***/ }),
/* 34 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseLogHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Helper to manage logging to Moodle.
 */
var CoreCourseLogHelperProvider = /** @class */ (function () {
    function CoreCourseLogHelperProvider(sitesProvider, timeUtils, textUtils, utils, appProvider, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.textUtils = textUtils;
        this.utils = utils;
        this.appProvider = appProvider;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.siteSchema = {
            name: 'CoreCourseLogHelperProvider',
            version: 1,
            tables: [
                {
                    name: CoreCourseLogHelperProvider_1.ACTIVITY_LOG_TABLE,
                    columns: [
                        {
                            name: 'component',
                            type: 'TEXT'
                        },
                        {
                            name: 'componentid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'ws',
                            type: 'TEXT'
                        },
                        {
                            name: 'data',
                            type: 'TEXT'
                        },
                        {
                            name: 'time',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['component', 'componentid', 'ws', 'time']
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    CoreCourseLogHelperProvider_1 = CoreCourseLogHelperProvider;
    /**
     * Delete the offline saved activity logs.
     *
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when deleted, rejected if failure.
     */
    CoreCourseLogHelperProvider.prototype.deleteLogs = function (component, componentId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(CoreCourseLogHelperProvider_1.ACTIVITY_LOG_TABLE, { component: component, componentid: componentId });
        });
    };
    /**
     * Delete a WS based log.
     *
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         ws          WS name.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when deleted, rejected if failure.
     */
    CoreCourseLogHelperProvider.prototype.deleteWSLogsByComponent = function (component, componentId, ws, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(CoreCourseLogHelperProvider_1.ACTIVITY_LOG_TABLE, { component: component, componentid: componentId, ws: ws });
        });
    };
    /**
     * Delete the offline saved activity logs using call data.
     *
     * @param  {string}         ws          WS name.
     * @param  {any}            data        Data to send to the WS.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when deleted, rejected if failure.
     */
    CoreCourseLogHelperProvider.prototype.deleteWSLogs = function (ws, data, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(CoreCourseLogHelperProvider_1.ACTIVITY_LOG_TABLE, { ws: ws, data: _this.utils.sortAndStringify(data) });
        });
    };
    /**
     * Get all the offline saved activity logs.
     *
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of offline logs.
     */
    CoreCourseLogHelperProvider.prototype.getAllLogs = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getAllRecords(CoreCourseLogHelperProvider_1.ACTIVITY_LOG_TABLE);
        });
    };
    /**
     * Get the offline saved activity logs.
     *
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of offline logs.
     */
    CoreCourseLogHelperProvider.prototype.getLogs = function (component, componentId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(CoreCourseLogHelperProvider_1.ACTIVITY_LOG_TABLE, { component: component, componentid: componentId });
        });
    };
    /**
     * Perform log online. Data will be saved offline for syncing.
     *
     * @param  {string}         ws          WS name.
     * @param  {any}            data        Data to send to the WS.
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseLogHelperProvider.prototype.log = function (ws, data, component, componentId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!_this.appProvider.isOnline()) {
                // App is offline, store the action.
                return _this.storeOffline(ws, data, component, componentId, site.getId());
            }
            return _this.logOnline(ws, data, site.getId()).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that responses cannot be submitted.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store in offline.
                return _this.storeOffline(ws, data, component, componentId, site.getId());
            });
        });
    };
    /**
     * Perform the log online.
     *
     * @param  {string}       ws       WS name.
     * @param  {any}          data     Data to send to the WS.
     * @param  {string}       [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when log is successfully submitted. Rejected with object containing
     *                            the error message (if any) and a boolean indicating if the error was returned by WS.
     */
    CoreCourseLogHelperProvider.prototype.logOnline = function (ws, data, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.write(ws, data).then(function (response) {
                if (!response.status) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                // Remove all the logs performed.
                // TODO: Remove this lines when time is accepted in logs.
                return _this.deleteWSLogs(ws, data);
            });
        });
    };
    /**
     * Perform log online. Data will be saved offline for syncing.
     * It also triggers a Firebase view_item event.
     *
     * @param  {string}         ws          WS name.
     * @param  {any}            data        Data to send to the WS.
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         [name] Name of the viewed item.
     * @param  {string}         [category] Category of the viewed item.
     * @param  {string}         [eventData] Data to pass to the Firebase event.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseLogHelperProvider.prototype.logSingle = function (ws, data, component, componentId, name, category, eventData, siteId) {
        this.pushNotificationsProvider.logViewEvent(componentId, name, category, ws, eventData, siteId);
        return this.log(ws, data, component, componentId, siteId);
    };
    /**
     * Perform log online. Data will be saved offline for syncing.
     * It also triggers a Firebase view_item_list event.
     *
     * @param  {string}         ws          WS name.
     * @param  {any}            data        Data to send to the WS.
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         category    Category of the viewed item.
     * @param  {string}         [eventData] Data to pass to the Firebase event.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseLogHelperProvider.prototype.logList = function (ws, data, component, componentId, category, eventData, siteId) {
        this.pushNotificationsProvider.logViewListEvent(category, ws, eventData, siteId);
        return this.log(ws, data, component, componentId, siteId);
    };
    /**
     * Save activity log for offline sync.
     *
     * @param  {string}         ws          WS name.
     * @param  {any}            data        Data to send to the WS.
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<number>} Resolved with the inserted rowId field.
     */
    CoreCourseLogHelperProvider.prototype.storeOffline = function (ws, data, component, componentId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var log = {
                ws: ws,
                data: _this.utils.sortAndStringify(data),
                component: component,
                componentid: componentId,
                time: _this.timeUtils.timestamp()
            };
            return site.getDb().insertRecord(CoreCourseLogHelperProvider_1.ACTIVITY_LOG_TABLE, log);
        });
    };
    /**
     * Sync all the offline saved activity logs.
     *
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when done.
     */
    CoreCourseLogHelperProvider.prototype.syncSite = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var siteId = site.getId();
            return _this.getAllLogs(siteId).then(function (logs) {
                var unique = [];
                // TODO: When time is accepted on log, do not discard same logs.
                logs.forEach(function (log) {
                    // Just perform unique syncs.
                    var found = unique.find(function (doneLog) {
                        return log.component == doneLog.component && log.componentid == doneLog.componentid &&
                            log.ws == doneLog.ws && log.data == doneLog.data;
                    });
                    if (!found) {
                        unique.push(log);
                    }
                });
                return _this.syncLogs(unique, siteId);
            });
        });
    };
    /**
     * Sync the offline saved activity logs.
     *
     * @param  {string}         component   Component name.
     * @param  {number}         componentId Component ID.
     * @param  {string}         [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when done.
     */
    CoreCourseLogHelperProvider.prototype.syncIfNeeded = function (component, componentId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var siteId = site.getId();
            return _this.getLogs(component, componentId, siteId).then(function (logs) {
                var unique = [];
                // TODO: When time is accepted on log, do not discard same logs.
                logs.forEach(function (log) {
                    // Just perform unique syncs.
                    var found = unique.find(function (doneLog) {
                        return log.ws == doneLog.ws && log.data == doneLog.data;
                    });
                    if (!found) {
                        unique.push(log);
                    }
                });
                return _this.syncLogs(unique, siteId);
            });
        });
    };
    /**
     * Sync and delete given logs.
     *
     * @param  {any[]}        logs   Array of log objects.
     * @param  {string}       siteId Site Id.
     * @return {Promise<any>}        Promise resolved when done.
     */
    CoreCourseLogHelperProvider.prototype.syncLogs = function (logs, siteId) {
        var _this = this;
        return Promise.all(logs.map(function (log) {
            return _this.logOnline(log.ws, _this.textUtils.parseJSON(log.data), siteId).then(function () {
                return _this.deleteWSLogsByComponent(log.component, log.componentid, log.ws);
            });
        }));
    };
    // Variables for database.
    CoreCourseLogHelperProvider.ACTIVITY_LOG_TABLE = 'course_activity_log';
    CoreCourseLogHelperProvider = CoreCourseLogHelperProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], CoreCourseLogHelperProvider);
    return CoreCourseLogHelperProvider;
    var CoreCourseLogHelperProvider_1;
}());

//# sourceMappingURL=log-helper.js.map

/***/ }),
/* 35 */,
/* 36 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContentLinksDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Delegate to register handlers to handle links.
 */
var CoreContentLinksDelegate = /** @class */ (function () {
    function CoreContentLinksDelegate(logger, sitesProvider, urlUtils, utils) {
        this.sitesProvider = sitesProvider;
        this.urlUtils = urlUtils;
        this.utils = utils;
        this.handlers = {}; // All registered handlers.
        this.logger = logger.getInstance('CoreContentLinksDelegate');
    }
    /**
     * Get the list of possible actions to do for a URL.
     *
     * @param {string} url URL to handle.
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @param {string} [username] Username to use to filter sites.
     * @param {any} [data] Extra data to handle the URL.
     * @return {Promise<CoreContentLinksAction[]>}  Promise resolved with the actions.
     */
    CoreContentLinksDelegate.prototype.getActionsFor = function (url, courseId, username, data) {
        var _this = this;
        if (!url) {
            return Promise.resolve([]);
        }
        // Get the list of sites the URL belongs to.
        return this.sitesProvider.getSiteIdsFromUrl(url, true, username).then(function (siteIds) {
            var linkActions = [], promises = [], params = _this.urlUtils.extractUrlParams(url);
            var _loop_1 = function (name_1) {
                var handler = _this.handlers[name_1], checkAll = handler.checkAllUsers, isEnabledFn = _this.isHandlerEnabled.bind(_this, handler, url, params, courseId);
                if (!handler.handles(url)) {
                    return "continue";
                }
                // Filter the site IDs using the isEnabled function.
                promises.push(_this.utils.filterEnabledSites(siteIds, isEnabledFn, checkAll).then(function (siteIds) {
                    if (!siteIds.length) {
                        // No sites supported, no actions.
                        return;
                    }
                    return Promise.resolve(handler.getActions(siteIds, url, params, courseId, data)).then(function (actions) {
                        if (actions && actions.length) {
                            // Set default values if any value isn't supplied.
                            actions.forEach(function (action) {
                                action.message = action.message || 'core.view';
                                action.icon = action.icon || 'eye';
                                action.sites = action.sites || siteIds;
                            });
                            // Add them to the list.
                            linkActions.push({
                                priority: handler.priority,
                                actions: actions
                            });
                        }
                    });
                }));
            };
            for (var name_1 in _this.handlers) {
                _loop_1(name_1);
            }
            return _this.utils.allPromises(promises).catch(function () {
                // Ignore errors.
            }).then(function () {
                // Sort link actions by priority.
                return _this.sortActionsByPriority(linkActions);
            });
        });
    };
    /**
     * Get the site URL if the URL is supported by any handler.
     *
     * @param {string} url URL to handle.
     * @return {string} Site URL if the URL is supported by any handler, undefined otherwise.
     */
    CoreContentLinksDelegate.prototype.getSiteUrl = function (url) {
        if (!url) {
            return;
        }
        // Check if any handler supports this URL.
        for (var name_2 in this.handlers) {
            var handler = this.handlers[name_2], siteUrl = handler.getSiteUrl(url);
            if (siteUrl) {
                return siteUrl;
            }
        }
    };
    /**
     * Check if a handler is enabled for a certain site and URL.
     *
     * @param {CoreContentLinksHandler} handler Handler to check.
     * @param {string} url The URL to check.
     * @param {any} params The params of the URL
     * @param {number} courseId Course ID the URL belongs to (can be undefined).
     * @param {string} siteId The site ID to check.
     * @return {Promise<boolean>} Promise resolved with boolean: whether the handler is enabled.
     */
    CoreContentLinksDelegate.prototype.isHandlerEnabled = function (handler, url, params, courseId, siteId) {
        var promise;
        if (handler.featureName) {
            // Check if the feature is disabled.
            promise = this.sitesProvider.isFeatureDisabled(handler.featureName, siteId);
        }
        else {
            promise = Promise.resolve(false);
        }
        return promise.then(function (disabled) {
            if (disabled) {
                return false;
            }
            if (!handler.isEnabled) {
                // Handler doesn't implement isEnabled, assume it's enabled.
                return true;
            }
            return handler.isEnabled(siteId, url, params, courseId);
        });
    };
    /**
     * Register a handler.
     *
     * @param {CoreContentLinksHandler} handler The handler to register.
     * @return {boolean} True if registered successfully, false otherwise.
     */
    CoreContentLinksDelegate.prototype.registerHandler = function (handler) {
        if (typeof this.handlers[handler.name] !== 'undefined') {
            this.logger.log("Addon '" + handler.name + "' already registered");
            return false;
        }
        this.logger.log("Registered addon '" + handler.name + "'");
        this.handlers[handler.name] = handler;
        return true;
    };
    /**
     * Sort actions by priority.
     *
     * @param {CoreContentLinksHandlerActions[]} actions Actions to sort.
     * @return {CoreContentLinksAction[]} Sorted actions.
     */
    CoreContentLinksDelegate.prototype.sortActionsByPriority = function (actions) {
        var sorted = [];
        // Sort by priority.
        actions = actions.sort(function (a, b) {
            return a.priority <= b.priority ? 1 : -1;
        });
        // Fill result array.
        actions.forEach(function (entry) {
            sorted = sorted.concat(entry.actions);
        });
        return sorted;
    };
    CoreContentLinksDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreContentLinksDelegate);
    return CoreContentLinksDelegate;
}());

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 37 */,
/* 38 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModuleDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__default_module__ = __webpack_require__(758);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_delegate__ = __webpack_require__(62);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Delegate to register module handlers.
 */
var CoreCourseModuleDelegate = /** @class */ (function (_super) {
    __extends(CoreCourseModuleDelegate, _super);
    function CoreCourseModuleDelegate(loggerProvider, sitesProvider, eventsProvider, courseProvider, defaultHandler) {
        var _this = _super.call(this, 'CoreCourseModuleDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.sitesProvider = sitesProvider;
        _this.courseProvider = courseProvider;
        _this.defaultHandler = defaultHandler;
        _this.featurePrefix = 'CoreCourseModuleDelegate_';
        _this.handlerNameProperty = 'modName';
        return _this;
    }
    /**
     * Get the component to render the module.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreCourseModuleDelegate.prototype.getMainComponent = function (injector, course, module) {
        var _this = this;
        return Promise.resolve(this.executeFunctionOnEnabled(module.modname, 'getMainComponent', [injector, course, module]))
            .catch(function (err) {
            _this.logger.error('Error getting main component', err);
        });
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {string} modname The name of the module type.
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    CoreCourseModuleDelegate.prototype.getModuleDataFor = function (modname, module, courseId, sectionId) {
        return this.executeFunctionOnEnabled(modname, 'getData', [module, courseId, sectionId]);
    };
    /**
     * Check if a certain module type is disabled in a site.
     *
     * @param {string} modname The name of the module type.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether module is disabled.
     */
    CoreCourseModuleDelegate.prototype.isModuleDisabled = function (modname, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isModuleDisabledInSite(modname, site);
        });
    };
    /**
     * Check if a certain module type is disabled in a site.
     *
     * @param {string} modname The name of the module type.
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether module is disabled.
     */
    CoreCourseModuleDelegate.prototype.isModuleDisabledInSite = function (modname, site) {
        var handler = this.getHandler(modname, true);
        if (handler) {
            site = site || this.sitesProvider.getCurrentSite();
            return this.isFeatureDisabled(handler, site);
        }
        return false;
    };
    /**
     * Whether to display the course refresher in single activity course format. If it returns false, a refresher must be
     * included in the template that calls the doRefresh method of the component. Defaults to true.
     *
     * @param {any} modname The name of the module type.
     * @return {boolean} Whether the refresher should be displayed.
     */
    CoreCourseModuleDelegate.prototype.displayRefresherInSingleActivity = function (modname) {
        return this.executeFunctionOnEnabled(modname, 'displayRefresherInSingleActivity');
    };
    /**
     * Get the icon src for a certain type of module.
     *
     * @param {any} modname The name of the module type.
     * @param {string} [modicon] The mod icon string.
     * @return {string} The icon src.
     */
    CoreCourseModuleDelegate.prototype.getModuleIconSrc = function (modname, modicon) {
        return this.executeFunctionOnEnabled(modname, 'getIconSrc') || this.courseProvider.getModuleIconSrc(modname, modicon);
    };
    /**
     * Check if a certain type of module supports a certain feature.
     *
     * @param {string} modname The modname.
     * @param {string} feature The feature to check.
     * @param {any} defaultValue Value to return if the module is not supported or doesn't know if it's supported.
     * @return {any} The result of the supports check.
     */
    CoreCourseModuleDelegate.prototype.supportsFeature = function (modname, feature, defaultValue) {
        var handler = this.enabledHandlers[modname];
        var result;
        if (handler) {
            if (handler['supportsFeature']) {
                // The handler specified a function to determine the feature, use it.
                result = handler['supportsFeature'].apply(handler, [feature]);
            }
            else if (handler['supportedFeatures']) {
                // Handler has an object to determine the feature, use it.
                result = handler['supportedFeatures'][feature];
            }
        }
        if (result === null || typeof result == 'undefined') {
            // Not supported or doesn't know, return defaul.
            return defaultValue;
        }
        else {
            return result;
        }
    };
    CoreCourseModuleDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__default_module__["a" /* CoreCourseModuleDefaultHandler */]])
    ], CoreCourseModuleDelegate);
    return CoreCourseModuleDelegate;
}(__WEBPACK_IMPORTED_MODULE_6__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=module-delegate.js.map

/***/ }),
/* 39 */,
/* 40 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUrlUtilsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/*
 * "Utils" service with helper functions for URLs.
 */
var CoreUrlUtilsProvider = /** @class */ (function () {
    function CoreUrlUtilsProvider(langProvider, textUtils) {
        this.langProvider = langProvider;
        this.textUtils = textUtils;
    }
    /**
     * Add or remove 'www' from a URL. The url needs to have http or https protocol.
     *
     * @param {string} url URL to modify.
     * @return {string} Modified URL.
     */
    CoreUrlUtilsProvider.prototype.addOrRemoveWWW = function (url) {
        if (url) {
            if (url.match(/http(s)?:\/\/www\./)) {
                // Already has www. Remove it.
                url = url.replace('www.', '');
            }
            else {
                url = url.replace('https://', 'https://www.');
                url = url.replace('http://', 'http://www.');
            }
        }
        return url;
    };
    /**
     * Extracts the parameters from a URL and stores them in an object.
     *
     * @param {string} url URL to treat.
     * @return {any} Object with the params.
     */
    CoreUrlUtilsProvider.prototype.extractUrlParams = function (url) {
        var regex = /[?&]+([^=&]+)=?([^&]*)?/gi, subParamsPlaceholder = '@@@SUBPARAMS@@@', params = {}, urlAndHash = url.split('#'), questionMarkSplit = urlAndHash[0].split('?');
        var subParams;
        if (questionMarkSplit.length > 2) {
            // There is more than one question mark in the URL. This can happen if any of the params is a URL with params.
            // We only want to treat the first level of params, so we'll remove this second list of params and restore it later.
            questionMarkSplit.splice(0, 2);
            subParams = '?' + questionMarkSplit.join('?');
            urlAndHash[0] = urlAndHash[0].replace(subParams, subParamsPlaceholder);
        }
        urlAndHash[0].replace(regex, function (match, key, value) {
            params[key] = typeof value != 'undefined' ? value : '';
            if (subParams) {
                params[key] = params[key].replace(subParamsPlaceholder, subParams);
            }
            return match;
        });
        if (urlAndHash.length > 1) {
            // Remove the URL from the array.
            urlAndHash.shift();
            // Add the hash as a param with a special name. Use a join in case there is more than one #.
            params.urlHash = urlAndHash.join('#');
        }
        return params;
    };
    /**
     * Generic function for adding the wstoken to Moodle urls and for pointing to the correct script.
     * For download remote files from Moodle we need to use the special /webservice/pluginfile passing
     * the ws token as a get parameter.
     *
     * @param {string} url The url to be fixed.
     * @param {string} token Token to use.
     * @param {string} siteUrl The URL of the site the URL belongs to.
     * @return {string} Fixed URL.
     */
    CoreUrlUtilsProvider.prototype.fixPluginfileURL = function (url, token, siteUrl) {
        if (!url) {
            return '';
        }
        url = url.replace(/&amp;/g, '&');
        // First check if we need to fix this url or is already fixed.
        if (url.indexOf('token=') != -1) {
            return url;
        }
        // Check if is a valid URL (contains the pluginfile endpoint).
        if (!this.isPluginFileUrl(url)) {
            return url;
        }
        // Check if the URL already has params.
        if (url.match(/\?[^=]+=/)) {
            url += '&';
        }
        else {
            url += '?';
        }
        // Always send offline=1 (for external repositories). It shouldn't cause problems for local files or old Moodles.
        url += 'token=' + token + '&offline=1';
        // Some webservices returns directly the correct download url, others not.
        if (url.indexOf(this.textUtils.concatenatePaths(siteUrl, 'pluginfile.php')) === 0) {
            url = url.replace('/pluginfile', '/webservice/pluginfile');
        }
        return url;
    };
    /**
     * Formats a URL, trim, lowercase, etc...
     *
     * @param {string} url The url to be formatted.
     * @return {string} Fromatted url.
     */
    CoreUrlUtilsProvider.prototype.formatURL = function (url) {
        url = url.trim();
        // Check if the URL starts by http or https.
        if (!/^http(s)?\:\/\/.*/i.test(url)) {
            // Test first allways https.
            url = 'https://' + url;
        }
        // http allways in lowercase.
        url = url.replace(/^http/i, 'http');
        url = url.replace(/^https/i, 'https');
        // Replace last slash.
        url = url.replace(/\/$/, '');
        return url;
    };
    /**
     * Returns the URL to the documentation of the app, based on Moodle version and current language.
     *
     * @param {string} [release] Moodle release.
     * @param {string} [page=Mobile_app] Docs page to go to.
     * @return {Promise<string>} Promise resolved with the Moodle docs URL.
     */
    CoreUrlUtilsProvider.prototype.getDocsUrl = function (release, page) {
        if (page === void 0) { page = 'Mobile_app'; }
        var docsUrl = 'https://docs.moodle.org/en/' + page;
        if (typeof release != 'undefined') {
            var version = release.substr(0, 3).replace('.', '');
            // Check is a valid number.
            if (parseInt(version) >= 24) {
                // Append release number.
                docsUrl = docsUrl.replace('https://docs.moodle.org/', 'https://docs.moodle.org/' + version + '/');
            }
        }
        return this.langProvider.getCurrentLanguage().then(function (lang) {
            return docsUrl.replace('/en/', '/' + lang + '/');
        }).catch(function () {
            return docsUrl;
        });
    };
    /**
     * Given a URL, returns what's after the last '/' without params.
     * Example:
     * http://mysite.com/a/course.html?id=1 -> course.html
     *
     * @param {string} url URL to treat.
     * @return {string} Last file without params.
     */
    CoreUrlUtilsProvider.prototype.getLastFileWithoutParams = function (url) {
        var filename = url.substr(url.lastIndexOf('/') + 1);
        if (filename.indexOf('?') != -1) {
            filename = filename.substr(0, filename.indexOf('?'));
        }
        return filename;
    };
    /**
     * Get the protocol from a URL.
     * E.g. http://www.google.com returns 'http'.
     *
     * @param {string} url URL to treat.
     * @return {string} Protocol, undefined if no protocol found.
     */
    CoreUrlUtilsProvider.prototype.getUrlProtocol = function (url) {
        if (!url) {
            return;
        }
        var matches = url.match(/^([^\/:\.\?]*):\/\//);
        if (matches && matches[1]) {
            return matches[1];
        }
    };
    /**
     * Get the scheme from a URL. Please notice that, if a URL has protocol, it will return the protocol.
     * E.g. javascript:doSomething() returns 'javascript'.
     *
     * @param {string} url URL to treat.
     * @return {string} Scheme, undefined if no scheme found.
     */
    CoreUrlUtilsProvider.prototype.getUrlScheme = function (url) {
        if (!url) {
            return;
        }
        var matches = url.match(/^([a-z][a-z0-9+\-.]*):/);
        if (matches && matches[1]) {
            return matches[1];
        }
    };
    /*
     * Gets a username from a URL like: user@mysite.com.
     *
     * @param {string} url URL to treat.
     * @return {string} Username. Undefined if no username found.
     */
    CoreUrlUtilsProvider.prototype.getUsernameFromUrl = function (url) {
        if (url.indexOf('@') > -1) {
            // Get URL without protocol.
            var withoutProtocol = url.replace(/^[^?@\/]*:\/\//, ''), matches = withoutProtocol.match(/[^@]*/);
            // Make sure that @ is at the start of the URL, not in a param at the end.
            if (matches && matches.length && !matches[0].match(/[\/|?]/)) {
                return matches[0];
            }
        }
    };
    /**
     * Returns if a URL has any protocol (not a relative URL).
     *
     * @param {string} url The url to test against the pattern.
     * @return {boolean} Whether the url is absolute.
     */
    CoreUrlUtilsProvider.prototype.isAbsoluteURL = function (url) {
        return /^[^:]{2,}:\/\//i.test(url) || /^(tel:|mailto:|geo:)/.test(url);
    };
    /**
     * Returns if a URL is downloadable: plugin file OR theme/image.php OR gravatar.
     *
     * @param {string} url The URL to test.
     * @return {boolean} Whether the URL is downloadable.
     */
    CoreUrlUtilsProvider.prototype.isDownloadableUrl = function (url) {
        return this.isPluginFileUrl(url) || this.isThemeImageUrl(url) || this.isGravatarUrl(url);
    };
    /**
     * Returns if a URL is a gravatar URL.
     *
     * @param {string} url The URL to test.
     * @return {boolean} Whether the URL is a gravatar URL.
     */
    CoreUrlUtilsProvider.prototype.isGravatarUrl = function (url) {
        return url && url.indexOf('gravatar.com/avatar') !== -1;
    };
    /**
     * Check if a URL uses http or https protocol.
     *
     * @param {string} url The url to test.
     * @return {boolean} Whether the url uses http or https protocol.
     */
    CoreUrlUtilsProvider.prototype.isHttpURL = function (url) {
        return /^https?\:\/\/.+/i.test(url);
    };
    /**
     * Returns if a URL is a pluginfile URL.
     *
     * @param {string} url The URL to test.
     * @return {boolean} Whether the URL is a pluginfile URL.
     */
    CoreUrlUtilsProvider.prototype.isPluginFileUrl = function (url) {
        return url && url.indexOf('/pluginfile.php') !== -1;
    };
    /**
     * Returns if a URL is a theme image URL.
     *
     * @param {string} url The URL to test.
     * @return {boolean} Whether the URL is a theme image URL.
     */
    CoreUrlUtilsProvider.prototype.isThemeImageUrl = function (url) {
        return url && url.indexOf('/theme/image.php') !== -1;
    };
    /**
     * Remove protocol and www from a URL.
     *
     * @param {string} url URL to treat.
     * @return {string} Treated URL.
     */
    CoreUrlUtilsProvider.prototype.removeProtocolAndWWW = function (url) {
        // Remove protocol.
        url = url.replace(/.*?:\/\//g, '');
        // Remove www.
        url = url.replace(/^www./, '');
        return url;
    };
    /**
     * Remove the parameters from a URL, returning the URL without them.
     *
     * @param {string} url URL to treat.
     * @return {string} URL without params.
     */
    CoreUrlUtilsProvider.prototype.removeUrlParams = function (url) {
        var matches = url.match(/^[^\?]+/);
        return matches && matches[0];
    };
    CoreUrlUtilsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_2__text__["a" /* CoreTextUtilsProvider */]])
    ], CoreUrlUtilsProvider);
    return CoreUrlUtilsProvider;
}());

//# sourceMappingURL=url.js.map

/***/ }),
/* 41 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__format_format__ = __webpack_require__(350);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__module_module__ = __webpack_require__(1428);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__module_completion_module_completion__ = __webpack_require__(1429);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__module_description_module_description__ = __webpack_require__(1430);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__unsupported_module_unsupported_module__ = __webpack_require__(351);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};











var CoreCourseComponentsModule = /** @class */ (function () {
    function CoreCourseComponentsModule() {
    }
    CoreCourseComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__format_format__["a" /* CoreCourseFormatComponent */],
                __WEBPACK_IMPORTED_MODULE_7__module_module__["a" /* CoreCourseModuleComponent */],
                __WEBPACK_IMPORTED_MODULE_8__module_completion_module_completion__["a" /* CoreCourseModuleCompletionComponent */],
                __WEBPACK_IMPORTED_MODULE_9__module_description_module_description__["a" /* CoreCourseModuleDescriptionComponent */],
                __WEBPACK_IMPORTED_MODULE_10__unsupported_module_unsupported_module__["a" /* CoreCourseUnsupportedModuleComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__format_format__["a" /* CoreCourseFormatComponent */],
                __WEBPACK_IMPORTED_MODULE_7__module_module__["a" /* CoreCourseModuleComponent */],
                __WEBPACK_IMPORTED_MODULE_8__module_completion_module_completion__["a" /* CoreCourseModuleCompletionComponent */],
                __WEBPACK_IMPORTED_MODULE_9__module_description_module_description__["a" /* CoreCourseModuleDescriptionComponent */],
                __WEBPACK_IMPORTED_MODULE_10__unsupported_module_unsupported_module__["a" /* CoreCourseUnsupportedModuleComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_10__unsupported_module_unsupported_module__["a" /* CoreCourseUnsupportedModuleComponent */]
            ]
        })
    ], CoreCourseComponentsModule);
    return CoreCourseComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 42 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__default_question_handler__ = __webpack_require__(788);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Delegate to register question handlers.
 */
var CoreQuestionDelegate = /** @class */ (function (_super) {
    __extends(CoreQuestionDelegate, _super);
    function CoreQuestionDelegate(logger, sitesProvider, eventsProvider, defaultHandler) {
        var _this = _super.call(this, 'CoreQuestionDelegate', logger, sitesProvider, eventsProvider) || this;
        _this.defaultHandler = defaultHandler;
        _this.handlerNameProperty = 'type';
        return _this;
    }
    /**
     * Get the behaviour to use for a certain question type.
     * E.g. 'qtype_essay' uses 'manualgraded'.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    CoreQuestionDelegate.prototype.getBehaviourForQuestion = function (question, behaviour) {
        var type = this.getTypeName(question), questionBehaviour = this.executeFunctionOnEnabled(type, 'getBehaviour', [question, behaviour]);
        return questionBehaviour || behaviour;
    };
    /**
     * Get the directive to use for a certain question type.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreQuestionDelegate.prototype.getComponentForQuestion = function (injector, question) {
        var type = this.getTypeName(question);
        return Promise.resolve(this.executeFunctionOnEnabled(type, 'getComponent', [injector, question]));
    };
    /**
     * Check if a question can be submitted.
     * If a question cannot be submitted it should return a message explaining why (translated or not).
     *
     * @param {any} question Question.
     * @return {string} Prevent submit message. Undefined or empty if can be submitted.
     */
    CoreQuestionDelegate.prototype.getPreventSubmitMessage = function (question) {
        var type = this.getTypeName(question);
        return this.executeFunctionOnEnabled(type, 'getPreventSubmitMessage', [question]);
    };
    /**
     * Given a type name, return the full name of that type. E.g. 'calculated' -> 'qtype_calculated'.
     *
     * @param {string} type Type to treat.
     * @return {string} Type full name.
     */
    CoreQuestionDelegate.prototype.getFullTypeName = function (type) {
        return 'qtype_' + type;
    };
    /**
     * Given a question, return the full name of its question type.
     *
     * @param {any} question Question.
     * @return {string} Type name.
     */
    CoreQuestionDelegate.prototype.getTypeName = function (question) {
        return this.getFullTypeName(question.type);
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    CoreQuestionDelegate.prototype.isCompleteResponse = function (question, answers) {
        var type = this.getTypeName(question);
        return this.executeFunctionOnEnabled(type, 'isCompleteResponse', [question, answers]);
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    CoreQuestionDelegate.prototype.isGradableResponse = function (question, answers) {
        var type = this.getTypeName(question);
        return this.executeFunctionOnEnabled(type, 'isGradableResponse', [question, answers]);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    CoreQuestionDelegate.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        var type = this.getTypeName(question);
        return this.executeFunctionOnEnabled(type, 'isSameResponse', [question, prevAnswers, newAnswers]);
    };
    /**
     * Check if a question type is supported.
     *
     * @param {string} type Question type.
     * @return {boolean} Whether it's supported.
     */
    CoreQuestionDelegate.prototype.isQuestionSupported = function (type) {
        return this.hasHandler(this.getFullTypeName(type), true);
    };
    /**
     * Prepare the answers for a certain question.
     *
     * @param {any} question Question.
     * @param {any} answers The answers retrieved from the form. Prepared answers must be stored in this object.
     * @param {boolean} [offline] Whether the data should be saved in offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data has been prepared.
     */
    CoreQuestionDelegate.prototype.prepareAnswersForQuestion = function (question, answers, offline, siteId) {
        var type = this.getTypeName(question);
        return Promise.resolve(this.executeFunctionOnEnabled(type, 'prepareAnswers', [question, answers, offline, siteId]));
    };
    /**
     * Validate if an offline sequencecheck is valid compared with the online one.
     *
     * @param {any} question The question.
     * @param {string} offlineSequenceCheck Sequence check stored in offline.
     * @return {boolean} Whether sequencecheck is valid.
     */
    CoreQuestionDelegate.prototype.validateSequenceCheck = function (question, offlineSequenceCheck) {
        var type = this.getTypeName(question);
        return this.executeFunctionOnEnabled(type, 'validateSequenceCheck', [question, offlineSequenceCheck]);
    };
    /**
     * Get the list of files that needs to be downloaded in addition to the files embedded in the HTML.
     *
     * @param {any} question Question.
     * @param {number} usageId Usage ID.
     * @return {string[]} List of URLs.
     */
    CoreQuestionDelegate.prototype.getAdditionalDownloadableFiles = function (question, usageId) {
        var type = this.getTypeName(question);
        return this.executeFunctionOnEnabled(type, 'getAdditionalDownloadableFiles', [question, usageId]) || [];
    };
    CoreQuestionDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__default_question_handler__["a" /* CoreQuestionDefaultHandler */]])
    ], CoreQuestionDelegate);
    return CoreQuestionDelegate;
}(__WEBPACK_IMPORTED_MODULE_4__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 43 */,
/* 44 */,
/* 45 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_events__ = __webpack_require__(12);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * Service to provide functionalities regarding site plugins.
 */
var CoreSitePluginsProvider = /** @class */ (function () {
    function CoreSitePluginsProvider(logger, sitesProvider, utils, langProvider, appProvider, platform, filepoolProvider, coursesProvider, textUtils, eventsProvider) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.langProvider = langProvider;
        this.appProvider = appProvider;
        this.platform = platform;
        this.filepoolProvider = filepoolProvider;
        this.coursesProvider = coursesProvider;
        this.textUtils = textUtils;
        this.eventsProvider = eventsProvider;
        this.ROOT_CACHE_KEY = 'CoreSitePlugins:';
        this.sitePlugins = {}; // Site plugins registered.
        this.sitePluginPromises = {}; // Promises of loading plugins.
        this.hasSitePluginsLoaded = false;
        this.sitePluginsFinishedLoading = false;
        this.logger = logger.getInstance('CoreUserProvider');
        var observer = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_12__providers_events__["a" /* CoreEventsProvider */].SITE_PLUGINS_LOADED, function () {
            _this.sitePluginsFinishedLoading = true;
            observer && observer.off();
        });
        // Initialize deferred at start and on logout.
        this.fetchPluginsDeferred = this.utils.promiseDefer();
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_12__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function () {
            _this.fetchPluginsDeferred = _this.utils.promiseDefer();
        });
    }
    /**
     * Add some params that will always be sent for get content.
     *
     * @param {any} args Original params.
     * @param {CoreSite} [site] Site. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the new params.
     */
    CoreSitePluginsProvider.prototype.addDefaultArgs = function (args, site) {
        var _this = this;
        args = args || {};
        site = site || this.sitesProvider.getCurrentSite();
        return this.langProvider.getCurrentLanguage().then(function (lang) {
            // Clone the object so the original one isn't modified.
            var argsToSend = _this.utils.clone(args);
            argsToSend.userid = args.userid || site.getUserId();
            argsToSend.appid = __WEBPACK_IMPORTED_MODULE_10__configconstants__["a" /* CoreConfigConstants */].app_id;
            argsToSend.appversioncode = __WEBPACK_IMPORTED_MODULE_10__configconstants__["a" /* CoreConfigConstants */].versioncode;
            argsToSend.appversionname = __WEBPACK_IMPORTED_MODULE_10__configconstants__["a" /* CoreConfigConstants */].versionname;
            argsToSend.applang = lang;
            argsToSend.appcustomurlscheme = __WEBPACK_IMPORTED_MODULE_10__configconstants__["a" /* CoreConfigConstants */].customurlscheme;
            argsToSend.appisdesktop = _this.appProvider.isDesktop();
            argsToSend.appismobile = _this.appProvider.isMobile();
            argsToSend.appiswide = _this.appProvider.isWide();
            if (argsToSend.appisdevice) {
                if (_this.platform.is('ios')) {
                    argsToSend.appplatform = 'ios';
                }
                else {
                    argsToSend.appplatform = 'android';
                }
            }
            else if (argsToSend.appisdesktop) {
                if (_this.appProvider.isMac()) {
                    argsToSend.appplatform = 'mac';
                }
                else if (_this.appProvider.isLinux()) {
                    argsToSend.appplatform = 'linux';
                }
                else {
                    argsToSend.appplatform = 'windows';
                }
            }
            else {
                argsToSend.appplatform = 'browser';
            }
            return argsToSend;
        });
    };
    /**
     * Call a WS for a site plugin.
     *
     * @param {string} method WS method to use.
     * @param {any} data Data to send to the WS.
     * @param {CoreSiteWSPreSets} [preSets] Extra options.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the response.
     */
    CoreSitePluginsProvider.prototype.callWS = function (method, data, preSets, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            preSets = preSets || {};
            preSets.cacheKey = preSets.cacheKey || _this.getCallWSCacheKey(method, data);
            return site.read(method, data, preSets);
        });
    };
    /**
     * Given the result of a init get_content and, optionally, the result of another get_content,
     * build an object with the data to pass to the JS of the get_content.
     *
     * @param {any} initResult Result of the init WS call.
     * @param {any} [contentResult] Result of the content WS call (if any).
     * @return {any} An object with the data to pass to the JS.
     */
    CoreSitePluginsProvider.prototype.createDataForJS = function (initResult, contentResult) {
        var data;
        if (initResult) {
            // First of all, add the data returned by the init JS (if any).
            data = this.utils.clone(initResult.jsResult || {});
            if (typeof data == 'boolean') {
                data = {};
            }
            // Now add some data returned by the init WS call.
            data.INIT_TEMPLATES = this.utils.objectToKeyValueMap(initResult.templates, 'id', 'html');
            data.INIT_OTHERDATA = initResult.otherdata;
        }
        if (contentResult) {
            // Now add the data returned by the content WS call.
            data.CONTENT_TEMPLATES = this.utils.objectToKeyValueMap(contentResult.templates, 'id', 'html');
            data.CONTENT_OTHERDATA = contentResult.otherdata;
        }
        return data;
    };
    /**
     * Get cache key for a WS call.
     *
     * @param {string} method Name of the method.
     * @param {any} data Data to identify the WS call.
     * @return {string} Cache key.
     */
    CoreSitePluginsProvider.prototype.getCallWSCacheKey = function (method, data) {
        return this.getCallWSCommonCacheKey(method) + ':' + this.utils.sortAndStringify(data);
    };
    /**
     * Get common cache key for a WS call.
     *
     * @param {string} method Name of the method.
     * @return {string} Cache key.
     */
    CoreSitePluginsProvider.prototype.getCallWSCommonCacheKey = function (method) {
        return this.ROOT_CACHE_KEY + 'ws:' + method;
    };
    /**
     * Get a certain content for a site plugin.
     *
     * @param {string} component Component where the class is. E.g. mod_assign.
     * @param {string} method Method to execute in the class.
     * @param {any} args The params for the method.
     * @param {CoreSiteWSPreSets} [preSets] Extra options.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the result.
     */
    CoreSitePluginsProvider.prototype.getContent = function (component, method, args, preSets, siteId) {
        var _this = this;
        this.logger.debug("Get content for component '" + component + "' and method '" + method + "'");
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Add some params that will always be sent.
            return _this.addDefaultArgs(args, site).then(function (argsToSend) {
                // Now call the WS.
                var data = {
                    component: component,
                    method: method,
                    args: _this.utils.objectToArrayOfObjects(argsToSend, 'name', 'value', true)
                };
                preSets = preSets || {};
                preSets.cacheKey = _this.getContentCacheKey(component, method, args);
                preSets.updateFrequency = typeof preSets.updateFrequency != 'undefined' ? preSets.updateFrequency :
                    __WEBPACK_IMPORTED_MODULE_6__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN;
                return _this.sitesProvider.getCurrentSite().read('tool_mobile_get_content', data, preSets);
            }).then(function (result) {
                if (result.otherdata) {
                    result.otherdata = _this.utils.objectToKeyValueMap(result.otherdata, 'name', 'value');
                    // Try to parse all properties that could be JSON encoded strings.
                    for (var name_1 in result.otherdata) {
                        var value = result.otherdata[name_1];
                        if (typeof value == 'string' && (value[0] == '{' || value[0] == '[')) {
                            result.otherdata[name_1] = _this.textUtils.parseJSON(value);
                        }
                    }
                }
                else {
                    result.otherdata = {};
                }
                return result;
            });
        });
    };
    /**
     * Get cache key for get content WS calls.
     *
     * @param {string} component Component where the class is. E.g. mod_assign.
     * @param {string} method Method to execute in the class.
     * @param {any} args The params for the method.
     * @return {string} Cache key.
     */
    CoreSitePluginsProvider.prototype.getContentCacheKey = function (component, method, args) {
        return this.ROOT_CACHE_KEY + 'content:' + component + ':' + method + ':' + this.utils.sortAndStringify(args);
    };
    /**
     * Get the value of a WS param for prefetch.
     *
     * @param {string} component The component of the handler.
     * @param {string} paramName Name of the param as defined by the handler.
     * @param {number} [courseId] Course ID (if prefetching a course).
     * @param {any} [module] The module object returned by WS (if prefetching a module).
     * @return {any} The value.
     */
    CoreSitePluginsProvider.prototype.getDownloadParam = function (component, paramName, courseId, module) {
        switch (paramName) {
            case 'courseids':
                // The WS needs the list of course IDs. Create the list.
                return [courseId];
            case component + 'id':
                // The WS needs the instance id.
                return module && module.instance;
            default:
        }
    };
    /**
     * Get the unique name of a handler (plugin + handler).
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler inside the plugin.
     * @return {string} Unique name.
     */
    CoreSitePluginsProvider.prototype.getHandlerUniqueName = function (plugin, handlerName) {
        return plugin.addon + '_' + handlerName;
    };
    /**
     * Get a site plugin handler.
     *
     * @param {string} name Unique name of the handler.
     * @return {CoreSitePluginsHandler} Handler.
     */
    CoreSitePluginsProvider.prototype.getSitePluginHandler = function (name) {
        return this.sitePlugins[name];
    };
    /**
     * Invalidate all WS call to a certain method.
     *
     * @param {string} method WS method to use.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreSitePluginsProvider.prototype.invalidateAllCallWSForMethod = function (method, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getCallWSCommonCacheKey(method));
        });
    };
    /**
     * Invalidate a WS call.
     *
     * @param {string} method WS method to use.
     * @param {any} data Data to send to the WS.
     * @param {CoreSiteWSPreSets} [preSets] Extra options.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreSitePluginsProvider.prototype.invalidateCallWS = function (method, data, preSets, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(preSets.cacheKey || _this.getCallWSCacheKey(method, data));
        });
    };
    /**
     * Invalidate a page content.
     *
     * @param {string} component Component where the class is. E.g. mod_assign.
     * @param {string} method Method to execute in the class.
     * @param {any} args The params for the method.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreSitePluginsProvider.prototype.invalidateContent = function (component, callback, args, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getContentCacheKey(component, callback, args));
        });
    };
    /**
     * Check if the get content WS is available.
     *
     * @param {CoreSite} site The site to check. If not defined, current site.
     */
    CoreSitePluginsProvider.prototype.isGetContentAvailable = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.wsAvailable('tool_mobile_get_content');
    };
    /**
     * Check if a handler is enabled for a certain course.
     *
     * @param {number} courseId Course ID to check.
     * @param {boolean} [restrictEnrolled] If true or undefined, handler is only enabled for courses the user is enrolled in.
     * @param {any} [restrict] Users and courses the handler is restricted to.
     * @return {boolean | Promise<boolean>} Whether the handler is enabled.
     */
    CoreSitePluginsProvider.prototype.isHandlerEnabledForCourse = function (courseId, restrictEnrolled, restrict) {
        if (restrict && restrict.courses && restrict.courses.indexOf(courseId) == -1) {
            // Course is not in the list of restricted courses.
            return false;
        }
        if (restrictEnrolled || typeof restrictEnrolled == 'undefined') {
            // Only enabled for courses the user is enrolled to. Check if the user is enrolled in the course.
            return this.coursesProvider.getUserCourse(courseId, true).then(function () {
                return true;
            }).catch(function () {
                return false;
            });
        }
        return true;
    };
    /**
     * Check if a handler is enabled for a certain user.
     *
     * @param {number} userId User ID to check.
     * @param {boolean} [restrictCurrent] Whether handler is only enabled for current user.
     * @param {any} [restrict] Users and courses the handler is restricted to.
     * @return {boolean} Whether the handler is enabled.
     */
    CoreSitePluginsProvider.prototype.isHandlerEnabledForUser = function (userId, restrictCurrent, restrict) {
        if (restrictCurrent && userId != this.sitesProvider.getCurrentSite().getUserId()) {
            // Only enabled for current user.
            return false;
        }
        if (restrict && restrict.users && restrict.users.indexOf(userId) == -1) {
            // User is not in the list of restricted users.
            return false;
        }
        return true;
    };
    /**
     * Load other data into args as determined by useOtherData list.
     * If useOtherData is undefined, it won't add any data.
     * If useOtherData is defined but empty (null, false or empty string) it will copy all the data from otherData to args.
     * If useOtherData is an array, it will only copy the properties whose names are in the array.
     *
     * @param {any} args The current args.
     * @param {any} otherData All the other data.
     * @param {any[]} useOtherData Names of the attributes to include.
     * @return {any} New args.
     */
    CoreSitePluginsProvider.prototype.loadOtherDataInArgs = function (args, otherData, useOtherData) {
        if (!args) {
            args = {};
        }
        else {
            args = this.utils.clone(args);
        }
        otherData = otherData || {};
        if (typeof useOtherData == 'undefined') {
            // No need to add other data, return args as they are.
            return args;
        }
        else if (!useOtherData) {
            // Use other data is defined but empty. Add all the data to args.
            for (var name_2 in otherData) {
                args[name_2] = otherData[name_2];
            }
        }
        else {
            for (var i in useOtherData) {
                var name_3 = useOtherData[i];
                args[name_3] = otherData[name_3];
            }
        }
        return args;
    };
    /**
     * Prefetch offline functions for a site plugin handler.
     *
     * @param {string} component The component of the handler.
     * @param {any} args Params to send to the get_content calls.
     * @param {any} handlerSchema The handler schema.
     * @param {number} [courseId] Course ID (if prefetching a course).
     * @param {any} [module] The module object returned by WS (if prefetching a module).
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @param {CoreSite} [site] Site. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsProvider.prototype.prefetchFunctions = function (component, args, handlerSchema, courseId, module, prefetch, dirPath, site) {
        var _this = this;
        site = site || this.sitesProvider.getCurrentSite();
        var promises = [];
        for (var method in handlerSchema.offlinefunctions) {
            if (site.wsAvailable(method)) {
                // The method is a WS.
                var paramsList = handlerSchema.offlinefunctions[method], cacheKey = this.getCallWSCacheKey(method, args);
                var params = {};
                if (!paramsList.length) {
                    // No params defined, send the default ones.
                    params = args;
                }
                else {
                    for (var i in paramsList) {
                        var paramName = paramsList[i];
                        if (typeof args[paramName] != 'undefined') {
                            params[paramName] = args[paramName];
                        }
                        else {
                            // The param is not one of the default ones. Try to calculate the param to use.
                            var value = this.getDownloadParam(component, paramName, courseId, module);
                            if (typeof value != 'undefined') {
                                params[paramName] = value;
                            }
                        }
                    }
                }
                promises.push(this.callWS(method, params, { cacheKey: cacheKey }));
            }
            else {
                // It's a method to get content.
                promises.push(this.getContent(component, method, args).then(function (result) {
                    var subPromises = [];
                    // Prefetch the files in the content.
                    if (result.files && result.files.length) {
                        subPromises.push(_this.filepoolProvider.downloadOrPrefetchFiles(site.id, result.files, prefetch, false, component, module.id, dirPath));
                    }
                    return Promise.all(subPromises);
                }));
            }
        }
        return Promise.all(promises);
    };
    /**
     * Store a site plugin handler.
     *
     * @param {string} name A unique name to identify the handler.
     * @param {CoreSitePluginsHandler} handler Handler to set.
     */
    CoreSitePluginsProvider.prototype.setSitePluginHandler = function (name, handler) {
        this.sitePlugins[name] = handler;
    };
    /**
     * Store the promise for a plugin that is being initialised.
     *
     * @param {String} component
     * @param {Promise<any>} promise
     */
    CoreSitePluginsProvider.prototype.registerSitePluginPromise = function (component, promise) {
        this.sitePluginPromises[component] = promise;
    };
    /**
     * Set plugins fetched.
     */
    CoreSitePluginsProvider.prototype.setPluginsFetched = function () {
        this.fetchPluginsDeferred.resolve();
    };
    /**
     * Is a plugin being initialised for the specified component?
     *
     * @param {String} component
     * @return {boolean}
     */
    CoreSitePluginsProvider.prototype.sitePluginPromiseExists = function (component) {
        return this.sitePluginPromises.hasOwnProperty(component);
    };
    /**
     * Get the promise for a plugin that is being initialised.
     *
     * @param {String} component
     * @return {Promise<any>}
     */
    CoreSitePluginsProvider.prototype.sitePluginLoaded = function (component) {
        return this.sitePluginPromises[component];
    };
    /**
     * Wait for fetch plugins to be done.
     *
     * @return {Promise<any>} Promise resolved when site plugins have been fetched.
     */
    CoreSitePluginsProvider.prototype.waitFetchPlugins = function () {
        return this.fetchPluginsDeferred.promise;
    };
    CoreSitePluginsProvider.COMPONENT = 'CoreSitePlugins';
    CoreSitePluginsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_11__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_12__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreSitePluginsProvider);
    return CoreSitePluginsProvider;
}());

//# sourceMappingURL=siteplugins.js.map

/***/ }),
/* 46 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/*
 * Service that provides some features regarding synchronization.
*/
var CoreSyncProvider = /** @class */ (function () {
    function CoreSyncProvider(eventsProvider, sitesProvider) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        // Variables for the database.
        this.SYNC_TABLE = 'sync';
        this.siteSchema = {
            name: 'CoreSyncProvider',
            version: 1,
            tables: [
                {
                    name: this.SYNC_TABLE,
                    columns: [
                        {
                            name: 'component',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'id',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'time',
                            type: 'INTEGER'
                        },
                        {
                            name: 'warnings',
                            type: 'TEXT'
                        }
                    ],
                    primaryKeys: ['component', 'id']
                }
            ]
        };
        // Store blocked sync objects.
        this.blockedItems = {};
        this.sitesProvider.registerSiteSchema(this.siteSchema);
        // Unblock all blocks on logout.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__events__["a" /* CoreEventsProvider */].LOGOUT, function (data) {
            _this.clearAllBlocks(data.siteId);
        });
    }
    /**
     * Block a component and ID so it cannot be synchronized.
     *
     * @param {string} component Component name.
     * @param {string | number} id Unique ID per component.
     * @param {string} [operation] Operation name. If not defined, a default text is used.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreSyncProvider.prototype.blockOperation = function (component, id, operation, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var uniqueId = this.getUniqueSyncBlockId(component, id);
        if (!this.blockedItems[siteId]) {
            this.blockedItems[siteId] = {};
        }
        if (!this.blockedItems[siteId][uniqueId]) {
            this.blockedItems[siteId][uniqueId] = {};
        }
        operation = operation || '-';
        this.blockedItems[siteId][uniqueId][operation] = true;
    };
    /**
     * Clear all blocks for a site or all sites.
     *
     * @param {string} [siteId] If set, clear the blocked objects only for this site. Otherwise clear them for all sites.
     */
    CoreSyncProvider.prototype.clearAllBlocks = function (siteId) {
        if (siteId) {
            delete this.blockedItems[siteId];
        }
        else {
            this.blockedItems = {};
        }
    };
    /**
     * Clear all blocks for a certain component.
     *
     * @param {string} component Component name.
     * @param {string | number} id Unique ID per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreSyncProvider.prototype.clearBlocks = function (component, id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var uniqueId = this.getUniqueSyncBlockId(component, id);
        if (this.blockedItems[siteId]) {
            delete this.blockedItems[siteId][uniqueId];
        }
    };
    /**
     * Returns a sync record.
     * @param  {string}           component Component name.
     * @param  {string | number}  id        Unique ID per component.
     * @param  {string}           [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>}     Record if found or reject.
     */
    CoreSyncProvider.prototype.getSyncRecord = function (component, id, siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getRecord(_this.SYNC_TABLE, { component: component, id: id });
        });
    };
    /**
     * Inserts or Updates info of a sync record.
     * @param  {string}           component Component name.
     * @param  {string | number}  id        Unique ID per component.
     * @param  {any}              data      Data that updates the record.
     * @param  {string}           [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>}     Promise resolved with done.
     */
    CoreSyncProvider.prototype.insertOrUpdateSyncRecord = function (component, id, data, siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            data.component = component;
            data.id = id;
            return db.insertRecord(_this.SYNC_TABLE, data);
        });
    };
    /**
     * Convenience function to create unique identifiers for a component and id.
     *
     * @param {string} component Component name.
     * @param {string | number} id Unique ID per component.
     * @return {string} Unique sync id.
     */
    CoreSyncProvider.prototype.getUniqueSyncBlockId = function (component, id) {
        return component + '#' + id;
    };
    /**
     * Check if a component is blocked.
     * One block can have different operations. Here we check how many operations are being blocking the object.
     *
     * @param {string} component Component name.
     * @param {string | number} id Unique ID per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean} Whether it's blocked.
     */
    CoreSyncProvider.prototype.isBlocked = function (component, id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!this.blockedItems[siteId]) {
            return false;
        }
        var uniqueId = this.getUniqueSyncBlockId(component, id);
        if (!this.blockedItems[siteId][uniqueId]) {
            return false;
        }
        return Object.keys(this.blockedItems[siteId][uniqueId]).length > 0;
    };
    /**
     * Unblock an operation on a component and ID.
     *
     * @param {string} component Component name.
     * @param {string | number} id Unique ID per component.
     * @param {string} [operation] Operation name. If not defined, a default text is used.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreSyncProvider.prototype.unblockOperation = function (component, id, operation, siteId) {
        operation = operation || '-';
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var uniqueId = this.getUniqueSyncBlockId(component, id);
        if (this.blockedItems[siteId] && this.blockedItems[siteId][uniqueId]) {
            delete this.blockedItems[siteId][uniqueId][operation];
        }
    };
    CoreSyncProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_2__sites__["a" /* CoreSitesProvider */]])
    ], CoreSyncProvider);
    return CoreSyncProvider;
}());

//# sourceMappingURL=sync.js.map

/***/ }),
/* 47 */,
/* 48 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGroupsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/*
 * Service to handle groups.
*/
var CoreGroupsProvider = /** @class */ (function () {
    function CoreGroupsProvider(sitesProvider, translate, coursesProvider) {
        this.sitesProvider = sitesProvider;
        this.translate = translate;
        this.coursesProvider = coursesProvider;
        this.ROOT_CACHE_KEY = 'mmGroups:';
    }
    CoreGroupsProvider_1 = CoreGroupsProvider;
    /**
     * Check if group mode of an activity is enabled.
     *
     * @param {number} cmId Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<boolean>} Promise resolved with true if the activity has groups, resolved with false otherwise.
     */
    CoreGroupsProvider.prototype.activityHasGroups = function (cmId, siteId, ignoreCache) {
        return this.getActivityGroupMode(cmId, siteId, ignoreCache).then(function (groupmode) {
            return groupmode === CoreGroupsProvider_1.SEPARATEGROUPS || groupmode === CoreGroupsProvider_1.VISIBLEGROUPS;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Get the groups allowed in an activity.
     *
     * @param {number} cmId Course module ID.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>} Promise resolved when the groups are retrieved.
     */
    CoreGroupsProvider.prototype.getActivityAllowedGroups = function (cmId, userId, siteId, ignoreCache) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                cmid: cmId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getActivityAllowedGroupsCacheKey(cmId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('core_group_get_activity_allowed_groups', params, preSets).then(function (response) {
                if (!response || !response.groups) {
                    return Promise.reject(null);
                }
                return response.groups;
            });
        });
    };
    /**
     * Get cache key for group mode WS calls.
     *
     * @param {number} cmId Course module ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    CoreGroupsProvider.prototype.getActivityAllowedGroupsCacheKey = function (cmId, userId) {
        return this.ROOT_CACHE_KEY + 'allowedgroups:' + cmId + ':' + userId;
    };
    /**
     * Get the groups allowed in an activity if they are allowed.
     *
     * @param {number} cmId Course module ID.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any[]>} Promise resolved when the groups are retrieved. If not allowed, empty array will be returned.
     */
    CoreGroupsProvider.prototype.getActivityAllowedGroupsIfEnabled = function (cmId, userId, siteId, ignoreCache) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Get real groupmode, in case it's forced by the course.
        return this.activityHasGroups(cmId, siteId, ignoreCache).then(function (hasGroups) {
            if (hasGroups) {
                // Get the groups available for the user.
                return _this.getActivityAllowedGroups(cmId, userId, siteId, ignoreCache);
            }
            return [];
        });
    };
    /**
     * Helper function to get activity group info (group mode and list of groups).
     *
     * @param {number} cmId Course module ID.
     * @param {boolean} [addAllParts=true] Whether to add the all participants option. Always true for visible groups.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<CoreGroupInfo>} Promise resolved with the group info.
     */
    CoreGroupsProvider.prototype.getActivityGroupInfo = function (cmId, addAllParts, userId, siteId, ignoreCache) {
        var _this = this;
        if (addAllParts === void 0) { addAllParts = true; }
        var groupInfo = {
            groups: []
        };
        return this.getActivityGroupMode(cmId, siteId, ignoreCache).then(function (groupMode) {
            groupInfo.separateGroups = groupMode === CoreGroupsProvider_1.SEPARATEGROUPS;
            groupInfo.visibleGroups = groupMode === CoreGroupsProvider_1.VISIBLEGROUPS;
            if (groupInfo.separateGroups || groupInfo.visibleGroups) {
                return _this.getActivityAllowedGroups(cmId, userId, siteId, ignoreCache);
            }
            return [];
        }).then(function (groups) {
            if (groups.length <= 0) {
                groupInfo.separateGroups = false;
                groupInfo.visibleGroups = false;
            }
            else {
                if (addAllParts || groupInfo.visibleGroups) {
                    groupInfo.groups.push({ id: 0, name: _this.translate.instant('core.allparticipants') });
                }
                groupInfo.groups = groupInfo.groups.concat(groups);
            }
            return groupInfo;
        });
    };
    /**
     * Get the group mode of an activity.
     *
     * @param {number} cmId Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<number>} Promise resolved when the group mode is retrieved.
     */
    CoreGroupsProvider.prototype.getActivityGroupMode = function (cmId, siteId, ignoreCache) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                cmid: cmId
            }, preSets = {
                cacheKey: _this.getActivityGroupModeCacheKey(cmId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('core_group_get_activity_groupmode', params, preSets).then(function (response) {
                if (!response || typeof response.groupmode == 'undefined') {
                    return Promise.reject(null);
                }
                return response.groupmode;
            });
        });
    };
    /**
     * Get cache key for group mode WS calls.
     *
     * @param {number} cmId Course module ID.
     * @return {string} Cache key.
     */
    CoreGroupsProvider.prototype.getActivityGroupModeCacheKey = function (cmId) {
        return this.ROOT_CACHE_KEY + 'groupmode:' + cmId;
    };
    /**
     * Get user groups in all the user enrolled courses.
     *
     * @param {string} [siteId] Site to get the groups from. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved when the groups are retrieved.
     */
    CoreGroupsProvider.prototype.getAllUserGroups = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            siteId = siteId || site.getId();
            if (site.isVersionGreaterEqualThan('3.6')) {
                return _this.getUserGroupsInCourse(0, siteId);
            }
            return _this.coursesProvider.getUserCourses(false, siteId).then(function (courses) {
                courses.push({ id: site.getSiteHomeId() }); // Add front page.
                return _this.getUserGroups(courses, siteId);
            });
        });
    };
    /**
     * Get user groups in all the supplied courses.
     *
     * @param {any[]} courses List of courses or course ids to get the groups from.
     * @param {string} [siteId] Site to get the groups from. If not defined, use current site.
     * @param {number} [userId] ID of the user. If not defined, use the userId related to siteId.
     * @return {Promise<any[]>} Promise resolved when the groups are retrieved.
     */
    CoreGroupsProvider.prototype.getUserGroups = function (courses, siteId, userId) {
        var _this = this;
        // Get all courses one by one.
        var promises = courses.map(function (course) {
            var courseId = typeof course == 'object' ? course.id : course;
            return _this.getUserGroupsInCourse(courseId, siteId, userId);
        });
        return Promise.all(promises).then(function (courseGroups) {
            return [].concat.apply([], courseGroups);
        });
    };
    /**
     * Get user groups in a course.
     *
     * @param {number} courseId ID of the course. 0 to get all enrolled courses groups (Moodle version > 3.6).
     * @param {string} [siteId] Site to get the groups from. If not defined, use current site.
     * @param {number} [userId] ID of the user. If not defined, use ID related to siteid.
     * @return {Promise<any[]>} Promise resolved when the groups are retrieved.
     */
    CoreGroupsProvider.prototype.getUserGroupsInCourse = function (courseId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var data = {
                userid: userId,
                courseid: courseId
            }, preSets = {
                cacheKey: _this.getUserGroupsInCourseCacheKey(courseId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_group_get_course_user_groups', data, preSets).then(function (response) {
                if (response && response.groups) {
                    return response.groups;
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Get prefix cache key for  user groups in course WS calls.
     *
     * @return {string} Prefix Cache key.
     */
    CoreGroupsProvider.prototype.getUserGroupsInCoursePrefixCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'courseGroups:';
    };
    /**
     * Get cache key for user groups in course WS calls.
     *
     * @param {number} courseId Course ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    CoreGroupsProvider.prototype.getUserGroupsInCourseCacheKey = function (courseId, userId) {
        return this.getUserGroupsInCoursePrefixCacheKey() + courseId + ':' + userId;
    };
    /**
     * Invalidates activity allowed groups.
     *
     * @param {number} cmId Course module ID.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreGroupsProvider.prototype.invalidateActivityAllowedGroups = function (cmId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getActivityAllowedGroupsCacheKey(cmId, userId));
        });
    };
    /**
     * Invalidates activity group mode.
     *
     * @param {number} cmId Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreGroupsProvider.prototype.invalidateActivityGroupMode = function (cmId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getActivityGroupModeCacheKey(cmId));
        });
    };
    /**
     * Invalidates all activity group info: mode and allowed groups.
     *
     * @param {number} cmId Course module ID.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreGroupsProvider.prototype.invalidateActivityGroupInfo = function (cmId, userId, siteId) {
        var promises = [];
        promises.push(this.invalidateActivityAllowedGroups(cmId, userId, siteId));
        promises.push(this.invalidateActivityGroupMode(cmId, siteId));
        return Promise.all(promises);
    };
    /**
     * Invalidates user groups in all user enrolled courses.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreGroupsProvider.prototype.invalidateAllUserGroups = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (site.isVersionGreaterEqualThan('3.6')) {
                return _this.invalidateUserGroupsInCourse(0, siteId);
            }
            return site.invalidateWsCacheForKeyStartingWith(_this.getUserGroupsInCoursePrefixCacheKey());
        });
    };
    /**
     * Invalidates user groups in courses.
     *
     * @param {any[]} courses List of courses or course ids.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreGroupsProvider.prototype.invalidateUserGroups = function (courses, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var promises = courses.map(function (course) {
                var courseId = typeof course == 'object' ? course.id : course;
                return _this.invalidateUserGroupsInCourse(courseId, site.id, userId);
            });
            return Promise.all(promises);
        });
    };
    /**
     * Invalidates user groups in course.
     *
     * @param {number} courseId ID of the course. 0 to get all enrolled courses groups (Moodle version > 3.6).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreGroupsProvider.prototype.invalidateUserGroupsInCourse = function (courseId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getUserGroupsInCourseCacheKey(courseId, userId));
        });
    };
    // Group mode constants.
    CoreGroupsProvider.NOGROUPS = 0;
    CoreGroupsProvider.SEPARATEGROUPS = 1;
    CoreGroupsProvider.VISIBLEGROUPS = 2;
    CoreGroupsProvider = CoreGroupsProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreGroupsProvider);
    return CoreGroupsProvider;
    var CoreGroupsProvider_1;
}());

//# sourceMappingURL=groups.js.map

/***/ }),
/* 49 */,
/* 50 */,
/* 51 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContentLinksModuleIndexHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(28);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Handler to handle URLs pointing to the index of a module.
 */
var CoreContentLinksModuleIndexHandler = /** @class */ (function (_super) {
    __extends(CoreContentLinksModuleIndexHandler, _super);
    /**
     * Construct the handler.
     *
     * @param {CoreCourseHelperProvider} courseHelper The CoreCourseHelperProvider instance.
     * @param {string} addon Name of the addon as it's registered in course delegate. It'll be used to check if it's disabled.
     * @param {string} modName Name of the module (assign, book, ...).
     */
    function CoreContentLinksModuleIndexHandler(courseHelper, addon, modName) {
        var _this = _super.call(this) || this;
        _this.courseHelper = courseHelper;
        _this.addon = addon;
        _this.modName = modName;
        /**
         * If this boolean is set to true, the app will retrieve all modules with this modName with a single WS call.
         * This reduces the number of WS calls, but it isn't recommended for modules that can return a lot of contents.
         * @type {boolean}
         */
        _this.useModNameToGetModule = false;
        // Match the view.php URL with an id param.
        _this.pattern = new RegExp('\/mod\/' + modName + '\/view\.php.*([\&\?]id=\\d+)');
        _this.featureName = 'CoreCourseModuleDelegate_' + addon;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreContentLinksModuleIndexHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    _this.courseHelper.navigateToModule(parseInt(params.id, 10), siteId, courseId, undefined, _this.useModNameToGetModule ? _this.modName : undefined);
                }
            }];
    };
    return CoreContentLinksModuleIndexHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=module-index-handler.js.map

/***/ }),
/* 52 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLoginHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_siteplugins_providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_19_ts_md5_dist_md5__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




















/**
 * Helper provider that provides some common features regarding authentication.
 */
var CoreLoginHelperProvider = /** @class */ (function () {
    function CoreLoginHelperProvider(logger, sitesProvider, domUtils, wsProvider, translate, textUtils, eventsProvider, appProvider, utils, urlUtils, configProvider, platform, initDelegate, sitePluginsProvider, location, alertCtrl, courseProvider) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.domUtils = domUtils;
        this.wsProvider = wsProvider;
        this.translate = translate;
        this.textUtils = textUtils;
        this.eventsProvider = eventsProvider;
        this.appProvider = appProvider;
        this.utils = utils;
        this.urlUtils = urlUtils;
        this.configProvider = configProvider;
        this.platform = platform;
        this.initDelegate = initDelegate;
        this.sitePluginsProvider = sitePluginsProvider;
        this.location = location;
        this.alertCtrl = alertCtrl;
        this.courseProvider = courseProvider;
        this.isSSOConfirmShown = false;
        this.isOpenEditAlertShown = false;
        this.waitingForBrowser = false;
        this.logger = logger.getInstance('CoreLoginHelper');
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */].MAIN_MENU_OPEN, function () {
            /* If there is any page pending to be opened, do it now. Don't open pages stored more than 5 seconds ago, probably
               the function to open the page was called when it shouldn't. */
            if (_this.pageToLoad && Date.now() - _this.pageToLoad.time < 5000) {
                _this.loadPageInMainMenu(_this.pageToLoad.page, _this.pageToLoad.params);
                delete _this.pageToLoad;
            }
        });
    }
    CoreLoginHelperProvider_1 = CoreLoginHelperProvider;
    /**
     * Accept site policy.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success, rejected if failure.
     */
    CoreLoginHelperProvider.prototype.acceptSitePolicy = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.write('core_user_agree_site_policy', {}).then(function (result) {
                if (!result.status) {
                    // Error.
                    if (result.warnings && result.warnings.length) {
                        // Check if there is a warning 'alreadyagreed'.
                        for (var i in result.warnings) {
                            var warning = result.warnings[i];
                            if (warning.warningcode == 'alreadyagreed') {
                                // Policy already agreed, treat it as a success.
                                return;
                            }
                        }
                        // Another warning, reject.
                        return Promise.reject(result.warnings[0]);
                    }
                    else {
                        return Promise.reject(null);
                    }
                }
            });
        });
    };
    /**
     * Function to handle URL received by Custom URL Scheme. If it's a SSO login, perform authentication.
     *
     * @param {string} url URL received.
     * @return {boolean} True if it's a SSO URL, false otherwise.
     * @deprecated Please use CoreCustomURLSchemesProvider.handleCustomURL instead.
     */
    CoreLoginHelperProvider.prototype.appLaunchedByURL = function (url) {
        var _this = this;
        var ssoScheme = __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://token=';
        if (url.indexOf(ssoScheme) == -1) {
            return false;
        }
        if (this.appProvider.isSSOAuthenticationOngoing()) {
            // Authentication ongoing, probably duplicated request.
            return true;
        }
        if (this.appProvider.isDesktop()) {
            // In desktop, make sure InAppBrowser is closed.
            this.utils.closeInAppBrowser(true);
        }
        // App opened using custom URL scheme. Probably an SSO authentication.
        this.appProvider.startSSOAuthentication();
        this.logger.debug('App launched by URL with an SSO');
        // Delete the sso scheme from the URL.
        url = url.replace(ssoScheme, '');
        // Some platforms like Windows add a slash at the end. Remove it.
        // Some sites add a # at the end of the URL. If it's there, remove it.
        url = url.replace(/\/?#?\/?$/, '');
        // Decode from base64.
        try {
            url = atob(url);
        }
        catch (err) {
            // Error decoding the parameter.
            this.logger.error('Error decoding parameter received for login SSO');
            return false;
        }
        var siteData, modal;
        // Wait for app to be ready.
        this.initDelegate.ready().then(function () {
            modal = _this.domUtils.showModalLoading('core.login.authenticating', true);
            return _this.validateBrowserSSOLogin(url);
        }).then(function (data) {
            siteData = data;
            return _this.handleSSOLoginAuthentication(siteData.siteUrl, siteData.token, siteData.privateToken);
        }).then(function () {
            if (siteData.pageName) {
                // State defined, go to that state instead of site initial page.
                _this.appProvider.getRootNavController().push(siteData.pageName, siteData.pageParams);
            }
            else {
                _this.goToSiteInitialPage();
            }
        }).catch(function (error) {
            if (error) {
                // An error occurred, display the error and logout the user.
                _this.treatUserTokenError(siteData.siteUrl, error);
                _this.sitesProvider.logout();
            }
        }).finally(function () {
            modal.dismiss();
            _this.appProvider.finishSSOAuthentication();
        });
        return true;
    };
    /**
     * Check if a site allows requesting a password reset through the app.
     *
     * @param {string} siteUrl URL of the site.
     * @return {Promise<any>} Promise resolved with boolean: whether can be done through the app.
     */
    CoreLoginHelperProvider.prototype.canRequestPasswordReset = function (siteUrl) {
        return this.requestPasswordReset(siteUrl).then(function () {
            return true;
        }).catch(function (error) {
            return error.available == 1 || (typeof error.errorcode != 'undefined' && error.errorcode != 'invalidrecord' &&
                error.errorcode != '');
        });
    };
    /**
     * Function called when an SSO InAppBrowser is closed or the app is resumed. Check if user needs to be logged out.
     */
    CoreLoginHelperProvider.prototype.checkLogout = function () {
        var navCtrl = this.appProvider.getRootNavController();
        if (!this.appProvider.isSSOAuthenticationOngoing() && this.sitesProvider.isLoggedIn() &&
            this.sitesProvider.getCurrentSite().isLoggedOut() && navCtrl.getActive().name == 'CoreLoginReconnectPage') {
            // User must reauthenticate but he closed the InAppBrowser without doing so, logout him.
            this.sitesProvider.logout();
        }
    };
    /**
     * Show a confirm modal if needed and open a browser to perform SSO login.
     *
     * @param  {string} siteurl     URL of the site where the SSO login will be performed.
     * @param  {number} typeOfLogin CoreConstants.LOGIN_SSO_CODE or CoreConstants.LOGIN_SSO_INAPP_CODE.
     * @param  {string} [service]   The service to use. If not defined, external service will be used.
     * @param  {string} [launchUrl] The URL to open for SSO. If not defined, local_mobile launch URL will be used.
     * @return {Void}
     */
    CoreLoginHelperProvider.prototype.confirmAndOpenBrowserForSSOLogin = function (siteUrl, typeOfLogin, service, launchUrl) {
        var _this = this;
        // Show confirm only if it's needed. Treat "false" (string) as false to prevent typing errors.
        var showConfirmation = this.shouldShowSSOConfirm(typeOfLogin);
        var promise;
        if (showConfirmation) {
            promise = this.domUtils.showConfirm(this.translate.instant('core.login.logininsiterequired'));
        }
        else {
            promise = Promise.resolve();
        }
        promise.then(function () {
            _this.openBrowserForSSOLogin(siteUrl, typeOfLogin, service, launchUrl);
        }).catch(function () {
            // User cancelled, ignore.
        });
    };
    /**
     * Format profile fields, filtering the ones that shouldn't be shown on signup and classifying them in categories.
     *
     * @param {any[]} profileFields Profile fields to format.
     * @return {any} Categories with the fields to show in each one.
     */
    CoreLoginHelperProvider.prototype.formatProfileFieldsForSignup = function (profileFields) {
        if (!profileFields) {
            return [];
        }
        var categories = {};
        profileFields.forEach(function (field) {
            if (!field.signup) {
                // Not a signup field, ignore it.
                return;
            }
            if (!categories[field.categoryid]) {
                categories[field.categoryid] = {
                    id: field.categoryid,
                    name: field.categoryname,
                    fields: []
                };
            }
            categories[field.categoryid].fields.push(field);
        });
        return Object.keys(categories).map(function (index) {
            return categories[index];
        });
    };
    /**
     * Builds an object with error messages for some common errors.
     * Please notice that this function doesn't support all possible error types.
     *
     * @param {string} [requiredMsg] Code of the string for required error.
     * @param {string} [emailMsg] Code of the string for invalid email error.
     * @param {string} [patternMsg] Code of the string for pattern not match error.
     * @param {string} [urlMsg] Code of the string for invalid url error.
     * @param {string} [minlengthMsg] Code of the string for "too short" error.
     * @param {string} [maxlengthMsg] Code of the string for "too long" error.
     * @param {string} [minMsg] Code of the string for min value error.
     * @param {string} [maxMsg] Code of the string for max value error.
     * @return {any} Object with the errors.
     */
    CoreLoginHelperProvider.prototype.getErrorMessages = function (requiredMsg, emailMsg, patternMsg, urlMsg, minlengthMsg, maxlengthMsg, minMsg, maxMsg) {
        var errors = {};
        if (requiredMsg) {
            errors.required = errors.requiredTrue = this.translate.instant(requiredMsg);
        }
        if (emailMsg) {
            errors.email = this.translate.instant(emailMsg);
        }
        if (patternMsg) {
            errors.pattern = this.translate.instant(patternMsg);
        }
        if (urlMsg) {
            errors.url = this.translate.instant(urlMsg);
        }
        if (minlengthMsg) {
            errors.minlength = this.translate.instant(minlengthMsg);
        }
        if (maxlengthMsg) {
            errors.maxlength = this.translate.instant(maxlengthMsg);
        }
        if (minMsg) {
            errors.min = this.translate.instant(minMsg);
        }
        if (maxMsg) {
            errors.max = this.translate.instant(maxMsg);
        }
        return errors;
    };
    /**
     * Get the site policy.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the site policy.
     */
    CoreLoginHelperProvider.prototype.getSitePolicy = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Try to get the latest config, maybe the site policy was just added or has changed.
            return site.getConfig('sitepolicy', true).then(function (sitePolicy) {
                return sitePolicy ? sitePolicy : Promise.reject(null);
            }, function () {
                // Cannot get config, try to get the site policy using auth_email_get_signup_settings.
                return _this.wsProvider.callAjax('auth_email_get_signup_settings', {}, { siteUrl: site.getURL() })
                    .then(function (settings) {
                    return settings.sitepolicy ? settings.sitepolicy : Promise.reject(null);
                });
            });
        });
    };
    /**
     * Get fixed site or sites.
     *
     * @return {string|any[]} Fixed site or list of fixed sites.
     */
    CoreLoginHelperProvider.prototype.getFixedSites = function () {
        return __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl;
    };
    /**
     * Get the valid identity providers from a site config.
     *
     * @param {any} siteConfig Site's public config.
     * @return {any[]} Valid identity providers.
     */
    CoreLoginHelperProvider.prototype.getValidIdentityProviders = function (siteConfig) {
        var validProviders = [], httpUrl = this.textUtils.concatenatePaths(siteConfig.wwwroot, 'auth/oauth2/'), httpsUrl = this.textUtils.concatenatePaths(siteConfig.httpswwwroot, 'auth/oauth2/');
        if (siteConfig.identityproviders && siteConfig.identityproviders.length) {
            siteConfig.identityproviders.forEach(function (provider) {
                if (provider.url && (provider.url.indexOf(httpsUrl) != -1 || provider.url.indexOf(httpUrl) != -1)) {
                    validProviders.push(provider);
                }
            });
        }
        return validProviders;
    };
    /**
     * Go to the page to add a new site.
     * If a fixed URL is configured, go to credentials instead.
     *
     * @param {boolean} [setRoot] True to set the new page as root, false to add it to the stack.
     * @param {boolean} [showKeyboard] Whether to show keyboard in the new page. Only if no fixed URL set.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLoginHelperProvider.prototype.goToAddSite = function (setRoot, showKeyboard) {
        var pageName, params;
        if (this.isFixedUrlSet()) {
            // Fixed URL is set, go to credentials page.
            var url = typeof __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl == 'string' ?
                __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl : __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl[0].url;
            pageName = 'CoreLoginCredentialsPage';
            params = { siteUrl: url };
        }
        else {
            pageName = 'CoreLoginSitePage';
            params = {
                showKeyboard: showKeyboard
            };
        }
        if (setRoot) {
            return this.appProvider.getRootNavController().setRoot(pageName, params, { animate: false });
        }
        else {
            return this.appProvider.getRootNavController().push(pageName, params);
        }
    };
    /**
     * Open a page that doesn't belong to any site.
     *
     * @param {NavController} [navCtrl] Nav Controller.
     * @param {string} [page] Page to open.
     * @param {any} [params] Params of the page.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLoginHelperProvider.prototype.goToNoSitePage = function (navCtrl, page, params) {
        navCtrl = navCtrl || this.appProvider.getRootNavController();
        if (page == 'CoreLoginSitesPage') {
            // Just open the page as root.
            return navCtrl.setRoot(page, params);
        }
        else {
            // Check if there is any site stored.
            return this.sitesProvider.hasSites().then(function (hasSites) {
                if (hasSites) {
                    // There are sites stored, open sites page first to be able to go back.
                    navCtrl.setRoot('CoreLoginSitesPage');
                    return navCtrl.push(page, params, { animate: false });
                }
                else {
                    if (page != 'CoreLoginSitePage') {
                        // Open the new site page to be able to go back.
                        navCtrl.setRoot('CoreLoginSitePage');
                        return navCtrl.push(page, params, { animate: false });
                    }
                    else {
                        // Just open the page as root.
                        return navCtrl.setRoot(page, params);
                    }
                }
            });
        }
    };
    /**
     * Go to the initial page of a site depending on 'userhomepage' setting.
     *
     * @param {NavController} [navCtrl] NavController to use. Defaults to app root NavController.
     * @param {string} [page] Name of the page to load after loading the main page.
     * @param {any} [params] Params to pass to the page.
     * @param {NavOptions} [options] Navigation options.
     * @param {string} [url] URL to open once the main menu is loaded.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLoginHelperProvider.prototype.goToSiteInitialPage = function (navCtrl, page, params, options, url) {
        return this.openMainMenu(navCtrl, page, params, options, url);
    };
    /**
     * Convenient helper to handle authentication in the app using a token received by SSO login. If it's a new account,
     * the site is stored and the user is authenticated. If the account already exists, update its token.
     *
     * @param {string} siteUrl Site's URL.
     * @param {string} token User's token.
     * @param {string} [privateToken] User's private token.
     * @return {Promise<any>} Promise resolved when the user is authenticated with the token.
     */
    CoreLoginHelperProvider.prototype.handleSSOLoginAuthentication = function (siteUrl, token, privateToken) {
        // Always create a new site to prevent overriding data if another user credentials were introduced.
        return this.sitesProvider.newSite(siteUrl, token, privateToken);
    };
    /**
     * Check if the app is configured to use several fixed URLs.
     *
     * @return {boolean} Whether there are several fixed URLs.
     */
    CoreLoginHelperProvider.prototype.hasSeveralFixedSites = function () {
        return __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl && Array.isArray(__WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl) &&
            __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl.length > 1;
    };
    /**
     * Function called when a page starts loading in any InAppBrowser window.
     *
     * @param {string} url Loaded url.
     * @deprecated
     */
    CoreLoginHelperProvider.prototype.inAppBrowserLoadStart = function (url) {
        // This function is deprecated.
    };
    /**
     * Given a site public config, check if email signup is disabled.
     *
     * @param {any} config Site public config.
     * @return {boolean} Whether email signup is disabled.
     */
    CoreLoginHelperProvider.prototype.isEmailSignupDisabled = function (config) {
        var disabledFeatures = config && config.tool_mobile_disabledfeatures;
        if (!disabledFeatures) {
            return false;
        }
        disabledFeatures = this.textUtils.treatDisabledFeatures(disabledFeatures);
        var regEx = new RegExp('(,|^)CoreLoginEmailSignup(,|$)', 'g');
        return !!disabledFeatures.match(regEx);
    };
    /**
     * Check if the app is configured to use a fixed URL (only 1).
     *
     * @return {boolean} Whether there is 1 fixed URL.
     */
    CoreLoginHelperProvider.prototype.isFixedUrlSet = function () {
        if (Array.isArray(__WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl)) {
            return __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl.length == 1;
        }
        return !!__WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].siteurl;
    };
    /**
     * Check if current site is logged out, triggering mmCoreEventSessionExpired if it is.
     *
     * @param {string} [pageName] Name of the page to go once authenticated if logged out. If not defined, site initial page.
     * @param {any} [params] Params of the page to go once authenticated if logged out.
     * @return {boolean} True if user is logged out, false otherwise.
     */
    CoreLoginHelperProvider.prototype.isSiteLoggedOut = function (pageName, params) {
        var site = this.sitesProvider.getCurrentSite();
        if (!site) {
            return false;
        }
        if (site.isLoggedOut()) {
            this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */].SESSION_EXPIRED, {
                pageName: pageName,
                params: params
            }, site.getId());
            return true;
        }
        return false;
    };
    /**
     * Check if SSO login should use an embedded browser.
     *
     * @param {number} code Code to check.
     * @return {boolean} True if embedded browser, false othwerise.
     */
    CoreLoginHelperProvider.prototype.isSSOEmbeddedBrowser = function (code) {
        if (this.appProvider.isLinux()) {
            // In Linux desktop app, always use embedded browser.
            return true;
        }
        return code == __WEBPACK_IMPORTED_MODULE_18__core_constants__["a" /* CoreConstants */].LOGIN_SSO_INAPP_CODE;
    };
    /**
     * Check if SSO login is needed based on code returned by the WS.
     *
     * @param {number} code Code to check.
     * @return {boolean} True if SSO login is needed, false othwerise.
     */
    CoreLoginHelperProvider.prototype.isSSOLoginNeeded = function (code) {
        return code == __WEBPACK_IMPORTED_MODULE_18__core_constants__["a" /* CoreConstants */].LOGIN_SSO_CODE || code == __WEBPACK_IMPORTED_MODULE_18__core_constants__["a" /* CoreConstants */].LOGIN_SSO_INAPP_CODE;
    };
    /**
     * Load a site and load a certain page in that site.
     *
     * @param {string} page Name of the page to load.
     * @param {any} params Params to pass to the page.
     * @param {string} siteId Site to load.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLoginHelperProvider.prototype.loadSiteAndPage = function (page, params, siteId) {
        var _this = this;
        var navCtrl = this.appProvider.getRootNavController();
        if (siteId == __WEBPACK_IMPORTED_MODULE_18__core_constants__["a" /* CoreConstants */].NO_SITE_ID) {
            // Page doesn't belong to a site, just load the page.
            return navCtrl.setRoot(page, params);
        }
        else {
            var modal_1 = this.domUtils.showModalLoading();
            return this.sitesProvider.loadSite(siteId, page, params).then(function (loggedIn) {
                if (loggedIn) {
                    return _this.openMainMenu(navCtrl, page, params);
                }
            }).catch(function (error) {
                // Site doesn't exist.
                return navCtrl.setRoot('CoreLoginSitesPage');
            }).finally(function () {
                modal_1.dismiss();
            });
        }
    };
    /**
     * Load a certain page in the main menu page.
     *
     * @param {string} page Name of the page to load.
     * @param {any} params Params to pass to the page.
     */
    CoreLoginHelperProvider.prototype.loadPageInMainMenu = function (page, params) {
        if (!this.appProvider.isMainMenuOpen()) {
            // Main menu not open. Store the page to be loaded later.
            this.pageToLoad = {
                page: page,
                params: params,
                time: Date.now()
            };
            return;
        }
        if (page == CoreLoginHelperProvider_1.OPEN_COURSE) {
            // Use the openCourse function.
            this.courseProvider.openCourse(undefined, params.course, params);
        }
        else {
            this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */].LOAD_PAGE_MAIN_MENU, { redirectPage: page, redirectParams: params });
        }
    };
    /**
     * Open the main menu, loading a certain page.
     *
     * @param {NavController} navCtrl NavController.
     * @param {string} page Name of the page to load.
     * @param {any} params Params to pass to the page.
     * @param {NavOptions} [options] Navigation options.
     * @param {string} [url] URL to open once the main menu is loaded.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLoginHelperProvider.prototype.openMainMenu = function (navCtrl, page, params, options, url) {
        var _this = this;
        navCtrl = navCtrl || this.appProvider.getRootNavController();
        // Due to DeepLinker, we need to remove the path from the URL before going to main menu.
        // IonTabs checks the URL to determine which path to load for deep linking, so we clear the URL.
        this.location.replaceState('');
        if (page == CoreLoginHelperProvider_1.OPEN_COURSE) {
            // Load the main menu first, and then open the course.
            return navCtrl.setRoot('CoreMainMenuPage').finally(function () {
                return _this.courseProvider.openCourse(undefined, params.course, params);
            });
        }
        else {
            // Open the main menu.
            return navCtrl.setRoot('CoreMainMenuPage', { redirectPage: page, redirectParams: params, urlToOpen: url }, options);
        }
    };
    /**
     * Open a browser to perform OAuth login (Google, Facebook, Microsoft).
     *
     * @param {string} siteUrl URL of the site where the login will be performed.
     * @param {any} provider The identity provider.
     * @param {string} [launchUrl] The URL to open for SSO. If not defined, tool/mobile launch URL will be used.
     * @param {string} [pageName] Name of the page to go once authenticated. If not defined, site initial page.
     * @param {any} [pageParams] Params of the state to go once authenticated.
     * @return {boolean} True if success, false if error.
     */
    CoreLoginHelperProvider.prototype.openBrowserForOAuthLogin = function (siteUrl, provider, launchUrl, pageName, pageParams) {
        launchUrl = launchUrl || siteUrl + '/admin/tool/mobile/launch.php';
        if (!provider || !provider.url) {
            return false;
        }
        var service = this.sitesProvider.determineService(siteUrl), params = this.urlUtils.extractUrlParams(provider.url);
        var loginUrl = this.prepareForSSOLogin(siteUrl, service, launchUrl, pageName, pageParams);
        if (!params.id) {
            return false;
        }
        loginUrl += '&oauthsso=' + params.id;
        if (this.appProvider.isLinux()) {
            // In Linux desktop app, always use embedded browser.
            this.utils.openInApp(loginUrl);
        }
        else {
            // Always open it in browser because the user might have the session stored in there.
            this.utils.openInBrowser(loginUrl);
            if (navigator.app) {
                navigator.app.exitApp();
            }
        }
        return true;
    };
    /**
     * Open a browser to perform SSO login.
     *
     * @param {string} siteurl URL of the site where the SSO login will be performed.
     * @param {number} typeOfLogin CoreConstants.LOGIN_SSO_CODE or CoreConstants.LOGIN_SSO_INAPP_CODE.
     * @param {string} [service] The service to use. If not defined, external service will be used.
     * @param {string} [launchUrl] The URL to open for SSO. If not defined, local_mobile launch URL will be used.
     * @param {string} [pageName] Name of the page to go once authenticated. If not defined, site initial page.
     * @param {any} [pageParams] Params of the state to go once authenticated.
     */
    CoreLoginHelperProvider.prototype.openBrowserForSSOLogin = function (siteUrl, typeOfLogin, service, launchUrl, pageName, pageParams) {
        var loginUrl = this.prepareForSSOLogin(siteUrl, service, launchUrl, pageName, pageParams);
        if (this.isSSOEmbeddedBrowser(typeOfLogin)) {
            var options = {
                clearsessioncache: 'yes',
                closebuttoncaption: this.translate.instant('core.login.cancel'),
            };
            this.utils.openInApp(loginUrl, options);
        }
        else {
            this.utils.openInBrowser(loginUrl);
            if (navigator.app) {
                navigator.app.exitApp();
            }
        }
    };
    /**
     * Convenient helper to open change password page.
     *
     * @param {string} siteUrl Site URL to construct change password URL.
     * @param {string} error Error message.
     */
    CoreLoginHelperProvider.prototype.openChangePassword = function (siteUrl, error) {
        var _this = this;
        this.domUtils.showAlert(this.translate.instant('core.notice'), error, undefined, 3000).then(function (alert) {
            var subscription = alert.didDismiss.subscribe(function () {
                subscription && subscription.unsubscribe();
                _this.utils.openInApp(siteUrl + '/login/change_password.php');
            });
        });
    };
    /**
     * Open forgotten password in inappbrowser.
     *
     * @param {string} siteUrl URL of the site.
     */
    CoreLoginHelperProvider.prototype.openForgottenPassword = function (siteUrl) {
        this.utils.openInApp(siteUrl + '/login/forgot_password.php');
    };
    /*
     * Function to open in app browser to change password or complete user profile.
     *
     * @param {string} siteId The site ID.
     * @param {string} path The relative path of the URL to open.
     * @param {string} alertMessage The key of the message to display before opening the in app browser.
     * @param {boolean} [invalidateCache] Whether to invalidate site's cache (e.g. when the user is forced to change password).
     */
    CoreLoginHelperProvider.prototype.openInAppForEdit = function (siteId, path, alertMessage, invalidateCache) {
        var _this = this;
        if (!siteId || siteId !== this.sitesProvider.getCurrentSiteId()) {
            // Site that triggered the event is not current site, nothing to do.
            return;
        }
        var currentSite = this.sitesProvider.getCurrentSite(), siteUrl = currentSite && currentSite.getURL();
        if (!currentSite || !siteUrl) {
            return;
        }
        if (!this.isOpenEditAlertShown && !this.waitingForBrowser) {
            this.isOpenEditAlertShown = true;
            if (invalidateCache) {
                currentSite.invalidateWsCache();
            }
            // Open change password.
            alertMessage = this.translate.instant(alertMessage) + '<br>' + this.translate.instant('core.redirectingtosite');
            currentSite.openInAppWithAutoLogin(siteUrl + path, undefined, alertMessage).then(function () {
                _this.waitingForBrowser = true;
            }).finally(function () {
                _this.isOpenEditAlertShown = false;
            });
        }
    };
    /**
     * Prepare the app to perform SSO login.
     *
     * @param {string} siteUrl URL of the site where the SSO login will be performed.
     * @param {string} [service] The service to use. If not defined, external service will be used.
     * @param {string} [launchUrl] The URL to open for SSO. If not defined, local_mobile launch URL will be used.
     * @param {string} [pageName] Name of the page to go once authenticated. If not defined, site initial page.
     * @param {any} [pageParams] Params of the state to go once authenticated.
     */
    CoreLoginHelperProvider.prototype.prepareForSSOLogin = function (siteUrl, service, launchUrl, pageName, pageParams) {
        service = service || __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].wsextservice;
        launchUrl = launchUrl || siteUrl + '/local/mobile/launch.php';
        var passport = Math.random() * 1000;
        var loginUrl = launchUrl + '?service=' + service;
        loginUrl += '&passport=' + passport;
        loginUrl += '&urlscheme=' + __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].customurlscheme;
        // Store the siteurl and passport in CoreConfigProvider for persistence.
        // We are "configuring" the app to wait for an SSO. CoreConfigProvider shouldn't be used as a temporary storage.
        this.configProvider.set(__WEBPACK_IMPORTED_MODULE_18__core_constants__["a" /* CoreConstants */].LOGIN_LAUNCH_DATA, JSON.stringify({
            siteUrl: siteUrl,
            passport: passport,
            pageName: pageName || '',
            pageParams: pageParams || {}
        }));
        return loginUrl;
    };
    /**
     * Redirect to a new page, setting it as the root page and loading the right site if needed.
     *
     * @param {string} page Name of the page to load. Special cases: OPEN_COURSE (to open course page).
     * @param {any} params Params to pass to the page.
     * @param {string} [siteId] Site to load. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLoginHelperProvider.prototype.redirect = function (page, params, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.sitesProvider.isLoggedIn()) {
            if (siteId && siteId != this.sitesProvider.getCurrentSiteId()) {
                // Target page belongs to a different site. Change site.
                if (this.sitePluginsProvider.hasSitePluginsLoaded) {
                    // The site has site plugins so the app will be restarted. Store the data and logout.
                    this.appProvider.storeRedirect(siteId, page, params);
                    return this.sitesProvider.logout();
                }
                else {
                    return this.sitesProvider.logout().then(function () {
                        return _this.loadSiteAndPage(page, params, siteId);
                    });
                }
            }
            else {
                this.loadPageInMainMenu(page, params);
            }
        }
        else {
            if (siteId) {
                return this.loadSiteAndPage(page, params, siteId);
            }
            else {
                return this.appProvider.getRootNavController().setRoot('CoreLoginSitesPage');
            }
        }
        return Promise.resolve();
    };
    /**
     * Request a password reset.
     *
     * @param {string} siteUrl URL of the site.
     * @param {string} [username] Username to search.
     * @param {string} [email] Email to search.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLoginHelperProvider.prototype.requestPasswordReset = function (siteUrl, username, email) {
        var params = {};
        if (username) {
            params.username = username;
        }
        if (email) {
            params.email = email;
        }
        return this.wsProvider.callAjax('core_auth_request_password_reset', params, { siteUrl: siteUrl });
    };
    /**
     * Function that should be called when the session expires. Reserved for core use.
     *
     * @param {any} data Data received by the SESSION_EXPIRED event.
     */
    CoreLoginHelperProvider.prototype.sessionExpired = function (data) {
        var _this = this;
        var siteId = data && data.siteId, currentSite = this.sitesProvider.getCurrentSite(), siteUrl = currentSite && currentSite.getURL();
        var promise;
        if (!currentSite || !siteUrl) {
            return;
        }
        if (siteId && siteId !== currentSite.getId()) {
            return; // Site that triggered the event is not current site.
        }
        // Check authentication method.
        this.sitesProvider.checkSite(siteUrl).then(function (result) {
            if (result.warning) {
                _this.domUtils.showErrorModal(result.warning, true, 4000);
            }
            if (_this.isSSOLoginNeeded(result.code)) {
                // SSO. User needs to authenticate in a browser. Check if we need to display a message.
                if (!_this.appProvider.isSSOAuthenticationOngoing() && !_this.isSSOConfirmShown && !_this.waitingForBrowser) {
                    _this.isSSOConfirmShown = true;
                    if (_this.shouldShowSSOConfirm(result.code)) {
                        promise = _this.domUtils.showConfirm(_this.translate.instant('core.login.' +
                            (currentSite.isLoggedOut() ? 'loggedoutssodescription' : 'reconnectssodescription')));
                    }
                    else {
                        promise = Promise.resolve();
                    }
                    promise.then(function () {
                        _this.waitingForBrowser = true;
                        _this.sitesProvider.unsetCurrentSite(); // We need to unset current site to make authentication work fine.
                        _this.openBrowserForSSOLogin(result.siteUrl, result.code, result.service, result.config && result.config.launchurl, data.pageName, data.params);
                    }).catch(function () {
                        // User cancelled, logout him.
                        _this.sitesProvider.logout();
                    }).finally(function () {
                        _this.isSSOConfirmShown = false;
                    });
                }
            }
            else {
                var info = currentSite.getInfo();
                if (typeof info != 'undefined' && typeof info.username != 'undefined') {
                    var rootNavCtrl = _this.appProvider.getRootNavController(), activePage = rootNavCtrl.getActive();
                    // If current page is already reconnect, stop.
                    if (activePage && activePage.component && activePage.component.name == 'CoreLoginReconnectPage') {
                        return;
                    }
                    rootNavCtrl.setRoot('CoreLoginReconnectPage', {
                        infoSiteUrl: info.siteurl,
                        siteUrl: result.siteUrl,
                        siteId: siteId,
                        pageName: data.pageName,
                        pageParams: data.params,
                        siteConfig: result.config
                    });
                }
            }
        }).catch(function (error) {
            // Error checking site.
            if (currentSite.isLoggedOut()) {
                // Site is logged out, show error and logout the user.
                _this.domUtils.showErrorModalDefault(error, 'core.networkerrormsg', true);
                _this.sitesProvider.logout();
            }
        });
    };
    /**
     * Check if a confirm should be shown to open a SSO authentication.
     *
     * @param {number} typeOfLogin CoreConstants.LOGIN_SSO_CODE or CoreConstants.LOGIN_SSO_INAPP_CODE.
     * @return {boolean} True if confirm modal should be shown, false otherwise.
     */
    CoreLoginHelperProvider.prototype.shouldShowSSOConfirm = function (typeOfLogin) {
        return !this.isSSOEmbeddedBrowser(typeOfLogin) &&
            (!__WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].skipssoconfirmation || String(__WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].skipssoconfirmation) === 'false');
    };
    /**
     * Show a modal warning the user that he should use the Classic app.
     *
     * @param {string} message The warning message.
     */
    CoreLoginHelperProvider.prototype.showLegacyNoticeModal = function (message) {
        var _this = this;
        var isAndroid = this.platform.is('android'), isIOS = this.platform.is('ios'), isWindows = this.appProvider.isWindows(), isLinux = this.appProvider.isLinux(), buttons = [
            {
                text: this.translate.instant('core.ok'),
                role: 'cancel'
            }
        ];
        if (isAndroid || isIOS || isWindows || isLinux) {
            buttons.push({
                text: this.translate.instant('core.download'),
                handler: function () {
                    var link;
                    if (isWindows) {
                        link = 'https://download.moodle.org/desktop/download.php?platform=windows&version=342';
                    }
                    else if (isLinux) {
                        link = 'https://download.moodle.org/desktop/download.php?platform=linux&version=342&arch=' +
                            (_this.appProvider.is64Bits() ? '64' : '32');
                    }
                    else if (isAndroid) {
                        link = 'market://details?id=com.moodle.classic';
                    }
                    else {
                        link = 'itms-apps://itunes.apple.com/app/id1403448117';
                    }
                    _this.utils.openInBrowser(link);
                }
            });
        }
        var alert = this.alertCtrl.create({
            message: message,
            buttons: buttons
        });
        alert.present().then(function () {
            if (!isAndroid && !isIOS) {
                // Treat all anchors so they don't override the app.
                var alertMessageEl = alert.pageRef().nativeElement.querySelector('.alert-message');
                _this.domUtils.treatAnchors(alertMessageEl);
            }
        });
    };
    /**
     * Show a modal to inform the user that a confirmation email was sent, and a button to resend the email on 3.6+ sites.
     *
     * @param {string} siteUrl Site URL.
     * @param {string} [email] Email of the user. If set displayed in the message.
     * @param {string} [username] Username. If not set the button to resend email will not be shown.
     * @param {string} [password] User password. If not set the button to resend email will not be shown.
     */
    CoreLoginHelperProvider.prototype.showNotConfirmedModal = function (siteUrl, email, username, password) {
        var _this = this;
        var title = this.translate.instant('core.login.mustconfirm');
        var message;
        if (email) {
            message = this.translate.instant('core.login.emailconfirmsent', { $a: email });
        }
        else {
            message = this.translate.instant('core.login.emailconfirmsentnoemail');
        }
        // Check whether we need to display the resend button or not.
        var promise;
        if (username && password) {
            var modal_2 = this.domUtils.showModalLoading();
            // We don't have site info before login, the only way to check if the WS is available is by calling it.
            var preSets = { siteUrl: siteUrl };
            promise = this.wsProvider.callAjax('core_auth_resend_confirmation_email', {}, preSets).catch(function (error) {
                // If the WS responds with an invalid parameter error it means the WS is avaiable.
                return Promise.resolve(error && error.errorcode === 'invalidparameter');
            }).finally(function () {
                modal_2.dismiss();
            });
        }
        else {
            promise = Promise.resolve(false);
        }
        promise.then(function (canResend) {
            if (canResend) {
                var okText = _this.translate.instant('core.login.resendemail');
                var cancelText = _this.translate.instant('core.close');
                _this.domUtils.showConfirm(message, title, okText, cancelText).then(function () {
                    // Call the WS to resend the confirmation email.
                    var modal = _this.domUtils.showModalLoading('core.sending', true);
                    var data = { username: username, password: password };
                    var preSets = { siteUrl: siteUrl };
                    _this.wsProvider.callAjax('core_auth_resend_confirmation_email', data, preSets).then(function (response) {
                        var message = _this.translate.instant('core.login.emailconfirmsentsuccess');
                        _this.domUtils.showAlert(_this.translate.instant('core.success'), message);
                    }).catch(function (error) {
                        _this.domUtils.showErrorModal(error);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }).catch(function () {
                    // Dialog dismissed.
                });
            }
            else {
                _this.domUtils.showAlert(title, message);
            }
        });
    };
    /**
     * Function called when site policy is not agreed. Reserved for core use.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreLoginHelperProvider.prototype.sitePolicyNotAgreed = function (siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!siteId || siteId != this.sitesProvider.getCurrentSiteId()) {
            // Only current site allowed.
            return;
        }
        if (!this.sitesProvider.wsAvailableInCurrentSite('core_user_agree_site_policy')) {
            // WS not available, stop.
            return;
        }
        var rootNavCtrl = this.appProvider.getRootNavController(), activePage = rootNavCtrl.getActive();
        // If current page is already site policy, stop.
        if (activePage && activePage.component && activePage.component.name == 'CoreLoginSitePolicyPage') {
            return;
        }
        rootNavCtrl.setRoot('CoreLoginSitePolicyPage', { siteId: siteId });
    };
    /**
     * Convenient helper to handle get User Token error. It redirects to change password page if forcepassword is set.
     *
     * @param {string} siteUrl Site URL to construct change password URL.
     * @param {any} error Error object containing errorcode and error message.
     * @param {string} [username] Username.
     * @param {string} [password] User password.
     */
    CoreLoginHelperProvider.prototype.treatUserTokenError = function (siteUrl, error, username, password) {
        if (error.errorcode == 'forcepasswordchangenotice') {
            this.openChangePassword(siteUrl, this.textUtils.getErrorMessageFromError(error));
        }
        else if (error.errorcode == 'usernotconfirmed') {
            this.showNotConfirmedModal(siteUrl, undefined, username, password);
        }
        else if (error.errorcode == 'legacymoodleversion') {
            this.showLegacyNoticeModal(this.textUtils.getErrorMessageFromError(error));
        }
        else {
            this.domUtils.showErrorModal(error);
        }
    };
    /**
     * Convenient helper to validate a browser SSO login.
     *
     * @param {string} url URL received, to be validated.
     * @return {Promise<CoreLoginSSOData>} Promise resolved on success.
     */
    CoreLoginHelperProvider.prototype.validateBrowserSSOLogin = function (url) {
        var _this = this;
        // Split signature:::token
        var params = url.split(':::');
        return this.configProvider.get(__WEBPACK_IMPORTED_MODULE_18__core_constants__["a" /* CoreConstants */].LOGIN_LAUNCH_DATA).then(function (data) {
            data = _this.textUtils.parseJSON(data, null);
            if (data === null) {
                return Promise.reject(null);
            }
            var passport = data.passport;
            var launchSiteURL = data.siteUrl;
            // Reset temporary values.
            _this.configProvider.delete(__WEBPACK_IMPORTED_MODULE_18__core_constants__["a" /* CoreConstants */].LOGIN_LAUNCH_DATA);
            // Validate the signature.
            // We need to check both http and https.
            var signature = __WEBPACK_IMPORTED_MODULE_19_ts_md5_dist_md5__["Md5"].hashAsciiStr(launchSiteURL + passport);
            if (signature != params[0]) {
                if (launchSiteURL.indexOf('https://') != -1) {
                    launchSiteURL = launchSiteURL.replace('https://', 'http://');
                }
                else {
                    launchSiteURL = launchSiteURL.replace('http://', 'https://');
                }
                signature = __WEBPACK_IMPORTED_MODULE_19_ts_md5_dist_md5__["Md5"].hashAsciiStr(launchSiteURL + passport);
            }
            if (signature == params[0]) {
                _this.logger.debug('Signature validated');
                return {
                    siteUrl: launchSiteURL,
                    token: params[1],
                    privateToken: params[2],
                    pageName: data.pageName,
                    pageParams: data.pageParams
                };
            }
            else {
                _this.logger.debug('Invalid signature in the URL request yours: ' + params[0] + ' mine: '
                    + signature + ' for passport ' + passport);
                return Promise.reject(_this.translate.instant('core.unexpectederror'));
            }
        });
    };
    CoreLoginHelperProvider.OPEN_COURSE = 'open_course';
    CoreLoginHelperProvider = CoreLoginHelperProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_11__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_ws__["a" /* CoreWSProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_12__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_14__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_config__["a" /* CoreConfigProvider */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_7__providers_init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_15__core_siteplugins_providers_siteplugins__["a" /* CoreSitePluginsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__angular_common__["Location"], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["b" /* AlertController */], __WEBPACK_IMPORTED_MODULE_16__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], CoreLoginHelperProvider);
    return CoreLoginHelperProvider;
    var CoreLoginHelperProvider_1;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 53 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_comments_providers_comments__ = __webpack_require__(134);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_grades_providers_grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__classes_interceptor__ = __webpack_require__(344);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















/**
 * Service that provides some functions for assign.
 */
var AddonModAssignProvider = /** @class */ (function () {
    function AddonModAssignProvider(logger, sitesProvider, textUtils, timeUtils, appProvider, utils, submissionDelegate, gradesProvider, filepoolProvider, assignOffline, commentsProvider, logHelper) {
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.timeUtils = timeUtils;
        this.appProvider = appProvider;
        this.utils = utils;
        this.submissionDelegate = submissionDelegate;
        this.gradesProvider = gradesProvider;
        this.filepoolProvider = filepoolProvider;
        this.assignOffline = assignOffline;
        this.commentsProvider = commentsProvider;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModAssign:';
        this.gradingOfflineEnabled = {};
        this.logger = logger.getInstance('AddonModAssignProvider');
    }
    AddonModAssignProvider_1 = AddonModAssignProvider;
    /**
     * Check if the user can submit in offline. This should only be used if submissionStatus.lastattempt.cansubmit cannot
     * be used (offline usage).
     * This function doesn't check if the submission is empty, it should be checked before calling this function.
     *
     * @param {any} assign  Assignment instance.
     * @param {any} submissionStatus Submission status returned by getSubmissionStatus.
     * @return {boolean} Whether it can submit.
     */
    AddonModAssignProvider.prototype.canSubmitOffline = function (assign, submissionStatus) {
        if (!this.isSubmissionOpen(assign, submissionStatus)) {
            return false;
        }
        var userSubmission = submissionStatus.lastattempt.submission, teamSubmission = submissionStatus.lastattempt.teamsubmission;
        if (teamSubmission) {
            if (teamSubmission.status === AddonModAssignProvider_1.SUBMISSION_STATUS_SUBMITTED) {
                // The assignment submission has been completed.
                return false;
            }
            else if (userSubmission && userSubmission.status === AddonModAssignProvider_1.SUBMISSION_STATUS_SUBMITTED) {
                // The user has already clicked the submit button on the team submission.
                return false;
            }
            else if (assign.preventsubmissionnotingroup && !submissionStatus.lastattempt.submissiongroup) {
                return false;
            }
        }
        else if (userSubmission) {
            if (userSubmission.status === AddonModAssignProvider_1.SUBMISSION_STATUS_SUBMITTED) {
                // The assignment submission has been completed.
                return false;
            }
        }
        else {
            // No valid submission or team submission.
            return false;
        }
        // Last check is that this instance allows drafts.
        return assign.submissiondrafts;
    };
    /**
     * Get an assignment by course module ID.
     *
     * @param {number} courseId Course ID the assignment belongs to.
     * @param {number} cmId Assignment module ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the assignment.
     */
    AddonModAssignProvider.prototype.getAssignment = function (courseId, cmId, ignoreCache, siteId) {
        return this.getAssignmentByField(courseId, 'cmid', cmId, ignoreCache, siteId);
    };
    /**
     * Get an assigment with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the assignment is retrieved.
     */
    AddonModAssignProvider.prototype.getAssignmentByField = function (courseId, key, value, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId],
                includenotenrolledcourses: 1
            }, preSets = {
                cacheKey: _this.getAssignmentCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_13__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_assign_get_assignments', params, preSets).catch(function () {
                // In 3.6 we added a new parameter includenotenrolledcourses that could cause offline data not to be found.
                // Retry again without the param to check if the request is already cached.
                delete params.includenotenrolledcourses;
                return site.read('mod_assign_get_assignments', params, preSets);
            }).then(function (response) {
                // Search the assignment to return.
                if (response.courses && response.courses.length) {
                    var assignments = response.courses[0].assignments;
                    for (var i = 0; i < assignments.length; i++) {
                        if (assignments[i][key] == value) {
                            return assignments[i];
                        }
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get an assignment by instance ID.
     *
     * @param {number} courseId Course ID the assignment belongs to.
     * @param {number} cmId Assignment instance ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved with the assignment.
     */
    AddonModAssignProvider.prototype.getAssignmentById = function (courseId, id, ignoreCache, siteId) {
        return this.getAssignmentByField(courseId, 'id', id, ignoreCache, siteId);
    };
    /**
     * Get cache key for assignment data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModAssignProvider.prototype.getAssignmentCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'assignment:' + courseId;
    };
    /**
     * Get an assignment user mapping for blind marking.
     *
     * @param {number} assignId Assignment Id.
     * @param {number} userId User Id to be blinded.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the user blind id.
     */
    AddonModAssignProvider.prototype.getAssignmentUserMappings = function (assignId, userId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assignmentids: [assignId]
            }, preSets = {
                cacheKey: _this.getAssignmentUserMappingsCacheKey(assignId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_13__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_assign_get_user_mappings', params, preSets).then(function (response) {
                // Search the user.
                if (response.assignments && response.assignments.length) {
                    if (!userId || userId < 0) {
                        // User not valid, stop.
                        return -1;
                    }
                    var assignment = response.assignments[0];
                    if (assignment.assignmentid == assignId) {
                        var mappings = assignment.mappings;
                        for (var i = 0; i < mappings.length; i++) {
                            if (mappings[i].userid == userId) {
                                return mappings[i].id;
                            }
                        }
                    }
                }
                else if (response.warnings && response.warnings.length) {
                    return Promise.reject(response.warnings[0]);
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for assignment user mappings data WS calls.
     *
     * @param {number} assignId Assignment ID.
     * @return {string} Cache key.
     */
    AddonModAssignProvider.prototype.getAssignmentUserMappingsCacheKey = function (assignId) {
        return this.ROOT_CACHE_KEY + 'usermappings:' + assignId;
    };
    /**
     * Returns grade information from assign_grades for the requested assignment id
     *
     * @param {number} assignId Assignment Id.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Resolved with requested info when done.
     */
    AddonModAssignProvider.prototype.getAssignmentGrades = function (assignId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assignmentids: [assignId]
            }, preSets = {
                cacheKey: _this.getAssignmentGradesCacheKey(assignId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_assign_get_grades', params, preSets).then(function (response) {
                // Search the assignment.
                if (response.assignments && response.assignments.length) {
                    var assignment = response.assignments[0];
                    if (assignment.assignmentid == assignId) {
                        return assignment.grades;
                    }
                }
                else if (response.warnings && response.warnings.length) {
                    if (response.warnings[0].warningcode == 3) {
                        // No grades found.
                        return [];
                    }
                    return Promise.reject(response.warnings[0]);
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for assignment grades data WS calls.
     *
     * @param {number} assignId Assignment ID.
     * @return {string} Cache key.
     */
    AddonModAssignProvider.prototype.getAssignmentGradesCacheKey = function (assignId) {
        return this.ROOT_CACHE_KEY + 'assigngrades:' + assignId;
    };
    /**
     * Returns the color name for a given grading status name.
     *
     * @param {string} status Grading status name
     * @return {string} The color name.
     */
    AddonModAssignProvider.prototype.getSubmissionGradingStatusColor = function (status) {
        if (!status) {
            return '';
        }
        if (status == AddonModAssignProvider_1.GRADING_STATUS_GRADED ||
            status == AddonModAssignProvider_1.MARKING_WORKFLOW_STATE_RELEASED) {
            return 'success';
        }
        return 'danger';
    };
    /**
     * Returns the translation id for a given grading status name.
     *
     * @param {string} status Grading Status name
     * @return {string} The status translation identifier.
     */
    AddonModAssignProvider.prototype.getSubmissionGradingStatusTranslationId = function (status) {
        if (!status) {
            return;
        }
        if (status == AddonModAssignProvider_1.GRADING_STATUS_GRADED || status == AddonModAssignProvider_1.GRADING_STATUS_NOT_GRADED
            || status == AddonModAssignProvider_1.GRADED_FOLLOWUP_SUBMIT) {
            return 'addon.mod_assign.' + status;
        }
        return 'addon.mod_assign.markingworkflowstate' + status;
    };
    /**
     * Get the submission object from an attempt.
     *
     * @param {any} assign Assign.
     * @param {any} attempt Attempt.
     * @return {any} Submission object or null.
     */
    AddonModAssignProvider.prototype.getSubmissionObjectFromAttempt = function (assign, attempt) {
        if (!attempt) {
            return null;
        }
        return assign.teamsubmission ? attempt.teamsubmission : attempt.submission;
    };
    /**
     * Get attachments of a submission plugin.
     *
     * @param {any} submissionPlugin Submission plugin.
     * @return {any[]} Submission plugin attachments.
     */
    AddonModAssignProvider.prototype.getSubmissionPluginAttachments = function (submissionPlugin) {
        var files = [];
        if (submissionPlugin.fileareas) {
            submissionPlugin.fileareas.forEach(function (filearea) {
                if (!filearea || !filearea.files) {
                    // No files to get.
                    return;
                }
                filearea.files.forEach(function (file) {
                    if (!file.filename) {
                        // We don't have filename, extract it from the path.
                        file.filename = file.filepath[0] == '/' ? file.filepath.substr(1) : file.filepath;
                    }
                    files.push(file);
                });
            });
        }
        return files;
    };
    /**
     * Get text of a submission plugin.
     *
     * @param {any} submissionPlugin Submission plugin.
     * @param {boolean} [keepUrls] True if it should keep original URLs, false if they should be replaced.
     * @return {string} Submission text.
     */
    AddonModAssignProvider.prototype.getSubmissionPluginText = function (submissionPlugin, keepUrls) {
        var text = '';
        if (submissionPlugin.editorfields) {
            submissionPlugin.editorfields.forEach(function (field) {
                text += field.text;
            });
            if (!keepUrls && submissionPlugin.fileareas && submissionPlugin.fileareas[0]) {
                text = this.textUtils.replacePluginfileUrls(text, submissionPlugin.fileareas[0].files);
            }
        }
        return text;
    };
    /**
     * Get an assignment submissions.
     *
     * @param {number} assignId Assignment id.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{canviewsubmissions: boolean, submissions?: any[]}>} Promise resolved when done.
     */
    AddonModAssignProvider.prototype.getSubmissions = function (assignId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assignmentids: [assignId]
            }, preSets = {
                cacheKey: _this.getSubmissionsCacheKey(assignId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_13__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_assign_get_submissions', params, preSets).then(function (response) {
                // Check if we can view submissions, with enough permissions.
                if (response.warnings.length > 0 && response.warnings[0].warningcode == 1) {
                    return { canviewsubmissions: false };
                }
                if (response.assignments && response.assignments.length) {
                    return {
                        canviewsubmissions: true,
                        submissions: response.assignments[0].submissions
                    };
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for assignment submissions data WS calls.
     *
     * @param {number} assignId Assignment id.
     * @return {string} Cache key.
     */
    AddonModAssignProvider.prototype.getSubmissionsCacheKey = function (assignId) {
        return this.ROOT_CACHE_KEY + 'submissions:' + assignId;
    };
    /**
     * Get information about an assignment submission status for a given user.
     *
     * @param {number} assignId Assignment instance id.
     * @param {number} [userId] User Id (empty for current user).
     * @param {number} [groupId] Group Id (empty for all participants).
     * @param {boolean} [isBlind] If blind marking is enabled or not.
     * @param {number} [filter=true] True to filter WS response and rewrite URLs, false otherwise.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site id (empty for current site).
     * @return {Promise<any>} Promise always resolved with the user submission status.
     */
    AddonModAssignProvider.prototype.getSubmissionStatus = function (assignId, userId, groupId, isBlind, filter, ignoreCache, siteId) {
        var _this = this;
        if (filter === void 0) { filter = true; }
        userId = userId || 0;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            groupId = site.isVersionGreaterEqualThan('3.5') ? groupId || 0 : 0;
            var params = {
                assignid: assignId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getSubmissionStatusCacheKey(assignId, userId, groupId, isBlind),
                getCacheUsingCacheKey: true,
                filter: filter,
                rewriteurls: filter
            };
            if (groupId) {
                params['groupid'] = groupId;
            }
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            if (!filter) {
                // Don't cache when getting text without filters.
                // @todo Change this to support offline editing.
                preSets.saveToCache = false;
            }
            return site.read('mod_assign_get_submission_status', params, preSets);
        });
    };
    /**
     * Get information about an assignment submission status for a given user.
     * If the data doesn't include the user submission, retry ignoring cache.
     *
     * @param {any} assign Assignment.
     * @param {number} [userId] User id (empty for current user).
     * @param {number} [groupId] Group Id (empty for all participants).
     * @param {boolean} [isBlind] If blind marking is enabled or not.
     * @param {number} [filter=true] True to filter WS response and rewrite URLs, false otherwise.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site id (empty for current site).
     * @return {Promise<any>} Promise always resolved with the user submission status.
     */
    AddonModAssignProvider.prototype.getSubmissionStatusWithRetry = function (assign, userId, groupId, isBlind, filter, ignoreCache, siteId) {
        var _this = this;
        if (filter === void 0) { filter = true; }
        return this.getSubmissionStatus(assign.id, userId, groupId, isBlind, filter, ignoreCache, siteId).then(function (response) {
            var userSubmission = _this.getSubmissionObjectFromAttempt(assign, response.lastattempt);
            if (!userSubmission) {
                // Try again, ignoring cache.
                return _this.getSubmissionStatus(assign.id, userId, groupId, isBlind, filter, true, siteId).catch(function () {
                    // Error, return the first result even if it doesn't have the user submission.
                    return response;
                });
            }
            return response;
        });
    };
    /**
     * Get cache key for get submission status data WS calls.
     *
     * @param {number} assignId Assignment instance id.
     * @param {number} [userId] User id (empty for current user).
     * @param {number} [groupId] Group Id (empty for all participants).
     * @param {number} [isBlind] If blind marking is enabled or not.
     * @return {string} Cache key.
     */
    AddonModAssignProvider.prototype.getSubmissionStatusCacheKey = function (assignId, userId, groupId, isBlind) {
        if (!userId) {
            isBlind = false;
            userId = this.sitesProvider.getCurrentSiteUserId();
        }
        return this.getSubmissionsCacheKey(assignId) + ':' + userId + ':' + (isBlind ? 1 : 0) + ':' + groupId;
    };
    /**
     * Returns the color name for a given status name.
     *
     * @param {string} status Status name
     * @return {string} The color name.
     */
    AddonModAssignProvider.prototype.getSubmissionStatusColor = function (status) {
        switch (status) {
            case 'submitted':
                return 'success';
            case 'draft':
                return 'info';
            case 'new':
            case 'noattempt':
            case 'noonlinesubmissions':
            case 'nosubmission':
            case 'gradedfollowupsubmit':
                return 'danger';
            default:
                return 'light';
        }
    };
    /**
     * Given a list of plugins, returns the plugin names that aren't supported for editing.
     *
     * @param {any[]} plugins Plugins to check.
     * @return {Promise<string[]>} Promise resolved with unsupported plugin names.
     */
    AddonModAssignProvider.prototype.getUnsupportedEditPlugins = function (plugins) {
        var _this = this;
        var notSupported = [], promises = [];
        plugins.forEach(function (plugin) {
            promises.push(_this.submissionDelegate.isPluginSupportedForEdit(plugin.type).then(function (enabled) {
                if (!enabled) {
                    notSupported.push(plugin.name);
                }
            }));
        });
        return Promise.all(promises).then(function () {
            return notSupported;
        });
    };
    /**
     * List the participants for a single assignment, with some summary info about their submissions.
     *
     * @param {number} assignId Assignment id.
     * @param {number} [groupId] Group id. If not defined, 0.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of participants and summary of submissions.
     */
    AddonModAssignProvider.prototype.listParticipants = function (assignId, groupId, ignoreCache, siteId) {
        var _this = this;
        groupId = groupId || 0;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.wsAvailable('mod_assign_list_participants')) {
                // Silently fail if is not available. (needs Moodle version >= 3.2)
                return Promise.reject(null);
            }
            var params = {
                assignid: assignId,
                groupid: groupId,
                filter: ''
            }, preSets = {
                cacheKey: _this.listParticipantsCacheKey(assignId, groupId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_13__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_assign_list_participants', params, preSets);
        });
    };
    /**
     * Get cache key for assignment list participants data WS calls.
     *
     * @param {number} assignId Assignment id.
     * @param {number} groupId Group id.
     * @return {string} Cache key.
     */
    AddonModAssignProvider.prototype.listParticipantsCacheKey = function (assignId, groupId) {
        return this.listParticipantsPrefixCacheKey(assignId) + ':' + groupId;
    };
    /**
     * Get prefix cache key for assignment list participants data WS calls.
     *
     * @param {number} assignId Assignment id.
     * @return {string} Cache key.
     */
    AddonModAssignProvider.prototype.listParticipantsPrefixCacheKey = function (assignId) {
        return this.ROOT_CACHE_KEY + 'participants:' + assignId;
    };
    /**
     * Invalidates all submission status data.
     *
     * @param {number} assignId Assignment instance id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateAllSubmissionData = function (assignId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getSubmissionsCacheKey(assignId));
        });
    };
    /**
     * Invalidates assignment data WS calls.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateAssignmentData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAssignmentCacheKey(courseId));
        });
    };
    /**
     * Invalidates assignment user mappings data WS calls.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateAssignmentUserMappingsData = function (assignId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAssignmentUserMappingsCacheKey(assignId));
        });
    };
    /**
     * Invalidates assignment grades data WS calls.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateAssignmentGradesData = function (assignId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAssignmentGradesCacheKey(assignId));
        });
    };
    /**
     * Invalidate the prefetched content except files.
     * To invalidate files, use AddonModAssignProvider.invalidateFiles.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getAssignment(courseId, moduleId, false, siteId).then(function (assign) {
            var promises = [];
            // Do not invalidate assignment data before getting assignment info, we need it!
            promises.push(_this.invalidateAllSubmissionData(assign.id, siteId));
            promises.push(_this.invalidateAssignmentUserMappingsData(assign.id, siteId));
            promises.push(_this.invalidateAssignmentGradesData(assign.id, siteId));
            promises.push(_this.invalidateListParticipantsData(assign.id, siteId));
            promises.push(_this.commentsProvider.invalidateCommentsByInstance('module', assign.id, siteId));
            promises.push(_this.invalidateAssignmentData(courseId, siteId));
            promises.push(_this.gradesProvider.invalidateAllCourseGradesData(courseId));
            return Promise.all(promises);
        });
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param {number} moduleId The module ID.
     * @return {Promise<any>} Promise resolved when the files are invalidated.
     */
    AddonModAssignProvider.prototype.invalidateFiles = function (moduleId) {
        return this.filepoolProvider.invalidateFilesByComponent(this.sitesProvider.getCurrentSiteId(), AddonModAssignProvider_1.COMPONENT, moduleId);
    };
    /**
     * Invalidates assignment submissions data WS calls.
     *
     * @param {number} assignId Assignment instance id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateSubmissionData = function (assignId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getSubmissionsCacheKey(assignId));
        });
    };
    /**
     * Invalidates submission status data.
     *
     * @param {number} assignId Assignment instance id.
     * @param {number} [userId] User id (empty for current user).
     * @param {number} [groupId] Group Id (empty for all participants).
     * @param {boolean} [isBlind] Whether blind marking is enabled or not.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateSubmissionStatusData = function (assignId, userId, groupId, isBlind, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getSubmissionStatusCacheKey(assignId, userId, groupId, isBlind));
        });
    };
    /**
     * Invalidates assignment participants data.
     *
     * @param {number} assignId Assignment instance id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignProvider.prototype.invalidateListParticipantsData = function (assignId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.listParticipantsPrefixCacheKey(assignId));
        });
    };
    /**
     * Convenience function to check if grading offline is enabled.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether grading offline is enabled.
     */
    AddonModAssignProvider.prototype.isGradingOfflineEnabled = function (siteId) {
        var _this = this;
        if (typeof this.gradingOfflineEnabled[siteId] != 'undefined') {
            return Promise.resolve(this.gradingOfflineEnabled[siteId]);
        }
        return this.gradesProvider.isGradeItemsAvalaible(siteId).then(function (enabled) {
            _this.gradingOfflineEnabled[siteId] = enabled;
            return enabled;
        });
    };
    /**
     * Outcomes only can be edited if mod_assign_submit_grading_form is avalaible.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if outcomes edit is enabled, rejected or resolved with false otherwise.
     * @since 3.2
     */
    AddonModAssignProvider.prototype.isOutcomesEditEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('mod_assign_submit_grading_form');
        });
    };
    /**
     * Check if assignments plugin is enabled in a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean} Whether the plugin is enabled.
     */
    AddonModAssignProvider.prototype.isPluginEnabled = function (siteId) {
        return true;
    };
    /**
     * Check if a submission is open. This function is based on Moodle's submissions_open.
     *
     * @param {any} assign Assignment instance.
     * @param {any} submissionStatus Submission status returned by getSubmissionStatus.
     * @return {boolean} Whether submission is open.
     */
    AddonModAssignProvider.prototype.isSubmissionOpen = function (assign, submissionStatus) {
        if (!assign || !submissionStatus) {
            return false;
        }
        var time = this.timeUtils.timestamp(), lastAttempt = submissionStatus.lastattempt, submission = this.getSubmissionObjectFromAttempt(assign, lastAttempt);
        var dateOpen = true, finalDate;
        if (assign.cutoffdate) {
            finalDate = assign.cutoffdate;
        }
        if (lastAttempt && lastAttempt.locked) {
            return false;
        }
        // User extensions.
        if (finalDate) {
            if (lastAttempt && lastAttempt.extensionduedate) {
                // Extension can be before cut off date.
                if (lastAttempt.extensionduedate > finalDate) {
                    finalDate = lastAttempt.extensionduedate;
                }
            }
        }
        if (finalDate) {
            dateOpen = assign.allowsubmissionsfromdate <= time && time <= finalDate;
        }
        else {
            dateOpen = assign.allowsubmissionsfromdate <= time;
        }
        if (!dateOpen) {
            return false;
        }
        if (submission) {
            if (assign.submissiondrafts && submission.status == AddonModAssignProvider_1.SUBMISSION_STATUS_SUBMITTED) {
                // Drafts are tracked and the student has submitted the assignment.
                return false;
            }
        }
        return true;
    };
    /**
     * Report an assignment submission as being viewed.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [name] Name of the assign.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModAssignProvider.prototype.logSubmissionView = function (assignId, name, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assignid: assignId
            };
            return _this.logHelper.logSingle('mod_assign_view_submission_status', params, AddonModAssignProvider_1.COMPONENT, assignId, name, 'assign', {}, siteId);
        });
    };
    /**
     * Report an assignment grading table is being viewed.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [name] Name of the assign.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModAssignProvider.prototype.logGradingView = function (assignId, name, siteId) {
        var params = {
            assignid: assignId
        };
        return this.logHelper.logSingle('mod_assign_view_grading_table', params, AddonModAssignProvider_1.COMPONENT, assignId, name, 'assign', {}, siteId);
    };
    /**
     * Report an assign as being viewed.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [name] Name of the assign.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModAssignProvider.prototype.logView = function (assignId, name, siteId) {
        var params = {
            assignid: assignId
        };
        return this.logHelper.logSingle('mod_assign_view_assign', params, AddonModAssignProvider_1.COMPONENT, assignId, name, 'assign', {}, siteId);
    };
    /**
     * Returns if a submissions needs to be graded.
     *
     * @param {any} submission Submission.
     * @param {number} assignId Assignment ID.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it needs to be graded or not.
     */
    AddonModAssignProvider.prototype.needsSubmissionToBeGraded = function (submission, assignId) {
        if (!submission.gradingstatus) {
            // This should not happen, but it's better to show rather than not showing any of the submissions.
            return Promise.resolve(true);
        }
        if (submission.gradingstatus != AddonModAssignProvider_1.GRADING_STATUS_GRADED &&
            submission.gradingstatus != AddonModAssignProvider_1.MARKING_WORKFLOW_STATE_RELEASED) {
            // Not graded.
            return Promise.resolve(true);
        }
        // We need more data to decide that.
        return this.getSubmissionStatus(assignId, submission.submitid, undefined, submission.blindid).then(function (response) {
            if (!response.feedback || !response.feedback.gradeddate) {
                // Not graded.
                return true;
            }
            // Submitted after grading?
            return response.feedback.gradeddate < submission.timemodified;
        });
    };
    /**
     * Save current user submission for a certain assignment.
     *
     * @param {number} assignId Assign ID.
     * @param {number} courseId Course ID the assign belongs to.
     * @param {any} pluginData Data to save.
     * @param {boolean} allowOffline Whether to allow offline usage.
     * @param {number} timemodified The time the submission was last modified in online.
     * @param {boolean} [allowsDrafts] Whether the assignment allows submission drafts.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if sent to server, resolved with false if stored in offline.
     */
    AddonModAssignProvider.prototype.saveSubmission = function (assignId, courseId, pluginData, allowOffline, timemodified, allowsDrafts, userId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Function to store the submission to be synchronized later.
        var storeOffline = function () {
            return _this.assignOffline.saveSubmission(assignId, courseId, pluginData, timemodified, !allowsDrafts, userId, siteId)
                .then(function () {
                return false;
            });
        };
        if (allowOffline && !this.appProvider.isOnline()) {
            // App is offline, store the action.
            return storeOffline();
        }
        // If there's already a submission to be sent to the server, discard it first.
        return this.assignOffline.deleteSubmission(assignId, userId, siteId).then(function () {
            return _this.saveSubmissionOnline(assignId, pluginData, siteId).then(function () {
                return true;
            }).catch(function (error) {
                if (allowOffline && error && !_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Save current user submission for a certain assignment. It will fail if offline or cannot connect.
     *
     * @param {number} assignId Assign ID.
     * @param {any} pluginData Data to save.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when saved, rejected otherwise.
     */
    AddonModAssignProvider.prototype.saveSubmissionOnline = function (assignId, pluginData, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assignmentid: assignId,
                plugindata: pluginData
            };
            return site.write('mod_assign_save_submission', params).then(function (warnings) {
                if (warnings && warnings.length) {
                    // The WebService returned warnings, reject.
                    return Promise.reject(warnings[0]);
                }
            });
        });
    };
    /**
     * Submit the current user assignment for grading.
     *
     * @param {number} assignId Assign ID.
     * @param {number} courseId Course ID the assign belongs to.
     * @param {boolean} acceptStatement True if submission statement is accepted, false otherwise.
     * @param {number} timemodified The time the submission was last modified in online.
     * @param {boolean} [forceOffline] True to always mark it in offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if sent to server, resolved with false if stored in offline.
     */
    AddonModAssignProvider.prototype.submitForGrading = function (assignId, courseId, acceptStatement, timemodified, forceOffline, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Function to store the submission to be synchronized later.
        var storeOffline = function () {
            return _this.assignOffline.markSubmitted(assignId, courseId, true, acceptStatement, timemodified, undefined, siteId)
                .then(function () {
                return false;
            });
        };
        if (forceOffline || !this.appProvider.isOnline()) {
            // App is offline, store the action.
            return storeOffline();
        }
        // If there's already a submission to be sent to the server, discard it first.
        return this.assignOffline.deleteSubmission(assignId, undefined, siteId).then(function () {
            return _this.submitForGradingOnline(assignId, acceptStatement, siteId).then(function () {
                return true;
            }).catch(function (error) {
                if (error && !_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Submit the current user assignment for grading. It will fail if offline or cannot connect.
     *
     * @param {number} assignId Assign ID.
     * @param {boolean} acceptStatement True if submission statement is accepted, false otherwise.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when submitted, rejected otherwise.
     */
    AddonModAssignProvider.prototype.submitForGradingOnline = function (assignId, acceptStatement, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assignmentid: assignId,
                acceptsubmissionstatement: acceptStatement ? 1 : 0
            };
            return site.write('mod_assign_submit_for_grading', params).then(function (warnings) {
                if (warnings && warnings.length) {
                    // The WebService returned warnings, reject.
                    return Promise.reject(warnings[0]);
                }
            });
        });
    };
    /**
     * Submit the grading for the current user and assignment. It will use old or new WS depending on availability.
     *
     * @param {number} assignId Assign ID.
     * @param {number} userId User ID.
     * @param {number} courseId Course ID the assign belongs to.
     * @param {number} grade Grade to submit.
     * @param {number} attemptNumber Number of the attempt being graded.
     * @param {boolean} addAttempt Admit the user to attempt again.
     * @param {string} workflowState Next workflow State.
     * @param {boolean} applyToAll If it's a team submission, whether the grade applies to all group members.
     * @param {any} outcomes Object including all outcomes values. If empty, any of them will be sent.
     * @param {any} pluginData Feedback plugin data to save.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if sent to server, resolved with false if stored offline.
     */
    AddonModAssignProvider.prototype.submitGradingForm = function (assignId, userId, courseId, grade, attemptNumber, addAttempt, workflowState, applyToAll, outcomes, pluginData, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Function to store the grading to be synchronized later.
        var storeOffline = function () {
            return _this.assignOffline.submitGradingForm(assignId, userId, courseId, grade, attemptNumber, addAttempt, workflowState, applyToAll, outcomes, pluginData, siteId).then(function () {
                return false;
            });
        };
        // Grading offline is only allowed if WS of grade items is enabled to avoid inconsistency.
        return this.isGradingOfflineEnabled(siteId).then(function (enabled) {
            if (!enabled) {
                return _this.submitGradingFormOnline(assignId, userId, grade, attemptNumber, addAttempt, workflowState, applyToAll, outcomes, pluginData, siteId);
            }
            if (!_this.appProvider.isOnline()) {
                // App is offline, store the action.
                return storeOffline();
            }
            // If there's already a grade to be sent to the server, discard it first.
            return _this.assignOffline.deleteSubmissionGrade(assignId, userId, siteId).then(function () {
                return _this.submitGradingFormOnline(assignId, userId, grade, attemptNumber, addAttempt, workflowState, applyToAll, outcomes, pluginData, siteId).then(function () {
                    return true;
                }).catch(function (error) {
                    if (error && !_this.utils.isWebServiceError(error)) {
                        // Couldn't connect to server, store in offline.
                        return storeOffline();
                    }
                    else {
                        // The WebService has thrown an error, reject.
                        return Promise.reject(error);
                    }
                });
            });
        });
    };
    /**
     * Submit the grading for the current user and assignment. It will use old or new WS depending on availability.
     * It will fail if offline or cannot connect.
     *
     * @param {number} assignId Assign ID.
     * @param {number} userId User ID.
     * @param {number} grade Grade to submit.
     * @param {number} attemptNumber Number of the attempt being graded.
     * @param {number} addAttempt Allow the user to attempt again.
     * @param {string} workflowState Next workflow State.
     * @param {boolean} applyToAll If it's a team submission, if the grade applies to all group members.
     * @param {any} outcomes Object including all outcomes values. If empty, any of them will be sent.
     * @param {any} pluginData Feedback plugin data to save.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when submitted, rejected otherwise.
     */
    AddonModAssignProvider.prototype.submitGradingFormOnline = function (assignId, userId, grade, attemptNumber, addAttempt, workflowState, applyToAll, outcomes, pluginData, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            if (site.wsAvailable('mod_assign_submit_grading_form')) {
                // WS available @since 3.2.
                var jsonData = {
                    grade: grade,
                    attemptnumber: attemptNumber,
                    addattempt: addAttempt ? 1 : 0,
                    workflowstate: workflowState,
                    applytoall: applyToAll ? 1 : 0
                };
                for (var index in outcomes) {
                    jsonData['outcome_' + index + '[' + userId + ']'] = outcomes[index];
                }
                for (var index in pluginData) {
                    jsonData[index] = pluginData[index];
                }
                var serialized = __WEBPACK_IMPORTED_MODULE_14__classes_interceptor__["a" /* CoreInterceptor */].serialize(jsonData, true), params = {
                    assignmentid: assignId,
                    userid: userId,
                    jsonformdata: JSON.stringify(serialized)
                };
                return site.write('mod_assign_submit_grading_form', params).then(function (warnings) {
                    if (warnings && warnings.length) {
                        // The WebService returned warnings, reject.
                        return Promise.reject(warnings[0]);
                    }
                });
            }
            else {
                // WS not available, fallback to save_grade.
                var params = {
                    assignmentid: assignId,
                    userid: userId,
                    grade: grade,
                    attemptnumber: attemptNumber,
                    addattempt: addAttempt ? 1 : 0,
                    workflowstate: workflowState,
                    applytoall: applyToAll ? 1 : 0,
                    plugindata: pluginData
                }, preSets = {
                    responseExpected: false
                };
                return site.write('mod_assign_save_grade', params, preSets);
            }
        });
    };
    AddonModAssignProvider.COMPONENT = 'mmaModAssign';
    AddonModAssignProvider.SUBMISSION_COMPONENT = 'mmaModAssignSubmission';
    AddonModAssignProvider.UNLIMITED_ATTEMPTS = -1;
    // Submission status.
    AddonModAssignProvider.SUBMISSION_STATUS_NEW = 'new';
    AddonModAssignProvider.SUBMISSION_STATUS_REOPENED = 'reopened';
    AddonModAssignProvider.SUBMISSION_STATUS_DRAFT = 'draft';
    AddonModAssignProvider.SUBMISSION_STATUS_SUBMITTED = 'submitted';
    // "Re-open" methods (to retry the assign).
    AddonModAssignProvider.ATTEMPT_REOPEN_METHOD_NONE = 'none';
    AddonModAssignProvider.ATTEMPT_REOPEN_METHOD_MANUAL = 'manual';
    // Grading status.
    AddonModAssignProvider.GRADING_STATUS_GRADED = 'graded';
    AddonModAssignProvider.GRADING_STATUS_NOT_GRADED = 'notgraded';
    AddonModAssignProvider.MARKING_WORKFLOW_STATE_RELEASED = 'released';
    AddonModAssignProvider.NEED_GRADING = 'needgrading';
    AddonModAssignProvider.GRADED_FOLLOWUP_SUBMIT = 'gradedfollowupsubmit';
    // Events.
    AddonModAssignProvider.SUBMISSION_SAVED_EVENT = 'addon_mod_assign_submission_saved';
    AddonModAssignProvider.SUBMITTED_FOR_GRADING_EVENT = 'addon_mod_assign_submitted_for_grading';
    AddonModAssignProvider.GRADED_EVENT = 'addon_mod_assign_graded';
    AddonModAssignProvider = AddonModAssignProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__submission_delegate__["a" /* AddonModAssignSubmissionDelegate */],
            __WEBPACK_IMPORTED_MODULE_9__core_grades_providers_grades__["a" /* CoreGradesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_12__assign_offline__["a" /* AddonModAssignOfflineProvider */], __WEBPACK_IMPORTED_MODULE_8__core_comments_providers_comments__["a" /* CoreCommentsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModAssignProvider);
    return AddonModAssignProvider;
    var AddonModAssignProvider_1;
}());

//# sourceMappingURL=assign.js.map

/***/ }),
/* 54 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_camera__ = __webpack_require__(256);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_media_capture__ = __webpack_require__(347);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_13_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Service to upload files.
 */
var CoreFileUploaderProvider = /** @class */ (function () {
    function CoreFileUploaderProvider(logger, fileProvider, textUtils, utils, sitesProvider, timeUtils, mimeUtils, filepoolProvider, platform, translate, mediaCapture, camera) {
        this.fileProvider = fileProvider;
        this.textUtils = textUtils;
        this.utils = utils;
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.mimeUtils = mimeUtils;
        this.filepoolProvider = filepoolProvider;
        this.platform = platform;
        this.translate = translate;
        this.mediaCapture = mediaCapture;
        this.camera = camera;
        // Observers to notify when a media file starts/stops being recorded/selected.
        this.onGetPicture = new __WEBPACK_IMPORTED_MODULE_13_rxjs__["Subject"]();
        this.onAudioCapture = new __WEBPACK_IMPORTED_MODULE_13_rxjs__["Subject"]();
        this.onVideoCapture = new __WEBPACK_IMPORTED_MODULE_13_rxjs__["Subject"]();
        this.logger = logger.getInstance('CoreFileUploaderProvider');
    }
    /**
     * Add a dot to the beginning of an extension.
     *
     * @param {string} extension Extension.
     * @return {string}           Treated extension.
     */
    CoreFileUploaderProvider.prototype.addDot = function (extension) {
        return '.' + extension;
    };
    /**
     * Compares two file lists and returns if they are different.
     *
     * @param {any[]} a First file list.
     * @param {any[]} b Second file list.
     * @return {boolean} Whether both lists are different.
     */
    CoreFileUploaderProvider.prototype.areFileListDifferent = function (a, b) {
        a = a || [];
        b = b || [];
        if (a.length != b.length) {
            return true;
        }
        // Currently we are going to compare the order of the files as well.
        // This function can be improved comparing more fields or not comparing the order.
        for (var i = 0; i < a.length; i++) {
            if ((a[i].name || a[i].filename) != (b[i].name || b[i].filename)) {
                return true;
            }
        }
        return false;
    };
    /**
     * Start the audio recorder application and return information about captured audio clip files.
     *
     * @param {CaptureAudioOptions} options Options.
     * @return {Promise<MediaFile[] | CaptureError>} Promise resolved with the result.
     */
    CoreFileUploaderProvider.prototype.captureAudio = function (options) {
        var _this = this;
        this.onAudioCapture.next(true);
        return this.mediaCapture.captureAudio(options).finally(function () {
            _this.onAudioCapture.next(false);
        });
    };
    /**
     * Start the video recorder application and return information about captured video clip files.
     *
     * @param {CaptureVideoOptions} options Options.
     * @return {Promise<MediaFile[] | CaptureError>} Promise resolved with the result.
     */
    CoreFileUploaderProvider.prototype.captureVideo = function (options) {
        var _this = this;
        this.onVideoCapture.next(true);
        return this.mediaCapture.captureVideo(options).finally(function () {
            _this.onVideoCapture.next(false);
        });
    };
    /**
     * Clear temporary attachments to be uploaded.
     * Attachments already saved in an offline store will NOT be deleted.
     *
     * @param {any[]} files List of files.
     */
    CoreFileUploaderProvider.prototype.clearTmpFiles = function (files) {
        // Delete the local files.
        files.forEach(function (file) {
            if (!file.offline && file.remove) {
                // Pass an empty function to prevent missing parameter error.
                file.remove(function () {
                    // Nothing to do.
                });
            }
        });
    };
    /**
     * Get the upload options for a file taken with the Camera Cordova plugin.
     *
     * @param {string} uri File URI.
     * @param {boolean} [isFromAlbum] True if the image was taken from album, false if it's a new image taken with camera.
     * @return {CoreFileUploaderOptions} Options.
     */
    CoreFileUploaderProvider.prototype.getCameraUploadOptions = function (uri, isFromAlbum) {
        var extension = this.mimeUtils.getExtension(uri), mimetype = this.mimeUtils.getMimeType(extension), isIOS = this.platform.is('ios'), options = {
            deleteAfterUpload: !isFromAlbum,
            mimeType: mimetype
        };
        if (isIOS && (mimetype == 'image/jpeg' || mimetype == 'image/png')) {
            // In iOS, the pictures can have repeated names, even if they come from the album.
            options.fileName = 'image_' + this.timeUtils.readableTimestamp() + '.' + extension;
        }
        else {
            // Use the same name that the file already has.
            options.fileName = this.fileProvider.getFileAndDirectoryFromPath(uri).name;
        }
        if (isFromAlbum) {
            // If the file was picked from the album, delete it only if it was copied to the app's folder.
            options.deleteAfterUpload = this.fileProvider.isFileInAppFolder(uri);
            if (this.platform.is('android')) {
                // Picking an image from album in Android adds a timestamp at the end of the file. Delete it.
                options.fileName = options.fileName.replace(/(\.[^\.]*)\?[^\.]*$/, '$1');
            }
        }
        return options;
    };
    /**
     * Get the upload options for a file of any type.
     *
     * @param {string} uri File URI.
     * @param {string} name File name.
     * @param {string} type File type.
     * @param {boolean} [deleteAfterUpload] Whether the file should be deleted after upload.
     * @param {string} [fileArea] File area to upload the file to. It defaults to 'draft'.
     * @param {number} [itemId] Draft ID to upload the file to, 0 to create new.
     * @return {CoreFileUploaderOptions} Options.
     */
    CoreFileUploaderProvider.prototype.getFileUploadOptions = function (uri, name, type, deleteAfterUpload, fileArea, itemId) {
        var options = {};
        options.fileName = name;
        options.mimeType = type || this.mimeUtils.getMimeType(this.mimeUtils.getFileExtension(options.fileName));
        options.deleteAfterUpload = !!deleteAfterUpload;
        options.itemId = itemId || 0;
        options.fileArea = fileArea;
        return options;
    };
    /**
     * Get the upload options for a file taken with the media capture Cordova plugin.
     *
     * @param {MediaFile} mediaFile File object to upload.
     * @return {CoreFileUploaderOptions} Options.
     */
    CoreFileUploaderProvider.prototype.getMediaUploadOptions = function (mediaFile) {
        var options = {};
        var filename = mediaFile.name, split;
        // Add a timestamp to the filename to make it unique.
        split = filename.split('.');
        split[0] += '_' + this.timeUtils.readableTimestamp();
        filename = split.join('.');
        options.fileName = filename;
        options.deleteAfterUpload = true;
        if (mediaFile.type) {
            options.mimeType = mediaFile.type;
        }
        else {
            options.mimeType = this.mimeUtils.getMimeType(this.mimeUtils.getFileExtension(options.fileName));
        }
        return options;
    };
    /**
     * Take a picture or video, or load one from the library.
     *
     * @param {CameraOptions} options Options.
     * @return {Promise<any>} Promise resolved with the result.
     */
    CoreFileUploaderProvider.prototype.getPicture = function (options) {
        var _this = this;
        this.onGetPicture.next(true);
        return this.camera.getPicture(options).finally(function () {
            _this.onGetPicture.next(false);
        });
    };
    /**
     * Get the files stored in a folder, marking them as offline.
     *
     * @param {string} folderPath Folder where to get the files.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    CoreFileUploaderProvider.prototype.getStoredFiles = function (folderPath) {
        var _this = this;
        return this.fileProvider.getDirectoryContents(folderPath).then(function (files) {
            return _this.markOfflineFiles(files);
        });
    };
    /**
     * Get stored files from combined online and offline file object.
     *
     * @param {{online: any[], offline: number}} filesObject The combined offline and online files object.
     * @param {string} folderPath Folder path to get files from.
     * @return {Promise<any[]>} Promise resolved with files.
     */
    CoreFileUploaderProvider.prototype.getStoredFilesFromOfflineFilesObject = function (filesObject, folderPath) {
        var files = [];
        if (filesObject) {
            if (filesObject.online && filesObject.online.length > 0) {
                files = this.utils.clone(filesObject.online);
            }
            if (filesObject.offline > 0) {
                return this.getStoredFiles(folderPath).then(function (offlineFiles) {
                    return files.concat(offlineFiles);
                }).catch(function () {
                    // Ignore not found files.
                    return files;
                });
            }
        }
        return Promise.resolve(files);
    };
    /**
     * Check if a file's mimetype is invalid based on the list of accepted mimetypes. This function needs either the file's
     * mimetype or the file's path/name.
     *
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @param {string} [path] File's path or name.
     * @param {string} [mimetype] File's mimetype.
     * @return {string} Undefined if file is valid, error message if file is invalid.
     */
    CoreFileUploaderProvider.prototype.isInvalidMimetype = function (mimetypes, path, mimetype) {
        var extension;
        if (mimetypes) {
            // Verify that the mimetype of the file is supported.
            if (mimetype) {
                extension = this.mimeUtils.getExtension(mimetype);
            }
            else {
                extension = this.mimeUtils.getFileExtension(path);
                mimetype = this.mimeUtils.getMimeType(extension);
            }
            if (mimetype && mimetypes.indexOf(mimetype) == -1) {
                extension = extension || this.translate.instant('core.unknown');
                return this.translate.instant('core.fileuploader.invalidfiletype', { $a: extension });
            }
        }
    };
    /**
     * Mark files as offline.
     *
     * @param {any[]} files Files to mark as offline.
     * @return {any[]} Files marked as offline.
     */
    CoreFileUploaderProvider.prototype.markOfflineFiles = function (files) {
        // Mark the files as pending offline.
        files.forEach(function (file) {
            file.offline = true;
            file.filename = file.name;
        });
        return files;
    };
    /**
     * Parse filetypeList to get the list of allowed mimetypes and the data to render information.
     *
     * @param {string} filetypeList Formatted string list where the mimetypes can be checked.
     * @return {{info: any[], mimetypes: string[]}}  Mimetypes and the filetypes informations. Undefined if all types supported.
     */
    CoreFileUploaderProvider.prototype.prepareFiletypeList = function (filetypeList) {
        var _this = this;
        filetypeList = filetypeList && filetypeList.trim();
        if (!filetypeList || filetypeList == '*') {
            // All types supported, return undefined.
            return undefined;
        }
        var filetypes = filetypeList.split(/[;, ]+/g), mimetypes = {}, // Use an object to prevent duplicates.
        typesInfo = [];
        filetypes.forEach(function (filetype) {
            filetype = filetype.trim();
            if (filetype) {
                if (filetype.indexOf('/') != -1) {
                    // It's a mimetype.
                    typesInfo.push({
                        name: _this.mimeUtils.getMimetypeDescription(filetype),
                        extlist: _this.mimeUtils.getExtensions(filetype).map(_this.addDot).join(' ')
                    });
                    mimetypes[filetype] = true;
                }
                else if (filetype.indexOf('.') === 0) {
                    // It's an extension.
                    var mimetype = _this.mimeUtils.getMimeType(filetype);
                    typesInfo.push({
                        name: mimetype ? _this.mimeUtils.getMimetypeDescription(mimetype) : false,
                        extlist: filetype
                    });
                    if (mimetype) {
                        mimetypes[mimetype] = true;
                    }
                }
                else {
                    // It's a group.
                    var groupExtensions = _this.mimeUtils.getGroupMimeInfo(filetype, 'extensions'), groupMimetypes = _this.mimeUtils.getGroupMimeInfo(filetype, 'mimetypes');
                    if (groupExtensions.length > 0) {
                        typesInfo.push({
                            name: _this.mimeUtils.getTranslatedGroupName(filetype),
                            extlist: groupExtensions ? groupExtensions.map(_this.addDot).join(' ') : ''
                        });
                        groupMimetypes.forEach(function (mimetype) {
                            if (mimetype) {
                                mimetypes[mimetype] = true;
                            }
                        });
                    }
                    else {
                        // Treat them as extensions.
                        filetype = _this.addDot(filetype);
                        var mimetype = _this.mimeUtils.getMimeType(filetype);
                        typesInfo.push({
                            name: mimetype ? _this.mimeUtils.getMimetypeDescription(mimetype) : false,
                            extlist: filetype
                        });
                        if (mimetype) {
                            mimetypes[mimetype] = true;
                        }
                    }
                }
            }
        });
        return {
            info: typesInfo,
            mimetypes: Object.keys(mimetypes)
        };
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be uploaded later.
     *
     * @param {string} folderPath Path of the folder where to store the files.
     * @param {any[]} files List of files.
     * @return {Promise<{online: any[], offline: number}>} Promise resolved if success.
     */
    CoreFileUploaderProvider.prototype.storeFilesToUpload = function (folderPath, files) {
        var _this = this;
        var result = {
            online: [],
            offline: 0
        };
        if (!files || !files.length) {
            return Promise.resolve(result);
        }
        // Remove unused files from previous saves.
        return this.fileProvider.removeUnusedFiles(folderPath, files).then(function () {
            var promises = [];
            files.forEach(function (file) {
                if (file.filename && !file.name) {
                    // It's an online file, add it to the result and ignore it.
                    result.online.push({
                        filename: file.filename,
                        fileurl: file.fileurl
                    });
                }
                else if (!file.name) {
                    // Error.
                    promises.push(Promise.reject(null));
                }
                else if (file.fullPath && file.fullPath.indexOf(folderPath) != -1) {
                    // File already in the submission folder.
                    result.offline++;
                }
                else {
                    // Local file, copy it.
                    // Use copy instead of move to prevent having a unstable state if some copies succeed and others don't.
                    var destFile = _this.textUtils.concatenatePaths(folderPath, file.name);
                    promises.push(_this.fileProvider.copyFile(file.toURL(), destFile));
                    result.offline++;
                }
            });
            return Promise.all(promises).then(function () {
                return result;
            });
        });
    };
    /**
     * Upload a file.
     *
     * @param {string} uri File URI.
     * @param {CoreFileUploaderOptions} [options] Options for the upload.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {string} [siteId] Id of the site to upload the file to. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileUploaderProvider.prototype.uploadFile = function (uri, options, onProgress, siteId) {
        var _this = this;
        options = options || {};
        var deleteAfterUpload = options.deleteAfterUpload, ftOptions = this.utils.clone(options);
        delete ftOptions.deleteAfterUpload;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.uploadFile(uri, ftOptions, onProgress);
        }).then(function (result) {
            if (deleteAfterUpload) {
                setTimeout(function () {
                    // Use set timeout, otherwise in Electron the upload threw an error sometimes.
                    _this.fileProvider.removeExternalFile(uri);
                }, 500);
            }
            return result;
        });
    };
    /**
     * Upload a file to a draft area and return the draft ID.
     *
     * If the file is an online file it will be downloaded and then re-uploaded.
     * If the file is a local file it will not be deleted from the device after upload.
     *
     * @param {any} file Online file or local FileEntry.
     * @param {number} [itemId] Draft ID to use. Undefined or 0 to create a new draft ID.
     * @param {string} [component] The component to set to the downloaded files.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the itemId.
     */
    CoreFileUploaderProvider.prototype.uploadOrReuploadFile = function (file, itemId, component, componentId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promise, fileName;
        var isOnline = file.filename && !file.name;
        if (isOnline) {
            // It's an online file. We need to download it and re-upload it.
            fileName = file.filename;
            promise = this.filepoolProvider.downloadUrl(siteId, file.url || file.fileurl, false, component, componentId, file.timemodified, undefined, undefined, file).then(function (path) {
                return _this.fileProvider.getExternalFile(path);
            });
        }
        else {
            // Local file, we already have the file entry.
            fileName = file.name;
            promise = Promise.resolve(file);
        }
        return promise.then(function (fileEntry) {
            // Now upload the file.
            var options = _this.getFileUploadOptions(fileEntry.toURL(), fileName, fileEntry.type, isOnline, 'draft', itemId);
            return _this.uploadFile(fileEntry.toURL(), options, undefined, siteId).then(function (result) {
                return result.itemid;
            });
        });
    };
    /**
     * Given a list of files (either online files or local files), upload them to a draft area and return the draft ID.
     *
     * Online files will be downloaded and then re-uploaded.
     * Local files are not deleted from the device after upload.
     * If there are no files to upload it will return a fake draft ID (1).
     *
     * @param {any[]} files List of files.
     * @param {string} [component] The component to set to the downloaded files.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the itemId.
     */
    CoreFileUploaderProvider.prototype.uploadOrReuploadFiles = function (files, component, componentId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!files || !files.length) {
            // Return fake draft ID.
            return Promise.resolve(1);
        }
        // Upload only the first file first to get a draft id.
        return this.uploadOrReuploadFile(files[0], 0, component, componentId, siteId).then(function (itemId) {
            var promises = [];
            for (var i = 1; i < files.length; i++) {
                var file = files[i];
                promises.push(_this.uploadOrReuploadFile(file, itemId, component, componentId, siteId));
            }
            return Promise.all(promises).then(function () {
                return itemId;
            });
        });
    };
    CoreFileUploaderProvider.LIMITED_SIZE_WARNING = 1048576; // 1 MB.
    CoreFileUploaderProvider.WIFI_SIZE_WARNING = 10485760; // 10 MB.
    CoreFileUploaderProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_7__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_11__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_4__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__ionic_native_media_capture__["a" /* MediaCapture */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_camera__["a" /* Camera */]])
    ], CoreFileUploaderProvider);
    return CoreFileUploaderProvider;
}());

//# sourceMappingURL=fileuploader.js.map

/***/ }),
/* 55 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Service to interact with plugins to be shown in user profile. Provides functions to register a plugin
 * and notify an update in the data.
 */
var CoreUserDelegate = /** @class */ (function (_super) {
    __extends(CoreUserDelegate, _super);
    function CoreUserDelegate(loggerProvider, sitesProvider, coursesProvider, eventsProvider, utils) {
        var _this = _super.call(this, 'CoreUserDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.loggerProvider = loggerProvider;
        _this.sitesProvider = sitesProvider;
        _this.coursesProvider = coursesProvider;
        _this.eventsProvider = eventsProvider;
        _this.utils = utils;
        _this.featurePrefix = 'CoreUserDelegate_';
        // Hold the handlers and the observable to notify them for each user.
        _this.userHandlers = {};
        eventsProvider.on(CoreUserDelegate_1.UPDATE_HANDLER_EVENT, function (data) {
            if (data && data.handler && _this.userHandlers[data.userId]) {
                var userData = _this.userHandlers[data.userId], handler = userData.handlers.find(function (userHandler) {
                    return userHandler.name == data.handler;
                });
                if (handler) {
                    for (var x in data.data) {
                        handler.data[x] = data.data[x];
                    }
                    userData.observable.next(userData.handlers);
                }
            }
        });
        return _this;
    }
    CoreUserDelegate_1 = CoreUserDelegate;
    /**
     * Check if handlers are loaded.
     *
     * @return {boolean} True if handlers are loaded, false otherwise.
     */
    CoreUserDelegate.prototype.areHandlersLoaded = function (userId) {
        return this.userHandlers[userId] && this.userHandlers[userId].loaded;
    };
    /**
     * Clear current user handlers.
     *
     * @param {number} userId The user to clear.
     */
    CoreUserDelegate.prototype.clearUserHandlers = function (userId) {
        var userData = this.userHandlers[userId];
        if (userData) {
            userData.handlers = [];
            userData.observable.next([]);
            userData.loaded = false;
        }
    };
    /**
     * Get the profile handlers for a user.
     *
     * @param {any} user The user object.
     * @param {number} courseId The course ID.
     * @return {Subject<CoreUserProfileHandlerToDisplay[]>} Resolved with the handlers.
     */
    CoreUserDelegate.prototype.getProfileHandlersFor = function (user, courseId) {
        var _this = this;
        var promise, navOptions, admOptions;
        if (this.coursesProvider.canGetAdminAndNavOptions()) {
            // Get course options.
            promise = this.coursesProvider.getUserCourses(true).then(function (courses) {
                var courseIds = courses.map(function (course) {
                    return course.id;
                });
                return _this.coursesProvider.getCoursesAdminAndNavOptions(courseIds).then(function (options) {
                    // For backwards compatibility we don't modify the courseId.
                    var courseIdForOptions = courseId || _this.sitesProvider.getCurrentSiteHomeId();
                    navOptions = options.navOptions[courseIdForOptions];
                    admOptions = options.admOptions[courseIdForOptions];
                });
            });
        }
        else {
            promise = Promise.resolve();
        }
        // Initialize the user handlers if it isn't initialized already.
        if (!this.userHandlers[user.id]) {
            this.userHandlers[user.id] = {
                loaded: false,
                handlers: [],
                observable: new __WEBPACK_IMPORTED_MODULE_7_rxjs__["BehaviorSubject"]([])
            };
        }
        var userData = this.userHandlers[user.id];
        userData.handlers = [];
        promise.then(function () {
            var promises = [];
            var _loop_1 = function (name_1) {
                // Checks if the handler is enabled for the user.
                var handler = _this.handlers[name_1], isEnabledForUser = handler.isEnabledForUser(user, courseId, navOptions, admOptions);
                promises.push(Promise.resolve(isEnabledForUser).then(function (enabled) {
                    if (enabled) {
                        userData.handlers.push({
                            name: name_1,
                            data: handler.getDisplayData(user, courseId),
                            priority: handler.priority,
                            type: handler.type || CoreUserDelegate_1.TYPE_NEW_PAGE
                        });
                    }
                }).catch(function () {
                    // Nothing to do here, it is not enabled for this user.
                }));
            };
            for (var name_1 in _this.enabledHandlers) {
                _loop_1(name_1);
            }
            return _this.utils.allPromises(promises).then(function () {
                // Sort them by priority.
                userData.handlers.sort(function (a, b) {
                    return b.priority - a.priority;
                });
                userData.loaded = true;
                userData.observable.next(userData.handlers);
            });
        }).catch(function () {
            // Never fails.
            userData.loaded = true;
            userData.observable.next(userData.handlers);
        });
        return userData.observable;
    };
    /**
     * User profile handler type for communication.
     * @type {string}
     */
    CoreUserDelegate.TYPE_COMMUNICATION = 'communication';
    /**
     * User profile handler type for new page.
     * @type {string}
     */
    CoreUserDelegate.TYPE_NEW_PAGE = 'newpage';
    /**
     * User profile handler type for actions.
     * @type {string}
     */
    CoreUserDelegate.TYPE_ACTION = 'action';
    /**
     * Update handler information event.
     * @type {string}
     */
    CoreUserDelegate.UPDATE_HANDLER_EVENT = 'CoreUserDelegate_update_handler_event';
    CoreUserDelegate = CoreUserDelegate_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreUserDelegate);
    return CoreUserDelegate;
    var CoreUserDelegate_1;
}(__WEBPACK_IMPORTED_MODULE_1__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=user-delegate.js.map

/***/ }),
/* 56 */,
/* 57 */,
/* 58 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCronDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/*
 * Service to handle cron processes. The registered processes will be executed every certain time.
*/
var CoreCronDelegate = /** @class */ (function () {
    function CoreCronDelegate(logger, appProvider, configProvider, utils, network, zone) {
        var _this = this;
        this.appProvider = appProvider;
        this.configProvider = configProvider;
        this.utils = utils;
        // Variables for database.
        this.CRON_TABLE = 'cron';
        this.tableSchema = {
            name: this.CRON_TABLE,
            columns: [
                {
                    name: 'id',
                    type: 'TEXT',
                    primaryKey: true
                },
                {
                    name: 'value',
                    type: 'INTEGER'
                }
            ]
        };
        this.handlers = {};
        this.queuePromise = Promise.resolve();
        this.logger = logger.getInstance('CoreCronDelegate');
        this.appDB = this.appProvider.getDB();
        this.appDB.createTableFromSchema(this.tableSchema);
        // When the app is re-connected, start network handlers that were stopped.
        network.onConnect().subscribe(function () {
            // Execute the callback in the Angular zone, so change detection doesn't stop working.
            zone.run(function () {
                _this.startNetworkHandlers();
            });
        });
    }
    CoreCronDelegate_1 = CoreCronDelegate;
    /**
     * Try to execute a handler. It will schedule the next execution once done.
     * If the handler cannot be executed or it fails, it will be re-executed after mmCoreCronMinInterval.
     *
     * @param {string} name Name of the handler.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @param {string}  [siteId] Site ID. If not defined, all sites.
     * @return {Promise<any>} Promise resolved if handler is executed successfully, rejected otherwise.
     */
    CoreCronDelegate.prototype.checkAndExecuteHandler = function (name, force, siteId) {
        var _this = this;
        if (!this.handlers[name] || !this.handlers[name].execute) {
            // Invalid handler.
            this.logger.debug('Cannot execute handler because is invalid: ' + name);
            return Promise.reject(null);
        }
        var usesNetwork = this.handlerUsesNetwork(name), isSync = !force && this.isHandlerSync(name);
        var promise;
        if (usesNetwork && !this.appProvider.isOnline()) {
            // Offline, stop executing.
            this.logger.debug('Cannot execute handler because device is offline: ' + name);
            this.stopHandler(name);
            return Promise.reject(null);
        }
        if (isSync) {
            // Check network connection.
            promise = this.configProvider.get(__WEBPACK_IMPORTED_MODULE_6__core_constants__["a" /* CoreConstants */].SETTINGS_SYNC_ONLY_ON_WIFI, false).then(function (syncOnlyOnWifi) {
                return !syncOnlyOnWifi || _this.appProvider.isWifi();
            });
        }
        else {
            promise = Promise.resolve(true);
        }
        return promise.then(function (execute) {
            if (!execute) {
                // Cannot execute in this network connection, retry soon.
                _this.logger.debug('Cannot execute handler because device is using limited connection: ' + name);
                _this.scheduleNextExecution(name, CoreCronDelegate_1.MIN_INTERVAL);
                return Promise.reject(null);
            }
            // Add the execution to the queue.
            _this.queuePromise = _this.queuePromise.catch(function () {
                // Ignore errors in previous handlers.
            }).then(function () {
                return _this.executeHandler(name, force, siteId).then(function () {
                    _this.logger.debug("Execution of handler '" + name + "' was a success.");
                    return _this.setHandlerLastExecutionTime(name, Date.now()).then(function () {
                        _this.scheduleNextExecution(name);
                    });
                }, function (error) {
                    // Handler call failed. Retry soon.
                    _this.logger.error("Execution of handler '" + name + "' failed.", error);
                    _this.scheduleNextExecution(name, CoreCronDelegate_1.MIN_INTERVAL);
                    return Promise.reject(null);
                });
            });
            return _this.queuePromise;
        });
    };
    /**
     * Run a handler, cancelling the execution if it takes more than MAX_TIME_PROCESS.
     *
     * @param {string} name Name of the handler.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @param {string} [siteId] Site ID. If not defined, all sites.
     * @return {Promise<any>} Promise resolved when the handler finishes or reaches max time, rejected if it fails.
     */
    CoreCronDelegate.prototype.executeHandler = function (name, force, siteId) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var cancelTimeout;
            _this.logger.debug('Executing handler: ' + name);
            // Wrap the call in Promise.resolve to make sure it's a promise.
            Promise.resolve(_this.handlers[name].execute(siteId, force)).then(resolve).catch(reject).finally(function () {
                clearTimeout(cancelTimeout);
            });
            cancelTimeout = setTimeout(function () {
                // The handler took too long. Resolve because we don't want to retry soon.
                _this.logger.debug("Resolving execution of handler '" + name + "' because it took too long.");
                resolve();
            }, CoreCronDelegate_1.MAX_TIME_PROCESS);
        });
    };
    /**
     * Force execution of synchronization cron tasks without waiting for the scheduled time.
     * Please notice that some tasks may not be executed depending on the network connection and sync settings.
     *
     * @param {string} [siteId] Site ID. If not defined, all sites.
     * @return {Promise<any>} Promise resolved if all handlers are executed successfully, rejected otherwise.
     */
    CoreCronDelegate.prototype.forceSyncExecution = function (siteId) {
        var promises = [];
        for (var name_1 in this.handlers) {
            if (this.isHandlerManualSync(name_1)) {
                // Now force the execution of the handler.
                promises.push(this.forceCronHandlerExecution(name_1, siteId));
            }
        }
        return this.utils.allPromises(promises);
    };
    /**
     * Force execution of a cron tasks without waiting for the scheduled time.
     * Please notice that some tasks may not be executed depending on the network connection and sync settings.
     *
     * @param {string} [name]  If provided, the name of the handler.
     * @param {string} [siteId] Site ID. If not defined, all sites.
     * @return {Promise<any>} Promise resolved if handler has been executed successfully, rejected otherwise.
     */
    CoreCronDelegate.prototype.forceCronHandlerExecution = function (name, siteId) {
        var handler = this.handlers[name];
        // Mark the handler as running (it might be running already).
        handler.running = true;
        // Cancel pending timeout.
        clearTimeout(handler.timeout);
        delete handler.timeout;
        // Now force the execution of the handler.
        return this.checkAndExecuteHandler(name, true, siteId);
    };
    /**
     * Get a handler's interval.
     *
     * @param {string} name Handler's name.
     * @return {number} Handler's interval.
     */
    CoreCronDelegate.prototype.getHandlerInterval = function (name) {
        if (!this.handlers[name] || !this.handlers[name].getInterval) {
            // Invalid, return default.
            return CoreCronDelegate_1.DEFAULT_INTERVAL;
        }
        // Don't allow intervals lower than the minimum.
        var minInterval = this.appProvider.isDesktop() ? CoreCronDelegate_1.DESKTOP_MIN_INTERVAL : CoreCronDelegate_1.MIN_INTERVAL, handlerInterval = this.handlers[name].getInterval();
        if (!handlerInterval) {
            return CoreCronDelegate_1.DEFAULT_INTERVAL;
        }
        else {
            return Math.max(minInterval, handlerInterval);
        }
    };
    /**
     * Get a handler's last execution ID.
     *
     * @param {string} name Handler's name.
     * @return {string} Handler's last execution ID.
     */
    CoreCronDelegate.prototype.getHandlerLastExecutionId = function (name) {
        return 'last_execution_' + name;
    };
    /**
     * Get a handler's last execution time. If not defined, return 0.
     *
     * @param {string} name Handler's name.
     * @return {Promise<number>} Promise resolved with the handler's last execution time.
     */
    CoreCronDelegate.prototype.getHandlerLastExecutionTime = function (name) {
        var id = this.getHandlerLastExecutionId(name);
        return this.appDB.getRecord(this.CRON_TABLE, { id: id }).then(function (entry) {
            var time = parseInt(entry.value, 10);
            return isNaN(time) ? 0 : time;
        }).catch(function () {
            return 0; // Not set, return 0.
        });
    };
    /**
     * Check if a handler uses network. Defaults to true.
     *
     * @param {string} name Handler's name.
     * @return {boolean} True if handler uses network or not defined, false otherwise.
     */
    CoreCronDelegate.prototype.handlerUsesNetwork = function (name) {
        if (!this.handlers[name] || !this.handlers[name].usesNetwork) {
            // Invalid, return default.
            return true;
        }
        return this.handlers[name].usesNetwork();
    };
    /**
     * Check if there is any manual sync handler registered.
     *
     * @return {boolean} Whether it has at least 1 manual sync handler.
     */
    CoreCronDelegate.prototype.hasManualSyncHandlers = function () {
        for (var name_2 in this.handlers) {
            if (this.isHandlerManualSync(name_2)) {
                return true;
            }
        }
        return false;
    };
    /**
     * Check if there is any sync handler registered.
     *
     * @return {boolean} Whether it has at least 1 sync handler.
     */
    CoreCronDelegate.prototype.hasSyncHandlers = function () {
        for (var name_3 in this.handlers) {
            if (this.isHandlerSync(name_3)) {
                return true;
            }
        }
        return false;
    };
    /**
     * Check if a handler can be manually synced. Defaults will use isSync instead.
     *
     * @param {string} name Handler's name.
     * @return {boolean} True if handler is a sync process and can be manually executed or not defined, false otherwise.
     */
    CoreCronDelegate.prototype.isHandlerManualSync = function (name) {
        if (!this.handlers[name] || !this.handlers[name].canManualSync) {
            // Invalid, return default.
            return this.isHandlerSync(name);
        }
        return this.handlers[name].canManualSync();
    };
    /**
     * Check if a handler is a sync process. Defaults to true.
     *
     * @param {string} name Handler's name.
     * @return {boolean} True if handler is a sync process or not defined, false otherwise.
     */
    CoreCronDelegate.prototype.isHandlerSync = function (name) {
        if (!this.handlers[name] || !this.handlers[name].isSync) {
            // Invalid, return default.
            return true;
        }
        return this.handlers[name].isSync();
    };
    /**
     * Register a handler to be executed every certain time.
     *
     * @param {CoreCronHandler} handler The handler to register.
     */
    CoreCronDelegate.prototype.register = function (handler) {
        if (!handler || !handler.name) {
            // Invalid handler.
            return;
        }
        if (typeof this.handlers[handler.name] != 'undefined') {
            this.logger.debug("The cron handler '" + handler.name + "' is already registered.");
            return;
        }
        this.logger.debug("Register handler '" + handler.name + "' in cron.");
        handler.running = false;
        this.handlers[handler.name] = handler;
        // Start the handler.
        this.startHandler(handler.name);
    };
    /**
     * Schedule a next execution for a handler.
     *
     * @param {string} name Name of the handler.
     * @param {number} [time] Time to the next execution. If not supplied it will be calculated using the last execution and
     *                        the handler's interval. This param should be used only if it's really necessary.
     */
    CoreCronDelegate.prototype.scheduleNextExecution = function (name, time) {
        var _this = this;
        if (!this.handlers[name]) {
            // Invalid handler.
            return;
        }
        if (this.handlers[name].timeout) {
            // There's already a pending timeout.
            return;
        }
        var promise;
        if (time) {
            promise = Promise.resolve(time);
        }
        else {
            // Get last execution time to check when do we need to execute it.
            promise = this.getHandlerLastExecutionTime(name).then(function (lastExecution) {
                var interval = _this.getHandlerInterval(name), nextExecution = lastExecution + interval;
                return nextExecution - Date.now();
            });
        }
        promise.then(function (nextExecution) {
            _this.logger.debug("Scheduling next execution of handler '" + name + "' in '" + nextExecution + "' ms");
            if (nextExecution < 0) {
                nextExecution = 0; // Big negative numbers aren't executed immediately.
            }
            _this.handlers[name].timeout = setTimeout(function () {
                delete _this.handlers[name].timeout;
                _this.checkAndExecuteHandler(name).catch(function () {
                    // Ignore errors.
                });
            }, nextExecution);
        });
    };
    /**
     * Set a handler's last execution time.
     *
     * @param {string} name Handler's name.
     * @param {number} time Time to set.
     * @return {Promise}    Promise resolved when the execution time is saved.
     */
    CoreCronDelegate.prototype.setHandlerLastExecutionTime = function (name, time) {
        var id = this.getHandlerLastExecutionId(name), entry = {
            id: id,
            value: time
        };
        return this.appDB.insertRecord(this.CRON_TABLE, entry);
    };
    /**
     * Start running a handler periodically.
     *
     * @param {string} name Name of the handler.
     */
    CoreCronDelegate.prototype.startHandler = function (name) {
        if (!this.handlers[name]) {
            // Invalid handler.
            this.logger.debug("Cannot start handler '" + name + "', is invalid.");
            return;
        }
        if (this.handlers[name].running) {
            this.logger.debug("Handler '" + name + "', is already running.");
            return;
        }
        this.handlers[name].running = true;
        this.scheduleNextExecution(name);
    };
    /**
     * Start running periodically the handlers that use network.
     */
    CoreCronDelegate.prototype.startNetworkHandlers = function () {
        for (var name_4 in this.handlers) {
            if (this.handlerUsesNetwork(name_4)) {
                this.startHandler(name_4);
            }
        }
    };
    /**
     * Stop running a handler periodically.
     *
     * @param {string} name Name of the handler.
     */
    CoreCronDelegate.prototype.stopHandler = function (name) {
        if (!this.handlers[name]) {
            // Invalid handler.
            this.logger.debug("Cannot stop handler '" + name + "', is invalid.");
            return;
        }
        if (!this.handlers[name].running) {
            this.logger.debug("Cannot stop handler '" + name + "', it's not running.");
            return;
        }
        this.handlers[name].running = false;
        clearTimeout(this.handlers[name].timeout);
        delete this.handlers[name].timeout;
    };
    // Constants.
    CoreCronDelegate.DEFAULT_INTERVAL = 3600000; // Default interval is 1 hour.
    CoreCronDelegate.MIN_INTERVAL = 300000; // Minimum interval is 5 minutes.
    CoreCronDelegate.DESKTOP_MIN_INTERVAL = 60000; // Minimum interval in desktop is 1 minute.
    CoreCronDelegate.MAX_TIME_PROCESS = 120000; // Max time a process can block the queue. Defaults to 2 minutes.
    CoreCronDelegate = CoreCronDelegate_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__config__["a" /* CoreConfigProvider */],
            __WEBPACK_IMPORTED_MODULE_5__utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ionic_native_network__["a" /* Network */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"]])
    ], CoreCronDelegate);
    return CoreCronDelegate;
    var CoreCronDelegate_1;
}());

//# sourceMappingURL=cron.js.map

/***/ }),
/* 59 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContentLinksModuleListHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(28);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Handler to handle URLs pointing to a list of a certain type of modules.
 */
var CoreContentLinksModuleListHandler = /** @class */ (function (_super) {
    __extends(CoreContentLinksModuleListHandler, _super);
    /**
     * Construct the handler.
     *
     * @param {CoreContentLinksHelperProvider} linkHelper The CoreContentLinksHelperProvider instance.
     * @param {TranslateService} translate The TranslateService instance.
     * @param {string} addon Name of the addon as it's registered in course delegate. It'll be used to check if it's disabled.
     * @param {string} modName Name of the module (assign, book, ...).
     */
    function CoreContentLinksModuleListHandler(linkHelper, translate, addon, modName) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.translate = translate;
        _this.addon = addon;
        _this.modName = modName;
        // Match the view.php URL with an id param.
        _this.pattern = new RegExp('\/mod\/' + modName + '\/index\.php.*([\&\?]id=\\d+)');
        _this.featureName = 'CoreCourseModuleDelegate_' + addon;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreContentLinksModuleListHandler.prototype.getActions = function (siteIds, url, params) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var stateParams = {
                        courseId: params.id,
                        modName: _this.modName,
                        title: _this.title || _this.translate.instant('addon.mod_' + _this.modName + '.modulenameplural')
                    };
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, 'CoreCourseListModTypePage', stateParams, siteId);
                }
            }];
    };
    return CoreContentLinksModuleListHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=module-list-handler.js.map

/***/ }),
/* 60 */,
/* 61 */,
/* 62 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__providers_events__ = __webpack_require__(12);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Superclass to help creating delegates
 */
var CoreDelegate = /** @class */ (function () {
    /**
     * Constructor of the Delegate.
     *
     * @param {string} delegateName Delegate name used for logging purposes.
     * @param {CoreLoggerProvider}   loggerProvider CoreLoggerProvider instance, cannot be directly injected.
     * @param {CoreSitesProvider}    sitesProvider  CoreSitesProvider instance, cannot be directly injected.
     * @param {CoreEventsProvider}   [eventsProvider]  CoreEventsProvider instance, cannot be directly injected.
     *                                                  If not set, no events will be fired.
     */
    function CoreDelegate(delegateName, loggerProvider, sitesProvider, eventsProvider) {
        this.loggerProvider = loggerProvider;
        this.sitesProvider = sitesProvider;
        this.eventsProvider = eventsProvider;
        /**
         * List of registered handlers.
         * @type {any}
         */
        this.handlers = {};
        /**
         * List of registered handlers enabled for the current site.
         * @type {any}
         */
        this.enabledHandlers = {};
        /**
         * Name of the property to be used to index the handlers. By default, the handler's name will be used.
         * If your delegate uses a Moodle component name to identify the handlers, please override this property.
         * E.g. CoreCourseModuleDelegate uses 'modName' to index the handlers.
         * @type {string}
         */
        this.handlerNameProperty = 'name';
        /**
         * Set of promises to update a handler, to prevent doing the same operation twice.
         * @type {{[siteId: string]: {[name: string]: Promise<any>}}}
         */
        this.updatePromises = {};
        this.logger = this.loggerProvider.getInstance(delegateName);
        if (eventsProvider) {
            // Update handlers on this cases.
            eventsProvider.on(__WEBPACK_IMPORTED_MODULE_0__providers_events__["a" /* CoreEventsProvider */].LOGIN, this.updateHandlers.bind(this));
            eventsProvider.on(__WEBPACK_IMPORTED_MODULE_0__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, this.updateHandlers.bind(this));
            eventsProvider.on(__WEBPACK_IMPORTED_MODULE_0__providers_events__["a" /* CoreEventsProvider */].SITE_PLUGINS_LOADED, this.updateHandlers.bind(this));
        }
    }
    /**
     * Execute a certain function in a enabled handler.
     * If the handler isn't found or function isn't defined, call the same function in the default handler.
     *
     * @param {string} handlerName The handler name.
     * @param {string} fnName Name of the function to execute.
     * @param {any[]} params Parameters to pass to the function.
     * @return {any} Function returned value or default value.
     */
    CoreDelegate.prototype.executeFunctionOnEnabled = function (handlerName, fnName, params) {
        return this.execute(this.enabledHandlers[handlerName], fnName, params);
    };
    /**
     * Execute a certain function in a handler.
     * If the handler isn't found or function isn't defined, call the same function in the default handler.
     *
     * @param {string} handlerName The handler name.
     * @param {string} fnName Name of the function to execute.
     * @param {any[]} params Parameters to pass to the function.
     * @return {any} Function returned value or default value.
     */
    CoreDelegate.prototype.executeFunction = function (handlerName, fnName, params) {
        return this.execute(this.handlers[handlerName], fnName, params);
    };
    /**
     * Execute a certain function in a handler.
     * If the handler isn't found or function isn't defined, call the same function in the default handler.
     *
     * @param {any} handler The handler.
     * @param {string} fnName Name of the function to execute.
     * @param {any[]} params Parameters to pass to the function.
     * @return {any} Function returned value or default value.
     */
    CoreDelegate.prototype.execute = function (handler, fnName, params) {
        if (handler && handler[fnName]) {
            return handler[fnName].apply(handler, params);
        }
        else if (this.defaultHandler && this.defaultHandler[fnName]) {
            return this.defaultHandler[fnName].apply(this.defaultHandler, params);
        }
    };
    /**
     * Get a handler.
     *
     * @param  {string} handlerName The handler name.
     * @param  {boolean} [enabled]  Only enabled, or any.
     * @return {CoreDelegateHandler} Handler.
     */
    CoreDelegate.prototype.getHandler = function (handlerName, enabled) {
        if (enabled === void 0) { enabled = false; }
        return enabled ? this.enabledHandlers[handlerName] : this.handlers[handlerName];
    };
    /**
     * Gets the handler full name for a given name. This is useful when the handlerNameProperty is different than "name".
     * E.g. blocks are indexed by blockName. If you call this function passing the blockName it will return the name.
     *
     * @param {string} name Name used to indentify the handler.
     * @return {string} Full name of corresponding handler.
     */
    CoreDelegate.prototype.getHandlerName = function (name) {
        var handler = this.getHandler(name, true);
        if (!handler) {
            return '';
        }
        return handler.name;
    };
    /**
     * Check if function exists on a handler.
     *
     * @param {string} handlerName         The handler name.
     * @param {string} fnName              Name of the function to execute.
     * @param {booealn} [onlyEnabled=true] If check only enabled handlers or all.
     * @return {any} Function returned value or default value.
     */
    CoreDelegate.prototype.hasFunction = function (handlerName, fnName, onlyEnabled) {
        if (onlyEnabled === void 0) { onlyEnabled = true; }
        var handler = onlyEnabled ? this.enabledHandlers[handlerName] : this.handlers[handlerName];
        return handler && handler[fnName];
    };
    /**
     * Check if a handler name has a registered handler (not necessarily enabled).
     *
     * @param {string} name The handler name.
     * @param  {boolean} [enabled]  Only enabled, or any.
     * @return {boolean} If the handler is registered or not.
     */
    CoreDelegate.prototype.hasHandler = function (name, enabled) {
        if (enabled === void 0) { enabled = false; }
        return enabled ? typeof this.enabledHandlers[name] !== 'undefined' : typeof this.handlers[name] !== 'undefined';
    };
    /**
     * Check if a time belongs to the last update handlers call.
     * This is to handle the cases where updateHandlers don't finish in the same order as they're called.
     *
     * @param {number} time Time to check.
     * @return {boolean} Whether it's the last call.
     */
    CoreDelegate.prototype.isLastUpdateCall = function (time) {
        if (!this.lastUpdateHandlersStart) {
            return true;
        }
        return time == this.lastUpdateHandlersStart;
    };
    /**
     * Register a handler.
     *
     * @param {CoreDelegateHandler} handler The handler delegate object to register.
     * @return {boolean} True when registered, false if already registered.
     */
    CoreDelegate.prototype.registerHandler = function (handler) {
        if (typeof this.handlers[handler[this.handlerNameProperty]] !== 'undefined') {
            this.logger.log("Handler '" + handler[this.handlerNameProperty] + "' already registered");
            return false;
        }
        this.logger.log("Registered handler '" + handler[this.handlerNameProperty] + "'");
        this.handlers[handler[this.handlerNameProperty]] = handler;
        return true;
    };
    /**
     * Update the handler for the current site.
     *
     * @param {CoreDelegateHandler} handler The handler to check.
     * @param {number} time Time this update process started.
     * @return {Promise<void>} Resolved when done.
     */
    CoreDelegate.prototype.updateHandler = function (handler, time) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId(), currentSite = this.sitesProvider.getCurrentSite();
        var promise;
        if (this.updatePromises[siteId] && this.updatePromises[siteId][handler.name]) {
            // There's already an update ongoing for this handler, return the promise.
            return this.updatePromises[siteId][handler.name];
        }
        else if (!this.updatePromises[siteId]) {
            this.updatePromises[siteId] = {};
        }
        if (!this.sitesProvider.isLoggedIn()) {
            promise = Promise.reject(null);
        }
        else if (this.isFeatureDisabled(handler, currentSite)) {
            promise = Promise.resolve(false);
        }
        else {
            promise = Promise.resolve(handler.isEnabled());
        }
        // Checks if the handler is enabled.
        this.updatePromises[siteId][handler.name] = promise.catch(function () {
            return false;
        }).then(function (enabled) {
            // Check that site hasn't changed since the check started.
            if (_this.sitesProvider.getCurrentSiteId() === siteId) {
                if (enabled) {
                    _this.enabledHandlers[handler[_this.handlerNameProperty]] = handler;
                }
                else {
                    delete _this.enabledHandlers[handler[_this.handlerNameProperty]];
                }
            }
        }).finally(function () {
            // Update finished, delete the promise.
            delete _this.updatePromises[siteId][handler.name];
        });
        return this.updatePromises[siteId][handler.name];
    };
    /**
     * Check if feature is enabled or disabled in the site, depending on the feature prefix and the handler name.
     *
     * @param  {CoreDelegateHandler} handler Handler to check.
     * @param  {CoreSite} site Site to check.
     * @return {boolean} Whether is enabled or disabled in site.
     */
    CoreDelegate.prototype.isFeatureDisabled = function (handler, site) {
        return typeof this.featurePrefix != 'undefined' && site.isFeatureDisabled(this.featurePrefix + handler.name);
    };
    /**
     * Update the handlers for the current site.
     *
     * @return {Promise<void>} Resolved when done.
     */
    CoreDelegate.prototype.updateHandlers = function () {
        var _this = this;
        var promises = [], now = Date.now();
        this.logger.debug('Updating handlers for current site.');
        this.lastUpdateHandlersStart = now;
        // Loop over all the handlers.
        for (var name_1 in this.handlers) {
            promises.push(this.updateHandler(this.handlers[name_1], now));
        }
        return Promise.all(promises).then(function () {
            return true;
        }, function () {
            // Never reject.
            return true;
        }).then(function () {
            // Verify that this call is the last one that was started.
            if (_this.isLastUpdateCall(now)) {
                _this.updateData();
            }
        });
    };
    /**
     * Update handlers Data.
     * Override this function to update handlers data.
     */
    CoreDelegate.prototype.updateData = function () {
        // To be overridden.
    };
    return CoreDelegate;
}());

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 63 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CorePipesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__bytes_to_size__ = __webpack_require__(1335);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__create_links__ = __webpack_require__(1336);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__date_day_or_time__ = __webpack_require__(1337);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__duration__ = __webpack_require__(1338);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__format_date__ = __webpack_require__(1339);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__no_tags__ = __webpack_require__(1340);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__seconds_to_hms__ = __webpack_require__(1341);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__time_ago__ = __webpack_require__(1342);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__to_locale_string__ = __webpack_require__(1343);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};










var CorePipesModule = /** @class */ (function () {
    function CorePipesModule() {
    }
    CorePipesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_1__bytes_to_size__["a" /* CoreBytesToSizePipe */],
                __WEBPACK_IMPORTED_MODULE_2__create_links__["a" /* CoreCreateLinksPipe */],
                __WEBPACK_IMPORTED_MODULE_3__date_day_or_time__["a" /* CoreDateDayOrTimePipe */],
                __WEBPACK_IMPORTED_MODULE_4__duration__["a" /* CoreDurationPipe */],
                __WEBPACK_IMPORTED_MODULE_5__format_date__["a" /* CoreFormatDatePipe */],
                __WEBPACK_IMPORTED_MODULE_6__no_tags__["a" /* CoreNoTagsPipe */],
                __WEBPACK_IMPORTED_MODULE_7__seconds_to_hms__["a" /* CoreSecondsToHMSPipe */],
                __WEBPACK_IMPORTED_MODULE_8__time_ago__["a" /* CoreTimeAgoPipe */],
                __WEBPACK_IMPORTED_MODULE_9__to_locale_string__["a" /* CoreToLocaleStringPipe */]
            ],
            imports: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_1__bytes_to_size__["a" /* CoreBytesToSizePipe */],
                __WEBPACK_IMPORTED_MODULE_2__create_links__["a" /* CoreCreateLinksPipe */],
                __WEBPACK_IMPORTED_MODULE_3__date_day_or_time__["a" /* CoreDateDayOrTimePipe */],
                __WEBPACK_IMPORTED_MODULE_4__duration__["a" /* CoreDurationPipe */],
                __WEBPACK_IMPORTED_MODULE_5__format_date__["a" /* CoreFormatDatePipe */],
                __WEBPACK_IMPORTED_MODULE_6__no_tags__["a" /* CoreNoTagsPipe */],
                __WEBPACK_IMPORTED_MODULE_7__seconds_to_hms__["a" /* CoreSecondsToHMSPipe */],
                __WEBPACK_IMPORTED_MODULE_8__time_ago__["a" /* CoreTimeAgoPipe */],
                __WEBPACK_IMPORTED_MODULE_9__to_locale_string__["a" /* CoreToLocaleStringPipe */]
            ]
        })
    ], CorePipesModule);
    return CorePipesModule;
}());

//# sourceMappingURL=pipes.module.js.map

/***/ }),
/* 64 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(191);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service that provides some features for databases.
 */
var AddonModDataProvider = /** @class */ (function () {
    function AddonModDataProvider(logger, sitesProvider, utils, filepoolProvider, dataOffline, appProvider, fieldsDelegate, logHelper) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.filepoolProvider = filepoolProvider;
        this.dataOffline = dataOffline;
        this.appProvider = appProvider;
        this.fieldsDelegate = fieldsDelegate;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = AddonModDataProvider_1.COMPONENT + ':';
        this.logger = logger.getInstance('AddonModDataProvider');
    }
    AddonModDataProvider_1 = AddonModDataProvider;
    /**
     * Adds a new entry to a database.
     *
     * @param   {number}  dataId          Data instance ID.
     * @param   {number}  entryId         EntryId or provisional entry ID when offline.
     * @param   {number}  courseId        Course ID.
     * @param   {any}     contents        The fields data to be created.
     * @param   {number}  [groupId]       Group id, 0 means that the function will determine the user group.
     * @param   {any[]}   fields          The fields that define the contents.
     * @param   {string}  [siteId]        Site ID. If not defined, current site.
     * @param   {boolean} [forceOffline]  Force editing entry in offline.
     * @return  {Promise<any>}            Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.addEntry = function (dataId, entryId, courseId, contents, groupId, fields, siteId, forceOffline) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (forceOffline === void 0) { forceOffline = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a data to be synchronized later.
        var storeOffline = function () {
            return _this.dataOffline.saveEntry(dataId, entryId, 'add', courseId, groupId, contents, undefined, siteId)
                .then(function (entry) {
                return {
                    // Return provissional entry Id.
                    newentryid: entry
                };
            });
        };
        if (!this.appProvider.isOnline() || forceOffline) {
            var notifications = this.checkFields(fields, contents);
            if (notifications) {
                return Promise.resolve({
                    fieldnotifications: notifications
                });
            }
            return storeOffline();
        }
        return this.addEntryOnline(dataId, contents, groupId, siteId).catch(function (error) {
            if (_this.utils.isWebServiceError(error)) {
                // The WebService has thrown an error, this means that responses cannot be submitted.
                return Promise.reject(error);
            }
            // Couldn't connect to server, store in offline.
            return storeOffline();
        });
    };
    /**
     * Adds a new entry to a database. It does not cache calls. It will fail if offline or cannot connect.
     *
     * @param   {number} dataId     Database ID.
     * @param   {any[]}  data       The fields data to be created.
     * @param   {number} [groupId]  Group id, 0 means that the function will determine the user group.
     * @param   {string} [siteId]   Site ID. If not defined, current site.
     * @return  {Promise<any>}      Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.addEntryOnline = function (dataId, data, groupId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                databaseid: dataId,
                data: data
            };
            if (typeof groupId !== 'undefined') {
                params['groupid'] = groupId;
            }
            return site.write('mod_data_add_entry', params);
        });
    };
    /**
     * Approves or unapproves an entry.
     *
     * @param   {number}    dataId      Database ID.
     * @param   {number}    entryId     Entry ID.
     * @param   {boolean}   approve     Whether to approve (true) or unapprove the entry.
     * @param   {number}    courseId    Course ID.
     * @param   {string}    [siteId]    Site ID. If not defined, current site.
     * @return  {Promise<any>}          Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.approveEntry = function (dataId, entryId, approve, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a data to be synchronized later.
        var storeOffline = function () {
            var action = approve ? 'approve' : 'disapprove';
            return _this.dataOffline.saveEntry(dataId, entryId, action, courseId, undefined, undefined, undefined, siteId);
        };
        // Get if the opposite action is not synced.
        var oppositeAction = approve ? 'disapprove' : 'approve';
        return this.dataOffline.getEntry(dataId, entryId, oppositeAction, siteId).then(function () {
            // Found. Just delete the action.
            return _this.dataOffline.deleteEntry(dataId, entryId, oppositeAction, siteId);
        }).catch(function () {
            if (!_this.appProvider.isOnline()) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.approveEntryOnline(entryId, approve, siteId).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that responses cannot be submitted.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store in offline.
                return storeOffline();
            });
        });
    };
    /**
     * Approves or unapproves an entry. It does not cache calls. It will fail if offline or cannot connect.
     *
     * @param   {number}    entryId  Entry ID.
     * @param   {boolean}   approve  Whether to approve (true) or unapprove the entry.
     * @param   {string}    [siteId] Site ID. If not defined, current site.
     * @return  {Promise<any>}       Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.approveEntryOnline = function (entryId, approve, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                entryid: entryId,
                approve: approve ? 1 : 0
            };
            return site.write('mod_data_approve_entry', params);
        });
    };
    /**
     * Convenience function to check fields requeriments here named "notifications".
     *
     * @param   {any}    fields    The fields that define the contents.
     * @param   {any}    contents  The contents data of the fields.
     * @return  {any}            Array of notifications if any or false.
     */
    AddonModDataProvider.prototype.checkFields = function (fields, contents) {
        var _this = this;
        var notifications = [], contentsIndexed = {};
        contents.forEach(function (content) {
            if (typeof contentsIndexed[content.fieldid] == 'undefined') {
                contentsIndexed[content.fieldid] = [];
            }
            contentsIndexed[content.fieldid].push(content);
        });
        // App is offline, check required fields.
        Object.keys(fields).forEach(function (key) {
            var field = fields[key], notification = _this.fieldsDelegate.getFieldsNotifications(field, contentsIndexed[field.id]);
            if (notification) {
                notifications.push({
                    fieldname: field.name,
                    notification: notification
                });
            }
        });
        return notifications.length ? notifications : false;
    };
    /**
     * Deletes an entry.
     *
     * @param   {number}    dataId     Database ID.
     * @param   {number}    entryId    Entry ID.
     * @param   {number}    courseId   Course ID.
     * @param   {string}    [siteId]   Site ID. If not defined, current site.
     * @return  {Promise<any>}         Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.deleteEntry = function (dataId, entryId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a data to be synchronized later.
        var storeOffline = function () {
            return _this.dataOffline.saveEntry(dataId, entryId, 'delete', courseId, undefined, undefined, undefined, siteId);
        };
        var justAdded = false;
        // Check if the opposite action is not synced and just delete it.
        return this.dataOffline.getEntryActions(dataId, entryId, siteId).then(function (entries) {
            if (entries && entries.length) {
                // Found. Delete other actions first.
                var proms = entries.map(function (entry) {
                    if (entry.action == 'add') {
                        justAdded = true;
                    }
                    return _this.dataOffline.deleteEntry(dataId, entryId, entry.action, siteId);
                });
                return Promise.all(proms);
            }
        }).then(function () {
            if (justAdded) {
                // The field was added offline, delete and stop.
                return;
            }
            if (!_this.appProvider.isOnline()) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.deleteEntryOnline(entryId, siteId).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that responses cannot be submitted.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store in offline.
                return storeOffline();
            });
        });
    };
    /**
     * Deletes an entry. It does not cache calls. It will fail if offline or cannot connect.
     *
     * @param   {number}  entryId  Entry ID.
     * @param   {string}  [siteId] Site ID. If not defined, current site.
     * @return  {Promise<any>}     Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.deleteEntryOnline = function (entryId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                entryid: entryId
            };
            return site.write('mod_data_delete_entry', params);
        });
    };
    /**
     * Updates an existing entry.
     *
     * @param   {number}  dataId          Database ID.
     * @param   {number}  entryId         Entry ID.
     * @param   {number}  courseId        Course ID.
     * @param   {any[]}   contents        The contents data to be updated.
     * @param   {any}     fields          The fields that define the contents.
     * @param   {string}  [siteId]        Site ID. If not defined, current site.
     * @param   {boolean} forceOffline    Force editing entry in offline.
     * @return  {Promise<any>}            Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.editEntry = function (dataId, entryId, courseId, contents, fields, siteId, forceOffline) {
        var _this = this;
        if (forceOffline === void 0) { forceOffline = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a data to be synchronized later.
        var storeOffline = function () {
            return _this.dataOffline.saveEntry(dataId, entryId, 'edit', courseId, undefined, contents, undefined, siteId)
                .then(function () {
                return {
                    updated: true
                };
            });
        };
        var justAdded = false, groupId;
        if (!this.appProvider.isOnline() || forceOffline) {
            var notifications = this.checkFields(fields, contents);
            if (notifications) {
                return Promise.resolve({
                    fieldnotifications: notifications
                });
            }
        }
        // Get other not not synced actions.
        return this.dataOffline.getEntryActions(dataId, entryId, siteId).then(function (entries) {
            if (entries && entries.length) {
                // Found. Delete add and edit actions first.
                var proms_1 = [];
                entries.forEach(function (entry) {
                    if (entry.action == 'add') {
                        justAdded = true;
                        groupId = entry.groupid;
                        proms_1.push(_this.dataOffline.deleteEntry(dataId, entryId, entry.action, siteId));
                    }
                    else if (entry.action == 'edit') {
                        proms_1.push(_this.dataOffline.deleteEntry(dataId, entryId, entry.action, siteId));
                    }
                });
                return Promise.all(proms_1);
            }
        }).then(function () {
            if (justAdded) {
                // The field was added offline, add again and stop.
                return _this.addEntry(dataId, entryId, courseId, contents, groupId, fields, siteId, forceOffline)
                    .then(function (result) {
                    result.updated = true;
                    return result;
                });
            }
            if (!_this.appProvider.isOnline() || forceOffline) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.editEntryOnline(entryId, contents, siteId).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that responses cannot be submitted.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store in offline.
                return storeOffline();
            });
        });
    };
    /**
     * Updates an existing entry. It does not cache calls. It will fail if offline or cannot connect.
     *
     * @param   {number}  entryId  Entry ID.
     * @param   {any[]}   data     The fields data to be updated.
     * @param   {string}  [siteId] Site ID. If not defined, current site.
     * @return  {Promise<any>}     Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.editEntryOnline = function (entryId, data, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                entryid: entryId,
                data: data
            };
            return site.write('mod_data_update_entry', params);
        });
    };
    /**
     * Performs the whole fetch of the entries in the database.
     *
     * @param  {number}    dataId          Data ID.
     * @param  {number}    [groupId]       Group ID.
     * @param  {string}    [sort]          Sort the records by this field id. See AddonModDataProvider#getEntries for more info.
     * @param  {string}    [order]         The direction of the sorting.  See AddonModDataProvider#getEntries for more info.
     * @param  {number}    [perPage]       Records per page to fetch. It has to match with the prefetch.
     *                                     Default on AddonModDataProvider.PER_PAGE.
     * @param  {boolean}   [forceCache]    True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean}   [ignoreCache]   True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}    [siteId]        Site ID. If not defined, current site.
     * @return {Promise<AddonModDataEntry[]>} Promise resolved when done.
     */
    AddonModDataProvider.prototype.fetchAllEntries = function (dataId, groupId, sort, order, perPage, forceCache, ignoreCache, siteId) {
        if (groupId === void 0) { groupId = 0; }
        if (sort === void 0) { sort = '0'; }
        if (order === void 0) { order = 'DESC'; }
        if (perPage === void 0) { perPage = AddonModDataProvider_1.PER_PAGE; }
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.fetchEntriesRecursive(dataId, groupId, sort, order, perPage, forceCache, ignoreCache, [], 0, siteId);
    };
    /**
     * Recursive call on fetch all entries.
     *
     * @param  {number}    dataId          Data ID.
     * @param  {number}    groupId         Group ID.
     * @param  {string}    sort            Sort the records by this field id. See AddonModDataProvider#getEntries for more info.
     * @param  {string}    order           The direction of the sorting.  See AddonModDataProvider#getEntries for more info.
     * @param  {number}    perPage         Records per page to fetch. It has to match with the prefetch.
     * @param  {boolean}   forceCache      True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean}   ignoreCache     True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {any}       entries         Entries already fetch (just to concatenate them).
     * @param  {number}    page            Page of records to return.
     * @param  {string}    siteId          Site ID.
     * @return {Promise<AddonModDataEntry[]>} Promise resolved when done.
     */
    AddonModDataProvider.prototype.fetchEntriesRecursive = function (dataId, groupId, sort, order, perPage, forceCache, ignoreCache, entries, page, siteId) {
        var _this = this;
        return this.getEntries(dataId, groupId, sort, order, page, perPage, forceCache, ignoreCache, siteId)
            .then(function (result) {
            entries = entries.concat(result.entries);
            var canLoadMore = perPage > 0 && ((page + 1) * perPage) < result.totalcount;
            if (canLoadMore) {
                return _this.fetchEntriesRecursive(dataId, groupId, sort, order, perPage, forceCache, ignoreCache, entries, page + 1, siteId);
            }
            return entries;
        });
    };
    /**
     * Get cache key for data data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonModDataProvider.prototype.getDatabaseDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'data:' + courseId;
    };
    /**
     * Get prefix cache key for all database activity data WS calls.
     *
     * @param {number} dataId   Data ID.
     * @return {string}         Cache key.
     */
    AddonModDataProvider.prototype.getDatabaseDataPrefixCacheKey = function (dataId) {
        return this.ROOT_CACHE_KEY + dataId;
    };
    /**
     * Get a database data. If more than one is found, only the first will be returned.
     *
     * @param {number}   courseId           Course ID.
     * @param {string}   key                Name of the property to check.
     * @param {any}      value              Value to search.
     * @param {string}   [siteId]           Site ID. If not defined, current site.
     * @param {boolean}  [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @return {Promise<any>}  Promise resolved when the data is retrieved.
     */
    AddonModDataProvider.prototype.getDatabaseByKey = function (courseId, key, value, siteId, forceCache) {
        var _this = this;
        if (forceCache === void 0) { forceCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getDatabaseDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets['omitExpires'] = true;
            }
            return site.read('mod_data_get_databases_by_courses', params, preSets).then(function (response) {
                if (response && response.databases) {
                    var currentData = response.databases.find(function (data) { return data[key] == value; });
                    if (currentData) {
                        return currentData;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a data by course module ID.
     *
     * @param {number}   courseId           Course ID.
     * @param {number}   cmId               Course module ID.
     * @param {string}   [siteId]           Site ID. If not defined, current site.
     * @param {boolean}  [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @return {Promise<any>} Promise resolved when the data is retrieved.
     */
    AddonModDataProvider.prototype.getDatabase = function (courseId, cmId, siteId, forceCache) {
        if (forceCache === void 0) { forceCache = false; }
        return this.getDatabaseByKey(courseId, 'coursemodule', cmId, siteId, forceCache);
    };
    /**
     * Get a data by ID.
     *
     * @param {number}   courseId           Course ID.
     * @param {number}   id                 Data ID.
     * @param {string}   [siteId]           Site ID. If not defined, current site.
     * @param {boolean}  [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @return {Promise<any>}         Promise resolved when the data is retrieved.
     */
    AddonModDataProvider.prototype.getDatabaseById = function (courseId, id, siteId, forceCache) {
        if (forceCache === void 0) { forceCache = false; }
        return this.getDatabaseByKey(courseId, 'id', id, siteId, forceCache);
    };
    /**
     * Get prefix cache key for all database access information data WS calls.
     *
     * @param {number} dataId   Data ID.
     * @return {string}         Cache key.
     */
    AddonModDataProvider.prototype.getDatabaseAccessInformationDataPrefixCacheKey = function (dataId) {
        return this.getDatabaseDataPrefixCacheKey(dataId) + ':access:';
    };
    /**
     * Get cache key for database access information data WS calls.
     *
     * @param {number} dataId       Data ID.
     * @param {number} [groupId=0]  Group ID.
     * @return {string}             Cache key.
     */
    AddonModDataProvider.prototype.getDatabaseAccessInformationDataCacheKey = function (dataId, groupId) {
        if (groupId === void 0) { groupId = 0; }
        return this.getDatabaseAccessInformationDataPrefixCacheKey(dataId) + groupId;
    };
    /**
     * Get  access information for a given database.
     *
     * @param   {number}    dataId              Data ID.
     * @param   {number}    [groupId]           Group ID.
     * @param   {boolean}   [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param   {boolean}   [ignoreCache=false] True if it should ignore cached data (it'll always fail in offline or server down).
     * @param   {string}    [siteId]            Site ID. If not defined, current site.
     * @return  {Promise<any>}                  Promise resolved when the database is retrieved.
     */
    AddonModDataProvider.prototype.getDatabaseAccessInformation = function (dataId, groupId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                databaseid: dataId
            }, preSets = {
                cacheKey: _this.getDatabaseAccessInformationDataCacheKey(dataId, groupId)
            };
            if (typeof groupId !== 'undefined') {
                params['groupid'] = groupId;
            }
            if (offline) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('mod_data_get_data_access_information', params, preSets);
        });
    };
    /**
     * Get entries for a specific database and group.
     *
     * @param   {number}    dataId             Data ID.
     * @param   {number}    [groupId=0]        Group ID.
     * @param   {string}    [sort=0]           Sort the records by this field id, reserved ids are:
     *                                            0: timeadded
     *                                           -1: firstname
     *                                           -2: lastname
     *                                           -3: approved
     *                                           -4: timemodified.
     *                                          Empty for using the default database setting.
     * @param   {string}    [order=DESC]        The direction of the sorting: 'ASC' or 'DESC'.
     *                                          Empty for using the default database setting.
     * @param   {number}    [page=0]            Page of records to return.
     * @param   {number}    [perPage=PER_PAGE]  Records per page to return. Default on PER_PAGE.
     * @param   {boolean}   [forceCache=false]  True to always get the value from cache, false otherwise. Default false.
     * @param   {boolean}   [ignoreCache=false] True if it should ignore cached data (it'll always fail in offline or server down).
     * @param   {string}    [siteId]            Site ID. If not defined, current site.
     * @return  {Promise<AddonModDataEntries>} Promise resolved when the database is retrieved.
     */
    AddonModDataProvider.prototype.getEntries = function (dataId, groupId, sort, order, page, perPage, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (sort === void 0) { sort = '0'; }
        if (order === void 0) { order = 'DESC'; }
        if (page === void 0) { page = 0; }
        if (perPage === void 0) { perPage = AddonModDataProvider_1.PER_PAGE; }
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Always use sort and order params to improve cache usage (entries are identified by params).
            var params = {
                databaseid: dataId,
                returncontents: 1,
                page: page,
                perpage: perPage,
                groupid: groupId,
                sort: sort,
                order: order
            }, preSets = {
                cacheKey: _this.getEntriesCacheKey(dataId, groupId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (forceCache) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('mod_data_get_entries', params, preSets).then(function (response) {
                response.entries.forEach(function (entry) {
                    entry.contents = _this.utils.arrayToObject(entry.contents, 'fieldid');
                });
                return response;
            });
        });
    };
    /**
     * Get cache key for database entries data WS calls.
     *
     * @param {number} dataId       Data ID.
     * @param {number} [groupId=0]  Group ID.
     * @return {string}             Cache key.
     */
    AddonModDataProvider.prototype.getEntriesCacheKey = function (dataId, groupId) {
        if (groupId === void 0) { groupId = 0; }
        return this.getEntriesPrefixCacheKey(dataId) + groupId;
    };
    /**
     * Get prefix cache key for database all entries data WS calls.
     *
     * @param {number} dataId     Data ID.
     * @return {string}           Cache key.
     */
    AddonModDataProvider.prototype.getEntriesPrefixCacheKey = function (dataId) {
        return this.getDatabaseDataPrefixCacheKey(dataId) + ':entries:';
    };
    /**
     * Get an entry of the database activity.
     *
     * @param   {number}    dataId    Data ID for caching purposes.
     * @param   {number}    entryId   Entry ID.
     * @param   {boolean}   [ignoreCache=false] True if it should ignore cached data (it'll always fail in offline or server down).
     * @param   {string}    [siteId]  Site ID. If not defined, current site.
     * @return {Promise<{entry: AddonModDataEntry, ratinginfo: CoreRatingInfo}>} Promise resolved when the entry is retrieved.
     */
    AddonModDataProvider.prototype.getEntry = function (dataId, entryId, ignoreCache, siteId) {
        var _this = this;
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                entryid: entryId,
                returncontents: 1
            }, preSets = {
                cacheKey: _this.getEntryCacheKey(dataId, entryId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('mod_data_get_entry', params, preSets).then(function (response) {
                response.entry.contents = _this.utils.arrayToObject(response.entry.contents, 'fieldid');
                return response;
            });
        });
    };
    /**
     * Get cache key for database entry data WS calls.
     *
     * @param {number} dataId     Data ID for caching purposes.
     * @param {number} entryId    Entry ID.
     * @return {string}           Cache key.
     */
    AddonModDataProvider.prototype.getEntryCacheKey = function (dataId, entryId) {
        return this.getDatabaseDataPrefixCacheKey(dataId) + ':entry:' + entryId;
    };
    /**
     * Get the list of configured fields for the given database.
     *
     * @param  {number} dataId               Data ID.
     * @param  {boolean} [forceCache=false]  True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string} [siteId]             Site ID. If not defined, current site.
     * @return {Promise<any>}                Promise resolved when the fields are retrieved.
     */
    AddonModDataProvider.prototype.getFields = function (dataId, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                databaseid: dataId
            }, preSets = {
                cacheKey: _this.getFieldsCacheKey(dataId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('mod_data_get_fields', params, preSets).then(function (response) {
                if (response && response.fields) {
                    return response.fields;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for database fields data WS calls.
     *
     * @param {number} dataId     Data ID.
     * @return {string}           Cache key.
     */
    AddonModDataProvider.prototype.getFieldsCacheKey = function (dataId) {
        return this.getDatabaseDataPrefixCacheKey(dataId) + ':fields';
    };
    /**
     * Invalidate the prefetched content.
     * To invalidate files, use AddonModDataProvider#invalidateFiles.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModDataProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.getDatabase(courseId, moduleId).then(function (data) {
            var ps = [];
            // Do not invalidate module data before getting module info, we need it!
            ps.push(_this.invalidateDatabaseData(courseId, siteId));
            ps.push(_this.invalidateDatabaseWSData(data.id, siteId));
            return Promise.all(ps);
        }));
        promises.push(this.invalidateFiles(moduleId, siteId));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates database access information data.
     *
     * @param {number} dataId     Data ID.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>}     Promise resolved when the data is invalidated.
     */
    AddonModDataProvider.prototype.invalidateDatabaseAccessInformationData = function (dataId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getDatabaseAccessInformationDataPrefixCacheKey(dataId));
        });
    };
    /**
     * Invalidates database entries data.
     *
     * @param {number} dataId       Data ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModDataProvider.prototype.invalidateEntriesData = function (dataId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getEntriesPrefixCacheKey(dataId));
        });
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param {number} moduleId  The module ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when the files are invalidated.
     */
    AddonModDataProvider.prototype.invalidateFiles = function (moduleId, siteId) {
        return this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModDataProvider_1.COMPONENT, moduleId);
    };
    /**
     * Invalidates database data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the data is invalidated.
     */
    AddonModDataProvider.prototype.invalidateDatabaseData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getDatabaseDataCacheKey(courseId));
        });
    };
    /**
     * Invalidates database data except files and module info.
     *
     * @param  {number} databaseId   Data ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModDataProvider.prototype.invalidateDatabaseWSData = function (databaseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getDatabaseDataPrefixCacheKey(databaseId));
        });
    };
    /**
     * Invalidates database entry data.
     *
     * @param  {number}  dataId     Data ID for caching purposes.
     * @param  {number}  entryId    Entry ID.
     * @param  {string}  [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}            Promise resolved when the data is invalidated.
     */
    AddonModDataProvider.prototype.invalidateEntryData = function (dataId, entryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getEntryCacheKey(dataId, entryId));
        });
    };
    /**
     * Return whether or not the plugin is enabled in a certain site. Plugin is enabled if the database WS are available.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>}  Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     * @since 3.3
     */
    AddonModDataProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('mod_data_get_data_access_information');
        });
    };
    /**
     * Report the database as being viewed.
     *
     * @param {number} id      Module ID.
     * @param {string} [name] Name of the data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModDataProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            databaseid: id
        };
        return this.logHelper.logSingle('mod_data_view_database', params, AddonModDataProvider_1.COMPONENT, id, name, 'data', {}, siteId);
    };
    /**
     * Performs search over a database.
     *
     * @param {number} dataId             The data instance id.
     * @param {number} [groupId=0]        Group id, 0 means that the function will determine the user group.
     * @param {string} [search]           Search text. It will be used if advSearch is not defined.
     * @param {any[]}  [advSearch]        Advanced search data.
     * @param {string} [sort]             Sort by this field.
     * @param {string} [order]            The direction of the sorting.
     * @param {number} [page=0]           Page of records to return.
     * @param {number} [perPage=PER_PAGE] Records per page to return. Default on AddonModDataProvider.PER_PAGE.
     * @param {string} [siteId]           Site ID. If not defined, current site.
     * @return {Promise<AddonModDataEntries>} Promise resolved when the action is done.
     */
    AddonModDataProvider.prototype.searchEntries = function (dataId, groupId, search, advSearch, sort, order, page, perPage, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (page === void 0) { page = 0; }
        if (perPage === void 0) { perPage = AddonModDataProvider_1.PER_PAGE; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                databaseid: dataId,
                groupid: groupId,
                returncontents: 1,
                page: page,
                perpage: perPage
            }, preSets = {
                getFromCache: false,
                saveToCache: true,
                emergencyCache: true
            };
            if (typeof sort != 'undefined') {
                params['sort'] = sort;
            }
            if (typeof order !== 'undefined') {
                params['order'] = order;
            }
            if (typeof search !== 'undefined') {
                params['search'] = search;
            }
            if (typeof advSearch !== 'undefined') {
                params['advsearch'] = advSearch;
            }
            return site.read('mod_data_search_entries', params, preSets).then(function (response) {
                response.entries.forEach(function (entry) {
                    entry.contents = _this.utils.arrayToObject(entry.contents, 'fieldid');
                });
                return response;
            });
        });
    };
    AddonModDataProvider.COMPONENT = 'mmaModData';
    AddonModDataProvider.PER_PAGE = 25;
    AddonModDataProvider.ENTRY_CHANGED = 'addon_mod_data_entry_changed';
    AddonModDataProvider = AddonModDataProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* AddonModDataOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_8__fields_delegate__["a" /* AddonModDataFieldsDelegate */],
            __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModDataProvider);
    return AddonModDataProvider;
    var AddonModDataProvider_1;
}());

//# sourceMappingURL=data.js.map

/***/ }),
/* 65 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUpdateManagerProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__addon_calendar_providers_calendar__ = __webpack_require__(281);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Factory to handle app updates. This factory shouldn't be used outside of core.
 *
 * This service handles processes that need to be run when updating the app, like migrate Ionic 1 database data to Ionic 3.
 */
var CoreUpdateManagerProvider = /** @class */ (function () {
    function CoreUpdateManagerProvider(logger, configProvider, sitesProvider, filepoolProvider, notifProvider, utils, appProvider, timeUtils, calendarProvider) {
        this.configProvider = configProvider;
        this.sitesProvider = sitesProvider;
        this.filepoolProvider = filepoolProvider;
        this.notifProvider = notifProvider;
        this.utils = utils;
        this.appProvider = appProvider;
        this.timeUtils = timeUtils;
        this.calendarProvider = calendarProvider;
        // Data for init delegate.
        this.name = 'CoreUpdateManager';
        this.priority = __WEBPACK_IMPORTED_MODULE_4__init__["a" /* CoreInitDelegate */].MAX_RECOMMENDED_PRIORITY + 300;
        this.blocking = true;
        this.VERSION_APPLIED = 'version_applied';
        this.localNotificationsComponentsMigrate = {};
        /**
         * Tables to migrate from app DB ('MoodleMobile'). Include all the core ones to decrease the dependencies.
         *
         * @type {CoreUpdateManagerMigrateTable[]}
         */
        this.appDBTables = [
            {
                name: 'config',
                newName: 'core_config',
                fields: [
                    {
                        name: 'value',
                        type: 'any'
                    }
                ]
            },
            {
                name: 'cron'
            },
            {
                name: 'current_site',
                fields: [
                    {
                        name: 'siteid',
                        newName: 'siteId'
                    }
                ]
            },
            {
                name: 'desktop_local_notifications',
                fields: [
                    {
                        name: 'data',
                        type: 'object'
                    },
                    {
                        name: 'triggered',
                        type: 'boolean'
                    }
                ],
                filterFields: ['id', 'title', 'text', 'at', 'data', 'triggered']
            },
            {
                name: 'files_queue',
                newName: 'filepool_files_queue',
                fields: [
                    {
                        name: 'isexternalfile',
                        type: 'boolean'
                    },
                    {
                        name: 'links',
                        type: 'object'
                    },
                    {
                        name: 'sortorder',
                        delete: true
                    }
                ]
            },
            {
                name: 'notification_components'
            },
            {
                name: 'notification_sites'
            },
            {
                name: 'notifications_triggered'
            },
            {
                name: 'shared_files'
            },
            {
                name: 'sites',
                fields: [
                    {
                        name: 'siteurl',
                        newName: 'siteUrl'
                    },
                    {
                        name: 'infos',
                        newName: 'info',
                        type: 'object'
                    },
                    {
                        name: 'privatetoken',
                        newName: 'privateToken'
                    },
                    {
                        name: 'config',
                        type: 'object'
                    },
                    {
                        name: 'loggedout',
                        newName: 'loggedOut'
                    }
                ]
            },
        ];
        /**
         * Tables to migrate from each site DB. Include all the core ones to decrease the dependencies.
         *
         * @type {CoreUpdateManagerMigrateTable[]}
         */
        this.siteDBTables = [
            {
                name: 'check_updates_times',
                fields: [
                    {
                        name: 'courseid',
                        newName: 'courseId'
                    }
                ]
            },
            {
                name: 'course_status',
                fields: [
                    {
                        name: 'previous',
                        newName: 'previousStatus'
                    },
                    {
                        name: 'downloadtime',
                        newName: 'downloadTime'
                    },
                    {
                        name: 'previousdownloadtime',
                        newName: 'previousDownloadTime'
                    }
                ]
            },
            {
                name: 'filepool',
                newName: 'filepool_files',
                fields: [
                    {
                        name: 'stale',
                        type: 'boolean'
                    },
                    {
                        name: 'downloaded',
                        newName: 'downloadTime'
                    },
                    {
                        name: 'isexternalfile',
                        type: 'boolean'
                    }
                ]
            },
            {
                name: 'files_links',
                newName: 'filepool_files_links',
                fields: [
                    {
                        name: 'componentAndId',
                        delete: true
                    }
                ]
            },
            {
                name: 'filepool_packages',
                fields: [
                    {
                        name: 'downloadtime',
                        newName: 'downloadTime'
                    },
                    {
                        name: 'previousdownloadtime',
                        newName: 'previousDownloadTime'
                    },
                    {
                        name: 'revision',
                        newName: 'extra'
                    },
                    {
                        name: 'timemodified',
                        delete: true
                    }
                ]
            },
            {
                name: 'mm_emulator_last_received_notification',
                newName: 'core_emulator_last_received_notification',
                filterFields: ['component', 'id', 'timecreated']
            },
            {
                name: 'questions',
                fields: [
                    {
                        name: 'componentId',
                        newName: 'componentid'
                    },
                    {
                        name: 'componentAndAttempt',
                        delete: true
                    },
                    {
                        name: 'componentAndComponentId',
                        delete: true
                    }
                ]
            },
            {
                name: 'question_answers',
                fields: [
                    {
                        name: 'componentId',
                        newName: 'componentid'
                    },
                    {
                        name: 'componentAndAttempt',
                        delete: true
                    },
                    {
                        name: 'componentAndComponentId',
                        delete: true
                    },
                    {
                        name: 'componentAndAttemptAndQuestion',
                        delete: true
                    }
                ]
            },
            {
                name: 'sync'
            },
            {
                name: 'users'
            },
            {
                name: 'wscache',
                fields: [
                    {
                        name: 'data',
                        type: 'object'
                    },
                    {
                        name: 'expirationtime',
                        newName: 'expirationTime'
                    }
                ]
            }
        ];
        this.logger = logger.getInstance('CoreUpdateManagerProvider');
    }
    /**
     * Check if the app has been updated and performs the needed processes.
     * This function shouldn't be used outside of core.
     *
     * @return {Promise<any>} Promise resolved when the update process finishes.
     */
    CoreUpdateManagerProvider.prototype.load = function () {
        var _this = this;
        var promises = [], versionCode = __WEBPACK_IMPORTED_MODULE_10__configconstants__["a" /* CoreConfigConstants */].versioncode;
        return this.configProvider.get(this.VERSION_APPLIED, 0).then(function (versionApplied) {
            if (!versionApplied) {
                // No version applied, either the app was just installed or it's being updated from Ionic 1.
                return _this.migrateAllDBs().then(function () {
                    // Now that the DBs have been migrated, migrate the local notification components names.
                    return _this.migrateLocalNotificationsComponents();
                }).then(function () {
                    // DBs migrated, get the version applied again.
                    return _this.configProvider.get(_this.VERSION_APPLIED, 0);
                });
            }
            else {
                return versionApplied;
            }
        }).then(function (versionApplied) {
            if (versionCode >= 2013 && versionApplied < 2013 && versionApplied > 0) {
                promises.push(_this.migrateFileExtensions());
            }
            if (versionCode >= 2017 && versionApplied < 2017 && versionApplied > 0) {
                promises.push(_this.setCalendarDefaultNotifTime());
                promises.push(_this.setSitesConfig());
            }
            // In version 2018 we adapted the forum offline stores to match a new schema.
            // However, due to the migration of data to SQLite we can no longer do that.
            if (versionCode >= 3500 && versionApplied < 3500 && versionApplied > 0) {
                promises.push(_this.logoutLegacySites());
            }
            return Promise.all(promises).then(function () {
                return _this.configProvider.set(_this.VERSION_APPLIED, versionCode);
            }).catch(function (error) {
                _this.logger.error("Error applying update from " + versionApplied + " to " + versionCode, error);
            });
        });
    };
    /**
     * Register several app tables to be migrated to the new schema.
     *
     * @param {CoreUpdateManagerMigrateTable[]} tables The tables to migrate.
     */
    CoreUpdateManagerProvider.prototype.registerAppTablesMigration = function (tables) {
        var _this = this;
        tables.forEach(function (table) {
            _this.registerAppTableMigration(table);
        });
    };
    /**
     * Register an app table to be migrated to the new schema.
     *
     * @param {CoreUpdateManagerMigrateTable} table The table to migrate.
     */
    CoreUpdateManagerProvider.prototype.registerAppTableMigration = function (table) {
        this.appDBTables.push(table);
    };
    /**
     * Register several site tables to be migrated to the new schema.
     *
     * @param {CoreUpdateManagerMigrateTable[]} tables The tables to migrate.
     */
    CoreUpdateManagerProvider.prototype.registerSiteTablesMigration = function (tables) {
        var _this = this;
        tables.forEach(function (table) {
            _this.registerSiteTableMigration(table);
        });
    };
    /**
     * Register a site table to be migrated to the new schema.
     *
     * @param {CoreUpdateManagerMigrateTable} table The table to migrate.
     */
    CoreUpdateManagerProvider.prototype.registerSiteTableMigration = function (table) {
        this.siteDBTables.push(table);
    };
    /**
     * Register a migration of component name for local notifications.
     *
     * @param {string} oldName The old name.
     * @param {string} newName The new name.
     */
    CoreUpdateManagerProvider.prototype.registerLocalNotifComponentMigration = function (oldName, newName) {
        this.localNotificationsComponentsMigrate[oldName] = newName;
    };
    /**
     * Migrate all DBs and tables from the old format to SQLite.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUpdateManagerProvider.prototype.migrateAllDBs = function () {
        var _this = this;
        if (!window.ydn) {
            // The ydn-db library is not loaded, stop.
            return Promise.resolve();
        }
        // First migrate the app DB.
        return this.migrateAppDB().then(function () {
            // Now migrate all site DBs.
            return _this.sitesProvider.getSitesIds();
        }).then(function (ids) {
            var promises = [];
            ids.forEach(function (id) {
                promises.push(_this.migrateSiteDB(id));
            });
            return _this.utils.allPromises(promises);
        });
    };
    /**
     * Migrate the app DB.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUpdateManagerProvider.prototype.migrateAppDB = function () {
        var oldDb = new window.ydn.db.Storage('MoodleMobile'), newDb = this.appProvider.getDB();
        return this.migrateDB(oldDb, newDb, this.appDBTables);
    };
    /**
     * Migrate the DB of a certain site.
     *
     * @param {string} siteId The site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUpdateManagerProvider.prototype.migrateSiteDB = function (siteId) {
        var _this = this;
        // Get the site DB.
        return this.sitesProvider.getSiteDb(siteId).then(function (newDb) {
            var oldDb = new window.ydn.db.Storage('Site-' + siteId);
            return _this.migrateDB(oldDb, newDb, _this.siteDBTables);
        });
    };
    /**
     * Migrate all the tables of a certain DB to the SQLite DB.
     *
     * @param {any} oldDb The old DB (created using ydn-db).
     * @param {SQLiteDB} newDb The new DB.
     * @param {CoreUpdateManagerMigrateTable[]} tables The tables to migrate.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUpdateManagerProvider.prototype.migrateDB = function (oldDb, newDb, tables) {
        var _this = this;
        if (!oldDb || !newDb) {
            // Some of the DBs doesn't exist, stop.
            return Promise.resolve();
        }
        var promises = [];
        tables.forEach(function (table) {
            // Get current values.
            promises.push(Promise.resolve(oldDb.values(table.name, undefined, 99999999)).then(function (entries) {
                var fields = table.fields || [], filterFields = table.filterFields || [];
                var _loop_1 = function (i) {
                    var entry = entries[i];
                    // Convert and rename the fields to match the new schema.
                    fields.forEach(function (field) {
                        var value = entry[field.name];
                        // Convert the field to the right format.
                        if (field.type == 'object' || (field.type == 'any' && typeof value == 'object')) {
                            entry[field.name] = JSON.stringify(value);
                        }
                        else if (field.type == 'date' && value) {
                            entry[field.name] = value.getTime();
                        }
                        else if (field.type == 'boolean' || (field.type == 'any' && typeof value == 'boolean')) {
                            entry[field.name] = value ? 1 : 0;
                        }
                        if (field.newName) {
                            // Rename the field.
                            entry[field.newName] = entry[field.name];
                            delete entry[field.name];
                        }
                        if (field.delete) {
                            // Delete the field.
                            delete entry[field.name];
                        }
                    });
                    // Remove invalid and unneeded properties.
                    for (var name_1 in entry) {
                        if (name_1.indexOf('$') === 0) {
                            // Property not valid, remove.
                            delete entry[name_1];
                        }
                        else if (filterFields.length && filterFields.indexOf(name_1) == -1) {
                            // The property isn't present in filterFields, remove it.
                            delete entry[name_1];
                        }
                    }
                };
                // Treat the entries.
                for (var i = 0; i < entries.length; i++) {
                    _loop_1(i);
                }
                // Now store the entries in the new DB.
                return newDb.insertRecords(table.newName || table.name, entries);
            }).catch(function (error) {
                _this.logger.error('Error migrating table ' + table.name + ' to ' + (table.newName || table.name) + ': ', error);
            }));
        });
        return this.utils.allPromises(promises);
    };
    /**
     * Migrates files filling extensions.
     *
     * @return {Promise<any>} Promise resolved when the site migration is finished.
     */
    CoreUpdateManagerProvider.prototype.migrateFileExtensions = function () {
        var _this = this;
        return this.sitesProvider.getSitesIds().then(function (sites) {
            var promises = [];
            sites.forEach(function (siteId) {
                promises.push(_this.filepoolProvider.fillMissingExtensionInFiles(siteId));
            });
            promises.push(_this.filepoolProvider.treatExtensionInQueue());
            return Promise.all(promises);
        });
    };
    /**
     * Migrate local notifications components from the old nomenclature to the new one.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUpdateManagerProvider.prototype.migrateLocalNotificationsComponents = function () {
        var _this = this;
        if (!this.notifProvider.isAvailable()) {
            // Local notifications not available, nothing to do.
            return Promise.resolve();
        }
        var promises = [];
        var _loop_2 = function (oldName) {
            var newName = this_1.localNotificationsComponentsMigrate[oldName];
            promises.push(this_1.notifProvider.updateComponentName(oldName, newName).catch(function (error) {
                _this.logger.error('Error migrating local notif component from ' + oldName + ' to ' + newName + ': ', error);
            }));
        };
        var this_1 = this;
        for (var oldName in this.localNotificationsComponentsMigrate) {
            _loop_2(oldName);
        }
        return Promise.all(promises);
    };
    /**
     * Calendar default notification time is configurable from version 3.2.1, and a new option "Default" is added.
     * All events that were configured to use the fixed default time should now be configured to use "Default" option.
     *
     * @return {Promise<any>} Promise resolved when the events are configured.
     */
    CoreUpdateManagerProvider.prototype.setCalendarDefaultNotifTime = function () {
        var _this = this;
        if (!this.notifProvider.isAvailable()) {
            // Local notifications not available, nothing to do.
            return Promise.resolve();
        }
        var now = this.timeUtils.timestamp();
        return this.sitesProvider.getSitesIds().then(function (siteIds) {
            var promises = [];
            siteIds.forEach(function (siteId) {
                // Get stored events.
                promises.push(_this.calendarProvider.getAllEventsFromLocalDb(siteId).then(function (events) {
                    var eventPromises = [];
                    events.forEach(function (event) {
                        if (event.notificationtime && event.notificationtime == __WEBPACK_IMPORTED_MODULE_11__addon_calendar_providers_calendar__["a" /* AddonCalendarProvider */].DEFAULT_NOTIFICATION_TIME) {
                            eventPromises.push(_this.calendarProvider.addEventReminder(event, -1, siteId));
                        }
                        else if (event.notificationtime && event.notificationtime > 0) {
                            var time = event.timestart - event.notificationtime * 60;
                            if (time < now) {
                                // Old reminder, just not add this.
                                return;
                            }
                            eventPromises.push(_this.calendarProvider.addEventReminder(event, time, siteId));
                        }
                    });
                    return Promise.all(eventPromises);
                }));
            });
            return Promise.all(promises);
        });
    };
    /**
     * In version 3.2.1 we want the site config to be stored in each site if available.
     * Since it can be slow, we'll only block retrieving the config of current site, the rest will be in background.
     *
     * @return {Promise<any>} Promise resolved when the config is loaded for the current site (if any).
     */
    CoreUpdateManagerProvider.prototype.setSitesConfig = function () {
        var _this = this;
        return this.sitesProvider.getSitesIds().then(function (siteIds) {
            return _this.sitesProvider.getStoredCurrentSiteId().catch(function () {
                // Error getting current site.
            }).then(function (currentSiteId) {
                var promise;
                // Load the config of current site first.
                if (currentSiteId) {
                    promise = _this.setSiteConfig(currentSiteId);
                }
                else {
                    promise = Promise.resolve();
                }
                // Load the config of rest of sites in background.
                siteIds.forEach(function (siteId) {
                    if (siteId != currentSiteId) {
                        _this.setSiteConfig(siteId);
                    }
                });
                return promise;
            });
        });
    };
    /**
     * Store the config of a site.
     *
     * @param {String} siteId Site ID.
     * @return {Promise<any>} Promise resolved when the config is loaded for the site.
     */
    CoreUpdateManagerProvider.prototype.setSiteConfig = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (site.getStoredConfig() || !site.wsAvailable('tool_mobile_get_config')) {
                // Site already has the config or it cannot be retrieved. Stop.
                return;
            }
            // Get the site config.
            return site.getConfig().then(function (config) {
                return _this.sitesProvider.addSite(site.getId(), site.getURL(), site.getToken(), site.getInfo(), site.getPrivateToken(), config);
            }).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Logout from legacy sites.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUpdateManagerProvider.prototype.logoutLegacySites = function () {
        var _this = this;
        return this.sitesProvider.getSitesIds().then(function (siteIds) {
            var promises = [];
            siteIds.forEach(function (siteId) {
                promises.push(_this.sitesProvider.getSite(siteId).then(function (site) {
                    // If the site is a legacy site, mark it as logged out so the user has to authenticate again.
                    if (_this.sitesProvider.isLegacyMoodleByInfo(site.getInfo())) {
                        return _this.sitesProvider.setSiteLoggedOut(site.getId(), true);
                    }
                }));
            });
            return _this.utils.allPromises(promises);
        });
    };
    CoreUpdateManagerProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__config__["a" /* CoreConfigProvider */], __WEBPACK_IMPORTED_MODULE_7__sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_5__local_notifications__["a" /* CoreLocalNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_9__utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__addon_calendar_providers_calendar__["a" /* AddonCalendarProvider */]])
    ], CoreUpdateManagerProvider);
    return CoreUpdateManagerProvider;
}());

//# sourceMappingURL=update-manager.js.map

/***/ }),
/* 66 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreConfigConstants; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// tslint:disable: variable-name
var CoreConfigConstants = /** @class */ (function () {
    function CoreConfigConstants() {
    }
    CoreConfigConstants.app_id = 'com.moodle.moodlemobile';
    CoreConfigConstants.appname = 'Moodle Mobile';
    CoreConfigConstants.desktopappname = 'Moodle Desktop';
    CoreConfigConstants.versioncode = 3700;
    CoreConfigConstants.versionname = '3.7.0';
    CoreConfigConstants.cache_update_frequency_usually = 420000;
    CoreConfigConstants.cache_update_frequency_often = 1200000;
    CoreConfigConstants.cache_update_frequency_sometimes = 3600000;
    CoreConfigConstants.cache_update_frequency_rarely = 43200000;
    CoreConfigConstants.default_lang = 'en';
    CoreConfigConstants.languages = {
        'ar': 'عربي',
        'bg': 'Български',
        'ca': 'Català',
        'cs': 'Čeština',
        'da': 'Dansk',
        'de': 'Deutsch',
        'de-du': 'Deutsch - Du',
        'el': 'Ελληνικά',
        'en': 'English',
        'en-us': 'English - United States',
        'es': 'Español',
        'es-mx': 'Español - México',
        'eu': 'Euskara',
        'fa': 'فارسی',
        'fi': 'Suomi',
        'fr': 'Français',
        'he': 'עברית',
        'hi': 'हिंदी',
        'hr': 'Hrvatski',
        'hu': 'magyar',
        'id': 'Indonesian',
        'it': 'Italiano',
        'ja': '日本語',
        'km': 'ខ្មែរ',
        'kn': 'ಕನ್ನಡ',
        'ko': '한국어',
        'lt': 'Lietuvių',
        'mr': 'मराठी',
        'nl': 'Nederlands',
        'no': 'Norsk - bokmål',
        'pl': 'Polski',
        'pt': 'Português - Portugal',
        'pt-br': 'Português - Brasil',
        'ro': 'Română',
        'ru': 'Русский',
        'sr-cr': 'Српски',
        'sr-lt': 'Srpski',
        'sv': 'Svenska',
        'tg': 'Тоҷикӣ',
        'tr': 'Türkçe',
        'uk': 'Українська',
        'zh-cn': '简体中文',
        'zh-tw': '正體中文'
    };
    CoreConfigConstants.wsservice = 'moodle_mobile_app';
    CoreConfigConstants.wsextservice = 'local_mobile';
    CoreConfigConstants.demo_sites = {
        student: {
            url: 'https://school.demo.moodle.net',
            username: 'student',
            password: 'moodle'
        },
        teacher: {
            url: 'https://school.demo.moodle.net',
            username: 'teacher',
            password: 'moodle'
        }
    };
    CoreConfigConstants.customurlscheme = 'moodlemobile';
    CoreConfigConstants.siteurl = '';
    CoreConfigConstants.sitename = '';
    CoreConfigConstants.multisitesdisplay = '';
    CoreConfigConstants.skipssoconfirmation = false;
    CoreConfigConstants.forcedefaultlanguage = false;
    CoreConfigConstants.privacypolicy = 'https://moodle.org/mod/page/view.php?id=8148';
    CoreConfigConstants.notificoncolor = '#336efa';
    CoreConfigConstants.statusbarbg = false;
    CoreConfigConstants.statusbarlighttext = false;
    CoreConfigConstants.statusbarbgios = '#336efa';
    CoreConfigConstants.statusbarlighttextios = true;
    CoreConfigConstants.statusbarbgandroid = '#336efa';
    CoreConfigConstants.statusbarlighttextandroid = true;
    CoreConfigConstants.statusbarbgremotetheme = '#000000';
    CoreConfigConstants.statusbarlighttextremotetheme = true;
    CoreConfigConstants.enableanalytics = false;
    CoreConfigConstants.compilationtime = 1639054143987;
    CoreConfigConstants.lastcommit = '';
    return CoreConfigConstants;
}());

//# sourceMappingURL=configconstants.js.map

/***/ }),
/* 67 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreMimetypeUtilsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/*
 * "Utils" service with helper functions for mimetypes and extensions.
 */
var CoreMimetypeUtilsProvider = /** @class */ (function () {
    function CoreMimetypeUtilsProvider(http, logger, translate, textUtils) {
        var _this = this;
        this.translate = translate;
        this.textUtils = textUtils;
        this.extToMime = {}; // Object to map extensions -> mimetypes.
        this.mimeToExt = {}; // Object to map mimetypes -> extensions.
        this.groupsMimeInfo = {}; // Object to hold extensions and mimetypes that belong to a certain "group" (audio, video, ...).
        this.extensionRegex = /^[a-z0-9]+$/;
        this.logger = logger.getInstance('CoreMimetypeUtilsProvider');
        http.get('assets/exttomime.json').subscribe(function (result) {
            _this.extToMime = result;
        }, function (err) {
            // Error, shouldn't happen.
        });
        http.get('assets/mimetoext.json').subscribe(function (result) {
            _this.mimeToExt = result;
        }, function (err) {
            // Error, shouldn't happen.
        });
    }
    /**
     * Check if a file extension can be embedded without using iframes.
     *
     * @param {string} extension Extension.
     * @return {boolean} Whether it can be embedded.
     */
    CoreMimetypeUtilsProvider.prototype.canBeEmbedded = function (extension) {
        return this.isExtensionInGroup(extension, ['web_image', 'web_video', 'web_audio']);
    };
    /**
     * Clean a extension, removing the dot, hash, extra params...
     *
     * @param {string} extension Extension to clean.
     * @return {string} Clean extension.
     */
    CoreMimetypeUtilsProvider.prototype.cleanExtension = function (extension) {
        if (!extension) {
            return extension;
        }
        // If the extension has parameters, remove them.
        var position = extension.indexOf('?');
        if (position > -1) {
            extension = extension.substr(0, position);
        }
        // Remove hash in extension if there's any (added by filepool).
        extension = extension.replace(/_.{32}$/, '');
        // Remove dot from the extension if found.
        if (extension && extension[0] == '.') {
            extension = extension.substr(1);
        }
        return extension;
    };
    /**
     * Fill the mimetypes and extensions info for a certain group.
     *
     * @param {string} group Group name.
     */
    CoreMimetypeUtilsProvider.prototype.fillGroupMimeInfo = function (group) {
        var mimetypes = {}, // Use an object to prevent duplicates.
        extensions = []; // Extensions are unique.
        for (var extension in this.extToMime) {
            var data = this.extToMime[extension];
            if (data.type && data.groups && data.groups.indexOf(group) != -1) {
                // This extension has the group, add it to the list.
                mimetypes[data.type] = true;
                extensions.push(extension);
            }
        }
        this.groupsMimeInfo[group] = {
            mimetypes: Object.keys(mimetypes),
            extensions: extensions
        };
    };
    /**
     * Get the extension of a mimetype. Returns undefined if not found.
     *
     * @param {string} mimetype Mimetype.
     * @param {string} [url] URL of the file. It will be used if there's more than one possible extension.
     * @return {string} Extension.
     */
    CoreMimetypeUtilsProvider.prototype.getExtension = function (mimetype, url) {
        mimetype = mimetype || '';
        mimetype = mimetype.split(';')[0]; // Remove codecs from the mimetype if any.
        if (mimetype == 'application/x-forcedownload' || mimetype == 'application/forcedownload') {
            // Couldn't get the right mimetype, try to guess it.
            return this.guessExtensionFromUrl(url);
        }
        var extensions = this.mimeToExt[mimetype];
        if (extensions && extensions.length) {
            if (extensions.length > 1 && url) {
                // There's more than one possible extension. Check if the URL has extension.
                var candidate = this.guessExtensionFromUrl(url);
                if (extensions.indexOf(candidate) != -1) {
                    return candidate;
                }
            }
            return extensions[0];
        }
    };
    /**
     * Get the URL of the icon of an extension.
     *
     * @param {string} extension Extension.
     * @return {string} Icon URL.
     */
    CoreMimetypeUtilsProvider.prototype.getExtensionIcon = function (extension) {
        var icon = this.getExtensionIconName(extension) || 'unknown';
        return this.getFileIconForType(icon);
    };
    /**
     * Get the name of the icon of an extension.
     *
     * @param {string} extension Extension.
     * @return {string} Icon. Undefined if not found.
     */
    CoreMimetypeUtilsProvider.prototype.getExtensionIconName = function (extension) {
        if (this.extToMime[extension]) {
            if (this.extToMime[extension].icon) {
                return this.extToMime[extension].icon;
            }
            else {
                var type = this.extToMime[extension].type.split('/')[0];
                if (type == 'video' || type == 'text' || type == 'image' || type == 'document' || type == 'audio') {
                    return type;
                }
            }
        }
    };
    /**
     * Get the "type" (string) of an extension, something like "image", "video" or "audio".
     *
     * @param {string} extension Extension.
     * @return {string} Type of the extension.
     */
    CoreMimetypeUtilsProvider.prototype.getExtensionType = function (extension) {
        extension = this.cleanExtension(extension);
        if (this.extToMime[extension] && this.extToMime[extension].string) {
            return this.extToMime[extension].string;
        }
    };
    /**
     * Get all the possible extensions of a mimetype. Returns empty array if not found.
     *
     * @param {string} mimetype Mimetype.
     * @return {string[]} Extensions.
     */
    CoreMimetypeUtilsProvider.prototype.getExtensions = function (mimetype) {
        mimetype = mimetype || '';
        mimetype = mimetype.split(';')[0]; // Remove codecs from the mimetype if any.
        return this.mimeToExt[mimetype] || [];
    };
    /**
     * Get a file icon URL based on its file name.
     *
     * @param {string} The name of the file.
     * @return {string} The path to a file icon.
     */
    CoreMimetypeUtilsProvider.prototype.getFileIcon = function (filename) {
        var ext = this.getFileExtension(filename), icon = this.getExtensionIconName(ext) || 'unknown';
        return this.getFileIconForType(icon);
    };
    /**
     * Get the folder icon URL.
     *
     * @return {string} The path to a folder icon.
     */
    CoreMimetypeUtilsProvider.prototype.getFolderIcon = function () {
        return 'assets/img/files/folder-64.png';
    };
    /**
     * Given a type (audio, video, html, ...), return its file icon path.
     *
     * @param {string} type The type to get the icon.
     * @return {string} The icon path.
     */
    CoreMimetypeUtilsProvider.prototype.getFileIconForType = function (type) {
        return 'assets/img/files/' + type + '-64.png';
    };
    /**
     * Guess the extension of a file from its URL.
     * This is very weak and unreliable.
     *
     * @param {string} fileUrl The file URL.
     * @return {string} The lowercased extension without the dot, or undefined.
     */
    CoreMimetypeUtilsProvider.prototype.guessExtensionFromUrl = function (fileUrl) {
        var split = fileUrl.split('.');
        var candidate, extension, position;
        if (split.length > 1) {
            candidate = split.pop().toLowerCase();
            // Remove params if any.
            position = candidate.indexOf('?');
            if (position > -1) {
                candidate = candidate.substr(0, position);
            }
            if (this.extensionRegex.test(candidate)) {
                extension = candidate;
            }
        }
        // Check extension corresponds to a mimetype to know if it's valid.
        if (extension && typeof this.getMimeType(extension) == 'undefined') {
            this.logger.warn('Guess file extension: Not valid extension ' + extension);
            return;
        }
        return extension;
    };
    /**
     * Returns the file extension of a file.
     * When the file does not have an extension, it returns undefined.
     *
     * @param {string} filename The file name.
     * @return {string} The lowercased extension, or undefined.
     */
    CoreMimetypeUtilsProvider.prototype.getFileExtension = function (filename) {
        var dot = filename.lastIndexOf('.');
        var ext;
        if (dot > -1) {
            ext = filename.substr(dot + 1).toLowerCase();
            ext = this.cleanExtension(ext);
            // Check extension corresponds to a mimetype to know if it's valid.
            if (typeof this.getMimeType(ext) == 'undefined') {
                this.logger.warn('Get file extension: Not valid extension ' + ext);
                return;
            }
        }
        return ext;
    };
    /**
     * Get the mimetype/extension info belonging to a certain group.
     *
     * @param {string} group Group name.
     * @param {string} [field] The field to get. If not supplied, all the info will be returned.
     * @return {any} Info for the group.
     */
    CoreMimetypeUtilsProvider.prototype.getGroupMimeInfo = function (group, field) {
        if (typeof this.groupsMimeInfo[group] == 'undefined') {
            this.fillGroupMimeInfo(group);
        }
        if (field) {
            return this.groupsMimeInfo[group][field];
        }
        return this.groupsMimeInfo[group];
    };
    /**
     * Get the mimetype of an extension. Returns undefined if not found.
     *
     * @param {string} extension Extension.
     * @return {string} Mimetype.
     */
    CoreMimetypeUtilsProvider.prototype.getMimeType = function (extension) {
        extension = this.cleanExtension(extension);
        if (this.extToMime[extension] && this.extToMime[extension].type) {
            return this.extToMime[extension].type;
        }
    };
    /**
     * Obtains descriptions for file types (e.g. 'Microsoft Word document') from the language file.
     * Based on Moodle's get_mimetype_description.
     *
     * @param {any} obj Instance of FileEntry OR object with 'filename' and 'mimetype' OR string with mimetype.
     * @param {boolean} [capitalise] If true, capitalises first character of result.
     * @return {string} Type description.
     */
    CoreMimetypeUtilsProvider.prototype.getMimetypeDescription = function (obj, capitalise) {
        var langPrefix = 'assets.mimetypes.';
        var filename = '', mimetype = '', extension = '';
        if (typeof obj == 'object' && typeof obj.file == 'function') {
            // It's a FileEntry. Don't use the file function because it's asynchronous and the type isn't reliable.
            filename = obj.name;
        }
        else if (typeof obj == 'object') {
            filename = obj.filename || '';
            mimetype = obj.mimetype || '';
        }
        else {
            mimetype = obj;
        }
        if (filename) {
            extension = this.getFileExtension(filename);
            if (!mimetype) {
                // Try to calculate the mimetype using the extension.
                mimetype = this.getMimeType(extension);
            }
        }
        if (!mimetype) {
            // Don't have the mimetype, stop.
            return '';
        }
        if (!extension) {
            extension = this.getExtension(mimetype);
        }
        var mimetypeStr = this.getMimetypeType(mimetype) || '', chunks = mimetype.split('/'), attr = {
            mimetype: mimetype,
            ext: extension || '',
            mimetype1: chunks[0],
            mimetype2: chunks[1] || '',
        }, translateParams = {};
        for (var key in attr) {
            var value = attr[key];
            translateParams[key] = value;
            translateParams[key.toUpperCase()] = value.toUpperCase();
            translateParams[this.textUtils.ucFirst(key)] = this.textUtils.ucFirst(value);
        }
        // MIME types may include + symbol but this is not permitted in string ids.
        var safeMimetype = mimetype.replace(/\+/g, '_'), safeMimetypeStr = mimetypeStr.replace(/\+/g, '_'), safeMimetypeTrns = this.translate.instant(langPrefix + safeMimetype, { $a: translateParams }), safeMimetypeStrTrns = this.translate.instant(langPrefix + safeMimetypeStr, { $a: translateParams }), defaultTrns = this.translate.instant(langPrefix + 'default', { $a: translateParams });
        var result = mimetype;
        if (safeMimetypeTrns != langPrefix + safeMimetype) {
            result = safeMimetypeTrns;
        }
        else if (safeMimetypeStrTrns != langPrefix + safeMimetypeStr) {
            result = safeMimetypeStrTrns;
        }
        else if (defaultTrns != langPrefix + 'default') {
            result = defaultTrns;
        }
        if (capitalise) {
            result = this.textUtils.ucFirst(result);
        }
        return result;
    };
    /**
     * Get the "type" (string) of a mimetype, something like "image", "video" or "audio".
     *
     * @param {string} mimetype Mimetype.
     * @return {string} Type of the mimetype.
     */
    CoreMimetypeUtilsProvider.prototype.getMimetypeType = function (mimetype) {
        mimetype = mimetype.split(';')[0]; // Remove codecs from the mimetype if any.
        var extensions = this.mimeToExt[mimetype];
        if (!extensions) {
            return;
        }
        for (var i = 0; i < extensions.length; i++) {
            var extension = extensions[i];
            if (this.extToMime[extension] && this.extToMime[extension].string) {
                return this.extToMime[extension].string;
            }
        }
    };
    /**
     * Get the icon of a mimetype.
     *
     * @param {string} mimetype Mimetype.
     * @return {string} Type of the mimetype.
     */
    CoreMimetypeUtilsProvider.prototype.getMimetypeIcon = function (mimetype) {
        mimetype = mimetype.split(';')[0]; // Remove codecs from the mimetype if any.
        var extensions = this.mimeToExt[mimetype] || [];
        var icon = 'unknown';
        for (var i = 0; i < extensions.length; i++) {
            var iconName = this.getExtensionIconName(extensions[i]);
            if (iconName) {
                icon = iconName;
                break;
            }
        }
        return this.getFileIconForType(icon);
    };
    /**
     * Given a group name, return the translated name.
     *
     * @param {string} name Group name.
     * @return {string} Translated name.
     */
    CoreMimetypeUtilsProvider.prototype.getTranslatedGroupName = function (name) {
        var key = 'assets.mimetypes.group:' + name, translated = this.translate.instant(key);
        return translated != key ? translated : name;
    };
    /**
     * Check if an extension belongs to at least one of the groups.
     * Similar to Moodle's file_mimetype_in_typegroup, but using the extension instead of mimetype.
     *
     * @param {string} extension Extension.
     * @param {string[]} groups List of groups to check.
     * @return {boolean} Whether the extension belongs to any of the groups.
     */
    CoreMimetypeUtilsProvider.prototype.isExtensionInGroup = function (extension, groups) {
        extension = this.cleanExtension(extension);
        if (groups && groups.length && this.extToMime[extension] && this.extToMime[extension].groups) {
            for (var i = 0; i < this.extToMime[extension].groups.length; i++) {
                var group = this.extToMime[extension].groups[i];
                if (groups.indexOf(group) != -1) {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * Remove the extension from a path (if any).
     *
     * @param {string} path Path.
     * @return {string} Path without extension.
     */
    CoreMimetypeUtilsProvider.prototype.removeExtension = function (path) {
        var position = path.lastIndexOf('.');
        var extension;
        if (position > -1) {
            // Check extension corresponds to a mimetype to know if it's valid.
            extension = path.substr(position + 1).toLowerCase();
            if (typeof this.getMimeType(extension) != 'undefined') {
                return path.substr(0, position); // Remove extension.
            }
        }
        return path;
    };
    CoreMimetypeUtilsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_2__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__text__["a" /* CoreTextUtilsProvider */]])
    ], CoreMimetypeUtilsProvider);
    return CoreMimetypeUtilsProvider;
}());

//# sourceMappingURL=mimetype.js.map

/***/ }),
/* 68 */,
/* 69 */,
/* 70 */
/***/ (function(module, exports) {

module.exports = require('electron');

/***/ }),
/* 71 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldsDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__default_field_handler__ = __webpack_require__(881);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Delegate to register database fields handlers.
 */
var AddonModDataFieldsDelegate = /** @class */ (function (_super) {
    __extends(AddonModDataFieldsDelegate, _super);
    function AddonModDataFieldsDelegate(logger, sitesProvider, eventsProvider, utils, defaultHandler) {
        var _this = _super.call(this, 'AddonModDataFieldsDelegate', logger, sitesProvider, eventsProvider) || this;
        _this.utils = utils;
        _this.defaultHandler = defaultHandler;
        _this.handlerNameProperty = 'type';
        return _this;
    }
    /**
     * Get the component to use for a certain field field.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {Promise<any>}     Promise resolved with the component to use, undefined if not found.
     */
    AddonModDataFieldsDelegate.prototype.getComponentForField = function (injector, field) {
        return Promise.resolve(this.executeFunctionOnEnabled(field.type, 'getComponent', [injector, field]));
    };
    /**
     * Get database data in the input data to search.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}             Name and data field.
     */
    AddonModDataFieldsDelegate.prototype.getFieldSearchData = function (field, inputData) {
        return this.executeFunctionOnEnabled(field.type, 'getFieldSearchData', [field, inputData]);
    };
    /**
     * Get database data in the input data to add or update entry.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the search form.
     * @param  {any} originalFieldData   Original field entered data.
     * @return {any}                     Name and data field.
     */
    AddonModDataFieldsDelegate.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        return this.executeFunctionOnEnabled(field.type, 'getFieldEditData', [field, inputData, originalFieldData]);
    };
    /**
     * Get database data in the input files to add or update entry.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the search form.
     * @param  {any} originalFieldData   Original field entered data.
     * @return {any}                     Name and data field.
     */
    AddonModDataFieldsDelegate.prototype.getFieldEditFiles = function (field, inputData, originalFieldData) {
        return this.executeFunctionOnEnabled(field.type, 'getFieldEditFiles', [field, inputData, originalFieldData]);
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {string}         String with the notification or false.
     */
    AddonModDataFieldsDelegate.prototype.getFieldsNotifications = function (field, inputData) {
        return this.executeFunctionOnEnabled(field.type, 'getFieldsNotifications', [field, inputData]);
    };
    /**
     * Check if field type manage files or not.
     *
     * @param  {any} field  Defines the field to be checked.
     * @return {boolean}    If the field type manages files.
     */
    AddonModDataFieldsDelegate.prototype.hasFiles = function (field) {
        return this.hasFunction(field.type, 'getFieldEditFiles');
    };
    /**
     * Check if the data has changed for a certain field.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the search form.
     * @param  {any} originalFieldData   Original field entered data.
     * @return {Promise<void>}           Promise rejected if has changed, resolved if no changes.
     */
    AddonModDataFieldsDelegate.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        return Promise.resolve(this.executeFunctionOnEnabled(field.type, 'hasFieldDataChanged', [field, inputData, originalFieldData])).then(function (result) {
            return result ? Promise.reject(null) : Promise.resolve();
        });
    };
    /**
     * Check if a field plugin is supported.
     *
     * @param  {string} pluginType Type of the plugin.
     * @return {boolean}           True if supported, false otherwise.
     */
    AddonModDataFieldsDelegate.prototype.isPluginSupported = function (pluginType) {
        return this.hasHandler(pluginType, true);
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} originalContent     Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldsDelegate.prototype.overrideData = function (field, originalContent, offlineContent, offlineFiles) {
        originalContent = originalContent || {};
        if (!offlineContent) {
            return originalContent;
        }
        return this.executeFunctionOnEnabled(field.type, 'overrideData', [originalContent, offlineContent, offlineFiles]);
    };
    AddonModDataFieldsDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__default_field_handler__["a" /* AddonModDataDefaultFieldHandler */]])
    ], AddonModDataFieldsDelegate);
    return AddonModDataFieldsDelegate;
}(__WEBPACK_IMPORTED_MODULE_5__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=fields-delegate.js.map

/***/ }),
/* 72 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseOptionsDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__course__ = __webpack_require__(10);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Service to interact with plugins to be shown in each course (participants, learning plans, ...).
 */
var CoreCourseOptionsDelegate = /** @class */ (function (_super) {
    __extends(CoreCourseOptionsDelegate, _super);
    function CoreCourseOptionsDelegate(loggerProvider, sitesProvider, utils, eventsProvider, coursesProvider) {
        var _this = _super.call(this, 'CoreCourseOptionsDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.sitesProvider = sitesProvider;
        _this.utils = utils;
        _this.eventsProvider = eventsProvider;
        _this.coursesProvider = coursesProvider;
        _this.loaded = {};
        _this.lastUpdateHandlersForCoursesStart = {};
        _this.coursesHandlers = {};
        _this.featurePrefix = 'CoreCourseOptionsDelegate_';
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function () {
            _this.clearCoursesHandlers();
        });
        return _this;
    }
    /**
     * Check if handlers are loaded for a certain course.
     *
     * @param {number} courseId The course ID to check.
     * @return {boolean} True if handlers are loaded, false otherwise.
     */
    CoreCourseOptionsDelegate.prototype.areHandlersLoaded = function (courseId) {
        return !!this.loaded[courseId];
    };
    /**
     * Clear all course options handlers.
     *
     * @param {number} [courseId] The course ID. If not defined, all handlers will be cleared.
     */
    CoreCourseOptionsDelegate.prototype.clearCoursesHandlers = function (courseId) {
        if (courseId) {
            this.loaded[courseId] = false;
            delete this.coursesHandlers[courseId];
        }
        else {
            this.loaded = {};
            this.coursesHandlers = {};
        }
    };
    /**
     * Clear all courses handlers and invalidate its options.
     *
     * @param {number} [courseId] The course ID. If not defined, all handlers will be cleared.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseOptionsDelegate.prototype.clearAndInvalidateCoursesOptions = function (courseId) {
        var promises = [];
        this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_MY_COURSES_REFRESHED);
        // Invalidate course enabled data for the handlers that are enabled at site level.
        if (courseId) {
            // Invalidate only options for this course.
            promises.push(this.coursesProvider.invalidateCoursesAdminAndNavOptions([courseId]));
            promises.push(this.invalidateCourseHandlers(courseId));
        }
        else {
            // Invalidate all options.
            promises.push(this.coursesProvider.invalidateUserNavigationOptions());
            promises.push(this.coursesProvider.invalidateUserAdministrationOptions());
            for (var cId in this.coursesHandlers) {
                promises.push(this.invalidateCourseHandlers(parseInt(cId, 10)));
            }
        }
        this.clearCoursesHandlers(courseId);
        return Promise.all(promises);
    };
    /**
     * Get the handlers for a course using a certain access type.
     *
     * @param {number} courseId The course ID.
     * @param {boolean} refresh True if it should refresh the list.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<CoreCourseOptionsHandler[]>} Promise resolved with array of handlers.
     */
    CoreCourseOptionsDelegate.prototype.getHandlersForAccess = function (courseId, refresh, accessData, navOptions, admOptions) {
        var _this = this;
        // If the handlers aren't loaded, do not refresh.
        if (!this.loaded[courseId]) {
            refresh = false;
        }
        if (refresh || !this.coursesHandlers[courseId] || this.coursesHandlers[courseId].access.type != accessData.type) {
            if (!this.coursesHandlers[courseId]) {
                this.coursesHandlers[courseId] = {};
            }
            this.coursesHandlers[courseId].access = accessData;
            this.coursesHandlers[courseId].navOptions = navOptions;
            this.coursesHandlers[courseId].admOptions = admOptions;
            this.coursesHandlers[courseId].deferred = this.utils.promiseDefer();
            this.updateHandlersForCourse(courseId, accessData, navOptions, admOptions);
        }
        return this.coursesHandlers[courseId].deferred.promise.then(function () {
            return _this.coursesHandlers[courseId].enabledHandlers;
        });
    };
    /**
     * Get the list of handlers that should be displayed for a course.
     * This function should be called only when the handlers need to be displayed, since it can call several WebServices.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {boolean} [refresh] True if it should refresh the list.
     * @param {boolean} [isGuest] Whether it's guest.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<CoreCourseOptionsHandlerToDisplay[]>} Promise resolved with array of handlers.
     */
    CoreCourseOptionsDelegate.prototype.getHandlersToDisplay = function (injector, course, refresh, isGuest, navOptions, admOptions) {
        return this.getHandlersToDisplayInternal(false, injector, course, refresh, isGuest, navOptions, admOptions);
    };
    /**
     * Get the list of menu handlers that should be displayed for a course.
     * This function should be called only when the handlers need to be displayed, since it can call several WebServices.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {boolean} [refresh] True if it should refresh the list.
     * @param {boolean} [isGuest] Whether it's guest.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<CoreCourseOptionsMenuHandlerToDisplay[]>} Promise resolved with array of handlers.
     */
    CoreCourseOptionsDelegate.prototype.getMenuHandlersToDisplay = function (injector, course, refresh, isGuest, navOptions, admOptions) {
        return this.getHandlersToDisplayInternal(true, injector, course, refresh, isGuest, navOptions, admOptions);
    };
    /**
     * Get the list of menu handlers that should be displayed for a course.
     * This function should be called only when the handlers need to be displayed, since it can call several WebServices.
     *
     * @param {boolean} menu If true, gets menu handlers; false, gets tab handlers
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {boolean} refresh True if it should refresh the list.
     * @param {boolean} isGuest Whether it's guest.
     * @param {any} navOptions Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} admOptions Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<any[]>} Promise resolved with array of handlers.
     */
    CoreCourseOptionsDelegate.prototype.getHandlersToDisplayInternal = function (menu, injector, course, refresh, isGuest, navOptions, admOptions) {
        var _this = this;
        course.id = parseInt(course.id, 10);
        var accessData = {
            type: isGuest ? __WEBPACK_IMPORTED_MODULE_7__course__["a" /* CoreCourseProvider */].ACCESS_GUEST : __WEBPACK_IMPORTED_MODULE_7__course__["a" /* CoreCourseProvider */].ACCESS_DEFAULT
        }, handlersToDisplay = [];
        if (navOptions) {
            course.navOptions = navOptions;
        }
        if (admOptions) {
            course.admOptions = admOptions;
        }
        return this.loadCourseOptions(course, refresh).then(function () {
            // Call getHandlersForAccess to make sure the handlers have been loaded.
            return _this.getHandlersForAccess(course.id, refresh, accessData, course.navOptions, course.admOptions);
        }).then(function () {
            var promises = [];
            var handlerList;
            if (menu) {
                handlerList = _this.coursesHandlers[course.id].enabledMenuHandlers;
            }
            else {
                handlerList = _this.coursesHandlers[course.id].enabledHandlers;
            }
            handlerList.forEach(function (handler) {
                var getFunction = menu ? handler.getMenuDisplayData : handler.getDisplayData;
                promises.push(Promise.resolve(getFunction.call(handler, injector, course)).then(function (data) {
                    handlersToDisplay.push({
                        data: data,
                        priority: handler.priority,
                        prefetch: handler.prefetch && handler.prefetch.bind(handler),
                        name: handler.name
                    });
                }).catch(function (err) {
                    _this.logger.error('Error getting data for handler', handler.name, err);
                }));
            });
            return Promise.all(promises);
        }).then(function () {
            // Sort them by priority.
            handlersToDisplay.sort(function (a, b) {
                return b.priority - a.priority;
            });
            return handlersToDisplay;
        });
    };
    /**
     * Check if a course has any handler enabled for default access, using course object.
     *
     * @param {any} course The course object.
     * @param {boolean} [refresh] True if it should refresh the list.
     * @return {Promise<boolean>} Promise resolved with boolean: true if it has handlers, false otherwise.
     */
    CoreCourseOptionsDelegate.prototype.hasHandlersForCourse = function (course, refresh) {
        var _this = this;
        // Load course options if missing.
        return this.loadCourseOptions(course, refresh).then(function () {
            return _this.hasHandlersForDefault(course.id, refresh, course.navOptions, course.admOptions);
        });
    };
    /**
     * Check if a course has any handler enabled for default access.
     *
     * @param {number} courseId The course ID.
     * @param {boolean} [refresh] True if it should refresh the list.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<boolean>} Promise resolved with boolean: true if it has handlers, false otherwise.
     */
    CoreCourseOptionsDelegate.prototype.hasHandlersForDefault = function (courseId, refresh, navOptions, admOptions) {
        // Default access.
        var accessData = {
            type: __WEBPACK_IMPORTED_MODULE_7__course__["a" /* CoreCourseProvider */].ACCESS_DEFAULT
        };
        return this.getHandlersForAccess(courseId, refresh, accessData, navOptions, admOptions).then(function (handlers) {
            return !!(handlers && handlers.length);
        });
    };
    /**
     * Check if a course has any handler enabled for guest access.
     *
     * @param {number} courseId The course ID.
     * @param {boolean} [refresh] True if it should refresh the list.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<boolean>} Promise resolved with boolean: true if it has handlers, false otherwise.
     */
    CoreCourseOptionsDelegate.prototype.hasHandlersForGuest = function (courseId, refresh, navOptions, admOptions) {
        // Guest access.
        var accessData = {
            type: __WEBPACK_IMPORTED_MODULE_7__course__["a" /* CoreCourseProvider */].ACCESS_GUEST
        };
        return this.getHandlersForAccess(courseId, refresh, accessData, navOptions, admOptions).then(function (handlers) {
            return !!(handlers && handlers.length);
        });
    };
    /**
     * Invalidate the data to be able to determine if handlers are enabled for a certain course.
     *
     * @param {number} courseId Course ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseOptionsDelegate.prototype.invalidateCourseHandlers = function (courseId) {
        var promises = [], courseData = this.coursesHandlers[courseId];
        if (!courseData) {
            return Promise.resolve();
        }
        courseData.enabledHandlers.forEach(function (handler) {
            if (handler && handler.invalidateEnabledForCourse) {
                promises.push(Promise.resolve(handler.invalidateEnabledForCourse(courseId, courseData.navOptions, courseData.admOptions)));
            }
        });
        return this.utils.allPromises(promises);
    };
    /**
     * Check if a time belongs to the last update handlers for course call.
     * This is to handle the cases where updateHandlersForCourse don't finish in the same order as they're called.
     *
     * @param {number} courseId Course ID.
     * @param {number} time Time to check.
     * @return {boolean} Whether it's the last call.
     */
    CoreCourseOptionsDelegate.prototype.isLastUpdateCourseCall = function (courseId, time) {
        if (!this.lastUpdateHandlersForCoursesStart[courseId]) {
            return true;
        }
        return time == this.lastUpdateHandlersForCoursesStart[courseId];
    };
    /**
     * Load course options if missing.
     *
     * @param {any} course The course object.
     * @param {boolean} [refresh] True if it should refresh the list.
     * @return {Promise<void>} Promise resolved when done.
     */
    CoreCourseOptionsDelegate.prototype.loadCourseOptions = function (course, refresh) {
        if (this.coursesProvider.canGetAdminAndNavOptions() &&
            (typeof course.navOptions == 'undefined' || typeof course.admOptions == 'undefined' || refresh)) {
            return this.coursesProvider.getCoursesAdminAndNavOptions([course.id]).then(function (options) {
                course.navOptions = options.navOptions[course.id];
                course.admOptions = options.admOptions[course.id];
            });
        }
        else {
            return Promise.resolve();
        }
    };
    /**
     * Update handlers for each course.
     *
     * @param {string} [siteId] Site ID.
     */
    CoreCourseOptionsDelegate.prototype.updateData = function (siteId) {
        if (this.sitesProvider.getCurrentSiteId() === siteId) {
            // Update handlers for all courses.
            for (var courseId in this.coursesHandlers) {
                var handler = this.coursesHandlers[courseId];
                this.updateHandlersForCourse(parseInt(courseId, 10), handler.access, handler.navOptions, handler.admOptions);
            }
        }
    };
    /**
     * Update the handlers for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<any>} Resolved when updated.
     */
    CoreCourseOptionsDelegate.prototype.updateHandlersForCourse = function (courseId, accessData, navOptions, admOptions) {
        var _this = this;
        var promises = [], enabledForCourse = [], enabledForCourseMenu = [], siteId = this.sitesProvider.getCurrentSiteId(), now = Date.now();
        this.lastUpdateHandlersForCoursesStart[courseId] = now;
        var _loop_1 = function (name_1) {
            var handler = this_1.enabledHandlers[name_1];
            // Checks if the handler is enabled for the user.
            promises.push(Promise.resolve(handler.isEnabledForCourse(courseId, accessData, navOptions, admOptions))
                .then(function (enabled) {
                if (enabled) {
                    if (handler.isMenuHandler) {
                        enabledForCourseMenu.push(handler);
                    }
                    else {
                        enabledForCourse.push(handler);
                    }
                }
                else {
                    return Promise.reject(null);
                }
            }).catch(function () {
                // Nothing to do here, it is not enabled for this user.
            }));
        };
        var this_1 = this;
        for (var name_1 in this.enabledHandlers) {
            _loop_1(name_1);
        }
        return Promise.all(promises).then(function () {
            return true;
        }).catch(function () {
            // Never fails.
            return true;
        }).finally(function () {
            // Verify that this call is the last one that was started.
            // Check that site hasn't changed since the check started.
            if (_this.isLastUpdateCourseCall(courseId, now) && _this.sitesProvider.getCurrentSiteId() === siteId) {
                // Update the coursesHandlers array with the new enabled addons.
                _this.coursesHandlers[courseId].enabledHandlers = enabledForCourse;
                _this.coursesHandlers[courseId].enabledMenuHandlers = enabledForCourseMenu;
                _this.loaded[courseId] = true;
                // Resolve the promise.
                _this.coursesHandlers[courseId].deferred.resolve();
            }
        });
    };
    CoreCourseOptionsDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreCourseOptionsDelegate);
    return CoreCourseOptionsDelegate;
}(__WEBPACK_IMPORTED_MODULE_1__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=options-delegate.js.map

/***/ }),
/* 73 */,
/* 74 */,
/* 75 */,
/* 76 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle questions.
 */
var CoreQuestionProvider = /** @class */ (function () {
    function CoreQuestionProvider(logger, sitesProvider, timeUtils, utils) {
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.utils = utils;
        // Variables for database.
        this.QUESTION_TABLE = 'questions';
        this.QUESTION_ANSWERS_TABLE = 'question_answers';
        this.siteSchema = {
            name: 'CoreQuestionProvider',
            version: 1,
            tables: [
                {
                    name: this.QUESTION_TABLE,
                    columns: [
                        {
                            name: 'component',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'attemptid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'slot',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'componentid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'number',
                            type: 'INTEGER'
                        },
                        {
                            name: 'state',
                            type: 'TEXT'
                        }
                    ],
                    primaryKeys: ['component', 'attemptid', 'slot']
                },
                {
                    name: this.QUESTION_ANSWERS_TABLE,
                    columns: [
                        {
                            name: 'component',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'attemptid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'name',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'componentid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'questionslot',
                            type: 'INTEGER'
                        },
                        {
                            name: 'value',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['component', 'attemptid', 'name']
                }
            ]
        };
        this.QUESTION_PREFIX_REGEX = /q\d+:(\d+)_/;
        this.STATES = {
            todo: {
                name: 'todo',
                class: 'core-question-notyetanswered',
                status: 'notyetanswered',
                active: true,
                finished: false
            },
            invalid: {
                name: 'invalid',
                class: 'core-question-invalidanswer',
                status: 'invalidanswer',
                active: true,
                finished: false
            },
            complete: {
                name: 'complete',
                class: 'core-question-answersaved',
                status: 'answersaved',
                active: true,
                finished: false
            },
            needsgrading: {
                name: 'needsgrading',
                class: 'core-question-requiresgrading',
                status: 'requiresgrading',
                active: false,
                finished: true
            },
            finished: {
                name: 'finished',
                class: 'core-question-complete',
                status: 'complete',
                active: false,
                finished: true
            },
            gaveup: {
                name: 'gaveup',
                class: 'core-question-notanswered',
                status: 'notanswered',
                active: false,
                finished: true
            },
            gradedwrong: {
                name: 'gradedwrong',
                class: 'core-question-incorrect',
                status: 'incorrect',
                active: false,
                finished: true
            },
            gradedpartial: {
                name: 'gradedpartial',
                class: 'core-question-partiallycorrect',
                status: 'partiallycorrect',
                active: false,
                finished: true
            },
            gradedright: {
                name: 'gradedright',
                class: 'core-question-correct',
                status: 'correct',
                active: false,
                finished: true
            },
            mangrwrong: {
                name: 'mangrwrong',
                class: 'core-question-incorrect',
                status: 'incorrect',
                active: false,
                finished: true
            },
            mangrpartial: {
                name: 'mangrpartial',
                class: 'core-question-partiallycorrect',
                status: 'partiallycorrect',
                active: false,
                finished: true
            },
            mangrright: {
                name: 'mangrright',
                class: 'core-question-correct',
                status: 'correct',
                active: false,
                finished: true
            },
            cannotdeterminestatus: {
                name: 'cannotdeterminestatus',
                class: 'core-question-unknown',
                status: 'cannotdeterminestatus',
                active: true,
                finished: false
            }
        };
        this.logger = logger.getInstance('CoreQuestionProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    /**
     * Compare that all the answers in two objects are equal, except some extra data like sequencecheck or certainty.
     *
     * @param {any} prevAnswers Object with previous answers.
     * @param {any} newAnswers Object with new answers.
     * @return {boolean} Whether all answers are equal.
     */
    CoreQuestionProvider.prototype.compareAllAnswers = function (prevAnswers, newAnswers) {
        // Get all the keys.
        var keys = this.utils.mergeArraysWithoutDuplicates(Object.keys(prevAnswers), Object.keys(newAnswers));
        // Check that all the keys have the same value on both objects.
        for (var i in keys) {
            var key = keys[i];
            // Ignore extra answers like sequencecheck or certainty.
            if (!this.isExtraAnswer(key[0])) {
                if (!this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, key)) {
                    return false;
                }
            }
        }
        return true;
    };
    /**
     * Convert a list of answers retrieved from local DB to an object with name - value.
     *
     * @param {any[]} answers List of answers.
     * @param {boolean} [removePrefix] Whether to remove the prefix in the answer's name.
     * @return {any} Object with name -> value.
     */
    CoreQuestionProvider.prototype.convertAnswersArrayToObject = function (answers, removePrefix) {
        var _this = this;
        var result = {};
        answers.forEach(function (answer) {
            if (removePrefix) {
                var nameWithoutPrefix = _this.removeQuestionPrefix(answer.name);
                result[nameWithoutPrefix] = answer.value;
            }
            else {
                result[answer.name] = answer.value;
            }
        });
        return result;
    };
    /**
     * Retrieve an answer from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} name Answer's name.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the answer.
     */
    CoreQuestionProvider.prototype.getAnswer = function (component, attemptId, name, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(_this.QUESTION_ANSWERS_TABLE, { component: component, attemptid: attemptId, name: name });
        });
    };
    /**
     * Retrieve an attempt answers from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the answers.
     */
    CoreQuestionProvider.prototype.getAttemptAnswers = function (component, attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(_this.QUESTION_ANSWERS_TABLE, { component: component, attemptid: attemptId });
        });
    };
    /**
     * Retrieve an attempt questions from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the questions.
     */
    CoreQuestionProvider.prototype.getAttemptQuestions = function (component, attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(_this.QUESTION_TABLE, { component: component, attemptid: attemptId });
        });
    };
    /**
     * Get all the answers that aren't "extra" (sequencecheck, certainty, ...).
     *
     * @param {any} answers Object with all the answers.
     * @return {any} Object with the basic answers.
     */
    CoreQuestionProvider.prototype.getBasicAnswers = function (answers) {
        var result = {};
        for (var name_1 in answers) {
            if (!this.isExtraAnswer(name_1)) {
                result[name_1] = answers[name_1];
            }
        }
        return result;
    };
    /**
     * Get all the answers that aren't "extra" (sequencecheck, certainty, ...).
     *
     * @param {any[]} answers List of answers.
     * @return {any[]} List with the basic answers.
     */
    CoreQuestionProvider.prototype.getBasicAnswersFromArray = function (answers) {
        var _this = this;
        var result = [];
        answers.forEach(function (answer) {
            if (_this.isExtraAnswer(answer.name)) {
                result.push(answer);
            }
        });
        return result;
    };
    /**
     * Retrieve a question from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} slot Question slot.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the question.
     */
    CoreQuestionProvider.prototype.getQuestion = function (component, attemptId, slot, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(_this.QUESTION_TABLE, { component: component, attemptid: attemptId, slot: slot });
        });
    };
    /**
     * Retrieve a question answers from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} slot Question slot.
     * @param {boolean} [filter] Whether it should ignore "extra" answers like sequencecheck or certainty.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the answers.
     */
    CoreQuestionProvider.prototype.getQuestionAnswers = function (component, attemptId, slot, filter, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(_this.QUESTION_ANSWERS_TABLE, { component: component, attemptid: attemptId,
                questionslot: slot }).then(function (answers) {
                if (filter) {
                    // Get only answers that isn't "extra" data like sequencecheck or certainty.
                    return _this.getBasicAnswersFromArray(answers);
                }
                else {
                    return answers;
                }
            });
        });
    };
    /**
     * Extract the question slot from a question name.
     *
     * @param {string} name Question name.
     * @return {number} Question slot.
     */
    CoreQuestionProvider.prototype.getQuestionSlotFromName = function (name) {
        if (name) {
            var match = name.match(this.QUESTION_PREFIX_REGEX);
            if (match && match[1]) {
                return parseInt(match[1], 10);
            }
        }
        return -1;
    };
    /**
     * Get question state based on state name.
     *
     * @param {string} name State name.
     * @return {CoreQuestionState} State.
     */
    CoreQuestionProvider.prototype.getState = function (name) {
        return this.STATES[name || 'cannotdeterminestatus'];
    };
    /**
     * Check if an answer is extra data like sequencecheck or certainty.
     *
     * @param {string} name Answer name.
     * @return {boolean} Whether it's extra data.
     */
    CoreQuestionProvider.prototype.isExtraAnswer = function (name) {
        // Maybe the name still has the prefix.
        name = this.removeQuestionPrefix(name);
        return name[0] == '-' || name[0] == ':';
    };
    /**
     * Remove an attempt answers from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreQuestionProvider.prototype.removeAttemptAnswers = function (component, attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(_this.QUESTION_ANSWERS_TABLE, { component: component, attemptid: attemptId });
        });
    };
    /**
     * Remove an attempt questions from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreQuestionProvider.prototype.removeAttemptQuestions = function (component, attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(_this.QUESTION_TABLE, { component: component, attemptid: attemptId });
        });
    };
    /**
     * Remove an answer from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} name Answer's name.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreQuestionProvider.prototype.removeAnswer = function (component, attemptId, name, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(_this.QUESTION_ANSWERS_TABLE, { component: component, attemptid: attemptId,
                name: name });
        });
    };
    /**
     * Remove a question from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} slot Question slot.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreQuestionProvider.prototype.removeQuestion = function (component, attemptId, slot, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(_this.QUESTION_TABLE, { component: component, attemptid: attemptId, slot: slot });
        });
    };
    /**
     * Remove a question answers from site DB.
     *
     * @param {string} component Component the attempt belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {string} slot Question slot.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreQuestionProvider.prototype.removeQuestionAnswers = function (component, attemptId, slot, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(_this.QUESTION_ANSWERS_TABLE, { component: component, attemptid: attemptId,
                questionslot: slot });
        });
    };
    /**
     * Remove the prefix from a question answer name.
     *
     * @param {string} name Question name.
     * @return {string} Name without prefix.
     */
    CoreQuestionProvider.prototype.removeQuestionPrefix = function (name) {
        if (name) {
            return name.replace(this.QUESTION_PREFIX_REGEX, '');
        }
        return '';
    };
    /**
     * Save answers in local DB.
     *
     * @param {string} component Component the answers belong to. E.g. 'mmaModQuiz'.
     * @param {number} componentId ID of the component the answers belong to.
     * @param {number} attemptId Attempt ID.
     * @param {number} userId User ID.
     * @param {any} answers Object with the answers to save.
     * @param {number} [timemodified] Time modified to set in the answers. If not defined, current time.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreQuestionProvider.prototype.saveAnswers = function (component, componentId, attemptId, userId, answers, timemodified, siteId) {
        var _this = this;
        timemodified = timemodified || this.timeUtils.timestamp();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var db = site.getDb(), promises = [];
            for (var name_2 in answers) {
                var value = answers[name_2], entry = {
                    component: component,
                    componentid: componentId,
                    attemptid: attemptId,
                    userid: userId,
                    questionslot: _this.getQuestionSlotFromName(name_2),
                    name: name_2,
                    value: value,
                    timemodified: timemodified
                };
                promises.push(db.insertRecord(_this.QUESTION_ANSWERS_TABLE, entry));
            }
            return Promise.all(promises);
        });
    };
    /**
     * Save a question in local DB.
     *
     * @param {string} component Component the question belongs to. E.g. 'mmaModQuiz'.
     * @param {number} componentId ID of the component the question belongs to.
     * @param {number} attemptId Attempt ID.
     * @param {number} userId User ID.
     * @param {any} question The question to save.
     * @param {string} state Question's state.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreQuestionProvider.prototype.saveQuestion = function (component, componentId, attemptId, userId, question, state, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                component: component,
                componentid: componentId,
                attemptid: attemptId,
                userid: userId,
                number: question.number,
                slot: question.slot,
                state: state
            };
            return site.getDb().insertRecord(_this.QUESTION_TABLE, entry);
        });
    };
    CoreQuestionProvider.COMPONENT = 'mmQuestion';
    CoreQuestionProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreQuestionProvider);
    return CoreQuestionProvider;
}());

//# sourceMappingURL=question.js.map

/***/ }),
/* 77 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionBehaviourDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__default_behaviour_handler__ = __webpack_require__(790);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Delegate to register question behaviour handlers.
 */
var CoreQuestionBehaviourDelegate = /** @class */ (function (_super) {
    __extends(CoreQuestionBehaviourDelegate, _super);
    function CoreQuestionBehaviourDelegate(logger, sitesProvider, eventsProvider, questionDelegate, defaultHandler) {
        var _this = _super.call(this, 'CoreQuestionBehaviourDelegate', logger, sitesProvider, eventsProvider) || this;
        _this.questionDelegate = questionDelegate;
        _this.defaultHandler = defaultHandler;
        _this.handlerNameProperty = 'type';
        return _this;
    }
    /**
     * Determine a question new state based on its answer(s).
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<CoreQuestionState>} Promise resolved with state.
     */
    CoreQuestionBehaviourDelegate.prototype.determineNewState = function (behaviour, component, attemptId, question, siteId) {
        behaviour = this.questionDelegate.getBehaviourForQuestion(question, behaviour);
        return Promise.resolve(this.executeFunctionOnEnabled(behaviour, 'determineNewState', [component, attemptId, question, siteId]));
    };
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return a directive to render it.
     *
     * @param {Injector} injector Injector.
     * @param {string} behaviour Default behaviour.
     * @param {any} question The question.
     * @return {Promise<any[]>} Promise resolved with components to render some extra data in the question.
     */
    CoreQuestionBehaviourDelegate.prototype.handleQuestion = function (injector, behaviour, question) {
        behaviour = this.questionDelegate.getBehaviourForQuestion(question, behaviour);
        return Promise.resolve(this.executeFunctionOnEnabled(behaviour, 'handleQuestion', [injector, question]));
    };
    /**
     * Check if a question behaviour is supported.
     *
     * @param {string} behaviour Name of the behaviour.
     * @return {boolean} Whether it's supported.
     */
    CoreQuestionBehaviourDelegate.prototype.isBehaviourSupported = function (behaviour) {
        return this.hasHandler(behaviour, true);
    };
    CoreQuestionBehaviourDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__default_behaviour_handler__["a" /* CoreQuestionBehaviourDefaultHandler */]])
    ], CoreQuestionBehaviourDelegate);
    return CoreQuestionBehaviourDelegate;
}(__WEBPACK_IMPORTED_MODULE_4__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=behaviour-delegate.js.map

/***/ }),
/* 78 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__delegate__ = __webpack_require__(42);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service with some common functions to handle questions.
 */
var CoreQuestionHelperProvider = /** @class */ (function () {
    function CoreQuestionHelperProvider(domUtils, textUtils, questionProvider, sitesProvider, translate, urlUtils, utils, filepoolProvider, questionDelegate) {
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.questionProvider = questionProvider;
        this.sitesProvider = sitesProvider;
        this.translate = translate;
        this.urlUtils = urlUtils;
        this.utils = utils;
        this.filepoolProvider = filepoolProvider;
        this.questionDelegate = questionDelegate;
        this.lastErrorShown = 0;
    }
    /**
     * Add a behaviour button to the question's "behaviourButtons" property.
     *
     * @param {any} question Question.
     * @param {HTMLInputElement} button Behaviour button (DOM element).
     */
    CoreQuestionHelperProvider.prototype.addBehaviourButton = function (question, button) {
        if (!button || !question) {
            return;
        }
        if (!question.behaviourButtons) {
            question.behaviourButtons = [];
        }
        // Extract the data we want.
        question.behaviourButtons.push({
            id: button.id,
            name: button.name,
            value: button.value,
            disabled: button.disabled
        });
    };
    /**
     * Extract question behaviour submit buttons from the question's HTML and add them to "behaviourButtons" property.
     * The buttons aren't deleted from the content because all the im-controls block will be removed afterwards.
     *
     * @param {any} question Question to treat.
     * @param {string} [selector] Selector to search the buttons. By default, '.im-controls input[type="submit"]'.
     */
    CoreQuestionHelperProvider.prototype.extractQbehaviourButtons = function (question, selector) {
        var _this = this;
        selector = selector || '.im-controls input[type="submit"]';
        var element = this.domUtils.convertToElement(question.html);
        // Search the buttons.
        var buttons = Array.from(element.querySelectorAll(selector));
        buttons.forEach(function (button) {
            _this.addBehaviourButton(question, button);
        });
        question.html = element.innerHTML;
    };
    /**
     * Check if the question has CBM and, if so, extract the certainty options and add them to a new
     * "behaviourCertaintyOptions" property.
     * The value of the selected option is stored in question.behaviourCertaintySelected.
     * We don't remove them from HTML because the whole im-controls block will be removed afterwards.
     *
     * @param {any} question Question to treat.
     * @return {boolean} Wether the certainty is found.
     */
    CoreQuestionHelperProvider.prototype.extractQbehaviourCBM = function (question) {
        var _this = this;
        var element = this.domUtils.convertToElement(question.html);
        var labels = Array.from(element.querySelectorAll('.im-controls .certaintychoices label[for*="certainty"]'));
        question.behaviourCertaintyOptions = [];
        labels.forEach(function (label) {
            // Search the radio button inside this certainty and add its data to the options array.
            var input = label.querySelector('input[type="radio"]');
            if (input) {
                question.behaviourCertaintyOptions.push({
                    id: input.id,
                    name: input.name,
                    value: input.value,
                    text: _this.textUtils.cleanTags(label.innerHTML),
                    disabled: input.disabled
                });
                if (input.checked) {
                    question.behaviourCertaintySelected = input.value;
                }
            }
        });
        // If we have a certainty value stored in local we'll use that one.
        if (question.localAnswers && typeof question.localAnswers['-certainty'] != 'undefined') {
            question.behaviourCertaintySelected = question.localAnswers['-certainty'];
        }
        return labels.length > 0;
    };
    /**
     * Check if the question has a redo button and, if so, add it to "behaviourButtons" property
     * and remove it from the HTML.
     *
     * @param {any} question Question to treat.
     */
    CoreQuestionHelperProvider.prototype.extractQbehaviourRedoButton = function (question) {
        // Create a fake div element so we can search using querySelector.
        var redoSelector = 'input[type="submit"][name*=redoslot], input[type="submit"][name*=tryagain]';
        // Search redo button in feedback.
        if (!this.searchBehaviourButton(question, 'html', '.outcome ' + redoSelector)) {
            // Not found in question HTML.
            if (question.feedbackHtml) {
                // We extracted the feedback already, search it in there.
                if (this.searchBehaviourButton(question, 'feedbackHtml', redoSelector)) {
                    // Button found, stop.
                    return;
                }
            }
            // Button still not found. Now search in the info box if it exists.
            if (question.infoHtml) {
                this.searchBehaviourButton(question, 'infoHtml', redoSelector);
            }
        }
    };
    /**
     * Check if the question contains a "seen" input.
     * If so, add the name and value to a "behaviourSeenInput" property and remove the input.
     *
     * @param {any} question Question to treat.
     * @return {boolean} Whether the seen input is found.
     */
    CoreQuestionHelperProvider.prototype.extractQbehaviourSeenInput = function (question) {
        var element = this.domUtils.convertToElement(question.html);
        // Search the "seen" input.
        var seenInput = element.querySelector('input[type="hidden"][name*=seen]');
        if (seenInput) {
            // Get the data and remove the input.
            question.behaviourSeenInput = {
                name: seenInput.name,
                value: seenInput.value
            };
            seenInput.parentElement.removeChild(seenInput);
            question.html = element.innerHTML;
            return true;
        }
        return false;
    };
    /**
     * Removes the comment from the question HTML code and adds it in a new "commentHtml" property.
     *
     * @param {any} question Question.
     */
    CoreQuestionHelperProvider.prototype.extractQuestionComment = function (question) {
        this.extractQuestionLastElementNotInContent(question, '.comment', 'commentHtml');
    };
    /**
     * Removes the feedback from the question HTML code and adds it in a new "feedbackHtml" property.
     *
     * @param {any} question Question.
     */
    CoreQuestionHelperProvider.prototype.extractQuestionFeedback = function (question) {
        this.extractQuestionLastElementNotInContent(question, '.outcome', 'feedbackHtml');
    };
    /**
     * Extracts the info box from a question and add it to an "infoHtml" property.
     *
     * @param {any} question Question.
     * @param {string} selector Selector to search the element.
     */
    CoreQuestionHelperProvider.prototype.extractQuestionInfoBox = function (question, selector) {
        this.extractQuestionLastElementNotInContent(question, selector, 'infoHtml');
    };
    /**
     * Searches the last occurrence of a certain element and check it's not in the question contents.
     * If found, removes it from the question HTML and adds it to a new property inside question.
     *
     * @param {any} question Question.
     * @param {string} selector Selector to search the element.
     * @param {string} attrName Name of the attribute to store the HTML in.
     */
    CoreQuestionHelperProvider.prototype.extractQuestionLastElementNotInContent = function (question, selector, attrName) {
        var element = this.domUtils.convertToElement(question.html);
        var matches = Array.from(element.querySelectorAll(selector));
        // Get the last element and check it's not in the question contents.
        var last = matches.pop();
        while (last) {
            if (!this.domUtils.closest(last, '.formulation')) {
                // Not in question contents. Add it to a separate attribute and remove it from the HTML.
                question[attrName] = last.innerHTML;
                last.parentElement.removeChild(last);
                question.html = element.innerHTML;
                return;
            }
            // It's inside the question content, treat next element.
            last = matches.pop();
        }
    };
    /**
     * Removes the scripts from a question's HTML and adds it in a new 'scriptsCode' property.
     * It will also search for init_question functions of the question type and add the object to an 'initObjects' property.
     *
     * @param {any} question Question.
     * @param {number} usageId Usage ID.
     */
    CoreQuestionHelperProvider.prototype.extractQuestionScripts = function (question, usageId) {
        var _this = this;
        question.scriptsCode = '';
        question.initObjects = null;
        question.amdArgs = null;
        if (question.html) {
            // Search the scripts.
            var matches = question.html.match(/<script[^>]*>[\s\S]*?<\/script>/mg);
            if (!matches) {
                // No scripts, stop.
                return;
            }
            matches.forEach(function (match) {
                // Add the script to scriptsCode and remove it from html.
                question.scriptsCode += match;
                question.html = question.html.replace(match, '');
                // Search init_question functions for this type.
                var initMatches = match.match(new RegExp('M\.qtype_' + question.type + '\.init_question\\(.*?}\\);', 'mg'));
                if (initMatches) {
                    var initMatch = initMatches.pop();
                    // Remove start and end of the match, we only want the object.
                    initMatch = initMatch.replace('M.qtype_' + question.type + '.init_question(', '');
                    initMatch = initMatch.substr(0, initMatch.length - 2);
                    // Try to convert it to an object and add it to the question.
                    question.initObjects = _this.textUtils.parseJSON(initMatch, null);
                }
                var amdRegExp = new RegExp('require\\(\\["qtype_' + question.type + '/question"\\], ' +
                    'function\\(amd\\) \\{ amd\.init\\(("(q|question-' + usageId + '-)' + question.slot +
                    '".*?)\\); \\}\\);;', 'm');
                var amdMatch = match.match(amdRegExp);
                if (amdMatch) {
                    // Try to convert the arguments to an array and add them to the question.
                    question.amdArgs = _this.textUtils.parseJSON('[' + amdMatch[1] + ']', null);
                }
            });
        }
    };
    /**
     * Get the names of all the inputs inside an HTML code.
     * This function will return an object where the keys are the input names. The values will always be true.
     * This is in order to make this function compatible with other functions like CoreQuestionProvider.getBasicAnswers.
     *
     * @param {string} html HTML code.
     * @return {any} Object where the keys are the names.
     */
    CoreQuestionHelperProvider.prototype.getAllInputNamesFromHtml = function (html) {
        var _this = this;
        var element = this.domUtils.convertToElement('<form>' + html + '</form>'), form = element.children[0], answers = {};
        // Search all input elements.
        Array.from(form.elements).forEach(function (element) {
            var name = element.name || '';
            // Ignore flag and submit inputs.
            if (!name || name.match(/_:flagged$/) || element.type == 'submit' || element.tagName == 'BUTTON') {
                return;
            }
            answers[_this.questionProvider.removeQuestionPrefix(name)] = true;
        });
        return answers;
    };
    /**
     * Retrieve the answers entered in a form.
     * We don't use ngModel because it doesn't detect changes done by JavaScript and some questions might do that.
     *
     * @param {HTMLFormElement} form Form.
     * @return {any} Object with the answers.
     */
    CoreQuestionHelperProvider.prototype.getAnswersFromForm = function (form) {
        if (!form || !form.elements) {
            return {};
        }
        var answers = {}, elements = Array.from(form.elements);
        elements.forEach(function (element) {
            var name = element.name || element.getAttribute('ng-reflect-name') || '';
            // Ignore flag and submit inputs.
            if (!name || name.match(/_:flagged$/) || element.type == 'submit' || element.tagName == 'BUTTON') {
                return;
            }
            // Get the value.
            if (element.type == 'checkbox') {
                answers[name] = !!element.checked;
            }
            else if (element.type == 'radio') {
                if (element.checked) {
                    answers[name] = element.value;
                }
            }
            else {
                answers[name] = element.value;
            }
        });
        return answers;
    };
    /**
     * Given an HTML code with list of attachments, returns the list of attached files (filename and fileurl).
     * Please take into account that this function will treat all the anchors in the HTML, you should provide
     * an HTML containing only the attachments anchors.
     *
     * @param  {String} html HTML code to search in.
     * @return {Object[]}    Attachments.
     */
    CoreQuestionHelperProvider.prototype.getQuestionAttachmentsFromHtml = function (html) {
        var _this = this;
        var element = this.domUtils.convertToElement(html);
        // Remove the filemanager (area to attach files to a question).
        this.domUtils.removeElement(element, 'div[id*=filemanager]');
        // Search the anchors.
        var anchors = Array.from(element.querySelectorAll('a')), attachments = [];
        anchors.forEach(function (anchor) {
            var content = anchor.innerHTML;
            // Check anchor is valid.
            if (anchor.href && content) {
                content = _this.textUtils.cleanTags(content, true).trim();
                attachments.push({
                    filename: content,
                    fileurl: anchor.href
                });
            }
        });
        return attachments;
    };
    /**
     * Get the sequence check from a question HTML.
     *
     * @param {string} html Question's HTML.
     * @return {{name: string, value: string}} Object with the sequencecheck name and value.
     */
    CoreQuestionHelperProvider.prototype.getQuestionSequenceCheckFromHtml = function (html) {
        if (html) {
            var element = this.domUtils.convertToElement(html);
            // Search the input holding the sequencecheck.
            var input = element.querySelector('input[name*=sequencecheck]');
            if (input && typeof input.name != 'undefined' && typeof input.value != 'undefined') {
                return {
                    name: input.name,
                    value: input.value
                };
            }
        }
    };
    /**
     * Get the CSS class for a question based on its state.
     *
     * @param {string} name Question's state name.
     * @return {string} State class.
     */
    CoreQuestionHelperProvider.prototype.getQuestionStateClass = function (name) {
        var state = this.questionProvider.getState(name);
        return state ? state.class : '';
    };
    /**
     * Get the validation error message from a question HTML if it's there.
     *
     * @param {string} html Question's HTML.
     * @return {string} Validation error message if present.
     */
    CoreQuestionHelperProvider.prototype.getValidationErrorFromHtml = function (html) {
        var element = this.domUtils.convertToElement(html);
        return this.domUtils.getContentsOfElement(element, '.validationerror');
    };
    /**
     * Check if some HTML contains draft file URLs for the current site.
     *
     * @param {string} html Question's HTML.
     * @return {boolean} Whether it contains draft files URLs.
     */
    CoreQuestionHelperProvider.prototype.hasDraftFileUrls = function (html) {
        var url = this.sitesProvider.getCurrentSite().getURL();
        if (url.slice(-1) != '/') {
            url = url += '/';
        }
        url += 'draftfile.php';
        return html.indexOf(url) != -1;
    };
    /**
     * For each input element found in the HTML, search if there's a local answer stored and
     * override the HTML's value with the local one.
     *
     * @param {any} question Question.
     */
    CoreQuestionHelperProvider.prototype.loadLocalAnswersInHtml = function (question) {
        var _this = this;
        var element = this.domUtils.convertToElement('<form>' + question.html + '</form>'), form = element.children[0];
        // Search all input elements.
        Array.from(form.elements).forEach(function (element) {
            var name = element.name || '';
            // Ignore flag and submit inputs.
            if (!name || name.match(/_:flagged$/) || element.type == 'submit' || element.tagName == 'BUTTON') {
                return;
            }
            // Search if there's a local answer.
            name = _this.questionProvider.removeQuestionPrefix(name);
            if (question.localAnswers && typeof question.localAnswers[name] != 'undefined') {
                if (element.tagName == 'TEXTAREA') {
                    // Just put the answer inside the textarea.
                    element.innerHTML = question.localAnswers[name];
                }
                else if (element.tagName == 'SELECT') {
                    // Search the selected option and select it.
                    var selected = element.querySelector('option[value="' + question.localAnswers[name] + '"]');
                    if (selected) {
                        selected.setAttribute('selected', 'selected');
                    }
                }
                else if (element.type == 'radio') {
                    // Check if this radio is selected.
                    if (element.value == question.localAnswers[name]) {
                        element.setAttribute('checked', 'checked');
                    }
                    else {
                        element.removeAttribute('checked');
                    }
                }
                else if (element.type == 'checkbox') {
                    // Check if this checkbox is checked.
                    if (_this.utils.isTrueOrOne(question.localAnswers[name])) {
                        element.setAttribute('checked', 'checked');
                    }
                    else {
                        element.removeAttribute('checked');
                    }
                }
                else {
                    // Put the answer in the value.
                    element.setAttribute('value', question.localAnswers[name]);
                }
            }
        });
        // Update the question HTML.
        question.html = form.innerHTML;
    };
    /**
     * Prefetch the files in a question HTML.
     *
     * @param {any} question Question.
     * @param {string} [component] The component to link the files to. If not defined, question component.
     * @param {string|number} [componentId] An ID to use in conjunction with the component. If not defined, question ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [usageId] Usage ID. Required in Moodle 3.7+.
     * @return {Promise<any>} Promise resolved when all the files have been downloaded.
     */
    CoreQuestionHelperProvider.prototype.prefetchQuestionFiles = function (question, component, componentId, siteId, usageId) {
        var _this = this;
        var urls = this.domUtils.extractDownloadableFilesFromHtml(question.html);
        if (!component) {
            component = __WEBPACK_IMPORTED_MODULE_8__question__["a" /* CoreQuestionProvider */].COMPONENT;
            componentId = question.id;
        }
        urls.push.apply(urls, this.questionDelegate.getAdditionalDownloadableFiles(question, usageId));
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = [];
            urls.forEach(function (url) {
                if (!site.canDownloadFiles() && _this.urlUtils.isPluginFileUrl(url)) {
                    return;
                }
                if (url.indexOf('theme/image.php') > -1 && url.indexOf('flagged') > -1) {
                    // Ignore flag images.
                    return;
                }
                promises.push(_this.filepoolProvider.addToQueueByUrl(siteId, url, component, componentId));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Prepare and return the answers.
     *
     * @param {any[]} questions The list of questions.
     * @param {any} answers The input data.
     * @param {boolean} offline True if data should be saved in offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with answers to send to server.
     */
    CoreQuestionHelperProvider.prototype.prepareAnswers = function (questions, answers, offline, siteId) {
        var _this = this;
        var promises = [];
        questions = questions || [];
        questions.forEach(function (question) {
            promises.push(_this.questionDelegate.prepareAnswersForQuestion(question, answers, offline, siteId));
        });
        return this.utils.allPromises(promises).then(function () {
            return answers;
        });
    };
    /**
     * Replace Moodle's correct/incorrect classes with the Mobile ones.
     *
     * @param {HTMLElement} element DOM element.
     */
    CoreQuestionHelperProvider.prototype.replaceCorrectnessClasses = function (element) {
        this.domUtils.replaceClassesInElement(element, {
            correct: 'core-question-answer-correct',
            incorrect: 'core-question-answer-incorrect'
        });
    };
    /**
     * Replace Moodle's feedback classes with the Mobile ones.
     *
     * @param {HTMLElement} element DOM element.
     */
    CoreQuestionHelperProvider.prototype.replaceFeedbackClasses = function (element) {
        this.domUtils.replaceClassesInElement(element, {
            outcome: 'core-question-feedback-container core-question-feedback-padding',
            specificfeedback: 'core-question-feedback-container core-question-feedback-inline'
        });
    };
    /**
     * Search a behaviour button in a certain question property containing HTML.
     *
     * @param {any} question Question.
     * @param {string} htmlProperty The name of the property containing the HTML to search.
     * @param {string} selector The selector to find the button.
     * @return {boolean} Whether the button is found.
     */
    CoreQuestionHelperProvider.prototype.searchBehaviourButton = function (question, htmlProperty, selector) {
        var element = this.domUtils.convertToElement(question[htmlProperty]);
        var button = element.querySelector(selector);
        if (button) {
            // Add a behaviour button to the question's "behaviourButtons" property.
            this.addBehaviourButton(question, button);
            // Remove the button from the HTML.
            button.parentElement.removeChild(button);
            // Update the question's html.
            question[htmlProperty] = element.innerHTML;
            return true;
        }
        return false;
    };
    /**
     * Convenience function to show a parsing error and abort.
     *
     * @param {EventEmitter<void>} [onAbort] If supplied, will emit an event.
     * @param {string} [error] Error to show.
     */
    CoreQuestionHelperProvider.prototype.showComponentError = function (onAbort, error) {
        // Prevent consecutive errors.
        var now = Date.now();
        if (now - this.lastErrorShown > 500) {
            this.lastErrorShown = now;
            this.domUtils.showErrorModalDefault(error, 'addon.mod_quiz.errorparsequestions', true);
        }
        onAbort && onAbort.emit();
    };
    /**
     * Treat correctness icons, replacing them with local icons and setting click events to show the feedback if needed.
     *
     * @param {HTMLElement} element DOM element.
     */
    CoreQuestionHelperProvider.prototype.treatCorrectnessIcons = function (element) {
        var icons = Array.from(element.querySelectorAll('img.icon, img.questioncorrectnessicon'));
        icons.forEach(function (icon) {
            // Replace the icon with the font version.
            if (icon.src) {
                var newIcon = document.createElement('i');
                if (icon.src.indexOf('incorrect') > -1) {
                    newIcon.className = 'icon fa fa-remove text-danger fa-fw questioncorrectnessicon';
                }
                else if (icon.src.indexOf('correct') > -1) {
                    newIcon.className = 'icon fa fa-check text-success fa-fw questioncorrectnessicon';
                }
                else {
                    return;
                }
                newIcon.title = icon.title;
                newIcon.ariaLabel = icon.title;
                icon.parentNode.replaceChild(newIcon, icon);
            }
        });
        var spans = Array.from(element.querySelectorAll('.feedbackspan.accesshide'));
        spans.forEach(function (span) {
            // Search if there's a hidden feedback for this element.
            var icon = span.previousSibling;
            if (!icon) {
                return;
            }
            if (!icon.classList.contains('icon') && !icon.classList.contains('questioncorrectnessicon')) {
                return;
            }
            icon.classList.add('questioncorrectnessicon');
            if (span.innerHTML) {
                // There's a hidden feedback. Mark the icon as tappable.
                // The click listener is only added if treatCorrectnessIconsClicks is called.
                icon.setAttribute('tappable', '');
            }
        });
    };
    /**
     * Add click listeners to all tappable correctness icons.
     *
     * @param {HTMLElement} element DOM element.
     * @param {string} [component] The component to use when viewing the feedback.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     */
    CoreQuestionHelperProvider.prototype.treatCorrectnessIconsClicks = function (element, component, componentId) {
        var _this = this;
        var icons = Array.from(element.querySelectorAll('i.icon.questioncorrectnessicon[tappable]')), title = this.translate.instant('core.question.feedback');
        icons.forEach(function (icon) {
            // Search the feedback for the icon.
            var span = icon.parentElement.querySelector('.feedbackspan.accesshide');
            if (span) {
                // There's a hidden feedback, show it when the icon is clicked.
                icon.addEventListener('click', function (event) {
                    _this.textUtils.expandText(title, span.innerHTML, component, componentId);
                });
            }
        });
    };
    CoreQuestionHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__question__["a" /* CoreQuestionProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_9__delegate__["a" /* CoreQuestionDelegate */]])
    ], CoreQuestionHelperProvider);
    return CoreQuestionHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 79 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessRuleDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__classes_delegate__ = __webpack_require__(62);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Delegate to register access rules for quiz module.
 */
var AddonModQuizAccessRuleDelegate = /** @class */ (function (_super) {
    __extends(AddonModQuizAccessRuleDelegate, _super);
    function AddonModQuizAccessRuleDelegate(logger, sitesProvider, eventsProvider, utils) {
        var _this = _super.call(this, 'AddonModQuizAccessRulesDelegate', logger, sitesProvider, eventsProvider) || this;
        _this.utils = utils;
        _this.handlerNameProperty = 'ruleName';
        return _this;
    }
    /**
     * Get the handler for a certain rule.
     *
     * @param {string} ruleName Name of the access rule.
     * @return {AddonModQuizAccessRuleHandler} Handler. Undefined if no handler found for the rule.
     */
    AddonModQuizAccessRuleDelegate.prototype.getAccessRuleHandler = function (ruleName) {
        return this.getHandler(ruleName, true);
    };
    /**
     * Given a list of rules, get some fixed preflight data (data that doesn't require user interaction).
     *
     * @param {string[]} rules List of active rules names.
     * @param {any} quiz Quiz.
     * @param {any} preflightData Object where to store the preflight data.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when all the data has been gathered.
     */
    AddonModQuizAccessRuleDelegate.prototype.getFixedPreflightData = function (rules, quiz, preflightData, attempt, prefetch, siteId) {
        var _this = this;
        rules = rules || [];
        var promises = [];
        rules.forEach(function (rule) {
            promises.push(Promise.resolve(_this.executeFunctionOnEnabled(rule, 'getFixedPreflightData', [quiz, preflightData, attempt, prefetch, siteId])));
        });
        return this.utils.allPromises(promises).catch(function () {
            // Never reject.
        });
    };
    /**
     * Get the Component to use to display the access rule preflight.
     *
     * @param {Injector} injector Injector.
     * @return {Promise<any>} Promise resolved with the component to use, undefined if not found.
     */
    AddonModQuizAccessRuleDelegate.prototype.getPreflightComponent = function (rule, injector) {
        return Promise.resolve(this.executeFunctionOnEnabled(rule, 'getPreflightComponent', [injector]));
    };
    /**
     * Check if an access rule is supported.
     *
     * @param {string} ruleName Name of the rule.
     * @return {boolean} Whether it's supported.
     */
    AddonModQuizAccessRuleDelegate.prototype.isAccessRuleSupported = function (ruleName) {
        return this.hasHandler(ruleName, true);
    };
    /**
     * Given a list of rules, check if preflight check is required.
     *
     * @param {string[]} rules List of active rules names.
     * @param {any} quiz Quiz.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it's required.
     */
    AddonModQuizAccessRuleDelegate.prototype.isPreflightCheckRequired = function (rules, quiz, attempt, prefetch, siteId) {
        var _this = this;
        rules = rules || [];
        var promises = [];
        var isRequired = false;
        rules.forEach(function (rule) {
            promises.push(_this.isPreflightCheckRequiredForRule(rule, quiz, attempt, prefetch, siteId).then(function (required) {
                if (required) {
                    isRequired = true;
                }
            }));
        });
        return this.utils.allPromises(promises).then(function () {
            return isRequired;
        }).catch(function () {
            // Never reject.
            return isRequired;
        });
    };
    /**
     * Check if preflight check is required for a certain rule.
     *
     * @param {string} rule Rule name.
     * @param {any} quiz Quiz.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it's required.
     */
    AddonModQuizAccessRuleDelegate.prototype.isPreflightCheckRequiredForRule = function (rule, quiz, attempt, prefetch, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(rule, 'isPreflightCheckRequired', [quiz, attempt, prefetch, siteId]));
    };
    /**
     * Notify all rules that the preflight check has passed.
     *
     * @param {string[]} rules List of active rules names.
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} preflightData Preflight data gathered.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizAccessRuleDelegate.prototype.notifyPreflightCheckPassed = function (rules, quiz, attempt, preflightData, prefetch, siteId) {
        var _this = this;
        rules = rules || [];
        var promises = [];
        rules.forEach(function (rule) {
            promises.push(Promise.resolve(_this.executeFunctionOnEnabled(rule, 'notifyPreflightCheckPassed', [quiz, attempt, preflightData, prefetch, siteId])));
        });
        return this.utils.allPromises(promises).catch(function () {
            // Never reject.
        });
    };
    /**
     * Notify all rules that the preflight check has failed.
     *
     * @param {string[]} rules List of active rules names.
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} preflightData Preflight data gathered.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizAccessRuleDelegate.prototype.notifyPreflightCheckFailed = function (rules, quiz, attempt, preflightData, prefetch, siteId) {
        var _this = this;
        rules = rules || [];
        var promises = [];
        rules.forEach(function (rule) {
            promises.push(Promise.resolve(_this.executeFunctionOnEnabled(rule, 'notifyPreflightCheckFailed', [quiz, attempt, preflightData, prefetch, siteId])));
        });
        return this.utils.allPromises(promises).catch(function () {
            // Never reject.
        });
    };
    /**
     * Whether or not the time left of an attempt should be displayed.
     *
     * @param {string[]} rules List of active rules names.
     * @param {any} attempt The attempt.
     * @param {number} endTime The attempt end time (in seconds).
     * @param {number} timeNow The current time in seconds.
     * @return {boolean} Whether it should be displayed.
     */
    AddonModQuizAccessRuleDelegate.prototype.shouldShowTimeLeft = function (rules, attempt, endTime, timeNow) {
        rules = rules || [];
        for (var i in rules) {
            var rule = rules[i];
            if (this.executeFunctionOnEnabled(rule, 'shouldShowTimeLeft', [attempt, endTime, timeNow])) {
                return true;
            }
        }
        return false;
    };
    AddonModQuizAccessRuleDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModQuizAccessRuleDelegate);
    return AddonModQuizAccessRuleDelegate;
}(__WEBPACK_IMPORTED_MODULE_5__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=access-rules-delegate.js.map

/***/ }),
/* 80 */,
/* 81 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseActivityPrefetchHandlerBase; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__module_prefetch_handler__ = __webpack_require__(773);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Base prefetch handler to be registered in CoreCourseModulePrefetchDelegate. It is useful to minimize the amount of
 * functions that handlers need to implement. It also provides some helper features like preventing a module to be
 * downloaded twice at the same time.
 *
 * If your handler inherits from this service, you just need to override the functions that you want to change.
 *
 * This class should be used for ACTIVITIES. You must override the prefetch function, and it's recommended to call
 * prefetchPackage in there since it handles the package status.
 */
var CoreCourseActivityPrefetchHandlerBase = /** @class */ (function (_super) {
    __extends(CoreCourseActivityPrefetchHandlerBase, _super);
    function CoreCourseActivityPrefetchHandlerBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Download the module.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when all content is downloaded.
     */
    CoreCourseActivityPrefetchHandlerBase.prototype.download = function (module, courseId, dirPath) {
        // Same implementation for download and prefetch.
        return this.prefetch(module, courseId, false, dirPath);
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseActivityPrefetchHandlerBase.prototype.prefetch = function (module, courseId, single, dirPath) {
        // To be overridden. It should call prefetchPackage
        return Promise.resolve();
    };
    /**
     * Prefetch the module, setting package status at start and finish.
     *
     * Example usage from a child instance:
     *     return this.prefetchPackage(module, courseId, single, this.prefetchModule.bind(this), siteId, someParam, anotherParam);
     *
     * Then the function "prefetchModule" will receive params:
     *     prefetchModule(module, courseId, single, siteId, someParam, anotherParam)
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {prefetchFunction} downloadFn Function to perform the prefetch. Please check the documentation of prefetchFunction.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the module has been downloaded. Data returned is not reliable.
     */
    CoreCourseActivityPrefetchHandlerBase.prototype.prefetchPackage = function (module, courseId, single, downloadFn, siteId) {
        var _this = this;
        var args = [];
        for (var _i = 5; _i < arguments.length; _i++) {
            args[_i - 5] = arguments[_i];
        }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!this.appProvider.isOnline()) {
            // Cannot prefetch in offline.
            return Promise.reject(this.translate.instant('core.networkerrormsg'));
        }
        if (this.isDownloading(module.id, siteId)) {
            // There's already a download ongoing for this module, return the promise.
            return this.getOngoingDownload(module.id, siteId);
        }
        var prefetchPromise = this.setDownloading(module.id, siteId).then(function () {
            // Package marked as downloading, get module info to be able to handle links.
            return Promise.all([
                _this.courseProvider.getModuleBasicInfo(module.id, siteId),
                _this.courseProvider.getModule(module.id, courseId, undefined, false, true, siteId),
            ]);
        }).then(function () {
            // Call the download function, send all the params except downloadFn. This includes all params passed after siteId.
            return downloadFn.apply(downloadFn, [module, courseId, single, siteId].concat(args));
        }).then(function (extra) {
            // Only accept string types.
            if (typeof extra != 'string') {
                extra = '';
            }
            // Prefetch finished, mark as downloaded.
            return _this.setDownloaded(module.id, siteId, extra);
        }).catch(function (error) {
            // Error prefetching, go back to previous status and reject the promise.
            return _this.setPreviousStatusAndReject(module.id, error, siteId);
        });
        return this.addOngoingDownload(module.id, prefetchPromise, siteId);
    };
    /**
     * Mark the module as downloaded.
     *
     * @param {number} id Unique identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {string} [extra] Extra data to store.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseActivityPrefetchHandlerBase.prototype.setDownloaded = function (id, siteId, extra) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.storePackageStatus(siteId, __WEBPACK_IMPORTED_MODULE_0__constants__["a" /* CoreConstants */].DOWNLOADED, this.component, id, extra);
    };
    /**
     * Mark the module as downloading.
     *
     * @param {number} id Unique identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseActivityPrefetchHandlerBase.prototype.setDownloading = function (id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.storePackageStatus(siteId, __WEBPACK_IMPORTED_MODULE_0__constants__["a" /* CoreConstants */].DOWNLOADING, this.component, id);
    };
    /**
     * Set previous status and return a rejected promise.
     *
     * @param {number} id Unique identifier per component.
     * @param {any} [error] Error to return.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<never>} Rejected promise.
     */
    CoreCourseActivityPrefetchHandlerBase.prototype.setPreviousStatusAndReject = function (id, error, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.setPackagePreviousStatus(siteId, this.component, id).then(function () {
            return Promise.reject(error);
        });
    };
    return CoreCourseActivityPrefetchHandlerBase;
}(__WEBPACK_IMPORTED_MODULE_1__module_prefetch_handler__["a" /* CoreCourseModulePrefetchHandlerBase */]));

//# sourceMappingURL=activity-prefetch-handler.js.map

/***/ }),
/* 82 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CorePushNotificationsDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle push notifications actions to perform when clicked and received.
 */
var CorePushNotificationsDelegate = /** @class */ (function () {
    function CorePushNotificationsDelegate(loggerProvider, sitesProvider, utils) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.observables = {};
        this.clickHandlers = {};
        this.counterHandlers = {};
        this.logger = loggerProvider.getInstance('CorePushNotificationsDelegate');
        this.observables['receive'] = new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Subject"]();
    }
    /**
     * Function called when a push notification is clicked. Sends notification to handlers.
     *
     * @param {any} notification Notification clicked.
     * @return {Promise<any>} Promise resolved when done.
     */
    CorePushNotificationsDelegate.prototype.clicked = function (notification) {
        if (!notification) {
            return;
        }
        var promises = [];
        var handlers = [];
        var _loop_1 = function (name_1) {
            var handler = this_1.clickHandlers[name_1];
            // Check if the handler is disabled for the site.
            promises.push(this_1.isFeatureDisabled(handler, notification.site).then(function (disabled) {
                if (!disabled) {
                    // Check if the handler handles the notification.
                    return Promise.resolve(handler.handles(notification)).then(function (handles) {
                        if (handles) {
                            handlers.push(handler);
                        }
                    });
                }
            }));
        };
        var this_1 = this;
        for (var name_1 in this.clickHandlers) {
            _loop_1(name_1);
        }
        return this.utils.allPromises(promises).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Sort by priority.
            handlers = handlers.sort(function (a, b) {
                return a.priority <= b.priority ? 1 : -1;
            });
            if (handlers[0]) {
                // Execute the first one.
                handlers[0].handleClick(notification);
            }
        });
    };
    /**
     * Check if a handler's feature is disabled for a certain site.
     *
     * @param {CorePushNotificationsClickHandler} handler Handler to check.
     * @param {string} siteId The site ID to check.
     * @return {Promise<boolean>} Promise resolved with boolean: whether the handler feature is disabled.
     */
    CorePushNotificationsDelegate.prototype.isFeatureDisabled = function (handler, siteId) {
        if (handler.featureName) {
            // Check if the feature is disabled.
            return this.sitesProvider.isFeatureDisabled(handler.featureName, siteId);
        }
        else {
            return Promise.resolve(false);
        }
    };
    /**
     * Function called when a push notification is received in foreground (cannot tell when it's received in background).
     * Sends notification to all handlers.
     *
     * @param {any} notification Notification received.
     */
    CorePushNotificationsDelegate.prototype.received = function (notification) {
        this.observables['receive'].next(notification);
    };
    /**
     * Register a push notifications observable for a certain event. Right now, only receive is supported.
     * let observer = pushNotificationsDelegate.on('receive').subscribe((notification) => {
     * ...
     * observer.unsuscribe();
     *
     * @param {string}  eventName Only receive is permitted.
     * @return {Subject<any>} Observer to subscribe.
     */
    CorePushNotificationsDelegate.prototype.on = function (eventName) {
        if (typeof this.observables[eventName] == 'undefined') {
            var eventNames = Object.keys(this.observables).join(', ');
            this.logger.warn("'" + eventName + "' event name is not allowed. Use one of the following: '" + eventNames + "'.");
            return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Subject"]();
        }
        return this.observables[eventName];
    };
    /**
     * Register a click handler.
     *
     * @param {CorePushNotificationsClickHandler} handler The handler to register.
     * @return {boolean} True if registered successfully, false otherwise.
     */
    CorePushNotificationsDelegate.prototype.registerClickHandler = function (handler) {
        if (typeof this.clickHandlers[handler.name] !== 'undefined') {
            this.logger.log("Addon '" + handler.name + "' already registered");
            return false;
        }
        this.logger.log("Registered addon '" + handler.name + "'");
        this.clickHandlers[handler.name] = handler;
        return true;
    };
    /**
     * Register a push notifications handler for update badge counter.
     *
     * @param {string} name  Handler's name.
     */
    CorePushNotificationsDelegate.prototype.registerCounterHandler = function (name) {
        if (typeof this.counterHandlers[name] == 'undefined') {
            this.logger.debug("Registered handler '" + name + "' as badge counter handler.");
            this.counterHandlers[name] = name;
        }
        else {
            this.logger.log("Handler '" + name + "' as badge counter handler already registered.");
        }
    };
    /**
     * Check if a counter handler is present.
     *
     * @param {string} name       Handler's name.
     * @return {boolean}  If handler name is present.
     */
    CorePushNotificationsDelegate.prototype.isCounterHandlerRegistered = function (name) {
        return typeof this.counterHandlers[name] != 'undefined';
    };
    /**
     * Get all counter badge handlers.
     *
     * @return {any}  with all the handler names.
     */
    CorePushNotificationsDelegate.prototype.getCounterHandlers = function () {
        return this.counterHandlers;
    };
    CorePushNotificationsDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CorePushNotificationsDelegate);
    return CorePushNotificationsDelegate;
}());

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 83 */,
/* 84 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModuleMainActivityComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__main_resource_component__ = __webpack_require__(164);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Template class to easily create CoreCourseModuleMainComponent of activities.
 */
var CoreCourseModuleMainActivityComponent = /** @class */ (function (_super) {
    __extends(CoreCourseModuleMainActivityComponent, _super);
    function CoreCourseModuleMainActivityComponent(injector, content, loggerName) {
        if (loggerName === void 0) { loggerName = 'CoreCourseModuleMainResourceComponent'; }
        var _this = _super.call(this, injector, loggerName) || this;
        _this.content = content;
        _this.sitesProvider = injector.get(__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]);
        _this.courseProvider = injector.get(__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]);
        _this.appProvider = injector.get(__WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */]);
        _this.eventsProvider = injector.get(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */]);
        _this.modulePrefetchDelegate = injector.get(__WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */]);
        var network = injector.get(__WEBPACK_IMPORTED_MODULE_5__ionic_native_network__["a" /* Network */]);
        var zone = injector.get(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"]);
        // Refresh online status when changes.
        _this.onlineObserver = network.onchange().subscribe(function (online) {
            // Execute the callback in the Angular zone, so change detection doesn't stop working.
            zone.run(function () {
                _this.isOnline = online;
            });
        });
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreCourseModuleMainActivityComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.hasOffline = false;
        this.syncIcon = 'spinner';
        this.siteId = this.sitesProvider.getCurrentSiteId();
        this.moduleName = this.courseProvider.translateModuleName(this.moduleName);
        if (this.syncEventName) {
            // Refresh data if this discussion is synchronized automatically.
            this.syncObserver = this.eventsProvider.on(this.syncEventName, function (data) {
                _this.autoSyncEventReceived(data);
            }, this.siteId);
        }
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data received on sync observer.
     * @return {boolean}          True if refresh is needed, false otherwise.
     */
    CoreCourseModuleMainActivityComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        return false;
    };
    /**
     * An autosync event has been received, check if refresh is needed and update the view.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     */
    CoreCourseModuleMainActivityComponent.prototype.autoSyncEventReceived = function (syncEventData) {
        if (this.isRefreshSyncNeeded(syncEventData)) {
            // Refresh the data.
            this.showLoadingAndRefresh(false);
        }
    };
    /**
     * Perform the refresh content function.
     *
     * @param  {boolean}      [sync=false]       If the refresh needs syncing.
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Resolved when done.
     */
    CoreCourseModuleMainActivityComponent.prototype.refreshContent = function (sync, showErrors) {
        var _this = this;
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        if (!this.module) {
            // This can happen if course format changes from single activity to weekly/topics.
            return Promise.resolve();
        }
        this.refreshIcon = 'spinner';
        this.syncIcon = 'spinner';
        // Wrap the call in a try/catch so the workflow isn't interrupted if an error occurs.
        // E.g. when changing course format we cannot know when will this.module become undefined, so it could cause errors.
        var promise;
        try {
            promise = this.invalidateContent();
        }
        catch (ex) {
            // An error ocurred in the function, log the error and just resolve the promise so the workflow continues.
            this.logger.error(ex);
            promise = Promise.resolve();
        }
        return promise.catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.loadContent(true, sync, showErrors);
        }).finally(function () {
            _this.refreshIcon = 'refresh';
            _this.syncIcon = 'sync';
        });
    };
    /**
     * Show loading and perform the load content function.
     *
     * @param  {boolean}      [sync=false]       If the fetch needs syncing.
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Resolved when done.
     */
    CoreCourseModuleMainActivityComponent.prototype.showLoadingAndFetch = function (sync, showErrors) {
        var _this = this;
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        this.refreshIcon = 'spinner';
        this.syncIcon = 'spinner';
        this.loaded = false;
        this.domUtils.scrollToTop(this.content);
        return this.loadContent(false, sync, showErrors).finally(function () {
            _this.refreshIcon = 'refresh';
            _this.syncIcon = 'sync';
        });
    };
    /**
     * Show loading and perform the refresh content function.
     *
     * @param  {boolean}      [sync=false]       If the refresh needs syncing.
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Resolved when done.
     */
    CoreCourseModuleMainActivityComponent.prototype.showLoadingAndRefresh = function (sync, showErrors) {
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        this.refreshIcon = 'spinner';
        this.syncIcon = 'spinner';
        this.loaded = false;
        this.domUtils.scrollToTop(this.content);
        return this.refreshContent(sync, showErrors);
    };
    /**
     * Download the component contents.
     *
     * @param {boolean}       [refresh=false] Whether we're refreshing data.
     * @param  {boolean}      [sync=false]       If the refresh needs syncing.
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModuleMainActivityComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        return Promise.resolve();
    };
    /**
     * Loads the component contents and shows the corresponding error.
     *
     * @param {boolean}       [refresh=false] Whether we're refreshing data.
     * @param  {boolean}      [sync=false]       If the refresh needs syncing.
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModuleMainActivityComponent.prototype.loadContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        this.isOnline = this.appProvider.isOnline();
        if (!this.module) {
            // This can happen if course format changes from single activity to weekly/topics.
            return Promise.resolve();
        }
        // Wrap the call in a try/catch so the workflow isn't interrupted if an error occurs.
        // E.g. when changing course format we cannot know when will this.module become undefined, so it could cause errors.
        var promise;
        try {
            promise = this.fetchContent(refresh, sync, showErrors);
        }
        catch (ex) {
            // An error ocurred in the function, log the error and just resolve the promise so the workflow continues.
            this.logger.error(ex);
            promise = Promise.resolve();
        }
        return promise.catch(function (error) {
            if (!refresh) {
                // Some call failed, retry without using cache since it might be a new activity.
                return _this.refreshContent(sync);
            }
            // Error getting data, fail.
            _this.domUtils.showErrorModalDefault(error, _this.fetchContentDefaultError, true);
        }).finally(function () {
            _this.loaded = true;
            _this.refreshIcon = 'refresh';
            _this.syncIcon = 'sync';
        });
    };
    /**
     * Displays some data based on the current status.
     *
     * @param {string} status The current status.
     * @param {string} [previousStatus] The previous status. If not defined, there is no previous status.
     */
    CoreCourseModuleMainActivityComponent.prototype.showStatus = function (status, previousStatus) {
        // To be overridden.
    };
    /**
     * Watch for changes on the status.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModuleMainActivityComponent.prototype.setStatusListener = function () {
        var _this = this;
        if (typeof this.statusObserver == 'undefined') {
            // Listen for changes on this module status.
            this.statusObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].PACKAGE_STATUS_CHANGED, function (data) {
                if (data.componentId === _this.module.id && data.component === _this.component) {
                    // The status has changed, update it.
                    var previousStatus = _this.currentStatus;
                    _this.currentStatus = data.status;
                    _this.showStatus(_this.currentStatus, previousStatus);
                }
            }, this.siteId);
            // Also, get the current status.
            return this.modulePrefetchDelegate.getModuleStatus(this.module, this.courseId).then(function (status) {
                _this.currentStatus = status;
                _this.showStatus(status);
            });
        }
        return Promise.resolve();
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModuleMainActivityComponent.prototype.sync = function () {
        return Promise.resolve(true);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any}     result Data returned on the sync function.
     * @return {boolean}        If suceed or not.
     */
    CoreCourseModuleMainActivityComponent.prototype.hasSyncSucceed = function (result) {
        return true;
    };
    /**
     * Tries to synchronize the activity.
     *
     * @param  {boolean}      [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<boolean>} Promise resolved with true if sync succeed, or false if failed.
     */
    CoreCourseModuleMainActivityComponent.prototype.syncActivity = function (showErrors) {
        var _this = this;
        if (showErrors === void 0) { showErrors = false; }
        return this.sync().then(function (result) {
            if (result.warnings && result.warnings.length) {
                _this.domUtils.showErrorModal(result.warnings[0]);
            }
            return _this.hasSyncSucceed(result);
        }).catch(function (error) {
            if (showErrors) {
                _this.domUtils.showErrorModalDefault(error, 'core.errorsync', true);
            }
            return false;
        });
    };
    /**
     * Component being destroyed.
     */
    CoreCourseModuleMainActivityComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.onlineObserver && this.onlineObserver.unsubscribe();
        this.syncObserver && this.syncObserver.off();
        this.statusObserver && this.statusObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseModuleMainActivityComponent.prototype, "group", void 0);
    return CoreCourseModuleMainActivityComponent;
}(__WEBPACK_IMPORTED_MODULE_7__main_resource_component__["a" /* CoreCourseModuleMainResourceComponent */]));

//# sourceMappingURL=main-activity-component.js.map

/***/ }),
/* 85 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(267);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service that provides some features for feedbacks.
 */
var AddonModFeedbackProvider = /** @class */ (function () {
    function AddonModFeedbackProvider(logger, sitesProvider, utils, filepoolProvider, feedbackOffline, appProvider, logHelper) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.filepoolProvider = filepoolProvider;
        this.feedbackOffline = feedbackOffline;
        this.appProvider = appProvider;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = this.ROOT_CACHE_KEY + '';
        this.logger = logger.getInstance('AddonModFeedbackProvider');
    }
    AddonModFeedbackProvider_1 = AddonModFeedbackProvider;
    /**
     * Check dependency of a question item.
     *
     * @param   {any[]}  items      All question items to check dependency.
     * @param   {any}    item       Item to check.
     * @return  {boolean}           Return true if dependency is acomplished and it can be shown. False, otherwise.
     */
    AddonModFeedbackProvider.prototype.checkDependencyItem = function (items, item) {
        var depend = items.find(function (itemFind) {
            return itemFind.id == item.dependitem;
        });
        // Item not found, looks like dependent item has been removed or is in the same or following pages.
        if (!depend) {
            return true;
        }
        switch (depend.typ) {
            case 'label':
                return false;
            case 'multichoice':
            case 'multichoicerated':
                return this.compareDependItemMultichoice(depend, item.dependvalue);
            default:
                break;
        }
        return item.dependvalue == depend.rawValue;
    };
    /**
     * Check dependency item of type Multichoice.
     *
     * @param  {any}     item        Item to check.
     * @param  {string}  dependValue Value to compare.
     * @return {boolean}             Return true if dependency is acomplished and it can be shown. False, otherwise.
     */
    AddonModFeedbackProvider.prototype.compareDependItemMultichoice = function (item, dependValue) {
        var values, choices;
        var parts = item.presentation.split(AddonModFeedbackProvider_1.MULTICHOICE_TYPE_SEP) || [], subtype = parts.length > 0 && parts[0] ? parts[0] : 'r';
        choices = parts[1] || '';
        choices = choices.split(AddonModFeedbackProvider_1.MULTICHOICE_ADJUST_SEP)[0] || '';
        choices = choices.split(AddonModFeedbackProvider_1.LINE_SEP) || [];
        if (subtype === 'c') {
            if (typeof item.rawValue == 'undefined') {
                values = [''];
            }
            else {
                item.rawValue = '' + item.rawValue;
                values = item.rawValue.split(AddonModFeedbackProvider_1.LINE_SEP);
            }
        }
        else {
            values = [item.rawValue];
        }
        for (var index = 0; index < choices.length; index++) {
            for (var x in values) {
                if (values[x] == index + 1) {
                    var value = choices[index];
                    if (item.typ == 'multichoicerated') {
                        value = value.split(AddonModFeedbackProvider_1.MULTICHOICERATED_VALUE_SEP)[1] || '';
                    }
                    if (value.trim() == dependValue) {
                        return true;
                    }
                    // We can finish checking if only searching on one value and we found it.
                    if (values.length == 1) {
                        return false;
                    }
                }
            }
        }
        return false;
    };
    /**
     * Fill values of item questions.
     *
     * @param   {number}   feedbackId   Feedback ID.
     * @param   {any[]}    items        Item to fill the value.
     * @param   {boolean}  offline      True if it should return cached data. Has priority over ignoreCache.
     * @param   {boolean}  ignoreCache  True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}   siteId       Site ID.
     * @return  {Promise<any>}          Resolved with values when done.
     */
    AddonModFeedbackProvider.prototype.fillValues = function (feedbackId, items, offline, ignoreCache, siteId) {
        var _this = this;
        return this.getCurrentValues(feedbackId, offline, ignoreCache, siteId).then(function (valuesArray) {
            var values = {};
            valuesArray.forEach(function (value) {
                values[value.item] = value.value;
            });
            items.forEach(function (itemData) {
                if (itemData.hasvalue && typeof values[itemData.id] != 'undefined') {
                    itemData.rawValue = values[itemData.id];
                }
            });
        }).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Merge with offline data.
            return _this.feedbackOffline.getFeedbackResponses(feedbackId, siteId).then(function (offlineValuesArray) {
                var offlineValues = {};
                // Merge all values into one array.
                offlineValuesArray = offlineValuesArray.reduce(function (a, b) {
                    var responses = _this.utils.objectToArrayOfObjects(b.responses, 'id', 'value');
                    return a.concat(responses);
                }, []).map(function (a) {
                    var parts = a.id.split('_');
                    a.typ = parts[0];
                    a.item = parseInt(parts[1], 0);
                    return a;
                });
                offlineValuesArray.forEach(function (value) {
                    if (typeof offlineValues[value.item] == 'undefined') {
                        offlineValues[value.item] = [];
                    }
                    offlineValues[value.item].push(value.value);
                });
                items.forEach(function (itemData) {
                    if (itemData.hasvalue && typeof offlineValues[itemData.id] != 'undefined') {
                        // Treat multichoice checkboxes.
                        if (itemData.typ == 'multichoice' &&
                            itemData.presentation.split(AddonModFeedbackProvider_1.MULTICHOICE_TYPE_SEP)[0] == 'c') {
                            offlineValues[itemData.id] = offlineValues[itemData.id].filter(function (value) {
                                return value > 0;
                            });
                            itemData.rawValue = offlineValues[itemData.id].join(AddonModFeedbackProvider_1.LINE_SEP);
                        }
                        else {
                            itemData.rawValue = offlineValues[itemData.id][0];
                        }
                    }
                });
                return items;
            });
        }).catch(function () {
            // Ignore errors.
            return items;
        });
    };
    /**
     * Returns all the feedback non respondents users.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    groupId         Group id, 0 means that the function will determine the user group.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @param   {any}       [previous]      Only for recurrent use. Object with the previous fetched info.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getAllNonRespondents = function (feedbackId, groupId, ignoreCache, siteId, previous) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (typeof previous == 'undefined') {
            previous = {
                page: 0,
                users: []
            };
        }
        return this.getNonRespondents(feedbackId, groupId, previous.page, ignoreCache, siteId).then(function (response) {
            if (previous.users.length < response.total) {
                previous.users = previous.users.concat(response.users);
            }
            if (previous.users.length < response.total) {
                // Can load more.
                previous.page++;
                return _this.getAllNonRespondents(feedbackId, groupId, ignoreCache, siteId, previous);
            }
            previous.total = response.total;
            return previous;
        });
    };
    /**
     * Returns all the feedback user responses.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    groupId         Group id, 0 means that the function will determine the user group.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @param   {any}       [previous]      Only for recurrent use. Object with the previous fetched info.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getAllResponsesAnalysis = function (feedbackId, groupId, ignoreCache, siteId, previous) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (typeof previous == 'undefined') {
            previous = {
                page: 0,
                attempts: [],
                anonattempts: []
            };
        }
        return this.getResponsesAnalysis(feedbackId, groupId, previous.page, ignoreCache, siteId).then(function (responses) {
            if (previous.anonattempts.length < responses.totalanonattempts) {
                previous.anonattempts = previous.anonattempts.concat(responses.anonattempts);
            }
            if (previous.attempts.length < responses.totalattempts) {
                previous.attempts = previous.attempts.concat(responses.attempts);
            }
            if (previous.anonattempts.length < responses.totalanonattempts || previous.attempts.length < responses.totalattempts) {
                // Can load more.
                previous.page++;
                return _this.getAllResponsesAnalysis(feedbackId, groupId, ignoreCache, siteId, previous);
            }
            previous.totalattempts = responses.totalattempts;
            previous.totalanonattempts = responses.totalanonattempts;
            return previous;
        });
    };
    /**
     * Get analysis information for a given feedback.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    [groupId]       Group ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<any>}                   Promise resolved when the feedback is retrieved.
     */
    AddonModFeedbackProvider.prototype.getAnalysis = function (feedbackId, groupId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId
            }, preSets = {
                cacheKey: _this.getAnalysisDataCacheKey(feedbackId, groupId)
            };
            if (groupId) {
                params['groupid'] = groupId;
            }
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_feedback_get_analysis', params, preSets);
        });
    };
    /**
     * Get cache key for feedback analysis data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @param {number} [groupId=0]  Group ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getAnalysisDataCacheKey = function (feedbackId, groupId) {
        if (groupId === void 0) { groupId = 0; }
        return this.getAnalysisDataPrefixCacheKey(feedbackId) + groupId;
    };
    /**
     * Get prefix cache key for feedback analysis data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getAnalysisDataPrefixCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':analysis:';
    };
    /**
     * Find an attempt in all responses analysis.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    attemptId       Attempt id to find.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @param   {any}       [previous]      Only for recurrent use. Object with the previous fetched info.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getAttempt = function (feedbackId, attemptId, ignoreCache, siteId, previous) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (typeof previous == 'undefined') {
            previous = {
                page: 0,
                attemptsLoaded: 0,
                anonAttemptsLoaded: 0
            };
        }
        return this.getResponsesAnalysis(feedbackId, 0, previous.page, ignoreCache, siteId).then(function (responses) {
            var attempt;
            attempt = responses.attempts.find(function (attempt) {
                return attemptId == attempt.id;
            });
            if (attempt) {
                return attempt;
            }
            attempt = responses.anonattempts.find(function (attempt) {
                return attemptId == attempt.id;
            });
            if (attempt) {
                return attempt;
            }
            if (previous.anonAttemptsLoaded < responses.totalanonattempts) {
                previous.anonAttemptsLoaded += responses.anonattempts.length;
            }
            if (previous.attemptsLoaded < responses.totalattempts) {
                previous.attemptsLoaded += responses.attempts.length;
            }
            if (previous.anonAttemptsLoaded < responses.totalanonattempts || previous.attemptsLoaded < responses.totalattempts) {
                // Can load more. Check there.
                previous.page++;
                return _this.getAttempt(feedbackId, attemptId, ignoreCache, siteId, previous);
            }
            // Not found and all loaded. Reject.
            return Promise.reject(null);
        });
    };
    /**
     * Get prefix cache key for feedback completion data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getCompletedDataCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':completed:';
    };
    /**
     * Returns the temporary completion timemodified for the current user.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<any>}                   Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getCurrentCompletedTimeModified = function (feedbackId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId
            }, preSets = {
                cacheKey: _this.getCurrentCompletedTimeModifiedDataCacheKey(feedbackId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_feedback_get_current_completed_tmp', params, preSets).then(function (response) {
                if (response && typeof response.feedback != 'undefined' && typeof response.feedback.timemodified != 'undefined') {
                    return response.feedback.timemodified;
                }
                return 0;
            }).catch(function () {
                // Ignore errors.
                return 0;
            });
        });
    };
    /**
     * Get prefix cache key for feedback current completed temp data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getCurrentCompletedTimeModifiedDataCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':completedtime:';
    };
    /**
     * Returns the temporary responses or responses of the last submission for the current user.
     *
     * @param   {number}    feedbackId          Feedback ID.
     * @param   {boolean}   [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param   {boolean}   [ignoreCache=false] True if it should ignore cached data (it always fail in offline or server down).
     * @param   {string}    [siteId]            Site ID. If not defined, current site.
     * @return  {Promise<any>}                  Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getCurrentValues = function (feedbackId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId
            }, preSets = {
                cacheKey: _this.getCurrentValuesDataCacheKey(feedbackId)
            };
            if (offline) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('mod_feedback_get_unfinished_responses', params, preSets).then(function (response) {
                if (!response || typeof response.responses == 'undefined') {
                    return Promise.reject(null);
                }
                if (response.responses.length == 0) {
                    // No unfinished responses, fetch responses of the last submission.
                    return site.read('mod_feedback_get_finished_responses', params, preSets).then(function (response) {
                        if (!response || typeof response.responses == 'undefined') {
                            return Promise.reject(null);
                        }
                        return response.responses;
                    });
                }
                return response.responses;
            });
        });
    };
    /**
     * Get cache key for get current values feedback data WS calls.
     *
     * @param  {number} feedbackId  Feedback ID.
     * @return {string}             Cache key.
     */
    AddonModFeedbackProvider.prototype.getCurrentValuesDataCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':currentvalues';
    };
    /**
     * Get  access information for a given feedback.
     *
     * @param   {number}    feedbackId          Feedback ID.
     * @param   {boolean}   [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param   {boolean}   [ignoreCache=false] True if it should ignore cached data (it always fail in offline or server down).
     * @param   {string}    [siteId]            Site ID. If not defined, current site.
     * @return  {Promise<any>}                  Promise resolved when the feedback is retrieved.
     */
    AddonModFeedbackProvider.prototype.getFeedbackAccessInformation = function (feedbackId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId
            }, preSets = {
                cacheKey: _this.getFeedbackAccessInformationDataCacheKey(feedbackId)
            };
            if (offline) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('mod_feedback_get_feedback_access_information', params, preSets);
        });
    };
    /**
     * Get cache key for feedback access information data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getFeedbackAccessInformationDataCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':access';
    };
    /**
     * Get cache key for feedback data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getFeedbackCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'feedback:' + courseId;
    };
    /**
     * Get prefix cache key for all feedback activity data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getFeedbackDataPrefixCacheKey = function (feedbackId) {
        return this.ROOT_CACHE_KEY + feedbackId;
    };
    /**
     * Get a feedback with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number}   courseId            Course ID.
     * @param {string}   key                 Name of the property to check.
     * @param {any}      value               Value to search.
     * @param {string}   [siteId]            Site ID. If not defined, current site.
     * @param {boolean} [forceCache]  True to always get the value from cache, false otherwise. Default false.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}  Promise resolved when the feedback is retrieved.
     */
    AddonModFeedbackProvider.prototype.getFeedbackDataByKey = function (courseId, key, value, siteId, forceCache, ignoreCache) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getFeedbackCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_8__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_feedback_get_feedbacks_by_courses', params, preSets).then(function (response) {
                if (response && response.feedbacks) {
                    var currentFeedback = response.feedbacks.find(function (feedback) {
                        return feedback[key] == value;
                    });
                    if (currentFeedback) {
                        return currentFeedback;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a feedback by course module ID.
     *
     * @param {number}   courseId       Course ID.
     * @param {number}   cmId           Course module ID.
     * @param {string}   [siteId]       Site ID. If not defined, current site.
     * @param {boolean} [forceCache]   True to always get the value from cache, false otherwise. Default false.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}   Promise resolved when the feedback is retrieved.
     */
    AddonModFeedbackProvider.prototype.getFeedback = function (courseId, cmId, siteId, forceCache, ignoreCache) {
        return this.getFeedbackDataByKey(courseId, 'coursemodule', cmId, siteId, forceCache, ignoreCache);
    };
    /**
     * Get a feedback by ID.
     *
     * @param {number}  courseId      Course ID.
     * @param {number}  id            Feedback ID.
     * @param {string}  [siteId]      Site ID. If not defined, current site.
     * @param {boolean} [forceCache]  True to always get the value from cache, false otherwise. Default false.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}         Promise resolved when the feedback is retrieved.
     */
    AddonModFeedbackProvider.prototype.getFeedbackById = function (courseId, id, siteId, forceCache, ignoreCache) {
        return this.getFeedbackDataByKey(courseId, 'id', id, siteId, forceCache, ignoreCache);
    };
    /**
     * Returns the items (questions) in the given feedback.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<any>}                   Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getItems = function (feedbackId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId
            }, preSets = {
                cacheKey: _this.getItemsDataCacheKey(feedbackId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_8__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_feedback_get_items', params, preSets);
        });
    };
    /**
     * Get cache key for get items feedback data WS calls.
     *
     * @param  {number} feedbackId  Feedback ID.
     * @return {string}             Cache key.
     */
    AddonModFeedbackProvider.prototype.getItemsDataCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':items';
    };
    /**
     * Retrieves a list of students who didn't submit the feedback.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    [groupId=0]     Group id, 0 means that the function will determine the user group.
     * @param   {number}    [page=0]        The page of records to return.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getNonRespondents = function (feedbackId, groupId, page, ignoreCache, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (page === void 0) { page = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId,
                groupid: groupId,
                page: page
            }, preSets = {
                cacheKey: _this.getNonRespondentsDataCacheKey(feedbackId, groupId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_feedback_get_non_respondents', params, preSets);
        });
    };
    /**
     * Get cache key for non respondents feedback data WS calls.
     *
     * @param  {number} feedbackId  Feedback ID.
     * @param  {number} [groupId=0] Group id, 0 means that the function will determine the user group.
     * @return {string}             Cache key.
     */
    AddonModFeedbackProvider.prototype.getNonRespondentsDataCacheKey = function (feedbackId, groupId) {
        if (groupId === void 0) { groupId = 0; }
        return this.getNonRespondentsDataPrefixCacheKey(feedbackId) + groupId;
    };
    /**
     * Get prefix cache key for feedback non respondents data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @return {string}           Cache key.
     */
    AddonModFeedbackProvider.prototype.getNonRespondentsDataPrefixCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':nonrespondents:';
    };
    /**
     * Get a single feedback page items. This function is not cached, use AddonModFeedbackHelperProvider#getPageItems instead.
     *
     * @param   {number}    feedbackId  Feedback ID.
     * @param   {number}    page        The page to get.
     * @param   {string}    [siteId]    Site ID. If not defined, current site.
     * @return  {Promise<any>}          Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getPageItems = function (feedbackId, page, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId,
                page: page
            };
            return site.write('mod_feedback_get_page_items', params);
        });
    };
    /**
     * Get a single feedback page items. If offline or server down it will use getItems to calculate dependencies.
     *
     * @param   {number}  feedbackId          Feedback ID.
     * @param   {number}  page                The page to get.
     * @param   {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param   {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}  [siteId]            Site ID. If not defined, current site.
     * @return  {Promise<any>}                Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getPageItemsWithValues = function (feedbackId, page, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getPageItems(feedbackId, page, siteId).then(function (response) {
            return _this.fillValues(feedbackId, response.items, offline, ignoreCache, siteId).then(function (items) {
                response.items = items;
                return response;
            });
        }).catch(function () {
            // If getPageItems fail we should calculate it using getItems.
            return _this.getItems(feedbackId, false, siteId).then(function (response) {
                return _this.fillValues(feedbackId, response.items, offline, ignoreCache, siteId).then(function (items) {
                    // Separate items by pages.
                    var currentPage = 0;
                    var previousPageItems = [];
                    var pageItems = items.filter(function (item) {
                        // Greater page, discard all entries.
                        if (currentPage > page) {
                            return false;
                        }
                        if (item.typ == 'pagebreak') {
                            currentPage++;
                            return false;
                        }
                        // Save items on previous page to check dependencies and discard entry.
                        if (currentPage < page) {
                            previousPageItems.push(item);
                            return false;
                        }
                        // Filter depending items.
                        if (item && item.dependitem > 0 && previousPageItems.length > 0) {
                            return _this.checkDependencyItem(previousPageItems, item);
                        }
                        // Filter items with errors.
                        return item;
                    });
                    // Check if there are more pages.
                    response.hasprevpage = page > 0;
                    response.hasnextpage = currentPage > page;
                    response.items = pageItems;
                    return response;
                });
            });
        });
    };
    /**
     * Convenience function to get the page we can jump.
     *
     * @param  {number}  feedbackId Feedback ID.
     * @param  {number}  page       Page where we want to jump.
     * @param  {number}  changePage If page change is forward (1) or backward (-1).
     * @param  {string}  siteId     Site ID.
     * @return {Promise<number | false>}  Page number where to jump. Or false if completed or first page.
     */
    AddonModFeedbackProvider.prototype.getPageJumpTo = function (feedbackId, page, changePage, siteId) {
        var _this = this;
        return this.getPageItemsWithValues(feedbackId, page, true, false, siteId).then(function (resp) {
            // The page we are going has items.
            if (resp.items.length > 0) {
                return page;
            }
            // Check we can jump futher.
            if ((changePage == 1 && resp.hasnextpage) || (changePage == -1 && resp.hasprevpage)) {
                return _this.getPageJumpTo(feedbackId, page + changePage, changePage, siteId);
            }
            // Completed or first page.
            return false;
        });
    };
    /**
     * Returns the feedback user responses.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    groupId         Group id, 0 means that the function will determine the user group.
     * @param   {number}    page            The page of records to return.
     * @param   {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getResponsesAnalysis = function (feedbackId, groupId, page, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId,
                groupid: groupId || 0,
                page: page || 0
            }, preSets = {
                cacheKey: _this.getResponsesAnalysisDataCacheKey(feedbackId, groupId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_feedback_get_responses_analysis', params, preSets);
        });
    };
    /**
     * Get cache key for responses analysis feedback data WS calls.
     *
     * @param  {number} feedbackId  Feedback ID.
     * @param  {number} [groupId=0] Group id, 0 means that the function will determine the user group.
     * @return {string}             Cache key.
     */
    AddonModFeedbackProvider.prototype.getResponsesAnalysisDataCacheKey = function (feedbackId, groupId) {
        if (groupId === void 0) { groupId = 0; }
        return this.getResponsesAnalysisDataPrefixCacheKey(feedbackId) + groupId;
    };
    /**
     * Get prefix cache key for feedback responses analysis data WS calls.
     *
     * @param {number} feedbackId Feedback ID.
     * @return {string}         Cache key.
     */
    AddonModFeedbackProvider.prototype.getResponsesAnalysisDataPrefixCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':responsesanalysis:';
    };
    /**
     * Gets the resume page information.
     *
     * @param   {number}    feedbackId          Feedback ID.
     * @param   {boolean}   [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param   {boolean}   [ignoreCache=false] True if it should ignore cached data (it always fail in offline or server down).
     * @param   {string}    [siteId]            Site ID. If not defined, current site.
     * @return  {Promise<any>}                  Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.getResumePage = function (feedbackId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId
            }, preSets = {
                cacheKey: _this.getResumePageDataCacheKey(feedbackId)
            };
            if (offline) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('mod_feedback_launch_feedback', params, preSets).then(function (response) {
                if (response && typeof response.gopage != 'undefined') {
                    // WS will return -1 for last page but the user need to start again.
                    return response.gopage > 0 ? response.gopage : 0;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get prefix cache key for resume feedback page data WS calls.
     *
     * @param {number} feedbackId   Feedback ID.
     * @return {string}             Cache key.
     */
    AddonModFeedbackProvider.prototype.getResumePageDataCacheKey = function (feedbackId) {
        return this.getFeedbackDataPrefixCacheKey(feedbackId) + ':launch';
    };
    /**
     * Invalidates feedback data except files and module info.
     *
     * @param  {number} feedbackId   Feedback ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateAllFeedbackData = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getFeedbackDataPrefixCacheKey(feedbackId));
        });
    };
    /**
     * Invalidates feedback analysis data.
     *
     * @param {number} feedbackId   Feedback ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateAnalysisData = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getAnalysisDataPrefixCacheKey(feedbackId));
        });
    };
    /**
     * Invalidate the prefetched content.
     * To invalidate files, use AddonFeedbackProvider#invalidateFiles.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.getFeedback(courseId, moduleId, siteId).then(function (feedback) {
            var ps = [];
            // Do not invalidate module data before getting module info, we need it!
            ps.push(_this.invalidateFeedbackData(courseId, siteId));
            ps.push(_this.invalidateAllFeedbackData(feedback.id, siteId));
            return Promise.all(ps);
        }));
        promises.push(this.invalidateFiles(moduleId, siteId));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates temporary completion record data.
     *
     * @param  {number} feedbackId   Feedback ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateCurrentValuesData = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCurrentValuesDataCacheKey(feedbackId));
        });
    };
    /**
     * Invalidates feedback access information data.
     *
     * @param {number} feedbackId   Feedback ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateFeedbackAccessInformationData = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getFeedbackAccessInformationDataCacheKey(feedbackId));
        });
    };
    /**
     * Invalidates feedback data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateFeedbackData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getFeedbackCacheKey(courseId));
        });
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param {number} moduleId  The module ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when the files are invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateFiles = function (moduleId, siteId) {
        return this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModFeedbackProvider_1.COMPONENT, moduleId);
    };
    /**
     * Invalidates feedback non respondents record data.
     *
     * @param  {number} feedbackId   Feedback ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateNonRespondentsData = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getNonRespondentsDataPrefixCacheKey(feedbackId));
        });
    };
    /**
     * Invalidates feedback user responses record data.
     *
     * @param  {number} feedbackId   Feedback ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateResponsesAnalysisData = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getResponsesAnalysisDataPrefixCacheKey(feedbackId));
        });
    };
    /**
     * Invalidates launch feedback data.
     *
     * @param {number} feedbackId   Feedback ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModFeedbackProvider.prototype.invalidateResumePageData = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getResumePageDataCacheKey(feedbackId));
        });
    };
    /**
     * Returns if feedback has been completed
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<boolean>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.isCompleted = function (feedbackId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId
            }, preSets = {
                cacheKey: _this.getCompletedDataCacheKey(feedbackId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return _this.utils.promiseWorks(site.read('mod_feedback_get_last_completed', params, preSets));
        });
    };
    /**
     * Return whether or not the plugin is enabled in a certain site. Plugin is enabled if the feedback WS are available.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     * @since 3.3
     */
    AddonModFeedbackProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('mod_feedback_get_feedbacks_by_courses') &&
                site.wsAvailable('mod_feedback_get_feedback_access_information');
        });
    };
    /**
     * Report the feedback as being viewed.
     *
     * @param {number} id                   Module ID.
     * @param {string} [name] Name of the feedback.
     * @param  {boolean} [formViewed=false] True if form was viewed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}               Promise resolved when the WS call is successful.
     */
    AddonModFeedbackProvider.prototype.logView = function (id, name, formViewed, siteId) {
        if (formViewed === void 0) { formViewed = false; }
        var params = {
            feedbackid: id,
            moduleviewed: formViewed ? 1 : 0
        };
        return this.logHelper.logSingle('mod_feedback_view_feedback', params, AddonModFeedbackProvider_1.COMPONENT, id, name, 'feedback', { moduleviewed: params.moduleviewed }, siteId);
    };
    /**
     * Process a jump between pages.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    page            The page being processed.
     * @param   {any}       responses       The data to be processed the key is the field name (usually type[index]_id).
     * @param   {boolean}   goPrevious      Whether we want to jump to previous page.
     * @param   {boolean}   formHasErrors   Whether the form we sent has required but empty fields (only used in offline).
     * @param   {number}    courseId        Course ID the feedback belongs to.
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.processPage = function (feedbackId, page, responses, goPrevious, formHasErrors, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.feedbackOffline.saveResponses(feedbackId, page, responses, courseId, siteId).then(function () {
                // Simulate process_page response.
                var response = {
                    jumpto: page,
                    completed: false,
                    offline: true
                };
                var changePage = 0;
                if (goPrevious) {
                    if (page > 0) {
                        changePage = -1;
                    }
                }
                else if (!formHasErrors) {
                    // We can only go next if it has no errors.
                    changePage = 1;
                }
                if (changePage === 0) {
                    return response;
                }
                return _this.getPageItemsWithValues(feedbackId, page, true, false, siteId).then(function (resp) {
                    // Check completion.
                    if (changePage == 1 && !resp.hasnextpage) {
                        response.completed = true;
                        return response;
                    }
                    return _this.getPageJumpTo(feedbackId, page + changePage, changePage, siteId).then(function (loadPage) {
                        if (loadPage === false) {
                            // Completed or first page.
                            if (changePage == -1) {
                                // First page.
                                response.jumpto = 0;
                            }
                            else {
                                // Completed.
                                response.completed = true;
                            }
                        }
                        else {
                            response.jumpto = loadPage;
                        }
                        return response;
                    });
                });
            });
        };
        if (!this.appProvider.isOnline()) {
            // App is offline, store the action.
            return storeOffline();
        }
        // If there's already a response to be sent to the server, discard it first.
        return this.feedbackOffline.deleteFeedbackPageResponses(feedbackId, page, siteId).then(function () {
            return _this.processPageOnline(feedbackId, page, responses, goPrevious, siteId).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that responses cannot be submitted.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store in offline.
                return storeOffline();
            });
        });
    };
    /**
     * Process a jump between pages.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    page            The page being processed.
     * @param   {any}       responses       The data to be processed the key is the field name (usually type[index]_id).
     * @param   {boolean}   goPrevious      Whether we want to jump to previous page.
     * @param   {string}    [siteId]        Site ID. If not defined, current site.
     * @return  {Promise<any>}                   Promise resolved when the info is retrieved.
     */
    AddonModFeedbackProvider.prototype.processPageOnline = function (feedbackId, page, responses, goPrevious, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                feedbackid: feedbackId,
                page: page,
                responses: _this.utils.objectToArrayOfObjects(responses, 'name', 'value'),
                goprevious: goPrevious ? 1 : 0
            };
            return site.write('mod_feedback_process_page', params).catch(function (error) {
                return Promise.reject(_this.utils.createFakeWSError(error));
            }).then(function (response) {
                // Invalidate and update current values because they will change.
                return _this.invalidateCurrentValuesData(feedbackId, site.getId()).then(function () {
                    return _this.getCurrentValues(feedbackId, false, false, site.getId());
                }).catch(function () {
                    // Ignore errors.
                }).then(function () {
                    return response;
                });
            });
        });
    };
    AddonModFeedbackProvider.COMPONENT = 'mmaModFeedback';
    AddonModFeedbackProvider.FORM_SUBMITTED = 'addon_mod_feedback_form_submitted';
    AddonModFeedbackProvider.LINE_SEP = '|';
    AddonModFeedbackProvider.MULTICHOICE_TYPE_SEP = '>>>>>';
    AddonModFeedbackProvider.MULTICHOICE_ADJUST_SEP = '<<<<<';
    AddonModFeedbackProvider.MULTICHOICE_HIDENOSELECT = 'h';
    AddonModFeedbackProvider.MULTICHOICERATED_VALUE_SEP = '####';
    AddonModFeedbackProvider = AddonModFeedbackProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* AddonModFeedbackOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModFeedbackProvider);
    return AddonModFeedbackProvider;
    var AddonModFeedbackProvider_1;
}());

//# sourceMappingURL=feedback.js.map

/***/ }),
/* 86 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CorePushNotificationsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_badge__ = __webpack_require__(747);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_push__ = __webpack_require__(254);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_device__ = __webpack_require__(418);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_sites_factory__ = __webpack_require__(345);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__configconstants__ = __webpack_require__(66);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















/**
 * Service to handle push notifications.
 */
var CorePushNotificationsProvider = /** @class */ (function () {
    function CorePushNotificationsProvider(logger, appProvider, initDelegate, pushNotificationsDelegate, sitesProvider, badge, localNotificationsProvider, utils, textUtils, push, configProvider, device, zone, translate, platform, sitesFactory) {
        var _this = this;
        this.appProvider = appProvider;
        this.initDelegate = initDelegate;
        this.pushNotificationsDelegate = pushNotificationsDelegate;
        this.sitesProvider = sitesProvider;
        this.badge = badge;
        this.localNotificationsProvider = localNotificationsProvider;
        this.utils = utils;
        this.textUtils = textUtils;
        this.push = push;
        this.configProvider = configProvider;
        this.device = device;
        this.zone = zone;
        this.translate = translate;
        this.platform = platform;
        this.sitesFactory = sitesFactory;
        this.appTablesSchema = [
            {
                name: CorePushNotificationsProvider_1.BADGE_TABLE,
                columns: [
                    {
                        name: 'siteid',
                        type: 'TEXT'
                    },
                    {
                        name: 'addon',
                        type: 'TEXT'
                    },
                    {
                        name: 'number',
                        type: 'INTEGER'
                    }
                ],
                primaryKeys: ['siteid', 'addon']
            },
            {
                name: CorePushNotificationsProvider_1.PENDING_UNREGISTER_TABLE,
                columns: [
                    {
                        name: 'siteid',
                        type: 'TEXT',
                        primaryKey: true
                    },
                    {
                        name: 'siteurl',
                        type: 'TEXT'
                    },
                    {
                        name: 'token',
                        type: 'TEXT'
                    },
                    {
                        name: 'info',
                        type: 'TEXT'
                    }
                ]
            }
        ];
        this.siteSchema = {
            name: 'AddonPushNotificationsProvider',
            version: 1,
            tables: [
                {
                    name: CorePushNotificationsProvider_1.REGISTERED_DEVICES_TABLE,
                    columns: [
                        {
                            name: 'appid',
                            type: 'TEXT',
                        },
                        {
                            name: 'uuid',
                            type: 'TEXT'
                        },
                        {
                            name: 'name',
                            type: 'TEXT'
                        },
                        {
                            name: 'model',
                            type: 'TEXT'
                        },
                        {
                            name: 'platform',
                            type: 'TEXT'
                        },
                        {
                            name: 'version',
                            type: 'TEXT'
                        },
                        {
                            name: 'pushid',
                            type: 'TEXT'
                        },
                    ],
                    primaryKeys: ['appid', 'uuid']
                }
            ],
        };
        this.logger = logger.getInstance('CorePushNotificationsProvider');
        this.appDB = appProvider.getDB();
        this.appDB.createTablesFromSchema(this.appTablesSchema);
        this.sitesProvider.registerSiteSchema(this.siteSchema);
        platform.ready().then(function () {
            // Create the default channel.
            _this.createDefaultChannel();
            translate.onLangChange.subscribe(function (event) {
                // Update the channel name.
                _this.createDefaultChannel();
            });
        });
    }
    CorePushNotificationsProvider_1 = CorePushNotificationsProvider;
    /**
     * Check whether the device can be registered in Moodle to receive push notifications.
     *
     * @return {boolean} Whether the device can be registered in Moodle.
     */
    CorePushNotificationsProvider.prototype.canRegisterOnMoodle = function () {
        return this.pushID && this.appProvider.isMobile();
    };
    /**
     * Delete all badge records for a given site.
     *
     * @param  {string} siteId Site ID.
     * @return {Promise<any>}  Resolved when done.
     */
    CorePushNotificationsProvider.prototype.cleanSiteCounters = function (siteId) {
        var _this = this;
        return this.appDB.deleteRecords(CorePushNotificationsProvider_1.BADGE_TABLE, { siteid: siteId }).finally(function () {
            _this.updateAppCounter();
        });
    };
    /**
     * Create the default push channel. It is used to change the name.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CorePushNotificationsProvider.prototype.createDefaultChannel = function () {
        var _this = this;
        if (!this.platform.is('android')) {
            return Promise.resolve();
        }
        return this.push.createChannel({
            id: 'PushPluginChannel',
            description: this.translate.instant('core.misc'),
            importance: 4
        }).catch(function (error) {
            _this.logger.error('Error changing push channel name', error);
        });
    };
    /**
     * Returns options for push notifications based on device.
     *
     * @return {Promise<PushOptions>} Promise with the push options resolved when done.
     */
    CorePushNotificationsProvider.prototype.getOptions = function () {
        var promise;
        if (this.localNotificationsProvider.canDisableSound()) {
            promise = this.configProvider.get(__WEBPACK_IMPORTED_MODULE_16__core_constants__["a" /* CoreConstants */].SETTINGS_NOTIFICATION_SOUND, true);
        }
        else {
            promise = Promise.resolve(true);
        }
        return promise.then(function (soundEnabled) {
            return {
                android: {
                    sound: !!soundEnabled,
                    icon: 'smallicon',
                    iconColor: __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].notificoncolor
                },
                ios: {
                    alert: 'true',
                    badge: true,
                    sound: !!soundEnabled
                },
                windows: {
                    sound: !!soundEnabled
                }
            };
        });
    };
    /**
     * Get the pushID for this device.
     *
     * @return {string} Push ID.
     */
    CorePushNotificationsProvider.prototype.getPushId = function () {
        return this.pushID;
    };
    /**
     * Get data to register the device in Moodle.
     *
     * @return {CorePushNotificationsRegisterData} Data.
     */
    CorePushNotificationsProvider.prototype.getRegisterData = function () {
        return {
            appid: __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].app_id,
            name: this.device.manufacturer || '',
            model: this.device.model,
            platform: this.device.platform + '-fcm',
            version: this.device.version,
            pushid: this.pushID,
            uuid: this.device.uuid
        };
    };
    /**
     * Get Sitebadge  counter from the database.
     *
     * @param  {string} siteId Site ID.
     * @return {Promise<any>}       Promise resolved with the stored badge counter for the site.
     */
    CorePushNotificationsProvider.prototype.getSiteCounter = function (siteId) {
        return this.getAddonBadge(siteId);
    };
    /**
     * Log a firebase event.
     *
     * @param {string} name Name of the event.
     * @param {any} data Data of the event.
     * @param {boolean} [filter] Whether to filter the data. This is useful when logging a full notification.
     * @return {Promise<any>} Promise resolved when done. This promise is never rejected.
     */
    CorePushNotificationsProvider.prototype.logEvent = function (name, data, filter) {
        var _this = this;
        var win = window; // This feature is only present in our fork of the plugin.
        if (__WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].enableanalytics && win.PushNotification && win.PushNotification.logEvent) {
            return new Promise(function (resolve, reject) {
                win.PushNotification.logEvent(resolve, function (error) {
                    _this.logger.error('Error logging firebase event', name, error);
                    resolve();
                }, name, data, !!filter);
            });
        }
        return Promise.resolve();
    };
    /**
     * Log a firebase view_item event.
     *
     * @param {number|string} itemId The item ID.
     * @param {string} itemName The item name.
     * @param {string} itemCategory The item category.
     * @param {string} wsName Name of the WS.
     * @param {any} [data] Other data to pass to the event.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done. This promise is never rejected.
     */
    CorePushNotificationsProvider.prototype.logViewEvent = function (itemId, itemName, itemCategory, wsName, data, siteId) {
        data = data || {};
        // Add "moodle" to the name of all extra params.
        data = this.utils.prefixKeys(data, 'moodle');
        data['moodleaction'] = wsName;
        data['moodlesiteid'] = siteId || this.sitesProvider.getCurrentSiteId();
        if (itemId) {
            data['item_id'] = itemId;
        }
        if (itemName) {
            data['item_name'] = itemName;
        }
        if (itemCategory) {
            data['item_category'] = itemCategory;
        }
        return this.logEvent('view_item', data, false);
    };
    /**
     * Log a firebase view_item_list event.
     *
     * @param {string} itemCategory The item category.
     * @param {string} wsName Name of the WS.
     * @param {any} [data] Other data to pass to the event.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done. This promise is never rejected.
     */
    CorePushNotificationsProvider.prototype.logViewListEvent = function (itemCategory, wsName, data, siteId) {
        data = data || {};
        // Add "moodle" to the name of all extra params.
        data = this.utils.prefixKeys(data, 'moodle');
        data['moodleaction'] = wsName;
        data['moodlesiteid'] = siteId || this.sitesProvider.getCurrentSiteId();
        if (itemCategory) {
            data['item_category'] = itemCategory;
        }
        return this.logEvent('view_item_list', data, false);
    };
    /**
     * Function called when a push notification is clicked. Redirect the user to the right state.
     *
     * @param {any} notification Notification.
     */
    CorePushNotificationsProvider.prototype.notificationClicked = function (notification) {
        var _this = this;
        this.initDelegate.ready().then(function () {
            _this.pushNotificationsDelegate.clicked(notification);
        });
    };
    /**
     * This function is called when we receive a Notification from APNS or a message notification from GCM.
     * The app can be in foreground or background,
     * if we are in background this code is executed when we open the app clicking in the notification bar.
     *
     * @param {any} notification Notification received.
     */
    CorePushNotificationsProvider.prototype.onMessageReceived = function (notification) {
        var _this = this;
        var data = notification ? notification.additionalData : {};
        this.sitesProvider.getSite(data.site).then(function () {
            if (typeof data.customdata == 'string') {
                data.customdata = _this.textUtils.parseJSON(data.customdata, {});
            }
            if (_this.utils.isTrueOrOne(data.foreground)) {
                // If the app is in foreground when the notification is received, it's not shown. Let's show it ourselves.
                if (_this.localNotificationsProvider.isAvailable()) {
                    var localNotif_1 = {
                        id: data.notId || 1,
                        data: data,
                        title: '',
                        text: '',
                        channel: 'PushPluginChannel'
                    }, promises = [], isAndroid_1 = _this.platform.is('android'), extraFeatures_1 = _this.utils.isTrueOrOne(data.extrafeatures);
                    // Apply formatText to title and message.
                    promises.push(_this.textUtils.formatText(notification.title, true, true).then(function (formattedTitle) {
                        localNotif_1.title = formattedTitle;
                    }).catch(function () {
                        localNotif_1.title = notification.title;
                    }));
                    promises.push(_this.textUtils.formatText(notification.message, true, true).catch(function () {
                        // Error formatting, use the original message.
                        return notification.message;
                    }).then(function (formattedMessage) {
                        if (extraFeatures_1 && isAndroid_1 && _this.utils.isFalseOrZero(data.notif)) {
                            // It's a message, use messaging style. Ionic Native doesn't specify this option.
                            localNotif_1.text = [
                                {
                                    message: formattedMessage,
                                    person: data.conversationtype == 2 ? data.userfromfullname : ''
                                }
                            ];
                        }
                        else {
                            localNotif_1.text = formattedMessage;
                        }
                    }));
                    if (extraFeatures_1 && isAndroid_1) {
                        // Use a different icon if needed.
                        localNotif_1.icon = notification.image;
                        // This feature isn't supported by the official plugin, we use a fork.
                        localNotif_1.iconType = data['image-type'];
                    }
                    Promise.all(promises).then(function () {
                        _this.localNotificationsProvider.schedule(localNotif_1, CorePushNotificationsProvider_1.COMPONENT, data.site, true);
                    });
                }
                // Trigger a notification received event.
                _this.initDelegate.ready().then(function () {
                    data.title = notification.title;
                    data.message = notification.message;
                    _this.pushNotificationsDelegate.received(data);
                });
            }
            else {
                // The notification was clicked.
                _this.notificationClicked(data);
            }
        });
    };
    /**
     * Unregisters a device from a certain Moodle site.
     *
     * @param {CoreSite} site Site to unregister from.
     * @return {Promise<any>} Promise resolved when device is unregistered.
     */
    CorePushNotificationsProvider.prototype.unregisterDeviceOnMoodle = function (site) {
        var _this = this;
        if (!site || !this.appProvider.isMobile()) {
            return Promise.reject(null);
        }
        this.logger.debug("Unregister device on Moodle: '" + site.id + "'");
        var data = {
            appid: __WEBPACK_IMPORTED_MODULE_17__configconstants__["a" /* CoreConfigConstants */].app_id,
            uuid: this.device.uuid
        };
        return site.write('core_user_remove_user_device', data).then(function (response) {
            if (!response || !response.removed) {
                return Promise.reject(null);
            }
            var promises = [];
            // Remove the device from the local DB.
            promises.push(site.getDb().deleteRecords(CorePushNotificationsProvider_1.REGISTERED_DEVICES_TABLE, _this.getRegisterData()));
            // Remove pending unregisters for this site.
            promises.push(_this.appDB.deleteRecords(CorePushNotificationsProvider_1.PENDING_UNREGISTER_TABLE, { siteid: site.id }));
            return Promise.all(promises).catch(function () {
                // Ignore errors.
            });
        }).catch(function (error) {
            if (_this.utils.isWebServiceError(error)) {
                // It's a WebService error, can't unregister.
                return Promise.reject(error);
            }
            // Store the pending unregister so it's retried again later.
            return _this.appDB.insertRecord(CorePushNotificationsProvider_1.PENDING_UNREGISTER_TABLE, {
                siteid: site.id,
                siteurl: site.getURL(),
                token: site.getToken(),
                info: JSON.stringify(site.getInfo())
            }).then(function () {
                return Promise.reject(error);
            });
        });
    };
    /**
     * Update Counter for an addon. It will update the refered siteId counter and the total badge.
     * It will return the updated addon counter.
     *
     * @param  {string} addon    Registered addon name to set the badge number.
     * @param  {number} value    The number to be stored.
     * @param  {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>}    Promise resolved with the stored badge counter for the addon on the site.
     */
    CorePushNotificationsProvider.prototype.updateAddonCounter = function (addon, value, siteId) {
        var _this = this;
        if (this.pushNotificationsDelegate.isCounterHandlerRegistered(addon)) {
            siteId = siteId || this.sitesProvider.getCurrentSiteId();
            return this.saveAddonBadge(value, siteId, addon).then(function () {
                return _this.updateSiteCounter(siteId).then(function () {
                    return value;
                });
            });
        }
        return Promise.resolve(0);
    };
    /**
     * Update total badge counter of the app.
     *
     * @return {Promise<any>}        Promise resolved with the stored badge counter for the site.
     */
    CorePushNotificationsProvider.prototype.updateAppCounter = function () {
        var _this = this;
        return this.sitesProvider.getSitesIds().then(function (sites) {
            var promises = [];
            sites.forEach(function (siteId) {
                promises.push(_this.getAddonBadge(siteId));
            });
            return Promise.all(promises).then(function (counters) {
                var total = counters.reduce(function (previous, counter) {
                    // The app badge counter does not support strings, so parse to int before.
                    return previous + parseInt(counter, 10);
                }, 0);
                if (!_this.appProvider.isDesktop() && !_this.appProvider.isMobile()) {
                    // Browser doesn't have an app badge, stop.
                    return total;
                }
                // Set the app badge.
                return _this.badge.set(total).then(function () {
                    return total;
                });
            });
        });
    };
    /**
     * Update counter for a site using the stored addon data. It will update the total badge application number.
     * It will return the updated site counter.
     *
     * @param  {string} siteId Site ID.
     * @return {Promise<any>}       Promise resolved with the stored badge counter for the site.
     */
    CorePushNotificationsProvider.prototype.updateSiteCounter = function (siteId) {
        var _this = this;
        var addons = this.pushNotificationsDelegate.getCounterHandlers(), promises = [];
        for (var x in addons) {
            promises.push(this.getAddonBadge(siteId, addons[x]));
        }
        return Promise.all(promises).then(function (counters) {
            var plus = false, total = counters.reduce(function (previous, counter) {
                // Check if there is a plus sign at the end of the counter.
                if (counter != parseInt(counter, 10)) {
                    plus = true;
                    counter = parseInt(counter, 10);
                }
                return previous + counter;
            }, 0);
            total = plus && total > 0 ? total + '+' : total;
            // Save the counter on site.
            return _this.saveAddonBadge(total, siteId);
        }).then(function (siteTotal) {
            return _this.updateAppCounter().then(function () {
                return siteTotal;
            });
        });
    };
    /**
     * Register a device in Apple APNS or Google GCM.
     *
     * @return {Promise<any>} Promise resolved when the device is registered.
     */
    CorePushNotificationsProvider.prototype.registerDevice = function () {
        var _this = this;
        try {
            // Check if sound is enabled for notifications.
            return this.getOptions().then(function (options) {
                var pushObject = _this.push.init(options);
                pushObject.on('notification').subscribe(function (notification) {
                    // Execute the callback in the Angular zone, so change detection doesn't stop working.
                    _this.zone.run(function () {
                        _this.logger.log('Received a notification', notification);
                        _this.onMessageReceived(notification);
                    });
                });
                pushObject.on('registration').subscribe(function (data) {
                    // Execute the callback in the Angular zone, so change detection doesn't stop working.
                    _this.zone.run(function () {
                        _this.pushID = data.registrationId;
                        if (_this.sitesProvider.isLoggedIn()) {
                            _this.registerDeviceOnMoodle().catch(function (error) {
                                _this.logger.warn('Can\'t register device', error);
                            });
                        }
                    });
                });
                pushObject.on('error').subscribe(function (error) {
                    // Execute the callback in the Angular zone, so change detection doesn't stop working.
                    _this.zone.run(function () {
                        _this.logger.warn('Error with Push plugin', error);
                    });
                });
            });
        }
        catch (ex) {
            // Ignore errors.
            this.logger.warn(ex);
        }
        return Promise.reject(null);
    };
    /**
     * Registers a device on a Moodle site if needed.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [forceUnregister] Whether to force unregister and register.
     * @return {Promise<any>} Promise resolved when device is registered.
     */
    CorePushNotificationsProvider.prototype.registerDeviceOnMoodle = function (siteId, forceUnregister) {
        var _this = this;
        this.logger.debug('Register device on Moodle.');
        if (!this.canRegisterOnMoodle()) {
            return Promise.reject(null);
        }
        var data = this.getRegisterData();
        var result, site;
        return this.sitesProvider.getSite(siteId).then(function (s) {
            site = s;
            if (forceUnregister) {
                return { unregister: true, register: true };
            }
            else {
                // Check if the device is already registered.
                return _this.shouldRegister(data, site);
            }
        }).then(function (res) {
            result = res;
            if (result.unregister) {
                // Unregister the device first.
                return _this.unregisterDeviceOnMoodle(site).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            if (result.register) {
                // Now register the device.
                return site.write('core_user_add_user_device', _this.utils.clone(data)).then(function (response) {
                    // Insert the device in the local DB.
                    return site.getDb().insertRecord(CorePushNotificationsProvider_1.REGISTERED_DEVICES_TABLE, data)
                        .catch(function (error) {
                        // Ignore errors.
                    });
                });
            }
        }).finally(function () {
            // Remove pending unregisters for this site.
            _this.appDB.deleteRecords(CorePushNotificationsProvider_1.PENDING_UNREGISTER_TABLE, { siteid: site.id }).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Get the addon/site badge counter from the database.
     *
     * @param  {string} siteId   Site ID.
     * @param  {string} [addon='site'] Registered addon name. If not defined it will store the site total.
     * @return {Promise<any>}         Promise resolved with the stored badge counter for the addon or site or 0 if none.
     */
    CorePushNotificationsProvider.prototype.getAddonBadge = function (siteId, addon) {
        if (addon === void 0) { addon = 'site'; }
        return this.appDB.getRecord(CorePushNotificationsProvider_1.BADGE_TABLE, { siteid: siteId, addon: addon }).then(function (entry) {
            return (entry && entry.number) || 0;
        }).catch(function () {
            return 0;
        });
    };
    /**
     * Retry pending unregisters.
     *
     * @param {string} [siteId] If defined, retry only for that site if needed. Otherwise, retry all pending unregisters.
     * @return {Promise<any>} Promise resolved when done.
     */
    CorePushNotificationsProvider.prototype.retryUnregisters = function (siteId) {
        var _this = this;
        var promise;
        if (siteId) {
            // Check if the site has a pending unregister.
            promise = this.appDB.getRecords(CorePushNotificationsProvider_1.PENDING_UNREGISTER_TABLE, { siteid: siteId });
        }
        else {
            // Get all pending unregisters.
            promise = this.appDB.getAllRecords(CorePushNotificationsProvider_1.PENDING_UNREGISTER_TABLE);
        }
        return promise.then(function (results) {
            var promises = [];
            results.forEach(function (result) {
                // Create a temporary site to unregister.
                var tmpSite = _this.sitesFactory.makeSite(result.siteid, result.siteurl, result.token, _this.textUtils.parseJSON(result.info, {}));
                promises.push(_this.unregisterDeviceOnMoodle(tmpSite));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Save the addon/site badgecounter on the database.
     *
     * @param  {number} value   The number to be stored.
     * @param  {string} [siteId] Site ID. If not defined, use current site.
     * @param  {string} [addon='site'] Registered addon name. If not defined it will store the site total.
     * @return {Promise<any>}         Promise resolved with the stored badge counter for the addon or site.
     */
    CorePushNotificationsProvider.prototype.saveAddonBadge = function (value, siteId, addon) {
        if (addon === void 0) { addon = 'site'; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var entry = {
            siteid: siteId,
            addon: addon,
            number: value
        };
        return this.appDB.insertRecord(CorePushNotificationsProvider_1.BADGE_TABLE, entry).then(function () {
            return value;
        });
    };
    /**
     * Check if device should be registered (and unregistered first).
     *
     * @param {CorePushNotificationsRegisterData} data Data of the device.
     * @param {CoreSite} site Site to use.
     * @return {Promise<{register: boolean, unregister: boolean}>} Promise resolved with booleans: whether to register/unregister.
     */
    CorePushNotificationsProvider.prototype.shouldRegister = function (data, site) {
        // Check if the device is already registered.
        return site.getDb().getRecords(CorePushNotificationsProvider_1.REGISTERED_DEVICES_TABLE, {
            appid: data.appid,
            uuid: data.uuid
        }).catch(function () {
            // Ignore errors.
            return [];
        }).then(function (records) {
            var isStored = false, versionOrPushChanged = false;
            records.forEach(function (record) {
                if (record.name == data.name && record.model == data.model && record.platform == data.platform) {
                    if (record.version == data.version && record.pushid == data.pushid) {
                        // The device is already stored.
                        isStored = true;
                    }
                    else {
                        // The version or pushid has changed.
                        versionOrPushChanged = true;
                    }
                }
            });
            if (isStored) {
                // The device has already been registered, no need to register it again.
                return {
                    register: false,
                    unregister: false
                };
            }
            else if (versionOrPushChanged) {
                // This data can be updated by calling register WS, no need to call unregister.
                return {
                    register: true,
                    unregister: false
                };
            }
            else {
                return {
                    register: true,
                    unregister: true
                };
            }
        });
    };
    CorePushNotificationsProvider.COMPONENT = 'CorePushNotificationsProvider';
    // Variables for database. The name still contains the name "addon" for backwards compatibility.
    CorePushNotificationsProvider.BADGE_TABLE = 'addon_pushnotifications_badge';
    CorePushNotificationsProvider.PENDING_UNREGISTER_TABLE = 'addon_pushnotifications_pending_unregister';
    CorePushNotificationsProvider.REGISTERED_DEVICES_TABLE = 'addon_pushnotifications_registered_devices';
    CorePushNotificationsProvider = CorePushNotificationsProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_init__["a" /* CoreInitDelegate */],
            __WEBPACK_IMPORTED_MODULE_11__delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_badge__["a" /* Badge */], __WEBPACK_IMPORTED_MODULE_12__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_14__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__ionic_native_push__["a" /* Push */],
            __WEBPACK_IMPORTED_MODULE_15__providers_config__["a" /* CoreConfigProvider */], __WEBPACK_IMPORTED_MODULE_4__ionic_native_device__["a" /* Device */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"],
            __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_10__providers_sites_factory__["a" /* CoreSitesFactoryProvider */]])
    ], CorePushNotificationsProvider);
    return CorePushNotificationsProvider;
    var CorePushNotificationsProvider_1;
}());

//# sourceMappingURL=pushnotifications.js.map

/***/ }),
/* 87 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreInitDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/*
 * Provider for initialisation mechanisms.
 */
var CoreInitDelegate = /** @class */ (function () {
    function CoreInitDelegate(logger, platform, utils) {
        this.utils = utils;
        this.initProcesses = {};
        this.logger = logger.getInstance('CoreInitDelegate');
    }
    CoreInitDelegate_1 = CoreInitDelegate;
    /**
     * Executes the registered init processes.
     *
     * Reserved for core use, do not call directly.
     */
    CoreInitDelegate.prototype.executeInitProcesses = function () {
        var _this = this;
        var ordered = [];
        if (typeof this.readiness == 'undefined') {
            this.initReadiness();
        }
        // Re-ordering by priority.
        for (var name_1 in this.initProcesses) {
            ordered.push(this.initProcesses[name_1]);
        }
        ordered.sort(function (a, b) {
            return b.priority - a.priority;
        });
        ordered = ordered.map(function (data) {
            return {
                context: _this,
                func: _this.prepareProcess,
                params: [data],
                blocking: !!data.blocking
            };
        });
        // Execute all the processes in order to solve dependencies.
        this.utils.executeOrderedPromises(ordered).finally(this.readiness.resolve);
    };
    /**
     * Init the readiness promise.
     */
    CoreInitDelegate.prototype.initReadiness = function () {
        var _this = this;
        this.readiness = this.utils.promiseDefer();
        this.readiness.promise.then(function () { return _this.readiness.resolved = true; });
    };
    /**
     * Instantly returns if the app is ready.
     *
     * @return {boolean} Whether it's ready.
     */
    CoreInitDelegate.prototype.isReady = function () {
        return this.readiness.resolved;
    };
    /**
     * Convenience function to return a function that executes the process.
     *
     * @param {CoreInitHandler} data The data of the process.
     * @return {Promise<any>} Promise of the process.
     */
    CoreInitDelegate.prototype.prepareProcess = function (data) {
        var promise;
        this.logger.debug("Executing init process '" + data.name + "'");
        try {
            promise = data.load();
        }
        catch (e) {
            this.logger.error('Error while calling the init process \'' + data.name + '\'. ' + e);
            return;
        }
        return promise;
    };
    /**
     * Notifies when the app is ready. This returns a promise that is resolved when the app is initialised.
     *
     * @return {Promise<any>} Resolved when the app is initialised. Never rejected.
     */
    CoreInitDelegate.prototype.ready = function () {
        if (typeof this.readiness === 'undefined') {
            // Prevent race conditions if this is called before executeInitProcesses.
            this.initReadiness();
        }
        return this.readiness.promise;
    };
    /**
     * Registers an initialisation process.
     *
     * @description
     * Init processes can be used to add initialisation logic to the app. Anything that should block the user interface while
     * some processes are done should be an init process. It is recommended to use a priority lower than MAX_RECOMMENDED_PRIORITY
     * to make sure that your process does not happen before some essential other core processes.
     *
     * An init process should never change state or prompt user interaction.
     *
     * This delegate cannot be used by site plugins.
     *
     * @param {CoreInitHandler} instance The instance of the handler.
     */
    CoreInitDelegate.prototype.registerProcess = function (handler) {
        if (typeof handler.priority == 'undefined') {
            handler.priority = CoreInitDelegate_1.DEFAULT_PRIORITY;
        }
        if (typeof this.initProcesses[handler.name] != 'undefined') {
            this.logger.log("Process '" + handler.name + "' already registered.");
            return;
        }
        this.logger.log("Registering process '" + handler.name + "'.");
        this.initProcesses[handler.name] = handler;
    };
    CoreInitDelegate.DEFAULT_PRIORITY = 100; // Default priority for init processes.
    CoreInitDelegate.MAX_RECOMMENDED_PRIORITY = 600;
    CoreInitDelegate = CoreInitDelegate_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_3__utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreInitDelegate);
    return CoreInitDelegate;
    var CoreInitDelegate_1;
}());

//# sourceMappingURL=init.js.map

/***/ }),
/* 88 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBlockDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__default_block_handler__ = __webpack_require__(776);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_siteplugins_providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Delegate to register block handlers.
 */
var CoreBlockDelegate = /** @class */ (function (_super) {
    __extends(CoreBlockDelegate, _super);
    function CoreBlockDelegate(logger, sitesProvider, eventsProvider, defaultHandler, sitePluginsProvider) {
        var _this = _super.call(this, 'CoreBlockDelegate', logger, sitesProvider, eventsProvider) || this;
        _this.defaultHandler = defaultHandler;
        _this.sitePluginsProvider = sitePluginsProvider;
        _this.handlerNameProperty = 'blockName';
        _this.featurePrefix = 'CoreBlockDelegate_';
        _this.blocksUpdateObservable = new __WEBPACK_IMPORTED_MODULE_7_rxjs__["Subject"]();
        return _this;
    }
    /**
     * Check if blocks are disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreBlockDelegate.prototype.areBlocksDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('NoDelegate_SiteBlocks');
    };
    /**
     * Check if blocks are disabled in a certain site.
     *
     * @param  {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>}     Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreBlockDelegate.prototype.areBlocksDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.areBlocksDisabledInSite(site);
        });
    };
    /**
     * Get the display data for a certain block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {Promise<CoreBlockHandlerData>} Promise resolved with the display data.
     */
    CoreBlockDelegate.prototype.getBlockDisplayData = function (injector, block, contextLevel, instanceId) {
        return Promise.resolve(this.executeFunctionOnEnabled(block.name, 'getDisplayData', [injector, block]));
    };
    /**
     * Check if any of the blocks in a list is supported.
     *
     * @param {any[]} blocks The list of blocks.
     * @return {boolean} Whether any of the blocks is supported.
     */
    CoreBlockDelegate.prototype.hasSupportedBlock = function (blocks) {
        var _this = this;
        blocks = blocks || [];
        return !!blocks.find(function (block) { return _this.isBlockSupported(block.name); });
    };
    /**
     * Check if a block is supported.
     *
     * @param {string} name Block "name". E.g. 'activity_modules'.
     * @return {boolean} Whether it's supported.
     */
    CoreBlockDelegate.prototype.isBlockSupported = function (name) {
        return this.hasHandler(name, true);
    };
    /**
     * Check if feature is enabled or disabled in the site, depending on the feature prefix and the handler name.
     *
     * @param  {CoreDelegateHandler} handler Handler to check.
     * @param  {CoreSite} site Site to check.
     * @return {boolean} Whether is enabled or disabled in site.
     */
    CoreBlockDelegate.prototype.isFeatureDisabled = function (handler, site) {
        return this.areBlocksDisabledInSite(site) || _super.prototype.isFeatureDisabled.call(this, handler, site);
    };
    /**
     * Called when there are new block handlers available. Informs anyone who subscribed to the
     * observable.
     */
    CoreBlockDelegate.prototype.updateData = function () {
        this.blocksUpdateObservable.next();
    };
    CoreBlockDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__default_block_handler__["a" /* CoreBlockDefaultHandler */], __WEBPACK_IMPORTED_MODULE_6__core_siteplugins_providers_siteplugins__["a" /* CoreSitePluginsProvider */]])
    ], CoreBlockDelegate);
    return CoreBlockDelegate;
}(__WEBPACK_IMPORTED_MODULE_4__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 89 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSyncBaseProvider; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base class to create sync providers. It provides some common functions.
 */
var CoreSyncBaseProvider = /** @class */ (function () {
    function CoreSyncBaseProvider(component, loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) {
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.syncProvider = syncProvider;
        this.textUtils = textUtils;
        this.translate = translate;
        this.timeUtils = timeUtils;
        /**
         * Component of the sync provider.
         * @type {string}
         */
        this.component = 'core';
        /**
         * Sync provider's interval.
         * @type {number}
         */
        this.syncInterval = 300000;
        // Store sync promises.
        this.syncPromises = {};
        this.logger = loggerProvider.getInstance(component);
        this.component = component;
    }
    /**
     * Add an ongoing sync to the syncPromises list. On finish the promise will be removed.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {Promise<any>} promise The promise of the sync to add.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} The sync promise.
     */
    CoreSyncBaseProvider.prototype.addOngoingSync = function (id, promise, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var uniqueId = this.getUniqueSyncId(id);
        if (!this.syncPromises[siteId]) {
            this.syncPromises[siteId] = {};
        }
        this.syncPromises[siteId][uniqueId] = promise;
        // Promise will be deleted when finish.
        return promise.finally(function () {
            delete _this.syncPromises[siteId][uniqueId];
        });
    };
    /**
     * If there's an ongoing sync for a certain identifier return it.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise of the current sync or undefined if there isn't any.
     */
    CoreSyncBaseProvider.prototype.getOngoingSync = function (id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.isSyncing(id, siteId)) {
            // There's already a sync ongoing for this discussion, return the promise.
            var uniqueId = this.getUniqueSyncId(id);
            return this.syncPromises[siteId][uniqueId];
        }
    };
    /**
     * Get the synchronization time in a human readable format.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the readable time.
     */
    CoreSyncBaseProvider.prototype.getReadableSyncTime = function (id, siteId) {
        var _this = this;
        return this.getSyncTime(id, siteId).then(function (time) {
            return _this.getReadableTimeFromTimestamp(time);
        });
    };
    /**
     * Given a timestamp return it in a human readable format.
     *
     * @param {number} timestamp Timestamp
     * @return {string} Human readable time.
     */
    CoreSyncBaseProvider.prototype.getReadableTimeFromTimestamp = function (timestamp) {
        if (!timestamp) {
            return this.translate.instant('core.never');
        }
        else {
            return this.timeUtils.userDate(timestamp);
        }
    };
    /**
     * Get the synchronization time. Returns 0 if no time stored.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the time.
     */
    CoreSyncBaseProvider.prototype.getSyncTime = function (id, siteId) {
        return this.syncProvider.getSyncRecord(this.component, id, siteId).then(function (entry) {
            return entry.time;
        }).catch(function () {
            return 0;
        });
    };
    /**
     * Get the synchronization warnings of an instance.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string[]>} Promise resolved with the warnings.
     */
    CoreSyncBaseProvider.prototype.getSyncWarnings = function (id, siteId) {
        var _this = this;
        return this.syncProvider.getSyncRecord(this.component, id, siteId).then(function (entry) {
            return _this.textUtils.parseJSON(entry.warnings, []);
        }).catch(function () {
            return [];
        });
    };
    /**
     * Create a unique identifier from component and id.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @return {string} Unique identifier from component and id.
     */
    CoreSyncBaseProvider.prototype.getUniqueSyncId = function (id) {
        return this.component + '#' + id;
    };
    /**
     * Check if a there's an ongoing syncronization for the given id.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean} Whether it's synchronizing.
     */
    CoreSyncBaseProvider.prototype.isSyncing = function (id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var uniqueId = this.getUniqueSyncId(id);
        return !!(this.syncPromises[siteId] && this.syncPromises[siteId][uniqueId]);
    };
    /**
     * Check if a sync is needed: if a certain time has passed since the last time.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether sync is needed.
     */
    CoreSyncBaseProvider.prototype.isSyncNeeded = function (id, siteId) {
        var _this = this;
        return this.getSyncTime(id, siteId).then(function (time) {
            return Date.now() - _this.syncInterval >= time;
        });
    };
    /**
     * Set the synchronization time.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [time] Time to set. If not defined, current time.
     * @return {Promise<any>} Promise resolved when the time is set.
     */
    CoreSyncBaseProvider.prototype.setSyncTime = function (id, siteId, time) {
        time = typeof time != 'undefined' ? time : Date.now();
        return this.syncProvider.insertOrUpdateSyncRecord(this.component, id, { time: time }, siteId);
    };
    /**
     * Set the synchronization warnings.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string[]} warnings Warnings to set.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSyncBaseProvider.prototype.setSyncWarnings = function (id, warnings, siteId) {
        var warningsText = JSON.stringify(warnings || []);
        return this.syncProvider.insertOrUpdateSyncRecord(this.component, id, { warnings: warningsText }, siteId);
    };
    /**
     * Execute a sync function on selected sites.
     *
     * @param  {string} syncFunctionLog Log message to explain the sync function purpose.
     * @param  {Function} syncFunction  Sync function to execute.
     * @param  {any[]}    [params]      Array that defines the params that admit the funcion.
     * @param  {string} [siteId]        Site ID to sync. If not defined, sync all sites.
     * @return {Promise<any>}           Resolved with siteIds selected. Rejected if offline.
     */
    CoreSyncBaseProvider.prototype.syncOnSites = function (syncFunctionLog, syncFunction, params, siteId) {
        if (!this.appProvider.isOnline()) {
            this.logger.debug("Cannot sync '" + syncFunctionLog + "' because device is offline.");
            return Promise.reject(null);
        }
        var promise;
        if (!siteId) {
            // No site ID defined, sync all sites.
            this.logger.debug("Try to sync '" + syncFunctionLog + "' in all sites.");
            promise = this.sitesProvider.getLoggedInSitesIds();
        }
        else {
            this.logger.debug("Try to sync '" + syncFunctionLog + "' in site '" + siteId + "'.");
            promise = Promise.resolve([siteId]);
        }
        params = params || [];
        return promise.then(function (siteIds) {
            var sitePromises = [];
            siteIds.forEach(function (siteId) {
                // Execute function for every site selected.
                sitePromises.push(syncFunction.apply(syncFunction, [siteId].concat(params)));
            });
            return Promise.all(sitePromises);
        });
    };
    /**
     * If there's an ongoing sync for a certain identifier, wait for it to end.
     * If there's no sync ongoing the promise will be resolved right away.
     *
     * @param {string | number} id Unique sync identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when there's no sync going on for the identifier.
     */
    CoreSyncBaseProvider.prototype.waitForSync = function (id, siteId) {
        var promise = this.getOngoingSync(id, siteId);
        if (promise) {
            return promise.catch(function () {
                // Ignore errors.
            });
        }
        return Promise.resolve();
    };
    return CoreSyncBaseProvider;
}());

//# sourceMappingURL=base-sync.js.map

/***/ }),
/* 90 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export AppGlobal */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucrestProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_angular_oauth2_oidc__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_storage__ = __webpack_require__(131);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_ouclogin_ouclogin__ = __webpack_require__(411);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/*
 * @Description: In User Settings Edit
 * @Author: your name
 * @Date: 2019-07-25 16:55:17
 * @LastEditTime: 2019-11-04 09:35:33
 * @LastEditors: Please set LastEditors
 */







var AppGlobal = /** @class */ (function () {
    function AppGlobal() {
    }
    //缓存key的配置
    AppGlobal.cache = {
        slides: "_dress_slides",
        categories: "_dress_categories",
        products: "_dress_products"
    };
    //接口基地址
    AppGlobal.domain = "https://tlimama.tongedev.cn";
    //接口地址
    AppGlobal.API = {
        getCategories: '/api/ionic3/getCategories',
        getProducts: '/api/ionic3/getProducts',
        getDetails: '/api/ionic3/details'
    };
    AppGlobal = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AppGlobal);
    return AppGlobal;
}());

/*
  Generated class for the OucrestProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var OucrestProvider = /** @class */ (function () {
    function OucrestProvider(http, loadingCtrl, alertCtrl, toastCtrl, oauthService, httpOptions, storage, oucloginProvider, events) {
        this.http = http;
        this.loadingCtrl = loadingCtrl;
        this.alertCtrl = alertCtrl;
        this.toastCtrl = toastCtrl;
        this.oauthService = oauthService;
        this.httpOptions = httpOptions;
        this.storage = storage;
        this.oucloginProvider = oucloginProvider;
        this.events = events;
    }
    OucrestProvider.prototype.myEncode = function (params) {
        var str = '';
        if (params) {
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    var value = params[key];
                    str += encodeURIComponent(key) + '=' + encodeURIComponent(value) + '&';
                }
            }
            str = '&' + str.substring(0, str.length - 1);
        }
        return str;
    };
    // get对参数进行编码
    OucrestProvider.prototype.encode = function (params) {
        var str = '';
        if (params) {
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    var value = params[key];
                    str += encodeURIComponent(key) + '=' + encodeURIComponent(value) + '&';
                }
            }
            str = '?' + str.substring(0, str.length - 1);
        }
        return str;
    };
    // Post对参数进行编码
    OucrestProvider.prototype.encodeForPost = function (params) {
        var str = '';
        if (params) {
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    var value = params[key];
                    str += encodeURIComponent(key) + '=' + encodeURIComponent(value) + '&';
                }
            }
            str = str.substring(0, str.length - 1);
        }
        return str;
    };
    OucrestProvider.prototype.httpGet = function (accessToken, url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["a" /* Headers */]({
            'Content-Type': 'application/x-www-form-urlencoded',
            'Authorization': 'Bearer ' + accessToken,
        });
        var options = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create({});
        if (loader) {
            loading.present();
        }
        this.http.get(url + this.encode(params), options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        })
            .catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            // this.alert(error);
            _this.handleError(error);
            _this.doRefreshToken();
        });
    };
    OucrestProvider.prototype.httpPost = function (accessToken, url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["a" /* Headers */]({
            'Content-Type': 'application/json;charset=UTF-8',
            'Authorization': 'Bearer ' + accessToken,
        });
        var options = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create();
        if (loader) {
            loading.present();
        }
        this.http.post(url, this.encodeForPost(params), options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        }).catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
            _this.doRefreshToken();
        });
    };
    OucrestProvider.prototype.httpOucGet = function (url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var loading = this.loadingCtrl.create({});
        if (loader) {
            loading.present();
        }
        this.http.get(url + this.encode(params))
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        })
            .catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
        });
    };
    OucrestProvider.prototype.httpOucPost = function (url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["a" /* Headers */]({
            'Content-Type': 'application/x-www-form-urlencoded',
        });
        var options = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create();
        if (loader) {
            loading.present();
        }
        this.http.post(url, this.encodeForPost(params), options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        }).catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
        });
    };
    OucrestProvider.prototype.httpPatch = function (url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["a" /* Headers */]({
            'Content-Type': 'application/json;charset=UTF-8',
            'Authorization': 'Bearer ' + this.oauthService.getAccessToken(),
        });
        var options = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create();
        if (loader) {
            loading.present();
        }
        this.http.patch(url, params, options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        }).catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
        });
    };
    OucrestProvider.prototype.handleError = function (error) {
        var msg = '';
        if (error.status == 400) {
            msg = '请求无效(code：404)';
            console.log('请检查参数类型是否匹配');
        }
        if (error.status == 404) {
            msg = '请求资源不存在(code：404)';
            console.error(msg + '，请检查路径是否正确');
        }
        if (error.status == 500) {
            msg = '服务器发生错误(code：500)';
            console.error(msg + '，请检查路径是否正确');
        }
        console.log(error);
        if (msg != '') {
            this.toast(msg);
        }
    };
    OucrestProvider.prototype.alert = function (message, callback) {
        if (callback) {
            var alert_1 = this.alertCtrl.create({
                title: '提示',
                message: message,
                buttons: [{
                        text: "确定",
                        handler: function (data) {
                            callback();
                        }
                    }]
            });
            alert_1.present();
        }
        else {
            var alert_2 = this.alertCtrl.create({
                title: '提示',
                message: message,
                buttons: ["确定"]
            });
            alert_2.present();
        }
    };
    OucrestProvider.prototype.toast = function (message, callback) {
        var toast = this.toastCtrl.create({
            message: message,
            duration: 2000,
            dismissOnPageChange: true,
        });
        toast.present();
        if (callback) {
            callback();
        }
    };
    OucrestProvider.prototype.setItem = function (key, obj) {
        try {
            var json = JSON.stringify(obj);
            window.localStorage[key] = json;
        }
        catch (e) {
            console.error("window.localStorage error:" + e);
        }
    };
    OucrestProvider.prototype.getItem = function (key, callback) {
        try {
            var json = window.localStorage[key];
            var obj = JSON.parse(json);
            callback(obj);
        }
        catch (e) {
            console.error("window.localStorage error:" + e);
        }
    };
    OucrestProvider.prototype.httpMyPost = function (accessToken, url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["a" /* Headers */]({
            'Content-Type': 'application/json-patch+json',
            'Authorization': 'Bearer ' + accessToken,
        });
        var options = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create();
        if (loader) {
            loading.present();
        }
        this.http.post(url, params, options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        }).catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
            _this.doRefreshToken();
        });
    };
    OucrestProvider.prototype.httpMyGet = function (url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["a" /* Headers */]({
            'Content-Type': ' application/json; charset=utf-8 ',
        });
        var options = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create({});
        if (loader) {
            loading.present();
        }
        this.http.get(url + this.encode(params), options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        })
            .catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
        });
    };
    OucrestProvider.prototype.doRefreshToken = function () {
        var _this = this;
        this.storage.get('refreshOucAccessToken').then(function (value) {
            if (value != null) {
                var param = {
                    client_secret: 'QU9cZkL.>/n4ZE@sHj7U&zPyuzN68^]zp3BqRg#MdDFN7Yr%9jT3?hFJCsfucWJ7',
                    grant_type: 'refresh_token',
                    scope: 'openid profile ouchnuser ouchnstudentspaceapi ouchnteacherspaceapi ouchnappcloudapi offline_access ouconlineappapi',
                    client_id: 'OUCOnlineAPP',
                    refresh_token: value,
                };
                _this.httpRefreshOucPost('http://passport.ouchn.cn/connect/token', param, function (d) {
                    _this.storage.set('oucAccessToken', d.access_token);
                    _this.storage.set('refreshOucAccessToken', d.refresh_token);
                    _this.events.publish('reLogin', 'reLogin');
                }, false);
            }
            else {
                _this.oucloginProvider.redirectLogin().then(function (success) {
                    _this.events.publish('reLogin', 'reLogin');
                }, function (error) {
                });
            }
        });
    };
    OucrestProvider.prototype.httpRefreshOucPost = function (url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["a" /* Headers */]({
            'Content-Type': 'application/x-www-form-urlencoded',
        });
        var options = new __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create();
        if (loader) {
            loading.present();
        }
        this.http.post(url, this.encodeForPost(params), options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        }).catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
            _this.storage.set('oucAccessToken', null);
            _this.storage.set('refreshOucAccessToken', null);
            _this.oucloginProvider.redirectLogin().then(function (success) {
                _this.events.publish('reLogin', 'reLogin');
            }, function (error) {
            });
        });
    };
    OucrestProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_http__["b" /* Http */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["o" /* LoadingController */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["b" /* AlertController */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["E" /* ToastController */],
            __WEBPACK_IMPORTED_MODULE_3_angular_oauth2_oidc__["b" /* OAuthService */], __WEBPACK_IMPORTED_MODULE_1__angular_http__["d" /* RequestOptions */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_storage__["b" /* Storage */], __WEBPACK_IMPORTED_MODULE_5__providers_ouclogin_ouclogin__["a" /* OucloginProvider */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["i" /* Events */]])
    ], OucrestProvider);
    return OucrestProvider;
}());

//# sourceMappingURL=oucrest.js.map

/***/ }),
/* 91 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__messages_offline__ = __webpack_require__(282);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_emulator_providers_helper__ = __webpack_require__(211);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Service to handle messages.
 */
var AddonMessagesProvider = /** @class */ (function () {
    function AddonMessagesProvider(logger, sitesProvider, appProvider, userProvider, messagesOffline, utils, timeUtils, emulatorHelper, eventsProvider) {
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.userProvider = userProvider;
        this.messagesOffline = messagesOffline;
        this.utils = utils;
        this.timeUtils = timeUtils;
        this.emulatorHelper = emulatorHelper;
        this.eventsProvider = eventsProvider;
        this.ROOT_CACHE_KEY = 'mmaMessages:';
        this.LIMIT_MESSAGES = AddonMessagesProvider_1.LIMIT_MESSAGES;
        this.logger = logger.getInstance('AddonMessagesProvider');
    }
    AddonMessagesProvider_1 = AddonMessagesProvider;
    /**
     * Add a contact.
     *
     * @param {number} userId  User ID of the person to add.
     * @param {string} [siteId]  Site ID. If not defined, use current site.
     * @return {Promise<any>}  Resolved when done.
     * @deprecated since Moodle 3.6
     */
    AddonMessagesProvider.prototype.addContact = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                userids: [userId]
            };
            return site.write('core_message_create_contacts', params).then(function () {
                return _this.invalidateAllContactsCache(site.getUserId(), site.getId());
            });
        });
    };
    /**
     * Block a user.
     *
     * @param {number} userId User ID of the person to block.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.blockContact = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promise;
            if (site.wsAvailable('core_message_block_user')) {
                // Since Moodle 3.6
                var params = {
                    userid: site.getUserId(),
                    blockeduserid: userId,
                };
                promise = site.write('core_message_block_user', params);
            }
            else {
                var params = {
                    userids: [userId]
                };
                promise = site.write('core_message_block_contacts', params);
            }
            return promise.then(function () {
                return _this.invalidateAllMemberInfo(userId, site).finally(function () {
                    var data = { userId: userId, userBlocked: true };
                    _this.eventsProvider.trigger(AddonMessagesProvider_1.MEMBER_INFO_CHANGED_EVENT, data, site.id);
                });
            });
        });
    };
    /**
     * Confirm a contact request from another user.
     *
     * @param {number} userId ID of the user who made the contact request.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved when done.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.confirmContactRequest = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                userid: userId,
                requesteduserid: site.getUserId(),
            };
            return site.write('core_message_confirm_contact_request', params).then(function () {
                return _this.utils.allPromises([
                    _this.invalidateAllMemberInfo(userId, site),
                    _this.invalidateContactsCache(site.id),
                    _this.invalidateUserContacts(site.id),
                    _this.refreshContactRequestsCount(site.id),
                ]).finally(function () {
                    var data = { userId: userId, contactRequestConfirmed: true };
                    _this.eventsProvider.trigger(AddonMessagesProvider_1.MEMBER_INFO_CHANGED_EVENT, data, site.id);
                });
            });
        });
    };
    /**
     * Send a contact request to another user.
     *
     * @param {number} userId ID of the receiver of the contact request.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved when done.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.createContactRequest = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                userid: site.getUserId(),
                requesteduserid: userId,
            };
            return site.write('core_message_create_contact_request', params).then(function () {
                return _this.invalidateAllMemberInfo(userId, site).finally(function () {
                    var data = { userId: userId, contactRequestCreated: true };
                    _this.eventsProvider.trigger(AddonMessagesProvider_1.MEMBER_INFO_CHANGED_EVENT, data, site.id);
                });
            });
        });
    };
    /**
     * Decline a contact request from another user.
     *
     * @param {number} userId ID of the user who made the contact request.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved when done.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.declineContactRequest = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                userid: userId,
                requesteduserid: site.getUserId(),
            };
            return site.write('core_message_decline_contact_request', params).then(function () {
                return _this.utils.allPromises([
                    _this.invalidateAllMemberInfo(userId, site),
                    _this.refreshContactRequestsCount(site.id),
                ]).finally(function () {
                    var data = { userId: userId, contactRequestDeclined: true };
                    _this.eventsProvider.trigger(AddonMessagesProvider_1.MEMBER_INFO_CHANGED_EVENT, data, site.id);
                });
            });
        });
    };
    /**
     * Delete a conversation.
     *
     * @param {number} conversationId Conversation to delete.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Promise resolved when the conversation has been deleted.
     */
    AddonMessagesProvider.prototype.deleteConversation = function (conversationId, siteId, userId) {
        return this.deleteConversations([conversationId], siteId, userId);
    };
    /**
     * Delete several conversations.
     *
     * @param {number[]} conversationIds Conversations to delete.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Promise resolved when the conversations have been deleted.
     */
    AddonMessagesProvider.prototype.deleteConversations = function (conversationIds, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                userid: userId,
                conversationids: conversationIds
            };
            return site.write('core_message_delete_conversations_by_id', params).then(function () {
                var promises = [];
                conversationIds.forEach(function (conversationId) {
                    promises.push(_this.messagesOffline.deleteConversationMessages(conversationId, site.getId()).catch(function () {
                        // Ignore errors (shouldn't happen).
                    }));
                });
                return Promise.all(promises);
            });
        });
    };
    /**
     * Delete a message (online or offline).
     *
     * @param {any} message    Message to delete.
     * @param {boolean} [deleteForAll] Whether the message should be deleted for all users.
     * @return {Promise<any>}  Promise resolved when the message has been deleted.
     */
    AddonMessagesProvider.prototype.deleteMessage = function (message, deleteForAll) {
        if (message.id) {
            // Message has ID, it means it has been sent to the server.
            if (deleteForAll) {
                return this.deleteMessageForAllOnline(message.id);
            }
            else {
                return this.deleteMessageOnline(message.id, message.read);
            }
        }
        // It's an offline message.
        if (message.conversationid) {
            return this.messagesOffline.deleteConversationMessage(message.conversationid, message.text, message.timecreated);
        }
        else {
            return this.messagesOffline.deleteMessage(message.touserid, message.smallmessage, message.timecreated);
        }
    };
    /**
     * Delete a message from the server.
     *
     * @param {number} id       Message ID.
     * @param {number} read     1 if message is read, 0 otherwise.
     * @param {number} [userId] User we want to delete the message for. If not defined, use current user.
     * @return {Promise<any>}   Promise resolved when the message has been deleted.
     */
    AddonMessagesProvider.prototype.deleteMessageOnline = function (id, read, userId) {
        var _this = this;
        var params = {
            messageid: id,
            userid: userId || this.sitesProvider.getCurrentSiteUserId()
        };
        if (typeof read != 'undefined') {
            params.read = read;
        }
        return this.sitesProvider.getCurrentSite().write('core_message_delete_message', params).then(function () {
            return _this.invalidateDiscussionCache(userId);
        });
    };
    /**
     * Delete a message for all users.
     *
     * @param {number} id Message ID.
     * @param {number} [userId] User we want to delete the message for. If not defined, use current user.
     * @return {Promise<any>} Promise resolved when the message has been deleted.
     */
    AddonMessagesProvider.prototype.deleteMessageForAllOnline = function (id, userId) {
        var _this = this;
        var params = {
            messageid: id,
            userid: userId || this.sitesProvider.getCurrentSiteUserId()
        };
        return this.sitesProvider.getCurrentSite().write('core_message_delete_message_for_all_users', params).then(function () {
            return _this.invalidateDiscussionCache(userId);
        });
    };
    /**
     * Format a conversation.
     *
     * @param {any} conversation Conversation to format.
     * @param {number} userId User ID viewing the conversation.
     * @return {any} Formatted conversation.
     */
    AddonMessagesProvider.prototype.formatConversation = function (conversation, userId) {
        var numMessages = conversation.messages.length, lastMessage = numMessages ? conversation.messages[numMessages - 1] : null;
        conversation.lastmessage = lastMessage ? lastMessage.text : null;
        conversation.lastmessagedate = lastMessage ? lastMessage.timecreated : null;
        conversation.sentfromcurrentuser = lastMessage ? lastMessage.useridfrom == userId : null;
        if (conversation.type != AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_GROUP) {
            var isIndividual_1 = conversation.type == AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_INDIVIDUAL, otherUser = conversation.members.reduce(function (carry, member) {
                if (!carry && ((isIndividual_1 && member.id != userId) || (!isIndividual_1 && member.id == userId))) {
                    carry = member;
                }
                return carry;
            }, null);
            conversation.name = conversation.name ? conversation.name : otherUser.fullname;
            conversation.imageurl = conversation.imageurl ? conversation.imageurl : otherUser.profileimageurl;
            conversation.userid = otherUser.id;
            conversation.showonlinestatus = otherUser.showonlinestatus;
            conversation.isonline = otherUser.isonline;
            conversation.isblocked = otherUser.isblocked;
            conversation.otherUser = otherUser;
        }
        return conversation;
    };
    /**
     * Get the cache key for blocked contacts.
     *
     * @param {number} userId The user who's contacts we're looking for.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForBlockedContacts = function (userId) {
        return this.ROOT_CACHE_KEY + 'blockedContacts:' + userId;
    };
    /**
     * Get the cache key for contacts.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForContacts = function () {
        return this.ROOT_CACHE_KEY + 'contacts';
    };
    /**
     * Get the cache key for comfirmed contacts.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForUserContacts = function () {
        return this.ROOT_CACHE_KEY + 'userContacts';
    };
    /**
     * Get the cache key for contact requests.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForContactRequests = function () {
        return this.ROOT_CACHE_KEY + 'contactRequests';
    };
    /**
     * Get the cache key for contact requests count.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForContactRequestsCount = function () {
        return this.ROOT_CACHE_KEY + 'contactRequestsCount';
    };
    /**
     * Get the cache key for a discussion.
     *
     * @param {number} userId The other person with whom the current user is having the discussion.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForDiscussion = function (userId) {
        return this.ROOT_CACHE_KEY + 'discussion:' + userId;
    };
    /**
     * Get the cache key for the message count.
     *
     * @param {number} userId  User ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForMessageCount = function (userId) {
        return this.ROOT_CACHE_KEY + 'count:' + userId;
    };
    /**
     * Get the cache key for unread conversation counts.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForUnreadConversationCounts = function () {
        return this.ROOT_CACHE_KEY + 'unreadConversationCounts';
    };
    /**
     * Get the cache key for the list of discussions.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForDiscussions = function () {
        return this.ROOT_CACHE_KEY + 'discussions';
    };
    /**
     * Get cache key for get conversations.
     *
     * @param {number} userId User ID.
     * @param {number} conversationId Conversation ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForConversation = function (userId, conversationId) {
        return this.ROOT_CACHE_KEY + 'conversation:' + userId + ':' + conversationId;
    };
    /**
     * Get cache key for get conversations between users.
     *
     * @param {number} userId User ID.
     * @param {number} otherUserId Other user ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForConversationBetweenUsers = function (userId, otherUserId) {
        return this.ROOT_CACHE_KEY + 'conversationBetweenUsers:' + userId + ':' + otherUserId;
    };
    /**
     * Get cache key for get conversation members.
     *
     * @param {number} userId User ID.
     * @param {number} conversationId Conversation ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForConversationMembers = function (userId, conversationId) {
        return this.ROOT_CACHE_KEY + 'conversationMembers:' + userId + ':' + conversationId;
    };
    /**
     * Get cache key for get conversation messages.
     *
     * @param {number} userId User ID.
     * @param {number} conversationId Conversation ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForConversationMessages = function (userId, conversationId) {
        return this.ROOT_CACHE_KEY + 'conversationMessages:' + userId + ':' + conversationId;
    };
    /**
     * Get cache key for get conversations.
     *
     * @param {number} userId User ID.
     * @param {number} [type] Filter by type.
     * @param {boolean} [favourites] Filter favourites.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForConversations = function (userId, type, favourites) {
        return this.getCommonCacheKeyForUserConversations(userId) + ':' + type + ':' + favourites;
    };
    /**
     * Get cache key for conversation counts.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForConversationCounts = function () {
        return this.ROOT_CACHE_KEY + 'conversationCounts';
    };
    /**
     * Get cache key for member info.
     *
     * @param {number} userId User ID.
     * @param {number} otherUserId The other user ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForMemberInfo = function (userId, otherUserId) {
        return this.ROOT_CACHE_KEY + 'memberInfo:' + userId + ':' + otherUserId;
    };
    /**
     * Get cache key for get self conversation.
     *
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCacheKeyForSelfConversation = function (userId) {
        return this.ROOT_CACHE_KEY + 'selfconversation:' + userId;
    };
    /**
     * Get common cache key for get user conversations.
     *
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getCommonCacheKeyForUserConversations = function (userId) {
        return this.getRootCacheKeyForConversations() + userId;
    };
    /**
     * Get root cache key for get conversations.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getRootCacheKeyForConversations = function () {
        return this.ROOT_CACHE_KEY + 'conversations:';
    };
    /**
     * Get all the contacts of the current user.
     *
     * @param  {string} [siteId]  Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved with the WS data.
     * @deprecated since Moodle 3.6
     */
    AddonMessagesProvider.prototype.getAllContacts = function (siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getContacts(siteId).then(function (contacts) {
            return _this.getBlockedContacts(siteId).then(function (blocked) {
                contacts.blocked = blocked.users;
                _this.storeUsersFromAllContacts(contacts);
                return contacts;
            }).catch(function () {
                // The WS for blocked contacts might fail, but we still want the contacts.
                contacts.blocked = [];
                _this.storeUsersFromAllContacts(contacts);
                return contacts;
            });
        });
    };
    /**
     * Get all the users blocked by the current user.
     *
     * @param  {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved with the WS data.
     */
    AddonMessagesProvider.prototype.getBlockedContacts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var userId = site.getUserId(), params = {
                userid: userId
            }, preSets = {
                cacheKey: _this.getCacheKeyForBlockedContacts(userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            return site.read('core_message_get_blocked_users', params, preSets);
        });
    };
    /**
     * Get the contacts of the current user.
     *
     * This excludes the blocked users.
     *
     * @param  {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved with the WS data.
     * @deprecated since Moodle 3.6
     */
    AddonMessagesProvider.prototype.getContacts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getCacheKeyForContacts(),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            return site.read('core_message_get_contacts', undefined, preSets).then(function (contacts) {
                // Filter contacts with negative ID, they are notifications.
                var validContacts = {};
                var _loop_1 = function (typeName) {
                    if (!validContacts[typeName]) {
                        validContacts[typeName] = [];
                    }
                    contacts[typeName].forEach(function (contact) {
                        if (contact.id > 0) {
                            validContacts[typeName].push(contact);
                        }
                    });
                };
                for (var typeName in contacts) {
                    _loop_1(typeName);
                }
                return validContacts;
            });
        });
    };
    /**
     * Get the list of user contacts.
     *
     * @param {number} [limitFrom=0] Position of the first contact to fetch.
     * @param {number} [limitNum] Number of contacts to fetch. Default is AddonMessagesProvider.LIMIT_CONTACTS.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{contacts: any[], canLoadMore: boolean}>} Resolved with the list of user contacts.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getUserContacts = function (limitFrom, limitNum, siteId) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNum === void 0) { limitNum = AddonMessagesProvider_1.LIMIT_CONTACTS; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                userid: site.getUserId(),
                limitfrom: limitFrom,
                limitnum: limitNum <= 0 ? 0 : limitNum + 1
            };
            var preSets = {
                cacheKey: _this.getCacheKeyForUserContacts(),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            return site.read('core_message_get_user_contacts', params, preSets).then(function (contacts) {
                if (!contacts || !contacts.length) {
                    return { contacts: [], canLoadMore: false };
                }
                _this.userProvider.storeUsers(contacts, site.id);
                if (limitNum <= 0) {
                    return { contacts: contacts, canLoadMore: false };
                }
                return {
                    contacts: contacts.slice(0, limitNum),
                    canLoadMore: contacts.length > limitNum
                };
            });
        });
    };
    /**
     * Get the contact request sent to the current user.
     *
     * @param {number} [limitFrom=0] Position of the first contact request to fetch.
     * @param {number} [limitNum] Number of contact requests to fetch. Default is AddonMessagesProvider.LIMIT_CONTACTS.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{requests: any[], canLoadMore: boolean}>} Resolved with the list of contact requests.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getContactRequests = function (limitFrom, limitNum, siteId) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNum === void 0) { limitNum = AddonMessagesProvider_1.LIMIT_CONTACTS; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                userid: site.getUserId(),
                limitfrom: limitFrom,
                limitnum: limitNum <= 0 ? 0 : limitNum + 1
            };
            var preSets = {
                cacheKey: _this.getCacheKeyForContactRequests(),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            return site.read('core_message_get_contact_requests', data, preSets).then(function (requests) {
                if (!requests || !requests.length) {
                    return { requests: [], canLoadMore: false };
                }
                _this.userProvider.storeUsers(requests, site.id);
                if (limitNum <= 0) {
                    return { requests: requests, canLoadMore: false };
                }
                return {
                    requests: requests.slice(0, limitNum),
                    canLoadMore: requests.length > limitNum
                };
            });
        });
    };
    /**
     * Get the number of contact requests sent to the current user.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<number>} Resolved with the number of contact requests.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getContactRequestsCount = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                userid: site.getUserId(),
            };
            var preSets = {
                cacheKey: _this.getCacheKeyForContactRequestsCount(),
                typeExpected: 'number'
            };
            return site.read('core_message_get_received_contact_requests_count', data, preSets).then(function (count) {
                // Notify the new count so all badges are updated.
                _this.eventsProvider.trigger(AddonMessagesProvider_1.CONTACT_REQUESTS_COUNT_EVENT, { count: count }, site.id);
                return count;
            });
        });
    };
    /**
     * Get a conversation by the conversation ID.
     *
     * @param {number} conversationId Conversation ID to fetch.
     * @param {boolean} [includeContactRequests] Include contact requests.
     * @param {boolean} [includePrivacyInfo] Include privacy info.
     * @param {number} [messageOffset=0] Offset for messages list.
     * @param {number} [messageLimit=1] Limit of messages. Defaults to 1 (last message).
     *                                  We recommend getConversationMessages to get them.
     * @param {number} [memberOffset=0] Offset for members list.
     * @param {number} [memberLimit=2] Limit of members. Defaults to 2 (to be able to know the other user in individual ones).
     *                                 We recommend getConversationMembers to get them.
     * @param {boolean} [newestFirst=true] Whether to order messages by newest first.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Promise resolved with the response.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getConversation = function (conversationId, includeContactRequests, includePrivacyInfo, messageOffset, messageLimit, memberOffset, memberLimit, newestFirst, siteId, userId) {
        var _this = this;
        if (messageOffset === void 0) { messageOffset = 0; }
        if (messageLimit === void 0) { messageLimit = 1; }
        if (memberOffset === void 0) { memberOffset = 0; }
        if (memberLimit === void 0) { memberLimit = 2; }
        if (newestFirst === void 0) { newestFirst = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var preSets = {
                cacheKey: _this.getCacheKeyForConversation(userId, conversationId)
            }, params = {
                userid: userId,
                conversationid: conversationId,
                includecontactrequests: includeContactRequests ? 1 : 0,
                includeprivacyinfo: includePrivacyInfo ? 1 : 0,
                messageoffset: messageOffset,
                messagelimit: messageLimit,
                memberoffset: memberOffset,
                memberlimit: memberLimit,
                newestmessagesfirst: newestFirst ? 1 : 0
            };
            return site.read('core_message_get_conversation', params, preSets).then(function (conversation) {
                return _this.formatConversation(conversation, userId);
            });
        });
    };
    /**
     * Get a conversation between two users.
     *
     * @param {number} otherUserId The other user ID.
     * @param {boolean} [includeContactRequests] Include contact requests.
     * @param {boolean} [includePrivacyInfo] Include privacy info.
     * @param {number} [messageOffset=0] Offset for messages list.
     * @param {number} [messageLimit=1] Limit of messages. Defaults to 1 (last message).
     *                                  We recommend getConversationMessages to get them.
     * @param {number} [memberOffset=0] Offset for members list.
     * @param {number} [memberLimit=2] Limit of members. Defaults to 2 (to be able to know the other user in individual ones).
     *                                 We recommend getConversationMembers to get them.
     * @param {boolean} [newestFirst=true] Whether to order messages by newest first.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @param {boolean} [preferCache] True if shouldn't call WS if data is cached, false otherwise.
     * @return {Promise<any>} Promise resolved with the response.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getConversationBetweenUsers = function (otherUserId, includeContactRequests, includePrivacyInfo, messageOffset, messageLimit, memberOffset, memberLimit, newestFirst, siteId, userId, preferCache) {
        var _this = this;
        if (messageOffset === void 0) { messageOffset = 0; }
        if (messageLimit === void 0) { messageLimit = 1; }
        if (memberOffset === void 0) { memberOffset = 0; }
        if (memberLimit === void 0) { memberLimit = 2; }
        if (newestFirst === void 0) { newestFirst = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var preSets = {
                cacheKey: _this.getCacheKeyForConversationBetweenUsers(userId, otherUserId),
                omitExpires: !!preferCache,
            }, params = {
                userid: userId,
                otheruserid: otherUserId,
                includecontactrequests: includeContactRequests ? 1 : 0,
                includeprivacyinfo: includePrivacyInfo ? 1 : 0,
                messageoffset: messageOffset,
                messagelimit: messageLimit,
                memberoffset: memberOffset,
                memberlimit: memberLimit,
                newestmessagesfirst: newestFirst ? 1 : 0
            };
            return site.read('core_message_get_conversation_between_users', params, preSets).then(function (conversation) {
                return _this.formatConversation(conversation, userId);
            });
        });
    };
    /**
     * Get a conversation members.
     *
     * @param {number} conversationId Conversation ID to fetch.
     * @param {number} [limitFrom=0] Offset for members list.
     * @param {number} [limitTo] Limit of members.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Promise resolved with the response.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getConversationMembers = function (conversationId, limitFrom, limitTo, includeContactRequests, siteId, userId) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            if (typeof limitTo == 'undefined' || limitTo === null) {
                limitTo = _this.LIMIT_MESSAGES;
            }
            var preSets = {
                cacheKey: _this.getCacheKeyForConversationMembers(userId, conversationId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            }, params = {
                userid: userId,
                conversationid: conversationId,
                limitfrom: limitFrom,
                limitnum: limitTo < 1 ? limitTo : limitTo + 1,
                includecontactrequests: includeContactRequests ? 1 : 0,
                includeprivacyinfo: 1,
            };
            return site.read('core_message_get_conversation_members', params, preSets).then(function (members) {
                var result = {};
                if (limitTo < 1) {
                    result.canLoadMore = false;
                    result.members = members;
                }
                else {
                    result.canLoadMore = members.length > limitTo;
                    result.members = members.slice(0, limitTo);
                }
                return result;
            });
        });
    };
    /**
     * Get a conversation by the conversation ID.
     *
     * @param {number} conversationId Conversation ID to fetch.
     * @param {boolean} excludePending True to exclude messages pending to be sent.
     * @param {number} [limitFrom=0] Offset for messages list.
     * @param {number} [limitTo] Limit of messages.
     * @param {boolean} [newestFirst=true] Whether to order messages by newest first.
     * @param {number} [timeFrom] The timestamp from which the messages were created.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Promise resolved with the response.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getConversationMessages = function (conversationId, excludePending, limitFrom, limitTo, newestFirst, timeFrom, siteId, userId) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        if (newestFirst === void 0) { newestFirst = true; }
        if (timeFrom === void 0) { timeFrom = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            if (typeof limitTo == 'undefined' || limitTo === null) {
                limitTo = _this.LIMIT_MESSAGES;
            }
            var preSets = {
                cacheKey: _this.getCacheKeyForConversationMessages(userId, conversationId)
            }, params = {
                currentuserid: userId,
                convid: conversationId,
                limitfrom: limitFrom,
                limitnum: limitTo < 1 ? limitTo : limitTo + 1,
                newest: newestFirst ? 1 : 0,
                timefrom: timeFrom
            };
            if (limitFrom > 0) {
                // Do not use cache when retrieving older messages.
                // This is to prevent storing too much data and to prevent inconsistencies between "pages" loaded.
                preSets['getFromCache'] = false;
                preSets['saveToCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return site.read('core_message_get_conversation_messages', params, preSets).then(function (result) {
                if (limitTo < 1) {
                    result.canLoadMore = false;
                    result.messages = result.messages;
                }
                else {
                    result.canLoadMore = result.messages.length > limitTo;
                    result.messages = result.messages.slice(0, limitTo);
                }
                var lastReceived;
                result.messages.forEach(function (message) {
                    // Convert time to milliseconds.
                    message.timecreated = message.timecreated ? message.timecreated * 1000 : 0;
                    if (!lastReceived && message.useridfrom != userId) {
                        lastReceived = message;
                    }
                });
                if (_this.appProvider.isDesktop() && limitFrom === 0 && lastReceived) {
                    // Store the last received message (we cannot know if it's unread or not). Don't block the user for this.
                    _this.storeLastReceivedMessageIfNeeded(conversationId, lastReceived, site.getId());
                }
                if (excludePending) {
                    // No need to get offline messages, return the ones we have.
                    return result;
                }
                // Get offline messages.
                return _this.messagesOffline.getConversationMessages(conversationId).then(function (offlineMessages) {
                    // Mark offline messages as pending.
                    offlineMessages.forEach(function (message) {
                        message.pending = true;
                        message.useridfrom = userId;
                    });
                    result.messages = result.messages.concat(offlineMessages);
                    return result;
                });
            });
        });
    };
    /**
     * Get the discussions of a certain user. This function is used in Moodle sites higher than 3.6.
     * If the site is older than 3.6, please use getDiscussions.
     *
     * @param {number} [type] Filter by type.
     * @param {boolean} [favourites] Whether to restrict the results to contain NO favourite conversations (false), ONLY favourite
     *                               conversation (true), or ignore any restriction altogether (undefined or null).
     * @param {number} [limitFrom=0] The offset to start at.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @param {boolean} [forceCache] True if it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>} Promise resolved with the conversations.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getConversations = function (type, favourites, limitFrom, siteId, userId, forceCache, ignoreCache) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var preSets = {
                cacheKey: _this.getCacheKeyForConversations(userId, type, favourites)
            }, params = {
                userid: userId,
                limitfrom: limitFrom,
                limitnum: _this.LIMIT_MESSAGES + 1,
            };
            if (forceCache) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            if (typeof type != 'undefined' && type != null) {
                params.type = type;
            }
            if (typeof favourites != 'undefined' && favourites != null) {
                params.favourites = favourites ? 1 : 0;
            }
            if (site.isVersionGreaterEqualThan('3.7') && type != AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_GROUP) {
                // Add self conversation to the list.
                params.mergeself = 1;
            }
            return site.read('core_message_get_conversations', params, preSets).catch(function (error) {
                if (params.mergeself) {
                    // Try again without the new param. Maybe the user is offline and he has a previous request cached.
                    delete params.mergeself;
                    return site.read('core_message_get_conversations', params, preSets);
                }
                return Promise.reject(error);
            }).then(function (response) {
                // Format the conversations, adding some calculated fields.
                var conversations = response.conversations.slice(0, _this.LIMIT_MESSAGES).map(function (conversation) {
                    return _this.formatConversation(conversation, userId);
                }), conv = conversations[0], lastMessage = conv && conv.messages[0];
                if (_this.appProvider.isDesktop() && limitFrom === 0 && lastMessage && !conv.sentfromcurrentuser) {
                    // Store the last received message (we cannot know if it's unread or not). Don't block the user for this.
                    _this.storeLastReceivedMessageIfNeeded(conv.id, lastMessage, site.getId());
                }
                return {
                    conversations: conversations,
                    canLoadMore: response.conversations.length > _this.LIMIT_MESSAGES
                };
            });
        });
    };
    /**
     * Get conversation counts by type.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<favourites: number, individual: number, group: number, self: number>} Promise resolved with favourite,
     *                                      individual, group and self conversation counts.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getConversationCounts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getCacheKeyForConversationCounts()
            };
            return site.read('core_message_get_conversation_counts', {}, preSets).then(function (result) {
                var counts = {
                    favourites: result.favourites,
                    individual: result.types[AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_INDIVIDUAL],
                    group: result.types[AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_GROUP],
                    self: result.types[AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_SELF] || 0
                };
                return counts;
            });
        });
    };
    /**
     * Return the current user's discussion with another user.
     *
     * @param  {number} userId               The ID of the other user.
     * @param  {boolean} excludePending      True to exclude messages pending to be sent.
     * @param  {number} [lfReceivedUnread=0] Number of unread received messages already fetched, so fetch will be done from this.
     * @param  {number} [lfReceivedRead=0]   Number of read received messages already fetched, so fetch will be done from this.
     * @param  {number} [lfSentUnread=0]     Number of unread sent messages already fetched, so fetch will be done from this.
     * @param  {number} [lfSentRead=0]       Number of read sent messages already fetched, so fetch will be done from this.
     * @param  {boolean} [toDisplay=true]    True if messages will be displayed to the user, either in view or in a notification.
     * @param  {string} [siteId]             Site ID. If not defined, use current site.
     * @return {Promise<any>}                     Promise resolved with messages and a boolean telling if can load more messages.
     */
    AddonMessagesProvider.prototype.getDiscussion = function (userId, excludePending, lfReceivedUnread, lfReceivedRead, lfSentUnread, lfSentRead, toDisplay, siteId) {
        var _this = this;
        if (lfReceivedUnread === void 0) { lfReceivedUnread = 0; }
        if (lfReceivedRead === void 0) { lfReceivedRead = 0; }
        if (lfSentUnread === void 0) { lfSentUnread = 0; }
        if (lfSentRead === void 0) { lfSentRead = 0; }
        if (toDisplay === void 0) { toDisplay = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var result = {}, preSets = {
                cacheKey: _this.getCacheKeyForDiscussion(userId)
            }, params = {
                useridto: site.getUserId(),
                useridfrom: userId,
                limitnum: _this.LIMIT_MESSAGES
            };
            var hasReceived, hasSent;
            if (lfReceivedUnread > 0 || lfReceivedRead > 0 || lfSentUnread > 0 || lfSentRead > 0) {
                // Do not use cache when retrieving older messages.
                // This is to prevent storing too much data and to prevent inconsistencies between "pages" loaded.
                preSets['getFromCache'] = false;
                preSets['saveToCache'] = false;
                preSets['emergencyCache'] = false;
            }
            // Get message received by current user.
            return _this.getRecentMessages(params, preSets, lfReceivedUnread, lfReceivedRead, toDisplay, site.getId())
                .then(function (response) {
                result['messages'] = response;
                params.useridto = userId;
                params.useridfrom = site.getUserId();
                hasReceived = response.length > 0;
                // Get message sent by current user.
                return _this.getRecentMessages(params, preSets, lfSentUnread, lfSentRead, toDisplay, siteId);
            }).then(function (response) {
                result['messages'] = result['messages'].concat(response);
                hasSent = response.length > 0;
                if (result['messages'].length > _this.LIMIT_MESSAGES) {
                    // Sort messages and get the more recent ones.
                    result['canLoadMore'] = true;
                    result['messages'] = _this.sortMessages(result['messages']);
                    result['messages'] = result['messages'].slice(-_this.LIMIT_MESSAGES);
                }
                else {
                    result['canLoadMore'] = result['messages'].length == _this.LIMIT_MESSAGES && (!hasReceived || !hasSent);
                }
                if (excludePending) {
                    // No need to get offline messages, return the ones we have.
                    return result;
                }
                // Get offline messages.
                return _this.messagesOffline.getMessages(userId).then(function (offlineMessages) {
                    // Mark offline messages as pending.
                    offlineMessages.forEach(function (message) {
                        message.pending = true;
                        message.text = message.smallmessage;
                    });
                    result['messages'] = result['messages'].concat(offlineMessages);
                    return result;
                });
            });
        });
    };
    /**
     * Get the discussions of the current user. This function is used in Moodle sites older than 3.6.
     * If the site is 3.6 or higher, please use getConversations.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved with an object where the keys are the user ID of the other user.
     */
    AddonMessagesProvider.prototype.getDiscussions = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var discussions = {}, currentUserId = site.getUserId(), params = {
                useridto: currentUserId,
                useridfrom: 0,
                limitnum: _this.LIMIT_MESSAGES
            }, preSets = {
                cacheKey: _this.getCacheKeyForDiscussions()
            };
            /**
             * Convenience function to treat a recent message, adding it to discussions list if needed.
             */
            var treatRecentMessage = function (message, userId, userFullname) {
                if (typeof discussions[userId] === 'undefined') {
                    discussions[userId] = {
                        fullname: userFullname,
                        profileimageurl: ''
                    };
                    if (!message.timeread && !message.pending && message.useridfrom != currentUserId) {
                        discussions[userId].unread = true;
                    }
                }
                // Extract the most recent message. Pending messages are considered more recent than messages already sent.
                var discMessage = discussions[userId].message;
                if (typeof discMessage === 'undefined' || (!discMessage.pending && message.pending) ||
                    (discMessage.pending == message.pending && (discMessage.timecreated < message.timecreated ||
                        (discMessage.timecreated == message.timecreated && discMessage.id < message.id)))) {
                    discussions[userId].message = {
                        id: message.id,
                        user: userId,
                        message: message.text,
                        timecreated: message.timecreated,
                        pending: !!message.pending
                    };
                }
            };
            // Get recent messages sent to current user.
            return _this.getRecentMessages(params, preSets, undefined, undefined, undefined, site.getId()).then(function (messages) {
                // Extract the discussions by filtering same senders.
                messages.forEach(function (message) {
                    treatRecentMessage(message, message.useridfrom, message.userfromfullname);
                });
                // Now get the last messages sent by the current user.
                params.useridfrom = params.useridto;
                params.useridto = 0;
                return _this.getRecentMessages(params, preSets);
            }).then(function (messages) {
                // Extract the discussions by filtering same senders.
                messages.forEach(function (message) {
                    treatRecentMessage(message, message.useridto, message.usertofullname);
                });
                // Now get unsent messages.
                return _this.messagesOffline.getAllMessages(site.getId());
            }).then(function (offlineMessages) {
                offlineMessages.forEach(function (message) {
                    message.pending = true;
                    message.text = message.smallmessage;
                    treatRecentMessage(message, message.touserid, '');
                });
                return _this.getDiscussionsUserImg(discussions, site.getId()).then(function (discussions) {
                    _this.storeUsersFromDiscussions(discussions);
                    return discussions;
                });
            });
        });
    };
    /**
     * Get user images for all the discussions that don't have one already.
     *
     * @param {any} discussions List of discussions.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}             Promise always resolved. Resolve param is the formatted discussions.
     */
    AddonMessagesProvider.prototype.getDiscussionsUserImg = function (discussions, siteId) {
        var promises = [];
        var _loop_2 = function (userId) {
            if (!discussions[userId].profileimageurl) {
                // We don't have the user image. Try to retrieve it.
                promises.push(this_1.userProvider.getProfile(discussions[userId].message.user, 0, true, siteId).then(function (user) {
                    discussions[userId].profileimageurl = user.profileimageurl;
                }).catch(function () {
                    // Error getting profile, resolve promise without adding any extra data.
                }));
            }
        };
        var this_1 = this;
        for (var userId in discussions) {
            _loop_2(userId);
        }
        return Promise.all(promises).then(function () {
            return discussions;
        });
    };
    /**
     * Get conversation member info by user id, works even if no conversation betwen the users exists.
     *
     * @param {number} otherUserId The other user ID.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Promise resolved with the member info.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.getMemberInfo = function (otherUserId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var preSets = {
                cacheKey: _this.getCacheKeyForMemberInfo(userId, otherUserId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            }, params = {
                referenceuserid: userId,
                userids: [otherUserId],
                includecontactrequests: 1,
                includeprivacyinfo: 1,
            };
            return site.read('core_message_get_member_info', params, preSets).then(function (members) {
                if (!members || members.length < 1) {
                    // Should never happen.
                    return Promise.reject(null);
                }
                return members[0];
            });
        });
    };
    /**
     * Get the cache key for the get message preferences call.
     *
     * @return {string} Cache key.
     */
    AddonMessagesProvider.prototype.getMessagePreferencesCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'messagePreferences';
    };
    /**
     * Get message preferences.
     *
     * @param  {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>}         Promise resolved with the message preferences.
     */
    AddonMessagesProvider.prototype.getMessagePreferences = function (siteId) {
        var _this = this;
        this.logger.debug('Get message preferences');
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getMessagePreferencesCacheKey(),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('core_message_get_user_message_preferences', {}, preSets).then(function (data) {
                if (data.preferences) {
                    data.preferences.blocknoncontacts = data.blocknoncontacts;
                    return data.preferences;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get messages according to the params.
     *
     * @param  {any} params            Parameters to pass to the WS.
     * @param  {any} preSets           Set of presets for the WS.
     * @param  {boolean} [toDisplay=true] True if messages will be displayed to the user, either in view or in a notification.
     * @param  {string} [siteId]          Site ID. If not defined, use current site.
     * @return {Promise<any>}
     */
    AddonMessagesProvider.prototype.getMessages = function (params, preSets, toDisplay, siteId) {
        var _this = this;
        if (toDisplay === void 0) { toDisplay = true; }
        params['type'] = 'conversations';
        params['newestfirst'] = 1;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var userId = site.getUserId();
            return site.read('core_message_get_messages', params, preSets).then(function (response) {
                response.messages.forEach(function (message) {
                    message.read = params.read == 0 ? 0 : 1;
                    // Convert times to milliseconds.
                    message.timecreated = message.timecreated ? message.timecreated * 1000 : 0;
                    message.timeread = message.timeread ? message.timeread * 1000 : 0;
                });
                if (toDisplay && _this.appProvider.isDesktop() && !params.read && params.useridto == userId &&
                    params.limitfrom === 0) {
                    // Store the last unread received messages. Don't block the user for this.
                    _this.storeLastReceivedMessageIfNeeded(params.useridfrom, response.messages[0], site.getId());
                }
                return response;
            });
        });
    };
    /**
     * Get the most recent messages.
     *
     * @param  {any} params              Parameters to pass to the WS.
     * @param  {any} preSets             Set of presets for the WS.
     * @param  {number} [limitFromUnread=0] Number of read messages already fetched, so fetch will be done from this number.
     * @param  {number} [limitFromRead=0]   Number of unread messages already fetched, so fetch will be done from this number.
     * @param  {boolean} [toDisplay=true]   True if messages will be displayed to the user, either in view or in a notification.
     * @param  {string} [siteId]            Site ID. If not defined, use current site.
     * @return {Promise<any>}
     */
    AddonMessagesProvider.prototype.getRecentMessages = function (params, preSets, limitFromUnread, limitFromRead, toDisplay, siteId) {
        var _this = this;
        if (limitFromUnread === void 0) { limitFromUnread = 0; }
        if (limitFromRead === void 0) { limitFromRead = 0; }
        if (toDisplay === void 0) { toDisplay = true; }
        limitFromUnread = limitFromUnread || 0;
        limitFromRead = limitFromRead || 0;
        params['read'] = 0;
        params['limitfrom'] = limitFromUnread;
        return this.getMessages(params, preSets, toDisplay, siteId).then(function (response) {
            var messages = response.messages;
            if (messages) {
                if (messages.length >= params.limitnum) {
                    return messages;
                }
                // We need to fetch more messages.
                params.limitnum = params.limitnum - messages.length;
                params.read = 1;
                params.limitfrom = limitFromRead;
                return _this.getMessages(params, preSets, toDisplay, siteId).then(function (response) {
                    if (response.messages) {
                        messages = messages.concat(response.messages);
                    }
                    return messages;
                }).catch(function () {
                    return messages;
                });
            }
            else {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Get a self conversation.
     *
     * @param {number} [messageOffset=0] Offset for messages list.
     * @param {number} [messageLimit=1] Limit of messages. Defaults to 1 (last message).
     *                                  We recommend getConversationMessages to get them.
     * @param {boolean} [newestFirst=true] Whether to order messages by newest first.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @param {string} [userId] User ID to get the self conversation for. If not defined, current user in the site.
     * @return {Promise<any>} Promise resolved with the response.
     * @since 3.7
     */
    AddonMessagesProvider.prototype.getSelfConversation = function (messageOffset, messageLimit, newestFirst, siteId, userId) {
        var _this = this;
        if (messageOffset === void 0) { messageOffset = 0; }
        if (messageLimit === void 0) { messageLimit = 1; }
        if (newestFirst === void 0) { newestFirst = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var preSets = {
                cacheKey: _this.getCacheKeyForSelfConversation(userId)
            }, params = {
                userid: userId,
                messageoffset: messageOffset,
                messagelimit: messageLimit,
                newestmessagesfirst: newestFirst ? 1 : 0
            };
            return site.read('core_message_get_self_conversation', params, preSets).then(function (conversation) {
                return _this.formatConversation(conversation, userId);
            });
        });
    };
    /**
     * Get unread conversation counts by type.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved with the unread favourite, individual and group conversation counts.
     */
    AddonMessagesProvider.prototype.getUnreadConversationCounts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promise;
            if (_this.isGroupMessagingEnabled()) {
                // @since 3.6
                var preSets = {
                    cacheKey: _this.getCacheKeyForUnreadConversationCounts()
                };
                promise = site.read('core_message_get_unread_conversation_counts', {}, preSets).then(function (result) {
                    return {
                        favourites: result.favourites,
                        individual: result.types[AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_INDIVIDUAL],
                        group: result.types[AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_GROUP],
                        self: result.types[AddonMessagesProvider_1.MESSAGE_CONVERSATION_TYPE_SELF] || 0
                    };
                });
            }
            else if (_this.isMessageCountEnabled()) {
                // @since 3.2
                var params = {
                    useridto: site.getUserId(),
                }, preSets = {
                    cacheKey: _this.getCacheKeyForMessageCount(site.getUserId()),
                    typeExpected: 'number'
                };
                promise = site.read('core_message_get_unread_conversations_count', params, preSets).then(function (count) {
                    return { favourites: 0, individual: count, group: 0, self: 0 };
                });
            }
            else {
                // Fallback call.
                var params = {
                    read: 0,
                    limitfrom: 0,
                    limitnum: _this.LIMIT_MESSAGES + 1,
                    useridto: site.getUserId(),
                    useridfrom: 0,
                };
                promise = _this.getMessages(params, undefined, false, siteId).then(function (response) {
                    // Count the discussions by filtering same senders.
                    var discussions = {};
                    response.messages.forEach(function (message) {
                        discussions[message.useridto] = 1;
                    });
                    var count = Object.keys(discussions).length;
                    return {
                        favourites: 0,
                        individual: count,
                        group: 0,
                        self: 0,
                        orMore: count > _this.LIMIT_MESSAGES
                    };
                });
            }
            return promise.then(function (counts) {
                // Notify the new counts so all views are updated.
                _this.eventsProvider.trigger(AddonMessagesProvider_1.UNREAD_CONVERSATION_COUNTS_EVENT, counts, site.id);
                return counts;
            });
        });
    };
    /**
     * Get the latest unread received messages.
     *
     * @param  {boolean} [toDisplay=true] True if messages will be displayed to the user, either in view or in a notification.
     * @param  {boolean} [forceCache]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache]    True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string} [siteId]          Site ID. If not defined, use current site.
     * @return {Promise<any>}                  Promise resolved with the message unread count.
     */
    AddonMessagesProvider.prototype.getUnreadReceivedMessages = function (toDisplay, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (toDisplay === void 0) { toDisplay = true; }
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                read: 0,
                limitfrom: 0,
                limitnum: _this.LIMIT_MESSAGES,
                useridto: site.getUserId(),
                useridfrom: 0
            }, preSets = {};
            if (forceCache) {
                preSets['omitExpires'] = true;
            }
            else if (ignoreCache) {
                preSets['getFromCache'] = false;
                preSets['emergencyCache'] = false;
            }
            return _this.getMessages(params, preSets, toDisplay, siteId);
        });
    };
    /**
     * Invalidate all contacts cache.
     *
     * @param {number} userId    The user ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateAllContactsCache = function (userId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.invalidateContactsCache(siteId).then(function () {
            return _this.invalidateBlockedContactsCache(userId, siteId);
        });
    };
    /**
     * Invalidate blocked contacts cache.
     *
     * @param {number} userId    The user ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}
     */
    AddonMessagesProvider.prototype.invalidateBlockedContactsCache = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCacheKeyForBlockedContacts(userId));
        });
    };
    /**
     * Invalidate contacts cache.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateContactsCache = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCacheKeyForContacts());
        });
    };
    /**
     * Invalidate user contacts cache.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateUserContacts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCacheKeyForUserContacts());
        });
    };
    /**
     * Invalidate contact requests cache.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateContactRequestsCache = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCacheKeyForContactRequests());
        });
    };
    /**
     * Invalidate contact requests count cache.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateContactRequestsCountCache = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCacheKeyForContactRequestsCount());
        });
    };
    /**
     * Invalidate conversation.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateConversation = function (conversationId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCacheKeyForConversation(userId, conversationId));
        });
    };
    /**
     * Invalidate conversation between users.
     *
     * @param {number} otherUserId Other user ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateConversationBetweenUsers = function (otherUserId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCacheKeyForConversationBetweenUsers(userId, otherUserId));
        });
    };
    /**
     * Invalidate conversation members cache.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateConversationMembers = function (conversationId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCacheKeyForConversationMembers(userId, conversationId));
        });
    };
    /**
     * Invalidate conversation messages cache.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateConversationMessages = function (conversationId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCacheKeyForConversationMessages(userId, conversationId));
        });
    };
    /**
     * Invalidate conversations cache.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateConversations = function (siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKeyStartingWith(_this.getCommonCacheKeyForUserConversations(userId));
        });
    };
    /**
     * Invalidate conversation counts cache.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateConversationCounts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCacheKeyForConversationCounts());
        });
    };
    /**
     * Invalidate discussion cache.
     *
     * @param {number} userId    The user ID with whom the current user is having the discussion.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateDiscussionCache = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCacheKeyForDiscussion(userId));
        });
    };
    /**
     * Invalidate discussions cache.
     *
     * Note that {@link this.getDiscussions} uses the contacts, so we need to invalidate contacts too.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateDiscussionsCache = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = [];
            promises.push(site.invalidateWsCacheForKey(_this.getCacheKeyForDiscussions()));
            promises.push(_this.invalidateContactsCache(site.getId()));
            return Promise.all(promises);
        });
    };
    /**
     * Invalidate member info cache.
     *
     * @param {number} otherUserId The other user ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateMemberInfo = function (otherUserId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCacheKeyForMemberInfo(userId, otherUserId));
        });
    };
    /**
     * Invalidate get message preferences.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when data is invalidated.
     */
    AddonMessagesProvider.prototype.invalidateMessagePreferences = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getMessagePreferencesCacheKey());
        });
    };
    /**
     * Invalidate all cache entries with member info.
     *
     * @param {number} userId Id of the user to invalidate.
     * @param {CoreSite} site Site object.
     * @return {Promie<any>} Promise resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateAllMemberInfo = function (userId, site) {
        var _this = this;
        return this.utils.allPromises([
            this.invalidateMemberInfo(userId, site.id),
            this.invalidateUserContacts(site.id),
            this.invalidateContactRequestsCache(site.id),
            this.invalidateConversations(site.id),
            this.getConversationBetweenUsers(userId, undefined, undefined, undefined, undefined, undefined, undefined, undefined, site.id, undefined, true).then(function (conversation) {
                return _this.utils.allPromises([
                    _this.invalidateConversation(conversation.id),
                    _this.invalidateConversationMembers(conversation.id, site.id),
                ]);
            }).catch(function () {
                // The conversation does not exist or we can't fetch it now, ignore it.
            })
        ]);
    };
    /**
     * Invalidate a self conversation.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateSelfConversation = function (siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCacheKeyForSelfConversation(userId));
        });
    };
    /**
     * Invalidate unread conversation counts cache.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.invalidateUnreadConversationCounts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (_this.isGroupMessagingEnabled()) {
                // @since 3.6
                return site.invalidateWsCacheForKey(_this.getCacheKeyForUnreadConversationCounts());
            }
            else if (_this.isMessageCountEnabled()) {
                // @since 3.2
                return site.invalidateWsCacheForKey(_this.getCacheKeyForMessageCount(site.getUserId()));
            }
        });
    };
    /**
     * Checks if the a user is blocked by the current user.
     *
     * @param {number} userId The user ID to check against.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<boolean>} Resolved with boolean, rejected when we do not know.
     */
    AddonMessagesProvider.prototype.isBlocked = function (userId, siteId) {
        if (this.isGroupMessagingEnabled()) {
            return this.getMemberInfo(userId, siteId).then(function (member) {
                return member.isblocked;
            });
        }
        return this.getBlockedContacts(siteId).then(function (blockedContacts) {
            if (!blockedContacts.users || blockedContacts.users.length < 1) {
                return false;
            }
            return blockedContacts.users.some(function (user) {
                return userId == user.id;
            });
        });
    };
    /**
     * Checks if the a user is a contact of the current user.
     *
     * @param {number} userId The user ID to check against.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<boolean>} Resolved with boolean, rejected when we do not know.
     */
    AddonMessagesProvider.prototype.isContact = function (userId, siteId) {
        if (this.isGroupMessagingEnabled()) {
            return this.getMemberInfo(userId, siteId).then(function (member) {
                return member.iscontact;
            });
        }
        return this.getContacts(siteId).then(function (contacts) {
            return ['online', 'offline'].some(function (type) {
                if (contacts[type] && contacts[type].length > 0) {
                    return contacts[type].some(function (user) {
                        return userId == user.id;
                    });
                }
                return false;
            });
        });
    };
    /**
     * Returns whether or not group messaging is supported.
     *
     * @return {boolean} If related WS is available on current site.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.isGroupMessagingEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_message_get_conversations');
    };
    /**
     * Returns whether or not group messaging is supported in a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether related WS is available on a certain site.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.isGroupMessagingEnabledInSite = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('core_message_get_conversations');
        }).catch(function () {
            return false;
        });
    };
    /**
     * Returns whether or not we can mark all messages as read.
     *
     * @return {boolean} If related WS is available on current site.
     * @since  3.2
     */
    AddonMessagesProvider.prototype.isMarkAllMessagesReadEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_message_mark_all_messages_as_read');
    };
    /**
     * Returns whether or not we can count unread messages.
     *
     * @return {boolean} True if enabled, false otherwise.
     * @since  3.2
     */
    AddonMessagesProvider.prototype.isMessageCountEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_message_get_unread_conversations_count');
    };
    /**
     * Returns whether or not the message preferences are enabled for the current site.
     *
     * @return {boolean} True if enabled, false otherwise.
     * @since  3.2
     */
    AddonMessagesProvider.prototype.isMessagePreferencesEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_message_get_user_message_preferences');
    };
    /**
     * Returns whether or not messaging is enabled for a certain site.
     *
     * This could call a WS so do not abuse this method.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Resolved when enabled, otherwise rejected.
     */
    AddonMessagesProvider.prototype.isMessagingEnabledForSite = function (siteId) {
        return this.isPluginEnabled(siteId).then(function (enabled) {
            if (!enabled) {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Returns whether or not a site supports muting or unmuting a conversation.
     *
     * @param {CoreSite} [site] The site to check, undefined for current site.
     * @return {boolean} If related WS is available on current site.
     * @since 3.7
     */
    AddonMessagesProvider.prototype.isMuteConversationEnabled = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.wsAvailable('core_message_mute_conversations');
    };
    /**
     * Returns whether or not a site supports muting or unmuting a conversation.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether related WS is available on a certain site.
     * @since 3.7
     */
    AddonMessagesProvider.prototype.isMuteConversationEnabledInSite = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isMuteConversationEnabled(site);
        }).catch(function () {
            return false;
        });
    };
    /**
     * Returns whether or not the plugin is enabled in a certain site.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved with true if enabled, rejected or resolved with false otherwise.
     */
    AddonMessagesProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.canUseAdvancedFeature('messaging');
        });
    };
    /**
     * Returns whether or not we can search messages.
     *
     * @return {boolean}
     * @since  3.2
     */
    AddonMessagesProvider.prototype.isSearchMessagesEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_message_data_for_messagearea_search_messages');
    };
    /**
     * Returns whether or not self conversation is supported in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, current site.
     * @return {boolean} If related WS is available on the site.
     * @since 3.7
     */
    AddonMessagesProvider.prototype.isSelfConversationEnabled = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.wsAvailable('core_message_get_self_conversation');
    };
    /**
     * Returns whether or not self conversation is supported in a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether related WS is available on a certain site.
     * @since 3.7
     */
    AddonMessagesProvider.prototype.isSelfConversationEnabledInSite = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isSelfConversationEnabled(site);
        }).catch(function () {
            return false;
        });
    };
    /**
     * Mark message as read.
     *
     * @param {number} messageId ID of message to mark as read
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @returns {Promise<any>} Promise resolved with boolean marking success or not.
     */
    AddonMessagesProvider.prototype.markMessageRead = function (messageId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                messageid: messageId,
                timeread: _this.timeUtils.timestamp()
            };
            return site.write('core_message_mark_message_read', params);
        });
    };
    /**
     * Mark all messages of a conversation as read.
     *
     * @param {number} conversationId Conversation ID.
     * @returns {Promise<any>} Promise resolved if success.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.markAllConversationMessagesRead = function (conversationId) {
        var params = {
            userid: this.sitesProvider.getCurrentSiteUserId(),
            conversationid: conversationId
        }, preSets = {
            responseExpected: false
        };
        return this.sitesProvider.getCurrentSite().write('core_message_mark_all_conversation_messages_as_read', params, preSets);
    };
    /**
     * Mark all messages of a discussion as read.
     *
     * @param   {number}  userIdFrom  User Id for the sender.
     * @returns {Promise<any>} Promise resolved with boolean marking success or not.
     */
    AddonMessagesProvider.prototype.markAllMessagesRead = function (userIdFrom) {
        var params = {
            useridto: this.sitesProvider.getCurrentSiteUserId(),
            useridfrom: userIdFrom
        }, preSets = {
            typeExpected: 'boolean'
        };
        return this.sitesProvider.getCurrentSite().write('core_message_mark_all_messages_as_read', params, preSets);
    };
    /**
     * Mute or unmute a conversation.
     *
     * @param {number} conversationId Conversation ID.
     * @param {boolean} set Whether to mute or unmute.
     * @param {string} [siteId]  Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>}  Resolved when done.
     */
    AddonMessagesProvider.prototype.muteConversation = function (conversationId, set, siteId, userId) {
        return this.muteConversations([conversationId], set, siteId, userId);
    };
    /**
     * Mute or unmute some conversations.
     *
     * @param {number[]} conversations Conversation IDs.
     * @param {boolean} set Whether to mute or unmute.
     * @param {string} [siteId]  Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>}  Resolved when done.
     */
    AddonMessagesProvider.prototype.muteConversations = function (conversations, set, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                userid: userId,
                conversationids: conversations
            }, wsName = set ? 'core_message_mute_conversations' : 'core_message_unmute_conversations';
            return site.write(wsName, params).then(function () {
                // Invalidate the conversations data.
                var promises = [];
                conversations.forEach(function (conversationId) {
                    promises.push(_this.invalidateConversation(conversationId, site.getId(), userId));
                });
                return Promise.all(promises).catch(function () {
                    // Ignore errors.
                });
            });
        });
    };
    /**
     * Refresh the number of contact requests sent to the current user.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<number>} Resolved with the number of contact requests.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.refreshContactRequestsCount = function (siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.invalidateContactRequestsCountCache(siteId).then(function () {
            return _this.getContactRequestsCount(siteId);
        });
    };
    /**
     * Refresh unread conversation counts and trigger event.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved with the unread favourite, individual and group conversation counts.
     */
    AddonMessagesProvider.prototype.refreshUnreadConversationCounts = function (siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.invalidateUnreadConversationCounts(siteId).then(function () {
            return _this.getUnreadConversationCounts(siteId);
        });
    };
    /**
     * Remove a contact.
     *
     * @param {number} userId User ID of the person to remove.
     * @param {string} [siteId]  Site ID. If not defined, use current site.
     * @return {Promise<any>}  Resolved when done.
     */
    AddonMessagesProvider.prototype.removeContact = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                userids: [userId]
            }, preSets = {
                responseExpected: false
            };
            return site.write('core_message_delete_contacts', params, preSets).then(function () {
                if (_this.isGroupMessagingEnabled()) {
                    return _this.utils.allPromises([
                        _this.invalidateUserContacts(site.id),
                        _this.invalidateAllMemberInfo(userId, site),
                    ]).then(function () {
                        var data = { userId: userId, contactRemoved: true };
                        _this.eventsProvider.trigger(AddonMessagesProvider_1.MEMBER_INFO_CHANGED_EVENT, data, site.id);
                    });
                }
                else {
                    return _this.invalidateContactsCache(site.id);
                }
            });
        });
    };
    /**
     * Search for contacts.
     *
     * By default this only returns the first 100 contacts, but note that the WS can return thousands
     * of results which would take a while to process. The limit here is just a convenience to
     * prevent viewed to crash because too many DOM elements are created.
     *
     * @param {string} query The query string.
     * @param {number} [limit=100] The number of results to return, 0 for none.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}
     */
    AddonMessagesProvider.prototype.searchContacts = function (query, limit, siteId) {
        var _this = this;
        if (limit === void 0) { limit = 100; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                searchtext: query,
                onlymycourses: 0
            }, preSets = {
                getFromCache: false // Always try to get updated data. If it fails, it will get it from cache.
            };
            return site.read('core_message_search_contacts', data, preSets).then(function (contacts) {
                if (limit && contacts.length > limit) {
                    contacts = contacts.splice(0, limit);
                }
                _this.userProvider.storeUsers(contacts);
                return contacts;
            });
        });
    };
    /**
     * Search for all the messges with a specific text.
     *
     * @param {string} query The query string.
     * @param {number} [userId] The user ID. If not defined, current user.
     * @param {number} [limitFrom=0] Position of the first result to get. Defaults to 0.
     * @param {number} [limitNum] Number of results to get. Defaults to AddonMessagesProvider.LIMIT_SEARCH.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the results.
     */
    AddonMessagesProvider.prototype.searchMessages = function (query, userId, limitFrom, limitNum, siteId) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNum === void 0) { limitNum = AddonMessagesProvider_1.LIMIT_SEARCH; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                userid: userId || site.getUserId(),
                search: query,
                limitfrom: limitFrom,
                limitnum: limitNum <= 0 ? 0 : limitNum + 1
            }, preSets = {
                getFromCache: false // Always try to get updated data. If it fails, it will get it from cache.
            };
            return site.read('core_message_data_for_messagearea_search_messages', params, preSets).then(function (result) {
                if (!result.contacts || !result.contacts.length) {
                    return { messages: [], canLoadMore: false };
                }
                result.contacts.forEach(function (result) {
                    result.id = result.userid;
                });
                _this.userProvider.storeUsers(result.contacts, site.id);
                if (limitNum <= 0) {
                    return { messages: result.contacts, canLoadMore: false };
                }
                return {
                    messages: result.contacts.slice(0, limitNum),
                    canLoadMore: result.contacts.length > limitNum
                };
            });
        });
    };
    /**
     * Search for users.
     *
     * @param {string} query Text to search for.
     * @param {number} [limitFrom=0] Position of the first found user to fetch.
     * @param {number} [limitNum] Number of found users to fetch. Defaults to AddonMessagesProvider.LIMIT_SEARCH.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved with two lists of found users: contacts and non-contacts.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.searchUsers = function (query, limitFrom, limitNum, siteId) {
        var _this = this;
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNum === void 0) { limitNum = AddonMessagesProvider_1.LIMIT_SEARCH; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                userid: site.getUserId(),
                search: query,
                limitfrom: limitFrom,
                limitnum: limitNum <= 0 ? 0 : limitNum + 1
            }, preSets = {
                getFromCache: false // Always try to get updated data. If it fails, it will get it from cache.
            };
            return site.read('core_message_message_search_users', data, preSets).then(function (result) {
                var contacts = result.contacts || [];
                var nonContacts = result.noncontacts || [];
                _this.userProvider.storeUsers(contacts, site.id);
                _this.userProvider.storeUsers(nonContacts, site.id);
                if (limitNum <= 0) {
                    return { contacts: contacts, nonContacts: nonContacts, canLoadMoreContacts: false, canLoadMoreNonContacts: false };
                }
                return {
                    contacts: contacts.slice(0, limitNum),
                    nonContacts: nonContacts.slice(0, limitNum),
                    canLoadMoreContacts: contacts.length > limitNum,
                    canLoadMoreNonContacts: nonContacts.length > limitNum
                };
            });
        });
    };
    /**
     * Send a message to someone.
     *
     * @param {number} userIdTo  User ID to send the message to.
     * @param {string} message   The message to send
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved with:
     *                                 - sent (Boolean) True if message was sent to server, false if stored in device.
     *                                 - message (Object) If sent=false, contains the stored message.
     */
    AddonMessagesProvider.prototype.sendMessage = function (toUserId, message, siteId) {
        var _this = this;
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.messagesOffline.saveMessage(toUserId, message, siteId).then(function (entry) {
                return {
                    sent: false,
                    message: entry
                };
            });
        };
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!this.appProvider.isOnline()) {
            // App is offline, store the message.
            return storeOffline();
        }
        // Check if this conversation already has offline messages.
        // If so, store this message since they need to be sent in order.
        return this.messagesOffline.hasMessages(toUserId, siteId).catch(function () {
            // Error, it's safer to assume it has messages.
            return true;
        }).then(function (hasStoredMessages) {
            if (hasStoredMessages) {
                return storeOffline();
            }
            // Online and no messages stored. Send it to server.
            return _this.sendMessageOnline(toUserId, message).then(function (result) {
                return {
                    sent: true,
                    message: result
                };
            }).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // It's a WebService error, the user cannot send the message so don't store it.
                    return Promise.reject(error);
                }
                // Error sending message, store it to retry later.
                return storeOffline();
            });
        });
    };
    /**
     * Send a message to someone. It will fail if offline or cannot connect.
     *
     * @param {number} toUserId  User ID to send the message to.
     * @param {string} message   The message to send
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if success, rejected if failure.
     */
    AddonMessagesProvider.prototype.sendMessageOnline = function (toUserId, message, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var messages = [
            {
                touserid: toUserId,
                text: message,
                textformat: 1
            }
        ];
        return this.sendMessagesOnline(messages, siteId).then(function (response) {
            if (response && response[0] && response[0].msgid === -1) {
                // There was an error, and it should be translated already.
                return Promise.reject(_this.utils.createFakeWSError(response[0].errormessage));
            }
            return _this.invalidateDiscussionCache(toUserId, siteId).catch(function () {
                // Ignore errors.
            }).then(function () {
                return response[0];
            });
        });
    };
    /**
     * Send some messages. It will fail if offline or cannot connect.
     * IMPORTANT: Sending several messages at once for the same discussions can cause problems with display order,
     * since messages with same timecreated aren't ordered by ID.
     *
     * @param  {any} messages Messages to send. Each message must contain touserid, text and textformat.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if success, rejected if failure. Promise resolved doesn't mean that messages
     *                           have been sent, the resolve param can contain errors for messages not sent.
     */
    AddonMessagesProvider.prototype.sendMessagesOnline = function (messages, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                messages: messages
            };
            return site.write('core_message_send_instant_messages', data);
        });
    };
    /**
     * Send a message to a conversation.
     *
     * @param {any} conversation Conversation.
     * @param {string} message The message to send.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with:
     *                                - sent (boolean) True if message was sent to server, false if stored in device.
     *                                - message (any) If sent=false, contains the stored message.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.sendMessageToConversation = function (conversation, message, siteId) {
        var _this = this;
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.messagesOffline.saveConversationMessage(conversation, message, siteId).then(function (entry) {
                return {
                    sent: false,
                    message: entry
                };
            });
        };
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!this.appProvider.isOnline()) {
            // App is offline, store the message.
            return storeOffline();
        }
        // Check if this conversation already has offline messages.
        // If so, store this message since they need to be sent in order.
        return this.messagesOffline.hasConversationMessages(conversation.id, siteId).catch(function () {
            // Error, it's safer to assume it has messages.
            return true;
        }).then(function (hasStoredMessages) {
            if (hasStoredMessages) {
                return storeOffline();
            }
            // Online and no messages stored. Send it to server.
            return _this.sendMessageToConversationOnline(conversation.id, message).then(function (result) {
                return {
                    sent: true,
                    message: result
                };
            }).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // It's a WebService error, the user cannot send the message so don't store it.
                    return Promise.reject(error);
                }
                // Error sending message, store it to retry later.
                return storeOffline();
            });
        });
    };
    /**
     * Send a message to a conversation. It will fail if offline or cannot connect.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} message The message to send
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success, rejected if failure.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.sendMessageToConversationOnline = function (conversationId, message, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var messages = [
            {
                text: message,
                textformat: 1
            }
        ];
        return this.sendMessagesToConversationOnline(conversationId, messages, siteId).then(function (response) {
            return _this.invalidateConversationMessages(conversationId, siteId).catch(function () {
                // Ignore errors.
            }).then(function () {
                return response[0];
            });
        });
    };
    /**
     * Send some messages to a conversation. It will fail if offline or cannot connect.
     *
     * @param {number} conversationId Conversation ID.
     * @param {any} messages Messages to send. Each message must contain text and, optionally, textformat.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success, rejected if failure.
     * @since 3.6
     */
    AddonMessagesProvider.prototype.sendMessagesToConversationOnline = function (conversationId, messages, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                conversationid: conversationId,
                messages: messages.map(function (message) {
                    return {
                        text: message.text,
                        textformat: typeof message.textformat != 'undefined' ? message.textformat : 1
                    };
                })
            };
            return site.write('core_message_send_messages_to_conversation', params);
        });
    };
    /**
     * Set or unset a conversation as favourite.
     *
     * @param {number} conversationId Conversation ID.
     * @param {boolean} set Whether to set or unset it as favourite.
     * @param {string} [siteId]  Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>}  Resolved when done.
     */
    AddonMessagesProvider.prototype.setFavouriteConversation = function (conversationId, set, siteId, userId) {
        return this.setFavouriteConversations([conversationId], set, siteId, userId);
    };
    /**
     * Set or unset some conversations as favourites.
     *
     * @param {number[]} conversations Conversation IDs.
     * @param {boolean} set Whether to set or unset them as favourites.
     * @param {string} [siteId]  Site ID. If not defined, use current site.
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @return {Promise<any>}  Resolved when done.
     */
    AddonMessagesProvider.prototype.setFavouriteConversations = function (conversations, set, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                userid: userId,
                conversations: conversations
            }, wsName = set ? 'core_message_set_favourite_conversations' : 'core_message_unset_favourite_conversations';
            return site.write(wsName, params).then(function () {
                // Invalidate the conversations data.
                var promises = [];
                conversations.forEach(function (conversationId) {
                    promises.push(_this.invalidateConversation(conversationId, site.getId(), userId));
                });
                return Promise.all(promises).catch(function () {
                    // Ignore errors.
                });
            });
        });
    };
    /**
     * Helper method to sort conversations by last message time.
     *
     * @param {any[]} conversations Array of conversations.
     * @return {any[]} Conversations sorted with most recent last.
     */
    AddonMessagesProvider.prototype.sortConversations = function (conversations) {
        return conversations.sort(function (a, b) {
            var timeA = parseInt(a.lastmessagedate, 10), timeB = parseInt(b.lastmessagedate, 10);
            if (timeA == timeB && a.id) {
                // Same time, sort by ID.
                return a.id <= b.id ? 1 : -1;
            }
            return timeA <= timeB ? 1 : -1;
        });
    };
    /**
     * Helper method to sort messages by time.
     *
     * @param {any[]} messages Array of messages containing the key 'timecreated'.
     * @return {any[]} Messages sorted with most recent last.
     */
    AddonMessagesProvider.prototype.sortMessages = function (messages) {
        return messages.sort(function (a, b) {
            // Pending messages last.
            if (a.pending && !b.pending) {
                return 1;
            }
            else if (!a.pending && b.pending) {
                return -1;
            }
            var timecreatedA = parseInt(a.timecreated, 10), timecreatedB = parseInt(b.timecreated, 10);
            if (timecreatedA == timecreatedB && a.id) {
                // Same time, sort by ID.
                return a.id >= b.id ? 1 : -1;
            }
            return timecreatedA >= timecreatedB ? 1 : -1;
        });
    };
    /**
     * Store the last received message if it's newer than the last stored.
     *
     * @param  {number} convIdOrUserIdFrom Conversation ID (3.6+) or ID of the useridfrom retrieved (3.5-), 0 for all users.
     * @param  {any} message       Last message received.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when done.
     */
    AddonMessagesProvider.prototype.storeLastReceivedMessageIfNeeded = function (convIdOrUserIdFrom, message, siteId) {
        var _this = this;
        var component = AddonMessagesProvider_1.PUSH_SIMULATION_COMPONENT;
        // Get the last received message.
        return this.emulatorHelper.getLastReceivedNotification(component, siteId).then(function (lastMessage) {
            if (convIdOrUserIdFrom > 0 && (!message || !lastMessage)) {
                // Seeing a single discussion. No received message or cannot know if it really is the last received message. Stop.
                return;
            }
            if (message && lastMessage && message.timecreated <= lastMessage.timecreated) {
                // The message isn't newer than the stored message, don't store it.
                return;
            }
            return _this.emulatorHelper.storeLastReceivedNotification(component, message, siteId);
        });
    };
    /**
     * Store user data from contacts in local DB.
     *
     * @param {any} contactTypes List of contacts grouped in types.
     */
    AddonMessagesProvider.prototype.storeUsersFromAllContacts = function (contactTypes) {
        for (var x in contactTypes) {
            this.userProvider.storeUsers(contactTypes[x]);
        }
    };
    /**
     * Store user data from discussions in local DB.
     *
     * @param {any} discussions List of discussions.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    AddonMessagesProvider.prototype.storeUsersFromDiscussions = function (discussions, siteId) {
        var users = [];
        for (var userId in discussions) {
            users.push({
                id: userId,
                fullname: discussions[userId].fullname,
                profileimageurl: discussions[userId].profileimageurl
            });
        }
        this.userProvider.storeUsers(users, siteId);
    };
    /**
     * Unblock a user.
     *
     * @param {number} userId User ID of the person to unblock.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Resolved when done.
     */
    AddonMessagesProvider.prototype.unblockContact = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promise;
            if (site.wsAvailable('core_message_unblock_user')) {
                // Since Moodle 3.6
                var params = {
                    userid: site.getUserId(),
                    unblockeduserid: userId,
                };
                promise = site.write('core_message_unblock_user', params);
            }
            else {
                var params = {
                    userids: [userId]
                };
                var preSets = {
                    responseExpected: false
                };
                promise = site.write('core_message_unblock_contacts', params, preSets);
            }
            return promise.then(function () {
                return _this.invalidateAllMemberInfo(userId, site).finally(function () {
                    var data = { userId: userId, userUnblocked: true };
                    _this.eventsProvider.trigger(AddonMessagesProvider_1.MEMBER_INFO_CHANGED_EVENT, data, site.id);
                });
            });
        });
    };
    AddonMessagesProvider.NEW_MESSAGE_EVENT = 'addon_messages_new_message_event';
    AddonMessagesProvider.READ_CHANGED_EVENT = 'addon_messages_read_changed_event';
    AddonMessagesProvider.OPEN_CONVERSATION_EVENT = 'addon_messages_open_conversation_event'; // Notify that a conversation should be opened.
    AddonMessagesProvider.SPLIT_VIEW_LOAD_EVENT = 'addon_messages_split_view_load_event';
    AddonMessagesProvider.UPDATE_CONVERSATION_LIST_EVENT = 'addon_messages_update_conversation_list_event';
    AddonMessagesProvider.MEMBER_INFO_CHANGED_EVENT = 'addon_messages_member_changed_event';
    AddonMessagesProvider.UNREAD_CONVERSATION_COUNTS_EVENT = 'addon_messages_unread_conversation_counts_event';
    AddonMessagesProvider.CONTACT_REQUESTS_COUNT_EVENT = 'addon_messages_contact_requests_count_event';
    AddonMessagesProvider.POLL_INTERVAL = 10000;
    AddonMessagesProvider.PUSH_SIMULATION_COMPONENT = 'AddonMessagesPushSimulation';
    AddonMessagesProvider.MESSAGE_PRIVACY_COURSEMEMBER = 0; // Privacy setting for being messaged by anyone within courses user is member of.
    AddonMessagesProvider.MESSAGE_PRIVACY_ONLYCONTACTS = 1; // Privacy setting for being messaged only by contacts.
    AddonMessagesProvider.MESSAGE_PRIVACY_SITE = 2; // Privacy setting for being messaged by anyone on the site.
    AddonMessagesProvider.MESSAGE_CONVERSATION_TYPE_INDIVIDUAL = 1; // An individual conversation.
    AddonMessagesProvider.MESSAGE_CONVERSATION_TYPE_GROUP = 2; // A group conversation.
    AddonMessagesProvider.MESSAGE_CONVERSATION_TYPE_SELF = 3; // A self conversation.
    AddonMessagesProvider.LIMIT_CONTACTS = 50;
    AddonMessagesProvider.LIMIT_MESSAGES = 50;
    AddonMessagesProvider.LIMIT_INITIAL_USER_SEARCH = 3;
    AddonMessagesProvider.LIMIT_SEARCH = 50;
    AddonMessagesProvider.NOTIFICATION_PREFERENCES_KEY = 'message_provider_moodle_instantmessage';
    AddonMessagesProvider = AddonMessagesProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_5__messages_offline__["a" /* AddonMessagesOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_emulator_providers_helper__["a" /* CoreEmulatorHelperProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_events__["a" /* CoreEventsProvider */]])
    ], AddonMessagesProvider);
    return AddonMessagesProvider;
    var AddonMessagesProvider_1;
}());

//# sourceMappingURL=messages.js.map

/***/ }),
/* 92 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLocalNotificationsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_local_notifications__ = __webpack_require__(255);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_push__ = __webpack_require__(254);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_13_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/*
 * Generated class for the LocalNotificationsProvider provider.
 *
 * See https://angular.io/guide/dependency-injection for more info on providers
 * and Angular DI.
*/
var CoreLocalNotificationsProvider = /** @class */ (function () {
    function CoreLocalNotificationsProvider(logger, localNotifications, platform, appProvider, utils, configProvider, textUtils, translate, alertCtrl, eventsProvider, push, zone) {
        var _this = this;
        this.localNotifications = localNotifications;
        this.platform = platform;
        this.appProvider = appProvider;
        this.utils = utils;
        this.configProvider = configProvider;
        this.textUtils = textUtils;
        this.translate = translate;
        this.alertCtrl = alertCtrl;
        this.push = push;
        this.zone = zone;
        // Variables for the database.
        this.SITES_TABLE = 'notification_sites'; // Store to asigne unique codes to each site.
        this.COMPONENTS_TABLE = 'notification_components'; // Store to asigne unique codes to each component.
        this.TRIGGERED_TABLE = 'notifications_triggered'; // Store to prevent re-triggering notifications.
        this.tablesSchema = [
            {
                name: this.SITES_TABLE,
                columns: [
                    {
                        name: 'id',
                        type: 'TEXT',
                        primaryKey: true
                    },
                    {
                        name: 'code',
                        type: 'INTEGER',
                        notNull: true
                    }
                ]
            },
            {
                name: this.COMPONENTS_TABLE,
                columns: [
                    {
                        name: 'id',
                        type: 'TEXT',
                        primaryKey: true
                    },
                    {
                        name: 'code',
                        type: 'INTEGER',
                        notNull: true
                    }
                ]
            },
            {
                name: this.TRIGGERED_TABLE,
                columns: [
                    {
                        name: 'id',
                        type: 'INTEGER',
                        primaryKey: true
                    },
                    {
                        name: 'at',
                        type: 'INTEGER',
                        notNull: true
                    }
                ]
            }
        ];
        this.codes = {};
        this.codeRequestsQueue = {};
        this.observables = {};
        this.currentNotification = {
            title: '',
            texts: [],
            ids: [],
            timeouts: []
        };
        this.logger = logger.getInstance('CoreLocalNotificationsProvider');
        this.appDB = appProvider.getDB();
        this.appDB.createTablesFromSchema(this.tablesSchema);
        platform.ready().then(function () {
            // Listen to events.
            _this.triggerSubscription = localNotifications.on('trigger').subscribe(function (notification) {
                _this.trigger(notification);
                _this.handleEvent('trigger', notification);
            });
            _this.clickSubscription = localNotifications.on('click').subscribe(function (notification) {
                _this.handleEvent('click', notification);
            });
            _this.clearSubscription = localNotifications.on('clear').subscribe(function (notification) {
                _this.handleEvent('clear', notification);
            });
            _this.cancelSubscription = localNotifications.on('cancel').subscribe(function (notification) {
                _this.handleEvent('cancel', notification);
            });
            _this.addSubscription = localNotifications.on('schedule').subscribe(function (notification) {
                _this.handleEvent('schedule', notification);
            });
            _this.updateSubscription = localNotifications.on('update').subscribe(function (notification) {
                _this.handleEvent('update', notification);
            });
            // Create the default channel for local notifications.
            _this.createDefaultChannel();
            translate.onLangChange.subscribe(function (event) {
                // Update the channel name.
                _this.createDefaultChannel();
            });
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__events__["a" /* CoreEventsProvider */].SITE_DELETED, function (site) {
            if (site) {
                _this.cancelSiteNotifications(site.id);
            }
        });
    }
    /**
     * Cancel a local notification.
     *
     * @param {number} id Notification id.
     * @param {string} component Component of the notification.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when the notification is cancelled.
     */
    CoreLocalNotificationsProvider.prototype.cancel = function (id, component, siteId) {
        var _this = this;
        return this.getUniqueNotificationId(id, component, siteId).then(function (uniqueId) {
            return _this.localNotifications.cancel(uniqueId);
        });
    };
    /**
     * Cancel all the scheduled notifications belonging to a certain site.
     *
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when the notifications are cancelled.
     */
    CoreLocalNotificationsProvider.prototype.cancelSiteNotifications = function (siteId) {
        var _this = this;
        if (!this.isAvailable()) {
            return Promise.resolve();
        }
        else if (!siteId) {
            return Promise.reject(null);
        }
        return this.localNotifications.getScheduled().then(function (scheduled) {
            var ids = [];
            scheduled.forEach(function (notif) {
                if (typeof notif.data == 'string') {
                    notif.data = _this.textUtils.parseJSON(notif.data);
                }
                if (typeof notif.data == 'object' && notif.data.siteId === siteId) {
                    ids.push(notif.id);
                }
            });
            return _this.localNotifications.cancel(ids);
        });
    };
    /**
     * Check whether sound can be disabled for notifications.
     *
     * @return {boolean} Whether sound can be disabled for notifications.
     */
    CoreLocalNotificationsProvider.prototype.canDisableSound = function () {
        // Only allow disabling sound in Android 7 or lower. In iOS and Android 8+ it can easily be done with system settings.
        return this.isAvailable() && !this.appProvider.isDesktop() && this.platform.is('android') &&
            this.platform.version().major < 8;
    };
    /**
     * Create the default channel. It is used to change the name.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLocalNotificationsProvider.prototype.createDefaultChannel = function () {
        var _this = this;
        if (!this.platform.is('android')) {
            return Promise.resolve();
        }
        return this.push.createChannel({
            id: 'default-channel-id',
            description: this.translate.instant('addon.calendar.calendarreminders'),
            importance: 4
        }).catch(function (error) {
            _this.logger.error('Error changing channel name', error);
        });
    };
    /**
     * Get a code to create unique notifications. If there's no code assigned, create a new one.
     *
     * @param {string} table Table to search in local DB.
     * @param {string} id ID of the element to get its code.
     * @return {Promise<number>} Promise resolved when the code is retrieved.
     */
    CoreLocalNotificationsProvider.prototype.getCode = function (table, id) {
        var _this = this;
        var key = table + '#' + id;
        // Check if the code is already in memory.
        if (typeof this.codes[key] != 'undefined') {
            return Promise.resolve(this.codes[key]);
        }
        // Check if we already have a code stored for that ID.
        return this.appDB.getRecord(table, { id: id }).then(function (entry) {
            _this.codes[key] = entry.code;
            return entry.code;
        }).catch(function () {
            // No code stored for that ID. Create a new code for it.
            return _this.appDB.getRecords(table, undefined, 'code DESC').then(function (entries) {
                var newCode = 0;
                if (entries.length > 0) {
                    newCode = entries[0].code + 1;
                }
                return _this.appDB.insertRecord(table, { id: id, code: newCode }).then(function () {
                    _this.codes[key] = newCode;
                    return newCode;
                });
            });
        });
    };
    /**
     * Get a notification component code to be used.
     * If it's the first time this component is used to send notifications, create a new code for it.
     *
     * @param {string} component Component name.
     * @return {Promise<number>} Promise resolved when the component code is retrieved.
     */
    CoreLocalNotificationsProvider.prototype.getComponentCode = function (component) {
        return this.requestCode(this.COMPONENTS_TABLE, component);
    };
    /**
     * Get a site code to be used.
     * If it's the first time this site is used to send notifications, create a new code for it.
     *
     * @param {string} siteId Site ID.
     * @return {Promise<number>} Promise resolved when the site code is retrieved.
     */
    CoreLocalNotificationsProvider.prototype.getSiteCode = function (siteId) {
        return this.requestCode(this.SITES_TABLE, siteId);
    };
    /**
     * Create a unique notification ID, trying to prevent collisions. Generated ID must be a Number (Android).
     * The generated ID shouldn't be higher than 2147483647 or it's going to cause problems in Android.
     * This function will prevent collisions and keep the number under Android limit if:
     *     -User has used less than 21 sites.
     *     -There are less than 11 components.
     *     -The notificationId passed as parameter is lower than 10000000.
     *
     * @param {number} notificationId Notification ID.
     * @param {string} component Component triggering the notification.
     * @param {string} siteId Site ID.
     * @return {Promise<number>} Promise resolved when the notification ID is generated.
     */
    CoreLocalNotificationsProvider.prototype.getUniqueNotificationId = function (notificationId, component, siteId) {
        var _this = this;
        if (!siteId || !component) {
            return Promise.reject(null);
        }
        return this.getSiteCode(siteId).then(function (siteCode) {
            return _this.getComponentCode(component).then(function (componentCode) {
                // We use the % operation to keep the number under Android's limit.
                return (siteCode * 100000000 + componentCode * 10000000 + notificationId) % 2147483647;
            });
        });
    };
    /**
     * Handle an event triggered by the local notifications plugin.
     *
     * @param {string} eventName Name of the event.
     * @param {any} notification Notification.
     */
    CoreLocalNotificationsProvider.prototype.handleEvent = function (eventName, notification) {
        if (notification && notification.data) {
            this.logger.debug('Notification event: ' + eventName + '. Data:', notification.data);
            this.notifyEvent(eventName, notification.data);
        }
    };
    /**
     * Returns whether local notifications plugin is installed.
     *
     * @return {boolean} Whether local notifications plugin is installed.
     */
    CoreLocalNotificationsProvider.prototype.isAvailable = function () {
        var win = window;
        return this.appProvider.isDesktop() || !!(win.cordova && win.cordova.plugins && win.cordova.plugins.notification &&
            win.cordova.plugins.notification.local);
    };
    /**
     * Check if a notification has been triggered with the same trigger time.
     *
     * @param {ILocalNotification} notification Notification to check.
     * @return {Promise<any>} Promise resolved with a boolean indicating if promise is triggered (true) or not.
     */
    CoreLocalNotificationsProvider.prototype.isTriggered = function (notification) {
        var _this = this;
        return this.appDB.getRecord(this.TRIGGERED_TABLE, { id: notification.id }).then(function (stored) {
            var triggered = (notification.trigger && notification.trigger.at) || 0;
            if (typeof triggered != 'number') {
                triggered = triggered.getTime();
            }
            return stored.at === triggered;
        }).catch(function () {
            return _this.localNotifications.isTriggered(notification.id);
        });
    };
    /**
     * Notify notification click to observers. Only the observers with the same component as the notification will be notified.
     *
     * @param {any} data Data received by the notification.
     */
    CoreLocalNotificationsProvider.prototype.notifyClick = function (data) {
        this.notifyEvent('click', data);
    };
    /**
     * Notify a certain event to observers. Only the observers with the same component as the notification will be notified.
     *
     * @param {string} eventName Name of the event to notify.
     * @param {any} data Data received by the notification.
     */
    CoreLocalNotificationsProvider.prototype.notifyEvent = function (eventName, data) {
        var _this = this;
        // Execute the code in the Angular zone, so change detection doesn't stop working.
        this.zone.run(function () {
            var component = data.component;
            if (component) {
                if (_this.observables[eventName] && _this.observables[eventName][component]) {
                    _this.observables[eventName][component].next(data);
                }
            }
        });
    };
    /**
     * Process the next request in queue.
     */
    CoreLocalNotificationsProvider.prototype.processNextRequest = function () {
        var _this = this;
        var nextKey = Object.keys(this.codeRequestsQueue)[0];
        var request, promise;
        if (typeof nextKey == 'undefined') {
            // No more requests in queue, stop.
            return;
        }
        request = this.codeRequestsQueue[nextKey];
        // Check if request is valid.
        if (typeof request == 'object' && typeof request.table != 'undefined' && typeof request.id != 'undefined') {
            // Get the code and resolve/reject all the promises of this request.
            promise = this.getCode(request.table, request.id).then(function (code) {
                request.promises.forEach(function (p) {
                    p.resolve(code);
                });
            }).catch(function (error) {
                request.promises.forEach(function (p) {
                    p.reject(error);
                });
            });
        }
        else {
            promise = Promise.resolve();
        }
        // Once this item is treated, remove it and process next.
        promise.finally(function () {
            delete _this.codeRequestsQueue[nextKey];
            _this.processNextRequest();
        });
    };
    /**
     * Register an observer to be notified when a notification belonging to a certain component is clicked.
     *
     * @param {string} component Component to listen notifications for.
     * @param {Function} callback Function to call with the data received by the notification.
     * @return {any} Object with an "off" property to stop listening for clicks.
     */
    CoreLocalNotificationsProvider.prototype.registerClick = function (component, callback) {
        return this.registerObserver('click', component, callback);
    };
    /**
     * Register an observer to be notified when a certain event is fired for a notification belonging to a certain component.
     *
     * @param {string} eventName Name of the event to listen to.
     * @param {string} component Component to listen notifications for.
     * @param {Function} callback Function to call with the data received by the notification.
     * @return {any} Object with an "off" property to stop listening for events.
     */
    CoreLocalNotificationsProvider.prototype.registerObserver = function (eventName, component, callback) {
        var _this = this;
        this.logger.debug("Register observer '" + component + "' for event '" + eventName + "'.");
        if (typeof this.observables[eventName] == 'undefined') {
            this.observables[eventName] = {};
        }
        if (typeof this.observables[eventName][component] == 'undefined') {
            // No observable for this component, create a new one.
            this.observables[eventName][component] = new __WEBPACK_IMPORTED_MODULE_13_rxjs__["Subject"]();
        }
        this.observables[eventName][component].subscribe(callback);
        return {
            off: function () {
                _this.observables[eventName][component].unsubscribe(callback);
            }
        };
    };
    /**
     * Remove a notification from triggered store.
     *
     * @param {number} id Notification ID.
     * @return {Promise<any>} Promise resolved when it is removed.
     */
    CoreLocalNotificationsProvider.prototype.removeTriggered = function (id) {
        return this.appDB.deleteRecords(this.TRIGGERED_TABLE, { id: id });
    };
    /**
     * Request a unique code. The request will be added to the queue and the queue is going to be started if it's paused.
     *
     * @param {string} table Table to search in local DB.
     * @param {string} id ID of the element to get its code.
     * @return {Promise}      Promise resolved when the code is retrieved.
     */
    CoreLocalNotificationsProvider.prototype.requestCode = function (table, id) {
        var deferred = this.utils.promiseDefer(), key = table + '#' + id, isQueueEmpty = Object.keys(this.codeRequestsQueue).length == 0;
        if (typeof this.codeRequestsQueue[key] != 'undefined') {
            // There's already a pending request for this store and ID, add the promise to it.
            this.codeRequestsQueue[key].promises.push(deferred);
        }
        else {
            // Add a pending request to the queue.
            this.codeRequestsQueue[key] = {
                table: table,
                id: id,
                promises: [deferred]
            };
        }
        if (isQueueEmpty) {
            this.processNextRequest();
        }
        return deferred.promise;
    };
    /**
     * Reschedule all notifications that are already scheduled.
     *
     * @return {Promise<any>} Promise resolved when all notifications have been rescheduled.
     */
    CoreLocalNotificationsProvider.prototype.rescheduleAll = function () {
        var _this = this;
        // Get all the scheduled notifications.
        return this.localNotifications.getScheduled().then(function (notifications) {
            var promises = [];
            notifications.forEach(function (notification) {
                // Convert some properties to the needed types.
                notification.data = notification.data ? _this.textUtils.parseJSON(notification.data, {}) : {};
                promises.push(_this.scheduleNotification(notification));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Schedule a local notification.
     *
     * @param {ILocalNotification} notification Notification to schedule. Its ID should be lower than 10000000 and it should
     *                                          be unique inside its component and site.
     * @param {string} component Component triggering the notification. It is used to generate unique IDs.
     * @param {string} siteId Site ID.
     * @param {boolean} [alreadyUnique] Whether the ID is already unique.
     * @return {Promise<any>} Promise resolved when the notification is scheduled.
     */
    CoreLocalNotificationsProvider.prototype.schedule = function (notification, component, siteId, alreadyUnique) {
        var _this = this;
        var promise;
        if (alreadyUnique) {
            promise = Promise.resolve(notification.id);
        }
        else {
            promise = this.getUniqueNotificationId(notification.id, component, siteId);
        }
        return promise.then(function (uniqueId) {
            notification.id = uniqueId;
            notification.data = notification.data || {};
            notification.data.component = component;
            notification.data.siteId = siteId;
            if (_this.platform.is('android')) {
                notification.icon = notification.icon || 'res://icon';
                notification.smallIcon = notification.smallIcon || 'res://smallicon';
                notification.color = notification.color || __WEBPACK_IMPORTED_MODULE_12__configconstants__["a" /* CoreConfigConstants */].notificoncolor;
                var led = notification.led || {};
                notification.led = {
                    color: led.color || 'FF9900',
                    on: led.on || 1000,
                    off: led.off || 1000
                };
            }
            return _this.scheduleNotification(notification);
        });
    };
    /**
     * Helper function to schedule a notification object if it hasn't been triggered already.
     *
     * @param {ILocalNotification} notification Notification to schedule.
     * @return {Promise<any>} Promise resolved when scheduled.
     */
    CoreLocalNotificationsProvider.prototype.scheduleNotification = function (notification) {
        var _this = this;
        // Check if the notification has been triggered already.
        return this.isTriggered(notification).then(function (triggered) {
            // Cancel the current notification in case it gets scheduled twice.
            return _this.localNotifications.cancel(notification.id).finally(function () {
                if (!triggered) {
                    // Check if sound is enabled for notifications.
                    var promise = void 0;
                    if (_this.canDisableSound()) {
                        promise = _this.configProvider.get(__WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].SETTINGS_NOTIFICATION_SOUND, true);
                    }
                    else {
                        promise = Promise.resolve(true);
                    }
                    return promise.then(function (soundEnabled) {
                        if (!soundEnabled) {
                            notification.sound = null;
                        }
                        else {
                            delete notification.sound; // Use default value.
                        }
                        notification.foreground = true;
                        // Remove from triggered, since the notification could be in there with a different time.
                        _this.removeTriggered(notification.id);
                        _this.localNotifications.schedule(notification);
                    });
                }
            });
        });
    };
    /**
     * Show an in app notification popover.
     * This function was used because local notifications weren't displayed when the app was in foreground in iOS10+,
     * but the issue was fixed in the plugin and this function is no longer used.
     *
     * @param {ILocalNotification} notification Notification.
     */
    CoreLocalNotificationsProvider.prototype.showNotificationPopover = function (notification) {
        var _this = this;
        if (!notification || !notification.title || !notification.text) {
            // Invalid data.
            return;
        }
        var clearAlert = function (all) {
            if (all === void 0) { all = false; }
            // Only erase first notification.
            if (!all && _this.alertNotification && _this.currentNotification.ids.length > 1) {
                _this.currentNotification.texts.shift();
                _this.currentNotification.ids.shift();
                clearTimeout(_this.currentNotification.timeouts.shift());
                var text_1 = '<p>' + _this.currentNotification.texts.join('</p><p>') + '</p>';
                _this.alertNotification.setMessage(text_1);
            }
            else {
                // Close the alert and reset the current object.
                if (_this.alertNotification && !all) {
                    _this.alertNotification.dismiss();
                }
                _this.alertNotification = null;
                _this.currentNotification.title = '';
                _this.currentNotification.texts = [];
                _this.currentNotification.ids = [];
                _this.currentNotification.timeouts.forEach(function (time) {
                    clearTimeout(time);
                });
                _this.currentNotification.timeouts = [];
            }
        };
        if (this.alertNotification && this.currentNotification.title == notification.title) {
            if (this.currentNotification.ids.indexOf(notification.id) != -1) {
                // Notification already shown, don't show it again, just renew the timeout.
                return;
            }
            // Same title and the notification is shown, update it.
            this.currentNotification.texts.push(notification.text);
            this.currentNotification.ids.push(notification.id);
            if (this.currentNotification.texts.length > 3) {
                this.currentNotification.texts.shift();
                this.currentNotification.ids.shift();
                clearTimeout(this.currentNotification.timeouts.shift());
            }
        }
        else {
            this.currentNotification.timeouts.forEach(function (time) {
                clearTimeout(time);
            });
            this.currentNotification.timeouts = [];
            // Not shown or title is different, set new data.
            this.currentNotification.title = notification.title;
            this.currentNotification.texts = [notification.text];
            this.currentNotification.ids = [notification.id];
        }
        var text = '<p>' + this.currentNotification.texts.join('</p><p>') + '</p>';
        if (this.alertNotification) {
            this.alertNotification.setTitle(this.currentNotification.title);
            this.alertNotification.setMessage(text);
        }
        else {
            this.alertNotification = this.alertCtrl.create({
                title: this.currentNotification.title,
                message: text,
                cssClass: 'core-inapp-notification',
                enableBackdropDismiss: false,
                buttons: [{
                        text: this.translate.instant('core.dismiss'),
                        role: 'cancel',
                        handler: function () {
                            clearAlert(true);
                        }
                    }]
            });
        }
        this.alertNotification.present();
        this.currentNotification.timeouts.push(setTimeout(function () {
            clearAlert();
        }, 4000));
    };
    /**
     * Function to call when a notification is triggered. Stores the notification so it's not scheduled again unless the
     * time is changed.
     *
     * @param {ILocalNotification} notification Triggered notification.
     * @return {Promise<any>} Promise resolved when stored, rejected otherwise.
     */
    CoreLocalNotificationsProvider.prototype.trigger = function (notification) {
        var entry = {
            id: notification.id,
            at: notification.trigger && notification.trigger.at ? notification.trigger.at : Date.now()
        };
        return this.appDB.insertRecord(this.TRIGGERED_TABLE, entry);
    };
    /**
     * Update a component name.
     *
     * @param {string} oldName The old name.
     * @param {string}  newName The new name.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLocalNotificationsProvider.prototype.updateComponentName = function (oldName, newName) {
        var oldId = this.COMPONENTS_TABLE + '#' + oldName, newId = this.COMPONENTS_TABLE + '#' + newName;
        return this.appDB.updateRecords(this.COMPONENTS_TABLE, { id: newId }, { id: oldId });
    };
    CoreLocalNotificationsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__ionic_native_local_notifications__["a" /* LocalNotifications */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_5__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_10__utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__config__["a" /* CoreConfigProvider */],
            __WEBPACK_IMPORTED_MODULE_9__utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_7__events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_3__ionic_native_push__["a" /* Push */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"]])
    ], CoreLocalNotificationsProvider);
    return CoreLocalNotificationsProvider;
}());

//# sourceMappingURL=local-notifications.js.map

/***/ }),
/* 93 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Service to handle offline assign.
 */
var AddonModAssignOfflineProvider = /** @class */ (function () {
    function AddonModAssignOfflineProvider(logger, sitesProvider, textUtils, fileProvider, timeUtils) {
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.fileProvider = fileProvider;
        this.timeUtils = timeUtils;
        this.siteSchema = {
            name: 'AddonModAssignOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModAssignOfflineProvider_1.SUBMISSIONS_TABLE,
                    columns: [
                        {
                            name: 'assignid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'plugindata',
                            type: 'TEXT'
                        },
                        {
                            name: 'onlinetimemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'submitted',
                            type: 'INTEGER'
                        },
                        {
                            name: 'submissionstatement',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['assignid', 'userid']
                },
                {
                    name: AddonModAssignOfflineProvider_1.SUBMISSIONS_GRADES_TABLE,
                    columns: [
                        {
                            name: 'assignid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'grade',
                            type: 'REAL'
                        },
                        {
                            name: 'attemptnumber',
                            type: 'INTEGER'
                        },
                        {
                            name: 'addattempt',
                            type: 'INTEGER'
                        },
                        {
                            name: 'workflowstate',
                            type: 'TEXT'
                        },
                        {
                            name: 'applytoall',
                            type: 'INTEGER'
                        },
                        {
                            name: 'outcomes',
                            type: 'TEXT'
                        },
                        {
                            name: 'plugindata',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['assignid', 'userid']
                }
            ]
        };
        this.logger = logger.getInstance('AddonModAssignOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModAssignOfflineProvider_1 = AddonModAssignOfflineProvider;
    /**
     * Delete a submission.
     *
     * @param {number} assignId Assignment ID.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if deleted, rejected if failure.
     */
    AddonModAssignOfflineProvider.prototype.deleteSubmission = function (assignId, userId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().deleteRecords(AddonModAssignOfflineProvider_1.SUBMISSIONS_TABLE, { assignid: assignId, userid: userId });
        });
    };
    /**
     * Delete a submission grade.
     *
     * @param {number} assignId Assignment ID.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if deleted, rejected if failure.
     */
    AddonModAssignOfflineProvider.prototype.deleteSubmissionGrade = function (assignId, userId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().deleteRecords(AddonModAssignOfflineProvider_1.SUBMISSIONS_GRADES_TABLE, { assignid: assignId, userid: userId });
        });
    };
    /**
     * Get all the assignments ids that have something to be synced.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number[]>} Promise resolved with assignments id that have something to be synced.
     */
    AddonModAssignOfflineProvider.prototype.getAllAssigns = function (siteId) {
        var promises = [];
        promises.push(this.getAllSubmissions(siteId));
        promises.push(this.getAllSubmissionsGrade(siteId));
        return Promise.all(promises).then(function (results) {
            // Flatten array.
            results = [].concat.apply([], results);
            // Get assign id.
            results = results.map(function (object) {
                return object.assignid;
            });
            // Get unique values.
            results = results.filter(function (id, pos) {
                return results.indexOf(id) == pos;
            });
            return results;
        });
    };
    /**
     * Get all the stored submissions from all the assignments.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]} Promise resolved with submissions.
     */
    AddonModAssignOfflineProvider.prototype.getAllSubmissions = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getAllRecords(AddonModAssignOfflineProvider_1.SUBMISSIONS_TABLE);
        }).then(function (submissions) {
            // Parse the plugin data.
            submissions.forEach(function (submission) {
                submission.plugindata = _this.textUtils.parseJSON(submission.plugindata, {});
            });
            return submissions;
        });
    };
    /**
     * Get all the stored submissions grades from all the assignments.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with submissions grades.
     */
    AddonModAssignOfflineProvider.prototype.getAllSubmissionsGrade = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getAllRecords(AddonModAssignOfflineProvider_1.SUBMISSIONS_GRADES_TABLE);
        }).then(function (submissions) {
            // Parse the plugin data and outcomes.
            submissions.forEach(function (submission) {
                submission.outcomes = _this.textUtils.parseJSON(submission.outcomes, {});
                submission.plugindata = _this.textUtils.parseJSON(submission.plugindata, {});
            });
            return submissions;
        });
    };
    /**
     * Get all the stored submissions for a certain assignment.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with submissions.
     */
    AddonModAssignOfflineProvider.prototype.getAssignSubmissions = function (assignId, siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getRecords(AddonModAssignOfflineProvider_1.SUBMISSIONS_TABLE, { assignid: assignId });
        }).then(function (submissions) {
            // Parse the plugin data.
            submissions.forEach(function (submission) {
                submission.plugindata = _this.textUtils.parseJSON(submission.plugindata, {});
            });
            return submissions;
        });
    };
    /**
     * Get all the stored submissions grades for a certain assignment.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with submissions grades.
     */
    AddonModAssignOfflineProvider.prototype.getAssignSubmissionsGrade = function (assignId, siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getRecords(AddonModAssignOfflineProvider_1.SUBMISSIONS_GRADES_TABLE, { assignid: assignId });
        }).then(function (submissions) {
            // Parse the plugin data and outcomes.
            submissions.forEach(function (submission) {
                submission.outcomes = _this.textUtils.parseJSON(submission.outcomes, {});
                submission.plugindata = _this.textUtils.parseJSON(submission.plugindata, {});
            });
            return submissions;
        });
    };
    /**
     * Get a stored submission.
     *
     * @param {number} assignId Assignment ID.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with submission.
     */
    AddonModAssignOfflineProvider.prototype.getSubmission = function (assignId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().getRecord(AddonModAssignOfflineProvider_1.SUBMISSIONS_TABLE, { assignid: assignId, userid: userId });
        }).then(function (submission) {
            // Parse the plugin data.
            submission.plugindata = _this.textUtils.parseJSON(submission.plugindata, {});
            return submission;
        });
    };
    /**
     * Get the path to the folder where to store files for an offline submission.
     *
     * @param {number} assignId Assignment ID.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the path.
     */
    AddonModAssignOfflineProvider.prototype.getSubmissionFolder = function (assignId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var siteFolderPath = _this.fileProvider.getSiteFolder(site.getId()), submissionFolderPath = 'offlineassign/' + assignId + '/' + userId;
            return _this.textUtils.concatenatePaths(siteFolderPath, submissionFolderPath);
        });
    };
    /**
     * Get a stored submission grade.
     * Submission grades are not identified using attempt number so it can retrieve the feedback for a previous attempt.
     *
     * @param {number} assignId Assignment ID.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with submission grade.
     */
    AddonModAssignOfflineProvider.prototype.getSubmissionGrade = function (assignId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().getRecord(AddonModAssignOfflineProvider_1.SUBMISSIONS_GRADES_TABLE, { assignid: assignId, userid: userId });
        }).then(function (submission) {
            // Parse the plugin data and outcomes.
            submission.outcomes = _this.textUtils.parseJSON(submission.outcomes, {});
            submission.plugindata = _this.textUtils.parseJSON(submission.plugindata, {});
            return submission;
        });
    };
    /**
     * Get the path to the folder where to store files for a certain plugin in an offline submission.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} pluginName Name of the plugin. Must be unique (both in submission and feedback plugins).
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the path.
     */
    AddonModAssignOfflineProvider.prototype.getSubmissionPluginFolder = function (assignId, pluginName, userId, siteId) {
        var _this = this;
        return this.getSubmissionFolder(assignId, userId, siteId).then(function (folderPath) {
            return _this.textUtils.concatenatePaths(folderPath, pluginName);
        });
    };
    /**
     * Check if the assignment has something to be synced.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether the assignment has something to be synced.
     */
    AddonModAssignOfflineProvider.prototype.hasAssignOfflineData = function (assignId, siteId) {
        var promises = [];
        promises.push(this.getAssignSubmissions(assignId, siteId));
        promises.push(this.getAssignSubmissionsGrade(assignId, siteId));
        return Promise.all(promises).then(function (results) {
            for (var i = 0; i < results.length; i++) {
                var result = results[i];
                if (result && result.length) {
                    return true;
                }
            }
            return false;
        }).catch(function () {
            // No offline data found.
            return false;
        });
    };
    /**
     * Mark/Unmark a submission as being submitted.
     *
     * @param {number} assignId Assignment ID.
     * @param {number} courseId Course ID the assign belongs to.
     * @param {boolean} submitted True to mark as submitted, false to mark as not submitted.
     * @param {boolean} acceptStatement True to accept the submission statement, false otherwise.
     * @param {number} timemodified The time the submission was last modified in online.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if marked, rejected if failure.
     */
    AddonModAssignOfflineProvider.prototype.markSubmitted = function (assignId, courseId, submitted, acceptStatement, timemodified, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            // Check if there's a submission stored.
            return _this.getSubmission(assignId, userId, site.getId()).catch(function () {
                // No submission, create an empty one.
                var now = _this.timeUtils.timestamp();
                return {
                    assignid: assignId,
                    courseid: courseId,
                    userid: userId,
                    onlinetimemodified: timemodified,
                    timecreated: now,
                    timemodified: now
                };
            }).then(function (submission) {
                // Mark the submission.
                submission.submitted = submitted ? 1 : 0;
                submission.submissionstatement = acceptStatement ? 1 : 0;
                submission.plugindata = submission.plugindata ? JSON.stringify(submission.plugindata) : '{}';
                return site.getDb().insertRecord(AddonModAssignOfflineProvider_1.SUBMISSIONS_TABLE, submission);
            });
        });
    };
    /**
     * Save a submission to be sent later.
     *
     * @param {number} assignId Assignment ID.
     * @param {number} courseId Course ID the assign belongs to.
     * @param {any} pluginData Data to save.
     * @param {number} timemodified The time the submission was last modified in online.
     * @param {boolean} submitted True if submission has been submitted, false otherwise.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if stored, rejected if failure.
     */
    AddonModAssignOfflineProvider.prototype.saveSubmission = function (assignId, courseId, pluginData, timemodified, submitted, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var now = _this.timeUtils.timestamp(), entry = {
                assignid: assignId,
                courseid: courseId,
                plugindata: pluginData ? JSON.stringify(pluginData) : '{}',
                userid: userId,
                submitted: submitted ? 1 : 0,
                timecreated: now,
                timemodified: now,
                onlinetimemodified: timemodified
            };
            return site.getDb().insertRecord(AddonModAssignOfflineProvider_1.SUBMISSIONS_TABLE, entry);
        });
    };
    /**
     * Save a grading to be sent later.
     *
     * @param {number} assignId Assign ID.
     * @param {number} userId User ID.
     * @param {number} courseId Course ID the assign belongs to.
     * @param {number} grade Grade to submit.
     * @param {number} attemptNumber Number of the attempt being graded.
     * @param {boolean} addAttempt Admit the user to attempt again.
     * @param {string} workflowState Next workflow State.
     * @param {boolean} applyToAll If it's a team submission, whether the grade applies to all group members.
     * @param {any} outcomes Object including all outcomes values. If empty, any of them will be sent.
     * @param {any} pluginData Plugin data to save.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if stored, rejected if failure.
     */
    AddonModAssignOfflineProvider.prototype.submitGradingForm = function (assignId, userId, courseId, grade, attemptNumber, addAttempt, workflowState, applyToAll, outcomes, pluginData, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var now = _this.timeUtils.timestamp(), entry = {
                assignid: assignId,
                userid: userId,
                courseid: courseId,
                grade: grade,
                attemptnumber: attemptNumber,
                addattempt: addAttempt ? 1 : 0,
                workflowstate: workflowState,
                applytoall: applyToAll ? 1 : 0,
                outcomes: outcomes ? JSON.stringify(outcomes) : '{}',
                plugindata: pluginData ? JSON.stringify(pluginData) : '{}',
                timemodified: now
            };
            return site.getDb().insertRecord(AddonModAssignOfflineProvider_1.SUBMISSIONS_GRADES_TABLE, entry);
        });
    };
    // Variables for database.
    AddonModAssignOfflineProvider.SUBMISSIONS_TABLE = 'addon_mod_assign_submissions';
    AddonModAssignOfflineProvider.SUBMISSIONS_GRADES_TABLE = 'addon_mod_assign_submissions_grading';
    AddonModAssignOfflineProvider = AddonModAssignOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonModAssignOfflineProvider);
    return AddonModAssignOfflineProvider;
    var AddonModAssignOfflineProvider_1;
}());

//# sourceMappingURL=assign-offline.js.map

/***/ }),
/* 94 */,
/* 95 */,
/* 96 */,
/* 97 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldPluginComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Base class for component to render a field.
 */
var AddonModDataFieldPluginComponent = /** @class */ (function () {
    function AddonModDataFieldPluginComponent(fb) {
        this.fb = fb;
        this.gotoEntry = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Add the form control for the search mode.
     *
     * @param {string} fieldName Control field name.
     * @param {any}    value     Initial set value.
     */
    AddonModDataFieldPluginComponent.prototype.addControl = function (fieldName, value) {
        if (!this.form) {
            return;
        }
        if (this.mode == 'search') {
            this.form.addControl(fieldName, this.fb.control(this.search[fieldName] || null));
        }
        if (this.mode == 'edit') {
            this.form.addControl(fieldName, this.fb.control(value, this.field.required ? __WEBPACK_IMPORTED_MODULE_1__angular_forms__["h" /* Validators */].required : null));
        }
    };
    /**
     * Component being initialized.
     */
    AddonModDataFieldPluginComponent.prototype.ngOnInit = function () {
        this.init();
    };
    /**
     * Initialize field.
     */
    AddonModDataFieldPluginComponent.prototype.init = function () {
        return;
    };
    /**
     * Return if is shown or list mode.
     *
     * @return {boolean} True if mode is show or list.
     */
    AddonModDataFieldPluginComponent.prototype.isShowOrListMode = function () {
        return this.mode == 'list' || this.mode == 'show';
    };
    /**
     * Component being changed.
     */
    AddonModDataFieldPluginComponent.prototype.ngOnChanges = function (changes) {
        if (this.isShowOrListMode() && changes.value) {
            this.updateValue(changes.value.currentValue);
        }
    };
    /**
     * Update value being shown.
     */
    AddonModDataFieldPluginComponent.prototype.updateValue = function (value) {
        this.value = value;
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModDataFieldPluginComponent.prototype, "mode", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "value", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "database", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModDataFieldPluginComponent.prototype, "error", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonModDataFieldPluginComponent.prototype, "gotoEntry", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonModDataFieldPluginComponent.prototype, "form", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "search", void 0);
    return AddonModDataFieldPluginComponent;
}());

//# sourceMappingURL=field-plugin-component.js.map

/***/ }),
/* 98 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle caompetency learning plans.
 */
var AddonCompetencyProvider = /** @class */ (function () {
    function AddonCompetencyProvider(loggerProvider, sitesProvider, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.ROOT_CACHE_KEY = 'mmaCompetency:';
        this.logger = loggerProvider.getInstance('AddonCompetencyProvider');
    }
    AddonCompetencyProvider_1 = AddonCompetencyProvider;
    /**
     * Check if all competencies features are disabled.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether all competency features are disabled.
     */
    AddonCompetencyProvider.prototype.allCompetenciesDisabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.isFeatureDisabled('CoreMainMenuDelegate_AddonCompetency') &&
                site.isFeatureDisabled('CoreCourseOptionsDelegate_AddonCompetency') &&
                site.isFeatureDisabled('CoreUserDelegate_AddonCompetency');
        });
    };
    /**
     * Get cache key for user learning plans data WS calls.
     *
     * @param {number} userId User ID.
     * @return {string}         Cache key.
     */
    AddonCompetencyProvider.prototype.getLearningPlansCacheKey = function (userId) {
        return this.ROOT_CACHE_KEY + 'userplans:' + userId;
    };
    /**
     * Get cache key for learning plan data WS calls.
     *
     * @param {number} planId Plan ID.
     * @return {string}         Cache key.
     */
    AddonCompetencyProvider.prototype.getLearningPlanCacheKey = function (planId) {
        return this.ROOT_CACHE_KEY + 'learningplan:' + planId;
    };
    /**
     * Get cache key for competency in plan data WS calls.
     *
     * @param {number} planId Plan ID.
     * @param {number} competencyId Competency ID.
     * @return {string}         Cache key.
     */
    AddonCompetencyProvider.prototype.getCompetencyInPlanCacheKey = function (planId, competencyId) {
        return this.ROOT_CACHE_KEY + 'plancompetency:' + planId + ':' + competencyId;
    };
    /**
     * Get cache key for competency in course data WS calls.
     *
     * @param {number} courseId Course ID.
     * @param {number} competencyId Competency ID.
     * @param {number} userId User ID.
     * @return {string}         Cache key.
     */
    AddonCompetencyProvider.prototype.getCompetencyInCourseCacheKey = function (courseId, competencyId, userId) {
        return this.ROOT_CACHE_KEY + 'coursecompetency:' + userId + ':' + courseId + ':' + competencyId;
    };
    /**
     * Get cache key for competency summary data WS calls.
     *
     * @param {number} competencyId Competency ID.
     * @param {number} userId User ID.
     * @return {string}         Cache key.
     */
    AddonCompetencyProvider.prototype.getCompetencySummaryCacheKey = function (competencyId, userId) {
        return this.ROOT_CACHE_KEY + 'competencysummary:' + userId + ':' + competencyId;
    };
    /**
     * Get cache key for course competencies data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonCompetencyProvider.prototype.getCourseCompetenciesCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'coursecompetencies:' + courseId;
    };
    /**
     * Returns whether competencies are enabled.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} competencies if enabled for the given course, false otherwise.
     */
    AddonCompetencyProvider.prototype.isPluginForCourseEnabled = function (courseId, siteId) {
        if (!this.sitesProvider.isLoggedIn()) {
            return Promise.resolve(false);
        }
        return this.getCourseCompetencies(courseId, 0, siteId).catch(function () {
            return false;
        });
    };
    /**
     * Get plans for a certain user.
     *
     * @param  {number} [userId]    ID of the user. If not defined, current user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}            Promise to be resolved when the plans are retrieved.
     */
    AddonCompetencyProvider.prototype.getLearningPlans = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Get plans for user ' + userId);
            var params = {
                userid: userId
            }, preSets = {
                cacheKey: _this.getLearningPlansCacheKey(userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('tool_lp_data_for_plans_page', params, preSets).then(function (response) {
                if (response.plans) {
                    return response.plans;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a certain plan.
     *
     * @param  {number} planId    ID of the plan.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}            Promise to be resolved when the plans are retrieved.
     */
    AddonCompetencyProvider.prototype.getLearningPlan = function (planId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            _this.logger.debug('Get plan ' + planId);
            var params = {
                planid: planId
            }, preSets = {
                cacheKey: _this.getLearningPlanCacheKey(planId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('tool_lp_data_for_plan_page', params, preSets).then(function (response) {
                if (response.plan) {
                    return response;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a certain competency in a plan.
     *
     * @param  {number} planId    ID of the plan.
     * @param  {number} competencyId    ID of the competency.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}            Promise to be resolved when the plans are retrieved.
     */
    AddonCompetencyProvider.prototype.getCompetencyInPlan = function (planId, competencyId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            _this.logger.debug('Get competency ' + competencyId + ' in plan ' + planId);
            var params = {
                planid: planId,
                competencyid: competencyId
            }, preSets = {
                cacheKey: _this.getCompetencyInPlanCacheKey(planId, competencyId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('tool_lp_data_for_user_competency_summary_in_plan', params, preSets).then(function (response) {
                if (response.usercompetencysummary) {
                    return response;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a certain competency in a course.
     *
     * @param  {number} courseId    ID of the course.
     * @param  {number} competencyId    ID of the competency.
     * @param  {number} [userId]    ID of the user. If not defined, current user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}            Promise to be resolved when the plans are retrieved.
     */
    AddonCompetencyProvider.prototype.getCompetencyInCourse = function (courseId, competencyId, userId, siteId, ignoreCache) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Get competency ' + competencyId + ' in course ' + courseId);
            var params = {
                courseid: courseId,
                competencyid: competencyId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getCompetencyInCourseCacheKey(courseId, competencyId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('tool_lp_data_for_user_competency_summary_in_course', params, preSets).then(function (response) {
                if (response.usercompetencysummary) {
                    return response;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a certain competency summary.
     *
     * @param  {number} competencyId    ID of the competency.
     * @param  {number} [userId]    ID of the user. If not defined, current user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}            Promise to be resolved when the plans are retrieved.
     */
    AddonCompetencyProvider.prototype.getCompetencySummary = function (competencyId, userId, siteId, ignoreCache) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Get competency ' + competencyId + ' summary for user' + userId);
            var params = {
                competencyid: competencyId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getCompetencySummaryCacheKey(competencyId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('tool_lp_data_for_user_competency_summary', params, preSets).then(function (response) {
                if (response.competency) {
                    return response.competency;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get all competencies in a course.
     *
     * @param  {number} courseId    ID of the course.
     * @param  {number} [userId]    ID of the user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}            Promise to be resolved when the course competencies are retrieved.
     */
    AddonCompetencyProvider.prototype.getCourseCompetencies = function (courseId, userId, siteId, ignoreCache) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            _this.logger.debug('Get course competencies for course ' + courseId);
            var params = {
                courseid: courseId
            }, preSets = {
                cacheKey: _this.getCourseCompetenciesCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('tool_lp_data_for_course_competencies_page', params, preSets).then(function (response) {
                if (response.competencies) {
                    return response;
                }
                return Promise.reject(null);
            });
        }).then(function (response) {
            if (!userId || userId == _this.sitesProvider.getCurrentSiteUserId()) {
                return response;
            }
            var promises = response.competencies.map(function (competency) {
                return _this.getCompetencyInCourse(courseId, competency.competency.id, userId, siteId);
            });
            return Promise.all(promises).then(function (responses) {
                responses.forEach(function (resp, index) {
                    response.competencies[index].usercompetencycourse = resp.usercompetencysummary.usercompetencycourse;
                });
                return response;
            });
        });
    };
    /**
     * Invalidates User Learning Plans data.
     *
     * @param  {number} [userId]    ID of the user. If not defined, current user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}            Promise resolved when the data is invalidated.
     */
    AddonCompetencyProvider.prototype.invalidateLearningPlans = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getLearningPlansCacheKey(userId));
        });
    };
    /**
     * Invalidates Learning Plan data.
     *
     * @param  {number} planId    ID of the plan.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonCompetencyProvider.prototype.invalidateLearningPlan = function (planId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getLearningPlanCacheKey(planId));
        });
    };
    /**
     * Invalidates Competency in Plan data.
     *
     * @param  {number} planId    ID of the plan.
     * @param  {number} competencyId    ID of the competency.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonCompetencyProvider.prototype.invalidateCompetencyInPlan = function (planId, competencyId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCompetencyInPlanCacheKey(planId, competencyId));
        });
    };
    /**
     * Invalidates Competency in Course data.
     *
     * @param  {number} courseId    ID of the course.
     * @param  {number} competencyId    ID of the competency.
     * @param  {number} [userId]    ID of the user. If not defined, current user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonCompetencyProvider.prototype.invalidateCompetencyInCourse = function (courseId, competencyId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCompetencyInCourseCacheKey(courseId, competencyId, userId));
        });
    };
    /**
     * Invalidates Competency Summary data.
     *
     * @param  {number} competencyId    ID of the competency.
     * @param  {number} [userId]    ID of the user. If not defined, current user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonCompetencyProvider.prototype.invalidateCompetencySummary = function (competencyId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCompetencySummaryCacheKey(competencyId, userId));
        });
    };
    /**
     * Invalidates Course Competencies data.
     *
     * @param  {number} courseId    ID of the course.
     * @param  {number} [userId]      ID of the user.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonCompetencyProvider.prototype.invalidateCourseCompetencies = function (courseId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCourseCompetenciesCacheKey(courseId));
        }).then(function () {
            if (!userId || userId == _this.sitesProvider.getCurrentSiteUserId()) {
                return;
            }
            /* Competencies for other users are fetched with getCompetencyInCourse (and saved in their own cache).
               We need to fecth the list of competencies to know which ones to invalidate. We can pass 0 as userId
               to getCourseCompetencies, we just need the competency IDs and this way we avid extra WS calls. */
            return _this.getCourseCompetencies(courseId, 0, siteId).then(function (competencies) {
                var promises = competencies.competencies.map(function (competency) {
                    return _this.invalidateCompetencyInCourse(courseId, competency.competency.id, userId, siteId);
                });
                return Promise.all(promises);
            });
        });
    };
    /**
     * Report the competency as being viewed in plan.
     *
     * @param  {number} planId    ID of the plan.
     * @param  {number} competencyId  ID of the competency.
     * @param  {number} planStatus    Current plan Status to decide what action should be logged.
     * @param  {string} [name] Name of the competency.
     * @param  {number} [userId] User ID. If not defined, current user.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonCompetencyProvider.prototype.logCompetencyInPlanView = function (planId, competencyId, planStatus, name, userId, siteId) {
        var _this = this;
        if (planId && competencyId) {
            return this.sitesProvider.getSite(siteId).then(function (site) {
                userId = userId || site.getUserId();
                var params = {
                    planid: planId,
                    competencyid: competencyId,
                    userid: userId
                }, preSets = {
                    typeExpected: 'boolean'
                }, wsName = planStatus == AddonCompetencyProvider_1.STATUS_COMPLETE ?
                    'core_competency_user_competency_plan_viewed' : 'core_competency_user_competency_viewed_in_plan';
                _this.pushNotificationsProvider.logViewEvent(competencyId, name, 'competency', wsName, {
                    planid: planId,
                    planstatus: planStatus,
                    userid: userId
                }, siteId);
                return site.write(wsName, params, preSets);
            });
        }
        return Promise.reject(null);
    };
    /**
     * Report the competency as being viewed in course.
     *
     * @param  {number} courseId        ID of the course.
     * @param  {number} competencyId    ID of the competency.
     * @param  {string} [name] Name of the competency.
     * @param  {number} [userId] User ID. If not defined, current user.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonCompetencyProvider.prototype.logCompetencyInCourseView = function (courseId, competencyId, name, userId, siteId) {
        var _this = this;
        if (courseId && competencyId) {
            return this.sitesProvider.getSite(siteId).then(function (site) {
                userId = userId || site.getUserId();
                var params = {
                    courseid: courseId,
                    competencyid: competencyId,
                    userid: userId
                };
                var preSets = {
                    typeExpected: 'boolean'
                };
                var wsName = 'core_competency_user_competency_viewed_in_course';
                _this.pushNotificationsProvider.logViewEvent(competencyId, name, 'competency', wsName, {
                    courseid: courseId,
                    userid: userId
                }, siteId);
                return site.write(wsName, params, preSets);
            });
        }
        return Promise.reject(null);
    };
    /**
     * Report the competency as being viewed.
     *
     * @param  {number} competencyId    ID of the competency.
     * @param  {string} [name] Name of the competency.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonCompetencyProvider.prototype.logCompetencyView = function (competencyId, name, siteId) {
        var _this = this;
        if (competencyId) {
            return this.sitesProvider.getSite(siteId).then(function (site) {
                var params = {
                    id: competencyId,
                };
                var preSets = {
                    typeExpected: 'boolean'
                };
                var wsName = 'core_competency_competency_viewed';
                _this.pushNotificationsProvider.logViewEvent(competencyId, name, 'competency', wsName, {}, siteId);
                return site.write('core_competency_competency_viewed', params, preSets);
            });
        }
        return Promise.reject(null);
    };
    // Learning plan status.
    AddonCompetencyProvider.STATUS_DRAFT = 0;
    AddonCompetencyProvider.STATUS_ACTIVE = 1;
    AddonCompetencyProvider.STATUS_COMPLETE = 2;
    AddonCompetencyProvider.STATUS_WAITING_FOR_REVIEW = 3;
    AddonCompetencyProvider.STATUS_IN_REVIEW = 4;
    // Competency status.
    AddonCompetencyProvider.REVIEW_STATUS_IDLE = 0;
    AddonCompetencyProvider.REVIEW_STATUS_WAITING_FOR_REVIEW = 1;
    AddonCompetencyProvider.REVIEW_STATUS_IN_REVIEW = 2;
    AddonCompetencyProvider = AddonCompetencyProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], AddonCompetencyProvider);
    return AddonCompetencyProvider;
    var AddonCompetencyProvider_1;
}());

//# sourceMappingURL=competency.js.map

/***/ }),
/* 99 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_grades_providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__access_rules_delegate__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__quiz_offline__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/**
 * Service that provides some features for quiz.
 */
var AddonModQuizProvider = /** @class */ (function () {
    function AddonModQuizProvider(logger, sitesProvider, utils, translate, textUtils, gradesHelper, questionDelegate, filepoolProvider, timeUtils, accessRulesDelegate, quizOfflineProvider, domUtils, logHelper, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.translate = translate;
        this.textUtils = textUtils;
        this.gradesHelper = gradesHelper;
        this.questionDelegate = questionDelegate;
        this.filepoolProvider = filepoolProvider;
        this.timeUtils = timeUtils;
        this.accessRulesDelegate = accessRulesDelegate;
        this.quizOfflineProvider = quizOfflineProvider;
        this.domUtils = domUtils;
        this.logHelper = logHelper;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.ROOT_CACHE_KEY = 'mmaModQuiz:';
        this.logger = logger.getInstance('AddonModQuizProvider');
    }
    AddonModQuizProvider_1 = AddonModQuizProvider;
    /**
     * Formats a grade to be displayed.
     *
     * @param {number} grade Grade.
     * @param {number} decimals Decimals to use.
     * @return {string} Grade to display.
     */
    AddonModQuizProvider.prototype.formatGrade = function (grade, decimals) {
        if (typeof grade == 'undefined' || grade == -1 || grade === null) {
            return this.translate.instant('addon.mod_quiz.notyetgraded');
        }
        return this.utils.formatFloat(this.textUtils.roundToDecimals(grade, decimals));
    };
    /**
     * Get attempt questions. Returns all of them or just the ones in certain pages.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} preflightData Preflight required data (like password).
     * @param {number[]} [pages] List of pages to get. If not defined, all pages.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the questions.
     */
    AddonModQuizProvider.prototype.getAllQuestionsData = function (quiz, attempt, preflightData, pages, offline, ignoreCache, siteId) {
        var _this = this;
        var promises = [], questions = {}, isSequential = this.isNavigationSequential(quiz);
        if (!pages) {
            pages = this.getPagesFromLayout(attempt.layout);
        }
        pages.forEach(function (page) {
            if (isSequential && page < attempt.currentpage) {
                // Sequential quiz, cannot get pages before the current one.
                return;
            }
            // Get the questions in the page.
            promises.push(_this.getAttemptData(attempt.id, page, preflightData, offline, ignoreCache, siteId).then(function (data) {
                // Add the questions to the result object.
                data.questions.forEach(function (question) {
                    questions[question.slot] = question;
                });
            }));
        });
        return Promise.all(promises).then(function () {
            return questions;
        });
    };
    /**
     * Get cache key for get attempt access information WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} attemptId Attempt ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getAttemptAccessInformationCacheKey = function (quizId, attemptId) {
        return this.getAttemptAccessInformationCommonCacheKey(quizId) + ':' + attemptId;
    };
    /**
     * Get common cache key for get attempt access information WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getAttemptAccessInformationCommonCacheKey = function (quizId) {
        return this.ROOT_CACHE_KEY + 'attemptAccessInformation:' + quizId;
    };
    /**
     * Get access information for an attempt.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} attemptId Attempt ID. 0 for user's last attempt.
     * @param {boolean} offline Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} ignoreCache Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the access information.
     */
    AddonModQuizProvider.prototype.getAttemptAccessInformation = function (quizId, attemptId, offline, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                quizid: quizId,
                attemptid: attemptId
            }, preSets = {
                cacheKey: _this.getAttemptAccessInformationCacheKey(quizId, attemptId)
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_attempt_access_information', params, preSets);
        });
    };
    /**
     * Get cache key for get attempt data WS calls.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} page Page.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getAttemptDataCacheKey = function (attemptId, page) {
        return this.getAttemptDataCommonCacheKey(attemptId) + ':' + page;
    };
    /**
     * Get common cache key for get attempt data WS calls.
     *
     * @param {number} attemptId Attempt ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getAttemptDataCommonCacheKey = function (attemptId) {
        return this.ROOT_CACHE_KEY + 'attemptData:' + attemptId;
    };
    /**
     * Get an attempt's data.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} page Page number.
     * @param {any} preflightData Preflight required data (like password).
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the attempt data.
     */
    AddonModQuizProvider.prototype.getAttemptData = function (attemptId, page, preflightData, offline, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                attemptid: attemptId,
                page: page,
                preflightdata: _this.utils.objectToArrayOfObjects(preflightData, 'name', 'value', true)
            }, preSets = {
                cacheKey: _this.getAttemptDataCacheKey(attemptId, page)
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_attempt_data', params, preSets);
        });
    };
    /**
     * Get an attempt's due date.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @return {number} Attempt's due date, 0 if no due date or invalid data.
     */
    AddonModQuizProvider.prototype.getAttemptDueDate = function (quiz, attempt) {
        var deadlines = [];
        if (quiz.timelimit) {
            deadlines.push(parseInt(attempt.timestart, 10) + parseInt(quiz.timelimit, 10));
        }
        if (quiz.timeclose) {
            deadlines.push(parseInt(quiz.timeclose, 10));
        }
        if (!deadlines.length) {
            return 0;
        }
        // Get min due date.
        var dueDate = Math.min.apply(null, deadlines);
        if (!dueDate) {
            return 0;
        }
        switch (attempt.state) {
            case AddonModQuizProvider_1.ATTEMPT_IN_PROGRESS:
                return dueDate * 1000;
            case AddonModQuizProvider_1.ATTEMPT_OVERDUE:
                return (dueDate + parseInt(quiz.graceperiod, 10)) * 1000;
            default:
                this.logger.warn('Unexpected state when getting due date: ' + attempt.state);
                return 0;
        }
    };
    /**
     * Get an attempt's warning because of due date.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @return {string} Attempt's warning, undefined if no due date.
     */
    AddonModQuizProvider.prototype.getAttemptDueDateWarning = function (quiz, attempt) {
        var dueDate = this.getAttemptDueDate(quiz, attempt);
        if (attempt.state === AddonModQuizProvider_1.ATTEMPT_OVERDUE) {
            return this.translate.instant('addon.mod_quiz.overduemustbesubmittedby', { $a: this.timeUtils.userDate(dueDate) });
        }
        else if (dueDate) {
            return this.translate.instant('addon.mod_quiz.mustbesubmittedby', { $a: this.timeUtils.userDate(dueDate) });
        }
    };
    /**
     * Turn attempt's state into a readable state, including some extra data depending on the state.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @return {string[]} List of state sentences.
     */
    AddonModQuizProvider.prototype.getAttemptReadableState = function (quiz, attempt) {
        if (attempt.finishedOffline) {
            return [this.translate.instant('addon.mod_quiz.finishnotsynced')];
        }
        switch (attempt.state) {
            case AddonModQuizProvider_1.ATTEMPT_IN_PROGRESS:
                return [this.translate.instant('addon.mod_quiz.stateinprogress')];
            case AddonModQuizProvider_1.ATTEMPT_OVERDUE:
                var sentences = [], dueDate = this.getAttemptDueDate(quiz, attempt);
                sentences.push(this.translate.instant('addon.mod_quiz.stateoverdue'));
                if (dueDate) {
                    sentences.push(this.translate.instant('addon.mod_quiz.stateoverduedetails', { $a: this.timeUtils.userDate(dueDate) }));
                }
                return sentences;
            case AddonModQuizProvider_1.ATTEMPT_FINISHED:
                return [
                    this.translate.instant('addon.mod_quiz.statefinished'),
                    this.translate.instant('addon.mod_quiz.statefinisheddetails', { $a: this.timeUtils.userDate(attempt.timefinish * 1000) })
                ];
            case AddonModQuizProvider_1.ATTEMPT_ABANDONED:
                return [this.translate.instant('addon.mod_quiz.stateabandoned')];
            default:
                return [];
        }
    };
    /**
     * Turn attempt's state into a readable state name, without any more data.
     *
     * @param {string} state State.
     * @return {string} Readable state name.
     */
    AddonModQuizProvider.prototype.getAttemptReadableStateName = function (state) {
        switch (state) {
            case AddonModQuizProvider_1.ATTEMPT_IN_PROGRESS:
                return this.translate.instant('addon.mod_quiz.stateinprogress');
            case AddonModQuizProvider_1.ATTEMPT_OVERDUE:
                return this.translate.instant('addon.mod_quiz.stateoverdue');
            case AddonModQuizProvider_1.ATTEMPT_FINISHED:
                return this.translate.instant('addon.mod_quiz.statefinished');
            case AddonModQuizProvider_1.ATTEMPT_ABANDONED:
                return this.translate.instant('addon.mod_quiz.stateabandoned');
            default:
                return '';
        }
    };
    /**
     * Get cache key for get attempt review WS calls.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} page Page.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getAttemptReviewCacheKey = function (attemptId, page) {
        return this.getAttemptReviewCommonCacheKey(attemptId) + ':' + page;
    };
    /**
     * Get common cache key for get attempt review WS calls.
     *
     * @param {number} attemptId Attempt ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getAttemptReviewCommonCacheKey = function (attemptId) {
        return this.ROOT_CACHE_KEY + 'attemptReview:' + attemptId;
    };
    /**
     * Get an attempt's review.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} [page] Page number. If not defined, return all the questions in all the pages.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the attempt review.
     */
    AddonModQuizProvider.prototype.getAttemptReview = function (attemptId, page, ignoreCache, siteId) {
        var _this = this;
        if (typeof page == 'undefined') {
            page = -1;
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                attemptid: attemptId,
                page: page
            }, preSets = {
                cacheKey: _this.getAttemptReviewCacheKey(attemptId, page),
                cacheErrors: ['noreview']
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_attempt_review', params, preSets);
        });
    };
    /**
     * Get cache key for get attempt summary WS calls.
     *
     * @param {number} attemptId Attempt ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getAttemptSummaryCacheKey = function (attemptId) {
        return this.ROOT_CACHE_KEY + 'attemptSummary:' + attemptId;
    };
    /**
     * Get an attempt's summary.
     *
     * @param {number} attemptId Attempt ID.
     * @param {any} preflightData Preflight required data (like password).
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {boolean} [loadLocal] Whether it should load local state for each question. Only applicable if offline=true.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of questions for the attempt summary.
     */
    AddonModQuizProvider.prototype.getAttemptSummary = function (attemptId, preflightData, offline, ignoreCache, loadLocal, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                attemptid: attemptId,
                preflightdata: _this.utils.objectToArrayOfObjects(preflightData, 'name', 'value', true)
            }, preSets = {
                cacheKey: _this.getAttemptSummaryCacheKey(attemptId)
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_attempt_summary', params, preSets).then(function (response) {
                if (response && response.questions) {
                    if (offline && loadLocal) {
                        return _this.quizOfflineProvider.loadQuestionsLocalStates(attemptId, response.questions, site.getId());
                    }
                    return response.questions;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get combined review options WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getCombinedReviewOptionsCacheKey = function (quizId, userId) {
        return this.getCombinedReviewOptionsCommonCacheKey(quizId) + ':' + userId;
    };
    /**
     * Get common cache key for get combined review options WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getCombinedReviewOptionsCommonCacheKey = function (quizId) {
        return this.ROOT_CACHE_KEY + 'combinedReviewOptions:' + quizId;
    };
    /**
     * Get a quiz combined review options.
     *
     * @param {number} quizId  Quiz ID.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>}Promise resolved with the combined review options.
     */
    AddonModQuizProvider.prototype.getCombinedReviewOptions = function (quizId, ignoreCache, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                quizid: quizId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getCombinedReviewOptionsCacheKey(quizId, userId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_combined_review_options', params, preSets).then(function (response) {
                if (response && response.someoptions && response.alloptions) {
                    // Convert the arrays to objects with name -> value.
                    response.someoptions = _this.utils.objectToKeyValueMap(response.someoptions, 'name', 'value');
                    response.alloptions = _this.utils.objectToKeyValueMap(response.alloptions, 'name', 'value');
                    return response;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get feedback for grade WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} grade  Grade.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getFeedbackForGradeCacheKey = function (quizId, grade) {
        return this.getFeedbackForGradeCommonCacheKey(quizId) + ':' + grade;
    };
    /**
     * Get common cache key for get feedback for grade WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getFeedbackForGradeCommonCacheKey = function (quizId) {
        return this.ROOT_CACHE_KEY + 'feedbackForGrade:' + quizId;
    };
    /**
     * Get the feedback for a certain grade.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} grade Grade.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the feedback.
     */
    AddonModQuizProvider.prototype.getFeedbackForGrade = function (quizId, grade, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                quizid: quizId,
                grade: grade
            }, preSets = {
                cacheKey: _this.getFeedbackForGradeCacheKey(quizId, grade),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_quiz_feedback_for_grade', params, preSets);
        });
    };
    /**
     * Determine the correct number of decimal places required to format a grade.
     * Based on Moodle's quiz_get_grade_format.
     *
     * @param {any} quiz Quiz.
     * @return {number} Number of decimals.
     */
    AddonModQuizProvider.prototype.getGradeDecimals = function (quiz) {
        if (typeof quiz.questiondecimalpoints == 'undefined') {
            quiz.questiondecimalpoints = -1;
        }
        if (quiz.questiondecimalpoints == -1) {
            return quiz.decimalpoints;
        }
        return quiz.questiondecimalpoints;
    };
    /**
     * Gets a quiz grade and feedback from the gradebook.
     *
     * @param {number} courseId Course ID.
     * @param {number} moduleId Quiz module ID.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved with an object containing the grade and the feedback.
     */
    AddonModQuizProvider.prototype.getGradeFromGradebook = function (courseId, moduleId, ignoreCache, siteId, userId) {
        return this.gradesHelper.getGradeModuleItems(courseId, moduleId, userId, null, siteId, ignoreCache).then(function (items) {
            return items.shift();
        });
    };
    /**
     * Given a list of attempts, returns the last finished attempt.
     *
     * @param {any[]} attempts Attempts.
     * @return {any} Last finished attempt.
     */
    AddonModQuizProvider.prototype.getLastFinishedAttemptFromList = function (attempts) {
        if (attempts && attempts.length) {
            for (var i = attempts.length - 1; i >= 0; i--) {
                var attempt = attempts[i];
                if (this.isAttemptFinished(attempt.state)) {
                    return attempt;
                }
            }
        }
    };
    /**
     * Given a list of questions, check if the quiz can be submitted.
     * Will return an array with the messages to prevent the submit. Empty array if quiz can be submitted.
     *
     * @param {any[]} questions Questions.
     * @return {string[]} List of prevent submit messages. Empty array if quiz can be submitted.
     */
    AddonModQuizProvider.prototype.getPreventSubmitMessages = function (questions) {
        var _this = this;
        var messages = [];
        questions.forEach(function (question) {
            var message = _this.questionDelegate.getPreventSubmitMessage(question);
            if (message) {
                message = _this.translate.instant(message);
                messages.push(_this.translate.instant('core.question.questionmessage', { $a: question.slot, $b: message }));
            }
        });
        return messages;
    };
    /**
     * Get cache key for quiz data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getQuizDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'quiz:' + courseId;
    };
    /**
     * Get a Quiz with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the Quiz is retrieved.
     */
    AddonModQuizProvider.prototype.getQuizByField = function (courseId, key, value, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getQuizDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_quizzes_by_courses', params, preSets).then(function (response) {
                if (response && response.quizzes) {
                    // Search the quiz.
                    for (var i in response.quizzes) {
                        var quiz = response.quizzes[i];
                        if (quiz[key] == value) {
                            return quiz;
                        }
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a quiz by module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the quiz is retrieved.
     */
    AddonModQuizProvider.prototype.getQuiz = function (courseId, cmId, forceCache, ignoreCache, siteId) {
        return this.getQuizByField(courseId, 'coursemodule', cmId, forceCache, ignoreCache, siteId);
    };
    /**
     * Get a quiz by quiz ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} id Quiz ID.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the quiz is retrieved.
     */
    AddonModQuizProvider.prototype.getQuizById = function (courseId, id, forceCache, ignoreCache, siteId) {
        return this.getQuizByField(courseId, 'id', id, forceCache, ignoreCache, siteId);
    };
    /**
     * Get cache key for get quiz access information WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getQuizAccessInformationCacheKey = function (quizId) {
        return this.ROOT_CACHE_KEY + 'quizAccessInformation:' + quizId;
    };
    /**
     * Get access information for an attempt.
     *
     * @param {number} quizId Quiz ID.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the access information.
     */
    AddonModQuizProvider.prototype.getQuizAccessInformation = function (quizId, offline, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                quizid: quizId
            }, preSets = {
                cacheKey: _this.getQuizAccessInformationCacheKey(quizId)
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_quiz_access_information', params, preSets);
        });
    };
    /**
     * Get a readable Quiz grade method.
     *
     * @param {number|string} method Grading method.
     * @return {string} Readable grading method.
     */
    AddonModQuizProvider.prototype.getQuizGradeMethod = function (method) {
        if (typeof method == 'string') {
            method = parseInt(method, 10);
        }
        switch (method) {
            case AddonModQuizProvider_1.GRADEHIGHEST:
                return this.translate.instant('addon.mod_quiz.gradehighest');
            case AddonModQuizProvider_1.GRADEAVERAGE:
                return this.translate.instant('addon.mod_quiz.gradeaverage');
            case AddonModQuizProvider_1.ATTEMPTFIRST:
                return this.translate.instant('addon.mod_quiz.attemptfirst');
            case AddonModQuizProvider_1.ATTEMPTLAST:
                return this.translate.instant('addon.mod_quiz.attemptlast');
            default:
                return '';
        }
    };
    /**
     * Get cache key for get quiz required qtypes WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getQuizRequiredQtypesCacheKey = function (quizId) {
        return this.ROOT_CACHE_KEY + 'quizRequiredQtypes:' + quizId;
    };
    /**
     * Get the potential question types that would be required for a given quiz.
     *
     * @param {number} quizId Quiz ID.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the access information.
     */
    AddonModQuizProvider.prototype.getQuizRequiredQtypes = function (quizId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                quizid: quizId
            }, preSets = {
                cacheKey: _this.getQuizRequiredQtypesCacheKey(quizId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_quiz_required_qtypes', params, preSets).then(function (response) {
                if (response && response.questiontypes) {
                    return response.questiontypes;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Given an attempt's layout, return the list of pages.
     *
     * @param {string} layout Attempt's layout.
     * @return {number[]} Pages.
     * @description
     * An attempt's layout is a string with the question numbers separated by commas. A 0 indicates a change of page.
     * Example: 1,2,3,0,4,5,6,0
     * In the example above, first page has questions 1, 2 and 3. Second page has questions 4, 5 and 6.
     *
     * This function returns a list of pages.
     */
    AddonModQuizProvider.prototype.getPagesFromLayout = function (layout) {
        var split = layout.split(','), pages = [];
        var page = 0;
        for (var i = 0; i < split.length; i++) {
            if (split[i] == '0') {
                pages.push(page);
                page++;
            }
        }
        return pages;
    };
    /**
     * Given an attempt's layout and a list of questions identified by question slot,
     * return the list of pages that have at least 1 of the questions.
     *
     * @param {string} layout Attempt's layout.
     * @param {any} questions List of questions. It needs to be an object where the keys are question slot.
     * @return {number[]} Pages.
     * @description
     * An attempt's layout is a string with the question numbers separated by commas. A 0 indicates a change of page.
     * Example: 1,2,3,0,4,5,6,0
     * In the example above, first page has questions 1, 2 and 3. Second page has questions 4, 5 and 6.
     *
     * This function returns a list of pages.
     */
    AddonModQuizProvider.prototype.getPagesFromLayoutAndQuestions = function (layout, questions) {
        var split = layout.split(','), pages = [];
        var page = 0, pageAdded = false;
        for (var i = 0; i < split.length; i++) {
            var value = Number(split[i]);
            if (value == 0) {
                page++;
                pageAdded = false;
            }
            else if (!pageAdded && questions[value]) {
                pages.push(page);
                pageAdded = true;
            }
        }
        return pages;
    };
    /**
     * Given a list of question types, returns the types that aren't supported.
     *
     * @param {string[]} questionTypes Question types to check.
     * @return {string[]} Not supported question types.
     */
    AddonModQuizProvider.prototype.getUnsupportedQuestions = function (questionTypes) {
        var _this = this;
        var notSupported = [];
        questionTypes.forEach(function (type) {
            if (type != 'random' && !_this.questionDelegate.isQuestionSupported(type)) {
                notSupported.push(type);
            }
        });
        return notSupported;
    };
    /**
     * Given a list of access rules names, returns the rules that aren't supported.
     *
     * @param {string[]} rulesNames Rules to check.
     * @return {string[]} Not supported rules names.
     */
    AddonModQuizProvider.prototype.getUnsupportedRules = function (rulesNames) {
        var _this = this;
        var notSupported = [];
        rulesNames.forEach(function (name) {
            if (!_this.accessRulesDelegate.isAccessRuleSupported(name)) {
                notSupported.push(name);
            }
        });
        return notSupported;
    };
    /**
     * Get cache key for get user attempts WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getUserAttemptsCacheKey = function (quizId, userId) {
        return this.getUserAttemptsCommonCacheKey(quizId) + ':' + userId;
    };
    /**
     * Get common cache key for get user attempts WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getUserAttemptsCommonCacheKey = function (quizId) {
        return this.ROOT_CACHE_KEY + 'userAttempts:' + quizId;
    };
    /**
     * Get quiz attempts for a certain user.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} [status=all]  Status of the attempts to get. By default, 'all'.
     * @param {boolean} [includePreviews=true] Whether to include previews. Defaults to true.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any[]>} Promise resolved with the attempts.
     */
    AddonModQuizProvider.prototype.getUserAttempts = function (quizId, status, includePreviews, offline, ignoreCache, siteId, userId) {
        var _this = this;
        if (status === void 0) { status = 'all'; }
        if (includePreviews === void 0) { includePreviews = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                quizid: quizId,
                userid: userId,
                status: status,
                includepreviews: includePreviews ? 1 : 0
            }, preSets = {
                cacheKey: _this.getUserAttemptsCacheKey(quizId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_user_attempts', params, preSets).then(function (response) {
                if (response && response.attempts) {
                    return response.attempts;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get user best grade WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getUserBestGradeCacheKey = function (quizId, userId) {
        return this.getUserBestGradeCommonCacheKey(quizId) + ':' + userId;
    };
    /**
     * Get common cache key for get user best grade WS calls.
     *
     * @param {number} quizId Quiz ID.
     * @return {string} Cache key.
     */
    AddonModQuizProvider.prototype.getUserBestGradeCommonCacheKey = function (quizId) {
        return this.ROOT_CACHE_KEY + 'userBestGrade:' + quizId;
    };
    /**
     * Get best grade in a quiz for a certain user.
     *
     * @param {number} quizId Quiz ID.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved with the best grade data.
     */
    AddonModQuizProvider.prototype.getUserBestGrade = function (quizId, ignoreCache, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                quizid: quizId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getUserBestGradeCacheKey(quizId, userId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_quiz_get_user_best_grade', params, preSets);
        });
    };
    /**
     * Invalidates all the data related to a certain quiz.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} [courseId] Course ID.
     * @param {number} [attemptId] Attempt ID to invalidate some WS calls.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAllQuizData = function (quizId, courseId, attemptId, siteId, userId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.invalidateAttemptAccessInformation(quizId, siteId));
        promises.push(this.invalidateCombinedReviewOptionsForUser(quizId, siteId, userId));
        promises.push(this.invalidateFeedback(quizId, siteId));
        promises.push(this.invalidateQuizAccessInformation(quizId, siteId));
        promises.push(this.invalidateQuizRequiredQtypes(quizId, siteId));
        promises.push(this.invalidateUserAttemptsForUser(quizId, siteId, userId));
        promises.push(this.invalidateUserBestGradeForUser(quizId, siteId, userId));
        if (attemptId) {
            promises.push(this.invalidateAttemptData(attemptId, siteId));
            promises.push(this.invalidateAttemptReview(attemptId, siteId));
            promises.push(this.invalidateAttemptSummary(attemptId, siteId));
        }
        if (courseId) {
            promises.push(this.invalidateGradeFromGradebook(courseId, siteId, userId));
        }
        return Promise.all(promises);
    };
    /**
     * Invalidates attempt access information for all attempts in a quiz.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAttemptAccessInformation = function (quizId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getAttemptAccessInformationCommonCacheKey(quizId));
        });
    };
    /**
     * Invalidates attempt access information for an attempt.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAttemptAccessInformationForAttempt = function (quizId, attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAttemptAccessInformationCacheKey(quizId, attemptId));
        });
    };
    /**
     * Invalidates attempt data for all pages.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAttemptData = function (attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getAttemptDataCommonCacheKey(attemptId));
        });
    };
    /**
     * Invalidates attempt data for a certain page.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} page Page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAttemptDataForPage = function (attemptId, page, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAttemptDataCacheKey(attemptId, page));
        });
    };
    /**
     * Invalidates attempt review for all pages.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAttemptReview = function (attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getAttemptReviewCommonCacheKey(attemptId));
        });
    };
    /**
     * Invalidates attempt review for a certain page.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} page Page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAttemptReviewForPage = function (attemptId, page, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAttemptReviewCacheKey(attemptId, page));
        });
    };
    /**
     * Invalidates attempt summary.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateAttemptSummary = function (attemptId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAttemptSummaryCacheKey(attemptId));
        });
    };
    /**
     * Invalidates combined review options for all users.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateCombinedReviewOptions = function (quizId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getCombinedReviewOptionsCommonCacheKey(quizId));
        });
    };
    /**
     * Invalidates combined review options for a certain user.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateCombinedReviewOptionsForUser = function (quizId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCombinedReviewOptionsCacheKey(quizId, userId));
        });
    };
    /**
     * Invalidate the prefetched content except files.
     * To invalidate files, use AddonModQuizProvider.invalidateFiles.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Get required data to call the invalidate functions.
        return this.getQuiz(courseId, moduleId, true, false, siteId).then(function (quiz) {
            return _this.getUserAttempts(quiz.id, 'all', true, false, false, siteId).then(function (attempts) {
                // Now invalidate it.
                var lastAttemptId = attempts.length ? attempts[attempts.length - 1].id : undefined;
                return _this.invalidateAllQuizData(quiz.id, courseId, lastAttemptId, siteId);
            });
        });
    };
    /**
     * Invalidates feedback for all grades of a quiz.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateFeedback = function (quizId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getFeedbackForGradeCommonCacheKey(quizId));
        });
    };
    /**
     * Invalidates feedback for a certain grade.
     *
     * @param {number} quizId Quiz ID.
     * @param {number} grade Grade.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateFeedbackForGrade = function (quizId, grade, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getFeedbackForGradeCacheKey(quizId, grade));
        });
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param {number} moduleId The module ID.
     * @return {Promise<any>} Promise resolved when the files are invalidated.
     */
    AddonModQuizProvider.prototype.invalidateFiles = function (moduleId) {
        return this.filepoolProvider.invalidateFilesByComponent(this.sitesProvider.getCurrentSiteId(), AddonModQuizProvider_1.COMPONENT, moduleId);
    };
    /**
     * Invalidates grade from gradebook for a certain user.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateGradeFromGradebook = function (courseId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return _this.gradesHelper.invalidateGradeModuleItems(courseId, userId, null, siteId);
        });
    };
    /**
     * Invalidates quiz access information for a quiz.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateQuizAccessInformation = function (quizId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getQuizAccessInformationCacheKey(quizId));
        });
    };
    /**
     * Invalidates required qtypes for a quiz.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateQuizRequiredQtypes = function (quizId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getQuizRequiredQtypesCacheKey(quizId));
        });
    };
    /**
     * Invalidates user attempts for all users.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateUserAttempts = function (quizId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getUserAttemptsCommonCacheKey(quizId));
        });
    };
    /**
     * Invalidates user attempts for a certain user.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateUserAttemptsForUser = function (quizId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getUserAttemptsCacheKey(quizId, userId));
        });
    };
    /**
     * Invalidates user best grade for all users.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateUserBestGrade = function (quizId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getUserBestGradeCommonCacheKey(quizId));
        });
    };
    /**
     * Invalidates user best grade for a certain user.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateUserBestGradeForUser = function (quizId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getUserBestGradeCacheKey(quizId, userId));
        });
    };
    /**
     * Invalidates quiz data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizProvider.prototype.invalidateQuizData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getQuizDataCacheKey(courseId));
        });
    };
    /**
     * Check if an attempt is finished based on its state.
     *
     * @param {string} state Attempt's state.
     * @return {boolean} Whether it's finished.
     */
    AddonModQuizProvider.prototype.isAttemptFinished = function (state) {
        return state == AddonModQuizProvider_1.ATTEMPT_FINISHED || state == AddonModQuizProvider_1.ATTEMPT_ABANDONED;
    };
    /**
     * Check if an attempt is finished in offline but not synced.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if finished in offline but not synced, false otherwise.
     */
    AddonModQuizProvider.prototype.isAttemptFinishedOffline = function (attemptId, siteId) {
        return this.quizOfflineProvider.getAttemptById(attemptId, siteId).then(function (attempt) {
            return !!attempt.finished;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Check if an attempt is nearly over. We consider an attempt nearly over or over if:
     * - Is not in progress
     * OR
     * - It finished before autosaveperiod passes.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @return {boolean} Whether it's nearly over or over.
     */
    AddonModQuizProvider.prototype.isAttemptTimeNearlyOver = function (quiz, attempt) {
        if (attempt.state != AddonModQuizProvider_1.ATTEMPT_IN_PROGRESS) {
            // Attempt not in progress, return true.
            return true;
        }
        var dueDate = this.getAttemptDueDate(quiz, attempt), autoSavePeriod = quiz.autosaveperiod || 0;
        if (dueDate > 0 && Date.now() + autoSavePeriod >= dueDate) {
            return true;
        }
        return false;
    };
    /**
     * Check if last attempt is offline and unfinished.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, user current site's user.
     * @return {Promise<boolean>} Promise resolved with boolean: true if last offline attempt is unfinished, false otherwise.
     */
    AddonModQuizProvider.prototype.isLastAttemptOfflineUnfinished = function (quiz, siteId, userId) {
        return this.quizOfflineProvider.getQuizAttempts(quiz.id, siteId, userId).then(function (attempts) {
            var last = attempts.pop();
            return last && !last.finished;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Check if a quiz navigation is sequential.
     *
     * @param {any} quiz Quiz.
     * @return {boolean} Whether navigation is sequential.
     */
    AddonModQuizProvider.prototype.isNavigationSequential = function (quiz) {
        return quiz.navmethod == 'sequential';
    };
    /**
     * Return whether or not the plugin is enabled in a certain site. Plugin is enabled if the quiz WS are available.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean} Whether the plugin is enabled.
     */
    AddonModQuizProvider.prototype.isPluginEnabled = function (siteId) {
        // Quiz WebServices were introduced in 3.1, it will always be enabled.
        return true;
    };
    /**
     * Check if a question is blocked.
     *
     * @param {any} question Question.
     * @return {boolean} Whether it's blocked.
     */
    AddonModQuizProvider.prototype.isQuestionBlocked = function (question) {
        var element = this.domUtils.convertToElement(question.html);
        return !!element.querySelector('.mod_quiz-blocked_question_warning');
    };
    /**
     * Check if a quiz is enabled to be used in offline.
     *
     * @param {any} quiz Quiz.
     * @return {boolean} Whether offline is enabled.
     */
    AddonModQuizProvider.prototype.isQuizOffline = function (quiz) {
        // Don't allow downloading the quiz if offline is disabled to prevent wasting a lot of data when opening it.
        return !!quiz.allowofflineattempts && !this.sitesProvider.getCurrentSite().isOfflineDisabled();
    };
    /**
     * Given a list of attempts, add finishedOffline=true to those attempts that are finished in offline but not synced.
     *
     * @param {any[]} attempts List of attempts.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModQuizProvider.prototype.loadFinishedOfflineData = function (attempts, siteId) {
        if (attempts.length) {
            // We only need to check the last attempt because the user can only have 1 local attempt.
            var lastAttempt_1 = attempts[attempts.length - 1];
            return this.isAttemptFinishedOffline(lastAttempt_1.id, siteId).then(function (finished) {
                lastAttempt_1.finishedOffline = finished;
            });
        }
        return Promise.resolve();
    };
    /**
     * Report an attempt as being viewed. It did not store logs offline because order of the log is important.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} [page=0] Page number.
     * @param {any} [preflightData] Preflight required data (like password).
     * @param {boolean} [offline] Whether attempt is offline.
     * @param {string} [quiz] Quiz instance. If set, a Firebase event will be stored.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModQuizProvider.prototype.logViewAttempt = function (attemptId, page, preflightData, offline, quiz, siteId) {
        var _this = this;
        if (page === void 0) { page = 0; }
        if (preflightData === void 0) { preflightData = {}; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                attemptid: attemptId,
                page: page,
                preflightdata: _this.utils.objectToArrayOfObjects(preflightData, 'name', 'value', true)
            }, promises = [];
            promises.push(site.write('mod_quiz_view_attempt', params));
            if (offline) {
                promises.push(_this.quizOfflineProvider.setAttemptCurrentPage(attemptId, page, site.getId()));
            }
            if (quiz) {
                _this.pushNotificationsProvider.logViewEvent(quiz.id, quiz.name, 'quiz', 'mod_quiz_view_attempt', { attemptid: attemptId, page: page }, siteId);
            }
            return Promise.all(promises);
        });
    };
    /**
     * Report an attempt's review as being viewed.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} quizId Quiz ID.
     * @param {string} [name] Name of the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModQuizProvider.prototype.logViewAttemptReview = function (attemptId, quizId, name, siteId) {
        var params = {
            attemptid: attemptId
        };
        return this.logHelper.logSingle('mod_quiz_view_attempt_review', params, AddonModQuizProvider_1.COMPONENT, quizId, name, 'quiz', params, siteId);
    };
    /**
     * Report an attempt's summary as being viewed.
     *
     * @param {number} attemptId Attempt ID.
     * @param {any} preflightData Preflight required data (like password).
     * @param {number} quizId Quiz ID.
     * @param {string} [name] Name of the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModQuizProvider.prototype.logViewAttemptSummary = function (attemptId, preflightData, quizId, name, siteId) {
        var params = {
            attemptid: attemptId,
            preflightdata: this.utils.objectToArrayOfObjects(preflightData, 'name', 'value', true)
        };
        return this.logHelper.logSingle('mod_quiz_view_attempt_summary', params, AddonModQuizProvider_1.COMPONENT, quizId, name, 'quiz', { attemptid: attemptId }, siteId);
    };
    /**
     * Report a quiz as being viewed.
     *
     * @param {number} id Module ID.
     * @param {string} [name] Name of the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModQuizProvider.prototype.logViewQuiz = function (id, name, siteId) {
        var params = {
            quizid: id
        };
        return this.logHelper.logSingle('mod_quiz_view_quiz', params, AddonModQuizProvider_1.COMPONENT, id, name, 'quiz', {}, siteId);
    };
    /**
     * Process an attempt, saving its data.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} data Data to save.
     * @param {any} preflightData Preflight required data (like password).
     * @param {boolean} [finish] Whether to finish the quiz.
     * @param {boolean} [timeUp] Whether the quiz time is up, false otherwise.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModQuizProvider.prototype.processAttempt = function (quiz, attempt, data, preflightData, finish, timeUp, offline, siteId) {
        if (offline) {
            return this.processAttemptOffline(quiz, attempt, data, preflightData, finish, siteId);
        }
        return this.processAttemptOnline(attempt.id, data, preflightData, finish, timeUp, siteId);
    };
    /**
     * Process an online attempt, saving its data.
     *
     * @param {number} attemptId Attempt ID.
     * @param {any} data Data to save.
     * @param {any} preflightData Preflight required data (like password).
     * @param {boolean} [finish] Whether to finish the quiz.
     * @param {boolean} [timeUp] Whether the quiz time is up, false otherwise.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModQuizProvider.prototype.processAttemptOnline = function (attemptId, data, preflightData, finish, timeUp, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                attemptid: attemptId,
                data: _this.utils.objectToArrayOfObjects(data, 'name', 'value'),
                finishattempt: finish ? 1 : 0,
                timeup: timeUp ? 1 : 0,
                preflightdata: _this.utils.objectToArrayOfObjects(preflightData, 'name', 'value')
            };
            return site.write('mod_quiz_process_attempt', params).then(function (response) {
                if (response && response.warnings && response.warnings.length) {
                    // Reject with the first warning.
                    return Promise.reject(response.warnings[0]);
                }
                else if (response && response.state) {
                    return response.state;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Process an offline attempt, saving its data.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} data Data to save.
     * @param {any} preflightData Preflight required data (like password).
     * @param {boolean} [finish] Whether to finish the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModQuizProvider.prototype.processAttemptOffline = function (quiz, attempt, data, preflightData, finish, siteId) {
        var _this = this;
        // Get attempt summary to have the list of questions.
        return this.getAttemptSummary(attempt.id, preflightData, true, false, true, siteId).then(function (questionArray) {
            // Convert the question array to an object.
            var questions = _this.utils.arrayToObject(questionArray, 'slot');
            return _this.quizOfflineProvider.processAttempt(quiz, attempt, questions, data, finish, siteId);
        });
    };
    /**
     * Check if it's a graded quiz. Based on Moodle's quiz_has_grades.
     *
     * @param {any} quiz Quiz.
     * @return {boolean} Whether quiz is graded.
     */
    AddonModQuizProvider.prototype.quizHasGrades = function (quiz) {
        return quiz.grade >= 0.000005 && quiz.sumgrades >= 0.000005;
    };
    /**
     * Convert the raw grade into a grade out of the maximum grade for this quiz.
     * Based on Moodle's quiz_rescale_grade.
     *
     * @param {string} rawGrade The unadjusted grade, for example attempt.sumgrades.
     * @param {any} quiz Quiz.
     * @param {boolean|string} format True to format the results for display, 'question' to format a question grade
     *                                 (different number of decimal places), false to not format it.
     * @return {string} Grade to display.
     */
    AddonModQuizProvider.prototype.rescaleGrade = function (rawGrade, quiz, format) {
        if (format === void 0) { format = true; }
        var grade;
        var rawGradeNum = parseFloat(rawGrade);
        if (!isNaN(rawGradeNum)) {
            if (quiz.sumgrades >= 0.000005) {
                grade = rawGradeNum * quiz.grade / quiz.sumgrades;
            }
            else {
                grade = 0;
            }
        }
        if (format === 'question') {
            return this.formatGrade(grade, this.getGradeDecimals(quiz));
        }
        else if (format) {
            return this.formatGrade(grade, quiz.decimalpoints);
        }
        if (grade === null) {
            return null;
        }
        else if (typeof grade == 'undefined') {
            return undefined;
        }
        return String(grade);
    };
    /**
     * Save an attempt data.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} data Data to save.
     * @param {any} preflightData Preflight required data (like password).
     * @param {boolean} [offline] Whether attempt is offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModQuizProvider.prototype.saveAttempt = function (quiz, attempt, data, preflightData, offline, siteId) {
        try {
            if (offline) {
                return this.processAttemptOffline(quiz, attempt, data, preflightData, false, siteId);
            }
            return this.saveAttemptOnline(attempt.id, data, preflightData, siteId);
        }
        catch (ex) {
            this.logger.error(ex);
            return Promise.reject(null);
        }
    };
    /**
     * Save an attempt data.
     *
     * @param {number} attemptId Attempt ID.
     * @param {any} data Data to save.
     * @param {any} preflightData Preflight required data (like password).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<void>} Promise resolved in success, rejected otherwise.
     */
    AddonModQuizProvider.prototype.saveAttemptOnline = function (attemptId, data, preflightData, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                attemptid: attemptId,
                data: _this.utils.objectToArrayOfObjects(data, 'name', 'value'),
                preflightdata: _this.utils.objectToArrayOfObjects(preflightData, 'name', 'value')
            };
            return site.write('mod_quiz_save_attempt', params).then(function (response) {
                if (response && response.warnings && response.warnings.length) {
                    // Reject with the first warning.
                    return Promise.reject(response.warnings[0]);
                }
                else if (!response || !response.status) {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Check if time left should be shown.
     *
     * @param {string[]} rules List of active rules names.
     * @param {any} attempt Attempt.
     * @param {number} endTime The attempt end time (in seconds).
     * @return {boolean} Whether time left should be displayed.
     */
    AddonModQuizProvider.prototype.shouldShowTimeLeft = function (rules, attempt, endTime) {
        var timeNow = this.timeUtils.timestamp();
        if (attempt.state != AddonModQuizProvider_1.ATTEMPT_IN_PROGRESS) {
            return false;
        }
        return this.accessRulesDelegate.shouldShowTimeLeft(rules, attempt, endTime, timeNow);
    };
    /**
     * Start an attempt.
     *
     * @param {number} quizId Quiz ID.
     * @param {any} preflightData Preflight required data (like password).
     * @param {boolean} [forceNew] Whether to force a new attempt or not.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the attempt data.
     */
    AddonModQuizProvider.prototype.startAttempt = function (quizId, preflightData, forceNew, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                quizid: quizId,
                preflightdata: _this.utils.objectToArrayOfObjects(preflightData, 'name', 'value', true),
                forcenew: forceNew ? 1 : 0
            };
            return site.write('mod_quiz_start_attempt', params).then(function (response) {
                if (response && response.warnings && response.warnings.length) {
                    // Reject with the first warning.
                    return Promise.reject(response.warnings[0]);
                }
                else if (response && response.attempt) {
                    return response.attempt;
                }
                return Promise.reject(null);
            });
        });
    };
    AddonModQuizProvider.COMPONENT = 'mmaModQuiz';
    AddonModQuizProvider.ATTEMPT_FINISHED_EVENT = 'addon_mod_quiz_attempt_finished';
    // Grade methods.
    AddonModQuizProvider.GRADEHIGHEST = 1;
    AddonModQuizProvider.GRADEAVERAGE = 2;
    AddonModQuizProvider.ATTEMPTFIRST = 3;
    AddonModQuizProvider.ATTEMPTLAST = 4;
    // Question options.
    AddonModQuizProvider.QUESTION_OPTIONS_MAX_ONLY = 1;
    AddonModQuizProvider.QUESTION_OPTIONS_MARK_AND_MAX = 2;
    // Attempt state.
    AddonModQuizProvider.ATTEMPT_IN_PROGRESS = 'inprogress';
    AddonModQuizProvider.ATTEMPT_OVERDUE = 'overdue';
    AddonModQuizProvider.ATTEMPT_FINISHED = 'finished';
    AddonModQuizProvider.ATTEMPT_ABANDONED = 'abandoned';
    // Show the countdown timer if there is less than this amount of time left before the the quiz close date.
    AddonModQuizProvider.QUIZ_SHOW_TIME_BEFORE_DEADLINE = 3600;
    AddonModQuizProvider = AddonModQuizProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_grades_providers_helper__["a" /* CoreGradesHelperProvider */], __WEBPACK_IMPORTED_MODULE_11__core_question_providers_delegate__["a" /* CoreQuestionDelegate */],
            __WEBPACK_IMPORTED_MODULE_2__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_14__quiz_offline__["a" /* AddonModQuizOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_15__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], AddonModQuizProvider);
    return AddonModQuizProvider;
    var AddonModQuizProvider_1;
}());

//# sourceMappingURL=quiz.js.map

/***/ }),
/* 100 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__offline__ = __webpack_require__(169);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Service that provides some features for forums.
 */
var AddonModForumProvider = /** @class */ (function () {
    function AddonModForumProvider(appProvider, sitesProvider, groupsProvider, filepoolProvider, userProvider, translate, utils, forumOffline, logHelper) {
        this.appProvider = appProvider;
        this.sitesProvider = sitesProvider;
        this.groupsProvider = groupsProvider;
        this.filepoolProvider = filepoolProvider;
        this.userProvider = userProvider;
        this.translate = translate;
        this.utils = utils;
        this.forumOffline = forumOffline;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModForum:';
    }
    AddonModForumProvider_1 = AddonModForumProvider;
    /**
     * Get cache key for can add discussion WS calls.
     *
     * @param  {number} forumId Forum ID.
     * @param  {number} groupId Group ID.
     * @return {string}         Cache key.
     */
    AddonModForumProvider.prototype.getCanAddDiscussionCacheKey = function (forumId, groupId) {
        return this.getCommonCanAddDiscussionCacheKey(forumId) + groupId;
    };
    /**
     * Get common part of cache key for can add discussion WS calls.
     *
     * @param  {number} forumId Forum ID.
     * @return {string}         Cache key.
     */
    AddonModForumProvider.prototype.getCommonCanAddDiscussionCacheKey = function (forumId) {
        return this.ROOT_CACHE_KEY + 'canadddiscussion:' + forumId + ':';
    };
    /**
     * Get cache key for forum data WS calls.
     *
     * @param  {number} courseId Course ID.
     * @return {string}          Cache key.
     */
    AddonModForumProvider.prototype.getForumDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'forum:' + courseId;
    };
    /**
     * Get cache key for forum access information WS calls.
     *
     * @param  {number} forumId Forum ID.
     * @return {string}         Cache key.
     */
    AddonModForumProvider.prototype.getAccessInformationCacheKey = function (forumId) {
        return this.ROOT_CACHE_KEY + 'accessInformation:' + forumId;
    };
    /**
     * Get cache key for forum discussion posts WS calls.
     *
     * @param  {number} discussionId Discussion ID.
     * @return {string}              Cache key.
     */
    AddonModForumProvider.prototype.getDiscussionPostsCacheKey = function (discussionId) {
        return this.ROOT_CACHE_KEY + 'discussion:' + discussionId;
    };
    /**
     * Get cache key for forum discussions list WS calls.
     *
     * @param  {number} forumId Forum ID.
     * @param  {number} sortOrder Sort order.
     * @return {string} Cache key.
     */
    AddonModForumProvider.prototype.getDiscussionsListCacheKey = function (forumId, sortOrder) {
        var key = this.ROOT_CACHE_KEY + 'discussions:' + forumId;
        if (sortOrder != AddonModForumProvider_1.SORTORDER_LASTPOST_DESC) {
            key += ':' + sortOrder;
        }
        return key;
    };
    /**
     * Add a new discussion. It will fail if offline or cannot connect.
     *
     * @param  {number} forumId   Forum ID.
     * @param  {string} subject   New discussion's subject.
     * @param  {string} message   New discussion's message.
     * @param  {any}    [options] Options (subscribe, pin, ...).
     * @param  {string} [groupId] Group this discussion belongs to.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>}     Promise resolved when the discussion is created.
     */
    AddonModForumProvider.prototype.addNewDiscussionOnline = function (forumId, subject, message, options, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                forumid: forumId,
                subject: subject,
                message: message,
                options: _this.utils.objectToArrayOfObjects(options, 'name', 'value')
            };
            if (groupId) {
                params.groupid = groupId;
            }
            return site.write('mod_forum_add_discussion', params).then(function (response) {
                // Other errors ocurring.
                if (!response || !response.discussionid) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                else {
                    return response.discussionid;
                }
            });
        });
    };
    /**
     * Check if a user can post to a certain group.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {number} groupId  Group ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved with an object with the following properties:
     *                            - status (boolean)
     *                            - canpindiscussions (boolean)
     *                            - cancreateattachment (boolean)
     */
    AddonModForumProvider.prototype.canAddDiscussion = function (forumId, groupId, siteId) {
        var params = {
            forumid: forumId,
            groupid: groupId
        };
        var preSets = {
            cacheKey: this.getCanAddDiscussionCacheKey(forumId, groupId)
        };
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.read('mod_forum_can_add_discussion', params, preSets).then(function (result) {
                if (result) {
                    if (typeof result.canpindiscussions == 'undefined') {
                        // WS doesn't support it yet, default it to false to prevent students from seing the option.
                        result.canpindiscussions = false;
                    }
                    if (typeof result.cancreateattachment == 'undefined') {
                        // WS doesn't support it yet, default it to true since usually the users will be able to create them.
                        result.cancreateattachment = true;
                    }
                    return result;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Check if a user can post to all groups.
     *
     * @param  {number} forumId Forum ID.
     * @return {Promise<any>}   Promise resolved with an object with the following properties:
     *                           - status (boolean)
     *                           - canpindiscussions (boolean)
     *                           - cancreateattachment (boolean)
     */
    AddonModForumProvider.prototype.canAddDiscussionToAll = function (forumId) {
        return this.canAddDiscussion(forumId, AddonModForumProvider_1.ALL_PARTICIPANTS);
    };
    /**
     * Extract the starting post of a discussion from a list of posts. The post is removed from the array passed as a parameter.
     *
     * @param  {any[]} posts Posts to search.
     * @return {any}         Starting post or undefined if not found.
     */
    AddonModForumProvider.prototype.extractStartingPost = function (posts) {
        // Check the last post first, since they'll usually be ordered by create time.
        for (var i = posts.length - 1; i >= 0; i--) {
            if (posts[i].parent == 0) {
                return posts.splice(i, 1).pop(); // Remove it from the array.
            }
        }
        return undefined;
    };
    /**
     * There was a bug adding new discussions to All Participants (see MDL-57962). Check if it's fixed.
     *
     * @return {boolean} True if fixed, false otherwise.
     */
    AddonModForumProvider.prototype.isAllParticipantsFixed = function () {
        return this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan(['3.1.5', '3.2.2']);
    };
    /**
     * Format discussions, setting groupname if the discussion group is valid.
     *
     * @param  {number} cmId        Forum cmid.
     * @param  {any[]}  discussions List of discussions to format.
     * @return {Promise<any[]>}     Promise resolved with the formatted discussions.
     */
    AddonModForumProvider.prototype.formatDiscussionsGroups = function (cmId, discussions) {
        var _this = this;
        discussions = this.utils.clone(discussions);
        return this.groupsProvider.getActivityAllowedGroups(cmId).then(function (forumGroups) {
            var strAllParts = _this.translate.instant('core.allparticipants');
            var strAllGroups = _this.translate.instant('core.allgroups');
            // Turn groups into an object where each group is identified by id.
            var groups = {};
            forumGroups.forEach(function (fg) {
                groups[fg.id] = fg;
            });
            // Format discussions.
            discussions.forEach(function (disc) {
                if (disc.groupid == AddonModForumProvider_1.ALL_PARTICIPANTS) {
                    disc.groupname = strAllParts;
                }
                else if (disc.groupid == AddonModForumProvider_1.ALL_GROUPS) {
                    // Offline discussions only.
                    disc.groupname = strAllGroups;
                }
                else {
                    var group = groups[disc.groupid];
                    if (group) {
                        disc.groupname = group.name;
                    }
                }
            });
            return discussions;
        }).catch(function () {
            return discussions;
        });
    };
    /**
     * Get all course forums.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved when the forums are retrieved.
     */
    AddonModForumProvider.prototype.getCourseForums = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            };
            var preSets = {
                cacheKey: _this.getForumDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_forum_get_forums_by_courses', params, preSets);
        });
    };
    /**
     * Get a forum by course module ID.
     *
     * @param  {number} courseId Course ID.
     * @param  {number} cmId     Course module ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the forum is retrieved.
     */
    AddonModForumProvider.prototype.getForum = function (courseId, cmId, siteId) {
        return this.getCourseForums(courseId, siteId).then(function (forums) {
            var forum = forums.find(function (forum) { return forum.cmid == cmId; });
            if (forum) {
                return forum;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get a forum by forum ID.
     *
     * @param  {number} courseId Course ID.
     * @param  {number} forumId  Forum ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the forum is retrieved.
     */
    AddonModForumProvider.prototype.getForumById = function (courseId, forumId, siteId) {
        return this.getCourseForums(courseId, siteId).then(function (forums) {
            var forum = forums.find(function (forum) { return forum.id == forumId; });
            if (forum) {
                return forum;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get access information for a given forum.
     *
     * @param  {number}  forumId      Forum ID.
     * @param  {boolean} [forceCache] True to always get the value from cache. false otherwise.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>} Object with access information.
     * @since 3.7
     */
    AddonModForumProvider.prototype.getAccessInformation = function (forumId, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.wsAvailable('mod_forum_get_forum_access_information')) {
                // Access information not available for 3.6 or older sites.
                return Promise.resolve({});
            }
            var params = {
                forumid: forumId
            };
            var preSets = {
                cacheKey: _this.getAccessInformationCacheKey(forumId),
                omitExpires: forceCache
            };
            return site.read('mod_forum_get_forum_access_information', params, preSets);
        });
    };
    /**
     * Get forum discussion posts.
     *
     * @param  {number} discussionId Discussion ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<{posts: any[], ratinginfo?: CoreRatingInfo}>} Promise resolved with forum posts and rating info.
     */
    AddonModForumProvider.prototype.getDiscussionPosts = function (discussionId, siteId) {
        var _this = this;
        var params = {
            discussionid: discussionId
        };
        var preSets = {
            cacheKey: this.getDiscussionPostsCacheKey(discussionId)
        };
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.read('mod_forum_get_forum_discussion_posts', params, preSets).then(function (response) {
                if (response) {
                    _this.storeUserData(response.posts);
                    return response;
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Sort forum discussion posts by an specified field.
     *
     * @param {any[]}  posts     Discussion posts to be sorted in place.
     * @param {string} direction Direction of the sorting (ASC / DESC).
     */
    AddonModForumProvider.prototype.sortDiscussionPosts = function (posts, direction) {
        // @todo: Check children when sorting.
        posts.sort(function (a, b) {
            a = parseInt(a.created, 10);
            b = parseInt(b.created, 10);
            if (direction == 'ASC') {
                return a - b;
            }
            else {
                return b - a;
            }
        });
    };
    /**
     * Return whether discussion lists can be sorted.
     *
     * @param {CoreSite} [site] Site. If not defined, current site.
     * @return {boolean} True if discussion lists can be sorted.
     */
    AddonModForumProvider.prototype.isDiscussionListSortingAvailable = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isVersionGreaterEqualThan('3.7');
    };
    /**
     * Return the list of available sort orders.
     *
     * @return {{label: string, value: number}[]} List of sort orders.
     */
    AddonModForumProvider.prototype.getAvailableSortOrders = function () {
        var sortOrders = [
            {
                label: 'addon.mod_forum.discussionlistsortbylastpostdesc',
                value: AddonModForumProvider_1.SORTORDER_LASTPOST_DESC
            },
        ];
        if (this.isDiscussionListSortingAvailable()) {
            sortOrders.push({
                label: 'addon.mod_forum.discussionlistsortbylastpostasc',
                value: AddonModForumProvider_1.SORTORDER_LASTPOST_ASC
            }, {
                label: 'addon.mod_forum.discussionlistsortbycreateddesc',
                value: AddonModForumProvider_1.SORTORDER_CREATED_DESC
            }, {
                label: 'addon.mod_forum.discussionlistsortbycreatedasc',
                value: AddonModForumProvider_1.SORTORDER_CREATED_ASC
            }, {
                label: 'addon.mod_forum.discussionlistsortbyrepliesdesc',
                value: AddonModForumProvider_1.SORTORDER_REPLIES_DESC
            }, {
                label: 'addon.mod_forum.discussionlistsortbyrepliesasc',
                value: AddonModForumProvider_1.SORTORDER_REPLIES_ASC
            });
        }
        return sortOrders;
    };
    /**
     * Get forum discussions.
     *
     * @param  {number}  forumId      Forum ID.
     * @param  {number}  [sortOrder]  Sort order.
     * @param  {number}  [page=0]     Page.
     * @param  {boolean} [forceCache] True to always get the value from cache. false otherwise.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved with an object with:
     *                                 - discussions: List of discussions.
     *                                 - canLoadMore: True if there may be more discussions to load.
     */
    AddonModForumProvider.prototype.getDiscussions = function (forumId, sortOrder, page, forceCache, siteId) {
        var _this = this;
        if (page === void 0) { page = 0; }
        sortOrder = sortOrder || AddonModForumProvider_1.SORTORDER_LASTPOST_DESC;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var method = 'mod_forum_get_forum_discussions_paginated';
            var params = {
                forumid: forumId,
                page: page,
                perpage: AddonModForumProvider_1.DISCUSSIONS_PER_PAGE
            };
            if (site.wsAvailable('mod_forum_get_forum_discussions')) {
                // Since Moodle 3.7.
                method = 'mod_forum_get_forum_discussions';
                params.sortorder = sortOrder;
            }
            else {
                if (sortOrder == AddonModForumProvider_1.SORTORDER_LASTPOST_DESC) {
                    params.sortby = 'timemodified';
                    params.sortdirection = 'DESC';
                }
                else {
                    // Sorting not supported with the old WS method.
                    return Promise.reject(null);
                }
            }
            var preSets = {
                cacheKey: _this.getDiscussionsListCacheKey(forumId, sortOrder)
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            return site.read(method, params, preSets).catch(function (error) {
                // Try to get the data from cache stored with the old WS method.
                if (!_this.appProvider.isOnline() && method == 'mod_forum_get_forum_discussion' &&
                    sortOrder == AddonModForumProvider_1.SORTORDER_LASTPOST_DESC) {
                    var params_1 = {
                        forumid: forumId,
                        page: page,
                        perpage: AddonModForumProvider_1.DISCUSSIONS_PER_PAGE,
                        sortby: 'timemodified',
                        sortdirection: 'DESC'
                    };
                    var preSets_1 = {
                        cacheKey: _this.getDiscussionsListCacheKey(forumId, sortOrder),
                        omitExpires: true
                    };
                    return site.read('mod_forum_get_forum_discussions_paginated', params_1, preSets_1);
                }
                return Promise.reject(error);
            }).then(function (response) {
                if (response) {
                    _this.storeUserData(response.discussions);
                    return Promise.resolve({
                        discussions: response.discussions,
                        canLoadMore: response.discussions.length >= AddonModForumProvider_1.DISCUSSIONS_PER_PAGE,
                    });
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Get forum discussions in several pages.
     * If a page fails, the discussions until that page will be returned along with a flag indicating an error occurred.
     *
     * @param  {number}  forumId     Forum ID.
     * @param  {number}  [sortOrder] Sort order.
     * @param  {boolean} [forceCache] True to always get the value from cache, false otherwise.
     * @param  {number}  [numPages]  Number of pages to get. If not defined, all pages.
     * @param  {number}  [startPage] Page to start. If not defined, first page.
     * @param  {string}  [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with an object with:
     *                                - discussions: List of discussions.
     *                                - error: True if an error occurred, false otherwise.
     */
    AddonModForumProvider.prototype.getDiscussionsInPages = function (forumId, sortOrder, forceCache, numPages, startPage, siteId) {
        var _this = this;
        if (typeof numPages == 'undefined') {
            numPages = -1;
        }
        startPage = startPage || 0;
        var result = {
            discussions: [],
            error: false
        };
        if (!numPages) {
            return Promise.resolve(result);
        }
        var getPage = function (page) {
            // Get page discussions.
            return _this.getDiscussions(forumId, sortOrder, page, forceCache, siteId).then(function (response) {
                result.discussions = result.discussions.concat(response.discussions);
                numPages--;
                if (response.canLoadMore && numPages !== 0) {
                    return getPage(page + 1); // Get next page.
                }
                else {
                    return result;
                }
            }).catch(function () {
                // Error getting a page.
                result.error = true;
                return result;
            });
        };
        return getPage(startPage);
    };
    /**
     * Invalidates can add discussion WS calls.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModForumProvider.prototype.invalidateCanAddDiscussion = function (forumId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getCommonCanAddDiscussionCacheKey(forumId));
        });
    };
    /**
     * Invalidate the prefetched content except files.
     * To invalidate files, use AddonModForum#invalidateFiles.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID.
     * @return {Promise<any>}    Promise resolved when data is invalidated.
     */
    AddonModForumProvider.prototype.invalidateContent = function (moduleId, courseId) {
        var _this = this;
        // Get the forum first, we need the forum ID.
        return this.getForum(courseId, moduleId).then(function (forum) {
            var promises = [];
            promises.push(_this.invalidateForumData(courseId));
            promises.push(_this.invalidateDiscussionsList(forum.id));
            promises.push(_this.invalidateCanAddDiscussion(forum.id));
            promises.push(_this.invalidateAccessInformation(forum.id));
            _this.getAvailableSortOrders().forEach(function (sortOrder) {
                // We need to get the list of discussions to be able to invalidate their posts.
                promises.push(_this.getDiscussionsInPages(forum.id, sortOrder.value, true).then(function (response) {
                    // Now invalidate the WS calls.
                    var promises = [];
                    response.discussions.forEach(function (discussion) {
                        promises.push(_this.invalidateDiscussionPosts(discussion.discussion));
                    });
                    return _this.utils.allPromises(promises);
                }));
            });
            if (_this.isDiscussionListSortingAvailable()) {
                promises.push(_this.userProvider.invalidateUserPreference(AddonModForumProvider_1.PREFERENCE_SORTORDER));
            }
            return _this.utils.allPromises(promises);
        });
    };
    /**
     * Invalidates access information.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModForumProvider.prototype.invalidateAccessInformation = function (forumId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAccessInformationCacheKey(forumId));
        });
    };
    /**
     * Invalidates forum discussion posts.
     *
     * @param  {number} discussionId Discussion ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModForumProvider.prototype.invalidateDiscussionPosts = function (discussionId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getDiscussionPostsCacheKey(discussionId));
        });
    };
    /**
     * Invalidates discussion list.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModForumProvider.prototype.invalidateDiscussionsList = function (forumId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.utils.allPromises(_this.getAvailableSortOrders().map(function (sortOrder) {
                return site.invalidateWsCacheForKey(_this.getDiscussionsListCacheKey(forumId, sortOrder.value));
            }));
        });
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param  {number} moduleId The module ID.
     * @return {Promise<any>}   Promise resolved when the files are invalidated.
     */
    AddonModForumProvider.prototype.invalidateFiles = function (moduleId) {
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModForumProvider_1.COMPONENT, moduleId);
    };
    /**
     * Invalidates forum data.
     *
     * @param  {number} courseId Course ID.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModForumProvider.prototype.invalidateForumData = function (courseId) {
        return this.sitesProvider.getCurrentSite().invalidateWsCacheForKey(this.getForumDataCacheKey(courseId));
    };
    /**
     * Report a forum as being viewed.
     *
     * @param  {number} id    Module ID.
     * @param {string} [name] Name of the forum.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModForumProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            forumid: id
        };
        return this.logHelper.logSingle('mod_forum_view_forum', params, AddonModForumProvider_1.COMPONENT, id, name, 'forum', {}, siteId);
    };
    /**
     * Report a forum discussion as being viewed.
     *
     * @param  {number} id    Discussion ID.
     * @param  {number} forumId  Forum ID.
     * @param {string} [name] Name of the forum.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModForumProvider.prototype.logDiscussionView = function (id, forumId, name, siteId) {
        var params = {
            discussionid: id
        };
        return this.logHelper.logSingle('mod_forum_view_forum_discussion', params, AddonModForumProvider_1.COMPONENT, forumId, name, 'forum', params, siteId);
    };
    /**
     * Reply to a certain post.
     *
     * @param  {number}  postId         ID of the post being replied.
     * @param  {number}  discussionId   ID of the discussion the user is replying to.
     * @param  {number}  forumId        ID of the forum the user is replying to.
     * @param  {string}  name           Forum name.
     * @param  {number}  courseId       Course ID the forum belongs to.
     * @param  {string}  subject        New post's subject.
     * @param  {string}  message        New post's message.
     * @param  {any}     [options]      Options (subscribe, attachments, ...).
     * @param  {string}  [siteId]       Site ID. If not defined, current site.
     * @param  {boolean} [allowOffline] True if it can be stored in offline, false otherwise.
     * @return {Promise<any>}           Promise resolved with post ID if sent online, resolved with false if stored offline.
     */
    AddonModForumProvider.prototype.replyPost = function (postId, discussionId, forumId, name, courseId, subject, message, options, siteId, allowOffline) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            if (!forumId) {
                // Not enough data to store in offline, reject.
                return Promise.reject(_this.translate.instant('core.networkerrormsg'));
            }
            return _this.forumOffline.replyPost(postId, discussionId, forumId, name, courseId, subject, message, options, siteId)
                .then(function () {
                return false;
            });
        };
        if (!this.appProvider.isOnline() && allowOffline) {
            // App is offline, store the action.
            return storeOffline();
        }
        // If there's already a reply to be sent to the server, discard it first.
        return this.forumOffline.deleteReply(postId, siteId).then(function () {
            return _this.replyPostOnline(postId, subject, message, options, siteId).then(function () {
                return true;
            }).catch(function (error) {
                if (allowOffline && !_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Reply to a certain post. It will fail if offline or cannot connect.
     *
     * @param  {number} postId    ID of the post being replied.
     * @param  {string} subject   New post's subject.
     * @param  {string} message   New post's message.
     * @param  {any}    [options] Options (subscribe, attachments, ...).
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<number>}  Promise resolved with the created post id.
     */
    AddonModForumProvider.prototype.replyPostOnline = function (postId, subject, message, options, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                postid: postId,
                subject: subject,
                message: message,
                options: _this.utils.objectToArrayOfObjects(options, 'name', 'value')
            };
            return site.write('mod_forum_add_discussion_post', params).then(function (response) {
                if (!response || !response.postid) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                else {
                    return response.postid;
                }
            });
        });
    };
    /**
     * Lock or unlock a discussion.
     *
     * @param {number} forumId Forum id.
     * @param {number} discussionId DIscussion id.
     * @param {boolean} locked True to lock, false to unlock.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resvoled when done.
     * @since 3.7
     */
    AddonModForumProvider.prototype.setLockState = function (forumId, discussionId, locked, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                forumid: forumId,
                discussionid: discussionId,
                targetstate: locked ? 0 : 1
            };
            return site.write('mod_forum_set_lock_state', params);
        });
    };
    /**
     * Returns whether the set pin state WS is available.
     *
     * @param  {CoreSite} [site] Site. If not defined, current site.
     * @return {boolean} Whether it's available.
     * @since 3.7
     */
    AddonModForumProvider.prototype.isSetPinStateAvailableForSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return this.sitesProvider.wsAvailableInCurrentSite('mod_forum_set_pin_state');
    };
    /**
     * Pin or unpin a discussion.
     *
     * @param {number} discussionId Discussion id.
     * @param {boolean} locked True to pin, false to unpin.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resvoled when done.
     * @since 3.7
     */
    AddonModForumProvider.prototype.setPinState = function (discussionId, pinned, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                discussionid: discussionId,
                targetstate: pinned ? 1 : 0
            };
            return site.write('mod_forum_set_pin_state', params);
        });
    };
    /**
     * Star or unstar a discussion.
     *
     * @param {number} discussionId Discussion id.
     * @param {boolean} starred True to star, false to unstar.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resvoled when done.
     * @since 3.7
     */
    AddonModForumProvider.prototype.toggleFavouriteState = function (discussionId, starred, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                discussionid: discussionId,
                targetstate: starred ? 1 : 0
            };
            return site.write('mod_forum_toggle_favourite_state', params);
        });
    };
    /**
     * Store the users data from a discussions/posts list.
     *
     * @param {any[]} list Array of posts or discussions.
     */
    AddonModForumProvider.prototype.storeUserData = function (list) {
        var users = {};
        list.forEach(function (entry) {
            var userId = parseInt(entry.userid);
            if (!isNaN(userId) && !users[userId]) {
                users[userId] = {
                    id: userId,
                    fullname: entry.userfullname,
                    profileimageurl: entry.userpictureurl
                };
            }
            var userModified = parseInt(entry.usermodified);
            if (!isNaN(userModified) && !users[userModified]) {
                users[userModified] = {
                    id: userModified,
                    fullname: entry.usermodifiedfullname,
                    profileimageurl: entry.usermodifiedpictureurl
                };
            }
        });
        this.userProvider.storeUsers(this.utils.objectToArray(users));
    };
    AddonModForumProvider.COMPONENT = 'mmaModForum';
    AddonModForumProvider.DISCUSSIONS_PER_PAGE = 10; // Max of discussions per page.
    AddonModForumProvider.NEW_DISCUSSION_EVENT = 'addon_mod_forum_new_discussion';
    AddonModForumProvider.REPLY_DISCUSSION_EVENT = 'addon_mod_forum_reply_discussion';
    AddonModForumProvider.VIEW_DISCUSSION_EVENT = 'addon_mod_forum_view_discussion';
    AddonModForumProvider.CHANGE_DISCUSSION_EVENT = 'addon_mod_forum_lock_discussion';
    AddonModForumProvider.MARK_READ_EVENT = 'addon_mod_forum_mark_read';
    AddonModForumProvider.PREFERENCE_SORTORDER = 'forum_discussionlistsortorder';
    AddonModForumProvider.SORTORDER_LASTPOST_DESC = 1;
    AddonModForumProvider.SORTORDER_LASTPOST_ASC = 2;
    AddonModForumProvider.SORTORDER_CREATED_DESC = 3;
    AddonModForumProvider.SORTORDER_CREATED_ASC = 4;
    AddonModForumProvider.SORTORDER_REPLIES_DESC = 5;
    AddonModForumProvider.SORTORDER_REPLIES_ASC = 6;
    AddonModForumProvider.ALL_PARTICIPANTS = -1;
    AddonModForumProvider.ALL_GROUPS = -2;
    AddonModForumProvider = AddonModForumProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__offline__["a" /* AddonModForumOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModForumProvider);
    return AddonModForumProvider;
    var AddonModForumProvider_1;
}());

//# sourceMappingURL=forum.js.map

/***/ }),
/* 101 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to provide grade functionalities.
 */
var CoreGradesProvider = /** @class */ (function () {
    function CoreGradesProvider(logger, sitesProvider, coursesProvider, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.coursesProvider = coursesProvider;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.ROOT_CACHE_KEY = 'mmGrades:';
        this.logger = logger.getInstance('CoreGradesProvider');
    }
    /**
     * Get cache key for grade table data WS calls.
     *
     * @param {number} courseId ID of the course to get the grades from.
     * @param {number} userId   ID of the user to get the grades from.
     * @return {string}         Cache key.
     */
    CoreGradesProvider.prototype.getCourseGradesCacheKey = function (courseId, userId) {
        return this.getCourseGradesPrefixCacheKey(courseId) + userId;
    };
    /**
     * Get cache key for grade items data WS calls.
     *
     * @param {number} courseId     ID of the course to get the grades from.
     * @param {number} userId       ID of the user to get the grades from.
     * @param {number} [groupId]    ID of the group to get the grades from. Default: 0.
     * @return {string}         Cache key.
     */
    CoreGradesProvider.prototype.getCourseGradesItemsCacheKey = function (courseId, userId, groupId) {
        groupId = groupId || 0;
        return this.getCourseGradesPrefixCacheKey(courseId) + userId + ':' + groupId;
    };
    /**
     * Get prefix cache key for grade table data WS calls.
     *
     * @param {number} courseId ID of the course to get the grades from.
     * @return {string}         Cache key.
     */
    CoreGradesProvider.prototype.getCourseGradesPrefixCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'items:' + courseId + ':';
    };
    /**
     * Get cache key for courses grade WS calls.
     *
     * @return {string}   Cache key.
     */
    CoreGradesProvider.prototype.getCoursesGradesCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'coursesgrades';
    };
    /**
     * Get the grade items for a certain module. Keep in mind that may have more than one item to include outcomes and scales.
     * Fallback function only used if 'gradereport_user_get_grade_items' WS is not avalaible Moodle < 3.2.
     *
     * @param  {number}  courseId             ID of the course to get the grades from.
     * @param  {number}  [userId]             ID of the user to get the grades from. If not defined use site's current user.
     * @param  {number}  [groupId]            ID of the group to get the grades from. Not used for old gradebook table.
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache=false]  True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}                Promise to be resolved when the grades are retrieved.
     */
    CoreGradesProvider.prototype.getGradeItems = function (courseId, userId, groupId, siteId, ignoreCache) {
        var _this = this;
        if (ignoreCache === void 0) { ignoreCache = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return _this.isGradeItemsAvalaible(siteId).then(function (enabled) {
                if (enabled) {
                    return _this.getCourseGradesItems(courseId, userId, groupId, siteId, ignoreCache).catch(function () {
                        // FallBack while solving MDL-57255.
                        return _this.getCourseGradesTable(courseId, userId, siteId, ignoreCache);
                    });
                }
                else {
                    return _this.getCourseGradesTable(courseId, userId, siteId, ignoreCache);
                }
            });
        });
    };
    /**
     * Get the grade items for a certain course.
     *
     * @param  {number}  courseId             ID of the course to get the grades from.
     * @param  {number}  [userId]             ID of the user to get the grades from.
     * @param  {number}  [groupId]            ID of the group to get the grades from. Default 0.
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache=false]  True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}                      Promise to be resolved when the grades table is retrieved.
     */
    CoreGradesProvider.prototype.getCourseGradesItems = function (courseId, userId, groupId, siteId, ignoreCache) {
        var _this = this;
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            groupId = groupId || 0;
            _this.logger.debug("Get grades for course '" + courseId + "' and user '" + userId + "'");
            var data = {
                courseid: courseId,
                userid: userId,
                groupid: groupId
            }, preSets = {
                cacheKey: _this.getCourseGradesItemsCacheKey(courseId, userId, groupId)
            };
            if (ignoreCache) {
                preSets['getFromCache'] = 0;
                preSets['emergencyCache'] = 0;
            }
            return site.read('gradereport_user_get_grade_items', data, preSets).then(function (grades) {
                if (grades && grades.usergrades && grades.usergrades[0]) {
                    return grades.usergrades[0].gradeitems;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get the grades for a certain course.
     *
     * @param  {number}  courseId             ID of the course to get the grades from.
     * @param  {number}  [userId]             ID of the user to get the grades from.
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache=false]  True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}                      Promise to be resolved when the grades table is retrieved.
     */
    CoreGradesProvider.prototype.getCourseGradesTable = function (courseId, userId, siteId, ignoreCache) {
        var _this = this;
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug("Get grades for course '" + courseId + "' and user '" + userId + "'");
            var data = {
                courseid: courseId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getCourseGradesCacheKey(courseId, userId)
            };
            if (ignoreCache) {
                preSets['getFromCache'] = 0;
                preSets['emergencyCache'] = 0;
            }
            return site.read('gradereport_user_get_grades_table', data, preSets).then(function (table) {
                if (table && table.tables && table.tables[0]) {
                    return table.tables[0];
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get the grades for a certain course.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise to be resolved when the grades are retrieved.
     */
    CoreGradesProvider.prototype.getCoursesGrades = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            _this.logger.debug('Get course grades');
            var preSets = {
                cacheKey: _this.getCoursesGradesCacheKey()
            };
            return site.read('gradereport_overview_get_course_grades', undefined, preSets).then(function (data) {
                if (data && data.grades) {
                    return data.grades;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates courses grade table and items WS calls for all users.
     *
     * @param {number} courseId ID of the course to get the grades from.
     * @param {string} [siteId] Site ID (empty for current site).
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreGradesProvider.prototype.invalidateAllCourseGradesData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getCourseGradesPrefixCacheKey(courseId));
        });
    };
    /**
     * Invalidates grade table data WS calls.
     *
     * @param {number} courseId Course ID.
     * @param {number} [userId]   User ID.
     * @param {string} [siteId]   Site id (empty for current site).
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    CoreGradesProvider.prototype.invalidateCourseGradesData = function (courseId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getCourseGradesCacheKey(courseId, userId));
        });
    };
    /**
     * Invalidates courses grade data WS calls.
     *
     * @param {string} [siteId]   Site id (empty for current site).
     * @return {Promise<any>}     Promise resolved when the data is invalidated.
     */
    CoreGradesProvider.prototype.invalidateCoursesGradesData = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCoursesGradesCacheKey());
        });
    };
    /**
     * Invalidates courses grade items data WS calls.
     *
     * @param {number} courseId     ID of the course to get the grades from.
     * @param {number} userId       ID of the user to get the grades from.
     * @param {number} [groupId]    ID of the group to get the grades from. Default: 0.
     * @param {string} [siteId]     Site id (empty for current site).
     * @return {Promise<any>}     Promise resolved when the data is invalidated.
     */
    CoreGradesProvider.prototype.invalidateCourseGradesItemsData = function (courseId, userId, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCourseGradesItemsCacheKey(courseId, userId, groupId));
        });
    };
    /**
     * Returns whether or not the plugin is enabled for a certain site.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>}  Resolve with true if plugin is enabled, false otherwise.
     * @since  Moodle 3.2
     */
    CoreGradesProvider.prototype.isCourseGradesEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.wsAvailable('gradereport_overview_get_course_grades')) {
                return false;
            }
            // Now check that the configurable mygradesurl is pointing to the gradereport_overview plugin.
            var url = site.getStoredConfig('mygradesurl') || '';
            return url.indexOf('/grade/report/overview/') !== -1;
        });
    };
    /**
     * Returns whether or not the grade addon is enabled for a certain course.
     *
     * @param {number} courseId  Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promisee<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    CoreGradesProvider.prototype.isPluginEnabledForCourse = function (courseId, siteId) {
        if (!courseId) {
            return Promise.reject(null);
        }
        return this.coursesProvider.getUserCourse(courseId, true, siteId).then(function (course) {
            return !(course && typeof course.showgrades != 'undefined' && course.showgrades == 0);
        });
    };
    /**
     * Returns whether or not WS Grade Items is avalaible.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>}         True if ws is avalaible, false otherwise.
     * @since  Moodle 3.2
     */
    CoreGradesProvider.prototype.isGradeItemsAvalaible = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('gradereport_user_get_grade_items');
        });
    };
    /**
     * Log Course grades view in Moodle.
     *
     * @param  {number}  courseId Course ID.
     * @param  {number}  userId   User ID.
     * @param  {string}  [name]   Course name. If not set, it will be calculated.
     * @return {Promise<any>}     Promise resolved when done.
     */
    CoreGradesProvider.prototype.logCourseGradesView = function (courseId, userId, name) {
        var _this = this;
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        var wsName = 'gradereport_user_view_grade_report';
        if (!name) {
            this.coursesProvider.getUserCourse(courseId, true).catch(function () {
                return {};
            }).then(function (course) {
                _this.pushNotificationsProvider.logViewEvent(courseId, course.fullname || '', 'grades', wsName, { userid: userId });
            });
        }
        else {
            this.pushNotificationsProvider.logViewEvent(courseId, name, 'grades', wsName, { userid: userId });
        }
        return this.sitesProvider.getCurrentSite().write(wsName, {
            courseid: courseId,
            userid: userId
        });
    };
    /**
     * Log Courses grades view in Moodle.
     *
     * @param  {number}  [courseId] Course ID. If not defined, site Home ID.
     * @return {Promise<any>}     Promise resolved when done.
     */
    CoreGradesProvider.prototype.logCoursesGradesView = function (courseId) {
        if (!courseId) {
            courseId = this.sitesProvider.getCurrentSiteHomeId();
        }
        var params = {
            courseid: courseId
        };
        this.pushNotificationsProvider.logViewListEvent('grades', 'gradereport_overview_view_grade_report', params);
        return this.sitesProvider.getCurrentSite().write('gradereport_overview_view_grade_report', params);
    };
    CoreGradesProvider.TYPE_NONE = 0; // Moodle's GRADE_TYPE_NONE.
    CoreGradesProvider.TYPE_VALUE = 1; // Moodle's GRADE_TYPE_VALUE.
    CoreGradesProvider.TYPE_SCALE = 2; // Moodle's GRADE_TYPE_SCALE.
    CoreGradesProvider.TYPE_TEXT = 3; // Moodle's GRADE_TYPE_TEXT.
    CoreGradesProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_4__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], CoreGradesProvider);
    return CoreGradesProvider;
}());

//# sourceMappingURL=grades.js.map

/***/ }),
/* 102 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_grades_providers_grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__lesson_offline__ = __webpack_require__(225);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Service that provides some features for lesson.
 *
 * Lesson terminology is a bit confusing and ambiguous in Moodle. For that reason, in the app it has been decided to use
 * the following terminology:
 *     - Retake: An attempt in a lesson. In Moodle it's sometimes called "attempt", "try" or "retry".
 *     - Attempt: An attempt in a page inside a retake. In the app, this includes content pages.
 *     - Content page: A page with only content (no question). In Moodle it's sometimes called "branch table".
 *     - Page answers: List of possible answers for a page (configured by the teacher). NOT the student answer for the page.
 *
 * This terminology sometimes won't match with WebServices names, params or responses.
 */
var AddonModLessonProvider = /** @class */ (function () {
    function AddonModLessonProvider(logger, sitesProvider, utils, translate, textUtils, domUtils, lessonOfflineProvider, logHelper, eventsProvider) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.translate = translate;
        this.textUtils = textUtils;
        this.domUtils = domUtils;
        this.lessonOfflineProvider = lessonOfflineProvider;
        this.logHelper = logHelper;
        this.eventsProvider = eventsProvider;
        this.siteSchema = {
            name: 'AddonModLessonProvider',
            version: 1,
            tables: [
                {
                    name: AddonModLessonProvider_1.PASSWORD_TABLE,
                    columns: [
                        {
                            name: 'lessonid',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'password',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        }
                    ]
                }
            ]
        };
        this.ROOT_CACHE_KEY = 'mmaModLesson:';
        this.logger = logger.getInstance('AddonModLessonProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModLessonProvider_1 = AddonModLessonProvider;
    /**
     * Add an answer and its response to a feedback string (HTML).
     *
     * @param {string} feedback The current feedback.
     * @param {string} answer Student answer.
     * @param {number} answerFormat Answer format.
     * @param {string} response Response.
     * @param {string} className Class to add to the response.
     * @return {string} New feedback.
     */
    AddonModLessonProvider.prototype.addAnswerAndResponseToFeedback = function (feedback, answer, answerFormat, response, className) {
        // Add a table row containing the answer.
        feedback += '<tr><td class="cell c0 lastcol">' + (answerFormat ? answer : this.textUtils.cleanTags(answer)) +
            '</td></tr>';
        // If the response exists, add a table row containing the response. If not, add en empty row.
        if (response && response.trim()) {
            feedback += '<tr><td class="cell c0 lastcol ' + className + '"><em>' +
                this.translate.instant('addon.mod_lesson.response') + '</em>: <br/>' +
                response + '</td></tr>';
        }
        else {
            feedback += '<tr><td class="cell c0 lastcol"></td></tr>';
        }
        return feedback;
    };
    /**
     * Add a message to a list of messages, following the format of the messages returned by WS.
     *
     * @param {any[]} messages List of messages where to add the message.
     * @param {string} stringName The ID of the message to be translated. E.g. 'addon.mod_lesson.numberofpagesviewednotice'.
     * @param {any} [stringParams] The params of the message (if any).
     */
    AddonModLessonProvider.prototype.addMessage = function (messages, stringName, stringParams) {
        messages.push({
            message: this.translate.instant(stringName, stringParams)
        });
    };
    /**
     * Add a property to the result of the "process EOL page" simulation in offline.
     *
     * @param {any} result Result where to add the value.
     * @param {string} name Name of the property.
     * @param {any} value Value to add.
     * @param {boolean} addMessage Whether to add a message related to the value.
     */
    AddonModLessonProvider.prototype.addResultValueEolPage = function (result, name, value, addMessage) {
        var message = '';
        if (addMessage) {
            var params = typeof value != 'boolean' ? { $a: value } : undefined;
            message = this.translate.instant('addon.mod_lesson.' + name, params);
        }
        result.data[name] = {
            name: name,
            value: value,
            message: message
        };
    };
    /**
     * Check if an answer page (from getUserRetake) is a content page.
     *
     * @param {any} page Answer page.
     * @return {boolean} Whether it's a content page.
     */
    AddonModLessonProvider.prototype.answerPageIsContent = function (page) {
        // The page doesn't have any reliable field to use for checking this. Check qtype first (translated string).
        if (page.qtype == this.translate.instant('addon.mod_lesson.branchtable')) {
            return true;
        }
        // The qtype doesn't match, but that doesn't mean it's not a content page, maybe the language is different.
        // Check it's not a question page.
        if (page.answerdata && !this.answerPageIsQuestion(page)) {
            // It isn't a question page, but it can be an end of branch, etc. Check if the first answer has a button.
            if (page.answerdata.answers && page.answerdata.answers[0]) {
                var element = this.domUtils.convertToElement(page.answerdata.answers[0][0]);
                return !!element.querySelector('input[type="button"]');
            }
        }
        return false;
    };
    /**
     * Check if an answer page (from getUserRetake) is a question page.
     *
     * @param {any} page Answer page.
     * @return {boolean} Whether it's a question page.
     */
    AddonModLessonProvider.prototype.answerPageIsQuestion = function (page) {
        if (!page.answerdata) {
            return false;
        }
        if (page.answerdata.score) {
            // Only question pages have a score.
            return true;
        }
        if (page.answerdata.answers) {
            for (var i = 0; i < page.answerdata.answers.length; i++) {
                var answer = page.answerdata.answers[i];
                if (answer[1]) {
                    // Only question pages have a statistic.
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * Calculate some offline data like progress and ongoingscore.
     *
     * @param {any} lesson Lesson.
     * @param {any} accessInfo Result of get access info.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {any} [pageIndex] Object containing all the pages indexed by ID. If not defined, it will be calculated.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{reviewmode: boolean, progress: number, ongoingscore: string}>} Promise resolved with the data.
     */
    AddonModLessonProvider.prototype.calculateOfflineData = function (lesson, accessInfo, password, review, pageIndex, siteId) {
        accessInfo = accessInfo || {};
        var reviewMode = review || accessInfo.reviewmode, promises = [];
        var ongoingMessage = '', progress;
        if (!accessInfo.canmanage) {
            if (lesson.ongoing && !reviewMode) {
                promises.push(this.getOngoingScoreMessage(lesson, accessInfo, password, review, pageIndex, siteId)
                    .then(function (message) {
                    ongoingMessage = message;
                }));
            }
            if (lesson.progressbar) {
                promises.push(this.calculateProgress(lesson.id, accessInfo, password, review, pageIndex, siteId).then(function (p) {
                    progress = p;
                }));
            }
        }
        return Promise.all(promises).then(function () {
            return {
                reviewmode: reviewMode,
                progress: progress,
                ongoingscore: ongoingMessage
            };
        });
    };
    /**
     * Calculate the progress of the current user in the lesson.
     * Based on Moodle's calculate_progress.
     *
     * @param {number} lessonId Lesson ID.
     * @param {any} accessInfo Result of get access info.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {any} [pageIndex] Object containing all the pages indexed by ID. If not defined, it will be calculated.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with a number: the progress (scale 0-100).
     */
    AddonModLessonProvider.prototype.calculateProgress = function (lessonId, accessInfo, password, review, pageIndex, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Check if the user is reviewing the attempt.
        if (review) {
            return Promise.resolve(100);
        }
        var retake = accessInfo.attemptscount;
        var viewedPagesIds, promise;
        if (pageIndex) {
            promise = Promise.resolve();
        }
        else {
            // Retrieve the index.
            promise = this.getPages(lessonId, password, true, false, siteId).then(function (pages) {
                pageIndex = _this.createPagesIndex(pages);
            });
        }
        return promise.then(function () {
            // Get the list of question pages attempted.
            return _this.getPagesIdsWithQuestionAttempts(lessonId, retake, false, siteId);
        }).then(function (ids) {
            viewedPagesIds = ids;
            // Get the list of viewed content pages.
            return _this.getContentPagesViewedIds(lessonId, retake, siteId);
        }).then(function (viewedContentPagesIds) {
            var validPages = {};
            var pageId = accessInfo.firstpageid;
            viewedPagesIds = _this.utils.mergeArraysWithoutDuplicates(viewedPagesIds, viewedContentPagesIds);
            // Filter out the following pages:
            // - End of Cluster
            // - End of Branch
            // - Pages found inside of Clusters
            // Do not filter out Cluster Page(s) because we count a cluster as one.
            // By keeping the cluster page, we get our 1.
            while (pageId) {
                pageId = _this.validPageAndView(pageIndex, pageIndex[pageId], validPages, viewedPagesIds);
            }
            // Progress calculation as a percent.
            return _this.textUtils.roundToDecimals(viewedPagesIds.length / Object.keys(validPages).length, 2) * 100;
        });
    };
    /**
     * Check if the answer provided by the user is correct or not and return the result object.
     * This method is based on the check_answer implementation of all page types (Moodle).
     *
     * @param {any} lesson Lesson.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data containing the user answer.
     * @param {any} jumps Result of get pages possible jumps.
     * @param {any} pageIndex Object containing all the pages indexed by ID.
     * @return {AddonModLessonCheckAnswerResult} Result.
     */
    AddonModLessonProvider.prototype.checkAnswer = function (lesson, pageData, data, jumps, pageIndex) {
        // Default result.
        var result = {
            answerid: 0,
            noanswer: false,
            correctanswer: false,
            isessayquestion: false,
            response: '',
            newpageid: 0,
            studentanswer: '',
            userresponse: null,
            feedback: '',
            nodefaultresponse: false,
            inmediatejump: false
        };
        switch (pageData.page.qtype) {
            case AddonModLessonProvider_1.LESSON_PAGE_BRANCHTABLE:
                // Load the new page immediately.
                result.inmediatejump = true;
                result.newpageid = this.getNewPageId(pageData.page.id, data.jumpto, jumps);
                break;
            case AddonModLessonProvider_1.LESSON_PAGE_ESSAY:
                this.checkAnswerEssay(pageData, data, result);
                break;
            case AddonModLessonProvider_1.LESSON_PAGE_MATCHING:
                this.checkAnswerMatching(pageData, data, result);
                break;
            case AddonModLessonProvider_1.LESSON_PAGE_MULTICHOICE:
                this.checkAnswerMultichoice(lesson, pageData, data, pageIndex, result);
                break;
            case AddonModLessonProvider_1.LESSON_PAGE_NUMERICAL:
                this.checkAnswerNumerical(lesson, pageData, data, pageIndex, result);
                break;
            case AddonModLessonProvider_1.LESSON_PAGE_SHORTANSWER:
                this.checkAnswerShort(lesson, pageData, data, pageIndex, result);
                break;
            case AddonModLessonProvider_1.LESSON_PAGE_TRUEFALSE:
                this.checkAnswerTruefalse(lesson, pageData, data, pageIndex, result);
                break;
            default:
        }
        return result;
    };
    /**
     * Check an essay answer.
     *
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data containing the user answer.
     * @param {AddonModLessonCheckAnswerResult} result Object where to store the result.
     */
    AddonModLessonProvider.prototype.checkAnswerEssay = function (pageData, data, result) {
        var studentAnswer;
        result.isessayquestion = true;
        if (!data) {
            result.inmediatejump = true;
            result.newpageid = pageData.page.id;
            return;
        }
        // The name was changed to "answer_editor" in 3.7. Before it was just "answer". Support both cases.
        if (typeof data['answer_editor[text]'] != 'undefined') {
            studentAnswer = data['answer_editor[text]'];
        }
        else if (typeof data.answer_editor == 'object') {
            studentAnswer = data.answer_editor.text;
        }
        else if (typeof data['answer[text]'] != 'undefined') {
            studentAnswer = data['answer[text]'];
        }
        else if (typeof data.answer == 'object') {
            studentAnswer = data.answer.text;
        }
        else {
            studentAnswer = data.answer;
        }
        if (!studentAnswer || studentAnswer.trim() === '') {
            result.noanswer = true;
            return;
        }
        // Essay pages should only have 1 possible answer.
        pageData.answers.forEach(function (answer) {
            result.answerid = answer.id;
            result.newpageid = answer.jumpto;
        });
        result.userresponse = {
            sent: 0,
            graded: 0,
            score: 0,
            answer: studentAnswer,
            answerformat: 1,
            response: '',
            responseformat: 1
        };
        result.studentanswerformat = 1;
        result.studentanswer = studentAnswer;
    };
    /**
     * Check a matching answer.
     *
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data containing the user answer.
     * @param {AddonModLessonCheckAnswerResult} result Object where to store the result.
     */
    AddonModLessonProvider.prototype.checkAnswerMatching = function (pageData, data, result) {
        if (!data) {
            result.inmediatejump = true;
            result.newpageid = pageData.page.id;
            return;
        }
        var response = this.getUserResponseMatching(data), getAnswers = this.utils.clone(pageData.answers), correct = getAnswers.shift(), wrong = getAnswers.shift(), answers = {};
        getAnswers.forEach(function (answer) {
            if (answer.answer !== '' || answer.response !== '') {
                answers[answer.id] = answer;
            }
        });
        // Get the user's exact responses for record keeping.
        var userResponse = [];
        var hits = 0;
        result.studentanswer = '';
        result.studentanswerformat = 1;
        for (var id in response) {
            var value = response[id];
            if (!value) {
                result.noanswer = true;
                return;
            }
            value = this.textUtils.decodeHTML(value);
            userResponse.push(value);
            if (typeof answers[id] != 'undefined') {
                var answer = answers[id];
                result.studentanswer += '<br />' + answer.answer + ' = ' + value;
                if (answer.response && answer.response.trim() == value.trim()) {
                    hits++;
                }
            }
        }
        result.userresponse = userResponse.join(',');
        if (hits == Object.keys(answers).length) {
            result.correctanswer = true;
            result.response = correct.answer;
            result.answerid = correct.id;
            result.newpageid = correct.jumpto;
        }
        else {
            result.correctanswer = false;
            result.response = wrong.answer;
            result.answerid = wrong.id;
            result.newpageid = wrong.jumpto;
        }
    };
    /**
     * Check a multichoice answer.
     *
     * @param {any} lesson Lesson.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data containing the user answer.
     * @param {any} pageIndex Object containing all the pages indexed by ID.
     * @param {AddonModLessonCheckAnswerResult} result Object where to store the result.
     */
    AddonModLessonProvider.prototype.checkAnswerMultichoice = function (lesson, pageData, data, pageIndex, result) {
        var _this = this;
        if (!data) {
            result.inmediatejump = true;
            result.newpageid = pageData.page.id;
            return;
        }
        var answers = this.getUsedAnswersMultichoice(pageData);
        if (pageData.page.qoption) {
            // Multianswer allowed, user's answer is an array.
            var studentAnswers_1 = this.getUserResponseMultichoice(data);
            if (!studentAnswers_1 || !Array.isArray(studentAnswers_1)) {
                result.noanswer = true;
                return;
            }
            // Get what the user answered.
            result.userresponse = studentAnswers_1.join(',');
            // Get the answers in a set order, the id order.
            var studentAswersArray_1 = [], responses_1 = [];
            var nHits_1 = 0, nCorrect_1 = 0, correctAnswerId_1 = 0, wrongAnswerId_1 = 0, correctPageId_1, wrongPageId_1;
            // Store student's answers for displaying on feedback page.
            result.studentanswer = '';
            result.studentanswerformat = 1;
            answers.forEach(function (answer) {
                for (var i in studentAnswers_1) {
                    var answerId = studentAnswers_1[i];
                    if (answerId == answer.id) {
                        studentAswersArray_1.push(answer.answer);
                        responses_1.push(answer.response);
                        break;
                    }
                }
            });
            result.studentanswer = studentAswersArray_1.join(AddonModLessonProvider_1.MULTIANSWER_DELIMITER);
            // Iterate over all the possible answers.
            answers.forEach(function (answer) {
                var correctAnswer = _this.isAnswerCorrect(lesson, pageData.page.id, answer, pageIndex);
                // Iterate over all the student answers to check if he selected the current possible answer.
                studentAnswers_1.forEach(function (answerId) {
                    if (answerId == answer.id) {
                        if (correctAnswer) {
                            nHits_1++;
                        }
                        else {
                            // Always use the first student wrong answer.
                            if (typeof wrongPageId_1 == 'undefined') {
                                wrongPageId_1 = answer.jumpto;
                            }
                            // Save the answer id for scoring.
                            if (!wrongAnswerId_1) {
                                wrongAnswerId_1 = answer.id;
                            }
                        }
                    }
                });
                if (correctAnswer) {
                    nCorrect_1++;
                    // Save the first jumpto.
                    if (typeof correctPageId_1 == 'undefined') {
                        correctPageId_1 = answer.jumpto;
                    }
                    // Save the answer id for scoring.
                    if (!correctAnswerId_1) {
                        correctAnswerId_1 = answer.id;
                    }
                }
            });
            if (studentAnswers_1.length == nCorrect_1 && nHits_1 == nCorrect_1) {
                result.correctanswer = true;
                result.response = responses_1.join(AddonModLessonProvider_1.MULTIANSWER_DELIMITER);
                result.newpageid = correctPageId_1;
                result.answerid = correctAnswerId_1;
            }
            else {
                result.correctanswer = false;
                result.response = responses_1.join(AddonModLessonProvider_1.MULTIANSWER_DELIMITER);
                result.newpageid = wrongPageId_1;
                result.answerid = wrongAnswerId_1;
            }
        }
        else {
            // Only one answer allowed.
            if (typeof data.answerid == 'undefined' || (!data.answerid && Number(data.answerid) !== 0)) {
                result.noanswer = true;
                return;
            }
            result.answerid = data.answerid;
            // Search the answer.
            for (var i in pageData.answers) {
                var answer = pageData.answers[i];
                if (answer.id == data.answerid) {
                    result.correctanswer = this.isAnswerCorrect(lesson, pageData.page.id, answer, pageIndex);
                    result.newpageid = answer.jumpto;
                    result.response = answer.response;
                    result.userresponse = result.studentanswer = answer.answer;
                    break;
                }
            }
        }
    };
    /**
     * Check a numerical answer.
     *
     * @param {any} lesson Lesson.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data containing the user answer.
     * @param {any} pageIndex Object containing all the pages indexed by ID.
     * @param {any} result Object where to store the result.
     */
    AddonModLessonProvider.prototype.checkAnswerNumerical = function (lesson, pageData, data, pageIndex, result) {
        var parsedAnswer = parseFloat(data.answer);
        // Set defaults.
        result.response = '';
        result.newpageid = 0;
        if (!data.answer || isNaN(parsedAnswer)) {
            result.noanswer = true;
            return;
        }
        else {
            result.useranswer = parsedAnswer;
        }
        result.studentanswer = result.userresponse = result.useranswer;
        // Find the answer.
        for (var i in pageData.answers) {
            var answer = pageData.answers[i];
            var max = void 0, min = void 0;
            if (answer.answer && answer.answer.indexOf(':') != -1) {
                // There's a pair of values.
                var split = answer.answer.split(':');
                min = parseFloat(split[0]);
                max = parseFloat(split[1]);
            }
            else {
                // Only one value.
                min = parseFloat(answer.answer);
                max = min;
            }
            if (result.useranswer >= min && result.useranswer <= max) {
                result.newpageid = answer.jumpto;
                result.response = answer.response;
                result.correctanswer = this.isAnswerCorrect(lesson, pageData.page.id, answer, pageIndex);
                result.answerid = answer.id;
                break;
            }
        }
        this.checkOtherAnswers(lesson, pageData, result);
    };
    /**
     * Check a short answer.
     *
     * @param {any} lesson Lesson.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data containing the user answer.
     * @param {any} pageIndex Object containing all the pages indexed by ID.
     * @param {any} result Object where to store the result.
     */
    AddonModLessonProvider.prototype.checkAnswerShort = function (lesson, pageData, data, pageIndex, result) {
        var studentAnswer = data.answer && data.answer.trim ? data.answer.trim() : false;
        if (!studentAnswer) {
            result.noanswer = true;
            return;
        }
        // Search the answer in the list of possible answers.
        for (var i in pageData.answers) {
            var answer = pageData.answers[i], useRegExp = pageData.page.qoption;
            var expectedAnswer = answer.answer, isMatch = false, ignoreCase = void 0;
            if (useRegExp) {
                ignoreCase = '';
                if (expectedAnswer.substr(-2) == '/i') {
                    expectedAnswer = expectedAnswer.substr(0, expectedAnswer.length - 2);
                    ignoreCase = 'i';
                }
            }
            else {
                expectedAnswer = expectedAnswer.replace('*', '#####');
                expectedAnswer = this.textUtils.escapeForRegex(expectedAnswer);
                expectedAnswer = expectedAnswer.replace('#####', '.*');
            }
            // See if user typed in any of the correct answers.
            if (this.isAnswerCorrect(lesson, pageData.page.id, answer, pageIndex)) {
                if (!useRegExp) {
                    if (studentAnswer.match(new RegExp('^' + expectedAnswer + '$', 'i'))) {
                        isMatch = true;
                    }
                }
                else {
                    if (studentAnswer.match(new RegExp('^' + expectedAnswer + '$', ignoreCase))) {
                        isMatch = true;
                    }
                }
                if (isMatch) {
                    result.correctanswer = true;
                }
            }
            else {
                if (!useRegExp) {
                    // See if user typed in any of the wrong answers; don't worry about case.
                    if (studentAnswer.match(new RegExp('^' + expectedAnswer + '$', 'i'))) {
                        isMatch = true;
                    }
                }
                else {
                    var startCode = expectedAnswer.substr(0, 2);
                    switch (startCode) {
                        // 1- Check for absence of required string in studentAnswer (coded by initial '--').
                        case '--':
                            expectedAnswer = expectedAnswer.substr(2);
                            if (!studentAnswer.match(new RegExp('^' + expectedAnswer + '$', ignoreCase))) {
                                isMatch = true;
                            }
                            break;
                        // 2- Check for code for marking wrong strings (coded by initial '++').
                        case '++':
                            expectedAnswer = expectedAnswer.substr(2);
                            // Check for one or several matches.
                            var matches = studentAnswer.match(new RegExp(expectedAnswer, 'g' + ignoreCase));
                            if (matches) {
                                isMatch = true;
                                var nb = matches[0].length, original = [], marked = [];
                                for (var j = 0; j < nb; j++) {
                                    original.push(matches[0][j]);
                                    marked.push('<span class="incorrect matches">' + matches[0][j] + '</span>');
                                }
                                studentAnswer = studentAnswer.replace(original, marked);
                            }
                            break;
                        // 3- Check for wrong answers belonging neither to -- nor to ++ categories.
                        default:
                            if (studentAnswer.match(new RegExp('^' + expectedAnswer + '$', ignoreCase))) {
                                isMatch = true;
                            }
                            break;
                    }
                    result.correctanswer = false;
                }
            }
            if (isMatch) {
                result.newpageid = answer.jumpto;
                result.response = answer.response;
                result.answerid = answer.id;
                break; // Quit answer analysis immediately after a match has been found.
            }
        }
        this.checkOtherAnswers(lesson, pageData, result);
        result.userresponse = studentAnswer;
        result.studentanswer = this.textUtils.s(studentAnswer); // Clean student answer as it goes to output.
    };
    /**
     * Check a truefalse answer.
     *
     * @param {any} lesson Lesson.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data containing the user answer.
     * @param {any} pageIndex Object containing all the pages indexed by ID.
     * @param {any} result Object where to store the result.
     */
    AddonModLessonProvider.prototype.checkAnswerTruefalse = function (lesson, pageData, data, pageIndex, result) {
        if (!data.answerid) {
            result.noanswer = true;
            return;
        }
        result.answerid = data.answerid;
        // Get the answer.
        for (var i in pageData.answers) {
            var answer = pageData.answers[i];
            if (answer.id == data.answerid) {
                // Answer found.
                result.correctanswer = this.isAnswerCorrect(lesson, pageData.page.id, answer, pageIndex);
                result.newpageid = answer.jumpto;
                result.response = answer.response;
                result.studentanswer = result.userresponse = answer.answer;
                break;
            }
        }
    };
    /**
     * Check the "other answers" value.
     *
     * @param {any} lesson Lesson.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {AddonModLessonCheckAnswerResult} result Object where to store the result.
     */
    AddonModLessonProvider.prototype.checkOtherAnswers = function (lesson, pageData, result) {
        // We could check here to see if we have a wrong answer jump to use.
        if (result.answerid == 0) {
            // Use the all other answers jump details if it is set up.
            var lastAnswer = pageData.answers[pageData.answers.length - 1] || {};
            // Double check that this is the OTHER_ANSWERS answer.
            if (typeof lastAnswer.answer == 'string' &&
                lastAnswer.answer.indexOf(AddonModLessonProvider_1.LESSON_OTHER_ANSWERS) != -1) {
                result.newpageid = lastAnswer.jumpto;
                result.response = lastAnswer.response;
                if (lesson.custom) {
                    result.correctanswer = lastAnswer.score > 0;
                }
                result.answerid = lastAnswer.id;
            }
        }
    };
    /**
     * Create a list of pages indexed by page ID based on a list of pages.
     *
     * @param {Object[]} pageList Result of get pages.
     * @return {any} Pages index.
     */
    AddonModLessonProvider.prototype.createPagesIndex = function (pageList) {
        // Index the pages by page ID.
        var pages = {};
        pageList.forEach(function (pageData) {
            pages[pageData.page.id] = pageData.page;
        });
        return pages;
    };
    /**
     * Finishes a retake.
     *
     * @param {any} lesson Lesson.
     * @param {number} courseId Course ID the lesson belongs to.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [outOfTime] If the user ran out of time.
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {boolean} [offline] Whether it's offline mode.
     * @param {any} [accessInfo] Result of get access info. Required if offline is true.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModLessonProvider.prototype.finishRetake = function (lesson, courseId, password, outOfTime, review, offline, accessInfo, siteId) {
        var _this = this;
        if (offline) {
            var retake_1 = accessInfo.attemptscount;
            return this.lessonOfflineProvider.finishRetake(lesson.id, courseId, retake_1, true, outOfTime, siteId).then(function () {
                // Get the lesson grade.
                return _this.lessonGrade(lesson, retake_1, password, review, undefined, siteId).catch(function () {
                    // Ignore errors.
                    return {};
                });
            }).then(function (gradeInfo) {
                // Retake marked, now return the response. We won't return all the possible data.
                // This code is based in Moodle's process_eol_page.
                var result = {
                    data: {},
                    messages: [],
                    warnings: []
                }, promises = [];
                var gradeLesson = true, messageParams, entryData;
                _this.addResultValueEolPage(result, 'offline', true); // Mark the result as offline.
                _this.addResultValueEolPage(result, 'gradeinfo', gradeInfo);
                if (lesson.custom && !accessInfo.canmanage) {
                    /* Before we calculate the custom score make sure they answered the minimum number of questions.
                       We only need to do this for custom scoring as we can not get the miniumum score the user should achieve.
                       If we are not using custom scoring (so all questions are valued as 1) then we simply check if they
                       answered more than the minimum questions, if not, we mark it out of the number specified in the minimum
                       questions setting - which is done in lesson_grade(). */
                    // Get the number of answers given.
                    if (gradeInfo.nquestions < lesson.minquestions) {
                        gradeLesson = false;
                        messageParams = {
                            nquestions: gradeInfo.nquestions,
                            minquestions: lesson.minquestions
                        };
                        _this.addMessage(result.messages, 'addon.mod_lesson.numberofpagesviewednotice', { $a: messageParams });
                    }
                }
                if (!accessInfo.canmanage) {
                    if (gradeLesson) {
                        promises.push(_this.calculateProgress(lesson.id, accessInfo, password, review, undefined, siteId)
                            .then(function (progress) {
                            _this.addResultValueEolPage(result, 'progresscompleted', progress);
                        }));
                        if (gradeInfo.attempts) {
                            // User has answered questions.
                            if (!lesson.custom) {
                                _this.addResultValueEolPage(result, 'numberofpagesviewed', gradeInfo.nquestions, true);
                                if (lesson.minquestions) {
                                    if (gradeInfo.nquestions < lesson.minquestions) {
                                        _this.addResultValueEolPage(result, 'youshouldview', lesson.minquestions, true);
                                    }
                                }
                                _this.addResultValueEolPage(result, 'numberofcorrectanswers', gradeInfo.earned, true);
                            }
                            entryData = {
                                score: gradeInfo.earned,
                                grade: gradeInfo.total
                            };
                            if (gradeInfo.nmanual) {
                                entryData.tempmaxgrade = gradeInfo.total - gradeInfo.manualpoints;
                                entryData.essayquestions = gradeInfo.nmanual;
                                _this.addResultValueEolPage(result, 'displayscorewithessays', entryData, true);
                            }
                            else {
                                _this.addResultValueEolPage(result, 'displayscorewithoutessays', entryData, true);
                            }
                            if (lesson.grade != __WEBPACK_IMPORTED_MODULE_8__core_grades_providers_grades__["a" /* CoreGradesProvider */].TYPE_NONE) {
                                entryData = {
                                    grade: _this.textUtils.roundToDecimals(gradeInfo.grade * lesson.grade / 100, 1),
                                    total: lesson.grade
                                };
                                _this.addResultValueEolPage(result, 'yourcurrentgradeisoutof', entryData, true);
                            }
                        }
                        else {
                            // User hasn't answered any question, only content pages.
                            if (lesson.timelimit) {
                                if (outOfTime) {
                                    _this.addResultValueEolPage(result, 'eolstudentoutoftimenoanswers', true, true);
                                }
                            }
                            else {
                                _this.addResultValueEolPage(result, 'welldone', true, true);
                            }
                        }
                    }
                }
                else {
                    // Display for teacher.
                    if (lesson.grade != __WEBPACK_IMPORTED_MODULE_8__core_grades_providers_grades__["a" /* CoreGradesProvider */].TYPE_NONE) {
                        _this.addResultValueEolPage(result, 'displayofgrade', true, true);
                    }
                }
                if (lesson.modattempts && accessInfo.canmanage) {
                    _this.addResultValueEolPage(result, 'modattemptsnoteacher', true, true);
                }
                if (gradeLesson) {
                    _this.addResultValueEolPage(result, 'gradelesson', 1);
                }
                return result;
            });
        }
        return this.finishRetakeOnline(lesson.id, password, outOfTime, review, siteId).then(function (response) {
            _this.eventsProvider.trigger(AddonModLessonProvider_1.DATA_SENT_EVENT, {
                lessonId: lesson.id,
                type: 'finish',
                courseId: courseId,
                outOfTime: outOfTime,
                review: review
            }, _this.sitesProvider.getCurrentSiteId());
            return response;
        });
    };
    /**
     * Finishes a retake. It will fail if offline or cannot connect.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [outOfTime] If the user ran out of time.
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModLessonProvider.prototype.finishRetakeOnline = function (lessonId, password, outOfTime, review, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId,
                outoftime: outOfTime ? 1 : 0,
                review: review ? 1 : 0
            };
            if (typeof password == 'string') {
                params.password = password;
            }
            return site.write('mod_lesson_finish_attempt', params).then(function (response) {
                // Convert the data array into an object and decode the values.
                var map = {};
                response.data.forEach(function (entry) {
                    if (entry.value && typeof entry.value == 'string' && entry.value !== '1') {
                        // It's a JSON encoded object. Try to decode it.
                        entry.value = _this.textUtils.parseJSON(entry.value);
                    }
                    map[entry.name] = entry;
                });
                response.data = map;
                return response;
            });
        });
    };
    /**
     * Get the access information of a certain lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the access information.
     */
    AddonModLessonProvider.prototype.getAccessInformation = function (lessonId, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId
            }, preSets = {
                cacheKey: _this.getAccessInformationCacheKey(lessonId)
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_lesson_access_information', params, preSets);
        });
    };
    /**
     * Get cache key for access information WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getAccessInformationCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'accessInfo:' + lessonId;
    };
    /**
     * Get content pages viewed in online and offline.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{online: any[], offline: any[]}>} Promise resolved with an object with the online and offline viewed pages.
     */
    AddonModLessonProvider.prototype.getContentPagesViewed = function (lessonId, retake, siteId) {
        var promises = [], type = AddonModLessonProvider_1.TYPE_STRUCTURE, result = {
            online: [],
            offline: []
        };
        // Get the online pages.
        promises.push(this.getContentPagesViewedOnline(lessonId, retake, false, false, siteId).then(function (pages) {
            result.online = pages;
        }));
        // Get the offline pages.
        promises.push(this.lessonOfflineProvider.getRetakeAttemptsForType(lessonId, retake, type, siteId).catch(function () {
            return [];
        }).then(function (pages) {
            result.offline = pages;
        }));
        return Promise.all(promises).then(function () {
            return result;
        });
    };
    /**
     * Get cache key for get content pages viewed WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getContentPagesViewedCacheKey = function (lessonId, retake) {
        return this.getContentPagesViewedCommonCacheKey(lessonId) + ':' + retake;
    };
    /**
     * Get common cache key for get content pages viewed WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getContentPagesViewedCommonCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'contentPagesViewed:' + lessonId;
    };
    /**
     * Get IDS of content pages viewed in online and offline.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number[]>} Promise resolved with list of IDs.
     */
    AddonModLessonProvider.prototype.getContentPagesViewedIds = function (lessonId, retake, siteId) {
        return this.getContentPagesViewed(lessonId, retake, siteId).then(function (result) {
            var ids = {}, pages = result.online.concat(result.offline);
            pages.forEach(function (page) {
                if (!ids[page.pageid]) {
                    ids[page.pageid] = true;
                }
            });
            return Object.keys(ids).map(function (id) {
                return Number(id);
            });
        });
    };
    /**
     * Get the list of content pages viewed in the site for a certain retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the viewed pages.
     */
    AddonModLessonProvider.prototype.getContentPagesViewedOnline = function (lessonId, retake, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId,
                lessonattempt: retake
            }, preSets = {
                cacheKey: _this.getContentPagesViewedCacheKey(lessonId, retake)
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_content_pages_viewed', params, preSets).then(function (result) {
                return result.pages;
            });
        });
    };
    /**
     * Get the last content page viewed.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the last content page viewed.
     */
    AddonModLessonProvider.prototype.getLastContentPageViewed = function (lessonId, retake, siteId) {
        return this.getContentPagesViewed(lessonId, retake, siteId).then(function (data) {
            var lastPage, maxTime = 0;
            data.online.forEach(function (page) {
                if (page.timeseen > maxTime) {
                    lastPage = page;
                    maxTime = page.timeseen;
                }
            });
            data.offline.forEach(function (page) {
                if (page.timemodified > maxTime) {
                    lastPage = page;
                    maxTime = page.timemodified;
                }
            });
            return lastPage;
        }).catch(function () {
            // Error getting last page, don't return anything.
        });
    };
    /**
     * Get the last page seen.
     * Based on Moodle's get_last_page_seen.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the last page seen.
     */
    AddonModLessonProvider.prototype.getLastPageSeen = function (lessonId, retake, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var lastPageSeen;
        // Get the last question answered.
        return this.lessonOfflineProvider.getLastQuestionPageAttempt(lessonId, retake, siteId).then(function (answer) {
            if (answer) {
                lastPageSeen = answer.newpageid;
            }
            // Now get the last content page viewed.
            return _this.getLastContentPageViewed(lessonId, retake, siteId).then(function (page) {
                if (page) {
                    if (answer) {
                        if (page.timemodified > answer.timemodified) {
                            // This content page was viewed more recently than the question page.
                            lastPageSeen = page.newpageid || page.pageid;
                        }
                    }
                    else {
                        // Has not answered any questions but has viewed a content page.
                        lastPageSeen = page.newpageid || page.pageid;
                    }
                }
                return lastPageSeen;
            });
        });
    };
    /**
     * Get a Lesson by module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmid Course module ID.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the lesson is retrieved.
     */
    AddonModLessonProvider.prototype.getLesson = function (courseId, cmId, forceCache, ignoreCache, siteId) {
        return this.getLessonByField(courseId, 'coursemodule', cmId, forceCache, ignoreCache, siteId);
    };
    /**
     * Get a Lesson with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the lesson is retrieved.
     */
    AddonModLessonProvider.prototype.getLessonByField = function (courseId, key, value, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getLessonDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_lessons_by_courses', params, preSets).then(function (response) {
                if (response && response.lessons) {
                    var currentLesson = response.lessons.find(function (lesson) {
                        return lesson[key] == value;
                    });
                    if (currentLesson) {
                        return currentLesson;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a Lesson by lesson ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} id Lesson ID.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the lesson is retrieved.
     */
    AddonModLessonProvider.prototype.getLessonById = function (courseId, id, forceCache, ignoreCache, siteId) {
        return this.getLessonByField(courseId, 'id', id, forceCache, ignoreCache, siteId);
    };
    /**
     * Get cache key for Lesson data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getLessonDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'lesson:' + courseId;
    };
    /**
     * Get a lesson protected with password.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [password] Password.
     * @param {boolean} [validatePassword=true] If true, the function will fail if the password is wrong.
     *                                          If false, it will return a lesson with the basic data if password is wrong.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the lesson.
     */
    AddonModLessonProvider.prototype.getLessonWithPassword = function (lessonId, password, validatePassword, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (validatePassword === void 0) { validatePassword = true; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId
            }, preSets = {
                cacheKey: _this.getLessonWithPasswordCacheKey(lessonId)
            };
            if (typeof password == 'string') {
                params.password = password;
            }
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_lesson', params, preSets).then(function (response) {
                if (typeof response.lesson.ongoing == 'undefined') {
                    // Basic data not received, password is wrong. Remove stored password.
                    _this.removeStoredPassword(lessonId, site.id);
                    if (validatePassword) {
                        // Invalidate the data and reject.
                        return _this.invalidateLessonWithPassword(lessonId, site.id).catch(function () {
                            // Shouldn't happen.
                        }).then(function () {
                            return Promise.reject(_this.translate.instant('addon.mod_lesson.loginfail'));
                        });
                    }
                }
                return response.lesson;
            });
        });
    };
    /**
     * Get cache key for get lesson with password WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getLessonWithPasswordCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'lessonWithPswrd:' + lessonId;
    };
    /**
     * Given a page ID, a jumpto and all the possible jumps, calcualate the new page ID.
     *
     * @param {number} pageId Current page ID.
     * @param {number} jumpTo The jumpto.
     * @param {any} jumps Result of get pages possible jumps.
     * @return {number} New page ID.
     */
    AddonModLessonProvider.prototype.getNewPageId = function (pageId, jumpTo, jumps) {
        // If jump not found, return current jumpTo.
        if (jumps && jumps[pageId] && jumps[pageId][jumpTo]) {
            return jumps[pageId][jumpTo].calculatedjump;
        }
        else if (!jumpTo) {
            // Return current page.
            return pageId;
        }
        return jumpTo;
    };
    /**
     * Get the ongoing score message for the user (depending on the user permission and lesson settings).
     *
     * @param {any} lesson Lesson.
     * @param {any} accessInfo Result of get access info.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {any} [pageIndex] Object containing all the pages indexed by ID. If not provided, it will be calculated.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the ongoing score message.
     */
    AddonModLessonProvider.prototype.getOngoingScoreMessage = function (lesson, accessInfo, password, review, pageIndex, siteId) {
        var _this = this;
        if (accessInfo.canmanage) {
            return Promise.resolve(this.translate.instant('addon.mod_lesson.teacherongoingwarning'));
        }
        else {
            var retake = accessInfo.attemptscount;
            if (review) {
                retake--;
            }
            return this.lessonGrade(lesson, retake, password, review, pageIndex, siteId).then(function (gradeInfo) {
                var data = {};
                if (lesson.custom) {
                    data.score = gradeInfo.earned;
                    data.currenthigh = gradeInfo.total;
                    return _this.translate.instant('addon.mod_lesson.ongoingcustom', { $a: data });
                }
                else {
                    data.correct = gradeInfo.earned;
                    data.viewed = gradeInfo.attempts;
                    return _this.translate.instant('addon.mod_lesson.ongoingnormal', { $a: data });
                }
            });
        }
    };
    /**
     * Get the possible answers from a page.
     *
     * @param {any} lesson Lesson.
     * @param {number} pageId Page ID.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the list of possible answers.
     */
    AddonModLessonProvider.prototype.getPageAnswers = function (lesson, pageId, password, review, siteId) {
        return this.getPageData(lesson, pageId, password, review, true, true, false, undefined, undefined, siteId).then(function (data) {
            return data.answers;
        });
    };
    /**
     * Get all the possible answers from a list of pages, indexed by answerId.
     *
     * @param {any} lesson Lesson.
     * @param {number[]} pageIds List of page IDs.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with an object containing the answers.
     */
    AddonModLessonProvider.prototype.getPagesAnswers = function (lesson, pageIds, password, review, siteId) {
        var _this = this;
        var answers = {}, promises = [];
        pageIds.forEach(function (pageId) {
            promises.push(_this.getPageAnswers(lesson, pageId, password, review, siteId).then(function (pageAnswers) {
                pageAnswers.forEach(function (answer) {
                    // Include the pageid in each answer and add them to the final list.
                    answer.pageid = pageId;
                    answers[answer.id] = answer;
                });
            }));
        });
        return Promise.all(promises).then(function () {
            return answers;
        });
    };
    /**
     * Get page data.
     *
     * @param {any} lesson Lesson.
     * @param {number} pageId Page ID.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {boolean} [includeContents] Include the page rendered contents.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {any} [accessInfo] Result of get access info. Required if offline is true.
     * @param {any} [jumps] Result of get pages possible jumps. Required if offline is true.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the page data.
     */
    AddonModLessonProvider.prototype.getPageData = function (lesson, pageId, password, review, includeContents, forceCache, ignoreCache, accessInfo, jumps, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lesson.id,
                pageid: Number(pageId),
                review: review ? 1 : 0,
                returncontents: includeContents ? 1 : 0
            }, preSets = {
                cacheKey: _this.getPageDataCacheKey(lesson.id, pageId)
            };
            if (typeof password == 'string') {
                params.password = password;
            }
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            if (review) {
                // Force online mode in review.
                preSets.getFromCache = false;
                preSets.saveToCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_page_data', params, preSets).then(function (data) {
                if (forceCache && accessInfo && data.page) {
                    // Offline mode and valid page. Calculate the data that might be affected.
                    return _this.calculateOfflineData(lesson, accessInfo, password, review, undefined, siteId).then(function (calcData) {
                        Object.assign(data, calcData);
                        return _this.getPageViewMessages(lesson, accessInfo, data.page, review, jumps, password, siteId);
                    }).then(function (messages) {
                        data.messages = messages;
                        return data;
                    });
                }
                return data;
            });
        });
    };
    /**
     * Get cache key for get page data WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} pageId Page ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getPageDataCacheKey = function (lessonId, pageId) {
        return this.getPageDataCommonCacheKey(lessonId) + ':' + pageId;
    };
    /**
     * Get common cache key for get page data WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getPageDataCommonCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'pageData:' + lessonId;
    };
    /**
     * Get lesson pages.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the pages.
     */
    AddonModLessonProvider.prototype.getPages = function (lessonId, password, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId,
            }, preSets = {
                cacheKey: _this.getPagesCacheKey(lessonId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (typeof password == 'string') {
                params.password = password;
            }
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_pages', params, preSets).then(function (response) {
                return response.pages;
            });
        });
    };
    /**
     * Get cache key for get pages WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getPagesCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'pages:' + lessonId;
    };
    /**
     * Get possible jumps for a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the jumps.
     */
    AddonModLessonProvider.prototype.getPagesPossibleJumps = function (lessonId, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId,
            }, preSets = {
                cacheKey: _this.getPagesPossibleJumpsCacheKey(lessonId)
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_pages_possible_jumps', params, preSets).then(function (response) {
                // Index the jumps by page and jumpto.
                if (response.jumps) {
                    var jumps_1 = {};
                    response.jumps.forEach(function (jump) {
                        if (typeof jumps_1[jump.pageid] == 'undefined') {
                            jumps_1[jump.pageid] = {};
                        }
                        jumps_1[jump.pageid][jump.jumpto] = jump;
                    });
                    return jumps_1;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get pages possible jumps WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getPagesPossibleJumpsCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'pagesJumps:' + lessonId;
    };
    /**
     * Get different informative messages when processing a lesson page.
     * Please try to use WS response messages instead of this function if possible.
     * Based on Moodle's add_messages_on_page_process.
     *
     * @param {any} lesson Lesson.
     * @param {any} accessInfo Result of get access info.
     * @param {any} result Result of process page.
     * @param {boolean} review If the user wants to review just after finishing (1 hour margin).
     * @param {any} jumps Result of get pages possible jumps.
     * @return {any[]} Array with the messages.
     */
    AddonModLessonProvider.prototype.getPageProcessMessages = function (lesson, accessInfo, result, review, jumps) {
        var messages = [];
        if (accessInfo.canmanage) {
            // Warning for teachers to inform them that cluster and unseen does not work while logged in as a teacher.
            if (this.lessonDisplayTeacherWarning(jumps)) {
                this.addMessage(messages, 'addon.mod_lesson.teacherjumpwarning', { $a: {
                        cluster: this.translate.instant('addon.mod_lesson.clusterjump'),
                        unseen: this.translate.instant('addon.mod_lesson.unseenpageinbranch')
                    } });
            }
            // Inform teacher that s/he will not see the timer.
            if (lesson.timelimit) {
                this.addMessage(messages, 'addon.mod_lesson.teachertimerwarning');
            }
        }
        // Report attempts remaining.
        if (result.attemptsremaining > 0 && lesson.review && !review) {
            this.addMessage(messages, 'addon.mod_lesson.attemptsremaining', { $a: result.attemptsremaining });
        }
        return messages;
    };
    /**
     * Get the IDs of all the pages that have at least 1 question attempt.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {boolean} [correct] True to only fetch correct attempts, false to get them all.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, site's user.
     * @return {Promise<number[]>} Promise resolved with the IDs.
     */
    AddonModLessonProvider.prototype.getPagesIdsWithQuestionAttempts = function (lessonId, retake, correct, siteId, userId) {
        return this.getQuestionsAttempts(lessonId, retake, correct, undefined, siteId, userId).then(function (result) {
            var ids = {}, attempts = result.online.concat(result.offline);
            attempts.forEach(function (attempt) {
                if (!ids[attempt.pageid]) {
                    ids[attempt.pageid] = true;
                }
            });
            return Object.keys(ids).map(function (id) {
                return Number(id);
            });
        });
    };
    /**
     * Get different informative messages when viewing a lesson page.
     * Please try to use WS response messages instead of this function if possible.
     * Based on Moodle's add_messages_on_page_view.
     *
     * @param {any} lesson Lesson.
     * @param {any} accessInfo Result of get access info. Required if offline is true.
     * @param {any} page Page loaded.
     * @param {boolean} review If the user wants to review just after finishing (1 hour margin).
     * @param {any} jumps Result of get pages possible jumps.
     * @param {string} [password] Lesson password (if any).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of messages.
     */
    AddonModLessonProvider.prototype.getPageViewMessages = function (lesson, accessInfo, page, review, jumps, password, siteId) {
        var _this = this;
        var messages = [];
        var promise = Promise.resolve();
        if (!accessInfo.canmanage) {
            if (page.qtype == AddonModLessonProvider_1.LESSON_PAGE_BRANCHTABLE && lesson.minquestions) {
                // Tell student how many questions they have seen, how many are required and their grade.
                var retake = accessInfo.attemptscount;
                promise = this.lessonGrade(lesson, retake, password, review, undefined, siteId).then(function (gradeInfo) {
                    if (gradeInfo.attempts) {
                        if (gradeInfo.nquestions < lesson.minquestions) {
                            _this.addMessage(messages, 'addon.mod_lesson.numberofpagesviewednotice', { $a: {
                                    nquestions: gradeInfo.nquestions,
                                    minquestions: lesson.minquestions
                                } });
                        }
                        if (!review && !lesson.retake) {
                            _this.addMessage(messages, 'addon.mod_lesson.numberofcorrectanswers', { $a: gradeInfo.earned });
                            if (lesson.grade != __WEBPACK_IMPORTED_MODULE_8__core_grades_providers_grades__["a" /* CoreGradesProvider */].TYPE_NONE) {
                                _this.addMessage(messages, 'addon.mod_lesson.yourcurrentgradeisoutof', { $a: {
                                        grade: _this.textUtils.roundToDecimals(gradeInfo.grade * lesson.grade / 100, 1),
                                        total: lesson.grade
                                    } });
                            }
                        }
                    }
                }).catch(function () {
                    // Ignore errors.
                });
            }
        }
        else {
            if (lesson.timelimit) {
                this.addMessage(messages, 'addon.mod_lesson.teachertimerwarning');
            }
            if (this.lessonDisplayTeacherWarning(jumps)) {
                // Warning for teachers to inform them that cluster and unseen does not work while logged in as a teacher.
                this.addMessage(messages, 'addon.mod_lesson.teacherjumpwarning', { $a: {
                        cluster: this.translate.instant('addon.mod_lesson.clusterjump'),
                        unseen: this.translate.instant('addon.mod_lesson.unseenpageinbranch')
                    } });
            }
        }
        return promise.then(function () {
            return messages;
        });
    };
    /**
     * Get questions attempts, including offline attempts.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {boolean} [correct] True to only fetch correct attempts, false to get them all.
     * @param {number} [pageId] If defined, only get attempts on this page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, site's user.
     * @return {Promise<{online: any[], offline: any[]}>} Promise resolved with the questions attempts.
     */
    AddonModLessonProvider.prototype.getQuestionsAttempts = function (lessonId, retake, correct, pageId, siteId, userId) {
        var promises = [], result = {
            online: [],
            offline: []
        };
        promises.push(this.getQuestionsAttemptsOnline(lessonId, retake, correct, pageId, false, false, siteId, userId)
            .then(function (attempts) {
            result.online = attempts;
        }));
        promises.push(this.lessonOfflineProvider.getQuestionsAttempts(lessonId, retake, correct, pageId, siteId).catch(function () {
            // Error, assume no attempts.
            return [];
        }).then(function (attempts) {
            result.offline = attempts;
        }));
        return Promise.all(promises).then(function () {
            return result;
        });
    };
    /**
     * Get cache key for get questions attempts WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getQuestionsAttemptsCacheKey = function (lessonId, retake, userId) {
        return this.getQuestionsAttemptsCommonCacheKey(lessonId) + ':' + userId + ':' + retake;
    };
    /**
     * Get common cache key for get questions attempts WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getQuestionsAttemptsCommonCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'questionsAttempts:' + lessonId;
    };
    /**
     * Get questions attempts from the site.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {boolean} [correct] True to only fetch correct attempts, false to get them all.
     * @param {number} [pageId] If defined, only get attempts on this page.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, site's user.
     * @return {Promise<any[]>} Promise resolved with the questions attempts.
     */
    AddonModLessonProvider.prototype.getQuestionsAttemptsOnline = function (lessonId, retake, correct, pageId, forceCache, ignoreCache, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            // Don't pass "pageId" and "correct" params, they will be filtered locally.
            var params = {
                lessonid: lessonId,
                attempt: retake,
                userid: userId
            }, preSets = {
                cacheKey: _this.getQuestionsAttemptsCacheKey(lessonId, retake, userId)
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_questions_attempts', params, preSets).then(function (response) {
                if (pageId || correct) {
                    // Filter the attempts.
                    return response.attempts.filter(function (attempt) {
                        if (correct && !attempt.correct) {
                            return false;
                        }
                        if (pageId && attempt.pageid != pageId) {
                            return false;
                        }
                        return true;
                    });
                }
                return response.attempts;
            });
        });
    };
    /**
     * Get the overview of retakes in a lesson (named "attempts overview" in Moodle).
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} [groupId] The group to get. If not defined, all participants.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the retakes overview.
     */
    AddonModLessonProvider.prototype.getRetakesOverview = function (lessonId, groupId, forceCache, ignoreCache, siteId) {
        var _this = this;
        groupId = groupId || 0;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId,
                groupid: groupId
            }, preSets = {
                cacheKey: _this.getRetakesOverviewCacheKey(lessonId, groupId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_attempts_overview', params, preSets).then(function (response) {
                return response.data;
            });
        });
    };
    /**
     * Get cache key for get retakes overview WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} groupId Group ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getRetakesOverviewCacheKey = function (lessonId, groupId) {
        return this.getRetakesOverviewCommonCacheKey(lessonId) + ':' + groupId;
    };
    /**
     * Get common cache key for get retakes overview WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getRetakesOverviewCommonCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'retakesOverview:' + lessonId;
    };
    /**
     * Get a password stored in DB.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with password on success, rejected otherwise.
     */
    AddonModLessonProvider.prototype.getStoredPassword = function (lessonId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonModLessonProvider_1.PASSWORD_TABLE, { lessonid: lessonId }).then(function (entry) {
                return entry.password;
            });
        });
    };
    /**
     * Finds all pages that appear to be a subtype of the provided pageId until an end point specified within "ends" is
     * encountered or no more pages exist.
     * Based on Moodle's get_sub_pages_of.
     *
     * @param {any} pages Index of lesson pages, indexed by page ID. See createPagesIndex.
     * @param {number} pageId Page ID to get subpages of.
     * @param {number[]} end An array of LESSON_PAGE_* types that signify an end of the subtype.
     * @return {Object[]} List of subpages.
     */
    AddonModLessonProvider.prototype.getSubpagesOf = function (pages, pageId, ends) {
        var subPages = [];
        pageId = pages[pageId].nextpageid; // Move to the first page after the given page.
        ends = ends || [];
        while (true) {
            if (!pageId || ends.indexOf(pages[pageId].qtype) != -1) {
                // No more pages or it reached a page of the searched types. Stop.
                break;
            }
            subPages.push(pages[pageId]);
            pageId = pages[pageId].nextpageid;
        }
        return subPages;
    };
    /**
     * Get lesson timers.
     *
     * @param {number} lessonId Lesson ID.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @return {Promise<any[]>} Promise resolved with the pages.
     */
    AddonModLessonProvider.prototype.getTimers = function (lessonId, forceCache, ignoreCache, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                lessonid: lessonId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getTimersCacheKey(lessonId, userId)
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_user_timers', params, preSets).then(function (response) {
                return response.timers;
            });
        });
    };
    /**
     * Get cache key for get timers WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getTimersCacheKey = function (lessonId, userId) {
        return this.getTimersCommonCacheKey(lessonId) + ':' + userId;
    };
    /**
     * Get common cache key for get timers WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getTimersCommonCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'timers:' + lessonId;
    };
    /**
     * Get the list of used answers (with valid answer) in a multichoice question page.
     *
     * @param {any} pageData Result of getPageData for the page to process.
     * @return {any[]} List of used answers.
     */
    AddonModLessonProvider.prototype.getUsedAnswersMultichoice = function (pageData) {
        var answers = this.utils.clone(pageData.answers);
        return answers.filter(function (entry) {
            return entry.answer !== '';
        });
    };
    /**
     * Get the user's response in a matching question page.
     *
     * @param {any} data Data containing the user answer.
     * @return {any} User response.
     */
    AddonModLessonProvider.prototype.getUserResponseMatching = function (data) {
        if (data.response) {
            // The data is already stored as expected. Return it.
            return data.response;
        }
        // Data is stored in properties like 'response[379]'. Recreate the response object.
        var response = {};
        for (var key in data) {
            var match = key.match(/^response\[(\d+)\]/);
            if (match && match.length > 1) {
                response[match[1]] = data[key];
            }
        }
        return response;
    };
    /**
     * Get the user's response in a multichoice page if multiple answers are allowed.
     *
     * @param {any} data Data containing the user answer.
     * @return {any[]} User response.
     */
    AddonModLessonProvider.prototype.getUserResponseMultichoice = function (data) {
        if (data.answer) {
            // The data is already stored as expected. If it's valid, parse the values to int.
            if (Array.isArray(data.answer)) {
                return data.answer.map(function (value) {
                    return parseInt(value, 10);
                });
            }
            return data.answer;
        }
        // Data is stored in properties like 'answer[379]'. Recreate the answer array.
        var answer = [];
        for (var key in data) {
            var match = key.match(/^answer\[(\d+)\]/);
            if (match && match.length > 1) {
                answer.push(parseInt(match[1], 10));
            }
        }
        return answer;
    };
    /**
     * Get a user's retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number
     * @param {number} [userId] User ID. Undefined for current user.
     * @param {boolean} [forceCache] Whether it should always return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the retake data.
     */
    AddonModLessonProvider.prototype.getUserRetake = function (lessonId, retake, userId, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                lessonid: lessonId,
                userid: userId,
                lessonattempt: retake
            }, preSets = {
                cacheKey: _this.getUserRetakeCacheKey(lessonId, userId, retake),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_lesson_get_user_attempt', params, preSets);
        });
    };
    /**
     * Get cache key for get user retake WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} userId User ID.
     * @param {number} retake Retake number
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getUserRetakeCacheKey = function (lessonId, userId, retake) {
        return this.getUserRetakeUserCacheKey(lessonId, userId) + ':' + retake;
    };
    /**
     * Get user cache key for get user retake WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getUserRetakeUserCacheKey = function (lessonId, userId) {
        return this.getUserRetakeLessonCacheKey(lessonId) + ':' + userId;
    };
    /**
     * Get lesson cache key for get user retake WS calls.
     *
     * @param {number} lessonId Lesson ID.
     * @return {string} Cache key.
     */
    AddonModLessonProvider.prototype.getUserRetakeLessonCacheKey = function (lessonId) {
        return this.ROOT_CACHE_KEY + 'userRetake:' + lessonId;
    };
    /**
     * Get the prevent access reason to display for a certain lesson.
     *
     * @param {any} info Lesson access info.
     * @param {boolean} [ignorePassword] Whether password protected reason should be ignored (user already entered the password).
     * @param {boolean} [isReview] Whether user is reviewing a retake.
     * @return {any} Prevent access reason.
     */
    AddonModLessonProvider.prototype.getPreventAccessReason = function (info, ignorePassword, isReview) {
        var result;
        if (info && info.preventaccessreasons) {
            for (var i = 0; i < info.preventaccessreasons.length; i++) {
                var entry = info.preventaccessreasons[i];
                if (entry.reason == 'lessonopen' || entry.reason == 'lessonclosed') {
                    // Time restrictions are the most prioritary, return it.
                    return entry;
                }
                else if (entry.reason == 'passwordprotectedlesson') {
                    if (!ignorePassword) {
                        // Treat password before all other reasons.
                        result = entry;
                    }
                }
                else if (entry.reason == 'noretake' && isReview) {
                    // Ignore noretake error when reviewing.
                }
                else if (!result) {
                    // Rest of cases, just return any of them.
                    result = entry;
                }
            }
        }
        return result;
    };
    /**
     * Check if a jump is correct.
     * Based in Moodle's jumpto_is_correct.
     *
     * @param {number} pageId ID of the page from which you are jumping from.
     * @param {number} jumpTo The jumpto number.
     * @param {any} pageIndex Object containing all the pages indexed by ID. See createPagesIndex.
     * @return {boolean} Whether jump is correct.
     */
    AddonModLessonProvider.prototype.jumptoIsCorrect = function (pageId, jumpTo, pageIndex) {
        // First test the special values.
        if (!jumpTo) {
            // Same page
            return false;
        }
        else if (jumpTo == AddonModLessonProvider_1.LESSON_NEXTPAGE) {
            return true;
        }
        else if (jumpTo == AddonModLessonProvider_1.LESSON_UNSEENBRANCHPAGE) {
            return true;
        }
        else if (jumpTo == AddonModLessonProvider_1.LESSON_RANDOMPAGE) {
            return true;
        }
        else if (jumpTo == AddonModLessonProvider_1.LESSON_CLUSTERJUMP) {
            return true;
        }
        else if (jumpTo == AddonModLessonProvider_1.LESSON_EOL) {
            return true;
        }
        var aPageId = pageIndex[pageId].nextpageid;
        while (aPageId) {
            if (jumpTo == aPageId) {
                return true;
            }
            aPageId = pageIndex[aPageId].nextpageid;
        }
        return false;
    };
    /**
     * Invalidates Lesson data.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateAccessInformation = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAccessInformationCacheKey(lessonId));
        });
    };
    /**
     * Invalidates content pages viewed for all retakes.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateContentPagesViewed = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getContentPagesViewedCommonCacheKey(lessonId));
        });
    };
    /**
     * Invalidates content pages viewed for a certain retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateContentPagesViewedForRetake = function (lessonId, retake, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getContentPagesViewedCacheKey(lessonId, retake));
        });
    };
    /**
     * Invalidates Lesson data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateLessonData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getLessonDataCacheKey(courseId));
        });
    };
    /**
     * Invalidates lesson with password.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateLessonWithPassword = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getLessonWithPasswordCacheKey(lessonId));
        });
    };
    /**
     * Invalidates page data for all pages.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidatePageData = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getPageDataCommonCacheKey(lessonId));
        });
    };
    /**
     * Invalidates page data for a certain page.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} pageId Page ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidatePageDataForPage = function (lessonId, pageId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getPageDataCacheKey(lessonId, pageId));
        });
    };
    /**
     * Invalidates pages.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidatePages = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getPagesCacheKey(lessonId));
        });
    };
    /**
     * Invalidates pages possible jumps.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidatePagesPossibleJumps = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getPagesPossibleJumpsCacheKey(lessonId));
        });
    };
    /**
     * Invalidates questions attempts for all retakes.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateQuestionsAttempts = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getQuestionsAttemptsCommonCacheKey(lessonId));
        });
    };
    /**
     * Invalidates question attempts for a certain retake and user.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site..
     * @param {number} [userId] User ID. If not defined, site's user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateQuestionsAttemptsForRetake = function (lessonId, retake, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getQuestionsAttemptsCacheKey(lessonId, retake, userId));
        });
    };
    /**
     * Invalidates retakes overview for all groups in a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateRetakesOverview = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getRetakesOverviewCommonCacheKey(lessonId));
        });
    };
    /**
     * Invalidates retakes overview for a certain group in a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} groupId Group ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateRetakesOverviewForGroup = function (lessonId, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getRetakesOverviewCacheKey(lessonId, groupId));
        });
    };
    /**
     * Invalidates timers for all users in a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateTimers = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getTimersCommonCacheKey(lessonId));
        });
    };
    /**
     * Invalidates timers for a certain user.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateTimersForUser = function (lessonId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getTimersCacheKey(lessonId, userId));
        });
    };
    /**
     * Invalidates a certain retake for a certain user.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {number} [userId] User ID. Undefined for current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateUserRetake = function (lessonId, retake, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getUserRetakeCacheKey(lessonId, userId, retake));
        });
    };
    /**
     * Invalidates all retakes for all users in a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateUserRetakesForLesson = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getUserRetakeLessonCacheKey(lessonId));
        });
    };
    /**
     * Invalidates all retakes for a certain user in a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} [userId] User ID. Undefined for current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonProvider.prototype.invalidateUserRetakesForUser = function (lessonId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKeyStartingWith(_this.getUserRetakeUserCacheKey(lessonId, userId));
        });
    };
    /**
     * Check if a page answer is correct.
     *
     * @param {any} lesson Lesson.
     * @param {number} pageId The page ID.
     * @param {any} answer The answer to check.
     * @param {any} pageIndex Object containing all the pages indexed by ID.
     * @return {boolean} Whether the answer is correct.
     */
    AddonModLessonProvider.prototype.isAnswerCorrect = function (lesson, pageId, answer, pageIndex) {
        if (lesson.custom) {
            // Custom scores. If score on answer is positive, it is correct.
            return answer.score > 0;
        }
        else {
            return this.jumptoIsCorrect(pageId, answer.jumpto, pageIndex);
        }
    };
    /**
     * Check if a lesson is enabled to be used in offline.
     *
     * @param {any} lesson Lesson.
     * @return {boolean} Whether offline is enabled.
     */
    AddonModLessonProvider.prototype.isLessonOffline = function (lesson) {
        return !!lesson.allowofflineattempts;
    };
    /**
     * Check if a lesson is password protected based in the access info.
     *
     * @param {any} info Lesson access info.
     * @return {boolean} Whether the lesson is password protected.
     */
    AddonModLessonProvider.prototype.isPasswordProtected = function (info) {
        if (info && info.preventaccessreasons) {
            for (var i = 0; i < info.preventaccessreasons.length; i++) {
                var entry = info.preventaccessreasons[i];
                if (entry.reason == 'passwordprotectedlesson') {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * Return whether or not the plugin is enabled in a certain site. Plugin is enabled if the lesson WS are available.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonModLessonProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // All WS were introduced at the same time so checking one is enough.
            return site.wsAvailable('mod_lesson_get_lesson_access_information');
        });
    };
    /**
     * Check if a page is a question page or a content page.
     *
     * @param {number} type Type of the page.
     * @return {boolean} True if question page, false if content page.
     */
    AddonModLessonProvider.prototype.isQuestionPage = function (type) {
        return type == AddonModLessonProvider_1.TYPE_QUESTION;
    };
    /**
     * Start or continue a retake.
     *
     * @param {string} id Lesson ID.
     * @param {string} [password] Lesson password (if any).
     * @param {number} [pageId] Page id to continue from (only when continuing a retake).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModLessonProvider.prototype.launchRetake = function (id, password, pageId, review, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: id,
                review: review ? 1 : 0
            };
            if (typeof password == 'string') {
                params.password = password;
            }
            if (typeof pageId == 'number') {
                params.pageid = pageId;
            }
            return site.write('mod_lesson_launch_attempt', params).then(function (response) {
                _this.eventsProvider.trigger(AddonModLessonProvider_1.DATA_SENT_EVENT, {
                    lessonId: id,
                    type: 'launch'
                }, _this.sitesProvider.getCurrentSiteId());
                return response;
            });
        });
    };
    /**
     * Check if the user left during a timed session.
     *
     * @param {any} info Lesson access info.
     * @return {boolean} True if left during timed, false otherwise.
     */
    AddonModLessonProvider.prototype.leftDuringTimed = function (info) {
        return info && info.lastpageseen && info.lastpageseen != AddonModLessonProvider_1.LESSON_EOL && info.leftduringtimedsession;
    };
    /**
     * Checks to see if a LESSON_CLUSTERJUMP or a LESSON_UNSEENBRANCHPAGE is used in a lesson.
     * Based on Moodle's lesson_display_teacher_warning.
     *
     * @param {any} jumps Result of get pages possible jumps.
     * @return {boolean} Whether the lesson uses one of those jumps.
     */
    AddonModLessonProvider.prototype.lessonDisplayTeacherWarning = function (jumps) {
        if (!jumps) {
            return false;
        }
        // Check if any jump is to cluster or unseen content page.
        for (var pageId in jumps) {
            for (var jumpto in jumps[pageId]) {
                var jumptoNum = Number(jumpto);
                if (jumptoNum == AddonModLessonProvider_1.LESSON_CLUSTERJUMP ||
                    jumptoNum == AddonModLessonProvider_1.LESSON_UNSEENBRANCHPAGE) {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * Calculates a user's grade for a lesson.
     * Based on Moodle's lesson_grade.
     *
     * @param {any} lesson Lesson.
     * @param {number} retake Retake number.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {any} [pageIndex] Object containing all the pages indexed by ID. If not provided, it will be calculated.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined, site's user.
     * @return {Promise<AddonModLessonCheckAnswerResult>} Promise resolved with the grade data.
     */
    AddonModLessonProvider.prototype.lessonGrade = function (lesson, retake, password, review, pageIndex, siteId, userId) {
        var _this = this;
        // Initialize all variables.
        var nViewed = 0, nManual = 0, manualPoints = 0, theGrade = 0, nQuestions = 0, total = 0, earned = 0;
        // Get the questions attempts for the user.
        return this.getQuestionsAttempts(lesson.id, retake, false, undefined, siteId, userId).then(function (attemptsData) {
            var attempts = attemptsData.online.concat(attemptsData.offline);
            if (!attempts.length) {
                // No attempts.
                return;
            }
            var attemptSet = {};
            var promise;
            // Create the pageIndex if it isn't provided.
            if (!pageIndex) {
                promise = _this.getPages(lesson.id, password, true, false, siteId).then(function (pages) {
                    pageIndex = _this.createPagesIndex(pages);
                });
            }
            else {
                promise = Promise.resolve();
            }
            return promise.then(function () {
                var pageIds = [];
                // Group each try with its page.
                attempts.forEach(function (attempt) {
                    if (!attemptSet[attempt.pageid]) {
                        attemptSet[attempt.pageid] = [];
                        pageIds.push(attempt.pageid);
                    }
                    attemptSet[attempt.pageid].push(attempt);
                });
                // Drop all attempts that go beyond max attempts for the lesson.
                for (var pageId in attemptSet) {
                    // Sort the list by time in ascending order.
                    var attempts_1 = attemptSet[pageId].sort(function (a, b) {
                        return (a.timeseen || a.timemodified) - (b.timeseen || b.timemodified);
                    });
                    attemptSet[pageId] = attempts_1.slice(0, lesson.maxattempts);
                }
                // Get all the answers from the pages the user answered.
                return _this.getPagesAnswers(lesson, pageIds, password, review, siteId);
            }).then(function (answers) {
                // Number of pages answered.
                nQuestions = Object.keys(attemptSet).length;
                for (var pageId in attemptSet) {
                    var attempts_2 = attemptSet[pageId], lastAttempt = attempts_2[attempts_2.length - 1];
                    if (lesson.custom) {
                        // If essay question, handle it, otherwise add to score.
                        if (pageIndex[lastAttempt.pageid].qtype == AddonModLessonProvider_1.LESSON_PAGE_ESSAY) {
                            if (lastAttempt.useranswer && typeof lastAttempt.useranswer.score != 'undefined') {
                                earned += lastAttempt.useranswer.score;
                            }
                            nManual++;
                            manualPoints += answers[lastAttempt.answerid].score;
                        }
                        else if (lastAttempt.answerid) {
                            earned += answers[lastAttempt.answerid].score;
                        }
                    }
                    else {
                        attempts_2.forEach(function (attempt) {
                            earned += attempt.correct ? 1 : 0;
                        });
                        // If essay question, increase numbers.
                        if (pageIndex[lastAttempt.pageid].qtype == AddonModLessonProvider_1.LESSON_PAGE_ESSAY) {
                            nManual++;
                            manualPoints++;
                        }
                    }
                    // Number of times answered.
                    nViewed += attempts_2.length;
                }
                if (lesson.custom) {
                    var bestScores = {};
                    // Find the highest possible score per page to get our total.
                    for (var answerId in answers) {
                        var answer = answers[answerId];
                        if (typeof bestScores[answer.pageid] == 'undefined') {
                            bestScores[answer.pageid] = answer.score;
                        }
                        else if (bestScores[answer.pageid] < answer.score) {
                            bestScores[answer.pageid] = answer.score;
                        }
                    }
                    // Sum all the scores.
                    for (var pageId in bestScores) {
                        total += bestScores[pageId];
                    }
                }
                else {
                    // Check to make sure the student has answered the minimum questions.
                    if (lesson.minquestions && nQuestions < lesson.minquestions) {
                        // Nope, increase number viewed by the amount of unanswered questions.
                        total = nViewed + (lesson.minquestions - nQuestions);
                    }
                    else {
                        total = nViewed;
                    }
                }
            });
        }).then(function () {
            if (total) {
                theGrade = _this.textUtils.roundToDecimals(earned * 100 / total, 5);
            }
            return {
                nquestions: nQuestions,
                attempts: nViewed,
                total: total,
                earned: earned,
                grade: theGrade,
                nmanual: nManual,
                manualpoints: manualPoints
            };
        });
    };
    /**
     * Report a lesson as being viewed.
     *
     * @param {string} id Module ID.
     * @param {string} [password] Lesson password (if any).
     * @param {string} [name] Name of the assign.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModLessonProvider.prototype.logViewLesson = function (id, password, name, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: id
            };
            if (typeof password == 'string') {
                params.password = password;
            }
            return _this.logHelper.logSingle('mod_lesson_view_lesson', params, AddonModLessonProvider_1.COMPONENT, id, name, 'lesson', {}, siteId);
        });
    };
    /**
     * Process a lesson page, saving its data.
     *
     * @param {any} lesson Lesson.
     * @param {number} courseId Course ID the lesson belongs to.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data to save.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {boolean} [offline] Whether it's offline mode.
     * @param {any} [accessInfo] Result of get access info. Required if offline is true.
     * @param {any} [jumps] Result of get pages possible jumps. Required if offline is true.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonProvider.prototype.processPage = function (lesson, courseId, pageData, data, password, review, offline, accessInfo, jumps, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var page = pageData.page, pageId = page.id;
        var result, pageIndex;
        if (offline) {
            // Get the list of pages of the lesson.
            return this.getPages(lesson.id, password, true, false, siteId).then(function (pages) {
                pageIndex = _this.createPagesIndex(pages);
                if (pageData.answers.length) {
                    return _this.recordAttempt(lesson, courseId, pageData, data, review, accessInfo, jumps, pageIndex, siteId);
                }
                else {
                    // The page has no answers so we will just progress to the next page (as set by newpageid).
                    return {
                        nodefaultresponse: true,
                        newpageid: data.newpageid
                    };
                }
            }).then(function (res) {
                result = res;
                result.newpageid = _this.getNewPageId(pageData.page.id, result.newpageid, jumps);
                // Calculate some needed offline data.
                return _this.calculateOfflineData(lesson, accessInfo, password, review, pageIndex, siteId);
            }).then(function (calculatedData) {
                // Add some default data to match the WS response.
                result.warnings = [];
                result.displaymenu = pageData.displaymenu; // Keep the same value since we can't calculate it in offline.
                result.messages = _this.getPageProcessMessages(lesson, accessInfo, result, review, jumps);
                Object.assign(result, calculatedData);
                return result;
            });
        }
        return this.processPageOnline(lesson.id, pageId, data, password, review, siteId).then(function (response) {
            _this.eventsProvider.trigger(AddonModLessonProvider_1.DATA_SENT_EVENT, {
                lessonId: lesson.id,
                type: 'process',
                courseId: courseId,
                pageId: pageId,
                review: review
            }, _this.sitesProvider.getCurrentSiteId());
            return response;
        });
    };
    /**
     * Process a lesson page, saving its data. It will fail if offline or cannot connect.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} pageId Page ID.
     * @param {any} data Data to save.
     * @param {string} [password] Lesson password (if any).
     * @param {boolean} [review] If the user wants to review just after finishing (1 hour margin).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModLessonProvider.prototype.processPageOnline = function (lessonId, pageId, data, password, review, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                lessonid: lessonId,
                pageid: pageId,
                data: _this.utils.objectToArrayOfObjects(data, 'name', 'value', true),
                review: review ? 1 : 0
            };
            if (typeof password == 'string') {
                params.password = password;
            }
            return site.write('mod_lesson_process_page', params);
        });
    };
    /**
     * Records an attempt on a certain page.
     * Based on Moodle's record_attempt.
     *
     * @param {any} lesson Lesson.
     * @param {number} courseId Course ID the lesson belongs to.
     * @param {any} pageData Result of getPageData for the page to process.
     * @param {any} data Data to save.
     * @param {boolean} review If the user wants to review just after finishing (1 hour margin).
     * @param {any} accessInfo Result of get access info.
     * @param {any} jumps Result of get pages possible jumps.
     * @param {any} pageIndex Object containing all the pages indexed by ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModLessonRecordAttemptResult>} Promise resolved with the result.
     */
    AddonModLessonProvider.prototype.recordAttempt = function (lesson, courseId, pageData, data, review, accessInfo, jumps, pageIndex, siteId) {
        var _this = this;
        // Check the user answer. Each page type has its own implementation.
        var result = this.checkAnswer(lesson, pageData, data, jumps, pageIndex), retake = accessInfo.attemptscount;
        // Processes inmediate jumps.
        if (result.inmediatejump) {
            if (pageData.page.qtype == AddonModLessonProvider_1.LESSON_PAGE_BRANCHTABLE) {
                // Store the content page data. In Moodle this is stored in a separate table, during checkAnswer.
                return this.lessonOfflineProvider.processPage(lesson.id, courseId, retake, pageData.page, data, result.newpageid, result.answerid, false, result.userresponse, siteId).then(function () {
                    return result;
                });
            }
            return Promise.resolve(result);
        }
        var promise = Promise.resolve(), stop = false, nAttempts;
        result.attemptsremaining = 0;
        result.maxattemptsreached = false;
        if (result.noanswer) {
            result.newpageid = pageData.page.id; // Display same page again.
            result.feedback = this.translate.instant('addon.mod_lesson.noanswer');
        }
        else {
            if (!accessInfo.canmanage) {
                // Get the number of attempts that have been made on this question for this student and retake.
                promise = this.getQuestionsAttempts(lesson.id, retake, false, pageData.page.id, siteId).then(function (attempts) {
                    nAttempts = attempts.online.length + attempts.offline.length;
                    // Check if they have reached (or exceeded) the maximum number of attempts allowed.
                    if (nAttempts >= lesson.maxattempts) {
                        result.maxattemptsreached = true;
                        result.feedback = _this.translate.instant('addon.mod_lesson.maximumnumberofattemptsreached');
                        result.newpageid = AddonModLessonProvider_1.LESSON_NEXTPAGE;
                        stop = true; // Set stop to true to prevent further calculations.
                        return;
                    }
                    var subPromise;
                    // Only insert a record if we are not reviewing the lesson.
                    if (!review) {
                        if (lesson.retake || (!lesson.retake && !retake)) {
                            // Store the student's attempt and increase the number of attempts made.
                            // Calculate and store the new page ID to prevent having to recalculate it later.
                            var newPageId = _this.getNewPageId(pageData.page.id, result.newpageid, jumps);
                            subPromise = _this.lessonOfflineProvider.processPage(lesson.id, courseId, retake, pageData.page, data, newPageId, result.answerid, result.correctanswer, result.userresponse, siteId);
                            nAttempts++;
                        }
                    }
                    // Check if "number of attempts remaining" message is needed.
                    if (!result.correctanswer && !result.newpageid) {
                        // Retreive the number of attempts left counter.
                        if (nAttempts >= lesson.maxattempts) {
                            if (lesson.maxattempts > 1) {
                                result.maxattemptsreached = true;
                            }
                            result.newpageid = AddonModLessonProvider_1.LESSON_NEXTPAGE;
                        }
                        else if (lesson.maxattempts > 1) {
                            result.attemptsremaining = lesson.maxattempts - nAttempts;
                        }
                    }
                    return subPromise;
                });
            }
            promise = promise.then(function () {
                if (stop) {
                    return;
                }
                // Determine default feedback if necessary.
                if (!result.response) {
                    if (!lesson.feedback && !result.noanswer &&
                        !(lesson.review && !result.correctanswer && !result.isessayquestion)) {
                        // These conditions have been met:
                        //  1. The lesson manager has not supplied feedback to the student.
                        //  2. Not displaying default feedback.
                        //  3. The user did provide an answer.
                        //  4. We are not reviewing with an incorrect answer (and not reviewing an essay question).
                        result.nodefaultresponse = true;
                    }
                    else if (result.isessayquestion) {
                        result.response = _this.translate.instant('addon.mod_lesson.defaultessayresponse');
                    }
                    else if (result.correctanswer) {
                        result.response = _this.translate.instant('addon.mod_lesson.thatsthecorrectanswer');
                    }
                    else {
                        result.response = _this.translate.instant('addon.mod_lesson.thatsthewronganswer');
                    }
                }
                if (result.response) {
                    var subPromise = void 0;
                    if (lesson.review && !result.correctanswer && !result.isessayquestion) {
                        // Calculate the number of question attempt in the page if it isn't calculated already.
                        if (typeof nAttempts == 'undefined') {
                            subPromise = _this.getQuestionsAttempts(lesson.id, retake, false, pageData.page.id, siteId)
                                .then(function (result) {
                                nAttempts = result.online.length + result.offline.length;
                            });
                        }
                        else {
                            subPromise = Promise.resolve();
                        }
                        subPromise.then(function () {
                            var messageId = nAttempts == 1 ? 'firstwrong' : 'secondpluswrong';
                            result.feedback = '<div class="box feedback">' +
                                _this.translate.instant('addon.mod_lesson.' + messageId) + '</div>';
                        });
                    }
                    else {
                        result.feedback = '';
                        subPromise = Promise.resolve();
                    }
                    var className_1 = 'response';
                    if (result.correctanswer) {
                        className_1 += ' correct';
                    }
                    else if (!result.isessayquestion) {
                        className_1 += ' incorrect';
                    }
                    return subPromise.then(function () {
                        result.feedback += '<div class="box generalbox boxaligncenter p-y-1">' + pageData.page.contents + '</div>';
                        result.feedback += '<div class="correctanswer generalbox"><em>' +
                            _this.translate.instant('addon.mod_lesson.youranswer') + '</em> : ' +
                            '<div class="studentanswer m-t-2 m-b-2"><table class="generaltable"><tbody>';
                        // Create a table containing the answers and responses.
                        if (pageData.page.qoption) {
                            // Multianswer allowed.
                            var studentAnswerArray = result.studentanswer ?
                                result.studentanswer.split(AddonModLessonProvider_1.MULTIANSWER_DELIMITER) : [], responseArray = result.response ?
                                result.response.split(AddonModLessonProvider_1.MULTIANSWER_DELIMITER) : [];
                            // Add answers and responses to the table.
                            for (var i = 0; i < studentAnswerArray.length; i++) {
                                result.feedback = _this.addAnswerAndResponseToFeedback(result.feedback, studentAnswerArray[i], result.studentanswerformat, responseArray[i], className_1);
                            }
                        }
                        else {
                            // Only 1 answer, add it to the table.
                            result.feedback = _this.addAnswerAndResponseToFeedback(result.feedback, result.studentanswer, result.studentanswerformat, result.response, className_1);
                        }
                        result.feedback += '</tbody></table></div></div>';
                    });
                }
            });
        }
        return promise.then(function () {
            return result;
        });
    };
    /**
     * Remove a password stored in DB.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when removed.
     */
    AddonModLessonProvider.prototype.removeStoredPassword = function (lessonId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModLessonProvider_1.PASSWORD_TABLE, { lessonid: lessonId });
        });
    };
    /**
     * Store a password in DB.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} password Password to store.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when stored.
     */
    AddonModLessonProvider.prototype.storePassword = function (lessonId, password, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                lessonid: lessonId,
                password: password,
                timemodified: Date.now()
            };
            return site.getDb().insertRecord(AddonModLessonProvider_1.PASSWORD_TABLE, entry);
        });
    };
    /**
     * Function to determine if a page is a valid page. It will add the page to validPages if valid. It can also
     * modify the list of viewedPagesIds for cluster pages.
     * Based on Moodle's valid_page_and_view.
     *
     * @param {any} pages Index of lesson pages, indexed by page ID. See createPagesIndex.
     * @param {any} page Page to check.
     * @param {any} validPages Valid pages, indexed by page ID.
     * @param {number[]} viewedPagesIds List of viewed pages IDs.
     * @return {number} Next page ID.
     */
    AddonModLessonProvider.prototype.validPageAndView = function (pages, page, validPages, viewedPagesIds) {
        if (page.qtype != AddonModLessonProvider_1.LESSON_PAGE_ENDOFCLUSTER &&
            page.qtype != AddonModLessonProvider_1.LESSON_PAGE_ENDOFBRANCH) {
            // Add this page as a valid page.
            validPages[page.id] = 1;
        }
        if (page.qtype == AddonModLessonProvider_1.LESSON_PAGE_CLUSTER) {
            // Get list of pages in the cluster.
            var subPages = this.getSubpagesOf(pages, page.id, [AddonModLessonProvider_1.LESSON_PAGE_ENDOFCLUSTER]);
            subPages.forEach(function (subPage) {
                var position = viewedPagesIds.indexOf(subPage.id);
                if (position != -1) {
                    delete viewedPagesIds[position]; // Remove it.
                    // Since the user did see one page in the cluster, add the cluster pageid to the viewedPagesIds.
                    if (viewedPagesIds.indexOf(page.id) == -1) {
                        viewedPagesIds.push(page.id);
                    }
                }
            });
        }
        return page.nextpageid;
    };
    AddonModLessonProvider.COMPONENT = 'mmaModLesson';
    AddonModLessonProvider.DATA_SENT_EVENT = 'addon_mod_lesson_data_sent';
    // This page.
    AddonModLessonProvider.LESSON_THISPAGE = 0;
    // Next page -> any page not seen before.
    AddonModLessonProvider.LESSON_UNSEENPAGE = 1;
    // Next page -> any page not answered correctly.
    AddonModLessonProvider.LESSON_UNANSWEREDPAGE = 2;
    // Jump to Next Page.
    AddonModLessonProvider.LESSON_NEXTPAGE = -1;
    // End of Lesson.
    AddonModLessonProvider.LESSON_EOL = -9;
    // Jump to an unseen page within a branch and end of branch or end of lesson.
    AddonModLessonProvider.LESSON_UNSEENBRANCHPAGE = -50;
    // Jump to a random page within a branch and end of branch or end of lesson.
    AddonModLessonProvider.LESSON_RANDOMPAGE = -60;
    // Jump to a random Branch.
    AddonModLessonProvider.LESSON_RANDOMBRANCH = -70;
    // Cluster Jump.
    AddonModLessonProvider.LESSON_CLUSTERJUMP = -80;
    // Type of page: question or structure (content).
    AddonModLessonProvider.TYPE_QUESTION = 0;
    AddonModLessonProvider.TYPE_STRUCTURE = 1;
    // Type of question pages.
    AddonModLessonProvider.LESSON_PAGE_SHORTANSWER = 1;
    AddonModLessonProvider.LESSON_PAGE_TRUEFALSE = 2;
    AddonModLessonProvider.LESSON_PAGE_MULTICHOICE = 3;
    AddonModLessonProvider.LESSON_PAGE_MATCHING = 5;
    AddonModLessonProvider.LESSON_PAGE_NUMERICAL = 8;
    AddonModLessonProvider.LESSON_PAGE_ESSAY = 10;
    AddonModLessonProvider.LESSON_PAGE_BRANCHTABLE = 20; // Content page.
    AddonModLessonProvider.LESSON_PAGE_ENDOFBRANCH = 21;
    AddonModLessonProvider.LESSON_PAGE_CLUSTER = 30;
    AddonModLessonProvider.LESSON_PAGE_ENDOFCLUSTER = 31;
    /**
     * Constant used as a delimiter when parsing multianswer questions
     */
    AddonModLessonProvider.MULTIANSWER_DELIMITER = '@^#|';
    AddonModLessonProvider.LESSON_OTHER_ANSWERS = '@#wronganswer#@';
    // Variables for database.
    AddonModLessonProvider.PASSWORD_TABLE = 'addon_mod_lesson_password';
    AddonModLessonProvider = AddonModLessonProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__lesson_offline__["a" /* AddonModLessonOfflineProvider */], __WEBPACK_IMPORTED_MODULE_9__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */]])
    ], AddonModLessonProvider);
    return AddonModLessonProvider;
    var AddonModLessonProvider_1;
}());

//# sourceMappingURL=lesson.js.map

/***/ }),
/* 103 */,
/* 104 */,
/* 105 */,
/* 106 */,
/* 107 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__default_submission_handler__ = __webpack_require__(769);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Delegate to register plugins for assign submission.
 */
var AddonModAssignSubmissionDelegate = /** @class */ (function (_super) {
    __extends(AddonModAssignSubmissionDelegate, _super);
    function AddonModAssignSubmissionDelegate(logger, sitesProvider, eventsProvider, defaultHandler) {
        var _this = _super.call(this, 'AddonModAssignSubmissionDelegate', logger, sitesProvider, eventsProvider) || this;
        _this.defaultHandler = defaultHandler;
        _this.handlerNameProperty = 'type';
        return _this;
    }
    /**
     * Whether the plugin can be edited in offline for existing submissions.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @return {boolean|Promise<boolean>} Promise resolved with boolean: whether it can be edited in offline.
     */
    AddonModAssignSubmissionDelegate.prototype.canPluginEditOffline = function (assign, submission, plugin) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'canEditOffline', [assign, submission, plugin]));
    };
    /**
     * Clear some temporary data for a certain plugin because a submission was cancelled.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     */
    AddonModAssignSubmissionDelegate.prototype.clearTmpData = function (assign, submission, plugin, inputData) {
        return this.executeFunctionOnEnabled(plugin.type, 'clearTmpData', [assign, submission, plugin, inputData]);
    };
    /**
     * Copy the data from last submitted attempt to the current submission for a certain plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @param {any} pluginData Object where to store the data to send.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data has been copied.
     */
    AddonModAssignSubmissionDelegate.prototype.copyPluginSubmissionData = function (assign, plugin, pluginData, userId, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'copySubmissionData', [assign, plugin, pluginData, userId, siteId]));
    };
    /**
     * Delete offline data stored for a certain submission and plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} offlineData Offline data stored.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionDelegate.prototype.deletePluginOfflineData = function (assign, submission, plugin, offlineData, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'deleteOfflineData', [assign, submission, plugin, offlineData, siteId]));
    };
    /**
     * Get the component to use for a certain submission plugin.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {Promise<any>} Promise resolved with the component to use, undefined if not found.
     */
    AddonModAssignSubmissionDelegate.prototype.getComponentForPlugin = function (injector, plugin, edit) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'getComponent', [injector, plugin, edit]));
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    AddonModAssignSubmissionDelegate.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'getPluginFiles', [assign, submission, plugin, siteId]));
    };
    /**
     * Get a readable name to use for a certain submission plugin.
     *
     * @param {any} plugin Plugin to get the name for.
     * @return {string} Human readable name.
     */
    AddonModAssignSubmissionDelegate.prototype.getPluginName = function (plugin) {
        return this.executeFunctionOnEnabled(plugin.type, 'getPluginName', [plugin]);
    };
    /**
     * Get the size of data (in bytes) this plugin will send to copy a previous submission.
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @return {Promise<number>} Promise resolved with size.
     */
    AddonModAssignSubmissionDelegate.prototype.getPluginSizeForCopy = function (assign, plugin) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'getSizeForCopy', [assign, plugin]));
    };
    /**
     * Get the size of data (in bytes) this plugin will send to add or edit a submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {Promise<number>} Promise resolved with size.
     */
    AddonModAssignSubmissionDelegate.prototype.getPluginSizeForEdit = function (assign, submission, plugin, inputData) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'getSizeForEdit', [assign, submission, plugin, inputData]));
    };
    /**
     * Check if the submission data has changed for a certain plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {Promise<boolean>} Promise resolved with true if data has changed, resolved with false otherwise.
     */
    AddonModAssignSubmissionDelegate.prototype.hasPluginDataChanged = function (assign, submission, plugin, inputData) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'hasDataChanged', [assign, submission, plugin, inputData]));
    };
    /**
     * Check if a submission plugin is supported.
     *
     * @param {string} pluginType Type of the plugin.
     * @return {boolean} Whether it's supported.
     */
    AddonModAssignSubmissionDelegate.prototype.isPluginSupported = function (pluginType) {
        return this.hasHandler(pluginType, true);
    };
    /**
     * Check if a submission plugin is supported for edit.
     *
     * @param {string} pluginType Type of the plugin.
     * @return {Promise<boolean>} Whether it's supported for edit.
     */
    AddonModAssignSubmissionDelegate.prototype.isPluginSupportedForEdit = function (pluginType) {
        return Promise.resolve(this.executeFunctionOnEnabled(pluginType, 'isEnabledForEdit'));
    };
    /**
     * Prefetch any required data for a submission plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionDelegate.prototype.prefetch = function (assign, submission, plugin, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'prefetch', [assign, submission, plugin, siteId]));
    };
    /**
     * Prepare and add to pluginData the data to submit for a certain submission plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @param {any} pluginData Object where to store the data to send.
     * @param {boolean} [offline] Whether the user is editing in offline.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data has been gathered.
     */
    AddonModAssignSubmissionDelegate.prototype.preparePluginSubmissionData = function (assign, submission, plugin, inputData, pluginData, offline, userId, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'prepareSubmissionData', [assign, submission, plugin, inputData, pluginData, offline, userId, siteId]));
    };
    /**
     * Prepare and add to pluginData the data to send to server to synchronize an offline submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} offlineData Offline data stored.
     * @param {any} pluginData Object where to store the data to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data has been gathered.
     */
    AddonModAssignSubmissionDelegate.prototype.preparePluginSyncData = function (assign, submission, plugin, offlineData, pluginData, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'prepareSyncData', [assign, submission, plugin, offlineData, pluginData, siteId]));
    };
    AddonModAssignSubmissionDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__default_submission_handler__["a" /* AddonModAssignDefaultSubmissionHandler */]])
    ], AddonModAssignSubmissionDelegate);
    return AddonModAssignSubmissionDelegate;
}(__WEBPACK_IMPORTED_MODULE_4__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=submission-delegate.js.map

/***/ }),
/* 108 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionBaseComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Base class for components to render a question.
 */
var CoreQuestionBaseComponent = /** @class */ (function () {
    function CoreQuestionBaseComponent(logger, logName, injector) {
        this.injector = injector;
        this.logger = logger.getInstance(logName);
        // Use an injector to get the providers to prevent having to modify all subclasses if a new provider is needed.
        this.questionHelper = injector.get(__WEBPACK_IMPORTED_MODULE_3__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]);
        this.domUtils = injector.get(__WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */]);
        this.textUtils = injector.get(__WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */]);
        this.realElement = injector.get(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]).nativeElement;
    }
    /**
     * Initialize a question component of type calculated or calculated simple.
     *
     * @return {void|HTMLElement} Element containing the question HTML, void if the data is not valid.
     */
    CoreQuestionBaseComponent.prototype.initCalculatedComponent = function () {
        // Treat the input text first.
        var questionEl = this.initInputTextComponent();
        if (questionEl) {
            // Check if the question has a select for units.
            var selectModel = {}, select = questionEl.querySelector('select[name*=unit]'), options = select && Array.from(select.querySelectorAll('option'));
            if (select && options && options.length) {
                selectModel.id = select.id;
                selectModel.name = select.name;
                selectModel.disabled = select.disabled;
                selectModel.options = [];
                // Treat each option.
                for (var i in options) {
                    var optionEl = options[i];
                    if (typeof optionEl.value == 'undefined') {
                        this.logger.warn('Aborting because couldn\'t find input.', this.question.name);
                        return this.questionHelper.showComponentError(this.onAbort);
                    }
                    var option = {
                        value: optionEl.value,
                        label: optionEl.innerHTML
                    };
                    if (optionEl.selected) {
                        selectModel.selected = option.value;
                    }
                    selectModel.options.push(option);
                }
                if (!selectModel.selected) {
                    // No selected option, select the first one.
                    selectModel.selected = selectModel.options[0].value;
                }
                // Get the accessibility label.
                var accessibilityLabel = questionEl.querySelector('label[for="' + select.id + '"]');
                selectModel.accessibilityLabel = accessibilityLabel && accessibilityLabel.innerHTML;
                this.question.select = selectModel;
                // Check which one should be displayed first: the select or the input.
                var input_1 = questionEl.querySelector('input[type="text"][name*=answer]');
                this.question.selectFirst =
                    questionEl.innerHTML.indexOf(input_1.outerHTML) > questionEl.innerHTML.indexOf(select.outerHTML);
                return questionEl;
            }
            // Check if the question has radio buttons for units.
            var radios = Array.from(questionEl.querySelectorAll('input[type="radio"]'));
            if (!radios.length) {
                // No select and no radio buttons. The units need to be entered in the input text.
                return questionEl;
            }
            this.question.options = [];
            for (var i in radios) {
                var radioEl = radios[i], option = {
                    id: radioEl.id,
                    name: radioEl.name,
                    value: radioEl.value,
                    checked: radioEl.checked,
                    disabled: radioEl.disabled
                }, 
                // Get the label with the question text.
                label = questionEl.querySelector('label[for="' + option.id + '"]');
                this.question.optionsName = option.name;
                if (label) {
                    option.text = label.innerText;
                    // Check that we were able to successfully extract options required data.
                    if (typeof option.name != 'undefined' && typeof option.value != 'undefined' &&
                        typeof option.text != 'undefined') {
                        if (radioEl.checked) {
                            // If the option is checked we use the model to select the one.
                            this.question.unit = option.value;
                        }
                        this.question.options.push(option);
                        continue;
                    }
                }
                // Something went wrong when extracting the questions data. Abort.
                this.logger.warn('Aborting because of an error parsing options.', this.question.name, option.name);
                return this.questionHelper.showComponentError(this.onAbort);
            }
            // Check which one should be displayed first: the options or the input.
            var input = questionEl.querySelector('input[type="text"][name*=answer]');
            this.question.optionsFirst =
                questionEl.innerHTML.indexOf(input.outerHTML) > questionEl.innerHTML.indexOf(radios[0].outerHTML);
        }
    };
    /**
     * Initialize the component and the question text.
     *
     * @return {void|HTMLElement} Element containing the question HTML, void if the data is not valid.
     */
    CoreQuestionBaseComponent.prototype.initComponent = function () {
        if (!this.question) {
            this.logger.warn('Aborting because of no question received.');
            return this.questionHelper.showComponentError(this.onAbort);
        }
        this.realElement.classList.add('core-question-container');
        var element = this.domUtils.convertToElement(this.question.html);
        // Extract question text.
        this.question.text = this.domUtils.getContentsOfElement(element, '.qtext');
        if (typeof this.question.text == 'undefined') {
            this.logger.warn('Aborting because of an error parsing question.', this.question.name);
            return this.questionHelper.showComponentError(this.onAbort);
        }
        return element;
    };
    /**
     * Initialize a question component of type essay.
     *
     * @return {void|HTMLElement} Element containing the question HTML, void if the data is not valid.
     */
    CoreQuestionBaseComponent.prototype.initEssayComponent = function () {
        var questionEl = this.initComponent();
        if (questionEl) {
            // First search the textarea.
            var textarea = questionEl.querySelector('textarea[name*=_answer]');
            this.question.allowsAttachments = !!questionEl.querySelector('div[id*=filemanager]');
            this.question.isMonospaced = !!questionEl.querySelector('.qtype_essay_monospaced');
            this.question.isPlainText = this.question.isMonospaced || !!questionEl.querySelector('.qtype_essay_plain');
            this.question.hasDraftFiles = this.questionHelper.hasDraftFileUrls(questionEl.innerHTML);
            if (!textarea) {
                // Textarea not found, we might be in review. Search the answer and the attachments.
                this.question.answer = this.domUtils.getContentsOfElement(questionEl, '.qtype_essay_response');
                this.question.attachments = this.questionHelper.getQuestionAttachmentsFromHtml(this.domUtils.getContentsOfElement(questionEl, '.attachments'));
            }
            else {
                // Textarea found.
                var input = questionEl.querySelector('input[type="hidden"][name*=answerformat]'), content = textarea.innerHTML;
                this.question.textarea = {
                    id: textarea.id,
                    name: textarea.name,
                    text: content ? this.textUtils.decodeHTML(content) : ''
                };
                if (input) {
                    this.question.formatInput = {
                        name: input.name,
                        value: input.value
                    };
                }
            }
        }
    };
    /**
     * Initialize a question component that uses the original question text with some basic treatment.
     *
     * @param {string} contentSelector The selector to find the question content (text).
     * @return {void|HTMLElement} Element containing the question HTML, void if the data is not valid.
     */
    CoreQuestionBaseComponent.prototype.initOriginalTextComponent = function (contentSelector) {
        if (!this.question) {
            this.logger.warn('Aborting because of no question received.');
            return this.questionHelper.showComponentError(this.onAbort);
        }
        var element = this.domUtils.convertToElement(this.question.html);
        // Get question content.
        var content = element.querySelector(contentSelector);
        if (!content) {
            this.logger.warn('Aborting because of an error parsing question.', this.question.name);
            return this.questionHelper.showComponentError(this.onAbort);
        }
        // Remove sequencecheck and validation error.
        this.domUtils.removeElement(content, 'input[name*=sequencecheck]');
        this.domUtils.removeElement(content, '.validationerror');
        // Replace Moodle's correct/incorrect and feedback classes with our own.
        this.questionHelper.replaceCorrectnessClasses(element);
        this.questionHelper.replaceFeedbackClasses(element);
        // Treat the correct/incorrect icons.
        this.questionHelper.treatCorrectnessIcons(element);
        // Set the question text.
        this.question.text = content.innerHTML;
    };
    /**
     * Initialize a question component that has an input of type "text".
     *
     * @return {void|HTMLElement} Element containing the question HTML, void if the data is not valid.
     */
    CoreQuestionBaseComponent.prototype.initInputTextComponent = function () {
        var questionEl = this.initComponent();
        if (questionEl) {
            // Get the input element.
            var input = questionEl.querySelector('input[type="text"][name*=answer]');
            if (!input) {
                this.logger.warn('Aborting because couldn\'t find input.', this.question.name);
                return this.questionHelper.showComponentError(this.onAbort);
            }
            this.question.input = {
                id: input.id,
                name: input.name,
                value: input.value,
                readOnly: input.readOnly,
                isInline: !!this.domUtils.closest(input, '.qtext') // The answer can be inside the question text.
            };
            // Check if question is marked as correct.
            if (input.classList.contains('incorrect')) {
                this.question.input.correctClass = 'core-question-incorrect';
                this.question.input.correctIcon = 'fa-remove';
                this.question.input.correctIconColor = 'danger';
            }
            else if (input.classList.contains('correct')) {
                this.question.input.correctClass = 'core-question-correct';
                this.question.input.correctIcon = 'fa-check';
                this.question.input.correctIconColor = 'success';
            }
            else if (input.classList.contains('partiallycorrect')) {
                this.question.input.correctClass = 'core-question-partiallycorrect';
                this.question.input.correctIcon = 'fa-check-square';
                this.question.input.correctIconColor = 'warning';
            }
            else {
                this.question.input.correctClass = '';
                this.question.input.correctIcon = '';
                this.question.input.correctIconColor = '';
            }
            if (this.question.input.isInline) {
                // Handle correct/incorrect classes and icons.
                var content = questionEl.querySelector('.qtext');
                this.questionHelper.replaceCorrectnessClasses(content);
                this.questionHelper.treatCorrectnessIcons(content);
                this.question.text = content.innerHTML;
            }
        }
        return questionEl;
    };
    /**
     * Initialize a question component with a "match" behaviour.
     *
     * @return {void|HTMLElement} Element containing the question HTML, void if the data is not valid.
     */
    CoreQuestionBaseComponent.prototype.initMatchComponent = function () {
        var questionEl = this.initComponent();
        if (questionEl) {
            // Find rows.
            var rows = Array.from(questionEl.querySelectorAll('table.answer tr'));
            if (!rows || !rows.length) {
                this.logger.warn('Aborting because couldn\'t find any row.', this.question.name);
                return this.questionHelper.showComponentError(this.onAbort);
            }
            this.question.rows = [];
            for (var i in rows) {
                var row = rows[i], rowModel = {}, columns = Array.from(row.querySelectorAll('td'));
                if (!columns || columns.length < 2) {
                    this.logger.warn('Aborting because couldn\'t the right columns.', this.question.name);
                    return this.questionHelper.showComponentError(this.onAbort);
                }
                // Get the row's text. It should be in the first column.
                rowModel.text = columns[0].innerHTML;
                // Get the select and the options.
                var select = columns[1].querySelector('select'), options = Array.from(columns[1].querySelectorAll('option'));
                if (!select || !options || !options.length) {
                    this.logger.warn('Aborting because couldn\'t find select or options.', this.question.name);
                    return this.questionHelper.showComponentError(this.onAbort);
                }
                rowModel.id = select.id;
                rowModel.name = select.name;
                rowModel.disabled = select.disabled;
                rowModel.selected = false;
                rowModel.options = [];
                // Check if answer is correct.
                if (columns[1].className.indexOf('incorrect') >= 0) {
                    rowModel.isCorrect = 0;
                }
                else if (columns[1].className.indexOf('correct') >= 0) {
                    rowModel.isCorrect = 1;
                }
                // Treat each option.
                for (var j in options) {
                    var optionEl = options[j];
                    if (typeof optionEl.value == 'undefined') {
                        this.logger.warn('Aborting because couldn\'t find the value of an option.', this.question.name);
                        return this.questionHelper.showComponentError(this.onAbort);
                    }
                    var option = {
                        value: optionEl.value,
                        label: optionEl.innerHTML,
                        selected: optionEl.selected
                    };
                    if (option.selected) {
                        rowModel.selected = option.value;
                    }
                    rowModel.options.push(option);
                }
                // Get the accessibility label.
                var accessibilityLabel = columns[1].querySelector('label.accesshide');
                rowModel.accessibilityLabel = accessibilityLabel && accessibilityLabel.innerHTML;
                this.question.rows.push(rowModel);
            }
            this.question.loaded = true;
        }
        return questionEl;
    };
    /**
     * Initialize a question component with a multiple choice (checkbox) or single choice (radio).
     *
     * @return {void|HTMLElement} Element containing the question HTML, void if the data is not valid.
     */
    CoreQuestionBaseComponent.prototype.initMultichoiceComponent = function () {
        var questionEl = this.initComponent();
        if (questionEl) {
            // Get the prompt.
            this.question.prompt = this.domUtils.getContentsOfElement(questionEl, '.prompt');
            // Search radio buttons first (single choice).
            var options = Array.from(questionEl.querySelectorAll('input[type="radio"]'));
            if (!options || !options.length) {
                // Radio buttons not found, it should be a multi answer. Search for checkbox.
                this.question.multi = true;
                options = Array.from(questionEl.querySelectorAll('input[type="checkbox"]'));
                if (!options || !options.length) {
                    // No checkbox found either. Abort.
                    this.logger.warn('Aborting because of no radio and checkbox found.', this.question.name);
                    return this.questionHelper.showComponentError(this.onAbort);
                }
            }
            this.question.options = [];
            this.question.disabled = true;
            for (var i in options) {
                var element = options[i], option = {
                    id: element.id,
                    name: element.name,
                    value: element.value,
                    checked: element.checked,
                    disabled: element.disabled
                }, parent_1 = element.parentElement;
                if (option.value == '-1') {
                    // It's the clear choice option, ignore it.
                    continue;
                }
                this.question.optionsName = option.name;
                this.question.disabled = this.question.disabled && element.disabled;
                // Get the label with the question text.
                var label = questionEl.querySelector('label[for="' + option.id + '"]');
                if (label) {
                    option.text = label.innerHTML;
                    // Check that we were able to successfully extract options required data.
                    if (typeof option.name != 'undefined' && typeof option.value != 'undefined' &&
                        typeof option.text != 'undefined') {
                        if (element.checked) {
                            // If the option is checked and it's a single choice we use the model to select the one.
                            if (!this.question.multi) {
                                this.question.singleChoiceModel = option.value;
                            }
                            if (parent_1) {
                                // Check if answer is correct.
                                if (parent_1 && parent_1.className.indexOf('incorrect') >= 0) {
                                    option.isCorrect = 0;
                                }
                                else if (parent_1 && parent_1.className.indexOf('correct') >= 0) {
                                    option.isCorrect = 1;
                                }
                                // Search the feedback.
                                var feedback = parent_1.querySelector('.specificfeedback');
                                if (feedback) {
                                    option.feedback = feedback.innerHTML;
                                }
                            }
                        }
                        this.question.options.push(option);
                        continue;
                    }
                }
                // Something went wrong when extracting the questions data. Abort.
                this.logger.warn('Aborting because of an error parsing options.', this.question.name, option.name);
                return this.questionHelper.showComponentError(this.onAbort);
            }
        }
        return questionEl;
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreQuestionBaseComponent.prototype, "question", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreQuestionBaseComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreQuestionBaseComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreQuestionBaseComponent.prototype, "attemptId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreQuestionBaseComponent.prototype, "offlineEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreQuestionBaseComponent.prototype, "buttonClicked", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreQuestionBaseComponent.prototype, "onAbort", void 0);
    return CoreQuestionBaseComponent;
}());

//# sourceMappingURL=base-question-component.js.map

/***/ }),
/* 109 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreConfigProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Factory to provide access to dynamic and permanent config and settings.
 * It should not be abused into a temporary storage.
 */
var CoreConfigProvider = /** @class */ (function () {
    function CoreConfigProvider(appProvider) {
        this.TABLE_NAME = 'core_config';
        this.tableSchema = {
            name: this.TABLE_NAME,
            columns: [
                {
                    name: 'name',
                    type: 'TEXT',
                    unique: true,
                    notNull: true
                },
                {
                    name: 'value'
                }
            ]
        };
        this.appDB = appProvider.getDB();
        this.appDB.createTableFromSchema(this.tableSchema);
    }
    /**
     * Deletes an app setting.
     *
     * @param {string} name The config name.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreConfigProvider.prototype.delete = function (name) {
        return this.appDB.deleteRecords(this.TABLE_NAME, { name: name });
    };
    /**
     * Get an app setting.
     *
     * @param {string} name The config name.
     * @param {any} [defaultValue] Default value to use if the entry is not found.
     * @return {Promise<any>} Resolves upon success along with the config data. Reject on failure.
     */
    CoreConfigProvider.prototype.get = function (name, defaultValue) {
        return this.appDB.getRecord(this.TABLE_NAME, { name: name }).then(function (entry) {
            return entry.value;
        }).catch(function (error) {
            if (typeof defaultValue != 'undefined') {
                return defaultValue;
            }
            return Promise.reject(error);
        });
    };
    /**
     * Set an app setting.
     *
     * @param {string} name The config name.
     * @param {number|string} value The config value. Can only store number or strings.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreConfigProvider.prototype.set = function (name, value) {
        return this.appDB.insertRecord(this.TABLE_NAME, { name: name, value: value });
    };
    CoreConfigProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__app__["a" /* CoreAppProvider */]])
    ], CoreConfigProvider);
    return CoreConfigProvider;
}());

//# sourceMappingURL=config.js.map

/***/ }),
/* 110 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * Service that provides some features regarding grades information.
 */
var CoreGradesHelperProvider = /** @class */ (function () {
    function CoreGradesHelperProvider(logger, coursesProvider, gradesProvider, sitesProvider, textUtils, courseProvider, domUtils, urlUtils, utils, linkHelper, loginHelper, courseHelper) {
        this.coursesProvider = coursesProvider;
        this.gradesProvider = gradesProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.courseProvider = courseProvider;
        this.domUtils = domUtils;
        this.urlUtils = urlUtils;
        this.utils = utils;
        this.linkHelper = linkHelper;
        this.loginHelper = loginHelper;
        this.courseHelper = courseHelper;
        this.logger = logger.getInstance('CoreGradesHelperProvider');
    }
    /**
     * Formats a row from the grades table te be rendered in a page.
     *
     * @param  {any}  tableRow JSON object representing row of grades table data.
     * @return {any}           Formatted row object.
     */
    CoreGradesHelperProvider.prototype.formatGradeRow = function (tableRow) {
        var row = {};
        for (var name_1 in tableRow) {
            if (typeof tableRow[name_1].content != 'undefined' && tableRow[name_1].content !== null) {
                var content = String(tableRow[name_1].content);
                if (name_1 == 'itemname') {
                    this.setRowIcon(row, content);
                    row['link'] = this.getModuleLink(content);
                    row['rowclass'] += tableRow[name_1].class.indexOf('hidden') >= 0 ? ' hidden' : '';
                    row['rowclass'] += tableRow[name_1].class.indexOf('dimmed_text') >= 0 ? ' dimmed_text' : '';
                    content = content.replace(/<\/span>/gi, '\n');
                    content = this.textUtils.cleanTags(content);
                }
                else {
                    content = this.textUtils.replaceNewLines(content, '<br>');
                }
                if (content == '&nbsp;') {
                    content = '';
                }
                row[name_1] = content.trim();
            }
        }
        return row;
    };
    /**
     * Formats a row from the grades table to be rendered in one table.
     *
     * @param  {any}  tableRow JSON object representing row of grades table data.
     * @return {any}           Formatted row object.
     */
    CoreGradesHelperProvider.prototype.formatGradeRowForTable = function (tableRow) {
        var row = {};
        for (var name_2 in tableRow) {
            if (typeof tableRow[name_2].content != 'undefined' && tableRow[name_2].content !== null) {
                var content = String(tableRow[name_2].content);
                if (name_2 == 'itemname') {
                    row['id'] = parseInt(tableRow[name_2].id.split('_')[1], 10);
                    row['colspan'] = tableRow[name_2].colspan;
                    row['rowspan'] = (tableRow['leader'] && tableRow['leader'].rowspan) || 1;
                    this.setRowIcon(row, content);
                    row['rowclass'] = tableRow[name_2].class.indexOf('leveleven') < 0 ? 'odd' : 'even';
                    row['rowclass'] += tableRow[name_2].class.indexOf('hidden') >= 0 ? ' hidden' : '';
                    row['rowclass'] += tableRow[name_2].class.indexOf('dimmed_text') >= 0 ? ' dimmed_text' : '';
                    content = content.replace(/<\/span>/gi, '\n');
                    content = this.textUtils.cleanTags(content);
                    name_2 = 'gradeitem';
                }
                else {
                    content = this.textUtils.replaceNewLines(content, '<br>');
                }
                if (content == '&nbsp;') {
                    content = '';
                }
                row[name_2] = content.trim();
            }
        }
        return row;
    };
    /**
     * Removes suffix formatted to compatibilize data from table and items.
     *
     * @param  {any} item Grade item to format.
     * @return {any}      Grade item formatted.
     */
    CoreGradesHelperProvider.prototype.formatGradeItem = function (item) {
        for (var name_3 in item) {
            var index = name_3.indexOf('formatted');
            if (index > 0) {
                item[name_3.substr(0, index)] = item[name_3];
            }
        }
        return item;
    };
    /**
     * Formats the response of gradereport_user_get_grades_table to be rendered.
     *
     * @param  {any}  table          JSON object representing a table with data.
     * @return {any}             Formatted HTML table.
     */
    CoreGradesHelperProvider.prototype.formatGradesTable = function (table) {
        var _this = this;
        var maxDepth = table.maxdepth, formatted = {
            columns: [],
            rows: []
        }, 
        // Columns, in order.
        columns = {
            gradeitem: true,
            weight: false,
            grade: false,
            range: false,
            percentage: false,
            lettergrade: false,
            rank: false,
            average: false,
            feedback: false,
            contributiontocoursetotal: false
        };
        formatted.rows = table.tabledata.map(function (row) {
            return _this.formatGradeRowForTable(row);
        });
        // Get a row with some info.
        var normalRow = formatted.rows.find(function (e) {
            return e.itemtype != 'leader' && (typeof e.grade != 'undefined' || typeof e.percentage != 'undefined');
        });
        // Decide if grades or percentage is being shown on phones.
        if (normalRow && typeof normalRow.grade != 'undefined') {
            columns.grade = true;
        }
        else if (normalRow && typeof normalRow.percentage != 'undefined') {
            columns.percentage = true;
        }
        else {
            normalRow = formatted.rows.find(function (e) {
                return e.itemtype != 'leader';
            });
            columns.grade = true;
        }
        for (var colName in columns) {
            if (typeof normalRow[colName] != 'undefined') {
                formatted.columns.push({
                    name: colName,
                    colspan: colName == 'gradeitem' ? maxDepth : 1,
                    hiddenPhone: !columns[colName]
                });
            }
        }
        return formatted;
    };
    /**
     * Get course data for grades since they only have courseid.
     *
     * @param  {any} grades    Grades to get the data for.
     * @return {Promise<any>}  Promise always resolved. Resolve param is the formatted grades.
     */
    CoreGradesHelperProvider.prototype.getGradesCourseData = function (grades) {
        // Using cache for performance reasons.
        return this.coursesProvider.getUserCourses(true).then(function (courses) {
            var indexedCourses = {};
            courses.forEach(function (course) {
                indexedCourses[course.id] = course;
            });
            grades.forEach(function (grade) {
                if (typeof indexedCourses[grade.courseid] != 'undefined') {
                    grade.courseFullName = indexedCourses[grade.courseid].fullname;
                }
            });
            return grades;
        });
    };
    /**
     * Get an specific grade item.
     *
     * @param  {number}  courseId             ID of the course to get the grades from.
     * @param  {number}  gradeId              Grade ID.
     * @param  {number}  [userId]             ID of the user to get the grades from. If not defined use site's current user.
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache=false]  True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}                Promise to be resolved when the grades are retrieved.
     */
    CoreGradesHelperProvider.prototype.getGradeItem = function (courseId, gradeId, userId, siteId, ignoreCache) {
        var _this = this;
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.gradesProvider.getCourseGradesTable(courseId, userId, siteId, ignoreCache).then(function (grades) {
            if (grades) {
                return _this.getGradesTableRow(grades, gradeId);
            }
            return Promise.reject(null);
        });
    };
    /**
     * Returns the label of the selected grade.
     *
     * @param {any[]} grades Array with objects with value and label.
     * @param {number} selectedGrade Selected grade value.
     * @return {string} Selected grade label.
     */
    CoreGradesHelperProvider.prototype.getGradeLabelFromValue = function (grades, selectedGrade) {
        selectedGrade = Number(selectedGrade);
        if (!grades || !selectedGrade || selectedGrade <= 0) {
            return '';
        }
        for (var x in grades) {
            if (grades[x].value == selectedGrade) {
                return grades[x].label;
            }
        }
        return '';
    };
    /**
     * Get the grade items for a certain module. Keep in mind that may have more than one item to include outcomes and scales.
     *
     * @param  {number}  courseId             ID of the course to get the grades from.
     * @param  {number}  moduleId             Module ID.
     * @param  {number}  [userId]             ID of the user to get the grades from. If not defined use site's current user.
     * @param  {number}  [groupId]            ID of the group to get the grades from. Not used for old gradebook table.
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @param  {boolean} [ignoreCache=false]  True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>}                Promise to be resolved when the grades are retrieved.
     */
    CoreGradesHelperProvider.prototype.getGradeModuleItems = function (courseId, moduleId, userId, groupId, siteId, ignoreCache) {
        var _this = this;
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.gradesProvider.getGradeItems(courseId, userId, groupId, siteId, ignoreCache).then(function (grades) {
            if (grades) {
                if (typeof grades.tabledata != 'undefined') {
                    // Table format.
                    return _this.getModuleGradesTableRows(grades, moduleId);
                }
                else {
                    return grades.filter(function (item) {
                        return item.cmid == moduleId;
                    }).map(function (item) {
                        return _this.formatGradeItem(item);
                    });
                }
            }
            return Promise.reject(null);
        });
    };
    /**
     * Returns the value of the selected grade.
     *
     * @param {any[]} grades Array with objects with value and label.
     * @param {string} selectedGrade Selected grade label.
     * @return {number} Selected grade value.
     */
    CoreGradesHelperProvider.prototype.getGradeValueFromLabel = function (grades, selectedGrade) {
        if (!grades || !selectedGrade) {
            return 0;
        }
        for (var x in grades) {
            if (grades[x].label == selectedGrade) {
                return grades[x].value < 0 ? 0 : grades[x].value;
            }
        }
        return 0;
    };
    /**
     * Gets the link to the module for the selected grade.
     *
     * @param  {string} text HTML where the link is present.
     * @return {string | false}      URL linking to the module.
     */
    CoreGradesHelperProvider.prototype.getModuleLink = function (text) {
        var el = this.domUtils.toDom(text)[0], link = el.attributes['href'] ? el.attributes['href'].value : false;
        if (!link || link.indexOf('/mod/') < 0) {
            return false;
        }
        return link;
    };
    /**
     * Get a row from the grades table.
     *
     * @param  {any}   table    JSON object representing a table with data.
     * @param  {number} gradeId Grade Object identifier.
     * @return {any}            Formatted HTML table.
     */
    CoreGradesHelperProvider.prototype.getGradesTableRow = function (table, gradeId) {
        if (table.tabledata) {
            var selectedRow = table.tabledata.find(function (row) {
                return row.itemname && row.itemname.id && row.itemname.id.substr(0, 3) == 'row' &&
                    parseInt(row.itemname.id.split('_')[1], 10) == gradeId;
            });
            if (selectedRow) {
                return this.formatGradeRow(selectedRow);
            }
        }
        return '';
    };
    /**
     * Get the rows related to a module from the grades table.
     *
     * @param  {any}   table     JSON object representing a table with data.
     * @param  {number} moduleId Grade Object identifier.
     * @return {any}             Formatted HTML table.
     */
    CoreGradesHelperProvider.prototype.getModuleGradesTableRows = function (table, moduleId) {
        var _this = this;
        if (table.tabledata) {
            // Find href containing "/mod/xxx/xxx.php".
            var regex_1 = /href="([^"]*\/mod\/[^"|^\/]*\/[^"|^\.]*\.php[^"]*)/;
            return table.tabledata.filter(function (row) {
                if (row.itemname && row.itemname.content) {
                    var matches = row.itemname.content.match(regex_1);
                    if (matches && matches.length) {
                        var hrefParams = _this.urlUtils.extractUrlParams(matches[1]);
                        return hrefParams && hrefParams.id == moduleId;
                    }
                }
                return false;
            }).map(function (row) {
                return _this.formatGradeRow(row);
            });
        }
        return [];
    };
    /**
     * Go to view grades.
     *
     * @param {number} courseId Course ID t oview.
     * @param {number} [userId] User to view. If not defined, current user.
     * @param {number} [moduleId] Module to view. If not defined, view all course grades.
     * @param {NavController} [navCtrl] NavController to use.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreGradesHelperProvider.prototype.goToGrades = function (courseId, userId, moduleId, navCtrl, siteId) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        var currentUserId;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            siteId = site.id;
            currentUserId = site.getUserId();
            if (moduleId) {
                // Try to open the module grade directly. Check if it's possible.
                return _this.gradesProvider.isGradeItemsAvalaible(siteId).then(function (getGrades) {
                    if (!getGrades) {
                        return Promise.reject(null);
                    }
                });
            }
            else {
                return Promise.reject(null);
            }
        }).then(function () {
            // Can get grades. Do it.
            return _this.gradesProvider.getGradeItems(courseId, userId, undefined, siteId).then(function (items) {
                // Find the item of the module.
                var item = items.find(function (item) {
                    return moduleId == item.cmid;
                });
                if (item) {
                    // Open the item directly.
                    var pageParams = {
                        courseId: courseId,
                        userId: userId,
                        gradeId: item.id
                    };
                    return _this.linkHelper.goInSite(navCtrl, 'CoreGradesGradePage', pageParams, siteId).catch(function () {
                        // Ignore errors.
                    });
                }
                return Promise.reject(null);
            });
        }).catch(function () {
            // Cannot get grade items or there's no need to.
            if (userId && userId != currentUserId) {
                // View another user grades. Open the grades page directly.
                var pageParams = {
                    course: { id: courseId },
                    userId: userId
                };
                return _this.linkHelper.goInSite(navCtrl, 'CoreGradesCoursePage', pageParams, siteId).catch(function () {
                    // Ignore errors.
                });
            }
            // View own grades. Open the course with the grades tab selected.
            return _this.courseHelper.getCourse(courseId, siteId).then(function (result) {
                var pageParams = {
                    course: result.course,
                    selectedTab: 'CoreGrades'
                };
                return _this.loginHelper.redirect('CoreCourseSectionPage', pageParams, siteId).catch(function () {
                    // Ignore errors.
                });
            });
        }).catch(function () {
            // Cannot get course for some reason, just open the grades page.
            return _this.linkHelper.goInSite(navCtrl, 'CoreGradesCoursePage', { course: { id: courseId } }, siteId);
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Invalidate the grade items for a certain module.
     *
     * @param  {number}  courseId     ID of the course to invalidate the grades.
     * @param  {number}  [userId]     ID of the user to invalidate. If not defined use site's current user.
     * @param  {number}  [groupId]    ID of the group to invalidate. Not used for old gradebook table.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise}              Promise to be resolved when the grades are invalidated.
     */
    CoreGradesHelperProvider.prototype.invalidateGradeModuleItems = function (courseId, userId, groupId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return _this.gradesProvider.isGradeItemsAvalaible(siteId).then(function (enabled) {
                if (enabled) {
                    return _this.gradesProvider.invalidateCourseGradesItemsData(courseId, userId, groupId, siteId);
                }
                else {
                    return _this.gradesProvider.invalidateCourseGradesData(courseId, userId, siteId);
                }
            });
        });
    };
    /**
     * Parses the image and sets it to the row.
     *
     * @param  {any} row  Formatted grade row object.
     * @param  {string} text HTML where the image will be rendered.
     * @return {any}      Row object with the image.
     */
    CoreGradesHelperProvider.prototype.setRowIcon = function (row, text) {
        text = text.replace('%2F', '/').replace('%2f', '/');
        if (text.indexOf('/agg_mean') > -1) {
            row['itemtype'] = 'agg_mean';
            row['image'] = 'assets/img/grades/agg_mean.png';
        }
        else if (text.indexOf('/agg_sum') > -1) {
            row['itemtype'] = 'agg_sum';
            row['image'] = 'assets/img/grades/agg_sum.png';
        }
        else if (text.indexOf('/outcomes') > -1 || text.indexOf('fa-tasks') > -1) {
            row['itemtype'] = 'outcome';
            row['icon'] = 'fa-tasks';
        }
        else if (text.indexOf('i/folder') > -1 || text.indexOf('fa-folder') > -1) {
            row['itemtype'] = 'category';
            row['icon'] = 'fa-folder';
        }
        else if (text.indexOf('/manual_item') > -1 || text.indexOf('fa-square-o') > -1) {
            row['itemtype'] = 'manual';
            row['icon'] = 'fa-square-o';
        }
        else if (text.indexOf('/mod/') > -1) {
            var module_1 = text.match(/mod\/([^\/]*)\//);
            if (typeof module_1[1] != 'undefined') {
                row['itemtype'] = 'mod';
                row['itemmodule'] = module_1[1];
                row['image'] = this.courseProvider.getModuleIconSrc(module_1[1], this.domUtils.convertToElement(text).querySelector('img').getAttribute('src'));
            }
        }
        else {
            if (row['rowspan'] && row['rowspan'] > 1) {
                row['itemtype'] = 'category';
                row['icon'] = 'fa-folder';
            }
            else if (text.indexOf('src=') > -1) {
                row['itemtype'] = 'unknown';
                var src = text.match(/src="([^"]*)"/);
                row['image'] = src[1];
            }
            else if (text.indexOf('<i ') > -1) {
                row['itemtype'] = 'unknown';
                var src = text.match(/<i class="(?:[^"]*?\s)?(fa-[a-z0-9-]+)/);
                row['icon'] = src ? src[1] : '';
            }
        }
        return row;
    };
    /**
     * Creates an array that represents all the current grades that can be chosen using the given grading type.
     * Negative numbers are scales, zero is no grade, and positive numbers are maximum grades.
     *
     * Taken from make_grades_menu on moodlelib.php
     *
     * @param  {number} gradingType     If positive, max grade you can provide. If negative, scale Id.
     * @param  {number} [moduleId]      Module ID. Used to retrieve the scale items when they are not passed as parameter.
     *                                  If the user does not have permision to manage the activity an empty list is returned.
     * @param  {string} [defaultLabel]  Element that will become default option, if not defined, it won't be added.
     * @param  {any}    [defaultValue]  Element that will become default option value. Default ''.
     * @param  {string} [scale]         Scale csv list String. If not provided, it will take it from the module grade info.
     * @return {Promise<any[]>}         Array with objects with value and label to create a propper HTML select.
     */
    CoreGradesHelperProvider.prototype.makeGradesMenu = function (gradingType, moduleId, defaultLabel, defaultValue, scale) {
        var _this = this;
        if (defaultLabel === void 0) { defaultLabel = ''; }
        if (defaultValue === void 0) { defaultValue = ''; }
        if (gradingType < 0) {
            if (scale) {
                return Promise.resolve(this.utils.makeMenuFromList(scale, defaultLabel, undefined, defaultValue));
            }
            else if (moduleId) {
                return this.courseProvider.getModuleBasicGradeInfo(moduleId).then(function (gradeInfo) {
                    if (gradeInfo.scale) {
                        return _this.utils.makeMenuFromList(gradeInfo.scale, defaultLabel, undefined, defaultValue);
                    }
                    return [];
                });
            }
            else {
                return Promise.resolve([]);
            }
        }
        if (gradingType > 0) {
            var grades = [];
            if (defaultLabel) {
                // Key as string to avoid resorting of the object.
                grades.push({
                    label: defaultLabel,
                    value: defaultValue
                });
            }
            for (var i = gradingType; i >= 0; i--) {
                grades.push({
                    label: i + ' / ' + gradingType,
                    value: i
                });
            }
            return Promise.resolve(grades);
        }
        return Promise.resolve([]);
    };
    CoreGradesHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__grades__["a" /* CoreGradesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_11__core_login_providers_helper__["a" /* CoreLoginHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], CoreGradesHelperProvider);
    return CoreGradesHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 111 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__offline__ = __webpack_require__(133);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Service that provides some features for workshops.
 */
var AddonModWorkshopProvider = /** @class */ (function () {
    function AddonModWorkshopProvider(appProvider, filepoolProvider, sitesProvider, utils, workshopOffline, logHelper) {
        this.appProvider = appProvider;
        this.filepoolProvider = filepoolProvider;
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.workshopOffline = workshopOffline;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModWorkshop:';
    }
    AddonModWorkshopProvider_1 = AddonModWorkshopProvider;
    /**
     * Get cache key for workshop data WS calls.
     *
     * @param  {number} courseId Course ID.
     * @return {string}          Cache key.
     */
    AddonModWorkshopProvider.prototype.getWorkshopDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'workshop:' + courseId;
    };
    /**
     * Get prefix cache key for all workshop activity data WS calls.
     *
     * @param  {number} workshopId Workshop ID.
     * @return {string}            Cache key.
     */
    AddonModWorkshopProvider.prototype.getWorkshopDataPrefixCacheKey = function (workshopId) {
        return this.ROOT_CACHE_KEY + workshopId;
    };
    /**
     * Get cache key for workshop access information data WS calls.
     *
     * @param  {number} workshopId Workshop ID.
     * @return {string}            Cache key.
     */
    AddonModWorkshopProvider.prototype.getWorkshopAccessInformationDataCacheKey = function (workshopId) {
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':access';
    };
    /**
     * Get cache key for workshop user plan data WS calls.
     *
     * @param  {number} workshopId Workshop ID.
     * @return {string}            Cache key.
     */
    AddonModWorkshopProvider.prototype.getUserPlanDataCacheKey = function (workshopId) {
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':userplan';
    };
    /**
     * Get cache key for workshop submissions data WS calls.
     *
     * @param  {number} workshopId  Workshop ID.
     * @param  {number} [userId=0]  User ID.
     * @param  {number} [groupId=0] Group ID.
     * @return {string}             Cache key.
     */
    AddonModWorkshopProvider.prototype.getSubmissionsDataCacheKey = function (workshopId, userId, groupId) {
        if (userId === void 0) { userId = 0; }
        if (groupId === void 0) { groupId = 0; }
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':submissions:' + userId + ':' + groupId;
    };
    /**
     * Get cache key for a workshop submission data WS calls.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @return {string}              Cache key.
     */
    AddonModWorkshopProvider.prototype.getSubmissionDataCacheKey = function (workshopId, submissionId) {
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':submission:' + submissionId;
    };
    /**
     * Get cache key for workshop grades data WS calls.
     *
     * @param  {number} workshopId Workshop ID.
     * @return {string}            Cache key.
     */
    AddonModWorkshopProvider.prototype.getGradesDataCacheKey = function (workshopId) {
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':grades';
    };
    /**
     * Get cache key for workshop grade report data WS calls.
     *
     * @param  {number} workshopId  Workshop ID.
     * @param  {number} [groupId=0] Group ID.
     * @return {string}             Cache key.
     */
    AddonModWorkshopProvider.prototype.getGradesReportDataCacheKey = function (workshopId, groupId) {
        if (groupId === void 0) { groupId = 0; }
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':report:' + groupId;
    };
    /**
     * Get cache key for workshop submission assessments data WS calls.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @return {string}              Cache key.
     */
    AddonModWorkshopProvider.prototype.getSubmissionAssessmentsDataCacheKey = function (workshopId, submissionId) {
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':assessments:' + submissionId;
    };
    /**
     * Get cache key for workshop reviewer assessments data WS calls.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {number} [userId=0] User ID or current user.
     * @return {string}            Cache key.
     */
    AddonModWorkshopProvider.prototype.getReviewerAssessmentsDataCacheKey = function (workshopId, userId) {
        if (userId === void 0) { userId = 0; }
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':reviewerassessments:' + userId;
    };
    /**
     * Get cache key for a workshop assessment data WS calls.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @return {string}              Cache key.
     */
    AddonModWorkshopProvider.prototype.getAssessmentDataCacheKey = function (workshopId, assessmentId) {
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':assessment:' + assessmentId;
    };
    /**
     * Get cache key for workshop assessment form data WS calls.
     *
     * @param  {number} workshopId          Workshop ID.
     * @param  {number} assessmentId        Assessment ID.
     * @param  {string} [mode='assessment'] Mode assessment (default) or preview.
     * @return {string}                     Cache key.
     */
    AddonModWorkshopProvider.prototype.getAssessmentFormDataCacheKey = function (workshopId, assessmentId, mode) {
        if (mode === void 0) { mode = 'assessment'; }
        return this.getWorkshopDataPrefixCacheKey(workshopId) + ':assessmentsform:' + assessmentId + ':' + mode;
    };
    /**
     * Return whether or not the plugin is enabled in a certain site. Plugin is enabled if the workshop WS are available.
     *
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonModWorkshopProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('mod_workshop_get_workshops_by_courses') &&
                site.wsAvailable('mod_workshop_get_workshop_access_information');
        });
    };
    /**
     * Get a workshop with key=value. If more than one is found, only the first will be returned.
     *
     * @param  {number}  courseId           Course ID.
     * @param  {string}  key                Name of the property to check.
     * @param  {any}     value              Value to search.
     * @param  {string}  [siteId]           Site ID. If not defined, current site.
     * @param  {boolean} [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @return {Promise<any>}               Promise resolved when the workshop is retrieved.
     */
    AddonModWorkshopProvider.prototype.getWorkshopByKey = function (courseId, key, value, siteId, forceCache) {
        var _this = this;
        if (forceCache === void 0) { forceCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            };
            var preSets = {
                cacheKey: _this.getWorkshopDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            return site.read('mod_workshop_get_workshops_by_courses', params, preSets).then(function (response) {
                if (response && response.workshops) {
                    var workshopFound = response.workshops.find(function (workshop) { return workshop[key] == value; });
                    if (workshopFound) {
                        return workshopFound;
                    }
                }
                return Promise.reject(null);
            }).then(function (workshop) {
                // Set submission types for Moodle 3.5 and older.
                if (typeof workshop.submissiontypetext == 'undefined') {
                    if (workshop.nattachments > 0) {
                        workshop.submissiontypetext = AddonModWorkshopProvider_1.SUBMISSION_TYPE_AVAILABLE;
                        workshop.submissiontypefile = AddonModWorkshopProvider_1.SUBMISSION_TYPE_AVAILABLE;
                    }
                    else {
                        workshop.submissiontypetext = AddonModWorkshopProvider_1.SUBMISSION_TYPE_REQUIRED;
                        workshop.submissiontypefile = AddonModWorkshopProvider_1.SUBMISSION_TYPE_DISABLED;
                    }
                }
                return workshop;
            });
        });
    };
    /**
     * Get a workshop by course module ID.
     *
     * @param  {number}  courseId           Course ID.
     * @param  {number}  cmId               Course module ID.
     * @param  {string}  [siteId]           Site ID. If not defined, current site.
     * @param  {boolean} [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @return {Promise<any>}               Promise resolved when the workshop is retrieved.
     */
    AddonModWorkshopProvider.prototype.getWorkshop = function (courseId, cmId, siteId, forceCache) {
        if (forceCache === void 0) { forceCache = false; }
        return this.getWorkshopByKey(courseId, 'coursemodule', cmId, siteId, forceCache);
    };
    /**
     * Get a workshop by ID.
     *
     * @param  {number}  courseId           Course ID.
     * @param  {number}  id                 Workshop ID.
     * @param  {string}  [siteId]           Site ID. If not defined, current site.
     * @param  {boolean} [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @return {Promise<any>}               Promise resolved when the workshop is retrieved.
     */
    AddonModWorkshopProvider.prototype.getWorkshopById = function (courseId, id, siteId, forceCache) {
        if (forceCache === void 0) { forceCache = false; }
        return this.getWorkshopByKey(courseId, 'id', id, siteId, forceCache);
    };
    /**
     * Invalidates workshop data.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the workshop is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateWorkshopData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getWorkshopDataCacheKey(courseId));
        });
    };
    /**
     * Invalidates workshop data except files and module info.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the workshop is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateWorkshopWSData = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getWorkshopDataPrefixCacheKey(workshopId));
        });
    };
    /**
     * Get access information for a given workshop.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @return {Promise<any>}                 Promise resolved when the workshop is retrieved.
     */
    AddonModWorkshopProvider.prototype.getWorkshopAccessInformation = function (workshopId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                workshopid: workshopId
            };
            var preSets = {
                cacheKey: _this.getWorkshopAccessInformationDataCacheKey(workshopId)
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = 0;
                preSets.emergencyCache = 0;
            }
            return site.read('mod_workshop_get_workshop_access_information', params, preSets);
        });
    };
    /**
     * Invalidates workshop access information data.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateWorkshopAccessInformationData = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getWorkshopAccessInformationDataCacheKey(workshopId));
        });
    };
    /**
     * Return the planner information for the given user.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any>}                Promise resolved when the workshop data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getUserPlanPhases = function (workshopId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                workshopid: workshopId
            };
            var preSets = {
                cacheKey: _this.getUserPlanDataCacheKey(workshopId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = 0;
                preSets.emergencyCache = 0;
            }
            return site.read('mod_workshop_get_user_plan', params, preSets).then(function (response) {
                if (response && response.userplan && response.userplan.phases) {
                    return _this.utils.arrayToObject(response.userplan.phases, 'code');
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates workshop user plan data.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateUserPlanPhasesData = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUserPlanDataCacheKey(workshopId));
        });
    };
    /**
     * Retrieves all the workshop submissions visible by the current user or the one done by the given user.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {number}  [userId=0]          User ID, 0 means the current user.
     * @param  {number}  [groupId=0]         Group id, 0 means that the function will determine the user group.
     * @param  {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any[]>}              Promise resolved when the workshop submissions are retrieved.
     */
    AddonModWorkshopProvider.prototype.getSubmissions = function (workshopId, userId, groupId, offline, ignoreCache, siteId) {
        var _this = this;
        if (userId === void 0) { userId = 0; }
        if (groupId === void 0) { groupId = 0; }
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                workshopid: workshopId,
                userid: userId,
                groupid: groupId
            };
            var preSets = {
                cacheKey: _this.getSubmissionsDataCacheKey(workshopId, userId, groupId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = 0;
                preSets.emergencyCache = 0;
            }
            return site.read('mod_workshop_get_submissions', params, preSets).then(function (response) {
                if (response && response.submissions) {
                    return response.submissions;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates workshop submissions data.
     *
     * @param  {number} workshopId  Workshop ID.
     * @param  {number} [userId=0]  User ID.
     * @param  {number} [groupId=0] Group ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateSubmissionsData = function (workshopId, userId, groupId, siteId) {
        var _this = this;
        if (userId === void 0) { userId = 0; }
        if (groupId === void 0) { groupId = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getSubmissionsDataCacheKey(workshopId, userId, groupId));
        });
    };
    /**
     * Retrieves the given submission.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the workshop submission data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getSubmission = function (workshopId, submissionId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                submissionid: submissionId
            };
            var preSets = {
                cacheKey: _this.getSubmissionDataCacheKey(workshopId, submissionId)
            };
            return site.read('mod_workshop_get_submission', params, preSets).then(function (response) {
                if (response && response.submission) {
                    return response.submission;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates workshop submission data.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateSubmissionData = function (workshopId, submissionId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getSubmissionDataCacheKey(workshopId, submissionId));
        });
    };
    /**
     * Returns the grades information for the given workshop and user.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the workshop grades data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getGrades = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                workshopid: workshopId
            };
            var preSets = {
                cacheKey: _this.getGradesDataCacheKey(workshopId)
            };
            return site.read('mod_workshop_get_grades', params, preSets);
        });
    };
    /**
     * Invalidates workshop grades data.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateGradesData = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getGradesDataCacheKey(workshopId));
        });
    };
    /**
     * Retrieves the assessment grades report.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {number}  [groupId]           Group id, 0 means that the function will determine the user group.
     * @param  {number}  [page=0]            Page of records to return. Default 0.
     * @param  {number}  [perPage=0]         Records per page to return. Default AddonModWorkshopProvider.PER_PAGE.
     * @param  {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any>}                Promise resolved when the workshop data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getGradesReport = function (workshopId, groupId, page, perPage, offline, ignoreCache, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (page === void 0) { page = 0; }
        if (perPage === void 0) { perPage = 0; }
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                workshopid: workshopId,
                groupid: groupId,
                page: page,
                perpage: perPage || AddonModWorkshopProvider_1.PER_PAGE
            };
            var preSets = {
                cacheKey: _this.getGradesReportDataCacheKey(workshopId, groupId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_OFTEN
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = 0;
                preSets.emergencyCache = 0;
            }
            return site.read('mod_workshop_get_grades_report', params, preSets).then(function (response) {
                if (response && response.report) {
                    return response.report;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Performs the whole fetch of the grade reports in the workshop.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {number}  [groupId=0]         Group ID.
     * @param  {number}  [perPage=0]         Records per page to fetch. It has to match with the prefetch.
     *                                       Default on AddonModWorkshopProvider.PER_PAGE.
     * @param  {boolean} [forceCache=false]  True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any[]>}              Promise resolved when done.
     */
    AddonModWorkshopProvider.prototype.fetchAllGradeReports = function (workshopId, groupId, perPage, forceCache, ignoreCache, siteId) {
        if (groupId === void 0) { groupId = 0; }
        if (perPage === void 0) { perPage = 0; }
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        perPage = perPage || AddonModWorkshopProvider_1.PER_PAGE;
        return this.fetchGradeReportsRecursive(workshopId, groupId, perPage, forceCache, ignoreCache, [], 0, siteId);
    };
    /**
     * Recursive call on fetch all grade reports.
     *
     * @param  {number}  workshopId  Workshop ID.
     * @param  {number}  groupId     Group ID.
     * @param  {number}  perPage     Records per page to fetch. It has to match with the prefetch.
     * @param  {boolean} forceCache  True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean} ignoreCache True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {any[]}   grades      Grades already fetched (just to concatenate them).
     * @param  {number}  page        Page of records to return.
     * @param  {string}  siteId      Site ID.
     * @return {Promise<any[]>}      Promise resolved when done.
     */
    AddonModWorkshopProvider.prototype.fetchGradeReportsRecursive = function (workshopId, groupId, perPage, forceCache, ignoreCache, grades, page, siteId) {
        var _this = this;
        return this.getGradesReport(workshopId, groupId, page, perPage, forceCache, ignoreCache, siteId).then(function (report) {
            Array.prototype.push.apply(grades, report.grades);
            var canLoadMore = ((page + 1) * perPage) < report.totalcount;
            if (canLoadMore) {
                return _this.fetchGradeReportsRecursive(workshopId, groupId, perPage, forceCache, ignoreCache, grades, page + 1, siteId);
            }
            return grades;
        });
    };
    /**
     * Invalidates workshop grade report data.
     *
     * @param  {number} workshopId  Workshop ID.
     * @param  {number} [groupId=0] Group ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateGradeReportData = function (workshopId, groupId, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getGradesReportDataCacheKey(workshopId, groupId));
        });
    };
    /**
     * Retrieves the given submission assessment.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {number}  submissionId        Submission ID.
     * @param  {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any[]>}              Promise resolved when the workshop data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getSubmissionAssessments = function (workshopId, submissionId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                submissionid: submissionId
            };
            var preSets = {
                cacheKey: _this.getSubmissionAssessmentsDataCacheKey(workshopId, submissionId)
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = 0;
                preSets.emergencyCache = 0;
            }
            return site.read('mod_workshop_get_submission_assessments', params, preSets).then(function (response) {
                if (response && response.assessments) {
                    return response.assessments;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates workshop submission assessments data.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateSubmissionAssesmentsData = function (workshopId, submissionId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getSubmissionAssessmentsDataCacheKey(workshopId, submissionId));
        });
    };
    /**
     * Add a new submission to a given workshop.
     *
     * @param  {number}  workshopId           Workshop ID.
     * @param  {number}  courseId             Course ID the workshop belongs to.
     * @param  {string}  title                The submission title.
     * @param  {string}  content              The submission text content.
     * @param  {number}  [attachmentsId]      The draft file area id for attachments.
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @param  {number}  [timecreated]        The time the submission was created. Only used when editing an offline discussion.
     * @param  {boolean} [allowOffline=false] True if it can be stored in offline, false otherwise.
     * @return {Promise<any>}                 Promise resolved with submission ID if sent online or false if stored offline.
     */
    AddonModWorkshopProvider.prototype.addSubmission = function (workshopId, courseId, title, content, attachmentsId, siteId, timecreated, allowOffline) {
        var _this = this;
        if (allowOffline === void 0) { allowOffline = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.workshopOffline.saveSubmission(workshopId, courseId, title, content, {}, timecreated, 'add', siteId).then(function () {
                return false;
            });
        };
        // If we are editing an offline discussion, discard previous first.
        var discardPromise = timecreated ? this.workshopOffline.deleteSubmissionAction(workshopId, timecreated, 'add', siteId) : Promise.resolve();
        return discardPromise.then(function () {
            if (!_this.appProvider.isOnline() && allowOffline) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.addSubmissionOnline(workshopId, title, content, attachmentsId, siteId).catch(function (error) {
                if (allowOffline && !_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Add a new submission to a given workshop. It will fail if offline or cannot connect.
     *
     * @param  {number} workshopId      Workshop ID.
     * @param  {string} title           The submission title.
     * @param  {string} content         The submission text content.
     * @param  {number} [attachmentsId] The draft file area id for attachments.
     * @param  {string} [siteId]        Site ID. If not defined, current site.
     * @return {Promise<any>}           Promise resolved when the submission is created.
     */
    AddonModWorkshopProvider.prototype.addSubmissionOnline = function (workshopId, title, content, attachmentsId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                workshopid: workshopId,
                title: title,
                content: content,
                attachmentsid: attachmentsId || 0
            };
            return site.write('mod_workshop_add_submission', params).then(function (response) {
                // Other errors ocurring.
                if (!response || !response.submissionid) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                return response.submissionid;
            });
        });
    };
    /**
     * Updates the given submission.
     *
     * @param  {number}  workshopId           Workshop ID.
     * @param  {number}  submissionId         Submission ID.
     * @param  {number}  courseId             Course ID the workshop belongs to.
     * @param  {string}  title                The submission title.
     * @param  {string}  content              The submission text content.
     * @param  {number}  [attachmentsId]      The draft file area id for attachments.
     * @param  {string}  [siteId]             Site ID. If not defined, current site.
     * @param  {boolean} [allowOffline=false] True if it can be stored in offline, false otherwise.
     * @return {Promise<any>}                 Promise resolved with submission ID if sent online or false if stored offline.
     */
    AddonModWorkshopProvider.prototype.updateSubmission = function (workshopId, submissionId, courseId, title, content, attachmentsId, siteId, allowOffline) {
        var _this = this;
        if (allowOffline === void 0) { allowOffline = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.workshopOffline.saveSubmission(workshopId, courseId, title, content, attachmentsId, submissionId, 'update', siteId).then(function () {
                return false;
            });
        };
        // If we are editing an offline discussion, discard previous first.
        return this.workshopOffline.deleteSubmissionAction(workshopId, submissionId, 'update', siteId).then(function () {
            if (!_this.appProvider.isOnline() && allowOffline) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.updateSubmissionOnline(submissionId, title, content, attachmentsId, siteId).catch(function (error) {
                if (allowOffline && !_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Updates the given submission. It will fail if offline or cannot connect.
     *
     * @param  {number} submissionId    Submission ID.
     * @param  {string} title           The submission title.
     * @param  {string} content         The submission text content.
     * @param  {number} [attachmentsId] The draft file area id for attachments.
     * @param  {string} [siteId]        Site ID. If not defined, current site.
     * @return {Promise<any>}           Promise resolved when the submission is updated.
     */
    AddonModWorkshopProvider.prototype.updateSubmissionOnline = function (submissionId, title, content, attachmentsId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                submissionid: submissionId,
                title: title,
                content: content,
                attachmentsid: attachmentsId || 0
            };
            return site.write('mod_workshop_update_submission', params).then(function (response) {
                // Other errors ocurring.
                if (!response || !response.status) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                // Return submissionId to be consistent with addSubmission.
                return Promise.resolve(submissionId);
            });
        });
    };
    /**
     * Deletes the given submission.
     *
     * @param  {number}  workshopId  Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {number} courseId     Course ID the workshop belongs to.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with submission ID if sent online, resolved with false if stored offline.
     */
    AddonModWorkshopProvider.prototype.deleteSubmission = function (workshopId, submissionId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.workshopOffline.saveSubmission(workshopId, courseId, '', '', 0, submissionId, 'delete', siteId).then(function () {
                return false;
            });
        };
        // If we are editing an offline discussion, discard previous first.
        return this.workshopOffline.deleteSubmissionAction(workshopId, submissionId, 'delete', siteId).then(function () {
            if (!_this.appProvider.isOnline()) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.deleteSubmissionOnline(submissionId, siteId).catch(function (error) {
                if (!_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Deletes the given submission. It will fail if offline or cannot connect.
     *
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the submission is deleted.
     */
    AddonModWorkshopProvider.prototype.deleteSubmissionOnline = function (submissionId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                submissionid: submissionId
            };
            return site.write('mod_workshop_delete_submission', params).then(function (response) {
                // Other errors ocurring.
                if (!response || !response.status) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                // Return submissionId to be consistent with addSubmission.
                return Promise.resolve(submissionId);
            });
        });
    };
    /**
     * Retrieves all the assessments reviewed by the given user.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {number}  [userId]            User ID. If not defined, current user.
     * @param  {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any[]>}              Promise resolved when the workshop data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getReviewerAssessments = function (workshopId, userId, offline, ignoreCache, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                workshopid: workshopId
            };
            var preSets = {
                cacheKey: _this.getReviewerAssessmentsDataCacheKey(workshopId, userId)
            };
            if (userId) {
                params.userid = userId;
            }
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = 0;
                preSets.emergencyCache = 0;
            }
            return site.read('mod_workshop_get_reviewer_assessments', params, preSets).then(function (response) {
                if (response && response.assessments) {
                    return response.assessments;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates workshop user assessments data.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {number} [userId]   User ID. If not defined, current user.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateReviewerAssesmentsData = function (workshopId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getReviewerAssessmentsDataCacheKey(workshopId, userId));
        });
    };
    /**
     * Retrieves the given assessment.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the workshop data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getAssessment = function (workshopId, assessmentId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assessmentid: assessmentId
            };
            var preSets = {
                cacheKey: _this.getAssessmentDataCacheKey(workshopId, assessmentId)
            };
            return site.read('mod_workshop_get_assessment', params, preSets).then(function (response) {
                if (response && response.assessment) {
                    return response.assessment;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates workshop assessment data.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateAssessmentData = function (workshopId, assessmentId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAssessmentDataCacheKey(workshopId, assessmentId));
        });
    };
    /**
     * Retrieves the assessment form definition (data required to be able to display the assessment form).
     *
     * @param  {number}    workshopId          Workshop ID.
     * @param  {number}    assessmentId        Assessment ID.
     * @param  {string}    [mode='assessment'] Mode assessment (default) or preview.
     * @param  {boolean}   [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean}   [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}    [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any>}                  Promise resolved when the workshop data is retrieved.
     */
    AddonModWorkshopProvider.prototype.getAssessmentForm = function (workshopId, assessmentId, mode, offline, ignoreCache, siteId) {
        var _this = this;
        if (mode === void 0) { mode = 'assessment'; }
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assessmentid: assessmentId,
                mode: mode || 'assessment'
            };
            var preSets = {
                cacheKey: _this.getAssessmentFormDataCacheKey(workshopId, assessmentId, mode),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = 0;
                preSets.emergencyCache = 0;
            }
            return site.read('mod_workshop_get_assessment_form_definition', params, preSets).then(function (response) {
                if (response) {
                    response.fields = _this.parseFields(response.fields);
                    response.options = _this.utils.objectToKeyValueMap(response.options, 'name', 'value');
                    response.current = _this.parseFields(response.current);
                    return response;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Parse fieldes into a more handful format.
     *
     * @param  {any[]} fields Fields to parse
     * @return {any[]}        Parsed fields
     */
    AddonModWorkshopProvider.prototype.parseFields = function (fields) {
        var parsedFields = [];
        fields.forEach(function (field) {
            var args = field.name.split('_');
            var name = args[0];
            var idx = args[3];
            var idy = args[6] || false;
            if (parseInt(idx, 10) == idx) {
                if (!parsedFields[idx]) {
                    parsedFields[idx] = {
                        number: parseInt(idx, 10) + 1
                    };
                }
                if (idy && parseInt(idy, 10) == idy) {
                    if (!parsedFields[idx].fields) {
                        parsedFields[idx].fields = [];
                    }
                    if (!parsedFields[idx].fields[idy]) {
                        parsedFields[idx].fields[idy] = {
                            number: parseInt(idy, 10) + 1
                        };
                    }
                    parsedFields[idx].fields[idy][name] = field.value;
                }
                else {
                    parsedFields[idx][name] = field.value;
                }
            }
        });
        return parsedFields;
    };
    /**
     * Invalidates workshop assessments form data.
     *
     * @param  {number} workshopId          Workshop ID.
     * @param  {number} assessmentId        Assessment ID.
     * @param  {string} [mode='assessment'] Mode assessment (default) or preview.
     * @param  {string} [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any>}               Promise resolved when the data is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateAssessmentFormData = function (workshopId, assessmentId, mode, siteId) {
        var _this = this;
        if (mode === void 0) { mode = 'assessment'; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAssessmentFormDataCacheKey(workshopId, assessmentId, mode));
        });
    };
    /**
     * Updates the given assessment.
     *
     * @param {number}  workshopId           Workshop ID.
     * @param {number}  assessmentId         Assessment ID.
     * @param {number}  courseId             Course ID the workshop belongs to.
     * @param {any}     inputData            Assessment data.
     * @param {string}  [siteId]             Site ID. If not defined, current site.
     * @param {boolean} [allowOffline=false] True if it can be stored in offline, false otherwise.
     * @return {Promise<any>}                Promise resolved with the grade of the submission if sent online,
     *                                       resolved with false if stored offline.
     */
    AddonModWorkshopProvider.prototype.updateAssessment = function (workshopId, assessmentId, courseId, inputData, siteId, allowOffline) {
        var _this = this;
        if (allowOffline === void 0) { allowOffline = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.workshopOffline.saveAssessment(workshopId, assessmentId, courseId, inputData, siteId).then(function () {
                return false;
            });
        };
        // If we are editing an offline discussion, discard previous first.
        return this.workshopOffline.deleteAssessment(workshopId, assessmentId, siteId).then(function () {
            if (!_this.appProvider.isOnline() && allowOffline) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.updateAssessmentOnline(assessmentId, inputData, siteId).catch(function (error) {
                if (allowOffline && !_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Updates the given assessment. It will fail if offline or cannot connect.
     *
     * @param  {number} assessmentId Assessment ID.
     * @param  {any}    inputData    Assessment data.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the grade of the submission.
     */
    AddonModWorkshopProvider.prototype.updateAssessmentOnline = function (assessmentId, inputData, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assessmentid: assessmentId,
                data: _this.utils.objectToArrayOfObjects(inputData, 'name', 'value')
            };
            return site.write('mod_workshop_update_assessment', params).then(function (response) {
                // Other errors ocurring.
                if (!response || !response.status) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                // Return rawgrade for submission
                return response.rawgrade;
            });
        });
    };
    /**
     * Evaluates a submission (used by teachers for provide feedback or override the submission grade).
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId The submission id.
     * @param  {number}  courseId     Course ID the workshop belongs to.
     * @param  {string}  feedbackText The feedback for the author.
     * @param  {boolean} published    Whether to publish the submission for other users.
     * @param  {any}     gradeOver    The new submission grade (empty for no overriding the grade).
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when submission is evaluated if sent online,
     *                                resolved with false if stored offline.
     */
    AddonModWorkshopProvider.prototype.evaluateSubmission = function (workshopId, submissionId, courseId, feedbackText, published, gradeOver, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.workshopOffline.saveEvaluateSubmission(workshopId, submissionId, courseId, feedbackText, published, gradeOver, siteId).then(function () {
                return false;
            });
        };
        // If we are editing an offline discussion, discard previous first.
        return this.workshopOffline.deleteEvaluateSubmission(workshopId, submissionId, siteId).then(function () {
            if (!_this.appProvider.isOnline()) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.evaluateSubmissionOnline(submissionId, feedbackText, published, gradeOver, siteId).catch(function (error) {
                if (!_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Evaluates a submission (used by teachers for provide feedback or override the submission grade).
     * It will fail if offline or cannot connect.
     *
     * @param  {number}  submissionId The submission id.
     * @param  {string}  feedbackText The feedback for the author.
     * @param  {boolean} published    Whether to publish the submission for other users.
     * @param  {any}     gradeOver    The new submission grade (empty for no overriding the grade).
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when the submission is evaluated.
     */
    AddonModWorkshopProvider.prototype.evaluateSubmissionOnline = function (submissionId, feedbackText, published, gradeOver, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                submissionid: submissionId,
                feedbacktext: feedbackText || '',
                feedbackformat: 1,
                published: published ? 1 : 0,
                gradeover: gradeOver
            };
            return site.write('mod_workshop_evaluate_submission', params).then(function (response) {
                // Other errors ocurring.
                if (!response || !response.status) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                // Return if worked.
                return Promise.resolve(true);
            });
        });
    };
    /**
     * Evaluates an assessment (used by teachers for provide feedback to the reviewer).
     *
     * @param  {number}  workshopId       Workshop ID.
     * @param  {number}  assessmentId     The assessment id.
     * @param  {number}  courseId         Course ID the workshop belongs to.
     * @param  {string}  feedbackText     The feedback for the reviewer.
     * @param  {boolean} weight           The new weight for the assessment.
     * @param  {any}     gradingGradeOver The new grading grade (empty for no overriding the grade).
     * @param  {string}  [siteId]         Site ID. If not defined, current site.
     * @return {Promise<any>}             Promise resolved when assessment is evaluated if sent online,
     *                                    resolved with false if stored offline.
     */
    AddonModWorkshopProvider.prototype.evaluateAssessment = function (workshopId, assessmentId, courseId, feedbackText, weight, gradingGradeOver, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.workshopOffline.saveEvaluateAssessment(workshopId, assessmentId, courseId, feedbackText, weight, gradingGradeOver, siteId).then(function () {
                return false;
            });
        };
        // If we are editing an offline discussion, discard previous first.
        return this.workshopOffline.deleteEvaluateAssessment(workshopId, assessmentId, siteId).then(function () {
            if (!_this.appProvider.isOnline()) {
                // App is offline, store the action.
                return storeOffline();
            }
            return _this.evaluateAssessmentOnline(assessmentId, feedbackText, weight, gradingGradeOver, siteId).catch(function (error) {
                if (!_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Evaluates an assessment (used by teachers for provide feedback to the reviewer). It will fail if offline or cannot connect.
     *
     * @param  {number}  assessmentId     The assessment id.
     * @param  {string}  feedbackText     The feedback for the reviewer.
     * @param  {number}  weight           The new weight for the assessment.
     * @param  {any}     gradingGradeOver The new grading grade (empty for no overriding the grade).
     * @param  {string}  [siteId]         Site ID. If not defined, current site.
     * @return {Promise<any>}             Promise resolved when the assessment is evaluated.
     */
    AddonModWorkshopProvider.prototype.evaluateAssessmentOnline = function (assessmentId, feedbackText, weight, gradingGradeOver, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                assessmentid: assessmentId,
                feedbacktext: feedbackText || '',
                feedbackformat: 1,
                weight: weight,
                gradinggradeover: gradingGradeOver
            };
            return site.write('mod_workshop_evaluate_assessment', params).then(function (response) {
                // Other errors ocurring.
                if (!response || !response.status) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                // Return if worked.
                return Promise.resolve(true);
            });
        });
    };
    /**
     * Invalidate the prefetched content except files.
     * To invalidate files, use AddonModWorkshopProvider#invalidateFiles.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promised resolved when content is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getWorkshop(courseId, moduleId, siteId, true).then(function (workshop) {
            return _this.invalidateContentById(workshop.id, courseId, siteId);
        });
    };
    /**
     * Invalidate the prefetched content except files using the activityId.
     * To invalidate files, use AdddonModWorkshop#invalidateFiles.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {number} courseId   Course ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when content is invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateContentById = function (workshopId, courseId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [
            // Do not invalidate workshop data before getting workshop info, we need it!
            this.invalidateWorkshopData(courseId, siteId),
            this.invalidateWorkshopWSData(workshopId, siteId),
        ];
        return Promise.all(promises);
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param  {number} moduleId The module ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the files are invalidated.
     */
    AddonModWorkshopProvider.prototype.invalidateFiles = function (moduleId, siteId) {
        return this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModWorkshopProvider_1.COMPONENT, moduleId);
    };
    /**
     * Report the workshop as being viewed.
     *
     * @param  {number} id       Workshop ID.
     * @param {string} [name] Name of the workshop.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the WS call is successful.
     */
    AddonModWorkshopProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            workshopid: id
        };
        return this.logHelper.logSingle('mod_workshop_view_workshop', params, AddonModWorkshopProvider_1.COMPONENT, id, name, 'workshop', siteId);
    };
    /**
     * Report the workshop submission as being viewed.
     *
     * @param  {number} id          Submission ID.
     * @param  {number} workshopId  Workshop ID.
     * @param {string} [name] Name of the workshop.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the WS call is successful.
     */
    AddonModWorkshopProvider.prototype.logViewSubmission = function (id, workshopId, name, siteId) {
        var params = {
            submissionid: id
        };
        return this.logHelper.logSingle('mod_workshop_view_submission', params, AddonModWorkshopProvider_1.COMPONENT, workshopId, name, 'workshop', params, siteId);
    };
    AddonModWorkshopProvider.COMPONENT = 'mmaModWorkshop';
    AddonModWorkshopProvider.PER_PAGE = 10;
    AddonModWorkshopProvider.PHASE_SETUP = 10;
    AddonModWorkshopProvider.PHASE_SUBMISSION = 20;
    AddonModWorkshopProvider.PHASE_ASSESSMENT = 30;
    AddonModWorkshopProvider.PHASE_EVALUATION = 40;
    AddonModWorkshopProvider.PHASE_CLOSED = 50;
    AddonModWorkshopProvider.SUBMISSION_TYPE_DISABLED = 0;
    AddonModWorkshopProvider.SUBMISSION_TYPE_AVAILABLE = 1;
    AddonModWorkshopProvider.SUBMISSION_TYPE_REQUIRED = 2;
    AddonModWorkshopProvider.SUBMISSION_CHANGED = 'addon_mod_workshop_submission_changed';
    AddonModWorkshopProvider.ASSESSMENT_SAVED = 'addon_mod_workshop_assessment_saved';
    AddonModWorkshopProvider.ASSESSMENT_INVALIDATED = 'addon_mod_workshop_assessment_invalidated';
    AddonModWorkshopProvider = AddonModWorkshopProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__offline__["a" /* AddonModWorkshopOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModWorkshopProvider);
    return AddonModWorkshopProvider;
    var AddonModWorkshopProvider_1;
}());

//# sourceMappingURL=workshop.js.map

/***/ }),
/* 112 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLangProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_moment__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_globalization__ = __webpack_require__(337);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__configconstants__ = __webpack_require__(66);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/*
 * Service to handle language features, like changing the current language.
*/
var CoreLangProvider = /** @class */ (function () {
    function CoreLangProvider(translate, configProvider, platform, globalization) {
        var _this = this;
        this.translate = translate;
        this.configProvider = configProvider;
        this.globalization = globalization;
        this.fallbackLanguage = 'zh-cn'; // Always use English as fallback language since it contains all strings.
        this.defaultLanguage = 'zh-cn'; // Lang to use if device lang not valid or is forced.
        this.customStrings = {}; // Strings defined using the admin tool.
        this.sitePluginsStrings = {}; // Strings defined by site plugins.
        // Set fallback language and language to use until the app determines the right language to use.
        translate.setDefaultLang(this.fallbackLanguage);
        translate.use(this.defaultLanguage);
        platform.ready().then(function () {
            _this.getCurrentLanguage().then(function (language) {
                _this.changeCurrentLanguage(language);
            });
        });
        translate.onLangChange.subscribe(function (event) {
            platform.setLang(event.lang, true);
            platform.setDir(_this.translate.instant('core.thisdirection'), true);
        });
    }
    /**
     * Add a set of site plugins strings for a certain language.
     *
     * @param {string} lang The language where to add the strings.
     * @param {any} strings Object with the strings to add.
     * @param {string} [prefix] A prefix to add to all keys.
     */
    CoreLangProvider.prototype.addSitePluginsStrings = function (lang, strings, prefix) {
        lang = lang.replace(/_/g, '-'); // Use the app format instead of Moodle format.
        // Initialize structure if it doesn't exist.
        if (!this.sitePluginsStrings[lang]) {
            this.sitePluginsStrings[lang] = {};
        }
        for (var key in strings) {
            var prefixedKey = prefix + key;
            var value = strings[key];
            if (this.customStrings[lang] && this.customStrings[lang][prefixedKey]) {
                // This string is overridden by a custom string, ignore it.
                continue;
            }
            // Replace the way to access subproperties.
            value = value.replace(/\$a->/gm, '$a.');
            // Add another curly bracket to string params ({$a} -> {{$a}}).
            value = value.replace(/{([^ ]+)}/gm, '{{$1}}');
            // Make sure we didn't add to many brackets in some case.
            value = value.replace(/{{{([^ ]+)}}}/gm, '{{$1}}');
            // Load the string.
            this.loadString(this.sitePluginsStrings, lang, prefixedKey, value);
        }
    };
    /**
     * Change current language.
     *
     * @param {string} language New language to use.
     * @return {Promise<any>} Promise resolved when the change is finished.
     */
    CoreLangProvider.prototype.changeCurrentLanguage = function (language) {
        var _this = this;
        var promises = [];
        // Change the language, resolving the promise when we receive the first value.
        promises.push(new Promise(function (resolve, reject) {
            var subscription = _this.translate.use(language).subscribe(function (data) {
                // It's a language override, load the original one first.
                var fallbackLang = _this.translate.instant('core.parentlanguage');
                if (fallbackLang != '' && fallbackLang != 'core.parentlanguage' && fallbackLang != language) {
                    var fallbackSubs_1 = _this.translate.use(fallbackLang).subscribe(function (fallbackData) {
                        data = Object.assign(fallbackData, data);
                        resolve(data);
                        // Data received, unsubscribe. Use a timeout because we can receive a value immediately.
                        setTimeout(function () {
                            fallbackSubs_1.unsubscribe();
                        });
                    }, function (error) {
                        // Resolve with the original language.
                        resolve(data);
                        // Error received, unsubscribe. Use a timeout because we can receive a value immediately.
                        setTimeout(function () {
                            fallbackSubs_1.unsubscribe();
                        });
                    });
                }
                else {
                    resolve(data);
                }
                // Data received, unsubscribe. Use a timeout because we can receive a value immediately.
                setTimeout(function () {
                    subscription.unsubscribe();
                });
            }, function (error) {
                reject(error);
                // Error received, unsubscribe. Use a timeout because we can receive a value immediately.
                setTimeout(function () {
                    subscription.unsubscribe();
                });
            });
        }));
        // Change the config.
        promises.push(this.configProvider.set('current_language', language));
        // Use british english when parent english is loaded.
        __WEBPACK_IMPORTED_MODULE_2_moment__["locale"](language == 'en' ? 'en-gb' : language);
        this.currentLanguage = language;
        return Promise.all(promises).finally(function () {
            // Load the custom and site plugins strings for the language.
            if (_this.loadLangStrings(_this.customStrings, language) || _this.loadLangStrings(_this.sitePluginsStrings, language)) {
                // Some lang strings have changed, emit an event to update the pipes.
                _this.translate.onLangChange.emit({ lang: language, translations: _this.translate.translations[language] });
            }
        });
    };
    /**
     * Clear current custom strings.
     */
    CoreLangProvider.prototype.clearCustomStrings = function () {
        this.unloadStrings(this.customStrings);
        this.customStrings = {};
        this.customStringsRaw = '';
    };
    /**
     * Clear current site plugins strings.
     */
    CoreLangProvider.prototype.clearSitePluginsStrings = function () {
        this.unloadStrings(this.sitePluginsStrings);
        this.sitePluginsStrings = {};
    };
    /**
     * Get all current custom strings.
     *
     * @return {any} Custom strings.
     */
    CoreLangProvider.prototype.getAllCustomStrings = function () {
        return this.customStrings;
    };
    /**
     * Get all current site plugins strings.
     *
     * @return {any} Site plugins strings.
     */
    CoreLangProvider.prototype.getAllSitePluginsStrings = function () {
        return this.sitePluginsStrings;
    };
    /**
     * Get current language.
     *
     * @return {Promise<string>} Promise resolved with the current language.
     */
    CoreLangProvider.prototype.getCurrentLanguage = function () {
        var _this = this;
        if (typeof this.currentLanguage != 'undefined') {
            return Promise.resolve(this.currentLanguage);
        }
        // Get current language from config (user might have changed it).
        return this.configProvider.get('current_language').then(function (language) {
            return language;
        }).catch(function () {
            // User hasn't defined a language. If default language is forced, use it.
            if (__WEBPACK_IMPORTED_MODULE_6__configconstants__["a" /* CoreConfigConstants */].default_lang && __WEBPACK_IMPORTED_MODULE_6__configconstants__["a" /* CoreConfigConstants */].forcedefaultlanguage) {
                return __WEBPACK_IMPORTED_MODULE_6__configconstants__["a" /* CoreConfigConstants */].default_lang;
            }
            try {
                // No forced language, try to get current language from cordova globalization.
                return _this.globalization.getPreferredLanguage().then(function (result) {
                    var language = result.value.toLowerCase();
                    if (language.indexOf('-') > -1) {
                        // Language code defined by locale has a dash, like en-US or es-ES. Check if it's supported.
                        if (__WEBPACK_IMPORTED_MODULE_6__configconstants__["a" /* CoreConfigConstants */].languages && typeof __WEBPACK_IMPORTED_MODULE_6__configconstants__["a" /* CoreConfigConstants */].languages[language] == 'undefined') {
                            // Code is NOT supported. Fallback to language without dash. E.g. 'en-US' would fallback to 'en'.
                            language = language.substr(0, language.indexOf('-'));
                        }
                    }
                    if (typeof __WEBPACK_IMPORTED_MODULE_6__configconstants__["a" /* CoreConfigConstants */].languages[language] == 'undefined') {
                        // Language not supported, use default language.
                        return _this.defaultLanguage;
                    }
                    return language;
                }).catch(function () {
                    // Error getting locale. Use default language.
                    return _this.defaultLanguage;
                });
            }
            catch (err) {
                // Error getting locale. Use default language.
                return Promise.resolve(_this.defaultLanguage);
            }
        }).then(function (language) {
            _this.currentLanguage = language; // Save it for later.
            return language;
        });
    };
    /**
     * Get the default language.
     *
     * @return {string} Default language.
     */
    CoreLangProvider.prototype.getDefaultLanguage = function () {
        return this.defaultLanguage;
    };
    /**
     * Get the fallback language.
     *
     * @return {string} Fallback language.
     */
    CoreLangProvider.prototype.getFallbackLanguage = function () {
        return this.fallbackLanguage;
    };
    /**
     * Get the full list of translations for a certain language.
     *
     * @param {string} lang The language to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreLangProvider.prototype.getTranslationTable = function (lang) {
        var _this = this;
        // Create a promise to convert the observable into a promise.
        return new Promise(function (resolve, reject) {
            var observer = _this.translate.getTranslation(lang).subscribe(function (table) {
                resolve(table);
                observer.unsubscribe();
            }, function (err) {
                reject(err);
                observer.unsubscribe();
            });
        });
    };
    /**
     * Load certain custom strings.
     *
     * @param {string} strings Custom strings to load (tool_mobile_customlangstrings).
     */
    CoreLangProvider.prototype.loadCustomStrings = function (strings) {
        var _this = this;
        if (strings == this.customStringsRaw) {
            // Strings haven't changed, stop.
            return;
        }
        // Reset current values.
        this.clearCustomStrings();
        if (!strings) {
            return;
        }
        var list = strings.split(/(?:\r\n|\r|\n)/);
        list.forEach(function (entry) {
            var values = entry.split('|');
            var lang;
            if (values.length < 3) {
                // Not enough data, ignore the entry.
                return;
            }
            lang = values[2].replace(/_/g, '-'); // Use the app format instead of Moodle format.
            if (!_this.customStrings[lang]) {
                _this.customStrings[lang] = {};
            }
            // Convert old keys format to new one.
            var key = values[0].replace(/^mm\.core/, 'core').replace(/^mm\./, 'core.').replace(/^mma\./, 'addon.')
                .replace(/^core\.sidemenu/, 'core.mainmenu').replace(/^addon\.grades/, 'core.grades')
                .replace(/^addon\.participants/, 'core.user');
            _this.loadString(_this.customStrings, lang, key, values[1]);
        });
        this.customStringsRaw = strings;
    };
    /**
     * Load custom strings for a certain language that weren't loaded because the language wasn't active.
     *
     * @param {any} langObject The object with the strings to load.
     * @param {string} lang Language to load.
     * @return {boolean} Whether the translation table was modified.
     */
    CoreLangProvider.prototype.loadLangStrings = function (langObject, lang) {
        var langApplied = false;
        if (langObject[lang]) {
            for (var key in langObject[lang]) {
                var entry = langObject[lang][key];
                if (!entry.applied) {
                    // Store the original value of the string.
                    entry.original = this.translate.translations[lang][key];
                    // Store the string in the translations table.
                    this.translate.translations[lang][key] = entry.value;
                    entry.applied = true;
                    langApplied = true;
                }
            }
        }
        return langApplied;
    };
    /**
     * Load a string in a certain lang object and in the translate table if the lang is loaded.
     *
     * @param {any} langObject The object where to store the lang.
     * @param {string} lang Language code.
     * @param {string} key String key.
     * @param {string} value String value.
     */
    CoreLangProvider.prototype.loadString = function (langObject, lang, key, value) {
        lang = lang.replace(/_/g, '-'); // Use the app format instead of Moodle format.
        if (this.translate.translations[lang]) {
            // The language is loaded.
            // Store the original value of the string.
            langObject[lang][key] = {
                original: this.translate.translations[lang][key],
                value: value,
                applied: true
            };
            // Store the string in the translations table.
            this.translate.translations[lang][key] = value;
        }
        else {
            // The language isn't loaded.
            // Save it in our object but not in the translations table, it will be loaded when the lang is loaded.
            langObject[lang][key] = {
                value: value,
                applied: false
            };
        }
    };
    /**
     * Unload custom or site plugin strings, removing them from the translations table.
     *
     * @param {any} strings Strings to unload.
     */
    CoreLangProvider.prototype.unloadStrings = function (strings) {
        // Iterate over all languages and strings.
        for (var lang in strings) {
            if (!this.translate.translations[lang]) {
                // Language isn't loaded, nothing to unload.
                continue;
            }
            var langStrings = strings[lang];
            for (var key in langStrings) {
                var entry = langStrings[key];
                if (entry.original) {
                    // The string had a value, restore it.
                    this.translate.translations[lang][key] = entry.original;
                }
                else {
                    // The string didn't exist, delete it.
                    delete this.translate.translations[lang][key];
                }
            }
        }
    };
    CoreLangProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__config__["a" /* CoreConfigProvider */], __WEBPACK_IMPORTED_MODULE_4_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_globalization__["a" /* Globalization */]])
    ], CoreLangProvider);
    return CoreLangProvider;
}());

//# sourceMappingURL=lang.js.map

/***/ }),
/* 113 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__default_format__ = __webpack_require__(746);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__classes_delegate__ = __webpack_require__(62);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Service to interact with course formats. Provides the functions to register and interact with the addons.
 */
var CoreCourseFormatDelegate = /** @class */ (function (_super) {
    __extends(CoreCourseFormatDelegate, _super);
    function CoreCourseFormatDelegate(loggerProvider, sitesProvider, eventsProvider, defaultHandler) {
        var _this = _super.call(this, 'CoreCoursesCourseFormatDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.sitesProvider = sitesProvider;
        _this.defaultHandler = defaultHandler;
        _this.featurePrefix = 'CoreCourseFormatDelegate_';
        _this.handlerNameProperty = 'format';
        return _this;
    }
    /**
     * Whether it allows seeing all sections at the same time. Defaults to true.
     *
     * @param {any} course The course to check.
     * @return {boolean} Whether it allows seeing all sections at the same time.
     */
    CoreCourseFormatDelegate.prototype.canViewAllSections = function (course) {
        return this.executeFunctionOnEnabled(course.format, 'canViewAllSections', [course]);
    };
    /**
     * Whether the option to enable section/module download should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @return {boolean} Whether the option to enable section/module download should be displayed
     */
    CoreCourseFormatDelegate.prototype.displayEnableDownload = function (course) {
        return this.executeFunctionOnEnabled(course.format, 'displayEnableDownload', [course]);
    };
    /**
     * Whether the course refresher should be displayed. If it returns false, a refresher must be included in the course format,
     * and the doRefresh method of CoreCourseSectionPage must be called on refresh. Defaults to true.
     *
     * @param {any} course The course to check.
     * @param {any[]} sections List of course sections.
     * @return {boolean} Whether the refresher should be displayed.
     */
    CoreCourseFormatDelegate.prototype.displayRefresher = function (course, sections) {
        return this.executeFunctionOnEnabled(course.format, 'displayRefresher', [course, sections]);
    };
    /**
     * Whether the default section selector should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @return {boolean} Whether the section selector should be displayed.
     */
    CoreCourseFormatDelegate.prototype.displaySectionSelector = function (course) {
        return this.executeFunctionOnEnabled(course.format, 'displaySectionSelector', [course]);
    };
    /**
     * Get the component to use to display all sections in a course.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course to render.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreCourseFormatDelegate.prototype.getAllSectionsComponent = function (injector, course) {
        var _this = this;
        return Promise.resolve(this.executeFunctionOnEnabled(course.format, 'getAllSectionsComponent', [injector, course]))
            .catch(function (e) {
            _this.logger.error('Error getting all sections component', e);
        });
    };
    /**
     * Get the component to use to display a course format.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course to render.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreCourseFormatDelegate.prototype.getCourseFormatComponent = function (injector, course) {
        var _this = this;
        return Promise.resolve(this.executeFunctionOnEnabled(course.format, 'getCourseFormatComponent', [injector, course]))
            .catch(function (e) {
            _this.logger.error('Error getting course format component', e);
        });
    };
    /**
     * Get the component to use to display the course summary in the default course format.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course to render.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreCourseFormatDelegate.prototype.getCourseSummaryComponent = function (injector, course) {
        var _this = this;
        return Promise.resolve(this.executeFunctionOnEnabled(course.format, 'getCourseSummaryComponent', [injector, course]))
            .catch(function (e) {
            _this.logger.error('Error getting course summary component', e);
        });
    };
    /**
     * Given a course, return the title to use in the course page.
     *
     * @param {any} course The course to get the title.
     * @param {any[]} [sections] List of sections.
     * @return {string} Course title.
     */
    CoreCourseFormatDelegate.prototype.getCourseTitle = function (course, sections) {
        return this.executeFunctionOnEnabled(course.format, 'getCourseTitle', [course, sections]);
    };
    /**
     * Given a course and a list of sections, return the current section that should be displayed first.
     *
     * @param {any} course The course to get the title.
     * @param {any[]} sections List of sections.
     * @return {Promise<any>} Promise resolved with current section.
     */
    CoreCourseFormatDelegate.prototype.getCurrentSection = function (course, sections) {
        // Convert the result to a Promise if it isn't.
        return Promise.resolve(this.executeFunctionOnEnabled(course.format, 'getCurrentSection', [course, sections])).catch(function () {
            // This function should never fail. Just return all the sections.
            return sections[0];
        });
    };
    /**
     * Get the component to use to display the section selector inside the default course format.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course to render.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreCourseFormatDelegate.prototype.getSectionSelectorComponent = function (injector, course) {
        var _this = this;
        return Promise.resolve(this.executeFunctionOnEnabled(course.format, 'getSectionSelectorComponent', [injector, course]))
            .catch(function (e) {
            _this.logger.error('Error getting section selector component', e);
        });
    };
    /**
     * Get the component to use to display a single section. This component will only be used if the user is viewing
     * a single section. If all the sections are displayed at once then it won't be used.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course to render.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreCourseFormatDelegate.prototype.getSingleSectionComponent = function (injector, course) {
        var _this = this;
        return Promise.resolve(this.executeFunctionOnEnabled(course.format, 'getSingleSectionComponent', [injector, course]))
            .catch(function (e) {
            _this.logger.error('Error getting single section component', e);
        });
    };
    /**
     * Invalidate the data required to load the course format.
     *
     * @param {any} course The course to get the title.
     * @param {any[]} sections List of sections.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseFormatDelegate.prototype.invalidateData = function (course, sections) {
        return this.executeFunctionOnEnabled(course.format, 'invalidateData', [course, sections]);
    };
    /**
     * Open a course.
     *
     * @param {NavController} navCtrl The NavController instance to use.
     * @param {any} course The course to open. It should contain a "format" attribute.
     * @param {any} [params] Params to pass to the course page.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseFormatDelegate.prototype.openCourse = function (navCtrl, course, params) {
        return this.executeFunctionOnEnabled(course.format, 'openCourse', [navCtrl, course, params]);
    };
    /**
     * Whether the view should be refreshed when completion changes. If your course format doesn't display
     * activity completion then you should return false.
     *
     * @param {any} course The course.
     * @return {Promise<boolean>} Whether course view should be refreshed when an activity completion changes.
     */
    CoreCourseFormatDelegate.prototype.shouldRefreshWhenCompletionChanges = function (course) {
        return Promise.resolve(this.executeFunctionOnEnabled(course.format, 'shouldRefreshWhenCompletionChanges', [course]));
    };
    CoreCourseFormatDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__default_format__["a" /* CoreCourseFormatDefaultHandler */]])
    ], CoreCourseFormatDelegate);
    return CoreCourseFormatDelegate;
}(__WEBPACK_IMPORTED_MODULE_5__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=format-delegate.js.map

/***/ }),
/* 114 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreMainMenuDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Service to interact with plugins to be shown in the main menu. Provides functions to register a plugin
 * and notify an update in the data.
 */
var CoreMainMenuDelegate = /** @class */ (function (_super) {
    __extends(CoreMainMenuDelegate, _super);
    function CoreMainMenuDelegate(loggerProvider, sitesProvider, eventsProvider) {
        var _this = _super.call(this, 'CoreMainMenuDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.loggerProvider = loggerProvider;
        _this.sitesProvider = sitesProvider;
        _this.eventsProvider = eventsProvider;
        _this.loaded = false;
        _this.siteHandlers = new __WEBPACK_IMPORTED_MODULE_5_rxjs__["BehaviorSubject"]([]);
        _this.featurePrefix = 'CoreMainMenuDelegate_';
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */].LOGOUT, _this.clearSiteHandlers.bind(_this));
        return _this;
    }
    /**
     * Check if handlers are loaded.
     *
     * @return {boolean} True if handlers are loaded, false otherwise.
     */
    CoreMainMenuDelegate.prototype.areHandlersLoaded = function () {
        return this.loaded;
    };
    /**
     * Clear current site handlers. Reserved for core use.
     */
    CoreMainMenuDelegate.prototype.clearSiteHandlers = function () {
        this.loaded = false;
        this.siteHandlers.next([]);
    };
    /**
     * Get the handlers for the current site.
     *
     * @return {Subject<CoreMainMenuHandlerToDisplay[]>} An observable that will receive the handlers.
     */
    CoreMainMenuDelegate.prototype.getHandlers = function () {
        return this.siteHandlers;
    };
    /**
     * Update handlers Data.
     */
    CoreMainMenuDelegate.prototype.updateData = function () {
        var handlersData = [];
        for (var name_1 in this.enabledHandlers) {
            var handler = this.enabledHandlers[name_1], data = handler.getDisplayData();
            handlersData.push({
                name: name_1,
                data: data,
                priority: handler.priority
            });
        }
        // Sort them by priority.
        handlersData.sort(function (a, b) {
            return b.priority - a.priority;
        });
        // Return only the display data.
        var displayData = handlersData.map(function (item) {
            // Move the name and the priority to the display data.
            item.data.name = item.name;
            item.data.priority = item.priority;
            return item.data;
        });
        this.loaded = true;
        this.siteHandlers.next(displayData);
    };
    CoreMainMenuDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreMainMenuDelegate);
    return CoreMainMenuDelegate;
}(__WEBPACK_IMPORTED_MODULE_2__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 115 */,
/* 116 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__default_feedback_handler__ = __webpack_require__(767);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Delegate to register plugins for assign feedback.
 */
var AddonModAssignFeedbackDelegate = /** @class */ (function (_super) {
    __extends(AddonModAssignFeedbackDelegate, _super);
    function AddonModAssignFeedbackDelegate(logger, sitesProvider, eventsProvider, defaultHandler) {
        var _this = _super.call(this, 'AddonModAssignFeedbackDelegate', logger, sitesProvider, eventsProvider) || this;
        _this.defaultHandler = defaultHandler;
        _this.handlerNameProperty = 'type';
        return _this;
    }
    /**
     * Discard the draft data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignFeedbackDelegate.prototype.discardPluginFeedbackData = function (assignId, userId, plugin, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'discardDraft', [assignId, userId, siteId]));
    };
    /**
     * Get the component to use for a certain feedback plugin.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @return {Promise<any>} Promise resolved with the component to use, undefined if not found.
     */
    AddonModAssignFeedbackDelegate.prototype.getComponentForPlugin = function (injector, plugin) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'getComponent', [injector, plugin]));
    };
    /**
     * Return the draft saved data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the draft data.
     */
    AddonModAssignFeedbackDelegate.prototype.getPluginDraftData = function (assignId, userId, plugin, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'getDraft', [assignId, userId, siteId]));
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    AddonModAssignFeedbackDelegate.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'getPluginFiles', [assign, submission, plugin, siteId]));
    };
    /**
     * Get a readable name to use for a certain feedback plugin.
     *
     * @param {any} plugin Plugin to get the name for.
     * @return {string} Human readable name.
     */
    AddonModAssignFeedbackDelegate.prototype.getPluginName = function (plugin) {
        return this.executeFunctionOnEnabled(plugin.type, 'getPluginName', [plugin]);
    };
    /**
     * Check if the feedback data has changed for a certain plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the feedback.
     * @param {number} userId User ID of the submission.
     * @return {Promise<boolean>} Promise resolved with true if data has changed, resolved with false otherwise.
     */
    AddonModAssignFeedbackDelegate.prototype.hasPluginDataChanged = function (assign, submission, plugin, inputData, userId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'hasDataChanged', [assign, submission, plugin, inputData, userId]));
    };
    /**
     * Check whether the plugin has draft data stored.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if it has draft data.
     */
    AddonModAssignFeedbackDelegate.prototype.hasPluginDraftData = function (assignId, userId, plugin, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'hasDraftData', [assignId, userId, siteId]));
    };
    /**
     * Check if a feedback plugin is supported.
     *
     * @param {string} pluginType Type of the plugin.
     * @return {boolean} Whether it's supported.
     */
    AddonModAssignFeedbackDelegate.prototype.isPluginSupported = function (pluginType) {
        return this.hasHandler(pluginType, true);
    };
    /**
     * Prefetch any required data for a feedback plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignFeedbackDelegate.prototype.prefetch = function (assign, submission, plugin, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'prefetch', [assign, submission, plugin, siteId]));
    };
    /**
     * Prepare and add to pluginData the data to submit for a certain feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {any} pluginData Object where to store the data to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data has been gathered.
     */
    AddonModAssignFeedbackDelegate.prototype.preparePluginFeedbackData = function (assignId, userId, plugin, pluginData, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'prepareFeedbackData', [assignId, userId, plugin, pluginData, siteId]));
    };
    /**
     * Save draft data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data to save.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data has been saved.
     */
    AddonModAssignFeedbackDelegate.prototype.saveFeedbackDraft = function (assignId, userId, plugin, inputData, siteId) {
        return Promise.resolve(this.executeFunctionOnEnabled(plugin.type, 'saveDraft', [assignId, userId, plugin, inputData, siteId]));
    };
    AddonModAssignFeedbackDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__default_feedback_handler__["a" /* AddonModAssignDefaultFeedbackHandler */]])
    ], AddonModAssignFeedbackDelegate);
    return AddonModAssignFeedbackDelegate;
}(__WEBPACK_IMPORTED_MODULE_4__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=feedback-delegate.js.map

/***/ }),
/* 117 */,
/* 118 */,
/* 119 */,
/* 120 */,
/* 121 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSplitViewComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
// Code based on https://github.com/martinpritchardelevate/ionic-split-pane-demo




/**
 * Directive to create a split view layout.
 *
 * @description
 * To init/change the right pane contents (content pane), inject this component in the master page.
 * @ViewChild(CoreSplitViewComponent) splitviewCtrl: CoreSplitViewComponent;
 * Then use the push function to load.
 *
 * Accepts the following params:
 *
 * @param {string|boolean} [when] When the split-pane should be shown. Can be a CSS media query expression, or a shortcut
 * expression. Can also be a boolean expression. Check split-pane component documentation for more information.
 *
 * Example:
 *
 * <core-split-view [when]="lg">
 *     <ion-content><!-- CONTENT TO SHOW ON THE LEFT PANEL (MENU) --></ion-content>
 * </core-split-view>
 */
var CoreSplitViewComponent = /** @class */ (function () {
    function CoreSplitViewComponent(masterNav, element, fileUploaderProvider, platform, translate) {
        var _this = this;
        this.masterNav = masterNav;
        this.when = 'md';
        this.masterPageName = '';
        this.masterPageIndex = 0;
        this.loadDetailPage = false;
        this.masterCanLeaveOverridden = false;
        this.ignoreSplitChanged = false;
        // Empty placeholder for the 'detail' page.
        this.detailPage = null;
        this.element = element.nativeElement;
        this.audioCaptureSubscription = fileUploaderProvider.onAudioCapture.subscribe(function (starting) {
            _this.ignoreSplitChanged = starting;
        });
        // Change the side when the language changes.
        this.languageChangedSubscription = translate.onLangChange.subscribe(function (event) {
            setTimeout(function () {
                _this.side = platform.isRTL ? 'right' : 'left';
                _this.menu.setElementAttribute('side', _this.side);
            });
        });
    }
    /**
     * Component being initialized.
     */
    CoreSplitViewComponent.prototype.ngOnInit = function () {
        // Get the master page name and set an empty page as a placeholder.
        this.masterPageName = this.masterNav.getActive().component.name;
        this.masterPageIndex = this.masterNav.indexOf(this.masterNav.getActive());
        this.emptyDetails();
        this.handleCanLeave();
    };
    /**
     * Get the details NavController. If split view is not enabled, it will return the master nav.
     *
     * @return {NavController} Details NavController.
     */
    CoreSplitViewComponent.prototype.getDetailsNav = function () {
        if (this.isEnabled) {
            return this.detailNav;
        }
        else {
            return this.masterNav;
        }
    };
    /**
     * Get the master NavController.
     *
     * @return {NavController} Master NavController.
     */
    CoreSplitViewComponent.prototype.getMasterNav = function () {
        return this.masterNav;
    };
    /**
     * Handle ionViewCanLeave functions in details page. By default, this function isn't captured by Ionic when
     * clicking the back button, it only uses the one in the master page.
     */
    CoreSplitViewComponent.prototype.handleCanLeave = function () {
        var _this = this;
        // Listen for the didEnter event on the details nav to detect everytime a page is loaded.
        this.detailsDidEnterSubscription = this.detailNav.viewDidEnter.subscribe(function (detailsViewController) {
            if (!_this.isOn()) {
                return;
            }
            var masterViewController = _this.masterNav.getActive();
            if (_this.masterCanLeaveOverridden) {
                // We've overridden the can leave of the master page for a previous details page. Restore it.
                masterViewController.instance.ionViewCanLeave = _this.originalMasterCanLeave;
                _this.originalMasterCanLeave = undefined;
                _this.masterCanLeaveOverridden = false;
            }
            if (detailsViewController && detailsViewController.instance && detailsViewController.instance.ionViewCanLeave) {
                // The details page defines a canLeave function. Check if the master page also defines one.
                if (masterViewController.instance.ionViewCanLeave) {
                    // Master page also defines a canLeave function, store it because it will be overridden.
                    _this.originalMasterCanLeave = masterViewController.instance.ionViewCanLeave;
                }
                // Override the master canLeave function so it also calls the details canLeave.
                _this.masterCanLeaveOverridden = true;
                masterViewController.instance.ionViewCanLeave = function () {
                    // Always return a Promise.
                    return Promise.resolve().then(function () {
                        if (_this.originalMasterCanLeave) {
                            // First call the master canLeave.
                            var result = _this.originalMasterCanLeave.apply(masterViewController.instance);
                            if (typeof result == 'boolean' && !result) {
                                // User cannot leave, return a rejected promise so the details canLeave isn't executed.
                                return Promise.reject(null);
                            }
                            else {
                                return result;
                            }
                        }
                    }).then(function () {
                        // User can leave the master page. Check if he can also leave the details page.
                        return detailsViewController.instance.ionViewCanLeave();
                    });
                };
            }
        });
    };
    /**
     * Check if both panels are shown. It depends on screen width.
     *
     * @return {boolean} If split view is enabled.
     */
    CoreSplitViewComponent.prototype.isOn = function () {
        return !!this.isEnabled;
    };
    /**
     * Push a page to the navigation stack. It will decide where to load it depending on the size of the screen.
     *
     * @param {any} page   The component class or deeplink name you want to push onto the navigation stack.
     * @param {any} params Any NavParams you want to pass along to the next view.
     * @param {boolean} [retrying] Whether it's retrying.
     */
    CoreSplitViewComponent.prototype.push = function (page, params, retrying) {
        var _this = this;
        if (typeof this.isEnabled == 'undefined' && !retrying) {
            // Hasn't calculated if it's enabled yet. Wait a bit and try again.
            setTimeout(function () {
                _this.push(page, params, true);
            }, 200);
        }
        else {
            if (this.isEnabled) {
                this.detailNav.setRoot(page, params);
            }
            else {
                this.loadDetailPage = {
                    component: page,
                    data: params
                };
                this.masterNav.push(page, params);
            }
        }
    };
    /**
     * Set the details panel to default info.
     */
    CoreSplitViewComponent.prototype.emptyDetails = function () {
        this.loadDetailPage = false;
        this.detailNav.setRoot('CoreSplitViewPlaceholderPage');
    };
    /**
     * Splitpanel visibility has changed.
     *
     * @param {Boolean} isOn If it fits both panels at the same time.
     */
    CoreSplitViewComponent.prototype.onSplitPaneChanged = function (isOn) {
        if (this.ignoreSplitChanged) {
            return;
        }
        this.isEnabled = isOn;
        if (this.masterNav && this.detailNav) {
            (isOn) ? this.activateSplitView() : this.deactivateSplitView();
        }
    };
    /**
     * Enable the split view, show both panels and do some magical navigation.
     */
    CoreSplitViewComponent.prototype.activateSplitView = function () {
        var currentView = this.masterNav.getActive(), currentPageName = currentView.component.name;
        if (this.masterNav.getPrevious() && this.masterNav.getPrevious().component.name == this.masterPageName) {
            if (currentPageName != this.masterPageName) {
                // CurrentView is a 'Detail' page remove it from the 'master' nav stack.
                this.masterNav.pop();
                // And add it to the 'detail' nav stack.
                this.detailNav.setRoot(currentView.component, currentView.data);
            }
            else if (this.loadDetailPage) {
                // MasterPage is shown, load the last detail page if found.
                this.detailNav.setRoot(this.loadDetailPage.component, this.loadDetailPage.data);
            }
            this.loadDetailPage = false;
        }
    };
    /**
     * Disabled the split view, show only one panel and do some magical navigation.
     */
    CoreSplitViewComponent.prototype.deactivateSplitView = function () {
        var detailView = this.detailNav.getActive(), currentPageName = detailView.component.name;
        if (currentPageName != 'CoreSplitViewPlaceholderPage') {
            // Current detail view is a 'Detail' page so, not the placeholder page, push it on 'master' nav stack.
            this.masterNav.insert(this.masterPageIndex + 1, detailView.component, detailView.data);
        }
    };
    /**
     * Component being destroyed.
     */
    CoreSplitViewComponent.prototype.ngOnDestroy = function () {
        this.detailsDidEnterSubscription && this.detailsDidEnterSubscription.unsubscribe();
        this.audioCaptureSubscription.unsubscribe();
        this.languageChangedSubscription.unsubscribe();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('detailNav'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["s" /* Nav */])
    ], CoreSplitViewComponent.prototype, "detailNav", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('menu'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["p" /* Menu */])
    ], CoreSplitViewComponent.prototype, "menu", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSplitViewComponent.prototype, "when", void 0);
    CoreSplitViewComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-split-view',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\split-view\core-split-view.html"*/'<ion-split-pane (ionChange)="onSplitPaneChanged($event._visible);" [when]="when">\n    <ion-menu [content]="detailNav" type="push" class="core-avoid-header" [side]="side" #menu>\n        <ng-content></ng-content>\n    </ion-menu>\n    <ion-nav [root]="detailPage" #detailNav main class="core-avoid-header"></ion-nav>\n</ion-split-pane>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\split-view\core-split-view.html"*/
        }),
        __param(0, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], CoreSplitViewComponent);
    return CoreSplitViewComponent;
}());

//# sourceMappingURL=split-view.js.map

/***/ }),
/* 122 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_camera__ = __webpack_require__(256);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__delegate__ = __webpack_require__(348);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Helper service to upload files.
 */
var CoreFileUploaderHelperProvider = /** @class */ (function () {
    function CoreFileUploaderHelperProvider(logger, appProvider, translate, fileUploaderProvider, domUtils, textUtils, fileProvider, utils, actionSheetCtrl, uploaderDelegate, camera, platform) {
        this.appProvider = appProvider;
        this.translate = translate;
        this.fileUploaderProvider = fileUploaderProvider;
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.fileProvider = fileProvider;
        this.utils = utils;
        this.actionSheetCtrl = actionSheetCtrl;
        this.uploaderDelegate = uploaderDelegate;
        this.camera = camera;
        this.platform = platform;
        this.logger = logger.getInstance('CoreFileUploaderProvider');
    }
    /**
     * Show a confirmation modal to the user if the size of the file is bigger than the allowed threshold.
     *
     * @param {number} size File size.
     * @param {boolean} [alwaysConfirm] True to show a confirm even if the size isn't high.
     * @param {boolean} [allowOffline] True to allow uploading in offline.
     * @param {number} [wifiThreshold] Threshold for WiFi connection. Default: CoreFileUploaderProvider.WIFI_SIZE_WARNING.
     * @param {number} [limitedThreshold] Threshold for limited connection. Default: CoreFileUploaderProvider.LIMITED_SIZE_WARNING.
     * @return {Promise<void>} Promise resolved when the user confirms or if there's no need to show a modal.
     */
    CoreFileUploaderHelperProvider.prototype.confirmUploadFile = function (size, alwaysConfirm, allowOffline, wifiThreshold, limitedThreshold) {
        if (size == 0) {
            return Promise.resolve();
        }
        if (!allowOffline && !this.appProvider.isOnline()) {
            return Promise.reject(this.translate.instant('core.fileuploader.errormustbeonlinetoupload'));
        }
        wifiThreshold = typeof wifiThreshold == 'undefined' ? __WEBPACK_IMPORTED_MODULE_10__fileuploader__["a" /* CoreFileUploaderProvider */].WIFI_SIZE_WARNING : wifiThreshold;
        limitedThreshold = typeof limitedThreshold == 'undefined' ?
            __WEBPACK_IMPORTED_MODULE_10__fileuploader__["a" /* CoreFileUploaderProvider */].LIMITED_SIZE_WARNING : limitedThreshold;
        if (size < 0) {
            return this.domUtils.showConfirm(this.translate.instant('core.fileuploader.confirmuploadunknownsize'));
        }
        else if (size >= wifiThreshold || (this.appProvider.isNetworkAccessLimited() && size >= limitedThreshold)) {
            var readableSize = this.textUtils.bytesToSize(size, 2);
            return this.domUtils.showConfirm(this.translate.instant('core.fileuploader.confirmuploadfile', { size: readableSize }));
        }
        else if (alwaysConfirm) {
            return this.domUtils.showConfirm(this.translate.instant('core.areyousure'));
        }
        else {
            return Promise.resolve();
        }
    };
    /**
     * Create a temporary copy of a file and upload it.
     *
     * @param {any} file File to copy and upload.
     * @param {boolean} [upload] True if the file should be uploaded, false to return the copy of the file.
     * @param {string} [name] Name to use when uploading the file. If not defined, use the file's name.
     * @return {Promise<any>} Promise resolved when the file is uploaded.
     */
    CoreFileUploaderHelperProvider.prototype.copyAndUploadFile = function (file, upload, name) {
        var _this = this;
        name = name || file.name;
        var modal = this.domUtils.showModalLoading('core.fileuploader.readingfile', true);
        // Get unique name for the copy.
        return this.fileProvider.getUniqueNameInFolder(__WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */].TMPFOLDER, name).then(function (newName) {
            var filePath = _this.textUtils.concatenatePaths(__WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */].TMPFOLDER, newName);
            // Write the data into the file.
            return _this.fileProvider.writeFileDataInFile(file, filePath, function (progress) {
                _this.showProgressModal(modal, 'core.fileuploader.readingfileperc', progress);
            });
        }).catch(function (error) {
            _this.logger.error('Error reading file to upload.', error);
            modal.dismiss();
            return Promise.reject(_this.translate.instant('core.fileuploader.errorreadingfile'));
        }).then(function (fileEntry) {
            modal.dismiss();
            if (upload) {
                // Pass true to delete the copy after the upload.
                return _this.uploadGenericFile(fileEntry.toURL(), name, file.type, true);
            }
            else {
                return fileEntry;
            }
        });
    };
    /**
     * Copy or move a file to the app temporary folder.
     *
     * @param {string} path  Path of the file.
     * @param {boolean} shouldDelete True if original file should be deleted (move), false otherwise (copy).
     * @param {number} [maxSize] Max size of the file. If not defined or -1, no max size.
     * @param {string} [defaultExt] Defaut extension to use if the file doesn't have any.
     * @return {Promise<any>} Promise resolved with the copied file.
     */
    CoreFileUploaderHelperProvider.prototype.copyToTmpFolder = function (path, shouldDelete, maxSize, defaultExt) {
        var _this = this;
        var fileName = this.fileProvider.getFileAndDirectoryFromPath(path).name, promise, fileTooLarge;
        // Check that size isn't too large.
        if (typeof maxSize != 'undefined' && maxSize != -1) {
            promise = this.fileProvider.getExternalFile(path).then(function (fileEntry) {
                return _this.fileProvider.getFileObjectFromFileEntry(fileEntry).then(function (file) {
                    if (file.size > maxSize) {
                        fileTooLarge = file;
                    }
                });
            }).catch(function () {
                // Ignore failures.
            });
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function () {
            if (fileTooLarge) {
                return _this.errorMaxBytes(maxSize, fileTooLarge.name);
            }
            // File isn't too large.
            // Picking an image from album in Android adds a timestamp at the end of the file. Delete it.
            fileName = fileName.replace(/(\.[^\.]*)\?[^\.]*$/, '$1');
            // Get a unique name in the folder to prevent overriding another file.
            return _this.fileProvider.getUniqueNameInFolder(__WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */].TMPFOLDER, fileName, defaultExt);
        }).then(function (newName) {
            // Now move or copy the file.
            var destPath = _this.textUtils.concatenatePaths(__WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */].TMPFOLDER, newName);
            if (shouldDelete) {
                return _this.fileProvider.moveExternalFile(path, destPath);
            }
            else {
                return _this.fileProvider.copyExternalFile(path, destPath);
            }
        });
    };
    /**
     * Function called when trying to upload a file bigger than max size. Shows an error.
     *
     * @param {number} maxSize Max size (bytes).
     * @param {string} fileName Name of the file.
     * @return {Promise<any>} Rejected promise.
     */
    CoreFileUploaderHelperProvider.prototype.errorMaxBytes = function (maxSize, fileName) {
        var errorMessage = this.translate.instant('core.fileuploader.maxbytesfile', {
            $a: {
                file: fileName,
                size: this.textUtils.bytesToSize(maxSize, 2)
            }
        });
        this.domUtils.showErrorModal(errorMessage);
        return Promise.reject(null);
    };
    /**
     * Function called when the file picker is closed.
     */
    CoreFileUploaderHelperProvider.prototype.filePickerClosed = function () {
        if (this.filePickerDeferred) {
            this.filePickerDeferred.reject(this.domUtils.createCanceledError());
            this.filePickerDeferred = undefined;
        }
    };
    /**
     * Function to call once a file is uploaded using the file picker.
     *
     * @param {any} result Result of the upload process.
     */
    CoreFileUploaderHelperProvider.prototype.fileUploaded = function (result) {
        if (this.filePickerDeferred) {
            this.filePickerDeferred.resolve(result);
            this.filePickerDeferred = undefined;
        }
        // Close the action sheet if it's opened.
        if (this.actionSheet) {
            this.actionSheet.dismiss();
        }
    };
    /**
     * Open the "file picker" to select and upload a file.
     *
     * @param {number} [maxSize] Max size of the file to upload. If not defined or -1, no max size.
     * @param {string} [title] File picker title.
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {Promise<any>} Promise resolved when a file is uploaded, rejected if file picker is closed without a file uploaded.
     *                        The resolve value is the response of the upload request.
     */
    CoreFileUploaderHelperProvider.prototype.selectAndUploadFile = function (maxSize, title, mimetypes) {
        return this.selectFileWithPicker(maxSize, false, title, mimetypes, true);
    };
    /**
     * Open the "file picker" to select a file without uploading it.
     *
     * @param {number} [maxSize] Max size of the file. If not defined or -1, no max size.
     * @param {boolean} [allowOffline] True to allow selecting in offline, false to require connection.
     * @param {string} [title] File picker title.
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {Promise<any>} Promise resolved when a file is selected, rejected if file picker is closed without selecting a file.
     *                        The resolve value is the FileEntry of a copy of the picked file, so it can be deleted afterwards.
     */
    CoreFileUploaderHelperProvider.prototype.selectFile = function (maxSize, allowOffline, title, mimetypes) {
        return this.selectFileWithPicker(maxSize, allowOffline, title, mimetypes, false);
    };
    /**
     * Open the "file picker" to select a file and maybe uploading it.
     *
     * @param {number} [maxSize] Max size of the file. If not defined or -1, no max size.
     * @param {boolean} [allowOffline] True to allow selecting in offline, false to require connection.
     * @param {string} [title] File picker title.
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @param {boolean} [upload] Whether the file should be uploaded.
     * @return {Promise<any>} Promise resolved when a file is selected/uploaded, rejected if file picker is closed.
     */
    CoreFileUploaderHelperProvider.prototype.selectFileWithPicker = function (maxSize, allowOffline, title, mimetypes, upload) {
        var _this = this;
        // Create the cancel button and get the handlers to upload the file.
        var buttons = [{
                text: this.translate.instant('core.cancel'),
                role: 'cancel',
                handler: function () {
                    // User cancelled the action sheet.
                    _this.filePickerClosed();
                }
            }], handlers = this.uploaderDelegate.getHandlers(mimetypes);
        this.filePickerDeferred = this.utils.promiseDefer();
        // Sort the handlers by priority.
        handlers.sort(function (a, b) {
            return a.priority <= b.priority ? 1 : -1;
        });
        // Create a button for each handler.
        handlers.forEach(function (handler) {
            buttons.push({
                text: _this.translate.instant(handler.title),
                icon: handler.icon,
                cssClass: handler.class,
                handler: function () {
                    if (!handler.action) {
                        // Nothing to do.
                        return false;
                    }
                    if (!allowOffline && !_this.appProvider.isOnline()) {
                        // Not allowed, show error.
                        _this.domUtils.showErrorModal('core.fileuploader.errormustbeonlinetoupload', true);
                        return false;
                    }
                    handler.action(maxSize, upload, allowOffline, handler.mimetypes).then(function (data) {
                        if (data.treated) {
                            // The handler already treated the file. Return the result.
                            return data.result;
                        }
                        else {
                            // The handler didn't treat the file, we need to do it.
                            if (data.fileEntry) {
                                // The handler provided us a fileEntry, use it.
                                return _this.uploadFileEntry(data.fileEntry, data.delete, maxSize, upload, allowOffline);
                            }
                            else if (data.path) {
                                // The handler provided a path. First treat it like it's a relative path.
                                return _this.fileProvider.getFile(data.path).catch(function () {
                                    // File not found, it's probably an absolute path.
                                    return _this.fileProvider.getExternalFile(data.path);
                                }).then(function (fileEntry) {
                                    // File found, treat it.
                                    return _this.uploadFileEntry(fileEntry, data.delete, maxSize, upload, allowOffline);
                                });
                            }
                            // Nothing received, fail.
                            return Promise.reject('No file received');
                        }
                    }).then(function (result) {
                        // Success uploading or picking, return the result.
                        _this.fileUploaded(result);
                    }).catch(function (error) {
                        if (error) {
                            _this.domUtils.showErrorModal(error);
                        }
                    });
                    // Do not close the action sheet, it will be closed if success.
                    return false;
                }
            });
        });
        this.actionSheet = this.actionSheetCtrl.create({
            title: title ? title : this.translate.instant('core.fileuploader.' + (upload ? 'uploadafile' : 'selectafile')),
            buttons: buttons
        });
        this.actionSheet.present();
        // Call afterRender for each button.
        setTimeout(function () {
            handlers.forEach(function (handler) {
                if (handler.afterRender) {
                    handler.afterRender(maxSize, upload, allowOffline, handler.mimetypes);
                }
            });
        }, 500);
        return this.filePickerDeferred.promise;
    };
    /**
     * Convenience function to upload a file on a certain site, showing a confirm if needed.
     *
     * @param {any} fileEntry FileEntry of the file to upload.
     * @param {boolean} [deleteAfterUpload] Whether the file should be deleted after upload.
     * @param {string} [siteId] Id of the site to upload the file to. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the file is uploaded.
     */
    CoreFileUploaderHelperProvider.prototype.showConfirmAndUploadInSite = function (fileEntry, deleteAfterUpload, siteId) {
        var _this = this;
        return this.fileProvider.getFileObjectFromFileEntry(fileEntry).then(function (file) {
            return _this.confirmUploadFile(file.size).then(function () {
                return _this.uploadGenericFile(fileEntry.toURL(), file.name, file.type, deleteAfterUpload, siteId).then(function () {
                    _this.domUtils.showToast('core.fileuploader.fileuploaded', true, undefined, 'core-toast-success');
                });
            }).catch(function (err) {
                if (err) {
                    _this.domUtils.showErrorModal(err);
                }
                return Promise.reject(null);
            });
        }, function () {
            _this.domUtils.showErrorModal('core.fileuploader.errorreadingfile', true);
            return Promise.reject(null);
        });
    };
    /**
     * Treat a capture audio/video error.
     *
     * @param {any} error Error returned by the Cordova plugin. Can be a string or an object.
     * @param {string} defaultMessage Key of the default message to show.
     * @return {Promise<any>} Rejected promise. If it doesn't have an error message it means it was cancelled.
     */
    CoreFileUploaderHelperProvider.prototype.treatCaptureError = function (error, defaultMessage) {
        // Cancelled or error. If cancelled, error is an object with code = 3.
        if (error) {
            if (typeof error === 'string') {
                this.logger.error('Error while recording audio/video: ' + error);
                if (error.indexOf('No Activity found') > -1) {
                    // User doesn't have an app to do this.
                    return Promise.reject(this.translate.instant('core.fileuploader.errornoapp'));
                }
                else {
                    return Promise.reject(this.translate.instant(defaultMessage));
                }
            }
            else {
                if (error.code != 3) {
                    // Error, not cancelled.
                    this.logger.error('Error while recording audio/video', error);
                    return Promise.reject(this.translate.instant(defaultMessage));
                }
                else {
                    this.logger.debug('Cancelled');
                }
            }
        }
        return Promise.reject(null);
    };
    /**
     * Treat a capture image or browse album error.
     *
     * @param {string} error Error returned by the Cordova plugin.
     * @param {string} defaultMessage Key of the default message to show.
     * @return {Promise<any>} Rejected promise. If it doesn't have an error message it means it was cancelled.
     */
    CoreFileUploaderHelperProvider.prototype.treatImageError = function (error, defaultMessage) {
        // Cancelled or error.
        if (error) {
            if (typeof error == 'string') {
                if (error.toLowerCase().indexOf('error') > -1 || error.toLowerCase().indexOf('unable') > -1) {
                    this.logger.error('Error getting image: ' + error);
                    return Promise.reject(error);
                }
                else {
                    // User cancelled.
                    this.logger.debug('Cancelled');
                }
            }
            else {
                return Promise.reject(this.translate.instant(defaultMessage));
            }
        }
        return Promise.reject(null);
    };
    /**
     * Convenient helper for the user to record and upload a video.
     *
     * @param {boolean} isAudio True if uploading an audio, false if it's a video.
     * @param {number} maxSize Max size of the upload. -1 for no max size.
     * @param {boolean} [upload] True if the file should be uploaded, false to return the picked file.
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileUploaderHelperProvider.prototype.uploadAudioOrVideo = function (isAudio, maxSize, upload, mimetypes) {
        var _this = this;
        this.logger.debug('Trying to record a ' + (isAudio ? 'audio' : 'video') + ' file');
        var options = { limit: 1, mimetypes: mimetypes }, promise = isAudio ? this.fileUploaderProvider.captureAudio(options) : this.fileUploaderProvider.captureVideo(options);
        // The mimetypes param is only for desktop apps, the Cordova plugin doesn't support it.
        return promise.then(function (medias) {
            // We used limit 1, we only want 1 media.
            var media = medias[0];
            var path = media.fullPath;
            var error = _this.fileUploaderProvider.isInvalidMimetype(mimetypes, path); // Verify that the mimetype is supported.
            if (error) {
                return Promise.reject(error);
            }
            // Make sure the path has the protocol. In iOS it doesn't.
            if (_this.appProvider.isMobile() && path.indexOf('file://') == -1) {
                path = 'file://' + path;
            }
            if (upload) {
                return _this.uploadFile(path, maxSize, true, _this.fileUploaderProvider.getMediaUploadOptions(media));
            }
            else {
                // Copy or move the file to our temporary folder.
                return _this.copyToTmpFolder(path, true, maxSize);
            }
        }, function (error) {
            var defaultError = isAudio ? 'core.fileuploader.errorcapturingaudio' : 'core.fileuploader.errorcapturingvideo';
            return _this.treatCaptureError(error, defaultError);
        });
    };
    /**
     * Uploads a file of any type.
     * This function will not check the size of the file, please check it before calling this function.
     *
     * @param {string} uri File URI.
     * @param {string} name File name.
     * @param {string} type File type.
     * @param {boolean} [deleteAfterUpload] Whether the file should be deleted after upload.
     * @param {string} [siteId] Id of the site to upload the file to. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the file is uploaded.
     */
    CoreFileUploaderHelperProvider.prototype.uploadGenericFile = function (uri, name, type, deleteAfterUpload, siteId) {
        var options = this.fileUploaderProvider.getFileUploadOptions(uri, name, type, deleteAfterUpload);
        return this.uploadFile(uri, -1, false, options, siteId);
    };
    /**
     * Convenient helper for the user to upload an image, either from the album or taking it with the camera.
     *
     * @param {boolean} fromAlbum True if the image should be selected from album, false if it should be taken with camera.
     * @param {number} maxSize Max size of the upload. -1 for no max size.
     * @param {boolean} [upload] True if the file should be uploaded, false to return the picked file.
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileUploaderHelperProvider.prototype.uploadImage = function (fromAlbum, maxSize, upload, mimetypes) {
        var _this = this;
        this.logger.debug('Trying to capture an image with camera');
        var options = {
            quality: 50,
            destinationType: this.camera.DestinationType.FILE_URI,
            correctOrientation: true
        };
        if (fromAlbum) {
            var imageSupported = !mimetypes || this.utils.indexOfRegexp(mimetypes, /^image\//) > -1, videoSupported = !mimetypes || this.utils.indexOfRegexp(mimetypes, /^video\//) > -1;
            options.sourceType = this.camera.PictureSourceType.PHOTOLIBRARY;
            options.popoverOptions = {
                x: 10,
                y: 10,
                width: this.platform.width() - 200,
                height: this.platform.height() - 200,
                arrowDir: this.camera.PopoverArrowDirection.ARROW_ANY
            };
            // Determine the mediaType based on the mimetypes.
            if (imageSupported && !videoSupported) {
                options.mediaType = this.camera.MediaType.PICTURE;
            }
            else if (!imageSupported && videoSupported) {
                options.mediaType = this.camera.MediaType.VIDEO;
            }
            else if (this.platform.is('ios')) {
                // Only get all media in iOS because in Android using this option allows uploading any kind of file.
                options.mediaType = this.camera.MediaType.ALLMEDIA;
            }
        }
        else if (mimetypes) {
            if (mimetypes.indexOf('image/jpeg') > -1) {
                options.encodingType = this.camera.EncodingType.JPEG;
            }
            else if (mimetypes.indexOf('image/png') > -1) {
                options.encodingType = this.camera.EncodingType.PNG;
            }
        }
        return this.fileUploaderProvider.getPicture(options).then(function (path) {
            var error = _this.fileUploaderProvider.isInvalidMimetype(mimetypes, path); // Verify that the mimetype is supported.
            if (error) {
                return Promise.reject(error);
            }
            if (upload) {
                return _this.uploadFile(path, maxSize, true, _this.fileUploaderProvider.getCameraUploadOptions(path, fromAlbum));
            }
            else {
                // Copy or move the file to our temporary folder.
                return _this.copyToTmpFolder(path, !fromAlbum, maxSize, 'jpg');
            }
        }, function (error) {
            var defaultError = fromAlbum ? 'core.fileuploader.errorgettingimagealbum' : 'core.fileuploader.errorcapturingimage';
            return _this.treatImageError(error, defaultError);
        });
    };
    /**
     * Upload a file given the file entry.
     *
     * @param {any} fileEntry The file entry.
     * @param {boolean} deleteAfter True if the file should be deleted once treated.
     * @param {number} [maxSize] Max size of the file. If not defined or -1, no max size.
     * @param {boolean} [upload] True if the file should be uploaded, false to return the picked file.
     * @param {boolean} [allowOffline] True to allow selecting in offline, false to require connection.
     * @param {string} [name] Name to use when uploading the file. If not defined, use the file's name.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileUploaderHelperProvider.prototype.uploadFileEntry = function (fileEntry, deleteAfter, maxSize, upload, allowOffline, name) {
        var _this = this;
        return this.fileProvider.getFileObjectFromFileEntry(fileEntry).then(function (file) {
            return _this.uploadFileObject(file, maxSize, upload, allowOffline, name).then(function (result) {
                if (deleteAfter) {
                    // We have uploaded and deleted a copy of the file. Now delete the original one.
                    _this.fileProvider.removeFileByFileEntry(fileEntry);
                }
                return result;
            });
        });
    };
    /**
     * Upload a file given the file object.
     *
     * @param {any} file The file object.
     * @param {number} [maxSize] Max size of the file. If not defined or -1, no max size.
     * @param {boolean} [upload] True if the file should be uploaded, false to return the picked file.
     * @param {boolean} [allowOffline] True to allow selecting in offline, false to require connection.
     * @param {string} [name] Name to use when uploading the file. If not defined, use the file's name.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreFileUploaderHelperProvider.prototype.uploadFileObject = function (file, maxSize, upload, allowOffline, name) {
        var _this = this;
        if (maxSize != -1 && file.size > maxSize) {
            return this.errorMaxBytes(maxSize, file.name);
        }
        return this.confirmUploadFile(file.size, false, allowOffline).then(function () {
            // We have the data of the file to be uploaded, but not its URL (needed). Create a copy of the file to upload it.
            return _this.copyAndUploadFile(file, upload, name);
        });
    };
    /**
     * Convenience function to upload a file, allowing to retry if it fails.
     *
     * @param {string} path Absolute path of the file to upload.
     * @param {number} maxSize Max size of the upload. -1 for no max size.
     * @param {boolean} checkSize True to check size.
     * @param {CoreFileUploaderOptions} Options.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if the file is uploaded, rejected otherwise.
     */
    CoreFileUploaderHelperProvider.prototype.uploadFile = function (path, maxSize, checkSize, options, siteId) {
        var _this = this;
        var errorStr = this.translate.instant('core.error'), retryStr = this.translate.instant('core.retry'), uploadingStr = this.translate.instant('core.fileuploader.uploading'), errorUploading = function (error) {
            // Allow the user to retry.
            return _this.domUtils.showConfirm(error, errorStr, retryStr).then(function () {
                // Try again.
                return _this.uploadFile(path, maxSize, checkSize, options, siteId);
            }, function () {
                // User cancelled. Delete the file if needed.
                if (options.deleteAfterUpload) {
                    _this.fileProvider.removeExternalFile(path);
                }
                return Promise.reject(null);
            });
        };
        var promise, file;
        if (!this.appProvider.isOnline()) {
            return errorUploading(this.translate.instant('core.fileuploader.errormustbeonlinetoupload'));
        }
        if (checkSize) {
            // Check that file size is the right one.
            promise = this.fileProvider.getExternalFile(path).then(function (fileEntry) {
                return _this.fileProvider.getFileObjectFromFileEntry(fileEntry).then(function (f) {
                    file = f;
                    return file.size;
                });
            }).catch(function () {
                // Ignore failures.
            });
        }
        else {
            promise = Promise.resolve(0);
        }
        return promise.then(function (size) {
            if (maxSize != -1 && size > maxSize) {
                return _this.errorMaxBytes(maxSize, file.name);
            }
            if (size > 0) {
                return _this.confirmUploadFile(size);
            }
        }).then(function () {
            // File isn't too large and user confirmed, let's upload.
            var modal = _this.domUtils.showModalLoading(uploadingStr);
            return _this.fileUploaderProvider.uploadFile(path, options, function (progress) {
                // Progress uploading.
                _this.showProgressModal(modal, 'core.fileuploader.uploadingperc', progress);
            }, siteId).catch(function (error) {
                _this.logger.error('Error uploading file.', error);
                modal.dismiss();
                if (typeof error != 'string') {
                    error = _this.translate.instant('core.fileuploader.errorwhileuploading');
                }
                return errorUploading(error);
            }).finally(function () {
                modal.dismiss();
            });
        });
    };
    /**
     * Show a progress modal.
     *
     * @param {Loading} modal The modal where to show the progress.
     * @param {string} stringKey The key of the string to display.
     * @param {ProgressEvent|CoreFileProgressEvent} progress The progress event.
     */
    CoreFileUploaderHelperProvider.prototype.showProgressModal = function (modal, stringKey, progress) {
        if (progress && progress.lengthComputable) {
            // Calculate the progress percentage.
            var perc = Math.min((progress.loaded / progress.total) * 100, 100);
            if (perc >= 0) {
                modal.setContent(this.translate.instant(stringKey, { $a: perc.toFixed(1) }));
                if (modal._cmp && modal._cmp.changeDetectorRef) {
                    // Force a change detection, otherwise the content is not updated.
                    modal._cmp.changeDetectorRef.detectChanges();
                }
            }
        }
    };
    CoreFileUploaderHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_10__fileuploader__["a" /* CoreFileUploaderProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["a" /* ActionSheetController */], __WEBPACK_IMPORTED_MODULE_11__delegate__["a" /* CoreFileUploaderDelegate */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_camera__["a" /* Camera */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */]])
    ], CoreFileUploaderHelperProvider);
    return CoreFileUploaderHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 123 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__assign_offline__ = __webpack_require__(93);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Service that provides some helper functions for assign.
 */
var AddonModAssignHelperProvider = /** @class */ (function () {
    function AddonModAssignHelperProvider(logger, sitesProvider, fileProvider, assignProvider, utils, assignOffline, feedbackDelegate, submissionDelegate, fileUploaderProvider, groupsProvider) {
        this.sitesProvider = sitesProvider;
        this.fileProvider = fileProvider;
        this.assignProvider = assignProvider;
        this.utils = utils;
        this.assignOffline = assignOffline;
        this.feedbackDelegate = feedbackDelegate;
        this.submissionDelegate = submissionDelegate;
        this.fileUploaderProvider = fileUploaderProvider;
        this.groupsProvider = groupsProvider;
        this.logger = logger.getInstance('AddonModAssignHelperProvider');
    }
    /**
     * Check if a submission can be edited in offline.
     *
     * @param {any} assign Assignment.
     * @param {any} submission Submission.
     * @return {boolean} Whether it can be edited offline.
     */
    AddonModAssignHelperProvider.prototype.canEditSubmissionOffline = function (assign, submission) {
        if (!submission) {
            return Promise.resolve(false);
        }
        if (submission.status == __WEBPACK_IMPORTED_MODULE_9__assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_NEW ||
            submission.status == __WEBPACK_IMPORTED_MODULE_9__assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_REOPENED) {
            // It's a new submission, allow creating it in offline.
            return Promise.resolve(true);
        }
        var promises = [];
        var canEdit = true;
        for (var i = 0; i < submission.plugins.length; i++) {
            var plugin = submission.plugins[i];
            promises.push(this.submissionDelegate.canPluginEditOffline(assign, submission, plugin).then(function (canEditPlugin) {
                if (!canEditPlugin) {
                    canEdit = false;
                }
            }));
        }
        return Promise.all(promises).then(function () {
            return canEdit;
        });
    };
    /**
     * Clear plugins temporary data because a submission was cancelled.
     *
     * @param {any} assign Assignment.
     * @param {any} submission Submission to clear the data for.
     * @param {any} inputData Data entered in the submission form.
     */
    AddonModAssignHelperProvider.prototype.clearSubmissionPluginTmpData = function (assign, submission, inputData) {
        var _this = this;
        submission.plugins.forEach(function (plugin) {
            _this.submissionDelegate.clearTmpData(assign, submission, plugin, inputData);
        });
    };
    /**
     * Copy the data from last submitted attempt to the current submission.
     * Since we don't have any WS for that we'll have to re-submit everything manually.
     *
     * @param {any} assign Assignment.
     * @param {any} previousSubmission Submission to copy.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignHelperProvider.prototype.copyPreviousAttempt = function (assign, previousSubmission) {
        var _this = this;
        var pluginData = {}, promises = [];
        previousSubmission.plugins.forEach(function (plugin) {
            promises.push(_this.submissionDelegate.copyPluginSubmissionData(assign, plugin, pluginData));
        });
        return Promise.all(promises).then(function () {
            // We got the plugin data. Now we need to submit it.
            if (Object.keys(pluginData).length) {
                // There's something to save.
                return _this.assignProvider.saveSubmissionOnline(assign.id, pluginData);
            }
        });
    };
    /**
     * Delete stored submission files for a plugin. See storeSubmissionFiles.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} folderName Name of the plugin folder. Must be unique (both in submission and feedback plugins).
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignHelperProvider.prototype.deleteStoredSubmissionFiles = function (assignId, folderName, userId, siteId) {
        var _this = this;
        return this.assignOffline.getSubmissionPluginFolder(assignId, folderName, userId, siteId).then(function (folderPath) {
            return _this.fileProvider.removeDir(folderPath);
        });
    };
    /**
     * Delete all drafts of the feedback plugin data.
     *
     * @param {number} assignId Assignment Id.
     * @param {number} userId User Id.
     * @param {any} feedback  Feedback data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignHelperProvider.prototype.discardFeedbackPluginData = function (assignId, userId, feedback, siteId) {
        var _this = this;
        var promises = [];
        feedback.plugins.forEach(function (plugin) {
            promises.push(_this.feedbackDelegate.discardPluginFeedbackData(assignId, userId, plugin, siteId));
        });
        return Promise.all(promises);
    };
    /**
     * List the participants for a single assignment, with some summary info about their submissions.
     *
     * @param {any} assign Assignment object.
     * @param {number} [groupId] Group Id.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of participants and summary of submissions.
     */
    AddonModAssignHelperProvider.prototype.getParticipants = function (assign, groupId, ignoreCache, siteId) {
        var _this = this;
        groupId = groupId || 0;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.assignProvider.listParticipants(assign.id, groupId, ignoreCache, siteId).then(function (participants) {
            if (groupId || participants && participants.length > 0) {
                return participants;
            }
            // If no participants returned and all groups specified, get participants by groups.
            return _this.groupsProvider.getActivityAllowedGroupsIfEnabled(assign.cmid, undefined, siteId).then(function (userGroups) {
                var promises = [], participants = {};
                userGroups.forEach(function (userGroup) {
                    promises.push(_this.assignProvider.listParticipants(assign.id, userGroup.id, ignoreCache, siteId)
                        .then(function (parts) {
                        // Do not get repeated users.
                        parts.forEach(function (participant) {
                            participants[participant.id] = participant;
                        });
                    }));
                });
                return Promise.all(promises).then(function () {
                    return _this.utils.objectToArray(participants);
                });
            });
        });
    };
    /**
     * Get plugin config from assignment config.
     *
     * @param {any} assign Assignment object including all config.
     * @param {string} subtype Subtype name (assignsubmission or assignfeedback)
     * @param {string} type Name of the subplugin.
     * @return {any} Object containing all configurations of the subplugin selected.
     */
    AddonModAssignHelperProvider.prototype.getPluginConfig = function (assign, subtype, type) {
        var configs = {};
        assign.configs.forEach(function (config) {
            if (config.subtype == subtype && config.plugin == type) {
                configs[config.name] = config.value;
            }
        });
        return configs;
    };
    /**
     * Get enabled subplugins.
     *
     * @param {any} assign Assignment object including all config.
     * @param {string} subtype  Subtype name (assignsubmission or assignfeedback)
     * @return {any} List of enabled plugins for the assign.
     */
    AddonModAssignHelperProvider.prototype.getPluginsEnabled = function (assign, subtype) {
        var enabled = [];
        assign.configs.forEach(function (config) {
            if (config.subtype == subtype && config.name == 'enabled' && parseInt(config.value, 10) === 1) {
                // Format the plugin objects.
                enabled.push({
                    type: config.plugin
                });
            }
        });
        return enabled;
    };
    /**
     * Get a list of stored submission files. See storeSubmissionFiles.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} folderName Name of the plugin folder. Must be unique (both in submission and feedback plugins).
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    AddonModAssignHelperProvider.prototype.getStoredSubmissionFiles = function (assignId, folderName, userId, siteId) {
        var _this = this;
        return this.assignOffline.getSubmissionPluginFolder(assignId, folderName, userId, siteId).then(function (folderPath) {
            return _this.fileProvider.getDirectoryContents(folderPath);
        });
    };
    /**
     * Get the size that will be uploaded to perform an attempt copy.
     *
     * @param {any} assign Assignment.
     * @param {any} previousSubmission Submission to copy.
     * @return {Promise<number>} Promise resolved with the size.
     */
    AddonModAssignHelperProvider.prototype.getSubmissionSizeForCopy = function (assign, previousSubmission) {
        var _this = this;
        var promises = [];
        var totalSize = 0;
        previousSubmission.plugins.forEach(function (plugin) {
            promises.push(_this.submissionDelegate.getPluginSizeForCopy(assign, plugin).then(function (size) {
                totalSize += size;
            }));
        });
        return Promise.all(promises).then(function () {
            return totalSize;
        });
    };
    /**
     * Get the size that will be uploaded to save a submission.
     *
     * @param {any} assign Assignment.
     * @param {any} submission Submission to check data.
     * @param {any} inputData Data entered in the submission form.
     * @return {Promise<number>} Promise resolved with the size.
     */
    AddonModAssignHelperProvider.prototype.getSubmissionSizeForEdit = function (assign, submission, inputData) {
        var _this = this;
        var promises = [];
        var totalSize = 0;
        submission.plugins.forEach(function (plugin) {
            promises.push(_this.submissionDelegate.getPluginSizeForEdit(assign, submission, plugin, inputData).then(function (size) {
                totalSize += size;
            }));
        });
        return Promise.all(promises).then(function () {
            return totalSize;
        });
    };
    /**
     * Get user data for submissions since they only have userid.
     *
     * @param {any} assign Assignment object.
     * @param {any[]} submissions Submissions to get the data for.
     * @param {number} [groupId] Group Id.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site id (empty for current site).
     * @return {Promise<any[]>} Promise always resolved. Resolve param is the formatted submissions.
     */
    AddonModAssignHelperProvider.prototype.getSubmissionsUserData = function (assign, submissions, groupId, ignoreCache, siteId) {
        var _this = this;
        return this.getParticipants(assign, groupId).then(function (participants) {
            var blind = assign.blindmarking && !assign.revealidentities;
            var promises = [];
            var result = [];
            participants = _this.utils.arrayToObject(participants, 'id');
            submissions.forEach(function (submission) {
                submission.submitid = submission.userid > 0 ? submission.userid : submission.blindid;
                if (submission.submitid <= 0) {
                    return;
                }
                var participant = participants[submission.submitid];
                if (participant) {
                    delete participants[submission.submitid];
                }
                else {
                    // Avoid permission denied error. Participant not found on list.
                    return;
                }
                if (!blind) {
                    submission.userfullname = participant.fullname;
                    submission.userprofileimageurl = participant.profileimageurl;
                }
                submission.manyGroups = !!participant.groups && participant.groups.length > 1;
                submission.noGroups = !!participant.groups && participant.groups.length == 0;
                if (participant.groupname) {
                    submission.groupid = participant.groupid;
                    submission.groupname = participant.groupname;
                }
                var promise;
                if (submission.userid > 0 && blind) {
                    // Blind but not blinded! (Moodle < 3.1.1, 3.2).
                    delete submission.userid;
                    promise = _this.assignProvider.getAssignmentUserMappings(assign.id, submission.submitid, ignoreCache, siteId).
                        then(function (blindId) {
                        submission.blindid = blindId;
                    });
                }
                promise = promise || Promise.resolve();
                promises.push(promise.then(function () {
                    // Add to the list.
                    if (submission.userfullname || submission.blindid) {
                        result.push(submission);
                    }
                }));
            });
            return Promise.all(promises).then(function () {
                // Create a submission for each participant left in the list (the participants already treated were removed).
                _this.utils.objectToArray(participants).forEach(function (participant) {
                    var submission = {
                        submitid: participant.id
                    };
                    if (!blind) {
                        submission.userid = participant.id;
                        submission.userfullname = participant.fullname;
                        submission.userprofileimageurl = participant.profileimageurl;
                    }
                    else {
                        submission.blindid = participant.id;
                    }
                    submission.manyGroups = !!participant.groups && participant.groups.length > 1;
                    submission.noGroups = !!participant.groups && participant.groups.length == 0;
                    if (participant.groupname) {
                        submission.groupid = participant.groupid;
                        submission.groupname = participant.groupname;
                    }
                    submission.status = participant.submitted ? __WEBPACK_IMPORTED_MODULE_9__assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_SUBMITTED :
                        __WEBPACK_IMPORTED_MODULE_9__assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_NEW;
                    result.push(submission);
                });
                return result;
            });
        });
    };
    /**
     * Check if the feedback data has changed for a certain submission and assign.
     *
     * @param {any} assign Assignment.
     * @param {number} userId User Id.
     * @param {any} feedback Feedback data.
     * @return {Promise<boolean>} Promise resolved with true if data has changed, resolved with false otherwise.
     */
    AddonModAssignHelperProvider.prototype.hasFeedbackDataChanged = function (assign, userId, feedback) {
        var _this = this;
        var promises = [];
        var hasChanged = false;
        feedback.plugins.forEach(function (plugin) {
            promises.push(_this.prepareFeedbackPluginData(assign.id, userId, feedback).then(function (inputData) {
                return _this.feedbackDelegate.hasPluginDataChanged(assign, userId, plugin, inputData, userId).then(function (changed) {
                    if (changed) {
                        hasChanged = true;
                    }
                });
            }).catch(function () {
                // Ignore errors.
            }));
        });
        return this.utils.allPromises(promises).then(function () {
            return hasChanged;
        });
    };
    /**
     * Check if the submission data has changed for a certain submission and assign.
     *
     * @param {any} assign Assignment.
     * @param {any} submission Submission to check data.
     * @param {any} inputData Data entered in the submission form.
     * @return {Promise<boolean>} Promise resolved with true if data has changed, resolved with false otherwise.
     */
    AddonModAssignHelperProvider.prototype.hasSubmissionDataChanged = function (assign, submission, inputData) {
        var _this = this;
        var promises = [];
        var hasChanged = false;
        submission.plugins.forEach(function (plugin) {
            promises.push(_this.submissionDelegate.hasPluginDataChanged(assign, submission, plugin, inputData).then(function (changed) {
                if (changed) {
                    hasChanged = true;
                }
            }).catch(function () {
                // Ignore errors.
            }));
        });
        return this.utils.allPromises(promises).then(function () {
            return hasChanged;
        });
    };
    /**
     * Prepare and return the plugin data to send for a certain feedback and assign.
     *
     * @param {number} assignId Assignment Id.
     * @param {number} userId User Id.
     * @param {any} feedback Feedback data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with plugin data to send to server.
     */
    AddonModAssignHelperProvider.prototype.prepareFeedbackPluginData = function (assignId, userId, feedback, siteId) {
        var _this = this;
        var pluginData = {}, promises = [];
        feedback.plugins.forEach(function (plugin) {
            promises.push(_this.feedbackDelegate.preparePluginFeedbackData(assignId, userId, plugin, pluginData, siteId));
        });
        return Promise.all(promises).then(function () {
            return pluginData;
        });
    };
    /**
     * Prepare and return the plugin data to send for a certain submission and assign.
     *
     * @param {any} assign Assignment.
     * @param {any} submission Submission to check data.
     * @param {any} inputData  Data entered in the submission form.
     * @param {boolean} [offline] True to prepare the data for an offline submission, false otherwise.
     * @return {Promise<any>} Promise resolved with plugin data to send to server.
     */
    AddonModAssignHelperProvider.prototype.prepareSubmissionPluginData = function (assign, submission, inputData, offline) {
        var _this = this;
        var pluginData = {}, promises = [];
        submission.plugins.forEach(function (plugin) {
            promises.push(_this.submissionDelegate.preparePluginSubmissionData(assign, submission, plugin, inputData, pluginData, offline));
        });
        return Promise.all(promises).then(function () {
            return pluginData;
        });
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be submitted later.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} folderName Name of the plugin folder. Must be unique (both in submission and feedback plugins).
     * @param {any[]} files List of files.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success, rejected otherwise.
     */
    AddonModAssignHelperProvider.prototype.storeSubmissionFiles = function (assignId, folderName, files, userId, siteId) {
        var _this = this;
        // Get the folder where to store the files.
        return this.assignOffline.getSubmissionPluginFolder(assignId, folderName, userId, siteId).then(function (folderPath) {
            return _this.fileUploaderProvider.storeFilesToUpload(folderPath, files);
        });
    };
    /**
     * Upload a file to a draft area. If the file is an online file it will be downloaded and then re-uploaded.
     *
     * @param {number} assignId Assignment ID.
     * @param {any} file Online file or local FileEntry.
     * @param {number} [itemId] Draft ID to use. Undefined or 0 to create a new draft ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the itemId.
     */
    AddonModAssignHelperProvider.prototype.uploadFile = function (assignId, file, itemId, siteId) {
        return this.fileUploaderProvider.uploadOrReuploadFile(file, itemId, __WEBPACK_IMPORTED_MODULE_9__assign__["a" /* AddonModAssignProvider */].COMPONENT, assignId, siteId);
    };
    /**
     * Given a list of files (either online files or local files), upload them to a draft area and return the draft ID.
     * Online files will be downloaded and then re-uploaded.
     * If there are no files to upload it will return a fake draft ID (1).
     *
     * @param {number} assignId Assignment ID.
     * @param {any[]} files List of files.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the itemId.
     */
    AddonModAssignHelperProvider.prototype.uploadFiles = function (assignId, files, siteId) {
        return this.fileUploaderProvider.uploadOrReuploadFiles(files, __WEBPACK_IMPORTED_MODULE_9__assign__["a" /* AddonModAssignProvider */].COMPONENT, assignId, siteId);
    };
    /**
     * Upload or store some files, depending if the user is offline or not.
     *
     * @param {number} assignId Assignment ID.
     * @param {string} folderName Name of the plugin folder. Must be unique (both in submission and feedback plugins).
     * @param {any[]} files List of files.
     * @param {boolean} offline True if files sould be stored for offline, false to upload them.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignHelperProvider.prototype.uploadOrStoreFiles = function (assignId, folderName, files, offline, userId, siteId) {
        if (offline) {
            return this.storeSubmissionFiles(assignId, folderName, files, userId, siteId);
        }
        else {
            return this.uploadFiles(assignId, files, siteId);
        }
    };
    AddonModAssignHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_9__assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__assign_offline__["a" /* AddonModAssignOfflineProvider */], __WEBPACK_IMPORTED_MODULE_7__feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */],
            __WEBPACK_IMPORTED_MODULE_8__submission_delegate__["a" /* AddonModAssignSubmissionDelegate */], __WEBPACK_IMPORTED_MODULE_6__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */]])
    ], AddonModAssignHelperProvider);
    return AddonModAssignHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 124 */,
/* 125 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserProfileFieldDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_events__ = __webpack_require__(12);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to interact with user profile fields. Provides functions to register a plugin.
 */
var CoreUserProfileFieldDelegate = /** @class */ (function (_super) {
    __extends(CoreUserProfileFieldDelegate, _super);
    function CoreUserProfileFieldDelegate(loggerProvider, sitesProvider, eventsProvider) {
        var _this = _super.call(this, 'CoreUserProfileFieldDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.loggerProvider = loggerProvider;
        _this.sitesProvider = sitesProvider;
        _this.eventsProvider = eventsProvider;
        _this.handlerNameProperty = 'type';
        return _this;
    }
    /**
     * Get the component to use to display an user field.
     *
     * @param {Injector} injector Injector.
     * @param  {any} field      User field to get the directive for.
     * @param  {boolean} signup         True if user is in signup page.
     * @return {Promise<any>} Promise resolved with component to use, undefined if not found.
     */
    CoreUserProfileFieldDelegate.prototype.getComponent = function (injector, field, signup) {
        var _this = this;
        var type = field.type || field.datatype;
        var result;
        if (signup) {
            result = this.executeFunction(type, 'getComponent', [injector]);
        }
        else {
            result = this.executeFunctionOnEnabled(type, 'getComponent', [injector]);
        }
        return Promise.resolve(result).catch(function (err) {
            _this.logger.error('Error getting component for field', type, err);
        });
    };
    /**
     * Get the data to send for a certain field based on the input data.
     *
     * @param  {any}     field          User field to get the data for.
     * @param  {boolean} signup         True if user is in signup page.
     * @param  {string}  registerAuth   Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form values.
     * @return {Promise<any>}           Data to send for the field.
     */
    CoreUserProfileFieldDelegate.prototype.getDataForField = function (field, signup, registerAuth, formValues) {
        var type = field.type || field.datatype, handler = this.getHandler(type, !signup);
        if (handler) {
            var name_1 = 'profile_field_' + field.shortname;
            if (handler.getData) {
                return Promise.resolve(handler.getData(field, signup, registerAuth, formValues));
            }
            else if (field.shortname && typeof formValues[name_1] != 'undefined') {
                // Handler doesn't implement the function, but the form has data for the field.
                return Promise.resolve({
                    type: type,
                    name: name_1,
                    value: formValues[name_1]
                });
            }
        }
        return Promise.reject(null);
    };
    /**
     * Get the data to send for a list of fields based on the input data.
     *
     * @param  {any[]}   fields           User fields to get the data for.
     * @param  {boolean} [signup]       True if user is in signup page.
     * @param  {string}  [registerAuth] Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form values.
     * @return {Promise<any>}           Data to send.
     */
    CoreUserProfileFieldDelegate.prototype.getDataForFields = function (fields, signup, registerAuth, formValues) {
        var _this = this;
        if (signup === void 0) { signup = false; }
        if (registerAuth === void 0) { registerAuth = ''; }
        var result = [], promises = [];
        if (!fields) {
            return Promise.resolve([]);
        }
        fields.forEach(function (field) {
            promises.push(_this.getDataForField(field, signup, registerAuth, formValues).then(function (data) {
                if (data) {
                    result.push(data);
                }
            }).catch(function () {
                // Ignore errors.
            }));
        });
        return Promise.all(promises).then(function () {
            return result;
        });
    };
    CoreUserProfileFieldDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreUserProfileFieldDelegate);
    return CoreUserProfileFieldDelegate;
}(__WEBPACK_IMPORTED_MODULE_1__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=user-profile-field-delegate.js.map

/***/ }),
/* 126 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsPluginContentComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};





/**
 * Component to render a site plugin content.
 */
var CoreSitePluginsPluginContentComponent = /** @class */ (function () {
    function CoreSitePluginsPluginContentComponent(domUtils, sitePluginsProvider, navCtrl, differs) {
        this.domUtils = domUtils;
        this.sitePluginsProvider = sitePluginsProvider;
        this.navCtrl = navCtrl;
        this.onContentLoaded = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.onLoadingContent = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.invalidateObservable = new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Subject"]();
        this.differ = differs.find([]).create();
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsPluginContentComponent.prototype.ngOnInit = function () {
        this.fetchContent();
    };
    /**
     * Detect and act upon changes that Angular can’t or won’t detect on its own (objects and arrays).
     */
    CoreSitePluginsPluginContentComponent.prototype.ngDoCheck = function () {
        if (!this.data || !this.jsData) {
            return;
        }
        // Check if there's any change in the data object.
        var changes = this.differ.diff(this.data);
        if (changes) {
            this.jsData = Object.assign(this.jsData, this.data);
        }
    };
    /**
     * Fetches the content to render.
     *
     * @param {boolean} [refresh] Whether the user is refreshing.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsPluginContentComponent.prototype.fetchContent = function (refresh) {
        var _this = this;
        this.onLoadingContent.emit(refresh);
        this.forceCompile = false;
        return this.sitePluginsProvider.getContent(this.component, this.method, this.args, this.preSets).then(function (result) {
            _this.content = result.templates.length ? result.templates[0].html : ''; // Load first template.
            _this.javascript = result.javascript;
            _this.otherData = result.otherdata;
            _this.data = _this.data || {};
            _this.forceCompile = true;
            _this.jsData = Object.assign(_this.data, _this.sitePluginsProvider.createDataForJS(_this.initResult, result));
            // Pass some methods as jsData so they can be called from the template too.
            _this.jsData.openContent = _this.openContent.bind(_this);
            _this.jsData.refreshContent = _this.refreshContent.bind(_this);
            _this.jsData.updateContent = _this.updateContent.bind(_this);
            _this.onContentLoaded.emit(refresh);
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.errorloadingcontent', true);
        }).finally(function () {
            _this.dataLoaded = true;
            _this.content = _this.content.replace('window.open', 'window.cordova.InAppBrowser.open');
        });
    };
    /**
     * Open a new page with a new content.
     *
     * @param {string} title The title to display with the new content.
     * @param {any} args New params.
     * @param {string} [component] New component. If not provided, current component
     * @param {string} [method] New method. If not provided, current method
     * @param {any} [jsData] JS variables to pass to the new view so they can be used in the template or JS.
     *                       If true is supplied instead of an object, all initial variables from current page will be copied.
     * @param {any} [preSets] The preSets for the WS call of the new content.
     */
    CoreSitePluginsPluginContentComponent.prototype.openContent = function (title, args, component, method, jsData, preSets) {
        if (jsData === true) {
            jsData = this.data;
        }
        this.navCtrl.push('CoreSitePluginsPluginPage', {
            title: title,
            component: component || this.component,
            method: method || this.method,
            args: args,
            initResult: this.initResult,
            jsData: jsData,
            preSets: preSets
        });
    };
    /**
     * Refresh the data.
     *
     * @param {boolean} [showSpinner=true] Whether to show spinner while refreshing.
     */
    CoreSitePluginsPluginContentComponent.prototype.refreshContent = function (showSpinner) {
        var _this = this;
        if (showSpinner === void 0) { showSpinner = true; }
        if (showSpinner) {
            this.dataLoaded = false;
        }
        this.invalidateObservable.next(); // Notify observers.
        return this.sitePluginsProvider.invalidateContent(this.component, this.method, this.args).finally(function () {
            return _this.fetchContent(true);
        });
    };
    /**
     * Update the content, usually with a different method or params.
     *
     * @param {any} args New params.
     * @param {string} [component] New component. If not provided, current component
     * @param {string} [method] New method. If not provided, current method
     * @param {string} [jsData] JS variables to pass to the new view so they can be used in the template or JS.
     */
    CoreSitePluginsPluginContentComponent.prototype.updateContent = function (args, component, method, jsData) {
        this.component = component || this.component;
        this.method = method || this.method;
        this.args = args;
        this.dataLoaded = false;
        if (jsData) {
            Object.assign(this.data, jsData);
        }
        this.fetchContent();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('compile'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreSitePluginsPluginContentComponent.prototype, "compileComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsPluginContentComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsPluginContentComponent.prototype, "method", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsPluginContentComponent.prototype, "args", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsPluginContentComponent.prototype, "initResult", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsPluginContentComponent.prototype, "data", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsPluginContentComponent.prototype, "preSets", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsPluginContentComponent.prototype, "onContentLoaded", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsPluginContentComponent.prototype, "onLoadingContent", void 0);
    CoreSitePluginsPluginContentComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-plugin-content',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\plugin-content\core-siteplugins-plugin-content.html"*/'<core-loading [hideUntil]="dataLoaded">\n    <core-compile-html [text]="content" [javascript]="javascript" [jsData]="jsData" [forceCompile]="forceCompile" #compile></core-compile-html>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\plugin-content\core-siteplugins-plugin-content.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_siteplugins__["a" /* CoreSitePluginsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["KeyValueDiffers"]])
    ], CoreSitePluginsPluginContentComponent);
    return CoreSitePluginsPluginContentComponent;
}());

//# sourceMappingURL=plugin-content.js.map

/***/ }),
/* 127 */,
/* 128 */,
/* 129 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonWorkshopAssessmentStrategyDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Delegate to register workshop assessment strategy handlers.
 * You can use this service to register your own assessment strategy handlers to be used in a workshop.
 */
var AddonWorkshopAssessmentStrategyDelegate = /** @class */ (function (_super) {
    __extends(AddonWorkshopAssessmentStrategyDelegate, _super);
    function AddonWorkshopAssessmentStrategyDelegate(loggerProvider, sitesProvider, eventsProvider) {
        var _this = _super.call(this, 'AddonWorkshopAssessmentStrategyDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.loggerProvider = loggerProvider;
        _this.sitesProvider = sitesProvider;
        _this.eventsProvider = eventsProvider;
        _this.handlerNameProperty = 'strategyName';
        return _this;
    }
    /**
     * Check if an assessment strategy plugin is supported.
     *
     * @param  {string} workshopStrategy Assessment strategy name.
     * @return {boolean}                 True if supported, false otherwise.
     */
    AddonWorkshopAssessmentStrategyDelegate.prototype.isPluginSupported = function (workshopStrategy) {
        return this.hasHandler(workshopStrategy, true);
    };
    /**
     * Get the directive to use for a certain assessment strategy plugin.
     *
     * @param {Injector} injector Injector.
     * @param  {string} workshopStrategy Assessment strategy name.
     * @return {any}                     The component, undefined if not found.
     */
    AddonWorkshopAssessmentStrategyDelegate.prototype.getComponentForPlugin = function (injector, workshopStrategy) {
        return this.executeFunctionOnEnabled(workshopStrategy, 'getComponent', [injector]);
    };
    /**
     * Prepare original values to be shown and compared depending on the strategy selected.
     *
     * @param  {string} workshopStrategy Workshop strategy.
     * @param  {any}    form             Original data of the form.
     * @param  {number} workshopId       Workshop ID.
     * @return {Promise<any[]>}          Resolved with original values sorted.
     */
    AddonWorkshopAssessmentStrategyDelegate.prototype.getOriginalValues = function (workshopStrategy, form, workshopId) {
        return Promise.resolve(this.executeFunctionOnEnabled(workshopStrategy, 'getOriginalValues', [form, workshopId]) || []);
    };
    /**
     * Check if the assessment data has changed for a certain submission and workshop for a this strategy plugin.
     *
     * @param  {any}   workshop       Workshop.
     * @param  {any[]} originalValues Original values of the form.
     * @param  {any[]} currentValues  Current values of the form.
     * @return {boolean}              True if data has changed, false otherwise.
     */
    AddonWorkshopAssessmentStrategyDelegate.prototype.hasDataChanged = function (workshop, originalValues, currentValues) {
        return this.executeFunctionOnEnabled(workshop.strategy, 'hasDataChanged', [originalValues, currentValues]) || false;
    };
    /**
     * Prepare assessment data to be sent to the server depending on the strategy selected.
     *
     * @param  {string} workshopStrategy Workshop strategy to follow.
     * @param  {any{}}  currentValues    Current values of the form.
     * @param  {any}    form             Assessment form data.
     * @return {Promise<any>}            Promise resolved with the data to be sent. Or rejected with the input errors object.
     */
    AddonWorkshopAssessmentStrategyDelegate.prototype.prepareAssessmentData = function (workshopStrategy, currentValues, form) {
        return Promise.resolve(this.executeFunctionOnEnabled(workshopStrategy, 'prepareAssessmentData', [currentValues, form]));
    };
    AddonWorkshopAssessmentStrategyDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */]])
    ], AddonWorkshopAssessmentStrategyDelegate);
    return AddonWorkshopAssessmentStrategyDelegate;
}(__WEBPACK_IMPORTED_MODULE_1__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=assessment-strategy-delegate.js.map

/***/ }),
/* 130 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsBaseHandler; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Super class for handlers for site plugins.
 */
var CoreSitePluginsBaseHandler = /** @class */ (function () {
    function CoreSitePluginsBaseHandler(name) {
        this.name = name;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    CoreSitePluginsBaseHandler.prototype.isEnabled = function () {
        return true;
    };
    return CoreSitePluginsBaseHandler;
}());

//# sourceMappingURL=base-handler.js.map

/***/ }),
/* 131 */,
/* 132 */,
/* 133 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle offline workshop.
 */
var AddonModWorkshopOfflineProvider = /** @class */ (function () {
    function AddonModWorkshopOfflineProvider(fileProvider, sitesProvider, textUtils, timeUtils) {
        this.fileProvider = fileProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.timeUtils = timeUtils;
        this.siteSchema = {
            name: 'AddonModWorkshopOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE,
                    columns: [
                        {
                            name: 'workshopid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'submissionid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'action',
                            type: 'TEXT',
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'title',
                            type: 'TEXT',
                        },
                        {
                            name: 'content',
                            type: 'TEXT',
                        },
                        {
                            name: 'attachmentsid',
                            type: 'TEXT',
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER',
                        }
                    ],
                    primaryKeys: ['workshopid', 'submissionid', 'action']
                },
                {
                    name: AddonModWorkshopOfflineProvider_1.ASSESSMENTS_TABLE,
                    columns: [
                        {
                            name: 'workshopid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'assessmentid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'inputdata',
                            type: 'TEXT',
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER',
                        },
                    ],
                    primaryKeys: ['workshopid', 'assessmentid']
                },
                {
                    name: AddonModWorkshopOfflineProvider_1.EVALUATE_SUBMISSIONS_TABLE,
                    columns: [
                        {
                            name: 'workshopid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'submissionid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER',
                        },
                        {
                            name: 'feedbacktext',
                            type: 'TEXT',
                        },
                        {
                            name: 'published',
                            type: 'INTEGER',
                        },
                        {
                            name: 'gradeover',
                            type: 'TEXT',
                        },
                    ],
                    primaryKeys: ['workshopid', 'submissionid']
                },
                {
                    name: AddonModWorkshopOfflineProvider_1.EVALUATE_ASSESSMENTS_TABLE,
                    columns: [
                        {
                            name: 'workshopid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'assessmentid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER',
                        },
                        {
                            name: 'feedbacktext',
                            type: 'TEXT',
                        },
                        {
                            name: 'weight',
                            type: 'INTEGER',
                        },
                        {
                            name: 'gradinggradeover',
                            type: 'TEXT',
                        },
                    ],
                    primaryKeys: ['workshopid', 'assessmentid']
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModWorkshopOfflineProvider_1 = AddonModWorkshopOfflineProvider;
    /**
     * Get all the workshops ids that have something to be synced.
     *
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<number[]>} Promise resolved with workshops id that have something to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getAllWorkshops = function (siteId) {
        var promises = [
            this.getAllSubmissions(siteId),
            this.getAllAssessments(siteId),
            this.getAllEvaluateSubmissions(siteId),
            this.getAllEvaluateAssessments(siteId)
        ];
        return Promise.all(promises).then(function (promiseResults) {
            var workshopIds = {};
            // Get workshops from any offline object all should have workshopid.
            promiseResults.forEach(function (offlineObjects) {
                offlineObjects.forEach(function (offlineObject) {
                    workshopIds[offlineObject.workshopid] = true;
                });
            });
            return Object.keys(workshopIds).map(function (workshopId) { return parseInt(workshopId, 10); });
        });
    };
    /**
     * Check if there is an offline data to be synced.
     *
     * @param  {number} workshopId Workshop ID to remove.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<boolean>}  Promise resolved with boolean: true if has offline data, false otherwise.
     */
    AddonModWorkshopOfflineProvider.prototype.hasWorkshopOfflineData = function (workshopId, siteId) {
        var promises = [
            this.getSubmissions(workshopId, siteId),
            this.getAssessments(workshopId, siteId),
            this.getEvaluateSubmissions(workshopId, siteId),
            this.getEvaluateAssessments(workshopId, siteId)
        ];
        return Promise.all(promises).then(function (results) {
            return results.some(function (result) { return result && result.length; });
        }).catch(function () {
            // No offline data found.
            return false;
        });
    };
    /**
     * Delete workshop submission action.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {string} action       Action to be done.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if stored, rejected if failure.
     */
    AddonModWorkshopOfflineProvider.prototype.deleteSubmissionAction = function (workshopId, submissionId, action, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                submissionid: submissionId,
                action: action
            };
            return site.getDb().deleteRecords(AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE, conditions);
        });
    };
    /**
     * Delete all workshop submission actions.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if stored, rejected if failure.
     */
    AddonModWorkshopOfflineProvider.prototype.deleteAllSubmissionActions = function (workshopId, submissionId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                submissionid: submissionId,
            };
            return site.getDb().deleteRecords(AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE, conditions);
        });
    };
    /**
     * Get the all the submissions to be synced.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with the objects to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getAllSubmissions = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE).then(function (records) {
                records.forEach(_this.parseSubmissionRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get the submissions of a workshop to be synced.
     *
     * @param  {number} workshopId ID of the workshop.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getSubmissions = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId
            };
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE, conditions).then(function (records) {
                records.forEach(_this.parseSubmissionRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get all actions of a submission of a workshop to be synced.
     *
     * @param  {number} workshopId   ID of the workshop.
     * @param  {number} submissionId ID of the submission.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any[]>}      Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getSubmissionActions = function (workshopId, submissionId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                submissionid: submissionId
            };
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE, conditions).then(function (records) {
                records.forEach(_this.parseSubmissionRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get an specific action of a submission of a workshop to be synced.
     *
     * @param  {number} workshopId   ID of the workshop.
     * @param  {number} submissionId ID of the submission.
     * @param  {string} action       Action to be done.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getSubmissionAction = function (workshopId, submissionId, action, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                submissionid: submissionId,
                action: action
            };
            return site.getDb().getRecord(AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE, conditions).then(function (record) {
                _this.parseSubmissionRecord(record);
                return record;
            });
        });
    };
    /**
     * Offline version for adding a submission action to a workshop.
     *
     * @param  {number} workshopId    Workshop ID.
     * @param  {number} courseId      Course ID the workshop belongs to.
     * @param  {string} title         The submission title.
     * @param  {string} content       The submission text content.
     * @param  {any}    attachmentsId Stored attachments.
     * @param  {number} submissionId  Submission Id, if action is add, the time the submission was created.
     *                                If set to 0, current time is used.
     * @param  {string} action        Action to be done. ['add', 'update', 'delete']
     * @param  {string} [siteId]      Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when submission action is successfully saved.
     */
    AddonModWorkshopOfflineProvider.prototype.saveSubmission = function (workshopId, courseId, title, content, attachmentsId, submissionId, action, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var timemodified = _this.timeUtils.timestamp();
            var assessment = {
                workshopid: workshopId,
                courseid: courseId,
                title: title,
                content: content,
                attachmentsid: JSON.stringify(attachmentsId),
                action: action,
                submissionid: submissionId ? submissionId : -timemodified,
                timemodified: timemodified
            };
            return site.getDb().insertRecord(AddonModWorkshopOfflineProvider_1.SUBMISSIONS_TABLE, assessment);
        });
    };
    /**
     * Parse "attachments" column of a submission record.
     *
     * @param  {any} record Submission record, modified in place.
     */
    AddonModWorkshopOfflineProvider.prototype.parseSubmissionRecord = function (record) {
        record.attachmentsid = this.textUtils.parseJSON(record.attachmentsid);
    };
    /**
     * Delete workshop assessment.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if stored, rejected if failure.
     */
    AddonModWorkshopOfflineProvider.prototype.deleteAssessment = function (workshopId, assessmentId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                assessmentid: assessmentId
            };
            return site.getDb().deleteRecords(AddonModWorkshopOfflineProvider_1.ASSESSMENTS_TABLE, conditions);
        });
    };
    /**
     * Get the all the assessments to be synced.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with the objects to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getAllAssessments = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.ASSESSMENTS_TABLE).then(function (records) {
                records.forEach(_this.parseAssessmentRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get the assessments of a workshop to be synced.
     *
     * @param  {number} workshopId ID of the workshop.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}    Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getAssessments = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId
            };
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.ASSESSMENTS_TABLE, conditions).then(function (records) {
                records.forEach(_this.parseAssessmentRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get an specific assessment of a workshop to be synced.
     *
     * @param  {number} workshopId   ID of the workshop.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getAssessment = function (workshopId, assessmentId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                assessmentid: assessmentId
            };
            return site.getDb().getRecord(AddonModWorkshopOfflineProvider_1.ASSESSMENTS_TABLE, conditions).then(function (record) {
                _this.parseAssessmentRecord(record);
                return record;
            });
        });
    };
    /**
     * Offline version for adding an assessment to a workshop.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {number} courseId     Course ID the workshop belongs to.
     * @param  {any}    inputData    Assessment data.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when assessment is successfully saved.
     */
    AddonModWorkshopOfflineProvider.prototype.saveAssessment = function (workshopId, assessmentId, courseId, inputData, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var assessment = {
                workshopid: workshopId,
                courseid: courseId,
                inputdata: JSON.stringify(inputData),
                assessmentid: assessmentId,
                timemodified: _this.timeUtils.timestamp()
            };
            return site.getDb().insertRecord(AddonModWorkshopOfflineProvider_1.ASSESSMENTS_TABLE, assessment);
        });
    };
    /**
     * Parse "inpudata" column of an assessment record.
     *
     * @param {any} record Assessnent record, modified in place.
     */
    AddonModWorkshopOfflineProvider.prototype.parseAssessmentRecord = function (record) {
        record.inputdata = this.textUtils.parseJSON(record.inputdata);
    };
    /**
     * Delete workshop evaluate submission.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if stored, rejected if failure.
     */
    AddonModWorkshopOfflineProvider.prototype.deleteEvaluateSubmission = function (workshopId, submissionId, siteId) {
        var conditions = {
            workshopid: workshopId,
            submissionid: submissionId
        };
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModWorkshopOfflineProvider_1.EVALUATE_SUBMISSIONS_TABLE, conditions);
        });
    };
    /**
     * Get the all the evaluate submissions to be synced.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with the objects to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getAllEvaluateSubmissions = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.EVALUATE_SUBMISSIONS_TABLE).then(function (records) {
                records.forEach(_this.parseEvaluateSubmissionRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get the evaluate submissions of a workshop to be synced.
     *
     * @param  {number} workshopId ID of the workshop.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}    Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getEvaluateSubmissions = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId
            };
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.EVALUATE_SUBMISSIONS_TABLE, conditions)
                .then(function (records) {
                records.forEach(_this.parseEvaluateSubmissionRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get an specific evaluate submission of a workshop to be synced.
     *
     * @param  {number} workshopId   ID of the workshop.
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getEvaluateSubmission = function (workshopId, submissionId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                submissionid: submissionId
            };
            return site.getDb().getRecord(AddonModWorkshopOfflineProvider_1.EVALUATE_SUBMISSIONS_TABLE, conditions).then(function (record) {
                _this.parseEvaluateSubmissionRecord(record);
                return record;
            });
        });
    };
    /**
     * Offline version for evaluation a submission to a workshop.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId Submission ID.
     * @param  {number}  courseId     Course ID the workshop belongs to.
     * @param  {string}  feedbackText The feedback for the author.
     * @param  {boolean} published    Whether to publish the submission for other users.
     * @param  {any}     gradeOver    The new submission grade (empty for no overriding the grade).
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when submission evaluation is successfully saved.
     */
    AddonModWorkshopOfflineProvider.prototype.saveEvaluateSubmission = function (workshopId, submissionId, courseId, feedbackText, published, gradeOver, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var submission = {
                workshopid: workshopId,
                courseid: courseId,
                submissionid: submissionId,
                timemodified: _this.timeUtils.timestamp(),
                feedbacktext: feedbackText,
                published: Number(published),
                gradeover: JSON.stringify(gradeOver)
            };
            return site.getDb().insertRecord(AddonModWorkshopOfflineProvider_1.EVALUATE_SUBMISSIONS_TABLE, submission);
        });
    };
    /**
     * Parse "published" and "gradeover" columns of an evaluate submission record.
     *
     * @param  {any} record Evaluate submission record, modified in place.
     */
    AddonModWorkshopOfflineProvider.prototype.parseEvaluateSubmissionRecord = function (record) {
        record.published = Boolean(record.published);
        record.gradeover = this.textUtils.parseJSON(record.gradeover);
    };
    /**
     * Delete workshop evaluate assessment.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if stored, rejected if failure.
     */
    AddonModWorkshopOfflineProvider.prototype.deleteEvaluateAssessment = function (workshopId, assessmentId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                assessmentid: assessmentId
            };
            return site.getDb().deleteRecords(AddonModWorkshopOfflineProvider_1.EVALUATE_ASSESSMENTS_TABLE, conditions);
        });
    };
    /**
     * Get the all the evaluate assessments to be synced.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with the objects to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getAllEvaluateAssessments = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.EVALUATE_ASSESSMENTS_TABLE).then(function (records) {
                records.forEach(_this.parseEvaluateAssessmentRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get the evaluate assessments of a workshop to be synced.
     *
     * @param  {number} workshopId ID of the workshop.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}    Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getEvaluateAssessments = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId
            };
            return site.getDb().getRecords(AddonModWorkshopOfflineProvider_1.EVALUATE_ASSESSMENTS_TABLE, conditions)
                .then(function (records) {
                records.forEach(_this.parseEvaluateAssessmentRecord.bind(_this));
                return records;
            });
        });
    };
    /**
     * Get an specific evaluate assessment of a workshop to be synced.
     *
     * @param  {number} workshopId   ID of the workshop.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the object to be synced.
     */
    AddonModWorkshopOfflineProvider.prototype.getEvaluateAssessment = function (workshopId, assessmentId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                workshopid: workshopId,
                assessmentid: assessmentId
            };
            return site.getDb().getRecord(AddonModWorkshopOfflineProvider_1.EVALUATE_ASSESSMENTS_TABLE, conditions).then(function (record) {
                _this.parseEvaluateAssessmentRecord(record);
                return record;
            });
        });
    };
    /**
     * Offline version for evaluating an assessment to a workshop.
     *
     * @param  {number}  workshopId       Workshop ID.
     * @param  {number}  assessmentId     Assessment ID.
     * @param  {number}  courseId         Course ID the workshop belongs to.
     * @param  {string}  feedbackText     The feedback for the reviewer.
     * @param  {number}  weight           The new weight for the assessment.
     * @param  {any}     gradingGradeOver The new grading grade (empty for no overriding the grade).
     * @param  {string}  [siteId]         Site ID. If not defined, current site.
     * @return {Promise<any>}             Promise resolved when assessment evaluation is successfully saved.
     */
    AddonModWorkshopOfflineProvider.prototype.saveEvaluateAssessment = function (workshopId, assessmentId, courseId, feedbackText, weight, gradingGradeOver, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var assessment = {
                workshopid: workshopId,
                courseid: courseId,
                assessmentid: assessmentId,
                timemodified: _this.timeUtils.timestamp(),
                feedbacktext: feedbackText,
                weight: weight,
                gradinggradeover: JSON.stringify(gradingGradeOver)
            };
            return site.getDb().insertRecord(AddonModWorkshopOfflineProvider_1.EVALUATE_ASSESSMENTS_TABLE, assessment);
        });
    };
    /**
     * Parse "gradinggradeover" column of an evaluate assessment record.
     *
     * @param  {any} record Evaluate assessment record, modified in place.
     */
    AddonModWorkshopOfflineProvider.prototype.parseEvaluateAssessmentRecord = function (record) {
        record.gradinggradeover = this.textUtils.parseJSON(record.gradinggradeover);
    };
    /**
     * Get the path to the folder where to store files for offline attachments in a workshop.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<string>}   Promise resolved with the path.
     */
    AddonModWorkshopOfflineProvider.prototype.getWorkshopFolder = function (workshopId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var siteFolderPath = _this.fileProvider.getSiteFolder(site.getId());
            var workshopFolderPath = 'offlineworkshop/' + workshopId + '/';
            return _this.textUtils.concatenatePaths(siteFolderPath, workshopFolderPath);
        });
    };
    /**
     * Get the path to the folder where to store files for offline submissions.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId If not editing, it will refer to timecreated.
     * @param  {boolean} editing      If the submission is being edited or added otherwise.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<string>}      Promise resolved with the path.
     */
    AddonModWorkshopOfflineProvider.prototype.getSubmissionFolder = function (workshopId, submissionId, editing, siteId) {
        var _this = this;
        return this.getWorkshopFolder(workshopId, siteId).then(function (folderPath) {
            folderPath += 'submission/';
            var folder = editing ? 'update_' + submissionId : 'add';
            return _this.textUtils.concatenatePaths(folderPath, folder);
        });
    };
    /**
     * Get the path to the folder where to store files for offline assessment.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  assessmentId Assessment ID.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<string>}      Promise resolved with the path.
     */
    AddonModWorkshopOfflineProvider.prototype.getAssessmentFolder = function (workshopId, assessmentId, siteId) {
        var _this = this;
        return this.getWorkshopFolder(workshopId, siteId).then(function (folderPath) {
            folderPath += 'assessment/';
            return _this.textUtils.concatenatePaths(folderPath, String(assessmentId));
        });
    };
    // Variables for database.
    AddonModWorkshopOfflineProvider.SUBMISSIONS_TABLE = 'addon_mod_workshop_submissions';
    AddonModWorkshopOfflineProvider.ASSESSMENTS_TABLE = 'addon_mod_workshop_assessments';
    AddonModWorkshopOfflineProvider.EVALUATE_SUBMISSIONS_TABLE = 'addon_mod_workshop_evaluate_submissions';
    AddonModWorkshopOfflineProvider.EVALUATE_ASSESSMENTS_TABLE = 'addon_mod_workshop_evaluate_assessments';
    AddonModWorkshopOfflineProvider = AddonModWorkshopOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonModWorkshopOfflineProvider);
    return AddonModWorkshopOfflineProvider;
    var AddonModWorkshopOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 134 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCommentsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Service that provides some features regarding comments.
 */
var CoreCommentsProvider = /** @class */ (function () {
    function CoreCommentsProvider(sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.ROOT_CACHE_KEY = 'mmComments:';
    }
    /**
     * Check if Calendar is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreCommentsProvider.prototype.areCommentsDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('NoDelegate_CoreComments');
    };
    /**
     * Check if comments are disabled in a certain site.
     *
     * @param  {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreCommentsProvider.prototype.areCommentsDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.areCommentsDisabledInSite(site);
        });
    };
    /**
     * Get cache key for get comments data WS calls.
     *
     * @param  {string} contextLevel Contextlevel system, course, user...
     * @param  {number} instanceId   The Instance id of item associated with the context level.
     * @param  {string} component    Component name.
     * @param  {number} itemId       Associated id.
     * @param  {string} [area='']    String comment area. Default empty.
     * @param  {number} [page=0]     Page number (0 based). Default 0.
     * @return {string} Cache key.
     */
    CoreCommentsProvider.prototype.getCommentsCacheKey = function (contextLevel, instanceId, component, itemId, area, page) {
        if (area === void 0) { area = ''; }
        if (page === void 0) { page = 0; }
        return this.getCommentsPrefixCacheKey(contextLevel, instanceId) + ':' + component + ':' + itemId + ':' + area + ':' + page;
    };
    /**
     * Get cache key for get comments instance data WS calls.
     *
     * @param  {string} contextLevel Contextlevel system, course, user...
     * @param  {number} instanceId   The Instance id of item associated with the context level.
     * @return {string} Cache key.
     */
    CoreCommentsProvider.prototype.getCommentsPrefixCacheKey = function (contextLevel, instanceId) {
        return this.ROOT_CACHE_KEY + 'comments:' + contextLevel + ':' + instanceId;
    };
    /**
     * Retrieve a list of comments.
     *
     * @param  {string} contextLevel Contextlevel system, course, user...
     * @param  {number} instanceId   The Instance id of item associated with the context level.
     * @param  {string} component    Component name.
     * @param  {number} itemId       Associated id.
     * @param  {string} [area='']    String comment area. Default empty.
     * @param  {number} [page=0]     Page number (0 based). Default 0.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the comments.
     */
    CoreCommentsProvider.prototype.getComments = function (contextLevel, instanceId, component, itemId, area, page, siteId) {
        var _this = this;
        if (area === void 0) { area = ''; }
        if (page === void 0) { page = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                contextlevel: contextLevel,
                instanceid: instanceId,
                component: component,
                itemid: itemId,
                area: area,
                page: page,
            };
            var preSets = {
                cacheKey: _this.getCommentsCacheKey(contextLevel, instanceId, component, itemId, area, page),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('core_comment_get_comments', params, preSets).then(function (response) {
                if (response.comments) {
                    return response.comments;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidates comments data.
     *
     * @param  {string} contextLevel Contextlevel system, course, user...
     * @param  {number} instanceId   The Instance id of item associated with the context level.
     * @param  {string} component    Component name.
     * @param  {number} itemId       Associated id.
     * @param  {string} [area='']    String comment area. Default empty.
     * @param  {number} [page=0]     Page number (0 based). Default 0.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCommentsProvider.prototype.invalidateCommentsData = function (contextLevel, instanceId, component, itemId, area, page, siteId) {
        var _this = this;
        if (area === void 0) { area = ''; }
        if (page === void 0) { page = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCommentsCacheKey(contextLevel, instanceId, component, itemId, area, page));
        });
    };
    /**
     * Invalidates all comments data for an instance.
     *
     * @param  {string} contextLevel Contextlevel system, course, user...
     * @param  {number} instanceId   The Instance id of item associated with the context level.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCommentsProvider.prototype.invalidateCommentsByInstance = function (contextLevel, instanceId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getCommentsPrefixCacheKey(contextLevel, instanceId));
        });
    };
    CoreCommentsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreCommentsProvider);
    return CoreCommentsProvider;
}());

//# sourceMappingURL=comments.js.map

/***/ }),
/* 135 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreWSProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_common_http__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_transfer__ = __webpack_require__(251);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__classes_interceptor__ = __webpack_require__(344);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * This service allows performing WS calls and download/upload files.
 */
var CoreWSProvider = /** @class */ (function () {
    function CoreWSProvider(http, translate, appProvider, textUtils, logger, fileProvider, fileTransfer, commonHttp, mimeUtils) {
        this.http = http;
        this.translate = translate;
        this.appProvider = appProvider;
        this.textUtils = textUtils;
        this.fileProvider = fileProvider;
        this.fileTransfer = fileTransfer;
        this.commonHttp = commonHttp;
        this.mimeUtils = mimeUtils;
        this.mimeTypeCache = {}; // A "cache" to store file mimetypes to prevent performing too many HEAD requests.
        this.ongoingCalls = {};
        this.retryCalls = [];
        this.retryTimeout = 0;
        this.logger = logger.getInstance('CoreWSProvider');
    }
    /**
     * Adds the call data to an special queue to be processed when retrying.
     *
     * @param {string} method The WebService method to be called.
     * @param {string} siteUrl Complete site url to perform the call.
     * @param {any} ajaxData Arguments to pass to the method.
     * @param {CoreWSPreSets} preSets Extra settings and information.
     * @return {Promise<any>} Deferred promise resolved with the response data in success and rejected with the error message
     *                        if it fails.
     */
    CoreWSProvider.prototype.addToRetryQueue = function (method, siteUrl, ajaxData, preSets) {
        var call = {
            method: method,
            siteUrl: siteUrl,
            ajaxData: ajaxData,
            preSets: preSets,
            deferred: {}
        };
        call.deferred.promise = new Promise(function (resolve, reject) {
            call.deferred.resolve = resolve;
            call.deferred.reject = reject;
        });
        this.retryCalls.push(call);
        return call.deferred.promise;
    };
    /**
     * A wrapper function for a moodle WebService call.
     *
     * @param {string} method The WebService method to be called.
     * @param {any} data Arguments to pass to the method. It's recommended to call convertValuesToString before passing the data.
     * @param {CoreWSPreSets} preSets Extra settings and information.
     * @return {Promise<any>} Promise resolved with the response data in success and rejected if it fails.
     */
    CoreWSProvider.prototype.call = function (method, data, preSets) {
        var siteUrl;
        if (!preSets) {
            return Promise.reject(this.createFakeWSError('core.unexpectederror', true));
        }
        else if (!this.appProvider.isOnline()) {
            return Promise.reject(this.createFakeWSError('core.networkerrormsg', true));
        }
        preSets.typeExpected = preSets.typeExpected || 'object';
        if (typeof preSets.responseExpected == 'undefined') {
            preSets.responseExpected = true;
        }
        data = Object.assign({}, data); // Create a new object so the changes don't affect the original data.
        data.wsfunction = method;
        data.wstoken = preSets.wsToken;
        siteUrl = preSets.siteUrl + '/webservice/rest/server.php?moodlewsrestformat=json';
        // There are some ongoing retry calls, wait for timeout.
        if (this.retryCalls.length > 0) {
            this.logger.warn('Calls locked, trying later...');
            return this.addToRetryQueue(method, siteUrl, data, preSets);
        }
        else {
            return this.performPost(method, siteUrl, data, preSets);
        }
    };
    /**
     * Call a Moodle WS using the AJAX API. Please use it if the WS layer is not an option.
     *
     * @param {string} method The WebService method to be called.
     * @param {any} data Arguments to pass to the method.
     * @param {CoreWSAjaxPreSets} preSets Extra settings and information. Only some
     * @return {Promise<any>} Promise resolved with the response data in success and rejected with an object containing:
     *                                 - error: Error message.
     *                                 - errorcode: Error code returned by the site (if any).
     *                                 - available: 0 if unknown, 1 if available, -1 if not available.
     */
    CoreWSProvider.prototype.callAjax = function (method, data, preSets) {
        var _this = this;
        var siteUrl, ajaxData;
        if (typeof preSets.siteUrl == 'undefined') {
            return rejectWithError(this.createFakeWSError('core.unexpectederror', true));
        }
        else if (!this.appProvider.isOnline()) {
            return rejectWithError(this.createFakeWSError('core.networkerrormsg', true));
        }
        if (typeof preSets.responseExpected == 'undefined') {
            preSets.responseExpected = true;
        }
        ajaxData = [{
                index: 0,
                methodname: method,
                args: this.convertValuesToString(data)
            }];
        // The info= parameter has no function. It is just to help with debugging.
        // We call it info to match the parameter name use by Moodle's AMD ajax module.
        siteUrl = preSets.siteUrl + '/lib/ajax/service.php?info=' + method;
        var promise = this.http.post(siteUrl, JSON.stringify(ajaxData)).timeout(__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].WS_TIMEOUT).toPromise();
        return promise.then(function (data) {
            // Some moodle web services return null.
            // If the responseExpected value is set then so long as no data is returned, we create a blank object.
            if (!data && !preSets.responseExpected) {
                data = [{}];
            }
            // Check if error. Ajax layer should always return an object (if error) or an array (if success).
            if (!data || typeof data != 'object') {
                return rejectWithError(_this.createFakeWSError('core.serverconnection', true));
            }
            else if (data.error) {
                return rejectWithError(data);
            }
            // Get the first response since only one request was done.
            data = data[0];
            if (data.error) {
                return rejectWithError(data.exception);
            }
            return data.data;
        }, function (data) {
            var available = data.status == 404 ? -1 : 0;
            return rejectWithError(_this.createFakeWSError('core.serverconnection', true), available);
        });
        // Convenience function to return an error.
        function rejectWithError(exception, available) {
            if (typeof available == 'undefined') {
                if (exception.errorcode) {
                    available = exception.errorcode == 'invalidrecord' ? -1 : 1;
                }
                else {
                    available = 0;
                }
            }
            exception.available = available;
            return Promise.reject(exception);
        }
    };
    /**
     * Converts an objects values to strings where appropriate.
     * Arrays (associative or otherwise) will be maintained, null values will be removed.
     *
     * @param {object} data The data that needs all the non-object values set to strings.
     * @param {boolean} [stripUnicode] If Unicode long chars need to be stripped.
     * @return {object} The cleaned object or null if some strings becomes empty after stripping Unicode.
     */
    CoreWSProvider.prototype.convertValuesToString = function (data, stripUnicode) {
        var result = Array.isArray(data) ? [] : {};
        for (var key in data) {
            var value = data[key];
            if (value == null) {
                // Skip null or undefined value.
                continue;
            }
            else if (typeof value == 'object') {
                // Object or array.
                value = this.convertValuesToString(value, stripUnicode);
                if (value == null) {
                    return null;
                }
            }
            else if (typeof value == 'string') {
                if (stripUnicode) {
                    var stripped = this.textUtils.stripUnicode(value);
                    if (stripped != value && stripped.trim().length == 0) {
                        return null;
                    }
                    value = stripped;
                }
            }
            else if (typeof value == 'boolean') {
                /* Moodle does not allow "true" or "false" in WS parameters, only in POST parameters.
                   We've been using "true" and "false" for WS settings "filter" and "fileurl",
                   we keep it this way to avoid changing cache keys. */
                if (key == 'moodlewssettingfilter' || key == 'moodlewssettingfileurl') {
                    value = value ? 'true' : 'false';
                }
                else {
                    value = value ? '1' : '0';
                }
            }
            else if (typeof value == 'number') {
                value = String(value);
            }
            else {
                // Unknown type.
                continue;
            }
            if (Array.isArray(result)) {
                result.push(value);
            }
            else {
                result[key] = value;
            }
        }
        return result;
    };
    /**
     * Create a "fake" WS error for local errors.
     *
     * @param {string} message The message to include in the error.
     * @param {boolean} [needsTranslate] If the message needs to be translated.
     * @return {CoreWSError} Fake WS error.
     */
    CoreWSProvider.prototype.createFakeWSError = function (message, needsTranslate) {
        if (needsTranslate) {
            message = this.translate.instant(message);
        }
        return {
            message: message
        };
    };
    /**
     * Downloads a file from Moodle using Cordova File API.
     *
     * @param {string} url Download url.
     * @param {string} path Local path to store the file.
     * @param {boolean} [addExtension] True if extension need to be added to the final path.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved with the downloaded file.
     */
    CoreWSProvider.prototype.downloadFile = function (url, path, addExtension, onProgress) {
        var _this = this;
        this.logger.debug('Downloading file', url, path, addExtension);
        if (!this.appProvider.isOnline()) {
            return Promise.reject(this.translate.instant('core.networkerrormsg'));
        }
        // Use a tmp path to download the file and then move it to final location.
        // This is because if the download fails, the local file is deleted.
        var tmpPath = path + '.tmp';
        // Create the tmp file as an empty file.
        return this.fileProvider.createFile(tmpPath).then(function (fileEntry) {
            var transfer = _this.fileTransfer.create();
            transfer.onProgress(onProgress);
            return transfer.download(url, fileEntry.toURL(), true).then(function () {
                var promise;
                if (addExtension) {
                    var ext_1 = _this.mimeUtils.getFileExtension(path);
                    // Google Drive extensions will be considered invalid since Moodle usually converts them.
                    if (!ext_1 || ext_1 == 'gdoc' || ext_1 == 'gsheet' || ext_1 == 'gslides' || ext_1 == 'gdraw' || ext_1 == 'php') {
                        // Not valid, get the file's mimetype.
                        promise = _this.getRemoteFileMimeType(url).then(function (mime) {
                            if (mime) {
                                var remoteExt = _this.mimeUtils.getExtension(mime, url);
                                // If the file is from Google Drive, ignore mimetype application/json.
                                if (remoteExt && (!ext_1 || mime != 'application/json')) {
                                    if (ext_1) {
                                        // Remove existing extension since we will use another one.
                                        path = _this.mimeUtils.removeExtension(path);
                                    }
                                    path += '.' + remoteExt;
                                    return remoteExt;
                                }
                            }
                            return ext_1;
                        });
                    }
                    else {
                        promise = Promise.resolve(ext_1);
                    }
                }
                else {
                    promise = Promise.resolve('');
                }
                return promise.then(function (extension) {
                    return _this.fileProvider.moveFile(tmpPath, path).then(function (movedEntry) {
                        // Save the extension.
                        movedEntry.extension = extension;
                        movedEntry.path = path;
                        _this.logger.debug("Success downloading file " + url + " to " + path + " with extension " + extension);
                        return movedEntry;
                    });
                });
            });
        }).catch(function (err) {
            _this.logger.error("Error downloading " + url + " to " + path, err);
            return Promise.reject(err);
        });
    };
    /**
     * Get a promise from the cache.
     *
     * @param {string} method Method of the HTTP request.
     * @param {string} url Base URL of the HTTP request.
     * @param {any} [params] Params of the HTTP request.
     */
    CoreWSProvider.prototype.getPromiseHttp = function (method, url, params) {
        var queueItemId = this.getQueueItemId(method, url, params);
        if (typeof this.ongoingCalls[queueItemId] != 'undefined') {
            return this.ongoingCalls[queueItemId];
        }
        return false;
    };
    /**
     * Perform a HEAD request to get the mimetype of a remote file.
     *
     * @param {string} url File URL.
     * @param {boolean} [ignoreCache] True to ignore cache, false otherwise.
     * @return {Promise<string>} Promise resolved with the mimetype or '' if failure.
     */
    CoreWSProvider.prototype.getRemoteFileMimeType = function (url, ignoreCache) {
        var _this = this;
        if (this.mimeTypeCache[url] && !ignoreCache) {
            return Promise.resolve(this.mimeTypeCache[url]);
        }
        return this.performHead(url).then(function (data) {
            var mimeType = data.headers.get('Content-Type');
            if (mimeType) {
                // Remove "parameters" like charset.
                mimeType = mimeType.split(';')[0];
            }
            _this.mimeTypeCache[url] = mimeType;
            return mimeType || '';
        }).catch(function () {
            // Error, resolve with empty mimetype.
            return '';
        });
    };
    /**
     * Perform a HEAD request to get the size of a remote file.
     *
     * @param {string} url File URL.
     * @return {Promise<number>} Promise resolved with the size or -1 if failure.
     */
    CoreWSProvider.prototype.getRemoteFileSize = function (url) {
        return this.performHead(url).then(function (data) {
            var size = parseInt(data.headers.get('Content-Length'), 10);
            if (size) {
                return size;
            }
            return -1;
        }).catch(function () {
            // Error, return -1.
            return -1;
        });
    };
    /**
     * Get the unique queue item id of the cache for a HTTP request.
     *
     * @param {string} method Method of the HTTP request.
     * @param {string} url Base URL of the HTTP request.
     * @param {object} [params] Params of the HTTP request.
     * @return {string} Queue item ID.
     */
    CoreWSProvider.prototype.getQueueItemId = function (method, url, params) {
        if (params) {
            url += '###' + __WEBPACK_IMPORTED_MODULE_12__classes_interceptor__["a" /* CoreInterceptor */].serialize(params);
        }
        return method + '#' + __WEBPACK_IMPORTED_MODULE_11_ts_md5_dist_md5__["Md5"].hashAsciiStr(url);
    };
    /**
     * Perform a HEAD request and save the promise while waiting to be resolved.
     *
     * @param {string} url URL to perform the request.
     * @return {Promise<any>} Promise resolved with the response.
     */
    CoreWSProvider.prototype.performHead = function (url) {
        var promise = this.getPromiseHttp('head', url);
        if (!promise) {
            promise = this.commonHttp.head(url).timeout(__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].WS_TIMEOUT).toPromise();
            promise = this.setPromiseHttp(promise, 'head', url);
        }
        return promise;
    };
    /**
     * Perform the post call and save the promise while waiting to be resolved.
     *
     * @param {string} method The WebService method to be called.
     * @param {string} siteUrl Complete site url to perform the call.
     * @param {any} ajaxData Arguments to pass to the method.
     * @param {CoreWSPreSets} preSets Extra settings and information.
     * @return {Promise<any>} Promise resolved with the response data in success and rejected with CoreWSError if it fails.
     */
    CoreWSProvider.prototype.performPost = function (method, siteUrl, ajaxData, preSets) {
        var _this = this;
        var options = {};
        // This is done because some returned values like 0 are treated as null if responseType is json.
        if (preSets.typeExpected == 'number' || preSets.typeExpected == 'boolean' || preSets.typeExpected == 'string') {
            // Avalaible values are: https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/responseType
            options['responseType'] = 'text';
        }
        // We add the method name to the URL purely to help with debugging.
        // This duplicates what is in the ajaxData, but that does no harm.
        // POST variables take precedence over GET.
        var requestUrl = siteUrl + '&wsfunction=' + method;
        // Perform the post request.
        var promise = this.http.post(requestUrl, ajaxData, options).timeout(__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].WS_TIMEOUT).toPromise();
        return promise.then(function (data) {
            // Some moodle web services return null.
            // If the responseExpected value is set to false, we create a blank object if the response is null.
            if (!data && !preSets.responseExpected) {
                data = {};
            }
            if (!data) {
                return Promise.reject(_this.createFakeWSError('core.serverconnection', true));
            }
            else if (typeof data != preSets.typeExpected) {
                // If responseType is text an string will be returned, parse before returning.
                if (typeof data == 'string') {
                    if (preSets.typeExpected == 'number') {
                        data = Number(data);
                        if (isNaN(data)) {
                            _this.logger.warn("Response expected type \"" + preSets.typeExpected + "\" cannot be parsed to number");
                            return Promise.reject(_this.createFakeWSError('core.errorinvalidresponse', true));
                        }
                    }
                    else if (preSets.typeExpected == 'boolean') {
                        if (data === 'true') {
                            data = true;
                        }
                        else if (data === 'false') {
                            data = false;
                        }
                        else {
                            _this.logger.warn("Response expected type \"" + preSets.typeExpected + "\" is not true or false");
                            return Promise.reject(_this.createFakeWSError('core.errorinvalidresponse', true));
                        }
                    }
                    else {
                        _this.logger.warn('Response of type "' + typeof data + ("\" received, expecting \"" + preSets.typeExpected + "\""));
                        return Promise.reject(_this.createFakeWSError('core.errorinvalidresponse', true));
                    }
                }
                else {
                    _this.logger.warn('Response of type "' + typeof data + ("\" received, expecting \"" + preSets.typeExpected + "\""));
                    return Promise.reject(_this.createFakeWSError('core.errorinvalidresponse', true));
                }
            }
            if (typeof data.exception !== 'undefined') {
                // Special debugging for site plugins, otherwise it's hard to debug errors if the data is cached.
                if (method == 'tool_mobile_get_content') {
                    _this.logger.error('Error calling WS', method, data);
                }
                return Promise.reject(data);
            }
            if (typeof data.debuginfo != 'undefined') {
                return Promise.reject(_this.createFakeWSError('Error. ' + data.message));
            }
            return data;
        }, function (error) {
            // If server has heavy load, retry after some seconds.
            if (error.status == 429) {
                var retryPromise = _this.addToRetryQueue(method, siteUrl, ajaxData, preSets);
                // Only process the queue one time.
                if (_this.retryTimeout == 0) {
                    _this.retryTimeout = parseInt(error.headers.get('Retry-After'), 10) || 5;
                    _this.logger.warn(error.statusText + ". Retrying in " + _this.retryTimeout + " seconds. " +
                        (_this.retryCalls.length + " calls left."));
                    setTimeout(function () {
                        _this.logger.warn("Retrying now with " + _this.retryCalls.length + " calls to process.");
                        // Finish timeout.
                        _this.retryTimeout = 0;
                        _this.processRetryQueue();
                    }, _this.retryTimeout * 1000);
                }
                else {
                    _this.logger.warn('Calls locked, trying later...');
                }
                return retryPromise;
            }
            return Promise.reject(_this.createFakeWSError('core.serverconnection', true));
        });
    };
    /**
     * Retry all requests in the queue.
     * This function uses recursion in order to add a delay between requests to reduce stress.
     */
    CoreWSProvider.prototype.processRetryQueue = function () {
        var _this = this;
        if (this.retryCalls.length > 0 && this.retryTimeout == 0) {
            var call_1 = this.retryCalls.shift();
            // Add a delay between calls.
            setTimeout(function () {
                call_1.deferred.resolve(_this.performPost(call_1.method, call_1.siteUrl, call_1.ajaxData, call_1.preSets));
                _this.processRetryQueue();
            }, 200);
        }
        else {
            this.logger.warn("Retry queue has stopped with " + this.retryCalls.length + " calls and " + this.retryTimeout + " timeout secs.");
        }
    };
    /**
     * Save promise on the cache.
     *
     * @param {Promise<any>} promise Promise to be saved.
     * @param {string} method Method of the HTTP request.
     * @param {string} url Base URL of the HTTP request.
     * @param {any} [params] Params of the HTTP request.
     * @return {Promise<any>} The promise saved.
     */
    CoreWSProvider.prototype.setPromiseHttp = function (promise, method, url, params) {
        var _this = this;
        var queueItemId = this.getQueueItemId(method, url, params);
        var timeout;
        this.ongoingCalls[queueItemId] = promise;
        // HTTP not finished, but we should delete the promise after timeout.
        timeout = setTimeout(function () {
            delete _this.ongoingCalls[queueItemId];
        }, __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].WS_TIMEOUT);
        // HTTP finished, delete from ongoing.
        return promise.finally(function () {
            delete _this.ongoingCalls[queueItemId];
            clearTimeout(timeout);
        });
    };
    /**
     * A wrapper function for a synchronous Moodle WebService call.
     * Warning: This function should only be used if synchronous is a must. It's recommended to use call.
     *
     * @param {string} method The WebService method to be called.
     * @param {any} data Arguments to pass to the method.
     * @param {CoreWSPreSets} preSets Extra settings and information.
     * @return {Promise} Promise resolved with the response data in success and rejected with the error message if it fails.
     * @return {any} Request response. If the request fails, returns an object with 'error'=true and 'message' properties.
     */
    CoreWSProvider.prototype.syncCall = function (method, data, preSets) {
        var errorResponse = {
            error: true,
            message: ''
        };
        var siteUrl, xhr;
        if (!preSets) {
            errorResponse.message = this.translate.instant('core.unexpectederror');
            return errorResponse;
        }
        else if (!this.appProvider.isOnline()) {
            errorResponse.message = this.translate.instant('core.networkerrormsg');
            return errorResponse;
        }
        preSets.typeExpected = preSets.typeExpected || 'object';
        if (typeof preSets.responseExpected == 'undefined') {
            preSets.responseExpected = true;
        }
        data = this.convertValuesToString(data || {}, preSets.cleanUnicode);
        if (data == null) {
            // Empty cleaned text found.
            errorResponse.message = this.translate.instant('core.unicodenotsupportedcleanerror');
            return errorResponse;
        }
        data.wsfunction = method;
        data.wstoken = preSets.wsToken;
        siteUrl = preSets.siteUrl + '/webservice/rest/server.php?moodlewsrestformat=json';
        // Serialize data.
        data = __WEBPACK_IMPORTED_MODULE_12__classes_interceptor__["a" /* CoreInterceptor */].serialize(data);
        // Perform sync request using XMLHttpRequest.
        xhr = new window.XMLHttpRequest();
        xhr.open('post', siteUrl, false);
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;charset=utf-8');
        xhr.send(data);
        // Get response.
        data = ('response' in xhr) ? xhr.response : xhr.responseText;
        // Check status.
        var status = Math.max(xhr.status === 1223 ? 204 : xhr.status, 0);
        if (status < 200 || status >= 300) {
            // Request failed.
            errorResponse.message = data;
            return errorResponse;
        }
        // Treat response.
        data = this.textUtils.parseJSON(data);
        // Some moodle web services return null.
        // If the responseExpected value is set then so long as no data is returned, we create a blank object.
        if ((!data || !data.data) && !preSets.responseExpected) {
            data = {};
        }
        if (!data) {
            errorResponse.message = this.translate.instant('core.serverconnection');
        }
        else if (typeof data != preSets.typeExpected) {
            this.logger.warn('Response of type "' + typeof data + '" received, expecting "' + preSets.typeExpected + '"');
            errorResponse.message = this.translate.instant('core.errorinvalidresponse');
        }
        if (typeof data.exception != 'undefined' || typeof data.debuginfo != 'undefined') {
            errorResponse.message = data.message;
        }
        if (errorResponse.message !== '') {
            return errorResponse;
        }
        return data;
    };
    /*
     * Uploads a file.
     *
     * @param {string} filePath File path.
     * @param {CoreWSFileUploadOptions} options File upload options.
     * @param {CoreWSPreSets} preSets Must contain siteUrl and wsToken.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved when uploaded.
     */
    CoreWSProvider.prototype.uploadFile = function (filePath, options, preSets, onProgress) {
        var _this = this;
        this.logger.debug("Trying to upload file: " + filePath);
        if (!filePath || !options || !preSets) {
            return Promise.reject(null);
        }
        if (!this.appProvider.isOnline()) {
            return Promise.reject(this.translate.instant('core.networkerrormsg'));
        }
        var uploadUrl = preSets.siteUrl + '/webservice/upload.php', transfer = this.fileTransfer.create();
        transfer.onProgress(onProgress);
        options.httpMethod = 'POST';
        options.params = {
            token: preSets.wsToken,
            filearea: options.fileArea || 'draft',
            itemid: options.itemId || 0
        };
        options.chunkedMode = false;
        options.headers = {
            Connection: 'close'
        };
        return transfer.upload(filePath, uploadUrl, options, true).then(function (success) {
            var data = _this.textUtils.parseJSON(success.response, null, _this.logger.error.bind(_this.logger, 'Error parsing response from upload'));
            if (data === null) {
                return Promise.reject(_this.translate.instant('core.errorinvalidresponse'));
            }
            if (!data) {
                return Promise.reject(_this.translate.instant('core.serverconnection'));
            }
            else if (typeof data != 'object') {
                _this.logger.warn('Upload file: Response of type "' + typeof data + '" received, expecting "object"');
                return Promise.reject(_this.translate.instant('core.errorinvalidresponse'));
            }
            if (typeof data.exception !== 'undefined') {
                return Promise.reject(data.message);
            }
            else if (data && typeof data.error !== 'undefined') {
                return Promise.reject(data.error);
            }
            else if (data[0] && typeof data[0].error !== 'undefined') {
                return Promise.reject(data[0].error);
            }
            // We uploaded only 1 file, so we only return the first file returned.
            _this.logger.debug('Successfully uploaded file', filePath);
            return data[0];
        }).catch(function (error) {
            _this.logger.error('Error while uploading file', filePath, error);
            return Promise.reject(_this.translate.instant('core.errorinvalidresponse'));
        });
    };
    CoreWSProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_9__utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_6__file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_transfer__["a" /* FileTransfer */], __WEBPACK_IMPORTED_MODULE_1__angular_http__["b" /* Http */],
            __WEBPACK_IMPORTED_MODULE_8__utils_mimetype__["a" /* CoreMimetypeUtilsProvider */]])
    ], CoreWSProvider);
    return CoreWSProvider;
}());

//# sourceMappingURL=ws.js.map

/***/ }),
/* 136 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileSessionProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Helper to store some temporary data for file submission.
 *
 * It uses siteId and component name to index the files.
 * Every component can provide a File area identifier to indentify every file list on the session.
 * This value can be the activity id or a mix of name and numbers.
 */
var CoreFileSessionProvider = /** @class */ (function () {
    function CoreFileSessionProvider(sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.files = {};
    }
    /**
     * Add a file to the session.
     *
     * @param {string} component Component Name.
     * @param {string|number} id File area identifier.
     * @param {any} file File to add.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreFileSessionProvider.prototype.addFile = function (component, id, file, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        this.initFileArea(component, id, siteId);
        this.files[siteId][component][id].push(file);
    };
    /**
     * Clear files stored in session.
     *
     * @param {string} component Component Name.
     * @param {string|number} id File area identifier.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreFileSessionProvider.prototype.clearFiles = function (component, id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.files[siteId] && this.files[siteId][component] && this.files[siteId][component][id]) {
            this.files[siteId][component][id] = [];
        }
    };
    /**
     * Get files stored in session.
     *
     * @param {string} component Component Name.
     * @param {string|number} id File area identifier.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]} Array of files in session.
     */
    CoreFileSessionProvider.prototype.getFiles = function (component, id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.files[siteId] && this.files[siteId][component] && this.files[siteId][component][id]) {
            return this.files[siteId][component][id];
        }
        return [];
    };
    /**
     * Initializes the filearea to store the file.
     *
     * @param {string} component Component Name.
     * @param {string|number} id File area identifier.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreFileSessionProvider.prototype.initFileArea = function (component, id, siteId) {
        if (!this.files[siteId]) {
            this.files[siteId] = {};
        }
        if (!this.files[siteId][component]) {
            this.files[siteId][component] = {};
        }
        if (!this.files[siteId][component][id]) {
            this.files[siteId][component][id] = [];
        }
    };
    /**
     * Remove a file stored in session.
     *
     * @param {string} component Component Name.
     * @param {string|number} id File area identifier.
     * @param {any} file File to remove. The instance should be exactly the same as the one stored in session.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreFileSessionProvider.prototype.removeFile = function (component, id, file, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.files[siteId] && this.files[siteId][component] && this.files[siteId][component][id]) {
            var position = this.files[siteId][component][id].indexOf(file);
            if (position != -1) {
                this.files[siteId][component][id].splice(position, 1);
            }
        }
    };
    /**
     * Remove a file stored in session.
     *
     * @param {string} component Component Name.
     * @param {string|number} id File area identifier.
     * @param {number} index Position of the file to remove.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreFileSessionProvider.prototype.removeFileByIndex = function (component, id, index, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.files[siteId] && this.files[siteId][component] && this.files[siteId][component][id] && index >= 0 &&
            index < this.files[siteId][component][id].length) {
            this.files[siteId][component][id].splice(index, 1);
        }
    };
    /**
     * Set a group of files in the session.
     *
     * @param {string} component Component Name.
     * @param {string|number} id File area identifier.
     * @param {any[]} newFiles Files to set.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    CoreFileSessionProvider.prototype.setFiles = function (component, id, newFiles, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        this.initFileArea(component, id, siteId);
        this.files[siteId][component][id] = newFiles;
    };
    CoreFileSessionProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sites__["a" /* CoreSitesProvider */]])
    ], CoreFileSessionProvider);
    return CoreFileSessionProvider;
}());

//# sourceMappingURL=file-session.js.map

/***/ }),
/* 137 */,
/* 138 */,
/* 139 */,
/* 140 */,
/* 141 */,
/* 142 */,
/* 143 */,
/* 144 */,
/* 145 */,
/* 146 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCourseCompletionProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Service to handle course completion.
 */
var AddonCourseCompletionProvider = /** @class */ (function () {
    function AddonCourseCompletionProvider(logger, sitesProvider, coursesProvider, utils) {
        this.sitesProvider = sitesProvider;
        this.coursesProvider = coursesProvider;
        this.utils = utils;
        this.ROOT_CACHE_KEY = 'mmaCourseCompletion:';
        this.logger = logger.getInstance('AddonCourseCompletionProvider');
    }
    /**
     * Returns whether or not the user can mark a course as self completed.
     * It can if it's configured in the course and it hasn't been completed yet.
     *
     * @param {number} userId     User ID.
     * @param {any}    completion Course completion.
     * @return {boolean} True if user can mark course as self completed, false otherwise.
     */
    AddonCourseCompletionProvider.prototype.canMarkSelfCompleted = function (userId, completion) {
        var selfCompletionActive = false, alreadyMarked = false;
        if (this.sitesProvider.getCurrentSiteUserId() != userId) {
            return false;
        }
        completion.completions.forEach(function (criteria) {
            if (criteria.type === 1) {
                // Self completion criteria found.
                selfCompletionActive = true;
                alreadyMarked = criteria.complete;
            }
        });
        return selfCompletionActive && !alreadyMarked;
    };
    /**
     * Get completed status text. The language code returned is meant to be translated.
     *
     * @param {any} completion Course completion.
     * @return {string} Language code of the text to show.
     */
    AddonCourseCompletionProvider.prototype.getCompletedStatusText = function (completion) {
        if (completion.completed) {
            return 'addon.coursecompletion.completed';
        }
        else {
            // Let's calculate status.
            var hasStarted_1 = false;
            completion.completions.forEach(function (criteria) {
                if (criteria.timecompleted || criteria.complete) {
                    hasStarted_1 = true;
                }
            });
            if (hasStarted_1) {
                return 'addon.coursecompletion.inprogress';
            }
            else {
                return 'addon.coursecompletion.notyetstarted';
            }
        }
    };
    /**
     * Get course completion status for a certain course and user.
     *
     * @param {number} courseId  Course ID.
     * @param {number} [userId]  User ID. If not defined, use current user.
     * @param {any}    [preSets] Presets to use when calling the WebService.
     * @param {string} [siteId]  Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise to be resolved when the completion is retrieved.
     */
    AddonCourseCompletionProvider.prototype.getCompletion = function (courseId, userId, preSets, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            preSets = preSets || {};
            _this.logger.debug('Get completion for course ' + courseId + ' and user ' + userId);
            var data = {
                courseid: courseId,
                userid: userId
            };
            preSets.cacheKey = _this.getCompletionCacheKey(courseId, userId);
            preSets.updateFrequency = preSets.updateFrequency || __WEBPACK_IMPORTED_MODULE_5__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES;
            return site.read('core_completion_get_course_completion_status', data, preSets).then(function (data) {
                if (data.completionstatus) {
                    return data.completionstatus;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get completion WS calls.
     *
     * @param {number} courseId Course ID.
     * @param {number} useIid   User ID.
     * @return {string} Cache key.
     */
    AddonCourseCompletionProvider.prototype.getCompletionCacheKey = function (courseId, userId) {
        return this.ROOT_CACHE_KEY + 'view:' + courseId + ':' + userId;
    };
    /**
     * Invalidates view course completion WS call.
     *
     * @param {number} courseId Course ID.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @return {Promise<any>} Promise resolved when the list is invalidated.
     */
    AddonCourseCompletionProvider.prototype.invalidateCourseCompletion = function (courseId, userId) {
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        return this.sitesProvider.getCurrentSite().invalidateWsCacheForKey(this.getCompletionCacheKey(courseId, userId));
    };
    /**
     * Returns whether or not the view course completion plugin is enabled for the current site.
     *
     * @return {boolean} True if plugin enabled, false otherwise.
     */
    AddonCourseCompletionProvider.prototype.isPluginViewEnabled = function () {
        return this.sitesProvider.isLoggedIn();
    };
    /**
     * Returns whether or not the view course completion plugin is enabled for a certain course.
     *
     * @param {number}  courseId           Course ID.
     * @param {boolean} [preferCache=true] True if shouldn't call WS if data is cached, false otherwise.
     * @return {Promise<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonCourseCompletionProvider.prototype.isPluginViewEnabledForCourse = function (courseId, preferCache) {
        if (preferCache === void 0) { preferCache = true; }
        if (!courseId) {
            return Promise.reject(null);
        }
        return this.coursesProvider.getUserCourse(courseId, preferCache).then(function (course) {
            if (course) {
                if (typeof course.enablecompletion != 'undefined' && course.enablecompletion == 0) {
                    // Completion not enabled for the course.
                    return false;
                }
                if (typeof course.completionhascriteria != 'undefined' && course.completionhascriteria == 0) {
                    // No criteria, cannot view completion.
                    return false;
                }
            }
            return true;
        });
    };
    /**
     * Returns whether or not the view course completion plugin is enabled for a certain user.
     *
     * @param {number} courseId Course ID.
     * @param {number} [userId] User ID. If not defined, use current user.
     * @return {Promise<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonCourseCompletionProvider.prototype.isPluginViewEnabledForUser = function (courseId, userId) {
        var _this = this;
        // Check if user wants to view his own completion.
        var currentUserId = this.sitesProvider.getCurrentSiteUserId();
        var promise;
        if (!userId || userId == currentUserId) {
            // Viewing own completion. Get the course to check if it has completion criteria.
            promise = this.coursesProvider.getUserCourse(courseId, true).then(function (course) {
                // If the site is returning the completionhascriteria then the user can view his own completion.
                // We already checked the value in isPluginViewEnabledForCourse.
                if (course && typeof course.completionhascriteria != 'undefined') {
                    return true;
                }
                return Promise.reject(null);
            });
        }
        else {
            promise = Promise.reject(null);
        }
        return promise.catch(function () {
            // User not viewing own completion or the site doesn't tell us if the course has criteria.
            // The only way to know if completion can be viewed is to call the WS.
            // Disable emergency cache to be able to detect that the plugin has been disabled (WS will fail).
            var preSets = {
                emergencyCache: 0
            };
            return _this.getCompletion(courseId, userId, preSets).then(function () {
                return true;
            }).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WS returned an error, plugin is not enabled.
                    return false;
                }
                else {
                    // Not a WS error. Check if we have a cached value.
                    preSets.omitExpires = true;
                    return _this.getCompletion(courseId, userId, preSets).then(function () {
                        return true;
                    }).catch(function () {
                        return false;
                    });
                }
            });
        });
    };
    /**
     * Mark a course as self completed.
     *
     * @param {number} courseId Course ID.
     * @return {Promise<any>} Resolved on success.
     */
    AddonCourseCompletionProvider.prototype.markCourseAsSelfCompleted = function (courseId) {
        var params = {
            courseid: courseId
        };
        return this.sitesProvider.getCurrentSite().write('core_completion_mark_course_self_completed', params).then(function (response) {
            if (!response.status) {
                return Promise.reject(null);
            }
        });
    };
    AddonCourseCompletionProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonCourseCompletionProvider);
    return AddonCourseCompletionProvider;
}());

//# sourceMappingURL=coursecompletion.js.map

/***/ }),
/* 147 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBlockBaseHandler; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base handler for blocks.
 *
 * This class is needed because parent classes cannot have @Injectable in Angular v6, so the default handler cannot be a
 * parent class.
 */
var CoreBlockBaseHandler = /** @class */ (function () {
    function CoreBlockBaseHandler() {
        this.name = 'CoreBlockBase';
        this.blockName = 'base';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreBlockBaseHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    CoreBlockBaseHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        // To be overridden.
        return;
    };
    return CoreBlockBaseHandler;
}());

//# sourceMappingURL=base-block-handler.js.map

/***/ }),
/* 148 */,
/* 149 */,
/* 150 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBlockBaseComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Template class to easily create components for blocks.
 */
var CoreBlockBaseComponent = /** @class */ (function () {
    function CoreBlockBaseComponent(injector, loggerName) {
        if (loggerName === void 0) { loggerName = 'AddonBlockComponent'; }
        this.domUtils = injector.get(__WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */]);
        var loggerProvider = injector.get(__WEBPACK_IMPORTED_MODULE_0__providers_logger__["a" /* CoreLoggerProvider */]);
        this.logger = loggerProvider.getInstance(loggerName);
    }
    /**
     * Component being initialized.
     */
    CoreBlockBaseComponent.prototype.ngOnInit = function () {
        this.loaded = false;
        this.loadContent();
    };
    /**
     * Refresh the data.
     *
     * @param {any}       [refresher] Refresher.
     * @param {Function}  [done] Function to call when done.
     * @param {boolean}   [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreBlockBaseComponent.prototype.doRefresh = function (refresher, done, showErrors) {
        if (showErrors === void 0) { showErrors = false; }
        if (this.loaded) {
            return this.refreshContent(showErrors).finally(function () {
                refresher && refresher.complete();
                done && done();
            });
        }
        return Promise.resolve();
    };
    /**
     * Perform the refresh content function.
     *
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Resolved when done.
     */
    CoreBlockBaseComponent.prototype.refreshContent = function (showErrors) {
        var _this = this;
        if (showErrors === void 0) { showErrors = false; }
        // Wrap the call in a try/catch so the workflow isn't interrupted if an error occurs.
        var promise;
        try {
            promise = this.invalidateContent();
        }
        catch (ex) {
            // An error ocurred in the function, log the error and just resolve the promise so the workflow continues.
            this.logger.error(ex);
            promise = Promise.resolve();
        }
        return promise.catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.loadContent(true, showErrors);
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    CoreBlockBaseComponent.prototype.invalidateContent = function () {
        return Promise.resolve();
    };
    /**
     * Loads the component contents and shows the corresponding error.
     *
     * @param {boolean}       [refresh=false] Whether we're refreshing data.
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreBlockBaseComponent.prototype.loadContent = function (refresh, showErrors) {
        var _this = this;
        if (showErrors === void 0) { showErrors = false; }
        // Wrap the call in a try/catch so the workflow isn't interrupted if an error occurs.
        var promise;
        try {
            promise = this.fetchContent(refresh);
        }
        catch (ex) {
            // An error ocurred in the function, log the error and just resolve the promise so the workflow continues.
            this.logger.error(ex);
            promise = Promise.resolve();
        }
        return promise.catch(function (error) {
            // Error getting data, fail.
            _this.domUtils.showErrorModalDefault(error, _this.fetchContentDefaultError, true);
        }).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Download the component contents.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreBlockBaseComponent.prototype.fetchContent = function (refresh) {
        return Promise.resolve();
    };
    return CoreBlockBaseComponent;
}());

//# sourceMappingURL=base-block-component.js.map

/***/ }),
/* 151 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreTabsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * This component displays some tabs that usually share data between them.
 *
 * If your tabs don't share any data then you should probably use ion-tabs. This component doesn't use different ion-nav
 * for each tab, so it will not load pages.
 *
 * Example usage:
 *
 * <core-tabs selectedIndex="1">
 *     <core-tab [title]="'core.courses.timeline' | translate" (ionSelect)="switchTab('timeline')">
 *         <ng-template> <!-- This ng-template is required, @see CoreTabComponent. -->
 *             <!-- Tab contents. -->
 *         </ng-template>
 *     </core-tab>
 * </core-tabs>
 *
 * Obviously, the tab contents will only be shown if that tab is selected.
 */
var CoreTabsComponent = /** @class */ (function () {
    function CoreTabsComponent(element, content, domUtils, appProvider, platform, translate) {
        var _this = this;
        this.content = content;
        this.domUtils = domUtils;
        this.appProvider = appProvider;
        this.selectedIndex = 0; // Index of the tab to select.
        this.hideUntil = true; // Determine when should the contents be shown.
        this.parentScrollable = false; // Determine if the scroll should be in the parent content or the tab itself.
        this.ionChange = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"](); // Emitted when the tab changes.
        this.tabs = []; // List of tabs.
        this.maxSlides = 3;
        this.slidesShown = this.maxSlides;
        this.numTabsShown = 0;
        this.direction = 'ltr';
        this.description = '';
        this.lastScroll = 0;
        this.initialized = false;
        this.afterViewInitTriggered = false;
        this.tabsShown = true;
        this.isDestroyed = false;
        this.isCurrentView = true;
        this.shouldSlideToInitial = false; // Whether we need to slide to the initial slide because it's out of view.
        this.hasSliddenToInitial = false; // Whether we've already slidden to the initial slide or there was no need.
        this.selectHistory = [];
        this.tabBarElement = element.nativeElement;
        this.direction = platform.isRTL ? 'rtl' : 'ltr';
        // Change the side when the language changes.
        this.languageChangedSubscription = translate.onLangChange.subscribe(function (event) {
            setTimeout(function () {
                _this.direction = platform.isRTL ? 'rtl' : 'ltr';
            });
        });
    }
    /**
     * Component being initialized.
     */
    CoreTabsComponent.prototype.ngOnInit = function () {
        this.originalTabsContainer = this.originalTabsRef.nativeElement;
        this.topTabsElement = this.topTabs.nativeElement;
    };
    /**
     * View has been initialized.
     */
    CoreTabsComponent.prototype.ngAfterViewInit = function () {
        if (this.isDestroyed) {
            return;
        }
        this.afterViewInitTriggered = true;
        if (!this.initialized && this.hideUntil) {
            // Tabs should be shown, initialize them.
            this.initializeTabs();
        }
        this.resizeFunction = this.calculateSlides.bind(this);
        window.addEventListener('resize', this.resizeFunction);
    };
    /**
     * Detect changes on input properties.
     */
    CoreTabsComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        // We need to wait for ngAfterViewInit because we need core-tab components to be executed.
        if (!this.initialized && this.hideUntil && this.afterViewInitTriggered) {
            // Tabs should be shown, initialize them.
            // Use a setTimeout so child core-tab update their inputs before initializing the tabs.
            setTimeout(function () {
                _this.initializeTabs();
            });
        }
    };
    /**
     * User entered the page that contains the component.
     */
    CoreTabsComponent.prototype.ionViewDidEnter = function () {
        this.isCurrentView = true;
        this.calculateSlides();
        this.registerBackButtonAction();
    };
    /**
     * Register back button action.
     */
    CoreTabsComponent.prototype.registerBackButtonAction = function () {
        var _this = this;
        this.unregisterBackButtonAction = this.appProvider.registerBackButtonAction(function () {
            // The previous page in history is not the last one, we need the previous one.
            if (_this.selectHistory.length > 1) {
                var tab_1 = _this.selectHistory[_this.selectHistory.length - 2];
                // Remove curent and previous tabs from history.
                _this.selectHistory = _this.selectHistory.filter(function (tabId) {
                    return _this.selected != tabId && tab_1 != tabId;
                });
                _this.selectTab(tab_1);
                return true;
            }
            else if (_this.selected != _this.firstSelectedTab) {
                // All history is gone but we are not in the first selected tab.
                _this.selectHistory = [];
                _this.selectTab(_this.firstSelectedTab);
                return true;
            }
            return false;
        }, 750);
    };
    /**
     * User left the page that contains the component.
     */
    CoreTabsComponent.prototype.ionViewDidLeave = function () {
        // Unregister the custom back button action for this page
        this.unregisterBackButtonAction && this.unregisterBackButtonAction();
        this.isCurrentView = false;
    };
    /**
     * Add a new tab if it isn't already in the list of tabs.
     *
     * @param {CoreTabComponent} tab The tab to add.
     */
    CoreTabsComponent.prototype.addTab = function (tab) {
        var _this = this;
        // Check if tab is already in the list.
        if (this.getIndex(tab) == -1) {
            this.tabs.push(tab);
            this.sortTabs();
            this.calculateSlides();
            if (this.initialized && this.tabs.length > 1 && this.tabBarHeight == 0) {
                // Calculate the tabBarHeight again now that there is more than 1 tab and the bar will be seen.
                // Use timeout to wait for the view to be rendered. 0 ms should be enough, use 50 to be sure.
                setTimeout(function () {
                    _this.calculateTabBarHeight();
                }, 50);
            }
        }
    };
    /**
     * Calculate slides.
     */
    CoreTabsComponent.prototype.calculateSlides = function () {
        var _this = this;
        if (!this.isCurrentView || !this.tabsShown || !this.initialized) {
            // Don't calculate if component isn't in current view, the calculations are wrong.
            return;
        }
        setTimeout(function () {
            _this.calculateMaxSlides();
            _this.updateSlides();
        });
    };
    /**
     * Calculate the tab bar height.
     */
    CoreTabsComponent.prototype.calculateTabBarHeight = function () {
        this.tabBarHeight = this.topTabsElement.offsetHeight;
        this.originalTabsContainer.style.paddingBottom = this.tabBarHeight + 'px';
    };
    /**
     * Get the index of tab.
     *
     * @param  {any}    tab Tab object to check.
     * @return {number}     Index number on the tabs array or -1 if not found.
     */
    CoreTabsComponent.prototype.getIndex = function (tab) {
        for (var i = 0; i < this.tabs.length; i++) {
            var t = this.tabs[i];
            if (t === tab || (typeof t.id != 'undefined' && t.id === tab.id)) {
                return i;
            }
        }
        return -1;
    };
    /**
     * Get the current selected tab.
     *
     * @return {CoreTabComponent} Selected tab.
     */
    CoreTabsComponent.prototype.getSelected = function () {
        return this.tabs[this.selected];
    };
    /**
     * Initialize the tabs, determining the first tab to be shown.
     */
    CoreTabsComponent.prototype.initializeTabs = function () {
        var selectedIndex = this.selectedIndex || 0, selectedTab = this.tabs[selectedIndex];
        if (!selectedTab || !selectedTab.enabled || !selectedTab.show) {
            // The tab is not enabled or not shown. Get the first tab that is enabled.
            selectedTab = this.tabs.find(function (tab, index) {
                if (tab.enabled && tab.show) {
                    selectedIndex = index;
                    return true;
                }
                return false;
            });
        }
        if (selectedTab) {
            this.firstSelectedTab = selectedIndex;
            this.selectTab(selectedIndex);
        }
        // Setup tab scrolling.
        this.calculateTabBarHeight();
        if (this.content) {
            if (!this.parentScrollable) {
                // Parent scroll element (if core-tabs is inside a ion-content).
                var scroll_1 = this.content.getScrollElement();
                if (scroll_1) {
                    scroll_1.classList.add('no-scroll');
                }
            }
            else {
                this.originalTabsContainer.classList.add('no-scroll');
            }
        }
        this.initialized = true;
        // Check which arrows should be shown.
        this.calculateSlides();
    };
    /**
     * Method executed when the slides are changed.
     */
    CoreTabsComponent.prototype.slideChanged = function () {
        var currentIndex = this.slides.getActiveIndex();
        if (this.slidesShown >= this.numTabsShown) {
            this.showPrevButton = false;
            this.showNextButton = false;
        }
        else if (typeof currentIndex !== 'undefined') {
            this.showPrevButton = currentIndex > 0;
            this.showNextButton = currentIndex < this.numTabsShown - this.slidesShown;
        }
        else {
            this.showPrevButton = false;
            this.showNextButton = this.numTabsShown > this.slidesShown;
        }
        if (this.shouldSlideToInitial && currentIndex != this.selected) {
            // Current tab has changed, don't slide to initial anymore.
            this.shouldSlideToInitial = false;
        }
        this.updateAriaHidden(); // Sliding resets the aria-hidden, update it.
    };
    /**
     * Update slides.
     */
    CoreTabsComponent.prototype.updateSlides = function () {
        var _this = this;
        this.numTabsShown = this.tabs.reduce(function (prev, current) {
            return current.show ? prev + 1 : prev;
        }, 0);
        this.slidesShown = Math.min(this.maxSlides, this.numTabsShown);
        this.slideChanged();
        setTimeout(function () {
            _this.calculateTabBarHeight();
            _this.slides.update();
            _this.slides.resize();
            if (!_this.hasSliddenToInitial && _this.selected && _this.selected >= _this.slidesShown) {
                _this.hasSliddenToInitial = true;
                _this.shouldSlideToInitial = true;
                setTimeout(function () {
                    if (_this.shouldSlideToInitial) {
                        _this.slides.slideTo(_this.selected, 0);
                        _this.shouldSlideToInitial = false;
                        _this.updateAriaHidden(); // Slide's slideTo() sets aria-hidden to true, update it.
                    }
                }, 400);
                return;
            }
            else if (_this.selected) {
                _this.hasSliddenToInitial = true;
            }
            setTimeout(function () {
                _this.updateAriaHidden(); // Slide's update() sets aria-hidden to true, update it.
            }, 400);
        });
    };
    CoreTabsComponent.prototype.calculateMaxSlides = function () {
        if (this.slides) {
            var width = this.domUtils.getElementWidth(this.slides.getNativeElement()) || this.slides.renderedWidth;
            if (width) {
                this.maxSlides = Math.floor(width / 100);
                return;
            }
        }
        this.maxSlides = 3;
    };
    /**
     * Method that shows the next slide.
     */
    CoreTabsComponent.prototype.slideNext = function () {
        if (this.showNextButton) {
            this.slides.slideNext();
        }
    };
    /**
     * Method that shows the previous slide.
     */
    CoreTabsComponent.prototype.slidePrev = function () {
        if (this.showPrevButton) {
            this.slides.slidePrev();
        }
    };
    /**
     * Show or hide the tabs. This is used when the user is scrolling inside a tab.
     *
     * @param {any} scrollElement Scroll element to check scroll position.
     */
    CoreTabsComponent.prototype.showHideTabs = function (scrollElement) {
        if (!this.tabBarHeight) {
            // We don't have the tab bar height, this means the tab bar isn't shown.
            return;
        }
        var scroll = parseInt(scrollElement.scrollTop, 10);
        if (scroll == this.lastScroll) {
            // Ensure scroll has been modified to avoid flicks.
            return;
        }
        if (this.tabsShown && scroll > this.tabBarHeight) {
            this.tabsShown = false;
            // Hide tabs.
            this.tabBarElement.classList.add('tabs-hidden');
        }
        else if (!this.tabsShown && scroll <= this.tabBarHeight) {
            this.tabsShown = true;
            this.tabBarElement.classList.remove('tabs-hidden');
            this.calculateSlides();
        }
        if (this.tabsShown) {
            // Smooth translation.
            this.topTabsElement.style.transform = 'translateY(-' + scroll + 'px)';
            this.originalTabsContainer.style.transform = 'translateY(-' + scroll + 'px)';
            this.originalTabsContainer.style.paddingBottom = this.tabBarHeight - scroll + 'px';
        }
        this.lastScroll = scroll;
    };
    /**
     * Remove a tab from the list of tabs.
     *
     * @param {CoreTabComponent} tab The tab to remove.
     */
    CoreTabsComponent.prototype.removeTab = function (tab) {
        var index = this.getIndex(tab);
        this.tabs.splice(index, 1);
        this.calculateSlides();
    };
    /**
     * Select a certain tab.
     *
     * @param {number} index The index of the tab to select.
     */
    CoreTabsComponent.prototype.selectTab = function (index) {
        if (index == this.selected) {
            // Already selected.
            return;
        }
        if (index < 0 || index >= this.tabs.length) {
            // Index isn't valid, select the first one.
            index = 0;
        }
        var currentTab = this.getSelected(), newTab = this.tabs[index];
        if (!newTab.enabled || !newTab.show) {
            // The tab isn't enabled or shown, stop.
            return;
        }
        if (currentTab) {
            // Unselect previous selected tab.
            currentTab.unselectTab();
        }
        if (this.selected) {
            this.slides.slideTo(index);
            this.updateAriaHidden(); // Slide's slideTo() sets aria-hidden to true, update it.
        }
        this.selectHistory.push(index);
        this.selected = index;
        newTab.selectTab();
        this.ionChange.emit(newTab);
    };
    /**
     * Sort the tabs, keeping the same order as in the original list.
     */
    CoreTabsComponent.prototype.sortTabs = function () {
        var _this = this;
        if (this.originalTabsContainer) {
            var newTabs_1 = [];
            this.tabs.forEach(function (tab, index) {
                var originalIndex = Array.prototype.indexOf.call(_this.originalTabsContainer.children, tab.element);
                if (originalIndex != -1) {
                    newTabs_1[originalIndex] = tab;
                }
            });
            this.tabs = newTabs_1;
        }
    };
    /**
     * Function to call when the visibility of a tab has changed.
     */
    CoreTabsComponent.prototype.tabVisibilityChanged = function () {
        this.calculateSlides();
    };
    /**
     * Update aria-hidden of all tabs.
     */
    CoreTabsComponent.prototype.updateAriaHidden = function () {
        this.tabs.forEach(function (tab, index) {
            tab.updateAriaHidden();
        });
    };
    /**
     * Component destroyed.
     */
    CoreTabsComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        if (this.resizeFunction) {
            window.removeEventListener('resize', this.resizeFunction);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreTabsComponent.prototype, "selectedIndex", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreTabsComponent.prototype, "hideUntil", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreTabsComponent.prototype, "parentScrollable", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreTabsComponent.prototype, "ionChange", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('originalTabs'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreTabsComponent.prototype, "originalTabsRef", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('topTabs'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreTabsComponent.prototype, "topTabs", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* Slides */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["A" /* Slides */])
    ], CoreTabsComponent.prototype, "slides", void 0);
    CoreTabsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-tabs',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\tabs\core-tabs.html"*/'<core-loading [hideUntil]="hideUntil" class="core-loading-center">\n    <div class="core-tabs-bar" #topTabs [hidden]="!tabs || numTabsShown < 2" id="core-tabs-bar">\n        <ion-row>\n            <ion-col class="col-with-arrow" (click)="slidePrev()" no-padding col-1>\n                <ion-icon *ngIf="showPrevButton" name="arrow-back" md="ios-arrow-back"></ion-icon>\n            </ion-col>\n            <ion-col no-padding col-10>\n                <ion-slides (ionSlideDidChange)="slideChanged()" [slidesPerView]="slidesShown" [dir]="direction" role="tablist" [attr.aria-label]="description" aria-hidden="false">\n                    <ng-container *ngFor="let tab of tabs; let idx = index">\n                       <ion-slide *ngIf="tab.show" [attr.aria-selected]="selected == idx" (click)="selectTab(idx)" class="tab-slide" [attr.aria-label]="tab.title || \'\'" role="tab" [attr.aria-controls]="tab.id" [id]="tab.id + \'-tab\'" [tabindex]="selected == idx ? null : -1">\n                            <core-icon *ngIf="tab.icon" [name]="tab.icon"></core-icon>\n                            <div *ngIf="tab.title">{{ tab.title }}</div>\n                            <ion-badge *ngIf="tab.badge" [color]="tab.badgeStyle" class="tab-badge">{{tab.badge}}</ion-badge>\n                        </ion-slide>\n                    </ng-container>\n                </ion-slides>\n            </ion-col>\n            <ion-col class="col-with-arrow" (click)="slideNext()" no-padding col-1>\n                <ion-icon *ngIf="showNextButton" name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n            </ion-col>\n        </ion-row>\n    </div>\n    <div class="core-tabs-content-container" #originalTabs>\n        <ng-content></ng-content>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\tabs\core-tabs.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], CoreTabsComponent);
    return CoreTabsComponent;
}());

//# sourceMappingURL=tabs.js.map

/***/ }),
/* 152 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__offline__ = __webpack_require__(133);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__assessment_strategy_delegate__ = __webpack_require__(129);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Helper to gather some common functions for workshop.
 */
var AddonModWorkshopHelperProvider = /** @class */ (function () {
    function AddonModWorkshopHelperProvider(translate, fileProvider, uploaderProvider, sitesProvider, textUtils, utils, workshopProvider, workshopOffline, strategyDelegate) {
        this.translate = translate;
        this.fileProvider = fileProvider;
        this.uploaderProvider = uploaderProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.utils = utils;
        this.workshopProvider = workshopProvider;
        this.workshopOffline = workshopOffline;
        this.strategyDelegate = strategyDelegate;
    }
    /**
     * Get a task by code.
     *
     * @param  {any[]}  tasks    Array of tasks.
     * @param  {string} taskCode Unique task code.
     * @return {any}             Task requested
     */
    AddonModWorkshopHelperProvider.prototype.getTask = function (tasks, taskCode) {
        for (var x in tasks) {
            if (tasks[x].code == taskCode) {
                return tasks[x];
            }
        }
        return false;
    };
    /**
     * Check is task code is done.
     *
     * @param  {any[]}  tasks    Array of tasks.
     * @param  {string} taskCode Unique task code.
     * @return {boolean}         True if task is completed.
     */
    AddonModWorkshopHelperProvider.prototype.isTaskDone = function (tasks, taskCode) {
        var task = this.getTask(tasks, taskCode);
        if (task) {
            return task.completed;
        }
        // Task not found, assume true.
        return true;
    };
    /**
     * Return if a user can submit a workshop.
     *
     * @param  {any}   workshop Workshop info.
     * @param  {any}   access   Access information.
     * @param  {any[]} tasks    Array of tasks.
     * @return {boolean}        True if the user can submit the workshop.
     */
    AddonModWorkshopHelperProvider.prototype.canSubmit = function (workshop, access, tasks) {
        var examplesMust = workshop.useexamples && workshop.examplesmode == __WEBPACK_IMPORTED_MODULE_7__workshop__["a" /* AddonModWorkshopProvider */].EXAMPLES_BEFORE_SUBMISSION;
        var examplesDone = access.canmanageexamples || workshop.examplesmode == __WEBPACK_IMPORTED_MODULE_7__workshop__["a" /* AddonModWorkshopProvider */].EXAMPLES_VOLUNTARY ||
            this.isTaskDone(tasks, 'examples');
        return workshop.phase > __WEBPACK_IMPORTED_MODULE_7__workshop__["a" /* AddonModWorkshopProvider */].PHASE_SETUP && access.cansubmit && (!examplesMust || examplesDone);
    };
    /**
     * Return if a user can assess a workshop.
     *
     * @param  {any} workshop Workshop info.
     * @param  {any} access   Access information.
     * @return {boolean}      True if the user can assess the workshop.
     */
    AddonModWorkshopHelperProvider.prototype.canAssess = function (workshop, access) {
        var examplesMust = workshop.useexamples && workshop.examplesmode == __WEBPACK_IMPORTED_MODULE_7__workshop__["a" /* AddonModWorkshopProvider */].EXAMPLES_BEFORE_ASSESSMENT;
        var examplesDone = access.canmanageexamples;
        return !examplesMust || examplesDone;
    };
    /**
     * Return a particular user submission from the submission list.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {number} [userId]   User ID. If not defined current user Id.
     * @return {Promise<any>}      Resolved with the submission, resolved with false if not found.
     */
    AddonModWorkshopHelperProvider.prototype.getUserSubmission = function (workshopId, userId) {
        var _this = this;
        if (userId === void 0) { userId = 0; }
        return this.workshopProvider.getSubmissions(workshopId).then(function (submissions) {
            userId = userId || _this.sitesProvider.getCurrentSiteUserId();
            for (var x in submissions) {
                if (submissions[x].authorid == userId) {
                    return submissions[x];
                }
            }
            return false;
        });
    };
    /**
     * Return a particular submission. It will use prefetched data if fetch fails.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} submissionId Submission ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Resolved with the submission, resolved with false if not found.
     */
    AddonModWorkshopHelperProvider.prototype.getSubmissionById = function (workshopId, submissionId, siteId) {
        var _this = this;
        return this.workshopProvider.getSubmission(workshopId, submissionId, siteId).catch(function () {
            return _this.workshopProvider.getSubmissions(workshopId, undefined, undefined, undefined, undefined, siteId)
                .then(function (submissions) {
                for (var x in submissions) {
                    if (submissions[x].id == submissionId) {
                        return submissions[x];
                    }
                }
                return false;
            });
        });
    };
    /**
     * Return a particular assesment. It will use prefetched data if fetch fails. It will add assessment form data.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {number} [userId]     User ID. If not defined, current user.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Resolved with the assessment.
     */
    AddonModWorkshopHelperProvider.prototype.getReviewerAssessmentById = function (workshopId, assessmentId, userId, siteId) {
        var _this = this;
        if (userId === void 0) { userId = 0; }
        return this.workshopProvider.getAssessment(workshopId, assessmentId, siteId).catch(function (error) {
            return _this.workshopProvider.getReviewerAssessments(workshopId, userId, undefined, undefined, siteId)
                .then(function (assessments) {
                for (var x in assessments) {
                    if (assessments[x].id == assessmentId) {
                        return assessments[x];
                    }
                }
                // Not found, return original error.
                return Promise.reject(error);
            });
        }).then(function (assessment) {
            return _this.workshopProvider.getAssessmentForm(workshopId, assessmentId, undefined, undefined, undefined, siteId)
                .then(function (assessmentForm) {
                assessment.form = assessmentForm;
                return assessment;
            });
        });
    };
    /**
     * Retrieves the assessment of the given user and all the related data.
     *
     * @param  {number}  workshopId          Workshop ID.
     * @param  {number}  [userId=0]          User ID. If not defined, current user.
     * @param  {boolean} [offline=false]     True if it should return cached data. Has priority over ignoreCache.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any[]>}              Promise resolved when the workshop data is retrieved.
     */
    AddonModWorkshopHelperProvider.prototype.getReviewerAssessments = function (workshopId, userId, offline, ignoreCache, siteId) {
        var _this = this;
        if (userId === void 0) { userId = 0; }
        if (offline === void 0) { offline = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.workshopProvider.getReviewerAssessments(workshopId, userId, offline, ignoreCache, siteId)
            .then(function (assessments) {
            var promises = assessments.map(function (assessment) {
                return _this.getSubmissionById(workshopId, assessment.submissionid, siteId).then(function (submission) {
                    assessment.submission = submission;
                });
            });
            return Promise.all(promises).then(function () {
                return assessments;
            });
        });
    };
    /**
     * Delete stored attachment files for a submission.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId If not editing, it will refer to timecreated.
     * @param  {boolean} editing      If the submission is being edited or added otherwise.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when deleted.
     */
    AddonModWorkshopHelperProvider.prototype.deleteSubmissionStoredFiles = function (workshopId, submissionId, editing, siteId) {
        var _this = this;
        return this.workshopOffline.getSubmissionFolder(workshopId, submissionId, editing, siteId).then(function (folderPath) {
            return _this.fileProvider.removeDir(folderPath).catch(function () {
                // Ignore any errors, CoreFileProvider.removeDir fails if folder doesn't exists.
            });
        });
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be submitted later.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId If not editing, it will refer to timecreated.
     * @param  {boolean} editing      If the submission is being edited or added otherwise.
     * @param  {any[]}   files        List of files.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved if success, rejected otherwise.
     */
    AddonModWorkshopHelperProvider.prototype.storeSubmissionFiles = function (workshopId, submissionId, editing, files, siteId) {
        var _this = this;
        // Get the folder where to store the files.
        return this.workshopOffline.getSubmissionFolder(workshopId, submissionId, editing, siteId).then(function (folderPath) {
            return _this.uploaderProvider.storeFilesToUpload(folderPath, files);
        });
    };
    /**
     * Upload or store some files for a submission, depending if the user is offline or not.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId If not editing, it will refer to timecreated.
     * @param  {any[]}   files        List of files.
     * @param  {boolean} editing      If the submission is being edited or added otherwise.
     * @param  {boolean} offline      True if files sould be stored for offline, false to upload them.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved if success.
     */
    AddonModWorkshopHelperProvider.prototype.uploadOrStoreSubmissionFiles = function (workshopId, submissionId, files, editing, offline, siteId) {
        if (offline) {
            return this.storeSubmissionFiles(workshopId, submissionId, editing, files, siteId);
        }
        else {
            return this.uploaderProvider.uploadOrReuploadFiles(files, __WEBPACK_IMPORTED_MODULE_7__workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, workshopId, siteId);
        }
    };
    /**
     * Get a list of stored attachment files for a submission. See AddonModWorkshopHelperProvider#storeFiles.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId If not editing, it will refer to timecreated.
     * @param  {boolean} editing      If the submission is being edited or added otherwise.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any[]>}       Promise resolved with the files.
     */
    AddonModWorkshopHelperProvider.prototype.getStoredSubmissionFiles = function (workshopId, submissionId, editing, siteId) {
        var _this = this;
        return this.workshopOffline.getSubmissionFolder(workshopId, submissionId, editing, siteId).then(function (folderPath) {
            return _this.uploaderProvider.getStoredFiles(folderPath).catch(function () {
                // Ignore not found files.
                return [];
            });
        });
    };
    /**
     * Get a list of stored attachment files for a submission and online files also. See AddonModWorkshopHelperProvider#storeFiles.
     *
     * @param  {any}     filesObject  Files object combining offline and online information.
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  submissionId If not editing, it will refer to timecreated.
     * @param  {boolean} editing      If the submission is being edited or added otherwise.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any[]>}       Promise resolved with the files.
     */
    AddonModWorkshopHelperProvider.prototype.getSubmissionFilesFromOfflineFilesObject = function (filesObject, workshopId, submissionId, editing, siteId) {
        var _this = this;
        return this.workshopOffline.getSubmissionFolder(workshopId, submissionId, editing, siteId).then(function (folderPath) {
            return _this.uploaderProvider.getStoredFilesFromOfflineFilesObject(filesObject, folderPath);
        });
    };
    /**
     * Delete stored attachment files for an assessment.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when deleted.
     */
    AddonModWorkshopHelperProvider.prototype.deleteAssessmentStoredFiles = function (workshopId, assessmentId, siteId) {
        var _this = this;
        return this.workshopOffline.getAssessmentFolder(workshopId, assessmentId, siteId).then(function (folderPath) {
            return _this.fileProvider.removeDir(folderPath).catch(function () {
                // Ignore any errors, CoreFileProvider.removeDir fails if folder doesn't exists.
            });
        });
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be submitted later.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {any[]}  files        List of files.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if success, rejected otherwise.
     */
    AddonModWorkshopHelperProvider.prototype.storeAssessmentFiles = function (workshopId, assessmentId, files, siteId) {
        var _this = this;
        // Get the folder where to store the files.
        return this.workshopOffline.getAssessmentFolder(workshopId, assessmentId, siteId).then(function (folderPath) {
            return _this.uploaderProvider.storeFilesToUpload(folderPath, files);
        });
    };
    /**
     * Upload or store some files for an assessment, depending if the user is offline or not.
     *
     * @param  {number}  workshopId   Workshop ID.
     * @param  {number}  assessmentId ID.
     * @param  {any[]}   files        List of files.
     * @param  {boolean} offline      True if files sould be stored for offline, false to upload them.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved if success.
     */
    AddonModWorkshopHelperProvider.prototype.uploadOrStoreAssessmentFiles = function (workshopId, assessmentId, files, offline, siteId) {
        if (offline) {
            return this.storeAssessmentFiles(workshopId, assessmentId, files, siteId);
        }
        else {
            return this.uploaderProvider.uploadOrReuploadFiles(files, __WEBPACK_IMPORTED_MODULE_7__workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, workshopId, siteId);
        }
    };
    /**
     * Get a list of stored attachment files for an assessment. See AddonModWorkshopHelperProvider#storeFiles.
     *
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the files.
     */
    AddonModWorkshopHelperProvider.prototype.getStoredAssessmentFiles = function (workshopId, assessmentId, siteId) {
        var _this = this;
        return this.workshopOffline.getAssessmentFolder(workshopId, assessmentId, siteId).then(function (folderPath) {
            return _this.uploaderProvider.getStoredFiles(folderPath).catch(function () {
                // Ignore not found files.
                return [];
            });
        });
    };
    /**
     * Get a list of stored attachment files for an assessment and online files also. See AddonModWorkshopHelperProvider#storeFiles.
     *
     * @param  {object} filesObject  Files object combining offline and online information.
     * @param  {number} workshopId   Workshop ID.
     * @param  {number} assessmentId Assessment ID.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the files.
     */
    AddonModWorkshopHelperProvider.prototype.getAssessmentFilesFromOfflineFilesObject = function (filesObject, workshopId, assessmentId, siteId) {
        var _this = this;
        return this.workshopOffline.getAssessmentFolder(workshopId, assessmentId, siteId).then(function (folderPath) {
            return _this.uploaderProvider.getStoredFilesFromOfflineFilesObject(filesObject, folderPath);
        });
    };
    /**
     * Returns the action of a given submission.
     *
     * @param  {any[]}  actions      Offline actions to be applied to the given submission.
     * @param  {number} submissionId ID of the submission to filter by or false.
     * @return {any[]}               Promise resolved with the files.
     */
    AddonModWorkshopHelperProvider.prototype.filterSubmissionActions = function (actions, submissionId) {
        return actions.filter(function (action) {
            if (submissionId) {
                return action.submissionid == submissionId;
            }
            else {
                return action.submissionid < 0;
            }
        });
    };
    /**
     * Applies offline data to submission.
     *
     * @param  {any}   submission Submission object to be modified.
     * @param  {any[]} actions    Offline actions to be applied to the given submission.
     * @return {Promise<any>}     Promise resolved with the files.
     */
    AddonModWorkshopHelperProvider.prototype.applyOfflineData = function (submission, actions) {
        if (actions.length && !submission) {
            submission = {};
        }
        var editing = true, attachmentsid = false, workshopId;
        actions.forEach(function (action) {
            switch (action.action) {
                case 'add':
                    submission.id = action.submissionid;
                    editing = false;
                case 'update':
                    submission.title = action.title;
                    submission.content = action.content;
                    submission.title = action.title;
                    submission.courseid = action.courseid;
                    submission.submissionmodified = parseInt(action.timemodified, 10) / 1000;
                    submission.offline = true;
                    attachmentsid = action.attachmentsid;
                    workshopId = action.workshopid;
                    break;
                case 'delete':
                    submission.deleted = true;
                    submission.submissionmodified = parseInt(action.timemodified, 10) / 1000;
                    break;
                default:
            }
        });
        // Check offline files for latest attachmentsid.
        if (actions.length) {
            if (attachmentsid) {
                return this.getSubmissionFilesFromOfflineFilesObject(attachmentsid, workshopId, submission.id, editing)
                    .then(function (files) {
                    submission.attachmentfiles = files;
                    return submission;
                });
            }
            else {
                submission.attachmentfiles = [];
            }
        }
        return Promise.resolve(submission);
    };
    /**
     * Prepare assessment data to be sent to the server.
     *
     * @param {any}    workshop       Workshop object.
     * @param {any[]}  selectedValues Assessment current values
     * @param {string} feedbackText   Feedback text.
     * @param {any[]}  feedbackFiles  Feedback attachments.
     * @param {any}    form           Assessment form original data.
     * @param {number} attachmentsId  The draft file area id for attachments.
     * @return {Promise<any>}         Promise resolved with the data to be sent. Or rejected with the input errors object.
     */
    AddonModWorkshopHelperProvider.prototype.prepareAssessmentData = function (workshop, selectedValues, feedbackText, feedbackFiles, form, attachmentsId) {
        if (workshop.overallfeedbackmode == 2 && !feedbackText) {
            return Promise.reject({ feedbackauthor: this.translate.instant('core.err_required') });
        }
        return this.strategyDelegate.prepareAssessmentData(workshop.strategy, selectedValues, form).then(function (data) {
            data.feedbackauthor = feedbackText;
            data.feedbackauthorattachmentsid = attachmentsId || 0;
            data.nodims = form.dimenssionscount;
            return data;
        });
    };
    /**
     * Calculates the real value of a grade based on real_grade_value.
     *
     * @param  {number} value    Percentual value from 0 to 100.
     * @param  {number} max      The maximal grade.
     * @param  {number} decimals Decimals to show in the formatted grade.
     * @return {string}          Real grade formatted.
     */
    AddonModWorkshopHelperProvider.prototype.realGradeValueHelper = function (value, max, decimals) {
        if (value == null) {
            return null;
        }
        else if (max == 0) {
            return '0';
        }
        else {
            value = this.textUtils.roundToDecimals(max * value / 100, decimals);
            return this.utils.formatFloat(value);
        }
    };
    /**
     * Calculates the real value of a grades of an assessment.
     *
     * @param  {any} workshop   Workshop object.
     * @param  {any} assessment Assessment data.
     * @return {any}            Assessment with real grades.
     */
    AddonModWorkshopHelperProvider.prototype.realGradeValue = function (workshop, assessment) {
        assessment.grade = this.realGradeValueHelper(assessment.grade, workshop.grade, workshop.gradedecimals);
        assessment.gradinggrade = this.realGradeValueHelper(assessment.gradinggrade, workshop.gradinggrade, workshop.gradedecimals);
        assessment.gradinggradeover = this.realGradeValueHelper(assessment.gradinggradeover, workshop.gradinggrade, workshop.gradedecimals);
        return assessment;
    };
    /**
     * Check grade should be shown
     *
     * @param  {any} grade Grade to be shown
     * @return {boolean}   If grade should be shown or not.
     */
    AddonModWorkshopHelperProvider.prototype.showGrade = function (grade) {
        return typeof grade !== 'undefined' && grade !== null;
    };
    AddonModWorkshopHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_2__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__workshop__["a" /* AddonModWorkshopProvider */],
            __WEBPACK_IMPORTED_MODULE_8__offline__["a" /* AddonModWorkshopOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */]])
    ], AddonModWorkshopHelperProvider);
    return AddonModWorkshopHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 153 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__offline__ = __webpack_require__(191);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_rating_providers_offline__ = __webpack_require__(157);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * Service that provides helper functions for datas.
 */
var AddonModDataHelperProvider = /** @class */ (function () {
    function AddonModDataHelperProvider(sitesProvider, dataProvider, translate, fieldsDelegate, dataOffline, fileUploaderProvider, textUtils, eventsProvider, utils, domUtils, courseProvider, ratingOffline) {
        this.sitesProvider = sitesProvider;
        this.dataProvider = dataProvider;
        this.translate = translate;
        this.fieldsDelegate = fieldsDelegate;
        this.dataOffline = dataOffline;
        this.fileUploaderProvider = fileUploaderProvider;
        this.textUtils = textUtils;
        this.eventsProvider = eventsProvider;
        this.utils = utils;
        this.domUtils = domUtils;
        this.courseProvider = courseProvider;
        this.ratingOffline = ratingOffline;
    }
    /**
     * Returns the record with the offline actions applied.
     *
     * @param {AddonModDataEntry} record Entry to modify.
     * @param {AddonModDataOfflineAction[]} offlineActions Offline data with the actions done.
     * @param {any[]} fields Entry defined fields indexed by fieldid.
     * @return {Promise<AddonModDataEntry>} Promise resolved when done.
     */
    AddonModDataHelperProvider.prototype.applyOfflineActions = function (record, offlineActions, fields) {
        var _this = this;
        var promises = [];
        offlineActions.forEach(function (action) {
            record.timemodified = action.timemodified;
            record.hasOffline = true;
            switch (action.action) {
                case 'approve':
                    record.approved = true;
                    break;
                case 'disapprove':
                    record.approved = false;
                    break;
                case 'delete':
                    record.deleted = true;
                    break;
                case 'add':
                case 'edit':
                    record.groupid = action.groupid;
                    var offlineContents_1 = {};
                    action.fields.forEach(function (offlineContent) {
                        if (typeof offlineContents_1[offlineContent.fieldid] == 'undefined') {
                            offlineContents_1[offlineContent.fieldid] = {};
                        }
                        if (offlineContent.subfield) {
                            offlineContents_1[offlineContent.fieldid][offlineContent.subfield] =
                                _this.textUtils.parseJSON(offlineContent.value);
                        }
                        else {
                            offlineContents_1[offlineContent.fieldid][''] = _this.textUtils.parseJSON(offlineContent.value);
                        }
                    });
                    // Override field contents.
                    fields.forEach(function (field) {
                        if (_this.fieldsDelegate.hasFiles(field)) {
                            promises.push(_this.getStoredFiles(record.dataid, record.id, field.id).then(function (offlineFiles) {
                                record.contents[field.id] = _this.fieldsDelegate.overrideData(field, record.contents[field.id], offlineContents_1[field.id], offlineFiles);
                                record.contents[field.id].fieldid = field.id;
                            }));
                        }
                        else {
                            record.contents[field.id] = _this.fieldsDelegate.overrideData(field, record.contents[field.id], offlineContents_1[field.id]);
                            record.contents[field.id].fieldid = field.id;
                        }
                    });
                    break;
                default:
                    break;
            }
        });
        return Promise.all(promises).then(function () {
            return record;
        });
    };
    /**
     * Approve or disapprove a database entry.
     *
     * @param {number} dataId Database ID.
     * @param {number} entryId Entry ID.
     * @param {boolaen} approve True to approve, false to disapprove.
     * @param {number} [courseId] Course ID. It not defined, it will be fetched.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    AddonModDataHelperProvider.prototype.approveOrDisapproveEntry = function (dataId, entryId, approve, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var modal = this.domUtils.showModalLoading('core.sending', true);
        this.getActivityCourseIdIfNotSet(dataId, courseId, siteId).then(function (courseId) {
            // Approve/disapprove entry.
            return _this.dataProvider.approveEntry(dataId, entryId, approve, courseId, siteId).catch(function (message) {
                _this.domUtils.showErrorModalDefault(message, 'addon.mod_data.errorapproving', true);
                return Promise.reject(null);
            });
        }).then(function () {
            var promises = [];
            promises.push(_this.dataProvider.invalidateEntryData(dataId, entryId, siteId));
            promises.push(_this.dataProvider.invalidateEntriesData(dataId, siteId));
            return Promise.all(promises).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_11__data__["a" /* AddonModDataProvider */].ENTRY_CHANGED, { dataId: dataId, entryId: entryId }, siteId);
            _this.domUtils.showToast(approve ? 'addon.mod_data.recordapproved' : 'addon.mod_data.recorddisapproved', true, 3000);
        }).catch(function () {
            // Ignore error, it was already displayed.
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Displays fields for being shown.
     *
     * @param {string} template Template HMTL.
     * @param {any[]} fields Fields that defines every content in the entry.
     * @param {any} entry Entry.
     * @param {number} offset Entry offset.
     * @param {string} mode Mode list or show.
     * @param {AddonModDataOfflineAction[]} actions Actions that can be performed to the record.
     * @return {string} Generated HTML.
     */
    AddonModDataHelperProvider.prototype.displayShowFields = function (template, fields, entry, offset, mode, actions) {
        if (!template) {
            return '';
        }
        var replace, render;
        // Replace the fields found on template.
        fields.forEach(function (field) {
            replace = '[[' + field.name + ']]';
            replace = replace.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
            replace = new RegExp(replace, 'gi');
            // Replace field by a generic directive.
            render = '<addon-mod-data-field-plugin [field]="fields[' + field.id + ']" [value]="entries[' + entry.id +
                '].contents[' + field.id + ']" mode="' + mode + '" [database]="data" (gotoEntry)="gotoEntry(' + entry.id +
                ')"></addon-mod-data-field-plugin>';
            template = template.replace(replace, render);
        });
        for (var action in actions) {
            replace = new RegExp('##' + action + '##', 'gi');
            // Is enabled?
            if (actions[action]) {
                if (action == 'moreurl') {
                    // Render more url directly because it can be part of an HTML attribute.
                    render = this.sitesProvider.getCurrentSite().getURL() + '/mod/data/view.php?d={{data.id}}&rid=' + entry.id;
                }
                else if (action == 'approvalstatus') {
                    render = this.translate.instant('addon.mod_data.' + (entry.approved ? 'approved' : 'notapproved'));
                }
                else {
                    render = '<addon-mod-data-action action="' + action + '" [entry]="entries[' + entry.id + ']" mode="' + mode +
                        '" [database]="data" [module]="module" [offset]="' + offset + '" [group]="group" ></addon-mod-data-action>';
                }
                template = template.replace(replace, render);
            }
            else {
                template = template.replace(replace, '');
            }
        }
        return template;
    };
    /**
     * Get online and offline entries, or search entries.
     *
     * @param   {any}       data               Database object.
     * @param   {any[]}     fields             The fields that define the contents.
     * @param   {number}    [groupId=0]        Group ID.
     * @param   {string}    [search]           Search text. It will be used if advSearch is not defined.
     * @param   {any[]}     [advSearch]        Advanced search data.
     * @param   {string}    [sort=0]           Sort the records by this field id, reserved ids are:
     *                                            0: timeadded
     *                                           -1: firstname
     *                                           -2: lastname
     *                                           -3: approved
     *                                           -4: timemodified.
     *                                          Empty for using the default database setting.
     * @param   {string}    [order=DESC]        The direction of the sorting: 'ASC' or 'DESC'.
     *                                          Empty for using the default database setting.
     * @param   {number}    [page=0]            Page of records to return.
     * @param   {number}    [perPage=PER_PAGE]  Records per page to return. Default on PER_PAGE.
     * @param   {string}    [siteId]            Site ID. If not defined, current site.
     * @return  {Promise<AddonModDataEntries>}  Promise resolved when the database is retrieved.
     */
    AddonModDataHelperProvider.prototype.fetchEntries = function (data, fields, groupId, search, advSearch, sort, order, page, perPage, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (sort === void 0) { sort = '0'; }
        if (order === void 0) { order = 'DESC'; }
        if (page === void 0) { page = 0; }
        if (perPage === void 0) { perPage = __WEBPACK_IMPORTED_MODULE_11__data__["a" /* AddonModDataProvider */].PER_PAGE; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var offlineActions = {};
            var result = {
                entries: [],
                totalcount: 0,
                offlineEntries: []
            };
            var offlinePromise = _this.dataOffline.getDatabaseEntries(data.id, site.id).then(function (actions) {
                result.hasOfflineActions = !!actions.length;
                actions.forEach(function (action) {
                    if (typeof offlineActions[action.entryid] == 'undefined') {
                        offlineActions[action.entryid] = [];
                    }
                    offlineActions[action.entryid].push(action);
                    // We only display new entries in the first page when not searching.
                    if (action.action == 'add' && page == 0 && !search && !advSearch &&
                        (!action.groupid || !groupId || action.groupid == groupId)) {
                        result.offlineEntries.push({
                            id: action.entryid,
                            canmanageentry: true,
                            approved: !data.approval || data.manageapproved,
                            dataid: data.id,
                            groupid: action.groupid,
                            timecreated: -action.entryid,
                            timemodified: -action.entryid,
                            userid: site.getUserId(),
                            fullname: site.getInfo().fullname,
                            contents: {}
                        });
                    }
                });
                // Sort offline entries by creation time.
                result.offlineEntries.sort(function (entry1, entry2) { return entry2.timecreated - entry1.timecreated; });
            });
            var ratingsPromise = _this.ratingOffline.hasRatings('mod_data', 'entry', 'module', data.coursemodule)
                .then(function (hasRatings) {
                result.hasOfflineRatings = hasRatings;
            });
            var fetchPromise;
            if (search || advSearch) {
                fetchPromise = _this.dataProvider.searchEntries(data.id, groupId, search, advSearch, sort, order, page, perPage, site.id).then(function (fetchResult) {
                    result.entries = fetchResult.entries;
                    result.totalcount = fetchResult.totalcount;
                    result.maxcount = fetchResult.maxcount;
                });
            }
            else {
                fetchPromise = _this.dataProvider.getEntries(data.id, groupId, sort, order, page, perPage, false, false, site.id)
                    .then(function (fetchResult) {
                    result.entries = fetchResult.entries;
                    result.totalcount = fetchResult.totalcount;
                });
            }
            return Promise.all([offlinePromise, ratingsPromise, fetchPromise]).then(function () {
                // Apply offline actions to online and offline entries.
                var promises = [];
                result.entries.forEach(function (entry) {
                    promises.push(_this.applyOfflineActions(entry, offlineActions[entry.id] || [], fields));
                });
                result.offlineEntries.forEach(function (entry) {
                    promises.push(_this.applyOfflineActions(entry, offlineActions[entry.id] || [], fields));
                });
                return Promise.all(promises);
            }).then(function () {
                return result;
            });
        });
    };
    /**
     * Fetch an online or offline entry.
     *
     * @param {any} data Database.
     * @param {any[]} fields List of database fields.
     * @param {number} entryId Entry ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{entry: AddonModDataEntry, ratinginfo?: CoreRatingInfo}>} Promise resolved with the entry.
     */
    AddonModDataHelperProvider.prototype.fetchEntry = function (data, fields, entryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.dataOffline.getEntryActions(data.id, entryId, site.id).then(function (offlineActions) {
                var promise;
                if (entryId > 0) {
                    // Online entry.
                    promise = _this.dataProvider.getEntry(data.id, entryId, false, site.id);
                }
                else {
                    // Offline entry or new entry.
                    promise = Promise.resolve({
                        entry: {
                            id: entryId,
                            userid: site.getUserId(),
                            groupid: 0,
                            dataid: data.id,
                            timecreated: -entryId,
                            timemodified: -entryId,
                            approved: !data.approval || data.manageapproved,
                            canmanageentry: true,
                            fullname: site.getInfo().fullname,
                            contents: [],
                        }
                    });
                }
                return promise.then(function (response) {
                    return _this.applyOfflineActions(response.entry, offlineActions, fields).then(function () {
                        return response;
                    });
                });
            });
        });
    };
    /**
     * Returns an object with all the actions that the user can do over the record.
     *
     * @param {any}  database     Database activity.
     * @param {any}  accessInfo   Access info to the activity.
     * @param {any}  record       Entry or record where the actions will be performed.
     * @return {any}              Keyed with the action names and boolean to evalute if it can or cannot be done.
     */
    AddonModDataHelperProvider.prototype.getActions = function (database, accessInfo, record) {
        return {
            more: true,
            moreurl: true,
            user: true,
            userpicture: true,
            timeadded: true,
            timemodified: true,
            edit: record.canmanageentry && !record.deleted,
            delete: record.canmanageentry,
            approve: database.approval && accessInfo.canapprove && !record.approved && !record.deleted,
            disapprove: database.approval && accessInfo.canapprove && record.approved && !record.deleted,
            approvalstatus: database.approval,
            comments: database.comments,
            // Unsupported actions.
            tags: false,
            delcheck: false,
            export: false
        };
    };
    /**
     * Convenience function to get the course id of the database.
     *
     * @param {number} dataId Database id.
     * @param {number} [courseId] Course id, if known.
     * @param {string} [siteId] Site id, if not set, current site will be used.
     * @return {Promise<number>} Resolved with course Id when done.
     */
    AddonModDataHelperProvider.prototype.getActivityCourseIdIfNotSet = function (dataId, courseId, siteId) {
        if (courseId) {
            return Promise.resolve(courseId);
        }
        return this.courseProvider.getModuleBasicInfoByInstance(dataId, 'data', siteId).then(function (module) {
            return module.course;
        });
    };
    /**
     * Returns the default template of a certain type.
     *
     * Based on Moodle function data_generate_default_template.
     *
     * @param {string} type Type of template.
     * @param {any[]} fields List of database fields.
     * @return {string} Template HTML.
     */
    AddonModDataHelperProvider.prototype.getDefaultTemplate = function (type, fields) {
        var html = [];
        if (type == 'list') {
            html.push('##delcheck##<br />');
        }
        html.push('<div class="defaulttemplate">', '<table class="mod-data-default-template ##approvalstatus##">', '<tbody>');
        fields.forEach(function (field) {
            html.push('<tr class="">', '<td class="template-field cell c0" style="">', field.name, ': </td>', '<td class="template-token cell c1 lastcol" style="">[[', field.name, ']]</td>', '</tr>');
        });
        if (type == 'list') {
            html.push('<tr class="lastrow">', '<td class="controls template-field cell c0 lastcol" style="" colspan="2">', '##edit##  ##more##  ##delete##  ##approve##  ##disapprove##  ##export##', '</td>', '</tr>');
        }
        else if (type == 'single') {
            html.push('<tr class="lastrow">', '<td class="controls template-field cell c0 lastcol" style="" colspan="2">', '##edit##  ##delete##  ##approve##  ##disapprove##  ##export##', '</td>', '</tr>');
        }
        else if (type == 'asearch') {
            html.push('<tr class="searchcontrols">', '<td class="template-field cell c0" style="">Author first name: </td>', '<td class="template-token cell c1 lastcol" style="">##firstname##</td>', '</tr>', '<tr class="searchcontrols lastrow">', '<td class="template-field cell c0" style="">Author surname: </td>', '<td class="template-token cell c1 lastcol" style="">##lastname##</td>', '</tr>');
        }
        html.push('</tbody>', '</table>', '</div>');
        if (type == 'list') {
            html.push('<hr />');
        }
        return html.join('');
    };
    /**
     * Retrieve the entered data in the edit form.
     * We don't use ng-model because it doesn't detect changes done by JavaScript.
     *
     * @param {any} inputData Array with the entered form values.
     * @param {Array} fields Fields that defines every content in the entry.
     * @param {number} [dataId] Database Id. If set, files will be uploaded and itemId set.
     * @param {number} entryId Entry Id.
     * @param {AddonModDataEntryFields} entryContents Original entry contents.
     * @param {boolean} offline True to prepare the data for an offline uploading, false otherwise.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} That contains object with the answers.
     */
    AddonModDataHelperProvider.prototype.getEditDataFromForm = function (inputData, fields, dataId, entryId, entryContents, offline, siteId) {
        var _this = this;
        if (offline === void 0) { offline = false; }
        if (!inputData) {
            return Promise.resolve({});
        }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Filter and translate fields to each field plugin.
        var edit = [], promises = [];
        fields.forEach(function (field) {
            promises.push(Promise.resolve(_this.fieldsDelegate.getFieldEditData(field, inputData, entryContents[field.id]))
                .then(function (fieldData) {
                if (fieldData) {
                    var proms_1 = [];
                    fieldData.forEach(function (data) {
                        var dataProm;
                        // Upload Files if asked.
                        if (dataId && data.files) {
                            dataProm = _this.uploadOrStoreFiles(dataId, 0, entryId, data.fieldid, data.files, offline, siteId)
                                .then(function (filesResult) {
                                delete data.files;
                                data.value = filesResult;
                            });
                        }
                        else {
                            dataProm = Promise.resolve();
                        }
                        proms_1.push(dataProm.then(function () {
                            if (data.value) {
                                data.value = JSON.stringify(data.value);
                            }
                            if (typeof data.subfield == 'undefined') {
                                data.subfield = '';
                            }
                            // WS wants values in Json format.
                            edit.push(data);
                        }));
                    });
                    return Promise.all(proms_1);
                }
            }));
        });
        return Promise.all(promises).then(function () {
            return edit;
        });
    };
    /**
     * Retrieve the temp files to be updated.
     *
     * @param {any} inputData Array with the entered form values.
     * @param {any[]} fields Fields that defines every content in the entry.
     * @param {number} [dataId] Database Id. If set, fils will be uploaded and itemId set.
     * @param {AddonModDataEntryFields} entryContents Original entry contents indexed by field id.
     * @return {Promise<any>} That contains object with the files.
     */
    AddonModDataHelperProvider.prototype.getEditTmpFiles = function (inputData, fields, dataId, entryContents) {
        var _this = this;
        if (!inputData) {
            return Promise.resolve([]);
        }
        // Filter and translate fields to each field plugin.
        var promises = fields.map(function (field) {
            return Promise.resolve(_this.fieldsDelegate.getFieldEditFiles(field, inputData, entryContents[field.id]));
        });
        return Promise.all(promises).then(function (fieldsFiles) {
            return fieldsFiles.reduce(function (files, fieldFiles) { return files.concat(fieldFiles); }, []);
        });
    };
    /**
     * Get a list of stored attachment files for a new entry. See $mmaModDataHelper#storeFiles.
     *
     * @param  {number} dataId     Database ID.
     * @param  {number} entryId    Entry ID or, if creating, timemodified.
     * @param  {number} fieldId    Field ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved with the files.
     */
    AddonModDataHelperProvider.prototype.getStoredFiles = function (dataId, entryId, fieldId, siteId) {
        var _this = this;
        return this.dataOffline.getEntryFieldFolder(dataId, entryId, fieldId, siteId).then(function (folderPath) {
            return _this.fileUploaderProvider.getStoredFiles(folderPath).catch(function () {
                // Ignore not found files.
                return [];
            });
        });
    };
    /**
     * Check if data has been changed by the user.
     *
     * @param {any} inputData Object with the entered form values.
     * @param {any[]} fields Fields that defines every content in the entry.
     * @param {number} [dataId] Database Id. If set, fils will be uploaded and itemId set.
     * @param {AddonModDataEntryFields} entryContents Original entry contents indexed by field id.
     * @return {Promise<boolean>} True if changed, false if not.
     */
    AddonModDataHelperProvider.prototype.hasEditDataChanged = function (inputData, fields, dataId, entryContents) {
        var _this = this;
        var promises = fields.map(function (field) {
            return _this.fieldsDelegate.hasFieldDataChanged(field, inputData, entryContents[field.id]);
        });
        // Will reject on first change detected.
        return Promise.all(promises).then(function () {
            // No changes.
            return false;
        }).catch(function () {
            // Has changes.
            return true;
        });
    };
    /**
     * Displays a confirmation modal for deleting an entry.
     *
     * @param {number} dataId Database ID.
     * @param {number} entryId Entry ID.
     * @param {number} [courseId] Course ID. It not defined, it will be fetched.
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    AddonModDataHelperProvider.prototype.showDeleteEntryModal = function (dataId, entryId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        this.domUtils.showConfirm(this.translate.instant('addon.mod_data.confirmdeleterecord')).then(function () {
            var modal = _this.domUtils.showModalLoading();
            return _this.getActivityCourseIdIfNotSet(dataId, courseId, siteId).then(function (courseId) {
                return _this.dataProvider.deleteEntry(dataId, entryId, courseId, siteId);
            }).catch(function (message) {
                _this.domUtils.showErrorModalDefault(message, 'addon.mod_data.errordeleting', true);
                return Promise.reject(null);
            }).then(function () {
                return _this.utils.allPromises([
                    _this.dataProvider.invalidateEntryData(dataId, entryId, siteId),
                    _this.dataProvider.invalidateEntriesData(dataId, siteId)
                ]).catch(function () {
                    // Ignore errors.
                });
            }).then(function () {
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_11__data__["a" /* AddonModDataProvider */].ENTRY_CHANGED, { dataId: dataId, entryId: entryId, deleted: true }, siteId);
                _this.domUtils.showToast('addon.mod_data.recorddeleted', true, 3000);
            }).finally(function () {
                modal.dismiss();
            });
        }).catch(function () {
            // Ignore error, it was already displayed.
        });
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be submitted later.
     *
     * @param  {number}   dataId   Database ID.
     * @param  {number}   entryId  Entry ID or, if creating, timemodified.
     * @param  {number}   fieldId  Field ID.
     * @param  {any[]}    files    List of files.
     * @param  {string}   [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved if success, rejected otherwise.
     */
    AddonModDataHelperProvider.prototype.storeFiles = function (dataId, entryId, fieldId, files, siteId) {
        var _this = this;
        // Get the folder where to store the files.
        return this.dataOffline.getEntryFieldFolder(dataId, entryId, fieldId, siteId).then(function (folderPath) {
            return _this.fileUploaderProvider.storeFilesToUpload(folderPath, files);
        });
    };
    /**
     * Upload or store some files, depending if the user is offline or not.
     *
     * @param  {number}   dataId     Database ID.
     * @param  {number}   [itemId=0] Draft ID to use. Undefined or 0 to create a new draft ID.
     * @param  {number}   entryId    Entry ID or, if creating, timemodified.
     * @param  {number}   fieldId    Field ID.
     * @param  {any[]}    files      List of files.
     * @param  {boolean}  offline    True if files sould be stored for offline, false to upload them.
     * @param  {string}   [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if success.
     */
    AddonModDataHelperProvider.prototype.uploadOrStoreFiles = function (dataId, itemId, entryId, fieldId, files, offline, siteId) {
        if (itemId === void 0) { itemId = 0; }
        if (files.length) {
            if (offline) {
                return this.storeFiles(dataId, entryId, fieldId, files, siteId);
            }
            return this.fileUploaderProvider.uploadOrReuploadFiles(files, __WEBPACK_IMPORTED_MODULE_11__data__["a" /* AddonModDataProvider */].COMPONENT, itemId, siteId);
        }
        return Promise.resolve(0);
    };
    AddonModDataHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_11__data__["a" /* AddonModDataProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_9__fields_delegate__["a" /* AddonModDataFieldsDelegate */],
            __WEBPACK_IMPORTED_MODULE_10__offline__["a" /* AddonModDataOfflineProvider */], __WEBPACK_IMPORTED_MODULE_8__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_rating_providers_offline__["a" /* CoreRatingOfflineProvider */]])
    ], AddonModDataHelperProvider);
    return AddonModDataHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 154 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRatingProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(157);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Service to handle ratings.
 */
var CoreRatingProvider = /** @class */ (function () {
    function CoreRatingProvider(appProvider, eventsProvider, sitesProvider, userProvider, utils, ratingOffline) {
        this.appProvider = appProvider;
        this.eventsProvider = eventsProvider;
        this.sitesProvider = sitesProvider;
        this.userProvider = userProvider;
        this.utils = utils;
        this.ratingOffline = ratingOffline;
        this.ROOT_CACHE_KEY = 'CoreRating:';
    }
    CoreRatingProvider_1 = CoreRatingProvider;
    /**
     * Returns whether the web serivce to add ratings is available.
     *
     * @return {boolean} If WS is abalaible.
     * @since 3.2
     */
    CoreRatingProvider.prototype.isAddRatingWSAvailable = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_rating_add_rating');
    };
    /**
     * Add a rating to an item.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Context instance id.
     * @param {number} itemId Item id. Example: forum post id.
     * @param {number} itemSetId Item set id. Example: forum discussion id.
     * @param {number} courseId Course id.
     * @param {number} scaleId Scale id.
     * @param {number} rating Rating value. Use CoreRatingProvider.UNSET_RATING to delete rating.
     * @param {number} ratedUserId Rated user id.
     * @param {number} aggregateMethod Aggregate method.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<CoreRatingItemRating|null>} Promise resolved with the aggregated rating or null if stored offline.
     * @since 3.2
     */
    CoreRatingProvider.prototype.addRating = function (component, ratingArea, contextLevel, instanceId, itemId, itemSetId, courseId, scaleId, rating, ratedUserId, aggregateMethod, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a rating to be synchronized later.
        var storeOffline = function () {
            return _this.ratingOffline.addRating(component, ratingArea, contextLevel, instanceId, itemId, itemSetId, courseId, scaleId, rating, ratedUserId, aggregateMethod, siteId).then(function () {
                _this.eventsProvider.trigger(CoreRatingProvider_1.RATING_SAVED_EVENT, {
                    component: component,
                    ratingArea: ratingArea,
                    contextLevel: contextLevel,
                    instanceId: instanceId,
                    itemSetId: itemSetId,
                    itemId: itemId
                }, siteId);
                return null;
            });
        };
        if (!this.appProvider.isOnline()) {
            // App is offline, store the action.
            return storeOffline();
        }
        return this.ratingOffline.deleteRating(component, ratingArea, contextLevel, instanceId, itemId, siteId).then(function () {
            return _this.addRatingOnline(component, ratingArea, contextLevel, instanceId, itemId, scaleId, rating, ratedUserId, aggregateMethod, siteId).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store offline.
                return storeOffline();
            });
        });
    };
    /**
     * Add a rating to an item. It will fail if offline or cannot connect.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Context instance id.
     * @param {number} itemId Item id. Example: forum post id.
     * @param {number} scaleId Scale id.
     * @param {number} rating Rating value. Use CoreRatingProvider.UNSET_RATING to delete rating.
     * @param {number} ratedUserId Rated user id.
     * @param {number} aggregateMethod Aggregate method.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<CoreRatingItemRating>} Promise resolved with the aggregated rating.
     * @since 3.2
     */
    CoreRatingProvider.prototype.addRatingOnline = function (component, ratingArea, contextLevel, instanceId, itemId, scaleId, rating, ratedUserId, aggregateMethod, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                contextlevel: contextLevel,
                instanceid: instanceId,
                component: component,
                ratingarea: ratingArea,
                itemid: itemId,
                scaleid: scaleId,
                rating: rating,
                rateduserid: ratedUserId,
                aggregation: aggregateMethod
            };
            return site.write('core_rating_add_rating', params).then(function (response) {
                return _this.invalidateRatingItems(contextLevel, instanceId, component, ratingArea, itemId, scaleId).then(function () {
                    _this.eventsProvider.trigger(CoreRatingProvider_1.AGGREGATE_CHANGED_EVENT, {
                        contextLevel: contextLevel,
                        instanceId: instanceId,
                        component: component,
                        ratingArea: ratingArea,
                        itemId: itemId,
                        aggregate: response.aggregate,
                        count: response.count
                    });
                    return response;
                });
            });
        });
    };
    /**
     * Get item ratings.
     *
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Context instance id.
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {number} itemId Item id. Example: forum post id.
     * @param {number} scaleId Scale id.
     * @param {string} [sort="timemodified"] Sort field.
     * @param {number} [courseId] Course id. Used for fetching user profiles.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<CoreRatingItemRating[]>} Promise resolved with the list of ratings.
     */
    CoreRatingProvider.prototype.getItemRatings = function (contextLevel, instanceId, component, ratingArea, itemId, scaleId, sort, courseId, siteId, ignoreCache) {
        var _this = this;
        if (sort === void 0) { sort = 'timemodified'; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                contextlevel: contextLevel,
                instanceid: instanceId,
                component: component,
                ratingarea: ratingArea,
                itemid: itemId,
                scaleid: scaleId,
                sort: sort
            };
            var preSets = {
                cacheKey: _this.getItemRatingsCacheKey(contextLevel, instanceId, component, ratingArea, itemId, scaleId, sort),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_1__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('core_rating_get_item_ratings', params, preSets).then(function (response) {
                if (!response || !response.ratings) {
                    return Promise.reject(null);
                }
                // We need to fetch profiles because the returned profile pictures are incorrect.
                var promises = response.ratings.map(function (rating) {
                    return _this.userProvider.getProfile(rating.userid, courseId, true, site.id).then(function (user) {
                        rating.userpictureurl = user.profileimageurl;
                    }).catch(function () {
                        // Ignore error.
                        rating.userpictureurl = null;
                    });
                });
                return Promise.all(promises).then(function () {
                    return response.ratings;
                });
            });
        });
    };
    /**
     * Invalidate item ratings.
     *
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Context instance id.
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {number} itemId Item id. Example: forum post id.
     * @param {number} scaleId Scale id.
     * @param {string} [sort="timemodified"] Sort field.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreRatingProvider.prototype.invalidateRatingItems = function (contextLevel, instanceId, component, ratingArea, itemId, scaleId, sort, siteId) {
        var _this = this;
        if (sort === void 0) { sort = 'timemodified'; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var key = _this.getItemRatingsCacheKey(contextLevel, instanceId, component, ratingArea, itemId, scaleId, sort);
            return site.invalidateWsCacheForKey(key);
        });
    };
    /**
     * Check if rating is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreRatingProvider.prototype.isRatingDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('NoDelegate_CoreRating');
    };
    /**
     * Check if rating is disabled in a certain site.
     *
     * @param  {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreRatingProvider.prototype.isRatingDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isRatingDisabledInSite(site);
        });
    };
    /**
     * Convenience function to merge two or more rating infos of the same instance.
     *
     * @param {CoreRatingInfo[]} ratingInfos Array of rating infos.
     * @return {CoreRatingInfo} Merged rating info or null.
     */
    CoreRatingProvider.prototype.mergeRatingInfos = function (ratingInfos) {
        var result = null;
        var scales = {};
        var ratings = {};
        ratingInfos.forEach(function (ratingInfo) {
            if (!ratingInfo) {
                // Skip null rating infos.
                return;
            }
            if (!result) {
                result = Object.assign({}, ratingInfo);
            }
            (ratingInfo.scales || []).forEach(function (scale) {
                scales[scale.id] = scale;
            });
            (ratingInfo.ratings || []).forEach(function (rating) {
                ratings[rating.itemid] = rating;
            });
        });
        if (result) {
            result.scales = this.utils.objectToArray(scales);
            result.ratings = this.utils.objectToArray(ratings);
        }
        return result;
    };
    /**
     * Prefetch individual ratings.
     *
     * This function should be called from the prefetch handler of activities with ratings.
     *
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Instance id.
     * @param {string} [siteId] Site id. If not defined, current site.
     * @param {number} [courseId] Course id. Used for prefetching user profiles.
     * @param {CoreRatingInfo} [ratingInfo] Rating info returned by web services.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreRatingProvider.prototype.prefetchRatings = function (contextLevel, instanceId, scaleId, courseId, ratingInfo, siteId) {
        var _this = this;
        if (!ratingInfo || !ratingInfo.ratings) {
            return Promise.resolve();
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = ratingInfo.ratings.map(function (item) {
                return _this.getItemRatings(contextLevel, instanceId, ratingInfo.component, ratingInfo.ratingarea, item.itemid, scaleId, undefined, courseId, site.id, true).then(function (ratings) {
                    var userIds = ratings.map(function (rating) { return rating.userid; });
                    return _this.userProvider.prefetchProfiles(userIds, courseId, site.id);
                });
            });
            return Promise.all(promises);
        });
    };
    /**
     * Get cache key for rating items WS calls.
     *
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {number} itemId Item id. Example: forum post id.
     * @param {number} scaleId Scale id.
     * @param {string} sort Sort field.
     * @return {string} Cache key.
     */
    CoreRatingProvider.prototype.getItemRatingsCacheKey = function (contextLevel, instanceId, component, ratingArea, itemId, scaleId, sort) {
        return "" + this.ROOT_CACHE_KEY + contextLevel + ":" + instanceId + ":" + component + ":" + ratingArea + ":" + itemId + ":" + scaleId + ":" + sort;
    };
    CoreRatingProvider.AGGREGATE_NONE = 0; // No ratings.
    CoreRatingProvider.AGGREGATE_AVERAGE = 1;
    CoreRatingProvider.AGGREGATE_COUNT = 2;
    CoreRatingProvider.AGGREGATE_MAXIMUM = 3;
    CoreRatingProvider.AGGREGATE_MINIMUM = 4;
    CoreRatingProvider.AGGREGATE_SUM = 5;
    CoreRatingProvider.UNSET_RATING = -999;
    CoreRatingProvider.AGGREGATE_CHANGED_EVENT = 'core_rating_aggregate_changed';
    CoreRatingProvider.RATING_SAVED_EVENT = 'core_rating_rating_saved';
    CoreRatingProvider = CoreRatingProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* CoreRatingOfflineProvider */]])
    ], CoreRatingProvider);
    return CoreRatingProvider;
    var CoreRatingProvider_1;
}());

//# sourceMappingURL=rating.js.map

/***/ }),
/* 155 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__offline__ = __webpack_require__(188);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service that provides some features for glossaries.
 */
var AddonModGlossaryProvider = /** @class */ (function () {
    function AddonModGlossaryProvider(appProvider, sitesProvider, filepoolProvider, translate, textUtils, utils, glossaryOffline, logHelper) {
        this.appProvider = appProvider;
        this.sitesProvider = sitesProvider;
        this.filepoolProvider = filepoolProvider;
        this.translate = translate;
        this.textUtils = textUtils;
        this.utils = utils;
        this.glossaryOffline = glossaryOffline;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModGlossary:';
    }
    AddonModGlossaryProvider_1 = AddonModGlossaryProvider;
    /**
     * Get the course glossary cache key.
     *
     * @param  {number} courseId Course Id.
     * @return {string}          Cache key.
     */
    AddonModGlossaryProvider.prototype.getCourseGlossariesCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'courseGlossaries:' + courseId;
    };
    /**
     * Get all the glossaries in a course.
     *
     * @param  {number} courseId Course Id.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Resolved with the glossaries.
     */
    AddonModGlossaryProvider.prototype.getCourseGlossaries = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            };
            var preSets = {
                cacheKey: _this.getCourseGlossariesCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_glossary_get_glossaries_by_courses', params, preSets).then(function (result) {
                return result.glossaries;
            });
        });
    };
    /**
     * Invalidate all glossaries in a course.
     *
     * @param  {number} courseId Course Id.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateCourseGlossaries = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var key = _this.getCourseGlossariesCacheKey(courseId);
            return site.invalidateWsCacheForKey(key);
        });
    };
    /**
     * Get the entries by author cache key.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} letter     First letter of firstname or lastname, or either keywords: ALL or SPECIAL.
     * @param  {string} field      Search and order using: FIRSTNAME or LASTNAME
     * @param  {string} sort       The direction of the order: ASC or DESC
     * @return {string}            Cache key.
     */
    AddonModGlossaryProvider.prototype.getEntriesByAuthorCacheKey = function (glossaryId, letter, field, sort) {
        return this.ROOT_CACHE_KEY + 'entriesByAuthor:' + glossaryId + ':' + letter + ':' + field + ':' + sort;
    };
    /**
     * Get entries by author.
     *
     * @param  {number}  glossaryId Glossary Id.
     * @param  {string}  letter     First letter of firstname or lastname, or either keywords: ALL or SPECIAL.
     * @param  {string}  field      Search and order using: FIRSTNAME or LASTNAME
     * @param  {string}  sort       The direction of the order: ASC or DESC
     * @param  {number}  from       Start returning records from here.
     * @param  {number}  limit      Number of records to return.
     * @param  {boolean} forceCache True to always get the value from cache, false otherwise. Default false.
     * @param  {string}  [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}     Resolved with the entries.
     */
    AddonModGlossaryProvider.prototype.getEntriesByAuthor = function (glossaryId, letter, field, sort, from, limit, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                id: glossaryId,
                letter: letter,
                field: field,
                sort: sort,
                from: from,
                limit: limit
            };
            var preSets = {
                cacheKey: _this.getEntriesByAuthorCacheKey(glossaryId, letter, field, sort),
                omitExpires: forceCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('mod_glossary_get_entries_by_author', params, preSets);
        });
    };
    /**
     * Invalidate cache of entries by author.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} letter     First letter of firstname or lastname, or either keywords: ALL or SPECIAL.
     * @param  {string} field      Search and order using: FIRSTNAME or LASTNAME
     * @param  {string} sort       The direction of the order: ASC or DESC
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateEntriesByAuthor = function (glossaryId, letter, field, sort, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var key = _this.getEntriesByAuthorCacheKey(glossaryId, letter, field, sort);
            return site.invalidateWsCacheForKey(key);
        });
    };
    /**
     * Get entries by category.
     *
     * @param  {number} glossaryId  Glossary Id.
     * @param  {string} categoryId  The category ID. Use constant SHOW_ALL_CATERGORIES for all categories, or
     *                              constant SHOW_NOT_CATEGORISED for uncategorised entries.
     * @param  {number} from        Start returning records from here.
     * @param  {number} limit       Number of records to return.
     * @param  {boolean} forceCache True to always get the value from cache, false otherwise. Default false.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any[]>}     Resolved with the entries.
     */
    AddonModGlossaryProvider.prototype.getEntriesByCategory = function (glossaryId, categoryId, from, limit, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                id: glossaryId,
                categoryid: categoryId,
                from: from,
                limit: limit
            };
            var preSets = {
                cacheKey: _this.getEntriesByCategoryCacheKey(glossaryId, categoryId),
                omitExpires: forceCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('mod_glossary_get_entries_by_category', params, preSets);
        });
    };
    /**
     * Invalidate cache of entries by category.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} categoryId The category ID. Use constant SHOW_ALL_CATERGORIES for all categories, or
     *                             constant SHOW_NOT_CATEGORISED for uncategorised entries.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateEntriesByCategory = function (glossaryId, categoryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var key = _this.getEntriesByCategoryCacheKey(glossaryId, categoryId);
            return site.invalidateWsCacheForKey(key);
        });
    };
    /**
     * Get the entries by category cache key.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} categoryId The category ID. Use constant SHOW_ALL_CATERGORIES for all categories, or
     *                             constant SHOW_NOT_CATEGORISED for uncategorised entries.
     * @return {string}            Cache key.
     */
    AddonModGlossaryProvider.prototype.getEntriesByCategoryCacheKey = function (glossaryId, categoryId) {
        return this.ROOT_CACHE_KEY + 'entriesByCategory:' + glossaryId + ':' + categoryId;
    };
    /**
     * Get the entries by date cache key.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} order      The way to order the records.
     * @param  {string} sort       The direction of the order.
     * @return {string}            Cache key.
     */
    AddonModGlossaryProvider.prototype.getEntriesByDateCacheKey = function (glossaryId, order, sort) {
        return this.ROOT_CACHE_KEY + 'entriesByDate:' + glossaryId + ':' + order + ':' + sort;
    };
    /**
     * Get entries by date.
     *
     * @param  {number}  glossaryId Glossary Id.
     * @param  {string}  order      The way to order the records.
     * @param  {string}  sort       The direction of the order.
     * @param  {number}  from       Start returning records from here.
     * @param  {number}  limit      Number of records to return.
     * @param  {boolean} forceCache True to always get the value from cache, false otherwise. Default false.
     * @param  {string}  [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}     Resolved with the entries.
     */
    AddonModGlossaryProvider.prototype.getEntriesByDate = function (glossaryId, order, sort, from, limit, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                id: glossaryId,
                order: order,
                sort: sort,
                from: from,
                limit: limit
            };
            var preSets = {
                cacheKey: _this.getEntriesByDateCacheKey(glossaryId, order, sort),
                omitExpires: forceCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('mod_glossary_get_entries_by_date', params, preSets);
        });
    };
    /**
     * Invalidate cache of entries by date.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} order      The way to order the records.
     * @param  {string} sort       The direction of the order.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateEntriesByDate = function (glossaryId, order, sort, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var key = _this.getEntriesByDateCacheKey(glossaryId, order, sort);
            return site.invalidateWsCacheForKey(key);
        });
    };
    /**
     * Get the entries by letter cache key.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} letter     A letter, or a special keyword.
     * @return {string}            Cache key.
     */
    AddonModGlossaryProvider.prototype.getEntriesByLetterCacheKey = function (glossaryId, letter) {
        return this.ROOT_CACHE_KEY + 'entriesByLetter:' + glossaryId + ':' + letter;
    };
    /**
     * Get entries by letter.
     *
     * @param  {number}  glossaryId Glossary Id.
     * @param  {string}  letter     A letter, or a special keyword.
     * @param  {number}  from       Start returning records from here.
     * @param  {number}  limit      Number of records to return.
     * @param  {boolean} forceCache True to always get the value from cache, false otherwise. Default false.
     * @param  {string}  [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}     Resolved with the entries.
     */
    AddonModGlossaryProvider.prototype.getEntriesByLetter = function (glossaryId, letter, from, limit, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                id: glossaryId,
                letter: letter,
                from: from,
                limit: limit
            };
            var preSets = {
                cacheKey: _this.getEntriesByLetterCacheKey(glossaryId, letter),
                omitExpires: forceCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('mod_glossary_get_entries_by_letter', params, preSets);
        });
    };
    /**
     * Invalidate cache of entries by letter.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} letter     A letter, or a special keyword.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateEntriesByLetter = function (glossaryId, letter, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var key = _this.getEntriesByLetterCacheKey(glossaryId, letter);
            return site.invalidateWsCacheForKey(key);
        });
    };
    /**
     * Get the entries by search cache key.
     *
     * @param  {number}  glossaryId Glossary Id.
     * @param  {string}  query      The search query.
     * @param  {boolean} fullSearch Whether or not full search is required.
     * @param  {string}  order      The way to order the results.
     * @param  {string}  sort       The direction of the order.
     * @return {string}             Cache key.
     */
    AddonModGlossaryProvider.prototype.getEntriesBySearchCacheKey = function (glossaryId, query, fullSearch, order, sort) {
        return this.ROOT_CACHE_KEY + 'entriesBySearch:' + glossaryId + ':' + fullSearch + ':' + order + ':' + sort + ':' + query;
    };
    /**
     * Get entries by search.
     *
     * @param  {number}  glossaryId Glossary Id.
     * @param  {string}  query      The search query.
     * @param  {boolean} fullSearch Whether or not full search is required.
     * @param  {string}  order      The way to order the results.
     * @param  {string}  sort       The direction of the order.
     * @param  {number}  from       Start returning records from here.
     * @param  {number}  limit      Number of records to return.
     * @param  {boolean} forceCache True to always get the value from cache, false otherwise. Default false.
     * @param  {string}  [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}     Resolved with the entries.
     */
    AddonModGlossaryProvider.prototype.getEntriesBySearch = function (glossaryId, query, fullSearch, order, sort, from, limit, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                id: glossaryId,
                query: query,
                fullsearch: fullSearch,
                order: order,
                sort: sort,
                from: from,
                limit: limit
            };
            var preSets = {
                cacheKey: _this.getEntriesBySearchCacheKey(glossaryId, query, fullSearch, order, sort),
                omitExpires: forceCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('mod_glossary_get_entries_by_search', params, preSets);
        });
    };
    /**
     * Invalidate cache of entries by search.
     *
     * @param  {number}  glossaryId Glossary Id.
     * @param  {string}  query      The search query.
     * @param  {boolean} fullSearch Whether or not full search is required.
     * @param  {string}  order      The way to order the results.
     * @param  {string}  sort       The direction of the order.
     * @param  {string}  [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}       Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateEntriesBySearch = function (glossaryId, query, fullSearch, order, sort, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var key = _this.getEntriesBySearchCacheKey(glossaryId, query, fullSearch, order, sort);
            return site.invalidateWsCacheForKey(key);
        });
    };
    /**
     * Get the glossary categories cache key.
     *
     * @param  {number} glossaryId Glossary Id.
     * @return {string}            The cache key.
     */
    AddonModGlossaryProvider.prototype.getCategoriesCacheKey = function (glossaryId) {
        return this.ROOT_CACHE_KEY + 'categories:' + glossaryId;
    };
    /**
     * Get all the categories related to the glossary.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any[]>}    Promise resolved with the categories if supported or empty array if not.
     */
    AddonModGlossaryProvider.prototype.getAllCategories = function (glossaryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.getCategories(glossaryId, 0, AddonModGlossaryProvider_1.LIMIT_CATEGORIES, [], site);
        });
    };
    /**
     * Get the categories related to the glossary by sections. It's a recursive function see initial call values.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {number} from       Number of categories already fetched, so fetch will be done from this number.  Initial value 0.
     * @param  {number} limit      Number of categories to fetch. Initial value LIMIT_CATEGORIES.
     * @param  {any[]}  categories Already fetched categories where to append the fetch. Initial value [].
     * @param  {any}    site       Site object.
     * @return {Promise<any[]>}    Promise resolved with the categories.
     */
    AddonModGlossaryProvider.prototype.getCategories = function (glossaryId, from, limit, categories, site) {
        var _this = this;
        var params = {
            id: glossaryId,
            from: from,
            limit: limit
        };
        var preSets = {
            cacheKey: this.getCategoriesCacheKey(glossaryId),
            updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
        };
        return site.read('mod_glossary_get_categories', params, preSets).then(function (response) {
            categories = categories.concat(response.categories);
            var canLoadMore = (from + limit) < response.count;
            if (canLoadMore) {
                from += limit;
                return _this.getCategories(glossaryId, from, limit, categories, site);
            }
            return categories;
        });
    };
    /**
     * Invalidate cache of categories by glossary id.
     *
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when categories data has been invalidated,
     */
    AddonModGlossaryProvider.prototype.invalidateCategories = function (glossaryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getCategoriesCacheKey(glossaryId));
        });
    };
    /**
     * Get an entry by ID cache key.
     *
     * @param  {number} entryId Entry Id.
     * @return {string}         Cache key.
     */
    AddonModGlossaryProvider.prototype.getEntryCacheKey = function (entryId) {
        return this.ROOT_CACHE_KEY + 'getEntry:' + entryId;
    };
    /**
     * Get one entry by ID.
     *
     * @param  {number} entryId  Entry ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved with the entry.
     */
    AddonModGlossaryProvider.prototype.getEntry = function (entryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                id: entryId
            };
            var preSets = {
                cacheKey: _this.getEntryCacheKey(entryId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_glossary_get_entry_by_id', params, preSets).then(function (response) {
                if (response && response.entry) {
                    return response;
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Performs the fetch of the entries using the propper function and arguments.
     *
     * @param  {Function} fetchFunction      Function to fetch.
     * @param  {any[]}    fetchArguments     Arguments to call the fetching.
     * @param  {number}   [limitFrom=0]      Number of entries already fetched, so fetch will be done from this number.
     * @param  {number}   [limitNum]         Number of records to return. Defaults to LIMIT_ENTRIES.
     * @param  {boolean}  [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @param  {string}   [siteId]           Site ID. If not defined, current site.
     * @return {Promise<any>}                Promise resolved with the response.
     */
    AddonModGlossaryProvider.prototype.fetchEntries = function (fetchFunction, fetchArguments, limitFrom, limitNum, forceCache, siteId) {
        if (limitFrom === void 0) { limitFrom = 0; }
        if (forceCache === void 0) { forceCache = false; }
        limitNum = limitNum || AddonModGlossaryProvider_1.LIMIT_ENTRIES;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var args = fetchArguments.slice();
        args.push(limitFrom);
        args.push(limitNum);
        args.push(forceCache);
        args.push(siteId);
        return fetchFunction.apply(this, args);
    };
    /**
     * Performs the whole fetch of the entries using the propper function and arguments.
     *
     * @param  {Function} fetchFunction      Function to fetch.
     * @param  {any[]}    fetchArguments     Arguments to call the fetching.
     * @param  {boolean}  [forceCache=false] True to always get the value from cache, false otherwise. Default false.
     * @param  {string}   [siteId]           Site ID. If not defined, current site.
     * @return {Promise<any[]>}              Promise resolved with all entrries.
     */
    AddonModGlossaryProvider.prototype.fetchAllEntries = function (fetchFunction, fetchArguments, forceCache, siteId) {
        var _this = this;
        if (forceCache === void 0) { forceCache = false; }
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var entries = [];
        var limitNum = AddonModGlossaryProvider_1.LIMIT_ENTRIES;
        var fetchMoreEntries = function () {
            return _this.fetchEntries(fetchFunction, fetchArguments, entries.length, limitNum, forceCache, siteId).then(function (result) {
                Array.prototype.push.apply(entries, result.entries);
                return entries.length < result.count ? fetchMoreEntries() : entries;
            });
        };
        return fetchMoreEntries();
    };
    /**
     * Invalidate cache of entry by ID.
     *
     * @param  {number} entryId  Entry Id.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateEntry = function (entryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getEntryCacheKey(entryId));
        });
    };
    /**
     * Invalidate cache of all entries in the array.
     *
     * @param  {any[]}  entries  Entry objects to invalidate.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateEntries = function (entries, siteId) {
        var _this = this;
        var keys = [];
        entries.forEach(function (entry) {
            keys.push(_this.getEntryCacheKey(entry.id));
        });
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateMultipleWsCacheForKey(keys);
        });
    };
    /**
     * Invalidate the prefetched content except files.
     * To invalidate files, use AddonModGlossary#invalidateFiles.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID.
     * @return {Promise<any>}    Promise resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateContent = function (moduleId, courseId) {
        var _this = this;
        return this.getGlossary(courseId, moduleId).then(function (glossary) {
            return _this.invalidateGlossaryEntries(glossary).finally(function () {
                return _this.utils.allPromises([
                    _this.invalidateCourseGlossaries(courseId),
                    _this.invalidateCategories(glossary.id)
                ]);
            });
        });
    };
    /**
     * Invalidate the prefetched content for a given glossary, except files.
     * To invalidate files, use AddonModGlossaryProvider#invalidateFiles.
     *
     * @param  {any}     glossary          The glossary object.
     * @param  {boolean} [onlyEntriesList] If true, entries won't be invalidated.
     * @param  {string}  [siteId]          Site ID. If not defined, current site.
     * @return {Promise<any>}              Promise resolved when data is invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateGlossaryEntries = function (glossary, onlyEntriesList, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        if (!onlyEntriesList) {
            promises.push(this.fetchAllEntries(this.getEntriesByLetter, [glossary.id, 'ALL'], true, siteId).then(function (entries) {
                return _this.invalidateEntries(entries, siteId);
            }));
        }
        glossary.browsemodes.forEach(function (mode) {
            switch (mode) {
                case 'letter':
                    promises.push(_this.invalidateEntriesByLetter(glossary.id, 'ALL', siteId));
                    break;
                case 'cat':
                    promises.push(_this.invalidateEntriesByCategory(glossary.id, AddonModGlossaryProvider_1.SHOW_ALL_CATERGORIES, siteId));
                    break;
                case 'date':
                    promises.push(_this.invalidateEntriesByDate(glossary.id, 'CREATION', 'DESC', siteId));
                    promises.push(_this.invalidateEntriesByDate(glossary.id, 'UPDATE', 'DESC', siteId));
                    break;
                case 'author':
                    promises.push(_this.invalidateEntriesByAuthor(glossary.id, 'ALL', 'LASTNAME', 'ASC', siteId));
                    break;
                default:
            }
        });
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param  {number} moduleId The module ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the files are invalidated.
     */
    AddonModGlossaryProvider.prototype.invalidateFiles = function (moduleId, siteId) {
        return this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModGlossaryProvider_1.COMPONENT, moduleId);
    };
    /**
     * Get one glossary by cmid.
     *
     * @param  {number} courseId Course Id.
     * @param  {number} cmId     Course Module Id.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved with the glossary.
     */
    AddonModGlossaryProvider.prototype.getGlossary = function (courseId, cmId, siteId) {
        return this.getCourseGlossaries(courseId, siteId).then(function (glossaries) {
            var glossary = glossaries.find(function (glossary) { return glossary.coursemodule == cmId; });
            if (glossary) {
                return glossary;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get one glossary by glossary ID.
     *
     * @param  {number} courseId   Course Id.
     * @param  {number} glossaryId Glossary Id.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved with the glossary.
     */
    AddonModGlossaryProvider.prototype.getGlossaryById = function (courseId, glossaryId, siteId) {
        return this.getCourseGlossaries(courseId, siteId).then(function (glossaries) {
            var glossary = glossaries.find(function (glossary) { return glossary.id == glossaryId; });
            if (glossary) {
                return glossary;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Create a new entry on a glossary
     *
     * @param  {number}  glossaryId        Glossary ID.
     * @param  {string}  concept           Glossary entry concept.
     * @param  {string}  definition        Glossary entry concept definition.
     * @param  {number}  courseId          Course ID of the glossary.
     * @param  {any}     [options]         Array of options for the entry.
     * @param  {any}     [attach]          Attachments ID if sending online, result of CoreFileUploaderProvider#storeFilesToUpload
     *                                     otherwise.
     * @param  {number}  [timeCreated]     The time the entry was created. If not defined, current time.
     * @param  {string}  [siteId]          Site ID. If not defined, current site.
     * @param  {any}     [discardEntry]    The entry provided will be discarded if found.
     * @param  {boolean} [allowOffline]    True if it can be stored in offline, false otherwise.
     * @param  {boolean} [checkDuplicates] Check for duplicates before storing offline. Only used if allowOffline is true.
     * @return {Promise<number | false>}   Promise resolved with entry ID if entry was created in server, false if stored in device.
     */
    AddonModGlossaryProvider.prototype.addEntry = function (glossaryId, concept, definition, courseId, options, attach, timeCreated, siteId, discardEntry, allowOffline, checkDuplicates) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a new entry to be synchronized later.
        var storeOffline = function () {
            var discardTime = discardEntry && discardEntry.timecreated;
            var duplicatesPromise;
            if (checkDuplicates) {
                duplicatesPromise = _this.isConceptUsed(glossaryId, concept, discardTime, siteId);
            }
            else {
                duplicatesPromise = Promise.resolve(false);
            }
            // Check if the entry is duplicated in online or offline mode.
            return duplicatesPromise.then(function (used) {
                if (used) {
                    return Promise.reject(_this.translate.instant('addon.mod_glossary.errconceptalreadyexists'));
                }
                return _this.glossaryOffline.addNewEntry(glossaryId, concept, definition, courseId, attach, options, timeCreated, siteId, undefined, discardEntry).then(function () {
                    return false;
                });
            });
        };
        if (!this.appProvider.isOnline() && allowOffline) {
            // App is offline, store the action.
            return storeOffline();
        }
        // If we are editing an offline entry, discard previous first.
        var discardPromise;
        if (discardEntry) {
            discardPromise = this.glossaryOffline.deleteNewEntry(glossaryId, discardEntry.concept, discardEntry.timecreated, siteId);
        }
        else {
            discardPromise = Promise.resolve();
        }
        return discardPromise.then(function () {
            // Try to add it in online.
            return _this.addEntryOnline(glossaryId, concept, definition, options, attach, siteId).then(function (entryId) {
                return entryId;
            }).catch(function (error) {
                if (allowOffline && !_this.utils.isWebServiceError(error)) {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
                else {
                    // The WebService has thrown an error or offline not supported, reject.
                    return Promise.reject(error);
                }
            });
        });
    };
    /**
     * Create a new entry on a glossary. It does not cache calls. It will fail if offline or cannot connect.
     *
     * @param  {number} glossaryId Glossary ID.
     * @param  {string} concept    Glossary entry concept.
     * @param  {string} definition Glossary entry concept definition.
     * @param  {any}    [options]  Array of options for the entry.
     * @param  {number} [attachId] Attachments ID (if any attachment).
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<number>}   Promise resolved with the entry ID if created, rejected otherwise.
     */
    AddonModGlossaryProvider.prototype.addEntryOnline = function (glossaryId, concept, definition, options, attachId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                glossaryid: glossaryId,
                concept: concept,
                definition: definition,
                definitionformat: 1,
                options: _this.utils.objectToArrayOfObjects(options || {}, 'name', 'value')
            };
            if (attachId) {
                params.options.push({
                    name: 'attachmentsid',
                    value: attachId
                });
            }
            // Workaround for bug MDL-57737.
            if (!site.isVersionGreaterEqualThan('3.2.2')) {
                params.definition = _this.textUtils.cleanTags(params.definition);
            }
            return site.write('mod_glossary_add_entry', params).then(function (response) {
                if (response && response.entryid) {
                    return response.entryid;
                }
                return Promise.reject(_this.utils.createFakeWSError(''));
            });
        });
    };
    /**
     * Check if a entry concept is already used.
     *
     * @param  {number} glossaryId    Glossary ID.
     * @param  {string} concept       Concept to check.
     * @param  {number} [timeCreated] Timecreated to check that is not the timecreated we are editing.
     * @param  {string} [siteId]      Site ID. If not defined, current site.
     * @return {Promise<boolean>}     Promise resolved with true if used, resolved with false if not used or error.
     */
    AddonModGlossaryProvider.prototype.isConceptUsed = function (glossaryId, concept, timeCreated, siteId) {
        var _this = this;
        // Check offline first.
        return this.glossaryOffline.isConceptUsed(glossaryId, concept, timeCreated, siteId).then(function (exists) {
            if (exists) {
                return true;
            }
            // If we get here, there's no offline entry with this name, check online.
            // Get entries from the cache.
            return _this.fetchAllEntries(_this.getEntriesByLetter, [glossaryId, 'ALL'], true, siteId).then(function (entries) {
                // Check if there's any entry with the same concept.
                return entries.some(function (entry) { return entry.concept == concept; });
            });
        }).catch(function () {
            // Error, assume not used.
            return false;
        });
    };
    /**
     * Return whether or not the plugin is enabled for editing in the current site. Plugin is enabled if the glossary WS are
     * available.
     *
     * @return {boolean} Whether the glossary editing is available or not.
     */
    AddonModGlossaryProvider.prototype.isPluginEnabledForEditing = function () {
        return this.sitesProvider.getCurrentSite().wsAvailable('mod_glossary_add_entry');
    };
    /**
     * Report a glossary as being viewed.
     *
     * @param  {number} glossaryId Glossary ID.
     * @param  {string} mode       The mode in which the glossary was viewed.
     * @param {string} [name] Name of the glossary.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the WS call is successful.
     */
    AddonModGlossaryProvider.prototype.logView = function (glossaryId, mode, name, siteId) {
        var params = {
            id: glossaryId,
            mode: mode
        };
        return this.logHelper.logSingle('mod_glossary_view_glossary', params, AddonModGlossaryProvider_1.COMPONENT, glossaryId, name, 'glossary', { mode: mode }, siteId);
    };
    /**
     * Report a glossary entry as being viewed.
     *
     * @param  {number} entryId Entry ID.
     * @param  {number} glossaryId Glossary ID.
     * @param {string} [name] Name of the glossary.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the WS call is successful.
     */
    AddonModGlossaryProvider.prototype.logEntryView = function (entryId, glossaryId, name, siteId) {
        var params = {
            id: entryId
        };
        return this.logHelper.logSingle('mod_glossary_view_entry', params, AddonModGlossaryProvider_1.COMPONENT, glossaryId, name, 'glossary', { entryid: entryId }, siteId);
    };
    AddonModGlossaryProvider.COMPONENT = 'mmaModGlossary';
    AddonModGlossaryProvider.LIMIT_ENTRIES = 25;
    AddonModGlossaryProvider.LIMIT_CATEGORIES = 10;
    AddonModGlossaryProvider.SHOW_ALL_CATERGORIES = 0;
    AddonModGlossaryProvider.SHOW_NOT_CATEGORISED = -1;
    AddonModGlossaryProvider.ADD_ENTRY_EVENT = 'addon_mod_glossary_add_entry';
    AddonModGlossaryProvider = AddonModGlossaryProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__offline__["a" /* AddonModGlossaryOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModGlossaryProvider);
    return AddonModGlossaryProvider;
    var AddonModGlossaryProvider_1;
}());

//# sourceMappingURL=glossary.js.map

/***/ }),
/* 156 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRatingSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__rating__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__offline__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_events__ = __webpack_require__(12);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * Service to sync ratings.
 */
var CoreRatingSyncProvider = /** @class */ (function (_super) {
    __extends(CoreRatingSyncProvider, _super);
    function CoreRatingSyncProvider(translate, appProvider, eventsProvider, loggerProvider, sitesProvider, syncProvider, textUtils, timeUtils, utils, ratingProvider, ratingOffline) {
        var _this = _super.call(this, 'CoreRatingSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.eventsProvider = eventsProvider;
        _this.utils = utils;
        _this.ratingProvider = ratingProvider;
        _this.ratingOffline = ratingOffline;
        return _this;
    }
    CoreRatingSyncProvider_1 = CoreRatingSyncProvider;
    /**
     * Try to synchronize all the ratings of a certain component, instance or item set.
     *
     * This function should be called from the sync provider of activities with ratings.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating Area. Example: "post".
     * @param {string} [contextLevel] Context level: course, module, user, etc.
     * @param {numnber} [instanceId] Context instance id.
     * @param {number} [itemSetId] Item set id.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    CoreRatingSyncProvider.prototype.syncRatings = function (component, ratingArea, contextLevel, instanceId, itemSetId, force, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.ratingOffline.getItemSets(component, ratingArea, contextLevel, instanceId, itemSetId, siteId)
            .then(function (itemSets) {
            var results = [];
            var promises = itemSets.map(function (itemSet) {
                var promise = force ? _this.syncItemSet(component, ratingArea, itemSet.contextLevel, itemSet.instanceId, itemSet.itemSetId, siteId) : _this.syncItemSetIfNeeded(component, ratingArea, itemSet.contextLevel, itemSet.instanceId, itemSet.itemSetId, siteId);
                return promise.then(function (result) {
                    if (result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(CoreRatingSyncProvider_1.SYNCED_EVENT, __assign({}, itemSet, { warnings: result.warnings }), siteId);
                    }
                    results.push(__assign({ itemSet: itemSet }, result));
                });
            });
            return Promise.all(promises).then(function () {
                return results;
            });
        });
    };
    /**
     * Sync ratings of an item set only if a certain time has passed since the last time.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating Area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Context instance id.
     * @param {number} itemSetId Item set id. Example: forum discussion id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when ratings are synced or if it doesn't need to be synced.
     */
    CoreRatingSyncProvider.prototype.syncItemSetIfNeeded = function (component, ratingArea, contextLevel, instanceId, itemSetId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getItemSetSyncId(component, ratingArea, contextLevel, instanceId, itemSetId);
        return this.isSyncNeeded(syncId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncItemSet(component, ratingArea, contextLevel, instanceId, itemSetId, siteId);
            }
        });
    };
    /**
     * Synchronize all offline ratings of an item set.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating Area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Context instance id.
     * @param {number} itemSetId Item set id. Example: forum discussion id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected otherwise.
     */
    CoreRatingSyncProvider.prototype.syncItemSet = function (component, ratingArea, contextLevel, instanceId, itemSetId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getItemSetSyncId(component, ratingArea, contextLevel, instanceId, itemSetId);
        if (this.isSyncing(syncId, siteId)) {
            // There's already a sync ongoing for this item set, return the promise.
            return this.getOngoingSync(syncId, siteId);
        }
        this.logger.debug("Try to sync ratings of component '" + component + "' rating area '" + ratingArea + "'" +
            (" context level '" + contextLevel + "' instance " + instanceId + " item set " + itemSetId));
        var updated = [];
        var warnings = [];
        return this.ratingOffline.getRatings(component, ratingArea, contextLevel, instanceId, itemSetId, siteId).then(function (ratings) {
            if (!ratings.length) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            var promises = ratings.map(function (rating) {
                return _this.ratingProvider.addRatingOnline(component, ratingArea, rating.contextlevel, rating.instanceid, rating.itemid, rating.scaleid, rating.rating, rating.rateduserid, rating.aggregation, siteId)
                    .catch(function (error) {
                    if (_this.utils.isWebServiceError(error)) {
                        warnings.push(_this.textUtils.getErrorMessageFromError(error));
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                }).then(function () {
                    updated.push(rating.itemid);
                    return _this.ratingOffline.deleteRating(component, ratingArea, rating.contextlevel, rating.instanceid, rating.itemid, siteId).finally(function () {
                        return _this.ratingProvider.invalidateRatingItems(rating.contextlevel, rating.instanceid, component, ratingArea, rating.itemid, rating.scaleid, undefined, siteId);
                    });
                });
            });
            return Promise.all(promises).then(function () {
                // All done, return the warnings.
                return { updated: updated, warnings: warnings };
            });
        });
    };
    /**
     * Get the sync id of an item set.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating Area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} instanceId Context instance id.
     * @param {number} itemSetId Item set id. Example: forum discussion id.
     * @return {string} Sync id.
     */
    CoreRatingSyncProvider.prototype.getItemSetSyncId = function (component, ratingArea, contextLevel, instanceId, itemSetId) {
        return "itemSet#" + component + "#" + ratingArea + "#" + contextLevel + "#" + instanceId + "#" + itemSetId;
    };
    CoreRatingSyncProvider.SYNCED_EVENT = 'core_rating_synced';
    CoreRatingSyncProvider = CoreRatingSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* CoreSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__rating__["a" /* CoreRatingProvider */],
            __WEBPACK_IMPORTED_MODULE_11__offline__["a" /* CoreRatingOfflineProvider */]])
    ], CoreRatingSyncProvider);
    return CoreRatingSyncProvider;
    var CoreRatingSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_2__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 157 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRatingOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Service to handle offline data for rating.
 */
var CoreRatingOfflineProvider = /** @class */ (function () {
    function CoreRatingOfflineProvider(sitesProvider, utils) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.siteSchema = {
            name: 'CoreRatingOfflineProvider',
            version: 1,
            tables: [
                {
                    name: CoreRatingOfflineProvider_1.RATINGS_TABLE,
                    columns: [
                        {
                            name: 'component',
                            type: 'TEXT'
                        },
                        {
                            name: 'ratingarea',
                            type: 'TEXT'
                        },
                        {
                            name: 'contextlevel',
                            type: 'INTEGER',
                        },
                        {
                            name: 'instanceid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'itemid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'itemsetid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'scaleid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'rating',
                            type: 'INTEGER'
                        },
                        {
                            name: 'rateduserid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'aggregation',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['component', 'ratingarea', 'contextlevel', 'instanceid', 'itemid']
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    CoreRatingOfflineProvider_1 = CoreRatingOfflineProvider;
    /**
     * Get an offline rating.
     *
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {numnber} instanceId Context instance id.
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {number} itemId Item id. Example: forum post id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<CoreRatingOfflineRating>} Promise resolved with the saved rating, rejected if not found.
     */
    CoreRatingOfflineProvider.prototype.getRating = function (contextLevel, instanceId, component, ratingArea, itemId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                contextlevel: contextLevel,
                instanceid: instanceId,
                component: component,
                ratingarea: ratingArea,
                itemid: itemId
            };
            return site.getDb().getRecord(CoreRatingOfflineProvider_1.RATINGS_TABLE, conditions);
        });
    };
    /**
     * Add an offline rating.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {numnber} instanceId Context instance id.
     * @param {number} itemId Item id. Example: forum post id.
     * @param {number} itemSetId Item set id. Example: forum discussion id.
     * @param {number} courseId Course id.
     * @param {number} scaleId Scale id.
     * @param {number} rating Rating value. Use CoreRatingProvider.UNSET_RATING to delete rating.
     * @param {number} ratedUserId Rated user id.
     * @param {number} aggregateMethod Aggregate method.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the rating is saved.
     */
    CoreRatingOfflineProvider.prototype.addRating = function (component, ratingArea, contextLevel, instanceId, itemId, itemSetId, courseId, scaleId, rating, ratedUserId, aggregateMethod, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                component: component,
                ratingarea: ratingArea,
                contextlevel: contextLevel,
                instanceid: instanceId,
                itemid: itemId,
                itemsetid: itemSetId,
                courseid: courseId,
                scaleid: scaleId,
                rating: rating,
                rateduserid: ratedUserId,
                aggregation: aggregateMethod
            };
            return site.getDb().insertRecord(CoreRatingOfflineProvider_1.RATINGS_TABLE, data);
        });
    };
    /**
     * Delete offline rating.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} itemId Item id. Example: forum post id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the rating is saved.
     */
    CoreRatingOfflineProvider.prototype.deleteRating = function (component, ratingArea, contextLevel, instanceId, itemId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                component: component,
                ratingarea: ratingArea,
                contextlevel: contextLevel,
                instanceid: instanceId,
                itemid: itemId
            };
            return site.getDb().deleteRecords(CoreRatingOfflineProvider_1.RATINGS_TABLE, conditions);
        });
    };
    /**
     * Get the list of item sets in a component or instance.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating Area. Example: "post".
     * @param {string} [contextLevel] Context level: course, module, user, etc.
     * @param {numnber} [instanceId] Context instance id.
     * @param {number} [itemSetId] Item set id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<CoreRatingItemSet[]>} Promise resolved with the list of item set ids.
     */
    CoreRatingOfflineProvider.prototype.getItemSets = function (component, ratingArea, contextLevel, instanceId, itemSetId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var fields = 'DISTINCT contextlevel, instanceid, itemsetid, courseid';
            var conditions = {
                component: component,
                ratingarea: ratingArea
            };
            if (contextLevel != null && instanceId != null) {
                conditions.contextlevel = contextLevel;
                conditions.instanceId = instanceId;
            }
            if (itemSetId != null) {
                conditions.itemSetId = itemSetId;
            }
            return site.getDb().getRecords(CoreRatingOfflineProvider_1.RATINGS_TABLE, conditions, undefined, fields)
                .then(function (records) {
                return records.map(function (record) {
                    return {
                        component: component,
                        ratingArea: ratingArea,
                        contextLevel: record.contextlevel,
                        instanceId: record.instanceid,
                        itemSetId: record.itemsetid,
                        courseId: record.courseid
                    };
                });
            });
        });
    };
    /**
     * Get offline ratings of an item set.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating Area. Example: "post".
     * @param {string} contextLevel Context level: course, module, user, etc.
     * @param {number} itemId Item id. Example: forum post id.
     * @param {number} itemSetId Item set id. Example: forum discussion id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<CoreRatingOfflineRating[]>} Promise resolved with the list of ratings.
     */
    CoreRatingOfflineProvider.prototype.getRatings = function (component, ratingArea, contextLevel, instanceId, itemSetId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                component: component,
                ratingarea: ratingArea,
                contextlevel: contextLevel,
                instanceid: instanceId,
                itemsetid: itemSetId
            };
            return site.getDb().getRecords(CoreRatingOfflineProvider_1.RATINGS_TABLE, conditions);
        });
    };
    /**
     * Return whether a component, instance or item set has offline ratings.
     *
     * @param {string} component Component. Example: "mod_forum".
     * @param {string} ratingArea Rating Area. Example: "post".
     * @param {string} [contextLevel] Context level: course, module, user, etc.
     * @param {number} [instanceId] Context instance id.
     * @param {number} [itemSetId] Item set id. Example: forum discussion id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with a boolean.
     */
    CoreRatingOfflineProvider.prototype.hasRatings = function (component, ratingArea, contextLevel, instanceId, itemSetId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                component: component,
                ratingarea: ratingArea
            };
            if (contextLevel != null && instanceId != null) {
                conditions.contextlevel = contextLevel;
                conditions.instanceId = instanceId;
            }
            if (itemSetId != null) {
                conditions.itemsetid = itemSetId;
            }
            return _this.utils.promiseWorks(site.getDb().recordExists(CoreRatingOfflineProvider_1.RATINGS_TABLE, conditions));
        });
    };
    // Variables for database.
    CoreRatingOfflineProvider.RATINGS_TABLE = 'rating_ratings';
    CoreRatingOfflineProvider = CoreRatingOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreRatingOfflineProvider);
    return CoreRatingOfflineProvider;
    var CoreRatingOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 158 */,
/* 159 */,
/* 160 */,
/* 161 */,
/* 162 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDynamicComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};




/**
 * Component to create another component dynamically.
 *
 * You need to pass the class of the component to this component (the class, not the name), along with the input data.
 *
 * So you should do something like:
 *
 *     import { MyComponent } from './component';
 *
 *     ...
 *
 *         this.component = MyComponent;
 *
 * And in the template:
 *
 *     <core-dynamic-component [component]="component" [data]="data">
 *         <p>Cannot render the data.</p>
 *     </core-dynamic-component>
 *
 * Please notice that the component that you pass needs to be declared in entryComponents of the module to be created dynamically.
 *
 * Alternatively, you can also supply a ComponentRef instead of the class of the component. In this case, the component won't
 * be instantiated because it already is, it will be attached to the view and the right data will be passed to it.
 * Passing ComponentRef is meant for site plugins, so we'll inject a NavController instance to the component.
 *
 * The contents of this component will be displayed if no component is supplied or it cannot be created. In the example above,
 * if no component is supplied then the template will show the message "Cannot render the data.".
 */
var CoreDynamicComponent = /** @class */ (function () {
    function CoreDynamicComponent(logger, factoryResolver, differs, navCtrl, cdr, element, domUtils) {
        this.factoryResolver = factoryResolver;
        this.navCtrl = navCtrl;
        this.cdr = cdr;
        this.element = element;
        this.domUtils = domUtils;
        this.logger = logger.getInstance('CoreDynamicComponent');
        this.differ = differs.find([]).create();
    }
    Object.defineProperty(CoreDynamicComponent.prototype, "dynamicComponent", {
        // Get the container where to put the dynamic component.
        set: function (el) {
            this.container = el;
            this.createComponent();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Component being initialized.
     */
    CoreDynamicComponent.prototype.ngOnInit = function () {
        this.createComponent();
    };
    /**
     * Detect changes on input properties.
     */
    CoreDynamicComponent.prototype.ngOnChanges = function (changes) {
        if (changes.component && !this.component) {
            // Component not set, destroy the instance if any.
            this.lastComponent = undefined;
            this.instance = undefined;
            this.container && this.container.clear();
        }
        else if (changes.component && (!this.instance || this.component != this.lastComponent)) {
            this.createComponent();
        }
    };
    /**
     * Detect and act upon changes that Angular can’t or won’t detect on its own (objects and arrays).
     */
    CoreDynamicComponent.prototype.ngDoCheck = function () {
        if (this.instance) {
            // Check if there's any change in the data object.
            var changes = this.differ.diff(this.data);
            if (changes) {
                this.setInputData();
                if (this.instance.ngOnChanges) {
                    this.instance.ngOnChanges(this.domUtils.createChangesFromKeyValueDiff(changes));
                }
            }
        }
    };
    /**
     * Call a certain function on the component.
     *
     * @param {string} name Name of the function to call.
     * @param {any[]} params List of params to send to the function.
     * @return {any} Result of the call. Undefined if no component instance or the function doesn't exist.
     */
    CoreDynamicComponent.prototype.callComponentFunction = function (name, params) {
        if (this.instance && typeof this.instance[name] == 'function') {
            return this.instance[name].apply(this.instance, params);
        }
    };
    /**
     * Create a component, add it to a container and set the input data.
     *
     * @return {boolean} Whether the component was successfully created.
     */
    CoreDynamicComponent.prototype.createComponent = function () {
        this.lastComponent = this.component;
        if (!this.component || !this.container) {
            // No component to instantiate or container doesn't exist right now.
            return false;
        }
        if (this.instance) {
            // Component already instantiated.
            return true;
        }
        if (this.component instanceof __WEBPACK_IMPORTED_MODULE_0__angular_core__["ComponentRef"]) {
            // A ComponentRef was supplied instead of the component class. Add it to the view.
            this.container.insert(this.component.hostView);
            this.instance = this.component.instance;
            // This feature is usually meant for site plugins. Inject some properties.
            this.instance['ChangeDetectorRef'] = this.cdr;
            this.instance['NavController'] = this.navCtrl;
            this.instance['componentContainer'] = this.element.nativeElement;
        }
        else {
            try {
                // Create the component and add it to the container.
                var factory = this.factoryResolver.resolveComponentFactory(this.component), componentRef = this.container.createComponent(factory);
                this.instance = componentRef.instance;
            }
            catch (ex) {
                this.logger.error('Error creating component', ex);
                return false;
            }
        }
        this.setInputData();
        return true;
    };
    /**
     * Set the input data for the component.
     */
    CoreDynamicComponent.prototype.setInputData = function () {
        for (var name_1 in this.data) {
            this.instance[name_1] = this.data[name_1];
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreDynamicComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreDynamicComponent.prototype, "data", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('dynamicComponent', { read: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewContainerRef"] }),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewContainerRef"]),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewContainerRef"]])
    ], CoreDynamicComponent.prototype, "dynamicComponent", null);
    CoreDynamicComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-dynamic-component',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\dynamic-component\core-dynamic-component.html"*/'<!-- Content to display if no dynamic component. -->\n<ng-content *ngIf="!instance"></ng-content>\n\n<!-- Container of the dynamic component -->\n<ng-container #dynamicComponent></ng-container>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\dynamic-component\core-dynamic-component.html"*/
        }),
        __param(3, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ComponentFactoryResolver"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["KeyValueDiffers"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectorRef"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], CoreDynamicComponent);
    return CoreDynamicComponent;
}());

//# sourceMappingURL=dynamic-component.js.map

/***/ }),
/* 163 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Service to handle blog entries.
 */
var AddonBlogProvider = /** @class */ (function () {
    function AddonBlogProvider(logger, sitesProvider, utils, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.ROOT_CACHE_KEY = 'addonBlog:';
        this.logger = logger.getInstance('AddonBlogProvider');
    }
    AddonBlogProvider_1 = AddonBlogProvider;
    /**
     * Returns whether or not the blog plugin is enabled for a certain site.
     *
     * This method is called quite often and thus should only perform a quick
     * check, we should not be calling WS from here.
     *
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if enabled, resolved with false or rejected otherwise.
     */
    AddonBlogProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('core_blog_get_entries') &&
                site.canUseAdvancedFeature('enableblogs');
        });
    };
    /**
     * Get the cache key for the blog entries.
     *
     * @param  {any}     [filter]     Filter to apply on search.
     * @return {string}          Cache key.
     */
    AddonBlogProvider.prototype.getEntriesCacheKey = function (filter) {
        if (filter === void 0) { filter = {}; }
        return this.ROOT_CACHE_KEY + this.utils.sortAndStringify(filter);
    };
    /**
     * Get blog entries.
     *
     * @param  {any}     [filter]     Filter to apply on search.
     * @param  {any}     [page=0]     Page of the blog entries to fetch.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise to be resolved when the entries are retrieved.
     */
    AddonBlogProvider.prototype.getEntries = function (filter, page, siteId) {
        var _this = this;
        if (filter === void 0) { filter = {}; }
        if (page === void 0) { page = 0; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                filters: _this.utils.objectToArrayOfObjects(filter, 'name', 'value'),
                page: page,
                perpage: AddonBlogProvider_1.ENTRIES_PER_PAGE
            };
            var preSets = {
                cacheKey: _this.getEntriesCacheKey(filter),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_5__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('core_blog_get_entries', data, preSets);
        });
    };
    /**
     * Invalidate blog entries WS call.
     *
     * @param  {any}     [filter]     Filter to apply on search
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when data is invalidated.
     */
    AddonBlogProvider.prototype.invalidateEntries = function (filter, siteId) {
        var _this = this;
        if (filter === void 0) { filter = {}; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getEntriesCacheKey(filter));
        });
    };
    /**
     * Trigger the blog_entries_viewed event.
     *
     * @param  {any}     [filter]     Filter to apply on search.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise to be resolved when done.
     */
    AddonBlogProvider.prototype.logView = function (filter, siteId) {
        var _this = this;
        if (filter === void 0) { filter = {}; }
        this.pushNotificationsProvider.logViewListEvent('blog', 'core_blog_view_entries', filter, siteId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                filters: _this.utils.objectToArrayOfObjects(filter, 'name', 'value')
            };
            return site.write('core_blog_view_entries', data);
        });
    };
    AddonBlogProvider.ENTRIES_PER_PAGE = 10;
    AddonBlogProvider.COMPONENT = 'blog';
    AddonBlogProvider = AddonBlogProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], AddonBlogProvider);
    return AddonBlogProvider;
    var AddonBlogProvider_1;
}());

//# sourceMappingURL=blog.js.map

/***/ }),
/* 164 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModuleMainResourceComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_pages_section_section_ts__ = __webpack_require__(999);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__addon_blog_providers_blog__ = __webpack_require__(163);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Template class to easily create CoreCourseModuleMainComponent of resources (or activities without syncing).
 */
var CoreCourseModuleMainResourceComponent = /** @class */ (function () {
    function CoreCourseModuleMainResourceComponent(injector, loggerName) {
        if (loggerName === void 0) { loggerName = 'CoreCourseModuleMainResourceComponent'; }
        this.fetchContentDefaultError = 'core.course.errorgetmodule'; // Default error to show when loading contents.
        this.textUtils = injector.get(__WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */]);
        this.courseHelper = injector.get(__WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]);
        this.translate = injector.get(__WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]);
        this.domUtils = injector.get(__WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */]);
        this.moduleDelegate = injector.get(__WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */]);
        this.courseSectionPage = injector.get(__WEBPACK_IMPORTED_MODULE_8__core_course_pages_section_section_ts__["a" /* CoreCourseSectionPage */], null);
        this.linkHelper = injector.get(__WEBPACK_IMPORTED_MODULE_9__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]);
        this.navCtrl = injector.get(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], null);
        this.blogProvider = injector.get(__WEBPACK_IMPORTED_MODULE_10__addon_blog_providers_blog__["a" /* AddonBlogProvider */], null);
        this.dataRetrieved = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        var loggerProvider = injector.get(__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */]);
        this.logger = loggerProvider.getInstance(loggerName);
    }
    /**
     * Component being initialized.
     */
    CoreCourseModuleMainResourceComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.description = this.module.description;
        this.componentId = this.module.id;
        this.externalUrl = this.module.url;
        this.loaded = false;
        this.refreshIcon = 'spinner';
        this.blogProvider.isPluginEnabled().then(function (enabled) {
            _this.blog = enabled;
        });
    };
    /**
     * Refresh the data.
     *
     * @param {any}       [refresher] Refresher.
     * @param {Function}  [done] Function to call when done.
     * @param {boolean}   [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModuleMainResourceComponent.prototype.doRefresh = function (refresher, done, showErrors) {
        var _this = this;
        if (showErrors === void 0) { showErrors = false; }
        if (this.loaded && this.module) {
            /* If it's a single activity course and the refresher is displayed within the component,
               call doRefresh on the section page to refresh the course data. */
            var promise = void 0;
            if (this.courseSectionPage && !this.moduleDelegate.displayRefresherInSingleActivity(this.module.modname)) {
                promise = this.courseSectionPage.doRefresh();
            }
            else {
                promise = Promise.resolve();
            }
            return promise.finally(function () {
                return _this.refreshContent(true, showErrors).finally(function () {
                    refresher && refresher.complete();
                    done && done();
                });
            });
        }
        return Promise.resolve();
    };
    /**
     * Perform the refresh content function.
     *
     * @param  {boolean}      [sync=false]       If the refresh needs syncing.
     * @param  {boolean}      [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Resolved when done.
     */
    CoreCourseModuleMainResourceComponent.prototype.refreshContent = function (sync, showErrors) {
        var _this = this;
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        if (!this.module) {
            // This can happen if course format changes from single activity to weekly/topics.
            return Promise.resolve();
        }
        this.refreshIcon = 'spinner';
        // Wrap the call in a try/catch so the workflow isn't interrupted if an error occurs.
        // E.g. when changing course format we cannot know when will this.module become undefined, so it could cause errors.
        var promise;
        try {
            promise = this.invalidateContent();
        }
        catch (ex) {
            // An error ocurred in the function, log the error and just resolve the promise so the workflow continues.
            this.logger.error(ex);
            promise = Promise.resolve();
        }
        return promise.catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.loadContent(true);
        }).finally(function () {
            _this.refreshIcon = 'refresh';
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    CoreCourseModuleMainResourceComponent.prototype.invalidateContent = function () {
        return Promise.resolve();
    };
    /**
     * Download the component contents.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModuleMainResourceComponent.prototype.fetchContent = function (refresh) {
        return Promise.resolve();
    };
    /**
     * Loads the component contents and shows the corresponding error.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModuleMainResourceComponent.prototype.loadContent = function (refresh) {
        var _this = this;
        if (!this.module) {
            // This can happen if course format changes from single activity to weekly/topics.
            return Promise.resolve();
        }
        // Wrap the call in a try/catch so the workflow isn't interrupted if an error occurs.
        // E.g. when changing course format we cannot know when will this.module become undefined, so it could cause errors.
        var promise;
        try {
            promise = this.fetchContent(refresh);
        }
        catch (ex) {
            // An error ocurred in the function, log the error and just resolve the promise so the workflow continues.
            this.logger.error(ex);
            promise = Promise.resolve();
        }
        return promise.catch(function (error) {
            // Error getting data, fail.
            _this.domUtils.showErrorModalDefault(error, _this.fetchContentDefaultError, true);
        }).finally(function () {
            _this.loaded = true;
            _this.refreshIcon = 'refresh';
        });
    };
    /**
     * Fill the context menu options
     */
    CoreCourseModuleMainResourceComponent.prototype.fillContextMenu = function (refresh) {
        if (refresh === void 0) { refresh = false; }
        // All data obtained, now fill the context menu.
        this.courseHelper.fillContextMenu(this, this.module, this.courseId, refresh, this.component);
    };
    /**
     * Check if the module is prefetched or being prefetched. To make it faster, just use the data calculated by fillContextMenu.
     * This means that you need to call fillContextMenu to make this work.
     */
    CoreCourseModuleMainResourceComponent.prototype.isPrefetched = function () {
        return this.prefetchStatus != __WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADABLE && this.prefetchStatus != __WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
    };
    /**
     * Expand the description.
     */
    CoreCourseModuleMainResourceComponent.prototype.expandDescription = function () {
        this.textUtils.expandText(this.translate.instant('core.description'), this.description, this.component, this.module.id);
    };
    /**
     * Go to blog posts.
     *
     * @param {any} event Event.
     */
    CoreCourseModuleMainResourceComponent.prototype.gotoBlog = function (event) {
        // Always use redirect to make it the new history root (to avoid "loops" in history).
        this.linkHelper.goInSite(this.navCtrl, 'AddonBlogEntriesPage', { cmId: this.module.id });
    };
    /**
     * Prefetch the module.
     *
     * @param {Function}  [done] Function to call when done.
     */
    CoreCourseModuleMainResourceComponent.prototype.prefetch = function (done) {
        this.courseHelper.contextMenuPrefetch(this, this.module, this.courseId, done);
    };
    /**
     * Confirm and remove downloaded files.
     */
    CoreCourseModuleMainResourceComponent.prototype.removeFiles = function () {
        this.courseHelper.confirmAndRemoveFiles(this.module, this.courseId);
    };
    /**
     * Component being destroyed.
     */
    CoreCourseModuleMainResourceComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.contextMenuStatusObserver && this.contextMenuStatusObserver.off();
    };
    /**
     * User entered the page that contains the component. This function should be called by the page that contains this component.
     */
    CoreCourseModuleMainResourceComponent.prototype.ionViewDidEnter = function () {
        this.isCurrentView = true;
    };
    /**
     * User left the page that contains the component. This function should be called by the page that contains this component.
     */
    CoreCourseModuleMainResourceComponent.prototype.ionViewDidLeave = function () {
        this.isCurrentView = false;
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseModuleMainResourceComponent.prototype, "module", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseModuleMainResourceComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCourseModuleMainResourceComponent.prototype, "dataRetrieved", void 0);
    return CoreCourseModuleMainResourceComponent;
}());

//# sourceMappingURL=main-resource-component.js.map

/***/ }),
/* 165 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseResourcePrefetchHandlerBase; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__module_prefetch_handler__ = __webpack_require__(773);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Base prefetch handler to be registered in CoreCourseModulePrefetchDelegate. It is useful to minimize the amount of
 * functions that handlers need to implement. It also provides some helper features like preventing a module to be
 * downloaded twice at the same time.
 *
 * If your handler inherits from this service, you just need to override the functions that you want to change.
 *
 * This class should be used for RESOURCES whose main purpose is downloading files present in module.contents.
 */
var CoreCourseResourcePrefetchHandlerBase = /** @class */ (function (_super) {
    __extends(CoreCourseResourcePrefetchHandlerBase, _super);
    function CoreCourseResourcePrefetchHandlerBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Download the module.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when all content is downloaded.
     */
    CoreCourseResourcePrefetchHandlerBase.prototype.download = function (module, courseId, dirPath) {
        return this.downloadOrPrefetch(module, courseId, false, dirPath);
    };
    /**
     * Download or prefetch the content.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files. This is to keep the files
     *                           relative paths and make the package work in an iframe. Undefined to download the files
     *                           in the filepool root folder.
     * @return {Promise<any>} Promise resolved when all content is downloaded. Data returned is not reliable.
     */
    CoreCourseResourcePrefetchHandlerBase.prototype.downloadOrPrefetch = function (module, courseId, prefetch, dirPath) {
        var _this = this;
        if (!this.appProvider.isOnline()) {
            // Cannot download in offline.
            return Promise.reject(this.translate.instant('core.networkerrormsg'));
        }
        var siteId = this.sitesProvider.getCurrentSiteId();
        if (this.isDownloading(module.id, siteId)) {
            // There's already a download ongoing for this module, return the promise.
            return this.getOngoingDownload(module.id, siteId);
        }
        // Get module info to be able to handle links.
        var prefetchPromise = this.courseProvider.getModuleBasicInfo(module.id, siteId).then(function () {
            // Load module contents (ignore cache so we always have the latest data).
            return _this.loadContents(module, courseId, true);
        }).then(function () {
            // Get the intro files.
            return _this.getIntroFiles(module, courseId, true);
        }).then(function (introFiles) {
            var downloadFn = prefetch ? _this.filepoolProvider.prefetchPackage.bind(_this.filepoolProvider) :
                _this.filepoolProvider.downloadPackage.bind(_this.filepoolProvider), contentFiles = _this.getContentDownloadableFiles(module), promises = [];
            if (dirPath) {
                // Download intro files in filepool root folder.
                promises.push(_this.filepoolProvider.downloadOrPrefetchFiles(siteId, introFiles, prefetch, false, _this.component, module.id));
                // Download content files inside dirPath.
                promises.push(downloadFn(siteId, contentFiles, _this.component, module.id, undefined, dirPath));
            }
            else {
                // No dirPath, download everything in filepool root folder.
                var files = introFiles.concat(contentFiles);
                promises.push(downloadFn(siteId, files, _this.component, module.id));
            }
            return Promise.all(promises);
        });
        return this.addOngoingDownload(module.id, prefetchPromise, siteId);
    };
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    CoreCourseResourcePrefetchHandlerBase.prototype.getFiles = function (module, courseId, single) {
        var _this = this;
        // Load module contents if needed.
        return this.loadContents(module, courseId).then(function () {
            return _this.getIntroFiles(module, courseId).then(function (files) {
                return files.concat(_this.getContentDownloadableFiles(module));
            });
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseResourcePrefetchHandlerBase.prototype.invalidateContent = function (moduleId, courseId) {
        var promises = [], siteId = this.sitesProvider.getCurrentSiteId();
        promises.push(this.courseProvider.invalidateModule(moduleId));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, this.component, moduleId));
        return Promise.all(promises);
    };
    /**
     * Load module contents into module.contents if they aren't loaded already.
     *
     * @param {any} module Module to load the contents.
     * @param {number} [courseId] The course ID. Recommended to speed up the process and minimize data usage.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise}           Promise resolved when loaded.
     */
    CoreCourseResourcePrefetchHandlerBase.prototype.loadContents = function (module, courseId, ignoreCache) {
        return this.courseProvider.loadModuleContents(module, courseId, undefined, false, ignoreCache);
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseResourcePrefetchHandlerBase.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.downloadOrPrefetch(module, courseId, true, dirPath);
    };
    return CoreCourseResourcePrefetchHandlerBase;
}(__WEBPACK_IMPORTED_MODULE_0__module_prefetch_handler__["a" /* CoreCourseModulePrefetchHandlerBase */]));

//# sourceMappingURL=resource-prefetch-handler.js.map

/***/ }),
/* 166 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCompileInitComponent; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base class for components that will display a component using core-compile-html and want to call a
 * componentInit function returned by the handler JS.
 */
var CoreSitePluginsCompileInitComponent = /** @class */ (function () {
    function CoreSitePluginsCompileInitComponent(sitePluginsProvider, utils) {
        this.sitePluginsProvider = sitePluginsProvider;
        this.utils = utils;
        this.content = ''; // Content.
        this.jsData = {}; // Data to pass to the component.
    }
    /**
     * Function called when the component is created.
     *
     * @param {any} instance The component instance.
     */
    CoreSitePluginsCompileInitComponent.prototype.componentCreated = function (instance) {
        // Check if the JS defined an init function.
        if (instance && this.handlerSchema && this.handlerSchema.methodJSResult &&
            this.handlerSchema.methodJSResult.componentInit) {
            this.handlerSchema.methodJSResult.componentInit.apply(instance);
        }
    };
    /**
     * Get the handler data.
     *
     * @param {string} name The name of the handler.
     */
    CoreSitePluginsCompileInitComponent.prototype.getHandlerData = function (name) {
        // Retrieve the handler data.
        var handler = this.sitePluginsProvider.getSitePluginHandler(name);
        this.handlerSchema = handler && handler.handlerSchema;
        if (this.handlerSchema) {
            // Load first template.
            if (this.handlerSchema.methodTemplates && this.handlerSchema.methodTemplates.length) {
                this.content = handler.handlerSchema.methodTemplates[0].html;
                this.jsData.CONTENT_TEMPLATES = this.utils.objectToKeyValueMap(handler.handlerSchema.methodTemplates, 'id', 'html');
            }
            // Pass data from the method result to the component.
            if (this.handlerSchema.methodOtherdata) {
                this.jsData.CONTENT_OTHERDATA = this.handlerSchema.methodOtherdata;
            }
            if (this.handlerSchema.methodJSResult) {
                this.jsData.CONTENT_JS_RESULT = this.handlerSchema.methodJSResult;
            }
        }
    };
    return CoreSitePluginsCompileInitComponent;
}());

//# sourceMappingURL=compile-init-component.js.map

/***/ }),
/* 167 */,
/* 168 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__scorm_offline__ = __webpack_require__(216);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_course_providers_log_helper__ = __webpack_require__(34);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















/**
 * Service that provides some features for SCORM.
 */
var AddonModScormProvider = /** @class */ (function () {
    function AddonModScormProvider(logger, translate, sitesProvider, wsProvider, textUtils, utils, filepoolProvider, scormOfflineProvider, timeUtils, syncProvider, eventsProvider, logHelper) {
        this.translate = translate;
        this.sitesProvider = sitesProvider;
        this.wsProvider = wsProvider;
        this.textUtils = textUtils;
        this.utils = utils;
        this.filepoolProvider = filepoolProvider;
        this.scormOfflineProvider = scormOfflineProvider;
        this.timeUtils = timeUtils;
        this.syncProvider = syncProvider;
        this.eventsProvider = eventsProvider;
        this.logHelper = logHelper;
        // Protected constants.
        this.VALID_STATUSES = ['notattempted', 'passed', 'completed', 'failed', 'incomplete', 'browsed', 'suspend'];
        this.STATUSES = {
            'passed': 'passed',
            'completed': 'completed',
            'failed': 'failed',
            'incomplete': 'incomplete',
            'browsed': 'browsed',
            'not attempted': 'notattempted',
            'p': 'passed',
            'c': 'completed',
            'f': 'failed',
            'i': 'incomplete',
            'b': 'browsed',
            'n': 'notattempted'
        };
        this.ROOT_CACHE_KEY = 'mmaModScorm:';
        this.logger = logger.getInstance('AddonModScormProvider');
    }
    AddonModScormProvider_1 = AddonModScormProvider;
    /**
     * Calculates the SCORM grade based on the grading method and the list of attempts scores.
     * We only treat online attempts to calculate a SCORM grade.
     *
     * @param {any} scorm SCORM.
     * @param {any} onlineAttempts Object with the online attempts. Each attempt must have a property called "grade".
     * @return {number} Grade. -1 if no grade.
     */
    AddonModScormProvider.prototype.calculateScormGrade = function (scorm, onlineAttempts) {
        if (!onlineAttempts || !Object.keys(onlineAttempts).length) {
            return -1;
        }
        switch (scorm.whatgrade) {
            case AddonModScormProvider_1.FIRSTATTEMPT:
                return onlineAttempts[1] ? onlineAttempts[1].grade : -1;
            case AddonModScormProvider_1.LASTATTEMPT:
                // Search the last attempt number.
                var max_1 = 0;
                Object.keys(onlineAttempts).forEach(function (attemptNumber) {
                    max_1 = Math.max(Number(attemptNumber), max_1);
                });
                if (max_1 > 0) {
                    return onlineAttempts[max_1].grade;
                }
                return -1;
            case AddonModScormProvider_1.HIGHESTATTEMPT:
                // Search the highest grade.
                var grade = 0;
                for (var attemptNumber in onlineAttempts) {
                    grade = Math.max(onlineAttempts[attemptNumber].grade, grade);
                }
                return grade;
            case AddonModScormProvider_1.AVERAGEATTEMPT:
                // Calculate the average.
                var sumGrades = 0, total = 0;
                for (var attemptNumber in onlineAttempts) {
                    sumGrades += onlineAttempts[attemptNumber].grade;
                    total++;
                }
                return Math.round(sumGrades / total);
            default:
                return -1;
        }
    };
    /**
     * Calculates the size of a SCORM.
     *
     * @param {any} scorm SCORM.
     * @return {Promise<number>} Promise resolved with the SCORM size.
     */
    AddonModScormProvider.prototype.calculateScormSize = function (scorm) {
        if (scorm.packagesize) {
            return Promise.resolve(scorm.packagesize);
        }
        return this.wsProvider.getRemoteFileSize(this.getPackageUrl(scorm));
    };
    /**
     * Count the attempts left for the given scorm.
     *
     * @param {any} scorm SCORM.
     * @param {number} attemptsCount Number of attempts performed.
     * @return {number} Number of attempts left.
     */
    AddonModScormProvider.prototype.countAttemptsLeft = function (scorm, attemptsCount) {
        if (scorm.maxattempt == 0) {
            return Number.MAX_VALUE; // Unlimited attempts.
        }
        attemptsCount = Number(attemptsCount); // Make sure it's a number.
        if (isNaN(attemptsCount)) {
            return -1;
        }
        return scorm.maxattempt - attemptsCount;
    };
    /**
     * Returns the mode and attempt number to use based on mode selected and SCORM data.
     * This function is based on Moodle's scorm_check_mode.
     *
     * @param {any} scorm SCORM.
     * @param {string} mode Selected mode.
     * @param {number} attempt Current attempt.
     * @param {boolean} [newAttempt] Whether it should start a new attempt.
     * @param {boolean} [incomplete] Whether current attempt is incomplete.
     * @return {{mode: string, attempt: number, newAttempt: boolean}} Mode, attempt number and whether to start a new attempt.
     */
    AddonModScormProvider.prototype.determineAttemptAndMode = function (scorm, mode, attempt, newAttempt, incomplete) {
        if (mode == AddonModScormProvider_1.MODEBROWSE) {
            if (scorm.hidebrowse) {
                // Prevent Browse mode if hidebrowse is set.
                mode = AddonModScormProvider_1.MODENORMAL;
            }
            else {
                // We don't need to check attempts as browse mode is set.
                if (attempt == 0) {
                    attempt = 1;
                    newAttempt = true;
                }
                return {
                    mode: mode,
                    attempt: attempt,
                    newAttempt: newAttempt
                };
            }
        }
        if (scorm.forcenewattempt == AddonModScormProvider_1.SCORM_FORCEATTEMPT_ALWAYS) {
            // This SCORM is configured to force a new attempt on every re-entry.
            return {
                mode: AddonModScormProvider_1.MODENORMAL,
                attempt: attempt + 1,
                newAttempt: true
            };
        }
        // Validate user request to start a new attempt.
        if (attempt == 0) {
            newAttempt = true;
        }
        else if (incomplete) {
            // The option to start a new attempt should never have been presented. Force false.
            newAttempt = false;
        }
        else if (scorm.forcenewattempt) {
            // A new attempt should be forced for already completed attempts.
            newAttempt = true;
        }
        if (newAttempt && (scorm.maxattempt == 0 || attempt < scorm.maxattempt)) {
            // Create a new attempt. Force mode normal.
            attempt++;
            mode = AddonModScormProvider_1.MODENORMAL;
        }
        else {
            if (incomplete) {
                // We can't review an incomplete attempt.
                mode = AddonModScormProvider_1.MODENORMAL;
            }
            else {
                // We aren't starting a new attempt and the current one is complete, force review mode.
                mode = AddonModScormProvider_1.MODEREVIEW;
            }
        }
        return {
            mode: mode,
            attempt: attempt,
            newAttempt: newAttempt
        };
    };
    /**
     * Check if TOC should be displayed in the player.
     *
     * @param {any} scorm SCORM.
     * @return {boolean} Whether it should display TOC.
     */
    AddonModScormProvider.prototype.displayTocInPlayer = function (scorm) {
        return scorm.hidetoc !== 3;
    };
    /**
     * This is a little language parser for AICC_SCRIPT.
     * Evaluates the expression and returns a boolean answer.
     * See 2.3.2.5.1. Sequencing/Navigation Today - from the SCORM 1.2 spec (CAM).
     *
     * @param {string} prerequisites The AICC_SCRIPT prerequisites expression.
     * @param {any} trackData The tracked user data of each SCO.
     * @return {boolean} Whether the prerequisites are fulfilled.
     */
    AddonModScormProvider.prototype.evalPrerequisites = function (prerequisites, trackData) {
        var _this = this;
        var stack = []; // List of prerequisites.
        // Expand the amp entities.
        prerequisites = prerequisites.replace(/&amp;/gi, '&');
        // Find all my parsable tokens.
        prerequisites = prerequisites.replace(/(&|\||\(|\)|\~)/gi, '\t$1\t');
        // Expand operators.
        prerequisites = prerequisites.replace(/&/gi, '&&');
        prerequisites = prerequisites.replace(/\|/gi, '||');
        // Now - grab all the tokens.
        var elements = prerequisites.trim().split('\t');
        // Process each token to build an expression to be evaluated.
        elements.forEach(function (element) {
            element = element.trim();
            if (!element) {
                return;
            }
            if (!element.match(/^(&&|\|\||\(|\))$/gi)) {
                // Create each individual expression.
                // Search for ~ = <> X*{} .
                var re = /^(\d+)\*\{(.+)\}$/, // Sets like 3*{S34, S36, S37, S39}.
                reOther = /^(.+)(\=|\<\>)(.+)$/; // Other symbols.
                var matches = void 0;
                if (re.test(element)) {
                    matches = element.match(re);
                    var repeat = matches[1], set = matches[2].split(',');
                    var count_1 = 0;
                    set.forEach(function (setElement) {
                        setElement = setElement.trim();
                        if (typeof trackData[setElement] != 'undefined' &&
                            (trackData[setElement].status == 'completed' || trackData[setElement].status == 'passed')) {
                            count_1++;
                        }
                    });
                    if (count_1 >= repeat) {
                        element = 'true';
                    }
                    else {
                        element = 'false';
                    }
                }
                else if (element == '~') {
                    // Not maps ~.
                    element = '!';
                }
                else if (reOther.test(element)) {
                    // Other symbols = | <> .
                    matches = element.match(reOther);
                    element = matches[1].trim();
                    if (typeof trackData[element] != 'undefined') {
                        var value = matches[3].trim().replace(/(\'|\")/gi), oper = void 0;
                        if (typeof _this.STATUSES[value] != 'undefined') {
                            value = _this.STATUSES[value];
                        }
                        if (matches[2] == '<>') {
                            oper = '!=';
                        }
                        else {
                            oper = '==';
                        }
                        element = '(\'' + trackData[element].status + '\' ' + oper + ' \'' + value + '\')';
                    }
                    else {
                        element = 'false';
                    }
                }
                else {
                    // Everything else must be an element defined like S45 ...
                    if (typeof trackData[element] != 'undefined' &&
                        (trackData[element].status == 'completed' || trackData[element].status == 'passed')) {
                        element = 'true';
                    }
                    else {
                        element = 'false';
                    }
                }
            }
            // Add the element to the list of prerequisites.
            stack.push(' ' + element + ' ');
        });
        // tslint:disable: no-eval
        return eval(stack.join('') + ';');
    };
    /**
     * Formats a grade to be displayed.
     *
     * @param {any} scorm SCORM.
     * @param {number} grade Grade.
     * @return {string} Grade to display.
     */
    AddonModScormProvider.prototype.formatGrade = function (scorm, grade) {
        if (typeof grade == 'undefined' || grade == -1) {
            return this.translate.instant('core.none');
        }
        if (scorm.grademethod !== AddonModScormProvider_1.GRADESCOES && scorm.maxgrade > 0) {
            grade = (grade / scorm.maxgrade) * 100;
            return this.translate.instant('core.percentagenumber', { $a: this.textUtils.roundToDecimals(grade, 2) });
        }
        return String(grade);
    };
    /**
     * Formats a tree-like TOC into an array.
     *
     * @param {any[]} toc SCORM's TOC (tree format).
     * @param {number} [level=0] The level of the TOC we're right now. 0 by default.
     * @return {any[]} SCORM's TOC (array format).
     */
    AddonModScormProvider.prototype.formatTocToArray = function (toc, level) {
        var _this = this;
        if (level === void 0) { level = 0; }
        if (!toc || !toc.length) {
            return [];
        }
        var formatted = [];
        toc.forEach(function (node) {
            node.level = level;
            formatted.push(node);
            formatted = formatted.concat(_this.formatTocToArray(node.children, level + 1));
        });
        return formatted;
    };
    /**
     * Get access information for a given SCORM.
     *
     * @param  {number}  scormId      SCORM ID.
     * @param  {boolean} [forceCache] True to always get the value from cache. false otherwise.
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>} Object with access information.
     * @since 3.7
     */
    AddonModScormProvider.prototype.getAccessInformation = function (scormId, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.wsAvailable('mod_scorm_get_scorm_access_information')) {
                // Access information not available for 3.6 or older sites.
                return Promise.resolve({});
            }
            var params = {
                scormid: scormId
            };
            var preSets = {
                cacheKey: _this.getAccessInformationCacheKey(scormId),
                omitExpires: forceCache
            };
            return site.read('mod_scorm_get_scorm_access_information', params, preSets);
        });
    };
    /**
     * Get cache key for access information WS calls.
     *
     * @param {number} scormId SCORM ID.
     * @return {string} Cache key.
     */
    AddonModScormProvider.prototype.getAccessInformationCacheKey = function (scormId) {
        return this.ROOT_CACHE_KEY + 'accessInfo:' + scormId;
    };
    /**
     * Get the number of attempts done by a user in the given SCORM.
     *
     * @param {number} scormId SCORM ID.
     * @param {boolean} [ignoreMissing] Whether it should ignore attempts without grade/completion. Only for online attempts.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data for online attempts.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<AddonModScormAttemptCountResult>} Promise resolved when done.
     */
    AddonModScormProvider.prototype.getAttemptCount = function (scormId, ignoreMissing, ignoreCache, siteId, userId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var result = {
                lastAttempt: {
                    number: 0,
                    offline: false
                }
            }, promises = [];
            promises.push(_this.getAttemptCountOnline(scormId, ignoreMissing, ignoreCache, siteId, userId).then(function (count) {
                // Calculate numbers of online attempts.
                result.online = [];
                for (var i = 1; i <= count; i++) {
                    result.online.push(i);
                }
                // Calculate last attempt.
                if (count > result.lastAttempt.number) {
                    result.lastAttempt.number = count;
                    result.lastAttempt.offline = false;
                }
            }));
            promises.push(_this.scormOfflineProvider.getAttempts(scormId, siteId, userId).then(function (attempts) {
                // Get only attempt numbers.
                result.offline = attempts.map(function (entry) {
                    // Calculate last attempt. We use >= to prioritize offline events if an attempt is both online and offline.
                    if (entry.attempt >= result.lastAttempt.number) {
                        result.lastAttempt.number = entry.attempt;
                        result.lastAttempt.offline = true;
                    }
                    return entry.attempt;
                });
            }));
            return Promise.all(promises).then(function () {
                var total = result.online.length;
                result.offline.forEach(function (attempt) {
                    // Check if this attempt also exists in online, it might have been copied to local.
                    if (result.online.indexOf(attempt) == -1) {
                        total++;
                    }
                });
                result.total = total;
                return result;
            });
        });
    };
    /**
     * Get cache key for SCORM attempt count WS calls.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} [userId] User ID. If not defined, current user.
     * @return {string} Cache key.
     */
    AddonModScormProvider.prototype.getAttemptCountCacheKey = function (scormId, userId) {
        return this.ROOT_CACHE_KEY + 'attemptcount:' + scormId + ':' + userId;
    };
    /**
     * Get the number of attempts done by a user in the given SCORM in online.
     *
     * @param {number} scormId SCORM ID.
     * @param {boolean} [ignoreMissing] Whether it should ignore attempts that haven't reported a grade/completion.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<number>} Promise resolved when the attempt count is retrieved.
     */
    AddonModScormProvider.prototype.getAttemptCountOnline = function (scormId, ignoreMissing, ignoreCache, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                scormid: scormId,
                userid: userId,
                ignoremissingcompletion: ignoreMissing ? 1 : 0
            }, preSets = {
                cacheKey: _this.getAttemptCountCacheKey(scormId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_12__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_scorm_get_scorm_attempt_count', params, preSets).then(function (response) {
                if (response && typeof response.attemptscount != 'undefined') {
                    return response.attemptscount;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get the grade for a certain SCORM and attempt.
     * Based on Moodle's scorm_grade_user_attempt.
     *
     * @param {any} scorm SCORM.
     * @param {number} attempt Attempt number.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the grade. If the attempt hasn't reported grade/completion, it will be -1.
     */
    AddonModScormProvider.prototype.getAttemptGrade = function (scorm, attempt, offline, siteId) {
        var attemptScore = {
            scos: 0,
            values: 0,
            max: 0,
            sum: 0
        };
        // Get the user data and use it to calculate the grade.
        return this.getScormUserData(scorm.id, attempt, undefined, offline, false, siteId).then(function (data) {
            for (var scoId in data) {
                var sco = data[scoId], userData = sco.userdata;
                if (userData.status == 'completed' || userData.status == 'passed') {
                    attemptScore.scos++;
                }
                if (userData.score_raw || (typeof scorm.scormtype != 'undefined' &&
                    scorm.scormtype == 'sco' && typeof userData.score_raw != 'undefined')) {
                    var scoreRaw = parseFloat(userData.score_raw);
                    attemptScore.values++;
                    attemptScore.sum += scoreRaw;
                    attemptScore.max = Math.max(scoreRaw, attemptScore.max);
                }
            }
            var score = 0;
            switch (scorm.grademethod) {
                case AddonModScormProvider_1.GRADEHIGHEST:
                    score = attemptScore.max;
                    break;
                case AddonModScormProvider_1.GRADEAVERAGE:
                    if (attemptScore.values > 0) {
                        score = attemptScore.sum / attemptScore.values;
                    }
                    else {
                        score = 0;
                    }
                    break;
                case AddonModScormProvider_1.GRADESUM:
                    score = attemptScore.sum;
                    break;
                case AddonModScormProvider_1.GRADESCOES:
                    score = attemptScore.scos;
                    break;
                default:
                    score = attemptScore.max; // Remote Learner GRADEHIGHEST is default.
            }
            return score;
        });
    };
    /**
     * Get the list of a organizations defined in a SCORM package.
     *
     * @param {number} scormId SCORM ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of organizations.
     */
    AddonModScormProvider.prototype.getOrganizations = function (scormId, siteId) {
        return this.getScos(scormId, undefined, false, siteId).then(function (scos) {
            var organizations = [];
            scos.forEach(function (sco) {
                // Is an organization entry?
                if (sco.organization == '' && sco.parent == '/' && sco.scormtype == '') {
                    organizations.push({
                        identifier: sco.identifier,
                        title: sco.title,
                        sortorder: sco.sortorder
                    });
                }
            });
            return organizations;
        });
    };
    /**
     * Get the organization Toc any
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt The attempt number (to populate SCO track data).
     * @param {string} [organization] Organization identifier.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the toc object.
     */
    AddonModScormProvider.prototype.getOrganizationToc = function (scormId, attempt, organization, offline, siteId) {
        return this.getScosWithData(scormId, attempt, organization, offline, false, siteId).then(function (scos) {
            var map = {}, rootScos = [];
            scos.forEach(function (sco, index) {
                sco.children = [];
                map[sco.identifier] = index;
                if (sco.parent !== '/') {
                    if (sco.parent == organization) {
                        // It's a root SCO, add it to the root array.
                        rootScos.push(sco);
                    }
                    else {
                        // Add this sco to the parent.
                        scos[map[sco.parent]].children.push(sco);
                    }
                }
            });
            return rootScos;
        });
    };
    /**
     * Get the package URL of a given SCORM.
     *
     * @param {any} scorm SCORM.
     * @return {string} Package URL.
     */
    AddonModScormProvider.prototype.getPackageUrl = function (scorm) {
        if (scorm.packageurl) {
            return scorm.packageurl;
        }
        if (scorm.reference) {
            return scorm.reference;
        }
        return '';
    };
    /**
     * Get the user data for a certain SCORM and attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} [scos] SCOs returned by getScos. Recommended if offline=true.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data for online attempts.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the user data is retrieved.
     */
    AddonModScormProvider.prototype.getScormUserData = function (scormId, attempt, scos, offline, ignoreCache, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (offline) {
            // Get SCOs if not provided.
            var promise = scos ? Promise.resolve(scos) : this.getScos(scormId, undefined, undefined, siteId);
            return promise.then(function (scos) {
                return _this.scormOfflineProvider.getScormUserData(scormId, attempt, scos, siteId);
            });
        }
        else {
            return this.getScormUserDataOnline(scormId, attempt, ignoreCache, siteId);
        }
    };
    /**
     * Get cache key for SCORM user data WS calls.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @return {string} Cache key.
     */
    AddonModScormProvider.prototype.getScormUserDataCacheKey = function (scormId, attempt) {
        return this.getScormUserDataCommonCacheKey(scormId) + ':' + attempt;
    };
    /**
     * Get common cache key for SCORM user data WS calls.
     *
     * @param {number} scormId SCORM ID.
     * @return {string} Cache key.
     */
    AddonModScormProvider.prototype.getScormUserDataCommonCacheKey = function (scormId) {
        return this.ROOT_CACHE_KEY + 'userdata:' + scormId;
    };
    /**
     * Get the user data for a certain SCORM and attempt in online.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the user data is retrieved.
     */
    AddonModScormProvider.prototype.getScormUserDataOnline = function (scormId, attempt, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                scormid: scormId,
                attempt: attempt
            }, preSets = {
                cacheKey: _this.getScormUserDataCacheKey(scormId, attempt)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_scorm_get_scorm_user_data', params, preSets).then(function (response) {
                if (response && response.data) {
                    // Format the response.
                    var data_1 = {};
                    response.data.forEach(function (sco) {
                        sco.defaultdata = _this.utils.objectToKeyValueMap(sco.defaultdata, 'element', 'value');
                        sco.userdata = _this.utils.objectToKeyValueMap(sco.userdata, 'element', 'value');
                        data_1[sco.scoid] = sco;
                    });
                    return data_1;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get SCORM scos WS calls.
     *
     * @param {number} scormId SCORM ID.
     * @return {string} Cache key.
     */
    AddonModScormProvider.prototype.getScosCacheKey = function (scormId) {
        return this.ROOT_CACHE_KEY + 'scos:' + scormId;
    };
    /**
     * Retrieves the list of SCO objects for a given SCORM and organization.
     *
     * @param {number} scormId SCORM ID.
     * @param {string} [organization] Organization.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail if offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]} Promise resolved with a list of SCO.
     */
    AddonModScormProvider.prototype.getScos = function (scormId, organization, ignoreCache, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Don't send the organization to the WS, we'll filter them locally.
            var params = {
                scormid: scormId
            }, preSets = {
                cacheKey: _this.getScosCacheKey(scormId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_12__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_scorm_get_scorm_scoes', params, preSets).then(function (response) {
                if (response && response.scoes) {
                    if (organization) {
                        // Filter SCOs by organization.
                        return response.scoes.filter(function (sco) {
                            return sco.organization == organization;
                        });
                    }
                    else {
                        return response.scoes;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Retrieves the list of SCO objects for a given SCORM and organization, including data about
     * a certain attempt (status, isvisible, ...).
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {string} [organization] Organization ID.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data for online attempts.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with a list of SCO objects.
     */
    AddonModScormProvider.prototype.getScosWithData = function (scormId, attempt, organization, offline, ignoreCache, siteId) {
        var _this = this;
        // Get organization SCOs.
        return this.getScos(scormId, organization, ignoreCache, siteId).then(function (scos) {
            // Get the track data for all the SCOs in the organization for the given attempt.
            // We'll use this data to set SCO data like isvisible, status and so.
            return _this.getScormUserData(scormId, attempt, scos, offline, ignoreCache, siteId).then(function (data) {
                var trackDataBySCO = {};
                // First populate trackDataBySCO to index by SCO identifier.
                // We want the full list first because it's needed by evalPrerequisites.
                scos.forEach(function (sco) {
                    trackDataBySCO[sco.identifier] = data[sco.id].userdata;
                });
                scos.forEach(function (sco) {
                    // Add specific SCO information (related to tracked data).
                    var scoData = data[sco.id].userdata;
                    if (!scoData) {
                        return;
                    }
                    // Check isvisible attribute.
                    sco.isvisible = typeof scoData.isvisible == 'undefined' || (scoData.isvisible && scoData.isvisible !== 'false');
                    // Check pre-requisites status.
                    sco.prereq = typeof scoData.prerequisites == 'undefined' ||
                        _this.evalPrerequisites(scoData.prerequisites, trackDataBySCO);
                    // Add status.
                    sco.status = (typeof scoData.status == 'undefined' || scoData.status === '') ?
                        'notattempted' : scoData.status;
                    // Exit var.
                    sco.exitvar = typeof scoData.exitvar == 'undefined' ? 'cmi.core.exit' : scoData.exitvar;
                    sco.exitvalue = scoData[sco.exitvar];
                });
                return scos;
            });
        });
    };
    /**
     * Given a SCORM and a SCO, returns the full launch URL for the SCO.
     *
     * @param {any} scorm SCORM.
     * @param {any} sco SCO.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the URL.
     */
    AddonModScormProvider.prototype.getScoSrc = function (scorm, sco, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Build the launch URL. Moodle web checks SCORM version, we don't need to, it's always SCORM 1.2.
        var launchUrl = sco.launch, parameters;
        if (sco.extradata && sco.extradata.length) {
            for (var i = 0; i < sco.extradata.length; i++) {
                var entry = sco.extradata[i];
                if (entry.element == 'parameters') {
                    parameters = entry.value;
                    break;
                }
            }
        }
        if (parameters) {
            var connector = launchUrl.indexOf('?') > -1 ? '&' : '?';
            if (parameters.charAt(0) == '?') {
                parameters = parameters.substr(1);
            }
            launchUrl += connector + parameters;
        }
        if (this.isExternalLink(launchUrl)) {
            // It's an online URL.
            return Promise.resolve(launchUrl);
        }
        return this.filepoolProvider.getPackageDirUrlByUrl(siteId, scorm.moduleurl).then(function (dirPath) {
            return _this.textUtils.concatenatePaths(dirPath, launchUrl);
        });
    };
    /**
     * Get the path to the folder where a SCORM is downloaded.
     *
     * @param {string} moduleUrl Module URL (returned by get_course_contents).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the folder path.
     */
    AddonModScormProvider.prototype.getScormFolder = function (moduleUrl, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.getPackageDirPathByUrl(siteId, moduleUrl);
    };
    /**
     * Gets a list of files to downlaod for a SCORM, using a format similar to module.contents from get_course_contents.
     * It will only return one file: the ZIP package.
     *
     * @param {any} scorm SCORM.
     * @return {any[]} File list.
     */
    AddonModScormProvider.prototype.getScormFileList = function (scorm) {
        var files = [];
        if (!this.isScormUnsupported(scorm) && !scorm.warningMessage) {
            files.push({
                fileurl: this.getPackageUrl(scorm),
                filepath: '/',
                filename: scorm.reference,
                filesize: scorm.packagesize,
                type: 'file',
                timemodified: 0
            });
        }
        return files;
    };
    /**
     * Get the URL and description of the status icon.
     *
     * @param {any} sco SCO.
     * @param {boolean} [incomplete] Whether the SCORM is incomplete.
     * @return {{url: string, description: string}} Image URL and description.
     */
    AddonModScormProvider.prototype.getScoStatusIcon = function (sco, incomplete) {
        var imageName = '', descName = '', status;
        if (sco.scormtype == 'sco') {
            // Not an asset, calculate image using status.
            status = sco.status;
            if (this.VALID_STATUSES.indexOf(status) < 0) {
                // Status empty or not valid, use 'notattempted'.
                status = 'notattempted';
            }
            if (!incomplete) {
                // Check if SCO is completed or not. If SCORM is incomplete there's no need to check SCO.
                incomplete = this.isStatusIncomplete(status);
            }
            if (incomplete && sco.exitvalue == 'suspend') {
                imageName = 'suspend';
                descName = 'suspended';
            }
            else {
                imageName = sco.status;
                descName = sco.status;
            }
        }
        else {
            imageName = 'asset';
            descName = (!sco.status || sco.status == 'notattempted') ? 'asset' : 'assetlaunched';
        }
        return {
            url: 'assets/img/scorm/' + imageName + '.gif',
            description: this.translate.instant('addon.mod_scorm.' + descName)
        };
    };
    /**
     * Get cache key for SCORM data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModScormProvider.prototype.getScormDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'scorm:' + courseId;
    };
    /**
     * Get a SCORM with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {string} [moduleUrl] Module URL.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the SCORM is retrieved.
     */
    AddonModScormProvider.prototype.getScormByField = function (courseId, key, value, moduleUrl, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getScormDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_12__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            return site.read('mod_scorm_get_scorms_by_courses', params, preSets).then(function (response) {
                if (response && response.scorms) {
                    var currentScorm = response.scorms.find(function (scorm) {
                        return scorm[key] == value;
                    });
                    if (currentScorm) {
                        // If the SCORM isn't available the WS returns a warning and it doesn't return timeopen and timeclosed.
                        if (typeof currentScorm.timeopen == 'undefined') {
                            for (var i in response.warnings) {
                                var warning = response.warnings[i];
                                if (warning.itemid === currentScorm.id) {
                                    currentScorm.warningMessage = warning.message;
                                    break;
                                }
                            }
                        }
                        currentScorm.moduleurl = moduleUrl;
                        return currentScorm;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a SCORM by module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @param {string} [moduleUrl] Module URL.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the SCORM is retrieved.
     */
    AddonModScormProvider.prototype.getScorm = function (courseId, cmId, moduleUrl, forceCache, siteId) {
        return this.getScormByField(courseId, 'coursemodule', cmId, moduleUrl, forceCache, siteId);
    };
    /**
     * Get a SCORM by SCORM ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} id SCORM ID.
     * @param {string} [moduleUrl] Module URL.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the SCORM is retrieved.
     */
    AddonModScormProvider.prototype.getScormById = function (courseId, id, moduleUrl, forceCache, siteId) {
        return this.getScormByField(courseId, 'id', id, moduleUrl, forceCache, siteId);
    };
    /**
     * Get a readable SCORM grade method.
     *
     * @param {any} scorm SCORM.
     * @return {string} Grading method.
     */
    AddonModScormProvider.prototype.getScormGradeMethod = function (scorm) {
        if (scorm.maxattempt == 1) {
            switch (parseInt(scorm.grademethod, 10)) {
                case AddonModScormProvider_1.GRADEHIGHEST:
                    return this.translate.instant('addon.mod_scorm.gradehighest');
                case AddonModScormProvider_1.GRADEAVERAGE:
                    return this.translate.instant('addon.mod_scorm.gradeaverage');
                case AddonModScormProvider_1.GRADESUM:
                    return this.translate.instant('addon.mod_scorm.gradesum');
                case AddonModScormProvider_1.GRADESCOES:
                    return this.translate.instant('addon.mod_scorm.gradescoes');
                default:
                    return '';
            }
        }
        else {
            switch (parseInt(scorm.whatgrade, 10)) {
                case AddonModScormProvider_1.HIGHESTATTEMPT:
                    return this.translate.instant('addon.mod_scorm.highestattempt');
                case AddonModScormProvider_1.AVERAGEATTEMPT:
                    return this.translate.instant('addon.mod_scorm.averageattempt');
                case AddonModScormProvider_1.FIRSTATTEMPT:
                    return this.translate.instant('addon.mod_scorm.firstattempt');
                case AddonModScormProvider_1.LASTATTEMPT:
                    return this.translate.instant('addon.mod_scorm.lastattempt');
                default:
                    return '';
            }
        }
    };
    /**
     * Invalidates access information.
     *
     * @param  {number} forumId  SCORM ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormProvider.prototype.invalidateAccessInformation = function (scormId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getAccessInformationCacheKey(scormId));
        });
    };
    /**
     * Invalidates all the data related to a certain SCORM.
     *
     * @param {number} scormId SCORM ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormProvider.prototype.invalidateAllScormData = function (scormId, siteId, userId) {
        var promises = [];
        promises.push(this.invalidateAttemptCount(scormId, siteId, userId));
        promises.push(this.invalidateScos(scormId, siteId));
        promises.push(this.invalidateScormUserData(scormId, siteId));
        promises.push(this.invalidateAccessInformation(scormId, siteId));
        return Promise.all(promises);
    };
    /**
     * Invalidates attempt count.
     *
     * @param {number} scormId SCORM ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormProvider.prototype.invalidateAttemptCount = function (scormId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getAttemptCountCacheKey(scormId, userId));
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID of the module.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormProvider.prototype.invalidateContent = function (moduleId, courseId, siteId, userId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getScorm(courseId, moduleId, undefined, false, siteId).then(function (scorm) {
            var promises = [];
            promises.push(_this.invalidateAllScormData(scorm.id, siteId, userId));
            promises.push(_this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModScormProvider_1.COMPONENT, moduleId, true));
            return Promise.all(promises);
        });
    };
    /**
     * Invalidates SCORM data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormProvider.prototype.invalidateScormData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getScormDataCacheKey(courseId));
        });
    };
    /**
     * Invalidates SCORM user data for all attempts.
     *
     * @param {number} scormId SCORM ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormProvider.prototype.invalidateScormUserData = function (scormId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getScormUserDataCommonCacheKey(scormId));
        });
    };
    /**
     * Invalidates SCORM scos for all organizations.
     *
     * @param {number} scormId SCORM ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormProvider.prototype.invalidateScos = function (scormId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getScosCacheKey(scormId));
        });
    };
    /**
     * Check if a SCORM's attempt is incomplete.
     *
     * @param {any} scormId SCORM ID.
     * @param {number} attempt Attempt.
     * @param {boolean} offline Whether the attempt is offline.
     * @param {boolean} ignoreCache Whether it should ignore cached data for online attempts.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with a boolean: true if incomplete, false otherwise.
     */
    AddonModScormProvider.prototype.isAttemptIncomplete = function (scormId, attempt, offline, ignoreCache, siteId) {
        var _this = this;
        return this.getScosWithData(scormId, attempt, undefined, offline, ignoreCache, siteId).then(function (scos) {
            for (var i in scos) {
                var sco = scos[i];
                // Ignore SCOs not visible or without launch URL.
                if (sco.isvisible && sco.launch) {
                    if (_this.isStatusIncomplete(sco.status)) {
                        return true;
                    }
                }
            }
            return false;
        });
    };
    /**
     * Given a launch URL, check if it's a external link.
     * Based on Moodle's scorm_external_link.
     *
     * @param {string} link Link to check.
     * @return {boolean} Whether it's an external link.
     */
    AddonModScormProvider.prototype.isExternalLink = function (link) {
        link = link.toLowerCase();
        if (link.match(/https?:\/\//)) {
            return true;
        }
        else if (link.substr(0, 4) == 'www.') {
            return true;
        }
        return false;
    };
    /**
     * Check if the given SCORM is closed.
     *
     * @param {any} scorm SCORM to check.
     * @return {boolean} Whether the SCORM is closed.
     */
    AddonModScormProvider.prototype.isScormClosed = function (scorm) {
        var timeNow = this.timeUtils.timestamp();
        if (scorm.timeclose > 0 && timeNow > scorm.timeclose) {
            return true;
        }
        return false;
    };
    /**
     * Check if the given SCORM is downloadable.
     *
     * @param {any} scorm SCORM to check.
     * @return {boolean} Whether the SCORM is downloadable.
     */
    AddonModScormProvider.prototype.isScormDownloadable = function (scorm) {
        return typeof scorm.protectpackagedownloads != 'undefined' && scorm.protectpackagedownloads === false;
    };
    /**
     * Check if the given SCORM is open.
     *
     * @param {any} scorm SCORM to check.
     * @return {boolean} Whether the SCORM is open.
     */
    AddonModScormProvider.prototype.isScormOpen = function (scorm) {
        var timeNow = this.timeUtils.timestamp();
        if (scorm.timeopen > 0 && scorm.timeopen > timeNow) {
            return false;
        }
        return true;
    };
    /**
     * Check if a SCORM is unsupported in the app. If it's not, returns the error code to show.
     *
     * @param {any} scorm SCORM to check.
     * @return {string} String with error code if unsupported, undefined if supported.
     */
    AddonModScormProvider.prototype.isScormUnsupported = function (scorm) {
        if (!this.isScormValidVersion(scorm)) {
            return 'addon.mod_scorm.errorinvalidversion';
        }
        else if (!this.isScormDownloadable(scorm)) {
            return 'addon.mod_scorm.errornotdownloadable';
        }
        else if (!this.isValidPackageUrl(this.getPackageUrl(scorm))) {
            return 'addon.mod_scorm.errorpackagefile';
        }
    };
    /**
     * Check if it's a valid SCORM 1.2.
     *
     * @param {any} scorm SCORM to check.
     * @return {boolean} Whether the SCORM is valid.
     */
    AddonModScormProvider.prototype.isScormValidVersion = function (scorm) {
        return scorm.version == 'SCORM_1.2';
    };
    /**
     * Check if a SCO status is incomplete.
     *
     * @param {string} status SCO status.
     * @return {boolean} Whether it's incomplete.
     */
    AddonModScormProvider.prototype.isStatusIncomplete = function (status) {
        return !status || status == 'notattempted' || status == 'incomplete' || status == 'browsed';
    };
    /**
     * Check if a package URL is valid.
     *
     * @param {string} packageUrl Package URL.
     * @return {boolean} Whether it's valid.
     */
    AddonModScormProvider.prototype.isValidPackageUrl = function (packageUrl) {
        if (!packageUrl) {
            return false;
        }
        if (packageUrl.indexOf('imsmanifest.xml') > -1) {
            return false;
        }
        return true;
    };
    /**
     * Report a SCO as being launched.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} scoId SCO ID.
     * @param {string} [name] Name of the SCORM.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModScormProvider.prototype.logLaunchSco = function (scormId, scoId, name, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                scormid: scormId,
                scoid: scoId
            };
            return _this.logHelper.logSingle('mod_scorm_launch_sco', params, AddonModScormProvider_1.COMPONENT, scormId, name, 'scorm', { scoid: scoId }, siteId);
        });
    };
    /**
     * Report a SCORM as being viewed.
     *
     * @param {string} id Module ID.
     * @param {string} [name] Name of the SCORM.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModScormProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            scormid: id
        };
        return this.logHelper.logSingle('mod_scorm_view_scorm', params, AddonModScormProvider_1.COMPONENT, id, name, 'scorm', {}, siteId);
    };
    /**
     * Saves a SCORM tracking record.
     *
     * @param {number} scoId Sco ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} tracks Tracking data to store.
     * @param {any} scorm SCORM.
     * @param {boolean} offline Whether the attempt is offline.
     * @param {any} [userData] User data for this attempt and SCO. If not defined, it will be retrieved from DB. Recommended.
     * @return {Promise<any>} Promise resolved when data is saved.
     */
    AddonModScormProvider.prototype.saveTracks = function (scoId, attempt, tracks, scorm, offline, userData, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (offline) {
            var promise = userData ? Promise.resolve(userData) : this.getScormUserData(scorm.id, attempt, undefined, offline, false, siteId);
            return promise.then(function (userData) {
                return _this.scormOfflineProvider.saveTracks(scorm, scoId, attempt, tracks, userData, siteId);
            });
        }
        else {
            return this.saveTracksOnline(scorm.id, scoId, attempt, tracks, siteId).then(function () {
                // Tracks have been saved, update cached user data.
                _this.updateUserDataAfterSave(scorm.id, attempt, tracks, siteId);
                _this.eventsProvider.trigger(AddonModScormProvider_1.DATA_SENT_EVENT, {
                    scormId: scorm.id,
                    scoId: scoId,
                    attempt: attempt
                }, _this.sitesProvider.getCurrentSiteId());
            });
        }
    };
    /**
     * Saves a SCORM tracking record.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} scoId Sco ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} tracks Tracking data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data is saved.
     */
    AddonModScormProvider.prototype.saveTracksOnline = function (scormId, scoId, attempt, tracks, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!tracks || !tracks.length) {
                return Promise.resolve(); // Nothing to save.
            }
            var params = {
                scoid: scoId,
                attempt: attempt,
                tracks: tracks
            };
            _this.syncProvider.blockOperation(AddonModScormProvider_1.COMPONENT, scormId, 'saveTracksOnline', site.id);
            return site.write('mod_scorm_insert_scorm_tracks', params).then(function (response) {
                if (response && response.trackids) {
                    return response.trackids;
                }
                return Promise.reject(null);
            }).finally(function () {
                _this.syncProvider.unblockOperation(AddonModScormProvider_1.COMPONENT, scormId, 'saveTracksOnline', site.id);
            });
        });
    };
    /**
     * Saves a SCORM tracking record using a synchronous call.
     * Please use this function only if synchronous is a must. It's recommended to use saveTracks.
     *
     * @param {number} scoId Sco ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} tracks Tracking data to store.
     * @param {any} scorm SCORM.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {any} [userData] User data for this attempt and SCO. Required if offline=true.
     * @return {boolean} In online returns true if data is inserted, false otherwise.
     *                   In offline returns true if data to insert is valid, false otherwise. True doesn't mean that the
     *                   data has been stored, this function can return true but the insertion can still fail somehow.
     */
    AddonModScormProvider.prototype.saveTracksSync = function (scoId, attempt, tracks, scorm, offline, userData) {
        if (offline) {
            return this.scormOfflineProvider.saveTracksSync(scorm, scoId, attempt, tracks, userData);
        }
        else {
            var success = this.saveTracksSyncOnline(scoId, attempt, tracks);
            if (success) {
                // Tracks have been saved, update cached user data.
                this.updateUserDataAfterSave(scorm.id, attempt, tracks);
                this.eventsProvider.trigger(AddonModScormProvider_1.DATA_SENT_EVENT, {
                    scormId: scorm.id,
                    scoId: scoId,
                    attempt: attempt
                }, this.sitesProvider.getCurrentSiteId());
            }
            return success;
        }
    };
    /**
     * Saves a SCORM tracking record using a synchronous call.
     * Please use this function only if synchronous is a must. It's recommended to use saveTracksOnline.
     *
     * @param {number} scoId Sco ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} tracks Tracking data.
     * @return {boolean} True if success, false otherwise.
     */
    AddonModScormProvider.prototype.saveTracksSyncOnline = function (scoId, attempt, tracks) {
        var params = {
            scoid: scoId,
            attempt: attempt,
            tracks: tracks
        }, currentSite = this.sitesProvider.getCurrentSite(), preSets = {
            siteUrl: currentSite.getURL(),
            wsToken: currentSite.getToken()
        };
        var wsFunction = 'mod_scorm_insert_scorm_tracks', response;
        if (!tracks || !tracks.length) {
            return true; // Nothing to save.
        }
        // Check if the method is available, use a prefixed version if possible.
        if (!currentSite.wsAvailable(wsFunction, false)) {
            if (currentSite.wsAvailable(__WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].WS_PREFIX + wsFunction, false)) {
                wsFunction = __WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].WS_PREFIX + wsFunction;
            }
            else {
                this.logger.error('WS function "' + wsFunction + '" is not available, even in compatibility mode.');
                return false;
            }
        }
        response = this.wsProvider.syncCall(wsFunction, params, preSets);
        if (response && !response.error && response.trackids) {
            return true;
        }
        return false;
    };
    /**
     * Check if the SCORM main file should be downloaded.
     * This function should only be called if the SCORM can be downloaded (not downloaded or outdated).
     *
     * @param {any} scorm SCORM to check.
     * @param {boolean} [isOutdated] True if package outdated, false if not downloaded, undefined to calculate it.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>}  Promise resolved with true if it should be downloaded, false otherwise.
     */
    AddonModScormProvider.prototype.shouldDownloadMainFile = function (scorm, isOutdated, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var component = AddonModScormProvider_1.COMPONENT;
        if (typeof isOutdated == 'undefined') {
            // Calculate if it's outdated.
            return this.filepoolProvider.getPackageData(siteId, component, scorm.coursemodule).then(function (data) {
                var isOutdated = data.status == __WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].OUTDATED ||
                    (data.status == __WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].DOWNLOADING && data.previous == __WEBPACK_IMPORTED_MODULE_13__core_constants__["a" /* CoreConstants */].OUTDATED);
                // Package needs to be downloaded if it's not outdated (not downloaded) or if the hash has changed.
                return !isOutdated || data.extra != scorm.sha1hash;
            }).catch(function () {
                // Package not found, not downloaded.
                return true;
            });
        }
        else if (isOutdated) {
            // The package is outdated, but maybe the file hasn't changed.
            return this.filepoolProvider.getPackageExtra(siteId, component, scorm.coursemodule).then(function (extra) {
                return scorm.sha1hash != extra;
            }).catch(function () {
                // Package not found, not downloaded.
                return true;
            });
        }
        else {
            // Package is not outdated and not downloaded, download the main file.
            return Promise.resolve(true);
        }
    };
    /**
     * If needed, updates cached user data after saving tracks in online.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} tracks Tracking data saved.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when updated.
     */
    AddonModScormProvider.prototype.updateUserDataAfterSave = function (scormId, attempt, tracks, siteId) {
        if (!tracks || !tracks.length) {
            return Promise.resolve();
        }
        // Check if we need to update. We only update if we sent some track with a dot notation.
        var needsUpdate = false;
        for (var i = 0, len = tracks.length; i < len; i++) {
            var track = tracks[i];
            if (track.element && track.element.indexOf('.') > -1) {
                needsUpdate = true;
                break;
            }
        }
        if (needsUpdate) {
            return this.getScormUserDataOnline(scormId, attempt, true, siteId);
        }
        return Promise.resolve();
    };
    AddonModScormProvider.COMPONENT = 'mmaModScorm';
    // Public constants.
    AddonModScormProvider.GRADESCOES = 0;
    AddonModScormProvider.GRADEHIGHEST = 1;
    AddonModScormProvider.GRADEAVERAGE = 2;
    AddonModScormProvider.GRADESUM = 3;
    AddonModScormProvider.HIGHESTATTEMPT = 0;
    AddonModScormProvider.AVERAGEATTEMPT = 1;
    AddonModScormProvider.FIRSTATTEMPT = 2;
    AddonModScormProvider.LASTATTEMPT = 3;
    AddonModScormProvider.MODEBROWSE = 'browse';
    AddonModScormProvider.MODENORMAL = 'normal';
    AddonModScormProvider.MODEREVIEW = 'review';
    AddonModScormProvider.SCORM_FORCEATTEMPT_NO = 0;
    AddonModScormProvider.SCORM_FORCEATTEMPT_ONCOMPLETE = 1;
    AddonModScormProvider.SCORM_FORCEATTEMPT_ALWAYS = 2;
    AddonModScormProvider.SKIPVIEW_NEVER = 0;
    AddonModScormProvider.SKIPVIEW_FIRST = 1;
    AddonModScormProvider.SKIPVIEW_ALWAYS = 2;
    // Events.
    AddonModScormProvider.LAUNCH_NEXT_SCO_EVENT = 'addon_mod_scorm_launch_next_sco';
    AddonModScormProvider.LAUNCH_PREV_SCO_EVENT = 'addon_mod_scorm_launch_prev_sco';
    AddonModScormProvider.UPDATE_TOC_EVENT = 'addon_mod_scorm_update_toc';
    AddonModScormProvider.GO_OFFLINE_EVENT = 'addon_mod_scorm_go_offline';
    AddonModScormProvider.DATA_SENT_EVENT = 'addon_mod_scorm_data_sent';
    AddonModScormProvider = AddonModScormProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_ws__["a" /* CoreWSProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_11__scorm_offline__["a" /* AddonModScormOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* CoreSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_14__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModScormProvider);
    return AddonModScormProvider;
    var AddonModScormProvider_1;
}());

//# sourceMappingURL=scorm.js.map

/***/ }),
/* 169 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__forum__ = __webpack_require__(100);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle offline forum.
 */
var AddonModForumOfflineProvider = /** @class */ (function () {
    function AddonModForumOfflineProvider(fileProvider, sitesProvider, textUtils) {
        this.fileProvider = fileProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.siteSchema = {
            name: 'AddonModForumOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModForumOfflineProvider_1.DISCUSSIONS_TABLE,
                    columns: [
                        {
                            name: 'forumid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'name',
                            type: 'TEXT',
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'subject',
                            type: 'TEXT',
                        },
                        {
                            name: 'message',
                            type: 'TEXT',
                        },
                        {
                            name: 'options',
                            type: 'TEXT',
                        },
                        {
                            name: 'groupid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER',
                        }
                    ],
                    primaryKeys: ['forumid', 'userid', 'timecreated']
                },
                {
                    name: AddonModForumOfflineProvider_1.REPLIES_TABLE,
                    columns: [
                        {
                            name: 'postid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'discussionid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'forumid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'name',
                            type: 'TEXT',
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'subject',
                            type: 'TEXT',
                        },
                        {
                            name: 'message',
                            type: 'TEXT',
                        },
                        {
                            name: 'options',
                            type: 'TEXT',
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER',
                        }
                    ],
                    primaryKeys: ['postid', 'userid']
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModForumOfflineProvider_1 = AddonModForumOfflineProvider;
    /**
     * Delete a forum offline discussion.
     *
     * @param  {number} forumId     Forum ID.
     * @param  {number} timeCreated The time the discussion was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @param  {number} [userId]    User the discussion belongs to. If not defined, current user in site.
     * @return {Promise<any>}       Promise resolved if stored, rejected if failure.
     */
    AddonModForumOfflineProvider.prototype.deleteNewDiscussion = function (forumId, timeCreated, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                forumid: forumId,
                userid: userId || site.getUserId(),
                timecreated: timeCreated,
            };
            return site.getDb().deleteRecords(AddonModForumOfflineProvider_1.DISCUSSIONS_TABLE, conditions);
        });
    };
    /**
     * Get a forum offline discussion.
     *
     * @param  {number} forumId     Forum ID.
     * @param  {number} timeCreated The time the discussion was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @param  {number} [userId]    User the discussion belongs to. If not defined, current user in site.
     * @return {Promise<any>}       Promise resolved if stored, rejected if failure.
     */
    AddonModForumOfflineProvider.prototype.getNewDiscussion = function (forumId, timeCreated, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                forumid: forumId,
                userid: userId || site.getUserId(),
                timecreated: timeCreated,
            };
            return site.getDb().getRecord(AddonModForumOfflineProvider_1.DISCUSSIONS_TABLE, conditions).then(function (record) {
                record.options = _this.textUtils.parseJSON(record.options);
                return record;
            });
        });
    };
    /**
     * Get all offline new discussions.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with discussions.
     */
    AddonModForumOfflineProvider.prototype.getAllNewDiscussions = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModForumOfflineProvider_1.DISCUSSIONS_TABLE).then(_this.parseRecordOptions.bind(_this));
        });
    };
    /**
     * Check if there are offline new discussions to send.
     *
     * @param  {number} forumId   Forum ID.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @param  {number} [userId]  User the discussions belong to. If not defined, current user in site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if has offline answers, false otherwise.
     */
    AddonModForumOfflineProvider.prototype.hasNewDiscussions = function (forumId, siteId, userId) {
        return this.getNewDiscussions(forumId, siteId, userId).then(function (discussions) {
            return !!discussions.length;
        }).catch(function () {
            // No offline data found, return false.
            return false;
        });
    };
    /**
     * Get new discussions to be synced.
     *
     * @param  {number} forumId  Forum ID to get.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the discussions belong to. If not defined, current user in site.
     * @return {Promise<any[]>}  Promise resolved with the object to be synced.
     */
    AddonModForumOfflineProvider.prototype.getNewDiscussions = function (forumId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                forumid: forumId,
                userid: userId || site.getUserId(),
            };
            return site.getDb().getRecords(AddonModForumOfflineProvider_1.DISCUSSIONS_TABLE, conditions)
                .then(_this.parseRecordOptions.bind(_this));
        });
    };
    /**
     * Offline version for adding a new discussion to a forum.
     *
     * @param  {number} forumId       Forum ID.
     * @param  {string} name          Forum name.
     * @param  {number} courseId      Course ID the forum belongs to.
     * @param  {string} subject       New discussion's subject.
     * @param  {string} message       New discussion's message.
     * @param  {any}    [options]     Options (subscribe, pin, ...).
     * @param  {string} [groupId]     Group this discussion belongs to.
     * @param  {number} [timeCreated] The time the discussion was created. If not defined, current time.
     * @param  {string} [siteId]      Site ID. If not defined, current site.
     * @param  {number} [userId]      User the discussion belong to. If not defined, current user in site.
     * @return {Promise<any>}         Promise resolved when new discussion is successfully saved.
     */
    AddonModForumOfflineProvider.prototype.addNewDiscussion = function (forumId, name, courseId, subject, message, options, groupId, timeCreated, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                forumid: forumId,
                name: name,
                courseid: courseId,
                subject: subject,
                message: message,
                options: JSON.stringify(options || {}),
                groupid: groupId || __WEBPACK_IMPORTED_MODULE_4__forum__["a" /* AddonModForumProvider */].ALL_PARTICIPANTS,
                userid: userId || site.getUserId(),
                timecreated: timeCreated || new Date().getTime()
            };
            return site.getDb().insertRecord(AddonModForumOfflineProvider_1.DISCUSSIONS_TABLE, data);
        });
    };
    /**
     * Delete forum offline replies.
     *
     * @param  {number} postId   ID of the post being replied.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the reply belongs to. If not defined, current user in site.
     * @return {Promise<any>}    Promise resolved if stored, rejected if failure.
     */
    AddonModForumOfflineProvider.prototype.deleteReply = function (postId, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                postid: postId,
                userid: userId || site.getUserId(),
            };
            return site.getDb().deleteRecords(AddonModForumOfflineProvider_1.REPLIES_TABLE, conditions);
        });
    };
    /**
     * Get all offline replies.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with replies.
     */
    AddonModForumOfflineProvider.prototype.getAllReplies = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModForumOfflineProvider_1.REPLIES_TABLE).then(_this.parseRecordOptions.bind(_this));
        });
    };
    /**
     * Check if there is an offline reply for a forum to be synced.
     *
     * @param  {number} forumId   ID of the forum being replied.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @param  {number} [userId]  User the replies belong to. If not defined, current user in site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if has offline answers, false otherwise.
     */
    AddonModForumOfflineProvider.prototype.hasForumReplies = function (forumId, siteId, userId) {
        return this.getForumReplies(forumId, siteId, userId).then(function (replies) {
            return !!replies.length;
        }).catch(function () {
            // No offline data found, return false.
            return false;
        });
    };
    /**
     * Get the replies of a forum to be synced.
     *
     * @param  {number} forumId  ID of the forum being replied.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the replies belong to. If not defined, current user in site.
     * @return {Promise<any[]>}  Promise resolved with replies.
     */
    AddonModForumOfflineProvider.prototype.getForumReplies = function (forumId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                forumid: forumId,
                userid: userId || site.getUserId(),
            };
            return site.getDb().getRecords(AddonModForumOfflineProvider_1.REPLIES_TABLE, conditions)
                .then(_this.parseRecordOptions.bind(_this));
        });
    };
    /**
     * Check if there is an offline reply to be synced.
     *
     * @param  {number} discussionId ID of the discussion the user is replying to.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @param  {number} [userId]     User the replies belong to. If not defined, current user in site.
     * @return {Promise<boolean>}    Promise resolved with boolean: true if has offline answers, false otherwise.
     */
    AddonModForumOfflineProvider.prototype.hasDiscussionReplies = function (discussionId, siteId, userId) {
        return this.getDiscussionReplies(discussionId, siteId, userId).then(function (replies) {
            return !!replies.length;
        }).catch(function () {
            // No offline data found, return false.
            return false;
        });
    };
    /**
     * Get the replies of a discussion to be synced.
     *
     * @param  {number} discussionId ID of the discussion the user is replying to.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @param  {number} [userId]     User the replies belong to. If not defined, current user in site.
     * @return {Promise<any[]>}      Promise resolved with discussions.
     */
    AddonModForumOfflineProvider.prototype.getDiscussionReplies = function (discussionId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                discussionid: discussionId,
                userid: userId || site.getUserId(),
            };
            return site.getDb().getRecords(AddonModForumOfflineProvider_1.REPLIES_TABLE, conditions)
                .then(_this.parseRecordOptions.bind(_this));
        });
    };
    /**
     * Offline version for replying to a certain post.
     *
     * @param  {number}  postId       ID of the post being replied.
     * @param  {number}  discussionId ID of the discussion the user is replying to.
     * @param  {number}  forumId      ID of the forum the user is replying to.
     * @param  {string}  name         Forum name.
     * @param  {number}  courseId     Course ID the forum belongs to.
     * @param  {string}  subject      New post's subject.
     * @param  {string}  message      New post's message.
     * @param  {any}     [options]    Options (subscribe, attachments, ...).
     * @param  {string}  [siteId]     Site ID. If not defined, current site.
     * @param  {number}  [userId]     User the post belong to. If not defined, current user in site.
     * @return {Promise<any>}         Promise resolved when the post is created.
     */
    AddonModForumOfflineProvider.prototype.replyPost = function (postId, discussionId, forumId, name, courseId, subject, message, options, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                postid: postId,
                discussionid: discussionId,
                forumid: forumId,
                name: name,
                courseid: courseId,
                subject: subject,
                message: message,
                options: JSON.stringify(options || {}),
                userid: userId || site.getUserId(),
                timecreated: new Date().getTime()
            };
            return site.getDb().insertRecord(AddonModForumOfflineProvider_1.REPLIES_TABLE, data);
        });
    };
    /**
     * Get the path to the folder where to store files for offline attachments in a forum.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<string>} Promise resolved with the path.
     */
    AddonModForumOfflineProvider.prototype.getForumFolder = function (forumId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var siteFolderPath = _this.fileProvider.getSiteFolder(site.getId());
            return _this.textUtils.concatenatePaths(siteFolderPath, 'offlineforum/' + forumId);
        });
    };
    /**
     * Get the path to the folder where to store files for a new offline discussion.
     *
     * @param  {number} forumId     Forum ID.
     * @param  {number} timeCreated The time the discussion was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<string>}    Promise resolved with the path.
     */
    AddonModForumOfflineProvider.prototype.getNewDiscussionFolder = function (forumId, timeCreated, siteId) {
        var _this = this;
        return this.getForumFolder(forumId, siteId).then(function (folderPath) {
            return _this.textUtils.concatenatePaths(folderPath, 'newdisc_' + timeCreated);
        });
    };
    /**
     * Get the path to the folder where to store files for a new offline reply.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {number} postId   ID of the post being replied.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the replies belong to. If not defined, current user in site.
     * @return {Promise<string>} Promise resolved with the path.
     */
    AddonModForumOfflineProvider.prototype.getReplyFolder = function (forumId, postId, siteId, userId) {
        var _this = this;
        return this.getForumFolder(forumId, siteId).then(function (folderPath) {
            return _this.sitesProvider.getSite(siteId).then(function (site) {
                userId = userId || site.getUserId();
                return _this.textUtils.concatenatePaths(folderPath, 'reply_' + postId + '_' + userId);
            });
        });
    };
    /**
     * Parse "options" column of fetched records.
     *
     * @param  {any[]} records List of records.
     * @return {any[]}         List of records with options parsed.
     */
    AddonModForumOfflineProvider.prototype.parseRecordOptions = function (records) {
        var _this = this;
        records.forEach(function (record) {
            record.options = _this.textUtils.parseJSON(record.options);
        });
        return records;
    };
    // Variables for database.
    AddonModForumOfflineProvider.DISCUSSIONS_TABLE = 'addon_mod_forum_discussions';
    AddonModForumOfflineProvider.REPLIES_TABLE = 'addon_mod_forum_replies';
    AddonModForumOfflineProvider = AddonModForumOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonModForumOfflineProvider);
    return AddonModForumOfflineProvider;
    var AddonModForumOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 170 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotificationsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_emulator_providers_helper__ = __webpack_require__(211);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__addon_messages_providers_messages__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service to handle notifications.
 */
var AddonNotificationsProvider = /** @class */ (function () {
    function AddonNotificationsProvider(logger, appProvider, sitesProvider, timeUtils, userProvider, emulatorHelper, messageProvider, textUtils) {
        this.appProvider = appProvider;
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.userProvider = userProvider;
        this.emulatorHelper = emulatorHelper;
        this.messageProvider = messageProvider;
        this.textUtils = textUtils;
        this.ROOT_CACHE_KEY = 'mmaNotifications:';
        this.logger = logger.getInstance('AddonNotificationsProvider');
    }
    AddonNotificationsProvider_1 = AddonNotificationsProvider;
    /**
     * Function to format notification data.
     *
     * @param {any[]} notifications List of notifications.
     * @param {boolean} [read] Whether the notifications are read or unread.
     * @return {Promise<any[]>} Promise resolved with notifications.
     */
    AddonNotificationsProvider.prototype.formatNotificationsData = function (notifications, read) {
        var _this = this;
        var promises = notifications.map(function (notification) {
            // Set message to show.
            if (notification.component && notification.component == 'mod_forum') {
                notification.mobiletext = notification.smallmessage;
            }
            else if (notification.component && notification.component == 'moodle' && notification.name == 'insights') {
                notification.mobiletext = notification.fullmessagehtml;
            }
            else {
                notification.mobiletext = notification.fullmessage;
            }
            notification.moodlecomponent = notification.component;
            notification.notification = 1;
            notification.notif = 1;
            if (typeof read != 'undefined') {
                notification.read = read;
            }
            if (typeof notification.customdata == 'string') {
                notification.customdata = _this.textUtils.parseJSON(notification.customdata, {});
            }
            // Try to set courseid the notification belongs to.
            if (notification.customdata && notification.customdata.courseid) {
                notification.courseid = notification.customdata.courseid;
            }
            else if (!notification.courseid) {
                var cid = notification.fullmessagehtml.match(/course\/view\.php\?id=([^"]*)/);
                if (cid && cid[1]) {
                    notification.courseid = parseInt(cid[1], 10);
                }
            }
            if (notification.useridfrom > 0) {
                // Try to get the profile picture of the user.
                return _this.userProvider.getProfile(notification.useridfrom, notification.courseid, true).then(function (user) {
                    notification.profileimageurlfrom = user.profileimageurl;
                    notification.userfromfullname = user.fullname;
                    return notification;
                }).catch(function () {
                    // Error getting user. This can happen if device is offline or the user is deleted.
                });
            }
            return Promise.resolve(notification);
        });
        return Promise.all(promises);
    };
    /**
     * Get the cache key for the get notification preferences call.
     *
     * @return {string} Cache key.
     */
    AddonNotificationsProvider.prototype.getNotificationPreferencesCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'notificationPreferences';
    };
    /**
     * Get notification preferences.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved with the notification preferences.
     */
    AddonNotificationsProvider.prototype.getNotificationPreferences = function (siteId) {
        var _this = this;
        this.logger.debug('Get notification preferences');
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getNotificationPreferencesCacheKey(),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('core_message_get_user_notification_preferences', {}, preSets).then(function (data) {
                return data.preferences;
            });
        });
    };
    /**
     * Get cache key for notification list WS calls.
     *
     * @return {string} Cache key.
     */
    AddonNotificationsProvider.prototype.getNotificationsCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'list';
    };
    /**
     * Get notifications from site.
     *
     * @param {boolean} read True if should get read notifications, false otherwise.
     * @param {number} limitFrom Position of the first notification to get.
     * @param {number} limitNumber Number of notifications to get or 0 to use the default limit.
     * @param {boolean} [toDisplay=true] True if notifications will be displayed to the user, either in view or in a notification.
     * @param {boolean} [forceCache] True if it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved with notifications.
     */
    AddonNotificationsProvider.prototype.getNotifications = function (read, limitFrom, limitNumber, toDisplay, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (limitNumber === void 0) { limitNumber = 0; }
        if (toDisplay === void 0) { toDisplay = true; }
        limitNumber = limitNumber || AddonNotificationsProvider_1.LIST_LIMIT;
        this.logger.debug('Get ' + (read ? 'read' : 'unread') + ' notifications from ' + limitFrom + '. Limit: ' + limitNumber);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                useridto: site.getUserId(),
                useridfrom: 0,
                type: 'notifications',
                read: read ? 1 : 0,
                newestfirst: 1,
                limitfrom: limitFrom,
                limitnum: limitNumber
            };
            var preSets = {
                cacheKey: _this.getNotificationsCacheKey(),
                omitExpires: forceCache,
                getFromCache: forceCache || !ignoreCache,
                emergencyCache: forceCache || !ignoreCache,
            };
            // Get unread notifications.
            return site.read('core_message_get_messages', data, preSets).then(function (response) {
                if (response.messages) {
                    var notifications_1 = response.messages;
                    return _this.formatNotificationsData(notifications_1, read).then(function () {
                        if (_this.appProvider.isDesktop() && toDisplay && !read && limitFrom === 0) {
                            // Store the last received notification. Don't block the user for this.
                            _this.emulatorHelper.storeLastReceivedNotification(AddonNotificationsProvider_1.PUSH_SIMULATION_COMPONENT, notifications_1[0], siteId);
                        }
                        return notifications_1;
                    });
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Get notifications from site using the new WebService.
     *
     * @param {number} offset Position of the first notification to get.
     * @param {number} [limit] Number of notifications to get. Defaults to LIST_LIMIT.
     * @param {boolean} [toDisplay=true] True if notifications will be displayed to the user, either in view or in a notification.
     * @param {boolean} [forceCache] True if it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{notifications: any[], canLoadMore: boolean}>} Promise resolved with notifications and if can load more.
     * @since 3.2
     */
    AddonNotificationsProvider.prototype.getPopupNotifications = function (offset, limit, toDisplay, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (toDisplay === void 0) { toDisplay = true; }
        limit = limit || AddonNotificationsProvider_1.LIST_LIMIT;
        this.logger.debug('Get popup notifications from ' + offset + '. Limit: ' + limit);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                useridto: site.getUserId(),
                newestfirst: 1,
                offset: offset,
                limit: limit + 1 // Get one more to calculate canLoadMore.
            }, preSets = {
                cacheKey: _this.getNotificationsCacheKey(),
                omitExpires: forceCache,
                getFromCache: forceCache || !ignoreCache,
                emergencyCache: forceCache || !ignoreCache,
            };
            // Get notifications.
            return site.read('message_popup_get_popup_notifications', data, preSets).then(function (response) {
                if (response.notifications) {
                    var result_1 = {
                        canLoadMore: response.notifications.length > limit
                    }, notifications_2 = response.notifications.slice(0, limit);
                    result_1.notifications = notifications_2;
                    return _this.formatNotificationsData(notifications_2).then(function () {
                        var first = notifications_2[0];
                        if (_this.appProvider.isDesktop() && toDisplay && offset === 0 && first && !first.read) {
                            // Store the last received notification. Don't block the user for this.
                            _this.emulatorHelper.storeLastReceivedNotification(AddonNotificationsProvider_1.PUSH_SIMULATION_COMPONENT, first, siteId);
                        }
                        return result_1;
                    });
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Get read notifications from site.
     *
     * @param {number} limitFrom Position of the first notification to get.
     * @param {number} limitNumber Number of notifications to get.
     * @param {boolean} [toDisplay=true] True if notifications will be displayed to the user, either in view or in a notification.
     * @param {boolean} [forceCache] True if it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved with notifications.
     */
    AddonNotificationsProvider.prototype.getReadNotifications = function (limitFrom, limitNumber, toDisplay, forceCache, ignoreCache, siteId) {
        if (toDisplay === void 0) { toDisplay = true; }
        return this.getNotifications(true, limitFrom, limitNumber, toDisplay, forceCache, ignoreCache, siteId);
    };
    /**
     * Get unread notifications from site.
     *
     * @param {number} limitFrom Position of the first notification to get.
     * @param {number} limitNumber Number of notifications to get.
     * @param {boolean} [toDisplay=true] True if notifications will be displayed to the user, either in view or in a notification.
     * @param {boolean} [forceCache] True if it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved with notifications.
     */
    AddonNotificationsProvider.prototype.getUnreadNotifications = function (limitFrom, limitNumber, toDisplay, forceCache, ignoreCache, siteId) {
        if (toDisplay === void 0) { toDisplay = true; }
        return this.getNotifications(false, limitFrom, limitNumber, toDisplay, forceCache, ignoreCache, siteId);
    };
    /**
     * Get unread notifications count. Do not cache calls.
     *
     * @param {number} [userId] The user id who received the notification. If not defined, use current user.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<number>} Promise resolved with the message notifications count.
     */
    AddonNotificationsProvider.prototype.getUnreadNotificationsCount = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // @since 3.2
            if (site.wsAvailable('message_popup_get_unread_popup_notification_count')) {
                userId = userId || site.getUserId();
                var params = {
                    useridto: userId
                };
                var preSets = {
                    getFromCache: false,
                    emergencyCache: false,
                    saveToCache: false,
                    typeExpected: 'number'
                };
                return site.read('message_popup_get_unread_popup_notification_count', params, preSets).catch(function () {
                    // Return no messages if the call fails.
                    return 0;
                });
            }
            // Fallback call.
            var limit = AddonNotificationsProvider_1.LIST_LIMIT + 1;
            return _this.getUnreadNotifications(0, limit, false, false, false, siteId).then(function (unread) {
                // Add + sign if there are more than the limit reachable.
                return (unread.length > AddonNotificationsProvider_1.LIST_LIMIT) ?
                    AddonNotificationsProvider_1.LIST_LIMIT + '+' : unread.length;
            }).catch(function () {
                // Return no messages if the call fails.
                return 0;
            });
        });
    };
    /**
     * Returns whether or not popup WS is available for a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if available, resolved with false or rejected otherwise.
     */
    AddonNotificationsProvider.prototype.isPopupAvailable = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('message_popup_get_popup_notifications');
        });
    };
    /**
     * Mark all message notification as read.
     *
     * @returns {Promise<any>} Resolved when done.
     * @since 3.2
     */
    AddonNotificationsProvider.prototype.markAllNotificationsAsRead = function () {
        var params = {
            useridto: this.sitesProvider.getCurrentSiteUserId()
        };
        return this.sitesProvider.getCurrentSite().write('core_message_mark_all_notifications_as_read', params);
    };
    /**
     * Mark a single notification as read.
     *
     * @param {number} notificationId ID of notification to mark as read
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @returns {Promise<any>} Resolved when done.
     * @since 3.5
     */
    AddonNotificationsProvider.prototype.markNotificationRead = function (notificationId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (site.wsAvailable('core_message_mark_notification_read')) {
                var params = {
                    notificationid: notificationId,
                    timeread: _this.timeUtils.timestamp()
                };
                return site.write('core_message_mark_notification_read', params);
            }
            else {
                // Fallback for versions prior to 3.5.
                return _this.messageProvider.markMessageRead(notificationId, site.id);
            }
        });
    };
    /**
     * Invalidate get notification preferences.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data is invalidated.
     */
    AddonNotificationsProvider.prototype.invalidateNotificationPreferences = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getNotificationPreferencesCacheKey());
        });
    };
    /**
     * Invalidates notifications list WS calls.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the list is invalidated.
     */
    AddonNotificationsProvider.prototype.invalidateNotificationsList = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getNotificationsCacheKey());
        });
    };
    /**
     * Returns whether or not we can mark all notifications as read.
     *
     * @return {boolean} True if enabled, false otherwise.
     * @since 3.2
     */
    AddonNotificationsProvider.prototype.isMarkAllNotificationsAsReadEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_message_mark_all_notifications_as_read');
    };
    /**
     * Returns whether or not we can count unread notifications precisely.
     *
     * @return {boolean} True if enabled, false otherwise.
     * @since 3.2
     */
    AddonNotificationsProvider.prototype.isPreciseNotificationCountEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('message_popup_get_unread_popup_notification_count');
    };
    /**
     * Returns whether or not the notification preferences are enabled for the current site.
     *
     * @return {boolean} True if enabled, false otherwise.
     * @since 3.2
     */
    AddonNotificationsProvider.prototype.isNotificationPreferencesEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_message_get_user_notification_preferences');
    };
    AddonNotificationsProvider.READ_CHANGED_EVENT = 'addon_notifications_read_changed_event';
    AddonNotificationsProvider.READ_CRON_EVENT = 'addon_notifications_read_cron_event';
    AddonNotificationsProvider.PUSH_SIMULATION_COMPONENT = 'AddonNotificationsPushSimulation';
    AddonNotificationsProvider.LIST_LIMIT = 20;
    AddonNotificationsProvider = AddonNotificationsProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_emulator_providers_helper__["a" /* CoreEmulatorHelperProvider */], __WEBPACK_IMPORTED_MODULE_8__addon_messages_providers_messages__["a" /* AddonMessagesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonNotificationsProvider);
    return AddonNotificationsProvider;
    var AddonNotificationsProvider_1;
}());

//# sourceMappingURL=notifications.js.map

/***/ }),
/* 171 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__addon_mod_forum_providers_forum__ = __webpack_require__(100);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service that provides some features regarding site home.
 */
var CoreSiteHomeProvider = /** @class */ (function () {
    function CoreSiteHomeProvider(logger, sitesProvider, courseProvider, forumProvider) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.forumProvider = forumProvider;
        this.logger = logger.getInstance('CoreSiteHomeProvider');
    }
    /**
     * Get the news forum for the Site Home.
     *
     * @param {number} siteHomeId Site Home ID.
     * @return {Promise<any>} Promise resolved with the forum if found, rejected otherwise.
     */
    CoreSiteHomeProvider.prototype.getNewsForum = function (siteHomeId) {
        return this.forumProvider.getCourseForums(siteHomeId).then(function (forums) {
            for (var i = 0; i < forums.length; i++) {
                if (forums[i].type == 'news') {
                    return forums[i];
                }
            }
            return Promise.reject(null);
        });
    };
    /**
     * Invalidate the WS call to get the news forum for the Site Home.
     *
     * @param {number} siteHomeId Site Home ID.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    CoreSiteHomeProvider.prototype.invalidateNewsForum = function (siteHomeId) {
        return this.forumProvider.invalidateForumData(siteHomeId);
    };
    /**
     * Returns whether or not the frontpage is available for the current site.
     *
     * @param {string} [siteId] The site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it's available.
     */
    CoreSiteHomeProvider.prototype.isAvailable = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // First check if it's disabled.
            if (_this.isDisabledInSite(site)) {
                return false;
            }
            // Use a WS call to check if there's content in the site home.
            var siteHomeId = site.getSiteHomeId(), preSets = { emergencyCache: false };
            _this.logger.debug('Using WS call to check if site home is available.');
            return _this.courseProvider.getSections(siteHomeId, false, true, preSets, site.id).then(function (sections) {
                if (!sections || !sections.length) {
                    return Promise.reject(null);
                }
                for (var i = 0; i < sections.length; i++) {
                    var section = sections[i];
                    if (section.summary || (section.modules && section.modules.length)) {
                        // It has content, return true.
                        return true;
                    }
                }
                return Promise.reject(null);
            }).catch(function () {
                var config = site.getStoredConfig();
                if (config && config.frontpageloggedin) {
                    var items = config.frontpageloggedin.split(',');
                    if (items.length > 0) {
                        // It's enabled.
                        return true;
                    }
                }
                return false;
            });
        }).catch(function () {
            return false;
        });
    };
    /**
     * Check if Site Home is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreSiteHomeProvider.prototype.isDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isDisabledInSite(site);
        });
    };
    /**
     * Check if Site Home is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreSiteHomeProvider.prototype.isDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreMainMenuDelegate_CoreSiteHome');
    };
    CoreSiteHomeProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_4__addon_mod_forum_providers_forum__["a" /* AddonModForumProvider */]])
    ], CoreSiteHomeProvider);
    return CoreSiteHomeProvider;
}());

//# sourceMappingURL=sitehome.js.map

/***/ }),
/* 172 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPageProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Service that provides some features for page.
 */
var AddonModPageProvider = /** @class */ (function () {
    function AddonModPageProvider(logger, sitesProvider, courseProvider, utils, filepoolProvider, logHelper) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.utils = utils;
        this.filepoolProvider = filepoolProvider;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModPage:';
        this.logger = logger.getInstance('AddonModPageProvider');
    }
    AddonModPageProvider_1 = AddonModPageProvider;
    /**
     * Get a page by course module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId     Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the book is retrieved.
     */
    AddonModPageProvider.prototype.getPageData = function (courseId, cmId, siteId) {
        return this.getPageByKey(courseId, 'coursemodule', cmId, siteId);
    };
    /**
     * Get a page.
     *
     * @param {number} courseId  Course ID.
     * @param {string} key       Name of the property to check.
     * @param {any}  value     Value to search.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}          Promise resolved when the book is retrieved.
     */
    AddonModPageProvider.prototype.getPageByKey = function (courseId, key, value, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getPageCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_page_get_pages_by_courses', params, preSets).then(function (response) {
                if (response && response.pages) {
                    var currentPage = response.pages.find(function (page) {
                        return page[key] == value;
                    });
                    if (currentPage) {
                        return currentPage;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for page data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonModPageProvider.prototype.getPageCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'page:' + courseId;
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}
     */
    AddonModPageProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var promises = [];
        promises.push(this.invalidatePageData(courseId, siteId));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModPageProvider_1.COMPONENT, moduleId));
        promises.push(this.courseProvider.invalidateModule(moduleId, siteId));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates page data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the data is invalidated.
     */
    AddonModPageProvider.prototype.invalidatePageData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getPageCacheKey(courseId));
        });
    };
    /**
     * Returns whether or not getPage WS available or not.
     *
     * @return {boolean} If WS is avalaible.
     * @since 3.3
     */
    AddonModPageProvider.prototype.isGetPageWSAvailable = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('mod_page_get_pages_by_courses');
    };
    /**
     * Return whether or not the plugin is enabled.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonModPageProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.canDownloadFiles();
        });
    };
    /**
     * Report a page as being viewed.
     *
     * @param {number} id Module ID.
     * @param {string} [name] Name of the page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModPageProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            pageid: id
        };
        return this.logHelper.logSingle('mod_page_view_page', params, AddonModPageProvider_1.COMPONENT, id, name, 'page', {}, siteId);
    };
    AddonModPageProvider.COMPONENT = 'mmaModPage';
    AddonModPageProvider = AddonModPageProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModPageProvider);
    return AddonModPageProvider;
    var AddonModPageProvider_1;
}());

//# sourceMappingURL=page.js.map

/***/ }),
/* 173 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__wiki_offline__ = __webpack_require__(228);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Service that provides some features for wikis.
 */
var AddonModWikiProvider = /** @class */ (function () {
    function AddonModWikiProvider(logger, sitesProvider, appProvider, filepoolProvider, utils, translate, wikiOffline, eventsProvider, logHelper) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.filepoolProvider = filepoolProvider;
        this.utils = utils;
        this.translate = translate;
        this.wikiOffline = wikiOffline;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModWiki:';
        this.subwikiListsCache = {};
        this.logger = logger.getInstance('AddonModWikiProvider');
        // Clear subwiki lists cache on logout.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGIN, function () {
            _this.clearSubwikiList();
        });
    }
    AddonModWikiProvider_1 = AddonModWikiProvider;
    /**
     * Clear subwiki list cache for a certain wiki or all of them.
     *
     * @param {number} [wikiId] wiki Id, if not provided all will be cleared.
     */
    AddonModWikiProvider.prototype.clearSubwikiList = function (wikiId) {
        if (typeof wikiId == 'undefined') {
            this.subwikiListsCache = {};
        }
        else {
            delete this.subwikiListsCache[wikiId];
        }
    };
    /**
     * Save wiki contents on a page or section.
     *
     * @param {number} pageId Page ID.
     * @param {string} content content to be saved.
     * @param {string} [section] section to get.
     * @return {Promise<number>} Promise resolved with the page ID.
     */
    AddonModWikiProvider.prototype.editPage = function (pageId, content, section, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                pageid: pageId,
                content: content
            };
            if (section) {
                params.section = section;
            }
            return site.write('mod_wiki_edit_page', params).then(function (response) {
                return response.pageid || Promise.reject(null);
            });
        });
    };
    /**
     * Get a wiki page contents.
     *
     * @param {number} pageId Page ID.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the page data.
     */
    AddonModWikiProvider.prototype.getPageContents = function (pageId, offline, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                pageid: pageId
            }, preSets = {
                cacheKey: _this.getPageContentsCacheKey(pageId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_wiki_get_page_contents', params, preSets).then(function (response) {
                return response.page || Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for wiki Pages Contents WS calls.
     *
     * @param {number} pageId Wiki Page ID.
     * @return {string} Cache key.
     */
    AddonModWikiProvider.prototype.getPageContentsCacheKey = function (pageId) {
        return this.ROOT_CACHE_KEY + 'page:' + pageId;
    };
    /**
     * Get a wiki page contents for editing. It does not cache calls.
     *
     * @param {number} pageId Page ID.
     * @param {string} [section] Section to get.
     * @param {boolean} [lockOnly] Just renew lock and not return content.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with page contents.
     */
    AddonModWikiProvider.prototype.getPageForEditing = function (pageId, section, lockOnly, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                pageid: pageId
            };
            if (section) {
                params.section = section;
            }
            // This parameter requires Moodle 3.2. It saves network usage.
            if (lockOnly && site.isVersionGreaterEqualThan('3.2')) {
                params.lockonly = 1;
            }
            return site.write('mod_wiki_get_page_for_editing', params).then(function (response) {
                return response.pagesection || Promise.reject(null);
            });
        });
    };
    /**
     * Gets the list of files from a specific subwiki.
     *
     * @param {number} wikiId Wiki ID.
     * @param {number} [groupId] Group to get files from.
     * @param {number} [userId] User to get files from.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with subwiki files.
     */
    AddonModWikiProvider.prototype.getSubwikiFiles = function (wikiId, groupId, userId, offline, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            groupId = groupId || -1;
            userId = userId || 0;
            var params = {
                wikiid: wikiId,
                groupid: groupId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getSubwikiFilesCacheKey(wikiId, groupId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_wiki_get_subwiki_files', params, preSets).then(function (response) {
                return response.files || Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for wiki Subwiki Files WS calls.
     *
     * @param {number} wikiId Wiki ID.
     * @param {number} groupId Group ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModWikiProvider.prototype.getSubwikiFilesCacheKey = function (wikiId, groupId, userId) {
        return this.getSubwikiFilesCacheKeyPrefix(wikiId) + ':' + groupId + ':' + userId;
    };
    /**
     * Get cache key for all wiki Subwiki Files WS calls.
     *
     * @param {number} wikiId Wiki ID.
     * @return {string} Cache key.
     */
    AddonModWikiProvider.prototype.getSubwikiFilesCacheKeyPrefix = function (wikiId) {
        return this.ROOT_CACHE_KEY + 'subwikifiles:' + wikiId;
    };
    /**
     * Get a list of subwikis and related data for a certain wiki from the cache.
     *
     * @param {number} wikiId wiki Id
     * @return {AddonModWikiSubwikiListData} Subwiki list and related data.
     */
    AddonModWikiProvider.prototype.getSubwikiList = function (wikiId) {
        return this.subwikiListsCache[wikiId];
    };
    /**
     * Get the list of Pages of a SubWiki.
     *
     * @param {number} wikiId Wiki ID.
     * @param {number} [groupId] Group to get pages from.
     * @param {number} [userId] User to get pages from.
     * @param {string} [sortBy=title] The attribute to sort the returned list.
     * @param {string} [sortDirection=ASC] Direction to sort the returned list (ASC | DESC).
     * @param {boolean} [includeContent] Whether the pages have to include its content. Default: false.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with wiki subwiki pages.
     */
    AddonModWikiProvider.prototype.getSubwikiPages = function (wikiId, groupId, userId, sortBy, sortDirection, includeContent, offline, ignoreCache, siteId) {
        var _this = this;
        if (sortBy === void 0) { sortBy = 'title'; }
        if (sortDirection === void 0) { sortDirection = 'ASC'; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            groupId = groupId || -1;
            userId = userId || 0;
            sortBy = sortBy || 'title';
            sortDirection = sortDirection || 'ASC';
            includeContent = includeContent || false;
            var params = {
                wikiid: wikiId,
                groupid: groupId,
                userid: userId,
                options: {
                    sortby: sortBy,
                    sortdirection: sortDirection,
                    includecontent: includeContent ? 1 : 0
                }
            }, preSets = {
                cacheKey: _this.getSubwikiPagesCacheKey(wikiId, groupId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_wiki_get_subwiki_pages', params, preSets).then(function (response) {
                return response.pages || Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for wiki Subwiki Pages WS calls.
     *
     * @param {number} wikiId Wiki ID.
     * @param {number} groupId Group ID.
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonModWikiProvider.prototype.getSubwikiPagesCacheKey = function (wikiId, groupId, userId) {
        return this.getSubwikiPagesCacheKeyPrefix(wikiId) + ':' + groupId + ':' + userId;
    };
    /**
     * Get cache key for all wiki Subwiki Pages WS calls.
     *
     * @param {number} wikiId Wiki ID.
     * @return {string} Cache key.
     */
    AddonModWikiProvider.prototype.getSubwikiPagesCacheKeyPrefix = function (wikiId) {
        return this.ROOT_CACHE_KEY + 'subwikipages:' + wikiId;
    };
    /**
     * Get all the subwikis of a wiki.
     *
     * @param {number} wikiId Wiki ID.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with subwikis.
     */
    AddonModWikiProvider.prototype.getSubwikis = function (wikiId, offline, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                wikiid: wikiId
            }, preSets = {
                cacheKey: _this.getSubwikisCacheKey(wikiId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (offline) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_wiki_get_subwikis', params, preSets).then(function (response) {
                return response.subwikis || Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get wiki subWikis WS calls.
     *
     * @param {number} wikiId Wiki ID.
     * @return {string} Cache key.
     */
    AddonModWikiProvider.prototype.getSubwikisCacheKey = function (wikiId) {
        return this.ROOT_CACHE_KEY + 'subwikis:' + wikiId;
    };
    /**
     * Get a wiki by module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the wiki is retrieved.
     */
    AddonModWikiProvider.prototype.getWiki = function (courseId, cmId, forceCache, siteId) {
        return this.getWikiByField(courseId, 'coursemodule', cmId, forceCache, siteId);
    };
    /**
     * Get a wiki with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the wiki is retrieved.
     */
    AddonModWikiProvider.prototype.getWikiByField = function (courseId, key, value, forceCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getWikiDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_10__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_wiki_get_wikis_by_courses', params, preSets).then(function (response) {
                if (response.wikis) {
                    var currentWiki = response.wikis.find(function (wiki) {
                        return wiki[key] == value;
                    });
                    if (currentWiki) {
                        return currentWiki;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a wiki by wiki ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} id Wiki ID.
     * @param {boolean} [forceCache] Whether it should always return cached data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the wiki is retrieved.
     */
    AddonModWikiProvider.prototype.getWikiById = function (courseId, id, forceCache, siteId) {
        return this.getWikiByField(courseId, 'id', id, forceCache, siteId);
    };
    /**
     * Get cache key for wiki data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModWikiProvider.prototype.getWikiDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'wiki:' + courseId;
    };
    /**
     * Gets a list of files to download for a wiki, using a format similar to module.contents from get_course_contents.
     *
     * @param {any} wiki Wiki.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModWikiProvider.prototype.getWikiFileList = function (wiki, offline, ignoreCache, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var files = [];
        return this.getSubwikis(wiki.id, offline, ignoreCache, siteId).then(function (subwikis) {
            var promises = [];
            subwikis.forEach(function (subwiki) {
                promises.push(_this.getSubwikiFiles(subwiki.wikiid, subwiki.groupid, subwiki.userid, offline, ignoreCache, siteId)
                    .then(function (swFiles) {
                    files = files.concat(swFiles);
                }));
            });
            return Promise.all(promises).then(function () {
                return files;
            });
        });
    };
    /**
     * Gets a list of all pages for a Wiki.
     *
     * @param {any} wiki Wiki.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Page list.
     */
    AddonModWikiProvider.prototype.getWikiPageList = function (wiki, offline, ignoreCache, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var pages = [];
        return this.getSubwikis(wiki.id, offline, ignoreCache, siteId).then(function (subwikis) {
            var promises = [];
            subwikis.forEach(function (subwiki) {
                promises.push(_this.getSubwikiPages(subwiki.wikiid, subwiki.groupid, subwiki.userid, undefined, undefined, undefined, offline, ignoreCache, siteId).then(function (subwikiPages) {
                    pages = pages.concat(subwikiPages);
                }));
            });
            return Promise.all(promises).then(function () {
                return pages;
            });
        });
    };
    /**
     * Invalidate the prefetched content except files.
     * To invalidate files, use invalidateFiles.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWikiProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getWiki(courseId, moduleId, false, siteId).then(function (wiki) {
            var promises = [];
            promises.push(_this.invalidateWikiData(courseId, siteId));
            promises.push(_this.invalidateSubwikis(wiki.id, siteId));
            promises.push(_this.invalidateSubwikiPages(wiki.id, siteId));
            promises.push(_this.invalidateSubwikiFiles(wiki.id, siteId));
            return Promise.all(promises);
        });
    };
    /**
     * Invalidate the prefetched files.
     *
     * @param {number} moduleId The module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the files are invalidated.
     */
    AddonModWikiProvider.prototype.invalidateFiles = function (moduleId, siteId) {
        return this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModWikiProvider_1.COMPONENT, moduleId);
    };
    /**
     * Invalidates page content WS call for a certain page.
     *
     * @param {number} pageId Wiki Page ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModWikiProvider.prototype.invalidatePage = function (pageId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getPageContentsCacheKey(pageId));
        });
    };
    /**
     * Invalidates all the subwiki files WS calls for a certain wiki.
     *
     * @param {number} wikiId Wiki ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModWikiProvider.prototype.invalidateSubwikiFiles = function (wikiId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getSubwikiFilesCacheKeyPrefix(wikiId));
        });
    };
    /**
     * Invalidates all the subwiki pages WS calls for a certain wiki.
     *
     * @param {Number} wikiId Wiki ID.
     * @param  {String} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModWikiProvider.prototype.invalidateSubwikiPages = function (wikiId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getSubwikiPagesCacheKeyPrefix(wikiId));
        });
    };
    /**
     * Invalidates all the get subwikis WS calls for a certain wiki.
     *
     * @param {number} wikiId Wiki ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModWikiProvider.prototype.invalidateSubwikis = function (wikiId, siteId) {
        var _this = this;
        this.clearSubwikiList(wikiId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getSubwikisCacheKey(wikiId));
        });
    };
    /**
     * Invalidates wiki data.
     *
     * @param {Number} courseId Course ID.
     * @param  {String} [siteId] Site ID. If not defined, current site.
     * @return {Promise}        Promise resolved when the data is invalidated.
     */
    AddonModWikiProvider.prototype.invalidateWikiData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getWikiDataCacheKey(courseId));
        });
    };
    /**
     * Check if a page title is already used.
     *
     * @param {number} wikiId Wiki ID.
     * @param {number} subwikiId Subwiki ID.
     * @param {string} title Page title.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if used, resolved with false if not used or cannot determine.
     */
    AddonModWikiProvider.prototype.isTitleUsed = function (wikiId, subwikiId, title, offline, ignoreCache, siteId) {
        var _this = this;
        // First get the subwiki.
        return this.getSubwikis(wikiId, offline, ignoreCache, siteId).then(function (subwikis) {
            // Search the subwiki.
            var subwiki = subwikis.find(function (subwiki) {
                return subwiki.id == subwikiId;
            });
            return subwiki || Promise.reject(null);
        }).then(function (subwiki) {
            // Now get all the pages of the subwiki.
            return _this.getSubwikiPages(wikiId, subwiki.groupid, subwiki.userid, undefined, undefined, false, offline, ignoreCache, siteId);
        }).then(function (pages) {
            // Check if there's any page with the same title.
            var page = pages.find(function (page) {
                return page.title == title;
            });
            return !!page;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Report a wiki page as being viewed.
     *
     * @param {number} id Page ID.
     * @param {number} wikiId Wiki ID.
     * @param {string} [name] Name of the wiki.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModWikiProvider.prototype.logPageView = function (id, wikiId, name, siteId) {
        var params = {
            pageid: id
        };
        return this.logHelper.logSingle('mod_wiki_view_page', params, AddonModWikiProvider_1.COMPONENT, wikiId, name, 'wiki', params, siteId);
    };
    /**
     * Report the wiki as being viewed.
     *
     * @param {number} id Wiki ID.
     * @param {string} [name] Name of the wiki.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModWikiProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            wikiid: id
        };
        return this.logHelper.logSingle('mod_wiki_view_wiki', params, AddonModWikiProvider_1.COMPONENT, id, name, 'wiki', {}, siteId);
    };
    /**
     * Create a new page on a subwiki.
     *
     * @param {string} title Title to create the page.
     * @param {string} content Content to save on the page.
     * @param {number} [subwikiId] Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used to create a new subwiki if subwikiId not supplied.
     * @param {number} [userId] User ID. Optional, will be used to create a new subwiki if subwikiId not supplied.
     * @param {number} [groupId] Group ID. Optional, will be used to create a new subwiki if subwikiId not supplied.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with page ID if page was created in server, -1 if stored in device.
     */
    AddonModWikiProvider.prototype.newPage = function (title, content, subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a new page to be synchronized later.
        var storeOffline = function () {
            var promise;
            if (wikiId) {
                // We have wiki ID, check if there's already an online page with this title and subwiki.
                promise = _this.isTitleUsed(wikiId, subwikiId, title, true, false, siteId).catch(function () {
                    // Error, assume not used.
                    return false;
                }).then(function (used) {
                    if (used) {
                        return Promise.reject(_this.translate.instant('addon.mod_wiki.pageexists'));
                    }
                });
            }
            else {
                promise = Promise.resolve();
            }
            return promise.then(function () {
                return _this.wikiOffline.saveNewPage(title, content, subwikiId, wikiId, userId, groupId, siteId).then(function () {
                    return -1;
                });
            });
        };
        if (!this.appProvider.isOnline()) {
            // App is offline, store the action.
            return storeOffline();
        }
        // Discard stored content for this page. If it exists it means the user is editing it.
        return this.wikiOffline.deleteNewPage(title, subwikiId, wikiId, userId, groupId, siteId).then(function () {
            // Try to create it in online.
            return _this.newPageOnline(title, content, subwikiId, wikiId, userId, groupId, siteId).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that the page cannot be added.
                    return Promise.reject(error);
                }
                else {
                    // Couldn't connect to server, store in offline.
                    return storeOffline();
                }
            });
        });
    };
    /**
     * Create a new page on a subwiki. It will fail if offline or cannot connect.
     *
     * @param {string} title Title to create the page.
     * @param {string} content Content to save on the page.
     * @param {number} [subwikiId] Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used create subwiki if not informed.
     * @param {number} [userId] User ID. Optional, will be used create subwiki if not informed.
     * @param {number} [groupId] Group ID. Optional, will be used create subwiki if not informed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the page ID if created, rejected otherwise.
     */
    AddonModWikiProvider.prototype.newPageOnline = function (title, content, subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                title: title,
                content: content,
                contentformat: 'html'
            };
            subwikiId = _this.wikiOffline.convertToPositiveNumber(subwikiId);
            wikiId = _this.wikiOffline.convertToPositiveNumber(wikiId);
            if (subwikiId && subwikiId > 0) {
                params.subwikiid = subwikiId;
            }
            else if (wikiId) {
                params.wikiid = wikiId;
                params.userid = _this.wikiOffline.convertToPositiveNumber(userId);
                params.groupid = _this.wikiOffline.convertToPositiveNumber(groupId);
            }
            return site.write('mod_wiki_new_page', params).then(function (response) {
                return response.pageid || Promise.reject(null);
            });
        });
    };
    /**
     * Save subwiki list for a wiki to the cache.
     *
     * @param {number} wikiId Wiki Id.
     * @param {any[]} subwikis List of subwikis.
     * @param {number} count Number of subwikis in the subwikis list.
     * @param {number} subwikiId Subwiki Id currently selected.
     * @param {number} userId User Id currently selected.
     * @param {number} groupId Group Id currently selected.
     */
    AddonModWikiProvider.prototype.setSubwikiList = function (wikiId, subwikis, count, subwikiId, userId, groupId) {
        this.subwikiListsCache[wikiId] = {
            count: count,
            subwikiSelected: subwikiId,
            userSelected: userId,
            groupSelected: groupId,
            subwikis: subwikis
        };
    };
    /**
     * Sort an array of wiki pages by title.
     *
     * @param {any[]} pages Pages to sort.
     * @param {boolean} [desc] True to sort in descendent order, false to sort in ascendent order. Defaults to false.
     * @return {any[]} Sorted pages.
     */
    AddonModWikiProvider.prototype.sortPagesByTitle = function (pages, desc) {
        return pages.sort(function (a, b) {
            var result = a.title >= b.title ? 1 : -1;
            if (desc) {
                result = -result;
            }
            return result;
        });
    };
    /**
     * Check if a wiki has a certain subwiki.
     *
     * @param {number} wikiId Wiki ID.
     * @param {number} subwikiId Subwiki ID to search.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if it has subwiki, resolved with false otherwise.
     */
    AddonModWikiProvider.prototype.wikiHasSubwiki = function (wikiId, subwikiId, offline, ignoreCache, siteId) {
        // Get the subwikis to check if any of them matches the one passed as param.
        return this.getSubwikis(wikiId, offline, ignoreCache, siteId).then(function (subwikis) {
            var subwiki = subwikis.find(function (subwiki) {
                return subwiki.id == subwikiId;
            });
            return !!subwiki;
        }).catch(function () {
            // Not found, return false.
            return false;
        });
    };
    AddonModWikiProvider.COMPONENT = 'mmaModWiki';
    AddonModWikiProvider.PAGE_CREATED_EVENT = 'addon_mod_wiki_page_created';
    AddonModWikiProvider.RENEW_LOCK_TIME = 30000; // Milliseconds.
    AddonModWikiProvider = AddonModWikiProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_9__wiki_offline__["a" /* AddonModWikiOfflineProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModWikiProvider);
    return AddonModWikiProvider;
    var AddonModWikiProvider_1;
}());

//# sourceMappingURL=wiki.js.map

/***/ }),
/* 174 */,
/* 175 */,
/* 176 */,
/* 177 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CorePluginFileDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__logger__ = __webpack_require__(6);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Delegate to register pluginfile information handlers.
 */
var CorePluginFileDelegate = /** @class */ (function () {
    function CorePluginFileDelegate(logger) {
        this.handlers = {};
        this.logger = logger.getInstance('CorePluginFileDelegate');
    }
    /**
     * Get the handler for a certain pluginfile url.
     *
     * @param {string} component Component of the plugin.
     * @return {CorePluginFileHandler} Handler. Undefined if no handler found for the plugin.
     */
    CorePluginFileDelegate.prototype.getPluginHandler = function (component) {
        if (typeof this.handlers[component] != 'undefined') {
            return this.handlers[component];
        }
    };
    /**
     * Get the RegExp of the component and filearea described in the URL.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {RegExp}  RegExp to match the revision or undefined if not found.
     */
    CorePluginFileDelegate.prototype.getComponentRevisionRegExp = function (args) {
        // Get handler based on component (args[1]).
        var handler = this.getPluginHandler(args[1]);
        if (handler && handler.getComponentRevisionRegExp) {
            return handler.getComponentRevisionRegExp(args);
        }
    };
    /**
     * Register a handler.
     *
     * @param {CorePluginFileHandler} handler The handler to register.
     * @return {boolean} True if registered successfully, false otherwise.
     */
    CorePluginFileDelegate.prototype.registerHandler = function (handler) {
        if (typeof this.handlers[handler.component] !== 'undefined') {
            this.logger.log("Handler '" + handler.component + "' already registered");
            return false;
        }
        this.logger.log("Registered handler '" + handler.component + "'");
        this.handlers[handler.component] = handler;
        return true;
    };
    /**
     * Removes the revision number from a file URL.
     *
     * @param {string} url URL to be replaced.
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {string} Replaced URL without revision.
     */
    CorePluginFileDelegate.prototype.removeRevisionFromUrl = function (url, args) {
        // Get handler based on component (args[1]).
        var handler = this.getPluginHandler(args[1]);
        if (handler && handler.getComponentRevisionRegExp && handler.getComponentRevisionReplace) {
            var revisionRegex = handler.getComponentRevisionRegExp(args);
            if (revisionRegex) {
                return url.replace(revisionRegex, handler.getComponentRevisionReplace(args));
            }
        }
        return url;
    };
    CorePluginFileDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__logger__["a" /* CoreLoggerProvider */]])
    ], CorePluginFileDelegate);
    return CorePluginFileDelegate;
}());

//# sourceMappingURL=plugin-file-delegate.js.map

/***/ }),
/* 178 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseActivitySyncBaseProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__classes_base_sync__ = __webpack_require__(89);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Base class to create activity sync providers. It provides some common functions.
 */
var CoreCourseActivitySyncBaseProvider = /** @class */ (function (_super) {
    __extends(CoreCourseActivitySyncBaseProvider, _super);
    function CoreCourseActivitySyncBaseProvider(component, loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils, prefetchDelegate, prefetchHandler) {
        var _this = _super.call(this, component, loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.sitesProvider = sitesProvider;
        _this.appProvider = appProvider;
        _this.syncProvider = syncProvider;
        _this.textUtils = textUtils;
        _this.translate = translate;
        _this.timeUtils = timeUtils;
        _this.prefetchDelegate = prefetchDelegate;
        _this.prefetchHandler = prefetchHandler;
        return _this;
    }
    /**
     * Conveniece function to prefetch data after an update.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID.
     * @param {RegExp} [regex] If regex matches, don't download the data. Defaults to check files.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseActivitySyncBaseProvider.prototype.prefetchAfterUpdate = function (module, courseId, regex, siteId) {
        var _this = this;
        regex = regex || /^.*files$/;
        // Get the module updates to check if the data was updated or not.
        return this.prefetchDelegate.getModuleUpdates(module, courseId, true, siteId).then(function (result) {
            if (result && result.updates && result.updates.length > 0) {
                // Only prefetch if files haven't changed.
                var shouldDownload = !result.updates.find(function (entry) {
                    return entry.name.match(regex);
                });
                if (shouldDownload) {
                    return _this.prefetchHandler.download(module, courseId);
                }
            }
        });
    };
    return CoreCourseActivitySyncBaseProvider;
}(__WEBPACK_IMPORTED_MODULE_0__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=activity-sync.js.map

/***/ }),
/* 179 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__addon_coursecompletion_providers_coursecompletion__ = __webpack_require__(146);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Helper to gather some common courses functions.
 */
var CoreCoursesHelperProvider = /** @class */ (function () {
    function CoreCoursesHelperProvider(coursesProvider, utils, courseCompletionProvider) {
        this.coursesProvider = coursesProvider;
        this.utils = utils;
        this.courseCompletionProvider = courseCompletionProvider;
    }
    /**
     * Given a course object returned by core_enrol_get_users_courses and another one returned by core_course_get_courses_by_field,
     * load some extra data to the first one.
     *
     * @param {any} course Course returned by core_enrol_get_users_courses.
     * @param {any} courseByField Course returned by core_course_get_courses_by_field.
     */
    CoreCoursesHelperProvider.prototype.loadCourseExtraInfo = function (course, courseByField) {
        if (courseByField) {
            course.displayname = courseByField.displayname;
            if (courseByField.overviewfiles && courseByField.overviewfiles[0]) {
                course.courseImage = courseByField.overviewfiles[0].fileurl;
            }
            else {
                course.courseImage = false;
            }
        }
        else {
            delete course.displayname;
            course.courseImage = false;
        }
    };
    /**
     * Given a list of courses returned by core_enrol_get_users_courses, load some extra data using the WebService
     * core_course_get_courses_by_field if available.
     *
     * @param {any[]} courses List of courses.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCoursesHelperProvider.prototype.loadCoursesExtraInfo = function (courses) {
        var _this = this;
        if (courses[0] && typeof courses[0].overviewfiles != 'undefined' && typeof courses[0].displayname != 'undefined') {
            // We already have the extra data. Call loadCourseExtraInfo to load the calculated fields.
            courses.forEach(function (course) {
                _this.loadCourseExtraInfo(course, course);
            });
            return Promise.resolve();
        }
        if (!courses.length || !this.coursesProvider.isGetCoursesByFieldAvailable()) {
            // No courses or cannot get the data, stop.
            return Promise.resolve();
        }
        var courseIds = courses.map(function (course) {
            return course.id;
        }).join(',');
        // Get the extra data for the courses.
        return this.coursesProvider.getCoursesByField('ids', courseIds).then(function (coursesInfo) {
            coursesInfo = _this.utils.arrayToObject(coursesInfo, 'id');
            courses.forEach(function (course) {
                _this.loadCourseExtraInfo(course, coursesInfo[course.id]);
            });
        });
    };
    /**
     * Get user courses with admin and nav options.
     *
     * @param  {string}  [sort=fullname] Sort courses after get them. If sort is not defined it won't be sorted.
     * @param  {number}  [slice=0]    Slice results to get the X first one. If slice > 0 it will be done after sorting.
     * @param  {string}  [filter]    Filter using some field.
     * @return {Promise<any[]>} Courses filled with options.
     */
    CoreCoursesHelperProvider.prototype.getUserCoursesWithOptions = function (sort, slice, filter) {
        var _this = this;
        if (sort === void 0) { sort = 'fullname'; }
        if (slice === void 0) { slice = 0; }
        return this.coursesProvider.getUserCourses().then(function (courses) {
            var promises = [], courseIds = courses.map(function (course) {
                return course.id;
            });
            if (_this.coursesProvider.canGetAdminAndNavOptions()) {
                // Load course options of the course.
                promises.push(_this.coursesProvider.getCoursesAdminAndNavOptions(courseIds).then(function (options) {
                    courses.forEach(function (course) {
                        course.navOptions = options.navOptions[course.id];
                        course.admOptions = options.admOptions[course.id];
                    });
                }));
            }
            promises.push(_this.loadCoursesExtraInfo(courses));
            return Promise.all(promises).then(function () {
                if (courses.length <= 0) {
                    return [];
                }
                switch (filter) {
                    case 'isfavourite':
                        courses = courses.filter(function (course) {
                            return !!course.isfavourite;
                        });
                        break;
                    default:
                }
                switch (sort) {
                    case 'fullname':
                        courses.sort(function (a, b) {
                            var compareA = a.fullname.toLowerCase(), compareB = b.fullname.toLowerCase();
                            return compareA.localeCompare(compareB);
                        });
                        break;
                    case 'lastaccess':
                        courses.sort(function (a, b) {
                            return b.lastaccess - a.lastaccess;
                        });
                        break;
                    case 'timemodified':
                        courses.sort(function (a, b) {
                            return b.timemodified - a.timemodified;
                        });
                        break;
                    default:
                }
                courses = slice > 0 ? courses.slice(0, slice) : courses;
                // Fetch course completion status if needed.
                return Promise.all(courses.map(function (course) {
                    if (typeof course.completed != 'undefined') {
                        // The WebService already returns the completed status, no need to fetch it.
                        return Promise.resolve(course);
                    }
                    if (typeof course.enablecompletion != 'undefined' && course.enablecompletion == 0) {
                        // Completion is disabled for this course, there is no need to fetch the completion status.
                        return Promise.resolve(course);
                    }
                    return _this.courseCompletionProvider.getCompletion(course.id).catch(function () {
                        // Ignore error, maybe course completion is disabled or user has no permission.
                    }).then(function (completion) {
                        course.completed = completion && completion.completed;
                        return course;
                    });
                }));
            });
        });
    };
    CoreCoursesHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__addon_coursecompletion_providers_coursecompletion__["a" /* AddonCourseCompletionProvider */]])
    ], CoreCoursesHelperProvider);
    return CoreCoursesHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 180 */,
/* 181 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Service that provides some features for resources.
 */
var AddonModResourceProvider = /** @class */ (function () {
    function AddonModResourceProvider(logger, sitesProvider, courseProvider, filepoolProvider, utils, logHelper) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.filepoolProvider = filepoolProvider;
        this.utils = utils;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModResource:';
        this.logger = logger.getInstance('AddonModResourceProvider');
    }
    AddonModResourceProvider_1 = AddonModResourceProvider;
    /**
     * Get cache key for resource data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonModResourceProvider.prototype.getResourceCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'resource:' + courseId;
    };
    /**
     * Get a resource data.
     *
     * @param {number} courseId Course ID.
     * @param {string} key     Name of the property to check.
     * @param {any}  value   Value to search.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the resource is retrieved.
     */
    AddonModResourceProvider.prototype.getResourceDataByKey = function (courseId, key, value, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getResourceCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_resource_get_resources_by_courses', params, preSets).then(function (response) {
                if (response && response.resources) {
                    var currentResource = response.resources.find(function (resource) {
                        return resource[key] == value;
                    });
                    if (currentResource) {
                        return currentResource;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a resource by course module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId     Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the resource is retrieved.
     */
    AddonModResourceProvider.prototype.getResourceData = function (courseId, cmId, siteId) {
        return this.getResourceDataByKey(courseId, 'coursemodule', cmId, siteId);
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModResourceProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.invalidateResourceData(courseId, siteId));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModResourceProvider_1.COMPONENT, moduleId));
        promises.push(this.courseProvider.invalidateModule(moduleId, siteId, 'resource'));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates resource data.
     *
     * @param {number} courseid Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the data is invalidated.
     */
    AddonModResourceProvider.prototype.invalidateResourceData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getResourceCacheKey(courseId));
        });
    };
    /**
     * Returns whether or not getResource WS available or not.
     *
     * @return {boolean} If WS is abalaible.
     * @since 3.3
     */
    AddonModResourceProvider.prototype.isGetResourceWSAvailable = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('mod_resource_get_resources_by_courses');
    };
    /**
     * Return whether or not the plugin is enabled.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonModResourceProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.canDownloadFiles();
        });
    };
    /**
     * Report the resource as being viewed.
     *
     * @param {number} id Module ID.
     * @param {string} [name] Name of the resource.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModResourceProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            resourceid: id
        };
        return this.logHelper.logSingle('mod_resource_view_resource', params, AddonModResourceProvider_1.COMPONENT, id, name, 'resource', {}, siteId);
    };
    AddonModResourceProvider.COMPONENT = 'mmaModResource';
    AddonModResourceProvider = AddonModResourceProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModResourceProvider);
    return AddonModResourceProvider;
    var AddonModResourceProvider_1;
}());

//# sourceMappingURL=resource.js.map

/***/ }),
/* 182 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__course_progress_course_progress__ = __webpack_require__(1523);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__course_list_item_course_list_item__ = __webpack_require__(1524);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__course_options_menu_course_options_menu__ = __webpack_require__(821);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__my_courses_my_courses__ = __webpack_require__(982);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};











var CoreCoursesComponentsModule = /** @class */ (function () {
    function CoreCoursesComponentsModule() {
    }
    CoreCoursesComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__course_progress_course_progress__["a" /* CoreCoursesCourseProgressComponent */],
                __WEBPACK_IMPORTED_MODULE_8__course_list_item_course_list_item__["a" /* CoreCoursesCourseListItemComponent */],
                __WEBPACK_IMPORTED_MODULE_9__course_options_menu_course_options_menu__["a" /* CoreCoursesCourseOptionsMenuComponent */],
                __WEBPACK_IMPORTED_MODULE_10__my_courses_my_courses__["a" /* CoreCoursesMyCoursesComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__course_progress_course_progress__["a" /* CoreCoursesCourseProgressComponent */],
                __WEBPACK_IMPORTED_MODULE_8__course_list_item_course_list_item__["a" /* CoreCoursesCourseListItemComponent */],
                __WEBPACK_IMPORTED_MODULE_9__course_options_menu_course_options_menu__["a" /* CoreCoursesCourseOptionsMenuComponent */],
                __WEBPACK_IMPORTED_MODULE_10__my_courses_my_courses__["a" /* CoreCoursesMyCoursesComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_9__course_options_menu_course_options_menu__["a" /* CoreCoursesCourseOptionsMenuComponent */]
            ]
        })
    ], CoreCoursesComponentsModule);
    return CoreCoursesComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 183 */,
/* 184 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Service that provides helper functions for feedbacks.
 */
var AddonModFeedbackHelperProvider = /** @class */ (function () {
    function AddonModFeedbackHelperProvider(feedbackProvider, userProvider, textUtils, translate, timeUtils, domUtils, courseProvider, linkHelper, sitesProvider, utils) {
        this.feedbackProvider = feedbackProvider;
        this.userProvider = userProvider;
        this.textUtils = textUtils;
        this.translate = translate;
        this.timeUtils = timeUtils;
        this.domUtils = domUtils;
        this.courseProvider = courseProvider;
        this.linkHelper = linkHelper;
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.MODE_RESPONSETIME = 1;
        this.MODE_COURSE = 2;
        this.MODE_CATEGORY = 3;
    }
    /**
     * Check if the page we are going to open is in the history and returns the view controller in the stack to go back.
     *
     * @param {string} pageName       Name of the page we want to navigate.
     * @param {number} instance       Activity instance Id. I.e FeedbackId.
     * @param {string} paramName      Param name where to find the instance number.
     * @param {string} prefix         Prefix to check if we are out of the activity context.
     * @param {NavController} navCtrl Nav Controller of the view.
     * @return {ViewController}   Returns view controller found or null.
     */
    AddonModFeedbackHelperProvider.prototype.getPageView = function (pageName, instance, paramName, prefix, navCtrl) {
        var historyInstance, params, view = navCtrl.getActive();
        while (!view.isFirst()) {
            if (!view.name.startsWith(prefix)) {
                break;
            }
            params = view.getNavParams();
            historyInstance = params.get(paramName) ? params.get(paramName) : params.get('module').instance;
            // Check we are not changing to another activity.
            if (!historyInstance || historyInstance != instance) {
                break;
            }
            // Page found.
            if (view.name == pageName) {
                return view;
            }
            view = navCtrl.getPrevious(view);
        }
        return null;
    };
    /**
     * Retrieves a list of students who didn't submit the feedback with extra info.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    groupId         Group id, 0 means that the function will determine the user group.
     * @param   {number}    page            The page of records to return.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackHelperProvider.prototype.getNonRespondents = function (feedbackId, groupId, page) {
        var _this = this;
        return this.feedbackProvider.getNonRespondents(feedbackId, groupId, page).then(function (responses) {
            return _this.addImageProfileToAttempts(responses.users).then(function (users) {
                responses.users = users;
                return responses;
            });
        });
    };
    /**
     * Get page items responses to be sent.
     *
     * @param   {any[]} items    Items where the values are.
     * @return  {any}            Responses object to be sent.
     */
    AddonModFeedbackHelperProvider.prototype.getPageItemsResponses = function (items) {
        var responses = {};
        items.forEach(function (itemData) {
            var answered = false;
            itemData.hasError = false;
            if (itemData.typ == 'captcha') {
                var value = itemData.value || '', name_1 = itemData.typ + '_' + itemData.id;
                answered = !!value;
                responses[name_1] = 1;
                responses['g-recaptcha-response'] = value;
                responses['recaptcha_element'] = 'dummyvalue';
                if (itemData.required && !answered) {
                    // Check if it has any value.
                    itemData.isEmpty = true;
                }
                else {
                    itemData.isEmpty = false;
                }
            }
            else if (itemData.hasvalue) {
                var name_2, value_1;
                var nameTemp_1 = itemData.typ + '_' + itemData.id;
                if (itemData.typ == 'multichoice' && itemData.subtype == 'c') {
                    name_2 = nameTemp_1 + '[0]';
                    responses[name_2] = 0;
                    itemData.choices.forEach(function (choice, index) {
                        name_2 = nameTemp_1 + '[' + (index + 1) + ']';
                        value_1 = choice.checked ? choice.value : 0;
                        if (!answered && value_1) {
                            answered = true;
                        }
                        responses[name_2] = value_1;
                    });
                }
                else {
                    if (itemData.typ == 'multichoice' && itemData.subtype != 'r') {
                        name_2 = nameTemp_1 + '[0]';
                    }
                    else {
                        name_2 = nameTemp_1;
                    }
                    if (itemData.typ == 'multichoice' || itemData.typ == 'multichoicerated') {
                        value_1 = itemData.value || 0;
                    }
                    else if (itemData.typ == 'numeric') {
                        value_1 = itemData.value || itemData.value == 0 ? itemData.value : '';
                        if (value_1 != '') {
                            if ((itemData.rangefrom != '' && value_1 < itemData.rangefrom) ||
                                (itemData.rangeto != '' && value_1 > itemData.rangeto)) {
                                itemData.hasError = true;
                            }
                        }
                    }
                    else {
                        value_1 = itemData.value || itemData.value == 0 ? itemData.value : '';
                    }
                    answered = !!value_1;
                    responses[name_2] = value_1;
                }
                if (itemData.required && !answered) {
                    // Check if it has any value.
                    itemData.isEmpty = true;
                }
                else {
                    itemData.isEmpty = false;
                }
            }
        });
        return responses;
    };
    /**
     * Returns the feedback user responses with extra info.
     *
     * @param   {number}    feedbackId      Feedback ID.
     * @param   {number}    groupId         Group id, 0 means that the function will determine the user group.
     * @param   {number}    page            The page of records to return.
     * @return  {Promise<any>}              Promise resolved when the info is retrieved.
     */
    AddonModFeedbackHelperProvider.prototype.getResponsesAnalysis = function (feedbackId, groupId, page) {
        var _this = this;
        return this.feedbackProvider.getResponsesAnalysis(feedbackId, groupId, page).then(function (responses) {
            return _this.addImageProfileToAttempts(responses.attempts).then(function (attempts) {
                responses.attempts = attempts;
                return responses;
            });
        });
    };
    /**
     * Handle a show entries link.
     *
     * @param {NavController} navCtrl Nav controller to use to navigate. Can be undefined/null.
     * @param {any} params URL params.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackHelperProvider.prototype.handleShowEntriesLink = function (navCtrl, params, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var modal = this.domUtils.showModalLoading(), moduleId = params.id;
        return this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
            var stateParams;
            if (typeof params.showcompleted == 'undefined') {
                // Param showcompleted not defined. Show entry list.
                stateParams = {
                    module: module,
                    courseId: module.course
                };
                return _this.linkHelper.goInSite(navCtrl, 'AddonModFeedbackRespondentsPage', stateParams, siteId);
            }
            return _this.feedbackProvider.getAttempt(module.instance, params.showcompleted, true, siteId).then(function (attempt) {
                stateParams = {
                    moduleId: module.id,
                    attempt: attempt,
                    feedbackId: module.instance,
                    courseId: module.course
                };
                return _this.linkHelper.goInSite(navCtrl, 'AddonModFeedbackAttemptPage', stateParams, siteId);
            });
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Add Image profile url field on attempts
     *
     * @param  {any}          attempts Attempts array to get profile from.
     * @return {Promise<any>}          Returns the same array with the profileimageurl added if found.
     */
    AddonModFeedbackHelperProvider.prototype.addImageProfileToAttempts = function (attempts) {
        var _this = this;
        var promises = attempts.map(function (attempt) {
            return _this.userProvider.getProfile(attempt.userid, attempt.courseid, true).then(function (user) {
                attempt.profileimageurl = user.profileimageurl;
            }).catch(function () {
                // Error getting profile, resolve promise without adding any extra data.
            });
        });
        return Promise.all(promises).then(function () {
            return attempts;
        });
    };
    /**
     * Helper function to open a feature in the app.
     *
     * @param {string}        feature   Name of the feature to open.
     * @param {NavController} navCtrl   NavController.
     * @param {any}           module    Course module activity object.
     * @param {number}        courseId  Course Id.
     * @param {number}        [group=0] Course module activity object.
     * @return {Promise<void>}    Resolved when navigation animation is done.
     */
    AddonModFeedbackHelperProvider.prototype.openFeature = function (feature, navCtrl, module, courseId, group) {
        if (group === void 0) { group = 0; }
        var pageName = feature && feature != 'analysis' ? 'AddonModFeedback' + feature + 'Page' : 'AddonModFeedbackIndexPage', stateParams = {
            module: module,
            moduleId: module.id,
            courseId: courseId,
            feedbackId: module.instance,
            group: group
        };
        // Only check history if navigating through tabs.
        if (pageName == 'AddonModFeedbackIndexPage') {
            stateParams['tab'] = feature == 'analysis' ? 'analysis' : 'overview';
            var view = this.getPageView(pageName, module.instance, 'feedbackId', 'AddonModFeedback', navCtrl);
            if (view) {
                // Go back to the found page.
                return navCtrl.popTo(view);
            }
        }
        // Not found, open new state.
        return navCtrl.push(pageName, stateParams);
    };
    /**
     * Helper funtion for item type Label.
     *
     * @param  {any} item Item to process.
     * @return {any}      Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemFormLabel = function (item) {
        item.template = 'label';
        item.name = '';
        item.presentation = this.textUtils.replacePluginfileUrls(item.presentation, item.itemfiles);
        return item;
    };
    /**
     * Helper funtion for item type Info.
     *
     * @param  {any} item Item to process.
     * @return {any}      Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemFormInfo = function (item) {
        item.template = 'label';
        var type = parseInt(item.presentation, 10);
        if (type == this.MODE_COURSE || type == this.MODE_CATEGORY) {
            item.presentation = item.otherdata;
            item.value = typeof item.rawValue != 'undefined' ? item.rawValue : item.otherdata;
        }
        else if (type == this.MODE_RESPONSETIME) {
            item.value = '__CURRENT__TIMESTAMP__';
            var tempValue = typeof item.rawValue != 'undefined' ? item.rawValue * 1000 : new Date().getTime();
            item.presentation = this.timeUtils.userDate(tempValue);
        }
        else {
            // Errors on item, return false.
            return false;
        }
        return item;
    };
    /**
     * Helper funtion for item type Numeric.
     *
     * @param  {any} item Item to process.
     * @return {any}      Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemFormNumeric = function (item) {
        item.template = 'numeric';
        var range = item.presentation.split(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].LINE_SEP) || [];
        range[0] = range.length > 0 ? parseInt(range[0], 10) : undefined;
        range[1] = range.length > 1 ? parseInt(range[1], 10) : undefined;
        item.rangefrom = typeof range[0] == 'number' && !isNaN(range[0]) ? range[0] : '';
        item.rangeto = typeof range[1] == 'number' && !isNaN(range[1]) ? range[1] : '';
        item.value = typeof item.rawValue != 'undefined' ? parseFloat(item.rawValue) : '';
        item.postfix = this.getNumericBoundariesForDisplay(item.rangefrom, item.rangeto);
        return item;
    };
    /**
     * Helper funtion for item type Text field.
     *
     * @param  {any} item Item to process.
     * @return {any}      Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemFormTextfield = function (item) {
        item.template = 'textfield';
        item.length = item.presentation.split(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].LINE_SEP)[1] || 255;
        item.value = typeof item.rawValue != 'undefined' ? item.rawValue : '';
        return item;
    };
    /**
     * Helper funtion for item type Textarea.
     *
     * @param  {any} item Item to process.
     * @return {any}      Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemFormTextarea = function (item) {
        item.template = 'textarea';
        item.value = typeof item.rawValue != 'undefined' ? item.rawValue : '';
        return item;
    };
    /**
     * Helper funtion for item type Multichoice.
     *
     * @param  {any} item Item to process.
     * @return {any}      Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemFormMultichoice = function (item) {
        var parts = item.presentation.split(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].MULTICHOICE_TYPE_SEP) || [];
        item.subtype = parts.length > 0 && parts[0] ? parts[0] : 'r';
        item.template = 'multichoice-' + item.subtype;
        item.presentation = parts.length > 1 ? parts[1] : '';
        if (item.subtype != 'd') {
            parts = item.presentation.split(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].MULTICHOICE_ADJUST_SEP) || [];
            item.presentation = parts.length > 0 ? parts[0] : '';
            // Horizontal are not supported right now. item.horizontal = parts.length > 1 && !!parts[1];
        }
        item.choices = item.presentation.split(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].LINE_SEP) || [];
        item.choices = item.choices.map(function (choice, index) {
            var weightValue = choice.split(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].MULTICHOICERATED_VALUE_SEP) || [''];
            choice = weightValue.length == 1 ? weightValue[0] : '(' + weightValue[0] + ') ' + weightValue[1];
            return { value: index + 1, label: choice };
        });
        if (item.subtype === 'r' && item.options.search(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].MULTICHOICE_HIDENOSELECT) == -1) {
            item.choices.unshift({ value: 0, label: this.translate.instant('addon.mod_feedback.not_selected') });
            item.value = typeof item.rawValue != 'undefined' ? parseInt(item.rawValue, 10) : 0;
        }
        else if (item.subtype === 'd') {
            item.choices.unshift({ value: 0, label: '' });
            item.value = typeof item.rawValue != 'undefined' ? parseInt(item.rawValue, 10) : 0;
        }
        else if (item.subtype === 'c') {
            if (typeof item.rawValue == 'undefined') {
                item.value = '';
            }
            else {
                item.rawValue = '' + item.rawValue;
                var values_1 = item.rawValue.split(__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */].LINE_SEP);
                item.choices.forEach(function (choice) {
                    for (var x in values_1) {
                        if (choice.value == values_1[x]) {
                            choice.checked = true;
                            return;
                        }
                    }
                });
            }
        }
        else {
            item.value = typeof item.rawValue != 'undefined' ? parseInt(item.rawValue, 10) : '';
        }
        return item;
    };
    /**
     * Helper funtion for item type Captcha.
     *
     * @param  {any} item Item to process.
     * @return {any}      Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemFormCaptcha = function (item) {
        var data = this.textUtils.parseJSON(item.otherdata);
        if (data && data.length > 3) {
            item.captcha = {
                recaptchapublickey: data[3]
            };
        }
        item.template = 'captcha';
        item.value = '';
        return item;
    };
    /**
     * Process and returns item to print form.
     *
     * @param {any}  item        Item to process.
     * @param {boolean} preview  Previewing options.
     * @return {any}             Item processed to show form.
     */
    AddonModFeedbackHelperProvider.prototype.getItemForm = function (item, preview) {
        switch (item.typ) {
            case 'label':
                return this.getItemFormLabel(item);
            case 'info':
                return this.getItemFormInfo(item);
            case 'numeric':
                return this.getItemFormNumeric(item);
            case 'textfield':
                return this.getItemFormTextfield(item);
            case 'textarea':
                return this.getItemFormTextarea(item);
            case 'multichoice':
                return this.getItemFormMultichoice(item);
            case 'multichoicerated':
                return this.getItemFormMultichoice(item);
            case 'pagebreak':
                if (!preview) {
                    // Pagebreaks are only used on preview.
                    return false;
                }
                break;
            case 'captcha':
                // Captcha is not supported right now. However label will be shown.
                return this.getItemFormCaptcha(item);
            default:
                return false;
        }
        return item;
    };
    /**
     * Returns human-readable boundaries (min - max).
     * Based on Moodle's get_boundaries_for_display.
     *
     * @param {number} rangeFrom Range from.
     * @param {number} rangeTo Range to.
     * @return {string} Human-readable boundaries.
     */
    AddonModFeedbackHelperProvider.prototype.getNumericBoundariesForDisplay = function (rangeFrom, rangeTo) {
        var rangeFromSet = typeof rangeFrom == 'number', rangeToSet = typeof rangeTo == 'number';
        if (!rangeFromSet && rangeToSet) {
            return ' (' + this.translate.instant('addon.mod_feedback.maximal') + ': ' + this.utils.formatFloat(rangeTo) + ')';
        }
        else if (rangeFromSet && !rangeToSet) {
            return ' (' + this.translate.instant('addon.mod_feedback.minimal') + ': ' + this.utils.formatFloat(rangeFrom) + ')';
        }
        else if (!rangeFromSet && !rangeToSet) {
            return '';
        }
        return ' (' + this.utils.formatFloat(rangeFrom) + ' - ' + this.utils.formatFloat(rangeTo) + ')';
    };
    AddonModFeedbackHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__feedback__["a" /* AddonModFeedbackProvider */], __WEBPACK_IMPORTED_MODULE_2__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModFeedbackHelperProvider);
    return AddonModFeedbackHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 185 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__quiz__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__quiz_offline__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__access_rules_delegate__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_helper__ = __webpack_require__(19);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Helper service that provides some features for quiz.
 */
var AddonModQuizHelperProvider = /** @class */ (function () {
    function AddonModQuizHelperProvider(domUtils, translate, utils, accessRuleDelegate, quizProvider, modalCtrl, quizOfflineProvider, courseHelper, sitesProvider, linkHelper) {
        this.domUtils = domUtils;
        this.translate = translate;
        this.utils = utils;
        this.accessRuleDelegate = accessRuleDelegate;
        this.quizProvider = quizProvider;
        this.modalCtrl = modalCtrl;
        this.quizOfflineProvider = quizOfflineProvider;
        this.courseHelper = courseHelper;
        this.sitesProvider = sitesProvider;
        this.linkHelper = linkHelper;
    }
    /**
     * Validate a preflight data or show a modal to input the preflight data if required.
     * It calls AddonModQuizProvider.startAttempt if a new attempt is needed.
     *
     * @param {any} quiz Quiz.
     * @param {any} accessInfo Quiz access info returned by AddonModQuizProvider.getQuizAccessInformation.
     * @param {any} preflightData Object where to store the preflight data.
     * @param {any} [attempt] Attempt to continue. Don't pass any value if the user needs to start a new attempt.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {boolean} [prefetch] Whether user is prefetching.
     * @param {string} [title] The title to display in the modal and in the submit button.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [retrying] Whether we're retrying after a failure.
     * @return {Promise<any>} Promise resolved when the preflight data is validated. The resolve param is the attempt.
     */
    AddonModQuizHelperProvider.prototype.getAndCheckPreflightData = function (quiz, accessInfo, preflightData, attempt, offline, prefetch, title, siteId, retrying) {
        var _this = this;
        var rules = accessInfo && accessInfo.activerulenames;
        var isPreflightCheckRequired = false;
        // Check if the user needs to input preflight data.
        return this.accessRuleDelegate.isPreflightCheckRequired(rules, quiz, attempt, prefetch, siteId).then(function (required) {
            isPreflightCheckRequired = required;
            if (required) {
                // Preflight check is required but no preflightData has been sent. Show a modal with the preflight form.
                return _this.getPreflightData(quiz, accessInfo, attempt, prefetch, title, siteId).then(function (data) {
                    // Data entered by the user, add it to preflight data and check it again.
                    Object.assign(preflightData, data);
                });
            }
        }).then(function () {
            // Get some fixed preflight data from access rules (data that doesn't require user interaction).
            return _this.accessRuleDelegate.getFixedPreflightData(rules, quiz, preflightData, attempt, prefetch, siteId);
        }).then(function () {
            // All the preflight data is gathered, now validate it.
            return _this.validatePreflightData(quiz, accessInfo, preflightData, attempt, offline, prefetch, siteId)
                .catch(function (error) {
                if (prefetch) {
                    return Promise.reject(error);
                }
                else if (retrying && !isPreflightCheckRequired) {
                    // We're retrying after a failure, but the preflight check wasn't required.
                    // This means there's something wrong with some access rule or user is offline and data isn't cached.
                    // Don't retry again because it would lead to an infinite loop.
                    return Promise.reject(error);
                }
                else {
                    // Show error and ask for the preflight again.
                    // Wait to show the error because we want it to be shown over the preflight modal.
                    setTimeout(function () {
                        _this.domUtils.showErrorModalDefault(error, 'core.error', true);
                    }, 100);
                    return _this.getAndCheckPreflightData(quiz, accessInfo, preflightData, attempt, offline, prefetch, title, siteId, true);
                }
            });
        });
    };
    /**
     * Get the preflight data from the user using a modal.
     *
     * @param {any} quiz Quiz.
     * @param {any} accessInfo Quiz access info returned by AddonModQuizProvider.getQuizAccessInformation.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [title] The title to display in the modal and in the submit button.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the preflight data. Rejected if user cancels.
     */
    AddonModQuizHelperProvider.prototype.getPreflightData = function (quiz, accessInfo, attempt, prefetch, title, siteId) {
        var _this = this;
        var notSupported = [];
        // Check if there is any unsupported rule.
        accessInfo.activerulenames.forEach(function (rule) {
            if (!_this.accessRuleDelegate.isAccessRuleSupported(rule)) {
                notSupported.push(rule);
            }
        });
        if (notSupported.length) {
            return Promise.reject(this.translate.instant('addon.mod_quiz.errorrulesnotsupported') + ' ' +
                JSON.stringify(notSupported));
        }
        // Create and show the modal.
        var modal = this.modalCtrl.create('AddonModQuizPreflightModalPage', {
            title: title,
            quiz: quiz,
            attempt: attempt,
            prefetch: !!prefetch,
            siteId: siteId,
            rules: accessInfo.activerulenames
        });
        modal.present();
        // Wait for modal to be dismissed.
        return new Promise(function (resolve, reject) {
            modal.onDidDismiss(function (data) {
                if (typeof data != 'undefined') {
                    resolve(data);
                }
                else {
                    reject(_this.domUtils.createCanceledError());
                }
            });
        });
    };
    /**
     * Gets the mark string from a question HTML.
     * Example result: "Marked out of 1.00".
     *
     * @param  {string} html Question's HTML.
     * @return {string}      Question's mark.
     */
    AddonModQuizHelperProvider.prototype.getQuestionMarkFromHtml = function (html) {
        var element = this.domUtils.convertToElement(html);
        return this.domUtils.getContentsOfElement(element, '.grade');
    };
    /**
     * Get a quiz ID by attempt ID.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with the quiz ID.
     */
    AddonModQuizHelperProvider.prototype.getQuizIdByAttemptId = function (attemptId, siteId) {
        // Use getAttemptReview to retrieve the quiz ID.
        return this.quizProvider.getAttemptReview(attemptId, undefined, false, siteId).then(function (reviewData) {
            if (reviewData.attempt && reviewData.attempt.quiz) {
                return reviewData.attempt.quiz;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Handle a review link.
     *
     * @param {NavController} navCtrl Nav controller, can be undefined/null.
     * @param {number} attemptId Attempt ID.
     * @param {number} [page] Page to load, -1 to all questions in same page.
     * @param {number} [courseId] Course ID.
     * @param {number} [quizId] Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizHelperProvider.prototype.handleReviewLink = function (navCtrl, attemptId, page, courseId, quizId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var modal = this.domUtils.showModalLoading();
        var promise;
        if (quizId) {
            promise = Promise.resolve(quizId);
        }
        else {
            // Retrieve the quiz ID using the attempt ID.
            promise = this.getQuizIdByAttemptId(attemptId);
        }
        return promise.then(function (id) {
            quizId = id;
            // Get the courseId if we don't have it.
            if (courseId) {
                return courseId;
            }
            else {
                return _this.courseHelper.getModuleCourseIdByInstance(quizId, 'quiz', siteId);
            }
        }).then(function (courseId) {
            // Go to the review page.
            var pageParams = {
                quizId: quizId,
                attemptId: attemptId,
                courseId: courseId,
                page: isNaN(page) ? -1 : page
            };
            return _this.linkHelper.goInSite(navCtrl, 'AddonModQuizReviewPage', pageParams, siteId);
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'An error occurred while loading the required data.');
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Add some calculated data to the attempt.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {boolean} highlight Whether we should check if attempt should be highlighted.
     * @param {number} [bestGrade] Quiz's best grade (formatted). Required if highlight=true.
     */
    AddonModQuizHelperProvider.prototype.setAttemptCalculatedData = function (quiz, attempt, highlight, bestGrade) {
        attempt.rescaledGrade = this.quizProvider.rescaleGrade(attempt.sumgrades, quiz, false);
        attempt.finished = this.quizProvider.isAttemptFinished(attempt.state);
        attempt.readableState = this.quizProvider.getAttemptReadableState(quiz, attempt);
        if (quiz.showMarkColumn && attempt.finished) {
            attempt.readableMark = this.quizProvider.formatGrade(attempt.sumgrades, quiz.decimalpoints);
        }
        else {
            attempt.readableMark = '';
        }
        if (quiz.showGradeColumn && attempt.finished) {
            attempt.readableGrade = this.quizProvider.formatGrade(attempt.rescaledGrade, quiz.decimalpoints);
            // Highlight the highest grade if appropriate.
            attempt.highlightGrade = highlight && !attempt.preview && attempt.state == __WEBPACK_IMPORTED_MODULE_6__quiz__["a" /* AddonModQuizProvider */].ATTEMPT_FINISHED &&
                attempt.readableGrade == bestGrade;
        }
        else {
            attempt.readableGrade = '';
        }
    };
    /**
     * Add some calculated data to the quiz.
     *
     * @param {any} quiz Quiz.
     * @param {any} options Options returned by AddonModQuizProvider.getCombinedReviewOptions.
     */
    AddonModQuizHelperProvider.prototype.setQuizCalculatedData = function (quiz, options) {
        quiz.sumGradesFormatted = this.quizProvider.formatGrade(quiz.sumgrades, quiz.decimalpoints);
        quiz.gradeFormatted = this.quizProvider.formatGrade(quiz.grade, quiz.decimalpoints);
        quiz.showAttemptColumn = quiz.attempts != 1;
        quiz.showGradeColumn = options.someoptions.marks >= __WEBPACK_IMPORTED_MODULE_6__quiz__["a" /* AddonModQuizProvider */].QUESTION_OPTIONS_MARK_AND_MAX &&
            this.quizProvider.quizHasGrades(quiz);
        quiz.showMarkColumn = quiz.showGradeColumn && quiz.grade != quiz.sumgrades;
        quiz.showFeedbackColumn = quiz.hasfeedback && options.alloptions.overallfeedback;
    };
    /**
     * Validate the preflight data. It calls AddonModQuizProvider.startAttempt if a new attempt is needed.
     *
     * @param {any} quiz Quiz.
     * @param {any} accessInfo Quiz access info returned by AddonModQuizProvider.getQuizAccessInformation.
     * @param {any} preflightData Object where to store the preflight data.
     * @param {any} [attempt] Attempt to continue. Don't pass any value if the user needs to start a new attempt.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {boolean} [sent] Whether preflight data has been entered by the user.
     * @param {boolean} [prefetch] Whether user is prefetching.
     * @param {string} [title] The title to display in the modal and in the submit button.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the preflight data is validated.
     */
    AddonModQuizHelperProvider.prototype.validatePreflightData = function (quiz, accessInfo, preflightData, attempt, offline, prefetch, siteId) {
        var _this = this;
        var rules = accessInfo.activerulenames;
        var promise;
        if (attempt) {
            if (attempt.state != __WEBPACK_IMPORTED_MODULE_6__quiz__["a" /* AddonModQuizProvider */].ATTEMPT_OVERDUE && !attempt.finishedOffline) {
                // We're continuing an attempt. Call getAttemptData to validate the preflight data.
                var page = attempt.currentpage;
                promise = this.quizProvider.getAttemptData(attempt.id, page, preflightData, offline, true, siteId).then(function () {
                    if (offline) {
                        // Get current page stored in local.
                        return _this.quizOfflineProvider.getAttemptById(attempt.id).then(function (localAttempt) {
                            attempt.currentpage = localAttempt.currentpage;
                        }).catch(function () {
                            // No local data.
                        });
                    }
                });
            }
            else {
                // Attempt is overdue or finished in offline, we can only see the summary.
                // Call getAttemptSummary to validate the preflight data.
                promise = this.quizProvider.getAttemptSummary(attempt.id, preflightData, offline, true, false, siteId);
            }
        }
        else {
            // We're starting a new attempt, call startAttempt.
            promise = this.quizProvider.startAttempt(quiz.id, preflightData, false, siteId).then(function (att) {
                attempt = att;
            });
        }
        return promise.then(function () {
            // Preflight data validated.
            _this.accessRuleDelegate.notifyPreflightCheckPassed(rules, quiz, attempt, preflightData, prefetch, siteId);
            return attempt;
        }).catch(function (error) {
            if (_this.utils.isWebServiceError(error)) {
                // The WebService returned an error, assume the preflight failed.
                _this.accessRuleDelegate.notifyPreflightCheckFailed(rules, quiz, attempt, preflightData, prefetch, siteId);
            }
            return Promise.reject(error);
        });
    };
    AddonModQuizHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_6__quiz__["a" /* AddonModQuizProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_7__quiz_offline__["a" /* AddonModQuizOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], AddonModQuizHelperProvider);
    return AddonModQuizHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 186 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBadgesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service to handle badges.
 */
var AddonBadgesProvider = /** @class */ (function () {
    function AddonBadgesProvider(logger, sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.ROOT_CACHE_KEY = 'mmaBadges:';
        this.logger = logger.getInstance('AddonBadgesProvider');
    }
    /**
     * Returns whether or not the badge plugin is enabled for a certain site.
     *
     * This method is called quite often and thus should only perform a quick
     * check, we should not be calling WS from here.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if enabled, false otherwise.
     */
    AddonBadgesProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.canUseAdvancedFeature('enablebadges')) {
                return false;
            }
            else if (!site.wsAvailable('core_course_get_user_navigation_options')) {
                return false;
            }
            return true;
        });
    };
    /**
     * Get the cache key for the get badges call.
     *
     * @param {number} courseId ID of the course to get the badges from.
     * @param {number} userId ID of the user to get the badges from.
     * @return {string} Cache key.
     */
    AddonBadgesProvider.prototype.getBadgesCacheKey = function (courseId, userId) {
        return this.ROOT_CACHE_KEY + 'badges:' + courseId + ':' + userId;
    };
    /**
     * Get issued badges for a certain user in a course.
     *
     * @param {number} courseId ID of the course to get the badges from.
     * @param {number} userId ID of the user to get the badges from.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}Promise to be resolved when the badges are retrieved.
     */
    AddonBadgesProvider.prototype.getUserBadges = function (courseId, userId, siteId) {
        var _this = this;
        this.logger.debug('Get badges for course ' + courseId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                courseid: courseId,
                userid: userId
            }, preSets = {
                cacheKey: _this.getBadgesCacheKey(courseId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('core_badges_get_user_badges', data, preSets).then(function (response) {
                if (response && response.badges) {
                    return response.badges;
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Invalidate get badges WS call.
     *
     * @param {number} courseId Course ID.
     * @param {number} userId ID of the user to get the badges from.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data is invalidated.
     */
    AddonBadgesProvider.prototype.invalidateUserBadges = function (courseId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getBadgesCacheKey(courseId, userId));
        });
    };
    AddonBadgesProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonBadgesProvider);
    return AddonBadgesProvider;
}());

//# sourceMappingURL=badges.js.map

/***/ }),
/* 187 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__forum__ = __webpack_require__(100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__helper__ = __webpack_require__(220);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__offline__ = __webpack_require__(169);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__core_rating_providers_sync__ = __webpack_require__(156);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



















/**
 * Service to sync forums.
 */
var AddonModForumSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModForumSyncProvider, _super);
    function AddonModForumSyncProvider(translate, appProvider, courseProvider, eventsProvider, groupsProvider, loggerProvider, sitesProvider, syncProvider, textUtils, timeUtils, uploaderProvider, utils, forumProvider, forumHelper, forumOffline, logHelper, ratingSync) {
        var _this = _super.call(this, 'AddonModForumSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.eventsProvider = eventsProvider;
        _this.groupsProvider = groupsProvider;
        _this.uploaderProvider = uploaderProvider;
        _this.utils = utils;
        _this.forumProvider = forumProvider;
        _this.forumHelper = forumHelper;
        _this.forumOffline = forumOffline;
        _this.logHelper = logHelper;
        _this.ratingSync = ratingSync;
        _this.componentTranslate = courseProvider.translateModuleName('forum');
        return _this;
    }
    AddonModForumSyncProvider_1 = AddonModForumSyncProvider;
    /**
     * Try to synchronize all the forums in a certain site or in all sites.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModForumSyncProvider.prototype.syncAllForums = function (siteId, force) {
        return this.syncOnSites('all forums', this.syncAllForumsFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all forums on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}          Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModForumSyncProvider.prototype.syncAllForumsFunc = function (siteId, force) {
        var _this = this;
        var sitePromises = [];
        // Sync all new discussions.
        sitePromises.push(this.forumOffline.getAllNewDiscussions(siteId).then(function (discussions) {
            var promises = {};
            // Do not sync same forum twice.
            discussions.forEach(function (discussion) {
                if (typeof promises[discussion.forumid] != 'undefined') {
                    return;
                }
                promises[discussion.forumid] = force ? _this.syncForumDiscussions(discussion.forumid, discussion.userid, siteId) :
                    _this.syncForumDiscussionsIfNeeded(discussion.forumid, discussion.userid, siteId);
                promises[discussion.forumid].then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModForumSyncProvider_1.AUTO_SYNCED, {
                            forumId: discussion.forumid,
                            userId: discussion.userid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(_this.utils.objectToArray(promises));
        }));
        // Sync all discussion replies.
        sitePromises.push(this.forumOffline.getAllReplies(siteId).then(function (replies) {
            var promises = {};
            // Do not sync same discussion twice.
            replies.forEach(function (reply) {
                if (typeof promises[reply.discussionid] != 'undefined') {
                    return;
                }
                promises[reply.discussionid] = force ? _this.syncDiscussionReplies(reply.discussionid, reply.userid, siteId) :
                    _this.syncDiscussionRepliesIfNeeded(reply.discussionid, reply.userid, siteId);
                promises[reply.discussionid].then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModForumSyncProvider_1.AUTO_SYNCED, {
                            forumId: reply.forumid,
                            discussionId: reply.discussionid,
                            userId: reply.userid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(_this.utils.objectToArray(promises));
        }));
        sitePromises.push(this.syncRatings(undefined, undefined, force, siteId));
        return Promise.all(sitePromises);
    };
    /**
     * Sync a forum only if a certain time has passed since the last time.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {number} userId   User the discussion belong to.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the forum is synced or if it doesn't need to be synced.
     */
    AddonModForumSyncProvider.prototype.syncForumDiscussionsIfNeeded = function (forumId, userId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getForumSyncId(forumId, userId);
        return this.isSyncNeeded(syncId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncForumDiscussions(forumId, userId, siteId);
            }
        });
    };
    /**
     * Synchronize all offline discussions of a forum.
     *
     * @param  {number} forumId  Forum ID to be synced.
     * @param  {number} [userId] User the discussions belong to.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModForumSyncProvider.prototype.syncForumDiscussions = function (forumId, userId, siteId) {
        var _this = this;
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getForumSyncId(forumId, userId);
        if (this.isSyncing(syncId, siteId)) {
            // There's already a sync ongoing for this discussion, return the promise.
            return this.getOngoingSync(syncId, siteId);
        }
        // Verify that forum isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_15__forum__["a" /* AddonModForumProvider */].COMPONENT, syncId, siteId)) {
            this.logger.debug('Cannot sync forum ' + forumId + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync forum ' + forumId + ' for user ' + userId);
        var result = {
            warnings: [],
            updated: false
        };
        // Sync offline logs.
        var syncPromise = this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_15__forum__["a" /* AddonModForumProvider */].COMPONENT, forumId, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Get offline responses to be sent.
            return _this.forumOffline.getNewDiscussions(forumId, siteId, userId).catch(function () {
                // No offline data found, return empty object.
                return [];
            });
        }).then(function (discussions) {
            if (!discussions.length) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            var promises = [];
            discussions.forEach(function (data) {
                var groupsPromise;
                if (data.groupid == __WEBPACK_IMPORTED_MODULE_15__forum__["a" /* AddonModForumProvider */].ALL_GROUPS) {
                    // Fetch all group ids.
                    groupsPromise = _this.forumProvider.getForumById(data.courseid, data.forumid, siteId).then(function (forum) {
                        return _this.groupsProvider.getActivityAllowedGroups(forum.cmid).then(function (groups) {
                            return groups.map(function (group) { return group.id; });
                        });
                    });
                }
                else {
                    groupsPromise = Promise.resolve([data.groupid]);
                }
                promises.push(groupsPromise.then(function (groupIds) {
                    var errors = [];
                    return Promise.all(groupIds.map(function (groupId) {
                        // First of all upload the attachments (if any).
                        return _this.uploadAttachments(forumId, data, true, siteId, userId).then(function (itemId) {
                            // Now try to add the discussion.
                            var options = _this.utils.clone(data.options || {});
                            options.attachmentsid = itemId;
                            return _this.forumProvider.addNewDiscussionOnline(forumId, data.subject, data.message, options, groupId, siteId);
                        }).catch(function (error) {
                            errors.push(error);
                        });
                    })).then(function () {
                        if (errors.length == groupIds.length) {
                            // All requests have failed, reject if errors were not returned by WS.
                            for (var i = 0; i < errors.length; i++) {
                                if (!_this.utils.isWebServiceError(errors[i])) {
                                    return Promise.reject(errors[i]);
                                }
                            }
                        }
                        // All requests succeeded, some failed or all failed with a WS error.
                        result.updated = true;
                        return _this.deleteNewDiscussion(forumId, data.timecreated, siteId, userId).then(function () {
                            if (errors.length == groupIds.length) {
                                // All requests failed with WS error.
                                result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                    component: _this.componentTranslate,
                                    name: data.name,
                                    error: _this.textUtils.getErrorMessageFromError(errors[0])
                                }));
                            }
                        });
                    });
                }));
            });
            return Promise.all(promises);
        }).then(function () {
            if (result.updated) {
                // Data has been sent to server. Now invalidate the WS calls.
                var promises = [
                    _this.forumProvider.invalidateDiscussionsList(forumId, siteId),
                    _this.forumProvider.invalidateCanAddDiscussion(forumId, siteId),
                ];
                return Promise.all(promises).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(syncId, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // All done, return the warnings.
            return result;
        });
        return this.addOngoingSync(syncId, syncPromise, siteId);
    };
    /**
     * Synchronize forum offline ratings.
     *
     * @param {number} [cmId] Course module to be synced. If not defined, sync all forums.
     * @param {number} [discussionId] Discussion id to be synced. If not defined, sync all discussions.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModForumSyncProvider.prototype.syncRatings = function (cmId, discussionId, force, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.ratingSync.syncRatings('mod_forum', 'post', 'module', cmId, discussionId, force, siteId).then(function (results) {
            var updated = false;
            var warnings = [];
            var promises = [];
            results.forEach(function (result) {
                if (result.updated.length) {
                    updated = true;
                    // Invalidate discussions of updated ratings.
                    promises.push(_this.forumProvider.invalidateDiscussionPosts(result.itemSet.itemSetId, siteId));
                }
                if (result.warnings.length) {
                    // Fetch forum to construct the warning message.
                    promises.push(_this.forumProvider.getForum(result.itemSet.courseId, result.itemSet.instanceId, siteId)
                        .then(function (forum) {
                        result.warnings.forEach(function (warning) {
                            warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: forum.name,
                                error: warning
                            }));
                        });
                    }));
                }
            });
            return _this.utils.allPromises(promises).then(function () {
                return { updated: updated, warnings: warnings };
            });
        });
    };
    /**
     * Synchronize all offline discussion replies of a forum.
     *
     * @param  {number} forumId  Forum ID to be synced.
     * @param  {number} [userId] User the discussions belong to.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModForumSyncProvider.prototype.syncForumReplies = function (forumId, userId, siteId) {
        var _this = this;
        // Get offline forum replies to be sent.
        return this.forumOffline.getForumReplies(forumId, siteId, userId).catch(function () {
            // No offline data found, return empty list.
            return [];
        }).then(function (replies) {
            if (!replies.length) {
                // Nothing to sync.
                return { warnings: [], updated: false };
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            var promises = {};
            // Do not sync same discussion twice.
            replies.forEach(function (reply) {
                if (typeof promises[reply.discussionid] != 'undefined') {
                    return;
                }
                promises[reply.discussionid] = _this.syncDiscussionReplies(reply.discussionid, userId, siteId);
            });
            return Promise.all(_this.utils.objectToArray(promises)).then(function (results) {
                return results.reduce(function (a, b) { return ({
                    warnings: a.warnings.concat(b.warnings),
                    updated: a.updated || b.updated,
                }); }, { warnings: [], updated: false });
            });
        });
    };
    /**
     * Sync a forum discussion replies only if a certain time has passed since the last time.
     *
     * @param  {number} discussionId Discussion ID to be synced.
     * @param  {number} [userId]     User the posts belong to.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the forum discussion is synced or if it doesn't need to be synced.
     */
    AddonModForumSyncProvider.prototype.syncDiscussionRepliesIfNeeded = function (discussionId, userId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getDiscussionSyncId(discussionId, userId);
        return this.isSyncNeeded(syncId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncDiscussionReplies(discussionId, userId, siteId);
            }
        });
    };
    /**
     * Synchronize all offline replies from a discussion.
     *
     * @param  {number} discussionId Discussion ID to be synced.
     * @param  {number} [userId]     User the posts belong to.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModForumSyncProvider.prototype.syncDiscussionReplies = function (discussionId, userId, siteId) {
        var _this = this;
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getDiscussionSyncId(discussionId, userId);
        if (this.isSyncing(syncId, siteId)) {
            // There's already a sync ongoing for this discussion, return the promise.
            return this.getOngoingSync(syncId, siteId);
        }
        // Verify that forum isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_15__forum__["a" /* AddonModForumProvider */].COMPONENT, syncId, siteId)) {
            this.logger.debug('Cannot sync forum discussion ' + discussionId + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync forum discussion ' + discussionId + ' for user ' + userId);
        var forumId;
        var result = {
            warnings: [],
            updated: false
        };
        // Get offline responses to be sent.
        var syncPromise = this.forumOffline.getDiscussionReplies(discussionId, siteId, userId).catch(function () {
            // No offline data found, return empty object.
            return [];
        }).then(function (replies) {
            if (!replies.length) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            var promises = [];
            replies.forEach(function (data) {
                forumId = data.forumid;
                data.options = data.options || {};
                // First of all upload the attachments (if any).
                var promise = _this.uploadAttachments(forumId, data, false, siteId, userId).then(function (itemId) {
                    // Now try to send the reply.
                    data.options.attachmentsid = itemId;
                    return _this.forumProvider.replyPostOnline(data.postid, data.subject, data.message, data.options, siteId);
                });
                promises.push(promise.then(function () {
                    result.updated = true;
                    return _this.deleteReply(forumId, data.postid, siteId, userId);
                }).catch(function (error) {
                    if (_this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means that responses cannot be submitted. Delete them.
                        result.updated = true;
                        return _this.deleteReply(forumId, data.postid, siteId, userId).then(function () {
                            // Responses deleted, add a warning.
                            result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: data.name,
                                error: _this.textUtils.getErrorMessageFromError(error)
                            }));
                        });
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                }));
            });
            return Promise.all(promises);
        }).then(function () {
            // Data has been sent to server. Now invalidate the WS calls.
            var promises = [];
            if (forumId) {
                promises.push(_this.forumProvider.invalidateDiscussionsList(forumId, siteId));
            }
            promises.push(_this.forumProvider.invalidateDiscussionPosts(discussionId, siteId));
            return _this.utils.allPromises(promises).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(syncId, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // All done, return the warnings.
            return result;
        });
        return this.addOngoingSync(syncId, syncPromise, siteId);
    };
    /**
     * Delete a new discussion.
     *
     * @param  {number} forumId     Forum ID the discussion belongs to.
     * @param  {number} timecreated The timecreated of the discussion.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @param  {number} [userId]    User the discussion belongs to. If not defined, current user in site.
     * @return {Promise<any>}       Promise resolved when deleted.
     */
    AddonModForumSyncProvider.prototype.deleteNewDiscussion = function (forumId, timecreated, siteId, userId) {
        var promises = [];
        promises.push(this.forumOffline.deleteNewDiscussion(forumId, timecreated, siteId, userId));
        promises.push(this.forumHelper.deleteNewDiscussionStoredFiles(forumId, timecreated, siteId).catch(function () {
            // Ignore errors, maybe there are no files.
        }));
        return Promise.all(promises);
    };
    /**
     * Delete a new discussion.
     *
     * @param  {number} forumId  Forum ID the discussion belongs to.
     * @param  {number} postId   ID of the post being replied.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the discussion belongs to. If not defined, current user in site.
     * @return {Promise<any>}    Promise resolved when deleted.
     */
    AddonModForumSyncProvider.prototype.deleteReply = function (forumId, postId, siteId, userId) {
        var promises = [];
        promises.push(this.forumOffline.deleteReply(postId, siteId, userId));
        promises.push(this.forumHelper.deleteReplyStoredFiles(forumId, postId, siteId, userId).catch(function () {
            // Ignore errors, maybe there are no files.
        }));
        return Promise.all(promises);
    };
    /**
     * Upload attachments of an offline post/discussion.
     *
     * @param  {number}  forumId  Forum ID the post belongs to.
     * @param  {any}     post     Offline post or discussion.
     * @param  {boolean} isDisc   True if it's a new discussion, false if it's a reply.
     * @param  {string}  [siteId] Site ID. If not defined, current site.
     * @param  {number}  [userId] User the reply belongs to. If not defined, current user in site.
     * @return {Promise<any>}     Promise resolved with draftid if uploaded, resolved with undefined if nothing to upload.
     */
    AddonModForumSyncProvider.prototype.uploadAttachments = function (forumId, post, isDisc, siteId, userId) {
        var _this = this;
        var attachments = post && post.options && post.options.attachmentsid;
        if (attachments) {
            // Has some attachments to sync.
            var files_1 = attachments.online || [];
            var promise = void 0;
            if (attachments.offline) {
                // Has offline files.
                if (isDisc) {
                    promise = this.forumHelper.getNewDiscussionStoredFiles(forumId, post.timecreated, siteId);
                }
                else {
                    promise = this.forumHelper.getReplyStoredFiles(forumId, post.postid, siteId, userId);
                }
                promise.then(function (atts) {
                    files_1 = files_1.concat(atts);
                }).catch(function () {
                    // Folder not found, no files to add.
                });
            }
            else {
                promise = Promise.resolve();
            }
            return promise.then(function () {
                return _this.uploaderProvider.uploadOrReuploadFiles(files_1, __WEBPACK_IMPORTED_MODULE_15__forum__["a" /* AddonModForumProvider */].COMPONENT, forumId, siteId);
            });
        }
        // No attachments, resolve.
        return Promise.resolve();
    };
    /**
     * Get the ID of a forum sync.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {number} [userId] User the responses belong to.. If not defined, current user.
     * @return {string}          Sync ID.
     */
    AddonModForumSyncProvider.prototype.getForumSyncId = function (forumId, userId) {
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        return 'forum#' + forumId + '#' + userId;
    };
    /**
     * Get the ID of a discussion sync.
     *
     * @param  {number} discussionId Discussion ID.
     * @param  {number} [userId]     User the responses belong to.. If not defined, current user.
     * @return {string}              Sync ID.
     */
    AddonModForumSyncProvider.prototype.getDiscussionSyncId = function (discussionId, userId) {
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        return 'discussion#' + discussionId + '#' + userId;
    };
    AddonModForumSyncProvider.AUTO_SYNCED = 'addon_mod_forum_autom_synced';
    AddonModForumSyncProvider.MANUAL_SYNCED = 'addon_mod_forum_manual_synced';
    AddonModForumSyncProvider = AddonModForumSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_sync__["a" /* CoreSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_14__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_15__forum__["a" /* AddonModForumProvider */],
            __WEBPACK_IMPORTED_MODULE_16__helper__["a" /* AddonModForumHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_17__offline__["a" /* AddonModForumOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_18__core_rating_providers_sync__["a" /* CoreRatingSyncProvider */]])
    ], AddonModForumSyncProvider);
    return AddonModForumSyncProvider;
    var AddonModForumSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_2__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 188 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle offline glossary.
 */
var AddonModGlossaryOfflineProvider = /** @class */ (function () {
    function AddonModGlossaryOfflineProvider(fileProvider, sitesProvider, textUtils, utils) {
        this.fileProvider = fileProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.utils = utils;
        this.siteSchema = {
            name: 'AddonModGlossaryOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModGlossaryOfflineProvider_1.ENTRIES_TABLE,
                    columns: [
                        {
                            name: 'glossaryid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'concept',
                            type: 'TEXT',
                        },
                        {
                            name: 'definition',
                            type: 'TEXT',
                        },
                        {
                            name: 'definitionformat',
                            type: 'TEXT',
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER',
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER',
                        },
                        {
                            name: 'options',
                            type: 'TEXT',
                        },
                        {
                            name: 'attachments',
                            type: 'TEXT',
                        },
                    ],
                    primaryKeys: ['glossaryid', 'concept', 'timecreated']
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModGlossaryOfflineProvider_1 = AddonModGlossaryOfflineProvider;
    /**
     * Delete a new entry.
     *
     * @param  {number} glossaryId  Glossary ID.
     * @param  {string} concept     Glossary entry concept.
     * @param  {number} timeCreated The time the entry was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<void>}      Promise resolved if deleted, rejected if failure.
     */
    AddonModGlossaryOfflineProvider.prototype.deleteNewEntry = function (glossaryId, concept, timeCreated, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                glossaryid: glossaryId,
                concept: concept,
                timecreated: timeCreated,
            };
            return site.getDb().deleteRecords(AddonModGlossaryOfflineProvider_1.ENTRIES_TABLE, conditions);
        });
    };
    /**
     * Get all the stored new entries from all the glossaries.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with entries.
     */
    AddonModGlossaryOfflineProvider.prototype.getAllNewEntries = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModGlossaryOfflineProvider_1.ENTRIES_TABLE).then(function (records) {
                return records.map(_this.parseRecord.bind(_this));
            });
        });
    };
    /**
     * Get a stored new entry.
     *
     * @param  {number} glossaryId  Glossary ID.
     * @param  {string} concept     Glossary entry concept.
     * @param  {number} timeCreated The time the entry was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with entry.
     */
    AddonModGlossaryOfflineProvider.prototype.getNewEntry = function (glossaryId, concept, timeCreated, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                glossaryid: glossaryId,
                concept: concept,
                timecreated: timeCreated,
            };
            return site.getDb().getRecord(AddonModGlossaryOfflineProvider_1.ENTRIES_TABLE, conditions)
                .then(_this.parseRecord.bind(_this));
        });
    };
    /**
     * Get all the stored add entry data from a certain glossary.
     *
     * @param  {number} glossaryId Glossary ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @param  {number} [userId]   User the entries belong to. If not defined, current user in site.
     * @return {Promise<any[]>} Promise resolved with entries.
     */
    AddonModGlossaryOfflineProvider.prototype.getGlossaryNewEntries = function (glossaryId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                glossaryid: glossaryId,
                userId: userId || site.getUserId(),
            };
            return site.getDb().getRecords(AddonModGlossaryOfflineProvider_1.ENTRIES_TABLE, conditions).then(function (records) {
                return records.map(_this.parseRecord.bind(_this));
            });
        });
    };
    /**
     * Check if a concept is used offline.
     *
     * @param  {number} glossaryId    Glossary ID.
     * @param  {string} concept       Concept to check.
     * @param  {number} [timeCreated] Time of the entry we are editing.
     * @param  {string} [siteId]      Site ID. If not defined, current site.
     * @return {Promise<boolean>}     Promise resolved with true if concept is found, false otherwise.
     */
    AddonModGlossaryOfflineProvider.prototype.isConceptUsed = function (glossaryId, concept, timeCreated, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = {
                glossaryid: glossaryId,
                concept: concept,
            };
            return site.getDb().getRecords(AddonModGlossaryOfflineProvider_1.ENTRIES_TABLE, conditions).then(function (entries) {
                if (!entries.length) {
                    return false;
                }
                if (entries.length > 1 || !timeCreated) {
                    return true;
                }
                // If there's only one entry, check that is not the one we are editing.
                return _this.utils.promiseFails(_this.getNewEntry(glossaryId, concept, timeCreated, siteId));
            });
        }).catch(function () {
            // No offline data found, return false.
            return false;
        });
    };
    /**
     * Save a new entry to be sent later.
     *
     * @param  {number} glossaryId     Glossary ID.
     * @param  {string} concept        Glossary entry concept.
     * @param  {string} definition     Glossary entry concept definition.
     * @param  {number} courseId       Course ID of the glossary.
     * @param  {any}    [options]      Options for the entry.
     * @param  {any}    [attachments]  Result of CoreFileUploaderProvider#storeFilesToUpload for attachments.
     * @param  {number} [timeCreated]  The time the entry was created. If not defined, current time.
     * @param  {string} [siteId]       Site ID. If not defined, current site.
     * @param  {number} [userId]       User the entry belong to. If not defined, current user in site.
     * @param  {any}    [discardEntry] The entry provided will be discarded if found.
     * @return {Promise<false>}        Promise resolved if stored, rejected if failure.
     */
    AddonModGlossaryOfflineProvider.prototype.addNewEntry = function (glossaryId, concept, definition, courseId, options, attachments, timeCreated, siteId, userId, discardEntry) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                glossaryid: glossaryId,
                courseid: courseId,
                concept: concept,
                definition: definition,
                definitionformat: 'html',
                options: JSON.stringify(options),
                attachments: JSON.stringify(attachments),
                userid: userId || site.getUserId(),
                timecreated: timeCreated || new Date().getTime()
            };
            // If editing an offline entry, delete previous first.
            var discardPromise;
            if (discardEntry) {
                discardPromise = _this.deleteNewEntry(glossaryId, discardEntry.concept, discardEntry.timecreated, site.getId());
            }
            else {
                discardPromise = Promise.resolve();
            }
            return discardPromise.then(function () {
                return site.getDb().insertRecord(AddonModGlossaryOfflineProvider_1.ENTRIES_TABLE, entry).then(function () { return false; });
            });
        });
    };
    /**
     * Get the path to the folder where to store files for offline attachments in a glossary.
     *
     * @param  {number} glossaryId Glossary ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<string>}   Promise resolved with the path.
     */
    AddonModGlossaryOfflineProvider.prototype.getGlossaryFolder = function (glossaryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var siteFolderPath = _this.fileProvider.getSiteFolder(site.getId());
            var folderPath = 'offlineglossary/' + glossaryId;
            return _this.textUtils.concatenatePaths(siteFolderPath, folderPath);
        });
    };
    /**
     * Get the path to the folder where to store files for a new offline entry.
     *
     * @param  {number} glossaryId  Glossary ID.
     * @param  {string} concept     The name of the entry.
     * @param  {number} timeCreated Time to allow duplicated entries.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<string>}    Promise resolved with the path.
     */
    AddonModGlossaryOfflineProvider.prototype.getEntryFolder = function (glossaryId, concept, timeCreated, siteId) {
        var _this = this;
        return this.getGlossaryFolder(glossaryId, siteId).then(function (folderPath) {
            return _this.textUtils.concatenatePaths(folderPath, 'newentry_' + concept + '_' + timeCreated);
        });
    };
    /**
     * Parse "options" and "attachments" columns of a fetched record.
     *
     * @param  {any} records Record object
     * @return {any}         Record object with columns parsed.
     */
    AddonModGlossaryOfflineProvider.prototype.parseRecord = function (record) {
        record.options = this.textUtils.parseJSON(record.options);
        record.attachments = this.textUtils.parseJSON(record.attachments);
        return record;
    };
    // Variables for database.
    AddonModGlossaryOfflineProvider.ENTRIES_TABLE = 'addon_mod_glossary_entrues';
    AddonModGlossaryOfflineProvider = AddonModGlossaryOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModGlossaryOfflineProvider);
    return AddonModGlossaryOfflineProvider;
    var AddonModGlossaryOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 189 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__ = __webpack_require__(178);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__quiz__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__quiz_offline__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__prefetch_handler__ = __webpack_require__(375);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















/**
 * Service to sync quizzes.
 */
var AddonModQuizSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModQuizSyncProvider, _super);
    function AddonModQuizSyncProvider(loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, eventsProvider, timeUtils, quizProvider, quizOfflineProvider, prefetchHandler, questionProvider, questionDelegate, logHelper, prefetchDelegate, courseProvider) {
        var _this = _super.call(this, 'AddonModQuizSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils, prefetchDelegate, prefetchHandler) || this;
        _this.eventsProvider = eventsProvider;
        _this.quizProvider = quizProvider;
        _this.quizOfflineProvider = quizOfflineProvider;
        _this.prefetchHandler = prefetchHandler;
        _this.questionProvider = questionProvider;
        _this.questionDelegate = questionDelegate;
        _this.logHelper = logHelper;
        _this.courseProvider = courseProvider;
        _this.componentTranslate = courseProvider.translateModuleName('quiz');
        return _this;
    }
    AddonModQuizSyncProvider_1 = AddonModQuizSyncProvider;
    /**
     * Finish a sync process: remove offline data if needed, prefetch quiz data, set sync time and return the result.
     *
     * @param {string} siteId Site ID.
     * @param {any} quiz Quiz.
     * @param {number} courseId Course ID.
     * @param {string[]} warnings List of warnings generated by the sync.
     * @param {number} [attemptId] Last attempt ID.
     * @param {any} [offlineAttempt] Offline attempt synchronized, if any.
     * @param {any} [onlineAttempt] Online data for the offline attempt.
     * @param {boolean} [removeAttempt] Whether the offline data should be removed.
     * @param {boolean} [updated] Whether some data was sent to the site.
     * @return {Promise<AddonModQuizSyncResult>} Promise resolved on success.
     */
    AddonModQuizSyncProvider.prototype.finishSync = function (siteId, quiz, courseId, warnings, attemptId, offlineAttempt, onlineAttempt, removeAttempt, updated) {
        var _this = this;
        // Invalidate the data for the quiz and attempt.
        return this.quizProvider.invalidateAllQuizData(quiz.id, courseId, attemptId, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            if (removeAttempt && attemptId) {
                return _this.quizOfflineProvider.removeAttemptAndAnswers(attemptId, siteId);
            }
        }).then(function () {
            if (updated) {
                // Data has been sent. Update prefetched data.
                return _this.courseProvider.getModuleBasicInfoByInstance(quiz.id, 'quiz', siteId).then(function (module) {
                    return _this.prefetchAfterUpdateQuiz(module, quiz, courseId, undefined, siteId);
                }).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            return _this.setSyncTime(quiz.id, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // Check if online attempt was finished because of the sync.
            if (onlineAttempt && !_this.quizProvider.isAttemptFinished(onlineAttempt.state)) {
                // Attempt wasn't finished at start. Check if it's finished now.
                return _this.quizProvider.getUserAttempts(quiz.id, 'all', true, false, false, siteId).then(function (attempts) {
                    // Search the attempt.
                    for (var i in attempts) {
                        var attempt = attempts[i];
                        if (attempt.id == onlineAttempt.id) {
                            return _this.quizProvider.isAttemptFinished(attempt.state);
                        }
                    }
                    return false;
                });
            }
            return false;
        }).then(function (attemptFinished) {
            return {
                warnings: warnings,
                attemptFinished: attemptFinished
            };
        });
    };
    /**
     * Check if a quiz has data to synchronize.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it has data to sync.
     */
    AddonModQuizSyncProvider.prototype.hasDataToSync = function (quizId, siteId) {
        return this.quizOfflineProvider.getQuizAttempts(quizId, siteId).then(function (attempts) {
            return !!attempts.length;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Conveniece function to prefetch data after an update.
     *
     * @param {any} module Module.
     * @param {any} quiz Quiz.
     * @param {number} courseId Course ID.
     * @param {RegExp} [regex] If regex matches, don't download the data. Defaults to check files.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizSyncProvider.prototype.prefetchAfterUpdateQuiz = function (module, quiz, courseId, regex, siteId) {
        var _this = this;
        regex = regex || /^.*files$/;
        var shouldDownload;
        // Get the module updates to check if the data was updated or not.
        return this.prefetchDelegate.getModuleUpdates(module, courseId, true, siteId).then(function (result) {
            if (result && result.updates && result.updates.length > 0) {
                // Only prefetch if files haven't changed.
                shouldDownload = !result.updates.find(function (entry) {
                    return entry.name.match(regex);
                });
                if (shouldDownload) {
                    return _this.prefetchHandler.download(module, courseId, undefined, false, false);
                }
            }
        }).then(function () {
            // Prefetch finished or not needed, set the right status.
            return _this.prefetchHandler.setStatusAfterPrefetch(quiz, undefined, shouldDownload, false, siteId);
        });
    };
    /**
     * Try to synchronize all the quizzes in a certain site or in all sites.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModQuizSyncProvider.prototype.syncAllQuizzes = function (siteId, force) {
        return this.syncOnSites('all quizzes', this.syncAllQuizzesFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all quizzes on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModQuizSyncProvider.prototype.syncAllQuizzesFunc = function (siteId, force) {
        var _this = this;
        // Get all offline attempts.
        return this.quizOfflineProvider.getAllAttempts(siteId).then(function (attempts) {
            var quizzes = [], ids = [], // To prevent duplicates.
            promises = [];
            // Get the IDs of all the quizzes that have something to be synced.
            attempts.forEach(function (attempt) {
                if (ids.indexOf(attempt.quizid) == -1) {
                    ids.push(attempt.quizid);
                    quizzes.push({
                        id: attempt.quizid,
                        courseid: attempt.courseid
                    });
                }
            });
            // Sync all quizzes that haven't been synced for a while and that aren't attempted right now.
            quizzes.forEach(function (quiz) {
                if (!_this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_15__quiz__["a" /* AddonModQuizProvider */].COMPONENT, quiz.id, siteId)) {
                    // Quiz not blocked, try to synchronize it.
                    promises.push(_this.quizProvider.getQuizById(quiz.courseid, quiz.id, false, false, siteId).then(function (quiz) {
                        var promise = force ? _this.syncQuiz(quiz, false, siteId) : _this.syncQuizIfNeeded(quiz, false, siteId);
                        return promise.then(function (data) {
                            if (data && data.warnings && data.warnings.length) {
                                // Store the warnings to show them when the user opens the quiz.
                                return _this.setSyncWarnings(quiz.id, data.warnings, siteId).then(function () {
                                    return data;
                                });
                            }
                            return data;
                        }).then(function (data) {
                            if (typeof data != 'undefined') {
                                // Sync successful. Send event.
                                _this.eventsProvider.trigger(AddonModQuizSyncProvider_1.AUTO_SYNCED, {
                                    quizId: quiz.id,
                                    attemptFinished: data.attemptFinished,
                                    warnings: data.warnings
                                }, siteId);
                            }
                        });
                    }));
                }
            });
            return Promise.all(promises);
        });
    };
    /**
     * Sync a quiz only if a certain time has passed since the last time.
     *
     * @param {any} quiz Quiz.
     * @param {boolean} [askPreflight] Whether we should ask for preflight data if needed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the quiz is synced or if it doesn't need to be synced.
     */
    AddonModQuizSyncProvider.prototype.syncQuizIfNeeded = function (quiz, askPreflight, siteId) {
        var _this = this;
        return this.isSyncNeeded(quiz.id, siteId).then(function (needed) {
            if (needed) {
                return _this.syncQuiz(quiz, askPreflight, siteId);
            }
        });
    };
    /**
     * Try to synchronize a quiz.
     * The promise returned will be resolved with an array with warnings if the synchronization is successful.
     *
     * @param {any} quiz Quiz.
     * @param {boolean} [askPreflight] Whether we should ask for preflight data if needed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModQuizSyncResult>} Promise resolved in success.
     */
    AddonModQuizSyncProvider.prototype.syncQuiz = function (quiz, askPreflight, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var warnings = [], courseId = quiz.course;
        var syncPromise, preflightData;
        if (this.isSyncing(quiz.id, siteId)) {
            // There's already a sync ongoing for this quiz, return the promise.
            return this.getOngoingSync(quiz.id, siteId);
        }
        // Verify that quiz isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_15__quiz__["a" /* AddonModQuizProvider */].COMPONENT, quiz.id, siteId)) {
            this.logger.debug('Cannot sync quiz ' + quiz.id + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync quiz ' + quiz.id + ' in site ' + siteId);
        // Sync offline logs.
        syncPromise = this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_15__quiz__["a" /* AddonModQuizProvider */].COMPONENT, quiz.id, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Get all the offline attempts for the quiz.
            return _this.quizOfflineProvider.getQuizAttempts(quiz.id, siteId);
        }).then(function (attempts) {
            // Should return 0 or 1 attempt.
            if (!attempts.length) {
                return _this.finishSync(siteId, quiz, courseId, warnings);
            }
            var offlineAttempt = attempts.pop();
            // Now get the list of online attempts to make sure this attempt exists and isn't finished.
            return _this.quizProvider.getUserAttempts(quiz.id, 'all', true, false, true, siteId).then(function (attempts) {
                var lastAttemptId = attempts.length ? attempts[attempts.length - 1].id : undefined;
                var onlineAttempt;
                // Search the attempt we retrieved from offline.
                for (var i in attempts) {
                    var attempt = attempts[i];
                    if (attempt.id == offlineAttempt.id) {
                        onlineAttempt = attempt;
                        break;
                    }
                }
                if (!onlineAttempt || _this.quizProvider.isAttemptFinished(onlineAttempt.state)) {
                    // Attempt not found or it's finished in online. Discard it.
                    warnings.push(_this.translate.instant('addon.mod_quiz.warningattemptfinished'));
                    return _this.finishSync(siteId, quiz, courseId, warnings, offlineAttempt.id, offlineAttempt, onlineAttempt, true);
                }
                // Get the data stored in offline.
                return _this.quizOfflineProvider.getAttemptAnswers(offlineAttempt.id, siteId).then(function (answersList) {
                    if (!answersList.length) {
                        // No answers stored, finish.
                        return _this.finishSync(siteId, quiz, courseId, warnings, lastAttemptId, offlineAttempt, onlineAttempt, true);
                    }
                    var answers = _this.questionProvider.convertAnswersArrayToObject(answersList), offlineQuestions = _this.quizOfflineProvider.classifyAnswersInQuestions(answers);
                    var finish;
                    // We're going to need preflightData, get it.
                    return _this.quizProvider.getQuizAccessInformation(quiz.id, false, true, siteId).then(function (info) {
                        return _this.prefetchHandler.getPreflightData(quiz, info, onlineAttempt, askPreflight, 'core.settings.synchronization', siteId);
                    }).then(function (data) {
                        preflightData = data;
                        // Now get the online questions data.
                        var pages = _this.quizProvider.getPagesFromLayoutAndQuestions(onlineAttempt.layout, offlineQuestions);
                        return _this.quizProvider.getAllQuestionsData(quiz, onlineAttempt, preflightData, pages, false, true, siteId);
                    }).then(function (onlineQuestions) {
                        // Validate questions, discarding the offline answers that can't be synchronized.
                        return _this.validateQuestions(onlineAttempt.id, onlineQuestions, offlineQuestions, siteId);
                    }).then(function (discardedData) {
                        // Get the answers to send.
                        var answers = _this.quizOfflineProvider.extractAnswersFromQuestions(offlineQuestions);
                        finish = offlineAttempt.finished && !discardedData;
                        if (discardedData) {
                            if (offlineAttempt.finished) {
                                warnings.push(_this.translate.instant('addon.mod_quiz.warningdatadiscardedfromfinished'));
                            }
                            else {
                                warnings.push(_this.translate.instant('addon.mod_quiz.warningdatadiscarded'));
                            }
                        }
                        return _this.quizProvider.processAttempt(quiz, onlineAttempt, answers, preflightData, finish, false, false, siteId);
                    }).then(function () {
                        // Answers sent, now set the current page if the attempt isn't finished.
                        if (!finish) {
                            // Don't pass the quiz instance because we don't want to trigger a Firebase event in this case.
                            return _this.quizProvider.logViewAttempt(onlineAttempt.id, offlineAttempt.currentpage, preflightData, false, undefined, siteId).catch(function () {
                                // Ignore errors.
                            });
                        }
                    }).then(function () {
                        // Data sent. Finish the sync.
                        return _this.finishSync(siteId, quiz, courseId, warnings, lastAttemptId, offlineAttempt, onlineAttempt, true, true);
                    });
                });
            });
        });
        return this.addOngoingSync(quiz.id, syncPromise, siteId);
    };
    /**
     * Validate questions, discarding the offline answers that can't be synchronized.
     *
     * @param {number} attemptId Attempt ID.
     * @param {any} onlineQuestions Online questions
     * @param {any} offlineQuestions Offline questions.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if some offline data was discarded, false otherwise.
     */
    AddonModQuizSyncProvider.prototype.validateQuestions = function (attemptId, onlineQuestions, offlineQuestions, siteId) {
        var promises = [];
        var discardedData = false;
        for (var slot in offlineQuestions) {
            var offlineQuestion = offlineQuestions[slot], onlineQuestion = onlineQuestions[slot], offlineSequenceCheck = offlineQuestion.answers[':sequencecheck'];
            if (onlineQuestion) {
                // We found the online data for the question, validate that the sequence check is ok.
                if (!this.questionDelegate.validateSequenceCheck(onlineQuestion, offlineSequenceCheck)) {
                    // Sequence check is not valid, remove the offline data.
                    discardedData = true;
                    promises.push(this.quizOfflineProvider.removeQuestionAndAnswers(attemptId, Number(slot), siteId));
                    delete offlineQuestions[slot];
                }
                else {
                    // Sequence check is valid. Use the online one to prevent synchronization errors.
                    offlineQuestion.answers[':sequencecheck'] = onlineQuestion.sequencecheck;
                }
            }
            else {
                // Online question not found, it can happen for 2 reasons:
                // 1- It's a sequential quiz and the question is in a page already passed.
                // 2- Quiz layout has changed (shouldn't happen since it's blocked if there are attempts).
                discardedData = true;
                promises.push(this.quizOfflineProvider.removeQuestionAndAnswers(attemptId, Number(slot), siteId));
                delete offlineQuestions[slot];
            }
        }
        return Promise.all(promises).then(function () {
            return discardedData;
        });
    };
    AddonModQuizSyncProvider.AUTO_SYNCED = 'addon_mod_quiz_autom_synced';
    AddonModQuizSyncProvider = AddonModQuizSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_15__quiz__["a" /* AddonModQuizProvider */], __WEBPACK_IMPORTED_MODULE_16__quiz_offline__["a" /* AddonModQuizOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_17__prefetch_handler__["a" /* AddonModQuizPrefetchHandler */], __WEBPACK_IMPORTED_MODULE_12__core_question_providers_question__["a" /* CoreQuestionProvider */],
            __WEBPACK_IMPORTED_MODULE_13__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_10__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_9__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModQuizSyncProvider);
    return AddonModQuizSyncProvider;
    var AddonModQuizSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__["a" /* CoreCourseActivitySyncBaseProvider */]));

//# sourceMappingURL=quiz-sync.js.map

/***/ }),
/* 190 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__notes_offline__ = __webpack_require__(380);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service to handle notes.
 */
var AddonNotesProvider = /** @class */ (function () {
    function AddonNotesProvider(logger, sitesProvider, appProvider, utils, translate, userProvider, notesOffline, pushNotificationsProvider) {
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.utils = utils;
        this.translate = translate;
        this.userProvider = userProvider;
        this.notesOffline = notesOffline;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.ROOT_CACHE_KEY = 'mmaNotes:';
        this.logger = logger.getInstance('AddonNotesProvider');
    }
    /**
     * Add a note.
     *
     * @param  {number} userId       User ID of the person to add the note.
     * @param  {number} courseId     Course ID where the note belongs.
     * @param  {string} publishState Personal, Site or Course.
     * @param  {string} noteText     The note text.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<boolean>}    Promise resolved with boolean: true if note was sent to server, false if stored in device.
     */
    AddonNotesProvider.prototype.addNote = function (userId, courseId, publishState, noteText, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a note to be synchronized later.
        var storeOffline = function () {
            return _this.notesOffline.saveNote(userId, courseId, publishState, noteText, siteId).then(function () {
                return false;
            });
        };
        if (!this.appProvider.isOnline()) {
            // App is offline, store the note.
            return storeOffline();
        }
        // Send note to server.
        return this.addNoteOnline(userId, courseId, publishState, noteText, siteId).then(function () {
            return true;
        }).catch(function (error) {
            if (_this.utils.isWebServiceError(error)) {
                // It's a WebService error, the user cannot send the message so don't store it.
                return Promise.reject(error);
            }
            // Error sending note, store it to retry later.
            return storeOffline();
        });
    };
    /**
     * Add a note. It will fail if offline or cannot connect.
     *
     * @param  {number} userId       User ID of the person to add the note.
     * @param  {number} courseId     Course ID where the note belongs.
     * @param  {string} publishState Personal, Site or Course.
     * @param  {string} noteText     The note text.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when added, rejected otherwise.
     */
    AddonNotesProvider.prototype.addNoteOnline = function (userId, courseId, publishState, noteText, siteId) {
        var _this = this;
        var notes = [
            {
                courseid: courseId,
                format: 1,
                publishstate: publishState,
                text: noteText,
                userid: userId
            }
        ];
        return this.addNotesOnline(notes, siteId).then(function (response) {
            if (response && response[0] && response[0].noteid === -1) {
                // There was an error, and it should be translated already.
                return Promise.reject(_this.utils.createFakeWSError(response[0].errormessage));
            }
            // A note was added, invalidate the course notes.
            return _this.invalidateNotes(courseId, undefined, siteId).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Add several notes. It will fail if offline or cannot connect.
     *
     * @param  {any[]}  notes    Notes to save.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when added, rejected otherwise. Promise resolved doesn't mean that notes
     *                           have been added, the resolve param can contain errors for notes not sent.
     */
    AddonNotesProvider.prototype.addNotesOnline = function (notes, siteId) {
        if (!notes || !notes.length) {
            return Promise.resolve();
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                notes: notes
            };
            return site.write('core_notes_create_notes', data);
        });
    };
    /**
     * Returns whether or not the notes plugin is enabled for a certain site.
     *
     * This method is called quite often and thus should only perform a quick
     * check, we should not be calling WS from here.
     *
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if enabled, resolved with false or rejected otherwise.
     */
    AddonNotesProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.canUseAdvancedFeature('enablenotes');
        });
    };
    /**
     * Returns whether or not the add note plugin is enabled for a certain course.
     *
     * @param  {number} courseId  ID of the course.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if enabled, resolved with false or rejected otherwise.
     */
    AddonNotesProvider.prototype.isPluginAddNoteEnabledForCourse = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // The only way to detect if it's enabled is to perform a WS call.
            // We use an invalid user ID (-1) to avoid saving the note if the user has permissions.
            var data = {
                notes: [
                    {
                        userid: -1,
                        publishstate: 'personal',
                        courseid: courseId,
                        text: '',
                        format: 1
                    }
                ]
            }, preSets = {
                updateFrequency: __WEBPACK_IMPORTED_MODULE_5__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            /* Use .read to cache data and be able to check it in offline. This means that, if a user loses the capabilities
               to add notes, he'll still see the option in the app. */
            return _this.utils.promiseWorks(site.read('core_notes_create_notes', data, preSets));
        });
    };
    /**
     * Returns whether or not the read notes plugin is enabled for a certain course.
     *
     * @param  {number} courseId  ID of the course.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if enabled, resolved with false or rejected otherwise.
     */
    AddonNotesProvider.prototype.isPluginViewNotesEnabledForCourse = function (courseId, siteId) {
        return this.utils.promiseWorks(this.getNotes(courseId, undefined, false, true, siteId));
    };
    /**
     * Get prefix cache key for course notes.
     *
     * @param  {number} courseId ID of the course to get the notes from.
     * @return {string}          Cache key.
     */
    AddonNotesProvider.prototype.getNotesPrefixCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'notes:' + courseId + ':';
    };
    /**
     * Get the cache key for the get notes call.
     *
     * @param  {number} courseId ID of the course to get the notes from.
     * @param  {number}  [userId]      ID of the user to get the notes from if requested.
     * @return {string}          Cache key.
     */
    AddonNotesProvider.prototype.getNotesCacheKey = function (courseId, userId) {
        return this.getNotesPrefixCacheKey(courseId) + (userId ? userId : '');
    };
    /**
     * Get users notes for a certain site, course and personal notes.
     *
     * @param  {number}  courseId      ID of the course to get the notes from.
     * @param  {number}  [userId]      ID of the user to get the notes from if requested.
     * @param  {boolean} [ignoreCache] True when we should not get the value from the cache.
     * @param  {boolean} [onlyOnline]  True to return only online notes, false to return both online and offline.
     * @param  {string}  [siteId]      Site ID. If not defined, current site.
     * @return {Promise<any>}          Promise to be resolved when the notes are retrieved.
     */
    AddonNotesProvider.prototype.getNotes = function (courseId, userId, ignoreCache, onlyOnline, siteId) {
        var _this = this;
        this.logger.debug('Get notes for course ' + courseId);
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                courseid: courseId
            };
            if (userId) {
                data['userid'] = userId;
            }
            var preSets = {
                cacheKey: _this.getNotesCacheKey(courseId, userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_5__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('core_notes_get_course_notes', data, preSets).then(function (notes) {
                if (onlyOnline) {
                    return notes;
                }
                // Get offline notes and add them to the list.
                return _this.notesOffline.getNotesForCourseAndUser(courseId, userId, siteId).then(function (offlineNotes) {
                    offlineNotes.forEach(function (note) {
                        var fieldName = note.publishstate + 'notes';
                        if (!notes[fieldName]) {
                            notes[fieldName] = [];
                        }
                        note.offline = true;
                        // Add note to the start of array since last notes are shown first.
                        notes[fieldName].unshift(note);
                    });
                    return notes;
                });
            });
        });
    };
    /**
     * Get user data for notes since they only have userid.
     *
     * @param  {any[]}  notes    Notes to get the data for.
     * @param  {number} courseId ID of the course the notes belong to.
     * @return {Promise<any>}    Promise always resolved. Resolve param is the formatted notes.
     */
    AddonNotesProvider.prototype.getNotesUserData = function (notes, courseId) {
        var _this = this;
        var promises = notes.map(function (note) {
            // Get the user profile to retrieve the user image.
            return _this.userProvider.getProfile(note.userid, note.courseid, true).then(function (user) {
                note.userfullname = user.fullname;
                note.userprofileimageurl = user.profileimageurl || null;
            }).catch(function () {
                note.userfullname = _this.translate.instant('addon.notes.userwithid', { id: note.userid });
            });
        });
        return Promise.all(promises).then(function () {
            return notes;
        });
    };
    /**
     * Invalidate get notes WS call.
     *
     * @param  {number} courseId Course ID.
     * @param  {number} [userId] User ID if needed.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when data is invalidated.
     */
    AddonNotesProvider.prototype.invalidateNotes = function (courseId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (userId) {
                return site.invalidateWsCacheForKey(_this.getNotesCacheKey(courseId, userId));
            }
            return site.invalidateWsCacheForKeyStartingWith(_this.getNotesPrefixCacheKey(courseId));
        });
    };
    /**
     * Report notes as being viewed.
     *
     * @param {number} courseId  ID of the course.
     * @param {number} [userId]  User ID if needed.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonNotesProvider.prototype.logView = function (courseId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseid: courseId,
                userid: userId || 0
            };
            _this.pushNotificationsProvider.logViewListEvent('notes', 'core_notes_view_notes', params, site.getId());
            return site.write('core_notes_view_notes', params);
        });
    };
    AddonNotesProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_8__notes_offline__["a" /* AddonNotesOfflineProvider */], __WEBPACK_IMPORTED_MODULE_9__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], AddonNotesProvider);
    return AddonNotesProvider;
}());

//# sourceMappingURL=notes.js.map

/***/ }),
/* 191 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Service to handle Offline data.
 */
var AddonModDataOfflineProvider = /** @class */ (function () {
    function AddonModDataOfflineProvider(logger, sitesProvider, textUtils, fileProvider, fileUploaderProvider, utils) {
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.fileProvider = fileProvider;
        this.fileUploaderProvider = fileUploaderProvider;
        this.utils = utils;
        this.siteSchema = {
            name: 'AddonModDataOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE,
                    columns: [
                        {
                            name: 'dataid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'groupid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'action',
                            type: 'TEXT'
                        },
                        {
                            name: 'entryid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'fields',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['dataid', 'entryid', 'action']
                }
            ],
            migrate: function (db, oldVersion, siteId) {
                if (oldVersion == 0) {
                    // Move the records from the old table.
                    var newTable_1 = AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE;
                    var oldTable_1 = 'addon_mod_data_entry';
                    return db.tableExists(oldTable_1).then(function () {
                        return db.insertRecordsFrom(newTable_1, oldTable_1).then(function () {
                            return db.dropTable(oldTable_1);
                        });
                    }).catch(function () {
                        // Old table does not exist, ignore.
                    });
                }
            }
        };
        this.logger = logger.getInstance('AddonModDataOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModDataOfflineProvider_1 = AddonModDataOfflineProvider;
    /**
     * Delete all the actions of an entry.
     *
     * @param  {number} dataId   Database ID.
     * @param  {number} entryId  Database entry ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved if deleted, rejected if failure.
     */
    AddonModDataOfflineProvider.prototype.deleteAllEntryActions = function (dataId, entryId, siteId) {
        var _this = this;
        return this.getEntryActions(dataId, entryId, siteId).then(function (actions) {
            var promises = [];
            actions.forEach(function (action) {
                promises.push(_this.deleteEntry(dataId, entryId, action.action, siteId));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Delete an stored entry.
     *
     * @param  {number} dataId       Database ID.
     * @param  {number} entryId      Database entry Id.
     * @param  {string} action       Action to be done
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}             Promise resolved if deleted, rejected if failure.
     */
    AddonModDataOfflineProvider.prototype.deleteEntry = function (dataId, entryId, action, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.deleteEntryFiles(dataId, entryId, action, site.id).then(function () {
                return site.getDb().deleteRecords(AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE, { dataid: dataId, entryid: entryId,
                    action: action });
            });
        });
    };
    /**
     * Delete entry offline files.
     *
     * @param  {number} dataId Database ID.
     * @param  {number} entryId Database entry ID.
     * @param  {string} action Action to be done.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if deleted, rejected if failure.
     */
    AddonModDataOfflineProvider.prototype.deleteEntryFiles = function (dataId, entryId, action, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.getEntry(dataId, entryId, action, site.id).then(function (entry) {
                if (!entry.fields) {
                    return;
                }
                var promises = [];
                entry.fields.forEach(function (field) {
                    var value = _this.textUtils.parseJSON(field.value);
                    if (!value.offline) {
                        return;
                    }
                    var promise = _this.getEntryFieldFolder(dataId, entryId, field.fieldid, site.id).then(function (folderPath) {
                        return _this.fileUploaderProvider.getStoredFiles(folderPath);
                    }).then(function (files) {
                        return _this.fileUploaderProvider.clearTmpFiles(files);
                    }).catch(function () {
                        // Files not found, ignore.
                    });
                    promises.push(promise);
                });
                return Promise.all(promises);
            }).catch(function () {
                // Entry not found, ignore.
            });
        });
    };
    /**
     * Get all the stored entry data from all the databases.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModDataOfflineAction[]>} Promise resolved with entries.
     */
    AddonModDataOfflineProvider.prototype.getAllEntries = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getAllRecords(AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE);
        }).then(function (entries) {
            return entries.map(_this.parseRecord.bind(_this));
        });
    };
    /**
     * Get all the stored entry actions from a certain database, sorted by modification time.
     *
     * @param  {number} dataId Database ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModDataOfflineAction[]>} Promise resolved with entries.
     */
    AddonModDataOfflineProvider.prototype.getDatabaseEntries = function (dataId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE, { dataid: dataId }, 'timemodified');
        }).then(function (entries) {
            return entries.map(_this.parseRecord.bind(_this));
        });
    };
    /**
     * Get an stored entry data.
     *
     * @param  {number} dataId      Database ID.
     * @param  {number} entryId     Database entry Id.
     * @param  {string} action      Action to be done
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<AddonModDataOfflineAction>} Promise resolved with entry.
     */
    AddonModDataOfflineProvider.prototype.getEntry = function (dataId, entryId, action, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE, { dataid: dataId, entryid: entryId,
                action: action });
        }).then(function (entry) {
            return _this.parseRecord(entry);
        });
    };
    /**
     * Get an all stored entry actions data.
     *
     * @param  {number} dataId      Database ID.
     * @param  {number} entryId     Database entry Id.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<AddonModDataOfflineAction[]>} Promise resolved with entry actions.
     */
    AddonModDataOfflineProvider.prototype.getEntryActions = function (dataId, entryId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE, { dataid: dataId, entryid: entryId });
        }).then(function (entries) {
            return entries.map(_this.parseRecord.bind(_this));
        });
    };
    /**
     * Check if there are offline entries to send.
     *
     * @param  {number} dataId    Database ID.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>}          Promise resolved with boolean: true if has offline answers, false otherwise.
     */
    AddonModDataOfflineProvider.prototype.hasOfflineData = function (dataId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.utils.promiseWorks(site.getDb().recordExists(AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE, { dataid: dataId }));
        });
    };
    /**
     * Get the path to the folder where to store files for offline files in a database.
     *
     * @param  {number} dataId      Database ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<string>}    Promise resolved with the path.
     */
    AddonModDataOfflineProvider.prototype.getDatabaseFolder = function (dataId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var siteFolderPath = _this.fileProvider.getSiteFolder(site.getId()), folderPath = 'offlinedatabase/' + dataId;
            return _this.textUtils.concatenatePaths(siteFolderPath, folderPath);
        });
    };
    /**
     * Get the path to the folder where to store files for a new offline entry.
     *
     * @param  {number} dataId      Database ID.
     * @param  {number} entryId     The ID of the entry.
     * @param  {number} fieldId     Field ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<string>}    Promise resolved with the path.
     */
    AddonModDataOfflineProvider.prototype.getEntryFieldFolder = function (dataId, entryId, fieldId, siteId) {
        var _this = this;
        return this.getDatabaseFolder(dataId, siteId).then(function (folderPath) {
            return _this.textUtils.concatenatePaths(folderPath, entryId + '_' + fieldId);
        });
    };
    /**
     * Parse "fields" of an offline record.
     *
     * @param {any} record Record object
     * @return {AddonModDataOfflineAction} Record object with columns parsed.
     */
    AddonModDataOfflineProvider.prototype.parseRecord = function (record) {
        record.fields = this.textUtils.parseJSON(record.fields);
        return record;
    };
    /**
     * Save an entry data to be sent later.
     *
     * @param  {number} dataId          Database ID.
     * @param  {number} entryId         Database entry Id. If action is add entryId should be 0 and -timemodified will be used.
     * @param  {string} action          Action to be done to the entry: [add, edit, delete, approve, disapprove]
     * @param  {number} courseId        Course ID of the database.
     * @param  {number} [groupId]       Group ID. Only provided when adding.
     * @param  {any[]}  [fields]        Array of field data of the entry if needed.
     * @param  {number} [timemodified]  The time the entry was modified. If not defined, current time.
     * @param  {string} [siteId]        Site ID. If not defined, current site.
     * @return {Promise<any>}           Promise resolved if stored, rejected if failure.
     */
    AddonModDataOfflineProvider.prototype.saveEntry = function (dataId, entryId, action, courseId, groupId, fields, timemodified, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            timemodified = timemodified || new Date().getTime();
            entryId = typeof entryId == 'undefined' || entryId === null ? -timemodified : entryId;
            var entry = {
                dataid: dataId,
                courseid: courseId,
                groupid: groupId,
                action: action,
                entryid: entryId,
                fields: JSON.stringify(fields || []),
                timemodified: timemodified
            };
            return site.getDb().insertRecord(AddonModDataOfflineProvider_1.DATA_ENTRY_TABLE, entry);
        });
    };
    // Variables for database.
    AddonModDataOfflineProvider.DATA_ENTRY_TABLE = 'addon_mod_data_entry_1';
    AddonModDataOfflineProvider = AddonModDataOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_6__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModDataOfflineProvider);
    return AddonModDataOfflineProvider;
    var AddonModDataOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 192 */,
/* 193 */,
/* 194 */,
/* 195 */,
/* 196 */,
/* 197 */,
/* 198 */,
/* 199 */,
/* 200 */,
/* 201 */,
/* 202 */,
/* 203 */,
/* 204 */,
/* 205 */,
/* 206 */,
/* 207 */,
/* 208 */,
/* 209 */,
/* 210 */,
/* 211 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreEmulatorHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_file__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_local_notifications__ = __webpack_require__(255);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__file_transfer__ = __webpack_require__(766);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__capture_helper__ = __webpack_require__(258);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Helper service for the emulator feature. It also acts as an init handler.
 */
var CoreEmulatorHelperProvider = /** @class */ (function () {
    function CoreEmulatorHelperProvider(file, fileProvider, utils, logger, sitesProvider, localNotif, captureHelper, timeUtils, appProvider, localNotifProvider) {
        this.file = file;
        this.fileProvider = fileProvider;
        this.utils = utils;
        this.sitesProvider = sitesProvider;
        this.localNotif = localNotif;
        this.captureHelper = captureHelper;
        this.timeUtils = timeUtils;
        this.appProvider = appProvider;
        this.localNotifProvider = localNotifProvider;
        this.name = 'CoreEmulator';
        this.priority = __WEBPACK_IMPORTED_MODULE_6__providers_init__["a" /* CoreInitDelegate */].MAX_RECOMMENDED_PRIORITY + 500;
        this.blocking = true;
        // Variables for database.
        this.LAST_RECEIVED_NOTIFICATION_TABLE = 'core_emulator_last_received_notification';
        this.siteSchema = {
            name: 'CoreEmulatorHelperProvider',
            version: 1,
            tables: [
                {
                    name: this.LAST_RECEIVED_NOTIFICATION_TABLE,
                    columns: [
                        {
                            name: 'component',
                            type: 'TEXT'
                        },
                        {
                            name: 'id',
                            type: 'INTEGER',
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER',
                        },
                    ],
                    primaryKeys: ['component']
                }
            ]
        };
        this.logger = logger.getInstance('CoreEmulatorHelper');
        sitesProvider.registerSiteSchema(this.siteSchema);
    }
    /**
     * Load the Mocks that need it.
     *
     * @return {Promise<void>} Promise resolved when loaded.
     */
    CoreEmulatorHelperProvider.prototype.load = function () {
        var _this = this;
        var promises = [];
        promises.push(this.file.load().then(function (basePath) {
            _this.fileProvider.setHTMLBasePath(basePath);
        }));
        promises.push(this.localNotif.load());
        promises.push(this.captureHelper.load());
        window.FileTransferError = __WEBPACK_IMPORTED_MODULE_11__file_transfer__["a" /* FileTransferErrorMock */];
        return this.utils.allPromises(promises);
    };
    /**
     * Check if there are new notifications, triggering a local notification if found.
     * Only for desktop apps since they don't support push notifications.
     *
     * @param  {string}   component Component to check.
     * @param  {Function} fetchFn   Function that receives a site ID and returns a Promise resolved with an array of notifications.
     * @param  {Function} getDataFn Function that receives a notification and returns a promise resolved with the title and text.
     * @param  {string}   [siteId]  Site ID to check. If not defined, check all sites.
     * @return {Promise<any>}       Promise resolved when done.
     */
    CoreEmulatorHelperProvider.prototype.checkNewNotifications = function (component, fetchFn, getDataFn, siteId) {
        var _this = this;
        if (!this.appProvider.isDesktop() || !this.localNotifProvider.isAvailable()) {
            return Promise.resolve(null);
        }
        if (!this.appProvider.isOnline()) {
            this.logger.debug('Cannot check push notifications because device is offline.');
            return Promise.reject(null);
        }
        var promise;
        if (!siteId) {
            // No site ID defined, check all sites.
            promise = this.sitesProvider.getSitesIds();
        }
        else {
            promise = Promise.resolve([siteId]);
        }
        return promise.then(function (siteIds) {
            var sitePromises = siteIds.map(function (siteId) {
                // Check new notifications for each site.
                return _this.checkNewNotificationsForSite(component, fetchFn, getDataFn, siteId);
            });
            return Promise.all(sitePromises);
        });
    };
    /**
     * Check if there are new notifications for a certain site, triggering a local notification if found.
     *
     * @param  {string}   component Component to check.
     * @param  {Function} fetchFn   Function that receives a site ID and returns a Promise resolved with an array of notifications.
     * @param  {Function} getDataFn Function that receives a notification and returns a promise resolved with the title and text.
     * @param  {string}   siteId    Site ID to check.
     * @return {Promise<any>}       Promise resolved when done.
     */
    CoreEmulatorHelperProvider.prototype.checkNewNotificationsForSite = function (component, fetchFn, getDataFn, siteId) {
        var _this = this;
        // Get the last received notification in the app.
        return this.getLastReceivedNotification(component, siteId).then(function (lastNotification) {
            // Now fetch the latest notifications from the server.
            return fetchFn(siteId).then(function (notifications) {
                if (!lastNotification || !notifications.length) {
                    // No last notification stored (first call) or no new notifications. Stop.
                    return;
                }
                var notification = notifications[0];
                if (notification.id == lastNotification.id || notification.timecreated <= lastNotification.timecreated ||
                    _this.timeUtils.timestamp() - notification.timecreated > __WEBPACK_IMPORTED_MODULE_13__constants__["a" /* CoreConstants */].SECONDS_DAY) {
                    // There are no new notifications or the newest one happened more than a day ago, stop.
                    return;
                }
                // There is a new notification, show it.
                return getDataFn(notification).then(function (titleAndText) {
                    // Set some calculated data.
                    notification.site = siteId;
                    notification.name = notification.name || notification.eventtype;
                    var localNotif = {
                        id: 1,
                        title: titleAndText.title,
                        text: titleAndText.text,
                        data: notification
                    };
                    return _this.localNotifProvider.schedule(localNotif, component, siteId);
                });
            });
        });
    };
    /**
     * Get the last notification received in a certain site for a certain component.
     *
     * @param  {string} component Component of the notification to get.
     * @param  {string} siteId    Site ID of the notification.
     * @return {Promise<any>}     Promise resolved with the notification or false if not found.
     */
    CoreEmulatorHelperProvider.prototype.getLastReceivedNotification = function (component, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(_this.LAST_RECEIVED_NOTIFICATION_TABLE, { component: component });
        }).catch(function () {
            return false;
        });
    };
    /**
     * Store the last notification received in a certain site.
     *
     * @param  {string} component    Component of the notification to store.
     * @param  {any}    notification Notification to store.
     * @param  {string} siteId       Site ID of the notification.
     * @return {Promise<any>}        Promise resolved when done.
     */
    CoreEmulatorHelperProvider.prototype.storeLastReceivedNotification = function (component, notification, siteId) {
        var _this = this;
        if (!notification) {
            // No notification, store a fake one.
            notification = { id: -1, timecreated: 0 };
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                component: component,
                id: notification.id,
                timecreated: notification.timecreated,
            };
            return site.getDb().insertRecord(_this.LAST_RECEIVED_NOTIFICATION_TABLE, entry);
        });
    };
    CoreEmulatorHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__ionic_native_file__["a" /* File */], __WEBPACK_IMPORTED_MODULE_1__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__ionic_native_local_notifications__["a" /* LocalNotifications */],
            __WEBPACK_IMPORTED_MODULE_12__capture_helper__["a" /* CoreEmulatorCaptureHelperProvider */], __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */]])
    ], CoreEmulatorHelperProvider);
    return CoreEmulatorHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 212 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModBookProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Service that provides some features for books.
 */
var AddonModBookProvider = /** @class */ (function () {
    function AddonModBookProvider(logger, sitesProvider, textUtils, fileProvider, filepoolProvider, http, utils, courseProvider, domUtils, logHelper) {
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.fileProvider = fileProvider;
        this.filepoolProvider = filepoolProvider;
        this.http = http;
        this.utils = utils;
        this.courseProvider = courseProvider;
        this.domUtils = domUtils;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModBook:';
        this.logger = logger.getInstance('AddonModBookProvider');
    }
    AddonModBookProvider_1 = AddonModBookProvider;
    /**
     * Get a book by course module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the book is retrieved.
     */
    AddonModBookProvider.prototype.getBook = function (courseId, cmId, siteId) {
        return this.getBookByField(courseId, 'coursemodule', cmId, siteId);
    };
    /**
     * Get a book with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the book is retrieved.
     */
    AddonModBookProvider.prototype.getBookByField = function (courseId, key, value, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getBookDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_11__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_book_get_books_by_courses', params, preSets).then(function (response) {
                // Search the book.
                if (response && response.books) {
                    for (var i in response.books) {
                        var book = response.books[i];
                        if (book[key] == value) {
                            return book;
                        }
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get book data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModBookProvider.prototype.getBookDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'book:' + courseId;
    };
    /**
     * Gets a chapter contents.
     *
     * @param {AddonModBookContentsMap} contentsMap Contents map returned by getContentsMap.
     * @param {string} chapterId Chapter to retrieve.
     * @param {number} moduleId The module ID.
     * @return {Promise<string>} Promise resolved with the contents.
     */
    AddonModBookProvider.prototype.getChapterContent = function (contentsMap, chapterId, moduleId) {
        var _this = this;
        var indexUrl = contentsMap[chapterId] ? contentsMap[chapterId].indexUrl : undefined, siteId = this.sitesProvider.getCurrentSiteId();
        var promise;
        if (!indexUrl) {
            // It shouldn't happen.
            this.logger.debug('Could not locate the index chapter');
            return Promise.reject(null);
        }
        if (this.fileProvider.isAvailable()) {
            promise = this.filepoolProvider.downloadUrl(siteId, indexUrl, false, AddonModBookProvider_1.COMPONENT, moduleId);
        }
        else {
            // We return the live URL.
            return Promise.resolve(this.sitesProvider.getCurrentSite().fixPluginfileURL(indexUrl));
        }
        return promise.then(function (url) {
            // Fetch the URL content.
            var promise = _this.http.get(url).toPromise();
            return promise.then(function (response) {
                var content = response.text();
                if (typeof content !== 'string') {
                    return Promise.reject(null);
                }
                else {
                    // Now that we have the content, we update the SRC to point back to the external resource.
                    return _this.domUtils.restoreSourcesInHtml(content, contentsMap[chapterId].paths);
                }
            });
        });
    };
    /**
     * Convert an array of book contents into an object where contents are organized in chapters.
     * Each chapter has an indexUrl and the list of contents in that chapter.
     *
     * @param {any[]} contents The module contents.
     * @return {AddonModBookContentsMap} Contents map.
     */
    AddonModBookProvider.prototype.getContentsMap = function (contents) {
        var _this = this;
        var map = {};
        if (!contents) {
            return map;
        }
        contents.forEach(function (content) {
            if (_this.isFileDownloadable(content)) {
                var chapter = void 0, matches = void 0, split = void 0, filepathIsChapter = void 0, key = void 0;
                // Search the chapter number in the filepath.
                matches = content.filepath.match(/\/(\d+)\//);
                if (matches && matches[1]) {
                    chapter = matches[1];
                    filepathIsChapter = content.filepath == '/' + chapter + '/';
                    // Init the chapter if it's not defined yet.
                    map[chapter] = map[chapter] || { paths: {} };
                    if (content.filename == 'index.html' && filepathIsChapter) {
                        // Index of the chapter, set indexUrl of the chapter.
                        map[chapter].indexUrl = content.fileurl;
                    }
                    else {
                        if (filepathIsChapter) {
                            // It's a file in the root folder OR the WS isn't returning the filepath as it should (MDL-53671).
                            // Try to get the path to the file from the URL.
                            split = content.fileurl.split('mod_book/chapter' + content.filepath);
                            key = split[1] || content.filename; // Use filename if we couldn't find the path.
                        }
                        else {
                            // Remove the chapter folder from the path and add the filename.
                            key = content.filepath.replace('/' + chapter + '/', '') + content.filename;
                        }
                        map[chapter].paths[_this.textUtils.decodeURIComponent(key)] = content.fileurl;
                    }
                }
            }
        });
        return map;
    };
    /**
     * Get the first chapter of a book.
     *
     * @param {AddonModBookTocChapter[]} chapters The chapters list.
     * @return {string} The chapter id.
     */
    AddonModBookProvider.prototype.getFirstChapter = function (chapters) {
        if (!chapters || !chapters.length) {
            return;
        }
        return chapters[0].id;
    };
    /**
     * Get the next chapter to the given one.
     *
     * @param {AddonModBookTocChapter[]} chapters The chapters list.
     * @param {string} chapterId The current chapter.
     * @return {string} The next chapter id.
     */
    AddonModBookProvider.prototype.getNextChapter = function (chapters, chapterId) {
        var next = '0';
        for (var i = 0; i < chapters.length; i++) {
            if (chapters[i].id == chapterId) {
                if (typeof chapters[i + 1] != 'undefined') {
                    next = chapters[i + 1].id;
                    break;
                }
            }
        }
        return next;
    };
    /**
     * Get the previous chapter to the given one.
     *
     * @param {AddonModBookTocChapter[]} chapters The chapters list.
     * @param {string} chapterId The current chapter.
     * @return {string} The next chapter id.
     */
    AddonModBookProvider.prototype.getPreviousChapter = function (chapters, chapterId) {
        var previous = '0';
        for (var i = 0; i < chapters.length; i++) {
            if (chapters[i].id == chapterId) {
                break;
            }
            previous = chapters[i].id;
        }
        return previous;
    };
    /**
     * Get the book toc as an array.
     *
     * @param {any[]} contents The module contents.
     * @return {any[]} The toc.
     */
    AddonModBookProvider.prototype.getToc = function (contents) {
        if (!contents || !contents.length) {
            return [];
        }
        return this.textUtils.parseJSON(contents[0].content, []);
    };
    /**
     * Get the book toc as an array of chapters (not nested).
     *
     * @param {any[]} contents The module contents.
     * @return {AddonModBookTocChapter[]} The toc as a list.
     */
    AddonModBookProvider.prototype.getTocList = function (contents) {
        var chapters = [], toc = this.getToc(contents);
        toc.forEach(function (chapter) {
            // Add the chapter to the list.
            var chapterId = chapter.href.replace('/index.html', '');
            chapters.push({ id: chapterId, title: chapter.title, level: chapter.level });
            if (chapter.subitems) {
                // Add all the subchapters to the list.
                chapter.subitems.forEach(function (subChapter) {
                    chapterId = subChapter.href.replace('/index.html', '');
                    chapters.push({ id: chapterId, title: subChapter.title, level: subChapter.level });
                });
            }
        });
        return chapters;
    };
    /**
     * Invalidates book data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModBookProvider.prototype.invalidateBookData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getBookDataCacheKey(courseId));
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID of the module.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModBookProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.invalidateBookData(courseId, siteId));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModBookProvider_1.COMPONENT, moduleId));
        promises.push(this.courseProvider.invalidateModule(moduleId, siteId));
        return this.utils.allPromises(promises);
    };
    /**
     * Check if a file is downloadable. The file param must have a 'type' attribute like in core_course_get_contents response.
     *
     * @param {any} file File to check.
     * @return {boolean} Whether it's downloadable.
     */
    AddonModBookProvider.prototype.isFileDownloadable = function (file) {
        return file.type === 'file';
    };
    /**
     * Return whether or not the plugin is enabled.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonModBookProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.canDownloadFiles();
        });
    };
    /**
     * Report a book as being viewed.
     *
     * @param {number} id Module ID.
     * @param {string} chapterId Chapter ID.
     * @param {string} [name] Name of the book.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModBookProvider.prototype.logView = function (id, chapterId, name, siteId) {
        var params = {
            bookid: id,
            chapterid: chapterId
        };
        return this.logHelper.logSingle('mod_book_view_book', params, AddonModBookProvider_1.COMPONENT, id, name, 'book', { chapterid: chapterId }, siteId);
    };
    AddonModBookProvider.COMPONENT = 'mmaModBook';
    AddonModBookProvider = AddonModBookProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_1__angular_http__["b" /* Http */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModBookProvider);
    return AddonModBookProvider;
    var AddonModBookProvider_1;
}());

//# sourceMappingURL=book.js.map

/***/ }),
/* 213 */,
/* 214 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service that provides some features for IMSCP.
 */
var AddonModImscpProvider = /** @class */ (function () {
    function AddonModImscpProvider(appProvider, courseProvider, filepoolProvider, sitesProvider, textUtils, utils, logHelper) {
        this.appProvider = appProvider;
        this.courseProvider = courseProvider;
        this.filepoolProvider = filepoolProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.utils = utils;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModImscp:';
    }
    AddonModImscpProvider_1 = AddonModImscpProvider;
    /**
     * Get the IMSCP toc as an array.
     *
     * @param  {any[]} contents The module contents.
     * @return {any} The toc.
     */
    AddonModImscpProvider.prototype.getToc = function (contents) {
        if (!contents || !contents.length) {
            return [];
        }
        return JSON.parse(contents[0].content);
    };
    /**
     * Get the imscp toc as an array of items (not nested) to build the navigation tree.
     *
     * @param  {any[]} contents The module contents.
     * @return {any[]} The toc as a list.
     */
    AddonModImscpProvider.prototype.createItemList = function (contents) {
        var items = [];
        this.getToc(contents).forEach(function (el) {
            items.push({ href: el.href, title: el.title, level: el.level });
            el.subitems.forEach(function (sel) {
                items.push({ href: sel.href, title: sel.title, level: sel.level });
            });
        });
        return items;
    };
    /**
     * Get the previous item to the given one.
     *
     * @param  {any[]}  items  The items list.
     * @param  {string} itemId The current item.
     * @return {string} The previous item id.
     */
    AddonModImscpProvider.prototype.getPreviousItem = function (items, itemId) {
        var position = this.getItemPosition(items, itemId);
        if (position != -1) {
            for (var i = position - 1; i >= 0; i--) {
                if (items[i] && items[i].href) {
                    return items[i].href;
                }
            }
        }
        return '';
    };
    /**
     * Get the next item to the given one.
     *
     * @param  {any[]}  items  The items list.
     * @param  {string} itemId The current item.
     * @return {string} The next item id.
     */
    AddonModImscpProvider.prototype.getNextItem = function (items, itemId) {
        var position = this.getItemPosition(items, itemId);
        if (position != -1) {
            for (var i = position + 1; i < items.length; i++) {
                if (items[i] && items[i].href) {
                    return items[i].href;
                }
            }
        }
        return '';
    };
    /**
     * Get the position of a item.
     *
     * @param  {any[]}  items  The items list.
     * @param  {string} itemId The item to search.
     * @return {number} The item position.
     */
    AddonModImscpProvider.prototype.getItemPosition = function (items, itemId) {
        for (var i = 0; i < items.length; i++) {
            if (items[i].href == itemId) {
                return i;
            }
        }
        return -1;
    };
    /**
     * Check if we should ommit the file download.
     *
     * @param  {string} fileName The file name
     * @return {boolean} True if we should ommit the file.
     */
    AddonModImscpProvider.prototype.checkSpecialFiles = function (fileName) {
        return fileName == 'imsmanifest.xml';
    };
    /**
     * Get cache key for imscp data WS calls.
     *
     * @param  {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModImscpProvider.prototype.getImscpDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'imscp:' + courseId;
    };
    /**
     * Get a imscp with key=value. If more than one is found, only the first will be returned.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} key      Name of the property to check.
     * @param  {any}    value    Value to search.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the imscp is retrieved.
     */
    AddonModImscpProvider.prototype.getImscpByKey = function (courseId, key, value, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            };
            var preSets = {
                cacheKey: _this.getImscpDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_8__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_imscp_get_imscps_by_courses', params, preSets).then(function (response) {
                if (response && response.imscps) {
                    var currentImscp = response.imscps.find(function (imscp) { return imscp[key] == value; });
                    if (currentImscp) {
                        return currentImscp;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a imscp by course module ID.
     *
     * @param  {number} courseId Course ID.
     * @param  {number} cmId     Course module ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the imscp is retrieved.
     */
    AddonModImscpProvider.prototype.getImscp = function (courseId, cmId, siteId) {
        return this.getImscpByKey(courseId, 'coursemodule', cmId, siteId);
    };
    /**
     * Given a filepath, get a certain fileurl from module contents.
     *
     * @param  {any[]}  contents       Module contents.
     * @param  {string} targetFilePath Path of the searched file.
     * @return {string} File URL.
     */
    AddonModImscpProvider.prototype.getFileUrlFromContents = function (contents, targetFilePath) {
        var _this = this;
        var indexUrl;
        contents.forEach(function (content) {
            if (content.type == 'file' && !indexUrl) {
                var filePath = _this.textUtils.concatenatePaths(content.filepath, content.filename);
                var filePathAlt = filePath.charAt(0) === '/' ? filePath.substr(1) : '/' + filePath;
                // Check if it's main file.
                if (filePath === targetFilePath || filePathAlt === targetFilePath) {
                    indexUrl = content.fileurl;
                }
            }
        });
        return indexUrl;
    };
    /**
     * Get src of a imscp item.
     *
     * @param  {any}    module     The module object.
     * @param  {string} [itemHref] Href of item to get. If not defined, gets src of main item.
     * @return {Promise<string>} Promise resolved with the item src.
     */
    AddonModImscpProvider.prototype.getIframeSrc = function (module, itemHref) {
        var _this = this;
        if (!itemHref) {
            var toc = this.getToc(module.contents);
            if (!toc.length) {
                return Promise.reject(null);
            }
            itemHref = toc[0].href;
        }
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.getPackageDirUrlByUrl(siteId, module.url).then(function (dirPath) {
            return _this.textUtils.concatenatePaths(dirPath, itemHref);
        }).catch(function () {
            // Error getting directory, there was an error downloading or we're in browser. Return online URL if connected.
            if (_this.appProvider.isOnline()) {
                var indexUrl_1 = _this.getFileUrlFromContents(module.contents, itemHref);
                if (indexUrl_1) {
                    return _this.sitesProvider.getSite(siteId).then(function (site) {
                        return site.fixPluginfileURL(indexUrl_1);
                    });
                }
            }
            return Promise.reject(null);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the content is invalidated.
     */
    AddonModImscpProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.invalidateImscpData(courseId, siteId));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModImscpProvider_1.COMPONENT, moduleId));
        promises.push(this.courseProvider.invalidateModule(moduleId, siteId));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates imscp data.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModImscpProvider.prototype.invalidateImscpData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getImscpDataCacheKey(courseId));
        });
    };
    /**
     * Check if a file is downloadable. The file param must have 'type' and 'filename' attributes
     * like in core_course_get_contents response.
     *
     * @param  {any} file File to check.
     * @return {boolean} True if downloadable, false otherwise.
     */
    AddonModImscpProvider.prototype.isFileDownloadable = function (file) {
        return file.type === 'file' && !this.checkSpecialFiles(file.filename);
    };
    /**
     * Return whether or not the plugin is enabled in a certain site.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with true if plugin is enabled, rejected or resolved with false otherwise.
     */
    AddonModImscpProvider.prototype.isPluginEnabled = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.canDownloadFiles();
        });
    };
    /**
     * Report a IMSCP as being viewed.
     *
     * @param  {string} id Module ID.
     * @param {string} [name] Name of the imscp.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModImscpProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            imscpid: id
        };
        return this.logHelper.logSingle('mod_imscp_view_imscp', params, AddonModImscpProvider_1.COMPONENT, id, name, 'imscp', {}, siteId);
    };
    AddonModImscpProvider.COMPONENT = 'mmaModImscp';
    AddonModImscpProvider = AddonModImscpProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModImscpProvider);
    return AddonModImscpProvider;
    var AddonModImscpProvider_1;
}());

//# sourceMappingURL=imscp.js.map

/***/ }),
/* 215 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__quiz__ = __webpack_require__(99);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service to handle offline quiz.
 */
var AddonModQuizOfflineProvider = /** @class */ (function () {
    function AddonModQuizOfflineProvider(logger, sitesProvider, timeUtils, questionProvider, translate, utils, behaviourDelegate) {
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.questionProvider = questionProvider;
        this.translate = translate;
        this.utils = utils;
        this.behaviourDelegate = behaviourDelegate;
        this.siteSchema = {
            name: 'AddonModQuizOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModQuizOfflineProvider_1.ATTEMPTS_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'attempt',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'quizid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'currentpage',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'finished',
                            type: 'INTEGER'
                        }
                    ]
                }
            ]
        };
        this.logger = logger.getInstance('AddonModQuizOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModQuizOfflineProvider_1 = AddonModQuizOfflineProvider;
    /**
     * Classify the answers in questions.
     *
     * @param {any} answers List of answers.
     * @return {any} Object with the questions, the keys are the slot. Each question contains its answers.
     */
    AddonModQuizOfflineProvider.prototype.classifyAnswersInQuestions = function (answers) {
        var questionsWithAnswers = {};
        // Classify the answers in each question.
        for (var name_1 in answers) {
            var slot = this.questionProvider.getQuestionSlotFromName(name_1), nameWithoutPrefix = this.questionProvider.removeQuestionPrefix(name_1);
            if (!questionsWithAnswers[slot]) {
                questionsWithAnswers[slot] = {
                    answers: {},
                    prefix: name_1.substr(0, name_1.indexOf(nameWithoutPrefix))
                };
            }
            questionsWithAnswers[slot].answers[nameWithoutPrefix] = answers[name_1];
        }
        return questionsWithAnswers;
    };
    /**
     * Given a list of questions with answers classified in it (@see AddonModQuizOfflineProvider.classifyAnswersInQuestions),
     * returns a list of answers (including prefix in the name).
     *
     * @param {any} questions Questions.
     * @return {any} Answers.
     */
    AddonModQuizOfflineProvider.prototype.extractAnswersFromQuestions = function (questions) {
        var answers = {};
        for (var slot in questions) {
            var question = questions[slot];
            for (var name_2 in question.answers) {
                answers[question.prefix + name_2] = question.answers[name_2];
            }
        }
        return answers;
    };
    /**
     * Get all the offline attempts in a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the offline attempts.
     */
    AddonModQuizOfflineProvider.prototype.getAllAttempts = function (siteId) {
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getAllRecords(AddonModQuizOfflineProvider_1.ATTEMPTS_TABLE);
        });
    };
    /**
     * Retrieve an attempt answers from site DB.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the answers.
     */
    AddonModQuizOfflineProvider.prototype.getAttemptAnswers = function (attemptId, siteId) {
        return this.questionProvider.getAttemptAnswers(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, attemptId, siteId);
    };
    /**
     * Retrieve an attempt from site DB.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the attempt.
     */
    AddonModQuizOfflineProvider.prototype.getAttemptById = function (attemptId, siteId) {
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getRecord(AddonModQuizOfflineProvider_1.ATTEMPTS_TABLE, { id: attemptId });
        });
    };
    /**
     * Retrieve an attempt from site DB.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @param {number} [userId]  User ID. If not defined, user current site's user.
     * @return {Promise<any[]>} Promise resolved with the attempts.
     */
    AddonModQuizOfflineProvider.prototype.getQuizAttempts = function (quizId, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().getRecords(AddonModQuizOfflineProvider_1.ATTEMPTS_TABLE, { quizid: quizId, userid: userId });
        });
    };
    /**
     * Load local state in the questions.
     *
     * @param {number} attemptId Attempt ID.
     * @param {any[]} questions List of questions.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizOfflineProvider.prototype.loadQuestionsLocalStates = function (attemptId, questions, siteId) {
        var _this = this;
        var promises = [];
        questions.forEach(function (question) {
            promises.push(_this.questionProvider.getQuestion(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, attemptId, question.slot, siteId)
                .then(function (q) {
                var state = _this.questionProvider.getState(q.state);
                question.state = q.state;
                question.status = _this.translate.instant('core.question.' + state.status);
            }).catch(function () {
                // Question not found.
            }));
        });
        return Promise.all(promises).then(function () {
            return questions;
        });
    };
    /**
     * Process an attempt, saving its data.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} questions Object with the questions of the quiz. The keys should be the question slot.
     * @param {any} data Data to save.
     * @param {boolean} [finish] Whether to finish the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModQuizOfflineProvider.prototype.processAttempt = function (quiz, attempt, questions, data, finish, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var now = this.timeUtils.timestamp();
        var db;
        return this.sitesProvider.getSiteDb(siteId).then(function (siteDb) {
            db = siteDb;
            // Check if an attempt already exists.
            return _this.getAttemptById(attempt.id, siteId).catch(function () {
                // Attempt doesn't exist, create a new entry.
                return {
                    quizid: quiz.id,
                    userid: attempt.userid,
                    id: attempt.id,
                    courseid: quiz.course,
                    timecreated: now,
                    attempt: attempt.attempt,
                    currentpage: attempt.currentpage
                };
            });
        }).then(function (entry) {
            // Save attempt in DB.
            entry.timemodified = now;
            entry.finished = finish ? 1 : 0;
            return db.insertRecord(AddonModQuizOfflineProvider_1.ATTEMPTS_TABLE, entry);
        }).then(function () {
            // Attempt has been saved, now we need to save the answers.
            return _this.saveAnswers(quiz, attempt, questions, data, now, siteId);
        });
    };
    /**
     * Remove an attempt and its answers from local DB.
     *
     * @param {number} attemptId Attempt ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizOfflineProvider.prototype.removeAttemptAndAnswers = function (attemptId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        // Remove stored answers and questions.
        promises.push(this.questionProvider.removeAttemptAnswers(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, attemptId, siteId));
        promises.push(this.questionProvider.removeAttemptQuestions(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, attemptId, siteId));
        // Remove the attempt.
        promises.push(this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.deleteRecords(AddonModQuizOfflineProvider_1.ATTEMPTS_TABLE, { id: attemptId });
        }));
        return Promise.all(promises);
    };
    /**
     * Remove a question and its answers from local DB.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} slot Question slot.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when finished.
     */
    AddonModQuizOfflineProvider.prototype.removeQuestionAndAnswers = function (attemptId, slot, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.questionProvider.removeQuestion(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, attemptId, slot, siteId));
        promises.push(this.questionProvider.removeQuestionAnswers(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, attemptId, slot, siteId));
        return Promise.all(promises);
    };
    /**
     * Save an attempt's answers and calculate state for questions modified.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} questions Object with the questions of the quiz. The keys should be the question slot.
     * @param {any} answers Answers to save.
     * @param {number} [timeMod] Time modified to set in the answers. If not defined, current time.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizOfflineProvider.prototype.saveAnswers = function (quiz, attempt, questions, answers, timeMod, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        timeMod = timeMod || this.timeUtils.timestamp();
        var questionsWithAnswers = {}, newStates = {};
        var promises = [];
        // Classify the answers in each question.
        for (var name_3 in answers) {
            var slot = this.questionProvider.getQuestionSlotFromName(name_3), nameWithoutPrefix = this.questionProvider.removeQuestionPrefix(name_3);
            if (questions[slot]) {
                if (!questionsWithAnswers[slot]) {
                    questionsWithAnswers[slot] = questions[slot];
                    questionsWithAnswers[slot].answers = {};
                }
                questionsWithAnswers[slot].answers[nameWithoutPrefix] = answers[name_3];
            }
        }
        var _loop_1 = function (slot) {
            var question = questionsWithAnswers[slot];
            promises.push(this_1.behaviourDelegate.determineNewState(quiz.preferredbehaviour, __WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, attempt.id, question, siteId).then(function (state) {
                // Check if state has changed.
                if (state && state.name != question.state) {
                    newStates[question.slot] = state.name;
                }
            }));
        };
        var this_1 = this;
        // First determine the new state of each question. We won't save the new state yet.
        for (var slot in questionsWithAnswers) {
            _loop_1(slot);
        }
        return Promise.all(promises).then(function () {
            // Now save the answers.
            return _this.questionProvider.saveAnswers(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, quiz.id, attempt.id, attempt.userid, answers, timeMod, siteId);
        }).then(function () {
            // Answers have been saved, now we can save the questions with the states.
            promises = [];
            for (var slot in newStates) {
                var question = questionsWithAnswers[slot];
                promises.push(_this.questionProvider.saveQuestion(__WEBPACK_IMPORTED_MODULE_8__quiz__["a" /* AddonModQuizProvider */].COMPONENT, quiz.id, attempt.id, attempt.userid, question, newStates[slot], siteId));
            }
            return _this.utils.allPromises(promises).catch(function (err) {
                // Ignore errors when saving question state.
                _this.logger.error('Error saving question state', err);
            });
        });
    };
    /**
     * Set attempt's current page.
     *
     * @param {number} attemptId Attempt ID.
     * @param {number} page Page to set.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModQuizOfflineProvider.prototype.setAttemptCurrentPage = function (attemptId, page, siteId) {
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.updateRecords(AddonModQuizOfflineProvider_1.ATTEMPTS_TABLE, { currentpage: page }, { id: attemptId });
        });
    };
    // Variables for database.
    AddonModQuizOfflineProvider.ATTEMPTS_TABLE = 'addon_mod_quiz_attempts';
    AddonModQuizOfflineProvider = AddonModQuizOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_question_providers_question__["a" /* CoreQuestionProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */]])
    ], AddonModQuizOfflineProvider);
    return AddonModQuizOfflineProvider;
    var AddonModQuizOfflineProvider_1;
}());

//# sourceMappingURL=quiz-offline.js.map

/***/ }),
/* 216 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__scorm__ = __webpack_require__(168);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service to handle offline SCORM.
 */
var AddonModScormOfflineProvider = /** @class */ (function () {
    function AddonModScormOfflineProvider(logger, sitesProvider, timeUtils, syncProvider, utils, textUtils, userProvider) {
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.syncProvider = syncProvider;
        this.utils = utils;
        this.textUtils = textUtils;
        this.userProvider = userProvider;
        this.siteSchema = {
            name: 'AddonModScormOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModScormOfflineProvider_1.ATTEMPTS_TABLE,
                    columns: [
                        {
                            name: 'scormid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'attempt',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'snapshot',
                            type: 'TEXT'
                        },
                    ],
                    primaryKeys: ['scormid', 'userid', 'attempt']
                },
                {
                    name: AddonModScormOfflineProvider_1.TRACKS_TABLE,
                    columns: [
                        {
                            name: 'scormid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'attempt',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'scoid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'element',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'value',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'synced',
                            type: 'INTEGER'
                        },
                    ],
                    primaryKeys: ['scormid', 'userid', 'attempt', 'scoid', 'element']
                }
            ]
        };
        this.logger = logger.getInstance('AddonModScormOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModScormOfflineProvider_1 = AddonModScormOfflineProvider;
    /**
     * Changes an attempt number in the data stored in offline.
     * This function is used to convert attempts into new attempts, so the stored snapshot will be removed and
     * entries will be marked as not synced.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Number of the attempt to change.
     * @param {number} newAttempt New attempt number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the attempt number changes.
     */
    AddonModScormOfflineProvider.prototype.changeAttemptNumber = function (scormId, attempt, newAttempt, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Change attempt number from ' + attempt + ' to ' + newAttempt + ' in SCORM ' + scormId);
            // Update the attempt number.
            var db = site.getDb(), currentAttemptConditions = { scormid: scormId, userid: userId, attempt: attempt }, newAttemptConditions = { scormid: scormId, userid: userId, attempt: newAttempt };
            var newData = {
                attempt: newAttempt,
                timemodified: _this.timeUtils.timestamp()
            };
            // Block the SCORM so it can't be synced.
            _this.syncProvider.blockOperation(__WEBPACK_IMPORTED_MODULE_8__scorm__["a" /* AddonModScormProvider */].COMPONENT, scormId, 'changeAttemptNumber', site.id);
            return db.updateRecords(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE, newData, currentAttemptConditions).then(function () {
                // Now update the attempt number of all the tracks and mark them as not synced.
                newData = {
                    attempt: newAttempt,
                    synced: 0
                };
                return db.updateRecords(AddonModScormOfflineProvider_1.TRACKS_TABLE, newData, currentAttemptConditions)
                    .catch(function (error) {
                    // Failed to update the tracks, restore the old attempt number.
                    return db.updateRecords(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE, { attempt: attempt }, newAttemptConditions).then(function () {
                        return Promise.reject(error);
                    });
                });
            }).finally(function () {
                // Unblock the SCORM.
                _this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_8__scorm__["a" /* AddonModScormProvider */].COMPONENT, scormId, 'changeAttemptNumber', site.id);
            });
        });
    };
    /**
     * Creates a new offline attempt. It can be created from scratch or as a copy of another attempt.
     *
     * @param {any} scorm SCORM.
     * @param {number} attempt Number of the new attempt.
     * @param {any} userData User data to store in the attempt.
     * @param {any} [snapshot] Optional. Snapshot to store in the attempt.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the new attempt is created.
     */
    AddonModScormOfflineProvider.prototype.createNewAttempt = function (scorm, attempt, userData, snapshot, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Creating new offline attempt ' + attempt + ' in SCORM ' + scorm.id);
            // Block the SCORM so it can't be synced.
            _this.syncProvider.blockOperation(__WEBPACK_IMPORTED_MODULE_8__scorm__["a" /* AddonModScormProvider */].COMPONENT, scorm.id, 'createNewAttempt', site.id);
            // Create attempt in DB.
            var db = site.getDb(), entry = {
                scormid: scorm.id,
                userid: userId,
                attempt: attempt,
                courseid: scorm.course,
                timecreated: _this.timeUtils.timestamp(),
                timemodified: _this.timeUtils.timestamp(),
                snapshot: null
            };
            if (snapshot) {
                // Save a snapshot of the data we had when we created the attempt.
                // Remove the default data, we don't want to store it.
                entry.snapshot = JSON.stringify(_this.removeDefaultData(snapshot));
            }
            return db.insertRecord(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE, entry).then(function () {
                // Store all the data in userData.
                var promises = [];
                for (var key in userData) {
                    var sco = userData[key], tracks = [];
                    for (var element in sco.userdata) {
                        tracks.push({ element: element, value: sco.userdata[element] });
                    }
                    promises.push(_this.saveTracks(scorm, sco.scoid, attempt, tracks, userData, site.id, userId));
                }
                return Promise.all(promises);
            }).finally(function () {
                // Unblock the SCORM.
                _this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_8__scorm__["a" /* AddonModScormProvider */].COMPONENT, scorm.id, 'createNewAttempt', site.id);
            });
        });
    };
    /**
     * Delete all the stored data from an attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when all the data has been deleted.
     */
    AddonModScormOfflineProvider.prototype.deleteAttempt = function (scormId, attempt, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Delete offline attempt ' + attempt + ' in SCORM ' + scormId);
            var promises = [], db = site.getDb();
            // Delete the attempt.
            promises.push(db.deleteRecords(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE, { scormid: scormId, userid: userId,
                attempt: attempt }));
            // Delete all the tracks.
            promises.push(db.deleteRecords(AddonModScormOfflineProvider_1.TRACKS_TABLE, { scormid: scormId, userid: userId,
                attempt: attempt }));
            return Promise.all(promises);
        });
    };
    /**
     * Helper function to return a formatted list of interactions for reports.
     * This function is based in Moodle's scorm_format_interactions.
     *
     * @param {any} scoUserData Userdata from a certain SCO.
     * @return {any} Formatted userdata.
     */
    AddonModScormOfflineProvider.prototype.formatInteractions = function (scoUserData) {
        var formatted = {};
        // Defined in order to unify scorm1.2 and scorm2004.
        formatted.score_raw = '';
        formatted.status = '';
        formatted.total_time = '00:00:00';
        formatted.session_time = '00:00:00';
        for (var element in scoUserData) {
            var value = scoUserData[element];
            // Ignore elements that are calculated.
            if (element == 'score_raw' || element == 'status' || element == 'total_time' || element == 'session_time') {
                return;
            }
            formatted[element] = value;
            switch (element) {
                case 'cmi.core.lesson_status':
                case 'cmi.completion_status':
                    if (value == 'not attempted') {
                        value = 'notattempted';
                    }
                    formatted.status = value;
                    break;
                case 'cmi.core.score.raw':
                case 'cmi.score.raw':
                    formatted.score_raw = this.textUtils.roundToDecimals(value, 2); // Round to 2 decimals max.
                    break;
                case 'cmi.core.session_time':
                case 'cmi.session_time':
                    formatted.session_time = value;
                    break;
                case 'cmi.core.total_time':
                case 'cmi.total_time':
                    formatted.total_time = value;
                    break;
                default:
            }
        }
        return formatted;
    };
    /**
     * Get all the offline attempts in a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved when the offline attempts are retrieved.
     */
    AddonModScormOfflineProvider.prototype.getAllAttempts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getAllRecords(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE);
        }).then(function (attempts) {
            attempts.forEach(function (attempt) {
                attempt.snapshot = _this.textUtils.parseJSON(attempt.snapshot);
            });
            return attempts;
        });
    };
    /**
     * Get an offline attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<number>} Promise resolved with the attempt.
     */
    AddonModScormOfflineProvider.prototype.getAttempt = function (scormId, attempt, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().getRecord(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE, { scormid: scormId, userid: userId,
                attempt: attempt });
        }).then(function (entry) {
            entry.snapshot = _this.textUtils.parseJSON(entry.snapshot);
            return entry;
        });
    };
    /**
     * Get the creation time of an attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<number>} Promise resolved with time the attempt was created.
     */
    AddonModScormOfflineProvider.prototype.getAttemptCreationTime = function (scormId, attempt, siteId, userId) {
        return this.getAttempt(scormId, attempt, siteId, userId).catch(function () {
            return {}; // Attempt not found.
        }).then(function (entry) {
            return entry.timecreated;
        });
    };
    /**
     * Get the offline attempts done by a user in the given SCORM.
     *
     * @param {number} scormId  SCORM ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any[]>} Promise resolved when the offline attempts are retrieved.
     */
    AddonModScormOfflineProvider.prototype.getAttempts = function (scormId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().getRecords(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE, { scormid: scormId, userid: userId });
        }).then(function (attempts) {
            attempts.forEach(function (attempt) {
                attempt.snapshot = _this.textUtils.parseJSON(attempt.snapshot);
            });
            return attempts;
        });
    };
    /**
     * Get the snapshot of an attempt.
     *
     * @param {number} scormId  SCORM ID.
     * @param {number} attempt  Attempt number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved with the snapshot or undefined if no snapshot.
     */
    AddonModScormOfflineProvider.prototype.getAttemptSnapshot = function (scormId, attempt, siteId, userId) {
        return this.getAttempt(scormId, attempt, siteId, userId).catch(function () {
            return {}; // Attempt not found.
        }).then(function (entry) {
            return entry.snapshot;
        });
    };
    /**
     * Get launch URLs from a list of SCOs, indexing them by SCO ID.
     *
     * @param {any[]} scos List of SCOs. Each SCO needs to have 'id' and 'launch' properties.
     * @return {{[scoId: number]: string}} Launch URLs indexed by SCO ID.
     */
    AddonModScormOfflineProvider.prototype.getLaunchUrlsFromScos = function (scos) {
        scos = scos || [];
        var response = {};
        scos.forEach(function (sco) {
            response[sco.id] = sco.launch;
        });
        return response;
    };
    /**
     * Get data stored in local DB for a certain scorm and attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {boolean} [excludeSynced] Whether it should only return not synced entries.
     * @param {boolean} [excludeNotSynced] Whether it should only return synced entries.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any[]>} Promise resolved with the entries.
     */
    AddonModScormOfflineProvider.prototype.getScormStoredData = function (scormId, attempt, excludeSynced, excludeNotSynced, siteId, userId) {
        var _this = this;
        if (excludeSynced && excludeNotSynced) {
            return Promise.resolve([]);
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var conditions = {
                scormid: scormId,
                userid: userId,
                attempt: attempt
            };
            if (excludeSynced) {
                conditions.synced = 0;
            }
            else if (excludeNotSynced) {
                conditions.synced = 1;
            }
            return site.getDb().getRecords(AddonModScormOfflineProvider_1.TRACKS_TABLE, conditions);
        }).then(function (tracks) {
            tracks.forEach(function (track) {
                track.value = _this.textUtils.parseJSON(track.value);
            });
            return tracks;
        });
    };
    /**
     * Get the user data for a certain SCORM and offline attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} scos SCOs returned by AddonModScormProvider.getScos. If not supplied, this function will only return the
     *                     SCOs that have something stored and cmi.launch_data will be undefined.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when the user data is retrieved.
     */
    AddonModScormOfflineProvider.prototype.getScormUserData = function (scormId, attempt, scos, siteId, userId) {
        var _this = this;
        scos = scos || [];
        var fullName = '', userName = '';
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            // Get username and fullname.
            if (userId == site.getUserId()) {
                fullName = site.getInfo().fullname;
                userName = site.getInfo().username;
            }
            else {
                return _this.userProvider.getProfile(userId).then(function (profile) {
                    fullName = profile.fullname;
                    userName = profile.username || '';
                }).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            // Get user data. Ordering when using a compound index is complex, so we won't order by scoid.
            return _this.getScormStoredData(scormId, attempt, false, false, siteId, userId).then(function (entries) {
                var response = {}, launchUrls = _this.getLaunchUrlsFromScos(scos);
                // Gather user data retrieved from DB, grouping it by scoid.
                entries.forEach(function (entry) {
                    var scoId = entry.scoid;
                    if (!response[scoId]) {
                        // Initialize SCO.
                        response[scoId] = {
                            scoid: scoId,
                            userdata: {
                                userid: userId,
                                scoid: scoId,
                                timemodified: 0
                            }
                        };
                    }
                    response[scoId].userdata[entry.element] = entry.value;
                    if (entry.timemodified > response[scoId].userdata.timemodified) {
                        response[scoId].userdata.timemodified = entry.timemodified;
                    }
                });
                // Format each user data retrieved.
                for (var scoId in response) {
                    var sco = response[scoId];
                    sco.userdata = _this.formatInteractions(sco.userdata);
                }
                // Create empty entries for the SCOs without user data stored.
                scos.forEach(function (sco) {
                    if (!response[sco.id]) {
                        response[sco.id] = {
                            scoid: sco.id,
                            userdata: {
                                status: '',
                                score_raw: ''
                            }
                        };
                    }
                });
                // Calculate defaultdata.
                for (var scoId in response) {
                    var sco = response[scoId];
                    sco.defaultdata = {};
                    sco.defaultdata['cmi.core.student_id'] = userName;
                    sco.defaultdata['cmi.core.student_name'] = fullName;
                    sco.defaultdata['cmi.core.lesson_mode'] = 'normal'; // Overridden in player.
                    sco.defaultdata['cmi.core.credit'] = 'credit'; // Overridden in player.
                    if (sco.userdata.status === '') {
                        sco.defaultdata['cmi.core.entry'] = 'ab-initio';
                    }
                    else if (sco.userdata['cmi.core.exit'] === 'suspend') {
                        sco.defaultdata['cmi.core.entry'] = 'resume';
                    }
                    else {
                        sco.defaultdata['cmi.core.entry'] = '';
                    }
                    sco.defaultdata['cmi.student_data.mastery_score'] = _this.scormIsset(sco.userdata, 'masteryscore');
                    sco.defaultdata['cmi.student_data.max_time_allowed'] = _this.scormIsset(sco.userdata, 'max_time_allowed');
                    sco.defaultdata['cmi.student_data.time_limit_action'] = _this.scormIsset(sco.userdata, 'time_limit_action');
                    sco.defaultdata['cmi.core.total_time'] = _this.scormIsset(sco.userdata, 'cmi.core.total_time', '00:00:00');
                    sco.defaultdata['cmi.launch_data'] = launchUrls[sco.scoid];
                    // Now handle standard userdata items.
                    sco.defaultdata['cmi.core.lesson_location'] = _this.scormIsset(sco.userdata, 'cmi.core.lesson_location');
                    sco.defaultdata['cmi.core.lesson_status'] = _this.scormIsset(sco.userdata, 'cmi.core.lesson_status');
                    sco.defaultdata['cmi.core.score.raw'] = _this.scormIsset(sco.userdata, 'cmi.core.score.raw');
                    sco.defaultdata['cmi.core.score.max'] = _this.scormIsset(sco.userdata, 'cmi.core.score.max');
                    sco.defaultdata['cmi.core.score.min'] = _this.scormIsset(sco.userdata, 'cmi.core.score.min');
                    sco.defaultdata['cmi.core.exit'] = _this.scormIsset(sco.userdata, 'cmi.core.exit');
                    sco.defaultdata['cmi.suspend_data'] = _this.scormIsset(sco.userdata, 'cmi.suspend_data');
                    sco.defaultdata['cmi.comments'] = _this.scormIsset(sco.userdata, 'cmi.comments');
                    sco.defaultdata['cmi.student_preference.language'] = _this.scormIsset(sco.userdata, 'cmi.student_preference.language');
                    sco.defaultdata['cmi.student_preference.audio'] = _this.scormIsset(sco.userdata, 'cmi.student_preference.audio', '0');
                    sco.defaultdata['cmi.student_preference.speed'] = _this.scormIsset(sco.userdata, 'cmi.student_preference.speed', '0');
                    sco.defaultdata['cmi.student_preference.text'] = _this.scormIsset(sco.userdata, 'cmi.student_preference.text', '0');
                    // Some data needs to be both in default data and user data.
                    sco.userdata.student_id = userName;
                    sco.userdata.student_name = fullName;
                    sco.userdata.mode = sco.defaultdata['cmi.core.lesson_mode'];
                    sco.userdata.credit = sco.defaultdata['cmi.core.credit'];
                    sco.userdata.entry = sco.defaultdata['cmi.core.entry'];
                }
                return response;
            });
        });
    };
    /**
     * Insert a track in the offline tracks store.
     * This function is based on Moodle's scorm_insert_track.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} scoId SCO ID.
     * @param {number} attempt Attempt number.
     * @param {string} element Name of the element to insert.
     * @param {any} value Value to insert.
     * @param {boolean} [forceCompleted] True if SCORM forces completed.
     * @param {any} [scoData] User data for the given SCO.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not set use site's current user.
     * @return {Promise<any>} Promise resolved when the insert is done.
     */
    AddonModScormOfflineProvider.prototype.insertTrack = function (scormId, scoId, attempt, element, value, forceCompleted, scoData, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            scoData = scoData || {};
            var promises = [], // List of promises for actions previous to the real insert.
            scoUserData = scoData.userdata || {}, db = site.getDb();
            var lessonStatusInserted = false;
            if (forceCompleted) {
                if (element == 'cmi.core.lesson_status' && value == 'incomplete') {
                    if (scoUserData['cmi.core.score.raw']) {
                        value = 'completed';
                    }
                }
                if (element == 'cmi.core.score.raw') {
                    if (scoUserData['cmi.core.lesson_status'] == 'incomplete') {
                        lessonStatusInserted = true;
                        promises.push(_this.insertTrackToDB(db, userId, scormId, scoId, attempt, 'cmi.core.lesson_status', 'completed'));
                    }
                }
            }
            return Promise.all(promises).then(function () {
                // Don't update x.start.time, keep the original value.
                if (!scoUserData[element] || element != 'x.start.time') {
                    var promise_1 = _this.insertTrackToDB(db, userId, scormId, scoId, attempt, element, value);
                    return promise_1.catch(function (error) {
                        if (lessonStatusInserted) {
                            // Rollback previous insert.
                            promise_1 = _this.insertTrackToDB(db, userId, scormId, scoId, attempt, 'cmi.core.lesson_status', 'incomplete');
                            return promise_1.then(function () {
                                return Promise.reject(error);
                            });
                        }
                        return Promise.reject(null);
                    });
                }
            });
        });
    };
    /**
     * Insert a track in the DB.
     *
     * @param {SQLiteDB} db Site's DB.
     * @param {number} userId User ID.
     * @param {number} scormId SCORM ID.
     * @param {number} scoId SCO ID.
     * @param {number} attempt Attempt number.
     * @param {string} element Name of the element to insert.
     * @param {any} value Value of the element to insert.
     * @param {boolean} synchronous True if insert should NOT return a promise. Please use it only if synchronous is a must.
     * @return {boolean|Promise<any>} Returns a promise if synchronous=false, otherwise returns a boolean.
     */
    AddonModScormOfflineProvider.prototype.insertTrackToDB = function (db, userId, scormId, scoId, attempt, element, value, synchronous) {
        var entry = {
            userid: userId,
            scormid: scormId,
            scoid: scoId,
            attempt: attempt,
            element: element,
            value: typeof value == 'undefined' ? null : JSON.stringify(value),
            timemodified: this.timeUtils.timestamp(),
            synced: 0
        };
        if (synchronous) {
            // The insert operation is always asynchronous, always return true.
            db.insertRecord(AddonModScormOfflineProvider_1.TRACKS_TABLE, entry);
            return true;
        }
        else {
            return db.insertRecord(AddonModScormOfflineProvider_1.TRACKS_TABLE, entry);
        }
    };
    /**
     * Insert a track in the offline tracks store, returning a synchronous value.
     * Please use this function only if synchronous is a must. It's recommended to use insertTrack.
     * This function is based on Moodle's scorm_insert_track.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} scoId SCO ID.
     * @param {number} attempt Attempt number.
     * @param {string} element Name of the element to insert.
     * @param {any} value Value of the element to insert.
     * @param {boolean} [forceCompleted] True if SCORM forces completed.
     * @param {any} [scoData] User data for the given SCO.
     * @param {number} [userId] User ID. If not set use current user.
     * @return {boolean} Promise resolved when the insert is done.
     */
    AddonModScormOfflineProvider.prototype.insertTrackSync = function (scormId, scoId, attempt, element, value, forceCompleted, scoData, userId) {
        scoData = scoData || {};
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        if (!this.sitesProvider.isLoggedIn()) {
            // Not logged in, we can't get the site DB. User logged out or session expired while an operation was ongoing.
            return false;
        }
        var scoUserData = scoData.userdata || {}, db = this.sitesProvider.getCurrentSite().getDb();
        var lessonStatusInserted = false;
        if (forceCompleted) {
            if (element == 'cmi.core.lesson_status' && value == 'incomplete') {
                if (scoUserData['cmi.core.score.raw']) {
                    value = 'completed';
                }
            }
            if (element == 'cmi.core.score.raw') {
                if (scoUserData['cmi.core.lesson_status'] == 'incomplete') {
                    lessonStatusInserted = true;
                    if (!this.insertTrackToDB(db, userId, scormId, scoId, attempt, 'cmi.core.lesson_status', 'completed', true)) {
                        return false;
                    }
                }
            }
        }
        // Don't update x.start.time, keep the original value.
        if (!scoUserData[element] || element != 'x.start.time') {
            if (!this.insertTrackToDB(db, userId, scormId, scoId, attempt, element, value, true)) {
                // Insert failed.
                if (lessonStatusInserted) {
                    // Rollback previous insert.
                    this.insertTrackToDB(db, userId, scormId, scoId, attempt, 'cmi.core.lesson_status', 'incomplete', true);
                }
                return false;
            }
            return true;
        }
    };
    /**
     * Mark all the entries from a SCO and attempt as synced.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {number} scoId SCO ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when marked.
     */
    AddonModScormOfflineProvider.prototype.markAsSynced = function (scormId, attempt, scoId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Mark SCO ' + scoId + ' as synced for attempt ' + attempt + ' in SCORM ' + scormId);
            return site.getDb().updateRecords(AddonModScormOfflineProvider_1.TRACKS_TABLE, { synced: 1 }, {
                scormid: scormId,
                userid: userId,
                attempt: attempt,
                scoid: scoId,
                synced: 0
            });
        });
    };
    /**
     * Removes the default data form user data.
     *
     * @param {any} userData User data returned by AddonModScormProvider.getScormUserData.
     * @return {any} User data without default data.
     */
    AddonModScormOfflineProvider.prototype.removeDefaultData = function (userData) {
        var result = this.utils.clone(userData);
        for (var key in result) {
            delete result[key].defaultdata;
        }
        return result;
    };
    /**
     * Saves a SCORM tracking record in offline.
     *
     * @param {any} scorm SCORM.
     * @param {number} scoId Sco ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} tracks Tracking data to store.
     * @param {any} userData User data for this attempt and SCO.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when data is saved.
     */
    AddonModScormOfflineProvider.prototype.saveTracks = function (scorm, scoId, attempt, tracks, userData, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            // Block the SCORM so it can't be synced.
            _this.syncProvider.blockOperation(__WEBPACK_IMPORTED_MODULE_8__scorm__["a" /* AddonModScormProvider */].COMPONENT, scorm.id, 'saveTracksOffline', siteId);
            // Insert all the tracks.
            var promises = [];
            tracks.forEach(function (track) {
                promises.push(_this.insertTrack(scorm.id, scoId, attempt, track.element, track.value, scorm.forcecompleted, userData[scoId], siteId, userId));
            });
            return Promise.all(promises).finally(function () {
                // Unblock the SCORM operation.
                _this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_8__scorm__["a" /* AddonModScormProvider */].COMPONENT, scorm.id, 'saveTracksOffline', siteId);
            });
        });
    };
    /**
     * Saves a SCORM tracking record in offline returning a synchronous value.
     * Please use this function only if synchronous is a must. It's recommended to use saveTracks.
     *
     * @param  {any} scorm    SCORM.
     * @param  {number} scoId    Sco ID.
     * @param  {number} attempt  Attempt number.
     * @param  {Object[]} tracks Tracking data to store.
     * @param  {any} userData User data for this attempt and SCO.
     * @return {boolean}         True if data to insert is valid, false otherwise. Returning true doesn't mean that the data
     *                           has been stored, this function can return true but the insertion can still fail somehow.
     */
    AddonModScormOfflineProvider.prototype.saveTracksSync = function (scorm, scoId, attempt, tracks, userData, userId) {
        var _this = this;
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        var success = true;
        tracks.forEach(function (track) {
            if (!_this.insertTrackSync(scorm.id, scoId, attempt, track.element, track.value, scorm.forcecompleted, userData[scoId], userId)) {
                success = false;
            }
        });
        return success;
    };
    /**
     * Check for a parameter in userData and return it if it's set or return 'ifempty' if it's empty.
     * Based on Moodle's scorm_isset function.
     *
     * @param {any} userData Contains user's data.
     * @param {string} param Name of parameter that should be checked.
     * @param {any} [ifEmpty] Value to be replaced with if param is not set.
     * @return {any} Value from userData[param] if set, ifEmpty otherwise.
     */
    AddonModScormOfflineProvider.prototype.scormIsset = function (userData, param, ifEmpty) {
        if (ifEmpty === void 0) { ifEmpty = ''; }
        if (typeof userData[param] != 'undefined') {
            return userData[param];
        }
        return ifEmpty;
    };
    /**
     * Set an attempt's snapshot.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {any} userData User data to store as snapshot.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {number} [userId] User ID. If not defined use site's current user.
     * @return {Promise<any>} Promise resolved when snapshot has been stored.
     */
    AddonModScormOfflineProvider.prototype.setAttemptSnapshot = function (scormId, attempt, userData, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            _this.logger.debug('Set snapshot for attempt ' + attempt + ' in SCORM ' + scormId);
            var newData = {
                timemodified: _this.timeUtils.timestamp(),
                snapshot: JSON.stringify(_this.removeDefaultData(userData))
            };
            return site.getDb().updateRecords(AddonModScormOfflineProvider_1.ATTEMPTS_TABLE, newData, { scormid: scormId,
                userid: userId, attempt: attempt });
        });
    };
    // Variables for database.
    AddonModScormOfflineProvider.ATTEMPTS_TABLE = 'addon_mod_scorm_offline_attempts';
    AddonModScormOfflineProvider.TRACKS_TABLE = 'addon_mod_scorm_offline_scos_tracks';
    AddonModScormOfflineProvider = AddonModScormOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__["a" /* CoreUserProvider */]])
    ], AddonModScormOfflineProvider);
    return AddonModScormOfflineProvider;
    var AddonModScormOfflineProvider_1;
}());

//# sourceMappingURL=scorm-offline.js.map

/***/ }),
/* 217 */,
/* 218 */,
/* 219 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChatProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Service that provides some features for chats.
 */
var AddonModChatProvider = /** @class */ (function () {
    function AddonModChatProvider(sitesProvider, userProvider, logHelper, utils, translate) {
        this.sitesProvider = sitesProvider;
        this.userProvider = userProvider;
        this.logHelper = logHelper;
        this.utils = utils;
        this.translate = translate;
        this.ROOT_CACHE_KEY = 'AddonModChat:';
    }
    AddonModChatProvider_1 = AddonModChatProvider;
    /**
     * Get a chat.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the chat is retrieved.
     */
    AddonModChatProvider.prototype.getChat = function (courseId, cmId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            };
            var preSets = {
                cacheKey: _this.getChatsCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_6__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_chat_get_chats_by_courses', params, preSets).then(function (response) {
                if (response.chats) {
                    var chat = response.chats.find(function (chat) { return chat.coursemodule == cmId; });
                    if (chat) {
                        return chat;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Log the user into a chat room.
     *
     * @param  {number} chatId Chat instance ID.
     * @return {Promise<any>} Promise resolved when the WS is executed.
     */
    AddonModChatProvider.prototype.loginUser = function (chatId) {
        var params = {
            chatid: chatId
        };
        return this.sitesProvider.getCurrentSite().write('mod_chat_login_user', params).then(function (response) {
            if (response.chatsid) {
                return response.chatsid;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Report a chat as being viewed.
     *
     * @param  {number} id Chat instance ID.
     * @param {string} [name] Name of the chat.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModChatProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            chatid: id
        };
        return this.logHelper.logSingle('mod_chat_view_chat', params, AddonModChatProvider_1.COMPONENT, id, name, 'chat', {}, siteId);
    };
    /**
     * Send a message to a chat.
     *
     * @param  {number} sessionId  Chat sessiond ID.
     * @param  {string} message    Message text.
     * @param  {number} beepUserId Beep user ID.
     * @return {Promise<any>} Promise resolved when the WS is executed.
     */
    AddonModChatProvider.prototype.sendMessage = function (sessionId, message, beepUserId) {
        var params = {
            chatsid: sessionId,
            messagetext: message,
            beepid: beepUserId
        };
        return this.sitesProvider.getCurrentSite().write('mod_chat_send_chat_message', params).then(function (response) {
            if (response.messageid) {
                return response.messageid;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get the latest messages from a chat session.
     *
     * @param  {number} sessionId Chat sessiond ID.
     * @param  {number} lastTime  Last time when messages were retrieved.
     * @return {Promise<any>} Promise resolved when the WS is executed.
     */
    AddonModChatProvider.prototype.getLatestMessages = function (sessionId, lastTime) {
        var params = {
            chatsid: sessionId,
            chatlasttime: lastTime
        };
        /* We use write to not use cache. It doesn't make sense to store the messages in cache
           because we won't be able to retireve them if AddonModChatProvider.loginUser fails. */
        return this.sitesProvider.getCurrentSite().write('mod_chat_get_chat_latest_messages', params);
    };
    /**
     * Get user data for messages since they only have userid.
     *
     * @param  {any[]}  messages Messages to get the user data for.
     * @param  {number} courseId ID of the course the messages belong to.
     * @return {Promise<any>} Promise always resolved with the formatted messages.
     */
    AddonModChatProvider.prototype.getMessagesUserData = function (messages, courseId) {
        var _this = this;
        var promises = messages.map(function (message) {
            return _this.userProvider.getProfile(message.userid, courseId, true).then(function (user) {
                message.userfullname = user.fullname;
                message.userprofileimageurl = user.profileimageurl;
            }).catch(function () {
                // Error getting profile, most probably the user is deleted.
                message.userfullname = _this.translate.instant('core.deleteduser') + ' ' + message.userid;
            });
        });
        return Promise.all(promises).then(function () {
            return messages;
        });
    };
    /**
     * Get the actives users of a current chat.
     *
     * @param  {number} sessionId Chat sessiond ID.
     * @return {Promise<any>} Promise resolved when the WS is executed.
     */
    AddonModChatProvider.prototype.getChatUsers = function (sessionId) {
        var params = {
            chatsid: sessionId
        };
        var preSets = {
            getFromCache: false
        };
        return this.sitesProvider.getCurrentSite().read('mod_chat_get_chat_users', params, preSets);
    };
    /**
     * Return whether WS for passed sessions are available.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with a boolean.
     */
    AddonModChatProvider.prototype.areSessionsAvailable = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('mod_chat_get_sessions') && site.wsAvailable('mod_chat_get_session_messages');
        });
    };
    /**
     * Get chat sessions.
     *
     * @param {number} chatId Chat ID.
     * @param {number} [groupId=0] Group ID, 0 means that the function will determine the user group.
     * @param {boolean} [showAll=false] Whether to include incomplete sessions or not.
     * @param {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of sessions.
     * @since 3.5
     */
    AddonModChatProvider.prototype.getSessions = function (chatId, groupId, showAll, ignoreCache, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (showAll === void 0) { showAll = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                chatid: chatId,
                groupid: groupId,
                showall: showAll ? 1 : 0
            };
            var preSets = {
                cacheKey: _this.getSessionsCacheKey(chatId, groupId, showAll),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_6__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_chat_get_sessions', params, preSets).then(function (response) {
                if (!response || !response.sessions) {
                    return Promise.reject(null);
                }
                return response.sessions;
            });
        });
    };
    /**
     * Get chat session messages.
     *
     * @param {number} chatId Chat ID.
     * @param {number} sessionStart Session start time.
     * @param {number} sessionEnd Session end time.
     * @param {number} [groupId=0] Group ID, 0 means that the function will determine the user group.
     * @param {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of messages.
     * @since 3.5
     */
    AddonModChatProvider.prototype.getSessionMessages = function (chatId, sessionStart, sessionEnd, groupId, ignoreCache, siteId) {
        var _this = this;
        if (groupId === void 0) { groupId = 0; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                chatid: chatId,
                sessionstart: sessionStart,
                sessionend: sessionEnd,
                groupid: groupId
            };
            var preSets = {
                cacheKey: _this.getSessionMessagesCacheKey(chatId, sessionStart, groupId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_6__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_chat_get_session_messages', params, preSets).then(function (response) {
                if (!response || !response.messages) {
                    return Promise.reject(null);
                }
                return response.messages;
            });
        });
    };
    /**
     * Invalidate chats.
     *
     * @param {number} courseId Course ID.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChatProvider.prototype.invalidateChats = function (courseId) {
        var site = this.sitesProvider.getCurrentSite();
        return site.invalidateWsCacheForKey(this.getChatsCacheKey(courseId));
    };
    /**
     * Invalidate chat sessions.
     *
     * @param {number} chatId Chat ID.
     * @param {number} [groupId=0] Group ID, 0 means that the function will determine the user group.
     * @param {boolean} [showAll=false] Whether to include incomplete sessions or not.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChatProvider.prototype.invalidateSessions = function (chatId, groupId, showAll) {
        if (groupId === void 0) { groupId = 0; }
        if (showAll === void 0) { showAll = false; }
        var site = this.sitesProvider.getCurrentSite();
        return site.invalidateWsCacheForKey(this.getSessionsCacheKey(chatId, groupId, showAll));
    };
    /**
     * Invalidate all chat sessions.
     *
     * @param {number} chatId Chat ID.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChatProvider.prototype.invalidateAllSessions = function (chatId) {
        var site = this.sitesProvider.getCurrentSite();
        return site.invalidateWsCacheForKeyStartingWith(this.getSessionsCacheKeyPrefix(chatId));
    };
    /**
     * Invalidate chat session messages.
     *
     * @param {number} chatId Chat ID.
     * @param {number} sessionStart Session start time.
     * @param {number} [groupId=0] Group ID, 0 means that the function will determine the user group.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChatProvider.prototype.invalidateSessionMessages = function (chatId, sessionStart, groupId) {
        if (groupId === void 0) { groupId = 0; }
        var site = this.sitesProvider.getCurrentSite();
        return site.invalidateWsCacheForKey(this.getSessionMessagesCacheKey(chatId, sessionStart, groupId));
    };
    /**
     * Invalidate all chat session messages.
     *
     * @param {number} chatId Chat ID.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChatProvider.prototype.invalidateAllSessionMessages = function (chatId) {
        var site = this.sitesProvider.getCurrentSite();
        return site.invalidateWsCacheForKeyStartingWith(this.getSessionMessagesCacheKeyPrefix(chatId));
    };
    /**
     * Get cache key for chats WS call.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModChatProvider.prototype.getChatsCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'chats:' + courseId;
    };
    /**
     * Get cache key for sessions WS call.
     *
     * @param {number} chatId Chat ID.
     * @param {number} groupId Goup ID, 0 means that the function will determine the user group.
     * @param {boolean} showAll Whether to include incomplete sessions or not.
     * @return {string} Cache key.
     */
    AddonModChatProvider.prototype.getSessionsCacheKey = function (chatId, groupId, showAll) {
        return this.getSessionsCacheKeyPrefix(chatId) + groupId + ':' + (showAll ? 1 : 0);
    };
    /**
     * Get cache key prefix for sessions WS call.
     *
     * @param {number} chatId Chat ID.
     * @return {string} Cache key prefix.
     */
    AddonModChatProvider.prototype.getSessionsCacheKeyPrefix = function (chatId) {
        return this.ROOT_CACHE_KEY + 'sessions:' + chatId + ':';
    };
    /**
     * Get cache key for session messages WS call.
     *
     * @param {number} chatId Chat ID.
     * @param {number} sessionStart Session start time.
     * @param {number} groupId Group ID, 0 means that the function will determine the user group.
     * @return {string} Cache key.
     */
    AddonModChatProvider.prototype.getSessionMessagesCacheKey = function (chatId, sessionStart, groupId) {
        return this.getSessionMessagesCacheKeyPrefix(chatId) + sessionStart + ':' + groupId;
    };
    /**
     * Get cache key prefix for session messages WS call.
     *
     * @param {number} chatId Chat ID.
     * @return {string} Cache key prefix.
     */
    AddonModChatProvider.prototype.getSessionMessagesCacheKeyPrefix = function (chatId) {
        return this.ROOT_CACHE_KEY + 'sessionsMessages:' + chatId + ':';
    };
    AddonModChatProvider.COMPONENT = 'mmaModChat';
    AddonModChatProvider.POLL_INTERVAL = 4000;
    AddonModChatProvider = AddonModChatProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModChatProvider);
    return AddonModChatProvider;
    var AddonModChatProvider_1;
}());

//# sourceMappingURL=chat.js.map

/***/ }),
/* 220 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__forum__ = __webpack_require__(100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__offline__ = __webpack_require__(169);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Service that provides some features for forums.
 */
var AddonModForumHelperProvider = /** @class */ (function () {
    function AddonModForumHelperProvider(translate, fileProvider, sitesProvider, uploaderProvider, timeUtils, userProvider, appProvider, utils, forumProvider, forumOffline) {
        this.translate = translate;
        this.fileProvider = fileProvider;
        this.sitesProvider = sitesProvider;
        this.uploaderProvider = uploaderProvider;
        this.timeUtils = timeUtils;
        this.userProvider = userProvider;
        this.appProvider = appProvider;
        this.utils = utils;
        this.forumProvider = forumProvider;
        this.forumOffline = forumOffline;
    }
    /**
     * Add a new discussion.
     *
     * @param {number} forumId Forum ID.
     * @param {string} name Forum name.
     * @param {number} courseId Course ID the forum belongs to.
     * @param {string} subject New discussion's subject.
     * @param {string} message New discussion's message.
     * @param {any[]} [attachments] New discussion's attachments.
     * @param {any} [options] Options (subscribe, pin, ...).
     * @param {number[]} [groupIds] Groups this discussion belongs to.
     * @param {number} [timeCreated] The time the discussion was created. Only used when editing discussion.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<number[]>} Promise resolved with ids of the created discussions or null if stored offline
     */
    AddonModForumHelperProvider.prototype.addNewDiscussion = function (forumId, name, courseId, subject, message, attachments, options, groupIds, timeCreated, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        groupIds = groupIds && groupIds.length > 0 ? groupIds : [0];
        var saveOffline = false;
        var attachmentsIds = [];
        var offlineAttachments;
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            // Multiple groups, the discussion is being posted to all groups.
            var groupId = groupIds.length > 1 ? __WEBPACK_IMPORTED_MODULE_9__forum__["a" /* AddonModForumProvider */].ALL_GROUPS : groupIds[0];
            if (offlineAttachments) {
                options.attachmentsid = offlineAttachments;
            }
            return _this.forumOffline.addNewDiscussion(forumId, name, courseId, subject, message, options, groupId, timeCreated, siteId).then(function () {
                return null;
            });
        };
        // First try to upload attachments, once per group.
        var promise;
        if (attachments && attachments.length > 0) {
            var promises = groupIds.map(function () {
                return _this.uploadOrStoreNewDiscussionFiles(forumId, timeCreated, attachments, false).then(function (attach) {
                    attachmentsIds.push(attach);
                });
            });
            promise = Promise.all(promises).catch(function () {
                // Cannot upload them in online, save them in offline.
                saveOffline = true;
                return _this.uploadOrStoreNewDiscussionFiles(forumId, timeCreated, attachments, true).then(function (attach) {
                    offlineAttachments = attach;
                });
            });
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function () {
            // If we are editing an offline discussion, discard previous first.
            var discardPromise;
            if (timeCreated) {
                discardPromise = _this.forumOffline.deleteNewDiscussion(forumId, timeCreated, siteId);
            }
            else {
                discardPromise = Promise.resolve();
            }
            return discardPromise.then(function () {
                if (saveOffline || !_this.appProvider.isOnline()) {
                    return storeOffline();
                }
                var errors = [];
                var discussionIds = [];
                var promises = groupIds.map(function (groupId, index) {
                    var grouOptions = _this.utils.clone(options);
                    if (attachmentsIds[index]) {
                        grouOptions.attachmentsid = attachmentsIds[index];
                    }
                    return _this.forumProvider.addNewDiscussionOnline(forumId, subject, message, grouOptions, groupId, siteId)
                        .then(function (discussionId) {
                        discussionIds.push(discussionId);
                    }).catch(function (error) {
                        errors.push(error);
                    });
                });
                return Promise.all(promises).then(function () {
                    if (errors.length == groupIds.length) {
                        // All requests have failed.
                        for (var i = 0; i < errors.length; i++) {
                            if (_this.utils.isWebServiceError(errors[i]) || attachments.length > 0) {
                                // The WebService has thrown an error or offline not supported, reject.
                                return Promise.reject(errors[i]);
                            }
                        }
                        // Couldn't connect to server, store offline.
                        return storeOffline();
                    }
                    return discussionIds;
                });
            });
        });
    };
    /**
     * Convert offline reply to online format in order to be compatible with them.
     *
     * @param  {any}    offlineReply Offline version of the reply.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved with the object converted to Online.
     */
    AddonModForumHelperProvider.prototype.convertOfflineReplyToOnline = function (offlineReply, siteId) {
        var reply = {
            attachments: [],
            canreply: false,
            children: [],
            created: offlineReply.timecreated,
            discussion: offlineReply.discussionid,
            id: false,
            mailed: 0,
            mailnow: 0,
            message: offlineReply.message,
            messageformat: 1,
            messagetrust: 0,
            modified: false,
            parent: offlineReply.postid,
            postread: false,
            subject: offlineReply.subject,
            totalscore: 0,
            userid: offlineReply.userid,
            isprivatereply: offlineReply.options && offlineReply.options.private
        }, promises = [];
        // Treat attachments if any.
        if (offlineReply.options && offlineReply.options.attachmentsid) {
            reply.attachments = offlineReply.options.attachmentsid.online || [];
            if (offlineReply.options.attachmentsid.offline) {
                promises.push(this.getReplyStoredFiles(offlineReply.forumid, reply.parent, siteId, reply.userid)
                    .then(function (files) {
                    reply.attachments = reply.attachments.concat(files);
                }));
            }
        }
        // Get user data.
        promises.push(this.userProvider.getProfile(offlineReply.userid, offlineReply.courseid, true).then(function (user) {
            reply.userfullname = user.fullname;
            reply.userpictureurl = user.profileimageurl;
        }).catch(function () {
            // Ignore errors.
        }));
        return Promise.all(promises).then(function () {
            reply.attachment = reply.attachments.length > 0 ? 1 : 0;
            return reply;
        });
    };
    /**
     * Delete stored attachment files for a new discussion.
     *
     * @param  {number} forumId     Forum ID.
     * @param  {number} timecreated The time the discussion was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved when deleted.
     */
    AddonModForumHelperProvider.prototype.deleteNewDiscussionStoredFiles = function (forumId, timecreated, siteId) {
        var _this = this;
        return this.forumOffline.getNewDiscussionFolder(forumId, timecreated, siteId).then(function (folderPath) {
            return _this.fileProvider.removeDir(folderPath).catch(function () {
                // Ignore any errors, CoreFileProvider.removeDir fails if folder doesn't exists.
            });
        });
    };
    /**
     * Delete stored attachment files for a reply.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {number} postId   ID of the post being replied.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the reply belongs to. If not defined, current user in site.
     * @return {Promise<any>}    Promise resolved when deleted.
     */
    AddonModForumHelperProvider.prototype.deleteReplyStoredFiles = function (forumId, postId, siteId, userId) {
        var _this = this;
        return this.forumOffline.getReplyFolder(forumId, postId, siteId, userId).then(function (folderPath) {
            return _this.fileProvider.removeDir(folderPath).catch(function () {
                // Ignore any errors, CoreFileProvider.removeDir fails if folder doesn't exists.
            });
        });
    };
    /**
     * Returns the availability message of the given forum.
     *
     * @param {any} forum Forum instance.
     * @return {string} Message or null if the forum has no cut-off or due date.
     */
    AddonModForumHelperProvider.prototype.getAvailabilityMessage = function (forum) {
        if (this.isCutoffDateReached(forum)) {
            return this.translate.instant('addon.mod_forum.cutoffdatereached');
        }
        else if (this.isDueDateReached(forum)) {
            var dueDate = this.timeUtils.userDate(forum.duedate * 1000);
            return this.translate.instant('addon.mod_forum.thisforumisdue', { $a: dueDate });
        }
        else if (forum.duedate > 0) {
            var dueDate = this.timeUtils.userDate(forum.duedate * 1000);
            return this.translate.instant('addon.mod_forum.thisforumhasduedate', { $a: dueDate });
        }
        else {
            return null;
        }
    };
    /**
     * Get a forum discussion by id.
     *
     * This function is inefficient because it needs to fetch all discussion pages in the worst case.
     *
     * @param {number} forumId Forum ID.
     * @param {number} discussionId Discussion ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the discussion data.
     */
    AddonModForumHelperProvider.prototype.getDiscussionById = function (forumId, discussionId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var findDiscussion = function (page) {
            return _this.forumProvider.getDiscussions(forumId, undefined, page, false, siteId).then(function (response) {
                if (response.discussions && response.discussions.length > 0) {
                    var discussion = response.discussions.find(function (discussion) { return discussion.id == discussionId; });
                    if (discussion) {
                        return discussion;
                    }
                    if (response.canLoadMore) {
                        return findDiscussion(page + 1);
                    }
                }
                return Promise.reject(null);
            });
        };
        return findDiscussion(0);
    };
    /**
     * Get a list of stored attachment files for a new discussion. See AddonModForumHelper#storeNewDiscussionFiles.
     *
     * @param  {number} forumId     Forum ID.
     * @param  {number} timecreated The time the discussion was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any[]>}     Promise resolved with the files.
     */
    AddonModForumHelperProvider.prototype.getNewDiscussionStoredFiles = function (forumId, timecreated, siteId) {
        var _this = this;
        return this.forumOffline.getNewDiscussionFolder(forumId, timecreated, siteId).then(function (folderPath) {
            return _this.uploaderProvider.getStoredFiles(folderPath);
        });
    };
    /**
     * Get a list of stored attachment files for a reply. See AddonModForumHelper#storeReplyFiles.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {number} postId   ID of the post being replied.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the reply belongs to. If not defined, current user in site.
     * @return {Promise<any[]>}  Promise resolved with the files.
     */
    AddonModForumHelperProvider.prototype.getReplyStoredFiles = function (forumId, postId, siteId, userId) {
        var _this = this;
        return this.forumOffline.getReplyFolder(forumId, postId, siteId, userId).then(function (folderPath) {
            return _this.uploaderProvider.getStoredFiles(folderPath);
        });
    };
    /**
     * Check if the data of a post/discussion has changed.
     *
     * @param  {any} post       Current data.
     * @param  {any} [original] Original ata.
     * @return {boolean} True if data has changed, false otherwise.
     */
    AddonModForumHelperProvider.prototype.hasPostDataChanged = function (post, original) {
        if (!original || original.subject == null) {
            // There is no original data, assume it hasn't changed.
            return false;
        }
        if (post.subject != original.subject || post.message != original.message) {
            return true;
        }
        if (post.isprivatereply != original.isprivatereply) {
            return true;
        }
        return this.uploaderProvider.areFileListDifferent(post.files, original.files);
    };
    /**
     * Is the cutoff date for the forum reached?
     *
     * @param {any} forum Forum instance.
     * @return {boolean}
     */
    AddonModForumHelperProvider.prototype.isCutoffDateReached = function (forum) {
        var now = Date.now() / 1000;
        return forum.cutoffdate > 0 && forum.cutoffdate < now;
    };
    /**
     * Is the due date for the forum reached?
     *
     * @param {any} forum Forum instance.
     * @return {boolean}
     */
    AddonModForumHelperProvider.prototype.isDueDateReached = function (forum) {
        var now = Date.now() / 1000;
        return forum.duedate > 0 && forum.duedate < now;
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be submitted later.
     *
     * @param  {number} forumId     Forum ID.
     * @param  {number} timecreated The time the discussion was created.
     * @param  {any[]}  files       List of files.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved if success, rejected otherwise.
     */
    AddonModForumHelperProvider.prototype.storeNewDiscussionFiles = function (forumId, timecreated, files, siteId) {
        var _this = this;
        // Get the folder where to store the files.
        return this.forumOffline.getNewDiscussionFolder(forumId, timecreated, siteId).then(function (folderPath) {
            return _this.uploaderProvider.storeFilesToUpload(folderPath, files);
        });
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be submitted later.
     *
     * @param  {number} forumId  Forum ID.
     * @param  {number} postId   ID of the post being replied.
     * @param  {any[]}  files    List of files.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the reply belongs to. If not defined, current user in site.
     * @return {Promise<any>}    Promise resolved if success, rejected otherwise.
     */
    AddonModForumHelperProvider.prototype.storeReplyFiles = function (forumId, postId, files, siteId, userId) {
        var _this = this;
        // Get the folder where to store the files.
        return this.forumOffline.getReplyFolder(forumId, postId, siteId, userId).then(function (folderPath) {
            return _this.uploaderProvider.storeFilesToUpload(folderPath, files);
        });
    };
    /**
     * Upload or store some files for a new discussion, depending if the user is offline or not.
     *
     * @param  {number}  forumId     Forum ID.
     * @param  {number}  timecreated The time the discussion was created.
     * @param  {any[]}   files       List of files.
     * @param  {boolean} offline     True if files sould be stored for offline, false to upload them.
     * @param  {string}  [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved if success.
     */
    AddonModForumHelperProvider.prototype.uploadOrStoreNewDiscussionFiles = function (forumId, timecreated, files, offline, siteId) {
        if (offline) {
            return this.storeNewDiscussionFiles(forumId, timecreated, files, siteId);
        }
        else {
            return this.uploaderProvider.uploadOrReuploadFiles(files, __WEBPACK_IMPORTED_MODULE_9__forum__["a" /* AddonModForumProvider */].COMPONENT, forumId, siteId);
        }
    };
    /**
     * Upload or store some files for a reply, depending if the user is offline or not.
     *
     * @param  {number}  forumId  Forum ID.
     * @param  {number}  postId   ID of the post being replied.
     * @param  {any[]}   files    List of files.
     * @param  {boolean} offline  True if files sould be stored for offline, false to upload them.
     * @param  {string}  [siteId] Site ID. If not defined, current site.
     * @param  {number}  [userId] User the reply belongs to. If not defined, current user in site.
     * @return {Promise<any>}     Promise resolved if success.
     */
    AddonModForumHelperProvider.prototype.uploadOrStoreReplyFiles = function (forumId, postId, files, offline, siteId, userId) {
        if (offline) {
            return this.storeReplyFiles(forumId, postId, files, siteId, userId);
        }
        else {
            return this.uploaderProvider.uploadOrReuploadFiles(files, __WEBPACK_IMPORTED_MODULE_9__forum__["a" /* AddonModForumProvider */].COMPONENT, forumId, siteId);
        }
    };
    AddonModForumHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__forum__["a" /* AddonModForumProvider */],
            __WEBPACK_IMPORTED_MODULE_10__offline__["a" /* AddonModForumOfflineProvider */]])
    ], AddonModForumHelperProvider);
    return AddonModForumHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 221 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__helper__ = __webpack_require__(152);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__offline__ = __webpack_require__(133);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/**
 * Service to sync workshops.
 */
var AddonModWorkshopSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModWorkshopSyncProvider, _super);
    function AddonModWorkshopSyncProvider(translate, appProvider, courseProvider, eventsProvider, loggerProvider, sitesProvider, syncProvider, textUtils, timeUtils, utils, workshopProvider, workshopHelper, workshopOffline, logHelper) {
        var _this = _super.call(this, 'AddonModWorkshopSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.eventsProvider = eventsProvider;
        _this.utils = utils;
        _this.workshopProvider = workshopProvider;
        _this.workshopHelper = workshopHelper;
        _this.workshopOffline = workshopOffline;
        _this.logHelper = logHelper;
        _this.componentTranslate = courseProvider.translateModuleName('workshop');
        return _this;
    }
    AddonModWorkshopSyncProvider_1 = AddonModWorkshopSyncProvider;
    /**
     * Check if an workshop has data to synchronize.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved with boolean: true if has data to sync, false otherwise.
     */
    AddonModWorkshopSyncProvider.prototype.hasDataToSync = function (workshopId, siteId) {
        return this.workshopOffline.hasWorkshopOfflineData(workshopId, siteId);
    };
    /**
     * Try to synchronize all workshops that need it and haven't been synchronized in a while.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved when the sync is done.
     */
    AddonModWorkshopSyncProvider.prototype.syncAllWorkshops = function (siteId, force) {
        return this.syncOnSites('all workshops', this.syncAllWorkshopsFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all workshops on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModWorkshopSyncProvider.prototype.syncAllWorkshopsFunc = function (siteId, force) {
        var _this = this;
        return this.workshopOffline.getAllWorkshops(siteId).then(function (workshopIds) {
            // Sync all workshops that haven't been synced for a while.
            var promises = workshopIds.map(function (workshopId) {
                var promise = force ? _this.syncWorkshop(workshopId, siteId) : _this.syncWorkshopIfNeeded(workshopId, siteId);
                return promise.then(function (data) {
                    if (data && data.updated) {
                        // Sync done. Send event.
                        _this.eventsProvider.trigger(AddonModWorkshopSyncProvider_1.AUTO_SYNCED, {
                            workshopId: workshopId,
                            warnings: data.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(promises);
        });
    };
    /**
     * Sync a workshop only if a certain time has passed since the last time.
     *
     * @param  {number} workshopId Workshop ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the workshop is synced or if it doesn't need to be synced.
     */
    AddonModWorkshopSyncProvider.prototype.syncWorkshopIfNeeded = function (workshopId, siteId) {
        var _this = this;
        return this.isSyncNeeded(workshopId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncWorkshop(workshopId, siteId);
            }
        });
    };
    /**
     * Try to synchronize a workshop.
     *
     * @param  {number} workshopId  Workshop ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModWorkshopSyncProvider.prototype.syncWorkshop = function (workshopId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.isSyncing(workshopId, siteId)) {
            // There's already a sync ongoing for this discussion, return the promise.
            return this.getOngoingSync(workshopId, siteId);
        }
        // Verify that workshop isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_13__workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, workshopId, siteId)) {
            this.logger.debug('Cannot sync workshop ' + workshopId + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync workshop ' + workshopId);
        var syncPromises = [];
        // Get offline submissions to be sent.
        syncPromises.push(this.workshopOffline.getSubmissions(workshopId, siteId).catch(function () {
            // No offline data found, return empty array.
            return [];
        }));
        // Get offline submission assessments to be sent.
        syncPromises.push(this.workshopOffline.getAssessments(workshopId, siteId).catch(function () {
            // No offline data found, return empty array.
            return [];
        }));
        // Get offline submission evaluations to be sent.
        syncPromises.push(this.workshopOffline.getEvaluateSubmissions(workshopId, siteId).catch(function () {
            // No offline data found, return empty array.
            return [];
        }));
        // Get offline assessment evaluations to be sent.
        syncPromises.push(this.workshopOffline.getEvaluateAssessments(workshopId, siteId).catch(function () {
            // No offline data found, return empty array.
            return [];
        }));
        // Sync offline logs.
        syncPromises.push(this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_13__workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, workshopId, siteId));
        var result = {
            warnings: [],
            updated: false
        };
        // Get offline submissions to be sent.
        var syncPromise = Promise.all(syncPromises).then(function (syncs) {
            var courseId;
            // Get courseId from the first object
            for (var x in syncs) {
                if (syncs[x].length > 0 && syncs[x][0].courseid) {
                    courseId = syncs[x][0].courseid;
                    break;
                }
            }
            if (!courseId) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            return _this.workshopProvider.getWorkshopById(courseId, workshopId, siteId).then(function (workshop) {
                var submissionsActions = syncs[0], assessments = syncs[1], submissionEvaluations = syncs[2], assessmentEvaluations = syncs[3], promises = [], offlineSubmissions = {};
                submissionsActions.forEach(function (action) {
                    if (typeof offlineSubmissions[action.submissionid] == 'undefined') {
                        offlineSubmissions[action.submissionid] = [];
                    }
                    offlineSubmissions[action.submissionid].push(action);
                });
                Object.keys(offlineSubmissions).forEach(function (submissionId) {
                    var submissionActions = offlineSubmissions[submissionId];
                    promises.push(_this.syncSubmission(workshop, submissionActions, result, siteId).then(function () {
                        result.updated = true;
                    }));
                });
                assessments.forEach(function (assessment) {
                    promises.push(_this.syncAssessment(workshop, assessment, result, siteId).then(function () {
                        result.updated = true;
                    }));
                });
                submissionEvaluations.forEach(function (evaluation) {
                    promises.push(_this.syncEvaluateSubmission(workshop, evaluation, result, siteId).then(function () {
                        result.updated = true;
                    }));
                });
                assessmentEvaluations.forEach(function (evaluation) {
                    promises.push(_this.syncEvaluateAssessment(workshop, evaluation, result, siteId).then(function () {
                        result.updated = true;
                    }));
                });
                return Promise.all(promises);
            }).then(function () {
                if (result.updated) {
                    // Data has been sent to server. Now invalidate the WS calls.
                    return _this.workshopProvider.invalidateContentById(workshopId, courseId, siteId).catch(function () {
                        // Ignore errors.
                    });
                }
            });
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(workshopId, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // All done, return the warnings.
            return result;
        });
        return this.addOngoingSync(workshopId, syncPromise, siteId);
    };
    /**
     * Synchronize a submission.
     *
     * @param  {any}    workshop          Workshop.
     * @param  {any[]}  submissionActions Submission actions offline data.
     * @param  {any}    result            Object with the result of the sync.
     * @param  {string} siteId            Site ID.
     * @return {Promise<any>}             Promise resolved if success, rejected otherwise.
     */
    AddonModWorkshopSyncProvider.prototype.syncSubmission = function (workshop, submissionActions, result, siteId) {
        var _this = this;
        var discardError;
        var editing = false;
        // Sort entries by timemodified.
        submissionActions = submissionActions.sort(function (a, b) {
            return a.timemodified - b.timemodified;
        });
        var timePromise = null;
        var submissionId = submissionActions[0].submissionid;
        if (submissionId > 0) {
            editing = true;
            timePromise = this.workshopProvider.getSubmission(workshop.id, submissionId, siteId).then(function (submission) {
                return submission.timemodified;
            }).catch(function () {
                return -1;
            });
        }
        else {
            timePromise = Promise.resolve(0);
        }
        return timePromise.then(function (timemodified) {
            if (timemodified < 0 || timemodified >= submissionActions[0].timemodified) {
                // The entry was not found in Moodle or the entry has been modified, discard the action.
                result.updated = true;
                discardError = _this.translate.instant('addon.mod_workshop.warningsubmissionmodified');
                return _this.workshopOffline.deleteAllSubmissionActions(workshop.id, submissionId, siteId);
            }
            var promise = Promise.resolve();
            submissionActions.forEach(function (action) {
                promise = promise.then(function () {
                    submissionId = action.submissionid > 0 ? action.submissionid : submissionId;
                    var fileProm;
                    // Upload attachments first if any.
                    if (action.attachmentsid) {
                        fileProm = _this.workshopHelper.getSubmissionFilesFromOfflineFilesObject(action.attachmentsid, workshop.id, submissionId, editing, siteId).then(function (files) {
                            return _this.workshopHelper.uploadOrStoreSubmissionFiles(workshop.id, submissionId, files, editing, false, siteId);
                        });
                    }
                    else {
                        // Remove all files.
                        fileProm = _this.workshopHelper.uploadOrStoreSubmissionFiles(workshop.id, submissionId, [], editing, false, siteId);
                    }
                    return fileProm.then(function (attachmentsId) {
                        if (workshop.submissiontypefile == __WEBPACK_IMPORTED_MODULE_13__workshop__["a" /* AddonModWorkshopProvider */].SUBMISSION_TYPE_DISABLED) {
                            attachmentsId = null;
                        }
                        // Perform the action.
                        switch (action.action) {
                            case 'add':
                                return _this.workshopProvider.addSubmissionOnline(workshop.id, action.title, action.content, attachmentsId, siteId).then(function (newSubmissionId) {
                                    submissionId = newSubmissionId;
                                });
                            case 'update':
                                return _this.workshopProvider.updateSubmissionOnline(submissionId, action.title, action.content, attachmentsId, siteId);
                            case 'delete':
                                return _this.workshopProvider.deleteSubmissionOnline(submissionId, siteId);
                            default:
                                return Promise.resolve();
                        }
                    }).catch(function (error) {
                        if (error && _this.utils.isWebServiceError(error)) {
                            // The WebService has thrown an error, this means it cannot be performed. Discard.
                            discardError = _this.textUtils.getErrorMessageFromError(error);
                        }
                        else {
                            // Couldn't connect to server, reject.
                            return Promise.reject(error);
                        }
                    }).then(function () {
                        // Delete the offline data.
                        result.updated = true;
                        return _this.workshopOffline.deleteSubmissionAction(action.workshopid, action.submissionid, action.action, siteId).then(function () {
                            // Delete stored files.
                            if (action.action == 'add' || action.action == 'update') {
                                var editing_1 = action.action == 'update';
                                return _this.workshopHelper.deleteSubmissionStoredFiles(action.workshopid, action.submissionid, editing_1, siteId);
                            }
                        });
                    });
                });
            });
            return promise.then(function () {
                if (discardError) {
                    // Submission was discarded, add a warning.
                    var message = _this.translate.instant('core.warningofflinedatadeleted', {
                        component: _this.componentTranslate,
                        name: workshop.name,
                        error: discardError
                    });
                    if (result.warnings.indexOf(message) == -1) {
                        result.warnings.push(message);
                    }
                }
            });
        });
    };
    /**
     * Synchronize an assessment.
     *
     * @param  {any}    workshop   Workshop.
     * @param  {any}    assessment Assessment offline data.
     * @param  {any}    result     Object with the result of the sync.
     * @param  {string} siteId     Site ID.
     * @return {Promise<any>}      Promise resolved if success, rejected otherwise.
     */
    AddonModWorkshopSyncProvider.prototype.syncAssessment = function (workshop, assessmentData, result, siteId) {
        var _this = this;
        var discardError;
        var assessmentId = assessmentData.assessmentid;
        var timePromise = this.workshopProvider.getAssessment(workshop.id, assessmentId, siteId).then(function (assessment) {
            return assessment.timemodified;
        }).catch(function () {
            return -1;
        });
        return timePromise.then(function (timemodified) {
            if (timemodified < 0 || timemodified >= assessmentData.timemodified) {
                // The entry was not found in Moodle or the entry has been modified, discard the action.
                result.updated = true;
                discardError = _this.translate.instant('addon.mod_workshop.warningassessmentmodified');
                return _this.workshopOffline.deleteAssessment(workshop.id, assessmentId, siteId);
            }
            var fileProm;
            var inputData = assessmentData.inputdata;
            // Upload attachments first if any.
            if (inputData.feedbackauthorattachmentsid) {
                fileProm = _this.workshopHelper.getAssessmentFilesFromOfflineFilesObject(inputData.feedbackauthorattachmentsid, workshop.id, assessmentId, siteId).then(function (files) {
                    return _this.workshopHelper.uploadOrStoreAssessmentFiles(workshop.id, assessmentId, files, false, siteId);
                });
            }
            else {
                // Remove all files.
                fileProm = _this.workshopHelper.uploadOrStoreAssessmentFiles(workshop.id, assessmentId, [], false, siteId);
            }
            return fileProm.then(function (attachmentsId) {
                inputData.feedbackauthorattachmentsid = attachmentsId || 0;
                return _this.workshopProvider.updateAssessmentOnline(assessmentId, inputData, siteId);
            }).catch(function (error) {
                if (error && _this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means it cannot be performed. Discard.
                    discardError = _this.textUtils.getErrorMessageFromError(error);
                }
                else {
                    // Couldn't connect to server, reject.
                    return Promise.reject(error);
                }
            }).then(function () {
                // Delete the offline data.
                result.updated = true;
                return _this.workshopOffline.deleteAssessment(workshop.id, assessmentId, siteId).then(function () {
                    _this.workshopHelper.deleteAssessmentStoredFiles(workshop.id, assessmentId, siteId);
                });
            });
        }).then(function () {
            if (discardError) {
                // Assessment was discarded, add a warning.
                var message = _this.translate.instant('core.warningofflinedatadeleted', {
                    component: _this.componentTranslate,
                    name: workshop.name,
                    error: discardError
                });
                if (result.warnings.indexOf(message) == -1) {
                    result.warnings.push(message);
                }
            }
        });
    };
    /**
     * Synchronize a submission evaluation.
     *
     * @param  {any}    workshop Workshop.
     * @param  {any}    evaluate Submission evaluation offline data.
     * @param  {any}    result   Object with the result of the sync.
     * @param  {string} siteId   Site ID.
     * @return {Promise<any>}    Promise resolved if success, rejected otherwise.
     */
    AddonModWorkshopSyncProvider.prototype.syncEvaluateSubmission = function (workshop, evaluate, result, siteId) {
        var _this = this;
        var discardError;
        var submissionId = evaluate.submissionid;
        var timePromise = this.workshopProvider.getSubmission(workshop.id, submissionId, siteId).then(function (submission) {
            return submission.timemodified;
        }).catch(function () {
            return -1;
        });
        return timePromise.then(function (timemodified) {
            if (timemodified < 0 || timemodified >= evaluate.timemodified) {
                // The entry was not found in Moodle or the entry has been modified, discard the action.
                result.updated = true;
                discardError = _this.translate.instant('addon.mod_workshop.warningsubmissionmodified');
                return _this.workshopOffline.deleteEvaluateSubmission(workshop.id, submissionId, siteId);
            }
            return _this.workshopProvider.evaluateSubmissionOnline(submissionId, evaluate.feedbacktext, evaluate.published, evaluate.gradeover, siteId).catch(function (error) {
                if (error && _this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means it cannot be performed. Discard.
                    discardError = _this.textUtils.getErrorMessageFromError(error);
                }
                else {
                    // Couldn't connect to server, reject.
                    return Promise.reject(error);
                }
            }).then(function () {
                // Delete the offline data.
                result.updated = true;
                return _this.workshopOffline.deleteEvaluateSubmission(workshop.id, submissionId, siteId);
            });
        }).then(function () {
            if (discardError) {
                // Assessment was discarded, add a warning.
                var message = _this.translate.instant('core.warningofflinedatadeleted', {
                    component: _this.componentTranslate,
                    name: workshop.name,
                    error: discardError
                });
                if (result.warnings.indexOf(message) == -1) {
                    result.warnings.push(message);
                }
            }
        });
    };
    /**
     * Synchronize a assessment evaluation.
     *
     * @param  {any}    workshop Workshop.
     * @param  {any}    evaluate Assessment evaluation offline data.
     * @param  {any}    result   Object with the result of the sync.
     * @param  {string} siteId   Site ID.
     * @return {Promise<any>}    Promise resolved if success, rejected otherwise.
     */
    AddonModWorkshopSyncProvider.prototype.syncEvaluateAssessment = function (workshop, evaluate, result, siteId) {
        var _this = this;
        var discardError;
        var assessmentId = evaluate.assessmentid;
        var timePromise = this.workshopProvider.getAssessment(workshop.id, assessmentId, siteId).then(function (assessment) {
            return assessment.timemodified;
        }).catch(function () {
            return -1;
        });
        return timePromise.then(function (timemodified) {
            if (timemodified < 0 || timemodified >= evaluate.timemodified) {
                // The entry was not found in Moodle or the entry has been modified, discard the action.
                result.updated = true;
                discardError = _this.translate.instant('addon.mod_workshop.warningassessmentmodified');
                return _this.workshopOffline.deleteEvaluateAssessment(workshop.id, assessmentId, siteId);
            }
            return _this.workshopProvider.evaluateAssessmentOnline(assessmentId, evaluate.feedbacktext, evaluate.weight, evaluate.gradinggradeover, siteId).catch(function (error) {
                if (error && _this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means it cannot be performed. Discard.
                    discardError = _this.textUtils.getErrorMessageFromError(error);
                }
                else {
                    // Couldn't connect to server, reject.
                    return Promise.reject(error);
                }
            }).then(function () {
                // Delete the offline data.
                result.updated = true;
                return _this.workshopOffline.deleteEvaluateAssessment(workshop.id, assessmentId, siteId);
            });
        }).then(function () {
            if (discardError) {
                // Assessment was discarded, add a warning.
                var message = _this.translate.instant('core.warningofflinedatadeleted', {
                    component: _this.componentTranslate,
                    name: workshop.name,
                    error: discardError
                });
                if (result.warnings.indexOf(message) == -1) {
                    result.warnings.push(message);
                }
            }
        });
    };
    AddonModWorkshopSyncProvider.AUTO_SYNCED = 'addon_mod_workshop_autom_synced';
    AddonModWorkshopSyncProvider.MANUAL_SYNCED = 'addon_mod_workshop_manual_synced';
    AddonModWorkshopSyncProvider = AddonModWorkshopSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_sync__["a" /* CoreSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__workshop__["a" /* AddonModWorkshopProvider */],
            __WEBPACK_IMPORTED_MODULE_14__helper__["a" /* AddonModWorkshopHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_15__offline__["a" /* AddonModWorkshopOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModWorkshopSyncProvider);
    return AddonModWorkshopSyncProvider;
    var AddonModWorkshopSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_2__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 222 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_grades_providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__submission_delegate__ = __webpack_require__(107);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















/**
 * Service to sync assigns.
 */
var AddonModAssignSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModAssignSyncProvider, _super);
    function AddonModAssignSyncProvider(loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, courseProvider, eventsProvider, assignProvider, assignOfflineProvider, utils, submissionDelegate, gradesHelper, timeUtils, logHelper) {
        var _this = _super.call(this, 'AddonModAssignSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.courseProvider = courseProvider;
        _this.eventsProvider = eventsProvider;
        _this.assignProvider = assignProvider;
        _this.assignOfflineProvider = assignOfflineProvider;
        _this.utils = utils;
        _this.submissionDelegate = submissionDelegate;
        _this.gradesHelper = gradesHelper;
        _this.logHelper = logHelper;
        _this.componentTranslate = courseProvider.translateModuleName('assign');
        return _this;
    }
    AddonModAssignSyncProvider_1 = AddonModAssignSyncProvider;
    /**
     * Convenience function to get scale selected option.
     *
     * @param {string} options Possible options.
     * @param {number} selected Selected option to search.
     * @return {number} Index of the selected option.
     */
    AddonModAssignSyncProvider.prototype.getSelectedScaleId = function (options, selected) {
        var optionsList = options.split(',');
        optionsList = optionsList.map(function (value) {
            return value.trim();
        });
        optionsList.unshift('');
        var index = options.indexOf(selected) || 0;
        if (index < 0) {
            return 0;
        }
        return index;
    };
    /**
     * Check if an assignment has data to synchronize.
     *
     * @param {number} assignId Assign ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it has data to sync.
     */
    AddonModAssignSyncProvider.prototype.hasDataToSync = function (assignId, siteId) {
        return this.assignOfflineProvider.hasAssignOfflineData(assignId, siteId);
    };
    /**
     * Try to synchronize all the assignments in a certain site or in all sites.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force Wether to force sync not depending on last execution.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModAssignSyncProvider.prototype.syncAllAssignments = function (siteId, force) {
        return this.syncOnSites('all assignments', this.syncAllAssignmentsFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all assignments on a site.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModAssignSyncProvider.prototype.syncAllAssignmentsFunc = function (siteId, force) {
        var _this = this;
        // Get all assignments that have offline data.
        return this.assignOfflineProvider.getAllAssigns(siteId).then(function (assignIds) {
            // Sync all assignments that haven't been synced for a while.
            var promises = assignIds.map(function (assignId) {
                var promise = force ? _this.syncAssign(assignId, siteId) : _this.syncAssignIfNeeded(assignId, siteId);
                return promise.then(function (data) {
                    if (data && data.updated) {
                        // Sync done. Send event.
                        _this.eventsProvider.trigger(AddonModAssignSyncProvider_1.AUTO_SYNCED, {
                            assignId: assignId,
                            warnings: data.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(promises);
        });
    };
    /**
     * Sync an assignment only if a certain time has passed since the last time.
     *
     * @param {number} assignId Assign ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<void|AddonModAssignSyncResult>} Promise resolved when the assign is synced or it doesn't need to be synced.
     */
    AddonModAssignSyncProvider.prototype.syncAssignIfNeeded = function (assignId, siteId) {
        var _this = this;
        return this.isSyncNeeded(assignId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncAssign(assignId, siteId);
            }
        });
    };
    /**
     * Try to synchronize an assign.
     *
     * @param {number} assignId Assign ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModAssignSyncResult>} Promise resolved in success.
     */
    AddonModAssignSyncProvider.prototype.syncAssign = function (assignId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [], result = {
            warnings: [],
            updated: false
        };
        var assign, courseId, syncPromise;
        if (this.isSyncing(assignId, siteId)) {
            // There's already a sync ongoing for this assign, return the promise.
            return this.getOngoingSync(assignId, siteId);
        }
        // Verify that assign isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_14__assign__["a" /* AddonModAssignProvider */].COMPONENT, assignId, siteId)) {
            this.logger.debug('Cannot sync assign ' + assignId + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync assign ' + assignId + ' in site ' + siteId);
        // Get offline submissions to be sent.
        promises.push(this.assignOfflineProvider.getAssignSubmissions(assignId, siteId).catch(function () {
            // No offline data found, return empty array.
            return [];
        }));
        // Get offline submission grades to be sent.
        promises.push(this.assignOfflineProvider.getAssignSubmissionsGrade(assignId, siteId).catch(function () {
            // No offline data found, return empty array.
            return [];
        }));
        // Sync offline logs.
        promises.push(this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_14__assign__["a" /* AddonModAssignProvider */].COMPONENT, assignId, siteId));
        syncPromise = Promise.all(promises).then(function (results) {
            var submissions = results[0], grades = results[1];
            if (!submissions.length && !grades.length) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            courseId = submissions.length > 0 ? submissions[0].courseid : grades[0].courseid;
            return _this.assignProvider.getAssignmentById(courseId, assignId, false, siteId).then(function (assignData) {
                assign = assignData;
                var promises = [];
                submissions.forEach(function (submission) {
                    promises.push(_this.syncSubmission(assign, submission, result.warnings, siteId).then(function () {
                        result.updated = true;
                    }));
                });
                grades.forEach(function (grade) {
                    promises.push(_this.syncSubmissionGrade(assign, grade, result.warnings, courseId, siteId).then(function () {
                        result.updated = true;
                    }));
                });
                return Promise.all(promises);
            }).then(function () {
                if (result.updated) {
                    // Data has been sent to server. Now invalidate the WS calls.
                    return _this.assignProvider.invalidateContent(assign.cmid, courseId, siteId).catch(function () {
                        // Ignore errors.
                    });
                }
            });
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(assignId, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // All done, return the result.
            return result;
        });
        return this.addOngoingSync(assignId, syncPromise, siteId);
    };
    /**
     * Synchronize a submission.
     *
     * @param {any} assign Assignment.
     * @param {any} offlineData Submission offline data.
     * @param {string[]} warnings List of warnings.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success, rejected otherwise.
     */
    AddonModAssignSyncProvider.prototype.syncSubmission = function (assign, offlineData, warnings, siteId) {
        var _this = this;
        var userId = offlineData.userid, pluginData = {};
        var discardError, submission;
        return this.assignProvider.getSubmissionStatus(assign.id, userId, undefined, false, true, true, siteId).then(function (status) {
            var promises = [];
            submission = _this.assignProvider.getSubmissionObjectFromAttempt(assign, status.lastattempt);
            if (submission.timemodified != offlineData.onlinetimemodified) {
                // The submission was modified in Moodle, discard the submission.
                discardError = _this.translate.instant('addon.mod_assign.warningsubmissionmodified');
                return;
            }
            submission.plugins.forEach(function (plugin) {
                promises.push(_this.submissionDelegate.preparePluginSyncData(assign, submission, plugin, offlineData, pluginData, siteId));
            });
            return Promise.all(promises).then(function () {
                // Now save the submission.
                var promise;
                if (!Object.keys(pluginData).length) {
                    // Nothing to save.
                    promise = Promise.resolve();
                }
                else {
                    promise = _this.assignProvider.saveSubmissionOnline(assign.id, pluginData, siteId);
                }
                return promise.then(function () {
                    if (assign.submissiondrafts && offlineData.submitted) {
                        // The user submitted the assign manually. Submit it for grading.
                        return _this.assignProvider.submitForGradingOnline(assign.id, offlineData.submissionstatement, siteId);
                    }
                }).then(function () {
                    // Submission data sent, update cached data. No need to block the user for this.
                    _this.assignProvider.getSubmissionStatus(assign.id, userId, undefined, false, true, true, siteId);
                });
            }).catch(function (error) {
                if (error && _this.utils.isWebServiceError(error)) {
                    // A WebService has thrown an error, this means it cannot be submitted. Discard the submission.
                    discardError = _this.textUtils.getErrorMessageFromError(error);
                }
                else {
                    // Couldn't connect to server, reject.
                    return Promise.reject(error);
                }
            });
        }).then(function () {
            // Delete the offline data.
            return _this.assignOfflineProvider.deleteSubmission(assign.id, userId, siteId).then(function () {
                var promises = [];
                submission.plugins.forEach(function (plugin) {
                    promises.push(_this.submissionDelegate.deletePluginOfflineData(assign, submission, plugin, offlineData, siteId));
                });
                return Promise.all(promises);
            });
        }).then(function () {
            if (discardError) {
                // Submission was discarded, add a warning.
                var message = _this.translate.instant('core.warningofflinedatadeleted', {
                    component: _this.componentTranslate,
                    name: assign.name,
                    error: discardError
                });
                if (warnings.indexOf(message) == -1) {
                    warnings.push(message);
                }
            }
        });
    };
    /**
     * Synchronize a submission grade.
     *
     * @param {any} assign Assignment.
     * @param {any} offlineData Submission grade offline data.
     * @param {string[]} warnings List of warnings.
     * @param {number} courseId Course Id.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success, rejected otherwise.
     */
    AddonModAssignSyncProvider.prototype.syncSubmissionGrade = function (assign, offlineData, warnings, courseId, siteId) {
        var _this = this;
        var userId = offlineData.userid;
        var discardError;
        return this.assignProvider.getSubmissionStatus(assign.id, userId, undefined, false, true, true, siteId).then(function (status) {
            var timemodified = status.feedback && (status.feedback.gradeddate || status.feedback.grade.timemodified);
            if (timemodified > offlineData.timemodified) {
                // The submission grade was modified in Moodle, discard it.
                discardError = _this.translate.instant('addon.mod_assign.warningsubmissiongrademodified');
                return;
            }
            // If grade has been modified from gradebook, do not use offline.
            return _this.gradesHelper.getGradeModuleItems(courseId, assign.cmid, userId, undefined, siteId, true).then(function (grades) {
                return _this.courseProvider.getModuleBasicGradeInfo(assign.cmid, siteId).then(function (gradeInfo) {
                    // Override offline grade and outcomes based on the gradebook data.
                    grades.forEach(function (grade) {
                        if (grade.gradedategraded >= offlineData.timemodified) {
                            if (!grade.outcomeid && !grade.scaleid) {
                                if (gradeInfo && gradeInfo.scale) {
                                    offlineData.grade = _this.getSelectedScaleId(gradeInfo.scale, grade.gradeformatted);
                                }
                                else {
                                    offlineData.grade = parseFloat(grade.gradeformatted) || null;
                                }
                            }
                            else if (grade.outcomeid && _this.assignProvider.isOutcomesEditEnabled() && gradeInfo.outcomes) {
                                gradeInfo.outcomes.forEach(function (outcome, index) {
                                    if (outcome.scale && grade.itemnumber == index) {
                                        offlineData.outcomes[grade.itemnumber] = _this.getSelectedScaleId(outcome.scale, outcome.selected);
                                    }
                                });
                            }
                        }
                    });
                });
            }).then(function () {
                // Now submit the grade.
                return _this.assignProvider.submitGradingFormOnline(assign.id, userId, offlineData.grade, offlineData.attemptnumber, offlineData.addattempt, offlineData.workflowstate, offlineData.applytoall, offlineData.outcomes, offlineData.plugindata, siteId).then(function () {
                    // Grades sent, update cached data. No need to block the user for this.
                    _this.assignProvider.getSubmissionStatus(assign.id, userId, undefined, false, true, true, siteId);
                }).catch(function (error) {
                    if (error && _this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means it cannot be submitted. Discard the offline data.
                        discardError = _this.textUtils.getErrorMessageFromError(error);
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                });
            });
        }).then(function () {
            // Delete the offline data.
            return _this.assignOfflineProvider.deleteSubmissionGrade(assign.id, userId, siteId);
        }).then(function () {
            if (discardError) {
                // Submission grade was discarded, add a warning.
                var message = _this.translate.instant('core.warningofflinedatadeleted', {
                    component: _this.componentTranslate,
                    name: assign.name,
                    error: discardError
                });
                if (warnings.indexOf(message) == -1) {
                    warnings.push(message);
                }
            }
        });
    };
    AddonModAssignSyncProvider.AUTO_SYNCED = 'addon_mod_assign_autom_synced';
    AddonModAssignSyncProvider = AddonModAssignSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_14__assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_15__assign_offline__["a" /* AddonModAssignOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_16__submission_delegate__["a" /* AddonModAssignSubmissionDelegate */],
            __WEBPACK_IMPORTED_MODULE_12__core_grades_providers_helper__["a" /* CoreGradesHelperProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModAssignSyncProvider);
    return AddonModAssignSyncProvider;
    var AddonModAssignSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_13__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=assign-sync.js.map

/***/ }),
/* 223 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSettingsDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Service to interact with addons to be shown in app settings. Provides functions to register a plugin
 * and notify an update in the data.
 */
var CoreSettingsDelegate = /** @class */ (function (_super) {
    __extends(CoreSettingsDelegate, _super);
    function CoreSettingsDelegate(loggerProvider, sitesProvider, eventsProvider, utils) {
        var _this = _super.call(this, 'CoreSettingsDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.loggerProvider = loggerProvider;
        _this.sitesProvider = sitesProvider;
        _this.eventsProvider = eventsProvider;
        _this.utils = utils;
        _this.siteHandlers = []; // Handlers to return.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGOUT, _this.clearSiteHandlers.bind(_this));
        return _this;
    }
    /**
     * Clear current site handlers. Reserved for core use.
     */
    CoreSettingsDelegate.prototype.clearSiteHandlers = function () {
        this.siteHandlers = [];
    };
    /**
     * Get the handlers for the current site.
     *
     * @return {CoreSettingsHandlerData[]}
     */
    CoreSettingsDelegate.prototype.getHandlers = function () {
        return this.siteHandlers;
    };
    /**
     * Update handlers Data.
     */
    CoreSettingsDelegate.prototype.updateData = function () {
        var handlersData = [];
        for (var name_1 in this.enabledHandlers) {
            var handler = this.enabledHandlers[name_1], data = handler.getDisplayData();
            handlersData.push({
                data: data,
                priority: handler.priority
            });
        }
        // Sort them by priority.
        handlersData.sort(function (a, b) {
            return b.priority - a.priority;
        });
        // Return only the display data.
        this.siteHandlers = handlersData.map(function (item) {
            return item.data;
        });
    };
    CoreSettingsDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreSettingsDelegate);
    return CoreSettingsDelegate;
}(__WEBPACK_IMPORTED_MODULE_1__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 224 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(267);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_classes_activity_sync__ = __webpack_require__(178);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__ = __webpack_require__(845);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















/**
 * Service to sync feedbacks.
 */
var AddonModFeedbackSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModFeedbackSyncProvider, _super);
    function AddonModFeedbackSyncProvider(sitesProvider, loggerProvider, appProvider, feedbackOffline, eventsProvider, feedbackProvider, translate, utils, textUtils, courseProvider, syncProvider, timeUtils, logHelper, prefetchDelegate, prefetchHandler) {
        var _this = _super.call(this, 'AddonModFeedbackSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils, prefetchDelegate, prefetchHandler) || this;
        _this.sitesProvider = sitesProvider;
        _this.loggerProvider = loggerProvider;
        _this.appProvider = appProvider;
        _this.feedbackOffline = feedbackOffline;
        _this.eventsProvider = eventsProvider;
        _this.feedbackProvider = feedbackProvider;
        _this.translate = translate;
        _this.utils = utils;
        _this.textUtils = textUtils;
        _this.courseProvider = courseProvider;
        _this.logHelper = logHelper;
        _this.componentTranslate = courseProvider.translateModuleName('feedback');
        return _this;
    }
    AddonModFeedbackSyncProvider_1 = AddonModFeedbackSyncProvider;
    /**
     * Conveniece function to prefetch data after an update.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID.
     * @param {RegExp} [regex] If regex matches, don't download the data. Defaults to check files and timers.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackSyncProvider.prototype.prefetchAfterUpdate = function (module, courseId, regex, siteId) {
        regex = regex || /^.*files$|^timers/;
        return _super.prototype.prefetchAfterUpdate.call(this, module, courseId, regex, siteId);
    };
    /**
     * Try to synchronize all the feedbacks in a certain site or in all sites.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModFeedbackSyncProvider.prototype.syncAllFeedbacks = function (siteId, force) {
        return this.syncOnSites('all feedbacks', this.syncAllFeedbacksFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all pending feedbacks on a site.
     *
     * @param {string}  [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force    Wether to force sync not depending on last execution.
     * @param {Promise<any>}     Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModFeedbackSyncProvider.prototype.syncAllFeedbacksFunc = function (siteId, force) {
        var _this = this;
        // Sync all new responses.
        return this.feedbackOffline.getAllFeedbackResponses(siteId).then(function (responses) {
            var promises = {};
            var _loop_1 = function (i) {
                var response = responses[i];
                if (typeof promises[response.feedbackid] != 'undefined') {
                    return "continue";
                }
                promises[response.feedbackid] = force ? _this.syncFeedback(response.feedbackid, siteId) :
                    _this.syncFeedbackIfNeeded(response.feedbackid, siteId);
                promises[response.feedbackid].then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModFeedbackSyncProvider_1.AUTO_SYNCED, {
                            feedbackId: response.feedbackid,
                            userId: response.userid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            };
            // Do not sync same feedback twice.
            for (var i in responses) {
                _loop_1(i);
            }
            // Promises will be an object so, convert to an array first;
            return Promise.all(_this.utils.objectToArray(promises));
        });
    };
    /**
     * Sync a feedback only if a certain time has passed since the last time.
     *
     * @param  {number} feedbackId  Feedback ID.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved when the feedback is synced or if it doesn't need to be synced.
     */
    AddonModFeedbackSyncProvider.prototype.syncFeedbackIfNeeded = function (feedbackId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.isSyncNeeded(feedbackId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncFeedback(feedbackId, siteId);
            }
        });
    };
    /**
     * Synchronize all offline responses of a feedback.
     *
     * @param  {number} feedbackId Feedback ID to be synced.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModFeedbackSyncProvider.prototype.syncFeedback = function (feedbackId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = feedbackId;
        if (this.isSyncing(syncId, siteId)) {
            // There's already a sync ongoing for this feedback, return the promise.
            return this.getOngoingSync(syncId, siteId);
        }
        // Verify that feedback isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_8__feedback__["a" /* AddonModFeedbackProvider */].COMPONENT, syncId, siteId)) {
            this.logger.debug("Cannot sync feedback '" + syncId + "' because it is blocked.");
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        var result = {
            warnings: [],
            updated: false
        };
        var courseId, feedback;
        this.logger.debug("Try to sync feedback '" + feedbackId + "' in site " + siteId + "'");
        // Sync offline logs.
        var syncPromise = this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_8__feedback__["a" /* AddonModFeedbackProvider */].COMPONENT, feedbackId, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Get offline responses to be sent.
            return _this.feedbackOffline.getFeedbackResponses(feedbackId, siteId).catch(function () {
                // No offline data found, return empty array.
                return [];
            });
        }).then(function (responses) {
            if (!responses.length) {
                // Nothing to sync.
                return;
            }
            if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            courseId = responses[0].courseid;
            return _this.feedbackProvider.getFeedbackById(courseId, feedbackId, siteId).then(function (feedbackData) {
                feedback = feedbackData;
                if (!feedback.multiple_submit) {
                    // If it does not admit multiple submits, check if it is completed to know if we can submit.
                    return _this.feedbackProvider.isCompleted(feedbackId);
                }
                else {
                    return false;
                }
            }).then(function (isCompleted) {
                if (isCompleted) {
                    // Cannot submit again, delete resposes.
                    var promises_1 = [];
                    responses.forEach(function (data) {
                        promises_1.push(_this.feedbackOffline.deleteFeedbackPageResponses(feedbackId, data.page, siteId));
                    });
                    result.updated = true;
                    result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                        component: _this.componentTranslate,
                        name: feedback.name,
                        error: _this.translate.instant('addon.mod_feedback.this_feedback_is_already_submitted')
                    }));
                    return Promise.all(promises_1);
                }
                return _this.feedbackProvider.getCurrentCompletedTimeModified(feedbackId, true, siteId).then(function (timemodified) {
                    // Sort by page.
                    responses.sort(function (a, b) {
                        return a.page - b.page;
                    });
                    responses = responses.map(function (data) {
                        return {
                            func: _this.processPage.bind(_this),
                            params: [feedback, data, siteId, timemodified, result],
                            blocking: true
                        };
                    });
                    // Execute all the processes in order to solve dependencies.
                    return _this.utils.executeOrderedPromises(responses);
                });
            });
        }).then(function () {
            if (result.updated) {
                // Data has been sent to server, update data.
                return _this.courseProvider.getModuleBasicInfoByInstance(feedbackId, 'feedback', siteId).then(function (module) {
                    return _this.prefetchAfterUpdate(module, courseId, undefined, siteId);
                }).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(syncId, siteId);
        }).then(function () {
            return result;
        });
        return this.addOngoingSync(syncId, syncPromise, siteId);
    };
    /**
     * Convenience function to sync process page calls.
     *
     * @param  {any}          feedback     Feedback object.
     * @param  {any}          data         Response data.
     * @param  {string}       siteId       Site Id.
     * @param  {number}       timemodified Current completed modification time.
     * @param  {any}          result       Result object to be modified.
     * @return {Promise<any>}              Resolve when done or rejected with error.
     */
    AddonModFeedbackSyncProvider.prototype.processPage = function (feedback, data, siteId, timemodified, result) {
        var _this = this;
        // Delete all pages that are submitted before changing website.
        if (timemodified > data.timemodified) {
            return this.feedbackOffline.deleteFeedbackPageResponses(feedback.id, data.page, siteId);
        }
        return this.feedbackProvider.processPageOnline(feedback.id, data.page, data.responses, false, siteId).then(function () {
            result.updated = true;
            return _this.feedbackOffline.deleteFeedbackPageResponses(feedback.id, data.page, siteId);
        }).catch(function (error) {
            if (error && error.wserror) {
                // The WebService has thrown an error, this means that responses cannot be submitted. Delete them.
                result.updated = true;
                return _this.feedbackOffline.deleteFeedbackPageResponses(feedback.id, data.page, siteId).then(function () {
                    // Responses deleted, add a warning.
                    result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                        component: _this.componentTranslate,
                        name: feedback.name,
                        error: _this.textUtils.getErrorMessageFromError(error)
                    }));
                });
            }
            else {
                // Couldn't connect to server, reject.
                return Promise.reject(error);
            }
        });
    };
    AddonModFeedbackSyncProvider.AUTO_SYNCED = 'addon_mod_feedback_autom_synced';
    AddonModFeedbackSyncProvider = AddonModFeedbackSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* AddonModFeedbackOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_8__feedback__["a" /* AddonModFeedbackProvider */],
            __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_15__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */], __WEBPACK_IMPORTED_MODULE_14__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
            __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__["a" /* AddonModFeedbackPrefetchHandler */]])
    ], AddonModFeedbackSyncProvider);
    return AddonModFeedbackSyncProvider;
    var AddonModFeedbackSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_12__core_course_classes_activity_sync__["a" /* CoreCourseActivitySyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 225 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__lesson__ = __webpack_require__(102);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Service to handle offline lesson.
 */
var AddonModLessonOfflineProvider = /** @class */ (function () {
    function AddonModLessonOfflineProvider(logger, sitesProvider, timeUtils, textUtils, utils) {
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.textUtils = textUtils;
        this.utils = utils;
        this.siteSchema = {
            name: 'AddonModLessonOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModLessonOfflineProvider_1.RETAKES_TABLE,
                    columns: [
                        {
                            name: 'lessonid',
                            type: 'INTEGER',
                            primaryKey: true // Only 1 offline retake per lesson.
                        },
                        {
                            name: 'retake',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'finished',
                            type: 'INTEGER'
                        },
                        {
                            name: 'outoftime',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'lastquestionpage',
                            type: 'INTEGER'
                        },
                    ]
                },
                {
                    name: AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE,
                    columns: [
                        {
                            name: 'lessonid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'retake',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'pageid',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER',
                            notNull: true
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'data',
                            type: 'TEXT'
                        },
                        {
                            name: 'type',
                            type: 'INTEGER'
                        },
                        {
                            name: 'newpageid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'correct',
                            type: 'INTEGER'
                        },
                        {
                            name: 'answerid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'useranswer',
                            type: 'TEXT'
                        },
                    ],
                    // A user can attempt several times per page and retake.
                    primaryKeys: ['lessonid', 'retake', 'pageid', 'timemodified']
                }
            ]
        };
        this.logger = logger.getInstance('AddonModLessonOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModLessonOfflineProvider_1 = AddonModLessonOfflineProvider;
    /**
     * Delete an offline attempt.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Lesson retake number.
     * @param {number} pageId Page ID.
     * @param {number} timemodified The timemodified of the attempt.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonOfflineProvider.prototype.deleteAttempt = function (lessonId, retake, pageId, timemodified, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE, {
                lessonid: lessonId,
                retake: retake,
                pageid: pageId,
                timemodified: timemodified
            });
        });
    };
    /**
     * Delete offline lesson retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonOfflineProvider.prototype.deleteRetake = function (lessonId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModLessonOfflineProvider_1.RETAKES_TABLE, { lessonid: lessonId });
        });
    };
    /**
     * Delete offline attempts for a retake and page.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Lesson retake number.
     * @param {number} pageId Page ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonOfflineProvider.prototype.deleteRetakeAttemptsForPage = function (lessonId, retake, pageId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE, { lessonid: lessonId,
                retake: retake, pageid: pageId });
        });
    };
    /**
     * Mark a retake as finished.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} courseId Course ID the lesson belongs to.
     * @param {number} retake Retake number.
     * @param {boolean} finished  Whether retake is finished.
     * @param {boolean} outOfTime If the user ran out of time.
     * @param {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}           Promise resolved in success, rejected otherwise.
     */
    AddonModLessonOfflineProvider.prototype.finishRetake = function (lessonId, courseId, retake, finished, outOfTime, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Get current stored retake (if any). If not found, it will create a new one.
            return _this.getRetakeWithFallback(lessonId, courseId, retake, site.id).then(function (entry) {
                entry.finished = finished ? 1 : 0;
                entry.outoftime = outOfTime ? 1 : 0;
                entry.timemodified = _this.timeUtils.timestamp();
                return site.getDb().insertRecord(AddonModLessonOfflineProvider_1.RETAKES_TABLE, entry);
            });
        });
    };
    /**
     * Get all the offline page attempts in a certain site.
     *
     * @param {string} [siteId] Site ID. If not set, use current site.
     * @return {Promise<any>} Promise resolved when the offline attempts are retrieved.
     */
    AddonModLessonOfflineProvider.prototype.getAllAttempts = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getAllRecords(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE);
        }).then(function (attempts) {
            return _this.parsePageAttempts(attempts);
        });
    };
    /**
     * Get all the lessons that have offline data in a certain site.
     *
     * @param {string} [siteId] Site ID. If not set, use current site.
     * @return {Promise<any>} Promise resolved with an object containing the lessons.
     */
    AddonModLessonOfflineProvider.prototype.getAllLessonsWithData = function (siteId) {
        var _this = this;
        var promises = [], lessons = {};
        // Get the lessons from page attempts.
        promises.push(this.getAllAttempts(siteId).then(function (entries) {
            _this.getLessonsFromEntries(lessons, entries);
        }).catch(function () {
            // Ignore errors.
        }));
        // Get the lessons from retakes.
        promises.push(this.getAllRetakes(siteId).then(function (entries) {
            _this.getLessonsFromEntries(lessons, entries);
        }).catch(function () {
            // Ignore errors.
        }));
        return Promise.all(promises).then(function () {
            return _this.utils.objectToArray(lessons);
        });
    };
    /**
     * Get all the offline retakes in a certain site.
     *
     * @param {string} [siteId] Site ID. If not set, use current site.
     * @return {Promise<any>} Promise resolved when the offline retakes are retrieved.
     */
    AddonModLessonOfflineProvider.prototype.getAllRetakes = function (siteId) {
        return this.sitesProvider.getSiteDb(siteId).then(function (db) {
            return db.getAllRecords(AddonModLessonOfflineProvider_1.RETAKES_TABLE);
        });
    };
    /**
     * Retrieve the last offline attempt stored in a retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the attempt (undefined if no attempts).
     */
    AddonModLessonOfflineProvider.prototype.getLastQuestionPageAttempt = function (lessonId, retake, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.getRetakeWithFallback(lessonId, 0, retake, siteId).then(function (retakeData) {
            if (!retakeData.lastquestionpage) {
                // No question page attempted.
                return;
            }
            return _this.getRetakeAttemptsForPage(lessonId, retake, retakeData.lastquestionpage, siteId).then(function (attempts) {
                // Return the attempt with highest timemodified.
                return attempts.reduce(function (a, b) {
                    return a.timemodified > b.timemodified ? a : b;
                });
            });
        }).catch(function () {
            // Error, return undefined.
        });
    };
    /**
     * Retrieve all offline attempts for a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the attempts.
     */
    AddonModLessonOfflineProvider.prototype.getLessonAttempts = function (lessonId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE, { lessonid: lessonId });
        }).then(function (attempts) {
            return _this.parsePageAttempts(attempts);
        });
    };
    /**
     * Given a list of DB entries (either retakes or page attempts), get the list of lessons.
     *
     * @param {any} lessons Object where to store the lessons.
     * @param {any[]} entries List of DB entries.
     */
    AddonModLessonOfflineProvider.prototype.getLessonsFromEntries = function (lessons, entries) {
        entries.forEach(function (entry) {
            if (!lessons[entry.lessonid]) {
                lessons[entry.lessonid] = {
                    id: entry.lessonid,
                    courseId: entry.courseid
                };
            }
        });
    };
    /**
     * Get attempts for question pages and retake in a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {boolean} [correct] True to only fetch correct attempts, false to get them all.
     * @param {number} [pageId] If defined, only get attempts on this page.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with the attempts.
     */
    AddonModLessonOfflineProvider.prototype.getQuestionsAttempts = function (lessonId, retake, correct, pageId, siteId) {
        var promise;
        if (pageId) {
            // Page ID is set, only get the attempts for that page.
            promise = this.getRetakeAttemptsForPage(lessonId, retake, pageId, siteId);
        }
        else {
            // Page ID not specified, get all the attempts.
            promise = this.getRetakeAttemptsForType(lessonId, retake, __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].TYPE_QUESTION, siteId);
        }
        return promise.then(function (attempts) {
            if (correct) {
                return attempts.filter(function (attempt) {
                    return !!attempt.correct;
                });
            }
            return attempts;
        });
    };
    /**
     * Retrieve a retake from site DB.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the retake.
     */
    AddonModLessonOfflineProvider.prototype.getRetake = function (lessonId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonModLessonOfflineProvider_1.RETAKES_TABLE, { lessonid: lessonId });
        });
    };
    /**
     * Retrieve all offline attempts for a retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake   Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the retake attempts.
     */
    AddonModLessonOfflineProvider.prototype.getRetakeAttempts = function (lessonId, retake, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE, { lessonid: lessonId, retake: retake });
        }).then(function (attempts) {
            return _this.parsePageAttempts(attempts);
        });
    };
    /**
     * Retrieve offline attempts for a retake and page.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake   Lesson retake number.
     * @param {number} pageId   Page ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved with the retake attempts.
     */
    AddonModLessonOfflineProvider.prototype.getRetakeAttemptsForPage = function (lessonId, retake, pageId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE, { lessonid: lessonId, retake: retake,
                pageid: pageId });
        }).then(function (attempts) {
            return _this.parsePageAttempts(attempts);
        });
    };
    /**
     * Retrieve offline attempts for certain pages for a retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake   Retake number.
     * @param {number} type     Type of the pages to get: TYPE_QUESTION or TYPE_STRUCTURE.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved with the retake attempts.
     */
    AddonModLessonOfflineProvider.prototype.getRetakeAttemptsForType = function (lessonId, retake, type, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE, { lessonid: lessonId, retake: retake,
                type: type });
        }).then(function (attempts) {
            return _this.parsePageAttempts(attempts);
        });
    };
    /**
     * Get stored retake. If not found or doesn't match the retake number, return a new one.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} courseId Course ID the lesson belongs to.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the retake.
     */
    AddonModLessonOfflineProvider.prototype.getRetakeWithFallback = function (lessonId, courseId, retake, siteId) {
        // Get current stored retake.
        return this.getRetake(lessonId, siteId).then(function (retakeData) {
            if (retakeData.retake != retake) {
                // The stored retake doesn't match the retake number, create a new one.
                return Promise.reject(null);
            }
            return retakeData;
        }).catch(function () {
            // No retake, create a new one.
            return {
                lessonid: lessonId,
                retake: retake,
                courseid: courseId,
                finished: 0
            };
        });
    };
    /**
     * Check if there is a finished retake for a certain lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean.
     */
    AddonModLessonOfflineProvider.prototype.hasFinishedRetake = function (lessonId, siteId) {
        return this.getRetake(lessonId, siteId).then(function (retake) {
            return !!retake.finished;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Check if a lesson has offline data.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean.
     */
    AddonModLessonOfflineProvider.prototype.hasOfflineData = function (lessonId, siteId) {
        var promises = [];
        var hasData = false;
        promises.push(this.getRetake(lessonId, siteId).then(function () {
            hasData = true;
        }).catch(function () {
            // Ignore errors.
        }));
        promises.push(this.getLessonAttempts(lessonId, siteId).then(function (attempts) {
            hasData = hasData || !!attempts.length;
        }).catch(function () {
            // Ignore errors.
        }));
        return Promise.all(promises).then(function () {
            return hasData;
        });
    };
    /**
     * Check if there are offline attempts for a retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with a boolean.
     */
    AddonModLessonOfflineProvider.prototype.hasRetakeAttempts = function (lessonId, retake, siteId) {
        return this.getRetakeAttempts(lessonId, retake, siteId).then(function (list) {
            return !!list.length;
        }).catch(function () {
            return false;
        });
    };
    /**
     * Parse some properties of a page attempt.
     *
     * @param {any} attempt The attempt to treat.
     * @return {any} The treated attempt.
     */
    AddonModLessonOfflineProvider.prototype.parsePageAttempt = function (attempt) {
        attempt.data = this.textUtils.parseJSON(attempt.data);
        attempt.useranswer = this.textUtils.parseJSON(attempt.useranswer);
        return attempt;
    };
    /**
     * Parse some properties of some page attempts.
     *
     * @param {any[]} attempts The attempts to treat.
     * @return {any[]} The treated attempts.
     */
    AddonModLessonOfflineProvider.prototype.parsePageAttempts = function (attempts) {
        var _this = this;
        attempts.forEach(function (attempt) {
            _this.parsePageAttempt(attempt);
        });
        return attempts;
    };
    /**
     * Process a lesson page, saving its data.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} courseId Course ID the lesson belongs to.
     * @param {number} retake Retake number.
     * @param {any} page Page.
     * @param {any} data Data to save.
     * @param {number} newPageId New page ID (calculated).
     * @param {number} [answerId] The answer ID that the user answered.
     * @param {boolean} [correct] If answer is correct. Only for question pages.
     * @param {any} [userAnswer] The user's answer (userresponse from checkAnswer).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModLessonOfflineProvider.prototype.processPage = function (lessonId, courseId, retake, page, data, newPageId, answerId, correct, userAnswer, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                lessonid: lessonId,
                retake: retake,
                pageid: page.id,
                timemodified: _this.timeUtils.timestamp(),
                courseid: courseId,
                data: data ? JSON.stringify(data) : null,
                type: page.type,
                newpageid: newPageId,
                correct: correct ? 1 : 0,
                answerid: Number(answerId),
                useranswer: userAnswer ? JSON.stringify(userAnswer) : null,
            };
            return site.getDb().insertRecord(AddonModLessonOfflineProvider_1.PAGE_ATTEMPTS_TABLE, entry);
        }).then(function () {
            if (page.type == __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].TYPE_QUESTION) {
                // It's a question page, set it as last question page attempted.
                return _this.setLastQuestionPageAttempted(lessonId, courseId, retake, page.id, siteId);
            }
        });
    };
    /**
     * Set the last question page attempted in a retake.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} courseId Course ID the lesson belongs to.
     * @param {number} retake Retake number.
     * @param {number} lastPage ID of the last question page attempted.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonModLessonOfflineProvider.prototype.setLastQuestionPageAttempted = function (lessonId, courseId, retake, lastPage, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Get current stored retake (if any). If not found, it will create a new one.
            return _this.getRetakeWithFallback(lessonId, courseId, retake, site.id).then(function (entry) {
                entry.lastquestionpage = lastPage;
                entry.timemodified = _this.timeUtils.timestamp();
                return site.getDb().insertRecord(AddonModLessonOfflineProvider_1.RETAKES_TABLE, entry);
            });
        });
    };
    // Variables for database. We use lowercase in the names to match the WS responses.
    AddonModLessonOfflineProvider.RETAKES_TABLE = 'addon_mod_lesson_retakes';
    AddonModLessonOfflineProvider.PAGE_ATTEMPTS_TABLE = 'addon_mod_lesson_page_attempts';
    AddonModLessonOfflineProvider = AddonModLessonOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModLessonOfflineProvider);
    return AddonModLessonOfflineProvider;
    var AddonModLessonOfflineProvider_1;
}());

//# sourceMappingURL=lesson-offline.js.map

/***/ }),
/* 226 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__ = __webpack_require__(178);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__lesson__ = __webpack_require__(102);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__lesson_offline__ = __webpack_require__(225);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__prefetch_handler__ = __webpack_require__(372);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















/**
 * Service to sync lesson.
 */
var AddonModLessonSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModLessonSyncProvider, _super);
    function AddonModLessonSyncProvider(loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, courseProvider, eventsProvider, lessonProvider, lessonOfflineProvider, prefetchHandler, timeUtils, utils, urlUtils, logHelper, prefetchDelegate) {
        var _this = _super.call(this, 'AddonModLessonSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils, prefetchDelegate, prefetchHandler) || this;
        _this.courseProvider = courseProvider;
        _this.eventsProvider = eventsProvider;
        _this.lessonProvider = lessonProvider;
        _this.lessonOfflineProvider = lessonOfflineProvider;
        _this.prefetchHandler = prefetchHandler;
        _this.utils = utils;
        _this.urlUtils = urlUtils;
        _this.logHelper = logHelper;
        _this.siteSchema = {
            name: 'AddonModLessonSyncProvider',
            version: 1,
            tables: [
                {
                    name: AddonModLessonSyncProvider_1.RETAKES_FINISHED_TABLE,
                    columns: [
                        {
                            name: 'lessonid',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'retake',
                            type: 'INTEGER'
                        },
                        {
                            name: 'pageid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timefinished',
                            type: 'INTEGER'
                        }
                    ]
                }
            ]
        };
        _this.componentTranslate = courseProvider.translateModuleName('lesson');
        _this.sitesProvider.registerSiteSchema(_this.siteSchema);
        return _this;
    }
    AddonModLessonSyncProvider_1 = AddonModLessonSyncProvider;
    /**
     * Unmark a retake as finished in a synchronization.
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonSyncProvider.prototype.deleteRetakeFinishedInSync = function (lessonId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModLessonSyncProvider_1.RETAKES_FINISHED_TABLE, { lessonid: lessonId });
        }).catch(function () {
            // Ignore errors, maybe there is none.
        });
    };
    /**
     * Get a retake finished in a synchronization for a certain lesson (if any).
     *
     * @param {number} lessonId Lesson ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the retake entry (undefined if no retake).
     */
    AddonModLessonSyncProvider.prototype.getRetakeFinishedInSync = function (lessonId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonModLessonSyncProvider_1.RETAKES_FINISHED_TABLE, { lessonid: lessonId });
        }).catch(function () {
            // Ignore errors, return undefined.
        });
    };
    /**
     * Check if a lesson has data to synchronize.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake  Retake number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it has data to sync.
     */
    AddonModLessonSyncProvider.prototype.hasDataToSync = function (lessonId, retake, siteId) {
        var promises = [];
        var hasDataToSync = false;
        promises.push(this.lessonOfflineProvider.hasRetakeAttempts(lessonId, retake, siteId).then(function (hasAttempts) {
            hasDataToSync = hasDataToSync || hasAttempts;
        }).catch(function () {
            // Ignore errors.
        }));
        promises.push(this.lessonOfflineProvider.hasFinishedRetake(lessonId, siteId).then(function (hasFinished) {
            hasDataToSync = hasDataToSync || hasFinished;
        }));
        return Promise.all(promises).then(function () {
            return hasDataToSync;
        });
    };
    /**
     * Mark a retake as finished in a synchronization.
     *
     * @param {number} lessonId Lesson ID.
     * @param {number} retake The retake number.
     * @param {number} pageId The page ID to start reviewing from.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonSyncProvider.prototype.setRetakeFinishedInSync = function (lessonId, retake, pageId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().insertRecord(AddonModLessonSyncProvider_1.RETAKES_FINISHED_TABLE, {
                lessonid: lessonId,
                retake: Number(retake),
                pageid: Number(pageId),
                timefinished: _this.timeUtils.timestamp()
            });
        });
    };
    /**
     * Try to synchronize all the lessons in a certain site or in all sites.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModLessonSyncProvider.prototype.syncAllLessons = function (siteId, force) {
        return this.syncOnSites('all lessons', this.syncAllLessonsFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all lessons on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModLessonSyncProvider.prototype.syncAllLessonsFunc = function (siteId, force) {
        var _this = this;
        // Get all the lessons that have something to be synchronized.
        return this.lessonOfflineProvider.getAllLessonsWithData(siteId).then(function (lessons) {
            // Sync all lessons that haven't been synced for a while.
            var promises = [];
            lessons.map(function (lesson) {
                var promise = force ? _this.syncLesson(lesson.id, false, false, siteId) :
                    _this.syncLessonIfNeeded(lesson.id, false, siteId);
                return promise.then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModLessonSyncProvider_1.AUTO_SYNCED, {
                            lessonId: lesson.id,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(promises);
        });
    };
    /**
     * Sync a lesson only if a certain time has passed since the last time.
     *
     * @param {any} lessonId Lesson ID.
     * @param {boolean} [askPreflight] Whether we should ask for password if needed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the lesson is synced or if it doesn't need to be synced.
     */
    AddonModLessonSyncProvider.prototype.syncLessonIfNeeded = function (lessonId, askPassword, siteId) {
        var _this = this;
        return this.isSyncNeeded(lessonId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncLesson(lessonId, askPassword, false, siteId);
            }
        });
    };
    /**
     * Try to synchronize a lesson.
     *
     * @param {number} lessonId Lesson ID.
     * @param {boolean} askPassword True if we should ask for password if needed, false otherwise.
     * @param {boolean} ignoreBlock True to ignore the sync block setting.
     * @param {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<AddonModLessonSyncResult>} Promise resolved in success.
     */
    AddonModLessonSyncProvider.prototype.syncLesson = function (lessonId, askPassword, ignoreBlock, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var result = {
            warnings: [],
            updated: false
        };
        var syncPromise, lesson, courseId, password, accessInfo;
        if (this.isSyncing(lessonId, siteId)) {
            // There's already a sync ongoing for this lesson, return the promise.
            return this.getOngoingSync(lessonId, siteId);
        }
        // Verify that lesson isn't blocked.
        if (!ignoreBlock && this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_15__lesson__["a" /* AddonModLessonProvider */].COMPONENT, lessonId, siteId)) {
            this.logger.debug('Cannot sync lesson ' + lessonId + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync lesson ' + lessonId + ' in site ' + siteId);
        // Sync offline logs.
        syncPromise = this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_15__lesson__["a" /* AddonModLessonProvider */].COMPONENT, lessonId, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Try to synchronize the attempts first.
            return _this.lessonOfflineProvider.getLessonAttempts(lessonId, siteId);
        }).then(function (attempts) {
            if (!attempts.length) {
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            courseId = attempts[0].courseid;
            // Get the info, access info and the lesson password if needed.
            return _this.lessonProvider.getLessonById(courseId, lessonId, false, false, siteId).then(function (lessonData) {
                lesson = lessonData;
                return _this.prefetchHandler.getLessonPassword(lessonId, false, true, askPassword, siteId);
            }).then(function (data) {
                var attemptsLength = attempts.length, promises = [];
                accessInfo = data.accessInfo;
                password = data.password;
                lesson = data.lesson || lesson;
                // Filter the attempts, get only the ones that belong to the current retake.
                attempts = attempts.filter(function (attempt) {
                    if (attempt.retake != accessInfo.attemptscount) {
                        // Attempt doesn't belong to current retake, delete.
                        promises.push(_this.lessonOfflineProvider.deleteAttempt(lesson.id, attempt.retake, attempt.pageid, attempt.timemodified, siteId).catch(function () {
                            // Ignore errors.
                        }));
                        return false;
                    }
                    return true;
                });
                if (attempts.length != attemptsLength) {
                    // Some attempts won't be sent, add a warning.
                    result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                        component: _this.componentTranslate,
                        name: lesson.name,
                        error: _this.translate.instant('addon.mod_lesson.warningretakefinished')
                    }));
                }
                return Promise.all(promises);
            }).then(function () {
                if (!attempts.length) {
                    return;
                }
                // Send the attempts in the same order they were answered.
                attempts.sort(function (a, b) {
                    return a.timemodified - b.timemodified;
                });
                attempts = attempts.map(function (attempt) {
                    return {
                        func: _this.sendAttempt.bind(_this),
                        params: [lesson, password, attempt, result, siteId],
                        blocking: true
                    };
                });
                return _this.utils.executeOrderedPromises(attempts);
            });
        }).then(function () {
            // Attempts sent or there was none. If there is a finished retake, send it.
            return _this.lessonOfflineProvider.getRetake(lessonId, siteId).then(function (retake) {
                if (!retake.finished) {
                    // The retake isn't marked as finished, nothing to send. Delete the retake.
                    return _this.lessonOfflineProvider.deleteRetake(lessonId, siteId);
                }
                else if (!_this.appProvider.isOnline()) {
                    // Cannot sync in offline.
                    return Promise.reject(null);
                }
                var promise;
                courseId = retake.courseid || courseId;
                if (lesson) {
                    // Data already retrieved when syncing attempts.
                    promise = Promise.resolve();
                }
                else {
                    promise = _this.lessonProvider.getLessonById(courseId, lessonId, false, false, siteId).then(function (lessonData) {
                        lesson = lessonData;
                        return _this.prefetchHandler.getLessonPassword(lessonId, false, true, askPassword, siteId);
                    }).then(function (data) {
                        accessInfo = data.accessInfo;
                        password = data.password;
                        lesson = data.lesson || lesson;
                    });
                }
                return promise.then(function () {
                    if (retake.retake != accessInfo.attemptscount) {
                        // The retake changed, add a warning if it isn't there already.
                        if (!result.warnings.length) {
                            result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: lesson.name,
                                error: _this.translate.instant('addon.mod_lesson.warningretakefinished')
                            }));
                        }
                        return _this.lessonOfflineProvider.deleteRetake(lessonId, siteId);
                    }
                    // All good, finish the retake.
                    return _this.lessonProvider.finishRetakeOnline(lessonId, password, false, false, siteId).then(function (response) {
                        result.updated = true;
                        if (!ignoreBlock) {
                            // Mark the retake as finished in a sync if it can be reviewed.
                            if (response.data && response.data.reviewlesson) {
                                var params = _this.urlUtils.extractUrlParams(response.data.reviewlesson.value);
                                if (params && params.pageid) {
                                    // The retake can be reviewed, mark it as finished. Don't block the user for this.
                                    _this.setRetakeFinishedInSync(lessonId, retake.retake, params.pageid, siteId);
                                }
                            }
                        }
                        return _this.lessonOfflineProvider.deleteRetake(lessonId, siteId);
                    }).catch(function (error) {
                        if (error && _this.utils.isWebServiceError(error)) {
                            // The WebService has thrown an error, this means that responses cannot be submitted. Delete them.
                            result.updated = true;
                            return _this.lessonOfflineProvider.deleteRetake(lessonId, siteId).then(function () {
                                // Retake deleted, add a warning.
                                result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                    component: _this.componentTranslate,
                                    name: lesson.name,
                                    error: _this.textUtils.getErrorMessageFromError(error)
                                }));
                            });
                        }
                        else {
                            // Couldn't connect to server, reject.
                            return Promise.reject(error);
                        }
                    });
                });
            }, function () {
                // No retake stored, nothing to do.
            });
        }).then(function () {
            if (result.updated && courseId) {
                // Data has been sent to server, update data.
                return _this.courseProvider.getModuleBasicInfoByInstance(lessonId, 'lesson', siteId).then(function (module) {
                    return _this.prefetchAfterUpdate(module, courseId, undefined, siteId);
                }).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(lessonId, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // All done, return the result.
            return result;
        });
        return this.addOngoingSync(lessonId, syncPromise, siteId);
    };
    /**
     * Send an attempt to the site and delete it afterwards.
     *
     * @param {any} lesson Lesson.
     * @param {string} password Password (if any).
     * @param {any} attempt Attempt to send.
     * @param {AddonModLessonSyncResult} result Result where to store the data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonSyncProvider.prototype.sendAttempt = function (lesson, password, attempt, result, siteId) {
        var _this = this;
        return this.lessonProvider.processPageOnline(lesson.id, attempt.pageid, attempt.data, password, false, siteId).then(function () {
            result.updated = true;
            return _this.lessonOfflineProvider.deleteAttempt(lesson.id, attempt.retake, attempt.pageid, attempt.timemodified, siteId);
        }).catch(function (error) {
            if (error && _this.utils.isWebServiceError(error)) {
                // The WebService has thrown an error, this means that the attempt cannot be submitted. Delete it.
                result.updated = true;
                return _this.lessonOfflineProvider.deleteAttempt(lesson.id, attempt.retake, attempt.pageid, attempt.timemodified, siteId).then(function () {
                    // Attempt deleted, add a warning.
                    result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                        component: _this.componentTranslate,
                        name: lesson.name,
                        error: _this.textUtils.getErrorMessageFromError(error)
                    }));
                });
            }
            else {
                // Couldn't connect to server, reject.
                return Promise.reject(error);
            }
        });
    };
    AddonModLessonSyncProvider.AUTO_SYNCED = 'addon_mod_lesson_autom_synced';
    // Variables for database.
    AddonModLessonSyncProvider.RETAKES_FINISHED_TABLE = 'addon_mod_lesson_retakes_finished_sync';
    AddonModLessonSyncProvider = AddonModLessonSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_15__lesson__["a" /* AddonModLessonProvider */], __WEBPACK_IMPORTED_MODULE_16__lesson_offline__["a" /* AddonModLessonOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_17__prefetch_handler__["a" /* AddonModLessonPrefetchHandler */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */], __WEBPACK_IMPORTED_MODULE_13__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */]])
    ], AddonModLessonSyncProvider);
    return AddonModLessonSyncProvider;
    var AddonModLessonSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__["a" /* CoreCourseActivitySyncBaseProvider */]));

//# sourceMappingURL=lesson-sync.js.map

/***/ }),
/* 227 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_course_classes_activity_sync__ = __webpack_require__(178);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__scorm__ = __webpack_require__(168);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__scorm_offline__ = __webpack_require__(216);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__ = __webpack_require__(376);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















/**
 * Service to sync SCORMs.
 */
var AddonModScormSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModScormSyncProvider, _super);
    function AddonModScormSyncProvider(loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, eventsProvider, timeUtils, scormProvider, scormOfflineProvider, prefetchHandler, utils, prefetchDelegate, courseProvider, logHelper) {
        var _this = _super.call(this, 'AddonModScormSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils, prefetchDelegate, prefetchHandler) || this;
        _this.eventsProvider = eventsProvider;
        _this.scormProvider = scormProvider;
        _this.scormOfflineProvider = scormOfflineProvider;
        _this.utils = utils;
        _this.courseProvider = courseProvider;
        _this.logHelper = logHelper;
        _this.componentTranslate = courseProvider.translateModuleName('scorm');
        return _this;
    }
    AddonModScormSyncProvider_1 = AddonModScormSyncProvider;
    /**
     * Add an offline attempt to the right of the new attempts array if possible.
     * If the attempt cannot be created as a new attempt then it will be deleted.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt The offline attempt to treat.
     * @param {number} lastOffline Last offline attempt number.
     * @param {number[]} newAttemptsSameOrder Attempts that'll be created as new attempts but keeping the current order.
     * @param {any} newAttemptsAtEnd Object with attempts that'll be created at the end of the list of attempts (should be max 1).
     * @param {number} lastOfflineCreated Time when the last offline attempt was created.
     * @param {boolean} lastOfflineIncomplete Whether the last offline attempt is incomplete.
     * @param {string[]} warnings Array where to add the warnings.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormSyncProvider.prototype.addToNewOrDelete = function (scormId, attempt, lastOffline, newAttemptsSameOrder, newAttemptsAtEnd, lastOfflineCreated, lastOfflineIncomplete, warnings, siteId) {
        var _this = this;
        if (attempt == lastOffline) {
            newAttemptsSameOrder.push(attempt);
            return Promise.resolve();
        }
        // Check if the attempt can be created.
        return this.scormOfflineProvider.getAttemptCreationTime(scormId, attempt, siteId).then(function (time) {
            if (time > lastOfflineCreated) {
                // This attempt was created after the last offline attempt, we'll add it to the end of the list if possible.
                if (lastOfflineIncomplete) {
                    // It can't be added because the last offline attempt is incomplete, delete it.
                    _this.logger.debug('Try to delete attempt ' + attempt + ' because it cannot be created as a new attempt.');
                    return _this.scormOfflineProvider.deleteAttempt(scormId, attempt, siteId).then(function () {
                        warnings.push(_this.translate.instant('addon.mod_scorm.warningofflinedatadeleted', { number: attempt }));
                    }).catch(function () {
                        // Maybe there's something wrong with the data or the storage implementation.
                    });
                }
                else {
                    // Add the attempt at the end.
                    newAttemptsAtEnd[time] = attempt;
                }
            }
            else {
                newAttemptsSameOrder.push(attempt);
            }
        });
    };
    /**
     * Check if can retry an attempt synchronization.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {number} lastOnline Last online attempt number.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved if can retry the synchronization, rejected otherwise.
     */
    AddonModScormSyncProvider.prototype.canRetrySync = function (scormId, attempt, lastOnline, siteId) {
        var _this = this;
        // If it's the last attempt we don't need to ignore cache because we already did it.
        var refresh = lastOnline != attempt;
        return this.scormProvider.getScormUserData(scormId, attempt, undefined, false, refresh, siteId).then(function (siteData) {
            // Get synchronization snapshot (if sync fails it should store a snapshot).
            return _this.scormOfflineProvider.getAttemptSnapshot(scormId, attempt, siteId).then(function (snapshot) {
                if (!snapshot || !Object.keys(snapshot).length || !_this.snapshotEquals(snapshot, siteData)) {
                    // No snapshot or it doesn't match, we can't retry the synchronization.
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Create new attempts at the end of the offline attempts list.
     *
     * @param {number} scormId SCORM ID.
     * @param {any} newAttempts Object with the attempts to create. The keys are the timecreated, the values are the attempt number.
     * @param {number} lastOffline Number of last offline attempt.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormSyncProvider.prototype.createNewAttemptsAtEnd = function (scormId, newAttempts, lastOffline, siteId) {
        var _this = this;
        var times = Object.keys(newAttempts).sort(), // Sort in ASC order.
        promises = [];
        if (!times.length) {
            return Promise.resolve();
        }
        times.forEach(function (time, index) {
            var attempt = newAttempts[time];
            promises.push(_this.scormOfflineProvider.changeAttemptNumber(scormId, attempt, lastOffline + index + 1, siteId));
        });
        return this.utils.allPromises(promises);
    };
    /**
     * Finish a sync process: remove offline data if needed, prefetch SCORM data, set sync time and return the result.
     *
     * @param {string} siteId Site ID.
     * @param {any} scorm SCORM.
     * @param {string[]} warnings List of warnings generated by the sync.
     * @param {number} [lastOnline] Last online attempt number before the sync.
     * @param {boolean} [lastOnlineWasFinished] Whether the last online attempt was finished before the sync.
     * @param {AddonModScormAttemptCountResult} [initialCount] Attempt count before the sync.
     * @param {boolean} [updated] Whether some data was sent to the site.
     * @return {Promise<AddonModScormSyncResult>} Promise resolved on success.
     */
    AddonModScormSyncProvider.prototype.finishSync = function (siteId, scorm, warnings, lastOnline, lastOnlineWasFinished, initialCount, updated) {
        var _this = this;
        var promise;
        if (updated) {
            // Update downloaded data.
            promise = this.courseProvider.getModuleBasicInfoByInstance(scorm.id, 'scorm', siteId).then(function (module) {
                return _this.prefetchAfterUpdate(module, scorm.course, undefined, siteId);
            }).catch(function () {
                // Ignore errors.
            });
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function () {
            return _this.setSyncTime(scorm.id, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // Check if an attempt was finished in Moodle.
            if (initialCount) {
                // Get attempt count again to check if an attempt was finished.
                return _this.scormProvider.getAttemptCount(scorm.id, undefined, false, siteId).then(function (attemptsData) {
                    if (attemptsData.online.length > initialCount.online.length) {
                        return true;
                    }
                    else if (!lastOnlineWasFinished && lastOnline > 0) {
                        // Last online attempt wasn't finished, let's check if it is now.
                        return _this.scormProvider.isAttemptIncomplete(scorm.id, lastOnline, false, true, siteId).then(function (inc) {
                            return !inc;
                        });
                    }
                    return false;
                });
            }
            return false;
        }).then(function (attemptFinished) {
            return {
                warnings: warnings,
                attemptFinished: attemptFinished,
                updated: updated
            };
        });
    };
    /**
     * Get the creation time and the status (complete/incomplete) of an offline attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {string} siteId Site ID.
     * @return {Promise<{incomplete: boolean, timecreated: number}>} Promise resolved with the data.
     */
    AddonModScormSyncProvider.prototype.getOfflineAttemptData = function (scormId, attempt, siteId) {
        var _this = this;
        // Check if last offline attempt is incomplete.
        return this.scormProvider.isAttemptIncomplete(scormId, attempt, true, false, siteId).then(function (incomplete) {
            return _this.scormOfflineProvider.getAttemptCreationTime(scormId, attempt, siteId).then(function (timecreated) {
                return {
                    incomplete: incomplete,
                    timecreated: timecreated
                };
            });
        });
    };
    /**
     * Change the number of some offline attempts. We need to move all offline attempts after the collisions
     * too, otherwise we would overwrite data.
     * Example: We have offline attempts 1, 2 and 3. #1 and #2 have collisions. #1 can be synced, but #2 needs
     * to be a new attempt. #3 will now be #4, and #2 will now be #3.
     *
     * @param {number} scormId SCORM ID.
     * @param {number[]} newAttempts Attempts that need to be converted into new attempts.
     * @param {number} lastOnline Last online attempt.
     * @param {number} lastCollision Last attempt with collision (exists in online and offline).
     * @param {number[]} offlineAttempts Numbers of offline attempts.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when attempts have been moved.
     */
    AddonModScormSyncProvider.prototype.moveNewAttempts = function (scormId, newAttempts, lastOnline, lastCollision, offlineAttempts, siteId) {
        var _this = this;
        if (!newAttempts.length) {
            return Promise.resolve();
        }
        var promise = Promise.resolve(), lastSuccessful;
        // Sort offline attempts in DESC order.
        offlineAttempts = offlineAttempts.sort(function (a, b) {
            return Number(a) <= Number(b) ? 1 : -1;
        });
        // First move the offline attempts after the collisions.
        offlineAttempts.forEach(function (attempt) {
            if (attempt > lastCollision) {
                // We use a chain of promises because we need to move them in order.
                promise = promise.then(function () {
                    var newNumber = attempt + newAttempts.length;
                    return _this.scormOfflineProvider.changeAttemptNumber(scormId, attempt, newNumber, siteId).then(function () {
                        lastSuccessful = attempt;
                    });
                });
            }
        });
        return promise.then(function () {
            var successful = [];
            var promises = [];
            // Sort newAttempts in ASC order.
            newAttempts = newAttempts.sort(function (a, b) {
                return Number(a) >= Number(b) ? 1 : -1;
            });
            // Now move the attempts in newAttempts.
            newAttempts.forEach(function (attempt, index) {
                // No need to use chain of promises.
                var newNumber = lastOnline + index + 1;
                promises.push(_this.scormOfflineProvider.changeAttemptNumber(scormId, attempt, newNumber, siteId).then(function () {
                    successful.push(attempt);
                }));
            });
            return Promise.all(promises).catch(function (error) {
                // Moving the new attempts failed (it shouldn't happen). Let's undo the new attempts move.
                promises = [];
                successful.forEach(function (attempt) {
                    var newNumber = lastOnline + newAttempts.indexOf(attempt) + 1;
                    promises.push(_this.scormOfflineProvider.changeAttemptNumber(scormId, newNumber, attempt, siteId));
                });
                return _this.utils.allPromises(promises).then(function () {
                    return Promise.reject(error); // It will now enter the .catch that moves offline attempts after collisions.
                });
            });
        }).catch(function (error) {
            // Moving offline attempts after collisions failed (it shouldn't happen). Let's undo the changes.
            if (!lastSuccessful) {
                return Promise.reject(error);
            }
            var attemptsToUndo = [];
            var promise = Promise.resolve();
            for (var i = lastSuccessful; offlineAttempts.indexOf(i) != -1; i++) {
                attemptsToUndo.push(i);
            }
            attemptsToUndo.forEach(function (attempt) {
                promise = promise.then(function () {
                    // Move it back.
                    return _this.scormOfflineProvider.changeAttemptNumber(scormId, attempt + newAttempts.length, attempt, siteId);
                });
            });
            return promise.then(function () {
                return Promise.reject(error);
            });
        });
    };
    /**
     * Save a snapshot from a synchronization.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attemot number.
     * @param {string} siteId  Site ID.
     * @return {Promise<any>} Promise resolved when the snapshot is stored.
     */
    AddonModScormSyncProvider.prototype.saveSyncSnapshot = function (scormId, attempt, siteId) {
        var _this = this;
        // Try to get current state from the site.
        return this.scormProvider.getScormUserData(scormId, attempt, undefined, false, true, siteId).then(function (data) {
            return _this.scormOfflineProvider.setAttemptSnapshot(scormId, attempt, data, siteId);
        }, function () {
            // Error getting user data from the site. We'll have to build it ourselves.
            // Let's try to get cached data about the attempt.
            return _this.scormProvider.getScormUserData(scormId, attempt, undefined, false, false, siteId).catch(function () {
                // No cached data.
                return {};
            }).then(function (data) {
                // We need to add the synced data to the snapshot.
                return _this.scormOfflineProvider.getScormStoredData(scormId, attempt, false, true, siteId).then(function (synced) {
                    synced.forEach(function (entry) {
                        if (!data[entry.scoid]) {
                            data[entry.scoid] = {
                                scoid: entry.scoid,
                                userdata: {}
                            };
                        }
                        data[entry.scoid].userdata[entry.element] = entry.value;
                    });
                    return _this.scormOfflineProvider.setAttemptSnapshot(scormId, attempt, data, siteId);
                });
            });
        });
    };
    /**
     * Compares an attempt's snapshot with the data retrieved from the site.
     * It only compares elements with dot notation. This means that, if some SCO has been added to Moodle web
     * but the user hasn't generated data for it, then the snapshot will be detected as equal.
     *
     * @param {any} snapshot Attempt's snapshot.
     * @param {any} userData Data retrieved from the site.
     * @return {boolean} True if snapshot is equal to the user data, false otherwise.
     */
    AddonModScormSyncProvider.prototype.snapshotEquals = function (snapshot, userData) {
        // Check that snapshot contains the data from the site.
        for (var scoId in userData) {
            var siteSco = userData[scoId], snapshotSco = snapshot[scoId];
            for (var element in siteSco.userdata) {
                if (element.indexOf('.') > -1) {
                    if (!snapshotSco || siteSco.userdata[element] !== snapshotSco.userdata[element]) {
                        return false;
                    }
                }
            }
        }
        // Now check the opposite way: site userData contains the data from the snapshot.
        for (var scoId in snapshot) {
            var siteSco = userData[scoId], snapshotSco = snapshot[scoId];
            for (var element in snapshotSco.userdata) {
                if (element.indexOf('.') > -1) {
                    if (!siteSco || siteSco.userdata[element] !== snapshotSco.userdata[element]) {
                        return false;
                    }
                }
            }
        }
        return true;
    };
    /**
     * Try to synchronize all the SCORMs in a certain site or in all sites.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force Wether to force sync not depending on last execution.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModScormSyncProvider.prototype.syncAllScorms = function (siteId, force) {
        return this.syncOnSites('all SCORMs', this.syncAllScormsFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all SCORMs on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModScormSyncProvider.prototype.syncAllScormsFunc = function (siteId, force) {
        var _this = this;
        // Get all offline attempts.
        return this.scormOfflineProvider.getAllAttempts(siteId).then(function (attempts) {
            var scorms = [], ids = [], // To prevent duplicates.
            promises = [];
            // Get the IDs of all the SCORMs that have something to be synced.
            attempts.forEach(function (attempt) {
                if (ids.indexOf(attempt.scormid) == -1) {
                    ids.push(attempt.scormid);
                    scorms.push({
                        id: attempt.scormid,
                        courseId: attempt.courseid
                    });
                }
            });
            // Sync all SCORMs that haven't been synced for a while and that aren't attempted right now.
            scorms.forEach(function (scorm) {
                if (!_this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_14__scorm__["a" /* AddonModScormProvider */].COMPONENT, scorm.id, siteId)) {
                    promises.push(_this.scormProvider.getScormById(scorm.courseId, scorm.id, '', false, siteId).then(function (scorm) {
                        var promise = force ? _this.syncScorm(scorm, siteId) : _this.syncScormIfNeeded(scorm, siteId);
                        return promise.then(function (data) {
                            if (typeof data != 'undefined') {
                                // We tried to sync. Send event.
                                _this.eventsProvider.trigger(AddonModScormSyncProvider_1.AUTO_SYNCED, {
                                    scormId: scorm.id,
                                    attemptFinished: data.attemptFinished,
                                    warnings: data.warnings,
                                    updated: data.updated
                                }, siteId);
                            }
                        });
                    }));
                }
            });
            return Promise.all(promises);
        });
    };
    /**
     * Send data from a SCORM offline attempt to the site.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Attempt number.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the attempt is successfully synced.
     */
    AddonModScormSyncProvider.prototype.syncAttempt = function (scormId, attempt, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        this.logger.debug('Try to sync attempt ' + attempt + ' in SCORM ' + scormId + ' and site ' + siteId);
        // Get only not synced entries.
        return this.scormOfflineProvider.getScormStoredData(scormId, attempt, true, false, siteId).then(function (entries) {
            var scos = {}, promises = [];
            var somethingSynced = false;
            // Get data to send (only elements with dots like cmi.core.exit, in Mobile we store more data to make offline work).
            entries.forEach(function (entry) {
                if (entry.element.indexOf('.') > -1) {
                    if (!scos[entry.scoid]) {
                        scos[entry.scoid] = [];
                    }
                    scos[entry.scoid].push({
                        element: entry.element,
                        value: entry.value
                    });
                }
            });
            var _loop_1 = function (id) {
                var scoId = Number(id), tracks = scos[scoId];
                promises.push(_this.scormProvider.saveTracksOnline(scormId, scoId, attempt, tracks, siteId).then(function () {
                    // Sco data successfully sent. Mark them as synced. This is needed because some SCOs sync might fail.
                    return _this.scormOfflineProvider.markAsSynced(scormId, attempt, scoId, siteId).catch(function () {
                        // Ignore errors.
                    }).then(function () {
                        somethingSynced = true;
                    });
                }));
            };
            // Send the data in each SCO.
            for (var id in scos) {
                _loop_1(id);
            }
            return _this.utils.allPromises(promises).then(function () {
                // Attempt has been sent. Let's delete it from local.
                return _this.scormOfflineProvider.deleteAttempt(scormId, attempt, siteId).catch(function () {
                    // Failed to delete (shouldn't happen). Let's retry once.
                    return _this.scormOfflineProvider.deleteAttempt(scormId, attempt, siteId).catch(function () {
                        // Maybe there's something wrong with the data or the storage implementation.
                        _this.logger.error('After sync: error deleting attempt ' + attempt + ' in SCORM ' + scormId);
                    });
                });
            }).catch(function (error) {
                if (somethingSynced) {
                    // Some SCOs have been synced and some not.
                    // Try to store a snapshot of the current state to be able to re-try the synchronization later.
                    _this.logger.error('Error synchronizing some SCOs for attempt ' + attempt + ' in SCORM ' +
                        scormId + '. Saving snapshot.');
                    return _this.saveSyncSnapshot(scormId, attempt, siteId).then(function () {
                        return Promise.reject(error);
                    });
                }
                else {
                    _this.logger.error('Error synchronizing attempt ' + attempt + ' in SCORM ' + scormId);
                }
                return Promise.reject(error);
            });
        });
    };
    /**
     * Sync a SCORM only if a certain time has passed since the last time.
     *
     * @param {any} scorm SCORM.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the SCORM is synced or if it doesn't need to be synced.
     */
    AddonModScormSyncProvider.prototype.syncScormIfNeeded = function (scorm, siteId) {
        var _this = this;
        return this.isSyncNeeded(scorm.id, siteId).then(function (needed) {
            if (needed) {
                return _this.syncScorm(scorm, siteId);
            }
        });
    };
    /**
     * Try to synchronize a SCORM.
     * The promise returned will be resolved with an array with warnings if the synchronization is successful. A successful
     * synchronization doesn't mean that all the data has been sent to the site, it's possible that some attempt can't be sent.
     *
     * @param {any} scorm SCORM.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModScormSyncResult>} Promise resolved in success.
     */
    AddonModScormSyncProvider.prototype.syncScorm = function (scorm, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var warnings = [], syncPromise, initialCount, lastOnline = 0, lastOnlineWasFinished = false;
        if (this.isSyncing(scorm.id, siteId)) {
            // There's already a sync ongoing for this SCORM, return the promise.
            return this.getOngoingSync(scorm.id, siteId);
        }
        // Verify that SCORM isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_14__scorm__["a" /* AddonModScormProvider */].COMPONENT, scorm.id, siteId)) {
            this.logger.debug('Cannot sync SCORM ' + scorm.id + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync SCORM ' + scorm.id + ' in site ' + siteId);
        // Sync offline logs.
        syncPromise = this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_14__scorm__["a" /* AddonModScormProvider */].COMPONENT, scorm.id, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Get attempts data. We ignore cache for online attempts, so this call will fail if offline or server down.
            return _this.scormProvider.getAttemptCount(scorm.id, false, true, siteId);
        }).then(function (attemptsData) {
            if (!attemptsData.offline || !attemptsData.offline.length) {
                // Nothing to sync.
                return _this.finishSync(siteId, scorm, warnings, lastOnline, lastOnlineWasFinished);
            }
            initialCount = attemptsData;
            var collisions = [];
            // Check if there are collisions between offline and online attempts (same number).
            attemptsData.online.forEach(function (attempt) {
                lastOnline = Math.max(lastOnline, attempt);
                if (attemptsData.offline.indexOf(attempt) > -1) {
                    collisions.push(attempt);
                }
            });
            // Check if last online attempt is finished. Ignore cache.
            var promise = lastOnline > 0 ? _this.scormProvider.isAttemptIncomplete(scorm.id, lastOnline, false, true, siteId) :
                Promise.resolve(false);
            return promise.then(function (incomplete) {
                lastOnlineWasFinished = !incomplete;
                if (!collisions.length && !incomplete) {
                    // No collisions and last attempt is complete. Send offline attempts to Moodle.
                    var promises_1 = [];
                    attemptsData.offline.forEach(function (attempt) {
                        if (scorm.maxattempt == 0 || attempt <= scorm.maxattempt) {
                            promises_1.push(_this.syncAttempt(scorm.id, attempt, siteId));
                        }
                    });
                    return Promise.all(promises_1).then(function () {
                        // All data synced, finish.
                        return _this.finishSync(siteId, scorm, warnings, lastOnline, lastOnlineWasFinished, initialCount, true);
                    });
                }
                else if (collisions.length) {
                    // We have collisions, treat them.
                    return _this.treatCollisions(scorm.id, collisions, lastOnline, attemptsData.offline, siteId).then(function (warns) {
                        warnings = warnings.concat(warns);
                        // The offline attempts might have changed since some collisions can be converted to new attempts.
                        return _this.scormOfflineProvider.getAttempts(scorm.id, siteId).then(function (entries) {
                            var promises = [];
                            var cannotSyncSome = false;
                            entries = entries.map(function (entry) {
                                return entry.attempt; // Get only the attempt number.
                            });
                            if (incomplete && entries.indexOf(lastOnline) > -1) {
                                // Last online was incomplete, but it was continued in offline.
                                incomplete = false;
                            }
                            entries.forEach(function (attempt) {
                                // We'll always sync attempts previous to lastOnline (failed sync or continued in offline).
                                // We'll only sync new attemps if last online attempt is completed.
                                if (!incomplete || attempt <= lastOnline) {
                                    if (scorm.maxattempt == 0 || attempt <= scorm.maxattempt) {
                                        promises.push(_this.syncAttempt(scorm.id, attempt, siteId));
                                    }
                                }
                                else {
                                    cannotSyncSome = true;
                                }
                            });
                            return Promise.all(promises).then(function () {
                                if (cannotSyncSome) {
                                    warnings.push(_this.translate.instant('addon.mod_scorm.warningsynconlineincomplete'));
                                }
                                return _this.finishSync(siteId, scorm, warnings, lastOnline, lastOnlineWasFinished, initialCount, true);
                            });
                        });
                    });
                }
                else {
                    // No collisions, but last online attempt is incomplete so we can't send offline attempts.
                    warnings.push(_this.translate.instant('addon.mod_scorm.warningsynconlineincomplete'));
                    return _this.finishSync(siteId, scorm, warnings, lastOnline, lastOnlineWasFinished, initialCount, false);
                }
            });
        });
        return this.addOngoingSync(scorm.id, syncPromise, siteId);
    };
    /**
     * Treat collisions found in a SCORM synchronization process.
     *
     * @param {number} scormId SCORM ID.
     * @param {number[]} collisions Numbers of attempts that exist both in online and offline.
     * @param {number} lastOnline Last online attempt.
     * @param {number[]} offlineAttempts Numbers of offline attempts.
     * @param {string} siteId Site ID.
     * @return {Promise<string[]} Promise resolved when the collisions have been treated. It returns warnings array.
     * @description
     *
     * Treat collisions found in a SCORM synchronization process. A collision is when an attempt exists both in offline
     * and online. A collision can be:
     *
     * - Two different attempts.
     * - An online attempt continued in offline.
     * - A failure in a previous sync.
     *
     * This function will move into new attempts the collisions that can't be merged. It will usually keep the order of the
     * offline attempts EXCEPT if the offline attempt was created after the last offline attempt (edge case).
     *
     * Edge case: A user creates offline attempts and when he syncs we retrieve an incomplete online attempt, so the offline
     * attempts cannot be synced. Then the user continues that online attempt and goes offline, so a collision is created.
     * When we perform the next sync we detect that this collision cannot be merged, so this offline attempt needs to be
     * created as a new attempt. Since this attempt was created after the last offline attempt, it will be added ot the end
     * of the list if the last attempt is completed. If the last attempt is not completed then the offline data will de deleted
     * because we can't create a new attempt.
     */
    AddonModScormSyncProvider.prototype.treatCollisions = function (scormId, collisions, lastOnline, offlineAttempts, siteId) {
        var _this = this;
        var warnings = [], newAttemptsSameOrder = [], // Attempts that will be created as new attempts but keeping the current order.
        newAttemptsAtEnd = {}, // Attempts that will be created at the end of the list of attempts (should be max 1 attempt).
        lastCollision = Math.max.apply(Math, collisions);
        var lastOffline = Math.max.apply(Math, offlineAttempts);
        // Get needed data from the last offline attempt.
        return this.getOfflineAttemptData(scormId, lastOffline, siteId).then(function (lastOfflineData) {
            var promises = [];
            collisions.forEach(function (attempt) {
                // First get synced entries to detect if it was a failed synchronization.
                promises.push(_this.scormOfflineProvider.getScormStoredData(scormId, attempt, false, true, siteId).then(function (synced) {
                    if (synced && synced.length) {
                        // The attempt has synced entries, it seems to be a failed synchronization.
                        // Let's get the entries that haven't been synced, maybe it just failed to delete the attempt.
                        return _this.scormOfflineProvider.getScormStoredData(scormId, attempt, true, false, siteId)
                            .then(function (entries) {
                            // Check if there are elements to sync.
                            var hasDataToSend = false;
                            for (var i in entries) {
                                var entry = entries[i];
                                if (entry.element.indexOf('.') > -1) {
                                    hasDataToSend = true;
                                    break;
                                }
                            }
                            if (hasDataToSend) {
                                // There are elements to sync. We need to check if it's possible to sync them or not.
                                return _this.canRetrySync(scormId, attempt, lastOnline, siteId).catch(function () {
                                    // Cannot retry sync, we'll create a new offline attempt if possible.
                                    return _this.addToNewOrDelete(scormId, attempt, lastOffline, newAttemptsSameOrder, newAttemptsAtEnd, lastOfflineData.timecreated, lastOfflineData.incomplete, warnings, siteId);
                                });
                            }
                            else {
                                // Nothing to sync, delete the attempt.
                                return _this.scormOfflineProvider.deleteAttempt(scormId, attempt, siteId).catch(function () {
                                    // Maybe there's something wrong with the data or the storage implementation.
                                });
                            }
                        });
                    }
                    else {
                        // It's not a failed synchronization. Check if it's an attempt continued in offline.
                        return _this.scormOfflineProvider.getAttemptSnapshot(scormId, attempt, siteId).then(function (snapshot) {
                            if (snapshot && Object.keys(snapshot).length) {
                                // It has a snapshot, it means it continued an online attempt. We need to check if they've diverged.
                                // If it's the last attempt we don't need to ignore cache because we already did it.
                                var refresh = lastOnline != attempt;
                                return _this.scormProvider.getScormUserData(scormId, attempt, undefined, false, refresh, siteId)
                                    .then(function (data) {
                                    if (!_this.snapshotEquals(snapshot, data)) {
                                        // Snapshot has diverged, it will be converted into a new attempt if possible.
                                        return _this.addToNewOrDelete(scormId, attempt, lastOffline, newAttemptsSameOrder, newAttemptsAtEnd, lastOfflineData.timecreated, lastOfflineData.incomplete, warnings, siteId);
                                    }
                                });
                            }
                            else {
                                // No snapshot, it's a different attempt.
                                newAttemptsSameOrder.push(attempt);
                            }
                        });
                    }
                }));
            });
            return Promise.all(promises).then(function () {
                return _this.moveNewAttempts(scormId, newAttemptsSameOrder, lastOnline, lastCollision, offlineAttempts, siteId)
                    .then(function () {
                    // The new attempts that need to keep the order have been created.
                    // Now create the new attempts at the end of the list of offline attempts. It should only be 1 attempt max.
                    lastOffline = lastOffline + newAttemptsSameOrder.length;
                    return _this.createNewAttemptsAtEnd(scormId, newAttemptsAtEnd, lastOffline, siteId).then(function () {
                        return warnings;
                    });
                });
            });
        });
    };
    AddonModScormSyncProvider.AUTO_SYNCED = 'addon_mod_scorm_autom_synced';
    AddonModScormSyncProvider = AddonModScormSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_14__scorm__["a" /* AddonModScormProvider */], __WEBPACK_IMPORTED_MODULE_15__scorm_offline__["a" /* AddonModScormOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__["a" /* AddonModScormPrefetchHandler */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModScormSyncProvider);
    return AddonModScormSyncProvider;
    var AddonModScormSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_13__core_course_classes_activity_sync__["a" /* CoreCourseActivitySyncBaseProvider */]));

//# sourceMappingURL=scorm-sync.js.map

/***/ }),
/* 228 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Service to handle offline wiki.
 */
var AddonModWikiOfflineProvider = /** @class */ (function () {
    function AddonModWikiOfflineProvider(logger, sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.siteSchema = {
            name: 'AddonModWikiOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModWikiOfflineProvider_1.NEW_PAGES_TABLE,
                    columns: [
                        {
                            name: 'wikiid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'subwikiid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'groupid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'title',
                            type: 'TEXT'
                        },
                        {
                            name: 'cachedcontent',
                            type: 'TEXT'
                        },
                        {
                            name: 'contentformat',
                            type: 'TEXT'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'caneditpage',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['wikiid', 'subwikiid', 'userid', 'groupid', 'title']
                }
            ]
        };
        this.logger = logger.getInstance('AddonModWikiOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModWikiOfflineProvider_1 = AddonModWikiOfflineProvider;
    /**
     * Convert a value to a positive number. If not a number or less than 0, 0 will be returned.
     *
     * @param {any} value Value to convert.
     * @return {number} Converted value.
     */
    AddonModWikiOfflineProvider.prototype.convertToPositiveNumber = function (value) {
        value = parseInt(value, 10);
        return value > 0 ? value : 0;
    };
    /**
     * Delete a new page.
     *
     * @param {string} title Title of the page.
     * @param {number} [subwikiId] Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used create subwiki if not informed.
     * @param {number} [userId] User ID. Optional, will be used create subwiki if not informed.
     * @param {number} [groupId] Group ID. Optional, will be used create subwiki if not informed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if deleted, rejected if failure.
     */
    AddonModWikiOfflineProvider.prototype.deleteNewPage = function (title, subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            subwikiId = _this.convertToPositiveNumber(subwikiId);
            wikiId = _this.convertToPositiveNumber(wikiId);
            userId = _this.convertToPositiveNumber(userId);
            groupId = _this.convertToPositiveNumber(groupId);
            return site.getDb().deleteRecords(AddonModWikiOfflineProvider_1.NEW_PAGES_TABLE, {
                subwikiid: subwikiId,
                wikiid: wikiId,
                userid: userId,
                groupid: groupId,
                title: title
            });
        });
    };
    /**
     * Get all the stored new pages from all the wikis.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with pages.
     */
    AddonModWikiOfflineProvider.prototype.getAllNewPages = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getAllRecords(AddonModWikiOfflineProvider_1.NEW_PAGES_TABLE);
        });
    };
    /**
     * Get a stored new page.
     *
     * @param {string} title Title of the page.
     * @param {number} [subwikiId] Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used create subwiki if not informed.
     * @param {number} [userId] User ID. Optional, will be used create subwiki if not informed.
     * @param {number} [groupId] Group ID. Optional, will be used create subwiki if not informed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with page.
     */
    AddonModWikiOfflineProvider.prototype.getNewPage = function (title, subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            subwikiId = _this.convertToPositiveNumber(subwikiId);
            wikiId = _this.convertToPositiveNumber(wikiId);
            userId = _this.convertToPositiveNumber(userId);
            groupId = _this.convertToPositiveNumber(groupId);
            return site.getDb().getRecord(AddonModWikiOfflineProvider_1.NEW_PAGES_TABLE, {
                subwikiid: subwikiId,
                wikiid: wikiId,
                userid: userId,
                groupid: groupId,
                title: title
            });
        });
    };
    /**
     * Get all the stored new pages from a certain subwiki.
     *
     * @param {number} [subwikiId] Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used create subwiki if not informed.
     * @param {number} [userId] User ID. Optional, will be used create subwiki if not informed.
     * @param {number} [groupId] Group ID. Optional, will be used create subwiki if not informed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with pages.
     */
    AddonModWikiOfflineProvider.prototype.getSubwikiNewPages = function (subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            subwikiId = _this.convertToPositiveNumber(subwikiId);
            wikiId = _this.convertToPositiveNumber(wikiId);
            userId = _this.convertToPositiveNumber(userId);
            groupId = _this.convertToPositiveNumber(groupId);
            return site.getDb().getRecords(AddonModWikiOfflineProvider_1.NEW_PAGES_TABLE, {
                subwikiid: subwikiId,
                wikiid: wikiId,
                userid: userId,
                groupid: groupId
            });
        });
    };
    /**
     * Get all the stored new pages from a list of subwikis.
     *
     * @param {any[]} subwikis List of subwiki.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with pages.
     */
    AddonModWikiOfflineProvider.prototype.getSubwikisNewPages = function (subwikis, siteId) {
        var _this = this;
        var promises = [];
        var pages = [];
        subwikis.forEach(function (subwiki) {
            promises.push(_this.getSubwikiNewPages(subwiki.id, subwiki.wikiid, subwiki.userid, subwiki.groupid, siteId)
                .then(function (subwikiPages) {
                pages = pages.concat(subwikiPages);
            }));
        });
        return Promise.all(promises).then(function () {
            return pages;
        });
    };
    /**
     * Save a new page to be sent later.
     *
     * @param {string} title Title of the page.
     * @param {string} content Content of the page.
     * @param {number} [subwikiId] Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used create subwiki if not informed.
     * @param {number} [userId] User ID. Optional, will be used create subwiki if not informed.
     * @param {number} [groupId] Group ID. Optional, will be used create subwiki if not informed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if stored, rejected if failure.
     */
    AddonModWikiOfflineProvider.prototype.saveNewPage = function (title, content, subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var now = new Date().getTime(), entry = {
                title: title,
                cachedcontent: content,
                subwikiid: _this.convertToPositiveNumber(subwikiId),
                wikiid: _this.convertToPositiveNumber(wikiId),
                userid: _this.convertToPositiveNumber(userId),
                groupid: _this.convertToPositiveNumber(groupId),
                contentformat: 'html',
                timecreated: now,
                timemodified: now,
                caneditpage: 1
            };
            return site.getDb().insertRecord(AddonModWikiOfflineProvider_1.NEW_PAGES_TABLE, entry);
        });
    };
    /**
     * Check if a list of subwikis have offline data stored.
     *
     * @param {any[]} subwikis List of subwikis.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return{Promise<boolean>} Promise resolved with boolean: whether it has offline data.
     */
    AddonModWikiOfflineProvider.prototype.subwikisHaveOfflineData = function (subwikis, siteId) {
        return this.getSubwikisNewPages(subwikis, siteId).then(function (pages) {
            return !!pages.length;
        }).catch(function () {
            // Error, return false.
            return false;
        });
    };
    // Variables for database.
    AddonModWikiOfflineProvider.NEW_PAGES_TABLE = 'addon_mod_wiki_new_pages_store';
    AddonModWikiOfflineProvider = AddonModWikiOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModWikiOfflineProvider);
    return AddonModWikiOfflineProvider;
    var AddonModWikiOfflineProvider_1;
}());

//# sourceMappingURL=wiki-offline.js.map

/***/ }),
/* 229 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__wiki__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__wiki_offline__ = __webpack_require__(228);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/**
 * Service to sync wikis.
 */
var AddonModWikiSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModWikiSyncProvider, _super);
    function AddonModWikiSyncProvider(loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, courseProvider, eventsProvider, wikiProvider, wikiOfflineProvider, utils, groupsProvider, timeUtils, logHelper) {
        var _this = _super.call(this, 'AddonModWikiSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.eventsProvider = eventsProvider;
        _this.wikiProvider = wikiProvider;
        _this.wikiOfflineProvider = wikiOfflineProvider;
        _this.utils = utils;
        _this.groupsProvider = groupsProvider;
        _this.logHelper = logHelper;
        _this.componentTranslate = courseProvider.translateModuleName('wiki');
        return _this;
    }
    AddonModWikiSyncProvider_1 = AddonModWikiSyncProvider;
    /**
     * Get a string to identify a subwiki. If it doesn't have a subwiki ID it will be identified by wiki ID, user ID and group ID.
     *
     * @param {number} subwikiId Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {number} [userId] User ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {number} [groupId] Group ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @return {string} Identifier.
     */
    AddonModWikiSyncProvider.prototype.getSubwikiBlockId = function (subwikiId, wikiId, userId, groupId) {
        subwikiId = this.wikiOfflineProvider.convertToPositiveNumber(subwikiId);
        if (subwikiId && subwikiId > 0) {
            return String(subwikiId);
        }
        wikiId = this.wikiOfflineProvider.convertToPositiveNumber(wikiId);
        if (wikiId) {
            userId = this.wikiOfflineProvider.convertToPositiveNumber(userId);
            groupId = this.wikiOfflineProvider.convertToPositiveNumber(groupId);
            return wikiId + ':' + userId + ':' + groupId;
        }
    };
    /**
     * Try to synchronize all the wikis in a certain site or in all sites.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModWikiSyncProvider.prototype.syncAllWikis = function (siteId, force) {
        return this.syncOnSites('all wikis', this.syncAllWikisFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all wikis on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModWikiSyncProvider.prototype.syncAllWikisFunc = function (siteId, force) {
        var _this = this;
        // Get all the pages created in offline.
        return this.wikiOfflineProvider.getAllNewPages(siteId).then(function (pages) {
            var promises = [], subwikis = {};
            // Get subwikis to sync.
            pages.forEach(function (page) {
                var index = _this.getSubwikiBlockId(page.subwikiid, page.wikiid, page.userid, page.groupid);
                subwikis[index] = page;
            });
            var _loop_1 = function (id) {
                var subwiki = subwikis[id];
                var promise = force ? _this.syncSubwiki(subwiki.subwikiid, subwiki.wikiid, subwiki.userid, subwiki.groupid, siteId)
                    : _this.syncSubwikiIfNeeded(subwiki.subwikiid, subwiki.wikiid, subwiki.userid, subwiki.groupid, siteId);
                promises.push(promise.then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModWikiSyncProvider_1.AUTO_SYNCED, {
                            siteId: siteId,
                            subwikiId: subwiki.subwikiid,
                            wikiId: subwiki.wikiid,
                            userId: subwiki.userid,
                            groupId: subwiki.groupid,
                            created: result.created,
                            discarded: result.discarded,
                            warnings: result.warnings
                        });
                    }
                }));
            };
            // Sync all subwikis.
            for (var id in subwikis) {
                _loop_1(id);
            }
            return Promise.all(promises);
        });
    };
    /**
     * Sync a subwiki only if a certain time has passed since the last time.
     *
     * @param {number} subwikiId Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {number} [userId] User ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {number} [groupId] Group ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<void|AddonModWikiSyncSubwikiResult>} Promise resolved when subwiki is synced or doesn't need to be synced.
     */
    AddonModWikiSyncProvider.prototype.syncSubwikiIfNeeded = function (subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        var blockId = this.getSubwikiBlockId(subwikiId, wikiId, userId, groupId);
        return this.isSyncNeeded(blockId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncSubwiki(subwikiId, wikiId, userId, groupId, siteId);
            }
        });
    };
    /**
     * Synchronize a subwiki.
     *
     * @param {number} subwikiId Subwiki ID. If not defined, wikiId, userId and groupId should be defined.
     * @param {number} [wikiId] Wiki ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {number} [userId] User ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {number} [groupId] Group ID. Optional, will be used to create the subwiki if subwiki ID not provided.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModWikiSyncSubwikiResult>} Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModWikiSyncProvider.prototype.syncSubwiki = function (subwikiId, wikiId, userId, groupId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var result = {
            warnings: [],
            updated: false,
            created: [],
            discarded: []
        }, subwikiBlockId = this.getSubwikiBlockId(subwikiId, wikiId, userId, groupId);
        if (this.isSyncing(subwikiBlockId, siteId)) {
            // There's already a sync ongoing for this subwiki, return the promise.
            return this.getOngoingSync(subwikiBlockId, siteId);
        }
        // Verify that subwiki isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_14__wiki__["a" /* AddonModWikiProvider */].COMPONENT, subwikiBlockId, siteId)) {
            this.logger.debug('Cannot sync subwiki ' + subwikiBlockId + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync subwiki ' + subwikiBlockId);
        // Get offline responses to be sent.
        var syncPromise = this.wikiOfflineProvider.getSubwikiNewPages(subwikiId, wikiId, userId, groupId, siteId).catch(function () {
            // No offline data found, return empty array.
            return [];
        }).then(function (pages) {
            if (!pages || !pages.length) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(_this.translate.instant('core.networkerrormsg'));
            }
            var promises = [];
            // Send the pages.
            pages.forEach(function (page) {
                promises.push(_this.wikiProvider.newPageOnline(page.title, page.cachedcontent, subwikiId, wikiId, userId, groupId, siteId).then(function (pageId) {
                    result.updated = true;
                    // Add page to created pages array.
                    result.created.push({
                        pageId: pageId,
                        title: page.title
                    });
                    // Delete the local page.
                    return _this.wikiOfflineProvider.deleteNewPage(page.title, subwikiId, wikiId, userId, groupId, siteId);
                }).catch(function (error) {
                    if (_this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means that the page cannot be submitted. Delete it.
                        return _this.wikiOfflineProvider.deleteNewPage(page.title, subwikiId, wikiId, userId, groupId, siteId)
                            .then(function () {
                            result.updated = true;
                            // Page deleted, add the page to discarded pages and add a warning.
                            var warning = _this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.translate.instant('addon.mod_wiki.wikipage'),
                                name: page.title,
                                error: _this.textUtils.getErrorMessageFromError(error)
                            });
                            result.discarded.push({
                                title: page.title,
                                warning: warning
                            });
                            result.warnings.push(warning);
                        });
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                }));
            });
            return Promise.all(promises);
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(subwikiBlockId, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // All done, return the warnings.
            return result;
        });
        return this.addOngoingSync(subwikiBlockId, syncPromise, siteId);
    };
    /**
     * Tries to synchronize a wiki.
     *
     * @param {number} wikiId Wiki ID.
     * @param {number} [courseId] Course ID.
     * @param {number} [cmId] Wiki course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<AddonModWikiSyncWikiResult>} Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModWikiSyncProvider.prototype.syncWiki = function (wikiId, courseId, cmId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Sync offline logs.
        return this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_14__wiki__["a" /* AddonModWikiProvider */].COMPONENT, wikiId, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Sync is done at subwiki level, get all the subwikis.
            return _this.wikiProvider.getSubwikis(wikiId);
        }).then(function (subwikis) {
            var promises = [], result = {
                warnings: [],
                updated: false,
                subwikis: {},
                siteId: siteId
            };
            subwikis.forEach(function (subwiki) {
                promises.push(_this.syncSubwiki(subwiki.id, subwiki.wikiid, subwiki.userid, subwiki.groupid, siteId).then(function (data) {
                    if (data && data.updated) {
                        result.warnings = result.warnings.concat(data.warnings);
                        result.updated = true;
                        result.subwikis[subwiki.id] = {
                            created: data.created,
                            discarded: data.discarded
                        };
                    }
                }));
            });
            return Promise.all(promises).then(function () {
                var promises = [];
                if (result.updated) {
                    // Something has changed, invalidate data.
                    if (wikiId) {
                        promises.push(_this.wikiProvider.invalidateSubwikis(wikiId));
                        promises.push(_this.wikiProvider.invalidateSubwikiPages(wikiId));
                        promises.push(_this.wikiProvider.invalidateSubwikiFiles(wikiId));
                    }
                    if (courseId) {
                        promises.push(_this.wikiProvider.invalidateWikiData(courseId));
                    }
                    if (cmId) {
                        promises.push(_this.groupsProvider.invalidateActivityAllowedGroups(cmId));
                        promises.push(_this.groupsProvider.invalidateActivityGroupMode(cmId));
                    }
                }
                return Promise.all(promises).catch(function () {
                    // Ignore errors.
                }).then(function () {
                    return result;
                });
            });
        });
    };
    AddonModWikiSyncProvider.AUTO_SYNCED = 'addon_mod_wiki_autom_synced';
    AddonModWikiSyncProvider.MANUAL_SYNCED = 'addon_mod_wiki_manual_synced';
    AddonModWikiSyncProvider = AddonModWikiSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_14__wiki__["a" /* AddonModWikiProvider */], __WEBPACK_IMPORTED_MODULE_15__wiki_offline__["a" /* AddonModWikiOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_groups__["a" /* CoreGroupsProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModWikiSyncProvider);
    return AddonModWikiSyncProvider;
    var AddonModWikiSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_13__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=wiki-sync.js.map

/***/ }),
/* 230 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__offline__ = __webpack_require__(191);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__helper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_rating_providers_sync__ = __webpack_require__(156);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















/**
 * Service to sync databases.
 */
var AddonModDataSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModDataSyncProvider, _super);
    function AddonModDataSyncProvider(sitesProvider, loggerProvider, appProvider, dataOffline, eventsProvider, dataProvider, translate, utils, courseProvider, syncProvider, textUtils, timeUtils, dataHelper, logHelper, ratingSync) {
        var _this = _super.call(this, 'AddonModDataSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.sitesProvider = sitesProvider;
        _this.loggerProvider = loggerProvider;
        _this.appProvider = appProvider;
        _this.dataOffline = dataOffline;
        _this.eventsProvider = eventsProvider;
        _this.dataProvider = dataProvider;
        _this.translate = translate;
        _this.utils = utils;
        _this.textUtils = textUtils;
        _this.dataHelper = dataHelper;
        _this.logHelper = logHelper;
        _this.ratingSync = ratingSync;
        _this.componentTranslate = courseProvider.translateModuleName('data');
        return _this;
    }
    AddonModDataSyncProvider_1 = AddonModDataSyncProvider;
    /**
     * Check if a database has data to synchronize.
     *
     * @param  {number} dataId   Database ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>}         Promise resolved with boolean: true if has data to sync, false otherwise.
     */
    AddonModDataSyncProvider.prototype.hasDataToSync = function (dataId, siteId) {
        return this.dataOffline.hasOfflineData(dataId, siteId);
    };
    /**
     * Try to synchronize all the databases in a certain site or in all sites.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModDataSyncProvider.prototype.syncAllDatabases = function (siteId, force) {
        return this.syncOnSites('all databases', this.syncAllDatabasesFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all pending databases on a site.
     *
     * @param {string}  [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force    Wether to force sync not depending on last execution.
     * @param {Promise<any>}     Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModDataSyncProvider.prototype.syncAllDatabasesFunc = function (siteId, force) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        // Get all data answers pending to be sent in the site.
        promises.push(this.dataOffline.getAllEntries(siteId).then(function (offlineActions) {
            var promises = {};
            // Do not sync same database twice.
            offlineActions.forEach(function (action) {
                if (typeof promises[action.dataid] != 'undefined') {
                    return;
                }
                promises[action.dataid] = force ? _this.syncDatabase(action.dataid, siteId) :
                    _this.syncDatabaseIfNeeded(action.dataid, siteId);
                promises[action.dataid].then(function (result) {
                    if (result && result.updated) {
                        // Sync done. Send event.
                        _this.eventsProvider.trigger(AddonModDataSyncProvider_1.AUTO_SYNCED, {
                            dataId: action.dataid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            });
            // Promises will be an object so, convert to an array first;
            return Promise.all(_this.utils.objectToArray(promises));
        }));
        promises.push(this.syncRatings(undefined, force, siteId));
        return Promise.all(promises);
    };
    /**
     * Sync a database only if a certain time has passed since the last time.
     *
     * @param {number} dataId      Database ID.
     * @param {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}            Promise resolved when the data is synced or if it doesn't need to be synced.
     */
    AddonModDataSyncProvider.prototype.syncDatabaseIfNeeded = function (dataId, siteId) {
        var _this = this;
        return this.isSyncNeeded(dataId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncDatabase(dataId, siteId);
            }
        });
    };
    /**
     * Synchronize a data.
     *
     * @param  {number} dataId Data ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModDataSyncProvider.prototype.syncDatabase = function (dataId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.isSyncing(dataId, siteId)) {
            // There's already a sync ongoing for this data and user, return the promise.
            return this.getOngoingSync(dataId, siteId);
        }
        // Verify that data isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_9__data__["a" /* AddonModDataProvider */].COMPONENT, dataId, siteId)) {
            this.logger.debug("Cannot sync database '" + dataId + "' because it is blocked.");
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug("Try to sync data '" + dataId + "' in site " + siteId + "'");
        var courseId, data;
        var result = {
            warnings: [],
            updated: false
        };
        // Sync offline logs.
        var syncPromise = this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_9__data__["a" /* AddonModDataProvider */].COMPONENT, dataId, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Get answers to be sent.
            return _this.dataOffline.getDatabaseEntries(dataId, siteId).catch(function () {
                // No offline data found, return empty object.
                return [];
            });
        }).then(function (offlineActions) {
            if (!offlineActions.length) {
                // Nothing to sync.
                return;
            }
            if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            courseId = offlineActions[0].courseid;
            // Send the answers.
            return _this.dataProvider.getDatabaseById(courseId, dataId, siteId).then(function (database) {
                data = database;
                var offlineEntries = {};
                offlineActions.forEach(function (entry) {
                    if (typeof offlineEntries[entry.entryid] == 'undefined') {
                        offlineEntries[entry.entryid] = [];
                    }
                    offlineEntries[entry.entryid].push(entry);
                });
                var promises = _this.utils.objectToArray(offlineEntries).map(function (entryActions) {
                    return _this.syncEntry(data, entryActions, result, siteId);
                });
                return Promise.all(promises);
            }).then(function () {
                if (result.updated) {
                    // Data has been sent to server. Now invalidate the WS calls.
                    return _this.dataProvider.invalidateContent(data.cmid, courseId, siteId).catch(function () {
                        // Ignore errors.
                    });
                }
            });
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(dataId, siteId);
        }).then(function () {
            return result;
        });
        return this.addOngoingSync(dataId, syncPromise, siteId);
    };
    /**
     * Synchronize an entry.
     *
     * @param {any} data Database.
     * @param {AddonModDataOfflineAction[]} entryActions  Entry actions.
     * @param {any} result Object with the result of the sync.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success, rejected otherwise.
     */
    AddonModDataSyncProvider.prototype.syncEntry = function (data, entryActions, result, siteId) {
        var _this = this;
        var discardError, timePromise, entryId = entryActions[0].entryid, offlineId, deleted = false;
        var editAction = entryActions.find(function (action) { return action.action == 'add' || action.action == 'edit'; });
        var approveAction = entryActions.find(function (action) { return action.action == 'approve' || action.action == 'disapprove'; });
        var deleteAction = entryActions.find(function (action) { return action.action == 'delete'; });
        if (entryId > 0) {
            timePromise = this.dataProvider.getEntry(data.id, entryId, true, siteId).then(function (entry) {
                return entry.entry.timemodified;
            }).catch(function (error) {
                if (error && _this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means the entry has been deleted.
                    return Promise.resolve(-1);
                }
                return Promise.reject(error);
            });
        }
        else if (editAction) {
            // New entry.
            offlineId = entryId;
            timePromise = Promise.resolve(0);
        }
        else {
            // New entry but the add action is missing, discard.
            timePromise = Promise.resolve(-1);
        }
        return timePromise.then(function (timemodified) {
            if (timemodified < 0 || timemodified >= entryActions[0].timemodified) {
                // The entry was not found in Moodle or the entry has been modified, discard the action.
                result.updated = true;
                discardError = _this.translate.instant('addon.mod_data.warningsubmissionmodified');
                return _this.dataOffline.deleteAllEntryActions(data.id, entryId, siteId);
            }
            if (deleteAction) {
                return _this.dataProvider.deleteEntryOnline(entryId, siteId).then(function () {
                    deleted = true;
                }).catch(function (error) {
                    if (error && _this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means it cannot be performed. Discard.
                        discardError = _this.textUtils.getErrorMessageFromError(error);
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                }).then(function () {
                    // Delete the offline data.
                    result.updated = true;
                    return _this.dataOffline.deleteAllEntryActions(deleteAction.dataid, deleteAction.entryid, siteId);
                });
            }
            var editPromise;
            if (editAction) {
                editPromise = Promise.all(editAction.fields.map(function (field) {
                    // Upload Files if asked.
                    var value = _this.textUtils.parseJSON(field.value);
                    if (value.online || value.offline) {
                        var files_1 = value.online || [];
                        var fileProm = value.offline ?
                            _this.dataHelper.getStoredFiles(editAction.dataid, entryId, field.fieldid) :
                            Promise.resolve([]);
                        return fileProm.then(function (offlineFiles) {
                            files_1 = files_1.concat(offlineFiles);
                            return _this.dataHelper.uploadOrStoreFiles(editAction.dataid, 0, entryId, field.fieldid, files_1, false, siteId).then(function (filesResult) {
                                field.value = JSON.stringify(filesResult);
                            });
                        });
                    }
                })).then(function () {
                    if (editAction.action == 'add') {
                        return _this.dataProvider.addEntryOnline(editAction.dataid, editAction.fields, editAction.groupid, siteId)
                            .then(function (result) {
                            entryId = result.newentryid;
                        });
                    }
                    else {
                        return _this.dataProvider.editEntryOnline(entryId, editAction.fields, siteId);
                    }
                }).catch(function (error) {
                    if (error && _this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means it cannot be performed. Discard.
                        discardError = _this.textUtils.getErrorMessageFromError(error);
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                }).then(function () {
                    // Delete the offline data.
                    result.updated = true;
                    return _this.dataOffline.deleteEntry(editAction.dataid, editAction.entryid, editAction.action, siteId);
                });
            }
            else {
                editPromise = Promise.resolve();
            }
            if (approveAction) {
                editPromise = editPromise.then(function () {
                    return _this.dataProvider.approveEntryOnline(entryId, approveAction.action == 'approve', siteId);
                }).catch(function (error) {
                    if (error && _this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means it cannot be performed. Discard.
                        discardError = _this.textUtils.getErrorMessageFromError(error);
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                }).then(function () {
                    // Delete the offline data.
                    result.updated = true;
                    return _this.dataOffline.deleteEntry(approveAction.dataid, approveAction.entryid, approveAction.action, siteId);
                });
            }
            return editPromise;
        }).then(function () {
            if (discardError) {
                // Submission was discarded, add a warning.
                var message = _this.translate.instant('core.warningofflinedatadeleted', {
                    component: _this.componentTranslate,
                    name: data.name,
                    error: discardError
                });
                if (result.warnings.indexOf(message) == -1) {
                    result.warnings.push(message);
                }
            }
            // Sync done. Send event.
            _this.eventsProvider.trigger(AddonModDataSyncProvider_1.AUTO_SYNCED, {
                dataId: data.id,
                entryId: entryId,
                offlineEntryId: offlineId,
                warnings: result.warnings,
                deleted: deleted
            }, siteId);
        });
    };
    /**
     * Synchronize offline ratings.
     *
     * @param {number} [cmId] Course module to be synced. If not defined, sync all databases.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModDataSyncProvider.prototype.syncRatings = function (cmId, force, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.ratingSync.syncRatings('mod_data', 'entry', 'module', cmId, 0, force, siteId).then(function (results) {
            var updated = false;
            var warnings = [];
            var promises = [];
            results.forEach(function (result) {
                promises.push(_this.dataProvider.getDatabase(result.itemSet.courseId, result.itemSet.instanceId, siteId)
                    .then(function (data) {
                    var promises = [];
                    if (result.updated.length) {
                        updated = true;
                        // Invalidate entry of updated ratings.
                        result.updated.forEach(function (itemId) {
                            promises.push(_this.dataProvider.invalidateEntryData(data.id, itemId, siteId));
                        });
                    }
                    if (result.warnings.length) {
                        result.warnings.forEach(function (warning) {
                            warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: data.name,
                                error: warning
                            }));
                        });
                    }
                    return _this.utils.allPromises(promises);
                }));
            });
            return Promise.all(promises).then(function () {
                return { updated: updated, warnings: warnings };
            });
        });
    };
    AddonModDataSyncProvider.AUTO_SYNCED = 'addon_mod_data_autom_synced';
    AddonModDataSyncProvider = AddonModDataSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_8__offline__["a" /* AddonModDataOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_9__data__["a" /* AddonModDataProvider */],
            __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_13__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_15__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__helper__["a" /* AddonModDataHelperProvider */], __WEBPACK_IMPORTED_MODULE_14__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_16__core_rating_providers_sync__["a" /* CoreRatingSyncProvider */]])
    ], AddonModDataSyncProvider);
    return AddonModDataSyncProvider;
    var AddonModDataSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_3__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 231 */,
/* 232 */,
/* 233 */,
/* 234 */,
/* 235 */,
/* 236 */,
/* 237 */,
/* 238 */,
/* 239 */,
/* 240 */,
/* 241 */,
/* 242 */,
/* 243 */,
/* 244 */,
/* 245 */,
/* 246 */,
/* 247 */,
/* 248 */,
/* 249 */,
/* 250 */,
/* 251 */,
/* 252 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Provider to provide some helper functions regarding files and packages.
 */
var CoreFileHelperProvider = /** @class */ (function () {
    function CoreFileHelperProvider(fileProvider, filepoolProvider, sitesProvider, appProvider, translate, utils) {
        this.fileProvider = fileProvider;
        this.filepoolProvider = filepoolProvider;
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.translate = translate;
        this.utils = utils;
    }
    /**
     * Convenience function to open a file, downloading it if needed.
     *
     * @param {any} file The file to download.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {string} [state] The file's state. If not provided, it will be calculated.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {string} [siteId] The site ID. If not defined, current site.
     * @return {Promise<any>} Resolved on success.
     */
    CoreFileHelperProvider.prototype.downloadAndOpenFile = function (file, component, componentId, state, onProgress, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var fileUrl = this.getFileUrl(file), timemodified = this.getFileTimemodified(file);
        return this.downloadFileIfNeeded(file, fileUrl, component, componentId, timemodified, state, onProgress, siteId)
            .then(function (url) {
            if (!url) {
                return;
            }
            if (url.indexOf('http') === 0) {
                /* In iOS, if we use the same URL in embedded browser and background download then the download only
                   downloads a few bytes (cached ones). Add a hash to the URL so both URLs are different. */
                url = url + '#moodlemobile-embedded';
                return _this.utils.openOnlineFile(url).catch(function (error) {
                    // Error opening the file, some apps don't allow opening online files.
                    if (!_this.fileProvider.isAvailable()) {
                        return Promise.reject(error);
                    }
                    var promise;
                    // Get the state.
                    if (state) {
                        promise = Promise.resolve(state);
                    }
                    else {
                        promise = _this.filepoolProvider.getFileStateByUrl(siteId, fileUrl, timemodified);
                    }
                    return promise.then(function (state) {
                        if (state == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
                            return Promise.reject(_this.translate.instant('core.erroropenfiledownloading'));
                        }
                        var promise;
                        if (state === __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
                            // File is not downloaded, download and then return the local URL.
                            promise = _this.downloadFile(fileUrl, component, componentId, timemodified, onProgress, file, siteId);
                        }
                        else {
                            // File is outdated and can't be opened in online, return the local URL.
                            promise = _this.filepoolProvider.getInternalUrlByUrl(siteId, fileUrl);
                        }
                        return promise.then(function (url) {
                            return _this.utils.openFile(url);
                        });
                    });
                });
            }
            else {
                return _this.utils.openFile(url);
            }
        });
    };
    /**
     * Download a file if it needs to be downloaded.
     *
     * @param {any} file The file to download.
     * @param {string} fileUrl The file URL.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [timemodified] The time this file was modified.
     * @param {string} [state] The file's state. If not provided, it will be calculated.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {string} [siteId] The site ID. If not defined, current site.
     * @return {Promise<string>} Resolved with the URL to use on success.
     */
    CoreFileHelperProvider.prototype.downloadFileIfNeeded = function (file, fileUrl, component, componentId, timemodified, state, onProgress, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var fixedUrl = site.fixPluginfileURL(fileUrl);
            if (_this.fileProvider.isAvailable()) {
                var promise = void 0;
                if (state) {
                    promise = Promise.resolve(state);
                }
                else {
                    // Calculate the state.
                    promise = _this.filepoolProvider.getFileStateByUrl(siteId, fileUrl, timemodified);
                }
                return promise.then(function (state) {
                    // The file system is available.
                    var isWifi = _this.appProvider.isWifi(), isOnline = _this.appProvider.isOnline();
                    if (state == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].DOWNLOADED) {
                        // File is downloaded, get the local file URL.
                        return _this.filepoolProvider.getUrlByUrl(siteId, fileUrl, component, componentId, timemodified, false, false, file);
                    }
                    else {
                        if (!isOnline && !_this.isStateDownloaded(state)) {
                            // Not downloaded and user is offline, reject.
                            return Promise.reject(_this.translate.instant('core.networkerrormsg'));
                        }
                        if (onProgress) {
                            // This call can take a while. Send a fake event to notify that we're doing some calculations.
                            onProgress({ calculating: true });
                        }
                        return _this.filepoolProvider.shouldDownloadBeforeOpen(fixedUrl, file.filesize).then(function () {
                            if (state == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
                                // It's already downloading, stop.
                                return;
                            }
                            // Download and then return the local URL.
                            return _this.downloadFile(fileUrl, component, componentId, timemodified, onProgress, file, siteId);
                        }, function () {
                            // Start the download if in wifi, but return the URL right away so the file is opened.
                            if (isWifi) {
                                _this.downloadFile(fileUrl, component, componentId, timemodified, onProgress, file, siteId);
                            }
                            if (!_this.isStateDownloaded(state) || isOnline) {
                                // Not downloaded or online, return the online URL.
                                return fixedUrl;
                            }
                            else {
                                // Outdated but offline, so we return the local URL.
                                return _this.filepoolProvider.getUrlByUrl(siteId, fileUrl, component, componentId, timemodified, false, false, file);
                            }
                        });
                    }
                });
            }
            else {
                // Use the online URL.
                return fixedUrl;
            }
        });
    };
    /**
     * Download the file.
     *
     * @param {string} fileUrl The file URL.
     * @param {string} [component] The component to link the file to.
     * @param {string|number} [componentId] An ID to use in conjunction with the component.
     * @param {number} [timemodified] The time this file was modified.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {any} [file] The file to download.
     * @param {string} [siteId] The site ID. If not defined, current site.
     * @return {Promise<string>} Resolved with internal URL on success, rejected otherwise.
     */
    CoreFileHelperProvider.prototype.downloadFile = function (fileUrl, component, componentId, timemodified, onProgress, file, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Get the site and check if it can download files.
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.canDownloadFiles()) {
                return Promise.reject(_this.translate.instant('core.cannotdownloadfiles'));
            }
            return _this.filepoolProvider.downloadUrl(siteId, fileUrl, false, component, componentId, timemodified, onProgress, undefined, file).catch(function (error) {
                // Download failed, check the state again to see if the file was downloaded before.
                return _this.filepoolProvider.getFileStateByUrl(siteId, fileUrl, timemodified).then(function (state) {
                    if (_this.isStateDownloaded(state)) {
                        return _this.filepoolProvider.getInternalUrlByUrl(siteId, fileUrl);
                    }
                    else {
                        return Promise.reject(error);
                    }
                });
            });
        });
    };
    /**
     * Get the file's URL.
     *
     * @param {any} file The file.
     */
    CoreFileHelperProvider.prototype.getFileUrl = function (file) {
        return file.fileurl || file.url;
    };
    /**
     * Get the file's timemodified.
     *
     * @param {any} file The file.
     */
    CoreFileHelperProvider.prototype.getFileTimemodified = function (file) {
        return file.timemodified || 0;
    };
    /**
     * Check if a state is downloaded or outdated.
     *
     * @param {string} state The state to check.
     */
    CoreFileHelperProvider.prototype.isStateDownloaded = function (state) {
        return state === __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].DOWNLOADED || state === __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].OUTDATED;
    };
    /**
     * Whether the file has to be opened in browser (external repository).
     * The file must have a mimetype attribute.
     *
     * @param {any} file The file to check.
     * @return {boolean} Whether the file should be opened in browser.
     */
    CoreFileHelperProvider.prototype.shouldOpenInBrowser = function (file) {
        if (!file || !file.isexternalfile || !file.mimetype) {
            return false;
        }
        var mimetype = file.mimetype;
        if (mimetype.indexOf('application/vnd.google-apps.') != -1) {
            // Google Docs file, always open in browser.
            return true;
        }
        if (file.repositorytype == 'onedrive') {
            // In OneDrive, open in browser the office docs
            return mimetype.indexOf('application/vnd.openxmlformats-officedocument') != -1 ||
                mimetype == 'text/plain' || mimetype == 'document/unknown';
        }
        return false;
    };
    CoreFileHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_4__filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_5__sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_6__utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreFileHelperProvider);
    return CoreFileHelperProvider;
}());

//# sourceMappingURL=file-helper.js.map

/***/ }),
/* 253 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Service to handle offline data for courses.
 */
var CoreCourseOfflineProvider = /** @class */ (function () {
    function CoreCourseOfflineProvider(sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.siteSchema = {
            name: 'CoreCourseOfflineProvider',
            version: 1,
            tables: [
                {
                    name: CoreCourseOfflineProvider_1.MANUAL_COMPLETION_TABLE,
                    columns: [
                        {
                            name: 'cmid',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'completed',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'coursename',
                            type: 'TEXT'
                        },
                        {
                            name: 'timecompleted',
                            type: 'INTEGER'
                        }
                    ]
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    CoreCourseOfflineProvider_1 = CoreCourseOfflineProvider;
    /**
     * Delete a manual completion stored.
     *
     * @param {number} cmId The module ID to remove the completion.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when deleted, rejected if failure.
     */
    CoreCourseOfflineProvider.prototype.deleteManualCompletion = function (cmId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(CoreCourseOfflineProvider_1.MANUAL_COMPLETION_TABLE, { cmid: cmId });
        });
    };
    /**
     * Get all offline manual completions for a certain course.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of completions.
     */
    CoreCourseOfflineProvider.prototype.getAllManualCompletions = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(CoreCourseOfflineProvider_1.MANUAL_COMPLETION_TABLE);
        });
    };
    /**
     * Get all offline manual completions for a certain course.
     *
     * @param {number} courseId Course ID the module belongs to.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of completions.
     */
    CoreCourseOfflineProvider.prototype.getCourseManualCompletions = function (courseId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(CoreCourseOfflineProvider_1.MANUAL_COMPLETION_TABLE, { courseid: courseId });
        });
    };
    /**
     * Get the offline manual completion for a certain module.
     *
     * @param {number} cmId The module ID to remove the completion.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the completion, rejected if failure or not found.
     */
    CoreCourseOfflineProvider.prototype.getManualCompletion = function (cmId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(CoreCourseOfflineProvider_1.MANUAL_COMPLETION_TABLE, { cmid: cmId });
        });
    };
    /**
     * Offline version for manually marking a module as completed.
     *
     * @param {number} cmId The module ID to store the completion.
     * @param {number} completed Whether the module is completed or not.
     * @param {number} courseId Course ID the module belongs to.
     * @param {string} [courseName] Course name. Recommended, it is used to display a better warning message.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{status: boolean, offline: boolean}>} Promise resolved when completion is successfully stored.
     */
    CoreCourseOfflineProvider.prototype.markCompletedManually = function (cmId, completed, courseId, courseName, siteId) {
        // Store the offline data.
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                cmid: cmId,
                completed: completed,
                courseid: courseId,
                coursename: courseName || '',
                timecompleted: Date.now()
            };
            return site.getDb().insertRecord(CoreCourseOfflineProvider_1.MANUAL_COMPLETION_TABLE, entry);
        }).then(function () {
            return {
                status: true,
                offline: true
            };
        });
    };
    // Variables for database.
    CoreCourseOfflineProvider.MANUAL_COMPLETION_TABLE = 'course_manual_completion';
    CoreCourseOfflineProvider = CoreCourseOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreCourseOfflineProvider);
    return CoreCourseOfflineProvider;
    var CoreCourseOfflineProvider_1;
}());

//# sourceMappingURL=course-offline.js.map

/***/ }),
/* 254 */,
/* 255 */,
/* 256 */,
/* 257 */,
/* 258 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreEmulatorCaptureHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Helper service with some features to capture media (image, audio, video).
 */
var CoreEmulatorCaptureHelperProvider = /** @class */ (function () {
    function CoreEmulatorCaptureHelperProvider(utils, mimeUtils, modalCtrl) {
        this.utils = utils;
        this.mimeUtils = mimeUtils;
        this.modalCtrl = modalCtrl;
        this.possibleAudioMimeTypes = {
            'audio/webm': 'weba',
            'audio/ogg': 'ogg'
        };
        this.possibleVideoMimeTypes = {
            'video/webm;codecs=vp9': 'webm',
            'video/webm;codecs=vp8': 'webm',
            'video/ogg': 'ogv'
        };
        // Convert the window to "any" type because some of the variables used (like MediaRecorder) aren't in the window spec.
        this.win = window;
    }
    /**
     * Capture media (image, audio, video).
     *
     * @param {string} type Type of media: image, audio, video.
     * @param {any} [options] Optional options.
     * @return {Promise<any>} Promise resolved when captured, rejected if error.
     */
    CoreEmulatorCaptureHelperProvider.prototype.captureMedia = function (type, options) {
        options = options || {};
        try {
            // Build the params to send to the modal.
            var deferred_1 = this.utils.promiseDefer(), params = {
                type: type
            };
            var mimeAndExt = void 0, modal = void 0;
            // Initialize some data based on the type of media to capture.
            if (type == 'video') {
                mimeAndExt = this.getMimeTypeAndExtension(type, options.mimetypes);
                params.mimetype = mimeAndExt.mimetype;
                params.extension = mimeAndExt.extension;
            }
            else if (type == 'audio') {
                mimeAndExt = this.getMimeTypeAndExtension(type, options.mimetypes);
                params.mimetype = mimeAndExt.mimetype;
                params.extension = mimeAndExt.extension;
            }
            else if (type == 'image') {
                if (typeof options.sourceType != 'undefined' && options.sourceType != 1) {
                    return Promise.reject('This source type is not supported in desktop.');
                }
                if (options.cameraDirection == 1) {
                    params.facingMode = 'user';
                }
                if (options.encodingType == 1) {
                    params.mimetype = 'image/png';
                    params.extension = 'png';
                }
                else {
                    params.mimetype = 'image/jpeg';
                    params.extension = 'jpeg';
                }
                if (options.quality >= 0 && options.quality <= 100) {
                    params.quality = options.quality / 100;
                }
                if (options.destinationType == 0) {
                    params.returnDataUrl = true;
                }
            }
            if (options.duration) {
                params.maxTime = options.duration * 1000;
            }
            modal = this.modalCtrl.create('CoreEmulatorCaptureMediaPage', params);
            modal.present();
            modal.onDidDismiss(function (data, role) {
                if (role == 'success') {
                    deferred_1.resolve(data);
                }
                else {
                    deferred_1.reject(data);
                }
            });
            return deferred_1.promise;
        }
        catch (ex) {
            return Promise.reject(ex.toString());
        }
    };
    /**
     * Get the mimetype and extension to capture media.
     *
     * @param {string} type Type of media: image, audio, video.
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {{extension: string, mimetype: string}} An object with mimetype and extension to use.
     */
    CoreEmulatorCaptureHelperProvider.prototype.getMimeTypeAndExtension = function (type, mimetypes) {
        var result = {};
        if (mimetypes && mimetypes.length) {
            // Search for a supported mimetype.
            for (var i = 0; i < mimetypes.length; i++) {
                var mimetype = mimetypes[i], matches = mimetype.match(new RegExp('^' + type + '/'));
                if (matches && matches.length && this.win.MediaRecorder.isTypeSupported(mimetype)) {
                    result.mimetype = mimetype;
                    break;
                }
            }
        }
        if (result.mimetype) {
            // Found a supported mimetype in the mimetypes array, get the extension.
            result.extension = this.mimeUtils.getExtension(result.mimetype);
        }
        else if (type == 'video') {
            // No mimetype found, use default extension.
            result.mimetype = this.videoMimeType;
            result.extension = this.possibleVideoMimeTypes[result.mimetype];
        }
        else if (type == 'audio') {
            // No mimetype found, use default extension.
            result.mimetype = this.audioMimeType;
            result.extension = this.possibleAudioMimeTypes[result.mimetype];
        }
        return result;
    };
    /**
     * Init the getUserMedia function, using a deprecated function as fallback if the new one doesn't exist.
     *
     * @return {boolean} Whether the function is supported.
     */
    CoreEmulatorCaptureHelperProvider.prototype.initGetUserMedia = function () {
        var _this = this;
        var nav = navigator;
        // Check if there is a function to get user media.
        if (typeof nav.mediaDevices == 'undefined') {
            nav.mediaDevices = {};
        }
        if (!nav.mediaDevices.getUserMedia) {
            // New function doesn't exist, check if the deprecated function is supported.
            nav.getUserMedia = nav.getUserMedia || nav.webkitGetUserMedia || nav.mozGetUserMedia || nav.msGetUserMedia;
            if (nav.getUserMedia) {
                // Deprecated function exists, support the new function using the deprecated one.
                navigator.mediaDevices.getUserMedia = function (constraints) {
                    var deferred = _this.utils.promiseDefer();
                    nav.getUserMedia(constraints, deferred.resolve, deferred.reject);
                    return deferred.promise;
                };
            }
            else {
                return false;
            }
        }
        return true;
    };
    /**
     * Initialize the mimetypes to use when capturing.
     */
    CoreEmulatorCaptureHelperProvider.prototype.initMimeTypes = function () {
        // Determine video and audio mimetype to use.
        for (var mimeType in this.possibleVideoMimeTypes) {
            if (this.win.MediaRecorder.isTypeSupported(mimeType)) {
                this.videoMimeType = mimeType;
                break;
            }
        }
        for (var mimeType in this.possibleAudioMimeTypes) {
            if (this.win.MediaRecorder.isTypeSupported(mimeType)) {
                this.audioMimeType = mimeType;
                break;
            }
        }
    };
    /**
     * Load the Mocks that need it.
     *
     * @return {Promise<void>} Promise resolved when loaded.
     */
    CoreEmulatorCaptureHelperProvider.prototype.load = function () {
        if (typeof this.win.MediaRecorder != 'undefined' && this.initGetUserMedia()) {
            this.initMimeTypes();
        }
        return Promise.resolve();
    };
    CoreEmulatorCaptureHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */]])
    ], CoreEmulatorCaptureHelperProvider);
    return CoreEmulatorCaptureHelperProvider;
}());

//# sourceMappingURL=capture-helper.js.map

/***/ }),
/* 259 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__offline__ = __webpack_require__(260);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Service that provides some features for choices.
 */
var AddonModChoiceProvider = /** @class */ (function () {
    function AddonModChoiceProvider(sitesProvider, appProvider, filepoolProvider, utils, choiceOffline, logHelper) {
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.filepoolProvider = filepoolProvider;
        this.utils = utils;
        this.choiceOffline = choiceOffline;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModChoice:';
    }
    AddonModChoiceProvider_1 = AddonModChoiceProvider;
    /**
     * Check if results can be seen by a student. The student can see the results if:
     *     - they're always published, OR
     *     - they're published after the choice is closed and it's closed, OR
     *     - they're published after answering and the user has answered.
     *
     * @param  {any}     choice      Choice to check.
     * @param  {boolean} hasAnswered True if user has answered the choice, false otherwise.
     * @return {boolean} True if the students can see the results.
     */
    AddonModChoiceProvider.prototype.canStudentSeeResults = function (choice, hasAnswered) {
        var now = new Date().getTime();
        return choice.showresults === AddonModChoiceProvider_1.RESULTS_ALWAYS ||
            choice.showresults === AddonModChoiceProvider_1.RESULTS_AFTER_CLOSE &&
                choice.timeclose !== 0 && choice.timeclose <= now ||
            choice.showresults === AddonModChoiceProvider_1.RESULTS_AFTER_ANSWER && hasAnswered;
    };
    /**
     * Delete responses from a choice.
     *
     * @param  {number}   choiceId    Choice ID.
     * @param  {string}   name        Choice name.
     * @param  {number}   courseId    Course ID the choice belongs to.
     * @param  {number[]} [responses] IDs of the answers. If not defined, delete all the answers of the current user.
     * @param  {string}   [siteId]    Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if response was sent to server, false if stored in device.
     */
    AddonModChoiceProvider.prototype.deleteResponses = function (choiceId, name, courseId, responses, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        responses = responses || [];
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.choiceOffline.saveResponse(choiceId, name, courseId, responses, true, siteId).then(function () {
                return false;
            });
        };
        if (!this.appProvider.isOnline()) {
            // App is offline, store the action.
            return storeOffline();
        }
        // If there's already a response to be sent to the server, discard it first.
        return this.choiceOffline.deleteResponse(choiceId, siteId).then(function () {
            return _this.deleteResponsesOnline(choiceId, responses, siteId).then(function () {
                return true;
            }).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that responses cannot be submitted.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store in offline.
                return storeOffline();
            });
        });
    };
    /**
     * Delete responses from a choice. It will fail if offline or cannot connect.
     *
     * @param  {number}   choiceId    Choice ID.
     * @param  {number[]} [responses] IDs of the answers. If not defined, delete all the answers of the current user.
     * @param  {string}   [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when responses are successfully deleted.
     */
    AddonModChoiceProvider.prototype.deleteResponsesOnline = function (choiceId, responses, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                choiceid: choiceId,
                responses: responses
            };
            return site.write('mod_choice_delete_choice_responses', params).then(function (response) {
                // Other errors ocurring.
                if (!response || response.status === false) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
                // Invalidate related data.
                var promises = [
                    _this.invalidateOptions(choiceId, site.id),
                    _this.invalidateResults(choiceId, site.id)
                ];
                return Promise.all(promises).catch(function () {
                    // Ignore errors.
                });
            });
        });
    };
    /**
     * Get cache key for choice data WS calls.
     *
     * @param  {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModChoiceProvider.prototype.getChoiceDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'choice:' + courseId;
    };
    /**
     * Get cache key for choice options WS calls.
     *
     * @param  {number} choiceId Choice ID.
     * @return {string} Cache key.
     */
    AddonModChoiceProvider.prototype.getChoiceOptionsCacheKey = function (choiceId) {
        return this.ROOT_CACHE_KEY + 'options:' + choiceId;
    };
    /**
     * Get cache key for choice results WS calls.
     *
     * @param  {number} choiceId Choice ID.
     * @return {string} Cache key.
     */
    AddonModChoiceProvider.prototype.getChoiceResultsCacheKey = function (choiceId) {
        return this.ROOT_CACHE_KEY + 'results:' + choiceId;
    };
    /**
     * Get a choice with key=value. If more than one is found, only the first will be returned.
     *
     * @param  {string}  siteId             Site ID.
     * @param  {number}  courseId           Course ID.
     * @param  {string}  key                Name of the property to check.
     * @param  {any}     value              Value to search.
     * @param  {boolean} [forceCache] True to always get the value from cache, false otherwise. Default false.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>} Promise resolved when the choice is retrieved.
     */
    AddonModChoiceProvider.prototype.getChoiceByDataKey = function (siteId, courseId, key, value, forceCache, ignoreCache) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            };
            var preSets = {
                cacheKey: _this.getChoiceDataCacheKey(courseId),
                omitExpires: forceCache,
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_choice_get_choices_by_courses', params, preSets).then(function (response) {
                if (response && response.choices) {
                    var currentChoice = response.choices.find(function (choice) { return choice[key] == value; });
                    if (currentChoice) {
                        return currentChoice;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a choice by course module ID.
     *
     * @param  {number}  courseId           Course ID.
     * @param  {number}  cmId               Course module ID.
     * @param  {string}  [siteId]           Site ID. If not defined, current site.
     * @param  {boolean} [forceCache] True to always get the value from cache, false otherwise. Default false.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>} Promise resolved when the choice is retrieved.
     */
    AddonModChoiceProvider.prototype.getChoice = function (courseId, cmId, siteId, forceCache, ignoreCache) {
        return this.getChoiceByDataKey(siteId, courseId, 'coursemodule', cmId, forceCache, ignoreCache);
    };
    /**
     * Get a choice by ID.
     *
     * @param  {number}  courseId           Course ID.
     * @param  {number}  choiceId           Choice ID.
     * @param  {string}  [siteId]           Site ID. If not defined, current site.
     * @param  {boolean} [forceCache] True to always get the value from cache, false otherwise. Default false.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any>} Promise resolved when the choice is retrieved.
     */
    AddonModChoiceProvider.prototype.getChoiceById = function (courseId, choiceId, siteId, forceCache, ignoreCache) {
        return this.getChoiceByDataKey(siteId, courseId, 'id', choiceId, forceCache, ignoreCache);
    };
    /**
     * Get choice options.
     *
     * @param {number} choiceId Choice ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with choice options.
     */
    AddonModChoiceProvider.prototype.getOptions = function (choiceId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                choiceid: choiceId
            };
            var preSets = {
                cacheKey: _this.getChoiceOptionsCacheKey(choiceId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_7__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_choice_get_choice_options', params, preSets).then(function (response) {
                if (response.options) {
                    return response.options;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get choice results.
     *
     * @param {number} choiceId Choice ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with choice results.
     */
    AddonModChoiceProvider.prototype.getResults = function (choiceId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                choiceid: choiceId
            };
            var preSets = {
                cacheKey: _this.getChoiceResultsCacheKey(choiceId)
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_choice_get_choice_results', params, preSets).then(function (response) {
                if (response.options) {
                    return response.options;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Invalidate choice data.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChoiceProvider.prototype.invalidateChoiceData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(null).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getChoiceDataCacheKey(courseId));
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data is invalidated.
     */
    AddonModChoiceProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.getChoice(courseId, moduleId).then(function (choice) {
            return Promise.all([
                _this.invalidateChoiceData(courseId),
                _this.invalidateOptions(choice.id),
                _this.invalidateResults(choice.id),
            ]);
        }));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModChoiceProvider_1.COMPONENT, moduleId));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidate choice options.
     *
     * @param  {number} choiceId Choice ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChoiceProvider.prototype.invalidateOptions = function (choiceId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getChoiceOptionsCacheKey(choiceId));
        });
    };
    /**
     * Invalidate choice results.
     *
     * @param  {number} choiceId Choice ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChoiceProvider.prototype.invalidateResults = function (choiceId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getChoiceResultsCacheKey(choiceId));
        });
    };
    /**
     * Report the choice as being viewed.
     *
     * @param  {string} id Choice ID.
     * @param {string} [name] Name of the choice.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModChoiceProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            choiceid: id
        };
        return this.logHelper.logSingle('mod_choice_view_choice', params, AddonModChoiceProvider_1.COMPONENT, id, name, 'choice', {}, siteId);
    };
    /**
     * Send a response to a choice to Moodle.
     *
     * @param  {number}   choiceId  Choice ID.
     * @param  {string}   name      Choice name.
     * @param  {number}   courseId  Course ID the choice belongs to.
     * @param  {number[]} responses IDs of selected options.
     * @param  {string}   [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if response was sent to server, false if stored in device.
     */
    AddonModChoiceProvider.prototype.submitResponse = function (choiceId, name, courseId, responses, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Convenience function to store a message to be synchronized later.
        var storeOffline = function () {
            return _this.choiceOffline.saveResponse(choiceId, name, courseId, responses, false, siteId).then(function () {
                return false;
            });
        };
        if (!this.appProvider.isOnline()) {
            // App is offline, store the action.
            return storeOffline();
        }
        // If there's already a response to be sent to the server, discard it first.
        return this.choiceOffline.deleteResponse(choiceId, siteId).then(function () {
            return _this.submitResponseOnline(choiceId, responses, siteId).then(function () {
                return true;
            }).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // The WebService has thrown an error, this means that responses cannot be submitted.
                    return Promise.reject(error);
                }
                else {
                    // Couldn't connect to server, store it offline.
                    return storeOffline();
                }
            });
        });
    };
    /**
     * Send a response to a choice to Moodle. It will fail if offline or cannot connect.
     *
     * @param  {number}   choiceId  Choice ID.
     * @param  {number[]} responses IDs of selected options.
     * @param  {string}   [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when responses are successfully submitted.
     */
    AddonModChoiceProvider.prototype.submitResponseOnline = function (choiceId, responses, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                choiceid: choiceId,
                responses: responses
            };
            return site.write('mod_choice_submit_choice_response', params).then(function () {
                // Invalidate related data.
                var promises = [
                    _this.invalidateOptions(choiceId, siteId),
                    _this.invalidateResults(choiceId, siteId)
                ];
                return Promise.all(promises).catch(function () {
                    // Ignore errors.
                });
            });
        });
    };
    AddonModChoiceProvider.COMPONENT = 'mmaModChoice';
    AddonModChoiceProvider.RESULTS_NOT = 0;
    AddonModChoiceProvider.RESULTS_AFTER_ANSWER = 1;
    AddonModChoiceProvider.RESULTS_AFTER_CLOSE = 2;
    AddonModChoiceProvider.RESULTS_ALWAYS = 3;
    AddonModChoiceProvider.PUBLISH_ANONYMOUS = false;
    AddonModChoiceProvider.PUBLISH_NAMES = true;
    AddonModChoiceProvider = AddonModChoiceProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__offline__["a" /* AddonModChoiceOfflineProvider */], __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModChoiceProvider);
    return AddonModChoiceProvider;
    var AddonModChoiceProvider_1;
}());

//# sourceMappingURL=choice.js.map

/***/ }),
/* 260 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Service to handle offline choices.
 */
var AddonModChoiceOfflineProvider = /** @class */ (function () {
    function AddonModChoiceOfflineProvider(sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.siteSchema = {
            name: 'AddonModChoiceOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModChoiceOfflineProvider_1.CHOICE_TABLE,
                    columns: [
                        {
                            name: 'choiceid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'name',
                            type: 'TEXT'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'responses',
                            type: 'TEXT'
                        },
                        {
                            name: 'deleting',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['choiceid', 'userid']
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModChoiceOfflineProvider_1 = AddonModChoiceOfflineProvider;
    /**
     * Delete a response.
     *
     * @param  {number} choiceId Choice ID to remove.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the responses belong to. If not defined, current user in site.
     * @return {Promise<any>} Promise resolved if stored, rejected if failure.
     */
    AddonModChoiceOfflineProvider.prototype.deleteResponse = function (choiceId, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().deleteRecords(AddonModChoiceOfflineProvider_1.CHOICE_TABLE, { choiceid: choiceId, userid: userId });
        });
    };
    /**
     * Get all offline responses.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promi[se resolved with responses.
     */
    AddonModChoiceOfflineProvider.prototype.getResponses = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModChoiceOfflineProvider_1.CHOICE_TABLE).then(function (records) {
                records.forEach(function (record) {
                    record.responses = JSON.parse(record.responses);
                });
                return records;
            });
        });
    };
    /**
     * Check if there are offline responses to send.
     *
     * @param  {number} choiceId Choice ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the responses belong to. If not defined, current user in site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if has offline answers, false otherwise.
     */
    AddonModChoiceOfflineProvider.prototype.hasResponse = function (choiceId, siteId, userId) {
        return this.getResponse(choiceId, siteId, userId).then(function (response) {
            return !!response.choiceid;
        }).catch(function (error) {
            // No offline data found, return false.
            return false;
        });
    };
    /**
     * Get response to be synced.
     *
     * @param  {number} choiceId Choice ID to get.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the responses belong to. If not defined, current user in site.
     * @return {Promise<any>} Promise resolved with the object to be synced.
     */
    AddonModChoiceOfflineProvider.prototype.getResponse = function (choiceId, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().getRecord(AddonModChoiceOfflineProvider_1.CHOICE_TABLE, { choiceid: choiceId, userid: userId })
                .then(function (record) {
                record.responses = JSON.parse(record.responses);
                return record;
            });
        });
    };
    /**
     * Offline version for sending a response to a choice to Moodle.
     *
     * @param  {number}   choiceId  Choice ID.
     * @param  {string}   name      Choice name.
     * @param  {number}   courseId  Course ID the choice belongs to.
     * @param  {number[]} responses IDs of selected options.
     * @param  {boolean}  deleting  If true, the user is deleting responses, if false, submitting.
     * @param  {string}   [siteId]  Site ID. If not defined, current site.
     * @param  {number}   [userId]  User the responses belong to. If not defined, current user in site.
     * @return {Promise<any>} Promise resolved when results are successfully submitted.
     */
    AddonModChoiceOfflineProvider.prototype.saveResponse = function (choiceId, name, courseId, responses, deleting, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                choiceid: choiceId,
                name: name,
                courseid: courseId,
                userid: userId || site.getUserId(),
                responses: JSON.stringify(responses),
                deleting: deleting ? 1 : 0,
                timecreated: new Date().getTime()
            };
            return site.getDb().insertRecord(AddonModChoiceOfflineProvider_1.CHOICE_TABLE, entry);
        });
    };
    // Variables for database.
    AddonModChoiceOfflineProvider.CHOICE_TABLE = 'addon_mod_choice_responses';
    AddonModChoiceOfflineProvider = AddonModChoiceOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModChoiceOfflineProvider);
    return AddonModChoiceOfflineProvider;
    var AddonModChoiceOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 261 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(260);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__choice__ = __webpack_require__(259);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__ = __webpack_require__(178);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__ = __webpack_require__(774);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















/**
 * Service to sync choices.
 */
var AddonModChoiceSyncProvider = /** @class */ (function (_super) {
    __extends(AddonModChoiceSyncProvider, _super);
    function AddonModChoiceSyncProvider(sitesProvider, loggerProvider, appProvider, choiceOffline, eventsProvider, choiceProvider, translate, utils, textUtils, courseProvider, syncProvider, timeUtils, logHelper, prefetchHandler, prefetchDelegate) {
        var _this = _super.call(this, 'AddonModChoiceSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils, prefetchDelegate, prefetchHandler) || this;
        _this.sitesProvider = sitesProvider;
        _this.appProvider = appProvider;
        _this.choiceOffline = choiceOffline;
        _this.eventsProvider = eventsProvider;
        _this.choiceProvider = choiceProvider;
        _this.utils = utils;
        _this.textUtils = textUtils;
        _this.courseProvider = courseProvider;
        _this.logHelper = logHelper;
        _this.componentTranslate = courseProvider.translateModuleName('choice');
        return _this;
    }
    AddonModChoiceSyncProvider_1 = AddonModChoiceSyncProvider;
    /**
     * Get the ID of a choice sync.
     *
     * @param  {number} choiceId Choice ID.
     * @param  {number} userId   User the responses belong to.
     * @return {string} Sync ID.
     */
    AddonModChoiceSyncProvider.prototype.getSyncId = function (choiceId, userId) {
        return choiceId + '#' + userId;
    };
    /**
     * Try to synchronize all the choices in a certain site or in all sites.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force Wether to force sync not depending on last execution.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModChoiceSyncProvider.prototype.syncAllChoices = function (siteId, force) {
        return this.syncOnSites('choices', this.syncAllChoicesFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all pending choices on a site.
     *
     * @param {string}  [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force    Wether to force sync not depending on last execution.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModChoiceSyncProvider.prototype.syncAllChoicesFunc = function (siteId, force) {
        var _this = this;
        return this.choiceOffline.getResponses(siteId).then(function (responses) {
            // Sync all responses.
            var promises = responses.map(function (response) {
                var promise = force ? _this.syncChoice(response.choiceid, response.userid, siteId) :
                    _this.syncChoiceIfNeeded(response.choiceid, response.userid, siteId);
                return promise.then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModChoiceSyncProvider_1.AUTO_SYNCED, {
                            choiceId: response.choiceid,
                            userId: response.userid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(promises);
        });
    };
    /**
     * Sync an choice only if a certain time has passed since the last time.
     *
     * @param  {number} choiceId Choice ID to be synced.
     * @param  {number} userId   User the answers belong to.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the choice is synced or it doesn't need to be synced.
     */
    AddonModChoiceSyncProvider.prototype.syncChoiceIfNeeded = function (choiceId, userId, siteId) {
        var _this = this;
        var syncId = this.getSyncId(choiceId, userId);
        return this.isSyncNeeded(syncId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncChoice(choiceId, userId, siteId);
            }
        });
    };
    /**
     * Synchronize a choice.
     *
     * @param  {number} choiceId Choice ID to be synced.
     * @param  {number} [userId] User the answers belong to.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModChoiceSyncProvider.prototype.syncChoice = function (choiceId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            siteId = site.getId();
            var syncId = _this.getSyncId(choiceId, userId);
            if (_this.isSyncing(syncId, siteId)) {
                // There's already a sync ongoing for this discussion, return the promise.
                return _this.getOngoingSync(syncId, siteId);
            }
            _this.logger.debug("Try to sync choice '" + choiceId + "' for user '" + userId + "'");
            var courseId;
            var result = {
                warnings: [],
                updated: false
            };
            // Sync offline logs.
            var syncPromise = _this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_8__choice__["a" /* AddonModChoiceProvider */].COMPONENT, choiceId, siteId).catch(function () {
                // Ignore errors.
            }).then(function () {
                return _this.choiceOffline.getResponse(choiceId, siteId, userId).catch(function () {
                    // No offline data found, return empty object.
                    return {};
                });
            }).then(function (data) {
                if (!data.choiceid) {
                    // Nothing to sync.
                    return;
                }
                if (!_this.appProvider.isOnline()) {
                    // Cannot sync in offline.
                    return Promise.reject(null);
                }
                courseId = data.courseid;
                // Send the responses.
                var promise;
                if (data.deleting) {
                    // A user has deleted some responses.
                    promise = _this.choiceProvider.deleteResponsesOnline(choiceId, data.responses, siteId);
                }
                else {
                    // A user has added some responses.
                    promise = _this.choiceProvider.submitResponseOnline(choiceId, data.responses, siteId);
                }
                return promise.then(function () {
                    result.updated = true;
                    return _this.choiceOffline.deleteResponse(choiceId, siteId, userId);
                }).catch(function (error) {
                    if (_this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means that responses cannot be submitted. Delete them.
                        result.updated = true;
                        return _this.choiceOffline.deleteResponse(choiceId, siteId, userId).then(function () {
                            // Responses deleted, add a warning.
                            result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: data.name,
                                error: _this.textUtils.getErrorMessageFromError(error)
                            }));
                        });
                    }
                    // Couldn't connect to server, reject.
                    return Promise.reject(error);
                });
            }).then(function () {
                if (courseId) {
                    // Data has been sent to server, prefetch choice if needed.
                    return _this.courseProvider.getModuleBasicInfoByInstance(choiceId, 'choice', siteId).then(function (module) {
                        return _this.prefetchAfterUpdate(module, courseId, undefined, siteId);
                    }).catch(function () {
                        // Ignore errors.
                    });
                }
            }).then(function () {
                // Sync finished, set sync time.
                return _this.setSyncTime(syncId, siteId);
            }).then(function () {
                // All done, return the warnings.
                return result;
            });
            return _this.addOngoingSync(syncId, syncPromise, siteId);
        });
    };
    AddonModChoiceSyncProvider.AUTO_SYNCED = 'addon_mod_choice_autom_synced';
    AddonModChoiceSyncProvider = AddonModChoiceSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* AddonModChoiceOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_8__choice__["a" /* AddonModChoiceProvider */],
            __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_15__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */], __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__["a" /* AddonModChoicePrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_13__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */]])
    ], AddonModChoiceSyncProvider);
    return AddonModChoiceSyncProvider;
    var AddonModChoiceSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__["a" /* CoreCourseActivitySyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 262 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockTimelineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_courses_providers_dashboard__ = __webpack_require__(284);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_moment__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service that provides some features regarding course overview.
 */
var AddonBlockTimelineProvider = /** @class */ (function () {
    function AddonBlockTimelineProvider(sitesProvider, dashboardProvider) {
        this.sitesProvider = sitesProvider;
        this.dashboardProvider = dashboardProvider;
        // Cache key was maintained when moving the functions to this file. It comes from core myoverview.
        this.ROOT_CACHE_KEY = 'myoverview:';
    }
    AddonBlockTimelineProvider_1 = AddonBlockTimelineProvider;
    /**
     * Get calendar action events for the given course.
     *
     * @param {number} courseId Only events in this course.
     * @param {number} [afterEventId] The last seen event id.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{events: any[], canLoadMore: number}>} Promise resolved when the info is retrieved.
     */
    AddonBlockTimelineProvider.prototype.getActionEventsByCourse = function (courseId, afterEventId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var time = __WEBPACK_IMPORTED_MODULE_3_moment__().subtract(14, 'days').unix(), // Check two weeks ago.
            data = {
                timesortfrom: time,
                courseid: courseId,
                limitnum: AddonBlockTimelineProvider_1.EVENTS_LIMIT_PER_COURSE
            }, preSets = {
                cacheKey: _this.getActionEventsByCourseCacheKey(courseId)
            };
            if (afterEventId) {
                data.aftereventid = afterEventId;
            }
            return site.read('core_calendar_get_action_events_by_course', data, preSets).then(function (courseEvents) {
                if (courseEvents && courseEvents.events) {
                    return _this.treatCourseEvents(courseEvents, time);
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get calendar action events for the given course value WS call.
     *
     * @param {number} courseId Only events in this course.
     * @return {string} Cache key.
     */
    AddonBlockTimelineProvider.prototype.getActionEventsByCourseCacheKey = function (courseId) {
        return this.getActionEventsByCoursesCacheKey() + ':' + courseId;
    };
    /**
     * Get calendar action events for a given list of courses.
     *
     * @param {number[]} courseIds Course IDs.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{[s: string]: {events: any[], canLoadMore: number}}>} Promise resolved when the info is retrieved.
     */
    AddonBlockTimelineProvider.prototype.getActionEventsByCourses = function (courseIds, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var time = __WEBPACK_IMPORTED_MODULE_3_moment__().subtract(14, 'days').unix(), // Check two weeks ago.
            data = {
                timesortfrom: time,
                courseids: courseIds,
                limitnum: AddonBlockTimelineProvider_1.EVENTS_LIMIT_PER_COURSE
            }, preSets = {
                cacheKey: _this.getActionEventsByCoursesCacheKey()
            };
            return site.read('core_calendar_get_action_events_by_courses', data, preSets).then(function (events) {
                if (events && events.groupedbycourse) {
                    var courseEvents_1 = {};
                    events.groupedbycourse.forEach(function (course) {
                        courseEvents_1[course.courseid] = _this.treatCourseEvents(course, time);
                    });
                    return courseEvents_1;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for get calendar action events for a given list of courses value WS call.
     *
     * @return {string} Cache key.
     */
    AddonBlockTimelineProvider.prototype.getActionEventsByCoursesCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'bycourse';
    };
    /**
     * Get calendar action events based on the timesort value.
     *
     * @param {number} [afterEventId] The last seen event id.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{events: any[], canLoadMore: number}>} Promise resolved when the info is retrieved.
     */
    AddonBlockTimelineProvider.prototype.getActionEventsByTimesort = function (afterEventId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var time = __WEBPACK_IMPORTED_MODULE_3_moment__().subtract(14, 'days').unix(), // Check two weeks ago.
            data = {
                timesortfrom: time,
                limitnum: AddonBlockTimelineProvider_1.EVENTS_LIMIT
            }, preSets = {
                cacheKey: _this.getActionEventsByTimesortCacheKey(afterEventId, data.limitnum),
                getCacheUsingCacheKey: true,
                uniqueCacheKey: true
            };
            if (afterEventId) {
                data.aftereventid = afterEventId;
            }
            return site.read('core_calendar_get_action_events_by_timesort', data, preSets).then(function (events) {
                if (events && events.events) {
                    var canLoadMore = events.events.length >= data.limitnum ? events.lastid : undefined;
                    // Filter events by time in case it uses cache.
                    events = events.events.filter(function (element) {
                        return element.timesort >= time;
                    });
                    return {
                        events: events,
                        canLoadMore: canLoadMore
                    };
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get prefix cache key for calendar action events based on the timesort value WS calls.
     *
     * @return {string} Cache key.
     */
    AddonBlockTimelineProvider.prototype.getActionEventsByTimesortPrefixCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'bytimesort:';
    };
    /**
     * Get cache key for get calendar action events based on the timesort value WS call.
     *
     * @param {number} [afterEventId] The last seen event id.
     * @param {number} [limit] Limit num of the call.
     * @return {string} Cache key.
     */
    AddonBlockTimelineProvider.prototype.getActionEventsByTimesortCacheKey = function (afterEventId, limit) {
        afterEventId = afterEventId || 0;
        limit = limit || 0;
        return this.getActionEventsByTimesortPrefixCacheKey() + afterEventId + ':' + limit;
    };
    /**
     * Invalidates get calendar action events for a given list of courses WS call.
     *
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonBlockTimelineProvider.prototype.invalidateActionEventsByCourses = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getActionEventsByCoursesCacheKey());
        });
    };
    /**
     * Invalidates get calendar action events based on the timesort value WS call.
     *
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonBlockTimelineProvider.prototype.invalidateActionEventsByTimesort = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getActionEventsByTimesortPrefixCacheKey());
        });
    };
    /**
     * Returns whether or not My Overview is available for a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if available, resolved with false or rejected otherwise.
     */
    AddonBlockTimelineProvider.prototype.isAvailable = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // First check if dashboard is disabled.
            if (_this.dashboardProvider.isDisabledInSite(site)) {
                return false;
            }
            return site.wsAvailable('core_calendar_get_action_events_by_courses') &&
                site.wsAvailable('core_calendar_get_action_events_by_timesort');
        });
    };
    /**
     * Handles course events, filtering and treating if more can be loaded.
     *
     * @param {any} course Object containing response course events info.
     * @param {number} timeFrom Current time to filter events from.
     * @return {{events: any[], canLoadMore: number}} Object with course events and last loaded event id if more can be loaded.
     */
    AddonBlockTimelineProvider.prototype.treatCourseEvents = function (course, timeFrom) {
        var canLoadMore = course.events.length >= AddonBlockTimelineProvider_1.EVENTS_LIMIT_PER_COURSE ? course.lastid : undefined;
        // Filter events by time in case it uses cache.
        course.events = course.events.filter(function (element) {
            return element.timesort >= timeFrom;
        });
        return {
            events: course.events,
            canLoadMore: canLoadMore
        };
    };
    AddonBlockTimelineProvider.EVENTS_LIMIT = 20;
    AddonBlockTimelineProvider.EVENTS_LIMIT_PER_COURSE = 10;
    AddonBlockTimelineProvider = AddonBlockTimelineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__core_courses_providers_dashboard__["a" /* CoreCoursesDashboardProvider */]])
    ], AddonBlockTimelineProvider);
    return AddonBlockTimelineProvider;
    var AddonBlockTimelineProvider_1;
}());

//# sourceMappingURL=timeline.js.map

/***/ }),
/* 263 */
/***/ (function(module, exports) {

module.exports = require('fs');

/***/ }),
/* 264 */,
/* 265 */,
/* 266 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContentLinksModuleGradeHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(28);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Handler to handle URLs pointing to the grade of a module.
 */
var CoreContentLinksModuleGradeHandler = /** @class */ (function (_super) {
    __extends(CoreContentLinksModuleGradeHandler, _super);
    /**
     * Construct the handler.
     *
     * @param {CoreCourseHelperProvider} courseHelper The CoreCourseHelperProvider instance.
     * @param {CoreDomUtilsProvider} domUtils The CoreDomUtilsProvider instance.
     * @param {CoreSitesProvider} sitesProvider The CoreSitesProvider instance.
     * @param {string} addon Name of the addon as it's registered in course delegate. It'll be used to check if it's disabled.
     * @param {string} modName Name of the module (assign, book, ...).
     */
    function CoreContentLinksModuleGradeHandler(courseHelper, domUtils, sitesProvider, addon, modName) {
        var _this = _super.call(this) || this;
        _this.courseHelper = courseHelper;
        _this.domUtils = domUtils;
        _this.sitesProvider = sitesProvider;
        _this.addon = addon;
        _this.modName = modName;
        /**
         * If this boolean is set to true, the app will retrieve all modules with this modName with a single WS call.
         * This reduces the number of WS calls, but it isn't recommended for modules that can return a lot of contents.
         * @type {boolean}
         */
        _this.useModNameToGetModule = false;
        // Match the grade.php URL with an id param.
        _this.pattern = new RegExp('\/mod\/' + modName + '\/grade\.php.*([\&\?]id=\\d+)');
        _this.featureName = 'CoreCourseModuleDelegate_' + addon;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreContentLinksModuleGradeHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    // Check if userid is the site's current user.
                    var modal = _this.domUtils.showModalLoading();
                    _this.sitesProvider.getSite(siteId).then(function (site) {
                        if (!params.userid || params.userid == site.getUserId()) {
                            // No user specified or current user. Navigate to module.
                            _this.courseHelper.navigateToModule(parseInt(params.id, 10), siteId, courseId, undefined, _this.useModNameToGetModule ? _this.modName : undefined);
                        }
                        else if (_this.canReview) {
                            // Use the goToReview function.
                            _this.goToReview(url, params, courseId, siteId, navCtrl);
                        }
                        else {
                            // Not current user and cannot review it in the app, open it in browser.
                            site.openInBrowserWithAutoLogin(url);
                        }
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Go to the page to review.
     *
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} courseId Course ID related to the URL.
     * @param {string} siteId Site to use.
     * @param {NavController} [navCtrl] Nav Controller to use to navigate.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreContentLinksModuleGradeHandler.prototype.goToReview = function (url, params, courseId, siteId, navCtrl) {
        // This function should be overridden.
        return Promise.resolve();
    };
    return CoreContentLinksModuleGradeHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=module-grade-handler.js.map

/***/ }),
/* 267 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle Offline feedback.
 */
var AddonModFeedbackOfflineProvider = /** @class */ (function () {
    function AddonModFeedbackOfflineProvider(logger, sitesProvider, textUtils, timeUtils) {
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.timeUtils = timeUtils;
        this.siteSchema = {
            name: 'AddonModFeedbackOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModFeedbackOfflineProvider_1.FEEDBACK_TABLE,
                    columns: [
                        {
                            name: 'feedbackid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'page',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'responses',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['feedbackid', 'page']
                }
            ]
        };
        this.logger = logger.getInstance('AddonModFeedbackOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModFeedbackOfflineProvider_1 = AddonModFeedbackOfflineProvider;
    /**
     * Delete the stored for a certain feedback page.
     *
     * @param  {number} feedbackId Feedback ID.
     * @param  {number} page       Page of the form to delete responses from.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved if deleted, rejected if failure.
     */
    AddonModFeedbackOfflineProvider.prototype.deleteFeedbackPageResponses = function (feedbackId, page, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModFeedbackOfflineProvider_1.FEEDBACK_TABLE, { feedbackid: feedbackId, page: page });
        });
    };
    /**
     * Get all the stored feedback responses data from all the feedback.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved with entries.
     */
    AddonModFeedbackOfflineProvider.prototype.getAllFeedbackResponses = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getAllRecords(AddonModFeedbackOfflineProvider_1.FEEDBACK_TABLE).then(function (entries) {
                entries.forEach(function (entry) {
                    entry.responses = _this.textUtils.parseJSON(entry.responses);
                });
                return entries;
            });
        });
    };
    /**
     * Get all the stored responses from a certain feedback.
     *
     * @param  {number} feedbackId Feedback ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved with responses.
     */
    AddonModFeedbackOfflineProvider.prototype.getFeedbackResponses = function (feedbackId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonModFeedbackOfflineProvider_1.FEEDBACK_TABLE, { feedbackid: feedbackId });
        }).then(function (entries) {
            entries.forEach(function (entry) {
                entry.responses = _this.textUtils.parseJSON(entry.responses);
            });
            return entries;
        });
    };
    /**
     * Get the stored responses for a certain feedback page.
     *
     * @param  {number} feedbackId Feedback ID.
     * @param  {number} page       Page of the form to get responses from.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved with responses.
     */
    AddonModFeedbackOfflineProvider.prototype.getFeedbackPageResponses = function (feedbackId, page, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonModFeedbackOfflineProvider_1.FEEDBACK_TABLE, { feedbackid: feedbackId, page: page });
        }).then(function (entry) {
            entry.responses = _this.textUtils.parseJSON(entry.responses);
            return entry;
        });
    };
    /**
     * Get if the feedback have something to be synced.
     *
     * @param  {number} feedbackId Feedback ID.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved with true if the feedback have something to be synced.
     */
    AddonModFeedbackOfflineProvider.prototype.hasFeedbackOfflineData = function (feedbackId, siteId) {
        return this.getFeedbackResponses(feedbackId, siteId).then(function (responses) {
            return !!responses.length;
        });
    };
    /**
     * Save page responses to be sent later.
     *
     * @param  {number} feedbackId   Feedback ID.
     * @param  {number} page         The page being processed.
     * @param  {any} responses    The data to be processed the key is the field name (usually type[index]_id)
     * @param  {number} courseId     Course ID the feedback belongs to.
     * @param  {string} [siteId]     Site ID. If not defined, current site.
     * @return {Promise<any>}             Promise resolved if stored, rejected if failure.
     */
    AddonModFeedbackOfflineProvider.prototype.saveResponses = function (feedbackId, page, responses, courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                feedbackid: feedbackId,
                page: page,
                courseid: courseId,
                responses: JSON.stringify(responses),
                timemodified: _this.timeUtils.timestamp()
            };
            return site.getDb().insertRecord(AddonModFeedbackOfflineProvider_1.FEEDBACK_TABLE, entry);
        });
    };
    // Variables for database.
    AddonModFeedbackOfflineProvider.FEEDBACK_TABLE = 'addon_mod_feedback_answers';
    AddonModFeedbackOfflineProvider = AddonModFeedbackOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonModFeedbackOfflineProvider);
    return AddonModFeedbackOfflineProvider;
    var AddonModFeedbackOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 268 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossarySyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__glossary__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__helper__ = __webpack_require__(434);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__offline__ = __webpack_require__(188);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__core_rating_providers_sync__ = __webpack_require__(156);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















/**
 * Service to sync glossaries.
 */
var AddonModGlossarySyncProvider = /** @class */ (function (_super) {
    __extends(AddonModGlossarySyncProvider, _super);
    function AddonModGlossarySyncProvider(translate, appProvider, courseProvider, eventsProvider, loggerProvider, sitesProvider, syncProvider, textUtils, timeUtils, uploaderProvider, utils, glossaryProvider, glossaryHelper, glossaryOffline, logHelper, ratingSync) {
        var _this = _super.call(this, 'AddonModGlossarySyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.eventsProvider = eventsProvider;
        _this.uploaderProvider = uploaderProvider;
        _this.utils = utils;
        _this.glossaryProvider = glossaryProvider;
        _this.glossaryHelper = glossaryHelper;
        _this.glossaryOffline = glossaryOffline;
        _this.logHelper = logHelper;
        _this.ratingSync = ratingSync;
        _this.componentTranslate = courseProvider.translateModuleName('glossary');
        return _this;
    }
    AddonModGlossarySyncProvider_1 = AddonModGlossarySyncProvider;
    /**
     * Try to synchronize all the glossaries in a certain site or in all sites.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModGlossarySyncProvider.prototype.syncAllGlossaries = function (siteId, force) {
        return this.syncOnSites('all glossaries', this.syncAllGlossariesFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all glossaries on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModGlossarySyncProvider.prototype.syncAllGlossariesFunc = function (siteId, force) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        // Sync all new entries
        promises.push(this.glossaryOffline.getAllNewEntries(siteId).then(function (entries) {
            var promises = {};
            var _loop_1 = function (i) {
                var entry = entries[i];
                if (typeof promises[entry.glossaryid] != 'undefined') {
                    return "continue";
                }
                promises[entry.glossaryid] = force ? _this.syncGlossaryEntries(entry.glossaryid, entry.userid, siteId) :
                    _this.syncGlossaryEntriesIfNeeded(entry.glossaryid, entry.userid, siteId);
                promises[entry.glossaryid].then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModGlossarySyncProvider_1.AUTO_SYNCED, {
                            glossaryId: entry.glossaryid,
                            userId: entry.userid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            };
            // Do not sync same glossary twice.
            for (var i in entries) {
                _loop_1(i);
            }
            // Promises will be an object so, convert to an array first;
            return Promise.all(_this.utils.objectToArray(promises));
        }));
        promises.push(this.syncRatings(undefined, force, siteId));
        return Promise.all(promises);
    };
    /**
     * Sync a glossary only if a certain time has passed since the last time.
     *
     * @param  {number} glossaryId Glossary ID.
     * @param  {number} userId     User the entry belong to.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved when the glossary is synced or if it doesn't need to be synced.
     */
    AddonModGlossarySyncProvider.prototype.syncGlossaryEntriesIfNeeded = function (glossaryId, userId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getGlossarySyncId(glossaryId, userId);
        return this.isSyncNeeded(syncId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncGlossaryEntries(glossaryId, userId, siteId);
            }
        });
    };
    /**
     * Synchronize all offline entries of a glossary.
     *
     * @param  {number} glossaryId Glossary ID to be synced.
     * @param  {number} [userId]   User the entries belong to.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<any>}      Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModGlossarySyncProvider.prototype.syncGlossaryEntries = function (glossaryId, userId, siteId) {
        var _this = this;
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getGlossarySyncId(glossaryId, userId);
        if (this.isSyncing(syncId, siteId)) {
            // There's already a sync ongoing for this glossary, return the promise.
            return this.getOngoingSync(syncId, siteId);
        }
        // Verify that glossary isn't blocked.
        if (this.syncProvider.isBlocked(__WEBPACK_IMPORTED_MODULE_14__glossary__["a" /* AddonModGlossaryProvider */].COMPONENT, syncId, siteId)) {
            this.logger.debug('Cannot sync glossary ' + glossaryId + ' because it is blocked.');
            return Promise.reject(this.translate.instant('core.errorsyncblocked', { $a: this.componentTranslate }));
        }
        this.logger.debug('Try to sync glossary ' + glossaryId + ' for user ' + userId);
        var courseId;
        var result = {
            warnings: [],
            updated: false
        };
        // Sync offline logs.
        var syncPromise = this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_14__glossary__["a" /* AddonModGlossaryProvider */].COMPONENT, glossaryId, siteId).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Get offline responses to be sent.
            return _this.glossaryOffline.getGlossaryNewEntries(glossaryId, siteId, userId).catch(function () {
                // No offline data found, return empty object.
                return [];
            });
        }).then(function (entries) {
            if (!entries.length) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            var promises = [];
            entries.forEach(function (data) {
                var promise;
                courseId = data.courseid;
                // First of all upload the attachments (if any).
                promise = _this.uploadAttachments(glossaryId, data, siteId).then(function (itemId) {
                    // Now try to add the entry.
                    return _this.glossaryProvider.addEntryOnline(glossaryId, data.concept, data.definition, data.options, itemId, siteId);
                });
                promises.push(promise.then(function () {
                    result.updated = true;
                    return _this.deleteAddEntry(glossaryId, data.concept, data.timecreated, siteId);
                }).catch(function (error) {
                    if (_this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means that responses cannot be submitted. Delete them.
                        result.updated = true;
                        return _this.deleteAddEntry(glossaryId, data.concept, data.timecreated, siteId).then(function () {
                            // Responses deleted, add a warning.
                            result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: data.concept,
                                error: _this.textUtils.getErrorMessageFromError(error)
                            }));
                        });
                    }
                    else {
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }
                }));
            });
            return Promise.all(promises);
        }).then(function () {
            if (result.updated && courseId) {
                // Data has been sent to server. Now invalidate the WS calls.
                return _this.glossaryProvider.getGlossaryById(courseId, glossaryId).then(function (glossary) {
                    return _this.glossaryProvider.invalidateGlossaryEntries(glossary, true);
                }).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(syncId, siteId).catch(function () {
                // Ignore errors.
            });
        }).then(function () {
            // All done, return the warnings.
            return result;
        });
        return this.addOngoingSync(syncId, syncPromise, siteId);
    };
    /**
     * Synchronize offline ratings.
     *
     * @param {number} [cmId] Course module to be synced. If not defined, sync all glossaries.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModGlossarySyncProvider.prototype.syncRatings = function (cmId, force, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.ratingSync.syncRatings('mod_glossary', 'entry', 'module', cmId, 0, force, siteId).then(function (results) {
            var updated = false;
            var warnings = [];
            var promises = [];
            results.forEach(function (result) {
                if (result.updated.length) {
                    updated = true;
                    // Invalidate entry of updated ratings.
                    result.updated.forEach(function (itemId) {
                        promises.push(_this.glossaryProvider.invalidateEntry(itemId, siteId));
                    });
                }
                if (result.warnings.length) {
                    promises.push(_this.glossaryProvider.getGlossary(result.itemSet.courseId, result.itemSet.instanceId, siteId)
                        .then(function (glossary) {
                        result.warnings.forEach(function (warning) {
                            warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: glossary.name,
                                error: warning
                            }));
                        });
                    }));
                }
            });
            return _this.utils.allPromises(promises).then(function () {
                return { updated: updated, warnings: warnings };
            });
        });
    };
    /**
     * Delete a new entry.
     *
     * @param  {number} glossaryId  Glossary ID.
     * @param  {string} concept     Glossary entry concept.
     * @param  {number} timeCreated Time to allow duplicated entries.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved when deleted.
     */
    AddonModGlossarySyncProvider.prototype.deleteAddEntry = function (glossaryId, concept, timeCreated, siteId) {
        var promises = [];
        promises.push(this.glossaryOffline.deleteNewEntry(glossaryId, concept, timeCreated, siteId));
        promises.push(this.glossaryHelper.deleteStoredFiles(glossaryId, concept, timeCreated, siteId).catch(function () {
            // Ignore errors, maybe there are no files.
        }));
        return Promise.all(promises);
    };
    /**
     * Upload attachments of an offline entry.
     *
     * @param  {number} glossaryId Glossary ID.
     * @param  {any}    entry      Offline entry.
     * @param  {string} [siteId]   Site ID. If not defined, current site.
     * @return {Promise<number>} Promise resolved with draftid if uploaded, resolved with 0 if nothing to upload.
     */
    AddonModGlossarySyncProvider.prototype.uploadAttachments = function (glossaryId, entry, siteId) {
        var _this = this;
        if (entry.attachments) {
            // Has some attachments to sync.
            var files_1 = entry.attachments.online || [];
            var promise = void 0;
            if (entry.attachments.offline) {
                // Has offline files.
                promise = this.glossaryHelper.getStoredFiles(glossaryId, entry.concept, entry.timecreated, siteId).then(function (atts) {
                    files_1 = files_1.concat(atts);
                }).catch(function () {
                    // Folder not found, no files to add.
                });
            }
            else {
                promise = Promise.resolve(0);
            }
            return promise.then(function () {
                return _this.uploaderProvider.uploadOrReuploadFiles(files_1, __WEBPACK_IMPORTED_MODULE_14__glossary__["a" /* AddonModGlossaryProvider */].COMPONENT, glossaryId, siteId);
            });
        }
        // No attachments, resolve.
        return Promise.resolve(0);
    };
    /**
     * Get the ID of a glossary sync.
     *
     * @param  {number} glossaryId Glossary ID.
     * @param  {number} [userId]   User the entries belong to.. If not defined, current user.
     * @return {string}            Sync ID.
     */
    AddonModGlossarySyncProvider.prototype.getGlossarySyncId = function (glossaryId, userId) {
        userId = userId || this.sitesProvider.getCurrentSiteUserId();
        return 'glossary#' + glossaryId + '#' + userId;
    };
    AddonModGlossarySyncProvider.AUTO_SYNCED = 'addon_mod_glossary_autom_synced';
    AddonModGlossarySyncProvider = AddonModGlossarySyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_sync__["a" /* CoreSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_14__glossary__["a" /* AddonModGlossaryProvider */],
            __WEBPACK_IMPORTED_MODULE_15__helper__["a" /* AddonModGlossaryHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_16__offline__["a" /* AddonModGlossaryOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_17__core_rating_providers_sync__["a" /* CoreRatingSyncProvider */]])
    ], AddonModGlossarySyncProvider);
    return AddonModGlossarySyncProvider;
    var AddonModGlossarySyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_2__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 269 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourceHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__resource__ = __webpack_require__(181);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Service that provides helper functions for resources.
 */
var AddonModResourceHelperProvider = /** @class */ (function () {
    function AddonModResourceHelperProvider(courseProvider, domUtils, resourceProvider, courseHelper, textUtils, mimetypeUtils, fileProvider, appProvider, filepoolProvider, sitesProvider) {
        this.courseProvider = courseProvider;
        this.domUtils = domUtils;
        this.resourceProvider = resourceProvider;
        this.courseHelper = courseHelper;
        this.textUtils = textUtils;
        this.mimetypeUtils = mimetypeUtils;
        this.fileProvider = fileProvider;
        this.appProvider = appProvider;
        this.filepoolProvider = filepoolProvider;
        this.sitesProvider = sitesProvider;
        /* Constants to determine how a resource should be displayed in Moodle. */
        // Try the best way.
        this.DISPLAY_AUTO = 0;
        // Display using object tag.
        this.DISPLAY_EMBED = 1;
    }
    /**
     * Get the HTML to display an embedded resource.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @return {Promise<any>} Promise resolved with the HTML.
     */
    AddonModResourceHelperProvider.prototype.getEmbeddedHtml = function (module, courseId) {
        var _this = this;
        return this.courseHelper.downloadModuleWithMainFileIfNeeded(module, courseId, __WEBPACK_IMPORTED_MODULE_4__resource__["a" /* AddonModResourceProvider */].COMPONENT, module.id, module.contents).then(function (result) {
            var file = module.contents[0], ext = _this.mimetypeUtils.getFileExtension(file.filename), type = _this.mimetypeUtils.getExtensionType(ext), mimeType = _this.mimetypeUtils.getMimeType(ext);
            if (type == 'image') {
                return '<img src="' + result.path + '"></img>';
            }
            if (type == 'audio' || type == 'video') {
                return '<' + type + ' controls title="' + file.filename + '"" src="' + result.path + '">' +
                    '<source src="' + result.path + '" type="' + mimeType + '">' +
                    '</' + type + '>';
            }
            // Shouldn't reach here, the user should have called CoreMimetypeUtilsProvider#canBeEmbedded.
            return '';
        });
    };
    /**
     * Download all the files needed and returns the src of the iframe.
     *
     * @param {any} module The module object.
     * @return {Promise<string>} Promise resolved with the iframe src.
     */
    AddonModResourceHelperProvider.prototype.getIframeSrc = function (module) {
        var _this = this;
        if (!module.contents.length) {
            return Promise.reject(null);
        }
        var mainFile = module.contents[0];
        var mainFilePath = mainFile.filename;
        if (mainFile.filepath !== '/') {
            mainFilePath = mainFile.filepath.substr(1) + mainFilePath;
        }
        return this.filepoolProvider.getPackageDirUrlByUrl(this.sitesProvider.getCurrentSiteId(), module.url).then(function (dirPath) {
            // This URL is going to be injected in an iframe, we need trustAsResourceUrl to make it work in a browser.
            return _this.textUtils.concatenatePaths(dirPath, mainFilePath);
        }).catch(function () {
            // Error getting directory, there was an error downloading or we're in browser. Return online URL.
            if (_this.appProvider.isOnline() && mainFile.fileurl) {
                // This URL is going to be injected in an iframe, we need this to make it work.
                return Promise.resolve(_this.sitesProvider.getCurrentSite().fixPluginfileURL(mainFile.fileurl));
            }
            return Promise.reject(null);
        });
    };
    /**
     * Whether the resource has to be displayed embedded.
     *
     * @param {any} module    The module object.
     * @param {number} [display] The display mode (if available).
     * @return {boolean}         Whether the resource should be displayed embeded.
     */
    AddonModResourceHelperProvider.prototype.isDisplayedEmbedded = function (module, display) {
        if ((!module.contents.length && !module.contentsinfo) || !this.fileProvider.isAvailable() ||
            (!this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.7') && this.isNextcloudFile(module))) {
            return false;
        }
        var ext;
        if (module.contentsinfo) {
            ext = this.mimetypeUtils.getExtension(module.contentsinfo.mimetypes[0]);
        }
        else {
            ext = this.mimetypeUtils.getFileExtension(module.contents[0].filename);
        }
        return (display == this.DISPLAY_EMBED || display == this.DISPLAY_AUTO) && this.mimetypeUtils.canBeEmbedded(ext);
    };
    /**
     * Whether the resource has to be displayed in an iframe.
     *
     * @param {any} module The module object.
     * @return {boolean}   Whether the resource should be displayed in an iframe.
     */
    AddonModResourceHelperProvider.prototype.isDisplayedInIframe = function (module) {
        if ((!module.contents.length && !module.contentsinfo) || !this.fileProvider.isAvailable()) {
            return false;
        }
        var mimetype;
        if (module.contentsinfo) {
            mimetype = module.contentsinfo.mimetypes[0];
        }
        else {
            var ext = this.mimetypeUtils.getFileExtension(module.contents[0].filename);
            mimetype = this.mimetypeUtils.getMimeType(ext);
        }
        return mimetype == 'text/html';
    };
    /**
     * Check if the resource is a Nextcloud file.
     *
     * @param {any} module Module to check.
     * @return {boolean} Whether it's a Nextcloud file.
     */
    AddonModResourceHelperProvider.prototype.isNextcloudFile = function (module) {
        if (module.contentsinfo) {
            return module.contentsinfo.repositorytype == 'nextcloud';
        }
        return module.contents && module.contents[0] && module.contents[0].repositorytype == 'nextcloud';
    };
    /**
     * Opens a file of the resource activity.
     *
     * @param  {any} module        Module where to get the contents.
     * @param  {number} courseId   Course Id, used for completion purposes.
     * @return {Promise<any>}      Resolved when done.
     */
    AddonModResourceHelperProvider.prototype.openModuleFile = function (module, courseId) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        // Download and open the file from the resource contents.
        return this.courseHelper.downloadModuleAndOpenFile(module, courseId, __WEBPACK_IMPORTED_MODULE_4__resource__["a" /* AddonModResourceProvider */].COMPONENT, module.id, module.contents).then(function () {
            _this.resourceProvider.logView(module.instance, module.name).then(function () {
                _this.courseProvider.checkModuleCompletion(courseId, module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'addon.mod_resource.errorwhileloadingthecontent', true);
        }).finally(function () {
            modal.dismiss();
        });
    };
    AddonModResourceHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__resource__["a" /* AddonModResourceProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModResourceHelperProvider);
    return AddonModResourceHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 270 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(271);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service that provides some features for surveys.
 */
var AddonModSurveyProvider = /** @class */ (function () {
    function AddonModSurveyProvider(logger, sitesProvider, appProvider, filepoolProvider, utils, surveyOffline, logHelper) {
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.filepoolProvider = filepoolProvider;
        this.utils = utils;
        this.surveyOffline = surveyOffline;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModSurvey:';
        this.logger = logger.getInstance('AddonModSurveyProvider');
    }
    AddonModSurveyProvider_1 = AddonModSurveyProvider;
    /**
     * Get a survey's questions.
     *
     * @param {number} surveyId Survey ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the questions are retrieved.
     */
    AddonModSurveyProvider.prototype.getQuestions = function (surveyId, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                surveyid: surveyId
            }, preSets = {
                cacheKey: _this.getQuestionsCacheKey(surveyId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_8__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_survey_get_questions', params, preSets).then(function (response) {
                if (response.questions) {
                    return response.questions;
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for survey questions WS calls.
     *
     * @param {number} surveyId Survey ID.
     * @return {string}         Cache key.
     */
    AddonModSurveyProvider.prototype.getQuestionsCacheKey = function (surveyId) {
        return this.ROOT_CACHE_KEY + 'questions:' + surveyId;
    };
    /**
     * Get cache key for survey data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonModSurveyProvider.prototype.getSurveyCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'survey:' + courseId;
    };
    /**
     * Get a survey data.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the survey is retrieved.
     */
    AddonModSurveyProvider.prototype.getSurveyDataByKey = function (courseId, key, value, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getSurveyCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_8__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_survey_get_surveys_by_courses', params, preSets).then(function (response) {
                if (response && response.surveys) {
                    var currentSurvey = response.surveys.find(function (survey) {
                        return survey[key] == value;
                    });
                    if (currentSurvey) {
                        return currentSurvey;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a survey by course module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the survey is retrieved.
     */
    AddonModSurveyProvider.prototype.getSurvey = function (courseId, cmId, ignoreCache, siteId) {
        return this.getSurveyDataByKey(courseId, 'coursemodule', cmId, ignoreCache, siteId);
    };
    /**
     * Get a survey by ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} id Survey ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved when the survey is retrieved.
     */
    AddonModSurveyProvider.prototype.getSurveyById = function (courseId, id, ignoreCache, siteId) {
        return this.getSurveyDataByKey(courseId, 'id', id, ignoreCache, siteId);
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModSurveyProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.getSurvey(courseId, moduleId).then(function (survey) {
            var ps = [];
            // Do not invalidate activity data before getting activity info, we need it!
            ps.push(_this.invalidateSurveyData(courseId, siteId));
            ps.push(_this.invalidateQuestions(survey.id, siteId));
            return Promise.all(ps);
        }));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModSurveyProvider_1.COMPONENT, moduleId));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates survey questions.
     *
     * @param {number} surveyId Survey ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the data is invalidated.
     */
    AddonModSurveyProvider.prototype.invalidateQuestions = function (surveyId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getQuestionsCacheKey(surveyId));
        });
    };
    /**
     * Invalidates survey data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the data is invalidated.
     */
    AddonModSurveyProvider.prototype.invalidateSurveyData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getSurveyCacheKey(courseId));
        });
    };
    /**
     * Report the survey as being viewed.
     *
     * @param {number} id Module ID.
     * @param {string} [name] Name of the assign.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModSurveyProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            surveyid: id
        };
        return this.logHelper.logSingle('mod_survey_view_survey', params, AddonModSurveyProvider_1.COMPONENT, id, name, 'survey', {}, siteId);
    };
    /**
     * Send survey answers. If cannot send them to Moodle, they'll be stored in offline to be sent later.
     *
     * @param  {number} surveyId  Survey ID.
     * @param  {string} name      Survey name.
     * @param  {number} courseId  Course ID the survey belongs to.
     * @param  {any[]} answers Answers.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>}    Promise resolved with boolean if success: true if answers were sent to server,
     *                           false if stored in device.
     */
    AddonModSurveyProvider.prototype.submitAnswers = function (surveyId, name, courseId, answers, siteId) {
        var _this = this;
        // Convenience function to store a survey to be synchronized later.
        var storeOffline = function () {
            return _this.surveyOffline.saveAnswers(surveyId, name, courseId, answers, siteId).then(function () {
                return false;
            });
        };
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!this.appProvider.isOnline()) {
            // App is offline, store the message.
            return storeOffline();
        }
        // If there's already answers to be sent to the server, discard it first.
        return this.surveyOffline.deleteSurveyAnswers(surveyId, siteId).then(function () {
            // Device is online, try to send them to server.
            return _this.submitAnswersOnline(surveyId, answers, siteId).then(function () {
                return true;
            }).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // It's a WebService error, the user cannot send the message so don't store it.
                    return Promise.reject(error);
                }
                // Couldn't connect to server, store in offline.
                return storeOffline();
            });
        });
    };
    /**
     * Send survey answers to Moodle.
     *
     * @param  {number} surveyId  Survey ID.
     * @param  {any[]} answers Answers.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}     Promise resolved when answers are successfully submitted. Rejected with object containing
     *                            the error message (if any) and a boolean indicating if the error was returned by WS.
     */
    AddonModSurveyProvider.prototype.submitAnswersOnline = function (surveyId, answers, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                surveyid: surveyId,
                answers: answers
            };
            return site.write('mod_survey_submit_answers', params).then(function (response) {
                if (!response.status) {
                    return Promise.reject(_this.utils.createFakeWSError(''));
                }
            });
        });
    };
    AddonModSurveyProvider.COMPONENT = 'mmaModSurvey';
    AddonModSurveyProvider = AddonModSurveyProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* AddonModSurveyOfflineProvider */], __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModSurveyProvider);
    return AddonModSurveyProvider;
    var AddonModSurveyProvider_1;
}());

//# sourceMappingURL=survey.js.map

/***/ }),
/* 271 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service to handle Offline survey.
 */
var AddonModSurveyOfflineProvider = /** @class */ (function () {
    function AddonModSurveyOfflineProvider(logger, sitesProvider, textUtils) {
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.siteSchema = {
            name: 'AddonModSurveyOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonModSurveyOfflineProvider_1.SURVEY_TABLE,
                    columns: [
                        {
                            name: 'surveyid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'name',
                            type: 'TEXT'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'answers',
                            type: 'TEXT'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['surveyid', 'userid']
                }
            ]
        };
        this.logger = logger.getInstance('AddonModSurveyOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModSurveyOfflineProvider_1 = AddonModSurveyOfflineProvider;
    /**
     * Delete a survey answers.
     *
     * @param  {number} surveyId Survey ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the answers belong to. If not defined, current user in site.
     * @return {Promise<any>}         Promise resolved if deleted, rejected if failure.
     */
    AddonModSurveyOfflineProvider.prototype.deleteSurveyAnswers = function (surveyId, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().deleteRecords(AddonModSurveyOfflineProvider_1.SURVEY_TABLE, { surveyid: surveyId, userid: userId });
        });
    };
    /**
     * Get all the stored data from all the surveys.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved with answers.
     */
    AddonModSurveyOfflineProvider.prototype.getAllData = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getAllRecords(AddonModSurveyOfflineProvider_1.SURVEY_TABLE).then(function (entries) {
                entries.forEach(function (entry) {
                    entry.answers = _this.textUtils.parseJSON(entry.answers);
                });
                return entries;
            });
        });
    };
    /**
     * Get a survey stored answers.
     *
     * @param  {number} surveyId Survey ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the answers belong to. If not defined, current user in site.
     * @return {Promise<any>}    Promise resolved with the answers.
     */
    AddonModSurveyOfflineProvider.prototype.getSurveyAnswers = function (surveyId, siteId, userId) {
        return this.getSurveyData(surveyId, siteId, userId).then(function (entry) {
            return entry.answers || [];
        }).catch(function () {
            return [];
        });
    };
    /**
     * Get a survey stored data.
     *
     * @param  {number} surveyId Survey ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @param  {number} [userId] User the answers belong to. If not defined, current user in site.
     * @return {Promise<any>}         Promise resolved with the data.
     */
    AddonModSurveyOfflineProvider.prototype.getSurveyData = function (surveyId, siteId, userId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.getDb().getRecord(AddonModSurveyOfflineProvider_1.SURVEY_TABLE, { surveyid: surveyId, userid: userId });
        }).then(function (entry) {
            entry.answers = _this.textUtils.parseJSON(entry.answers);
            return entry;
        });
    };
    /**
     * Check if there are offline answers to send.
     *
     * @param  {number} surveyId  Survey ID.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @param  {number} [userId]  User the answers belong to. If not defined, current user in site.
     * @return {Promise<boolean>}          Promise resolved with boolean: true if has offline answers, false otherwise.
     */
    AddonModSurveyOfflineProvider.prototype.hasAnswers = function (surveyId, siteId, userId) {
        return this.getSurveyAnswers(surveyId, siteId, userId).then(function (answers) {
            return !!answers.length;
        });
    };
    /**
     * Save answers to be sent later.
     *
     * @param  {number} surveyId  Survey ID.
     * @param  {string} name      Survey name.
     * @param  {number} courseId  Course ID the survey belongs to.
     * @param  {any[]} answers    Answers.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @param  {number} [userId]  User the answers belong to. If not defined, current user in site.
     * @return {Promise<any>}     Promise resolved if stored, rejected if failure.
     */
    AddonModSurveyOfflineProvider.prototype.saveAnswers = function (surveyId, name, courseId, answers, siteId, userId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var entry = {
                surveyid: surveyId,
                name: name,
                courseid: courseId,
                userid: userId,
                answers: JSON.stringify(answers),
                timecreated: new Date().getTime()
            };
            return site.getDb().insertRecord(AddonModSurveyOfflineProvider_1.SURVEY_TABLE, entry);
        });
    };
    // Variables for database.
    AddonModSurveyOfflineProvider.SURVEY_TABLE = 'addon_mod_survey_answers';
    AddonModSurveyOfflineProvider = AddonModSurveyOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonModSurveyOfflineProvider);
    return AddonModSurveyOfflineProvider;
    var AddonModSurveyOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 272 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveySyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offline__ = __webpack_require__(271);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__survey__ = __webpack_require__(270);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__ = __webpack_require__(178);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__ = __webpack_require__(868);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















/**
 * Service to sync surveys.
 */
var AddonModSurveySyncProvider = /** @class */ (function (_super) {
    __extends(AddonModSurveySyncProvider, _super);
    function AddonModSurveySyncProvider(loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, courseProvider, surveyOffline, eventsProvider, surveyProvider, utils, timeUtils, logHelper, prefetchDelegate, prefetchHandler) {
        var _this = _super.call(this, 'AddonModSurveySyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils, prefetchDelegate, prefetchHandler) || this;
        _this.courseProvider = courseProvider;
        _this.surveyOffline = surveyOffline;
        _this.eventsProvider = eventsProvider;
        _this.surveyProvider = surveyProvider;
        _this.utils = utils;
        _this.logHelper = logHelper;
        _this.componentTranslate = courseProvider.translateModuleName('survey');
        return _this;
    }
    AddonModSurveySyncProvider_1 = AddonModSurveySyncProvider;
    /**
     * Get the ID of a survey sync.
     *
     * @param  {number} surveyId Survey ID.
     * @param  {number} userId   User the answers belong to.
     * @return {string}          Sync ID.
     * @protected
     */
    AddonModSurveySyncProvider.prototype.getSyncId = function (surveyId, userId) {
        return surveyId + '#' + userId;
    };
    /**
     * Try to synchronize all the surveys in a certain site or in all sites.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModSurveySyncProvider.prototype.syncAllSurveys = function (siteId, force) {
        return this.syncOnSites('all surveys', this.syncAllSurveysFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all pending surveys on a site.
     *
     * @param  {string} siteId Site ID to sync.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @param {Promise<any>}     Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonModSurveySyncProvider.prototype.syncAllSurveysFunc = function (siteId, force) {
        var _this = this;
        // Get all survey answers pending to be sent in the site.
        return this.surveyOffline.getAllData(siteId).then(function (entries) {
            // Sync all surveys.
            var promises = entries.map(function (entry) {
                var promise = force ? _this.syncSurvey(entry.surveyid, entry.userid, siteId) :
                    _this.syncSurveyIfNeeded(entry.surveyid, entry.userid, siteId);
                return promise.then(function (result) {
                    if (result && result.answersSent) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonModSurveySyncProvider_1.AUTO_SYNCED, {
                            surveyId: entry.surveyid,
                            userId: entry.userid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(promises);
        });
    };
    /**
     * Sync a survey only if a certain time has passed since the last time.
     *
     * @param  {number} surveyId Survey ID.
     * @param  {number} userId   User the answers belong to.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the survey is synced or if it doesn't need to be synced.
     */
    AddonModSurveySyncProvider.prototype.syncSurveyIfNeeded = function (surveyId, userId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getSyncId(surveyId, userId);
        return this.isSyncNeeded(syncId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncSurvey(surveyId, userId, siteId);
            }
        });
    };
    /**
     * Synchronize a survey.
     *
     * @param  {number} surveyId Survey ID.
     * @param  {number} [userId]   User the answers belong to. If not defined, current user.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected otherwise.
     */
    AddonModSurveySyncProvider.prototype.syncSurvey = function (surveyId, userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            siteId = site.getId();
            var syncId = _this.getSyncId(surveyId, userId);
            if (_this.isSyncing(syncId, siteId)) {
                // There's already a sync ongoing for this survey and user, return the promise.
                return _this.getOngoingSync(syncId, siteId);
            }
            _this.logger.debug("Try to sync survey '" + surveyId + "' for user '" + userId + "'");
            var courseId;
            var result = {
                warnings: [],
                answersSent: false
            };
            // Sync offline logs.
            var syncPromise = _this.logHelper.syncIfNeeded(__WEBPACK_IMPORTED_MODULE_8__survey__["a" /* AddonModSurveyProvider */].COMPONENT, surveyId, siteId).catch(function () {
                // Ignore errors.
            }).then(function () {
                // Get answers to be sent.
                return _this.surveyOffline.getSurveyData(surveyId, siteId, userId).catch(function () {
                    // No offline data found, return empty object.
                    return {};
                });
            }).then(function (data) {
                if (!data.answers || !data.answers.length) {
                    // Nothing to sync.
                    return;
                }
                if (!_this.appProvider.isOnline()) {
                    // Cannot sync in offline.
                    return Promise.reject(null);
                }
                courseId = data.courseid;
                // Send the answers.
                return _this.surveyProvider.submitAnswersOnline(surveyId, data.answers, siteId).then(function () {
                    result.answersSent = true;
                    // Answers sent, delete them.
                    return _this.surveyOffline.deleteSurveyAnswers(surveyId, siteId, userId);
                }).catch(function (error) {
                    if (_this.utils.isWebServiceError(error)) {
                        // The WebService has thrown an error, this means that answers cannot be submitted. Delete them.
                        result.answersSent = true;
                        return _this.surveyOffline.deleteSurveyAnswers(surveyId, siteId, userId).then(function () {
                            // Answers deleted, add a warning.
                            result.warnings.push(_this.translate.instant('core.warningofflinedatadeleted', {
                                component: _this.componentTranslate,
                                name: data.name,
                                error: _this.textUtils.getErrorMessageFromError(error)
                            }));
                        });
                    }
                    // Couldn't connect to server, reject.
                    return Promise.reject(error);
                });
            }).then(function () {
                if (courseId) {
                    // Data has been sent to server, update survey data.
                    return _this.courseProvider.getModuleBasicInfoByInstance(surveyId, 'survey', siteId).then(function (module) {
                        return _this.prefetchAfterUpdate(module, courseId, undefined, siteId);
                    }).catch(function () {
                        // Ignore errors.
                    });
                }
            }).then(function () {
                // Sync finished, set sync time.
                return _this.setSyncTime(syncId, siteId);
            }).then(function () {
                return result;
            });
            return _this.addOngoingSync(syncId, syncPromise, siteId);
        });
    };
    AddonModSurveySyncProvider.AUTO_SYNCED = 'addon_mod_survey_autom_synced';
    AddonModSurveySyncProvider = AddonModSurveySyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_15__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_7__offline__["a" /* AddonModSurveyOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_8__survey__["a" /* AddonModSurveyProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_12__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_13__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_16__prefetch_handler__["a" /* AddonModSurveyPrefetchHandler */]])
    ], AddonModSurveySyncProvider);
    return AddonModSurveySyncProvider;
    var AddonModSurveySyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_14__core_course_classes_activity_sync__["a" /* CoreCourseActivitySyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 273 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyComponentBase; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Base class for component to render an assessment strategy.
 */
var AddonModWorkshopAssessmentStrategyComponentBase = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyComponentBase() {
        // Nothing to do.
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWorkshopAssessmentStrategyComponentBase.prototype, "workshopId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentStrategyComponentBase.prototype, "assessment", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModWorkshopAssessmentStrategyComponentBase.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], AddonModWorkshopAssessmentStrategyComponentBase.prototype, "selectedValues", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentStrategyComponentBase.prototype, "fieldErrors", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModWorkshopAssessmentStrategyComponentBase.prototype, "strategy", void 0);
    return AddonModWorkshopAssessmentStrategyComponentBase;
}());

//# sourceMappingURL=assessment-strategy-component.js.map

/***/ }),
/* 274 */,
/* 275 */,
/* 276 */,
/* 277 */,
/* 278 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldTextHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_text__ = __webpack_require__(946);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Handler for number data field plugin.
 */
var AddonModDataFieldTextHandler = /** @class */ (function () {
    function AddonModDataFieldTextHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModDataFieldTextHandler';
        this.type = 'text';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldTextHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_text__["a" /* AddonModDataFieldTextComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldTextHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id;
        if (inputData[fieldName]) {
            return [{
                    name: fieldName,
                    value: inputData[fieldName]
                }];
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldTextHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        return [{
                fieldid: field.id,
                value: inputData[fieldName] || ''
            }];
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldTextHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id, input = inputData[fieldName] || '';
        originalFieldData = (originalFieldData && originalFieldData.content) || '';
        return input != originalFieldData;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldTextHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || !inputData[0].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldTextHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        originalContent.content = offlineContent[''] || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldTextHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldTextHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldTextHandler);
    return AddonModDataFieldTextHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 279 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMultichoiceComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to render a multichoice question.
 */
var AddonQtypeMultichoiceComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeMultichoiceComponent, _super);
    function AddonQtypeMultichoiceComponent(logger, injector) {
        return _super.call(this, logger, 'AddonQtypeMultichoiceComponent', injector) || this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeMultichoiceComponent.prototype.ngOnInit = function () {
        this.initMultichoiceComponent();
    };
    /**
     * Clear selected choices.
     */
    AddonQtypeMultichoiceComponent.prototype.clear = function () {
        this.question.singleChoiceModel = null;
    };
    AddonQtypeMultichoiceComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-multichoice',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\multichoice\component\addon-qtype-multichoice.html"*/'<section ion-list *ngIf="question.text || question.text === \'\'">\n    <!-- Question text first. -->\n    <ion-item text-wrap>\n        <core-format-text [component]="component" [componentId]="componentId" [text]="question.text"></core-format-text>\n        <core-format-text [component]="component" [componentId]="componentId" [text]="question.prompt" *ngIf="question.prompt"></core-format-text>\n    </ion-item>\n\n    <!-- Checkbox for multiple choice. -->\n    <ng-container *ngIf="question.multi">\n        <ion-item text-wrap *ngFor="let option of question.options">\n            <ion-label [color]=\'(option.isCorrect === 1 ? "success": "") +  (option.isCorrect === 0 ? "danger": "")\'>\n                <core-format-text [component]="component" [componentId]="componentId" [text]="option.text"></core-format-text>\n                <div *ngIf="option.feedback" class="specificfeedback"><core-format-text [component]="component" [componentId]="componentId" [text]="option.feedback"></core-format-text></div>\n            </ion-label>\n            <ion-checkbox [attr.name]="option.name" [(ngModel)]="option.checked" [disabled]="option.disabled" item-end [color]=\'(option.isCorrect === 1 ? "success": "") +  (option.isCorrect === 0 ? "danger": "")\'></ion-checkbox>\n            <core-icon item-content *ngIf="option.isCorrect === 1" class="core-correct-icon" name="fa-check" color="success"></core-icon>\n            <core-icon item-content *ngIf="option.isCorrect === 0" class="core-correct-icon" name="fa-remove" color="danger"></core-icon>\n\n            <!-- ion-checkbox doesn\'t use an input. Create a hidden input to hold the value. -->\n            <input item-content type="hidden" [ngModel]="option.checked" [attr.name]="option.name">\n        </ion-item>\n    </ng-container>\n\n    <!-- Radio buttons for single choice. -->\n    <div *ngIf="!question.multi" radio-group [(ngModel)]="question.singleChoiceModel" [name]="question.optionsName">\n        <ion-item text-wrap *ngFor="let option of question.options">\n            <ion-label>\n                <core-format-text [component]="component" [componentId]="componentId" [text]="option.text"></core-format-text>\n                <div *ngIf="option.feedback" class="specificfeedback"><core-format-text [component]="component" [componentId]="componentId" [text]="option.feedback"></core-format-text></div>\n            </ion-label>\n            <ion-radio [value]="option.value" [disabled]="option.disabled" [color]=\'(option.isCorrect === 1 ? "success": "") +  (option.isCorrect === 0 ? "danger": "")\'></ion-radio>\n            <core-icon item-content *ngIf="option.isCorrect === 1" class="core-correct-icon" name="fa-check" color="success"></core-icon>\n            <core-icon item-content *ngIf="option.isCorrect === 0" class="core-correct-icon" name="fa-remove" color="danger"></core-icon>\n        </ion-item>\n        <div *ngIf="!question.disabled" padding-horizontal>\n            <button text-wrap [disabled]="!question.singleChoiceModel" ion-button full color="light" (click)="clear()" type="reset">{{ \'addon.mod_quiz.clearchoice\' | translate }}</button>\n        </div>\n\n        <!-- ion-radio doesn\'t use an input. Create a hidden input to hold the selected value. -->\n        <input type="hidden" [ngModel]="question.singleChoiceModel" [attr.name]="question.optionsName">\n    </div>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\multichoice\component\addon-qtype-multichoice.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonQtypeMultichoiceComponent);
    return AddonQtypeMultichoiceComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=multichoice.js.map

/***/ }),
/* 280 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCommentsComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__comments_comments__ = __webpack_require__(762);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};






var CoreCommentsComponentsModule = /** @class */ (function () {
    function CoreCommentsComponentsModule() {
    }
    CoreCommentsComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__comments_comments__["a" /* CoreCommentsCommentsComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__comments_comments__["a" /* CoreCommentsCommentsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__comments_comments__["a" /* CoreCommentsCommentsComponent */]
            ]
        })
    ], CoreCommentsComponentsModule);
    return CoreCommentsComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 281 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCalendarProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_site__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_config__ = __webpack_require__(109);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service to handle calendar events.
 */
var AddonCalendarProvider = /** @class */ (function () {
    function AddonCalendarProvider(logger, sitesProvider, groupsProvider, coursesProvider, timeUtils, localNotificationsProvider, configProvider) {
        this.sitesProvider = sitesProvider;
        this.groupsProvider = groupsProvider;
        this.coursesProvider = coursesProvider;
        this.timeUtils = timeUtils;
        this.localNotificationsProvider = localNotificationsProvider;
        this.configProvider = configProvider;
        this.ROOT_CACHE_KEY = 'mmaCalendar:';
        this.siteSchema = {
            name: 'AddonCalendarProvider',
            version: 2,
            tables: [
                {
                    name: AddonCalendarProvider_1.EVENTS_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'name',
                            type: 'TEXT',
                            notNull: true
                        },
                        {
                            name: 'description',
                            type: 'TEXT'
                        },
                        {
                            name: 'format',
                            type: 'INTEGER'
                        },
                        {
                            name: 'eventtype',
                            type: 'TEXT'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timestart',
                            type: 'INTEGER'
                        },
                        {
                            name: 'timeduration',
                            type: 'INTEGER'
                        },
                        {
                            name: 'categoryid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'groupid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'instance',
                            type: 'INTEGER'
                        },
                        {
                            name: 'modulename',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        },
                        {
                            name: 'repeatid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'visible',
                            type: 'INTEGER'
                        },
                        {
                            name: 'uuid',
                            type: 'TEXT'
                        },
                        {
                            name: 'sequence',
                            type: 'INTEGER'
                        },
                        {
                            name: 'subscriptionid',
                            type: 'INTEGER'
                        }
                    ]
                },
                {
                    name: AddonCalendarProvider_1.REMINDERS_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'eventid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'time',
                            type: 'INTEGER'
                        }
                    ],
                    uniqueKeys: [
                        ['eventid', 'time']
                    ]
                }
            ],
            migrate: function (db, oldVersion, siteId) {
                var _this = this;
                if (oldVersion < 2) {
                    var newTable_1 = AddonCalendarProvider_1.EVENTS_TABLE;
                    var oldTable_1 = 'addon_calendar_events';
                    return db.tableExists(oldTable_1).then(function () {
                        return db.getAllRecords(oldTable_1).then(function (events) {
                            var now = Math.round(Date.now() / 1000);
                            return Promise.all(events.map(function (event) {
                                if (event.notificationtime == 0) {
                                    // No reminders.
                                    return Promise.resolve();
                                }
                                var time;
                                if (event.notificationtime == -1) {
                                    time = -1;
                                }
                                else {
                                    time = event.timestart - event.notificationtime * 60;
                                    if (time < now) {
                                        // Old reminder, just not add this.
                                        return Promise.resolve();
                                    }
                                }
                                var reminder = {
                                    eventid: event.id,
                                    time: time
                                };
                                // Cancel old notification.
                                _this.localNotificationsProvider.cancel(event.id, AddonCalendarProvider_1.COMPONENT, siteId);
                                return db.insertRecord(AddonCalendarProvider_1.REMINDERS_TABLE, reminder);
                            })).then(function () {
                                // Move the records from the old table.
                                return db.insertRecordsFrom(newTable_1, oldTable_1, undefined, 'id, name, description, format, eventtype,\
                                courseid, timestart, timeduration, categoryid, groupid, userid, instance, modulename, timemodified,\
                                repeatid, visible, uuid, sequence, subscriptionid');
                            }).then(function () {
                                return db.dropTable(oldTable_1);
                            });
                        });
                    }).catch(function () {
                        // Old table does not exist, ignore.
                    });
                }
            }
        };
        this.logger = logger.getInstance('AddonCalendarProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonCalendarProvider_1 = AddonCalendarProvider;
    /**
     * Removes expired events from local DB.
     *
     * @param {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonCalendarProvider.prototype.cleanExpiredEvents = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecordsSelect(AddonCalendarProvider_1.EVENTS_TABLE, 'timestart + timeduration < ?', [_this.timeUtils.timestamp()]).then(function (events) {
                return Promise.all(events.map(function (event) {
                    return _this.deleteEvent(event.id, siteId);
                }));
            });
        });
    };
    /**
     * Delete event cancelling all the reminders and notifications.
     *
     * @param  {number}       eventId Event ID.
     * @param  {string}       [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any>}         Resolved when done.
     */
    AddonCalendarProvider.prototype.deleteEvent = function (eventId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            siteId = site.getId();
            var promises = [];
            promises.push(site.getDb().deleteRecords(AddonCalendarProvider_1.EVENTS_TABLE, { id: eventId }));
            promises.push(site.getDb().getRecords(AddonCalendarProvider_1.REMINDERS_TABLE, { eventid: eventId }).then(function (reminders) {
                return Promise.all(reminders.map(function (reminder) {
                    return _this.deleteEventReminder(reminder.id, siteId);
                }));
            }));
            return Promise.all(promises).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Get all calendar events from local Db.
     *
     * @param {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved with all the events.
     */
    AddonCalendarProvider.prototype.getAllEventsFromLocalDb = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getAllRecords(AddonCalendarProvider_1.EVENTS_TABLE);
        });
    };
    /**
     * Get the configured default notification time.
     *
     * @param  {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<number>}  Promise resolved with the default time.
     */
    AddonCalendarProvider.prototype.getDefaultNotificationTime = function (siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var key = AddonCalendarProvider_1.DEFAULT_NOTIFICATION_TIME_SETTING + '#' + siteId;
        return this.configProvider.get(key, AddonCalendarProvider_1.DEFAULT_NOTIFICATION_TIME);
    };
    /**
     * Get a calendar event. If the server request fails and data is not cached, try to get it from local DB.
     *
     * @param {number}  id        Event ID.
     * @param {boolean} [refresh] True when we should update the event data.
     * @param {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the event data is retrieved.
     */
    AddonCalendarProvider.prototype.getEvent = function (id, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getEventCacheKey(id),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            }, data = {
                options: {
                    userevents: 0,
                    siteevents: 0,
                },
                events: {
                    eventids: [
                        id
                    ]
                }
            };
            return site.read('core_calendar_get_calendar_events', data, preSets).then(function (response) {
                // The WebService returns all category events. Check the response to search for the event we want.
                var event = response.events.find(function (e) { return e.id == id; });
                return event || _this.getEventFromLocalDb(id);
            }).catch(function () {
                return _this.getEventFromLocalDb(id);
            });
        });
    };
    /**
     * Get a calendar event by ID. This function returns more data than getEvent, but it isn't available in all Moodles.
     *
     * @param {number} id Event ID.
     * @param {boolean} [refresh] True when we should update the event data.
     * @param {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the event data is retrieved.
     * @since 3.4
     */
    AddonCalendarProvider.prototype.getEventById = function (id, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getEventCacheKey(id),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            }, data = {
                eventid: id
            };
            return site.read('core_calendar_get_calendar_event_by_id', data, preSets).then(function (response) {
                return response.event;
            });
        });
    };
    /**
     * Get cache key for a single event WS call.
     *
     * @param {number} id Event ID.
     * @return {string} Cache key.
     */
    AddonCalendarProvider.prototype.getEventCacheKey = function (id) {
        return this.ROOT_CACHE_KEY + 'events:' + id;
    };
    /**
     * Get a calendar event from local Db.
     *
     * @param  {number} id       Event ID.
     * @param  {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any>}    Promise resolved when the event data is retrieved.
     */
    AddonCalendarProvider.prototype.getEventFromLocalDb = function (id, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonCalendarProvider_1.EVENTS_TABLE, { id: id });
        });
    };
    /**
     * Adds an event reminder and schedule a new notification.
     *
     * @param  {any} event       Event to update its notification time.
     * @param  {number} time     New notification setting timestamp.
     * @param  {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the notification is updated.
     */
    AddonCalendarProvider.prototype.addEventReminder = function (event, time, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var reminder = {
                eventid: event.id,
                time: time
            };
            return site.getDb().insertRecord(AddonCalendarProvider_1.REMINDERS_TABLE, reminder).then(function (reminderId) {
                return _this.scheduleEventNotification(event, reminderId, time, site.getId());
            });
        });
    };
    /**
     * Remove an event reminder and cancel the notification.
     *
     * @param  {number} id       Reminder ID.
     * @param  {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the notification is updated.
     */
    AddonCalendarProvider.prototype.deleteEventReminder = function (id, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (_this.localNotificationsProvider.isAvailable()) {
                _this.localNotificationsProvider.cancel(id, AddonCalendarProvider_1.COMPONENT, site.getId());
            }
            return site.getDb().deleteRecords(AddonCalendarProvider_1.REMINDERS_TABLE, { id: id });
        });
    };
    /**
     * Get a calendar reminders from local Db.
     *
     * @param  {number} id       Event ID.
     * @param  {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any>}    Promise resolved when the event data is retrieved.
     */
    AddonCalendarProvider.prototype.getEventReminders = function (id, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonCalendarProvider_1.REMINDERS_TABLE, { eventid: id }, 'time ASC');
        });
    };
    /**
     * Get the events in a certain period. The period is calculated like this:
     *     start time: now + daysToStart
     *     end time: start time + daysInterval
     * E.g. using provider.getEventsList(30, 30) is going to get the events starting after 30 days from now
     * and ending before 60 days from now.
     *
     * @param {number} [daysToStart=0]   Number of days from now to start getting events.
     * @param {number} [daysInterval=30] Number of days between timestart and timeend.
     * @param {string} [siteId]          Site to get the events from. If not defined, use current site.
     * @return {Promise<any[]>}          Promise to be resolved when the participants are retrieved.
     */
    AddonCalendarProvider.prototype.getEventsList = function (daysToStart, daysInterval, siteId) {
        var _this = this;
        if (daysToStart === void 0) { daysToStart = 0; }
        if (daysInterval === void 0) { daysInterval = AddonCalendarProvider_1.DAYS_INTERVAL; }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            siteId = site.getId();
            var promises = [];
            var courses, groups;
            promises.push(_this.coursesProvider.getUserCourses(false, siteId).then(function (data) {
                courses = data;
                courses.push({ id: site.getSiteHomeId() }); // Add front page.
            }));
            promises.push(_this.groupsProvider.getAllUserGroups(siteId).then(function (data) {
                groups = data;
            }));
            return Promise.all(promises).then(function () {
                var now = _this.timeUtils.timestamp(), start = now + (__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].SECONDS_DAY * daysToStart), end = start + (__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].SECONDS_DAY * daysInterval), data = {
                    options: {
                        userevents: 1,
                        siteevents: 1,
                        timestart: start,
                        timeend: end
                    },
                    events: {
                        courseids: [],
                        groupids: []
                    }
                };
                data.events.courseids = courses.map(function (course) {
                    return course.id;
                });
                data.events.groupids = groups.map(function (group) {
                    return group.id;
                });
                // We need to retrieve cached data using cache key because we have timestamp in the params.
                var preSets = {
                    cacheKey: _this.getEventsListCacheKey(daysToStart, daysInterval),
                    getCacheUsingCacheKey: true,
                    updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
                };
                return site.read('core_calendar_get_calendar_events', data, preSets).then(function (response) {
                    _this.storeEventsInLocalDB(response.events, siteId);
                    return response.events;
                });
            });
        });
    };
    /**
     * Get prefix cache key for events list WS calls.
     *
     * @return {string} Prefix Cache key.
     */
    AddonCalendarProvider.prototype.getEventsListPrefixCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'events:';
    };
    /**
     * Get cache key for events list WS calls.
     *
     * @param {number} daysToStart  Number of days from now to start getting events.
     * @param {number} daysInterval Number of days between timestart and timeend.
     * @return {string} Cache key.
     */
    AddonCalendarProvider.prototype.getEventsListCacheKey = function (daysToStart, daysInterval) {
        return this.getEventsListPrefixCacheKey() + daysToStart + ':' + daysInterval;
    };
    /**
     * Invalidates events list and all the single events and related info.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved when the list is invalidated.
     */
    AddonCalendarProvider.prototype.invalidateEventsList = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            siteId = site.getId();
            var promises = [];
            promises.push(_this.coursesProvider.invalidateUserCourses(siteId));
            promises.push(_this.groupsProvider.invalidateAllUserGroups(siteId));
            promises.push(site.invalidateWsCacheForKeyStartingWith(_this.getEventsListPrefixCacheKey()));
            return Promise.all(promises);
        });
    };
    /**
     * Invalidates a single event.
     *
     * @param {number} eventId List of courses or course ids.
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the list is invalidated.
     */
    AddonCalendarProvider.prototype.invalidateEvent = function (eventId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getEventCacheKey(eventId));
        });
    };
    /**
     * Check if Calendar is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    AddonCalendarProvider.prototype.isCalendarDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreMainMenuDelegate_AddonCalendar');
    };
    /**
     * Check if Calendar is disabled in a certain site.
     *
     * @param  {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>}     Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    AddonCalendarProvider.prototype.isDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isCalendarDisabledInSite(site);
        });
    };
    /**
     * Check if the get event by ID WS is available.
     *
     * @return {boolean} Whether it's available.
     * @since 3.4
     */
    AddonCalendarProvider.prototype.isGetEventByIdAvailable = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_calendar_get_calendar_event_by_id');
    };
    /**
     * Get the next events for all the sites and schedules their notifications.
     * If an event notification time is 0, cancel its scheduled notification (if any).
     * If local notification plugin is not enabled, resolve the promise.
     *
     * @return {Promise}         Promise resolved when all the notifications have been scheduled.
     */
    AddonCalendarProvider.prototype.scheduleAllSitesEventsNotifications = function () {
        var _this = this;
        var notificationsEnabled = this.localNotificationsProvider.isAvailable();
        return this.sitesProvider.getSitesIds().then(function (siteIds) {
            var promises = [];
            siteIds.forEach(function (siteId) {
                promises.push(_this.cleanExpiredEvents(siteId).then(function () {
                    if (notificationsEnabled) {
                        // Check if calendar is disabled for the site.
                        return _this.isDisabled(siteId).then(function (disabled) {
                            if (!disabled) {
                                // Get first events.
                                return _this.getEventsList(undefined, undefined, siteId).then(function (events) {
                                    return _this.scheduleEventsNotifications(events, siteId);
                                });
                            }
                        });
                    }
                }));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Schedules an event notification. If time is 0, cancel scheduled notification if any.
     * If local notification plugin is not enabled, resolve the promise.
     *
     * @param  {any} event    Event to schedule.
     * @param  {number} time     Notification setting time (in minutes). E.g. 10 means "notificate 10 minutes before start".
     * @param  {string} [siteId] Site ID the event belongs to. If not defined, use current site.
     * @return {Promise<void>}    Promise resolved when the notification is scheduled.
     */
    AddonCalendarProvider.prototype.scheduleEventNotification = function (event, reminderId, time, siteId) {
        var _this = this;
        if (this.localNotificationsProvider.isAvailable()) {
            siteId = siteId || this.sitesProvider.getCurrentSiteId();
            if (time === 0) {
                // Cancel if it was scheduled.
                return this.localNotificationsProvider.cancel(reminderId, AddonCalendarProvider_1.COMPONENT, siteId);
            }
            var promise = void 0;
            if (time == -1) {
                // If time is -1, get event default time to calculate the notification time.
                promise = this.getDefaultNotificationTime(siteId).then(function (time) {
                    if (time == 0) {
                        // Default notification time is disabled, do not show.
                        return _this.localNotificationsProvider.cancel(reminderId, AddonCalendarProvider_1.COMPONENT, siteId);
                    }
                    return event.timestart - (time * 60);
                });
            }
            else {
                promise = Promise.resolve(time);
            }
            return promise.then(function (time) {
                time = time * 1000;
                if (time <= new Date().getTime()) {
                    // This reminder is over, don't schedule. Cancel if it was scheduled.
                    return _this.localNotificationsProvider.cancel(reminderId, AddonCalendarProvider_1.COMPONENT, siteId);
                }
                var notification = {
                    id: reminderId,
                    title: event.name,
                    text: _this.timeUtils.userDate(event.timestart * 1000, 'core.strftimedaydatetime', true),
                    icon: 'file://assets/img/icons/calendar.png',
                    trigger: {
                        at: new Date(time)
                    },
                    data: {
                        eventid: event.id,
                        reminderid: reminderId,
                        siteid: siteId
                    }
                };
                return _this.localNotificationsProvider.schedule(notification, AddonCalendarProvider_1.COMPONENT, siteId);
            });
        }
        else {
            return Promise.resolve();
        }
    };
    /**
     * Schedules the notifications for a list of events.
     * If an event notification time is 0, cancel its scheduled notification (if any).
     * If local notification plugin is not enabled, resolve the promise.
     *
     * @param  {any[]} events Events to schedule.
     * @param  {string} [siteId] ID of the site the events belong to. If not defined, use current site.
     * @return {Promise<any[]>}         Promise resolved when all the notifications have been scheduled.
     */
    AddonCalendarProvider.prototype.scheduleEventsNotifications = function (events, siteId) {
        var _this = this;
        if (this.localNotificationsProvider.isAvailable()) {
            siteId = siteId || this.sitesProvider.getCurrentSiteId();
            return Promise.all(events.map(function (event) {
                var timeEnd = (event.timestart + event.timeduration) * 1000;
                if (timeEnd <= new Date().getTime()) {
                    // The event has finished already, don't schedule it.
                    return _this.deleteEvent(event.id, siteId);
                }
                return _this.getEventReminders(event.id, siteId).then(function (reminders) {
                    return Promise.all(reminders.map(function (reminder) {
                        return _this.scheduleEventNotification(event, reminder.id, reminder.time, siteId);
                    }));
                });
            }));
        }
        return Promise.resolve([]);
    };
    /**
     * Set the default notification time.
     *
     * @param  {number} time     New default time.
     * @param  {string} [siteId] ID of the site. If not defined, use current site.
     * @return {Promise<any[]>}    Promise resolved when stored.
     */
    AddonCalendarProvider.prototype.setDefaultNotificationTime = function (time, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var key = AddonCalendarProvider_1.DEFAULT_NOTIFICATION_TIME_SETTING + '#' + siteId;
        return this.configProvider.set(key, time);
    };
    /**
     * Store an event in local DB as it is.
     *
     * @param {any} event Event to store.
     * @param {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when stored.
     */
    AddonCalendarProvider.prototype.storeEventInLocalDb = function (event, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            siteId = site.getId();
            // If event does not exist on the DB, schedule the reminder.
            return _this.getEventFromLocalDb(event.id, site.id).catch(function () {
                // Event does not exist. Check if any reminder exists first.
                return _this.getEventReminders(event.id, siteId).then(function (reminders) {
                    if (reminders.length == 0) {
                        _this.addEventReminder(event, -1, siteId);
                    }
                });
            }).then(function () {
                var eventRecord = {
                    id: event.id,
                    name: event.name,
                    description: event.description,
                    format: event.format,
                    eventtype: event.eventtype,
                    courseid: event.courseid,
                    timestart: event.timestart,
                    timeduration: event.timeduration,
                    categoryid: event.categoryid,
                    groupid: event.groupid,
                    userid: event.userid,
                    instance: event.instance,
                    modulename: event.modulename,
                    timemodified: event.timemodified,
                    repeatid: event.repeatid,
                    visible: event.visible,
                    uuid: event.uuid,
                    sequence: event.sequence,
                    subscriptionid: event.subscriptionid
                };
                return site.getDb().insertRecord(AddonCalendarProvider_1.EVENTS_TABLE, eventRecord);
            });
        });
    };
    /**
     * Store events in local DB.
     *
     * @param {any[]} events  Events to store.
     * @param  {string} [siteId] ID of the site the event belongs to. If not defined, use current site.
     * @return {Promise<any[]>}         Promise resolved when the events are stored.
     */
    AddonCalendarProvider.prototype.storeEventsInLocalDB = function (events, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            siteId = site.getId();
            return Promise.all(events.map(function (event) {
                // If event does not exist on the DB, schedule the reminder.
                return _this.storeEventInLocalDb(event, siteId);
            }));
        });
    };
    AddonCalendarProvider.DAYS_INTERVAL = 30;
    AddonCalendarProvider.COMPONENT = 'AddonCalendarEvents';
    AddonCalendarProvider.DEFAULT_NOTIFICATION_TIME_CHANGED = 'AddonCalendarDefaultNotificationTimeChangedEvent';
    AddonCalendarProvider.DEFAULT_NOTIFICATION_TIME_SETTING = 'mmaCalendarDefaultNotifTime';
    AddonCalendarProvider.DEFAULT_NOTIFICATION_TIME = 60;
    // Variables for database.
    AddonCalendarProvider.EVENTS_TABLE = 'addon_calendar_events_2';
    AddonCalendarProvider.REMINDERS_TABLE = 'addon_calendar_reminders';
    AddonCalendarProvider = AddonCalendarProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_config__["a" /* CoreConfigProvider */]])
    ], AddonCalendarProvider);
    return AddonCalendarProvider;
    var AddonCalendarProvider_1;
}());

//# sourceMappingURL=calendar.js.map

/***/ }),
/* 282 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle Offline messages.
 */
var AddonMessagesOfflineProvider = /** @class */ (function () {
    function AddonMessagesOfflineProvider(logger, sitesProvider, appProvider, textUtils) {
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.textUtils = textUtils;
        this.siteSchema = {
            name: 'AddonMessagesOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonMessagesOfflineProvider_1.MESSAGES_TABLE,
                    columns: [
                        {
                            name: 'touserid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'useridfrom',
                            type: 'INTEGER'
                        },
                        {
                            name: 'smallmessage',
                            type: 'TEXT'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'deviceoffline',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['touserid', 'smallmessage', 'timecreated']
                },
                {
                    name: AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE,
                    columns: [
                        {
                            name: 'conversationid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'text',
                            type: 'TEXT'
                        },
                        {
                            name: 'timecreated',
                            type: 'INTEGER'
                        },
                        {
                            name: 'deviceoffline',
                            type: 'INTEGER'
                        },
                        {
                            name: 'conversation',
                            type: 'TEXT'
                        }
                    ],
                    primaryKeys: ['conversationid', 'text', 'timecreated']
                }
            ]
        };
        this.logger = logger.getInstance('AddonMessagesOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonMessagesOfflineProvider_1 = AddonMessagesOfflineProvider;
    /**
     * Delete a message.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} message The message.
     * @param {number} timeCreated The time the message was created.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if stored, rejected if failure.
     */
    AddonMessagesOfflineProvider.prototype.deleteConversationMessage = function (conversationId, message, timeCreated, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE, {
                conversationid: conversationId,
                text: message,
                timecreated: timeCreated
            });
        });
    };
    /**
     * Delete all the messages in a conversation.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if stored, rejected if failure.
     */
    AddonMessagesOfflineProvider.prototype.deleteConversationMessages = function (conversationId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE, {
                conversationid: conversationId
            });
        });
    };
    /**
     * Delete a message.
     *
     * @param  {number} toUserId    User ID to send the message to.
     * @param  {string} message     The message.
     * @param  {number} timeCreated The time the message was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved if stored, rejected if failure.
     */
    AddonMessagesOfflineProvider.prototype.deleteMessage = function (toUserId, message, timeCreated, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonMessagesOfflineProvider_1.MESSAGES_TABLE, {
                touserid: toUserId,
                smallmessage: message,
                timecreated: timeCreated
            });
        });
    };
    /**
     * Get all messages where deviceoffline is set to 1.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}    Promise resolved with messages.
     */
    AddonMessagesOfflineProvider.prototype.getAllDeviceOfflineMessages = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = [];
            promises.push(site.getDb().getRecords(AddonMessagesOfflineProvider_1.MESSAGES_TABLE, { deviceoffline: 1 }));
            promises.push(site.getDb().getRecords(AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE, { deviceoffline: 1 }));
            return Promise.all(promises).then(function (results) {
                results[1] = _this.parseConversationMessages(results[1]);
                return results[0].concat(results[1]);
            });
        });
    };
    /**
     * Get all offline messages.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved with messages.
     */
    AddonMessagesOfflineProvider.prototype.getAllMessages = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = [];
            promises.push(site.getDb().getAllRecords(AddonMessagesOfflineProvider_1.MESSAGES_TABLE));
            promises.push(site.getDb().getAllRecords(AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE));
            return Promise.all(promises).then(function (results) {
                results[1] = _this.parseConversationMessages(results[1]);
                return results[0].concat(results[1]);
            });
        });
    };
    /**
     * Get offline messages to send to a certain user.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with messages.
     */
    AddonMessagesOfflineProvider.prototype.getConversationMessages = function (conversationId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE, { conversationid: conversationId }).then(function (messages) {
                return _this.parseConversationMessages(messages);
            });
        });
    };
    /**
     * Get offline messages to send to a certain user.
     *
     * @param  {number} toUserId       User ID to get messages to.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}    Promise resolved with messages.
     */
    AddonMessagesOfflineProvider.prototype.getMessages = function (toUserId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonMessagesOfflineProvider_1.MESSAGES_TABLE, { touserid: toUserId });
        });
    };
    /**
     * Check if there are offline messages to send to a conversation.
     *
     * @param {number} conversationId Conversation ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if has offline messages, false otherwise.
     */
    AddonMessagesOfflineProvider.prototype.hasConversationMessages = function (conversationId, siteId) {
        return this.getConversationMessages(conversationId, siteId).then(function (messages) {
            return !!messages.length;
        });
    };
    /**
     * Check if there are offline messages to send to a certain user.
     *
     * @param  {number} toUserId User ID to check.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>}    Promise resolved with boolean: true if has offline messages, false otherwise.
     */
    AddonMessagesOfflineProvider.prototype.hasMessages = function (toUserId, siteId) {
        return this.getMessages(toUserId, siteId).then(function (messages) {
            return !!messages.length;
        });
    };
    /**
     * Parse some fields of each offline conversation messages.
     *
     * @param {any[]} messages List of messages to parse.
     * @return {any[]} Parsed messages.
     */
    AddonMessagesOfflineProvider.prototype.parseConversationMessages = function (messages) {
        var _this = this;
        if (!messages) {
            return [];
        }
        messages.forEach(function (message) {
            if (message.conversation) {
                message.conversation = _this.textUtils.parseJSON(message.conversation, {});
            }
        });
        return messages;
    };
    /**
     * Save a conversation message to be sent later.
     *
     * @param {any} conversation Conversation.
     * @param {string} message The message to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if stored, rejected if failure.
     */
    AddonMessagesOfflineProvider.prototype.saveConversationMessage = function (conversation, message, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                conversationid: conversation.id,
                text: message,
                timecreated: Date.now(),
                deviceoffline: _this.appProvider.isOnline() ? 0 : 1,
                conversation: JSON.stringify({
                    name: conversation.name || '',
                    subname: conversation.subname || '',
                    imageurl: conversation.imageurl || '',
                    isfavourite: conversation.isfavourite ? 1 : 0,
                    type: conversation.type
                })
            };
            return site.getDb().insertRecord(AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE, entry).then(function () {
                return entry;
            });
        });
    };
    /**
     * Save a message to be sent later.
     *
     * @param  {number} toUserId User ID recipient of the message.
     * @param  {string} message  The message to send.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if stored, rejected if failure.
     */
    AddonMessagesOfflineProvider.prototype.saveMessage = function (toUserId, message, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                touserid: toUserId,
                useridfrom: site.getUserId(),
                smallmessage: message,
                timecreated: new Date().getTime(),
                deviceoffline: _this.appProvider.isOnline() ? 0 : 1
            };
            return site.getDb().insertRecord(AddonMessagesOfflineProvider_1.MESSAGES_TABLE, entry).then(function () {
                return entry;
            });
        });
    };
    /**
     * Set deviceoffline for a group of messages.
     *
     * @param  {any} messages Messages to update. Should be the same entry as retrieved from the DB.
     * @param  {boolean} value   Value to set.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if stored, rejected if failure.
     */
    AddonMessagesOfflineProvider.prototype.setMessagesDeviceOffline = function (messages, value, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var db = site.getDb(), promises = [], data = { deviceoffline: value ? 1 : 0 };
            messages.forEach(function (message) {
                if (message.conversationid) {
                    promises.push(db.updateRecords(AddonMessagesOfflineProvider_1.CONVERSATION_MESSAGES_TABLE, data, { conversationid: message.conversationid, text: message.text, timecreated: message.timecreated }));
                }
                else {
                    promises.push(db.updateRecords(AddonMessagesOfflineProvider_1.MESSAGES_TABLE, data, { touserid: message.touserid, smallmessage: message.smallmessage, timecreated: message.timecreated }));
                }
            });
            return Promise.all(promises);
        });
    };
    // Variables for database.
    AddonMessagesOfflineProvider.MESSAGES_TABLE = 'addon_messages_offline_messages'; // When group messaging isn't available or a new conversation starts.
    AddonMessagesOfflineProvider.CONVERSATION_MESSAGES_TABLE = 'addon_messages_offline_conversation_messages'; // Conversation messages.
    AddonMessagesOfflineProvider = AddonMessagesOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonMessagesOfflineProvider);
    return AddonMessagesOfflineProvider;
    var AddonMessagesOfflineProvider_1;
}());

//# sourceMappingURL=messages-offline.js.map

/***/ }),
/* 283 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonFilesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service to handle my files and site files.
 */
var AddonFilesProvider = /** @class */ (function () {
    function AddonFilesProvider(sitesProvider, mimeUtils) {
        this.sitesProvider = sitesProvider;
        this.mimeUtils = mimeUtils;
        this.ROOT_CACHE_KEY = 'mmaFiles:';
    }
    /**
     * Check if core_user_get_private_files_info WS call is available.
     *
     * @return {boolean} Whether the WS is available, false otherwise.
     */
    AddonFilesProvider.prototype.canGetPrivateFilesInfo = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('core_user_get_private_files_info');
    };
    /**
     * Check if user can view his private files.
     *
     * @return {boolean} Whether the user can view his private files.
     */
    AddonFilesProvider.prototype.canViewPrivateFiles = function () {
        return this.sitesProvider.getCurrentSite().canAccessMyFiles() && !this.isPrivateFilesDisabledInSite();
    };
    /**
     * Check if user can view site files.
     *
     * @return {boolean} Whether the user can view site files.
     */
    AddonFilesProvider.prototype.canViewSiteFiles = function () {
        return !this.isSiteFilesDisabledInSite();
    };
    /**
     * Check if user can upload private files.
     *
     * @return {boolean} Whether the user can upload private files.
     */
    AddonFilesProvider.prototype.canUploadFiles = function () {
        var currentSite = this.sitesProvider.getCurrentSite();
        return currentSite.canAccessMyFiles() && currentSite.canUploadFiles() && !this.isUploadDisabledInSite();
    };
    /**
     * Get the list of files.
     *
     * @param {any} params A list of parameters accepted by the Web service.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    AddonFilesProvider.prototype.getFiles = function (params, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getFilesListCacheKey(params),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('core_files_get_files', params, preSets);
        }).then(function (result) {
            var entries = [];
            if (result.files) {
                result.files.forEach(function (entry) {
                    if (entry.isdir) {
                        // Create a "link" to load the folder.
                        entry.link = {
                            contextid: entry.contextid || '',
                            component: entry.component || '',
                            filearea: entry.filearea || '',
                            itemid: entry.itemid || 0,
                            filepath: entry.filepath || '',
                            filename: entry.filename || ''
                        };
                        if (entry.component) {
                            // Delete unused elements that may break the request.
                            entry.link.filename = '';
                        }
                    }
                    if (entry.isdir) {
                        entry.imgPath = _this.mimeUtils.getFolderIcon();
                    }
                    else {
                        entry.imgPath = _this.mimeUtils.getFileIcon(entry.filename);
                    }
                    entries.push(entry);
                });
            }
            return entries;
        });
    };
    /**
     * Get cache key for file list WS calls.
     *
     * @param {any} params Params of the WS.
     * @return {string} Cache key.
     */
    AddonFilesProvider.prototype.getFilesListCacheKey = function (params) {
        var root = !params.component ? 'site' : 'my';
        return this.ROOT_CACHE_KEY + 'list:' + root + ':' + params.contextid + ':' + params.filepath;
    };
    /**
     * Get the private files of the current user.
     *
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    AddonFilesProvider.prototype.getPrivateFiles = function () {
        return this.getFiles(this.getPrivateFilesRootParams());
    };
    /**
     * Get params to get root private files directory.
     *
     * @return {any} Params.
     */
    AddonFilesProvider.prototype.getPrivateFilesRootParams = function () {
        return {
            contextid: -1,
            component: 'user',
            filearea: 'private',
            contextlevel: 'user',
            instanceid: this.sitesProvider.getCurrentSite().getUserId(),
            itemid: 0,
            filepath: '',
            filename: ''
        };
    };
    /**
     * Get private files info.
     *
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved with the info.
     */
    AddonFilesProvider.prototype.getPrivateFilesInfo = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            var params = {
                userid: userId
            }, preSets = {
                cacheKey: _this.getPrivateFilesInfoCacheKey(userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_3__classes_site__["a" /* CoreSite */].FREQUENCY_SOMETIMES
            };
            return site.read('core_user_get_private_files_info', params, preSets);
        });
    };
    /**
     * Get the cache key for private files info WS calls.
     *
     * @param {number} userId User ID.
     * @return {string} Cache key.
     */
    AddonFilesProvider.prototype.getPrivateFilesInfoCacheKey = function (userId) {
        return this.getPrivateFilesInfoCommonCacheKey() + ':' + userId;
    };
    /**
     * Get the common part of the cache keys for private files info WS calls.
     *
     * @return {string} Cache key.
     */
    AddonFilesProvider.prototype.getPrivateFilesInfoCommonCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'privateInfo';
    };
    /**
     * Get the site files.
     *
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    AddonFilesProvider.prototype.getSiteFiles = function () {
        return this.getFiles(this.getSiteFilesRootParams());
    };
    /**
     * Get params to get root site files directory.
     *
     * @return {any} Params.
     */
    AddonFilesProvider.prototype.getSiteFilesRootParams = function () {
        return {
            contextid: 0,
            component: '',
            filearea: '',
            itemid: 0,
            filepath: '',
            filename: ''
        };
    };
    /**
     * Invalidates list of files in a certain directory.
     *
     * @param {string} root Root of the directory ('my' for private files, 'site' for site files).
     * @param {string} path Path to the directory.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonFilesProvider.prototype.invalidateDirectory = function (root, path, siteId) {
        var _this = this;
        var params;
        if (!path) {
            if (root === 'site') {
                params = this.getSiteFilesRootParams();
            }
            else if (root === 'my') {
                params = this.getPrivateFilesRootParams();
            }
        }
        else {
            params = path;
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getFilesListCacheKey(params));
        });
    };
    /**
     * Invalidates private files info for all users.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonFilesProvider.prototype.invalidatePrivateFilesInfo = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKeyStartingWith(_this.getPrivateFilesInfoCommonCacheKey());
        });
    };
    /**
     * Invalidates private files info for a certain user.
     *
     * @param {number} [userId] User ID. If not defined, current user in the site.
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonFilesProvider.prototype.invalidatePrivateFilesInfoForUser = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            userId = userId || site.getUserId();
            return site.invalidateWsCacheForKey(_this.getPrivateFilesInfoCacheKey(userId));
        });
    };
    /**
     * Check if Files is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    AddonFilesProvider.prototype.isDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isDisabledInSite(site);
        });
    };
    /**
     * Check if Files is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    AddonFilesProvider.prototype.isDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreMainMenuDelegate_AddonFiles');
    };
    /**
     * Return whether or not the plugin is enabled.
     *
     * @return {boolean} True if enabled, false otherwise.
     */
    AddonFilesProvider.prototype.isPluginEnabled = function () {
        return this.canViewPrivateFiles() || this.canViewSiteFiles() || this.canUploadFiles();
    };
    /**
     * Check if private files is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    AddonFilesProvider.prototype.isPrivateFilesDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isPrivateFilesDisabledInSite(site);
        });
    };
    /**
     * Check if private files is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    AddonFilesProvider.prototype.isPrivateFilesDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('AddonFilesPrivateFiles');
    };
    /**
     * Check if site files is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    AddonFilesProvider.prototype.isSiteFilesDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isSiteFilesDisabledInSite(site);
        });
    };
    /**
     * Check if site files is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    AddonFilesProvider.prototype.isSiteFilesDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('AddonFilesSiteFiles');
    };
    /**
     * Check if upload files is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    AddonFilesProvider.prototype.isUploadDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isUploadDisabledInSite(site);
        });
    };
    /**
     * Check if upload files is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    AddonFilesProvider.prototype.isUploadDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('AddonFilesUpload');
    };
    /**
     * Move a file from draft area to private files.
     *
     * @param {number} draftId The draft area ID of the file.
     * @param {string} [siteid] ID of the site. If not defined, use current site.
     * @return {Promise<any>} Promise resolved in success, rejected otherwise.
     */
    AddonFilesProvider.prototype.moveFromDraftToPrivate = function (draftId, siteId) {
        var params = {
            draftid: draftId
        }, preSets = {
            responseExpected: false
        };
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.write('core_user_add_user_private_files', params, preSets);
        });
    };
    /**
     * Check the Moodle version in order to check if upload files is working.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if WS is working, false otherwise.
     */
    AddonFilesProvider.prototype.versionCanUploadFiles = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Upload private files doesn't work for Moodle 3.1.0 due to a bug.
            return site.isVersionGreaterEqualThan('3.1.1');
        });
    };
    AddonFilesProvider.PRIVATE_FILES_COMPONENT = 'mmaFilesMy';
    AddonFilesProvider.SITE_FILES_COMPONENT = 'mmaFilesSite';
    AddonFilesProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */]])
    ], AddonFilesProvider);
    return AddonFilesProvider;
}());

//# sourceMappingURL=files.js.map

/***/ }),
/* 284 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesDashboardProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Service that provides some features regarding course overview.
 */
var CoreCoursesDashboardProvider = /** @class */ (function () {
    function CoreCoursesDashboardProvider(sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.ROOT_CACHE_KEY = 'CoreCoursesDashboard:';
    }
    /**
     * Get cache key for dashboard blocks WS calls.
     *
     * @param {number} [userId] User ID. Default, 0 means current user.
     * @return {string} Cache key.
     */
    CoreCoursesDashboardProvider.prototype.getDashboardBlocksCacheKey = function (userId) {
        if (userId === void 0) { userId = 0; }
        return this.ROOT_CACHE_KEY + 'blocks:' + userId;
    };
    /**
     * Get dashboard blocks.
     *
     * @param {number} [userId] User ID. Default, current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of blocks.
     * @since 3.6
     */
    CoreCoursesDashboardProvider.prototype.getDashboardBlocks = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {}, preSets = {
                cacheKey: _this.getDashboardBlocksCacheKey(userId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_2__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (userId) {
                params['userid'] = userId;
            }
            return site.read('core_block_get_dashboard_blocks', params, preSets).then(function (result) {
                return result.blocks || [];
            });
        });
    };
    /**
     * Invalidates dashboard blocks WS call.
     *
     * @param {number} [userId] User ID. Default, current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCoursesDashboardProvider.prototype.invalidateDashboardBlocks = function (userId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getDashboardBlocksCacheKey(userId));
        });
    };
    /**
     * Returns whether or not block based Dashboard is available for a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with true if available, resolved with false or rejected otherwise.
     * @since 3.6
     */
    CoreCoursesDashboardProvider.prototype.isAvailable = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // First check if it's disabled.
            if (_this.isDisabledInSite(site)) {
                return false;
            }
            return site.wsAvailable('core_block_get_dashboard_blocks');
        });
    };
    /**
     * Check if Site Home is disabled in a certain site.
     *
     * @param {string} [siteId] Site Id. If not defined, use current site.
     * @return {Promise<boolean>} Promise resolved with true if disabled, rejected or resolved with false otherwise.
     */
    CoreCoursesDashboardProvider.prototype.isDisabled = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.isDisabledInSite(site);
        });
    };
    /**
     * Check if Site Home is disabled in a certain site.
     *
     * @param {CoreSite} [site] Site. If not defined, use current site.
     * @return {boolean} Whether it's disabled.
     */
    CoreCoursesDashboardProvider.prototype.isDisabledInSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.isFeatureDisabled('CoreMainMenuDelegate_CoreCoursesDashboard');
    };
    CoreCoursesDashboardProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreCoursesDashboardProvider);
    return CoreCoursesDashboardProvider;
}());

//# sourceMappingURL=dashboard.js.map

/***/ }),
/* 285 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsModuleIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__plugin_content_plugin_content__ = __webpack_require__(126);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Component that displays the index of a module site plugin.
 */
var CoreSitePluginsModuleIndexComponent = /** @class */ (function () {
    function CoreSitePluginsModuleIndexComponent(sitePluginsProvider, courseHelper, prefetchDelegate, textUtils, translate, utils, moduleDelegate) {
        this.sitePluginsProvider = sitePluginsProvider;
        this.courseHelper = courseHelper;
        this.prefetchDelegate = prefetchDelegate;
        this.textUtils = textUtils;
        this.translate = translate;
        this.utils = utils;
        this.moduleDelegate = moduleDelegate;
        this.displayOpenInBrowser = true;
        this.displayDescription = true;
        this.displayRefresh = true;
        this.displayPrefetch = true;
        this.displaySize = true;
        this.isDestroyed = false;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsModuleIndexComponent.prototype.ngOnInit = function () {
        this.refreshIcon = 'spinner';
        if (this.module) {
            var handlerName = this.moduleDelegate.getHandlerName(this.module.modname), handler = this.sitePluginsProvider.getSitePluginHandler(handlerName);
            if (handler) {
                this.component = handler.plugin.component;
                this.method = handler.handlerSchema.method;
                this.args = {
                    courseid: this.courseId,
                    cmid: this.module.id
                };
                this.initResult = handler.initResult;
                this.jsData = {
                    module: this.module,
                    courseId: this.courseId
                };
                this.displayOpenInBrowser = !this.utils.isFalseOrZero(handler.handlerSchema.displayopeninbrowser);
                this.displayDescription = !this.utils.isFalseOrZero(handler.handlerSchema.displaydescription);
                this.displayRefresh = !this.utils.isFalseOrZero(handler.handlerSchema.displayrefresh);
                this.displayPrefetch = !this.utils.isFalseOrZero(handler.handlerSchema.displayprefetch);
                this.displaySize = !this.utils.isFalseOrZero(handler.handlerSchema.displaysize);
            }
            // Get the data for the context menu.
            this.description = this.module.description;
            this.externalUrl = this.module.url;
        }
    };
    /**
     * Refresh the data.
     *
     * @param {any} [refresher] Refresher.
     * @param {Function} [done] Function to call when done.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsModuleIndexComponent.prototype.doRefresh = function (refresher, done) {
        if (this.content) {
            this.refreshIcon = 'spinner';
            return Promise.resolve(this.content.refreshContent(false)).finally(function () {
                refresher && refresher.complete();
                done && done();
            });
        }
        else {
            refresher && refresher.complete();
            done && done();
            return Promise.resolve();
        }
    };
    /**
     * Function called when the data of the site plugin content is loaded.
     */
    CoreSitePluginsModuleIndexComponent.prototype.contentLoaded = function (refresh) {
        this.refreshIcon = 'refresh';
        // Check if there is a prefetch handler for this type of module.
        if (this.prefetchDelegate.getPrefetchHandlerFor(this.module)) {
            this.courseHelper.fillContextMenu(this, this.module, this.courseId, refresh, this.component);
        }
    };
    /**
     * Function called when starting to load the data of the site plugin content.
     */
    CoreSitePluginsModuleIndexComponent.prototype.contentLoading = function (refresh) {
        this.refreshIcon = 'spinner';
    };
    /**
     * Expand the description.
     */
    CoreSitePluginsModuleIndexComponent.prototype.expandDescription = function () {
        this.textUtils.expandText(this.translate.instant('core.description'), this.description, this.component, this.module.id);
    };
    /**
     * Prefetch the module.
     */
    CoreSitePluginsModuleIndexComponent.prototype.prefetch = function () {
        this.courseHelper.contextMenuPrefetch(this, this.module, this.courseId);
    };
    /**
     * Confirm and remove downloaded files.
     */
    CoreSitePluginsModuleIndexComponent.prototype.removeFiles = function () {
        this.courseHelper.confirmAndRemoveFiles(this.module, this.courseId);
    };
    /**
     * Component destroyed.
     */
    CoreSitePluginsModuleIndexComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.statusObserver && this.statusObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsModuleIndexComponent.prototype, "module", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsModuleIndexComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_8__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_8__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */])
    ], CoreSitePluginsModuleIndexComponent.prototype, "content", void 0);
    CoreSitePluginsModuleIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-module-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\module-index\core-siteplugins-module-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item [hidden]="!displayOpenInBrowser || !externalUrl || (content && content.compileComponent && content.compileComponent.componentInstance && content.compileComponent.componentInstance.displayOpenInBrowser === false)" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item [hidden]="!displayDescription || !description || (content && content.compileComponent && content.compileComponent.componentInstance && content.compileComponent.componentInstance.displayDescription === false)" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item [hidden]="!displayRefresh || (content && content.compileComponent && content.compileComponent.componentInstance && content.compileComponent.componentInstance.displayRefresh === false)" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item [hidden]="!displayPrefetch || !prefetchStatusIcon || (content && content.compileComponent && content.compileComponent.componentInstance && content.compileComponent.componentInstance.displayPrefetch === false)" [priority]="600" [content]="prefetchText" (action)="prefetch()" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item [hidden]="!displaySize || !size || (content && content.compileComponent && content.compileComponent.componentInstance && content.compileComponent.componentInstance.displaySize === false)" [priority]="500" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<core-site-plugins-plugin-content *ngIf="component && method" [component]="component" [method]="method" [args]="args" [initResult]="initResult" [data]="jsData" (onContentLoaded)="contentLoaded($event)" (onLoadingContent)="contentLoading($event)"></core-site-plugins-plugin-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\module-index\core-siteplugins-module-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */]])
    ], CoreSitePluginsModuleIndexComponent);
    return CoreSitePluginsModuleIndexComponent;
}());

//# sourceMappingURL=module-index.js.map

/***/ }),
/* 286 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessageOutputDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Delegate to register processors (message/output) to be used in places like notification preferences.
 */
var AddonMessageOutputDelegate = /** @class */ (function (_super) {
    __extends(AddonMessageOutputDelegate, _super);
    function AddonMessageOutputDelegate(loggerProvider, sitesProvider, eventsProvider) {
        var _this = _super.call(this, 'AddonMessageOutputDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.loggerProvider = loggerProvider;
        _this.sitesProvider = sitesProvider;
        _this.eventsProvider = eventsProvider;
        _this.handlerNameProperty = 'processorName';
        return _this;
    }
    /**
     * Get the display data of the handler.
     *
     * @param {string} processor The processor object.
     * @return {AddonMessageOutputHandlerData} Data.
     */
    AddonMessageOutputDelegate.prototype.getDisplayData = function (processor) {
        return this.executeFunctionOnEnabled(processor.name, 'getDisplayData', processor);
    };
    AddonMessageOutputDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */]])
    ], AddonMessageOutputDelegate);
    return AddonMessageOutputDelegate;
}(__WEBPACK_IMPORTED_MODULE_1__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 287 */,
/* 288 */,
/* 289 */,
/* 290 */,
/* 291 */,
/* 292 */,
/* 293 */,
/* 294 */,
/* 295 */,
/* 296 */,
/* 297 */,
/* 298 */,
/* 299 */,
/* 300 */,
/* 301 */,
/* 302 */,
/* 303 */,
/* 304 */,
/* 305 */,
/* 306 */,
/* 307 */,
/* 308 */,
/* 309 */,
/* 310 */,
/* 311 */,
/* 312 */,
/* 313 */,
/* 314 */,
/* 315 */,
/* 316 */,
/* 317 */,
/* 318 */,
/* 319 */,
/* 320 */,
/* 321 */,
/* 322 */,
/* 323 */,
/* 324 */,
/* 325 */,
/* 326 */,
/* 327 */,
/* 328 */,
/* 329 */,
/* 330 */,
/* 331 */,
/* 332 */,
/* 333 */,
/* 334 */,
/* 335 */,
/* 336 */,
/* 337 */,
/* 338 */,
/* 339 */,
/* 340 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDbProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_sqlite__ = __webpack_require__(741);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_sqlitedb__ = __webpack_require__(742);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_emulator_classes_sqlitedb__ = __webpack_require__(1324);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * This service allows interacting with the local database to store and retrieve data.
 */
var CoreDbProvider = /** @class */ (function () {
    function CoreDbProvider(sqlite, platform) {
        this.sqlite = sqlite;
        this.platform = platform;
        this.dbInstances = {};
    }
    /**
     * Get or create a database object.
     *
     * The database objects are cached statically.
     *
     * @param {string} name DB name.
     * @param {boolean} forceNew True if it should always create a new instance.
     * @return {SQLiteDB} DB.
     */
    CoreDbProvider.prototype.getDB = function (name, forceNew) {
        if (typeof this.dbInstances[name] === 'undefined' || forceNew) {
            if (this.platform.is('cordova')) {
                this.dbInstances[name] = new __WEBPACK_IMPORTED_MODULE_3__classes_sqlitedb__["a" /* SQLiteDB */](name, this.sqlite, this.platform);
            }
            else {
                this.dbInstances[name] = new __WEBPACK_IMPORTED_MODULE_4__core_emulator_classes_sqlitedb__["a" /* SQLiteDBMock */](name);
            }
        }
        return this.dbInstances[name];
    };
    /**
     * Delete a DB.
     *
     * @param {string} name DB name.
     * @return {Promise<any>} Promise resolved when the DB is deleted.
     */
    CoreDbProvider.prototype.deleteDB = function (name) {
        var _this = this;
        var promise;
        if (typeof this.dbInstances[name] != 'undefined') {
            // Close the database first.
            promise = this.dbInstances[name].close();
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function () {
            var db = _this.dbInstances[name];
            delete _this.dbInstances[name];
            if (_this.platform.is('cordova')) {
                return _this.sqlite.deleteDatabase({
                    name: name,
                    location: 'default'
                });
            }
            else {
                // In WebSQL we cannot delete the database, just empty it.
                return db.emptyDatabase();
            }
        });
    };
    CoreDbProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_sqlite__["a" /* SQLite */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["w" /* Platform */]])
    ], CoreDbProvider);
    return CoreDbProvider;
}());

//# sourceMappingURL=db.js.map

/***/ }),
/* 341 */
/***/ (function(module, exports) {

if(typeof require('os') === 'undefined') {var e = new Error("Cannot find module \"require('os')\""); e.code = 'MODULE_NOT_FOUND'; throw e;}
module.exports = require('os');

/***/ }),
/* 342 */,
/* 343 */,
/* 344 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreInterceptor; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Interceptor for Http calls. Adds the header 'Content-Type'='application/x-www-form-urlencoded'
 * and serializes the parameters if needed.
 */
var CoreInterceptor = /** @class */ (function () {
    function CoreInterceptor() {
        // Nothing to do.
    }
    CoreInterceptor_1 = CoreInterceptor;
    CoreInterceptor.prototype.intercept = function (req, next) {
        // Add the header and serialize the body if needed.
        var newReq = req.clone({
            headers: req.headers.set('Content-Type', 'application/x-www-form-urlencoded'),
            body: typeof req.body == 'object' && String(req.body) != '[object File]' ?
                CoreInterceptor_1.serialize(req.body) : req.body
        });
        // Pass on the cloned request instead of the original request.
        return next.handle(newReq);
    };
    /**
     * Serialize an object to be used in a request.
     *
     * @param {any} obj Object to serialize.
     * @param {boolean} [addNull] Add null values to the serialized as empty parameters.
     * @return {string} Serialization of the object.
     */
    CoreInterceptor.serialize = function (obj, addNull) {
        var query = '', fullSubName, subValue, innerObj;
        for (var name_1 in obj) {
            var value = obj[name_1];
            if (value instanceof Array) {
                for (var i = 0; i < value.length; ++i) {
                    subValue = value[i];
                    fullSubName = name_1 + '[' + i + ']';
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += this.serialize(innerObj) + '&';
                }
            }
            else if (value instanceof Object) {
                for (var subName in value) {
                    subValue = value[subName];
                    fullSubName = name_1 + '[' + subName + ']';
                    innerObj = {};
                    innerObj[fullSubName] = subValue;
                    query += this.serialize(innerObj) + '&';
                }
            }
            else if (addNull || (typeof value != 'undefined' && value !== null)) {
                query += encodeURIComponent(name_1) + '=' + encodeURIComponent(value) + '&';
            }
        }
        return query.length ? query.substr(0, query.length - 1) : query;
    };
    CoreInterceptor = CoreInterceptor_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], CoreInterceptor);
    return CoreInterceptor;
    var CoreInterceptor_1;
}());

//# sourceMappingURL=interceptor.js.map

/***/ }),
/* 345 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitesFactoryProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/*
 * Provider to create sites instances.
*/
var CoreSitesFactoryProvider = /** @class */ (function () {
    function CoreSitesFactoryProvider(injector) {
        this.injector = injector;
    }
    /**
     * Make a site object.
     *
     * @param {string} id Site ID.
     * @param {string} siteUrl Site URL.
     * @param {string} [token] Site's WS token.
     * @param {any} [info] Site info.
     * @param {string} [privateToken] Private token.
     * @param {any} [config] Site public config.
     * @param {boolean} [loggedOut] Whether user is logged out.
     * @return {CoreSite} Site instance.
     * @description
     * This returns a site object.
     */
    CoreSitesFactoryProvider.prototype.makeSite = function (id, siteUrl, token, info, privateToken, config, loggedOut) {
        return new __WEBPACK_IMPORTED_MODULE_1__classes_site__["a" /* CoreSite */](this.injector, id, siteUrl, token, info, privateToken, config, loggedOut);
    };
    /**
     * Gets the list of Site methods.
     *
     * @return {string[]} List of methods.
     */
    CoreSitesFactoryProvider.prototype.getSiteMethods = function () {
        var methods = [];
        for (var name_1 in __WEBPACK_IMPORTED_MODULE_1__classes_site__["a" /* CoreSite */].prototype) {
            methods.push(name_1);
        }
        return methods;
    };
    CoreSitesFactoryProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], CoreSitesFactoryProvider);
    return CoreSitesFactoryProvider;
}());

//# sourceMappingURL=sites-factory.js.map

/***/ }),
/* 346 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreIframeUtilsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_contentlinks_providers_helper__ = __webpack_require__(19);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/*
 * "Utils" service with helper functions for iframes, embed and similar.
 */
var CoreIframeUtilsProvider = /** @class */ (function () {
    function CoreIframeUtilsProvider(logger, fileProvider, sitesProvider, urlUtils, textUtils, utils, domUtils, platform, appProvider, translate, network, zone, config, contentLinksHelper) {
        this.fileProvider = fileProvider;
        this.sitesProvider = sitesProvider;
        this.urlUtils = urlUtils;
        this.textUtils = textUtils;
        this.utils = utils;
        this.domUtils = domUtils;
        this.platform = platform;
        this.appProvider = appProvider;
        this.translate = translate;
        this.network = network;
        this.zone = zone;
        this.config = config;
        this.contentLinksHelper = contentLinksHelper;
        this.logger = logger.getInstance('CoreUtilsProvider');
    }
    CoreIframeUtilsProvider_1 = CoreIframeUtilsProvider;
    /**
     * Check if a frame uses an online URL but the app is offline. If it does, the iframe is hidden and a warning is shown.
     *
     * @param {any} element The frame to check (iframe, embed, ...).
     * @param {boolean} [isSubframe] Whether it's a frame inside another frame.
     * @return {boolean} True if frame is online and the app is offline, false otherwise.
     */
    CoreIframeUtilsProvider.prototype.checkOnlineFrameInOffline = function (element, isSubframe) {
        var _this = this;
        var src = element.src || element.data;
        if (src && src.match(/^https?:\/\//i) && !this.appProvider.isOnline()) {
            if (element.classList.contains('core-iframe-offline-disabled')) {
                // Iframe already hidden, stop.
                return true;
            }
            // The frame has an online URL but the app is offline. Show a warning, or a link if the URL can be opened in the app.
            var div_1 = document.createElement('div');
            div_1.setAttribute('text-center', '');
            div_1.setAttribute('padding', '');
            div_1.classList.add('core-iframe-offline-warning');
            var site = this.sitesProvider.getCurrentSite();
            var username_1 = site ? site.getInfo().username : undefined;
            this.contentLinksHelper.canHandleLink(src, undefined, username_1).then(function (canHandleLink) {
                if (canHandleLink) {
                    var link = document.createElement('a');
                    if (isSubframe) {
                        // Ionic styles are not available in subframes, adding some minimal inline styles.
                        link.style.display = 'block';
                        link.style.padding = '1em';
                        link.style.fontWeight = '500';
                        link.style.textAlign = 'center';
                        link.style.textTransform = 'uppercase';
                        link.style.cursor = 'pointer';
                    }
                    else {
                        var mode = _this.config.get('mode');
                        link.setAttribute('ion-button', '');
                        link.classList.add('button', 'button-' + mode, 'button-default', 'button-default-' + mode, 'button-block', 'button-block-' + mode);
                    }
                    var message = _this.translate.instant('core.viewembeddedcontent');
                    link.innerHTML = isSubframe ? message : '<span class="button-inner">' + message + '</span>';
                    link.onclick = function (event) {
                        _this.contentLinksHelper.handleLink(src, username_1);
                        event.preventDefault();
                    };
                    div_1.appendChild(link);
                }
                else {
                    div_1.innerHTML = (isSubframe ? '' : _this.domUtils.getConnectionWarningIconHtml()) +
                        '<p>' + _this.translate.instant('core.networkerroriframemsg') + '</p>';
                }
                element.parentElement.insertBefore(div_1, element);
            });
            // Add a class to specify that the iframe is hidden.
            element.classList.add('core-iframe-offline-disabled');
            if (isSubframe) {
                // We cannot apply CSS styles in subframes, just hide the iframe.
                element.style.display = 'none';
            }
            // If the network changes, check it again.
            var subscription_1 = this.network.onConnect().subscribe(function () {
                // Execute the callback in the Angular zone, so change detection doesn't stop working.
                _this.zone.run(function () {
                    if (!_this.checkOnlineFrameInOffline(element, isSubframe)) {
                        // Now the app is online, no need to check connection again.
                        subscription_1.unsubscribe();
                    }
                });
            });
            return true;
        }
        else if (element.classList.contains('core-iframe-offline-disabled')) {
            // Reload the frame.
            element.src = element.src;
            element.data = element.data;
            // Remove the warning and show the iframe
            this.domUtils.removeElement(element.parentElement, 'div.core-iframe-offline-warning');
            element.classList.remove('core-iframe-offline-disabled');
            if (isSubframe) {
                element.style.display = '';
            }
        }
        return false;
    };
    /**
     * Given an element, return the content window and document.
     * Please notice that the element should be an iframe, embed or similar.
     *
     * @param {any} element Element to treat (iframe, embed, ...).
     * @return {{ window: Window, document: Document }} Window and Document.
     */
    CoreIframeUtilsProvider.prototype.getContentWindowAndDocument = function (element) {
        var contentWindow = element.contentWindow, contentDocument;
        try {
            contentDocument = element.contentDocument || (contentWindow && contentWindow.document);
        }
        catch (ex) {
            // Ignore errors.
        }
        if (!contentWindow && contentDocument) {
            // It's probably an <object>. Try to get the window.
            contentWindow = contentDocument.defaultView;
        }
        if (!contentWindow && element.getSVGDocument) {
            // It's probably an <embed>. Try to get the window and the document.
            try {
                contentDocument = element.getSVGDocument();
            }
            catch (ex) {
                // Ignore errors.
            }
            if (contentDocument && contentDocument.defaultView) {
                contentWindow = contentDocument.defaultView;
            }
            else if (element.window) {
                contentWindow = element.window;
            }
            else if (element.getWindow) {
                contentWindow = element.getWindow();
            }
        }
        return { window: contentWindow, document: contentDocument };
    };
    /**
     * Redefine the open method in the contentWindow of an element and the sub frames.
     * Please notice that the element should be an iframe, embed or similar.
     *
     * @param {any} element Element to treat (iframe, embed, ...).
     * @param {Window} contentWindow The window of the element contents.
     * @param {Document} contentDocument The document of the element contents.
     */
    CoreIframeUtilsProvider.prototype.redefineWindowOpen = function (element, contentWindow, contentDocument) {
        var _this = this;
        if (contentWindow) {
            // Intercept window.open.
            contentWindow.open = function (url, target) {
                var scheme = _this.urlUtils.getUrlScheme(url);
                if (!scheme) {
                    // It's a relative URL, use the frame src to create the full URL.
                    var src = element.src || element.data;
                    if (src) {
                        var dirAndFile = _this.fileProvider.getFileAndDirectoryFromPath(src);
                        if (dirAndFile.directory) {
                            url = _this.textUtils.concatenatePaths(dirAndFile.directory, url);
                        }
                        else {
                            _this.logger.warn('Cannot get iframe dir path to open relative url', url, element);
                            return null;
                        }
                    }
                    else {
                        _this.logger.warn('Cannot get iframe src to open relative url', url, element);
                        return null;
                    }
                }
                if (target == '_self') {
                    // Link should be loaded in the same frame.
                    if (element.tagName.toLowerCase() == 'object') {
                        element.setAttribute('data', url);
                    }
                    else {
                        element.setAttribute('src', url);
                    }
                }
                else if (url.indexOf('cdvfile://') === 0 || url.indexOf('file://') === 0) {
                    // It's a local file.
                    _this.utils.openFile(url).catch(function (error) {
                        _this.domUtils.showErrorModal(error);
                    });
                }
                else {
                    // It's an external link, we will open with browser. Check if we need to auto-login.
                    if (!_this.sitesProvider.isLoggedIn()) {
                        // Not logged in, cannot auto-login.
                        _this.utils.openInBrowser(url);
                    }
                    else {
                        _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(url);
                    }
                }
                // We cannot create new Window objects directly, return null which is a valid return value for Window.open().
                return null;
            };
        }
        if (contentDocument) {
            // Search sub frames.
            CoreIframeUtilsProvider_1.FRAME_TAGS.forEach(function (tag) {
                var elements = Array.from(contentDocument.querySelectorAll(tag));
                elements.forEach(function (subElement) {
                    _this.treatFrame(subElement, true);
                });
            });
        }
    };
    /**
     * Intercept window.open in a frame and its subframes, shows an error modal instead.
     * Search links (<a>) and open them in browser or InAppBrowser if needed.
     *
     * @param {any} element Element to treat (iframe, embed, ...).
     * @param {boolean} [isSubframe] Whether it's a frame inside another frame.
     */
    CoreIframeUtilsProvider.prototype.treatFrame = function (element, isSubframe) {
        var _this = this;
        if (element) {
            this.checkOnlineFrameInOffline(element, isSubframe);
            var winAndDoc_1 = this.getContentWindowAndDocument(element);
            // Redefine window.open in this element and sub frames, it might have been loaded already.
            this.redefineWindowOpen(element, winAndDoc_1.window, winAndDoc_1.document);
            // Treat links.
            this.treatFrameLinks(element, winAndDoc_1.document);
            element.addEventListener('load', function () {
                _this.checkOnlineFrameInOffline(element, isSubframe);
                // Element loaded, redefine window.open and treat links again.
                winAndDoc_1 = _this.getContentWindowAndDocument(element);
                _this.redefineWindowOpen(element, winAndDoc_1.window, winAndDoc_1.document);
                _this.treatFrameLinks(element, winAndDoc_1.document);
                if (winAndDoc_1.window) {
                    // Send a resize events to the iframe so it calculates the right size if needed.
                    setTimeout(function () {
                        winAndDoc_1.window.dispatchEvent(new Event('resize'));
                    }, 1000);
                }
            });
        }
    };
    /**
     * Search links (<a>) in a frame and open them in browser or InAppBrowser if needed.
     * Only links that haven't been treated by the frame's Javascript will be treated.
     *
     * @param {any} element Element to treat (iframe, embed, ...).
     * @param {Document} contentDocument The document of the element contents.
     */
    CoreIframeUtilsProvider.prototype.treatFrameLinks = function (element, contentDocument) {
        var _this = this;
        if (!contentDocument) {
            return;
        }
        contentDocument.addEventListener('click', function (event) {
            if (event.defaultPrevented) {
                // Event already prevented by some other code.
                return;
            }
            // Find the link being clicked.
            var el = event.target;
            while (el && el.tagName !== 'A') {
                el = el.parentElement;
            }
            if (!el || el.tagName !== 'A') {
                return;
            }
            var link = el;
            var scheme = _this.urlUtils.getUrlScheme(link.href);
            if (!link.href || (scheme && scheme == 'javascript')) {
                // Links with no URL and Javascript links are ignored.
                return;
            }
            if (scheme && scheme != 'file' && scheme != 'filesystem') {
                // Scheme suggests it's an external resource.
                event.preventDefault();
                var frameSrc = element.src || element.data, frameScheme = _this.urlUtils.getUrlScheme(frameSrc);
                // If the frame is not local, check the target to identify how to treat the link.
                if (frameScheme && frameScheme != 'file' && frameScheme != 'filesystem' &&
                    (!link.target || link.target == '_self')) {
                    // Load the link inside the frame itself.
                    if (element.tagName.toLowerCase() == 'object') {
                        element.setAttribute('data', link.href);
                    }
                    else {
                        element.setAttribute('src', link.href);
                    }
                    return;
                }
                // The frame is local or the link needs to be opened in a new window. Open in browser.
                if (!_this.sitesProvider.isLoggedIn()) {
                    _this.utils.openInBrowser(link.href);
                }
                else {
                    _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(link.href);
                }
            }
            else if (link.target == '_parent' || link.target == '_top' || link.target == '_blank') {
                // Opening links with _parent, _top or _blank can break the app. We'll open it in InAppBrowser.
                event.preventDefault();
                _this.utils.openFile(link.href).catch(function (error) {
                    _this.domUtils.showErrorModal(error);
                });
            }
            else if (_this.platform.is('ios') && (!link.target || link.target == '_self')) {
                // In cordova ios 4.1.0 links inside iframes stopped working. We'll manually treat them.
                event.preventDefault();
                if (element.tagName.toLowerCase() == 'object') {
                    element.setAttribute('data', link.href);
                }
                else {
                    element.setAttribute('src', link.href);
                }
            }
        });
    };
    CoreIframeUtilsProvider.FRAME_TAGS = ['iframe', 'frame', 'object', 'embed'];
    CoreIframeUtilsProvider = CoreIframeUtilsProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_5__file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_7__sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_10__url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_11__utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_4__app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__ionic_native_network__["a" /* Network */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Config */],
            __WEBPACK_IMPORTED_MODULE_12__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], CoreIframeUtilsProvider);
    return CoreIframeUtilsProvider;
    var CoreIframeUtilsProvider_1;
}());

//# sourceMappingURL=iframe.js.map

/***/ }),
/* 347 */,
/* 348 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderDelegate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_delegate__ = __webpack_require__(62);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Delegate to register handlers to be shown in the file picker.
 */
var CoreFileUploaderDelegate = /** @class */ (function (_super) {
    __extends(CoreFileUploaderDelegate, _super);
    function CoreFileUploaderDelegate(loggerProvider, sitesProvider, eventsProvider) {
        var _this = _super.call(this, 'CoreFileUploaderDelegate', loggerProvider, sitesProvider, eventsProvider) || this;
        _this.sitesProvider = sitesProvider;
        _this.eventsProvider = eventsProvider;
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */].LOGOUT, _this.clearSiteHandlers.bind(_this));
        return _this;
    }
    /**
     * Clear current site handlers. Reserved for core use.
     */
    CoreFileUploaderDelegate.prototype.clearSiteHandlers = function () {
        this.enabledHandlers = {};
    };
    /**
     * Get the handlers for the current site.
     *
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {CoreFileUploaderHandlerDataToReturn[]} List of handlers data.
     */
    CoreFileUploaderDelegate.prototype.getHandlers = function (mimetypes) {
        var handlers = [];
        for (var name_1 in this.enabledHandlers) {
            var handler = this.enabledHandlers[name_1];
            var supportedMimetypes = void 0;
            if (mimetypes) {
                if (!handler.getSupportedMimetypes) {
                    // Handler doesn't implement a required function, don't add it.
                    continue;
                }
                supportedMimetypes = handler.getSupportedMimetypes(mimetypes);
                if (!supportedMimetypes.length) {
                    // Handler doesn't support any mimetype, don't add it.
                    continue;
                }
            }
            var data = handler.getData();
            data.priority = handler.priority;
            data.mimetypes = supportedMimetypes;
            handlers.push(data);
        }
        return handlers;
    };
    CoreFileUploaderDelegate = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreFileUploaderDelegate);
    return CoreFileUploaderDelegate;
}(__WEBPACK_IMPORTED_MODULE_4__classes_delegate__["a" /* CoreDelegate */]));

//# sourceMappingURL=delegate.js.map

/***/ }),
/* 349 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Service to handle offline user preferences.
 */
var CoreUserOfflineProvider = /** @class */ (function () {
    function CoreUserOfflineProvider(sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.siteSchema = {
            name: 'CoreUserOfflineProvider',
            version: 1,
            tables: [
                {
                    name: CoreUserOfflineProvider_1.PREFERENCES_TABLE,
                    columns: [
                        {
                            name: 'name',
                            type: 'TEXT',
                            unique: true,
                            notNull: true
                        },
                        {
                            name: 'value',
                            type: 'TEXT'
                        },
                        {
                            name: 'onlinevalue',
                            type: 'TEXT'
                        },
                    ]
                }
            ]
        };
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    CoreUserOfflineProvider_1 = CoreUserOfflineProvider;
    /**
     * Get preferences that were changed offline.
     *
     * @return {Promise<CoreUserOfflinePreference[]>} Promise resolved with list of preferences.
     */
    CoreUserOfflineProvider.prototype.getChangedPreferences = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecordsSelect(CoreUserOfflineProvider_1.PREFERENCES_TABLE, 'value != onlineValue');
        });
    };
    /**
     * Get an offline preference.
     *
     * @param {string} name Name of the preference.
     * @return {Promise<CoreUserOfflinePreference>} Promise resolved with the preference, rejected if not found.
     */
    CoreUserOfflineProvider.prototype.getPreference = function (name, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var conditions = { name: name };
            return site.getDb().getRecord(CoreUserOfflineProvider_1.PREFERENCES_TABLE, conditions);
        });
    };
    /**
     * Set an offline preference.
     *
     * @param {string} name Name of the preference.
     * @param {string} value Value of the preference.
     * @param {string} onlineValue Online value of the preference. If unedfined, preserve previously stored value.
     * @return {Promise<CoreUserPreference>} Promise resolved when done.
     */
    CoreUserOfflineProvider.prototype.setPreference = function (name, value, onlineValue, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promise;
            if (typeof onlineValue == 'undefined') {
                promise = _this.getPreference(name, site.id).then(function (preference) { return preference.onlinevalue; });
            }
            else {
                promise = Promise.resolve(onlineValue);
            }
            return promise.then(function (onlineValue) {
                var record = { name: name, value: value, onlinevalue: onlineValue };
                return site.getDb().insertRecord(CoreUserOfflineProvider_1.PREFERENCES_TABLE, record);
            });
        });
    };
    // Variables for database.
    CoreUserOfflineProvider.PREFERENCES_TABLE = 'user_preferences';
    CoreUserOfflineProvider = CoreUserOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreUserOfflineProvider);
    return CoreUserOfflineProvider;
    var CoreUserOfflineProvider_1;
}());

//# sourceMappingURL=offline.js.map

/***/ }),
/* 350 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_format_delegate__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_dynamic_component_dynamic_component__ = __webpack_require__(162);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Component to display course contents using a certain format. If the format isn't found, use default one.
 *
 * The inputs of this component will be shared with the course format components. Please use CoreCourseFormatDelegate
 * to register your handler for course formats.
 *
 * Example usage:
 *
 * <core-course-format [course]="course" [sections]="sections" (completionChanged)="onCompletionChange()"></core-course-format>
 */
var CoreCourseFormatComponent = /** @class */ (function () {
    function CoreCourseFormatComponent(cfDelegate, translate, injector, courseHelper, domUtils, eventsProvider, sitesProvider, content, prefetchDelegate, modalCtrl, event) {
        var _this = this;
        this.cfDelegate = cfDelegate;
        this.injector = injector;
        this.courseHelper = courseHelper;
        this.domUtils = domUtils;
        this.sitesProvider = sitesProvider;
        this.content = content;
        this.modalCtrl = modalCtrl;
        this.event = event;
        this.canLoadMore = false;
        this.showSectionId = 0;
        this.sectionSelectorExpanded = false;
        // Data to pass to the components.
        this.data = {};
        this.allSectionsId = __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID;
        this.stealthModulesSectionId = __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__["a" /* CoreCourseProvider */].STEALTH_MODULES_SECTION_ID;
        this.selectOptions = {};
        this.selectOptions.title = translate.instant('core.course.sections');
        this.completionChanged = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        // Pass this instance to all components so they can use its methods and properties.
        this.data.coreCourseFormatComponent = this;
        // Listen for section status changes.
        this.sectionStatusObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SECTION_STATUS_CHANGED, function (data) {
            if (_this.downloadEnabled && _this.sections && _this.sections.length && _this.course && data.sectionId &&
                data.courseId == _this.course.id) {
                // Check if the affected section is being downloaded.
                // If so, we don't update section status because it'll already be updated when the download finishes.
                var downloadId_1 = _this.courseHelper.getSectionDownloadId({ id: data.sectionId });
                if (prefetchDelegate.isBeingDownloaded(downloadId_1)) {
                    return;
                }
                // Get the affected section.
                var section_1;
                for (var i = 0; i < _this.sections.length; i++) {
                    var s = _this.sections[i];
                    if (s.id === data.sectionId) {
                        section_1 = s;
                        break;
                    }
                }
                if (!section_1) {
                    // Section not found, stop.
                    return;
                }
                // Recalculate the status.
                _this.courseHelper.calculateSectionStatus(section_1, _this.course.id, false).then(function () {
                    if (section_1.isDownloading && !prefetchDelegate.isBeingDownloaded(downloadId_1)) {
                        // All the modules are now downloading, set a download all promise.
                        _this.prefetch(section_1);
                    }
                });
            }
        }, this.sitesProvider.getCurrentSiteId());
    }
    CoreCourseFormatComponent_1 = CoreCourseFormatComponent;
    /**
     * Component being initialized.
     */
    CoreCourseFormatComponent.prototype.ngOnInit = function () {
        this.displaySectionSelector = this.cfDelegate.displaySectionSelector(this.course);
    };
    /**
     * Detect changes on input properties.
     */
    CoreCourseFormatComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        this.setInputData();
        if (changes.course) {
            // Course has changed, try to get the components.
            this.getComponents();
        }
        if (changes.sections && this.sections) {
            if (!this.selectedSection) {
                // There is no selected section yet, calculate which one to load.
                if (this.initialSectionId || this.initialSectionNumber) {
                    // We have an input indicating the section ID to load. Search the section.
                    for (var i = 0; i < this.sections.length; i++) {
                        var section = this.sections[i];
                        if ((section.id && section.id == this.initialSectionId) ||
                            (section.section && section.section == this.initialSectionNumber)) {
                            // Don't load the section if it cannot be viewed by the user.
                            if (this.canViewSection(section)) {
                                this.loaded = true;
                                this.sectionChanged(section);
                            }
                            break;
                        }
                    }
                }
                if (!this.loaded) {
                    // No section specified, not found or not visible, get current section.
                    this.cfDelegate.getCurrentSection(this.course, this.sections).then(function (section) {
                        _this.loaded = true;
                        _this.sectionChanged(section);
                    });
                }
            }
            else {
                // We have a selected section, but the list has changed. Search the section in the list.
                var newSection = void 0;
                for (var i = 0; i < this.sections.length; i++) {
                    var section = this.sections[i];
                    if (this.compareSections(section, this.selectedSection)) {
                        newSection = section;
                        break;
                    }
                }
                if (!newSection) {
                    // Section not found, calculate which one to use.
                    this.cfDelegate.getCurrentSection(this.course, this.sections).then(function (section) {
                        _this.sectionChanged(section);
                    });
                }
                else {
                    this.sectionChanged(newSection);
                }
            }
        }
        if (this.downloadEnabled && (changes.downloadEnabled || changes.sections)) {
            this.calculateSectionsStatus(false);
        }
    };
    /**
     * Set the input data for components.
     */
    CoreCourseFormatComponent.prototype.setInputData = function () {
        this.data.course = this.course;
        this.data.sections = this.sections;
        this.data.initialSectionId = this.initialSectionId;
        this.data.initialSectionNumber = this.initialSectionNumber;
        this.data.downloadEnabled = this.downloadEnabled;
        this.data.moduleId = this.moduleId;
        this.data.completionChanged = this.completionChanged;
    };
    /**
     * Get the components classes.
     */
    CoreCourseFormatComponent.prototype.getComponents = function () {
        var _this = this;
        if (this.course && this.course.format != this.lastCourseFormat) {
            this.lastCourseFormat = this.course.format;
            // Format has changed or it's the first time, load all the components.
            this.cfDelegate.getCourseFormatComponent(this.injector, this.course).then(function (component) {
                _this.courseFormatComponent = component;
            });
            this.cfDelegate.getCourseSummaryComponent(this.injector, this.course).then(function (component) {
                _this.courseSummaryComponent = component;
            });
            this.cfDelegate.getSectionSelectorComponent(this.injector, this.course).then(function (component) {
                _this.sectionSelectorComponent = component;
            });
            this.cfDelegate.getSingleSectionComponent(this.injector, this.course).then(function (component) {
                _this.singleSectionComponent = component;
            });
            this.cfDelegate.getAllSectionsComponent(this.injector, this.course).then(function (component) {
                _this.allSectionsComponent = component;
            });
        }
    };
    /**
     * Display the section selector modal.
     *
     * @param {MouseEvent} event Event.
     */
    CoreCourseFormatComponent.prototype.showSectionSelector = function (event) {
        var _this = this;
        if (!this.sectionSelectorExpanded) {
            this.sections.forEach(function (element) {
                element.isShowExpands = true;
            });
            var modal = this.modalCtrl.create('CoreCourseSectionSelectorPage', { course: this.course, sections: this.sections, selected: this.selectedSection });
            modal.onDidDismiss(function (newSection) {
                if (newSection) {
                    _this.sectionChanged(newSection);
                }
                _this.sectionSelectorExpanded = false;
            });
            modal.present({
                ev: event
            });
            this.sectionSelectorExpanded = true;
        }
    };
    /**
     * Function called when selected section changes.
     *
     * @param {any} newSection The new selected section.
     */
    CoreCourseFormatComponent.prototype.sectionChanged = function (newSection) {
        var _this = this;
        var previousValue = this.selectedSection;
        this.selectedSection = newSection;
        this.data.section = this.selectedSection;
        if (newSection.id != this.allSectionsId) {
            // Select next and previous sections to show the arrows.
            var i = this.sections.findIndex(function (value, index) {
                return _this.compareSections(value, _this.selectedSection);
            });
            var j = void 0;
            for (j = i - 1; j >= 1; j--) {
                if (this.canViewSection(this.sections[j])) {
                    break;
                }
            }
            this.previousSection = j >= 1 ? this.sections[j] : null;
            for (j = i + 1; j < this.sections.length; j++) {
                if (this.canViewSection(this.sections[j])) {
                    break;
                }
            }
            this.nextSection = j < this.sections.length ? this.sections[j] : null;
        }
        else {
            this.previousSection = null;
            this.nextSection = null;
            this.canLoadMore = false;
            this.showSectionId = 0;
            this.showMoreActivities();
        }
        if (this.moduleId && typeof previousValue == 'undefined') {
            setTimeout(function () {
                _this.domUtils.scrollToElementBySelector(_this.content, '#core-course-module-' + _this.moduleId);
            }, 200);
        }
        else {
            this.domUtils.scrollToTop(this.content, 0);
        }
    };
    /**
     * Compare if two sections are equal.
     *
     * @param {any} s1 First section.
     * @param {any} s2 Second section.
     * @return {boolean} Whether they're equal.
     */
    CoreCourseFormatComponent.prototype.compareSections = function (s1, s2) {
        return s1 && s2 ? s1.id === s2.id : s1 === s2;
    };
    /**
     * Calculate the status of sections.
     *
     * @param {boolean} refresh If refresh or not.
     */
    CoreCourseFormatComponent.prototype.calculateSectionsStatus = function (refresh) {
        this.courseHelper.calculateSectionsStatus(this.sections, this.course.id, refresh).catch(function () {
            // Ignore errors (shouldn't happen).
        });
    };
    /**
     * Confirm and prefetch a section. If the section is "all sections", prefetch all the sections.
     *
     * @param {any} section Section to download.
     * @param {boolean} refresh Refresh clicked (not used).
     */
    CoreCourseFormatComponent.prototype.prefetch = function (section, refresh) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        section.isCalculating = true;
        this.courseHelper.confirmDownloadSizeSection(this.course.id, section, this.sections).then(function () {
            _this.prefetchSection(section, true);
        }, function (error) {
            // User cancelled or there was an error calculating the size.
            if (error) {
                _this.domUtils.showErrorModal(error);
            }
        }).finally(function () {
            section.isCalculating = false;
        });
    };
    /**
     * Prefetch a section.
     *
     * @param {any} section The section to download.
     * @param {boolean} [manual] Whether the prefetch was started manually or it was automatically started because all modules
     *                           are being downloaded.
     */
    CoreCourseFormatComponent.prototype.prefetchSection = function (section, manual) {
        var _this = this;
        this.courseHelper.prefetchSection(section, this.course.id, this.sections).catch(function (error) {
            // Don't show error message if it's an automatic download.
            if (!manual) {
                return;
            }
            _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingsection', true);
        });
    };
    /**
     * Refresh the data.
     *
     * @param {any} [refresher] Refresher.
     * @param {Function} [done] Function to call when done.
     * @param {boolean} [afterCompletionChange] Whether the refresh is due to a completion change.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseFormatComponent.prototype.doRefresh = function (refresher, done, afterCompletionChange) {
        var promises = [];
        this.dynamicComponents.forEach(function (component) {
            promises.push(Promise.resolve(component.callComponentFunction('doRefresh', [refresher, done, afterCompletionChange])));
        });
        return Promise.all(promises);
    };
    /**
     * Show more activities (only used when showing all the sections at the same time).
     *
     * @param {any} [infiniteComplete] Infinite scroll complete function. Only used from core-infinite-loading.
     */
    CoreCourseFormatComponent.prototype.showMoreActivities = function (infiniteComplete) {
        this.canLoadMore = false;
        var modulesLoaded = 0, i;
        for (i = this.showSectionId + 1; i < this.sections.length; i++) {
            if (this.sections[i].hasContent && this.sections[i].modules) {
                modulesLoaded += this.sections[i].modules.reduce(function (total, module) {
                    return module.visibleoncoursepage !== 0 ? total + 1 : total;
                }, 0);
                if (modulesLoaded >= CoreCourseFormatComponent_1.LOAD_MORE_ACTIVITIES) {
                    break;
                }
            }
        }
        this.showSectionId = i;
        this.canLoadMore = i < this.sections.length;
        if (this.canLoadMore) {
            // Check if any of the following sections have any content.
            var thereAreMore = false;
            for (i++; i < this.sections.length; i++) {
                if (this.sections[i].hasContent && this.sections[i].modules && this.sections[i].modules.length > 0) {
                    thereAreMore = true;
                    break;
                }
            }
            this.canLoadMore = thereAreMore;
        }
        infiniteComplete && infiniteComplete();
    };
    /**
     * Component destroyed.
     */
    CoreCourseFormatComponent.prototype.ngOnDestroy = function () {
        if (this.sectionStatusObserver) {
            this.sectionStatusObserver.off();
        }
    };
    /**
     * User entered the page that contains the component.
     */
    CoreCourseFormatComponent.prototype.ionViewDidEnter = function () {
        this.dynamicComponents.forEach(function (component) {
            component.callComponentFunction('ionViewDidEnter');
        });
    };
    /**
     * User left the page that contains the component.
     */
    CoreCourseFormatComponent.prototype.ionViewDidLeave = function () {
        this.dynamicComponents.forEach(function (component) {
            component.callComponentFunction('ionViewDidLeave');
        });
    };
    /**
     * Check whether a section can be viewed.
     *
     * @param {any} section The section to check.
     * @return {boolean} Whether the section can be viewed.
     */
    CoreCourseFormatComponent.prototype.canViewSection = function (section) {
        return section.uservisible !== false && !section.hiddenbynumsections &&
            section.id != __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__["a" /* CoreCourseProvider */].STEALTH_MODULES_SECTION_ID;
    };
    /**
     * The completion of any of the modules have changed.
     */
    CoreCourseFormatComponent.prototype.onCompletionChange = function (completionData) {
        if (completionData.hasOwnProperty('valueused') && !completionData.valueused) {
            // If the completion value is not used, the page won't be reloaded, so update the progress bar.
            var completionModules = []
                .concat.apply([], this.sections.filter(function (section) { return section.hasOwnProperty('modules'); })
                .map(function (section) { return section.modules; })).map(function (module) { return (module.completion > 0) ? 1 : module.completion; })
                .reduce(function (accumulator, currentValue) { return accumulator + currentValue; });
            var moduleProgressPercent = 100 / completionModules;
            // Use min/max here to avoid floating point rounding errors over/under-flowing the progress bar.
            if (completionData.state === __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__["a" /* CoreCourseProvider */].COMPLETION_COMPLETE) {
                this.course.progress = Math.min(100, this.course.progress + moduleProgressPercent);
            }
            else {
                this.course.progress = Math.max(0, this.course.progress - moduleProgressPercent);
            }
        }
        // Emit a new event for other components.
        this.completionChanged.emit(completionData);
    };
    CoreCourseFormatComponent.prototype.openExpends = function (f) {
        // f.isShowExpands=!f.isShowExpands;
        this.event.publish('openexpends', f);
    };
    CoreCourseFormatComponent.LOAD_MORE_ACTIVITIES = Number.MAX_SAFE_INTEGER; // How many activities should load each time showMoreActivities is called.
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseFormatComponent.prototype, "course", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreCourseFormatComponent.prototype, "sections", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreCourseFormatComponent.prototype, "downloadEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseFormatComponent.prototype, "initialSectionId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseFormatComponent.prototype, "initialSectionNumber", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseFormatComponent.prototype, "moduleId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCourseFormatComponent.prototype, "completionChanged", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChildren"])(__WEBPACK_IMPORTED_MODULE_10__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["QueryList"])
    ], CoreCourseFormatComponent.prototype, "dynamicComponents", void 0);
    CoreCourseFormatComponent = CoreCourseFormatComponent_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-course-format',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\format\core-course-format.html"*/'<!-- Buttons to add to the header. *ngIf is needed, otherwise the component is executed too soon and doesn\'t find the header. -->\n<core-navbar-buttons end *ngIf="loaded">\n    <core-context-menu>\n        <core-context-menu-item [hidden]="!displaySectionSelector || !sections || !sections.length" [priority]="500" [content]="\'core.course.sections\' | translate" (action)="showSectionSelector($event)" iconAction="menu"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Default course format. -->\n<core-dynamic-component  [component]="courseFormatComponent" [data]="data">\n    <core-loading [hideUntil]="loaded">\n        <!-- Section selector. -->\n        <core-dynamic-component hidden [component]="sectionSelectorComponent" [data]="data">\n            <div style="border-bottom: 6px #EDEDF1 solid;" text-wrap *ngIf="displaySectionSelector && sections && sections.length" padding class="clearfix" ion-row justify-content-between class="safe-padding-horizontal" [class.core-section-download]="downloadEnabled">\n                <button  float-start ion-button icon-start icon-end (click)="showSectionSelector($event)" color="light" class="core-button-select button-no-uppercase ouc-button" ion-col [attr.aria-label]="(\'core.course.sections\' | translate) + \': \' + (selectedSection && (selectedSection.formattedName || selectedSection.name))" aria-haspopup="true" [attr.aria-expanded]="sectionSelectorExpanded" aria-controls="core-course-section-selector" id="core-course-section-button">\n                    <core-icon hidden name="fa-folder"></core-icon>\n                    <span style="font-size: 18px;font-weight: 650;color: #000;" class="core-section-selector-text">{{selectedSection && (selectedSection.formattedName || selectedSection.name) || \'core.course.sections\' | translate }}</span>\n                    <ion-icon name="arrow-dropdown" ios="md-arrow-dropdown" style="color: #000;"></ion-icon>\n                </button>\n                <!-- Section download. -->\n                <ng-container *ngTemplateOutlet="sectionDownloadTemplate; context: {section: selectedSection}"></ng-container>\n            </div>\n        </core-dynamic-component>\n\n        <!-- Course summary. By default we only display the course progress. -->\n        <core-dynamic-component hidden [component]="courseSummaryComponent" [data]="data">\n            <ion-list no-lines *ngIf="course.imageThumb || (selectedSection && selectedSection.id == allSectionsId && course.progress != null && course.progress >= 0)" class="core-format-progress-list">\n                <div *ngIf="course.imageThumb" class="core-course-thumb">\n                    <img [src]="course.imageThumb" core-external-content alt=""/>\n                </div>\n                <ion-item class="core-course-progress" *ngIf="selectedSection && selectedSection.id == allSectionsId && course.progress != null && course.progress >= 0 && course.completionusertracked !== false">\n                    <core-progress-bar [progress]="course.progress"></core-progress-bar>\n                </ion-item>\n            </ion-list>\n        </core-dynamic-component>\n\n        <!-- Single section. -->\n        <div *ngIf="selectedSection && selectedSection.id != allSectionsId">\n            <core-dynamic-component [component]="singleSectionComponent" [data]="data">\n                <ng-container *ngTemplateOutlet="sectionTemplate; context: {section: selectedSection}"></ng-container>\n                <core-empty-box *ngIf="!selectedSection.hasContent" icon="qr-scanner" [message]="\'本页无内容，请点击下一页。\' | translate"></core-empty-box>\n            </core-dynamic-component>\n        </div>\n\n        <!-- Multiple sections. -->\n        <div *ngIf="selectedSection && selectedSection.id == allSectionsId">\n            <core-dynamic-component [component]="allSectionsComponent" [data]="data">\n                <ng-container *ngFor="let section of sections; index as i">\n                    <ng-container *ngIf="i <= showSectionId">\n                        <ng-container *ngTemplateOutlet="sectionTemplate; context: {section: section}"></ng-container>\n                    </ng-container>\n                </ng-container>\n            </core-dynamic-component>\n\n            <!-- <core-infinite-loading [enabled]="canLoadMore" (action)="showMoreActivities($event)"></core-infinite-loading> -->\n        </div>\n    </core-loading>\n    <ion-buttons padding end class="core-course-section-nav-buttons" *ngIf="displaySectionSelector && sections && sections.length">\n        <button *ngIf="previousSection" ion-button color="light" icon-only (click)="sectionChanged(previousSection)" title="{{ \'core.previous\' | translate }}">\n            <ion-icon name="arrow-back" md="ios-arrow-back"></ion-icon>\n            <core-format-text class="accesshide" [text]="previousSection.formattedName || previousSection.name"></core-format-text>\n        </button>\n        <button *ngIf="nextSection" ion-button icon-only (click)="sectionChanged(nextSection)" title="{{ \'core.next\' | translate }}">\n            <core-format-text class="accesshide" [text]="nextSection.formattedName || nextSection.name"></core-format-text>\n            <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n        </button>\n    </ion-buttons>\n\n</core-dynamic-component>\n\n<!-- Template to render a section. -->\n<ng-template #sectionTemplate let-section="section">\n    <div *ngIf="section.isShowExpands||section.isThemTitle">\n    <section ion-list *ngIf="!section.hiddenbynumsections && section.id != allSectionsId && section.id != stealthModulesSectionId">\n        <div *ngIf="section.isThemTitle" (click)="openExpends(section)">\n        <div style="width: 100%;background: #EDEDF1;height: 6px;opacity: 0.6;"></div>\n        <div  class="ouc-theme-title">\n            <div>{{section.name}}</div>\n       \n            <div> <ion-icon name="arrow-dropdown" ios="md-arrow-dropdown" style="color: #000;padding-right: 34px;"></ion-icon></div>\n        </div>\n        <div style="width: 100%;background: #EDEDF1;height: 6px;opacity: 0.6;"></div>\n         </div>\n        <!-- Title is only displayed when viewing all sections. -->\n        <div *ngIf="!section.isThemTitle" style="background: white;"> \n        <ion-item-divider style="background: white;padding-left: 34px;border-bottom: none;" text-wrap color="light" *ngIf="selectedSection.id == allSectionsId && section.name" [class.core-section-download]="downloadEnabled">\n            <core-format-text style="font-size: 16px;font-weight: 500;"  [text]="section.name"></core-format-text>\n            <!-- Section download. -->\n            <ng-container *ngTemplateOutlet="sectionDownloadTemplate; context: {section: section}"></ng-container>\n        </ion-item-divider>\n         </div>\n        <ion-item text-wrap *ngIf="section.summary">\n            <core-format-text [text]="section.summary"></core-format-text>\n        </ion-item>\n\n        <ng-container *ngFor="let module of section.modules">\n            <core-course-module *ngIf="module.visibleoncoursepage !== 0" [module]="module" [courseId]="course.id" [downloadEnabled]="downloadEnabled" [section]="section" (completionChanged)="onCompletionChange($event)"></core-course-module>\n        </ng-container>\n    </section>\n</div>\n</ng-template>\n\n<!-- Template to render a section download button/progress. -->\n<ng-template #sectionDownloadTemplate let-section="section">\n    <div *ngIf="section && downloadEnabled" class="core-button-spinner" float-end>\n        <!-- Download progress. -->\n        <ion-badge class="core-course-download-section-progress" *ngIf="section.isDownloading && section.total > 0 && section.count < section.total">{{section.count}} / {{section.total}}</ion-badge>\n\n        <core-download-refresh [status]="section.downloadStatus" [enabled]="downloadEnabled" [loading]="section.isDownloading || section.isCalculating" [canTrustDownload]="section.canCheckUpdates" (action)="prefetch(section, $event)"></core-download-refresh>\n    </div>\n</ng-template>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\format\core-course-format.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__core_course_providers_format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["i" /* Events */]])
    ], CoreCourseFormatComponent);
    return CoreCourseFormatComponent;
    var CoreCourseFormatComponent_1;
}());

//# sourceMappingURL=format.js.map

/***/ }),
/* 351 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseUnsupportedModuleComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_module_delegate__ = __webpack_require__(38);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component that displays info about an unsupported module.
 */
var CoreCourseUnsupportedModuleComponent = /** @class */ (function () {
    function CoreCourseUnsupportedModuleComponent(courseProvider, moduleDelegate) {
        this.courseProvider = courseProvider;
        this.moduleDelegate = moduleDelegate;
    }
    /**
     * Component being initialized.
     */
    CoreCourseUnsupportedModuleComponent.prototype.ngOnInit = function () {
        this.isDisabledInSite = this.moduleDelegate.isModuleDisabledInSite(this.module.modname);
        this.isSupportedByTheApp = this.moduleDelegate.hasHandler(this.module.modname);
        this.moduleName = this.courseProvider.translateModuleName(this.module.modname);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseUnsupportedModuleComponent.prototype, "course", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseUnsupportedModuleComponent.prototype, "module", void 0);
    CoreCourseUnsupportedModuleComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-course-unsupported-module',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\unsupported-module\core-course-unsupported-module.html"*/'<div padding>\n    <core-course-module-description [description]="module && module.description"></core-course-module-description>\n    <h2 *ngIf="!isDisabledInSite && isSupportedByTheApp">{{ \'core.whoops\' | translate }}</h2>\n    <h2 *ngIf="isDisabledInSite || !isSupportedByTheApp">{{ \'core.uhoh\' | translate }}</h2>\n\n    <p class="core-big" *ngIf="isDisabledInSite">{{ \'core.course.activitydisabled\' | translate }}</p>\n    <p class="core-big" *ngIf="!isDisabledInSite && isSupportedByTheApp">{{ \'core.course.activitynotyetviewablesiteupgradeneeded\' | translate }}</p>\n    <p class="core-big" *ngIf="!isDisabledInSite && !isSupportedByTheApp">{{ \'core.course.activitynotyetviewableremoteaddon\' | translate }}</p>\n    <p *ngIf="isDisabledInSite || !isSupportedByTheApp"><strong>{{ \'core.course.askadmintosupport\' | translate }}</strong></p>\n\n    <div *ngIf="module && module.url">\n        <p><strong>{{ \'core.course.useactivityonbrowser\' | translate }}</strong></p>\n        <a ion-button block icon-end [href]="module.url" core-link>\n            {{ \'core.openinbrowser\' | translate }}\n            <ion-icon name="open"></ion-icon>\n        </a>\n    </div>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\unsupported-module\core-course-unsupported-module.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_module_delegate__["a" /* CoreCourseModuleDelegate */]])
    ], CoreCourseUnsupportedModuleComponent);
    return CoreCourseUnsupportedModuleComponent;
}());

//# sourceMappingURL=unsupported-module.js.map

/***/ }),
/* 352 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__course_offline__ = __webpack_require__(253);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__log_helper__ = __webpack_require__(34);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Service to sync course offline data. This only syncs the offline data of the course itself, not the offline data of
 * the activities in the course.
 */
var CoreCourseSyncProvider = /** @class */ (function (_super) {
    __extends(CoreCourseSyncProvider, _super);
    function CoreCourseSyncProvider(sitesProvider, loggerProvider, appProvider, courseOffline, eventsProvider, courseProvider, translate, utils, textUtils, syncProvider, timeUtils, logHelper) {
        var _this = _super.call(this, 'CoreCourseSyncProvider', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.sitesProvider = sitesProvider;
        _this.appProvider = appProvider;
        _this.courseOffline = courseOffline;
        _this.eventsProvider = eventsProvider;
        _this.courseProvider = courseProvider;
        _this.utils = utils;
        _this.textUtils = textUtils;
        _this.logHelper = logHelper;
        return _this;
    }
    CoreCourseSyncProvider_1 = CoreCourseSyncProvider;
    /**
     * Try to synchronize all the courses in a certain site or in all sites.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    CoreCourseSyncProvider.prototype.syncAllCourses = function (siteId, force) {
        return this.syncOnSites('courses', this.syncAllCoursesFunc.bind(this), [force], siteId);
    };
    /**
     * Sync all courses on a site.
     *
     * @param {string} siteId Site ID to sync. If not defined, sync all sites.
     * @param {boolean} force Wether the execution is forced (manual sync).
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    CoreCourseSyncProvider.prototype.syncAllCoursesFunc = function (siteId, force) {
        var _this = this;
        var p1 = [];
        p1.push(this.logHelper.syncSite(siteId));
        p1.push(this.courseOffline.getAllManualCompletions(siteId).then(function (completions) {
            // Sync all courses.
            var p2 = completions.map(function (completion) {
                var promise = force ? _this.syncCourse(completion.courseid, siteId) :
                    _this.syncCourseIfNeeded(completion.courseid, siteId);
                return promise.then(function (result) {
                    if (result && result.updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(CoreCourseSyncProvider_1.AUTO_SYNCED, {
                            courseId: completion.courseid,
                            warnings: result.warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(p2);
        }));
        return Promise.all(p1);
    };
    /**
     * Sync a course if it's needed.
     *
     * @param {number} courseId Course ID to be synced.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the course is synced or it doesn't need to be synced.
     */
    CoreCourseSyncProvider.prototype.syncCourseIfNeeded = function (courseId, siteId) {
        // Usually we call isSyncNeeded to check if a certain time has passed.
        // However, since we barely send data for now just sync the course.
        return this.syncCourse(courseId, siteId);
    };
    /**
     * Synchronize a course.
     *
     * @param {number} courseId Course ID to be synced.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected otherwise.
     */
    CoreCourseSyncProvider.prototype.syncCourse = function (courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.isSyncing(courseId, siteId)) {
            // There's already a sync ongoing for this discussion, return the promise.
            return this.getOngoingSync(courseId, siteId);
        }
        this.logger.debug("Try to sync course '" + courseId + "'");
        var result = {
            warnings: [],
            updated: false
        };
        // Get offline responses to be sent.
        var syncPromise = this.courseOffline.getCourseManualCompletions(courseId, siteId).catch(function () {
            // No offline data found, return empty list.
            return [];
        }).then(function (completions) {
            if (!completions || !completions.length) {
                // Nothing to sync.
                return;
            }
            if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(null);
            }
            // Get the current completion status to check if any completion was modified in web.
            // This can be retrieved on core_course_get_contents since 3.6 but this is an easy way to get them.
            return _this.courseProvider.getActivitiesCompletionStatus(courseId, siteId, undefined, false, true, false)
                .then(function (onlineCompletions) {
                var promises = [];
                // Send all the completions.
                completions.forEach(function (entry) {
                    var onlineComp = onlineCompletions[entry.cmid];
                    // Check if the completion was modified in online. If so, discard it.
                    if (onlineComp && onlineComp.timecompleted * 1000 > entry.timecompleted) {
                        promises.push(_this.courseOffline.deleteManualCompletion(entry.cmid, siteId).then(function () {
                            // Completion deleted, add a warning if the completion status doesn't match.
                            if (onlineComp.state != entry.completed) {
                                result.warnings.push(_this.translate.instant('core.course.warningofflinemanualcompletiondeleted', {
                                    name: entry.coursename || courseId,
                                    error: _this.translate.instant('core.course.warningmanualcompletionmodified')
                                }));
                            }
                        }));
                        return;
                    }
                    promises.push(_this.courseProvider.markCompletedManuallyOnline(entry.cmid, entry.completed, siteId).then(function () {
                        result.updated = true;
                        return _this.courseOffline.deleteManualCompletion(entry.cmid, siteId);
                    }).catch(function (error) {
                        if (_this.utils.isWebServiceError(error)) {
                            // The WebService has thrown an error, this means that the completion cannot be submitted. Delete it.
                            result.updated = true;
                            return _this.courseOffline.deleteManualCompletion(entry.cmid, siteId).then(function () {
                                // Completion deleted, add a warning.
                                result.warnings.push(_this.translate.instant('core.course.warningofflinemanualcompletiondeleted', {
                                    name: entry.coursename || courseId,
                                    error: _this.textUtils.getErrorMessageFromError(error)
                                }));
                            });
                        }
                        // Couldn't connect to server, reject.
                        return Promise.reject(error);
                    }));
                });
                return Promise.all(promises);
            });
        }).then(function () {
            if (result.updated) {
                // Update data.
                return _this.courseProvider.invalidateSections(courseId, siteId).then(function () {
                    if (_this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.6')) {
                        return _this.courseProvider.getSections(courseId, false, true, undefined, siteId);
                    }
                    else {
                        return _this.courseProvider.getActivitiesCompletionStatus(courseId, siteId);
                    }
                }).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            // Sync finished, set sync time.
            return _this.setSyncTime(courseId, siteId);
        }).then(function () {
            // All done, return the data.
            return result;
        });
        return this.addOngoingSync(courseId, syncPromise, siteId);
    };
    CoreCourseSyncProvider.AUTO_SYNCED = 'core_course_autom_synced';
    CoreCourseSyncProvider = CoreCourseSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_11__course_offline__["a" /* CoreCourseOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_12__course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_13__log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], CoreCourseSyncProvider);
    return CoreCourseSyncProvider;
    var CoreCourseSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_2__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 353 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCompileProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser_dynamic__ = __webpack_require__(287);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__app_app_module__ = __webpack_require__(463);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_block_block_module__ = __webpack_require__(775);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_contentlinks_contentlinks_module__ = __webpack_require__(777);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_course_module__ = __webpack_require__(778);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_courses_courses_module__ = __webpack_require__(780);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_fileuploader_fileuploader_module__ = __webpack_require__(782);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_grades_grades_module__ = __webpack_require__(783);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_login_login_module__ = __webpack_require__(785);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_mainmenu_mainmenu_module__ = __webpack_require__(786);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_question_question_module__ = __webpack_require__(787);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_sharedfiles_sharedfiles_module__ = __webpack_require__(792);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_sitehome_sitehome_module__ = __webpack_require__(793);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__core_user_user_module__ = __webpack_require__(794);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__core_pushnotifications_pushnotifications_module__ = __webpack_require__(797);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__core_emulator_emulator_module__ = __webpack_require__(798);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__core_siteplugins_providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__angular_platform_browser__ = __webpack_require__(83);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__angular_common_http__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_27_moment__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_28_ts_md5_dist_md5__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__classes_cache__ = __webpack_require__(759);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__classes_delegate__ = __webpack_require__(62);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__core_contentlinks_classes_module_grade_handler__ = __webpack_require__(266);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__core_course_classes_resource_prefetch_handler__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__core_course_directives_directives_module__ = __webpack_require__(1521);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__core_courses_components_components_module__ = __webpack_require__(182);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__core_siteplugins_directives_directives_module__ = __webpack_require__(1525);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_44__core_sitehome_components_components_module__ = __webpack_require__(983);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_45__core_user_components_components_module__ = __webpack_require__(415);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_46__core_question_components_components_module__ = __webpack_require__(985);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_47__core_block_components_components_module__ = __webpack_require__(429);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_48__core_course_components_unsupported_module_unsupported_module__ = __webpack_require__(351);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_49__core_course_formats_singleactivity_components_singleactivity__ = __webpack_require__(354);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_50__core_siteplugins_components_module_index_module_index__ = __webpack_require__(285);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_51__core_siteplugins_components_block_block__ = __webpack_require__(360);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_52__core_siteplugins_components_course_option_course_option__ = __webpack_require__(361);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_53__core_siteplugins_components_course_format_course_format__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_54__core_siteplugins_components_question_question__ = __webpack_require__(363);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_55__core_siteplugins_components_question_behaviour_question_behaviour__ = __webpack_require__(364);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_56__core_siteplugins_components_user_profile_field_user_profile_field__ = __webpack_require__(365);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_57__core_siteplugins_components_quiz_access_rule_quiz_access_rule__ = __webpack_require__(366);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_58__core_siteplugins_components_assign_feedback_assign_feedback__ = __webpack_require__(367);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_59__core_siteplugins_components_assign_submission_assign_submission__ = __webpack_require__(368);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_60__addon_badges_badges_module__ = __webpack_require__(824);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_61__addon_calendar_calendar_module__ = __webpack_require__(825);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_62__addon_competency_competency_module__ = __webpack_require__(826);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_63__addon_files_files_module__ = __webpack_require__(827);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_64__addon_messageoutput_messageoutput_module__ = __webpack_require__(828);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_65__addon_messages_messages_module__ = __webpack_require__(829);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_66__addon_mod_assign_assign_module__ = __webpack_require__(832);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_67__addon_mod_book_book_module__ = __webpack_require__(841);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_68__addon_mod_chat_chat_module__ = __webpack_require__(842);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_69__addon_mod_choice_choice_module__ = __webpack_require__(843);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_70__addon_mod_feedback_feedback_module__ = __webpack_require__(844);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_71__addon_mod_folder_folder_module__ = __webpack_require__(846);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_72__addon_mod_forum_forum_module__ = __webpack_require__(848);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_73__addon_mod_glossary_glossary_module__ = __webpack_require__(850);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_74__addon_mod_imscp_imscp_module__ = __webpack_require__(853);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_75__addon_mod_lesson_lesson_module__ = __webpack_require__(856);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_76__addon_mod_lti_lti_module__ = __webpack_require__(857);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_77__addon_mod_page_page_module__ = __webpack_require__(858);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_78__addon_mod_quiz_quiz_module__ = __webpack_require__(860);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_79__addon_mod_resource_resource_module__ = __webpack_require__(864);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_80__addon_mod_scorm_scorm_module__ = __webpack_require__(866);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_81__addon_mod_survey_survey_module__ = __webpack_require__(867);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_82__addon_mod_url_url_module__ = __webpack_require__(869);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_83__addon_mod_wiki_wiki_module__ = __webpack_require__(870);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_84__addon_mod_workshop_workshop_module__ = __webpack_require__(872);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_85__addon_notes_notes_module__ = __webpack_require__(877);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_86__addon_notifications_notifications_module__ = __webpack_require__(879);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_87__addon_remotethemes_remotethemes_module__ = __webpack_require__(880);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_88__addon_mod_assign_components_components_module__ = __webpack_require__(976);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_89__addon_mod_workshop_components_components_module__ = __webpack_require__(416);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





// Import core providers.















// Import only this provider to prevent circular dependencies.

// Import other libraries and providers.








// Import core classes that can be useful for site plugins.








// Import all core modules that define components, directives and pipes.











// Import some components listed in entryComponents so they can be injected dynamically.












// Import addon providers. Do not import database module because it causes circular dependencies.




























// Import some addon modules that define components, directives and pipes. Only import the important ones.


/**
 * Service to provide functionalities regarding compiling dynamic HTML and Javascript.
 */
var CoreCompileProvider = /** @class */ (function () {
    function CoreCompileProvider(injector, logger, compilerFactory) {
        this.injector = injector;
        // Other Ionic/Angular providers that don't depend on where they are injected.
        this.OTHER_PROVIDERS = [
            __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_23__angular_http__["b" /* Http */], __WEBPACK_IMPORTED_MODULE_24__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_21__angular_platform_browser__["c" /* DomSanitizer */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["a" /* ActionSheetController */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["b" /* AlertController */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["o" /* LoadingController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["x" /* PopoverController */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["E" /* ToastController */], __WEBPACK_IMPORTED_MODULE_22__angular_forms__["a" /* FormBuilder */]
        ];
        // List of imports for dynamic module. Since the template can have any component we need to import all core components modules.
        this.IMPORTS = [
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(), __WEBPACK_IMPORTED_MODULE_37__components_components_module__["a" /* CoreComponentsModule */], __WEBPACK_IMPORTED_MODULE_38__directives_directives_module__["a" /* CoreDirectivesModule */], __WEBPACK_IMPORTED_MODULE_39__pipes_pipes_module__["a" /* CorePipesModule */],
            __WEBPACK_IMPORTED_MODULE_40__core_course_components_components_module__["a" /* CoreCourseComponentsModule */], __WEBPACK_IMPORTED_MODULE_42__core_courses_components_components_module__["a" /* CoreCoursesComponentsModule */], __WEBPACK_IMPORTED_MODULE_44__core_sitehome_components_components_module__["a" /* CoreSiteHomeComponentsModule */], __WEBPACK_IMPORTED_MODULE_45__core_user_components_components_module__["a" /* CoreUserComponentsModule */],
            __WEBPACK_IMPORTED_MODULE_41__core_course_directives_directives_module__["a" /* CoreCourseDirectivesModule */], __WEBPACK_IMPORTED_MODULE_43__core_siteplugins_directives_directives_module__["a" /* CoreSitePluginsDirectivesModule */], __WEBPACK_IMPORTED_MODULE_46__core_question_components_components_module__["a" /* CoreQuestionComponentsModule */], __WEBPACK_IMPORTED_MODULE_88__addon_mod_assign_components_components_module__["a" /* AddonModAssignComponentsModule */],
            __WEBPACK_IMPORTED_MODULE_89__addon_mod_workshop_components_components_module__["a" /* AddonModWorkshopComponentsModule */], __WEBPACK_IMPORTED_MODULE_47__core_block_components_components_module__["a" /* CoreBlockComponentsModule */]
        ];
        this.logger = logger.getInstance('CoreCompileProvider');
        this.compiler = compilerFactory.createCompiler();
    }
    /**
     * Create and compile a dynamic component.
     *
     * @param {string} template The template of the component.
     * @param {any} componentClass The JS class of the component.
     * @param {any[]} [extraImports] Extra imported modules if needed and not imported by this class.
     * @return {Promise<ComponentFactory<any>>} Promise resolved with the factory to instantiate the component.
     */
    CoreCompileProvider.prototype.createAndCompileComponent = function (template, componentClass, extraImports) {
        if (extraImports === void 0) { extraImports = []; }
        // Create the component using the template and the class.
        var component = Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            template: template
        })(componentClass);
        var imports = this.IMPORTS.concat(extraImports);
        // Now create the module containing the component.
        var module = Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({ imports: imports, declarations: [component] })(/** @class */ (function () {
            function class_1() {
            }
            return class_1;
        }()));
        try {
            // Compile the module and the component.
            return this.compiler.compileModuleAndAllComponentsAsync(module).then(function (factories) {
                // Search and return the factory of the component we just created.
                for (var i in factories.componentFactories) {
                    var factory = factories.componentFactories[i];
                    if (factory.componentType == component) {
                        return factory;
                    }
                }
            });
        }
        catch (ex) {
            return Promise.reject({ message: 'Template has some errors and cannot be displayed.', debuginfo: ex });
        }
    };
    /**
     * Eval some javascript using the context of the function.
     *
     * @param {string} javascript The javascript to eval.
     * @return {any} Result of the eval.
     */
    CoreCompileProvider.prototype.evalInContext = function (javascript) {
        // tslint:disable: no-eval
        return eval(javascript);
    };
    /**
     * Execute some javascript code, using a certain instance as the context.
     *
     * @param {any} instance Instance to use as the context. In the JS code, "this" will be this instance.
     * @param {string} javascript The javascript code to eval.
     * @return {any} Result of the javascript execution.
     */
    CoreCompileProvider.prototype.executeJavascript = function (instance, javascript) {
        try {
            return this.evalInContext.call(instance, javascript);
        }
        catch (ex) {
            this.logger.error('Error evaluating javascript', ex);
        }
    };
    /**
     * Inject all the core libraries in a certain object.
     *
     * @param {any} instance The instance where to inject the libraries.
     * @param {any[]} [extraProviders] Extra imported providers if needed and not imported by this class.
     */
    CoreCompileProvider.prototype.injectLibraries = function (instance, extraProviders) {
        if (extraProviders === void 0) { extraProviders = []; }
        var providers = __WEBPACK_IMPORTED_MODULE_5__app_app_module__["b" /* CORE_PROVIDERS */].concat(__WEBPACK_IMPORTED_MODULE_7__core_contentlinks_contentlinks_module__["a" /* CORE_CONTENTLINKS_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_8__core_course_course_module__["a" /* CORE_COURSE_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_9__core_courses_courses_module__["a" /* CORE_COURSES_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_10__core_fileuploader_fileuploader_module__["a" /* CORE_FILEUPLOADER_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_11__core_grades_grades_module__["a" /* CORE_GRADES_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_12__core_login_login_module__["a" /* CORE_LOGIN_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_13__core_mainmenu_mainmenu_module__["a" /* CORE_MAINMENU_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_15__core_sharedfiles_sharedfiles_module__["a" /* CORE_SHAREDFILES_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_16__core_sitehome_sitehome_module__["a" /* CORE_SITEHOME_PROVIDERS */]).concat([__WEBPACK_IMPORTED_MODULE_20__core_siteplugins_providers_siteplugins__["a" /* CoreSitePluginsProvider */]]).concat(__WEBPACK_IMPORTED_MODULE_17__core_user_user_module__["a" /* CORE_USER_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_14__core_question_question_module__["a" /* CORE_QUESTION_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_19__core_emulator_emulator_module__["b" /* IONIC_NATIVE_PROVIDERS */]).concat(this.OTHER_PROVIDERS).concat(extraProviders)
            .concat(__WEBPACK_IMPORTED_MODULE_60__addon_badges_badges_module__["a" /* ADDON_BADGES_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_61__addon_calendar_calendar_module__["a" /* ADDON_CALENDAR_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_62__addon_competency_competency_module__["a" /* ADDON_COMPETENCY_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_63__addon_files_files_module__["a" /* ADDON_FILES_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_64__addon_messageoutput_messageoutput_module__["a" /* ADDON_MESSAGEOUTPUT_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_65__addon_messages_messages_module__["a" /* ADDON_MESSAGES_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_66__addon_mod_assign_assign_module__["a" /* ADDON_MOD_ASSIGN_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_67__addon_mod_book_book_module__["a" /* ADDON_MOD_BOOK_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_68__addon_mod_chat_chat_module__["a" /* ADDON_MOD_CHAT_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_69__addon_mod_choice_choice_module__["a" /* ADDON_MOD_CHOICE_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_70__addon_mod_feedback_feedback_module__["a" /* ADDON_MOD_FEEDBACK_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_71__addon_mod_folder_folder_module__["a" /* ADDON_MOD_FOLDER_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_72__addon_mod_forum_forum_module__["a" /* ADDON_MOD_FORUM_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_73__addon_mod_glossary_glossary_module__["a" /* ADDON_MOD_GLOSSARY_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_74__addon_mod_imscp_imscp_module__["a" /* ADDON_MOD_IMSCP_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_75__addon_mod_lesson_lesson_module__["a" /* ADDON_MOD_LESSON_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_76__addon_mod_lti_lti_module__["a" /* ADDON_MOD_LTI_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_77__addon_mod_page_page_module__["a" /* ADDON_MOD_PAGE_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_78__addon_mod_quiz_quiz_module__["a" /* ADDON_MOD_QUIZ_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_79__addon_mod_resource_resource_module__["a" /* ADDON_MOD_RESOURCE_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_80__addon_mod_scorm_scorm_module__["a" /* ADDON_MOD_SCORM_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_81__addon_mod_survey_survey_module__["a" /* ADDON_MOD_SURVEY_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_82__addon_mod_url_url_module__["a" /* ADDON_MOD_URL_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_83__addon_mod_wiki_wiki_module__["a" /* ADDON_MOD_WIKI_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_84__addon_mod_workshop_workshop_module__["a" /* ADDON_MOD_WORKSHOP_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_85__addon_notes_notes_module__["a" /* ADDON_NOTES_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_86__addon_notifications_notifications_module__["a" /* ADDON_NOTIFICATIONS_PROVIDERS */])
            .concat(__WEBPACK_IMPORTED_MODULE_18__core_pushnotifications_pushnotifications_module__["a" /* CORE_PUSHNOTIFICATIONS_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_87__addon_remotethemes_remotethemes_module__["a" /* ADDON_REMOTETHEMES_PROVIDERS */]).concat(__WEBPACK_IMPORTED_MODULE_6__core_block_block_module__["a" /* CORE_BLOCK_PROVIDERS */]);
        // We cannot inject anything to this constructor. Use the Injector to inject all the providers into the instance.
        for (var i in providers) {
            var providerDef = providers[i];
            if (typeof providerDef == 'function' && providerDef.name) {
                try {
                    // Inject the provider to the instance. We use the class name as the property name.
                    instance[providerDef.name] = this.injector.get(providerDef);
                }
                catch (ex) {
                    this.logger.warn('Error injecting provider', providerDef.name, ex);
                }
            }
        }
        // Inject current service.
        instance['CoreCompileProvider'] = this;
        // Add some final classes.
        instance['injector'] = this.injector;
        instance['Validators'] = __WEBPACK_IMPORTED_MODULE_22__angular_forms__["h" /* Validators */];
        instance['CoreConfigConstants'] = __WEBPACK_IMPORTED_MODULE_25__configconstants__["a" /* CoreConfigConstants */];
        instance['CoreConstants'] = __WEBPACK_IMPORTED_MODULE_26__core_constants__["a" /* CoreConstants */];
        instance['moment'] = __WEBPACK_IMPORTED_MODULE_27_moment__;
        instance['Md5'] = __WEBPACK_IMPORTED_MODULE_28_ts_md5_dist_md5__["Md5"];
        instance['CoreSyncBaseProvider'] = __WEBPACK_IMPORTED_MODULE_29__classes_base_sync__["a" /* CoreSyncBaseProvider */];
        instance['CoreCache'] = __WEBPACK_IMPORTED_MODULE_30__classes_cache__["a" /* CoreCache */];
        instance['CoreDelegate'] = __WEBPACK_IMPORTED_MODULE_31__classes_delegate__["a" /* CoreDelegate */];
        instance['CoreContentLinksHandlerBase'] = __WEBPACK_IMPORTED_MODULE_32__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */];
        instance['CoreContentLinksModuleGradeHandler'] = __WEBPACK_IMPORTED_MODULE_33__core_contentlinks_classes_module_grade_handler__["a" /* CoreContentLinksModuleGradeHandler */];
        instance['CoreContentLinksModuleIndexHandler'] = __WEBPACK_IMPORTED_MODULE_34__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */];
        instance['CoreCourseActivityPrefetchHandlerBase'] = __WEBPACK_IMPORTED_MODULE_35__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */];
        instance['CoreCourseResourcePrefetchHandlerBase'] = __WEBPACK_IMPORTED_MODULE_36__core_course_classes_resource_prefetch_handler__["a" /* CoreCourseResourcePrefetchHandlerBase */];
        instance['CoreCourseUnsupportedModuleComponent'] = __WEBPACK_IMPORTED_MODULE_48__core_course_components_unsupported_module_unsupported_module__["a" /* CoreCourseUnsupportedModuleComponent */];
        instance['CoreCourseFormatSingleActivityComponent'] = __WEBPACK_IMPORTED_MODULE_49__core_course_formats_singleactivity_components_singleactivity__["a" /* CoreCourseFormatSingleActivityComponent */];
        instance['CoreSitePluginsModuleIndexComponent'] = __WEBPACK_IMPORTED_MODULE_50__core_siteplugins_components_module_index_module_index__["a" /* CoreSitePluginsModuleIndexComponent */];
        instance['CoreSitePluginsBlockComponent'] = __WEBPACK_IMPORTED_MODULE_51__core_siteplugins_components_block_block__["a" /* CoreSitePluginsBlockComponent */];
        instance['CoreSitePluginsCourseOptionComponent'] = __WEBPACK_IMPORTED_MODULE_52__core_siteplugins_components_course_option_course_option__["a" /* CoreSitePluginsCourseOptionComponent */];
        instance['CoreSitePluginsCourseFormatComponent'] = __WEBPACK_IMPORTED_MODULE_53__core_siteplugins_components_course_format_course_format__["a" /* CoreSitePluginsCourseFormatComponent */];
        instance['CoreSitePluginsQuestionComponent'] = __WEBPACK_IMPORTED_MODULE_54__core_siteplugins_components_question_question__["a" /* CoreSitePluginsQuestionComponent */];
        instance['CoreSitePluginsQuestionBehaviourComponent'] = __WEBPACK_IMPORTED_MODULE_55__core_siteplugins_components_question_behaviour_question_behaviour__["a" /* CoreSitePluginsQuestionBehaviourComponent */];
        instance['CoreSitePluginsUserProfileFieldComponent'] = __WEBPACK_IMPORTED_MODULE_56__core_siteplugins_components_user_profile_field_user_profile_field__["a" /* CoreSitePluginsUserProfileFieldComponent */];
        instance['CoreSitePluginsQuizAccessRuleComponent'] = __WEBPACK_IMPORTED_MODULE_57__core_siteplugins_components_quiz_access_rule_quiz_access_rule__["a" /* CoreSitePluginsQuizAccessRuleComponent */];
        instance['CoreSitePluginsAssignFeedbackComponent'] = __WEBPACK_IMPORTED_MODULE_58__core_siteplugins_components_assign_feedback_assign_feedback__["a" /* CoreSitePluginsAssignFeedbackComponent */];
        instance['CoreSitePluginsAssignSubmissionComponent'] = __WEBPACK_IMPORTED_MODULE_59__core_siteplugins_components_assign_submission_assign_submission__["a" /* CoreSitePluginsAssignSubmissionComponent */];
    };
    /**
     * Instantiate a dynamic component.
     *
     * @param {string} template The template of the component.
     * @param {any} componentClass The JS class of the component.
     * @param {Injector} [injector] The injector to use. It's recommended to pass it so NavController and similar can be injected.
     * @return {Promise<ComponentRef<any>>} Promise resolved with the component instance.
     */
    CoreCompileProvider.prototype.instantiateDynamicComponent = function (template, componentClass, injector) {
        injector = injector || this.injector;
        return this.createAndCompileComponent(template, componentClass).then(function (factory) {
            if (factory) {
                // Create and return the component.
                return factory.create(injector, undefined, undefined, injector.get(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModuleRef"]));
            }
        });
    };
    CoreCompileProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser_dynamic__["a" /* JitCompilerFactory */]])
    ], CoreCompileProvider);
    return CoreCompileProvider;
}());

//# sourceMappingURL=compile.js.map

/***/ }),
/* 354 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatSingleActivityComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_unsupported_module_unsupported_module__ = __webpack_require__(351);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_dynamic_component_dynamic_component__ = __webpack_require__(162);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to display single activity format. It will determine the right component to use and instantiate it.
 *
 * The instantiated component will receive the course and the module as inputs.
 */
var CoreCourseFormatSingleActivityComponent = /** @class */ (function () {
    function CoreCourseFormatSingleActivityComponent(moduleDelegate, injector) {
        this.moduleDelegate = moduleDelegate;
        this.injector = injector;
        this.data = {}; // Data to pass to the component.
    }
    /**
     * Detect changes on input properties.
     */
    CoreCourseFormatSingleActivityComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        if (this.course && this.sections && this.sections.length) {
            // In single activity the module should only have 1 section and 1 module. Get the module.
            var module_1 = this.sections[0] && this.sections[0].modules && this.sections[0].modules[0];
            if (module_1 && !this.componentClass) {
                // We haven't obtained the class yet. Get it now.
                this.moduleDelegate.getMainComponent(this.injector, this.course, module_1).then(function (component) {
                    _this.componentClass = component || __WEBPACK_IMPORTED_MODULE_2__components_unsupported_module_unsupported_module__["a" /* CoreCourseUnsupportedModuleComponent */];
                });
            }
            this.data.courseId = this.course.id;
            this.data.module = module_1;
        }
    };
    /**
     * Refresh the data.
     *
     * @param {any} [refresher] Refresher.
     * @param {Function} [done] Function to call when done.
     * @param {boolean} [afterCompletionChange] Whether the refresh is due to a completion change.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseFormatSingleActivityComponent.prototype.doRefresh = function (refresher, done, afterCompletionChange) {
        if (afterCompletionChange) {
            // Don't refresh the view after a completion change since completion isn't displayed.
            return Promise.resolve();
        }
        return Promise.resolve(this.dynamicComponent.callComponentFunction('doRefresh', [refresher, done]));
    };
    /**
     * User entered the page that contains the component.
     */
    CoreCourseFormatSingleActivityComponent.prototype.ionViewDidEnter = function () {
        this.dynamicComponent.callComponentFunction('ionViewDidEnter');
    };
    /**
     * User left the page that contains the component.
     */
    CoreCourseFormatSingleActivityComponent.prototype.ionViewDidLeave = function () {
        this.dynamicComponent.callComponentFunction('ionViewDidLeave');
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseFormatSingleActivityComponent.prototype, "course", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreCourseFormatSingleActivityComponent.prototype, "sections", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreCourseFormatSingleActivityComponent.prototype, "downloadEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseFormatSingleActivityComponent.prototype, "initialSectionId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseFormatSingleActivityComponent.prototype, "initialSectionNumber", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseFormatSingleActivityComponent.prototype, "moduleId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCourseFormatSingleActivityComponent.prototype, "completionChanged", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_3__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_3__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */])
    ], CoreCourseFormatSingleActivityComponent.prototype, "dynamicComponent", void 0);
    CoreCourseFormatSingleActivityComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-course-format-single-activity',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\formats\singleactivity\components\core-course-format-single-activity.html"*/'<core-dynamic-component [component]="componentClass" [data]="data"></core-dynamic-component>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\formats\singleactivity\components\core-course-format-single-activity.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], CoreCourseFormatSingleActivityComponent);
    return CoreCourseFormatSingleActivityComponent;
}());

//# sourceMappingURL=singleactivity.js.map

/***/ }),
/* 355 */,
/* 356 */,
/* 357 */,
/* 358 */,
/* 359 */,
/* 360 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsBlockComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__ = __webpack_require__(126);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_block_classes_base_block_component__ = __webpack_require__(150);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__ = __webpack_require__(88);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays the index of a course format site plugin.
 */
var CoreSitePluginsBlockComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsBlockComponent, _super);
    function CoreSitePluginsBlockComponent(injector, sitePluginsProvider, blockDelegate) {
        var _this = _super.call(this, injector, 'CoreSitePluginsBlockComponent') || this;
        _this.injector = injector;
        _this.sitePluginsProvider = sitePluginsProvider;
        _this.blockDelegate = blockDelegate;
        return _this;
    }
    /**
     * Detect changes on input properties.
     */
    CoreSitePluginsBlockComponent.prototype.ngOnChanges = function () {
        if (!this.component) {
            // Initialize the data.
            var handlerName = this.blockDelegate.getHandlerName(this.block.name);
            var handler = this.sitePluginsProvider.getSitePluginHandler(handlerName);
            if (handler) {
                this.component = handler.plugin.component;
                this.method = handler.handlerSchema.method;
                this.args = {};
                this.initResult = handler.initResult;
            }
        }
    };
    /**
     * Pass on content invalidation by refreshing content in the plugin content component.
     */
    CoreSitePluginsBlockComponent.prototype.invalidateContent = function () {
        return Promise.resolve(this.content.refreshContent());
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsBlockComponent.prototype, "block", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsBlockComponent.prototype, "contextLevel", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsBlockComponent.prototype, "instanceId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */])
    ], CoreSitePluginsBlockComponent.prototype, "content", void 0);
    CoreSitePluginsBlockComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-block',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\block\core-siteplugins-block.html"*/'<core-site-plugins-plugin-content *ngIf="component && method" [component]="component" [method]="method" [args]="args" [initResult]="initResult"></core-site-plugins-plugin-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\block\core-siteplugins-block.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__["a" /* CoreSitePluginsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__["a" /* CoreBlockDelegate */]])
    ], CoreSitePluginsBlockComponent);
    return CoreSitePluginsBlockComponent;
}(__WEBPACK_IMPORTED_MODULE_3__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=block.js.map

/***/ }),
/* 361 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCourseOptionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__ = __webpack_require__(126);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component that displays the index of a course option site plugin.
 */
var CoreSitePluginsCourseOptionComponent = /** @class */ (function () {
    function CoreSitePluginsCourseOptionComponent(sitePluginsProvider) {
        this.sitePluginsProvider = sitePluginsProvider;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsCourseOptionComponent.prototype.ngOnInit = function () {
        if (this.handlerUniqueName) {
            var handler = this.sitePluginsProvider.getSitePluginHandler(this.handlerUniqueName);
            if (handler) {
                this.component = handler.plugin.component;
                this.method = handler.handlerSchema.method;
                this.args = {
                    courseid: this.courseId,
                };
                this.initResult = handler.initResult;
            }
        }
    };
    /**
     * Refresh the data.
     *
     * @param {any} refresher Refresher.
     */
    CoreSitePluginsCourseOptionComponent.prototype.refreshData = function (refresher) {
        this.content.refreshContent(false).finally(function () {
            refresher.complete();
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsCourseOptionComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCourseOptionComponent.prototype, "handlerUniqueName", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */])
    ], CoreSitePluginsCourseOptionComponent.prototype, "content", void 0);
    CoreSitePluginsCourseOptionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-course-option',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\course-option\core-siteplugins-course-option.html"*/'<ion-content>\n    <ion-refresher [enabled]="content && content.dataLoaded" (ionRefresh)="refreshData($event)">\n        <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n    </ion-refresher>\n    <core-site-plugins-plugin-content *ngIf="component && method" [component]="component" [method]="method" [args]="args" [initResult]="initResult"></core-site-plugins-plugin-content>\n</ion-content>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\course-option\core-siteplugins-course-option.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__["a" /* CoreSitePluginsProvider */]])
    ], CoreSitePluginsCourseOptionComponent);
    return CoreSitePluginsCourseOptionComponent;
}());

//# sourceMappingURL=course-option.js.map

/***/ }),
/* 362 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCourseFormatComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__ = __webpack_require__(126);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_components_format_format__ = __webpack_require__(350);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_format_delegate__ = __webpack_require__(113);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays the index of a course format site plugin.
 */
var CoreSitePluginsCourseFormatComponent = /** @class */ (function () {
    function CoreSitePluginsCourseFormatComponent(sitePluginsProvider, courseFormatDelegate) {
        this.sitePluginsProvider = sitePluginsProvider;
        this.courseFormatDelegate = courseFormatDelegate;
    }
    /**
     * Detect changes on input properties.
     */
    CoreSitePluginsCourseFormatComponent.prototype.ngOnChanges = function () {
        if (this.course && this.course.format) {
            if (!this.component) {
                // Initialize the data.
                var handlerName = this.courseFormatDelegate.getHandlerName(this.course.format), handler = this.sitePluginsProvider.getSitePluginHandler(handlerName);
                if (handler) {
                    this.component = handler.plugin.component;
                    this.method = handler.handlerSchema.method;
                    this.args = {
                        courseid: this.course.id,
                        downloadenabled: this.downloadEnabled
                    };
                    this.initResult = handler.initResult;
                }
            }
            // Pass input data to the component.
            this.data = {
                course: this.course,
                sections: this.sections,
                downloadEnabled: this.downloadEnabled,
                initialSectionId: this.initialSectionId,
                initialSectionNumber: this.initialSectionNumber,
                moduleId: this.moduleId,
                completionChanged: this.completionChanged,
                coreCourseFormatComponent: this.coreCourseFormatComponent
            };
        }
    };
    /**
     * Refresh the data.
     *
     * @param {any} [refresher] Refresher.
     * @param {Function} [done] Function to call when done.
     * @param {boolean} [afterCompletionChange] Whether the refresh is due to a completion change.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsCourseFormatComponent.prototype.doRefresh = function (refresher, done, afterCompletionChange) {
        return Promise.resolve(this.content.refreshContent(afterCompletionChange));
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCourseFormatComponent.prototype, "course", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreSitePluginsCourseFormatComponent.prototype, "sections", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreSitePluginsCourseFormatComponent.prototype, "downloadEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsCourseFormatComponent.prototype, "initialSectionId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsCourseFormatComponent.prototype, "initialSectionNumber", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsCourseFormatComponent.prototype, "moduleId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsCourseFormatComponent.prototype, "completionChanged", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_3__core_course_components_format_format__["a" /* CoreCourseFormatComponent */])
    ], CoreSitePluginsCourseFormatComponent.prototype, "coreCourseFormatComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */])
    ], CoreSitePluginsCourseFormatComponent.prototype, "content", void 0);
    CoreSitePluginsCourseFormatComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-course-format',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\course-format\core-siteplugins-course-format.html"*/'<core-site-plugins-plugin-content *ngIf="component && method" [component]="component" [method]="method" [args]="args" [initResult]="initResult" [data]="data"></core-site-plugins-plugin-content>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\course-format\core-siteplugins-course-format.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__["a" /* CoreSitePluginsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_format_delegate__["a" /* CoreCourseFormatDelegate */]])
    ], CoreSitePluginsCourseFormatComponent);
    return CoreSitePluginsCourseFormatComponent;
}());

//# sourceMappingURL=course-format.js.map

/***/ }),
/* 363 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsQuestionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_question_providers_delegate__ = __webpack_require__(42);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays a question created using a site plugin.
 */
var CoreSitePluginsQuestionComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsQuestionComponent, _super);
    function CoreSitePluginsQuestionComponent(sitePluginsProvider, utils, questionDelegate) {
        var _this = _super.call(this, sitePluginsProvider, utils) || this;
        _this.questionDelegate = questionDelegate;
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsQuestionComponent.prototype.ngOnInit = function () {
        // Pass the input and output data to the component.
        this.jsData.question = this.question;
        this.jsData.component = this.component;
        this.jsData.componentId = this.componentId;
        this.jsData.attemptId = this.attemptId;
        this.jsData.offlineEnabled = this.offlineEnabled;
        this.jsData.buttonClicked = this.buttonClicked;
        this.jsData.onAbort = this.onAbort;
        if (this.question) {
            this.getHandlerData(this.questionDelegate.getHandlerName('qtype_' + this.question.type));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsQuestionComponent.prototype, "question", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsQuestionComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsQuestionComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsQuestionComponent.prototype, "attemptId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsQuestionComponent.prototype, "offlineEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsQuestionComponent.prototype, "buttonClicked", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsQuestionComponent.prototype, "onAbort", void 0);
    CoreSitePluginsQuestionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-question',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\question\core-siteplugins-question.html"*/'<core-compile-html [text]="content" [jsData]="jsData" (created)="componentCreated($event)"></core-compile-html>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\question\core-siteplugins-question.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_question_providers_delegate__["a" /* CoreQuestionDelegate */]])
    ], CoreSitePluginsQuestionComponent);
    return CoreSitePluginsQuestionComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__["a" /* CoreSitePluginsCompileInitComponent */]));

//# sourceMappingURL=question.js.map

/***/ }),
/* 364 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsQuestionBehaviourComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays a question behaviour created using a site plugin.
 */
var CoreSitePluginsQuestionBehaviourComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsQuestionBehaviourComponent, _super);
    function CoreSitePluginsQuestionBehaviourComponent(sitePluginsProvider, utils, questionBehaviourDelegate) {
        var _this = _super.call(this, sitePluginsProvider, utils) || this;
        _this.questionBehaviourDelegate = questionBehaviourDelegate;
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsQuestionBehaviourComponent.prototype.ngOnInit = function () {
        // Pass the input and output data to the component.
        this.jsData.question = this.question;
        this.jsData.component = this.component;
        this.jsData.componentId = this.componentId;
        this.jsData.attemptId = this.attemptId;
        this.jsData.offlineEnabled = this.offlineEnabled;
        this.jsData.buttonClicked = this.buttonClicked;
        this.jsData.onAbort = this.onAbort;
        if (this.question) {
            this.getHandlerData(this.questionBehaviourDelegate.getHandlerName(this.question.preferredBehaviour));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsQuestionBehaviourComponent.prototype, "question", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsQuestionBehaviourComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsQuestionBehaviourComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsQuestionBehaviourComponent.prototype, "attemptId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsQuestionBehaviourComponent.prototype, "offlineEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsQuestionBehaviourComponent.prototype, "buttonClicked", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsQuestionBehaviourComponent.prototype, "onAbort", void 0);
    CoreSitePluginsQuestionBehaviourComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-question-behaviour',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\question-behaviour\core-siteplugins-question-behaviour.html"*/'<core-compile-html [text]="content" [jsData]="jsData" (created)="componentCreated($event)"></core-compile-html>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\question-behaviour\core-siteplugins-question-behaviour.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */]])
    ], CoreSitePluginsQuestionBehaviourComponent);
    return CoreSitePluginsQuestionBehaviourComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__["a" /* CoreSitePluginsCompileInitComponent */]));

//# sourceMappingURL=question-behaviour.js.map

/***/ }),
/* 365 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsUserProfileFieldComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user_profile_field_delegate__ = __webpack_require__(125);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Component that displays a user profile field created using a site plugin.
 */
var CoreSitePluginsUserProfileFieldComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsUserProfileFieldComponent, _super);
    function CoreSitePluginsUserProfileFieldComponent(sitePluginsProvider, utils, profileFieldDelegate) {
        var _this = _super.call(this, sitePluginsProvider, utils) || this;
        _this.profileFieldDelegate = profileFieldDelegate;
        _this.edit = false; // True if editing the field. Defaults to false.
        _this.disabled = false; // True if disabled. Defaults to false.
        _this.signup = false; // True if editing the field in signup. Defaults to false.
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsUserProfileFieldComponent.prototype.ngOnInit = function () {
        // Pass the input data to the component.
        this.jsData.field = this.field;
        this.jsData.signup = this.signup;
        this.jsData.edit = this.edit;
        this.jsData.disabled = this.disabled;
        this.jsData.form = this.form;
        this.jsData.registerAuth = this.registerAuth;
        if (this.field) {
            this.getHandlerData(this.profileFieldDelegate.getHandlerName(this.field.type || this.field.datatype));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsUserProfileFieldComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsUserProfileFieldComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsUserProfileFieldComponent.prototype, "disabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_4__angular_forms__["c" /* FormGroup */])
    ], CoreSitePluginsUserProfileFieldComponent.prototype, "form", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsUserProfileFieldComponent.prototype, "signup", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsUserProfileFieldComponent.prototype, "registerAuth", void 0);
    CoreSitePluginsUserProfileFieldComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-user-profile-field',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\user-profile-field\core-siteplugins-user-profile-field.html"*/'<core-compile-html [text]="content" [jsData]="jsData" (created)="componentCreated($event)"></core-compile-html>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\user-profile-field\core-siteplugins-user-profile-field.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */]])
    ], CoreSitePluginsUserProfileFieldComponent);
    return CoreSitePluginsUserProfileFieldComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__["a" /* CoreSitePluginsCompileInitComponent */]));

//# sourceMappingURL=user-profile-field.js.map

/***/ }),
/* 366 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsQuizAccessRuleComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__addon_mod_quiz_providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Component that displays a quiz access rule created using a site plugin.
 */
var CoreSitePluginsQuizAccessRuleComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsQuizAccessRuleComponent, _super);
    function CoreSitePluginsQuizAccessRuleComponent(sitePluginsProvider, utils, accessRulesDelegate) {
        var _this = _super.call(this, sitePluginsProvider, utils) || this;
        _this.accessRulesDelegate = accessRulesDelegate;
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsQuizAccessRuleComponent.prototype.ngOnInit = function () {
        // Pass the input and output data to the component.
        this.jsData.rule = this.rule;
        this.jsData.quiz = this.quiz;
        this.jsData.attempt = this.attempt;
        this.jsData.prefetch = this.prefetch;
        this.jsData.siteId = this.siteId;
        this.jsData.form = this.form;
        if (this.rule) {
            this.getHandlerData(this.accessRulesDelegate.getHandlerName(this.rule));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsQuizAccessRuleComponent.prototype, "rule", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsQuizAccessRuleComponent.prototype, "quiz", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsQuizAccessRuleComponent.prototype, "attempt", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreSitePluginsQuizAccessRuleComponent.prototype, "prefetch", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsQuizAccessRuleComponent.prototype, "siteId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_4__angular_forms__["c" /* FormGroup */])
    ], CoreSitePluginsQuizAccessRuleComponent.prototype, "form", void 0);
    CoreSitePluginsQuizAccessRuleComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-quiz-access-rule',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\quiz-access-rule\core-siteplugins-quiz-access-rule.html"*/'<core-compile-html [text]="content" [jsData]="jsData" (created)="componentCreated($event)"></core-compile-html>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\quiz-access-rule\core-siteplugins-quiz-access-rule.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__addon_mod_quiz_providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */]])
    ], CoreSitePluginsQuizAccessRuleComponent);
    return CoreSitePluginsQuizAccessRuleComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__["a" /* CoreSitePluginsCompileInitComponent */]));

//# sourceMappingURL=quiz-access-rule.js.map

/***/ }),
/* 367 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsAssignFeedbackComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__addon_mod_assign_providers_feedback_delegate__ = __webpack_require__(116);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays an assign feedback plugin created using a site plugin.
 */
var CoreSitePluginsAssignFeedbackComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsAssignFeedbackComponent, _super);
    function CoreSitePluginsAssignFeedbackComponent(sitePluginsProvider, utils, assignFeedbackDelegate) {
        var _this = _super.call(this, sitePluginsProvider, utils) || this;
        _this.assignFeedbackDelegate = assignFeedbackDelegate;
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsAssignFeedbackComponent.prototype.ngOnInit = function () {
        // Pass the input and output data to the component.
        this.jsData.assign = this.assign;
        this.jsData.submission = this.submission;
        this.jsData.plugin = this.plugin;
        this.jsData.userId = this.userId;
        this.jsData.configs = this.configs;
        this.jsData.edit = this.edit;
        this.jsData.canEdit = this.canEdit;
        if (this.plugin) {
            this.getHandlerData(this.assignFeedbackDelegate.getHandlerName(this.plugin.type));
        }
    };
    /**
     * Invalidate the data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsAssignFeedbackComponent.prototype.invalidate = function () {
        return Promise.resolve();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignFeedbackComponent.prototype, "assign", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignFeedbackComponent.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignFeedbackComponent.prototype, "plugin", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsAssignFeedbackComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignFeedbackComponent.prototype, "configs", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreSitePluginsAssignFeedbackComponent.prototype, "canEdit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreSitePluginsAssignFeedbackComponent.prototype, "edit", void 0);
    CoreSitePluginsAssignFeedbackComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-assign-feedback',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\assign-feedback\core-siteplugins-assign-feedback.html"*/'<core-compile-html [text]="content" [jsData]="jsData" (created)="componentCreated($event)"></core-compile-html>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\assign-feedback\core-siteplugins-assign-feedback.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__addon_mod_assign_providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */]])
    ], CoreSitePluginsAssignFeedbackComponent);
    return CoreSitePluginsAssignFeedbackComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__["a" /* CoreSitePluginsCompileInitComponent */]));

//# sourceMappingURL=assign-feedback.js.map

/***/ }),
/* 368 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsAssignSubmissionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__addon_mod_assign_providers_submission_delegate__ = __webpack_require__(107);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays an assign submission plugin created using a site plugin.
 */
var CoreSitePluginsAssignSubmissionComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsAssignSubmissionComponent, _super);
    function CoreSitePluginsAssignSubmissionComponent(sitePluginsProvider, utils, assignSubmissionDelegate) {
        var _this = _super.call(this, sitePluginsProvider, utils) || this;
        _this.assignSubmissionDelegate = assignSubmissionDelegate;
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsAssignSubmissionComponent.prototype.ngOnInit = function () {
        // Pass the input and output data to the component.
        this.jsData.assign = this.assign;
        this.jsData.submission = this.submission;
        this.jsData.plugin = this.plugin;
        this.jsData.configs = this.configs;
        this.jsData.edit = this.edit;
        this.jsData.allowOffline = this.allowOffline;
        if (this.plugin) {
            this.getHandlerData(this.assignSubmissionDelegate.getHandlerName(this.plugin.type));
        }
    };
    /**
     * Invalidate the data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsAssignSubmissionComponent.prototype.invalidate = function () {
        return Promise.resolve();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignSubmissionComponent.prototype, "assign", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignSubmissionComponent.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignSubmissionComponent.prototype, "plugin", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsAssignSubmissionComponent.prototype, "configs", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreSitePluginsAssignSubmissionComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreSitePluginsAssignSubmissionComponent.prototype, "allowOffline", void 0);
    CoreSitePluginsAssignSubmissionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-plugins-assign-submission',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\assign-submission\core-siteplugins-assign-submission.html"*/'<core-compile-html [text]="content" [jsData]="jsData" (created)="componentCreated($event)"></core-compile-html>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\assign-submission\core-siteplugins-assign-submission.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__addon_mod_assign_providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */]])
    ], CoreSitePluginsAssignSubmissionComponent);
    return CoreSitePluginsAssignSubmissionComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__["a" /* CoreSitePluginsCompileInitComponent */]));

//# sourceMappingURL=assign-submission.js.map

/***/ }),
/* 369 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionPluginComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Base class for component to render a submission plugin.
 */
var AddonModAssignSubmissionPluginComponent = /** @class */ (function () {
    function AddonModAssignSubmissionPluginComponent() {
        // Nothing to do.
    }
    /**
     * Invalidate the data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionPluginComponent.prototype.invalidate = function () {
        return Promise.resolve();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "assign", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "plugin", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "configs", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModAssignSubmissionPluginComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModAssignSubmissionPluginComponent.prototype, "allowOffline", void 0);
    return AddonModAssignSubmissionPluginComponent;
}());

//# sourceMappingURL=submission-plugin-component.js.map

/***/ }),
/* 370 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackPluginComponentBase; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Base class for component to render a feedback plugin.
 */
var AddonModAssignFeedbackPluginComponentBase = /** @class */ (function () {
    function AddonModAssignFeedbackPluginComponentBase(modalCtrl) {
        this.modalCtrl = modalCtrl;
    }
    /**
     * Open a modal to edit the feedback plugin.
     *
     * @return {Promise<any>} Promise resolved with the input data, rejected if cancelled.
     */
    AddonModAssignFeedbackPluginComponentBase.prototype.editFeedback = function () {
        var _this = this;
        if (this.canEdit) {
            return new Promise(function (resolve, reject) {
                // Create the navigation modal.
                var modal = _this.modalCtrl.create('AddonModAssignEditFeedbackModalPage', {
                    assign: _this.assign,
                    submission: _this.submission,
                    plugin: _this.plugin,
                    userId: _this.userId
                });
                modal.present();
                modal.onDidDismiss(function (data) {
                    if (typeof data == 'undefined') {
                        reject();
                    }
                    else {
                        resolve(data);
                    }
                });
            });
        }
        else {
            return Promise.reject(null);
        }
    };
    /**
     * Invalidate the data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignFeedbackPluginComponentBase.prototype.invalidate = function () {
        return Promise.resolve();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponentBase.prototype, "assign", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponentBase.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponentBase.prototype, "plugin", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModAssignFeedbackPluginComponentBase.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponentBase.prototype, "configs", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModAssignFeedbackPluginComponentBase.prototype, "canEdit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModAssignFeedbackPluginComponentBase.prototype, "edit", void 0);
    return AddonModAssignFeedbackPluginComponentBase;
}());

//# sourceMappingURL=feedback-plugin-component.js.map

/***/ }),
/* 371 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Service that provides some features for folder.
 */
var AddonModFolderProvider = /** @class */ (function () {
    function AddonModFolderProvider(logger, sitesProvider, courseProvider, utils, logHelper) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.utils = utils;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModFolder:';
        this.logger = logger.getInstance('AddonModFolderProvider');
    }
    AddonModFolderProvider_1 = AddonModFolderProvider;
    /**
     * Get a folder by course module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId     Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}        Promise resolved when the book is retrieved.
     */
    AddonModFolderProvider.prototype.getFolder = function (courseId, cmId, siteId) {
        return this.getFolderByKey(courseId, 'coursemodule', cmId, siteId);
    };
    /**
     * Get a folder.
     *
     * @param {number} courseId  Course ID.
     * @param {string} key       Name of the property to check.
     * @param {any}  value     Value to search.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}          Promise resolved when the book is retrieved.
     */
    AddonModFolderProvider.prototype.getFolderByKey = function (courseId, key, value, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getFolderCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_6__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_folder_get_folders_by_courses', params, preSets).then(function (response) {
                if (response && response.folders) {
                    var currentFolder = response.folders.find(function (folder) {
                        return folder[key] == value;
                    });
                    if (currentFolder) {
                        return currentFolder;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get cache key for folder data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonModFolderProvider.prototype.getFolderCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'folder:' + courseId;
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}
     */
    AddonModFolderProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        var promises = [];
        promises.push(this.invalidateFolderData(courseId, siteId));
        promises.push(this.courseProvider.invalidateModule(moduleId, siteId));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates folder data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the data is invalidated.
     */
    AddonModFolderProvider.prototype.invalidateFolderData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getFolderCacheKey(courseId));
        });
    };
    /**
     * Returns whether or not getFolder WS available or not.
     *
     * @return {boolean} If WS is avalaible.
     * @since 3.3
     */
    AddonModFolderProvider.prototype.isGetFolderWSAvailable = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('mod_folder_get_folders_by_courses');
    };
    /**
     * Report a folder as being viewed.
     *
     * @param {number} id Module ID.
     * @param {string} [name] Name of the folder.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModFolderProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            folderid: id
        };
        return this.logHelper.logSingle('mod_folder_view_folder', params, AddonModFolderProvider_1.COMPONENT, id, name, 'folder', {}, siteId);
    };
    AddonModFolderProvider.COMPONENT = 'mmaModFolder';
    AddonModFolderProvider = AddonModFolderProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModFolderProvider);
    return AddonModFolderProvider;
    var AddonModFolderProvider_1;
}());

//# sourceMappingURL=folder.js.map

/***/ }),
/* 372 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__lesson__ = __webpack_require__(102);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__lesson_sync__ = __webpack_require__(226);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * Handler to prefetch lessons.
 */
var AddonModLessonPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModLessonPrefetchHandler, _super);
    function AddonModLessonPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, modalCtrl, groupsProvider, lessonProvider, injector) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.modalCtrl = modalCtrl;
        _this.groupsProvider = groupsProvider;
        _this.lessonProvider = lessonProvider;
        _this.injector = injector;
        _this.name = 'AddonModLesson';
        _this.modName = 'lesson';
        _this.component = __WEBPACK_IMPORTED_MODULE_11__lesson__["a" /* AddonModLessonProvider */].COMPONENT;
        // Don't check timers to decrease positives. If a user performs some action it will be reflected in other items.
        _this.updatesNames = /^configuration$|^.*files$|^grades$|^gradeitems$|^pages$|^answers$|^questionattempts$|^pagesviewed$/;
        return _this;
    }
    /**
     * Ask password.
     *
     * @param {any} info Lesson access info.
     * @return {Promise<string>} Promise resolved with the password.
     */
    AddonModLessonPrefetchHandler.prototype.askUserPassword = function (info) {
        var _this = this;
        // Create and show the modal.
        var modal = this.modalCtrl.create('AddonModLessonPasswordModalPage');
        modal.present();
        // Wait for modal to be dismissed.
        return new Promise(function (resolve, reject) {
            modal.onDidDismiss(function (password) {
                if (typeof password != 'undefined') {
                    resolve(password);
                }
                else {
                    reject(_this.domUtils.createCanceledError());
                }
            });
        });
    };
    /**
     * Get the download size of a module.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<{size: number, total: boolean}>} Promise resolved with the size and a boolean indicating if it was able
     *                                                   to calculate the total size.
     */
    AddonModLessonPrefetchHandler.prototype.getDownloadSize = function (module, courseId, single) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        var lesson, password, result;
        return this.lessonProvider.getLesson(courseId, module.id, false, false, siteId).then(function (lessonData) {
            lesson = lessonData;
            // Get the lesson password if it's needed.
            return _this.getLessonPassword(lesson.id, false, true, single, siteId);
        }).then(function (data) {
            password = data.password;
            lesson = data.lesson || lesson;
            // Get intro files and media files.
            var files = lesson.mediafiles || [];
            files = files.concat(_this.getIntroFilesFromInstance(module, lesson));
            result = _this.utils.sumFileSizes(files);
            // Get the pages to calculate the size.
            return _this.lessonProvider.getPages(lesson.id, password, false, false, siteId);
        }).then(function (pages) {
            pages.forEach(function (page) {
                result.size += page.filessizetotal;
            });
            return result;
        });
    };
    /**
     * Get the lesson password if needed. If not stored, it can ask the user to enter it.
     *
     * @param {number} lessonId Lesson ID.
     * @param {boolean} [forceCache] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {boolean} [askPassword] True if we should ask for password if needed, false otherwise.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{password?: string, lesson?: any, accessInfo: any}>} Promise resolved when done.
     */
    AddonModLessonPrefetchHandler.prototype.getLessonPassword = function (lessonId, forceCache, ignoreCache, askPassword, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Get access information to check if password is needed.
        return this.lessonProvider.getAccessInformation(lessonId, forceCache, ignoreCache, siteId).then(function (info) {
            if (info.preventaccessreasons && info.preventaccessreasons.length) {
                var passwordNeeded = info.preventaccessreasons.length == 1 && _this.lessonProvider.isPasswordProtected(info);
                if (passwordNeeded) {
                    // The lesson requires a password. Check if there is one in DB.
                    return _this.lessonProvider.getStoredPassword(lessonId).catch(function () {
                        // No password found.
                    }).then(function (password) {
                        if (password) {
                            return _this.validatePassword(lessonId, info, password, forceCache, ignoreCache, siteId);
                        }
                        else {
                            return Promise.reject(null);
                        }
                    }).catch(function () {
                        // No password or error validating it. Ask for it if allowed.
                        if (askPassword) {
                            return _this.askUserPassword(info).then(function (password) {
                                return _this.validatePassword(lessonId, info, password, forceCache, ignoreCache, siteId);
                            });
                        }
                        // Cannot ask for password, reject.
                        return Promise.reject(info.preventaccessreasons[0].message);
                    });
                }
                else {
                    // Lesson cannot be played, reject.
                    return Promise.reject(info.preventaccessreasons[0].message);
                }
            }
            // Password not needed.
            return { accessInfo: info };
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLessonPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        // Only invalidate the data that doesn't ignore cache when prefetching.
        var promises = [];
        promises.push(this.lessonProvider.invalidateLessonData(courseId));
        promises.push(this.courseProvider.invalidateModule(moduleId));
        promises.push(this.groupsProvider.invalidateActivityAllowedGroups(moduleId));
        return Promise.all(promises);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModLessonPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        // Invalidate data to determine if module is downloadable.
        return this.lessonProvider.getLesson(courseId, module.id, true, false, siteId).then(function (lesson) {
            var promises = [];
            promises.push(_this.lessonProvider.invalidateLessonData(courseId, siteId));
            promises.push(_this.lessonProvider.invalidateAccessInformation(lesson.id, siteId));
            return Promise.all(promises);
        });
    };
    /**
     * Check if a module can be downloaded. If the function is not defined, we assume that all modules are downloadable.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {boolean|Promise<boolean>} Whether the module can be downloaded. The promise should never be rejected.
     */
    AddonModLessonPrefetchHandler.prototype.isDownloadable = function (module, courseId) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.lessonProvider.getLesson(courseId, module.id, false, false, siteId).then(function (lesson) {
            // Check if there is any prevent access reason.
            return _this.lessonProvider.getAccessInformation(lesson.id, false, false, siteId).then(function (info) {
                if (!info.canviewreports && !_this.lessonProvider.isLessonOffline(lesson)) {
                    return false;
                }
                // It's downloadable if there are no prevent access reasons or there is just 1 and it's password.
                return !info.preventaccessreasons || !info.preventaccessreasons.length ||
                    (info.preventaccessreasons.length == 1 && _this.lessonProvider.isPasswordProtected(info));
            });
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModLessonPrefetchHandler.prototype.isEnabled = function () {
        return this.lessonProvider.isPluginEnabled();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchLesson.bind(this));
    };
    /**
     * Prefetch a lesson.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonPrefetchHandler.prototype.prefetchLesson = function (module, courseId, single, siteId) {
        var _this = this;
        var lesson, password, accessInfo;
        return this.lessonProvider.getLesson(courseId, module.id, false, true, siteId).then(function (lessonData) {
            lesson = lessonData;
            // Get the lesson password if it's needed.
            return _this.getLessonPassword(lesson.id, false, true, single, siteId);
        }).then(function (data) {
            password = data.password;
            lesson = data.lesson || lesson;
            accessInfo = data.accessInfo;
            if (_this.lessonProvider.isLessonOffline(lesson) && !_this.lessonProvider.leftDuringTimed(accessInfo)) {
                // The user didn't left during a timed session. Call launch retake to make sure there is a started retake.
                return _this.lessonProvider.launchRetake(lesson.id, password, undefined, false, siteId).then(function () {
                    var promises = [];
                    // New data generated, update the download time and refresh the access info.
                    promises.push(_this.filepoolProvider.updatePackageDownloadTime(siteId, _this.component, module.id).catch(function () {
                        // Ignore errors.
                    }));
                    promises.push(_this.lessonProvider.getAccessInformation(lesson.id, false, true, siteId).then(function (info) {
                        accessInfo = info;
                    }));
                    return Promise.all(promises);
                });
            }
        }).then(function () {
            var promises = [], retake = accessInfo.attemptscount;
            // Download intro files and media files.
            var files = lesson.mediafiles || [];
            files = files.concat(_this.getIntroFilesFromInstance(module, lesson));
            promises.push(_this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id));
            // Get the list of pages.
            if (_this.lessonProvider.isLessonOffline(lesson)) {
                promises.push(_this.lessonProvider.getPages(lesson.id, password, false, true, siteId).then(function (pages) {
                    var subPromises = [];
                    var hasRandomBranch = false;
                    // Get the data for each page.
                    pages.forEach(function (data) {
                        // Check if any page has a RANDOMBRANCH jump.
                        if (!hasRandomBranch) {
                            for (var i = 0; i < data.jumps.length; i++) {
                                if (data.jumps[i] == __WEBPACK_IMPORTED_MODULE_11__lesson__["a" /* AddonModLessonProvider */].LESSON_RANDOMBRANCH) {
                                    hasRandomBranch = true;
                                    break;
                                }
                            }
                        }
                        // Get the page data. We don't pass accessInfo because we don't need to calculate the offline data.
                        subPromises.push(_this.lessonProvider.getPageData(lesson, data.page.id, password, false, true, false, true, undefined, undefined, siteId).then(function (pageData) {
                            // Download the page files.
                            var pageFiles = pageData.contentfiles || [];
                            pageData.answers.forEach(function (answer) {
                                if (answer.answerfiles && answer.answerfiles.length) {
                                    pageFiles = pageFiles.concat(answer.answerfiles);
                                }
                                if (answer.responsefiles && answer.responsefiles.length) {
                                    pageFiles = pageFiles.concat(answer.responsefiles);
                                }
                            });
                            return _this.filepoolProvider.addFilesToQueue(siteId, pageFiles, _this.component, module.id);
                        }));
                    });
                    // Prefetch the list of possible jumps for offline navigation. Do it here because we know hasRandomBranch.
                    subPromises.push(_this.lessonProvider.getPagesPossibleJumps(lesson.id, false, true, siteId).catch(function (error) {
                        if (hasRandomBranch) {
                            // The WebSevice probably failed because RANDOMBRANCH aren't supported if the user hasn't seen any page.
                            return Promise.reject(_this.translate.instant('addon.mod_lesson.errorprefetchrandombranch'));
                        }
                        else {
                            return Promise.reject(error);
                        }
                    }));
                    return Promise.all(subPromises);
                }));
                // Prefetch user timers to be able to calculate timemodified in offline.
                promises.push(_this.lessonProvider.getTimers(lesson.id, false, true, siteId).catch(function () {
                    // Ignore errors.
                }));
                // Prefetch viewed pages in last retake to calculate progress.
                promises.push(_this.lessonProvider.getContentPagesViewedOnline(lesson.id, retake, false, true, siteId));
                // Prefetch question attempts in last retake for offline calculations.
                promises.push(_this.lessonProvider.getQuestionsAttemptsOnline(lesson.id, retake, false, undefined, false, true, siteId));
            }
            if (accessInfo.canviewreports) {
                // Prefetch reports data.
                promises.push(_this.groupsProvider.getActivityAllowedGroupsIfEnabled(module.id, undefined, siteId, true)
                    .then(function (groups) {
                    var subPromises = [];
                    groups.forEach(function (group) {
                        subPromises.push(_this.lessonProvider.getRetakesOverview(lesson.id, group.id, false, true, siteId));
                    });
                    // Always get group 0, even if there are no groups.
                    subPromises.push(_this.lessonProvider.getRetakesOverview(lesson.id, 0, false, true, siteId).then(function (data) {
                        if (!data || !data.students) {
                            return;
                        }
                        // Prefetch the last retake for each user.
                        var retakePromises = [];
                        data.students.forEach(function (student) {
                            if (!student.attempts || !student.attempts.length) {
                                return;
                            }
                            var lastRetake = student.attempts[student.attempts.length - 1];
                            if (!lastRetake) {
                                return;
                            }
                            retakePromises.push(_this.lessonProvider.getUserRetake(lesson.id, lastRetake.try, student.id, false, true, siteId).then(function (attempt) {
                                if (!attempt || !attempt.answerpages) {
                                    return;
                                }
                                // Download embedded files in essays.
                                var files = [];
                                attempt.answerpages.forEach(function (answerPage) {
                                    if (answerPage.page.qtype != __WEBPACK_IMPORTED_MODULE_11__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_ESSAY) {
                                        return;
                                    }
                                    answerPage.answerdata.answers.forEach(function (answer) {
                                        files.push.apply(files, _this.domUtils.extractDownloadableFilesFromHtmlAsFakeFileObjects(answer[0]));
                                    });
                                });
                                return _this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id);
                            }));
                        });
                        return Promise.all(retakePromises);
                    }));
                    return Promise.all(subPromises);
                }));
            }
            return Promise.all(promises);
        });
    };
    /**
     * Validate the password.
     *
     * @param {number} lessonId Lesson ID.
     * @param {any} info Lesson access info.
     * @param {string} pwd Password to check.
     * @param {boolean} [forceCache] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{password: string, lesson: any, accessInfo: any}>} Promise resolved when done.
     */
    AddonModLessonPrefetchHandler.prototype.validatePassword = function (lessonId, info, pwd, forceCache, ignoreCache, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.lessonProvider.getLessonWithPassword(lessonId, pwd, true, forceCache, ignoreCache, siteId).then(function (lesson) {
            // Password is ok, store it and return the data.
            return _this.lessonProvider.storePassword(lesson.id, pwd, siteId).then(function () {
                return {
                    password: pwd,
                    lesson: lesson,
                    accessInfo: info
                };
            });
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        if (!this.syncProvider) {
            this.syncProvider = this.injector.get(__WEBPACK_IMPORTED_MODULE_12__lesson_sync__["a" /* AddonModLessonSyncProvider */]);
        }
        return this.syncProvider.syncLesson(module.instance, false, false, siteId);
    };
    AddonModLessonPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_9__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__lesson__["a" /* AddonModLessonProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonModLessonPrefetchHandler);
    return AddonModLessonPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 373 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLtiProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service that provides some features for LTI.
 */
var AddonModLtiProvider = /** @class */ (function () {
    function AddonModLtiProvider(fileProvider, sitesProvider, textUtils, urlUtils, utils, translate, appProvider, logHelper) {
        this.fileProvider = fileProvider;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.urlUtils = urlUtils;
        this.utils = utils;
        this.translate = translate;
        this.appProvider = appProvider;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModLti:';
        this.LAUNCHER_FILE_NAME = 'lti_launcher.html';
    }
    AddonModLtiProvider_1 = AddonModLtiProvider;
    /**
     * Delete launcher.
     *
     * @return {Promise<any>} Promise resolved when the launcher file is deleted.
     */
    AddonModLtiProvider.prototype.deleteLauncher = function () {
        return this.fileProvider.removeFile(this.LAUNCHER_FILE_NAME);
    };
    /**
     * Generates a launcher file.
     *
     * @param {string} url Launch URL.
     * @param {AddonModLtiParam[]} params Launch params.
     * @return {Promise<string>} Promise resolved with the file URL.
     */
    AddonModLtiProvider.prototype.generateLauncher = function (url, params) {
        var _this = this;
        if (!this.fileProvider.isAvailable()) {
            return Promise.resolve(url);
        }
        // Generate a form with the params.
        var text = '<form action="' + url + '" name="ltiLaunchForm" ' +
            'method="post" encType="application/x-www-form-urlencoded">\n';
        params.forEach(function (p) {
            if (p.name == 'ext_submit') {
                text += '    <input type="submit"';
            }
            else {
                text += '    <input type="hidden" name="' + _this.textUtils.escapeHTML(p.name) + '"';
            }
            text += ' value="' + _this.textUtils.escapeHTML(p.value) + '"/>\n';
        });
        text += '</form>\n';
        // Add an in-line script to automatically submit the form.
        text += '<script type="text/javascript"> \n' +
            '    window.onload = function() { \n' +
            '        document.ltiLaunchForm.submit(); \n' +
            '    }; \n' +
            '</script> \n';
        return this.fileProvider.writeFile(this.LAUNCHER_FILE_NAME, text).then(function (entry) {
            if (_this.appProvider.isDesktop()) {
                return entry.toInternalURL();
            }
            else {
                return entry.toURL();
            }
        });
    };
    /**
     * Get a LTI.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @return {Promise<any>} Promise resolved when the LTI is retrieved.
     */
    AddonModLtiProvider.prototype.getLti = function (courseId, cmId) {
        var params = {
            courseids: [courseId]
        };
        var preSets = {
            cacheKey: this.getLtiCacheKey(courseId),
            updateFrequency: __WEBPACK_IMPORTED_MODULE_9__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
        };
        return this.sitesProvider.getCurrentSite().read('mod_lti_get_ltis_by_courses', params, preSets).then(function (response) {
            if (response.ltis) {
                var currentLti = response.ltis.find(function (lti) { return lti.coursemodule == cmId; });
                if (currentLti) {
                    return currentLti;
                }
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get cache key for LTI data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModLtiProvider.prototype.getLtiCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'lti:' + courseId;
    };
    /**
     * Get a LTI launch data.
     *
     * @param {number} id LTI id.
     * @return {Promise<any>} Promise resolved when the launch data is retrieved.
     */
    AddonModLtiProvider.prototype.getLtiLaunchData = function (id) {
        var params = {
            toolid: id
        };
        // Try to avoid using cache since the "nonce" parameter is set to a timestamp.
        var preSets = {
            getFromCache: false,
            saveToCache: true,
            emergencyCache: true,
            cacheKey: this.getLtiLaunchDataCacheKey(id)
        };
        return this.sitesProvider.getCurrentSite().read('mod_lti_get_tool_launch_data', params, preSets).then(function (response) {
            if (response.endpoint) {
                return response;
            }
            return Promise.reject(null);
        });
    };
    /**
     * Get cache key for LTI launch data WS calls.
     *
     * @param {number} id LTI id.
     * @return {string} Cache key.
     */
    AddonModLtiProvider.prototype.getLtiLaunchDataCacheKey = function (id) {
        return this.ROOT_CACHE_KEY + 'launch:' + id;
    };
    /**
     * Invalidates LTI data.
     *
     * @param {number} courseId Course ID.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLtiProvider.prototype.invalidateLti = function (courseId) {
        return this.sitesProvider.getCurrentSite().invalidateWsCacheForKey(this.getLtiCacheKey(courseId));
    };
    /**
     * Invalidates options.
     *
     * @param {number} id LTI id.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLtiProvider.prototype.invalidateLtiLaunchData = function (id) {
        return this.sitesProvider.getCurrentSite().invalidateWsCacheForKey(this.getLtiLaunchDataCacheKey(id));
    };
    /**
     * Launch LTI.
     *
     * @param {string} url Launch URL.
     * @param {AddonModLtiParam[]} params Launch params.
     * @return {Promise<any>} Promise resolved when the WS call is successful.
     */
    AddonModLtiProvider.prototype.launch = function (url, params) {
        var _this = this;
        if (!this.urlUtils.isHttpURL(url)) {
            return Promise.reject(this.translate.instant('addon.mod_lti.errorinvalidlaunchurl'));
        }
        // Generate launcher and open it.
        return this.generateLauncher(url, params).then(function (url) {
            _this.utils.openInApp(url);
        });
    };
    /**
     * Report the LTI as being viewed.
     *
     * @param {string} id LTI id.
     * @param {string} [name] Name of the lti.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModLtiProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            ltiid: id
        };
        return this.logHelper.logSingle('mod_lti_view_lti', params, AddonModLtiProvider_1.COMPONENT, id, name, 'lti', {}, siteId);
    };
    AddonModLtiProvider.COMPONENT = 'mmaModLti';
    AddonModLtiProvider = AddonModLtiProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModLtiProvider);
    return AddonModLtiProvider;
    var AddonModLtiProvider_1;
}());

//# sourceMappingURL=lti.js.map

/***/ }),
/* 374 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPageHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__page__ = __webpack_require__(172);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__angular_http__ = __webpack_require__(124);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service that provides some features for page.
 */
var AddonModPageHelperProvider = /** @class */ (function () {
    function AddonModPageHelperProvider(logger, domUtils, filepoolProvider, fileProvider, textUtils, http, sitesProvider) {
        this.domUtils = domUtils;
        this.filepoolProvider = filepoolProvider;
        this.fileProvider = fileProvider;
        this.textUtils = textUtils;
        this.http = http;
        this.sitesProvider = sitesProvider;
        this.logger = logger.getInstance('AddonModPageHelperProvider');
    }
    /**
     * Gets the page HTML.
     *
     * @param {any} contents The module contents.
     * @param {number} moduleId The module ID.
     * @return {Promise<string>} The HTML of the page.
     */
    AddonModPageHelperProvider.prototype.getPageHtml = function (contents, moduleId) {
        var _this = this;
        var indexUrl, promise;
        var paths = {};
        // Extract the information about paths from the module contents.
        contents.forEach(function (content) {
            var url = content.fileurl;
            if (_this.isMainPage(content)) {
                // This seems to be the most reliable way to spot the index page.
                indexUrl = url;
            }
            else {
                var key = content.filename;
                if (content.filepath !== '/') {
                    // Add the folders without the leading slash.
                    key = content.filepath.substr(1) + key;
                }
                paths[_this.textUtils.decodeURIComponent(key)] = url;
            }
        });
        // Promise handling when we are in a browser.
        if (!indexUrl) {
            // If ever that happens.
            this.logger.debug('Could not locate the index page');
            promise = Promise.reject(null);
        }
        else if (this.fileProvider.isAvailable()) {
            // The file system is available.
            promise = this.filepoolProvider.downloadUrl(this.sitesProvider.getCurrentSiteId(), indexUrl, false, __WEBPACK_IMPORTED_MODULE_5__page__["a" /* AddonModPageProvider */].COMPONENT, moduleId);
        }
        else {
            // We return the live URL.
            promise = Promise.resolve(this.sitesProvider.getCurrentSite().fixPluginfileURL(indexUrl));
        }
        return promise.then(function (url) {
            // Fetch the URL content.
            var promise = _this.http.get(url).toPromise();
            return promise.then(function (response) {
                var content = response.text();
                if (typeof content !== 'string') {
                    return Promise.reject(null);
                }
                // Now that we have the content, we update the SRC to point back to the external resource.
                // That will be caught by core-format-text.
                return _this.domUtils.restoreSourcesInHtml(content, paths);
            });
        });
    };
    /**
     * Returns whether the file is the main page of the module.
     *
     * @param {any} file An object returned from WS containing file info.
     * @return {boolean}  Whether the file is the main page or not.
     */
    AddonModPageHelperProvider.prototype.isMainPage = function (file) {
        var filename = file.filename || '', fileurl = file.fileurl || '', url = '/mod_page/content/index.html', encodedUrl = encodeURIComponent(url);
        return (filename === 'index.html' && (fileurl.indexOf(url) > 0 || fileurl.indexOf(encodedUrl) > 0));
    };
    AddonModPageHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_8__angular_http__["b" /* Http */],
            __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModPageHelperProvider);
    return AddonModPageHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 375 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_question_providers_helper__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__quiz__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__helper__ = __webpack_require__(185);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__access_rules_delegate__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__quiz_sync__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/**
 * Handler to prefetch quizzes.
 */
var AddonModQuizPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModQuizPrefetchHandler, _super);
    function AddonModQuizPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, injector, quizProvider, textUtils, quizHelper, accessRuleDelegate, questionHelper) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.injector = injector;
        _this.quizProvider = quizProvider;
        _this.textUtils = textUtils;
        _this.quizHelper = quizHelper;
        _this.accessRuleDelegate = accessRuleDelegate;
        _this.questionHelper = questionHelper;
        _this.name = 'AddonModQuiz';
        _this.modName = 'quiz';
        _this.component = __WEBPACK_IMPORTED_MODULE_11__quiz__["a" /* AddonModQuizProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^grades$|^gradeitems$|^questions$|^attempts$/;
        return _this;
    }
    /**
     * Download the module.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {boolean} [canStart=true] If true, start a new attempt if needed.
     * @return {Promise<any>} Promise resolved when all content is downloaded.
     */
    AddonModQuizPrefetchHandler.prototype.download = function (module, courseId, dirPath, single, canStart) {
        if (canStart === void 0) { canStart = true; }
        // Same implementation for download and prefetch.
        return this.prefetch(module, courseId, single, dirPath, canStart);
    };
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModQuizPrefetchHandler.prototype.getFiles = function (module, courseId, single) {
        var _this = this;
        return this.quizProvider.getQuiz(courseId, module.id).then(function (quiz) {
            var files = _this.getIntroFilesFromInstance(module, quiz);
            return _this.quizProvider.getUserAttempts(quiz.id, 'all', true, false, true).then(function (attempts) {
                return _this.getAttemptsFeedbackFiles(quiz, attempts).then(function (attemptFiles) {
                    return files.concat(attemptFiles);
                });
            });
        }).catch(function () {
            // Quiz not found, return empty list.
            return [];
        });
    };
    /**
     * Get the list of downloadable files on feedback attemptss.
     *
     * @param  {any}   quiz     Quiz.
     * @param  {any[]} attempts Quiz user attempts.
     * @return {Promise<any[]>} List of Files.
     */
    AddonModQuizPrefetchHandler.prototype.getAttemptsFeedbackFiles = function (quiz, attempts) {
        var _this = this;
        // We have quiz data, now we'll get specific data for each attempt.
        var promises = [], getInlineFiles = this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.2');
        var files = [];
        attempts.forEach(function (attempt) {
            if (_this.quizProvider.isAttemptFinished(attempt.state)) {
                // Attempt is finished, get feedback and review data.
                var attemptGrade = _this.quizProvider.rescaleGrade(attempt.sumgrades, quiz, false);
                if (typeof attemptGrade != 'undefined') {
                    promises.push(_this.quizProvider.getFeedbackForGrade(quiz.id, Number(attemptGrade), true)
                        .then(function (feedback) {
                        if (getInlineFiles && feedback.feedbackinlinefiles && feedback.feedbackinlinefiles.length) {
                            files = files.concat(feedback.feedbackinlinefiles);
                        }
                        else if (feedback.feedbacktext && !getInlineFiles) {
                            files = files.concat(_this.domUtils.extractDownloadableFilesFromHtmlAsFakeFileObjects(feedback.feedbacktext));
                        }
                    }));
                }
            }
        });
        return Promise.all(promises).then(function () {
            return files;
        });
    };
    /**
     * Gather some preflight data for an attempt. This function will start a new attempt if needed.
     *
     * @param {any} quiz Quiz.
     * @param {any} accessInfo Quiz access info returned by AddonModQuizProvider.getQuizAccessInformation.
     * @param {any} [attempt] Attempt to continue. Don't pass any value if the user needs to start a new attempt.
     * @param {boolean} [askPreflight] Whether it should ask for preflight data if needed.
     * @param {string} [modalTitle] Lang key of the title to set to preflight modal (e.g. 'addon.mod_quiz.startattempt').
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the preflight data.
     */
    AddonModQuizPrefetchHandler.prototype.getPreflightData = function (quiz, accessInfo, attempt, askPreflight, title, siteId) {
        var _this = this;
        var preflightData = {};
        var promise;
        if (askPreflight) {
            // We can ask preflight, check if it's needed and get the data.
            promise = this.quizHelper.getAndCheckPreflightData(quiz, accessInfo, preflightData, attempt, false, true, title, siteId);
        }
        else {
            // Get some fixed preflight data from access rules (data that doesn't require user interaction).
            var rules = accessInfo.activerulenames;
            promise = this.accessRuleDelegate.getFixedPreflightData(rules, quiz, preflightData, attempt, true, siteId).then(function () {
                if (!attempt) {
                    // We need to create a new attempt.
                    return _this.quizProvider.startAttempt(quiz.id, preflightData, false, siteId);
                }
            });
        }
        return promise.then(function () {
            return preflightData;
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModQuizPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.quizProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModQuizPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        // Invalidate the calls required to check if a quiz is downloadable.
        var promises = [];
        promises.push(this.quizProvider.invalidateQuizData(courseId));
        promises.push(this.quizProvider.invalidateUserAttemptsForUser(module.instance));
        return Promise.all(promises);
    };
    /**
     * Check if a module can be downloaded. If the function is not defined, we assume that all modules are downloadable.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {boolean|Promise<boolean>} Whether the module can be downloaded. The promise should never be rejected.
     */
    AddonModQuizPrefetchHandler.prototype.isDownloadable = function (module, courseId) {
        var _this = this;
        if (this.sitesProvider.getCurrentSite().isOfflineDisabled()) {
            // Don't allow downloading the quiz if offline is disabled to prevent wasting a lot of data when opening it.
            return false;
        }
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.quizProvider.getQuiz(courseId, module.id, false, false, siteId).then(function (quiz) {
            if (quiz.allowofflineattempts !== 1 || quiz.hasquestions === 0) {
                return false;
            }
            // Not downloadable if we reached max attempts or the quiz has an unfinished attempt.
            return _this.quizProvider.getUserAttempts(quiz.id, undefined, true, false, false, siteId).then(function (attempts) {
                var isLastFinished = !attempts.length || _this.quizProvider.isAttemptFinished(attempts[attempts.length - 1].state);
                return quiz.attempts === 0 || quiz.attempts > attempts.length || !isLastFinished;
            });
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModQuizPrefetchHandler.prototype.isEnabled = function () {
        return this.quizProvider.isPluginEnabled();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @param {boolean} [canStart=true] If true, start a new attempt if needed.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath, canStart) {
        if (canStart === void 0) { canStart = true; }
        if (module.attemptFinished) {
            // Delete the value so it does not block anything if true.
            delete module.attemptFinished;
            // Quiz got synced recently and an attempt has finished. Do not prefetch.
            return Promise.resolve();
        }
        return this.prefetchPackage(module, courseId, single, this.prefetchQuiz.bind(this), undefined, canStart);
    };
    /**
     * Prefetch a quiz.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @param {boolean} canStart If true, start a new attempt if needed.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizPrefetchHandler.prototype.prefetchQuiz = function (module, courseId, single, siteId, canStart) {
        var _this = this;
        var attempts, startAttempt = false, quiz, quizAccessInfo, attemptAccessInfo, preflightData;
        // Get quiz.
        return this.quizProvider.getQuiz(courseId, module.id, false, true, siteId).then(function (quizData) {
            quiz = quizData;
            var promises = [], introFiles = _this.getIntroFilesFromInstance(module, quiz);
            // Prefetch some quiz data.
            promises.push(_this.quizProvider.getQuizAccessInformation(quiz.id, false, true, siteId).then(function (info) {
                quizAccessInfo = info;
            }));
            promises.push(_this.quizProvider.getQuizRequiredQtypes(quiz.id, true, siteId));
            promises.push(_this.quizProvider.getUserAttempts(quiz.id, 'all', true, false, true, siteId).then(function (atts) {
                attempts = atts;
                return _this.getAttemptsFeedbackFiles(quiz, attempts).then(function (attemptFiles) {
                    return _this.filepoolProvider.addFilesToQueue(siteId, attemptFiles, __WEBPACK_IMPORTED_MODULE_11__quiz__["a" /* AddonModQuizProvider */].COMPONENT, module.id);
                });
            }));
            promises.push(_this.quizProvider.getAttemptAccessInformation(quiz.id, 0, false, true, siteId).then(function (info) {
                attemptAccessInfo = info;
            }));
            promises.push(_this.filepoolProvider.addFilesToQueue(siteId, introFiles, __WEBPACK_IMPORTED_MODULE_11__quiz__["a" /* AddonModQuizProvider */].COMPONENT, module.id));
            return Promise.all(promises);
        }).then(function () {
            // Check if we need to start a new attempt.
            var attempt = attempts[attempts.length - 1];
            if (!canStart && !attempt) {
                // No attempts and we won't start a new one, so we don't need preflight data.
                return;
            }
            if (canStart && (!attempt || _this.quizProvider.isAttemptFinished(attempt.state))) {
                // Check if the user can attempt the quiz.
                if (attemptAccessInfo.preventnewattemptreasons.length) {
                    return Promise.reject(_this.textUtils.buildMessage(attemptAccessInfo.preventnewattemptreasons));
                }
                startAttempt = true;
                attempt = undefined;
            }
            // Get the preflight data. This function will also start a new attempt if needed.
            return _this.getPreflightData(quiz, quizAccessInfo, attempt, single, 'core.download', siteId);
        }).then(function (data) {
            preflightData = data;
            var promises = [];
            if (startAttempt) {
                // Re-fetch user attempts since we created a new one.
                promises.push(_this.quizProvider.getUserAttempts(quiz.id, 'all', true, false, true, siteId).then(function (atts) {
                    attempts = atts;
                    return _this.getAttemptsFeedbackFiles(quiz, attempts).then(function (attemptFiles) {
                        return _this.filepoolProvider.addFilesToQueue(siteId, attemptFiles, __WEBPACK_IMPORTED_MODULE_11__quiz__["a" /* AddonModQuizProvider */].COMPONENT, module.id);
                    });
                }));
                // Update the download time to prevent detecting the new attempt as an update.
                promises.push(_this.filepoolProvider.updatePackageDownloadTime(siteId, __WEBPACK_IMPORTED_MODULE_11__quiz__["a" /* AddonModQuizProvider */].COMPONENT, module.id)
                    .catch(function () {
                    // Ignore errors.
                }));
            }
            // Fetch attempt related data.
            promises.push(_this.quizProvider.getCombinedReviewOptions(quiz.id, true, siteId));
            promises.push(_this.quizProvider.getUserBestGrade(quiz.id, true, siteId));
            promises.push(_this.quizProvider.getGradeFromGradebook(courseId, module.id, true, siteId).then(function (gradebookData) {
                if (typeof gradebookData.graderaw != 'undefined') {
                    return _this.quizProvider.getFeedbackForGrade(quiz.id, gradebookData.graderaw, true, siteId);
                }
            }).catch(function () {
                // Ignore errors.
            }));
            promises.push(_this.quizProvider.getAttemptAccessInformation(quiz.id, 0, false, true, siteId)); // Last attempt.
            return Promise.all(promises);
        }).then(function () {
            // We have quiz data, now we'll get specific data for each attempt.
            var promises = [];
            attempts.forEach(function (attempt) {
                promises.push(_this.prefetchAttempt(quiz, attempt, preflightData, siteId));
            });
            return Promise.all(promises);
        }).then(function () {
            if (!canStart) {
                // Nothing else to do.
                return;
            }
            // If there's nothing to send, mark the quiz as synchronized.
            // We don't return the promises because it should be fast and we don't want to block the user for this.
            if (!_this.syncProvider) {
                _this.syncProvider = _this.injector.get(__WEBPACK_IMPORTED_MODULE_14__quiz_sync__["a" /* AddonModQuizSyncProvider */]);
            }
            _this.syncProvider.hasDataToSync(quiz.id, siteId).then(function (hasData) {
                if (!hasData) {
                    _this.syncProvider.setSyncTime(quiz.id, siteId);
                }
            });
        });
    };
    /**
     * Prefetch all WS data for an attempt.
     *
     * @param {any} quiz Quiz.
     * @param {any} attempt Attempt.
     * @param {any} preflightData Preflight required data (like password).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the prefetch is finished. Data returned is not reliable.
     */
    AddonModQuizPrefetchHandler.prototype.prefetchAttempt = function (quiz, attempt, preflightData, siteId) {
        var _this = this;
        var pages = this.quizProvider.getPagesFromLayout(attempt.layout), promises = [], isSequential = this.quizProvider.isNavigationSequential(quiz);
        if (this.quizProvider.isAttemptFinished(attempt.state)) {
            // Attempt is finished, get feedback and review data.
            var attemptGrade = this.quizProvider.rescaleGrade(attempt.sumgrades, quiz, false);
            if (typeof attemptGrade != 'undefined') {
                promises.push(this.quizProvider.getFeedbackForGrade(quiz.id, Number(attemptGrade), true, siteId));
            }
            // Get the review for each page.
            pages.forEach(function (page) {
                promises.push(_this.quizProvider.getAttemptReview(attempt.id, page, true, siteId).catch(function () {
                    // Ignore failures, maybe the user can't review the attempt.
                }));
            });
            // Get the review for all questions in same page.
            promises.push(this.quizProvider.getAttemptReview(attempt.id, -1, true, siteId).then(function (data) {
                // Download the files inside the questions.
                var questionPromises = [];
                data.questions.forEach(function (question) {
                    questionPromises.push(_this.questionHelper.prefetchQuestionFiles(question, _this.component, quiz.coursemodule, siteId, attempt.uniqueid));
                });
                return Promise.all(questionPromises);
            }, function () {
                // Ignore failures, maybe the user can't review the attempt.
            }));
        }
        else {
            // Attempt not finished, get data needed to continue the attempt.
            promises.push(this.quizProvider.getAttemptAccessInformation(quiz.id, attempt.id, false, true, siteId));
            promises.push(this.quizProvider.getAttemptSummary(attempt.id, preflightData, false, true, false, siteId));
            if (attempt.state == __WEBPACK_IMPORTED_MODULE_11__quiz__["a" /* AddonModQuizProvider */].ATTEMPT_IN_PROGRESS) {
                // Get data for each page.
                pages.forEach(function (page) {
                    if (isSequential && page < attempt.currentpage) {
                        // Sequential quiz, cannot get pages before the current one.
                        return;
                    }
                    promises.push(_this.quizProvider.getAttemptData(attempt.id, page, preflightData, false, true, siteId)
                        .then(function (data) {
                        // Download the files inside the questions.
                        var questionPromises = [];
                        data.questions.forEach(function (question) {
                            questionPromises.push(_this.questionHelper.prefetchQuestionFiles(question, _this.component, quiz.coursemodule, siteId, attempt.uniqueid));
                        });
                        return Promise.all(questionPromises);
                    }));
                });
            }
        }
        return Promise.all(promises);
    };
    /**
     * Prefetches some data for a quiz and its last attempt.
     * This function will NOT start a new attempt, it only reads data for the quiz and the last attempt.
     *
     * @param {any} quiz Quiz.
     * @param {boolean} [askPreflight] Whether it should ask for preflight data if needed.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizPrefetchHandler.prototype.prefetchQuizAndLastAttempt = function (quiz, askPreflight, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        var attempts, quizAccessInfo, preflightData, lastAttempt;
        // Get quiz data.
        promises.push(this.quizProvider.getQuizAccessInformation(quiz.id, false, true, siteId).then(function (info) {
            quizAccessInfo = info;
        }));
        promises.push(this.quizProvider.getQuizRequiredQtypes(quiz.id, true, siteId));
        promises.push(this.quizProvider.getCombinedReviewOptions(quiz.id, true, siteId));
        promises.push(this.quizProvider.getUserBestGrade(quiz.id, true, siteId));
        promises.push(this.quizProvider.getUserAttempts(quiz.id, 'all', true, false, true, siteId).then(function (atts) {
            attempts = atts;
        }));
        promises.push(this.quizProvider.getGradeFromGradebook(quiz.course, quiz.coursemodule, true, siteId)
            .then(function (gradebookData) {
            if (typeof gradebookData.graderaw != 'undefined') {
                return _this.quizProvider.getFeedbackForGrade(quiz.id, gradebookData.graderaw, true, siteId);
            }
        }).catch(function () {
            // Ignore errors.
        }));
        promises.push(this.quizProvider.getAttemptAccessInformation(quiz.id, 0, false, true, siteId)); // Last attempt.
        return Promise.all(promises).then(function () {
            lastAttempt = attempts[attempts.length - 1];
            if (!lastAttempt) {
                // No need to get attempt data, we don't need preflight data.
                return;
            }
            // Get the preflight data.
            return _this.getPreflightData(quiz, quizAccessInfo, lastAttempt, askPreflight, 'core.download', siteId);
        }).then(function (data) {
            preflightData = data;
            if (lastAttempt) {
                // Get data for last attempt.
                return _this.prefetchAttempt(quiz, lastAttempt, preflightData, siteId);
            }
        }).then(function () {
            // Prefetch finished, set the right status.
            return _this.setStatusAfterPrefetch(quiz, attempts, true, false, siteId);
        });
    };
    /**
     * Set the right status to a quiz after prefetching.
     * If the last attempt is finished or there isn't one, set it as not downloaded to show download icon.
     *
     * @param {any} quiz Quiz.
     * @param  {any[]} [attempts] List of attempts. If not provided, they will be calculated.
     * @param {boolean} [forceCache] Whether it should always return cached data. Only if attempts is undefined.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down). Only if
     *                                attempts is undefined.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizPrefetchHandler.prototype.setStatusAfterPrefetch = function (quiz, attempts, forceCache, ignoreCache, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        var status;
        if (!attempts) {
            // Get the attempts.
            promises.push(this.quizProvider.getUserAttempts(quiz.id, 'all', true, forceCache, ignoreCache, siteId).then(function (atts) {
                attempts = atts;
            }));
        }
        // Check the current status of the quiz.
        promises.push(this.filepoolProvider.getPackageStatus(siteId, this.component, quiz.coursemodule).then(function (stat) {
            status = stat;
        }));
        return Promise.all(promises).then(function () {
            if (status !== __WEBPACK_IMPORTED_MODULE_15__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
                // Quiz was downloaded, set the new status.
                // If no attempts or last is finished we'll mark it as not downloaded to show download icon.
                var lastAttempt = attempts[attempts.length - 1], isLastFinished = !lastAttempt || _this.quizProvider.isAttemptFinished(lastAttempt.state), newStatus = isLastFinished ? __WEBPACK_IMPORTED_MODULE_15__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED : __WEBPACK_IMPORTED_MODULE_15__core_constants__["a" /* CoreConstants */].DOWNLOADED;
                return _this.filepoolProvider.storePackageStatus(siteId, newStatus, _this.component, quiz.coursemodule);
            }
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        var _this = this;
        if (!this.syncProvider) {
            this.syncProvider = this.injector.get(__WEBPACK_IMPORTED_MODULE_14__quiz_sync__["a" /* AddonModQuizSyncProvider */]);
        }
        return this.quizProvider.getQuiz(courseId, module.id).then(function (quiz) {
            return _this.syncProvider.syncQuiz(quiz, false, siteId).then(function (results) {
                module.attemptFinished = (results && results.attemptFinished) || false;
                return results;
            }).catch(function () {
                // Ignore errors.
                module.attemptFinished = false;
            });
        });
    };
    AddonModQuizPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_11__quiz__["a" /* AddonModQuizProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_12__helper__["a" /* AddonModQuizHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_13__access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_9__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonModQuizPrefetchHandler);
    return AddonModQuizPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 376 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__scorm__ = __webpack_require__(168);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__scorm_sync__ = __webpack_require__(227);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * Handler to prefetch SCORMs.
 */
var AddonModScormPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModScormPrefetchHandler, _super);
    function AddonModScormPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, fileProvider, textUtils, scormProvider, injector) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.fileProvider = fileProvider;
        _this.textUtils = textUtils;
        _this.scormProvider = scormProvider;
        _this.injector = injector;
        _this.name = 'AddonModScorm';
        _this.modName = 'scorm';
        _this.component = __WEBPACK_IMPORTED_MODULE_11__scorm__["a" /* AddonModScormProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^tracks$/;
        return _this;
    }
    /**
     * Download the module.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved when all content is downloaded.
     */
    AddonModScormPrefetchHandler.prototype.download = function (module, courseId, dirPath, onProgress) {
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.prefetchPackage(module, courseId, true, this.downloadOrPrefetchScorm.bind(this), siteId, false, onProgress);
    };
    /**
     * Download or prefetch a SCORM.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @param {boolean} prefetch True to prefetch, false to download right away.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved with the "extra" data to store: the hash of the file.
     */
    AddonModScormPrefetchHandler.prototype.downloadOrPrefetchScorm = function (module, courseId, single, siteId, prefetch, onProgress) {
        var _this = this;
        var scorm;
        return this.scormProvider.getScorm(courseId, module.id, module.url, false, siteId).then(function (scormData) {
            scorm = scormData;
            var promises = [], introFiles = _this.getIntroFilesFromInstance(module, scorm);
            // Download WS data.
            promises.push(_this.fetchWSData(scorm, siteId).catch(function () {
                // If prefetchData fails we don't want to fail the whole download, so we'll ignore the error for now.
                // @todo Implement a warning system so the user knows which SCORMs have failed.
            }));
            // Download the package.
            promises.push(_this.downloadOrPrefetchMainFileIfNeeded(scorm, prefetch, onProgress, siteId));
            // Download intro files.
            promises.push(_this.filepoolProvider.downloadOrPrefetchFiles(siteId, introFiles, prefetch, false, _this.component, module.id).catch(function () {
                // Ignore errors.
            }));
            // Prefetch access information.
            promises.push(_this.scormProvider.getAccessInformation(scorm.id));
            return Promise.all(promises);
        }).then(function () {
            // Success, return the hash.
            return scorm.sha1hash;
        });
    };
    /**
     * Downloads/Prefetches and unzips the SCORM package.
     *
     * @param {any} scorm SCORM object.
     * @param {boolean} [prefetch] True if prefetch, false otherwise.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the file is downloaded and unzipped.
     */
    AddonModScormPrefetchHandler.prototype.downloadOrPrefetchMainFile = function (scorm, prefetch, onProgress, siteId) {
        var _this = this;
        var packageUrl = this.scormProvider.getPackageUrl(scorm);
        var dirPath;
        // Get the folder where the unzipped files will be.
        return this.scormProvider.getScormFolder(scorm.moduleurl).then(function (path) {
            dirPath = path;
            // Notify that the download is starting.
            onProgress && onProgress({ message: 'core.downloading' });
            // Download the ZIP file to the filepool.
            if (prefetch) {
                return _this.filepoolProvider.addToQueueByUrl(siteId, packageUrl, _this.component, scorm.coursemodule, undefined, undefined, _this.downloadProgress.bind(_this, true, onProgress));
            }
            else {
                return _this.filepoolProvider.downloadUrl(siteId, packageUrl, true, _this.component, scorm.coursemodule, undefined, _this.downloadProgress.bind(_this, true, onProgress));
            }
        }).then(function () {
            // Remove the destination folder to prevent having old unused files.
            return _this.fileProvider.removeDir(dirPath).catch(function () {
                // Ignore errors, it might have failed because the folder doesn't exist.
            });
        }).then(function () {
            // Get the ZIP file path.
            return _this.filepoolProvider.getFilePathByUrl(siteId, packageUrl);
        }).then(function (zipPath) {
            // Notify that the unzip is starting.
            onProgress && onProgress({ message: 'core.unzipping' });
            // Unzip and delete the zip when finished.
            return _this.fileProvider.unzipFile(zipPath, dirPath, _this.downloadProgress.bind(_this, false, onProgress)).then(function () {
                return _this.filepoolProvider.removeFileByUrl(siteId, packageUrl).catch(function () {
                    // Ignore errors.
                });
            });
        });
    };
    /**
     * Downloads/Prefetches and unzips the SCORM package if it should be downloaded.
     *
     * @param {any} scorm SCORM object.
     * @param {boolean} [prefetch] True if prefetch, false otherwise.
     * @param {Function} [onProgress] Function to call on progress.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the file is downloaded and unzipped.
     */
    AddonModScormPrefetchHandler.prototype.downloadOrPrefetchMainFileIfNeeded = function (scorm, prefetch, onProgress, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var result = this.scormProvider.isScormUnsupported(scorm);
        if (result) {
            return Promise.reject(this.translate.instant(result));
        }
        // First verify that the file needs to be downloaded.
        // It needs to be checked manually because the ZIP file is deleted after unzipped, so the filepool will always download it.
        return this.scormProvider.shouldDownloadMainFile(scorm, undefined, siteId).then(function (download) {
            if (download) {
                return _this.downloadOrPrefetchMainFile(scorm, prefetch, onProgress, siteId);
            }
        });
    };
    /**
     * Function that converts a regular ProgressEvent into a AddonModScormProgressEvent.
     *
     * @param {Function} [onProgress] Function to call on progress.
     * @param {ProgressEvent} [progress] Event returned by the download function.
     */
    AddonModScormPrefetchHandler.prototype.downloadProgress = function (downloading, onProgress, progress) {
        if (onProgress && progress && progress.loaded) {
            onProgress({
                downloading: downloading,
                progress: progress
            });
        }
    };
    /**
     * Get WS data for SCORM.
     *
     * @param {any} scorm SCORM object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is prefetched.
     */
    AddonModScormPrefetchHandler.prototype.fetchWSData = function (scorm, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        // Prefetch number of attempts (including not completed).
        promises.push(this.scormProvider.getAttemptCountOnline(scorm.id, undefined, true, siteId).catch(function () {
            // If it fails, assume we have no attempts.
            return 0;
        }).then(function (numAttempts) {
            if (numAttempts > 0) {
                // Get user data for each attempt.
                var dataPromises = [];
                var _loop_1 = function (i) {
                    dataPromises.push(_this.scormProvider.getScormUserDataOnline(scorm.id, i, true, siteId).catch(function (err) {
                        // Ignore failures of all the attempts that aren't the last one.
                        if (i == numAttempts) {
                            return Promise.reject(err);
                        }
                    }));
                };
                for (var i = 1; i <= numAttempts; i++) {
                    _loop_1(i);
                }
                return Promise.all(dataPromises);
            }
            else {
                // No attempts. We'll still try to get user data to be able to identify SCOs not visible and so.
                return _this.scormProvider.getScormUserDataOnline(scorm.id, 0, true, siteId);
            }
        }));
        // Prefetch SCOs.
        promises.push(this.scormProvider.getScos(scorm.id, undefined, true, siteId));
        return Promise.all(promises);
    };
    /**
     * Get the download size of a module.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<{size: number, total: boolean}>} Promise resolved with the size and a boolean indicating if it was able
     *                                                   to calculate the total size.
     */
    AddonModScormPrefetchHandler.prototype.getDownloadSize = function (module, courseId, single) {
        var _this = this;
        return this.scormProvider.getScorm(courseId, module.id, module.url).then(function (scorm) {
            if (_this.scormProvider.isScormUnsupported(scorm)) {
                return { size: -1, total: false };
            }
            else if (!scorm.packagesize) {
                // We don't have package size, try to calculate it.
                return _this.scormProvider.calculateScormSize(scorm).then(function (size) {
                    return { size: size, total: true };
                });
            }
            else {
                return { size: scorm.packagesize, total: true };
            }
        });
    };
    /**
     * Get the downloaded size of a module. If not defined, we'll use getFiles to calculate it (it can be slow).
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {number|Promise<number>} Size, or promise resolved with the size.
     */
    AddonModScormPrefetchHandler.prototype.getDownloadedSize = function (module, courseId) {
        var _this = this;
        return this.scormProvider.getScorm(courseId, module.id, module.url).then(function (scorm) {
            // Get the folder where SCORM should be unzipped.
            return _this.scormProvider.getScormFolder(scorm.moduleurl);
        }).then(function (path) {
            return _this.fileProvider.getDirectorySize(path);
        });
    };
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModScormPrefetchHandler.prototype.getFiles = function (module, courseId, single) {
        var _this = this;
        return this.scormProvider.getScorm(courseId, module.id, module.url).then(function (scorm) {
            return _this.scormProvider.getScormFileList(scorm);
        }).catch(function () {
            // SCORM not found, return empty list.
            return [];
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModScormPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.scormProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModScormPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        // Invalidate the calls required to check if a SCORM is downloadable.
        return this.scormProvider.invalidateScormData(courseId);
    };
    /**
     * Check if a module can be downloaded. If the function is not defined, we assume that all modules are downloadable.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {boolean|Promise<boolean>} Whether the module can be downloaded. The promise should never be rejected.
     */
    AddonModScormPrefetchHandler.prototype.isDownloadable = function (module, courseId) {
        var _this = this;
        return this.scormProvider.getScorm(courseId, module.id, module.url).then(function (scorm) {
            if (scorm.warningMessage) {
                // SCORM closed or not opened yet.
                return false;
            }
            if (_this.scormProvider.isScormUnsupported(scorm)) {
                return false;
            }
            return true;
        });
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @param {Function} [onProgress] Function to call on progress.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath, onProgress) {
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.prefetchPackage(module, courseId, single, this.downloadOrPrefetchScorm.bind(this), siteId, true, onProgress);
    };
    /**
     * Remove module downloaded files. If not defined, we'll use getFiles to remove them (slow).
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormPrefetchHandler.prototype.removeFiles = function (module, courseId) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        var scorm;
        return this.scormProvider.getScorm(courseId, module.id, module.url, false, siteId).then(function (scormData) {
            scorm = scormData;
            // Get the folder where SCORM should be unzipped.
            return _this.scormProvider.getScormFolder(scorm.moduleurl);
        }).then(function (path) {
            var promises = [];
            // Remove the unzipped folder.
            promises.push(_this.fileProvider.removeDir(path).catch(function (error) {
                if (error && error.code == 1) {
                    // Not found, ignore error.
                }
                else {
                    return Promise.reject(error);
                }
            }));
            // Maybe the ZIP wasn't deleted for some reason. Try to delete it too.
            promises.push(_this.filepoolProvider.removeFileByUrl(siteId, _this.scormProvider.getPackageUrl(scorm)).catch(function () {
                // Ignore errors.
            }));
            return Promise.all(promises);
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        var _this = this;
        if (!this.syncProvider) {
            this.syncProvider = this.injector.get(__WEBPACK_IMPORTED_MODULE_12__scorm_sync__["a" /* AddonModScormSyncProvider */]);
        }
        return this.scormProvider.getScorm(courseId, module.id, module.url, false, siteId).then(function (scorm) {
            return _this.syncProvider.syncScorm(scorm, siteId);
        });
    };
    AddonModScormPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__scorm__["a" /* AddonModScormProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonModScormPrefetchHandler);
    return AddonModScormPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 377 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Service that provides helper functions for surveys.
 */
var AddonModSurveyHelperProvider = /** @class */ (function () {
    function AddonModSurveyHelperProvider(translate) {
        this.translate = translate;
    }
    /**
     * Turns a string with values separated by commas into an array.
     *
     * @param {any} value Value to convert.
     * @return {string[]}    Array.
     */
    AddonModSurveyHelperProvider.prototype.commaStringToArray = function (value) {
        if (typeof value == 'string') {
            if (value.length > 0) {
                return value.split(',');
            }
            return [];
        }
        return value;
    };
    /**
     * Gets the parent questions and puts them in an object: ID -> question.
     *
     * @param {Object[]} questions Questions.
     * @return {any}            Object with parent questions.
     */
    AddonModSurveyHelperProvider.prototype.getParentQuestions = function (questions) {
        var parents = {};
        questions.forEach(function (question) {
            if (question.parent === 0) {
                parents[question.id] = question;
            }
        });
        return parents;
    };
    /**
     * Format a questions list, turning "multi" and "options" strings into arrays and adding the properties
     * 'num' and 'name'.
     *
     * @param {any[]} questions Questions.
     * @return {any[]}           Promise resolved with the formatted questions.
     */
    AddonModSurveyHelperProvider.prototype.formatQuestions = function (questions) {
        var _this = this;
        var strIPreferThat = this.translate.instant('addon.mod_survey.ipreferthat'), strIFoundThat = this.translate.instant('addon.mod_survey.ifoundthat'), strChoose = this.translate.instant('core.choose'), formatted = [], parents = this.getParentQuestions(questions);
        var num = 1;
        questions.forEach(function (question) {
            // Copy the object to prevent modifying the original.
            var q1 = Object.assign({}, question), parent = parents[q1.parent];
            // Turn multi and options into arrays.
            q1.multi = _this.commaStringToArray(q1.multi);
            q1.options = _this.commaStringToArray(q1.options);
            if (parent) {
                // It's a sub-question.
                q1.required = true;
                if (parent.type === 1 || parent.type === 2) {
                    // One answer question. Set its name and add it to the returned array.
                    q1.name = 'q' + (parent.type == 2 ? 'P' : '') + q1.id;
                    q1.num = num++;
                }
                else {
                    // Two answers per question (COLLES P&A). We'll add two questions.
                    var q2 = Object.assign({}, q1);
                    q1.text = strIPreferThat + ' ' + q1.text;
                    q1.name = 'qP' + q1.id;
                    q1.num = num++;
                    formatted.push(q1);
                    q2.text = strIFoundThat + ' ' + q2.text;
                    q2.name = 'q' + q1.id;
                    q2.num = num++;
                    formatted.push(q2);
                    return;
                }
            }
            else if (q1.multi && q1.multi.length === 0) {
                // It's a single question.
                q1.name = 'q' + q1.id;
                q1.num = num++;
                if (q1.type > 0) {
                    q1.options.unshift(strChoose);
                }
            }
            formatted.push(q1);
        });
        return formatted;
    };
    AddonModSurveyHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModSurveyHelperProvider);
    return AddonModSurveyHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 378 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModUrlProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service that provides some features for urls.
 */
var AddonModUrlProvider = /** @class */ (function () {
    function AddonModUrlProvider(logger, sitesProvider, courseProvider, utils, mimeUtils, logHelper) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.utils = utils;
        this.mimeUtils = mimeUtils;
        this.logHelper = logHelper;
        this.ROOT_CACHE_KEY = 'mmaModUrl:';
        this.logger = logger.getInstance('AddonModUrlProvider');
    }
    AddonModUrlProvider_1 = AddonModUrlProvider;
    /**
     * Get the final display type for a certain URL. Based on Moodle's url_get_final_display_type.
     *
     * @param {any} url URL data.
     * @return {number} Final display type.
     */
    AddonModUrlProvider.prototype.getFinalDisplayType = function (url) {
        if (!url) {
            return -1;
        }
        var extension = this.mimeUtils.guessExtensionFromUrl(url.externalurl);
        // PDFs can be embedded in web, but not in the Mobile app.
        if (url.display == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_EMBED && extension == 'pdf') {
            return __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_DOWNLOAD;
        }
        if (url.display != __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_AUTO) {
            return url.display;
        }
        // Detect links to local moodle pages.
        var currentSite = this.sitesProvider.getCurrentSite();
        if (currentSite && currentSite.containsUrl(url.externalurl)) {
            if (url.externalurl.indexOf('file.php') == -1 && url.externalurl.indexOf('.php') != -1) {
                // Most probably our moodle page with navigation.
                return __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_OPEN;
            }
        }
        var download = ['application/zip', 'application/x-tar', 'application/g-zip', 'application/pdf', 'text/html'];
        var mimetype = this.mimeUtils.getMimeType(extension);
        if (url.externalurl.indexOf('.php') != -1 || url.externalurl.substr(-1) === '/' ||
            (url.externalurl.indexOf('//') != -1 && url.externalurl.match(/\//g).length == 2)) {
            // Seems to be a web, use HTML mimetype.
            mimetype = 'text/html';
        }
        if (download.indexOf(mimetype) != -1) {
            return __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_DOWNLOAD;
        }
        if (this.mimeUtils.canBeEmbedded(extension)) {
            return __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_EMBED;
        }
        // Let the browser deal with it somehow.
        return __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_OPEN;
    };
    /**
     * Get cache key for url data WS calls.
     *
     * @param {number} courseId Course ID.
     * @return {string}         Cache key.
     */
    AddonModUrlProvider.prototype.getUrlCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'url:' + courseId;
    };
    /**
     * Get a url data.
     *
     * @param {number} courseId Course ID.
     * @param {string} key     Name of the property to check.
     * @param {any}  value   Value to search.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the url is retrieved.
     */
    AddonModUrlProvider.prototype.getUrlDataByKey = function (courseId, key, value, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getUrlCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_8__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('mod_url_get_urls_by_courses', params, preSets).then(function (response) {
                if (response && response.urls) {
                    var currentUrl = response.urls.find(function (url) {
                        return url[key] == value;
                    });
                    if (currentUrl) {
                        return currentUrl;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a url by course module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId     Course module ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the url is retrieved.
     */
    AddonModUrlProvider.prototype.getUrl = function (courseId, cmId, siteId) {
        return this.getUrlDataByKey(courseId, 'coursemodule', cmId, siteId);
    };
    /**
     * Guess the icon for a certain URL. Based on Moodle's url_guess_icon.
     *
     * @param {string} url URL to check.
     * @return {string} Icon, empty if it should use the default icon.
     */
    AddonModUrlProvider.prototype.guessIcon = function (url) {
        url = url || '';
        var matches = url.match(/\//g), extension = this.mimeUtils.getFileExtension(url);
        if (!matches || matches.length < 3 || url.substr(-1) === '/' || extension == 'php') {
            // Use default icon.
            return '';
        }
        var icon = this.mimeUtils.getFileIcon(url);
        // We do not want to return those icon types, the module icon is more appropriate.
        if (icon === this.mimeUtils.getFileIconForType('unknown') || icon === this.mimeUtils.getFileIconForType('html')) {
            return '';
        }
        return icon;
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID of the module.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the data is invalidated.
     */
    AddonModUrlProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.invalidateUrlData(courseId, siteId));
        promises.push(this.courseProvider.invalidateModule(moduleId, siteId, 'url'));
        return this.utils.allPromises(promises);
    };
    /**
     * Invalidates url data.
     *
     * @param {number} courseid Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}   Promise resolved when the data is invalidated.
     */
    AddonModUrlProvider.prototype.invalidateUrlData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUrlCacheKey(courseId));
        });
    };
    /**
     * Returns whether or not getUrl WS available or not.
     *
     * @return {boolean} If WS is abalaible.
     * @since 3.3
     */
    AddonModUrlProvider.prototype.isGetUrlWSAvailable = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('mod_url_get_urls_by_courses');
    };
    /**
     * Report the url as being viewed.
     *
     * @param {number} id Module ID.
     * @param {string} [name] Name of the assign.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}  Promise resolved when the WS call is successful.
     */
    AddonModUrlProvider.prototype.logView = function (id, name, siteId) {
        var params = {
            urlid: id
        };
        return this.logHelper.logSingle('mod_url_view_url', params, AddonModUrlProvider_1.COMPONENT, id, name, 'url', {}, siteId);
    };
    AddonModUrlProvider.COMPONENT = 'mmaModUrl';
    AddonModUrlProvider = AddonModUrlProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_course_providers_log_helper__["a" /* CoreCourseLogHelperProvider */]])
    ], AddonModUrlProvider);
    return AddonModUrlProvider;
    var AddonModUrlProvider_1;
}());

//# sourceMappingURL=url.js.map

/***/ }),
/* 379 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModUrlHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Service that provides helper functions for urls.
 */
var AddonModUrlHelperProvider = /** @class */ (function () {
    function AddonModUrlHelperProvider(sitesProvider, domUtils, contentLinksHelper, utils, platform, app) {
        this.sitesProvider = sitesProvider;
        this.domUtils = domUtils;
        this.contentLinksHelper = contentLinksHelper;
        this.utils = utils;
        this.platform = platform;
        this.app = app;
    }
    /**
     * Opens a URL.
     *
     * @param {string} url The URL to go to.
     */
    AddonModUrlHelperProvider.prototype.open = function (url) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        this.contentLinksHelper.handleLink(url, undefined, undefined, true, true).then(function (treated) {
            console.log('url1234' + url);
            // this.navCtrl.push('OucshowpdfPage',{
            //     displayData:url
            // });
            if (!treated) {
                if (_this.platform.is('android') && (url.endsWith('doc') || url.endsWith('docx') || url.endsWith('xls'))) {
                    _this.utils.openOnlineFile(url);
                }
                else if (_this.platform.is('android') && url.endsWith('pdf')) {
                    _this.app.getActiveNav().push('OucshowpdfPage', {
                        displayData: url
                    });
                }
                else {
                    return _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(url);
                }
            }
        }).finally(function () {
            modal.dismiss();
        });
    };
    AddonModUrlHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_4_ionic_angular__["c" /* App */]])
    ], AddonModUrlHelperProvider);
    return AddonModUrlHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 380 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesOfflineProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service to handle offline notes.
 */
var AddonNotesOfflineProvider = /** @class */ (function () {
    function AddonNotesOfflineProvider(logger, sitesProvider, timeUtils) {
        this.sitesProvider = sitesProvider;
        this.timeUtils = timeUtils;
        this.siteSchema = {
            name: 'AddonNotesOfflineProvider',
            version: 1,
            tables: [
                {
                    name: AddonNotesOfflineProvider_1.NOTES_TABLE,
                    columns: [
                        {
                            name: 'userid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'courseid',
                            type: 'INTEGER'
                        },
                        {
                            name: 'publishstate',
                            type: 'TEXT',
                        },
                        {
                            name: 'content',
                            type: 'TEXT'
                        },
                        {
                            name: 'format',
                            type: 'INTEGER'
                        },
                        {
                            name: 'created',
                            type: 'INTEGER'
                        },
                        {
                            name: 'lastmodified',
                            type: 'INTEGER'
                        }
                    ],
                    primaryKeys: ['userid', 'content', 'created']
                }
            ]
        };
        this.logger = logger.getInstance('AddonNotesOfflineProvider');
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonNotesOfflineProvider_1 = AddonNotesOfflineProvider;
    /**
     * Delete a note.
     *
     * @param  {number} userId      User ID the note is about.
     * @param  {string} content     The note content.
     * @param  {number} timecreated The time the note was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved if deleted, rejected if failure.
     */
    AddonNotesOfflineProvider.prototype.deleteNote = function (userId, content, timecreated, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonNotesOfflineProvider_1.NOTES_TABLE, {
                userid: userId,
                content: content,
                created: timecreated
            });
        });
    };
    /**
     * Get all offline notes.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved with notes.
     */
    AddonNotesOfflineProvider.prototype.getAllNotes = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonNotesOfflineProvider_1.NOTES_TABLE);
        });
    };
    /**
     * Get an offline note.
     *
     * @param  {number} userId      User ID the note is about.
     * @param  {string} content     The note content.
     * @param  {number} timecreated The time the note was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved with the notes.
     */
    AddonNotesOfflineProvider.prototype.getNote = function (userId, content, timecreated, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonNotesOfflineProvider_1.NOTES_TABLE, {
                userid: userId,
                content: content,
                created: timecreated
            });
        });
    };
    /**
     * Get offline notes for a certain course and user.
     *
     * @param  {number} courseId Course ID.
     * @param  {number} [userId] User ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with notes.
     */
    AddonNotesOfflineProvider.prototype.getNotesForCourseAndUser = function (courseId, userId, siteId) {
        if (!userId) {
            return this.getNotesForCourse(courseId, siteId);
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonNotesOfflineProvider_1.NOTES_TABLE, { userid: userId, courseid: courseId });
        });
    };
    /**
     * Get offline notes for a certain course.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with notes.
     */
    AddonNotesOfflineProvider.prototype.getNotesForCourse = function (courseId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonNotesOfflineProvider_1.NOTES_TABLE, { courseid: courseId });
        });
    };
    /**
     * Get offline notes for a certain user.
     *
     * @param  {number} userId   User ID the notes are about.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with notes.
     */
    AddonNotesOfflineProvider.prototype.getNotesForUser = function (userId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonNotesOfflineProvider_1.NOTES_TABLE, { userid: userId });
        });
    };
    /**
     * Get offline notes with a certain publish state (Personal, Site or Course).
     *
     * @param  {string} state    Publish state ('personal', 'site' or 'course').
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>}  Promise resolved with notes.
     */
    AddonNotesOfflineProvider.prototype.getNotesWithPublishState = function (state, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecords(AddonNotesOfflineProvider_1.NOTES_TABLE, { publishstate: state });
        });
    };
    /**
     * Check if there are offline notes for a certain course.
     *
     * @param  {number} courseId  Course ID.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if has offline notes, false otherwise.
     */
    AddonNotesOfflineProvider.prototype.hasNotesForCourse = function (courseId, siteId) {
        return this.getNotesForCourse(courseId, siteId).then(function (notes) {
            return !!notes.length;
        });
    };
    /**
     * Check if there are offline notes for a certain user.
     *
     * @param  {number} userId    User ID the notes are about.
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if has offline notes, false otherwise.
     */
    AddonNotesOfflineProvider.prototype.hasNotesForUser = function (userId, siteId) {
        return this.getNotesForUser(userId, siteId).then(function (notes) {
            return !!notes.length;
        });
    };
    /**
     * Check if there are offline notes with a certain publish state (Personal, Site or Course).
     *
     * @param  {string} state     Publish state ('personal', 'site' or 'course').
     * @param  {string} [siteId]  Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: true if has offline notes, false otherwise.
     */
    AddonNotesOfflineProvider.prototype.hasNotesWithPublishState = function (state, siteId) {
        return this.getNotesWithPublishState(state, siteId).then(function (notes) {
            return !!notes.length;
        });
    };
    /**
     * Save a note to be sent later.
     *
     * @param  {number} userId   User ID the note is about.
     * @param  {number} courseId Course ID.
     * @param  {string} state    Publish state ('personal', 'site' or 'course').
     * @param  {string} content  The note content.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if stored, rejected if failure.
     */
    AddonNotesOfflineProvider.prototype.saveNote = function (userId, courseId, state, content, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var now = _this.timeUtils.timestamp();
            var data = {
                userid: userId,
                courseid: courseId,
                publishstate: state,
                content: content,
                format: 1,
                created: now,
                lastmodified: now
            };
            return site.getDb().insertRecord(AddonNotesOfflineProvider_1.NOTES_TABLE, data).then(function () {
                return data;
            });
        });
    };
    // Variables for database.
    AddonNotesOfflineProvider.NOTES_TABLE = 'addon_notes_offline_notes';
    AddonNotesOfflineProvider = AddonNotesOfflineProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonNotesOfflineProvider);
    return AddonNotesOfflineProvider;
    var AddonNotesOfflineProvider_1;
}());

//# sourceMappingURL=notes-offline.js.map

/***/ }),
/* 381 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__notes_offline__ = __webpack_require__(380);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__notes__ = __webpack_require__(190);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_sync__ = __webpack_require__(46);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Service to sync notes.
 */
var AddonNotesSyncProvider = /** @class */ (function (_super) {
    __extends(AddonNotesSyncProvider, _super);
    function AddonNotesSyncProvider(loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, notesOffline, utils, eventsProvider, notesProvider, coursesProvider, timeUtils) {
        var _this = _super.call(this, 'AddonNotesSync', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.notesOffline = notesOffline;
        _this.utils = utils;
        _this.eventsProvider = eventsProvider;
        _this.notesProvider = notesProvider;
        _this.coursesProvider = coursesProvider;
        return _this;
    }
    AddonNotesSyncProvider_1 = AddonNotesSyncProvider;
    /**
     * Try to synchronize all the notes in a certain site or in all sites.
     *
     * @param  {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [force] Wether to force sync not depending on last execution.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonNotesSyncProvider.prototype.syncAllNotes = function (siteId, force) {
        return this.syncOnSites('all notes', this.syncAllNotesFunc.bind(this), [force], siteId);
    };
    /**
     * Synchronize all the notes in a certain site
     *
     * @param  {string} siteId Site ID to sync.
     * @param  {boolean} force Wether to force sync not depending on last execution.
     * @return {Promise<any>}  Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonNotesSyncProvider.prototype.syncAllNotesFunc = function (siteId, force) {
        var _this = this;
        return this.notesOffline.getAllNotes(siteId).then(function (notes) {
            // Get all the courses to be synced.
            var courseIds = [];
            notes.forEach(function (note) {
                if (courseIds.indexOf(note.courseid) == -1) {
                    courseIds.push(note.courseid);
                }
            });
            // Sync all courses.
            var promises = courseIds.map(function (courseId) {
                var promise = force ? _this.syncNotes(courseId, siteId) : _this.syncNotesIfNeeded(courseId, siteId);
                return promise.then(function (warnings) {
                    if (typeof warnings != 'undefined') {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonNotesSyncProvider_1.AUTO_SYNCED, {
                            courseId: courseId,
                            warnings: warnings
                        }, siteId);
                    }
                });
            });
            return Promise.all(promises);
        });
    };
    /**
     * Sync course notes only if a certain time has passed since the last time.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved when the notes are synced or if they don't need to be synced.
     */
    AddonNotesSyncProvider.prototype.syncNotesIfNeeded = function (courseId, siteId) {
        var _this = this;
        return this.isSyncNeeded(courseId, siteId).then(function (needed) {
            if (needed) {
                return _this.syncNotes(courseId, siteId);
            }
        });
    };
    /**
     * Synchronize notes of a course.
     *
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}    Promise resolved if sync is successful, rejected otherwise.
     */
    AddonNotesSyncProvider.prototype.syncNotes = function (courseId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.isSyncing(courseId, siteId)) {
            // There's already a sync ongoing for notes, return the promise.
            return this.getOngoingSync(courseId, siteId);
        }
        this.logger.debug('Try to sync notes for course ' + courseId);
        var warnings = [];
        // Get offline notes to be sent.
        var syncPromise = this.notesOffline.getNotesForCourse(courseId, siteId).then(function (notes) {
            if (!notes.length) {
                // Nothing to sync.
                return;
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline.
                return Promise.reject(_this.translate.instant('core.networkerrormsg'));
            }
            var errors = [];
            // Format the notes to be sent.
            var notesToSend = notes.map(function (note) {
                return {
                    userid: note.userid,
                    publishstate: note.publishstate,
                    courseid: note.courseid,
                    text: note.content,
                    format: note.format
                };
            });
            // Send the notes.
            return _this.notesProvider.addNotesOnline(notesToSend, siteId).then(function (response) {
                // Search errors in the response.
                response.forEach(function (entry) {
                    if (entry.noteid === -1 && errors.indexOf(entry.errormessage) == -1) {
                        errors.push(entry.errormessage);
                    }
                });
                // Fetch the notes from server to be sure they're up to date.
                return _this.notesProvider.invalidateNotes(courseId, undefined, siteId).then(function () {
                    return _this.notesProvider.getNotes(courseId, undefined, false, true, siteId);
                }).catch(function () {
                    // Ignore errors.
                });
            }).catch(function (error) {
                if (_this.utils.isWebServiceError(error)) {
                    // It's a WebService error, this means the user cannot send notes.
                    errors.push(error);
                }
                else {
                    // Not a WebService error, reject the synchronization to try again.
                    return Promise.reject(error);
                }
            }).then(function () {
                // Notes were sent, delete them from local DB.
                var promises = notes.map(function (note) {
                    return _this.notesOffline.deleteNote(note.userid, note.content, note.created, siteId);
                });
                return Promise.all(promises);
            }).then(function () {
                if (errors && errors.length) {
                    // At least an error occurred, get course name and add errors to warnings array.
                    return _this.coursesProvider.getUserCourse(courseId, true, siteId).catch(function () {
                        // Ignore errors.
                        return {};
                    }).then(function (course) {
                        errors.forEach(function (error) {
                            warnings.push(_this.translate.instant('addon.notes.warningnotenotsent', {
                                course: course.fullname ? course.fullname : courseId,
                                error: error
                            }));
                        });
                    });
                }
            });
        }).then(function () {
            // All done, return the warnings.
            return warnings;
        });
        return this.addOngoingSync(courseId, syncPromise, siteId);
    };
    AddonNotesSyncProvider.AUTO_SYNCED = 'addon_notes_autom_synced';
    AddonNotesSyncProvider = AddonNotesSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_5__notes_offline__["a" /* AddonNotesOfflineProvider */], __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_6__notes__["a" /* AddonNotesProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonNotesSyncProvider);
    return AddonNotesSyncProvider;
    var AddonNotesSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_3__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=notes-sync.js.map

/***/ }),
/* 382 */,
/* 383 */,
/* 384 */,
/* 385 */,
/* 386 */,
/* 387 */,
/* 388 */,
/* 389 */,
/* 390 */,
/* 391 */,
/* 392 */,
/* 393 */,
/* 394 */,
/* 395 */,
/* 396 */,
/* 397 */,
/* 398 */,
/* 399 */,
/* 400 */,
/* 401 */,
/* 402 */,
/* 403 */,
/* 404 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourDeferredCBMComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Component to render the deferred CBM in a question.
 */
var AddonQbehaviourDeferredCBMComponent = /** @class */ (function () {
    function AddonQbehaviourDeferredCBMComponent() {
        // Nothing to do.
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonQbehaviourDeferredCBMComponent.prototype, "question", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonQbehaviourDeferredCBMComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonQbehaviourDeferredCBMComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonQbehaviourDeferredCBMComponent.prototype, "attemptId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonQbehaviourDeferredCBMComponent.prototype, "offlineEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonQbehaviourDeferredCBMComponent.prototype, "buttonClicked", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonQbehaviourDeferredCBMComponent.prototype, "onAbort", void 0);
    AddonQbehaviourDeferredCBMComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qbehaviour-deferredcbm',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qbehaviour\deferredcbm\component\addon-qbehaviour-deferredcbm.html"*/'<div *ngIf="question.behaviourCertaintyOptions && question.behaviourCertaintyOptions.length">\n    <ion-item text-wrap class="addon-qbehaviour-deferredcbm-certainty-title" >\n        <p>{{ \'core.question.certainty\' | translate }}</p>\n    </ion-item>\n    <div radio-group [(ngModel)]="question.behaviourCertaintySelected" [name]="question.behaviourCertaintyOptions[0].name">\n        <ion-item text-wrap *ngFor="let option of question.behaviourCertaintyOptions">\n            <ion-label>\n                <core-format-text [component]="component" [componentId]="componentId" [text]="option.text"></core-format-text>\n            </ion-label>\n            <ion-radio id="{{option.id}}" [value]="option.value" [disabled]="option.disabled"></ion-radio>\n        </ion-item>\n    </div>\n\n    <!-- ion-radio doesn\'t use an input. Create a hidden input to hold the selected value. -->\n    <input type="hidden" [ngModel]="question.behaviourCertaintySelected" [attr.name]="question.behaviourCertaintyOptions[0].name">\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qbehaviour\deferredcbm\component\addon-qbehaviour-deferredcbm.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], AddonQbehaviourDeferredCBMComponent);
    return AddonQbehaviourDeferredCBMComponent;
}());

//# sourceMappingURL=deferredcbm.js.map

/***/ }),
/* 405 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeCalculatedHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_calculated__ = __webpack_require__(406);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support calculated question type.
 */
var AddonQtypeCalculatedHandler = /** @class */ (function () {
    function AddonQtypeCalculatedHandler(utils, domUtils) {
        this.utils = utils;
        this.domUtils = domUtils;
        this.name = 'AddonQtypeCalculated';
        this.type = 'qtype_calculated';
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeCalculatedHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_3__component_calculated__["a" /* AddonQtypeCalculatedComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeCalculatedHandler.prototype.isCompleteResponse = function (question, answers) {
        if (this.isGradableResponse(question, answers) === 0 || !this.validateUnits(answers['answer'])) {
            return 0;
        }
        if (this.requiresUnits(question)) {
            return this.isValidValue(answers['unit']) ? 1 : 0;
        }
        return -1;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeCalculatedHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeCalculatedHandler.prototype.isGradableResponse = function (question, answers) {
        var isGradable = this.isValidValue(answers['answer']);
        if (isGradable && this.requiresUnits(question)) {
            // The question requires a unit.
            isGradable = this.isValidValue(answers['unit']);
        }
        return isGradable ? 1 : 0;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeCalculatedHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, 'answer') &&
            this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, 'unit');
    };
    /**
     * Check if a value is valid (not empty).
     *
     * @param {string|number} value Value to check.
     * @return {boolean} Whether the value is valid.
     */
    AddonQtypeCalculatedHandler.prototype.isValidValue = function (value) {
        return !!value || value === '0' || value === 0;
    };
    /**
     * Check if a question requires units in a separate input.
     *
     * @param {any} question The question.
     * @return {boolean} Whether the question requires units.
     */
    AddonQtypeCalculatedHandler.prototype.requiresUnits = function (question) {
        var element = this.domUtils.convertToElement(question.html);
        return !!(element.querySelector('select[name*=unit]') || element.querySelector('input[type="radio"]'));
    };
    /**
     * Validate a number with units. We don't have the list of valid units and conversions, so we can't perform
     * a full validation. If this function returns true it means we can't be sure it's valid.
     *
     * @param {string} answer Answer.
     * @return {boolean} False if answer isn't valid, true if we aren't sure if it's valid.
     */
    AddonQtypeCalculatedHandler.prototype.validateUnits = function (answer) {
        if (!answer) {
            return false;
        }
        var regexString = '[+-]?(?:\\d+(?:\\.\\d*)?|\\.\\d+)(?:e[-+]?\\d+)?';
        // Strip spaces (which may be thousands separators) and change other forms of writing e to e.
        answer = answer.replace(' ', '');
        answer = answer.replace(/(?:e|E|(?:x|\*|×)10(?:\^|\*\*))([+-]?\d+)/, 'e$1');
        // If a '.' is present or there are multiple ',' (i.e. 2,456,789) assume ',' is a thousands separator and stip it.
        // Else assume it is a decimal separator, and change it to '.'.
        if (answer.indexOf('.') != -1 || answer.split(',').length - 1 > 1) {
            answer = answer.replace(',', '');
        }
        else {
            answer = answer.replace(',', '.');
        }
        // We don't know if units should be before or after so we check both.
        if (answer.match(new RegExp('^' + regexString)) === null || answer.match(new RegExp(regexString + '$')) === null) {
            return false;
        }
        return true;
    };
    AddonQtypeCalculatedHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonQtypeCalculatedHandler);
    return AddonQtypeCalculatedHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 406 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeCalculatedComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to render a calculated question.
 */
var AddonQtypeCalculatedComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeCalculatedComponent, _super);
    function AddonQtypeCalculatedComponent(logger, injector) {
        return _super.call(this, logger, 'AddonQtypeCalculatedComponent', injector) || this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeCalculatedComponent.prototype.ngOnInit = function () {
        this.initCalculatedComponent();
    };
    AddonQtypeCalculatedComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-calculated',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\calculated\component\addon-qtype-calculated.html"*/'<section ion-list class="addon-qtype-calculated-container" *ngIf="question.text || question.text === \'\'">\n    <ion-item text-wrap>\n        <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.text"></core-format-text></p>\n    </ion-item>\n\n    <!-- Display unit options before the answer input. -->\n    <ng-container *ngIf="question.options && question.options.length && question.optionsFirst">\n        <ng-container *ngTemplateOutlet="radioUnits"></ng-container>\n    </ng-container>\n\n    <ion-item text-wrap ion-grid ngClass="core-{{question.input.correctIconColor}}-item">\n        <ion-label stacked>{{ \'addon.mod_quiz.answercolon\' | translate }}</ion-label>\n        <ion-grid item-content no-padding>\n            <ion-row>\n                <!-- Display unit select before the answer input. -->\n                <ng-container *ngIf="question.select && question.selectFirst">\n                    <ng-container *ngTemplateOutlet="selectUnits"></ng-container>\n                </ng-container>\n\n                <!-- Input to enter the answer. -->\n                <ion-col>\n                    <ion-input padding-left type="text" [placeholder]="question.input.readOnly ? \'\' : \'core.question.answer\' | translate" [attr.name]="question.input.name" [value]="question.input.value" [disabled]="question.input.readOnly" autocorrect="off">\n                    </ion-input>\n                </ion-col>\n\n                <!-- Display unit select after the answer input. -->\n                <ng-container *ngIf="question.select && !question.selectFirst">\n                    <ng-container *ngTemplateOutlet="selectUnits"></ng-container>\n                </ng-container>\n            </ion-row>\n            <core-icon *ngIf="question.input.correctIcon" class="core-correct-icon" item-content item-end [name]="question.input.correctIcon" [color]="[question.input.correctIconColor]"></core-icon>\n        </ion-grid>\n    </ion-item>\n\n    <!-- Display unit options after the answer input. -->\n    <ng-container *ngIf="question.options && question.options.length && !question.optionsFirst">\n        <ng-container *ngTemplateOutlet="radioUnits"></ng-container>\n    </ng-container>\n</section>\n\n<!-- Template for units entered using a select. -->\n<ng-template #selectUnits>\n    <ion-col>\n        <label *ngIf="question.select.accessibilityLabel" class="accesshide" for="{{question.select.id}}">{{ question.select.accessibilityLabel }}</label>\n        <ion-select id="{{question.select.id}}" [name]="question.select.name" [(ngModel)]="question.select.selected" interface="action-sheet" [disabled]="question.select.disabled">\n            <ion-option *ngFor="let option of question.select.options" [value]="option.value">{{option.label}}</ion-option>\n        </ion-select>\n\n        <!-- ion-select doesn\'t use a select. Create a hidden input to hold the selected value. -->\n        <input type="hidden" [ngModel]="question.select.selected" [attr.name]="question.select.name">\n    </ion-col>\n</ng-template>\n\n<!-- Template for units entered using radio buttons. -->\n<ng-template #radioUnits>\n    <div radio-group [(ngModel)]="question.unit" [name]="question.optionsName">\n        <ion-item text-wrap *ngFor="let option of question.options">\n            <ion-label>\n                <core-format-text [component]="component" [componentId]="componentId" [text]="option.text"></core-format-text>\n            </ion-label>\n            <ion-radio [value]="option.value" [disabled]="option.disabled || question.input.readOnly" [color]="question.input.correctIconColor"></ion-radio>\n        </ion-item>\n\n        <!-- ion-radio doesn\'t use an input. Create a hidden input to hold the selected value. -->\n        <input type="hidden" [ngModel]="question.unit" [attr.name]="question.optionsName">\n    </div>\n</ng-template>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\calculated\component\addon-qtype-calculated.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonQtypeCalculatedComponent);
    return AddonQtypeCalculatedComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=calculated.js.map

/***/ }),
/* 407 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMatchComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to render a match question.
 */
var AddonQtypeMatchComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeMatchComponent, _super);
    function AddonQtypeMatchComponent(logger, injector) {
        return _super.call(this, logger, 'AddonQtypeMatchComponent', injector) || this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeMatchComponent.prototype.ngOnInit = function () {
        this.initMatchComponent();
    };
    AddonQtypeMatchComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-match',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\match\component\addon-qtype-match.html"*/'<section ion-list class="addon-qtype-match-container" *ngIf="question.loaded">\n    <ion-item text-wrap>\n        <core-format-text [component]="component" [componentId]="componentId" [text]="question.text"></core-format-text>\n    </ion-item>\n    <ion-item text-wrap *ngFor="let row of question.rows">\n        <ion-grid item-content no-margin no-padding>\n            <ion-row no-margin>\n                <ion-col>\n                    <p><core-format-text id="addon-qtype-match-question-{{row.id}}" [component]="component" [componentId]="componentId" [text]="row.text"></core-format-text></p>\n                </ion-col>\n                <ion-col>\n                    <label class="accesshide" for="{{row.id}}" *ngIf="row.accessibilityLabel">{{ row.accessibilityLabel }}</label>\n                    <ion-select id="{{row.id}}" [name]="row.name" [attr.aria-labelledby]="\'addon-qtype-match-question-\' + row.id" [(ngModel)]="row.selected" interface="action-sheet" [disabled]="row.disabled" [color]=\'(row.isCorrect === 1 ? "success": "") +  (row.isCorrect === 0 ? "danger": "")\'>\n                        <ion-option *ngFor="let option of row.options" [value]="option.value">{{option.label}}</ion-option>\n                    </ion-select>\n\n                    <core-icon *ngIf="row.isCorrect === 1" class="core-correct-icon" name="fa-check" color="success"></core-icon>\n                    <core-icon *ngIf="row.isCorrect === 0" class="core-correct-icon" name="fa-remove" color="danger"></core-icon>\n\n                    <!-- ion-select doesn\'t use a select. Create a hidden input to hold the selected value. -->\n                    <input type="hidden" [ngModel]="row.selected" [attr.name]="row.name">\n                </ion-col>\n            </ion-row>\n        </ion-grid>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\match\component\addon-qtype-match.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonQtypeMatchComponent);
    return AddonQtypeMatchComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=match.js.map

/***/ }),
/* 408 */,
/* 409 */,
/* 410 */,
/* 411 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucloginProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_storage__ = __webpack_require__(131);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_angular_oauth2_oidc__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_ionic_angular__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/*
  Generated class for the OucloginProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
var OucloginProvider = /** @class */ (function () {
    function OucloginProvider(oauthService, toastCtrl, storage, loadingCtrl, http) {
        this.oauthService = oauthService;
        this.toastCtrl = toastCtrl;
        this.storage = storage;
        this.loadingCtrl = loadingCtrl;
        this.http = http;
    }
    OucloginProvider.prototype.redirectLogin = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.oktaLogin().then(function (success) {
                var param = {
                    grant_type: 'authorization_code',
                    scope: 'openid profile ouchnuser ouchnstudentspaceapi ouchnteacherspaceapi ouchnappcloudapi offline_access ouconlineappapi',
                    client_id: 'OUCOnlineAPP',
                    client_secret: 'QU9cZkL.>/n4ZE@sHj7U&zPyuzN68^]zp3BqRg#MdDFN7Yr%9jT3?hFJCsfucWJ7',
                    code: success.code,
                    redirect_uri: 'http://localhost:8100'
                };
                _this.httpOucPost('http://passport.ouchn.cn/connect/token', param, function (d) {
                    _this.storage.set('oucAccessToken', d.access_token);
                    _this.storage.set('refreshOucAccessToken', d.refresh_token);
                    resolve(d.access_token);
                }, false);
            }, function (error) {
                reject('失败');
            });
        });
    };
    OucloginProvider.prototype.oktaLogin = function () {
        var _this = this;
        return this.oauthService.createAndSaveNonce().then(function (nonce) {
            var state = Math.floor(Math.random() * 1000000000).toString();
            if (window.crypto) {
                var array = new Uint32Array(1);
                window.crypto.getRandomValues(array);
                state = array.join().toString();
            }
            return new Promise(function (resolve, reject) {
                var oauthUrl = _this.buildOAuthUrl(state, nonce);
                var browser = window.cordova.InAppBrowser.open(oauthUrl, '_blank', 'clearcache=yes,clearsessioncache=yes,location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
                browser.addEventListener('loadstart', function (event) {
                    if ((event.url).indexOf('http://localhost:8100') === 0) {
                        browser.removeEventListener('exit', function () { });
                        var responseParameters = ((event.url).split('?')[1]).split('&');
                        var parsedResponse = {};
                        for (var i = 0; i < responseParameters.length; i++) {
                            parsedResponse[responseParameters[i].split('=')[0]] =
                                responseParameters[i].split('=')[1];
                        }
                        var defaultError = 'Problem authenticating with Okta';
                        if (parsedResponse['code'] !== undefined &&
                            parsedResponse['code'] !== null) {
                            resolve(parsedResponse);
                            browser.close();
                        }
                        else {
                            reject(defaultError);
                        }
                    }
                });
                browser.addEventListener('exit', function (event) {
                    reject('The Okta sign in flow was canceled');
                });
                // this.inAppBrowser.create(oauthUrl, '_system');
            });
        });
    };
    OucloginProvider.prototype.buildOAuthUrl = function (state, nonce) {
        // return 'http://passport.ouchn.cn/Account/Login?ReturnUrl=%2Fconnect%2Fauthorize%2Fcallback%3Fresponse_type%3Did_token%2520token%26client_id%3Douchn-android%26state%3DCswwU1-7KduiW64q2Hl_UFCfvVRshmgJm8Cw8DNNYJVnW%26redirect_uri%3Dhttp%253A%252F%252Flocalhost%253A8100%252Findex.html%26scope%3Dopenid%2520profile%2520ouchnuser%2520ouchnstudentspaceapi%26nonce%3DCswwU1-7KduiW64q2Hl_UFCfvVRshmgJm8Cw8DNNYJVnW';
        // return 'http://passport.ouchn.cn/Account/Login?ReturnUrl=%2Fconnect%2Fauthorize%2Fcallback%3Fresponse_type%3Did_token%2520token%26client_id%3Douchn-android%26state%3DJ90irxhDLYKQ0t-aE5xx7hvCx2sSsJhWGEqTwlhAek_fI%26redirect_uri%3Dhttp%253A%252F%252Flocalhost%253A8100%252Findex.html%26scope%3Dopenid%2520profile%2520ouchnuser%2520ouchnstudentspaceapi%2520ouchnteacherspaceapi%26nonce%3DJ90irxhDLYKQ0t-aE5xx7hvCx2sSsJhWGEqTwlhAek_fI';
        // return 'http://passport.ouchn.cn/Account/Login?ReturnUrl=%2Fconnect%2Fauthorize%2Fcallback%3Fresponse_type%3Did_token%2520token%26client_id%3Douchn-android%26state%3DiDA84oPgl4wnNdgGB8LjWBxvxF4JX7NKzBJsSNjOGQBNQ%26redirect_uri%3Dhttp%253A%252F%252Flocalhost%253A8100%252Findex.html%26scope%3Dopenid%2520profile%2520ouchnuser%2520ouchnstudentspaceapi%2520ouchnteacherspaceapi%2520ouchnappcloudapi%26nonce%3DiDA84oPgl4wnNdgGB8LjWBxvxF4JX7NKzBJsSNjOGQBNQ';
        return 'http://passport.ouchn.cn/connect/authorize?response_type=code&scope=openid profile offline_access ouchnuser ouchnstudentspaceapi ouchnteacherspaceapi ouchnappcloudapi ouconlineappapi&client_id=OUCOnlineAPP&redirect_uri=http://localhost:8100';
    };
    OucloginProvider.prototype.toast = function (message, callback) {
        var toast = this.toastCtrl.create({
            message: message,
            duration: 2000,
            dismissOnPageChange: true,
        });
        toast.present();
        if (callback) {
            callback();
        }
    };
    // Post对参数进行编码
    OucloginProvider.prototype.encodeForPost = function (params) {
        var str = '';
        if (params) {
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    var value = params[key];
                    str += encodeURIComponent(key) + '=' + encodeURIComponent(value) + '&';
                }
            }
            str = str.substring(0, str.length - 1);
        }
        return str;
    };
    OucloginProvider.prototype.handleError = function (error) {
        var msg = '';
        if (error.status == 400) {
            msg = '请求无效(code：404)';
            console.log('请检查参数类型是否匹配');
        }
        if (error.status == 404) {
            msg = '请求资源不存在(code：404)';
            console.error(msg + '，请检查路径是否正确');
        }
        if (error.status == 500) {
            msg = '服务器发生错误(code：500)';
            console.error(msg + '，请检查路径是否正确');
        }
        console.log(error);
        if (msg != '') {
            this.toast(msg);
        }
    };
    OucloginProvider.prototype.httpOucPost = function (url, params, callback, loader) {
        var _this = this;
        if (loader === void 0) { loader = false; }
        var headers = new __WEBPACK_IMPORTED_MODULE_3__angular_http__["a" /* Headers */]({
            'Content-Type': 'application/x-www-form-urlencoded',
        });
        var options = new __WEBPACK_IMPORTED_MODULE_3__angular_http__["d" /* RequestOptions */]({
            headers: headers
        });
        var loading = this.loadingCtrl.create();
        if (loader) {
            loading.present();
        }
        this.http.post(url, this.encodeForPost(params), options)
            .toPromise()
            .then(function (res) {
            var d = res.json();
            if (loader) {
                loading.dismiss();
            }
            callback(d == null ? "[]" : d);
        }).catch(function (error) {
            if (loader) {
                loading.dismiss();
            }
            _this.handleError(error);
        });
    };
    OucloginProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_angular_oauth2_oidc__["b" /* OAuthService */], __WEBPACK_IMPORTED_MODULE_4_ionic_angular__["E" /* ToastController */], __WEBPACK_IMPORTED_MODULE_1__ionic_storage__["b" /* Storage */], __WEBPACK_IMPORTED_MODULE_4_ionic_angular__["o" /* LoadingController */],
            __WEBPACK_IMPORTED_MODULE_3__angular_http__["b" /* Http */]])
    ], OucloginProvider);
    return OucloginProvider;
}());

//# sourceMappingURL=ouclogin.js.map

/***/ }),
/* 412 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__index_index__ = __webpack_require__(449);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__field_plugin_field_plugin__ = __webpack_require__(1706);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__action_action__ = __webpack_require__(1707);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_compile_components_compile_html_compile_html_module__ = __webpack_require__(413);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_comments_components_components_module__ = __webpack_require__(280);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};













var AddonModDataComponentsModule = /** @class */ (function () {
    function AddonModDataComponentsModule() {
    }
    AddonModDataComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModDataIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__field_plugin_field_plugin__["a" /* AddonModDataFieldPluginComponent */],
                __WEBPACK_IMPORTED_MODULE_10__action_action__["a" /* AddonModDataActionComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_11__core_compile_components_compile_html_compile_html_module__["a" /* CoreCompileHtmlComponentModule */],
                __WEBPACK_IMPORTED_MODULE_12__core_comments_components_components_module__["a" /* CoreCommentsComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModDataIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__field_plugin_field_plugin__["a" /* AddonModDataFieldPluginComponent */],
                __WEBPACK_IMPORTED_MODULE_10__action_action__["a" /* AddonModDataActionComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModDataIndexComponent */]
            ]
        })
    ], AddonModDataComponentsModule);
    return AddonModDataComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 413 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCompileHtmlComponentModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__compile_html__ = __webpack_require__(1432);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(13);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var CoreCompileHtmlComponentModule = /** @class */ (function () {
    function CoreCompileHtmlComponentModule() {
    }
    CoreCompileHtmlComponentModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__compile_html__["a" /* CoreCompileHtmlComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* CoreComponentsModule */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_2__compile_html__["a" /* CoreCompileHtmlComponent */]
            ]
        })
    ], CoreCompileHtmlComponentModule);
    return CoreCompileHtmlComponentModule;
}());

//# sourceMappingURL=compile-html.module.js.map

/***/ }),
/* 414 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service that provides some features regarding learning plans.
 */
var AddonCompetencyHelperProvider = /** @class */ (function () {
    function AddonCompetencyHelperProvider(sitesProvider, userProvider, translate) {
        this.sitesProvider = sitesProvider;
        this.userProvider = userProvider;
        this.translate = translate;
    }
    /**
     * Convenient helper to get the user profile image.
     *
     * @param  {number} userId User Id
     * @return {Promise<any>}  User profile Image URL or true if default icon.
     */
    AddonCompetencyHelperProvider.prototype.getProfile = function (userId) {
        if (!userId || userId == this.sitesProvider.getCurrentSiteUserId()) {
            return Promise.resolve(false);
        }
        // Get the user profile to retrieve the user image.
        return this.userProvider.getProfile(userId, null, true).then(function (user) {
            user.profileimageurl = user.profileimageurl || true;
            return user;
        });
    };
    /**
     * Get the review status name translated.
     *
     * @param {number} status
     * @return {string}
     */
    AddonCompetencyHelperProvider.prototype.getCompetencyStatusName = function (status) {
        var statusTranslateName;
        switch (status) {
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].REVIEW_STATUS_IDLE:
                statusTranslateName = 'idle';
                break;
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].REVIEW_STATUS_IN_REVIEW:
                statusTranslateName = 'inreview';
                break;
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].REVIEW_STATUS_WAITING_FOR_REVIEW:
                statusTranslateName = 'waitingforreview';
                break;
            default:
                // We can use the current status name.
                return String(status);
        }
        return this.translate.instant('addon.competency.usercompetencystatus_' + statusTranslateName);
    };
    /**
     * Get the status name translated.
     *
     * @param {number} status
     * @return {string}
     */
    AddonCompetencyHelperProvider.prototype.getPlanStatusName = function (status) {
        var statusTranslateName;
        switch (status) {
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].STATUS_DRAFT:
                statusTranslateName = 'draft';
                break;
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].STATUS_ACTIVE:
                statusTranslateName = 'active';
                break;
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].STATUS_COMPLETE:
                statusTranslateName = 'complete';
                break;
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].STATUS_WAITING_FOR_REVIEW:
                statusTranslateName = 'waitingforreview';
                break;
            case __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */].STATUS_IN_REVIEW:
                statusTranslateName = 'inreview';
                break;
            default:
                // We can use the current status name.
                return String(status);
        }
        return this.translate.instant('addon.competency.planstatus' + statusTranslateName);
    };
    AddonCompetencyHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonCompetencyHelperProvider);
    return AddonCompetencyHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 415 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__participants_participants__ = __webpack_require__(795);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__user_profile_field_user_profile_field__ = __webpack_require__(1463);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__pipes_pipes_module__ = __webpack_require__(63);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









var CoreUserComponentsModule = /** @class */ (function () {
    function CoreUserComponentsModule() {
    }
    CoreUserComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__participants_participants__["a" /* CoreUserParticipantsComponent */],
                __WEBPACK_IMPORTED_MODULE_5__user_profile_field_user_profile_field__["a" /* CoreUserProfileFieldComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_8__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__participants_participants__["a" /* CoreUserParticipantsComponent */],
                __WEBPACK_IMPORTED_MODULE_5__user_profile_field_user_profile_field__["a" /* CoreUserProfileFieldComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__participants_participants__["a" /* CoreUserParticipantsComponent */]
            ]
        })
    ], CoreUserComponentsModule);
    return CoreUserComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 416 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__index_index__ = __webpack_require__(447);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__submission_submission__ = __webpack_require__(1691);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__assessment_assessment__ = __webpack_require__(1692);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__assessment_strategy_assessment_strategy__ = __webpack_require__(1016);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};












var AddonModWorkshopComponentsModule = /** @class */ (function () {
    function AddonModWorkshopComponentsModule() {
    }
    AddonModWorkshopComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModWorkshopIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__submission_submission__["a" /* AddonModWorkshopSubmissionComponent */],
                __WEBPACK_IMPORTED_MODULE_10__assessment_assessment__["a" /* AddonModWorkshopAssessmentComponent */],
                __WEBPACK_IMPORTED_MODULE_11__assessment_strategy_assessment_strategy__["a" /* AddonModWorkshopAssessmentStrategyComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModWorkshopIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__submission_submission__["a" /* AddonModWorkshopSubmissionComponent */],
                __WEBPACK_IMPORTED_MODULE_10__assessment_assessment__["a" /* AddonModWorkshopAssessmentComponent */],
                __WEBPACK_IMPORTED_MODULE_11__assessment_strategy_assessment_strategy__["a" /* AddonModWorkshopAssessmentStrategyComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModWorkshopIndexComponent */]
            ]
        })
    ], AddonModWorkshopComponentsModule);
    return AddonModWorkshopComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 417 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreIonTabsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};




/**
 * Equivalent to ion-tabs. It has 2 improvements:
 *     - If a core-ion-tab is added or removed, it will be reflected in the tab bar in the right position.
 *     - It supports a loaded input to tell when are the tabs ready.
 */
var CoreIonTabsComponent = /** @class */ (function (_super) {
    __extends(CoreIonTabsComponent, _super);
    function CoreIonTabsComponent(utils, appProvider, parent, viewCtrl, _app, config, elementRef, _plt, renderer, _linker, keyboard) {
        var _this = _super.call(this, parent, viewCtrl, _app, config, elementRef, _plt, renderer, _linker, keyboard) || this;
        _this.utils = utils;
        _this.appProvider = appProvider;
        _this.hidden = false; // Whether to show/hide tabs.
        /**
         * List of tabs that haven't been initialized yet. This is required because IonTab calls add() on the constructor,
         * but we need it to be called in OnInit to be able to determine the tab position.
         * @type {CoreIonTabComponent[]}
         */
        _this.tabsNotInit = [];
        _this.tabsIds = []; // An array to keep the order of tab IDs when they're sorted.
        _this.tabsNotInitIds = []; // An array to keep the order of tab IDs for non-init tabs.
        _this.viewInit = false; // Whether the view has been initialized.
        _this.initialized = false; // Whether tabs have been initialized.
        return _this;
    }
    CoreIonTabsComponent_1 = CoreIonTabsComponent;
    Object.defineProperty(CoreIonTabsComponent.prototype, "loaded", {
        /**
         * Whether the tabs have been loaded. If defined, tabs won't be initialized until it's set to true.
         */
        set: function (val) {
            var _this = this;
            this._loaded = this.utils.isTrueOrOne(val);
            if (this.viewInit && !this.initialized) {
                // Use a setTimeout to make sure the tabs have been loaded.
                setTimeout(function () {
                    _this.initTabs();
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * View has been initialized.
     */
    CoreIonTabsComponent.prototype.ngAfterViewInit = function () {
        this.viewInit = true;
        _super.prototype.ngAfterViewInit.call(this);
        this.registerBackButtonAction();
    };
    /**
     * Add a new tab if it isn't already in the list of tabs.
     *
     * @param {CoreIonTabComponent} tab The tab to add.
     * @param {boolean} [isInit] Whether the tab has been initialized.
     * @return {string} The tab ID.
     */
    CoreIonTabsComponent.prototype.add = function (tab, isInit) {
        // Check if tab is already in the list of initialized tabs.
        var position = this._tabs.indexOf(tab);
        if (position != -1) {
            return this.tabsIds[position];
        }
        // Now check if the tab is in the not init list.
        position = this.tabsNotInit.indexOf(tab);
        if (position != -1) {
            if (!isInit) {
                return this.tabsNotInitIds[position];
            }
            // The tab wasn't initialized but now it is. Move it from one array to the other.
            var tabId = this.tabsNotInitIds[position];
            this.tabsNotInit.splice(position, 1);
            this.tabsNotInitIds.splice(position, 1);
            this._tabs.push(tab);
            this.tabsIds.push(tabId);
            this.sortTabs();
            return tabId;
        }
        // Tab is new. In this case isInit should always be false, but check it just in case.
        var id = this.id + '-' + (++this._ids);
        if (isInit) {
            this._tabs.push(tab);
            this.tabsIds.push(id);
            this.sortTabs();
        }
        else {
            this.tabsNotInit.push(tab);
            this.tabsNotInitIds.push(id);
        }
        return id;
    };
    /**
     * Initialize the tabs.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreIonTabsComponent.prototype.initTabs = function () {
        var _this = this;
        if (!this.initialized && (this._loaded || typeof this._loaded == 'undefined')) {
            this.initialized = true;
            return _super.prototype.initTabs.call(this).then(function () {
                // Tabs initialized. Force select the tab if it's not enabled.
                if (_this.selectedDisabled && typeof _this.selectedIndex != 'undefined') {
                    var tab = _this.getByIndex(_this.selectedIndex);
                    if (tab && !tab.enabled) {
                        _this.select(tab);
                    }
                }
                _this.firstSelectedTab = _this._selectHistory[0] || null;
            }).finally(function () {
                // If there was a select promise pending to be resolved, do it now.
                if (_this.selectTabPromiseDefer) {
                    _this.selectTabPromiseDefer.resolve();
                    delete _this.selectTabPromiseDefer;
                }
            });
        }
        else {
            // Tabs not loaded yet. Set the tab bar position so the tab bar is shown, it'll have a spinner.
            this.setTabbarPosition(-1, 0);
            return Promise.resolve();
        }
    };
    /**
     * Register back button action.
     */
    CoreIonTabsComponent.prototype.registerBackButtonAction = function () {
        var _this = this;
        this.unregisterBackButtonAction = this.appProvider.registerBackButtonAction(function () {
            var tab = _this.previousTab(true);
            if (tab) {
                var selectedTab_1 = _this.getSelected();
                // It can happen when the previous is a phantom tab.
                if (tab.id == selectedTab_1.id) {
                    tab = _this.previousTab(true);
                }
                if (tab) {
                    // Remove curent and previous tabs from history.
                    _this._selectHistory = _this._selectHistory.filter(function (tabId) {
                        return selectedTab_1.id != tabId && tab.id != tabId;
                    });
                    _this.select(tab);
                    return true;
                }
            }
            else {
                var selected = _this.getSelected();
                if (selected && _this.firstSelectedTab && selected.id != _this.firstSelectedTab) {
                    // All history is gone but we are not in the first selected tab.
                    _this._selectHistory = [];
                    tab = _this._tabs.find(function (t) { return t.id === _this.firstSelectedTab; });
                    if (tab && tab.enabled) {
                        _this.select(tab);
                        return true;
                    }
                }
            }
            return false;
        }, 250);
    };
    /**
     * Remove a tab from the list of tabs.
     *
     * @param {CoreIonTabComponent} tab The tab to remove.
     */
    CoreIonTabsComponent.prototype.remove = function (tab) {
        // First search in the list of initialized tabs.
        var index = this._tabs.indexOf(tab);
        if (index != -1) {
            this._tabs.splice(index, 1);
            this.tabsIds.splice(index, 1);
        }
        else {
            // Not found, search in the list of non-init tabs.
            index = this.tabsNotInit.indexOf(tab);
            if (index != -1) {
                this.tabsNotInit.splice(index, 1);
                this.tabsNotInitIds.splice(index, 1);
            }
        }
    };
    /**
     * Sort the tabs, keeping the same order as in the original list.
     */
    CoreIonTabsComponent.prototype.sortTabs = function () {
        var _this = this;
        if (this.originalTabsRef) {
            var newTabs_1 = [], newTabsIds_1 = [], originalTabsEl_1 = this.originalTabsRef.nativeElement;
            this._tabs.forEach(function (tab, index) {
                var originalIndex = Array.prototype.indexOf.call(originalTabsEl_1.children, tab.getNativeElement());
                if (originalIndex != -1) {
                    newTabs_1[originalIndex] = tab;
                    newTabsIds_1[originalIndex] = _this.tabsIds[index];
                }
            });
            // Remove undefined values. It can happen if the view has some tabs that were destroyed but weren't removed yet.
            this._tabs = newTabs_1.filter(function (tab) {
                return typeof tab != 'undefined';
            });
            this.tabsIds = newTabsIds_1.filter(function (id) {
                return typeof id != 'undefined';
            });
        }
    };
    /**
     * Select a tab.
     *
     * @param {number|Tab} tabOrIndex Index, or the Tab instance, of the tab to select.
     * @param {NavOptions} Nav options.
     * @param {boolean} [fromUrl=true] Whether to load from a URL.
     * @return {Promise<any>} Promise resolved when selected.
     */
    CoreIonTabsComponent.prototype.select = function (tabOrIndex, opts, fromUrl) {
        if (opts === void 0) { opts = {}; }
        if (fromUrl === void 0) { fromUrl = false; }
        if (this.initialized) {
            // Tabs have been initialized, select the tab.
            return _super.prototype.select.call(this, tabOrIndex, opts, fromUrl);
        }
        else {
            // Tabs not initialized yet. Mark it as "selectedIndex" input so it's treated when the tabs are initialized.
            if (typeof tabOrIndex == 'number') {
                this.selectedIndex = tabOrIndex;
            }
            else {
                this.selectedIndex = this.getIndex(tabOrIndex);
            }
            // Don't resolve the Promise until the tab is really selected (tabs are initialized).
            this.selectTabPromiseDefer = this.selectTabPromiseDefer || this.utils.promiseDefer();
            return this.selectTabPromiseDefer.promise;
        }
    };
    /**
     * Select a tab by Index. First it will reset the status of the tab.
     *
     * @param {number} index Index of the tab.
     * @return {Promise<any>} Promise resolved when selected.
     */
    CoreIonTabsComponent.prototype.selectTabRootByIndex = function (index) {
        var _this = this;
        if (this.initialized) {
            var tab_1 = this.getByIndex(index);
            if (tab_1) {
                return tab_1.goToRoot({ animate: false, updateUrl: true, isNavRoot: true }).then(function () {
                    // Tab not previously selected. Select it after going to root.
                    if (!tab_1.isSelected) {
                        return _this.select(tab_1, { animate: false, updateUrl: true, isNavRoot: true });
                    }
                });
            }
            // Not found.
            return Promise.reject(null);
        }
        else {
            // Tabs not initialized yet. Mark it as "selectedIndex" input so it's treated when the tabs are initialized.
            this.selectedIndex = index;
            // Don't resolve the Promise until the tab is really selected (tabs are initialized).
            this.selectTabPromiseDefer = this.selectTabPromiseDefer || this.utils.promiseDefer();
            return this.selectTabPromiseDefer.promise;
        }
    };
    /**
     * Change tabs visibility to show/hide them from the view.
     *
     * @param {boolean} visible If show or hide the tabs.
     */
    CoreIonTabsComponent.prototype.changeVisibility = function (visible) {
        var _this = this;
        if (this.hidden == visible) {
            // Change needed.
            this.hidden = !visible;
            setTimeout(function () {
                _this.viewCtrl.getContent().resize();
            });
        }
    };
    /**
     * Component destroyed.
     */
    CoreIonTabsComponent.prototype.ngOnDestroy = function () {
        // Unregister the custom back button action for this page
        this.unregisterBackButtonAction && this.unregisterBackButtonAction();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], CoreIonTabsComponent.prototype, "loaded", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreIonTabsComponent.prototype, "selectedDisabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('originalTabs'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreIonTabsComponent.prototype, "originalTabsRef", void 0);
    CoreIonTabsComponent = CoreIonTabsComponent_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-ion-tabs',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ion-tabs\core-ion-tabs.html"*/'<div class="tabbar" role="tablist" #tabbar [hidden]="hidden">\n    <a [hidden]="_loaded === false" *ngFor="let t of _tabs" [tab]="t" class="tab-button" role="tab" href="#" (ionSelect)="select(t)" [attr.aria-hidden]="!t.show" [attr.aria-label]="t.tabTitle || \'\'" [title]="t.tabTitle || \'\'"></a>\n    <div class="tab-highlight"></div>\n    <div *ngIf="_loaded === false" class="core-ion-tabs-loading">\n        <span class="core-ion-tabs-loading-spinner">\n            <ion-spinner></ion-spinner>\n        </span>\n    </div>\n</div>\n<div #originalTabs class="tabcontent">\n    <ng-content></ng-content>\n</div>\n<div #portal tab-portal></div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ion-tabs\core-ion-tabs.html"*/,
            encapsulation: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewEncapsulation"].None,
            providers: [{ provide: __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["y" /* RootNode */], useExisting: Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["forwardRef"])(function () { return CoreIonTabsComponent_1; }) }]
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __param(3, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["c" /* App */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Config */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["Renderer"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* DeepLinker */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["n" /* Keyboard */]])
    ], CoreIonTabsComponent);
    return CoreIonTabsComponent;
    var CoreIonTabsComponent_1;
}(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["C" /* Tabs */]));

//# sourceMappingURL=ion-tabs.js.map

/***/ }),
/* 418 */,
/* 419 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessageOutputAirnotifierProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service to handle Airnotifier message output.
 */
var AddonMessageOutputAirnotifierProvider = /** @class */ (function () {
    function AddonMessageOutputAirnotifierProvider(loggerProvider, sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.ROOT_CACHE_KEY = 'mmaMessageOutputAirnotifier:';
        this.logger = loggerProvider.getInstance('AddonMessageOutputAirnotifier');
    }
    /**
     * Enables or disables a device.
     *
     * @param {number} deviceId Device ID.
     * @param {boolean} enable True to enable, false to disable.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved if success.
     */
    AddonMessageOutputAirnotifierProvider.prototype.enableDevice = function (deviceId, enable, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                deviceid: deviceId,
                enable: enable ? 1 : 0
            };
            return site.write('message_airnotifier_enable_device', data).then(function (result) {
                if (!result.success) {
                    // Fail. Reject with warning message if any.
                    if (result.warnings && result.warnings.length) {
                        return Promise.reject(result.warnings[0].message);
                    }
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Get the cache key for the get user devices call.
     *
     * @return {string} Cache key.
     */
    AddonMessageOutputAirnotifierProvider.prototype.getUserDevicesCacheKey = function () {
        return this.ROOT_CACHE_KEY + 'userDevices';
    };
    /**
     * Get user devices.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any>} Promise resolved with the devices.
     */
    AddonMessageOutputAirnotifierProvider.prototype.getUserDevices = function (siteId) {
        var _this = this;
        this.logger.debug('Get user devices');
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var data = {
                appid: __WEBPACK_IMPORTED_MODULE_3__configconstants__["a" /* CoreConfigConstants */].app_id
            };
            var preSets = {
                cacheKey: _this.getUserDevicesCacheKey(),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            return site.read('message_airnotifier_get_user_devices', data, preSets).then(function (data) {
                return data.devices;
            });
        });
    };
    /**
     * Invalidate get user devices.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data is invalidated.
     */
    AddonMessageOutputAirnotifierProvider.prototype.invalidateUserDevices = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getUserDevicesCacheKey());
        });
    };
    /**
     * Returns whether or not the plugin is enabled for the current site.
     *
     * @return {boolean} True if enabled, false otherwise.
     * @since 3.2
     */
    AddonMessageOutputAirnotifierProvider.prototype.isEnabled = function () {
        return this.sitesProvider.wsAvailableInCurrentSite('message_airnotifier_enable_device') &&
            this.sitesProvider.wsAvailableInCurrentSite('message_airnotifier_get_user_devices');
    };
    AddonMessageOutputAirnotifierProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonMessageOutputAirnotifierProvider);
    return AddonMessageOutputAirnotifierProvider;
}());

//# sourceMappingURL=airnotifier.js.map

/***/ }),
/* 420 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__messages_offline__ = __webpack_require__(282);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__messages__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_sync__ = __webpack_require__(46);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Service to sync messages.
 */
var AddonMessagesSyncProvider = /** @class */ (function (_super) {
    __extends(AddonMessagesSyncProvider, _super);
    function AddonMessagesSyncProvider(loggerProvider, sitesProvider, appProvider, translate, syncProvider, textUtils, messagesOffline, eventsProvider, messagesProvider, userProvider, utils, timeUtils) {
        var _this = _super.call(this, 'AddonMessagesSync', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.messagesOffline = messagesOffline;
        _this.eventsProvider = eventsProvider;
        _this.messagesProvider = messagesProvider;
        _this.userProvider = userProvider;
        _this.utils = utils;
        return _this;
    }
    AddonMessagesSyncProvider_1 = AddonMessagesSyncProvider;
    /**
     * Get the ID of a discussion sync.
     *
     * @param {number} conversationId Conversation ID.
     * @param {number} userId User ID talking to (if no conversation ID).
     * @return {string} Sync ID.
     */
    AddonMessagesSyncProvider.prototype.getSyncId = function (conversationId, userId) {
        if (conversationId) {
            return 'conversationid:' + conversationId;
        }
        else {
            return 'userid:' + userId;
        }
    };
    /**
     * Try to synchronize all the discussions in a certain site or in all sites.
     *
     * @param  {string} [siteId]                   Site ID to sync. If not defined, sync all sites.
     * @param  {boolean} [onlyDeviceOffline=false] True to only sync discussions that failed because device was offline,
     *                                             false to sync all.
     * @return {Promise<any>}                      Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonMessagesSyncProvider.prototype.syncAllDiscussions = function (siteId, onlyDeviceOffline) {
        if (onlyDeviceOffline === void 0) { onlyDeviceOffline = false; }
        var syncFunctionLog = 'all discussions' + (onlyDeviceOffline ? ' (Only offline)' : '');
        return this.syncOnSites(syncFunctionLog, this.syncAllDiscussionsFunc.bind(this), [onlyDeviceOffline], siteId);
    };
    /**
     * Get all messages pending to be sent in the site.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {boolean} [onlyDeviceOffline=false] True to only sync discussions that failed because device was offline.
     * @param {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    AddonMessagesSyncProvider.prototype.syncAllDiscussionsFunc = function (siteId, onlyDeviceOffline) {
        var _this = this;
        if (onlyDeviceOffline === void 0) { onlyDeviceOffline = false; }
        var promise = onlyDeviceOffline ?
            this.messagesOffline.getAllDeviceOfflineMessages(siteId) :
            this.messagesOffline.getAllMessages(siteId);
        return promise.then(function (messages) {
            var userIds = [], conversationIds = [], promises = [];
            // Get all the conversations to be synced.
            messages.forEach(function (message) {
                if (message.conversationid) {
                    if (conversationIds.indexOf(message.conversationid) == -1) {
                        conversationIds.push(message.conversationid);
                    }
                }
                else if (userIds.indexOf(message.touserid) == -1) {
                    userIds.push(message.touserid);
                }
            });
            // Sync all conversations.
            conversationIds.forEach(function (conversationId) {
                promises.push(_this.syncDiscussion(conversationId, undefined, siteId).then(function (warnings) {
                    if (typeof warnings != 'undefined') {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonMessagesSyncProvider_1.AUTO_SYNCED, {
                            conversationId: conversationId,
                            warnings: warnings
                        }, siteId);
                    }
                }));
            });
            userIds.forEach(function (userId) {
                promises.push(_this.syncDiscussion(undefined, userId, siteId).then(function (warnings) {
                    if (typeof warnings != 'undefined') {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(AddonMessagesSyncProvider_1.AUTO_SYNCED, {
                            userId: userId,
                            warnings: warnings
                        }, siteId);
                    }
                }));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Synchronize a discussion.
     *
     * @param {number} conversationId Conversation ID.
     * @param {number} userId User ID talking to (if no conversation ID).
     * @return {Promise<any>} Promise resolved if sync is successful, rejected otherwise.
     */
    AddonMessagesSyncProvider.prototype.syncDiscussion = function (conversationId, userId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = this.getSyncId(conversationId, userId), groupMessagingEnabled = this.messagesProvider.isGroupMessagingEnabled();
        if (this.isSyncing(syncId, siteId)) {
            // There's already a sync ongoing for this conversation, return the promise.
            return this.getOngoingSync(syncId, siteId);
        }
        var warnings = [];
        if (conversationId) {
            this.logger.debug("Try to sync conversation '" + conversationId + "'");
        }
        else {
            this.logger.debug("Try to sync discussion with user '" + userId + "'");
        }
        // Get offline messages to be sent.
        var syncPromise;
        if (conversationId) {
            syncPromise = this.messagesOffline.getConversationMessages(conversationId, siteId);
        }
        else {
            syncPromise = this.messagesOffline.getMessages(userId, siteId);
        }
        syncPromise = syncPromise.then(function (messages) {
            if (!messages.length) {
                // Nothing to sync.
                return [];
            }
            else if (!_this.appProvider.isOnline()) {
                // Cannot sync in offline. Mark messages as device offline.
                _this.messagesOffline.setMessagesDeviceOffline(messages, true);
                return Promise.reject(null);
            }
            var promise = Promise.resolve();
            var errors = [];
            // Order message by timecreated.
            messages = _this.messagesProvider.sortMessages(messages);
            // Send the messages.
            // Send them 1 by 1 to simulate web's behaviour and to make sure we know which message has failed.
            messages.forEach(function (message, index) {
                // Chain message sending. If 1 message fails to be sent we'll stop sending.
                promise = promise.then(function () {
                    var subPromise;
                    if (conversationId) {
                        subPromise = _this.messagesProvider.sendMessageToConversationOnline(conversationId, message.text, siteId);
                    }
                    else {
                        subPromise = _this.messagesProvider.sendMessageOnline(userId, message.smallmessage, siteId);
                    }
                    return subPromise.catch(function (error) {
                        if (_this.utils.isWebServiceError(error)) {
                            // Error returned by WS. Store the error to show a warning but keep sending messages.
                            if (errors.indexOf(error) == -1) {
                                errors.push(error);
                            }
                            return;
                        }
                        // Error sending, stop execution.
                        if (_this.appProvider.isOnline()) {
                            // App is online, unmark deviceoffline if marked.
                            _this.messagesOffline.setMessagesDeviceOffline(messages, false);
                        }
                        return Promise.reject(error);
                    }).then(function () {
                        // Message was sent, delete it from local DB.
                        if (conversationId) {
                            return _this.messagesOffline.deleteConversationMessage(conversationId, message.text, message.timecreated, siteId);
                        }
                        else {
                            return _this.messagesOffline.deleteMessage(userId, message.smallmessage, message.timecreated, siteId);
                        }
                    }).then(function () {
                        // In some Moodle versions, wait 1 second to make sure timecreated is different.
                        // This is because there was a bug where messages with the same timecreated had a wrong order.
                        if (!groupMessagingEnabled && index < messages.length - 1) {
                            return new Promise(function (resolve, reject) {
                                setTimeout(resolve, 1000);
                            });
                        }
                    });
                });
            });
            return promise;
        }).then(function (errors) {
            return _this.handleSyncErrors(conversationId, userId, errors, warnings);
        }).then(function () {
            // All done, return the warnings.
            return warnings;
        });
        return this.addOngoingSync(syncId, syncPromise, siteId);
    };
    /**
     * Handle sync errors.
     *
     * @param {number} conversationId Conversation ID.
     * @param {number} userId User ID talking to (if no conversation ID).
     * @param {any[]} errors List of errors.
     * @param {any[]} warnings Array where to place the warnings.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonMessagesSyncProvider.prototype.handleSyncErrors = function (conversationId, userId, errors, warnings) {
        var _this = this;
        if (errors && errors.length) {
            if (conversationId) {
                // Get conversation name and add errors to warnings array.
                return this.messagesProvider.getConversation(conversationId, false, false).catch(function () {
                    // Ignore errors.
                    return {};
                }).then(function (conversation) {
                    errors.forEach(function (error) {
                        warnings.push(_this.translate.instant('addon.messages.warningconversationmessagenotsent', {
                            conversation: conversation.name ? conversation.name : conversationId,
                            error: _this.textUtils.getErrorMessageFromError(error)
                        }));
                    });
                });
            }
            else {
                // Get user full name and add errors to warnings array.
                return this.userProvider.getProfile(userId, undefined, true).catch(function () {
                    // Ignore errors.
                    return {};
                }).then(function (user) {
                    errors.forEach(function (error) {
                        warnings.push(_this.translate.instant('addon.messages.warningmessagenotsent', {
                            user: user.fullname ? user.fullname : userId,
                            error: _this.textUtils.getErrorMessageFromError(error)
                        }));
                    });
                });
            }
        }
    };
    /**
     * If there's an ongoing sync for a certain conversation, wait for it to end.
     * If there's no sync ongoing the promise will be resolved right away.
     *
     * @param {number} conversationId Conversation ID.
     * @param {number} userId User ID talking to (if no conversation ID).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when there's no sync going on for the identifier.
     */
    AddonMessagesSyncProvider.prototype.waitForSyncConversation = function (conversationId, userId, siteId) {
        var syncId = this.getSyncId(conversationId, userId);
        return this.waitForSync(syncId, siteId);
    };
    AddonMessagesSyncProvider.AUTO_SYNCED = 'addon_messages_autom_synced';
    AddonMessagesSyncProvider = AddonMessagesSyncProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__messages_offline__["a" /* AddonMessagesOfflineProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__messages__["a" /* AddonMessagesProvider */], __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_10__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonMessagesSyncProvider);
    return AddonMessagesSyncProvider;
    var AddonMessagesSyncProvider_1;
}(__WEBPACK_IMPORTED_MODULE_3__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 421 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_assign_sync__ = __webpack_require__(222);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__submission_submission__ = __webpack_require__(422);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};










/**
 * Component that displays an assignment.
 */
var AddonModAssignIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModAssignIndexComponent, _super);
    function AddonModAssignIndexComponent(injector, assignProvider, content, assignHelper, assignOffline, syncProvider, timeUtils, groupsProvider, navCtrl) {
        var _this = _super.call(this, injector, content) || this;
        _this.assignProvider = assignProvider;
        _this.assignHelper = assignHelper;
        _this.assignOffline = assignOffline;
        _this.syncProvider = syncProvider;
        _this.timeUtils = timeUtils;
        _this.groupsProvider = groupsProvider;
        _this.navCtrl = navCtrl;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        _this.moduleName = 'assign';
        _this.showNumbers = true; // Whether to show number of submissions with each status.
        _this.groupInfo = {
            groups: [],
            separateGroups: false,
            visibleGroups: false
        };
        // Status.
        _this.submissionStatusSubmitted = __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_SUBMITTED;
        _this.submissionStatusDraft = __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_DRAFT;
        _this.needGrading = __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].NEED_GRADING;
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_8__providers_assign_sync__["a" /* AddonModAssignSyncProvider */].AUTO_SYNCED;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModAssignIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.userId = this.sitesProvider.getCurrentSiteUserId();
        this.loadContent(false, true).then(function () {
            _this.assignProvider.logView(_this.assign.id, _this.assign.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
            if (_this.canViewAllSubmissions) {
                // User can see all submissions, log grading view.
                _this.assignProvider.logGradingView(_this.assign.id, _this.assign.name).catch(function () {
                    // Ignore errors.
                });
            }
            else if (_this.canViewOwnSubmission) {
                // User can only see their own submission, log view the user submission.
                _this.assignProvider.logSubmissionView(_this.assign.id, _this.assign.name).catch(function () {
                    // Ignore errors.
                });
            }
        });
        // Listen to events.
        this.savedObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].SUBMISSION_SAVED_EVENT, function (data) {
            if (_this.assign && data.assignmentId == _this.assign.id && data.userId == _this.userId) {
                // Assignment submission saved, refresh data.
                _this.showLoadingAndRefresh(true, false);
            }
        }, this.siteId);
        this.submittedObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].SUBMITTED_FOR_GRADING_EVENT, function (data) {
            if (_this.assign && data.assignmentId == _this.assign.id && data.userId == _this.userId) {
                // Assignment submitted, check completion.
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
                // Reload data since it can have offline data now.
                _this.showLoadingAndRefresh(true, false);
            }
        }, this.siteId);
        this.gradedObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].GRADED_EVENT, function (data) {
            if (_this.assign && data.assignmentId == _this.assign.id && data.userId == _this.userId) {
                // Assignment graded, refresh data.
                _this.showLoadingAndRefresh(true, false);
            }
        }, this.siteId);
    };
    /**
     * Expand the description.
     */
    AddonModAssignIndexComponent.prototype.expandDescription = function (ev) {
        ev && ev.preventDefault();
        ev && ev.stopPropagation();
        if (this.assign && (this.description || this.assign.introattachments)) {
            this.textUtils.expandText(this.translate.instant('core.description'), this.description, this.component, this.module.id, this.assign.introattachments);
        }
    };
    /**
     * Get assignment data.
     *
     * @param {boolean} [refresh=false] If it's refreshing content.
     * @param {boolean} [sync=false] If it should try to sync.
     * @param {boolean} [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        // Get assignment data.
        return this.assignProvider.getAssignment(this.courseId, this.module.id).then(function (assignData) {
            _this.assign = assignData;
            _this.dataRetrieved.emit(_this.assign);
            _this.description = _this.assign.intro || _this.description;
            if (sync) {
                // Try to synchronize the assign.
                return _this.syncActivity(showErrors).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            // Check if there's any offline data for this assign.
            return _this.assignOffline.hasAssignOfflineData(_this.assign.id);
        }).then(function (hasOffline) {
            _this.hasOffline = hasOffline;
            // Get assignment submissions.
            return _this.assignProvider.getSubmissions(_this.assign.id).then(function (data) {
                var time = _this.timeUtils.timestamp();
                _this.canViewAllSubmissions = data.canviewsubmissions;
                if (data.canviewsubmissions) {
                    // Calculate the messages to display about time remaining and late submissions.
                    if (_this.assign.duedate > 0) {
                        if (_this.assign.duedate - time <= 0) {
                            _this.timeRemaining = _this.translate.instant('addon.mod_assign.assignmentisdue');
                        }
                        else {
                            _this.timeRemaining = _this.timeUtils.formatDuration(_this.assign.duedate - time, 3);
                            if (_this.assign.cutoffdate) {
                                if (_this.assign.cutoffdate > time) {
                                    _this.lateSubmissions = _this.translate.instant('addon.mod_assign.latesubmissionsaccepted', { $a: _this.timeUtils.userDate(_this.assign.cutoffdate * 1000) });
                                }
                                else {
                                    _this.lateSubmissions = _this.translate.instant('addon.mod_assign.nomoresubmissionsaccepted');
                                }
                            }
                            else {
                                _this.lateSubmissions = '';
                            }
                        }
                    }
                    else {
                        _this.timeRemaining = '';
                        _this.lateSubmissions = '';
                    }
                    // Check if groupmode is enabled to avoid showing wrong numbers.
                    return _this.groupsProvider.getActivityGroupInfo(_this.assign.cmid, false).then(function (groupInfo) {
                        _this.groupInfo = groupInfo;
                        _this.showNumbers = groupInfo.groups.length == 0 ||
                            _this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.5');
                        return _this.setGroup(_this.group || (groupInfo.groups && groupInfo.groups[0] && groupInfo.groups[0].id) ||
                            0);
                    });
                }
                // Check if the user can view their own submission.
                return _this.assignProvider.getSubmissionStatus(_this.assign.id).then(function () {
                    _this.canViewOwnSubmission = true;
                }).catch(function (error) {
                    _this.canViewOwnSubmission = false;
                    if (error.errorcode !== 'nopermission') {
                        return Promise.reject(error);
                    }
                });
            });
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Set group to see the summary.
     *
     * @param  {number}       groupId Group ID.
     * @return {Promise<any>}         Resolved when done.
     */
    AddonModAssignIndexComponent.prototype.setGroup = function (groupId) {
        var _this = this;
        this.group = groupId;
        return this.assignProvider.getSubmissionStatus(this.assign.id, undefined, this.group).then(function (response) {
            _this.summary = response.gradingsummary;
            _this.needsGradingAvalaible = response.gradingsummary && response.gradingsummary.submissionsneedgradingcount > 0 &&
                _this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.2');
        });
    };
    /**
     * Go to view a list of submissions.
     *
     * @param {string} status Status to see.
     * @param {number} count Number of submissions with the status.
     */
    AddonModAssignIndexComponent.prototype.goToSubmissionList = function (status, count) {
        if (typeof status == 'undefined') {
            this.navCtrl.push('AddonModAssignSubmissionListPage', {
                courseId: this.courseId,
                groupId: this.group || 0,
                moduleId: this.module.id,
                moduleName: this.moduleName
            });
        }
        else if (count || !this.showNumbers) {
            this.navCtrl.push('AddonModAssignSubmissionListPage', {
                status: status,
                courseId: this.courseId,
                groupId: this.group || 0,
                moduleId: this.module.id,
                moduleName: this.moduleName
            });
        }
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param {any} result Data returned by the sync function.
     * @return {boolean} If succeed or not.
     */
    AddonModAssignIndexComponent.prototype.hasSyncSucceed = function (result) {
        if (result.updated) {
            this.submissionComponent && this.submissionComponent.invalidateAndRefresh();
        }
        return result.updated;
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModAssignIndexComponent.prototype.invalidateContent = function () {
        var _this = this;
        var promises = [];
        promises.push(this.assignProvider.invalidateAssignmentData(this.courseId));
        if (this.assign) {
            promises.push(this.assignProvider.invalidateAllSubmissionData(this.assign.id));
            if (this.canViewAllSubmissions) {
                promises.push(this.assignProvider.invalidateSubmissionStatusData(this.assign.id, undefined, this.group));
            }
        }
        return Promise.all(promises).finally(function () {
            _this.submissionComponent && _this.submissionComponent.invalidateAndRefresh();
        });
    };
    /**
     * User entered the page that contains the component.
     */
    AddonModAssignIndexComponent.prototype.ionViewDidEnter = function () {
        _super.prototype.ionViewDidEnter.call(this);
        this.submissionComponent && this.submissionComponent.ionViewDidEnter();
    };
    /**
     * User left the page that contains the component.
     */
    AddonModAssignIndexComponent.prototype.ionViewDidLeave = function () {
        _super.prototype.ionViewDidLeave.call(this);
        this.submissionComponent && this.submissionComponent.ionViewDidLeave();
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean}          True if refresh is needed, false otherwise.
     */
    AddonModAssignIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (this.assign && syncEventData.assignId == this.assign.id) {
            if (syncEventData.warnings && syncEventData.warnings.length) {
                // Show warnings.
                this.domUtils.showErrorModal(syncEventData.warnings[0]);
            }
            return true;
        }
        return false;
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignIndexComponent.prototype.sync = function () {
        return this.syncProvider.syncAssign(this.assign.id);
    };
    /**
     * Component being destroyed.
     */
    AddonModAssignIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.savedObserver && this.savedObserver.off();
        this.submittedObserver && this.submittedObserver.off();
        this.gradedObserver && this.gradedObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_9__submission_submission__["a" /* AddonModAssignSubmissionComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_9__submission_submission__["a" /* AddonModAssignSubmissionComponent */])
    ], AddonModAssignIndexComponent.prototype, "submissionComponent", void 0);
    AddonModAssignIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\index\addon-mod-assign-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="assign && (description || (assign.introattachments && assign.introattachments.length))" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <!-- Description and intro attachments. -->\n    <ion-card *ngIf="description" (click)="expandDescription($event)">\n        <ion-item text-wrap>\n            <core-format-text [text]="description" [component]="component" [componentId]="componentId" maxHeight="120" (click)="expandDescription($event)"></core-format-text>\n        </ion-item>\n    </ion-card>\n\n    <ion-card *ngIf="assign && assign.introattachments && assign.introattachments.length">\n        <core-file *ngFor="let file of assign.introattachments" [file]="file" [component]="component" [componentId]="componentId"></core-file>\n    </ion-card>\n\n    <!-- Assign has something offline. -->\n    <div *ngIf="hasOffline" class="core-warning-card" icon-start>\n        <ion-icon name="warning"></ion-icon>\n        {{ \'core.hasdatatosync\' | translate:{$a: moduleName} }}\n    </div>\n\n    <!-- User can view all submissions (teacher). -->\n    <ion-list *ngIf="assign && canViewAllSubmissions" class="core-list-align-detail-right with-borders">\n        <ion-item text-wrap *ngIf="(groupInfo.separateGroups || groupInfo.visibleGroups)">\n            <ion-label id="addon-assign-groupslabel" *ngIf="groupInfo.separateGroups">{{ \'core.groupsseparate\' | translate }}</ion-label>\n            <ion-label id="addon-assign-groupslabel" *ngIf="groupInfo.visibleGroups">{{ \'core.groupsvisible\' | translate }}</ion-label>\n            <ion-select [(ngModel)]="group" (ionChange)="setGroup(group)" aria-labelledby="addon-assign-groupslabel" interface="action-sheet">\n                <ion-option *ngFor="let groupOpt of groupInfo.groups" [value]="groupOpt.id">{{groupOpt.name}}</ion-option>\n            </ion-select>\n        </ion-item>\n\n        <ion-item text-wrap *ngIf="timeRemaining">\n            <h2>{{ \'addon.mod_assign.timeremaining\' | translate }}</h2>\n            <p>{{ timeRemaining }}</p>\n        </ion-item>\n        <ion-item text-wrap *ngIf="lateSubmissions">\n            <h2>{{ \'addon.mod_assign.latesubmissions\' | translate }}</h2>\n            <p>{{ lateSubmissions }}</p>\n        </ion-item>\n\n        <!-- Summary of all submissions. -->\n        <a ion-item text-wrap *ngIf="summary && summary.participantcount" (click)="goToSubmissionList()">\n            <h2 *ngIf="assign.teamsubmission">{{ \'addon.mod_assign.numberofteams\' | translate }}</h2>\n            <h2 *ngIf="!assign.teamsubmission">{{ \'addon.mod_assign.numberofparticipants\' | translate }}</h2>\n            <ion-badge item-end *ngIf="showNumbers" color="primary">\n                {{ summary.participantcount }}\n            </ion-badge>\n        </a>\n\n        <!-- Summary of submissions with draft status. -->\n        <a ion-item text-wrap *ngIf="assign.submissiondrafts && summary && summary.submissionsenabled" [attr.detail-none]="(showNumbers && !summary.submissiondraftscount) ? true : null" (click)="goToSubmissionList(submissionStatusDraft, summary.submissiondraftscount)">\n            <h2>{{ \'addon.mod_assign.numberofdraftsubmissions\' | translate }}</h2>\n            <ion-badge item-end *ngIf="showNumbers" color="primary">\n                {{ summary.submissiondraftscount }}\n            </ion-badge>\n        </a>\n\n        <!-- Summary of submissions with submitted status. -->\n        <a ion-item text-wrap *ngIf="summary && summary.submissionsenabled" [attr.detail-none]="(showNumbers && !summary.submissionssubmittedcount) ? true : null" (click)="goToSubmissionList(submissionStatusSubmitted, summary.submissionssubmittedcount)">\n            <h2>{{ \'addon.mod_assign.numberofsubmittedassignments\' | translate }}</h2>\n            <ion-badge item-end *ngIf="showNumbers" color="primary">\n                {{ summary.submissionssubmittedcount }}\n            </ion-badge>\n        </a>\n\n        <!-- Summary of submissions that need grading. -->\n        <a ion-item text-wrap *ngIf="summary && summary.submissionsenabled && !assign.teamsubmission && showNumbers" [attr.detail-none]="needsGradingAvalaible ? null : true" (click)="goToSubmissionList(needGrading, needsGradingAvalaible)">\n            <h2>{{ \'addon.mod_assign.numberofsubmissionsneedgrading\' | translate }}</h2>\n            <ion-badge item-end color="primary">\n                {{ summary.submissionsneedgradingcount }}\n            </ion-badge>\n        </a>\n\n        <!-- Ungrouped users. -->\n        <div *ngIf="assign.teamsubmission && summary && summary.warnofungroupedusers" class="core-info-card" icon-start>\n            <ion-icon name="information-circle"></ion-icon>\n            {{ \'addon.mod_assign.ungroupedusers\' | translate }}\n        </div>\n    </ion-list>\n\n    <!-- If it\'s a student, display his submission. -->\n    <addon-mod-assign-submission *ngIf="loaded && !canViewAllSubmissions && canViewOwnSubmission" [courseId]="courseId" [moduleId]="module.id"></addon-mod-assign-submission>\n\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\index\addon-mod-assign-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModAssignHelperProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_assign_sync__["a" /* AddonModAssignSyncProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], AddonModAssignIndexComponent);
    return AddonModAssignIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 422 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_fileuploader_providers_helper__ = __webpack_require__(122);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_grades_providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__components_tabs_tabs__ = __webpack_require__(151);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__components_split_view_split_view__ = __webpack_require__(121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__submission_plugin_submission_plugin__ = __webpack_require__(771);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};























/**
 * Component that displays an assignment submission.
 */
var AddonModAssignSubmissionComponent = /** @class */ (function () {
    function AddonModAssignSubmissionComponent(navCtrl, appProvider, domUtils, sitesProvider, syncProvider, timeUtils, textUtils, translate, utils, eventsProvider, courseProvider, fileUploaderHelper, gradesHelper, userProvider, groupsProvider, langProvider, assignProvider, assignHelper, assignOfflineProvider, splitviewCtrl) {
        this.navCtrl = navCtrl;
        this.appProvider = appProvider;
        this.domUtils = domUtils;
        this.syncProvider = syncProvider;
        this.timeUtils = timeUtils;
        this.textUtils = textUtils;
        this.translate = translate;
        this.utils = utils;
        this.eventsProvider = eventsProvider;
        this.courseProvider = courseProvider;
        this.fileUploaderHelper = fileUploaderHelper;
        this.gradesHelper = gradesHelper;
        this.userProvider = userProvider;
        this.groupsProvider = groupsProvider;
        this.langProvider = langProvider;
        this.assignProvider = assignProvider;
        this.assignHelper = assignHelper;
        this.assignOfflineProvider = assignOfflineProvider;
        this.splitviewCtrl = splitviewCtrl;
        this.submitModel = {}; // Model where to store the data to submit (for grading).
        // Some constants.
        this.statusNew = __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_NEW;
        this.statusReopened = __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_REOPENED;
        this.attemptReopenMethodNone = __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].ATTEMPT_REOPEN_METHOD_NONE;
        this.unlimitedAttempts = __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].UNLIMITED_ATTEMPTS;
        this.originalGrades = {}; // Object with the original grade data, to check for changes.
        this.siteId = sitesProvider.getCurrentSiteId();
        this.currentUserId = sitesProvider.getCurrentSiteUserId();
    }
    /**
     * Component being initialized.
     */
    AddonModAssignSubmissionComponent.prototype.ngOnInit = function () {
        this.selectedTab = this.showGrade && this.showGrade !== 'false' ? 1 : 0;
        this.isSubmittedForGrading = !!this.submitId;
        this.loadData();
    };
    /**
     * Calculate the time remaining message and class.
     *
     * @param {any} response Response of get submission status.
     */
    AddonModAssignSubmissionComponent.prototype.calculateTimeRemaining = function (response) {
        if (this.assign.duedate > 0) {
            var time = this.timeUtils.timestamp(), dueDate = response.lastattempt && response.lastattempt.extensionduedate ?
                response.lastattempt.extensionduedate : this.assign.duedate, timeRemaining = dueDate - time;
            if (timeRemaining <= 0) {
                if (!this.userSubmission || this.userSubmission.status != __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].SUBMISSION_STATUS_SUBMITTED) {
                    if ((response.lastattempt && response.lastattempt.submissionsenabled) ||
                        (response.gradingsummary && response.gradingsummary.submissionsenabled)) {
                        this.timeRemaining = this.translate.instant('addon.mod_assign.overdue', { $a: this.timeUtils.formatDuration(-timeRemaining, 3) });
                        this.timeRemainingClass = 'overdue';
                    }
                    else {
                        this.timeRemaining = this.translate.instant('addon.mod_assign.duedatereached');
                        this.timeRemainingClass = '';
                    }
                }
                else {
                    var timeSubmittedDiff = this.userSubmission.timemodified - dueDate;
                    if (timeSubmittedDiff > 0) {
                        this.timeRemaining = this.translate.instant('addon.mod_assign.submittedlate', { $a: this.timeUtils.formatDuration(timeSubmittedDiff, 2) });
                        this.timeRemainingClass = 'latesubmission';
                    }
                    else {
                        this.timeRemaining = this.translate.instant('addon.mod_assign.submittedearly', { $a: this.timeUtils.formatDuration(-timeSubmittedDiff, 2) });
                        this.timeRemainingClass = 'earlysubmission';
                    }
                }
            }
            else {
                this.timeRemaining = this.timeUtils.formatDuration(timeRemaining, 3);
                this.timeRemainingClass = '';
            }
        }
        else {
            this.timeRemaining = '';
            this.timeRemainingClass = '';
        }
    };
    /**
     * Check if the user can leave the view. If there are changes to be saved, it will ask for confirm.
     *
     * @return {Promise<void>} Promise resolved if can leave the view, rejected otherwise.
     */
    AddonModAssignSubmissionComponent.prototype.canLeave = function () {
        var _this = this;
        // Check if there is data to save.
        return this.hasDataToSave().then(function (modified) {
            if (modified) {
                // Modified, confirm user wants to go back.
                return _this.domUtils.showConfirm(_this.translate.instant('core.confirmcanceledit')).then(function () {
                    return _this.discardDrafts().catch(function () {
                        // Ignore errors.
                    });
                });
            }
        });
    };
    /**
     * Copy a previous attempt and then go to edit.
     */
    AddonModAssignSubmissionComponent.prototype.copyPrevious = function () {
        var _this = this;
        if (!this.appProvider.isOnline()) {
            this.domUtils.showErrorModal('core.networkerrormsg', true);
            return;
        }
        if (!this.previousAttempt) {
            // Cannot access previous attempts, just go to edit.
            return this.goToEdit();
        }
        var previousSubmission = this.assignProvider.getSubmissionObjectFromAttempt(this.assign, this.previousAttempt);
        var modal = this.domUtils.showModalLoading();
        this.assignHelper.getSubmissionSizeForCopy(this.assign, previousSubmission).catch(function () {
            // Error calculating size, return -1.
            return -1;
        }).then(function (size) {
            modal.dismiss();
            // Confirm action.
            return _this.fileUploaderHelper.confirmUploadFile(size, true);
        }).then(function () {
            // User confirmed, copy the attempt.
            modal = _this.domUtils.showModalLoading('core.sending', true);
            _this.assignHelper.copyPreviousAttempt(_this.assign, previousSubmission).then(function () {
                // Now go to edit.
                _this.goToEdit();
                if (!_this.assign.submissiondrafts) {
                    // No drafts allowed, so it was submitted. Trigger event.
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].SUBMITTED_FOR_GRADING_EVENT, {
                        assignmentId: _this.assign.id,
                        submissionId: _this.userSubmission.id,
                        userId: _this.currentUserId
                    }, _this.siteId);
                }
                else {
                    // Invalidate and refresh data to update this view.
                    _this.invalidateAndRefresh();
                }
            }).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'core.error', true);
            }).finally(function () {
                modal.dismiss();
            });
        }).catch(function () {
            // Cancelled.
        });
    };
    /**
     * Discard feedback drafts.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionComponent.prototype.discardDrafts = function () {
        if (this.feedback && this.feedback.plugins) {
            return this.assignHelper.discardFeedbackPluginData(this.assign.id, this.submitId, this.feedback);
        }
        return Promise.resolve();
    };
    /**
     * Go to the page to add or edit submission.
     */
    AddonModAssignSubmissionComponent.prototype.goToEdit = function () {
        this.navCtrl.push('AddonModAssignEditPage', {
            moduleId: this.moduleId,
            courseId: this.courseId,
            userId: this.submitId,
            blindId: this.blindId
        });
    };
    /**
     * Check if there's data to save (grade).
     *
     * @return {Promise<boolean>} Promise resolved with boolean: whether there's data to save.
     */
    AddonModAssignSubmissionComponent.prototype.hasDataToSave = function () {
        if (!this.canSaveGrades || !this.loaded) {
            return Promise.resolve(false);
        }
        // Check if numeric grade and toggles changed.
        if (this.originalGrades.grade != this.grade.grade || this.originalGrades.addAttempt != this.grade.addAttempt ||
            this.originalGrades.applyToAll != this.grade.applyToAll) {
            return Promise.resolve(true);
        }
        // Check if outcomes changed.
        if (this.gradeInfo && this.gradeInfo.outcomes) {
            for (var x in this.gradeInfo.outcomes) {
                var outcome = this.gradeInfo.outcomes[x];
                if (this.originalGrades.outcomes[outcome.id] == 'undefined' ||
                    this.originalGrades.outcomes[outcome.id] != outcome.selectedId) {
                    return Promise.resolve(true);
                }
            }
        }
        if (this.feedback && this.feedback.plugins) {
            return this.assignHelper.hasFeedbackDataChanged(this.assign, this.submitId, this.feedback).catch(function () {
                // Error ocurred, consider there are no changes.
                return false;
            });
        }
        return Promise.resolve(false);
    };
    /**
     * User entered the page that contains the component.
     */
    AddonModAssignSubmissionComponent.prototype.ionViewDidEnter = function () {
        this.tabs && this.tabs.ionViewDidEnter();
    };
    /**
     * User left the page that contains the component.
     */
    AddonModAssignSubmissionComponent.prototype.ionViewDidLeave = function () {
        this.tabs && this.tabs.ionViewDidLeave();
    };
    /**
     * Invalidate and refresh data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionComponent.prototype.invalidateAndRefresh = function () {
        var _this = this;
        this.loaded = false;
        var promises = [];
        promises.push(this.assignProvider.invalidateAssignmentData(this.courseId));
        if (this.assign) {
            promises.push(this.assignProvider.invalidateSubmissionStatusData(this.assign.id, this.submitId, undefined, !!this.blindId));
            promises.push(this.assignProvider.invalidateAssignmentUserMappingsData(this.assign.id));
            promises.push(this.assignProvider.invalidateListParticipantsData(this.assign.id));
        }
        promises.push(this.gradesHelper.invalidateGradeModuleItems(this.courseId, this.submitId));
        promises.push(this.courseProvider.invalidateModule(this.moduleId));
        // Invalidate plugins.
        if (this.submissionComponents && this.submissionComponents.length) {
            this.submissionComponents.forEach(function (component) {
                promises.push(component.invalidate());
            });
        }
        return Promise.all(promises).catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.loadData();
        });
    };
    /**
     * Load the data to render the submission.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionComponent.prototype.loadData = function () {
        var _this = this;
        var isBlind = !!this.blindId;
        this.previousAttempt = undefined;
        if (!this.submitId) {
            this.submitId = this.currentUserId;
            isBlind = false;
        }
        // Get the assignment.
        return this.assignProvider.getAssignment(this.courseId, this.moduleId).then(function (assign) {
            var time = _this.timeUtils.timestamp(), promises = [];
            _this.assign = assign;
            if (assign.allowsubmissionsfromdate && assign.allowsubmissionsfromdate >= time) {
                _this.fromDate = _this.timeUtils.userDate(assign.allowsubmissionsfromdate * 1000);
            }
            _this.currentAttempt = 0;
            _this.maxAttemptsText = _this.translate.instant('addon.mod_assign.unlimitedattempts');
            _this.blindMarking = _this.isSubmittedForGrading && assign.blindmarking && !assign.revealidentities;
            if (!_this.blindMarking && _this.submitId != _this.currentUserId) {
                promises.push(_this.userProvider.getProfile(_this.submitId, _this.courseId).then(function (profile) {
                    _this.user = profile;
                }));
            }
            // Check if there's any offline data for this submission.
            promises.push(_this.assignOfflineProvider.getSubmission(assign.id, _this.submitId).then(function (data) {
                _this.hasOffline = data && data.plugindata && Object.keys(data.plugindata).length > 0;
                _this.submittedOffline = data && data.submitted;
            }).catch(function () {
                // No offline data found.
                _this.hasOffline = false;
                _this.submittedOffline = false;
            }));
            return Promise.all(promises);
        }).then(function () {
            // Get submission status.
            return _this.assignProvider.getSubmissionStatusWithRetry(_this.assign, _this.submitId, undefined, isBlind);
        }).then(function (response) {
            var promises = [];
            _this.submissionStatusAvailable = true;
            _this.lastAttempt = response.lastattempt;
            _this.membersToSubmit = [];
            // Search the previous attempt.
            if (response.previousattempts && response.previousattempts.length > 0) {
                var previousAttempts = response.previousattempts.sort(function (a, b) {
                    return a.attemptnumber - b.attemptnumber;
                });
                _this.previousAttempt = previousAttempts[previousAttempts.length - 1];
            }
            // Treat last attempt.
            _this.treatLastAttempt(response, promises);
            // Calculate the time remaining.
            _this.calculateTimeRemaining(response);
            // Load the feedback.
            promises.push(_this.loadFeedback(response.feedback));
            // Check if there's any unsupported plugin for editing.
            if (!_this.userSubmission || !_this.userSubmission.plugins) {
                // Submission not created yet, we have to use assign configs to detect the plugins used.
                _this.userSubmission = {};
                _this.userSubmission.plugins = _this.assignHelper.getPluginsEnabled(_this.assign, 'assignsubmission');
            }
            // Get the submission plugins that don't support editing.
            promises.push(_this.assignProvider.getUnsupportedEditPlugins(_this.userSubmission.plugins).then(function (list) {
                _this.unsupportedEditPlugins = list;
            }));
            return Promise.all(promises);
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'Error getting assigment data.');
        }).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Load the data to render the feedback and grade.
     *
     * @param {any} feedback The feedback data from the submission status.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionComponent.prototype.loadFeedback = function (feedback) {
        var _this = this;
        this.grade = {
            method: false,
            grade: false,
            gradebookGrade: false,
            modified: 0,
            gradingStatus: false,
            addAttempt: false,
            applyToAll: false,
            scale: false,
            lang: false,
            disabled: false
        };
        this.originalGrades = {
            grade: false,
            addAttempt: false,
            applyToAll: false,
            outcomes: {}
        };
        if (feedback) {
            this.feedback = feedback;
            // If we have data about the grader, get its profile.
            if (feedback.grade && feedback.grade.grader > 0) {
                this.userProvider.getProfile(feedback.grade.grader, this.courseId).then(function (profile) {
                    _this.grader = profile;
                }).catch(function () {
                    // Ignore errors.
                });
            }
            else {
                delete this.grader;
            }
            // Check if the grade uses advanced grading.
            if (feedback.gradefordisplay) {
                var position = feedback.gradefordisplay.indexOf('class="advancedgrade"');
                if (position > -1) {
                    this.feedback.advancedgrade = true;
                }
            }
            // Do not override already loaded grade.
            if (feedback.grade && feedback.grade.grade && !this.grade.grade) {
                var parsedGrade = parseFloat(feedback.grade.grade);
                this.grade.grade = parsedGrade >= 0 ? parsedGrade : null;
                this.grade.gradebookGrade = this.utils.formatFloat(this.grade.grade);
                this.originalGrades.grade = this.grade.grade;
            }
        }
        else {
            // If no feedback, always show Submission.
            this.selectedTab = 0;
            this.tabs.selectTab(0);
        }
        this.grade.gradingStatus = this.lastAttempt && this.lastAttempt.gradingstatus;
        // Get the grade for the assign.
        return this.courseProvider.getModuleBasicGradeInfo(this.moduleId).then(function (gradeInfo) {
            _this.gradeInfo = gradeInfo;
            if (!gradeInfo) {
                return;
            }
            // Make sure outcomes is an array.
            gradeInfo.outcomes = gradeInfo.outcomes || [];
            if (!_this.isDestroyed) {
                // Block the assignment.
                _this.syncProvider.blockOperation(__WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, _this.assign.id);
            }
            // Treat the grade info.
            return _this.treatGradeInfo();
        }).then(function () {
            if (!_this.isGrading) {
                return;
            }
            var isManual = _this.assign.attemptreopenmethod == __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].ATTEMPT_REOPEN_METHOD_MANUAL, isUnlimited = _this.assign.maxattempts == __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].UNLIMITED_ATTEMPTS, isLessThanMaxAttempts = _this.userSubmission && (_this.userSubmission.attemptnumber < (_this.assign.maxattempts - 1));
            _this.allowAddAttempt = isManual && (!_this.userSubmission || isUnlimited || isLessThanMaxAttempts);
            if (_this.assign.teamsubmission) {
                _this.grade.applyToAll = true;
                _this.originalGrades.applyToAll = true;
            }
            if (_this.assign.markingworkflow && _this.grade.gradingStatus) {
                _this.workflowStatusTranslationId =
                    _this.assignProvider.getSubmissionGradingStatusTranslationId(_this.grade.gradingStatus);
            }
            if (_this.isGrading && _this.lastAttempt.gradingstatus == 'graded' && !_this.assign.markingworkflow) {
                if (_this.feedback.gradeddate < _this.lastAttempt.submission.timemodified) {
                    _this.lastAttempt.gradingstatus = __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].GRADED_FOLLOWUP_SUBMIT;
                    // Get grading text and color.
                    _this.gradingStatusTranslationId = _this.assignProvider.getSubmissionGradingStatusTranslationId(_this.lastAttempt.gradingstatus);
                    _this.gradingColor = _this.assignProvider.getSubmissionGradingStatusColor(_this.lastAttempt.gradingstatus);
                }
            }
            if (!_this.feedback || !_this.feedback.plugins) {
                // Feedback plugins not present, we have to use assign configs to detect the plugins used.
                _this.feedback = {};
                _this.feedback.plugins = _this.assignHelper.getPluginsEnabled(_this.assign, 'assignfeedback');
            }
            // Check if there's any offline data for this submission.
            if (_this.canSaveGrades) {
                // Submission grades aren't identified by attempt number so it can retrieve the feedback for a previous attempt.
                // The app will not treat that as an special case.
                return _this.assignOfflineProvider.getSubmissionGrade(_this.assign.id, _this.submitId).catch(function () {
                    // Grade not found.
                }).then(function (data) {
                    // Load offline grades.
                    if (data && (!feedback || !feedback.gradeddate || feedback.gradeddate < data.timemodified)) {
                        // If grade has been modified from gradebook, do not use offline.
                        if (_this.grade.modified < data.timemodified) {
                            _this.grade.grade = !_this.grade.scale ? _this.utils.formatFloat(data.grade) : data.grade;
                            _this.gradingStatusTranslationId = 'addon.mod_assign.gradenotsynced';
                            _this.gradingColor = '';
                            _this.originalGrades.grade = _this.grade.grade;
                        }
                        _this.grade.applyToAll = data.applytoall;
                        _this.grade.addAttempt = data.addattempt;
                        _this.originalGrades.applyToAll = _this.grade.applyToAll;
                        _this.originalGrades.addAttempt = _this.grade.addAttempt;
                        if (data.outcomes && Object.keys(data.outcomes).length) {
                            _this.gradeInfo.outcomes.forEach(function (outcome) {
                                if (typeof data.outcomes[outcome.itemNumber] != 'undefined') {
                                    // If outcome has been modified from gradebook, do not use offline.
                                    if (outcome.modified < data.timemodified) {
                                        outcome.selectedId = data.outcomes[outcome.itemNumber];
                                        _this.originalGrades.outcomes[outcome.id] = outcome.selectedId;
                                    }
                                }
                            });
                        }
                    }
                });
            }
            else {
                // User cannot save grades in the app. Load the URL to grade it in browser.
                return _this.courseProvider.getModule(_this.moduleId, _this.courseId, undefined, true).then(function (mod) {
                    _this.gradeUrl = mod.url + '&action=grader&userid=' + _this.submitId;
                });
            }
        });
    };
    /**
     * Open a user profile.
     *
     * @param {number} userId User to open.
     */
    AddonModAssignSubmissionComponent.prototype.openUserProfile = function (userId) {
        // Open a user profile. If this component is inside a split view, use the master nav to open it.
        var navCtrl = this.splitviewCtrl ? this.splitviewCtrl.getMasterNav() : this.navCtrl;
        navCtrl.push('CoreUserProfilePage', { userId: userId, courseId: this.courseId });
    };
    /**
     * Set the submission status name and class.
     *
     * @param {any} status Submission status.
     */
    AddonModAssignSubmissionComponent.prototype.setStatusNameAndClass = function (status) {
        if (this.hasOffline || this.submittedOffline) {
            // Offline data.
            this.statusTranslated = this.translate.instant('core.notsent');
            this.statusColor = 'warning';
        }
        else if (!this.assign.teamsubmission) {
            // Single submission.
            if (this.userSubmission && this.userSubmission.status != this.statusNew) {
                this.statusTranslated = this.translate.instant('addon.mod_assign.submissionstatus_' + this.userSubmission.status);
                this.statusColor = this.assignProvider.getSubmissionStatusColor(this.userSubmission.status);
            }
            else {
                if (!status.lastattempt.submissionsenabled) {
                    this.statusTranslated = this.translate.instant('addon.mod_assign.noonlinesubmissions');
                    this.statusColor = this.assignProvider.getSubmissionStatusColor('noonlinesubmissions');
                }
                else {
                    this.statusTranslated = this.translate.instant('addon.mod_assign.noattempt');
                    this.statusColor = this.assignProvider.getSubmissionStatusColor('noattempt');
                }
            }
        }
        else {
            // Team submission.
            if (!status.lastattempt.submissiongroup && this.assign.preventsubmissionnotingroup) {
                this.statusTranslated = this.translate.instant('addon.mod_assign.nosubmission');
                this.statusColor = this.assignProvider.getSubmissionStatusColor('nosubmission');
            }
            else if (this.userSubmission && this.userSubmission.status != this.statusNew) {
                this.statusTranslated = this.translate.instant('addon.mod_assign.submissionstatus_' + this.userSubmission.status);
                this.statusColor = this.assignProvider.getSubmissionStatusColor(this.userSubmission.status);
            }
            else {
                if (!status.lastattempt.submissionsenabled) {
                    this.statusTranslated = this.translate.instant('addon.mod_assign.noonlinesubmissions');
                    this.statusColor = this.assignProvider.getSubmissionStatusColor('noonlinesubmissions');
                }
                else {
                    this.statusTranslated = this.translate.instant('addon.mod_assign.nosubmission');
                    this.statusColor = this.assignProvider.getSubmissionStatusColor('nosubmission');
                }
            }
        }
    };
    /**
     * Show advanced grade.
     */
    AddonModAssignSubmissionComponent.prototype.showAdvancedGrade = function () {
        if (this.feedback && this.feedback.advancedgrade) {
            this.textUtils.expandText(this.translate.instant('core.grades.grade'), this.feedback.gradefordisplay, __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, this.moduleId);
        }
    };
    /**
     * Submit for grading.
     *
     * @param {boolean} acceptStatement Whether the statement has been accepted.
     */
    AddonModAssignSubmissionComponent.prototype.submitForGrading = function (acceptStatement) {
        var _this = this;
        if (this.assign.requiresubmissionstatement && !acceptStatement) {
            this.domUtils.showErrorModal('addon.mod_assign.acceptsubmissionstatement', true);
            return;
        }
        // Ask for confirmation. @todo plugin precheck_submission
        this.domUtils.showConfirm(this.translate.instant('addon.mod_assign.confirmsubmission')).then(function () {
            var modal = _this.domUtils.showModalLoading('core.sending', true);
            _this.assignProvider.submitForGrading(_this.assign.id, _this.courseId, acceptStatement, _this.userSubmission.timemodified, _this.hasOffline).then(function () {
                // Submitted, trigger event.
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].SUBMITTED_FOR_GRADING_EVENT, {
                    assignmentId: _this.assign.id,
                    submissionId: _this.userSubmission.id,
                    userId: _this.currentUserId
                }, _this.siteId);
            }).finally(function () {
                modal.dismiss();
            });
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.error', true);
        });
    };
    /**
     * Submit a grade and feedback.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionComponent.prototype.submitGrade = function () {
        var _this = this;
        // Check if there's something to be saved.
        return this.hasDataToSave().then(function (modified) {
            if (!modified) {
                return;
            }
            var attemptNumber = _this.userSubmission ? _this.userSubmission.attemptnumber : -1, outcomes = {}, 
            // Scale "no grade" uses -1 instead of 0.
            grade = _this.grade.scale && _this.grade.grade == 0 ? -1 : _this.utils.unformatFloat(_this.grade.grade, true);
            if (grade === false) {
                // Grade is invalid.
                return Promise.reject(_this.translate.instant('core.grades.badgrade'));
            }
            var modal = _this.domUtils.showModalLoading('core.sending', true);
            var pluginPromise;
            _this.gradeInfo.outcomes.forEach(function (outcome) {
                if (outcome.itemNumber) {
                    outcomes[outcome.itemNumber] = outcome.selectedId;
                }
            });
            if (_this.feedback && _this.feedback.plugins) {
                pluginPromise = _this.assignHelper.prepareFeedbackPluginData(_this.assign.id, _this.submitId, _this.feedback);
            }
            else {
                pluginPromise = Promise.resolve({});
            }
            return pluginPromise.then(function (pluginData) {
                // We have all the data, now send it.
                return _this.assignProvider.submitGradingForm(_this.assign.id, _this.submitId, _this.courseId, grade, attemptNumber, _this.grade.addAttempt, _this.grade.gradingStatus, _this.grade.applyToAll, outcomes, pluginData).then(function () {
                    // Data sent, discard draft.
                    return _this.discardDrafts();
                }).finally(function () {
                    // Invalidate and refresh data.
                    _this.invalidateAndRefresh();
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].GRADED_EVENT, {
                        assignmentId: _this.assign.id,
                        submissionId: _this.submitId,
                        userId: _this.currentUserId
                    }, _this.siteId);
                });
            }).finally(function () {
                // Select submission view.
                _this.tabs.selectTab(0);
                modal.dismiss();
            });
        });
    };
    /**
     * Treat the grade info.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionComponent.prototype.treatGradeInfo = function () {
        var _this = this;
        // Check if grading method is simple or not.
        if (this.gradeInfo.advancedgrading && this.gradeInfo.advancedgrading[0] &&
            typeof this.gradeInfo.advancedgrading[0].method != 'undefined') {
            this.grade.method = this.gradeInfo.advancedgrading[0].method || 'simple';
        }
        else {
            this.grade.method = 'simple';
        }
        this.isGrading = true;
        this.canSaveGrades = this.grade.method == 'simple'; // Grades can be saved if simple grading.
        if (this.gradeInfo.scale) {
            this.grade.scale = this.utils.makeMenuFromList(this.gradeInfo.scale, this.translate.instant('core.nograde'));
        }
        else {
            // Format the grade.
            this.grade.grade = this.utils.formatFloat(this.grade.grade);
            this.originalGrades.grade = this.grade.grade;
            // Get current language to format grade input field.
            this.langProvider.getCurrentLanguage().then(function (lang) {
                _this.grade.lang = lang;
            });
        }
        // Treat outcomes.
        if (this.assignProvider.isOutcomesEditEnabled()) {
            this.gradeInfo.outcomes.forEach(function (outcome) {
                if (outcome.scale) {
                    outcome.options =
                        _this.utils.makeMenuFromList(outcome.scale, _this.translate.instant('core.grades.nooutcome'));
                }
                outcome.selectedId = 0;
                _this.originalGrades.outcomes[outcome.id] = outcome.selectedId;
            });
        }
        // Get grade items.
        return this.gradesHelper.getGradeModuleItems(this.courseId, this.moduleId, this.submitId).then(function (grades) {
            var outcomes = [];
            grades.forEach(function (grade) {
                if (!grade.outcomeid && !grade.scaleid) {
                    // Not using outcomes or scale, get the numeric grade.
                    if (_this.grade.scale) {
                        _this.grade.gradebookGrade = _this.utils.formatFloat(_this.gradesHelper.getGradeValueFromLabel(_this.grade.scale, grade.gradeformatted));
                    }
                    else {
                        var parsedGrade = parseFloat(grade.gradeformatted);
                        _this.grade.gradebookGrade = parsedGrade || parsedGrade == 0 ? _this.utils.formatFloat(parsedGrade) : null;
                    }
                    _this.grade.disabled = grade.gradeislocked || grade.gradeisoverridden;
                    _this.grade.modified = grade.gradedategraded;
                }
                else if (grade.outcomeid) {
                    // Only show outcomes with info on it, outcomeid could be null if outcomes are disabled on site.
                    _this.gradeInfo.outcomes.forEach(function (outcome) {
                        if (outcome.id == grade.outcomeid) {
                            outcome.selected = grade.gradeformatted;
                            outcome.modified = grade.gradedategraded;
                            if (outcome.options) {
                                outcome.selectedId = _this.gradesHelper.getGradeValueFromLabel(outcome.options, outcome.selected);
                                _this.originalGrades.outcomes[outcome.id] = outcome.selectedId;
                                outcome.itemNumber = grade.itemnumber;
                            }
                            outcomes.push(outcome);
                        }
                    });
                    _this.gradeInfo.disabled = grade.gradeislocked || grade.gradeisoverridden;
                }
            });
            _this.gradeInfo.outcomes = outcomes;
        });
    };
    /**
     * Treat the last attempt.
     *
     * @param {any} response Response of get submission status.
     * @param {any[]} promises List where to add the promises.
     */
    AddonModAssignSubmissionComponent.prototype.treatLastAttempt = function (response, promises) {
        var _this = this;
        if (!response.lastattempt) {
            return;
        }
        var submissionStatementMissing = this.assign.requiresubmissionstatement &&
            typeof this.assign.submissionstatement == 'undefined';
        this.canSubmit = !this.isSubmittedForGrading && !this.submittedOffline && (response.lastattempt.cansubmit ||
            (this.hasOffline && this.assignProvider.canSubmitOffline(this.assign, response)));
        this.canEdit = !this.isSubmittedForGrading && response.lastattempt.canedit &&
            (!this.submittedOffline || !this.assign.submissiondrafts);
        // Get submission statement if needed.
        if (this.assign.requiresubmissionstatement && this.assign.submissiondrafts && this.submitId == this.currentUserId) {
            this.submissionStatement = this.assign.submissionstatement;
            this.submitModel.submissionStatement = false;
        }
        else {
            this.submissionStatement = undefined;
            this.submitModel.submissionStatement = true; // No submission statement, so it's accepted.
        }
        // Show error if submission statement should be shown but it couldn't be retrieved.
        this.showErrorStatementEdit = submissionStatementMissing && !this.assign.submissiondrafts &&
            this.submitId == this.currentUserId;
        this.showErrorStatementSubmit = submissionStatementMissing && this.assign.submissiondrafts;
        this.userSubmission = this.assignProvider.getSubmissionObjectFromAttempt(this.assign, response.lastattempt);
        if (this.assign.attemptreopenmethod != this.attemptReopenMethodNone && this.userSubmission) {
            this.currentAttempt = this.userSubmission.attemptnumber + 1;
        }
        this.setStatusNameAndClass(response);
        if (this.assign.teamsubmission) {
            if (response.lastattempt.submissiongroup) {
                // Get the name of the group.
                promises.push(this.groupsProvider.getActivityAllowedGroups(this.assign.cmid).then(function (groups) {
                    groups.forEach(function (group) {
                        if (group.id == response.lastattempt.submissiongroup) {
                            _this.lastAttempt.submissiongroupname = group.name;
                        }
                    });
                }));
            }
            // Get the members that need to submit.
            if (this.userSubmission && this.userSubmission.status != this.statusNew) {
                response.lastattempt.submissiongroupmemberswhoneedtosubmit.forEach(function (member) {
                    if (_this.blindMarking) {
                        // Users not blinded! (Moodle < 3.1.1, 3.2).
                        promises.push(_this.assignProvider.getAssignmentUserMappings(_this.assign.id, member).then(function (blindId) {
                            _this.membersToSubmit.push(blindId);
                        }));
                    }
                    else {
                        promises.push(_this.userProvider.getProfile(member, _this.courseId).then(function (profile) {
                            _this.membersToSubmit.push(profile);
                        }));
                    }
                });
            }
        }
        // Get grading text and color.
        this.gradingStatusTranslationId = this.assignProvider.getSubmissionGradingStatusTranslationId(response.lastattempt.gradingstatus);
        this.gradingColor = this.assignProvider.getSubmissionGradingStatusColor(response.lastattempt.gradingstatus);
        // Get the submission plugins.
        if (this.userSubmission) {
            if (!this.assign.teamsubmission || !response.lastattempt.submissiongroup || !this.assign.preventsubmissionnotingroup) {
                if (this.previousAttempt && this.previousAttempt.submission.plugins &&
                    this.userSubmission.status == this.statusReopened) {
                    // Get latest attempt if avalaible.
                    this.submissionPlugins = this.previousAttempt.submission.plugins;
                }
                else {
                    this.submissionPlugins = this.userSubmission.plugins;
                }
            }
        }
    };
    /**
     * Component being destroyed.
     */
    AddonModAssignSubmissionComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        if (this.assign && this.isGrading) {
            this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, this.assign.id);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_20__components_tabs_tabs__["a" /* CoreTabsComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_20__components_tabs_tabs__["a" /* CoreTabsComponent */])
    ], AddonModAssignSubmissionComponent.prototype, "tabs", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChildren"])(__WEBPACK_IMPORTED_MODULE_22__submission_plugin_submission_plugin__["a" /* AddonModAssignSubmissionPluginComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["QueryList"])
    ], AddonModAssignSubmissionComponent.prototype, "submissionComponents", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModAssignSubmissionComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModAssignSubmissionComponent.prototype, "moduleId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModAssignSubmissionComponent.prototype, "submitId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModAssignSubmissionComponent.prototype, "blindId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionComponent.prototype, "showGrade", void 0);
    AddonModAssignSubmissionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-submission',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\submission\addon-mod-assign-submission.html"*/'<core-loading [hideUntil]="loaded">\n\n    <!-- User and status of the submission. -->\n    <a ion-item text-wrap *ngIf="!blindMarking && user" (click)="openUserProfile(submitId)" [title]="user.fullname">\n        <ion-avatar core-user-avatar [user]="user" item-start></ion-avatar>\n        <h2>{{ user.fullname }}</h2>\n        <ng-container *ngTemplateOutlet="submissionStatus"></ng-container>\n    </a>\n\n    <!-- Status of the submission if user is blinded. -->\n    <ion-item text-wrap *ngIf="blindMarking && !user">\n        <h2>{{ \'addon.mod_assign.hiddenuser\' | translate }} {{blindId}}</h2>\n        <ng-container *ngTemplateOutlet="submissionStatus"></ng-container>\n    </ion-item>\n\n    <!-- Status of the submission in the rest of cases. -->\n    <ion-item text-wrap *ngIf="(blindMarking && user) || (!blindMarking && !user)">\n        <h2>{{ \'addon.mod_assign.submissionstatus\' | translate }}</h2>\n        <ng-container *ngTemplateOutlet="submissionStatus"></ng-container>\n    </ion-item>\n\n    <!-- Tabs: see the submission or grade it. -->\n    <core-tabs [selectedIndex]="selectedTab" [hideUntil]="loaded" parentScrollable="true">\n        <!-- View the submission tab. -->\n        <core-tab [title]="\'addon.mod_assign.submission\' | translate">\n            <ng-template>\n                <addon-mod-assign-submission-plugin *ngFor="let plugin of submissionPlugins" [assign]="assign" [submission]="userSubmission" [plugin]="plugin"></addon-mod-assign-submission-plugin>\n\n                <!-- Render some data about the submission. -->\n                <ion-item text-wrap *ngIf="userSubmission && userSubmission.status != statusNew && userSubmission.timemodified">\n                    <h2>{{ \'addon.mod_assign.timemodified\' | translate }}</h2>\n                    <p>{{ userSubmission.timemodified * 1000 | coreFormatDate }}</p>\n                </ion-item>\n\n                <ion-item text-wrap *ngIf="timeRemaining" [ngClass]="[timeRemainingClass]">\n                    <h2>{{ \'addon.mod_assign.timeremaining\' | translate }}</h2>\n                    <p><core-format-text [text]="timeRemaining"></core-format-text></p>\n                </ion-item>\n\n                <ion-item text-wrap *ngIf="fromDate && !isSubmittedForGrading">\n                    <p *ngIf="assign.intro" [innerHTML]="\'addon.mod_assign.allowsubmissionsfromdatesummary\' | translate: {\'$a\': fromDate}"></p>\n                    <p *ngIf="!assign.intro" [innerHTML]="\'addon.mod_assign.allowsubmissionsanddescriptionfromdatesummary\' | translate: {\'$a\': fromDate}"></p>\n                </ion-item>\n\n                <ion-item text-wrap *ngIf="assign.duedate && !isSubmittedForGrading">\n                    <h2>{{ \'addon.mod_assign.duedate\' | translate }}</h2>\n                    <p *ngIf="assign.duedate" >{{ assign.duedate * 1000 | coreFormatDate }}</p>\n                    <p *ngIf="!assign.duedate" >{{ \'addon.mod_assign.duedateno\' | translate }}</p>\n                </ion-item>\n\n                <ion-item text-wrap *ngIf="assign.duedate && assign.cutoffdate && isSubmittedForGrading">\n                    <h2>{{ \'addon.mod_assign.cutoffdate\' | translate }}</h2>\n                    <p>{{ assign.cutoffdate * 1000 | coreFormatDate }}</p>\n                </ion-item>\n\n                <ion-item text-wrap *ngIf="assign.duedate && lastAttempt && lastAttempt.extensionduedate && !isSubmittedForGrading">\n                    <h2>{{ \'addon.mod_assign.extensionduedate\' | translate }}</h2>\n                    <p>{{ lastAttempt.extensionduedate * 1000 | coreFormatDate }}</p>\n                </ion-item>\n\n                <ion-item text-wrap *ngIf="currentAttempt && !isGrading">\n                    <h2>{{ \'addon.mod_assign.attemptnumber\' | translate }}</h2>\n                    <p *ngIf="assign.maxattempts == unlimitedAttempts">{{ \'addon.mod_assign.outof\' | translate : {\'$a\': {\'current\': currentAttempt, \'total\': maxAttemptsText} } }}</p>\n                    <p *ngIf="assign.maxattempts != unlimitedAttempts">{{ \'addon.mod_assign.outof\' | translate : {\'$a\': {\'current\': currentAttempt, \'total\': assign.maxattempts} } }}</p>\n                </ion-item>\n\n                <!-- Add or edit submission. -->\n                <ion-item text-wrap *ngIf="canEdit">\n                    <div *ngIf="!unsupportedEditPlugins.length && !showErrorStatementEdit">\n                        <!-- If has offline data, show edit. -->\n                        <a ion-button block text-wrap color="primary" *ngIf="hasOffline" (click)="goToEdit()">{{ \'addon.mod_assign.editsubmission\' | translate }}</a>\n                        <!-- If no submission or is new, show add submission. -->\n                        <a ion-button block text-wrap color="primary" *ngIf="!hasOffline && (!userSubmission || !userSubmission.status || userSubmission.status == statusNew)" (click)="goToEdit()">{{ \'addon.mod_assign.addsubmission\' | translate }}</a>\n                        <!-- If reopened, show addfromprevious and addnewattempt. -->\n                        <ng-container *ngIf="!hasOffline && userSubmission && userSubmission.status == statusReopened">\n                            <a ion-button block text-wrap color="primary" (click)="copyPrevious()">{{ \'addon.mod_assign.addnewattemptfromprevious\' | translate }}</a>\n                            <a ion-button block text-wrap color="primary" (click)="goToEdit()">{{ \'addon.mod_assign.addnewattempt\' | translate }}</a>\n                        </ng-container>\n                        <!-- Else show editsubmission. -->\n                        <a ion-button block text-wrap color="primary" *ngIf="!hasOffline && userSubmission && userSubmission.status && userSubmission.status != statusNew && userSubmission.status != statusReopened" (click)="goToEdit()">{{ \'addon.mod_assign.editsubmission\' | translate }}</a>\n                    </div>\n                    <div *ngIf="unsupportedEditPlugins && unsupportedEditPlugins.length && !showErrorStatementEdit">\n                        <p class="core-danger-item">{{ \'addon.mod_assign.erroreditpluginsnotsupported\' | translate }}</p>\n                        <p class="core-danger-item" *ngFor="let name of unsupportedEditPlugins">{{ name }}</p>\n                    </div>\n                    <div *ngIf="showErrorStatementEdit">\n                        <p class="core-danger-item">{{ \'addon.mod_assign.cannoteditduetostatementsubmission\' | translate }}</p>\n                    </div>\n                </ion-item>\n\n                <!-- Submit for grading form. -->\n                <div *ngIf="canSubmit">\n                    <ion-item text-wrap *ngIf="submissionStatement">\n                        <ion-label><core-format-text [text]="submissionStatement"></core-format-text></ion-label>\n                        <ion-checkbox item-end name="submissionstatement" [(ngModel)]="submitModel.submissionStatement">\n                        </ion-checkbox>\n                    </ion-item>\n                    <!-- Submit button. -->\n                    <ion-item text-wrap *ngIf="!showErrorStatementSubmit">\n                        <a ion-button block text-wrap (click)="submitForGrading(submitModel.submissionStatement)">{{ \'addon.mod_assign.submitassignment\' | translate }}</a>\n                        <p>{{ \'addon.mod_assign.submitassignment_help\' | translate }}</p>\n                    </ion-item>\n                    <!-- Error because we lack submissions statement. -->\n                    <ion-item text-wrap *ngIf="showErrorStatementSubmit">\n                        <p class="core-danger-item">{{ \'addon.mod_assign.cannotsubmitduetostatementsubmission\' | translate }}</p>\n                    </ion-item>\n                </div>\n\n                <!-- Team members that need to submit it too. -->\n                <ion-item text-wrap *ngIf="membersToSubmit && membersToSubmit.length > 0">\n                    <h2>{{ \'addon.mod_assign.userswhoneedtosubmit\' | translate: {$a: \'\'} }}</h2>\n                    <div *ngFor="let user of membersToSubmit">\n                        <a ion-item text-wrap *ngIf="user.fullname" (click)="openUserProfile(user.id)" [title]="user.fullname">\n                            <ion-avatar core-user-avatar [user]="user" item-start></ion-avatar>\n                            <h2>{{ user.fullname }}</h2>\n                        </a>\n                        <ion-item text-wrap *ngIf="!user.fullname">\n                            {{ \'addon.mod_assign.hiddenuser\' | translate }} <core-format-text [text]="user"></core-format-text>\n                        </ion-item>\n                    </div>\n                </ion-item>\n\n                <!-- Submission is locked. -->\n                <ion-item text-wrap *ngIf="lastAttempt && lastAttempt.locked">\n                    <h2>{{ \'addon.mod_assign.submissionslocked\' | translate }}</h2>\n                </ion-item>\n\n                <!-- Editing status. -->\n                <ion-item text-wrap *ngIf="lastAttempt && isSubmittedForGrading && lastAttempt.caneditowner !== undefined" [ngClass]="{submissioneditable: lastAttempt.caneditowner, submissionnoteditable: !lastAttempt.caneditowner}">\n                    <h2>{{ \'addon.mod_assign.editingstatus\' | translate }}</h2>\n                    <p *ngIf="lastAttempt.caneditowner">{{ \'addon.mod_assign.submissioneditable\' | translate }}</p>\n                    <p *ngIf="!lastAttempt.caneditowner">{{ \'addon.mod_assign.submissionnoteditable\' | translate }}</p>\n                </ion-item>\n            </ng-template>\n        </core-tab>\n\n        <!-- Grade the submission tab. -->\n        <core-tab [title]="\'addon.mod_assign.grade\' | translate" *ngIf="feedback || isGrading">\n            <ng-template>\n                <!-- Current grade if method is advanced. -->\n                <ion-item text-wrap *ngIf="feedback.gradefordisplay && (!isGrading || grade.method != \'simple\')" class="core-grading-summary">\n                    <h2>{{ \'addon.mod_assign.currentgrade\' | translate }}</h2>\n                    <p><core-format-text [text]="feedback.gradefordisplay"></core-format-text></p>\n                    <a ion-button item-end icon-only *ngIf="feedback.advancedgrade" (click)="showAdvancedGrade()">\n                        <ion-icon name="search"></ion-icon>\n                    </a>\n                </ion-item>\n\n                <!-- Numeric grade. Use a text input because otherwise we cannot read the value if it has an invalid character. -->\n                <ion-item text-wrap *ngIf="grade.method == \'simple\' && !grade.scale">\n                    <ion-label stacked><h2>{{ \'addon.mod_assign.gradeoutof\' | translate: {$a: gradeInfo.grade} }}</h2></ion-label>\n                    <ion-input *ngIf="!grade.disabled" type="text" [(ngModel)]="grade.grade" min="0" [max]="gradeInfo.grade" [lang]="grade.lang"></ion-input>\n                    <p item-content *ngIf="grade.disabled">{{ \'addon.mod_assign.gradelocked\' | translate }}</p>\n                </ion-item>\n\n                <!-- Grade using a scale. -->\n                <ion-item text-wrap *ngIf="grade.method == \'simple\' && grade.scale">\n                    <ion-label><h2>{{ \'addon.mod_assign.grade\' | translate }}</h2></ion-label>\n                    <ion-select [(ngModel)]="grade.grade" interface="action-sheet" [disabled]="grade.disabled">\n                        <ion-option *ngFor="let grade of grade.scale" [value]="grade.value">{{grade.label}}</ion-option>\n                    </ion-select>\n                </ion-item>\n\n                <!-- Outcomes. -->\n                <ion-item text-wrap *ngFor="let outcome of gradeInfo.outcomes">\n                    <ion-label><h2>{{ outcome.name }}</h2></ion-label>\n                    <ion-select *ngIf="canSaveGrades && outcome.itemNumber" [(ngModel)]="outcome.selectedId" interface="action-sheet" [disabled]="gradeInfo.disabled">\n                        <ion-option *ngFor="let grade of outcome.options" [value]="grade.value">{{grade.label}}</ion-option>\n                    </ion-select>\n                    <p item-content *ngIf="!canSaveGrades || !outcome.itemNumber">{{ outcome.selected }}</p>\n                </ion-item>\n\n                <!-- Gradebook grade for simple grading. -->\n                <ion-item text-wrap *ngIf="grade.method == \'simple\'">\n                    <h2>{{ \'addon.mod_assign.currentgrade\' | translate }}</h2>\n                    <p *ngIf="grade.gradebookGrade !== false && grade.gradebookGrade !== null && !grade.scale">{{ grade.gradebookGrade }}</p>\n                    <p *ngIf="grade.gradebookGrade !== false && grade.gradebookGrade !== null && grade.scale">{{ grade.scale[grade.gradebookGrade].label }}</p>\n                    <p *ngIf="grade.gradebookGrade === false || grade.gradebookGrade === null">-</p>\n                </ion-item>\n\n                <addon-mod-assign-feedback-plugin *ngFor="let plugin of feedback.plugins" [assign]="assign" [submission]="userSubmission" [userId]="submitId" [plugin]="plugin" [canEdit]="canSaveGrades"></addon-mod-assign-feedback-plugin>\n\n                <!-- Workflow status. -->\n                <ion-item text-wrap *ngIf="workflowStatusTranslationId">\n                    <h2>{{ \'addon.mod_assign.markingworkflowstate\' | translate }}</h2>\n                    <p>{{ workflowStatusTranslationId | translate }}</p>\n                </ion-item>\n\n                <!--- Apply grade to all team members. -->\n                <ion-item text-wrap *ngIf="assign.teamsubmission && canSaveGrades">\n                    <h2>{{ \'addon.mod_assign.groupsubmissionsettings\' | translate }}</h2>\n                    <ion-label>{{ \'addon.mod_assign.applytoteam\' | translate }}</ion-label>\n                    <ion-toggle [(ngModel)]="grade.applyToAll"></ion-toggle>\n                </ion-item>\n\n                <!-- Attempt status. -->\n                <ng-container *ngIf="isGrading && assign.attemptreopenmethod != attemptReopenMethodNone">\n                    <ion-item text-wrap>\n                        <h2>{{ \'addon.mod_assign.attemptsettings\' | translate }}</h2>\n                        <p *ngIf="assign.maxattempts == unlimitedAttempts">{{ \'addon.mod_assign.outof\' | translate : {\'$a\': {\'current\': currentAttempt, \'total\': maxAttemptsText} } }}</p>\n                        <p *ngIf="assign.maxattempts != unlimitedAttempts">{{ \'addon.mod_assign.outof\' | translate : {\'$a\': {\'current\': currentAttempt, \'total\': assign.maxattempts} } }}</p>\n                        <p>{{ \'addon.mod_assign.attemptreopenmethod\' | translate }}: {{ \'addon.mod_assign.attemptreopenmethod_\' + assign.attemptreopenmethod | translate }}</p>\n                    </ion-item>\n                    <ion-item *ngIf="canSaveGrades && allowAddAttempt" >\n                        <ion-label>{{ \'addon.mod_assign.addattempt\' | translate }}</ion-label>\n                        <ion-toggle [(ngModel)]="grade.addAttempt"></ion-toggle>\n                    </ion-item>\n                </ng-container>\n\n                <!-- Data about the grader (teacher who graded). -->\n                <a ion-item text-wrap *ngIf="grader" (click)="openUserProfile(grader.id)" [title]="grader.fullname" detail-push>\n                    <ion-avatar core-user-avatar [user]="grader" item-start></ion-avatar>\n                    <h2>{{ \'addon.mod_assign.gradedby\' | translate }}</h2>\n                    <h2>{{ grader.fullname }}</h2>\n                    <p *ngIf="feedback.gradeddate">{{ feedback.gradeddate * 1000 | coreFormatDate }}</p>\n                </a>\n\n                <!-- Grader is hidden, display only the grade date. -->\n                <ion-item text-wrap *ngIf="!grader && feedback.gradeddate">\n                    <h2>{{ \'addon.mod_assign.gradedon\' | translate }}</h2>\n                    <p>{{ feedback.gradeddate * 1000 | coreFormatDate }}</p>\n                </ion-item>\n\n                <!-- Warning message if cannot save grades. -->\n                <div *ngIf="isGrading && !canSaveGrades" class="core-warning-card" icon-start>\n                    <ion-icon name="warning"></ion-icon>\n                    <p>{{ \'addon.mod_assign.cannotgradefromapp\' | translate:{$a: moduleName} }}</p>\n                    <a ion-button block *ngIf="gradeUrl" [href]="gradeUrl" core-link icon-end>\n                        {{ \'core.openinbrowser\' | translate }}\n                        <ion-icon name="open"></ion-icon>\n                    </a>\n                </div>\n            </ng-template>\n        </core-tab>\n    </core-tabs>\n</core-loading>\n\n<!-- Template to render some data regarding the submission status. -->\n<ng-template #submissionStatus>\n    <ng-container *ngIf="assign && assign.teamsubmission && lastAttempt">\n        <p *ngIf="lastAttempt.submissiongroup && lastAttempt.submissiongroupname">{{lastAttempt.submissiongroupname}}</p>\n        <ng-container *ngIf="assign.preventsubmissionnotingroup && !lastAttempt.submissiongroup && (!lastAttempt.usergroups || lastAttempt.usergroups.length <= 0)">\n            <p class="text-danger"><strong>{{ \'addon.mod_assign.noteam\' | translate }}</strong></p>\n            <p class="text-danger">{{ \'addon.mod_assign.noteam_desc\' | translate }}</p>\n        </ng-container>\n        <ng-container *ngIf="assign.preventsubmissionnotingroup && !lastAttempt.submissiongroup && lastAttempt.usergroups && lastAttempt.usergroups.length > 1">\n            <p class="text-danger"><strong>{{ \'addon.mod_assign.multipleteams\' | translate }}</strong></p>\n            <p class="text-danger">{{ \'addon.mod_assign.multipleteams_desc\' | translate }}</p>\n        </ng-container>\n        <p *ngIf="!assign.preventsubmissionnotingroup && !lastAttempt.submissiongroup">\n            {{ \'addon.mod_assign.defaultteam\' | translate }}\n        </p>\n    </ng-container>\n    <ion-badge item-end *ngIf="statusTranslated" [color]="statusColor">\n        {{ statusTranslated }}\n    </ion-badge>\n    <ion-badge item-end *ngIf="gradingStatusTranslationId" [color]="gradingColor">\n        {{ gradingStatusTranslationId | translate }}\n    </ion-badge>\n</ng-template>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\submission\addon-mod-assign-submission.html"*/,
        }),
        __param(19, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_11__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_13__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_14__core_fileuploader_providers_helper__["a" /* CoreFileUploaderHelperProvider */], __WEBPACK_IMPORTED_MODULE_15__core_grades_providers_helper__["a" /* CoreGradesHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_16__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_17__providers_assign__["a" /* AddonModAssignProvider */],
            __WEBPACK_IMPORTED_MODULE_18__providers_helper__["a" /* AddonModAssignHelperProvider */], __WEBPACK_IMPORTED_MODULE_19__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_21__components_split_view_split_view__["a" /* CoreSplitViewComponent */]])
    ], AddonModAssignSubmissionComponent);
    return AddonModAssignSubmissionComponent;
}());

//# sourceMappingURL=submission.js.map

/***/ }),
/* 423 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModBookIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__ = __webpack_require__(164);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_book__ = __webpack_require__(212);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__ = __webpack_require__(772);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};







/**
 * Component that displays a book.
 */
var AddonModBookIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModBookIndexComponent, _super);
    function AddonModBookIndexComponent(injector, bookProvider, courseProvider, appProvider, prefetchDelegate, modalCtrl, content) {
        var _this = _super.call(this, injector) || this;
        _this.bookProvider = bookProvider;
        _this.courseProvider = courseProvider;
        _this.appProvider = appProvider;
        _this.prefetchDelegate = prefetchDelegate;
        _this.modalCtrl = modalCtrl;
        _this.content = content;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_book__["a" /* AddonModBookProvider */].COMPONENT;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModBookIndexComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.loadContent();
    };
    /**
     * Show the TOC.
     *
     * @param {MouseEvent} event Event.
     */
    AddonModBookIndexComponent.prototype.showToc = function (event) {
        var _this = this;
        // Create the toc modal.
        var modal = this.modalCtrl.create('AddonModBookTocPage', {
            chapters: this.chapters,
            selected: this.currentChapter
        }, { cssClass: 'core-modal-lateral',
            showBackdrop: true,
            enableBackdropDismiss: true,
            enterAnimation: 'core-modal-lateral-transition',
            leaveAnimation: 'core-modal-lateral-transition' });
        modal.onDidDismiss(function (chapterId) {
            if (chapterId) {
                _this.changeChapter(chapterId);
            }
        });
        modal.present({
            ev: event
        });
    };
    /**
     * Change the current chapter.
     *
     * @param {string} chapterId Chapter to load.
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModBookIndexComponent.prototype.changeChapter = function (chapterId) {
        if (chapterId && chapterId != this.currentChapter) {
            this.loaded = false;
            this.refreshIcon = 'spinner';
            this.loadChapter(chapterId);
        }
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModBookIndexComponent.prototype.invalidateContent = function () {
        return this.bookProvider.invalidateContent(this.module.id, this.courseId);
    };
    /**
     * Download book contents and load the current chapter.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModBookIndexComponent.prototype.fetchContent = function (refresh) {
        var _this = this;
        var promises = [];
        var downloadFailed = false;
        // Try to get the book data.
        promises.push(this.bookProvider.getBook(this.courseId, this.module.id).then(function (book) {
            _this.dataRetrieved.emit(book);
            _this.description = book.intro || _this.description;
        }).catch(function () {
            // Ignore errors since this WS isn't available in some Moodle versions.
        }));
        // Download content. This function also loads module contents if needed.
        promises.push(this.prefetchDelegate.download(this.module, this.courseId).catch(function () {
            // Mark download as failed but go on since the main files could have been downloaded.
            downloadFailed = true;
            if (!_this.module.contents.length) {
                // Try to load module contents for offline usage.
                return _this.courseProvider.loadModuleContents(_this.module, _this.courseId);
            }
        }));
        return Promise.all(promises).then(function () {
            _this.contentsMap = _this.bookProvider.getContentsMap(_this.module.contents);
            _this.chapters = _this.bookProvider.getTocList(_this.module.contents);
            if (typeof _this.currentChapter == 'undefined' && typeof _this.initialChapterId != 'undefined' && _this.chapters) {
                // Initial chapter set. Validate that the chapter exists.
                var chapter = _this.chapters.find(function (chapter) {
                    return chapter.id == _this.initialChapterId;
                });
                if (chapter) {
                    _this.currentChapter = _this.initialChapterId;
                }
            }
            if (typeof _this.currentChapter == 'undefined') {
                // Load the first chapter.
                _this.currentChapter = _this.bookProvider.getFirstChapter(_this.chapters);
            }
            // Show chapter.
            return _this.loadChapter(_this.currentChapter).then(function () {
                if (downloadFailed && _this.appProvider.isOnline()) {
                    // We could load the main file but the download failed. Show error message.
                    _this.domUtils.showErrorModal('core.errordownloadingsomefiles', true);
                }
                // All data obtained, now fill the context menu.
                _this.fillContextMenu(refresh);
            }).catch(function () {
                // Ignore errors, they're handled inside the loadChapter function.
            });
        });
    };
    /**
     * Load a book chapter.
     *
     * @param {string} chapterId Chapter to load.
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModBookIndexComponent.prototype.loadChapter = function (chapterId) {
        var _this = this;
        this.currentChapter = chapterId;
        this.domUtils.scrollToTop(this.content);
        return this.bookProvider.getChapterContent(this.contentsMap, chapterId, this.module.id).then(function (content) {
            _this.chapterContent = content;
            _this.previousChapter = _this.bookProvider.getPreviousChapter(_this.chapters, chapterId);
            _this.nextChapter = _this.bookProvider.getNextChapter(_this.chapters, chapterId);
            // Chapter loaded, log view. We don't return the promise because we don't want to block the user for this.
            _this.bookProvider.logView(_this.module.instance, chapterId, _this.module.name).then(function () {
                // Module is completed when last chapter is viewed, so we only check completion if the last is reached.
                if (_this.nextChapter == '0') {
                    _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
                }
            }).catch(function () {
                // Ignore errors.
            });
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'addon.mod_book.errorchapter', true);
            return Promise.reject(null);
        }).finally(function () {
            _this.loaded = true;
            _this.refreshIcon = 'refresh';
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModBookIndexComponent.prototype, "initialChapterId", void 0);
    AddonModBookIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-book-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\book\components\index\addon-mod-book-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <button ion-button icon-only (click)="showToc($event)" [attr.aria-label]="\'addon.mod_book.toc\' | translate" aria-haspopup="true" *ngIf="loaded">\n        <ion-icon name="bookmark"></ion-icon>\n    </button>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="600" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="500" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <div padding>\n        <core-navigation-bar [previous]="previousChapter > 0 && previousChapter" [next]="nextChapter > 0 && nextChapter" (action)="changeChapter($event)"></core-navigation-bar>\n        <core-format-text [component]="component" [componentId]="componentId" [text]="chapterContent"></core-format-text>\n        <core-navigation-bar [previous]="previousChapter > 0 && previousChapter" [next]="nextChapter > 0 && nextChapter" (action)="changeChapter($event)"></core-navigation-bar>\n    </div>\n\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\book\components\index\addon-mod-book-index.html"*/,
        }),
        __param(6, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_book__["a" /* AddonModBookProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__["a" /* AddonModBookPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]])
    ], AddonModBookIndexComponent);
    return AddonModBookIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__["a" /* CoreCourseModuleMainResourceComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 424 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChatIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_chat__ = __webpack_require__(219);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays a chat.
 */
var AddonModChatIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModChatIndexComponent, _super);
    function AddonModChatIndexComponent(injector, chatProvider, timeUtils, navCtrl) {
        var _this = _super.call(this, injector) || this;
        _this.chatProvider = chatProvider;
        _this.timeUtils = timeUtils;
        _this.navCtrl = navCtrl;
        _this.component = __WEBPACK_IMPORTED_MODULE_4__providers_chat__["a" /* AddonModChatProvider */].COMPONENT;
        _this.moduleName = 'chat';
        _this.sessionsAvailable = false;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModChatIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.loadContent().then(function () {
            _this.chatProvider.logView(_this.chat.id, _this.chat.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Download chat.
     *
     * @param  {boolean}      [refresh=false]    If it's refreshing content.
     * @param  {boolean}      [sync=false]       If it should try to sync.
     * @param  {boolean}      [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChatIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        return this.chatProvider.getChat(this.courseId, this.module.id).then(function (chat) {
            _this.chat = chat;
            _this.description = chat.intro || chat.description;
            var now = _this.timeUtils.timestamp();
            var span = chat.chattime - now;
            if (chat.chattime && chat.schedule > 0 && span > 0) {
                _this.chatInfo = {
                    date: _this.timeUtils.userDate(chat.chattime * 1000),
                    fromnow: _this.timeUtils.formatTime(span)
                };
            }
            else {
                _this.chatInfo = false;
            }
            _this.dataRetrieved.emit(chat);
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
            return _this.chatProvider.areSessionsAvailable().then(function (available) {
                _this.sessionsAvailable = available;
            });
        });
    };
    /**
     * Enter the chat.
     */
    AddonModChatIndexComponent.prototype.enterChat = function () {
        var title = this.chat.name || this.moduleName;
        this.navCtrl.push('AddonModChatChatPage', { chatId: this.chat.id, courseId: this.courseId, title: title });
    };
    /**
     * View past sessions.
     */
    AddonModChatIndexComponent.prototype.viewSessions = function () {
        this.navCtrl.push('AddonModChatSessionsPage', { courseId: this.courseId, chatId: this.chat.id, cmId: this.module.id });
    };
    AddonModChatIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-chat-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\chat\components\index\addon-mod-chat-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <ion-card icon-start class="core-info-card" *ngIf="chatInfo">\n        <ion-icon name="time"></ion-icon> {{ \'addon.mod_chat.sessionstart\' | translate:{$a: chatInfo} }}\n    </ion-card>\n\n    <div padding>\n        <a ion-button block color="primary" (click)="enterChat()">{{ \'addon.mod_chat.enterchat\' | translate }}</a>\n        <a ion-button block color="light" margin-top *ngIf="sessionsAvailable" (click)="viewSessions()">{{ \'addon.mod_chat.viewreport\' | translate }}</a>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\chat\components\index\addon-mod-chat-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__providers_chat__["a" /* AddonModChatProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], AddonModChatIndexComponent);
    return AddonModChatIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 425 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_choice__ = __webpack_require__(259);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_offline__ = __webpack_require__(260);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(261);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};







/**
 * Component that displays a choice.
 */
var AddonModChoiceIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModChoiceIndexComponent, _super);
    function AddonModChoiceIndexComponent(injector, choiceProvider, content, choiceOffline, choiceSync, timeUtils) {
        var _this = _super.call(this, injector, content) || this;
        _this.choiceProvider = choiceProvider;
        _this.choiceOffline = choiceOffline;
        _this.choiceSync = choiceSync;
        _this.timeUtils = timeUtils;
        _this.component = __WEBPACK_IMPORTED_MODULE_4__providers_choice__["a" /* AddonModChoiceProvider */].COMPONENT;
        _this.moduleName = 'choice';
        _this.options = [];
        _this.choiceNotOpenYet = false;
        _this.choiceClosed = false;
        _this.canEdit = false;
        _this.canDelete = false;
        _this.canSeeResults = false;
        _this.data = [];
        _this.labels = [];
        _this.results = [];
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* AddonModChoiceSyncProvider */].AUTO_SYNCED;
        _this.hasAnsweredOnline = false;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModChoiceIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.userId = this.sitesProvider.getCurrentSiteUserId();
        this.loadContent(false, true).then(function () {
            if (!_this.choice) {
                return;
            }
            _this.choiceProvider.logView(_this.choice.id, _this.choice.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function (error) {
                // Ignore errors.
            });
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModChoiceIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.choiceProvider.invalidateChoiceData(this.courseId));
        if (this.choice) {
            promises.push(this.choiceProvider.invalidateOptions(this.choice.id));
            promises.push(this.choiceProvider.invalidateResults(this.choice.id));
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean}          True if refresh is needed, false otherwise.
     */
    AddonModChoiceIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (this.choice && syncEventData.choiceId == this.choice.id && syncEventData.userId == this.userId) {
            this.domUtils.scrollToTop(this.content);
            return true;
        }
        return false;
    };
    /**
     * Download choice contents.
     *
     * @param  {boolean}      [refresh=false]    If it's refreshing content.
     * @param  {boolean}      [sync=false]       If it should try to sync.
     * @param  {boolean}      [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChoiceIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        this.now = new Date().getTime();
        return this.choiceProvider.getChoice(this.courseId, this.module.id).then(function (choice) {
            _this.choice = choice;
            _this.choice.timeopen = parseInt(choice.timeopen) * 1000;
            _this.choice.openTimeReadable = _this.timeUtils.userDate(choice.timeopen);
            _this.choice.timeclose = parseInt(choice.timeclose) * 1000;
            _this.choice.closeTimeReadable = _this.timeUtils.userDate(choice.timeclose);
            _this.description = choice.intro || choice.description;
            _this.choiceNotOpenYet = choice.timeopen && choice.timeopen > _this.now;
            _this.choiceClosed = choice.timeclose && choice.timeclose <= _this.now;
            _this.dataRetrieved.emit(choice);
            if (sync) {
                // Try to synchronize the choice.
                return _this.syncActivity(showErrors).then(function (updated) {
                    if (updated) {
                        // Responses were sent, update the choice.
                        return _this.choiceProvider.getChoice(_this.courseId, _this.module.id).then(function (choice) {
                            _this.choice = choice;
                        });
                    }
                });
            }
        }).then(function () {
            // Check if there are responses stored in offline.
            return _this.choiceOffline.hasResponse(_this.choice.id);
        }).then(function (hasOffline) {
            _this.hasOffline = hasOffline;
            // We need fetchOptions to finish before calling fetchResults because it needs hasAnsweredOnline variable.
            return _this.fetchOptions(hasOffline).then(function () {
                return _this.fetchResults();
            });
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Convenience function to get choice options.
     *
     * @param {boolean} hasOffline True if there are responses stored offline.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChoiceIndexComponent.prototype.fetchOptions = function (hasOffline) {
        var _this = this;
        return this.choiceProvider.getOptions(this.choice.id).then(function (options) {
            var promise;
            // Check if the user has answered (synced) to allow show results.
            _this.hasAnsweredOnline = options.some(function (option) { return option.checked; });
            if (hasOffline) {
                promise = _this.choiceOffline.getResponse(_this.choice.id).then(function (response) {
                    var optionsKeys = {};
                    options.forEach(function (option) {
                        optionsKeys[option.id] = option;
                    });
                    // Update options with the offline data.
                    if (response.deleting) {
                        // Uncheck selected options.
                        if (response.responses.length > 0) {
                            // Uncheck all options selected in responses.
                            response.responses.forEach(function (selected) {
                                if (optionsKeys[selected] && optionsKeys[selected].checked) {
                                    optionsKeys[selected].checked = false;
                                    optionsKeys[selected].countanswers--;
                                }
                            });
                        }
                        else {
                            // On empty responses, uncheck all selected.
                            Object.keys(optionsKeys).forEach(function (key) {
                                if (optionsKeys[key].checked) {
                                    optionsKeys[key].checked = false;
                                    optionsKeys[key].countanswers--;
                                }
                            });
                        }
                    }
                    else {
                        // Uncheck all options to check again the offlines'.
                        Object.keys(optionsKeys).forEach(function (key) {
                            if (optionsKeys[key].checked) {
                                optionsKeys[key].checked = false;
                                optionsKeys[key].countanswers--;
                            }
                        });
                        // Then check selected ones.
                        response.responses.forEach(function (selected) {
                            if (optionsKeys[selected]) {
                                optionsKeys[selected].checked = true;
                                optionsKeys[selected].countanswers++;
                            }
                        });
                    }
                    // Convert it again to array.
                    return Object.keys(optionsKeys).map(function (key) { return optionsKeys[key]; });
                });
            }
            else {
                promise = Promise.resolve(options);
            }
            promise.then(function (options) {
                var isOpen = _this.isChoiceOpen();
                var hasAnswered = false;
                _this.selectedOption = { id: -1 }; // Single choice model.
                options.forEach(function (option) {
                    if (option.checked) {
                        hasAnswered = true;
                        if (!_this.choice.allowmultiple) {
                            _this.selectedOption.id = option.id;
                        }
                    }
                });
                _this.canEdit = isOpen && (_this.choice.allowupdate || !hasAnswered);
                _this.canDelete = isOpen && _this.choice.allowupdate && hasAnswered;
                _this.options = options;
                if (_this.canEdit) {
                    // Calculate the publish info message.
                    switch (_this.choice.showresults) {
                        case __WEBPACK_IMPORTED_MODULE_4__providers_choice__["a" /* AddonModChoiceProvider */].RESULTS_NOT:
                            _this.publishInfo = 'addon.mod_choice.publishinfonever';
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__providers_choice__["a" /* AddonModChoiceProvider */].RESULTS_AFTER_ANSWER:
                            if (_this.choice.publish == __WEBPACK_IMPORTED_MODULE_4__providers_choice__["a" /* AddonModChoiceProvider */].PUBLISH_ANONYMOUS) {
                                _this.publishInfo = 'addon.mod_choice.publishinfoanonafter';
                            }
                            else {
                                _this.publishInfo = 'addon.mod_choice.publishinfofullafter';
                            }
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__providers_choice__["a" /* AddonModChoiceProvider */].RESULTS_AFTER_CLOSE:
                            if (_this.choice.publish == __WEBPACK_IMPORTED_MODULE_4__providers_choice__["a" /* AddonModChoiceProvider */].PUBLISH_ANONYMOUS) {
                                _this.publishInfo = 'addon.mod_choice.publishinfoanonclose';
                            }
                            else {
                                _this.publishInfo = 'addon.mod_choice.publishinfofullclose';
                            }
                            break;
                        default:
                            // No need to inform the user since it's obvious that the results are being published.
                            _this.publishInfo = '';
                    }
                }
            });
        });
    };
    /**
     * Convenience function to get choice results.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModChoiceIndexComponent.prototype.fetchResults = function () {
        var _this = this;
        if (this.choiceNotOpenYet) {
            // Cannot see results yet.
            this.canSeeResults = false;
            return Promise.resolve();
        }
        return this.choiceProvider.getResults(this.choice.id).then(function (results) {
            var hasVotes = false;
            _this.data = [];
            _this.labels = [];
            results.forEach(function (result) {
                if (result.numberofuser > 0) {
                    hasVotes = true;
                }
                result.percentageamount = parseFloat(result.percentageamount).toFixed(1);
                _this.data.push(result.numberofuser);
                _this.labels.push(result.text);
            });
            _this.canSeeResults = hasVotes || _this.choiceProvider.canStudentSeeResults(_this.choice, _this.hasAnsweredOnline);
            _this.results = results;
        });
    };
    /**
     * Check if a choice is open.
     *
     * @return {boolean} True if choice is open, false otherwise.
     */
    AddonModChoiceIndexComponent.prototype.isChoiceOpen = function () {
        return (this.choice.timeopen === 0 || this.choice.timeopen <= this.now) &&
            (this.choice.timeclose === 0 || this.choice.timeclose > this.now);
    };
    /**
     * Return true if the user has selected at least one option.
     *
     * @return {boolean} True if the user has responded.
     */
    AddonModChoiceIndexComponent.prototype.canSave = function () {
        if (this.choice.allowmultiple) {
            return this.options.some(function (option) { return option.checked; });
        }
        else {
            return this.selectedOption.id !== -1;
        }
    };
    /**
     * Save options selected.
     */
    AddonModChoiceIndexComponent.prototype.save = function () {
        var _this = this;
        // Only show confirm if choice doesn't allow update.
        var promise;
        if (this.choice.allowupdate) {
            promise = Promise.resolve();
        }
        else {
            promise = this.domUtils.showConfirm(this.translate.instant('core.areyousure'));
        }
        promise.then(function () {
            var responses = [];
            if (_this.choice.allowmultiple) {
                _this.options.forEach(function (option) {
                    if (option.checked) {
                        responses.push(option.id);
                    }
                });
            }
            else {
                responses.push(_this.selectedOption.id);
            }
            var modal = _this.domUtils.showModalLoading('core.sending', true);
            _this.choiceProvider.submitResponse(_this.choice.id, _this.choice.name, _this.courseId, responses).then(function (online) {
                // Success!
                // Check completion since it could be configured to complete once the user answers the choice.
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
                _this.domUtils.scrollToTop(_this.content);
                return _this.dataUpdated(online);
            }).catch(function (message) {
                _this.domUtils.showErrorModalDefault(message, 'addon.mod_choice.cannotsubmit', true);
            }).finally(function () {
                modal.dismiss();
            });
        });
    };
    /**
     * Delete options selected.
     */
    AddonModChoiceIndexComponent.prototype.delete = function () {
        var _this = this;
        this.domUtils.showConfirm(this.translate.instant('core.areyousure')).then(function () {
            var modal = _this.domUtils.showModalLoading('core.sending', true);
            _this.choiceProvider.deleteResponses(_this.choice.id, _this.choice.name, _this.courseId).then(function () {
                _this.domUtils.scrollToTop(_this.content);
                // Refresh the data. Don't call dataUpdated because deleting an answer doesn't mark the choice as outdated.
                return _this.refreshContent(false);
            }).catch(function (message) {
                _this.domUtils.showErrorModalDefault(message, 'addon.mod_choice.cannotsubmit', true);
            }).finally(function () {
                modal.dismiss();
            });
        }).catch(function () {
            // Ingore cancelled modal.
        });
    };
    /**
     * Function to call when some data has changed. It will refresh/prefetch data.
     *
     * @param {boolean} online Whether the data was sent to server or stored in offline.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChoiceIndexComponent.prototype.dataUpdated = function (online) {
        var _this = this;
        if (online && this.isPrefetched()) {
            // The choice is downloaded, update the data.
            return this.choiceSync.prefetchAfterUpdate(this.module, this.courseId).then(function () {
                // Update the view.
                _this.showLoadingAndFetch(false, false);
            }).catch(function () {
                // Prefetch failed, refresh the data.
                return _this.refreshContent(false);
            });
        }
        else {
            // Not downloaded, refresh the data.
            return this.refreshContent(false);
        }
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChoiceIndexComponent.prototype.sync = function () {
        return this.choiceSync.syncChoice(this.choice.id, this.userId);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any} result Data returned on the sync function.
     * @return {boolean} Whether it succeed or not.
     */
    AddonModChoiceIndexComponent.prototype.hasSyncSucceed = function (result) {
        return result.updated;
    };
    AddonModChoiceIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-choice-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\choice\components\index\addon-mod-choice-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <!-- Activity availability messages -->\n    <ion-card class="core-info-card" icon-start *ngIf="choiceNotOpenYet">\n        <ion-icon name="information-circle"></ion-icon>\n        <p *ngIf="options && options.length">{{ \'addon.mod_choice.previewonly\' | translate:{$a: choice.openTimeReadable} }}</p>\n        <p *ngIf="!options || !options.length">{{ \'addon.mod_choice.notopenyet\' | translate:{$a: choice.openTimeReadable} }}</p>\n    </ion-card>\n    <ion-card class="core-info-card" icon-start *ngIf="choiceClosed">\n        <ion-icon name="information-circle"></ion-icon>\n        <p *ngIf="options && options.length">{{ \'addon.mod_choice.yourselection\' | translate }} <core-format-text [text]="options[0].text"></core-format-text></p>\n        <p>{{ \'addon.mod_choice.expired\' | translate:{$a: choice.closeTimeReadable} }}</p>\n    </ion-card>\n\n    <!-- Choice done in offline but not synchronized -->\n    <ion-card class="core-warning-card" icon-start *ngIf="hasOffline">\n        <ion-icon name="warning"></ion-icon> {{ \'core.hasdatatosync\' | translate:{$a: moduleName} }}\n    </ion-card>\n\n    <!-- Inform what will happen with the choices. -->\n    <div *ngIf="canEdit && publishInfo && options && options.length" class="core-info-card" icon-start>\n        <ion-icon name="information-circle"></ion-icon>\n        {{ publishInfo | translate }}\n    </div>\n\n    <!-- Choice options -->\n    <ion-card *ngIf="options && options.length">\n        <ng-container *ngIf="choice.allowmultiple">\n            <ion-item text-wrap *ngFor="let option of options">\n                <ion-label><core-format-text [text]="option.text"></core-format-text> <span *ngIf="choice.limitanswers && option.countanswers >= option.maxanswers">{{ \'addon.mod_choice.full\' | translate }}</span></ion-label>\n                <ion-checkbox item-end [(ngModel)]="option.checked" [disabled]="option.disabled || !canEdit"></ion-checkbox>\n            </ion-item>\n        </ng-container>\n        <ng-container *ngIf="!choice.allowmultiple">\n            <ion-item text-wrap *ngFor="let option of options" radio-group [(ngModel)]="selectedOption.id">\n                <ion-label><core-format-text [text]="option.text"></core-format-text> <span *ngIf="choice.limitanswers && option.countanswers >= option.maxanswers">{{ \'addon.mod_choice.full\' | translate }}</span></ion-label>\n                <ion-radio color="primary" [value]="option.id" [disabled]="option.disabled || !canEdit"></ion-radio>\n            </ion-item>\n        </ng-container>\n        <ion-item *ngIf="canEdit">\n            <button ion-button block (click)="save()" [disabled]="!canSave()">{{ \'addon.mod_choice.savemychoice\' | translate }}</button>\n        </ion-item>\n        <ion-item *ngIf="canDelete">\n            <button ion-button block color="light" (click)="delete()">{{ \'addon.mod_choice.removemychoice\' | translate }}</button>\n        </ion-item>\n    </ion-card>\n\n    <!-- Choice results -->\n    <div *ngIf="canSeeResults">\n        <ion-item-divider text-center>\n            {{ \'addon.mod_choice.responses\' | translate }}\n        </ion-item-divider>\n        <ion-grid no-padding>\n            <ion-row>\n                <ion-col col-12 col-lg-5>\n                    <ion-item text-wrap class="core-warning-item" *ngIf="hasOffline">\n                        <ion-icon item-start name="warning" color="warning"></ion-icon> {{ \'addon.mod_choice.resultsnotsynced\' | translate }}\n                    </ion-item>\n                    <ion-item>\n                        <core-chart type="pie" [data]="data" [labels]="labels" height="300"></core-chart>\n                    </ion-item>\n                </ion-col>\n                <ion-col *ngIf="choice.publish && results" col-12 col-lg-7>\n                    <ion-item-group *ngFor="let result of results">\n                        <ion-item-divider text-wrap>\n                            <h2><core-format-text [text]="result.text"></core-format-text></h2>\n                            <p>{{ \'addon.mod_choice.numberofuser\' | translate }}: {{ result.numberofuser }} ({{ \'core.percentagenumber\' | translate: {$a: result.percentageamount} }})</p>\n                        </ion-item-divider>\n                        <a ion-item *ngFor="let user of result.userresponses" core-user-link [courseId]="courseid" [userId]="user.userid" [title]="user.fullname" text-wrap>\n                            <ion-avatar core-user-avatar [user]="user" item-start [courseId]="courseid"></ion-avatar>\n                            <p>{{user.fullname}}</p>\n                        </a>\n                    </ion-item-group>\n                </ion-col>\n            </ion-row>\n        </ion-grid>\n    </div>\n    <ion-card class="core-info-card" *ngIf="!canSeeResults && !choiceNotOpenYet">\n        <p>{{ \'addon.mod_choice.noresultsviewable\' | translate }}</p>\n    </ion-card>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\choice\components\index\addon-mod-choice-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__providers_choice__["a" /* AddonModChoiceProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_5__providers_offline__["a" /* AddonModChoiceOfflineProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* AddonModChoiceSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonModChoiceIndexComponent);
    return AddonModChoiceIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 426 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSharedFilesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_ts_md5_dist_md5__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Service to share files with the app.
 */
var CoreSharedFilesProvider = /** @class */ (function () {
    function CoreSharedFilesProvider(logger, fileProvider, appProvider, textUtils, mimeUtils, sitesProvider, eventsProvider) {
        this.fileProvider = fileProvider;
        this.textUtils = textUtils;
        this.mimeUtils = mimeUtils;
        this.sitesProvider = sitesProvider;
        this.eventsProvider = eventsProvider;
        // Variables for the database.
        this.SHARED_FILES_TABLE = 'shared_files';
        this.tableSchema = {
            name: this.SHARED_FILES_TABLE,
            columns: [
                {
                    name: 'id',
                    type: 'TEXT',
                    primaryKey: true
                }
            ]
        };
        this.logger = logger.getInstance('CoreSharedFilesProvider');
        this.appDB = appProvider.getDB();
        this.appDB.createTableFromSchema(this.tableSchema);
    }
    CoreSharedFilesProvider_1 = CoreSharedFilesProvider;
    /**
     * Checks if there is a new file received in iOS. If more than one file is found, treat only the first one.
     * The file returned is marked as "treated" and will be deleted in the next execution.
     *
     * @return {Promise<any>} Promise resolved with a new file to be treated. If no new files found, promise is rejected.
     */
    CoreSharedFilesProvider.prototype.checkIOSNewFiles = function () {
        var _this = this;
        this.logger.debug('Search for new files on iOS');
        return this.fileProvider.getDirectoryContents('Inbox').then(function (entries) {
            if (entries.length > 0) {
                var promises_1 = [];
                var fileToReturn_1;
                entries.forEach(function (entry) {
                    var fileId = _this.getFileId(entry);
                    // Check if file was already treated.
                    promises_1.push(_this.isFileTreated(fileId).then(function () {
                        // File already treated, delete it. Don't return delete promise, we'll ignore errors.
                        _this.deleteInboxFile(entry);
                    }).catch(function () {
                        // File not treated before.
                        _this.logger.debug('Found new file ' + entry.name + ' shared with the app.');
                        if (!fileToReturn_1) {
                            fileToReturn_1 = entry;
                        }
                    }));
                });
                return Promise.all(promises_1).then(function () {
                    var fileId;
                    if (fileToReturn_1) {
                        // Mark it as "treated".
                        fileId = _this.getFileId(fileToReturn_1);
                        return _this.markAsTreated(fileId).then(function () {
                            _this.logger.debug('File marked as "treated": ' + fileToReturn_1.name);
                            return fileToReturn_1;
                        });
                    }
                    else {
                        return Promise.reject(null);
                    }
                });
            }
            else {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Deletes a file in the Inbox folder (shared with the app).
     *
     * @param {any} entry FileEntry.
     * @return {Promise<any>} Promise resolved when done, rejected otherwise.
     */
    CoreSharedFilesProvider.prototype.deleteInboxFile = function (entry) {
        var _this = this;
        this.logger.debug('Delete inbox file: ' + entry.name);
        return this.fileProvider.removeFileByFileEntry(entry).catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.unmarkAsTreated(_this.getFileId(entry)).then(function () {
                _this.logger.debug('"Treated" mark removed from file: ' + entry.name);
            }).catch(function (error) {
                _this.logger.debug('Error deleting "treated" mark from file: ' + entry.name, error);
                return Promise.reject(error);
            });
        });
    };
    /**
     * Get the ID of a file for managing "treated" files.
     *
     * @param {any} entry FileEntry.
     * @return {string} File ID.
     */
    CoreSharedFilesProvider.prototype.getFileId = function (entry) {
        return __WEBPACK_IMPORTED_MODULE_8_ts_md5_dist_md5__["Md5"].hashAsciiStr(entry.name);
    };
    /**
     * Get the shared files stored in a site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {string} [path] Path to search inside the site shared folder.
     * @param {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {Promise<any[]>} Promise resolved with the files.
     */
    CoreSharedFilesProvider.prototype.getSiteSharedFiles = function (siteId, path, mimetypes) {
        var _this = this;
        var pathToGet = this.getSiteSharedFilesDirPath(siteId);
        if (path) {
            pathToGet = this.textUtils.concatenatePaths(pathToGet, path);
        }
        return this.fileProvider.getDirectoryContents(pathToGet).then(function (files) {
            if (mimetypes) {
                // Only show files with the right mimetype and the ones we cannot determine the mimetype.
                files = files.filter(function (file) {
                    var extension = _this.mimeUtils.getFileExtension(file.name), mimetype = _this.mimeUtils.getMimeType(extension);
                    return !mimetype || mimetypes.indexOf(mimetype) > -1;
                });
            }
            return files;
        }).catch(function () {
            // Directory not found, return empty list.
            return [];
        });
    };
    /**
     * Get the path to a site's shared files folder.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {string} Path.
     */
    CoreSharedFilesProvider.prototype.getSiteSharedFilesDirPath = function (siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.fileProvider.getSiteFolder(siteId) + '/' + CoreSharedFilesProvider_1.SHARED_FILES_FOLDER;
    };
    /**
     * Check if a file has been treated already.
     *
     * @param {string} fileId File ID.
     * @return {Promise<any>} Resolved if treated, rejected otherwise.
     */
    CoreSharedFilesProvider.prototype.isFileTreated = function (fileId) {
        return this.appDB.getRecord(this.SHARED_FILES_TABLE, { id: fileId });
    };
    /**
     * Mark a file as treated.
     *
     * @param {string} fileId File ID.
     * @return {Promise<any>} Promise resolved when marked.
     */
    CoreSharedFilesProvider.prototype.markAsTreated = function (fileId) {
        var _this = this;
        // Check if it's already marked.
        return this.isFileTreated(fileId).catch(function () {
            // Doesn't exist, insert it.
            return _this.appDB.insertRecord(_this.SHARED_FILES_TABLE, { id: fileId });
        });
    };
    /**
     * Store a file in a site's shared folder.
     *
     * @param {any} entry File entry.
     * @param {string} [newName] Name of the new file. If not defined, use original file's name.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>}Promise resolved when done.
     */
    CoreSharedFilesProvider.prototype.storeFileInSite = function (entry, newName, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!entry || !siteId) {
            return Promise.reject(null);
        }
        newName = newName || entry.name;
        var sharedFilesFolder = this.getSiteSharedFilesDirPath(siteId), newPath = this.textUtils.concatenatePaths(sharedFilesFolder, newName);
        // Create dir if it doesn't exist already.
        return this.fileProvider.createDir(sharedFilesFolder).then(function () {
            return _this.fileProvider.moveExternalFile(entry.toURL(), newPath).then(function (newFile) {
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].FILE_SHARED, { siteId: siteId, name: newName });
                return newFile;
            });
        });
    };
    /**
     * Unmark a file as treated.
     *
     * @param {string} fileId File ID.
     * @return {Promise<any>} Resolved when unmarked.
     */
    CoreSharedFilesProvider.prototype.unmarkAsTreated = function (fileId) {
        return this.appDB.deleteRecords(this.SHARED_FILES_TABLE, { id: fileId });
    };
    CoreSharedFilesProvider.SHARED_FILES_FOLDER = 'sharedfiles';
    CoreSharedFilesProvider = CoreSharedFilesProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreSharedFilesProvider);
    return CoreSharedFilesProvider;
    var CoreSharedFilesProvider_1;
}());

//# sourceMappingURL=sharedfiles.js.map

/***/ }),
/* 427 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSharedFilesHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__sharedfiles__ = __webpack_require__(426);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Helper service to share files with the app.
 */
var CoreSharedFilesHelperProvider = /** @class */ (function () {
    function CoreSharedFilesHelperProvider(logger, alertCtrl, translate, utils, sitesProvider, modalCtrl, fileUploaderProvider, initDelegate, sharedFilesProvider, domUtils, fileProvider, appProvider) {
        this.alertCtrl = alertCtrl;
        this.translate = translate;
        this.utils = utils;
        this.sitesProvider = sitesProvider;
        this.modalCtrl = modalCtrl;
        this.fileUploaderProvider = fileUploaderProvider;
        this.initDelegate = initDelegate;
        this.sharedFilesProvider = sharedFilesProvider;
        this.domUtils = domUtils;
        this.fileProvider = fileProvider;
        this.appProvider = appProvider;
        this.logger = logger.getInstance('CoreSharedFilesHelperProvider');
    }
    /**
     * Ask a user if he wants to replace a file (using originalName) or rename it (using newName).
     *
     * @param {string} originalName Original name.
     * @param {string} newName New name.
     * @return {Promise<string>} Promise resolved with the name to use when the user chooses. Rejected if user cancels.
     */
    CoreSharedFilesHelperProvider.prototype.askRenameReplace = function (originalName, newName) {
        var deferred = this.utils.promiseDefer(), alert = this.alertCtrl.create({
            title: this.translate.instant('core.sharedfiles.sharedfiles'),
            message: this.translate.instant('core.sharedfiles.chooseactionrepeatedfile', { $a: newName }),
            buttons: [
                {
                    text: this.translate.instant('core.sharedfiles.rename'),
                    handler: function () {
                        deferred.resolve(newName);
                    }
                },
                {
                    text: this.translate.instant('core.sharedfiles.replace'),
                    handler: function () {
                        deferred.resolve(originalName);
                    }
                }
            ]
        });
        alert.present();
        return deferred.promise;
    };
    /**
     * Go to the choose site view.
     *
     * @param {string} filePath File path to send to the view.
     * @param {boolean} [isInbox] Whether the file is in the Inbox folder.
     */
    CoreSharedFilesHelperProvider.prototype.goToChooseSite = function (filePath, isInbox) {
        var navCtrl = this.appProvider.getRootNavController();
        navCtrl.push('CoreSharedFilesChooseSitePage', { filePath: filePath, isInbox: isInbox });
    };
    /**
     * Whether the user is already choosing a site to store a shared file.
     *
     * @return {boolean} Whether the user is already choosing a site to store a shared file.
     */
    CoreSharedFilesHelperProvider.prototype.isChoosingSite = function () {
        var navCtrl = this.appProvider.getRootNavController();
        return navCtrl && navCtrl.getActive().id == 'CoreSharedFilesChooseSitePage';
    };
    /**
     * Open the view to select a shared file.
     *
     * @param  {string[]} [mimetypes] List of supported mimetypes. If undefined, all mimetypes supported.
     * @return {Promise<any>} Promise resolved when a file is picked, rejected if file picker is closed without selecting a file.
     */
    CoreSharedFilesHelperProvider.prototype.pickSharedFile = function (mimetypes) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var modal = _this.modalCtrl.create('CoreSharedFilesListPage', { mimetypes: mimetypes, isModal: true, pick: true });
            modal.present();
            modal.onDidDismiss(function (file) {
                if (!file) {
                    // User cancelled.
                    reject();
                    return;
                }
                var error = _this.fileUploaderProvider.isInvalidMimetype(mimetypes, file.fullPath);
                if (error) {
                    reject(error);
                }
                else {
                    resolve({
                        path: file.fullPath,
                        treated: false
                    });
                }
            });
        });
    };
    /**
     * Delete a shared file.
     *
     * @param {any} fileEntry The file entry to delete.
     * @param {boolean} [isInbox] Whether the file is in the Inbox folder.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSharedFilesHelperProvider.prototype.removeSharedFile = function (fileEntry, isInbox) {
        if (isInbox) {
            return this.sharedFilesProvider.deleteInboxFile(fileEntry);
        }
        else {
            return this.fileProvider.removeFileByFileEntry(fileEntry);
        }
    };
    /**
     * Checks if there is a new file received in iOS and move it to the shared folder of current site.
     * If more than one site is found, the user will have to choose the site where to store it in.
     * If more than one file is found, treat only the first one.
     *
     * @param {string} [path] Path to a file received when launching the app.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSharedFilesHelperProvider.prototype.searchIOSNewSharedFiles = function (path) {
        var _this = this;
        return this.initDelegate.ready().then(function () {
            if (_this.isChoosingSite()) {
                // We're already treating a shared file. Abort.
                return Promise.reject(null);
            }
            var promise;
            if (path) {
                // The app was launched with the path to the file, get the file.
                promise = _this.fileProvider.getExternalFile(path);
            }
            else {
                // No path received, search if there is any file in the Inbox folder.
                promise = _this.sharedFilesProvider.checkIOSNewFiles();
            }
            return promise.then(function (fileEntry) {
                return _this.sitesProvider.getSitesIds().then(function (siteIds) {
                    if (!siteIds.length) {
                        // No sites stored, show error and delete the file.
                        _this.domUtils.showErrorModal('core.sharedfiles.errorreceivefilenosites', true);
                        return _this.removeSharedFile(fileEntry, !path);
                    }
                    else if (siteIds.length == 1) {
                        return _this.storeSharedFileInSite(fileEntry, siteIds[0], !path);
                    }
                    else if (!_this.isChoosingSite()) {
                        _this.goToChooseSite(fileEntry.toURL(), !path);
                    }
                });
            }).catch(function (error) {
                if (error) {
                    _this.logger.error('Error searching iOS new shared files', error, path);
                }
            });
        });
    };
    /**
     * Store a shared file in a site's shared files folder.
     *
     * @param {any} fileEntry Shared file entry.
     * @param {string} [siteId]  Site ID. If not defined, current site.
     * @param {boolean} [isInbox] Whether the file is in the Inbox folder.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSharedFilesHelperProvider.prototype.storeSharedFileInSite = function (fileEntry, siteId, isInbox) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // First of all check if there's already a file with the same name in the shared files folder.
        var sharedFilesDirPath = this.sharedFilesProvider.getSiteSharedFilesDirPath(siteId);
        return this.fileProvider.getUniqueNameInFolder(sharedFilesDirPath, fileEntry.name).then(function (newName) {
            if (newName.toLowerCase() == fileEntry.name.toLowerCase()) {
                // No file with the same name. Use the original file name.
                return newName;
            }
            else {
                // Repeated name. Ask the user what he wants to do.
                return _this.askRenameReplace(fileEntry.name, newName);
            }
        }).then(function (name) {
            return _this.sharedFilesProvider.storeFileInSite(fileEntry, name, siteId).catch(function (err) {
                _this.domUtils.showErrorModal(err || 'Error moving file.');
            }).finally(function () {
                _this.removeSharedFile(fileEntry, isInbox);
                _this.domUtils.showAlertTranslated('core.success', 'core.sharedfiles.successstorefile');
            });
        });
    };
    CoreSharedFilesHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_11__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_init__["a" /* CoreInitDelegate */],
            __WEBPACK_IMPORTED_MODULE_10__sharedfiles__["a" /* CoreSharedFilesProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */]])
    ], CoreSharedFilesHelperProvider);
    return CoreSharedFilesHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 428 */,
/* 429 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBlockComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__block_block__ = __webpack_require__(430);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};






var CoreBlockComponentsModule = /** @class */ (function () {
    function CoreBlockComponentsModule() {
    }
    CoreBlockComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__block_block__["a" /* CoreBlockComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__block_block__["a" /* CoreBlockComponent */]
            ]
        })
    ], CoreBlockComponentsModule);
    return CoreBlockComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 430 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBlockComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_dynamic_component_dynamic_component__ = __webpack_require__(162);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to render a block.
 */
var CoreBlockComponent = /** @class */ (function () {
    function CoreBlockComponent(injector, blockDelegate, eventsProvider) {
        this.injector = injector;
        this.blockDelegate = blockDelegate;
        this.eventsProvider = eventsProvider;
        this.data = {}; // Data to pass to the component.
        this.loaded = false;
    }
    /**
     * Component being initialized.
     */
    CoreBlockComponent.prototype.ngOnInit = function () {
        if (!this.block) {
            this.loaded = true;
            return;
        }
        // Get the data to render the block.
        this.initBlock();
    };
    /**
     * Get block display data and initialises the block once this is available. If the block is not
     * supported at the moment, try again if the available blocks are updated (because it comes
     * from a site plugin).
     */
    CoreBlockComponent.prototype.initBlock = function () {
        var _this = this;
        this.blockDelegate.getBlockDisplayData(this.injector, this.block, this.contextLevel, this.instanceId).then(function (data) {
            if (!data) {
                // Block not supported, don't render it. But, site plugins might not have finished loading.
                // Subscribe to the observable in block delegate that will tell us if blocks are updated.
                // We can retry init later if that happens.
                _this.blockSubscription = _this.blockDelegate.blocksUpdateObservable.subscribe(function () {
                    _this.blockSubscription.unsubscribe();
                    delete _this.blockSubscription;
                    _this.initBlock();
                });
                return;
            }
            _this.title = data.title;
            _this.class = data.class;
            _this.componentClass = data.component;
            // Set up the data needed by the block component.
            _this.data = Object.assign({
                block: _this.block,
                contextLevel: _this.contextLevel,
                instanceId: _this.instanceId,
            }, _this.extraData || {}, data.componentData || {});
        }).catch(function () {
            // Ignore errors.
        }).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * On destroy of the component, clear up any subscriptions.
     */
    CoreBlockComponent.prototype.ngOnDestroy = function () {
        if (this.blockSubscription) {
            this.blockSubscription.unsubscribe();
            delete this.blockSubscription;
        }
    };
    /**
     * Refresh the data.
     *
     * @param {any} [refresher] Refresher. Please pass this only if the refresher should finish when this function finishes.
     * @param {Function} [done] Function to call when done.
     * @param {boolean} [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreBlockComponent.prototype.doRefresh = function (refresher, done, showErrors) {
        if (showErrors === void 0) { showErrors = false; }
        if (this.dynamicComponent) {
            return Promise.resolve(this.dynamicComponent.callComponentFunction('doRefresh', [refresher, done, showErrors]));
        }
        return Promise.resolve();
    };
    /**
     * Invalidate some data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreBlockComponent.prototype.invalidate = function () {
        if (this.dynamicComponent) {
            return Promise.resolve(this.dynamicComponent.callComponentFunction('invalidateContent'));
        }
        return Promise.resolve();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */])
    ], CoreBlockComponent.prototype, "dynamicComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreBlockComponent.prototype, "block", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreBlockComponent.prototype, "contextLevel", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreBlockComponent.prototype, "instanceId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreBlockComponent.prototype, "extraData", void 0);
    CoreBlockComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-block',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\block\components\block\core-block.html"*/'<!-- Only render the block if it\'s supported. -->\n<div *ngIf="loaded && componentClass" class="{{class}}">\n    <core-dynamic-component [component]="componentClass" [data]="data"></core-dynamic-component>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\block\components\block\core-block.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_1__providers_delegate__["a" /* CoreBlockDelegate */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreBlockComponent);
    return CoreBlockComponent;
}());

//# sourceMappingURL=block.js.map

/***/ }),
/* 431 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(184);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_offline__ = __webpack_require__(267);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_sync__ = __webpack_require__(224);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_tabs_tabs__ = __webpack_require__(151);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};










/**
 * Component that displays a feedback index page.
 */
var AddonModFeedbackIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModFeedbackIndexComponent, _super);
    function AddonModFeedbackIndexComponent(injector, feedbackProvider, content, feedbackOffline, groupsProvider, feedbackSync, navCtrl, feedbackHelper, timeUtils) {
        var _this = _super.call(this, injector, content) || this;
        _this.feedbackProvider = feedbackProvider;
        _this.feedbackOffline = feedbackOffline;
        _this.groupsProvider = groupsProvider;
        _this.feedbackSync = feedbackSync;
        _this.navCtrl = navCtrl;
        _this.feedbackHelper = feedbackHelper;
        _this.timeUtils = timeUtils;
        _this.tab = 'overview';
        _this.group = 0;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_feedback__["a" /* AddonModFeedbackProvider */].COMPONENT;
        _this.moduleName = 'feedback';
        _this.access = {
            canviewreports: false,
            canviewanalysis: false,
            isempty: true
        };
        _this.groupInfo = {
            groups: [],
            separateGroups: false,
            visibleGroups: false
        };
        _this.overview = {
            timeopen: 0,
            openTimeReadable: '',
            timeclose: 0,
            closeTimeReadable: ''
        };
        _this.warning = '';
        _this.tabsLoaded = {
            overview: false,
            analysis: false
        };
        _this.showTabs = false;
        _this.tabsReady = false;
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_8__providers_sync__["a" /* AddonModFeedbackSyncProvider */].AUTO_SYNCED;
        // Listen for form submit events.
        _this.submitObserver = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_feedback__["a" /* AddonModFeedbackProvider */].FORM_SUBMITTED, function (data) {
            if (_this.feedback && data.feedbackId == _this.feedback.id) {
                _this.tabsLoaded['analysis'] = false;
                _this.tabsLoaded['overview'] = false;
                _this.loaded = false;
                var promise = void 0;
                // Prefetch data if needed.
                if (!data.offline && _this.isPrefetched()) {
                    promise = _this.feedbackSync.prefetchAfterUpdate(_this.module, _this.courseId).catch(function () {
                        // Ignore errors.
                    });
                }
                else {
                    promise = Promise.resolve();
                }
                promise.then(function () {
                    // Load the right tab.
                    if (data.tab != _this.tab) {
                        _this.tabChanged(data.tab);
                    }
                    else {
                        _this.loadContent(true);
                    }
                });
            }
        }, _this.siteId);
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModFeedbackIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.loadContent(false, true).then(function () {
            _this.feedbackProvider.logView(_this.feedback.id, _this.feedback.name).catch(function () {
                // Ignore errors.
            });
        }).finally(function () {
            _this.tabsReady = true;
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModFeedbackIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.feedbackProvider.invalidateFeedbackData(this.courseId));
        if (this.feedback) {
            promises.push(this.feedbackProvider.invalidateFeedbackAccessInformationData(this.feedback.id));
            promises.push(this.feedbackProvider.invalidateAnalysisData(this.feedback.id));
            promises.push(this.groupsProvider.invalidateActivityAllowedGroups(this.feedback.coursemodule));
            promises.push(this.groupsProvider.invalidateActivityGroupMode(this.feedback.coursemodule));
            promises.push(this.feedbackProvider.invalidateResumePageData(this.feedback.id));
        }
        this.tabsLoaded['analysis'] = false;
        this.tabsLoaded['overview'] = false;
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean}          True if refresh is needed, false otherwise.
     */
    AddonModFeedbackIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (this.feedback && syncEventData.feedbackId == this.feedback.id) {
            // Refresh the data.
            this.domUtils.scrollToTop(this.content);
            return true;
        }
        return false;
    };
    /**
     * Download feedback contents.
     *
     * @param  {boolean}      [refresh=false]    If it's refreshing content.
     * @param  {boolean}      [sync=false]       If it should try to sync.
     * @param  {boolean}      [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        return this.feedbackProvider.getFeedback(this.courseId, this.module.id).then(function (feedback) {
            _this.feedback = feedback;
            _this.description = feedback.intro || feedback.description;
            _this.dataRetrieved.emit(feedback);
            if (sync) {
                // Try to synchronize the feedback.
                return _this.syncActivity(showErrors);
            }
        }).then(function () {
            // Check if there are answers stored in offline.
            return _this.feedbackProvider.getFeedbackAccessInformation(_this.feedback.id);
        }).then(function (accessData) {
            _this.access = accessData;
            _this.showTabs = (accessData.canviewreports || accessData.canviewanalysis) && !accessData.isempty;
            _this.firstSelectedTab = 0;
            if (_this.tab == 'analysis') {
                _this.firstSelectedTab = 1;
                return _this.fetchFeedbackAnalysisData(_this.access);
            }
            return _this.fetchFeedbackOverviewData(_this.access);
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
            // Check if there are responses stored in offline.
            return _this.feedbackOffline.hasFeedbackOfflineData(_this.feedback.id);
        }).then(function (hasOffline) {
            _this.hasOffline = hasOffline;
        });
    };
    /**
     * Convenience function to get feedback overview data.
     *
     * @param {any} accessData Retrieved access data.
     * @return {Promise<any>}  Resolved when done.
     */
    AddonModFeedbackIndexComponent.prototype.fetchFeedbackOverviewData = function (accessData) {
        var _this = this;
        var promises = [];
        if (accessData.cancomplete && accessData.cansubmit && accessData.isopen) {
            promises.push(this.feedbackProvider.getResumePage(this.feedback.id).then(function (goPage) {
                _this.goPage = goPage > 0 ? goPage : false;
            }));
        }
        if (accessData.canedititems) {
            this.overview.timeopen = parseInt(this.feedback.timeopen) * 1000 || 0;
            this.overview.openTimeReadable = this.overview.timeopen ? this.timeUtils.userDate(this.overview.timeopen) : '';
            this.overview.timeclose = parseInt(this.feedback.timeclose) * 1000 || 0;
            this.overview.closeTimeReadable = this.overview.timeclose ? this.timeUtils.userDate(this.overview.timeclose) : '';
        }
        if (accessData.canviewanalysis) {
            // Get groups (only for teachers).
            promises.push(this.fetchGroupInfo(this.feedback.coursemodule));
        }
        return Promise.all(promises).finally(function () {
            _this.tabsLoaded['overview'] = true;
        });
    };
    /**
     * Convenience function to get feedback analysis data.
     *
     * @param {any} accessData Retrieved access data.
     * @return {Promise<any>}  Resolved when done.
     */
    AddonModFeedbackIndexComponent.prototype.fetchFeedbackAnalysisData = function (accessData) {
        var _this = this;
        var promise;
        if (accessData.canviewanalysis) {
            // Get groups (only for teachers).
            promise = this.fetchGroupInfo(this.feedback.coursemodule);
        }
        else {
            this.tabChanged('overview');
            promise = Promise.resolve();
        }
        return promise.finally(function () {
            _this.tabsLoaded['analysis'] = true;
        });
    };
    /**
     * Fetch Group info data.
     *
     * @param  {number}       cmId Course module ID.
     * @return {Promise<any>}      Resolved when done.
     */
    AddonModFeedbackIndexComponent.prototype.fetchGroupInfo = function (cmId) {
        var _this = this;
        return this.groupsProvider.getActivityGroupInfo(cmId).then(function (groupInfo) {
            _this.groupInfo = groupInfo;
            return _this.setGroup(_this.group);
        });
    };
    /**
     * Parse the analysis info to show the info correctly formatted.
     *
     * @param  {any} item Item to parse.
     * @return {any}      Parsed item.
     */
    AddonModFeedbackIndexComponent.prototype.parseAnalysisInfo = function (item) {
        var _this = this;
        switch (item.typ) {
            case 'numeric':
                item.average = item.data.reduce(function (prev, current) {
                    return prev + parseInt(current, 10);
                }, 0) / item.data.length;
                item.template = 'numeric';
                break;
            case 'info':
                item.data = item.data.map(function (dataItem) {
                    dataItem = _this.textUtils.parseJSON(dataItem);
                    return typeof dataItem.show != 'undefined' ? dataItem.show : false;
                }).filter(function (dataItem) {
                    // Filter false entries.
                    return dataItem;
                });
            case 'textfield':
            case 'textarea':
                item.template = 'list';
                break;
            case 'multichoicerated':
            case 'multichoice':
                item.data = item.data.map(function (dataItem) {
                    dataItem = _this.textUtils.parseJSON(dataItem);
                    return typeof dataItem.answertext != 'undefined' ? dataItem : false;
                }).filter(function (dataItem) {
                    // Filter false entries.
                    return dataItem;
                });
                // Format labels.
                item.labels = item.data.map(function (dataItem) {
                    dataItem.quotient = (dataItem.quotient * 100).toFixed(2);
                    var label = '';
                    if (typeof dataItem.value != 'undefined') {
                        label = '(' + dataItem.value + ') ';
                    }
                    label += dataItem.answertext;
                    label += dataItem.quotient > 0 ? ' (' + dataItem.quotient + '%)' : '';
                    return label;
                });
                item.chartData = item.data.map(function (dataItem) {
                    return dataItem.answercount;
                });
                if (item.typ == 'multichoicerated') {
                    item.average = item.data.reduce(function (prev, current) {
                        return prev + parseFloat(current.avg);
                    }, 0.0);
                }
                var subtype = item.presentation.charAt(0);
                var single = subtype != 'c';
                item.chartType = single ? 'doughnut' : 'bar';
                item.template = 'chart';
                break;
            default:
                break;
        }
        return item;
    };
    /**
     * Function to go to the questions form.
     *
     * @param {boolean} preview Preview or edit the form.
     */
    AddonModFeedbackIndexComponent.prototype.gotoAnswerQuestions = function (preview) {
        if (preview === void 0) { preview = false; }
        var stateParams = {
            module: this.module,
            moduleId: this.module.id,
            courseId: this.courseId,
            preview: preview
        };
        this.navCtrl.push('AddonModFeedbackFormPage', stateParams);
    };
    /**
     * User entered the page that contains the component.
     */
    AddonModFeedbackIndexComponent.prototype.ionViewDidEnter = function () {
        _super.prototype.ionViewDidEnter.call(this);
        this.tabsComponent && this.tabsComponent.ionViewDidEnter();
    };
    /**
     * User left the page that contains the component.
     */
    AddonModFeedbackIndexComponent.prototype.ionViewDidLeave = function () {
        _super.prototype.ionViewDidLeave.call(this);
        this.tabsComponent && this.tabsComponent.ionViewDidLeave();
    };
    /**
     * Function to link implemented features.
     *
     * @param {string} feature Feature to navigate.
     */
    AddonModFeedbackIndexComponent.prototype.openFeature = function (feature) {
        this.feedbackHelper.openFeature(feature, this.navCtrl, this.module, this.courseId, this.group);
    };
    /**
     * Tab changed, fetch content again.
     *
     * @param {string} tabName New tab name.
     */
    AddonModFeedbackIndexComponent.prototype.tabChanged = function (tabName) {
        this.tab = tabName;
        if (!this.tabsLoaded[this.tab]) {
            this.loadContent(false, false, true);
        }
    };
    /**
     * Set group to see the analysis.
     *
     * @param  {number}       groupId Group ID.
     * @return {Promise<any>}         Resolved when done.
     */
    AddonModFeedbackIndexComponent.prototype.setGroup = function (groupId) {
        var _this = this;
        this.group = groupId;
        return this.feedbackProvider.getAnalysis(this.feedback.id, groupId).then(function (analysis) {
            _this.feedback.completedCount = analysis.completedcount;
            _this.feedback.itemsCount = analysis.itemscount;
            if (_this.tab == 'analysis') {
                var num_1 = 1;
                _this.items = analysis.itemsdata.map(function (item) {
                    // Move data inside item.
                    item.item.data = item.data;
                    item = item.item;
                    item.number = num_1++;
                    if (item.data && item.data.length) {
                        return _this.parseAnalysisInfo(item);
                    }
                    return false;
                }).filter(function (item) {
                    return item;
                });
                _this.warning = '';
                if (analysis.warnings.length) {
                    var warning = analysis.warnings.find(function (warning) {
                        return warning.warningcode == 'insufficientresponsesforthisgroup';
                    });
                    _this.warning = warning && warning.message;
                }
            }
        });
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackIndexComponent.prototype.sync = function () {
        return this.feedbackSync.syncFeedback(this.feedback.id);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any}     result Data returned on the sync function.
     * @return {boolean}        If suceed or not.
     */
    AddonModFeedbackIndexComponent.prototype.hasSyncSucceed = function (result) {
        return result.updated;
    };
    /**
     * Component being destroyed.
     */
    AddonModFeedbackIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.submitObserver && this.submitObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_9__components_tabs_tabs__["a" /* CoreTabsComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_9__components_tabs_tabs__["a" /* CoreTabsComponent */])
    ], AddonModFeedbackIndexComponent.prototype, "tabsComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModFeedbackIndexComponent.prototype, "tab", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModFeedbackIndexComponent.prototype, "group", void 0);
    AddonModFeedbackIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-feedback-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\feedback\components\index\addon-mod-feedback-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <ng-container *ngIf="showTabs">\n        <core-tabs [hideUntil]="tabsReady" [selectedIndex]="firstSelectedTab">\n            <core-tab [title]="\'addon.mod_feedback.overview\' | translate" (ionSelect)="tabChanged(\'overview\')">\n                <ng-template>\n                    <ng-container *ngTemplateOutlet="tabOverview"></ng-container>\n                </ng-template>\n            </core-tab>\n            <core-tab [show]="access.canviewreports" [title]="\'addon.mod_feedback.analysis\' | translate" (ionSelect)="tabChanged(\'analysis\')">\n                <ng-template>\n                    <ng-container *ngTemplateOutlet="tabAnalysis"></ng-container>\n                </ng-template>\n            </core-tab>\n\n            <core-tab [show]="!access.canviewreports" [title]="\'addon.mod_feedback.completed_feedbacks\' | translate" (ionSelect)="tabChanged(\'analysis\')">\n                <ng-template>\n                    <ng-container *ngTemplateOutlet="tabAnalysis"></ng-container>\n                </ng-template>\n            </core-tab>\n        </core-tabs>\n    </ng-container>\n\n    <ng-container *ngIf="!showTabs">\n        <ng-container *ngTemplateOutlet="tabOverview"></ng-container>\n    </ng-container>\n</core-loading>\n\n\n<ng-template #basicInfo>\n    <ion-list *ngIf="access.canviewanalysis && !access.isempty">\n        <ion-item text-wrap *ngIf="access.canedititems && (groupInfo.separateGroups || groupInfo.visibleGroups)">\n            <ion-label id="addon-feedback-groupslabel" *ngIf="groupInfo.separateGroups">{{ \'core.groupsseparate\' | translate }}</ion-label>\n            <ion-label id="addon-feedback-groupslabel" *ngIf="groupInfo.visibleGroups">{{ \'core.groupsvisible\' | translate }}</ion-label>\n            <ion-select [(ngModel)]="group" (ionChange)="setGroup(group)" aria-labelledby="addon-feedback-groupslabel" interface="action-sheet">\n                <ion-option *ngFor="let groupOpt of groupInfo.groups" [value]="groupOpt.id">{{groupOpt.name}}</ion-option>\n            </ion-select>\n        </ion-item>\n        <a ion-item text-wrap (click)="access.canviewreports && feedback.completedCount > 0 && openFeature(\'Respondents\')" [attr.detail-none]="access.canviewreports && feedback.completedCount > 0 ? null : true">\n            <h2>{{ \'addon.mod_feedback.completed_feedbacks\' | translate }}</h2>\n            <ion-badge item-end>{{feedback.completedCount}}</ion-badge>\n        </a>\n        <a ion-item text-wrap *ngIf="!access.isanonymous && access.canviewreports" (click)="openFeature(\'NonRespondents\')" detail-push>\n            <h2>{{ \'addon.mod_feedback.show_nonrespondents\' | translate }}</h2>\n        </a>\n        <ion-item text-wrap>\n            <h2>{{ \'addon.mod_feedback.questions\' | translate }}</h2>\n            <ion-badge item-end>{{feedback.itemsCount}}</ion-badge>\n        </ion-item>\n    </ion-list>\n</ng-template>\n\n<!-- Template to render the overview. -->\n<ng-template #tabOverview>\n    <core-loading [hideUntil]="tabsLoaded.overview">\n        <ng-container *ngTemplateOutlet="basicInfo"></ng-container>\n\n        <!-- Feedback done in offline but not synchronized -->\n        <div class="core-warning-card" icon-start *ngIf="hasOffline">\n            <ion-icon name="warning"></ion-icon>\n            {{ \'core.hasdatatosync\' | translate: {$a: moduleName} }}\n        </div>\n\n        <div class="core-info-card" icon-start *ngIf="access.cancomplete && !access.isopen">\n            <ion-icon name="information-circle"></ion-icon>\n            {{ \'addon.mod_feedback.feedback_is_not_open\' | translate }}\n        </div>\n\n        <div class="core-success-card" *ngIf="access.cancomplete && access.isopen && !access.cansubmit">\n            <ion-icon name="checkmark"></ion-icon>\n            {{ \'addon.mod_feedback.this_feedback_is_already_submitted\' | translate }}\n        </div>\n\n        <ion-list *ngIf="access.canedititems || access.canviewreports || !access.isempty">\n            <ion-item text-wrap *ngIf="access.canedititems && overview.timeopen">\n                <h2>{{ \'addon.mod_feedback.feedbackopen\' | translate }}</h2>\n                <p>{{overview.openTimeReadable}}</p>\n            </ion-item>\n            <ion-item text-wrap *ngIf="access.canedititems && overview.timeclose">\n                <h2>{{ \'addon.mod_feedback.feedbackclose\' | translate }}</h2>\n                <p>{{overview.closeTimeReadable}}</p>\n            </ion-item>\n            <ion-item text-wrap *ngIf="access.canedititems && feedback.page_after_submit">\n                <h2>{{ \'addon.mod_feedback.page_after_submit\' | translate }}</h2>\n                <core-format-text  [component]="component" [componentId]="componentId" [text]=" feedback.page_after_submit"></core-format-text>\n            </ion-item>\n            <ng-container *ngIf="!access.isempty">\n                <ion-item text-wrap>\n                    <h2>{{ \'addon.mod_feedback.mode\' | translate }}</h2>\n                    <p *ngIf="access.isanonymous">{{ \'addon.mod_feedback.anonymous\' | translate }}</p>\n                    <p *ngIf="!access.isanonymous">{{ \'addon.mod_feedback.non_anonymous\' | translate }}</p>\n                </ion-item>\n                <ion-grid>\n                    <ion-row align-items-center>\n                        <ion-col>\n                            <button ion-button block outline icon-start (click)="gotoAnswerQuestions(true)">\n                                <ion-icon name="search"></ion-icon>\n                                {{ \'addon.mod_feedback.preview\' | translate }}\n                            </button>\n                        </ion-col>\n                        <ion-col *ngIf="access.cancomplete && access.cansubmit && access.isopen">\n                            <button ion-button block icon-end *ngIf="!goPage" (click)="gotoAnswerQuestions()">\n                                {{ \'addon.mod_feedback.complete_the_form\' | translate }}\n                                <ion-icon name="arrow-forward"></ion-icon>\n                            </button>\n                            <button ion-button block icon-end *ngIf="goPage" (click)="gotoAnswerQuestions()">\n                                {{ \'addon.mod_feedback.continue_the_form\' | translate }}\n                                <ion-icon name="arrow-forward"></ion-icon>\n                            </button>\n                        </ion-col>\n                    </ion-row>\n                </ion-grid>\n\n            </ng-container>\n        </ion-list>\n    </core-loading>\n</ng-template>\n\n<!-- Template to render the analysis. -->\n<ng-template #tabAnalysis>\n    <core-loading [hideUntil]="tabsLoaded.analysis">\n        <ng-container *ngTemplateOutlet="basicInfo"></ng-container>\n\n        <ng-container *ngIf="access.canedititems || !access.isempty">\n            <div class="core-info-card" icon-start *ngIf="warning">\n                <ion-icon name="information-circle"></ion-icon>\n                {{ warning }}\n            </div>\n\n            <ion-list *ngIf="items && items.length">\n                <ion-item text-wrap *ngFor="let item of items" class="core-analysis">\n                    <h2>{{item.number}}. <core-format-text  [component]="component" [componentId]="componentId" [text]="item.name"></core-format-text></h2>\n                    <p><core-format-text  [component]="component" [componentId]="componentId" [text]="item.label"></core-format-text></p>\n                    <ng-container [ngSwitch]="item.template">\n                        <ng-container *ngSwitchCase="\'numeric\'">\n                            <ul>\n                                <li *ngFor="let data of item.data">{{ data }}</li>\n                            </ul>\n                            <p>{{ \'addon.mod_feedback.average\' | translate }}: {{item.average | number : \'1.2-2\'}}</p>\n                        </ng-container>\n                        <ng-container *ngSwitchCase="\'list\'">\n                            <ul>\n                                <ng-container *ngFor="let data of item.data">\n                                    <li *ngIf="data">\n                                        <core-format-text [text]="data"></core-format-text>\n                                    </li>\n                                </ng-container>\n                            </ul>\n                        </ng-container>\n                        <ng-container *ngSwitchCase="\'chart\'">\n                            <core-chart [type]="item.chartType" [data]="item.chartData" [labels]="item.labels" height="300"></core-chart>\n                            <p *ngIf="item.average">{{ \'addon.mod_feedback.average\' | translate }}: {{item.average | number : \'1.2-2\'}}</p>\n                        </ng-container>\n                    </ng-container>\n                </ion-item>\n            </ion-list>\n        </ng-container>\n    </core-loading>\n</ng-template>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\feedback\components\index\addon-mod-feedback-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_feedback__["a" /* AddonModFeedbackProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_7__providers_offline__["a" /* AddonModFeedbackOfflineProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_sync__["a" /* AddonModFeedbackSyncProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModFeedbackHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonModFeedbackIndexComponent);
    return AddonModFeedbackIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 432 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_resource_component__ = __webpack_require__(164);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_folder__ = __webpack_require__(371);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_helper__ = __webpack_require__(847);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Component that displays a folder.
 * @todo Adding a new file in a folder updates the revision of all the files, so they're all shown as outdated.
 *       To ignore revision in folders we'll have to modify CoreCourseModulePrefetchDelegate, core-file and CoreFilepoolProvider.
 */
var AddonModFolderIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModFolderIndexComponent, _super);
    function AddonModFolderIndexComponent(injector, folderProvider, courseProvider, appProvider, folderHelper) {
        var _this = _super.call(this, injector) || this;
        _this.folderProvider = folderProvider;
        _this.courseProvider = courseProvider;
        _this.appProvider = appProvider;
        _this.folderHelper = folderHelper;
        _this.component = __WEBPACK_IMPORTED_MODULE_4__providers_folder__["a" /* AddonModFolderProvider */].COMPONENT;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModFolderIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.canGetFolder = this.folderProvider.isGetFolderWSAvailable();
        if (this.path) {
            // Subfolder. Use module param.
            this.showModuleData(this.module);
            this.loaded = true;
            this.refreshIcon = 'refresh';
        }
        else {
            this.loadContent().then(function () {
                _this.folderProvider.logView(_this.module.instance, _this.module.name).then(function () {
                    _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
                }).catch(function () {
                    // Ignore errors.
                });
            }).finally(function () {
                _this.loaded = true;
                _this.refreshIcon = 'refresh';
            });
        }
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModFolderIndexComponent.prototype.invalidateContent = function () {
        return this.folderProvider.invalidateContent(this.module.id, this.courseId);
    };
    /**
     * Convenience function to set scope data using module.
     * @param {any} module Module to show.
     */
    AddonModFolderIndexComponent.prototype.showModuleData = function (module) {
        this.description = module.intro || module.description;
        this.dataRetrieved.emit(module);
        if (this.path) {
            // Subfolder.
            this.contents = module.contents;
        }
        else {
            this.contents = this.folderHelper.formatContents(module.contents);
        }
    };
    /**
     * Download folder contents.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFolderIndexComponent.prototype.fetchContent = function (refresh) {
        var _this = this;
        var promise;
        if (this.canGetFolder) {
            promise = this.folderProvider.getFolder(this.courseId, this.module.id).then(function (folder) {
                return _this.courseProvider.loadModuleContents(_this.module, _this.courseId).then(function () {
                    folder.contents = _this.module.contents;
                    return folder;
                });
            });
        }
        else {
            promise = this.courseProvider.getModule(this.module.id, this.courseId).then(function (folder) {
                if (!folder.contents.length && _this.module.contents.length && !_this.appProvider.isOnline()) {
                    // The contents might be empty due to a cached data. Use the old ones.
                    folder.contents = _this.module.contents;
                }
                _this.module = folder;
                return folder;
            });
        }
        return promise.then(function (folder) {
            if (folder) {
                _this.description = folder.intro || folder.description;
                _this.dataRetrieved.emit(folder);
            }
            _this.showModuleData(folder);
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModFolderIndexComponent.prototype, "path", void 0);
    AddonModFolderIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-folder-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\folder\components\index\addon-mod-folder-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="600" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="500" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <ion-list *ngIf="contents && contents.length > 0">\n        <ng-container *ngFor="let file of contents">\n            <a *ngIf="file.type === \'folder\'" ion-item class="item-media" [navPush]="\'AddonModFolderIndexPage\'" [navParams]="{path: file.filepath, courseId: courseId, module: file}">\n                <ion-icon name="folder" item-start></ion-icon>\n                <h2>{{file.name}}</h2>\n            </a>\n            <core-file *ngIf="file.type !== \'folder\'" [file]="file" [component]="component" [componentId]="file.contextid"></core-file>\n        </ng-container>\n    </ion-list>\n\n    <core-empty-box *ngIf="!contents || contents.length == 0" icon="folder" [message]=" \'addon.mod_folder.emptyfilelist\' | translate"></core-empty-box>\n\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\folder\components\index\addon-mod-folder-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__providers_folder__["a" /* AddonModFolderProvider */], __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* AddonModFolderHelperProvider */]])
    ], AddonModFolderIndexComponent);
    return AddonModFolderIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_resource_component__["a" /* CoreCourseModuleMainResourceComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 433 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_split_view_split_view__ = __webpack_require__(121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_rating_providers_rating__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_rating_providers_offline__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_rating_providers_sync__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_forum__ = __webpack_require__(100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_helper__ = __webpack_require__(220);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_offline__ = __webpack_require__(169);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_sync__ = __webpack_require__(187);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_prefetch_handler__ = __webpack_require__(849);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};















/**
 * Component that displays a forum entry page.
 */
var AddonModForumIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModForumIndexComponent, _super);
    function AddonModForumIndexComponent(injector, content, navCtrl, modalCtrl, groupsProvider, userProvider, forumProvider, forumHelper, forumOffline, forumSync, prefetchDelegate, prefetchHandler, ratingOffline) {
        var _this = _super.call(this, injector) || this;
        _this.content = content;
        _this.navCtrl = navCtrl;
        _this.modalCtrl = modalCtrl;
        _this.groupsProvider = groupsProvider;
        _this.userProvider = userProvider;
        _this.forumProvider = forumProvider;
        _this.forumHelper = forumHelper;
        _this.forumOffline = forumOffline;
        _this.forumSync = forumSync;
        _this.prefetchDelegate = prefetchDelegate;
        _this.prefetchHandler = prefetchHandler;
        _this.ratingOffline = ratingOffline;
        _this.component = __WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].COMPONENT;
        _this.moduleName = 'forum';
        _this.canLoadMore = false;
        _this.loadMoreError = false;
        _this.discussions = [];
        _this.offlineDiscussions = [];
        _this.selectedDiscussion = 0; // Disucssion ID or negative timecreated if it's an offline discussion.
        _this.canAddDiscussion = false;
        _this.addDiscussionText = _this.translate.instant('addon.mod_forum.addanewdiscussion');
        _this.sortOrders = [];
        _this.selectedSortOrder = null;
        _this.sortOrderSelectorExpanded = false;
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* AddonModForumSyncProvider */].AUTO_SYNCED;
        _this.page = 0;
        _this.trackPosts = false;
        _this.usesGroups = false;
        _this.sortingAvailable = _this.forumProvider.isDiscussionListSortingAvailable();
        _this.sortOrders = _this.forumProvider.getAvailableSortOrders();
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModForumIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        // Refresh data if this forum discussion is synchronized from discussions list.
        this.syncManualObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* AddonModForumSyncProvider */].MANUAL_SYNCED, function (data) {
            _this.autoSyncEventReceived(data);
        }, this.siteId);
        // Listen for discussions added. When a discussion is added, we reload the data.
        this.newDiscObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].NEW_DISCUSSION_EVENT, this.eventReceived.bind(this, true));
        this.replyObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].REPLY_DISCUSSION_EVENT, this.eventReceived.bind(this, false));
        this.changeDiscObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].CHANGE_DISCUSSION_EVENT, this.eventReceived.bind(this, false));
        // Select the current opened discussion.
        this.viewDiscObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].VIEW_DISCUSSION_EVENT, function (data) {
            if (_this.forum && _this.forum.id == data.forumId) {
                _this.selectedDiscussion = _this.splitviewCtrl.isOn() ? data.discussion : 0;
                // Invalidate discussion list if it was not read.
                var discussion = _this.discussions.find(function (disc) { return disc.discussion == data.discussion; });
                if (discussion && discussion.numunread > 0) {
                    _this.forumProvider.invalidateDiscussionsList(_this.forum.id);
                }
            }
        }, this.sitesProvider.getCurrentSiteId());
        // Listen for offline ratings saved and synced.
        this.ratingOfflineObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__core_rating_providers_rating__["a" /* CoreRatingProvider */].RATING_SAVED_EVENT, function (data) {
            if (_this.forum && data.component == 'mod_forum' && data.ratingArea == 'post' &&
                data.contextLevel == 'module' && data.instanceId == _this.forum.cmid) {
                _this.hasOfflineRatings = true;
            }
        });
        this.ratingSyncObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_9__core_rating_providers_sync__["a" /* CoreRatingSyncProvider */].SYNCED_EVENT, function (data) {
            if (_this.forum && data.component == 'mod_forum' && data.ratingArea == 'post' &&
                data.contextLevel == 'module' && data.instanceId == _this.forum.cmid) {
                _this.ratingOffline.hasRatings('mod_forum', 'post', 'module', _this.forum.cmid).then(function (hasRatings) {
                    _this.hasOfflineRatings = hasRatings;
                });
            }
        });
        this.loadContent(false, true).then(function () {
            if (!_this.forum) {
                return;
            }
            if (_this.splitviewCtrl.isOn()) {
                // Load the first discussion.
                if (_this.offlineDiscussions.length > 0) {
                    _this.openNewDiscussion(_this.offlineDiscussions[0].timecreated);
                }
                else if (_this.discussions.length > 0) {
                    _this.openDiscussion(_this.discussions[0]);
                }
            }
            _this.forumProvider.logView(_this.forum.id, _this.forum.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function (error) {
                // Ignore errors.
            });
        });
    };
    /**
     * Download the component contents.
     *
     * @param  {boolean} [refresh=false]    Whether we're refreshing data.
     * @param  {boolean} [sync=false]       If the refresh needs syncing.
     * @param  {boolean} [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        this.loadMoreError = false;
        var promises = [];
        promises.push(this.forumProvider.getForum(this.courseId, this.module.id).then(function (forum) {
            _this.forum = forum;
            _this.description = forum.intro || _this.description;
            _this.descriptionNote = _this.translate.instant('addon.mod_forum.numdiscussions', { numdiscussions: forum.numdiscussions });
            if (typeof forum.istracked != 'undefined') {
                _this.trackPosts = forum.istracked;
            }
            _this.availabilityMessage = _this.forumHelper.getAvailabilityMessage(forum);
            _this.dataRetrieved.emit(forum);
            switch (forum.type) {
                case 'news':
                case 'blog':
                    _this.addDiscussionText = _this.translate.instant('addon.mod_forum.addanewtopic');
                    break;
                case 'qanda':
                    _this.addDiscussionText = _this.translate.instant('addon.mod_forum.addanewquestion');
                    break;
                default:
                    _this.addDiscussionText = _this.translate.instant('addon.mod_forum.addanewdiscussion');
            }
            if (sync) {
                // Try to synchronize the forum.
                return _this.syncActivity(showErrors).then(function (updated) {
                    if (updated) {
                        // Sync successful, send event.
                        _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* AddonModForumSyncProvider */].MANUAL_SYNCED, {
                            forumId: forum.id,
                            userId: _this.sitesProvider.getCurrentSiteUserId(),
                            source: 'index',
                        }, _this.sitesProvider.getCurrentSiteId());
                    }
                });
            }
        }).then(function () {
            return Promise.all([
                // Check if the activity uses groups.
                _this.groupsProvider.getActivityGroupMode(_this.forum.cmid).then(function (mode) {
                    _this.usesGroups = (mode === __WEBPACK_IMPORTED_MODULE_6__providers_groups__["a" /* CoreGroupsProvider */].SEPARATEGROUPS || mode === __WEBPACK_IMPORTED_MODULE_6__providers_groups__["a" /* CoreGroupsProvider */].VISIBLEGROUPS);
                }),
                _this.forumProvider.getAccessInformation(_this.forum.id).then(function (accessInfo) {
                    // Disallow adding discussions if cut-off date is reached and the user has not the capability to override it.
                    // Just in case the forum was fetched from WS when the cut-off date was not reached but it is now.
                    var cutoffDateReached = _this.forumHelper.isCutoffDateReached(_this.forum) && !accessInfo.cancanoverridecutoff;
                    _this.canAddDiscussion = _this.forum.cancreatediscussions && !cutoffDateReached;
                }),
            ]);
        }));
        promises.push(this.fetchSortOrderPreference());
        return Promise.all(promises).then(function () {
            return Promise.all([
                _this.fetchOfflineDiscussion(),
                _this.fetchDiscussions(refresh),
                _this.ratingOffline.hasRatings('mod_forum', 'post', 'module', _this.forum.cmid).then(function (hasRatings) {
                    _this.hasOfflineRatings = hasRatings;
                })
            ]);
        }).catch(function (message) {
            if (!refresh) {
                // Get forum failed, retry without using cache since it might be a new activity.
                return _this.refreshContent(sync);
            }
            _this.domUtils.showErrorModalDefault(message, 'addon.mod_forum.errorgetforum', true);
            _this.loadMoreError = true; // Set to prevent infinite calls with infinite-loading.
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Convenience function to fetch offline discussions.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumIndexComponent.prototype.fetchOfflineDiscussion = function () {
        var _this = this;
        return this.forumOffline.getNewDiscussions(this.forum.id).then(function (offlineDiscussions) {
            _this.hasOffline = !!offlineDiscussions.length;
            if (_this.hasOffline) {
                var promise = void 0;
                if (_this.usesGroups) {
                    promise = _this.forumProvider.formatDiscussionsGroups(_this.forum.cmid, offlineDiscussions);
                }
                else {
                    promise = Promise.resolve(offlineDiscussions);
                }
                return promise.then(function (offlineDiscussions) {
                    // Fill user data for Offline discussions (should be already cached).
                    var userPromises = [];
                    offlineDiscussions.forEach(function (discussion) {
                        if (discussion.parent != 0 || _this.forum.type != 'single') {
                            // Do not show author for first post and type single.
                            userPromises.push(_this.userProvider.getProfile(discussion.userid, _this.courseId, true)
                                .then(function (user) {
                                discussion.userfullname = user.fullname;
                                discussion.userpictureurl = user.profileimageurl;
                            }).catch(function () {
                                // Ignore errors.
                            }));
                        }
                    });
                    return Promise.all(userPromises).then(function () {
                        // Sort discussion by time (newer first).
                        offlineDiscussions.sort(function (a, b) { return b.timecreated - a.timecreated; });
                        _this.offlineDiscussions = offlineDiscussions;
                    });
                });
            }
            else {
                _this.offlineDiscussions = [];
            }
        });
    };
    /**
     * Convenience function to get forum discussions.
     *
     * @param  {boolean} refresh Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumIndexComponent.prototype.fetchDiscussions = function (refresh) {
        var _this = this;
        this.loadMoreError = false;
        if (refresh) {
            this.page = 0;
        }
        return this.forumProvider.getDiscussions(this.forum.id, this.selectedSortOrder.value, this.page).then(function (response) {
            var promise;
            if (_this.usesGroups) {
                promise = _this.forumProvider.formatDiscussionsGroups(_this.forum.cmid, response.discussions);
            }
            else {
                promise = Promise.resolve(response.discussions);
            }
            return promise.then(function (discussions) {
                if (_this.forum.type == 'single') {
                    // Hide author for first post and type single.
                    for (var x in discussions) {
                        if (discussions[x].userfullname && discussions[x].parent == 0) {
                            discussions[x].userfullname = false;
                            break;
                        }
                    }
                }
                if (typeof _this.forum.istracked == 'undefined' && !_this.trackPosts) {
                    // If any discussion has unread posts, the whole forum is being tracked.
                    for (var y in discussions) {
                        if (discussions[y].numunread > 0) {
                            _this.trackPosts = true;
                            break;
                        }
                    }
                }
                if (_this.page == 0) {
                    _this.discussions = discussions;
                }
                else {
                    _this.discussions = _this.discussions.concat(discussions);
                }
                _this.canLoadMore = response.canLoadMore;
                _this.page++;
                // Check if there are replies for discussions stored in offline.
                return _this.forumOffline.hasForumReplies(_this.forum.id).then(function (hasOffline) {
                    var offlinePromises = [];
                    _this.hasOffline = _this.hasOffline || hasOffline;
                    if (hasOffline) {
                        // Only update new fetched discussions.
                        discussions.forEach(function (discussion) {
                            // Get offline discussions.
                            offlinePromises.push(_this.forumOffline.getDiscussionReplies(discussion.discussion).then(function (replies) {
                                discussion.numreplies = parseInt(discussion.numreplies, 10) + replies.length;
                            }));
                        });
                    }
                    return Promise.all(offlinePromises);
                });
            });
        });
    };
    /**
     * Convenience function to load more forum discussions.
     *
     * @param {any} [infiniteComplete] Infinite scroll complete function. Only used from core-infinite-loading.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumIndexComponent.prototype.fetchMoreDiscussions = function (infiniteComplete) {
        var _this = this;
        return this.fetchDiscussions(false).catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'addon.mod_forum.errorgetforum', true);
            _this.loadMoreError = true; // Set to prevent infinite calls with infinite-loading.
        }).finally(function () {
            infiniteComplete && infiniteComplete();
        });
    };
    /**
     * Convenience function to fetch the sort order preference.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumIndexComponent.prototype.fetchSortOrderPreference = function () {
        var _this = this;
        var promise;
        if (this.sortingAvailable) {
            promise = this.userProvider.getUserPreference(__WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].PREFERENCE_SORTORDER).then(function (value) {
                return value ? parseInt(value, 10) : null;
            });
        }
        else {
            // Use default.
            promise = Promise.resolve(null);
        }
        return promise.then(function (value) {
            _this.selectedSortOrder = _this.sortOrders.find(function (sortOrder) { return sortOrder.value === value; }) || _this.sortOrders[0];
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModForumIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.forumProvider.invalidateForumData(this.courseId));
        if (this.forum) {
            promises.push(this.forumProvider.invalidateDiscussionsList(this.forum.id));
            promises.push(this.groupsProvider.invalidateActivityGroupMode(this.forum.cmid));
            promises.push(this.forumProvider.invalidateAccessInformation(this.forum.id));
        }
        if (this.sortingAvailable) {
            promises.push(this.userProvider.invalidateUserPreference(__WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].PREFERENCE_SORTORDER));
        }
        return Promise.all(promises);
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumIndexComponent.prototype.sync = function () {
        return this.prefetchHandler.sync(this.module, this.courseId);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any} result Data returned on the sync function.
     * @return {boolean} Whether it succeed or not.
     */
    AddonModForumIndexComponent.prototype.hasSyncSucceed = function (result) {
        return result.updated;
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param  {any} syncEventData Data receiven on sync observer.
     * @return {boolean} True if refresh is needed, false otherwise.
     */
    AddonModForumIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        return this.forum && syncEventData.source != 'index' && syncEventData.forumId == this.forum.id &&
            syncEventData.userId == this.sitesProvider.getCurrentSiteUserId();
    };
    /**
     * Function called when we receive an event of new discussion or reply to discussion.
     *
     * @param {boolean} isNewDiscussion Whether it's a new discussion event.
     * @param {any} data Event data.
     */
    AddonModForumIndexComponent.prototype.eventReceived = function (isNewDiscussion, data) {
        var _this = this;
        if ((this.forum && this.forum.id === data.forumId) || data.cmId === this.module.id) {
            if (isNewDiscussion && this.splitviewCtrl.isOn()) {
                // Discussion added, clear details page.
                this.splitviewCtrl.emptyDetails();
            }
            this.showLoadingAndRefresh(false).finally(function () {
                // If it's a new discussion in tablet mode, try to open it.
                if (isNewDiscussion && _this.splitviewCtrl.isOn()) {
                    if (data.discussionIds) {
                        // Discussion sent to server, search it in the list of discussions.
                        var discussion = _this.discussions.find(function (disc) {
                            return data.discussionIds.indexOf(disc.discussion) >= 0;
                        });
                        if (discussion) {
                            _this.openDiscussion(discussion);
                        }
                    }
                    else if (data.discTimecreated) {
                        // It's an offline discussion, open it.
                        _this.openNewDiscussion(data.discTimecreated);
                    }
                }
            });
            // Check completion since it could be configured to complete once the user adds a new discussion or replies.
            this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
        }
    };
    /**
     * Opens a discussion.
     *
     * @param {any} discussion Discussion object.
     */
    AddonModForumIndexComponent.prototype.openDiscussion = function (discussion) {
        var params = {
            courseId: this.courseId,
            cmId: this.module.id,
            forumId: this.forum.id,
            discussion: discussion,
            trackPosts: this.trackPosts,
        };
        this.splitviewCtrl.push('AddonModForumDiscussionPage', params);
    };
    /**
     * Opens the new discussion form.
     *
     * @param {number} [timeCreated=0] Creation time of the offline discussion.
     */
    AddonModForumIndexComponent.prototype.openNewDiscussion = function (timeCreated) {
        if (timeCreated === void 0) { timeCreated = 0; }
        var params = {
            courseId: this.courseId,
            cmId: this.module.id,
            forumId: this.forum.id,
            timeCreated: timeCreated,
        };
        this.splitviewCtrl.push('AddonModForumNewDiscussionPage', params);
        this.selectedDiscussion = 0;
    };
    /**
     * Display the sort order selector modal.
     *
     * @param {MouseEvent} event Event.
     */
    AddonModForumIndexComponent.prototype.showSortOrderSelector = function (event) {
        var _this = this;
        if (!this.sortingAvailable) {
            return;
        }
        var params = { sortOrders: this.sortOrders, selected: this.selectedSortOrder.value };
        var modal = this.modalCtrl.create('AddonModForumSortOrderSelectorPage', params);
        modal.onDidDismiss(function (sortOrder) {
            _this.sortOrderSelectorExpanded = false;
            if (sortOrder && sortOrder.value != _this.selectedSortOrder.value) {
                _this.selectedSortOrder = sortOrder;
                _this.page = 0;
                _this.userProvider.setUserPreference(__WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */].PREFERENCE_SORTORDER, sortOrder.value.toFixed(0))
                    .then(function () {
                    _this.showLoadingAndFetch();
                }).catch(function (error) {
                    _this.domUtils.showErrorModalDefault(error, 'Error updating preference.');
                });
            }
        });
        modal.present({ ev: event });
        this.sortOrderSelectorExpanded = true;
    };
    /**
     * Component being destroyed.
     */
    AddonModForumIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.syncManualObserver && this.syncManualObserver.off();
        this.newDiscObserver && this.newDiscObserver.off();
        this.replyObserver && this.replyObserver.off();
        this.viewDiscObserver && this.viewDiscObserver.off();
        this.changeDiscObserver && this.changeDiscObserver.off();
        this.ratingOfflineObserver && this.ratingOfflineObserver.off();
        this.ratingSyncObserver && this.ratingSyncObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2__components_split_view_split_view__["a" /* CoreSplitViewComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2__components_split_view_split_view__["a" /* CoreSplitViewComponent */])
    ], AddonModForumIndexComponent.prototype, "splitviewCtrl", void 0);
    AddonModForumIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-forum-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\forum\components\index\addon-mod-forum-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !(hasOffline || hasOfflineRatings) && isOnline" [priority]="700" [content]="\'addon.mod_forum.refreshdiscussions\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && (hasOffline || hasOfflineRatings) && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="sortingAvailable" [priority]="300" [content]="\'core.sort\' | translate" (action)="showSortOrderSelector($event)" iconAction="fa-sort"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-split-view>\n    <ion-content>\n        <ion-refresher [enabled]="loaded" (ionRefresh)="doRefresh($event)">\n            <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n        </ion-refresher>\n        <core-loading [hideUntil]="loaded" class="core-loading-center">\n            <core-course-module-description [description]="description" [component]="component" [componentId]="componentId" [note]="descriptionNote"></core-course-module-description>\n\n            <!-- Forum discussions found to be synchronized -->\n            <ion-card class="core-warning-card" icon-start *ngIf="hasOffline || hasOfflineRatings">\n                <ion-icon name="warning"></ion-icon> {{ \'core.hasdatatosync\' | translate:{$a: moduleName} }}\n            </ion-card>\n\n            <!-- Cut-off date or due date message -->\n            <ion-card class="core-info-card" icon-start *ngIf="availabilityMessage">\n                <ion-icon name="information-circle"></ion-icon> {{ availabilityMessage }}\n            </ion-card>\n\n            <core-empty-box *ngIf="forum && discussions.length == 0 && offlineDiscussions.length == 0" icon="chatbubbles" [message]="\'addon.mod_forum.forumnodiscussionsyet\' | translate">\n            </core-empty-box>\n\n            <div text-wrap *ngIf="sortingAvailable && selectedSortOrder" ion-row padding-horizontal padding-top margin-bottom>\n                <button *ngIf="sortingAvailable" ion-button padding-horizontal icon-end ion-col (click)="showSortOrderSelector($event)" color="light" class="core-button-select button-no-uppercase" [attr.aria-label]="(\'core.sort\' | translate)" aria-haspopup="true" [attr.aria-expanded]="sortOrderSelectorExpanded" aria-controls="addon-mod-forum-sort-order-selector" id="addon-mod-forum-sort-order-button">\n                    <span class="core-section-selector-text">{{ selectedSortOrder.label | translate }}</span>\n                    <ion-icon name="arrow-dropdown" ios="md-arrow-dropdown"></ion-icon>\n                </button>\n            </div>\n\n            <ng-container *ngIf="forum">\n                <ion-card *ngFor="let discussion of offlineDiscussions" (click)="openNewDiscussion(discussion.timecreated)" [class.addon-forum-discussion-selected]="discussion.timecreated == -selectedDiscussion">\n                    <ion-item text-wrap>\n                        <ion-avatar core-user-avatar [user]="discussion" item-start [courseId]="courseId"></ion-avatar>\n                        <h2><core-format-text [text]="discussion.subject"></core-format-text></h2>\n                        <p *ngIf="discussion.userfullname">\n                            <ion-note float-end padding-left><ion-icon name="time"></ion-icon> {{ \'core.notsent\' | translate }}</ion-note>\n                            {{discussion.userfullname}}\n                        </p>\n                    </ion-item>\n                    <ion-card-content>\n                        <ion-note text-end *ngIf="discussion.groupname">\n                            <ion-icon name="people"></ion-icon> {{ discussion.groupname }}\n                        </ion-note>\n                        <p><core-format-text [maxHeight]="60" [component]="component" [componentId]="componentId" [text]="discussion.message"></core-format-text></p>\n                    </ion-card-content>\n                </ion-card>\n                <ion-card *ngFor="let discussion of discussions" (click)="openDiscussion(discussion)" [class.addon-forum-discussion-selected]="discussion.discussion == selectedDiscussion">\n                    <ion-item text-wrap>\n                        <ion-avatar core-user-avatar [user]="discussion" item-start [courseId]="courseId"></ion-avatar>\n                        <h2>\n                            <core-icon name="fa-map-pin" *ngIf="discussion.pinned"></core-icon>\n                            <core-icon name="fa-star" class="addon-forum-star" *ngIf="!discussion.pinned && discussion.starred"></core-icon>\n                            <core-format-text [text]="discussion.subject"></core-format-text>\n                        </h2>\n                        <p>\n                            <ion-note float-end padding-left text-end>\n                                {{discussion.created | coreDateDayOrTime}}\n                                <div *ngIf="discussion.numunread"><core-icon name="fa-circle" color="primary"></core-icon> {{ \'addon.mod_forum.unreadpostsnumber\' | translate:{ \'$a\' : discussion.numunread} }}</div>\n                            </ion-note>\n                            {{discussion.userfullname}}\n                        </p>\n                    </ion-item>\n                    <ion-card-content>\n                        <core-format-text [maxHeight]="60" [component]="component" [componentId]="componentId" [text]="discussion.message"></core-format-text>\n                    </ion-card-content>\n                    <ion-row text-center>\n                        <ion-col *ngIf="discussion.groupname">\n                            <ion-note>\n                                <ion-icon name="people"></ion-icon> {{ discussion.groupname }}\n                            </ion-note>\n                        </ion-col>\n                        <ion-col>\n                            <ion-note>\n                                <ion-icon name="chatboxes"></ion-icon> {{ \'addon.mod_forum.numreplies\' | translate:{numreplies: discussion.numreplies} }}\n                            </ion-note>\n                        </ion-col>\n                        <ion-col *ngIf="discussion.timemodified > discussion.created">\n                            <ion-note>\n                                <ion-icon name="time"></ion-icon> {{discussion.timemodified | coreTimeAgo}}\n                            </ion-note>\n                        </ion-col>\n                    </ion-row>\n                </ion-card>\n            </ng-container>\n\n            <core-infinite-loading [enabled]="canLoadMore" (action)="fetchMoreDiscussions($event)" [error]="loadMoreError"></core-infinite-loading>\n        </core-loading>\n\n        <ion-fab core-fab bottom end *ngIf="forum && canAddDiscussion">\n            <button ion-fab (click)="openNewDiscussion()" [attr.aria-label]="addDiscussionText">\n                <ion-icon name="add"></ion-icon>\n            </button>\n        </ion-fab>\n    </ion-content>\n</core-split-view>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\forum\components\index\addon-mod-forum-index.html"*/,
        }),
        __param(1, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_6__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_forum__["a" /* AddonModForumProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_helper__["a" /* AddonModForumHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_offline__["a" /* AddonModForumOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* AddonModForumSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
            __WEBPACK_IMPORTED_MODULE_14__providers_prefetch_handler__["a" /* AddonModForumPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_8__core_rating_providers_offline__["a" /* CoreRatingOfflineProvider */]])
    ], AddonModForumIndexComponent);
    return AddonModForumIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 434 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__glossary__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__offline__ = __webpack_require__(188);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Helper to gather some common functions for glossary.
 */
var AddonModGlossaryHelperProvider = /** @class */ (function () {
    function AddonModGlossaryHelperProvider(fileProvider, uploaderProvider, glossaryOffline) {
        this.fileProvider = fileProvider;
        this.uploaderProvider = uploaderProvider;
        this.glossaryOffline = glossaryOffline;
    }
    /**
     * Delete stored attachment files for a new entry.
     *
     * @param  {number} glossaryId  Glossary ID.
     * @param  {string} entryName   The name of the entry.
     * @param  {number} timeCreated The time the entry was created.
     * @param  {string} [siteId]    Site ID. If not defined, current site.
     * @return {Promise<any>}       Promise resolved when deleted.
     */
    AddonModGlossaryHelperProvider.prototype.deleteStoredFiles = function (glossaryId, entryName, timeCreated, siteId) {
        var _this = this;
        return this.glossaryOffline.getEntryFolder(glossaryId, entryName, timeCreated, siteId).then(function (folderPath) {
            return _this.fileProvider.removeDir(folderPath).catch(function () {
                // Ignore any errors, CoreFileProvider.removeDir fails if folder doesn't exists.
            });
        });
    };
    /**
     * Get a list of stored attachment files for a new entry. See AddonModGlossaryHelperProvider#storeFiles.
     *
     * @param  {number} glossaryId    lossary ID.
     * @param  {string} entryName     The name of the entry.
     * @param  {number} [timeCreated] The time the entry was created.
     * @param  {string} [siteId]      Site ID. If not defined, current site.
     * @return {Promise<any[]>}         Promise resolved with the files.
     */
    AddonModGlossaryHelperProvider.prototype.getStoredFiles = function (glossaryId, entryName, timeCreated, siteId) {
        var _this = this;
        return this.glossaryOffline.getEntryFolder(glossaryId, entryName, timeCreated, siteId).then(function (folderPath) {
            return _this.uploaderProvider.getStoredFiles(folderPath);
        });
    };
    /**
     * Check if the data of an entry has changed.
     *
     * @param  {any}   entry    Current data.
     * @param  {any[]} files    Files attached.
     * @param  {any}   original Original content.
     * @return {boolean}        True if data has changed, false otherwise.
     */
    AddonModGlossaryHelperProvider.prototype.hasEntryDataChanged = function (entry, files, original) {
        if (!original || typeof original.concept == 'undefined') {
            // There is no original data.
            return entry.definition || entry.concept || files.length > 0;
        }
        if (original.definition != entry.definition || original.concept != entry.concept) {
            return true;
        }
        return this.uploaderProvider.areFileListDifferent(files, original.files);
    };
    /**
     * Given a list of files (either online files or local files), store the local files in a local folder
     * to be submitted later.
     *
     * @param  {number} glossaryId    Glossary ID.
     * @param  {string} entryName     The name of the entry.
     * @param  {number} [timeCreated] The time the entry was created.
     * @param  {any[]}  files         List of files.
     * @param  {string} [siteId]      Site ID. If not defined, current site.
     * @return {Promise<any>}         Promise resolved if success, rejected otherwise.
     */
    AddonModGlossaryHelperProvider.prototype.storeFiles = function (glossaryId, entryName, timeCreated, files, siteId) {
        var _this = this;
        // Get the folder where to store the files.
        return this.glossaryOffline.getEntryFolder(glossaryId, entryName, timeCreated, siteId).then(function (folderPath) {
            return _this.uploaderProvider.storeFilesToUpload(folderPath, files);
        });
    };
    /**
     * Upload or store some files, depending if the user is offline or not.
     *
     * @param  {number}  glossaryId    Glossary ID.
     * @param  {string}  entryName     The name of the entry.
     * @param  {number}  [timeCreated] The time the entry was created.
     * @param  {any[]}   files         List of files.
     * @param  {boolean} offline       True if files sould be stored for offline, false to upload them.
     * @param  {string}  [siteId]      Site ID. If not defined, current site.
     * @return {Promise<any>}          Promise resolved if success.
     */
    AddonModGlossaryHelperProvider.prototype.uploadOrStoreFiles = function (glossaryId, entryName, timeCreated, files, offline, siteId) {
        if (offline) {
            return this.storeFiles(glossaryId, entryName, timeCreated, files, siteId);
        }
        else {
            return this.uploaderProvider.uploadOrReuploadFiles(files, __WEBPACK_IMPORTED_MODULE_3__glossary__["a" /* AddonModGlossaryProvider */].COMPONENT, glossaryId, siteId);
        }
    };
    AddonModGlossaryHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_1__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_4__offline__["a" /* AddonModGlossaryOfflineProvider */]])
    ], AddonModGlossaryHelperProvider);
    return AddonModGlossaryHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 435 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_split_view_split_view__ = __webpack_require__(121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_rating_providers_rating__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_rating_providers_offline__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_rating_providers_sync__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_glossary__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_offline__ = __webpack_require__(188);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_sync__ = __webpack_require__(268);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__mode_picker_mode_picker__ = __webpack_require__(851);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__ = __webpack_require__(852);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Component that displays a glossary entry page.
 */
var AddonModGlossaryIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModGlossaryIndexComponent, _super);
    function AddonModGlossaryIndexComponent(injector, popoverCtrl, glossaryProvider, glossaryOffline, prefetchHandler, ratingOffline) {
        var _this = _super.call(this, injector) || this;
        _this.popoverCtrl = popoverCtrl;
        _this.glossaryProvider = glossaryProvider;
        _this.glossaryOffline = glossaryOffline;
        _this.prefetchHandler = prefetchHandler;
        _this.ratingOffline = ratingOffline;
        _this.component = __WEBPACK_IMPORTED_MODULE_7__providers_glossary__["a" /* AddonModGlossaryProvider */].COMPONENT;
        _this.moduleName = 'glossary';
        _this.isSearch = false;
        _this.entries = [];
        _this.offlineEntries = [];
        _this.canAdd = false;
        _this.canLoadMore = false;
        _this.loadMoreError = false;
        _this.loadingMessage = _this.translate.instant('core.loading');
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_9__providers_sync__["a" /* AddonModGlossarySyncProvider */].AUTO_SYNCED;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModGlossaryIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        // When an entry is added, we reload the data.
        this.addEntryObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__providers_glossary__["a" /* AddonModGlossaryProvider */].ADD_ENTRY_EVENT, this.eventReceived.bind(this));
        // Listen for offline ratings saved and synced.
        this.ratingOfflineObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__core_rating_providers_rating__["a" /* CoreRatingProvider */].RATING_SAVED_EVENT, function (data) {
            if (_this.glossary && data.component == 'mod_glossary' && data.ratingArea == 'entry' && data.contextLevel == 'module'
                && data.instanceId == _this.glossary.coursemodule) {
                _this.hasOfflineRatings = true;
            }
        });
        this.ratingSyncObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__core_rating_providers_sync__["a" /* CoreRatingSyncProvider */].SYNCED_EVENT, function (data) {
            if (_this.glossary && data.component == 'mod_glossary' && data.ratingArea == 'entry' && data.contextLevel == 'module'
                && data.instanceId == _this.glossary.coursemodule) {
                _this.hasOfflineRatings = false;
            }
        });
        this.loadContent(false, true).then(function () {
            if (!_this.glossary) {
                return;
            }
            if (_this.splitviewCtrl.isOn()) {
                // Load the first entry.
                if (_this.entries.length > 0) {
                    _this.openEntry(_this.entries[0].id);
                }
            }
            _this.glossaryProvider.logView(_this.glossary.id, _this.viewMode, _this.glossary.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function (error) {
                // Ignore errors.
            });
        });
    };
    /**
     * Download the component contents.
     *
     * @param  {boolean} [refresh=false]    Whether we're refreshing data.
     * @param  {boolean} [sync=false]       If the refresh needs syncing.
     * @param  {boolean} [showErrors=false] Wether to show errors to the user or hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModGlossaryIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        return this.glossaryProvider.getGlossary(this.courseId, this.module.id).then(function (glossary) {
            _this.glossary = glossary;
            _this.description = glossary.intro || _this.description;
            _this.canAdd = (_this.glossaryProvider.isPluginEnabledForEditing() && glossary.canaddentry) || false;
            if (!_this.fetchMode) {
                _this.switchMode('letter_all');
            }
            if (sync) {
                // Try to synchronize the glossary.
                return _this.syncActivity(showErrors);
            }
        }).then(function () {
            var promises = [];
            promises.push(_this.fetchEntries().then(function () {
                // Check if there are responses stored in offline.
                return _this.glossaryOffline.getGlossaryNewEntries(_this.glossary.id).then(function (offlineEntries) {
                    offlineEntries.sort(function (a, b) { return a.concept.localeCompare(b.fullname); });
                    _this.hasOffline = !!offlineEntries.length;
                    _this.offlineEntries = offlineEntries || [];
                });
            }));
            promises.push(_this.ratingOffline.hasRatings('mod_glossary', 'entry', 'module', _this.glossary.coursemodule)
                .then(function (hasRatings) {
                _this.hasOfflineRatings = hasRatings;
            }));
            return Promise.all(promises);
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Convenience function to fetch entries.
     *
     * @param {boolean} [append=false] True if fetched entries are appended to exsiting ones.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModGlossaryIndexComponent.prototype.fetchEntries = function (append) {
        var _this = this;
        if (append === void 0) { append = false; }
        this.loadMoreError = false;
        if (!this.fetchFunction || !this.fetchArguments) {
            // This happens in search mode with an empty query.
            return Promise.resolve({ entries: [], count: 0 });
        }
        var limitFrom = append ? this.entries.length : 0;
        var limitNum = __WEBPACK_IMPORTED_MODULE_7__providers_glossary__["a" /* AddonModGlossaryProvider */].LIMIT_ENTRIES;
        return this.glossaryProvider.fetchEntries(this.fetchFunction, this.fetchArguments, limitFrom, limitNum).then(function (result) {
            if (append) {
                Array.prototype.push.apply(_this.entries, result.entries);
            }
            else {
                _this.entries = result.entries;
            }
            _this.canLoadMore = _this.entries.length < result.count;
        }).catch(function (error) {
            return Promise.reject(error);
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModGlossaryIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        if (this.fetchInvalidate && this.fetchArguments) {
            promises.push(this.fetchInvalidate.apply(this.glossaryProvider, this.fetchArguments));
        }
        promises.push(this.glossaryProvider.invalidateCourseGlossaries(this.courseId));
        if (this.glossary && this.glossary.id) {
            promises.push(this.glossaryProvider.invalidateCategories(this.glossary.id));
        }
        return Promise.all(promises);
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModGlossaryIndexComponent.prototype.sync = function () {
        return this.prefetchHandler.sync(this.module, this.courseId);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any} result Data returned on the sync function.
     * @return {boolean} Whether it succeed or not.
     */
    AddonModGlossaryIndexComponent.prototype.hasSyncSucceed = function (result) {
        return result.updated;
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param  {any} syncEventData Data receiven on sync observer.
     * @return {boolean} True if refresh is needed, false otherwise.
     */
    AddonModGlossaryIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        return this.glossary && syncEventData.glossaryId == this.glossary.id &&
            syncEventData.userId == this.sitesProvider.getCurrentSiteUserId();
    };
    /**
     * Change fetch mode.
     *
     * @param {FetchMode} mode New mode.
     */
    AddonModGlossaryIndexComponent.prototype.switchMode = function (mode) {
        var _this = this;
        this.fetchMode = mode;
        switch (mode) {
            case 'author_all':
                // Browse by author.
                this.viewMode = 'author';
                this.fetchFunction = this.glossaryProvider.getEntriesByAuthor;
                this.fetchInvalidate = this.glossaryProvider.invalidateEntriesByAuthor;
                this.fetchArguments = [this.glossary.id, 'ALL', 'LASTNAME', 'ASC'];
                this.getDivider = function (entry) { return entry.userfullname; };
                this.showDivider = function (entry, previous) {
                    return typeof previous === 'undefined' || entry.userid != previous.userid;
                };
                break;
            case 'cat_all':
                // Browse by category.
                this.viewMode = 'cat';
                this.fetchFunction = this.glossaryProvider.getEntriesByCategory;
                this.fetchInvalidate = this.glossaryProvider.invalidateEntriesByCategory;
                this.fetchArguments = [this.glossary.id, __WEBPACK_IMPORTED_MODULE_7__providers_glossary__["a" /* AddonModGlossaryProvider */].SHOW_ALL_CATERGORIES];
                this.getDivider = function (entry) { return entry.categoryname; };
                this.showDivider = function (entry, previous) {
                    return !previous || _this.getDivider(entry) != _this.getDivider(previous);
                };
                break;
            case 'newest_first':
                // Newest first.
                this.viewMode = 'date';
                this.fetchFunction = this.glossaryProvider.getEntriesByDate;
                this.fetchInvalidate = this.glossaryProvider.invalidateEntriesByDate;
                this.fetchArguments = [this.glossary.id, 'CREATION', 'DESC'];
                this.getDivider = null;
                this.showDivider = function () { return false; };
                break;
            case 'recently_updated':
                // Recently updated.
                this.viewMode = 'date';
                this.fetchFunction = this.glossaryProvider.getEntriesByDate;
                this.fetchInvalidate = this.glossaryProvider.invalidateEntriesByDate;
                this.fetchArguments = [this.glossary.id, 'UPDATE', 'DESC'];
                this.getDivider = null;
                this.showDivider = function () { return false; };
                break;
            case 'search':
                // Search for entries.
                this.viewMode = 'search';
                this.fetchFunction = this.glossaryProvider.getEntriesBySearch;
                this.fetchInvalidate = this.glossaryProvider.invalidateEntriesBySearch;
                this.fetchArguments = null; // Dynamically set later.
                this.getDivider = null;
                this.showDivider = function () { return false; };
                break;
            case 'letter_all':
            default:
                // Consider it is 'letter_all'.
                this.viewMode = 'letter';
                this.fetchMode = 'letter_all';
                this.fetchFunction = this.glossaryProvider.getEntriesByLetter;
                this.fetchInvalidate = this.glossaryProvider.invalidateEntriesByLetter;
                this.fetchArguments = [this.glossary.id, 'ALL'];
                this.getDivider = function (entry) { return entry.concept.substr(0, 1).toUpperCase(); };
                this.showDivider = function (entry, previous) {
                    return !previous || _this.getDivider(entry) != _this.getDivider(previous);
                };
                break;
        }
    };
    /**
     * Convenience function to load more forum discussions.
     *
     * @param {any} [infiniteComplete] Infinite scroll complete function. Only used from core-infinite-loading.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModGlossaryIndexComponent.prototype.loadMoreEntries = function (infiniteComplete) {
        var _this = this;
        return this.fetchEntries(true).catch(function (error) {
            _this.loadMoreError = true;
            _this.domUtils.showErrorModalDefault(error, 'addon.mod_glossary.errorloadingentries', true);
        }).finally(function () {
            infiniteComplete && infiniteComplete();
        });
    };
    /**
     * Show the mode picker menu.
     *
     * @param {MouseEvent} event Event.
     */
    AddonModGlossaryIndexComponent.prototype.openModePicker = function (event) {
        var _this = this;
        var popover = this.popoverCtrl.create(__WEBPACK_IMPORTED_MODULE_10__mode_picker_mode_picker__["a" /* AddonModGlossaryModePickerPopoverComponent */], {
            glossary: this.glossary,
            selectedMode: this.fetchMode
        });
        popover.onDidDismiss(function (newMode) {
            if (newMode === _this.fetchMode) {
                return;
            }
            _this.loadingMessage = _this.translate.instant('core.loading');
            _this.domUtils.scrollToTop(_this.content);
            _this.switchMode(newMode);
            if (_this.fetchMode === 'search') {
                // If it's not an instant search, then we reset the values.
                _this.entries = [];
                _this.canLoadMore = false;
            }
            else {
                _this.loaded = false;
                _this.loadContent();
            }
        });
        popover.present({
            ev: event
        });
    };
    /**
     * Opens an entry.
     *
     * @param {number} entryId Entry id.
     */
    AddonModGlossaryIndexComponent.prototype.openEntry = function (entryId) {
        var params = {
            courseId: this.courseId,
            entryId: entryId
        };
        this.splitviewCtrl.push('AddonModGlossaryEntryPage', params);
        this.selectedEntry = entryId;
    };
    /**
     * Opens new entry editor.
     *
     * @param {any} [entry] Offline entry to edit.
     */
    AddonModGlossaryIndexComponent.prototype.openNewEntry = function (entry) {
        var params = {
            courseId: this.courseId,
            module: this.module,
            glossary: this.glossary,
            entry: entry,
        };
        this.splitviewCtrl.getMasterNav().push('AddonModGlossaryEditPage', params);
        this.selectedEntry = 0;
    };
    /**
     * Search entries.
     *
     * @param {string} query Text entered on the search box.
     */
    AddonModGlossaryIndexComponent.prototype.search = function (query) {
        this.loadingMessage = this.translate.instant('core.searching');
        this.fetchArguments = [this.glossary.id, query, 1, 'CONCEPT', 'ASC'];
        this.loaded = false;
        this.loadContent();
    };
    /**
     * Function called when we receive an event of new entry.
     *
     * @param {any} data Event data.
     */
    AddonModGlossaryIndexComponent.prototype.eventReceived = function (data) {
        if (this.glossary && this.glossary.id === data.glossaryId) {
            this.showLoadingAndRefresh(false);
            // Check completion since it could be configured to complete once the user adds a new discussion or replies.
            this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
        }
    };
    /**
     * Component being destroyed.
     */
    AddonModGlossaryIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.addEntryObserver && this.addEntryObserver.off();
        this.ratingOfflineObserver && this.ratingOfflineObserver.off();
        this.ratingSyncObserver && this.ratingSyncObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2__components_split_view_split_view__["a" /* CoreSplitViewComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2__components_split_view_split_view__["a" /* CoreSplitViewComponent */])
    ], AddonModGlossaryIndexComponent.prototype, "splitviewCtrl", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */])
    ], AddonModGlossaryIndexComponent.prototype, "content", void 0);
    AddonModGlossaryIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-glossary-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\glossary\components\index\addon-mod-glossary-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <button *ngIf="glossary" ion-button icon-only (click)="openModePicker($event)" [attr.aria-label]="\'addon.mod_glossary.browsemode\' | translate">\n        <ion-icon name="funnel"></ion-icon>\n    </button>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !(hasOffline || hasOfflineRatings) && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && (hasOffline || hasOfflineRatings) && isOnline"  [priority]="650" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="canAdd" [priority]="600" [content]="\'addon.mod_glossary.addentry\' | translate" (action)="openNewEntry()" iconAction="add"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-split-view>\n    <ion-content>\n        <ion-refresher [enabled]="loaded" (ionRefresh)="doRefresh($event)">\n            <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n        </ion-refresher>\n\n        <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n        <!-- Glossary entries found to be synchronized -->\n        <ion-card class="core-warning-card" icon-start *ngIf="hasOffline || hasOfflineRatings">\n            <ion-icon name="warning"></ion-icon> {{ \'core.hasdatatosync\' | translate:{$a: moduleName} }}\n        </ion-card>\n\n        <core-search-box *ngIf="viewMode == \'search\'" (onSubmit)="search($event)" [placeholder]="\'addon.mod_glossary.searchquery\' | translate" [autoFocus]="true" [lengthCheck]="2" [showClear]="false"></core-search-box>\n\n        <core-loading [hideUntil]="loaded" class="core-loading-center">\n\n            <ion-list *ngIf="viewMode != \'search\' && offlineEntries.length > 0">\n                <ion-item-divider>\n                    {{ \'addon.mod_glossary.entriestobesynced\' | translate }}\n                </ion-item-divider>\n                <a ion-item *ngFor="let entry of offlineEntries" (click)="openNewEntry(entry)" detail-none>\n                    <p>{{entry.concept}}</p>\n                </a>\n            </ion-list>\n\n            <ion-list *ngIf="entries.length > 0">\n                <ng-container *ngFor="let entry of entries; let index = index">\n\n                    <ion-item-divider *ngIf="showDivider(entry, entries[index - 1])">\n                        {{getDivider(entry)}}\n                    </ion-item-divider>\n\n                    <a ion-item (click)="openEntry(entry.id)" [class.core-split-item-selected]="entry.id == selectedEntry" detail-none>\n                        <p>{{entry.concept}}</p>\n                    </a>\n                </ng-container>\n            </ion-list>\n\n            <core-empty-box *ngIf="!entries.length && !offlineEntries.length" icon="list" [message]="\'addon.mod_glossary.noentriesfound\' | translate"></core-empty-box>\n\n            <core-infinite-loading [enabled]="canLoadMore" (action)="loadMoreEntries($event)" [error]="loadMoreError"></core-infinite-loading>\n        </core-loading>\n\n        <ion-fab core-fab bottom end *ngIf="canAdd">\n            <button ion-fab (click)="openNewEntry()" [attr.aria-label]="\'addon.mod_glossary.addentry\' | translate">\n                <ion-icon name="add"></ion-icon>\n            </button>\n        </ion-fab>\n    </ion-content>\n</core-split-view>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\glossary\components\index\addon-mod-glossary-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["x" /* PopoverController */],
            __WEBPACK_IMPORTED_MODULE_7__providers_glossary__["a" /* AddonModGlossaryProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_offline__["a" /* AddonModGlossaryOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__["a" /* AddonModGlossaryPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_5__core_rating_providers_offline__["a" /* CoreRatingOfflineProvider */]])
    ], AddonModGlossaryIndexComponent);
    return AddonModGlossaryIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 436 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__ = __webpack_require__(164);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_imscp__ = __webpack_require__(214);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__ = __webpack_require__(854);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_toc_popover_toc_popover__ = __webpack_require__(855);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Component that displays a IMSCP.
 */
var AddonModImscpIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModImscpIndexComponent, _super);
    function AddonModImscpIndexComponent(injector, imscpProvider, courseProvider, appProvider, popoverCtrl, imscpPrefetch) {
        var _this = _super.call(this, injector) || this;
        _this.imscpProvider = imscpProvider;
        _this.courseProvider = courseProvider;
        _this.appProvider = appProvider;
        _this.popoverCtrl = popoverCtrl;
        _this.imscpPrefetch = imscpPrefetch;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_imscp__["a" /* AddonModImscpProvider */].COMPONENT;
        _this.items = [];
        _this.src = '';
        // Initialize empty previous/next to prevent showing arrows for an instant before they're hidden.
        _this.previousItem = '';
        _this.nextItem = '';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModImscpIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.loadContent().then(function () {
            _this.imscpProvider.logView(_this.module.instance, _this.module.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModImscpIndexComponent.prototype.invalidateContent = function () {
        return this.imscpProvider.invalidateContent(this.module.id, this.courseId);
    };
    /**
     * Download imscp contents.
     *
     * @param  {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModImscpIndexComponent.prototype.fetchContent = function (refresh) {
        var _this = this;
        var downloadFailed = false;
        var promises = [];
        promises.push(this.imscpProvider.getImscp(this.courseId, this.module.id).then(function (imscp) {
            _this.description = imscp.intro || imscp.description;
            _this.dataRetrieved.emit(imscp);
        }));
        promises.push(this.imscpPrefetch.download(this.module, this.courseId).catch(function () {
            // Mark download as failed but go on since the main files could have been downloaded.
            downloadFailed = true;
            return _this.courseProvider.loadModuleContents(_this.module, _this.courseId).catch(function (error) {
                // Error getting module contents, fail.
                _this.domUtils.showErrorModalDefault(error, 'core.course.errorgetmodule', true);
                return Promise.reject(null);
            });
        }));
        return Promise.all(promises).then(function () {
            _this.items = _this.imscpProvider.createItemList(_this.module.contents);
            if (_this.items.length && typeof _this.currentItem == 'undefined') {
                _this.currentItem = _this.items[0].href;
            }
            return _this.loadItem(_this.currentItem).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'addon.mod_imscp.deploymenterror', true);
                return Promise.reject(null);
            });
        }).then(function () {
            if (downloadFailed && _this.appProvider.isOnline()) {
                // We could load the main file but the download failed. Show error message.
                _this.domUtils.showErrorModal('core.errordownloadingsomefiles', true);
            }
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Loads an item.
     *
     * @param  {string} itemId Item ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModImscpIndexComponent.prototype.loadItem = function (itemId) {
        var _this = this;
        return this.imscpProvider.getIframeSrc(this.module, itemId).then(function (src) {
            _this.currentItem = itemId;
            _this.previousItem = _this.imscpProvider.getPreviousItem(_this.items, itemId);
            _this.nextItem = _this.imscpProvider.getNextItem(_this.items, itemId);
            if (_this.src && src == _this.src) {
                // Re-loading same page. Set it to empty and then re-set the src in the next digest so it detects it has changed.
                _this.src = '';
                setTimeout(function () {
                    _this.src = src;
                });
            }
            else {
                _this.src = src;
            }
        });
    };
    /**
     * Show the TOC.
     *
     * @param {MouseEvent} event Event.
     */
    AddonModImscpIndexComponent.prototype.showToc = function (event) {
        var _this = this;
        var popover = this.popoverCtrl.create(__WEBPACK_IMPORTED_MODULE_7__components_toc_popover_toc_popover__["a" /* AddonModImscpTocPopoverComponent */], { items: this.items });
        popover.onDidDismiss(function (itemId) {
            if (!itemId) {
                // Not valid, probably a category.
                return;
            }
            _this.loadItem(itemId);
        });
        popover.present({
            ev: event
        });
    };
    AddonModImscpIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-imscp-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\imscp\components\index\addon-mod-imscp-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <button ion-button icon-only (click)="showToc($event)">\n        <ion-icon name="bookmark" *ngIf="items.length"></ion-icon>\n    </button>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="600" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="500" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <div class="addon-mod-imscp-container">\n        <core-navigation-bar [previous]="previousItem" [next]="nextItem" (action)="loadItem($event)" [info]="description" [title]="\'core.description\' | translate" [component]="component" [componentId]="componentId"></core-navigation-bar>\n        <core-iframe [src]="src"></core-iframe>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\imscp\components\index\addon-mod-imscp-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_imscp__["a" /* AddonModImscpProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["x" /* PopoverController */],
            __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__["a" /* AddonModImscpPrefetchHandler */]])
    ], AddonModImscpIndexComponent);
    return AddonModImscpIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__["a" /* CoreCourseModuleMainResourceComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 437 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_lesson__ = __webpack_require__(102);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_lesson_offline__ = __webpack_require__(225);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_lesson_sync__ = __webpack_require__(226);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__ = __webpack_require__(372);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__components_tabs_tabs__ = __webpack_require__(151);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};













/**
 * Component that displays a lesson entry page.
 */
var AddonModLessonIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModLessonIndexComponent, _super);
    function AddonModLessonIndexComponent(injector, lessonProvider, content, groupsProvider, lessonOffline, lessonSync, utils, prefetchHandler, navCtrl, timeUtils, userProvider) {
        var _this = _super.call(this, injector, content) || this;
        _this.lessonProvider = lessonProvider;
        _this.groupsProvider = groupsProvider;
        _this.lessonOffline = lessonOffline;
        _this.lessonSync = lessonSync;
        _this.utils = utils;
        _this.prefetchHandler = prefetchHandler;
        _this.navCtrl = navCtrl;
        _this.timeUtils = timeUtils;
        _this.userProvider = userProvider;
        _this.component = __WEBPACK_IMPORTED_MODULE_7__providers_lesson__["a" /* AddonModLessonProvider */].COMPONENT;
        _this.moduleName = 'lesson';
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_9__providers_lesson_sync__["a" /* AddonModLessonSyncProvider */].AUTO_SYNCED;
        _this.dataSent = false; // Whether some data was sent to server while playing the lesson.
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModLessonIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.selectedTab = this.action == 'report' ? 1 : 0;
        this.loadContent(false, true).then(function () {
            if (!_this.lesson || (_this.preventMessages && _this.preventMessages.length)) {
                return;
            }
            _this.logView();
        });
    };
    /**
     * Change the group displayed.
     *
     * @param {number} groupId Group ID to display.
     */
    AddonModLessonIndexComponent.prototype.changeGroup = function (groupId) {
        var _this = this;
        this.reportLoaded = false;
        this.setGroup(groupId).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'Error getting report.');
        }).finally(function () {
            _this.reportLoaded = true;
        });
    };
    /**
     * Get the lesson data.
     *
     * @param {boolean} [refresh=false] If it's refreshing content.
     * @param {boolean} [sync=false] If it should try to sync.
     * @param {boolean} [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        var lessonReady = true;
        this.askPassword = false;
        return this.lessonProvider.getLesson(this.courseId, this.module.id).then(function (lessonData) {
            _this.lesson = lessonData;
            _this.dataRetrieved.emit(_this.lesson);
            _this.description = _this.lesson.intro; // Show description only if intro is present.
            if (sync) {
                // Try to synchronize the lesson.
                return _this.syncActivity(showErrors);
            }
        }).then(function () {
            return _this.lessonProvider.getAccessInformation(_this.lesson.id);
        }).then(function (info) {
            var promises = [];
            _this.accessInfo = info;
            _this.canManage = info.canmanage;
            _this.canViewReports = info.canviewreports;
            _this.preventMessages = [];
            if (_this.lessonProvider.isLessonOffline(_this.lesson)) {
                // Handle status.
                _this.setStatusListener();
                // Check if there is offline data.
                promises.push(_this.lessonSync.hasDataToSync(_this.lesson.id, info.attemptscount).then(function (hasOffline) {
                    _this.hasOffline = hasOffline;
                }));
                // Check if there is a retake finished in a synchronization.
                promises.push(_this.lessonSync.getRetakeFinishedInSync(_this.lesson.id).then(function (retake) {
                    if (retake && retake.retake == info.attemptscount - 1) {
                        // The retake finished is still the last retake. Allow reviewing it.
                        _this.retakeToReview = retake;
                    }
                    else {
                        _this.retakeToReview = undefined;
                        if (retake) {
                            _this.lessonSync.deleteRetakeFinishedInSync(_this.lesson.id);
                        }
                    }
                }));
                // Check if the ser has a finished retake in offline.
                promises.push(_this.lessonOffline.hasFinishedRetake(_this.lesson.id).then(function (finished) {
                    _this.finishedOffline = finished;
                }));
                // Update the list of content pages viewed and question attempts.
                promises.push(_this.lessonProvider.getContentPagesViewedOnline(_this.lesson.id, info.attemptscount));
                promises.push(_this.lessonProvider.getQuestionsAttemptsOnline(_this.lesson.id, info.attemptscount));
            }
            if (info.preventaccessreasons && info.preventaccessreasons.length) {
                var preventReason_1 = _this.lessonProvider.getPreventAccessReason(info, false);
                var askPassword = preventReason_1.reason == 'passwordprotectedlesson';
                if (askPassword) {
                    // The lesson requires a password. Check if there is one in memory or DB.
                    var promise = _this.password ? Promise.resolve(_this.password) :
                        _this.lessonProvider.getStoredPassword(_this.lesson.id);
                    promises.push(promise.then(function (password) {
                        return _this.validatePassword(password);
                    }).then(function () {
                        // Now that we have the password, get the access reason again ignoring the password.
                        preventReason_1 = _this.lessonProvider.getPreventAccessReason(info, true);
                        if (preventReason_1) {
                            _this.preventMessages = [preventReason_1];
                        }
                    }).catch(function () {
                        // No password or the validation failed. Show password form.
                        _this.askPassword = true;
                        _this.preventMessages = [preventReason_1];
                        lessonReady = false;
                    }));
                }
                else {
                    // Lesson cannot be started.
                    _this.preventMessages = [preventReason_1];
                    lessonReady = false;
                }
            }
            if (_this.selectedTab == 1 && _this.canViewReports) {
                // Only fetch the report data if the tab is selected.
                promises.push(_this.fetchReportData());
            }
            return Promise.all(promises).then(function () {
                if (lessonReady) {
                    // Lesson can be started, don't ask the password and don't show prevent messages.
                    _this.lessonReady(refresh);
                }
            });
        });
    };
    /**
     * Fetch the reports data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonIndexComponent.prototype.fetchReportData = function () {
        var _this = this;
        return this.groupsProvider.getActivityGroupInfo(this.module.id).then(function (groupInfo) {
            _this.groupInfo = groupInfo;
            return _this.setGroup(_this.group || 0);
        }).finally(function () {
            _this.reportLoaded = true;
        });
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param {any} result Data returned on the sync function.
     * @return {boolean} If suceed or not.
     */
    AddonModLessonIndexComponent.prototype.hasSyncSucceed = function (result) {
        if (result.updated || this.dataSent) {
            // Check completion status if something was sent.
            this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
        }
        this.dataSent = false;
        return result.updated;
    };
    /**
     * User entered the page that contains the component.
     */
    AddonModLessonIndexComponent.prototype.ionViewDidEnter = function () {
        _super.prototype.ionViewDidEnter.call(this);
        this.tabsComponent && this.tabsComponent.ionViewDidEnter();
        // Update data when we come back from the player since the status could have changed.
        if (this.hasPlayed) {
            this.hasPlayed = false;
            this.dataSentObserver && this.dataSentObserver.off(); // Stop listening for changes.
            this.dataSentObserver = undefined;
            // Refresh data.
            this.showLoadingAndRefresh(true, false);
        }
    };
    /**
     * User left the page that contains the component.
     */
    AddonModLessonIndexComponent.prototype.ionViewDidLeave = function () {
        var _this = this;
        _super.prototype.ionViewDidLeave.call(this);
        this.tabsComponent && this.tabsComponent.ionViewDidLeave();
        if (this.navCtrl.getActive().component.name == 'AddonModLessonPlayerPage') {
            this.hasPlayed = true;
            // Detect if anything was sent to server.
            this.dataSentObserver && this.dataSentObserver.off();
            this.dataSentObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__providers_lesson__["a" /* AddonModLessonProvider */].DATA_SENT_EVENT, function (data) {
                // Ignore launch sending because it only affects timers.
                if (data.lessonId === _this.lesson.id && data.type != 'launch') {
                    _this.dataSent = true;
                }
            }, this.siteId);
        }
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModLessonIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.lessonProvider.invalidateLessonData(this.courseId));
        if (this.lesson) {
            promises.push(this.lessonProvider.invalidateAccessInformation(this.lesson.id));
            promises.push(this.lessonProvider.invalidatePages(this.lesson.id));
            promises.push(this.lessonProvider.invalidateLessonWithPassword(this.lesson.id));
            promises.push(this.lessonProvider.invalidateTimers(this.lesson.id));
            promises.push(this.lessonProvider.invalidateContentPagesViewed(this.lesson.id));
            promises.push(this.lessonProvider.invalidateQuestionsAttempts(this.lesson.id));
            promises.push(this.lessonProvider.invalidateRetakesOverview(this.lesson.id));
            promises.push(this.groupsProvider.invalidateActivityGroupInfo(this.module.id));
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean} True if refresh is needed, false otherwise.
     */
    AddonModLessonIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        return this.lesson && syncEventData.lessonId == this.lesson.id;
    };
    /**
     * Function called when the lesson is ready to be seen (no pending prevent access reasons).
     *
     * @param {boolean} [refresh=false] If it's refreshing content.
     */
    AddonModLessonIndexComponent.prototype.lessonReady = function (refresh) {
        this.askPassword = false;
        this.leftDuringTimed = this.hasOffline || this.lessonProvider.leftDuringTimed(this.accessInfo);
        if (this.password) {
            // Store the password in DB.
            this.lessonProvider.storePassword(this.lesson.id, this.password);
        }
        // All data obtained, now fill the context menu.
        this.fillContextMenu(refresh);
    };
    /**
     * Log viewing the lesson.
     */
    AddonModLessonIndexComponent.prototype.logView = function () {
        var _this = this;
        this.lessonProvider.logViewLesson(this.lesson.id, this.password, this.lesson.name).then(function () {
            _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
        }).catch(function (error) {
            // Ignore errors.
        });
    };
    /**
     * Open the lesson player.
     *
     * @param  {boolean} continueLast Whether to continue the last retake.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonIndexComponent.prototype.playLesson = function (continueLast) {
        var _this = this;
        // Calculate the pageId to load. If there is timelimit, lesson is always restarted from the start.
        var promise;
        if (this.hasOffline) {
            if (continueLast) {
                promise = this.lessonProvider.getLastPageSeen(this.lesson.id, this.accessInfo.attemptscount);
            }
            else {
                promise = Promise.resolve(this.accessInfo.firstpageid);
            }
        }
        else if (this.leftDuringTimed && !this.lesson.timelimit) {
            promise = Promise.resolve(continueLast ? this.accessInfo.lastpageseen : this.accessInfo.firstpageid);
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function (pageId) {
            _this.navCtrl.push('AddonModLessonPlayerPage', {
                courseId: _this.courseId,
                lessonId: _this.lesson.id,
                pageId: pageId,
                password: _this.password
            });
        });
    };
    /**
     * Reports tab selected.
     */
    AddonModLessonIndexComponent.prototype.reportsSelected = function () {
        var _this = this;
        if (!this.groupInfo) {
            this.fetchReportData().catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'Error getting report.');
            });
        }
    };
    /**
     * Review the lesson.
     */
    AddonModLessonIndexComponent.prototype.review = function () {
        if (!this.retakeToReview) {
            // No retake to review, stop.
            return;
        }
        this.navCtrl.push('AddonModLessonPlayerPage', {
            courseId: this.courseId,
            lessonId: this.lesson.id,
            pageId: this.retakeToReview.pageid,
            password: this.password,
            review: true,
            retake: this.retakeToReview.retake
        });
    };
    /**
     * Set a group to view the reports.
     *
     * @param  {number} groupId Group ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonIndexComponent.prototype.setGroup = function (groupId) {
        var _this = this;
        this.group = groupId;
        this.selectedGroupName = '';
        // Search the name of the group if it isn't all participants.
        if (groupId && this.groupInfo && this.groupInfo.groups) {
            for (var i = 0; i < this.groupInfo.groups.length; i++) {
                var group = this.groupInfo.groups[i];
                if (groupId == group.id) {
                    this.selectedGroupName = group.name;
                    break;
                }
            }
        }
        // Get the overview of retakes for the group.
        return this.lessonProvider.getRetakesOverview(this.lesson.id, groupId).then(function (data) {
            var promises = [];
            // Format times and grades.
            if (data && data.avetime != null && data.numofattempts) {
                data.avetime = Math.floor(data.avetime / data.numofattempts);
                data.avetimeReadable = _this.timeUtils.formatTime(data.avetime);
            }
            if (data && data.hightime != null) {
                data.hightimeReadable = _this.timeUtils.formatTime(data.hightime);
            }
            if (data && data.lowtime != null) {
                data.lowtimeReadable = _this.timeUtils.formatTime(data.lowtime);
            }
            if (data && data.lessonscored) {
                if (data.numofattempts) {
                    data.avescore = _this.textUtils.roundToDecimals(data.avescore, 2);
                }
                if (data.highscore != null) {
                    data.highscore = _this.textUtils.roundToDecimals(data.highscore, 2);
                }
                if (data.lowscore != null) {
                    data.lowscore = _this.textUtils.roundToDecimals(data.lowscore, 2);
                }
            }
            if (data && data.students) {
                // Get the user data for each student returned.
                data.students.forEach(function (student) {
                    student.bestgrade = _this.textUtils.roundToDecimals(student.bestgrade, 2);
                    promises.push(_this.userProvider.getProfile(student.id, _this.courseId, true).then(function (user) {
                        student.profileimageurl = user.profileimageurl;
                    }).catch(function () {
                        // Error getting profile, resolve promise without adding any extra data.
                    }));
                });
            }
            return _this.utils.allPromises(promises).catch(function () {
                // Shouldn't happen.
            }).then(function () {
                _this.overview = data;
            });
        });
    };
    /**
     * Displays some data based on the current status.
     *
     * @param {string} status The current status.
     * @param {string} [previousStatus] The previous status. If not defined, there is no previous status.
     */
    AddonModLessonIndexComponent.prototype.showStatus = function (status, previousStatus) {
        this.showSpinner = status == __WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].DOWNLOADING;
    };
    /**
     * Start the lesson.
     *
     * @param {boolean} [continueLast] Whether to continue the last attempt.
     */
    AddonModLessonIndexComponent.prototype.start = function (continueLast) {
        var _this = this;
        if (this.showSpinner) {
            // Lesson is being downloaded, abort.
            return;
        }
        if (this.lessonProvider.isLessonOffline(this.lesson)) {
            // Lesson supports offline, check if it needs to be downloaded.
            if (this.currentStatus != __WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].DOWNLOADED) {
                // Prefetch the lesson.
                this.showSpinner = true;
                this.prefetchHandler.prefetch(this.module, this.courseId, true).then(function () {
                    // Success downloading, open lesson.
                    _this.playLesson(continueLast);
                }).catch(function (error) {
                    if (_this.hasOffline) {
                        // Error downloading but there is something offline, allow continuing it.
                        _this.playLesson(continueLast);
                    }
                    else {
                        _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
                    }
                }).finally(function () {
                    _this.showSpinner = false;
                });
            }
            else {
                // Already downloaded, open it.
                this.playLesson(continueLast);
            }
        }
        else {
            this.playLesson(continueLast);
        }
    };
    /**
     * Submit password for password protected lessons.
     *
     * @param {Event} e Event.
     * @param {HTMLInputElement} passwordEl The password input.
     */
    AddonModLessonIndexComponent.prototype.submitPassword = function (e, passwordEl) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        var password = passwordEl && passwordEl.value;
        if (!password) {
            this.domUtils.showErrorModal('addon.mod_lesson.emptypassword', true);
            return;
        }
        this.loaded = false;
        this.refreshIcon = 'spinner';
        this.syncIcon = 'spinner';
        this.validatePassword(password).then(function () {
            // Password validated.
            _this.lessonReady(false);
            // Now that we have the password, get the access reason again ignoring the password.
            var preventReason = _this.lessonProvider.getPreventAccessReason(_this.accessInfo, true);
            if (preventReason) {
                _this.preventMessages = [preventReason];
            }
            else {
                _this.preventMessages = [];
            }
            // Log view now that we have the password.
            _this.logView();
        }).catch(function (error) {
            _this.domUtils.showErrorModal(error);
        }).finally(function () {
            _this.loaded = true;
            _this.refreshIcon = 'refresh';
            _this.syncIcon = 'sync';
        });
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonIndexComponent.prototype.sync = function () {
        var _this = this;
        return this.lessonSync.syncLesson(this.lesson.id, true).then(function (result) {
            if (!result.updated && _this.dataSent && _this.isPrefetched()) {
                // The user sent data to server, but not in the sync process. Check if we need to fetch data.
                return _this.lessonSync.prefetchAfterUpdate(_this.module, _this.courseId).catch(function () {
                    // Ignore errors.
                }).then(function () {
                    return result;
                });
            }
            return result;
        });
    };
    /**
     * Validate a password and retrieve extra data.
     *
     * @param {string} password The password to validate.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonIndexComponent.prototype.validatePassword = function (password) {
        var _this = this;
        return this.lessonProvider.getLessonWithPassword(this.lesson.id, password).then(function (lessonData) {
            _this.lesson = lessonData;
            _this.password = password;
        }).catch(function (error) {
            _this.password = '';
            return Promise.reject(error);
        });
    };
    /**
     * Component being destroyed.
     */
    AddonModLessonIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.dataSentObserver && this.dataSentObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_12__components_tabs_tabs__["a" /* CoreTabsComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_12__components_tabs_tabs__["a" /* CoreTabsComponent */])
    ], AddonModLessonIndexComponent.prototype, "tabsComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModLessonIndexComponent.prototype, "group", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModLessonIndexComponent.prototype, "action", void 0);
    AddonModLessonIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-lesson-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\lesson\components\index\addon-mod-lesson-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-tabs [hideUntil]="loaded" [selectedIndex]="selectedTab">\n        <!-- Index/Preview tab. -->\n        <core-tab [title]="\'addon.mod_lesson.preview\' | translate">\n            <ng-template>\n                <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n                <!-- Prevent access messages. Only show the first one. -->\n                <div class="core-info-card" icon-start *ngIf="lesson && preventMessages && preventMessages.length">\n                    <ion-icon name="information-circle"></ion-icon>\n                    <core-format-text [component]="component" [componentId]="componentId" [text]="preventMessages[0].message"></core-format-text>\n                </div>\n\n                <!-- Lesson has data to be synchronized -->\n                <div class="core-warning-card" icon-start *ngIf="hasOffline">\n                    <ion-icon name="warning"></ion-icon>\n                    {{ \'core.hasdatatosync\' | translate: {$a: moduleName} }}\n                </div>\n\n                <!-- Input password for protected lessons. -->\n                <ion-card *ngIf="askPassword">\n                    <form ion-list (ngSubmit)="submitPassword($event, passwordinput)">\n                        <ion-item text-wrap>\n                            <ion-label stacked>{{ \'addon.mod_lesson.enterpassword\' | translate }}</ion-label>\n                            <core-show-password item-content [name]="\'password\'">\n                                <ion-input name="password" type="password" placeholder="{{ \'core.login.password\' | translate }}" [core-auto-focus] #passwordinput [clearOnEdit]="false"></ion-input>\n                            </core-show-password>\n                        </ion-item>\n                        <ion-item>\n                            <button ion-button block type="submit" icon-end>\n                                {{ \'addon.mod_lesson.continue\' | translate }}\n                                <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n                            </button>\n                        </ion-item>\n                    </form>\n                </ion-card>\n\n                <core-loading [hideUntil]="!showSpinner">\n\n                    <ion-list *ngIf="(lesson && (!preventMessages || !preventMessages.length)) || retakeToReview">\n                        <ion-item text-wrap *ngIf="retakeToReview">\n                            <!-- A retake was finished in a synchronization, allow reviewing it. -->\n                            <p padding-bottom>{{ \'addon.mod_lesson.retakefinishedinsync\' | translate }}</p>\n                            <a ion-button block (click)="review()">{{ \'addon.mod_lesson.review\' | translate }}</a>\n                        </ion-item>\n\n                        <ng-container *ngIf="lesson && (!preventMessages || !preventMessages.length)">\n                            <ion-item text-wrap *ngIf="leftDuringTimed && !lesson.timelimit && !finishedOffline">\n                                <!-- User left during the session and there is no time limit, ask to continue. -->\n                                <p [innerHTML]="\'addon.mod_lesson.youhaveseen\' | translate"></p>\n                                <ion-grid>\n                                    <ion-row>\n                                        <ion-col>\n                                            <a ion-button block color="light" (click)="start(false)">{{ \'core.no\' | translate }}</a>\n                                        </ion-col>\n                                        <ion-col>\n                                            <a ion-button block (click)="start(true)">{{ \'core.yes\' | translate }}</a>\n                                        </ion-col>\n                                    </ion-row>\n                                </ion-grid>\n                            </ion-item>\n\n                            <ion-item text-wrap *ngIf="leftDuringTimed && lesson.timelimit && lesson.retake && !finishedOffline">\n                                <!-- User left during the session with time limit and retakes allowed, ask to continue. -->\n                                <p [innerHTML]="\'addon.mod_lesson.leftduringtimed\' | translate"></p>\n                                <a ion-button block icon-end (click)="start(false)">\n                                    {{ \'addon.mod_lesson.continue\' | translate }}\n                                    <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n                                </a>\n                            </ion-item>\n\n                            <ion-item text-wrap *ngIf="leftDuringTimed && lesson.timelimit && !lesson.retake">\n                                <!-- User left during the session with time limit and retakes not allowed. This should be handled by preventMessages -->\n                                <p [innerHTML]="\'addon.mod_lesson.leftduringtimednoretake\' | translate"></p>\n                            </ion-item>\n\n                            <ion-item text-wrap *ngIf="!leftDuringTimed && !finishedOffline">\n                                <!-- User hasn\'t left during the session, show a start button. -->\n                                <a ion-button block *ngIf="!canManage" icon-end (click)="start(false)">\n                                    {{ \'core.start\' | translate }}\n                                    <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n                                </a>\n                                <a ion-button block *ngIf="canManage" icon-end (click)="start(false)">\n                                    {{ \'addon.mod_lesson.preview\' | translate }}\n                                    <ion-icon name="search"></ion-icon>\n                                </a>\n                            </ion-item>\n\n                            <ion-item text-wrap *ngIf="finishedOffline">\n                                <!-- There\'s an attempt finished in offline. Let the user continue, showing the end of lesson. -->\n                                <a ion-button block icon-end (click)="start(true)">\n                                    {{ \'addon.mod_lesson.continue\' | translate }}\n                                    <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n                                </a>\n                            </ion-item>\n                        </ng-container>\n                    </ion-list>\n                </core-loading>\n            </ng-template>\n        </core-tab>\n\n        <!-- Reports tab. -->\n        <core-tab *ngIf="canViewReports" [title]="\'addon.mod_lesson.reports\' | translate" (ionSelect)="reportsSelected()">\n            <ng-template>\n                <core-loading [hideUntil]="reportLoaded">\n                    <!-- Group selector if the activity uses groups. -->\n                    <ion-item text-wrap *ngIf="groupInfo && (groupInfo.separateGroups || groupInfo.visibleGroups)">\n                        <ion-label id="addon-mod_lesson-groupslabel" *ngIf="groupInfo.separateGroups">{{ \'core.groupsseparate\' | translate }}</ion-label>\n                        <ion-label id="addon-mod_lesson-groupslabel" *ngIf="groupInfo.visibleGroups">{{ \'core.groupsvisible\' | translate }}</ion-label>\n                        <ion-select [(ngModel)]="group" (ionChange)="setGroup(group)" aria-labelledby="addon-mod_lesson-groupslabel" interface="action-sheet">\n                            <ion-option *ngFor="let groupOpt of groupInfo.groups" [value]="groupOpt.id">{{groupOpt.name}}</ion-option>\n                        </ion-select>\n                    </ion-item>\n\n                    <!-- No lesson retakes. -->\n                    <core-empty-box *ngIf="!overview && selectedGroupName" icon="stats" [message]="\'addon.mod_lesson.nolessonattemptsgroup\' | translate:{$a: selectedGroupName}">\n                    </core-empty-box>\n                    <core-empty-box *ngIf="!overview && !selectedGroupName" icon="stats" [message]="\'addon.mod_lesson.nolessonattempts\' | translate">\n                    </core-empty-box>\n\n                    <!-- General statistics for the current group. -->\n                    <ion-card class="addon-mod_lesson-lessonstats" *ngIf="overview">\n                        <ion-card-header text-wrap>\n                            {{ \'addon.mod_lesson.lessonstats\' | translate }}\n                        </ion-card-header>\n\n                        <!-- In tablet, max 2 rows with 3 columns. -->\n                        <ion-list class="hidden-phone">\n                            <ion-item text-wrap *ngIf="overview.lessonscored">\n                                <ion-row>\n                                    <ion-col text-center>\n                                        <p class="item-heading">{{ \'addon.mod_lesson.averagescore\' | translate }}</p>\n                                        <p *ngIf="overview.numofattempts > 0">{{ \'core.percentagenumber\' | translate:{$a: overview.avescore} }}</p>\n                                        <p *ngIf="overview.numofattempts <= 0">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n\n                                    <ion-col text-center>\n                                        <p class="item-heading">{{ \'addon.mod_lesson.highscore\' | translate }}</p>\n                                        <p *ngIf="overview.highscore != null">{{ \'core.percentagenumber\' | translate:{$a: overview.highscore} }}</p>\n                                        <p *ngIf="overview.highscore == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n\n                                    <ion-col text-center>\n                                        <p class="item-heading">{{ \'addon.mod_lesson.lowscore\' | translate }}</p>\n                                        <p *ngIf="overview.lowscore != null">{{ \'core.percentagenumber\' | translate:{$a: overview.lowscore} }}</p>\n                                        <p *ngIf="overview.lowscore == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n                                </ion-row>\n                            </ion-item>\n\n                            <ion-item text-wrap>\n                                <ion-row>\n                                    <ion-col text-center>\n                                        <p class="item-heading">{{ \'addon.mod_lesson.averagetime\' | translate }}</p>\n                                        <p *ngIf="overview.avetime != null && overview.numofattempts">{{ overview.avetimeReadable }}</p>\n                                        <p *ngIf="overview.avetime == null || !overview.numofattempts">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n\n                                    <ion-col text-center>\n                                        <p class="item-heading">{{ \'addon.mod_lesson.hightime\' | translate }}</p>\n                                        <p *ngIf="overview.hightime != null">{{ overview.hightimeReadable }}</p>\n                                        <p *ngIf="overview.hightime == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n\n                                    <ion-col text-center>\n                                        <p class="item-heading">{{ \'addon.mod_lesson.lowtime\' | translate }}</p>\n                                        <p *ngIf="overview.lowtime != null">{{ overview.lowtimeReadable }}</p>\n                                        <p *ngIf="overview.lowtime == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n                                </ion-row>\n                            </ion-item>\n                        </ion-list>\n\n                        <!-- In phone, 3 rows with 1 or 2 columns. -->\n                        <ion-list class="hidden-tablet">\n                            <ion-item text-wrap>\n                                <ion-row>\n                                    <ion-col text-center *ngIf="overview.lessonscored">\n                                        <p class="item-heading">{{ \'addon.mod_lesson.averagescore\' | translate }}</p>\n                                        <p *ngIf="overview.numofattempts > 0">{{ \'core.percentagenumber\' | translate:{$a: overview.avescore} }}</p>\n                                        <p *ngIf="overview.numofattempts <= 0">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n\n                                    <ion-col [attr.text-center]="overview.lessonscored ? true : null">\n                                        <p class="item-heading">{{ \'addon.mod_lesson.averagetime\' | translate }}</p>\n                                        <p *ngIf="overview.avetime != null && overview.numofattempts">{{ overview.avetimeReadable }}</p>\n                                        <p *ngIf="overview.avetime == null || !overview.numofattempts">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n                                </ion-row>\n                            </ion-item>\n\n                            <ion-item text-wrap>\n                                <ion-row>\n                                    <ion-col text-center *ngIf="overview.lessonscored">\n                                        <p class="item-heading">{{ \'addon.mod_lesson.highscore\' | translate }}</p>\n                                        <p *ngIf="overview.highscore != null">{{ \'core.percentagenumber\' | translate:{$a: overview.highscore} }}</p>\n                                        <p *ngIf="overview.highscore == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n\n                                    <ion-col [attr.text-center]="overview.lessonscored ? true : null">\n                                        <p class="item-heading">{{ \'addon.mod_lesson.hightime\' | translate }}</p>\n                                        <p *ngIf="overview.hightime != null">{{ overview.hightimeReadable }}</p>\n                                        <p *ngIf="overview.hightime == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n                                </ion-row>\n                            </ion-item>\n\n                            <ion-item text-wrap>\n                                <ion-row>\n                                    <ion-col text-center *ngIf="overview.lessonscored">\n                                        <p class="item-heading">{{ \'addon.mod_lesson.lowscore\' | translate }}</p>\n                                        <p *ngIf="overview.lowscore != null">{{ \'core.percentagenumber\' | translate:{$a: overview.lowscore} }}</p>\n                                        <p *ngIf="overview.lowscore == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n\n                                    <ion-col [attr.text-center]="overview.lessonscored ? true : null">\n                                        <p class="item-heading">{{ \'addon.mod_lesson.lowtime\' | translate }}</p>\n                                        <p *ngIf="overview.lowtime != null">{{ overview.lowtimeReadable }}</p>\n                                        <p *ngIf="overview.lowtime == null">{{ \'addon.mod_lesson.notcompleted\' | translate }}</p>\n                                    </ion-col>\n                                </ion-row>\n                            </ion-item>\n                        </ion-list>\n                    </ion-card>\n\n                    <!-- List of students that have retakes. -->\n                    <ion-card *ngIf="overview">\n                        <ion-card-header text-wrap>\n                            {{ \'addon.mod_lesson.overview\' | translate }}\n                        </ion-card-header>\n\n                        <a ion-item text-wrap *ngFor="let student of overview.students" [navPush]="\'AddonModLessonUserRetakePage\'" [navParams]="{courseId: courseId, lessonId: lesson.id, userId: student.id}">\n                            <ion-avatar core-user-avatar [user]="student" item-start [userId]="student.id" [courseId]="courseId"></ion-avatar>\n                            <h2>{{ student.fullname }}</h2>\n                            <core-progress-bar [progress]="student.bestgrade"></core-progress-bar>\n                        </a>\n                    </ion-card>\n                </core-loading>\n            </ng-template>\n        </core-tab>\n    </core-tabs>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\lesson\components\index\addon-mod-lesson-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_7__providers_lesson__["a" /* AddonModLessonProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_lesson_offline__["a" /* AddonModLessonOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_lesson_sync__["a" /* AddonModLessonSyncProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__["a" /* AddonModLessonPrefetchHandler */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__["a" /* CoreUserProvider */]])
    ], AddonModLessonIndexComponent);
    return AddonModLessonIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_5__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 438 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLtiIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_lti__ = __webpack_require__(373);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};




/**
 * Component that displays an LTI entry page.
 */
var AddonModLtiIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModLtiIndexComponent, _super);
    function AddonModLtiIndexComponent(injector, content, ltiProvider) {
        var _this = _super.call(this, injector, content) || this;
        _this.content = content;
        _this.ltiProvider = ltiProvider;
        _this.component = __WEBPACK_IMPORTED_MODULE_3__providers_lti__["a" /* AddonModLtiProvider */].COMPONENT;
        _this.moduleName = 'lti';
        _this.fetchContentDefaultError = 'addon.mod_lti.errorgetlti';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModLtiIndexComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.loadContent();
    };
    /**
     * Check the completion.
     */
    AddonModLtiIndexComponent.prototype.checkCompletion = function () {
        this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
    };
    /**
     * Get the LTI data.
     *
     * @param {boolean} [refresh=false] If it's refreshing content.
     * @param {boolean} [sync=false] If it should try to sync.
     * @param {boolean} [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLtiIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        return this.ltiProvider.getLti(this.courseId, this.module.id).then(function (ltiData) {
            _this.lti = ltiData;
            _this.description = _this.lti.intro || _this.description;
            _this.dataRetrieved.emit(_this.lti);
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModLtiIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.ltiProvider.invalidateLti(this.courseId));
        if (this.lti) {
            promises.push(this.ltiProvider.invalidateLtiLaunchData(this.lti.id));
        }
        return Promise.all(promises);
    };
    /**
     * Launch the LTI.
     */
    AddonModLtiIndexComponent.prototype.launch = function () {
        var _this = this;
        this.ltiProvider.getLtiLaunchData(this.lti.id).then(function (launchData) {
            // "View" LTI.
            _this.ltiProvider.logView(_this.lti.id, _this.lti.name).then(function () {
                _this.checkCompletion();
            }).catch(function (error) {
                // Ignore errors.
            });
            // Launch LTI.
            return _this.ltiProvider.launch(launchData.endpoint, launchData.parameters);
        }).catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'core.error', true);
        });
    };
    AddonModLtiIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-lti-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\lti\components\index\addon-mod-lti-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <div padding-horizontal>\n        <button ion-button block icon-left (click)="launch()">\n            <ion-icon name="link"></ion-icon>\n            {{ \'addon.mod_lti.launchactivity\' | translate }}\n        </button>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\lti\components\index\addon-mod-lti-index.html"*/,
        }),
        __param(1, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_3__providers_lti__["a" /* AddonModLtiProvider */]])
    ], AddonModLtiIndexComponent);
    return AddonModLtiIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 439 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPageIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__ = __webpack_require__(164);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_page__ = __webpack_require__(172);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(374);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_prefetch_handler__ = __webpack_require__(859);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Component that displays a page.
 */
var AddonModPageIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModPageIndexComponent, _super);
    function AddonModPageIndexComponent(injector, pageProvider, courseProvider, appProvider, pageHelper, pagePrefetch, utils) {
        var _this = _super.call(this, injector) || this;
        _this.pageProvider = pageProvider;
        _this.courseProvider = courseProvider;
        _this.appProvider = appProvider;
        _this.pageHelper = pageHelper;
        _this.pagePrefetch = pagePrefetch;
        _this.utils = utils;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_page__["a" /* AddonModPageProvider */].COMPONENT;
        _this.displayDescription = true;
        _this.displayTimemodified = true;
        _this.fetchContentDefaultError = 'addon.mod_page.errorwhileloadingthepage';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModPageIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.canGetPage = this.pageProvider.isGetPageWSAvailable();
        this.loadContent().then(function () {
            _this.pageProvider.logView(_this.module.instance, _this.module.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModPageIndexComponent.prototype.invalidateContent = function () {
        return this.pageProvider.invalidateContent(this.module.id, this.courseId);
    };
    /**
     * Download page contents.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModPageIndexComponent.prototype.fetchContent = function (refresh) {
        var _this = this;
        var downloadFailed = false;
        // Download content. This function also loads module contents if needed.
        return this.pagePrefetch.download(this.module, this.courseId).catch(function () {
            // Mark download as failed but go on since the main files could have been downloaded.
            downloadFailed = true;
        }).then(function () {
            if (!_this.module.contents.length) {
                // Try to load module contents for offline usage.
                return _this.courseProvider.loadModuleContents(_this.module, _this.courseId);
            }
        }).then(function () {
            var promises = [];
            var getPagePromise;
            // Get the module to get the latest title and description. Data should've been updated in download.
            if (_this.canGetPage) {
                getPagePromise = _this.pageProvider.getPageData(_this.courseId, _this.module.id);
            }
            else {
                getPagePromise = _this.courseProvider.getModule(_this.module.id, _this.courseId);
            }
            promises.push(getPagePromise.then(function (page) {
                if (page) {
                    _this.description = page.intro || page.description;
                    _this.dataRetrieved.emit(page);
                    if (_this.canGetPage) {
                        _this.page = page;
                        // Check if description and timemodified should be displayed.
                        if (page.displayoptions) {
                            var options = _this.textUtils.unserialize(page.displayoptions) || {};
                            _this.displayDescription = typeof options.printintro == 'undefined' ||
                                _this.utils.isTrueOrOne(options.printintro);
                            _this.displayTimemodified = typeof options.printlastmodified == 'undefined' ||
                                _this.utils.isTrueOrOne(options.printlastmodified);
                        }
                        else {
                            _this.displayDescription = true;
                            _this.displayTimemodified = true;
                        }
                    }
                }
            }).catch(function () {
                // Ignore errors.
            }));
            // Get the page HTML.
            promises.push(_this.pageHelper.getPageHtml(_this.module.contents, _this.module.id).then(function (content) {
                // All data obtained, now fill the context menu.
                _this.fillContextMenu(refresh);
                _this.contents = content;
                if (downloadFailed && _this.appProvider.isOnline()) {
                    // We could load the main file but the download failed. Show error message.
                    _this.domUtils.showErrorModal('core.errordownloadingsomefiles', true);
                }
            }));
            return Promise.all(promises);
        });
    };
    AddonModPageIndexComponent.prototype.OnClick1 = function ($event) {
        if ($event.target.tagName.toLowerCase() === 'a') {
            var browser = window.cordova.InAppBrowser.open($event.target.href, '_blank', 'location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
            event.preventDefault();
            console.log("点击了A标签");
            return false;
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["HostListener"])('click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], AddonModPageIndexComponent.prototype, "OnClick1", null);
    AddonModPageIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-page-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\page\components\index\addon-mod-page-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="600" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="500" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description *ngIf="displayDescription" [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <div padding>\n        <core-format-text [component]="component" [componentId]="componentId" [text]="contents" class="ArticleContent"></core-format-text>\n        <p padding-bottom class="addon-mod_page-timemodified" *ngIf="displayTimemodified && page && page.timemodified">\n            {{ \'core.lastmodified\' | translate}}: {{ page.timemodified * 1000 | coreFormatDate }}\n        </p>\n    </div>\n\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\page\components\index\addon-mod-page-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_page__["a" /* AddonModPageProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModPageHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_prefetch_handler__["a" /* AddonModPagePrefetchHandler */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModPageIndexComponent);
    return AddonModPageIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__["a" /* CoreCourseModuleMainResourceComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 440 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_quiz__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_helper__ = __webpack_require__(185);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_quiz_offline__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_quiz_sync__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_prefetch_handler__ = __webpack_require__(375);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};










/**
 * Component that displays a quiz entry page.
 */
var AddonModQuizIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModQuizIndexComponent, _super);
    function AddonModQuizIndexComponent(injector, quizProvider, content, quizHelper, quizOffline, quizSync, behaviourDelegate, prefetchHandler, navCtrl) {
        var _this = _super.call(this, injector, content) || this;
        _this.quizProvider = quizProvider;
        _this.quizHelper = quizHelper;
        _this.quizOffline = quizOffline;
        _this.quizSync = quizSync;
        _this.behaviourDelegate = behaviourDelegate;
        _this.prefetchHandler = prefetchHandler;
        _this.navCtrl = navCtrl;
        _this.component = __WEBPACK_IMPORTED_MODULE_4__providers_quiz__["a" /* AddonModQuizProvider */].COMPONENT;
        _this.moduleName = 'quiz';
        _this.showStatusSpinner = true; // Whether to show a spinner due to quiz status.
        _this.fetchContentDefaultError = 'addon.mod_quiz.errorgetquiz'; // Default error to show when loading contents.
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_7__providers_quiz_sync__["a" /* AddonModQuizSyncProvider */].AUTO_SYNCED;
        _this.hasPlayed = false; // Whether the user has gone to the quiz player (attempted).
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModQuizIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.loadContent(false, true).then(function () {
            if (!_this.quizData) {
                return;
            }
            _this.quizProvider.logViewQuiz(_this.quizData.id, _this.quizData.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function (error) {
                // Ignore errors.
            });
        });
        // Listen for attempt finished events.
        this.finishedObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__providers_quiz__["a" /* AddonModQuizProvider */].ATTEMPT_FINISHED_EVENT, function (data) {
            // Go to review attempt if an attempt in this quiz was finished and synced.
            if (_this.quizData && data.quizId == _this.quizData.id) {
                _this.autoReview = data;
            }
        }, this.siteId);
    };
    /**
     * Attempt the quiz.
     */
    AddonModQuizIndexComponent.prototype.attemptQuiz = function () {
        var _this = this;
        if (this.showStatusSpinner) {
            // Quiz is being downloaded or synchronized, abort.
            return;
        }
        if (this.quizProvider.isQuizOffline(this.quizData)) {
            // Quiz supports offline, check if it needs to be downloaded.
            // If the site doesn't support check updates, always prefetch it because we cannot tell if there's something new.
            var isDownloaded_1 = this.currentStatus == __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].DOWNLOADED;
            if (!isDownloaded_1 || !this.modulePrefetchDelegate.canCheckUpdates()) {
                // Prefetch the quiz.
                this.showStatusSpinner = true;
                this.prefetchHandler.prefetch(this.module, this.courseId, true).then(function () {
                    // Success downloading, open quiz.
                    _this.openQuiz();
                }).catch(function (error) {
                    if (_this.hasOffline || (isDownloaded_1 && !_this.modulePrefetchDelegate.canCheckUpdates())) {
                        // Error downloading but there is something offline, allow continuing it.
                        // If the site doesn't support check updates, continue too because we cannot tell if there's something new.
                        _this.openQuiz();
                    }
                    else {
                        _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
                    }
                }).finally(function () {
                    _this.showStatusSpinner = false;
                });
            }
            else {
                // Already downloaded, open it.
                this.openQuiz();
            }
        }
        else {
            // Quiz isn't offline, just open it.
            this.openQuiz();
        }
    };
    /**
     * Get the quiz data.
     *
     * @param {boolean} [refresh=false] If it's refreshing content.
     * @param {boolean} [sync=false] If it should try to sync.
     * @param {boolean} [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        // First get the quiz instance.
        return this.quizProvider.getQuiz(this.courseId, this.module.id).then(function (quizData) {
            _this.quizData = quizData;
            _this.quizData.gradeMethodReadable = _this.quizProvider.getQuizGradeMethod(_this.quizData.grademethod);
            _this.now = new Date().getTime();
            _this.dataRetrieved.emit(_this.quizData);
            _this.description = _this.quizData.intro || _this.description;
            // Try to get warnings from automatic sync.
            return _this.quizSync.getSyncWarnings(_this.quizData.id).then(function (warnings) {
                if (warnings && warnings.length) {
                    // Show warnings and delete them so they aren't shown again.
                    _this.domUtils.showErrorModal(_this.textUtils.buildMessage(warnings));
                    return _this.quizSync.setSyncWarnings(_this.quizData.id, []);
                }
            });
        }).then(function () {
            if (_this.quizProvider.isQuizOffline(_this.quizData)) {
                // Try to sync the quiz.
                return _this.syncActivity(showErrors).catch(function () {
                    // Ignore errors, keep getting data even if sync fails.
                    _this.autoReview = undefined;
                });
            }
            else {
                _this.autoReview = undefined;
                _this.showStatusSpinner = false;
            }
        }).then(function () {
            if (_this.quizProvider.isQuizOffline(_this.quizData)) {
                // Handle status.
                _this.setStatusListener();
                // Get last synchronization time and check if sync button should be seen.
                // No need to return these promises, they should be faster than the rest.
                _this.quizSync.getReadableSyncTime(_this.quizData.id).then(function (syncTime) {
                    _this.syncTime = syncTime;
                });
                _this.quizSync.hasDataToSync(_this.quizData.id).then(function (hasOffline) {
                    _this.hasOffline = hasOffline;
                });
            }
            // Get quiz access info.
            return _this.quizProvider.getQuizAccessInformation(_this.quizData.id).then(function (info) {
                _this.quizAccessInfo = info;
                _this.quizData.showReviewColumn = info.canreviewmyattempts;
                _this.accessRules = info.accessrules;
                _this.unsupportedRules = _this.quizProvider.getUnsupportedRules(info.activerulenames);
                if (_this.quizData.preferredbehaviour) {
                    _this.behaviourSupported = _this.behaviourDelegate.isBehaviourSupported(_this.quizData.preferredbehaviour);
                }
                // Get question types in the quiz.
                return _this.quizProvider.getQuizRequiredQtypes(_this.quizData.id).then(function (types) {
                    _this.unsupportedQuestions = _this.quizProvider.getUnsupportedQuestions(types);
                    return _this.getAttempts();
                });
            });
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
            // Quiz is ready to be shown, move it to the variable that is displayed.
            _this.quiz = _this.quizData;
        });
    };
    /**
     * Get the user attempts in the quiz and the result info.
     *
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModQuizIndexComponent.prototype.getAttempts = function () {
        var _this = this;
        // Get access information of last attempt (it also works if no attempts made).
        return this.quizProvider.getAttemptAccessInformation(this.quizData.id, 0).then(function (info) {
            _this.attemptAccessInfo = info;
            // Get attempts.
            return _this.quizProvider.getUserAttempts(_this.quizData.id).then(function (atts) {
                return _this.treatAttempts(atts).then(function (atts) {
                    _this.attempts = atts;
                    // Check if user can create/continue attempts.
                    if (_this.attempts.length) {
                        var last = _this.attempts[_this.attempts.length - 1];
                        _this.moreAttempts = !_this.quizProvider.isAttemptFinished(last.state) || !_this.attemptAccessInfo.isfinished;
                    }
                    else {
                        _this.moreAttempts = !_this.attemptAccessInfo.isfinished;
                    }
                    _this.getButtonText();
                    return _this.getResultInfo();
                });
            });
        });
    };
    /**
     * Get the text to show in the button. It also sets restriction messages if needed.
     */
    AddonModQuizIndexComponent.prototype.getButtonText = function () {
        this.buttonText = '';
        if (this.quizData.hasquestions !== 0) {
            if (this.attempts.length && !this.quizProvider.isAttemptFinished(this.attempts[this.attempts.length - 1].state)) {
                // Last attempt is unfinished.
                if (this.quizAccessInfo.canattempt) {
                    this.buttonText = 'addon.mod_quiz.continueattemptquiz';
                }
                else if (this.quizAccessInfo.canpreview) {
                    this.buttonText = 'addon.mod_quiz.continuepreview';
                }
            }
            else {
                // Last attempt is finished or no attempts.
                if (this.quizAccessInfo.canattempt) {
                    this.preventMessages = this.attemptAccessInfo.preventnewattemptreasons;
                    if (!this.preventMessages.length) {
                        if (!this.attempts.length) {
                            this.buttonText = 'addon.mod_quiz.attemptquiznow';
                        }
                        else {
                            this.buttonText = 'addon.mod_quiz.reattemptquiz';
                        }
                    }
                }
                else if (this.quizAccessInfo.canpreview) {
                    this.buttonText = 'addon.mod_quiz.previewquiznow';
                }
            }
        }
        if (this.buttonText) {
            // So far we think a button should be printed, check if they will be allowed to access it.
            this.preventMessages = this.quizAccessInfo.preventaccessreasons;
            if (!this.moreAttempts) {
                this.buttonText = '';
            }
            else if (this.quizAccessInfo.canattempt && this.preventMessages.length) {
                this.buttonText = '';
            }
            else if (this.unsupportedQuestions.length || this.unsupportedRules.length || !this.behaviourSupported) {
                this.buttonText = '';
            }
        }
    };
    /**
     * Get result info to show.
     *
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModQuizIndexComponent.prototype.getResultInfo = function () {
        var _this = this;
        if (this.attempts.length && this.quizData.showGradeColumn && this.bestGrade.hasgrade &&
            typeof this.gradebookData.grade != 'undefined') {
            var formattedGradebookGrade = this.quizProvider.formatGrade(this.gradebookData.grade, this.quizData.decimalpoints), formattedBestGrade = this.quizProvider.formatGrade(this.bestGrade.grade, this.quizData.decimalpoints);
            var gradeToShow = formattedGradebookGrade; // By default we show the grade in the gradebook.
            this.showResults = true;
            this.gradeOverridden = formattedGradebookGrade != formattedBestGrade;
            this.gradebookFeedback = this.gradebookData.feedback;
            if (this.bestGrade.grade > this.gradebookData.grade && this.gradebookData.grade == this.quizData.grade) {
                // The best grade is higher than the max grade for the quiz.
                // We'll do like Moodle web and show the best grade instead of the gradebook grade.
                this.gradeOverridden = false;
                gradeToShow = formattedBestGrade;
            }
            if (this.overallStats) {
                // Show the quiz grade. The message shown is different if the quiz is finished.
                if (this.moreAttempts) {
                    this.gradeResult = this.translate.instant('addon.mod_quiz.gradesofar', { $a: {
                            method: this.quizData.gradeMethodReadable,
                            mygrade: gradeToShow,
                            quizgrade: this.quizData.gradeFormatted
                        } });
                }
                else {
                    var outOfShort = this.translate.instant('addon.mod_quiz.outofshort', { $a: {
                            grade: gradeToShow,
                            maxgrade: this.quizData.gradeFormatted
                        } });
                    this.gradeResult = this.translate.instant('addon.mod_quiz.yourfinalgradeis', { $a: outOfShort });
                }
            }
            if (this.quizData.showFeedbackColumn) {
                // Get the quiz overall feedback.
                return this.quizProvider.getFeedbackForGrade(this.quizData.id, this.gradebookData.grade).then(function (response) {
                    _this.overallFeedback = response.feedbacktext;
                });
            }
        }
        else {
            this.showResults = false;
        }
        return Promise.resolve();
    };
    /**
     * Go to review an attempt that has just been finished.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizIndexComponent.prototype.goToAutoReview = function () {
        var _this = this;
        // If we go to auto review it means an attempt was finished. Check completion status.
        this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
        // Verify that user can see the review.
        var attemptId = this.autoReview.attemptId;
        if (this.quizAccessInfo.canreviewmyattempts) {
            return this.quizProvider.getAttemptReview(attemptId, -1).then(function () {
                _this.navCtrl.push('AddonModQuizReviewPage', { courseId: _this.courseId, quizId: _this.quizData.id, attemptId: attemptId });
            }).catch(function () {
                // Ignore errors.
            });
        }
        return Promise.resolve();
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param {any} result Data returned on the sync function.
     * @return {boolean} If suceed or not.
     */
    AddonModQuizIndexComponent.prototype.hasSyncSucceed = function (result) {
        if (result.attemptFinished) {
            // An attempt was finished, check completion status.
            this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
        }
        // If the sync call isn't rejected it means the sync was successful.
        return result.answersSent;
    };
    /**
     * User entered the page that contains the component.
     */
    AddonModQuizIndexComponent.prototype.ionViewDidEnter = function () {
        var _this = this;
        _super.prototype.ionViewDidEnter.call(this);
        if (this.hasPlayed) {
            this.hasPlayed = false;
            // Update data when we come back from the player since the attempt status could have changed.
            var promise = void 0;
            // Check if we need to go to review an attempt automatically.
            if (this.autoReview && this.autoReview.synced) {
                promise = this.goToAutoReview();
                this.autoReview = undefined;
            }
            else {
                promise = Promise.resolve();
            }
            // Refresh data.
            this.loaded = false;
            this.refreshIcon = 'spinner';
            this.syncIcon = 'spinner';
            this.domUtils.scrollToTop(this.content);
            promise.then(function () {
                _this.refreshContent().finally(function () {
                    _this.loaded = true;
                    _this.refreshIcon = 'refresh';
                    _this.syncIcon = 'sync';
                });
            });
        }
        else {
            this.autoReview = undefined;
        }
    };
    /**
     * User left the page that contains the component.
     */
    AddonModQuizIndexComponent.prototype.ionViewDidLeave = function () {
        _super.prototype.ionViewDidLeave.call(this);
        this.autoReview = undefined;
        if (this.navCtrl.getActive().component.name == 'AddonModQuizPlayerPage') {
            this.hasPlayed = true;
        }
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModQuizIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.quizProvider.invalidateQuizData(this.courseId));
        if (this.quizData) {
            promises.push(this.quizProvider.invalidateUserAttemptsForUser(this.quizData.id));
            promises.push(this.quizProvider.invalidateQuizAccessInformation(this.quizData.id));
            promises.push(this.quizProvider.invalidateQuizRequiredQtypes(this.quizData.id));
            promises.push(this.quizProvider.invalidateAttemptAccessInformation(this.quizData.id));
            promises.push(this.quizProvider.invalidateCombinedReviewOptionsForUser(this.quizData.id));
            promises.push(this.quizProvider.invalidateUserBestGradeForUser(this.quizData.id));
            promises.push(this.quizProvider.invalidateGradeFromGradebook(this.courseId));
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean} True if refresh is needed, false otherwise.
     */
    AddonModQuizIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (syncEventData.attemptFinished) {
            // An attempt was finished, check completion status.
            this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
        }
        if (this.quizData && syncEventData.quizId == this.quizData.id) {
            this.domUtils.scrollToTop(this.content);
            return true;
        }
        return false;
    };
    /**
     * Open a quiz to attempt it.
     */
    AddonModQuizIndexComponent.prototype.openQuiz = function () {
        this.navCtrl.push('AddonModQuizPlayerPage', { courseId: this.courseId, quizId: this.quiz.id, moduleUrl: this.module.url });
    };
    /**
     * Displays some data based on the current status.
     *
     * @param {string} status The current status.
     * @param {string} [previousStatus] The previous status. If not defined, there is no previous status.
     */
    AddonModQuizIndexComponent.prototype.showStatus = function (status, previousStatus) {
        this.showStatusSpinner = status == __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].DOWNLOADING;
        if (status == __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].DOWNLOADED && previousStatus == __WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
            // Quiz downloaded now, maybe a new attempt was created. Load content again.
            this.loaded = false;
            this.loadContent();
        }
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizIndexComponent.prototype.sync = function () {
        return this.quizSync.syncQuiz(this.quizData, true);
    };
    /**
     * Treat user attempts.
     *
     * @param {any} attempts The attempts to treat.
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModQuizIndexComponent.prototype.treatAttempts = function (attempts) {
        var _this = this;
        if (!attempts || !attempts.length) {
            // There are no attempts to treat.
            return Promise.resolve(attempts);
        }
        var lastFinished = this.quizProvider.getLastFinishedAttemptFromList(attempts), promises = [];
        if (this.autoReview && lastFinished && lastFinished.id >= this.autoReview.attemptId) {
            // User just finished an attempt in offline and it seems it's been synced, since it's finished in online.
            // Go to the review of this attempt if the user hasn't left this view.
            if (!this.isDestroyed && this.isCurrentView) {
                promises.push(this.goToAutoReview());
            }
            this.autoReview = undefined;
        }
        // Load flag to show if attempts are finished but not synced.
        promises.push(this.quizProvider.loadFinishedOfflineData(attempts));
        // Get combined review options.
        promises.push(this.quizProvider.getCombinedReviewOptions(this.quizData.id).then(function (result) {
            _this.options = result;
        }));
        // Get best grade.
        promises.push(this.quizProvider.getUserBestGrade(this.quizData.id).then(function (best) {
            _this.bestGrade = best;
            // Get gradebook grade.
            return _this.quizProvider.getGradeFromGradebook(_this.courseId, _this.module.id).then(function (data) {
                _this.gradebookData = {
                    grade: data.graderaw,
                    feedback: data.feedback
                };
            }).catch(function () {
                // Fallback to quiz best grade if failure or not found.
                _this.gradebookData = {
                    grade: _this.bestGrade.grade
                };
            });
        }));
        return Promise.all(promises).then(function () {
            var grade = typeof _this.gradebookData.grade != 'undefined' ? _this.gradebookData.grade : _this.bestGrade.grade, quizGrade = _this.quizProvider.formatGrade(grade, _this.quizData.decimalpoints);
            // Calculate data to construct the header of the attempts table.
            _this.quizHelper.setQuizCalculatedData(_this.quizData, _this.options);
            _this.overallStats = lastFinished && _this.options.alloptions.marks >= __WEBPACK_IMPORTED_MODULE_4__providers_quiz__["a" /* AddonModQuizProvider */].QUESTION_OPTIONS_MARK_AND_MAX;
            // Calculate data to show for each attempt.
            attempts.forEach(function (attempt) {
                // Highlight the highest grade if appropriate.
                var shouldHighlight = _this.overallStats && _this.quizData.grademethod == __WEBPACK_IMPORTED_MODULE_4__providers_quiz__["a" /* AddonModQuizProvider */].GRADEHIGHEST &&
                    attempts.length > 1;
                _this.quizHelper.setAttemptCalculatedData(_this.quizData, attempt, shouldHighlight, quizGrade);
            });
            return attempts;
        });
    };
    /**
     * Component being destroyed.
     */
    AddonModQuizIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.finishedObserver && this.finishedObserver.off();
    };
    AddonModQuizIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-quiz-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\components\index\addon-mod-quiz-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <!-- Access rules description messages. -->\n    <ion-card *ngIf="(quiz && quiz.gradeMethodReadable) || (accessRules && accessRules.length) || syncTime">\n        <ion-list>\n            <ion-item text-wrap *ngFor="let rule of accessRules">\n                <p>{{ rule }}</p>\n            </ion-item>\n            <ion-item text-wrap *ngIf="quiz && quiz.gradeMethodReadable">\n                <h2>{{ \'addon.mod_quiz.grademethod\' | translate }}</h2>\n                <p>{{ quiz.gradeMethodReadable }}</p>\n            </ion-item>\n            <ion-item text-wrap *ngIf="syncTime">\n                <h2>{{ \'core.lastsync\' | translate }}</h2>\n                <p>{{ syncTime }}</p>\n            </ion-item>\n        </ion-list>\n    </ion-card>\n\n    <!-- List of user attempts. -->\n    <ion-card class="addon-mod_quiz-table" *ngIf="quiz && attempts && attempts.length">\n        <ion-card-header text-wrap>\n            <h2>{{ \'addon.mod_quiz.summaryofattempts\' | translate }}</h2>\n        </ion-card-header>\n        <ion-list>\n            <!-- "Header" of the table -->\n            <ion-item text-wrap class="addon-mod_quiz-table-header" detail-push>\n                <ion-row align-items-center>\n                    <ion-col text-center class="hidden-phone" *ngIf="quiz.showAttemptColumn"><b>{{ \'addon.mod_quiz.attemptnumber\' | translate }}</b></ion-col>\n                    <ion-col text-center class="hidden-tablet" *ngIf="quiz.showAttemptColumn"><b>#</b></ion-col>\n                    <ion-col col-7><b>{{ \'addon.mod_quiz.attemptstate\' | translate }}</b></ion-col>\n                    <ion-col text-center class="hidden-phone" *ngIf="quiz.showMarkColumn"><b>{{ \'addon.mod_quiz.marks\' | translate }} / {{ quiz.sumGradesFormatted }}</b></ion-col>\n                    <ion-col text-center *ngIf="quiz.showGradeColumn"><b>{{ \'addon.mod_quiz.grade\' | translate }} / {{ quiz.gradeFormatted }}</b></ion-col>\n                </ion-row>\n            </ion-item>\n            <!-- List of attempts. -->\n            <a ion-item text-wrap *ngFor="let attempt of attempts" [ngClass]=\'{"addon-mod_quiz-highlighted core-white-push-arrow": attempt.highlightGrade}\' [navPush]="\'AddonModQuizAttemptPage\'" [navParams]="{courseId: courseId, quizId: quiz.id, attemptId: attempt.id}" [attr.aria-label]="\'core.seemoredetail\' | translate">\n                <ion-row align-items-center>\n                    <ion-col text-center *ngIf="quiz.showAttemptColumn && attempt.preview">{{ \'addon.mod_quiz.preview\' | translate }}</ion-col>\n                    <ion-col text-center *ngIf="quiz.showAttemptColumn && !attempt.preview">{{ attempt.attempt }}</ion-col>\n                    <ion-col col-7>\n                        <p *ngFor="let sentence of attempt.readableState">{{ sentence }}</p>\n                    </ion-col>\n                    <ion-col text-center class="hidden-phone" *ngIf="quiz.showMarkColumn"><p>{{ attempt.readableMark }}</p></ion-col>\n                    <ion-col text-center *ngIf="quiz.showGradeColumn"><p>{{ attempt.readableGrade }}</p></ion-col>\n                </ion-row>\n            </a>\n        </ion-list>\n    </ion-card>\n\n    <!-- Result info. -->\n    <ion-card *ngIf="quiz && showResults && (gradeResult || gradeOverridden || gradebookFeedback || (quiz.showFeedbackColumn && overallFeedback))">\n        <ion-list>\n            <ion-item text-wrap *ngIf="gradeResult">{{ gradeResult }}</ion-item>\n            <ion-item text-wrap *ngIf="gradeOverridden">{{ \'core.course.overriddennotice\' | translate }}</ion-item>\n            <ion-item text-wrap *ngIf="gradebookFeedback">\n                <p class="item-heading">{{ \'addon.mod_quiz.comment\' | translate }}</p>\n                <p><core-format-text [component]="component" [componentId]="componentId" [text]="gradebookFeedback"></core-format-text></p>\n            </ion-item>\n            <ion-item text-wrap *ngIf="quiz.showFeedbackColumn && overallFeedback">\n                <p class="item-heading">{{ \'addon.mod_quiz.overallfeedback\' | translate }}</p>\n                <p><core-format-text [component]="component" [componentId]="componentId" [text]="overallFeedback"></core-format-text></p>\n            </ion-item>\n        </ion-list>\n    </ion-card>\n\n    <!-- More data and button to start/continue. -->\n    <ion-card *ngIf="quiz">\n        <ion-list>\n            <!-- Error messages. -->\n            <ion-item text-wrap class="core-danger-item" *ngFor="let message of preventMessages">\n                <p>{{ message }}</p>\n            </ion-item>\n            <ion-item text-wrap class="core-danger-item" *ngIf="quiz.hasquestions === 0">\n                <p>{{ \'addon.mod_quiz.noquestions\' | translate }}</p>\n            </ion-item>\n            <ion-item text-wrap class="core-danger-item" *ngIf="unsupportedQuestions && unsupportedQuestions.length">\n                <p>{{ \'addon.mod_quiz.errorquestionsnotsupported\' | translate }}</p>\n                <p *ngFor="let type of unsupportedQuestions">{{ type }}</p>\n            </ion-item>\n            <ion-item text-wrap class="core-danger-item" *ngIf="unsupportedRules && unsupportedRules.length">\n                <p>{{ \'addon.mod_quiz.errorrulesnotsupported\' | translate }}</p>\n                <p *ngFor="let name of unsupportedRules">{{ name }}</p>\n            </ion-item>\n            <ion-item text-wrap class="core-danger-item" *ngIf="behaviourSupported === false">\n                <p>{{ \'addon.mod_quiz.errorbehaviournotsupported\' | translate }}</p>\n                <p>{{ quiz.preferredbehaviour }}</p>\n            </ion-item>\n\n            <!-- Synchronization warning. -->\n            <div class="core-warning-card" icon-start *ngIf="buttonText && hasOffline && !showStatusSpinner">\n                <ion-icon name="warning"></ion-icon>\n                {{ \'core.hasdatatosync\' | translate: {$a: moduleName} }}\n            </div>\n\n            <!-- Button to start/continue. -->\n            <ion-item *ngIf="buttonText && !showStatusSpinner">\n                <button ion-button block (click)="attemptQuiz()">\n                    {{ buttonText | translate }}\n                </button>\n            </ion-item>\n\n            <!-- Button to open in browser if it cannot be attempted in the app. -->\n            <ion-item *ngIf="!buttonText && ((unsupportedQuestions && unsupportedQuestions.length) || (unsupportedRules && unsupportedRules.length) || behaviourSupported === false)">\n                <a ion-button block [href]="externalUrl" core-link icon-end>\n                    {{ \'core.openinbrowser\' | translate }}\n                    <ion-icon name="open"></ion-icon>\n                </a>\n            </ion-item>\n\n            <!-- Spinner shown while downloading or calculating. -->\n            <ion-item text-center *ngIf="showStatusSpinner">\n                <ion-spinner></ion-spinner>\n            </ion-item>\n        </ion-list>\n    </ion-card>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\components\index\addon-mod-quiz-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__providers_quiz__["a" /* AddonModQuizProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* AddonModQuizHelperProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_quiz_offline__["a" /* AddonModQuizOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_quiz_sync__["a" /* AddonModQuizSyncProvider */], __WEBPACK_IMPORTED_MODULE_3__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */],
            __WEBPACK_IMPORTED_MODULE_8__providers_prefetch_handler__["a" /* AddonModQuizPrefetchHandler */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], AddonModQuizIndexComponent);
    return AddonModQuizIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 441 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourceIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_classes_main_resource_component__ = __webpack_require__(164);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_resource__ = __webpack_require__(181);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_prefetch_handler__ = __webpack_require__(865);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_helper__ = __webpack_require__(269);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Component that displays a resource.
 */
var AddonModResourceIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModResourceIndexComponent, _super);
    function AddonModResourceIndexComponent(injector, resourceProvider, courseProvider, appProvider, prefetchHandler, resourceHelper, sitesProvider, utils) {
        var _this = _super.call(this, injector) || this;
        _this.resourceProvider = resourceProvider;
        _this.courseProvider = courseProvider;
        _this.appProvider = appProvider;
        _this.prefetchHandler = prefetchHandler;
        _this.resourceHelper = resourceHelper;
        _this.sitesProvider = sitesProvider;
        _this.utils = utils;
        _this.component = __WEBPACK_IMPORTED_MODULE_6__providers_resource__["a" /* AddonModResourceProvider */].COMPONENT;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModResourceIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.canGetResource = this.resourceProvider.isGetResourceWSAvailable();
        this.loadContent().then(function () {
            _this.resourceProvider.logView(_this.module.instance, _this.module.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModResourceIndexComponent.prototype.invalidateContent = function () {
        return this.resourceProvider.invalidateContent(this.module.id, this.courseId);
    };
    /**
     * Download resource contents.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModResourceIndexComponent.prototype.fetchContent = function (refresh) {
        var _this = this;
        // Load module contents if needed. Passing refresh is needed to force reloading contents.
        return this.courseProvider.loadModuleContents(this.module, this.courseId, null, false, refresh).then(function () {
            if (!_this.module.contents || !_this.module.contents.length) {
                return Promise.reject(_this.utils.createFakeWSError('core.filenotfound', true));
            }
            // Get the resource instance to get the latest name/description and to know if it's embedded.
            if (_this.canGetResource) {
                return _this.resourceProvider.getResourceData(_this.courseId, _this.module.id).catch(function () {
                    // Ignore errors.
                });
            }
            return _this.courseProvider.getModule(_this.module.id, _this.courseId).catch(function () {
                // Ignore errors.
            });
        }).then(function (resource) {
            if (resource) {
                _this.description = resource.intro || resource.description;
                _this.dataRetrieved.emit(resource);
            }
            if (_this.resourceHelper.isDisplayedInIframe(_this.module)) {
                var downloadFailed_1 = false;
                return _this.prefetchHandler.download(_this.module, _this.courseId).catch(function () {
                    // Mark download as failed but go on since the main files could have been downloaded.
                    downloadFailed_1 = true;
                }).then(function () {
                    return _this.resourceHelper.getIframeSrc(_this.module).then(function (src) {
                        _this.mode = 'iframe';
                        if (_this.src && src.toString() == _this.src.toString()) {
                            // Re-loading same page.
                            // Set it to empty and then re-set the src in the next digest so it detects it has changed.
                            _this.src = '';
                            setTimeout(function () {
                                _this.src = src;
                            });
                        }
                        else {
                            _this.src = src;
                        }
                        if (downloadFailed_1 && _this.appProvider.isOnline()) {
                            // We could load the main file but the download failed. Show error message.
                            _this.domUtils.showErrorModal('core.errordownloadingsomefiles', true);
                        }
                    });
                });
            }
            else if (_this.resourceHelper.isDisplayedEmbedded(_this.module, resource && resource.display)) {
                _this.mode = 'embedded';
                return _this.resourceHelper.getEmbeddedHtml(_this.module, _this.courseId).then(function (html) {
                    _this.contentText = html;
                });
            }
            else {
                _this.mode = 'external';
            }
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Opens a file.
     */
    AddonModResourceIndexComponent.prototype.open = function () {
        var _this = this;
        this.prefetchHandler.isDownloadable(this.module, this.courseId).then(function (downloadable) {
            if (downloadable) {
                _this.resourceHelper.openModuleFile(_this.module, _this.courseId);
            }
            else {
                // The resource cannot be downloaded, open the activity in browser.
                return _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(_this.module.url);
            }
        });
    };
    AddonModResourceIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-resource-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\resource\components\index\addon-mod-resource-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="600" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="500" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description *ngIf="mode != \'iframe\'" [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <ng-container *ngIf="mode == \'iframe\'">\n        <core-iframe [src]="src"></core-iframe>\n    </ng-container>\n\n    <div *ngIf="mode == \'embedded\'">\n        <core-format-text [text]="contentText"></core-format-text>\n    </div>\n\n    <div padding *ngIf="mode == \'external\'">\n        <a ion-button block (click)="open()" icon-start>\n            <ion-icon name="document" start></ion-icon>\n            {{ \'addon.mod_resource.openthefile\' | translate }}\n        </a>\n    </div>\n\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\resource\components\index\addon-mod-resource-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_6__providers_resource__["a" /* AddonModResourceProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_prefetch_handler__["a" /* AddonModResourcePrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_8__providers_helper__["a" /* AddonModResourceHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModResourceIndexComponent);
    return AddonModResourceIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_5__core_course_classes_main_resource_component__["a" /* CoreCourseModuleMainResourceComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 442 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__scorm__ = __webpack_require__(168);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__scorm_offline__ = __webpack_require__(216);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Helper service that provides some features for SCORM.
 */
var AddonModScormHelperProvider = /** @class */ (function () {
    function AddonModScormHelperProvider(sitesProvider, translate, domUtils, utils, scormProvider, scormOfflineProvider) {
        this.sitesProvider = sitesProvider;
        this.translate = translate;
        this.domUtils = domUtils;
        this.utils = utils;
        this.scormProvider = scormProvider;
        this.scormOfflineProvider = scormOfflineProvider;
        // List of elements we want to ignore when copying attempts (they're calculated).
        this.elementsToIgnore = ['status', 'score_raw', 'total_time', 'session_time', 'student_id', 'student_name', 'credit',
            'mode', 'entry'];
    }
    /**
     * Show a confirm dialog if needed. If SCORM doesn't have size, try to calculate it.
     *
     * @param {any} scorm SCORM to download.
     * @param {boolean} [isOutdated] True if package outdated, false if not outdated, undefined to calculate it.
     * @return {Promise<any>} Promise resolved if the user confirms or no confirmation needed.
     */
    AddonModScormHelperProvider.prototype.confirmDownload = function (scorm, isOutdated) {
        var _this = this;
        // Check if file should be downloaded.
        return this.scormProvider.shouldDownloadMainFile(scorm, isOutdated).then(function (download) {
            if (download) {
                var subPromise = void 0;
                if (!scorm.packagesize) {
                    // We don't have package size, try to calculate it.
                    subPromise = _this.scormProvider.calculateScormSize(scorm).then(function (size) {
                        // Store it so we don't have to calculate it again when using the same object.
                        scorm.packagesize = size;
                        return size;
                    });
                }
                else {
                    subPromise = Promise.resolve(scorm.packagesize);
                }
                return subPromise.then(function (size) {
                    return _this.domUtils.confirmDownloadSize({ size: size, total: true });
                });
            }
        });
    };
    /**
     * Creates a new offline attempt based on an existing online attempt.
     *
     * @param {any} scorm SCORM.
     * @param {number} attempt Number of the online attempt.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the attempt is created.
     */
    AddonModScormHelperProvider.prototype.convertAttemptToOffline = function (scorm, attempt, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Get data from the online attempt.
        return this.scormProvider.getScormUserData(scorm.id, attempt, undefined, false, false, siteId).then(function (onlineData) {
            // The SCORM API might have written some data to the offline attempt already.
            // We don't want to override it with cached online data.
            return _this.scormOfflineProvider.getScormUserData(scorm.id, attempt, undefined, siteId).catch(function () {
                // Ignore errors.
            }).then(function (offlineData) {
                var dataToStore = _this.utils.clone(onlineData);
                var _loop_1 = function (scoId) {
                    var sco = dataToStore[scoId];
                    // Delete calculated data.
                    _this.elementsToIgnore.forEach(function (el) {
                        delete sco.userdata[el];
                    });
                    // Don't override offline data.
                    if (offlineData && offlineData[sco.scoid] && offlineData[sco.scoid].userdata) {
                        var scoUserData = {};
                        for (var element in sco.userdata) {
                            if (!offlineData[sco.scoid].userdata[element]) {
                                // This element is not stored in offline, we can save it.
                                scoUserData[element] = sco.userdata[element];
                            }
                        }
                        sco.userdata = scoUserData;
                    }
                };
                // Filter the data to copy.
                for (var scoId in dataToStore) {
                    _loop_1(scoId);
                }
                return _this.scormOfflineProvider.createNewAttempt(scorm, attempt, dataToStore, onlineData, siteId);
            });
        }).catch(function () {
            // Shouldn't happen.
            return Promise.reject(_this.translate.instant('addon.mod_scorm.errorcreateofflineattempt'));
        });
    };
    /**
     * Creates a new offline attempt.
     *
     * @param {any} scorm SCORM.
     * @param {number} newAttempt Number of the new attempt.
     * @param {number} lastOnline Number of the last online attempt.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the attempt is created.
     */
    AddonModScormHelperProvider.prototype.createOfflineAttempt = function (scorm, newAttempt, lastOnline, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Try to get data from online attempts.
        return this.searchOnlineAttemptUserData(scorm.id, lastOnline, siteId).then(function (userData) {
            // We're creating a new attempt, remove all the user data that is not needed for a new attempt.
            for (var scoId in userData) {
                var sco = userData[scoId], filtered = {};
                for (var element in sco.userdata) {
                    if (element.indexOf('.') == -1 && _this.elementsToIgnore.indexOf(element) == -1) {
                        // The element doesn't use a dot notation, probably SCO data.
                        filtered[element] = sco.userdata[element];
                    }
                }
                sco.userdata = filtered;
            }
            return _this.scormOfflineProvider.createNewAttempt(scorm, newAttempt, userData, undefined, siteId);
        }).catch(function () {
            return Promise.reject(_this.translate.instant('addon.mod_scorm.errorcreateofflineattempt'));
        });
    };
    /**
     * Determines the attempt to continue/review. It will be:
     * - The last incomplete online attempt if it hasn't been continued in offline and all offline attempts are complete.
     * - The attempt with highest number without surpassing max attempts otherwise.
     *
     * @param {any} scorm SCORM object.
     * @param {AddonModScormAttemptCountResult} attempts Attempts count.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{number: number, offline: boolean}>} Promise resolved with the attempt data.
     */
    AddonModScormHelperProvider.prototype.determineAttemptToContinue = function (scorm, attempts, siteId) {
        var _this = this;
        var lastOnline;
        // Get last online attempt.
        if (attempts.online.length) {
            lastOnline = Math.max.apply(Math, attempts.online);
        }
        if (lastOnline) {
            // Check if last online incomplete.
            var hasOffline_1 = attempts.offline.indexOf(lastOnline) > -1;
            return this.scormProvider.isAttemptIncomplete(scorm.id, lastOnline, hasOffline_1, false, siteId).then(function (incomplete) {
                if (incomplete) {
                    return {
                        number: lastOnline,
                        offline: hasOffline_1
                    };
                }
                else {
                    return _this.getLastBeforeMax(scorm, attempts);
                }
            });
        }
        else {
            return Promise.resolve(this.getLastBeforeMax(scorm, attempts));
        }
    };
    /**
     * Get the first SCO to load in a SCORM: the first valid and incomplete SCO.
     *
     * @param {number} scormId Scorm ID.
     * @param {number} attempt Attempt number.
     * @param {any[]} [toc] SCORM's TOC. If not provided, it will be calculated.
     * @param {string} [organization] Organization to use.
     * @param {boolean} [offline] Whether the attempt is offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the first SCO.
     */
    AddonModScormHelperProvider.prototype.getFirstSco = function (scormId, attempt, toc, organization, offline, siteId) {
        var _this = this;
        var promise;
        if (toc && toc.length) {
            promise = Promise.resolve(toc);
        }
        else {
            // SCORM doesn't have a TOC. Get all the scos.
            promise = this.scormProvider.getScosWithData(scormId, attempt, organization, offline, false, siteId);
        }
        return promise.then(function (scos) {
            // Search the first valid SCO.
            for (var i = 0; i < scos.length; i++) {
                var sco = scos[i];
                // Return the first valid and incomplete SCO.
                if (sco.isvisible && sco.prereq && sco.launch && _this.scormProvider.isStatusIncomplete(sco.status)) {
                    return sco;
                }
            }
        });
    };
    /**
     * Get the last attempt (number and whether it's offline).
     * It'll be the highest number as long as it doesn't surpass the max number of attempts.
     *
     * @param {any} scorm SCORM object.
     * @param {AddonModScormAttemptCountResult} attempts Attempts count.
     * @return {{number: number, offline: boolean}} Last attempt data.
     */
    AddonModScormHelperProvider.prototype.getLastBeforeMax = function (scorm, attempts) {
        if (scorm.maxattempt != 0 && attempts.lastAttempt.number > scorm.maxattempt) {
            return {
                number: scorm.maxattempt,
                offline: attempts.offline.indexOf(scorm.maxattempt) > -1
            };
        }
        else {
            return {
                number: attempts.lastAttempt.number,
                offline: attempts.lastAttempt.offline
            };
        }
    };
    /**
     * Given a TOC in array format and a scoId, return the next available SCO.
     *
     * @param {any[]} toc SCORM's TOC.
     * @param {number} scoId SCO ID.
     * @return {any} Next SCO.
     */
    AddonModScormHelperProvider.prototype.getNextScoFromToc = function (toc, scoId) {
        for (var i = 0; i < toc.length; i++) {
            if (toc[i].id == scoId) {
                // We found the current SCO. Now let's search the next visible SCO with fulfilled prerequisites.
                for (var j = i + 1; j < toc.length; j++) {
                    if (toc[j].isvisible && toc[j].prereq && toc[j].launch) {
                        return toc[j];
                    }
                }
                break;
            }
        }
    };
    /**
     * Given a TOC in array format and a scoId, return the previous available SCO.
     *
     * @param {any[]} toc SCORM's TOC.
     * @param {number} scoId SCO ID.
     * @return {any} Previous SCO.
     */
    AddonModScormHelperProvider.prototype.getPreviousScoFromToc = function (toc, scoId) {
        for (var i = 0; i < toc.length; i++) {
            if (toc[i].id == scoId) {
                // We found the current SCO. Now let's search the previous visible SCO with fulfilled prerequisites.
                for (var j = i - 1; j >= 0; j--) {
                    if (toc[j].isvisible && toc[j].prereq && toc[j].launch) {
                        return toc[j];
                    }
                }
                break;
            }
        }
    };
    /**
     * Given a TOC in array format and a scoId, return the SCO.
     *
     * @param {any[]} toc SCORM's TOC.
     * @param {number} scoId SCO ID.
     * @return {any} SCO.
     */
    AddonModScormHelperProvider.prototype.getScoFromToc = function (toc, scoId) {
        for (var i = 0; i < toc.length; i++) {
            if (toc[i].id == scoId) {
                return toc[i];
            }
        }
    };
    /**
     * Searches user data for an online attempt. If the data can't be retrieved, re-try with the previous online attempt.
     *
     * @param {number} scormId SCORM ID.
     * @param {number} attempt Online attempt to get the data.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with user data.
     */
    AddonModScormHelperProvider.prototype.searchOnlineAttemptUserData = function (scormId, attempt, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.scormProvider.getScormUserData(scormId, attempt, undefined, false, false, siteId).catch(function () {
            if (attempt > 0) {
                // We couldn't retrieve the data. Try again with the previous online attempt.
                return _this.searchOnlineAttemptUserData(scormId, attempt - 1, siteId);
            }
            else {
                // No more attempts to try. Reject
                return Promise.reject(null);
            }
        });
    };
    AddonModScormHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__scorm__["a" /* AddonModScormProvider */], __WEBPACK_IMPORTED_MODULE_6__scorm_offline__["a" /* AddonModScormOfflineProvider */]])
    ], AddonModScormHelperProvider);
    return AddonModScormHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 443 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_scorm__ = __webpack_require__(168);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(442);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_scorm_offline__ = __webpack_require__(216);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_scorm_sync__ = __webpack_require__(227);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__ = __webpack_require__(376);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};











/**
 * Component that displays a SCORM entry page.
 */
var AddonModScormIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModScormIndexComponent, _super);
    function AddonModScormIndexComponent(injector, scormProvider, content, scormHelper, scormOffline, scormSync, prefetchHandler, navCtrl, prefetchDelegate, utils) {
        var _this = _super.call(this, injector, content) || this;
        _this.scormProvider = scormProvider;
        _this.content = content;
        _this.scormHelper = scormHelper;
        _this.scormOffline = scormOffline;
        _this.scormSync = scormSync;
        _this.prefetchHandler = prefetchHandler;
        _this.navCtrl = navCtrl;
        _this.prefetchDelegate = prefetchDelegate;
        _this.utils = utils;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].COMPONENT;
        _this.moduleName = 'scorm';
        _this.currentOrganization = {}; // Selected organization.
        _this.scormOptions = {
            mode: __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].MODENORMAL,
            newAttempt: false
        };
        _this.modeNormal = __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].MODENORMAL; // Normal open mode.
        _this.modeBrowser = __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].MODEBROWSE; // Browser open mode.
        _this.fetchContentDefaultError = 'addon.mod_scorm.errorgetscorm'; // Default error to show when loading contents.
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_8__providers_scorm_sync__["a" /* AddonModScormSyncProvider */].AUTO_SYNCED;
        _this.hasPlayed = false; // Whether the user has opened the player page.
        _this.dataSent = false; // Whether some data was sent to server while playing the SCORM.
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModScormIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.loadContent(false, true).then(function () {
            if (!_this.scorm) {
                return;
            }
            if (_this.skip) {
                _this.open();
            }
            _this.scormProvider.logView(_this.scorm.id, _this.scorm.name).then(function () {
                _this.checkCompletion();
            }).catch(function (error) {
                // Ignore errors.
            });
        });
    };
    /**
     * Check the completion.
     */
    AddonModScormIndexComponent.prototype.checkCompletion = function () {
        this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
    };
    /**
     * Download a SCORM package or restores an ongoing download.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormIndexComponent.prototype.downloadScormPackage = function () {
        var _this = this;
        this.downloading = true;
        return this.prefetchHandler.download(this.module, this.courseId, undefined, function (data) {
            if (!data) {
                return;
            }
            if (data.downloading) {
                // Downloading package.
                if (_this.scorm.packagesize && data.progress) {
                    _this.percentage = (Number(data.progress.loaded / _this.scorm.packagesize) * 100).toFixed(1);
                }
            }
            else if (data.message) {
                // Show a message.
                _this.progressMessage = data.message;
                _this.percentage = undefined;
            }
            else if (data.progress && data.progress.loaded && data.progress.total) {
                // Unzipping package.
                _this.percentage = (Number(data.progress.loaded / data.progress.total) * 100).toFixed(1);
            }
            else {
                _this.percentage = undefined;
            }
        }).finally(function () {
            _this.progressMessage = undefined;
            _this.percentage = undefined;
            _this.downloading = false;
        });
    };
    /**
     * Get the SCORM data.
     *
     * @param {boolean} [refresh=false] If it's refreshing content.
     * @param {boolean} [sync=false] If it should try to sync.
     * @param {boolean} [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        // Get the SCORM instance.
        return this.scormProvider.getScorm(this.courseId, this.module.id, this.module.url).then(function (scormData) {
            _this.scorm = scormData;
            _this.dataRetrieved.emit(_this.scorm);
            _this.description = _this.scorm.intro || _this.description;
            var result = _this.scormProvider.isScormUnsupported(_this.scorm);
            if (result) {
                _this.errorMessage = result;
            }
            else {
                _this.errorMessage = '';
            }
            if (_this.scorm.warningMessage) {
                return; // SCORM is closed or not open yet, we can't get more data.
            }
            var promise;
            if (sync) {
                // Try to synchronize the assign.
                promise = _this.syncActivity(showErrors).catch(function () {
                    // Ignore errors.
                });
            }
            else {
                promise = Promise.resolve();
            }
            return promise.catch(function () {
                // Ignore errors, keep getting data even if sync fails.
            }).then(function () {
                // No need to return this promise, it should be faster than the rest.
                _this.scormSync.getReadableSyncTime(_this.scorm.id).then(function (syncTime) {
                    _this.syncTime = syncTime;
                });
                var promises = [];
                // Get access information.
                promises.push(_this.scormProvider.getAccessInformation(_this.scorm.id).then(function (accessInfo) {
                    _this.accessInfo = accessInfo;
                }));
                // Get the number of attempts.
                promises.push(_this.scormProvider.getAttemptCount(_this.scorm.id).then(function (attemptsData) {
                    _this.attempts = attemptsData;
                    _this.hasOffline = !!_this.attempts.offline.length;
                    // Determine the attempt that will be continued or reviewed.
                    return _this.scormHelper.determineAttemptToContinue(_this.scorm, _this.attempts);
                }).then(function (attempt) {
                    _this.lastAttempt = attempt.number;
                    _this.lastIsOffline = attempt.offline;
                    if (_this.lastAttempt != _this.attempts.lastAttempt.number) {
                        _this.attemptToContinue = _this.lastAttempt;
                    }
                    else {
                        _this.attemptToContinue = undefined;
                    }
                    // Check if the last attempt is incomplete.
                    return _this.scormProvider.isAttemptIncomplete(_this.scorm.id, _this.lastAttempt, _this.lastIsOffline);
                }).then(function (incomplete) {
                    var promises = [];
                    _this.scorm.incomplete = incomplete;
                    _this.scorm.numAttempts = _this.attempts.total;
                    _this.scorm.gradeMethodReadable = _this.scormProvider.getScormGradeMethod(_this.scorm);
                    _this.scorm.attemptsLeft = _this.scormProvider.countAttemptsLeft(_this.scorm, _this.attempts.lastAttempt.number);
                    if (_this.scorm.forcenewattempt == __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].SCORM_FORCEATTEMPT_ALWAYS ||
                        (_this.scorm.forcenewattempt && !_this.scorm.incomplete)) {
                        _this.scormOptions.newAttempt = true;
                    }
                    promises.push(_this.getReportedGrades());
                    promises.push(_this.fetchStructure());
                    if (!_this.scorm.packagesize && _this.errorMessage === '') {
                        // SCORM is supported but we don't have package size. Try to calculate it.
                        promises.push(_this.scormProvider.calculateScormSize(_this.scorm).then(function (size) {
                            _this.scorm.packagesize = size;
                        }));
                    }
                    // Handle status.
                    promises.push(_this.setStatusListener());
                    return Promise.all(promises);
                }));
                return Promise.all(promises).then(function () {
                    // Check whether to launch the SCORM immediately.
                    if (typeof _this.skip == 'undefined') {
                        _this.skip = !_this.hasOffline && !_this.errorMessage &&
                            (!_this.scorm.lastattemptlock || _this.scorm.attemptsLeft > 0) &&
                            _this.accessInfo.canskipview && !_this.accessInfo.canviewreport &&
                            _this.scorm.skipview >= __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].SKIPVIEW_FIRST &&
                            (_this.scorm.skipview == __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].SKIPVIEW_ALWAYS || _this.lastAttempt == 0);
                    }
                });
            });
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Fetch the structure of the SCORM (TOC).
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormIndexComponent.prototype.fetchStructure = function () {
        var _this = this;
        return this.scormProvider.getOrganizations(this.scorm.id).then(function (organizations) {
            _this.organizations = organizations;
            if (!_this.currentOrganization.identifier) {
                // Load first organization (if any).
                if (organizations.length) {
                    _this.currentOrganization.identifier = organizations[0].identifier;
                }
                else {
                    _this.currentOrganization.identifier = '';
                }
            }
            return _this.loadOrganizationToc(_this.currentOrganization.identifier);
        });
    };
    /**
     * Get the grade of an attempt and add it to the scorm attempts list.
     *
     * @param {number} attempt The attempt number.
     * @param {boolean} offline Whether it's an offline attempt.
     * @param {any} attempts Object where to add the attempt.
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModScormIndexComponent.prototype.getAttemptGrade = function (attempt, offline, attempts) {
        return this.scormProvider.getAttemptGrade(this.scorm, attempt, offline).then(function (grade) {
            attempts[attempt] = {
                number: attempt,
                grade: grade
            };
        });
    };
    /**
     * Get the grades of each attempt and the grade of the SCORM.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormIndexComponent.prototype.getReportedGrades = function () {
        var _this = this;
        var promises = [], onlineAttempts = {}, offlineAttempts = {};
        // Calculate the grade for each attempt.
        this.attempts.online.forEach(function (attempt) {
            // Check that attempt isn't in offline to prevent showing the same attempt twice. Offline should be more recent.
            if (_this.attempts.offline.indexOf(attempt) == -1) {
                promises.push(_this.getAttemptGrade(attempt, false, onlineAttempts));
            }
        });
        this.attempts.offline.forEach(function (attempt) {
            promises.push(_this.getAttemptGrade(attempt, true, offlineAttempts));
        });
        return Promise.all(promises).then(function () {
            // Calculate the grade of the whole SCORM. We only use online attempts to calculate this data.
            _this.scorm.grade = _this.scormProvider.calculateScormGrade(_this.scorm, onlineAttempts);
            // Add the attempts to the SCORM in array format in ASC order, and format the grades.
            _this.scorm.onlineAttempts = _this.utils.objectToArray(onlineAttempts);
            _this.scorm.offlineAttempts = _this.utils.objectToArray(offlineAttempts);
            _this.scorm.onlineAttempts.sort(function (a, b) {
                return a.number - b.number;
            });
            _this.scorm.offlineAttempts.sort(function (a, b) {
                return a.number - b.number;
            });
            // Now format the grades.
            _this.scorm.onlineAttempts.forEach(function (attempt) {
                attempt.grade = _this.scormProvider.formatGrade(_this.scorm, attempt.grade);
            });
            _this.scorm.offlineAttempts.forEach(function (attempt) {
                attempt.grade = _this.scormProvider.formatGrade(_this.scorm, attempt.grade);
            });
            _this.scorm.grade = _this.scormProvider.formatGrade(_this.scorm, _this.scorm.grade);
        });
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any}     result Data returned on the sync function.
     * @return {boolean}        If suceed or not.
     */
    AddonModScormIndexComponent.prototype.hasSyncSucceed = function (result) {
        if (result.updated || this.dataSent) {
            // Check completion status if something was sent.
            this.checkCompletion();
        }
        this.dataSent = false;
        return true;
    };
    /**
     * User entered the page that contains the component.
     */
    AddonModScormIndexComponent.prototype.ionViewDidEnter = function () {
        var _this = this;
        _super.prototype.ionViewDidEnter.call(this);
        if (this.hasPlayed) {
            this.hasPlayed = false;
            this.scormOptions.newAttempt = false; // Uncheck new attempt.
            // Add a delay to make sure the player has started the last writing calls so we can detect conflicts.
            setTimeout(function () {
                _this.dataSentObserver && _this.dataSentObserver.off(); // Stop listening for changes.
                _this.dataSentObserver = undefined;
                // Refresh data.
                _this.showLoadingAndRefresh(true, false);
            }, 500);
        }
    };
    /**
     * User left the page that contains the component.
     */
    AddonModScormIndexComponent.prototype.ionViewDidLeave = function () {
        var _this = this;
        _super.prototype.ionViewDidLeave.call(this);
        // Display the full page when returning to the page.
        this.skip = false;
        if (this.navCtrl.getActive().component.name == 'AddonModScormPlayerPage') {
            this.hasPlayed = true;
            // Detect if anything was sent to server.
            this.dataSentObserver && this.dataSentObserver.off();
            this.dataSentObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */].DATA_SENT_EVENT, function (data) {
                if (data.scormId === _this.scorm.id) {
                    _this.dataSent = true;
                }
            }, this.siteId);
        }
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModScormIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.scormProvider.invalidateScormData(this.courseId));
        if (this.scorm) {
            promises.push(this.scormProvider.invalidateAllScormData(this.scorm.id));
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean} True if refresh is needed, false otherwise.
     */
    AddonModScormIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (syncEventData.updated && this.scorm && syncEventData.scormId == this.scorm.id) {
            // Check completion status.
            this.checkCompletion();
            return true;
        }
        return false;
    };
    /**
     * Load a organization's TOC.
     */
    AddonModScormIndexComponent.prototype.loadOrganization = function () {
        var _this = this;
        this.loadOrganizationToc(this.currentOrganization.identifier).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, _this.fetchContentDefaultError, true);
        });
    };
    /**
     * Load the TOC of a certain organization.
     *
     * @param {string} organizationId The organization id.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormIndexComponent.prototype.loadOrganizationToc = function (organizationId) {
        var _this = this;
        if (!this.scorm.displaycoursestructure) {
            // TOC is not displayed, no need to load it.
            return Promise.resolve();
        }
        this.loadingToc = true;
        return this.scormProvider.getOrganizationToc(this.scorm.id, this.lastAttempt, organizationId, this.lastIsOffline)
            .then(function (toc) {
            _this.toc = _this.scormProvider.formatTocToArray(toc);
            // Get images for each SCO.
            _this.toc.forEach(function (sco) {
                sco.image = _this.scormProvider.getScoStatusIcon(sco, _this.scorm.incomplete);
            });
            // Search organization title.
            _this.organizations.forEach(function (org) {
                if (org.identifier == organizationId) {
                    _this.currentOrganization.title = org.title;
                }
            });
        }).finally(function () {
            _this.loadingToc = false;
        });
    };
    /**
     * Open a SCORM. It will download the SCORM package if it's not downloaded or it has changed.
     *
     * @param {Event} [event] Event.
     * @param {string} [scoId] SCO that needs to be loaded when the SCORM is opened. If not defined, load first SCO.
     */
    AddonModScormIndexComponent.prototype.open = function (event, scoId) {
        var _this = this;
        if (event) {
            event.preventDefault();
            event.stopPropagation();
        }
        if (this.downloading) {
            // Scope is being downloaded, abort.
            return;
        }
        var isOutdated = this.currentStatus == __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].OUTDATED;
        if (isOutdated || this.currentStatus == __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
            // SCORM needs to be downloaded.
            this.scormHelper.confirmDownload(this.scorm, isOutdated).then(function () {
                // Invalidate WS data if SCORM is outdated.
                var promise = isOutdated ? _this.scormProvider.invalidateAllScormData(_this.scorm.id) : Promise.resolve();
                promise.finally(function () {
                    _this.downloadScormPackage().then(function () {
                        // Success downloading, open SCORM if user hasn't left the view.
                        if (!_this.isDestroyed) {
                            _this.openScorm(scoId);
                        }
                    }).catch(function (error) {
                        if (!_this.isDestroyed) {
                            _this.domUtils.showErrorModalDefault(error, _this.translate.instant('addon.mod_scorm.errordownloadscorm', { name: _this.scorm.name }));
                        }
                    });
                });
            });
        }
        else {
            this.openScorm(scoId);
        }
    };
    /**
     * Open a SCORM package.
     *
     * @param {number} scoId SCO ID.
     */
    AddonModScormIndexComponent.prototype.openScorm = function (scoId) {
        this.navCtrl.push('AddonModScormPlayerPage', {
            scorm: this.scorm,
            mode: this.scormOptions.mode,
            newAttempt: !!this.scormOptions.newAttempt,
            organizationId: this.currentOrganization.identifier,
            scoId: scoId
        });
    };
    /**
     * Displays some data based on the current status.
     *
     * @param {string} status The current status.
     * @param {string} [previousStatus] The previous status. If not defined, there is no previous status.
     */
    AddonModScormIndexComponent.prototype.showStatus = function (status, previousStatus) {
        var _this = this;
        if (status == __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].OUTDATED && this.scorm) {
            // Only show the outdated message if the file should be downloaded.
            this.scormProvider.shouldDownloadMainFile(this.scorm, true).then(function (download) {
                _this.statusMessage = download ? 'addon.mod_scorm.scormstatusoutdated' : '';
            });
        }
        else if (status == __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED) {
            this.statusMessage = 'addon.mod_scorm.scormstatusnotdownloaded';
        }
        else if (status == __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].DOWNLOADING) {
            if (!this.downloading) {
                // It's being downloaded right now but the view isn't tracking it. "Restore" the download.
                this.downloadScormPackage();
            }
        }
        else {
            this.statusMessage = '';
        }
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModScormIndexComponent.prototype.sync = function () {
        var _this = this;
        return this.scormSync.syncScorm(this.scorm).then(function (result) {
            if (!result.updated && _this.dataSent) {
                // The user sent data to server, but not in the sync process. Check if we need to fetch data.
                return _this.scormSync.prefetchAfterUpdate(_this.module, _this.courseId).catch(function () {
                    // Ignore errors.
                }).then(function () {
                    return result;
                });
            }
            return result;
        });
    };
    AddonModScormIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-scorm-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\scorm\components\index\addon-mod-scorm-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <!-- Warning message. -->\n    <div *ngIf="scorm && scorm.warningMessage" class="core-info-card" icon-start>\n        <ion-icon name="information-circle"></ion-icon>\n        {{ scorm.warningMessage }}\n    </div>\n\n    <div *ngIf="scorm && loaded && !scorm.warningMessage">\n        <!-- Attempts status. -->\n        <ion-card *ngIf="(scorm.displayattemptstatus || (scorm.offlineAttempts && scorm.offlineAttempts.length)) && !skip">\n            <ion-card-header text-wrap>\n                <h2>{{ \'addon.mod_scorm.attempts\' | translate }}</h2>\n            </ion-card-header>\n            <ion-list>\n                <ng-container *ngIf="scorm.displayattemptstatus">\n                    <ion-item text-wrap *ngIf="scorm.maxattempt >= 0">\n                        <p class="item-heading">{{ \'addon.mod_scorm.noattemptsallowed\' | translate }}</p>\n                        <p *ngIf="scorm.maxattempt == 0">{{ \'core.unlimited\' | translate }}</p>\n                        <p *ngIf="scorm.maxattempt > 0">{{ scorm.maxattempt }}</p>\n                    </ion-item>\n                    <ion-item text-wrap *ngIf="scorm.numAttempts >= 0">\n                        <p class="item-heading">{{ \'addon.mod_scorm.noattemptsmade\' | translate }}</p>\n                        <p>{{ scorm.numAttempts }}</p>\n                    </ion-item>\n                    <ion-item text-wrap *ngFor="let attempt of scorm.onlineAttempts">\n                        <p class="item-heading">{{ \'addon.mod_scorm.gradeforattempt\' | translate }} {{attempt.number}}</p>\n                        <p *ngIf="attempt.grade != -1">{{ attempt.grade }}</p>\n                        <p *ngIf="attempt.grade == -1">{{ \'addon.mod_scorm.cannotcalculategrade\' | translate }}</p>\n                    </ion-item>\n                </ng-container>\n                <ion-item text-wrap *ngFor="let attempt of scorm.offlineAttempts">\n                    <p class="item-heading">{{ \'addon.mod_scorm.gradeforattempt\' | translate }} {{attempt.number}}</p>\n                    <p *ngIf="attempt.grade != -1">{{ attempt.grade }}</p>\n                    <p *ngIf="attempt.grade == -1">{{ \'addon.mod_scorm.cannotcalculategrade\' | translate }}</p>\n                    <p *ngIf="scorm.maxattempt == 0 || attempt.number <= scorm.maxattempt">{{ \'addon.mod_scorm.offlineattemptnote\' | translate }}</p>\n                    <p *ngIf="scorm.maxattempt != 0 && attempt.number > scorm.maxattempt">{{ \'addon.mod_scorm.offlineattemptovermax\' | translate }}</p>\n                </ion-item>\n                <ion-item text-wrap *ngIf="scorm.displayattemptstatus && scorm.gradeMethodReadable">\n                    <p class="item-heading">{{ \'addon.mod_scorm.grademethod\' | translate }}</p>\n                    <p>{{ scorm.gradeMethodReadable }}</p>\n                </ion-item>\n                <ion-item text-wrap *ngIf="scorm.displayattemptstatus && scorm.grade">\n                    <p class="item-heading">{{ \'addon.mod_scorm.gradereported\' | translate }}</p>\n                    <p *ngIf="scorm.grade != -1">{{ scorm.grade }}</p>\n                    <p *ngIf="scorm.grade == -1">{{ \'addon.mod_scorm.cannotcalculategrade\' | translate }}</p>\n                </ion-item>\n                <ion-item text-wrap *ngIf="syncTime">\n                    <p class="item-heading">{{ \'core.lastsync\' | translate }}</p>\n                    <p>{{ syncTime }}</p>\n                </ion-item>\n            </ion-list>\n        </ion-card>\n\n        <!-- Synchronization warning. -->\n        <div class="core-warning-card" icon-start *ngIf="!errorMessage && hasOffline">\n            <ion-icon name="warning"></ion-icon>\n            {{ \'core.hasdatatosync\' | translate: {$a: moduleName} }}\n        </div>\n\n        <!-- TOC. -->\n        <ion-card *ngIf="scorm && organizations && ((scorm.displaycoursestructure && organizations.length) || organizations.length > 1) && !skip" class="addon-mod_scorm-toc">\n            <ion-card-header text-wrap>\n                <h2>{{ \'addon.mod_scorm.contents\' | translate }}</h2>\n            </ion-card-header>\n            <ion-list>\n                <ion-item text-wrap *ngIf="organizations.length > 1">\n                    <ion-label>{{ \'addon.mod_scorm.organizations\' | translate }}</ion-label>\n                    <ion-select [(ngModel)]="currentOrganization.identifier" (ionChange)="loadOrganization()" interface="action-sheet">\n                        <ion-option *ngFor="let org of organizations" [value]="org.identifier">{{ org.title }}</ion-option>\n                    </ion-select>\n                </ion-item>\n                <ion-item text-center *ngIf="scorm.displaycoursestructure && loadingToc">\n                    <ion-spinner></ion-spinner>\n                </ion-item>\n                <ion-item text-wrap *ngIf="scorm.displaycoursestructure && !loadingToc">\n                    <!-- If data shown doesn\'t belong to last attempt, show a warning. -->\n                    <p *ngIf="attemptToContinue">{{ \'addon.mod_scorm.dataattemptshown\' | translate:{number: attemptToContinue} }}</p>\n                    <p>{{ currentOrganization.title }}</p>\n                    <div *ngFor="let sco of toc" class="core-padding-{{sco.level}}">\n                        <p *ngIf="sco.isvisible">\n                            <img [src]="sco.image.url" [alt]="sco.image.description" />\n                            <a *ngIf="sco.prereq && sco.launch" (click)="open($event, sco.id)">{{ sco.title }}</a>\n                            <span *ngIf="!sco.prereq || !sco.launch">{{ sco.title }}</span>\n                        </p>\n                    </div>\n                </ion-item>\n            </ion-list>\n        </ion-card>\n\n        <!-- Open in browser button. -->\n        <ion-card *ngIf="errorMessage">\n            <ion-item text-wrap>\n                <p class="text-danger">{{ errorMessage | translate }}</p>\n            </ion-item>\n            <ion-item text-wrap>\n                <a ion-button block icon-end [href]="externalUrl" core-link>\n                    {{ \'core.openinbrowser\' | translate }}\n                    <ion-icon name="open"></ion-icon>\n                </a>\n            </ion-item>\n        </ion-card>\n\n        <!-- Warning that user doesn\'t have any more attempts. -->\n        <ion-card *ngIf="!errorMessage && scorm && scorm.attemptsLeft <= 0">\n            <ion-item text-wrap>\n                <p class="text-danger">{{ \'addon.mod_scorm.exceededmaxattempts\' | translate }}</p>\n            </ion-item>\n        </ion-card>\n\n        <!-- Open SCORM in app form -->\n        <ion-card *ngIf="!errorMessage && scorm && (!scorm.lastattemptlock || scorm.attemptsLeft > 0)">\n            <ion-list>\n                <!-- Open mode (Preview or Normal) -->\n                <div *ngIf="!scorm.hidebrowse && !skip" radio-group [(ngModel)]="scormOptions.mode" name="mode">\n                    <ion-item>\n                        <p class="item-heading">{{ \'addon.mod_scorm.mode\' | translate }}</p>\n                    </ion-item>\n                    <ion-item>\n                        <ion-label>{{ \'addon.mod_scorm.browse\' | translate }}</ion-label>\n                        <ion-radio [value]="modeBrowser"></ion-radio>\n                    </ion-item>\n                    <ion-item>\n                        <ion-label>{{ \'addon.mod_scorm.normal\' | translate }}</ion-label>\n                        <ion-radio [value]="modeNormal"></ion-radio>\n                    </ion-item>\n                </div>\n\n                <!-- Create new attempt -->\n                <ion-item text-wrap *ngIf="!scorm.forcenewattempt && scorm.numAttempts > 0 && !scorm.incomplete && scorm.attemptsLeft > 0 && !skip">\n                    <ion-label>{{ \'addon.mod_scorm.newattempt\' | translate }}</ion-label>\n                    <ion-checkbox item-end name="newAttempt" [(ngModel)]="scormOptions.newAttempt">\n                    </ion-checkbox>\n                </ion-item>\n\n                <!-- Button to open the SCORM. -->\n                <ng-container *ngIf="!downloading && !skip">\n                    <ion-item text-wrap *ngIf="statusMessage">\n                        <p >{{ statusMessage | translate }}</p>\n                    </ion-item>\n                    <ion-item text-wrap>\n                        <a ion-button block (click)="open($event)">{{ \'addon.mod_scorm.enter\' | translate }}</a>\n                    </ion-item>\n                </ng-container>\n\n                <!-- Download progress. -->\n                <ion-item text-center *ngIf="downloading">\n                    <ion-spinner></ion-spinner>\n                    <p *ngIf="progressMessage">{{ progressMessage | translate }}</p>\n                    <p *ngIf="percentage <= 100">{{ \'core.percentagenumber\' | translate:{$a: percentage} }}</p>\n                </ion-item>\n            </ion-list>\n        </ion-card>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\scorm\components\index\addon-mod-scorm-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModScormHelperProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_scorm_offline__["a" /* AddonModScormOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_scorm_sync__["a" /* AddonModScormSyncProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__["a" /* AddonModScormPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
            __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModScormIndexComponent);
    return AddonModScormIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_3__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 444 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_survey__ = __webpack_require__(270);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_helper__ = __webpack_require__(377);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_offline__ = __webpack_require__(271);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(272);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};







/**
 * Component that displays a survey.
 */
var AddonModSurveyIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModSurveyIndexComponent, _super);
    function AddonModSurveyIndexComponent(injector, surveyProvider, content, surveyHelper, surveyOffline, surveySync) {
        var _this = _super.call(this, injector, content) || this;
        _this.surveyProvider = surveyProvider;
        _this.surveyHelper = surveyHelper;
        _this.surveyOffline = surveyOffline;
        _this.surveySync = surveySync;
        _this.component = __WEBPACK_IMPORTED_MODULE_3__providers_survey__["a" /* AddonModSurveyProvider */].COMPONENT;
        _this.moduleName = 'survey';
        _this.answers = {};
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* AddonModSurveySyncProvider */].AUTO_SYNCED;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModSurveyIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.userId = this.sitesProvider.getCurrentSiteUserId();
        this.loadContent(false, true).then(function () {
            _this.surveyProvider.logView(_this.survey.id, _this.survey.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModSurveyIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.surveyProvider.invalidateSurveyData(this.courseId));
        if (this.survey) {
            promises.push(this.surveyProvider.invalidateQuestions(this.survey.id));
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean}          True if refresh is needed, false otherwise.
     */
    AddonModSurveyIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (this.survey && syncEventData.surveyId == this.survey.id && syncEventData.userId == this.userId) {
            return true;
        }
        return false;
    };
    /**
     * Download survey contents.
     *
     * @param  {boolean}      [refresh=false]    If it's refreshing content.
     * @param  {boolean}      [sync=false]       If it should try to sync.
     * @param  {boolean}      [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModSurveyIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        return this.surveyProvider.getSurvey(this.courseId, this.module.id).then(function (survey) {
            _this.survey = survey;
            _this.description = survey.intro || survey.description;
            _this.dataRetrieved.emit(survey);
            if (sync) {
                // Try to synchronize the survey.
                return _this.syncActivity(showErrors).then(function (answersSent) {
                    if (answersSent) {
                        // Answers were sent, update the survey.
                        return _this.surveyProvider.getSurvey(_this.courseId, _this.module.id).then(function (survey) {
                            _this.survey = survey;
                        });
                    }
                });
            }
        }).then(function () {
            // Check if there are answers stored in offline.
            return _this.surveyOffline.hasAnswers(_this.survey.id);
        }).then(function (hasOffline) {
            _this.hasOffline = _this.survey.surveydone ? false : hasOffline;
            if (!_this.survey.surveydone && !_this.hasOffline) {
                return _this.fetchQuestions();
            }
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Convenience function to get survey questions.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModSurveyIndexComponent.prototype.fetchQuestions = function () {
        var _this = this;
        return this.surveyProvider.getQuestions(this.survey.id).then(function (questions) {
            _this.questions = _this.surveyHelper.formatQuestions(questions);
            // Init answers object.
            _this.questions.forEach(function (q) {
                if (q.name) {
                    var isTextArea = q.multi && q.multi.length === 0 && q.type === 0;
                    _this.answers[q.name] = q.required ? -1 : (isTextArea ? '' : '0');
                }
                if (q.multi && !q.multi.length && q.parent === 0 && q.type > 0) {
                    // Options shown in a select. Remove all HTML.
                    q.options = q.options.map(function (option) {
                        return _this.textUtils.cleanTags(option);
                    });
                }
            });
        });
    };
    /**
     * Check if answers are valid to be submitted.
     *
     * @return {boolean}  If answers are valid
     */
    AddonModSurveyIndexComponent.prototype.isValidResponse = function () {
        for (var x in this.answers) {
            if (this.answers[x] === -1) {
                return false;
            }
        }
        return true;
    };
    /**
     * Save options selected.
     */
    AddonModSurveyIndexComponent.prototype.submit = function () {
        var _this = this;
        this.domUtils.showConfirm(this.translate.instant('core.areyousure')).then(function () {
            var answers = [], modal = _this.domUtils.showModalLoading('core.sending', true);
            for (var x in _this.answers) {
                answers.push({
                    key: x,
                    value: _this.answers[x]
                });
            }
            return _this.surveyProvider.submitAnswers(_this.survey.id, _this.survey.name, _this.courseId, answers).then(function (online) {
                if (online && _this.isPrefetched()) {
                    // The survey is downloaded, update the data.
                    return _this.surveySync.prefetchAfterUpdate(_this.module, _this.courseId).then(function () {
                        // Update the view.
                        _this.showLoadingAndFetch(false, false);
                    }).catch(function (error) {
                        // Prefetch failed, refresh the data.
                        return _this.showLoadingAndRefresh(false);
                    });
                }
                else {
                    // Not downloaded, refresh the data.
                    return _this.showLoadingAndRefresh(false);
                }
            }).finally(function () {
                modal.dismiss();
            });
        }).catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'addon.mod_survey.cannotsubmitsurvey', true);
        });
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModSurveyIndexComponent.prototype.sync = function () {
        return this.surveySync.syncSurvey(this.survey.id, this.userId);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any}     result Data returned on the sync function.
     * @return {boolean}        If suceed or not.
     */
    AddonModSurveyIndexComponent.prototype.hasSyncSucceed = function (result) {
        return result.answersSent;
    };
    AddonModSurveyIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-survey-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\survey\components\index\addon-mod-survey-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <!-- Survey already done -->\n    <ion-card padding *ngIf="survey && survey.surveydone">\n        <p padding>{{ \'addon.mod_survey.surveycompletednograph\' | translate }}</p>\n        <a ion-button block icon-start [href]="externalUrl" core-link>\n            <ion-icon name="open" start></ion-icon>\n            {{ \'addon.mod_survey.results\' | translate }}\n        </a>\n    </ion-card>\n\n    <!-- Survey done in offline but not synchronized -->\n    <div class="core-warning-card" icon-start *ngIf="hasOffline">\n        <ion-icon name="warning"></ion-icon>\n        {{ \'core.hasdatatosync\' | translate: {$a: moduleName} }}\n    </div>\n\n    <!-- Survey questions -->\n    <section *ngIf="survey && !survey.surveydone && !hasOffline && questions && questions.length">\n\n        <ng-container *ngFor="let question of questions; let index=index; let isEven=even;">\n            <!-- Parent question (Category header) -->\n            <div *ngIf="question.multi && question.multi.length" [attr.padding-top]="index == 1">\n                <h3 padding-horizontal>{{ question.text }}</h3>\n                <ion-grid no-padding>\n                    <ion-row no-padding align-items-center class="hidden-phone">\n                        <ion-col col-7>\n                            <div padding>{{ \'addon.mod_survey.responses\' | translate }}</div>\n                        </ion-col>\n                        <ion-col text-center *ngFor="let option of question.options">\n                            <div padding>{{ option }}</div>\n                        </ion-col>\n                    </ion-row>\n                </ion-grid>\n                <ion-item text-wrap [class.even]="isEven" class="addon-mod_survey-question">\n                    <p>{{ question.intro }}</p>\n                </ion-item>\n            </div>\n\n            <!-- Subquestion -->\n            <ion-grid no-padding *ngIf="question.parent !== 0" text-wrap [class.even]="isEven">\n                <ion-row no-padding nowrap align-items-center radio-group [(ngModel)]="answers[question.name]" [required]="question.required">\n                    <ion-col col-7>\n                        <ion-label padding-horizontal [core-mark-required]="question.required" id="addon-mod_survey-{{question.name}}"><strong>{{question.num}}.</strong> {{ question.text }}</ion-label>\n                    </ion-col>\n\n                    <!-- Tablet view: radio buttons -->\n                    <ion-col class="hidden-phone" text-center *ngFor="let option of question.options; let value=index;">\n                        <ion-radio [value]="value + 1" [attr.aria-labelledby]="\'addon-mod_survey-\'+question.name"></ion-radio>\n                    </ion-col>\n                    <ion-col class="hidden-tablet">\n                        <ion-select padding [(ngModel)]="answers[question.name]" [attr.aria-labelledby]="\'addon-mod_survey-\'+question.name" interface="action-sheet" [required]="question.required">\n                            <ion-option value="-1" selected disabled>{{ \'core.choose\' | translate }}</ion-option>\n                            <ion-option *ngFor="let option of question.options; let value=index;" [value]="value +1">{{option}}</ion-option>\n                        </ion-select>\n                    </ion-col>\n                </ion-row>\n            </ion-grid>\n\n            <!-- Single question (don\'t belong to a category) -->\n            <ng-container *ngIf="(!question.multi || question.multi.length == 0) && question.parent === 0">\n                <ion-grid no-padding text-wrap *ngIf="question.type > 0" [class.even]="isEven">\n                    <ion-row no-padding align-items-center>\n                        <ion-col col-7>\n                            <ion-label [core-mark-required]="question.required" padding-horizontal id="addon-mod_survey-{{question.name}}"><strong>{{question.num}}.</strong> {{ question.text }}</ion-label>\n                        </ion-col>\n                        <ion-col col-5>\n                            <ion-select padding [(ngModel)]="answers[question.name]" [attr.aria-labelledby]="\'addon-mod_survey-\'+question.name" interface="action-sheet" [required]="question.required">\n                            <ion-option *ngFor="let option of question.options; let value=index;" [value]="value">{{option}}</ion-option>\n                        </ion-select>\n                        </ion-col>\n                    </ion-row>\n                </ion-grid>\n\n                <ion-item *ngIf="question.type === 0" text-wrap [class.even]="isEven">\n                    <ion-label stacked [core-mark-required]="question.required" id="addon-mod_survey-{{question.name}}">\n                        <strong>{{question.num}}.</strong> {{ question.text }}\n                    </ion-label>\n                    <ion-textarea [(ngModel)]="answers[question.name]" class="addon-mod_survey-textarea" [attr.aria-label]="question.text" [required]="question.required"></ion-textarea>\n                </ion-item>\n            </ng-container>\n\n        </ng-container>\n\n        <ion-item>\n            <button ion-button block (click)="submit()" [disabled]="!isValidResponse()">{{ \'core.submit\' | translate }}</button>\n        </ion-item>\n    </section>\n\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\survey\components\index\addon-mod-survey-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_3__providers_survey__["a" /* AddonModSurveyProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_4__providers_helper__["a" /* AddonModSurveyHelperProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_offline__["a" /* AddonModSurveyOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* AddonModSurveySyncProvider */]])
    ], AddonModSurveyIndexComponent);
    return AddonModSurveyIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 445 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModUrlIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__ = __webpack_require__(164);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_url__ = __webpack_require__(378);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(379);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Component that displays a url.
 */
var AddonModUrlIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModUrlIndexComponent, _super);
    function AddonModUrlIndexComponent(injector, urlProvider, courseProvider, urlHelper, mimeUtils, sitesProvider, modalCtrl, platform, utils) {
        var _this = _super.call(this, injector) || this;
        _this.urlProvider = urlProvider;
        _this.courseProvider = courseProvider;
        _this.urlHelper = urlHelper;
        _this.mimeUtils = mimeUtils;
        _this.sitesProvider = sitesProvider;
        _this.modalCtrl = modalCtrl;
        _this.platform = platform;
        _this.utils = utils;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_url__["a" /* AddonModUrlProvider */].COMPONENT;
        _this.shouldEmbed = false;
        _this.shouldIframe = false;
        _this.isImage = false;
        _this.isAudio = false;
        _this.isVideo = false;
        _this.isOther = false;
        _this.displayDescription = true;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModUrlIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.canGetUrl = this.urlProvider.isGetUrlWSAvailable();
        this.loadContent().then(function () {
            if ((_this.shouldIframe || (_this.shouldEmbed && _this.isOther)) ||
                (!_this.shouldIframe && (!_this.shouldEmbed || !_this.isOther))) {
                _this.logView();
            }
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModUrlIndexComponent.prototype.invalidateContent = function () {
        return this.urlProvider.invalidateContent(this.module.id, this.courseId);
    };
    /**
     * Download url contents.
     *
     * @param {boolean} [refresh] Whether we're refreshing data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModUrlIndexComponent.prototype.fetchContent = function (refresh) {
        var _this = this;
        var canGetUrl = this.canGetUrl, mod, url, promise;
        // Fetch the module data.
        if (canGetUrl) {
            promise = this.urlProvider.getUrl(this.courseId, this.module.id);
        }
        else {
            promise = Promise.reject(null);
        }
        return promise.catch(function () {
            canGetUrl = false;
            // Fallback in case is not prefetched or not available.
            return _this.courseProvider.getModule(_this.module.id, _this.courseId, undefined, false, false, undefined, 'url');
        }).then(function (urlData) {
            url = urlData;
            _this.name = url.name || _this.module.name;
            _this.description = url.intro || url.description;
            _this.dataRetrieved.emit(url);
            if (canGetUrl && url.displayoptions) {
                var unserialized = _this.textUtils.unserialize(url.displayoptions);
                _this.displayDescription = typeof unserialized.printintro == 'undefined' || !!unserialized.printintro;
            }
            if (!canGetUrl) {
                mod = url;
                if (!url.contents.length) {
                    // If the data was cached maybe we don't have contents. Reject.
                    return Promise.reject(null);
                }
            }
            else {
                mod = _this.module;
                if (!mod.contents || !mod.contents.length) {
                    // Try to load module contents, it's needed to get the URL with parameters.
                    return _this.courseProvider.loadModuleContents(mod, _this.courseId, undefined, false, false, undefined, 'url');
                }
            }
        }).then(function () {
            // Always use the URL from the module because it already includes the parameters.
            _this.url = mod.contents && mod.contents[0] && mod.contents[0].fileurl ? mod.contents[0].fileurl : undefined;
            // this.url='http://fmp.ouchn.edu.cn/webroot/vod/videofile/kfdxjtgxg/kfdxjtgxg.mp4';
            if (url != null && url.externalurl == null && url.contents != null && url.contents.length > 0) {
                url.externalurl = url.contents[0].fileurl;
            }
            ;
            var extension = _this.mimeUtils.guessExtensionFromUrl(url.externalurl);
            if (extension == 'pdf') {
                _this.navCtrl.pop();
                if (_this.platform.is('ios')) {
                    var browser = window.cordova.InAppBrowser.open(url.externalurl, '_blank', 'location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
                }
                else {
                    _this.navCtrl.push('OucshowpdfPage', {
                        displayData: url.externalurl
                    });
                }
                // 
                // let modal: Modal = this.modalCtrl.create('OucshowpdfPage', {
                //     displayData:url.externalurl
                //   });
                //  modal.present();
            }
            else if (extension == 'doc' || extension == 'docx' || extension == 'xls' || extension == 'txt') {
                _this.navCtrl.pop();
                if (_this.platform.is('ios')) {
                    var browser = window.cordova.InAppBrowser.open(url.externalurl, '_blank', 'location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
                }
                else {
                    _this.utils.openOnlineFile(url);
                }
            }
            else {
                if (canGetUrl) {
                    return _this.calculateDisplayOptions(url);
                }
                else {
                    _this.doRefresh();
                }
            }
        });
    };
    /**
     * Calculate the display options to determine how the URL should be rendered.
     *
     * @param {any} url Object with the URL data.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModUrlIndexComponent.prototype.calculateDisplayOptions = function (url) {
        var _this = this;
        var displayType = this.urlProvider.getFinalDisplayType(url);
        this.shouldEmbed = displayType == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_EMBED;
        this.shouldIframe = displayType == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_FRAME;
        if (this.shouldEmbed) {
            var extension = this.mimeUtils.guessExtensionFromUrl(url.externalurl);
            this.mimetype = this.mimeUtils.getMimeType(extension);
            this.isImage = this.mimeUtils.isExtensionInGroup(extension, ['web_image']);
            this.isAudio = this.mimeUtils.isExtensionInGroup(extension, ['web_audio']);
            this.isVideo = this.mimeUtils.isExtensionInGroup(extension, ['web_video']);
            this.isOther = !this.isImage && !this.isAudio && !this.isVideo;
        }
        if (this.shouldIframe || (this.shouldEmbed && !this.isImage && !this.isAudio && !this.isVideo)) {
            // Will be displayed in an iframe. Check if we need to auto-login.
            var currentSite = this.sitesProvider.getCurrentSite();
            if (currentSite && currentSite.containsUrl(this.url)) {
                // Format the URL to add auto-login.
                return currentSite.getAutoLoginUrl(this.url, false).then(function (url) {
                    _this.url = url;
                });
            }
        }
        return Promise.resolve();
    };
    /**
     * Log view into the site and checks module completion.
     *
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonModUrlIndexComponent.prototype.logView = function () {
        var _this = this;
        return this.urlProvider.logView(this.module.instance, this.module.name).then(function () {
            _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
        }).catch(function () {
            // Ignore errors.
        });
    };
    /**
     * Opens a file.
     */
    AddonModUrlIndexComponent.prototype.go = function () {
        this.logView();
        this.urlHelper.open(this.url);
    };
    AddonModUrlIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-url-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\url\components\index\addon-mod-url-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description *ngIf="displayDescription" [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <div *ngIf="shouldIframe || (shouldEmbed && isOther)" class="addon-mod_url-embedded-url">\n        <core-iframe [src]="url"></core-iframe>\n    </div>\n\n    <ion-list *ngIf="!shouldIframe && (!shouldEmbed || !isOther)">\n        <ion-item *ngIf="shouldEmbed">\n            <img *ngIf="isImage" title="{{name}}" [src]="url">\n            <video *ngIf="isVideo" title="{{name}}" controls class="ouc-video-with">\n                <source [src]="url" [type]="mimetype">\n            </video>\n            <audio *ngIf="isAudio" title="{{name}}" controls>\n                <source [src]="url" [type]="mimetype">\n            </audio>\n        </ion-item>\n        <!-- <ion-item text-wrap>\n            <h2>{{ \'addon.mod_url.pointingtourl\' | translate }}</h2>\n            <p>{{ url }}</p>\n        </ion-item> -->\n        <!-- <div padding>\n            <a ion-button block (click)="go()" icon-start>\n                <ion-icon name="link" start></ion-icon>\n                {{ \'addon.mod_url.accessurl\' | translate }}\n            </a>\n        </div> -->\n    </ion-list>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\url\components\index\addon-mod-url-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_url__["a" /* AddonModUrlProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModUrlHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModUrlIndexComponent);
    return AddonModUrlIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_resource_component__["a" /* CoreCourseModuleMainResourceComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 446 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_wiki__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_wiki_offline__ = __webpack_require__(228);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__ = __webpack_require__(229);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_tabs_tabs__ = __webpack_require__(151);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_subwiki_picker_subwiki_picker__ = __webpack_require__(871);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};











/**
 * Component that displays a wiki entry page.
 */
var AddonModWikiIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModWikiIndexComponent, _super);
    function AddonModWikiIndexComponent(injector, wikiProvider, content, wikiOffline, wikiSync, navCtrl, utils, groupsProvider, userProvider, popoverCtrl) {
        var _this = _super.call(this, injector, content) || this;
        _this.wikiProvider = wikiProvider;
        _this.content = content;
        _this.wikiOffline = wikiOffline;
        _this.wikiSync = wikiSync;
        _this.navCtrl = navCtrl;
        _this.utils = utils;
        _this.groupsProvider = groupsProvider;
        _this.userProvider = userProvider;
        _this.popoverCtrl = popoverCtrl;
        _this.component = __WEBPACK_IMPORTED_MODULE_6__providers_wiki__["a" /* AddonModWikiProvider */].COMPONENT;
        _this.moduleName = 'wiki';
        _this.canEdit = false; // Whether user can edit the page.
        _this.pageStr = '';
        _this.loadedSubwikis = []; // The loaded subwikis.
        _this.selectedTab = 0; // Tab to select at start.
        _this.map = []; // Map of pages, categorized by letter.
        _this.subwikiData = {
            subwikiSelected: 0,
            userSelected: 0,
            groupSelected: 0,
            subwikis: [],
            count: 0
        };
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__["a" /* AddonModWikiSyncProvider */].AUTO_SYNCED;
        _this.hasEdited = false; // Whether the user has opened the edit page.
        _this.mapInitialized = false; // Whether the map was initialized.
        _this.initHomeButton = true; // Whether the init home button must be initialized.
        _this.pageStr = _this.translate.instant('addon.mod_wiki.wikipage');
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModWikiIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.currentUserId = this.sitesProvider.getCurrentSiteUserId();
        this.isMainPage = !this.pageId && !this.pageTitle;
        this.currentPage = this.pageId;
        this.selectedTab = this.action == 'map' ? 1 : 0;
        this.loadContent(false, true).then(function () {
            if (!_this.wiki) {
                return;
            }
            if (_this.isMainPage) {
                _this.wikiProvider.logView(_this.wiki.id, _this.wiki.name).then(function () {
                    _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
                }).catch(function (error) {
                    // Ignore errors.
                });
            }
            else {
                _this.wikiProvider.logPageView(_this.pageId, _this.wiki.id, _this.wiki.name).catch(function () {
                    // Ignore errors.
                });
            }
        });
        // Listen for manual sync events.
        this.manualSyncObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__["a" /* AddonModWikiSyncProvider */].MANUAL_SYNCED, function (data) {
            if (data && _this.wiki && data.wikiId == _this.wiki.id) {
                if (_this.ignoreManualSyncEvent) {
                    // Event needs to be ignored.
                    _this.ignoreManualSyncEvent = false;
                    return;
                }
                if (_this.currentSubwiki) {
                    _this.checkPageCreatedOrDiscarded(data.subwikis[_this.currentSubwiki.id]);
                }
                if (!_this.pageWarning) {
                    _this.showLoadingAndFetch(false, false);
                }
            }
        }, this.siteId);
    };
    /**
     * Check if the current page was created or discarded.
     *
     * @param {any} data Data about created and deleted pages.
     */
    AddonModWikiIndexComponent.prototype.checkPageCreatedOrDiscarded = function (data) {
        if (!this.currentPage && data) {
            // This is an offline page. Check if the page was created.
            var pageId = void 0;
            for (var i = 0, len = data.created.length; i < len; i++) {
                var page = data.created[i];
                if (page.title == this.pageTitle) {
                    pageId = page.pageId;
                    break;
                }
            }
            if (pageId) {
                // Page was created, set the ID so it's retrieved from server.
                this.currentPage = pageId;
                this.pageIsOffline = false;
            }
            else {
                // Page not found in created list, check if it was discarded.
                for (var i = 0, len = data.discarded.length; i < len; i++) {
                    var page = data.discarded[i];
                    if (page.title == this.pageTitle) {
                        // Page discarded, show warning.
                        this.pageWarning = page.warning;
                        this.pageContent = '';
                        this.pageIsOffline = false;
                        this.hasOffline = false;
                    }
                }
            }
        }
    };
    /**
     * Construct the map of pages.
     *
     * @param {any[]} subwikiPages List of pages.
     */
    AddonModWikiIndexComponent.prototype.constructMap = function (subwikiPages) {
        var _this = this;
        var letter, initialLetter;
        this.map = [];
        this.mapInitialized = true;
        subwikiPages.sort(function (a, b) {
            var compareA = a.title.toLowerCase().trim(), compareB = b.title.toLowerCase().trim();
            return compareA.localeCompare(compareB);
        });
        subwikiPages.forEach(function (page) {
            var letterCandidate = page.title.charAt(0).toLocaleUpperCase();
            // Should we create a new grouping?
            if (letterCandidate !== initialLetter) {
                initialLetter = letterCandidate;
                letter = { label: letterCandidate, pages: [] };
                _this.map.push(letter);
            }
            // Add the subwiki to the currently active grouping.
            letter.pages.push(page);
        });
    };
    /**
     * Get the wiki data.
     *
     * @param {boolean} [refresh=false] If it's refreshing content.
     * @param {boolean} [sync=false] If it should try to sync.
     * @param {boolean} [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWikiIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        // Get the wiki instance.
        var promise;
        if (this.module.id) {
            promise = this.wikiProvider.getWiki(this.courseId, this.module.id);
        }
        else {
            promise = this.wikiProvider.getWikiById(this.courseId, this.wikiId);
        }
        return promise.then(function (wiki) {
            _this.wiki = wiki;
            _this.dataRetrieved.emit(_this.wiki);
            if (sync) {
                // Try to synchronize the wiki.
                return _this.syncActivity(showErrors).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            if (_this.pageWarning) {
                // Page discarded, stop getting data.
                return Promise.reject(null);
            }
            if (_this.isCurrentView || _this.initHomeButton) {
                _this.initHomeButton = false;
                _this.showHomeButton = !!_this.getWikiHomeView();
            }
            // Get module instance if it's empty.
            var promise;
            if (!_this.module.id) {
                promise = _this.courseProvider.getModule(_this.wiki.coursemodule, _this.wiki.course, undefined, true);
            }
            else {
                promise = Promise.resolve(_this.module);
            }
            return promise.then(function (mod) {
                _this.module = mod;
                _this.description = _this.wiki.intro || _this.module.description;
                _this.externalUrl = _this.module.url;
                _this.componentId = _this.module.id;
                // Get real groupmode, in case it's forced by the course.
                return _this.groupsProvider.getActivityGroupMode(_this.wiki.coursemodule).then(function (groupMode) {
                    if (groupMode === __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */].SEPARATEGROUPS || groupMode === __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */].VISIBLEGROUPS) {
                        // Get the groups available for the user.
                        promise = _this.groupsProvider.getActivityAllowedGroups(_this.wiki.coursemodule);
                    }
                    else {
                        promise = Promise.resolve([]);
                    }
                    return promise.then(function (userGroups) {
                        return _this.fetchSubwikis(_this.wiki.id).then(function () {
                            // Get the subwiki list data from the cache.
                            var subwikiList = _this.wikiProvider.getSubwikiList(_this.wiki.id);
                            if (!subwikiList) {
                                // Not found in cache, create a new one.
                                return _this.createSubwikiList(userGroups);
                            }
                            _this.subwikiData.count = subwikiList.count;
                            _this.setSelectedWiki(_this.subwikiId, _this.userId, _this.groupId);
                            // If nothing was selected using nav params, use the selected from cache.
                            if (!_this.isAnySubwikiSelected()) {
                                _this.setSelectedWiki(subwikiList.subwikiSelected, subwikiList.userSelected, subwikiList.groupSelected);
                            }
                            _this.subwikiData.subwikis = subwikiList.subwikis;
                        });
                    }).then(function () {
                        if (!_this.isAnySubwikiSelected() || _this.subwikiData.count <= 0) {
                            return Promise.reject(_this.translate.instant('addon.mod_wiki.errornowikiavailable'));
                        }
                    }).then(function () {
                        return _this.fetchWikiPage();
                    });
                });
            });
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        }).catch(function (error) {
            if (_this.pageWarning) {
                // Warning is already shown in screen, no need to show a modal.
                return;
            }
            return Promise.reject(error);
        });
    };
    /**
     * Get wiki page contents.
     *
     * @param {number} pageId Page to get.
     * @return {Promise<any>} Promise resolved with the page data.
     */
    AddonModWikiIndexComponent.prototype.fetchPageContents = function (pageId) {
        var _this = this;
        if (!pageId) {
            var title_1 = this.pageTitle || this.wiki.firstpagetitle;
            // No page ID but we received a title. This means we're trying to load an offline page.
            return this.wikiOffline.getNewPage(title_1, this.currentSubwiki.id, this.currentSubwiki.wikiid, this.currentSubwiki.userid, this.currentSubwiki.groupid).then(function (offlinePage) {
                _this.pageIsOffline = true;
                if (!_this.newPageObserver) {
                    // It's an offline page, listen for new pages event to detect if the user goes to Edit and submits the page.
                    _this.newPageObserver = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__providers_wiki__["a" /* AddonModWikiProvider */].PAGE_CREATED_EVENT, function (data) {
                        if (data.subwikiId == _this.currentSubwiki.id && data.pageTitle == title_1) {
                            // The page has been submitted. Get the page from the server.
                            _this.currentPage = data.pageId;
                            _this.showLoadingAndFetch(true, false).then(function () {
                                _this.wikiProvider.logPageView(_this.currentPage, _this.wiki.id, _this.wiki.name).catch(function () {
                                    // Ignore errors.
                                });
                            });
                            // Stop listening for new page events.
                            _this.newPageObserver.off();
                            _this.newPageObserver = undefined;
                        }
                    }, _this.sitesProvider.getCurrentSiteId());
                }
                return offlinePage;
            }).catch(function () {
                // Page not found, ignore.
            });
        }
        this.pageIsOffline = false;
        return this.wikiProvider.getPageContents(pageId);
    };
    /**
     * Fetch the list of pages of a subwiki.
     *
     * @param {any} subwiki Subwiki.
     */
    AddonModWikiIndexComponent.prototype.fetchSubwikiPages = function (subwiki) {
        var _this = this;
        var subwikiPages;
        return this.wikiProvider.getSubwikiPages(subwiki.wikiid, subwiki.groupid, subwiki.userid).then(function (pages) {
            subwikiPages = pages;
            // If no page specified, search first page.
            if (!_this.currentPage && !_this.pageTitle) {
                for (var i in subwikiPages) {
                    var page = subwikiPages[i];
                    if (page.firstpage) {
                        _this.currentPage = page.id;
                        break;
                    }
                }
            }
            // Now get the offline pages.
            return _this.wikiOffline.getSubwikiNewPages(subwiki.id, subwiki.wikiid, subwiki.userid, subwiki.groupid);
        }).then(function (offlinePages) {
            // If no page specified, search page title in the offline pages.
            if (!_this.currentPage) {
                var searchTitle_1 = _this.pageTitle ? _this.pageTitle : _this.wiki.firstpagetitle, pageExists = offlinePages.some(function (page) {
                    return page.title == searchTitle_1;
                });
                if (pageExists) {
                    _this.pageTitle = searchTitle_1;
                }
            }
            _this.subwikiPages = _this.wikiProvider.sortPagesByTitle(subwikiPages.concat(offlinePages));
            _this.constructMap(_this.subwikiPages);
            // Reject if no currentPage selected from the subwikis given (if no subwikis available, do not reject).
            if (!_this.currentPage && !_this.pageTitle && _this.subwikiPages.length > 0) {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Get the subwikis.
     *
     * @param {number} wikiId Wiki ID.
     */
    AddonModWikiIndexComponent.prototype.fetchSubwikis = function (wikiId) {
        var _this = this;
        return this.wikiProvider.getSubwikis(wikiId).then(function (subwikis) {
            _this.loadedSubwikis = subwikis;
            return _this.wikiOffline.subwikisHaveOfflineData(subwikis).then(function (hasOffline) {
                _this.hasOffline = hasOffline;
            });
        });
    };
    /**
     * Fetch the page to be shown.
     *
     * @return {Promise<any>} [description]
     */
    AddonModWikiIndexComponent.prototype.fetchWikiPage = function () {
        var _this = this;
        // Search the current Subwiki.
        this.currentSubwiki = this.loadedSubwikis.find(function (subwiki) {
            return _this.isSubwikiSelected(subwiki);
        });
        if (!this.currentSubwiki) {
            return Promise.reject(null);
        }
        this.setSelectedWiki(this.currentSubwiki.id, this.currentSubwiki.userid, this.currentSubwiki.groupid);
        return this.fetchSubwikiPages(this.currentSubwiki).then(function () {
            // Check can edit before to have the value if there's no valid page.
            _this.canEdit = _this.currentSubwiki.canedit;
            return _this.fetchPageContents(_this.currentPage).then(function (pageContents) {
                if (pageContents) {
                    _this.dataRetrieved.emit(pageContents.title);
                    _this.setSelectedWiki(pageContents.subwikiid, pageContents.userid, pageContents.groupid);
                    _this.pageContent = _this.replaceEditLinks(pageContents.cachedcontent);
                    _this.canEdit = pageContents.caneditpage;
                    _this.currentPageObj = pageContents;
                }
            });
        });
    };
    /**
     * Get the wiki home view. If cannot determine or it's current view, return undefined.
     *
     * @return {ViewController} The view controller of the home view
     */
    AddonModWikiIndexComponent.prototype.getWikiHomeView = function () {
        if (!this.wiki.id) {
            return;
        }
        var views = this.navCtrl.getViews();
        // Go back in history until we find a page that doesn't belong to current wiki.
        for (var i = views.length - 2; i >= 0; i--) {
            var view = views[i];
            if (view.component.name != 'AddonModWikiIndexPage') {
                if (i == views.length - 2) {
                    // Next view is current view, return undefined.
                    return;
                }
                // This view is no longer from wiki, return the next view.
                return views[i + 1];
            }
            // Check that the view belongs to the same wiki as current view.
            var wikiId = view.data.wikiId ? view.data.wikiId : view.data.module.instance;
            if (!wikiId || wikiId != this.wiki.id) {
                // Wiki has changed, return the next view.
                return views[i + 1];
            }
        }
    };
    /**
     * Go back to the initial page of the wiki.
     */
    AddonModWikiIndexComponent.prototype.goToWikiHome = function () {
        var homeView = this.getWikiHomeView();
        if (homeView) {
            this.navCtrl.popTo(homeView);
        }
    };
    /**
     * Open the view to create the first page of the wiki.
     */
    AddonModWikiIndexComponent.prototype.goToCreateFirstPage = function () {
        this.navCtrl.push('AddonModWikiEditPage', {
            module: this.module,
            courseId: this.courseId,
            pageTitle: this.wiki.firstpagetitle,
            wikiId: this.currentSubwiki.wikiid,
            userId: this.currentSubwiki.userid,
            groupId: this.currentSubwiki.groupid
        });
    };
    /**
     * Open the view to edit the current page.
     */
    AddonModWikiIndexComponent.prototype.goToEditPage = function () {
        if (!this.canEdit) {
            return;
        }
        if (this.currentPageObj) {
            // Current page exists, go to edit it.
            var pageParams = {
                module: this.module,
                courseId: this.courseId,
                pageId: this.currentPageObj.id,
                pageTitle: this.currentPageObj.title,
                subwikiId: this.currentPageObj.subwikiid
            };
            if (this.currentSubwiki) {
                pageParams.wikiId = this.currentSubwiki.wikiid;
                pageParams.userId = this.currentSubwiki.userid;
                pageParams.groupId = this.currentSubwiki.groupid;
            }
            this.navCtrl.push('AddonModWikiEditPage', pageParams);
        }
        else if (this.currentSubwiki) {
            // No page loaded, the wiki doesn't have first page.
            this.goToCreateFirstPage();
        }
    };
    /**
     * Go to the view to create a new page.
     */
    AddonModWikiIndexComponent.prototype.goToNewPage = function () {
        if (!this.canEdit) {
            return;
        }
        if (this.currentPageObj) {
            // Current page exists, go to edit it.
            var pageParams = {
                module: this.module,
                courseId: this.courseId,
                subwikiId: this.currentPageObj.subwikiid
            };
            if (this.currentSubwiki) {
                pageParams.wikiId = this.currentSubwiki.wikiid;
                pageParams.userId = this.currentSubwiki.userid;
                pageParams.groupId = this.currentSubwiki.groupid;
            }
            this.navCtrl.push('AddonModWikiEditPage', pageParams);
        }
        else if (this.currentSubwiki) {
            // No page loaded, the wiki doesn't have first page.
            this.goToCreateFirstPage();
        }
    };
    /**
     * Go to view a certain page.
     *
     * @param {any} page Page to view.
     */
    AddonModWikiIndexComponent.prototype.goToPage = function (page) {
        var _this = this;
        if (!page.id) {
            // It's an offline page. Check if we are already in the same offline page.
            if (this.currentPage || !this.pageTitle || page.title != this.pageTitle) {
                this.navCtrl.push('AddonModWikiIndexPage', {
                    module: this.module,
                    courseId: this.courseId,
                    pageTitle: page.title,
                    wikiId: this.wiki.id,
                    subwikiId: page.subwikiid,
                    action: 'page'
                });
                return;
            }
        }
        else if (this.currentPage != page.id) {
            // Add a new State.
            this.fetchPageContents(page.id).then(function (page) {
                _this.navCtrl.push('AddonModWikiIndexPage', {
                    module: _this.module,
                    courseId: _this.courseId,
                    pageTitle: page.title,
                    pageId: page.id,
                    wikiId: page.wikiid,
                    subwikiId: page.subwikiid,
                    action: 'page'
                });
            });
            return;
        }
        // No changes done.
        this.tabs.selectTab(0);
    };
    /**
     * Go to the page to view a certain subwiki.
     *
     * @param {number} subwikiId Subwiki ID.
     * @param {number} userId User ID of the subwiki.
     * @param {number} groupId Group ID of the subwiki.
     * @param {boolean} canEdit Whether the subwiki can be edited.
     */
    AddonModWikiIndexComponent.prototype.goToSubwiki = function (subwikiId, userId, groupId, canEdit) {
        // Check if the subwiki is disabled.
        if (subwikiId > 0 || canEdit) {
            if (subwikiId != this.currentSubwiki.id || userId != this.currentSubwiki.userid ||
                groupId != this.currentSubwiki.groupid) {
                this.navCtrl.push('AddonModWikiIndexPage', {
                    module: this.module,
                    courseId: this.courseId,
                    wikiId: this.wiki.id,
                    subwikiId: subwikiId,
                    userId: userId,
                    groupId: groupId,
                    action: this.tabs.selected == 0 ? 'page' : 'map'
                });
            }
        }
    };
    /**
     * Checks if there is any subwiki selected.
     *
     * @return {boolean} Whether there is any subwiki selected.
     */
    AddonModWikiIndexComponent.prototype.isAnySubwikiSelected = function () {
        return this.subwikiData.subwikiSelected > 0 || this.subwikiData.userSelected > 0 || this.subwikiData.groupSelected > 0;
    };
    /**
     * Checks if the given subwiki is the one picked on the subwiki picker.
     *
     * @param {any} subwiki Subwiki to check.
     * @return {boolean} Whether it's the selected subwiki.
     */
    AddonModWikiIndexComponent.prototype.isSubwikiSelected = function (subwiki) {
        var subwikiId = parseInt(subwiki.id, 10) || 0;
        if (subwikiId > 0 && this.subwikiData.subwikiSelected > 0) {
            return subwikiId == this.subwikiData.subwikiSelected;
        }
        var userId = parseInt(subwiki.userid, 10) || 0, groupId = parseInt(subwiki.groupid, 10) || 0;
        return userId == this.subwikiData.userSelected && groupId == this.subwikiData.groupSelected;
    };
    /**
     * Replace edit links to have full url.
     *
     * @param {string} content Content to treat.
     * @return {string} Treated content.
     */
    AddonModWikiIndexComponent.prototype.replaceEditLinks = function (content) {
        content = content.trim();
        if (content.length > 0) {
            var editUrl = this.textUtils.concatenatePaths(this.sitesProvider.getCurrentSite().getURL(), '/mod/wiki/edit.php');
            content = content.replace(/href="edit\.php/g, 'href="' + editUrl);
        }
        return content;
    };
    /**
     * Sets the selected subwiki for the subwiki picker.
     *
     * @param {number} subwikiId Subwiki ID to select.
     * @param {number} userId User ID of the subwiki to select.
     * @param {number} groupId Group ID of the subwiki to select.
     */
    AddonModWikiIndexComponent.prototype.setSelectedWiki = function (subwikiId, userId, groupId) {
        this.subwikiData.subwikiSelected = this.wikiOffline.convertToPositiveNumber(subwikiId);
        this.subwikiData.userSelected = this.wikiOffline.convertToPositiveNumber(userId);
        this.subwikiData.groupSelected = this.wikiOffline.convertToPositiveNumber(groupId);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any}     result Data returned on the sync function.
     * @return {boolean}        If suceed or not.
     */
    AddonModWikiIndexComponent.prototype.hasSyncSucceed = function (result) {
        result.wikiId = this.wiki.id;
        if (result.updated) {
            // Trigger event.
            this.ignoreManualSyncEvent = true;
            this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__["a" /* AddonModWikiSyncProvider */].MANUAL_SYNCED, result);
        }
        if (this.currentSubwiki) {
            this.checkPageCreatedOrDiscarded(result.subwikis[this.currentSubwiki.id]);
        }
        return result.updated;
    };
    /**
     * User entered the page that contains the component.
     */
    AddonModWikiIndexComponent.prototype.ionViewDidEnter = function () {
        _super.prototype.ionViewDidEnter.call(this);
        this.tabs && this.tabs.ionViewDidEnter();
        if (this.hasEdited) {
            this.hasEdited = false;
            this.showLoadingAndRefresh(true, false);
        }
    };
    /**
     * User left the page that contains the component.
     */
    AddonModWikiIndexComponent.prototype.ionViewDidLeave = function () {
        _super.prototype.ionViewDidLeave.call(this);
        this.tabs && this.tabs.ionViewDidLeave();
        if (this.navCtrl.getActive().component.name == 'AddonModWikiEditPage') {
            this.hasEdited = true;
        }
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModWikiIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.wikiProvider.invalidateWikiData(this.courseId));
        if (this.wiki) {
            promises.push(this.wikiProvider.invalidateSubwikis(this.wiki.id));
            promises.push(this.groupsProvider.invalidateActivityAllowedGroups(this.wiki.coursemodule));
            promises.push(this.groupsProvider.invalidateActivityGroupMode(this.wiki.coursemodule));
        }
        if (this.currentSubwiki) {
            promises.push(this.wikiProvider.invalidateSubwikiPages(this.currentSubwiki.wikiid));
            promises.push(this.wikiProvider.invalidateSubwikiFiles(this.currentSubwiki.wikiid));
        }
        if (this.currentPage) {
            promises.push(this.wikiProvider.invalidatePage(this.currentPage));
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean} True if refresh is needed, false otherwise.
     */
    AddonModWikiIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (this.currentSubwiki && syncEventData.subwikiId == this.currentSubwiki.id &&
            syncEventData.wikiId == this.currentSubwiki.wikiid && syncEventData.userId == this.currentSubwiki.userid &&
            syncEventData.groupId == this.currentSubwiki.groupid) {
            if (this.isCurrentView && syncEventData.warnings && syncEventData.warnings.length) {
                // Show warnings.
                this.domUtils.showErrorModal(syncEventData.warnings[0]);
            }
            // Check if current page was created or discarded.
            this.checkPageCreatedOrDiscarded(syncEventData);
        }
        return !this.pageWarning;
    };
    /**
     * Show the TOC.
     *
     * @param {MouseEvent} event Event.
     */
    AddonModWikiIndexComponent.prototype.showSubwikiPicker = function (event) {
        var _this = this;
        var popover = this.popoverCtrl.create(__WEBPACK_IMPORTED_MODULE_10__components_subwiki_picker_subwiki_picker__["a" /* AddonModWikiSubwikiPickerComponent */], {
            subwikis: this.subwikiData.subwikis,
            currentSubwiki: this.currentSubwiki
        });
        popover.onDidDismiss(function (subwiki) {
            if (subwiki) {
                _this.goToSubwiki(subwiki.id, subwiki.userid, subwiki.groupid, subwiki.canedit);
            }
        });
        popover.present({
            ev: event
        });
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWikiIndexComponent.prototype.sync = function () {
        return this.wikiSync.syncWiki(this.wiki.id, this.courseId, this.wiki.coursemodule);
    };
    /**
     * Component being destroyed.
     */
    AddonModWikiIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.manualSyncObserver && this.manualSyncObserver.off();
        this.newPageObserver && this.newPageObserver.off();
    };
    /**
     * Create the subwiki list for the selector and store it in the cache.
     *
     * @param {any[]} userGroups Groups.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWikiIndexComponent.prototype.createSubwikiList = function (userGroups) {
        var _this = this;
        var subwikiList = [], promises = [];
        var userGroupsIds = [], allParticipants = false, showMyGroupsLabel = false, multiLevelList = false;
        this.subwikiData.subwikis = [];
        this.setSelectedWiki(this.subwikiId, this.userId, this.groupId);
        this.subwikiData.count = 0;
        // Group mode available.
        if (userGroups.length > 0) {
            userGroupsIds = userGroups.map(function (g) {
                return g.id;
            });
        }
        // Add the subwikis to the subwikiList.
        this.loadedSubwikis.forEach(function (subwiki) {
            var groupId = parseInt(subwiki.groupid, 10), userId = parseInt(subwiki.userid, 10);
            var groupLabel = '';
            if (groupId == 0 && userId == 0) {
                // Add 'All participants' subwiki if needed at the start.
                if (!allParticipants) {
                    subwikiList.unshift({
                        name: _this.translate.instant('core.allparticipants'),
                        id: subwiki.id,
                        userid: userId,
                        groupid: groupId,
                        groupLabel: '',
                        canedit: subwiki.canedit
                    });
                    allParticipants = true;
                }
            }
            else {
                if (groupId != 0 && userGroupsIds.length > 0) {
                    // Get groupLabel if it has groupId.
                    var groupIdPosition = userGroupsIds.indexOf(groupId);
                    if (groupIdPosition > -1) {
                        groupLabel = userGroups[groupIdPosition].name;
                    }
                }
                else {
                    groupLabel = _this.translate.instant('addon.mod_wiki.notingroup');
                }
                if (userId != 0) {
                    // Get user if it has userId.
                    promises.push(_this.userProvider.getProfile(userId, _this.courseId, true).then(function (user) {
                        subwikiList.push({
                            name: user.fullname,
                            id: subwiki.id,
                            userid: userId,
                            groupid: groupId,
                            groupLabel: groupLabel,
                            canedit: subwiki.canedit
                        });
                    }));
                    if (!multiLevelList && groupId != 0) {
                        multiLevelList = true;
                    }
                }
                else {
                    subwikiList.push({
                        name: groupLabel,
                        id: subwiki.id,
                        userid: userId,
                        groupid: groupId,
                        groupLabel: groupLabel,
                        canedit: subwiki.canedit
                    });
                    showMyGroupsLabel = true;
                }
            }
        });
        return Promise.all(promises).then(function () {
            _this.fillSubwikiData(subwikiList, showMyGroupsLabel, multiLevelList);
        });
    };
    /**
     * Fill the subwiki data.
     *
     * @param {any[]} subwikiList List of subwikis.
     * @param {boolean} showMyGroupsLabel Whether subwikis should be grouped in "My groups" and "Other groups".
     * @param {boolean} multiLevelList Whether it's a multi level list.
     */
    AddonModWikiIndexComponent.prototype.fillSubwikiData = function (subwikiList, showMyGroupsLabel, multiLevelList) {
        var groupValue = -1, grouping;
        subwikiList.sort(function (a, b) {
            return a.groupid - b.groupid;
        });
        this.subwikiData.count = subwikiList.length;
        // If no subwiki is received as view param, select always the most appropiate.
        if ((!this.subwikiId || (!this.userId && !this.groupId)) && !this.isAnySubwikiSelected() && subwikiList.length > 0) {
            var firstCanEdit = void 0, candidateNoFirstPage = void 0, candidateFirstPage = void 0;
            for (var i in subwikiList) {
                var subwiki_1 = subwikiList[i];
                if (subwiki_1.canedit) {
                    var candidateSubwikiId = void 0;
                    if (subwiki_1.userid > 0) {
                        // Check if it's the current user.
                        if (this.currentUserId == subwiki_1.userid) {
                            candidateSubwikiId = subwiki_1.id;
                        }
                    }
                    else if (subwiki_1.groupid > 0) {
                        // Check if it's a current user' group.
                        if (showMyGroupsLabel) {
                            candidateSubwikiId = subwiki_1.id;
                        }
                    }
                    else if (subwiki_1.id > 0) {
                        candidateSubwikiId = subwiki_1.id;
                    }
                    if (typeof candidateSubwikiId != 'undefined') {
                        if (candidateSubwikiId > 0) {
                            // Subwiki found and created, no need to keep looking.
                            candidateFirstPage = i;
                            break;
                        }
                        else if (typeof candidateNoFirstPage == 'undefined') {
                            candidateNoFirstPage = i;
                        }
                    }
                    else if (typeof firstCanEdit == 'undefined') {
                        firstCanEdit = i;
                    }
                }
            }
            var subWikiToTake = void 0;
            if (typeof candidateFirstPage != 'undefined') {
                // Take the candidate that already has the first page created.
                subWikiToTake = candidateFirstPage;
            }
            else if (typeof candidateNoFirstPage != 'undefined') {
                // No first page created, take the first candidate.
                subWikiToTake = candidateNoFirstPage;
            }
            else if (typeof firstCanEdit != 'undefined') {
                // None selected, take the first the user can edit.
                subWikiToTake = firstCanEdit;
            }
            else {
                // Otherwise take the very first.
                subWikiToTake = 0;
            }
            var subwiki = subwikiList[subWikiToTake];
            if (typeof subwiki != 'undefined') {
                this.setSelectedWiki(subwiki.id, subwiki.userid, subwiki.groupid);
            }
        }
        if (multiLevelList) {
            // As we loop over each subwiki, add it to the current group
            for (var i in subwikiList) {
                var subwiki = subwikiList[i];
                // Should we create a new grouping?
                if (subwiki.groupid !== groupValue) {
                    grouping = { label: subwiki.groupLabel, subwikis: [] };
                    groupValue = subwiki.groupid;
                    this.subwikiData.subwikis.push(grouping);
                }
                // Add the subwiki to the currently active grouping.
                grouping.subwikis.push(subwiki);
            }
        }
        else if (showMyGroupsLabel) {
            var noGrouping = { label: '', subwikis: [] }, myGroupsGrouping = { label: this.translate.instant('core.mygroups'), subwikis: [] }, otherGroupsGrouping = { label: this.translate.instant('core.othergroups'), subwikis: [] };
            // As we loop over each subwiki, add it to the current group
            for (var i in subwikiList) {
                var subwiki = subwikiList[i];
                // Add the subwiki to the currently active grouping.
                if (typeof subwiki.canedit == 'undefined') {
                    noGrouping.subwikis.push(subwiki);
                }
                else if (subwiki.canedit) {
                    myGroupsGrouping.subwikis.push(subwiki);
                }
                else {
                    otherGroupsGrouping.subwikis.push(subwiki);
                }
            }
            // Add each grouping to the subwikis
            if (noGrouping.subwikis.length > 0) {
                this.subwikiData.subwikis.push(noGrouping);
            }
            if (myGroupsGrouping.subwikis.length > 0) {
                this.subwikiData.subwikis.push(myGroupsGrouping);
            }
            if (otherGroupsGrouping.subwikis.length > 0) {
                this.subwikiData.subwikis.push(otherGroupsGrouping);
            }
        }
        else {
            this.subwikiData.subwikis.push({ label: '', subwikis: subwikiList });
        }
        this.wikiProvider.setSubwikiList(this.wiki.id, this.subwikiData.subwikis, this.subwikiData.count, this.subwikiData.subwikiSelected, this.subwikiData.userSelected, this.subwikiData.groupSelected);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_9__components_tabs_tabs__["a" /* CoreTabsComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_9__components_tabs_tabs__["a" /* CoreTabsComponent */])
    ], AddonModWikiIndexComponent.prototype, "tabs", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModWikiIndexComponent.prototype, "action", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWikiIndexComponent.prototype, "pageId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModWikiIndexComponent.prototype, "pageTitle", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWikiIndexComponent.prototype, "wikiId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWikiIndexComponent.prototype, "subwikiId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWikiIndexComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWikiIndexComponent.prototype, "groupId", void 0);
    AddonModWikiIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-wiki-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\wiki\components\index\addon-mod-wiki-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <!-- Select subwiki. -->\n    <button ion-button icon-only *ngIf="subwikiData.count > 1" (click)="showSubwikiPicker($event)" [attr.aria-label]="\'addon.mod_wiki.subwiki\' | translate">\n        <ion-icon name="person"></ion-icon>\n    </button>\n\n    <!-- Go to "home". -->\n    <button ion-button icon-only *ngIf="showHomeButton" (click)="goToWikiHome()" [attr.aria-label]="\'addon.mod_wiki.gowikihome\' | translate">\n        <ion-icon name="home"></ion-icon>\n    </button>\n\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline && !pageIsOffline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && isOnline && (hasOffline || pageIsOffline)"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="canEdit && (isOnline || pageIsOffline)" [priority]="590" [content]="\'core.edit\' | translate" iconAction="create" (action)="goToEditPage()"></core-context-menu-item>\n        <core-context-menu-item *ngIf="canEdit" [priority]="580" [content]="\'addon.mod_wiki.createpage\' | translate" iconAction="add" (action)="goToNewPage()"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-tabs [hideUntil]="loaded" [selectedIndex]="selectedTab">\n        <!-- Page contents. -->\n        <core-tab [title]="\'addon.mod_wiki.viewpage\' | translate" icon="document">\n            <ng-template>\n                <div padding class="addon-mod_wiki-page-content">\n                    <core-course-module-description *ngIf="isMainPage" [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n                    <!-- Wiki has something offline. -->\n                    <div class="core-warning-card" icon-start *ngIf="pageIsOffline || hasOffline">\n                        <ion-icon name="warning"></ion-icon>\n                        <span *ngIf="pageIsOffline">{{ \'core.hasdatatosync\' | translate:{$a: pageStr} }}</span>\n                        <span *ngIf="!pageIsOffline">{{ \'core.hasdatatosync\' | translate:{$a: moduleName} }}</span>\n                    </div>\n\n                    <!-- Page warning. -->\n                    <div class="core-warning-card" icon-start *ngIf="pageWarning">\n                        <ion-icon name="warning"></ion-icon>\n                        {{ pageWarning }}\n                    </div>\n\n                    <article [ngClass]="{\'addon-mod_wiki-noedit\': !canEdit}">\n                        <core-format-text *ngIf="pageContent" [component]="component" [componentId]="componentId" [text]="pageContent"></core-format-text>\n                        <core-empty-box *ngIf="!pageContent" icon="document" [message]="\'addon.mod_wiki.nocontent\' | translate" [inline]="true"></core-empty-box>\n                    </article>\n                </div>\n            </ng-template>\n        </core-tab>\n\n        <!-- Map. -->\n        <core-tab [title]="\'addon.mod_wiki.map\' | translate" icon="map">\n            <ng-template>\n                <ion-list>\n                    <ng-container *ngFor="let letter of map">\n                        <ion-item-divider *ngIf="letter.label">\n                            {{ letter.label }}\n                        </ion-item-divider>\n                        <a ion-item text-wrap *ngFor="let page of letter.pages" (click)="goToPage(page)">\n                            {{ page.title }}\n                            <ion-note *ngIf="!page.id" item-end color="danger">{{ \'core.offline\' | translate }}</ion-note>\n                        </a>\n                    </ng-container>\n                </ion-list>\n            </ng-template>\n        </core-tab>\n    </core-tabs>\n\n</core-loading>\n\n<ion-fab core-fab bottom end *ngIf="canEdit">\n    <button ion-fab (click)="goToNewPage()" [attr.aria-label]="\'addon.mod_wiki.createpage\' | translate">\n        <ion-icon name="add"></ion-icon>\n    </button>\n</ion-fab>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\wiki\components\index\addon-mod-wiki-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_6__providers_wiki__["a" /* AddonModWikiProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_7__providers_wiki_offline__["a" /* AddonModWikiOfflineProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__["a" /* AddonModWikiSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["x" /* PopoverController */]])
    ], AddonModWikiIndexComponent);
    return AddonModWikiIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 447 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(152);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sync__ = __webpack_require__(221);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_offline__ = __webpack_require__(133);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};









/**
 * Component that displays a workshop index page.
 */
var AddonModWorkshopIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModWorkshopIndexComponent, _super);
    function AddonModWorkshopIndexComponent(injector, workshopProvider, content, workshopOffline, groupsProvider, navCtrl, modalCtrl, utils, platform, workshopHelper, workshopSync) {
        var _this = _super.call(this, injector, content) || this;
        _this.workshopProvider = workshopProvider;
        _this.workshopOffline = workshopOffline;
        _this.groupsProvider = groupsProvider;
        _this.navCtrl = navCtrl;
        _this.modalCtrl = modalCtrl;
        _this.utils = utils;
        _this.workshopHelper = workshopHelper;
        _this.workshopSync = workshopSync;
        _this.group = 0;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].COMPONENT;
        _this.moduleName = 'workshop';
        _this.page = 0;
        _this.groupInfo = {
            groups: [],
            separateGroups: false,
            visibleGroups: false
        };
        _this.canSubmit = false;
        _this.canAssess = false;
        _this.hasNextPage = false;
        _this.workshopPhases = {
            PHASE_SETUP: __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_SETUP,
            PHASE_SUBMISSION: __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_SUBMISSION,
            PHASE_ASSESSMENT: __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_ASSESSMENT,
            PHASE_EVALUATION: __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_EVALUATION,
            PHASE_CLOSED: __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_CLOSED
        };
        _this.offlineSubmissions = [];
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_7__providers_sync__["a" /* AddonModWorkshopSyncProvider */].AUTO_SYNCED;
        // Listen to submission and assessment changes.
        _this.obsSubmissionChanged = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].SUBMISSION_CHANGED, function (data) {
            _this.eventReceived(data);
        }, _this.siteId);
        // Listen to submission and assessment changes.
        _this.obsAssessmentSaved = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].ASSESSMENT_SAVED, function (data) {
            _this.eventReceived(data);
        }, _this.siteId);
        // Since most actions will take the user out of the app, we should refresh the view when the app is resumed.
        _this.appResumeSubscription = platform.resume.subscribe(function () {
            _this.showLoadingAndRefresh(true);
        });
        // Refresh workshop on sync.
        _this.syncObserver = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__providers_sync__["a" /* AddonModWorkshopSyncProvider */].AUTO_SYNCED, function (data) {
            // Update just when all database is synced.
            _this.eventReceived(data);
        }, _this.siteId);
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModWorkshopIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.loadContent(false, true).then(function () {
            if (!_this.workshop) {
                return;
            }
            _this.workshopProvider.logView(_this.workshop.id, _this.workshop.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function (error) {
                // Ignore errors.
            });
        });
    };
    /**
     * Function called when we receive an event of submission changes.
     *
     * @param {any} data Data received by the event.
     */
    AddonModWorkshopIndexComponent.prototype.eventReceived = function (data) {
        if ((this.workshop && this.workshop.id === data.workshopId) || data.cmId === this.module.id) {
            this.showLoadingAndRefresh(true);
            // Check completion since it could be configured to complete once the user adds a new discussion or replies.
            this.courseProvider.checkModuleCompletion(this.courseId, this.module.completiondata);
        }
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModWorkshopIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.workshopProvider.invalidateWorkshopData(this.courseId));
        if (this.workshop) {
            promises.push(this.workshopProvider.invalidateWorkshopAccessInformationData(this.workshop.id));
            promises.push(this.workshopProvider.invalidateUserPlanPhasesData(this.workshop.id));
            if (this.canSubmit) {
                promises.push(this.workshopProvider.invalidateSubmissionsData(this.workshop.id));
            }
            if (this.access.canviewallsubmissions) {
                promises.push(this.workshopProvider.invalidateGradeReportData(this.workshop.id));
                promises.push(this.groupsProvider.invalidateActivityAllowedGroups(this.workshop.coursemodule));
                promises.push(this.groupsProvider.invalidateActivityGroupMode(this.workshop.coursemodule));
            }
            if (this.canAssess) {
                promises.push(this.workshopProvider.invalidateReviewerAssesmentsData(this.workshop.id));
            }
            promises.push(this.workshopProvider.invalidateGradesData(this.workshop.id));
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean}          True if refresh is needed, false otherwise.
     */
    AddonModWorkshopIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (this.workshop && syncEventData.workshopId == this.workshop.id) {
            // Refresh the data.
            this.domUtils.scrollToTop(this.content);
            return true;
        }
        return false;
    };
    /**
     * Download feedback contents.
     *
     * @param  {boolean}      [refresh=false]    If it's refreshing content.
     * @param  {boolean}      [sync=false]       If it should try to sync.
     * @param  {boolean}      [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWorkshopIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        return this.workshopProvider.getWorkshop(this.courseId, this.module.id).then(function (workshop) {
            _this.workshop = workshop;
            _this.description = workshop.intro || workshop.description;
            _this.dataRetrieved.emit(workshop);
            if (sync) {
                // Try to synchronize the feedback.
                return _this.syncActivity(showErrors);
            }
        }).then(function () {
            // Check if there are answers stored in offline.
            return _this.workshopProvider.getWorkshopAccessInformation(_this.workshop.id);
        }).then(function (accessData) {
            _this.access = accessData;
            if (accessData.canviewallsubmissions) {
                return _this.groupsProvider.getActivityGroupInfo(_this.workshop.coursemodule, accessData.canviewallsubmissions).then(function (groupInfo) {
                    _this.groupInfo = groupInfo;
                    // Check selected group is accessible.
                    if (groupInfo && groupInfo.groups && groupInfo.groups.length > 0) {
                        var found = groupInfo.groups.some(function (group) {
                            return group.id == _this.group;
                        });
                        if (!found) {
                            _this.group = groupInfo.groups[0].id;
                        }
                    }
                });
            }
        }).then(function () {
            return _this.workshopProvider.getUserPlanPhases(_this.workshop.id);
        }).then(function (phases) {
            _this.phases = phases;
            phases[_this.workshop.phase].tasks.forEach(function (task) {
                if (!task.link && (task.code == 'examples' || task.code == 'prepareexamples')) {
                    // Add links to manage examples.
                    task.link = _this.externalUrl;
                }
            });
            // Check if there are info stored in offline.
            return _this.workshopOffline.hasWorkshopOfflineData(_this.workshop.id).then(function (hasOffline) {
                _this.hasOffline = hasOffline;
                if (hasOffline) {
                    return _this.workshopOffline.getSubmissions(_this.workshop.id).then(function (submissionsActions) {
                        _this.offlineSubmissions = submissionsActions;
                    });
                }
                else {
                    _this.offlineSubmissions = [];
                }
            });
        }).then(function () {
            return _this.setPhaseInfo();
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        });
    };
    /**
     * Retrieves and shows submissions grade page.
     *
     * @param  {number}       page Page number to be retrieved.
     * @return {Promise<any>}      Resolved when done.
     */
    AddonModWorkshopIndexComponent.prototype.gotoSubmissionsPage = function (page) {
        var _this = this;
        return this.workshopProvider.getGradesReport(this.workshop.id, this.group, page).then(function (report) {
            var numEntries = (report && report.grades && report.grades.length) || 0;
            _this.page = page;
            _this.hasNextPage = numEntries >= __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PER_PAGE && ((_this.page + 1) *
                __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PER_PAGE) < report.totalcount;
            _this.grades = report.grades || [];
            _this.grades.forEach(function (submission) {
                var actions = _this.workshopHelper.filterSubmissionActions(_this.offlineSubmissions, submission.submissionid
                    || false);
                submission = _this.workshopHelper.applyOfflineData(submission, actions);
                return _this.workshopHelper.applyOfflineData(submission, actions).then(function (offlineSubmission) {
                    submission = offlineSubmission;
                });
            });
        });
    };
    /**
     * Open task.
     *
     * @param {any} task Task to be done.
     */
    AddonModWorkshopIndexComponent.prototype.runTask = function (task) {
        if (task.code == 'submit') {
            this.gotoSubmit();
        }
        else if (task.link) {
            this.utils.openInBrowser(task.link);
        }
    };
    /**
     * Go to submit page.
     */
    AddonModWorkshopIndexComponent.prototype.gotoSubmit = function () {
        if (this.canSubmit && ((this.access.creatingsubmissionallowed && !this.submission) ||
            (this.access.modifyingsubmissionallowed && this.submission))) {
            var params = {
                module: this.module,
                access: this.access,
                courseId: this.courseId,
                submissionId: this.submission && this.submission.id
            };
            this.navCtrl.push('AddonModWorkshopEditSubmissionPage', params);
        }
    };
    /**
     * View Phase info.
     */
    AddonModWorkshopIndexComponent.prototype.viewPhaseInfo = function () {
        var _this = this;
        if (this.phases) {
            var modal = this.modalCtrl.create('AddonModWorkshopPhaseInfoPage', {
                phases: this.utils.objectToArray(this.phases),
                workshopPhase: this.workshop.phase,
                externalUrl: this.externalUrl
            });
            modal.onDidDismiss(function (goSubmit) {
                goSubmit && _this.gotoSubmit();
            });
            modal.present();
        }
    };
    /**
     * Set group to see the workshop.
     * @param {number} groupId Group Id.
     * @return {Promise<any>}  Promise resolved when done.
     */
    AddonModWorkshopIndexComponent.prototype.setGroup = function (groupId) {
        this.group = groupId;
        return this.gotoSubmissionsPage(0);
    };
    /**
     * Convenience function to set current phase information.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWorkshopIndexComponent.prototype.setPhaseInfo = function () {
        var _this = this;
        this.submission = false;
        this.canAssess = false;
        this.assessments = false;
        this.userGrades = false;
        this.publishedSubmissions = false;
        this.canSubmit = this.workshopHelper.canSubmit(this.workshop, this.access, this.phases[__WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_SUBMISSION].tasks);
        var promises = [];
        if (this.canSubmit) {
            promises.push(this.workshopHelper.getUserSubmission(this.workshop.id).then(function (submission) {
                var actions = _this.workshopHelper.filterSubmissionActions(_this.offlineSubmissions, submission.id || false);
                return _this.workshopHelper.applyOfflineData(submission, actions).then(function (submission) {
                    _this.submission = submission;
                });
            }));
        }
        if (this.access.canviewallsubmissions && this.workshop.phase >= __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_SUBMISSION) {
            promises.push(this.gotoSubmissionsPage(this.page));
        }
        var assessPromise = Promise.resolve();
        if (this.workshop.phase >= __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_ASSESSMENT) {
            this.canAssess = this.workshopHelper.canAssess(this.workshop, this.access);
            if (this.canAssess) {
                assessPromise = this.workshopHelper.getReviewerAssessments(this.workshop.id).then(function (assessments) {
                    var p2 = [];
                    assessments.forEach(function (assessment) {
                        assessment.strategy = _this.workshop.strategy;
                        if (_this.hasOffline) {
                            p2.push(_this.workshopOffline.getAssessment(_this.workshop.id, assessment.id)
                                .then(function (offlineAssessment) {
                                assessment.offline = true;
                                assessment.timemodified = Math.floor(offlineAssessment.timemodified / 1000);
                            }).catch(function () {
                                // Ignore errors.
                            }));
                        }
                    });
                    return Promise.all(p2).then(function () {
                        _this.assessments = assessments;
                    });
                });
                promises.push(assessPromise);
            }
        }
        if (this.workshop.phase == __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_CLOSED) {
            promises.push(this.workshopProvider.getGrades(this.workshop.id).then(function (grades) {
                _this.userGrades = grades.submissionlongstrgrade || grades.assessmentlongstrgrade ? grades : false;
            }));
            if (this.access.canviewpublishedsubmissions) {
                promises.push(assessPromise.then(function () {
                    return _this.workshopProvider.getSubmissions(_this.workshop.id).then(function (submissions) {
                        _this.publishedSubmissions = submissions.filter(function (submission) {
                            if (submission.published) {
                                _this.assessments.forEach(function (assessment) {
                                    submission.reviewedby = [];
                                    if (assessment.submissionid == submission.id) {
                                        submission.reviewedby.push(_this.workshopHelper.realGradeValue(_this.workshop, assessment));
                                    }
                                });
                                return true;
                            }
                            return false;
                        });
                    });
                }));
            }
        }
        return Promise.all(promises);
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWorkshopIndexComponent.prototype.sync = function () {
        return this.workshopSync.syncWorkshop(this.workshop.id);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any}     result Data returned on the sync function.
     * @return {boolean}        If suceed or not.
     */
    AddonModWorkshopIndexComponent.prototype.hasSyncSucceed = function (result) {
        return result.updated;
    };
    /**
     * Component being destroyed.
     */
    AddonModWorkshopIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.obsSubmissionChanged && this.obsSubmissionChanged.off();
        this.obsAssessmentSaved && this.obsAssessmentSaved.off();
        this.appResumeSubscription && this.appResumeSubscription.unsubscribe();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopIndexComponent.prototype, "group", void 0);
    AddonModWorkshopIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\index\addon-mod-workshop-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !hasOffline && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && hasOffline && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="500" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="400" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <core-course-module-description *ngIf="description" [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <ion-card class="with-borders" *ngIf="phases">\n        <a ion-item (click)="viewPhaseInfo()">\n            <h2 stacked text-wrap>{{ phases[workshop.phase].title }}</h2>\n        </a>\n        <ng-container *ngIf="phases && phases[workshop.phase] && phases[workshop.phase].tasks && phases[workshop.phase].tasks.length">\n            <a ion-item text-wrap *ngFor="let task of phases[workshop.phase].tasks" (click)="runTask(task)" detail-none>\n                <ion-icon item-start name="radio-button-off" *ngIf="task.completed == null"></ion-icon>\n                <ion-icon item-start name="close-circle" color="danger" *ngIf="task.completed == \'\'"></ion-icon>\n                <ion-icon item-start name="information-circle" color="info" *ngIf="task.completed == \'info\'"></ion-icon>\n                <ion-icon item-start name="checkmark-circle" color="success" *ngIf="task.completed == \'1\'"></ion-icon>\n\n                <h2>{{task.title}}</h2>\n                <p *ngIf="task.details"><core-format-text [text]="task.details"></core-format-text></p>\n                <ion-icon item-end *ngIf="task.link && task.code != \'submit\'" name="open"></ion-icon>\n            </a>\n        </ng-container>\n    </ion-card>\n\n    <!-- Has something offline. -->\n    <div class="core-warning-card" icon-start *ngIf="hasOffline">\n        <ion-icon name="warning"></ion-icon>\n        {{ \'core.hasdatatosync\' | translate: {$a: moduleName} }}\n    </div>\n\n    <div *ngIf="access && workshop && workshop.phase >= workshopPhases.PHASE_SUBMISSION">\n        <!-- CLOSED PHASE -->\n        <ng-container *ngIf="workshop.phase >= workshopPhases.PHASE_CLOSED">\n            <ion-card *ngIf="workshop.conclusion">\n                <ion-item text-wrap>\n                    <h2>{{ \'addon.mod_workshop.conclusion\' | translate }}</h2>\n                    <core-format-text fullOnClick="true" [component]="component" [componentId]="workshop.cmid" [text]="workshop.conclusion"></core-format-text>\n                </ion-item>\n            </ion-card>\n\n            <ion-card class="with-borders" *ngIf="userGrades">\n                <ion-item-divider text-wrap>\n                    <h2>{{ \'addon.mod_workshop.yourgrades\' | translate }}</h2>\n                </ion-item-divider>\n                <ion-item text-wrap *ngIf="userGrades.submissionlongstrgrade">\n                    <h2>{{ \'addon.mod_workshop.submissiongrade\' | translate }}</h2>\n                    <core-format-text [text]="userGrades.submissionlongstrgrade"></core-format-text>\n                </ion-item>\n                <ion-item text-wrap *ngIf="userGrades.assessmentlongstrgrade">\n                    <h2>{{ \'addon.mod_workshop.gradinggrade\' | translate }}</h2>\n                    <core-format-text [text]="userGrades.assessmentlongstrgrade"></core-format-text>\n                </ion-item>\n            </ion-card>\n        </ng-container>\n\n        <!-- SUBMISSION PHASE -->\n        <ion-card *ngIf="workshop.phase == workshopPhases.PHASE_SUBMISSION && workshop.instructauthors">\n            <ion-item text-wrap>\n                <h2>{{ \'addon.mod_workshop.areainstructauthors\' | translate }}</h2>\n                <core-format-text fullOnClick="true" [component]="component" [componentId]="workshop.cmid" [text]="workshop.instructauthors"></core-format-text>\n            </ion-item>\n        </ion-card>\n\n        <ion-card *ngIf="canSubmit">\n            <ion-item text-wrap *ngIf="!submission">\n                <h2>{{ \'addon.mod_workshop.yoursubmission\' | translate }}</h2>\n                <p>{{ \'addon.mod_workshop.noyoursubmission\' | translate }}</p>\n            </ion-item>\n\n            <ng-container *ngIf="submission">\n                <ion-item-divider text-wrap>\n                    <h2>{{ \'addon.mod_workshop.yoursubmission\' | translate }}</h2>\n                </ion-item-divider>\n                <addon-mod-workshop-submission [submission]="submission" [courseId]="workshop.course" [module]="module" [workshop]="workshop" [access]="access"></addon-mod-workshop-submission>\n            </ng-container>\n        </ion-card>\n\n        <!-- Show only on current phase -->\n        <ng-container *ngIf="workshop.phase == workshopPhases.PHASE_SUBMISSION">\n            <ion-item text-wrap *ngIf="canSubmit && ((access.creatingsubmissionallowed && !submission) || (access.modifyingsubmissionallowed && submission))">\n                <button ion-button icon-start block *ngIf="access.creatingsubmissionallowed && !submission" (click)="gotoSubmit()">\n                    <ion-icon name="add"></ion-icon>\n                    {{ \'addon.mod_workshop.createsubmission\' | translate }}\n                </button>\n                <button ion-button icon-start block *ngIf="access.modifyingsubmissionallowed && submission" (click)="gotoSubmit()">\n                    <ion-icon name="create"></ion-icon>\n                    {{ \'addon.mod_workshop.editsubmission\' | translate }}\n                </button>\n            </ion-item>\n        </ng-container>\n\n        <ng-container *ngIf="workshop.phase >= workshopPhases.PHASE_CLOSED">\n            <ion-card class="with-borders" *ngIf="publishedSubmissions && publishedSubmissions.length">\n                <ion-item-divider text-wrap>\n                    <h2>{{ \'addon.mod_workshop.publishedsubmissions\' | translate }}</h2>\n                </ion-item-divider>\n                <ng-container *ngFor="let submission of publishedSubmissions">\n                    <addon-mod-workshop-submission [submission]="submission" [courseId]="workshop.course" [module]="module" [workshop]="workshop" [access]="access" summary="true"></addon-mod-workshop-submission>\n                </ng-container>\n            </ion-card>\n        </ng-container>\n\n        <!-- ASSESSMENT PHASE -->\n        <ng-container *ngIf="workshop.phase >= workshopPhases.PHASE_ASSESSMENT">\n            <ion-card *ngIf="workshop.phase == workshopPhases.PHASE_ASSESSMENT && workshop.instructreviewers">\n                <ion-item text-wrap>\n                    <h2>{{ \'addon.mod_workshop.areainstructreviewers\' | translate }}</h2>\n                    <core-format-text fullOnClick="true" [component]="component" [componentId]="workshop.cmid" [text]="workshop.instructreviewers"></core-format-text>\n                </ion-item>\n            </ion-card>\n\n            <ion-card class="with-borders" *ngIf="canAssess">\n                <ion-item-divider text-wrap>\n                    <h2>{{ \'addon.mod_workshop.assignedassessments\' | translate }}</h2>\n                </ion-item-divider>\n                <ion-item text-wrap *ngIf="!assessments || !assessments.length">\n                    <p>{{ \'addon.mod_workshop.assignedassessmentsnone\' | translate }}</p>\n                </ion-item>\n                <ng-container *ngFor="let assessment of (assessments || [])">\n                    <addon-mod-workshop-submission [submission]="assessment.submission" [assessment]="assessment" [courseId]="workshop.course" [module]="module" [workshop]="workshop" [access]="access" summary="true"></addon-mod-workshop-submission>\n                </ng-container>\n            </ion-card >\n        </ng-container>\n\n        <!-- MULTIPLE PHASES SUBMISSION OR GREATER only teachers -->\n        <ion-card class="with-borders" *ngIf="access.canviewallsubmissions && workshop.phase >= workshopPhases.PHASE_SUBMISSION && ((grades && grades.length) || (groupInfo && (groupInfo.separateGroups || groupInfo.visibleGroups)))">\n            <ion-item-divider text-wrap *ngIf="workshop.phase == workshopPhases.PHASE_SUBMISSION">\n                <h2>{{ \'addon.mod_workshop.submissionsreport\' | translate }}</h2>\n            </ion-item-divider>\n           <ion-item-divider text-wrap *ngIf="workshop.phase > workshopPhases.PHASE_SUBMISSION">\n                <h2>{{ \'addon.mod_workshop.gradesreport\' | translate }}</h2>\n            </ion-item-divider>\n            <ion-item text-wrap *ngIf="groupInfo && (groupInfo.separateGroups || groupInfo.visibleGroups)">\n                <ion-label id="addon-workshop-groupslabel" *ngIf="groupInfo.separateGroups">{{ \'core.groupsseparate\' | translate }}</ion-label>\n                <ion-label id="addon-workshop-groupslabel" *ngIf="groupInfo.visibleGroups">{{ \'core.groupsvisible\' | translate }}</ion-label>\n                <ion-select [(ngModel)]="selectedGroup" (ionChange)="setGroup(selectedGroup)" aria-labelledby="addon-workshop-groupslabel" interface="action-sheet">\n                    <ion-option *ngFor="let groupOpt of groupInfo.groups" [value]="groupOpt.id">{{groupOpt.name}}</ion-option>\n                </ion-select>\n            </ion-item>\n\n            <ng-container *ngFor="let submission of grades">\n                <addon-mod-workshop-submission [submission]="submission" [courseId]="workshop.course" [module]="module" [workshop]="workshop" [access]="access" summary="true"></addon-mod-workshop-submission>\n            </ng-container>\n\n            <ion-grid *ngIf="page > 0 || hasNextPage">\n                <ion-row align-items-center>\n                    <ion-col *ngIf="page > 0">\n                        <button ion-button block outline icon-start (click)="gotoSubmissionsPage(page - 1)">\n                            <ion-icon name="arrow-back" md="ios-arrow-back"></ion-icon>\n                            {{ \'core.previous\' | translate }}\n                        </button>\n                    </ion-col>\n                    <ion-col *ngIf="hasNextPage">\n                        <button ion-button block icon-end (click)="gotoSubmissionsPage(page + 1)">\n                            {{ \'core.next\' | translate }}\n                            <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n                        </button>\n                    </ion-col>\n                </ion-row>\n            </ion-grid>\n        </ion-card>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\index\addon-mod-workshop-index.html"*/,
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_5__providers_workshop__["a" /* AddonModWorkshopProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_8__providers_offline__["a" /* AddonModWorkshopOfflineProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModWorkshopHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_sync__["a" /* AddonModWorkshopSyncProvider */]])
    ], AddonModWorkshopIndexComponent);
    return AddonModWorkshopIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 448 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotificationsHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__notifications__ = __webpack_require__(170);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Service that provides some helper functions for notifications.
 */
var AddonNotificationsHelperProvider = /** @class */ (function () {
    function AddonNotificationsHelperProvider(notificationsProvider, sitesProvider) {
        this.notificationsProvider = notificationsProvider;
        this.sitesProvider = sitesProvider;
    }
    /**
     * Get some notifications. It will try to use the new WS if available.
     *
     * @param {any[]} notifications Current list of loaded notifications. It's used to calculate the offset.
     * @param {number} [limit] Number of notifications to get. Defaults to LIST_LIMIT.
     * @param {boolean} [toDisplay=true] True if notifications will be displayed to the user, either in view or in a notification.
     * @param {boolean} [forceCache] True if it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<{notifications: any[], canLoadMore: boolean}>} Promise resolved with notifications and if can load more.
     */
    AddonNotificationsHelperProvider.prototype.getNotifications = function (notifications, limit, toDisplay, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (toDisplay === void 0) { toDisplay = true; }
        notifications = notifications || [];
        limit = limit || __WEBPACK_IMPORTED_MODULE_2__notifications__["a" /* AddonNotificationsProvider */].LIST_LIMIT;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.notificationsProvider.isPopupAvailable(siteId).then(function (available) {
            if (available) {
                return _this.notificationsProvider.getPopupNotifications(notifications.length, limit, toDisplay, forceCache, ignoreCache, siteId);
            }
            else {
                // Fallback to get_messages. We need 2 calls, one for read and the other one for unread.
                var unreadFrom_1 = notifications.reduce(function (total, current) {
                    return total + (current.read ? 0 : 1);
                }, 0);
                return _this.notificationsProvider.getUnreadNotifications(unreadFrom_1, limit, toDisplay, forceCache, ignoreCache, siteId).then(function (unread) {
                    var promise;
                    if (unread.length < limit) {
                        // Limit not reached. Get read notifications until reach the limit.
                        var readLimit = limit - unread.length, readFrom = notifications.length - unreadFrom_1;
                        promise = _this.notificationsProvider.getReadNotifications(readFrom, readLimit, toDisplay, forceCache, ignoreCache, siteId).then(function (read) {
                            return unread.concat(read);
                        }).catch(function (error) {
                            if (unread.length > 0) {
                                // We were able to get some unread, return only the unread ones.
                                return unread;
                            }
                            return Promise.reject(error);
                        });
                    }
                    else {
                        promise = Promise.resolve(unread);
                    }
                    return promise.then(function (notifications) {
                        return {
                            notifications: notifications,
                            canLoadMore: notifications.length >= limit
                        };
                    });
                });
            }
        });
    };
    AddonNotificationsHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__notifications__["a" /* AddonNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonNotificationsHelperProvider);
    return AddonNotificationsHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 449 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_classes_main_activity_component__ = __webpack_require__(84);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_comments_providers_comments__ = __webpack_require__(134);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_rating_providers_rating__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_rating_providers_sync__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_helper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_sync__ = __webpack_require__(230);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__components_module__ = __webpack_require__(412);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_prefetch_handler__ = __webpack_require__(882);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};














/**
 * Component that displays a data index page.
 */
var AddonModDataIndexComponent = /** @class */ (function (_super) {
    __extends(AddonModDataIndexComponent, _super);
    function AddonModDataIndexComponent(injector, content, dataProvider, dataHelper, prefetchHandler, timeUtils, groupsProvider, commentsProvider, modalCtrl, utils, navCtrl) {
        var _this = _super.call(this, injector, content) || this;
        _this.dataProvider = dataProvider;
        _this.dataHelper = dataHelper;
        _this.prefetchHandler = prefetchHandler;
        _this.timeUtils = timeUtils;
        _this.groupsProvider = groupsProvider;
        _this.commentsProvider = commentsProvider;
        _this.modalCtrl = modalCtrl;
        _this.utils = utils;
        _this.navCtrl = navCtrl;
        _this.component = __WEBPACK_IMPORTED_MODULE_9__providers_data__["a" /* AddonModDataProvider */].COMPONENT;
        _this.moduleName = 'data';
        _this.access = {};
        _this.data = {};
        _this.isEmpty = false;
        _this.entries = [];
        _this.firstEntry = false;
        _this.canAdd = false;
        _this.canSearch = false;
        _this.search = {
            sortBy: '0',
            sortDirection: 'DESC',
            page: 0,
            text: '',
            searching: false,
            searchingAdvanced: false,
            advanced: []
        };
        _this.hasNextPage = false;
        _this.entriesRendered = '';
        _this.extraImports = [__WEBPACK_IMPORTED_MODULE_12__components_module__["a" /* AddonModDataComponentsModule */]];
        _this.syncEventName = __WEBPACK_IMPORTED_MODULE_11__providers_sync__["a" /* AddonModDataSyncProvider */].AUTO_SYNCED;
        _this.hasComments = false;
        // Refresh entries on change.
        _this.entryChangedObserver = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_9__providers_data__["a" /* AddonModDataProvider */].ENTRY_CHANGED, function (eventData) {
            if (_this.data.id == eventData.dataId) {
                _this.loaded = false;
                return _this.loadContent(true);
            }
        }, _this.siteId);
        // Listen for offline ratings saved and synced.
        _this.ratingOfflineObserver = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__core_rating_providers_rating__["a" /* CoreRatingProvider */].RATING_SAVED_EVENT, function (data) {
            if (_this.data && data.component == 'mod_data' && data.ratingArea == 'entry' && data.contextLevel == 'module'
                && data.instanceId == _this.data.coursemodule) {
                _this.hasOfflineRatings = true;
            }
        });
        _this.ratingSyncObserver = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_8__core_rating_providers_sync__["a" /* CoreRatingSyncProvider */].SYNCED_EVENT, function (data) {
            if (_this.data && data.component == 'mod_data' && data.ratingArea == 'entry' && data.contextLevel == 'module'
                && data.instanceId == _this.data.coursemodule) {
                _this.hasOfflineRatings = false;
            }
        });
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModDataIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.selectedGroup = this.group || 0;
        this.loadContent(false, true).then(function () {
            if (!_this.data) {
                return;
            }
            _this.dataProvider.logView(_this.data.id, _this.data.name).then(function () {
                _this.courseProvider.checkModuleCompletion(_this.courseId, _this.module.completiondata);
            }).catch(function () {
                // Ignore errors.
            });
        });
        // Setup search modal.
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonModDataIndexComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.dataProvider.invalidateDatabaseData(this.courseId));
        if (this.data) {
            promises.push(this.dataProvider.invalidateDatabaseAccessInformationData(this.data.id));
            promises.push(this.groupsProvider.invalidateActivityGroupInfo(this.data.coursemodule));
            promises.push(this.dataProvider.invalidateEntriesData(this.data.id));
            if (this.hasComments) {
                promises.push(this.commentsProvider.invalidateCommentsByInstance('module', this.data.coursemodule));
            }
        }
        return Promise.all(promises);
    };
    /**
     * Compares sync event data with current data to check if refresh content is needed.
     *
     * @param {any} syncEventData Data receiven on sync observer.
     * @return {boolean}          True if refresh is needed, false otherwise.
     */
    AddonModDataIndexComponent.prototype.isRefreshSyncNeeded = function (syncEventData) {
        if (this.data && syncEventData.dataId == this.data.id && typeof syncEventData.entryId == 'undefined') {
            this.loaded = false;
            // Refresh the data.
            this.domUtils.scrollToTop(this.content);
            return true;
        }
        return false;
    };
    /**
     * Download data contents.
     *
     * @param  {boolean}      [refresh=false]    If it's refreshing content.
     * @param  {boolean}      [sync=false]       If it should try to sync.
     * @param  {boolean}      [showErrors=false] If show errors to the user of hide them.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModDataIndexComponent.prototype.fetchContent = function (refresh, sync, showErrors) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        if (sync === void 0) { sync = false; }
        if (showErrors === void 0) { showErrors = false; }
        var canAdd = false, canSearch = false;
        return this.dataProvider.getDatabase(this.courseId, this.module.id).then(function (data) {
            _this.data = data;
            _this.description = data.intro || data.description;
            _this.dataRetrieved.emit(data);
            if (sync) {
                // Try to synchronize the data.
                return _this.syncActivity(showErrors).catch(function () {
                    // Ignore errors.
                });
            }
        }).then(function () {
            return _this.dataProvider.getDatabaseAccessInformation(_this.data.id);
        }).then(function (accessData) {
            _this.access = accessData;
            if (!accessData.timeavailable) {
                var time = _this.timeUtils.timestamp();
                _this.timeAvailableFrom = _this.data.timeavailablefrom && time < _this.data.timeavailablefrom ?
                    parseInt(_this.data.timeavailablefrom, 10) * 1000 : false;
                _this.timeAvailableFromReadable = _this.timeAvailableFrom ? _this.timeUtils.userDate(_this.timeAvailableFrom) : false;
                _this.timeAvailableTo = _this.data.timeavailableto && time > _this.data.timeavailableto ?
                    parseInt(_this.data.timeavailableto, 10) * 1000 : false;
                _this.timeAvailableToReadable = _this.timeAvailableTo ? _this.timeUtils.userDate(_this.timeAvailableTo) : false;
                _this.isEmpty = true;
                _this.groupInfo = null;
                return;
            }
            canSearch = true;
            canAdd = accessData.canaddentry;
            return _this.groupsProvider.getActivityGroupInfo(_this.data.coursemodule, accessData.canmanageentries)
                .then(function (groupInfo) {
                _this.groupInfo = groupInfo;
                // Check selected group is accessible.
                if (groupInfo && groupInfo.groups && groupInfo.groups.length > 0) {
                    if (!groupInfo.groups.some(function (group) { return _this.selectedGroup == group.id; })) {
                        _this.selectedGroup = groupInfo.groups[0].id;
                    }
                }
            });
        }).then(function () {
            return _this.dataProvider.getFields(_this.data.id).then(function (fields) {
                if (fields.length == 0) {
                    canSearch = false;
                    canAdd = false;
                }
                _this.search.advanced = [];
                _this.fields = _this.utils.arrayToObject(fields, 'id');
                _this.fieldsArray = _this.utils.objectToArray(_this.fields);
                return _this.fetchEntriesData();
            });
        }).then(function () {
            // All data obtained, now fill the context menu.
            _this.fillContextMenu(refresh);
        }).finally(function () {
            _this.canAdd = canAdd;
            _this.canSearch = canSearch;
        });
    };
    /**
     * Fetch current database entries.
     *
     * @return {Promise<any>} Resolved then done.
     */
    AddonModDataIndexComponent.prototype.fetchEntriesData = function () {
        var _this = this;
        this.hasComments = false;
        return this.dataProvider.getDatabaseAccessInformation(this.data.id, this.selectedGroup).then(function (accessData) {
            // Update values for current group.
            _this.access.canaddentry = accessData.canaddentry;
            var search = _this.search.searching && !_this.search.searchingAdvanced ? _this.search.text : undefined;
            var advSearch = _this.search.searching && _this.search.searchingAdvanced ? _this.search.advanced : undefined;
            return _this.dataHelper.fetchEntries(_this.data, _this.fieldsArray, _this.selectedGroup, search, advSearch, _this.search.sortBy, _this.search.sortDirection, _this.search.page);
        }).then(function (entries) {
            var numEntries = entries.entries.length;
            var numOfflineEntries = entries.offlineEntries.length;
            _this.isEmpty = !numEntries && !entries.offlineEntries.length;
            _this.hasNextPage = numEntries >= __WEBPACK_IMPORTED_MODULE_9__providers_data__["a" /* AddonModDataProvider */].PER_PAGE && ((_this.search.page + 1) *
                __WEBPACK_IMPORTED_MODULE_9__providers_data__["a" /* AddonModDataProvider */].PER_PAGE) < entries.totalcount;
            _this.hasOffline = entries.hasOfflineActions;
            _this.hasOfflineRatings = entries.hasOfflineRatings;
            _this.entriesRendered = '';
            if (typeof entries.maxcount != 'undefined') {
                _this.foundRecordsData = {
                    num: entries.totalcount,
                    max: entries.maxcount,
                    reseturl: '#'
                };
            }
            else {
                _this.foundRecordsData = undefined;
            }
            if (!_this.isEmpty) {
                _this.entries = entries.offlineEntries.concat(entries.entries);
                var entriesHTML_1 = _this.data.listtemplateheader || '';
                // Get first entry from the whole list.
                if (!_this.search.searching || !_this.firstEntry) {
                    _this.firstEntry = _this.entries[0].id;
                }
                var template_1 = _this.data.listtemplate || _this.dataHelper.getDefaultTemplate('list', _this.fieldsArray);
                var entriesById_1 = {};
                _this.entries.forEach(function (entry, index) {
                    entriesById_1[entry.id] = entry;
                    var actions = _this.dataHelper.getActions(_this.data, _this.access, entry);
                    var offset = _this.search.searching ? undefined :
                        _this.search.page * __WEBPACK_IMPORTED_MODULE_9__providers_data__["a" /* AddonModDataProvider */].PER_PAGE + index - numOfflineEntries;
                    entriesHTML_1 += _this.dataHelper.displayShowFields(template_1, _this.fieldsArray, entry, offset, 'list', actions);
                });
                entriesHTML_1 += _this.data.listtemplatefooter || '';
                _this.entriesRendered = entriesHTML_1;
                // Pass the input data to the component.
                _this.jsData = {
                    fields: _this.fields,
                    entries: entriesById_1,
                    data: _this.data,
                    module: _this.module,
                    group: _this.selectedGroup,
                    gotoEntry: _this.gotoEntry.bind(_this)
                };
            }
            else if (!_this.search.searching) {
                // Empty and no searching.
                _this.canSearch = false;
            }
            _this.firstEntry = false;
        });
    };
    /**
     * Display the chat users modal.
     */
    AddonModDataIndexComponent.prototype.showSearch = function () {
        var _this = this;
        var modal = this.modalCtrl.create('AddonModDataSearchPage', {
            search: this.search,
            fields: this.fields,
            data: this.data
        });
        modal.onDidDismiss(function (data) {
            // Add data to search object.
            if (data) {
                _this.search = data;
                _this.searchEntries(0);
            }
        });
        modal.present();
    };
    /**
     * Performs the search and closes the modal.
     *
     * @param  {number}       page Page number.
     * @return {Promise<any>}      Resolved when done.
     */
    AddonModDataIndexComponent.prototype.searchEntries = function (page) {
        var _this = this;
        this.loaded = false;
        this.search.page = page;
        return this.fetchEntriesData().catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'core.course.errorgetmodule', true);
        }).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Reset all search filters and closes the modal.
     */
    AddonModDataIndexComponent.prototype.searchReset = function () {
        this.search.sortBy = '0';
        this.search.sortDirection = 'DESC';
        this.search.text = '';
        this.search.advanced = [];
        this.search.searchingAdvanced = false;
        this.search.searching = false;
        this.searchEntries(0);
    };
    /**
     * Set group to see the database.
     *
     * @param  {number}       groupId Group ID.
     * @return {Promise<any>}         Resolved when new group is selected or rejected if not.
     */
    AddonModDataIndexComponent.prototype.setGroup = function (groupId) {
        var _this = this;
        this.selectedGroup = groupId;
        this.search.page = 0;
        return this.fetchEntriesData().catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'core.course.errorgetmodule', true);
            return Promise.reject(null);
        });
    };
    /**
     * Opens add entries form.
     */
    AddonModDataIndexComponent.prototype.gotoAddEntries = function () {
        var params = {
            module: this.module,
            courseId: this.courseId,
            group: this.selectedGroup
        };
        this.navCtrl.push('AddonModDataEditPage', params);
    };
    /**
     * Goto the selected entry.
     *
     * @param {number} entryId Entry ID.
     */
    AddonModDataIndexComponent.prototype.gotoEntry = function (entryId) {
        var params = {
            module: this.module,
            courseId: this.courseId,
            entryId: entryId,
            group: this.selectedGroup,
            offset: null
        };
        // Try to find page number and offset of the entry.
        var pageXOffset = this.entries.findIndex(function (entry) { return entry.id == entryId; });
        if (pageXOffset >= 0) {
            params.offset = this.search.page * __WEBPACK_IMPORTED_MODULE_9__providers_data__["a" /* AddonModDataProvider */].PER_PAGE + pageXOffset;
        }
        this.navCtrl.push('AddonModDataEntryPage', params);
    };
    /**
     * Performs the sync of the activity.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModDataIndexComponent.prototype.sync = function () {
        return this.prefetchHandler.sync(this.module, this.courseId);
    };
    /**
     * Checks if sync has succeed from result sync data.
     *
     * @param  {any}     result Data returned on the sync function.
     * @return {boolean}        If suceed or not.
     */
    AddonModDataIndexComponent.prototype.hasSyncSucceed = function (result) {
        return result.updated;
    };
    /**
     * Component being destroyed.
     */
    AddonModDataIndexComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.entryChangedObserver && this.entryChangedObserver.off();
        this.ratingOfflineObserver && this.ratingOfflineObserver.off();
        this.ratingSyncObserver && this.ratingSyncObserver.off();
    };
    AddonModDataIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\components\index\addon-mod-data-index.html"*/'<!-- Buttons to add to the header. -->\n<core-navbar-buttons end>\n    <button *ngIf="canSearch" ion-button icon-only (click)="showSearch($event)" [attr.aria-label]="\'addon.mod_data.search\' | translate">\n        <ion-icon name="search"></ion-icon>\n    </button>\n    <core-context-menu>\n        <core-context-menu-item *ngIf="externalUrl" [priority]="900" [content]="\'core.openinbrowser\' | translate" [href]="externalUrl" [iconAction]="\'open\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="description" [priority]="800" [content]="\'core.moduleintro\' | translate" (action)="expandDescription()" [iconAction]="\'arrow-forward\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="blog" [priority]="750" content="{{\'addon.blog.blog\' | translate}}" [iconAction]="\'fa-newspaper-o\'" (action)="gotoBlog($event)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && !(hasOffline || hasOfflineRatings) && isOnline" [priority]="700" [content]="\'core.refresh\' | translate" (action)="doRefresh(null, $event)" [iconAction]="refreshIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && (hasOffline || hasOfflineRatings) && isOnline"  [priority]="600" [content]="\'core.settings.synchronizenow\' | translate" (action)="doRefresh(null, $event, true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item [priority]="500" *ngIf="canAdd" [content]="\'addon.mod_data.addentries\' | translate" [iconAction]="\'add\'" (action)="gotoAddEntries($event)"></core-context-menu-item>\n        <core-context-menu-item [priority]="400" *ngIf="firstEntry" [content]="\'addon.mod_data.single\' | translate" [iconAction]="\'document\'" (action)="gotoEntry(firstEntry)"></core-context-menu-item>\n        <core-context-menu-item *ngIf="prefetchStatusIcon" [priority]="300" [content]="prefetchText" (action)="prefetch($event)" [iconAction]="prefetchStatusIcon" [closeOnClick]="false"></core-context-menu-item>\n        <core-context-menu-item *ngIf="size" [priority]="200" [content]="size" [iconDescription]="\'cube\'" (action)="removeFiles()" [iconAction]="\'trash\'"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<!-- Content. -->\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n\n    <core-course-module-description [description]="description" [component]="component" [componentId]="componentId"></core-course-module-description>\n\n    <!-- Data done in offline but not synchronized -->\n    <div class="core-warning-card" icon-start *ngIf="hasOffline || hasOfflineRatings">\n        <ion-icon name="warning"></ion-icon>\n        {{ \'core.hasdatatosync\' | translate: {$a: moduleName} }}\n    </div>\n\n    <ion-item text-wrap *ngIf="groupInfo && (groupInfo.separateGroups || groupInfo.visibleGroups)">\n        <ion-label id="addon-data-groupslabel" *ngIf="groupInfo.separateGroups">{{ \'core.groupsseparate\' | translate }}</ion-label>\n        <ion-label id="addon-data-groupslabel" *ngIf="groupInfo.visibleGroups">{{ \'core.groupsvisible\' | translate }}</ion-label>\n        <ion-select [(ngModel)]="selectedGroup" (ionChange)="setGroup(selectedGroup)" aria-labelledby="addon-data-groupslabel" interface="action-sheet">\n            <ion-option *ngFor="let groupOpt of groupInfo.groups" [value]="groupOpt.id">{{groupOpt.name}}</ion-option>\n        </ion-select>\n    </ion-item>\n\n    <div class="core-info-card" icon-start  *ngIf="!access.timeavailable && timeAvailableFrom">\n        <ion-icon name="information-circle"></ion-icon>\n        {{ \'addon.mod_data.notopenyet\' | translate:{$a: timeAvailableFromReadable} }}\n    </div>\n\n    <div class="core-info-card" icon-start *ngIf="!access.timeavailable && timeAvailableTo">\n        <ion-icon name="information-circle"></ion-icon>\n        {{ \'addon.mod_data.expired\' | translate:{$a: timeAvailableToReadable} }}\n    </div>\n\n    <div class="core-info-card" icon-start *ngIf="access.entrieslefttoview">\n        <ion-icon name="information-circle"></ion-icon>\n        {{ \'addon.mod_data.entrieslefttoaddtoview\' | translate:{$a: {entrieslefttoview: access.entrieslefttoview} } }}\n    </div>\n\n    <div class="core-info-card" icon-start *ngIf="access.entrieslefttoadd">\n        <ion-icon name="information-circle"></ion-icon>\n        {{ \'addon.mod_data.entrieslefttoadd\' | translate:{$a: {entriesleft: access.entrieslefttoadd} } }}\n    </div>\n\n    <!-- Reset search. -->\n    <ng-container *ngIf="search.searching && !isEmpty">\n        <ion-item class="item" *ngIf="!foundRecordsData">\n            <a (click)="searchReset()">{{ \'addon.mod_data.resetsettings\' | translate}}</a>\n        </ion-item>\n\n        <div class="core-success-card" *ngIf="foundRecordsData" (click)="searchReset()">\n            <p [innerHTML]="\'addon.mod_data.foundrecords\' | translate:{$a: foundRecordsData}"></p>\n        </div>\n    </ng-container>\n\n    <div class="addon-data-contents addon-data-entries-{{data.id}}" *ngIf="!isEmpty">\n        <core-style [css]="data.csstemplate" prefix=".addon-data-entries-{{data.id}}"></core-style>\n\n        <core-compile-html [text]="entriesRendered" [jsData]="jsData" [extraImports]="extraImports"></core-compile-html>\n    </div>\n\n    <ion-grid *ngIf="search.page > 0 || hasNextPage">\n        <ion-row align-items-center>\n            <ion-col *ngIf="search.page > 0">\n                <button ion-button block outline icon-start (click)="searchEntries(search.page - 1)">\n                    <ion-icon name="arrow-back" md="ios-arrow-back"></ion-icon>\n                    {{ \'core.previous\' | translate }}\n                </button>\n            </ion-col>\n            <ion-col *ngIf="hasNextPage">\n                <button ion-button block icon-end (click)="searchEntries(search.page + 1)">\n                    {{ \'core.next\' | translate }}\n                    <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n                </button>\n            </ion-col>\n        </ion-row>\n    </ion-grid>\n\n    <core-empty-box *ngIf="isEmpty && !search.searching" icon="archive" [message]="\'addon.mod_data.norecords\' | translate">\n    </core-empty-box>\n\n    <core-empty-box *ngIf="isEmpty && search.searching" icon="archive" [message]="\'addon.mod_data.nomatch\' | translate" class="core-empty-box-clickable">\n        <a (click)="searchReset()">{{ \'addon.mod_data.resetsettings\' | translate}}</a>\n    </core-empty-box>\n\n</core-loading>\n\n<ion-fab core-fab bottom end *ngIf="canAdd">\n    <button ion-fab (click)="gotoAddEntries($event)" [attr.aria-label]="\'addon.mod_data.addentries\' | translate">\n        <ion-icon name="add"></ion-icon>\n    </button>\n</ion-fab>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\components\index\addon-mod-data-index.html"*/,
        }),
        __param(1, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */],
            __WEBPACK_IMPORTED_MODULE_9__providers_data__["a" /* AddonModDataProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_helper__["a" /* AddonModDataHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_prefetch_handler__["a" /* AddonModDataPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_comments_providers_comments__["a" /* CoreCommentsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], AddonModDataIndexComponent);
    return AddonModDataIndexComponent;
}(__WEBPACK_IMPORTED_MODULE_5__core_course_classes_main_activity_component__["a" /* CoreCourseModuleMainActivityComponent */]));

//# sourceMappingURL=index.js.map

/***/ }),
/* 450 */,
/* 451 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NativeServiceProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_app_version__ = __webpack_require__(450);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_file__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_transfer__ = __webpack_require__(251);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_file_opener__ = __webpack_require__(250);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_Rx__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_Rx___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs_Rx__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_in_app_browser__ = __webpack_require__(249);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var NativeServiceProvider = /** @class */ (function () {
    function NativeServiceProvider(platform, alertCtrl, transfer, appVersion, file, fileOpener, 
        // private msg : MsgProvider,
        inAppBrowser) {
        this.platform = platform;
        this.alertCtrl = alertCtrl;
        this.transfer = transfer;
        this.appVersion = appVersion;
        this.file = file;
        this.fileOpener = fileOpener;
        this.inAppBrowser = inAppBrowser;
    }
    /**
     * 检查app是否需要升级
     */
    NativeServiceProvider.prototype.detectionUpgrade = function () {
        var _this = this;
        //this.appVersion.getVersionNumber()  获取当前apk的版本号类似于1.0.2
        this.appVersion.getVersionNumber().then(function (res) {
            //当前apk和调用接口的版本号进行对比
            if (localStorage.getItem("shandaversion") != res) {
                _this.alertCtrl.create({
                    title: '升级',
                    subTitle: '发现新版本,是否立即升级？',
                    buttons: [{ text: '取消' },
                        {
                            text: '确定',
                            handler: function () {
                                _this.downloadApp();
                            }
                        }
                    ]
                }).present();
            }
        }).catch(function (error) {
            alert(error);
        });
    };
    /**
     * 下载安装app
     */
    NativeServiceProvider.prototype.downloadApp = function () {
        if (this.isAndroid()) {
            var alert_1 = this.alertCtrl.create({
                title: '下载进度：0%',
                enableBackdropDismiss: false,
                buttons: ['后台下载']
            });
            alert_1.present();
            var that_1 = this;
            var fileTransfer = this.transfer.create();
            var apk = this.file.externalApplicationStorageDirectory + 'wlxx.apk'; //apk保存在手机里的目录
            var url = localStorage.getItem("shandadownLoadUrl"); //调用接口获取到的下载路径
            fileTransfer.download(url, apk).then(function (entry) {
                that_1.openApk(entry.toURL());
            });
            fileTransfer.onProgress(function (event) {
                var num = Math.floor(event.loaded / event.total * 100);
                if (num === 100) {
                    alert_1.dismiss();
                }
                else {
                    var title = document.getElementsByClassName('alert-title')[0];
                    title && (title.innerHTML = '下载进度：' + num + '%');
                }
            });
        }
        if (this.isIos()) {
            this.openUrlByBrowser(localStorage.getItem("shandadownLoadUrl"));
        }
    };
    /**
     * 通过浏览器打开url
     */
    NativeServiceProvider.prototype.openUrlByBrowser = function (url) {
        this.inAppBrowser.create(url, '_system');
    };
    /**
     * 打开下载的apk
     */
    NativeServiceProvider.prototype.openApk = function (url) {
        // this.fileOpener.open(url,'application/vnd.android.package-archive').then(res=>{
        //           // this.msg.toast("打开apk成功"+res);
        //         }).catch(err=>{
        //           // this.msg.toast("打开apk失败!"+err);
        //         })
        cordova.plugins.fileOpener2.open(url, 'application/vnd.android.package-archive', {
            error: function (e) {
                // this.presentToast("2222");
            },
            success: function () {
                // this.presentToast("3333");
            }
        });
    };
    /**
     * 是否真机环境
     * @return {boolean}
     */
    NativeServiceProvider.prototype.isMobile = function () {
        return this.platform.is('mobile') && !this.platform.is('mobileweb');
    };
    /**
     * 是否android真机环境
     * @return {boolean}
     */
    NativeServiceProvider.prototype.isAndroid = function () {
        return this.isMobile() && this.platform.is('android');
    };
    /**
     * 是否ios真机环境
     * @return {boolean}
     */
    NativeServiceProvider.prototype.isIos = function () {
        return this.isMobile() && (this.platform.is('ios') || this.platform.is('ipad') || this.platform.is('iphone'));
    };
    /**
     * 获得app版本号,如0.01
     * @description  对应/config.xml中version的值
     * @returns {Promise<string>}
     */
    NativeServiceProvider.prototype.getVersionNumber = function () {
        var _this = this;
        return __WEBPACK_IMPORTED_MODULE_6_rxjs_Rx__["Observable"].create(function (observer) {
            _this.appVersion.getVersionNumber().then(function (value) {
                observer.next(value);
            }).catch(function (err) {
                observer.error(false);
            });
        });
    };
    NativeServiceProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["b" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_transfer__["a" /* FileTransfer */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_app_version__["a" /* AppVersion */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_file__["a" /* File */],
            __WEBPACK_IMPORTED_MODULE_5__ionic_native_file_opener__["a" /* FileOpener */],
            __WEBPACK_IMPORTED_MODULE_7__ionic_native_in_app_browser__["a" /* InAppBrowser */]])
    ], NativeServiceProvider);
    return NativeServiceProvider;
}());

//# sourceMappingURL=native-service.js.map

/***/ }),
/* 452 */,
/* 453 */,
/* 454 */,
/* 455 */,
/* 456 */,
/* 457 */,
/* 458 */,
/* 459 */,
/* 460 */,
/* 461 */,
/* 462 */
/***/ (function(module, exports) {

function webpackEmptyAsyncContext(req) {
	// Here Promise.resolve().then() is used instead of new Promise() to prevent
	// uncatched exception popping up in devtools
	return Promise.resolve().then(function() {
		throw new Error("Cannot find module '" + req + "'.");
	});
}
webpackEmptyAsyncContext.keys = function() { return []; };
webpackEmptyAsyncContext.resolve = webpackEmptyAsyncContext;
module.exports = webpackEmptyAsyncContext;
webpackEmptyAsyncContext.id = 462;

/***/ }),
/* 463 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export createTranslateLoader */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CORE_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AppModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__ionic_storage__ = __webpack_require__(131);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_angular_oauth2_oidc__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_platform_browser__ = __webpack_require__(83);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_platform_browser_animations__ = __webpack_require__(1299);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_ionic_angular_util_util__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__angular_common_http__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__angular_platform_browser_dynamic__ = __webpack_require__(287);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__angular_common_testing__ = __webpack_require__(1727);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ngx_translate_http_loader__ = __webpack_require__(1728);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__ionic_native_screen_orientation__ = __webpack_require__(925);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__app_component__ = __webpack_require__(1730);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__classes_interceptor__ = __webpack_require__(344);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__classes_page_transition__ = __webpack_require__(1731);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__classes_modal_lateral_transition__ = __webpack_require__(1732);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__providers_db__ = __webpack_require__(340);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__providers_config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__providers_lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__providers_utils_iframe__ = __webpack_require__(346);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__providers_ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__providers_sites_factory__ = __webpack_require__(345);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__providers_update_manager__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__providers_plugin_file_delegate__ = __webpack_require__(177);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_44__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_45__providers_file_helper__ = __webpack_require__(252);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_46__providers_urlschemes__ = __webpack_require__(926);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_47__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_48__core_emulator_emulator_module__ = __webpack_require__(798);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_49__core_login_login_module__ = __webpack_require__(785);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_50__core_mainmenu_mainmenu_module__ = __webpack_require__(786);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_51__core_courses_courses_module__ = __webpack_require__(780);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_52__core_fileuploader_fileuploader_module__ = __webpack_require__(782);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_53__core_sharedfiles_sharedfiles_module__ = __webpack_require__(792);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_54__core_course_course_module__ = __webpack_require__(778);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_55__core_sitehome_sitehome_module__ = __webpack_require__(793);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_56__core_contentlinks_contentlinks_module__ = __webpack_require__(777);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_57__core_user_user_module__ = __webpack_require__(794);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_58__core_grades_grades_module__ = __webpack_require__(783);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_59__core_settings_settings_module__ = __webpack_require__(1733);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_60__core_siteplugins_siteplugins_module__ = __webpack_require__(1734);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_61__core_compile_compile_module__ = __webpack_require__(1752);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_62__core_question_question_module__ = __webpack_require__(787);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_63__core_comments_comments_module__ = __webpack_require__(1753);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_64__core_block_block_module__ = __webpack_require__(775);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_65__core_rating_rating_module__ = __webpack_require__(1754);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_66__addon_badges_badges_module__ = __webpack_require__(824);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_67__addon_blog_blog_module__ = __webpack_require__(1755);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_68__addon_calendar_calendar_module__ = __webpack_require__(825);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_69__addon_competency_competency_module__ = __webpack_require__(826);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_70__addon_coursecompletion_coursecompletion_module__ = __webpack_require__(1760);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_71__addon_userprofilefield_userprofilefield_module__ = __webpack_require__(1763);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_72__addon_files_files_module__ = __webpack_require__(827);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_73__addon_block_activitymodules_activitymodules_module__ = __webpack_require__(1774);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_74__addon_block_myoverview_myoverview_module__ = __webpack_require__(1777);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_75__addon_block_sitemainmenu_sitemainmenu_module__ = __webpack_require__(1780);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_76__addon_block_timeline_timeline_module__ = __webpack_require__(1783);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_77__addon_block_recentlyaccessedcourses_recentlyaccessedcourses_module__ = __webpack_require__(1787);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_78__addon_block_recentlyaccesseditems_recentlyaccesseditems_module__ = __webpack_require__(1790);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_79__addon_block_starredcourses_starredcourses_module__ = __webpack_require__(1793);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_80__addon_mod_assign_assign_module__ = __webpack_require__(832);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_81__addon_mod_book_book_module__ = __webpack_require__(841);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_82__addon_mod_chat_chat_module__ = __webpack_require__(842);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_83__addon_mod_choice_choice_module__ = __webpack_require__(843);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_84__addon_mod_data_data_module__ = __webpack_require__(1796);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_85__addon_mod_label_label_module__ = __webpack_require__(1829);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_86__addon_mod_lti_lti_module__ = __webpack_require__(857);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_87__addon_mod_resource_resource_module__ = __webpack_require__(864);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_88__addon_mod_feedback_feedback_module__ = __webpack_require__(844);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_89__addon_mod_folder_folder_module__ = __webpack_require__(846);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_90__addon_mod_forum_forum_module__ = __webpack_require__(848);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_91__addon_mod_glossary_glossary_module__ = __webpack_require__(850);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_92__addon_mod_lesson_lesson_module__ = __webpack_require__(856);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_93__addon_mod_page_page_module__ = __webpack_require__(858);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_94__addon_mod_quiz_quiz_module__ = __webpack_require__(860);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_95__addon_mod_scorm_scorm_module__ = __webpack_require__(866);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_96__addon_mod_url_url_module__ = __webpack_require__(869);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_97__addon_mod_survey_survey_module__ = __webpack_require__(867);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_98__addon_mod_workshop_workshop_module__ = __webpack_require__(872);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_99__addon_mod_imscp_imscp_module__ = __webpack_require__(853);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_100__addon_mod_wiki_wiki_module__ = __webpack_require__(870);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_101__addon_messageoutput_messageoutput_module__ = __webpack_require__(828);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_102__addon_messageoutput_airnotifier_airnotifier_module__ = __webpack_require__(1833);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_103__addon_messages_messages_module__ = __webpack_require__(829);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_104__addon_notes_notes_module__ = __webpack_require__(877);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_105__core_pushnotifications_pushnotifications_module__ = __webpack_require__(797);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_106__addon_notifications_notifications_module__ = __webpack_require__(879);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_107__addon_remotethemes_remotethemes_module__ = __webpack_require__(880);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_108__addon_qbehaviour_qbehaviour_module__ = __webpack_require__(1835);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_109__addon_qtype_qtype_module__ = __webpack_require__(1855);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_110__addon_storagemanager_storagemanager_module__ = __webpack_require__(1889);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_111__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_112__providers_ouclogin_ouclogin__ = __webpack_require__(411);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_113__providers_native_service_native_service__ = __webpack_require__(451);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_114__ionic_native_app_version__ = __webpack_require__(450);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_115__pages_showpdf_showpdf__ = __webpack_require__(1891);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_116_angular2_markdown__ = __webpack_require__(1018);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.















































// Core modules.



















// Addon modules.

















































// import {PdfViewerModule} from 'ng2-pdf-viewer';  


// For translate loader. AoT requires an exported function for factories.
function createTranslateLoader(http) {
    return new __WEBPACK_IMPORTED_MODULE_13__ngx_translate_http_loader__["a" /* TranslateHttpLoader */](http, './assets/lang/', '.json');
}
// List of providers.
var CORE_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_19__providers_logger__["a" /* CoreLoggerProvider */],
    __WEBPACK_IMPORTED_MODULE_20__providers_db__["a" /* CoreDbProvider */],
    __WEBPACK_IMPORTED_MODULE_21__providers_app__["a" /* CoreAppProvider */],
    __WEBPACK_IMPORTED_MODULE_22__providers_config__["a" /* CoreConfigProvider */],
    __WEBPACK_IMPORTED_MODULE_23__providers_lang__["a" /* CoreLangProvider */],
    __WEBPACK_IMPORTED_MODULE_24__providers_utils_text__["a" /* CoreTextUtilsProvider */],
    __WEBPACK_IMPORTED_MODULE_25__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
    __WEBPACK_IMPORTED_MODULE_26__providers_utils_iframe__["a" /* CoreIframeUtilsProvider */],
    __WEBPACK_IMPORTED_MODULE_27__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
    __WEBPACK_IMPORTED_MODULE_28__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
    __WEBPACK_IMPORTED_MODULE_29__providers_utils_utils__["a" /* CoreUtilsProvider */],
    __WEBPACK_IMPORTED_MODULE_30__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
    __WEBPACK_IMPORTED_MODULE_31__providers_init__["a" /* CoreInitDelegate */],
    __WEBPACK_IMPORTED_MODULE_32__providers_file__["a" /* CoreFileProvider */],
    __WEBPACK_IMPORTED_MODULE_33__providers_ws__["a" /* CoreWSProvider */],
    __WEBPACK_IMPORTED_MODULE_34__providers_events__["a" /* CoreEventsProvider */],
    __WEBPACK_IMPORTED_MODULE_35__providers_sites_factory__["a" /* CoreSitesFactoryProvider */],
    __WEBPACK_IMPORTED_MODULE_36__providers_sites__["a" /* CoreSitesProvider */],
    __WEBPACK_IMPORTED_MODULE_37__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */],
    __WEBPACK_IMPORTED_MODULE_38__providers_groups__["a" /* CoreGroupsProvider */],
    __WEBPACK_IMPORTED_MODULE_39__providers_cron__["a" /* CoreCronDelegate */],
    __WEBPACK_IMPORTED_MODULE_40__providers_file_session__["a" /* CoreFileSessionProvider */],
    __WEBPACK_IMPORTED_MODULE_41__providers_filepool__["a" /* CoreFilepoolProvider */],
    __WEBPACK_IMPORTED_MODULE_42__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
    __WEBPACK_IMPORTED_MODULE_43__providers_plugin_file_delegate__["a" /* CorePluginFileDelegate */],
    __WEBPACK_IMPORTED_MODULE_44__providers_sync__["a" /* CoreSyncProvider */],
    __WEBPACK_IMPORTED_MODULE_45__providers_file_helper__["a" /* CoreFileHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_46__providers_urlschemes__["a" /* CoreCustomURLSchemesProvider */]
];
var AppModule = /** @class */ (function () {
    function AppModule(platform, initDelegate, updateManager, config, sitesProvider, fileProvider, eventsProvider) {
        this.eventsProvider = eventsProvider;
        // Register a handler for platform ready.
        initDelegate.registerProcess({
            name: 'CorePlatformReady',
            priority: __WEBPACK_IMPORTED_MODULE_31__providers_init__["a" /* CoreInitDelegate */].MAX_RECOMMENDED_PRIORITY + 400,
            blocking: true,
            load: platform.ready
        });
        // Register the update manager as an init process.
        initDelegate.registerProcess(updateManager);
        // Restore the user's session during the init process.
        initDelegate.registerProcess({
            name: 'CoreRestoreSession',
            priority: __WEBPACK_IMPORTED_MODULE_31__providers_init__["a" /* CoreInitDelegate */].MAX_RECOMMENDED_PRIORITY + 200,
            blocking: false,
            load: sitesProvider.restoreSession.bind(sitesProvider)
        });
        // Register clear app tmp folder.
        initDelegate.registerProcess({
            name: 'CoreClearTmpFolder',
            priority: __WEBPACK_IMPORTED_MODULE_31__providers_init__["a" /* CoreInitDelegate */].MAX_RECOMMENDED_PRIORITY + 150,
            blocking: false,
            load: fileProvider.clearTmpFolder.bind(fileProvider)
        });
        // Execute the init processes.
        initDelegate.executeInitProcesses();
        // Set transition animation.
        config.setTransition('core-page-transition', __WEBPACK_IMPORTED_MODULE_17__classes_page_transition__["a" /* CorePageTransition */]);
        config.setTransition('core-modal-lateral-transition', __WEBPACK_IMPORTED_MODULE_18__classes_modal_lateral_transition__["a" /* CoreModalLateralTransition */]);
        // Decorate ion-content.
        this.decorateIonContent();
    }
    /**
     * Decorate ion-content to make our ion-tabs work.
     * https://github.com/ionic-team/ionic/issues/14483
     */
    AppModule.prototype.decorateIonContent = function () {
        var parsePxUnit = function (val) {
            return (val.indexOf('px') > 0) ? parseInt(val, 10) : 0;
        };
        // We need to convert the prototype to any because _readDimensions is private.
        // tslint:disable: typedef
        __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["f" /* Content */].prototype._readDimensions = function () {
            var cachePaddingTop = this._pTop;
            var cachePaddingRight = this._pRight;
            var cachePaddingBottom = this._pBottom;
            var cachePaddingLeft = this._pLeft;
            var cacheHeaderHeight = this._hdrHeight;
            var cacheFooterHeight = this._ftrHeight;
            var cacheTabsPlacement = this._tabsPlacement;
            var tabsTop = 0;
            var scrollEvent;
            this._pTop = 0;
            this._pRight = 0;
            this._pBottom = 0;
            this._pLeft = 0;
            this._hdrHeight = 0;
            this._ftrHeight = 0;
            this._tabsPlacement = null;
            this._tTop = 0;
            this._fTop = 0;
            this._fBottom = 0;
            // In certain cases this._scroll is undefined, if that is the case then we should just return.
            if (!this._scroll) {
                return;
            }
            scrollEvent = this._scroll.ev;
            var ele = this.getNativeElement();
            if (!ele) {
                Object(__WEBPACK_IMPORTED_MODULE_6_ionic_angular_util_util__["a" /* assert */])(false, 'ele should be valid');
                return;
            }
            var computedStyle;
            var tagName;
            var parentEle = ele.parentElement;
            var children = parentEle.children;
            for (var i = children.length - 1; i >= 0; i--) {
                ele = children[i];
                tagName = ele.tagName;
                if (tagName === 'ION-CONTENT') {
                    scrollEvent.contentElement = ele;
                    if (this._fullscreen) {
                        // ******** DOM READ ****************
                        computedStyle = getComputedStyle(ele);
                        this._pTop = parsePxUnit(computedStyle.paddingTop);
                        this._pBottom = parsePxUnit(computedStyle.paddingBottom);
                        this._pRight = parsePxUnit(computedStyle.paddingRight);
                        this._pLeft = parsePxUnit(computedStyle.paddingLeft);
                    }
                }
                else if (tagName === 'ION-HEADER') {
                    scrollEvent.headerElement = ele;
                    // ******** DOM READ ****************
                    this._hdrHeight = ele.clientHeight;
                }
                else if (tagName === 'ION-FOOTER') {
                    scrollEvent.footerElement = ele;
                    // ******** DOM READ ****************
                    this._ftrHeight = ele.clientHeight;
                    this._footerEle = ele;
                }
            }
            ele = parentEle;
            var tabbarEle;
            while (ele && ele.tagName !== 'ION-MODAL' && !ele.classList.contains('tab-subpage')) {
                if (ele.tagName.indexOf('ION-TABS') != -1) {
                    tabbarEle = ele.firstElementChild;
                    // ******** DOM READ ****************
                    this._tabbarHeight = tabbarEle.clientHeight;
                    if (this._tabsPlacement === null) {
                        // This is the first tabbar found, remember its position.
                        this._tabsPlacement = ele.getAttribute('tabsplacement');
                    }
                }
                ele = ele.parentElement;
            }
            // Tabs top
            if (this._tabs && this._tabsPlacement === 'top') {
                this._tTop = this._hdrHeight;
                tabsTop = this._tabs._top;
            }
            // Toolbar height
            this._cTop = this._hdrHeight;
            this._cBottom = this._ftrHeight;
            // Tabs height
            if (this._tabsPlacement === 'top') {
                this._cTop += this._tabbarHeight;
            }
            else if (this._tabsPlacement === 'bottom') {
                this._cBottom += this._tabbarHeight;
            }
            // Refresher uses a border which should be hidden unless pulled
            if (this._hasRefresher) {
                this._cTop -= 1;
            }
            // Fixed content shouldn't include content padding
            this._fTop = this._cTop;
            this._fBottom = this._cBottom;
            // Handle fullscreen viewport (padding vs margin)
            if (this._fullscreen) {
                this._cTop += this._pTop;
                this._cBottom += this._pBottom;
            }
            // ******** DOM READ ****************
            var contentDimensions = this.getContentDimensions();
            scrollEvent.scrollHeight = contentDimensions.scrollHeight;
            scrollEvent.scrollWidth = contentDimensions.scrollWidth;
            scrollEvent.contentHeight = contentDimensions.contentHeight;
            scrollEvent.contentWidth = contentDimensions.contentWidth;
            scrollEvent.contentTop = contentDimensions.contentTop;
            scrollEvent.contentBottom = contentDimensions.contentBottom;
            this._dirty = (cachePaddingTop !== this._pTop ||
                cachePaddingBottom !== this._pBottom ||
                cachePaddingLeft !== this._pLeft ||
                cachePaddingRight !== this._pRight ||
                cacheHeaderHeight !== this._hdrHeight ||
                cacheFooterHeight !== this._ftrHeight ||
                cacheTabsPlacement !== this._tabsPlacement ||
                tabsTop !== this._tTop ||
                this._cTop !== this.contentTop ||
                this._cBottom !== this.contentBottom);
            this._scroll.init(this.getScrollElement(), this._cTop, this._cBottom);
            // Initial imgs refresh.
            this.imgsUpdate();
        };
        var eventsProvider = this.eventsProvider;
        // tslint:disable: typedef
        __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["f" /* Content */].prototype.ngAfterViewInit = function () {
            var _this = this;
            Object(__WEBPACK_IMPORTED_MODULE_6_ionic_angular_util_util__["a" /* assert */])(this.getFixedElement(), 'fixed element was not found');
            Object(__WEBPACK_IMPORTED_MODULE_6_ionic_angular_util_util__["a" /* assert */])(this.getScrollElement(), 'scroll element was not found');
            var scroll = this._scroll;
            scroll.ev.fixedElement = this.getFixedElement();
            scroll.ev.scrollElement = this.getScrollElement();
            // Subscribe to the scroll start
            scroll.onScrollStart = function (ev) {
                _this.ionScrollStart.emit(ev);
            };
            // Subscribe to every scroll move
            scroll.onScroll = function (ev) {
                // Emit to all of our other friends things be scrolling
                _this.ionScroll.emit(ev);
                _this.imgsUpdate();
            };
            // Subscribe to the scroll end
            scroll.onScrollEnd = function (ev) {
                _this.ionScrollEnd.emit(ev);
                _this.imgsUpdate();
            };
            // Recalculate size when screen rotates.
            this._orientationObs = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_34__providers_events__["a" /* CoreEventsProvider */].ORIENTATION_CHANGE, this.resize.bind(this));
        };
        // tslint:disable: typedef
        __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["f" /* Content */].prototype.ngOnDestroy = function () {
            this._scLsn && this._scLsn();
            this._viewCtrlReadSub && this._viewCtrlReadSub.unsubscribe();
            this._viewCtrlWriteSub && this._viewCtrlWriteSub.unsubscribe();
            this._viewCtrlReadSub = this._viewCtrlWriteSub = null;
            this._scroll && this._scroll.destroy();
            this._footerEle = this._scLsn = this._scroll = null;
            this._orientationObs && this._orientationObs.off();
        };
    };
    AppModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_4__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_15__app_component__["a" /* MoodleMobileApp */],
                __WEBPACK_IMPORTED_MODULE_115__pages_showpdf_showpdf__["a" /* ShowpdfPage */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_angular_oauth2_oidc__["a" /* OAuthModule */].forRoot({
                    resourceServer: {
                        allowedUrls: ['http://www.angular.at/api'],
                        sendAccessToken: true
                    }
                }),
                __WEBPACK_IMPORTED_MODULE_0__ionic_storage__["a" /* IonicStorageModule */].forRoot(),
                __WEBPACK_IMPORTED_MODULE_2__angular_platform_browser__["a" /* BrowserModule */],
                __WEBPACK_IMPORTED_MODULE_3__angular_platform_browser_animations__["a" /* BrowserAnimationsModule */],
                __WEBPACK_IMPORTED_MODULE_8__angular_common_http__["c" /* HttpClientModule */],
                __WEBPACK_IMPORTED_MODULE_7__angular_http__["c" /* HttpModule */],
                __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["l" /* IonicModule */].forRoot(__WEBPACK_IMPORTED_MODULE_15__app_component__["a" /* MoodleMobileApp */], {
                    pageTransition: 'core-page-transition'
                }, {
                    links: [
                        { loadChildren: '../addon/badges/pages/user-badges/user-badges.module#AddonBadgesUserBadgesPageModule', name: 'AddonBadgesUserBadgesPage', segment: 'addon-badges-user-badges', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/badges/pages/issued-badge/issued-badge.module#AddonBadgesIssuedBadgePageModule', name: 'AddonBadgesIssuedBadgePage', segment: 'addon-badges-issued-badge', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/blog/pages/entries/entries.module#AddonBlogEntriesPageModule', name: 'AddonBlogEntriesPage', segment: 'addon-blog-entries', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/calendar/pages/event/event.module#AddonCalendarEventPageModule', name: 'AddonCalendarEventPage', segment: 'addon-calendar-event', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/calendar/pages/list/list.module#AddonCalendarListPageModule', name: 'AddonCalendarListPage', segment: 'addon-calendar-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/calendar/pages/settings/settings.module#AddonCalendarSettingsPageModule', name: 'AddonCalendarSettingsPage', segment: 'addon-calendar-settings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/competency/pages/competencies/competencies.module#AddonCompetencyCompetenciesPageModule', name: 'AddonCompetencyCompetenciesPage', segment: 'addon-competency-competencies', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/competency/pages/competencysummary/competencysummary.module#AddonCompetencyCompetencySummaryPageModule', name: 'AddonCompetencyCompetencySummaryPage', segment: 'addon-competency-competency-summary', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/competency/pages/competency/competency.module#AddonCompetencyCompetencyPageModule', name: 'AddonCompetencyCompetencyPage', segment: 'addon-competency-competency', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/competency/pages/coursecompetencies/coursecompetencies.module#AddonCompetencyCourseCompetenciesPageModule', name: 'AddonCompetencyCourseCompetenciesPage', segment: 'addon-competency-coursecompetencies', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/competency/pages/plan/plan.module#AddonCompetencyPlanPageModule', name: 'AddonCompetencyPlanPage', segment: 'addon-competency-plan', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/competency/pages/planlist/planlist.module#AddonCompetencyPlanListPageModule', name: 'AddonCompetencyPlanListPage', segment: 'addon-competency-planlist', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/coursecompletion/pages/report/report.module#AddonModFolderIndexPageModule', name: 'AddonCourseCompletionReportPage', segment: 'addon-course-completion-report', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/files/pages/list/list.module#AddonFilesListPageModule', name: 'AddonFilesListPage', segment: 'addon-files-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messageoutput/airnotifier/pages/devices/devices.module#AddonMessageOutputAirnotifierDevicesPageModule', name: 'AddonMessageOutputAirnotifierDevicesPage', segment: 'addon-message-output-airnotifier-devices', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messages/pages/contacts/contacts.module#AddonMessagesContactsPageModule', name: 'AddonMessagesContactsPage', segment: 'addon-messages-contacts', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messages/pages/conversation-info/conversation-info.module#AddonMessagesConversationInfoPageModule', name: 'AddonMessagesConversationInfoPage', segment: 'addon-messages-conversation-info', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messages/pages/discussion/discussion.module#AddonMessagesDiscussionPageModule', name: 'AddonMessagesDiscussionPage', segment: 'addon-messages-discussion', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messages/pages/group-conversations/group-conversations.module#AddonMessagesGroupConversationsPageModule', name: 'AddonMessagesGroupConversationsPage', segment: 'addon-messages-group-conversations', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messages/pages/index/index.module#AddonMessagesIndexPageModule', name: 'AddonMessagesIndexPage', segment: 'addon-messages-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messages/pages/search/search.module#AddonMessagesSearchPageModule', name: 'AddonMessagesSearchPage', segment: 'addon-messages-search', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/messages/pages/settings/settings.module#AddonMessagesSettingsPageModule', name: 'AddonMessagesSettingsPage', segment: 'addon-messages-settings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/assign/pages/edit-feedback-modal/edit-feedback-modal.module#AddonModAssignEditFeedbackModalPageModule', name: 'AddonModAssignEditFeedbackModalPage', segment: 'addon-mod-assign-edit-feedback-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/assign/pages/edit/edit.module#AddonModAssignEditPageModule', name: 'AddonModAssignEditPage', segment: 'addon-mod-assign-edit', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/assign/pages/index/index.module#AddonModAssignIndexPageModule', name: 'AddonModAssignIndexPage', segment: 'addon-mod-assign-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/assign/pages/submission-list/submission-list.module#AddonModAssignSubmissionListPageModule', name: 'AddonModAssignSubmissionListPage', segment: 'addon-mod-assign-submission-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/assign/pages/submission-review/submission-review.module#AddonModAssignSubmissionReviewPageModule', name: 'AddonModAssignSubmissionReviewPage', segment: 'addon-mod-assign-submission-review', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/book/pages/index/index.module#AddonModBookIndexPageModule', name: 'AddonModBookIndexPage', segment: 'addon-mod-book-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/book/pages/toc/toc.module#AddonModBookTocPageModule', name: 'AddonModBookTocPage', segment: 'addon-mod-book-toc-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/chat/pages/chat/chat.module#AddonModChatChatPageModule', name: 'AddonModChatChatPage', segment: 'addon-mod-chat-chat', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/chat/pages/session-messages/session-messages.module#AddonModChatSessionMessagesPageModule', name: 'AddonModChatSessionMessagesPage', segment: 'addon-mod-chat-session-messages', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/chat/pages/index/index.module#AddonModChatIndexPageModule', name: 'AddonModChatIndexPage', segment: 'addon-mod-chat-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/chat/pages/sessions/sessions.module#AddonModChatSessionsPageModule', name: 'AddonModChatSessionsPage', segment: 'addon-mod-chat-sessions', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/chat/pages/users/users.module#AddonModChatUsersPageModule', name: 'AddonModChatUsersPage', segment: 'addon-mod-chat-users', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/choice/pages/index/index.module#AddonModChoiceIndexPageModule', name: 'AddonModChoiceIndexPage', segment: 'addon-mod-choice-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/data/pages/edit/edit.module#AddonModDataEditPageModule', name: 'AddonModDataEditPage', segment: 'addon-mod-data-edit', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/data/pages/entry/entry.module#AddonModDataEntryPageModule', name: 'AddonModDataEntryPage', segment: 'addon-mod-data-entry', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/data/pages/index/index.module#AddonModDataIndexPageModule', name: 'AddonModDataIndexPage', segment: 'addon-mod-data-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/data/pages/search/search.module#AddonModDataSearchPageModule', name: 'AddonModDataSearchPage', segment: 'addon-mod-data-search', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/feedback/pages/form/form.module#AddonModFeedbackFormPageModule', name: 'AddonModFeedbackFormPage', segment: 'addon-mod-feedback-form', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/feedback/pages/index/index.module#AddonModFeedbackIndexPageModule', name: 'AddonModFeedbackIndexPage', segment: 'addon-mod-feedback-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/feedback/pages/attempt/attempt.module#AddonModFeedbackAttemptPageModule', name: 'AddonModFeedbackAttemptPage', segment: 'addon-mod-feedback-attempt', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/feedback/pages/nonrespondents/nonrespondents.module#AddonModFeedbackNonRespondentsPageModule', name: 'AddonModFeedbackNonRespondentsPage', segment: 'addon-mod-feedback-nonrespondents', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/feedback/pages/respondents/respondents.module#AddonModFeedbackRespondentsPageModule', name: 'AddonModFeedbackRespondentsPage', segment: 'addon-mod-feedback-respondents', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/folder/pages/index/index.module#AddonModFolderIndexPageModule', name: 'AddonModFolderIndexPage', segment: 'addon-mod-folder-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/forum/pages/discussion/discussion.module#AddonModForumDiscussionPageModule', name: 'AddonModForumDiscussionPage', segment: 'addon-mod-forum-discussion', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/forum/pages/index/index.module#AddonModForumIndexPageModule', name: 'AddonModForumIndexPage', segment: 'addon-mod-forum-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/forum/pages/new-discussion/new-discussion.module#AddonModForumNewDiscussionPageModule', name: 'AddonModForumNewDiscussionPage', segment: 'addon-mod-forum-new-discussion', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/forum/pages/sort-order-selector/sort-order-selector.module#AddonModForumSortOrderSelectorPagePageModule', name: 'AddonModForumSortOrderSelectorPage', segment: 'addon-mod-forum-sort-order-selector', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/glossary/pages/edit/edit.module#AddonModGlossaryNewDiscussionPageModule', name: 'AddonModGlossaryEditPage', segment: 'addon-mod-glossary-edit', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/glossary/pages/entry/entry.module#AddonModForumDiscussionPageModule', name: 'AddonModGlossaryEntryPage', segment: 'addon-mod-glossary-entry', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/glossary/pages/index/index.module#AddonModGlossaryIndexPageModule', name: 'AddonModGlossaryIndexPage', segment: 'addon-mod-glossary-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/imscp/pages/index/index.module#AddonModImscpIndexPageModule', name: 'AddonModImscpIndexPage', segment: 'addon-mod-imscp-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/lesson/pages/index/index.module#AddonModLessonIndexPageModule', name: 'AddonModLessonIndexPage', segment: 'addon-mod-lesson-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/lesson/pages/menu-modal/menu-modal.module#AddonModLessonMenuModalPageModule', name: 'AddonModLessonMenuModalPage', segment: 'addon-mod-lesson-menu-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/lesson/pages/password-modal/password-modal.module#AddonModLessonPasswordModalPageModule', name: 'AddonModLessonPasswordModalPage', segment: 'addon-mod-lesson-password-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/lesson/pages/user-retake/user-retake.module#AddonModLessonUserRetakePageModule', name: 'AddonModLessonUserRetakePage', segment: 'addon-mod-lesson-user-retake', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/lesson/pages/player/player.module#AddonModLessonPlayerPageModule', name: 'AddonModLessonPlayerPage', segment: 'addon-mod-lesson-player', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/lti/pages/index/index.module#AddonModLtiIndexPageModule', name: 'AddonModLtiIndexPage', segment: 'addon-mod-lti-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/page/pages/index/index.module#AddonModPageIndexPageModule', name: 'AddonModPageIndexPage', segment: 'addon-mod-page-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/quiz/pages/attempt/attempt.module#AddonModQuizAttemptPageModule', name: 'AddonModQuizAttemptPage', segment: 'addon-mod-quiz-attempt', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/quiz/pages/index/index.module#AddonModQuizIndexPageModule', name: 'AddonModQuizIndexPage', segment: 'addon-mod-quiz-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/quiz/pages/navigation-modal/navigation-modal.module#AddonModQuizNavigationModalPageModule', name: 'AddonModQuizNavigationModalPage', segment: 'addon-mod-quiz-navigation-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/quiz/pages/player/player.module#AddonModQuizPlayerPageModule', name: 'AddonModQuizPlayerPage', segment: 'addon-mod-quiz-player', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/quiz/pages/preflight-modal/preflight-modal.module#AddonModQuizPreflightModalModule', name: 'AddonModQuizPreflightModalPage', segment: 'addon-mod-quiz-preflight-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/quiz/pages/review/review.module#AddonModQuizReviewPageModule', name: 'AddonModQuizReviewPage', segment: 'addon-mod-quiz-review', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/resource/pages/index/index.module#AddonModResourceIndexPageModule', name: 'AddonModResourceIndexPage', segment: 'addon-mod-resource-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/scorm/pages/index/index.module#AddonModScormIndexPageModule', name: 'AddonModScormIndexPage', segment: 'addon-mod-scorm-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/scorm/pages/player/player.module#AddonModScormPlayerPageModule', name: 'AddonModScormPlayerPage', segment: 'addon-mod-scorm-player', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/scorm/pages/toc/toc.module#AddonModScormTocPageModule', name: 'AddonModScormTocPage', segment: 'addon-mod-scorm-toc-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/survey/pages/index/index.module#AddonModSurveyIndexPageModule', name: 'AddonModSurveyIndexPage', segment: 'addon-mod-survey-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/url/pages/index/index.module#AddonModUrlIndexPageModule', name: 'AddonModUrlIndexPage', segment: 'addon-mod-url-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/wiki/pages/index/index.module#AddonModWikiIndexPageModule', name: 'AddonModWikiIndexPage', segment: 'addon-mod-wiki-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/wiki/pages/edit/edit.module#AddonModWikiEditPageModule', name: 'AddonModWikiEditPage', segment: 'addon-mod-wiki-edit', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/workshop/pages/assessment/assessment.module#AddonModWorkshopAssessmentPageModule', name: 'AddonModWorkshopAssessmentPage', segment: 'addon-mod-workshop-assessment', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/workshop/pages/edit-submission/edit-submission.module#AddonModWorkshopEditSubmissionPageModule', name: 'AddonModWorkshopEditSubmissionPage', segment: 'addon-mod-workshop-edit-submission', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/workshop/pages/index/index.module#AddonModWorkshopIndexPageModule', name: 'AddonModWorkshopIndexPage', segment: 'addon-mod-workshop-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/workshop/pages/phase/phase.module#AddonModWorkshopPhaseInfoPageModule', name: 'AddonModWorkshopPhaseInfoPage', segment: 'addon-mod-workshop-phase-info', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/mod/workshop/pages/submission/submission.module#AddonModWorkshopSubmissionPageModule', name: 'AddonModWorkshopSubmissionPage', segment: 'addon-mod-workshop-submission', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/notes/pages/list/list.module#AddonNotesListPageModule', name: 'AddonNotesListPage', segment: 'addon-notes-list-page', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/notes/pages/add/add.module#AddonNotesAddPageModule', name: 'AddonNotesAddPage', segment: 'addon-notes-add', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/notifications/pages/settings/settings.module#AddonNotificationsSettingsPageModule', name: 'AddonNotificationsSettingsPage', segment: 'addon-notifications-settings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/notifications/pages/list/list.module#AddonNotificationsListPageModule', name: 'AddonNotificationsListPage', segment: 'addon-notifications-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../addon/storagemanager/pages/course-storage/course-storage.module#AddonStorageManagerCourseStoragePageModule', name: 'AddonStorageManagerCourseStoragePage', segment: 'addon-storagemanager-course-storage', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../components/split-view/placeholder/placeholder.module#CorePlaceholderPageModule', name: 'CoreSplitViewPlaceholderPage', segment: 'core-placeholder', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/comments/pages/viewer/viewer.module#CoreCommentsViewerPageModule', name: 'CoreCommentsViewerPage', segment: 'core-comments-viewer', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/contentlinks/pages/choose-site/choose-site.module#CoreContentLinksChooseSitePageModule', name: 'CoreContentLinksChooseSitePage', segment: 'core-content-links-choose-site', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/course/pages/list-mod-type/list-mod-type.module#CoreCourseListModTypePageModule', name: 'CoreCourseListModTypePage', segment: 'core-course-list-mod-type', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/course/pages/section-selector/section-selector.module#CoreCourseSectionSelectorPageModule', name: 'CoreCourseSectionSelectorPage', segment: 'core-course-section-selector', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/course/pages/section/section.module#CoreCourseSectionPageModule', name: 'CoreCourseSectionPage', segment: 'core-course-section', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/course/pages/unsupported-module/unsupported-module.module#CoreCourseUnsupportedModulePageModule', name: 'CoreCourseUnsupportedModulePage', segment: 'core-course-unsupported-module', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/courses/pages/available-courses/available-courses.module#CoreCoursesAvailableCoursesPageModule', name: 'CoreCoursesAvailableCoursesPage', segment: 'core-courses-available-courses', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/courses/pages/categories/categories.module#CoreCoursesCategoriesPageModule', name: 'CoreCoursesCategoriesPage', segment: 'core-courses-categories', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/courses/pages/course-preview/course-preview.module#CoreCoursesCoursePreviewPageModule', name: 'CoreCoursesCoursePreviewPage', segment: 'core-courses-course-preview', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/courses/pages/dashboard/dashboard.module#CoreCoursesDashboardPageModule', name: 'CoreCoursesDashboardPage', segment: 'core-courses-dashboard', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/courses/pages/search/search.module#CoreCoursesSearchPageModule', name: 'CoreCoursesSearchPage', segment: 'core-courses-search', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/courses/pages/my-courses/my-courses.module#CoreCoursesMyCoursesPageModule', name: 'CoreCoursesMyCoursesPage', segment: 'core-courses-my-courses', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/courses/pages/self-enrol-password/self-enrol-password.module#CoreCoursesSelfEnrolPasswordPageModule', name: 'CoreCoursesSelfEnrolPasswordPage', segment: 'core-courses-self-enrol-password', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/emulator/pages/capture-media/capture-media.module#CoreEmulatorCaptureMediaPageModule', name: 'CoreEmulatorCaptureMediaPage', segment: 'core-emulator-capture-media', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/grades/pages/course/course.module#CoreGradesCoursePageModule', name: 'CoreGradesCoursePage', segment: 'core-grades-course', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/grades/pages/courses/courses.module#CoreGradesCoursesPageModule', name: 'CoreGradesCoursesPage', segment: 'core-grades-courses', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/grades/pages/grade/grade.module#CoreGradesGradePageModule', name: 'CoreGradesGradePage', segment: 'core-grades-grade', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/grades/pages/coursesplit/coursesplit.module#CoreGradesCourseSplitPageModule', name: 'CoreGradesCourseSplitPage', segment: 'core-grades-course-split', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/credentials/credentials.module#CoreLoginCredentialsPageModule', name: 'CoreLoginCredentialsPage', segment: 'core-login-credentials', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/email-signup/email-signup.module#CoreLoginCredentialsPageModule', name: 'CoreLoginEmailSignupPage', segment: 'core-login-email-signup', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/forgotten-password/forgotten-password.module#CoreLoginForgottenPasswordPageModule', name: 'CoreLoginForgottenPasswordPage', segment: 'core-login-forgotten-password', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/init/init.module#CoreLoginInitPageModule', name: 'CoreLoginInitPage', segment: 'core-login-init', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/reconnect/reconnect.module#CoreLoginReconnectPageModule', name: 'CoreLoginReconnectPage', segment: 'core-login-reconnect', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/site-error/site-error.module#CoreLoginSiteErrorPageModule', name: 'CoreLoginSiteErrorPage', segment: 'core-login-site-error', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/site-help/site-help.module#CoreLoginSiteHelpPageModule', name: 'CoreLoginSiteHelpPage', segment: 'core-login-site-help', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/site-policy/site-policy.module#CoreLoginSitePolicyPageModule', name: 'CoreLoginSitePolicyPage', segment: 'core-login-site-policy', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/site/site.module#CoreLoginSitePageModule', name: 'CoreLoginSitePage', segment: 'core-login-site', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/login/pages/sites/sites.module#CoreLoginSitesPageModule', name: 'CoreLoginSitesPage', segment: 'core-login-sites', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/mainmenu/pages/menu/menu.module#CoreMainMenuPageModule', name: 'CoreMainMenuPage', segment: 'core-mainmenu', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/mainmenu/pages/more/more.module#CoreMainMenuPageModule', name: 'CoreMainMenuMorePage', segment: 'core-mainmenu-more', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/settings/pages/about/about.module#CoreSettingsAboutPageModule', name: 'CoreSettingsAboutPage', segment: 'core-settings-about', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/rating/pages/ratings/ratings.module#CoreRatingRatingsPageModule', name: 'CoreRatingRatingsPage', segment: 'core-rating-ratings', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/settings/pages/list/list.module#CoreSettingsListPageModule', name: 'CoreSettingsListPage', segment: 'core-settings-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/settings/pages/general/general.module#CoreSettingsGeneralPageModule', name: 'CoreSettingsGeneralPage', segment: 'core-settings-general', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/settings/pages/space-usage/space-usage.module#CoreSettingsSpaceUsagePageModule', name: 'CoreSettingsSpaceUsagePage', segment: 'core-settings-space-usage', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/settings/pages/synchronization/synchronization.module#CoreSettingsSynchronizationPageModule', name: 'CoreSettingsSynchronizationPage', segment: 'core-settings-synchronization', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/sharedfiles/pages/choose-site/choose-site.module#CoreSharedFilesChooseSitePageModule', name: 'CoreSharedFilesChooseSitePage', segment: 'core-shared-files-choose-site', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/sharedfiles/pages/list/list.module#CoreSharedFilesListPageModule', name: 'CoreSharedFilesListPage', segment: 'core-shared-files-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/sitehome/pages/index/index.module#CoreSiteHomeIndexPageModule', name: 'CoreSiteHomeIndexPage', segment: 'core-sitehome-index', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/siteplugins/pages/module-index/module-index.module#CoreSitePluginsModuleIndexPageModule', name: 'CoreSitePluginsModuleIndexPage', segment: 'core-site-plugins-module-index-page', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/siteplugins/pages/plugin-page/plugin-page.module#CoreSitePluginsPluginPageModule', name: 'CoreSitePluginsPluginPage', segment: 'core-site-plugins-plugin-page', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/user/pages/about/about.module#CoreUserAboutPageModule', name: 'CoreUserAboutPage', segment: 'core-user-about', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/user/pages/participants/participants.module#CoreUserParticipantsPageModule', name: 'CoreUserParticipantsPage', segment: 'core-user-participants', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/user/pages/profile/profile.module#CoreUserProfilePageModule', name: 'CoreUserProfilePage', segment: 'core-user-profile', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/viewer/pages/iframe/iframe.module#CoreViewerIframePageModule', name: 'CoreViewerIframePage', segment: 'core-viewer-iframe', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/viewer/pages/image/image.module#CoreViewerImagePageModule', name: 'CoreViewerImagePage', segment: 'core-viewer-image', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../core/viewer/pages/text/text.module#CoreViewerTextPageModule', name: 'CoreViewerTextPage', segment: 'core-viewer-text', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/contacts/contacts.module#ContactsPageModule', name: 'ContactsPage', segment: 'contacts', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/faceback/faceback.module#FacebackPageModule', name: 'FacebackPage', segment: 'faceback', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/formdetailorgan/formdetailorgan.module#FormdetailorganPageModule', name: 'FormdetailorganPage', segment: 'formdetailorgan', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/formdetailstudent/formdetailstudent.module#FormdetailstudentPageModule', name: 'FormdetailstudentPage', segment: 'formdetailstudent', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/formdetailteacher/formdetailteacher.module#FormdetailteacherPageModule', name: 'FormdetailteacherPage', segment: 'formdetailteacher', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/goodjob/goodjob.module#GoodjobPageModule', name: 'GoodjobPage', segment: 'goodjob', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/goodstudy/goodstudy.module#GoodstudyPageModule', name: 'GoodstudyPage', segment: 'goodstudy', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/helpcenter/helpcenter.module#HelpcenterPageModule', name: 'HelpcenterPage', segment: 'helpcenter', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/helpdetail/helpdetail.module#HelpdetailPageModule', name: 'HelpdetailPage', segment: 'helpdetail', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/homenewdetail/homenewdetail.module#HomenewdetailPageModule', name: 'HomenewdetailPage', segment: 'homenewdetail', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/htmlpage/htmlpage.module#HtmlpagePageModule', name: 'HtmlpagePage', segment: 'htmlpage', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/livecourse/livecourse.module#LivecoursePageModule', name: 'LivecoursePage', segment: 'livecourse', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/living/living.module#LivingPageModule', name: 'mypage1', segment: 'detail/:id', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/memberdetail/memberdetail.module#MemberdetailPageModule', name: 'MemberdetailPage', segment: 'memberdetail', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/newdetail/newdetail.module#NewdetailPageModule', name: 'NewdetailPage', segment: 'newdetail', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/newlist/newlist.module#NewlistPageModule', name: 'NewlistPage', segment: 'newlist', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/organform/organform.module#OrganformPageModule', name: 'OrganformPage', segment: 'organform', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucabout/oucabout.module#OucaboutPageModule', name: 'OucaboutPage', segment: 'oucabout', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/ouccredit/ouccredit.module#OuccreditPageModule', name: 'OuccreditPage', segment: 'ouccredit', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/ouccommon/ouccommon.module#OuccommonPageModule', name: 'OuccommonPage', segment: 'ouccommon', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucgrade/oucgrade.module#OucgradePageModule', name: 'OucgradePage', segment: 'oucgrade', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/ouchome/ouchome.module#OuchomePageModule', name: 'OuchomePage', segment: 'ouchome', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucmine/oucmine.module#OucminePageModule', name: 'OucminePage', segment: 'oucmine', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucorder/oucorder.module#OucorderPageModule', name: 'OucorderPage', segment: 'oucorder', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucsbout/oucsbout.module#OucsboutPageModule', name: 'OucsboutPage', segment: 'oucsbout', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucstudentstatus/oucstudentstatus.module#OucstudentstatusPageModule', name: 'OucstudentstatusPage', segment: 'oucstudentstatus', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucstudy/oucstudy.module#OucstudyPageModule', name: 'OucstudyPage', segment: 'page-oucstudy', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/ouctabs/ouctabs.module#OuctabsPageModule', name: 'OuctabsPage', segment: 'ouctabs', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/password/password.module#PasswordPageModule', name: 'PasswordPage', segment: 'password', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucwebview/oucwebview.module#OucwebviewPageModule', name: 'OucwebviewPage', segment: 'oucwebview', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/oucshowpdf/oucshowpdf.module#OucshowpdfPageModule', name: 'OucshowpdfPage', segment: 'oucshowpdf', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/sdchat/sdchat.module#SdchatPageModule', name: 'SdchatPage', segment: 'sdchat', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/setting/setting.module#SettingPageModule', name: 'SettingPage', segment: 'setting', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/sdchatmeeting/sdchatmeeting.module#SdchatmeetingPageModule', name: 'SdchatmeetingPage', segment: 'sdchatmeeting', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/specialdetail/specialdetail.module#SpecialdetailPageModule', name: 'SpecialdetailPage', segment: 'specialdetail', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/specilaitylist/specilaitylist.module#SpecilaitylistPageModule', name: 'SpecilaitylistPage', segment: 'specilaitylist', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/studentform/studentform.module#StudentformPageModule', name: 'StudentformPage', segment: 'studentform', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/teacherteam/teacherteam.module#TeacherteamPageModule', name: 'TeacherteamPage', segment: 'teacherteam', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/teamdetail/teamdetail.module#TeamdetailPageModule', name: 'TeamdetailPage', segment: 'teamdetail', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/teammembers/teammembers.module#TeammembersPageModule', name: 'TeammembersPage', segment: 'teammembers', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/teacherform/teacherform.module#TeacherformPageModule', name: 'TeacherformPage', segment: 'teacherform', priority: 'low', defaultHistory: [] }
                    ]
                }),
                __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__["b" /* TranslateModule */].forRoot({
                    loader: {
                        provide: __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__["a" /* TranslateLoader */],
                        useFactory: (createTranslateLoader),
                        deps: [__WEBPACK_IMPORTED_MODULE_8__angular_common_http__["b" /* HttpClient */]]
                    }
                }),
                __WEBPACK_IMPORTED_MODULE_47__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_48__core_emulator_emulator_module__["a" /* CoreEmulatorModule */],
                __WEBPACK_IMPORTED_MODULE_49__core_login_login_module__["b" /* CoreLoginModule */],
                __WEBPACK_IMPORTED_MODULE_50__core_mainmenu_mainmenu_module__["b" /* CoreMainMenuModule */],
                __WEBPACK_IMPORTED_MODULE_51__core_courses_courses_module__["b" /* CoreCoursesModule */],
                __WEBPACK_IMPORTED_MODULE_52__core_fileuploader_fileuploader_module__["b" /* CoreFileUploaderModule */],
                __WEBPACK_IMPORTED_MODULE_53__core_sharedfiles_sharedfiles_module__["b" /* CoreSharedFilesModule */],
                __WEBPACK_IMPORTED_MODULE_54__core_course_course_module__["b" /* CoreCourseModule */],
                __WEBPACK_IMPORTED_MODULE_55__core_sitehome_sitehome_module__["b" /* CoreSiteHomeModule */],
                __WEBPACK_IMPORTED_MODULE_56__core_contentlinks_contentlinks_module__["b" /* CoreContentLinksModule */],
                __WEBPACK_IMPORTED_MODULE_57__core_user_user_module__["b" /* CoreUserModule */],
                __WEBPACK_IMPORTED_MODULE_58__core_grades_grades_module__["b" /* CoreGradesModule */],
                __WEBPACK_IMPORTED_MODULE_59__core_settings_settings_module__["a" /* CoreSettingsModule */],
                __WEBPACK_IMPORTED_MODULE_60__core_siteplugins_siteplugins_module__["a" /* CoreSitePluginsModule */],
                __WEBPACK_IMPORTED_MODULE_61__core_compile_compile_module__["a" /* CoreCompileModule */],
                __WEBPACK_IMPORTED_MODULE_62__core_question_question_module__["b" /* CoreQuestionModule */],
                __WEBPACK_IMPORTED_MODULE_63__core_comments_comments_module__["a" /* CoreCommentsModule */],
                __WEBPACK_IMPORTED_MODULE_64__core_block_block_module__["b" /* CoreBlockModule */],
                __WEBPACK_IMPORTED_MODULE_65__core_rating_rating_module__["a" /* CoreRatingModule */],
                __WEBPACK_IMPORTED_MODULE_105__core_pushnotifications_pushnotifications_module__["b" /* CorePushNotificationsModule */],
                __WEBPACK_IMPORTED_MODULE_66__addon_badges_badges_module__["b" /* AddonBadgesModule */],
                __WEBPACK_IMPORTED_MODULE_67__addon_blog_blog_module__["a" /* AddonBlogModule */],
                __WEBPACK_IMPORTED_MODULE_68__addon_calendar_calendar_module__["b" /* AddonCalendarModule */],
                __WEBPACK_IMPORTED_MODULE_69__addon_competency_competency_module__["b" /* AddonCompetencyModule */],
                __WEBPACK_IMPORTED_MODULE_70__addon_coursecompletion_coursecompletion_module__["a" /* AddonCourseCompletionModule */],
                __WEBPACK_IMPORTED_MODULE_71__addon_userprofilefield_userprofilefield_module__["a" /* AddonUserProfileFieldModule */],
                __WEBPACK_IMPORTED_MODULE_72__addon_files_files_module__["b" /* AddonFilesModule */],
                __WEBPACK_IMPORTED_MODULE_73__addon_block_activitymodules_activitymodules_module__["a" /* AddonBlockActivityModulesModule */],
                __WEBPACK_IMPORTED_MODULE_74__addon_block_myoverview_myoverview_module__["a" /* AddonBlockMyOverviewModule */],
                __WEBPACK_IMPORTED_MODULE_75__addon_block_sitemainmenu_sitemainmenu_module__["a" /* AddonBlockSiteMainMenuModule */],
                __WEBPACK_IMPORTED_MODULE_76__addon_block_timeline_timeline_module__["a" /* AddonBlockTimelineModule */],
                __WEBPACK_IMPORTED_MODULE_77__addon_block_recentlyaccessedcourses_recentlyaccessedcourses_module__["a" /* AddonBlockRecentlyAccessedCoursesModule */],
                __WEBPACK_IMPORTED_MODULE_78__addon_block_recentlyaccesseditems_recentlyaccesseditems_module__["a" /* AddonBlockRecentlyAccessedItemsModule */],
                __WEBPACK_IMPORTED_MODULE_79__addon_block_starredcourses_starredcourses_module__["a" /* AddonBlockStarredCoursesModule */],
                __WEBPACK_IMPORTED_MODULE_80__addon_mod_assign_assign_module__["b" /* AddonModAssignModule */],
                __WEBPACK_IMPORTED_MODULE_81__addon_mod_book_book_module__["b" /* AddonModBookModule */],
                __WEBPACK_IMPORTED_MODULE_82__addon_mod_chat_chat_module__["b" /* AddonModChatModule */],
                __WEBPACK_IMPORTED_MODULE_83__addon_mod_choice_choice_module__["b" /* AddonModChoiceModule */],
                __WEBPACK_IMPORTED_MODULE_84__addon_mod_data_data_module__["a" /* AddonModDataModule */],
                __WEBPACK_IMPORTED_MODULE_85__addon_mod_label_label_module__["a" /* AddonModLabelModule */],
                __WEBPACK_IMPORTED_MODULE_92__addon_mod_lesson_lesson_module__["b" /* AddonModLessonModule */],
                __WEBPACK_IMPORTED_MODULE_87__addon_mod_resource_resource_module__["b" /* AddonModResourceModule */],
                __WEBPACK_IMPORTED_MODULE_88__addon_mod_feedback_feedback_module__["b" /* AddonModFeedbackModule */],
                __WEBPACK_IMPORTED_MODULE_89__addon_mod_folder_folder_module__["b" /* AddonModFolderModule */],
                __WEBPACK_IMPORTED_MODULE_90__addon_mod_forum_forum_module__["b" /* AddonModForumModule */],
                __WEBPACK_IMPORTED_MODULE_91__addon_mod_glossary_glossary_module__["b" /* AddonModGlossaryModule */],
                __WEBPACK_IMPORTED_MODULE_86__addon_mod_lti_lti_module__["b" /* AddonModLtiModule */],
                __WEBPACK_IMPORTED_MODULE_93__addon_mod_page_page_module__["b" /* AddonModPageModule */],
                __WEBPACK_IMPORTED_MODULE_94__addon_mod_quiz_quiz_module__["b" /* AddonModQuizModule */],
                __WEBPACK_IMPORTED_MODULE_95__addon_mod_scorm_scorm_module__["b" /* AddonModScormModule */],
                __WEBPACK_IMPORTED_MODULE_96__addon_mod_url_url_module__["b" /* AddonModUrlModule */],
                __WEBPACK_IMPORTED_MODULE_97__addon_mod_survey_survey_module__["b" /* AddonModSurveyModule */],
                __WEBPACK_IMPORTED_MODULE_98__addon_mod_workshop_workshop_module__["b" /* AddonModWorkshopModule */],
                __WEBPACK_IMPORTED_MODULE_99__addon_mod_imscp_imscp_module__["b" /* AddonModImscpModule */],
                __WEBPACK_IMPORTED_MODULE_100__addon_mod_wiki_wiki_module__["b" /* AddonModWikiModule */],
                __WEBPACK_IMPORTED_MODULE_101__addon_messageoutput_messageoutput_module__["b" /* AddonMessageOutputModule */],
                __WEBPACK_IMPORTED_MODULE_102__addon_messageoutput_airnotifier_airnotifier_module__["a" /* AddonMessageOutputAirnotifierModule */],
                __WEBPACK_IMPORTED_MODULE_103__addon_messages_messages_module__["b" /* AddonMessagesModule */],
                __WEBPACK_IMPORTED_MODULE_104__addon_notes_notes_module__["b" /* AddonNotesModule */],
                __WEBPACK_IMPORTED_MODULE_106__addon_notifications_notifications_module__["b" /* AddonNotificationsModule */],
                __WEBPACK_IMPORTED_MODULE_107__addon_remotethemes_remotethemes_module__["b" /* AddonRemoteThemesModule */],
                __WEBPACK_IMPORTED_MODULE_108__addon_qbehaviour_qbehaviour_module__["a" /* AddonQbehaviourModule */],
                __WEBPACK_IMPORTED_MODULE_109__addon_qtype_qtype_module__["a" /* AddonQtypeModule */],
                __WEBPACK_IMPORTED_MODULE_110__addon_storagemanager_storagemanager_module__["a" /* AddonStorageManagerModule */],
                __WEBPACK_IMPORTED_MODULE_116_angular2_markdown__["a" /* MarkdownModule */].forRoot()
                // PdfViewerModule
            ],
            bootstrap: [__WEBPACK_IMPORTED_MODULE_5_ionic_angular__["k" /* IonicApp */]],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_15__app_component__["a" /* MoodleMobileApp */],
                __WEBPACK_IMPORTED_MODULE_115__pages_showpdf_showpdf__["a" /* ShowpdfPage */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_114__ionic_native_app_version__["a" /* AppVersion */],
                __WEBPACK_IMPORTED_MODULE_19__providers_logger__["a" /* CoreLoggerProvider */],
                __WEBPACK_IMPORTED_MODULE_20__providers_db__["a" /* CoreDbProvider */],
                __WEBPACK_IMPORTED_MODULE_21__providers_app__["a" /* CoreAppProvider */],
                __WEBPACK_IMPORTED_MODULE_22__providers_config__["a" /* CoreConfigProvider */],
                __WEBPACK_IMPORTED_MODULE_23__providers_lang__["a" /* CoreLangProvider */],
                __WEBPACK_IMPORTED_MODULE_24__providers_utils_text__["a" /* CoreTextUtilsProvider */],
                __WEBPACK_IMPORTED_MODULE_25__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
                __WEBPACK_IMPORTED_MODULE_26__providers_utils_iframe__["a" /* CoreIframeUtilsProvider */],
                __WEBPACK_IMPORTED_MODULE_27__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
                __WEBPACK_IMPORTED_MODULE_28__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
                __WEBPACK_IMPORTED_MODULE_29__providers_utils_utils__["a" /* CoreUtilsProvider */],
                __WEBPACK_IMPORTED_MODULE_30__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
                __WEBPACK_IMPORTED_MODULE_31__providers_init__["a" /* CoreInitDelegate */],
                __WEBPACK_IMPORTED_MODULE_32__providers_file__["a" /* CoreFileProvider */],
                __WEBPACK_IMPORTED_MODULE_33__providers_ws__["a" /* CoreWSProvider */],
                __WEBPACK_IMPORTED_MODULE_34__providers_events__["a" /* CoreEventsProvider */],
                __WEBPACK_IMPORTED_MODULE_35__providers_sites_factory__["a" /* CoreSitesFactoryProvider */],
                __WEBPACK_IMPORTED_MODULE_36__providers_sites__["a" /* CoreSitesProvider */],
                __WEBPACK_IMPORTED_MODULE_37__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */],
                __WEBPACK_IMPORTED_MODULE_38__providers_groups__["a" /* CoreGroupsProvider */],
                __WEBPACK_IMPORTED_MODULE_39__providers_cron__["a" /* CoreCronDelegate */],
                __WEBPACK_IMPORTED_MODULE_40__providers_file_session__["a" /* CoreFileSessionProvider */],
                __WEBPACK_IMPORTED_MODULE_41__providers_filepool__["a" /* CoreFilepoolProvider */],
                __WEBPACK_IMPORTED_MODULE_42__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
                __WEBPACK_IMPORTED_MODULE_43__providers_plugin_file_delegate__["a" /* CorePluginFileDelegate */],
                __WEBPACK_IMPORTED_MODULE_44__providers_sync__["a" /* CoreSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_45__providers_file_helper__["a" /* CoreFileHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_46__providers_urlschemes__["a" /* CoreCustomURLSchemesProvider */],
                __WEBPACK_IMPORTED_MODULE_111__providers_oucrest_oucrest__["a" /* OucrestProvider */],
                {
                    provide: __WEBPACK_IMPORTED_MODULE_8__angular_common_http__["a" /* HTTP_INTERCEPTORS */],
                    useClass: __WEBPACK_IMPORTED_MODULE_16__classes_interceptor__["a" /* CoreInterceptor */],
                    multi: true,
                },
                __WEBPACK_IMPORTED_MODULE_14__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
                { provide: __WEBPACK_IMPORTED_MODULE_4__angular_core__["COMPILER_OPTIONS"], useValue: {}, multi: true },
                { provide: __WEBPACK_IMPORTED_MODULE_9__angular_platform_browser_dynamic__["a" /* JitCompilerFactory */], useClass: __WEBPACK_IMPORTED_MODULE_9__angular_platform_browser_dynamic__["a" /* JitCompilerFactory */], deps: [__WEBPACK_IMPORTED_MODULE_4__angular_core__["COMPILER_OPTIONS"]] },
                { provide: __WEBPACK_IMPORTED_MODULE_10__angular_common__["LocationStrategy"], useClass: __WEBPACK_IMPORTED_MODULE_11__angular_common_testing__["a" /* MockLocationStrategy */] },
                __WEBPACK_IMPORTED_MODULE_111__providers_oucrest_oucrest__["a" /* OucrestProvider */],
                __WEBPACK_IMPORTED_MODULE_112__providers_ouclogin_ouclogin__["a" /* OucloginProvider */],
                __WEBPACK_IMPORTED_MODULE_113__providers_native_service_native_service__["a" /* NativeServiceProvider */],
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_31__providers_init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_42__providers_update_manager__["a" /* CoreUpdateManagerProvider */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["e" /* Config */],
            __WEBPACK_IMPORTED_MODULE_36__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_32__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_34__providers_events__["a" /* CoreEventsProvider */]])
    ], AppModule);
    return AppModule;
}());

//# sourceMappingURL=app.module.js.map

/***/ }),
/* 464 */,
/* 465 */,
/* 466 */,
/* 467 */,
/* 468 */,
/* 469 */,
/* 470 */,
/* 471 */,
/* 472 */,
/* 473 */,
/* 474 */,
/* 475 */,
/* 476 */,
/* 477 */,
/* 478 */,
/* 479 */,
/* 480 */,
/* 481 */,
/* 482 */,
/* 483 */,
/* 484 */,
/* 485 */,
/* 486 */,
/* 487 */,
/* 488 */,
/* 489 */,
/* 490 */,
/* 491 */,
/* 492 */,
/* 493 */,
/* 494 */,
/* 495 */,
/* 496 */,
/* 497 */,
/* 498 */,
/* 499 */,
/* 500 */,
/* 501 */,
/* 502 */,
/* 503 */,
/* 504 */,
/* 505 */,
/* 506 */,
/* 507 */,
/* 508 */,
/* 509 */,
/* 510 */,
/* 511 */,
/* 512 */,
/* 513 */,
/* 514 */,
/* 515 */,
/* 516 */,
/* 517 */,
/* 518 */,
/* 519 */,
/* 520 */,
/* 521 */,
/* 522 */,
/* 523 */,
/* 524 */,
/* 525 */,
/* 526 */,
/* 527 */,
/* 528 */,
/* 529 */,
/* 530 */,
/* 531 */,
/* 532 */,
/* 533 */,
/* 534 */,
/* 535 */,
/* 536 */,
/* 537 */,
/* 538 */,
/* 539 */,
/* 540 */,
/* 541 */,
/* 542 */,
/* 543 */,
/* 544 */,
/* 545 */,
/* 546 */,
/* 547 */,
/* 548 */,
/* 549 */,
/* 550 */,
/* 551 */,
/* 552 */,
/* 553 */,
/* 554 */,
/* 555 */,
/* 556 */,
/* 557 */,
/* 558 */,
/* 559 */,
/* 560 */,
/* 561 */,
/* 562 */,
/* 563 */,
/* 564 */,
/* 565 */,
/* 566 */,
/* 567 */,
/* 568 */,
/* 569 */,
/* 570 */,
/* 571 */,
/* 572 */,
/* 573 */,
/* 574 */,
/* 575 */,
/* 576 */,
/* 577 */,
/* 578 */,
/* 579 */,
/* 580 */,
/* 581 */,
/* 582 */,
/* 583 */,
/* 584 */,
/* 585 */,
/* 586 */,
/* 587 */,
/* 588 */,
/* 589 */,
/* 590 */,
/* 591 */,
/* 592 */,
/* 593 */,
/* 594 */,
/* 595 */,
/* 596 */,
/* 597 */,
/* 598 */,
/* 599 */,
/* 600 */,
/* 601 */,
/* 602 */,
/* 603 */,
/* 604 */,
/* 605 */,
/* 606 */,
/* 607 */,
/* 608 */,
/* 609 */,
/* 610 */,
/* 611 */,
/* 612 */,
/* 613 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"../addon/badges/pages/issued-badge/issued-badge.module": [
		1910,
		171
	],
	"../addon/badges/pages/user-badges/user-badges.module": [
		1909,
		170
	],
	"../addon/blog/pages/entries/entries.module": [
		1911,
		169
	],
	"../addon/calendar/pages/event/event.module": [
		1912,
		168
	],
	"../addon/calendar/pages/list/list.module": [
		1913,
		167
	],
	"../addon/calendar/pages/settings/settings.module": [
		1914,
		166
	],
	"../addon/competency/pages/competencies/competencies.module": [
		1915,
		165
	],
	"../addon/competency/pages/competency/competency.module": [
		1917,
		164
	],
	"../addon/competency/pages/competencysummary/competencysummary.module": [
		1916,
		163
	],
	"../addon/competency/pages/coursecompetencies/coursecompetencies.module": [
		1918,
		162
	],
	"../addon/competency/pages/plan/plan.module": [
		1919,
		161
	],
	"../addon/competency/pages/planlist/planlist.module": [
		1920,
		160
	],
	"../addon/coursecompletion/pages/report/report.module": [
		1921,
		159
	],
	"../addon/files/pages/list/list.module": [
		1922,
		158
	],
	"../addon/messageoutput/airnotifier/pages/devices/devices.module": [
		1923,
		157
	],
	"../addon/messages/pages/contacts/contacts.module": [
		1924,
		4
	],
	"../addon/messages/pages/conversation-info/conversation-info.module": [
		1925,
		156
	],
	"../addon/messages/pages/discussion/discussion.module": [
		1926,
		155
	],
	"../addon/messages/pages/group-conversations/group-conversations.module": [
		1927,
		154
	],
	"../addon/messages/pages/index/index.module": [
		1928,
		3
	],
	"../addon/messages/pages/search/search.module": [
		1929,
		2
	],
	"../addon/messages/pages/settings/settings.module": [
		1930,
		1
	],
	"../addon/mod/assign/pages/edit-feedback-modal/edit-feedback-modal.module": [
		1931,
		153
	],
	"../addon/mod/assign/pages/edit/edit.module": [
		1932,
		152
	],
	"../addon/mod/assign/pages/index/index.module": [
		1933,
		151
	],
	"../addon/mod/assign/pages/submission-list/submission-list.module": [
		1934,
		150
	],
	"../addon/mod/assign/pages/submission-review/submission-review.module": [
		1935,
		149
	],
	"../addon/mod/book/pages/index/index.module": [
		1936,
		148
	],
	"../addon/mod/book/pages/toc/toc.module": [
		1937,
		147
	],
	"../addon/mod/chat/pages/chat/chat.module": [
		1938,
		146
	],
	"../addon/mod/chat/pages/index/index.module": [
		1940,
		145
	],
	"../addon/mod/chat/pages/session-messages/session-messages.module": [
		1939,
		144
	],
	"../addon/mod/chat/pages/sessions/sessions.module": [
		1941,
		143
	],
	"../addon/mod/chat/pages/users/users.module": [
		1942,
		142
	],
	"../addon/mod/choice/pages/index/index.module": [
		1943,
		141
	],
	"../addon/mod/data/pages/edit/edit.module": [
		1944,
		140
	],
	"../addon/mod/data/pages/entry/entry.module": [
		1945,
		139
	],
	"../addon/mod/data/pages/index/index.module": [
		1946,
		138
	],
	"../addon/mod/data/pages/search/search.module": [
		1947,
		137
	],
	"../addon/mod/feedback/pages/attempt/attempt.module": [
		1950,
		136
	],
	"../addon/mod/feedback/pages/form/form.module": [
		1948,
		135
	],
	"../addon/mod/feedback/pages/index/index.module": [
		1949,
		134
	],
	"../addon/mod/feedback/pages/nonrespondents/nonrespondents.module": [
		1951,
		133
	],
	"../addon/mod/feedback/pages/respondents/respondents.module": [
		1952,
		132
	],
	"../addon/mod/folder/pages/index/index.module": [
		1953,
		131
	],
	"../addon/mod/forum/pages/discussion/discussion.module": [
		1954,
		130
	],
	"../addon/mod/forum/pages/index/index.module": [
		1955,
		129
	],
	"../addon/mod/forum/pages/new-discussion/new-discussion.module": [
		1956,
		128
	],
	"../addon/mod/forum/pages/sort-order-selector/sort-order-selector.module": [
		1957,
		127
	],
	"../addon/mod/glossary/pages/edit/edit.module": [
		1958,
		126
	],
	"../addon/mod/glossary/pages/entry/entry.module": [
		1959,
		125
	],
	"../addon/mod/glossary/pages/index/index.module": [
		1960,
		124
	],
	"../addon/mod/imscp/pages/index/index.module": [
		1961,
		123
	],
	"../addon/mod/lesson/pages/index/index.module": [
		1962,
		122
	],
	"../addon/mod/lesson/pages/menu-modal/menu-modal.module": [
		1963,
		121
	],
	"../addon/mod/lesson/pages/password-modal/password-modal.module": [
		1964,
		120
	],
	"../addon/mod/lesson/pages/player/player.module": [
		1966,
		119
	],
	"../addon/mod/lesson/pages/user-retake/user-retake.module": [
		1965,
		118
	],
	"../addon/mod/lti/pages/index/index.module": [
		1967,
		117
	],
	"../addon/mod/page/pages/index/index.module": [
		1968,
		116
	],
	"../addon/mod/quiz/pages/attempt/attempt.module": [
		1969,
		115
	],
	"../addon/mod/quiz/pages/index/index.module": [
		1970,
		114
	],
	"../addon/mod/quiz/pages/navigation-modal/navigation-modal.module": [
		1971,
		113
	],
	"../addon/mod/quiz/pages/player/player.module": [
		1972,
		8
	],
	"../addon/mod/quiz/pages/preflight-modal/preflight-modal.module": [
		1973,
		112
	],
	"../addon/mod/quiz/pages/review/review.module": [
		1974,
		111
	],
	"../addon/mod/resource/pages/index/index.module": [
		1975,
		110
	],
	"../addon/mod/scorm/pages/index/index.module": [
		1976,
		109
	],
	"../addon/mod/scorm/pages/player/player.module": [
		1977,
		7
	],
	"../addon/mod/scorm/pages/toc/toc.module": [
		1978,
		108
	],
	"../addon/mod/survey/pages/index/index.module": [
		1979,
		107
	],
	"../addon/mod/url/pages/index/index.module": [
		1980,
		106
	],
	"../addon/mod/wiki/pages/edit/edit.module": [
		1982,
		105
	],
	"../addon/mod/wiki/pages/index/index.module": [
		1981,
		104
	],
	"../addon/mod/workshop/pages/assessment/assessment.module": [
		1983,
		103
	],
	"../addon/mod/workshop/pages/edit-submission/edit-submission.module": [
		1984,
		102
	],
	"../addon/mod/workshop/pages/index/index.module": [
		1985,
		101
	],
	"../addon/mod/workshop/pages/phase/phase.module": [
		1986,
		100
	],
	"../addon/mod/workshop/pages/submission/submission.module": [
		1987,
		6
	],
	"../addon/notes/pages/add/add.module": [
		1989,
		99
	],
	"../addon/notes/pages/list/list.module": [
		1988,
		98
	],
	"../addon/notifications/pages/list/list.module": [
		1991,
		5
	],
	"../addon/notifications/pages/settings/settings.module": [
		1990,
		97
	],
	"../addon/storagemanager/pages/course-storage/course-storage.module": [
		1992,
		96
	],
	"../components/split-view/placeholder/placeholder.module": [
		1993,
		95
	],
	"../core/comments/pages/viewer/viewer.module": [
		1994,
		94
	],
	"../core/contentlinks/pages/choose-site/choose-site.module": [
		1995,
		93
	],
	"../core/course/pages/list-mod-type/list-mod-type.module": [
		1996,
		92
	],
	"../core/course/pages/section-selector/section-selector.module": [
		1997,
		91
	],
	"../core/course/pages/section/section.module": [
		1998,
		172
	],
	"../core/course/pages/unsupported-module/unsupported-module.module": [
		1999,
		90
	],
	"../core/courses/pages/available-courses/available-courses.module": [
		2000,
		89
	],
	"../core/courses/pages/categories/categories.module": [
		2001,
		88
	],
	"../core/courses/pages/course-preview/course-preview.module": [
		2002,
		87
	],
	"../core/courses/pages/dashboard/dashboard.module": [
		2003,
		86
	],
	"../core/courses/pages/my-courses/my-courses.module": [
		2005,
		85
	],
	"../core/courses/pages/search/search.module": [
		2004,
		84
	],
	"../core/courses/pages/self-enrol-password/self-enrol-password.module": [
		2006,
		83
	],
	"../core/emulator/pages/capture-media/capture-media.module": [
		2007,
		82
	],
	"../core/grades/pages/course/course.module": [
		2008,
		81
	],
	"../core/grades/pages/courses/courses.module": [
		2009,
		80
	],
	"../core/grades/pages/coursesplit/coursesplit.module": [
		2011,
		79
	],
	"../core/grades/pages/grade/grade.module": [
		2010,
		78
	],
	"../core/login/pages/credentials/credentials.module": [
		2012,
		77
	],
	"../core/login/pages/email-signup/email-signup.module": [
		2013,
		76
	],
	"../core/login/pages/forgotten-password/forgotten-password.module": [
		2014,
		75
	],
	"../core/login/pages/init/init.module": [
		2015,
		74
	],
	"../core/login/pages/reconnect/reconnect.module": [
		2016,
		73
	],
	"../core/login/pages/site-error/site-error.module": [
		2017,
		72
	],
	"../core/login/pages/site-help/site-help.module": [
		2018,
		71
	],
	"../core/login/pages/site-policy/site-policy.module": [
		2019,
		70
	],
	"../core/login/pages/site/site.module": [
		2020,
		69
	],
	"../core/login/pages/sites/sites.module": [
		2021,
		68
	],
	"../core/mainmenu/pages/menu/menu.module": [
		2022,
		67
	],
	"../core/mainmenu/pages/more/more.module": [
		2023,
		66
	],
	"../core/rating/pages/ratings/ratings.module": [
		2025,
		65
	],
	"../core/settings/pages/about/about.module": [
		2024,
		64
	],
	"../core/settings/pages/general/general.module": [
		2027,
		63
	],
	"../core/settings/pages/list/list.module": [
		2026,
		62
	],
	"../core/settings/pages/space-usage/space-usage.module": [
		2028,
		61
	],
	"../core/settings/pages/synchronization/synchronization.module": [
		2029,
		60
	],
	"../core/sharedfiles/pages/choose-site/choose-site.module": [
		2030,
		59
	],
	"../core/sharedfiles/pages/list/list.module": [
		2031,
		58
	],
	"../core/sitehome/pages/index/index.module": [
		2032,
		57
	],
	"../core/siteplugins/pages/module-index/module-index.module": [
		2033,
		56
	],
	"../core/siteplugins/pages/plugin-page/plugin-page.module": [
		2034,
		55
	],
	"../core/user/pages/about/about.module": [
		2035,
		54
	],
	"../core/user/pages/participants/participants.module": [
		2036,
		53
	],
	"../core/user/pages/profile/profile.module": [
		2037,
		52
	],
	"../core/viewer/pages/iframe/iframe.module": [
		2038,
		51
	],
	"../core/viewer/pages/image/image.module": [
		2039,
		50
	],
	"../core/viewer/pages/text/text.module": [
		2040,
		49
	],
	"../pages/contacts/contacts.module": [
		2041,
		48
	],
	"../pages/faceback/faceback.module": [
		2042,
		47
	],
	"../pages/formdetailorgan/formdetailorgan.module": [
		2043,
		46
	],
	"../pages/formdetailstudent/formdetailstudent.module": [
		2044,
		45
	],
	"../pages/formdetailteacher/formdetailteacher.module": [
		2045,
		44
	],
	"../pages/goodjob/goodjob.module": [
		2046,
		43
	],
	"../pages/goodstudy/goodstudy.module": [
		2047,
		42
	],
	"../pages/helpcenter/helpcenter.module": [
		2048,
		41
	],
	"../pages/helpdetail/helpdetail.module": [
		2049,
		40
	],
	"../pages/homenewdetail/homenewdetail.module": [
		2050,
		39
	],
	"../pages/htmlpage/htmlpage.module": [
		2051,
		38
	],
	"../pages/livecourse/livecourse.module": [
		2052,
		37
	],
	"../pages/living/living.module": [
		2053,
		36
	],
	"../pages/memberdetail/memberdetail.module": [
		2054,
		35
	],
	"../pages/newdetail/newdetail.module": [
		2055,
		34
	],
	"../pages/newlist/newlist.module": [
		2056,
		33
	],
	"../pages/organform/organform.module": [
		2057,
		32
	],
	"../pages/oucabout/oucabout.module": [
		2058,
		31
	],
	"../pages/ouccommon/ouccommon.module": [
		2060,
		30
	],
	"../pages/ouccredit/ouccredit.module": [
		2059,
		0
	],
	"../pages/oucgrade/oucgrade.module": [
		2061,
		29
	],
	"../pages/ouchome/ouchome.module": [
		2062,
		28
	],
	"../pages/oucmine/oucmine.module": [
		2063,
		27
	],
	"../pages/oucorder/oucorder.module": [
		2064,
		26
	],
	"../pages/oucsbout/oucsbout.module": [
		2065,
		25
	],
	"../pages/oucshowpdf/oucshowpdf.module": [
		2071,
		24
	],
	"../pages/oucstudentstatus/oucstudentstatus.module": [
		2066,
		23
	],
	"../pages/oucstudy/oucstudy.module": [
		2067,
		22
	],
	"../pages/ouctabs/ouctabs.module": [
		2068,
		21
	],
	"../pages/oucwebview/oucwebview.module": [
		2070,
		20
	],
	"../pages/password/password.module": [
		2069,
		19
	],
	"../pages/sdchat/sdchat.module": [
		2072,
		18
	],
	"../pages/sdchatmeeting/sdchatmeeting.module": [
		2074,
		17
	],
	"../pages/setting/setting.module": [
		2073,
		16
	],
	"../pages/specialdetail/specialdetail.module": [
		2075,
		15
	],
	"../pages/specilaitylist/specilaitylist.module": [
		2076,
		14
	],
	"../pages/studentform/studentform.module": [
		2077,
		13
	],
	"../pages/teacherform/teacherform.module": [
		2081,
		12
	],
	"../pages/teacherteam/teacherteam.module": [
		2078,
		11
	],
	"../pages/teamdetail/teamdetail.module": [
		2079,
		10
	],
	"../pages/teammembers/teammembers.module": [
		2080,
		9
	]
};
function webpackAsyncContext(req) {
	var ids = map[req];
	if(!ids)
		return Promise.reject(new Error("Cannot find module '" + req + "'."));
	return __webpack_require__.e(ids[1]).then(function() {
		return __webpack_require__(ids[0]);
	});
};
webpackAsyncContext.keys = function webpackAsyncContextKeys() {
	return Object.keys(map);
};
webpackAsyncContext.id = 613;
module.exports = webpackAsyncContext;

/***/ }),
/* 614 */,
/* 615 */,
/* 616 */,
/* 617 */,
/* 618 */,
/* 619 */,
/* 620 */,
/* 621 */,
/* 622 */,
/* 623 */,
/* 624 */,
/* 625 */,
/* 626 */,
/* 627 */,
/* 628 */,
/* 629 */,
/* 630 */,
/* 631 */,
/* 632 */,
/* 633 */,
/* 634 */,
/* 635 */,
/* 636 */,
/* 637 */,
/* 638 */,
/* 639 */,
/* 640 */,
/* 641 */,
/* 642 */,
/* 643 */,
/* 644 */,
/* 645 */,
/* 646 */,
/* 647 */,
/* 648 */,
/* 649 */,
/* 650 */,
/* 651 */,
/* 652 */,
/* 653 */,
/* 654 */,
/* 655 */,
/* 656 */,
/* 657 */,
/* 658 */,
/* 659 */,
/* 660 */,
/* 661 */,
/* 662 */,
/* 663 */,
/* 664 */,
/* 665 */,
/* 666 */,
/* 667 */,
/* 668 */,
/* 669 */,
/* 670 */,
/* 671 */,
/* 672 */,
/* 673 */,
/* 674 */,
/* 675 */,
/* 676 */,
/* 677 */,
/* 678 */,
/* 679 */,
/* 680 */,
/* 681 */,
/* 682 */,
/* 683 */,
/* 684 */,
/* 685 */,
/* 686 */,
/* 687 */,
/* 688 */,
/* 689 */,
/* 690 */,
/* 691 */,
/* 692 */,
/* 693 */,
/* 694 */,
/* 695 */,
/* 696 */,
/* 697 */,
/* 698 */,
/* 699 */,
/* 700 */,
/* 701 */,
/* 702 */,
/* 703 */,
/* 704 */,
/* 705 */,
/* 706 */,
/* 707 */,
/* 708 */,
/* 709 */,
/* 710 */,
/* 711 */,
/* 712 */,
/* 713 */,
/* 714 */,
/* 715 */,
/* 716 */,
/* 717 */,
/* 718 */,
/* 719 */,
/* 720 */,
/* 721 */,
/* 722 */,
/* 723 */,
/* 724 */,
/* 725 */,
/* 726 */,
/* 727 */,
/* 728 */,
/* 729 */,
/* 730 */,
/* 731 */,
/* 732 */,
/* 733 */,
/* 734 */,
/* 735 */,
/* 736 */,
/* 737 */,
/* 738 */,
/* 739 */,
/* 740 */,
/* 741 */,
/* 742 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SQLiteDB; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Class to interact with the local database.
 *
 * @description
 * This class allows creating and interacting with a SQLite database.
 *
 * You need to supply some dependencies when creating the instance:
 * this.db = new SQLiteDB('MyDB', sqlite, platform);
 */
var SQLiteDB = /** @class */ (function () {
    /**
     * Create and open the database.
     *
     * @param {string} name Database name.
     * @param {SQLite} sqlite SQLite library.
     * @param {Platform} platform Ionic platform.
     */
    function SQLiteDB(name, sqlite, platform) {
        this.name = name;
        this.sqlite = sqlite;
        this.platform = platform;
        this.init();
    }
    /**
     * Helper function to create a table if it doesn't exist.
     *
     * @param {string} name The table name.
     * @param {SQLiteDBColumnSchema[]} columns The columns to create in the table.
     * @param {string[]} [primaryKeys] Names of columns that are primary key. Use it for compound primary keys.
     * @param {string[][]} [uniqueKeys] List of sets of unique columns. E.g: [['section', 'title'], ['author', 'title']].
     * @param {SQLiteDBForeignKeySchema[]} [foreignKeys] List of foreign keys.
     * @param {string} [tableCheck] Check constraint for the table.
     * @return SQL query.
     */
    SQLiteDB.prototype.buildCreateTableSql = function (name, columns, primaryKeys, uniqueKeys, foreignKeys, tableCheck) {
        var columnsSql = [];
        var sql = "CREATE TABLE IF NOT EXISTS " + name + " (";
        // First define all the columns.
        for (var index in columns) {
            var column = columns[index];
            var columnSql = column.name || '';
            if (column.type) {
                columnSql += ' ' + column.type;
            }
            if (column.primaryKey) {
                columnSql += ' PRIMARY KEY';
                if (column.autoIncrement) {
                    columnSql += ' AUTOINCREMENT';
                }
            }
            if (column.notNull) {
                columnSql += ' NOT NULL';
            }
            if (column.unique) {
                columnSql += ' UNIQUE';
            }
            if (column.check) {
                columnSql += " CHECK (" + column.check + ")";
            }
            if (typeof column.default != 'undefined') {
                columnSql += " DEFAULT " + column.default;
            }
            columnsSql.push(columnSql);
        }
        sql += columnsSql.join(', ');
        // Now add the table constraints.
        if (primaryKeys && primaryKeys.length) {
            sql += ", PRIMARY KEY (" + primaryKeys.join(', ') + ")";
        }
        if (uniqueKeys && uniqueKeys.length) {
            for (var index in uniqueKeys) {
                var setOfKeys = uniqueKeys[index];
                if (setOfKeys && setOfKeys.length) {
                    sql += ", UNIQUE (" + setOfKeys.join(', ') + ")";
                }
            }
        }
        if (tableCheck) {
            sql += ", CHECK (" + tableCheck + ")";
        }
        for (var index in foreignKeys) {
            var foreignKey = foreignKeys[index];
            if (!foreignKey.columns || !!foreignKey.columns.length) {
                return;
            }
            sql += ", FOREIGN KEY (" + foreignKey.columns.join(', ') + ") REFERENCES " + foreignKey.table + " ";
            if (foreignKey.foreignColumns && foreignKey.foreignColumns.length) {
                sql += "(" + foreignKey.foreignColumns.join(', ') + ")";
            }
            if (foreignKey.actions) {
                sql += " " + foreignKey.actions;
            }
        }
        return sql + ')';
    };
    /**
     * Close the database.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDB.prototype.close = function () {
        var _this = this;
        return this.ready().then(function () {
            return _this.db.close();
        });
    };
    /**
     * Count the records in a table where all the given conditions met.
     *
     * @param {string} table The table to query.
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @return {Promise<number>} Promise resolved with the count of records returned from the specified criteria.
     */
    SQLiteDB.prototype.countRecords = function (table, conditions) {
        var selectAndParams = this.whereClause(conditions);
        return this.countRecordsSelect(table, selectAndParams[0], selectAndParams[1]);
    };
    /**
     * Count the records in a table which match a particular WHERE clause.
     *
     * @param {string} table The table to query.
     * @param {string} [select] A fragment of SQL to be used in a where clause in the SQL call.
     * @param {any} [params] An array of sql parameters.
     * @param {string} [countItem] The count string to be used in the SQL call. Default is COUNT('x').
     * @return {Promise<number>} Promise resolved with the count of records returned from the specified criteria.
     */
    SQLiteDB.prototype.countRecordsSelect = function (table, select, params, countItem) {
        if (select === void 0) { select = ''; }
        if (countItem === void 0) { countItem = 'COUNT(\'x\')'; }
        if (select) {
            select = 'WHERE ' + select;
        }
        return this.countRecordsSql("SELECT " + countItem + " FROM " + table + " " + select, params);
    };
    /**
     * Get the result of a SQL SELECT COUNT(...) query.
     *
     * Given a query that counts rows, return that count.
     *
     * @param {string} sql The SQL string you wish to be executed.
     * @param {any} [params] An array of sql parameters.
     * @return {Promise<number>} Promise resolved with the count.
     */
    SQLiteDB.prototype.countRecordsSql = function (sql, params) {
        return this.getFieldSql(sql, params).then(function (count) {
            if (typeof count != 'number' || count < 0) {
                return 0;
            }
            return count;
        });
    };
    /**
     * Create a table if it doesn't exist.
     *
     * @param {string} name The table name.
     * @param {SQLiteDBColumnSchema[]} columns The columns to create in the table.
     * @param {string[]} [primaryKeys] Names of columns that are primary key. Use it for compound primary keys.
     * @param {string[][]} [uniqueKeys] List of sets of unique columns. E.g: [['section', 'title'], ['author', 'title']].
     * @param {SQLiteDBForeignKeySchema[]} [foreignKeys] List of foreign keys.
     * @param {string} [tableCheck] Check constraint for the table.
     * @return {Promise<any>} Promise resolved when success.
     */
    SQLiteDB.prototype.createTable = function (name, columns, primaryKeys, uniqueKeys, foreignKeys, tableCheck) {
        var sql = this.buildCreateTableSql(name, columns, primaryKeys, uniqueKeys, foreignKeys, tableCheck);
        return this.execute(sql);
    };
    /**
     * Create a table if it doesn't exist from a schema.
     *
     * @param {SQLiteDBTableSchema} table Table schema.
     * @return {Promise<any>} Promise resolved when success.
     */
    SQLiteDB.prototype.createTableFromSchema = function (table) {
        return this.createTable(table.name, table.columns, table.primaryKeys, table.uniqueKeys, table.foreignKeys, table.tableCheck);
    };
    /**
     * Create several tables if they don't exist from a list of schemas.
     *
     * @param {SQLiteDBTableSchema[]} tables List of table schema.
     * @return {Promise<any>} Promise resolved when success.
     */
    SQLiteDB.prototype.createTablesFromSchema = function (tables) {
        var _this = this;
        var promises = [];
        tables.forEach(function (table) {
            promises.push(_this.createTableFromSchema(table));
        });
        return Promise.all(promises);
    };
    /**
     * Delete the records from a table where all the given conditions met.
     * If conditions not specified, table is truncated.
     *
     * @param {string} table The table to delete from.
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDB.prototype.deleteRecords = function (table, conditions) {
        if (conditions === null || typeof conditions == 'undefined') {
            // No conditions, delete the whole table.
            return this.execute("DELETE FROM " + table);
        }
        var selectAndParams = this.whereClause(conditions);
        return this.deleteRecordsSelect(table, selectAndParams[0], selectAndParams[1]);
    };
    /**
     * Delete the records from a table where one field match one list of values.
     *
     * @param {string} table The table to delete from.
     * @param {string} field The name of a field.
     * @param {any[]} values The values field might take.
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDB.prototype.deleteRecordsList = function (table, field, values) {
        var selectAndParams = this.whereClauseList(field, values);
        return this.deleteRecordsSelect(table, selectAndParams[0], selectAndParams[1]);
    };
    /**
     * Delete one or more records from a table which match a particular WHERE clause.
     *
     * @param {string} table The table to delete from.
     * @param {string} [select] A fragment of SQL to be used in a where clause in the SQL call.
     * @param {any[]} [params] Array of sql parameters.
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDB.prototype.deleteRecordsSelect = function (table, select, params) {
        if (select === void 0) { select = ''; }
        if (select) {
            select = 'WHERE ' + select;
        }
        return this.execute("DELETE FROM " + table + " " + select, params);
    };
    /**
     * Drop a table if it exists.
     *
     * @param {string} name The table name.
     * @return {Promise<any>} Promise resolved when success.
     */
    SQLiteDB.prototype.dropTable = function (name) {
        return this.execute("DROP TABLE IF EXISTS " + name);
    };
    /**
     * Execute a SQL query.
     * IMPORTANT: Use this function only if you cannot use any of the other functions in this API. Please take into account that
     * these query will be run in SQLite (Mobile) and Web SQL (desktop), so your query should work in both environments.
     *
     * @param {string} sql SQL query to execute.
     * @param {any[]} params Query parameters.
     * @return {Promise<any>} Promise resolved with the result.
     */
    SQLiteDB.prototype.execute = function (sql, params) {
        var _this = this;
        return this.ready().then(function () {
            return _this.db.executeSql(sql, params);
        });
    };
    /**
     * Execute a set of SQL queries. This operation is atomic.
     * IMPORTANT: Use this function only if you cannot use any of the other functions in this API. Please take into account that
     * these query will be run in SQLite (Mobile) and Web SQL (desktop), so your query should work in both environments.
     *
     * @param {any[]} sqlStatements SQL statements to execute.
     * @return {Promise<any>} Promise resolved with the result.
     */
    SQLiteDB.prototype.executeBatch = function (sqlStatements) {
        var _this = this;
        return this.ready().then(function () {
            return _this.db.sqlBatch(sqlStatements);
        });
    };
    /**
     * Format the data to insert in the database. Removes undefined entries so they are stored as null instead of 'undefined'.
     *
     * @param {object} data Data to insert.
     */
    SQLiteDB.prototype.formatDataToInsert = function (data) {
        if (!data) {
            return;
        }
        // Remove undefined entries and convert null to "NULL".
        for (var name_1 in data) {
            var value = data[name_1];
            if (typeof value == 'undefined') {
                delete data[name_1];
            }
        }
    };
    /**
     * Get all the records from a table.
     *
     * @param {string} table The table to query.
     * @return {Promise<any>} Promise resolved with the records.
     */
    SQLiteDB.prototype.getAllRecords = function (table) {
        return this.getRecords(table);
    };
    /**
     * Get a single field value from a table record where all the given conditions met.
     *
     * @param {string} table The table to query.
     * @param {string} field The field to return the value of.
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @return {Promise<any>} Promise resolved with the field's value.
     */
    SQLiteDB.prototype.getField = function (table, field, conditions) {
        var selectAndParams = this.whereClause(conditions);
        return this.getFieldSelect(table, field, selectAndParams[0], selectAndParams[1]);
    };
    /**
     * Get a single field value from a table record which match a particular WHERE clause.
     *
     * @param {string} table The table to query.
     * @param {string} field The field to return the value of.
     * @param {string} [select=''] A fragment of SQL to be used in a where clause returning one row with one column.
     * @param {any[]} [params] Array of sql parameters.
     * @return {Promise<any>} Promise resolved with the field's value.
     */
    SQLiteDB.prototype.getFieldSelect = function (table, field, select, params) {
        if (select === void 0) { select = ''; }
        if (select) {
            select = 'WHERE ' + select;
        }
        return this.getFieldSql("SELECT " + field + " FROM " + table + " " + select, params);
    };
    /**
     * Get a single field value (first field) using a SQL statement.
     *
     * @param {string} sql The SQL query returning one row with one column.
     * @param {any[]} [params] An array of sql parameters.
     * @return {Promise<any>} Promise resolved with the field's value.
     */
    SQLiteDB.prototype.getFieldSql = function (sql, params) {
        return this.getRecordSql(sql, params).then(function (record) {
            if (!record) {
                return Promise.reject(null);
            }
            // Return the first property.
            return record[Object.keys(record)[0]];
        });
    };
    /**
     * Constructs 'IN()' or '=' sql fragment
     *
     * @param {any} items A single value or array of values for the expression. It doesn't accept objects.
     * @param {boolean} [equal=true] True means we want to equate to the constructed expression.
     * @param {any} [onEmptyItems] This defines the behavior when the array of items provided is empty. Defaults to false,
     *              meaning return empty. Other values will become part of the returned SQL fragment.
     * @return {any[]} A list containing the constructed sql fragment and an array of parameters.
     */
    SQLiteDB.prototype.getInOrEqual = function (items, equal, onEmptyItems) {
        if (equal === void 0) { equal = true; }
        var sql, params;
        if (typeof onEmptyItems == 'undefined') {
            onEmptyItems = false;
        }
        // Default behavior, return empty data on empty array.
        if (Array.isArray(items) && !items.length && onEmptyItems === false) {
            return ['', []];
        }
        // Handle onEmptyItems on empty array of items.
        if (Array.isArray(items) && !items.length) {
            if (onEmptyItems === null) {
                sql = equal ? ' IS NULL' : ' IS NOT NULL';
                return [sql, []];
            }
            else {
                items = [onEmptyItems]; // Rest of cases, prepare items for processing.
            }
        }
        if (!Array.isArray(items) || items.length == 1) {
            sql = equal ? '= ?' : '<> ?';
            params = Array.isArray(items) ? items : [items];
        }
        else {
            sql = (equal ? '' : 'NOT ') + 'IN (' + ',?'.repeat(items.length).substr(1) + ')';
            params = items;
        }
        return [sql, params];
    };
    /**
     * Get the database name.
     *
     * @return {string} Database name.
     */
    SQLiteDB.prototype.getName = function () {
        return this.name;
    };
    /**
     * Get a single database record where all the given conditions met.
     *
     * @param {string} table The table to query.
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @param {string} [fields='*'] A comma separated list of fields to return.
     * @return {Promise<any>} Promise resolved with the record, rejected if not found.
     */
    SQLiteDB.prototype.getRecord = function (table, conditions, fields) {
        if (fields === void 0) { fields = '*'; }
        var selectAndParams = this.whereClause(conditions);
        return this.getRecordSelect(table, selectAndParams[0], selectAndParams[1], fields);
    };
    /**
     * Get a single database record as an object which match a particular WHERE clause.
     *
     * @param {string} table The table to query.
     * @param {string} [select] A fragment of SQL to be used in a where clause in the SQL call.
     * @param {any[]} [params] An array of sql parameters.
     * @param {string} [fields='*'] A comma separated list of fields to return.
     * @return {Promise<any>} Promise resolved with the record, rejected if not found.
     */
    SQLiteDB.prototype.getRecordSelect = function (table, select, params, fields) {
        if (select === void 0) { select = ''; }
        if (params === void 0) { params = []; }
        if (fields === void 0) { fields = '*'; }
        if (select) {
            select = ' WHERE ' + select;
        }
        return this.getRecordSql("SELECT " + fields + " FROM " + table + " " + select, params);
    };
    /**
     * Get a single database record as an object using a SQL statement.
     *
     * The SQL statement should normally only return one record.
     * It is recommended to use getRecordsSql() if more matches possible!
     *
     * @param {string} sql The SQL string you wish to be executed, should normally only return one record.
     * @param {any[]} [params] List of sql parameters
     * @return {Promise<any>} Promise resolved with the records.
     */
    SQLiteDB.prototype.getRecordSql = function (sql, params) {
        return this.getRecordsSql(sql, params, 0, 1).then(function (result) {
            if (!result || !result.length) {
                // Not found, reject.
                return Promise.reject(null);
            }
            // Return only the first record.
            return result[0];
        });
    };
    /**
     * Get a number of records where all the given conditions met.
     *
     * @param {string} table The table to query.
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @param {string} [sort=''] An order to sort the results in.
     * @param {string} [fields='*'] A comma separated list of fields to return.
     * @param {number} [limitFrom=0] Return a subset of records, starting at this point.
     * @param {number} [limitNum=0] Return a subset comprising this many records in total.
     * @return {Promise<any>} Promise resolved with the records.
     */
    SQLiteDB.prototype.getRecords = function (table, conditions, sort, fields, limitFrom, limitNum) {
        if (sort === void 0) { sort = ''; }
        if (fields === void 0) { fields = '*'; }
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNum === void 0) { limitNum = 0; }
        var selectAndParams = this.whereClause(conditions);
        return this.getRecordsSelect(table, selectAndParams[0], selectAndParams[1], sort, fields, limitFrom, limitNum);
    };
    /**
     * Get a number of records where one field match one list of values.
     *
     * @param {string} table The database table to be checked against.
     * @param {string} field The name of a field.
     * @param {any[]} values The values field might take.
     * @param {string} [sort=''] An order to sort the results in.
     * @param {string} [fields='*'] A comma separated list of fields to return.
     * @param {number} [limitFrom=0] Return a subset of records, starting at this point.
     * @param {number} [limitNum=0] Return a subset comprising this many records in total.
     * @return {Promise<any>} Promise resolved with the records.
     */
    SQLiteDB.prototype.getRecordsList = function (table, field, values, sort, fields, limitFrom, limitNum) {
        if (sort === void 0) { sort = ''; }
        if (fields === void 0) { fields = '*'; }
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNum === void 0) { limitNum = 0; }
        var selectAndParams = this.whereClauseList(field, values);
        return this.getRecordsSelect(table, selectAndParams[0], selectAndParams[1], sort, fields, limitFrom, limitNum);
    };
    /**
     * Get a number of records which match a particular WHERE clause.
     *
     * @param {string} table The table to query.
     * @param {string} [select] A fragment of SQL to be used in a where clause in the SQL call.
     * @param {any[]} [params] An array of sql parameters.
     * @param {string} [sort=''] An order to sort the results in.
     * @param {string} [fields='*'] A comma separated list of fields to return.
     * @param {number} [limitFrom=0] Return a subset of records, starting at this point.
     * @param {number} [limitNum=0] Return a subset comprising this many records in total.
     * @return {Promise<any>} Promise resolved with the records.
     */
    SQLiteDB.prototype.getRecordsSelect = function (table, select, params, sort, fields, limitFrom, limitNum) {
        if (select === void 0) { select = ''; }
        if (params === void 0) { params = []; }
        if (sort === void 0) { sort = ''; }
        if (fields === void 0) { fields = '*'; }
        if (limitFrom === void 0) { limitFrom = 0; }
        if (limitNum === void 0) { limitNum = 0; }
        if (select) {
            select = ' WHERE ' + select;
        }
        if (sort) {
            sort = ' ORDER BY ' + sort;
        }
        var sql = "SELECT " + fields + " FROM " + table + " " + select + " " + sort;
        return this.getRecordsSql(sql, params, limitFrom, limitNum);
    };
    /**
     * Get a number of records using a SQL statement.
     *
     * @param {string} sql The SQL select query to execute.
     * @param {any[]} [params] List of sql parameters
     * @param {number} [limitFrom] Return a subset of records, starting at this point.
     * @param {number} [limitNum] Return a subset comprising this many records.
     * @return {Promise<any>} Promise resolved with the records.
     */
    SQLiteDB.prototype.getRecordsSql = function (sql, params, limitFrom, limitNum) {
        var limits = this.normaliseLimitFromNum(limitFrom, limitNum);
        if (limits[0] || limits[1]) {
            if (limits[1] < 1) {
                limits[1] = Number.MAX_VALUE;
            }
            sql += ' LIMIT ' + limits[0] + ', ' + limits[1];
        }
        return this.execute(sql, params).then(function (result) {
            // Retrieve the records.
            var records = [];
            for (var i = 0; i < result.rows.length; i++) {
                records.push(result.rows.item(i));
            }
            return records;
        });
    };
    /**
     * Given a data object, returns the SQL query and the params to insert that record.
     *
     * @param {string} table The database table.
     * @param {object} data A data object with values for one or more fields in the record.
     * @return {any[]} Array with the SQL query and the params.
     */
    SQLiteDB.prototype.getSqlInsertQuery = function (table, data) {
        this.formatDataToInsert(data);
        var keys = Object.keys(data), fields = keys.join(','), questionMarks = ',?'.repeat(keys.length).substr(1);
        return [
            "INSERT OR REPLACE INTO " + table + " (" + fields + ") VALUES (" + questionMarks + ")",
            keys.map(function (key) { return data[key]; })
        ];
    };
    /**
     * Initialize the database.
     */
    SQLiteDB.prototype.init = function () {
        var _this = this;
        this.promise = this.platform.ready().then(function () {
            return _this.sqlite.create({
                name: _this.name,
                location: 'default'
            });
        }).then(function (db) {
            _this.db = db;
        });
    };
    /**
     * Insert a record into a table and return the "rowId" field.
     *
     * @param {string} table The database table to be inserted into.
     * @param {object} data A data object with values for one or more fields in the record.
     * @return {Promise<number>} Promise resolved with new rowId. Please notice this rowId is internal from SQLite.
     */
    SQLiteDB.prototype.insertRecord = function (table, data) {
        var sqlAndParams = this.getSqlInsertQuery(table, data);
        return this.execute(sqlAndParams[0], sqlAndParams[1]).then(function (result) {
            return result.insertId;
        });
    };
    /**
     * Insert multiple records into database as fast as possible.
     *
     * @param {string} table The database table to be inserted into.
     * @param {object[]} dataObjects List of objects to be inserted.
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDB.prototype.insertRecords = function (table, dataObjects) {
        var _this = this;
        if (!Array.isArray(dataObjects)) {
            return Promise.reject(null);
        }
        var statements = [];
        dataObjects.forEach(function (dataObject) {
            statements.push(_this.getSqlInsertQuery(table, dataObject));
        });
        return this.executeBatch(statements);
    };
    /**
     * Insert multiple records into database from another table.
     *
     * @param {string} table The database table to be inserted into.
     * @param {string} source The database table to get the records from.
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @param {string} [fields='*'] A comma separated list of fields to return.
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDB.prototype.insertRecordsFrom = function (table, source, conditions, fields) {
        if (fields === void 0) { fields = '*'; }
        var selectAndParams = this.whereClause(conditions);
        var select = selectAndParams[0] ? 'WHERE ' + selectAndParams[0] : '';
        var params = selectAndParams[1];
        return this.execute("INSERT INTO " + table + " SELECT " + fields + " FROM " + source + " " + select, params);
    };
    /**
     * Ensures that limit params are numeric and positive integers, to be passed to the database.
     * We explicitly treat null, '' and -1 as 0 in order to provide compatibility with how limit
     * values have been passed historically.
     *
     * @param {any} limitFrom Where to start results from.
     * @param {any} limitNum How many results to return.
     * @return {number[]} Normalised limit params in array: [limitFrom, limitNum].
     */
    SQLiteDB.prototype.normaliseLimitFromNum = function (limitFrom, limitNum) {
        // We explicilty treat these cases as 0.
        if (typeof limitFrom == 'undefined' || limitFrom === null || limitFrom === '' || limitFrom === -1) {
            limitFrom = 0;
        }
        if (typeof limitNum == 'undefined' || limitNum === null || limitNum === '' || limitNum === -1) {
            limitNum = 0;
        }
        limitFrom = parseInt(limitFrom, 10);
        limitNum = parseInt(limitNum, 10);
        limitFrom = Math.max(0, limitFrom);
        limitNum = Math.max(0, limitNum);
        return [limitFrom, limitNum];
    };
    /**
     * Open the database. Only needed if it was closed before, a database is automatically opened when created.
     *
     * @return {Promise<void>} Promise resolved when open.
     */
    SQLiteDB.prototype.open = function () {
        var _this = this;
        return this.ready().then(function () {
            return _this.db.open();
        });
    };
    /**
     * Wait for the DB to be ready.
     *
     * @return {Promise<void>} Promise resolved when ready.
     */
    SQLiteDB.prototype.ready = function () {
        return this.promise;
    };
    /**
     * Test whether a record exists in a table where all the given conditions met.
     *
     * @param {string} table The table to check.
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @return {Promise<void>} Promise resolved if exists, rejected otherwise.
     */
    SQLiteDB.prototype.recordExists = function (table, conditions) {
        return this.getRecord(table, conditions).then(function (record) {
            if (!record) {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Test whether any records exists in a table which match a particular WHERE clause.
     *
     * @param {string} table The table to query.
     * @param {string} [select] A fragment of SQL to be used in a where clause in the SQL call.
     * @param {any[]} [params] An array of sql parameters.
     * @return {Promise<any>} Promise resolved if exists, rejected otherwise.
     */
    SQLiteDB.prototype.recordExistsSelect = function (table, select, params) {
        if (select === void 0) { select = ''; }
        if (params === void 0) { params = []; }
        return this.getRecordSelect(table, select, params).then(function (record) {
            if (!record) {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Test whether a SQL SELECT statement returns any records.
     *
     * @param {string} sql The SQL query returning one row with one column.
     * @param {any[]} [params] An array of sql parameters.
     * @return {Promise<any>} Promise resolved if exists, rejected otherwise.
     */
    SQLiteDB.prototype.recordExistsSql = function (sql, params) {
        return this.getRecordSql(sql, params).then(function (record) {
            if (!record) {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Test whether a table exists..
     *
     * @param {string} name The table name.
     * @return {Promise<void>} Promise resolved if exists, rejected otherwise.
     */
    SQLiteDB.prototype.tableExists = function (name) {
        return this.recordExists('sqlite_master', { type: 'table', tbl_name: name });
    };
    /**
     * Update one or more records in a table.
     *
     * @param {string} string table The database table to update.
     * @param {any} data An object with the fields to update: fieldname=>fieldvalue.
     * @param {any} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @return {Promise<any>} Promise resolved when updated.
     */
    SQLiteDB.prototype.updateRecords = function (table, data, conditions) {
        this.formatDataToInsert(data);
        if (!data || !Object.keys(data).length) {
            // No fields to update, consider it's done.
            return Promise.resolve();
        }
        var whereAndParams = this.whereClause(conditions), sets = [];
        var sql, params;
        for (var key in data) {
            sets.push(key + " = ?");
        }
        sql = "UPDATE " + table + " SET " + sets.join(', ') + " WHERE " + whereAndParams[0];
        // Create the list of params using the "data" object and the params for the where clause.
        params = Object.keys(data).map(function (key) { return data[key]; }).concat(whereAndParams[1]);
        return this.execute(sql, params);
    };
    /**
     * Update one or more records in a table. It accepts a WHERE clause as a string.
     *
     * @param {string} string table The database table to update.
     * @param {any} data An object with the fields to update: fieldname=>fieldvalue.
     * @param {string} [where] Where clause. Must not include the "WHERE" word.
     * @param {any[]} [whereParams] Params for the where clause.
     * @return {Promise<any>} Promise resolved when updated.
     */
    SQLiteDB.prototype.updateRecordsWhere = function (table, data, where, whereParams) {
        if (!data || !Object.keys(data).length) {
            // No fields to update, consider it's done.
            return Promise.resolve();
        }
        var sets = [];
        var sql, params;
        for (var key in data) {
            sets.push(key + " = ?");
        }
        sql = "UPDATE " + table + " SET " + sets.join(', ');
        if (where) {
            sql += " WHERE " + where;
        }
        // Create the list of params using the "data" object and the params for the where clause.
        params = Object.keys(data).map(function (key) { return data[key]; });
        if (where && whereParams) {
            params = params.concat(whereParams);
        }
        return this.execute(sql, params);
    };
    /**
     * Returns the SQL WHERE conditions.
     *
     * @param {object} [conditions] The conditions to build the where clause. Must not contain numeric indexes.
     * @return {any[]} An array list containing sql 'where' part and 'params'.
     */
    SQLiteDB.prototype.whereClause = function (conditions) {
        if (conditions === void 0) { conditions = {}; }
        if (!conditions || !Object.keys(conditions).length) {
            return ['1 = 1', []];
        }
        var where = [], params = [];
        for (var key in conditions) {
            var value = conditions[key];
            if (typeof value == 'undefined' || value === null) {
                where.push(key + ' IS NULL');
            }
            else {
                where.push(key + ' = ?');
                params.push(value);
            }
        }
        return [where.join(' AND '), params];
    };
    /**
     * Returns SQL WHERE conditions for the ..._list group of methods.
     *
     * @param {string} field The name of a field.
     * @param {any[]} values The values field might take.
     * @return {any[]} An array containing sql 'where' part and 'params'.
     */
    SQLiteDB.prototype.whereClauseList = function (field, values) {
        if (!values || !values.length) {
            return ['1 = 2', []]; // Fake condition, won't return rows ever.
        }
        var params = [];
        var select = '';
        values.forEach(function (value) {
            if (typeof value == 'boolean') {
                value = Number(value);
            }
            if (typeof value == 'undefined' || value === null) {
                select = field + ' IS NULL';
            }
            else {
                params.push(value);
            }
        });
        if (params && params.length) {
            if (select !== '') {
                select = select + ' OR ';
            }
            if (params.length == 1) {
                select = select + field + ' = ?';
            }
            else {
                var questionMarks = ',?'.repeat(params.length).substr(1);
                select = select + field + ' IN (' + questionMarks + ')';
            }
        }
        return [select, params];
    };
    return SQLiteDB;
}());

//# sourceMappingURL=sqlitedb.js.map

/***/ }),
/* 743 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBSTooltipComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to display a Bootstrap Tooltip in a popover.
 */
var CoreBSTooltipComponent = /** @class */ (function () {
    function CoreBSTooltipComponent(navParams) {
        this.content = navParams.get('content') || '';
        this.html = !!navParams.get('html');
    }
    CoreBSTooltipComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-bs-tooltip',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\bs-tooltip\core-bs-tooltip.html"*/'<ion-item text-wrap>\n    <p *ngIf="html" [innerHTML]="content"></p>\n    <p *ngIf="!html">{{content}}</p>\n</ion-item>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\bs-tooltip\core-bs-tooltip.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */]])
    ], CoreBSTooltipComponent);
    return CoreBSTooltipComponent;
}());

//# sourceMappingURL=bs-tooltip.js.map

/***/ }),
/* 744 */,
/* 745 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreExternalContentDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Directive to handle external content.
 *
 * This directive should be used with any element that links to external content
 * which we want to have available when the app is offline. Typically media and links.
 *
 * If a file is downloaded, its URL will be replaced by the local file URL.
 *
 * From v3.5.2 this directive will also download inline styles, so it can be used in any element as long as it has inline styles.
 */
var CoreExternalContentDirective = /** @class */ (function () {
    function CoreExternalContentDirective(element, logger, filepoolProvider, platform, sitesProvider, domUtils, urlUtils, appProvider, utils) {
        this.filepoolProvider = filepoolProvider;
        this.platform = platform;
        this.sitesProvider = sitesProvider;
        this.domUtils = domUtils;
        this.urlUtils = urlUtils;
        this.appProvider = appProvider;
        this.utils = utils;
        this.initialized = false;
        // This directive can be added dynamically. In that case, the first param is the HTMLElement.
        this.element = element.nativeElement || element;
        this.logger = logger.getInstance('CoreExternalContentDirective');
    }
    /**
     * View has been initialized
     */
    CoreExternalContentDirective.prototype.ngAfterViewInit = function () {
        this.checkAndHandleExternalContent();
        this.initialized = true;
    };
    /**
     * Listen to changes.
     *
     * * @param {{[name: string]: SimpleChange}} changes Changes.
     */
    CoreExternalContentDirective.prototype.ngOnChanges = function (changes) {
        if (changes && this.initialized) {
            // If any of the inputs changes, handle the content again.
            this.checkAndHandleExternalContent();
        }
    };
    /**
     * Add a new source with a certain URL as a sibling of the current element.
     *
     * @param {string} url URL to use in the source.
     */
    CoreExternalContentDirective.prototype.addSource = function (url) {
        if (this.element.tagName !== 'SOURCE') {
            return;
        }
        var newSource = document.createElement('source'), type = this.element.getAttribute('type');
        newSource.setAttribute('src', url);
        if (type) {
            if (this.platform.is('android') && type == 'video/quicktime') {
                // Fix for VideoJS/Chrome bug https://github.com/videojs/video.js/issues/423 .
                newSource.setAttribute('type', 'video/mp4');
            }
            else {
                newSource.setAttribute('type', type);
            }
        }
        this.element.parentNode.insertBefore(newSource, this.element);
    };
    /**
     * Get the URL that should be handled and, if valid, handle it.
     */
    CoreExternalContentDirective.prototype.checkAndHandleExternalContent = function () {
        var _this = this;
        var currentSite = this.sitesProvider.getCurrentSite(), siteId = this.siteId || (currentSite && currentSite.getId()), tagName = this.element.tagName;
        var targetAttr, url;
        // Always handle inline styles (if any).
        this.handleInlineStyles(siteId).catch(function (error) {
            _this.logger.error('Error treating inline styles.', _this.element);
        });
        if (tagName === 'A') {
            targetAttr = 'href';
            url = this.href;
        }
        else if (tagName === 'IMG') {
            targetAttr = 'src';
            url = this.src;
        }
        else if (tagName === 'AUDIO' || tagName === 'VIDEO' || tagName === 'SOURCE' || tagName === 'TRACK') {
            targetAttr = 'src';
            url = this.targetSrc || this.src;
            if (tagName === 'VIDEO') {
                if (this.poster) {
                    // Handle poster.
                    this.handleExternalContent('poster', this.poster, siteId).catch(function () {
                        // Ignore errors.
                    });
                }
            }
        }
        else {
            return;
        }
        this.handleExternalContent(targetAttr, url, siteId).catch(function () {
            // Ignore errors.
        });
    };
    /**
     * Handle external content, setting the right URL.
     *
     * @param {string} targetAttr Attribute to modify.
     * @param {string} url Original URL to treat.
     * @param {string} [siteId] Site ID.
     * @return {Promise<any>} Promise resolved if the element is successfully treated.
     */
    CoreExternalContentDirective.prototype.handleExternalContent = function (targetAttr, url, siteId) {
        var _this = this;
        var tagName = this.element.tagName;
        if (tagName == 'VIDEO' && targetAttr != 'poster') {
            var video = this.element;
            if (video.textTracks) {
                // It's a video with subtitles. In iOS, subtitles position is wrong so it needs to be fixed.
                video.textTracks.onaddtrack = function (event) {
                    var track = event.track;
                    if (track) {
                        track.oncuechange = function () {
                            var line = _this.platform.is('tablet') || _this.platform.is('android') ? 90 : 80;
                            // Position all subtitles to a percentage of video height.
                            Array.from(track.cues).forEach(function (cue) {
                                cue.snapToLines = false;
                                cue.line = line;
                                cue.size = 100; // This solves some Android issue.
                            });
                            // Delete listener.
                            track.oncuechange = null;
                        };
                    }
                };
            }
        }
        if (!url || !url.match(/^https?:\/\//i) || (tagName === 'A' && !this.urlUtils.isDownloadableUrl(url))) {
            this.logger.debug('Ignoring non-downloadable URL: ' + url);
            if (tagName === 'SOURCE') {
                // Restoring original src.
                this.addSource(url);
            }
            return Promise.reject(null);
        }
        // Get the webservice pluginfile URL, we ignore failures here.
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!site.canDownloadFiles() && _this.urlUtils.isPluginFileUrl(url)) {
                _this.element.parentElement.removeChild(_this.element); // Remove element since it'll be broken.
                return Promise.reject(null);
            }
            // Download images, tracks and posters if size is unknown.
            var dwnUnknown = tagName == 'IMG' || tagName == 'TRACK' || targetAttr == 'poster';
            var promise;
            if (targetAttr === 'src' && tagName !== 'SOURCE' && tagName !== 'TRACK' && tagName !== 'VIDEO' &&
                tagName !== 'AUDIO') {
                promise = _this.filepoolProvider.getSrcByUrl(siteId, url, _this.component, _this.componentId, 0, true, dwnUnknown);
            }
            else {
                promise = _this.filepoolProvider.getUrlByUrl(siteId, url, _this.component, _this.componentId, 0, true, dwnUnknown);
            }
            return promise.then(function (finalUrl) {
                if (finalUrl.match(/^https?:\/\//i)) {
                    /* In iOS, if we use the same URL in embedded file and background download then the download only
                       downloads a few bytes (cached ones). Add a hash to the URL so both URLs are different. */
                    finalUrl = finalUrl + '#moodlemobile-embedded';
                }
                _this.logger.debug('Using URL ' + finalUrl + ' for ' + url);
                if (tagName === 'SOURCE') {
                    // The browser does not catch changes in SRC, we need to add a new source.
                    _this.addSource(finalUrl);
                }
                else {
                    _this.element.setAttribute(targetAttr, finalUrl);
                }
                // Set events to download big files (not downloaded automatically).
                if (finalUrl.indexOf('http') === 0 && targetAttr != 'poster' &&
                    (tagName == 'VIDEO' || tagName == 'AUDIO' || tagName == 'A' || tagName == 'SOURCE')) {
                    var eventName = tagName == 'A' ? 'click' : 'play';
                    var clickableEl = _this.element;
                    if (tagName == 'SOURCE') {
                        clickableEl = _this.domUtils.closest(_this.element, 'video,audio');
                        if (!clickableEl) {
                            return;
                        }
                    }
                    clickableEl.addEventListener(eventName, function () {
                        // User played media or opened a downloadable link.
                        // Download the file if in wifi and it hasn't been downloaded already (for big files).
                        if (_this.appProvider.isWifi()) {
                            // We aren't using the result, so it doesn't matter which of the 2 functions we call.
                            _this.filepoolProvider.getUrlByUrl(siteId, url, _this.component, _this.componentId, 0, false);
                        }
                    });
                }
            });
        });
    };
    /**
     * Handle inline styles, trying to download referenced files.
     *
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved if the element is successfully treated.
     */
    CoreExternalContentDirective.prototype.handleInlineStyles = function (siteId) {
        var _this = this;
        var inlineStyles = this.element.getAttribute('style');
        if (!inlineStyles) {
            return Promise.resolve();
        }
        var urls = inlineStyles.match(/https?:\/\/[^"'\) ;]*/g);
        if (!urls || !urls.length) {
            return Promise.resolve();
        }
        var promises = [];
        urls = this.utils.uniqueArray(urls); // Remove duplicates.
        urls.forEach(function (url) {
            promises.push(_this.filepoolProvider.getUrlByUrl(siteId, url, _this.component, _this.componentId, 0, true, true)
                .then(function (finalUrl) {
                _this.logger.debug('Using URL ' + finalUrl + ' for ' + url + ' in inline styles');
                inlineStyles = inlineStyles.replace(new RegExp(url, 'gi'), finalUrl);
            }));
        });
        return this.utils.allPromises(promises).then(function () {
            _this.element.setAttribute('style', inlineStyles);
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreExternalContentDirective.prototype, "siteId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreExternalContentDirective.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreExternalContentDirective.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreExternalContentDirective.prototype, "src", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreExternalContentDirective.prototype, "href", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('target-src'),
        __metadata("design:type", String)
    ], CoreExternalContentDirective.prototype, "targetSrc", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreExternalContentDirective.prototype, "poster", void 0);
    CoreExternalContentDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-external-content]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreExternalContentDirective);
    return CoreExternalContentDirective;
}());

//# sourceMappingURL=external-content.js.map

/***/ }),
/* 746 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatDefaultHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Default handler used when the course format doesn't have a specific implementation.
 */
var CoreCourseFormatDefaultHandler = /** @class */ (function () {
    function CoreCourseFormatDefaultHandler(coursesProvider, injector) {
        this.coursesProvider = coursesProvider;
        this.injector = injector;
        this.name = 'CoreCourseFormatDefault';
        this.format = 'default';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreCourseFormatDefaultHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the title to use in course page.
     *
     * @param {any} course The course.
     * @return {string} Title.
     */
    CoreCourseFormatDefaultHandler.prototype.getCourseTitle = function (course) {
        if (course.displayname) {
            return course.displayname;
        }
        else if (course.fullname) {
            return course.fullname;
        }
        else {
            return '';
        }
    };
    /**
     * Whether it allows seeing all sections at the same time. Defaults to true.
     *
     * @param {any} course The course to check.
     * @type {boolean} Whether it can view all sections.
     */
    CoreCourseFormatDefaultHandler.prototype.canViewAllSections = function (course) {
        return true;
    };
    /**
     * Whether the option to enable section/module download should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @return {boolean} Whether the option to enable section/module download should be displayed
     */
    CoreCourseFormatDefaultHandler.prototype.displayEnableDownload = function (course) {
        return true;
    };
    /**
     * Whether the default section selector should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @type {boolean} Whether the default section selector should be displayed.
     */
    CoreCourseFormatDefaultHandler.prototype.displaySectionSelector = function (course) {
        return true;
    };
    /**
     * Whether the course refresher should be displayed. If it returns false, a refresher must be included in the course format,
     * and the doRefresh method of CoreCourseSectionPage must be called on refresh. Defaults to true.
     *
     * @param {any} course The course to check.
     * @param {any[]} sections List of course sections.
     * @return {boolean} Whether the refresher should be displayed.
     */
    CoreCourseFormatDefaultHandler.prototype.displayRefresher = function (course, sections) {
        return true;
    };
    /**
     * Given a list of sections, get the "current" section that should be displayed first.
     *
     * @param {any} course The course to get the title.
     * @param {any[]} sections List of sections.
     * @return {any|Promise<any>} Current section (or promise resolved with current section).
     */
    CoreCourseFormatDefaultHandler.prototype.getCurrentSection = function (course, sections) {
        var promise;
        // We need the "marker" to determine the current section.
        if (typeof course.marker != 'undefined') {
            // We already have it.
            promise = Promise.resolve(course.marker);
        }
        else if (!this.coursesProvider.isGetCoursesByFieldAvailable()) {
            // Cannot get the current section, return all of them.
            return sections[0];
        }
        else {
            // Try to retrieve the marker.
            promise = this.coursesProvider.getCourseByField('id', course.id).catch(function () {
                // Ignore errors.
            }).then(function (course) {
                return course && course.marker;
            });
        }
        return promise.then(function (marker) {
            if (marker > 0) {
                // Find the marked section.
                var section = sections.find(function (sect) {
                    return sect.section == marker;
                });
                if (section) {
                    return section;
                }
            }
            // Marked section not found or we couldn't retrieve the marker. Return all sections.
            return sections[0];
        });
    };
    /**
     * Invalidate the data required to load the course format.
     *
     * @param {any} course The course to get the title.
     * @param {any[]} sections List of sections.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseFormatDefaultHandler.prototype.invalidateData = function (course, sections) {
        return this.coursesProvider.invalidateCoursesByField('id', course.id);
    };
    /**
     * Open the page to display a course. If not defined, the page CoreCourseSectionPage will be opened.
     * Implement it only if you want to create your own page to display the course. In general it's better to use the method
     * getCourseFormatComponent because it will display the course handlers at the top.
     * Your page should include the course handlers using CoreCoursesDelegate.
     *
     * @param {NavController} navCtrl The NavController instance to use. If not defined, please use loginHelper.redirect.
     * @param {any} course The course to open. It should contain a "format" attribute.
     * @param {any} [params] Params to pass to the course page.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseFormatDefaultHandler.prototype.openCourse = function (navCtrl, course, params) {
        params = params || {};
        Object.assign(params, { course: course });
        if (navCtrl) {
            // Don't return the .push promise, we don't want to display a loading modal during the page transition.
            navCtrl.push('CoreCourseSectionPage', params);
            return Promise.resolve();
        }
        else {
            // Open the course in the "phantom" tab.
            this.loginHelper = this.loginHelper || this.injector.get(__WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]);
            return this.loginHelper.redirect('CoreCourseSectionPage', params);
        }
    };
    /**
     * Whether the view should be refreshed when completion changes. If your course format doesn't display
     * activity completion then you should return false.
     *
     * @param {any} course The course.
     * @return {boolean|Promise<boolean>} Whether course view should be refreshed when an activity completion changes.
     */
    CoreCourseFormatDefaultHandler.prototype.shouldRefreshWhenCompletionChanges = function (course) {
        return true;
    };
    CoreCourseFormatDefaultHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], CoreCourseFormatDefaultHandler);
    return CoreCourseFormatDefaultHandler;
}());

//# sourceMappingURL=default-format.js.map

/***/ }),
/* 747 */,
/* 748 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLinkDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_split_view_split_view__ = __webpack_require__(121);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};









/**
 * Directive to open a link in external browser.
 */
var CoreLinkDirective = /** @class */ (function () {
    function CoreLinkDirective(element, domUtils, utils, sitesProvider, urlUtils, contentLinksHelper, navCtrl, content, svComponent) {
        this.domUtils = domUtils;
        this.utils = utils;
        this.sitesProvider = sitesProvider;
        this.urlUtils = urlUtils;
        this.contentLinksHelper = contentLinksHelper;
        this.navCtrl = navCtrl;
        this.content = content;
        this.svComponent = svComponent;
        this.autoLogin = 'check'; // If the link should be open with auto-login. Accepts the following values:
        // This directive can be added dynamically. In that case, the first param is the anchor HTMLElement.
        this.element = element.nativeElement || element;
    }
    /**
     * Function executed when the component is initialized.
     */
    CoreLinkDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.inApp = this.utils.isTrueOrOne(this.inApp);
        var navCtrl = this.navCtrl;
        if (this.svComponent && (!this.navCtrl || this.navCtrl === this.svComponent.getDetailsNav())) {
            // The link is in the right side of a split view. Always open them with the left side NavController.
            navCtrl = this.svComponent.getMasterNav();
        }
        this.element.addEventListener('click', function (event) {
            // If the event prevented default action, do nothing.
            if (!event.defaultPrevented) {
                var href_1 = _this.element.getAttribute('href');
                if (href_1) {
                    event.preventDefault();
                    event.stopPropagation();
                    if (_this.utils.isTrueOrOne(_this.capture)) {
                        _this.contentLinksHelper.handleLink(href_1, undefined, navCtrl, true, true).then(function (treated) {
                            if (!treated) {
                                _this.navigate(href_1);
                            }
                        });
                    }
                    else {
                        _this.navigate(href_1);
                    }
                }
            }
        });
    };
    /**
     * Convenience function to correctly navigate, open file or url in the browser.
     *
     * @param {string} href HREF to be opened.
     */
    CoreLinkDirective.prototype.navigate = function (href) {
        var _this = this;
        var contentLinksScheme = __WEBPACK_IMPORTED_MODULE_7__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://link=';
        if (href.indexOf('cdvfile://') === 0 || href.indexOf('file://') === 0 || href.indexOf('filesystem:') === 0) {
            // We have a local file.
            this.utils.openFile(href).catch(function (error) {
                _this.domUtils.showErrorModal(error);
            });
        }
        else if (href.charAt(0) == '#') {
            href = href.substr(1);
            // In site links
            if (href.charAt(0) == '/') {
                // @todo: This cannot be achieved with push/pop navigation, location.go() doesn't update the state, only the URL.
                // In Ionic 4 the navigation will change, so maybe it can be done by then.
            }
            else {
                // Look for id or name.
                this.domUtils.scrollToElementBySelector(this.content, '#' + href + ', [name=\'' + href + '\']');
            }
        }
        else if (href.indexOf(contentLinksScheme) === 0) {
            // Link should be treated by Custom URL Scheme. Encode the right part, otherwise ':' is removed in iOS.
            href = contentLinksScheme + encodeURIComponent(href.replace(contentLinksScheme, ''));
            this.utils.openInBrowser(href);
        }
        else {
            // It's an external link, we will open with browser. Check if we need to auto-login.
            if (!this.sitesProvider.isLoggedIn()) {
                // Not logged in, cannot auto-login.
                if (this.inApp) {
                    this.utils.openInApp(href);
                }
                else {
                    this.utils.openInBrowser(href);
                }
            }
            else {
                // Check if URL does not have any protocol, so it's a relative URL.
                if (!this.urlUtils.isAbsoluteURL(href)) {
                    // Add the site URL at the begining.
                    if (href.charAt(0) == '/') {
                        href = this.sitesProvider.getCurrentSite().getURL() + href;
                    }
                    else {
                        href = this.sitesProvider.getCurrentSite().getURL() + '/' + href;
                    }
                }
                if (this.autoLogin == 'yes') {
                    if (this.inApp) {
                        this.sitesProvider.getCurrentSite().openInAppWithAutoLogin(href);
                    }
                    else {
                        this.sitesProvider.getCurrentSite().openInBrowserWithAutoLogin(href);
                    }
                }
                else if (this.autoLogin == 'no') {
                    if (this.inApp) {
                        this.utils.openInApp(href);
                    }
                    else {
                        this.utils.openInBrowser(href);
                    }
                }
                else {
                    if (this.inApp) {
                        this.sitesProvider.getCurrentSite().openInAppWithAutoLoginIfSameSite(href);
                    }
                    else {
                        this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(href);
                    }
                }
            }
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreLinkDirective.prototype, "capture", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreLinkDirective.prototype, "inApp", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreLinkDirective.prototype, "autoLogin", void 0);
    CoreLinkDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-link]'
        }),
        __param(6, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __param(7, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()), __param(8, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */], __WEBPACK_IMPORTED_MODULE_8__components_split_view_split_view__["a" /* CoreSplitViewComponent */]])
    ], CoreLinkDirective);
    return CoreLinkDirective;
}());

//# sourceMappingURL=link.js.map

/***/ }),
/* 749 */,
/* 750 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContextMenuComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__context_menu_popover__ = __webpack_require__(751);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_tabs_tab__ = __webpack_require__(752);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};








/**
 * This component adds a button (usually in the navigation bar) that displays a context menu popover.
 */
var CoreContextMenuComponent = /** @class */ (function () {
    function CoreContextMenuComponent(translate, popoverCtrl, elementRef, domUtils, coreTab, utils) {
        var _this = this;
        this.translate = translate;
        this.popoverCtrl = popoverCtrl;
        this.domUtils = domUtils;
        this.coreTab = coreTab;
        this.hideMenu = true; // It will be unhidden when items are added.
        this.expanded = false;
        this.items = [];
        this.itemsMovedToParent = [];
        // Create the stream and subscribe to it. We ignore successive changes during 250ms.
        this.itemsChangedStream = new __WEBPACK_IMPORTED_MODULE_7_rxjs__["Subject"]();
        this.itemsChangedStream.auditTime(250).subscribe(function () {
            // Hide the menu if all items are hidden.
            _this.hideMenu = !_this.items.some(function (item) {
                return !item.hidden;
            });
            // Sort the items by priority.
            _this.items.sort(function (a, b) {
                return a.priority <= b.priority ? 1 : -1;
            });
        });
        // Calculate the unique ID.
        this.uniqueId = 'core-context-menu-' + utils.getUniqueId('CoreContextMenuComponent');
        this.instanceId = this.domUtils.storeInstanceByElement(elementRef.nativeElement, this);
    }
    /**
     * Component being initialized.
     */
    CoreContextMenuComponent.prototype.ngOnInit = function () {
        this.icon = this.icon || 'more';
        this.ariaLabel = this.ariaLabel || this.title || this.translate.instant('core.info');
    };
    /**
     * Add a context menu item.
     *
     * @param {CoreContextMenuItemComponent} item The item to add.
     */
    CoreContextMenuComponent.prototype.addItem = function (item) {
        if (this.parentContextMenu) {
            // All items were moved to the "parent" menu. Add the item in there.
            this.parentContextMenu.addItem(item);
            if (this.itemsMovedToParent.indexOf(item) == -1) {
                this.itemsMovedToParent.push(item);
            }
        }
        else if (this.items.indexOf(item) == -1) {
            this.items.push(item);
            this.itemsChanged();
        }
    };
    /**
     * Function called when the items change.
     */
    CoreContextMenuComponent.prototype.itemsChanged = function () {
        if (this.parentContextMenu) {
            // All items were moved to the "parent" menu, call the function in there.
            this.parentContextMenu.itemsChanged();
        }
        else {
            this.itemsChangedStream.next();
        }
    };
    /**
     * Merge the current context menu with the one passed as parameter. All the items in this menu will be moved to the
     * one passed as parameter.
     *
     * @param {CoreContextMenuComponent} contextMenu The context menu where to move the items.
     */
    CoreContextMenuComponent.prototype.mergeContextMenus = function (contextMenu) {
        this.parentContextMenu = contextMenu;
        // Add all the items to the other menu.
        for (var i = 0; i < this.items.length; i++) {
            var item = this.items[i];
            contextMenu.addItem(item);
            this.itemsMovedToParent.push(item);
        }
        // Remove all items from the current menu.
        this.items = [];
        this.itemsChanged();
    };
    /**
     * Remove an item from the context menu.
     *
     * @param {CoreContextMenuItemComponent} item The item to remove.
     */
    CoreContextMenuComponent.prototype.removeItem = function (item) {
        if (this.parentContextMenu) {
            // All items were moved to the "parent" menu. Remove the item from there.
            this.parentContextMenu.removeItem(item);
            var index = this.itemsMovedToParent.indexOf(item);
            if (index >= 0) {
                this.itemsMovedToParent.splice(index, 1);
            }
        }
        else {
            var index = this.items.indexOf(item);
            if (index >= 0) {
                this.items.splice(index, 1);
            }
            this.itemsChanged();
        }
    };
    /**
     * Remove the items that were merged to a parent context menu.
     */
    CoreContextMenuComponent.prototype.removeMergedItems = function () {
        if (this.parentContextMenu) {
            for (var i = 0; i < this.itemsMovedToParent.length; i++) {
                this.parentContextMenu.removeItem(this.itemsMovedToParent[i]);
            }
        }
    };
    /**
     * Restore the items that were merged to a parent context menu.
     */
    CoreContextMenuComponent.prototype.restoreMergedItems = function () {
        if (this.parentContextMenu) {
            for (var i = 0; i < this.itemsMovedToParent.length; i++) {
                this.parentContextMenu.addItem(this.itemsMovedToParent[i]);
            }
        }
    };
    /**
     * Show the context menu.
     *
     * @param {MouseEvent} event Event.
     */
    CoreContextMenuComponent.prototype.showContextMenu = function (event) {
        var _this = this;
        if (!this.expanded) {
            var popover = this.popoverCtrl.create(__WEBPACK_IMPORTED_MODULE_5__context_menu_popover__["a" /* CoreContextMenuPopoverComponent */], { title: this.title, items: this.items, id: this.uniqueId });
            popover.onDidDismiss(function () {
                _this.expanded = false;
            });
            popover.present({
                ev: event
            });
            this.expanded = true;
        }
    };
    /**
     * Component destroyed.
     */
    CoreContextMenuComponent.prototype.ngOnDestroy = function () {
        this.domUtils.removeInstanceById(this.instanceId);
        this.removeMergedItems();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuComponent.prototype, "icon", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuComponent.prototype, "title", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('aria-label'),
        __metadata("design:type", String)
    ], CoreContextMenuComponent.prototype, "ariaLabel", void 0);
    CoreContextMenuComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-context-menu',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\context-menu\core-context-menu.html"*/'<button [hidden]="hideMenu" ion-button clear icon-only [attr.aria-label]="ariaLabel" (click)="showContextMenu($event)" class="bar-button" aria-haspopup="true" [attr.aria-expanded]="expanded" [attr.aria-controls]="uniqueId">\n    <core-icon [name]="icon"></core-icon>\n</button>\n<ng-content></ng-content>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\context-menu\core-context-menu.html"*/
        }),
        __param(4, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["x" /* PopoverController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__components_tabs_tab__["a" /* CoreTabComponent */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreContextMenuComponent);
    return CoreContextMenuComponent;
}());

//# sourceMappingURL=context-menu.js.map

/***/ }),
/* 751 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContextMenuPopoverComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to display a list of items received by param in a popover.
 */
var CoreContextMenuPopoverComponent = /** @class */ (function () {
    function CoreContextMenuPopoverComponent(navParams, viewCtrl, logger) {
        this.viewCtrl = viewCtrl;
        this.title = navParams.get('title');
        this.items = navParams.get('items') || [];
        this.uniqueId = navParams.get('id');
        this.logger = logger.getInstance('CoreContextMenuPopoverComponent');
    }
    /**
     * Close the popover.
     */
    CoreContextMenuPopoverComponent.prototype.closeMenu = function () {
        this.viewCtrl.dismiss();
    };
    /**
     * Function called when an item is clicked.
     *
     * @param {Event} event Click event.
     * @param {CoreContextMenuItemComponent} item Item clicked.
     * @return {boolean} Return true if success, false if error.
     */
    CoreContextMenuPopoverComponent.prototype.itemClicked = function (event, item) {
        if (item.action.observers.length > 0) {
            event.preventDefault();
            event.stopPropagation();
            if (item.iconAction == 'spinner') {
                return false;
            }
            if (item.closeOnClick) {
                this.closeMenu();
            }
            item.action.emit(this.closeMenu.bind(this));
        }
        else if (item.href && item.closeOnClick) {
            this.closeMenu();
        }
        return true;
    };
    CoreContextMenuPopoverComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-context-menu-popover',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\context-menu\core-context-menu-popover.html"*/'<ion-list [id]="uniqueId" role="menu">\n    <ion-list-header *ngIf="title">{{title}}</ion-list-header>\n    <a ion-item text-wrap *ngFor="let item of items" core-link [capture]="item.captureLink" [autoLogin]="item.autoLogin" [href]="item.href" (click)="itemClicked($event, item)" [attr.aria-label]="item.ariaAction" [hidden]="item.hidden" [attr.detail-none]="!item.href || item.iconAction" role="menuitem">\n        <core-icon *ngIf="item.iconDescription" [name]="item.iconDescription" [label]="item.ariaDescription" item-start></core-icon>\n        <core-format-text [clean]="true" [text]="item.content"></core-format-text>\n        <core-icon *ngIf="(item.href || item.action) && item.iconAction && item.iconAction != \'spinner\'" [name]="item.iconAction" [slash]="item.iconSlash" item-end></core-icon>\n        <ion-spinner *ngIf="(item.href || item.action) && item.iconAction == \'spinner\'" item-end></ion-spinner>\n        <ion-badge class="{{item.badgeClass}}" item-end *ngIf="item.badge">{{item.badge}}</ion-badge>\n    </a>\n</ion-list>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\context-menu\core-context-menu-popover.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */], __WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */]])
    ], CoreContextMenuPopoverComponent);
    return CoreContextMenuPopoverComponent;
}());

//# sourceMappingURL=context-menu-popover.js.map

/***/ }),
/* 752 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreTabComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__tabs__ = __webpack_require__(151);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * A tab to use inside core-tabs. The content of this tab will be displayed when the tab is selected.
 *
 * You must provide either a title or an icon for the tab.
 *
 * The tab content MUST be surrounded by ng-template. This component uses ngTemplateOutlet instead of ng-content because the
 * latter executes all the code immediately. This means that all the tabs would be initialized as soon as your view is
 * loaded, leading to performance issues.
 *
 * Example usage:
 *
 * <core-tabs selectedIndex="1">
 *     <core-tab [title]="'core.courses.timeline' | translate" (ionSelect)="switchTab('timeline')">
 *         <ng-template> <!-- This ng-template is required. -->
 *             <!-- Tab contents. -->
 *         </ng-template>
 *     </core-tab>
 * </core-tabs>
 */
var CoreTabComponent = /** @class */ (function () {
    function CoreTabComponent(tabs, element, domUtils, utils) {
        this.tabs = tabs;
        this.domUtils = domUtils;
        this.enabled = true; // Whether the tab is enabled.
        this.ionSelect = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.loaded = false;
        this.initialized = false;
        this._show = true;
        this.element = element.nativeElement;
        this.element.setAttribute('role', 'tabpanel');
        this.element.setAttribute('tabindex', '0');
        this.id = this.id || 'core-tab-' + utils.getUniqueId('CoreTabComponent');
    }
    Object.defineProperty(CoreTabComponent.prototype, "show", {
        get: function () {
            return this._show;
        },
        set: function (val) {
            if (typeof val != 'undefined') {
                var hasChanged = this._show != val;
                this._show = val;
                if (this.initialized && hasChanged) {
                    this.tabs.tabVisibilityChanged();
                    this.updateAriaHidden();
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Component being initialized.
     */
    CoreTabComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.element.setAttribute('aria-labelledby', this.id + '-tab');
        this.element.setAttribute('id', this.id);
        this.tabs.addTab(this);
        this.initialized = true;
        setTimeout(function () {
            _this.updateAriaHidden();
        }, 1000);
    };
    /**
     * Component destroyed.
     */
    CoreTabComponent.prototype.ngOnDestroy = function () {
        this.tabs.removeTab(this);
    };
    /**
     * Select tab.
     */
    CoreTabComponent.prototype.selectTab = function () {
        var _this = this;
        this.element.classList.add('selected');
        this.tabElement = this.tabElement || document.getElementById(this.id + '-tab');
        this.updateAriaHidden();
        this.tabElement && this.tabElement.setAttribute('aria-selected', true);
        this.loaded = true;
        this.ionSelect.emit(this);
        this.showHideNavBarButtons(true);
        // Setup tab scrolling.
        setTimeout(function () {
            // Workaround to solve undefined this.scroll on tab change.
            var scroll = _this.content ? _this.content.getScrollElement() :
                _this.element.querySelector('ion-content > .scroll-content');
            if (scroll) {
                scroll.onscroll = function (e) {
                    _this.tabs.showHideTabs(e.target);
                };
                _this.tabs.showHideTabs(scroll);
            }
        }, 1);
    };
    /**
     * Unselect tab.
     */
    CoreTabComponent.prototype.unselectTab = function () {
        this.updateAriaHidden();
        this.tabElement && this.tabElement.setAttribute('aria-selected', false);
        this.element.classList.remove('selected');
        this.showHideNavBarButtons(false);
    };
    /**
     * Get all child core-navbar-buttons. We need to use querySelectorAll because ContentChildren doesn't work with ng-template.
     * https://github.com/angular/angular/issues/14842
     *
     * @return {CoreNavBarButtonsComponent[]} List of component instances.
     */
    CoreTabComponent.prototype.getChildrenNavBarButtons = function () {
        var elements = this.element.querySelectorAll('core-navbar-buttons'), instances = [];
        for (var i = 0; i < elements.length; i++) {
            var instance = this.domUtils.getInstanceByElement(elements[i]);
            if (instance) {
                instances.push(instance);
            }
        }
        return instances;
    };
    /**
     * Show all hide all children navbar buttons.
     *
     * @param {boolean} show Whether to show or hide the buttons.
     */
    CoreTabComponent.prototype.showHideNavBarButtons = function (show) {
        var instances = this.getChildrenNavBarButtons();
        for (var i in instances) {
            instances[i].forceHide(!show);
        }
    };
    /**
     * Update aria hidden attribute.
     */
    CoreTabComponent.prototype.updateAriaHidden = function () {
        if (!this.tabElement) {
            this.tabElement = document.getElementById(this.id + '-tab');
        }
        if (this.tabElement) {
            this.tabElement && this.tabElement.setAttribute('aria-hidden', !this._show);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTabComponent.prototype, "title", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTabComponent.prototype, "icon", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTabComponent.prototype, "badge", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTabComponent.prototype, "badgeStyle", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreTabComponent.prototype, "enabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], CoreTabComponent.prototype, "show", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTabComponent.prototype, "id", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreTabComponent.prototype, "ionSelect", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ContentChild"])(__WEBPACK_IMPORTED_MODULE_0__angular_core__["TemplateRef"]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["TemplateRef"])
    ], CoreTabComponent.prototype, "template", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ContentChild"])(__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["f" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["f" /* Content */])
    ], CoreTabComponent.prototype, "content", void 0);
    CoreTabComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-tab',
            template: '<ng-container *ngIf="loaded" [ngTemplateOutlet]="template"></ng-container>'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__tabs__["a" /* CoreTabsComponent */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreTabComponent);
    return CoreTabComponent;
}());

//# sourceMappingURL=tab.js.map

/***/ }),
/* 753 */,
/* 754 */,
/* 755 */,
/* 756 */,
/* 757 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRecaptchaModalComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to display a the recaptcha in a modal.
 */
var CoreRecaptchaModalComponent = /** @class */ (function () {
    function CoreRecaptchaModalComponent(viewCtrl, params) {
        this.viewCtrl = viewCtrl;
        this.expired = false;
        this.value = '';
        this.src = params.get('src');
    }
    /**
     * Close modal.
     */
    CoreRecaptchaModalComponent.prototype.closeModal = function () {
        this.viewCtrl.dismiss({
            expired: this.expired,
            value: this.value
        });
    };
    /**
     * The iframe with the recaptcha was loaded.
     *
     * @param {HTMLIFrameElement} iframe Iframe element.
     */
    CoreRecaptchaModalComponent.prototype.loaded = function (iframe) {
        var _this = this;
        // Search the iframe content.
        var contentWindow = iframe && iframe.contentWindow;
        if (contentWindow) {
            // Set the callbacks we're interested in.
            contentWindow['recaptchacallback'] = function (value) {
                _this.expired = false;
                _this.value = value;
                _this.closeModal();
            };
            contentWindow['recaptchaexpiredcallback'] = function () {
                // Verification expired. Check the checkbox again.
                _this.expired = true;
                _this.value = '';
            };
        }
    };
    CoreRecaptchaModalComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-recaptcha-modal',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\recaptcha\core-recaptchamodal.html"*/'<ion-header>\n    <ion-navbar core-back-button>\n        <ion-title>{{ \'core.login.security_question\' | translate }}</ion-title>\n\n        <ion-buttons end>\n            <button ion-button icon-only (click)="closeModal()" [attr.aria-label]="\'core.close\' | translate">\n                <ion-icon name="close"></ion-icon>\n            </button>\n        </ion-buttons>\n    </ion-navbar>\n</ion-header>\n<ion-content>\n    <core-iframe [src]="src" (loaded)="loaded($event)"></core-iframe>\n</ion-content>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\recaptcha\core-recaptchamodal.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */]])
    ], CoreRecaptchaModalComponent);
    return CoreRecaptchaModalComponent;
}());

//# sourceMappingURL=recaptchamodal.js.map

/***/ }),
/* 758 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModuleDefaultHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__course__ = __webpack_require__(10);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Default handler used when the module doesn't have a specific implementation.
 */
var CoreCourseModuleDefaultHandler = /** @class */ (function () {
    function CoreCourseModuleDefaultHandler(sitesProvider, courseProvider) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.name = 'CoreCourseModuleDefault';
        this.modName = 'default';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreCourseModuleDefaultHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    CoreCourseModuleDefaultHandler.prototype.getData = function (module, courseId, sectionId) {
        var _this = this;
        // Return the default data.
        var defaultData = {
            icon: this.courseProvider.getModuleIconSrc(module.modname, module.modicon),
            title: module.name,
            class: 'core-course-default-handler core-course-module-' + module.modname + '-handler',
            action: function (event, navCtrl, module, courseId, options) {
                event.preventDefault();
                event.stopPropagation();
                navCtrl.push('CoreCourseUnsupportedModulePage', { module: module }, options);
            }
        };
        if (module.url) {
            defaultData.buttons = [{
                    icon: 'open',
                    label: 'core.openinbrowser',
                    action: function (e) {
                        e.preventDefault();
                        e.stopPropagation();
                        _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(module.url);
                    }
                }];
        }
        return defaultData;
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreCourseModuleDefaultHandler.prototype.getMainComponent = function (injector, course, module) {
        // We can't inject CoreCourseUnsupportedModuleComponent here due to circular dependencies.
        // Don't return anything, by default it will use CoreCourseUnsupportedModuleComponent.
    };
    /**
     * Whether to display the course refresher in single activity course format. If it returns false, a refresher must be
     * included in the template that calls the doRefresh method of the component. Defaults to true.
     *
     * @return {boolean} Whether the refresher should be displayed.
     */
    CoreCourseModuleDefaultHandler.prototype.displayRefresherInSingleActivity = function () {
        return true;
    };
    CoreCourseModuleDefaultHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__course__["a" /* CoreCourseProvider */]])
    ], CoreCourseModuleDefaultHandler);
    return CoreCourseModuleDefaultHandler;
}());

//# sourceMappingURL=default-module.js.map

/***/ }),
/* 759 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCache; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * A cache to store values in memory to speed up processes.
 *
 * The data is organized by "entries" that are identified by an ID. Each entry can have multiple values stored,
 * and each value has its own timemodified.
 *
 * Values expire after a certain time.
 */
var CoreCache = /** @class */ (function () {
    function CoreCache() {
        this.cacheStore = {};
        // Nothing to do.
    }
    /**
     * Clear the cache.
     */
    CoreCache.prototype.clear = function () {
        this.cacheStore = {};
    };
    /**
     * Get all the data stored in the cache for a certain id.
     *
     * @param {any} id The ID to identify the entry.
     * @return {any} The data from the cache. Undefined if not found.
     */
    CoreCache.prototype.getEntry = function (id) {
        if (!this.cacheStore[id]) {
            this.cacheStore[id] = {};
        }
        return this.cacheStore[id];
    };
    /**
     * Get the status of a module from the "cache".
     *
     * @param {any} id The ID to identify the entry.
     * @param {string} name Name of the value to get.
     * @param {boolean} [ignoreInvalidate] Whether it should always return the cached data, even if it's expired.
     * @return {any} Cached value. Undefined if not cached or expired.
     */
    CoreCache.prototype.getValue = function (id, name, ignoreInvalidate) {
        var entry = this.getEntry(id);
        if (entry[name] && typeof entry[name].value != 'undefined') {
            var now = Date.now();
            // Invalidate after 5 minutes.
            if (ignoreInvalidate || entry[name].timemodified + 300000 >= now) {
                return entry[name].value;
            }
        }
        return undefined;
    };
    /**
     * Invalidate all the cached data for a certain entry.
     *
     * @param {any} id The ID to identify the entry.
     */
    CoreCache.prototype.invalidate = function (id) {
        var entry = this.getEntry(id);
        for (var name_1 in entry) {
            entry[name_1].timemodified = 0;
        }
    };
    /**
     * Update the status of a module in the "cache".
     *
     * @param {any} id The ID to identify the entry.
     * @param {string} name Name of the value to set.
     * @param {any} value Value to set.
     * @return {any} The set value.
     */
    CoreCache.prototype.setValue = function (id, name, value) {
        var entry = this.getEntry(id);
        entry[name] = {
            value: value,
            timemodified: Date.now()
        };
        return value;
    };
    return CoreCache;
}());

//# sourceMappingURL=cache.js.map

/***/ }),
/* 760 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer, global, process) {/**
 * @licstart The following is the entire license notice for the
 * Javascript code in this page
 *
 * Copyright 2018 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * Javascript code in this page
 */

(function webpackUniversalModuleDefinition(root, factory) {
	if(true)
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("pdfjs-dist/build/pdf", [], factory);
	else if(typeof exports === 'object')
		exports["pdfjs-dist/build/pdf"] = factory();
	else
		root["pdfjs-dist/build/pdf"] = root.pdfjsLib = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __w_pdfjs_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __w_pdfjs_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__w_pdfjs_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__w_pdfjs_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__w_pdfjs_require__.d = function(exports, name, getter) {
/******/ 		if(!__w_pdfjs_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__w_pdfjs_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__w_pdfjs_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __w_pdfjs_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__w_pdfjs_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __w_pdfjs_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__w_pdfjs_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__w_pdfjs_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__w_pdfjs_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__w_pdfjs_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __w_pdfjs_require__(__w_pdfjs_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var pdfjsVersion = '2.1.266';
var pdfjsBuild = '81f5835c';

var pdfjsSharedUtil = __w_pdfjs_require__(1);

var pdfjsDisplayAPI = __w_pdfjs_require__(146);

var pdfjsDisplayTextLayer = __w_pdfjs_require__(162);

var pdfjsDisplayAnnotationLayer = __w_pdfjs_require__(163);

var pdfjsDisplayDOMUtils = __w_pdfjs_require__(151);

var pdfjsDisplaySVG = __w_pdfjs_require__(164);

var pdfjsDisplayWorkerOptions = __w_pdfjs_require__(156);

var pdfjsDisplayAPICompatibility = __w_pdfjs_require__(153);

{
  var isNodeJS = __w_pdfjs_require__(4);

  if (isNodeJS()) {
    var PDFNodeStream = __w_pdfjs_require__(165).PDFNodeStream;

    pdfjsDisplayAPI.setPDFNetworkStreamFactory(function (params) {
      return new PDFNodeStream(params);
    });
  } else if (typeof Response !== 'undefined' && 'body' in Response.prototype && typeof ReadableStream !== 'undefined') {
    var PDFFetchStream = __w_pdfjs_require__(168).PDFFetchStream;

    pdfjsDisplayAPI.setPDFNetworkStreamFactory(function (params) {
      return new PDFFetchStream(params);
    });
  } else {
    var PDFNetworkStream = __w_pdfjs_require__(169).PDFNetworkStream;

    pdfjsDisplayAPI.setPDFNetworkStreamFactory(function (params) {
      return new PDFNetworkStream(params);
    });
  }
}
exports.build = pdfjsDisplayAPI.build;
exports.version = pdfjsDisplayAPI.version;
exports.getDocument = pdfjsDisplayAPI.getDocument;
exports.LoopbackPort = pdfjsDisplayAPI.LoopbackPort;
exports.PDFDataRangeTransport = pdfjsDisplayAPI.PDFDataRangeTransport;
exports.PDFWorker = pdfjsDisplayAPI.PDFWorker;
exports.renderTextLayer = pdfjsDisplayTextLayer.renderTextLayer;
exports.AnnotationLayer = pdfjsDisplayAnnotationLayer.AnnotationLayer;
exports.createPromiseCapability = pdfjsSharedUtil.createPromiseCapability;
exports.PasswordResponses = pdfjsSharedUtil.PasswordResponses;
exports.InvalidPDFException = pdfjsSharedUtil.InvalidPDFException;
exports.MissingPDFException = pdfjsSharedUtil.MissingPDFException;
exports.SVGGraphics = pdfjsDisplaySVG.SVGGraphics;
exports.NativeImageDecoding = pdfjsSharedUtil.NativeImageDecoding;
exports.CMapCompressionType = pdfjsSharedUtil.CMapCompressionType;
exports.PermissionFlag = pdfjsSharedUtil.PermissionFlag;
exports.UnexpectedResponseException = pdfjsSharedUtil.UnexpectedResponseException;
exports.OPS = pdfjsSharedUtil.OPS;
exports.VerbosityLevel = pdfjsSharedUtil.VerbosityLevel;
exports.UNSUPPORTED_FEATURES = pdfjsSharedUtil.UNSUPPORTED_FEATURES;
exports.createValidAbsoluteUrl = pdfjsSharedUtil.createValidAbsoluteUrl;
exports.createObjectURL = pdfjsSharedUtil.createObjectURL;
exports.removeNullCharacters = pdfjsSharedUtil.removeNullCharacters;
exports.shadow = pdfjsSharedUtil.shadow;
exports.Util = pdfjsSharedUtil.Util;
exports.ReadableStream = pdfjsSharedUtil.ReadableStream;
exports.URL = pdfjsSharedUtil.URL;
exports.RenderingCancelledException = pdfjsDisplayDOMUtils.RenderingCancelledException;
exports.getFilenameFromUrl = pdfjsDisplayDOMUtils.getFilenameFromUrl;
exports.LinkTarget = pdfjsDisplayDOMUtils.LinkTarget;
exports.addLinkAttributes = pdfjsDisplayDOMUtils.addLinkAttributes;
exports.loadScript = pdfjsDisplayDOMUtils.loadScript;
exports.GlobalWorkerOptions = pdfjsDisplayWorkerOptions.GlobalWorkerOptions;
exports.apiCompatibilityParams = pdfjsDisplayAPICompatibility.apiCompatibilityParams;

/***/ }),
/* 1 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toRomanNumerals = toRomanNumerals;
exports.arrayByteLength = arrayByteLength;
exports.arraysToBytes = arraysToBytes;
exports.assert = assert;
exports.bytesToString = bytesToString;
exports.createPromiseCapability = createPromiseCapability;
exports.deprecated = deprecated;
exports.getInheritableProperty = getInheritableProperty;
exports.getLookupTableFactory = getLookupTableFactory;
exports.getVerbosityLevel = getVerbosityLevel;
exports.info = info;
exports.isArrayBuffer = isArrayBuffer;
exports.isBool = isBool;
exports.isEmptyObj = isEmptyObj;
exports.isNum = isNum;
exports.isString = isString;
exports.isSpace = isSpace;
exports.isSameOrigin = isSameOrigin;
exports.createValidAbsoluteUrl = createValidAbsoluteUrl;
exports.isLittleEndian = isLittleEndian;
exports.isEvalSupported = isEvalSupported;
exports.log2 = log2;
exports.readInt8 = readInt8;
exports.readUint16 = readUint16;
exports.readUint32 = readUint32;
exports.removeNullCharacters = removeNullCharacters;
exports.setVerbosityLevel = setVerbosityLevel;
exports.shadow = shadow;
exports.string32 = string32;
exports.stringToBytes = stringToBytes;
exports.stringToPDFString = stringToPDFString;
exports.stringToUTF8String = stringToUTF8String;
exports.utf8StringToString = utf8StringToString;
exports.warn = warn;
exports.unreachable = unreachable;
Object.defineProperty(exports, "ReadableStream", {
  enumerable: true,
  get: function get() {
    return _streams_polyfill.ReadableStream;
  }
});
Object.defineProperty(exports, "URL", {
  enumerable: true,
  get: function get() {
    return _url_polyfill.URL;
  }
});
exports.createObjectURL = exports.FormatError = exports.XRefParseException = exports.XRefEntryException = exports.Util = exports.UnknownErrorException = exports.UnexpectedResponseException = exports.TextRenderingMode = exports.StreamType = exports.PermissionFlag = exports.PasswordResponses = exports.PasswordException = exports.NativeImageDecoding = exports.MissingPDFException = exports.MissingDataException = exports.InvalidPDFException = exports.AbortException = exports.CMapCompressionType = exports.ImageKind = exports.FontType = exports.AnnotationType = exports.AnnotationFlag = exports.AnnotationFieldFlag = exports.AnnotationBorderStyleType = exports.UNSUPPORTED_FEATURES = exports.VerbosityLevel = exports.OPS = exports.IDENTITY_MATRIX = exports.FONT_IDENTITY_MATRIX = void 0;

__w_pdfjs_require__(2);

var _streams_polyfill = __w_pdfjs_require__(142);

var _url_polyfill = __w_pdfjs_require__(144);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var IDENTITY_MATRIX = [1, 0, 0, 1, 0, 0];
exports.IDENTITY_MATRIX = IDENTITY_MATRIX;
var FONT_IDENTITY_MATRIX = [0.001, 0, 0, 0.001, 0, 0];
exports.FONT_IDENTITY_MATRIX = FONT_IDENTITY_MATRIX;
var NativeImageDecoding = {
  NONE: 'none',
  DECODE: 'decode',
  DISPLAY: 'display'
};
exports.NativeImageDecoding = NativeImageDecoding;
var PermissionFlag = {
  PRINT: 0x04,
  MODIFY_CONTENTS: 0x08,
  COPY: 0x10,
  MODIFY_ANNOTATIONS: 0x20,
  FILL_INTERACTIVE_FORMS: 0x100,
  COPY_FOR_ACCESSIBILITY: 0x200,
  ASSEMBLE: 0x400,
  PRINT_HIGH_QUALITY: 0x800
};
exports.PermissionFlag = PermissionFlag;
var TextRenderingMode = {
  FILL: 0,
  STROKE: 1,
  FILL_STROKE: 2,
  INVISIBLE: 3,
  FILL_ADD_TO_PATH: 4,
  STROKE_ADD_TO_PATH: 5,
  FILL_STROKE_ADD_TO_PATH: 6,
  ADD_TO_PATH: 7,
  FILL_STROKE_MASK: 3,
  ADD_TO_PATH_FLAG: 4
};
exports.TextRenderingMode = TextRenderingMode;
var ImageKind = {
  GRAYSCALE_1BPP: 1,
  RGB_24BPP: 2,
  RGBA_32BPP: 3
};
exports.ImageKind = ImageKind;
var AnnotationType = {
  TEXT: 1,
  LINK: 2,
  FREETEXT: 3,
  LINE: 4,
  SQUARE: 5,
  CIRCLE: 6,
  POLYGON: 7,
  POLYLINE: 8,
  HIGHLIGHT: 9,
  UNDERLINE: 10,
  SQUIGGLY: 11,
  STRIKEOUT: 12,
  STAMP: 13,
  CARET: 14,
  INK: 15,
  POPUP: 16,
  FILEATTACHMENT: 17,
  SOUND: 18,
  MOVIE: 19,
  WIDGET: 20,
  SCREEN: 21,
  PRINTERMARK: 22,
  TRAPNET: 23,
  WATERMARK: 24,
  THREED: 25,
  REDACT: 26
};
exports.AnnotationType = AnnotationType;
var AnnotationFlag = {
  INVISIBLE: 0x01,
  HIDDEN: 0x02,
  PRINT: 0x04,
  NOZOOM: 0x08,
  NOROTATE: 0x10,
  NOVIEW: 0x20,
  READONLY: 0x40,
  LOCKED: 0x80,
  TOGGLENOVIEW: 0x100,
  LOCKEDCONTENTS: 0x200
};
exports.AnnotationFlag = AnnotationFlag;
var AnnotationFieldFlag = {
  READONLY: 0x0000001,
  REQUIRED: 0x0000002,
  NOEXPORT: 0x0000004,
  MULTILINE: 0x0001000,
  PASSWORD: 0x0002000,
  NOTOGGLETOOFF: 0x0004000,
  RADIO: 0x0008000,
  PUSHBUTTON: 0x0010000,
  COMBO: 0x0020000,
  EDIT: 0x0040000,
  SORT: 0x0080000,
  FILESELECT: 0x0100000,
  MULTISELECT: 0x0200000,
  DONOTSPELLCHECK: 0x0400000,
  DONOTSCROLL: 0x0800000,
  COMB: 0x1000000,
  RICHTEXT: 0x2000000,
  RADIOSINUNISON: 0x2000000,
  COMMITONSELCHANGE: 0x4000000
};
exports.AnnotationFieldFlag = AnnotationFieldFlag;
var AnnotationBorderStyleType = {
  SOLID: 1,
  DASHED: 2,
  BEVELED: 3,
  INSET: 4,
  UNDERLINE: 5
};
exports.AnnotationBorderStyleType = AnnotationBorderStyleType;
var StreamType = {
  UNKNOWN: 0,
  FLATE: 1,
  LZW: 2,
  DCT: 3,
  JPX: 4,
  JBIG: 5,
  A85: 6,
  AHX: 7,
  CCF: 8,
  RL: 9
};
exports.StreamType = StreamType;
var FontType = {
  UNKNOWN: 0,
  TYPE1: 1,
  TYPE1C: 2,
  CIDFONTTYPE0: 3,
  CIDFONTTYPE0C: 4,
  TRUETYPE: 5,
  CIDFONTTYPE2: 6,
  TYPE3: 7,
  OPENTYPE: 8,
  TYPE0: 9,
  MMTYPE1: 10
};
exports.FontType = FontType;
var VerbosityLevel = {
  ERRORS: 0,
  WARNINGS: 1,
  INFOS: 5
};
exports.VerbosityLevel = VerbosityLevel;
var CMapCompressionType = {
  NONE: 0,
  BINARY: 1,
  STREAM: 2
};
exports.CMapCompressionType = CMapCompressionType;
var OPS = {
  dependency: 1,
  setLineWidth: 2,
  setLineCap: 3,
  setLineJoin: 4,
  setMiterLimit: 5,
  setDash: 6,
  setRenderingIntent: 7,
  setFlatness: 8,
  setGState: 9,
  save: 10,
  restore: 11,
  transform: 12,
  moveTo: 13,
  lineTo: 14,
  curveTo: 15,
  curveTo2: 16,
  curveTo3: 17,
  closePath: 18,
  rectangle: 19,
  stroke: 20,
  closeStroke: 21,
  fill: 22,
  eoFill: 23,
  fillStroke: 24,
  eoFillStroke: 25,
  closeFillStroke: 26,
  closeEOFillStroke: 27,
  endPath: 28,
  clip: 29,
  eoClip: 30,
  beginText: 31,
  endText: 32,
  setCharSpacing: 33,
  setWordSpacing: 34,
  setHScale: 35,
  setLeading: 36,
  setFont: 37,
  setTextRenderingMode: 38,
  setTextRise: 39,
  moveText: 40,
  setLeadingMoveText: 41,
  setTextMatrix: 42,
  nextLine: 43,
  showText: 44,
  showSpacedText: 45,
  nextLineShowText: 46,
  nextLineSetSpacingShowText: 47,
  setCharWidth: 48,
  setCharWidthAndBounds: 49,
  setStrokeColorSpace: 50,
  setFillColorSpace: 51,
  setStrokeColor: 52,
  setStrokeColorN: 53,
  setFillColor: 54,
  setFillColorN: 55,
  setStrokeGray: 56,
  setFillGray: 57,
  setStrokeRGBColor: 58,
  setFillRGBColor: 59,
  setStrokeCMYKColor: 60,
  setFillCMYKColor: 61,
  shadingFill: 62,
  beginInlineImage: 63,
  beginImageData: 64,
  endInlineImage: 65,
  paintXObject: 66,
  markPoint: 67,
  markPointProps: 68,
  beginMarkedContent: 69,
  beginMarkedContentProps: 70,
  endMarkedContent: 71,
  beginCompat: 72,
  endCompat: 73,
  paintFormXObjectBegin: 74,
  paintFormXObjectEnd: 75,
  beginGroup: 76,
  endGroup: 77,
  beginAnnotations: 78,
  endAnnotations: 79,
  beginAnnotation: 80,
  endAnnotation: 81,
  paintJpegXObject: 82,
  paintImageMaskXObject: 83,
  paintImageMaskXObjectGroup: 84,
  paintImageXObject: 85,
  paintInlineImageXObject: 86,
  paintInlineImageXObjectGroup: 87,
  paintImageXObjectRepeat: 88,
  paintImageMaskXObjectRepeat: 89,
  paintSolidColorImageMask: 90,
  constructPath: 91
};
exports.OPS = OPS;
var UNSUPPORTED_FEATURES = {
  unknown: 'unknown',
  forms: 'forms',
  javaScript: 'javaScript',
  smask: 'smask',
  shadingPattern: 'shadingPattern',
  font: 'font'
};
exports.UNSUPPORTED_FEATURES = UNSUPPORTED_FEATURES;
var PasswordResponses = {
  NEED_PASSWORD: 1,
  INCORRECT_PASSWORD: 2
};
exports.PasswordResponses = PasswordResponses;
var verbosity = VerbosityLevel.WARNINGS;

function setVerbosityLevel(level) {
  if (Number.isInteger(level)) {
    verbosity = level;
  }
}

function getVerbosityLevel() {
  return verbosity;
}

function info(msg) {
  if (verbosity >= VerbosityLevel.INFOS) {
    console.log('Info: ' + msg);
  }
}

function warn(msg) {
  if (verbosity >= VerbosityLevel.WARNINGS) {
    console.log('Warning: ' + msg);
  }
}

function deprecated(details) {
  console.log('Deprecated API usage: ' + details);
}

function unreachable(msg) {
  throw new Error(msg);
}

function assert(cond, msg) {
  if (!cond) {
    unreachable(msg);
  }
}

function isSameOrigin(baseUrl, otherUrl) {
  try {
    var base = new _url_polyfill.URL(baseUrl);

    if (!base.origin || base.origin === 'null') {
      return false;
    }
  } catch (e) {
    return false;
  }

  var other = new _url_polyfill.URL(otherUrl, base);
  return base.origin === other.origin;
}

function _isValidProtocol(url) {
  if (!url) {
    return false;
  }

  switch (url.protocol) {
    case 'http:':
    case 'https:':
    case 'ftp:':
    case 'mailto:':
    case 'tel:':
      return true;

    default:
      return false;
  }
}

function createValidAbsoluteUrl(url, baseUrl) {
  if (!url) {
    return null;
  }

  try {
    var absoluteUrl = baseUrl ? new _url_polyfill.URL(url, baseUrl) : new _url_polyfill.URL(url);

    if (_isValidProtocol(absoluteUrl)) {
      return absoluteUrl;
    }
  } catch (ex) {}

  return null;
}

function shadow(obj, prop, value) {
  Object.defineProperty(obj, prop, {
    value: value,
    enumerable: true,
    configurable: true,
    writable: false
  });
  return value;
}

function getLookupTableFactory(initializer) {
  var lookup;
  return function () {
    if (initializer) {
      lookup = Object.create(null);
      initializer(lookup);
      initializer = null;
    }

    return lookup;
  };
}

var PasswordException = function PasswordExceptionClosure() {
  function PasswordException(msg, code) {
    this.name = 'PasswordException';
    this.message = msg;
    this.code = code;
  }

  PasswordException.prototype = new Error();
  PasswordException.constructor = PasswordException;
  return PasswordException;
}();

exports.PasswordException = PasswordException;

var UnknownErrorException = function UnknownErrorExceptionClosure() {
  function UnknownErrorException(msg, details) {
    this.name = 'UnknownErrorException';
    this.message = msg;
    this.details = details;
  }

  UnknownErrorException.prototype = new Error();
  UnknownErrorException.constructor = UnknownErrorException;
  return UnknownErrorException;
}();

exports.UnknownErrorException = UnknownErrorException;

var InvalidPDFException = function InvalidPDFExceptionClosure() {
  function InvalidPDFException(msg) {
    this.name = 'InvalidPDFException';
    this.message = msg;
  }

  InvalidPDFException.prototype = new Error();
  InvalidPDFException.constructor = InvalidPDFException;
  return InvalidPDFException;
}();

exports.InvalidPDFException = InvalidPDFException;

var MissingPDFException = function MissingPDFExceptionClosure() {
  function MissingPDFException(msg) {
    this.name = 'MissingPDFException';
    this.message = msg;
  }

  MissingPDFException.prototype = new Error();
  MissingPDFException.constructor = MissingPDFException;
  return MissingPDFException;
}();

exports.MissingPDFException = MissingPDFException;

var UnexpectedResponseException = function UnexpectedResponseExceptionClosure() {
  function UnexpectedResponseException(msg, status) {
    this.name = 'UnexpectedResponseException';
    this.message = msg;
    this.status = status;
  }

  UnexpectedResponseException.prototype = new Error();
  UnexpectedResponseException.constructor = UnexpectedResponseException;
  return UnexpectedResponseException;
}();

exports.UnexpectedResponseException = UnexpectedResponseException;

var MissingDataException = function MissingDataExceptionClosure() {
  function MissingDataException(begin, end) {
    this.begin = begin;
    this.end = end;
    this.message = 'Missing data [' + begin + ', ' + end + ')';
  }

  MissingDataException.prototype = new Error();
  MissingDataException.prototype.name = 'MissingDataException';
  MissingDataException.constructor = MissingDataException;
  return MissingDataException;
}();

exports.MissingDataException = MissingDataException;

var XRefEntryException = function XRefEntryExceptionClosure() {
  function XRefEntryException(msg) {
    this.message = msg;
  }

  XRefEntryException.prototype = new Error();
  XRefEntryException.prototype.name = 'XRefEntryException';
  XRefEntryException.constructor = XRefEntryException;
  return XRefEntryException;
}();

exports.XRefEntryException = XRefEntryException;

var XRefParseException = function XRefParseExceptionClosure() {
  function XRefParseException(msg) {
    this.message = msg;
  }

  XRefParseException.prototype = new Error();
  XRefParseException.prototype.name = 'XRefParseException';
  XRefParseException.constructor = XRefParseException;
  return XRefParseException;
}();

exports.XRefParseException = XRefParseException;

var FormatError = function FormatErrorClosure() {
  function FormatError(msg) {
    this.message = msg;
  }

  FormatError.prototype = new Error();
  FormatError.prototype.name = 'FormatError';
  FormatError.constructor = FormatError;
  return FormatError;
}();

exports.FormatError = FormatError;

var AbortException = function AbortExceptionClosure() {
  function AbortException(msg) {
    this.name = 'AbortException';
    this.message = msg;
  }

  AbortException.prototype = new Error();
  AbortException.constructor = AbortException;
  return AbortException;
}();

exports.AbortException = AbortException;
var NullCharactersRegExp = /\x00/g;

function removeNullCharacters(str) {
  if (typeof str !== 'string') {
    warn('The argument for removeNullCharacters must be a string.');
    return str;
  }

  return str.replace(NullCharactersRegExp, '');
}

function bytesToString(bytes) {
  assert(bytes !== null && _typeof(bytes) === 'object' && bytes.length !== undefined, 'Invalid argument for bytesToString');
  var length = bytes.length;
  var MAX_ARGUMENT_COUNT = 8192;

  if (length < MAX_ARGUMENT_COUNT) {
    return String.fromCharCode.apply(null, bytes);
  }

  var strBuf = [];

  for (var i = 0; i < length; i += MAX_ARGUMENT_COUNT) {
    var chunkEnd = Math.min(i + MAX_ARGUMENT_COUNT, length);
    var chunk = bytes.subarray(i, chunkEnd);
    strBuf.push(String.fromCharCode.apply(null, chunk));
  }

  return strBuf.join('');
}

function stringToBytes(str) {
  assert(typeof str === 'string', 'Invalid argument for stringToBytes');
  var length = str.length;
  var bytes = new Uint8Array(length);

  for (var i = 0; i < length; ++i) {
    bytes[i] = str.charCodeAt(i) & 0xFF;
  }

  return bytes;
}

function arrayByteLength(arr) {
  if (arr.length !== undefined) {
    return arr.length;
  }

  assert(arr.byteLength !== undefined);
  return arr.byteLength;
}

function arraysToBytes(arr) {
  if (arr.length === 1 && arr[0] instanceof Uint8Array) {
    return arr[0];
  }

  var resultLength = 0;
  var i,
      ii = arr.length;
  var item, itemLength;

  for (i = 0; i < ii; i++) {
    item = arr[i];
    itemLength = arrayByteLength(item);
    resultLength += itemLength;
  }

  var pos = 0;
  var data = new Uint8Array(resultLength);

  for (i = 0; i < ii; i++) {
    item = arr[i];

    if (!(item instanceof Uint8Array)) {
      if (typeof item === 'string') {
        item = stringToBytes(item);
      } else {
        item = new Uint8Array(item);
      }
    }

    itemLength = item.byteLength;
    data.set(item, pos);
    pos += itemLength;
  }

  return data;
}

function string32(value) {
  return String.fromCharCode(value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff);
}

function log2(x) {
  if (x <= 0) {
    return 0;
  }

  return Math.ceil(Math.log2(x));
}

function readInt8(data, start) {
  return data[start] << 24 >> 24;
}

function readUint16(data, offset) {
  return data[offset] << 8 | data[offset + 1];
}

function readUint32(data, offset) {
  return (data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3]) >>> 0;
}

function isLittleEndian() {
  var buffer8 = new Uint8Array(4);
  buffer8[0] = 1;
  var view32 = new Uint32Array(buffer8.buffer, 0, 1);
  return view32[0] === 1;
}

function isEvalSupported() {
  try {
    new Function('');
    return true;
  } catch (e) {
    return false;
  }
}

function getInheritableProperty(_ref) {
  var dict = _ref.dict,
      key = _ref.key,
      _ref$getArray = _ref.getArray,
      getArray = _ref$getArray === void 0 ? false : _ref$getArray,
      _ref$stopWhenFound = _ref.stopWhenFound,
      stopWhenFound = _ref$stopWhenFound === void 0 ? true : _ref$stopWhenFound;
  var LOOP_LIMIT = 100;
  var loopCount = 0;
  var values;

  while (dict) {
    var value = getArray ? dict.getArray(key) : dict.get(key);

    if (value !== undefined) {
      if (stopWhenFound) {
        return value;
      }

      if (!values) {
        values = [];
      }

      values.push(value);
    }

    if (++loopCount > LOOP_LIMIT) {
      warn("getInheritableProperty: maximum loop count exceeded for \"".concat(key, "\""));
      break;
    }

    dict = dict.get('Parent');
  }

  return values;
}

var Util = function UtilClosure() {
  function Util() {}

  var rgbBuf = ['rgb(', 0, ',', 0, ',', 0, ')'];

  Util.makeCssRgb = function Util_makeCssRgb(r, g, b) {
    rgbBuf[1] = r;
    rgbBuf[3] = g;
    rgbBuf[5] = b;
    return rgbBuf.join('');
  };

  Util.transform = function Util_transform(m1, m2) {
    return [m1[0] * m2[0] + m1[2] * m2[1], m1[1] * m2[0] + m1[3] * m2[1], m1[0] * m2[2] + m1[2] * m2[3], m1[1] * m2[2] + m1[3] * m2[3], m1[0] * m2[4] + m1[2] * m2[5] + m1[4], m1[1] * m2[4] + m1[3] * m2[5] + m1[5]];
  };

  Util.applyTransform = function Util_applyTransform(p, m) {
    var xt = p[0] * m[0] + p[1] * m[2] + m[4];
    var yt = p[0] * m[1] + p[1] * m[3] + m[5];
    return [xt, yt];
  };

  Util.applyInverseTransform = function Util_applyInverseTransform(p, m) {
    var d = m[0] * m[3] - m[1] * m[2];
    var xt = (p[0] * m[3] - p[1] * m[2] + m[2] * m[5] - m[4] * m[3]) / d;
    var yt = (-p[0] * m[1] + p[1] * m[0] + m[4] * m[1] - m[5] * m[0]) / d;
    return [xt, yt];
  };

  Util.getAxialAlignedBoundingBox = function Util_getAxialAlignedBoundingBox(r, m) {
    var p1 = Util.applyTransform(r, m);
    var p2 = Util.applyTransform(r.slice(2, 4), m);
    var p3 = Util.applyTransform([r[0], r[3]], m);
    var p4 = Util.applyTransform([r[2], r[1]], m);
    return [Math.min(p1[0], p2[0], p3[0], p4[0]), Math.min(p1[1], p2[1], p3[1], p4[1]), Math.max(p1[0], p2[0], p3[0], p4[0]), Math.max(p1[1], p2[1], p3[1], p4[1])];
  };

  Util.inverseTransform = function Util_inverseTransform(m) {
    var d = m[0] * m[3] - m[1] * m[2];
    return [m[3] / d, -m[1] / d, -m[2] / d, m[0] / d, (m[2] * m[5] - m[4] * m[3]) / d, (m[4] * m[1] - m[5] * m[0]) / d];
  };

  Util.apply3dTransform = function Util_apply3dTransform(m, v) {
    return [m[0] * v[0] + m[1] * v[1] + m[2] * v[2], m[3] * v[0] + m[4] * v[1] + m[5] * v[2], m[6] * v[0] + m[7] * v[1] + m[8] * v[2]];
  };

  Util.singularValueDecompose2dScale = function Util_singularValueDecompose2dScale(m) {
    var transpose = [m[0], m[2], m[1], m[3]];
    var a = m[0] * transpose[0] + m[1] * transpose[2];
    var b = m[0] * transpose[1] + m[1] * transpose[3];
    var c = m[2] * transpose[0] + m[3] * transpose[2];
    var d = m[2] * transpose[1] + m[3] * transpose[3];
    var first = (a + d) / 2;
    var second = Math.sqrt((a + d) * (a + d) - 4 * (a * d - c * b)) / 2;
    var sx = first + second || 1;
    var sy = first - second || 1;
    return [Math.sqrt(sx), Math.sqrt(sy)];
  };

  Util.normalizeRect = function Util_normalizeRect(rect) {
    var r = rect.slice(0);

    if (rect[0] > rect[2]) {
      r[0] = rect[2];
      r[2] = rect[0];
    }

    if (rect[1] > rect[3]) {
      r[1] = rect[3];
      r[3] = rect[1];
    }

    return r;
  };

  Util.intersect = function Util_intersect(rect1, rect2) {
    function compare(a, b) {
      return a - b;
    }

    var orderedX = [rect1[0], rect1[2], rect2[0], rect2[2]].sort(compare),
        orderedY = [rect1[1], rect1[3], rect2[1], rect2[3]].sort(compare),
        result = [];
    rect1 = Util.normalizeRect(rect1);
    rect2 = Util.normalizeRect(rect2);

    if (orderedX[0] === rect1[0] && orderedX[1] === rect2[0] || orderedX[0] === rect2[0] && orderedX[1] === rect1[0]) {
      result[0] = orderedX[1];
      result[2] = orderedX[2];
    } else {
      return false;
    }

    if (orderedY[0] === rect1[1] && orderedY[1] === rect2[1] || orderedY[0] === rect2[1] && orderedY[1] === rect1[1]) {
      result[1] = orderedY[1];
      result[3] = orderedY[2];
    } else {
      return false;
    }

    return result;
  };

  return Util;
}();

exports.Util = Util;
var ROMAN_NUMBER_MAP = ['', 'C', 'CC', 'CCC', 'CD', 'D', 'DC', 'DCC', 'DCCC', 'CM', '', 'X', 'XX', 'XXX', 'XL', 'L', 'LX', 'LXX', 'LXXX', 'XC', '', 'I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX'];

function toRomanNumerals(number) {
  var lowerCase = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  assert(Number.isInteger(number) && number > 0, 'The number should be a positive integer.');
  var pos,
      romanBuf = [];

  while (number >= 1000) {
    number -= 1000;
    romanBuf.push('M');
  }

  pos = number / 100 | 0;
  number %= 100;
  romanBuf.push(ROMAN_NUMBER_MAP[pos]);
  pos = number / 10 | 0;
  number %= 10;
  romanBuf.push(ROMAN_NUMBER_MAP[10 + pos]);
  romanBuf.push(ROMAN_NUMBER_MAP[20 + number]);
  var romanStr = romanBuf.join('');
  return lowerCase ? romanStr.toLowerCase() : romanStr;
}

var PDFStringTranslateTable = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2D8, 0x2C7, 0x2C6, 0x2D9, 0x2DD, 0x2DB, 0x2DA, 0x2DC, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2022, 0x2020, 0x2021, 0x2026, 0x2014, 0x2013, 0x192, 0x2044, 0x2039, 0x203A, 0x2212, 0x2030, 0x201E, 0x201C, 0x201D, 0x2018, 0x2019, 0x201A, 0x2122, 0xFB01, 0xFB02, 0x141, 0x152, 0x160, 0x178, 0x17D, 0x131, 0x142, 0x153, 0x161, 0x17E, 0, 0x20AC];

function stringToPDFString(str) {
  var i,
      n = str.length,
      strBuf = [];

  if (str[0] === '\xFE' && str[1] === '\xFF') {
    for (i = 2; i < n; i += 2) {
      strBuf.push(String.fromCharCode(str.charCodeAt(i) << 8 | str.charCodeAt(i + 1)));
    }
  } else {
    for (i = 0; i < n; ++i) {
      var code = PDFStringTranslateTable[str.charCodeAt(i)];
      strBuf.push(code ? String.fromCharCode(code) : str.charAt(i));
    }
  }

  return strBuf.join('');
}

function stringToUTF8String(str) {
  return decodeURIComponent(escape(str));
}

function utf8StringToString(str) {
  return unescape(encodeURIComponent(str));
}

function isEmptyObj(obj) {
  for (var key in obj) {
    return false;
  }

  return true;
}

function isBool(v) {
  return typeof v === 'boolean';
}

function isNum(v) {
  return typeof v === 'number';
}

function isString(v) {
  return typeof v === 'string';
}

function isArrayBuffer(v) {
  return _typeof(v) === 'object' && v !== null && v.byteLength !== undefined;
}

function isSpace(ch) {
  return ch === 0x20 || ch === 0x09 || ch === 0x0D || ch === 0x0A;
}

function createPromiseCapability() {
  var capability = Object.create(null);
  var isSettled = false;
  Object.defineProperty(capability, 'settled', {
    get: function get() {
      return isSettled;
    }
  });
  capability.promise = new Promise(function (resolve, reject) {
    capability.resolve = function (data) {
      isSettled = true;
      resolve(data);
    };

    capability.reject = function (reason) {
      isSettled = true;
      reject(reason);
    };
  });
  return capability;
}

var createObjectURL = function createObjectURLClosure() {
  var digits = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
  return function createObjectURL(data, contentType) {
    var forceDataSchema = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    if (!forceDataSchema && _url_polyfill.URL.createObjectURL) {
      var blob = new Blob([data], {
        type: contentType
      });
      return _url_polyfill.URL.createObjectURL(blob);
    }

    var buffer = 'data:' + contentType + ';base64,';

    for (var i = 0, ii = data.length; i < ii; i += 3) {
      var b1 = data[i] & 0xFF;
      var b2 = data[i + 1] & 0xFF;
      var b3 = data[i + 2] & 0xFF;
      var d1 = b1 >> 2,
          d2 = (b1 & 3) << 4 | b2 >> 4;
      var d3 = i + 1 < ii ? (b2 & 0xF) << 2 | b3 >> 6 : 64;
      var d4 = i + 2 < ii ? b3 & 0x3F : 64;
      buffer += digits[d1] + digits[d2] + digits[d3] + digits[d4];
    }

    return buffer;
  };
}();

exports.createObjectURL = createObjectURL;

/***/ }),
/* 2 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var globalScope = __w_pdfjs_require__(3);

if (!globalScope._pdfjsCompatibilityChecked) {
  globalScope._pdfjsCompatibilityChecked = true;

  var isNodeJS = __w_pdfjs_require__(4);

  var hasDOM = (typeof window === "undefined" ? "undefined" : _typeof(window)) === 'object' && (typeof document === "undefined" ? "undefined" : _typeof(document)) === 'object';

  (function checkNodeBtoa() {
    if (globalScope.btoa || !isNodeJS()) {
      return;
    }

    globalScope.btoa = function (chars) {
      return Buffer.from(chars, 'binary').toString('base64');
    };
  })();

  (function checkNodeAtob() {
    if (globalScope.atob || !isNodeJS()) {
      return;
    }

    globalScope.atob = function (input) {
      return Buffer.from(input, 'base64').toString('binary');
    };
  })();

  (function checkChildNodeRemove() {
    if (!hasDOM) {
      return;
    }

    if (typeof Element.prototype.remove !== 'undefined') {
      return;
    }

    Element.prototype.remove = function () {
      if (this.parentNode) {
        this.parentNode.removeChild(this);
      }
    };
  })();

  (function checkDOMTokenListAddRemove() {
    if (!hasDOM || isNodeJS()) {
      return;
    }

    var div = document.createElement('div');
    div.classList.add('testOne', 'testTwo');

    if (div.classList.contains('testOne') === true && div.classList.contains('testTwo') === true) {
      return;
    }

    var OriginalDOMTokenListAdd = DOMTokenList.prototype.add;
    var OriginalDOMTokenListRemove = DOMTokenList.prototype.remove;

    DOMTokenList.prototype.add = function () {
      for (var _len = arguments.length, tokens = new Array(_len), _key = 0; _key < _len; _key++) {
        tokens[_key] = arguments[_key];
      }

      for (var _i = 0; _i < tokens.length; _i++) {
        var token = tokens[_i];
        OriginalDOMTokenListAdd.call(this, token);
      }
    };

    DOMTokenList.prototype.remove = function () {
      for (var _len2 = arguments.length, tokens = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        tokens[_key2] = arguments[_key2];
      }

      for (var _i2 = 0; _i2 < tokens.length; _i2++) {
        var token = tokens[_i2];
        OriginalDOMTokenListRemove.call(this, token);
      }
    };
  })();

  (function checkDOMTokenListToggle() {
    if (!hasDOM || isNodeJS()) {
      return;
    }

    var div = document.createElement('div');

    if (div.classList.toggle('test', 0) === false) {
      return;
    }

    DOMTokenList.prototype.toggle = function (token) {
      var force = arguments.length > 1 ? !!arguments[1] : !this.contains(token);
      return this[force ? 'add' : 'remove'](token), force;
    };
  })();

  (function checkStringStartsWith() {
    if (String.prototype.startsWith) {
      return;
    }

    __w_pdfjs_require__(5);
  })();

  (function checkStringEndsWith() {
    if (String.prototype.endsWith) {
      return;
    }

    __w_pdfjs_require__(35);
  })();

  (function checkStringIncludes() {
    if (String.prototype.includes) {
      return;
    }

    __w_pdfjs_require__(37);
  })();

  (function checkArrayIncludes() {
    if (Array.prototype.includes) {
      return;
    }

    __w_pdfjs_require__(39);
  })();

  (function checkArrayFrom() {
    if (Array.from) {
      return;
    }

    __w_pdfjs_require__(46);
  })();

  (function checkObjectAssign() {
    if (Object.assign) {
      return;
    }

    __w_pdfjs_require__(69);
  })();

  (function checkMathLog2() {
    if (Math.log2) {
      return;
    }

    Math.log2 = __w_pdfjs_require__(74);
  })();

  (function checkNumberIsNaN() {
    if (Number.isNaN) {
      return;
    }

    Number.isNaN = __w_pdfjs_require__(76);
  })();

  (function checkNumberIsInteger() {
    if (Number.isInteger) {
      return;
    }

    Number.isInteger = __w_pdfjs_require__(78);
  })();

  (function checkPromise() {
    if (globalScope.Promise && globalScope.Promise.prototype && globalScope.Promise.prototype.finally) {
      return;
    }

    globalScope.Promise = __w_pdfjs_require__(81);
  })();

  (function checkWeakMap() {
    if (globalScope.WeakMap) {
      return;
    }

    globalScope.WeakMap = __w_pdfjs_require__(101);
  })();

  (function checkWeakSet() {
    if (globalScope.WeakSet) {
      return;
    }

    globalScope.WeakSet = __w_pdfjs_require__(118);
  })();

  (function checkStringCodePointAt() {
    if (String.codePointAt) {
      return;
    }

    String.codePointAt = __w_pdfjs_require__(122);
  })();

  (function checkStringFromCodePoint() {
    if (String.fromCodePoint) {
      return;
    }

    String.fromCodePoint = __w_pdfjs_require__(124);
  })();

  (function checkSymbol() {
    if (globalScope.Symbol) {
      return;
    }

    __w_pdfjs_require__(126);
  })();

  (function checkStringPadStart() {
    if (String.prototype.padStart) {
      return;
    }

    __w_pdfjs_require__(133);
  })();

  (function checkStringPadEnd() {
    if (String.prototype.padEnd) {
      return;
    }

    __w_pdfjs_require__(137);
  })();

  (function checkObjectValues() {
    if (Object.values) {
      return;
    }

    Object.values = __w_pdfjs_require__(139);
  })();
}

/***/ }),
/* 3 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = typeof window !== 'undefined' && window.Math === Math ? window : typeof global !== 'undefined' && global.Math === Math ? global : typeof self !== 'undefined' && self.Math === Math ? self : {};

/***/ }),
/* 4 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

module.exports = function isNodeJS() {
  return (typeof process === "undefined" ? "undefined" : _typeof(process)) === 'object' && process + '' === '[object process]' && !process.versions['nw'];
};

/***/ }),
/* 5 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(6);

module.exports = __w_pdfjs_require__(9).String.startsWith;

/***/ }),
/* 6 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var toLength = __w_pdfjs_require__(25);

var context = __w_pdfjs_require__(27);

var STARTS_WITH = 'startsWith';
var $startsWith = ''[STARTS_WITH];
$export($export.P + $export.F * __w_pdfjs_require__(34)(STARTS_WITH), 'String', {
  startsWith: function startsWith(searchString) {
    var that = context(this, searchString, STARTS_WITH);
    var index = toLength(Math.min(arguments.length > 1 ? arguments[1] : undefined, that.length));
    var search = String(searchString);
    return $startsWith ? $startsWith.call(that, search, index) : that.slice(index, index + search.length) === search;
  }
});

/***/ }),
/* 7 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(8);

var core = __w_pdfjs_require__(9);

var hide = __w_pdfjs_require__(10);

var redefine = __w_pdfjs_require__(20);

var ctx = __w_pdfjs_require__(23);

var PROTOTYPE = 'prototype';

var $export = function $export(type, name, source) {
  var IS_FORCED = type & $export.F;
  var IS_GLOBAL = type & $export.G;
  var IS_STATIC = type & $export.S;
  var IS_PROTO = type & $export.P;
  var IS_BIND = type & $export.B;
  var target = IS_GLOBAL ? global : IS_STATIC ? global[name] || (global[name] = {}) : (global[name] || {})[PROTOTYPE];
  var exports = IS_GLOBAL ? core : core[name] || (core[name] = {});
  var expProto = exports[PROTOTYPE] || (exports[PROTOTYPE] = {});
  var key, own, out, exp;
  if (IS_GLOBAL) source = name;

  for (key in source) {
    own = !IS_FORCED && target && target[key] !== undefined;
    out = (own ? target : source)[key];
    exp = IS_BIND && own ? ctx(out, global) : IS_PROTO && typeof out == 'function' ? ctx(Function.call, out) : out;
    if (target) redefine(target, key, out, type & $export.U);
    if (exports[key] != out) hide(exports, key, exp);
    if (IS_PROTO && expProto[key] != out) expProto[key] = out;
  }
};

global.core = core;
$export.F = 1;
$export.G = 2;
$export.S = 4;
$export.P = 8;
$export.B = 16;
$export.W = 32;
$export.U = 64;
$export.R = 128;
module.exports = $export;

/***/ }),
/* 8 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = module.exports = typeof window != 'undefined' && window.Math == Math ? window : typeof self != 'undefined' && self.Math == Math ? self : Function('return this')();
if (typeof __g == 'number') __g = global;

/***/ }),
/* 9 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var core = module.exports = {
  version: '2.6.2'
};
if (typeof __e == 'number') __e = core;

/***/ }),
/* 10 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var dP = __w_pdfjs_require__(11);

var createDesc = __w_pdfjs_require__(19);

module.exports = __w_pdfjs_require__(15) ? function (object, key, value) {
  return dP.f(object, key, createDesc(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};

/***/ }),
/* 11 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(12);

var IE8_DOM_DEFINE = __w_pdfjs_require__(14);

var toPrimitive = __w_pdfjs_require__(18);

var dP = Object.defineProperty;
exports.f = __w_pdfjs_require__(15) ? Object.defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return dP(O, P, Attributes);
  } catch (e) {}
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};

/***/ }),
/* 12 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

module.exports = function (it) {
  if (!isObject(it)) throw TypeError(it + ' is not an object!');
  return it;
};

/***/ }),
/* 13 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

module.exports = function (it) {
  return _typeof(it) === 'object' ? it !== null : typeof it === 'function';
};

/***/ }),
/* 14 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = !__w_pdfjs_require__(15) && !__w_pdfjs_require__(16)(function () {
  return Object.defineProperty(__w_pdfjs_require__(17)('div'), 'a', {
    get: function get() {
      return 7;
    }
  }).a != 7;
});

/***/ }),
/* 15 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = !__w_pdfjs_require__(16)(function () {
  return Object.defineProperty({}, 'a', {
    get: function get() {
      return 7;
    }
  }).a != 7;
});

/***/ }),
/* 16 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (exec) {
  try {
    return !!exec();
  } catch (e) {
    return true;
  }
};

/***/ }),
/* 17 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

var document = __w_pdfjs_require__(8).document;

var is = isObject(document) && isObject(document.createElement);

module.exports = function (it) {
  return is ? document.createElement(it) : {};
};

/***/ }),
/* 18 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

module.exports = function (it, S) {
  if (!isObject(it)) return it;
  var fn, val;
  if (S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  if (typeof (fn = it.valueOf) == 'function' && !isObject(val = fn.call(it))) return val;
  if (!S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  throw TypeError("Can't convert object to primitive value");
};

/***/ }),
/* 19 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};

/***/ }),
/* 20 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(8);

var hide = __w_pdfjs_require__(10);

var has = __w_pdfjs_require__(21);

var SRC = __w_pdfjs_require__(22)('src');

var TO_STRING = 'toString';
var $toString = Function[TO_STRING];
var TPL = ('' + $toString).split(TO_STRING);

__w_pdfjs_require__(9).inspectSource = function (it) {
  return $toString.call(it);
};

(module.exports = function (O, key, val, safe) {
  var isFunction = typeof val == 'function';
  if (isFunction) has(val, 'name') || hide(val, 'name', key);
  if (O[key] === val) return;
  if (isFunction) has(val, SRC) || hide(val, SRC, O[key] ? '' + O[key] : TPL.join(String(key)));

  if (O === global) {
    O[key] = val;
  } else if (!safe) {
    delete O[key];
    hide(O, key, val);
  } else if (O[key]) {
    O[key] = val;
  } else {
    hide(O, key, val);
  }
})(Function.prototype, TO_STRING, function toString() {
  return typeof this == 'function' && this[SRC] || $toString.call(this);
});

/***/ }),
/* 21 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var hasOwnProperty = {}.hasOwnProperty;

module.exports = function (it, key) {
  return hasOwnProperty.call(it, key);
};

/***/ }),
/* 22 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var id = 0;
var px = Math.random();

module.exports = function (key) {
  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
};

/***/ }),
/* 23 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var aFunction = __w_pdfjs_require__(24);

module.exports = function (fn, that, length) {
  aFunction(fn);
  if (that === undefined) return fn;

  switch (length) {
    case 1:
      return function (a) {
        return fn.call(that, a);
      };

    case 2:
      return function (a, b) {
        return fn.call(that, a, b);
      };

    case 3:
      return function (a, b, c) {
        return fn.call(that, a, b, c);
      };
  }

  return function () {
    return fn.apply(that, arguments);
  };
};

/***/ }),
/* 24 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (it) {
  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
  return it;
};

/***/ }),
/* 25 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(26);

var min = Math.min;

module.exports = function (it) {
  return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0;
};

/***/ }),
/* 26 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ceil = Math.ceil;
var floor = Math.floor;

module.exports = function (it) {
  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
};

/***/ }),
/* 27 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isRegExp = __w_pdfjs_require__(28);

var defined = __w_pdfjs_require__(33);

module.exports = function (that, searchString, NAME) {
  if (isRegExp(searchString)) throw TypeError('String#' + NAME + " doesn't accept regex!");
  return String(defined(that));
};

/***/ }),
/* 28 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

var cof = __w_pdfjs_require__(29);

var MATCH = __w_pdfjs_require__(30)('match');

module.exports = function (it) {
  var isRegExp;
  return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : cof(it) == 'RegExp');
};

/***/ }),
/* 29 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};

/***/ }),
/* 30 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var store = __w_pdfjs_require__(31)('wks');

var uid = __w_pdfjs_require__(22);

var _Symbol = __w_pdfjs_require__(8).Symbol;

var USE_SYMBOL = typeof _Symbol == 'function';

var $exports = module.exports = function (name) {
  return store[name] || (store[name] = USE_SYMBOL && _Symbol[name] || (USE_SYMBOL ? _Symbol : uid)('Symbol.' + name));
};

$exports.store = store;

/***/ }),
/* 31 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var core = __w_pdfjs_require__(9);

var global = __w_pdfjs_require__(8);

var SHARED = '__core-js_shared__';
var store = global[SHARED] || (global[SHARED] = {});
(module.exports = function (key, value) {
  return store[key] || (store[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: core.version,
  mode: __w_pdfjs_require__(32) ? 'pure' : 'global',
  copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
});

/***/ }),
/* 32 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = false;

/***/ }),
/* 33 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on  " + it);
  return it;
};

/***/ }),
/* 34 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var MATCH = __w_pdfjs_require__(30)('match');

module.exports = function (KEY) {
  var re = /./;

  try {
    '/./'[KEY](re);
  } catch (e) {
    try {
      re[MATCH] = false;
      return !'/./'[KEY](re);
    } catch (f) {}
  }

  return true;
};

/***/ }),
/* 35 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(36);

module.exports = __w_pdfjs_require__(9).String.endsWith;

/***/ }),
/* 36 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var toLength = __w_pdfjs_require__(25);

var context = __w_pdfjs_require__(27);

var ENDS_WITH = 'endsWith';
var $endsWith = ''[ENDS_WITH];
$export($export.P + $export.F * __w_pdfjs_require__(34)(ENDS_WITH), 'String', {
  endsWith: function endsWith(searchString) {
    var that = context(this, searchString, ENDS_WITH);
    var endPosition = arguments.length > 1 ? arguments[1] : undefined;
    var len = toLength(that.length);
    var end = endPosition === undefined ? len : Math.min(toLength(endPosition), len);
    var search = String(searchString);
    return $endsWith ? $endsWith.call(that, search, end) : that.slice(end - search.length, end) === search;
  }
});

/***/ }),
/* 37 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(38);

module.exports = __w_pdfjs_require__(9).String.includes;

/***/ }),
/* 38 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var context = __w_pdfjs_require__(27);

var INCLUDES = 'includes';
$export($export.P + $export.F * __w_pdfjs_require__(34)(INCLUDES), 'String', {
  includes: function includes(searchString) {
    return !!~context(this, searchString, INCLUDES).indexOf(searchString, arguments.length > 1 ? arguments[1] : undefined);
  }
});

/***/ }),
/* 39 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(40);

module.exports = __w_pdfjs_require__(9).Array.includes;

/***/ }),
/* 40 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var $includes = __w_pdfjs_require__(41)(true);

$export($export.P, 'Array', {
  includes: function includes(el) {
    return $includes(this, el, arguments.length > 1 ? arguments[1] : undefined);
  }
});

__w_pdfjs_require__(45)('includes');

/***/ }),
/* 41 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toIObject = __w_pdfjs_require__(42);

var toLength = __w_pdfjs_require__(25);

var toAbsoluteIndex = __w_pdfjs_require__(44);

module.exports = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      if (value != value) return true;
    } else for (; length > index; index++) {
      if (IS_INCLUDES || index in O) {
        if (O[index] === el) return IS_INCLUDES || index || 0;
      }
    }
    return !IS_INCLUDES && -1;
  };
};

/***/ }),
/* 42 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var IObject = __w_pdfjs_require__(43);

var defined = __w_pdfjs_require__(33);

module.exports = function (it) {
  return IObject(defined(it));
};

/***/ }),
/* 43 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var cof = __w_pdfjs_require__(29);

module.exports = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
  return cof(it) == 'String' ? it.split('') : Object(it);
};

/***/ }),
/* 44 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(26);

var max = Math.max;
var min = Math.min;

module.exports = function (index, length) {
  index = toInteger(index);
  return index < 0 ? max(index + length, 0) : min(index, length);
};

/***/ }),
/* 45 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var UNSCOPABLES = __w_pdfjs_require__(30)('unscopables');

var ArrayProto = Array.prototype;
if (ArrayProto[UNSCOPABLES] == undefined) __w_pdfjs_require__(10)(ArrayProto, UNSCOPABLES, {});

module.exports = function (key) {
  ArrayProto[UNSCOPABLES][key] = true;
};

/***/ }),
/* 46 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(47);

__w_pdfjs_require__(62);

module.exports = __w_pdfjs_require__(9).Array.from;

/***/ }),
/* 47 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $at = __w_pdfjs_require__(48)(true);

__w_pdfjs_require__(49)(String, 'String', function (iterated) {
  this._t = String(iterated);
  this._i = 0;
}, function () {
  var O = this._t;
  var index = this._i;
  var point;
  if (index >= O.length) return {
    value: undefined,
    done: true
  };
  point = $at(O, index);
  this._i += point.length;
  return {
    value: point,
    done: false
  };
});

/***/ }),
/* 48 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(26);

var defined = __w_pdfjs_require__(33);

module.exports = function (TO_STRING) {
  return function (that, pos) {
    var s = String(defined(that));
    var i = toInteger(pos);
    var l = s.length;
    var a, b;
    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
    a = s.charCodeAt(i);
    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff ? TO_STRING ? s.charAt(i) : a : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
  };
};

/***/ }),
/* 49 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var LIBRARY = __w_pdfjs_require__(32);

var $export = __w_pdfjs_require__(7);

var redefine = __w_pdfjs_require__(20);

var hide = __w_pdfjs_require__(10);

var Iterators = __w_pdfjs_require__(50);

var $iterCreate = __w_pdfjs_require__(51);

var setToStringTag = __w_pdfjs_require__(59);

var getPrototypeOf = __w_pdfjs_require__(60);

var ITERATOR = __w_pdfjs_require__(30)('iterator');

var BUGGY = !([].keys && 'next' in [].keys());
var FF_ITERATOR = '@@iterator';
var KEYS = 'keys';
var VALUES = 'values';

var returnThis = function returnThis() {
  return this;
};

module.exports = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
  $iterCreate(Constructor, NAME, next);

  var getMethod = function getMethod(kind) {
    if (!BUGGY && kind in proto) return proto[kind];

    switch (kind) {
      case KEYS:
        return function keys() {
          return new Constructor(this, kind);
        };

      case VALUES:
        return function values() {
          return new Constructor(this, kind);
        };
    }

    return function entries() {
      return new Constructor(this, kind);
    };
  };

  var TAG = NAME + ' Iterator';
  var DEF_VALUES = DEFAULT == VALUES;
  var VALUES_BUG = false;
  var proto = Base.prototype;
  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
  var $default = $native || getMethod(DEFAULT);
  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
  var methods, key, IteratorPrototype;

  if ($anyNative) {
    IteratorPrototype = getPrototypeOf($anyNative.call(new Base()));

    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
      setToStringTag(IteratorPrototype, TAG, true);
      if (!LIBRARY && typeof IteratorPrototype[ITERATOR] != 'function') hide(IteratorPrototype, ITERATOR, returnThis);
    }
  }

  if (DEF_VALUES && $native && $native.name !== VALUES) {
    VALUES_BUG = true;

    $default = function values() {
      return $native.call(this);
    };
  }

  if ((!LIBRARY || FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
    hide(proto, ITERATOR, $default);
  }

  Iterators[NAME] = $default;
  Iterators[TAG] = returnThis;

  if (DEFAULT) {
    methods = {
      values: DEF_VALUES ? $default : getMethod(VALUES),
      keys: IS_SET ? $default : getMethod(KEYS),
      entries: $entries
    };
    if (FORCED) for (key in methods) {
      if (!(key in proto)) redefine(proto, key, methods[key]);
    } else $export($export.P + $export.F * (BUGGY || VALUES_BUG), NAME, methods);
  }

  return methods;
};

/***/ }),
/* 50 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = {};

/***/ }),
/* 51 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var create = __w_pdfjs_require__(52);

var descriptor = __w_pdfjs_require__(19);

var setToStringTag = __w_pdfjs_require__(59);

var IteratorPrototype = {};

__w_pdfjs_require__(10)(IteratorPrototype, __w_pdfjs_require__(30)('iterator'), function () {
  return this;
});

module.exports = function (Constructor, NAME, next) {
  Constructor.prototype = create(IteratorPrototype, {
    next: descriptor(1, next)
  });
  setToStringTag(Constructor, NAME + ' Iterator');
};

/***/ }),
/* 52 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(12);

var dPs = __w_pdfjs_require__(53);

var enumBugKeys = __w_pdfjs_require__(57);

var IE_PROTO = __w_pdfjs_require__(56)('IE_PROTO');

var Empty = function Empty() {};

var PROTOTYPE = 'prototype';

var _createDict = function createDict() {
  var iframe = __w_pdfjs_require__(17)('iframe');

  var i = enumBugKeys.length;
  var lt = '<';
  var gt = '>';
  var iframeDocument;
  iframe.style.display = 'none';

  __w_pdfjs_require__(58).appendChild(iframe);

  iframe.src = 'javascript:';
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
  iframeDocument.close();
  _createDict = iframeDocument.F;

  while (i--) {
    delete _createDict[PROTOTYPE][enumBugKeys[i]];
  }

  return _createDict();
};

module.exports = Object.create || function create(O, Properties) {
  var result;

  if (O !== null) {
    Empty[PROTOTYPE] = anObject(O);
    result = new Empty();
    Empty[PROTOTYPE] = null;
    result[IE_PROTO] = O;
  } else result = _createDict();

  return Properties === undefined ? result : dPs(result, Properties);
};

/***/ }),
/* 53 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var dP = __w_pdfjs_require__(11);

var anObject = __w_pdfjs_require__(12);

var getKeys = __w_pdfjs_require__(54);

module.exports = __w_pdfjs_require__(15) ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = getKeys(Properties);
  var length = keys.length;
  var i = 0;
  var P;

  while (length > i) {
    dP.f(O, P = keys[i++], Properties[P]);
  }

  return O;
};

/***/ }),
/* 54 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $keys = __w_pdfjs_require__(55);

var enumBugKeys = __w_pdfjs_require__(57);

module.exports = Object.keys || function keys(O) {
  return $keys(O, enumBugKeys);
};

/***/ }),
/* 55 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var has = __w_pdfjs_require__(21);

var toIObject = __w_pdfjs_require__(42);

var arrayIndexOf = __w_pdfjs_require__(41)(false);

var IE_PROTO = __w_pdfjs_require__(56)('IE_PROTO');

module.exports = function (object, names) {
  var O = toIObject(object);
  var i = 0;
  var result = [];
  var key;

  for (key in O) {
    if (key != IE_PROTO) has(O, key) && result.push(key);
  }

  while (names.length > i) {
    if (has(O, key = names[i++])) {
      ~arrayIndexOf(result, key) || result.push(key);
    }
  }

  return result;
};

/***/ }),
/* 56 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var shared = __w_pdfjs_require__(31)('keys');

var uid = __w_pdfjs_require__(22);

module.exports = function (key) {
  return shared[key] || (shared[key] = uid(key));
};

/***/ }),
/* 57 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = 'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'.split(',');

/***/ }),
/* 58 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var document = __w_pdfjs_require__(8).document;

module.exports = document && document.documentElement;

/***/ }),
/* 59 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var def = __w_pdfjs_require__(11).f;

var has = __w_pdfjs_require__(21);

var TAG = __w_pdfjs_require__(30)('toStringTag');

module.exports = function (it, tag, stat) {
  if (it && !has(it = stat ? it : it.prototype, TAG)) def(it, TAG, {
    configurable: true,
    value: tag
  });
};

/***/ }),
/* 60 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var has = __w_pdfjs_require__(21);

var toObject = __w_pdfjs_require__(61);

var IE_PROTO = __w_pdfjs_require__(56)('IE_PROTO');

var ObjectProto = Object.prototype;

module.exports = Object.getPrototypeOf || function (O) {
  O = toObject(O);
  if (has(O, IE_PROTO)) return O[IE_PROTO];

  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
    return O.constructor.prototype;
  }

  return O instanceof Object ? ObjectProto : null;
};

/***/ }),
/* 61 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var defined = __w_pdfjs_require__(33);

module.exports = function (it) {
  return Object(defined(it));
};

/***/ }),
/* 62 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(23);

var $export = __w_pdfjs_require__(7);

var toObject = __w_pdfjs_require__(61);

var call = __w_pdfjs_require__(63);

var isArrayIter = __w_pdfjs_require__(64);

var toLength = __w_pdfjs_require__(25);

var createProperty = __w_pdfjs_require__(65);

var getIterFn = __w_pdfjs_require__(66);

$export($export.S + $export.F * !__w_pdfjs_require__(68)(function (iter) {
  Array.from(iter);
}), 'Array', {
  from: function from(arrayLike) {
    var O = toObject(arrayLike);
    var C = typeof this == 'function' ? this : Array;
    var aLen = arguments.length;
    var mapfn = aLen > 1 ? arguments[1] : undefined;
    var mapping = mapfn !== undefined;
    var index = 0;
    var iterFn = getIterFn(O);
    var length, result, step, iterator;
    if (mapping) mapfn = ctx(mapfn, aLen > 2 ? arguments[2] : undefined, 2);

    if (iterFn != undefined && !(C == Array && isArrayIter(iterFn))) {
      for (iterator = iterFn.call(O), result = new C(); !(step = iterator.next()).done; index++) {
        createProperty(result, index, mapping ? call(iterator, mapfn, [step.value, index], true) : step.value);
      }
    } else {
      length = toLength(O.length);

      for (result = new C(length); length > index; index++) {
        createProperty(result, index, mapping ? mapfn(O[index], index) : O[index]);
      }
    }

    result.length = index;
    return result;
  }
});

/***/ }),
/* 63 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(12);

module.exports = function (iterator, fn, value, entries) {
  try {
    return entries ? fn(anObject(value)[0], value[1]) : fn(value);
  } catch (e) {
    var ret = iterator['return'];
    if (ret !== undefined) anObject(ret.call(iterator));
    throw e;
  }
};

/***/ }),
/* 64 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var Iterators = __w_pdfjs_require__(50);

var ITERATOR = __w_pdfjs_require__(30)('iterator');

var ArrayProto = Array.prototype;

module.exports = function (it) {
  return it !== undefined && (Iterators.Array === it || ArrayProto[ITERATOR] === it);
};

/***/ }),
/* 65 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $defineProperty = __w_pdfjs_require__(11);

var createDesc = __w_pdfjs_require__(19);

module.exports = function (object, index, value) {
  if (index in object) $defineProperty.f(object, index, createDesc(0, value));else object[index] = value;
};

/***/ }),
/* 66 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var classof = __w_pdfjs_require__(67);

var ITERATOR = __w_pdfjs_require__(30)('iterator');

var Iterators = __w_pdfjs_require__(50);

module.exports = __w_pdfjs_require__(9).getIteratorMethod = function (it) {
  if (it != undefined) return it[ITERATOR] || it['@@iterator'] || Iterators[classof(it)];
};

/***/ }),
/* 67 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var cof = __w_pdfjs_require__(29);

var TAG = __w_pdfjs_require__(30)('toStringTag');

var ARG = cof(function () {
  return arguments;
}()) == 'Arguments';

var tryGet = function tryGet(it, key) {
  try {
    return it[key];
  } catch (e) {}
};

module.exports = function (it) {
  var O, T, B;
  return it === undefined ? 'Undefined' : it === null ? 'Null' : typeof (T = tryGet(O = Object(it), TAG)) == 'string' ? T : ARG ? cof(O) : (B = cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
};

/***/ }),
/* 68 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ITERATOR = __w_pdfjs_require__(30)('iterator');

var SAFE_CLOSING = false;

try {
  var riter = [7][ITERATOR]();

  riter['return'] = function () {
    SAFE_CLOSING = true;
  };

  Array.from(riter, function () {
    throw 2;
  });
} catch (e) {}

module.exports = function (exec, skipClosing) {
  if (!skipClosing && !SAFE_CLOSING) return false;
  var safe = false;

  try {
    var arr = [7];
    var iter = arr[ITERATOR]();

    iter.next = function () {
      return {
        done: safe = true
      };
    };

    arr[ITERATOR] = function () {
      return iter;
    };

    exec(arr);
  } catch (e) {}

  return safe;
};

/***/ }),
/* 69 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(70);

module.exports = __w_pdfjs_require__(9).Object.assign;

/***/ }),
/* 70 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

$export($export.S + $export.F, 'Object', {
  assign: __w_pdfjs_require__(71)
});

/***/ }),
/* 71 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var getKeys = __w_pdfjs_require__(54);

var gOPS = __w_pdfjs_require__(72);

var pIE = __w_pdfjs_require__(73);

var toObject = __w_pdfjs_require__(61);

var IObject = __w_pdfjs_require__(43);

var $assign = Object.assign;
module.exports = !$assign || __w_pdfjs_require__(16)(function () {
  var A = {};
  var B = {};
  var S = Symbol();
  var K = 'abcdefghijklmnopqrst';
  A[S] = 7;
  K.split('').forEach(function (k) {
    B[k] = k;
  });
  return $assign({}, A)[S] != 7 || Object.keys($assign({}, B)).join('') != K;
}) ? function assign(target, source) {
  var T = toObject(target);
  var aLen = arguments.length;
  var index = 1;
  var getSymbols = gOPS.f;
  var isEnum = pIE.f;

  while (aLen > index) {
    var S = IObject(arguments[index++]);
    var keys = getSymbols ? getKeys(S).concat(getSymbols(S)) : getKeys(S);
    var length = keys.length;
    var j = 0;
    var key;

    while (length > j) {
      if (isEnum.call(S, key = keys[j++])) T[key] = S[key];
    }
  }

  return T;
} : $assign;

/***/ }),
/* 72 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


exports.f = Object.getOwnPropertySymbols;

/***/ }),
/* 73 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


exports.f = {}.propertyIsEnumerable;

/***/ }),
/* 74 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(75);

module.exports = __w_pdfjs_require__(9).Math.log2;

/***/ }),
/* 75 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

$export($export.S, 'Math', {
  log2: function log2(x) {
    return Math.log(x) / Math.LN2;
  }
});

/***/ }),
/* 76 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(77);

module.exports = __w_pdfjs_require__(9).Number.isNaN;

/***/ }),
/* 77 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

$export($export.S, 'Number', {
  isNaN: function isNaN(number) {
    return number != number;
  }
});

/***/ }),
/* 78 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(79);

module.exports = __w_pdfjs_require__(9).Number.isInteger;

/***/ }),
/* 79 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

$export($export.S, 'Number', {
  isInteger: __w_pdfjs_require__(80)
});

/***/ }),
/* 80 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

var floor = Math.floor;

module.exports = function isInteger(it) {
  return !isObject(it) && isFinite(it) && floor(it) === it;
};

/***/ }),
/* 81 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(82);

__w_pdfjs_require__(47);

__w_pdfjs_require__(83);

__w_pdfjs_require__(86);

__w_pdfjs_require__(99);

__w_pdfjs_require__(100);

module.exports = __w_pdfjs_require__(9).Promise;

/***/ }),
/* 82 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var classof = __w_pdfjs_require__(67);

var test = {};
test[__w_pdfjs_require__(30)('toStringTag')] = 'z';

if (test + '' != '[object z]') {
  __w_pdfjs_require__(20)(Object.prototype, 'toString', function toString() {
    return '[object ' + classof(this) + ']';
  }, true);
}

/***/ }),
/* 83 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $iterators = __w_pdfjs_require__(84);

var getKeys = __w_pdfjs_require__(54);

var redefine = __w_pdfjs_require__(20);

var global = __w_pdfjs_require__(8);

var hide = __w_pdfjs_require__(10);

var Iterators = __w_pdfjs_require__(50);

var wks = __w_pdfjs_require__(30);

var ITERATOR = wks('iterator');
var TO_STRING_TAG = wks('toStringTag');
var ArrayValues = Iterators.Array;
var DOMIterables = {
  CSSRuleList: true,
  CSSStyleDeclaration: false,
  CSSValueList: false,
  ClientRectList: false,
  DOMRectList: false,
  DOMStringList: false,
  DOMTokenList: true,
  DataTransferItemList: false,
  FileList: false,
  HTMLAllCollection: false,
  HTMLCollection: false,
  HTMLFormElement: false,
  HTMLSelectElement: false,
  MediaList: true,
  MimeTypeArray: false,
  NamedNodeMap: false,
  NodeList: true,
  PaintRequestList: false,
  Plugin: false,
  PluginArray: false,
  SVGLengthList: false,
  SVGNumberList: false,
  SVGPathSegList: false,
  SVGPointList: false,
  SVGStringList: false,
  SVGTransformList: false,
  SourceBufferList: false,
  StyleSheetList: true,
  TextTrackCueList: false,
  TextTrackList: false,
  TouchList: false
};

for (var collections = getKeys(DOMIterables), i = 0; i < collections.length; i++) {
  var NAME = collections[i];
  var explicit = DOMIterables[NAME];
  var Collection = global[NAME];
  var proto = Collection && Collection.prototype;
  var key;

  if (proto) {
    if (!proto[ITERATOR]) hide(proto, ITERATOR, ArrayValues);
    if (!proto[TO_STRING_TAG]) hide(proto, TO_STRING_TAG, NAME);
    Iterators[NAME] = ArrayValues;
    if (explicit) for (key in $iterators) {
      if (!proto[key]) redefine(proto, key, $iterators[key], true);
    }
  }
}

/***/ }),
/* 84 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var addToUnscopables = __w_pdfjs_require__(45);

var step = __w_pdfjs_require__(85);

var Iterators = __w_pdfjs_require__(50);

var toIObject = __w_pdfjs_require__(42);

module.exports = __w_pdfjs_require__(49)(Array, 'Array', function (iterated, kind) {
  this._t = toIObject(iterated);
  this._i = 0;
  this._k = kind;
}, function () {
  var O = this._t;
  var kind = this._k;
  var index = this._i++;

  if (!O || index >= O.length) {
    this._t = undefined;
    return step(1);
  }

  if (kind == 'keys') return step(0, index);
  if (kind == 'values') return step(0, O[index]);
  return step(0, [index, O[index]]);
}, 'values');
Iterators.Arguments = Iterators.Array;
addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');

/***/ }),
/* 85 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (done, value) {
  return {
    value: value,
    done: !!done
  };
};

/***/ }),
/* 86 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var LIBRARY = __w_pdfjs_require__(32);

var global = __w_pdfjs_require__(8);

var ctx = __w_pdfjs_require__(23);

var classof = __w_pdfjs_require__(67);

var $export = __w_pdfjs_require__(7);

var isObject = __w_pdfjs_require__(13);

var aFunction = __w_pdfjs_require__(24);

var anInstance = __w_pdfjs_require__(87);

var forOf = __w_pdfjs_require__(88);

var speciesConstructor = __w_pdfjs_require__(89);

var task = __w_pdfjs_require__(90).set;

var microtask = __w_pdfjs_require__(92)();

var newPromiseCapabilityModule = __w_pdfjs_require__(93);

var perform = __w_pdfjs_require__(94);

var userAgent = __w_pdfjs_require__(95);

var promiseResolve = __w_pdfjs_require__(96);

var PROMISE = 'Promise';
var TypeError = global.TypeError;
var process = global.process;
var versions = process && process.versions;
var v8 = versions && versions.v8 || '';
var $Promise = global[PROMISE];
var isNode = classof(process) == 'process';

var empty = function empty() {};

var Internal, newGenericPromiseCapability, OwnPromiseCapability, Wrapper;
var newPromiseCapability = newGenericPromiseCapability = newPromiseCapabilityModule.f;
var USE_NATIVE = !!function () {
  try {
    var promise = $Promise.resolve(1);

    var FakePromise = (promise.constructor = {})[__w_pdfjs_require__(30)('species')] = function (exec) {
      exec(empty, empty);
    };

    return (isNode || typeof PromiseRejectionEvent == 'function') && promise.then(empty) instanceof FakePromise && v8.indexOf('6.6') !== 0 && userAgent.indexOf('Chrome/66') === -1;
  } catch (e) {}
}();

var isThenable = function isThenable(it) {
  var then;
  return isObject(it) && typeof (then = it.then) == 'function' ? then : false;
};

var notify = function notify(promise, isReject) {
  if (promise._n) return;
  promise._n = true;
  var chain = promise._c;
  microtask(function () {
    var value = promise._v;
    var ok = promise._s == 1;
    var i = 0;

    var run = function run(reaction) {
      var handler = ok ? reaction.ok : reaction.fail;
      var resolve = reaction.resolve;
      var reject = reaction.reject;
      var domain = reaction.domain;
      var result, then, exited;

      try {
        if (handler) {
          if (!ok) {
            if (promise._h == 2) onHandleUnhandled(promise);
            promise._h = 1;
          }

          if (handler === true) result = value;else {
            if (domain) domain.enter();
            result = handler(value);

            if (domain) {
              domain.exit();
              exited = true;
            }
          }

          if (result === reaction.promise) {
            reject(TypeError('Promise-chain cycle'));
          } else if (then = isThenable(result)) {
            then.call(result, resolve, reject);
          } else resolve(result);
        } else reject(value);
      } catch (e) {
        if (domain && !exited) domain.exit();
        reject(e);
      }
    };

    while (chain.length > i) {
      run(chain[i++]);
    }

    promise._c = [];
    promise._n = false;
    if (isReject && !promise._h) onUnhandled(promise);
  });
};

var onUnhandled = function onUnhandled(promise) {
  task.call(global, function () {
    var value = promise._v;
    var unhandled = isUnhandled(promise);
    var result, handler, console;

    if (unhandled) {
      result = perform(function () {
        if (isNode) {
          process.emit('unhandledRejection', value, promise);
        } else if (handler = global.onunhandledrejection) {
          handler({
            promise: promise,
            reason: value
          });
        } else if ((console = global.console) && console.error) {
          console.error('Unhandled promise rejection', value);
        }
      });
      promise._h = isNode || isUnhandled(promise) ? 2 : 1;
    }

    promise._a = undefined;
    if (unhandled && result.e) throw result.v;
  });
};

var isUnhandled = function isUnhandled(promise) {
  return promise._h !== 1 && (promise._a || promise._c).length === 0;
};

var onHandleUnhandled = function onHandleUnhandled(promise) {
  task.call(global, function () {
    var handler;

    if (isNode) {
      process.emit('rejectionHandled', promise);
    } else if (handler = global.onrejectionhandled) {
      handler({
        promise: promise,
        reason: promise._v
      });
    }
  });
};

var $reject = function $reject(value) {
  var promise = this;
  if (promise._d) return;
  promise._d = true;
  promise = promise._w || promise;
  promise._v = value;
  promise._s = 2;
  if (!promise._a) promise._a = promise._c.slice();
  notify(promise, true);
};

var $resolve = function $resolve(value) {
  var promise = this;
  var then;
  if (promise._d) return;
  promise._d = true;
  promise = promise._w || promise;

  try {
    if (promise === value) throw TypeError("Promise can't be resolved itself");

    if (then = isThenable(value)) {
      microtask(function () {
        var wrapper = {
          _w: promise,
          _d: false
        };

        try {
          then.call(value, ctx($resolve, wrapper, 1), ctx($reject, wrapper, 1));
        } catch (e) {
          $reject.call(wrapper, e);
        }
      });
    } else {
      promise._v = value;
      promise._s = 1;
      notify(promise, false);
    }
  } catch (e) {
    $reject.call({
      _w: promise,
      _d: false
    }, e);
  }
};

if (!USE_NATIVE) {
  $Promise = function Promise(executor) {
    anInstance(this, $Promise, PROMISE, '_h');
    aFunction(executor);
    Internal.call(this);

    try {
      executor(ctx($resolve, this, 1), ctx($reject, this, 1));
    } catch (err) {
      $reject.call(this, err);
    }
  };

  Internal = function Promise(executor) {
    this._c = [];
    this._a = undefined;
    this._s = 0;
    this._d = false;
    this._v = undefined;
    this._h = 0;
    this._n = false;
  };

  Internal.prototype = __w_pdfjs_require__(97)($Promise.prototype, {
    then: function then(onFulfilled, onRejected) {
      var reaction = newPromiseCapability(speciesConstructor(this, $Promise));
      reaction.ok = typeof onFulfilled == 'function' ? onFulfilled : true;
      reaction.fail = typeof onRejected == 'function' && onRejected;
      reaction.domain = isNode ? process.domain : undefined;

      this._c.push(reaction);

      if (this._a) this._a.push(reaction);
      if (this._s) notify(this, false);
      return reaction.promise;
    },
    'catch': function _catch(onRejected) {
      return this.then(undefined, onRejected);
    }
  });

  OwnPromiseCapability = function OwnPromiseCapability() {
    var promise = new Internal();
    this.promise = promise;
    this.resolve = ctx($resolve, promise, 1);
    this.reject = ctx($reject, promise, 1);
  };

  newPromiseCapabilityModule.f = newPromiseCapability = function newPromiseCapability(C) {
    return C === $Promise || C === Wrapper ? new OwnPromiseCapability(C) : newGenericPromiseCapability(C);
  };
}

$export($export.G + $export.W + $export.F * !USE_NATIVE, {
  Promise: $Promise
});

__w_pdfjs_require__(59)($Promise, PROMISE);

__w_pdfjs_require__(98)(PROMISE);

Wrapper = __w_pdfjs_require__(9)[PROMISE];
$export($export.S + $export.F * !USE_NATIVE, PROMISE, {
  reject: function reject(r) {
    var capability = newPromiseCapability(this);
    var $$reject = capability.reject;
    $$reject(r);
    return capability.promise;
  }
});
$export($export.S + $export.F * (LIBRARY || !USE_NATIVE), PROMISE, {
  resolve: function resolve(x) {
    return promiseResolve(LIBRARY && this === Wrapper ? $Promise : this, x);
  }
});
$export($export.S + $export.F * !(USE_NATIVE && __w_pdfjs_require__(68)(function (iter) {
  $Promise.all(iter)['catch'](empty);
})), PROMISE, {
  all: function all(iterable) {
    var C = this;
    var capability = newPromiseCapability(C);
    var resolve = capability.resolve;
    var reject = capability.reject;
    var result = perform(function () {
      var values = [];
      var index = 0;
      var remaining = 1;
      forOf(iterable, false, function (promise) {
        var $index = index++;
        var alreadyCalled = false;
        values.push(undefined);
        remaining++;
        C.resolve(promise).then(function (value) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[$index] = value;
          --remaining || resolve(values);
        }, reject);
      });
      --remaining || resolve(values);
    });
    if (result.e) reject(result.v);
    return capability.promise;
  },
  race: function race(iterable) {
    var C = this;
    var capability = newPromiseCapability(C);
    var reject = capability.reject;
    var result = perform(function () {
      forOf(iterable, false, function (promise) {
        C.resolve(promise).then(capability.resolve, reject);
      });
    });
    if (result.e) reject(result.v);
    return capability.promise;
  }
});

/***/ }),
/* 87 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (it, Constructor, name, forbiddenField) {
  if (!(it instanceof Constructor) || forbiddenField !== undefined && forbiddenField in it) {
    throw TypeError(name + ': incorrect invocation!');
  }

  return it;
};

/***/ }),
/* 88 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(23);

var call = __w_pdfjs_require__(63);

var isArrayIter = __w_pdfjs_require__(64);

var anObject = __w_pdfjs_require__(12);

var toLength = __w_pdfjs_require__(25);

var getIterFn = __w_pdfjs_require__(66);

var BREAK = {};
var RETURN = {};

var _exports = module.exports = function (iterable, entries, fn, that, ITERATOR) {
  var iterFn = ITERATOR ? function () {
    return iterable;
  } : getIterFn(iterable);
  var f = ctx(fn, that, entries ? 2 : 1);
  var index = 0;
  var length, step, iterator, result;
  if (typeof iterFn != 'function') throw TypeError(iterable + ' is not iterable!');
  if (isArrayIter(iterFn)) for (length = toLength(iterable.length); length > index; index++) {
    result = entries ? f(anObject(step = iterable[index])[0], step[1]) : f(iterable[index]);
    if (result === BREAK || result === RETURN) return result;
  } else for (iterator = iterFn.call(iterable); !(step = iterator.next()).done;) {
    result = call(iterator, f, step.value, entries);
    if (result === BREAK || result === RETURN) return result;
  }
};

_exports.BREAK = BREAK;
_exports.RETURN = RETURN;

/***/ }),
/* 89 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(12);

var aFunction = __w_pdfjs_require__(24);

var SPECIES = __w_pdfjs_require__(30)('species');

module.exports = function (O, D) {
  var C = anObject(O).constructor;
  var S;
  return C === undefined || (S = anObject(C)[SPECIES]) == undefined ? D : aFunction(S);
};

/***/ }),
/* 90 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(23);

var invoke = __w_pdfjs_require__(91);

var html = __w_pdfjs_require__(58);

var cel = __w_pdfjs_require__(17);

var global = __w_pdfjs_require__(8);

var process = global.process;
var setTask = global.setImmediate;
var clearTask = global.clearImmediate;
var MessageChannel = global.MessageChannel;
var Dispatch = global.Dispatch;
var counter = 0;
var queue = {};
var ONREADYSTATECHANGE = 'onreadystatechange';
var defer, channel, port;

var run = function run() {
  var id = +this;

  if (queue.hasOwnProperty(id)) {
    var fn = queue[id];
    delete queue[id];
    fn();
  }
};

var listener = function listener(event) {
  run.call(event.data);
};

if (!setTask || !clearTask) {
  setTask = function setImmediate(fn) {
    var args = [];
    var i = 1;

    while (arguments.length > i) {
      args.push(arguments[i++]);
    }

    queue[++counter] = function () {
      invoke(typeof fn == 'function' ? fn : Function(fn), args);
    };

    defer(counter);
    return counter;
  };

  clearTask = function clearImmediate(id) {
    delete queue[id];
  };

  if (__w_pdfjs_require__(29)(process) == 'process') {
    defer = function defer(id) {
      process.nextTick(ctx(run, id, 1));
    };
  } else if (Dispatch && Dispatch.now) {
    defer = function defer(id) {
      Dispatch.now(ctx(run, id, 1));
    };
  } else if (MessageChannel) {
    channel = new MessageChannel();
    port = channel.port2;
    channel.port1.onmessage = listener;
    defer = ctx(port.postMessage, port, 1);
  } else if (global.addEventListener && typeof postMessage == 'function' && !global.importScripts) {
    defer = function defer(id) {
      global.postMessage(id + '', '*');
    };

    global.addEventListener('message', listener, false);
  } else if (ONREADYSTATECHANGE in cel('script')) {
    defer = function defer(id) {
      html.appendChild(cel('script'))[ONREADYSTATECHANGE] = function () {
        html.removeChild(this);
        run.call(id);
      };
    };
  } else {
    defer = function defer(id) {
      setTimeout(ctx(run, id, 1), 0);
    };
  }
}

module.exports = {
  set: setTask,
  clear: clearTask
};

/***/ }),
/* 91 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (fn, args, that) {
  var un = that === undefined;

  switch (args.length) {
    case 0:
      return un ? fn() : fn.call(that);

    case 1:
      return un ? fn(args[0]) : fn.call(that, args[0]);

    case 2:
      return un ? fn(args[0], args[1]) : fn.call(that, args[0], args[1]);

    case 3:
      return un ? fn(args[0], args[1], args[2]) : fn.call(that, args[0], args[1], args[2]);

    case 4:
      return un ? fn(args[0], args[1], args[2], args[3]) : fn.call(that, args[0], args[1], args[2], args[3]);
  }

  return fn.apply(that, args);
};

/***/ }),
/* 92 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(8);

var macrotask = __w_pdfjs_require__(90).set;

var Observer = global.MutationObserver || global.WebKitMutationObserver;
var process = global.process;
var Promise = global.Promise;
var isNode = __w_pdfjs_require__(29)(process) == 'process';

module.exports = function () {
  var head, last, notify;

  var flush = function flush() {
    var parent, fn;
    if (isNode && (parent = process.domain)) parent.exit();

    while (head) {
      fn = head.fn;
      head = head.next;

      try {
        fn();
      } catch (e) {
        if (head) notify();else last = undefined;
        throw e;
      }
    }

    last = undefined;
    if (parent) parent.enter();
  };

  if (isNode) {
    notify = function notify() {
      process.nextTick(flush);
    };
  } else if (Observer && !(global.navigator && global.navigator.standalone)) {
    var toggle = true;
    var node = document.createTextNode('');
    new Observer(flush).observe(node, {
      characterData: true
    });

    notify = function notify() {
      node.data = toggle = !toggle;
    };
  } else if (Promise && Promise.resolve) {
    var promise = Promise.resolve(undefined);

    notify = function notify() {
      promise.then(flush);
    };
  } else {
    notify = function notify() {
      macrotask.call(global, flush);
    };
  }

  return function (fn) {
    var task = {
      fn: fn,
      next: undefined
    };
    if (last) last.next = task;

    if (!head) {
      head = task;
      notify();
    }

    last = task;
  };
};

/***/ }),
/* 93 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var aFunction = __w_pdfjs_require__(24);

function PromiseCapability(C) {
  var resolve, reject;
  this.promise = new C(function ($$resolve, $$reject) {
    if (resolve !== undefined || reject !== undefined) throw TypeError('Bad Promise constructor');
    resolve = $$resolve;
    reject = $$reject;
  });
  this.resolve = aFunction(resolve);
  this.reject = aFunction(reject);
}

module.exports.f = function (C) {
  return new PromiseCapability(C);
};

/***/ }),
/* 94 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (exec) {
  try {
    return {
      e: false,
      v: exec()
    };
  } catch (e) {
    return {
      e: true,
      v: e
    };
  }
};

/***/ }),
/* 95 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(8);

var navigator = global.navigator;
module.exports = navigator && navigator.userAgent || '';

/***/ }),
/* 96 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(12);

var isObject = __w_pdfjs_require__(13);

var newPromiseCapability = __w_pdfjs_require__(93);

module.exports = function (C, x) {
  anObject(C);
  if (isObject(x) && x.constructor === C) return x;
  var promiseCapability = newPromiseCapability.f(C);
  var resolve = promiseCapability.resolve;
  resolve(x);
  return promiseCapability.promise;
};

/***/ }),
/* 97 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var redefine = __w_pdfjs_require__(20);

module.exports = function (target, src, safe) {
  for (var key in src) {
    redefine(target, key, src[key], safe);
  }

  return target;
};

/***/ }),
/* 98 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(8);

var dP = __w_pdfjs_require__(11);

var DESCRIPTORS = __w_pdfjs_require__(15);

var SPECIES = __w_pdfjs_require__(30)('species');

module.exports = function (KEY) {
  var C = global[KEY];
  if (DESCRIPTORS && C && !C[SPECIES]) dP.f(C, SPECIES, {
    configurable: true,
    get: function get() {
      return this;
    }
  });
};

/***/ }),
/* 99 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var core = __w_pdfjs_require__(9);

var global = __w_pdfjs_require__(8);

var speciesConstructor = __w_pdfjs_require__(89);

var promiseResolve = __w_pdfjs_require__(96);

$export($export.P + $export.R, 'Promise', {
  'finally': function _finally(onFinally) {
    var C = speciesConstructor(this, core.Promise || global.Promise);
    var isFunction = typeof onFinally == 'function';
    return this.then(isFunction ? function (x) {
      return promiseResolve(C, onFinally()).then(function () {
        return x;
      });
    } : onFinally, isFunction ? function (e) {
      return promiseResolve(C, onFinally()).then(function () {
        throw e;
      });
    } : onFinally);
  }
});

/***/ }),
/* 100 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var newPromiseCapability = __w_pdfjs_require__(93);

var perform = __w_pdfjs_require__(94);

$export($export.S, 'Promise', {
  'try': function _try(callbackfn) {
    var promiseCapability = newPromiseCapability.f(this);
    var result = perform(callbackfn);
    (result.e ? promiseCapability.reject : promiseCapability.resolve)(result.v);
    return promiseCapability.promise;
  }
});

/***/ }),
/* 101 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(82);

__w_pdfjs_require__(83);

__w_pdfjs_require__(102);

__w_pdfjs_require__(114);

__w_pdfjs_require__(116);

module.exports = __w_pdfjs_require__(9).WeakMap;

/***/ }),
/* 102 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var each = __w_pdfjs_require__(103)(0);

var redefine = __w_pdfjs_require__(20);

var meta = __w_pdfjs_require__(107);

var assign = __w_pdfjs_require__(71);

var weak = __w_pdfjs_require__(108);

var isObject = __w_pdfjs_require__(13);

var fails = __w_pdfjs_require__(16);

var validate = __w_pdfjs_require__(109);

var WEAK_MAP = 'WeakMap';
var getWeak = meta.getWeak;
var isExtensible = Object.isExtensible;
var uncaughtFrozenStore = weak.ufstore;
var tmp = {};
var InternalMap;

var wrapper = function wrapper(get) {
  return function WeakMap() {
    return get(this, arguments.length > 0 ? arguments[0] : undefined);
  };
};

var methods = {
  get: function get(key) {
    if (isObject(key)) {
      var data = getWeak(key);
      if (data === true) return uncaughtFrozenStore(validate(this, WEAK_MAP)).get(key);
      return data ? data[this._i] : undefined;
    }
  },
  set: function set(key, value) {
    return weak.def(validate(this, WEAK_MAP), key, value);
  }
};

var $WeakMap = module.exports = __w_pdfjs_require__(110)(WEAK_MAP, wrapper, methods, weak, true, true);

if (fails(function () {
  return new $WeakMap().set((Object.freeze || Object)(tmp), 7).get(tmp) != 7;
})) {
  InternalMap = weak.getConstructor(wrapper, WEAK_MAP);
  assign(InternalMap.prototype, methods);
  meta.NEED = true;
  each(['delete', 'has', 'get', 'set'], function (key) {
    var proto = $WeakMap.prototype;
    var method = proto[key];
    redefine(proto, key, function (a, b) {
      if (isObject(a) && !isExtensible(a)) {
        if (!this._f) this._f = new InternalMap();

        var result = this._f[key](a, b);

        return key == 'set' ? this : result;
      }

      return method.call(this, a, b);
    });
  });
}

/***/ }),
/* 103 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(23);

var IObject = __w_pdfjs_require__(43);

var toObject = __w_pdfjs_require__(61);

var toLength = __w_pdfjs_require__(25);

var asc = __w_pdfjs_require__(104);

module.exports = function (TYPE, $create) {
  var IS_MAP = TYPE == 1;
  var IS_FILTER = TYPE == 2;
  var IS_SOME = TYPE == 3;
  var IS_EVERY = TYPE == 4;
  var IS_FIND_INDEX = TYPE == 6;
  var NO_HOLES = TYPE == 5 || IS_FIND_INDEX;
  var create = $create || asc;
  return function ($this, callbackfn, that) {
    var O = toObject($this);
    var self = IObject(O);
    var f = ctx(callbackfn, that, 3);
    var length = toLength(self.length);
    var index = 0;
    var result = IS_MAP ? create($this, length) : IS_FILTER ? create($this, 0) : undefined;
    var val, res;

    for (; length > index; index++) {
      if (NO_HOLES || index in self) {
        val = self[index];
        res = f(val, index, O);

        if (TYPE) {
          if (IS_MAP) result[index] = res;else if (res) switch (TYPE) {
            case 3:
              return true;

            case 5:
              return val;

            case 6:
              return index;

            case 2:
              result.push(val);
          } else if (IS_EVERY) return false;
        }
      }
    }

    return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : result;
  };
};

/***/ }),
/* 104 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var speciesConstructor = __w_pdfjs_require__(105);

module.exports = function (original, length) {
  return new (speciesConstructor(original))(length);
};

/***/ }),
/* 105 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

var isArray = __w_pdfjs_require__(106);

var SPECIES = __w_pdfjs_require__(30)('species');

module.exports = function (original) {
  var C;

  if (isArray(original)) {
    C = original.constructor;
    if (typeof C == 'function' && (C === Array || isArray(C.prototype))) C = undefined;

    if (isObject(C)) {
      C = C[SPECIES];
      if (C === null) C = undefined;
    }
  }

  return C === undefined ? Array : C;
};

/***/ }),
/* 106 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var cof = __w_pdfjs_require__(29);

module.exports = Array.isArray || function isArray(arg) {
  return cof(arg) == 'Array';
};

/***/ }),
/* 107 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var META = __w_pdfjs_require__(22)('meta');

var isObject = __w_pdfjs_require__(13);

var has = __w_pdfjs_require__(21);

var setDesc = __w_pdfjs_require__(11).f;

var id = 0;

var isExtensible = Object.isExtensible || function () {
  return true;
};

var FREEZE = !__w_pdfjs_require__(16)(function () {
  return isExtensible(Object.preventExtensions({}));
});

var setMeta = function setMeta(it) {
  setDesc(it, META, {
    value: {
      i: 'O' + ++id,
      w: {}
    }
  });
};

var fastKey = function fastKey(it, create) {
  if (!isObject(it)) return _typeof(it) == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;

  if (!has(it, META)) {
    if (!isExtensible(it)) return 'F';
    if (!create) return 'E';
    setMeta(it);
  }

  return it[META].i;
};

var getWeak = function getWeak(it, create) {
  if (!has(it, META)) {
    if (!isExtensible(it)) return true;
    if (!create) return false;
    setMeta(it);
  }

  return it[META].w;
};

var onFreeze = function onFreeze(it) {
  if (FREEZE && meta.NEED && isExtensible(it) && !has(it, META)) setMeta(it);
  return it;
};

var meta = module.exports = {
  KEY: META,
  NEED: false,
  fastKey: fastKey,
  getWeak: getWeak,
  onFreeze: onFreeze
};

/***/ }),
/* 108 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var redefineAll = __w_pdfjs_require__(97);

var getWeak = __w_pdfjs_require__(107).getWeak;

var anObject = __w_pdfjs_require__(12);

var isObject = __w_pdfjs_require__(13);

var anInstance = __w_pdfjs_require__(87);

var forOf = __w_pdfjs_require__(88);

var createArrayMethod = __w_pdfjs_require__(103);

var $has = __w_pdfjs_require__(21);

var validate = __w_pdfjs_require__(109);

var arrayFind = createArrayMethod(5);
var arrayFindIndex = createArrayMethod(6);
var id = 0;

var uncaughtFrozenStore = function uncaughtFrozenStore(that) {
  return that._l || (that._l = new UncaughtFrozenStore());
};

var UncaughtFrozenStore = function UncaughtFrozenStore() {
  this.a = [];
};

var findUncaughtFrozen = function findUncaughtFrozen(store, key) {
  return arrayFind(store.a, function (it) {
    return it[0] === key;
  });
};

UncaughtFrozenStore.prototype = {
  get: function get(key) {
    var entry = findUncaughtFrozen(this, key);
    if (entry) return entry[1];
  },
  has: function has(key) {
    return !!findUncaughtFrozen(this, key);
  },
  set: function set(key, value) {
    var entry = findUncaughtFrozen(this, key);
    if (entry) entry[1] = value;else this.a.push([key, value]);
  },
  'delete': function _delete(key) {
    var index = arrayFindIndex(this.a, function (it) {
      return it[0] === key;
    });
    if (~index) this.a.splice(index, 1);
    return !!~index;
  }
};
module.exports = {
  getConstructor: function getConstructor(wrapper, NAME, IS_MAP, ADDER) {
    var C = wrapper(function (that, iterable) {
      anInstance(that, C, NAME, '_i');
      that._t = NAME;
      that._i = id++;
      that._l = undefined;
      if (iterable != undefined) forOf(iterable, IS_MAP, that[ADDER], that);
    });
    redefineAll(C.prototype, {
      'delete': function _delete(key) {
        if (!isObject(key)) return false;
        var data = getWeak(key);
        if (data === true) return uncaughtFrozenStore(validate(this, NAME))['delete'](key);
        return data && $has(data, this._i) && delete data[this._i];
      },
      has: function has(key) {
        if (!isObject(key)) return false;
        var data = getWeak(key);
        if (data === true) return uncaughtFrozenStore(validate(this, NAME)).has(key);
        return data && $has(data, this._i);
      }
    });
    return C;
  },
  def: function def(that, key, value) {
    var data = getWeak(anObject(key), true);
    if (data === true) uncaughtFrozenStore(that).set(key, value);else data[that._i] = value;
    return that;
  },
  ufstore: uncaughtFrozenStore
};

/***/ }),
/* 109 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

module.exports = function (it, TYPE) {
  if (!isObject(it) || it._t !== TYPE) throw TypeError('Incompatible receiver, ' + TYPE + ' required!');
  return it;
};

/***/ }),
/* 110 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(8);

var $export = __w_pdfjs_require__(7);

var redefine = __w_pdfjs_require__(20);

var redefineAll = __w_pdfjs_require__(97);

var meta = __w_pdfjs_require__(107);

var forOf = __w_pdfjs_require__(88);

var anInstance = __w_pdfjs_require__(87);

var isObject = __w_pdfjs_require__(13);

var fails = __w_pdfjs_require__(16);

var $iterDetect = __w_pdfjs_require__(68);

var setToStringTag = __w_pdfjs_require__(59);

var inheritIfRequired = __w_pdfjs_require__(111);

module.exports = function (NAME, wrapper, methods, common, IS_MAP, IS_WEAK) {
  var Base = global[NAME];
  var C = Base;
  var ADDER = IS_MAP ? 'set' : 'add';
  var proto = C && C.prototype;
  var O = {};

  var fixMethod = function fixMethod(KEY) {
    var fn = proto[KEY];
    redefine(proto, KEY, KEY == 'delete' ? function (a) {
      return IS_WEAK && !isObject(a) ? false : fn.call(this, a === 0 ? 0 : a);
    } : KEY == 'has' ? function has(a) {
      return IS_WEAK && !isObject(a) ? false : fn.call(this, a === 0 ? 0 : a);
    } : KEY == 'get' ? function get(a) {
      return IS_WEAK && !isObject(a) ? undefined : fn.call(this, a === 0 ? 0 : a);
    } : KEY == 'add' ? function add(a) {
      fn.call(this, a === 0 ? 0 : a);
      return this;
    } : function set(a, b) {
      fn.call(this, a === 0 ? 0 : a, b);
      return this;
    });
  };

  if (typeof C != 'function' || !(IS_WEAK || proto.forEach && !fails(function () {
    new C().entries().next();
  }))) {
    C = common.getConstructor(wrapper, NAME, IS_MAP, ADDER);
    redefineAll(C.prototype, methods);
    meta.NEED = true;
  } else {
    var instance = new C();
    var HASNT_CHAINING = instance[ADDER](IS_WEAK ? {} : -0, 1) != instance;
    var THROWS_ON_PRIMITIVES = fails(function () {
      instance.has(1);
    });
    var ACCEPT_ITERABLES = $iterDetect(function (iter) {
      new C(iter);
    });
    var BUGGY_ZERO = !IS_WEAK && fails(function () {
      var $instance = new C();
      var index = 5;

      while (index--) {
        $instance[ADDER](index, index);
      }

      return !$instance.has(-0);
    });

    if (!ACCEPT_ITERABLES) {
      C = wrapper(function (target, iterable) {
        anInstance(target, C, NAME);
        var that = inheritIfRequired(new Base(), target, C);
        if (iterable != undefined) forOf(iterable, IS_MAP, that[ADDER], that);
        return that;
      });
      C.prototype = proto;
      proto.constructor = C;
    }

    if (THROWS_ON_PRIMITIVES || BUGGY_ZERO) {
      fixMethod('delete');
      fixMethod('has');
      IS_MAP && fixMethod('get');
    }

    if (BUGGY_ZERO || HASNT_CHAINING) fixMethod(ADDER);
    if (IS_WEAK && proto.clear) delete proto.clear;
  }

  setToStringTag(C, NAME);
  O[NAME] = C;
  $export($export.G + $export.W + $export.F * (C != Base), O);
  if (!IS_WEAK) common.setStrong(C, NAME, IS_MAP);
  return C;
};

/***/ }),
/* 111 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

var setPrototypeOf = __w_pdfjs_require__(112).set;

module.exports = function (that, target, C) {
  var S = target.constructor;
  var P;

  if (S !== C && typeof S == 'function' && (P = S.prototype) !== C.prototype && isObject(P) && setPrototypeOf) {
    setPrototypeOf(that, P);
  }

  return that;
};

/***/ }),
/* 112 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(13);

var anObject = __w_pdfjs_require__(12);

var check = function check(O, proto) {
  anObject(O);
  if (!isObject(proto) && proto !== null) throw TypeError(proto + ": can't set as prototype!");
};

module.exports = {
  set: Object.setPrototypeOf || ('__proto__' in {} ? function (test, buggy, set) {
    try {
      set = __w_pdfjs_require__(23)(Function.call, __w_pdfjs_require__(113).f(Object.prototype, '__proto__').set, 2);
      set(test, []);
      buggy = !(test instanceof Array);
    } catch (e) {
      buggy = true;
    }

    return function setPrototypeOf(O, proto) {
      check(O, proto);
      if (buggy) O.__proto__ = proto;else set(O, proto);
      return O;
    };
  }({}, false) : undefined),
  check: check
};

/***/ }),
/* 113 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var pIE = __w_pdfjs_require__(73);

var createDesc = __w_pdfjs_require__(19);

var toIObject = __w_pdfjs_require__(42);

var toPrimitive = __w_pdfjs_require__(18);

var has = __w_pdfjs_require__(21);

var IE8_DOM_DEFINE = __w_pdfjs_require__(14);

var gOPD = Object.getOwnPropertyDescriptor;
exports.f = __w_pdfjs_require__(15) ? gOPD : function getOwnPropertyDescriptor(O, P) {
  O = toIObject(O);
  P = toPrimitive(P, true);
  if (IE8_DOM_DEFINE) try {
    return gOPD(O, P);
  } catch (e) {}
  if (has(O, P)) return createDesc(!pIE.f.call(O, P), O[P]);
};

/***/ }),
/* 114 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(115)('WeakMap');

/***/ }),
/* 115 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

module.exports = function (COLLECTION) {
  $export($export.S, COLLECTION, {
    of: function of() {
      var length = arguments.length;
      var A = new Array(length);

      while (length--) {
        A[length] = arguments[length];
      }

      return new this(A);
    }
  });
};

/***/ }),
/* 116 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(117)('WeakMap');

/***/ }),
/* 117 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var aFunction = __w_pdfjs_require__(24);

var ctx = __w_pdfjs_require__(23);

var forOf = __w_pdfjs_require__(88);

module.exports = function (COLLECTION) {
  $export($export.S, COLLECTION, {
    from: function from(source) {
      var mapFn = arguments[1];
      var mapping, A, n, cb;
      aFunction(this);
      mapping = mapFn !== undefined;
      if (mapping) aFunction(mapFn);
      if (source == undefined) return new this();
      A = [];

      if (mapping) {
        n = 0;
        cb = ctx(mapFn, arguments[2], 2);
        forOf(source, false, function (nextItem) {
          A.push(cb(nextItem, n++));
        });
      } else {
        forOf(source, false, A.push, A);
      }

      return new this(A);
    }
  });
};

/***/ }),
/* 118 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(82);

__w_pdfjs_require__(83);

__w_pdfjs_require__(119);

__w_pdfjs_require__(120);

__w_pdfjs_require__(121);

module.exports = __w_pdfjs_require__(9).WeakSet;

/***/ }),
/* 119 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var weak = __w_pdfjs_require__(108);

var validate = __w_pdfjs_require__(109);

var WEAK_SET = 'WeakSet';

__w_pdfjs_require__(110)(WEAK_SET, function (get) {
  return function WeakSet() {
    return get(this, arguments.length > 0 ? arguments[0] : undefined);
  };
}, {
  add: function add(value) {
    return weak.def(validate(this, WEAK_SET), value, true);
  }
}, weak, false, true);

/***/ }),
/* 120 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(115)('WeakSet');

/***/ }),
/* 121 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(117)('WeakSet');

/***/ }),
/* 122 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(123);

module.exports = __w_pdfjs_require__(9).String.codePointAt;

/***/ }),
/* 123 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var $at = __w_pdfjs_require__(48)(false);

$export($export.P, 'String', {
  codePointAt: function codePointAt(pos) {
    return $at(this, pos);
  }
});

/***/ }),
/* 124 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(125);

module.exports = __w_pdfjs_require__(9).String.fromCodePoint;

/***/ }),
/* 125 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var toAbsoluteIndex = __w_pdfjs_require__(44);

var fromCharCode = String.fromCharCode;
var $fromCodePoint = String.fromCodePoint;
$export($export.S + $export.F * (!!$fromCodePoint && $fromCodePoint.length != 1), 'String', {
  fromCodePoint: function fromCodePoint(x) {
    var res = [];
    var aLen = arguments.length;
    var i = 0;
    var code;

    while (aLen > i) {
      code = +arguments[i++];
      if (toAbsoluteIndex(code, 0x10ffff) !== code) throw RangeError(code + ' is not a valid code point');
      res.push(code < 0x10000 ? fromCharCode(code) : fromCharCode(((code -= 0x10000) >> 10) + 0xd800, code % 0x400 + 0xdc00));
    }

    return res.join('');
  }
});

/***/ }),
/* 126 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(127);

__w_pdfjs_require__(82);

module.exports = __w_pdfjs_require__(9).Symbol;

/***/ }),
/* 127 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var global = __w_pdfjs_require__(8);

var has = __w_pdfjs_require__(21);

var DESCRIPTORS = __w_pdfjs_require__(15);

var $export = __w_pdfjs_require__(7);

var redefine = __w_pdfjs_require__(20);

var META = __w_pdfjs_require__(107).KEY;

var $fails = __w_pdfjs_require__(16);

var shared = __w_pdfjs_require__(31);

var setToStringTag = __w_pdfjs_require__(59);

var uid = __w_pdfjs_require__(22);

var wks = __w_pdfjs_require__(30);

var wksExt = __w_pdfjs_require__(128);

var wksDefine = __w_pdfjs_require__(129);

var enumKeys = __w_pdfjs_require__(130);

var isArray = __w_pdfjs_require__(106);

var anObject = __w_pdfjs_require__(12);

var isObject = __w_pdfjs_require__(13);

var toIObject = __w_pdfjs_require__(42);

var toPrimitive = __w_pdfjs_require__(18);

var createDesc = __w_pdfjs_require__(19);

var _create = __w_pdfjs_require__(52);

var gOPNExt = __w_pdfjs_require__(131);

var $GOPD = __w_pdfjs_require__(113);

var $DP = __w_pdfjs_require__(11);

var $keys = __w_pdfjs_require__(54);

var gOPD = $GOPD.f;
var dP = $DP.f;
var gOPN = gOPNExt.f;
var $Symbol = global.Symbol;
var $JSON = global.JSON;

var _stringify = $JSON && $JSON.stringify;

var PROTOTYPE = 'prototype';
var HIDDEN = wks('_hidden');
var TO_PRIMITIVE = wks('toPrimitive');
var isEnum = {}.propertyIsEnumerable;
var SymbolRegistry = shared('symbol-registry');
var AllSymbols = shared('symbols');
var OPSymbols = shared('op-symbols');
var ObjectProto = Object[PROTOTYPE];
var USE_NATIVE = typeof $Symbol == 'function';
var QObject = global.QObject;
var setter = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;
var setSymbolDesc = DESCRIPTORS && $fails(function () {
  return _create(dP({}, 'a', {
    get: function get() {
      return dP(this, 'a', {
        value: 7
      }).a;
    }
  })).a != 7;
}) ? function (it, key, D) {
  var protoDesc = gOPD(ObjectProto, key);
  if (protoDesc) delete ObjectProto[key];
  dP(it, key, D);
  if (protoDesc && it !== ObjectProto) dP(ObjectProto, key, protoDesc);
} : dP;

var wrap = function wrap(tag) {
  var sym = AllSymbols[tag] = _create($Symbol[PROTOTYPE]);

  sym._k = tag;
  return sym;
};

var isSymbol = USE_NATIVE && _typeof($Symbol.iterator) == 'symbol' ? function (it) {
  return _typeof(it) == 'symbol';
} : function (it) {
  return it instanceof $Symbol;
};

var $defineProperty = function defineProperty(it, key, D) {
  if (it === ObjectProto) $defineProperty(OPSymbols, key, D);
  anObject(it);
  key = toPrimitive(key, true);
  anObject(D);

  if (has(AllSymbols, key)) {
    if (!D.enumerable) {
      if (!has(it, HIDDEN)) dP(it, HIDDEN, createDesc(1, {}));
      it[HIDDEN][key] = true;
    } else {
      if (has(it, HIDDEN) && it[HIDDEN][key]) it[HIDDEN][key] = false;
      D = _create(D, {
        enumerable: createDesc(0, false)
      });
    }

    return setSymbolDesc(it, key, D);
  }

  return dP(it, key, D);
};

var $defineProperties = function defineProperties(it, P) {
  anObject(it);
  var keys = enumKeys(P = toIObject(P));
  var i = 0;
  var l = keys.length;
  var key;

  while (l > i) {
    $defineProperty(it, key = keys[i++], P[key]);
  }

  return it;
};

var $create = function create(it, P) {
  return P === undefined ? _create(it) : $defineProperties(_create(it), P);
};

var $propertyIsEnumerable = function propertyIsEnumerable(key) {
  var E = isEnum.call(this, key = toPrimitive(key, true));
  if (this === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return false;
  return E || !has(this, key) || !has(AllSymbols, key) || has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
};

var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key) {
  it = toIObject(it);
  key = toPrimitive(key, true);
  if (it === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return;
  var D = gOPD(it, key);
  if (D && has(AllSymbols, key) && !(has(it, HIDDEN) && it[HIDDEN][key])) D.enumerable = true;
  return D;
};

var $getOwnPropertyNames = function getOwnPropertyNames(it) {
  var names = gOPN(toIObject(it));
  var result = [];
  var i = 0;
  var key;

  while (names.length > i) {
    if (!has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META) result.push(key);
  }

  return result;
};

var $getOwnPropertySymbols = function getOwnPropertySymbols(it) {
  var IS_OP = it === ObjectProto;
  var names = gOPN(IS_OP ? OPSymbols : toIObject(it));
  var result = [];
  var i = 0;
  var key;

  while (names.length > i) {
    if (has(AllSymbols, key = names[i++]) && (IS_OP ? has(ObjectProto, key) : true)) result.push(AllSymbols[key]);
  }

  return result;
};

if (!USE_NATIVE) {
  $Symbol = function _Symbol() {
    if (this instanceof $Symbol) throw TypeError('Symbol is not a constructor!');
    var tag = uid(arguments.length > 0 ? arguments[0] : undefined);

    var $set = function $set(value) {
      if (this === ObjectProto) $set.call(OPSymbols, value);
      if (has(this, HIDDEN) && has(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
      setSymbolDesc(this, tag, createDesc(1, value));
    };

    if (DESCRIPTORS && setter) setSymbolDesc(ObjectProto, tag, {
      configurable: true,
      set: $set
    });
    return wrap(tag);
  };

  redefine($Symbol[PROTOTYPE], 'toString', function toString() {
    return this._k;
  });
  $GOPD.f = $getOwnPropertyDescriptor;
  $DP.f = $defineProperty;
  __w_pdfjs_require__(132).f = gOPNExt.f = $getOwnPropertyNames;
  __w_pdfjs_require__(73).f = $propertyIsEnumerable;
  __w_pdfjs_require__(72).f = $getOwnPropertySymbols;

  if (DESCRIPTORS && !__w_pdfjs_require__(32)) {
    redefine(ObjectProto, 'propertyIsEnumerable', $propertyIsEnumerable, true);
  }

  wksExt.f = function (name) {
    return wrap(wks(name));
  };
}

$export($export.G + $export.W + $export.F * !USE_NATIVE, {
  Symbol: $Symbol
});

for (var es6Symbols = 'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'.split(','), j = 0; es6Symbols.length > j;) {
  wks(es6Symbols[j++]);
}

for (var wellKnownSymbols = $keys(wks.store), k = 0; wellKnownSymbols.length > k;) {
  wksDefine(wellKnownSymbols[k++]);
}

$export($export.S + $export.F * !USE_NATIVE, 'Symbol', {
  'for': function _for(key) {
    return has(SymbolRegistry, key += '') ? SymbolRegistry[key] : SymbolRegistry[key] = $Symbol(key);
  },
  keyFor: function keyFor(sym) {
    if (!isSymbol(sym)) throw TypeError(sym + ' is not a symbol!');

    for (var key in SymbolRegistry) {
      if (SymbolRegistry[key] === sym) return key;
    }
  },
  useSetter: function useSetter() {
    setter = true;
  },
  useSimple: function useSimple() {
    setter = false;
  }
});
$export($export.S + $export.F * !USE_NATIVE, 'Object', {
  create: $create,
  defineProperty: $defineProperty,
  defineProperties: $defineProperties,
  getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
  getOwnPropertyNames: $getOwnPropertyNames,
  getOwnPropertySymbols: $getOwnPropertySymbols
});
$JSON && $export($export.S + $export.F * (!USE_NATIVE || $fails(function () {
  var S = $Symbol();
  return _stringify([S]) != '[null]' || _stringify({
    a: S
  }) != '{}' || _stringify(Object(S)) != '{}';
})), 'JSON', {
  stringify: function stringify(it) {
    var args = [it];
    var i = 1;
    var replacer, $replacer;

    while (arguments.length > i) {
      args.push(arguments[i++]);
    }

    $replacer = replacer = args[1];
    if (!isObject(replacer) && it === undefined || isSymbol(it)) return;
    if (!isArray(replacer)) replacer = function replacer(key, value) {
      if (typeof $replacer == 'function') value = $replacer.call(this, key, value);
      if (!isSymbol(value)) return value;
    };
    args[1] = replacer;
    return _stringify.apply($JSON, args);
  }
});
$Symbol[PROTOTYPE][TO_PRIMITIVE] || __w_pdfjs_require__(10)($Symbol[PROTOTYPE], TO_PRIMITIVE, $Symbol[PROTOTYPE].valueOf);
setToStringTag($Symbol, 'Symbol');
setToStringTag(Math, 'Math', true);
setToStringTag(global.JSON, 'JSON', true);

/***/ }),
/* 128 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


exports.f = __w_pdfjs_require__(30);

/***/ }),
/* 129 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(8);

var core = __w_pdfjs_require__(9);

var LIBRARY = __w_pdfjs_require__(32);

var wksExt = __w_pdfjs_require__(128);

var defineProperty = __w_pdfjs_require__(11).f;

module.exports = function (name) {
  var $Symbol = core.Symbol || (core.Symbol = LIBRARY ? {} : global.Symbol || {});
  if (name.charAt(0) != '_' && !(name in $Symbol)) defineProperty($Symbol, name, {
    value: wksExt.f(name)
  });
};

/***/ }),
/* 130 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var getKeys = __w_pdfjs_require__(54);

var gOPS = __w_pdfjs_require__(72);

var pIE = __w_pdfjs_require__(73);

module.exports = function (it) {
  var result = getKeys(it);
  var getSymbols = gOPS.f;

  if (getSymbols) {
    var symbols = getSymbols(it);
    var isEnum = pIE.f;
    var i = 0;
    var key;

    while (symbols.length > i) {
      if (isEnum.call(it, key = symbols[i++])) result.push(key);
    }
  }

  return result;
};

/***/ }),
/* 131 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var toIObject = __w_pdfjs_require__(42);

var gOPN = __w_pdfjs_require__(132).f;

var toString = {}.toString;
var windowNames = (typeof window === "undefined" ? "undefined" : _typeof(window)) == 'object' && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];

var getWindowNames = function getWindowNames(it) {
  try {
    return gOPN(it);
  } catch (e) {
    return windowNames.slice();
  }
};

module.exports.f = function getOwnPropertyNames(it) {
  return windowNames && toString.call(it) == '[object Window]' ? getWindowNames(it) : gOPN(toIObject(it));
};

/***/ }),
/* 132 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $keys = __w_pdfjs_require__(55);

var hiddenKeys = __w_pdfjs_require__(57).concat('length', 'prototype');

exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return $keys(O, hiddenKeys);
};

/***/ }),
/* 133 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(134);

module.exports = __w_pdfjs_require__(9).String.padStart;

/***/ }),
/* 134 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var $pad = __w_pdfjs_require__(135);

var userAgent = __w_pdfjs_require__(95);

$export($export.P + $export.F * /Version\/10\.\d+(\.\d+)? Safari\//.test(userAgent), 'String', {
  padStart: function padStart(maxLength) {
    return $pad(this, maxLength, arguments.length > 1 ? arguments[1] : undefined, true);
  }
});

/***/ }),
/* 135 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toLength = __w_pdfjs_require__(25);

var repeat = __w_pdfjs_require__(136);

var defined = __w_pdfjs_require__(33);

module.exports = function (that, maxLength, fillString, left) {
  var S = String(defined(that));
  var stringLength = S.length;
  var fillStr = fillString === undefined ? ' ' : String(fillString);
  var intMaxLength = toLength(maxLength);
  if (intMaxLength <= stringLength || fillStr == '') return S;
  var fillLen = intMaxLength - stringLength;
  var stringFiller = repeat.call(fillStr, Math.ceil(fillLen / fillStr.length));
  if (stringFiller.length > fillLen) stringFiller = stringFiller.slice(0, fillLen);
  return left ? stringFiller + S : S + stringFiller;
};

/***/ }),
/* 136 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(26);

var defined = __w_pdfjs_require__(33);

module.exports = function repeat(count) {
  var str = String(defined(this));
  var res = '';
  var n = toInteger(count);
  if (n < 0 || n == Infinity) throw RangeError("Count can't be negative");

  for (; n > 0; (n >>>= 1) && (str += str)) {
    if (n & 1) res += str;
  }

  return res;
};

/***/ }),
/* 137 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(138);

module.exports = __w_pdfjs_require__(9).String.padEnd;

/***/ }),
/* 138 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var $pad = __w_pdfjs_require__(135);

var userAgent = __w_pdfjs_require__(95);

$export($export.P + $export.F * /Version\/10\.\d+(\.\d+)? Safari\//.test(userAgent), 'String', {
  padEnd: function padEnd(maxLength) {
    return $pad(this, maxLength, arguments.length > 1 ? arguments[1] : undefined, false);
  }
});

/***/ }),
/* 139 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(140);

module.exports = __w_pdfjs_require__(9).Object.values;

/***/ }),
/* 140 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(7);

var $values = __w_pdfjs_require__(141)(false);

$export($export.S, 'Object', {
  values: function values(it) {
    return $values(it);
  }
});

/***/ }),
/* 141 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var getKeys = __w_pdfjs_require__(54);

var toIObject = __w_pdfjs_require__(42);

var isEnum = __w_pdfjs_require__(73).f;

module.exports = function (isEntries) {
  return function (it) {
    var O = toIObject(it);
    var keys = getKeys(O);
    var length = keys.length;
    var i = 0;
    var result = [];
    var key;

    while (length > i) {
      if (isEnum.call(O, key = keys[i++])) {
        result.push(isEntries ? [key, O[key]] : O[key]);
      }
    }

    return result;
  };
};

/***/ }),
/* 142 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


{
  var isReadableStreamSupported = false;

  if (typeof ReadableStream !== 'undefined') {
    try {
      new ReadableStream({
        start: function start(controller) {
          controller.close();
        }
      });
      isReadableStreamSupported = true;
    } catch (e) {}
  }

  if (isReadableStreamSupported) {
    exports.ReadableStream = ReadableStream;
  } else {
    exports.ReadableStream = __w_pdfjs_require__(143).ReadableStream;
  }
}

/***/ }),
/* 143 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

(function (e, a) {
  for (var i in a) {
    e[i] = a[i];
  }
})(exports, function (modules) {
  var installedModules = {};

  function __w_pdfjs_require__(moduleId) {
    if (installedModules[moduleId]) return installedModules[moduleId].exports;
    var module = installedModules[moduleId] = {
      i: moduleId,
      l: false,
      exports: {}
    };
    modules[moduleId].call(module.exports, module, module.exports, __w_pdfjs_require__);
    module.l = true;
    return module.exports;
  }

  __w_pdfjs_require__.m = modules;
  __w_pdfjs_require__.c = installedModules;

  __w_pdfjs_require__.i = function (value) {
    return value;
  };

  __w_pdfjs_require__.d = function (exports, name, getter) {
    if (!__w_pdfjs_require__.o(exports, name)) {
      Object.defineProperty(exports, name, {
        configurable: false,
        enumerable: true,
        get: getter
      });
    }
  };

  __w_pdfjs_require__.n = function (module) {
    var getter = module && module.__esModule ? function getDefault() {
      return module['default'];
    } : function getModuleExports() {
      return module;
    };

    __w_pdfjs_require__.d(getter, 'a', getter);

    return getter;
  };

  __w_pdfjs_require__.o = function (object, property) {
    return Object.prototype.hasOwnProperty.call(object, property);
  };

  __w_pdfjs_require__.p = "";
  return __w_pdfjs_require__(__w_pdfjs_require__.s = 7);
}([function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _typeof = typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol" ? function (obj) {
    return _typeof2(obj);
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
  };

  var _require = __w_pdfjs_require__(1),
      assert = _require.assert;

  function IsPropertyKey(argument) {
    return typeof argument === 'string' || (typeof argument === 'undefined' ? 'undefined' : _typeof(argument)) === 'symbol';
  }

  exports.typeIsObject = function (x) {
    return (typeof x === 'undefined' ? 'undefined' : _typeof(x)) === 'object' && x !== null || typeof x === 'function';
  };

  exports.createDataProperty = function (o, p, v) {
    assert(exports.typeIsObject(o));
    Object.defineProperty(o, p, {
      value: v,
      writable: true,
      enumerable: true,
      configurable: true
    });
  };

  exports.createArrayFromList = function (elements) {
    return elements.slice();
  };

  exports.ArrayBufferCopy = function (dest, destOffset, src, srcOffset, n) {
    new Uint8Array(dest).set(new Uint8Array(src, srcOffset, n), destOffset);
  };

  exports.CreateIterResultObject = function (value, done) {
    assert(typeof done === 'boolean');
    var obj = {};
    Object.defineProperty(obj, 'value', {
      value: value,
      enumerable: true,
      writable: true,
      configurable: true
    });
    Object.defineProperty(obj, 'done', {
      value: done,
      enumerable: true,
      writable: true,
      configurable: true
    });
    return obj;
  };

  exports.IsFiniteNonNegativeNumber = function (v) {
    if (Number.isNaN(v)) {
      return false;
    }

    if (v === Infinity) {
      return false;
    }

    if (v < 0) {
      return false;
    }

    return true;
  };

  function Call(F, V, args) {
    if (typeof F !== 'function') {
      throw new TypeError('Argument is not a function');
    }

    return Function.prototype.apply.call(F, V, args);
  }

  exports.InvokeOrNoop = function (O, P, args) {
    assert(O !== undefined);
    assert(IsPropertyKey(P));
    assert(Array.isArray(args));
    var method = O[P];

    if (method === undefined) {
      return undefined;
    }

    return Call(method, O, args);
  };

  exports.PromiseInvokeOrNoop = function (O, P, args) {
    assert(O !== undefined);
    assert(IsPropertyKey(P));
    assert(Array.isArray(args));

    try {
      return Promise.resolve(exports.InvokeOrNoop(O, P, args));
    } catch (returnValueE) {
      return Promise.reject(returnValueE);
    }
  };

  exports.PromiseInvokeOrPerformFallback = function (O, P, args, F, argsF) {
    assert(O !== undefined);
    assert(IsPropertyKey(P));
    assert(Array.isArray(args));
    assert(Array.isArray(argsF));
    var method = void 0;

    try {
      method = O[P];
    } catch (methodE) {
      return Promise.reject(methodE);
    }

    if (method === undefined) {
      return F.apply(null, argsF);
    }

    try {
      return Promise.resolve(Call(method, O, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  exports.TransferArrayBuffer = function (O) {
    return O.slice();
  };

  exports.ValidateAndNormalizeHighWaterMark = function (highWaterMark) {
    highWaterMark = Number(highWaterMark);

    if (Number.isNaN(highWaterMark) || highWaterMark < 0) {
      throw new RangeError('highWaterMark property of a queuing strategy must be non-negative and non-NaN');
    }

    return highWaterMark;
  };

  exports.ValidateAndNormalizeQueuingStrategy = function (size, highWaterMark) {
    if (size !== undefined && typeof size !== 'function') {
      throw new TypeError('size property of a queuing strategy must be a function');
    }

    highWaterMark = exports.ValidateAndNormalizeHighWaterMark(highWaterMark);
    return {
      size: size,
      highWaterMark: highWaterMark
    };
  };
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  function rethrowAssertionErrorRejection(e) {
    if (e && e.constructor === AssertionError) {
      setTimeout(function () {
        throw e;
      }, 0);
    }
  }

  function AssertionError(message) {
    this.name = 'AssertionError';
    this.message = message || '';
    this.stack = new Error().stack;
  }

  AssertionError.prototype = Object.create(Error.prototype);
  AssertionError.prototype.constructor = AssertionError;

  function assert(value, message) {
    if (!value) {
      throw new AssertionError(message);
    }
  }

  module.exports = {
    rethrowAssertionErrorRejection: rethrowAssertionErrorRejection,
    AssertionError: AssertionError,
    assert: assert
  };
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _require = __w_pdfjs_require__(0),
      InvokeOrNoop = _require.InvokeOrNoop,
      PromiseInvokeOrNoop = _require.PromiseInvokeOrNoop,
      ValidateAndNormalizeQueuingStrategy = _require.ValidateAndNormalizeQueuingStrategy,
      typeIsObject = _require.typeIsObject;

  var _require2 = __w_pdfjs_require__(1),
      assert = _require2.assert,
      rethrowAssertionErrorRejection = _require2.rethrowAssertionErrorRejection;

  var _require3 = __w_pdfjs_require__(3),
      DequeueValue = _require3.DequeueValue,
      EnqueueValueWithSize = _require3.EnqueueValueWithSize,
      PeekQueueValue = _require3.PeekQueueValue,
      ResetQueue = _require3.ResetQueue;

  var WritableStream = function () {
    function WritableStream() {
      var underlyingSink = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          size = _ref.size,
          _ref$highWaterMark = _ref.highWaterMark,
          highWaterMark = _ref$highWaterMark === undefined ? 1 : _ref$highWaterMark;

      _classCallCheck(this, WritableStream);

      this._state = 'writable';
      this._storedError = undefined;
      this._writer = undefined;
      this._writableStreamController = undefined;
      this._writeRequests = [];
      this._inFlightWriteRequest = undefined;
      this._closeRequest = undefined;
      this._inFlightCloseRequest = undefined;
      this._pendingAbortRequest = undefined;
      this._backpressure = false;
      var type = underlyingSink.type;

      if (type !== undefined) {
        throw new RangeError('Invalid type is specified');
      }

      this._writableStreamController = new WritableStreamDefaultController(this, underlyingSink, size, highWaterMark);

      this._writableStreamController.__startSteps();
    }

    _createClass(WritableStream, [{
      key: 'abort',
      value: function abort(reason) {
        if (IsWritableStream(this) === false) {
          return Promise.reject(streamBrandCheckException('abort'));
        }

        if (IsWritableStreamLocked(this) === true) {
          return Promise.reject(new TypeError('Cannot abort a stream that already has a writer'));
        }

        return WritableStreamAbort(this, reason);
      }
    }, {
      key: 'getWriter',
      value: function getWriter() {
        if (IsWritableStream(this) === false) {
          throw streamBrandCheckException('getWriter');
        }

        return AcquireWritableStreamDefaultWriter(this);
      }
    }, {
      key: 'locked',
      get: function get() {
        if (IsWritableStream(this) === false) {
          throw streamBrandCheckException('locked');
        }

        return IsWritableStreamLocked(this);
      }
    }]);

    return WritableStream;
  }();

  module.exports = {
    AcquireWritableStreamDefaultWriter: AcquireWritableStreamDefaultWriter,
    IsWritableStream: IsWritableStream,
    IsWritableStreamLocked: IsWritableStreamLocked,
    WritableStream: WritableStream,
    WritableStreamAbort: WritableStreamAbort,
    WritableStreamDefaultControllerError: WritableStreamDefaultControllerError,
    WritableStreamDefaultWriterCloseWithErrorPropagation: WritableStreamDefaultWriterCloseWithErrorPropagation,
    WritableStreamDefaultWriterRelease: WritableStreamDefaultWriterRelease,
    WritableStreamDefaultWriterWrite: WritableStreamDefaultWriterWrite,
    WritableStreamCloseQueuedOrInFlight: WritableStreamCloseQueuedOrInFlight
  };

  function AcquireWritableStreamDefaultWriter(stream) {
    return new WritableStreamDefaultWriter(stream);
  }

  function IsWritableStream(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_writableStreamController')) {
      return false;
    }

    return true;
  }

  function IsWritableStreamLocked(stream) {
    assert(IsWritableStream(stream) === true, 'IsWritableStreamLocked should only be used on known writable streams');

    if (stream._writer === undefined) {
      return false;
    }

    return true;
  }

  function WritableStreamAbort(stream, reason) {
    var state = stream._state;

    if (state === 'closed') {
      return Promise.resolve(undefined);
    }

    if (state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    var error = new TypeError('Requested to abort');

    if (stream._pendingAbortRequest !== undefined) {
      return Promise.reject(error);
    }

    assert(state === 'writable' || state === 'erroring', 'state must be writable or erroring');
    var wasAlreadyErroring = false;

    if (state === 'erroring') {
      wasAlreadyErroring = true;
      reason = undefined;
    }

    var promise = new Promise(function (resolve, reject) {
      stream._pendingAbortRequest = {
        _resolve: resolve,
        _reject: reject,
        _reason: reason,
        _wasAlreadyErroring: wasAlreadyErroring
      };
    });

    if (wasAlreadyErroring === false) {
      WritableStreamStartErroring(stream, error);
    }

    return promise;
  }

  function WritableStreamAddWriteRequest(stream) {
    assert(IsWritableStreamLocked(stream) === true);
    assert(stream._state === 'writable');
    var promise = new Promise(function (resolve, reject) {
      var writeRequest = {
        _resolve: resolve,
        _reject: reject
      };

      stream._writeRequests.push(writeRequest);
    });
    return promise;
  }

  function WritableStreamDealWithRejection(stream, error) {
    var state = stream._state;

    if (state === 'writable') {
      WritableStreamStartErroring(stream, error);
      return;
    }

    assert(state === 'erroring');
    WritableStreamFinishErroring(stream);
  }

  function WritableStreamStartErroring(stream, reason) {
    assert(stream._storedError === undefined, 'stream._storedError === undefined');
    assert(stream._state === 'writable', 'state must be writable');
    var controller = stream._writableStreamController;
    assert(controller !== undefined, 'controller must not be undefined');
    stream._state = 'erroring';
    stream._storedError = reason;
    var writer = stream._writer;

    if (writer !== undefined) {
      WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, reason);
    }

    if (WritableStreamHasOperationMarkedInFlight(stream) === false && controller._started === true) {
      WritableStreamFinishErroring(stream);
    }
  }

  function WritableStreamFinishErroring(stream) {
    assert(stream._state === 'erroring', 'stream._state === erroring');
    assert(WritableStreamHasOperationMarkedInFlight(stream) === false, 'WritableStreamHasOperationMarkedInFlight(stream) === false');
    stream._state = 'errored';

    stream._writableStreamController.__errorSteps();

    var storedError = stream._storedError;

    for (var i = 0; i < stream._writeRequests.length; i++) {
      var writeRequest = stream._writeRequests[i];

      writeRequest._reject(storedError);
    }

    stream._writeRequests = [];

    if (stream._pendingAbortRequest === undefined) {
      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
      return;
    }

    var abortRequest = stream._pendingAbortRequest;
    stream._pendingAbortRequest = undefined;

    if (abortRequest._wasAlreadyErroring === true) {
      abortRequest._reject(storedError);

      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
      return;
    }

    var promise = stream._writableStreamController.__abortSteps(abortRequest._reason);

    promise.then(function () {
      abortRequest._resolve();

      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
    }, function (reason) {
      abortRequest._reject(reason);

      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
    });
  }

  function WritableStreamFinishInFlightWrite(stream) {
    assert(stream._inFlightWriteRequest !== undefined);

    stream._inFlightWriteRequest._resolve(undefined);

    stream._inFlightWriteRequest = undefined;
  }

  function WritableStreamFinishInFlightWriteWithError(stream, error) {
    assert(stream._inFlightWriteRequest !== undefined);

    stream._inFlightWriteRequest._reject(error);

    stream._inFlightWriteRequest = undefined;
    assert(stream._state === 'writable' || stream._state === 'erroring');
    WritableStreamDealWithRejection(stream, error);
  }

  function WritableStreamFinishInFlightClose(stream) {
    assert(stream._inFlightCloseRequest !== undefined);

    stream._inFlightCloseRequest._resolve(undefined);

    stream._inFlightCloseRequest = undefined;
    var state = stream._state;
    assert(state === 'writable' || state === 'erroring');

    if (state === 'erroring') {
      stream._storedError = undefined;

      if (stream._pendingAbortRequest !== undefined) {
        stream._pendingAbortRequest._resolve();

        stream._pendingAbortRequest = undefined;
      }
    }

    stream._state = 'closed';
    var writer = stream._writer;

    if (writer !== undefined) {
      defaultWriterClosedPromiseResolve(writer);
    }

    assert(stream._pendingAbortRequest === undefined, 'stream._pendingAbortRequest === undefined');
    assert(stream._storedError === undefined, 'stream._storedError === undefined');
  }

  function WritableStreamFinishInFlightCloseWithError(stream, error) {
    assert(stream._inFlightCloseRequest !== undefined);

    stream._inFlightCloseRequest._reject(error);

    stream._inFlightCloseRequest = undefined;
    assert(stream._state === 'writable' || stream._state === 'erroring');

    if (stream._pendingAbortRequest !== undefined) {
      stream._pendingAbortRequest._reject(error);

      stream._pendingAbortRequest = undefined;
    }

    WritableStreamDealWithRejection(stream, error);
  }

  function WritableStreamCloseQueuedOrInFlight(stream) {
    if (stream._closeRequest === undefined && stream._inFlightCloseRequest === undefined) {
      return false;
    }

    return true;
  }

  function WritableStreamHasOperationMarkedInFlight(stream) {
    if (stream._inFlightWriteRequest === undefined && stream._inFlightCloseRequest === undefined) {
      return false;
    }

    return true;
  }

  function WritableStreamMarkCloseRequestInFlight(stream) {
    assert(stream._inFlightCloseRequest === undefined);
    assert(stream._closeRequest !== undefined);
    stream._inFlightCloseRequest = stream._closeRequest;
    stream._closeRequest = undefined;
  }

  function WritableStreamMarkFirstWriteRequestInFlight(stream) {
    assert(stream._inFlightWriteRequest === undefined, 'there must be no pending write request');
    assert(stream._writeRequests.length !== 0, 'writeRequests must not be empty');
    stream._inFlightWriteRequest = stream._writeRequests.shift();
  }

  function WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream) {
    assert(stream._state === 'errored', '_stream_.[[state]] is `"errored"`');

    if (stream._closeRequest !== undefined) {
      assert(stream._inFlightCloseRequest === undefined);

      stream._closeRequest._reject(stream._storedError);

      stream._closeRequest = undefined;
    }

    var writer = stream._writer;

    if (writer !== undefined) {
      defaultWriterClosedPromiseReject(writer, stream._storedError);

      writer._closedPromise.catch(function () {});
    }
  }

  function WritableStreamUpdateBackpressure(stream, backpressure) {
    assert(stream._state === 'writable');
    assert(WritableStreamCloseQueuedOrInFlight(stream) === false);
    var writer = stream._writer;

    if (writer !== undefined && backpressure !== stream._backpressure) {
      if (backpressure === true) {
        defaultWriterReadyPromiseReset(writer);
      } else {
        assert(backpressure === false);
        defaultWriterReadyPromiseResolve(writer);
      }
    }

    stream._backpressure = backpressure;
  }

  var WritableStreamDefaultWriter = function () {
    function WritableStreamDefaultWriter(stream) {
      _classCallCheck(this, WritableStreamDefaultWriter);

      if (IsWritableStream(stream) === false) {
        throw new TypeError('WritableStreamDefaultWriter can only be constructed with a WritableStream instance');
      }

      if (IsWritableStreamLocked(stream) === true) {
        throw new TypeError('This stream has already been locked for exclusive writing by another writer');
      }

      this._ownerWritableStream = stream;
      stream._writer = this;
      var state = stream._state;

      if (state === 'writable') {
        if (WritableStreamCloseQueuedOrInFlight(stream) === false && stream._backpressure === true) {
          defaultWriterReadyPromiseInitialize(this);
        } else {
          defaultWriterReadyPromiseInitializeAsResolved(this);
        }

        defaultWriterClosedPromiseInitialize(this);
      } else if (state === 'erroring') {
        defaultWriterReadyPromiseInitializeAsRejected(this, stream._storedError);

        this._readyPromise.catch(function () {});

        defaultWriterClosedPromiseInitialize(this);
      } else if (state === 'closed') {
        defaultWriterReadyPromiseInitializeAsResolved(this);
        defaultWriterClosedPromiseInitializeAsResolved(this);
      } else {
        assert(state === 'errored', 'state must be errored');
        var storedError = stream._storedError;
        defaultWriterReadyPromiseInitializeAsRejected(this, storedError);

        this._readyPromise.catch(function () {});

        defaultWriterClosedPromiseInitializeAsRejected(this, storedError);

        this._closedPromise.catch(function () {});
      }
    }

    _createClass(WritableStreamDefaultWriter, [{
      key: 'abort',
      value: function abort(reason) {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('abort'));
        }

        if (this._ownerWritableStream === undefined) {
          return Promise.reject(defaultWriterLockException('abort'));
        }

        return WritableStreamDefaultWriterAbort(this, reason);
      }
    }, {
      key: 'close',
      value: function close() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('close'));
        }

        var stream = this._ownerWritableStream;

        if (stream === undefined) {
          return Promise.reject(defaultWriterLockException('close'));
        }

        if (WritableStreamCloseQueuedOrInFlight(stream) === true) {
          return Promise.reject(new TypeError('cannot close an already-closing stream'));
        }

        return WritableStreamDefaultWriterClose(this);
      }
    }, {
      key: 'releaseLock',
      value: function releaseLock() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          throw defaultWriterBrandCheckException('releaseLock');
        }

        var stream = this._ownerWritableStream;

        if (stream === undefined) {
          return;
        }

        assert(stream._writer !== undefined);
        WritableStreamDefaultWriterRelease(this);
      }
    }, {
      key: 'write',
      value: function write(chunk) {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('write'));
        }

        if (this._ownerWritableStream === undefined) {
          return Promise.reject(defaultWriterLockException('write to'));
        }

        return WritableStreamDefaultWriterWrite(this, chunk);
      }
    }, {
      key: 'closed',
      get: function get() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('closed'));
        }

        return this._closedPromise;
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          throw defaultWriterBrandCheckException('desiredSize');
        }

        if (this._ownerWritableStream === undefined) {
          throw defaultWriterLockException('desiredSize');
        }

        return WritableStreamDefaultWriterGetDesiredSize(this);
      }
    }, {
      key: 'ready',
      get: function get() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('ready'));
        }

        return this._readyPromise;
      }
    }]);

    return WritableStreamDefaultWriter;
  }();

  function IsWritableStreamDefaultWriter(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_ownerWritableStream')) {
      return false;
    }

    return true;
  }

  function WritableStreamDefaultWriterAbort(writer, reason) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    return WritableStreamAbort(stream, reason);
  }

  function WritableStreamDefaultWriterClose(writer) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    var state = stream._state;

    if (state === 'closed' || state === 'errored') {
      return Promise.reject(new TypeError('The stream (in ' + state + ' state) is not in the writable state and cannot be closed'));
    }

    assert(state === 'writable' || state === 'erroring');
    assert(WritableStreamCloseQueuedOrInFlight(stream) === false);
    var promise = new Promise(function (resolve, reject) {
      var closeRequest = {
        _resolve: resolve,
        _reject: reject
      };
      stream._closeRequest = closeRequest;
    });

    if (stream._backpressure === true && state === 'writable') {
      defaultWriterReadyPromiseResolve(writer);
    }

    WritableStreamDefaultControllerClose(stream._writableStreamController);
    return promise;
  }

  function WritableStreamDefaultWriterCloseWithErrorPropagation(writer) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    var state = stream._state;

    if (WritableStreamCloseQueuedOrInFlight(stream) === true || state === 'closed') {
      return Promise.resolve();
    }

    if (state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    assert(state === 'writable' || state === 'erroring');
    return WritableStreamDefaultWriterClose(writer);
  }

  function WritableStreamDefaultWriterEnsureClosedPromiseRejected(writer, error) {
    if (writer._closedPromiseState === 'pending') {
      defaultWriterClosedPromiseReject(writer, error);
    } else {
      defaultWriterClosedPromiseResetToRejected(writer, error);
    }

    writer._closedPromise.catch(function () {});
  }

  function WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, error) {
    if (writer._readyPromiseState === 'pending') {
      defaultWriterReadyPromiseReject(writer, error);
    } else {
      defaultWriterReadyPromiseResetToRejected(writer, error);
    }

    writer._readyPromise.catch(function () {});
  }

  function WritableStreamDefaultWriterGetDesiredSize(writer) {
    var stream = writer._ownerWritableStream;
    var state = stream._state;

    if (state === 'errored' || state === 'erroring') {
      return null;
    }

    if (state === 'closed') {
      return 0;
    }

    return WritableStreamDefaultControllerGetDesiredSize(stream._writableStreamController);
  }

  function WritableStreamDefaultWriterRelease(writer) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    assert(stream._writer === writer);
    var releasedError = new TypeError('Writer was released and can no longer be used to monitor the stream\'s closedness');
    WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, releasedError);
    WritableStreamDefaultWriterEnsureClosedPromiseRejected(writer, releasedError);
    stream._writer = undefined;
    writer._ownerWritableStream = undefined;
  }

  function WritableStreamDefaultWriterWrite(writer, chunk) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    var controller = stream._writableStreamController;
    var chunkSize = WritableStreamDefaultControllerGetChunkSize(controller, chunk);

    if (stream !== writer._ownerWritableStream) {
      return Promise.reject(defaultWriterLockException('write to'));
    }

    var state = stream._state;

    if (state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    if (WritableStreamCloseQueuedOrInFlight(stream) === true || state === 'closed') {
      return Promise.reject(new TypeError('The stream is closing or closed and cannot be written to'));
    }

    if (state === 'erroring') {
      return Promise.reject(stream._storedError);
    }

    assert(state === 'writable');
    var promise = WritableStreamAddWriteRequest(stream);
    WritableStreamDefaultControllerWrite(controller, chunk, chunkSize);
    return promise;
  }

  var WritableStreamDefaultController = function () {
    function WritableStreamDefaultController(stream, underlyingSink, size, highWaterMark) {
      _classCallCheck(this, WritableStreamDefaultController);

      if (IsWritableStream(stream) === false) {
        throw new TypeError('WritableStreamDefaultController can only be constructed with a WritableStream instance');
      }

      if (stream._writableStreamController !== undefined) {
        throw new TypeError('WritableStreamDefaultController instances can only be created by the WritableStream constructor');
      }

      this._controlledWritableStream = stream;
      this._underlyingSink = underlyingSink;
      this._queue = undefined;
      this._queueTotalSize = undefined;
      ResetQueue(this);
      this._started = false;
      var normalizedStrategy = ValidateAndNormalizeQueuingStrategy(size, highWaterMark);
      this._strategySize = normalizedStrategy.size;
      this._strategyHWM = normalizedStrategy.highWaterMark;
      var backpressure = WritableStreamDefaultControllerGetBackpressure(this);
      WritableStreamUpdateBackpressure(stream, backpressure);
    }

    _createClass(WritableStreamDefaultController, [{
      key: 'error',
      value: function error(e) {
        if (IsWritableStreamDefaultController(this) === false) {
          throw new TypeError('WritableStreamDefaultController.prototype.error can only be used on a WritableStreamDefaultController');
        }

        var state = this._controlledWritableStream._state;

        if (state !== 'writable') {
          return;
        }

        WritableStreamDefaultControllerError(this, e);
      }
    }, {
      key: '__abortSteps',
      value: function __abortSteps(reason) {
        return PromiseInvokeOrNoop(this._underlyingSink, 'abort', [reason]);
      }
    }, {
      key: '__errorSteps',
      value: function __errorSteps() {
        ResetQueue(this);
      }
    }, {
      key: '__startSteps',
      value: function __startSteps() {
        var _this = this;

        var startResult = InvokeOrNoop(this._underlyingSink, 'start', [this]);
        var stream = this._controlledWritableStream;
        Promise.resolve(startResult).then(function () {
          assert(stream._state === 'writable' || stream._state === 'erroring');
          _this._started = true;
          WritableStreamDefaultControllerAdvanceQueueIfNeeded(_this);
        }, function (r) {
          assert(stream._state === 'writable' || stream._state === 'erroring');
          _this._started = true;
          WritableStreamDealWithRejection(stream, r);
        }).catch(rethrowAssertionErrorRejection);
      }
    }]);

    return WritableStreamDefaultController;
  }();

  function WritableStreamDefaultControllerClose(controller) {
    EnqueueValueWithSize(controller, 'close', 0);
    WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
  }

  function WritableStreamDefaultControllerGetChunkSize(controller, chunk) {
    var strategySize = controller._strategySize;

    if (strategySize === undefined) {
      return 1;
    }

    try {
      return strategySize(chunk);
    } catch (chunkSizeE) {
      WritableStreamDefaultControllerErrorIfNeeded(controller, chunkSizeE);
      return 1;
    }
  }

  function WritableStreamDefaultControllerGetDesiredSize(controller) {
    return controller._strategyHWM - controller._queueTotalSize;
  }

  function WritableStreamDefaultControllerWrite(controller, chunk, chunkSize) {
    var writeRecord = {
      chunk: chunk
    };

    try {
      EnqueueValueWithSize(controller, writeRecord, chunkSize);
    } catch (enqueueE) {
      WritableStreamDefaultControllerErrorIfNeeded(controller, enqueueE);
      return;
    }

    var stream = controller._controlledWritableStream;

    if (WritableStreamCloseQueuedOrInFlight(stream) === false && stream._state === 'writable') {
      var backpressure = WritableStreamDefaultControllerGetBackpressure(controller);
      WritableStreamUpdateBackpressure(stream, backpressure);
    }

    WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
  }

  function IsWritableStreamDefaultController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_underlyingSink')) {
      return false;
    }

    return true;
  }

  function WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller) {
    var stream = controller._controlledWritableStream;

    if (controller._started === false) {
      return;
    }

    if (stream._inFlightWriteRequest !== undefined) {
      return;
    }

    var state = stream._state;

    if (state === 'closed' || state === 'errored') {
      return;
    }

    if (state === 'erroring') {
      WritableStreamFinishErroring(stream);
      return;
    }

    if (controller._queue.length === 0) {
      return;
    }

    var writeRecord = PeekQueueValue(controller);

    if (writeRecord === 'close') {
      WritableStreamDefaultControllerProcessClose(controller);
    } else {
      WritableStreamDefaultControllerProcessWrite(controller, writeRecord.chunk);
    }
  }

  function WritableStreamDefaultControllerErrorIfNeeded(controller, error) {
    if (controller._controlledWritableStream._state === 'writable') {
      WritableStreamDefaultControllerError(controller, error);
    }
  }

  function WritableStreamDefaultControllerProcessClose(controller) {
    var stream = controller._controlledWritableStream;
    WritableStreamMarkCloseRequestInFlight(stream);
    DequeueValue(controller);
    assert(controller._queue.length === 0, 'queue must be empty once the final write record is dequeued');
    var sinkClosePromise = PromiseInvokeOrNoop(controller._underlyingSink, 'close', []);
    sinkClosePromise.then(function () {
      WritableStreamFinishInFlightClose(stream);
    }, function (reason) {
      WritableStreamFinishInFlightCloseWithError(stream, reason);
    }).catch(rethrowAssertionErrorRejection);
  }

  function WritableStreamDefaultControllerProcessWrite(controller, chunk) {
    var stream = controller._controlledWritableStream;
    WritableStreamMarkFirstWriteRequestInFlight(stream);
    var sinkWritePromise = PromiseInvokeOrNoop(controller._underlyingSink, 'write', [chunk, controller]);
    sinkWritePromise.then(function () {
      WritableStreamFinishInFlightWrite(stream);
      var state = stream._state;
      assert(state === 'writable' || state === 'erroring');
      DequeueValue(controller);

      if (WritableStreamCloseQueuedOrInFlight(stream) === false && state === 'writable') {
        var backpressure = WritableStreamDefaultControllerGetBackpressure(controller);
        WritableStreamUpdateBackpressure(stream, backpressure);
      }

      WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
    }, function (reason) {
      WritableStreamFinishInFlightWriteWithError(stream, reason);
    }).catch(rethrowAssertionErrorRejection);
  }

  function WritableStreamDefaultControllerGetBackpressure(controller) {
    var desiredSize = WritableStreamDefaultControllerGetDesiredSize(controller);
    return desiredSize <= 0;
  }

  function WritableStreamDefaultControllerError(controller, error) {
    var stream = controller._controlledWritableStream;
    assert(stream._state === 'writable');
    WritableStreamStartErroring(stream, error);
  }

  function streamBrandCheckException(name) {
    return new TypeError('WritableStream.prototype.' + name + ' can only be used on a WritableStream');
  }

  function defaultWriterBrandCheckException(name) {
    return new TypeError('WritableStreamDefaultWriter.prototype.' + name + ' can only be used on a WritableStreamDefaultWriter');
  }

  function defaultWriterLockException(name) {
    return new TypeError('Cannot ' + name + ' a stream using a released writer');
  }

  function defaultWriterClosedPromiseInitialize(writer) {
    writer._closedPromise = new Promise(function (resolve, reject) {
      writer._closedPromise_resolve = resolve;
      writer._closedPromise_reject = reject;
      writer._closedPromiseState = 'pending';
    });
  }

  function defaultWriterClosedPromiseInitializeAsRejected(writer, reason) {
    writer._closedPromise = Promise.reject(reason);
    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'rejected';
  }

  function defaultWriterClosedPromiseInitializeAsResolved(writer) {
    writer._closedPromise = Promise.resolve(undefined);
    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'resolved';
  }

  function defaultWriterClosedPromiseReject(writer, reason) {
    assert(writer._closedPromise_resolve !== undefined, 'writer._closedPromise_resolve !== undefined');
    assert(writer._closedPromise_reject !== undefined, 'writer._closedPromise_reject !== undefined');
    assert(writer._closedPromiseState === 'pending', 'writer._closedPromiseState is pending');

    writer._closedPromise_reject(reason);

    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'rejected';
  }

  function defaultWriterClosedPromiseResetToRejected(writer, reason) {
    assert(writer._closedPromise_resolve === undefined, 'writer._closedPromise_resolve === undefined');
    assert(writer._closedPromise_reject === undefined, 'writer._closedPromise_reject === undefined');
    assert(writer._closedPromiseState !== 'pending', 'writer._closedPromiseState is not pending');
    writer._closedPromise = Promise.reject(reason);
    writer._closedPromiseState = 'rejected';
  }

  function defaultWriterClosedPromiseResolve(writer) {
    assert(writer._closedPromise_resolve !== undefined, 'writer._closedPromise_resolve !== undefined');
    assert(writer._closedPromise_reject !== undefined, 'writer._closedPromise_reject !== undefined');
    assert(writer._closedPromiseState === 'pending', 'writer._closedPromiseState is pending');

    writer._closedPromise_resolve(undefined);

    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'resolved';
  }

  function defaultWriterReadyPromiseInitialize(writer) {
    writer._readyPromise = new Promise(function (resolve, reject) {
      writer._readyPromise_resolve = resolve;
      writer._readyPromise_reject = reject;
    });
    writer._readyPromiseState = 'pending';
  }

  function defaultWriterReadyPromiseInitializeAsRejected(writer, reason) {
    writer._readyPromise = Promise.reject(reason);
    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'rejected';
  }

  function defaultWriterReadyPromiseInitializeAsResolved(writer) {
    writer._readyPromise = Promise.resolve(undefined);
    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'fulfilled';
  }

  function defaultWriterReadyPromiseReject(writer, reason) {
    assert(writer._readyPromise_resolve !== undefined, 'writer._readyPromise_resolve !== undefined');
    assert(writer._readyPromise_reject !== undefined, 'writer._readyPromise_reject !== undefined');

    writer._readyPromise_reject(reason);

    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'rejected';
  }

  function defaultWriterReadyPromiseReset(writer) {
    assert(writer._readyPromise_resolve === undefined, 'writer._readyPromise_resolve === undefined');
    assert(writer._readyPromise_reject === undefined, 'writer._readyPromise_reject === undefined');
    writer._readyPromise = new Promise(function (resolve, reject) {
      writer._readyPromise_resolve = resolve;
      writer._readyPromise_reject = reject;
    });
    writer._readyPromiseState = 'pending';
  }

  function defaultWriterReadyPromiseResetToRejected(writer, reason) {
    assert(writer._readyPromise_resolve === undefined, 'writer._readyPromise_resolve === undefined');
    assert(writer._readyPromise_reject === undefined, 'writer._readyPromise_reject === undefined');
    writer._readyPromise = Promise.reject(reason);
    writer._readyPromiseState = 'rejected';
  }

  function defaultWriterReadyPromiseResolve(writer) {
    assert(writer._readyPromise_resolve !== undefined, 'writer._readyPromise_resolve !== undefined');
    assert(writer._readyPromise_reject !== undefined, 'writer._readyPromise_reject !== undefined');

    writer._readyPromise_resolve(undefined);

    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'fulfilled';
  }
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _require = __w_pdfjs_require__(0),
      IsFiniteNonNegativeNumber = _require.IsFiniteNonNegativeNumber;

  var _require2 = __w_pdfjs_require__(1),
      assert = _require2.assert;

  exports.DequeueValue = function (container) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: DequeueValue should only be used on containers with [[queue]] and [[queueTotalSize]].');
    assert(container._queue.length > 0, 'Spec-level failure: should never dequeue from an empty queue.');

    var pair = container._queue.shift();

    container._queueTotalSize -= pair.size;

    if (container._queueTotalSize < 0) {
      container._queueTotalSize = 0;
    }

    return pair.value;
  };

  exports.EnqueueValueWithSize = function (container, value, size) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: EnqueueValueWithSize should only be used on containers with [[queue]] and ' + '[[queueTotalSize]].');
    size = Number(size);

    if (!IsFiniteNonNegativeNumber(size)) {
      throw new RangeError('Size must be a finite, non-NaN, non-negative number.');
    }

    container._queue.push({
      value: value,
      size: size
    });

    container._queueTotalSize += size;
  };

  exports.PeekQueueValue = function (container) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: PeekQueueValue should only be used on containers with [[queue]] and [[queueTotalSize]].');
    assert(container._queue.length > 0, 'Spec-level failure: should never peek at an empty queue.');
    var pair = container._queue[0];
    return pair.value;
  };

  exports.ResetQueue = function (container) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: ResetQueue should only be used on containers with [[queue]] and [[queueTotalSize]].');
    container._queue = [];
    container._queueTotalSize = 0;
  };
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _require = __w_pdfjs_require__(0),
      ArrayBufferCopy = _require.ArrayBufferCopy,
      CreateIterResultObject = _require.CreateIterResultObject,
      IsFiniteNonNegativeNumber = _require.IsFiniteNonNegativeNumber,
      InvokeOrNoop = _require.InvokeOrNoop,
      PromiseInvokeOrNoop = _require.PromiseInvokeOrNoop,
      TransferArrayBuffer = _require.TransferArrayBuffer,
      ValidateAndNormalizeQueuingStrategy = _require.ValidateAndNormalizeQueuingStrategy,
      ValidateAndNormalizeHighWaterMark = _require.ValidateAndNormalizeHighWaterMark;

  var _require2 = __w_pdfjs_require__(0),
      createArrayFromList = _require2.createArrayFromList,
      createDataProperty = _require2.createDataProperty,
      typeIsObject = _require2.typeIsObject;

  var _require3 = __w_pdfjs_require__(1),
      assert = _require3.assert,
      rethrowAssertionErrorRejection = _require3.rethrowAssertionErrorRejection;

  var _require4 = __w_pdfjs_require__(3),
      DequeueValue = _require4.DequeueValue,
      EnqueueValueWithSize = _require4.EnqueueValueWithSize,
      ResetQueue = _require4.ResetQueue;

  var _require5 = __w_pdfjs_require__(2),
      AcquireWritableStreamDefaultWriter = _require5.AcquireWritableStreamDefaultWriter,
      IsWritableStream = _require5.IsWritableStream,
      IsWritableStreamLocked = _require5.IsWritableStreamLocked,
      WritableStreamAbort = _require5.WritableStreamAbort,
      WritableStreamDefaultWriterCloseWithErrorPropagation = _require5.WritableStreamDefaultWriterCloseWithErrorPropagation,
      WritableStreamDefaultWriterRelease = _require5.WritableStreamDefaultWriterRelease,
      WritableStreamDefaultWriterWrite = _require5.WritableStreamDefaultWriterWrite,
      WritableStreamCloseQueuedOrInFlight = _require5.WritableStreamCloseQueuedOrInFlight;

  var ReadableStream = function () {
    function ReadableStream() {
      var underlyingSource = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          size = _ref.size,
          highWaterMark = _ref.highWaterMark;

      _classCallCheck(this, ReadableStream);

      this._state = 'readable';
      this._reader = undefined;
      this._storedError = undefined;
      this._disturbed = false;
      this._readableStreamController = undefined;
      var type = underlyingSource.type;
      var typeString = String(type);

      if (typeString === 'bytes') {
        if (highWaterMark === undefined) {
          highWaterMark = 0;
        }

        this._readableStreamController = new ReadableByteStreamController(this, underlyingSource, highWaterMark);
      } else if (type === undefined) {
        if (highWaterMark === undefined) {
          highWaterMark = 1;
        }

        this._readableStreamController = new ReadableStreamDefaultController(this, underlyingSource, size, highWaterMark);
      } else {
        throw new RangeError('Invalid type is specified');
      }
    }

    _createClass(ReadableStream, [{
      key: 'cancel',
      value: function cancel(reason) {
        if (IsReadableStream(this) === false) {
          return Promise.reject(streamBrandCheckException('cancel'));
        }

        if (IsReadableStreamLocked(this) === true) {
          return Promise.reject(new TypeError('Cannot cancel a stream that already has a reader'));
        }

        return ReadableStreamCancel(this, reason);
      }
    }, {
      key: 'getReader',
      value: function getReader() {
        var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            mode = _ref2.mode;

        if (IsReadableStream(this) === false) {
          throw streamBrandCheckException('getReader');
        }

        if (mode === undefined) {
          return AcquireReadableStreamDefaultReader(this);
        }

        mode = String(mode);

        if (mode === 'byob') {
          return AcquireReadableStreamBYOBReader(this);
        }

        throw new RangeError('Invalid mode is specified');
      }
    }, {
      key: 'pipeThrough',
      value: function pipeThrough(_ref3, options) {
        var writable = _ref3.writable,
            readable = _ref3.readable;
        var promise = this.pipeTo(writable, options);
        ifIsObjectAndHasAPromiseIsHandledInternalSlotSetPromiseIsHandledToTrue(promise);
        return readable;
      }
    }, {
      key: 'pipeTo',
      value: function pipeTo(dest) {
        var _this = this;

        var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            preventClose = _ref4.preventClose,
            preventAbort = _ref4.preventAbort,
            preventCancel = _ref4.preventCancel;

        if (IsReadableStream(this) === false) {
          return Promise.reject(streamBrandCheckException('pipeTo'));
        }

        if (IsWritableStream(dest) === false) {
          return Promise.reject(new TypeError('ReadableStream.prototype.pipeTo\'s first argument must be a WritableStream'));
        }

        preventClose = Boolean(preventClose);
        preventAbort = Boolean(preventAbort);
        preventCancel = Boolean(preventCancel);

        if (IsReadableStreamLocked(this) === true) {
          return Promise.reject(new TypeError('ReadableStream.prototype.pipeTo cannot be used on a locked ReadableStream'));
        }

        if (IsWritableStreamLocked(dest) === true) {
          return Promise.reject(new TypeError('ReadableStream.prototype.pipeTo cannot be used on a locked WritableStream'));
        }

        var reader = AcquireReadableStreamDefaultReader(this);
        var writer = AcquireWritableStreamDefaultWriter(dest);
        var shuttingDown = false;
        var currentWrite = Promise.resolve();
        return new Promise(function (resolve, reject) {
          function pipeLoop() {
            currentWrite = Promise.resolve();

            if (shuttingDown === true) {
              return Promise.resolve();
            }

            return writer._readyPromise.then(function () {
              return ReadableStreamDefaultReaderRead(reader).then(function (_ref5) {
                var value = _ref5.value,
                    done = _ref5.done;

                if (done === true) {
                  return;
                }

                currentWrite = WritableStreamDefaultWriterWrite(writer, value).catch(function () {});
              });
            }).then(pipeLoop);
          }

          isOrBecomesErrored(_this, reader._closedPromise, function (storedError) {
            if (preventAbort === false) {
              shutdownWithAction(function () {
                return WritableStreamAbort(dest, storedError);
              }, true, storedError);
            } else {
              shutdown(true, storedError);
            }
          });
          isOrBecomesErrored(dest, writer._closedPromise, function (storedError) {
            if (preventCancel === false) {
              shutdownWithAction(function () {
                return ReadableStreamCancel(_this, storedError);
              }, true, storedError);
            } else {
              shutdown(true, storedError);
            }
          });
          isOrBecomesClosed(_this, reader._closedPromise, function () {
            if (preventClose === false) {
              shutdownWithAction(function () {
                return WritableStreamDefaultWriterCloseWithErrorPropagation(writer);
              });
            } else {
              shutdown();
            }
          });

          if (WritableStreamCloseQueuedOrInFlight(dest) === true || dest._state === 'closed') {
            var destClosed = new TypeError('the destination writable stream closed before all data could be piped to it');

            if (preventCancel === false) {
              shutdownWithAction(function () {
                return ReadableStreamCancel(_this, destClosed);
              }, true, destClosed);
            } else {
              shutdown(true, destClosed);
            }
          }

          pipeLoop().catch(function (err) {
            currentWrite = Promise.resolve();
            rethrowAssertionErrorRejection(err);
          });

          function waitForWritesToFinish() {
            var oldCurrentWrite = currentWrite;
            return currentWrite.then(function () {
              return oldCurrentWrite !== currentWrite ? waitForWritesToFinish() : undefined;
            });
          }

          function isOrBecomesErrored(stream, promise, action) {
            if (stream._state === 'errored') {
              action(stream._storedError);
            } else {
              promise.catch(action).catch(rethrowAssertionErrorRejection);
            }
          }

          function isOrBecomesClosed(stream, promise, action) {
            if (stream._state === 'closed') {
              action();
            } else {
              promise.then(action).catch(rethrowAssertionErrorRejection);
            }
          }

          function shutdownWithAction(action, originalIsError, originalError) {
            if (shuttingDown === true) {
              return;
            }

            shuttingDown = true;

            if (dest._state === 'writable' && WritableStreamCloseQueuedOrInFlight(dest) === false) {
              waitForWritesToFinish().then(doTheRest);
            } else {
              doTheRest();
            }

            function doTheRest() {
              action().then(function () {
                return finalize(originalIsError, originalError);
              }, function (newError) {
                return finalize(true, newError);
              }).catch(rethrowAssertionErrorRejection);
            }
          }

          function shutdown(isError, error) {
            if (shuttingDown === true) {
              return;
            }

            shuttingDown = true;

            if (dest._state === 'writable' && WritableStreamCloseQueuedOrInFlight(dest) === false) {
              waitForWritesToFinish().then(function () {
                return finalize(isError, error);
              }).catch(rethrowAssertionErrorRejection);
            } else {
              finalize(isError, error);
            }
          }

          function finalize(isError, error) {
            WritableStreamDefaultWriterRelease(writer);
            ReadableStreamReaderGenericRelease(reader);

            if (isError) {
              reject(error);
            } else {
              resolve(undefined);
            }
          }
        });
      }
    }, {
      key: 'tee',
      value: function tee() {
        if (IsReadableStream(this) === false) {
          throw streamBrandCheckException('tee');
        }

        var branches = ReadableStreamTee(this, false);
        return createArrayFromList(branches);
      }
    }, {
      key: 'locked',
      get: function get() {
        if (IsReadableStream(this) === false) {
          throw streamBrandCheckException('locked');
        }

        return IsReadableStreamLocked(this);
      }
    }]);

    return ReadableStream;
  }();

  module.exports = {
    ReadableStream: ReadableStream,
    IsReadableStreamDisturbed: IsReadableStreamDisturbed,
    ReadableStreamDefaultControllerClose: ReadableStreamDefaultControllerClose,
    ReadableStreamDefaultControllerEnqueue: ReadableStreamDefaultControllerEnqueue,
    ReadableStreamDefaultControllerError: ReadableStreamDefaultControllerError,
    ReadableStreamDefaultControllerGetDesiredSize: ReadableStreamDefaultControllerGetDesiredSize
  };

  function AcquireReadableStreamBYOBReader(stream) {
    return new ReadableStreamBYOBReader(stream);
  }

  function AcquireReadableStreamDefaultReader(stream) {
    return new ReadableStreamDefaultReader(stream);
  }

  function IsReadableStream(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_readableStreamController')) {
      return false;
    }

    return true;
  }

  function IsReadableStreamDisturbed(stream) {
    assert(IsReadableStream(stream) === true, 'IsReadableStreamDisturbed should only be used on known readable streams');
    return stream._disturbed;
  }

  function IsReadableStreamLocked(stream) {
    assert(IsReadableStream(stream) === true, 'IsReadableStreamLocked should only be used on known readable streams');

    if (stream._reader === undefined) {
      return false;
    }

    return true;
  }

  function ReadableStreamTee(stream, cloneForBranch2) {
    assert(IsReadableStream(stream) === true);
    assert(typeof cloneForBranch2 === 'boolean');
    var reader = AcquireReadableStreamDefaultReader(stream);
    var teeState = {
      closedOrErrored: false,
      canceled1: false,
      canceled2: false,
      reason1: undefined,
      reason2: undefined
    };
    teeState.promise = new Promise(function (resolve) {
      teeState._resolve = resolve;
    });
    var pull = create_ReadableStreamTeePullFunction();
    pull._reader = reader;
    pull._teeState = teeState;
    pull._cloneForBranch2 = cloneForBranch2;
    var cancel1 = create_ReadableStreamTeeBranch1CancelFunction();
    cancel1._stream = stream;
    cancel1._teeState = teeState;
    var cancel2 = create_ReadableStreamTeeBranch2CancelFunction();
    cancel2._stream = stream;
    cancel2._teeState = teeState;
    var underlyingSource1 = Object.create(Object.prototype);
    createDataProperty(underlyingSource1, 'pull', pull);
    createDataProperty(underlyingSource1, 'cancel', cancel1);
    var branch1Stream = new ReadableStream(underlyingSource1);
    var underlyingSource2 = Object.create(Object.prototype);
    createDataProperty(underlyingSource2, 'pull', pull);
    createDataProperty(underlyingSource2, 'cancel', cancel2);
    var branch2Stream = new ReadableStream(underlyingSource2);
    pull._branch1 = branch1Stream._readableStreamController;
    pull._branch2 = branch2Stream._readableStreamController;

    reader._closedPromise.catch(function (r) {
      if (teeState.closedOrErrored === true) {
        return;
      }

      ReadableStreamDefaultControllerError(pull._branch1, r);
      ReadableStreamDefaultControllerError(pull._branch2, r);
      teeState.closedOrErrored = true;
    });

    return [branch1Stream, branch2Stream];
  }

  function create_ReadableStreamTeePullFunction() {
    function f() {
      var reader = f._reader,
          branch1 = f._branch1,
          branch2 = f._branch2,
          teeState = f._teeState;
      return ReadableStreamDefaultReaderRead(reader).then(function (result) {
        assert(typeIsObject(result));
        var value = result.value;
        var done = result.done;
        assert(typeof done === 'boolean');

        if (done === true && teeState.closedOrErrored === false) {
          if (teeState.canceled1 === false) {
            ReadableStreamDefaultControllerClose(branch1);
          }

          if (teeState.canceled2 === false) {
            ReadableStreamDefaultControllerClose(branch2);
          }

          teeState.closedOrErrored = true;
        }

        if (teeState.closedOrErrored === true) {
          return;
        }

        var value1 = value;
        var value2 = value;

        if (teeState.canceled1 === false) {
          ReadableStreamDefaultControllerEnqueue(branch1, value1);
        }

        if (teeState.canceled2 === false) {
          ReadableStreamDefaultControllerEnqueue(branch2, value2);
        }
      });
    }

    return f;
  }

  function create_ReadableStreamTeeBranch1CancelFunction() {
    function f(reason) {
      var stream = f._stream,
          teeState = f._teeState;
      teeState.canceled1 = true;
      teeState.reason1 = reason;

      if (teeState.canceled2 === true) {
        var compositeReason = createArrayFromList([teeState.reason1, teeState.reason2]);
        var cancelResult = ReadableStreamCancel(stream, compositeReason);

        teeState._resolve(cancelResult);
      }

      return teeState.promise;
    }

    return f;
  }

  function create_ReadableStreamTeeBranch2CancelFunction() {
    function f(reason) {
      var stream = f._stream,
          teeState = f._teeState;
      teeState.canceled2 = true;
      teeState.reason2 = reason;

      if (teeState.canceled1 === true) {
        var compositeReason = createArrayFromList([teeState.reason1, teeState.reason2]);
        var cancelResult = ReadableStreamCancel(stream, compositeReason);

        teeState._resolve(cancelResult);
      }

      return teeState.promise;
    }

    return f;
  }

  function ReadableStreamAddReadIntoRequest(stream) {
    assert(IsReadableStreamBYOBReader(stream._reader) === true);
    assert(stream._state === 'readable' || stream._state === 'closed');
    var promise = new Promise(function (resolve, reject) {
      var readIntoRequest = {
        _resolve: resolve,
        _reject: reject
      };

      stream._reader._readIntoRequests.push(readIntoRequest);
    });
    return promise;
  }

  function ReadableStreamAddReadRequest(stream) {
    assert(IsReadableStreamDefaultReader(stream._reader) === true);
    assert(stream._state === 'readable');
    var promise = new Promise(function (resolve, reject) {
      var readRequest = {
        _resolve: resolve,
        _reject: reject
      };

      stream._reader._readRequests.push(readRequest);
    });
    return promise;
  }

  function ReadableStreamCancel(stream, reason) {
    stream._disturbed = true;

    if (stream._state === 'closed') {
      return Promise.resolve(undefined);
    }

    if (stream._state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    ReadableStreamClose(stream);

    var sourceCancelPromise = stream._readableStreamController.__cancelSteps(reason);

    return sourceCancelPromise.then(function () {
      return undefined;
    });
  }

  function ReadableStreamClose(stream) {
    assert(stream._state === 'readable');
    stream._state = 'closed';
    var reader = stream._reader;

    if (reader === undefined) {
      return undefined;
    }

    if (IsReadableStreamDefaultReader(reader) === true) {
      for (var i = 0; i < reader._readRequests.length; i++) {
        var _resolve = reader._readRequests[i]._resolve;

        _resolve(CreateIterResultObject(undefined, true));
      }

      reader._readRequests = [];
    }

    defaultReaderClosedPromiseResolve(reader);
    return undefined;
  }

  function ReadableStreamError(stream, e) {
    assert(IsReadableStream(stream) === true, 'stream must be ReadableStream');
    assert(stream._state === 'readable', 'state must be readable');
    stream._state = 'errored';
    stream._storedError = e;
    var reader = stream._reader;

    if (reader === undefined) {
      return undefined;
    }

    if (IsReadableStreamDefaultReader(reader) === true) {
      for (var i = 0; i < reader._readRequests.length; i++) {
        var readRequest = reader._readRequests[i];

        readRequest._reject(e);
      }

      reader._readRequests = [];
    } else {
      assert(IsReadableStreamBYOBReader(reader), 'reader must be ReadableStreamBYOBReader');

      for (var _i = 0; _i < reader._readIntoRequests.length; _i++) {
        var readIntoRequest = reader._readIntoRequests[_i];

        readIntoRequest._reject(e);
      }

      reader._readIntoRequests = [];
    }

    defaultReaderClosedPromiseReject(reader, e);

    reader._closedPromise.catch(function () {});
  }

  function ReadableStreamFulfillReadIntoRequest(stream, chunk, done) {
    var reader = stream._reader;
    assert(reader._readIntoRequests.length > 0);

    var readIntoRequest = reader._readIntoRequests.shift();

    readIntoRequest._resolve(CreateIterResultObject(chunk, done));
  }

  function ReadableStreamFulfillReadRequest(stream, chunk, done) {
    var reader = stream._reader;
    assert(reader._readRequests.length > 0);

    var readRequest = reader._readRequests.shift();

    readRequest._resolve(CreateIterResultObject(chunk, done));
  }

  function ReadableStreamGetNumReadIntoRequests(stream) {
    return stream._reader._readIntoRequests.length;
  }

  function ReadableStreamGetNumReadRequests(stream) {
    return stream._reader._readRequests.length;
  }

  function ReadableStreamHasBYOBReader(stream) {
    var reader = stream._reader;

    if (reader === undefined) {
      return false;
    }

    if (IsReadableStreamBYOBReader(reader) === false) {
      return false;
    }

    return true;
  }

  function ReadableStreamHasDefaultReader(stream) {
    var reader = stream._reader;

    if (reader === undefined) {
      return false;
    }

    if (IsReadableStreamDefaultReader(reader) === false) {
      return false;
    }

    return true;
  }

  var ReadableStreamDefaultReader = function () {
    function ReadableStreamDefaultReader(stream) {
      _classCallCheck(this, ReadableStreamDefaultReader);

      if (IsReadableStream(stream) === false) {
        throw new TypeError('ReadableStreamDefaultReader can only be constructed with a ReadableStream instance');
      }

      if (IsReadableStreamLocked(stream) === true) {
        throw new TypeError('This stream has already been locked for exclusive reading by another reader');
      }

      ReadableStreamReaderGenericInitialize(this, stream);
      this._readRequests = [];
    }

    _createClass(ReadableStreamDefaultReader, [{
      key: 'cancel',
      value: function cancel(reason) {
        if (IsReadableStreamDefaultReader(this) === false) {
          return Promise.reject(defaultReaderBrandCheckException('cancel'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('cancel'));
        }

        return ReadableStreamReaderGenericCancel(this, reason);
      }
    }, {
      key: 'read',
      value: function read() {
        if (IsReadableStreamDefaultReader(this) === false) {
          return Promise.reject(defaultReaderBrandCheckException('read'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('read from'));
        }

        return ReadableStreamDefaultReaderRead(this);
      }
    }, {
      key: 'releaseLock',
      value: function releaseLock() {
        if (IsReadableStreamDefaultReader(this) === false) {
          throw defaultReaderBrandCheckException('releaseLock');
        }

        if (this._ownerReadableStream === undefined) {
          return;
        }

        if (this._readRequests.length > 0) {
          throw new TypeError('Tried to release a reader lock when that reader has pending read() calls un-settled');
        }

        ReadableStreamReaderGenericRelease(this);
      }
    }, {
      key: 'closed',
      get: function get() {
        if (IsReadableStreamDefaultReader(this) === false) {
          return Promise.reject(defaultReaderBrandCheckException('closed'));
        }

        return this._closedPromise;
      }
    }]);

    return ReadableStreamDefaultReader;
  }();

  var ReadableStreamBYOBReader = function () {
    function ReadableStreamBYOBReader(stream) {
      _classCallCheck(this, ReadableStreamBYOBReader);

      if (!IsReadableStream(stream)) {
        throw new TypeError('ReadableStreamBYOBReader can only be constructed with a ReadableStream instance given a ' + 'byte source');
      }

      if (IsReadableByteStreamController(stream._readableStreamController) === false) {
        throw new TypeError('Cannot construct a ReadableStreamBYOBReader for a stream not constructed with a byte ' + 'source');
      }

      if (IsReadableStreamLocked(stream)) {
        throw new TypeError('This stream has already been locked for exclusive reading by another reader');
      }

      ReadableStreamReaderGenericInitialize(this, stream);
      this._readIntoRequests = [];
    }

    _createClass(ReadableStreamBYOBReader, [{
      key: 'cancel',
      value: function cancel(reason) {
        if (!IsReadableStreamBYOBReader(this)) {
          return Promise.reject(byobReaderBrandCheckException('cancel'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('cancel'));
        }

        return ReadableStreamReaderGenericCancel(this, reason);
      }
    }, {
      key: 'read',
      value: function read(view) {
        if (!IsReadableStreamBYOBReader(this)) {
          return Promise.reject(byobReaderBrandCheckException('read'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('read from'));
        }

        if (!ArrayBuffer.isView(view)) {
          return Promise.reject(new TypeError('view must be an array buffer view'));
        }

        if (view.byteLength === 0) {
          return Promise.reject(new TypeError('view must have non-zero byteLength'));
        }

        return ReadableStreamBYOBReaderRead(this, view);
      }
    }, {
      key: 'releaseLock',
      value: function releaseLock() {
        if (!IsReadableStreamBYOBReader(this)) {
          throw byobReaderBrandCheckException('releaseLock');
        }

        if (this._ownerReadableStream === undefined) {
          return;
        }

        if (this._readIntoRequests.length > 0) {
          throw new TypeError('Tried to release a reader lock when that reader has pending read() calls un-settled');
        }

        ReadableStreamReaderGenericRelease(this);
      }
    }, {
      key: 'closed',
      get: function get() {
        if (!IsReadableStreamBYOBReader(this)) {
          return Promise.reject(byobReaderBrandCheckException('closed'));
        }

        return this._closedPromise;
      }
    }]);

    return ReadableStreamBYOBReader;
  }();

  function IsReadableStreamBYOBReader(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_readIntoRequests')) {
      return false;
    }

    return true;
  }

  function IsReadableStreamDefaultReader(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_readRequests')) {
      return false;
    }

    return true;
  }

  function ReadableStreamReaderGenericInitialize(reader, stream) {
    reader._ownerReadableStream = stream;
    stream._reader = reader;

    if (stream._state === 'readable') {
      defaultReaderClosedPromiseInitialize(reader);
    } else if (stream._state === 'closed') {
      defaultReaderClosedPromiseInitializeAsResolved(reader);
    } else {
      assert(stream._state === 'errored', 'state must be errored');
      defaultReaderClosedPromiseInitializeAsRejected(reader, stream._storedError);

      reader._closedPromise.catch(function () {});
    }
  }

  function ReadableStreamReaderGenericCancel(reader, reason) {
    var stream = reader._ownerReadableStream;
    assert(stream !== undefined);
    return ReadableStreamCancel(stream, reason);
  }

  function ReadableStreamReaderGenericRelease(reader) {
    assert(reader._ownerReadableStream !== undefined);
    assert(reader._ownerReadableStream._reader === reader);

    if (reader._ownerReadableStream._state === 'readable') {
      defaultReaderClosedPromiseReject(reader, new TypeError('Reader was released and can no longer be used to monitor the stream\'s closedness'));
    } else {
      defaultReaderClosedPromiseResetToRejected(reader, new TypeError('Reader was released and can no longer be used to monitor the stream\'s closedness'));
    }

    reader._closedPromise.catch(function () {});

    reader._ownerReadableStream._reader = undefined;
    reader._ownerReadableStream = undefined;
  }

  function ReadableStreamBYOBReaderRead(reader, view) {
    var stream = reader._ownerReadableStream;
    assert(stream !== undefined);
    stream._disturbed = true;

    if (stream._state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    return ReadableByteStreamControllerPullInto(stream._readableStreamController, view);
  }

  function ReadableStreamDefaultReaderRead(reader) {
    var stream = reader._ownerReadableStream;
    assert(stream !== undefined);
    stream._disturbed = true;

    if (stream._state === 'closed') {
      return Promise.resolve(CreateIterResultObject(undefined, true));
    }

    if (stream._state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    assert(stream._state === 'readable');
    return stream._readableStreamController.__pullSteps();
  }

  var ReadableStreamDefaultController = function () {
    function ReadableStreamDefaultController(stream, underlyingSource, size, highWaterMark) {
      _classCallCheck(this, ReadableStreamDefaultController);

      if (IsReadableStream(stream) === false) {
        throw new TypeError('ReadableStreamDefaultController can only be constructed with a ReadableStream instance');
      }

      if (stream._readableStreamController !== undefined) {
        throw new TypeError('ReadableStreamDefaultController instances can only be created by the ReadableStream constructor');
      }

      this._controlledReadableStream = stream;
      this._underlyingSource = underlyingSource;
      this._queue = undefined;
      this._queueTotalSize = undefined;
      ResetQueue(this);
      this._started = false;
      this._closeRequested = false;
      this._pullAgain = false;
      this._pulling = false;
      var normalizedStrategy = ValidateAndNormalizeQueuingStrategy(size, highWaterMark);
      this._strategySize = normalizedStrategy.size;
      this._strategyHWM = normalizedStrategy.highWaterMark;
      var controller = this;
      var startResult = InvokeOrNoop(underlyingSource, 'start', [this]);
      Promise.resolve(startResult).then(function () {
        controller._started = true;
        assert(controller._pulling === false);
        assert(controller._pullAgain === false);
        ReadableStreamDefaultControllerCallPullIfNeeded(controller);
      }, function (r) {
        ReadableStreamDefaultControllerErrorIfNeeded(controller, r);
      }).catch(rethrowAssertionErrorRejection);
    }

    _createClass(ReadableStreamDefaultController, [{
      key: 'close',
      value: function close() {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('close');
        }

        if (this._closeRequested === true) {
          throw new TypeError('The stream has already been closed; do not close it again!');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be closed');
        }

        ReadableStreamDefaultControllerClose(this);
      }
    }, {
      key: 'enqueue',
      value: function enqueue(chunk) {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('enqueue');
        }

        if (this._closeRequested === true) {
          throw new TypeError('stream is closed or draining');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be enqueued to');
        }

        return ReadableStreamDefaultControllerEnqueue(this, chunk);
      }
    }, {
      key: 'error',
      value: function error(e) {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('error');
        }

        var stream = this._controlledReadableStream;

        if (stream._state !== 'readable') {
          throw new TypeError('The stream is ' + stream._state + ' and so cannot be errored');
        }

        ReadableStreamDefaultControllerError(this, e);
      }
    }, {
      key: '__cancelSteps',
      value: function __cancelSteps(reason) {
        ResetQueue(this);
        return PromiseInvokeOrNoop(this._underlyingSource, 'cancel', [reason]);
      }
    }, {
      key: '__pullSteps',
      value: function __pullSteps() {
        var stream = this._controlledReadableStream;

        if (this._queue.length > 0) {
          var chunk = DequeueValue(this);

          if (this._closeRequested === true && this._queue.length === 0) {
            ReadableStreamClose(stream);
          } else {
            ReadableStreamDefaultControllerCallPullIfNeeded(this);
          }

          return Promise.resolve(CreateIterResultObject(chunk, false));
        }

        var pendingPromise = ReadableStreamAddReadRequest(stream);
        ReadableStreamDefaultControllerCallPullIfNeeded(this);
        return pendingPromise;
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('desiredSize');
        }

        return ReadableStreamDefaultControllerGetDesiredSize(this);
      }
    }]);

    return ReadableStreamDefaultController;
  }();

  function IsReadableStreamDefaultController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_underlyingSource')) {
      return false;
    }

    return true;
  }

  function ReadableStreamDefaultControllerCallPullIfNeeded(controller) {
    var shouldPull = ReadableStreamDefaultControllerShouldCallPull(controller);

    if (shouldPull === false) {
      return undefined;
    }

    if (controller._pulling === true) {
      controller._pullAgain = true;
      return undefined;
    }

    assert(controller._pullAgain === false);
    controller._pulling = true;
    var pullPromise = PromiseInvokeOrNoop(controller._underlyingSource, 'pull', [controller]);
    pullPromise.then(function () {
      controller._pulling = false;

      if (controller._pullAgain === true) {
        controller._pullAgain = false;
        return ReadableStreamDefaultControllerCallPullIfNeeded(controller);
      }

      return undefined;
    }, function (e) {
      ReadableStreamDefaultControllerErrorIfNeeded(controller, e);
    }).catch(rethrowAssertionErrorRejection);
    return undefined;
  }

  function ReadableStreamDefaultControllerShouldCallPull(controller) {
    var stream = controller._controlledReadableStream;

    if (stream._state === 'closed' || stream._state === 'errored') {
      return false;
    }

    if (controller._closeRequested === true) {
      return false;
    }

    if (controller._started === false) {
      return false;
    }

    if (IsReadableStreamLocked(stream) === true && ReadableStreamGetNumReadRequests(stream) > 0) {
      return true;
    }

    var desiredSize = ReadableStreamDefaultControllerGetDesiredSize(controller);

    if (desiredSize > 0) {
      return true;
    }

    return false;
  }

  function ReadableStreamDefaultControllerClose(controller) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');
    controller._closeRequested = true;

    if (controller._queue.length === 0) {
      ReadableStreamClose(stream);
    }
  }

  function ReadableStreamDefaultControllerEnqueue(controller, chunk) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');

    if (IsReadableStreamLocked(stream) === true && ReadableStreamGetNumReadRequests(stream) > 0) {
      ReadableStreamFulfillReadRequest(stream, chunk, false);
    } else {
      var chunkSize = 1;

      if (controller._strategySize !== undefined) {
        var strategySize = controller._strategySize;

        try {
          chunkSize = strategySize(chunk);
        } catch (chunkSizeE) {
          ReadableStreamDefaultControllerErrorIfNeeded(controller, chunkSizeE);
          throw chunkSizeE;
        }
      }

      try {
        EnqueueValueWithSize(controller, chunk, chunkSize);
      } catch (enqueueE) {
        ReadableStreamDefaultControllerErrorIfNeeded(controller, enqueueE);
        throw enqueueE;
      }
    }

    ReadableStreamDefaultControllerCallPullIfNeeded(controller);
    return undefined;
  }

  function ReadableStreamDefaultControllerError(controller, e) {
    var stream = controller._controlledReadableStream;
    assert(stream._state === 'readable');
    ResetQueue(controller);
    ReadableStreamError(stream, e);
  }

  function ReadableStreamDefaultControllerErrorIfNeeded(controller, e) {
    if (controller._controlledReadableStream._state === 'readable') {
      ReadableStreamDefaultControllerError(controller, e);
    }
  }

  function ReadableStreamDefaultControllerGetDesiredSize(controller) {
    var stream = controller._controlledReadableStream;
    var state = stream._state;

    if (state === 'errored') {
      return null;
    }

    if (state === 'closed') {
      return 0;
    }

    return controller._strategyHWM - controller._queueTotalSize;
  }

  var ReadableStreamBYOBRequest = function () {
    function ReadableStreamBYOBRequest(controller, view) {
      _classCallCheck(this, ReadableStreamBYOBRequest);

      this._associatedReadableByteStreamController = controller;
      this._view = view;
    }

    _createClass(ReadableStreamBYOBRequest, [{
      key: 'respond',
      value: function respond(bytesWritten) {
        if (IsReadableStreamBYOBRequest(this) === false) {
          throw byobRequestBrandCheckException('respond');
        }

        if (this._associatedReadableByteStreamController === undefined) {
          throw new TypeError('This BYOB request has been invalidated');
        }

        ReadableByteStreamControllerRespond(this._associatedReadableByteStreamController, bytesWritten);
      }
    }, {
      key: 'respondWithNewView',
      value: function respondWithNewView(view) {
        if (IsReadableStreamBYOBRequest(this) === false) {
          throw byobRequestBrandCheckException('respond');
        }

        if (this._associatedReadableByteStreamController === undefined) {
          throw new TypeError('This BYOB request has been invalidated');
        }

        if (!ArrayBuffer.isView(view)) {
          throw new TypeError('You can only respond with array buffer views');
        }

        ReadableByteStreamControllerRespondWithNewView(this._associatedReadableByteStreamController, view);
      }
    }, {
      key: 'view',
      get: function get() {
        return this._view;
      }
    }]);

    return ReadableStreamBYOBRequest;
  }();

  var ReadableByteStreamController = function () {
    function ReadableByteStreamController(stream, underlyingByteSource, highWaterMark) {
      _classCallCheck(this, ReadableByteStreamController);

      if (IsReadableStream(stream) === false) {
        throw new TypeError('ReadableByteStreamController can only be constructed with a ReadableStream instance given ' + 'a byte source');
      }

      if (stream._readableStreamController !== undefined) {
        throw new TypeError('ReadableByteStreamController instances can only be created by the ReadableStream constructor given a byte ' + 'source');
      }

      this._controlledReadableStream = stream;
      this._underlyingByteSource = underlyingByteSource;
      this._pullAgain = false;
      this._pulling = false;
      ReadableByteStreamControllerClearPendingPullIntos(this);
      this._queue = this._queueTotalSize = undefined;
      ResetQueue(this);
      this._closeRequested = false;
      this._started = false;
      this._strategyHWM = ValidateAndNormalizeHighWaterMark(highWaterMark);
      var autoAllocateChunkSize = underlyingByteSource.autoAllocateChunkSize;

      if (autoAllocateChunkSize !== undefined) {
        if (Number.isInteger(autoAllocateChunkSize) === false || autoAllocateChunkSize <= 0) {
          throw new RangeError('autoAllocateChunkSize must be a positive integer');
        }
      }

      this._autoAllocateChunkSize = autoAllocateChunkSize;
      this._pendingPullIntos = [];
      var controller = this;
      var startResult = InvokeOrNoop(underlyingByteSource, 'start', [this]);
      Promise.resolve(startResult).then(function () {
        controller._started = true;
        assert(controller._pulling === false);
        assert(controller._pullAgain === false);
        ReadableByteStreamControllerCallPullIfNeeded(controller);
      }, function (r) {
        if (stream._state === 'readable') {
          ReadableByteStreamControllerError(controller, r);
        }
      }).catch(rethrowAssertionErrorRejection);
    }

    _createClass(ReadableByteStreamController, [{
      key: 'close',
      value: function close() {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('close');
        }

        if (this._closeRequested === true) {
          throw new TypeError('The stream has already been closed; do not close it again!');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be closed');
        }

        ReadableByteStreamControllerClose(this);
      }
    }, {
      key: 'enqueue',
      value: function enqueue(chunk) {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('enqueue');
        }

        if (this._closeRequested === true) {
          throw new TypeError('stream is closed or draining');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be enqueued to');
        }

        if (!ArrayBuffer.isView(chunk)) {
          throw new TypeError('You can only enqueue array buffer views when using a ReadableByteStreamController');
        }

        ReadableByteStreamControllerEnqueue(this, chunk);
      }
    }, {
      key: 'error',
      value: function error(e) {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('error');
        }

        var stream = this._controlledReadableStream;

        if (stream._state !== 'readable') {
          throw new TypeError('The stream is ' + stream._state + ' and so cannot be errored');
        }

        ReadableByteStreamControllerError(this, e);
      }
    }, {
      key: '__cancelSteps',
      value: function __cancelSteps(reason) {
        if (this._pendingPullIntos.length > 0) {
          var firstDescriptor = this._pendingPullIntos[0];
          firstDescriptor.bytesFilled = 0;
        }

        ResetQueue(this);
        return PromiseInvokeOrNoop(this._underlyingByteSource, 'cancel', [reason]);
      }
    }, {
      key: '__pullSteps',
      value: function __pullSteps() {
        var stream = this._controlledReadableStream;
        assert(ReadableStreamHasDefaultReader(stream) === true);

        if (this._queueTotalSize > 0) {
          assert(ReadableStreamGetNumReadRequests(stream) === 0);

          var entry = this._queue.shift();

          this._queueTotalSize -= entry.byteLength;
          ReadableByteStreamControllerHandleQueueDrain(this);
          var view = void 0;

          try {
            view = new Uint8Array(entry.buffer, entry.byteOffset, entry.byteLength);
          } catch (viewE) {
            return Promise.reject(viewE);
          }

          return Promise.resolve(CreateIterResultObject(view, false));
        }

        var autoAllocateChunkSize = this._autoAllocateChunkSize;

        if (autoAllocateChunkSize !== undefined) {
          var buffer = void 0;

          try {
            buffer = new ArrayBuffer(autoAllocateChunkSize);
          } catch (bufferE) {
            return Promise.reject(bufferE);
          }

          var pullIntoDescriptor = {
            buffer: buffer,
            byteOffset: 0,
            byteLength: autoAllocateChunkSize,
            bytesFilled: 0,
            elementSize: 1,
            ctor: Uint8Array,
            readerType: 'default'
          };

          this._pendingPullIntos.push(pullIntoDescriptor);
        }

        var promise = ReadableStreamAddReadRequest(stream);
        ReadableByteStreamControllerCallPullIfNeeded(this);
        return promise;
      }
    }, {
      key: 'byobRequest',
      get: function get() {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('byobRequest');
        }

        if (this._byobRequest === undefined && this._pendingPullIntos.length > 0) {
          var firstDescriptor = this._pendingPullIntos[0];
          var view = new Uint8Array(firstDescriptor.buffer, firstDescriptor.byteOffset + firstDescriptor.bytesFilled, firstDescriptor.byteLength - firstDescriptor.bytesFilled);
          this._byobRequest = new ReadableStreamBYOBRequest(this, view);
        }

        return this._byobRequest;
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('desiredSize');
        }

        return ReadableByteStreamControllerGetDesiredSize(this);
      }
    }]);

    return ReadableByteStreamController;
  }();

  function IsReadableByteStreamController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_underlyingByteSource')) {
      return false;
    }

    return true;
  }

  function IsReadableStreamBYOBRequest(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_associatedReadableByteStreamController')) {
      return false;
    }

    return true;
  }

  function ReadableByteStreamControllerCallPullIfNeeded(controller) {
    var shouldPull = ReadableByteStreamControllerShouldCallPull(controller);

    if (shouldPull === false) {
      return undefined;
    }

    if (controller._pulling === true) {
      controller._pullAgain = true;
      return undefined;
    }

    assert(controller._pullAgain === false);
    controller._pulling = true;
    var pullPromise = PromiseInvokeOrNoop(controller._underlyingByteSource, 'pull', [controller]);
    pullPromise.then(function () {
      controller._pulling = false;

      if (controller._pullAgain === true) {
        controller._pullAgain = false;
        ReadableByteStreamControllerCallPullIfNeeded(controller);
      }
    }, function (e) {
      if (controller._controlledReadableStream._state === 'readable') {
        ReadableByteStreamControllerError(controller, e);
      }
    }).catch(rethrowAssertionErrorRejection);
    return undefined;
  }

  function ReadableByteStreamControllerClearPendingPullIntos(controller) {
    ReadableByteStreamControllerInvalidateBYOBRequest(controller);
    controller._pendingPullIntos = [];
  }

  function ReadableByteStreamControllerCommitPullIntoDescriptor(stream, pullIntoDescriptor) {
    assert(stream._state !== 'errored', 'state must not be errored');
    var done = false;

    if (stream._state === 'closed') {
      assert(pullIntoDescriptor.bytesFilled === 0);
      done = true;
    }

    var filledView = ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor);

    if (pullIntoDescriptor.readerType === 'default') {
      ReadableStreamFulfillReadRequest(stream, filledView, done);
    } else {
      assert(pullIntoDescriptor.readerType === 'byob');
      ReadableStreamFulfillReadIntoRequest(stream, filledView, done);
    }
  }

  function ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor) {
    var bytesFilled = pullIntoDescriptor.bytesFilled;
    var elementSize = pullIntoDescriptor.elementSize;
    assert(bytesFilled <= pullIntoDescriptor.byteLength);
    assert(bytesFilled % elementSize === 0);
    return new pullIntoDescriptor.ctor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, bytesFilled / elementSize);
  }

  function ReadableByteStreamControllerEnqueueChunkToQueue(controller, buffer, byteOffset, byteLength) {
    controller._queue.push({
      buffer: buffer,
      byteOffset: byteOffset,
      byteLength: byteLength
    });

    controller._queueTotalSize += byteLength;
  }

  function ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor) {
    var elementSize = pullIntoDescriptor.elementSize;
    var currentAlignedBytes = pullIntoDescriptor.bytesFilled - pullIntoDescriptor.bytesFilled % elementSize;
    var maxBytesToCopy = Math.min(controller._queueTotalSize, pullIntoDescriptor.byteLength - pullIntoDescriptor.bytesFilled);
    var maxBytesFilled = pullIntoDescriptor.bytesFilled + maxBytesToCopy;
    var maxAlignedBytes = maxBytesFilled - maxBytesFilled % elementSize;
    var totalBytesToCopyRemaining = maxBytesToCopy;
    var ready = false;

    if (maxAlignedBytes > currentAlignedBytes) {
      totalBytesToCopyRemaining = maxAlignedBytes - pullIntoDescriptor.bytesFilled;
      ready = true;
    }

    var queue = controller._queue;

    while (totalBytesToCopyRemaining > 0) {
      var headOfQueue = queue[0];
      var bytesToCopy = Math.min(totalBytesToCopyRemaining, headOfQueue.byteLength);
      var destStart = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;
      ArrayBufferCopy(pullIntoDescriptor.buffer, destStart, headOfQueue.buffer, headOfQueue.byteOffset, bytesToCopy);

      if (headOfQueue.byteLength === bytesToCopy) {
        queue.shift();
      } else {
        headOfQueue.byteOffset += bytesToCopy;
        headOfQueue.byteLength -= bytesToCopy;
      }

      controller._queueTotalSize -= bytesToCopy;
      ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, bytesToCopy, pullIntoDescriptor);
      totalBytesToCopyRemaining -= bytesToCopy;
    }

    if (ready === false) {
      assert(controller._queueTotalSize === 0, 'queue must be empty');
      assert(pullIntoDescriptor.bytesFilled > 0);
      assert(pullIntoDescriptor.bytesFilled < pullIntoDescriptor.elementSize);
    }

    return ready;
  }

  function ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, size, pullIntoDescriptor) {
    assert(controller._pendingPullIntos.length === 0 || controller._pendingPullIntos[0] === pullIntoDescriptor);
    ReadableByteStreamControllerInvalidateBYOBRequest(controller);
    pullIntoDescriptor.bytesFilled += size;
  }

  function ReadableByteStreamControllerHandleQueueDrain(controller) {
    assert(controller._controlledReadableStream._state === 'readable');

    if (controller._queueTotalSize === 0 && controller._closeRequested === true) {
      ReadableStreamClose(controller._controlledReadableStream);
    } else {
      ReadableByteStreamControllerCallPullIfNeeded(controller);
    }
  }

  function ReadableByteStreamControllerInvalidateBYOBRequest(controller) {
    if (controller._byobRequest === undefined) {
      return;
    }

    controller._byobRequest._associatedReadableByteStreamController = undefined;
    controller._byobRequest._view = undefined;
    controller._byobRequest = undefined;
  }

  function ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller) {
    assert(controller._closeRequested === false);

    while (controller._pendingPullIntos.length > 0) {
      if (controller._queueTotalSize === 0) {
        return;
      }

      var pullIntoDescriptor = controller._pendingPullIntos[0];

      if (ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor) === true) {
        ReadableByteStreamControllerShiftPendingPullInto(controller);
        ReadableByteStreamControllerCommitPullIntoDescriptor(controller._controlledReadableStream, pullIntoDescriptor);
      }
    }
  }

  function ReadableByteStreamControllerPullInto(controller, view) {
    var stream = controller._controlledReadableStream;
    var elementSize = 1;

    if (view.constructor !== DataView) {
      elementSize = view.constructor.BYTES_PER_ELEMENT;
    }

    var ctor = view.constructor;
    var pullIntoDescriptor = {
      buffer: view.buffer,
      byteOffset: view.byteOffset,
      byteLength: view.byteLength,
      bytesFilled: 0,
      elementSize: elementSize,
      ctor: ctor,
      readerType: 'byob'
    };

    if (controller._pendingPullIntos.length > 0) {
      pullIntoDescriptor.buffer = TransferArrayBuffer(pullIntoDescriptor.buffer);

      controller._pendingPullIntos.push(pullIntoDescriptor);

      return ReadableStreamAddReadIntoRequest(stream);
    }

    if (stream._state === 'closed') {
      var emptyView = new view.constructor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, 0);
      return Promise.resolve(CreateIterResultObject(emptyView, true));
    }

    if (controller._queueTotalSize > 0) {
      if (ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor) === true) {
        var filledView = ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor);
        ReadableByteStreamControllerHandleQueueDrain(controller);
        return Promise.resolve(CreateIterResultObject(filledView, false));
      }

      if (controller._closeRequested === true) {
        var e = new TypeError('Insufficient bytes to fill elements in the given buffer');
        ReadableByteStreamControllerError(controller, e);
        return Promise.reject(e);
      }
    }

    pullIntoDescriptor.buffer = TransferArrayBuffer(pullIntoDescriptor.buffer);

    controller._pendingPullIntos.push(pullIntoDescriptor);

    var promise = ReadableStreamAddReadIntoRequest(stream);
    ReadableByteStreamControllerCallPullIfNeeded(controller);
    return promise;
  }

  function ReadableByteStreamControllerRespondInClosedState(controller, firstDescriptor) {
    firstDescriptor.buffer = TransferArrayBuffer(firstDescriptor.buffer);
    assert(firstDescriptor.bytesFilled === 0, 'bytesFilled must be 0');
    var stream = controller._controlledReadableStream;

    if (ReadableStreamHasBYOBReader(stream) === true) {
      while (ReadableStreamGetNumReadIntoRequests(stream) > 0) {
        var pullIntoDescriptor = ReadableByteStreamControllerShiftPendingPullInto(controller);
        ReadableByteStreamControllerCommitPullIntoDescriptor(stream, pullIntoDescriptor);
      }
    }
  }

  function ReadableByteStreamControllerRespondInReadableState(controller, bytesWritten, pullIntoDescriptor) {
    if (pullIntoDescriptor.bytesFilled + bytesWritten > pullIntoDescriptor.byteLength) {
      throw new RangeError('bytesWritten out of range');
    }

    ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, bytesWritten, pullIntoDescriptor);

    if (pullIntoDescriptor.bytesFilled < pullIntoDescriptor.elementSize) {
      return;
    }

    ReadableByteStreamControllerShiftPendingPullInto(controller);
    var remainderSize = pullIntoDescriptor.bytesFilled % pullIntoDescriptor.elementSize;

    if (remainderSize > 0) {
      var end = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;
      var remainder = pullIntoDescriptor.buffer.slice(end - remainderSize, end);
      ReadableByteStreamControllerEnqueueChunkToQueue(controller, remainder, 0, remainder.byteLength);
    }

    pullIntoDescriptor.buffer = TransferArrayBuffer(pullIntoDescriptor.buffer);
    pullIntoDescriptor.bytesFilled -= remainderSize;
    ReadableByteStreamControllerCommitPullIntoDescriptor(controller._controlledReadableStream, pullIntoDescriptor);
    ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller);
  }

  function ReadableByteStreamControllerRespondInternal(controller, bytesWritten) {
    var firstDescriptor = controller._pendingPullIntos[0];
    var stream = controller._controlledReadableStream;

    if (stream._state === 'closed') {
      if (bytesWritten !== 0) {
        throw new TypeError('bytesWritten must be 0 when calling respond() on a closed stream');
      }

      ReadableByteStreamControllerRespondInClosedState(controller, firstDescriptor);
    } else {
      assert(stream._state === 'readable');
      ReadableByteStreamControllerRespondInReadableState(controller, bytesWritten, firstDescriptor);
    }
  }

  function ReadableByteStreamControllerShiftPendingPullInto(controller) {
    var descriptor = controller._pendingPullIntos.shift();

    ReadableByteStreamControllerInvalidateBYOBRequest(controller);
    return descriptor;
  }

  function ReadableByteStreamControllerShouldCallPull(controller) {
    var stream = controller._controlledReadableStream;

    if (stream._state !== 'readable') {
      return false;
    }

    if (controller._closeRequested === true) {
      return false;
    }

    if (controller._started === false) {
      return false;
    }

    if (ReadableStreamHasDefaultReader(stream) === true && ReadableStreamGetNumReadRequests(stream) > 0) {
      return true;
    }

    if (ReadableStreamHasBYOBReader(stream) === true && ReadableStreamGetNumReadIntoRequests(stream) > 0) {
      return true;
    }

    if (ReadableByteStreamControllerGetDesiredSize(controller) > 0) {
      return true;
    }

    return false;
  }

  function ReadableByteStreamControllerClose(controller) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');

    if (controller._queueTotalSize > 0) {
      controller._closeRequested = true;
      return;
    }

    if (controller._pendingPullIntos.length > 0) {
      var firstPendingPullInto = controller._pendingPullIntos[0];

      if (firstPendingPullInto.bytesFilled > 0) {
        var e = new TypeError('Insufficient bytes to fill elements in the given buffer');
        ReadableByteStreamControllerError(controller, e);
        throw e;
      }
    }

    ReadableStreamClose(stream);
  }

  function ReadableByteStreamControllerEnqueue(controller, chunk) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');
    var buffer = chunk.buffer;
    var byteOffset = chunk.byteOffset;
    var byteLength = chunk.byteLength;
    var transferredBuffer = TransferArrayBuffer(buffer);

    if (ReadableStreamHasDefaultReader(stream) === true) {
      if (ReadableStreamGetNumReadRequests(stream) === 0) {
        ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
      } else {
        assert(controller._queue.length === 0);
        var transferredView = new Uint8Array(transferredBuffer, byteOffset, byteLength);
        ReadableStreamFulfillReadRequest(stream, transferredView, false);
      }
    } else if (ReadableStreamHasBYOBReader(stream) === true) {
      ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
      ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller);
    } else {
      assert(IsReadableStreamLocked(stream) === false, 'stream must not be locked');
      ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
    }
  }

  function ReadableByteStreamControllerError(controller, e) {
    var stream = controller._controlledReadableStream;
    assert(stream._state === 'readable');
    ReadableByteStreamControllerClearPendingPullIntos(controller);
    ResetQueue(controller);
    ReadableStreamError(stream, e);
  }

  function ReadableByteStreamControllerGetDesiredSize(controller) {
    var stream = controller._controlledReadableStream;
    var state = stream._state;

    if (state === 'errored') {
      return null;
    }

    if (state === 'closed') {
      return 0;
    }

    return controller._strategyHWM - controller._queueTotalSize;
  }

  function ReadableByteStreamControllerRespond(controller, bytesWritten) {
    bytesWritten = Number(bytesWritten);

    if (IsFiniteNonNegativeNumber(bytesWritten) === false) {
      throw new RangeError('bytesWritten must be a finite');
    }

    assert(controller._pendingPullIntos.length > 0);
    ReadableByteStreamControllerRespondInternal(controller, bytesWritten);
  }

  function ReadableByteStreamControllerRespondWithNewView(controller, view) {
    assert(controller._pendingPullIntos.length > 0);
    var firstDescriptor = controller._pendingPullIntos[0];

    if (firstDescriptor.byteOffset + firstDescriptor.bytesFilled !== view.byteOffset) {
      throw new RangeError('The region specified by view does not match byobRequest');
    }

    if (firstDescriptor.byteLength !== view.byteLength) {
      throw new RangeError('The buffer of view has different capacity than byobRequest');
    }

    firstDescriptor.buffer = view.buffer;
    ReadableByteStreamControllerRespondInternal(controller, view.byteLength);
  }

  function streamBrandCheckException(name) {
    return new TypeError('ReadableStream.prototype.' + name + ' can only be used on a ReadableStream');
  }

  function readerLockException(name) {
    return new TypeError('Cannot ' + name + ' a stream using a released reader');
  }

  function defaultReaderBrandCheckException(name) {
    return new TypeError('ReadableStreamDefaultReader.prototype.' + name + ' can only be used on a ReadableStreamDefaultReader');
  }

  function defaultReaderClosedPromiseInitialize(reader) {
    reader._closedPromise = new Promise(function (resolve, reject) {
      reader._closedPromise_resolve = resolve;
      reader._closedPromise_reject = reject;
    });
  }

  function defaultReaderClosedPromiseInitializeAsRejected(reader, reason) {
    reader._closedPromise = Promise.reject(reason);
    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function defaultReaderClosedPromiseInitializeAsResolved(reader) {
    reader._closedPromise = Promise.resolve(undefined);
    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function defaultReaderClosedPromiseReject(reader, reason) {
    assert(reader._closedPromise_resolve !== undefined);
    assert(reader._closedPromise_reject !== undefined);

    reader._closedPromise_reject(reason);

    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function defaultReaderClosedPromiseResetToRejected(reader, reason) {
    assert(reader._closedPromise_resolve === undefined);
    assert(reader._closedPromise_reject === undefined);
    reader._closedPromise = Promise.reject(reason);
  }

  function defaultReaderClosedPromiseResolve(reader) {
    assert(reader._closedPromise_resolve !== undefined);
    assert(reader._closedPromise_reject !== undefined);

    reader._closedPromise_resolve(undefined);

    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function byobReaderBrandCheckException(name) {
    return new TypeError('ReadableStreamBYOBReader.prototype.' + name + ' can only be used on a ReadableStreamBYOBReader');
  }

  function defaultControllerBrandCheckException(name) {
    return new TypeError('ReadableStreamDefaultController.prototype.' + name + ' can only be used on a ReadableStreamDefaultController');
  }

  function byobRequestBrandCheckException(name) {
    return new TypeError('ReadableStreamBYOBRequest.prototype.' + name + ' can only be used on a ReadableStreamBYOBRequest');
  }

  function byteStreamControllerBrandCheckException(name) {
    return new TypeError('ReadableByteStreamController.prototype.' + name + ' can only be used on a ReadableByteStreamController');
  }

  function ifIsObjectAndHasAPromiseIsHandledInternalSlotSetPromiseIsHandledToTrue(promise) {
    try {
      Promise.prototype.then.call(promise, undefined, function () {});
    } catch (e) {}
  }
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var transformStream = __w_pdfjs_require__(6);

  var readableStream = __w_pdfjs_require__(4);

  var writableStream = __w_pdfjs_require__(2);

  exports.TransformStream = transformStream.TransformStream;
  exports.ReadableStream = readableStream.ReadableStream;
  exports.IsReadableStreamDisturbed = readableStream.IsReadableStreamDisturbed;
  exports.ReadableStreamDefaultControllerClose = readableStream.ReadableStreamDefaultControllerClose;
  exports.ReadableStreamDefaultControllerEnqueue = readableStream.ReadableStreamDefaultControllerEnqueue;
  exports.ReadableStreamDefaultControllerError = readableStream.ReadableStreamDefaultControllerError;
  exports.ReadableStreamDefaultControllerGetDesiredSize = readableStream.ReadableStreamDefaultControllerGetDesiredSize;
  exports.AcquireWritableStreamDefaultWriter = writableStream.AcquireWritableStreamDefaultWriter;
  exports.IsWritableStream = writableStream.IsWritableStream;
  exports.IsWritableStreamLocked = writableStream.IsWritableStreamLocked;
  exports.WritableStream = writableStream.WritableStream;
  exports.WritableStreamAbort = writableStream.WritableStreamAbort;
  exports.WritableStreamDefaultControllerError = writableStream.WritableStreamDefaultControllerError;
  exports.WritableStreamDefaultWriterCloseWithErrorPropagation = writableStream.WritableStreamDefaultWriterCloseWithErrorPropagation;
  exports.WritableStreamDefaultWriterRelease = writableStream.WritableStreamDefaultWriterRelease;
  exports.WritableStreamDefaultWriterWrite = writableStream.WritableStreamDefaultWriterWrite;
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _require = __w_pdfjs_require__(1),
      assert = _require.assert;

  var _require2 = __w_pdfjs_require__(0),
      InvokeOrNoop = _require2.InvokeOrNoop,
      PromiseInvokeOrPerformFallback = _require2.PromiseInvokeOrPerformFallback,
      PromiseInvokeOrNoop = _require2.PromiseInvokeOrNoop,
      typeIsObject = _require2.typeIsObject;

  var _require3 = __w_pdfjs_require__(4),
      ReadableStream = _require3.ReadableStream,
      ReadableStreamDefaultControllerClose = _require3.ReadableStreamDefaultControllerClose,
      ReadableStreamDefaultControllerEnqueue = _require3.ReadableStreamDefaultControllerEnqueue,
      ReadableStreamDefaultControllerError = _require3.ReadableStreamDefaultControllerError,
      ReadableStreamDefaultControllerGetDesiredSize = _require3.ReadableStreamDefaultControllerGetDesiredSize;

  var _require4 = __w_pdfjs_require__(2),
      WritableStream = _require4.WritableStream,
      WritableStreamDefaultControllerError = _require4.WritableStreamDefaultControllerError;

  function TransformStreamCloseReadable(transformStream) {
    if (transformStream._errored === true) {
      throw new TypeError('TransformStream is already errored');
    }

    if (transformStream._readableClosed === true) {
      throw new TypeError('Readable side is already closed');
    }

    TransformStreamCloseReadableInternal(transformStream);
  }

  function TransformStreamEnqueueToReadable(transformStream, chunk) {
    if (transformStream._errored === true) {
      throw new TypeError('TransformStream is already errored');
    }

    if (transformStream._readableClosed === true) {
      throw new TypeError('Readable side is already closed');
    }

    var controller = transformStream._readableController;

    try {
      ReadableStreamDefaultControllerEnqueue(controller, chunk);
    } catch (e) {
      transformStream._readableClosed = true;
      TransformStreamErrorIfNeeded(transformStream, e);
      throw transformStream._storedError;
    }

    var desiredSize = ReadableStreamDefaultControllerGetDesiredSize(controller);
    var maybeBackpressure = desiredSize <= 0;

    if (maybeBackpressure === true && transformStream._backpressure === false) {
      TransformStreamSetBackpressure(transformStream, true);
    }
  }

  function TransformStreamError(transformStream, e) {
    if (transformStream._errored === true) {
      throw new TypeError('TransformStream is already errored');
    }

    TransformStreamErrorInternal(transformStream, e);
  }

  function TransformStreamCloseReadableInternal(transformStream) {
    assert(transformStream._errored === false);
    assert(transformStream._readableClosed === false);

    try {
      ReadableStreamDefaultControllerClose(transformStream._readableController);
    } catch (e) {
      assert(false);
    }

    transformStream._readableClosed = true;
  }

  function TransformStreamErrorIfNeeded(transformStream, e) {
    if (transformStream._errored === false) {
      TransformStreamErrorInternal(transformStream, e);
    }
  }

  function TransformStreamErrorInternal(transformStream, e) {
    assert(transformStream._errored === false);
    transformStream._errored = true;
    transformStream._storedError = e;

    if (transformStream._writableDone === false) {
      WritableStreamDefaultControllerError(transformStream._writableController, e);
    }

    if (transformStream._readableClosed === false) {
      ReadableStreamDefaultControllerError(transformStream._readableController, e);
    }
  }

  function TransformStreamReadableReadyPromise(transformStream) {
    assert(transformStream._backpressureChangePromise !== undefined, '_backpressureChangePromise should have been initialized');

    if (transformStream._backpressure === false) {
      return Promise.resolve();
    }

    assert(transformStream._backpressure === true, '_backpressure should have been initialized');
    return transformStream._backpressureChangePromise;
  }

  function TransformStreamSetBackpressure(transformStream, backpressure) {
    assert(transformStream._backpressure !== backpressure, 'TransformStreamSetBackpressure() should be called only when backpressure is changed');

    if (transformStream._backpressureChangePromise !== undefined) {
      transformStream._backpressureChangePromise_resolve(backpressure);
    }

    transformStream._backpressureChangePromise = new Promise(function (resolve) {
      transformStream._backpressureChangePromise_resolve = resolve;
    });

    transformStream._backpressureChangePromise.then(function (resolution) {
      assert(resolution !== backpressure, '_backpressureChangePromise should be fulfilled only when backpressure is changed');
    });

    transformStream._backpressure = backpressure;
  }

  function TransformStreamDefaultTransform(chunk, transformStreamController) {
    var transformStream = transformStreamController._controlledTransformStream;
    TransformStreamEnqueueToReadable(transformStream, chunk);
    return Promise.resolve();
  }

  function TransformStreamTransform(transformStream, chunk) {
    assert(transformStream._errored === false);
    assert(transformStream._transforming === false);
    assert(transformStream._backpressure === false);
    transformStream._transforming = true;
    var transformer = transformStream._transformer;
    var controller = transformStream._transformStreamController;
    var transformPromise = PromiseInvokeOrPerformFallback(transformer, 'transform', [chunk, controller], TransformStreamDefaultTransform, [chunk, controller]);
    return transformPromise.then(function () {
      transformStream._transforming = false;
      return TransformStreamReadableReadyPromise(transformStream);
    }, function (e) {
      TransformStreamErrorIfNeeded(transformStream, e);
      return Promise.reject(e);
    });
  }

  function IsTransformStreamDefaultController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_controlledTransformStream')) {
      return false;
    }

    return true;
  }

  function IsTransformStream(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_transformStreamController')) {
      return false;
    }

    return true;
  }

  var TransformStreamSink = function () {
    function TransformStreamSink(transformStream, startPromise) {
      _classCallCheck(this, TransformStreamSink);

      this._transformStream = transformStream;
      this._startPromise = startPromise;
    }

    _createClass(TransformStreamSink, [{
      key: 'start',
      value: function start(c) {
        var transformStream = this._transformStream;
        transformStream._writableController = c;
        return this._startPromise.then(function () {
          return TransformStreamReadableReadyPromise(transformStream);
        });
      }
    }, {
      key: 'write',
      value: function write(chunk) {
        var transformStream = this._transformStream;
        return TransformStreamTransform(transformStream, chunk);
      }
    }, {
      key: 'abort',
      value: function abort() {
        var transformStream = this._transformStream;
        transformStream._writableDone = true;
        TransformStreamErrorInternal(transformStream, new TypeError('Writable side aborted'));
      }
    }, {
      key: 'close',
      value: function close() {
        var transformStream = this._transformStream;
        assert(transformStream._transforming === false);
        transformStream._writableDone = true;
        var flushPromise = PromiseInvokeOrNoop(transformStream._transformer, 'flush', [transformStream._transformStreamController]);
        return flushPromise.then(function () {
          if (transformStream._errored === true) {
            return Promise.reject(transformStream._storedError);
          }

          if (transformStream._readableClosed === false) {
            TransformStreamCloseReadableInternal(transformStream);
          }

          return Promise.resolve();
        }).catch(function (r) {
          TransformStreamErrorIfNeeded(transformStream, r);
          return Promise.reject(transformStream._storedError);
        });
      }
    }]);

    return TransformStreamSink;
  }();

  var TransformStreamSource = function () {
    function TransformStreamSource(transformStream, startPromise) {
      _classCallCheck(this, TransformStreamSource);

      this._transformStream = transformStream;
      this._startPromise = startPromise;
    }

    _createClass(TransformStreamSource, [{
      key: 'start',
      value: function start(c) {
        var transformStream = this._transformStream;
        transformStream._readableController = c;
        return this._startPromise.then(function () {
          assert(transformStream._backpressureChangePromise !== undefined, '_backpressureChangePromise should have been initialized');

          if (transformStream._backpressure === true) {
            return Promise.resolve();
          }

          assert(transformStream._backpressure === false, '_backpressure should have been initialized');
          return transformStream._backpressureChangePromise;
        });
      }
    }, {
      key: 'pull',
      value: function pull() {
        var transformStream = this._transformStream;
        assert(transformStream._backpressure === true, 'pull() should be never called while _backpressure is false');
        assert(transformStream._backpressureChangePromise !== undefined, '_backpressureChangePromise should have been initialized');
        TransformStreamSetBackpressure(transformStream, false);
        return transformStream._backpressureChangePromise;
      }
    }, {
      key: 'cancel',
      value: function cancel() {
        var transformStream = this._transformStream;
        transformStream._readableClosed = true;
        TransformStreamErrorInternal(transformStream, new TypeError('Readable side canceled'));
      }
    }]);

    return TransformStreamSource;
  }();

  var TransformStreamDefaultController = function () {
    function TransformStreamDefaultController(transformStream) {
      _classCallCheck(this, TransformStreamDefaultController);

      if (IsTransformStream(transformStream) === false) {
        throw new TypeError('TransformStreamDefaultController can only be ' + 'constructed with a TransformStream instance');
      }

      if (transformStream._transformStreamController !== undefined) {
        throw new TypeError('TransformStreamDefaultController instances can ' + 'only be created by the TransformStream constructor');
      }

      this._controlledTransformStream = transformStream;
    }

    _createClass(TransformStreamDefaultController, [{
      key: 'enqueue',
      value: function enqueue(chunk) {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('enqueue');
        }

        TransformStreamEnqueueToReadable(this._controlledTransformStream, chunk);
      }
    }, {
      key: 'close',
      value: function close() {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('close');
        }

        TransformStreamCloseReadable(this._controlledTransformStream);
      }
    }, {
      key: 'error',
      value: function error(reason) {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('error');
        }

        TransformStreamError(this._controlledTransformStream, reason);
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('desiredSize');
        }

        var transformStream = this._controlledTransformStream;
        var readableController = transformStream._readableController;
        return ReadableStreamDefaultControllerGetDesiredSize(readableController);
      }
    }]);

    return TransformStreamDefaultController;
  }();

  var TransformStream = function () {
    function TransformStream() {
      var transformer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _classCallCheck(this, TransformStream);

      this._transformer = transformer;
      var readableStrategy = transformer.readableStrategy,
          writableStrategy = transformer.writableStrategy;
      this._transforming = false;
      this._errored = false;
      this._storedError = undefined;
      this._writableController = undefined;
      this._readableController = undefined;
      this._transformStreamController = undefined;
      this._writableDone = false;
      this._readableClosed = false;
      this._backpressure = undefined;
      this._backpressureChangePromise = undefined;
      this._backpressureChangePromise_resolve = undefined;
      this._transformStreamController = new TransformStreamDefaultController(this);
      var startPromise_resolve = void 0;
      var startPromise = new Promise(function (resolve) {
        startPromise_resolve = resolve;
      });
      var source = new TransformStreamSource(this, startPromise);
      this._readable = new ReadableStream(source, readableStrategy);
      var sink = new TransformStreamSink(this, startPromise);
      this._writable = new WritableStream(sink, writableStrategy);
      assert(this._writableController !== undefined);
      assert(this._readableController !== undefined);
      var desiredSize = ReadableStreamDefaultControllerGetDesiredSize(this._readableController);
      TransformStreamSetBackpressure(this, desiredSize <= 0);
      var transformStream = this;
      var startResult = InvokeOrNoop(transformer, 'start', [transformStream._transformStreamController]);
      startPromise_resolve(startResult);
      startPromise.catch(function (e) {
        if (transformStream._errored === false) {
          transformStream._errored = true;
          transformStream._storedError = e;
        }
      });
    }

    _createClass(TransformStream, [{
      key: 'readable',
      get: function get() {
        if (IsTransformStream(this) === false) {
          throw streamBrandCheckException('readable');
        }

        return this._readable;
      }
    }, {
      key: 'writable',
      get: function get() {
        if (IsTransformStream(this) === false) {
          throw streamBrandCheckException('writable');
        }

        return this._writable;
      }
    }]);

    return TransformStream;
  }();

  module.exports = {
    TransformStream: TransformStream
  };

  function defaultControllerBrandCheckException(name) {
    return new TypeError('TransformStreamDefaultController.prototype.' + name + ' can only be used on a TransformStreamDefaultController');
  }

  function streamBrandCheckException(name) {
    return new TypeError('TransformStream.prototype.' + name + ' can only be used on a TransformStream');
  }
}, function (module, exports, __w_pdfjs_require__) {
  module.exports = __w_pdfjs_require__(5);
}]));

/***/ }),
/* 144 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

{
  var isURLSupported = false;

  try {
    if (typeof URL === 'function' && _typeof(URL.prototype) === 'object' && 'origin' in URL.prototype) {
      var u = new URL('b', 'http://a');
      u.pathname = 'c%20d';
      isURLSupported = u.href === 'http://a/c%20d';
    }
  } catch (ex) {}

  if (isURLSupported) {
    exports.URL = URL;
  } else {
    var PolyfillURL = __w_pdfjs_require__(145).URL;

    var OriginalURL = __w_pdfjs_require__(3).URL;

    if (OriginalURL) {
      PolyfillURL.createObjectURL = function (blob) {
        return OriginalURL.createObjectURL.apply(OriginalURL, arguments);
      };

      PolyfillURL.revokeObjectURL = function (url) {
        OriginalURL.revokeObjectURL(url);
      };
    }

    exports.URL = PolyfillURL;
  }
}

/***/ }),
/* 145 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


(function URLConstructorClosure() {
  'use strict';

  var relative = Object.create(null);
  relative['ftp'] = 21;
  relative['file'] = 0;
  relative['gopher'] = 70;
  relative['http'] = 80;
  relative['https'] = 443;
  relative['ws'] = 80;
  relative['wss'] = 443;
  var relativePathDotMapping = Object.create(null);
  relativePathDotMapping['%2e'] = '.';
  relativePathDotMapping['.%2e'] = '..';
  relativePathDotMapping['%2e.'] = '..';
  relativePathDotMapping['%2e%2e'] = '..';

  function isRelativeScheme(scheme) {
    return relative[scheme] !== undefined;
  }

  function invalid() {
    clear.call(this);
    this._isInvalid = true;
  }

  function IDNAToASCII(h) {
    if (h === '') {
      invalid.call(this);
    }

    return h.toLowerCase();
  }

  function percentEscape(c) {
    var unicode = c.charCodeAt(0);

    if (unicode > 0x20 && unicode < 0x7F && [0x22, 0x23, 0x3C, 0x3E, 0x3F, 0x60].indexOf(unicode) === -1) {
      return c;
    }

    return encodeURIComponent(c);
  }

  function percentEscapeQuery(c) {
    var unicode = c.charCodeAt(0);

    if (unicode > 0x20 && unicode < 0x7F && [0x22, 0x23, 0x3C, 0x3E, 0x60].indexOf(unicode) === -1) {
      return c;
    }

    return encodeURIComponent(c);
  }

  var EOF,
      ALPHA = /[a-zA-Z]/,
      ALPHANUMERIC = /[a-zA-Z0-9\+\-\.]/;

  function parse(input, stateOverride, base) {
    function err(message) {
      errors.push(message);
    }

    var state = stateOverride || 'scheme start',
        cursor = 0,
        buffer = '',
        seenAt = false,
        seenBracket = false,
        errors = [];

    loop: while ((input[cursor - 1] !== EOF || cursor === 0) && !this._isInvalid) {
      var c = input[cursor];

      switch (state) {
        case 'scheme start':
          if (c && ALPHA.test(c)) {
            buffer += c.toLowerCase();
            state = 'scheme';
          } else if (!stateOverride) {
            buffer = '';
            state = 'no scheme';
            continue;
          } else {
            err('Invalid scheme.');
            break loop;
          }

          break;

        case 'scheme':
          if (c && ALPHANUMERIC.test(c)) {
            buffer += c.toLowerCase();
          } else if (c === ':') {
            this._scheme = buffer;
            buffer = '';

            if (stateOverride) {
              break loop;
            }

            if (isRelativeScheme(this._scheme)) {
              this._isRelative = true;
            }

            if (this._scheme === 'file') {
              state = 'relative';
            } else if (this._isRelative && base && base._scheme === this._scheme) {
              state = 'relative or authority';
            } else if (this._isRelative) {
              state = 'authority first slash';
            } else {
              state = 'scheme data';
            }
          } else if (!stateOverride) {
            buffer = '';
            cursor = 0;
            state = 'no scheme';
            continue;
          } else if (c === EOF) {
            break loop;
          } else {
            err('Code point not allowed in scheme: ' + c);
            break loop;
          }

          break;

        case 'scheme data':
          if (c === '?') {
            this._query = '?';
            state = 'query';
          } else if (c === '#') {
            this._fragment = '#';
            state = 'fragment';
          } else {
            if (c !== EOF && c !== '\t' && c !== '\n' && c !== '\r') {
              this._schemeData += percentEscape(c);
            }
          }

          break;

        case 'no scheme':
          if (!base || !isRelativeScheme(base._scheme)) {
            err('Missing scheme.');
            invalid.call(this);
          } else {
            state = 'relative';
            continue;
          }

          break;

        case 'relative or authority':
          if (c === '/' && input[cursor + 1] === '/') {
            state = 'authority ignore slashes';
          } else {
            err('Expected /, got: ' + c);
            state = 'relative';
            continue;
          }

          break;

        case 'relative':
          this._isRelative = true;

          if (this._scheme !== 'file') {
            this._scheme = base._scheme;
          }

          if (c === EOF) {
            this._host = base._host;
            this._port = base._port;
            this._path = base._path.slice();
            this._query = base._query;
            this._username = base._username;
            this._password = base._password;
            break loop;
          } else if (c === '/' || c === '\\') {
            if (c === '\\') {
              err('\\ is an invalid code point.');
            }

            state = 'relative slash';
          } else if (c === '?') {
            this._host = base._host;
            this._port = base._port;
            this._path = base._path.slice();
            this._query = '?';
            this._username = base._username;
            this._password = base._password;
            state = 'query';
          } else if (c === '#') {
            this._host = base._host;
            this._port = base._port;
            this._path = base._path.slice();
            this._query = base._query;
            this._fragment = '#';
            this._username = base._username;
            this._password = base._password;
            state = 'fragment';
          } else {
            var nextC = input[cursor + 1];
            var nextNextC = input[cursor + 2];

            if (this._scheme !== 'file' || !ALPHA.test(c) || nextC !== ':' && nextC !== '|' || nextNextC !== EOF && nextNextC !== '/' && nextNextC !== '\\' && nextNextC !== '?' && nextNextC !== '#') {
              this._host = base._host;
              this._port = base._port;
              this._username = base._username;
              this._password = base._password;
              this._path = base._path.slice();

              this._path.pop();
            }

            state = 'relative path';
            continue;
          }

          break;

        case 'relative slash':
          if (c === '/' || c === '\\') {
            if (c === '\\') {
              err('\\ is an invalid code point.');
            }

            if (this._scheme === 'file') {
              state = 'file host';
            } else {
              state = 'authority ignore slashes';
            }
          } else {
            if (this._scheme !== 'file') {
              this._host = base._host;
              this._port = base._port;
              this._username = base._username;
              this._password = base._password;
            }

            state = 'relative path';
            continue;
          }

          break;

        case 'authority first slash':
          if (c === '/') {
            state = 'authority second slash';
          } else {
            err('Expected \'/\', got: ' + c);
            state = 'authority ignore slashes';
            continue;
          }

          break;

        case 'authority second slash':
          state = 'authority ignore slashes';

          if (c !== '/') {
            err('Expected \'/\', got: ' + c);
            continue;
          }

          break;

        case 'authority ignore slashes':
          if (c !== '/' && c !== '\\') {
            state = 'authority';
            continue;
          } else {
            err('Expected authority, got: ' + c);
          }

          break;

        case 'authority':
          if (c === '@') {
            if (seenAt) {
              err('@ already seen.');
              buffer += '%40';
            }

            seenAt = true;

            for (var i = 0; i < buffer.length; i++) {
              var cp = buffer[i];

              if (cp === '\t' || cp === '\n' || cp === '\r') {
                err('Invalid whitespace in authority.');
                continue;
              }

              if (cp === ':' && this._password === null) {
                this._password = '';
                continue;
              }

              var tempC = percentEscape(cp);

              if (this._password !== null) {
                this._password += tempC;
              } else {
                this._username += tempC;
              }
            }

            buffer = '';
          } else if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#') {
            cursor -= buffer.length;
            buffer = '';
            state = 'host';
            continue;
          } else {
            buffer += c;
          }

          break;

        case 'file host':
          if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#') {
            if (buffer.length === 2 && ALPHA.test(buffer[0]) && (buffer[1] === ':' || buffer[1] === '|')) {
              state = 'relative path';
            } else if (buffer.length === 0) {
              state = 'relative path start';
            } else {
              this._host = IDNAToASCII.call(this, buffer);
              buffer = '';
              state = 'relative path start';
            }

            continue;
          } else if (c === '\t' || c === '\n' || c === '\r') {
            err('Invalid whitespace in file host.');
          } else {
            buffer += c;
          }

          break;

        case 'host':
        case 'hostname':
          if (c === ':' && !seenBracket) {
            this._host = IDNAToASCII.call(this, buffer);
            buffer = '';
            state = 'port';

            if (stateOverride === 'hostname') {
              break loop;
            }
          } else if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#') {
            this._host = IDNAToASCII.call(this, buffer);
            buffer = '';
            state = 'relative path start';

            if (stateOverride) {
              break loop;
            }

            continue;
          } else if (c !== '\t' && c !== '\n' && c !== '\r') {
            if (c === '[') {
              seenBracket = true;
            } else if (c === ']') {
              seenBracket = false;
            }

            buffer += c;
          } else {
            err('Invalid code point in host/hostname: ' + c);
          }

          break;

        case 'port':
          if (/[0-9]/.test(c)) {
            buffer += c;
          } else if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#' || stateOverride) {
            if (buffer !== '') {
              var temp = parseInt(buffer, 10);

              if (temp !== relative[this._scheme]) {
                this._port = temp + '';
              }

              buffer = '';
            }

            if (stateOverride) {
              break loop;
            }

            state = 'relative path start';
            continue;
          } else if (c === '\t' || c === '\n' || c === '\r') {
            err('Invalid code point in port: ' + c);
          } else {
            invalid.call(this);
          }

          break;

        case 'relative path start':
          if (c === '\\') {
            err('\'\\\' not allowed in path.');
          }

          state = 'relative path';

          if (c !== '/' && c !== '\\') {
            continue;
          }

          break;

        case 'relative path':
          if (c === EOF || c === '/' || c === '\\' || !stateOverride && (c === '?' || c === '#')) {
            if (c === '\\') {
              err('\\ not allowed in relative path.');
            }

            var tmp;

            if (tmp = relativePathDotMapping[buffer.toLowerCase()]) {
              buffer = tmp;
            }

            if (buffer === '..') {
              this._path.pop();

              if (c !== '/' && c !== '\\') {
                this._path.push('');
              }
            } else if (buffer === '.' && c !== '/' && c !== '\\') {
              this._path.push('');
            } else if (buffer !== '.') {
              if (this._scheme === 'file' && this._path.length === 0 && buffer.length === 2 && ALPHA.test(buffer[0]) && buffer[1] === '|') {
                buffer = buffer[0] + ':';
              }

              this._path.push(buffer);
            }

            buffer = '';

            if (c === '?') {
              this._query = '?';
              state = 'query';
            } else if (c === '#') {
              this._fragment = '#';
              state = 'fragment';
            }
          } else if (c !== '\t' && c !== '\n' && c !== '\r') {
            buffer += percentEscape(c);
          }

          break;

        case 'query':
          if (!stateOverride && c === '#') {
            this._fragment = '#';
            state = 'fragment';
          } else if (c !== EOF && c !== '\t' && c !== '\n' && c !== '\r') {
            this._query += percentEscapeQuery(c);
          }

          break;

        case 'fragment':
          if (c !== EOF && c !== '\t' && c !== '\n' && c !== '\r') {
            this._fragment += c;
          }

          break;
      }

      cursor++;
    }
  }

  function clear() {
    this._scheme = '';
    this._schemeData = '';
    this._username = '';
    this._password = null;
    this._host = '';
    this._port = '';
    this._path = [];
    this._query = '';
    this._fragment = '';
    this._isInvalid = false;
    this._isRelative = false;
  }

  function JURL(url, base) {
    if (base !== undefined && !(base instanceof JURL)) {
      base = new JURL(String(base));
    }

    this._url = url;
    clear.call(this);
    var input = url.replace(/^[ \t\r\n\f]+|[ \t\r\n\f]+$/g, '');
    parse.call(this, input, null, base);
  }

  JURL.prototype = {
    toString: function toString() {
      return this.href;
    },

    get href() {
      if (this._isInvalid) {
        return this._url;
      }

      var authority = '';

      if (this._username !== '' || this._password !== null) {
        authority = this._username + (this._password !== null ? ':' + this._password : '') + '@';
      }

      return this.protocol + (this._isRelative ? '//' + authority + this.host : '') + this.pathname + this._query + this._fragment;
    },

    set href(value) {
      clear.call(this);
      parse.call(this, value);
    },

    get protocol() {
      return this._scheme + ':';
    },

    set protocol(value) {
      if (this._isInvalid) {
        return;
      }

      parse.call(this, value + ':', 'scheme start');
    },

    get host() {
      return this._isInvalid ? '' : this._port ? this._host + ':' + this._port : this._host;
    },

    set host(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      parse.call(this, value, 'host');
    },

    get hostname() {
      return this._host;
    },

    set hostname(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      parse.call(this, value, 'hostname');
    },

    get port() {
      return this._port;
    },

    set port(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      parse.call(this, value, 'port');
    },

    get pathname() {
      return this._isInvalid ? '' : this._isRelative ? '/' + this._path.join('/') : this._schemeData;
    },

    set pathname(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      this._path = [];
      parse.call(this, value, 'relative path start');
    },

    get search() {
      return this._isInvalid || !this._query || this._query === '?' ? '' : this._query;
    },

    set search(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      this._query = '?';

      if (value[0] === '?') {
        value = value.slice(1);
      }

      parse.call(this, value, 'query');
    },

    get hash() {
      return this._isInvalid || !this._fragment || this._fragment === '#' ? '' : this._fragment;
    },

    set hash(value) {
      if (this._isInvalid) {
        return;
      }

      this._fragment = '#';

      if (value[0] === '#') {
        value = value.slice(1);
      }

      parse.call(this, value, 'fragment');
    },

    get origin() {
      var host;

      if (this._isInvalid || !this._scheme) {
        return '';
      }

      switch (this._scheme) {
        case 'data':
        case 'file':
        case 'javascript':
        case 'mailto':
          return 'null';

        case 'blob':
          try {
            return new JURL(this._schemeData).origin || 'null';
          } catch (_) {}

          return 'null';
      }

      host = this.host;

      if (!host) {
        return '';
      }

      return this._scheme + '://' + host;
    }

  };
  exports.URL = JURL;
})();

/***/ }),
/* 146 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDocument = getDocument;
exports.setPDFNetworkStreamFactory = setPDFNetworkStreamFactory;
exports.build = exports.version = exports.PDFPageProxy = exports.PDFDocumentProxy = exports.PDFWorker = exports.PDFDataRangeTransport = exports.LoopbackPort = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(147));

var _util = __w_pdfjs_require__(1);

var _dom_utils = __w_pdfjs_require__(151);

var _font_loader = __w_pdfjs_require__(152);

var _api_compatibility = __w_pdfjs_require__(153);

var _canvas = __w_pdfjs_require__(154);

var _global_scope = _interopRequireDefault(__w_pdfjs_require__(3));

var _worker_options = __w_pdfjs_require__(156);

var _message_handler = __w_pdfjs_require__(157);

var _metadata = __w_pdfjs_require__(158);

var _transport_stream = __w_pdfjs_require__(160);

var _webgl = __w_pdfjs_require__(161);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var DEFAULT_RANGE_CHUNK_SIZE = 65536;
var isWorkerDisabled = false;
var fallbackWorkerSrc;
var fakeWorkerFilesLoader = null;
{
  var useRequireEnsure = false;

  if (typeof window === 'undefined') {
    isWorkerDisabled = true;

    if (false) {
      require.ensure = require('node-ensure');
    }

    useRequireEnsure = true;
  } else if (true) {
    useRequireEnsure = true;
  }

  if (typeof requirejs !== 'undefined' && requirejs.toUrl) {
    fallbackWorkerSrc = requirejs.toUrl('pdfjs-dist/build/pdf.worker.js');
  }

  var dynamicLoaderSupported = typeof requirejs !== 'undefined' && requirejs.load;
  fakeWorkerFilesLoader = useRequireEnsure ? function () {
    return new Promise(function (resolve, reject) {
      new Promise(function(resolve) { resolve(); }).then((function () {
        try {
          var worker;
          worker = __webpack_require__(761);
          resolve(worker.WorkerMessageHandler);
        } catch (ex) {
          reject(ex);
        }
      }).bind(null, __webpack_require__)).catch(reject);
    });
  } : dynamicLoaderSupported ? function () {
    return new Promise(function (resolve, reject) {
      requirejs(['pdfjs-dist/build/pdf.worker'], function (worker) {
        try {
          resolve(worker.WorkerMessageHandler);
        } catch (ex) {
          reject(ex);
        }
      }, reject);
    });
  } : null;

  if (!fallbackWorkerSrc && (typeof document === "undefined" ? "undefined" : _typeof(document)) === 'object' && 'currentScript' in document) {
    var pdfjsFilePath = document.currentScript && document.currentScript.src;

    if (pdfjsFilePath) {
      fallbackWorkerSrc = pdfjsFilePath.replace(/(\.(?:min\.)?js)(\?.*)?$/i, '.worker$1$2');
    }
  }
}
var createPDFNetworkStream;

function setPDFNetworkStreamFactory(pdfNetworkStreamFactory) {
  createPDFNetworkStream = pdfNetworkStreamFactory;
}

function getDocument(src) {
  var task = new PDFDocumentLoadingTask();
  var source;

  if (typeof src === 'string') {
    source = {
      url: src
    };
  } else if ((0, _util.isArrayBuffer)(src)) {
    source = {
      data: src
    };
  } else if (src instanceof PDFDataRangeTransport) {
    source = {
      range: src
    };
  } else {
    if (_typeof(src) !== 'object') {
      throw new Error('Invalid parameter in getDocument, ' + 'need either Uint8Array, string or a parameter object');
    }

    if (!src.url && !src.data && !src.range) {
      throw new Error('Invalid parameter object: need either .data, .range or .url');
    }

    source = src;
  }

  var params = Object.create(null);
  var rangeTransport = null,
      worker = null;

  for (var key in source) {
    if (key === 'url' && typeof window !== 'undefined') {
      params[key] = new _util.URL(source[key], window.location).href;
      continue;
    } else if (key === 'range') {
      rangeTransport = source[key];
      continue;
    } else if (key === 'worker') {
      worker = source[key];
      continue;
    } else if (key === 'data' && !(source[key] instanceof Uint8Array)) {
      var pdfBytes = source[key];

      if (typeof pdfBytes === 'string') {
        params[key] = (0, _util.stringToBytes)(pdfBytes);
      } else if (_typeof(pdfBytes) === 'object' && pdfBytes !== null && !isNaN(pdfBytes.length)) {
        params[key] = new Uint8Array(pdfBytes);
      } else if ((0, _util.isArrayBuffer)(pdfBytes)) {
        params[key] = new Uint8Array(pdfBytes);
      } else {
        throw new Error('Invalid PDF binary data: either typed array, ' + 'string or array-like object is expected in the ' + 'data property.');
      }

      continue;
    }

    params[key] = source[key];
  }

  params.rangeChunkSize = params.rangeChunkSize || DEFAULT_RANGE_CHUNK_SIZE;
  params.CMapReaderFactory = params.CMapReaderFactory || _dom_utils.DOMCMapReaderFactory;
  params.ignoreErrors = params.stopAtErrors !== true;
  params.pdfBug = params.pdfBug === true;
  var NativeImageDecoderValues = Object.values(_util.NativeImageDecoding);

  if (params.nativeImageDecoderSupport === undefined || !NativeImageDecoderValues.includes(params.nativeImageDecoderSupport)) {
    params.nativeImageDecoderSupport = _api_compatibility.apiCompatibilityParams.nativeImageDecoderSupport || _util.NativeImageDecoding.DECODE;
  }

  if (!Number.isInteger(params.maxImageSize)) {
    params.maxImageSize = -1;
  }

  if (typeof params.isEvalSupported !== 'boolean') {
    params.isEvalSupported = true;
  }

  if (typeof params.disableFontFace !== 'boolean') {
    params.disableFontFace = _api_compatibility.apiCompatibilityParams.disableFontFace || false;
  }

  if (typeof params.disableRange !== 'boolean') {
    params.disableRange = false;
  }

  if (typeof params.disableStream !== 'boolean') {
    params.disableStream = false;
  }

  if (typeof params.disableAutoFetch !== 'boolean') {
    params.disableAutoFetch = false;
  }

  if (typeof params.disableCreateObjectURL !== 'boolean') {
    params.disableCreateObjectURL = _api_compatibility.apiCompatibilityParams.disableCreateObjectURL || false;
  }

  (0, _util.setVerbosityLevel)(params.verbosity);

  if (!worker) {
    var workerParams = {
      postMessageTransfers: params.postMessageTransfers,
      verbosity: params.verbosity,
      port: _worker_options.GlobalWorkerOptions.workerPort
    };
    worker = workerParams.port ? PDFWorker.fromPort(workerParams) : new PDFWorker(workerParams);
    task._worker = worker;
  }

  var docId = task.docId;
  worker.promise.then(function () {
    if (task.destroyed) {
      throw new Error('Loading aborted');
    }

    return _fetchDocument(worker, params, rangeTransport, docId).then(function (workerId) {
      if (task.destroyed) {
        throw new Error('Loading aborted');
      }

      var networkStream;

      if (rangeTransport) {
        networkStream = new _transport_stream.PDFDataTransportStream({
          length: params.length,
          initialData: params.initialData,
          disableRange: params.disableRange,
          disableStream: params.disableStream
        }, rangeTransport);
      } else if (!params.data) {
        networkStream = createPDFNetworkStream({
          url: params.url,
          length: params.length,
          httpHeaders: params.httpHeaders,
          withCredentials: params.withCredentials,
          rangeChunkSize: params.rangeChunkSize,
          disableRange: params.disableRange,
          disableStream: params.disableStream
        });
      }

      var messageHandler = new _message_handler.MessageHandler(docId, workerId, worker.port);
      messageHandler.postMessageTransfers = worker.postMessageTransfers;
      var transport = new WorkerTransport(messageHandler, task, networkStream, params);
      task._transport = transport;
      messageHandler.send('Ready', null);
    });
  }).catch(task._capability.reject);
  return task;
}

function _fetchDocument(worker, source, pdfDataRangeTransport, docId) {
  if (worker.destroyed) {
    return Promise.reject(new Error('Worker was destroyed'));
  }

  if (pdfDataRangeTransport) {
    source.length = pdfDataRangeTransport.length;
    source.initialData = pdfDataRangeTransport.initialData;
  }

  return worker.messageHandler.sendWithPromise('GetDocRequest', {
    docId: docId,
    apiVersion: '2.1.266',
    source: {
      data: source.data,
      url: source.url,
      password: source.password,
      disableAutoFetch: source.disableAutoFetch,
      rangeChunkSize: source.rangeChunkSize,
      length: source.length
    },
    maxImageSize: source.maxImageSize,
    disableFontFace: source.disableFontFace,
    disableCreateObjectURL: source.disableCreateObjectURL,
    postMessageTransfers: worker.postMessageTransfers,
    docBaseUrl: source.docBaseUrl,
    nativeImageDecoderSupport: source.nativeImageDecoderSupport,
    ignoreErrors: source.ignoreErrors,
    isEvalSupported: source.isEvalSupported
  }).then(function (workerId) {
    if (worker.destroyed) {
      throw new Error('Worker was destroyed');
    }

    return workerId;
  });
}

var PDFDocumentLoadingTask = function PDFDocumentLoadingTaskClosure() {
  var nextDocumentId = 0;

  var PDFDocumentLoadingTask =
  /*#__PURE__*/
  function () {
    function PDFDocumentLoadingTask() {
      _classCallCheck(this, PDFDocumentLoadingTask);

      this._capability = (0, _util.createPromiseCapability)();
      this._transport = null;
      this._worker = null;
      this.docId = 'd' + nextDocumentId++;
      this.destroyed = false;
      this.onPassword = null;
      this.onProgress = null;
      this.onUnsupportedFeature = null;
    }

    _createClass(PDFDocumentLoadingTask, [{
      key: "destroy",
      value: function destroy() {
        var _this = this;

        this.destroyed = true;
        var transportDestroyed = !this._transport ? Promise.resolve() : this._transport.destroy();
        return transportDestroyed.then(function () {
          _this._transport = null;

          if (_this._worker) {
            _this._worker.destroy();

            _this._worker = null;
          }
        });
      }
    }, {
      key: "then",
      value: function then(onFulfilled, onRejected) {
        (0, _util.deprecated)('PDFDocumentLoadingTask.then method, ' + 'use the `promise` getter instead.');
        return this.promise.then.apply(this.promise, arguments);
      }
    }, {
      key: "promise",
      get: function get() {
        return this._capability.promise;
      }
    }]);

    return PDFDocumentLoadingTask;
  }();

  return PDFDocumentLoadingTask;
}();

var PDFDataRangeTransport =
/*#__PURE__*/
function () {
  function PDFDataRangeTransport(length, initialData) {
    _classCallCheck(this, PDFDataRangeTransport);

    this.length = length;
    this.initialData = initialData;
    this._rangeListeners = [];
    this._progressListeners = [];
    this._progressiveReadListeners = [];
    this._readyCapability = (0, _util.createPromiseCapability)();
  }

  _createClass(PDFDataRangeTransport, [{
    key: "addRangeListener",
    value: function addRangeListener(listener) {
      this._rangeListeners.push(listener);
    }
  }, {
    key: "addProgressListener",
    value: function addProgressListener(listener) {
      this._progressListeners.push(listener);
    }
  }, {
    key: "addProgressiveReadListener",
    value: function addProgressiveReadListener(listener) {
      this._progressiveReadListeners.push(listener);
    }
  }, {
    key: "onDataRange",
    value: function onDataRange(begin, chunk) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this._rangeListeners[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var listener = _step.value;
          listener(begin, chunk);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: "onDataProgress",
    value: function onDataProgress(loaded) {
      var _this2 = this;

      this._readyCapability.promise.then(function () {
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = _this2._progressListeners[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var listener = _step2.value;
            listener(loaded);
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }
      });
    }
  }, {
    key: "onDataProgressiveRead",
    value: function onDataProgressiveRead(chunk) {
      var _this3 = this;

      this._readyCapability.promise.then(function () {
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = _this3._progressiveReadListeners[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var listener = _step3.value;
            listener(chunk);
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      });
    }
  }, {
    key: "transportReady",
    value: function transportReady() {
      this._readyCapability.resolve();
    }
  }, {
    key: "requestDataRange",
    value: function requestDataRange(begin, end) {
      (0, _util.unreachable)('Abstract method PDFDataRangeTransport.requestDataRange');
    }
  }, {
    key: "abort",
    value: function abort() {}
  }]);

  return PDFDataRangeTransport;
}();

exports.PDFDataRangeTransport = PDFDataRangeTransport;

var PDFDocumentProxy =
/*#__PURE__*/
function () {
  function PDFDocumentProxy(pdfInfo, transport, loadingTask) {
    _classCallCheck(this, PDFDocumentProxy);

    this.loadingTask = loadingTask;
    this._pdfInfo = pdfInfo;
    this._transport = transport;
  }

  _createClass(PDFDocumentProxy, [{
    key: "getPage",
    value: function getPage(pageNumber) {
      return this._transport.getPage(pageNumber);
    }
  }, {
    key: "getPageIndex",
    value: function getPageIndex(ref) {
      return this._transport.getPageIndex(ref);
    }
  }, {
    key: "getDestinations",
    value: function getDestinations() {
      return this._transport.getDestinations();
    }
  }, {
    key: "getDestination",
    value: function getDestination(id) {
      return this._transport.getDestination(id);
    }
  }, {
    key: "getPageLabels",
    value: function getPageLabels() {
      return this._transport.getPageLabels();
    }
  }, {
    key: "getPageMode",
    value: function getPageMode() {
      return this._transport.getPageMode();
    }
  }, {
    key: "getOpenActionDestination",
    value: function getOpenActionDestination() {
      return this._transport.getOpenActionDestination();
    }
  }, {
    key: "getAttachments",
    value: function getAttachments() {
      return this._transport.getAttachments();
    }
  }, {
    key: "getJavaScript",
    value: function getJavaScript() {
      return this._transport.getJavaScript();
    }
  }, {
    key: "getOutline",
    value: function getOutline() {
      return this._transport.getOutline();
    }
  }, {
    key: "getPermissions",
    value: function getPermissions() {
      return this._transport.getPermissions();
    }
  }, {
    key: "getMetadata",
    value: function getMetadata() {
      return this._transport.getMetadata();
    }
  }, {
    key: "getData",
    value: function getData() {
      return this._transport.getData();
    }
  }, {
    key: "getDownloadInfo",
    value: function getDownloadInfo() {
      return this._transport.downloadInfoCapability.promise;
    }
  }, {
    key: "getStats",
    value: function getStats() {
      return this._transport.getStats();
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      this._transport.startCleanup();
    }
  }, {
    key: "destroy",
    value: function destroy() {
      return this.loadingTask.destroy();
    }
  }, {
    key: "numPages",
    get: function get() {
      return this._pdfInfo.numPages;
    }
  }, {
    key: "fingerprint",
    get: function get() {
      return this._pdfInfo.fingerprint;
    }
  }, {
    key: "loadingParams",
    get: function get() {
      return this._transport.loadingParams;
    }
  }]);

  return PDFDocumentProxy;
}();

exports.PDFDocumentProxy = PDFDocumentProxy;

var PDFPageProxy =
/*#__PURE__*/
function () {
  function PDFPageProxy(pageIndex, pageInfo, transport) {
    var pdfBug = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

    _classCallCheck(this, PDFPageProxy);

    this.pageIndex = pageIndex;
    this._pageInfo = pageInfo;
    this._transport = transport;
    this._stats = pdfBug ? new _dom_utils.StatTimer() : _dom_utils.DummyStatTimer;
    this._pdfBug = pdfBug;
    this.commonObjs = transport.commonObjs;
    this.objs = new PDFObjects();
    this.cleanupAfterRender = false;
    this.pendingCleanup = false;
    this.intentStates = Object.create(null);
    this.destroyed = false;
  }

  _createClass(PDFPageProxy, [{
    key: "getViewport",
    value: function getViewport() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          scale = _ref.scale,
          _ref$rotation = _ref.rotation,
          rotation = _ref$rotation === void 0 ? this.rotate : _ref$rotation,
          _ref$dontFlip = _ref.dontFlip,
          dontFlip = _ref$dontFlip === void 0 ? false : _ref$dontFlip;

      if (arguments.length > 1 || typeof arguments[0] === 'number') {
        (0, _util.deprecated)('getViewport is called with obsolete arguments.');
        scale = arguments[0];
        rotation = typeof arguments[1] === 'number' ? arguments[1] : this.rotate;
        dontFlip = typeof arguments[2] === 'boolean' ? arguments[2] : false;
      }

      return new _dom_utils.PageViewport({
        viewBox: this.view,
        scale: scale,
        rotation: rotation,
        dontFlip: dontFlip
      });
    }
  }, {
    key: "getAnnotations",
    value: function getAnnotations() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref2$intent = _ref2.intent,
          intent = _ref2$intent === void 0 ? null : _ref2$intent;

      if (!this.annotationsPromise || this.annotationsIntent !== intent) {
        this.annotationsPromise = this._transport.getAnnotations(this.pageIndex, intent);
        this.annotationsIntent = intent;
      }

      return this.annotationsPromise;
    }
  }, {
    key: "render",
    value: function render(_ref3) {
      var _this4 = this;

      var canvasContext = _ref3.canvasContext,
          viewport = _ref3.viewport,
          _ref3$intent = _ref3.intent,
          intent = _ref3$intent === void 0 ? 'display' : _ref3$intent,
          _ref3$enableWebGL = _ref3.enableWebGL,
          enableWebGL = _ref3$enableWebGL === void 0 ? false : _ref3$enableWebGL,
          _ref3$renderInteracti = _ref3.renderInteractiveForms,
          renderInteractiveForms = _ref3$renderInteracti === void 0 ? false : _ref3$renderInteracti,
          _ref3$transform = _ref3.transform,
          transform = _ref3$transform === void 0 ? null : _ref3$transform,
          _ref3$imageLayer = _ref3.imageLayer,
          imageLayer = _ref3$imageLayer === void 0 ? null : _ref3$imageLayer,
          _ref3$canvasFactory = _ref3.canvasFactory,
          canvasFactory = _ref3$canvasFactory === void 0 ? null : _ref3$canvasFactory,
          _ref3$background = _ref3.background,
          background = _ref3$background === void 0 ? null : _ref3$background;
      var stats = this._stats;
      stats.time('Overall');
      this.pendingCleanup = false;
      var renderingIntent = intent === 'print' ? 'print' : 'display';
      var canvasFactoryInstance = canvasFactory || new _dom_utils.DOMCanvasFactory();
      var webGLContext = new _webgl.WebGLContext({
        enable: enableWebGL
      });

      if (!this.intentStates[renderingIntent]) {
        this.intentStates[renderingIntent] = Object.create(null);
      }

      var intentState = this.intentStates[renderingIntent];

      if (!intentState.displayReadyCapability) {
        intentState.receivingOperatorList = true;
        intentState.displayReadyCapability = (0, _util.createPromiseCapability)();
        intentState.operatorList = {
          fnArray: [],
          argsArray: [],
          lastChunk: false
        };
        stats.time('Page Request');

        this._transport.messageHandler.send('RenderPageRequest', {
          pageIndex: this.pageNumber - 1,
          intent: renderingIntent,
          renderInteractiveForms: renderInteractiveForms === true
        });
      }

      var complete = function complete(error) {
        var i = intentState.renderTasks.indexOf(internalRenderTask);

        if (i >= 0) {
          intentState.renderTasks.splice(i, 1);
        }

        if (_this4.cleanupAfterRender) {
          _this4.pendingCleanup = true;
        }

        _this4._tryCleanup();

        if (error) {
          internalRenderTask.capability.reject(error);
        } else {
          internalRenderTask.capability.resolve();
        }

        stats.timeEnd('Rendering');
        stats.timeEnd('Overall');
      };

      var internalRenderTask = new InternalRenderTask({
        callback: complete,
        params: {
          canvasContext: canvasContext,
          viewport: viewport,
          transform: transform,
          imageLayer: imageLayer,
          background: background
        },
        objs: this.objs,
        commonObjs: this.commonObjs,
        operatorList: intentState.operatorList,
        pageNumber: this.pageNumber,
        canvasFactory: canvasFactoryInstance,
        webGLContext: webGLContext,
        useRequestAnimationFrame: renderingIntent !== 'print',
        pdfBug: this._pdfBug
      });

      if (!intentState.renderTasks) {
        intentState.renderTasks = [];
      }

      intentState.renderTasks.push(internalRenderTask);
      var renderTask = internalRenderTask.task;
      intentState.displayReadyCapability.promise.then(function (transparency) {
        if (_this4.pendingCleanup) {
          complete();
          return;
        }

        stats.time('Rendering');
        internalRenderTask.initializeGraphics(transparency);
        internalRenderTask.operatorListChanged();
      }).catch(complete);
      return renderTask;
    }
  }, {
    key: "getOperatorList",
    value: function getOperatorList() {
      function operatorListChanged() {
        if (intentState.operatorList.lastChunk) {
          intentState.opListReadCapability.resolve(intentState.operatorList);
          var i = intentState.renderTasks.indexOf(opListTask);

          if (i >= 0) {
            intentState.renderTasks.splice(i, 1);
          }
        }
      }

      var renderingIntent = 'oplist';

      if (!this.intentStates[renderingIntent]) {
        this.intentStates[renderingIntent] = Object.create(null);
      }

      var intentState = this.intentStates[renderingIntent];
      var opListTask;

      if (!intentState.opListReadCapability) {
        opListTask = {};
        opListTask.operatorListChanged = operatorListChanged;
        intentState.receivingOperatorList = true;
        intentState.opListReadCapability = (0, _util.createPromiseCapability)();
        intentState.renderTasks = [];
        intentState.renderTasks.push(opListTask);
        intentState.operatorList = {
          fnArray: [],
          argsArray: [],
          lastChunk: false
        };

        this._stats.time('Page Request');

        this._transport.messageHandler.send('RenderPageRequest', {
          pageIndex: this.pageIndex,
          intent: renderingIntent
        });
      }

      return intentState.opListReadCapability.promise;
    }
  }, {
    key: "streamTextContent",
    value: function streamTextContent() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref4$normalizeWhites = _ref4.normalizeWhitespace,
          normalizeWhitespace = _ref4$normalizeWhites === void 0 ? false : _ref4$normalizeWhites,
          _ref4$disableCombineT = _ref4.disableCombineTextItems,
          disableCombineTextItems = _ref4$disableCombineT === void 0 ? false : _ref4$disableCombineT;

      var TEXT_CONTENT_CHUNK_SIZE = 100;
      return this._transport.messageHandler.sendWithStream('GetTextContent', {
        pageIndex: this.pageNumber - 1,
        normalizeWhitespace: normalizeWhitespace === true,
        combineTextItems: disableCombineTextItems !== true
      }, {
        highWaterMark: TEXT_CONTENT_CHUNK_SIZE,
        size: function size(textContent) {
          return textContent.items.length;
        }
      });
    }
  }, {
    key: "getTextContent",
    value: function getTextContent() {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var readableStream = this.streamTextContent(params);
      return new Promise(function (resolve, reject) {
        function pump() {
          reader.read().then(function (_ref5) {
            var _textContent$items;

            var value = _ref5.value,
                done = _ref5.done;

            if (done) {
              resolve(textContent);
              return;
            }

            Object.assign(textContent.styles, value.styles);

            (_textContent$items = textContent.items).push.apply(_textContent$items, _toConsumableArray(value.items));

            pump();
          }, reject);
        }

        var reader = readableStream.getReader();
        var textContent = {
          items: [],
          styles: Object.create(null)
        };
        pump();
      });
    }
  }, {
    key: "_destroy",
    value: function _destroy() {
      this.destroyed = true;
      this._transport.pageCache[this.pageIndex] = null;
      var waitOn = [];
      Object.keys(this.intentStates).forEach(function (intent) {
        if (intent === 'oplist') {
          return;
        }

        var intentState = this.intentStates[intent];
        intentState.renderTasks.forEach(function (renderTask) {
          var renderCompleted = renderTask.capability.promise.catch(function () {});
          waitOn.push(renderCompleted);
          renderTask.cancel();
        });
      }, this);
      this.objs.clear();
      this.annotationsPromise = null;
      this.pendingCleanup = false;
      return Promise.all(waitOn);
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      var resetStats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.pendingCleanup = true;

      this._tryCleanup(resetStats);
    }
  }, {
    key: "_tryCleanup",
    value: function _tryCleanup() {
      var resetStats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!this.pendingCleanup || Object.keys(this.intentStates).some(function (intent) {
        var intentState = this.intentStates[intent];
        return intentState.renderTasks.length !== 0 || intentState.receivingOperatorList;
      }, this)) {
        return;
      }

      Object.keys(this.intentStates).forEach(function (intent) {
        delete this.intentStates[intent];
      }, this);
      this.objs.clear();
      this.annotationsPromise = null;

      if (resetStats && this._stats instanceof _dom_utils.StatTimer) {
        this._stats = new _dom_utils.StatTimer();
      }

      this.pendingCleanup = false;
    }
  }, {
    key: "_startRenderPage",
    value: function _startRenderPage(transparency, intent) {
      var intentState = this.intentStates[intent];

      if (intentState.displayReadyCapability) {
        intentState.displayReadyCapability.resolve(transparency);
      }
    }
  }, {
    key: "_renderPageChunk",
    value: function _renderPageChunk(operatorListChunk, intent) {
      var intentState = this.intentStates[intent];

      for (var i = 0, ii = operatorListChunk.length; i < ii; i++) {
        intentState.operatorList.fnArray.push(operatorListChunk.fnArray[i]);
        intentState.operatorList.argsArray.push(operatorListChunk.argsArray[i]);
      }

      intentState.operatorList.lastChunk = operatorListChunk.lastChunk;

      for (var _i = 0; _i < intentState.renderTasks.length; _i++) {
        intentState.renderTasks[_i].operatorListChanged();
      }

      if (operatorListChunk.lastChunk) {
        intentState.receivingOperatorList = false;

        this._tryCleanup();
      }
    }
  }, {
    key: "pageNumber",
    get: function get() {
      return this.pageIndex + 1;
    }
  }, {
    key: "rotate",
    get: function get() {
      return this._pageInfo.rotate;
    }
  }, {
    key: "ref",
    get: function get() {
      return this._pageInfo.ref;
    }
  }, {
    key: "userUnit",
    get: function get() {
      return this._pageInfo.userUnit;
    }
  }, {
    key: "view",
    get: function get() {
      return this._pageInfo.view;
    }
  }, {
    key: "stats",
    get: function get() {
      return this._stats instanceof _dom_utils.StatTimer ? this._stats : null;
    }
  }]);

  return PDFPageProxy;
}();

exports.PDFPageProxy = PDFPageProxy;

var LoopbackPort =
/*#__PURE__*/
function () {
  function LoopbackPort() {
    var defer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

    _classCallCheck(this, LoopbackPort);

    this._listeners = [];
    this._defer = defer;
    this._deferred = Promise.resolve(undefined);
  }

  _createClass(LoopbackPort, [{
    key: "postMessage",
    value: function postMessage(obj, transfers) {
      var _this5 = this;

      function cloneValue(value) {
        if (_typeof(value) !== 'object' || value === null) {
          return value;
        }

        if (cloned.has(value)) {
          return cloned.get(value);
        }

        var buffer, result;

        if ((buffer = value.buffer) && (0, _util.isArrayBuffer)(buffer)) {
          var transferable = transfers && transfers.includes(buffer);

          if (value === buffer) {
            result = value;
          } else if (transferable) {
            result = new value.constructor(buffer, value.byteOffset, value.byteLength);
          } else {
            result = new value.constructor(value);
          }

          cloned.set(value, result);
          return result;
        }

        result = Array.isArray(value) ? [] : {};
        cloned.set(value, result);

        for (var i in value) {
          var desc = void 0,
              p = value;

          while (!(desc = Object.getOwnPropertyDescriptor(p, i))) {
            p = Object.getPrototypeOf(p);
          }

          if (typeof desc.value === 'undefined' || typeof desc.value === 'function') {
            continue;
          }

          result[i] = cloneValue(desc.value);
        }

        return result;
      }

      if (!this._defer) {
        this._listeners.forEach(function (listener) {
          listener.call(this, {
            data: obj
          });
        }, this);

        return;
      }

      var cloned = new WeakMap();
      var e = {
        data: cloneValue(obj)
      };

      this._deferred.then(function () {
        _this5._listeners.forEach(function (listener) {
          listener.call(this, e);
        }, _this5);
      });
    }
  }, {
    key: "addEventListener",
    value: function addEventListener(name, listener) {
      this._listeners.push(listener);
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener(name, listener) {
      var i = this._listeners.indexOf(listener);

      this._listeners.splice(i, 1);
    }
  }, {
    key: "terminate",
    value: function terminate() {
      this._listeners = [];
    }
  }]);

  return LoopbackPort;
}();

exports.LoopbackPort = LoopbackPort;

var PDFWorker = function PDFWorkerClosure() {
  var pdfWorkerPorts = new WeakMap();
  var nextFakeWorkerId = 0;
  var fakeWorkerFilesLoadedCapability;

  function _getWorkerSrc() {
    if (_worker_options.GlobalWorkerOptions.workerSrc) {
      return _worker_options.GlobalWorkerOptions.workerSrc;
    }

    if (typeof fallbackWorkerSrc !== 'undefined') {
      return fallbackWorkerSrc;
    }

    throw new Error('No "GlobalWorkerOptions.workerSrc" specified.');
  }

  function getMainThreadWorkerMessageHandler() {
    try {
      if (typeof window !== 'undefined') {
        return window.pdfjsWorker && window.pdfjsWorker.WorkerMessageHandler;
      }
    } catch (ex) {}

    return null;
  }

  function setupFakeWorkerGlobal() {
    if (fakeWorkerFilesLoadedCapability) {
      return fakeWorkerFilesLoadedCapability.promise;
    }

    fakeWorkerFilesLoadedCapability = (0, _util.createPromiseCapability)();
    var mainWorkerMessageHandler = getMainThreadWorkerMessageHandler();

    if (mainWorkerMessageHandler) {
      fakeWorkerFilesLoadedCapability.resolve(mainWorkerMessageHandler);
      return fakeWorkerFilesLoadedCapability.promise;
    }

    var loader = fakeWorkerFilesLoader || function () {
      return (0, _dom_utils.loadScript)(_getWorkerSrc()).then(function () {
        return window.pdfjsWorker.WorkerMessageHandler;
      });
    };

    loader().then(fakeWorkerFilesLoadedCapability.resolve, fakeWorkerFilesLoadedCapability.reject);
    return fakeWorkerFilesLoadedCapability.promise;
  }

  function createCDNWrapper(url) {
    var wrapper = 'importScripts(\'' + url + '\');';
    return _util.URL.createObjectURL(new Blob([wrapper]));
  }

  var PDFWorker =
  /*#__PURE__*/
  function () {
    function PDFWorker() {
      var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref6$name = _ref6.name,
          name = _ref6$name === void 0 ? null : _ref6$name,
          _ref6$port = _ref6.port,
          port = _ref6$port === void 0 ? null : _ref6$port,
          _ref6$postMessageTran = _ref6.postMessageTransfers,
          postMessageTransfers = _ref6$postMessageTran === void 0 ? true : _ref6$postMessageTran,
          _ref6$verbosity = _ref6.verbosity,
          verbosity = _ref6$verbosity === void 0 ? (0, _util.getVerbosityLevel)() : _ref6$verbosity;

      _classCallCheck(this, PDFWorker);

      if (port && pdfWorkerPorts.has(port)) {
        throw new Error('Cannot use more than one PDFWorker per port');
      }

      this.name = name;
      this.destroyed = false;
      this.postMessageTransfers = postMessageTransfers !== false;
      this.verbosity = verbosity;
      this._readyCapability = (0, _util.createPromiseCapability)();
      this._port = null;
      this._webWorker = null;
      this._messageHandler = null;

      if (port) {
        pdfWorkerPorts.set(port, this);

        this._initializeFromPort(port);

        return;
      }

      this._initialize();
    }

    _createClass(PDFWorker, [{
      key: "_initializeFromPort",
      value: function _initializeFromPort(port) {
        this._port = port;
        this._messageHandler = new _message_handler.MessageHandler('main', 'worker', port);

        this._messageHandler.on('ready', function () {});

        this._readyCapability.resolve();
      }
    }, {
      key: "_initialize",
      value: function _initialize() {
        var _this6 = this;

        if (typeof Worker !== 'undefined' && !isWorkerDisabled && !getMainThreadWorkerMessageHandler()) {
          var workerSrc = _getWorkerSrc();

          try {
            if (!(0, _util.isSameOrigin)(window.location.href, workerSrc)) {
              workerSrc = createCDNWrapper(new _util.URL(workerSrc, window.location).href);
            }

            var worker = new Worker(workerSrc);
            var messageHandler = new _message_handler.MessageHandler('main', 'worker', worker);

            var terminateEarly = function terminateEarly() {
              worker.removeEventListener('error', onWorkerError);
              messageHandler.destroy();
              worker.terminate();

              if (_this6.destroyed) {
                _this6._readyCapability.reject(new Error('Worker was destroyed'));
              } else {
                _this6._setupFakeWorker();
              }
            };

            var onWorkerError = function onWorkerError() {
              if (!_this6._webWorker) {
                terminateEarly();
              }
            };

            worker.addEventListener('error', onWorkerError);
            messageHandler.on('test', function (data) {
              worker.removeEventListener('error', onWorkerError);

              if (_this6.destroyed) {
                terminateEarly();
                return;
              }

              if (data && data.supportTypedArray) {
                _this6._messageHandler = messageHandler;
                _this6._port = worker;
                _this6._webWorker = worker;

                if (!data.supportTransfers) {
                  _this6.postMessageTransfers = false;
                }

                _this6._readyCapability.resolve();

                messageHandler.send('configure', {
                  verbosity: _this6.verbosity
                });
              } else {
                _this6._setupFakeWorker();

                messageHandler.destroy();
                worker.terminate();
              }
            });
            messageHandler.on('ready', function (data) {
              worker.removeEventListener('error', onWorkerError);

              if (_this6.destroyed) {
                terminateEarly();
                return;
              }

              try {
                sendTest();
              } catch (e) {
                _this6._setupFakeWorker();
              }
            });

            var sendTest = function sendTest() {
              var testObj = new Uint8Array([_this6.postMessageTransfers ? 255 : 0]);

              try {
                messageHandler.send('test', testObj, [testObj.buffer]);
              } catch (ex) {
                (0, _util.info)('Cannot use postMessage transfers');
                testObj[0] = 0;
                messageHandler.send('test', testObj);
              }
            };

            sendTest();
            return;
          } catch (e) {
            (0, _util.info)('The worker has been disabled.');
          }
        }

        this._setupFakeWorker();
      }
    }, {
      key: "_setupFakeWorker",
      value: function _setupFakeWorker() {
        var _this7 = this;

        if (!isWorkerDisabled) {
          (0, _util.warn)('Setting up fake worker.');
          isWorkerDisabled = true;
        }

        setupFakeWorkerGlobal().then(function (WorkerMessageHandler) {
          if (_this7.destroyed) {
            _this7._readyCapability.reject(new Error('Worker was destroyed'));

            return;
          }

          var port = new LoopbackPort();
          _this7._port = port;
          var id = 'fake' + nextFakeWorkerId++;
          var workerHandler = new _message_handler.MessageHandler(id + '_worker', id, port);
          WorkerMessageHandler.setup(workerHandler, port);
          var messageHandler = new _message_handler.MessageHandler(id, id + '_worker', port);
          _this7._messageHandler = messageHandler;

          _this7._readyCapability.resolve();
        }).catch(function (reason) {
          _this7._readyCapability.reject(new Error("Setting up fake worker failed: \"".concat(reason.message, "\".")));
        });
      }
    }, {
      key: "destroy",
      value: function destroy() {
        this.destroyed = true;

        if (this._webWorker) {
          this._webWorker.terminate();

          this._webWorker = null;
        }

        pdfWorkerPorts.delete(this._port);
        this._port = null;

        if (this._messageHandler) {
          this._messageHandler.destroy();

          this._messageHandler = null;
        }
      }
    }, {
      key: "promise",
      get: function get() {
        return this._readyCapability.promise;
      }
    }, {
      key: "port",
      get: function get() {
        return this._port;
      }
    }, {
      key: "messageHandler",
      get: function get() {
        return this._messageHandler;
      }
    }], [{
      key: "fromPort",
      value: function fromPort(params) {
        if (!params || !params.port) {
          throw new Error('PDFWorker.fromPort - invalid method signature.');
        }

        if (pdfWorkerPorts.has(params.port)) {
          return pdfWorkerPorts.get(params.port);
        }

        return new PDFWorker(params);
      }
    }, {
      key: "getWorkerSrc",
      value: function getWorkerSrc() {
        return _getWorkerSrc();
      }
    }]);

    return PDFWorker;
  }();

  return PDFWorker;
}();

exports.PDFWorker = PDFWorker;

var WorkerTransport =
/*#__PURE__*/
function () {
  function WorkerTransport(messageHandler, loadingTask, networkStream, params) {
    _classCallCheck(this, WorkerTransport);

    this.messageHandler = messageHandler;
    this.loadingTask = loadingTask;
    this.commonObjs = new PDFObjects();
    this.fontLoader = new _font_loader.FontLoader({
      docId: loadingTask.docId,
      onUnsupportedFeature: this._onUnsupportedFeature.bind(this)
    });
    this._params = params;
    this.CMapReaderFactory = new params.CMapReaderFactory({
      baseUrl: params.cMapUrl,
      isCompressed: params.cMapPacked
    });
    this.destroyed = false;
    this.destroyCapability = null;
    this._passwordCapability = null;
    this._networkStream = networkStream;
    this._fullReader = null;
    this._lastProgress = null;
    this.pageCache = [];
    this.pagePromises = [];
    this.downloadInfoCapability = (0, _util.createPromiseCapability)();
    this.setupMessageHandler();
  }

  _createClass(WorkerTransport, [{
    key: "destroy",
    value: function destroy() {
      var _this8 = this;

      if (this.destroyCapability) {
        return this.destroyCapability.promise;
      }

      this.destroyed = true;
      this.destroyCapability = (0, _util.createPromiseCapability)();

      if (this._passwordCapability) {
        this._passwordCapability.reject(new Error('Worker was destroyed during onPassword callback'));
      }

      var waitOn = [];
      this.pageCache.forEach(function (page) {
        if (page) {
          waitOn.push(page._destroy());
        }
      });
      this.pageCache = [];
      this.pagePromises = [];
      var terminated = this.messageHandler.sendWithPromise('Terminate', null);
      waitOn.push(terminated);
      Promise.all(waitOn).then(function () {
        _this8.fontLoader.clear();

        if (_this8._networkStream) {
          _this8._networkStream.cancelAllRequests();
        }

        if (_this8.messageHandler) {
          _this8.messageHandler.destroy();

          _this8.messageHandler = null;
        }

        _this8.destroyCapability.resolve();
      }, this.destroyCapability.reject);
      return this.destroyCapability.promise;
    }
  }, {
    key: "setupMessageHandler",
    value: function setupMessageHandler() {
      var messageHandler = this.messageHandler,
          loadingTask = this.loadingTask;
      messageHandler.on('GetReader', function (data, sink) {
        var _this9 = this;

        (0, _util.assert)(this._networkStream);
        this._fullReader = this._networkStream.getFullReader();

        this._fullReader.onProgress = function (evt) {
          _this9._lastProgress = {
            loaded: evt.loaded,
            total: evt.total
          };
        };

        sink.onPull = function () {
          _this9._fullReader.read().then(function (_ref7) {
            var value = _ref7.value,
                done = _ref7.done;

            if (done) {
              sink.close();
              return;
            }

            (0, _util.assert)((0, _util.isArrayBuffer)(value));
            sink.enqueue(new Uint8Array(value), 1, [value]);
          }).catch(function (reason) {
            sink.error(reason);
          });
        };

        sink.onCancel = function (reason) {
          _this9._fullReader.cancel(reason);
        };
      }, this);
      messageHandler.on('ReaderHeadersReady', function (data) {
        var _this10 = this;

        var headersCapability = (0, _util.createPromiseCapability)();
        var fullReader = this._fullReader;
        fullReader.headersReady.then(function () {
          if (!fullReader.isStreamingSupported || !fullReader.isRangeSupported) {
            if (_this10._lastProgress && loadingTask.onProgress) {
              loadingTask.onProgress(_this10._lastProgress);
            }

            fullReader.onProgress = function (evt) {
              if (loadingTask.onProgress) {
                loadingTask.onProgress({
                  loaded: evt.loaded,
                  total: evt.total
                });
              }
            };
          }

          headersCapability.resolve({
            isStreamingSupported: fullReader.isStreamingSupported,
            isRangeSupported: fullReader.isRangeSupported,
            contentLength: fullReader.contentLength
          });
        }, headersCapability.reject);
        return headersCapability.promise;
      }, this);
      messageHandler.on('GetRangeReader', function (data, sink) {
        (0, _util.assert)(this._networkStream);

        var rangeReader = this._networkStream.getRangeReader(data.begin, data.end);

        sink.onPull = function () {
          rangeReader.read().then(function (_ref8) {
            var value = _ref8.value,
                done = _ref8.done;

            if (done) {
              sink.close();
              return;
            }

            (0, _util.assert)((0, _util.isArrayBuffer)(value));
            sink.enqueue(new Uint8Array(value), 1, [value]);
          }).catch(function (reason) {
            sink.error(reason);
          });
        };

        sink.onCancel = function (reason) {
          rangeReader.cancel(reason);
        };
      }, this);
      messageHandler.on('GetDoc', function (_ref9) {
        var pdfInfo = _ref9.pdfInfo;
        this.numPages = pdfInfo.numPages;
        this.pdfDocument = new PDFDocumentProxy(pdfInfo, this, loadingTask);

        loadingTask._capability.resolve(this.pdfDocument);
      }, this);
      messageHandler.on('PasswordRequest', function (exception) {
        var _this11 = this;

        this._passwordCapability = (0, _util.createPromiseCapability)();

        if (loadingTask.onPassword) {
          var updatePassword = function updatePassword(password) {
            _this11._passwordCapability.resolve({
              password: password
            });
          };

          try {
            loadingTask.onPassword(updatePassword, exception.code);
          } catch (ex) {
            this._passwordCapability.reject(ex);
          }
        } else {
          this._passwordCapability.reject(new _util.PasswordException(exception.message, exception.code));
        }

        return this._passwordCapability.promise;
      }, this);
      messageHandler.on('PasswordException', function (exception) {
        loadingTask._capability.reject(new _util.PasswordException(exception.message, exception.code));
      }, this);
      messageHandler.on('InvalidPDF', function (exception) {
        loadingTask._capability.reject(new _util.InvalidPDFException(exception.message));
      }, this);
      messageHandler.on('MissingPDF', function (exception) {
        loadingTask._capability.reject(new _util.MissingPDFException(exception.message));
      }, this);
      messageHandler.on('UnexpectedResponse', function (exception) {
        loadingTask._capability.reject(new _util.UnexpectedResponseException(exception.message, exception.status));
      }, this);
      messageHandler.on('UnknownError', function (exception) {
        loadingTask._capability.reject(new _util.UnknownErrorException(exception.message, exception.details));
      }, this);
      messageHandler.on('DataLoaded', function (data) {
        if (loadingTask.onProgress) {
          loadingTask.onProgress({
            loaded: data.length,
            total: data.length
          });
        }

        this.downloadInfoCapability.resolve(data);
      }, this);
      messageHandler.on('StartRenderPage', function (data) {
        if (this.destroyed) {
          return;
        }

        var page = this.pageCache[data.pageIndex];

        page._stats.timeEnd('Page Request');

        page._startRenderPage(data.transparency, data.intent);
      }, this);
      messageHandler.on('RenderPageChunk', function (data) {
        if (this.destroyed) {
          return;
        }

        var page = this.pageCache[data.pageIndex];

        page._renderPageChunk(data.operatorList, data.intent);
      }, this);
      messageHandler.on('commonobj', function (data) {
        var _this12 = this;

        if (this.destroyed) {
          return;
        }

        var _data = _slicedToArray(data, 3),
            id = _data[0],
            type = _data[1],
            exportedData = _data[2];

        if (this.commonObjs.has(id)) {
          return;
        }

        switch (type) {
          case 'Font':
            var params = this._params;

            if ('error' in exportedData) {
              var exportedError = exportedData.error;
              (0, _util.warn)("Error during font loading: ".concat(exportedError));
              this.commonObjs.resolve(id, exportedError);
              break;
            }

            var fontRegistry = null;

            if (params.pdfBug && _global_scope.default.FontInspector && _global_scope.default.FontInspector.enabled) {
              fontRegistry = {
                registerFont: function registerFont(font, url) {
                  _global_scope.default['FontInspector'].fontAdded(font, url);
                }
              };
            }

            var font = new _font_loader.FontFaceObject(exportedData, {
              isEvalSupported: params.isEvalSupported,
              disableFontFace: params.disableFontFace,
              ignoreErrors: params.ignoreErrors,
              onUnsupportedFeature: this._onUnsupportedFeature.bind(this),
              fontRegistry: fontRegistry
            });
            this.fontLoader.bind(font).then(function () {
              _this12.commonObjs.resolve(id, font);
            }, function (reason) {
              messageHandler.sendWithPromise('FontFallback', {
                id: id
              }).finally(function () {
                _this12.commonObjs.resolve(id, font);
              });
            });
            break;

          case 'FontPath':
            this.commonObjs.resolve(id, exportedData);
            break;

          default:
            throw new Error("Got unknown common object type ".concat(type));
        }
      }, this);
      messageHandler.on('obj', function (data) {
        if (this.destroyed) {
          return;
        }

        var _data2 = _slicedToArray(data, 4),
            id = _data2[0],
            pageIndex = _data2[1],
            type = _data2[2],
            imageData = _data2[3];

        var pageProxy = this.pageCache[pageIndex];

        if (pageProxy.objs.has(id)) {
          return;
        }

        switch (type) {
          case 'JpegStream':
            return new Promise(function (resolve, reject) {
              var img = new Image();

              img.onload = function () {
                resolve(img);
              };

              img.onerror = function () {
                reject(new Error('Error during JPEG image loading'));
              };

              img.src = imageData;
            }).then(function (img) {
              pageProxy.objs.resolve(id, img);
            });

          case 'Image':
            pageProxy.objs.resolve(id, imageData);
            var MAX_IMAGE_SIZE_TO_STORE = 8000000;

            if (imageData && 'data' in imageData && imageData.data.length > MAX_IMAGE_SIZE_TO_STORE) {
              pageProxy.cleanupAfterRender = true;
            }

            break;

          default:
            throw new Error("Got unknown object type ".concat(type));
        }
      }, this);
      messageHandler.on('DocProgress', function (data) {
        if (this.destroyed) {
          return;
        }

        if (loadingTask.onProgress) {
          loadingTask.onProgress({
            loaded: data.loaded,
            total: data.total
          });
        }
      }, this);
      messageHandler.on('PageError', function (data) {
        if (this.destroyed) {
          return;
        }

        var page = this.pageCache[data.pageNum - 1];
        var intentState = page.intentStates[data.intent];

        if (intentState.displayReadyCapability) {
          intentState.displayReadyCapability.reject(data.error);
        } else {
          throw new Error(data.error);
        }

        if (intentState.operatorList) {
          intentState.operatorList.lastChunk = true;

          for (var i = 0; i < intentState.renderTasks.length; i++) {
            intentState.renderTasks[i].operatorListChanged();
          }
        }
      }, this);
      messageHandler.on('UnsupportedFeature', this._onUnsupportedFeature, this);
      messageHandler.on('JpegDecode', function (data) {
        if (this.destroyed) {
          return Promise.reject(new Error('Worker was destroyed'));
        }

        if (typeof document === 'undefined') {
          return Promise.reject(new Error('"document" is not defined.'));
        }

        var _data3 = _slicedToArray(data, 2),
            imageUrl = _data3[0],
            components = _data3[1];

        if (components !== 3 && components !== 1) {
          return Promise.reject(new Error('Only 3 components or 1 component can be returned'));
        }

        return new Promise(function (resolve, reject) {
          var img = new Image();

          img.onload = function () {
            var width = img.width;
            var height = img.height;
            var size = width * height;
            var rgbaLength = size * 4;
            var buf = new Uint8ClampedArray(size * components);
            var tmpCanvas = document.createElement('canvas');
            tmpCanvas.width = width;
            tmpCanvas.height = height;
            var tmpCtx = tmpCanvas.getContext('2d');
            tmpCtx.drawImage(img, 0, 0);
            var data = tmpCtx.getImageData(0, 0, width, height).data;

            if (components === 3) {
              for (var i = 0, j = 0; i < rgbaLength; i += 4, j += 3) {
                buf[j] = data[i];
                buf[j + 1] = data[i + 1];
                buf[j + 2] = data[i + 2];
              }
            } else if (components === 1) {
              for (var _i2 = 0, _j = 0; _i2 < rgbaLength; _i2 += 4, _j++) {
                buf[_j] = data[_i2];
              }
            }

            resolve({
              data: buf,
              width: width,
              height: height
            });
          };

          img.onerror = function () {
            reject(new Error('JpegDecode failed to load image'));
          };

          img.src = imageUrl;
        });
      }, this);
      messageHandler.on('FetchBuiltInCMap', function (data) {
        if (this.destroyed) {
          return Promise.reject(new Error('Worker was destroyed'));
        }

        return this.CMapReaderFactory.fetch({
          name: data.name
        });
      }, this);
    }
  }, {
    key: "_onUnsupportedFeature",
    value: function _onUnsupportedFeature(_ref10) {
      var featureId = _ref10.featureId;

      if (this.destroyed) {
        return;
      }

      if (this.loadingTask.onUnsupportedFeature) {
        this.loadingTask.onUnsupportedFeature(featureId);
      }
    }
  }, {
    key: "getData",
    value: function getData() {
      return this.messageHandler.sendWithPromise('GetData', null);
    }
  }, {
    key: "getPage",
    value: function getPage(pageNumber) {
      var _this13 = this;

      if (!Number.isInteger(pageNumber) || pageNumber <= 0 || pageNumber > this.numPages) {
        return Promise.reject(new Error('Invalid page request'));
      }

      var pageIndex = pageNumber - 1;

      if (pageIndex in this.pagePromises) {
        return this.pagePromises[pageIndex];
      }

      var promise = this.messageHandler.sendWithPromise('GetPage', {
        pageIndex: pageIndex
      }).then(function (pageInfo) {
        if (_this13.destroyed) {
          throw new Error('Transport destroyed');
        }

        var page = new PDFPageProxy(pageIndex, pageInfo, _this13, _this13._params.pdfBug);
        _this13.pageCache[pageIndex] = page;
        return page;
      });
      this.pagePromises[pageIndex] = promise;
      return promise;
    }
  }, {
    key: "getPageIndex",
    value: function getPageIndex(ref) {
      return this.messageHandler.sendWithPromise('GetPageIndex', {
        ref: ref
      }).catch(function (reason) {
        return Promise.reject(new Error(reason));
      });
    }
  }, {
    key: "getAnnotations",
    value: function getAnnotations(pageIndex, intent) {
      return this.messageHandler.sendWithPromise('GetAnnotations', {
        pageIndex: pageIndex,
        intent: intent
      });
    }
  }, {
    key: "getDestinations",
    value: function getDestinations() {
      return this.messageHandler.sendWithPromise('GetDestinations', null);
    }
  }, {
    key: "getDestination",
    value: function getDestination(id) {
      if (typeof id !== 'string') {
        return Promise.reject(new Error('Invalid destination request.'));
      }

      return this.messageHandler.sendWithPromise('GetDestination', {
        id: id
      });
    }
  }, {
    key: "getPageLabels",
    value: function getPageLabels() {
      return this.messageHandler.sendWithPromise('GetPageLabels', null);
    }
  }, {
    key: "getPageMode",
    value: function getPageMode() {
      return this.messageHandler.sendWithPromise('GetPageMode', null);
    }
  }, {
    key: "getOpenActionDestination",
    value: function getOpenActionDestination() {
      return this.messageHandler.sendWithPromise('getOpenActionDestination', null);
    }
  }, {
    key: "getAttachments",
    value: function getAttachments() {
      return this.messageHandler.sendWithPromise('GetAttachments', null);
    }
  }, {
    key: "getJavaScript",
    value: function getJavaScript() {
      return this.messageHandler.sendWithPromise('GetJavaScript', null);
    }
  }, {
    key: "getOutline",
    value: function getOutline() {
      return this.messageHandler.sendWithPromise('GetOutline', null);
    }
  }, {
    key: "getPermissions",
    value: function getPermissions() {
      return this.messageHandler.sendWithPromise('GetPermissions', null);
    }
  }, {
    key: "getMetadata",
    value: function getMetadata() {
      var _this14 = this;

      return this.messageHandler.sendWithPromise('GetMetadata', null).then(function (results) {
        return {
          info: results[0],
          metadata: results[1] ? new _metadata.Metadata(results[1]) : null,
          contentDispositionFilename: _this14._fullReader ? _this14._fullReader.filename : null
        };
      });
    }
  }, {
    key: "getStats",
    value: function getStats() {
      return this.messageHandler.sendWithPromise('GetStats', null);
    }
  }, {
    key: "startCleanup",
    value: function startCleanup() {
      var _this15 = this;

      this.messageHandler.sendWithPromise('Cleanup', null).then(function () {
        for (var i = 0, ii = _this15.pageCache.length; i < ii; i++) {
          var page = _this15.pageCache[i];

          if (page) {
            page.cleanup();
          }
        }

        _this15.commonObjs.clear();

        _this15.fontLoader.clear();
      });
    }
  }, {
    key: "loadingParams",
    get: function get() {
      var params = this._params;
      return (0, _util.shadow)(this, 'loadingParams', {
        disableAutoFetch: params.disableAutoFetch,
        disableCreateObjectURL: params.disableCreateObjectURL,
        disableFontFace: params.disableFontFace,
        nativeImageDecoderSupport: params.nativeImageDecoderSupport
      });
    }
  }]);

  return WorkerTransport;
}();

var PDFObjects =
/*#__PURE__*/
function () {
  function PDFObjects() {
    _classCallCheck(this, PDFObjects);

    this._objs = Object.create(null);
  }

  _createClass(PDFObjects, [{
    key: "_ensureObj",
    value: function _ensureObj(objId) {
      if (this._objs[objId]) {
        return this._objs[objId];
      }

      return this._objs[objId] = {
        capability: (0, _util.createPromiseCapability)(),
        data: null,
        resolved: false
      };
    }
  }, {
    key: "get",
    value: function get(objId) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (callback) {
        this._ensureObj(objId).capability.promise.then(callback);

        return null;
      }

      var obj = this._objs[objId];

      if (!obj || !obj.resolved) {
        throw new Error("Requesting object that isn't resolved yet ".concat(objId, "."));
      }

      return obj.data;
    }
  }, {
    key: "has",
    value: function has(objId) {
      var obj = this._objs[objId];
      return obj ? obj.resolved : false;
    }
  }, {
    key: "resolve",
    value: function resolve(objId, data) {
      var obj = this._ensureObj(objId);

      obj.resolved = true;
      obj.data = data;
      obj.capability.resolve(data);
    }
  }, {
    key: "clear",
    value: function clear() {
      this._objs = Object.create(null);
    }
  }]);

  return PDFObjects;
}();

var RenderTask =
/*#__PURE__*/
function () {
  function RenderTask(internalRenderTask) {
    _classCallCheck(this, RenderTask);

    this._internalRenderTask = internalRenderTask;
    this.onContinue = null;
  }

  _createClass(RenderTask, [{
    key: "cancel",
    value: function cancel() {
      this._internalRenderTask.cancel();
    }
  }, {
    key: "then",
    value: function then(onFulfilled, onRejected) {
      (0, _util.deprecated)('RenderTask.then method, use the `promise` getter instead.');
      return this.promise.then.apply(this.promise, arguments);
    }
  }, {
    key: "promise",
    get: function get() {
      return this._internalRenderTask.capability.promise;
    }
  }]);

  return RenderTask;
}();

var InternalRenderTask = function InternalRenderTaskClosure() {
  var canvasInRendering = new WeakSet();

  var InternalRenderTask =
  /*#__PURE__*/
  function () {
    function InternalRenderTask(_ref11) {
      var callback = _ref11.callback,
          params = _ref11.params,
          objs = _ref11.objs,
          commonObjs = _ref11.commonObjs,
          operatorList = _ref11.operatorList,
          pageNumber = _ref11.pageNumber,
          canvasFactory = _ref11.canvasFactory,
          webGLContext = _ref11.webGLContext,
          _ref11$useRequestAnim = _ref11.useRequestAnimationFrame,
          useRequestAnimationFrame = _ref11$useRequestAnim === void 0 ? false : _ref11$useRequestAnim,
          _ref11$pdfBug = _ref11.pdfBug,
          pdfBug = _ref11$pdfBug === void 0 ? false : _ref11$pdfBug;

      _classCallCheck(this, InternalRenderTask);

      this.callback = callback;
      this.params = params;
      this.objs = objs;
      this.commonObjs = commonObjs;
      this.operatorListIdx = null;
      this.operatorList = operatorList;
      this.pageNumber = pageNumber;
      this.canvasFactory = canvasFactory;
      this.webGLContext = webGLContext;
      this._pdfBug = pdfBug;
      this.running = false;
      this.graphicsReadyCallback = null;
      this.graphicsReady = false;
      this._useRequestAnimationFrame = useRequestAnimationFrame === true && typeof window !== 'undefined';
      this.cancelled = false;
      this.capability = (0, _util.createPromiseCapability)();
      this.task = new RenderTask(this);
      this._continueBound = this._continue.bind(this);
      this._scheduleNextBound = this._scheduleNext.bind(this);
      this._nextBound = this._next.bind(this);
      this._canvas = params.canvasContext.canvas;
    }

    _createClass(InternalRenderTask, [{
      key: "initializeGraphics",
      value: function initializeGraphics() {
        var transparency = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

        if (this.cancelled) {
          return;
        }

        if (this._canvas) {
          if (canvasInRendering.has(this._canvas)) {
            throw new Error('Cannot use the same canvas during multiple render() operations. ' + 'Use different canvas or ensure previous operations were ' + 'cancelled or completed.');
          }

          canvasInRendering.add(this._canvas);
        }

        if (this._pdfBug && _global_scope.default.StepperManager && _global_scope.default.StepperManager.enabled) {
          this.stepper = _global_scope.default.StepperManager.create(this.pageNumber - 1);
          this.stepper.init(this.operatorList);
          this.stepper.nextBreakPoint = this.stepper.getNextBreakPoint();
        }

        var _this$params = this.params,
            canvasContext = _this$params.canvasContext,
            viewport = _this$params.viewport,
            transform = _this$params.transform,
            imageLayer = _this$params.imageLayer,
            background = _this$params.background;
        this.gfx = new _canvas.CanvasGraphics(canvasContext, this.commonObjs, this.objs, this.canvasFactory, this.webGLContext, imageLayer);
        this.gfx.beginDrawing({
          transform: transform,
          viewport: viewport,
          transparency: transparency,
          background: background
        });
        this.operatorListIdx = 0;
        this.graphicsReady = true;

        if (this.graphicsReadyCallback) {
          this.graphicsReadyCallback();
        }
      }
    }, {
      key: "cancel",
      value: function cancel() {
        var error = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        this.running = false;
        this.cancelled = true;

        if (this.gfx) {
          this.gfx.endDrawing();
        }

        if (this._canvas) {
          canvasInRendering.delete(this._canvas);
        }

        this.callback(error || new _dom_utils.RenderingCancelledException("Rendering cancelled, page ".concat(this.pageNumber), 'canvas'));
      }
    }, {
      key: "operatorListChanged",
      value: function operatorListChanged() {
        if (!this.graphicsReady) {
          if (!this.graphicsReadyCallback) {
            this.graphicsReadyCallback = this._continueBound;
          }

          return;
        }

        if (this.stepper) {
          this.stepper.updateOperatorList(this.operatorList);
        }

        if (this.running) {
          return;
        }

        this._continue();
      }
    }, {
      key: "_continue",
      value: function _continue() {
        this.running = true;

        if (this.cancelled) {
          return;
        }

        if (this.task.onContinue) {
          this.task.onContinue(this._scheduleNextBound);
        } else {
          this._scheduleNext();
        }
      }
    }, {
      key: "_scheduleNext",
      value: function _scheduleNext() {
        var _this16 = this;

        if (this._useRequestAnimationFrame) {
          window.requestAnimationFrame(function () {
            _this16._nextBound().catch(_this16.cancel.bind(_this16));
          });
        } else {
          Promise.resolve().then(this._nextBound).catch(this.cancel.bind(this));
        }
      }
    }, {
      key: "_next",
      value: function () {
        var _next2 = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee() {
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!this.cancelled) {
                    _context.next = 2;
                    break;
                  }

                  return _context.abrupt("return");

                case 2:
                  this.operatorListIdx = this.gfx.executeOperatorList(this.operatorList, this.operatorListIdx, this._continueBound, this.stepper);

                  if (this.operatorListIdx === this.operatorList.argsArray.length) {
                    this.running = false;

                    if (this.operatorList.lastChunk) {
                      this.gfx.endDrawing();

                      if (this._canvas) {
                        canvasInRendering.delete(this._canvas);
                      }

                      this.callback();
                    }
                  }

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function _next() {
          return _next2.apply(this, arguments);
        }

        return _next;
      }()
    }]);

    return InternalRenderTask;
  }();

  return InternalRenderTask;
}();

var version = '2.1.266';
exports.version = version;
var build = '81f5835c';
exports.build = build;

/***/ }),
/* 147 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = __w_pdfjs_require__(148);

/***/ }),
/* 148 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var g = function () {
  return this || (typeof self === "undefined" ? "undefined" : _typeof(self)) === "object" && self;
}() || Function("return this")();

var hadRuntime = g.regeneratorRuntime && Object.getOwnPropertyNames(g).indexOf("regeneratorRuntime") >= 0;
var oldRuntime = hadRuntime && g.regeneratorRuntime;
g.regeneratorRuntime = undefined;
module.exports = __w_pdfjs_require__(149);

if (hadRuntime) {
  g.regeneratorRuntime = oldRuntime;
} else {
  try {
    delete g.regeneratorRuntime;
  } catch (e) {
    g.regeneratorRuntime = undefined;
  }
}

/***/ }),
/* 149 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(module) {

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

!function (global) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined;
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  var inModule = ( false ? undefined : _typeof(module)) === "object";
  var runtime = global.regeneratorRuntime;

  if (runtime) {
    if (inModule) {
      module.exports = runtime;
    }

    return;
  }

  runtime = global.regeneratorRuntime = inModule ? module.exports : {};

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);
    generator._invoke = makeInvokeMethod(innerFn, self, context);
    return generator;
  }

  runtime.wrap = wrap;

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};

  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

  if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      prototype[method] = function (arg) {
        return this._invoke(method, arg);
      };
    });
  }

  runtime.isGeneratorFunction = function (genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
  };

  runtime.mark = function (genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;

      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }

    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  runtime.awrap = function (arg) {
    return {
      __await: arg
    };
  };

  function AsyncIterator(generator) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;

        if (value && _typeof(value) === "object" && hasOwn.call(value, "__await")) {
          return Promise.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return Promise.resolve(value).then(function (unwrapped) {
          result.value = unwrapped;
          resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new Promise(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    }

    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);

  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };

  runtime.AsyncIterator = AsyncIterator;

  runtime.async = function (innerFn, outerFn, self, tryLocsList) {
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
    return runtime.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;
    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;

        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);

          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          context.sent = context._sent = context.arg;
        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);
        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;
        var record = tryCatch(innerFn, self, context);

        if (record.type === "normal") {
          state = context.done ? GenStateCompleted : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };
        } else if (record.type === "throw") {
          state = GenStateCompleted;
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (method === undefined) {
      context.delegate = null;

      if (context.method === "throw") {
        if (delegate.iterator.return) {
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (!info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      context[delegate.resultName] = info.value;
      context.next = delegate.nextLoc;

      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }
    } else {
      return info;
    }

    context.delegate = null;
    return ContinueSentinel;
  }

  defineIteratorMethods(Gp);
  Gp[toStringTagSymbol] = "Generator";

  Gp[iteratorSymbol] = function () {
    return this;
  };

  Gp.toString = function () {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  runtime.keys = function (object) {
    var keys = [];

    for (var key in object) {
      keys.push(key);
    }

    keys.reverse();
    return function next() {
      while (keys.length) {
        var key = keys.pop();

        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];

      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;
          return next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  runtime.values = values;

  function doneResult() {
    return {
      value: undefined,
      done: true
    };
  }

  Context.prototype = {
    constructor: Context,
    reset: function reset(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;
      this.method = "next";
      this.arg = undefined;
      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },
    stop: function stop() {
      this.done = true;
      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;

      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },
    dispatchException: function dispatchException(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;

      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          context.method = "next";
          context.arg = undefined;
        }

        return !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }
          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },
    abrupt: function abrupt(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },
    complete: function complete(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" || record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },
    finish: function finish(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },
    "catch": function _catch(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };
}(function () {
  return this || (typeof self === "undefined" ? "undefined" : _typeof(self)) === "object" && self;
}() || Function("return this")());
/* WEBPACK VAR INJECTION */}.call(this, __w_pdfjs_require__(150)(module)))

/***/ }),
/* 150 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (module) {
  if (!module.webpackPolyfill) {
    module.deprecate = function () {};

    module.paths = [];
    if (!module.children) module.children = [];
    Object.defineProperty(module, "loaded", {
      enumerable: true,
      get: function get() {
        return module.l;
      }
    });
    Object.defineProperty(module, "id", {
      enumerable: true,
      get: function get() {
        return module.i;
      }
    });
    module.webpackPolyfill = 1;
  }

  return module;
};

/***/ }),
/* 151 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addLinkAttributes = addLinkAttributes;
exports.getFilenameFromUrl = getFilenameFromUrl;
exports.loadScript = loadScript;
exports.DummyStatTimer = exports.StatTimer = exports.DOMSVGFactory = exports.DOMCMapReaderFactory = exports.DOMCanvasFactory = exports.DEFAULT_LINK_REL = exports.LinkTarget = exports.RenderingCancelledException = exports.PageViewport = void 0;

var _util = __w_pdfjs_require__(1);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEFAULT_LINK_REL = 'noopener noreferrer nofollow';
exports.DEFAULT_LINK_REL = DEFAULT_LINK_REL;
var SVG_NS = 'http://www.w3.org/2000/svg';

var DOMCanvasFactory =
/*#__PURE__*/
function () {
  function DOMCanvasFactory() {
    _classCallCheck(this, DOMCanvasFactory);
  }

  _createClass(DOMCanvasFactory, [{
    key: "create",
    value: function create(width, height) {
      if (width <= 0 || height <= 0) {
        throw new Error('invalid canvas size');
      }

      var canvas = document.createElement('canvas');
      var context = canvas.getContext('2d');
      canvas.width = width;
      canvas.height = height;
      return {
        canvas: canvas,
        context: context
      };
    }
  }, {
    key: "reset",
    value: function reset(canvasAndContext, width, height) {
      if (!canvasAndContext.canvas) {
        throw new Error('canvas is not specified');
      }

      if (width <= 0 || height <= 0) {
        throw new Error('invalid canvas size');
      }

      canvasAndContext.canvas.width = width;
      canvasAndContext.canvas.height = height;
    }
  }, {
    key: "destroy",
    value: function destroy(canvasAndContext) {
      if (!canvasAndContext.canvas) {
        throw new Error('canvas is not specified');
      }

      canvasAndContext.canvas.width = 0;
      canvasAndContext.canvas.height = 0;
      canvasAndContext.canvas = null;
      canvasAndContext.context = null;
    }
  }]);

  return DOMCanvasFactory;
}();

exports.DOMCanvasFactory = DOMCanvasFactory;

var DOMCMapReaderFactory =
/*#__PURE__*/
function () {
  function DOMCMapReaderFactory(_ref) {
    var _ref$baseUrl = _ref.baseUrl,
        baseUrl = _ref$baseUrl === void 0 ? null : _ref$baseUrl,
        _ref$isCompressed = _ref.isCompressed,
        isCompressed = _ref$isCompressed === void 0 ? false : _ref$isCompressed;

    _classCallCheck(this, DOMCMapReaderFactory);

    this.baseUrl = baseUrl;
    this.isCompressed = isCompressed;
  }

  _createClass(DOMCMapReaderFactory, [{
    key: "fetch",
    value: function fetch(_ref2) {
      var _this = this;

      var name = _ref2.name;

      if (!this.baseUrl) {
        return Promise.reject(new Error('The CMap "baseUrl" parameter must be specified, ensure that ' + 'the "cMapUrl" and "cMapPacked" API parameters are provided.'));
      }

      if (!name) {
        return Promise.reject(new Error('CMap name must be specified.'));
      }

      return new Promise(function (resolve, reject) {
        var url = _this.baseUrl + name + (_this.isCompressed ? '.bcmap' : '');
        var request = new XMLHttpRequest();
        request.open('GET', url, true);

        if (_this.isCompressed) {
          request.responseType = 'arraybuffer';
        }

        request.onreadystatechange = function () {
          if (request.readyState !== XMLHttpRequest.DONE) {
            return;
          }

          if (request.status === 200 || request.status === 0) {
            var data;

            if (_this.isCompressed && request.response) {
              data = new Uint8Array(request.response);
            } else if (!_this.isCompressed && request.responseText) {
              data = (0, _util.stringToBytes)(request.responseText);
            }

            if (data) {
              resolve({
                cMapData: data,
                compressionType: _this.isCompressed ? _util.CMapCompressionType.BINARY : _util.CMapCompressionType.NONE
              });
              return;
            }
          }

          reject(new Error('Unable to load ' + (_this.isCompressed ? 'binary ' : '') + 'CMap at: ' + url));
        };

        request.send(null);
      });
    }
  }]);

  return DOMCMapReaderFactory;
}();

exports.DOMCMapReaderFactory = DOMCMapReaderFactory;

var DOMSVGFactory =
/*#__PURE__*/
function () {
  function DOMSVGFactory() {
    _classCallCheck(this, DOMSVGFactory);
  }

  _createClass(DOMSVGFactory, [{
    key: "create",
    value: function create(width, height) {
      (0, _util.assert)(width > 0 && height > 0, 'Invalid SVG dimensions');
      var svg = document.createElementNS(SVG_NS, 'svg:svg');
      svg.setAttribute('version', '1.1');
      svg.setAttribute('width', width + 'px');
      svg.setAttribute('height', height + 'px');
      svg.setAttribute('preserveAspectRatio', 'none');
      svg.setAttribute('viewBox', '0 0 ' + width + ' ' + height);
      return svg;
    }
  }, {
    key: "createElement",
    value: function createElement(type) {
      (0, _util.assert)(typeof type === 'string', 'Invalid SVG element type');
      return document.createElementNS(SVG_NS, type);
    }
  }]);

  return DOMSVGFactory;
}();

exports.DOMSVGFactory = DOMSVGFactory;

var PageViewport =
/*#__PURE__*/
function () {
  function PageViewport(_ref3) {
    var viewBox = _ref3.viewBox,
        scale = _ref3.scale,
        rotation = _ref3.rotation,
        _ref3$offsetX = _ref3.offsetX,
        offsetX = _ref3$offsetX === void 0 ? 0 : _ref3$offsetX,
        _ref3$offsetY = _ref3.offsetY,
        offsetY = _ref3$offsetY === void 0 ? 0 : _ref3$offsetY,
        _ref3$dontFlip = _ref3.dontFlip,
        dontFlip = _ref3$dontFlip === void 0 ? false : _ref3$dontFlip;

    _classCallCheck(this, PageViewport);

    this.viewBox = viewBox;
    this.scale = scale;
    this.rotation = rotation;
    this.offsetX = offsetX;
    this.offsetY = offsetY;
    var centerX = (viewBox[2] + viewBox[0]) / 2;
    var centerY = (viewBox[3] + viewBox[1]) / 2;
    var rotateA, rotateB, rotateC, rotateD;
    rotation = rotation % 360;
    rotation = rotation < 0 ? rotation + 360 : rotation;

    switch (rotation) {
      case 180:
        rotateA = -1;
        rotateB = 0;
        rotateC = 0;
        rotateD = 1;
        break;

      case 90:
        rotateA = 0;
        rotateB = 1;
        rotateC = 1;
        rotateD = 0;
        break;

      case 270:
        rotateA = 0;
        rotateB = -1;
        rotateC = -1;
        rotateD = 0;
        break;

      default:
        rotateA = 1;
        rotateB = 0;
        rotateC = 0;
        rotateD = -1;
        break;
    }

    if (dontFlip) {
      rotateC = -rotateC;
      rotateD = -rotateD;
    }

    var offsetCanvasX, offsetCanvasY;
    var width, height;

    if (rotateA === 0) {
      offsetCanvasX = Math.abs(centerY - viewBox[1]) * scale + offsetX;
      offsetCanvasY = Math.abs(centerX - viewBox[0]) * scale + offsetY;
      width = Math.abs(viewBox[3] - viewBox[1]) * scale;
      height = Math.abs(viewBox[2] - viewBox[0]) * scale;
    } else {
      offsetCanvasX = Math.abs(centerX - viewBox[0]) * scale + offsetX;
      offsetCanvasY = Math.abs(centerY - viewBox[1]) * scale + offsetY;
      width = Math.abs(viewBox[2] - viewBox[0]) * scale;
      height = Math.abs(viewBox[3] - viewBox[1]) * scale;
    }

    this.transform = [rotateA * scale, rotateB * scale, rotateC * scale, rotateD * scale, offsetCanvasX - rotateA * scale * centerX - rotateC * scale * centerY, offsetCanvasY - rotateB * scale * centerX - rotateD * scale * centerY];
    this.width = width;
    this.height = height;
  }

  _createClass(PageViewport, [{
    key: "clone",
    value: function clone() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref4$scale = _ref4.scale,
          scale = _ref4$scale === void 0 ? this.scale : _ref4$scale,
          _ref4$rotation = _ref4.rotation,
          rotation = _ref4$rotation === void 0 ? this.rotation : _ref4$rotation,
          _ref4$dontFlip = _ref4.dontFlip,
          dontFlip = _ref4$dontFlip === void 0 ? false : _ref4$dontFlip;

      return new PageViewport({
        viewBox: this.viewBox.slice(),
        scale: scale,
        rotation: rotation,
        offsetX: this.offsetX,
        offsetY: this.offsetY,
        dontFlip: dontFlip
      });
    }
  }, {
    key: "convertToViewportPoint",
    value: function convertToViewportPoint(x, y) {
      return _util.Util.applyTransform([x, y], this.transform);
    }
  }, {
    key: "convertToViewportRectangle",
    value: function convertToViewportRectangle(rect) {
      var tl = _util.Util.applyTransform([rect[0], rect[1]], this.transform);

      var br = _util.Util.applyTransform([rect[2], rect[3]], this.transform);

      return [tl[0], tl[1], br[0], br[1]];
    }
  }, {
    key: "convertToPdfPoint",
    value: function convertToPdfPoint(x, y) {
      return _util.Util.applyInverseTransform([x, y], this.transform);
    }
  }]);

  return PageViewport;
}();

exports.PageViewport = PageViewport;

var RenderingCancelledException = function RenderingCancelledException() {
  function RenderingCancelledException(msg, type) {
    this.message = msg;
    this.type = type;
  }

  RenderingCancelledException.prototype = new Error();
  RenderingCancelledException.prototype.name = 'RenderingCancelledException';
  RenderingCancelledException.constructor = RenderingCancelledException;
  return RenderingCancelledException;
}();

exports.RenderingCancelledException = RenderingCancelledException;
var LinkTarget = {
  NONE: 0,
  SELF: 1,
  BLANK: 2,
  PARENT: 3,
  TOP: 4
};
exports.LinkTarget = LinkTarget;
var LinkTargetStringMap = ['', '_self', '_blank', '_parent', '_top'];

function addLinkAttributes(link) {
  var _ref5 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      url = _ref5.url,
      target = _ref5.target,
      rel = _ref5.rel;

  link.href = link.title = url ? (0, _util.removeNullCharacters)(url) : '';

  if (url) {
    var LinkTargetValues = Object.values(LinkTarget);
    var targetIndex = LinkTargetValues.includes(target) ? target : LinkTarget.NONE;
    link.target = LinkTargetStringMap[targetIndex];
    link.rel = typeof rel === 'string' ? rel : DEFAULT_LINK_REL;
  }
}

function getFilenameFromUrl(url) {
  var anchor = url.indexOf('#');
  var query = url.indexOf('?');
  var end = Math.min(anchor > 0 ? anchor : url.length, query > 0 ? query : url.length);
  return url.substring(url.lastIndexOf('/', end) + 1, end);
}

var StatTimer =
/*#__PURE__*/
function () {
  function StatTimer() {
    var enable = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

    _classCallCheck(this, StatTimer);

    this.enabled = !!enable;
    this.started = Object.create(null);
    this.times = [];
  }

  _createClass(StatTimer, [{
    key: "time",
    value: function time(name) {
      if (!this.enabled) {
        return;
      }

      if (name in this.started) {
        (0, _util.warn)('Timer is already running for ' + name);
      }

      this.started[name] = Date.now();
    }
  }, {
    key: "timeEnd",
    value: function timeEnd(name) {
      if (!this.enabled) {
        return;
      }

      if (!(name in this.started)) {
        (0, _util.warn)('Timer has not been started for ' + name);
      }

      this.times.push({
        'name': name,
        'start': this.started[name],
        'end': Date.now()
      });
      delete this.started[name];
    }
  }, {
    key: "toString",
    value: function toString() {
      var times = this.times;
      var out = '',
          longest = 0;

      for (var i = 0, ii = times.length; i < ii; ++i) {
        var name = times[i]['name'];

        if (name.length > longest) {
          longest = name.length;
        }
      }

      for (var _i = 0, _ii = times.length; _i < _ii; ++_i) {
        var span = times[_i];
        var duration = span.end - span.start;
        out += "".concat(span['name'].padEnd(longest), " ").concat(duration, "ms\n");
      }

      return out;
    }
  }]);

  return StatTimer;
}();

exports.StatTimer = StatTimer;

var DummyStatTimer =
/*#__PURE__*/
function () {
  function DummyStatTimer() {
    _classCallCheck(this, DummyStatTimer);

    (0, _util.unreachable)('Cannot initialize DummyStatTimer.');
  }

  _createClass(DummyStatTimer, null, [{
    key: "time",
    value: function time(name) {}
  }, {
    key: "timeEnd",
    value: function timeEnd(name) {}
  }, {
    key: "toString",
    value: function toString() {
      return '';
    }
  }]);

  return DummyStatTimer;
}();

exports.DummyStatTimer = DummyStatTimer;

function loadScript(src) {
  return new Promise(function (resolve, reject) {
    var script = document.createElement('script');
    script.src = src;
    script.onload = resolve;

    script.onerror = function () {
      reject(new Error("Cannot load script at: ".concat(script.src)));
    };

    (document.head || document.documentElement).appendChild(script);
  });
}

/***/ }),
/* 152 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FontLoader = exports.FontFaceObject = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(147));

var _util = __w_pdfjs_require__(1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var BaseFontLoader =
/*#__PURE__*/
function () {
  function BaseFontLoader(_ref) {
    var docId = _ref.docId,
        onUnsupportedFeature = _ref.onUnsupportedFeature;

    _classCallCheck(this, BaseFontLoader);

    if (this.constructor === BaseFontLoader) {
      (0, _util.unreachable)('Cannot initialize BaseFontLoader.');
    }

    this.docId = docId;
    this._onUnsupportedFeature = onUnsupportedFeature;
    this.nativeFontFaces = [];
    this.styleElement = null;
  }

  _createClass(BaseFontLoader, [{
    key: "addNativeFontFace",
    value: function addNativeFontFace(nativeFontFace) {
      this.nativeFontFaces.push(nativeFontFace);
      document.fonts.add(nativeFontFace);
    }
  }, {
    key: "insertRule",
    value: function insertRule(rule) {
      var styleElement = this.styleElement;

      if (!styleElement) {
        styleElement = this.styleElement = document.createElement('style');
        styleElement.id = "PDFJS_FONT_STYLE_TAG_".concat(this.docId);
        document.documentElement.getElementsByTagName('head')[0].appendChild(styleElement);
      }

      var styleSheet = styleElement.sheet;
      styleSheet.insertRule(rule, styleSheet.cssRules.length);
    }
  }, {
    key: "clear",
    value: function clear() {
      this.nativeFontFaces.forEach(function (nativeFontFace) {
        document.fonts.delete(nativeFontFace);
      });
      this.nativeFontFaces.length = 0;

      if (this.styleElement) {
        this.styleElement.remove();
        this.styleElement = null;
      }
    }
  }, {
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(font) {
        var _this = this;

        var nativeFontFace, rule;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(font.attached || font.missingFile)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                font.attached = true;

                if (!this.isFontLoadingAPISupported) {
                  _context.next = 19;
                  break;
                }

                nativeFontFace = font.createNativeFontFace();

                if (!nativeFontFace) {
                  _context.next = 18;
                  break;
                }

                this.addNativeFontFace(nativeFontFace);
                _context.prev = 7;
                _context.next = 10;
                return nativeFontFace.loaded;

              case 10:
                _context.next = 18;
                break;

              case 12:
                _context.prev = 12;
                _context.t0 = _context["catch"](7);

                this._onUnsupportedFeature({
                  featureId: _util.UNSUPPORTED_FEATURES.font
                });

                (0, _util.warn)("Failed to load font '".concat(nativeFontFace.family, "': '").concat(_context.t0, "'."));
                font.disableFontFace = true;
                throw _context.t0;

              case 18:
                return _context.abrupt("return");

              case 19:
                rule = font.createFontFaceRule();

                if (!rule) {
                  _context.next = 25;
                  break;
                }

                this.insertRule(rule);

                if (!this.isSyncFontLoadingSupported) {
                  _context.next = 24;
                  break;
                }

                return _context.abrupt("return");

              case 24:
                return _context.abrupt("return", new Promise(function (resolve) {
                  var request = _this._queueLoadingCallback(resolve);

                  _this._prepareFontLoadEvent([rule], [font], request);
                }));

              case 25:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[7, 12]]);
      }));

      function bind(_x) {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "_queueLoadingCallback",
    value: function _queueLoadingCallback(callback) {
      (0, _util.unreachable)('Abstract method `_queueLoadingCallback`.');
    }
  }, {
    key: "_prepareFontLoadEvent",
    value: function _prepareFontLoadEvent(rules, fontsToLoad, request) {
      (0, _util.unreachable)('Abstract method `_prepareFontLoadEvent`.');
    }
  }, {
    key: "isFontLoadingAPISupported",
    get: function get() {
      (0, _util.unreachable)('Abstract method `isFontLoadingAPISupported`.');
    }
  }, {
    key: "isSyncFontLoadingSupported",
    get: function get() {
      (0, _util.unreachable)('Abstract method `isSyncFontLoadingSupported`.');
    }
  }, {
    key: "_loadTestFont",
    get: function get() {
      (0, _util.unreachable)('Abstract method `_loadTestFont`.');
    }
  }]);

  return BaseFontLoader;
}();

var FontLoader;
exports.FontLoader = FontLoader;
{
  exports.FontLoader = FontLoader =
  /*#__PURE__*/
  function (_BaseFontLoader) {
    _inherits(GenericFontLoader, _BaseFontLoader);

    function GenericFontLoader(docId) {
      var _this2;

      _classCallCheck(this, GenericFontLoader);

      _this2 = _possibleConstructorReturn(this, _getPrototypeOf(GenericFontLoader).call(this, docId));
      _this2.loadingContext = {
        requests: [],
        nextRequestId: 0
      };
      _this2.loadTestFontId = 0;
      return _this2;
    }

    _createClass(GenericFontLoader, [{
      key: "_queueLoadingCallback",
      value: function _queueLoadingCallback(callback) {
        function completeRequest() {
          (0, _util.assert)(!request.done, 'completeRequest() cannot be called twice.');
          request.done = true;

          while (context.requests.length > 0 && context.requests[0].done) {
            var otherRequest = context.requests.shift();
            setTimeout(otherRequest.callback, 0);
          }
        }

        var context = this.loadingContext;
        var request = {
          id: "pdfjs-font-loading-".concat(context.nextRequestId++),
          done: false,
          complete: completeRequest,
          callback: callback
        };
        context.requests.push(request);
        return request;
      }
    }, {
      key: "_prepareFontLoadEvent",
      value: function _prepareFontLoadEvent(rules, fonts, request) {
        function int32(data, offset) {
          return data.charCodeAt(offset) << 24 | data.charCodeAt(offset + 1) << 16 | data.charCodeAt(offset + 2) << 8 | data.charCodeAt(offset + 3) & 0xff;
        }

        function spliceString(s, offset, remove, insert) {
          var chunk1 = s.substring(0, offset);
          var chunk2 = s.substring(offset + remove);
          return chunk1 + insert + chunk2;
        }

        var i, ii;
        var canvas = document.createElement('canvas');
        canvas.width = 1;
        canvas.height = 1;
        var ctx = canvas.getContext('2d');
        var called = 0;

        function isFontReady(name, callback) {
          called++;

          if (called > 30) {
            (0, _util.warn)('Load test font never loaded.');
            callback();
            return;
          }

          ctx.font = '30px ' + name;
          ctx.fillText('.', 0, 20);
          var imageData = ctx.getImageData(0, 0, 1, 1);

          if (imageData.data[3] > 0) {
            callback();
            return;
          }

          setTimeout(isFontReady.bind(null, name, callback));
        }

        var loadTestFontId = "lt".concat(Date.now()).concat(this.loadTestFontId++);
        var data = this._loadTestFont;
        var COMMENT_OFFSET = 976;
        data = spliceString(data, COMMENT_OFFSET, loadTestFontId.length, loadTestFontId);
        var CFF_CHECKSUM_OFFSET = 16;
        var XXXX_VALUE = 0x58585858;
        var checksum = int32(data, CFF_CHECKSUM_OFFSET);

        for (i = 0, ii = loadTestFontId.length - 3; i < ii; i += 4) {
          checksum = checksum - XXXX_VALUE + int32(loadTestFontId, i) | 0;
        }

        if (i < loadTestFontId.length) {
          checksum = checksum - XXXX_VALUE + int32(loadTestFontId + 'XXX', i) | 0;
        }

        data = spliceString(data, CFF_CHECKSUM_OFFSET, 4, (0, _util.string32)(checksum));
        var url = "url(data:font/opentype;base64,".concat(btoa(data), ");");
        var rule = "@font-face {font-family:\"".concat(loadTestFontId, "\";src:").concat(url, "}");
        this.insertRule(rule);
        var names = [];

        for (i = 0, ii = fonts.length; i < ii; i++) {
          names.push(fonts[i].loadedName);
        }

        names.push(loadTestFontId);
        var div = document.createElement('div');
        div.setAttribute('style', 'visibility: hidden;' + 'width: 10px; height: 10px;' + 'position: absolute; top: 0px; left: 0px;');

        for (i = 0, ii = names.length; i < ii; ++i) {
          var span = document.createElement('span');
          span.textContent = 'Hi';
          span.style.fontFamily = names[i];
          div.appendChild(span);
        }

        document.body.appendChild(div);
        isFontReady(loadTestFontId, function () {
          document.body.removeChild(div);
          request.complete();
        });
      }
    }, {
      key: "isFontLoadingAPISupported",
      get: function get() {
        var supported = typeof document !== 'undefined' && !!document.fonts;

        if (supported && typeof navigator !== 'undefined') {
          var m = /Mozilla\/5.0.*?rv:(\d+).*? Gecko/.exec(navigator.userAgent);

          if (m && m[1] < 63) {
            supported = false;
          }
        }

        return (0, _util.shadow)(this, 'isFontLoadingAPISupported', supported);
      }
    }, {
      key: "isSyncFontLoadingSupported",
      get: function get() {
        var supported = false;

        if (typeof navigator === 'undefined') {
          supported = true;
        } else {
          var m = /Mozilla\/5.0.*?rv:(\d+).*? Gecko/.exec(navigator.userAgent);

          if (m && m[1] >= 14) {
            supported = true;
          }
        }

        return (0, _util.shadow)(this, 'isSyncFontLoadingSupported', supported);
      }
    }, {
      key: "_loadTestFont",
      get: function get() {
        var getLoadTestFont = function getLoadTestFont() {
          return atob('T1RUTwALAIAAAwAwQ0ZGIDHtZg4AAAOYAAAAgUZGVE1lkzZwAAAEHAAAABxHREVGABQA' + 'FQAABDgAAAAeT1MvMlYNYwkAAAEgAAAAYGNtYXABDQLUAAACNAAAAUJoZWFk/xVFDQAA' + 'ALwAAAA2aGhlYQdkA+oAAAD0AAAAJGhtdHgD6AAAAAAEWAAAAAZtYXhwAAJQAAAAARgA' + 'AAAGbmFtZVjmdH4AAAGAAAAAsXBvc3T/hgAzAAADeAAAACAAAQAAAAEAALZRFsRfDzz1' + 'AAsD6AAAAADOBOTLAAAAAM4KHDwAAAAAA+gDIQAAAAgAAgAAAAAAAAABAAADIQAAAFoD' + '6AAAAAAD6AABAAAAAAAAAAAAAAAAAAAAAQAAUAAAAgAAAAQD6AH0AAUAAAKKArwAAACM' + 'AooCvAAAAeAAMQECAAACAAYJAAAAAAAAAAAAAQAAAAAAAAAAAAAAAFBmRWQAwAAuAC4D' + 'IP84AFoDIQAAAAAAAQAAAAAAAAAAACAAIAABAAAADgCuAAEAAAAAAAAAAQAAAAEAAAAA' + 'AAEAAQAAAAEAAAAAAAIAAQAAAAEAAAAAAAMAAQAAAAEAAAAAAAQAAQAAAAEAAAAAAAUA' + 'AQAAAAEAAAAAAAYAAQAAAAMAAQQJAAAAAgABAAMAAQQJAAEAAgABAAMAAQQJAAIAAgAB' + 'AAMAAQQJAAMAAgABAAMAAQQJAAQAAgABAAMAAQQJAAUAAgABAAMAAQQJAAYAAgABWABY' + 'AAAAAAAAAwAAAAMAAAAcAAEAAAAAADwAAwABAAAAHAAEACAAAAAEAAQAAQAAAC7//wAA' + 'AC7////TAAEAAAAAAAABBgAAAQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' + 'AAAAAAAAAAAAAAAAAAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' + 'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' + 'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' + 'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' + 'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAAAAD/gwAyAAAAAQAAAAAAAAAAAAAAAAAA' + 'AAABAAQEAAEBAQJYAAEBASH4DwD4GwHEAvgcA/gXBIwMAYuL+nz5tQXkD5j3CBLnEQAC' + 'AQEBIVhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYAAABAQAADwACAQEEE/t3' + 'Dov6fAH6fAT+fPp8+nwHDosMCvm1Cvm1DAz6fBQAAAAAAAABAAAAAMmJbzEAAAAAzgTj' + 'FQAAAADOBOQpAAEAAAAAAAAADAAUAAQAAAABAAAAAgABAAAAAAAAAAAD6AAAAAAAAA==');
        };

        return (0, _util.shadow)(this, '_loadTestFont', getLoadTestFont());
      }
    }]);

    return GenericFontLoader;
  }(BaseFontLoader);
}
var IsEvalSupportedCached = {
  get value() {
    return (0, _util.shadow)(this, 'value', (0, _util.isEvalSupported)());
  }

};

var FontFaceObject =
/*#__PURE__*/
function () {
  function FontFaceObject(translatedData, _ref2) {
    var _ref2$isEvalSupported = _ref2.isEvalSupported,
        isEvalSupported = _ref2$isEvalSupported === void 0 ? true : _ref2$isEvalSupported,
        _ref2$disableFontFace = _ref2.disableFontFace,
        disableFontFace = _ref2$disableFontFace === void 0 ? false : _ref2$disableFontFace,
        _ref2$ignoreErrors = _ref2.ignoreErrors,
        ignoreErrors = _ref2$ignoreErrors === void 0 ? false : _ref2$ignoreErrors,
        _ref2$onUnsupportedFe = _ref2.onUnsupportedFeature,
        onUnsupportedFeature = _ref2$onUnsupportedFe === void 0 ? null : _ref2$onUnsupportedFe,
        _ref2$fontRegistry = _ref2.fontRegistry,
        fontRegistry = _ref2$fontRegistry === void 0 ? null : _ref2$fontRegistry;

    _classCallCheck(this, FontFaceObject);

    this.compiledGlyphs = Object.create(null);

    for (var i in translatedData) {
      this[i] = translatedData[i];
    }

    this.isEvalSupported = isEvalSupported !== false;
    this.disableFontFace = disableFontFace === true;
    this.ignoreErrors = ignoreErrors === true;
    this._onUnsupportedFeature = onUnsupportedFeature;
    this.fontRegistry = fontRegistry;
  }

  _createClass(FontFaceObject, [{
    key: "createNativeFontFace",
    value: function createNativeFontFace() {
      if (!this.data || this.disableFontFace) {
        return null;
      }

      var nativeFontFace = new FontFace(this.loadedName, this.data, {});

      if (this.fontRegistry) {
        this.fontRegistry.registerFont(this);
      }

      return nativeFontFace;
    }
  }, {
    key: "createFontFaceRule",
    value: function createFontFaceRule() {
      if (!this.data || this.disableFontFace) {
        return null;
      }

      var data = (0, _util.bytesToString)(new Uint8Array(this.data));
      var url = "url(data:".concat(this.mimetype, ";base64,").concat(btoa(data), ");");
      var rule = "@font-face {font-family:\"".concat(this.loadedName, "\";src:").concat(url, "}");

      if (this.fontRegistry) {
        this.fontRegistry.registerFont(this, url);
      }

      return rule;
    }
  }, {
    key: "getPathGenerator",
    value: function getPathGenerator(objs, character) {
      if (this.compiledGlyphs[character] !== undefined) {
        return this.compiledGlyphs[character];
      }

      var cmds, current;

      try {
        cmds = objs.get(this.loadedName + '_path_' + character);
      } catch (ex) {
        if (!this.ignoreErrors) {
          throw ex;
        }

        if (this._onUnsupportedFeature) {
          this._onUnsupportedFeature({
            featureId: _util.UNSUPPORTED_FEATURES.font
          });
        }

        (0, _util.warn)("getPathGenerator - ignoring character: \"".concat(ex, "\"."));
        return this.compiledGlyphs[character] = function (c, size) {};
      }

      if (this.isEvalSupported && IsEvalSupportedCached.value) {
        var args,
            js = '';

        for (var i = 0, ii = cmds.length; i < ii; i++) {
          current = cmds[i];

          if (current.args !== undefined) {
            args = current.args.join(',');
          } else {
            args = '';
          }

          js += 'c.' + current.cmd + '(' + args + ');\n';
        }

        return this.compiledGlyphs[character] = new Function('c', 'size', js);
      }

      return this.compiledGlyphs[character] = function (c, size) {
        for (var _i = 0, _ii = cmds.length; _i < _ii; _i++) {
          current = cmds[_i];

          if (current.cmd === 'scale') {
            current.args = [size, -size];
          }

          c[current.cmd].apply(c, current.args);
        }
      };
    }
  }]);

  return FontFaceObject;
}();

exports.FontFaceObject = FontFaceObject;

/***/ }),
/* 153 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var compatibilityParams = Object.create(null);
{
  var isNodeJS = __w_pdfjs_require__(4);

  var userAgent = typeof navigator !== 'undefined' && navigator.userAgent || '';
  var isIE = /Trident/.test(userAgent);
  var isIOSChrome = /CriOS/.test(userAgent);

  (function checkOnBlobSupport() {
    if (isIE || isIOSChrome) {
      compatibilityParams.disableCreateObjectURL = true;
    }
  })();

  (function checkFontFaceAndImage() {
    if (isNodeJS()) {
      compatibilityParams.disableFontFace = true;
      compatibilityParams.nativeImageDecoderSupport = 'none';
    }
  })();
}
exports.apiCompatibilityParams = Object.freeze(compatibilityParams);

/***/ }),
/* 154 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CanvasGraphics = void 0;

var _util = __w_pdfjs_require__(1);

var _pattern_helper = __w_pdfjs_require__(155);

var MIN_FONT_SIZE = 16;
var MAX_FONT_SIZE = 100;
var MAX_GROUP_SIZE = 4096;
var MIN_WIDTH_FACTOR = 0.65;
var COMPILE_TYPE3_GLYPHS = true;
var MAX_SIZE_TO_COMPILE = 1000;
var FULL_CHUNK_HEIGHT = 16;
var IsLittleEndianCached = {
  get value() {
    return (0, _util.shadow)(IsLittleEndianCached, 'value', (0, _util.isLittleEndian)());
  }

};

function addContextCurrentTransform(ctx) {
  if (!ctx.mozCurrentTransform) {
    ctx._originalSave = ctx.save;
    ctx._originalRestore = ctx.restore;
    ctx._originalRotate = ctx.rotate;
    ctx._originalScale = ctx.scale;
    ctx._originalTranslate = ctx.translate;
    ctx._originalTransform = ctx.transform;
    ctx._originalSetTransform = ctx.setTransform;
    ctx._transformMatrix = ctx._transformMatrix || [1, 0, 0, 1, 0, 0];
    ctx._transformStack = [];
    Object.defineProperty(ctx, 'mozCurrentTransform', {
      get: function getCurrentTransform() {
        return this._transformMatrix;
      }
    });
    Object.defineProperty(ctx, 'mozCurrentTransformInverse', {
      get: function getCurrentTransformInverse() {
        var m = this._transformMatrix;
        var a = m[0],
            b = m[1],
            c = m[2],
            d = m[3],
            e = m[4],
            f = m[5];
        var ad_bc = a * d - b * c;
        var bc_ad = b * c - a * d;
        return [d / ad_bc, b / bc_ad, c / bc_ad, a / ad_bc, (d * e - c * f) / bc_ad, (b * e - a * f) / ad_bc];
      }
    });

    ctx.save = function ctxSave() {
      var old = this._transformMatrix;

      this._transformStack.push(old);

      this._transformMatrix = old.slice(0, 6);

      this._originalSave();
    };

    ctx.restore = function ctxRestore() {
      var prev = this._transformStack.pop();

      if (prev) {
        this._transformMatrix = prev;

        this._originalRestore();
      }
    };

    ctx.translate = function ctxTranslate(x, y) {
      var m = this._transformMatrix;
      m[4] = m[0] * x + m[2] * y + m[4];
      m[5] = m[1] * x + m[3] * y + m[5];

      this._originalTranslate(x, y);
    };

    ctx.scale = function ctxScale(x, y) {
      var m = this._transformMatrix;
      m[0] = m[0] * x;
      m[1] = m[1] * x;
      m[2] = m[2] * y;
      m[3] = m[3] * y;

      this._originalScale(x, y);
    };

    ctx.transform = function ctxTransform(a, b, c, d, e, f) {
      var m = this._transformMatrix;
      this._transformMatrix = [m[0] * a + m[2] * b, m[1] * a + m[3] * b, m[0] * c + m[2] * d, m[1] * c + m[3] * d, m[0] * e + m[2] * f + m[4], m[1] * e + m[3] * f + m[5]];

      ctx._originalTransform(a, b, c, d, e, f);
    };

    ctx.setTransform = function ctxSetTransform(a, b, c, d, e, f) {
      this._transformMatrix = [a, b, c, d, e, f];

      ctx._originalSetTransform(a, b, c, d, e, f);
    };

    ctx.rotate = function ctxRotate(angle) {
      var cosValue = Math.cos(angle);
      var sinValue = Math.sin(angle);
      var m = this._transformMatrix;
      this._transformMatrix = [m[0] * cosValue + m[2] * sinValue, m[1] * cosValue + m[3] * sinValue, m[0] * -sinValue + m[2] * cosValue, m[1] * -sinValue + m[3] * cosValue, m[4], m[5]];

      this._originalRotate(angle);
    };
  }
}

var CachedCanvases = function CachedCanvasesClosure() {
  function CachedCanvases(canvasFactory) {
    this.canvasFactory = canvasFactory;
    this.cache = Object.create(null);
  }

  CachedCanvases.prototype = {
    getCanvas: function CachedCanvases_getCanvas(id, width, height, trackTransform) {
      var canvasEntry;

      if (this.cache[id] !== undefined) {
        canvasEntry = this.cache[id];
        this.canvasFactory.reset(canvasEntry, width, height);
        canvasEntry.context.setTransform(1, 0, 0, 1, 0, 0);
      } else {
        canvasEntry = this.canvasFactory.create(width, height);
        this.cache[id] = canvasEntry;
      }

      if (trackTransform) {
        addContextCurrentTransform(canvasEntry.context);
      }

      return canvasEntry;
    },
    clear: function clear() {
      for (var id in this.cache) {
        var canvasEntry = this.cache[id];
        this.canvasFactory.destroy(canvasEntry);
        delete this.cache[id];
      }
    }
  };
  return CachedCanvases;
}();

function compileType3Glyph(imgData) {
  var POINT_TO_PROCESS_LIMIT = 1000;
  var width = imgData.width,
      height = imgData.height;
  var i,
      j,
      j0,
      width1 = width + 1;
  var points = new Uint8Array(width1 * (height + 1));
  var POINT_TYPES = new Uint8Array([0, 2, 4, 0, 1, 0, 5, 4, 8, 10, 0, 8, 0, 2, 1, 0]);
  var lineSize = width + 7 & ~7,
      data0 = imgData.data;
  var data = new Uint8Array(lineSize * height),
      pos = 0,
      ii;

  for (i = 0, ii = data0.length; i < ii; i++) {
    var mask = 128,
        elem = data0[i];

    while (mask > 0) {
      data[pos++] = elem & mask ? 0 : 255;
      mask >>= 1;
    }
  }

  var count = 0;
  pos = 0;

  if (data[pos] !== 0) {
    points[0] = 1;
    ++count;
  }

  for (j = 1; j < width; j++) {
    if (data[pos] !== data[pos + 1]) {
      points[j] = data[pos] ? 2 : 1;
      ++count;
    }

    pos++;
  }

  if (data[pos] !== 0) {
    points[j] = 2;
    ++count;
  }

  for (i = 1; i < height; i++) {
    pos = i * lineSize;
    j0 = i * width1;

    if (data[pos - lineSize] !== data[pos]) {
      points[j0] = data[pos] ? 1 : 8;
      ++count;
    }

    var sum = (data[pos] ? 4 : 0) + (data[pos - lineSize] ? 8 : 0);

    for (j = 1; j < width; j++) {
      sum = (sum >> 2) + (data[pos + 1] ? 4 : 0) + (data[pos - lineSize + 1] ? 8 : 0);

      if (POINT_TYPES[sum]) {
        points[j0 + j] = POINT_TYPES[sum];
        ++count;
      }

      pos++;
    }

    if (data[pos - lineSize] !== data[pos]) {
      points[j0 + j] = data[pos] ? 2 : 4;
      ++count;
    }

    if (count > POINT_TO_PROCESS_LIMIT) {
      return null;
    }
  }

  pos = lineSize * (height - 1);
  j0 = i * width1;

  if (data[pos] !== 0) {
    points[j0] = 8;
    ++count;
  }

  for (j = 1; j < width; j++) {
    if (data[pos] !== data[pos + 1]) {
      points[j0 + j] = data[pos] ? 4 : 8;
      ++count;
    }

    pos++;
  }

  if (data[pos] !== 0) {
    points[j0 + j] = 4;
    ++count;
  }

  if (count > POINT_TO_PROCESS_LIMIT) {
    return null;
  }

  var steps = new Int32Array([0, width1, -1, 0, -width1, 0, 0, 0, 1]);
  var outlines = [];

  for (i = 0; count && i <= height; i++) {
    var p = i * width1;
    var end = p + width;

    while (p < end && !points[p]) {
      p++;
    }

    if (p === end) {
      continue;
    }

    var coords = [p % width1, i];
    var type = points[p],
        p0 = p,
        pp;

    do {
      var step = steps[type];

      do {
        p += step;
      } while (!points[p]);

      pp = points[p];

      if (pp !== 5 && pp !== 10) {
        type = pp;
        points[p] = 0;
      } else {
        type = pp & 0x33 * type >> 4;
        points[p] &= type >> 2 | type << 2;
      }

      coords.push(p % width1);
      coords.push(p / width1 | 0);
      --count;
    } while (p0 !== p);

    outlines.push(coords);
    --i;
  }

  var drawOutline = function drawOutline(c) {
    c.save();
    c.scale(1 / width, -1 / height);
    c.translate(0, -height);
    c.beginPath();

    for (var i = 0, ii = outlines.length; i < ii; i++) {
      var o = outlines[i];
      c.moveTo(o[0], o[1]);

      for (var j = 2, jj = o.length; j < jj; j += 2) {
        c.lineTo(o[j], o[j + 1]);
      }
    }

    c.fill();
    c.beginPath();
    c.restore();
  };

  return drawOutline;
}

var CanvasExtraState = function CanvasExtraStateClosure() {
  function CanvasExtraState() {
    this.alphaIsShape = false;
    this.fontSize = 0;
    this.fontSizeScale = 1;
    this.textMatrix = _util.IDENTITY_MATRIX;
    this.textMatrixScale = 1;
    this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
    this.leading = 0;
    this.x = 0;
    this.y = 0;
    this.lineX = 0;
    this.lineY = 0;
    this.charSpacing = 0;
    this.wordSpacing = 0;
    this.textHScale = 1;
    this.textRenderingMode = _util.TextRenderingMode.FILL;
    this.textRise = 0;
    this.fillColor = '#000000';
    this.strokeColor = '#000000';
    this.patternFill = false;
    this.fillAlpha = 1;
    this.strokeAlpha = 1;
    this.lineWidth = 1;
    this.activeSMask = null;
    this.resumeSMaskCtx = null;
  }

  CanvasExtraState.prototype = {
    clone: function CanvasExtraState_clone() {
      return Object.create(this);
    },
    setCurrentPoint: function CanvasExtraState_setCurrentPoint(x, y) {
      this.x = x;
      this.y = y;
    }
  };
  return CanvasExtraState;
}();

var CanvasGraphics = function CanvasGraphicsClosure() {
  var EXECUTION_TIME = 15;
  var EXECUTION_STEPS = 10;

  function CanvasGraphics(canvasCtx, commonObjs, objs, canvasFactory, webGLContext, imageLayer) {
    this.ctx = canvasCtx;
    this.current = new CanvasExtraState();
    this.stateStack = [];
    this.pendingClip = null;
    this.pendingEOFill = false;
    this.res = null;
    this.xobjs = null;
    this.commonObjs = commonObjs;
    this.objs = objs;
    this.canvasFactory = canvasFactory;
    this.webGLContext = webGLContext;
    this.imageLayer = imageLayer;
    this.groupStack = [];
    this.processingType3 = null;
    this.baseTransform = null;
    this.baseTransformStack = [];
    this.groupLevel = 0;
    this.smaskStack = [];
    this.smaskCounter = 0;
    this.tempSMask = null;
    this.cachedCanvases = new CachedCanvases(this.canvasFactory);

    if (canvasCtx) {
      addContextCurrentTransform(canvasCtx);
    }

    this._cachedGetSinglePixelWidth = null;
  }

  function putBinaryImageData(ctx, imgData) {
    if (typeof ImageData !== 'undefined' && imgData instanceof ImageData) {
      ctx.putImageData(imgData, 0, 0);
      return;
    }

    var height = imgData.height,
        width = imgData.width;
    var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
    var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
    var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
    var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
    var srcPos = 0,
        destPos;
    var src = imgData.data;
    var dest = chunkImgData.data;
    var i, j, thisChunkHeight, elemsInThisChunk;

    if (imgData.kind === _util.ImageKind.GRAYSCALE_1BPP) {
      var srcLength = src.byteLength;
      var dest32 = new Uint32Array(dest.buffer, 0, dest.byteLength >> 2);
      var dest32DataLength = dest32.length;
      var fullSrcDiff = width + 7 >> 3;
      var white = 0xFFFFFFFF;
      var black = IsLittleEndianCached.value ? 0xFF000000 : 0x000000FF;

      for (i = 0; i < totalChunks; i++) {
        thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
        destPos = 0;

        for (j = 0; j < thisChunkHeight; j++) {
          var srcDiff = srcLength - srcPos;
          var k = 0;
          var kEnd = srcDiff > fullSrcDiff ? width : srcDiff * 8 - 7;
          var kEndUnrolled = kEnd & ~7;
          var mask = 0;
          var srcByte = 0;

          for (; k < kEndUnrolled; k += 8) {
            srcByte = src[srcPos++];
            dest32[destPos++] = srcByte & 128 ? white : black;
            dest32[destPos++] = srcByte & 64 ? white : black;
            dest32[destPos++] = srcByte & 32 ? white : black;
            dest32[destPos++] = srcByte & 16 ? white : black;
            dest32[destPos++] = srcByte & 8 ? white : black;
            dest32[destPos++] = srcByte & 4 ? white : black;
            dest32[destPos++] = srcByte & 2 ? white : black;
            dest32[destPos++] = srcByte & 1 ? white : black;
          }

          for (; k < kEnd; k++) {
            if (mask === 0) {
              srcByte = src[srcPos++];
              mask = 128;
            }

            dest32[destPos++] = srcByte & mask ? white : black;
            mask >>= 1;
          }
        }

        while (destPos < dest32DataLength) {
          dest32[destPos++] = 0;
        }

        ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
      }
    } else if (imgData.kind === _util.ImageKind.RGBA_32BPP) {
      j = 0;
      elemsInThisChunk = width * FULL_CHUNK_HEIGHT * 4;

      for (i = 0; i < fullChunks; i++) {
        dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));
        srcPos += elemsInThisChunk;
        ctx.putImageData(chunkImgData, 0, j);
        j += FULL_CHUNK_HEIGHT;
      }

      if (i < totalChunks) {
        elemsInThisChunk = width * partialChunkHeight * 4;
        dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));
        ctx.putImageData(chunkImgData, 0, j);
      }
    } else if (imgData.kind === _util.ImageKind.RGB_24BPP) {
      thisChunkHeight = FULL_CHUNK_HEIGHT;
      elemsInThisChunk = width * thisChunkHeight;

      for (i = 0; i < totalChunks; i++) {
        if (i >= fullChunks) {
          thisChunkHeight = partialChunkHeight;
          elemsInThisChunk = width * thisChunkHeight;
        }

        destPos = 0;

        for (j = elemsInThisChunk; j--;) {
          dest[destPos++] = src[srcPos++];
          dest[destPos++] = src[srcPos++];
          dest[destPos++] = src[srcPos++];
          dest[destPos++] = 255;
        }

        ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
      }
    } else {
      throw new Error("bad image kind: ".concat(imgData.kind));
    }
  }

  function putBinaryImageMask(ctx, imgData) {
    var height = imgData.height,
        width = imgData.width;
    var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
    var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
    var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
    var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
    var srcPos = 0;
    var src = imgData.data;
    var dest = chunkImgData.data;

    for (var i = 0; i < totalChunks; i++) {
      var thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
      var destPos = 3;

      for (var j = 0; j < thisChunkHeight; j++) {
        var mask = 0;

        for (var k = 0; k < width; k++) {
          if (!mask) {
            var elem = src[srcPos++];
            mask = 128;
          }

          dest[destPos] = elem & mask ? 0 : 255;
          destPos += 4;
          mask >>= 1;
        }
      }

      ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
    }
  }

  function copyCtxState(sourceCtx, destCtx) {
    var properties = ['strokeStyle', 'fillStyle', 'fillRule', 'globalAlpha', 'lineWidth', 'lineCap', 'lineJoin', 'miterLimit', 'globalCompositeOperation', 'font'];

    for (var i = 0, ii = properties.length; i < ii; i++) {
      var property = properties[i];

      if (sourceCtx[property] !== undefined) {
        destCtx[property] = sourceCtx[property];
      }
    }

    if (sourceCtx.setLineDash !== undefined) {
      destCtx.setLineDash(sourceCtx.getLineDash());
      destCtx.lineDashOffset = sourceCtx.lineDashOffset;
    }
  }

  function resetCtxToDefault(ctx) {
    ctx.strokeStyle = '#000000';
    ctx.fillStyle = '#000000';
    ctx.fillRule = 'nonzero';
    ctx.globalAlpha = 1;
    ctx.lineWidth = 1;
    ctx.lineCap = 'butt';
    ctx.lineJoin = 'miter';
    ctx.miterLimit = 10;
    ctx.globalCompositeOperation = 'source-over';
    ctx.font = '10px sans-serif';

    if (ctx.setLineDash !== undefined) {
      ctx.setLineDash([]);
      ctx.lineDashOffset = 0;
    }
  }

  function composeSMaskBackdrop(bytes, r0, g0, b0) {
    var length = bytes.length;

    for (var i = 3; i < length; i += 4) {
      var alpha = bytes[i];

      if (alpha === 0) {
        bytes[i - 3] = r0;
        bytes[i - 2] = g0;
        bytes[i - 1] = b0;
      } else if (alpha < 255) {
        var alpha_ = 255 - alpha;
        bytes[i - 3] = bytes[i - 3] * alpha + r0 * alpha_ >> 8;
        bytes[i - 2] = bytes[i - 2] * alpha + g0 * alpha_ >> 8;
        bytes[i - 1] = bytes[i - 1] * alpha + b0 * alpha_ >> 8;
      }
    }
  }

  function composeSMaskAlpha(maskData, layerData, transferMap) {
    var length = maskData.length;
    var scale = 1 / 255;

    for (var i = 3; i < length; i += 4) {
      var alpha = transferMap ? transferMap[maskData[i]] : maskData[i];
      layerData[i] = layerData[i] * alpha * scale | 0;
    }
  }

  function composeSMaskLuminosity(maskData, layerData, transferMap) {
    var length = maskData.length;

    for (var i = 3; i < length; i += 4) {
      var y = maskData[i - 3] * 77 + maskData[i - 2] * 152 + maskData[i - 1] * 28;
      layerData[i] = transferMap ? layerData[i] * transferMap[y >> 8] >> 8 : layerData[i] * y >> 16;
    }
  }

  function genericComposeSMask(maskCtx, layerCtx, width, height, subtype, backdrop, transferMap) {
    var hasBackdrop = !!backdrop;
    var r0 = hasBackdrop ? backdrop[0] : 0;
    var g0 = hasBackdrop ? backdrop[1] : 0;
    var b0 = hasBackdrop ? backdrop[2] : 0;
    var composeFn;

    if (subtype === 'Luminosity') {
      composeFn = composeSMaskLuminosity;
    } else {
      composeFn = composeSMaskAlpha;
    }

    var PIXELS_TO_PROCESS = 1048576;
    var chunkSize = Math.min(height, Math.ceil(PIXELS_TO_PROCESS / width));

    for (var row = 0; row < height; row += chunkSize) {
      var chunkHeight = Math.min(chunkSize, height - row);
      var maskData = maskCtx.getImageData(0, row, width, chunkHeight);
      var layerData = layerCtx.getImageData(0, row, width, chunkHeight);

      if (hasBackdrop) {
        composeSMaskBackdrop(maskData.data, r0, g0, b0);
      }

      composeFn(maskData.data, layerData.data, transferMap);
      maskCtx.putImageData(layerData, 0, row);
    }
  }

  function composeSMask(ctx, smask, layerCtx, webGLContext) {
    var mask = smask.canvas;
    var maskCtx = smask.context;
    ctx.setTransform(smask.scaleX, 0, 0, smask.scaleY, smask.offsetX, smask.offsetY);
    var backdrop = smask.backdrop || null;

    if (!smask.transferMap && webGLContext.isEnabled) {
      var composed = webGLContext.composeSMask({
        layer: layerCtx.canvas,
        mask: mask,
        properties: {
          subtype: smask.subtype,
          backdrop: backdrop
        }
      });
      ctx.setTransform(1, 0, 0, 1, 0, 0);
      ctx.drawImage(composed, smask.offsetX, smask.offsetY);
      return;
    }

    genericComposeSMask(maskCtx, layerCtx, mask.width, mask.height, smask.subtype, backdrop, smask.transferMap);
    ctx.drawImage(mask, 0, 0);
  }

  var LINE_CAP_STYLES = ['butt', 'round', 'square'];
  var LINE_JOIN_STYLES = ['miter', 'round', 'bevel'];
  var NORMAL_CLIP = {};
  var EO_CLIP = {};
  CanvasGraphics.prototype = {
    beginDrawing: function beginDrawing(_ref) {
      var transform = _ref.transform,
          viewport = _ref.viewport,
          _ref$transparency = _ref.transparency,
          transparency = _ref$transparency === void 0 ? false : _ref$transparency,
          _ref$background = _ref.background,
          background = _ref$background === void 0 ? null : _ref$background;
      var width = this.ctx.canvas.width;
      var height = this.ctx.canvas.height;
      this.ctx.save();
      this.ctx.fillStyle = background || 'rgb(255, 255, 255)';
      this.ctx.fillRect(0, 0, width, height);
      this.ctx.restore();

      if (transparency) {
        var transparentCanvas = this.cachedCanvases.getCanvas('transparent', width, height, true);
        this.compositeCtx = this.ctx;
        this.transparentCanvas = transparentCanvas.canvas;
        this.ctx = transparentCanvas.context;
        this.ctx.save();
        this.ctx.transform.apply(this.ctx, this.compositeCtx.mozCurrentTransform);
      }

      this.ctx.save();
      resetCtxToDefault(this.ctx);

      if (transform) {
        this.ctx.transform.apply(this.ctx, transform);
      }

      this.ctx.transform.apply(this.ctx, viewport.transform);
      this.baseTransform = this.ctx.mozCurrentTransform.slice();

      if (this.imageLayer) {
        this.imageLayer.beginLayout();
      }
    },
    executeOperatorList: function CanvasGraphics_executeOperatorList(operatorList, executionStartIdx, continueCallback, stepper) {
      var argsArray = operatorList.argsArray;
      var fnArray = operatorList.fnArray;
      var i = executionStartIdx || 0;
      var argsArrayLen = argsArray.length;

      if (argsArrayLen === i) {
        return i;
      }

      var chunkOperations = argsArrayLen - i > EXECUTION_STEPS && typeof continueCallback === 'function';
      var endTime = chunkOperations ? Date.now() + EXECUTION_TIME : 0;
      var steps = 0;
      var commonObjs = this.commonObjs;
      var objs = this.objs;
      var fnId;

      while (true) {
        if (stepper !== undefined && i === stepper.nextBreakPoint) {
          stepper.breakIt(i, continueCallback);
          return i;
        }

        fnId = fnArray[i];

        if (fnId !== _util.OPS.dependency) {
          this[fnId].apply(this, argsArray[i]);
        } else {
          var deps = argsArray[i];

          for (var n = 0, nn = deps.length; n < nn; n++) {
            var depObjId = deps[n];
            var common = depObjId[0] === 'g' && depObjId[1] === '_';
            var objsPool = common ? commonObjs : objs;

            if (!objsPool.has(depObjId)) {
              objsPool.get(depObjId, continueCallback);
              return i;
            }
          }
        }

        i++;

        if (i === argsArrayLen) {
          return i;
        }

        if (chunkOperations && ++steps > EXECUTION_STEPS) {
          if (Date.now() > endTime) {
            continueCallback();
            return i;
          }

          steps = 0;
        }
      }
    },
    endDrawing: function CanvasGraphics_endDrawing() {
      if (this.current.activeSMask !== null) {
        this.endSMaskGroup();
      }

      this.ctx.restore();

      if (this.transparentCanvas) {
        this.ctx = this.compositeCtx;
        this.ctx.save();
        this.ctx.setTransform(1, 0, 0, 1, 0, 0);
        this.ctx.drawImage(this.transparentCanvas, 0, 0);
        this.ctx.restore();
        this.transparentCanvas = null;
      }

      this.cachedCanvases.clear();
      this.webGLContext.clear();

      if (this.imageLayer) {
        this.imageLayer.endLayout();
      }
    },
    setLineWidth: function CanvasGraphics_setLineWidth(width) {
      this.current.lineWidth = width;
      this.ctx.lineWidth = width;
    },
    setLineCap: function CanvasGraphics_setLineCap(style) {
      this.ctx.lineCap = LINE_CAP_STYLES[style];
    },
    setLineJoin: function CanvasGraphics_setLineJoin(style) {
      this.ctx.lineJoin = LINE_JOIN_STYLES[style];
    },
    setMiterLimit: function CanvasGraphics_setMiterLimit(limit) {
      this.ctx.miterLimit = limit;
    },
    setDash: function CanvasGraphics_setDash(dashArray, dashPhase) {
      var ctx = this.ctx;

      if (ctx.setLineDash !== undefined) {
        ctx.setLineDash(dashArray);
        ctx.lineDashOffset = dashPhase;
      }
    },
    setRenderingIntent: function CanvasGraphics_setRenderingIntent(intent) {},
    setFlatness: function CanvasGraphics_setFlatness(flatness) {},
    setGState: function CanvasGraphics_setGState(states) {
      for (var i = 0, ii = states.length; i < ii; i++) {
        var state = states[i];
        var key = state[0];
        var value = state[1];

        switch (key) {
          case 'LW':
            this.setLineWidth(value);
            break;

          case 'LC':
            this.setLineCap(value);
            break;

          case 'LJ':
            this.setLineJoin(value);
            break;

          case 'ML':
            this.setMiterLimit(value);
            break;

          case 'D':
            this.setDash(value[0], value[1]);
            break;

          case 'RI':
            this.setRenderingIntent(value);
            break;

          case 'FL':
            this.setFlatness(value);
            break;

          case 'Font':
            this.setFont(value[0], value[1]);
            break;

          case 'CA':
            this.current.strokeAlpha = state[1];
            break;

          case 'ca':
            this.current.fillAlpha = state[1];
            this.ctx.globalAlpha = state[1];
            break;

          case 'BM':
            this.ctx.globalCompositeOperation = value;
            break;

          case 'SMask':
            if (this.current.activeSMask) {
              if (this.stateStack.length > 0 && this.stateStack[this.stateStack.length - 1].activeSMask === this.current.activeSMask) {
                this.suspendSMaskGroup();
              } else {
                this.endSMaskGroup();
              }
            }

            this.current.activeSMask = value ? this.tempSMask : null;

            if (this.current.activeSMask) {
              this.beginSMaskGroup();
            }

            this.tempSMask = null;
            break;
        }
      }
    },
    beginSMaskGroup: function CanvasGraphics_beginSMaskGroup() {
      var activeSMask = this.current.activeSMask;
      var drawnWidth = activeSMask.canvas.width;
      var drawnHeight = activeSMask.canvas.height;
      var cacheId = 'smaskGroupAt' + this.groupLevel;
      var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight, true);
      var currentCtx = this.ctx;
      var currentTransform = currentCtx.mozCurrentTransform;
      this.ctx.save();
      var groupCtx = scratchCanvas.context;
      groupCtx.scale(1 / activeSMask.scaleX, 1 / activeSMask.scaleY);
      groupCtx.translate(-activeSMask.offsetX, -activeSMask.offsetY);
      groupCtx.transform.apply(groupCtx, currentTransform);
      activeSMask.startTransformInverse = groupCtx.mozCurrentTransformInverse;
      copyCtxState(currentCtx, groupCtx);
      this.ctx = groupCtx;
      this.setGState([['BM', 'source-over'], ['ca', 1], ['CA', 1]]);
      this.groupStack.push(currentCtx);
      this.groupLevel++;
    },
    suspendSMaskGroup: function CanvasGraphics_endSMaskGroup() {
      var groupCtx = this.ctx;
      this.groupLevel--;
      this.ctx = this.groupStack.pop();
      composeSMask(this.ctx, this.current.activeSMask, groupCtx, this.webGLContext);
      this.ctx.restore();
      this.ctx.save();
      copyCtxState(groupCtx, this.ctx);
      this.current.resumeSMaskCtx = groupCtx;

      var deltaTransform = _util.Util.transform(this.current.activeSMask.startTransformInverse, groupCtx.mozCurrentTransform);

      this.ctx.transform.apply(this.ctx, deltaTransform);
      groupCtx.save();
      groupCtx.setTransform(1, 0, 0, 1, 0, 0);
      groupCtx.clearRect(0, 0, groupCtx.canvas.width, groupCtx.canvas.height);
      groupCtx.restore();
    },
    resumeSMaskGroup: function CanvasGraphics_endSMaskGroup() {
      var groupCtx = this.current.resumeSMaskCtx;
      var currentCtx = this.ctx;
      this.ctx = groupCtx;
      this.groupStack.push(currentCtx);
      this.groupLevel++;
    },
    endSMaskGroup: function CanvasGraphics_endSMaskGroup() {
      var groupCtx = this.ctx;
      this.groupLevel--;
      this.ctx = this.groupStack.pop();
      composeSMask(this.ctx, this.current.activeSMask, groupCtx, this.webGLContext);
      this.ctx.restore();
      copyCtxState(groupCtx, this.ctx);

      var deltaTransform = _util.Util.transform(this.current.activeSMask.startTransformInverse, groupCtx.mozCurrentTransform);

      this.ctx.transform.apply(this.ctx, deltaTransform);
    },
    save: function CanvasGraphics_save() {
      this.ctx.save();
      var old = this.current;
      this.stateStack.push(old);
      this.current = old.clone();
      this.current.resumeSMaskCtx = null;
    },
    restore: function CanvasGraphics_restore() {
      if (this.current.resumeSMaskCtx) {
        this.resumeSMaskGroup();
      }

      if (this.current.activeSMask !== null && (this.stateStack.length === 0 || this.stateStack[this.stateStack.length - 1].activeSMask !== this.current.activeSMask)) {
        this.endSMaskGroup();
      }

      if (this.stateStack.length !== 0) {
        this.current = this.stateStack.pop();
        this.ctx.restore();
        this.pendingClip = null;
        this._cachedGetSinglePixelWidth = null;
      }
    },
    transform: function CanvasGraphics_transform(a, b, c, d, e, f) {
      this.ctx.transform(a, b, c, d, e, f);
      this._cachedGetSinglePixelWidth = null;
    },
    constructPath: function CanvasGraphics_constructPath(ops, args) {
      var ctx = this.ctx;
      var current = this.current;
      var x = current.x,
          y = current.y;

      for (var i = 0, j = 0, ii = ops.length; i < ii; i++) {
        switch (ops[i] | 0) {
          case _util.OPS.rectangle:
            x = args[j++];
            y = args[j++];
            var width = args[j++];
            var height = args[j++];

            if (width === 0) {
              width = this.getSinglePixelWidth();
            }

            if (height === 0) {
              height = this.getSinglePixelWidth();
            }

            var xw = x + width;
            var yh = y + height;
            this.ctx.moveTo(x, y);
            this.ctx.lineTo(xw, y);
            this.ctx.lineTo(xw, yh);
            this.ctx.lineTo(x, yh);
            this.ctx.lineTo(x, y);
            this.ctx.closePath();
            break;

          case _util.OPS.moveTo:
            x = args[j++];
            y = args[j++];
            ctx.moveTo(x, y);
            break;

          case _util.OPS.lineTo:
            x = args[j++];
            y = args[j++];
            ctx.lineTo(x, y);
            break;

          case _util.OPS.curveTo:
            x = args[j + 4];
            y = args[j + 5];
            ctx.bezierCurveTo(args[j], args[j + 1], args[j + 2], args[j + 3], x, y);
            j += 6;
            break;

          case _util.OPS.curveTo2:
            ctx.bezierCurveTo(x, y, args[j], args[j + 1], args[j + 2], args[j + 3]);
            x = args[j + 2];
            y = args[j + 3];
            j += 4;
            break;

          case _util.OPS.curveTo3:
            x = args[j + 2];
            y = args[j + 3];
            ctx.bezierCurveTo(args[j], args[j + 1], x, y, x, y);
            j += 4;
            break;

          case _util.OPS.closePath:
            ctx.closePath();
            break;
        }
      }

      current.setCurrentPoint(x, y);
    },
    closePath: function CanvasGraphics_closePath() {
      this.ctx.closePath();
    },
    stroke: function CanvasGraphics_stroke(consumePath) {
      consumePath = typeof consumePath !== 'undefined' ? consumePath : true;
      var ctx = this.ctx;
      var strokeColor = this.current.strokeColor;
      ctx.lineWidth = Math.max(this.getSinglePixelWidth() * MIN_WIDTH_FACTOR, this.current.lineWidth);
      ctx.globalAlpha = this.current.strokeAlpha;

      if (strokeColor && strokeColor.hasOwnProperty('type') && strokeColor.type === 'Pattern') {
        ctx.save();
        ctx.strokeStyle = strokeColor.getPattern(ctx, this);
        ctx.stroke();
        ctx.restore();
      } else {
        ctx.stroke();
      }

      if (consumePath) {
        this.consumePath();
      }

      ctx.globalAlpha = this.current.fillAlpha;
    },
    closeStroke: function CanvasGraphics_closeStroke() {
      this.closePath();
      this.stroke();
    },
    fill: function CanvasGraphics_fill(consumePath) {
      consumePath = typeof consumePath !== 'undefined' ? consumePath : true;
      var ctx = this.ctx;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var needRestore = false;

      if (isPatternFill) {
        ctx.save();

        if (this.baseTransform) {
          ctx.setTransform.apply(ctx, this.baseTransform);
        }

        ctx.fillStyle = fillColor.getPattern(ctx, this);
        needRestore = true;
      }

      if (this.pendingEOFill) {
        ctx.fill('evenodd');
        this.pendingEOFill = false;
      } else {
        ctx.fill();
      }

      if (needRestore) {
        ctx.restore();
      }

      if (consumePath) {
        this.consumePath();
      }
    },
    eoFill: function CanvasGraphics_eoFill() {
      this.pendingEOFill = true;
      this.fill();
    },
    fillStroke: function CanvasGraphics_fillStroke() {
      this.fill(false);
      this.stroke(false);
      this.consumePath();
    },
    eoFillStroke: function CanvasGraphics_eoFillStroke() {
      this.pendingEOFill = true;
      this.fillStroke();
    },
    closeFillStroke: function CanvasGraphics_closeFillStroke() {
      this.closePath();
      this.fillStroke();
    },
    closeEOFillStroke: function CanvasGraphics_closeEOFillStroke() {
      this.pendingEOFill = true;
      this.closePath();
      this.fillStroke();
    },
    endPath: function CanvasGraphics_endPath() {
      this.consumePath();
    },
    clip: function CanvasGraphics_clip() {
      this.pendingClip = NORMAL_CLIP;
    },
    eoClip: function CanvasGraphics_eoClip() {
      this.pendingClip = EO_CLIP;
    },
    beginText: function CanvasGraphics_beginText() {
      this.current.textMatrix = _util.IDENTITY_MATRIX;
      this.current.textMatrixScale = 1;
      this.current.x = this.current.lineX = 0;
      this.current.y = this.current.lineY = 0;
    },
    endText: function CanvasGraphics_endText() {
      var paths = this.pendingTextPaths;
      var ctx = this.ctx;

      if (paths === undefined) {
        ctx.beginPath();
        return;
      }

      ctx.save();
      ctx.beginPath();

      for (var i = 0; i < paths.length; i++) {
        var path = paths[i];
        ctx.setTransform.apply(ctx, path.transform);
        ctx.translate(path.x, path.y);
        path.addToPath(ctx, path.fontSize);
      }

      ctx.restore();
      ctx.clip();
      ctx.beginPath();
      delete this.pendingTextPaths;
    },
    setCharSpacing: function CanvasGraphics_setCharSpacing(spacing) {
      this.current.charSpacing = spacing;
    },
    setWordSpacing: function CanvasGraphics_setWordSpacing(spacing) {
      this.current.wordSpacing = spacing;
    },
    setHScale: function CanvasGraphics_setHScale(scale) {
      this.current.textHScale = scale / 100;
    },
    setLeading: function CanvasGraphics_setLeading(leading) {
      this.current.leading = -leading;
    },
    setFont: function CanvasGraphics_setFont(fontRefName, size) {
      var fontObj = this.commonObjs.get(fontRefName);
      var current = this.current;

      if (!fontObj) {
        throw new Error("Can't find font for ".concat(fontRefName));
      }

      current.fontMatrix = fontObj.fontMatrix ? fontObj.fontMatrix : _util.FONT_IDENTITY_MATRIX;

      if (current.fontMatrix[0] === 0 || current.fontMatrix[3] === 0) {
        (0, _util.warn)('Invalid font matrix for font ' + fontRefName);
      }

      if (size < 0) {
        size = -size;
        current.fontDirection = -1;
      } else {
        current.fontDirection = 1;
      }

      this.current.font = fontObj;
      this.current.fontSize = size;

      if (fontObj.isType3Font) {
        return;
      }

      var name = fontObj.loadedName || 'sans-serif';
      var bold = fontObj.black ? '900' : fontObj.bold ? 'bold' : 'normal';
      var italic = fontObj.italic ? 'italic' : 'normal';
      var typeface = "\"".concat(name, "\", ").concat(fontObj.fallbackName);
      var browserFontSize = size < MIN_FONT_SIZE ? MIN_FONT_SIZE : size > MAX_FONT_SIZE ? MAX_FONT_SIZE : size;
      this.current.fontSizeScale = size / browserFontSize;
      this.ctx.font = "".concat(italic, " ").concat(bold, " ").concat(browserFontSize, "px ").concat(typeface);
    },
    setTextRenderingMode: function CanvasGraphics_setTextRenderingMode(mode) {
      this.current.textRenderingMode = mode;
    },
    setTextRise: function CanvasGraphics_setTextRise(rise) {
      this.current.textRise = rise;
    },
    moveText: function CanvasGraphics_moveText(x, y) {
      this.current.x = this.current.lineX += x;
      this.current.y = this.current.lineY += y;
    },
    setLeadingMoveText: function CanvasGraphics_setLeadingMoveText(x, y) {
      this.setLeading(-y);
      this.moveText(x, y);
    },
    setTextMatrix: function CanvasGraphics_setTextMatrix(a, b, c, d, e, f) {
      this.current.textMatrix = [a, b, c, d, e, f];
      this.current.textMatrixScale = Math.sqrt(a * a + b * b);
      this.current.x = this.current.lineX = 0;
      this.current.y = this.current.lineY = 0;
    },
    nextLine: function CanvasGraphics_nextLine() {
      this.moveText(0, this.current.leading);
    },
    paintChar: function paintChar(character, x, y, patternTransform) {
      var ctx = this.ctx;
      var current = this.current;
      var font = current.font;
      var textRenderingMode = current.textRenderingMode;
      var fontSize = current.fontSize / current.fontSizeScale;
      var fillStrokeMode = textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;
      var isAddToPathSet = !!(textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG);
      var patternFill = current.patternFill && font.data;
      var addToPath;

      if (font.disableFontFace || isAddToPathSet || patternFill) {
        addToPath = font.getPathGenerator(this.commonObjs, character);
      }

      if (font.disableFontFace || patternFill) {
        ctx.save();
        ctx.translate(x, y);
        ctx.beginPath();
        addToPath(ctx, fontSize);

        if (patternTransform) {
          ctx.setTransform.apply(ctx, patternTransform);
        }

        if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.fill();
        }

        if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.stroke();
        }

        ctx.restore();
      } else {
        if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.fillText(character, x, y);
        }

        if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          ctx.strokeText(character, x, y);
        }
      }

      if (isAddToPathSet) {
        var paths = this.pendingTextPaths || (this.pendingTextPaths = []);
        paths.push({
          transform: ctx.mozCurrentTransform,
          x: x,
          y: y,
          fontSize: fontSize,
          addToPath: addToPath
        });
      }
    },

    get isFontSubpixelAAEnabled() {
      var ctx = this.canvasFactory.create(10, 10).context;
      ctx.scale(1.5, 1);
      ctx.fillText('I', 0, 10);
      var data = ctx.getImageData(0, 0, 10, 10).data;
      var enabled = false;

      for (var i = 3; i < data.length; i += 4) {
        if (data[i] > 0 && data[i] < 255) {
          enabled = true;
          break;
        }
      }

      return (0, _util.shadow)(this, 'isFontSubpixelAAEnabled', enabled);
    },

    showText: function CanvasGraphics_showText(glyphs) {
      var current = this.current;
      var font = current.font;

      if (font.isType3Font) {
        return this.showType3Text(glyphs);
      }

      var fontSize = current.fontSize;

      if (fontSize === 0) {
        return;
      }

      var ctx = this.ctx;
      var fontSizeScale = current.fontSizeScale;
      var charSpacing = current.charSpacing;
      var wordSpacing = current.wordSpacing;
      var fontDirection = current.fontDirection;
      var textHScale = current.textHScale * fontDirection;
      var glyphsLength = glyphs.length;
      var vertical = font.vertical;
      var spacingDir = vertical ? 1 : -1;
      var defaultVMetrics = font.defaultVMetrics;
      var widthAdvanceScale = fontSize * current.fontMatrix[0];
      var simpleFillText = current.textRenderingMode === _util.TextRenderingMode.FILL && !font.disableFontFace && !current.patternFill;
      ctx.save();
      var patternTransform;

      if (current.patternFill) {
        ctx.save();
        var pattern = current.fillColor.getPattern(ctx, this);
        patternTransform = ctx.mozCurrentTransform;
        ctx.restore();
        ctx.fillStyle = pattern;
      }

      ctx.transform.apply(ctx, current.textMatrix);
      ctx.translate(current.x, current.y + current.textRise);

      if (fontDirection > 0) {
        ctx.scale(textHScale, -1);
      } else {
        ctx.scale(textHScale, 1);
      }

      var lineWidth = current.lineWidth;
      var scale = current.textMatrixScale;

      if (scale === 0 || lineWidth === 0) {
        var fillStrokeMode = current.textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;

        if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          this._cachedGetSinglePixelWidth = null;
          lineWidth = this.getSinglePixelWidth() * MIN_WIDTH_FACTOR;
        }
      } else {
        lineWidth /= scale;
      }

      if (fontSizeScale !== 1.0) {
        ctx.scale(fontSizeScale, fontSizeScale);
        lineWidth /= fontSizeScale;
      }

      ctx.lineWidth = lineWidth;
      var x = 0,
          i;

      for (i = 0; i < glyphsLength; ++i) {
        var glyph = glyphs[i];

        if ((0, _util.isNum)(glyph)) {
          x += spacingDir * glyph * fontSize / 1000;
          continue;
        }

        var restoreNeeded = false;
        var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
        var character = glyph.fontChar;
        var accent = glyph.accent;
        var scaledX, scaledY, scaledAccentX, scaledAccentY;
        var width = glyph.width;

        if (vertical) {
          var vmetric, vx, vy;
          vmetric = glyph.vmetric || defaultVMetrics;
          vx = glyph.vmetric ? vmetric[1] : width * 0.5;
          vx = -vx * widthAdvanceScale;
          vy = vmetric[2] * widthAdvanceScale;
          width = vmetric ? -vmetric[0] : width;
          scaledX = vx / fontSizeScale;
          scaledY = (x + vy) / fontSizeScale;
        } else {
          scaledX = x / fontSizeScale;
          scaledY = 0;
        }

        if (font.remeasure && width > 0) {
          var measuredWidth = ctx.measureText(character).width * 1000 / fontSize * fontSizeScale;

          if (width < measuredWidth && this.isFontSubpixelAAEnabled) {
            var characterScaleX = width / measuredWidth;
            restoreNeeded = true;
            ctx.save();
            ctx.scale(characterScaleX, 1);
            scaledX /= characterScaleX;
          } else if (width !== measuredWidth) {
            scaledX += (width - measuredWidth) / 2000 * fontSize / fontSizeScale;
          }
        }

        if (glyph.isInFont || font.missingFile) {
          if (simpleFillText && !accent) {
            ctx.fillText(character, scaledX, scaledY);
          } else {
            this.paintChar(character, scaledX, scaledY, patternTransform);

            if (accent) {
              scaledAccentX = scaledX + accent.offset.x / fontSizeScale;
              scaledAccentY = scaledY - accent.offset.y / fontSizeScale;
              this.paintChar(accent.fontChar, scaledAccentX, scaledAccentY, patternTransform);
            }
          }
        }

        var charWidth = width * widthAdvanceScale + spacing * fontDirection;
        x += charWidth;

        if (restoreNeeded) {
          ctx.restore();
        }
      }

      if (vertical) {
        current.y -= x * textHScale;
      } else {
        current.x += x * textHScale;
      }

      ctx.restore();
    },
    showType3Text: function CanvasGraphics_showType3Text(glyphs) {
      var ctx = this.ctx;
      var current = this.current;
      var font = current.font;
      var fontSize = current.fontSize;
      var fontDirection = current.fontDirection;
      var spacingDir = font.vertical ? 1 : -1;
      var charSpacing = current.charSpacing;
      var wordSpacing = current.wordSpacing;
      var textHScale = current.textHScale * fontDirection;
      var fontMatrix = current.fontMatrix || _util.FONT_IDENTITY_MATRIX;
      var glyphsLength = glyphs.length;
      var isTextInvisible = current.textRenderingMode === _util.TextRenderingMode.INVISIBLE;
      var i, glyph, width, spacingLength;

      if (isTextInvisible || fontSize === 0) {
        return;
      }

      this._cachedGetSinglePixelWidth = null;
      ctx.save();
      ctx.transform.apply(ctx, current.textMatrix);
      ctx.translate(current.x, current.y);
      ctx.scale(textHScale, fontDirection);

      for (i = 0; i < glyphsLength; ++i) {
        glyph = glyphs[i];

        if ((0, _util.isNum)(glyph)) {
          spacingLength = spacingDir * glyph * fontSize / 1000;
          this.ctx.translate(spacingLength, 0);
          current.x += spacingLength * textHScale;
          continue;
        }

        var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
        var operatorList = font.charProcOperatorList[glyph.operatorListId];

        if (!operatorList) {
          (0, _util.warn)("Type3 character \"".concat(glyph.operatorListId, "\" is not available."));
          continue;
        }

        this.processingType3 = glyph;
        this.save();
        ctx.scale(fontSize, fontSize);
        ctx.transform.apply(ctx, fontMatrix);
        this.executeOperatorList(operatorList);
        this.restore();

        var transformed = _util.Util.applyTransform([glyph.width, 0], fontMatrix);

        width = transformed[0] * fontSize + spacing;
        ctx.translate(width, 0);
        current.x += width * textHScale;
      }

      ctx.restore();
      this.processingType3 = null;
    },
    setCharWidth: function CanvasGraphics_setCharWidth(xWidth, yWidth) {},
    setCharWidthAndBounds: function CanvasGraphics_setCharWidthAndBounds(xWidth, yWidth, llx, lly, urx, ury) {
      this.ctx.rect(llx, lly, urx - llx, ury - lly);
      this.clip();
      this.endPath();
    },
    getColorN_Pattern: function CanvasGraphics_getColorN_Pattern(IR) {
      var _this = this;

      var pattern;

      if (IR[0] === 'TilingPattern') {
        var color = IR[1];
        var baseTransform = this.baseTransform || this.ctx.mozCurrentTransform.slice();
        var canvasGraphicsFactory = {
          createCanvasGraphics: function createCanvasGraphics(ctx) {
            return new CanvasGraphics(ctx, _this.commonObjs, _this.objs, _this.canvasFactory, _this.webGLContext);
          }
        };
        pattern = new _pattern_helper.TilingPattern(IR, color, this.ctx, canvasGraphicsFactory, baseTransform);
      } else {
        pattern = (0, _pattern_helper.getShadingPatternFromIR)(IR);
      }

      return pattern;
    },
    setStrokeColorN: function CanvasGraphics_setStrokeColorN() {
      this.current.strokeColor = this.getColorN_Pattern(arguments);
    },
    setFillColorN: function CanvasGraphics_setFillColorN() {
      this.current.fillColor = this.getColorN_Pattern(arguments);
      this.current.patternFill = true;
    },
    setStrokeRGBColor: function CanvasGraphics_setStrokeRGBColor(r, g, b) {
      var color = _util.Util.makeCssRgb(r, g, b);

      this.ctx.strokeStyle = color;
      this.current.strokeColor = color;
    },
    setFillRGBColor: function CanvasGraphics_setFillRGBColor(r, g, b) {
      var color = _util.Util.makeCssRgb(r, g, b);

      this.ctx.fillStyle = color;
      this.current.fillColor = color;
      this.current.patternFill = false;
    },
    shadingFill: function CanvasGraphics_shadingFill(patternIR) {
      var ctx = this.ctx;
      this.save();
      var pattern = (0, _pattern_helper.getShadingPatternFromIR)(patternIR);
      ctx.fillStyle = pattern.getPattern(ctx, this, true);
      var inv = ctx.mozCurrentTransformInverse;

      if (inv) {
        var canvas = ctx.canvas;
        var width = canvas.width;
        var height = canvas.height;

        var bl = _util.Util.applyTransform([0, 0], inv);

        var br = _util.Util.applyTransform([0, height], inv);

        var ul = _util.Util.applyTransform([width, 0], inv);

        var ur = _util.Util.applyTransform([width, height], inv);

        var x0 = Math.min(bl[0], br[0], ul[0], ur[0]);
        var y0 = Math.min(bl[1], br[1], ul[1], ur[1]);
        var x1 = Math.max(bl[0], br[0], ul[0], ur[0]);
        var y1 = Math.max(bl[1], br[1], ul[1], ur[1]);
        this.ctx.fillRect(x0, y0, x1 - x0, y1 - y0);
      } else {
        this.ctx.fillRect(-1e10, -1e10, 2e10, 2e10);
      }

      this.restore();
    },
    beginInlineImage: function CanvasGraphics_beginInlineImage() {
      (0, _util.unreachable)('Should not call beginInlineImage');
    },
    beginImageData: function CanvasGraphics_beginImageData() {
      (0, _util.unreachable)('Should not call beginImageData');
    },
    paintFormXObjectBegin: function CanvasGraphics_paintFormXObjectBegin(matrix, bbox) {
      this.save();
      this.baseTransformStack.push(this.baseTransform);

      if (Array.isArray(matrix) && matrix.length === 6) {
        this.transform.apply(this, matrix);
      }

      this.baseTransform = this.ctx.mozCurrentTransform;

      if (bbox) {
        var width = bbox[2] - bbox[0];
        var height = bbox[3] - bbox[1];
        this.ctx.rect(bbox[0], bbox[1], width, height);
        this.clip();
        this.endPath();
      }
    },
    paintFormXObjectEnd: function CanvasGraphics_paintFormXObjectEnd() {
      this.restore();
      this.baseTransform = this.baseTransformStack.pop();
    },
    beginGroup: function CanvasGraphics_beginGroup(group) {
      this.save();
      var currentCtx = this.ctx;

      if (!group.isolated) {
        (0, _util.info)('TODO: Support non-isolated groups.');
      }

      if (group.knockout) {
        (0, _util.warn)('Knockout groups not supported.');
      }

      var currentTransform = currentCtx.mozCurrentTransform;

      if (group.matrix) {
        currentCtx.transform.apply(currentCtx, group.matrix);
      }

      if (!group.bbox) {
        throw new Error('Bounding box is required.');
      }

      var bounds = _util.Util.getAxialAlignedBoundingBox(group.bbox, currentCtx.mozCurrentTransform);

      var canvasBounds = [0, 0, currentCtx.canvas.width, currentCtx.canvas.height];
      bounds = _util.Util.intersect(bounds, canvasBounds) || [0, 0, 0, 0];
      var offsetX = Math.floor(bounds[0]);
      var offsetY = Math.floor(bounds[1]);
      var drawnWidth = Math.max(Math.ceil(bounds[2]) - offsetX, 1);
      var drawnHeight = Math.max(Math.ceil(bounds[3]) - offsetY, 1);
      var scaleX = 1,
          scaleY = 1;

      if (drawnWidth > MAX_GROUP_SIZE) {
        scaleX = drawnWidth / MAX_GROUP_SIZE;
        drawnWidth = MAX_GROUP_SIZE;
      }

      if (drawnHeight > MAX_GROUP_SIZE) {
        scaleY = drawnHeight / MAX_GROUP_SIZE;
        drawnHeight = MAX_GROUP_SIZE;
      }

      var cacheId = 'groupAt' + this.groupLevel;

      if (group.smask) {
        cacheId += '_smask_' + this.smaskCounter++ % 2;
      }

      var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight, true);
      var groupCtx = scratchCanvas.context;
      groupCtx.scale(1 / scaleX, 1 / scaleY);
      groupCtx.translate(-offsetX, -offsetY);
      groupCtx.transform.apply(groupCtx, currentTransform);

      if (group.smask) {
        this.smaskStack.push({
          canvas: scratchCanvas.canvas,
          context: groupCtx,
          offsetX: offsetX,
          offsetY: offsetY,
          scaleX: scaleX,
          scaleY: scaleY,
          subtype: group.smask.subtype,
          backdrop: group.smask.backdrop,
          transferMap: group.smask.transferMap || null,
          startTransformInverse: null
        });
      } else {
        currentCtx.setTransform(1, 0, 0, 1, 0, 0);
        currentCtx.translate(offsetX, offsetY);
        currentCtx.scale(scaleX, scaleY);
      }

      copyCtxState(currentCtx, groupCtx);
      this.ctx = groupCtx;
      this.setGState([['BM', 'source-over'], ['ca', 1], ['CA', 1]]);
      this.groupStack.push(currentCtx);
      this.groupLevel++;
      this.current.activeSMask = null;
    },
    endGroup: function CanvasGraphics_endGroup(group) {
      this.groupLevel--;
      var groupCtx = this.ctx;
      this.ctx = this.groupStack.pop();

      if (this.ctx.imageSmoothingEnabled !== undefined) {
        this.ctx.imageSmoothingEnabled = false;
      } else {
        this.ctx.mozImageSmoothingEnabled = false;
      }

      if (group.smask) {
        this.tempSMask = this.smaskStack.pop();
      } else {
        this.ctx.drawImage(groupCtx.canvas, 0, 0);
      }

      this.restore();
    },
    beginAnnotations: function CanvasGraphics_beginAnnotations() {
      this.save();

      if (this.baseTransform) {
        this.ctx.setTransform.apply(this.ctx, this.baseTransform);
      }
    },
    endAnnotations: function CanvasGraphics_endAnnotations() {
      this.restore();
    },
    beginAnnotation: function CanvasGraphics_beginAnnotation(rect, transform, matrix) {
      this.save();
      resetCtxToDefault(this.ctx);
      this.current = new CanvasExtraState();

      if (Array.isArray(rect) && rect.length === 4) {
        var width = rect[2] - rect[0];
        var height = rect[3] - rect[1];
        this.ctx.rect(rect[0], rect[1], width, height);
        this.clip();
        this.endPath();
      }

      this.transform.apply(this, transform);
      this.transform.apply(this, matrix);
    },
    endAnnotation: function CanvasGraphics_endAnnotation() {
      this.restore();
    },
    paintJpegXObject: function CanvasGraphics_paintJpegXObject(objId, w, h) {
      var domImage = this.objs.get(objId);

      if (!domImage) {
        (0, _util.warn)('Dependent image isn\'t ready yet');
        return;
      }

      this.save();
      var ctx = this.ctx;
      ctx.scale(1 / w, -1 / h);
      ctx.drawImage(domImage, 0, 0, domImage.width, domImage.height, 0, -h, w, h);

      if (this.imageLayer) {
        var currentTransform = ctx.mozCurrentTransformInverse;
        var position = this.getCanvasPosition(0, 0);
        this.imageLayer.appendImage({
          objId: objId,
          left: position[0],
          top: position[1],
          width: w / currentTransform[0],
          height: h / currentTransform[3]
        });
      }

      this.restore();
    },
    paintImageMaskXObject: function CanvasGraphics_paintImageMaskXObject(img) {
      var ctx = this.ctx;
      var width = img.width,
          height = img.height;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var glyph = this.processingType3;

      if (COMPILE_TYPE3_GLYPHS && glyph && glyph.compiled === undefined) {
        if (width <= MAX_SIZE_TO_COMPILE && height <= MAX_SIZE_TO_COMPILE) {
          glyph.compiled = compileType3Glyph({
            data: img.data,
            width: width,
            height: height
          });
        } else {
          glyph.compiled = null;
        }
      }

      if (glyph && glyph.compiled) {
        glyph.compiled(ctx);
        return;
      }

      var maskCanvas = this.cachedCanvases.getCanvas('maskCanvas', width, height);
      var maskCtx = maskCanvas.context;
      maskCtx.save();
      putBinaryImageMask(maskCtx, img);
      maskCtx.globalCompositeOperation = 'source-in';
      maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
      maskCtx.fillRect(0, 0, width, height);
      maskCtx.restore();
      this.paintInlineImageXObject(maskCanvas.canvas);
    },
    paintImageMaskXObjectRepeat: function CanvasGraphics_paintImageMaskXObjectRepeat(imgData, scaleX, scaleY, positions) {
      var width = imgData.width;
      var height = imgData.height;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var maskCanvas = this.cachedCanvases.getCanvas('maskCanvas', width, height);
      var maskCtx = maskCanvas.context;
      maskCtx.save();
      putBinaryImageMask(maskCtx, imgData);
      maskCtx.globalCompositeOperation = 'source-in';
      maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
      maskCtx.fillRect(0, 0, width, height);
      maskCtx.restore();
      var ctx = this.ctx;

      for (var i = 0, ii = positions.length; i < ii; i += 2) {
        ctx.save();
        ctx.transform(scaleX, 0, 0, scaleY, positions[i], positions[i + 1]);
        ctx.scale(1, -1);
        ctx.drawImage(maskCanvas.canvas, 0, 0, width, height, 0, -1, 1, 1);
        ctx.restore();
      }
    },
    paintImageMaskXObjectGroup: function CanvasGraphics_paintImageMaskXObjectGroup(images) {
      var ctx = this.ctx;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;

      for (var i = 0, ii = images.length; i < ii; i++) {
        var image = images[i];
        var width = image.width,
            height = image.height;
        var maskCanvas = this.cachedCanvases.getCanvas('maskCanvas', width, height);
        var maskCtx = maskCanvas.context;
        maskCtx.save();
        putBinaryImageMask(maskCtx, image);
        maskCtx.globalCompositeOperation = 'source-in';
        maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this) : fillColor;
        maskCtx.fillRect(0, 0, width, height);
        maskCtx.restore();
        ctx.save();
        ctx.transform.apply(ctx, image.transform);
        ctx.scale(1, -1);
        ctx.drawImage(maskCanvas.canvas, 0, 0, width, height, 0, -1, 1, 1);
        ctx.restore();
      }
    },
    paintImageXObject: function CanvasGraphics_paintImageXObject(objId) {
      var imgData = this.objs.get(objId);

      if (!imgData) {
        (0, _util.warn)('Dependent image isn\'t ready yet');
        return;
      }

      this.paintInlineImageXObject(imgData);
    },
    paintImageXObjectRepeat: function CanvasGraphics_paintImageXObjectRepeat(objId, scaleX, scaleY, positions) {
      var imgData = this.objs.get(objId);

      if (!imgData) {
        (0, _util.warn)('Dependent image isn\'t ready yet');
        return;
      }

      var width = imgData.width;
      var height = imgData.height;
      var map = [];

      for (var i = 0, ii = positions.length; i < ii; i += 2) {
        map.push({
          transform: [scaleX, 0, 0, scaleY, positions[i], positions[i + 1]],
          x: 0,
          y: 0,
          w: width,
          h: height
        });
      }

      this.paintInlineImageXObjectGroup(imgData, map);
    },
    paintInlineImageXObject: function CanvasGraphics_paintInlineImageXObject(imgData) {
      var width = imgData.width;
      var height = imgData.height;
      var ctx = this.ctx;
      this.save();
      ctx.scale(1 / width, -1 / height);
      var currentTransform = ctx.mozCurrentTransformInverse;
      var a = currentTransform[0],
          b = currentTransform[1];
      var widthScale = Math.max(Math.sqrt(a * a + b * b), 1);
      var c = currentTransform[2],
          d = currentTransform[3];
      var heightScale = Math.max(Math.sqrt(c * c + d * d), 1);
      var imgToPaint, tmpCanvas;

      if (typeof HTMLElement === 'function' && imgData instanceof HTMLElement || !imgData.data) {
        imgToPaint = imgData;
      } else {
        tmpCanvas = this.cachedCanvases.getCanvas('inlineImage', width, height);
        var tmpCtx = tmpCanvas.context;
        putBinaryImageData(tmpCtx, imgData);
        imgToPaint = tmpCanvas.canvas;
      }

      var paintWidth = width,
          paintHeight = height;
      var tmpCanvasId = 'prescale1';

      while (widthScale > 2 && paintWidth > 1 || heightScale > 2 && paintHeight > 1) {
        var newWidth = paintWidth,
            newHeight = paintHeight;

        if (widthScale > 2 && paintWidth > 1) {
          newWidth = Math.ceil(paintWidth / 2);
          widthScale /= paintWidth / newWidth;
        }

        if (heightScale > 2 && paintHeight > 1) {
          newHeight = Math.ceil(paintHeight / 2);
          heightScale /= paintHeight / newHeight;
        }

        tmpCanvas = this.cachedCanvases.getCanvas(tmpCanvasId, newWidth, newHeight);
        tmpCtx = tmpCanvas.context;
        tmpCtx.clearRect(0, 0, newWidth, newHeight);
        tmpCtx.drawImage(imgToPaint, 0, 0, paintWidth, paintHeight, 0, 0, newWidth, newHeight);
        imgToPaint = tmpCanvas.canvas;
        paintWidth = newWidth;
        paintHeight = newHeight;
        tmpCanvasId = tmpCanvasId === 'prescale1' ? 'prescale2' : 'prescale1';
      }

      ctx.drawImage(imgToPaint, 0, 0, paintWidth, paintHeight, 0, -height, width, height);

      if (this.imageLayer) {
        var position = this.getCanvasPosition(0, -height);
        this.imageLayer.appendImage({
          imgData: imgData,
          left: position[0],
          top: position[1],
          width: width / currentTransform[0],
          height: height / currentTransform[3]
        });
      }

      this.restore();
    },
    paintInlineImageXObjectGroup: function CanvasGraphics_paintInlineImageXObjectGroup(imgData, map) {
      var ctx = this.ctx;
      var w = imgData.width;
      var h = imgData.height;
      var tmpCanvas = this.cachedCanvases.getCanvas('inlineImage', w, h);
      var tmpCtx = tmpCanvas.context;
      putBinaryImageData(tmpCtx, imgData);

      for (var i = 0, ii = map.length; i < ii; i++) {
        var entry = map[i];
        ctx.save();
        ctx.transform.apply(ctx, entry.transform);
        ctx.scale(1, -1);
        ctx.drawImage(tmpCanvas.canvas, entry.x, entry.y, entry.w, entry.h, 0, -1, 1, 1);

        if (this.imageLayer) {
          var position = this.getCanvasPosition(entry.x, entry.y);
          this.imageLayer.appendImage({
            imgData: imgData,
            left: position[0],
            top: position[1],
            width: w,
            height: h
          });
        }

        ctx.restore();
      }
    },
    paintSolidColorImageMask: function CanvasGraphics_paintSolidColorImageMask() {
      this.ctx.fillRect(0, 0, 1, 1);
    },
    paintXObject: function CanvasGraphics_paintXObject() {
      (0, _util.warn)('Unsupported \'paintXObject\' command.');
    },
    markPoint: function CanvasGraphics_markPoint(tag) {},
    markPointProps: function CanvasGraphics_markPointProps(tag, properties) {},
    beginMarkedContent: function CanvasGraphics_beginMarkedContent(tag) {},
    beginMarkedContentProps: function CanvasGraphics_beginMarkedContentProps(tag, properties) {},
    endMarkedContent: function CanvasGraphics_endMarkedContent() {},
    beginCompat: function CanvasGraphics_beginCompat() {},
    endCompat: function CanvasGraphics_endCompat() {},
    consumePath: function CanvasGraphics_consumePath() {
      var ctx = this.ctx;

      if (this.pendingClip) {
        if (this.pendingClip === EO_CLIP) {
          ctx.clip('evenodd');
        } else {
          ctx.clip();
        }

        this.pendingClip = null;
      }

      ctx.beginPath();
    },
    getSinglePixelWidth: function getSinglePixelWidth(scale) {
      if (this._cachedGetSinglePixelWidth === null) {
        var inverse = this.ctx.mozCurrentTransformInverse;
        this._cachedGetSinglePixelWidth = Math.sqrt(Math.max(inverse[0] * inverse[0] + inverse[1] * inverse[1], inverse[2] * inverse[2] + inverse[3] * inverse[3]));
      }

      return this._cachedGetSinglePixelWidth;
    },
    getCanvasPosition: function CanvasGraphics_getCanvasPosition(x, y) {
      var transform = this.ctx.mozCurrentTransform;
      return [transform[0] * x + transform[2] * y + transform[4], transform[1] * x + transform[3] * y + transform[5]];
    }
  };

  for (var op in _util.OPS) {
    CanvasGraphics.prototype[_util.OPS[op]] = CanvasGraphics.prototype[op];
  }

  return CanvasGraphics;
}();

exports.CanvasGraphics = CanvasGraphics;

/***/ }),
/* 155 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getShadingPatternFromIR = getShadingPatternFromIR;
exports.TilingPattern = void 0;

var _util = __w_pdfjs_require__(1);

var ShadingIRs = {};
ShadingIRs.RadialAxial = {
  fromIR: function RadialAxial_fromIR(raw) {
    var type = raw[1];
    var colorStops = raw[2];
    var p0 = raw[3];
    var p1 = raw[4];
    var r0 = raw[5];
    var r1 = raw[6];
    return {
      type: 'Pattern',
      getPattern: function RadialAxial_getPattern(ctx) {
        var grad;

        if (type === 'axial') {
          grad = ctx.createLinearGradient(p0[0], p0[1], p1[0], p1[1]);
        } else if (type === 'radial') {
          grad = ctx.createRadialGradient(p0[0], p0[1], r0, p1[0], p1[1], r1);
        }

        for (var i = 0, ii = colorStops.length; i < ii; ++i) {
          var c = colorStops[i];
          grad.addColorStop(c[0], c[1]);
        }

        return grad;
      }
    };
  }
};

var createMeshCanvas = function createMeshCanvasClosure() {
  function drawTriangle(data, context, p1, p2, p3, c1, c2, c3) {
    var coords = context.coords,
        colors = context.colors;
    var bytes = data.data,
        rowSize = data.width * 4;
    var tmp;

    if (coords[p1 + 1] > coords[p2 + 1]) {
      tmp = p1;
      p1 = p2;
      p2 = tmp;
      tmp = c1;
      c1 = c2;
      c2 = tmp;
    }

    if (coords[p2 + 1] > coords[p3 + 1]) {
      tmp = p2;
      p2 = p3;
      p3 = tmp;
      tmp = c2;
      c2 = c3;
      c3 = tmp;
    }

    if (coords[p1 + 1] > coords[p2 + 1]) {
      tmp = p1;
      p1 = p2;
      p2 = tmp;
      tmp = c1;
      c1 = c2;
      c2 = tmp;
    }

    var x1 = (coords[p1] + context.offsetX) * context.scaleX;
    var y1 = (coords[p1 + 1] + context.offsetY) * context.scaleY;
    var x2 = (coords[p2] + context.offsetX) * context.scaleX;
    var y2 = (coords[p2 + 1] + context.offsetY) * context.scaleY;
    var x3 = (coords[p3] + context.offsetX) * context.scaleX;
    var y3 = (coords[p3 + 1] + context.offsetY) * context.scaleY;

    if (y1 >= y3) {
      return;
    }

    var c1r = colors[c1],
        c1g = colors[c1 + 1],
        c1b = colors[c1 + 2];
    var c2r = colors[c2],
        c2g = colors[c2 + 1],
        c2b = colors[c2 + 2];
    var c3r = colors[c3],
        c3g = colors[c3 + 1],
        c3b = colors[c3 + 2];
    var minY = Math.round(y1),
        maxY = Math.round(y3);
    var xa, car, cag, cab;
    var xb, cbr, cbg, cbb;
    var k;

    for (var y = minY; y <= maxY; y++) {
      if (y < y2) {
        k = y < y1 ? 0 : y1 === y2 ? 1 : (y1 - y) / (y1 - y2);
        xa = x1 - (x1 - x2) * k;
        car = c1r - (c1r - c2r) * k;
        cag = c1g - (c1g - c2g) * k;
        cab = c1b - (c1b - c2b) * k;
      } else {
        k = y > y3 ? 1 : y2 === y3 ? 0 : (y2 - y) / (y2 - y3);
        xa = x2 - (x2 - x3) * k;
        car = c2r - (c2r - c3r) * k;
        cag = c2g - (c2g - c3g) * k;
        cab = c2b - (c2b - c3b) * k;
      }

      k = y < y1 ? 0 : y > y3 ? 1 : (y1 - y) / (y1 - y3);
      xb = x1 - (x1 - x3) * k;
      cbr = c1r - (c1r - c3r) * k;
      cbg = c1g - (c1g - c3g) * k;
      cbb = c1b - (c1b - c3b) * k;
      var x1_ = Math.round(Math.min(xa, xb));
      var x2_ = Math.round(Math.max(xa, xb));
      var j = rowSize * y + x1_ * 4;

      for (var x = x1_; x <= x2_; x++) {
        k = (xa - x) / (xa - xb);
        k = k < 0 ? 0 : k > 1 ? 1 : k;
        bytes[j++] = car - (car - cbr) * k | 0;
        bytes[j++] = cag - (cag - cbg) * k | 0;
        bytes[j++] = cab - (cab - cbb) * k | 0;
        bytes[j++] = 255;
      }
    }
  }

  function drawFigure(data, figure, context) {
    var ps = figure.coords;
    var cs = figure.colors;
    var i, ii;

    switch (figure.type) {
      case 'lattice':
        var verticesPerRow = figure.verticesPerRow;
        var rows = Math.floor(ps.length / verticesPerRow) - 1;
        var cols = verticesPerRow - 1;

        for (i = 0; i < rows; i++) {
          var q = i * verticesPerRow;

          for (var j = 0; j < cols; j++, q++) {
            drawTriangle(data, context, ps[q], ps[q + 1], ps[q + verticesPerRow], cs[q], cs[q + 1], cs[q + verticesPerRow]);
            drawTriangle(data, context, ps[q + verticesPerRow + 1], ps[q + 1], ps[q + verticesPerRow], cs[q + verticesPerRow + 1], cs[q + 1], cs[q + verticesPerRow]);
          }
        }

        break;

      case 'triangles':
        for (i = 0, ii = ps.length; i < ii; i += 3) {
          drawTriangle(data, context, ps[i], ps[i + 1], ps[i + 2], cs[i], cs[i + 1], cs[i + 2]);
        }

        break;

      default:
        throw new Error('illegal figure');
    }
  }

  function createMeshCanvas(bounds, combinesScale, coords, colors, figures, backgroundColor, cachedCanvases, webGLContext) {
    var EXPECTED_SCALE = 1.1;
    var MAX_PATTERN_SIZE = 3000;
    var BORDER_SIZE = 2;
    var offsetX = Math.floor(bounds[0]);
    var offsetY = Math.floor(bounds[1]);
    var boundsWidth = Math.ceil(bounds[2]) - offsetX;
    var boundsHeight = Math.ceil(bounds[3]) - offsetY;
    var width = Math.min(Math.ceil(Math.abs(boundsWidth * combinesScale[0] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
    var height = Math.min(Math.ceil(Math.abs(boundsHeight * combinesScale[1] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
    var scaleX = boundsWidth / width;
    var scaleY = boundsHeight / height;
    var context = {
      coords: coords,
      colors: colors,
      offsetX: -offsetX,
      offsetY: -offsetY,
      scaleX: 1 / scaleX,
      scaleY: 1 / scaleY
    };
    var paddedWidth = width + BORDER_SIZE * 2;
    var paddedHeight = height + BORDER_SIZE * 2;
    var canvas, tmpCanvas, i, ii;

    if (webGLContext.isEnabled) {
      canvas = webGLContext.drawFigures({
        width: width,
        height: height,
        backgroundColor: backgroundColor,
        figures: figures,
        context: context
      });
      tmpCanvas = cachedCanvases.getCanvas('mesh', paddedWidth, paddedHeight, false);
      tmpCanvas.context.drawImage(canvas, BORDER_SIZE, BORDER_SIZE);
      canvas = tmpCanvas.canvas;
    } else {
      tmpCanvas = cachedCanvases.getCanvas('mesh', paddedWidth, paddedHeight, false);
      var tmpCtx = tmpCanvas.context;
      var data = tmpCtx.createImageData(width, height);

      if (backgroundColor) {
        var bytes = data.data;

        for (i = 0, ii = bytes.length; i < ii; i += 4) {
          bytes[i] = backgroundColor[0];
          bytes[i + 1] = backgroundColor[1];
          bytes[i + 2] = backgroundColor[2];
          bytes[i + 3] = 255;
        }
      }

      for (i = 0; i < figures.length; i++) {
        drawFigure(data, figures[i], context);
      }

      tmpCtx.putImageData(data, BORDER_SIZE, BORDER_SIZE);
      canvas = tmpCanvas.canvas;
    }

    return {
      canvas: canvas,
      offsetX: offsetX - BORDER_SIZE * scaleX,
      offsetY: offsetY - BORDER_SIZE * scaleY,
      scaleX: scaleX,
      scaleY: scaleY
    };
  }

  return createMeshCanvas;
}();

ShadingIRs.Mesh = {
  fromIR: function Mesh_fromIR(raw) {
    var coords = raw[2];
    var colors = raw[3];
    var figures = raw[4];
    var bounds = raw[5];
    var matrix = raw[6];
    var background = raw[8];
    return {
      type: 'Pattern',
      getPattern: function Mesh_getPattern(ctx, owner, shadingFill) {
        var scale;

        if (shadingFill) {
          scale = _util.Util.singularValueDecompose2dScale(ctx.mozCurrentTransform);
        } else {
          scale = _util.Util.singularValueDecompose2dScale(owner.baseTransform);

          if (matrix) {
            var matrixScale = _util.Util.singularValueDecompose2dScale(matrix);

            scale = [scale[0] * matrixScale[0], scale[1] * matrixScale[1]];
          }
        }

        var temporaryPatternCanvas = createMeshCanvas(bounds, scale, coords, colors, figures, shadingFill ? null : background, owner.cachedCanvases, owner.webGLContext);

        if (!shadingFill) {
          ctx.setTransform.apply(ctx, owner.baseTransform);

          if (matrix) {
            ctx.transform.apply(ctx, matrix);
          }
        }

        ctx.translate(temporaryPatternCanvas.offsetX, temporaryPatternCanvas.offsetY);
        ctx.scale(temporaryPatternCanvas.scaleX, temporaryPatternCanvas.scaleY);
        return ctx.createPattern(temporaryPatternCanvas.canvas, 'no-repeat');
      }
    };
  }
};
ShadingIRs.Dummy = {
  fromIR: function Dummy_fromIR() {
    return {
      type: 'Pattern',
      getPattern: function Dummy_fromIR_getPattern() {
        return 'hotpink';
      }
    };
  }
};

function getShadingPatternFromIR(raw) {
  var shadingIR = ShadingIRs[raw[0]];

  if (!shadingIR) {
    throw new Error("Unknown IR type: ".concat(raw[0]));
  }

  return shadingIR.fromIR(raw);
}

var TilingPattern = function TilingPatternClosure() {
  var PaintType = {
    COLORED: 1,
    UNCOLORED: 2
  };
  var MAX_PATTERN_SIZE = 3000;

  function TilingPattern(IR, color, ctx, canvasGraphicsFactory, baseTransform) {
    this.operatorList = IR[2];
    this.matrix = IR[3] || [1, 0, 0, 1, 0, 0];
    this.bbox = IR[4];
    this.xstep = IR[5];
    this.ystep = IR[6];
    this.paintType = IR[7];
    this.tilingType = IR[8];
    this.color = color;
    this.canvasGraphicsFactory = canvasGraphicsFactory;
    this.baseTransform = baseTransform;
    this.type = 'Pattern';
    this.ctx = ctx;
  }

  TilingPattern.prototype = {
    createPatternCanvas: function TilinPattern_createPatternCanvas(owner) {
      var operatorList = this.operatorList;
      var bbox = this.bbox;
      var xstep = this.xstep;
      var ystep = this.ystep;
      var paintType = this.paintType;
      var tilingType = this.tilingType;
      var color = this.color;
      var canvasGraphicsFactory = this.canvasGraphicsFactory;
      (0, _util.info)('TilingType: ' + tilingType);
      var x0 = bbox[0],
          y0 = bbox[1],
          x1 = bbox[2],
          y1 = bbox[3];
      var topLeft = [x0, y0];
      var botRight = [x0 + xstep, y0 + ystep];
      var width = botRight[0] - topLeft[0];
      var height = botRight[1] - topLeft[1];

      var matrixScale = _util.Util.singularValueDecompose2dScale(this.matrix);

      var curMatrixScale = _util.Util.singularValueDecompose2dScale(this.baseTransform);

      var combinedScale = [matrixScale[0] * curMatrixScale[0], matrixScale[1] * curMatrixScale[1]];
      width = Math.min(Math.ceil(Math.abs(width * combinedScale[0])), MAX_PATTERN_SIZE);
      height = Math.min(Math.ceil(Math.abs(height * combinedScale[1])), MAX_PATTERN_SIZE);
      var tmpCanvas = owner.cachedCanvases.getCanvas('pattern', width, height, true);
      var tmpCtx = tmpCanvas.context;
      var graphics = canvasGraphicsFactory.createCanvasGraphics(tmpCtx);
      graphics.groupLevel = owner.groupLevel;
      this.setFillAndStrokeStyleToContext(graphics, paintType, color);
      this.setScale(width, height, xstep, ystep);
      this.transformToScale(graphics);
      var tmpTranslate = [1, 0, 0, 1, -topLeft[0], -topLeft[1]];
      graphics.transform.apply(graphics, tmpTranslate);
      this.clipBbox(graphics, bbox, x0, y0, x1, y1);
      graphics.executeOperatorList(operatorList);
      return tmpCanvas.canvas;
    },
    setScale: function TilingPattern_setScale(width, height, xstep, ystep) {
      this.scale = [width / xstep, height / ystep];
    },
    transformToScale: function TilingPattern_transformToScale(graphics) {
      var scale = this.scale;
      var tmpScale = [scale[0], 0, 0, scale[1], 0, 0];
      graphics.transform.apply(graphics, tmpScale);
    },
    scaleToContext: function TilingPattern_scaleToContext() {
      var scale = this.scale;
      this.ctx.scale(1 / scale[0], 1 / scale[1]);
    },
    clipBbox: function clipBbox(graphics, bbox, x0, y0, x1, y1) {
      if (Array.isArray(bbox) && bbox.length === 4) {
        var bboxWidth = x1 - x0;
        var bboxHeight = y1 - y0;
        graphics.ctx.rect(x0, y0, bboxWidth, bboxHeight);
        graphics.clip();
        graphics.endPath();
      }
    },
    setFillAndStrokeStyleToContext: function setFillAndStrokeStyleToContext(graphics, paintType, color) {
      var context = graphics.ctx,
          current = graphics.current;

      switch (paintType) {
        case PaintType.COLORED:
          var ctx = this.ctx;
          context.fillStyle = ctx.fillStyle;
          context.strokeStyle = ctx.strokeStyle;
          current.fillColor = ctx.fillStyle;
          current.strokeColor = ctx.strokeStyle;
          break;

        case PaintType.UNCOLORED:
          var cssColor = _util.Util.makeCssRgb(color[0], color[1], color[2]);

          context.fillStyle = cssColor;
          context.strokeStyle = cssColor;
          current.fillColor = cssColor;
          current.strokeColor = cssColor;
          break;

        default:
          throw new _util.FormatError("Unsupported paint type: ".concat(paintType));
      }
    },
    getPattern: function TilingPattern_getPattern(ctx, owner) {
      var temporaryPatternCanvas = this.createPatternCanvas(owner);
      ctx = this.ctx;
      ctx.setTransform.apply(ctx, this.baseTransform);
      ctx.transform.apply(ctx, this.matrix);
      this.scaleToContext();
      return ctx.createPattern(temporaryPatternCanvas, 'repeat');
    }
  };
  return TilingPattern;
}();

exports.TilingPattern = TilingPattern;

/***/ }),
/* 156 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GlobalWorkerOptions = void 0;
var GlobalWorkerOptions = Object.create(null);
exports.GlobalWorkerOptions = GlobalWorkerOptions;
GlobalWorkerOptions.workerPort = GlobalWorkerOptions.workerPort === undefined ? null : GlobalWorkerOptions.workerPort;
GlobalWorkerOptions.workerSrc = GlobalWorkerOptions.workerSrc === undefined ? '' : GlobalWorkerOptions.workerSrc;

/***/ }),
/* 157 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageHandler = MessageHandler;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(147));

var _util = __w_pdfjs_require__(1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function resolveCall(_x, _x2) {
  return _resolveCall.apply(this, arguments);
}

function _resolveCall() {
  _resolveCall = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(fn, args) {
    var thisArg,
        _args = arguments;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            thisArg = _args.length > 2 && _args[2] !== undefined ? _args[2] : null;

            if (fn) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return");

          case 3:
            return _context.abrupt("return", fn.apply(thisArg, args));

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _resolveCall.apply(this, arguments);
}

function wrapReason(reason) {
  if (_typeof(reason) !== 'object') {
    return reason;
  }

  switch (reason.name) {
    case 'AbortException':
      return new _util.AbortException(reason.message);

    case 'MissingPDFException':
      return new _util.MissingPDFException(reason.message);

    case 'UnexpectedResponseException':
      return new _util.UnexpectedResponseException(reason.message, reason.status);

    default:
      return new _util.UnknownErrorException(reason.message, reason.details);
  }
}

function makeReasonSerializable(reason) {
  if (!(reason instanceof Error) || reason instanceof _util.AbortException || reason instanceof _util.MissingPDFException || reason instanceof _util.UnexpectedResponseException || reason instanceof _util.UnknownErrorException) {
    return reason;
  }

  return new _util.UnknownErrorException(reason.message, reason.toString());
}

function resolveOrReject(capability, success, reason) {
  if (success) {
    capability.resolve();
  } else {
    capability.reject(reason);
  }
}

function finalize(promise) {
  return Promise.resolve(promise).catch(function () {});
}

function MessageHandler(sourceName, targetName, comObj) {
  var _this = this;

  this.sourceName = sourceName;
  this.targetName = targetName;
  this.comObj = comObj;
  this.callbackId = 1;
  this.streamId = 1;
  this.postMessageTransfers = true;
  this.streamSinks = Object.create(null);
  this.streamControllers = Object.create(null);
  var callbacksCapabilities = this.callbacksCapabilities = Object.create(null);
  var ah = this.actionHandler = Object.create(null);

  this._onComObjOnMessage = function (event) {
    var data = event.data;

    if (data.targetName !== _this.sourceName) {
      return;
    }

    if (data.stream) {
      _this._processStreamMessage(data);
    } else if (data.isReply) {
      var callbackId = data.callbackId;

      if (data.callbackId in callbacksCapabilities) {
        var callback = callbacksCapabilities[callbackId];
        delete callbacksCapabilities[callbackId];

        if ('error' in data) {
          callback.reject(wrapReason(data.error));
        } else {
          callback.resolve(data.data);
        }
      } else {
        throw new Error("Cannot resolve callback ".concat(callbackId));
      }
    } else if (data.action in ah) {
      var action = ah[data.action];

      if (data.callbackId) {
        var _sourceName = _this.sourceName;
        var _targetName = data.sourceName;
        Promise.resolve().then(function () {
          return action[0].call(action[1], data.data);
        }).then(function (result) {
          comObj.postMessage({
            sourceName: _sourceName,
            targetName: _targetName,
            isReply: true,
            callbackId: data.callbackId,
            data: result
          });
        }, function (reason) {
          comObj.postMessage({
            sourceName: _sourceName,
            targetName: _targetName,
            isReply: true,
            callbackId: data.callbackId,
            error: makeReasonSerializable(reason)
          });
        });
      } else if (data.streamId) {
        _this._createStreamSink(data);
      } else {
        action[0].call(action[1], data.data);
      }
    } else {
      throw new Error("Unknown action from worker: ".concat(data.action));
    }
  };

  comObj.addEventListener('message', this._onComObjOnMessage);
}

MessageHandler.prototype = {
  on: function on(actionName, handler, scope) {
    var ah = this.actionHandler;

    if (ah[actionName]) {
      throw new Error("There is already an actionName called \"".concat(actionName, "\""));
    }

    ah[actionName] = [handler, scope];
  },
  send: function send(actionName, data, transfers) {
    var message = {
      sourceName: this.sourceName,
      targetName: this.targetName,
      action: actionName,
      data: data
    };
    this.postMessage(message, transfers);
  },
  sendWithPromise: function sendWithPromise(actionName, data, transfers) {
    var callbackId = this.callbackId++;
    var message = {
      sourceName: this.sourceName,
      targetName: this.targetName,
      action: actionName,
      data: data,
      callbackId: callbackId
    };
    var capability = (0, _util.createPromiseCapability)();
    this.callbacksCapabilities[callbackId] = capability;

    try {
      this.postMessage(message, transfers);
    } catch (e) {
      capability.reject(e);
    }

    return capability.promise;
  },
  sendWithStream: function sendWithStream(actionName, data, queueingStrategy, transfers) {
    var _this2 = this;

    var streamId = this.streamId++;
    var sourceName = this.sourceName;
    var targetName = this.targetName;
    return new _util.ReadableStream({
      start: function start(controller) {
        var startCapability = (0, _util.createPromiseCapability)();
        _this2.streamControllers[streamId] = {
          controller: controller,
          startCall: startCapability,
          isClosed: false
        };

        _this2.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          action: actionName,
          streamId: streamId,
          data: data,
          desiredSize: controller.desiredSize
        });

        return startCapability.promise;
      },
      pull: function pull(controller) {
        var pullCapability = (0, _util.createPromiseCapability)();
        _this2.streamControllers[streamId].pullCall = pullCapability;

        _this2.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: 'pull',
          streamId: streamId,
          desiredSize: controller.desiredSize
        });

        return pullCapability.promise;
      },
      cancel: function cancel(reason) {
        var cancelCapability = (0, _util.createPromiseCapability)();
        _this2.streamControllers[streamId].cancelCall = cancelCapability;
        _this2.streamControllers[streamId].isClosed = true;

        _this2.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: 'cancel',
          reason: reason,
          streamId: streamId
        });

        return cancelCapability.promise;
      }
    }, queueingStrategy);
  },
  _createStreamSink: function _createStreamSink(data) {
    var _this3 = this;

    var self = this;
    var action = this.actionHandler[data.action];
    var streamId = data.streamId;
    var desiredSize = data.desiredSize;
    var sourceName = this.sourceName;
    var targetName = data.sourceName;
    var capability = (0, _util.createPromiseCapability)();

    var sendStreamRequest = function sendStreamRequest(_ref) {
      var stream = _ref.stream,
          chunk = _ref.chunk,
          transfers = _ref.transfers,
          success = _ref.success,
          reason = _ref.reason;

      _this3.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        stream: stream,
        streamId: streamId,
        chunk: chunk,
        success: success,
        reason: reason
      }, transfers);
    };

    var streamSink = {
      enqueue: function enqueue(chunk) {
        var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
        var transfers = arguments.length > 2 ? arguments[2] : undefined;

        if (this.isCancelled) {
          return;
        }

        var lastDesiredSize = this.desiredSize;
        this.desiredSize -= size;

        if (lastDesiredSize > 0 && this.desiredSize <= 0) {
          this.sinkCapability = (0, _util.createPromiseCapability)();
          this.ready = this.sinkCapability.promise;
        }

        sendStreamRequest({
          stream: 'enqueue',
          chunk: chunk,
          transfers: transfers
        });
      },
      close: function close() {
        if (this.isCancelled) {
          return;
        }

        this.isCancelled = true;
        sendStreamRequest({
          stream: 'close'
        });
        delete self.streamSinks[streamId];
      },
      error: function error(reason) {
        if (this.isCancelled) {
          return;
        }

        this.isCancelled = true;
        sendStreamRequest({
          stream: 'error',
          reason: reason
        });
      },
      sinkCapability: capability,
      onPull: null,
      onCancel: null,
      isCancelled: false,
      desiredSize: desiredSize,
      ready: null
    };
    streamSink.sinkCapability.resolve();
    streamSink.ready = streamSink.sinkCapability.promise;
    this.streamSinks[streamId] = streamSink;
    resolveCall(action[0], [data.data, streamSink], action[1]).then(function () {
      sendStreamRequest({
        stream: 'start_complete',
        success: true
      });
    }, function (reason) {
      sendStreamRequest({
        stream: 'start_complete',
        success: false,
        reason: reason
      });
    });
  },
  _processStreamMessage: function _processStreamMessage(data) {
    var _this4 = this;

    var sourceName = this.sourceName;
    var targetName = data.sourceName;
    var streamId = data.streamId;

    var sendStreamResponse = function sendStreamResponse(_ref2) {
      var stream = _ref2.stream,
          success = _ref2.success,
          reason = _ref2.reason;

      _this4.comObj.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        stream: stream,
        success: success,
        streamId: streamId,
        reason: reason
      });
    };

    var deleteStreamController = function deleteStreamController() {
      Promise.all([_this4.streamControllers[data.streamId].startCall, _this4.streamControllers[data.streamId].pullCall, _this4.streamControllers[data.streamId].cancelCall].map(function (capability) {
        return capability && finalize(capability.promise);
      })).then(function () {
        delete _this4.streamControllers[data.streamId];
      });
    };

    switch (data.stream) {
      case 'start_complete':
        resolveOrReject(this.streamControllers[data.streamId].startCall, data.success, wrapReason(data.reason));
        break;

      case 'pull_complete':
        resolveOrReject(this.streamControllers[data.streamId].pullCall, data.success, wrapReason(data.reason));
        break;

      case 'pull':
        if (!this.streamSinks[data.streamId]) {
          sendStreamResponse({
            stream: 'pull_complete',
            success: true
          });
          break;
        }

        if (this.streamSinks[data.streamId].desiredSize <= 0 && data.desiredSize > 0) {
          this.streamSinks[data.streamId].sinkCapability.resolve();
        }

        this.streamSinks[data.streamId].desiredSize = data.desiredSize;
        resolveCall(this.streamSinks[data.streamId].onPull).then(function () {
          sendStreamResponse({
            stream: 'pull_complete',
            success: true
          });
        }, function (reason) {
          sendStreamResponse({
            stream: 'pull_complete',
            success: false,
            reason: reason
          });
        });
        break;

      case 'enqueue':
        (0, _util.assert)(this.streamControllers[data.streamId], 'enqueue should have stream controller');

        if (!this.streamControllers[data.streamId].isClosed) {
          this.streamControllers[data.streamId].controller.enqueue(data.chunk);
        }

        break;

      case 'close':
        (0, _util.assert)(this.streamControllers[data.streamId], 'close should have stream controller');

        if (this.streamControllers[data.streamId].isClosed) {
          break;
        }

        this.streamControllers[data.streamId].isClosed = true;
        this.streamControllers[data.streamId].controller.close();
        deleteStreamController();
        break;

      case 'error':
        (0, _util.assert)(this.streamControllers[data.streamId], 'error should have stream controller');
        this.streamControllers[data.streamId].controller.error(wrapReason(data.reason));
        deleteStreamController();
        break;

      case 'cancel_complete':
        resolveOrReject(this.streamControllers[data.streamId].cancelCall, data.success, wrapReason(data.reason));
        deleteStreamController();
        break;

      case 'cancel':
        if (!this.streamSinks[data.streamId]) {
          break;
        }

        resolveCall(this.streamSinks[data.streamId].onCancel, [wrapReason(data.reason)]).then(function () {
          sendStreamResponse({
            stream: 'cancel_complete',
            success: true
          });
        }, function (reason) {
          sendStreamResponse({
            stream: 'cancel_complete',
            success: false,
            reason: reason
          });
        });
        this.streamSinks[data.streamId].sinkCapability.reject(wrapReason(data.reason));
        this.streamSinks[data.streamId].isCancelled = true;
        delete this.streamSinks[data.streamId];
        break;

      default:
        throw new Error('Unexpected stream case');
    }
  },
  postMessage: function postMessage(message, transfers) {
    if (transfers && this.postMessageTransfers) {
      this.comObj.postMessage(message, transfers);
    } else {
      this.comObj.postMessage(message);
    }
  },
  destroy: function destroy() {
    this.comObj.removeEventListener('message', this._onComObjOnMessage);
  }
};

/***/ }),
/* 158 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Metadata = void 0;

var _util = __w_pdfjs_require__(1);

var _xml_parser = __w_pdfjs_require__(159);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Metadata =
/*#__PURE__*/
function () {
  function Metadata(data) {
    _classCallCheck(this, Metadata);

    (0, _util.assert)(typeof data === 'string', 'Metadata: input is not a string');
    data = this._repair(data);
    var parser = new _xml_parser.SimpleXMLParser();
    var xmlDocument = parser.parseFromString(data);
    this._metadata = Object.create(null);

    if (xmlDocument) {
      this._parse(xmlDocument);
    }
  }

  _createClass(Metadata, [{
    key: "_repair",
    value: function _repair(data) {
      return data.replace(/^([^<]+)/, '').replace(/>\\376\\377([^<]+)/g, function (all, codes) {
        var bytes = codes.replace(/\\([0-3])([0-7])([0-7])/g, function (code, d1, d2, d3) {
          return String.fromCharCode(d1 * 64 + d2 * 8 + d3 * 1);
        }).replace(/&(amp|apos|gt|lt|quot);/g, function (str, name) {
          switch (name) {
            case 'amp':
              return '&';

            case 'apos':
              return '\'';

            case 'gt':
              return '>';

            case 'lt':
              return '<';

            case 'quot':
              return '\"';
          }

          throw new Error("_repair: ".concat(name, " isn't defined."));
        });
        var chars = '';

        for (var i = 0, ii = bytes.length; i < ii; i += 2) {
          var code = bytes.charCodeAt(i) * 256 + bytes.charCodeAt(i + 1);

          if (code >= 32 && code < 127 && code !== 60 && code !== 62 && code !== 38) {
            chars += String.fromCharCode(code);
          } else {
            chars += '&#x' + (0x10000 + code).toString(16).substring(1) + ';';
          }
        }

        return '>' + chars;
      });
    }
  }, {
    key: "_parse",
    value: function _parse(xmlDocument) {
      var rdf = xmlDocument.documentElement;

      if (rdf.nodeName.toLowerCase() !== 'rdf:rdf') {
        rdf = rdf.firstChild;

        while (rdf && rdf.nodeName.toLowerCase() !== 'rdf:rdf') {
          rdf = rdf.nextSibling;
        }
      }

      var nodeName = rdf ? rdf.nodeName.toLowerCase() : null;

      if (!rdf || nodeName !== 'rdf:rdf' || !rdf.hasChildNodes()) {
        return;
      }

      var children = rdf.childNodes;

      for (var i = 0, ii = children.length; i < ii; i++) {
        var desc = children[i];

        if (desc.nodeName.toLowerCase() !== 'rdf:description') {
          continue;
        }

        for (var j = 0, jj = desc.childNodes.length; j < jj; j++) {
          if (desc.childNodes[j].nodeName.toLowerCase() !== '#text') {
            var entry = desc.childNodes[j];
            var name = entry.nodeName.toLowerCase();
            this._metadata[name] = entry.textContent.trim();
          }
        }
      }
    }
  }, {
    key: "get",
    value: function get(name) {
      var data = this._metadata[name];
      return typeof data !== 'undefined' ? data : null;
    }
  }, {
    key: "getAll",
    value: function getAll() {
      return this._metadata;
    }
  }, {
    key: "has",
    value: function has(name) {
      return typeof this._metadata[name] !== 'undefined';
    }
  }]);

  return Metadata;
}();

exports.Metadata = Metadata;

/***/ }),
/* 159 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SimpleXMLParser = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var XMLParserErrorCode = {
  NoError: 0,
  EndOfDocument: -1,
  UnterminatedCdat: -2,
  UnterminatedXmlDeclaration: -3,
  UnterminatedDoctypeDeclaration: -4,
  UnterminatedComment: -5,
  MalformedElement: -6,
  OutOfMemory: -7,
  UnterminatedAttributeValue: -8,
  UnterminatedElement: -9,
  ElementNeverBegun: -10
};

function isWhitespace(s, index) {
  var ch = s[index];
  return ch === ' ' || ch === '\n' || ch === '\r' || ch === '\t';
}

function isWhitespaceString(s) {
  for (var i = 0, ii = s.length; i < ii; i++) {
    if (!isWhitespace(s, i)) {
      return false;
    }
  }

  return true;
}

var XMLParserBase =
/*#__PURE__*/
function () {
  function XMLParserBase() {
    _classCallCheck(this, XMLParserBase);
  }

  _createClass(XMLParserBase, [{
    key: "_resolveEntities",
    value: function _resolveEntities(s) {
      var _this = this;

      return s.replace(/&([^;]+);/g, function (all, entity) {
        if (entity.substring(0, 2) === '#x') {
          return String.fromCharCode(parseInt(entity.substring(2), 16));
        } else if (entity.substring(0, 1) === '#') {
          return String.fromCharCode(parseInt(entity.substring(1), 10));
        }

        switch (entity) {
          case 'lt':
            return '<';

          case 'gt':
            return '>';

          case 'amp':
            return '&';

          case 'quot':
            return '\"';
        }

        return _this.onResolveEntity(entity);
      });
    }
  }, {
    key: "_parseContent",
    value: function _parseContent(s, start) {
      var pos = start,
          name,
          attributes = [];

      function skipWs() {
        while (pos < s.length && isWhitespace(s, pos)) {
          ++pos;
        }
      }

      while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== '>' && s[pos] !== '/') {
        ++pos;
      }

      name = s.substring(start, pos);
      skipWs();

      while (pos < s.length && s[pos] !== '>' && s[pos] !== '/' && s[pos] !== '?') {
        skipWs();
        var attrName = '',
            attrValue = '';

        while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== '=') {
          attrName += s[pos];
          ++pos;
        }

        skipWs();

        if (s[pos] !== '=') {
          return null;
        }

        ++pos;
        skipWs();
        var attrEndChar = s[pos];

        if (attrEndChar !== '\"' && attrEndChar !== '\'') {
          return null;
        }

        var attrEndIndex = s.indexOf(attrEndChar, ++pos);

        if (attrEndIndex < 0) {
          return null;
        }

        attrValue = s.substring(pos, attrEndIndex);
        attributes.push({
          name: attrName,
          value: this._resolveEntities(attrValue)
        });
        pos = attrEndIndex + 1;
        skipWs();
      }

      return {
        name: name,
        attributes: attributes,
        parsed: pos - start
      };
    }
  }, {
    key: "_parseProcessingInstruction",
    value: function _parseProcessingInstruction(s, start) {
      var pos = start,
          name,
          value;

      function skipWs() {
        while (pos < s.length && isWhitespace(s, pos)) {
          ++pos;
        }
      }

      while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== '>' && s[pos] !== '/') {
        ++pos;
      }

      name = s.substring(start, pos);
      skipWs();
      var attrStart = pos;

      while (pos < s.length && (s[pos] !== '?' || s[pos + 1] !== '>')) {
        ++pos;
      }

      value = s.substring(attrStart, pos);
      return {
        name: name,
        value: value,
        parsed: pos - start
      };
    }
  }, {
    key: "parseXml",
    value: function parseXml(s) {
      var i = 0;

      while (i < s.length) {
        var ch = s[i];
        var j = i;

        if (ch === '<') {
          ++j;
          var ch2 = s[j];
          var q = void 0;

          switch (ch2) {
            case '/':
              ++j;
              q = s.indexOf('>', j);

              if (q < 0) {
                this.onError(XMLParserErrorCode.UnterminatedElement);
                return;
              }

              this.onEndElement(s.substring(j, q));
              j = q + 1;
              break;

            case '?':
              ++j;

              var pi = this._parseProcessingInstruction(s, j);

              if (s.substring(j + pi.parsed, j + pi.parsed + 2) !== '?>') {
                this.onError(XMLParserErrorCode.UnterminatedXmlDeclaration);
                return;
              }

              this.onPi(pi.name, pi.value);
              j += pi.parsed + 2;
              break;

            case '!':
              if (s.substring(j + 1, j + 3) === '--') {
                q = s.indexOf('-->', j + 3);

                if (q < 0) {
                  this.onError(XMLParserErrorCode.UnterminatedComment);
                  return;
                }

                this.onComment(s.substring(j + 3, q));
                j = q + 3;
              } else if (s.substring(j + 1, j + 8) === '[CDATA[') {
                q = s.indexOf(']]>', j + 8);

                if (q < 0) {
                  this.onError(XMLParserErrorCode.UnterminatedCdat);
                  return;
                }

                this.onCdata(s.substring(j + 8, q));
                j = q + 3;
              } else if (s.substring(j + 1, j + 8) === 'DOCTYPE') {
                var q2 = s.indexOf('[', j + 8);
                var complexDoctype = false;
                q = s.indexOf('>', j + 8);

                if (q < 0) {
                  this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
                  return;
                }

                if (q2 > 0 && q > q2) {
                  q = s.indexOf(']>', j + 8);

                  if (q < 0) {
                    this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
                    return;
                  }

                  complexDoctype = true;
                }

                var doctypeContent = s.substring(j + 8, q + (complexDoctype ? 1 : 0));
                this.onDoctype(doctypeContent);
                j = q + (complexDoctype ? 2 : 1);
              } else {
                this.onError(XMLParserErrorCode.MalformedElement);
                return;
              }

              break;

            default:
              var content = this._parseContent(s, j);

              if (content === null) {
                this.onError(XMLParserErrorCode.MalformedElement);
                return;
              }

              var isClosed = false;

              if (s.substring(j + content.parsed, j + content.parsed + 2) === '/>') {
                isClosed = true;
              } else if (s.substring(j + content.parsed, j + content.parsed + 1) !== '>') {
                this.onError(XMLParserErrorCode.UnterminatedElement);
                return;
              }

              this.onBeginElement(content.name, content.attributes, isClosed);
              j += content.parsed + (isClosed ? 2 : 1);
              break;
          }
        } else {
          while (j < s.length && s[j] !== '<') {
            j++;
          }

          var text = s.substring(i, j);
          this.onText(this._resolveEntities(text));
        }

        i = j;
      }
    }
  }, {
    key: "onResolveEntity",
    value: function onResolveEntity(name) {
      return "&".concat(name, ";");
    }
  }, {
    key: "onPi",
    value: function onPi(name, value) {}
  }, {
    key: "onComment",
    value: function onComment(text) {}
  }, {
    key: "onCdata",
    value: function onCdata(text) {}
  }, {
    key: "onDoctype",
    value: function onDoctype(doctypeContent) {}
  }, {
    key: "onText",
    value: function onText(text) {}
  }, {
    key: "onBeginElement",
    value: function onBeginElement(name, attributes, isEmpty) {}
  }, {
    key: "onEndElement",
    value: function onEndElement(name) {}
  }, {
    key: "onError",
    value: function onError(code) {}
  }]);

  return XMLParserBase;
}();

var SimpleDOMNode =
/*#__PURE__*/
function () {
  function SimpleDOMNode(nodeName, nodeValue) {
    _classCallCheck(this, SimpleDOMNode);

    this.nodeName = nodeName;
    this.nodeValue = nodeValue;
    Object.defineProperty(this, 'parentNode', {
      value: null,
      writable: true
    });
  }

  _createClass(SimpleDOMNode, [{
    key: "hasChildNodes",
    value: function hasChildNodes() {
      return this.childNodes && this.childNodes.length > 0;
    }
  }, {
    key: "firstChild",
    get: function get() {
      return this.childNodes && this.childNodes[0];
    }
  }, {
    key: "nextSibling",
    get: function get() {
      var childNodes = this.parentNode.childNodes;

      if (!childNodes) {
        return undefined;
      }

      var index = childNodes.indexOf(this);

      if (index === -1) {
        return undefined;
      }

      return childNodes[index + 1];
    }
  }, {
    key: "textContent",
    get: function get() {
      if (!this.childNodes) {
        return this.nodeValue || '';
      }

      return this.childNodes.map(function (child) {
        return child.textContent;
      }).join('');
    }
  }]);

  return SimpleDOMNode;
}();

var SimpleXMLParser =
/*#__PURE__*/
function (_XMLParserBase) {
  _inherits(SimpleXMLParser, _XMLParserBase);

  function SimpleXMLParser() {
    var _this2;

    _classCallCheck(this, SimpleXMLParser);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(SimpleXMLParser).call(this));
    _this2._currentFragment = null;
    _this2._stack = null;
    _this2._errorCode = XMLParserErrorCode.NoError;
    return _this2;
  }

  _createClass(SimpleXMLParser, [{
    key: "parseFromString",
    value: function parseFromString(data) {
      this._currentFragment = [];
      this._stack = [];
      this._errorCode = XMLParserErrorCode.NoError;
      this.parseXml(data);

      if (this._errorCode !== XMLParserErrorCode.NoError) {
        return undefined;
      }

      var _this$_currentFragmen = _slicedToArray(this._currentFragment, 1),
          documentElement = _this$_currentFragmen[0];

      if (!documentElement) {
        return undefined;
      }

      return {
        documentElement: documentElement
      };
    }
  }, {
    key: "onResolveEntity",
    value: function onResolveEntity(name) {
      switch (name) {
        case 'apos':
          return '\'';
      }

      return _get(_getPrototypeOf(SimpleXMLParser.prototype), "onResolveEntity", this).call(this, name);
    }
  }, {
    key: "onText",
    value: function onText(text) {
      if (isWhitespaceString(text)) {
        return;
      }

      var node = new SimpleDOMNode('#text', text);

      this._currentFragment.push(node);
    }
  }, {
    key: "onCdata",
    value: function onCdata(text) {
      var node = new SimpleDOMNode('#text', text);

      this._currentFragment.push(node);
    }
  }, {
    key: "onBeginElement",
    value: function onBeginElement(name, attributes, isEmpty) {
      var node = new SimpleDOMNode(name);
      node.childNodes = [];

      this._currentFragment.push(node);

      if (isEmpty) {
        return;
      }

      this._stack.push(this._currentFragment);

      this._currentFragment = node.childNodes;
    }
  }, {
    key: "onEndElement",
    value: function onEndElement(name) {
      this._currentFragment = this._stack.pop() || [];
      var lastElement = this._currentFragment[this._currentFragment.length - 1];

      if (!lastElement) {
        return;
      }

      for (var i = 0, ii = lastElement.childNodes.length; i < ii; i++) {
        lastElement.childNodes[i].parentNode = lastElement;
      }
    }
  }, {
    key: "onError",
    value: function onError(code) {
      this._errorCode = code;
    }
  }]);

  return SimpleXMLParser;
}(XMLParserBase);

exports.SimpleXMLParser = SimpleXMLParser;

/***/ }),
/* 160 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFDataTransportStream = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(147));

var _util = __w_pdfjs_require__(1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var PDFDataTransportStream = function PDFDataTransportStreamClosure() {
  function PDFDataTransportStream(params, pdfDataRangeTransport) {
    var _this = this;

    (0, _util.assert)(pdfDataRangeTransport);
    this._queuedChunks = [];
    var initialData = params.initialData;

    if (initialData && initialData.length > 0) {
      var buffer = new Uint8Array(initialData).buffer;

      this._queuedChunks.push(buffer);
    }

    this._pdfDataRangeTransport = pdfDataRangeTransport;
    this._isStreamingSupported = !params.disableStream;
    this._isRangeSupported = !params.disableRange;
    this._contentLength = params.length;
    this._fullRequestReader = null;
    this._rangeReaders = [];

    this._pdfDataRangeTransport.addRangeListener(function (begin, chunk) {
      _this._onReceiveData({
        begin: begin,
        chunk: chunk
      });
    });

    this._pdfDataRangeTransport.addProgressListener(function (loaded) {
      _this._onProgress({
        loaded: loaded
      });
    });

    this._pdfDataRangeTransport.addProgressiveReadListener(function (chunk) {
      _this._onReceiveData({
        chunk: chunk
      });
    });

    this._pdfDataRangeTransport.transportReady();
  }

  PDFDataTransportStream.prototype = {
    _onReceiveData: function PDFDataTransportStream_onReceiveData(args) {
      var buffer = new Uint8Array(args.chunk).buffer;

      if (args.begin === undefined) {
        if (this._fullRequestReader) {
          this._fullRequestReader._enqueue(buffer);
        } else {
          this._queuedChunks.push(buffer);
        }
      } else {
        var found = this._rangeReaders.some(function (rangeReader) {
          if (rangeReader._begin !== args.begin) {
            return false;
          }

          rangeReader._enqueue(buffer);

          return true;
        });

        (0, _util.assert)(found);
      }
    },
    _onProgress: function PDFDataTransportStream_onDataProgress(evt) {
      if (this._rangeReaders.length > 0) {
        var firstReader = this._rangeReaders[0];

        if (firstReader.onProgress) {
          firstReader.onProgress({
            loaded: evt.loaded
          });
        }
      }
    },
    _removeRangeReader: function PDFDataTransportStream_removeRangeReader(reader) {
      var i = this._rangeReaders.indexOf(reader);

      if (i >= 0) {
        this._rangeReaders.splice(i, 1);
      }
    },
    getFullReader: function PDFDataTransportStream_getFullReader() {
      (0, _util.assert)(!this._fullRequestReader);
      var queuedChunks = this._queuedChunks;
      this._queuedChunks = null;
      return new PDFDataTransportStreamReader(this, queuedChunks);
    },
    getRangeReader: function PDFDataTransportStream_getRangeReader(begin, end) {
      var reader = new PDFDataTransportStreamRangeReader(this, begin, end);

      this._pdfDataRangeTransport.requestDataRange(begin, end);

      this._rangeReaders.push(reader);

      return reader;
    },
    cancelAllRequests: function PDFDataTransportStream_cancelAllRequests(reason) {
      if (this._fullRequestReader) {
        this._fullRequestReader.cancel(reason);
      }

      var readers = this._rangeReaders.slice(0);

      readers.forEach(function (rangeReader) {
        rangeReader.cancel(reason);
      });

      this._pdfDataRangeTransport.abort();
    }
  };

  function PDFDataTransportStreamReader(stream, queuedChunks) {
    this._stream = stream;
    this._done = false;
    this._filename = null;
    this._queuedChunks = queuedChunks || [];
    this._requests = [];
    this._headersReady = Promise.resolve();
    stream._fullRequestReader = this;
    this.onProgress = null;
  }

  PDFDataTransportStreamReader.prototype = {
    _enqueue: function PDFDataTransportStreamReader_enqueue(chunk) {
      if (this._done) {
        return;
      }

      if (this._requests.length > 0) {
        var requestCapability = this._requests.shift();

        requestCapability.resolve({
          value: chunk,
          done: false
        });
        return;
      }

      this._queuedChunks.push(chunk);
    },

    get headersReady() {
      return this._headersReady;
    },

    get filename() {
      return this._filename;
    },

    get isRangeSupported() {
      return this._stream._isRangeSupported;
    },

    get isStreamingSupported() {
      return this._stream._isStreamingSupported;
    },

    get contentLength() {
      return this._stream._contentLength;
    },

    read: function () {
      var _read = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var chunk, requestCapability;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(this._queuedChunks.length > 0)) {
                  _context.next = 3;
                  break;
                }

                chunk = this._queuedChunks.shift();
                return _context.abrupt("return", {
                  value: chunk,
                  done: false
                });

              case 3:
                if (!this._done) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("return", {
                  value: undefined,
                  done: true
                });

              case 5:
                requestCapability = (0, _util.createPromiseCapability)();

                this._requests.push(requestCapability);

                return _context.abrupt("return", requestCapability.promise);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function read() {
        return _read.apply(this, arguments);
      }

      return read;
    }(),
    cancel: function PDFDataTransportStreamReader_cancel(reason) {
      this._done = true;

      this._requests.forEach(function (requestCapability) {
        requestCapability.resolve({
          value: undefined,
          done: true
        });
      });

      this._requests = [];
    }
  };

  function PDFDataTransportStreamRangeReader(stream, begin, end) {
    this._stream = stream;
    this._begin = begin;
    this._end = end;
    this._queuedChunk = null;
    this._requests = [];
    this._done = false;
    this.onProgress = null;
  }

  PDFDataTransportStreamRangeReader.prototype = {
    _enqueue: function PDFDataTransportStreamRangeReader_enqueue(chunk) {
      if (this._done) {
        return;
      }

      if (this._requests.length === 0) {
        this._queuedChunk = chunk;
      } else {
        var requestsCapability = this._requests.shift();

        requestsCapability.resolve({
          value: chunk,
          done: false
        });

        this._requests.forEach(function (requestCapability) {
          requestCapability.resolve({
            value: undefined,
            done: true
          });
        });

        this._requests = [];
      }

      this._done = true;

      this._stream._removeRangeReader(this);
    },

    get isStreamingSupported() {
      return false;
    },

    read: function () {
      var _read2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var chunk, requestCapability;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!this._queuedChunk) {
                  _context2.next = 4;
                  break;
                }

                chunk = this._queuedChunk;
                this._queuedChunk = null;
                return _context2.abrupt("return", {
                  value: chunk,
                  done: false
                });

              case 4:
                if (!this._done) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt("return", {
                  value: undefined,
                  done: true
                });

              case 6:
                requestCapability = (0, _util.createPromiseCapability)();

                this._requests.push(requestCapability);

                return _context2.abrupt("return", requestCapability.promise);

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read() {
        return _read2.apply(this, arguments);
      }

      return read;
    }(),
    cancel: function PDFDataTransportStreamRangeReader_cancel(reason) {
      this._done = true;

      this._requests.forEach(function (requestCapability) {
        requestCapability.resolve({
          value: undefined,
          done: true
        });
      });

      this._requests = [];

      this._stream._removeRangeReader(this);
    }
  };
  return PDFDataTransportStream;
}();

exports.PDFDataTransportStream = PDFDataTransportStream;

/***/ }),
/* 161 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebGLContext = void 0;

var _util = __w_pdfjs_require__(1);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var WebGLContext =
/*#__PURE__*/
function () {
  function WebGLContext(_ref) {
    var _ref$enable = _ref.enable,
        enable = _ref$enable === void 0 ? false : _ref$enable;

    _classCallCheck(this, WebGLContext);

    this._enabled = enable === true;
  }

  _createClass(WebGLContext, [{
    key: "composeSMask",
    value: function composeSMask(_ref2) {
      var layer = _ref2.layer,
          mask = _ref2.mask,
          properties = _ref2.properties;
      return WebGLUtils.composeSMask(layer, mask, properties);
    }
  }, {
    key: "drawFigures",
    value: function drawFigures(_ref3) {
      var width = _ref3.width,
          height = _ref3.height,
          backgroundColor = _ref3.backgroundColor,
          figures = _ref3.figures,
          context = _ref3.context;
      return WebGLUtils.drawFigures(width, height, backgroundColor, figures, context);
    }
  }, {
    key: "clear",
    value: function clear() {
      WebGLUtils.cleanup();
    }
  }, {
    key: "isEnabled",
    get: function get() {
      var enabled = this._enabled;

      if (enabled) {
        enabled = WebGLUtils.tryInitGL();
      }

      return (0, _util.shadow)(this, 'isEnabled', enabled);
    }
  }]);

  return WebGLContext;
}();

exports.WebGLContext = WebGLContext;

var WebGLUtils = function WebGLUtilsClosure() {
  function loadShader(gl, code, shaderType) {
    var shader = gl.createShader(shaderType);
    gl.shaderSource(shader, code);
    gl.compileShader(shader);
    var compiled = gl.getShaderParameter(shader, gl.COMPILE_STATUS);

    if (!compiled) {
      var errorMsg = gl.getShaderInfoLog(shader);
      throw new Error('Error during shader compilation: ' + errorMsg);
    }

    return shader;
  }

  function createVertexShader(gl, code) {
    return loadShader(gl, code, gl.VERTEX_SHADER);
  }

  function createFragmentShader(gl, code) {
    return loadShader(gl, code, gl.FRAGMENT_SHADER);
  }

  function createProgram(gl, shaders) {
    var program = gl.createProgram();

    for (var i = 0, ii = shaders.length; i < ii; ++i) {
      gl.attachShader(program, shaders[i]);
    }

    gl.linkProgram(program);
    var linked = gl.getProgramParameter(program, gl.LINK_STATUS);

    if (!linked) {
      var errorMsg = gl.getProgramInfoLog(program);
      throw new Error('Error during program linking: ' + errorMsg);
    }

    return program;
  }

  function createTexture(gl, image, textureId) {
    gl.activeTexture(textureId);
    var texture = gl.createTexture();
    gl.bindTexture(gl.TEXTURE_2D, texture);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
    gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, image);
    return texture;
  }

  var currentGL, currentCanvas;

  function generateGL() {
    if (currentGL) {
      return;
    }

    currentCanvas = document.createElement('canvas');
    currentGL = currentCanvas.getContext('webgl', {
      premultipliedalpha: false
    });
  }

  var smaskVertexShaderCode = '\
  attribute vec2 a_position;                                    \
  attribute vec2 a_texCoord;                                    \
                                                                \
  uniform vec2 u_resolution;                                    \
                                                                \
  varying vec2 v_texCoord;                                      \
                                                                \
  void main() {                                                 \
    vec2 clipSpace = (a_position / u_resolution) * 2.0 - 1.0;   \
    gl_Position = vec4(clipSpace * vec2(1, -1), 0, 1);          \
                                                                \
    v_texCoord = a_texCoord;                                    \
  }                                                             ';
  var smaskFragmentShaderCode = '\
  precision mediump float;                                      \
                                                                \
  uniform vec4 u_backdrop;                                      \
  uniform int u_subtype;                                        \
  uniform sampler2D u_image;                                    \
  uniform sampler2D u_mask;                                     \
                                                                \
  varying vec2 v_texCoord;                                      \
                                                                \
  void main() {                                                 \
    vec4 imageColor = texture2D(u_image, v_texCoord);           \
    vec4 maskColor = texture2D(u_mask, v_texCoord);             \
    if (u_backdrop.a > 0.0) {                                   \
      maskColor.rgb = maskColor.rgb * maskColor.a +             \
                      u_backdrop.rgb * (1.0 - maskColor.a);     \
    }                                                           \
    float lum;                                                  \
    if (u_subtype == 0) {                                       \
      lum = maskColor.a;                                        \
    } else {                                                    \
      lum = maskColor.r * 0.3 + maskColor.g * 0.59 +            \
            maskColor.b * 0.11;                                 \
    }                                                           \
    imageColor.a *= lum;                                        \
    imageColor.rgb *= imageColor.a;                             \
    gl_FragColor = imageColor;                                  \
  }                                                             ';
  var smaskCache = null;

  function initSmaskGL() {
    var canvas, gl;
    generateGL();
    canvas = currentCanvas;
    currentCanvas = null;
    gl = currentGL;
    currentGL = null;
    var vertexShader = createVertexShader(gl, smaskVertexShaderCode);
    var fragmentShader = createFragmentShader(gl, smaskFragmentShaderCode);
    var program = createProgram(gl, [vertexShader, fragmentShader]);
    gl.useProgram(program);
    var cache = {};
    cache.gl = gl;
    cache.canvas = canvas;
    cache.resolutionLocation = gl.getUniformLocation(program, 'u_resolution');
    cache.positionLocation = gl.getAttribLocation(program, 'a_position');
    cache.backdropLocation = gl.getUniformLocation(program, 'u_backdrop');
    cache.subtypeLocation = gl.getUniformLocation(program, 'u_subtype');
    var texCoordLocation = gl.getAttribLocation(program, 'a_texCoord');
    var texLayerLocation = gl.getUniformLocation(program, 'u_image');
    var texMaskLocation = gl.getUniformLocation(program, 'u_mask');
    var texCoordBuffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, texCoordBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, 1.0]), gl.STATIC_DRAW);
    gl.enableVertexAttribArray(texCoordLocation);
    gl.vertexAttribPointer(texCoordLocation, 2, gl.FLOAT, false, 0, 0);
    gl.uniform1i(texLayerLocation, 0);
    gl.uniform1i(texMaskLocation, 1);
    smaskCache = cache;
  }

  function composeSMask(layer, mask, properties) {
    var width = layer.width,
        height = layer.height;

    if (!smaskCache) {
      initSmaskGL();
    }

    var cache = smaskCache,
        canvas = cache.canvas,
        gl = cache.gl;
    canvas.width = width;
    canvas.height = height;
    gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);
    gl.uniform2f(cache.resolutionLocation, width, height);

    if (properties.backdrop) {
      gl.uniform4f(cache.resolutionLocation, properties.backdrop[0], properties.backdrop[1], properties.backdrop[2], 1);
    } else {
      gl.uniform4f(cache.resolutionLocation, 0, 0, 0, 0);
    }

    gl.uniform1i(cache.subtypeLocation, properties.subtype === 'Luminosity' ? 1 : 0);
    var texture = createTexture(gl, layer, gl.TEXTURE0);
    var maskTexture = createTexture(gl, mask, gl.TEXTURE1);
    var buffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array([0, 0, width, 0, 0, height, 0, height, width, 0, width, height]), gl.STATIC_DRAW);
    gl.enableVertexAttribArray(cache.positionLocation);
    gl.vertexAttribPointer(cache.positionLocation, 2, gl.FLOAT, false, 0, 0);
    gl.clearColor(0, 0, 0, 0);
    gl.enable(gl.BLEND);
    gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
    gl.clear(gl.COLOR_BUFFER_BIT);
    gl.drawArrays(gl.TRIANGLES, 0, 6);
    gl.flush();
    gl.deleteTexture(texture);
    gl.deleteTexture(maskTexture);
    gl.deleteBuffer(buffer);
    return canvas;
  }

  var figuresVertexShaderCode = '\
  attribute vec2 a_position;                                    \
  attribute vec3 a_color;                                       \
                                                                \
  uniform vec2 u_resolution;                                    \
  uniform vec2 u_scale;                                         \
  uniform vec2 u_offset;                                        \
                                                                \
  varying vec4 v_color;                                         \
                                                                \
  void main() {                                                 \
    vec2 position = (a_position + u_offset) * u_scale;          \
    vec2 clipSpace = (position / u_resolution) * 2.0 - 1.0;     \
    gl_Position = vec4(clipSpace * vec2(1, -1), 0, 1);          \
                                                                \
    v_color = vec4(a_color / 255.0, 1.0);                       \
  }                                                             ';
  var figuresFragmentShaderCode = '\
  precision mediump float;                                      \
                                                                \
  varying vec4 v_color;                                         \
                                                                \
  void main() {                                                 \
    gl_FragColor = v_color;                                     \
  }                                                             ';
  var figuresCache = null;

  function initFiguresGL() {
    var canvas, gl;
    generateGL();
    canvas = currentCanvas;
    currentCanvas = null;
    gl = currentGL;
    currentGL = null;
    var vertexShader = createVertexShader(gl, figuresVertexShaderCode);
    var fragmentShader = createFragmentShader(gl, figuresFragmentShaderCode);
    var program = createProgram(gl, [vertexShader, fragmentShader]);
    gl.useProgram(program);
    var cache = {};
    cache.gl = gl;
    cache.canvas = canvas;
    cache.resolutionLocation = gl.getUniformLocation(program, 'u_resolution');
    cache.scaleLocation = gl.getUniformLocation(program, 'u_scale');
    cache.offsetLocation = gl.getUniformLocation(program, 'u_offset');
    cache.positionLocation = gl.getAttribLocation(program, 'a_position');
    cache.colorLocation = gl.getAttribLocation(program, 'a_color');
    figuresCache = cache;
  }

  function drawFigures(width, height, backgroundColor, figures, context) {
    if (!figuresCache) {
      initFiguresGL();
    }

    var cache = figuresCache,
        canvas = cache.canvas,
        gl = cache.gl;
    canvas.width = width;
    canvas.height = height;
    gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);
    gl.uniform2f(cache.resolutionLocation, width, height);
    var count = 0;
    var i, ii, rows;

    for (i = 0, ii = figures.length; i < ii; i++) {
      switch (figures[i].type) {
        case 'lattice':
          rows = figures[i].coords.length / figures[i].verticesPerRow | 0;
          count += (rows - 1) * (figures[i].verticesPerRow - 1) * 6;
          break;

        case 'triangles':
          count += figures[i].coords.length;
          break;
      }
    }

    var coords = new Float32Array(count * 2);
    var colors = new Uint8Array(count * 3);
    var coordsMap = context.coords,
        colorsMap = context.colors;
    var pIndex = 0,
        cIndex = 0;

    for (i = 0, ii = figures.length; i < ii; i++) {
      var figure = figures[i],
          ps = figure.coords,
          cs = figure.colors;

      switch (figure.type) {
        case 'lattice':
          var cols = figure.verticesPerRow;
          rows = ps.length / cols | 0;

          for (var row = 1; row < rows; row++) {
            var offset = row * cols + 1;

            for (var col = 1; col < cols; col++, offset++) {
              coords[pIndex] = coordsMap[ps[offset - cols - 1]];
              coords[pIndex + 1] = coordsMap[ps[offset - cols - 1] + 1];
              coords[pIndex + 2] = coordsMap[ps[offset - cols]];
              coords[pIndex + 3] = coordsMap[ps[offset - cols] + 1];
              coords[pIndex + 4] = coordsMap[ps[offset - 1]];
              coords[pIndex + 5] = coordsMap[ps[offset - 1] + 1];
              colors[cIndex] = colorsMap[cs[offset - cols - 1]];
              colors[cIndex + 1] = colorsMap[cs[offset - cols - 1] + 1];
              colors[cIndex + 2] = colorsMap[cs[offset - cols - 1] + 2];
              colors[cIndex + 3] = colorsMap[cs[offset - cols]];
              colors[cIndex + 4] = colorsMap[cs[offset - cols] + 1];
              colors[cIndex + 5] = colorsMap[cs[offset - cols] + 2];
              colors[cIndex + 6] = colorsMap[cs[offset - 1]];
              colors[cIndex + 7] = colorsMap[cs[offset - 1] + 1];
              colors[cIndex + 8] = colorsMap[cs[offset - 1] + 2];
              coords[pIndex + 6] = coords[pIndex + 2];
              coords[pIndex + 7] = coords[pIndex + 3];
              coords[pIndex + 8] = coords[pIndex + 4];
              coords[pIndex + 9] = coords[pIndex + 5];
              coords[pIndex + 10] = coordsMap[ps[offset]];
              coords[pIndex + 11] = coordsMap[ps[offset] + 1];
              colors[cIndex + 9] = colors[cIndex + 3];
              colors[cIndex + 10] = colors[cIndex + 4];
              colors[cIndex + 11] = colors[cIndex + 5];
              colors[cIndex + 12] = colors[cIndex + 6];
              colors[cIndex + 13] = colors[cIndex + 7];
              colors[cIndex + 14] = colors[cIndex + 8];
              colors[cIndex + 15] = colorsMap[cs[offset]];
              colors[cIndex + 16] = colorsMap[cs[offset] + 1];
              colors[cIndex + 17] = colorsMap[cs[offset] + 2];
              pIndex += 12;
              cIndex += 18;
            }
          }

          break;

        case 'triangles':
          for (var j = 0, jj = ps.length; j < jj; j++) {
            coords[pIndex] = coordsMap[ps[j]];
            coords[pIndex + 1] = coordsMap[ps[j] + 1];
            colors[cIndex] = colorsMap[cs[j]];
            colors[cIndex + 1] = colorsMap[cs[j] + 1];
            colors[cIndex + 2] = colorsMap[cs[j] + 2];
            pIndex += 2;
            cIndex += 3;
          }

          break;
      }
    }

    if (backgroundColor) {
      gl.clearColor(backgroundColor[0] / 255, backgroundColor[1] / 255, backgroundColor[2] / 255, 1.0);
    } else {
      gl.clearColor(0, 0, 0, 0);
    }

    gl.clear(gl.COLOR_BUFFER_BIT);
    var coordsBuffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, coordsBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, coords, gl.STATIC_DRAW);
    gl.enableVertexAttribArray(cache.positionLocation);
    gl.vertexAttribPointer(cache.positionLocation, 2, gl.FLOAT, false, 0, 0);
    var colorsBuffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, colorsBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, colors, gl.STATIC_DRAW);
    gl.enableVertexAttribArray(cache.colorLocation);
    gl.vertexAttribPointer(cache.colorLocation, 3, gl.UNSIGNED_BYTE, false, 0, 0);
    gl.uniform2f(cache.scaleLocation, context.scaleX, context.scaleY);
    gl.uniform2f(cache.offsetLocation, context.offsetX, context.offsetY);
    gl.drawArrays(gl.TRIANGLES, 0, count);
    gl.flush();
    gl.deleteBuffer(coordsBuffer);
    gl.deleteBuffer(colorsBuffer);
    return canvas;
  }

  return {
    tryInitGL: function tryInitGL() {
      try {
        generateGL();
        return !!currentGL;
      } catch (ex) {}

      return false;
    },
    composeSMask: composeSMask,
    drawFigures: drawFigures,
    cleanup: function cleanup() {
      if (smaskCache && smaskCache.canvas) {
        smaskCache.canvas.width = 0;
        smaskCache.canvas.height = 0;
      }

      if (figuresCache && figuresCache.canvas) {
        figuresCache.canvas.width = 0;
        figuresCache.canvas.height = 0;
      }

      smaskCache = null;
      figuresCache = null;
    }
  };
}();

/***/ }),
/* 162 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderTextLayer = void 0;

var _util = __w_pdfjs_require__(1);

var _global_scope = _interopRequireDefault(__w_pdfjs_require__(3));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderTextLayer = function renderTextLayerClosure() {
  var MAX_TEXT_DIVS_TO_RENDER = 100000;
  var NonWhitespaceRegexp = /\S/;

  function isAllWhitespace(str) {
    return !NonWhitespaceRegexp.test(str);
  }

  var styleBuf = ['left: ', 0, 'px; top: ', 0, 'px; font-size: ', 0, 'px; font-family: ', '', ';'];

  function appendText(task, geom, styles) {
    var textDiv = document.createElement('span');
    var textDivProperties = {
      style: null,
      angle: 0,
      canvasWidth: 0,
      isWhitespace: false,
      originalTransform: null,
      paddingBottom: 0,
      paddingLeft: 0,
      paddingRight: 0,
      paddingTop: 0,
      scale: 1
    };

    task._textDivs.push(textDiv);

    if (isAllWhitespace(geom.str)) {
      textDivProperties.isWhitespace = true;

      task._textDivProperties.set(textDiv, textDivProperties);

      return;
    }

    var tx = _util.Util.transform(task._viewport.transform, geom.transform);

    var angle = Math.atan2(tx[1], tx[0]);
    var style = styles[geom.fontName];

    if (style.vertical) {
      angle += Math.PI / 2;
    }

    var fontHeight = Math.sqrt(tx[2] * tx[2] + tx[3] * tx[3]);
    var fontAscent = fontHeight;

    if (style.ascent) {
      fontAscent = style.ascent * fontAscent;
    } else if (style.descent) {
      fontAscent = (1 + style.descent) * fontAscent;
    }

    var left;
    var top;

    if (angle === 0) {
      left = tx[4];
      top = tx[5] - fontAscent;
    } else {
      left = tx[4] + fontAscent * Math.sin(angle);
      top = tx[5] - fontAscent * Math.cos(angle);
    }

    styleBuf[1] = left;
    styleBuf[3] = top;
    styleBuf[5] = fontHeight;
    styleBuf[7] = style.fontFamily;
    textDivProperties.style = styleBuf.join('');
    textDiv.setAttribute('style', textDivProperties.style);
    textDiv.textContent = geom.str;

    if (task._fontInspectorEnabled) {
      textDiv.dataset.fontName = geom.fontName;
    }

    if (angle !== 0) {
      textDivProperties.angle = angle * (180 / Math.PI);
    }

    if (geom.str.length > 1) {
      if (style.vertical) {
        textDivProperties.canvasWidth = geom.height * task._viewport.scale;
      } else {
        textDivProperties.canvasWidth = geom.width * task._viewport.scale;
      }
    }

    task._textDivProperties.set(textDiv, textDivProperties);

    if (task._textContentStream) {
      task._layoutText(textDiv);
    }

    if (task._enhanceTextSelection) {
      var angleCos = 1,
          angleSin = 0;

      if (angle !== 0) {
        angleCos = Math.cos(angle);
        angleSin = Math.sin(angle);
      }

      var divWidth = (style.vertical ? geom.height : geom.width) * task._viewport.scale;
      var divHeight = fontHeight;
      var m, b;

      if (angle !== 0) {
        m = [angleCos, angleSin, -angleSin, angleCos, left, top];
        b = _util.Util.getAxialAlignedBoundingBox([0, 0, divWidth, divHeight], m);
      } else {
        b = [left, top, left + divWidth, top + divHeight];
      }

      task._bounds.push({
        left: b[0],
        top: b[1],
        right: b[2],
        bottom: b[3],
        div: textDiv,
        size: [divWidth, divHeight],
        m: m
      });
    }
  }

  function render(task) {
    if (task._canceled) {
      return;
    }

    var textDivs = task._textDivs;
    var capability = task._capability;
    var textDivsLength = textDivs.length;

    if (textDivsLength > MAX_TEXT_DIVS_TO_RENDER) {
      task._renderingDone = true;
      capability.resolve();
      return;
    }

    if (!task._textContentStream) {
      for (var i = 0; i < textDivsLength; i++) {
        task._layoutText(textDivs[i]);
      }
    }

    task._renderingDone = true;
    capability.resolve();
  }

  function expand(task) {
    var bounds = task._bounds;
    var viewport = task._viewport;
    var expanded = expandBounds(viewport.width, viewport.height, bounds);

    for (var i = 0; i < expanded.length; i++) {
      var div = bounds[i].div;

      var divProperties = task._textDivProperties.get(div);

      if (divProperties.angle === 0) {
        divProperties.paddingLeft = bounds[i].left - expanded[i].left;
        divProperties.paddingTop = bounds[i].top - expanded[i].top;
        divProperties.paddingRight = expanded[i].right - bounds[i].right;
        divProperties.paddingBottom = expanded[i].bottom - bounds[i].bottom;

        task._textDivProperties.set(div, divProperties);

        continue;
      }

      var e = expanded[i],
          b = bounds[i];
      var m = b.m,
          c = m[0],
          s = m[1];
      var points = [[0, 0], [0, b.size[1]], [b.size[0], 0], b.size];
      var ts = new Float64Array(64);
      points.forEach(function (p, i) {
        var t = _util.Util.applyTransform(p, m);

        ts[i + 0] = c && (e.left - t[0]) / c;
        ts[i + 4] = s && (e.top - t[1]) / s;
        ts[i + 8] = c && (e.right - t[0]) / c;
        ts[i + 12] = s && (e.bottom - t[1]) / s;
        ts[i + 16] = s && (e.left - t[0]) / -s;
        ts[i + 20] = c && (e.top - t[1]) / c;
        ts[i + 24] = s && (e.right - t[0]) / -s;
        ts[i + 28] = c && (e.bottom - t[1]) / c;
        ts[i + 32] = c && (e.left - t[0]) / -c;
        ts[i + 36] = s && (e.top - t[1]) / -s;
        ts[i + 40] = c && (e.right - t[0]) / -c;
        ts[i + 44] = s && (e.bottom - t[1]) / -s;
        ts[i + 48] = s && (e.left - t[0]) / s;
        ts[i + 52] = c && (e.top - t[1]) / -c;
        ts[i + 56] = s && (e.right - t[0]) / s;
        ts[i + 60] = c && (e.bottom - t[1]) / -c;
      });

      var findPositiveMin = function findPositiveMin(ts, offset, count) {
        var result = 0;

        for (var i = 0; i < count; i++) {
          var t = ts[offset++];

          if (t > 0) {
            result = result ? Math.min(t, result) : t;
          }
        }

        return result;
      };

      var boxScale = 1 + Math.min(Math.abs(c), Math.abs(s));
      divProperties.paddingLeft = findPositiveMin(ts, 32, 16) / boxScale;
      divProperties.paddingTop = findPositiveMin(ts, 48, 16) / boxScale;
      divProperties.paddingRight = findPositiveMin(ts, 0, 16) / boxScale;
      divProperties.paddingBottom = findPositiveMin(ts, 16, 16) / boxScale;

      task._textDivProperties.set(div, divProperties);
    }
  }

  function expandBounds(width, height, boxes) {
    var bounds = boxes.map(function (box, i) {
      return {
        x1: box.left,
        y1: box.top,
        x2: box.right,
        y2: box.bottom,
        index: i,
        x1New: undefined,
        x2New: undefined
      };
    });
    expandBoundsLTR(width, bounds);
    var expanded = new Array(boxes.length);
    bounds.forEach(function (b) {
      var i = b.index;
      expanded[i] = {
        left: b.x1New,
        top: 0,
        right: b.x2New,
        bottom: 0
      };
    });
    boxes.map(function (box, i) {
      var e = expanded[i],
          b = bounds[i];
      b.x1 = box.top;
      b.y1 = width - e.right;
      b.x2 = box.bottom;
      b.y2 = width - e.left;
      b.index = i;
      b.x1New = undefined;
      b.x2New = undefined;
    });
    expandBoundsLTR(height, bounds);
    bounds.forEach(function (b) {
      var i = b.index;
      expanded[i].top = b.x1New;
      expanded[i].bottom = b.x2New;
    });
    return expanded;
  }

  function expandBoundsLTR(width, bounds) {
    bounds.sort(function (a, b) {
      return a.x1 - b.x1 || a.index - b.index;
    });
    var fakeBoundary = {
      x1: -Infinity,
      y1: -Infinity,
      x2: 0,
      y2: Infinity,
      index: -1,
      x1New: 0,
      x2New: 0
    };
    var horizon = [{
      start: -Infinity,
      end: Infinity,
      boundary: fakeBoundary
    }];
    bounds.forEach(function (boundary) {
      var i = 0;

      while (i < horizon.length && horizon[i].end <= boundary.y1) {
        i++;
      }

      var j = horizon.length - 1;

      while (j >= 0 && horizon[j].start >= boundary.y2) {
        j--;
      }

      var horizonPart, affectedBoundary;
      var q,
          k,
          maxXNew = -Infinity;

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;
        var xNew;

        if (affectedBoundary.x2 > boundary.x1) {
          xNew = affectedBoundary.index > boundary.index ? affectedBoundary.x1New : boundary.x1;
        } else if (affectedBoundary.x2New === undefined) {
          xNew = (affectedBoundary.x2 + boundary.x1) / 2;
        } else {
          xNew = affectedBoundary.x2New;
        }

        if (xNew > maxXNew) {
          maxXNew = xNew;
        }
      }

      boundary.x1New = maxXNew;

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;

        if (affectedBoundary.x2New === undefined) {
          if (affectedBoundary.x2 > boundary.x1) {
            if (affectedBoundary.index > boundary.index) {
              affectedBoundary.x2New = affectedBoundary.x2;
            }
          } else {
            affectedBoundary.x2New = maxXNew;
          }
        } else if (affectedBoundary.x2New > maxXNew) {
          affectedBoundary.x2New = Math.max(maxXNew, affectedBoundary.x2);
        }
      }

      var changedHorizon = [],
          lastBoundary = null;

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;
        var useBoundary = affectedBoundary.x2 > boundary.x2 ? affectedBoundary : boundary;

        if (lastBoundary === useBoundary) {
          changedHorizon[changedHorizon.length - 1].end = horizonPart.end;
        } else {
          changedHorizon.push({
            start: horizonPart.start,
            end: horizonPart.end,
            boundary: useBoundary
          });
          lastBoundary = useBoundary;
        }
      }

      if (horizon[i].start < boundary.y1) {
        changedHorizon[0].start = boundary.y1;
        changedHorizon.unshift({
          start: horizon[i].start,
          end: boundary.y1,
          boundary: horizon[i].boundary
        });
      }

      if (boundary.y2 < horizon[j].end) {
        changedHorizon[changedHorizon.length - 1].end = boundary.y2;
        changedHorizon.push({
          start: boundary.y2,
          end: horizon[j].end,
          boundary: horizon[j].boundary
        });
      }

      for (q = i; q <= j; q++) {
        horizonPart = horizon[q];
        affectedBoundary = horizonPart.boundary;

        if (affectedBoundary.x2New !== undefined) {
          continue;
        }

        var used = false;

        for (k = i - 1; !used && k >= 0 && horizon[k].start >= affectedBoundary.y1; k--) {
          used = horizon[k].boundary === affectedBoundary;
        }

        for (k = j + 1; !used && k < horizon.length && horizon[k].end <= affectedBoundary.y2; k++) {
          used = horizon[k].boundary === affectedBoundary;
        }

        for (k = 0; !used && k < changedHorizon.length; k++) {
          used = changedHorizon[k].boundary === affectedBoundary;
        }

        if (!used) {
          affectedBoundary.x2New = maxXNew;
        }
      }

      Array.prototype.splice.apply(horizon, [i, j - i + 1].concat(changedHorizon));
    });
    horizon.forEach(function (horizonPart) {
      var affectedBoundary = horizonPart.boundary;

      if (affectedBoundary.x2New === undefined) {
        affectedBoundary.x2New = Math.max(width, affectedBoundary.x2);
      }
    });
  }

  function TextLayerRenderTask(_ref) {
    var textContent = _ref.textContent,
        textContentStream = _ref.textContentStream,
        container = _ref.container,
        viewport = _ref.viewport,
        textDivs = _ref.textDivs,
        textContentItemsStr = _ref.textContentItemsStr,
        enhanceTextSelection = _ref.enhanceTextSelection;
    this._textContent = textContent;
    this._textContentStream = textContentStream;
    this._container = container;
    this._viewport = viewport;
    this._textDivs = textDivs || [];
    this._textContentItemsStr = textContentItemsStr || [];
    this._enhanceTextSelection = !!enhanceTextSelection;
    this._fontInspectorEnabled = !!(_global_scope.default.FontInspector && _global_scope.default.FontInspector.enabled);
    this._reader = null;
    this._layoutTextLastFontSize = null;
    this._layoutTextLastFontFamily = null;
    this._layoutTextCtx = null;
    this._textDivProperties = new WeakMap();
    this._renderingDone = false;
    this._canceled = false;
    this._capability = (0, _util.createPromiseCapability)();
    this._renderTimer = null;
    this._bounds = [];
  }

  TextLayerRenderTask.prototype = {
    get promise() {
      return this._capability.promise;
    },

    cancel: function TextLayer_cancel() {
      if (this._reader) {
        this._reader.cancel(new _util.AbortException('text layer task cancelled'));

        this._reader = null;
      }

      this._canceled = true;

      if (this._renderTimer !== null) {
        clearTimeout(this._renderTimer);
        this._renderTimer = null;
      }

      this._capability.reject('canceled');
    },
    _processItems: function _processItems(items, styleCache) {
      for (var i = 0, len = items.length; i < len; i++) {
        this._textContentItemsStr.push(items[i].str);

        appendText(this, items[i], styleCache);
      }
    },
    _layoutText: function _layoutText(textDiv) {
      var textLayerFrag = this._container;

      var textDivProperties = this._textDivProperties.get(textDiv);

      if (textDivProperties.isWhitespace) {
        return;
      }

      var fontSize = textDiv.style.fontSize;
      var fontFamily = textDiv.style.fontFamily;

      if (fontSize !== this._layoutTextLastFontSize || fontFamily !== this._layoutTextLastFontFamily) {
        this._layoutTextCtx.font = fontSize + ' ' + fontFamily;
        this._layoutTextLastFontSize = fontSize;
        this._layoutTextLastFontFamily = fontFamily;
      }

      var width = this._layoutTextCtx.measureText(textDiv.textContent).width;

      var transform = '';

      if (textDivProperties.canvasWidth !== 0 && width > 0) {
        textDivProperties.scale = textDivProperties.canvasWidth / width;
        transform = "scaleX(".concat(textDivProperties.scale, ")");
      }

      if (textDivProperties.angle !== 0) {
        transform = "rotate(".concat(textDivProperties.angle, "deg) ").concat(transform);
      }

      if (transform.length > 0) {
        textDivProperties.originalTransform = transform;
        textDiv.style.transform = transform;
      }

      this._textDivProperties.set(textDiv, textDivProperties);

      textLayerFrag.appendChild(textDiv);
    },
    _render: function TextLayer_render(timeout) {
      var _this = this;

      var capability = (0, _util.createPromiseCapability)();
      var styleCache = Object.create(null);
      var canvas = document.createElement('canvas');
      canvas.mozOpaque = true;
      this._layoutTextCtx = canvas.getContext('2d', {
        alpha: false
      });

      if (this._textContent) {
        var textItems = this._textContent.items;
        var textStyles = this._textContent.styles;

        this._processItems(textItems, textStyles);

        capability.resolve();
      } else if (this._textContentStream) {
        var pump = function pump() {
          _this._reader.read().then(function (_ref2) {
            var value = _ref2.value,
                done = _ref2.done;

            if (done) {
              capability.resolve();
              return;
            }

            Object.assign(styleCache, value.styles);

            _this._processItems(value.items, styleCache);

            pump();
          }, capability.reject);
        };

        this._reader = this._textContentStream.getReader();
        pump();
      } else {
        throw new Error('Neither "textContent" nor "textContentStream"' + ' parameters specified.');
      }

      capability.promise.then(function () {
        styleCache = null;

        if (!timeout) {
          render(_this);
        } else {
          _this._renderTimer = setTimeout(function () {
            render(_this);
            _this._renderTimer = null;
          }, timeout);
        }
      }, this._capability.reject);
    },
    expandTextDivs: function TextLayer_expandTextDivs(expandDivs) {
      if (!this._enhanceTextSelection || !this._renderingDone) {
        return;
      }

      if (this._bounds !== null) {
        expand(this);
        this._bounds = null;
      }

      for (var i = 0, ii = this._textDivs.length; i < ii; i++) {
        var div = this._textDivs[i];

        var divProperties = this._textDivProperties.get(div);

        if (divProperties.isWhitespace) {
          continue;
        }

        if (expandDivs) {
          var transform = '',
              padding = '';

          if (divProperties.scale !== 1) {
            transform = 'scaleX(' + divProperties.scale + ')';
          }

          if (divProperties.angle !== 0) {
            transform = 'rotate(' + divProperties.angle + 'deg) ' + transform;
          }

          if (divProperties.paddingLeft !== 0) {
            padding += ' padding-left: ' + divProperties.paddingLeft / divProperties.scale + 'px;';
            transform += ' translateX(' + -divProperties.paddingLeft / divProperties.scale + 'px)';
          }

          if (divProperties.paddingTop !== 0) {
            padding += ' padding-top: ' + divProperties.paddingTop + 'px;';
            transform += ' translateY(' + -divProperties.paddingTop + 'px)';
          }

          if (divProperties.paddingRight !== 0) {
            padding += ' padding-right: ' + divProperties.paddingRight / divProperties.scale + 'px;';
          }

          if (divProperties.paddingBottom !== 0) {
            padding += ' padding-bottom: ' + divProperties.paddingBottom + 'px;';
          }

          if (padding !== '') {
            div.setAttribute('style', divProperties.style + padding);
          }

          if (transform !== '') {
            div.style.transform = transform;
          }
        } else {
          div.style.padding = 0;
          div.style.transform = divProperties.originalTransform || '';
        }
      }
    }
  };

  function renderTextLayer(renderParameters) {
    var task = new TextLayerRenderTask({
      textContent: renderParameters.textContent,
      textContentStream: renderParameters.textContentStream,
      container: renderParameters.container,
      viewport: renderParameters.viewport,
      textDivs: renderParameters.textDivs,
      textContentItemsStr: renderParameters.textContentItemsStr,
      enhanceTextSelection: renderParameters.enhanceTextSelection
    });

    task._render(renderParameters.timeout);

    return task;
  }

  return renderTextLayer;
}();

exports.renderTextLayer = renderTextLayer;

/***/ }),
/* 163 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnnotationLayer = void 0;

var _dom_utils = __w_pdfjs_require__(151);

var _util = __w_pdfjs_require__(1);

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var AnnotationElementFactory =
/*#__PURE__*/
function () {
  function AnnotationElementFactory() {
    _classCallCheck(this, AnnotationElementFactory);
  }

  _createClass(AnnotationElementFactory, null, [{
    key: "create",
    value: function create(parameters) {
      var subtype = parameters.data.annotationType;

      switch (subtype) {
        case _util.AnnotationType.LINK:
          return new LinkAnnotationElement(parameters);

        case _util.AnnotationType.TEXT:
          return new TextAnnotationElement(parameters);

        case _util.AnnotationType.WIDGET:
          var fieldType = parameters.data.fieldType;

          switch (fieldType) {
            case 'Tx':
              return new TextWidgetAnnotationElement(parameters);

            case 'Btn':
              if (parameters.data.radioButton) {
                return new RadioButtonWidgetAnnotationElement(parameters);
              } else if (parameters.data.checkBox) {
                return new CheckboxWidgetAnnotationElement(parameters);
              }

              return new PushButtonWidgetAnnotationElement(parameters);

            case 'Ch':
              return new ChoiceWidgetAnnotationElement(parameters);
          }

          return new WidgetAnnotationElement(parameters);

        case _util.AnnotationType.POPUP:
          return new PopupAnnotationElement(parameters);

        case _util.AnnotationType.LINE:
          return new LineAnnotationElement(parameters);

        case _util.AnnotationType.SQUARE:
          return new SquareAnnotationElement(parameters);

        case _util.AnnotationType.CIRCLE:
          return new CircleAnnotationElement(parameters);

        case _util.AnnotationType.POLYLINE:
          return new PolylineAnnotationElement(parameters);

        case _util.AnnotationType.INK:
          return new InkAnnotationElement(parameters);

        case _util.AnnotationType.POLYGON:
          return new PolygonAnnotationElement(parameters);

        case _util.AnnotationType.HIGHLIGHT:
          return new HighlightAnnotationElement(parameters);

        case _util.AnnotationType.UNDERLINE:
          return new UnderlineAnnotationElement(parameters);

        case _util.AnnotationType.SQUIGGLY:
          return new SquigglyAnnotationElement(parameters);

        case _util.AnnotationType.STRIKEOUT:
          return new StrikeOutAnnotationElement(parameters);

        case _util.AnnotationType.STAMP:
          return new StampAnnotationElement(parameters);

        case _util.AnnotationType.FILEATTACHMENT:
          return new FileAttachmentAnnotationElement(parameters);

        default:
          return new AnnotationElement(parameters);
      }
    }
  }]);

  return AnnotationElementFactory;
}();

var AnnotationElement =
/*#__PURE__*/
function () {
  function AnnotationElement(parameters) {
    var isRenderable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var ignoreBorder = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    _classCallCheck(this, AnnotationElement);

    this.isRenderable = isRenderable;
    this.data = parameters.data;
    this.layer = parameters.layer;
    this.page = parameters.page;
    this.viewport = parameters.viewport;
    this.linkService = parameters.linkService;
    this.downloadManager = parameters.downloadManager;
    this.imageResourcesPath = parameters.imageResourcesPath;
    this.renderInteractiveForms = parameters.renderInteractiveForms;
    this.svgFactory = parameters.svgFactory;

    if (isRenderable) {
      this.container = this._createContainer(ignoreBorder);
    }
  }

  _createClass(AnnotationElement, [{
    key: "_createContainer",
    value: function _createContainer() {
      var ignoreBorder = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var data = this.data,
          page = this.page,
          viewport = this.viewport;
      var container = document.createElement('section');
      var width = data.rect[2] - data.rect[0];
      var height = data.rect[3] - data.rect[1];
      container.setAttribute('data-annotation-id', data.id);

      var rect = _util.Util.normalizeRect([data.rect[0], page.view[3] - data.rect[1] + page.view[1], data.rect[2], page.view[3] - data.rect[3] + page.view[1]]);

      container.style.transform = 'matrix(' + viewport.transform.join(',') + ')';
      container.style.transformOrigin = -rect[0] + 'px ' + -rect[1] + 'px';

      if (!ignoreBorder && data.borderStyle.width > 0) {
        container.style.borderWidth = data.borderStyle.width + 'px';

        if (data.borderStyle.style !== _util.AnnotationBorderStyleType.UNDERLINE) {
          width = width - 2 * data.borderStyle.width;
          height = height - 2 * data.borderStyle.width;
        }

        var horizontalRadius = data.borderStyle.horizontalCornerRadius;
        var verticalRadius = data.borderStyle.verticalCornerRadius;

        if (horizontalRadius > 0 || verticalRadius > 0) {
          var radius = horizontalRadius + 'px / ' + verticalRadius + 'px';
          container.style.borderRadius = radius;
        }

        switch (data.borderStyle.style) {
          case _util.AnnotationBorderStyleType.SOLID:
            container.style.borderStyle = 'solid';
            break;

          case _util.AnnotationBorderStyleType.DASHED:
            container.style.borderStyle = 'dashed';
            break;

          case _util.AnnotationBorderStyleType.BEVELED:
            (0, _util.warn)('Unimplemented border style: beveled');
            break;

          case _util.AnnotationBorderStyleType.INSET:
            (0, _util.warn)('Unimplemented border style: inset');
            break;

          case _util.AnnotationBorderStyleType.UNDERLINE:
            container.style.borderBottomStyle = 'solid';
            break;

          default:
            break;
        }

        if (data.color) {
          container.style.borderColor = _util.Util.makeCssRgb(data.color[0] | 0, data.color[1] | 0, data.color[2] | 0);
        } else {
          container.style.borderWidth = 0;
        }
      }

      container.style.left = rect[0] + 'px';
      container.style.top = rect[1] + 'px';
      container.style.width = width + 'px';
      container.style.height = height + 'px';
      return container;
    }
  }, {
    key: "_createPopup",
    value: function _createPopup(container, trigger, data) {
      if (!trigger) {
        trigger = document.createElement('div');
        trigger.style.height = container.style.height;
        trigger.style.width = container.style.width;
        container.appendChild(trigger);
      }

      var popupElement = new PopupElement({
        container: container,
        trigger: trigger,
        color: data.color,
        title: data.title,
        contents: data.contents,
        hideWrapper: true
      });
      var popup = popupElement.render();
      popup.style.left = container.style.width;
      container.appendChild(popup);
    }
  }, {
    key: "render",
    value: function render() {
      (0, _util.unreachable)('Abstract method `AnnotationElement.render` called');
    }
  }]);

  return AnnotationElement;
}();

var LinkAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement) {
  _inherits(LinkAnnotationElement, _AnnotationElement);

  function LinkAnnotationElement(parameters) {
    _classCallCheck(this, LinkAnnotationElement);

    var isRenderable = !!(parameters.data.url || parameters.data.dest || parameters.data.action);
    return _possibleConstructorReturn(this, _getPrototypeOf(LinkAnnotationElement).call(this, parameters, isRenderable));
  }

  _createClass(LinkAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'linkAnnotation';
      var data = this.data,
          linkService = this.linkService;
      var link = document.createElement('a');
      (0, _dom_utils.addLinkAttributes)(link, {
        url: data.url,
        target: data.newWindow ? _dom_utils.LinkTarget.BLANK : linkService.externalLinkTarget,
        rel: linkService.externalLinkRel
      });

      if (!data.url) {
        if (data.action) {
          this._bindNamedAction(link, data.action);
        } else {
          this._bindLink(link, data.dest);
        }
      }

      this.container.appendChild(link);
      return this.container;
    }
  }, {
    key: "_bindLink",
    value: function _bindLink(link, destination) {
      var _this = this;

      link.href = this.linkService.getDestinationHash(destination);

      link.onclick = function () {
        if (destination) {
          _this.linkService.navigateTo(destination);
        }

        return false;
      };

      if (destination) {
        link.className = 'internalLink';
      }
    }
  }, {
    key: "_bindNamedAction",
    value: function _bindNamedAction(link, action) {
      var _this2 = this;

      link.href = this.linkService.getAnchorUrl('');

      link.onclick = function () {
        _this2.linkService.executeNamedAction(action);

        return false;
      };

      link.className = 'internalLink';
    }
  }]);

  return LinkAnnotationElement;
}(AnnotationElement);

var TextAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement2) {
  _inherits(TextAnnotationElement, _AnnotationElement2);

  function TextAnnotationElement(parameters) {
    _classCallCheck(this, TextAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(TextAnnotationElement).call(this, parameters, isRenderable));
  }

  _createClass(TextAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'textAnnotation';
      var image = document.createElement('img');
      image.style.height = this.container.style.height;
      image.style.width = this.container.style.width;
      image.src = this.imageResourcesPath + 'annotation-' + this.data.name.toLowerCase() + '.svg';
      image.alt = '[{{type}} Annotation]';
      image.dataset.l10nId = 'text_annotation_type';
      image.dataset.l10nArgs = JSON.stringify({
        type: this.data.name
      });

      if (!this.data.hasPopup) {
        this._createPopup(this.container, image, this.data);
      }

      this.container.appendChild(image);
      return this.container;
    }
  }]);

  return TextAnnotationElement;
}(AnnotationElement);

var WidgetAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement3) {
  _inherits(WidgetAnnotationElement, _AnnotationElement3);

  function WidgetAnnotationElement() {
    _classCallCheck(this, WidgetAnnotationElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(WidgetAnnotationElement).apply(this, arguments));
  }

  _createClass(WidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      return this.container;
    }
  }]);

  return WidgetAnnotationElement;
}(AnnotationElement);

var TextWidgetAnnotationElement =
/*#__PURE__*/
function (_WidgetAnnotationElem) {
  _inherits(TextWidgetAnnotationElement, _WidgetAnnotationElem);

  function TextWidgetAnnotationElement(parameters) {
    _classCallCheck(this, TextWidgetAnnotationElement);

    var isRenderable = parameters.renderInteractiveForms || !parameters.data.hasAppearance && !!parameters.data.fieldValue;
    return _possibleConstructorReturn(this, _getPrototypeOf(TextWidgetAnnotationElement).call(this, parameters, isRenderable));
  }

  _createClass(TextWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      var TEXT_ALIGNMENT = ['left', 'center', 'right'];
      this.container.className = 'textWidgetAnnotation';
      var element = null;

      if (this.renderInteractiveForms) {
        if (this.data.multiLine) {
          element = document.createElement('textarea');
          element.textContent = this.data.fieldValue;
        } else {
          element = document.createElement('input');
          element.type = 'text';
          element.setAttribute('value', this.data.fieldValue);
        }

        element.disabled = this.data.readOnly;

        if (this.data.maxLen !== null) {
          element.maxLength = this.data.maxLen;
        }

        if (this.data.comb) {
          var fieldWidth = this.data.rect[2] - this.data.rect[0];
          var combWidth = fieldWidth / this.data.maxLen;
          element.classList.add('comb');
          element.style.letterSpacing = 'calc(' + combWidth + 'px - 1ch)';
        }
      } else {
        element = document.createElement('div');
        element.textContent = this.data.fieldValue;
        element.style.verticalAlign = 'middle';
        element.style.display = 'table-cell';
        var font = null;

        if (this.data.fontRefName && this.page.commonObjs.has(this.data.fontRefName)) {
          font = this.page.commonObjs.get(this.data.fontRefName);
        }

        this._setTextStyle(element, font);
      }

      if (this.data.textAlignment !== null) {
        element.style.textAlign = TEXT_ALIGNMENT[this.data.textAlignment];
      }

      this.container.appendChild(element);
      return this.container;
    }
  }, {
    key: "_setTextStyle",
    value: function _setTextStyle(element, font) {
      var style = element.style;
      style.fontSize = this.data.fontSize + 'px';
      style.direction = this.data.fontDirection < 0 ? 'rtl' : 'ltr';

      if (!font) {
        return;
      }

      style.fontWeight = font.black ? font.bold ? '900' : 'bold' : font.bold ? 'bold' : 'normal';
      style.fontStyle = font.italic ? 'italic' : 'normal';
      var fontFamily = font.loadedName ? '"' + font.loadedName + '", ' : '';
      var fallbackName = font.fallbackName || 'Helvetica, sans-serif';
      style.fontFamily = fontFamily + fallbackName;
    }
  }]);

  return TextWidgetAnnotationElement;
}(WidgetAnnotationElement);

var CheckboxWidgetAnnotationElement =
/*#__PURE__*/
function (_WidgetAnnotationElem2) {
  _inherits(CheckboxWidgetAnnotationElement, _WidgetAnnotationElem2);

  function CheckboxWidgetAnnotationElement(parameters) {
    _classCallCheck(this, CheckboxWidgetAnnotationElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(CheckboxWidgetAnnotationElement).call(this, parameters, parameters.renderInteractiveForms));
  }

  _createClass(CheckboxWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'buttonWidgetAnnotation checkBox';
      var element = document.createElement('input');
      element.disabled = this.data.readOnly;
      element.type = 'checkbox';

      if (this.data.fieldValue && this.data.fieldValue !== 'Off') {
        element.setAttribute('checked', true);
      }

      this.container.appendChild(element);
      return this.container;
    }
  }]);

  return CheckboxWidgetAnnotationElement;
}(WidgetAnnotationElement);

var RadioButtonWidgetAnnotationElement =
/*#__PURE__*/
function (_WidgetAnnotationElem3) {
  _inherits(RadioButtonWidgetAnnotationElement, _WidgetAnnotationElem3);

  function RadioButtonWidgetAnnotationElement(parameters) {
    _classCallCheck(this, RadioButtonWidgetAnnotationElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(RadioButtonWidgetAnnotationElement).call(this, parameters, parameters.renderInteractiveForms));
  }

  _createClass(RadioButtonWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'buttonWidgetAnnotation radioButton';
      var element = document.createElement('input');
      element.disabled = this.data.readOnly;
      element.type = 'radio';
      element.name = this.data.fieldName;

      if (this.data.fieldValue === this.data.buttonValue) {
        element.setAttribute('checked', true);
      }

      this.container.appendChild(element);
      return this.container;
    }
  }]);

  return RadioButtonWidgetAnnotationElement;
}(WidgetAnnotationElement);

var PushButtonWidgetAnnotationElement =
/*#__PURE__*/
function (_LinkAnnotationElemen) {
  _inherits(PushButtonWidgetAnnotationElement, _LinkAnnotationElemen);

  function PushButtonWidgetAnnotationElement() {
    _classCallCheck(this, PushButtonWidgetAnnotationElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(PushButtonWidgetAnnotationElement).apply(this, arguments));
  }

  _createClass(PushButtonWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      var container = _get(_getPrototypeOf(PushButtonWidgetAnnotationElement.prototype), "render", this).call(this);

      container.className = 'buttonWidgetAnnotation pushButton';
      return container;
    }
  }]);

  return PushButtonWidgetAnnotationElement;
}(LinkAnnotationElement);

var ChoiceWidgetAnnotationElement =
/*#__PURE__*/
function (_WidgetAnnotationElem4) {
  _inherits(ChoiceWidgetAnnotationElement, _WidgetAnnotationElem4);

  function ChoiceWidgetAnnotationElement(parameters) {
    _classCallCheck(this, ChoiceWidgetAnnotationElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(ChoiceWidgetAnnotationElement).call(this, parameters, parameters.renderInteractiveForms));
  }

  _createClass(ChoiceWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'choiceWidgetAnnotation';
      var selectElement = document.createElement('select');
      selectElement.disabled = this.data.readOnly;

      if (!this.data.combo) {
        selectElement.size = this.data.options.length;

        if (this.data.multiSelect) {
          selectElement.multiple = true;
        }
      }

      for (var i = 0, ii = this.data.options.length; i < ii; i++) {
        var option = this.data.options[i];
        var optionElement = document.createElement('option');
        optionElement.textContent = option.displayValue;
        optionElement.value = option.exportValue;

        if (this.data.fieldValue.includes(option.displayValue)) {
          optionElement.setAttribute('selected', true);
        }

        selectElement.appendChild(optionElement);
      }

      this.container.appendChild(selectElement);
      return this.container;
    }
  }]);

  return ChoiceWidgetAnnotationElement;
}(WidgetAnnotationElement);

var PopupAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement4) {
  _inherits(PopupAnnotationElement, _AnnotationElement4);

  function PopupAnnotationElement(parameters) {
    _classCallCheck(this, PopupAnnotationElement);

    var isRenderable = !!(parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(PopupAnnotationElement).call(this, parameters, isRenderable));
  }

  _createClass(PopupAnnotationElement, [{
    key: "render",
    value: function render() {
      var IGNORE_TYPES = ['Line', 'Square', 'Circle', 'PolyLine', 'Polygon', 'Ink'];
      this.container.className = 'popupAnnotation';

      if (IGNORE_TYPES.includes(this.data.parentType)) {
        return this.container;
      }

      var selector = '[data-annotation-id="' + this.data.parentId + '"]';
      var parentElement = this.layer.querySelector(selector);

      if (!parentElement) {
        return this.container;
      }

      var popup = new PopupElement({
        container: this.container,
        trigger: parentElement,
        color: this.data.color,
        title: this.data.title,
        contents: this.data.contents
      });
      var parentLeft = parseFloat(parentElement.style.left);
      var parentWidth = parseFloat(parentElement.style.width);
      this.container.style.transformOrigin = -(parentLeft + parentWidth) + 'px -' + parentElement.style.top;
      this.container.style.left = parentLeft + parentWidth + 'px';
      this.container.appendChild(popup.render());
      return this.container;
    }
  }]);

  return PopupAnnotationElement;
}(AnnotationElement);

var PopupElement =
/*#__PURE__*/
function () {
  function PopupElement(parameters) {
    _classCallCheck(this, PopupElement);

    this.container = parameters.container;
    this.trigger = parameters.trigger;
    this.color = parameters.color;
    this.title = parameters.title;
    this.contents = parameters.contents;
    this.hideWrapper = parameters.hideWrapper || false;
    this.pinned = false;
  }

  _createClass(PopupElement, [{
    key: "render",
    value: function render() {
      var BACKGROUND_ENLIGHT = 0.7;
      var wrapper = document.createElement('div');
      wrapper.className = 'popupWrapper';
      this.hideElement = this.hideWrapper ? wrapper : this.container;
      this.hideElement.setAttribute('hidden', true);
      var popup = document.createElement('div');
      popup.className = 'popup';
      var color = this.color;

      if (color) {
        var r = BACKGROUND_ENLIGHT * (255 - color[0]) + color[0];
        var g = BACKGROUND_ENLIGHT * (255 - color[1]) + color[1];
        var b = BACKGROUND_ENLIGHT * (255 - color[2]) + color[2];
        popup.style.backgroundColor = _util.Util.makeCssRgb(r | 0, g | 0, b | 0);
      }

      var contents = this._formatContents(this.contents);

      var title = document.createElement('h1');
      title.textContent = this.title;
      this.trigger.addEventListener('click', this._toggle.bind(this));
      this.trigger.addEventListener('mouseover', this._show.bind(this, false));
      this.trigger.addEventListener('mouseout', this._hide.bind(this, false));
      popup.addEventListener('click', this._hide.bind(this, true));
      popup.appendChild(title);
      popup.appendChild(contents);
      wrapper.appendChild(popup);
      return wrapper;
    }
  }, {
    key: "_formatContents",
    value: function _formatContents(contents) {
      var p = document.createElement('p');
      var lines = contents.split(/(?:\r\n?|\n)/);

      for (var i = 0, ii = lines.length; i < ii; ++i) {
        var line = lines[i];
        p.appendChild(document.createTextNode(line));

        if (i < ii - 1) {
          p.appendChild(document.createElement('br'));
        }
      }

      return p;
    }
  }, {
    key: "_toggle",
    value: function _toggle() {
      if (this.pinned) {
        this._hide(true);
      } else {
        this._show(true);
      }
    }
  }, {
    key: "_show",
    value: function _show() {
      var pin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (pin) {
        this.pinned = true;
      }

      if (this.hideElement.hasAttribute('hidden')) {
        this.hideElement.removeAttribute('hidden');
        this.container.style.zIndex += 1;
      }
    }
  }, {
    key: "_hide",
    value: function _hide() {
      var unpin = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      if (unpin) {
        this.pinned = false;
      }

      if (!this.hideElement.hasAttribute('hidden') && !this.pinned) {
        this.hideElement.setAttribute('hidden', true);
        this.container.style.zIndex -= 1;
      }
    }
  }]);

  return PopupElement;
}();

var LineAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement5) {
  _inherits(LineAnnotationElement, _AnnotationElement5);

  function LineAnnotationElement(parameters) {
    _classCallCheck(this, LineAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(LineAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(LineAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'lineAnnotation';
      var data = this.data;
      var width = data.rect[2] - data.rect[0];
      var height = data.rect[3] - data.rect[1];
      var svg = this.svgFactory.create(width, height);
      var line = this.svgFactory.createElement('svg:line');
      line.setAttribute('x1', data.rect[2] - data.lineCoordinates[0]);
      line.setAttribute('y1', data.rect[3] - data.lineCoordinates[1]);
      line.setAttribute('x2', data.rect[2] - data.lineCoordinates[2]);
      line.setAttribute('y2', data.rect[3] - data.lineCoordinates[3]);
      line.setAttribute('stroke-width', data.borderStyle.width);
      line.setAttribute('stroke', 'transparent');
      svg.appendChild(line);
      this.container.append(svg);

      this._createPopup(this.container, line, data);

      return this.container;
    }
  }]);

  return LineAnnotationElement;
}(AnnotationElement);

var SquareAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement6) {
  _inherits(SquareAnnotationElement, _AnnotationElement6);

  function SquareAnnotationElement(parameters) {
    _classCallCheck(this, SquareAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(SquareAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(SquareAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'squareAnnotation';
      var data = this.data;
      var width = data.rect[2] - data.rect[0];
      var height = data.rect[3] - data.rect[1];
      var svg = this.svgFactory.create(width, height);
      var borderWidth = data.borderStyle.width;
      var square = this.svgFactory.createElement('svg:rect');
      square.setAttribute('x', borderWidth / 2);
      square.setAttribute('y', borderWidth / 2);
      square.setAttribute('width', width - borderWidth);
      square.setAttribute('height', height - borderWidth);
      square.setAttribute('stroke-width', borderWidth);
      square.setAttribute('stroke', 'transparent');
      square.setAttribute('fill', 'none');
      svg.appendChild(square);
      this.container.append(svg);

      this._createPopup(this.container, square, data);

      return this.container;
    }
  }]);

  return SquareAnnotationElement;
}(AnnotationElement);

var CircleAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement7) {
  _inherits(CircleAnnotationElement, _AnnotationElement7);

  function CircleAnnotationElement(parameters) {
    _classCallCheck(this, CircleAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(CircleAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(CircleAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'circleAnnotation';
      var data = this.data;
      var width = data.rect[2] - data.rect[0];
      var height = data.rect[3] - data.rect[1];
      var svg = this.svgFactory.create(width, height);
      var borderWidth = data.borderStyle.width;
      var circle = this.svgFactory.createElement('svg:ellipse');
      circle.setAttribute('cx', width / 2);
      circle.setAttribute('cy', height / 2);
      circle.setAttribute('rx', width / 2 - borderWidth / 2);
      circle.setAttribute('ry', height / 2 - borderWidth / 2);
      circle.setAttribute('stroke-width', borderWidth);
      circle.setAttribute('stroke', 'transparent');
      circle.setAttribute('fill', 'none');
      svg.appendChild(circle);
      this.container.append(svg);

      this._createPopup(this.container, circle, data);

      return this.container;
    }
  }]);

  return CircleAnnotationElement;
}(AnnotationElement);

var PolylineAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement8) {
  _inherits(PolylineAnnotationElement, _AnnotationElement8);

  function PolylineAnnotationElement(parameters) {
    var _this3;

    _classCallCheck(this, PolylineAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(PolylineAnnotationElement).call(this, parameters, isRenderable, true));
    _this3.containerClassName = 'polylineAnnotation';
    _this3.svgElementName = 'svg:polyline';
    return _this3;
  }

  _createClass(PolylineAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = this.containerClassName;
      var data = this.data;
      var width = data.rect[2] - data.rect[0];
      var height = data.rect[3] - data.rect[1];
      var svg = this.svgFactory.create(width, height);
      var vertices = data.vertices;
      var points = [];

      for (var i = 0, ii = vertices.length; i < ii; i++) {
        var x = vertices[i].x - data.rect[0];
        var y = data.rect[3] - vertices[i].y;
        points.push(x + ',' + y);
      }

      points = points.join(' ');
      var borderWidth = data.borderStyle.width;
      var polyline = this.svgFactory.createElement(this.svgElementName);
      polyline.setAttribute('points', points);
      polyline.setAttribute('stroke-width', borderWidth);
      polyline.setAttribute('stroke', 'transparent');
      polyline.setAttribute('fill', 'none');
      svg.appendChild(polyline);
      this.container.append(svg);

      this._createPopup(this.container, polyline, data);

      return this.container;
    }
  }]);

  return PolylineAnnotationElement;
}(AnnotationElement);

var PolygonAnnotationElement =
/*#__PURE__*/
function (_PolylineAnnotationEl) {
  _inherits(PolygonAnnotationElement, _PolylineAnnotationEl);

  function PolygonAnnotationElement(parameters) {
    var _this4;

    _classCallCheck(this, PolygonAnnotationElement);

    _this4 = _possibleConstructorReturn(this, _getPrototypeOf(PolygonAnnotationElement).call(this, parameters));
    _this4.containerClassName = 'polygonAnnotation';
    _this4.svgElementName = 'svg:polygon';
    return _this4;
  }

  return PolygonAnnotationElement;
}(PolylineAnnotationElement);

var InkAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement9) {
  _inherits(InkAnnotationElement, _AnnotationElement9);

  function InkAnnotationElement(parameters) {
    var _this5;

    _classCallCheck(this, InkAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    _this5 = _possibleConstructorReturn(this, _getPrototypeOf(InkAnnotationElement).call(this, parameters, isRenderable, true));
    _this5.containerClassName = 'inkAnnotation';
    _this5.svgElementName = 'svg:polyline';
    return _this5;
  }

  _createClass(InkAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = this.containerClassName;
      var data = this.data;
      var width = data.rect[2] - data.rect[0];
      var height = data.rect[3] - data.rect[1];
      var svg = this.svgFactory.create(width, height);
      var inkLists = data.inkLists;

      for (var i = 0, ii = inkLists.length; i < ii; i++) {
        var inkList = inkLists[i];
        var points = [];

        for (var j = 0, jj = inkList.length; j < jj; j++) {
          var x = inkList[j].x - data.rect[0];
          var y = data.rect[3] - inkList[j].y;
          points.push(x + ',' + y);
        }

        points = points.join(' ');
        var borderWidth = data.borderStyle.width;
        var polyline = this.svgFactory.createElement(this.svgElementName);
        polyline.setAttribute('points', points);
        polyline.setAttribute('stroke-width', borderWidth);
        polyline.setAttribute('stroke', 'transparent');
        polyline.setAttribute('fill', 'none');

        this._createPopup(this.container, polyline, data);

        svg.appendChild(polyline);
      }

      this.container.append(svg);
      return this.container;
    }
  }]);

  return InkAnnotationElement;
}(AnnotationElement);

var HighlightAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement10) {
  _inherits(HighlightAnnotationElement, _AnnotationElement10);

  function HighlightAnnotationElement(parameters) {
    _classCallCheck(this, HighlightAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(HighlightAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(HighlightAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'highlightAnnotation';

      if (!this.data.hasPopup) {
        this._createPopup(this.container, null, this.data);
      }

      return this.container;
    }
  }]);

  return HighlightAnnotationElement;
}(AnnotationElement);

var UnderlineAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement11) {
  _inherits(UnderlineAnnotationElement, _AnnotationElement11);

  function UnderlineAnnotationElement(parameters) {
    _classCallCheck(this, UnderlineAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(UnderlineAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(UnderlineAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'underlineAnnotation';

      if (!this.data.hasPopup) {
        this._createPopup(this.container, null, this.data);
      }

      return this.container;
    }
  }]);

  return UnderlineAnnotationElement;
}(AnnotationElement);

var SquigglyAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement12) {
  _inherits(SquigglyAnnotationElement, _AnnotationElement12);

  function SquigglyAnnotationElement(parameters) {
    _classCallCheck(this, SquigglyAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(SquigglyAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(SquigglyAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'squigglyAnnotation';

      if (!this.data.hasPopup) {
        this._createPopup(this.container, null, this.data);
      }

      return this.container;
    }
  }]);

  return SquigglyAnnotationElement;
}(AnnotationElement);

var StrikeOutAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement13) {
  _inherits(StrikeOutAnnotationElement, _AnnotationElement13);

  function StrikeOutAnnotationElement(parameters) {
    _classCallCheck(this, StrikeOutAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(StrikeOutAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(StrikeOutAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'strikeoutAnnotation';

      if (!this.data.hasPopup) {
        this._createPopup(this.container, null, this.data);
      }

      return this.container;
    }
  }]);

  return StrikeOutAnnotationElement;
}(AnnotationElement);

var StampAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement14) {
  _inherits(StampAnnotationElement, _AnnotationElement14);

  function StampAnnotationElement(parameters) {
    _classCallCheck(this, StampAnnotationElement);

    var isRenderable = !!(parameters.data.hasPopup || parameters.data.title || parameters.data.contents);
    return _possibleConstructorReturn(this, _getPrototypeOf(StampAnnotationElement).call(this, parameters, isRenderable, true));
  }

  _createClass(StampAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'stampAnnotation';

      if (!this.data.hasPopup) {
        this._createPopup(this.container, null, this.data);
      }

      return this.container;
    }
  }]);

  return StampAnnotationElement;
}(AnnotationElement);

var FileAttachmentAnnotationElement =
/*#__PURE__*/
function (_AnnotationElement15) {
  _inherits(FileAttachmentAnnotationElement, _AnnotationElement15);

  function FileAttachmentAnnotationElement(parameters) {
    var _this6;

    _classCallCheck(this, FileAttachmentAnnotationElement);

    _this6 = _possibleConstructorReturn(this, _getPrototypeOf(FileAttachmentAnnotationElement).call(this, parameters, true));
    var _this6$data$file = _this6.data.file,
        filename = _this6$data$file.filename,
        content = _this6$data$file.content;
    _this6.filename = (0, _dom_utils.getFilenameFromUrl)(filename);
    _this6.content = content;

    if (_this6.linkService.eventBus) {
      _this6.linkService.eventBus.dispatch('fileattachmentannotation', {
        source: _assertThisInitialized(_assertThisInitialized(_this6)),
        id: (0, _util.stringToPDFString)(filename),
        filename: filename,
        content: content
      });
    }

    return _this6;
  }

  _createClass(FileAttachmentAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.className = 'fileAttachmentAnnotation';
      var trigger = document.createElement('div');
      trigger.style.height = this.container.style.height;
      trigger.style.width = this.container.style.width;
      trigger.addEventListener('dblclick', this._download.bind(this));

      if (!this.data.hasPopup && (this.data.title || this.data.contents)) {
        this._createPopup(this.container, trigger, this.data);
      }

      this.container.appendChild(trigger);
      return this.container;
    }
  }, {
    key: "_download",
    value: function _download() {
      if (!this.downloadManager) {
        (0, _util.warn)('Download cannot be started due to unavailable download manager');
        return;
      }

      this.downloadManager.downloadData(this.content, this.filename, '');
    }
  }]);

  return FileAttachmentAnnotationElement;
}(AnnotationElement);

var AnnotationLayer =
/*#__PURE__*/
function () {
  function AnnotationLayer() {
    _classCallCheck(this, AnnotationLayer);
  }

  _createClass(AnnotationLayer, null, [{
    key: "render",
    value: function render(parameters) {
      for (var i = 0, ii = parameters.annotations.length; i < ii; i++) {
        var data = parameters.annotations[i];

        if (!data) {
          continue;
        }

        var element = AnnotationElementFactory.create({
          data: data,
          layer: parameters.div,
          page: parameters.page,
          viewport: parameters.viewport,
          linkService: parameters.linkService,
          downloadManager: parameters.downloadManager,
          imageResourcesPath: parameters.imageResourcesPath || '',
          renderInteractiveForms: parameters.renderInteractiveForms || false,
          svgFactory: new _dom_utils.DOMSVGFactory()
        });

        if (element.isRenderable) {
          parameters.div.appendChild(element.render());
        }
      }
    }
  }, {
    key: "update",
    value: function update(parameters) {
      for (var i = 0, ii = parameters.annotations.length; i < ii; i++) {
        var data = parameters.annotations[i];
        var element = parameters.div.querySelector('[data-annotation-id="' + data.id + '"]');

        if (element) {
          element.style.transform = 'matrix(' + parameters.viewport.transform.join(',') + ')';
        }
      }

      parameters.div.removeAttribute('hidden');
    }
  }]);

  return AnnotationLayer;
}();

exports.AnnotationLayer = AnnotationLayer;

/***/ }),
/* 164 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SVGGraphics = void 0;

var _util = __w_pdfjs_require__(1);

var _dom_utils = __w_pdfjs_require__(151);

var _is_node = _interopRequireDefault(__w_pdfjs_require__(4));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SVGGraphics = function SVGGraphics() {
  throw new Error('Not implemented: SVGGraphics');
};

exports.SVGGraphics = SVGGraphics;
{
  var SVG_DEFAULTS = {
    fontStyle: 'normal',
    fontWeight: 'normal',
    fillColor: '#000000'
  };

  var convertImgDataToPng = function convertImgDataToPngClosure() {
    var PNG_HEADER = new Uint8Array([0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a]);
    var CHUNK_WRAPPER_SIZE = 12;
    var crcTable = new Int32Array(256);

    for (var i = 0; i < 256; i++) {
      var c = i;

      for (var h = 0; h < 8; h++) {
        if (c & 1) {
          c = 0xedB88320 ^ c >> 1 & 0x7fffffff;
        } else {
          c = c >> 1 & 0x7fffffff;
        }
      }

      crcTable[i] = c;
    }

    function crc32(data, start, end) {
      var crc = -1;

      for (var i = start; i < end; i++) {
        var a = (crc ^ data[i]) & 0xff;
        var b = crcTable[a];
        crc = crc >>> 8 ^ b;
      }

      return crc ^ -1;
    }

    function writePngChunk(type, body, data, offset) {
      var p = offset;
      var len = body.length;
      data[p] = len >> 24 & 0xff;
      data[p + 1] = len >> 16 & 0xff;
      data[p + 2] = len >> 8 & 0xff;
      data[p + 3] = len & 0xff;
      p += 4;
      data[p] = type.charCodeAt(0) & 0xff;
      data[p + 1] = type.charCodeAt(1) & 0xff;
      data[p + 2] = type.charCodeAt(2) & 0xff;
      data[p + 3] = type.charCodeAt(3) & 0xff;
      p += 4;
      data.set(body, p);
      p += body.length;
      var crc = crc32(data, offset + 4, p);
      data[p] = crc >> 24 & 0xff;
      data[p + 1] = crc >> 16 & 0xff;
      data[p + 2] = crc >> 8 & 0xff;
      data[p + 3] = crc & 0xff;
    }

    function adler32(data, start, end) {
      var a = 1;
      var b = 0;

      for (var i = start; i < end; ++i) {
        a = (a + (data[i] & 0xff)) % 65521;
        b = (b + a) % 65521;
      }

      return b << 16 | a;
    }

    function deflateSync(literals) {
      if (!(0, _is_node.default)()) {
        return deflateSyncUncompressed(literals);
      }

      try {
        var input;

        if (parseInt(process.versions.node) >= 8) {
          input = literals;
        } else {
          input = new Buffer(literals);
        }

        throw Error("zlib not available in the browser");

        return output instanceof Uint8Array ? output : new Uint8Array(output);
      } catch (e) {
        (0, _util.warn)('Not compressing PNG because zlib.deflateSync is unavailable: ' + e);
      }

      return deflateSyncUncompressed(literals);
    }

    function deflateSyncUncompressed(literals) {
      var len = literals.length;
      var maxBlockLength = 0xFFFF;
      var deflateBlocks = Math.ceil(len / maxBlockLength);
      var idat = new Uint8Array(2 + len + deflateBlocks * 5 + 4);
      var pi = 0;
      idat[pi++] = 0x78;
      idat[pi++] = 0x9c;
      var pos = 0;

      while (len > maxBlockLength) {
        idat[pi++] = 0x00;
        idat[pi++] = 0xff;
        idat[pi++] = 0xff;
        idat[pi++] = 0x00;
        idat[pi++] = 0x00;
        idat.set(literals.subarray(pos, pos + maxBlockLength), pi);
        pi += maxBlockLength;
        pos += maxBlockLength;
        len -= maxBlockLength;
      }

      idat[pi++] = 0x01;
      idat[pi++] = len & 0xff;
      idat[pi++] = len >> 8 & 0xff;
      idat[pi++] = ~len & 0xffff & 0xff;
      idat[pi++] = (~len & 0xffff) >> 8 & 0xff;
      idat.set(literals.subarray(pos), pi);
      pi += literals.length - pos;
      var adler = adler32(literals, 0, literals.length);
      idat[pi++] = adler >> 24 & 0xff;
      idat[pi++] = adler >> 16 & 0xff;
      idat[pi++] = adler >> 8 & 0xff;
      idat[pi++] = adler & 0xff;
      return idat;
    }

    function encode(imgData, kind, forceDataSchema, isMask) {
      var width = imgData.width;
      var height = imgData.height;
      var bitDepth, colorType, lineSize;
      var bytes = imgData.data;

      switch (kind) {
        case _util.ImageKind.GRAYSCALE_1BPP:
          colorType = 0;
          bitDepth = 1;
          lineSize = width + 7 >> 3;
          break;

        case _util.ImageKind.RGB_24BPP:
          colorType = 2;
          bitDepth = 8;
          lineSize = width * 3;
          break;

        case _util.ImageKind.RGBA_32BPP:
          colorType = 6;
          bitDepth = 8;
          lineSize = width * 4;
          break;

        default:
          throw new Error('invalid format');
      }

      var literals = new Uint8Array((1 + lineSize) * height);
      var offsetLiterals = 0,
          offsetBytes = 0;
      var y, i;

      for (y = 0; y < height; ++y) {
        literals[offsetLiterals++] = 0;
        literals.set(bytes.subarray(offsetBytes, offsetBytes + lineSize), offsetLiterals);
        offsetBytes += lineSize;
        offsetLiterals += lineSize;
      }

      if (kind === _util.ImageKind.GRAYSCALE_1BPP && isMask) {
        offsetLiterals = 0;

        for (y = 0; y < height; y++) {
          offsetLiterals++;

          for (i = 0; i < lineSize; i++) {
            literals[offsetLiterals++] ^= 0xFF;
          }
        }
      }

      var ihdr = new Uint8Array([width >> 24 & 0xff, width >> 16 & 0xff, width >> 8 & 0xff, width & 0xff, height >> 24 & 0xff, height >> 16 & 0xff, height >> 8 & 0xff, height & 0xff, bitDepth, colorType, 0x00, 0x00, 0x00]);
      var idat = deflateSync(literals);
      var pngLength = PNG_HEADER.length + CHUNK_WRAPPER_SIZE * 3 + ihdr.length + idat.length;
      var data = new Uint8Array(pngLength);
      var offset = 0;
      data.set(PNG_HEADER, offset);
      offset += PNG_HEADER.length;
      writePngChunk('IHDR', ihdr, data, offset);
      offset += CHUNK_WRAPPER_SIZE + ihdr.length;
      writePngChunk('IDATA', idat, data, offset);
      offset += CHUNK_WRAPPER_SIZE + idat.length;
      writePngChunk('IEND', new Uint8Array(0), data, offset);
      return (0, _util.createObjectURL)(data, 'image/png', forceDataSchema);
    }

    return function convertImgDataToPng(imgData, forceDataSchema, isMask) {
      var kind = imgData.kind === undefined ? _util.ImageKind.GRAYSCALE_1BPP : imgData.kind;
      return encode(imgData, kind, forceDataSchema, isMask);
    };
  }();

  var SVGExtraState = function SVGExtraStateClosure() {
    function SVGExtraState() {
      this.fontSizeScale = 1;
      this.fontWeight = SVG_DEFAULTS.fontWeight;
      this.fontSize = 0;
      this.textMatrix = _util.IDENTITY_MATRIX;
      this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
      this.leading = 0;
      this.textRenderingMode = _util.TextRenderingMode.FILL;
      this.x = 0;
      this.y = 0;
      this.lineX = 0;
      this.lineY = 0;
      this.charSpacing = 0;
      this.wordSpacing = 0;
      this.textHScale = 1;
      this.textRise = 0;
      this.fillColor = SVG_DEFAULTS.fillColor;
      this.strokeColor = '#000000';
      this.fillAlpha = 1;
      this.strokeAlpha = 1;
      this.lineWidth = 1;
      this.lineJoin = '';
      this.lineCap = '';
      this.miterLimit = 0;
      this.dashArray = [];
      this.dashPhase = 0;
      this.dependencies = [];
      this.activeClipUrl = null;
      this.clipGroup = null;
      this.maskId = '';
    }

    SVGExtraState.prototype = {
      clone: function SVGExtraState_clone() {
        return Object.create(this);
      },
      setCurrentPoint: function SVGExtraState_setCurrentPoint(x, y) {
        this.x = x;
        this.y = y;
      }
    };
    return SVGExtraState;
  }();

  exports.SVGGraphics = SVGGraphics = function SVGGraphicsClosure() {
    function opListToTree(opList) {
      var opTree = [];
      var tmp = [];
      var opListLen = opList.length;

      for (var x = 0; x < opListLen; x++) {
        if (opList[x].fn === 'save') {
          opTree.push({
            'fnId': 92,
            'fn': 'group',
            'items': []
          });
          tmp.push(opTree);
          opTree = opTree[opTree.length - 1].items;
          continue;
        }

        if (opList[x].fn === 'restore') {
          opTree = tmp.pop();
        } else {
          opTree.push(opList[x]);
        }
      }

      return opTree;
    }

    function pf(value) {
      if (Number.isInteger(value)) {
        return value.toString();
      }

      var s = value.toFixed(10);
      var i = s.length - 1;

      if (s[i] !== '0') {
        return s;
      }

      do {
        i--;
      } while (s[i] === '0');

      return s.substring(0, s[i] === '.' ? i : i + 1);
    }

    function pm(m) {
      if (m[4] === 0 && m[5] === 0) {
        if (m[1] === 0 && m[2] === 0) {
          if (m[0] === 1 && m[3] === 1) {
            return '';
          }

          return 'scale(' + pf(m[0]) + ' ' + pf(m[3]) + ')';
        }

        if (m[0] === m[3] && m[1] === -m[2]) {
          var a = Math.acos(m[0]) * 180 / Math.PI;
          return 'rotate(' + pf(a) + ')';
        }
      } else {
        if (m[0] === 1 && m[1] === 0 && m[2] === 0 && m[3] === 1) {
          return 'translate(' + pf(m[4]) + ' ' + pf(m[5]) + ')';
        }
      }

      return 'matrix(' + pf(m[0]) + ' ' + pf(m[1]) + ' ' + pf(m[2]) + ' ' + pf(m[3]) + ' ' + pf(m[4]) + ' ' + pf(m[5]) + ')';
    }

    function SVGGraphics(commonObjs, objs, forceDataSchema) {
      this.svgFactory = new _dom_utils.DOMSVGFactory();
      this.current = new SVGExtraState();
      this.transformMatrix = _util.IDENTITY_MATRIX;
      this.transformStack = [];
      this.extraStack = [];
      this.commonObjs = commonObjs;
      this.objs = objs;
      this.pendingClip = null;
      this.pendingEOFill = false;
      this.embedFonts = false;
      this.embeddedFonts = Object.create(null);
      this.cssStyle = null;
      this.forceDataSchema = !!forceDataSchema;
    }

    var XML_NS = 'http://www.w3.org/XML/1998/namespace';
    var XLINK_NS = 'http://www.w3.org/1999/xlink';
    var LINE_CAP_STYLES = ['butt', 'round', 'square'];
    var LINE_JOIN_STYLES = ['miter', 'round', 'bevel'];
    var clipCount = 0;
    var maskCount = 0;
    SVGGraphics.prototype = {
      save: function SVGGraphics_save() {
        this.transformStack.push(this.transformMatrix);
        var old = this.current;
        this.extraStack.push(old);
        this.current = old.clone();
      },
      restore: function SVGGraphics_restore() {
        this.transformMatrix = this.transformStack.pop();
        this.current = this.extraStack.pop();
        this.pendingClip = null;
        this.tgrp = null;
      },
      group: function SVGGraphics_group(items) {
        this.save();
        this.executeOpTree(items);
        this.restore();
      },
      loadDependencies: function SVGGraphics_loadDependencies(operatorList) {
        var _this = this;

        var fnArray = operatorList.fnArray;
        var fnArrayLen = fnArray.length;
        var argsArray = operatorList.argsArray;

        for (var i = 0; i < fnArrayLen; i++) {
          if (_util.OPS.dependency === fnArray[i]) {
            var deps = argsArray[i];

            for (var n = 0, nn = deps.length; n < nn; n++) {
              var obj = deps[n];
              var common = obj.substring(0, 2) === 'g_';
              var promise;

              if (common) {
                promise = new Promise(function (resolve) {
                  _this.commonObjs.get(obj, resolve);
                });
              } else {
                promise = new Promise(function (resolve) {
                  _this.objs.get(obj, resolve);
                });
              }

              this.current.dependencies.push(promise);
            }
          }
        }

        return Promise.all(this.current.dependencies);
      },
      transform: function SVGGraphics_transform(a, b, c, d, e, f) {
        var transformMatrix = [a, b, c, d, e, f];
        this.transformMatrix = _util.Util.transform(this.transformMatrix, transformMatrix);
        this.tgrp = null;
      },
      getSVG: function SVGGraphics_getSVG(operatorList, viewport) {
        var _this2 = this;

        this.viewport = viewport;

        var svgElement = this._initialize(viewport);

        return this.loadDependencies(operatorList).then(function () {
          _this2.transformMatrix = _util.IDENTITY_MATRIX;

          var opTree = _this2.convertOpList(operatorList);

          _this2.executeOpTree(opTree);

          return svgElement;
        });
      },
      convertOpList: function SVGGraphics_convertOpList(operatorList) {
        var argsArray = operatorList.argsArray;
        var fnArray = operatorList.fnArray;
        var fnArrayLen = fnArray.length;
        var REVOPS = [];
        var opList = [];

        for (var op in _util.OPS) {
          REVOPS[_util.OPS[op]] = op;
        }

        for (var x = 0; x < fnArrayLen; x++) {
          var fnId = fnArray[x];
          opList.push({
            'fnId': fnId,
            'fn': REVOPS[fnId],
            'args': argsArray[x]
          });
        }

        return opListToTree(opList);
      },
      executeOpTree: function SVGGraphics_executeOpTree(opTree) {
        var opTreeLen = opTree.length;

        for (var x = 0; x < opTreeLen; x++) {
          var fn = opTree[x].fn;
          var fnId = opTree[x].fnId;
          var args = opTree[x].args;

          switch (fnId | 0) {
            case _util.OPS.beginText:
              this.beginText();
              break;

            case _util.OPS.dependency:
              break;

            case _util.OPS.setLeading:
              this.setLeading(args);
              break;

            case _util.OPS.setLeadingMoveText:
              this.setLeadingMoveText(args[0], args[1]);
              break;

            case _util.OPS.setFont:
              this.setFont(args);
              break;

            case _util.OPS.showText:
              this.showText(args[0]);
              break;

            case _util.OPS.showSpacedText:
              this.showText(args[0]);
              break;

            case _util.OPS.endText:
              this.endText();
              break;

            case _util.OPS.moveText:
              this.moveText(args[0], args[1]);
              break;

            case _util.OPS.setCharSpacing:
              this.setCharSpacing(args[0]);
              break;

            case _util.OPS.setWordSpacing:
              this.setWordSpacing(args[0]);
              break;

            case _util.OPS.setHScale:
              this.setHScale(args[0]);
              break;

            case _util.OPS.setTextMatrix:
              this.setTextMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
              break;

            case _util.OPS.setTextRise:
              this.setTextRise(args[0]);
              break;

            case _util.OPS.setTextRenderingMode:
              this.setTextRenderingMode(args[0]);
              break;

            case _util.OPS.setLineWidth:
              this.setLineWidth(args[0]);
              break;

            case _util.OPS.setLineJoin:
              this.setLineJoin(args[0]);
              break;

            case _util.OPS.setLineCap:
              this.setLineCap(args[0]);
              break;

            case _util.OPS.setMiterLimit:
              this.setMiterLimit(args[0]);
              break;

            case _util.OPS.setFillRGBColor:
              this.setFillRGBColor(args[0], args[1], args[2]);
              break;

            case _util.OPS.setStrokeRGBColor:
              this.setStrokeRGBColor(args[0], args[1], args[2]);
              break;

            case _util.OPS.setDash:
              this.setDash(args[0], args[1]);
              break;

            case _util.OPS.setGState:
              this.setGState(args[0]);
              break;

            case _util.OPS.fill:
              this.fill();
              break;

            case _util.OPS.eoFill:
              this.eoFill();
              break;

            case _util.OPS.stroke:
              this.stroke();
              break;

            case _util.OPS.fillStroke:
              this.fillStroke();
              break;

            case _util.OPS.eoFillStroke:
              this.eoFillStroke();
              break;

            case _util.OPS.clip:
              this.clip('nonzero');
              break;

            case _util.OPS.eoClip:
              this.clip('evenodd');
              break;

            case _util.OPS.paintSolidColorImageMask:
              this.paintSolidColorImageMask();
              break;

            case _util.OPS.paintJpegXObject:
              this.paintJpegXObject(args[0], args[1], args[2]);
              break;

            case _util.OPS.paintImageXObject:
              this.paintImageXObject(args[0]);
              break;

            case _util.OPS.paintInlineImageXObject:
              this.paintInlineImageXObject(args[0]);
              break;

            case _util.OPS.paintImageMaskXObject:
              this.paintImageMaskXObject(args[0]);
              break;

            case _util.OPS.paintFormXObjectBegin:
              this.paintFormXObjectBegin(args[0], args[1]);
              break;

            case _util.OPS.paintFormXObjectEnd:
              this.paintFormXObjectEnd();
              break;

            case _util.OPS.closePath:
              this.closePath();
              break;

            case _util.OPS.closeStroke:
              this.closeStroke();
              break;

            case _util.OPS.closeFillStroke:
              this.closeFillStroke();
              break;

            case _util.OPS.closeEOFillStroke:
              this.closeEOFillStroke();
              break;

            case _util.OPS.nextLine:
              this.nextLine();
              break;

            case _util.OPS.transform:
              this.transform(args[0], args[1], args[2], args[3], args[4], args[5]);
              break;

            case _util.OPS.constructPath:
              this.constructPath(args[0], args[1]);
              break;

            case _util.OPS.endPath:
              this.endPath();
              break;

            case 92:
              this.group(opTree[x].items);
              break;

            default:
              (0, _util.warn)('Unimplemented operator ' + fn);
              break;
          }
        }
      },
      setWordSpacing: function SVGGraphics_setWordSpacing(wordSpacing) {
        this.current.wordSpacing = wordSpacing;
      },
      setCharSpacing: function SVGGraphics_setCharSpacing(charSpacing) {
        this.current.charSpacing = charSpacing;
      },
      nextLine: function SVGGraphics_nextLine() {
        this.moveText(0, this.current.leading);
      },
      setTextMatrix: function SVGGraphics_setTextMatrix(a, b, c, d, e, f) {
        var current = this.current;
        this.current.textMatrix = this.current.lineMatrix = [a, b, c, d, e, f];
        this.current.x = this.current.lineX = 0;
        this.current.y = this.current.lineY = 0;
        current.xcoords = [];
        current.tspan = this.svgFactory.createElement('svg:tspan');
        current.tspan.setAttributeNS(null, 'font-family', current.fontFamily);
        current.tspan.setAttributeNS(null, 'font-size', pf(current.fontSize) + 'px');
        current.tspan.setAttributeNS(null, 'y', pf(-current.y));
        current.txtElement = this.svgFactory.createElement('svg:text');
        current.txtElement.appendChild(current.tspan);
      },
      beginText: function SVGGraphics_beginText() {
        this.current.x = this.current.lineX = 0;
        this.current.y = this.current.lineY = 0;
        this.current.textMatrix = _util.IDENTITY_MATRIX;
        this.current.lineMatrix = _util.IDENTITY_MATRIX;
        this.current.tspan = this.svgFactory.createElement('svg:tspan');
        this.current.txtElement = this.svgFactory.createElement('svg:text');
        this.current.txtgrp = this.svgFactory.createElement('svg:g');
        this.current.xcoords = [];
      },
      moveText: function SVGGraphics_moveText(x, y) {
        var current = this.current;
        this.current.x = this.current.lineX += x;
        this.current.y = this.current.lineY += y;
        current.xcoords = [];
        current.tspan = this.svgFactory.createElement('svg:tspan');
        current.tspan.setAttributeNS(null, 'font-family', current.fontFamily);
        current.tspan.setAttributeNS(null, 'font-size', pf(current.fontSize) + 'px');
        current.tspan.setAttributeNS(null, 'y', pf(-current.y));
      },
      showText: function SVGGraphics_showText(glyphs) {
        var current = this.current;
        var font = current.font;
        var fontSize = current.fontSize;

        if (fontSize === 0) {
          return;
        }

        var charSpacing = current.charSpacing;
        var wordSpacing = current.wordSpacing;
        var fontDirection = current.fontDirection;
        var textHScale = current.textHScale * fontDirection;
        var glyphsLength = glyphs.length;
        var vertical = font.vertical;
        var widthAdvanceScale = fontSize * current.fontMatrix[0];
        var x = 0,
            i;

        for (i = 0; i < glyphsLength; ++i) {
          var glyph = glyphs[i];

          if (glyph === null) {
            x += fontDirection * wordSpacing;
            continue;
          } else if ((0, _util.isNum)(glyph)) {
            x += -glyph * fontSize * 0.001;
            continue;
          }

          var width = glyph.width;
          var character = glyph.fontChar;
          var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
          var charWidth = width * widthAdvanceScale + spacing * fontDirection;

          if (!glyph.isInFont && !font.missingFile) {
            x += charWidth;
            continue;
          }

          current.xcoords.push(current.x + x * textHScale);
          current.tspan.textContent += character;
          x += charWidth;
        }

        if (vertical) {
          current.y -= x * textHScale;
        } else {
          current.x += x * textHScale;
        }

        current.tspan.setAttributeNS(null, 'x', current.xcoords.map(pf).join(' '));
        current.tspan.setAttributeNS(null, 'y', pf(-current.y));
        current.tspan.setAttributeNS(null, 'font-family', current.fontFamily);
        current.tspan.setAttributeNS(null, 'font-size', pf(current.fontSize) + 'px');

        if (current.fontStyle !== SVG_DEFAULTS.fontStyle) {
          current.tspan.setAttributeNS(null, 'font-style', current.fontStyle);
        }

        if (current.fontWeight !== SVG_DEFAULTS.fontWeight) {
          current.tspan.setAttributeNS(null, 'font-weight', current.fontWeight);
        }

        var fillStrokeMode = current.textRenderingMode & _util.TextRenderingMode.FILL_STROKE_MASK;

        if (fillStrokeMode === _util.TextRenderingMode.FILL || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          if (current.fillColor !== SVG_DEFAULTS.fillColor) {
            current.tspan.setAttributeNS(null, 'fill', current.fillColor);
          }

          if (current.fillAlpha < 1) {
            current.tspan.setAttributeNS(null, 'fill-opacity', current.fillAlpha);
          }
        } else if (current.textRenderingMode === _util.TextRenderingMode.ADD_TO_PATH) {
          current.tspan.setAttributeNS(null, 'fill', 'transparent');
        } else {
          current.tspan.setAttributeNS(null, 'fill', 'none');
        }

        if (fillStrokeMode === _util.TextRenderingMode.STROKE || fillStrokeMode === _util.TextRenderingMode.FILL_STROKE) {
          this._setStrokeAttributes(current.tspan);
        }

        var textMatrix = current.textMatrix;

        if (current.textRise !== 0) {
          textMatrix = textMatrix.slice();
          textMatrix[5] += current.textRise;
        }

        current.txtElement.setAttributeNS(null, 'transform', pm(textMatrix) + ' scale(1, -1)');
        current.txtElement.setAttributeNS(XML_NS, 'xml:space', 'preserve');
        current.txtElement.appendChild(current.tspan);
        current.txtgrp.appendChild(current.txtElement);

        this._ensureTransformGroup().appendChild(current.txtElement);
      },
      setLeadingMoveText: function SVGGraphics_setLeadingMoveText(x, y) {
        this.setLeading(-y);
        this.moveText(x, y);
      },
      addFontStyle: function SVGGraphics_addFontStyle(fontObj) {
        if (!this.cssStyle) {
          this.cssStyle = this.svgFactory.createElement('svg:style');
          this.cssStyle.setAttributeNS(null, 'type', 'text/css');
          this.defs.appendChild(this.cssStyle);
        }

        var url = (0, _util.createObjectURL)(fontObj.data, fontObj.mimetype, this.forceDataSchema);
        this.cssStyle.textContent += '@font-face { font-family: "' + fontObj.loadedName + '";' + ' src: url(' + url + '); }\n';
      },
      setFont: function SVGGraphics_setFont(details) {
        var current = this.current;
        var fontObj = this.commonObjs.get(details[0]);
        var size = details[1];
        this.current.font = fontObj;

        if (this.embedFonts && fontObj.data && !this.embeddedFonts[fontObj.loadedName]) {
          this.addFontStyle(fontObj);
          this.embeddedFonts[fontObj.loadedName] = fontObj;
        }

        current.fontMatrix = fontObj.fontMatrix ? fontObj.fontMatrix : _util.FONT_IDENTITY_MATRIX;
        var bold = fontObj.black ? fontObj.bold ? 'bolder' : 'bold' : fontObj.bold ? 'bold' : 'normal';
        var italic = fontObj.italic ? 'italic' : 'normal';

        if (size < 0) {
          size = -size;
          current.fontDirection = -1;
        } else {
          current.fontDirection = 1;
        }

        current.fontSize = size;
        current.fontFamily = fontObj.loadedName;
        current.fontWeight = bold;
        current.fontStyle = italic;
        current.tspan = this.svgFactory.createElement('svg:tspan');
        current.tspan.setAttributeNS(null, 'y', pf(-current.y));
        current.xcoords = [];
      },
      endText: function endText() {
        var current = this.current;

        if (current.textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG && current.txtElement && current.txtElement.hasChildNodes()) {
          current.element = current.txtElement;
          this.clip('nonzero');
          this.endPath();
        }
      },
      setLineWidth: function SVGGraphics_setLineWidth(width) {
        if (width > 0) {
          this.current.lineWidth = width;
        }
      },
      setLineCap: function SVGGraphics_setLineCap(style) {
        this.current.lineCap = LINE_CAP_STYLES[style];
      },
      setLineJoin: function SVGGraphics_setLineJoin(style) {
        this.current.lineJoin = LINE_JOIN_STYLES[style];
      },
      setMiterLimit: function SVGGraphics_setMiterLimit(limit) {
        this.current.miterLimit = limit;
      },
      setStrokeAlpha: function SVGGraphics_setStrokeAlpha(strokeAlpha) {
        this.current.strokeAlpha = strokeAlpha;
      },
      setStrokeRGBColor: function SVGGraphics_setStrokeRGBColor(r, g, b) {
        var color = _util.Util.makeCssRgb(r, g, b);

        this.current.strokeColor = color;
      },
      setFillAlpha: function SVGGraphics_setFillAlpha(fillAlpha) {
        this.current.fillAlpha = fillAlpha;
      },
      setFillRGBColor: function SVGGraphics_setFillRGBColor(r, g, b) {
        var color = _util.Util.makeCssRgb(r, g, b);

        this.current.fillColor = color;
        this.current.tspan = this.svgFactory.createElement('svg:tspan');
        this.current.xcoords = [];
      },
      setDash: function SVGGraphics_setDash(dashArray, dashPhase) {
        this.current.dashArray = dashArray;
        this.current.dashPhase = dashPhase;
      },
      constructPath: function SVGGraphics_constructPath(ops, args) {
        var current = this.current;
        var x = current.x,
            y = current.y;
        current.path = this.svgFactory.createElement('svg:path');
        var d = [];
        var opLength = ops.length;

        for (var i = 0, j = 0; i < opLength; i++) {
          switch (ops[i] | 0) {
            case _util.OPS.rectangle:
              x = args[j++];
              y = args[j++];
              var width = args[j++];
              var height = args[j++];
              var xw = x + width;
              var yh = y + height;
              d.push('M', pf(x), pf(y), 'L', pf(xw), pf(y), 'L', pf(xw), pf(yh), 'L', pf(x), pf(yh), 'Z');
              break;

            case _util.OPS.moveTo:
              x = args[j++];
              y = args[j++];
              d.push('M', pf(x), pf(y));
              break;

            case _util.OPS.lineTo:
              x = args[j++];
              y = args[j++];
              d.push('L', pf(x), pf(y));
              break;

            case _util.OPS.curveTo:
              x = args[j + 4];
              y = args[j + 5];
              d.push('C', pf(args[j]), pf(args[j + 1]), pf(args[j + 2]), pf(args[j + 3]), pf(x), pf(y));
              j += 6;
              break;

            case _util.OPS.curveTo2:
              x = args[j + 2];
              y = args[j + 3];
              d.push('C', pf(x), pf(y), pf(args[j]), pf(args[j + 1]), pf(args[j + 2]), pf(args[j + 3]));
              j += 4;
              break;

            case _util.OPS.curveTo3:
              x = args[j + 2];
              y = args[j + 3];
              d.push('C', pf(args[j]), pf(args[j + 1]), pf(x), pf(y), pf(x), pf(y));
              j += 4;
              break;

            case _util.OPS.closePath:
              d.push('Z');
              break;
          }
        }

        current.path.setAttributeNS(null, 'd', d.join(' '));
        current.path.setAttributeNS(null, 'fill', 'none');

        this._ensureTransformGroup().appendChild(current.path);

        current.element = current.path;
        current.setCurrentPoint(x, y);
      },
      endPath: function SVGGraphics_endPath() {
        if (!this.pendingClip) {
          return;
        }

        var current = this.current;
        var clipId = 'clippath' + clipCount;
        clipCount++;
        var clipPath = this.svgFactory.createElement('svg:clipPath');
        clipPath.setAttributeNS(null, 'id', clipId);
        clipPath.setAttributeNS(null, 'transform', pm(this.transformMatrix));
        var clipElement = current.element.cloneNode(true);

        if (this.pendingClip === 'evenodd') {
          clipElement.setAttributeNS(null, 'clip-rule', 'evenodd');
        } else {
          clipElement.setAttributeNS(null, 'clip-rule', 'nonzero');
        }

        this.pendingClip = null;
        clipPath.appendChild(clipElement);
        this.defs.appendChild(clipPath);

        if (current.activeClipUrl) {
          current.clipGroup = null;
          this.extraStack.forEach(function (prev) {
            prev.clipGroup = null;
          });
          clipPath.setAttributeNS(null, 'clip-path', current.activeClipUrl);
        }

        current.activeClipUrl = 'url(#' + clipId + ')';
        this.tgrp = null;
      },
      clip: function SVGGraphics_clip(type) {
        this.pendingClip = type;
      },
      closePath: function SVGGraphics_closePath() {
        var current = this.current;

        if (current.path) {
          var d = current.path.getAttributeNS(null, 'd');
          d += 'Z';
          current.path.setAttributeNS(null, 'd', d);
        }
      },
      setLeading: function SVGGraphics_setLeading(leading) {
        this.current.leading = -leading;
      },
      setTextRise: function SVGGraphics_setTextRise(textRise) {
        this.current.textRise = textRise;
      },
      setTextRenderingMode: function setTextRenderingMode(textRenderingMode) {
        this.current.textRenderingMode = textRenderingMode;
      },
      setHScale: function SVGGraphics_setHScale(scale) {
        this.current.textHScale = scale / 100;
      },
      setGState: function SVGGraphics_setGState(states) {
        for (var i = 0, ii = states.length; i < ii; i++) {
          var state = states[i];
          var key = state[0];
          var value = state[1];

          switch (key) {
            case 'LW':
              this.setLineWidth(value);
              break;

            case 'LC':
              this.setLineCap(value);
              break;

            case 'LJ':
              this.setLineJoin(value);
              break;

            case 'ML':
              this.setMiterLimit(value);
              break;

            case 'D':
              this.setDash(value[0], value[1]);
              break;

            case 'Font':
              this.setFont(value);
              break;

            case 'CA':
              this.setStrokeAlpha(value);
              break;

            case 'ca':
              this.setFillAlpha(value);
              break;

            default:
              (0, _util.warn)('Unimplemented graphic state ' + key);
              break;
          }
        }
      },
      fill: function SVGGraphics_fill() {
        var current = this.current;

        if (current.element) {
          current.element.setAttributeNS(null, 'fill', current.fillColor);
          current.element.setAttributeNS(null, 'fill-opacity', current.fillAlpha);
          this.endPath();
        }
      },
      stroke: function SVGGraphics_stroke() {
        var current = this.current;

        if (current.element) {
          this._setStrokeAttributes(current.element);

          current.element.setAttributeNS(null, 'fill', 'none');
          this.endPath();
        }
      },
      _setStrokeAttributes: function _setStrokeAttributes(element) {
        var current = this.current;
        element.setAttributeNS(null, 'stroke', current.strokeColor);
        element.setAttributeNS(null, 'stroke-opacity', current.strokeAlpha);
        element.setAttributeNS(null, 'stroke-miterlimit', pf(current.miterLimit));
        element.setAttributeNS(null, 'stroke-linecap', current.lineCap);
        element.setAttributeNS(null, 'stroke-linejoin', current.lineJoin);
        element.setAttributeNS(null, 'stroke-width', pf(current.lineWidth) + 'px');
        element.setAttributeNS(null, 'stroke-dasharray', current.dashArray.map(pf).join(' '));
        element.setAttributeNS(null, 'stroke-dashoffset', pf(current.dashPhase) + 'px');
      },
      eoFill: function SVGGraphics_eoFill() {
        if (this.current.element) {
          this.current.element.setAttributeNS(null, 'fill-rule', 'evenodd');
        }

        this.fill();
      },
      fillStroke: function SVGGraphics_fillStroke() {
        this.stroke();
        this.fill();
      },
      eoFillStroke: function SVGGraphics_eoFillStroke() {
        if (this.current.element) {
          this.current.element.setAttributeNS(null, 'fill-rule', 'evenodd');
        }

        this.fillStroke();
      },
      closeStroke: function SVGGraphics_closeStroke() {
        this.closePath();
        this.stroke();
      },
      closeFillStroke: function SVGGraphics_closeFillStroke() {
        this.closePath();
        this.fillStroke();
      },
      closeEOFillStroke: function closeEOFillStroke() {
        this.closePath();
        this.eoFillStroke();
      },
      paintSolidColorImageMask: function SVGGraphics_paintSolidColorImageMask() {
        var current = this.current;
        var rect = this.svgFactory.createElement('svg:rect');
        rect.setAttributeNS(null, 'x', '0');
        rect.setAttributeNS(null, 'y', '0');
        rect.setAttributeNS(null, 'width', '1px');
        rect.setAttributeNS(null, 'height', '1px');
        rect.setAttributeNS(null, 'fill', current.fillColor);

        this._ensureTransformGroup().appendChild(rect);
      },
      paintJpegXObject: function SVGGraphics_paintJpegXObject(objId, w, h) {
        var imgObj = this.objs.get(objId);
        var imgEl = this.svgFactory.createElement('svg:image');
        imgEl.setAttributeNS(XLINK_NS, 'xlink:href', imgObj.src);
        imgEl.setAttributeNS(null, 'width', pf(w));
        imgEl.setAttributeNS(null, 'height', pf(h));
        imgEl.setAttributeNS(null, 'x', '0');
        imgEl.setAttributeNS(null, 'y', pf(-h));
        imgEl.setAttributeNS(null, 'transform', 'scale(' + pf(1 / w) + ' ' + pf(-1 / h) + ')');

        this._ensureTransformGroup().appendChild(imgEl);
      },
      paintImageXObject: function SVGGraphics_paintImageXObject(objId) {
        var imgData = this.objs.get(objId);

        if (!imgData) {
          (0, _util.warn)('Dependent image isn\'t ready yet');
          return;
        }

        this.paintInlineImageXObject(imgData);
      },
      paintInlineImageXObject: function SVGGraphics_paintInlineImageXObject(imgData, mask) {
        var width = imgData.width;
        var height = imgData.height;
        var imgSrc = convertImgDataToPng(imgData, this.forceDataSchema, !!mask);
        var cliprect = this.svgFactory.createElement('svg:rect');
        cliprect.setAttributeNS(null, 'x', '0');
        cliprect.setAttributeNS(null, 'y', '0');
        cliprect.setAttributeNS(null, 'width', pf(width));
        cliprect.setAttributeNS(null, 'height', pf(height));
        this.current.element = cliprect;
        this.clip('nonzero');
        var imgEl = this.svgFactory.createElement('svg:image');
        imgEl.setAttributeNS(XLINK_NS, 'xlink:href', imgSrc);
        imgEl.setAttributeNS(null, 'x', '0');
        imgEl.setAttributeNS(null, 'y', pf(-height));
        imgEl.setAttributeNS(null, 'width', pf(width) + 'px');
        imgEl.setAttributeNS(null, 'height', pf(height) + 'px');
        imgEl.setAttributeNS(null, 'transform', 'scale(' + pf(1 / width) + ' ' + pf(-1 / height) + ')');

        if (mask) {
          mask.appendChild(imgEl);
        } else {
          this._ensureTransformGroup().appendChild(imgEl);
        }
      },
      paintImageMaskXObject: function SVGGraphics_paintImageMaskXObject(imgData) {
        var current = this.current;
        var width = imgData.width;
        var height = imgData.height;
        var fillColor = current.fillColor;
        current.maskId = 'mask' + maskCount++;
        var mask = this.svgFactory.createElement('svg:mask');
        mask.setAttributeNS(null, 'id', current.maskId);
        var rect = this.svgFactory.createElement('svg:rect');
        rect.setAttributeNS(null, 'x', '0');
        rect.setAttributeNS(null, 'y', '0');
        rect.setAttributeNS(null, 'width', pf(width));
        rect.setAttributeNS(null, 'height', pf(height));
        rect.setAttributeNS(null, 'fill', fillColor);
        rect.setAttributeNS(null, 'mask', 'url(#' + current.maskId + ')');
        this.defs.appendChild(mask);

        this._ensureTransformGroup().appendChild(rect);

        this.paintInlineImageXObject(imgData, mask);
      },
      paintFormXObjectBegin: function SVGGraphics_paintFormXObjectBegin(matrix, bbox) {
        if (Array.isArray(matrix) && matrix.length === 6) {
          this.transform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
        }

        if (bbox) {
          var width = bbox[2] - bbox[0];
          var height = bbox[3] - bbox[1];
          var cliprect = this.svgFactory.createElement('svg:rect');
          cliprect.setAttributeNS(null, 'x', bbox[0]);
          cliprect.setAttributeNS(null, 'y', bbox[1]);
          cliprect.setAttributeNS(null, 'width', pf(width));
          cliprect.setAttributeNS(null, 'height', pf(height));
          this.current.element = cliprect;
          this.clip('nonzero');
          this.endPath();
        }
      },
      paintFormXObjectEnd: function SVGGraphics_paintFormXObjectEnd() {},
      _initialize: function _initialize(viewport) {
        var svg = this.svgFactory.create(viewport.width, viewport.height);
        var definitions = this.svgFactory.createElement('svg:defs');
        svg.appendChild(definitions);
        this.defs = definitions;
        var rootGroup = this.svgFactory.createElement('svg:g');
        rootGroup.setAttributeNS(null, 'transform', pm(viewport.transform));
        svg.appendChild(rootGroup);
        this.svg = rootGroup;
        return svg;
      },
      _ensureClipGroup: function SVGGraphics_ensureClipGroup() {
        if (!this.current.clipGroup) {
          var clipGroup = this.svgFactory.createElement('svg:g');
          clipGroup.setAttributeNS(null, 'clip-path', this.current.activeClipUrl);
          this.svg.appendChild(clipGroup);
          this.current.clipGroup = clipGroup;
        }

        return this.current.clipGroup;
      },
      _ensureTransformGroup: function SVGGraphics_ensureTransformGroup() {
        if (!this.tgrp) {
          this.tgrp = this.svgFactory.createElement('svg:g');
          this.tgrp.setAttributeNS(null, 'transform', pm(this.transformMatrix));

          if (this.current.activeClipUrl) {
            this._ensureClipGroup().appendChild(this.tgrp);
          } else {
            this.svg.appendChild(this.tgrp);
          }
        }

        return this.tgrp;
      }
    };
    return SVGGraphics;
  }();
}

/***/ }),
/* 165 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFNodeStream = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(147));

var _util = __w_pdfjs_require__(1);

var _network_utils = __w_pdfjs_require__(166);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var url = __webpack_require__(1424);

var fileUriRegex = /^file:\/\/\/[a-zA-Z]:\//;

function parseUrl(sourceUrl) {
  var parsedUrl = url.parse(sourceUrl);

  if (parsedUrl.protocol === 'file:' || parsedUrl.host) {
    return parsedUrl;
  }

  if (/^[a-z]:[/\\]/i.test(sourceUrl)) {
    return url.parse("file:///".concat(sourceUrl));
  }

  if (!parsedUrl.host) {
    parsedUrl.protocol = 'file:';
  }

  return parsedUrl;
}

var PDFNodeStream =
/*#__PURE__*/
function () {
  function PDFNodeStream(source) {
    _classCallCheck(this, PDFNodeStream);

    this.source = source;
    this.url = parseUrl(source.url);
    this.isHttp = this.url.protocol === 'http:' || this.url.protocol === 'https:';
    this.isFsUrl = this.url.protocol === 'file:';
    this.httpHeaders = this.isHttp && source.httpHeaders || {};
    this._fullRequest = null;
    this._rangeRequestReaders = [];
  }

  _createClass(PDFNodeStream, [{
    key: "getFullReader",
    value: function getFullReader() {
      (0, _util.assert)(!this._fullRequest);
      this._fullRequest = this.isFsUrl ? new PDFNodeStreamFsFullReader(this) : new PDFNodeStreamFullReader(this);
      return this._fullRequest;
    }
  }, {
    key: "getRangeReader",
    value: function getRangeReader(start, end) {
      var rangeReader = this.isFsUrl ? new PDFNodeStreamFsRangeReader(this, start, end) : new PDFNodeStreamRangeReader(this, start, end);

      this._rangeRequestReaders.push(rangeReader);

      return rangeReader;
    }
  }, {
    key: "cancelAllRequests",
    value: function cancelAllRequests(reason) {
      if (this._fullRequest) {
        this._fullRequest.cancel(reason);
      }

      var readers = this._rangeRequestReaders.slice(0);

      readers.forEach(function (reader) {
        reader.cancel(reason);
      });
    }
  }]);

  return PDFNodeStream;
}();

exports.PDFNodeStream = PDFNodeStream;

var BaseFullReader =
/*#__PURE__*/
function () {
  function BaseFullReader(stream) {
    _classCallCheck(this, BaseFullReader);

    this._url = stream.url;
    this._done = false;
    this._storedError = null;
    this.onProgress = null;
    var source = stream.source;
    this._contentLength = source.length;
    this._loaded = 0;
    this._filename = null;
    this._disableRange = source.disableRange || false;
    this._rangeChunkSize = source.rangeChunkSize;

    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }

    this._isStreamingSupported = !source.disableStream;
    this._isRangeSupported = !source.disableRange;
    this._readableStream = null;
    this._readCapability = (0, _util.createPromiseCapability)();
    this._headersCapability = (0, _util.createPromiseCapability)();
  }

  _createClass(BaseFullReader, [{
    key: "read",
    value: function () {
      var _read = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var chunk, buffer;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._readCapability.promise;

              case 2:
                if (!this._done) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt("return", {
                  value: undefined,
                  done: true
                });

              case 4:
                if (!this._storedError) {
                  _context.next = 6;
                  break;
                }

                throw this._storedError;

              case 6:
                chunk = this._readableStream.read();

                if (!(chunk === null)) {
                  _context.next = 10;
                  break;
                }

                this._readCapability = (0, _util.createPromiseCapability)();
                return _context.abrupt("return", this.read());

              case 10:
                this._loaded += chunk.length;

                if (this.onProgress) {
                  this.onProgress({
                    loaded: this._loaded,
                    total: this._contentLength
                  });
                }

                buffer = new Uint8Array(chunk).buffer;
                return _context.abrupt("return", {
                  value: buffer,
                  done: false
                });

              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function read() {
        return _read.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      if (!this._readableStream) {
        this._error(reason);

        return;
      }

      this._readableStream.destroy(reason);
    }
  }, {
    key: "_error",
    value: function _error(reason) {
      this._storedError = reason;

      this._readCapability.resolve();
    }
  }, {
    key: "_setReadableStream",
    value: function _setReadableStream(readableStream) {
      var _this = this;

      this._readableStream = readableStream;
      readableStream.on('readable', function () {
        _this._readCapability.resolve();
      });
      readableStream.on('end', function () {
        readableStream.destroy();
        _this._done = true;

        _this._readCapability.resolve();
      });
      readableStream.on('error', function (reason) {
        _this._error(reason);
      });

      if (!this._isStreamingSupported && this._isRangeSupported) {
        this._error(new _util.AbortException('streaming is disabled'));
      }

      if (this._storedError) {
        this._readableStream.destroy(this._storedError);
      }
    }
  }, {
    key: "headersReady",
    get: function get() {
      return this._headersCapability.promise;
    }
  }, {
    key: "filename",
    get: function get() {
      return this._filename;
    }
  }, {
    key: "contentLength",
    get: function get() {
      return this._contentLength;
    }
  }, {
    key: "isRangeSupported",
    get: function get() {
      return this._isRangeSupported;
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }]);

  return BaseFullReader;
}();

var BaseRangeReader =
/*#__PURE__*/
function () {
  function BaseRangeReader(stream) {
    _classCallCheck(this, BaseRangeReader);

    this._url = stream.url;
    this._done = false;
    this._storedError = null;
    this.onProgress = null;
    this._loaded = 0;
    this._readableStream = null;
    this._readCapability = (0, _util.createPromiseCapability)();
    var source = stream.source;
    this._isStreamingSupported = !source.disableStream;
  }

  _createClass(BaseRangeReader, [{
    key: "read",
    value: function () {
      var _read2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var chunk, buffer;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._readCapability.promise;

              case 2:
                if (!this._done) {
                  _context2.next = 4;
                  break;
                }

                return _context2.abrupt("return", {
                  value: undefined,
                  done: true
                });

              case 4:
                if (!this._storedError) {
                  _context2.next = 6;
                  break;
                }

                throw this._storedError;

              case 6:
                chunk = this._readableStream.read();

                if (!(chunk === null)) {
                  _context2.next = 10;
                  break;
                }

                this._readCapability = (0, _util.createPromiseCapability)();
                return _context2.abrupt("return", this.read());

              case 10:
                this._loaded += chunk.length;

                if (this.onProgress) {
                  this.onProgress({
                    loaded: this._loaded
                  });
                }

                buffer = new Uint8Array(chunk).buffer;
                return _context2.abrupt("return", {
                  value: buffer,
                  done: false
                });

              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read() {
        return _read2.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      if (!this._readableStream) {
        this._error(reason);

        return;
      }

      this._readableStream.destroy(reason);
    }
  }, {
    key: "_error",
    value: function _error(reason) {
      this._storedError = reason;

      this._readCapability.resolve();
    }
  }, {
    key: "_setReadableStream",
    value: function _setReadableStream(readableStream) {
      var _this2 = this;

      this._readableStream = readableStream;
      readableStream.on('readable', function () {
        _this2._readCapability.resolve();
      });
      readableStream.on('end', function () {
        readableStream.destroy();
        _this2._done = true;

        _this2._readCapability.resolve();
      });
      readableStream.on('error', function (reason) {
        _this2._error(reason);
      });

      if (this._storedError) {
        this._readableStream.destroy(this._storedError);
      }
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }]);

  return BaseRangeReader;
}();

function createRequestOptions(url, headers) {
  return {
    protocol: url.protocol,
    auth: url.auth,
    host: url.hostname,
    port: url.port,
    path: url.path,
    method: 'GET',
    headers: headers
  };
}

var PDFNodeStreamFullReader =
/*#__PURE__*/
function (_BaseFullReader) {
  _inherits(PDFNodeStreamFullReader, _BaseFullReader);

  function PDFNodeStreamFullReader(stream) {
    var _this3;

    _classCallCheck(this, PDFNodeStreamFullReader);

    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(PDFNodeStreamFullReader).call(this, stream));

    var handleResponse = function handleResponse(response) {
      if (response.statusCode === 404) {
        var error = new _util.MissingPDFException("Missing PDF \"".concat(_this3._url, "\"."));
        _this3._storedError = error;

        _this3._headersCapability.reject(error);

        return;
      }

      _this3._headersCapability.resolve();

      _this3._setReadableStream(response);

      var getResponseHeader = function getResponseHeader(name) {
        return _this3._readableStream.headers[name.toLowerCase()];
      };

      var _validateRangeRequest = (0, _network_utils.validateRangeRequestCapabilities)({
        getResponseHeader: getResponseHeader,
        isHttp: stream.isHttp,
        rangeChunkSize: _this3._rangeChunkSize,
        disableRange: _this3._disableRange
      }),
          allowRangeRequests = _validateRangeRequest.allowRangeRequests,
          suggestedLength = _validateRangeRequest.suggestedLength;

      _this3._isRangeSupported = allowRangeRequests;
      _this3._contentLength = suggestedLength || _this3._contentLength;
      _this3._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);
    };

    _this3._request = null;

    if (_this3._url.protocol === 'http:') {
      _this3._request = http.request(createRequestOptions(_this3._url, stream.httpHeaders), handleResponse);
    } else {
      _this3._request = https.request(createRequestOptions(_this3._url, stream.httpHeaders), handleResponse);
    }

    _this3._request.on('error', function (reason) {
      _this3._storedError = reason;

      _this3._headersCapability.reject(reason);
    });

    _this3._request.end();

    return _this3;
  }

  return PDFNodeStreamFullReader;
}(BaseFullReader);

var PDFNodeStreamRangeReader =
/*#__PURE__*/
function (_BaseRangeReader) {
  _inherits(PDFNodeStreamRangeReader, _BaseRangeReader);

  function PDFNodeStreamRangeReader(stream, start, end) {
    var _this4;

    _classCallCheck(this, PDFNodeStreamRangeReader);

    _this4 = _possibleConstructorReturn(this, _getPrototypeOf(PDFNodeStreamRangeReader).call(this, stream));
    _this4._httpHeaders = {};

    for (var property in stream.httpHeaders) {
      var value = stream.httpHeaders[property];

      if (typeof value === 'undefined') {
        continue;
      }

      _this4._httpHeaders[property] = value;
    }

    _this4._httpHeaders['Range'] = "bytes=".concat(start, "-").concat(end - 1);

    var handleResponse = function handleResponse(response) {
      if (response.statusCode === 404) {
        var error = new _util.MissingPDFException("Missing PDF \"".concat(_this4._url, "\"."));
        _this4._storedError = error;
        return;
      }

      _this4._setReadableStream(response);
    };

    _this4._request = null;

    if (_this4._url.protocol === 'http:') {
      _this4._request = http.request(createRequestOptions(_this4._url, _this4._httpHeaders), handleResponse);
    } else {
      _this4._request = https.request(createRequestOptions(_this4._url, _this4._httpHeaders), handleResponse);
    }

    _this4._request.on('error', function (reason) {
      _this4._storedError = reason;
    });

    _this4._request.end();

    return _this4;
  }

  return PDFNodeStreamRangeReader;
}(BaseRangeReader);

var PDFNodeStreamFsFullReader =
/*#__PURE__*/
function (_BaseFullReader2) {
  _inherits(PDFNodeStreamFsFullReader, _BaseFullReader2);

  function PDFNodeStreamFsFullReader(stream) {
    var _this5;

    _classCallCheck(this, PDFNodeStreamFsFullReader);

    _this5 = _possibleConstructorReturn(this, _getPrototypeOf(PDFNodeStreamFsFullReader).call(this, stream));
    var path = decodeURIComponent(_this5._url.path);

    if (fileUriRegex.test(_this5._url.href)) {
      path = path.replace(/^\//, '');
    }

    fs.lstat(path, function (error, stat) {
      if (error) {
        if (error.code === 'ENOENT') {
          error = new _util.MissingPDFException("Missing PDF \"".concat(path, "\"."));
        }

        _this5._storedError = error;

        _this5._headersCapability.reject(error);

        return;
      }

      _this5._contentLength = stat.size;

      _this5._setReadableStream(fs.createReadStream(path));

      _this5._headersCapability.resolve();
    });
    return _this5;
  }

  return PDFNodeStreamFsFullReader;
}(BaseFullReader);

var PDFNodeStreamFsRangeReader =
/*#__PURE__*/
function (_BaseRangeReader2) {
  _inherits(PDFNodeStreamFsRangeReader, _BaseRangeReader2);

  function PDFNodeStreamFsRangeReader(stream, start, end) {
    var _this6;

    _classCallCheck(this, PDFNodeStreamFsRangeReader);

    _this6 = _possibleConstructorReturn(this, _getPrototypeOf(PDFNodeStreamFsRangeReader).call(this, stream));
    var path = decodeURIComponent(_this6._url.path);

    if (fileUriRegex.test(_this6._url.href)) {
      path = path.replace(/^\//, '');
    }

    _this6._setReadableStream(fs.createReadStream(path, {
      start: start,
      end: end - 1
    }));

    return _this6;
  }

  return PDFNodeStreamFsRangeReader;
}(BaseRangeReader);

/***/ }),
/* 166 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createResponseStatusError = createResponseStatusError;
exports.extractFilenameFromHeader = extractFilenameFromHeader;
exports.validateRangeRequestCapabilities = validateRangeRequestCapabilities;
exports.validateResponseStatus = validateResponseStatus;

var _util = __w_pdfjs_require__(1);

var _content_disposition = __w_pdfjs_require__(167);

function validateRangeRequestCapabilities(_ref) {
  var getResponseHeader = _ref.getResponseHeader,
      isHttp = _ref.isHttp,
      rangeChunkSize = _ref.rangeChunkSize,
      disableRange = _ref.disableRange;
  (0, _util.assert)(rangeChunkSize > 0, 'Range chunk size must be larger than zero');
  var returnValues = {
    allowRangeRequests: false,
    suggestedLength: undefined
  };
  var length = parseInt(getResponseHeader('Content-Length'), 10);

  if (!Number.isInteger(length)) {
    return returnValues;
  }

  returnValues.suggestedLength = length;

  if (length <= 2 * rangeChunkSize) {
    return returnValues;
  }

  if (disableRange || !isHttp) {
    return returnValues;
  }

  if (getResponseHeader('Accept-Ranges') !== 'bytes') {
    return returnValues;
  }

  var contentEncoding = getResponseHeader('Content-Encoding') || 'identity';

  if (contentEncoding !== 'identity') {
    return returnValues;
  }

  returnValues.allowRangeRequests = true;
  return returnValues;
}

function extractFilenameFromHeader(getResponseHeader) {
  var contentDisposition = getResponseHeader('Content-Disposition');

  if (contentDisposition) {
    var filename = (0, _content_disposition.getFilenameFromContentDispositionHeader)(contentDisposition);

    if (/\.pdf$/i.test(filename)) {
      return filename;
    }
  }

  return null;
}

function createResponseStatusError(status, url) {
  if (status === 404 || status === 0 && /^file:/.test(url)) {
    return new _util.MissingPDFException('Missing PDF "' + url + '".');
  }

  return new _util.UnexpectedResponseException('Unexpected server response (' + status + ') while retrieving PDF "' + url + '".', status);
}

function validateResponseStatus(status) {
  return status === 200 || status === 206;
}

/***/ }),
/* 167 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFilenameFromContentDispositionHeader = getFilenameFromContentDispositionHeader;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getFilenameFromContentDispositionHeader(contentDisposition) {
  var needsEncodingFixup = true;
  var tmp = toParamRegExp('filename\\*', 'i').exec(contentDisposition);

  if (tmp) {
    tmp = tmp[1];
    var filename = rfc2616unquote(tmp);
    filename = unescape(filename);
    filename = rfc5987decode(filename);
    filename = rfc2047decode(filename);
    return fixupEncoding(filename);
  }

  tmp = rfc2231getparam(contentDisposition);

  if (tmp) {
    var _filename = rfc2047decode(tmp);

    return fixupEncoding(_filename);
  }

  tmp = toParamRegExp('filename', 'i').exec(contentDisposition);

  if (tmp) {
    tmp = tmp[1];

    var _filename2 = rfc2616unquote(tmp);

    _filename2 = rfc2047decode(_filename2);
    return fixupEncoding(_filename2);
  }

  function toParamRegExp(attributePattern, flags) {
    return new RegExp('(?:^|;)\\s*' + attributePattern + '\\s*=\\s*' + '(' + '[^";\\s][^;\\s]*' + '|' + '"(?:[^"\\\\]|\\\\"?)+"?' + ')', flags);
  }

  function textdecode(encoding, value) {
    if (encoding) {
      if (!/^[\x00-\xFF]+$/.test(value)) {
        return value;
      }

      try {
        var decoder = new TextDecoder(encoding, {
          fatal: true
        });
        var bytes = Array.from(value, function (ch) {
          return ch.charCodeAt(0) & 0xFF;
        });
        value = decoder.decode(new Uint8Array(bytes));
        needsEncodingFixup = false;
      } catch (e) {
        if (/^utf-?8$/i.test(encoding)) {
          try {
            value = decodeURIComponent(escape(value));
            needsEncodingFixup = false;
          } catch (err) {}
        }
      }
    }

    return value;
  }

  function fixupEncoding(value) {
    if (needsEncodingFixup && /[\x80-\xff]/.test(value)) {
      value = textdecode('utf-8', value);

      if (needsEncodingFixup) {
        value = textdecode('iso-8859-1', value);
      }
    }

    return value;
  }

  function rfc2231getparam(contentDisposition) {
    var matches = [],
        match;
    var iter = toParamRegExp('filename\\*((?!0\\d)\\d+)(\\*?)', 'ig');

    while ((match = iter.exec(contentDisposition)) !== null) {
      var _match = match,
          _match2 = _slicedToArray(_match, 4),
          n = _match2[1],
          quot = _match2[2],
          part = _match2[3];

      n = parseInt(n, 10);

      if (n in matches) {
        if (n === 0) {
          break;
        }

        continue;
      }

      matches[n] = [quot, part];
    }

    var parts = [];

    for (var n = 0; n < matches.length; ++n) {
      if (!(n in matches)) {
        break;
      }

      var _matches$n = _slicedToArray(matches[n], 2),
          quot = _matches$n[0],
          part = _matches$n[1];

      part = rfc2616unquote(part);

      if (quot) {
        part = unescape(part);

        if (n === 0) {
          part = rfc5987decode(part);
        }
      }

      parts.push(part);
    }

    return parts.join('');
  }

  function rfc2616unquote(value) {
    if (value.startsWith('"')) {
      var parts = value.slice(1).split('\\"');

      for (var i = 0; i < parts.length; ++i) {
        var quotindex = parts[i].indexOf('"');

        if (quotindex !== -1) {
          parts[i] = parts[i].slice(0, quotindex);
          parts.length = i + 1;
        }

        parts[i] = parts[i].replace(/\\(.)/g, '$1');
      }

      value = parts.join('"');
    }

    return value;
  }

  function rfc5987decode(extvalue) {
    var encodingend = extvalue.indexOf('\'');

    if (encodingend === -1) {
      return extvalue;
    }

    var encoding = extvalue.slice(0, encodingend);
    var langvalue = extvalue.slice(encodingend + 1);
    var value = langvalue.replace(/^[^']*'/, '');
    return textdecode(encoding, value);
  }

  function rfc2047decode(value) {
    if (!value.startsWith('=?') || /[\x00-\x19\x80-\xff]/.test(value)) {
      return value;
    }

    return value.replace(/=\?([\w-]*)\?([QqBb])\?((?:[^?]|\?(?!=))*)\?=/g, function (_, charset, encoding, text) {
      if (encoding === 'q' || encoding === 'Q') {
        text = text.replace(/_/g, ' ');
        text = text.replace(/=([0-9a-fA-F]{2})/g, function (_, hex) {
          return String.fromCharCode(parseInt(hex, 16));
        });
        return textdecode(charset, text);
      }

      try {
        text = atob(text);
      } catch (e) {}

      return textdecode(charset, text);
    });
  }

  return '';
}

/***/ }),
/* 168 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFFetchStream = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(147));

var _util = __w_pdfjs_require__(1);

var _network_utils = __w_pdfjs_require__(166);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function createFetchOptions(headers, withCredentials, abortController) {
  return {
    method: 'GET',
    headers: headers,
    signal: abortController && abortController.signal,
    mode: 'cors',
    credentials: withCredentials ? 'include' : 'same-origin',
    redirect: 'follow'
  };
}

var PDFFetchStream =
/*#__PURE__*/
function () {
  function PDFFetchStream(source) {
    _classCallCheck(this, PDFFetchStream);

    this.source = source;
    this.isHttp = /^https?:/i.test(source.url);
    this.httpHeaders = this.isHttp && source.httpHeaders || {};
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }

  _createClass(PDFFetchStream, [{
    key: "getFullReader",
    value: function getFullReader() {
      (0, _util.assert)(!this._fullRequestReader);
      this._fullRequestReader = new PDFFetchStreamReader(this);
      return this._fullRequestReader;
    }
  }, {
    key: "getRangeReader",
    value: function getRangeReader(begin, end) {
      var reader = new PDFFetchStreamRangeReader(this, begin, end);

      this._rangeRequestReaders.push(reader);

      return reader;
    }
  }, {
    key: "cancelAllRequests",
    value: function cancelAllRequests(reason) {
      if (this._fullRequestReader) {
        this._fullRequestReader.cancel(reason);
      }

      var readers = this._rangeRequestReaders.slice(0);

      readers.forEach(function (reader) {
        reader.cancel(reason);
      });
    }
  }]);

  return PDFFetchStream;
}();

exports.PDFFetchStream = PDFFetchStream;

var PDFFetchStreamReader =
/*#__PURE__*/
function () {
  function PDFFetchStreamReader(stream) {
    var _this = this;

    _classCallCheck(this, PDFFetchStreamReader);

    this._stream = stream;
    this._reader = null;
    this._loaded = 0;
    this._filename = null;
    var source = stream.source;
    this._withCredentials = source.withCredentials;
    this._contentLength = source.length;
    this._headersCapability = (0, _util.createPromiseCapability)();
    this._disableRange = source.disableRange || false;
    this._rangeChunkSize = source.rangeChunkSize;

    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }

    if (typeof AbortController !== 'undefined') {
      this._abortController = new AbortController();
    }

    this._isStreamingSupported = !source.disableStream;
    this._isRangeSupported = !source.disableRange;
    this._headers = new Headers();

    for (var property in this._stream.httpHeaders) {
      var value = this._stream.httpHeaders[property];

      if (typeof value === 'undefined') {
        continue;
      }

      this._headers.append(property, value);
    }

    var url = source.url;
    fetch(url, createFetchOptions(this._headers, this._withCredentials, this._abortController)).then(function (response) {
      if (!(0, _network_utils.validateResponseStatus)(response.status)) {
        throw (0, _network_utils.createResponseStatusError)(response.status, url);
      }

      _this._reader = response.body.getReader();

      _this._headersCapability.resolve();

      var getResponseHeader = function getResponseHeader(name) {
        return response.headers.get(name);
      };

      var _validateRangeRequest = (0, _network_utils.validateRangeRequestCapabilities)({
        getResponseHeader: getResponseHeader,
        isHttp: _this._stream.isHttp,
        rangeChunkSize: _this._rangeChunkSize,
        disableRange: _this._disableRange
      }),
          allowRangeRequests = _validateRangeRequest.allowRangeRequests,
          suggestedLength = _validateRangeRequest.suggestedLength;

      _this._isRangeSupported = allowRangeRequests;
      _this._contentLength = suggestedLength || _this._contentLength;
      _this._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);

      if (!_this._isStreamingSupported && _this._isRangeSupported) {
        _this.cancel(new _util.AbortException('streaming is disabled'));
      }
    }).catch(this._headersCapability.reject);
    this.onProgress = null;
  }

  _createClass(PDFFetchStreamReader, [{
    key: "read",
    value: function () {
      var _read = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _ref, value, done, buffer;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._headersCapability.promise;

              case 2:
                _context.next = 4;
                return this._reader.read();

              case 4:
                _ref = _context.sent;
                value = _ref.value;
                done = _ref.done;

                if (!done) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt("return", {
                  value: value,
                  done: done
                });

              case 9:
                this._loaded += value.byteLength;

                if (this.onProgress) {
                  this.onProgress({
                    loaded: this._loaded,
                    total: this._contentLength
                  });
                }

                buffer = new Uint8Array(value).buffer;
                return _context.abrupt("return", {
                  value: buffer,
                  done: false
                });

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function read() {
        return _read.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      if (this._reader) {
        this._reader.cancel(reason);
      }

      if (this._abortController) {
        this._abortController.abort();
      }
    }
  }, {
    key: "headersReady",
    get: function get() {
      return this._headersCapability.promise;
    }
  }, {
    key: "filename",
    get: function get() {
      return this._filename;
    }
  }, {
    key: "contentLength",
    get: function get() {
      return this._contentLength;
    }
  }, {
    key: "isRangeSupported",
    get: function get() {
      return this._isRangeSupported;
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }]);

  return PDFFetchStreamReader;
}();

var PDFFetchStreamRangeReader =
/*#__PURE__*/
function () {
  function PDFFetchStreamRangeReader(stream, begin, end) {
    var _this2 = this;

    _classCallCheck(this, PDFFetchStreamRangeReader);

    this._stream = stream;
    this._reader = null;
    this._loaded = 0;
    var source = stream.source;
    this._withCredentials = source.withCredentials;
    this._readCapability = (0, _util.createPromiseCapability)();
    this._isStreamingSupported = !source.disableStream;

    if (typeof AbortController !== 'undefined') {
      this._abortController = new AbortController();
    }

    this._headers = new Headers();

    for (var property in this._stream.httpHeaders) {
      var value = this._stream.httpHeaders[property];

      if (typeof value === 'undefined') {
        continue;
      }

      this._headers.append(property, value);
    }

    var rangeStr = begin + '-' + (end - 1);

    this._headers.append('Range', 'bytes=' + rangeStr);

    var url = source.url;
    fetch(url, createFetchOptions(this._headers, this._withCredentials, this._abortController)).then(function (response) {
      if (!(0, _network_utils.validateResponseStatus)(response.status)) {
        throw (0, _network_utils.createResponseStatusError)(response.status, url);
      }

      _this2._readCapability.resolve();

      _this2._reader = response.body.getReader();
    });
    this.onProgress = null;
  }

  _createClass(PDFFetchStreamRangeReader, [{
    key: "read",
    value: function () {
      var _read2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _ref2, value, done, buffer;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._readCapability.promise;

              case 2:
                _context2.next = 4;
                return this._reader.read();

              case 4:
                _ref2 = _context2.sent;
                value = _ref2.value;
                done = _ref2.done;

                if (!done) {
                  _context2.next = 9;
                  break;
                }

                return _context2.abrupt("return", {
                  value: value,
                  done: done
                });

              case 9:
                this._loaded += value.byteLength;

                if (this.onProgress) {
                  this.onProgress({
                    loaded: this._loaded
                  });
                }

                buffer = new Uint8Array(value).buffer;
                return _context2.abrupt("return", {
                  value: buffer,
                  done: false
                });

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read() {
        return _read2.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      if (this._reader) {
        this._reader.cancel(reason);
      }

      if (this._abortController) {
        this._abortController.abort();
      }
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }]);

  return PDFFetchStreamRangeReader;
}();

/***/ }),
/* 169 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFNetworkStream = PDFNetworkStream;
exports.NetworkManager = NetworkManager;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(147));

var _util = __w_pdfjs_require__(1);

var _network_utils = __w_pdfjs_require__(166);

var _global_scope = _interopRequireDefault(__w_pdfjs_require__(3));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

;
var OK_RESPONSE = 200;
var PARTIAL_CONTENT_RESPONSE = 206;

function NetworkManager(url, args) {
  this.url = url;
  args = args || {};
  this.isHttp = /^https?:/i.test(url);
  this.httpHeaders = this.isHttp && args.httpHeaders || {};
  this.withCredentials = args.withCredentials || false;

  this.getXhr = args.getXhr || function NetworkManager_getXhr() {
    return new XMLHttpRequest();
  };

  this.currXhrId = 0;
  this.pendingRequests = Object.create(null);
  this.loadedRequests = Object.create(null);
}

function getArrayBuffer(xhr) {
  var data = xhr.response;

  if (typeof data !== 'string') {
    return data;
  }

  var array = (0, _util.stringToBytes)(data);
  return array.buffer;
}

var supportsMozChunked = function supportsMozChunkedClosure() {
  try {
    var x = new XMLHttpRequest();
    x.open('GET', _global_scope.default.location.href);
    x.responseType = 'moz-chunked-arraybuffer';
    return x.responseType === 'moz-chunked-arraybuffer';
  } catch (e) {
    return false;
  }
}();

NetworkManager.prototype = {
  requestRange: function NetworkManager_requestRange(begin, end, listeners) {
    var args = {
      begin: begin,
      end: end
    };

    for (var prop in listeners) {
      args[prop] = listeners[prop];
    }

    return this.request(args);
  },
  requestFull: function NetworkManager_requestFull(listeners) {
    return this.request(listeners);
  },
  request: function NetworkManager_request(args) {
    var xhr = this.getXhr();
    var xhrId = this.currXhrId++;
    var pendingRequest = this.pendingRequests[xhrId] = {
      xhr: xhr
    };
    xhr.open('GET', this.url);
    xhr.withCredentials = this.withCredentials;

    for (var property in this.httpHeaders) {
      var value = this.httpHeaders[property];

      if (typeof value === 'undefined') {
        continue;
      }

      xhr.setRequestHeader(property, value);
    }

    if (this.isHttp && 'begin' in args && 'end' in args) {
      var rangeStr = args.begin + '-' + (args.end - 1);
      xhr.setRequestHeader('Range', 'bytes=' + rangeStr);
      pendingRequest.expectedStatus = 206;
    } else {
      pendingRequest.expectedStatus = 200;
    }

    var useMozChunkedLoading = supportsMozChunked && !!args.onProgressiveData;

    if (useMozChunkedLoading) {
      xhr.responseType = 'moz-chunked-arraybuffer';
      pendingRequest.onProgressiveData = args.onProgressiveData;
      pendingRequest.mozChunked = true;
    } else {
      xhr.responseType = 'arraybuffer';
    }

    if (args.onError) {
      xhr.onerror = function (evt) {
        args.onError(xhr.status);
      };
    }

    xhr.onreadystatechange = this.onStateChange.bind(this, xhrId);
    xhr.onprogress = this.onProgress.bind(this, xhrId);
    pendingRequest.onHeadersReceived = args.onHeadersReceived;
    pendingRequest.onDone = args.onDone;
    pendingRequest.onError = args.onError;
    pendingRequest.onProgress = args.onProgress;
    xhr.send(null);
    return xhrId;
  },
  onProgress: function NetworkManager_onProgress(xhrId, evt) {
    var pendingRequest = this.pendingRequests[xhrId];

    if (!pendingRequest) {
      return;
    }

    if (pendingRequest.mozChunked) {
      var chunk = getArrayBuffer(pendingRequest.xhr);
      pendingRequest.onProgressiveData(chunk);
    }

    var onProgress = pendingRequest.onProgress;

    if (onProgress) {
      onProgress(evt);
    }
  },
  onStateChange: function NetworkManager_onStateChange(xhrId, evt) {
    var pendingRequest = this.pendingRequests[xhrId];

    if (!pendingRequest) {
      return;
    }

    var xhr = pendingRequest.xhr;

    if (xhr.readyState >= 2 && pendingRequest.onHeadersReceived) {
      pendingRequest.onHeadersReceived();
      delete pendingRequest.onHeadersReceived;
    }

    if (xhr.readyState !== 4) {
      return;
    }

    if (!(xhrId in this.pendingRequests)) {
      return;
    }

    delete this.pendingRequests[xhrId];

    if (xhr.status === 0 && this.isHttp) {
      if (pendingRequest.onError) {
        pendingRequest.onError(xhr.status);
      }

      return;
    }

    var xhrStatus = xhr.status || OK_RESPONSE;
    var ok_response_on_range_request = xhrStatus === OK_RESPONSE && pendingRequest.expectedStatus === PARTIAL_CONTENT_RESPONSE;

    if (!ok_response_on_range_request && xhrStatus !== pendingRequest.expectedStatus) {
      if (pendingRequest.onError) {
        pendingRequest.onError(xhr.status);
      }

      return;
    }

    this.loadedRequests[xhrId] = true;
    var chunk = getArrayBuffer(xhr);

    if (xhrStatus === PARTIAL_CONTENT_RESPONSE) {
      var rangeHeader = xhr.getResponseHeader('Content-Range');
      var matches = /bytes (\d+)-(\d+)\/(\d+)/.exec(rangeHeader);
      var begin = parseInt(matches[1], 10);
      pendingRequest.onDone({
        begin: begin,
        chunk: chunk
      });
    } else if (pendingRequest.onProgressiveData) {
      pendingRequest.onDone(null);
    } else if (chunk) {
      pendingRequest.onDone({
        begin: 0,
        chunk: chunk
      });
    } else if (pendingRequest.onError) {
      pendingRequest.onError(xhr.status);
    }
  },
  hasPendingRequests: function NetworkManager_hasPendingRequests() {
    for (var xhrId in this.pendingRequests) {
      return true;
    }

    return false;
  },
  getRequestXhr: function NetworkManager_getXhr(xhrId) {
    return this.pendingRequests[xhrId].xhr;
  },
  isStreamingRequest: function NetworkManager_isStreamingRequest(xhrId) {
    return !!this.pendingRequests[xhrId].onProgressiveData;
  },
  isPendingRequest: function NetworkManager_isPendingRequest(xhrId) {
    return xhrId in this.pendingRequests;
  },
  isLoadedRequest: function NetworkManager_isLoadedRequest(xhrId) {
    return xhrId in this.loadedRequests;
  },
  abortAllRequests: function NetworkManager_abortAllRequests() {
    for (var xhrId in this.pendingRequests) {
      this.abortRequest(xhrId | 0);
    }
  },
  abortRequest: function NetworkManager_abortRequest(xhrId) {
    var xhr = this.pendingRequests[xhrId].xhr;
    delete this.pendingRequests[xhrId];
    xhr.abort();
  }
};

function PDFNetworkStream(source) {
  this._source = source;
  this._manager = new NetworkManager(source.url, {
    httpHeaders: source.httpHeaders,
    withCredentials: source.withCredentials
  });
  this._rangeChunkSize = source.rangeChunkSize;
  this._fullRequestReader = null;
  this._rangeRequestReaders = [];
}

PDFNetworkStream.prototype = {
  _onRangeRequestReaderClosed: function PDFNetworkStream_onRangeRequestReaderClosed(reader) {
    var i = this._rangeRequestReaders.indexOf(reader);

    if (i >= 0) {
      this._rangeRequestReaders.splice(i, 1);
    }
  },
  getFullReader: function PDFNetworkStream_getFullReader() {
    (0, _util.assert)(!this._fullRequestReader);
    this._fullRequestReader = new PDFNetworkStreamFullRequestReader(this._manager, this._source);
    return this._fullRequestReader;
  },
  getRangeReader: function PDFNetworkStream_getRangeReader(begin, end) {
    var reader = new PDFNetworkStreamRangeRequestReader(this._manager, begin, end);
    reader.onClosed = this._onRangeRequestReaderClosed.bind(this);

    this._rangeRequestReaders.push(reader);

    return reader;
  },
  cancelAllRequests: function PDFNetworkStream_cancelAllRequests(reason) {
    if (this._fullRequestReader) {
      this._fullRequestReader.cancel(reason);
    }

    var readers = this._rangeRequestReaders.slice(0);

    readers.forEach(function (reader) {
      reader.cancel(reason);
    });
  }
};

function PDFNetworkStreamFullRequestReader(manager, source) {
  this._manager = manager;
  var args = {
    onHeadersReceived: this._onHeadersReceived.bind(this),
    onProgressiveData: source.disableStream ? null : this._onProgressiveData.bind(this),
    onDone: this._onDone.bind(this),
    onError: this._onError.bind(this),
    onProgress: this._onProgress.bind(this)
  };
  this._url = source.url;
  this._fullRequestId = manager.requestFull(args);
  this._headersReceivedCapability = (0, _util.createPromiseCapability)();
  this._disableRange = source.disableRange || false;
  this._contentLength = source.length;
  this._rangeChunkSize = source.rangeChunkSize;

  if (!this._rangeChunkSize && !this._disableRange) {
    this._disableRange = true;
  }

  this._isStreamingSupported = false;
  this._isRangeSupported = false;
  this._cachedChunks = [];
  this._requests = [];
  this._done = false;
  this._storedError = undefined;
  this._filename = null;
  this.onProgress = null;
}

PDFNetworkStreamFullRequestReader.prototype = {
  _onHeadersReceived: function PDFNetworkStreamFullRequestReader_onHeadersReceived() {
    var fullRequestXhrId = this._fullRequestId;

    var fullRequestXhr = this._manager.getRequestXhr(fullRequestXhrId);

    var getResponseHeader = function getResponseHeader(name) {
      return fullRequestXhr.getResponseHeader(name);
    };

    var _validateRangeRequest = (0, _network_utils.validateRangeRequestCapabilities)({
      getResponseHeader: getResponseHeader,
      isHttp: this._manager.isHttp,
      rangeChunkSize: this._rangeChunkSize,
      disableRange: this._disableRange
    }),
        allowRangeRequests = _validateRangeRequest.allowRangeRequests,
        suggestedLength = _validateRangeRequest.suggestedLength;

    if (allowRangeRequests) {
      this._isRangeSupported = true;
    }

    this._contentLength = suggestedLength || this._contentLength;
    this._filename = (0, _network_utils.extractFilenameFromHeader)(getResponseHeader);
    var networkManager = this._manager;

    if (networkManager.isStreamingRequest(fullRequestXhrId)) {
      this._isStreamingSupported = true;
    } else if (this._isRangeSupported) {
      networkManager.abortRequest(fullRequestXhrId);
    }

    this._headersReceivedCapability.resolve();
  },
  _onProgressiveData: function PDFNetworkStreamFullRequestReader_onProgressiveData(chunk) {
    if (this._requests.length > 0) {
      var requestCapability = this._requests.shift();

      requestCapability.resolve({
        value: chunk,
        done: false
      });
    } else {
      this._cachedChunks.push(chunk);
    }
  },
  _onDone: function PDFNetworkStreamFullRequestReader_onDone(args) {
    if (args) {
      this._onProgressiveData(args.chunk);
    }

    this._done = true;

    if (this._cachedChunks.length > 0) {
      return;
    }

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];
  },
  _onError: function PDFNetworkStreamFullRequestReader_onError(status) {
    var url = this._url;
    var exception = (0, _network_utils.createResponseStatusError)(status, url);
    this._storedError = exception;

    this._headersReceivedCapability.reject(exception);

    this._requests.forEach(function (requestCapability) {
      requestCapability.reject(exception);
    });

    this._requests = [];
    this._cachedChunks = [];
  },
  _onProgress: function PDFNetworkStreamFullRequestReader_onProgress(data) {
    if (this.onProgress) {
      this.onProgress({
        loaded: data.loaded,
        total: data.lengthComputable ? data.total : this._contentLength
      });
    }
  },

  get filename() {
    return this._filename;
  },

  get isRangeSupported() {
    return this._isRangeSupported;
  },

  get isStreamingSupported() {
    return this._isStreamingSupported;
  },

  get contentLength() {
    return this._contentLength;
  },

  get headersReady() {
    return this._headersReceivedCapability.promise;
  },

  read: function () {
    var _read = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      var chunk, requestCapability;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!this._storedError) {
                _context.next = 2;
                break;
              }

              throw this._storedError;

            case 2:
              if (!(this._cachedChunks.length > 0)) {
                _context.next = 5;
                break;
              }

              chunk = this._cachedChunks.shift();
              return _context.abrupt("return", {
                value: chunk,
                done: false
              });

            case 5:
              if (!this._done) {
                _context.next = 7;
                break;
              }

              return _context.abrupt("return", {
                value: undefined,
                done: true
              });

            case 7:
              requestCapability = (0, _util.createPromiseCapability)();

              this._requests.push(requestCapability);

              return _context.abrupt("return", requestCapability.promise);

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function read() {
      return _read.apply(this, arguments);
    }

    return read;
  }(),
  cancel: function PDFNetworkStreamFullRequestReader_cancel(reason) {
    this._done = true;

    this._headersReceivedCapability.reject(reason);

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];

    if (this._manager.isPendingRequest(this._fullRequestId)) {
      this._manager.abortRequest(this._fullRequestId);
    }

    this._fullRequestReader = null;
  }
};

function PDFNetworkStreamRangeRequestReader(manager, begin, end) {
  this._manager = manager;
  var args = {
    onDone: this._onDone.bind(this),
    onProgress: this._onProgress.bind(this)
  };
  this._requestId = manager.requestRange(begin, end, args);
  this._requests = [];
  this._queuedChunk = null;
  this._done = false;
  this.onProgress = null;
  this.onClosed = null;
}

PDFNetworkStreamRangeRequestReader.prototype = {
  _close: function PDFNetworkStreamRangeRequestReader_close() {
    if (this.onClosed) {
      this.onClosed(this);
    }
  },
  _onDone: function PDFNetworkStreamRangeRequestReader_onDone(data) {
    var chunk = data.chunk;

    if (this._requests.length > 0) {
      var requestCapability = this._requests.shift();

      requestCapability.resolve({
        value: chunk,
        done: false
      });
    } else {
      this._queuedChunk = chunk;
    }

    this._done = true;

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];

    this._close();
  },
  _onProgress: function PDFNetworkStreamRangeRequestReader_onProgress(evt) {
    if (!this.isStreamingSupported && this.onProgress) {
      this.onProgress({
        loaded: evt.loaded
      });
    }
  },

  get isStreamingSupported() {
    return false;
  },

  read: function () {
    var _read2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2() {
      var chunk, requestCapability;
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(this._queuedChunk !== null)) {
                _context2.next = 4;
                break;
              }

              chunk = this._queuedChunk;
              this._queuedChunk = null;
              return _context2.abrupt("return", {
                value: chunk,
                done: false
              });

            case 4:
              if (!this._done) {
                _context2.next = 6;
                break;
              }

              return _context2.abrupt("return", {
                value: undefined,
                done: true
              });

            case 6:
              requestCapability = (0, _util.createPromiseCapability)();

              this._requests.push(requestCapability);

              return _context2.abrupt("return", requestCapability.promise);

            case 9:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function read() {
      return _read2.apply(this, arguments);
    }

    return read;
  }(),
  cancel: function PDFNetworkStreamRangeRequestReader_cancel(reason) {
    this._done = true;

    this._requests.forEach(function (requestCapability) {
      requestCapability.resolve({
        value: undefined,
        done: true
      });
    });

    this._requests = [];

    if (this._manager.isPendingRequest(this._requestId)) {
      this._manager.abortRequest(this._requestId);
    }

    this._close();
  }
};

/***/ })
/******/ ]);
});
//# sourceMappingURL=pdf.js.map
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(139).Buffer, __webpack_require__(103), __webpack_require__(306)))

/***/ }),
/* 761 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer, global, process) {/**
 * @licstart The following is the entire license notice for the
 * Javascript code in this page
 *
 * Copyright 2018 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * Javascript code in this page
 */

(function webpackUniversalModuleDefinition(root, factory) {
	if(true)
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("pdfjs-dist/build/pdf.worker", [], factory);
	else if(typeof exports === 'object')
		exports["pdfjs-dist/build/pdf.worker"] = factory();
	else
		root["pdfjs-dist/build/pdf.worker"] = root.pdfjsWorker = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __w_pdfjs_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __w_pdfjs_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__w_pdfjs_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__w_pdfjs_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__w_pdfjs_require__.d = function(exports, name, getter) {
/******/ 		if(!__w_pdfjs_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__w_pdfjs_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__w_pdfjs_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __w_pdfjs_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__w_pdfjs_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __w_pdfjs_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__w_pdfjs_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__w_pdfjs_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__w_pdfjs_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__w_pdfjs_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __w_pdfjs_require__(__w_pdfjs_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var pdfjsVersion = '2.1.266';
var pdfjsBuild = '81f5835c';

var pdfjsCoreWorker = __w_pdfjs_require__(1);

exports.WorkerMessageHandler = pdfjsCoreWorker.WorkerMessageHandler;

/***/ }),
/* 1 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WorkerMessageHandler = exports.WorkerTask = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(2));

var _util = __w_pdfjs_require__(6);

var _pdf_manager = __w_pdfjs_require__(151);

var _is_node = _interopRequireDefault(__w_pdfjs_require__(9));

var _message_handler = __w_pdfjs_require__(189);

var _primitives = __w_pdfjs_require__(155);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var WorkerTask = function WorkerTaskClosure() {
  function WorkerTask(name) {
    this.name = name;
    this.terminated = false;
    this._capability = (0, _util.createPromiseCapability)();
  }

  WorkerTask.prototype = {
    get finished() {
      return this._capability.promise;
    },

    finish: function finish() {
      this._capability.resolve();
    },
    terminate: function terminate() {
      this.terminated = true;
    },
    ensureNotTerminated: function ensureNotTerminated() {
      if (this.terminated) {
        throw new Error('Worker task was terminated');
      }
    }
  };
  return WorkerTask;
}();

exports.WorkerTask = WorkerTask;

var PDFWorkerStream = function PDFWorkerStreamClosure() {
  function PDFWorkerStream(msgHandler) {
    this._msgHandler = msgHandler;
    this._contentLength = null;
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }

  PDFWorkerStream.prototype = {
    getFullReader: function getFullReader() {
      (0, _util.assert)(!this._fullRequestReader);
      this._fullRequestReader = new PDFWorkerStreamReader(this._msgHandler);
      return this._fullRequestReader;
    },
    getRangeReader: function getRangeReader(begin, end) {
      var reader = new PDFWorkerStreamRangeReader(begin, end, this._msgHandler);

      this._rangeRequestReaders.push(reader);

      return reader;
    },
    cancelAllRequests: function cancelAllRequests(reason) {
      if (this._fullRequestReader) {
        this._fullRequestReader.cancel(reason);
      }

      var readers = this._rangeRequestReaders.slice(0);

      readers.forEach(function (reader) {
        reader.cancel(reason);
      });
    }
  };

  function PDFWorkerStreamReader(msgHandler) {
    var _this = this;

    this._msgHandler = msgHandler;
    this._contentLength = null;
    this._isRangeSupported = false;
    this._isStreamingSupported = false;

    var readableStream = this._msgHandler.sendWithStream('GetReader');

    this._reader = readableStream.getReader();
    this._headersReady = this._msgHandler.sendWithPromise('ReaderHeadersReady').then(function (data) {
      _this._isStreamingSupported = data.isStreamingSupported;
      _this._isRangeSupported = data.isRangeSupported;
      _this._contentLength = data.contentLength;
    });
  }

  PDFWorkerStreamReader.prototype = {
    get headersReady() {
      return this._headersReady;
    },

    get contentLength() {
      return this._contentLength;
    },

    get isStreamingSupported() {
      return this._isStreamingSupported;
    },

    get isRangeSupported() {
      return this._isRangeSupported;
    },

    read: function read() {
      return this._reader.read().then(function (_ref) {
        var value = _ref.value,
            done = _ref.done;

        if (done) {
          return {
            value: undefined,
            done: true
          };
        }

        return {
          value: value.buffer,
          done: false
        };
      });
    },
    cancel: function cancel(reason) {
      this._reader.cancel(reason);
    }
  };

  function PDFWorkerStreamRangeReader(begin, end, msgHandler) {
    this._msgHandler = msgHandler;
    this.onProgress = null;

    var readableStream = this._msgHandler.sendWithStream('GetRangeReader', {
      begin: begin,
      end: end
    });

    this._reader = readableStream.getReader();
  }

  PDFWorkerStreamRangeReader.prototype = {
    get isStreamingSupported() {
      return false;
    },

    read: function read() {
      return this._reader.read().then(function (_ref2) {
        var value = _ref2.value,
            done = _ref2.done;

        if (done) {
          return {
            value: undefined,
            done: true
          };
        }

        return {
          value: value.buffer,
          done: false
        };
      });
    },
    cancel: function cancel(reason) {
      this._reader.cancel(reason);
    }
  };
  return PDFWorkerStream;
}();

var WorkerMessageHandler = {
  setup: function setup(handler, port) {
    var testMessageProcessed = false;
    handler.on('test', function wphSetupTest(data) {
      if (testMessageProcessed) {
        return;
      }

      testMessageProcessed = true;

      if (!(data instanceof Uint8Array)) {
        handler.send('test', false);
        return;
      }

      var supportTransfers = data[0] === 255;
      handler.postMessageTransfers = supportTransfers;
      var xhr = new XMLHttpRequest();
      var responseExists = 'response' in xhr;

      try {
        xhr.responseType;
      } catch (e) {
        responseExists = false;
      }

      if (!responseExists) {
        handler.send('test', false);
        return;
      }

      handler.send('test', {
        supportTypedArray: true,
        supportTransfers: supportTransfers
      });
    });
    handler.on('configure', function wphConfigure(data) {
      (0, _util.setVerbosityLevel)(data.verbosity);
    });
    handler.on('GetDocRequest', function wphSetupDoc(data) {
      return WorkerMessageHandler.createDocumentHandler(data, port);
    });
  },
  createDocumentHandler: function createDocumentHandler(docParams, port) {
    var pdfManager;
    var terminated = false;
    var cancelXHRs = null;
    var WorkerTasks = [];
    var apiVersion = docParams.apiVersion;
    var workerVersion = '2.1.266';

    if (apiVersion !== workerVersion) {
      throw new Error("The API version \"".concat(apiVersion, "\" does not match ") + "the Worker version \"".concat(workerVersion, "\"."));
    }

    var docId = docParams.docId;
    var docBaseUrl = docParams.docBaseUrl;
    var workerHandlerName = docParams.docId + '_worker';
    var handler = new _message_handler.MessageHandler(workerHandlerName, docId, port);
    handler.postMessageTransfers = docParams.postMessageTransfers;

    function ensureNotTerminated() {
      if (terminated) {
        throw new Error('Worker was terminated');
      }
    }

    function startWorkerTask(task) {
      WorkerTasks.push(task);
    }

    function finishWorkerTask(task) {
      task.finish();
      var i = WorkerTasks.indexOf(task);
      WorkerTasks.splice(i, 1);
    }

    function loadDocument(_x) {
      return _loadDocument.apply(this, arguments);
    }

    function _loadDocument() {
      _loadDocument = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(recoveryMode) {
        var _ref6, _ref7, numPages, fingerprint;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return pdfManager.ensureDoc('checkHeader');

              case 2:
                _context.next = 4;
                return pdfManager.ensureDoc('parseStartXRef');

              case 4:
                _context.next = 6;
                return pdfManager.ensureDoc('parse', [recoveryMode]);

              case 6:
                if (recoveryMode) {
                  _context.next = 9;
                  break;
                }

                _context.next = 9;
                return pdfManager.ensureDoc('checkFirstPage');

              case 9:
                _context.next = 11;
                return Promise.all([pdfManager.ensureDoc('numPages'), pdfManager.ensureDoc('fingerprint')]);

              case 11:
                _ref6 = _context.sent;
                _ref7 = _slicedToArray(_ref6, 2);
                numPages = _ref7[0];
                fingerprint = _ref7[1];
                return _context.abrupt("return", {
                  numPages: numPages,
                  fingerprint: fingerprint
                });

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
      return _loadDocument.apply(this, arguments);
    }

    function getPdfManager(data, evaluatorOptions) {
      var pdfManagerCapability = (0, _util.createPromiseCapability)();
      var pdfManager;
      var source = data.source;

      if (source.data) {
        try {
          pdfManager = new _pdf_manager.LocalPdfManager(docId, source.data, source.password, evaluatorOptions, docBaseUrl);
          pdfManagerCapability.resolve(pdfManager);
        } catch (ex) {
          pdfManagerCapability.reject(ex);
        }

        return pdfManagerCapability.promise;
      }

      var pdfStream,
          cachedChunks = [];

      try {
        pdfStream = new PDFWorkerStream(handler);
      } catch (ex) {
        pdfManagerCapability.reject(ex);
        return pdfManagerCapability.promise;
      }

      var fullRequest = pdfStream.getFullReader();
      fullRequest.headersReady.then(function () {
        if (!fullRequest.isRangeSupported) {
          return;
        }

        var disableAutoFetch = source.disableAutoFetch || fullRequest.isStreamingSupported;
        pdfManager = new _pdf_manager.NetworkPdfManager(docId, pdfStream, {
          msgHandler: handler,
          password: source.password,
          length: fullRequest.contentLength,
          disableAutoFetch: disableAutoFetch,
          rangeChunkSize: source.rangeChunkSize
        }, evaluatorOptions, docBaseUrl);

        for (var i = 0; i < cachedChunks.length; i++) {
          pdfManager.sendProgressiveData(cachedChunks[i]);
        }

        cachedChunks = [];
        pdfManagerCapability.resolve(pdfManager);
        cancelXHRs = null;
      }).catch(function (reason) {
        pdfManagerCapability.reject(reason);
        cancelXHRs = null;
      });
      var loaded = 0;

      var flushChunks = function flushChunks() {
        var pdfFile = (0, _util.arraysToBytes)(cachedChunks);

        if (source.length && pdfFile.length !== source.length) {
          (0, _util.warn)('reported HTTP length is different from actual');
        }

        try {
          pdfManager = new _pdf_manager.LocalPdfManager(docId, pdfFile, source.password, evaluatorOptions, docBaseUrl);
          pdfManagerCapability.resolve(pdfManager);
        } catch (ex) {
          pdfManagerCapability.reject(ex);
        }

        cachedChunks = [];
      };

      var readPromise = new Promise(function (resolve, reject) {
        var readChunk = function readChunk(chunk) {
          try {
            ensureNotTerminated();

            if (chunk.done) {
              if (!pdfManager) {
                flushChunks();
              }

              cancelXHRs = null;
              return;
            }

            var data = chunk.value;
            loaded += (0, _util.arrayByteLength)(data);

            if (!fullRequest.isStreamingSupported) {
              handler.send('DocProgress', {
                loaded: loaded,
                total: Math.max(loaded, fullRequest.contentLength || 0)
              });
            }

            if (pdfManager) {
              pdfManager.sendProgressiveData(data);
            } else {
              cachedChunks.push(data);
            }

            fullRequest.read().then(readChunk, reject);
          } catch (e) {
            reject(e);
          }
        };

        fullRequest.read().then(readChunk, reject);
      });
      readPromise.catch(function (e) {
        pdfManagerCapability.reject(e);
        cancelXHRs = null;
      });

      cancelXHRs = function cancelXHRs() {
        pdfStream.cancelAllRequests('abort');
      };

      return pdfManagerCapability.promise;
    }

    function setupDoc(data) {
      function onSuccess(doc) {
        ensureNotTerminated();
        handler.send('GetDoc', {
          pdfInfo: doc
        });
      }

      function onFailure(e) {
        ensureNotTerminated();

        if (e instanceof _util.PasswordException) {
          var task = new WorkerTask('PasswordException: response ' + e.code);
          startWorkerTask(task);
          handler.sendWithPromise('PasswordRequest', e).then(function (data) {
            finishWorkerTask(task);
            pdfManager.updatePassword(data.password);
            pdfManagerReady();
          }).catch(function (boundException) {
            finishWorkerTask(task);
            handler.send('PasswordException', boundException);
          }.bind(null, e));
        } else if (e instanceof _util.InvalidPDFException) {
          handler.send('InvalidPDF', e);
        } else if (e instanceof _util.MissingPDFException) {
          handler.send('MissingPDF', e);
        } else if (e instanceof _util.UnexpectedResponseException) {
          handler.send('UnexpectedResponse', e);
        } else {
          handler.send('UnknownError', new _util.UnknownErrorException(e.message, e.toString()));
        }
      }

      function pdfManagerReady() {
        ensureNotTerminated();
        loadDocument(false).then(onSuccess, function loadFailure(ex) {
          ensureNotTerminated();

          if (!(ex instanceof _util.XRefParseException)) {
            onFailure(ex);
            return;
          }

          pdfManager.requestLoadedStream();
          pdfManager.onLoadedStream().then(function () {
            ensureNotTerminated();
            loadDocument(true).then(onSuccess, onFailure);
          });
        }, onFailure);
      }

      ensureNotTerminated();
      var evaluatorOptions = {
        forceDataSchema: data.disableCreateObjectURL,
        maxImageSize: data.maxImageSize,
        disableFontFace: data.disableFontFace,
        nativeImageDecoderSupport: data.nativeImageDecoderSupport,
        ignoreErrors: data.ignoreErrors,
        isEvalSupported: data.isEvalSupported
      };
      getPdfManager(data, evaluatorOptions).then(function (newPdfManager) {
        if (terminated) {
          newPdfManager.terminate();
          throw new Error('Worker was terminated');
        }

        pdfManager = newPdfManager;
        pdfManager.onLoadedStream().then(function (stream) {
          handler.send('DataLoaded', {
            length: stream.bytes.byteLength
          });
        });
      }).then(pdfManagerReady, onFailure);
    }

    handler.on('GetPage', function wphSetupGetPage(data) {
      return pdfManager.getPage(data.pageIndex).then(function (page) {
        return Promise.all([pdfManager.ensure(page, 'rotate'), pdfManager.ensure(page, 'ref'), pdfManager.ensure(page, 'userUnit'), pdfManager.ensure(page, 'view')]).then(function (_ref3) {
          var _ref4 = _slicedToArray(_ref3, 4),
              rotate = _ref4[0],
              ref = _ref4[1],
              userUnit = _ref4[2],
              view = _ref4[3];

          return {
            rotate: rotate,
            ref: ref,
            userUnit: userUnit,
            view: view
          };
        });
      });
    });
    handler.on('GetPageIndex', function wphSetupGetPageIndex(data) {
      var ref = new _primitives.Ref(data.ref.num, data.ref.gen);
      var catalog = pdfManager.pdfDocument.catalog;
      return catalog.getPageIndex(ref);
    });
    handler.on('GetDestinations', function wphSetupGetDestinations(data) {
      return pdfManager.ensureCatalog('destinations');
    });
    handler.on('GetDestination', function wphSetupGetDestination(data) {
      return pdfManager.ensureCatalog('getDestination', [data.id]);
    });
    handler.on('GetPageLabels', function wphSetupGetPageLabels(data) {
      return pdfManager.ensureCatalog('pageLabels');
    });
    handler.on('GetPageMode', function wphSetupGetPageMode(data) {
      return pdfManager.ensureCatalog('pageMode');
    });
    handler.on('getOpenActionDestination', function (data) {
      return pdfManager.ensureCatalog('openActionDestination');
    });
    handler.on('GetAttachments', function wphSetupGetAttachments(data) {
      return pdfManager.ensureCatalog('attachments');
    });
    handler.on('GetJavaScript', function wphSetupGetJavaScript(data) {
      return pdfManager.ensureCatalog('javaScript');
    });
    handler.on('GetOutline', function wphSetupGetOutline(data) {
      return pdfManager.ensureCatalog('documentOutline');
    });
    handler.on('GetPermissions', function (data) {
      return pdfManager.ensureCatalog('permissions');
    });
    handler.on('GetMetadata', function wphSetupGetMetadata(data) {
      return Promise.all([pdfManager.ensureDoc('documentInfo'), pdfManager.ensureCatalog('metadata')]);
    });
    handler.on('GetData', function wphSetupGetData(data) {
      pdfManager.requestLoadedStream();
      return pdfManager.onLoadedStream().then(function (stream) {
        return stream.bytes;
      });
    });
    handler.on('GetStats', function wphSetupGetStats(data) {
      return pdfManager.pdfDocument.xref.stats;
    });
    handler.on('GetAnnotations', function (_ref5) {
      var pageIndex = _ref5.pageIndex,
          intent = _ref5.intent;
      return pdfManager.getPage(pageIndex).then(function (page) {
        return page.getAnnotationsData(intent);
      });
    });
    handler.on('RenderPageRequest', function wphSetupRenderPage(data) {
      var pageIndex = data.pageIndex;
      pdfManager.getPage(pageIndex).then(function (page) {
        var task = new WorkerTask('RenderPageRequest: page ' + pageIndex);
        startWorkerTask(task);
        var pageNum = pageIndex + 1;
        var start = Date.now();
        page.getOperatorList({
          handler: handler,
          task: task,
          intent: data.intent,
          renderInteractiveForms: data.renderInteractiveForms
        }).then(function (operatorList) {
          finishWorkerTask(task);
          (0, _util.info)('page=' + pageNum + ' - getOperatorList: time=' + (Date.now() - start) + 'ms, len=' + operatorList.totalLength);
        }, function (e) {
          finishWorkerTask(task);

          if (task.terminated) {
            return;
          }

          handler.send('UnsupportedFeature', {
            featureId: _util.UNSUPPORTED_FEATURES.unknown
          });
          var minimumStackMessage = 'worker.js: while trying to getPage() and getOperatorList()';
          var wrappedException;

          if (typeof e === 'string') {
            wrappedException = {
              message: e,
              stack: minimumStackMessage
            };
          } else if (_typeof(e) === 'object') {
            wrappedException = {
              message: e.message || e.toString(),
              stack: e.stack || minimumStackMessage
            };
          } else {
            wrappedException = {
              message: 'Unknown exception type: ' + _typeof(e),
              stack: minimumStackMessage
            };
          }

          handler.send('PageError', {
            pageNum: pageNum,
            error: wrappedException,
            intent: data.intent
          });
        });
      });
    }, this);
    handler.on('GetTextContent', function wphExtractText(data, sink) {
      var pageIndex = data.pageIndex;

      sink.onPull = function (desiredSize) {};

      sink.onCancel = function (reason) {};

      pdfManager.getPage(pageIndex).then(function (page) {
        var task = new WorkerTask('GetTextContent: page ' + pageIndex);
        startWorkerTask(task);
        var pageNum = pageIndex + 1;
        var start = Date.now();
        page.extractTextContent({
          handler: handler,
          task: task,
          sink: sink,
          normalizeWhitespace: data.normalizeWhitespace,
          combineTextItems: data.combineTextItems
        }).then(function () {
          finishWorkerTask(task);
          (0, _util.info)('text indexing: page=' + pageNum + ' - time=' + (Date.now() - start) + 'ms');
          sink.close();
        }, function (reason) {
          finishWorkerTask(task);

          if (task.terminated) {
            return;
          }

          sink.error(reason);
          throw reason;
        });
      });
    });
    handler.on('FontFallback', function (data) {
      return pdfManager.fontFallback(data.id, handler);
    });
    handler.on('Cleanup', function wphCleanup(data) {
      return pdfManager.cleanup();
    });
    handler.on('Terminate', function wphTerminate(data) {
      terminated = true;

      if (pdfManager) {
        pdfManager.terminate();
        pdfManager = null;
      }

      if (cancelXHRs) {
        cancelXHRs();
      }

      var waitOn = [];
      WorkerTasks.forEach(function (task) {
        waitOn.push(task.finished);
        task.terminate();
      });
      return Promise.all(waitOn).then(function () {
        handler.destroy();
        handler = null;
      });
    });
    handler.on('Ready', function wphReady(data) {
      setupDoc(docParams);
      docParams = null;
    });
    return workerHandlerName;
  },
  initializeFromPort: function initializeFromPort(port) {
    var handler = new _message_handler.MessageHandler('worker', 'main', port);
    WorkerMessageHandler.setup(handler, port);
    handler.send('ready', null);
  }
};
exports.WorkerMessageHandler = WorkerMessageHandler;

function isMessagePort(maybePort) {
  return typeof maybePort.postMessage === 'function' && 'onmessage' in maybePort;
}

if (typeof window === 'undefined' && !(0, _is_node.default)() && typeof self !== 'undefined' && isMessagePort(self)) {
  WorkerMessageHandler.initializeFromPort(self);
}

/***/ }),
/* 2 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = __w_pdfjs_require__(3);

/***/ }),
/* 3 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var g = function () {
  return this || (typeof self === "undefined" ? "undefined" : _typeof(self)) === "object" && self;
}() || Function("return this")();

var hadRuntime = g.regeneratorRuntime && Object.getOwnPropertyNames(g).indexOf("regeneratorRuntime") >= 0;
var oldRuntime = hadRuntime && g.regeneratorRuntime;
g.regeneratorRuntime = undefined;
module.exports = __w_pdfjs_require__(4);

if (hadRuntime) {
  g.regeneratorRuntime = oldRuntime;
} else {
  try {
    delete g.regeneratorRuntime;
  } catch (e) {
    g.regeneratorRuntime = undefined;
  }
}

/***/ }),
/* 4 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(module) {

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

!function (global) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined;
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  var inModule = ( false ? undefined : _typeof(module)) === "object";
  var runtime = global.regeneratorRuntime;

  if (runtime) {
    if (inModule) {
      module.exports = runtime;
    }

    return;
  }

  runtime = global.regeneratorRuntime = inModule ? module.exports : {};

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);
    generator._invoke = makeInvokeMethod(innerFn, self, context);
    return generator;
  }

  runtime.wrap = wrap;

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};

  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

  if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      prototype[method] = function (arg) {
        return this._invoke(method, arg);
      };
    });
  }

  runtime.isGeneratorFunction = function (genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
  };

  runtime.mark = function (genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;

      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }

    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  runtime.awrap = function (arg) {
    return {
      __await: arg
    };
  };

  function AsyncIterator(generator) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;

        if (value && _typeof(value) === "object" && hasOwn.call(value, "__await")) {
          return Promise.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return Promise.resolve(value).then(function (unwrapped) {
          result.value = unwrapped;
          resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new Promise(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    }

    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);

  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };

  runtime.AsyncIterator = AsyncIterator;

  runtime.async = function (innerFn, outerFn, self, tryLocsList) {
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
    return runtime.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;
    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;

        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);

          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          context.sent = context._sent = context.arg;
        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);
        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;
        var record = tryCatch(innerFn, self, context);

        if (record.type === "normal") {
          state = context.done ? GenStateCompleted : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };
        } else if (record.type === "throw") {
          state = GenStateCompleted;
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (method === undefined) {
      context.delegate = null;

      if (context.method === "throw") {
        if (delegate.iterator.return) {
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (!info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      context[delegate.resultName] = info.value;
      context.next = delegate.nextLoc;

      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }
    } else {
      return info;
    }

    context.delegate = null;
    return ContinueSentinel;
  }

  defineIteratorMethods(Gp);
  Gp[toStringTagSymbol] = "Generator";

  Gp[iteratorSymbol] = function () {
    return this;
  };

  Gp.toString = function () {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  runtime.keys = function (object) {
    var keys = [];

    for (var key in object) {
      keys.push(key);
    }

    keys.reverse();
    return function next() {
      while (keys.length) {
        var key = keys.pop();

        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];

      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;
          return next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  runtime.values = values;

  function doneResult() {
    return {
      value: undefined,
      done: true
    };
  }

  Context.prototype = {
    constructor: Context,
    reset: function reset(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;
      this.method = "next";
      this.arg = undefined;
      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },
    stop: function stop() {
      this.done = true;
      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;

      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },
    dispatchException: function dispatchException(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;

      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          context.method = "next";
          context.arg = undefined;
        }

        return !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }
          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },
    abrupt: function abrupt(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },
    complete: function complete(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" || record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },
    finish: function finish(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },
    "catch": function _catch(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };
}(function () {
  return this || (typeof self === "undefined" ? "undefined" : _typeof(self)) === "object" && self;
}() || Function("return this")());
/* WEBPACK VAR INJECTION */}.call(this, __w_pdfjs_require__(5)(module)))

/***/ }),
/* 5 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (module) {
  if (!module.webpackPolyfill) {
    module.deprecate = function () {};

    module.paths = [];
    if (!module.children) module.children = [];
    Object.defineProperty(module, "loaded", {
      enumerable: true,
      get: function get() {
        return module.l;
      }
    });
    Object.defineProperty(module, "id", {
      enumerable: true,
      get: function get() {
        return module.i;
      }
    });
    module.webpackPolyfill = 1;
  }

  return module;
};

/***/ }),
/* 6 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toRomanNumerals = toRomanNumerals;
exports.arrayByteLength = arrayByteLength;
exports.arraysToBytes = arraysToBytes;
exports.assert = assert;
exports.bytesToString = bytesToString;
exports.createPromiseCapability = createPromiseCapability;
exports.deprecated = deprecated;
exports.getInheritableProperty = getInheritableProperty;
exports.getLookupTableFactory = getLookupTableFactory;
exports.getVerbosityLevel = getVerbosityLevel;
exports.info = info;
exports.isArrayBuffer = isArrayBuffer;
exports.isBool = isBool;
exports.isEmptyObj = isEmptyObj;
exports.isNum = isNum;
exports.isString = isString;
exports.isSpace = isSpace;
exports.isSameOrigin = isSameOrigin;
exports.createValidAbsoluteUrl = createValidAbsoluteUrl;
exports.isLittleEndian = isLittleEndian;
exports.isEvalSupported = isEvalSupported;
exports.log2 = log2;
exports.readInt8 = readInt8;
exports.readUint16 = readUint16;
exports.readUint32 = readUint32;
exports.removeNullCharacters = removeNullCharacters;
exports.setVerbosityLevel = setVerbosityLevel;
exports.shadow = shadow;
exports.string32 = string32;
exports.stringToBytes = stringToBytes;
exports.stringToPDFString = stringToPDFString;
exports.stringToUTF8String = stringToUTF8String;
exports.utf8StringToString = utf8StringToString;
exports.warn = warn;
exports.unreachable = unreachable;
Object.defineProperty(exports, "ReadableStream", {
  enumerable: true,
  get: function get() {
    return _streams_polyfill.ReadableStream;
  }
});
Object.defineProperty(exports, "URL", {
  enumerable: true,
  get: function get() {
    return _url_polyfill.URL;
  }
});
exports.createObjectURL = exports.FormatError = exports.XRefParseException = exports.XRefEntryException = exports.Util = exports.UnknownErrorException = exports.UnexpectedResponseException = exports.TextRenderingMode = exports.StreamType = exports.PermissionFlag = exports.PasswordResponses = exports.PasswordException = exports.NativeImageDecoding = exports.MissingPDFException = exports.MissingDataException = exports.InvalidPDFException = exports.AbortException = exports.CMapCompressionType = exports.ImageKind = exports.FontType = exports.AnnotationType = exports.AnnotationFlag = exports.AnnotationFieldFlag = exports.AnnotationBorderStyleType = exports.UNSUPPORTED_FEATURES = exports.VerbosityLevel = exports.OPS = exports.IDENTITY_MATRIX = exports.FONT_IDENTITY_MATRIX = void 0;

__w_pdfjs_require__(7);

var _streams_polyfill = __w_pdfjs_require__(147);

var _url_polyfill = __w_pdfjs_require__(149);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var IDENTITY_MATRIX = [1, 0, 0, 1, 0, 0];
exports.IDENTITY_MATRIX = IDENTITY_MATRIX;
var FONT_IDENTITY_MATRIX = [0.001, 0, 0, 0.001, 0, 0];
exports.FONT_IDENTITY_MATRIX = FONT_IDENTITY_MATRIX;
var NativeImageDecoding = {
  NONE: 'none',
  DECODE: 'decode',
  DISPLAY: 'display'
};
exports.NativeImageDecoding = NativeImageDecoding;
var PermissionFlag = {
  PRINT: 0x04,
  MODIFY_CONTENTS: 0x08,
  COPY: 0x10,
  MODIFY_ANNOTATIONS: 0x20,
  FILL_INTERACTIVE_FORMS: 0x100,
  COPY_FOR_ACCESSIBILITY: 0x200,
  ASSEMBLE: 0x400,
  PRINT_HIGH_QUALITY: 0x800
};
exports.PermissionFlag = PermissionFlag;
var TextRenderingMode = {
  FILL: 0,
  STROKE: 1,
  FILL_STROKE: 2,
  INVISIBLE: 3,
  FILL_ADD_TO_PATH: 4,
  STROKE_ADD_TO_PATH: 5,
  FILL_STROKE_ADD_TO_PATH: 6,
  ADD_TO_PATH: 7,
  FILL_STROKE_MASK: 3,
  ADD_TO_PATH_FLAG: 4
};
exports.TextRenderingMode = TextRenderingMode;
var ImageKind = {
  GRAYSCALE_1BPP: 1,
  RGB_24BPP: 2,
  RGBA_32BPP: 3
};
exports.ImageKind = ImageKind;
var AnnotationType = {
  TEXT: 1,
  LINK: 2,
  FREETEXT: 3,
  LINE: 4,
  SQUARE: 5,
  CIRCLE: 6,
  POLYGON: 7,
  POLYLINE: 8,
  HIGHLIGHT: 9,
  UNDERLINE: 10,
  SQUIGGLY: 11,
  STRIKEOUT: 12,
  STAMP: 13,
  CARET: 14,
  INK: 15,
  POPUP: 16,
  FILEATTACHMENT: 17,
  SOUND: 18,
  MOVIE: 19,
  WIDGET: 20,
  SCREEN: 21,
  PRINTERMARK: 22,
  TRAPNET: 23,
  WATERMARK: 24,
  THREED: 25,
  REDACT: 26
};
exports.AnnotationType = AnnotationType;
var AnnotationFlag = {
  INVISIBLE: 0x01,
  HIDDEN: 0x02,
  PRINT: 0x04,
  NOZOOM: 0x08,
  NOROTATE: 0x10,
  NOVIEW: 0x20,
  READONLY: 0x40,
  LOCKED: 0x80,
  TOGGLENOVIEW: 0x100,
  LOCKEDCONTENTS: 0x200
};
exports.AnnotationFlag = AnnotationFlag;
var AnnotationFieldFlag = {
  READONLY: 0x0000001,
  REQUIRED: 0x0000002,
  NOEXPORT: 0x0000004,
  MULTILINE: 0x0001000,
  PASSWORD: 0x0002000,
  NOTOGGLETOOFF: 0x0004000,
  RADIO: 0x0008000,
  PUSHBUTTON: 0x0010000,
  COMBO: 0x0020000,
  EDIT: 0x0040000,
  SORT: 0x0080000,
  FILESELECT: 0x0100000,
  MULTISELECT: 0x0200000,
  DONOTSPELLCHECK: 0x0400000,
  DONOTSCROLL: 0x0800000,
  COMB: 0x1000000,
  RICHTEXT: 0x2000000,
  RADIOSINUNISON: 0x2000000,
  COMMITONSELCHANGE: 0x4000000
};
exports.AnnotationFieldFlag = AnnotationFieldFlag;
var AnnotationBorderStyleType = {
  SOLID: 1,
  DASHED: 2,
  BEVELED: 3,
  INSET: 4,
  UNDERLINE: 5
};
exports.AnnotationBorderStyleType = AnnotationBorderStyleType;
var StreamType = {
  UNKNOWN: 0,
  FLATE: 1,
  LZW: 2,
  DCT: 3,
  JPX: 4,
  JBIG: 5,
  A85: 6,
  AHX: 7,
  CCF: 8,
  RL: 9
};
exports.StreamType = StreamType;
var FontType = {
  UNKNOWN: 0,
  TYPE1: 1,
  TYPE1C: 2,
  CIDFONTTYPE0: 3,
  CIDFONTTYPE0C: 4,
  TRUETYPE: 5,
  CIDFONTTYPE2: 6,
  TYPE3: 7,
  OPENTYPE: 8,
  TYPE0: 9,
  MMTYPE1: 10
};
exports.FontType = FontType;
var VerbosityLevel = {
  ERRORS: 0,
  WARNINGS: 1,
  INFOS: 5
};
exports.VerbosityLevel = VerbosityLevel;
var CMapCompressionType = {
  NONE: 0,
  BINARY: 1,
  STREAM: 2
};
exports.CMapCompressionType = CMapCompressionType;
var OPS = {
  dependency: 1,
  setLineWidth: 2,
  setLineCap: 3,
  setLineJoin: 4,
  setMiterLimit: 5,
  setDash: 6,
  setRenderingIntent: 7,
  setFlatness: 8,
  setGState: 9,
  save: 10,
  restore: 11,
  transform: 12,
  moveTo: 13,
  lineTo: 14,
  curveTo: 15,
  curveTo2: 16,
  curveTo3: 17,
  closePath: 18,
  rectangle: 19,
  stroke: 20,
  closeStroke: 21,
  fill: 22,
  eoFill: 23,
  fillStroke: 24,
  eoFillStroke: 25,
  closeFillStroke: 26,
  closeEOFillStroke: 27,
  endPath: 28,
  clip: 29,
  eoClip: 30,
  beginText: 31,
  endText: 32,
  setCharSpacing: 33,
  setWordSpacing: 34,
  setHScale: 35,
  setLeading: 36,
  setFont: 37,
  setTextRenderingMode: 38,
  setTextRise: 39,
  moveText: 40,
  setLeadingMoveText: 41,
  setTextMatrix: 42,
  nextLine: 43,
  showText: 44,
  showSpacedText: 45,
  nextLineShowText: 46,
  nextLineSetSpacingShowText: 47,
  setCharWidth: 48,
  setCharWidthAndBounds: 49,
  setStrokeColorSpace: 50,
  setFillColorSpace: 51,
  setStrokeColor: 52,
  setStrokeColorN: 53,
  setFillColor: 54,
  setFillColorN: 55,
  setStrokeGray: 56,
  setFillGray: 57,
  setStrokeRGBColor: 58,
  setFillRGBColor: 59,
  setStrokeCMYKColor: 60,
  setFillCMYKColor: 61,
  shadingFill: 62,
  beginInlineImage: 63,
  beginImageData: 64,
  endInlineImage: 65,
  paintXObject: 66,
  markPoint: 67,
  markPointProps: 68,
  beginMarkedContent: 69,
  beginMarkedContentProps: 70,
  endMarkedContent: 71,
  beginCompat: 72,
  endCompat: 73,
  paintFormXObjectBegin: 74,
  paintFormXObjectEnd: 75,
  beginGroup: 76,
  endGroup: 77,
  beginAnnotations: 78,
  endAnnotations: 79,
  beginAnnotation: 80,
  endAnnotation: 81,
  paintJpegXObject: 82,
  paintImageMaskXObject: 83,
  paintImageMaskXObjectGroup: 84,
  paintImageXObject: 85,
  paintInlineImageXObject: 86,
  paintInlineImageXObjectGroup: 87,
  paintImageXObjectRepeat: 88,
  paintImageMaskXObjectRepeat: 89,
  paintSolidColorImageMask: 90,
  constructPath: 91
};
exports.OPS = OPS;
var UNSUPPORTED_FEATURES = {
  unknown: 'unknown',
  forms: 'forms',
  javaScript: 'javaScript',
  smask: 'smask',
  shadingPattern: 'shadingPattern',
  font: 'font'
};
exports.UNSUPPORTED_FEATURES = UNSUPPORTED_FEATURES;
var PasswordResponses = {
  NEED_PASSWORD: 1,
  INCORRECT_PASSWORD: 2
};
exports.PasswordResponses = PasswordResponses;
var verbosity = VerbosityLevel.WARNINGS;

function setVerbosityLevel(level) {
  if (Number.isInteger(level)) {
    verbosity = level;
  }
}

function getVerbosityLevel() {
  return verbosity;
}

function info(msg) {
  if (verbosity >= VerbosityLevel.INFOS) {
    console.log('Info: ' + msg);
  }
}

function warn(msg) {
  if (verbosity >= VerbosityLevel.WARNINGS) {
    console.log('Warning: ' + msg);
  }
}

function deprecated(details) {
  console.log('Deprecated API usage: ' + details);
}

function unreachable(msg) {
  throw new Error(msg);
}

function assert(cond, msg) {
  if (!cond) {
    unreachable(msg);
  }
}

function isSameOrigin(baseUrl, otherUrl) {
  try {
    var base = new _url_polyfill.URL(baseUrl);

    if (!base.origin || base.origin === 'null') {
      return false;
    }
  } catch (e) {
    return false;
  }

  var other = new _url_polyfill.URL(otherUrl, base);
  return base.origin === other.origin;
}

function _isValidProtocol(url) {
  if (!url) {
    return false;
  }

  switch (url.protocol) {
    case 'http:':
    case 'https:':
    case 'ftp:':
    case 'mailto:':
    case 'tel:':
      return true;

    default:
      return false;
  }
}

function createValidAbsoluteUrl(url, baseUrl) {
  if (!url) {
    return null;
  }

  try {
    var absoluteUrl = baseUrl ? new _url_polyfill.URL(url, baseUrl) : new _url_polyfill.URL(url);

    if (_isValidProtocol(absoluteUrl)) {
      return absoluteUrl;
    }
  } catch (ex) {}

  return null;
}

function shadow(obj, prop, value) {
  Object.defineProperty(obj, prop, {
    value: value,
    enumerable: true,
    configurable: true,
    writable: false
  });
  return value;
}

function getLookupTableFactory(initializer) {
  var lookup;
  return function () {
    if (initializer) {
      lookup = Object.create(null);
      initializer(lookup);
      initializer = null;
    }

    return lookup;
  };
}

var PasswordException = function PasswordExceptionClosure() {
  function PasswordException(msg, code) {
    this.name = 'PasswordException';
    this.message = msg;
    this.code = code;
  }

  PasswordException.prototype = new Error();
  PasswordException.constructor = PasswordException;
  return PasswordException;
}();

exports.PasswordException = PasswordException;

var UnknownErrorException = function UnknownErrorExceptionClosure() {
  function UnknownErrorException(msg, details) {
    this.name = 'UnknownErrorException';
    this.message = msg;
    this.details = details;
  }

  UnknownErrorException.prototype = new Error();
  UnknownErrorException.constructor = UnknownErrorException;
  return UnknownErrorException;
}();

exports.UnknownErrorException = UnknownErrorException;

var InvalidPDFException = function InvalidPDFExceptionClosure() {
  function InvalidPDFException(msg) {
    this.name = 'InvalidPDFException';
    this.message = msg;
  }

  InvalidPDFException.prototype = new Error();
  InvalidPDFException.constructor = InvalidPDFException;
  return InvalidPDFException;
}();

exports.InvalidPDFException = InvalidPDFException;

var MissingPDFException = function MissingPDFExceptionClosure() {
  function MissingPDFException(msg) {
    this.name = 'MissingPDFException';
    this.message = msg;
  }

  MissingPDFException.prototype = new Error();
  MissingPDFException.constructor = MissingPDFException;
  return MissingPDFException;
}();

exports.MissingPDFException = MissingPDFException;

var UnexpectedResponseException = function UnexpectedResponseExceptionClosure() {
  function UnexpectedResponseException(msg, status) {
    this.name = 'UnexpectedResponseException';
    this.message = msg;
    this.status = status;
  }

  UnexpectedResponseException.prototype = new Error();
  UnexpectedResponseException.constructor = UnexpectedResponseException;
  return UnexpectedResponseException;
}();

exports.UnexpectedResponseException = UnexpectedResponseException;

var MissingDataException = function MissingDataExceptionClosure() {
  function MissingDataException(begin, end) {
    this.begin = begin;
    this.end = end;
    this.message = 'Missing data [' + begin + ', ' + end + ')';
  }

  MissingDataException.prototype = new Error();
  MissingDataException.prototype.name = 'MissingDataException';
  MissingDataException.constructor = MissingDataException;
  return MissingDataException;
}();

exports.MissingDataException = MissingDataException;

var XRefEntryException = function XRefEntryExceptionClosure() {
  function XRefEntryException(msg) {
    this.message = msg;
  }

  XRefEntryException.prototype = new Error();
  XRefEntryException.prototype.name = 'XRefEntryException';
  XRefEntryException.constructor = XRefEntryException;
  return XRefEntryException;
}();

exports.XRefEntryException = XRefEntryException;

var XRefParseException = function XRefParseExceptionClosure() {
  function XRefParseException(msg) {
    this.message = msg;
  }

  XRefParseException.prototype = new Error();
  XRefParseException.prototype.name = 'XRefParseException';
  XRefParseException.constructor = XRefParseException;
  return XRefParseException;
}();

exports.XRefParseException = XRefParseException;

var FormatError = function FormatErrorClosure() {
  function FormatError(msg) {
    this.message = msg;
  }

  FormatError.prototype = new Error();
  FormatError.prototype.name = 'FormatError';
  FormatError.constructor = FormatError;
  return FormatError;
}();

exports.FormatError = FormatError;

var AbortException = function AbortExceptionClosure() {
  function AbortException(msg) {
    this.name = 'AbortException';
    this.message = msg;
  }

  AbortException.prototype = new Error();
  AbortException.constructor = AbortException;
  return AbortException;
}();

exports.AbortException = AbortException;
var NullCharactersRegExp = /\x00/g;

function removeNullCharacters(str) {
  if (typeof str !== 'string') {
    warn('The argument for removeNullCharacters must be a string.');
    return str;
  }

  return str.replace(NullCharactersRegExp, '');
}

function bytesToString(bytes) {
  assert(bytes !== null && _typeof(bytes) === 'object' && bytes.length !== undefined, 'Invalid argument for bytesToString');
  var length = bytes.length;
  var MAX_ARGUMENT_COUNT = 8192;

  if (length < MAX_ARGUMENT_COUNT) {
    return String.fromCharCode.apply(null, bytes);
  }

  var strBuf = [];

  for (var i = 0; i < length; i += MAX_ARGUMENT_COUNT) {
    var chunkEnd = Math.min(i + MAX_ARGUMENT_COUNT, length);
    var chunk = bytes.subarray(i, chunkEnd);
    strBuf.push(String.fromCharCode.apply(null, chunk));
  }

  return strBuf.join('');
}

function stringToBytes(str) {
  assert(typeof str === 'string', 'Invalid argument for stringToBytes');
  var length = str.length;
  var bytes = new Uint8Array(length);

  for (var i = 0; i < length; ++i) {
    bytes[i] = str.charCodeAt(i) & 0xFF;
  }

  return bytes;
}

function arrayByteLength(arr) {
  if (arr.length !== undefined) {
    return arr.length;
  }

  assert(arr.byteLength !== undefined);
  return arr.byteLength;
}

function arraysToBytes(arr) {
  if (arr.length === 1 && arr[0] instanceof Uint8Array) {
    return arr[0];
  }

  var resultLength = 0;
  var i,
      ii = arr.length;
  var item, itemLength;

  for (i = 0; i < ii; i++) {
    item = arr[i];
    itemLength = arrayByteLength(item);
    resultLength += itemLength;
  }

  var pos = 0;
  var data = new Uint8Array(resultLength);

  for (i = 0; i < ii; i++) {
    item = arr[i];

    if (!(item instanceof Uint8Array)) {
      if (typeof item === 'string') {
        item = stringToBytes(item);
      } else {
        item = new Uint8Array(item);
      }
    }

    itemLength = item.byteLength;
    data.set(item, pos);
    pos += itemLength;
  }

  return data;
}

function string32(value) {
  return String.fromCharCode(value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff);
}

function log2(x) {
  if (x <= 0) {
    return 0;
  }

  return Math.ceil(Math.log2(x));
}

function readInt8(data, start) {
  return data[start] << 24 >> 24;
}

function readUint16(data, offset) {
  return data[offset] << 8 | data[offset + 1];
}

function readUint32(data, offset) {
  return (data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3]) >>> 0;
}

function isLittleEndian() {
  var buffer8 = new Uint8Array(4);
  buffer8[0] = 1;
  var view32 = new Uint32Array(buffer8.buffer, 0, 1);
  return view32[0] === 1;
}

function isEvalSupported() {
  try {
    new Function('');
    return true;
  } catch (e) {
    return false;
  }
}

function getInheritableProperty(_ref) {
  var dict = _ref.dict,
      key = _ref.key,
      _ref$getArray = _ref.getArray,
      getArray = _ref$getArray === void 0 ? false : _ref$getArray,
      _ref$stopWhenFound = _ref.stopWhenFound,
      stopWhenFound = _ref$stopWhenFound === void 0 ? true : _ref$stopWhenFound;
  var LOOP_LIMIT = 100;
  var loopCount = 0;
  var values;

  while (dict) {
    var value = getArray ? dict.getArray(key) : dict.get(key);

    if (value !== undefined) {
      if (stopWhenFound) {
        return value;
      }

      if (!values) {
        values = [];
      }

      values.push(value);
    }

    if (++loopCount > LOOP_LIMIT) {
      warn("getInheritableProperty: maximum loop count exceeded for \"".concat(key, "\""));
      break;
    }

    dict = dict.get('Parent');
  }

  return values;
}

var Util = function UtilClosure() {
  function Util() {}

  var rgbBuf = ['rgb(', 0, ',', 0, ',', 0, ')'];

  Util.makeCssRgb = function Util_makeCssRgb(r, g, b) {
    rgbBuf[1] = r;
    rgbBuf[3] = g;
    rgbBuf[5] = b;
    return rgbBuf.join('');
  };

  Util.transform = function Util_transform(m1, m2) {
    return [m1[0] * m2[0] + m1[2] * m2[1], m1[1] * m2[0] + m1[3] * m2[1], m1[0] * m2[2] + m1[2] * m2[3], m1[1] * m2[2] + m1[3] * m2[3], m1[0] * m2[4] + m1[2] * m2[5] + m1[4], m1[1] * m2[4] + m1[3] * m2[5] + m1[5]];
  };

  Util.applyTransform = function Util_applyTransform(p, m) {
    var xt = p[0] * m[0] + p[1] * m[2] + m[4];
    var yt = p[0] * m[1] + p[1] * m[3] + m[5];
    return [xt, yt];
  };

  Util.applyInverseTransform = function Util_applyInverseTransform(p, m) {
    var d = m[0] * m[3] - m[1] * m[2];
    var xt = (p[0] * m[3] - p[1] * m[2] + m[2] * m[5] - m[4] * m[3]) / d;
    var yt = (-p[0] * m[1] + p[1] * m[0] + m[4] * m[1] - m[5] * m[0]) / d;
    return [xt, yt];
  };

  Util.getAxialAlignedBoundingBox = function Util_getAxialAlignedBoundingBox(r, m) {
    var p1 = Util.applyTransform(r, m);
    var p2 = Util.applyTransform(r.slice(2, 4), m);
    var p3 = Util.applyTransform([r[0], r[3]], m);
    var p4 = Util.applyTransform([r[2], r[1]], m);
    return [Math.min(p1[0], p2[0], p3[0], p4[0]), Math.min(p1[1], p2[1], p3[1], p4[1]), Math.max(p1[0], p2[0], p3[0], p4[0]), Math.max(p1[1], p2[1], p3[1], p4[1])];
  };

  Util.inverseTransform = function Util_inverseTransform(m) {
    var d = m[0] * m[3] - m[1] * m[2];
    return [m[3] / d, -m[1] / d, -m[2] / d, m[0] / d, (m[2] * m[5] - m[4] * m[3]) / d, (m[4] * m[1] - m[5] * m[0]) / d];
  };

  Util.apply3dTransform = function Util_apply3dTransform(m, v) {
    return [m[0] * v[0] + m[1] * v[1] + m[2] * v[2], m[3] * v[0] + m[4] * v[1] + m[5] * v[2], m[6] * v[0] + m[7] * v[1] + m[8] * v[2]];
  };

  Util.singularValueDecompose2dScale = function Util_singularValueDecompose2dScale(m) {
    var transpose = [m[0], m[2], m[1], m[3]];
    var a = m[0] * transpose[0] + m[1] * transpose[2];
    var b = m[0] * transpose[1] + m[1] * transpose[3];
    var c = m[2] * transpose[0] + m[3] * transpose[2];
    var d = m[2] * transpose[1] + m[3] * transpose[3];
    var first = (a + d) / 2;
    var second = Math.sqrt((a + d) * (a + d) - 4 * (a * d - c * b)) / 2;
    var sx = first + second || 1;
    var sy = first - second || 1;
    return [Math.sqrt(sx), Math.sqrt(sy)];
  };

  Util.normalizeRect = function Util_normalizeRect(rect) {
    var r = rect.slice(0);

    if (rect[0] > rect[2]) {
      r[0] = rect[2];
      r[2] = rect[0];
    }

    if (rect[1] > rect[3]) {
      r[1] = rect[3];
      r[3] = rect[1];
    }

    return r;
  };

  Util.intersect = function Util_intersect(rect1, rect2) {
    function compare(a, b) {
      return a - b;
    }

    var orderedX = [rect1[0], rect1[2], rect2[0], rect2[2]].sort(compare),
        orderedY = [rect1[1], rect1[3], rect2[1], rect2[3]].sort(compare),
        result = [];
    rect1 = Util.normalizeRect(rect1);
    rect2 = Util.normalizeRect(rect2);

    if (orderedX[0] === rect1[0] && orderedX[1] === rect2[0] || orderedX[0] === rect2[0] && orderedX[1] === rect1[0]) {
      result[0] = orderedX[1];
      result[2] = orderedX[2];
    } else {
      return false;
    }

    if (orderedY[0] === rect1[1] && orderedY[1] === rect2[1] || orderedY[0] === rect2[1] && orderedY[1] === rect1[1]) {
      result[1] = orderedY[1];
      result[3] = orderedY[2];
    } else {
      return false;
    }

    return result;
  };

  return Util;
}();

exports.Util = Util;
var ROMAN_NUMBER_MAP = ['', 'C', 'CC', 'CCC', 'CD', 'D', 'DC', 'DCC', 'DCCC', 'CM', '', 'X', 'XX', 'XXX', 'XL', 'L', 'LX', 'LXX', 'LXXX', 'XC', '', 'I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX'];

function toRomanNumerals(number) {
  var lowerCase = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  assert(Number.isInteger(number) && number > 0, 'The number should be a positive integer.');
  var pos,
      romanBuf = [];

  while (number >= 1000) {
    number -= 1000;
    romanBuf.push('M');
  }

  pos = number / 100 | 0;
  number %= 100;
  romanBuf.push(ROMAN_NUMBER_MAP[pos]);
  pos = number / 10 | 0;
  number %= 10;
  romanBuf.push(ROMAN_NUMBER_MAP[10 + pos]);
  romanBuf.push(ROMAN_NUMBER_MAP[20 + number]);
  var romanStr = romanBuf.join('');
  return lowerCase ? romanStr.toLowerCase() : romanStr;
}

var PDFStringTranslateTable = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2D8, 0x2C7, 0x2C6, 0x2D9, 0x2DD, 0x2DB, 0x2DA, 0x2DC, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2022, 0x2020, 0x2021, 0x2026, 0x2014, 0x2013, 0x192, 0x2044, 0x2039, 0x203A, 0x2212, 0x2030, 0x201E, 0x201C, 0x201D, 0x2018, 0x2019, 0x201A, 0x2122, 0xFB01, 0xFB02, 0x141, 0x152, 0x160, 0x178, 0x17D, 0x131, 0x142, 0x153, 0x161, 0x17E, 0, 0x20AC];

function stringToPDFString(str) {
  var i,
      n = str.length,
      strBuf = [];

  if (str[0] === '\xFE' && str[1] === '\xFF') {
    for (i = 2; i < n; i += 2) {
      strBuf.push(String.fromCharCode(str.charCodeAt(i) << 8 | str.charCodeAt(i + 1)));
    }
  } else {
    for (i = 0; i < n; ++i) {
      var code = PDFStringTranslateTable[str.charCodeAt(i)];
      strBuf.push(code ? String.fromCharCode(code) : str.charAt(i));
    }
  }

  return strBuf.join('');
}

function stringToUTF8String(str) {
  return decodeURIComponent(escape(str));
}

function utf8StringToString(str) {
  return unescape(encodeURIComponent(str));
}

function isEmptyObj(obj) {
  for (var key in obj) {
    return false;
  }

  return true;
}

function isBool(v) {
  return typeof v === 'boolean';
}

function isNum(v) {
  return typeof v === 'number';
}

function isString(v) {
  return typeof v === 'string';
}

function isArrayBuffer(v) {
  return _typeof(v) === 'object' && v !== null && v.byteLength !== undefined;
}

function isSpace(ch) {
  return ch === 0x20 || ch === 0x09 || ch === 0x0D || ch === 0x0A;
}

function createPromiseCapability() {
  var capability = Object.create(null);
  var isSettled = false;
  Object.defineProperty(capability, 'settled', {
    get: function get() {
      return isSettled;
    }
  });
  capability.promise = new Promise(function (resolve, reject) {
    capability.resolve = function (data) {
      isSettled = true;
      resolve(data);
    };

    capability.reject = function (reason) {
      isSettled = true;
      reject(reason);
    };
  });
  return capability;
}

var createObjectURL = function createObjectURLClosure() {
  var digits = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
  return function createObjectURL(data, contentType) {
    var forceDataSchema = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    if (!forceDataSchema && _url_polyfill.URL.createObjectURL) {
      var blob = new Blob([data], {
        type: contentType
      });
      return _url_polyfill.URL.createObjectURL(blob);
    }

    var buffer = 'data:' + contentType + ';base64,';

    for (var i = 0, ii = data.length; i < ii; i += 3) {
      var b1 = data[i] & 0xFF;
      var b2 = data[i + 1] & 0xFF;
      var b3 = data[i + 2] & 0xFF;
      var d1 = b1 >> 2,
          d2 = (b1 & 3) << 4 | b2 >> 4;
      var d3 = i + 1 < ii ? (b2 & 0xF) << 2 | b3 >> 6 : 64;
      var d4 = i + 2 < ii ? b3 & 0x3F : 64;
      buffer += digits[d1] + digits[d2] + digits[d3] + digits[d4];
    }

    return buffer;
  };
}();

exports.createObjectURL = createObjectURL;

/***/ }),
/* 7 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var globalScope = __w_pdfjs_require__(8);

if (!globalScope._pdfjsCompatibilityChecked) {
  globalScope._pdfjsCompatibilityChecked = true;

  var isNodeJS = __w_pdfjs_require__(9);

  var hasDOM = (typeof window === "undefined" ? "undefined" : _typeof(window)) === 'object' && (typeof document === "undefined" ? "undefined" : _typeof(document)) === 'object';

  (function checkNodeBtoa() {
    if (globalScope.btoa || !isNodeJS()) {
      return;
    }

    globalScope.btoa = function (chars) {
      return Buffer.from(chars, 'binary').toString('base64');
    };
  })();

  (function checkNodeAtob() {
    if (globalScope.atob || !isNodeJS()) {
      return;
    }

    globalScope.atob = function (input) {
      return Buffer.from(input, 'base64').toString('binary');
    };
  })();

  (function checkChildNodeRemove() {
    if (!hasDOM) {
      return;
    }

    if (typeof Element.prototype.remove !== 'undefined') {
      return;
    }

    Element.prototype.remove = function () {
      if (this.parentNode) {
        this.parentNode.removeChild(this);
      }
    };
  })();

  (function checkDOMTokenListAddRemove() {
    if (!hasDOM || isNodeJS()) {
      return;
    }

    var div = document.createElement('div');
    div.classList.add('testOne', 'testTwo');

    if (div.classList.contains('testOne') === true && div.classList.contains('testTwo') === true) {
      return;
    }

    var OriginalDOMTokenListAdd = DOMTokenList.prototype.add;
    var OriginalDOMTokenListRemove = DOMTokenList.prototype.remove;

    DOMTokenList.prototype.add = function () {
      for (var _len = arguments.length, tokens = new Array(_len), _key = 0; _key < _len; _key++) {
        tokens[_key] = arguments[_key];
      }

      for (var _i = 0; _i < tokens.length; _i++) {
        var token = tokens[_i];
        OriginalDOMTokenListAdd.call(this, token);
      }
    };

    DOMTokenList.prototype.remove = function () {
      for (var _len2 = arguments.length, tokens = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        tokens[_key2] = arguments[_key2];
      }

      for (var _i2 = 0; _i2 < tokens.length; _i2++) {
        var token = tokens[_i2];
        OriginalDOMTokenListRemove.call(this, token);
      }
    };
  })();

  (function checkDOMTokenListToggle() {
    if (!hasDOM || isNodeJS()) {
      return;
    }

    var div = document.createElement('div');

    if (div.classList.toggle('test', 0) === false) {
      return;
    }

    DOMTokenList.prototype.toggle = function (token) {
      var force = arguments.length > 1 ? !!arguments[1] : !this.contains(token);
      return this[force ? 'add' : 'remove'](token), force;
    };
  })();

  (function checkStringStartsWith() {
    if (String.prototype.startsWith) {
      return;
    }

    __w_pdfjs_require__(10);
  })();

  (function checkStringEndsWith() {
    if (String.prototype.endsWith) {
      return;
    }

    __w_pdfjs_require__(40);
  })();

  (function checkStringIncludes() {
    if (String.prototype.includes) {
      return;
    }

    __w_pdfjs_require__(42);
  })();

  (function checkArrayIncludes() {
    if (Array.prototype.includes) {
      return;
    }

    __w_pdfjs_require__(44);
  })();

  (function checkArrayFrom() {
    if (Array.from) {
      return;
    }

    __w_pdfjs_require__(51);
  })();

  (function checkObjectAssign() {
    if (Object.assign) {
      return;
    }

    __w_pdfjs_require__(74);
  })();

  (function checkMathLog2() {
    if (Math.log2) {
      return;
    }

    Math.log2 = __w_pdfjs_require__(79);
  })();

  (function checkNumberIsNaN() {
    if (Number.isNaN) {
      return;
    }

    Number.isNaN = __w_pdfjs_require__(81);
  })();

  (function checkNumberIsInteger() {
    if (Number.isInteger) {
      return;
    }

    Number.isInteger = __w_pdfjs_require__(83);
  })();

  (function checkPromise() {
    if (globalScope.Promise && globalScope.Promise.prototype && globalScope.Promise.prototype.finally) {
      return;
    }

    globalScope.Promise = __w_pdfjs_require__(86);
  })();

  (function checkWeakMap() {
    if (globalScope.WeakMap) {
      return;
    }

    globalScope.WeakMap = __w_pdfjs_require__(106);
  })();

  (function checkWeakSet() {
    if (globalScope.WeakSet) {
      return;
    }

    globalScope.WeakSet = __w_pdfjs_require__(123);
  })();

  (function checkStringCodePointAt() {
    if (String.codePointAt) {
      return;
    }

    String.codePointAt = __w_pdfjs_require__(127);
  })();

  (function checkStringFromCodePoint() {
    if (String.fromCodePoint) {
      return;
    }

    String.fromCodePoint = __w_pdfjs_require__(129);
  })();

  (function checkSymbol() {
    if (globalScope.Symbol) {
      return;
    }

    __w_pdfjs_require__(131);
  })();

  (function checkStringPadStart() {
    if (String.prototype.padStart) {
      return;
    }

    __w_pdfjs_require__(138);
  })();

  (function checkStringPadEnd() {
    if (String.prototype.padEnd) {
      return;
    }

    __w_pdfjs_require__(142);
  })();

  (function checkObjectValues() {
    if (Object.values) {
      return;
    }

    Object.values = __w_pdfjs_require__(144);
  })();
}

/***/ }),
/* 8 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = typeof window !== 'undefined' && window.Math === Math ? window : typeof global !== 'undefined' && global.Math === Math ? global : typeof self !== 'undefined' && self.Math === Math ? self : {};

/***/ }),
/* 9 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

module.exports = function isNodeJS() {
  return (typeof process === "undefined" ? "undefined" : _typeof(process)) === 'object' && process + '' === '[object process]' && !process.versions['nw'];
};

/***/ }),
/* 10 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(11);

module.exports = __w_pdfjs_require__(14).String.startsWith;

/***/ }),
/* 11 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var toLength = __w_pdfjs_require__(30);

var context = __w_pdfjs_require__(32);

var STARTS_WITH = 'startsWith';
var $startsWith = ''[STARTS_WITH];
$export($export.P + $export.F * __w_pdfjs_require__(39)(STARTS_WITH), 'String', {
  startsWith: function startsWith(searchString) {
    var that = context(this, searchString, STARTS_WITH);
    var index = toLength(Math.min(arguments.length > 1 ? arguments[1] : undefined, that.length));
    var search = String(searchString);
    return $startsWith ? $startsWith.call(that, search, index) : that.slice(index, index + search.length) === search;
  }
});

/***/ }),
/* 12 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(13);

var core = __w_pdfjs_require__(14);

var hide = __w_pdfjs_require__(15);

var redefine = __w_pdfjs_require__(25);

var ctx = __w_pdfjs_require__(28);

var PROTOTYPE = 'prototype';

var $export = function $export(type, name, source) {
  var IS_FORCED = type & $export.F;
  var IS_GLOBAL = type & $export.G;
  var IS_STATIC = type & $export.S;
  var IS_PROTO = type & $export.P;
  var IS_BIND = type & $export.B;
  var target = IS_GLOBAL ? global : IS_STATIC ? global[name] || (global[name] = {}) : (global[name] || {})[PROTOTYPE];
  var exports = IS_GLOBAL ? core : core[name] || (core[name] = {});
  var expProto = exports[PROTOTYPE] || (exports[PROTOTYPE] = {});
  var key, own, out, exp;
  if (IS_GLOBAL) source = name;

  for (key in source) {
    own = !IS_FORCED && target && target[key] !== undefined;
    out = (own ? target : source)[key];
    exp = IS_BIND && own ? ctx(out, global) : IS_PROTO && typeof out == 'function' ? ctx(Function.call, out) : out;
    if (target) redefine(target, key, out, type & $export.U);
    if (exports[key] != out) hide(exports, key, exp);
    if (IS_PROTO && expProto[key] != out) expProto[key] = out;
  }
};

global.core = core;
$export.F = 1;
$export.G = 2;
$export.S = 4;
$export.P = 8;
$export.B = 16;
$export.W = 32;
$export.U = 64;
$export.R = 128;
module.exports = $export;

/***/ }),
/* 13 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = module.exports = typeof window != 'undefined' && window.Math == Math ? window : typeof self != 'undefined' && self.Math == Math ? self : Function('return this')();
if (typeof __g == 'number') __g = global;

/***/ }),
/* 14 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var core = module.exports = {
  version: '2.6.2'
};
if (typeof __e == 'number') __e = core;

/***/ }),
/* 15 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var dP = __w_pdfjs_require__(16);

var createDesc = __w_pdfjs_require__(24);

module.exports = __w_pdfjs_require__(20) ? function (object, key, value) {
  return dP.f(object, key, createDesc(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};

/***/ }),
/* 16 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(17);

var IE8_DOM_DEFINE = __w_pdfjs_require__(19);

var toPrimitive = __w_pdfjs_require__(23);

var dP = Object.defineProperty;
exports.f = __w_pdfjs_require__(20) ? Object.defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return dP(O, P, Attributes);
  } catch (e) {}
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};

/***/ }),
/* 17 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

module.exports = function (it) {
  if (!isObject(it)) throw TypeError(it + ' is not an object!');
  return it;
};

/***/ }),
/* 18 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

module.exports = function (it) {
  return _typeof(it) === 'object' ? it !== null : typeof it === 'function';
};

/***/ }),
/* 19 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = !__w_pdfjs_require__(20) && !__w_pdfjs_require__(21)(function () {
  return Object.defineProperty(__w_pdfjs_require__(22)('div'), 'a', {
    get: function get() {
      return 7;
    }
  }).a != 7;
});

/***/ }),
/* 20 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = !__w_pdfjs_require__(21)(function () {
  return Object.defineProperty({}, 'a', {
    get: function get() {
      return 7;
    }
  }).a != 7;
});

/***/ }),
/* 21 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (exec) {
  try {
    return !!exec();
  } catch (e) {
    return true;
  }
};

/***/ }),
/* 22 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

var document = __w_pdfjs_require__(13).document;

var is = isObject(document) && isObject(document.createElement);

module.exports = function (it) {
  return is ? document.createElement(it) : {};
};

/***/ }),
/* 23 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

module.exports = function (it, S) {
  if (!isObject(it)) return it;
  var fn, val;
  if (S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  if (typeof (fn = it.valueOf) == 'function' && !isObject(val = fn.call(it))) return val;
  if (!S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  throw TypeError("Can't convert object to primitive value");
};

/***/ }),
/* 24 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};

/***/ }),
/* 25 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(13);

var hide = __w_pdfjs_require__(15);

var has = __w_pdfjs_require__(26);

var SRC = __w_pdfjs_require__(27)('src');

var TO_STRING = 'toString';
var $toString = Function[TO_STRING];
var TPL = ('' + $toString).split(TO_STRING);

__w_pdfjs_require__(14).inspectSource = function (it) {
  return $toString.call(it);
};

(module.exports = function (O, key, val, safe) {
  var isFunction = typeof val == 'function';
  if (isFunction) has(val, 'name') || hide(val, 'name', key);
  if (O[key] === val) return;
  if (isFunction) has(val, SRC) || hide(val, SRC, O[key] ? '' + O[key] : TPL.join(String(key)));

  if (O === global) {
    O[key] = val;
  } else if (!safe) {
    delete O[key];
    hide(O, key, val);
  } else if (O[key]) {
    O[key] = val;
  } else {
    hide(O, key, val);
  }
})(Function.prototype, TO_STRING, function toString() {
  return typeof this == 'function' && this[SRC] || $toString.call(this);
});

/***/ }),
/* 26 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var hasOwnProperty = {}.hasOwnProperty;

module.exports = function (it, key) {
  return hasOwnProperty.call(it, key);
};

/***/ }),
/* 27 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var id = 0;
var px = Math.random();

module.exports = function (key) {
  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
};

/***/ }),
/* 28 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var aFunction = __w_pdfjs_require__(29);

module.exports = function (fn, that, length) {
  aFunction(fn);
  if (that === undefined) return fn;

  switch (length) {
    case 1:
      return function (a) {
        return fn.call(that, a);
      };

    case 2:
      return function (a, b) {
        return fn.call(that, a, b);
      };

    case 3:
      return function (a, b, c) {
        return fn.call(that, a, b, c);
      };
  }

  return function () {
    return fn.apply(that, arguments);
  };
};

/***/ }),
/* 29 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (it) {
  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
  return it;
};

/***/ }),
/* 30 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(31);

var min = Math.min;

module.exports = function (it) {
  return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0;
};

/***/ }),
/* 31 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ceil = Math.ceil;
var floor = Math.floor;

module.exports = function (it) {
  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
};

/***/ }),
/* 32 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isRegExp = __w_pdfjs_require__(33);

var defined = __w_pdfjs_require__(38);

module.exports = function (that, searchString, NAME) {
  if (isRegExp(searchString)) throw TypeError('String#' + NAME + " doesn't accept regex!");
  return String(defined(that));
};

/***/ }),
/* 33 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

var cof = __w_pdfjs_require__(34);

var MATCH = __w_pdfjs_require__(35)('match');

module.exports = function (it) {
  var isRegExp;
  return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : cof(it) == 'RegExp');
};

/***/ }),
/* 34 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};

/***/ }),
/* 35 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var store = __w_pdfjs_require__(36)('wks');

var uid = __w_pdfjs_require__(27);

var _Symbol = __w_pdfjs_require__(13).Symbol;

var USE_SYMBOL = typeof _Symbol == 'function';

var $exports = module.exports = function (name) {
  return store[name] || (store[name] = USE_SYMBOL && _Symbol[name] || (USE_SYMBOL ? _Symbol : uid)('Symbol.' + name));
};

$exports.store = store;

/***/ }),
/* 36 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var core = __w_pdfjs_require__(14);

var global = __w_pdfjs_require__(13);

var SHARED = '__core-js_shared__';
var store = global[SHARED] || (global[SHARED] = {});
(module.exports = function (key, value) {
  return store[key] || (store[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: core.version,
  mode: __w_pdfjs_require__(37) ? 'pure' : 'global',
  copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
});

/***/ }),
/* 37 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = false;

/***/ }),
/* 38 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on  " + it);
  return it;
};

/***/ }),
/* 39 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var MATCH = __w_pdfjs_require__(35)('match');

module.exports = function (KEY) {
  var re = /./;

  try {
    '/./'[KEY](re);
  } catch (e) {
    try {
      re[MATCH] = false;
      return !'/./'[KEY](re);
    } catch (f) {}
  }

  return true;
};

/***/ }),
/* 40 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(41);

module.exports = __w_pdfjs_require__(14).String.endsWith;

/***/ }),
/* 41 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var toLength = __w_pdfjs_require__(30);

var context = __w_pdfjs_require__(32);

var ENDS_WITH = 'endsWith';
var $endsWith = ''[ENDS_WITH];
$export($export.P + $export.F * __w_pdfjs_require__(39)(ENDS_WITH), 'String', {
  endsWith: function endsWith(searchString) {
    var that = context(this, searchString, ENDS_WITH);
    var endPosition = arguments.length > 1 ? arguments[1] : undefined;
    var len = toLength(that.length);
    var end = endPosition === undefined ? len : Math.min(toLength(endPosition), len);
    var search = String(searchString);
    return $endsWith ? $endsWith.call(that, search, end) : that.slice(end - search.length, end) === search;
  }
});

/***/ }),
/* 42 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(43);

module.exports = __w_pdfjs_require__(14).String.includes;

/***/ }),
/* 43 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var context = __w_pdfjs_require__(32);

var INCLUDES = 'includes';
$export($export.P + $export.F * __w_pdfjs_require__(39)(INCLUDES), 'String', {
  includes: function includes(searchString) {
    return !!~context(this, searchString, INCLUDES).indexOf(searchString, arguments.length > 1 ? arguments[1] : undefined);
  }
});

/***/ }),
/* 44 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(45);

module.exports = __w_pdfjs_require__(14).Array.includes;

/***/ }),
/* 45 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var $includes = __w_pdfjs_require__(46)(true);

$export($export.P, 'Array', {
  includes: function includes(el) {
    return $includes(this, el, arguments.length > 1 ? arguments[1] : undefined);
  }
});

__w_pdfjs_require__(50)('includes');

/***/ }),
/* 46 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toIObject = __w_pdfjs_require__(47);

var toLength = __w_pdfjs_require__(30);

var toAbsoluteIndex = __w_pdfjs_require__(49);

module.exports = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      if (value != value) return true;
    } else for (; length > index; index++) {
      if (IS_INCLUDES || index in O) {
        if (O[index] === el) return IS_INCLUDES || index || 0;
      }
    }
    return !IS_INCLUDES && -1;
  };
};

/***/ }),
/* 47 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var IObject = __w_pdfjs_require__(48);

var defined = __w_pdfjs_require__(38);

module.exports = function (it) {
  return IObject(defined(it));
};

/***/ }),
/* 48 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var cof = __w_pdfjs_require__(34);

module.exports = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
  return cof(it) == 'String' ? it.split('') : Object(it);
};

/***/ }),
/* 49 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(31);

var max = Math.max;
var min = Math.min;

module.exports = function (index, length) {
  index = toInteger(index);
  return index < 0 ? max(index + length, 0) : min(index, length);
};

/***/ }),
/* 50 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var UNSCOPABLES = __w_pdfjs_require__(35)('unscopables');

var ArrayProto = Array.prototype;
if (ArrayProto[UNSCOPABLES] == undefined) __w_pdfjs_require__(15)(ArrayProto, UNSCOPABLES, {});

module.exports = function (key) {
  ArrayProto[UNSCOPABLES][key] = true;
};

/***/ }),
/* 51 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(52);

__w_pdfjs_require__(67);

module.exports = __w_pdfjs_require__(14).Array.from;

/***/ }),
/* 52 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $at = __w_pdfjs_require__(53)(true);

__w_pdfjs_require__(54)(String, 'String', function (iterated) {
  this._t = String(iterated);
  this._i = 0;
}, function () {
  var O = this._t;
  var index = this._i;
  var point;
  if (index >= O.length) return {
    value: undefined,
    done: true
  };
  point = $at(O, index);
  this._i += point.length;
  return {
    value: point,
    done: false
  };
});

/***/ }),
/* 53 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(31);

var defined = __w_pdfjs_require__(38);

module.exports = function (TO_STRING) {
  return function (that, pos) {
    var s = String(defined(that));
    var i = toInteger(pos);
    var l = s.length;
    var a, b;
    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
    a = s.charCodeAt(i);
    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff ? TO_STRING ? s.charAt(i) : a : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
  };
};

/***/ }),
/* 54 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var LIBRARY = __w_pdfjs_require__(37);

var $export = __w_pdfjs_require__(12);

var redefine = __w_pdfjs_require__(25);

var hide = __w_pdfjs_require__(15);

var Iterators = __w_pdfjs_require__(55);

var $iterCreate = __w_pdfjs_require__(56);

var setToStringTag = __w_pdfjs_require__(64);

var getPrototypeOf = __w_pdfjs_require__(65);

var ITERATOR = __w_pdfjs_require__(35)('iterator');

var BUGGY = !([].keys && 'next' in [].keys());
var FF_ITERATOR = '@@iterator';
var KEYS = 'keys';
var VALUES = 'values';

var returnThis = function returnThis() {
  return this;
};

module.exports = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
  $iterCreate(Constructor, NAME, next);

  var getMethod = function getMethod(kind) {
    if (!BUGGY && kind in proto) return proto[kind];

    switch (kind) {
      case KEYS:
        return function keys() {
          return new Constructor(this, kind);
        };

      case VALUES:
        return function values() {
          return new Constructor(this, kind);
        };
    }

    return function entries() {
      return new Constructor(this, kind);
    };
  };

  var TAG = NAME + ' Iterator';
  var DEF_VALUES = DEFAULT == VALUES;
  var VALUES_BUG = false;
  var proto = Base.prototype;
  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
  var $default = $native || getMethod(DEFAULT);
  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
  var methods, key, IteratorPrototype;

  if ($anyNative) {
    IteratorPrototype = getPrototypeOf($anyNative.call(new Base()));

    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
      setToStringTag(IteratorPrototype, TAG, true);
      if (!LIBRARY && typeof IteratorPrototype[ITERATOR] != 'function') hide(IteratorPrototype, ITERATOR, returnThis);
    }
  }

  if (DEF_VALUES && $native && $native.name !== VALUES) {
    VALUES_BUG = true;

    $default = function values() {
      return $native.call(this);
    };
  }

  if ((!LIBRARY || FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
    hide(proto, ITERATOR, $default);
  }

  Iterators[NAME] = $default;
  Iterators[TAG] = returnThis;

  if (DEFAULT) {
    methods = {
      values: DEF_VALUES ? $default : getMethod(VALUES),
      keys: IS_SET ? $default : getMethod(KEYS),
      entries: $entries
    };
    if (FORCED) for (key in methods) {
      if (!(key in proto)) redefine(proto, key, methods[key]);
    } else $export($export.P + $export.F * (BUGGY || VALUES_BUG), NAME, methods);
  }

  return methods;
};

/***/ }),
/* 55 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = {};

/***/ }),
/* 56 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var create = __w_pdfjs_require__(57);

var descriptor = __w_pdfjs_require__(24);

var setToStringTag = __w_pdfjs_require__(64);

var IteratorPrototype = {};

__w_pdfjs_require__(15)(IteratorPrototype, __w_pdfjs_require__(35)('iterator'), function () {
  return this;
});

module.exports = function (Constructor, NAME, next) {
  Constructor.prototype = create(IteratorPrototype, {
    next: descriptor(1, next)
  });
  setToStringTag(Constructor, NAME + ' Iterator');
};

/***/ }),
/* 57 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(17);

var dPs = __w_pdfjs_require__(58);

var enumBugKeys = __w_pdfjs_require__(62);

var IE_PROTO = __w_pdfjs_require__(61)('IE_PROTO');

var Empty = function Empty() {};

var PROTOTYPE = 'prototype';

var _createDict = function createDict() {
  var iframe = __w_pdfjs_require__(22)('iframe');

  var i = enumBugKeys.length;
  var lt = '<';
  var gt = '>';
  var iframeDocument;
  iframe.style.display = 'none';

  __w_pdfjs_require__(63).appendChild(iframe);

  iframe.src = 'javascript:';
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
  iframeDocument.close();
  _createDict = iframeDocument.F;

  while (i--) {
    delete _createDict[PROTOTYPE][enumBugKeys[i]];
  }

  return _createDict();
};

module.exports = Object.create || function create(O, Properties) {
  var result;

  if (O !== null) {
    Empty[PROTOTYPE] = anObject(O);
    result = new Empty();
    Empty[PROTOTYPE] = null;
    result[IE_PROTO] = O;
  } else result = _createDict();

  return Properties === undefined ? result : dPs(result, Properties);
};

/***/ }),
/* 58 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var dP = __w_pdfjs_require__(16);

var anObject = __w_pdfjs_require__(17);

var getKeys = __w_pdfjs_require__(59);

module.exports = __w_pdfjs_require__(20) ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = getKeys(Properties);
  var length = keys.length;
  var i = 0;
  var P;

  while (length > i) {
    dP.f(O, P = keys[i++], Properties[P]);
  }

  return O;
};

/***/ }),
/* 59 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $keys = __w_pdfjs_require__(60);

var enumBugKeys = __w_pdfjs_require__(62);

module.exports = Object.keys || function keys(O) {
  return $keys(O, enumBugKeys);
};

/***/ }),
/* 60 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var has = __w_pdfjs_require__(26);

var toIObject = __w_pdfjs_require__(47);

var arrayIndexOf = __w_pdfjs_require__(46)(false);

var IE_PROTO = __w_pdfjs_require__(61)('IE_PROTO');

module.exports = function (object, names) {
  var O = toIObject(object);
  var i = 0;
  var result = [];
  var key;

  for (key in O) {
    if (key != IE_PROTO) has(O, key) && result.push(key);
  }

  while (names.length > i) {
    if (has(O, key = names[i++])) {
      ~arrayIndexOf(result, key) || result.push(key);
    }
  }

  return result;
};

/***/ }),
/* 61 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var shared = __w_pdfjs_require__(36)('keys');

var uid = __w_pdfjs_require__(27);

module.exports = function (key) {
  return shared[key] || (shared[key] = uid(key));
};

/***/ }),
/* 62 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = 'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'.split(',');

/***/ }),
/* 63 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var document = __w_pdfjs_require__(13).document;

module.exports = document && document.documentElement;

/***/ }),
/* 64 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var def = __w_pdfjs_require__(16).f;

var has = __w_pdfjs_require__(26);

var TAG = __w_pdfjs_require__(35)('toStringTag');

module.exports = function (it, tag, stat) {
  if (it && !has(it = stat ? it : it.prototype, TAG)) def(it, TAG, {
    configurable: true,
    value: tag
  });
};

/***/ }),
/* 65 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var has = __w_pdfjs_require__(26);

var toObject = __w_pdfjs_require__(66);

var IE_PROTO = __w_pdfjs_require__(61)('IE_PROTO');

var ObjectProto = Object.prototype;

module.exports = Object.getPrototypeOf || function (O) {
  O = toObject(O);
  if (has(O, IE_PROTO)) return O[IE_PROTO];

  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
    return O.constructor.prototype;
  }

  return O instanceof Object ? ObjectProto : null;
};

/***/ }),
/* 66 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var defined = __w_pdfjs_require__(38);

module.exports = function (it) {
  return Object(defined(it));
};

/***/ }),
/* 67 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(28);

var $export = __w_pdfjs_require__(12);

var toObject = __w_pdfjs_require__(66);

var call = __w_pdfjs_require__(68);

var isArrayIter = __w_pdfjs_require__(69);

var toLength = __w_pdfjs_require__(30);

var createProperty = __w_pdfjs_require__(70);

var getIterFn = __w_pdfjs_require__(71);

$export($export.S + $export.F * !__w_pdfjs_require__(73)(function (iter) {
  Array.from(iter);
}), 'Array', {
  from: function from(arrayLike) {
    var O = toObject(arrayLike);
    var C = typeof this == 'function' ? this : Array;
    var aLen = arguments.length;
    var mapfn = aLen > 1 ? arguments[1] : undefined;
    var mapping = mapfn !== undefined;
    var index = 0;
    var iterFn = getIterFn(O);
    var length, result, step, iterator;
    if (mapping) mapfn = ctx(mapfn, aLen > 2 ? arguments[2] : undefined, 2);

    if (iterFn != undefined && !(C == Array && isArrayIter(iterFn))) {
      for (iterator = iterFn.call(O), result = new C(); !(step = iterator.next()).done; index++) {
        createProperty(result, index, mapping ? call(iterator, mapfn, [step.value, index], true) : step.value);
      }
    } else {
      length = toLength(O.length);

      for (result = new C(length); length > index; index++) {
        createProperty(result, index, mapping ? mapfn(O[index], index) : O[index]);
      }
    }

    result.length = index;
    return result;
  }
});

/***/ }),
/* 68 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(17);

module.exports = function (iterator, fn, value, entries) {
  try {
    return entries ? fn(anObject(value)[0], value[1]) : fn(value);
  } catch (e) {
    var ret = iterator['return'];
    if (ret !== undefined) anObject(ret.call(iterator));
    throw e;
  }
};

/***/ }),
/* 69 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var Iterators = __w_pdfjs_require__(55);

var ITERATOR = __w_pdfjs_require__(35)('iterator');

var ArrayProto = Array.prototype;

module.exports = function (it) {
  return it !== undefined && (Iterators.Array === it || ArrayProto[ITERATOR] === it);
};

/***/ }),
/* 70 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $defineProperty = __w_pdfjs_require__(16);

var createDesc = __w_pdfjs_require__(24);

module.exports = function (object, index, value) {
  if (index in object) $defineProperty.f(object, index, createDesc(0, value));else object[index] = value;
};

/***/ }),
/* 71 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var classof = __w_pdfjs_require__(72);

var ITERATOR = __w_pdfjs_require__(35)('iterator');

var Iterators = __w_pdfjs_require__(55);

module.exports = __w_pdfjs_require__(14).getIteratorMethod = function (it) {
  if (it != undefined) return it[ITERATOR] || it['@@iterator'] || Iterators[classof(it)];
};

/***/ }),
/* 72 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var cof = __w_pdfjs_require__(34);

var TAG = __w_pdfjs_require__(35)('toStringTag');

var ARG = cof(function () {
  return arguments;
}()) == 'Arguments';

var tryGet = function tryGet(it, key) {
  try {
    return it[key];
  } catch (e) {}
};

module.exports = function (it) {
  var O, T, B;
  return it === undefined ? 'Undefined' : it === null ? 'Null' : typeof (T = tryGet(O = Object(it), TAG)) == 'string' ? T : ARG ? cof(O) : (B = cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
};

/***/ }),
/* 73 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ITERATOR = __w_pdfjs_require__(35)('iterator');

var SAFE_CLOSING = false;

try {
  var riter = [7][ITERATOR]();

  riter['return'] = function () {
    SAFE_CLOSING = true;
  };

  Array.from(riter, function () {
    throw 2;
  });
} catch (e) {}

module.exports = function (exec, skipClosing) {
  if (!skipClosing && !SAFE_CLOSING) return false;
  var safe = false;

  try {
    var arr = [7];
    var iter = arr[ITERATOR]();

    iter.next = function () {
      return {
        done: safe = true
      };
    };

    arr[ITERATOR] = function () {
      return iter;
    };

    exec(arr);
  } catch (e) {}

  return safe;
};

/***/ }),
/* 74 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(75);

module.exports = __w_pdfjs_require__(14).Object.assign;

/***/ }),
/* 75 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

$export($export.S + $export.F, 'Object', {
  assign: __w_pdfjs_require__(76)
});

/***/ }),
/* 76 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var getKeys = __w_pdfjs_require__(59);

var gOPS = __w_pdfjs_require__(77);

var pIE = __w_pdfjs_require__(78);

var toObject = __w_pdfjs_require__(66);

var IObject = __w_pdfjs_require__(48);

var $assign = Object.assign;
module.exports = !$assign || __w_pdfjs_require__(21)(function () {
  var A = {};
  var B = {};
  var S = Symbol();
  var K = 'abcdefghijklmnopqrst';
  A[S] = 7;
  K.split('').forEach(function (k) {
    B[k] = k;
  });
  return $assign({}, A)[S] != 7 || Object.keys($assign({}, B)).join('') != K;
}) ? function assign(target, source) {
  var T = toObject(target);
  var aLen = arguments.length;
  var index = 1;
  var getSymbols = gOPS.f;
  var isEnum = pIE.f;

  while (aLen > index) {
    var S = IObject(arguments[index++]);
    var keys = getSymbols ? getKeys(S).concat(getSymbols(S)) : getKeys(S);
    var length = keys.length;
    var j = 0;
    var key;

    while (length > j) {
      if (isEnum.call(S, key = keys[j++])) T[key] = S[key];
    }
  }

  return T;
} : $assign;

/***/ }),
/* 77 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


exports.f = Object.getOwnPropertySymbols;

/***/ }),
/* 78 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


exports.f = {}.propertyIsEnumerable;

/***/ }),
/* 79 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(80);

module.exports = __w_pdfjs_require__(14).Math.log2;

/***/ }),
/* 80 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

$export($export.S, 'Math', {
  log2: function log2(x) {
    return Math.log(x) / Math.LN2;
  }
});

/***/ }),
/* 81 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(82);

module.exports = __w_pdfjs_require__(14).Number.isNaN;

/***/ }),
/* 82 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

$export($export.S, 'Number', {
  isNaN: function isNaN(number) {
    return number != number;
  }
});

/***/ }),
/* 83 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(84);

module.exports = __w_pdfjs_require__(14).Number.isInteger;

/***/ }),
/* 84 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

$export($export.S, 'Number', {
  isInteger: __w_pdfjs_require__(85)
});

/***/ }),
/* 85 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

var floor = Math.floor;

module.exports = function isInteger(it) {
  return !isObject(it) && isFinite(it) && floor(it) === it;
};

/***/ }),
/* 86 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(87);

__w_pdfjs_require__(52);

__w_pdfjs_require__(88);

__w_pdfjs_require__(91);

__w_pdfjs_require__(104);

__w_pdfjs_require__(105);

module.exports = __w_pdfjs_require__(14).Promise;

/***/ }),
/* 87 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var classof = __w_pdfjs_require__(72);

var test = {};
test[__w_pdfjs_require__(35)('toStringTag')] = 'z';

if (test + '' != '[object z]') {
  __w_pdfjs_require__(25)(Object.prototype, 'toString', function toString() {
    return '[object ' + classof(this) + ']';
  }, true);
}

/***/ }),
/* 88 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $iterators = __w_pdfjs_require__(89);

var getKeys = __w_pdfjs_require__(59);

var redefine = __w_pdfjs_require__(25);

var global = __w_pdfjs_require__(13);

var hide = __w_pdfjs_require__(15);

var Iterators = __w_pdfjs_require__(55);

var wks = __w_pdfjs_require__(35);

var ITERATOR = wks('iterator');
var TO_STRING_TAG = wks('toStringTag');
var ArrayValues = Iterators.Array;
var DOMIterables = {
  CSSRuleList: true,
  CSSStyleDeclaration: false,
  CSSValueList: false,
  ClientRectList: false,
  DOMRectList: false,
  DOMStringList: false,
  DOMTokenList: true,
  DataTransferItemList: false,
  FileList: false,
  HTMLAllCollection: false,
  HTMLCollection: false,
  HTMLFormElement: false,
  HTMLSelectElement: false,
  MediaList: true,
  MimeTypeArray: false,
  NamedNodeMap: false,
  NodeList: true,
  PaintRequestList: false,
  Plugin: false,
  PluginArray: false,
  SVGLengthList: false,
  SVGNumberList: false,
  SVGPathSegList: false,
  SVGPointList: false,
  SVGStringList: false,
  SVGTransformList: false,
  SourceBufferList: false,
  StyleSheetList: true,
  TextTrackCueList: false,
  TextTrackList: false,
  TouchList: false
};

for (var collections = getKeys(DOMIterables), i = 0; i < collections.length; i++) {
  var NAME = collections[i];
  var explicit = DOMIterables[NAME];
  var Collection = global[NAME];
  var proto = Collection && Collection.prototype;
  var key;

  if (proto) {
    if (!proto[ITERATOR]) hide(proto, ITERATOR, ArrayValues);
    if (!proto[TO_STRING_TAG]) hide(proto, TO_STRING_TAG, NAME);
    Iterators[NAME] = ArrayValues;
    if (explicit) for (key in $iterators) {
      if (!proto[key]) redefine(proto, key, $iterators[key], true);
    }
  }
}

/***/ }),
/* 89 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var addToUnscopables = __w_pdfjs_require__(50);

var step = __w_pdfjs_require__(90);

var Iterators = __w_pdfjs_require__(55);

var toIObject = __w_pdfjs_require__(47);

module.exports = __w_pdfjs_require__(54)(Array, 'Array', function (iterated, kind) {
  this._t = toIObject(iterated);
  this._i = 0;
  this._k = kind;
}, function () {
  var O = this._t;
  var kind = this._k;
  var index = this._i++;

  if (!O || index >= O.length) {
    this._t = undefined;
    return step(1);
  }

  if (kind == 'keys') return step(0, index);
  if (kind == 'values') return step(0, O[index]);
  return step(0, [index, O[index]]);
}, 'values');
Iterators.Arguments = Iterators.Array;
addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');

/***/ }),
/* 90 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (done, value) {
  return {
    value: value,
    done: !!done
  };
};

/***/ }),
/* 91 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var LIBRARY = __w_pdfjs_require__(37);

var global = __w_pdfjs_require__(13);

var ctx = __w_pdfjs_require__(28);

var classof = __w_pdfjs_require__(72);

var $export = __w_pdfjs_require__(12);

var isObject = __w_pdfjs_require__(18);

var aFunction = __w_pdfjs_require__(29);

var anInstance = __w_pdfjs_require__(92);

var forOf = __w_pdfjs_require__(93);

var speciesConstructor = __w_pdfjs_require__(94);

var task = __w_pdfjs_require__(95).set;

var microtask = __w_pdfjs_require__(97)();

var newPromiseCapabilityModule = __w_pdfjs_require__(98);

var perform = __w_pdfjs_require__(99);

var userAgent = __w_pdfjs_require__(100);

var promiseResolve = __w_pdfjs_require__(101);

var PROMISE = 'Promise';
var TypeError = global.TypeError;
var process = global.process;
var versions = process && process.versions;
var v8 = versions && versions.v8 || '';
var $Promise = global[PROMISE];
var isNode = classof(process) == 'process';

var empty = function empty() {};

var Internal, newGenericPromiseCapability, OwnPromiseCapability, Wrapper;
var newPromiseCapability = newGenericPromiseCapability = newPromiseCapabilityModule.f;
var USE_NATIVE = !!function () {
  try {
    var promise = $Promise.resolve(1);

    var FakePromise = (promise.constructor = {})[__w_pdfjs_require__(35)('species')] = function (exec) {
      exec(empty, empty);
    };

    return (isNode || typeof PromiseRejectionEvent == 'function') && promise.then(empty) instanceof FakePromise && v8.indexOf('6.6') !== 0 && userAgent.indexOf('Chrome/66') === -1;
  } catch (e) {}
}();

var isThenable = function isThenable(it) {
  var then;
  return isObject(it) && typeof (then = it.then) == 'function' ? then : false;
};

var notify = function notify(promise, isReject) {
  if (promise._n) return;
  promise._n = true;
  var chain = promise._c;
  microtask(function () {
    var value = promise._v;
    var ok = promise._s == 1;
    var i = 0;

    var run = function run(reaction) {
      var handler = ok ? reaction.ok : reaction.fail;
      var resolve = reaction.resolve;
      var reject = reaction.reject;
      var domain = reaction.domain;
      var result, then, exited;

      try {
        if (handler) {
          if (!ok) {
            if (promise._h == 2) onHandleUnhandled(promise);
            promise._h = 1;
          }

          if (handler === true) result = value;else {
            if (domain) domain.enter();
            result = handler(value);

            if (domain) {
              domain.exit();
              exited = true;
            }
          }

          if (result === reaction.promise) {
            reject(TypeError('Promise-chain cycle'));
          } else if (then = isThenable(result)) {
            then.call(result, resolve, reject);
          } else resolve(result);
        } else reject(value);
      } catch (e) {
        if (domain && !exited) domain.exit();
        reject(e);
      }
    };

    while (chain.length > i) {
      run(chain[i++]);
    }

    promise._c = [];
    promise._n = false;
    if (isReject && !promise._h) onUnhandled(promise);
  });
};

var onUnhandled = function onUnhandled(promise) {
  task.call(global, function () {
    var value = promise._v;
    var unhandled = isUnhandled(promise);
    var result, handler, console;

    if (unhandled) {
      result = perform(function () {
        if (isNode) {
          process.emit('unhandledRejection', value, promise);
        } else if (handler = global.onunhandledrejection) {
          handler({
            promise: promise,
            reason: value
          });
        } else if ((console = global.console) && console.error) {
          console.error('Unhandled promise rejection', value);
        }
      });
      promise._h = isNode || isUnhandled(promise) ? 2 : 1;
    }

    promise._a = undefined;
    if (unhandled && result.e) throw result.v;
  });
};

var isUnhandled = function isUnhandled(promise) {
  return promise._h !== 1 && (promise._a || promise._c).length === 0;
};

var onHandleUnhandled = function onHandleUnhandled(promise) {
  task.call(global, function () {
    var handler;

    if (isNode) {
      process.emit('rejectionHandled', promise);
    } else if (handler = global.onrejectionhandled) {
      handler({
        promise: promise,
        reason: promise._v
      });
    }
  });
};

var $reject = function $reject(value) {
  var promise = this;
  if (promise._d) return;
  promise._d = true;
  promise = promise._w || promise;
  promise._v = value;
  promise._s = 2;
  if (!promise._a) promise._a = promise._c.slice();
  notify(promise, true);
};

var $resolve = function $resolve(value) {
  var promise = this;
  var then;
  if (promise._d) return;
  promise._d = true;
  promise = promise._w || promise;

  try {
    if (promise === value) throw TypeError("Promise can't be resolved itself");

    if (then = isThenable(value)) {
      microtask(function () {
        var wrapper = {
          _w: promise,
          _d: false
        };

        try {
          then.call(value, ctx($resolve, wrapper, 1), ctx($reject, wrapper, 1));
        } catch (e) {
          $reject.call(wrapper, e);
        }
      });
    } else {
      promise._v = value;
      promise._s = 1;
      notify(promise, false);
    }
  } catch (e) {
    $reject.call({
      _w: promise,
      _d: false
    }, e);
  }
};

if (!USE_NATIVE) {
  $Promise = function Promise(executor) {
    anInstance(this, $Promise, PROMISE, '_h');
    aFunction(executor);
    Internal.call(this);

    try {
      executor(ctx($resolve, this, 1), ctx($reject, this, 1));
    } catch (err) {
      $reject.call(this, err);
    }
  };

  Internal = function Promise(executor) {
    this._c = [];
    this._a = undefined;
    this._s = 0;
    this._d = false;
    this._v = undefined;
    this._h = 0;
    this._n = false;
  };

  Internal.prototype = __w_pdfjs_require__(102)($Promise.prototype, {
    then: function then(onFulfilled, onRejected) {
      var reaction = newPromiseCapability(speciesConstructor(this, $Promise));
      reaction.ok = typeof onFulfilled == 'function' ? onFulfilled : true;
      reaction.fail = typeof onRejected == 'function' && onRejected;
      reaction.domain = isNode ? process.domain : undefined;

      this._c.push(reaction);

      if (this._a) this._a.push(reaction);
      if (this._s) notify(this, false);
      return reaction.promise;
    },
    'catch': function _catch(onRejected) {
      return this.then(undefined, onRejected);
    }
  });

  OwnPromiseCapability = function OwnPromiseCapability() {
    var promise = new Internal();
    this.promise = promise;
    this.resolve = ctx($resolve, promise, 1);
    this.reject = ctx($reject, promise, 1);
  };

  newPromiseCapabilityModule.f = newPromiseCapability = function newPromiseCapability(C) {
    return C === $Promise || C === Wrapper ? new OwnPromiseCapability(C) : newGenericPromiseCapability(C);
  };
}

$export($export.G + $export.W + $export.F * !USE_NATIVE, {
  Promise: $Promise
});

__w_pdfjs_require__(64)($Promise, PROMISE);

__w_pdfjs_require__(103)(PROMISE);

Wrapper = __w_pdfjs_require__(14)[PROMISE];
$export($export.S + $export.F * !USE_NATIVE, PROMISE, {
  reject: function reject(r) {
    var capability = newPromiseCapability(this);
    var $$reject = capability.reject;
    $$reject(r);
    return capability.promise;
  }
});
$export($export.S + $export.F * (LIBRARY || !USE_NATIVE), PROMISE, {
  resolve: function resolve(x) {
    return promiseResolve(LIBRARY && this === Wrapper ? $Promise : this, x);
  }
});
$export($export.S + $export.F * !(USE_NATIVE && __w_pdfjs_require__(73)(function (iter) {
  $Promise.all(iter)['catch'](empty);
})), PROMISE, {
  all: function all(iterable) {
    var C = this;
    var capability = newPromiseCapability(C);
    var resolve = capability.resolve;
    var reject = capability.reject;
    var result = perform(function () {
      var values = [];
      var index = 0;
      var remaining = 1;
      forOf(iterable, false, function (promise) {
        var $index = index++;
        var alreadyCalled = false;
        values.push(undefined);
        remaining++;
        C.resolve(promise).then(function (value) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[$index] = value;
          --remaining || resolve(values);
        }, reject);
      });
      --remaining || resolve(values);
    });
    if (result.e) reject(result.v);
    return capability.promise;
  },
  race: function race(iterable) {
    var C = this;
    var capability = newPromiseCapability(C);
    var reject = capability.reject;
    var result = perform(function () {
      forOf(iterable, false, function (promise) {
        C.resolve(promise).then(capability.resolve, reject);
      });
    });
    if (result.e) reject(result.v);
    return capability.promise;
  }
});

/***/ }),
/* 92 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (it, Constructor, name, forbiddenField) {
  if (!(it instanceof Constructor) || forbiddenField !== undefined && forbiddenField in it) {
    throw TypeError(name + ': incorrect invocation!');
  }

  return it;
};

/***/ }),
/* 93 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(28);

var call = __w_pdfjs_require__(68);

var isArrayIter = __w_pdfjs_require__(69);

var anObject = __w_pdfjs_require__(17);

var toLength = __w_pdfjs_require__(30);

var getIterFn = __w_pdfjs_require__(71);

var BREAK = {};
var RETURN = {};

var _exports = module.exports = function (iterable, entries, fn, that, ITERATOR) {
  var iterFn = ITERATOR ? function () {
    return iterable;
  } : getIterFn(iterable);
  var f = ctx(fn, that, entries ? 2 : 1);
  var index = 0;
  var length, step, iterator, result;
  if (typeof iterFn != 'function') throw TypeError(iterable + ' is not iterable!');
  if (isArrayIter(iterFn)) for (length = toLength(iterable.length); length > index; index++) {
    result = entries ? f(anObject(step = iterable[index])[0], step[1]) : f(iterable[index]);
    if (result === BREAK || result === RETURN) return result;
  } else for (iterator = iterFn.call(iterable); !(step = iterator.next()).done;) {
    result = call(iterator, f, step.value, entries);
    if (result === BREAK || result === RETURN) return result;
  }
};

_exports.BREAK = BREAK;
_exports.RETURN = RETURN;

/***/ }),
/* 94 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(17);

var aFunction = __w_pdfjs_require__(29);

var SPECIES = __w_pdfjs_require__(35)('species');

module.exports = function (O, D) {
  var C = anObject(O).constructor;
  var S;
  return C === undefined || (S = anObject(C)[SPECIES]) == undefined ? D : aFunction(S);
};

/***/ }),
/* 95 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(28);

var invoke = __w_pdfjs_require__(96);

var html = __w_pdfjs_require__(63);

var cel = __w_pdfjs_require__(22);

var global = __w_pdfjs_require__(13);

var process = global.process;
var setTask = global.setImmediate;
var clearTask = global.clearImmediate;
var MessageChannel = global.MessageChannel;
var Dispatch = global.Dispatch;
var counter = 0;
var queue = {};
var ONREADYSTATECHANGE = 'onreadystatechange';
var defer, channel, port;

var run = function run() {
  var id = +this;

  if (queue.hasOwnProperty(id)) {
    var fn = queue[id];
    delete queue[id];
    fn();
  }
};

var listener = function listener(event) {
  run.call(event.data);
};

if (!setTask || !clearTask) {
  setTask = function setImmediate(fn) {
    var args = [];
    var i = 1;

    while (arguments.length > i) {
      args.push(arguments[i++]);
    }

    queue[++counter] = function () {
      invoke(typeof fn == 'function' ? fn : Function(fn), args);
    };

    defer(counter);
    return counter;
  };

  clearTask = function clearImmediate(id) {
    delete queue[id];
  };

  if (__w_pdfjs_require__(34)(process) == 'process') {
    defer = function defer(id) {
      process.nextTick(ctx(run, id, 1));
    };
  } else if (Dispatch && Dispatch.now) {
    defer = function defer(id) {
      Dispatch.now(ctx(run, id, 1));
    };
  } else if (MessageChannel) {
    channel = new MessageChannel();
    port = channel.port2;
    channel.port1.onmessage = listener;
    defer = ctx(port.postMessage, port, 1);
  } else if (global.addEventListener && typeof postMessage == 'function' && !global.importScripts) {
    defer = function defer(id) {
      global.postMessage(id + '', '*');
    };

    global.addEventListener('message', listener, false);
  } else if (ONREADYSTATECHANGE in cel('script')) {
    defer = function defer(id) {
      html.appendChild(cel('script'))[ONREADYSTATECHANGE] = function () {
        html.removeChild(this);
        run.call(id);
      };
    };
  } else {
    defer = function defer(id) {
      setTimeout(ctx(run, id, 1), 0);
    };
  }
}

module.exports = {
  set: setTask,
  clear: clearTask
};

/***/ }),
/* 96 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (fn, args, that) {
  var un = that === undefined;

  switch (args.length) {
    case 0:
      return un ? fn() : fn.call(that);

    case 1:
      return un ? fn(args[0]) : fn.call(that, args[0]);

    case 2:
      return un ? fn(args[0], args[1]) : fn.call(that, args[0], args[1]);

    case 3:
      return un ? fn(args[0], args[1], args[2]) : fn.call(that, args[0], args[1], args[2]);

    case 4:
      return un ? fn(args[0], args[1], args[2], args[3]) : fn.call(that, args[0], args[1], args[2], args[3]);
  }

  return fn.apply(that, args);
};

/***/ }),
/* 97 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(13);

var macrotask = __w_pdfjs_require__(95).set;

var Observer = global.MutationObserver || global.WebKitMutationObserver;
var process = global.process;
var Promise = global.Promise;
var isNode = __w_pdfjs_require__(34)(process) == 'process';

module.exports = function () {
  var head, last, notify;

  var flush = function flush() {
    var parent, fn;
    if (isNode && (parent = process.domain)) parent.exit();

    while (head) {
      fn = head.fn;
      head = head.next;

      try {
        fn();
      } catch (e) {
        if (head) notify();else last = undefined;
        throw e;
      }
    }

    last = undefined;
    if (parent) parent.enter();
  };

  if (isNode) {
    notify = function notify() {
      process.nextTick(flush);
    };
  } else if (Observer && !(global.navigator && global.navigator.standalone)) {
    var toggle = true;
    var node = document.createTextNode('');
    new Observer(flush).observe(node, {
      characterData: true
    });

    notify = function notify() {
      node.data = toggle = !toggle;
    };
  } else if (Promise && Promise.resolve) {
    var promise = Promise.resolve(undefined);

    notify = function notify() {
      promise.then(flush);
    };
  } else {
    notify = function notify() {
      macrotask.call(global, flush);
    };
  }

  return function (fn) {
    var task = {
      fn: fn,
      next: undefined
    };
    if (last) last.next = task;

    if (!head) {
      head = task;
      notify();
    }

    last = task;
  };
};

/***/ }),
/* 98 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var aFunction = __w_pdfjs_require__(29);

function PromiseCapability(C) {
  var resolve, reject;
  this.promise = new C(function ($$resolve, $$reject) {
    if (resolve !== undefined || reject !== undefined) throw TypeError('Bad Promise constructor');
    resolve = $$resolve;
    reject = $$reject;
  });
  this.resolve = aFunction(resolve);
  this.reject = aFunction(reject);
}

module.exports.f = function (C) {
  return new PromiseCapability(C);
};

/***/ }),
/* 99 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


module.exports = function (exec) {
  try {
    return {
      e: false,
      v: exec()
    };
  } catch (e) {
    return {
      e: true,
      v: e
    };
  }
};

/***/ }),
/* 100 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(13);

var navigator = global.navigator;
module.exports = navigator && navigator.userAgent || '';

/***/ }),
/* 101 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var anObject = __w_pdfjs_require__(17);

var isObject = __w_pdfjs_require__(18);

var newPromiseCapability = __w_pdfjs_require__(98);

module.exports = function (C, x) {
  anObject(C);
  if (isObject(x) && x.constructor === C) return x;
  var promiseCapability = newPromiseCapability.f(C);
  var resolve = promiseCapability.resolve;
  resolve(x);
  return promiseCapability.promise;
};

/***/ }),
/* 102 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var redefine = __w_pdfjs_require__(25);

module.exports = function (target, src, safe) {
  for (var key in src) {
    redefine(target, key, src[key], safe);
  }

  return target;
};

/***/ }),
/* 103 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(13);

var dP = __w_pdfjs_require__(16);

var DESCRIPTORS = __w_pdfjs_require__(20);

var SPECIES = __w_pdfjs_require__(35)('species');

module.exports = function (KEY) {
  var C = global[KEY];
  if (DESCRIPTORS && C && !C[SPECIES]) dP.f(C, SPECIES, {
    configurable: true,
    get: function get() {
      return this;
    }
  });
};

/***/ }),
/* 104 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var core = __w_pdfjs_require__(14);

var global = __w_pdfjs_require__(13);

var speciesConstructor = __w_pdfjs_require__(94);

var promiseResolve = __w_pdfjs_require__(101);

$export($export.P + $export.R, 'Promise', {
  'finally': function _finally(onFinally) {
    var C = speciesConstructor(this, core.Promise || global.Promise);
    var isFunction = typeof onFinally == 'function';
    return this.then(isFunction ? function (x) {
      return promiseResolve(C, onFinally()).then(function () {
        return x;
      });
    } : onFinally, isFunction ? function (e) {
      return promiseResolve(C, onFinally()).then(function () {
        throw e;
      });
    } : onFinally);
  }
});

/***/ }),
/* 105 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var newPromiseCapability = __w_pdfjs_require__(98);

var perform = __w_pdfjs_require__(99);

$export($export.S, 'Promise', {
  'try': function _try(callbackfn) {
    var promiseCapability = newPromiseCapability.f(this);
    var result = perform(callbackfn);
    (result.e ? promiseCapability.reject : promiseCapability.resolve)(result.v);
    return promiseCapability.promise;
  }
});

/***/ }),
/* 106 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(87);

__w_pdfjs_require__(88);

__w_pdfjs_require__(107);

__w_pdfjs_require__(119);

__w_pdfjs_require__(121);

module.exports = __w_pdfjs_require__(14).WeakMap;

/***/ }),
/* 107 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var each = __w_pdfjs_require__(108)(0);

var redefine = __w_pdfjs_require__(25);

var meta = __w_pdfjs_require__(112);

var assign = __w_pdfjs_require__(76);

var weak = __w_pdfjs_require__(113);

var isObject = __w_pdfjs_require__(18);

var fails = __w_pdfjs_require__(21);

var validate = __w_pdfjs_require__(114);

var WEAK_MAP = 'WeakMap';
var getWeak = meta.getWeak;
var isExtensible = Object.isExtensible;
var uncaughtFrozenStore = weak.ufstore;
var tmp = {};
var InternalMap;

var wrapper = function wrapper(get) {
  return function WeakMap() {
    return get(this, arguments.length > 0 ? arguments[0] : undefined);
  };
};

var methods = {
  get: function get(key) {
    if (isObject(key)) {
      var data = getWeak(key);
      if (data === true) return uncaughtFrozenStore(validate(this, WEAK_MAP)).get(key);
      return data ? data[this._i] : undefined;
    }
  },
  set: function set(key, value) {
    return weak.def(validate(this, WEAK_MAP), key, value);
  }
};

var $WeakMap = module.exports = __w_pdfjs_require__(115)(WEAK_MAP, wrapper, methods, weak, true, true);

if (fails(function () {
  return new $WeakMap().set((Object.freeze || Object)(tmp), 7).get(tmp) != 7;
})) {
  InternalMap = weak.getConstructor(wrapper, WEAK_MAP);
  assign(InternalMap.prototype, methods);
  meta.NEED = true;
  each(['delete', 'has', 'get', 'set'], function (key) {
    var proto = $WeakMap.prototype;
    var method = proto[key];
    redefine(proto, key, function (a, b) {
      if (isObject(a) && !isExtensible(a)) {
        if (!this._f) this._f = new InternalMap();

        var result = this._f[key](a, b);

        return key == 'set' ? this : result;
      }

      return method.call(this, a, b);
    });
  });
}

/***/ }),
/* 108 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var ctx = __w_pdfjs_require__(28);

var IObject = __w_pdfjs_require__(48);

var toObject = __w_pdfjs_require__(66);

var toLength = __w_pdfjs_require__(30);

var asc = __w_pdfjs_require__(109);

module.exports = function (TYPE, $create) {
  var IS_MAP = TYPE == 1;
  var IS_FILTER = TYPE == 2;
  var IS_SOME = TYPE == 3;
  var IS_EVERY = TYPE == 4;
  var IS_FIND_INDEX = TYPE == 6;
  var NO_HOLES = TYPE == 5 || IS_FIND_INDEX;
  var create = $create || asc;
  return function ($this, callbackfn, that) {
    var O = toObject($this);
    var self = IObject(O);
    var f = ctx(callbackfn, that, 3);
    var length = toLength(self.length);
    var index = 0;
    var result = IS_MAP ? create($this, length) : IS_FILTER ? create($this, 0) : undefined;
    var val, res;

    for (; length > index; index++) {
      if (NO_HOLES || index in self) {
        val = self[index];
        res = f(val, index, O);

        if (TYPE) {
          if (IS_MAP) result[index] = res;else if (res) switch (TYPE) {
            case 3:
              return true;

            case 5:
              return val;

            case 6:
              return index;

            case 2:
              result.push(val);
          } else if (IS_EVERY) return false;
        }
      }
    }

    return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : result;
  };
};

/***/ }),
/* 109 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var speciesConstructor = __w_pdfjs_require__(110);

module.exports = function (original, length) {
  return new (speciesConstructor(original))(length);
};

/***/ }),
/* 110 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

var isArray = __w_pdfjs_require__(111);

var SPECIES = __w_pdfjs_require__(35)('species');

module.exports = function (original) {
  var C;

  if (isArray(original)) {
    C = original.constructor;
    if (typeof C == 'function' && (C === Array || isArray(C.prototype))) C = undefined;

    if (isObject(C)) {
      C = C[SPECIES];
      if (C === null) C = undefined;
    }
  }

  return C === undefined ? Array : C;
};

/***/ }),
/* 111 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var cof = __w_pdfjs_require__(34);

module.exports = Array.isArray || function isArray(arg) {
  return cof(arg) == 'Array';
};

/***/ }),
/* 112 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var META = __w_pdfjs_require__(27)('meta');

var isObject = __w_pdfjs_require__(18);

var has = __w_pdfjs_require__(26);

var setDesc = __w_pdfjs_require__(16).f;

var id = 0;

var isExtensible = Object.isExtensible || function () {
  return true;
};

var FREEZE = !__w_pdfjs_require__(21)(function () {
  return isExtensible(Object.preventExtensions({}));
});

var setMeta = function setMeta(it) {
  setDesc(it, META, {
    value: {
      i: 'O' + ++id,
      w: {}
    }
  });
};

var fastKey = function fastKey(it, create) {
  if (!isObject(it)) return _typeof(it) == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;

  if (!has(it, META)) {
    if (!isExtensible(it)) return 'F';
    if (!create) return 'E';
    setMeta(it);
  }

  return it[META].i;
};

var getWeak = function getWeak(it, create) {
  if (!has(it, META)) {
    if (!isExtensible(it)) return true;
    if (!create) return false;
    setMeta(it);
  }

  return it[META].w;
};

var onFreeze = function onFreeze(it) {
  if (FREEZE && meta.NEED && isExtensible(it) && !has(it, META)) setMeta(it);
  return it;
};

var meta = module.exports = {
  KEY: META,
  NEED: false,
  fastKey: fastKey,
  getWeak: getWeak,
  onFreeze: onFreeze
};

/***/ }),
/* 113 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var redefineAll = __w_pdfjs_require__(102);

var getWeak = __w_pdfjs_require__(112).getWeak;

var anObject = __w_pdfjs_require__(17);

var isObject = __w_pdfjs_require__(18);

var anInstance = __w_pdfjs_require__(92);

var forOf = __w_pdfjs_require__(93);

var createArrayMethod = __w_pdfjs_require__(108);

var $has = __w_pdfjs_require__(26);

var validate = __w_pdfjs_require__(114);

var arrayFind = createArrayMethod(5);
var arrayFindIndex = createArrayMethod(6);
var id = 0;

var uncaughtFrozenStore = function uncaughtFrozenStore(that) {
  return that._l || (that._l = new UncaughtFrozenStore());
};

var UncaughtFrozenStore = function UncaughtFrozenStore() {
  this.a = [];
};

var findUncaughtFrozen = function findUncaughtFrozen(store, key) {
  return arrayFind(store.a, function (it) {
    return it[0] === key;
  });
};

UncaughtFrozenStore.prototype = {
  get: function get(key) {
    var entry = findUncaughtFrozen(this, key);
    if (entry) return entry[1];
  },
  has: function has(key) {
    return !!findUncaughtFrozen(this, key);
  },
  set: function set(key, value) {
    var entry = findUncaughtFrozen(this, key);
    if (entry) entry[1] = value;else this.a.push([key, value]);
  },
  'delete': function _delete(key) {
    var index = arrayFindIndex(this.a, function (it) {
      return it[0] === key;
    });
    if (~index) this.a.splice(index, 1);
    return !!~index;
  }
};
module.exports = {
  getConstructor: function getConstructor(wrapper, NAME, IS_MAP, ADDER) {
    var C = wrapper(function (that, iterable) {
      anInstance(that, C, NAME, '_i');
      that._t = NAME;
      that._i = id++;
      that._l = undefined;
      if (iterable != undefined) forOf(iterable, IS_MAP, that[ADDER], that);
    });
    redefineAll(C.prototype, {
      'delete': function _delete(key) {
        if (!isObject(key)) return false;
        var data = getWeak(key);
        if (data === true) return uncaughtFrozenStore(validate(this, NAME))['delete'](key);
        return data && $has(data, this._i) && delete data[this._i];
      },
      has: function has(key) {
        if (!isObject(key)) return false;
        var data = getWeak(key);
        if (data === true) return uncaughtFrozenStore(validate(this, NAME)).has(key);
        return data && $has(data, this._i);
      }
    });
    return C;
  },
  def: function def(that, key, value) {
    var data = getWeak(anObject(key), true);
    if (data === true) uncaughtFrozenStore(that).set(key, value);else data[that._i] = value;
    return that;
  },
  ufstore: uncaughtFrozenStore
};

/***/ }),
/* 114 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

module.exports = function (it, TYPE) {
  if (!isObject(it) || it._t !== TYPE) throw TypeError('Incompatible receiver, ' + TYPE + ' required!');
  return it;
};

/***/ }),
/* 115 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(13);

var $export = __w_pdfjs_require__(12);

var redefine = __w_pdfjs_require__(25);

var redefineAll = __w_pdfjs_require__(102);

var meta = __w_pdfjs_require__(112);

var forOf = __w_pdfjs_require__(93);

var anInstance = __w_pdfjs_require__(92);

var isObject = __w_pdfjs_require__(18);

var fails = __w_pdfjs_require__(21);

var $iterDetect = __w_pdfjs_require__(73);

var setToStringTag = __w_pdfjs_require__(64);

var inheritIfRequired = __w_pdfjs_require__(116);

module.exports = function (NAME, wrapper, methods, common, IS_MAP, IS_WEAK) {
  var Base = global[NAME];
  var C = Base;
  var ADDER = IS_MAP ? 'set' : 'add';
  var proto = C && C.prototype;
  var O = {};

  var fixMethod = function fixMethod(KEY) {
    var fn = proto[KEY];
    redefine(proto, KEY, KEY == 'delete' ? function (a) {
      return IS_WEAK && !isObject(a) ? false : fn.call(this, a === 0 ? 0 : a);
    } : KEY == 'has' ? function has(a) {
      return IS_WEAK && !isObject(a) ? false : fn.call(this, a === 0 ? 0 : a);
    } : KEY == 'get' ? function get(a) {
      return IS_WEAK && !isObject(a) ? undefined : fn.call(this, a === 0 ? 0 : a);
    } : KEY == 'add' ? function add(a) {
      fn.call(this, a === 0 ? 0 : a);
      return this;
    } : function set(a, b) {
      fn.call(this, a === 0 ? 0 : a, b);
      return this;
    });
  };

  if (typeof C != 'function' || !(IS_WEAK || proto.forEach && !fails(function () {
    new C().entries().next();
  }))) {
    C = common.getConstructor(wrapper, NAME, IS_MAP, ADDER);
    redefineAll(C.prototype, methods);
    meta.NEED = true;
  } else {
    var instance = new C();
    var HASNT_CHAINING = instance[ADDER](IS_WEAK ? {} : -0, 1) != instance;
    var THROWS_ON_PRIMITIVES = fails(function () {
      instance.has(1);
    });
    var ACCEPT_ITERABLES = $iterDetect(function (iter) {
      new C(iter);
    });
    var BUGGY_ZERO = !IS_WEAK && fails(function () {
      var $instance = new C();
      var index = 5;

      while (index--) {
        $instance[ADDER](index, index);
      }

      return !$instance.has(-0);
    });

    if (!ACCEPT_ITERABLES) {
      C = wrapper(function (target, iterable) {
        anInstance(target, C, NAME);
        var that = inheritIfRequired(new Base(), target, C);
        if (iterable != undefined) forOf(iterable, IS_MAP, that[ADDER], that);
        return that;
      });
      C.prototype = proto;
      proto.constructor = C;
    }

    if (THROWS_ON_PRIMITIVES || BUGGY_ZERO) {
      fixMethod('delete');
      fixMethod('has');
      IS_MAP && fixMethod('get');
    }

    if (BUGGY_ZERO || HASNT_CHAINING) fixMethod(ADDER);
    if (IS_WEAK && proto.clear) delete proto.clear;
  }

  setToStringTag(C, NAME);
  O[NAME] = C;
  $export($export.G + $export.W + $export.F * (C != Base), O);
  if (!IS_WEAK) common.setStrong(C, NAME, IS_MAP);
  return C;
};

/***/ }),
/* 116 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

var setPrototypeOf = __w_pdfjs_require__(117).set;

module.exports = function (that, target, C) {
  var S = target.constructor;
  var P;

  if (S !== C && typeof S == 'function' && (P = S.prototype) !== C.prototype && isObject(P) && setPrototypeOf) {
    setPrototypeOf(that, P);
  }

  return that;
};

/***/ }),
/* 117 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var isObject = __w_pdfjs_require__(18);

var anObject = __w_pdfjs_require__(17);

var check = function check(O, proto) {
  anObject(O);
  if (!isObject(proto) && proto !== null) throw TypeError(proto + ": can't set as prototype!");
};

module.exports = {
  set: Object.setPrototypeOf || ('__proto__' in {} ? function (test, buggy, set) {
    try {
      set = __w_pdfjs_require__(28)(Function.call, __w_pdfjs_require__(118).f(Object.prototype, '__proto__').set, 2);
      set(test, []);
      buggy = !(test instanceof Array);
    } catch (e) {
      buggy = true;
    }

    return function setPrototypeOf(O, proto) {
      check(O, proto);
      if (buggy) O.__proto__ = proto;else set(O, proto);
      return O;
    };
  }({}, false) : undefined),
  check: check
};

/***/ }),
/* 118 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var pIE = __w_pdfjs_require__(78);

var createDesc = __w_pdfjs_require__(24);

var toIObject = __w_pdfjs_require__(47);

var toPrimitive = __w_pdfjs_require__(23);

var has = __w_pdfjs_require__(26);

var IE8_DOM_DEFINE = __w_pdfjs_require__(19);

var gOPD = Object.getOwnPropertyDescriptor;
exports.f = __w_pdfjs_require__(20) ? gOPD : function getOwnPropertyDescriptor(O, P) {
  O = toIObject(O);
  P = toPrimitive(P, true);
  if (IE8_DOM_DEFINE) try {
    return gOPD(O, P);
  } catch (e) {}
  if (has(O, P)) return createDesc(!pIE.f.call(O, P), O[P]);
};

/***/ }),
/* 119 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(120)('WeakMap');

/***/ }),
/* 120 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

module.exports = function (COLLECTION) {
  $export($export.S, COLLECTION, {
    of: function of() {
      var length = arguments.length;
      var A = new Array(length);

      while (length--) {
        A[length] = arguments[length];
      }

      return new this(A);
    }
  });
};

/***/ }),
/* 121 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(122)('WeakMap');

/***/ }),
/* 122 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var aFunction = __w_pdfjs_require__(29);

var ctx = __w_pdfjs_require__(28);

var forOf = __w_pdfjs_require__(93);

module.exports = function (COLLECTION) {
  $export($export.S, COLLECTION, {
    from: function from(source) {
      var mapFn = arguments[1];
      var mapping, A, n, cb;
      aFunction(this);
      mapping = mapFn !== undefined;
      if (mapping) aFunction(mapFn);
      if (source == undefined) return new this();
      A = [];

      if (mapping) {
        n = 0;
        cb = ctx(mapFn, arguments[2], 2);
        forOf(source, false, function (nextItem) {
          A.push(cb(nextItem, n++));
        });
      } else {
        forOf(source, false, A.push, A);
      }

      return new this(A);
    }
  });
};

/***/ }),
/* 123 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(87);

__w_pdfjs_require__(88);

__w_pdfjs_require__(124);

__w_pdfjs_require__(125);

__w_pdfjs_require__(126);

module.exports = __w_pdfjs_require__(14).WeakSet;

/***/ }),
/* 124 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var weak = __w_pdfjs_require__(113);

var validate = __w_pdfjs_require__(114);

var WEAK_SET = 'WeakSet';

__w_pdfjs_require__(115)(WEAK_SET, function (get) {
  return function WeakSet() {
    return get(this, arguments.length > 0 ? arguments[0] : undefined);
  };
}, {
  add: function add(value) {
    return weak.def(validate(this, WEAK_SET), value, true);
  }
}, weak, false, true);

/***/ }),
/* 125 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(120)('WeakSet');

/***/ }),
/* 126 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(122)('WeakSet');

/***/ }),
/* 127 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(128);

module.exports = __w_pdfjs_require__(14).String.codePointAt;

/***/ }),
/* 128 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var $at = __w_pdfjs_require__(53)(false);

$export($export.P, 'String', {
  codePointAt: function codePointAt(pos) {
    return $at(this, pos);
  }
});

/***/ }),
/* 129 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(130);

module.exports = __w_pdfjs_require__(14).String.fromCodePoint;

/***/ }),
/* 130 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var toAbsoluteIndex = __w_pdfjs_require__(49);

var fromCharCode = String.fromCharCode;
var $fromCodePoint = String.fromCodePoint;
$export($export.S + $export.F * (!!$fromCodePoint && $fromCodePoint.length != 1), 'String', {
  fromCodePoint: function fromCodePoint(x) {
    var res = [];
    var aLen = arguments.length;
    var i = 0;
    var code;

    while (aLen > i) {
      code = +arguments[i++];
      if (toAbsoluteIndex(code, 0x10ffff) !== code) throw RangeError(code + ' is not a valid code point');
      res.push(code < 0x10000 ? fromCharCode(code) : fromCharCode(((code -= 0x10000) >> 10) + 0xd800, code % 0x400 + 0xdc00));
    }

    return res.join('');
  }
});

/***/ }),
/* 131 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(132);

__w_pdfjs_require__(87);

module.exports = __w_pdfjs_require__(14).Symbol;

/***/ }),
/* 132 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var global = __w_pdfjs_require__(13);

var has = __w_pdfjs_require__(26);

var DESCRIPTORS = __w_pdfjs_require__(20);

var $export = __w_pdfjs_require__(12);

var redefine = __w_pdfjs_require__(25);

var META = __w_pdfjs_require__(112).KEY;

var $fails = __w_pdfjs_require__(21);

var shared = __w_pdfjs_require__(36);

var setToStringTag = __w_pdfjs_require__(64);

var uid = __w_pdfjs_require__(27);

var wks = __w_pdfjs_require__(35);

var wksExt = __w_pdfjs_require__(133);

var wksDefine = __w_pdfjs_require__(134);

var enumKeys = __w_pdfjs_require__(135);

var isArray = __w_pdfjs_require__(111);

var anObject = __w_pdfjs_require__(17);

var isObject = __w_pdfjs_require__(18);

var toIObject = __w_pdfjs_require__(47);

var toPrimitive = __w_pdfjs_require__(23);

var createDesc = __w_pdfjs_require__(24);

var _create = __w_pdfjs_require__(57);

var gOPNExt = __w_pdfjs_require__(136);

var $GOPD = __w_pdfjs_require__(118);

var $DP = __w_pdfjs_require__(16);

var $keys = __w_pdfjs_require__(59);

var gOPD = $GOPD.f;
var dP = $DP.f;
var gOPN = gOPNExt.f;
var $Symbol = global.Symbol;
var $JSON = global.JSON;

var _stringify = $JSON && $JSON.stringify;

var PROTOTYPE = 'prototype';
var HIDDEN = wks('_hidden');
var TO_PRIMITIVE = wks('toPrimitive');
var isEnum = {}.propertyIsEnumerable;
var SymbolRegistry = shared('symbol-registry');
var AllSymbols = shared('symbols');
var OPSymbols = shared('op-symbols');
var ObjectProto = Object[PROTOTYPE];
var USE_NATIVE = typeof $Symbol == 'function';
var QObject = global.QObject;
var setter = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;
var setSymbolDesc = DESCRIPTORS && $fails(function () {
  return _create(dP({}, 'a', {
    get: function get() {
      return dP(this, 'a', {
        value: 7
      }).a;
    }
  })).a != 7;
}) ? function (it, key, D) {
  var protoDesc = gOPD(ObjectProto, key);
  if (protoDesc) delete ObjectProto[key];
  dP(it, key, D);
  if (protoDesc && it !== ObjectProto) dP(ObjectProto, key, protoDesc);
} : dP;

var wrap = function wrap(tag) {
  var sym = AllSymbols[tag] = _create($Symbol[PROTOTYPE]);

  sym._k = tag;
  return sym;
};

var isSymbol = USE_NATIVE && _typeof($Symbol.iterator) == 'symbol' ? function (it) {
  return _typeof(it) == 'symbol';
} : function (it) {
  return it instanceof $Symbol;
};

var $defineProperty = function defineProperty(it, key, D) {
  if (it === ObjectProto) $defineProperty(OPSymbols, key, D);
  anObject(it);
  key = toPrimitive(key, true);
  anObject(D);

  if (has(AllSymbols, key)) {
    if (!D.enumerable) {
      if (!has(it, HIDDEN)) dP(it, HIDDEN, createDesc(1, {}));
      it[HIDDEN][key] = true;
    } else {
      if (has(it, HIDDEN) && it[HIDDEN][key]) it[HIDDEN][key] = false;
      D = _create(D, {
        enumerable: createDesc(0, false)
      });
    }

    return setSymbolDesc(it, key, D);
  }

  return dP(it, key, D);
};

var $defineProperties = function defineProperties(it, P) {
  anObject(it);
  var keys = enumKeys(P = toIObject(P));
  var i = 0;
  var l = keys.length;
  var key;

  while (l > i) {
    $defineProperty(it, key = keys[i++], P[key]);
  }

  return it;
};

var $create = function create(it, P) {
  return P === undefined ? _create(it) : $defineProperties(_create(it), P);
};

var $propertyIsEnumerable = function propertyIsEnumerable(key) {
  var E = isEnum.call(this, key = toPrimitive(key, true));
  if (this === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return false;
  return E || !has(this, key) || !has(AllSymbols, key) || has(this, HIDDEN) && this[HIDDEN][key] ? E : true;
};

var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(it, key) {
  it = toIObject(it);
  key = toPrimitive(key, true);
  if (it === ObjectProto && has(AllSymbols, key) && !has(OPSymbols, key)) return;
  var D = gOPD(it, key);
  if (D && has(AllSymbols, key) && !(has(it, HIDDEN) && it[HIDDEN][key])) D.enumerable = true;
  return D;
};

var $getOwnPropertyNames = function getOwnPropertyNames(it) {
  var names = gOPN(toIObject(it));
  var result = [];
  var i = 0;
  var key;

  while (names.length > i) {
    if (!has(AllSymbols, key = names[i++]) && key != HIDDEN && key != META) result.push(key);
  }

  return result;
};

var $getOwnPropertySymbols = function getOwnPropertySymbols(it) {
  var IS_OP = it === ObjectProto;
  var names = gOPN(IS_OP ? OPSymbols : toIObject(it));
  var result = [];
  var i = 0;
  var key;

  while (names.length > i) {
    if (has(AllSymbols, key = names[i++]) && (IS_OP ? has(ObjectProto, key) : true)) result.push(AllSymbols[key]);
  }

  return result;
};

if (!USE_NATIVE) {
  $Symbol = function _Symbol() {
    if (this instanceof $Symbol) throw TypeError('Symbol is not a constructor!');
    var tag = uid(arguments.length > 0 ? arguments[0] : undefined);

    var $set = function $set(value) {
      if (this === ObjectProto) $set.call(OPSymbols, value);
      if (has(this, HIDDEN) && has(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
      setSymbolDesc(this, tag, createDesc(1, value));
    };

    if (DESCRIPTORS && setter) setSymbolDesc(ObjectProto, tag, {
      configurable: true,
      set: $set
    });
    return wrap(tag);
  };

  redefine($Symbol[PROTOTYPE], 'toString', function toString() {
    return this._k;
  });
  $GOPD.f = $getOwnPropertyDescriptor;
  $DP.f = $defineProperty;
  __w_pdfjs_require__(137).f = gOPNExt.f = $getOwnPropertyNames;
  __w_pdfjs_require__(78).f = $propertyIsEnumerable;
  __w_pdfjs_require__(77).f = $getOwnPropertySymbols;

  if (DESCRIPTORS && !__w_pdfjs_require__(37)) {
    redefine(ObjectProto, 'propertyIsEnumerable', $propertyIsEnumerable, true);
  }

  wksExt.f = function (name) {
    return wrap(wks(name));
  };
}

$export($export.G + $export.W + $export.F * !USE_NATIVE, {
  Symbol: $Symbol
});

for (var es6Symbols = 'hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables'.split(','), j = 0; es6Symbols.length > j;) {
  wks(es6Symbols[j++]);
}

for (var wellKnownSymbols = $keys(wks.store), k = 0; wellKnownSymbols.length > k;) {
  wksDefine(wellKnownSymbols[k++]);
}

$export($export.S + $export.F * !USE_NATIVE, 'Symbol', {
  'for': function _for(key) {
    return has(SymbolRegistry, key += '') ? SymbolRegistry[key] : SymbolRegistry[key] = $Symbol(key);
  },
  keyFor: function keyFor(sym) {
    if (!isSymbol(sym)) throw TypeError(sym + ' is not a symbol!');

    for (var key in SymbolRegistry) {
      if (SymbolRegistry[key] === sym) return key;
    }
  },
  useSetter: function useSetter() {
    setter = true;
  },
  useSimple: function useSimple() {
    setter = false;
  }
});
$export($export.S + $export.F * !USE_NATIVE, 'Object', {
  create: $create,
  defineProperty: $defineProperty,
  defineProperties: $defineProperties,
  getOwnPropertyDescriptor: $getOwnPropertyDescriptor,
  getOwnPropertyNames: $getOwnPropertyNames,
  getOwnPropertySymbols: $getOwnPropertySymbols
});
$JSON && $export($export.S + $export.F * (!USE_NATIVE || $fails(function () {
  var S = $Symbol();
  return _stringify([S]) != '[null]' || _stringify({
    a: S
  }) != '{}' || _stringify(Object(S)) != '{}';
})), 'JSON', {
  stringify: function stringify(it) {
    var args = [it];
    var i = 1;
    var replacer, $replacer;

    while (arguments.length > i) {
      args.push(arguments[i++]);
    }

    $replacer = replacer = args[1];
    if (!isObject(replacer) && it === undefined || isSymbol(it)) return;
    if (!isArray(replacer)) replacer = function replacer(key, value) {
      if (typeof $replacer == 'function') value = $replacer.call(this, key, value);
      if (!isSymbol(value)) return value;
    };
    args[1] = replacer;
    return _stringify.apply($JSON, args);
  }
});
$Symbol[PROTOTYPE][TO_PRIMITIVE] || __w_pdfjs_require__(15)($Symbol[PROTOTYPE], TO_PRIMITIVE, $Symbol[PROTOTYPE].valueOf);
setToStringTag($Symbol, 'Symbol');
setToStringTag(Math, 'Math', true);
setToStringTag(global.JSON, 'JSON', true);

/***/ }),
/* 133 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


exports.f = __w_pdfjs_require__(35);

/***/ }),
/* 134 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var global = __w_pdfjs_require__(13);

var core = __w_pdfjs_require__(14);

var LIBRARY = __w_pdfjs_require__(37);

var wksExt = __w_pdfjs_require__(133);

var defineProperty = __w_pdfjs_require__(16).f;

module.exports = function (name) {
  var $Symbol = core.Symbol || (core.Symbol = LIBRARY ? {} : global.Symbol || {});
  if (name.charAt(0) != '_' && !(name in $Symbol)) defineProperty($Symbol, name, {
    value: wksExt.f(name)
  });
};

/***/ }),
/* 135 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var getKeys = __w_pdfjs_require__(59);

var gOPS = __w_pdfjs_require__(77);

var pIE = __w_pdfjs_require__(78);

module.exports = function (it) {
  var result = getKeys(it);
  var getSymbols = gOPS.f;

  if (getSymbols) {
    var symbols = getSymbols(it);
    var isEnum = pIE.f;
    var i = 0;
    var key;

    while (symbols.length > i) {
      if (isEnum.call(it, key = symbols[i++])) result.push(key);
    }
  }

  return result;
};

/***/ }),
/* 136 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var toIObject = __w_pdfjs_require__(47);

var gOPN = __w_pdfjs_require__(137).f;

var toString = {}.toString;
var windowNames = (typeof window === "undefined" ? "undefined" : _typeof(window)) == 'object' && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];

var getWindowNames = function getWindowNames(it) {
  try {
    return gOPN(it);
  } catch (e) {
    return windowNames.slice();
  }
};

module.exports.f = function getOwnPropertyNames(it) {
  return windowNames && toString.call(it) == '[object Window]' ? getWindowNames(it) : gOPN(toIObject(it));
};

/***/ }),
/* 137 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $keys = __w_pdfjs_require__(60);

var hiddenKeys = __w_pdfjs_require__(62).concat('length', 'prototype');

exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return $keys(O, hiddenKeys);
};

/***/ }),
/* 138 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(139);

module.exports = __w_pdfjs_require__(14).String.padStart;

/***/ }),
/* 139 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var $pad = __w_pdfjs_require__(140);

var userAgent = __w_pdfjs_require__(100);

$export($export.P + $export.F * /Version\/10\.\d+(\.\d+)? Safari\//.test(userAgent), 'String', {
  padStart: function padStart(maxLength) {
    return $pad(this, maxLength, arguments.length > 1 ? arguments[1] : undefined, true);
  }
});

/***/ }),
/* 140 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toLength = __w_pdfjs_require__(30);

var repeat = __w_pdfjs_require__(141);

var defined = __w_pdfjs_require__(38);

module.exports = function (that, maxLength, fillString, left) {
  var S = String(defined(that));
  var stringLength = S.length;
  var fillStr = fillString === undefined ? ' ' : String(fillString);
  var intMaxLength = toLength(maxLength);
  if (intMaxLength <= stringLength || fillStr == '') return S;
  var fillLen = intMaxLength - stringLength;
  var stringFiller = repeat.call(fillStr, Math.ceil(fillLen / fillStr.length));
  if (stringFiller.length > fillLen) stringFiller = stringFiller.slice(0, fillLen);
  return left ? stringFiller + S : S + stringFiller;
};

/***/ }),
/* 141 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var toInteger = __w_pdfjs_require__(31);

var defined = __w_pdfjs_require__(38);

module.exports = function repeat(count) {
  var str = String(defined(this));
  var res = '';
  var n = toInteger(count);
  if (n < 0 || n == Infinity) throw RangeError("Count can't be negative");

  for (; n > 0; (n >>>= 1) && (str += str)) {
    if (n & 1) res += str;
  }

  return res;
};

/***/ }),
/* 142 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(143);

module.exports = __w_pdfjs_require__(14).String.padEnd;

/***/ }),
/* 143 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var $pad = __w_pdfjs_require__(140);

var userAgent = __w_pdfjs_require__(100);

$export($export.P + $export.F * /Version\/10\.\d+(\.\d+)? Safari\//.test(userAgent), 'String', {
  padEnd: function padEnd(maxLength) {
    return $pad(this, maxLength, arguments.length > 1 ? arguments[1] : undefined, false);
  }
});

/***/ }),
/* 144 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


__w_pdfjs_require__(145);

module.exports = __w_pdfjs_require__(14).Object.values;

/***/ }),
/* 145 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var $export = __w_pdfjs_require__(12);

var $values = __w_pdfjs_require__(146)(false);

$export($export.S, 'Object', {
  values: function values(it) {
    return $values(it);
  }
});

/***/ }),
/* 146 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


var getKeys = __w_pdfjs_require__(59);

var toIObject = __w_pdfjs_require__(47);

var isEnum = __w_pdfjs_require__(78).f;

module.exports = function (isEntries) {
  return function (it) {
    var O = toIObject(it);
    var keys = getKeys(O);
    var length = keys.length;
    var i = 0;
    var result = [];
    var key;

    while (length > i) {
      if (isEnum.call(O, key = keys[i++])) {
        result.push(isEntries ? [key, O[key]] : O[key]);
      }
    }

    return result;
  };
};

/***/ }),
/* 147 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


{
  var isReadableStreamSupported = false;

  if (typeof ReadableStream !== 'undefined') {
    try {
      new ReadableStream({
        start: function start(controller) {
          controller.close();
        }
      });
      isReadableStreamSupported = true;
    } catch (e) {}
  }

  if (isReadableStreamSupported) {
    exports.ReadableStream = ReadableStream;
  } else {
    exports.ReadableStream = __w_pdfjs_require__(148).ReadableStream;
  }
}

/***/ }),
/* 148 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

(function (e, a) {
  for (var i in a) {
    e[i] = a[i];
  }
})(exports, function (modules) {
  var installedModules = {};

  function __w_pdfjs_require__(moduleId) {
    if (installedModules[moduleId]) return installedModules[moduleId].exports;
    var module = installedModules[moduleId] = {
      i: moduleId,
      l: false,
      exports: {}
    };
    modules[moduleId].call(module.exports, module, module.exports, __w_pdfjs_require__);
    module.l = true;
    return module.exports;
  }

  __w_pdfjs_require__.m = modules;
  __w_pdfjs_require__.c = installedModules;

  __w_pdfjs_require__.i = function (value) {
    return value;
  };

  __w_pdfjs_require__.d = function (exports, name, getter) {
    if (!__w_pdfjs_require__.o(exports, name)) {
      Object.defineProperty(exports, name, {
        configurable: false,
        enumerable: true,
        get: getter
      });
    }
  };

  __w_pdfjs_require__.n = function (module) {
    var getter = module && module.__esModule ? function getDefault() {
      return module['default'];
    } : function getModuleExports() {
      return module;
    };

    __w_pdfjs_require__.d(getter, 'a', getter);

    return getter;
  };

  __w_pdfjs_require__.o = function (object, property) {
    return Object.prototype.hasOwnProperty.call(object, property);
  };

  __w_pdfjs_require__.p = "";
  return __w_pdfjs_require__(__w_pdfjs_require__.s = 7);
}([function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _typeof = typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol" ? function (obj) {
    return _typeof2(obj);
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
  };

  var _require = __w_pdfjs_require__(1),
      assert = _require.assert;

  function IsPropertyKey(argument) {
    return typeof argument === 'string' || (typeof argument === 'undefined' ? 'undefined' : _typeof(argument)) === 'symbol';
  }

  exports.typeIsObject = function (x) {
    return (typeof x === 'undefined' ? 'undefined' : _typeof(x)) === 'object' && x !== null || typeof x === 'function';
  };

  exports.createDataProperty = function (o, p, v) {
    assert(exports.typeIsObject(o));
    Object.defineProperty(o, p, {
      value: v,
      writable: true,
      enumerable: true,
      configurable: true
    });
  };

  exports.createArrayFromList = function (elements) {
    return elements.slice();
  };

  exports.ArrayBufferCopy = function (dest, destOffset, src, srcOffset, n) {
    new Uint8Array(dest).set(new Uint8Array(src, srcOffset, n), destOffset);
  };

  exports.CreateIterResultObject = function (value, done) {
    assert(typeof done === 'boolean');
    var obj = {};
    Object.defineProperty(obj, 'value', {
      value: value,
      enumerable: true,
      writable: true,
      configurable: true
    });
    Object.defineProperty(obj, 'done', {
      value: done,
      enumerable: true,
      writable: true,
      configurable: true
    });
    return obj;
  };

  exports.IsFiniteNonNegativeNumber = function (v) {
    if (Number.isNaN(v)) {
      return false;
    }

    if (v === Infinity) {
      return false;
    }

    if (v < 0) {
      return false;
    }

    return true;
  };

  function Call(F, V, args) {
    if (typeof F !== 'function') {
      throw new TypeError('Argument is not a function');
    }

    return Function.prototype.apply.call(F, V, args);
  }

  exports.InvokeOrNoop = function (O, P, args) {
    assert(O !== undefined);
    assert(IsPropertyKey(P));
    assert(Array.isArray(args));
    var method = O[P];

    if (method === undefined) {
      return undefined;
    }

    return Call(method, O, args);
  };

  exports.PromiseInvokeOrNoop = function (O, P, args) {
    assert(O !== undefined);
    assert(IsPropertyKey(P));
    assert(Array.isArray(args));

    try {
      return Promise.resolve(exports.InvokeOrNoop(O, P, args));
    } catch (returnValueE) {
      return Promise.reject(returnValueE);
    }
  };

  exports.PromiseInvokeOrPerformFallback = function (O, P, args, F, argsF) {
    assert(O !== undefined);
    assert(IsPropertyKey(P));
    assert(Array.isArray(args));
    assert(Array.isArray(argsF));
    var method = void 0;

    try {
      method = O[P];
    } catch (methodE) {
      return Promise.reject(methodE);
    }

    if (method === undefined) {
      return F.apply(null, argsF);
    }

    try {
      return Promise.resolve(Call(method, O, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  exports.TransferArrayBuffer = function (O) {
    return O.slice();
  };

  exports.ValidateAndNormalizeHighWaterMark = function (highWaterMark) {
    highWaterMark = Number(highWaterMark);

    if (Number.isNaN(highWaterMark) || highWaterMark < 0) {
      throw new RangeError('highWaterMark property of a queuing strategy must be non-negative and non-NaN');
    }

    return highWaterMark;
  };

  exports.ValidateAndNormalizeQueuingStrategy = function (size, highWaterMark) {
    if (size !== undefined && typeof size !== 'function') {
      throw new TypeError('size property of a queuing strategy must be a function');
    }

    highWaterMark = exports.ValidateAndNormalizeHighWaterMark(highWaterMark);
    return {
      size: size,
      highWaterMark: highWaterMark
    };
  };
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  function rethrowAssertionErrorRejection(e) {
    if (e && e.constructor === AssertionError) {
      setTimeout(function () {
        throw e;
      }, 0);
    }
  }

  function AssertionError(message) {
    this.name = 'AssertionError';
    this.message = message || '';
    this.stack = new Error().stack;
  }

  AssertionError.prototype = Object.create(Error.prototype);
  AssertionError.prototype.constructor = AssertionError;

  function assert(value, message) {
    if (!value) {
      throw new AssertionError(message);
    }
  }

  module.exports = {
    rethrowAssertionErrorRejection: rethrowAssertionErrorRejection,
    AssertionError: AssertionError,
    assert: assert
  };
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _require = __w_pdfjs_require__(0),
      InvokeOrNoop = _require.InvokeOrNoop,
      PromiseInvokeOrNoop = _require.PromiseInvokeOrNoop,
      ValidateAndNormalizeQueuingStrategy = _require.ValidateAndNormalizeQueuingStrategy,
      typeIsObject = _require.typeIsObject;

  var _require2 = __w_pdfjs_require__(1),
      assert = _require2.assert,
      rethrowAssertionErrorRejection = _require2.rethrowAssertionErrorRejection;

  var _require3 = __w_pdfjs_require__(3),
      DequeueValue = _require3.DequeueValue,
      EnqueueValueWithSize = _require3.EnqueueValueWithSize,
      PeekQueueValue = _require3.PeekQueueValue,
      ResetQueue = _require3.ResetQueue;

  var WritableStream = function () {
    function WritableStream() {
      var underlyingSink = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          size = _ref.size,
          _ref$highWaterMark = _ref.highWaterMark,
          highWaterMark = _ref$highWaterMark === undefined ? 1 : _ref$highWaterMark;

      _classCallCheck(this, WritableStream);

      this._state = 'writable';
      this._storedError = undefined;
      this._writer = undefined;
      this._writableStreamController = undefined;
      this._writeRequests = [];
      this._inFlightWriteRequest = undefined;
      this._closeRequest = undefined;
      this._inFlightCloseRequest = undefined;
      this._pendingAbortRequest = undefined;
      this._backpressure = false;
      var type = underlyingSink.type;

      if (type !== undefined) {
        throw new RangeError('Invalid type is specified');
      }

      this._writableStreamController = new WritableStreamDefaultController(this, underlyingSink, size, highWaterMark);

      this._writableStreamController.__startSteps();
    }

    _createClass(WritableStream, [{
      key: 'abort',
      value: function abort(reason) {
        if (IsWritableStream(this) === false) {
          return Promise.reject(streamBrandCheckException('abort'));
        }

        if (IsWritableStreamLocked(this) === true) {
          return Promise.reject(new TypeError('Cannot abort a stream that already has a writer'));
        }

        return WritableStreamAbort(this, reason);
      }
    }, {
      key: 'getWriter',
      value: function getWriter() {
        if (IsWritableStream(this) === false) {
          throw streamBrandCheckException('getWriter');
        }

        return AcquireWritableStreamDefaultWriter(this);
      }
    }, {
      key: 'locked',
      get: function get() {
        if (IsWritableStream(this) === false) {
          throw streamBrandCheckException('locked');
        }

        return IsWritableStreamLocked(this);
      }
    }]);

    return WritableStream;
  }();

  module.exports = {
    AcquireWritableStreamDefaultWriter: AcquireWritableStreamDefaultWriter,
    IsWritableStream: IsWritableStream,
    IsWritableStreamLocked: IsWritableStreamLocked,
    WritableStream: WritableStream,
    WritableStreamAbort: WritableStreamAbort,
    WritableStreamDefaultControllerError: WritableStreamDefaultControllerError,
    WritableStreamDefaultWriterCloseWithErrorPropagation: WritableStreamDefaultWriterCloseWithErrorPropagation,
    WritableStreamDefaultWriterRelease: WritableStreamDefaultWriterRelease,
    WritableStreamDefaultWriterWrite: WritableStreamDefaultWriterWrite,
    WritableStreamCloseQueuedOrInFlight: WritableStreamCloseQueuedOrInFlight
  };

  function AcquireWritableStreamDefaultWriter(stream) {
    return new WritableStreamDefaultWriter(stream);
  }

  function IsWritableStream(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_writableStreamController')) {
      return false;
    }

    return true;
  }

  function IsWritableStreamLocked(stream) {
    assert(IsWritableStream(stream) === true, 'IsWritableStreamLocked should only be used on known writable streams');

    if (stream._writer === undefined) {
      return false;
    }

    return true;
  }

  function WritableStreamAbort(stream, reason) {
    var state = stream._state;

    if (state === 'closed') {
      return Promise.resolve(undefined);
    }

    if (state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    var error = new TypeError('Requested to abort');

    if (stream._pendingAbortRequest !== undefined) {
      return Promise.reject(error);
    }

    assert(state === 'writable' || state === 'erroring', 'state must be writable or erroring');
    var wasAlreadyErroring = false;

    if (state === 'erroring') {
      wasAlreadyErroring = true;
      reason = undefined;
    }

    var promise = new Promise(function (resolve, reject) {
      stream._pendingAbortRequest = {
        _resolve: resolve,
        _reject: reject,
        _reason: reason,
        _wasAlreadyErroring: wasAlreadyErroring
      };
    });

    if (wasAlreadyErroring === false) {
      WritableStreamStartErroring(stream, error);
    }

    return promise;
  }

  function WritableStreamAddWriteRequest(stream) {
    assert(IsWritableStreamLocked(stream) === true);
    assert(stream._state === 'writable');
    var promise = new Promise(function (resolve, reject) {
      var writeRequest = {
        _resolve: resolve,
        _reject: reject
      };

      stream._writeRequests.push(writeRequest);
    });
    return promise;
  }

  function WritableStreamDealWithRejection(stream, error) {
    var state = stream._state;

    if (state === 'writable') {
      WritableStreamStartErroring(stream, error);
      return;
    }

    assert(state === 'erroring');
    WritableStreamFinishErroring(stream);
  }

  function WritableStreamStartErroring(stream, reason) {
    assert(stream._storedError === undefined, 'stream._storedError === undefined');
    assert(stream._state === 'writable', 'state must be writable');
    var controller = stream._writableStreamController;
    assert(controller !== undefined, 'controller must not be undefined');
    stream._state = 'erroring';
    stream._storedError = reason;
    var writer = stream._writer;

    if (writer !== undefined) {
      WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, reason);
    }

    if (WritableStreamHasOperationMarkedInFlight(stream) === false && controller._started === true) {
      WritableStreamFinishErroring(stream);
    }
  }

  function WritableStreamFinishErroring(stream) {
    assert(stream._state === 'erroring', 'stream._state === erroring');
    assert(WritableStreamHasOperationMarkedInFlight(stream) === false, 'WritableStreamHasOperationMarkedInFlight(stream) === false');
    stream._state = 'errored';

    stream._writableStreamController.__errorSteps();

    var storedError = stream._storedError;

    for (var i = 0; i < stream._writeRequests.length; i++) {
      var writeRequest = stream._writeRequests[i];

      writeRequest._reject(storedError);
    }

    stream._writeRequests = [];

    if (stream._pendingAbortRequest === undefined) {
      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
      return;
    }

    var abortRequest = stream._pendingAbortRequest;
    stream._pendingAbortRequest = undefined;

    if (abortRequest._wasAlreadyErroring === true) {
      abortRequest._reject(storedError);

      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
      return;
    }

    var promise = stream._writableStreamController.__abortSteps(abortRequest._reason);

    promise.then(function () {
      abortRequest._resolve();

      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
    }, function (reason) {
      abortRequest._reject(reason);

      WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
    });
  }

  function WritableStreamFinishInFlightWrite(stream) {
    assert(stream._inFlightWriteRequest !== undefined);

    stream._inFlightWriteRequest._resolve(undefined);

    stream._inFlightWriteRequest = undefined;
  }

  function WritableStreamFinishInFlightWriteWithError(stream, error) {
    assert(stream._inFlightWriteRequest !== undefined);

    stream._inFlightWriteRequest._reject(error);

    stream._inFlightWriteRequest = undefined;
    assert(stream._state === 'writable' || stream._state === 'erroring');
    WritableStreamDealWithRejection(stream, error);
  }

  function WritableStreamFinishInFlightClose(stream) {
    assert(stream._inFlightCloseRequest !== undefined);

    stream._inFlightCloseRequest._resolve(undefined);

    stream._inFlightCloseRequest = undefined;
    var state = stream._state;
    assert(state === 'writable' || state === 'erroring');

    if (state === 'erroring') {
      stream._storedError = undefined;

      if (stream._pendingAbortRequest !== undefined) {
        stream._pendingAbortRequest._resolve();

        stream._pendingAbortRequest = undefined;
      }
    }

    stream._state = 'closed';
    var writer = stream._writer;

    if (writer !== undefined) {
      defaultWriterClosedPromiseResolve(writer);
    }

    assert(stream._pendingAbortRequest === undefined, 'stream._pendingAbortRequest === undefined');
    assert(stream._storedError === undefined, 'stream._storedError === undefined');
  }

  function WritableStreamFinishInFlightCloseWithError(stream, error) {
    assert(stream._inFlightCloseRequest !== undefined);

    stream._inFlightCloseRequest._reject(error);

    stream._inFlightCloseRequest = undefined;
    assert(stream._state === 'writable' || stream._state === 'erroring');

    if (stream._pendingAbortRequest !== undefined) {
      stream._pendingAbortRequest._reject(error);

      stream._pendingAbortRequest = undefined;
    }

    WritableStreamDealWithRejection(stream, error);
  }

  function WritableStreamCloseQueuedOrInFlight(stream) {
    if (stream._closeRequest === undefined && stream._inFlightCloseRequest === undefined) {
      return false;
    }

    return true;
  }

  function WritableStreamHasOperationMarkedInFlight(stream) {
    if (stream._inFlightWriteRequest === undefined && stream._inFlightCloseRequest === undefined) {
      return false;
    }

    return true;
  }

  function WritableStreamMarkCloseRequestInFlight(stream) {
    assert(stream._inFlightCloseRequest === undefined);
    assert(stream._closeRequest !== undefined);
    stream._inFlightCloseRequest = stream._closeRequest;
    stream._closeRequest = undefined;
  }

  function WritableStreamMarkFirstWriteRequestInFlight(stream) {
    assert(stream._inFlightWriteRequest === undefined, 'there must be no pending write request');
    assert(stream._writeRequests.length !== 0, 'writeRequests must not be empty');
    stream._inFlightWriteRequest = stream._writeRequests.shift();
  }

  function WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream) {
    assert(stream._state === 'errored', '_stream_.[[state]] is `"errored"`');

    if (stream._closeRequest !== undefined) {
      assert(stream._inFlightCloseRequest === undefined);

      stream._closeRequest._reject(stream._storedError);

      stream._closeRequest = undefined;
    }

    var writer = stream._writer;

    if (writer !== undefined) {
      defaultWriterClosedPromiseReject(writer, stream._storedError);

      writer._closedPromise.catch(function () {});
    }
  }

  function WritableStreamUpdateBackpressure(stream, backpressure) {
    assert(stream._state === 'writable');
    assert(WritableStreamCloseQueuedOrInFlight(stream) === false);
    var writer = stream._writer;

    if (writer !== undefined && backpressure !== stream._backpressure) {
      if (backpressure === true) {
        defaultWriterReadyPromiseReset(writer);
      } else {
        assert(backpressure === false);
        defaultWriterReadyPromiseResolve(writer);
      }
    }

    stream._backpressure = backpressure;
  }

  var WritableStreamDefaultWriter = function () {
    function WritableStreamDefaultWriter(stream) {
      _classCallCheck(this, WritableStreamDefaultWriter);

      if (IsWritableStream(stream) === false) {
        throw new TypeError('WritableStreamDefaultWriter can only be constructed with a WritableStream instance');
      }

      if (IsWritableStreamLocked(stream) === true) {
        throw new TypeError('This stream has already been locked for exclusive writing by another writer');
      }

      this._ownerWritableStream = stream;
      stream._writer = this;
      var state = stream._state;

      if (state === 'writable') {
        if (WritableStreamCloseQueuedOrInFlight(stream) === false && stream._backpressure === true) {
          defaultWriterReadyPromiseInitialize(this);
        } else {
          defaultWriterReadyPromiseInitializeAsResolved(this);
        }

        defaultWriterClosedPromiseInitialize(this);
      } else if (state === 'erroring') {
        defaultWriterReadyPromiseInitializeAsRejected(this, stream._storedError);

        this._readyPromise.catch(function () {});

        defaultWriterClosedPromiseInitialize(this);
      } else if (state === 'closed') {
        defaultWriterReadyPromiseInitializeAsResolved(this);
        defaultWriterClosedPromiseInitializeAsResolved(this);
      } else {
        assert(state === 'errored', 'state must be errored');
        var storedError = stream._storedError;
        defaultWriterReadyPromiseInitializeAsRejected(this, storedError);

        this._readyPromise.catch(function () {});

        defaultWriterClosedPromiseInitializeAsRejected(this, storedError);

        this._closedPromise.catch(function () {});
      }
    }

    _createClass(WritableStreamDefaultWriter, [{
      key: 'abort',
      value: function abort(reason) {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('abort'));
        }

        if (this._ownerWritableStream === undefined) {
          return Promise.reject(defaultWriterLockException('abort'));
        }

        return WritableStreamDefaultWriterAbort(this, reason);
      }
    }, {
      key: 'close',
      value: function close() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('close'));
        }

        var stream = this._ownerWritableStream;

        if (stream === undefined) {
          return Promise.reject(defaultWriterLockException('close'));
        }

        if (WritableStreamCloseQueuedOrInFlight(stream) === true) {
          return Promise.reject(new TypeError('cannot close an already-closing stream'));
        }

        return WritableStreamDefaultWriterClose(this);
      }
    }, {
      key: 'releaseLock',
      value: function releaseLock() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          throw defaultWriterBrandCheckException('releaseLock');
        }

        var stream = this._ownerWritableStream;

        if (stream === undefined) {
          return;
        }

        assert(stream._writer !== undefined);
        WritableStreamDefaultWriterRelease(this);
      }
    }, {
      key: 'write',
      value: function write(chunk) {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('write'));
        }

        if (this._ownerWritableStream === undefined) {
          return Promise.reject(defaultWriterLockException('write to'));
        }

        return WritableStreamDefaultWriterWrite(this, chunk);
      }
    }, {
      key: 'closed',
      get: function get() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('closed'));
        }

        return this._closedPromise;
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          throw defaultWriterBrandCheckException('desiredSize');
        }

        if (this._ownerWritableStream === undefined) {
          throw defaultWriterLockException('desiredSize');
        }

        return WritableStreamDefaultWriterGetDesiredSize(this);
      }
    }, {
      key: 'ready',
      get: function get() {
        if (IsWritableStreamDefaultWriter(this) === false) {
          return Promise.reject(defaultWriterBrandCheckException('ready'));
        }

        return this._readyPromise;
      }
    }]);

    return WritableStreamDefaultWriter;
  }();

  function IsWritableStreamDefaultWriter(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_ownerWritableStream')) {
      return false;
    }

    return true;
  }

  function WritableStreamDefaultWriterAbort(writer, reason) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    return WritableStreamAbort(stream, reason);
  }

  function WritableStreamDefaultWriterClose(writer) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    var state = stream._state;

    if (state === 'closed' || state === 'errored') {
      return Promise.reject(new TypeError('The stream (in ' + state + ' state) is not in the writable state and cannot be closed'));
    }

    assert(state === 'writable' || state === 'erroring');
    assert(WritableStreamCloseQueuedOrInFlight(stream) === false);
    var promise = new Promise(function (resolve, reject) {
      var closeRequest = {
        _resolve: resolve,
        _reject: reject
      };
      stream._closeRequest = closeRequest;
    });

    if (stream._backpressure === true && state === 'writable') {
      defaultWriterReadyPromiseResolve(writer);
    }

    WritableStreamDefaultControllerClose(stream._writableStreamController);
    return promise;
  }

  function WritableStreamDefaultWriterCloseWithErrorPropagation(writer) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    var state = stream._state;

    if (WritableStreamCloseQueuedOrInFlight(stream) === true || state === 'closed') {
      return Promise.resolve();
    }

    if (state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    assert(state === 'writable' || state === 'erroring');
    return WritableStreamDefaultWriterClose(writer);
  }

  function WritableStreamDefaultWriterEnsureClosedPromiseRejected(writer, error) {
    if (writer._closedPromiseState === 'pending') {
      defaultWriterClosedPromiseReject(writer, error);
    } else {
      defaultWriterClosedPromiseResetToRejected(writer, error);
    }

    writer._closedPromise.catch(function () {});
  }

  function WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, error) {
    if (writer._readyPromiseState === 'pending') {
      defaultWriterReadyPromiseReject(writer, error);
    } else {
      defaultWriterReadyPromiseResetToRejected(writer, error);
    }

    writer._readyPromise.catch(function () {});
  }

  function WritableStreamDefaultWriterGetDesiredSize(writer) {
    var stream = writer._ownerWritableStream;
    var state = stream._state;

    if (state === 'errored' || state === 'erroring') {
      return null;
    }

    if (state === 'closed') {
      return 0;
    }

    return WritableStreamDefaultControllerGetDesiredSize(stream._writableStreamController);
  }

  function WritableStreamDefaultWriterRelease(writer) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    assert(stream._writer === writer);
    var releasedError = new TypeError('Writer was released and can no longer be used to monitor the stream\'s closedness');
    WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, releasedError);
    WritableStreamDefaultWriterEnsureClosedPromiseRejected(writer, releasedError);
    stream._writer = undefined;
    writer._ownerWritableStream = undefined;
  }

  function WritableStreamDefaultWriterWrite(writer, chunk) {
    var stream = writer._ownerWritableStream;
    assert(stream !== undefined);
    var controller = stream._writableStreamController;
    var chunkSize = WritableStreamDefaultControllerGetChunkSize(controller, chunk);

    if (stream !== writer._ownerWritableStream) {
      return Promise.reject(defaultWriterLockException('write to'));
    }

    var state = stream._state;

    if (state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    if (WritableStreamCloseQueuedOrInFlight(stream) === true || state === 'closed') {
      return Promise.reject(new TypeError('The stream is closing or closed and cannot be written to'));
    }

    if (state === 'erroring') {
      return Promise.reject(stream._storedError);
    }

    assert(state === 'writable');
    var promise = WritableStreamAddWriteRequest(stream);
    WritableStreamDefaultControllerWrite(controller, chunk, chunkSize);
    return promise;
  }

  var WritableStreamDefaultController = function () {
    function WritableStreamDefaultController(stream, underlyingSink, size, highWaterMark) {
      _classCallCheck(this, WritableStreamDefaultController);

      if (IsWritableStream(stream) === false) {
        throw new TypeError('WritableStreamDefaultController can only be constructed with a WritableStream instance');
      }

      if (stream._writableStreamController !== undefined) {
        throw new TypeError('WritableStreamDefaultController instances can only be created by the WritableStream constructor');
      }

      this._controlledWritableStream = stream;
      this._underlyingSink = underlyingSink;
      this._queue = undefined;
      this._queueTotalSize = undefined;
      ResetQueue(this);
      this._started = false;
      var normalizedStrategy = ValidateAndNormalizeQueuingStrategy(size, highWaterMark);
      this._strategySize = normalizedStrategy.size;
      this._strategyHWM = normalizedStrategy.highWaterMark;
      var backpressure = WritableStreamDefaultControllerGetBackpressure(this);
      WritableStreamUpdateBackpressure(stream, backpressure);
    }

    _createClass(WritableStreamDefaultController, [{
      key: 'error',
      value: function error(e) {
        if (IsWritableStreamDefaultController(this) === false) {
          throw new TypeError('WritableStreamDefaultController.prototype.error can only be used on a WritableStreamDefaultController');
        }

        var state = this._controlledWritableStream._state;

        if (state !== 'writable') {
          return;
        }

        WritableStreamDefaultControllerError(this, e);
      }
    }, {
      key: '__abortSteps',
      value: function __abortSteps(reason) {
        return PromiseInvokeOrNoop(this._underlyingSink, 'abort', [reason]);
      }
    }, {
      key: '__errorSteps',
      value: function __errorSteps() {
        ResetQueue(this);
      }
    }, {
      key: '__startSteps',
      value: function __startSteps() {
        var _this = this;

        var startResult = InvokeOrNoop(this._underlyingSink, 'start', [this]);
        var stream = this._controlledWritableStream;
        Promise.resolve(startResult).then(function () {
          assert(stream._state === 'writable' || stream._state === 'erroring');
          _this._started = true;
          WritableStreamDefaultControllerAdvanceQueueIfNeeded(_this);
        }, function (r) {
          assert(stream._state === 'writable' || stream._state === 'erroring');
          _this._started = true;
          WritableStreamDealWithRejection(stream, r);
        }).catch(rethrowAssertionErrorRejection);
      }
    }]);

    return WritableStreamDefaultController;
  }();

  function WritableStreamDefaultControllerClose(controller) {
    EnqueueValueWithSize(controller, 'close', 0);
    WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
  }

  function WritableStreamDefaultControllerGetChunkSize(controller, chunk) {
    var strategySize = controller._strategySize;

    if (strategySize === undefined) {
      return 1;
    }

    try {
      return strategySize(chunk);
    } catch (chunkSizeE) {
      WritableStreamDefaultControllerErrorIfNeeded(controller, chunkSizeE);
      return 1;
    }
  }

  function WritableStreamDefaultControllerGetDesiredSize(controller) {
    return controller._strategyHWM - controller._queueTotalSize;
  }

  function WritableStreamDefaultControllerWrite(controller, chunk, chunkSize) {
    var writeRecord = {
      chunk: chunk
    };

    try {
      EnqueueValueWithSize(controller, writeRecord, chunkSize);
    } catch (enqueueE) {
      WritableStreamDefaultControllerErrorIfNeeded(controller, enqueueE);
      return;
    }

    var stream = controller._controlledWritableStream;

    if (WritableStreamCloseQueuedOrInFlight(stream) === false && stream._state === 'writable') {
      var backpressure = WritableStreamDefaultControllerGetBackpressure(controller);
      WritableStreamUpdateBackpressure(stream, backpressure);
    }

    WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
  }

  function IsWritableStreamDefaultController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_underlyingSink')) {
      return false;
    }

    return true;
  }

  function WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller) {
    var stream = controller._controlledWritableStream;

    if (controller._started === false) {
      return;
    }

    if (stream._inFlightWriteRequest !== undefined) {
      return;
    }

    var state = stream._state;

    if (state === 'closed' || state === 'errored') {
      return;
    }

    if (state === 'erroring') {
      WritableStreamFinishErroring(stream);
      return;
    }

    if (controller._queue.length === 0) {
      return;
    }

    var writeRecord = PeekQueueValue(controller);

    if (writeRecord === 'close') {
      WritableStreamDefaultControllerProcessClose(controller);
    } else {
      WritableStreamDefaultControllerProcessWrite(controller, writeRecord.chunk);
    }
  }

  function WritableStreamDefaultControllerErrorIfNeeded(controller, error) {
    if (controller._controlledWritableStream._state === 'writable') {
      WritableStreamDefaultControllerError(controller, error);
    }
  }

  function WritableStreamDefaultControllerProcessClose(controller) {
    var stream = controller._controlledWritableStream;
    WritableStreamMarkCloseRequestInFlight(stream);
    DequeueValue(controller);
    assert(controller._queue.length === 0, 'queue must be empty once the final write record is dequeued');
    var sinkClosePromise = PromiseInvokeOrNoop(controller._underlyingSink, 'close', []);
    sinkClosePromise.then(function () {
      WritableStreamFinishInFlightClose(stream);
    }, function (reason) {
      WritableStreamFinishInFlightCloseWithError(stream, reason);
    }).catch(rethrowAssertionErrorRejection);
  }

  function WritableStreamDefaultControllerProcessWrite(controller, chunk) {
    var stream = controller._controlledWritableStream;
    WritableStreamMarkFirstWriteRequestInFlight(stream);
    var sinkWritePromise = PromiseInvokeOrNoop(controller._underlyingSink, 'write', [chunk, controller]);
    sinkWritePromise.then(function () {
      WritableStreamFinishInFlightWrite(stream);
      var state = stream._state;
      assert(state === 'writable' || state === 'erroring');
      DequeueValue(controller);

      if (WritableStreamCloseQueuedOrInFlight(stream) === false && state === 'writable') {
        var backpressure = WritableStreamDefaultControllerGetBackpressure(controller);
        WritableStreamUpdateBackpressure(stream, backpressure);
      }

      WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
    }, function (reason) {
      WritableStreamFinishInFlightWriteWithError(stream, reason);
    }).catch(rethrowAssertionErrorRejection);
  }

  function WritableStreamDefaultControllerGetBackpressure(controller) {
    var desiredSize = WritableStreamDefaultControllerGetDesiredSize(controller);
    return desiredSize <= 0;
  }

  function WritableStreamDefaultControllerError(controller, error) {
    var stream = controller._controlledWritableStream;
    assert(stream._state === 'writable');
    WritableStreamStartErroring(stream, error);
  }

  function streamBrandCheckException(name) {
    return new TypeError('WritableStream.prototype.' + name + ' can only be used on a WritableStream');
  }

  function defaultWriterBrandCheckException(name) {
    return new TypeError('WritableStreamDefaultWriter.prototype.' + name + ' can only be used on a WritableStreamDefaultWriter');
  }

  function defaultWriterLockException(name) {
    return new TypeError('Cannot ' + name + ' a stream using a released writer');
  }

  function defaultWriterClosedPromiseInitialize(writer) {
    writer._closedPromise = new Promise(function (resolve, reject) {
      writer._closedPromise_resolve = resolve;
      writer._closedPromise_reject = reject;
      writer._closedPromiseState = 'pending';
    });
  }

  function defaultWriterClosedPromiseInitializeAsRejected(writer, reason) {
    writer._closedPromise = Promise.reject(reason);
    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'rejected';
  }

  function defaultWriterClosedPromiseInitializeAsResolved(writer) {
    writer._closedPromise = Promise.resolve(undefined);
    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'resolved';
  }

  function defaultWriterClosedPromiseReject(writer, reason) {
    assert(writer._closedPromise_resolve !== undefined, 'writer._closedPromise_resolve !== undefined');
    assert(writer._closedPromise_reject !== undefined, 'writer._closedPromise_reject !== undefined');
    assert(writer._closedPromiseState === 'pending', 'writer._closedPromiseState is pending');

    writer._closedPromise_reject(reason);

    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'rejected';
  }

  function defaultWriterClosedPromiseResetToRejected(writer, reason) {
    assert(writer._closedPromise_resolve === undefined, 'writer._closedPromise_resolve === undefined');
    assert(writer._closedPromise_reject === undefined, 'writer._closedPromise_reject === undefined');
    assert(writer._closedPromiseState !== 'pending', 'writer._closedPromiseState is not pending');
    writer._closedPromise = Promise.reject(reason);
    writer._closedPromiseState = 'rejected';
  }

  function defaultWriterClosedPromiseResolve(writer) {
    assert(writer._closedPromise_resolve !== undefined, 'writer._closedPromise_resolve !== undefined');
    assert(writer._closedPromise_reject !== undefined, 'writer._closedPromise_reject !== undefined');
    assert(writer._closedPromiseState === 'pending', 'writer._closedPromiseState is pending');

    writer._closedPromise_resolve(undefined);

    writer._closedPromise_resolve = undefined;
    writer._closedPromise_reject = undefined;
    writer._closedPromiseState = 'resolved';
  }

  function defaultWriterReadyPromiseInitialize(writer) {
    writer._readyPromise = new Promise(function (resolve, reject) {
      writer._readyPromise_resolve = resolve;
      writer._readyPromise_reject = reject;
    });
    writer._readyPromiseState = 'pending';
  }

  function defaultWriterReadyPromiseInitializeAsRejected(writer, reason) {
    writer._readyPromise = Promise.reject(reason);
    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'rejected';
  }

  function defaultWriterReadyPromiseInitializeAsResolved(writer) {
    writer._readyPromise = Promise.resolve(undefined);
    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'fulfilled';
  }

  function defaultWriterReadyPromiseReject(writer, reason) {
    assert(writer._readyPromise_resolve !== undefined, 'writer._readyPromise_resolve !== undefined');
    assert(writer._readyPromise_reject !== undefined, 'writer._readyPromise_reject !== undefined');

    writer._readyPromise_reject(reason);

    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'rejected';
  }

  function defaultWriterReadyPromiseReset(writer) {
    assert(writer._readyPromise_resolve === undefined, 'writer._readyPromise_resolve === undefined');
    assert(writer._readyPromise_reject === undefined, 'writer._readyPromise_reject === undefined');
    writer._readyPromise = new Promise(function (resolve, reject) {
      writer._readyPromise_resolve = resolve;
      writer._readyPromise_reject = reject;
    });
    writer._readyPromiseState = 'pending';
  }

  function defaultWriterReadyPromiseResetToRejected(writer, reason) {
    assert(writer._readyPromise_resolve === undefined, 'writer._readyPromise_resolve === undefined');
    assert(writer._readyPromise_reject === undefined, 'writer._readyPromise_reject === undefined');
    writer._readyPromise = Promise.reject(reason);
    writer._readyPromiseState = 'rejected';
  }

  function defaultWriterReadyPromiseResolve(writer) {
    assert(writer._readyPromise_resolve !== undefined, 'writer._readyPromise_resolve !== undefined');
    assert(writer._readyPromise_reject !== undefined, 'writer._readyPromise_reject !== undefined');

    writer._readyPromise_resolve(undefined);

    writer._readyPromise_resolve = undefined;
    writer._readyPromise_reject = undefined;
    writer._readyPromiseState = 'fulfilled';
  }
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _require = __w_pdfjs_require__(0),
      IsFiniteNonNegativeNumber = _require.IsFiniteNonNegativeNumber;

  var _require2 = __w_pdfjs_require__(1),
      assert = _require2.assert;

  exports.DequeueValue = function (container) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: DequeueValue should only be used on containers with [[queue]] and [[queueTotalSize]].');
    assert(container._queue.length > 0, 'Spec-level failure: should never dequeue from an empty queue.');

    var pair = container._queue.shift();

    container._queueTotalSize -= pair.size;

    if (container._queueTotalSize < 0) {
      container._queueTotalSize = 0;
    }

    return pair.value;
  };

  exports.EnqueueValueWithSize = function (container, value, size) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: EnqueueValueWithSize should only be used on containers with [[queue]] and ' + '[[queueTotalSize]].');
    size = Number(size);

    if (!IsFiniteNonNegativeNumber(size)) {
      throw new RangeError('Size must be a finite, non-NaN, non-negative number.');
    }

    container._queue.push({
      value: value,
      size: size
    });

    container._queueTotalSize += size;
  };

  exports.PeekQueueValue = function (container) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: PeekQueueValue should only be used on containers with [[queue]] and [[queueTotalSize]].');
    assert(container._queue.length > 0, 'Spec-level failure: should never peek at an empty queue.');
    var pair = container._queue[0];
    return pair.value;
  };

  exports.ResetQueue = function (container) {
    assert('_queue' in container && '_queueTotalSize' in container, 'Spec-level failure: ResetQueue should only be used on containers with [[queue]] and [[queueTotalSize]].');
    container._queue = [];
    container._queueTotalSize = 0;
  };
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _require = __w_pdfjs_require__(0),
      ArrayBufferCopy = _require.ArrayBufferCopy,
      CreateIterResultObject = _require.CreateIterResultObject,
      IsFiniteNonNegativeNumber = _require.IsFiniteNonNegativeNumber,
      InvokeOrNoop = _require.InvokeOrNoop,
      PromiseInvokeOrNoop = _require.PromiseInvokeOrNoop,
      TransferArrayBuffer = _require.TransferArrayBuffer,
      ValidateAndNormalizeQueuingStrategy = _require.ValidateAndNormalizeQueuingStrategy,
      ValidateAndNormalizeHighWaterMark = _require.ValidateAndNormalizeHighWaterMark;

  var _require2 = __w_pdfjs_require__(0),
      createArrayFromList = _require2.createArrayFromList,
      createDataProperty = _require2.createDataProperty,
      typeIsObject = _require2.typeIsObject;

  var _require3 = __w_pdfjs_require__(1),
      assert = _require3.assert,
      rethrowAssertionErrorRejection = _require3.rethrowAssertionErrorRejection;

  var _require4 = __w_pdfjs_require__(3),
      DequeueValue = _require4.DequeueValue,
      EnqueueValueWithSize = _require4.EnqueueValueWithSize,
      ResetQueue = _require4.ResetQueue;

  var _require5 = __w_pdfjs_require__(2),
      AcquireWritableStreamDefaultWriter = _require5.AcquireWritableStreamDefaultWriter,
      IsWritableStream = _require5.IsWritableStream,
      IsWritableStreamLocked = _require5.IsWritableStreamLocked,
      WritableStreamAbort = _require5.WritableStreamAbort,
      WritableStreamDefaultWriterCloseWithErrorPropagation = _require5.WritableStreamDefaultWriterCloseWithErrorPropagation,
      WritableStreamDefaultWriterRelease = _require5.WritableStreamDefaultWriterRelease,
      WritableStreamDefaultWriterWrite = _require5.WritableStreamDefaultWriterWrite,
      WritableStreamCloseQueuedOrInFlight = _require5.WritableStreamCloseQueuedOrInFlight;

  var ReadableStream = function () {
    function ReadableStream() {
      var underlyingSource = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          size = _ref.size,
          highWaterMark = _ref.highWaterMark;

      _classCallCheck(this, ReadableStream);

      this._state = 'readable';
      this._reader = undefined;
      this._storedError = undefined;
      this._disturbed = false;
      this._readableStreamController = undefined;
      var type = underlyingSource.type;
      var typeString = String(type);

      if (typeString === 'bytes') {
        if (highWaterMark === undefined) {
          highWaterMark = 0;
        }

        this._readableStreamController = new ReadableByteStreamController(this, underlyingSource, highWaterMark);
      } else if (type === undefined) {
        if (highWaterMark === undefined) {
          highWaterMark = 1;
        }

        this._readableStreamController = new ReadableStreamDefaultController(this, underlyingSource, size, highWaterMark);
      } else {
        throw new RangeError('Invalid type is specified');
      }
    }

    _createClass(ReadableStream, [{
      key: 'cancel',
      value: function cancel(reason) {
        if (IsReadableStream(this) === false) {
          return Promise.reject(streamBrandCheckException('cancel'));
        }

        if (IsReadableStreamLocked(this) === true) {
          return Promise.reject(new TypeError('Cannot cancel a stream that already has a reader'));
        }

        return ReadableStreamCancel(this, reason);
      }
    }, {
      key: 'getReader',
      value: function getReader() {
        var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            mode = _ref2.mode;

        if (IsReadableStream(this) === false) {
          throw streamBrandCheckException('getReader');
        }

        if (mode === undefined) {
          return AcquireReadableStreamDefaultReader(this);
        }

        mode = String(mode);

        if (mode === 'byob') {
          return AcquireReadableStreamBYOBReader(this);
        }

        throw new RangeError('Invalid mode is specified');
      }
    }, {
      key: 'pipeThrough',
      value: function pipeThrough(_ref3, options) {
        var writable = _ref3.writable,
            readable = _ref3.readable;
        var promise = this.pipeTo(writable, options);
        ifIsObjectAndHasAPromiseIsHandledInternalSlotSetPromiseIsHandledToTrue(promise);
        return readable;
      }
    }, {
      key: 'pipeTo',
      value: function pipeTo(dest) {
        var _this = this;

        var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            preventClose = _ref4.preventClose,
            preventAbort = _ref4.preventAbort,
            preventCancel = _ref4.preventCancel;

        if (IsReadableStream(this) === false) {
          return Promise.reject(streamBrandCheckException('pipeTo'));
        }

        if (IsWritableStream(dest) === false) {
          return Promise.reject(new TypeError('ReadableStream.prototype.pipeTo\'s first argument must be a WritableStream'));
        }

        preventClose = Boolean(preventClose);
        preventAbort = Boolean(preventAbort);
        preventCancel = Boolean(preventCancel);

        if (IsReadableStreamLocked(this) === true) {
          return Promise.reject(new TypeError('ReadableStream.prototype.pipeTo cannot be used on a locked ReadableStream'));
        }

        if (IsWritableStreamLocked(dest) === true) {
          return Promise.reject(new TypeError('ReadableStream.prototype.pipeTo cannot be used on a locked WritableStream'));
        }

        var reader = AcquireReadableStreamDefaultReader(this);
        var writer = AcquireWritableStreamDefaultWriter(dest);
        var shuttingDown = false;
        var currentWrite = Promise.resolve();
        return new Promise(function (resolve, reject) {
          function pipeLoop() {
            currentWrite = Promise.resolve();

            if (shuttingDown === true) {
              return Promise.resolve();
            }

            return writer._readyPromise.then(function () {
              return ReadableStreamDefaultReaderRead(reader).then(function (_ref5) {
                var value = _ref5.value,
                    done = _ref5.done;

                if (done === true) {
                  return;
                }

                currentWrite = WritableStreamDefaultWriterWrite(writer, value).catch(function () {});
              });
            }).then(pipeLoop);
          }

          isOrBecomesErrored(_this, reader._closedPromise, function (storedError) {
            if (preventAbort === false) {
              shutdownWithAction(function () {
                return WritableStreamAbort(dest, storedError);
              }, true, storedError);
            } else {
              shutdown(true, storedError);
            }
          });
          isOrBecomesErrored(dest, writer._closedPromise, function (storedError) {
            if (preventCancel === false) {
              shutdownWithAction(function () {
                return ReadableStreamCancel(_this, storedError);
              }, true, storedError);
            } else {
              shutdown(true, storedError);
            }
          });
          isOrBecomesClosed(_this, reader._closedPromise, function () {
            if (preventClose === false) {
              shutdownWithAction(function () {
                return WritableStreamDefaultWriterCloseWithErrorPropagation(writer);
              });
            } else {
              shutdown();
            }
          });

          if (WritableStreamCloseQueuedOrInFlight(dest) === true || dest._state === 'closed') {
            var destClosed = new TypeError('the destination writable stream closed before all data could be piped to it');

            if (preventCancel === false) {
              shutdownWithAction(function () {
                return ReadableStreamCancel(_this, destClosed);
              }, true, destClosed);
            } else {
              shutdown(true, destClosed);
            }
          }

          pipeLoop().catch(function (err) {
            currentWrite = Promise.resolve();
            rethrowAssertionErrorRejection(err);
          });

          function waitForWritesToFinish() {
            var oldCurrentWrite = currentWrite;
            return currentWrite.then(function () {
              return oldCurrentWrite !== currentWrite ? waitForWritesToFinish() : undefined;
            });
          }

          function isOrBecomesErrored(stream, promise, action) {
            if (stream._state === 'errored') {
              action(stream._storedError);
            } else {
              promise.catch(action).catch(rethrowAssertionErrorRejection);
            }
          }

          function isOrBecomesClosed(stream, promise, action) {
            if (stream._state === 'closed') {
              action();
            } else {
              promise.then(action).catch(rethrowAssertionErrorRejection);
            }
          }

          function shutdownWithAction(action, originalIsError, originalError) {
            if (shuttingDown === true) {
              return;
            }

            shuttingDown = true;

            if (dest._state === 'writable' && WritableStreamCloseQueuedOrInFlight(dest) === false) {
              waitForWritesToFinish().then(doTheRest);
            } else {
              doTheRest();
            }

            function doTheRest() {
              action().then(function () {
                return finalize(originalIsError, originalError);
              }, function (newError) {
                return finalize(true, newError);
              }).catch(rethrowAssertionErrorRejection);
            }
          }

          function shutdown(isError, error) {
            if (shuttingDown === true) {
              return;
            }

            shuttingDown = true;

            if (dest._state === 'writable' && WritableStreamCloseQueuedOrInFlight(dest) === false) {
              waitForWritesToFinish().then(function () {
                return finalize(isError, error);
              }).catch(rethrowAssertionErrorRejection);
            } else {
              finalize(isError, error);
            }
          }

          function finalize(isError, error) {
            WritableStreamDefaultWriterRelease(writer);
            ReadableStreamReaderGenericRelease(reader);

            if (isError) {
              reject(error);
            } else {
              resolve(undefined);
            }
          }
        });
      }
    }, {
      key: 'tee',
      value: function tee() {
        if (IsReadableStream(this) === false) {
          throw streamBrandCheckException('tee');
        }

        var branches = ReadableStreamTee(this, false);
        return createArrayFromList(branches);
      }
    }, {
      key: 'locked',
      get: function get() {
        if (IsReadableStream(this) === false) {
          throw streamBrandCheckException('locked');
        }

        return IsReadableStreamLocked(this);
      }
    }]);

    return ReadableStream;
  }();

  module.exports = {
    ReadableStream: ReadableStream,
    IsReadableStreamDisturbed: IsReadableStreamDisturbed,
    ReadableStreamDefaultControllerClose: ReadableStreamDefaultControllerClose,
    ReadableStreamDefaultControllerEnqueue: ReadableStreamDefaultControllerEnqueue,
    ReadableStreamDefaultControllerError: ReadableStreamDefaultControllerError,
    ReadableStreamDefaultControllerGetDesiredSize: ReadableStreamDefaultControllerGetDesiredSize
  };

  function AcquireReadableStreamBYOBReader(stream) {
    return new ReadableStreamBYOBReader(stream);
  }

  function AcquireReadableStreamDefaultReader(stream) {
    return new ReadableStreamDefaultReader(stream);
  }

  function IsReadableStream(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_readableStreamController')) {
      return false;
    }

    return true;
  }

  function IsReadableStreamDisturbed(stream) {
    assert(IsReadableStream(stream) === true, 'IsReadableStreamDisturbed should only be used on known readable streams');
    return stream._disturbed;
  }

  function IsReadableStreamLocked(stream) {
    assert(IsReadableStream(stream) === true, 'IsReadableStreamLocked should only be used on known readable streams');

    if (stream._reader === undefined) {
      return false;
    }

    return true;
  }

  function ReadableStreamTee(stream, cloneForBranch2) {
    assert(IsReadableStream(stream) === true);
    assert(typeof cloneForBranch2 === 'boolean');
    var reader = AcquireReadableStreamDefaultReader(stream);
    var teeState = {
      closedOrErrored: false,
      canceled1: false,
      canceled2: false,
      reason1: undefined,
      reason2: undefined
    };
    teeState.promise = new Promise(function (resolve) {
      teeState._resolve = resolve;
    });
    var pull = create_ReadableStreamTeePullFunction();
    pull._reader = reader;
    pull._teeState = teeState;
    pull._cloneForBranch2 = cloneForBranch2;
    var cancel1 = create_ReadableStreamTeeBranch1CancelFunction();
    cancel1._stream = stream;
    cancel1._teeState = teeState;
    var cancel2 = create_ReadableStreamTeeBranch2CancelFunction();
    cancel2._stream = stream;
    cancel2._teeState = teeState;
    var underlyingSource1 = Object.create(Object.prototype);
    createDataProperty(underlyingSource1, 'pull', pull);
    createDataProperty(underlyingSource1, 'cancel', cancel1);
    var branch1Stream = new ReadableStream(underlyingSource1);
    var underlyingSource2 = Object.create(Object.prototype);
    createDataProperty(underlyingSource2, 'pull', pull);
    createDataProperty(underlyingSource2, 'cancel', cancel2);
    var branch2Stream = new ReadableStream(underlyingSource2);
    pull._branch1 = branch1Stream._readableStreamController;
    pull._branch2 = branch2Stream._readableStreamController;

    reader._closedPromise.catch(function (r) {
      if (teeState.closedOrErrored === true) {
        return;
      }

      ReadableStreamDefaultControllerError(pull._branch1, r);
      ReadableStreamDefaultControllerError(pull._branch2, r);
      teeState.closedOrErrored = true;
    });

    return [branch1Stream, branch2Stream];
  }

  function create_ReadableStreamTeePullFunction() {
    function f() {
      var reader = f._reader,
          branch1 = f._branch1,
          branch2 = f._branch2,
          teeState = f._teeState;
      return ReadableStreamDefaultReaderRead(reader).then(function (result) {
        assert(typeIsObject(result));
        var value = result.value;
        var done = result.done;
        assert(typeof done === 'boolean');

        if (done === true && teeState.closedOrErrored === false) {
          if (teeState.canceled1 === false) {
            ReadableStreamDefaultControllerClose(branch1);
          }

          if (teeState.canceled2 === false) {
            ReadableStreamDefaultControllerClose(branch2);
          }

          teeState.closedOrErrored = true;
        }

        if (teeState.closedOrErrored === true) {
          return;
        }

        var value1 = value;
        var value2 = value;

        if (teeState.canceled1 === false) {
          ReadableStreamDefaultControllerEnqueue(branch1, value1);
        }

        if (teeState.canceled2 === false) {
          ReadableStreamDefaultControllerEnqueue(branch2, value2);
        }
      });
    }

    return f;
  }

  function create_ReadableStreamTeeBranch1CancelFunction() {
    function f(reason) {
      var stream = f._stream,
          teeState = f._teeState;
      teeState.canceled1 = true;
      teeState.reason1 = reason;

      if (teeState.canceled2 === true) {
        var compositeReason = createArrayFromList([teeState.reason1, teeState.reason2]);
        var cancelResult = ReadableStreamCancel(stream, compositeReason);

        teeState._resolve(cancelResult);
      }

      return teeState.promise;
    }

    return f;
  }

  function create_ReadableStreamTeeBranch2CancelFunction() {
    function f(reason) {
      var stream = f._stream,
          teeState = f._teeState;
      teeState.canceled2 = true;
      teeState.reason2 = reason;

      if (teeState.canceled1 === true) {
        var compositeReason = createArrayFromList([teeState.reason1, teeState.reason2]);
        var cancelResult = ReadableStreamCancel(stream, compositeReason);

        teeState._resolve(cancelResult);
      }

      return teeState.promise;
    }

    return f;
  }

  function ReadableStreamAddReadIntoRequest(stream) {
    assert(IsReadableStreamBYOBReader(stream._reader) === true);
    assert(stream._state === 'readable' || stream._state === 'closed');
    var promise = new Promise(function (resolve, reject) {
      var readIntoRequest = {
        _resolve: resolve,
        _reject: reject
      };

      stream._reader._readIntoRequests.push(readIntoRequest);
    });
    return promise;
  }

  function ReadableStreamAddReadRequest(stream) {
    assert(IsReadableStreamDefaultReader(stream._reader) === true);
    assert(stream._state === 'readable');
    var promise = new Promise(function (resolve, reject) {
      var readRequest = {
        _resolve: resolve,
        _reject: reject
      };

      stream._reader._readRequests.push(readRequest);
    });
    return promise;
  }

  function ReadableStreamCancel(stream, reason) {
    stream._disturbed = true;

    if (stream._state === 'closed') {
      return Promise.resolve(undefined);
    }

    if (stream._state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    ReadableStreamClose(stream);

    var sourceCancelPromise = stream._readableStreamController.__cancelSteps(reason);

    return sourceCancelPromise.then(function () {
      return undefined;
    });
  }

  function ReadableStreamClose(stream) {
    assert(stream._state === 'readable');
    stream._state = 'closed';
    var reader = stream._reader;

    if (reader === undefined) {
      return undefined;
    }

    if (IsReadableStreamDefaultReader(reader) === true) {
      for (var i = 0; i < reader._readRequests.length; i++) {
        var _resolve = reader._readRequests[i]._resolve;

        _resolve(CreateIterResultObject(undefined, true));
      }

      reader._readRequests = [];
    }

    defaultReaderClosedPromiseResolve(reader);
    return undefined;
  }

  function ReadableStreamError(stream, e) {
    assert(IsReadableStream(stream) === true, 'stream must be ReadableStream');
    assert(stream._state === 'readable', 'state must be readable');
    stream._state = 'errored';
    stream._storedError = e;
    var reader = stream._reader;

    if (reader === undefined) {
      return undefined;
    }

    if (IsReadableStreamDefaultReader(reader) === true) {
      for (var i = 0; i < reader._readRequests.length; i++) {
        var readRequest = reader._readRequests[i];

        readRequest._reject(e);
      }

      reader._readRequests = [];
    } else {
      assert(IsReadableStreamBYOBReader(reader), 'reader must be ReadableStreamBYOBReader');

      for (var _i = 0; _i < reader._readIntoRequests.length; _i++) {
        var readIntoRequest = reader._readIntoRequests[_i];

        readIntoRequest._reject(e);
      }

      reader._readIntoRequests = [];
    }

    defaultReaderClosedPromiseReject(reader, e);

    reader._closedPromise.catch(function () {});
  }

  function ReadableStreamFulfillReadIntoRequest(stream, chunk, done) {
    var reader = stream._reader;
    assert(reader._readIntoRequests.length > 0);

    var readIntoRequest = reader._readIntoRequests.shift();

    readIntoRequest._resolve(CreateIterResultObject(chunk, done));
  }

  function ReadableStreamFulfillReadRequest(stream, chunk, done) {
    var reader = stream._reader;
    assert(reader._readRequests.length > 0);

    var readRequest = reader._readRequests.shift();

    readRequest._resolve(CreateIterResultObject(chunk, done));
  }

  function ReadableStreamGetNumReadIntoRequests(stream) {
    return stream._reader._readIntoRequests.length;
  }

  function ReadableStreamGetNumReadRequests(stream) {
    return stream._reader._readRequests.length;
  }

  function ReadableStreamHasBYOBReader(stream) {
    var reader = stream._reader;

    if (reader === undefined) {
      return false;
    }

    if (IsReadableStreamBYOBReader(reader) === false) {
      return false;
    }

    return true;
  }

  function ReadableStreamHasDefaultReader(stream) {
    var reader = stream._reader;

    if (reader === undefined) {
      return false;
    }

    if (IsReadableStreamDefaultReader(reader) === false) {
      return false;
    }

    return true;
  }

  var ReadableStreamDefaultReader = function () {
    function ReadableStreamDefaultReader(stream) {
      _classCallCheck(this, ReadableStreamDefaultReader);

      if (IsReadableStream(stream) === false) {
        throw new TypeError('ReadableStreamDefaultReader can only be constructed with a ReadableStream instance');
      }

      if (IsReadableStreamLocked(stream) === true) {
        throw new TypeError('This stream has already been locked for exclusive reading by another reader');
      }

      ReadableStreamReaderGenericInitialize(this, stream);
      this._readRequests = [];
    }

    _createClass(ReadableStreamDefaultReader, [{
      key: 'cancel',
      value: function cancel(reason) {
        if (IsReadableStreamDefaultReader(this) === false) {
          return Promise.reject(defaultReaderBrandCheckException('cancel'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('cancel'));
        }

        return ReadableStreamReaderGenericCancel(this, reason);
      }
    }, {
      key: 'read',
      value: function read() {
        if (IsReadableStreamDefaultReader(this) === false) {
          return Promise.reject(defaultReaderBrandCheckException('read'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('read from'));
        }

        return ReadableStreamDefaultReaderRead(this);
      }
    }, {
      key: 'releaseLock',
      value: function releaseLock() {
        if (IsReadableStreamDefaultReader(this) === false) {
          throw defaultReaderBrandCheckException('releaseLock');
        }

        if (this._ownerReadableStream === undefined) {
          return;
        }

        if (this._readRequests.length > 0) {
          throw new TypeError('Tried to release a reader lock when that reader has pending read() calls un-settled');
        }

        ReadableStreamReaderGenericRelease(this);
      }
    }, {
      key: 'closed',
      get: function get() {
        if (IsReadableStreamDefaultReader(this) === false) {
          return Promise.reject(defaultReaderBrandCheckException('closed'));
        }

        return this._closedPromise;
      }
    }]);

    return ReadableStreamDefaultReader;
  }();

  var ReadableStreamBYOBReader = function () {
    function ReadableStreamBYOBReader(stream) {
      _classCallCheck(this, ReadableStreamBYOBReader);

      if (!IsReadableStream(stream)) {
        throw new TypeError('ReadableStreamBYOBReader can only be constructed with a ReadableStream instance given a ' + 'byte source');
      }

      if (IsReadableByteStreamController(stream._readableStreamController) === false) {
        throw new TypeError('Cannot construct a ReadableStreamBYOBReader for a stream not constructed with a byte ' + 'source');
      }

      if (IsReadableStreamLocked(stream)) {
        throw new TypeError('This stream has already been locked for exclusive reading by another reader');
      }

      ReadableStreamReaderGenericInitialize(this, stream);
      this._readIntoRequests = [];
    }

    _createClass(ReadableStreamBYOBReader, [{
      key: 'cancel',
      value: function cancel(reason) {
        if (!IsReadableStreamBYOBReader(this)) {
          return Promise.reject(byobReaderBrandCheckException('cancel'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('cancel'));
        }

        return ReadableStreamReaderGenericCancel(this, reason);
      }
    }, {
      key: 'read',
      value: function read(view) {
        if (!IsReadableStreamBYOBReader(this)) {
          return Promise.reject(byobReaderBrandCheckException('read'));
        }

        if (this._ownerReadableStream === undefined) {
          return Promise.reject(readerLockException('read from'));
        }

        if (!ArrayBuffer.isView(view)) {
          return Promise.reject(new TypeError('view must be an array buffer view'));
        }

        if (view.byteLength === 0) {
          return Promise.reject(new TypeError('view must have non-zero byteLength'));
        }

        return ReadableStreamBYOBReaderRead(this, view);
      }
    }, {
      key: 'releaseLock',
      value: function releaseLock() {
        if (!IsReadableStreamBYOBReader(this)) {
          throw byobReaderBrandCheckException('releaseLock');
        }

        if (this._ownerReadableStream === undefined) {
          return;
        }

        if (this._readIntoRequests.length > 0) {
          throw new TypeError('Tried to release a reader lock when that reader has pending read() calls un-settled');
        }

        ReadableStreamReaderGenericRelease(this);
      }
    }, {
      key: 'closed',
      get: function get() {
        if (!IsReadableStreamBYOBReader(this)) {
          return Promise.reject(byobReaderBrandCheckException('closed'));
        }

        return this._closedPromise;
      }
    }]);

    return ReadableStreamBYOBReader;
  }();

  function IsReadableStreamBYOBReader(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_readIntoRequests')) {
      return false;
    }

    return true;
  }

  function IsReadableStreamDefaultReader(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_readRequests')) {
      return false;
    }

    return true;
  }

  function ReadableStreamReaderGenericInitialize(reader, stream) {
    reader._ownerReadableStream = stream;
    stream._reader = reader;

    if (stream._state === 'readable') {
      defaultReaderClosedPromiseInitialize(reader);
    } else if (stream._state === 'closed') {
      defaultReaderClosedPromiseInitializeAsResolved(reader);
    } else {
      assert(stream._state === 'errored', 'state must be errored');
      defaultReaderClosedPromiseInitializeAsRejected(reader, stream._storedError);

      reader._closedPromise.catch(function () {});
    }
  }

  function ReadableStreamReaderGenericCancel(reader, reason) {
    var stream = reader._ownerReadableStream;
    assert(stream !== undefined);
    return ReadableStreamCancel(stream, reason);
  }

  function ReadableStreamReaderGenericRelease(reader) {
    assert(reader._ownerReadableStream !== undefined);
    assert(reader._ownerReadableStream._reader === reader);

    if (reader._ownerReadableStream._state === 'readable') {
      defaultReaderClosedPromiseReject(reader, new TypeError('Reader was released and can no longer be used to monitor the stream\'s closedness'));
    } else {
      defaultReaderClosedPromiseResetToRejected(reader, new TypeError('Reader was released and can no longer be used to monitor the stream\'s closedness'));
    }

    reader._closedPromise.catch(function () {});

    reader._ownerReadableStream._reader = undefined;
    reader._ownerReadableStream = undefined;
  }

  function ReadableStreamBYOBReaderRead(reader, view) {
    var stream = reader._ownerReadableStream;
    assert(stream !== undefined);
    stream._disturbed = true;

    if (stream._state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    return ReadableByteStreamControllerPullInto(stream._readableStreamController, view);
  }

  function ReadableStreamDefaultReaderRead(reader) {
    var stream = reader._ownerReadableStream;
    assert(stream !== undefined);
    stream._disturbed = true;

    if (stream._state === 'closed') {
      return Promise.resolve(CreateIterResultObject(undefined, true));
    }

    if (stream._state === 'errored') {
      return Promise.reject(stream._storedError);
    }

    assert(stream._state === 'readable');
    return stream._readableStreamController.__pullSteps();
  }

  var ReadableStreamDefaultController = function () {
    function ReadableStreamDefaultController(stream, underlyingSource, size, highWaterMark) {
      _classCallCheck(this, ReadableStreamDefaultController);

      if (IsReadableStream(stream) === false) {
        throw new TypeError('ReadableStreamDefaultController can only be constructed with a ReadableStream instance');
      }

      if (stream._readableStreamController !== undefined) {
        throw new TypeError('ReadableStreamDefaultController instances can only be created by the ReadableStream constructor');
      }

      this._controlledReadableStream = stream;
      this._underlyingSource = underlyingSource;
      this._queue = undefined;
      this._queueTotalSize = undefined;
      ResetQueue(this);
      this._started = false;
      this._closeRequested = false;
      this._pullAgain = false;
      this._pulling = false;
      var normalizedStrategy = ValidateAndNormalizeQueuingStrategy(size, highWaterMark);
      this._strategySize = normalizedStrategy.size;
      this._strategyHWM = normalizedStrategy.highWaterMark;
      var controller = this;
      var startResult = InvokeOrNoop(underlyingSource, 'start', [this]);
      Promise.resolve(startResult).then(function () {
        controller._started = true;
        assert(controller._pulling === false);
        assert(controller._pullAgain === false);
        ReadableStreamDefaultControllerCallPullIfNeeded(controller);
      }, function (r) {
        ReadableStreamDefaultControllerErrorIfNeeded(controller, r);
      }).catch(rethrowAssertionErrorRejection);
    }

    _createClass(ReadableStreamDefaultController, [{
      key: 'close',
      value: function close() {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('close');
        }

        if (this._closeRequested === true) {
          throw new TypeError('The stream has already been closed; do not close it again!');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be closed');
        }

        ReadableStreamDefaultControllerClose(this);
      }
    }, {
      key: 'enqueue',
      value: function enqueue(chunk) {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('enqueue');
        }

        if (this._closeRequested === true) {
          throw new TypeError('stream is closed or draining');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be enqueued to');
        }

        return ReadableStreamDefaultControllerEnqueue(this, chunk);
      }
    }, {
      key: 'error',
      value: function error(e) {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('error');
        }

        var stream = this._controlledReadableStream;

        if (stream._state !== 'readable') {
          throw new TypeError('The stream is ' + stream._state + ' and so cannot be errored');
        }

        ReadableStreamDefaultControllerError(this, e);
      }
    }, {
      key: '__cancelSteps',
      value: function __cancelSteps(reason) {
        ResetQueue(this);
        return PromiseInvokeOrNoop(this._underlyingSource, 'cancel', [reason]);
      }
    }, {
      key: '__pullSteps',
      value: function __pullSteps() {
        var stream = this._controlledReadableStream;

        if (this._queue.length > 0) {
          var chunk = DequeueValue(this);

          if (this._closeRequested === true && this._queue.length === 0) {
            ReadableStreamClose(stream);
          } else {
            ReadableStreamDefaultControllerCallPullIfNeeded(this);
          }

          return Promise.resolve(CreateIterResultObject(chunk, false));
        }

        var pendingPromise = ReadableStreamAddReadRequest(stream);
        ReadableStreamDefaultControllerCallPullIfNeeded(this);
        return pendingPromise;
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsReadableStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('desiredSize');
        }

        return ReadableStreamDefaultControllerGetDesiredSize(this);
      }
    }]);

    return ReadableStreamDefaultController;
  }();

  function IsReadableStreamDefaultController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_underlyingSource')) {
      return false;
    }

    return true;
  }

  function ReadableStreamDefaultControllerCallPullIfNeeded(controller) {
    var shouldPull = ReadableStreamDefaultControllerShouldCallPull(controller);

    if (shouldPull === false) {
      return undefined;
    }

    if (controller._pulling === true) {
      controller._pullAgain = true;
      return undefined;
    }

    assert(controller._pullAgain === false);
    controller._pulling = true;
    var pullPromise = PromiseInvokeOrNoop(controller._underlyingSource, 'pull', [controller]);
    pullPromise.then(function () {
      controller._pulling = false;

      if (controller._pullAgain === true) {
        controller._pullAgain = false;
        return ReadableStreamDefaultControllerCallPullIfNeeded(controller);
      }

      return undefined;
    }, function (e) {
      ReadableStreamDefaultControllerErrorIfNeeded(controller, e);
    }).catch(rethrowAssertionErrorRejection);
    return undefined;
  }

  function ReadableStreamDefaultControllerShouldCallPull(controller) {
    var stream = controller._controlledReadableStream;

    if (stream._state === 'closed' || stream._state === 'errored') {
      return false;
    }

    if (controller._closeRequested === true) {
      return false;
    }

    if (controller._started === false) {
      return false;
    }

    if (IsReadableStreamLocked(stream) === true && ReadableStreamGetNumReadRequests(stream) > 0) {
      return true;
    }

    var desiredSize = ReadableStreamDefaultControllerGetDesiredSize(controller);

    if (desiredSize > 0) {
      return true;
    }

    return false;
  }

  function ReadableStreamDefaultControllerClose(controller) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');
    controller._closeRequested = true;

    if (controller._queue.length === 0) {
      ReadableStreamClose(stream);
    }
  }

  function ReadableStreamDefaultControllerEnqueue(controller, chunk) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');

    if (IsReadableStreamLocked(stream) === true && ReadableStreamGetNumReadRequests(stream) > 0) {
      ReadableStreamFulfillReadRequest(stream, chunk, false);
    } else {
      var chunkSize = 1;

      if (controller._strategySize !== undefined) {
        var strategySize = controller._strategySize;

        try {
          chunkSize = strategySize(chunk);
        } catch (chunkSizeE) {
          ReadableStreamDefaultControllerErrorIfNeeded(controller, chunkSizeE);
          throw chunkSizeE;
        }
      }

      try {
        EnqueueValueWithSize(controller, chunk, chunkSize);
      } catch (enqueueE) {
        ReadableStreamDefaultControllerErrorIfNeeded(controller, enqueueE);
        throw enqueueE;
      }
    }

    ReadableStreamDefaultControllerCallPullIfNeeded(controller);
    return undefined;
  }

  function ReadableStreamDefaultControllerError(controller, e) {
    var stream = controller._controlledReadableStream;
    assert(stream._state === 'readable');
    ResetQueue(controller);
    ReadableStreamError(stream, e);
  }

  function ReadableStreamDefaultControllerErrorIfNeeded(controller, e) {
    if (controller._controlledReadableStream._state === 'readable') {
      ReadableStreamDefaultControllerError(controller, e);
    }
  }

  function ReadableStreamDefaultControllerGetDesiredSize(controller) {
    var stream = controller._controlledReadableStream;
    var state = stream._state;

    if (state === 'errored') {
      return null;
    }

    if (state === 'closed') {
      return 0;
    }

    return controller._strategyHWM - controller._queueTotalSize;
  }

  var ReadableStreamBYOBRequest = function () {
    function ReadableStreamBYOBRequest(controller, view) {
      _classCallCheck(this, ReadableStreamBYOBRequest);

      this._associatedReadableByteStreamController = controller;
      this._view = view;
    }

    _createClass(ReadableStreamBYOBRequest, [{
      key: 'respond',
      value: function respond(bytesWritten) {
        if (IsReadableStreamBYOBRequest(this) === false) {
          throw byobRequestBrandCheckException('respond');
        }

        if (this._associatedReadableByteStreamController === undefined) {
          throw new TypeError('This BYOB request has been invalidated');
        }

        ReadableByteStreamControllerRespond(this._associatedReadableByteStreamController, bytesWritten);
      }
    }, {
      key: 'respondWithNewView',
      value: function respondWithNewView(view) {
        if (IsReadableStreamBYOBRequest(this) === false) {
          throw byobRequestBrandCheckException('respond');
        }

        if (this._associatedReadableByteStreamController === undefined) {
          throw new TypeError('This BYOB request has been invalidated');
        }

        if (!ArrayBuffer.isView(view)) {
          throw new TypeError('You can only respond with array buffer views');
        }

        ReadableByteStreamControllerRespondWithNewView(this._associatedReadableByteStreamController, view);
      }
    }, {
      key: 'view',
      get: function get() {
        return this._view;
      }
    }]);

    return ReadableStreamBYOBRequest;
  }();

  var ReadableByteStreamController = function () {
    function ReadableByteStreamController(stream, underlyingByteSource, highWaterMark) {
      _classCallCheck(this, ReadableByteStreamController);

      if (IsReadableStream(stream) === false) {
        throw new TypeError('ReadableByteStreamController can only be constructed with a ReadableStream instance given ' + 'a byte source');
      }

      if (stream._readableStreamController !== undefined) {
        throw new TypeError('ReadableByteStreamController instances can only be created by the ReadableStream constructor given a byte ' + 'source');
      }

      this._controlledReadableStream = stream;
      this._underlyingByteSource = underlyingByteSource;
      this._pullAgain = false;
      this._pulling = false;
      ReadableByteStreamControllerClearPendingPullIntos(this);
      this._queue = this._queueTotalSize = undefined;
      ResetQueue(this);
      this._closeRequested = false;
      this._started = false;
      this._strategyHWM = ValidateAndNormalizeHighWaterMark(highWaterMark);
      var autoAllocateChunkSize = underlyingByteSource.autoAllocateChunkSize;

      if (autoAllocateChunkSize !== undefined) {
        if (Number.isInteger(autoAllocateChunkSize) === false || autoAllocateChunkSize <= 0) {
          throw new RangeError('autoAllocateChunkSize must be a positive integer');
        }
      }

      this._autoAllocateChunkSize = autoAllocateChunkSize;
      this._pendingPullIntos = [];
      var controller = this;
      var startResult = InvokeOrNoop(underlyingByteSource, 'start', [this]);
      Promise.resolve(startResult).then(function () {
        controller._started = true;
        assert(controller._pulling === false);
        assert(controller._pullAgain === false);
        ReadableByteStreamControllerCallPullIfNeeded(controller);
      }, function (r) {
        if (stream._state === 'readable') {
          ReadableByteStreamControllerError(controller, r);
        }
      }).catch(rethrowAssertionErrorRejection);
    }

    _createClass(ReadableByteStreamController, [{
      key: 'close',
      value: function close() {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('close');
        }

        if (this._closeRequested === true) {
          throw new TypeError('The stream has already been closed; do not close it again!');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be closed');
        }

        ReadableByteStreamControllerClose(this);
      }
    }, {
      key: 'enqueue',
      value: function enqueue(chunk) {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('enqueue');
        }

        if (this._closeRequested === true) {
          throw new TypeError('stream is closed or draining');
        }

        var state = this._controlledReadableStream._state;

        if (state !== 'readable') {
          throw new TypeError('The stream (in ' + state + ' state) is not in the readable state and cannot be enqueued to');
        }

        if (!ArrayBuffer.isView(chunk)) {
          throw new TypeError('You can only enqueue array buffer views when using a ReadableByteStreamController');
        }

        ReadableByteStreamControllerEnqueue(this, chunk);
      }
    }, {
      key: 'error',
      value: function error(e) {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('error');
        }

        var stream = this._controlledReadableStream;

        if (stream._state !== 'readable') {
          throw new TypeError('The stream is ' + stream._state + ' and so cannot be errored');
        }

        ReadableByteStreamControllerError(this, e);
      }
    }, {
      key: '__cancelSteps',
      value: function __cancelSteps(reason) {
        if (this._pendingPullIntos.length > 0) {
          var firstDescriptor = this._pendingPullIntos[0];
          firstDescriptor.bytesFilled = 0;
        }

        ResetQueue(this);
        return PromiseInvokeOrNoop(this._underlyingByteSource, 'cancel', [reason]);
      }
    }, {
      key: '__pullSteps',
      value: function __pullSteps() {
        var stream = this._controlledReadableStream;
        assert(ReadableStreamHasDefaultReader(stream) === true);

        if (this._queueTotalSize > 0) {
          assert(ReadableStreamGetNumReadRequests(stream) === 0);

          var entry = this._queue.shift();

          this._queueTotalSize -= entry.byteLength;
          ReadableByteStreamControllerHandleQueueDrain(this);
          var view = void 0;

          try {
            view = new Uint8Array(entry.buffer, entry.byteOffset, entry.byteLength);
          } catch (viewE) {
            return Promise.reject(viewE);
          }

          return Promise.resolve(CreateIterResultObject(view, false));
        }

        var autoAllocateChunkSize = this._autoAllocateChunkSize;

        if (autoAllocateChunkSize !== undefined) {
          var buffer = void 0;

          try {
            buffer = new ArrayBuffer(autoAllocateChunkSize);
          } catch (bufferE) {
            return Promise.reject(bufferE);
          }

          var pullIntoDescriptor = {
            buffer: buffer,
            byteOffset: 0,
            byteLength: autoAllocateChunkSize,
            bytesFilled: 0,
            elementSize: 1,
            ctor: Uint8Array,
            readerType: 'default'
          };

          this._pendingPullIntos.push(pullIntoDescriptor);
        }

        var promise = ReadableStreamAddReadRequest(stream);
        ReadableByteStreamControllerCallPullIfNeeded(this);
        return promise;
      }
    }, {
      key: 'byobRequest',
      get: function get() {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('byobRequest');
        }

        if (this._byobRequest === undefined && this._pendingPullIntos.length > 0) {
          var firstDescriptor = this._pendingPullIntos[0];
          var view = new Uint8Array(firstDescriptor.buffer, firstDescriptor.byteOffset + firstDescriptor.bytesFilled, firstDescriptor.byteLength - firstDescriptor.bytesFilled);
          this._byobRequest = new ReadableStreamBYOBRequest(this, view);
        }

        return this._byobRequest;
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsReadableByteStreamController(this) === false) {
          throw byteStreamControllerBrandCheckException('desiredSize');
        }

        return ReadableByteStreamControllerGetDesiredSize(this);
      }
    }]);

    return ReadableByteStreamController;
  }();

  function IsReadableByteStreamController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_underlyingByteSource')) {
      return false;
    }

    return true;
  }

  function IsReadableStreamBYOBRequest(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_associatedReadableByteStreamController')) {
      return false;
    }

    return true;
  }

  function ReadableByteStreamControllerCallPullIfNeeded(controller) {
    var shouldPull = ReadableByteStreamControllerShouldCallPull(controller);

    if (shouldPull === false) {
      return undefined;
    }

    if (controller._pulling === true) {
      controller._pullAgain = true;
      return undefined;
    }

    assert(controller._pullAgain === false);
    controller._pulling = true;
    var pullPromise = PromiseInvokeOrNoop(controller._underlyingByteSource, 'pull', [controller]);
    pullPromise.then(function () {
      controller._pulling = false;

      if (controller._pullAgain === true) {
        controller._pullAgain = false;
        ReadableByteStreamControllerCallPullIfNeeded(controller);
      }
    }, function (e) {
      if (controller._controlledReadableStream._state === 'readable') {
        ReadableByteStreamControllerError(controller, e);
      }
    }).catch(rethrowAssertionErrorRejection);
    return undefined;
  }

  function ReadableByteStreamControllerClearPendingPullIntos(controller) {
    ReadableByteStreamControllerInvalidateBYOBRequest(controller);
    controller._pendingPullIntos = [];
  }

  function ReadableByteStreamControllerCommitPullIntoDescriptor(stream, pullIntoDescriptor) {
    assert(stream._state !== 'errored', 'state must not be errored');
    var done = false;

    if (stream._state === 'closed') {
      assert(pullIntoDescriptor.bytesFilled === 0);
      done = true;
    }

    var filledView = ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor);

    if (pullIntoDescriptor.readerType === 'default') {
      ReadableStreamFulfillReadRequest(stream, filledView, done);
    } else {
      assert(pullIntoDescriptor.readerType === 'byob');
      ReadableStreamFulfillReadIntoRequest(stream, filledView, done);
    }
  }

  function ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor) {
    var bytesFilled = pullIntoDescriptor.bytesFilled;
    var elementSize = pullIntoDescriptor.elementSize;
    assert(bytesFilled <= pullIntoDescriptor.byteLength);
    assert(bytesFilled % elementSize === 0);
    return new pullIntoDescriptor.ctor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, bytesFilled / elementSize);
  }

  function ReadableByteStreamControllerEnqueueChunkToQueue(controller, buffer, byteOffset, byteLength) {
    controller._queue.push({
      buffer: buffer,
      byteOffset: byteOffset,
      byteLength: byteLength
    });

    controller._queueTotalSize += byteLength;
  }

  function ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor) {
    var elementSize = pullIntoDescriptor.elementSize;
    var currentAlignedBytes = pullIntoDescriptor.bytesFilled - pullIntoDescriptor.bytesFilled % elementSize;
    var maxBytesToCopy = Math.min(controller._queueTotalSize, pullIntoDescriptor.byteLength - pullIntoDescriptor.bytesFilled);
    var maxBytesFilled = pullIntoDescriptor.bytesFilled + maxBytesToCopy;
    var maxAlignedBytes = maxBytesFilled - maxBytesFilled % elementSize;
    var totalBytesToCopyRemaining = maxBytesToCopy;
    var ready = false;

    if (maxAlignedBytes > currentAlignedBytes) {
      totalBytesToCopyRemaining = maxAlignedBytes - pullIntoDescriptor.bytesFilled;
      ready = true;
    }

    var queue = controller._queue;

    while (totalBytesToCopyRemaining > 0) {
      var headOfQueue = queue[0];
      var bytesToCopy = Math.min(totalBytesToCopyRemaining, headOfQueue.byteLength);
      var destStart = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;
      ArrayBufferCopy(pullIntoDescriptor.buffer, destStart, headOfQueue.buffer, headOfQueue.byteOffset, bytesToCopy);

      if (headOfQueue.byteLength === bytesToCopy) {
        queue.shift();
      } else {
        headOfQueue.byteOffset += bytesToCopy;
        headOfQueue.byteLength -= bytesToCopy;
      }

      controller._queueTotalSize -= bytesToCopy;
      ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, bytesToCopy, pullIntoDescriptor);
      totalBytesToCopyRemaining -= bytesToCopy;
    }

    if (ready === false) {
      assert(controller._queueTotalSize === 0, 'queue must be empty');
      assert(pullIntoDescriptor.bytesFilled > 0);
      assert(pullIntoDescriptor.bytesFilled < pullIntoDescriptor.elementSize);
    }

    return ready;
  }

  function ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, size, pullIntoDescriptor) {
    assert(controller._pendingPullIntos.length === 0 || controller._pendingPullIntos[0] === pullIntoDescriptor);
    ReadableByteStreamControllerInvalidateBYOBRequest(controller);
    pullIntoDescriptor.bytesFilled += size;
  }

  function ReadableByteStreamControllerHandleQueueDrain(controller) {
    assert(controller._controlledReadableStream._state === 'readable');

    if (controller._queueTotalSize === 0 && controller._closeRequested === true) {
      ReadableStreamClose(controller._controlledReadableStream);
    } else {
      ReadableByteStreamControllerCallPullIfNeeded(controller);
    }
  }

  function ReadableByteStreamControllerInvalidateBYOBRequest(controller) {
    if (controller._byobRequest === undefined) {
      return;
    }

    controller._byobRequest._associatedReadableByteStreamController = undefined;
    controller._byobRequest._view = undefined;
    controller._byobRequest = undefined;
  }

  function ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller) {
    assert(controller._closeRequested === false);

    while (controller._pendingPullIntos.length > 0) {
      if (controller._queueTotalSize === 0) {
        return;
      }

      var pullIntoDescriptor = controller._pendingPullIntos[0];

      if (ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor) === true) {
        ReadableByteStreamControllerShiftPendingPullInto(controller);
        ReadableByteStreamControllerCommitPullIntoDescriptor(controller._controlledReadableStream, pullIntoDescriptor);
      }
    }
  }

  function ReadableByteStreamControllerPullInto(controller, view) {
    var stream = controller._controlledReadableStream;
    var elementSize = 1;

    if (view.constructor !== DataView) {
      elementSize = view.constructor.BYTES_PER_ELEMENT;
    }

    var ctor = view.constructor;
    var pullIntoDescriptor = {
      buffer: view.buffer,
      byteOffset: view.byteOffset,
      byteLength: view.byteLength,
      bytesFilled: 0,
      elementSize: elementSize,
      ctor: ctor,
      readerType: 'byob'
    };

    if (controller._pendingPullIntos.length > 0) {
      pullIntoDescriptor.buffer = TransferArrayBuffer(pullIntoDescriptor.buffer);

      controller._pendingPullIntos.push(pullIntoDescriptor);

      return ReadableStreamAddReadIntoRequest(stream);
    }

    if (stream._state === 'closed') {
      var emptyView = new view.constructor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, 0);
      return Promise.resolve(CreateIterResultObject(emptyView, true));
    }

    if (controller._queueTotalSize > 0) {
      if (ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor) === true) {
        var filledView = ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor);
        ReadableByteStreamControllerHandleQueueDrain(controller);
        return Promise.resolve(CreateIterResultObject(filledView, false));
      }

      if (controller._closeRequested === true) {
        var e = new TypeError('Insufficient bytes to fill elements in the given buffer');
        ReadableByteStreamControllerError(controller, e);
        return Promise.reject(e);
      }
    }

    pullIntoDescriptor.buffer = TransferArrayBuffer(pullIntoDescriptor.buffer);

    controller._pendingPullIntos.push(pullIntoDescriptor);

    var promise = ReadableStreamAddReadIntoRequest(stream);
    ReadableByteStreamControllerCallPullIfNeeded(controller);
    return promise;
  }

  function ReadableByteStreamControllerRespondInClosedState(controller, firstDescriptor) {
    firstDescriptor.buffer = TransferArrayBuffer(firstDescriptor.buffer);
    assert(firstDescriptor.bytesFilled === 0, 'bytesFilled must be 0');
    var stream = controller._controlledReadableStream;

    if (ReadableStreamHasBYOBReader(stream) === true) {
      while (ReadableStreamGetNumReadIntoRequests(stream) > 0) {
        var pullIntoDescriptor = ReadableByteStreamControllerShiftPendingPullInto(controller);
        ReadableByteStreamControllerCommitPullIntoDescriptor(stream, pullIntoDescriptor);
      }
    }
  }

  function ReadableByteStreamControllerRespondInReadableState(controller, bytesWritten, pullIntoDescriptor) {
    if (pullIntoDescriptor.bytesFilled + bytesWritten > pullIntoDescriptor.byteLength) {
      throw new RangeError('bytesWritten out of range');
    }

    ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, bytesWritten, pullIntoDescriptor);

    if (pullIntoDescriptor.bytesFilled < pullIntoDescriptor.elementSize) {
      return;
    }

    ReadableByteStreamControllerShiftPendingPullInto(controller);
    var remainderSize = pullIntoDescriptor.bytesFilled % pullIntoDescriptor.elementSize;

    if (remainderSize > 0) {
      var end = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;
      var remainder = pullIntoDescriptor.buffer.slice(end - remainderSize, end);
      ReadableByteStreamControllerEnqueueChunkToQueue(controller, remainder, 0, remainder.byteLength);
    }

    pullIntoDescriptor.buffer = TransferArrayBuffer(pullIntoDescriptor.buffer);
    pullIntoDescriptor.bytesFilled -= remainderSize;
    ReadableByteStreamControllerCommitPullIntoDescriptor(controller._controlledReadableStream, pullIntoDescriptor);
    ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller);
  }

  function ReadableByteStreamControllerRespondInternal(controller, bytesWritten) {
    var firstDescriptor = controller._pendingPullIntos[0];
    var stream = controller._controlledReadableStream;

    if (stream._state === 'closed') {
      if (bytesWritten !== 0) {
        throw new TypeError('bytesWritten must be 0 when calling respond() on a closed stream');
      }

      ReadableByteStreamControllerRespondInClosedState(controller, firstDescriptor);
    } else {
      assert(stream._state === 'readable');
      ReadableByteStreamControllerRespondInReadableState(controller, bytesWritten, firstDescriptor);
    }
  }

  function ReadableByteStreamControllerShiftPendingPullInto(controller) {
    var descriptor = controller._pendingPullIntos.shift();

    ReadableByteStreamControllerInvalidateBYOBRequest(controller);
    return descriptor;
  }

  function ReadableByteStreamControllerShouldCallPull(controller) {
    var stream = controller._controlledReadableStream;

    if (stream._state !== 'readable') {
      return false;
    }

    if (controller._closeRequested === true) {
      return false;
    }

    if (controller._started === false) {
      return false;
    }

    if (ReadableStreamHasDefaultReader(stream) === true && ReadableStreamGetNumReadRequests(stream) > 0) {
      return true;
    }

    if (ReadableStreamHasBYOBReader(stream) === true && ReadableStreamGetNumReadIntoRequests(stream) > 0) {
      return true;
    }

    if (ReadableByteStreamControllerGetDesiredSize(controller) > 0) {
      return true;
    }

    return false;
  }

  function ReadableByteStreamControllerClose(controller) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');

    if (controller._queueTotalSize > 0) {
      controller._closeRequested = true;
      return;
    }

    if (controller._pendingPullIntos.length > 0) {
      var firstPendingPullInto = controller._pendingPullIntos[0];

      if (firstPendingPullInto.bytesFilled > 0) {
        var e = new TypeError('Insufficient bytes to fill elements in the given buffer');
        ReadableByteStreamControllerError(controller, e);
        throw e;
      }
    }

    ReadableStreamClose(stream);
  }

  function ReadableByteStreamControllerEnqueue(controller, chunk) {
    var stream = controller._controlledReadableStream;
    assert(controller._closeRequested === false);
    assert(stream._state === 'readable');
    var buffer = chunk.buffer;
    var byteOffset = chunk.byteOffset;
    var byteLength = chunk.byteLength;
    var transferredBuffer = TransferArrayBuffer(buffer);

    if (ReadableStreamHasDefaultReader(stream) === true) {
      if (ReadableStreamGetNumReadRequests(stream) === 0) {
        ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
      } else {
        assert(controller._queue.length === 0);
        var transferredView = new Uint8Array(transferredBuffer, byteOffset, byteLength);
        ReadableStreamFulfillReadRequest(stream, transferredView, false);
      }
    } else if (ReadableStreamHasBYOBReader(stream) === true) {
      ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
      ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller);
    } else {
      assert(IsReadableStreamLocked(stream) === false, 'stream must not be locked');
      ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
    }
  }

  function ReadableByteStreamControllerError(controller, e) {
    var stream = controller._controlledReadableStream;
    assert(stream._state === 'readable');
    ReadableByteStreamControllerClearPendingPullIntos(controller);
    ResetQueue(controller);
    ReadableStreamError(stream, e);
  }

  function ReadableByteStreamControllerGetDesiredSize(controller) {
    var stream = controller._controlledReadableStream;
    var state = stream._state;

    if (state === 'errored') {
      return null;
    }

    if (state === 'closed') {
      return 0;
    }

    return controller._strategyHWM - controller._queueTotalSize;
  }

  function ReadableByteStreamControllerRespond(controller, bytesWritten) {
    bytesWritten = Number(bytesWritten);

    if (IsFiniteNonNegativeNumber(bytesWritten) === false) {
      throw new RangeError('bytesWritten must be a finite');
    }

    assert(controller._pendingPullIntos.length > 0);
    ReadableByteStreamControllerRespondInternal(controller, bytesWritten);
  }

  function ReadableByteStreamControllerRespondWithNewView(controller, view) {
    assert(controller._pendingPullIntos.length > 0);
    var firstDescriptor = controller._pendingPullIntos[0];

    if (firstDescriptor.byteOffset + firstDescriptor.bytesFilled !== view.byteOffset) {
      throw new RangeError('The region specified by view does not match byobRequest');
    }

    if (firstDescriptor.byteLength !== view.byteLength) {
      throw new RangeError('The buffer of view has different capacity than byobRequest');
    }

    firstDescriptor.buffer = view.buffer;
    ReadableByteStreamControllerRespondInternal(controller, view.byteLength);
  }

  function streamBrandCheckException(name) {
    return new TypeError('ReadableStream.prototype.' + name + ' can only be used on a ReadableStream');
  }

  function readerLockException(name) {
    return new TypeError('Cannot ' + name + ' a stream using a released reader');
  }

  function defaultReaderBrandCheckException(name) {
    return new TypeError('ReadableStreamDefaultReader.prototype.' + name + ' can only be used on a ReadableStreamDefaultReader');
  }

  function defaultReaderClosedPromiseInitialize(reader) {
    reader._closedPromise = new Promise(function (resolve, reject) {
      reader._closedPromise_resolve = resolve;
      reader._closedPromise_reject = reject;
    });
  }

  function defaultReaderClosedPromiseInitializeAsRejected(reader, reason) {
    reader._closedPromise = Promise.reject(reason);
    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function defaultReaderClosedPromiseInitializeAsResolved(reader) {
    reader._closedPromise = Promise.resolve(undefined);
    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function defaultReaderClosedPromiseReject(reader, reason) {
    assert(reader._closedPromise_resolve !== undefined);
    assert(reader._closedPromise_reject !== undefined);

    reader._closedPromise_reject(reason);

    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function defaultReaderClosedPromiseResetToRejected(reader, reason) {
    assert(reader._closedPromise_resolve === undefined);
    assert(reader._closedPromise_reject === undefined);
    reader._closedPromise = Promise.reject(reason);
  }

  function defaultReaderClosedPromiseResolve(reader) {
    assert(reader._closedPromise_resolve !== undefined);
    assert(reader._closedPromise_reject !== undefined);

    reader._closedPromise_resolve(undefined);

    reader._closedPromise_resolve = undefined;
    reader._closedPromise_reject = undefined;
  }

  function byobReaderBrandCheckException(name) {
    return new TypeError('ReadableStreamBYOBReader.prototype.' + name + ' can only be used on a ReadableStreamBYOBReader');
  }

  function defaultControllerBrandCheckException(name) {
    return new TypeError('ReadableStreamDefaultController.prototype.' + name + ' can only be used on a ReadableStreamDefaultController');
  }

  function byobRequestBrandCheckException(name) {
    return new TypeError('ReadableStreamBYOBRequest.prototype.' + name + ' can only be used on a ReadableStreamBYOBRequest');
  }

  function byteStreamControllerBrandCheckException(name) {
    return new TypeError('ReadableByteStreamController.prototype.' + name + ' can only be used on a ReadableByteStreamController');
  }

  function ifIsObjectAndHasAPromiseIsHandledInternalSlotSetPromiseIsHandledToTrue(promise) {
    try {
      Promise.prototype.then.call(promise, undefined, function () {});
    } catch (e) {}
  }
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var transformStream = __w_pdfjs_require__(6);

  var readableStream = __w_pdfjs_require__(4);

  var writableStream = __w_pdfjs_require__(2);

  exports.TransformStream = transformStream.TransformStream;
  exports.ReadableStream = readableStream.ReadableStream;
  exports.IsReadableStreamDisturbed = readableStream.IsReadableStreamDisturbed;
  exports.ReadableStreamDefaultControllerClose = readableStream.ReadableStreamDefaultControllerClose;
  exports.ReadableStreamDefaultControllerEnqueue = readableStream.ReadableStreamDefaultControllerEnqueue;
  exports.ReadableStreamDefaultControllerError = readableStream.ReadableStreamDefaultControllerError;
  exports.ReadableStreamDefaultControllerGetDesiredSize = readableStream.ReadableStreamDefaultControllerGetDesiredSize;
  exports.AcquireWritableStreamDefaultWriter = writableStream.AcquireWritableStreamDefaultWriter;
  exports.IsWritableStream = writableStream.IsWritableStream;
  exports.IsWritableStreamLocked = writableStream.IsWritableStreamLocked;
  exports.WritableStream = writableStream.WritableStream;
  exports.WritableStreamAbort = writableStream.WritableStreamAbort;
  exports.WritableStreamDefaultControllerError = writableStream.WritableStreamDefaultControllerError;
  exports.WritableStreamDefaultWriterCloseWithErrorPropagation = writableStream.WritableStreamDefaultWriterCloseWithErrorPropagation;
  exports.WritableStreamDefaultWriterRelease = writableStream.WritableStreamDefaultWriterRelease;
  exports.WritableStreamDefaultWriterWrite = writableStream.WritableStreamDefaultWriterWrite;
}, function (module, exports, __w_pdfjs_require__) {
  "use strict";

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _require = __w_pdfjs_require__(1),
      assert = _require.assert;

  var _require2 = __w_pdfjs_require__(0),
      InvokeOrNoop = _require2.InvokeOrNoop,
      PromiseInvokeOrPerformFallback = _require2.PromiseInvokeOrPerformFallback,
      PromiseInvokeOrNoop = _require2.PromiseInvokeOrNoop,
      typeIsObject = _require2.typeIsObject;

  var _require3 = __w_pdfjs_require__(4),
      ReadableStream = _require3.ReadableStream,
      ReadableStreamDefaultControllerClose = _require3.ReadableStreamDefaultControllerClose,
      ReadableStreamDefaultControllerEnqueue = _require3.ReadableStreamDefaultControllerEnqueue,
      ReadableStreamDefaultControllerError = _require3.ReadableStreamDefaultControllerError,
      ReadableStreamDefaultControllerGetDesiredSize = _require3.ReadableStreamDefaultControllerGetDesiredSize;

  var _require4 = __w_pdfjs_require__(2),
      WritableStream = _require4.WritableStream,
      WritableStreamDefaultControllerError = _require4.WritableStreamDefaultControllerError;

  function TransformStreamCloseReadable(transformStream) {
    if (transformStream._errored === true) {
      throw new TypeError('TransformStream is already errored');
    }

    if (transformStream._readableClosed === true) {
      throw new TypeError('Readable side is already closed');
    }

    TransformStreamCloseReadableInternal(transformStream);
  }

  function TransformStreamEnqueueToReadable(transformStream, chunk) {
    if (transformStream._errored === true) {
      throw new TypeError('TransformStream is already errored');
    }

    if (transformStream._readableClosed === true) {
      throw new TypeError('Readable side is already closed');
    }

    var controller = transformStream._readableController;

    try {
      ReadableStreamDefaultControllerEnqueue(controller, chunk);
    } catch (e) {
      transformStream._readableClosed = true;
      TransformStreamErrorIfNeeded(transformStream, e);
      throw transformStream._storedError;
    }

    var desiredSize = ReadableStreamDefaultControllerGetDesiredSize(controller);
    var maybeBackpressure = desiredSize <= 0;

    if (maybeBackpressure === true && transformStream._backpressure === false) {
      TransformStreamSetBackpressure(transformStream, true);
    }
  }

  function TransformStreamError(transformStream, e) {
    if (transformStream._errored === true) {
      throw new TypeError('TransformStream is already errored');
    }

    TransformStreamErrorInternal(transformStream, e);
  }

  function TransformStreamCloseReadableInternal(transformStream) {
    assert(transformStream._errored === false);
    assert(transformStream._readableClosed === false);

    try {
      ReadableStreamDefaultControllerClose(transformStream._readableController);
    } catch (e) {
      assert(false);
    }

    transformStream._readableClosed = true;
  }

  function TransformStreamErrorIfNeeded(transformStream, e) {
    if (transformStream._errored === false) {
      TransformStreamErrorInternal(transformStream, e);
    }
  }

  function TransformStreamErrorInternal(transformStream, e) {
    assert(transformStream._errored === false);
    transformStream._errored = true;
    transformStream._storedError = e;

    if (transformStream._writableDone === false) {
      WritableStreamDefaultControllerError(transformStream._writableController, e);
    }

    if (transformStream._readableClosed === false) {
      ReadableStreamDefaultControllerError(transformStream._readableController, e);
    }
  }

  function TransformStreamReadableReadyPromise(transformStream) {
    assert(transformStream._backpressureChangePromise !== undefined, '_backpressureChangePromise should have been initialized');

    if (transformStream._backpressure === false) {
      return Promise.resolve();
    }

    assert(transformStream._backpressure === true, '_backpressure should have been initialized');
    return transformStream._backpressureChangePromise;
  }

  function TransformStreamSetBackpressure(transformStream, backpressure) {
    assert(transformStream._backpressure !== backpressure, 'TransformStreamSetBackpressure() should be called only when backpressure is changed');

    if (transformStream._backpressureChangePromise !== undefined) {
      transformStream._backpressureChangePromise_resolve(backpressure);
    }

    transformStream._backpressureChangePromise = new Promise(function (resolve) {
      transformStream._backpressureChangePromise_resolve = resolve;
    });

    transformStream._backpressureChangePromise.then(function (resolution) {
      assert(resolution !== backpressure, '_backpressureChangePromise should be fulfilled only when backpressure is changed');
    });

    transformStream._backpressure = backpressure;
  }

  function TransformStreamDefaultTransform(chunk, transformStreamController) {
    var transformStream = transformStreamController._controlledTransformStream;
    TransformStreamEnqueueToReadable(transformStream, chunk);
    return Promise.resolve();
  }

  function TransformStreamTransform(transformStream, chunk) {
    assert(transformStream._errored === false);
    assert(transformStream._transforming === false);
    assert(transformStream._backpressure === false);
    transformStream._transforming = true;
    var transformer = transformStream._transformer;
    var controller = transformStream._transformStreamController;
    var transformPromise = PromiseInvokeOrPerformFallback(transformer, 'transform', [chunk, controller], TransformStreamDefaultTransform, [chunk, controller]);
    return transformPromise.then(function () {
      transformStream._transforming = false;
      return TransformStreamReadableReadyPromise(transformStream);
    }, function (e) {
      TransformStreamErrorIfNeeded(transformStream, e);
      return Promise.reject(e);
    });
  }

  function IsTransformStreamDefaultController(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_controlledTransformStream')) {
      return false;
    }

    return true;
  }

  function IsTransformStream(x) {
    if (!typeIsObject(x)) {
      return false;
    }

    if (!Object.prototype.hasOwnProperty.call(x, '_transformStreamController')) {
      return false;
    }

    return true;
  }

  var TransformStreamSink = function () {
    function TransformStreamSink(transformStream, startPromise) {
      _classCallCheck(this, TransformStreamSink);

      this._transformStream = transformStream;
      this._startPromise = startPromise;
    }

    _createClass(TransformStreamSink, [{
      key: 'start',
      value: function start(c) {
        var transformStream = this._transformStream;
        transformStream._writableController = c;
        return this._startPromise.then(function () {
          return TransformStreamReadableReadyPromise(transformStream);
        });
      }
    }, {
      key: 'write',
      value: function write(chunk) {
        var transformStream = this._transformStream;
        return TransformStreamTransform(transformStream, chunk);
      }
    }, {
      key: 'abort',
      value: function abort() {
        var transformStream = this._transformStream;
        transformStream._writableDone = true;
        TransformStreamErrorInternal(transformStream, new TypeError('Writable side aborted'));
      }
    }, {
      key: 'close',
      value: function close() {
        var transformStream = this._transformStream;
        assert(transformStream._transforming === false);
        transformStream._writableDone = true;
        var flushPromise = PromiseInvokeOrNoop(transformStream._transformer, 'flush', [transformStream._transformStreamController]);
        return flushPromise.then(function () {
          if (transformStream._errored === true) {
            return Promise.reject(transformStream._storedError);
          }

          if (transformStream._readableClosed === false) {
            TransformStreamCloseReadableInternal(transformStream);
          }

          return Promise.resolve();
        }).catch(function (r) {
          TransformStreamErrorIfNeeded(transformStream, r);
          return Promise.reject(transformStream._storedError);
        });
      }
    }]);

    return TransformStreamSink;
  }();

  var TransformStreamSource = function () {
    function TransformStreamSource(transformStream, startPromise) {
      _classCallCheck(this, TransformStreamSource);

      this._transformStream = transformStream;
      this._startPromise = startPromise;
    }

    _createClass(TransformStreamSource, [{
      key: 'start',
      value: function start(c) {
        var transformStream = this._transformStream;
        transformStream._readableController = c;
        return this._startPromise.then(function () {
          assert(transformStream._backpressureChangePromise !== undefined, '_backpressureChangePromise should have been initialized');

          if (transformStream._backpressure === true) {
            return Promise.resolve();
          }

          assert(transformStream._backpressure === false, '_backpressure should have been initialized');
          return transformStream._backpressureChangePromise;
        });
      }
    }, {
      key: 'pull',
      value: function pull() {
        var transformStream = this._transformStream;
        assert(transformStream._backpressure === true, 'pull() should be never called while _backpressure is false');
        assert(transformStream._backpressureChangePromise !== undefined, '_backpressureChangePromise should have been initialized');
        TransformStreamSetBackpressure(transformStream, false);
        return transformStream._backpressureChangePromise;
      }
    }, {
      key: 'cancel',
      value: function cancel() {
        var transformStream = this._transformStream;
        transformStream._readableClosed = true;
        TransformStreamErrorInternal(transformStream, new TypeError('Readable side canceled'));
      }
    }]);

    return TransformStreamSource;
  }();

  var TransformStreamDefaultController = function () {
    function TransformStreamDefaultController(transformStream) {
      _classCallCheck(this, TransformStreamDefaultController);

      if (IsTransformStream(transformStream) === false) {
        throw new TypeError('TransformStreamDefaultController can only be ' + 'constructed with a TransformStream instance');
      }

      if (transformStream._transformStreamController !== undefined) {
        throw new TypeError('TransformStreamDefaultController instances can ' + 'only be created by the TransformStream constructor');
      }

      this._controlledTransformStream = transformStream;
    }

    _createClass(TransformStreamDefaultController, [{
      key: 'enqueue',
      value: function enqueue(chunk) {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('enqueue');
        }

        TransformStreamEnqueueToReadable(this._controlledTransformStream, chunk);
      }
    }, {
      key: 'close',
      value: function close() {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('close');
        }

        TransformStreamCloseReadable(this._controlledTransformStream);
      }
    }, {
      key: 'error',
      value: function error(reason) {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('error');
        }

        TransformStreamError(this._controlledTransformStream, reason);
      }
    }, {
      key: 'desiredSize',
      get: function get() {
        if (IsTransformStreamDefaultController(this) === false) {
          throw defaultControllerBrandCheckException('desiredSize');
        }

        var transformStream = this._controlledTransformStream;
        var readableController = transformStream._readableController;
        return ReadableStreamDefaultControllerGetDesiredSize(readableController);
      }
    }]);

    return TransformStreamDefaultController;
  }();

  var TransformStream = function () {
    function TransformStream() {
      var transformer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _classCallCheck(this, TransformStream);

      this._transformer = transformer;
      var readableStrategy = transformer.readableStrategy,
          writableStrategy = transformer.writableStrategy;
      this._transforming = false;
      this._errored = false;
      this._storedError = undefined;
      this._writableController = undefined;
      this._readableController = undefined;
      this._transformStreamController = undefined;
      this._writableDone = false;
      this._readableClosed = false;
      this._backpressure = undefined;
      this._backpressureChangePromise = undefined;
      this._backpressureChangePromise_resolve = undefined;
      this._transformStreamController = new TransformStreamDefaultController(this);
      var startPromise_resolve = void 0;
      var startPromise = new Promise(function (resolve) {
        startPromise_resolve = resolve;
      });
      var source = new TransformStreamSource(this, startPromise);
      this._readable = new ReadableStream(source, readableStrategy);
      var sink = new TransformStreamSink(this, startPromise);
      this._writable = new WritableStream(sink, writableStrategy);
      assert(this._writableController !== undefined);
      assert(this._readableController !== undefined);
      var desiredSize = ReadableStreamDefaultControllerGetDesiredSize(this._readableController);
      TransformStreamSetBackpressure(this, desiredSize <= 0);
      var transformStream = this;
      var startResult = InvokeOrNoop(transformer, 'start', [transformStream._transformStreamController]);
      startPromise_resolve(startResult);
      startPromise.catch(function (e) {
        if (transformStream._errored === false) {
          transformStream._errored = true;
          transformStream._storedError = e;
        }
      });
    }

    _createClass(TransformStream, [{
      key: 'readable',
      get: function get() {
        if (IsTransformStream(this) === false) {
          throw streamBrandCheckException('readable');
        }

        return this._readable;
      }
    }, {
      key: 'writable',
      get: function get() {
        if (IsTransformStream(this) === false) {
          throw streamBrandCheckException('writable');
        }

        return this._writable;
      }
    }]);

    return TransformStream;
  }();

  module.exports = {
    TransformStream: TransformStream
  };

  function defaultControllerBrandCheckException(name) {
    return new TypeError('TransformStreamDefaultController.prototype.' + name + ' can only be used on a TransformStreamDefaultController');
  }

  function streamBrandCheckException(name) {
    return new TypeError('TransformStream.prototype.' + name + ' can only be used on a TransformStream');
  }
}, function (module, exports, __w_pdfjs_require__) {
  module.exports = __w_pdfjs_require__(5);
}]));

/***/ }),
/* 149 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

{
  var isURLSupported = false;

  try {
    if (typeof URL === 'function' && _typeof(URL.prototype) === 'object' && 'origin' in URL.prototype) {
      var u = new URL('b', 'http://a');
      u.pathname = 'c%20d';
      isURLSupported = u.href === 'http://a/c%20d';
    }
  } catch (ex) {}

  if (isURLSupported) {
    exports.URL = URL;
  } else {
    var PolyfillURL = __w_pdfjs_require__(150).URL;

    var OriginalURL = __w_pdfjs_require__(8).URL;

    if (OriginalURL) {
      PolyfillURL.createObjectURL = function (blob) {
        return OriginalURL.createObjectURL.apply(OriginalURL, arguments);
      };

      PolyfillURL.revokeObjectURL = function (url) {
        OriginalURL.revokeObjectURL(url);
      };
    }

    exports.URL = PolyfillURL;
  }
}

/***/ }),
/* 150 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


(function URLConstructorClosure() {
  'use strict';

  var relative = Object.create(null);
  relative['ftp'] = 21;
  relative['file'] = 0;
  relative['gopher'] = 70;
  relative['http'] = 80;
  relative['https'] = 443;
  relative['ws'] = 80;
  relative['wss'] = 443;
  var relativePathDotMapping = Object.create(null);
  relativePathDotMapping['%2e'] = '.';
  relativePathDotMapping['.%2e'] = '..';
  relativePathDotMapping['%2e.'] = '..';
  relativePathDotMapping['%2e%2e'] = '..';

  function isRelativeScheme(scheme) {
    return relative[scheme] !== undefined;
  }

  function invalid() {
    clear.call(this);
    this._isInvalid = true;
  }

  function IDNAToASCII(h) {
    if (h === '') {
      invalid.call(this);
    }

    return h.toLowerCase();
  }

  function percentEscape(c) {
    var unicode = c.charCodeAt(0);

    if (unicode > 0x20 && unicode < 0x7F && [0x22, 0x23, 0x3C, 0x3E, 0x3F, 0x60].indexOf(unicode) === -1) {
      return c;
    }

    return encodeURIComponent(c);
  }

  function percentEscapeQuery(c) {
    var unicode = c.charCodeAt(0);

    if (unicode > 0x20 && unicode < 0x7F && [0x22, 0x23, 0x3C, 0x3E, 0x60].indexOf(unicode) === -1) {
      return c;
    }

    return encodeURIComponent(c);
  }

  var EOF,
      ALPHA = /[a-zA-Z]/,
      ALPHANUMERIC = /[a-zA-Z0-9\+\-\.]/;

  function parse(input, stateOverride, base) {
    function err(message) {
      errors.push(message);
    }

    var state = stateOverride || 'scheme start',
        cursor = 0,
        buffer = '',
        seenAt = false,
        seenBracket = false,
        errors = [];

    loop: while ((input[cursor - 1] !== EOF || cursor === 0) && !this._isInvalid) {
      var c = input[cursor];

      switch (state) {
        case 'scheme start':
          if (c && ALPHA.test(c)) {
            buffer += c.toLowerCase();
            state = 'scheme';
          } else if (!stateOverride) {
            buffer = '';
            state = 'no scheme';
            continue;
          } else {
            err('Invalid scheme.');
            break loop;
          }

          break;

        case 'scheme':
          if (c && ALPHANUMERIC.test(c)) {
            buffer += c.toLowerCase();
          } else if (c === ':') {
            this._scheme = buffer;
            buffer = '';

            if (stateOverride) {
              break loop;
            }

            if (isRelativeScheme(this._scheme)) {
              this._isRelative = true;
            }

            if (this._scheme === 'file') {
              state = 'relative';
            } else if (this._isRelative && base && base._scheme === this._scheme) {
              state = 'relative or authority';
            } else if (this._isRelative) {
              state = 'authority first slash';
            } else {
              state = 'scheme data';
            }
          } else if (!stateOverride) {
            buffer = '';
            cursor = 0;
            state = 'no scheme';
            continue;
          } else if (c === EOF) {
            break loop;
          } else {
            err('Code point not allowed in scheme: ' + c);
            break loop;
          }

          break;

        case 'scheme data':
          if (c === '?') {
            this._query = '?';
            state = 'query';
          } else if (c === '#') {
            this._fragment = '#';
            state = 'fragment';
          } else {
            if (c !== EOF && c !== '\t' && c !== '\n' && c !== '\r') {
              this._schemeData += percentEscape(c);
            }
          }

          break;

        case 'no scheme':
          if (!base || !isRelativeScheme(base._scheme)) {
            err('Missing scheme.');
            invalid.call(this);
          } else {
            state = 'relative';
            continue;
          }

          break;

        case 'relative or authority':
          if (c === '/' && input[cursor + 1] === '/') {
            state = 'authority ignore slashes';
          } else {
            err('Expected /, got: ' + c);
            state = 'relative';
            continue;
          }

          break;

        case 'relative':
          this._isRelative = true;

          if (this._scheme !== 'file') {
            this._scheme = base._scheme;
          }

          if (c === EOF) {
            this._host = base._host;
            this._port = base._port;
            this._path = base._path.slice();
            this._query = base._query;
            this._username = base._username;
            this._password = base._password;
            break loop;
          } else if (c === '/' || c === '\\') {
            if (c === '\\') {
              err('\\ is an invalid code point.');
            }

            state = 'relative slash';
          } else if (c === '?') {
            this._host = base._host;
            this._port = base._port;
            this._path = base._path.slice();
            this._query = '?';
            this._username = base._username;
            this._password = base._password;
            state = 'query';
          } else if (c === '#') {
            this._host = base._host;
            this._port = base._port;
            this._path = base._path.slice();
            this._query = base._query;
            this._fragment = '#';
            this._username = base._username;
            this._password = base._password;
            state = 'fragment';
          } else {
            var nextC = input[cursor + 1];
            var nextNextC = input[cursor + 2];

            if (this._scheme !== 'file' || !ALPHA.test(c) || nextC !== ':' && nextC !== '|' || nextNextC !== EOF && nextNextC !== '/' && nextNextC !== '\\' && nextNextC !== '?' && nextNextC !== '#') {
              this._host = base._host;
              this._port = base._port;
              this._username = base._username;
              this._password = base._password;
              this._path = base._path.slice();

              this._path.pop();
            }

            state = 'relative path';
            continue;
          }

          break;

        case 'relative slash':
          if (c === '/' || c === '\\') {
            if (c === '\\') {
              err('\\ is an invalid code point.');
            }

            if (this._scheme === 'file') {
              state = 'file host';
            } else {
              state = 'authority ignore slashes';
            }
          } else {
            if (this._scheme !== 'file') {
              this._host = base._host;
              this._port = base._port;
              this._username = base._username;
              this._password = base._password;
            }

            state = 'relative path';
            continue;
          }

          break;

        case 'authority first slash':
          if (c === '/') {
            state = 'authority second slash';
          } else {
            err('Expected \'/\', got: ' + c);
            state = 'authority ignore slashes';
            continue;
          }

          break;

        case 'authority second slash':
          state = 'authority ignore slashes';

          if (c !== '/') {
            err('Expected \'/\', got: ' + c);
            continue;
          }

          break;

        case 'authority ignore slashes':
          if (c !== '/' && c !== '\\') {
            state = 'authority';
            continue;
          } else {
            err('Expected authority, got: ' + c);
          }

          break;

        case 'authority':
          if (c === '@') {
            if (seenAt) {
              err('@ already seen.');
              buffer += '%40';
            }

            seenAt = true;

            for (var i = 0; i < buffer.length; i++) {
              var cp = buffer[i];

              if (cp === '\t' || cp === '\n' || cp === '\r') {
                err('Invalid whitespace in authority.');
                continue;
              }

              if (cp === ':' && this._password === null) {
                this._password = '';
                continue;
              }

              var tempC = percentEscape(cp);

              if (this._password !== null) {
                this._password += tempC;
              } else {
                this._username += tempC;
              }
            }

            buffer = '';
          } else if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#') {
            cursor -= buffer.length;
            buffer = '';
            state = 'host';
            continue;
          } else {
            buffer += c;
          }

          break;

        case 'file host':
          if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#') {
            if (buffer.length === 2 && ALPHA.test(buffer[0]) && (buffer[1] === ':' || buffer[1] === '|')) {
              state = 'relative path';
            } else if (buffer.length === 0) {
              state = 'relative path start';
            } else {
              this._host = IDNAToASCII.call(this, buffer);
              buffer = '';
              state = 'relative path start';
            }

            continue;
          } else if (c === '\t' || c === '\n' || c === '\r') {
            err('Invalid whitespace in file host.');
          } else {
            buffer += c;
          }

          break;

        case 'host':
        case 'hostname':
          if (c === ':' && !seenBracket) {
            this._host = IDNAToASCII.call(this, buffer);
            buffer = '';
            state = 'port';

            if (stateOverride === 'hostname') {
              break loop;
            }
          } else if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#') {
            this._host = IDNAToASCII.call(this, buffer);
            buffer = '';
            state = 'relative path start';

            if (stateOverride) {
              break loop;
            }

            continue;
          } else if (c !== '\t' && c !== '\n' && c !== '\r') {
            if (c === '[') {
              seenBracket = true;
            } else if (c === ']') {
              seenBracket = false;
            }

            buffer += c;
          } else {
            err('Invalid code point in host/hostname: ' + c);
          }

          break;

        case 'port':
          if (/[0-9]/.test(c)) {
            buffer += c;
          } else if (c === EOF || c === '/' || c === '\\' || c === '?' || c === '#' || stateOverride) {
            if (buffer !== '') {
              var temp = parseInt(buffer, 10);

              if (temp !== relative[this._scheme]) {
                this._port = temp + '';
              }

              buffer = '';
            }

            if (stateOverride) {
              break loop;
            }

            state = 'relative path start';
            continue;
          } else if (c === '\t' || c === '\n' || c === '\r') {
            err('Invalid code point in port: ' + c);
          } else {
            invalid.call(this);
          }

          break;

        case 'relative path start':
          if (c === '\\') {
            err('\'\\\' not allowed in path.');
          }

          state = 'relative path';

          if (c !== '/' && c !== '\\') {
            continue;
          }

          break;

        case 'relative path':
          if (c === EOF || c === '/' || c === '\\' || !stateOverride && (c === '?' || c === '#')) {
            if (c === '\\') {
              err('\\ not allowed in relative path.');
            }

            var tmp;

            if (tmp = relativePathDotMapping[buffer.toLowerCase()]) {
              buffer = tmp;
            }

            if (buffer === '..') {
              this._path.pop();

              if (c !== '/' && c !== '\\') {
                this._path.push('');
              }
            } else if (buffer === '.' && c !== '/' && c !== '\\') {
              this._path.push('');
            } else if (buffer !== '.') {
              if (this._scheme === 'file' && this._path.length === 0 && buffer.length === 2 && ALPHA.test(buffer[0]) && buffer[1] === '|') {
                buffer = buffer[0] + ':';
              }

              this._path.push(buffer);
            }

            buffer = '';

            if (c === '?') {
              this._query = '?';
              state = 'query';
            } else if (c === '#') {
              this._fragment = '#';
              state = 'fragment';
            }
          } else if (c !== '\t' && c !== '\n' && c !== '\r') {
            buffer += percentEscape(c);
          }

          break;

        case 'query':
          if (!stateOverride && c === '#') {
            this._fragment = '#';
            state = 'fragment';
          } else if (c !== EOF && c !== '\t' && c !== '\n' && c !== '\r') {
            this._query += percentEscapeQuery(c);
          }

          break;

        case 'fragment':
          if (c !== EOF && c !== '\t' && c !== '\n' && c !== '\r') {
            this._fragment += c;
          }

          break;
      }

      cursor++;
    }
  }

  function clear() {
    this._scheme = '';
    this._schemeData = '';
    this._username = '';
    this._password = null;
    this._host = '';
    this._port = '';
    this._path = [];
    this._query = '';
    this._fragment = '';
    this._isInvalid = false;
    this._isRelative = false;
  }

  function JURL(url, base) {
    if (base !== undefined && !(base instanceof JURL)) {
      base = new JURL(String(base));
    }

    this._url = url;
    clear.call(this);
    var input = url.replace(/^[ \t\r\n\f]+|[ \t\r\n\f]+$/g, '');
    parse.call(this, input, null, base);
  }

  JURL.prototype = {
    toString: function toString() {
      return this.href;
    },

    get href() {
      if (this._isInvalid) {
        return this._url;
      }

      var authority = '';

      if (this._username !== '' || this._password !== null) {
        authority = this._username + (this._password !== null ? ':' + this._password : '') + '@';
      }

      return this.protocol + (this._isRelative ? '//' + authority + this.host : '') + this.pathname + this._query + this._fragment;
    },

    set href(value) {
      clear.call(this);
      parse.call(this, value);
    },

    get protocol() {
      return this._scheme + ':';
    },

    set protocol(value) {
      if (this._isInvalid) {
        return;
      }

      parse.call(this, value + ':', 'scheme start');
    },

    get host() {
      return this._isInvalid ? '' : this._port ? this._host + ':' + this._port : this._host;
    },

    set host(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      parse.call(this, value, 'host');
    },

    get hostname() {
      return this._host;
    },

    set hostname(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      parse.call(this, value, 'hostname');
    },

    get port() {
      return this._port;
    },

    set port(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      parse.call(this, value, 'port');
    },

    get pathname() {
      return this._isInvalid ? '' : this._isRelative ? '/' + this._path.join('/') : this._schemeData;
    },

    set pathname(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      this._path = [];
      parse.call(this, value, 'relative path start');
    },

    get search() {
      return this._isInvalid || !this._query || this._query === '?' ? '' : this._query;
    },

    set search(value) {
      if (this._isInvalid || !this._isRelative) {
        return;
      }

      this._query = '?';

      if (value[0] === '?') {
        value = value.slice(1);
      }

      parse.call(this, value, 'query');
    },

    get hash() {
      return this._isInvalid || !this._fragment || this._fragment === '#' ? '' : this._fragment;
    },

    set hash(value) {
      if (this._isInvalid) {
        return;
      }

      this._fragment = '#';

      if (value[0] === '#') {
        value = value.slice(1);
      }

      parse.call(this, value, 'fragment');
    },

    get origin() {
      var host;

      if (this._isInvalid || !this._scheme) {
        return '';
      }

      switch (this._scheme) {
        case 'data':
        case 'file':
        case 'javascript':
        case 'mailto':
          return 'null';

        case 'blob':
          try {
            return new JURL(this._schemeData).origin || 'null';
          } catch (_) {}

          return 'null';
      }

      host = this.host;

      if (!host) {
        return '';
      }

      return this._scheme + '://' + host;
    }

  };
  exports.URL = JURL;
})();

/***/ }),
/* 151 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NetworkPdfManager = exports.LocalPdfManager = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(2));

var _util = __w_pdfjs_require__(6);

var _chunked_stream = __w_pdfjs_require__(152);

var _document = __w_pdfjs_require__(153);

var _stream = __w_pdfjs_require__(157);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var BasePdfManager =
/*#__PURE__*/
function () {
  function BasePdfManager() {
    _classCallCheck(this, BasePdfManager);

    if (this.constructor === BasePdfManager) {
      (0, _util.unreachable)('Cannot initialize BasePdfManager.');
    }
  }

  _createClass(BasePdfManager, [{
    key: "onLoadedStream",
    value: function onLoadedStream() {
      (0, _util.unreachable)('Abstract method `onLoadedStream` called');
    }
  }, {
    key: "ensureDoc",
    value: function ensureDoc(prop, args) {
      return this.ensure(this.pdfDocument, prop, args);
    }
  }, {
    key: "ensureXRef",
    value: function ensureXRef(prop, args) {
      return this.ensure(this.pdfDocument.xref, prop, args);
    }
  }, {
    key: "ensureCatalog",
    value: function ensureCatalog(prop, args) {
      return this.ensure(this.pdfDocument.catalog, prop, args);
    }
  }, {
    key: "getPage",
    value: function getPage(pageIndex) {
      return this.pdfDocument.getPage(pageIndex);
    }
  }, {
    key: "fontFallback",
    value: function fontFallback(id, handler) {
      return this.pdfDocument.fontFallback(id, handler);
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      return this.pdfDocument.cleanup();
    }
  }, {
    key: "ensure",
    value: function () {
      var _ensure = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(obj, prop, args) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0, _util.unreachable)('Abstract method `ensure` called');

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function ensure(_x, _x2, _x3) {
        return _ensure.apply(this, arguments);
      }

      return ensure;
    }()
  }, {
    key: "requestRange",
    value: function requestRange(begin, end) {
      (0, _util.unreachable)('Abstract method `requestRange` called');
    }
  }, {
    key: "requestLoadedStream",
    value: function requestLoadedStream() {
      (0, _util.unreachable)('Abstract method `requestLoadedStream` called');
    }
  }, {
    key: "sendProgressiveData",
    value: function sendProgressiveData(chunk) {
      (0, _util.unreachable)('Abstract method `sendProgressiveData` called');
    }
  }, {
    key: "updatePassword",
    value: function updatePassword(password) {
      this._password = password;
    }
  }, {
    key: "terminate",
    value: function terminate() {
      (0, _util.unreachable)('Abstract method `terminate` called');
    }
  }, {
    key: "docId",
    get: function get() {
      return this._docId;
    }
  }, {
    key: "password",
    get: function get() {
      return this._password;
    }
  }, {
    key: "docBaseUrl",
    get: function get() {
      var docBaseUrl = null;

      if (this._docBaseUrl) {
        var absoluteUrl = (0, _util.createValidAbsoluteUrl)(this._docBaseUrl);

        if (absoluteUrl) {
          docBaseUrl = absoluteUrl.href;
        } else {
          (0, _util.warn)("Invalid absolute docBaseUrl: \"".concat(this._docBaseUrl, "\"."));
        }
      }

      return (0, _util.shadow)(this, 'docBaseUrl', docBaseUrl);
    }
  }]);

  return BasePdfManager;
}();

var LocalPdfManager =
/*#__PURE__*/
function (_BasePdfManager) {
  _inherits(LocalPdfManager, _BasePdfManager);

  function LocalPdfManager(docId, data, password, evaluatorOptions, docBaseUrl) {
    var _this;

    _classCallCheck(this, LocalPdfManager);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LocalPdfManager).call(this));
    _this._docId = docId;
    _this._password = password;
    _this._docBaseUrl = docBaseUrl;
    _this.evaluatorOptions = evaluatorOptions;
    var stream = new _stream.Stream(data);
    _this.pdfDocument = new _document.PDFDocument(_assertThisInitialized(_assertThisInitialized(_this)), stream);
    _this._loadedStreamPromise = Promise.resolve(stream);
    return _this;
  }

  _createClass(LocalPdfManager, [{
    key: "ensure",
    value: function () {
      var _ensure2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(obj, prop, args) {
        var value;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                value = obj[prop];

                if (!(typeof value === 'function')) {
                  _context2.next = 3;
                  break;
                }

                return _context2.abrupt("return", value.apply(obj, args));

              case 3:
                return _context2.abrupt("return", value);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function ensure(_x4, _x5, _x6) {
        return _ensure2.apply(this, arguments);
      }

      return ensure;
    }()
  }, {
    key: "requestRange",
    value: function requestRange(begin, end) {
      return Promise.resolve();
    }
  }, {
    key: "requestLoadedStream",
    value: function requestLoadedStream() {}
  }, {
    key: "onLoadedStream",
    value: function onLoadedStream() {
      return this._loadedStreamPromise;
    }
  }, {
    key: "terminate",
    value: function terminate() {}
  }]);

  return LocalPdfManager;
}(BasePdfManager);

exports.LocalPdfManager = LocalPdfManager;

var NetworkPdfManager =
/*#__PURE__*/
function (_BasePdfManager2) {
  _inherits(NetworkPdfManager, _BasePdfManager2);

  function NetworkPdfManager(docId, pdfNetworkStream, args, evaluatorOptions, docBaseUrl) {
    var _this2;

    _classCallCheck(this, NetworkPdfManager);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(NetworkPdfManager).call(this));
    _this2._docId = docId;
    _this2._password = args.password;
    _this2._docBaseUrl = docBaseUrl;
    _this2.msgHandler = args.msgHandler;
    _this2.evaluatorOptions = evaluatorOptions;
    _this2.streamManager = new _chunked_stream.ChunkedStreamManager(pdfNetworkStream, {
      msgHandler: args.msgHandler,
      length: args.length,
      disableAutoFetch: args.disableAutoFetch,
      rangeChunkSize: args.rangeChunkSize
    });
    _this2.pdfDocument = new _document.PDFDocument(_assertThisInitialized(_assertThisInitialized(_this2)), _this2.streamManager.getStream());
    return _this2;
  }

  _createClass(NetworkPdfManager, [{
    key: "ensure",
    value: function () {
      var _ensure3 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(obj, prop, args) {
        var value;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                value = obj[prop];

                if (!(typeof value === 'function')) {
                  _context3.next = 4;
                  break;
                }

                return _context3.abrupt("return", value.apply(obj, args));

              case 4:
                return _context3.abrupt("return", value);

              case 7:
                _context3.prev = 7;
                _context3.t0 = _context3["catch"](0);

                if (_context3.t0 instanceof _util.MissingDataException) {
                  _context3.next = 11;
                  break;
                }

                throw _context3.t0;

              case 11:
                _context3.next = 13;
                return this.requestRange(_context3.t0.begin, _context3.t0.end);

              case 13:
                return _context3.abrupt("return", this.ensure(obj, prop, args));

              case 14:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[0, 7]]);
      }));

      function ensure(_x7, _x8, _x9) {
        return _ensure3.apply(this, arguments);
      }

      return ensure;
    }()
  }, {
    key: "requestRange",
    value: function requestRange(begin, end) {
      return this.streamManager.requestRange(begin, end);
    }
  }, {
    key: "requestLoadedStream",
    value: function requestLoadedStream() {
      this.streamManager.requestAllChunks();
    }
  }, {
    key: "sendProgressiveData",
    value: function sendProgressiveData(chunk) {
      this.streamManager.onReceiveData({
        chunk: chunk
      });
    }
  }, {
    key: "onLoadedStream",
    value: function onLoadedStream() {
      return this.streamManager.onLoadedStream();
    }
  }, {
    key: "terminate",
    value: function terminate() {
      this.streamManager.abort();
    }
  }]);

  return NetworkPdfManager;
}(BasePdfManager);

exports.NetworkPdfManager = NetworkPdfManager;

/***/ }),
/* 152 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChunkedStreamManager = exports.ChunkedStream = void 0;

var _util = __w_pdfjs_require__(6);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ChunkedStream =
/*#__PURE__*/
function () {
  function ChunkedStream(length, chunkSize, manager) {
    _classCallCheck(this, ChunkedStream);

    this.bytes = new Uint8Array(length);
    this.start = 0;
    this.pos = 0;
    this.end = length;
    this.chunkSize = chunkSize;
    this.loadedChunks = [];
    this.numChunksLoaded = 0;
    this.numChunks = Math.ceil(length / chunkSize);
    this.manager = manager;
    this.progressiveDataLength = 0;
    this.lastSuccessfulEnsureByteChunk = -1;
  }

  _createClass(ChunkedStream, [{
    key: "getMissingChunks",
    value: function getMissingChunks() {
      var chunks = [];

      for (var chunk = 0, n = this.numChunks; chunk < n; ++chunk) {
        if (!this.loadedChunks[chunk]) {
          chunks.push(chunk);
        }
      }

      return chunks;
    }
  }, {
    key: "getBaseStreams",
    value: function getBaseStreams() {
      return [this];
    }
  }, {
    key: "allChunksLoaded",
    value: function allChunksLoaded() {
      return this.numChunksLoaded === this.numChunks;
    }
  }, {
    key: "onReceiveData",
    value: function onReceiveData(begin, chunk) {
      var chunkSize = this.chunkSize;

      if (begin % chunkSize !== 0) {
        throw new Error("Bad begin offset: ".concat(begin));
      }

      var end = begin + chunk.byteLength;

      if (end % chunkSize !== 0 && end !== this.bytes.length) {
        throw new Error("Bad end offset: ".concat(end));
      }

      this.bytes.set(new Uint8Array(chunk), begin);
      var beginChunk = Math.floor(begin / chunkSize);
      var endChunk = Math.floor((end - 1) / chunkSize) + 1;

      for (var curChunk = beginChunk; curChunk < endChunk; ++curChunk) {
        if (!this.loadedChunks[curChunk]) {
          this.loadedChunks[curChunk] = true;
          ++this.numChunksLoaded;
        }
      }
    }
  }, {
    key: "onReceiveProgressiveData",
    value: function onReceiveProgressiveData(data) {
      var position = this.progressiveDataLength;
      var beginChunk = Math.floor(position / this.chunkSize);
      this.bytes.set(new Uint8Array(data), position);
      position += data.byteLength;
      this.progressiveDataLength = position;
      var endChunk = position >= this.end ? this.numChunks : Math.floor(position / this.chunkSize);

      for (var curChunk = beginChunk; curChunk < endChunk; ++curChunk) {
        if (!this.loadedChunks[curChunk]) {
          this.loadedChunks[curChunk] = true;
          ++this.numChunksLoaded;
        }
      }
    }
  }, {
    key: "ensureByte",
    value: function ensureByte(pos) {
      var chunk = Math.floor(pos / this.chunkSize);

      if (chunk === this.lastSuccessfulEnsureByteChunk) {
        return;
      }

      if (!this.loadedChunks[chunk]) {
        throw new _util.MissingDataException(pos, pos + 1);
      }

      this.lastSuccessfulEnsureByteChunk = chunk;
    }
  }, {
    key: "ensureRange",
    value: function ensureRange(begin, end) {
      if (begin >= end) {
        return;
      }

      if (end <= this.progressiveDataLength) {
        return;
      }

      var chunkSize = this.chunkSize;
      var beginChunk = Math.floor(begin / chunkSize);
      var endChunk = Math.floor((end - 1) / chunkSize) + 1;

      for (var chunk = beginChunk; chunk < endChunk; ++chunk) {
        if (!this.loadedChunks[chunk]) {
          throw new _util.MissingDataException(begin, end);
        }
      }
    }
  }, {
    key: "nextEmptyChunk",
    value: function nextEmptyChunk(beginChunk) {
      var numChunks = this.numChunks;

      for (var i = 0; i < numChunks; ++i) {
        var chunk = (beginChunk + i) % numChunks;

        if (!this.loadedChunks[chunk]) {
          return chunk;
        }
      }

      return null;
    }
  }, {
    key: "hasChunk",
    value: function hasChunk(chunk) {
      return !!this.loadedChunks[chunk];
    }
  }, {
    key: "getByte",
    value: function getByte() {
      var pos = this.pos;

      if (pos >= this.end) {
        return -1;
      }

      this.ensureByte(pos);
      return this.bytes[this.pos++];
    }
  }, {
    key: "getUint16",
    value: function getUint16() {
      var b0 = this.getByte();
      var b1 = this.getByte();

      if (b0 === -1 || b1 === -1) {
        return -1;
      }

      return (b0 << 8) + b1;
    }
  }, {
    key: "getInt32",
    value: function getInt32() {
      var b0 = this.getByte();
      var b1 = this.getByte();
      var b2 = this.getByte();
      var b3 = this.getByte();
      return (b0 << 24) + (b1 << 16) + (b2 << 8) + b3;
    }
  }, {
    key: "getBytes",
    value: function getBytes(length) {
      var forceClamped = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var bytes = this.bytes;
      var pos = this.pos;
      var strEnd = this.end;

      if (!length) {
        this.ensureRange(pos, strEnd);

        var _subarray = bytes.subarray(pos, strEnd);

        return forceClamped ? new Uint8ClampedArray(_subarray) : _subarray;
      }

      var end = pos + length;

      if (end > strEnd) {
        end = strEnd;
      }

      this.ensureRange(pos, end);
      this.pos = end;
      var subarray = bytes.subarray(pos, end);
      return forceClamped ? new Uint8ClampedArray(subarray) : subarray;
    }
  }, {
    key: "peekByte",
    value: function peekByte() {
      var peekedByte = this.getByte();
      this.pos--;
      return peekedByte;
    }
  }, {
    key: "peekBytes",
    value: function peekBytes(length) {
      var forceClamped = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var bytes = this.getBytes(length, forceClamped);
      this.pos -= bytes.length;
      return bytes;
    }
  }, {
    key: "getByteRange",
    value: function getByteRange(begin, end) {
      this.ensureRange(begin, end);
      return this.bytes.subarray(begin, end);
    }
  }, {
    key: "skip",
    value: function skip(n) {
      if (!n) {
        n = 1;
      }

      this.pos += n;
    }
  }, {
    key: "reset",
    value: function reset() {
      this.pos = this.start;
    }
  }, {
    key: "moveStart",
    value: function moveStart() {
      this.start = this.pos;
    }
  }, {
    key: "makeSubStream",
    value: function makeSubStream(start, length, dict) {
      this.ensureRange(start, start + length);

      function ChunkedStreamSubstream() {}

      ChunkedStreamSubstream.prototype = Object.create(this);

      ChunkedStreamSubstream.prototype.getMissingChunks = function () {
        var chunkSize = this.chunkSize;
        var beginChunk = Math.floor(this.start / chunkSize);
        var endChunk = Math.floor((this.end - 1) / chunkSize) + 1;
        var missingChunks = [];

        for (var chunk = beginChunk; chunk < endChunk; ++chunk) {
          if (!this.loadedChunks[chunk]) {
            missingChunks.push(chunk);
          }
        }

        return missingChunks;
      };

      var subStream = new ChunkedStreamSubstream();
      subStream.pos = subStream.start = start;
      subStream.end = start + length || this.end;
      subStream.dict = dict;
      return subStream;
    }
  }, {
    key: "length",
    get: function get() {
      return this.end - this.start;
    }
  }, {
    key: "isEmpty",
    get: function get() {
      return this.length === 0;
    }
  }]);

  return ChunkedStream;
}();

exports.ChunkedStream = ChunkedStream;

var ChunkedStreamManager =
/*#__PURE__*/
function () {
  function ChunkedStreamManager(pdfNetworkStream, args) {
    _classCallCheck(this, ChunkedStreamManager);

    this.length = args.length;
    this.chunkSize = args.rangeChunkSize;
    this.stream = new ChunkedStream(this.length, this.chunkSize, this);
    this.pdfNetworkStream = pdfNetworkStream;
    this.disableAutoFetch = args.disableAutoFetch;
    this.msgHandler = args.msgHandler;
    this.currRequestId = 0;
    this.chunksNeededByRequest = Object.create(null);
    this.requestsByChunk = Object.create(null);
    this.promisesByRequest = Object.create(null);
    this.progressiveDataLength = 0;
    this.aborted = false;
    this._loadedStreamCapability = (0, _util.createPromiseCapability)();
  }

  _createClass(ChunkedStreamManager, [{
    key: "onLoadedStream",
    value: function onLoadedStream() {
      return this._loadedStreamCapability.promise;
    }
  }, {
    key: "sendRequest",
    value: function sendRequest(begin, end) {
      var _this = this;

      var rangeReader = this.pdfNetworkStream.getRangeReader(begin, end);

      if (!rangeReader.isStreamingSupported) {
        rangeReader.onProgress = this.onProgress.bind(this);
      }

      var chunks = [],
          loaded = 0;
      var promise = new Promise(function (resolve, reject) {
        var readChunk = function readChunk(chunk) {
          try {
            if (!chunk.done) {
              var data = chunk.value;
              chunks.push(data);
              loaded += (0, _util.arrayByteLength)(data);

              if (rangeReader.isStreamingSupported) {
                _this.onProgress({
                  loaded: loaded
                });
              }

              rangeReader.read().then(readChunk, reject);
              return;
            }

            var chunkData = (0, _util.arraysToBytes)(chunks);
            chunks = null;
            resolve(chunkData);
          } catch (e) {
            reject(e);
          }
        };

        rangeReader.read().then(readChunk, reject);
      });
      promise.then(function (data) {
        if (_this.aborted) {
          return;
        }

        _this.onReceiveData({
          chunk: data,
          begin: begin
        });
      });
    }
  }, {
    key: "requestAllChunks",
    value: function requestAllChunks() {
      var missingChunks = this.stream.getMissingChunks();

      this._requestChunks(missingChunks);

      return this._loadedStreamCapability.promise;
    }
  }, {
    key: "_requestChunks",
    value: function _requestChunks(chunks) {
      var requestId = this.currRequestId++;
      var chunksNeeded = Object.create(null);
      this.chunksNeededByRequest[requestId] = chunksNeeded;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = chunks[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _chunk = _step.value;

          if (!this.stream.hasChunk(_chunk)) {
            chunksNeeded[_chunk] = true;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if ((0, _util.isEmptyObj)(chunksNeeded)) {
        return Promise.resolve();
      }

      var capability = (0, _util.createPromiseCapability)();
      this.promisesByRequest[requestId] = capability;
      var chunksToRequest = [];

      for (var chunk in chunksNeeded) {
        chunk = chunk | 0;

        if (!(chunk in this.requestsByChunk)) {
          this.requestsByChunk[chunk] = [];
          chunksToRequest.push(chunk);
        }

        this.requestsByChunk[chunk].push(requestId);
      }

      if (!chunksToRequest.length) {
        return capability.promise;
      }

      var groupedChunksToRequest = this.groupChunks(chunksToRequest);
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = groupedChunksToRequest[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var groupedChunk = _step2.value;
          var begin = groupedChunk.beginChunk * this.chunkSize;
          var end = Math.min(groupedChunk.endChunk * this.chunkSize, this.length);
          this.sendRequest(begin, end);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return capability.promise;
    }
  }, {
    key: "getStream",
    value: function getStream() {
      return this.stream;
    }
  }, {
    key: "requestRange",
    value: function requestRange(begin, end) {
      end = Math.min(end, this.length);
      var beginChunk = this.getBeginChunk(begin);
      var endChunk = this.getEndChunk(end);
      var chunks = [];

      for (var chunk = beginChunk; chunk < endChunk; ++chunk) {
        chunks.push(chunk);
      }

      return this._requestChunks(chunks);
    }
  }, {
    key: "requestRanges",
    value: function requestRanges() {
      var ranges = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var chunksToRequest = [];
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = ranges[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var range = _step3.value;
          var beginChunk = this.getBeginChunk(range.begin);
          var endChunk = this.getEndChunk(range.end);

          for (var chunk = beginChunk; chunk < endChunk; ++chunk) {
            if (!chunksToRequest.includes(chunk)) {
              chunksToRequest.push(chunk);
            }
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      chunksToRequest.sort(function (a, b) {
        return a - b;
      });
      return this._requestChunks(chunksToRequest);
    }
  }, {
    key: "groupChunks",
    value: function groupChunks(chunks) {
      var groupedChunks = [];
      var beginChunk = -1;
      var prevChunk = -1;

      for (var i = 0, ii = chunks.length; i < ii; ++i) {
        var chunk = chunks[i];

        if (beginChunk < 0) {
          beginChunk = chunk;
        }

        if (prevChunk >= 0 && prevChunk + 1 !== chunk) {
          groupedChunks.push({
            beginChunk: beginChunk,
            endChunk: prevChunk + 1
          });
          beginChunk = chunk;
        }

        if (i + 1 === chunks.length) {
          groupedChunks.push({
            beginChunk: beginChunk,
            endChunk: chunk + 1
          });
        }

        prevChunk = chunk;
      }

      return groupedChunks;
    }
  }, {
    key: "onProgress",
    value: function onProgress(args) {
      this.msgHandler.send('DocProgress', {
        loaded: this.stream.numChunksLoaded * this.chunkSize + args.loaded,
        total: this.length
      });
    }
  }, {
    key: "onReceiveData",
    value: function onReceiveData(args) {
      var chunk = args.chunk;
      var isProgressive = args.begin === undefined;
      var begin = isProgressive ? this.progressiveDataLength : args.begin;
      var end = begin + chunk.byteLength;
      var beginChunk = Math.floor(begin / this.chunkSize);
      var endChunk = end < this.length ? Math.floor(end / this.chunkSize) : Math.ceil(end / this.chunkSize);

      if (isProgressive) {
        this.stream.onReceiveProgressiveData(chunk);
        this.progressiveDataLength = end;
      } else {
        this.stream.onReceiveData(begin, chunk);
      }

      if (this.stream.allChunksLoaded()) {
        this._loadedStreamCapability.resolve(this.stream);
      }

      var loadedRequests = [];

      for (var _chunk2 = beginChunk; _chunk2 < endChunk; ++_chunk2) {
        var requestIds = this.requestsByChunk[_chunk2] || [];
        delete this.requestsByChunk[_chunk2];
        var _iteratorNormalCompletion4 = true;
        var _didIteratorError4 = false;
        var _iteratorError4 = undefined;

        try {
          for (var _iterator4 = requestIds[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var requestId = _step4.value;
            var chunksNeeded = this.chunksNeededByRequest[requestId];

            if (_chunk2 in chunksNeeded) {
              delete chunksNeeded[_chunk2];
            }

            if (!(0, _util.isEmptyObj)(chunksNeeded)) {
              continue;
            }

            loadedRequests.push(requestId);
          }
        } catch (err) {
          _didIteratorError4 = true;
          _iteratorError4 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
              _iterator4.return();
            }
          } finally {
            if (_didIteratorError4) {
              throw _iteratorError4;
            }
          }
        }
      }

      if (!this.disableAutoFetch && (0, _util.isEmptyObj)(this.requestsByChunk)) {
        var nextEmptyChunk;

        if (this.stream.numChunksLoaded === 1) {
          var lastChunk = this.stream.numChunks - 1;

          if (!this.stream.hasChunk(lastChunk)) {
            nextEmptyChunk = lastChunk;
          }
        } else {
          nextEmptyChunk = this.stream.nextEmptyChunk(endChunk);
        }

        if (Number.isInteger(nextEmptyChunk)) {
          this._requestChunks([nextEmptyChunk]);
        }
      }

      for (var _i = 0; _i < loadedRequests.length; _i++) {
        var _requestId = loadedRequests[_i];
        var capability = this.promisesByRequest[_requestId];
        delete this.promisesByRequest[_requestId];
        capability.resolve();
      }

      this.msgHandler.send('DocProgress', {
        loaded: this.stream.numChunksLoaded * this.chunkSize,
        total: this.length
      });
    }
  }, {
    key: "onError",
    value: function onError(err) {
      this._loadedStreamCapability.reject(err);
    }
  }, {
    key: "getBeginChunk",
    value: function getBeginChunk(begin) {
      return Math.floor(begin / this.chunkSize);
    }
  }, {
    key: "getEndChunk",
    value: function getEndChunk(end) {
      return Math.floor((end - 1) / this.chunkSize) + 1;
    }
  }, {
    key: "abort",
    value: function abort() {
      this.aborted = true;

      if (this.pdfNetworkStream) {
        this.pdfNetworkStream.cancelAllRequests('abort');
      }

      for (var requestId in this.promisesByRequest) {
        this.promisesByRequest[requestId].reject(new Error('Request was aborted'));
      }
    }
  }]);

  return ChunkedStreamManager;
}();

exports.ChunkedStreamManager = ChunkedStreamManager;

/***/ }),
/* 153 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFDocument = exports.Page = void 0;

var _util = __w_pdfjs_require__(6);

var _obj = __w_pdfjs_require__(154);

var _primitives = __w_pdfjs_require__(155);

var _stream2 = __w_pdfjs_require__(157);

var _annotation = __w_pdfjs_require__(169);

var _crypto = __w_pdfjs_require__(167);

var _parser = __w_pdfjs_require__(156);

var _operator_list = __w_pdfjs_require__(170);

var _evaluator = __w_pdfjs_require__(171);

var _function = __w_pdfjs_require__(185);

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEFAULT_USER_UNIT = 1.0;
var LETTER_SIZE_MEDIABOX = [0, 0, 612, 792];

function isAnnotationRenderable(annotation, intent) {
  return intent === 'display' && annotation.viewable || intent === 'print' && annotation.printable;
}

var Page =
/*#__PURE__*/
function () {
  function Page(_ref) {
    var pdfManager = _ref.pdfManager,
        xref = _ref.xref,
        pageIndex = _ref.pageIndex,
        pageDict = _ref.pageDict,
        ref = _ref.ref,
        fontCache = _ref.fontCache,
        builtInCMapCache = _ref.builtInCMapCache,
        pdfFunctionFactory = _ref.pdfFunctionFactory;

    _classCallCheck(this, Page);

    this.pdfManager = pdfManager;
    this.pageIndex = pageIndex;
    this.pageDict = pageDict;
    this.xref = xref;
    this.ref = ref;
    this.fontCache = fontCache;
    this.builtInCMapCache = builtInCMapCache;
    this.pdfFunctionFactory = pdfFunctionFactory;
    this.evaluatorOptions = pdfManager.evaluatorOptions;
    this.resourcesPromise = null;
    var uniquePrefix = "p".concat(this.pageIndex, "_");
    var idCounters = {
      obj: 0
    };
    this.idFactory = {
      createObjId: function createObjId() {
        return uniquePrefix + ++idCounters.obj;
      }
    };
  }

  _createClass(Page, [{
    key: "_getInheritableProperty",
    value: function _getInheritableProperty(key) {
      var getArray = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var value = (0, _util.getInheritableProperty)({
        dict: this.pageDict,
        key: key,
        getArray: getArray,
        stopWhenFound: false
      });

      if (!Array.isArray(value)) {
        return value;
      }

      if (value.length === 1 || !(0, _primitives.isDict)(value[0])) {
        return value[0];
      }

      return _primitives.Dict.merge(this.xref, value);
    }
  }, {
    key: "getContentStream",
    value: function getContentStream() {
      var content = this.content;
      var stream;

      if (Array.isArray(content)) {
        var xref = this.xref;
        var streams = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = content[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _stream = _step.value;
            streams.push(xref.fetchIfRef(_stream));
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        stream = new _stream2.StreamsSequenceStream(streams);
      } else if ((0, _primitives.isStream)(content)) {
        stream = content;
      } else {
        stream = new _stream2.NullStream();
      }

      return stream;
    }
  }, {
    key: "loadResources",
    value: function loadResources(keys) {
      var _this = this;

      if (!this.resourcesPromise) {
        this.resourcesPromise = this.pdfManager.ensure(this, 'resources');
      }

      return this.resourcesPromise.then(function () {
        var objectLoader = new _obj.ObjectLoader(_this.resources, keys, _this.xref);
        return objectLoader.load();
      });
    }
  }, {
    key: "getOperatorList",
    value: function getOperatorList(_ref2) {
      var _this2 = this;

      var handler = _ref2.handler,
          task = _ref2.task,
          intent = _ref2.intent,
          renderInteractiveForms = _ref2.renderInteractiveForms;
      var contentStreamPromise = this.pdfManager.ensure(this, 'getContentStream');
      var resourcesPromise = this.loadResources(['ExtGState', 'ColorSpace', 'Pattern', 'Shading', 'XObject', 'Font']);
      var partialEvaluator = new _evaluator.PartialEvaluator({
        pdfManager: this.pdfManager,
        xref: this.xref,
        handler: handler,
        pageIndex: this.pageIndex,
        idFactory: this.idFactory,
        fontCache: this.fontCache,
        builtInCMapCache: this.builtInCMapCache,
        options: this.evaluatorOptions,
        pdfFunctionFactory: this.pdfFunctionFactory
      });
      var dataPromises = Promise.all([contentStreamPromise, resourcesPromise]);
      var pageListPromise = dataPromises.then(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 1),
            contentStream = _ref4[0];

        var opList = new _operator_list.OperatorList(intent, handler, _this2.pageIndex);
        handler.send('StartRenderPage', {
          transparency: partialEvaluator.hasBlendModes(_this2.resources),
          pageIndex: _this2.pageIndex,
          intent: intent
        });
        return partialEvaluator.getOperatorList({
          stream: contentStream,
          task: task,
          resources: _this2.resources,
          operatorList: opList
        }).then(function () {
          return opList;
        });
      });
      return Promise.all([pageListPromise, this._parsedAnnotations]).then(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 2),
            pageOpList = _ref6[0],
            annotations = _ref6[1];

        if (annotations.length === 0) {
          pageOpList.flush(true);
          return pageOpList;
        }

        var opListPromises = [];
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = annotations[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var annotation = _step2.value;

            if (isAnnotationRenderable(annotation, intent)) {
              opListPromises.push(annotation.getOperatorList(partialEvaluator, task, renderInteractiveForms));
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        return Promise.all(opListPromises).then(function (opLists) {
          pageOpList.addOp(_util.OPS.beginAnnotations, []);
          var _iteratorNormalCompletion3 = true;
          var _didIteratorError3 = false;
          var _iteratorError3 = undefined;

          try {
            for (var _iterator3 = opLists[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
              var opList = _step3.value;
              pageOpList.addOpList(opList);
            }
          } catch (err) {
            _didIteratorError3 = true;
            _iteratorError3 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
                _iterator3.return();
              }
            } finally {
              if (_didIteratorError3) {
                throw _iteratorError3;
              }
            }
          }

          pageOpList.addOp(_util.OPS.endAnnotations, []);
          pageOpList.flush(true);
          return pageOpList;
        });
      });
    }
  }, {
    key: "extractTextContent",
    value: function extractTextContent(_ref7) {
      var _this3 = this;

      var handler = _ref7.handler,
          task = _ref7.task,
          normalizeWhitespace = _ref7.normalizeWhitespace,
          sink = _ref7.sink,
          combineTextItems = _ref7.combineTextItems;
      var contentStreamPromise = this.pdfManager.ensure(this, 'getContentStream');
      var resourcesPromise = this.loadResources(['ExtGState', 'XObject', 'Font']);
      var dataPromises = Promise.all([contentStreamPromise, resourcesPromise]);
      return dataPromises.then(function (_ref8) {
        var _ref9 = _slicedToArray(_ref8, 1),
            contentStream = _ref9[0];

        var partialEvaluator = new _evaluator.PartialEvaluator({
          pdfManager: _this3.pdfManager,
          xref: _this3.xref,
          handler: handler,
          pageIndex: _this3.pageIndex,
          idFactory: _this3.idFactory,
          fontCache: _this3.fontCache,
          builtInCMapCache: _this3.builtInCMapCache,
          options: _this3.evaluatorOptions,
          pdfFunctionFactory: _this3.pdfFunctionFactory
        });
        return partialEvaluator.getTextContent({
          stream: contentStream,
          task: task,
          resources: _this3.resources,
          normalizeWhitespace: normalizeWhitespace,
          combineTextItems: combineTextItems,
          sink: sink
        });
      });
    }
  }, {
    key: "getAnnotationsData",
    value: function getAnnotationsData(intent) {
      return this._parsedAnnotations.then(function (annotations) {
        var annotationsData = [];

        for (var i = 0, ii = annotations.length; i < ii; i++) {
          if (!intent || isAnnotationRenderable(annotations[i], intent)) {
            annotationsData.push(annotations[i].data);
          }
        }

        return annotationsData;
      });
    }
  }, {
    key: "content",
    get: function get() {
      return this.pageDict.get('Contents');
    }
  }, {
    key: "resources",
    get: function get() {
      return (0, _util.shadow)(this, 'resources', this._getInheritableProperty('Resources') || _primitives.Dict.empty);
    }
  }, {
    key: "mediaBox",
    get: function get() {
      var mediaBox = this._getInheritableProperty('MediaBox', true);

      if (!Array.isArray(mediaBox) || mediaBox.length !== 4) {
        return (0, _util.shadow)(this, 'mediaBox', LETTER_SIZE_MEDIABOX);
      }

      return (0, _util.shadow)(this, 'mediaBox', mediaBox);
    }
  }, {
    key: "cropBox",
    get: function get() {
      var cropBox = this._getInheritableProperty('CropBox', true);

      if (!Array.isArray(cropBox) || cropBox.length !== 4) {
        return (0, _util.shadow)(this, 'cropBox', this.mediaBox);
      }

      return (0, _util.shadow)(this, 'cropBox', cropBox);
    }
  }, {
    key: "userUnit",
    get: function get() {
      var obj = this.pageDict.get('UserUnit');

      if (!(0, _util.isNum)(obj) || obj <= 0) {
        obj = DEFAULT_USER_UNIT;
      }

      return (0, _util.shadow)(this, 'userUnit', obj);
    }
  }, {
    key: "view",
    get: function get() {
      var mediaBox = this.mediaBox,
          cropBox = this.cropBox;

      if (mediaBox === cropBox) {
        return (0, _util.shadow)(this, 'view', mediaBox);
      }

      var intersection = _util.Util.intersect(cropBox, mediaBox);

      return (0, _util.shadow)(this, 'view', intersection || mediaBox);
    }
  }, {
    key: "rotate",
    get: function get() {
      var rotate = this._getInheritableProperty('Rotate') || 0;

      if (rotate % 90 !== 0) {
        rotate = 0;
      } else if (rotate >= 360) {
        rotate = rotate % 360;
      } else if (rotate < 0) {
        rotate = (rotate % 360 + 360) % 360;
      }

      return (0, _util.shadow)(this, 'rotate', rotate);
    }
  }, {
    key: "annotations",
    get: function get() {
      return (0, _util.shadow)(this, 'annotations', this._getInheritableProperty('Annots') || []);
    }
  }, {
    key: "_parsedAnnotations",
    get: function get() {
      var _this4 = this;

      var parsedAnnotations = this.pdfManager.ensure(this, 'annotations').then(function () {
        var annotationRefs = _this4.annotations;
        var annotationPromises = [];

        for (var i = 0, ii = annotationRefs.length; i < ii; i++) {
          annotationPromises.push(_annotation.AnnotationFactory.create(_this4.xref, annotationRefs[i], _this4.pdfManager, _this4.idFactory));
        }

        return Promise.all(annotationPromises).then(function (annotations) {
          return annotations.filter(function isDefined(annotation) {
            return !!annotation;
          });
        }, function (reason) {
          (0, _util.warn)("_parsedAnnotations: \"".concat(reason, "\"."));
          return [];
        });
      });
      return (0, _util.shadow)(this, '_parsedAnnotations', parsedAnnotations);
    }
  }]);

  return Page;
}();

exports.Page = Page;
var FINGERPRINT_FIRST_BYTES = 1024;
var EMPTY_FINGERPRINT = '\x00\x00\x00\x00\x00\x00\x00' + '\x00\x00\x00\x00\x00\x00\x00\x00\x00';

function find(stream, needle, limit, backwards) {
  var pos = stream.pos;
  var end = stream.end;

  if (pos + limit > end) {
    limit = end - pos;
  }

  var strBuf = [];

  for (var i = 0; i < limit; ++i) {
    strBuf.push(String.fromCharCode(stream.getByte()));
  }

  var str = strBuf.join('');
  stream.pos = pos;
  var index = backwards ? str.lastIndexOf(needle) : str.indexOf(needle);

  if (index === -1) {
    return false;
  }

  stream.pos += index;
  return true;
}

var PDFDocument =
/*#__PURE__*/
function () {
  function PDFDocument(pdfManager, arg) {
    _classCallCheck(this, PDFDocument);

    var stream;

    if ((0, _primitives.isStream)(arg)) {
      stream = arg;
    } else if ((0, _util.isArrayBuffer)(arg)) {
      stream = new _stream2.Stream(arg);
    } else {
      throw new Error('PDFDocument: Unknown argument type');
    }

    if (stream.length <= 0) {
      throw new Error('PDFDocument: Stream must have data');
    }

    this.pdfManager = pdfManager;
    this.stream = stream;
    this.xref = new _obj.XRef(stream, pdfManager);
    this.pdfFunctionFactory = new _function.PDFFunctionFactory({
      xref: this.xref,
      isEvalSupported: pdfManager.evaluatorOptions.isEvalSupported
    });
    this._pagePromises = [];
  }

  _createClass(PDFDocument, [{
    key: "parse",
    value: function parse(recoveryMode) {
      this.setup(recoveryMode);
      var version = this.catalog.catDict.get('Version');

      if ((0, _primitives.isName)(version)) {
        this.pdfFormatVersion = version.name;
      }

      try {
        this.acroForm = this.catalog.catDict.get('AcroForm');

        if (this.acroForm) {
          this.xfa = this.acroForm.get('XFA');
          var fields = this.acroForm.get('Fields');

          if ((!fields || !Array.isArray(fields) || fields.length === 0) && !this.xfa) {
            this.acroForm = null;
          }
        }
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.info)('Cannot fetch AcroForm entry; assuming no AcroForms are present');
        this.acroForm = null;
      }
    }
  }, {
    key: "checkHeader",
    value: function checkHeader() {
      var stream = this.stream;
      stream.reset();

      if (!find(stream, '%PDF-', 1024)) {
        return;
      }

      stream.moveStart();
      var MAX_PDF_VERSION_LENGTH = 12;
      var version = '',
          ch;

      while ((ch = stream.getByte()) > 0x20) {
        if (version.length >= MAX_PDF_VERSION_LENGTH) {
          break;
        }

        version += String.fromCharCode(ch);
      }

      if (!this.pdfFormatVersion) {
        this.pdfFormatVersion = version.substring(5);
      }
    }
  }, {
    key: "parseStartXRef",
    value: function parseStartXRef() {
      this.xref.setStartXRef(this.startXRef);
    }
  }, {
    key: "setup",
    value: function setup(recoveryMode) {
      this.xref.parse(recoveryMode);
      this.catalog = new _obj.Catalog(this.pdfManager, this.xref);
    }
  }, {
    key: "_getLinearizationPage",
    value: function _getLinearizationPage(pageIndex) {
      var catalog = this.catalog,
          linearization = this.linearization;
      (0, _util.assert)(linearization && linearization.pageFirst === pageIndex);
      var ref = new _primitives.Ref(linearization.objectNumberFirst, 0);
      return this.xref.fetchAsync(ref).then(function (obj) {
        if ((0, _primitives.isDict)(obj, 'Page') || (0, _primitives.isDict)(obj) && !obj.has('Type') && obj.has('Contents')) {
          if (ref && !catalog.pageKidsCountCache.has(ref)) {
            catalog.pageKidsCountCache.put(ref, 1);
          }

          return [obj, ref];
        }

        throw new _util.FormatError('The Linearization dictionary doesn\'t point ' + 'to a valid Page dictionary.');
      }).catch(function (reason) {
        (0, _util.info)(reason);
        return catalog.getPageDict(pageIndex);
      });
    }
  }, {
    key: "getPage",
    value: function getPage(pageIndex) {
      var _this5 = this;

      if (this._pagePromises[pageIndex] !== undefined) {
        return this._pagePromises[pageIndex];
      }

      var catalog = this.catalog,
          linearization = this.linearization;
      var promise = linearization && linearization.pageFirst === pageIndex ? this._getLinearizationPage(pageIndex) : catalog.getPageDict(pageIndex);
      return this._pagePromises[pageIndex] = promise.then(function (_ref10) {
        var _ref11 = _slicedToArray(_ref10, 2),
            pageDict = _ref11[0],
            ref = _ref11[1];

        return new Page({
          pdfManager: _this5.pdfManager,
          xref: _this5.xref,
          pageIndex: pageIndex,
          pageDict: pageDict,
          ref: ref,
          fontCache: catalog.fontCache,
          builtInCMapCache: catalog.builtInCMapCache,
          pdfFunctionFactory: _this5.pdfFunctionFactory
        });
      });
    }
  }, {
    key: "checkFirstPage",
    value: function checkFirstPage() {
      var _this6 = this;

      return this.getPage(0).catch(function (reason) {
        if (reason instanceof _util.XRefEntryException) {
          _this6._pagePromises.length = 0;

          _this6.cleanup();

          throw new _util.XRefParseException();
        }
      });
    }
  }, {
    key: "fontFallback",
    value: function fontFallback(id, handler) {
      return this.catalog.fontFallback(id, handler);
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      return this.catalog.cleanup();
    }
  }, {
    key: "linearization",
    get: function get() {
      var linearization = null;

      try {
        linearization = _parser.Linearization.create(this.stream);
      } catch (err) {
        if (err instanceof _util.MissingDataException) {
          throw err;
        }

        (0, _util.info)(err);
      }

      return (0, _util.shadow)(this, 'linearization', linearization);
    }
  }, {
    key: "startXRef",
    get: function get() {
      var stream = this.stream;
      var startXRef = 0;

      if (this.linearization) {
        stream.reset();

        if (find(stream, 'endobj', 1024)) {
          startXRef = stream.pos + 6;
        }
      } else {
        var step = 1024;
        var startXRefLength = 'startxref'.length;
        var found = false,
            pos = stream.end;

        while (!found && pos > 0) {
          pos -= step - startXRefLength;

          if (pos < 0) {
            pos = 0;
          }

          stream.pos = pos;
          found = find(stream, 'startxref', step, true);
        }

        if (found) {
          stream.skip(9);
          var ch;

          do {
            ch = stream.getByte();
          } while ((0, _util.isSpace)(ch));

          var str = '';

          while (ch >= 0x20 && ch <= 0x39) {
            str += String.fromCharCode(ch);
            ch = stream.getByte();
          }

          startXRef = parseInt(str, 10);

          if (isNaN(startXRef)) {
            startXRef = 0;
          }
        }
      }

      return (0, _util.shadow)(this, 'startXRef', startXRef);
    }
  }, {
    key: "numPages",
    get: function get() {
      var linearization = this.linearization;
      var num = linearization ? linearization.numPages : this.catalog.numPages;
      return (0, _util.shadow)(this, 'numPages', num);
    }
  }, {
    key: "documentInfo",
    get: function get() {
      var DocumentInfoValidators = {
        Title: _util.isString,
        Author: _util.isString,
        Subject: _util.isString,
        Keywords: _util.isString,
        Creator: _util.isString,
        Producer: _util.isString,
        CreationDate: _util.isString,
        ModDate: _util.isString,
        Trapped: _primitives.isName
      };
      var docInfo = {
        PDFFormatVersion: this.pdfFormatVersion,
        IsLinearized: !!this.linearization,
        IsAcroFormPresent: !!this.acroForm,
        IsXFAPresent: !!this.xfa
      };
      var infoDict;

      try {
        infoDict = this.xref.trailer.get('Info');
      } catch (err) {
        if (err instanceof _util.MissingDataException) {
          throw err;
        }

        (0, _util.info)('The document information dictionary is invalid.');
      }

      if ((0, _primitives.isDict)(infoDict)) {
        var _iteratorNormalCompletion4 = true;
        var _didIteratorError4 = false;
        var _iteratorError4 = undefined;

        try {
          for (var _iterator4 = infoDict.getKeys()[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var key = _step4.value;
            var value = infoDict.get(key);

            if (DocumentInfoValidators[key]) {
              if (DocumentInfoValidators[key](value)) {
                docInfo[key] = typeof value !== 'string' ? value : (0, _util.stringToPDFString)(value);
              } else {
                (0, _util.info)("Bad value in document info for \"".concat(key, "\"."));
              }
            } else if (typeof key === 'string') {
              var customValue = void 0;

              if ((0, _util.isString)(value)) {
                customValue = (0, _util.stringToPDFString)(value);
              } else if ((0, _primitives.isName)(value) || (0, _util.isNum)(value) || (0, _util.isBool)(value)) {
                customValue = value;
              } else {
                (0, _util.info)("Unsupported value in document info for (custom) \"".concat(key, "\"."));
                continue;
              }

              if (!docInfo['Custom']) {
                docInfo['Custom'] = Object.create(null);
              }

              docInfo['Custom'][key] = customValue;
            }
          }
        } catch (err) {
          _didIteratorError4 = true;
          _iteratorError4 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
              _iterator4.return();
            }
          } finally {
            if (_didIteratorError4) {
              throw _iteratorError4;
            }
          }
        }
      }

      return (0, _util.shadow)(this, 'documentInfo', docInfo);
    }
  }, {
    key: "fingerprint",
    get: function get() {
      var hash;
      var idArray = this.xref.trailer.get('ID');

      if (Array.isArray(idArray) && idArray[0] && (0, _util.isString)(idArray[0]) && idArray[0] !== EMPTY_FINGERPRINT) {
        hash = (0, _util.stringToBytes)(idArray[0]);
      } else {
        if (this.stream.ensureRange) {
          this.stream.ensureRange(0, Math.min(FINGERPRINT_FIRST_BYTES, this.stream.end));
        }

        hash = (0, _crypto.calculateMD5)(this.stream.bytes.subarray(0, FINGERPRINT_FIRST_BYTES), 0, FINGERPRINT_FIRST_BYTES);
      }

      var fingerprint = '';

      for (var i = 0, ii = hash.length; i < ii; i++) {
        var hex = hash[i].toString(16);
        fingerprint += hex.length === 1 ? '0' + hex : hex;
      }

      return (0, _util.shadow)(this, 'fingerprint', fingerprint);
    }
  }]);

  return PDFDocument;
}();

exports.PDFDocument = PDFDocument;

/***/ }),
/* 154 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FileSpec = exports.XRef = exports.ObjectLoader = exports.Catalog = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(2));

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

var _parser = __w_pdfjs_require__(156);

var _chunked_stream = __w_pdfjs_require__(152);

var _crypto = __w_pdfjs_require__(167);

var _colorspace = __w_pdfjs_require__(168);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function fetchDestination(dest) {
  return (0, _primitives.isDict)(dest) ? dest.get('D') : dest;
}

var Catalog =
/*#__PURE__*/
function () {
  function Catalog(pdfManager, xref) {
    _classCallCheck(this, Catalog);

    this.pdfManager = pdfManager;
    this.xref = xref;
    this.catDict = xref.getCatalogObj();

    if (!(0, _primitives.isDict)(this.catDict)) {
      throw new _util.FormatError('Catalog object is not a dictionary.');
    }

    this.fontCache = new _primitives.RefSetCache();
    this.builtInCMapCache = new Map();
    this.pageKidsCountCache = new _primitives.RefSetCache();
  }

  _createClass(Catalog, [{
    key: "_readDocumentOutline",
    value: function _readDocumentOutline() {
      var obj = this.catDict.get('Outlines');

      if (!(0, _primitives.isDict)(obj)) {
        return null;
      }

      obj = obj.getRaw('First');

      if (!(0, _primitives.isRef)(obj)) {
        return null;
      }

      var root = {
        items: []
      };
      var queue = [{
        obj: obj,
        parent: root
      }];
      var processed = new _primitives.RefSet();
      processed.put(obj);
      var xref = this.xref,
          blackColor = new Uint8ClampedArray(3);

      while (queue.length > 0) {
        var i = queue.shift();
        var outlineDict = xref.fetchIfRef(i.obj);

        if (outlineDict === null) {
          continue;
        }

        if (!outlineDict.has('Title')) {
          throw new _util.FormatError('Invalid outline item encountered.');
        }

        var data = {
          url: null,
          dest: null
        };
        Catalog.parseDestDictionary({
          destDict: outlineDict,
          resultObj: data,
          docBaseUrl: this.pdfManager.docBaseUrl
        });
        var title = outlineDict.get('Title');
        var flags = outlineDict.get('F') || 0;
        var color = outlineDict.getArray('C');
        var rgbColor = blackColor;

        if (Array.isArray(color) && color.length === 3 && (color[0] !== 0 || color[1] !== 0 || color[2] !== 0)) {
          rgbColor = _colorspace.ColorSpace.singletons.rgb.getRgb(color, 0);
        }

        var outlineItem = {
          dest: data.dest,
          url: data.url,
          unsafeUrl: data.unsafeUrl,
          newWindow: data.newWindow,
          title: (0, _util.stringToPDFString)(title),
          color: rgbColor,
          count: outlineDict.get('Count'),
          bold: !!(flags & 2),
          italic: !!(flags & 1),
          items: []
        };
        i.parent.items.push(outlineItem);
        obj = outlineDict.getRaw('First');

        if ((0, _primitives.isRef)(obj) && !processed.has(obj)) {
          queue.push({
            obj: obj,
            parent: outlineItem
          });
          processed.put(obj);
        }

        obj = outlineDict.getRaw('Next');

        if ((0, _primitives.isRef)(obj) && !processed.has(obj)) {
          queue.push({
            obj: obj,
            parent: i.parent
          });
          processed.put(obj);
        }
      }

      return root.items.length > 0 ? root.items : null;
    }
  }, {
    key: "_readPermissions",
    value: function _readPermissions() {
      var encrypt = this.xref.trailer.get('Encrypt');

      if (!(0, _primitives.isDict)(encrypt)) {
        return null;
      }

      var flags = encrypt.get('P');

      if (!(0, _util.isNum)(flags)) {
        return null;
      }

      flags += Math.pow(2, 32);
      var permissions = [];

      for (var key in _util.PermissionFlag) {
        var value = _util.PermissionFlag[key];

        if (flags & value) {
          permissions.push(value);
        }
      }

      return permissions;
    }
  }, {
    key: "getDestination",
    value: function getDestination(destinationId) {
      var obj = this._readDests();

      if (obj instanceof NameTree || obj instanceof _primitives.Dict) {
        return fetchDestination(obj.get(destinationId) || null);
      }

      return null;
    }
  }, {
    key: "_readDests",
    value: function _readDests() {
      var obj = this.catDict.get('Names');

      if (obj && obj.has('Dests')) {
        return new NameTree(obj.getRaw('Dests'), this.xref);
      } else if (this.catDict.has('Dests')) {
        return this.catDict.get('Dests');
      }
    }
  }, {
    key: "_readPageLabels",
    value: function _readPageLabels() {
      var obj = this.catDict.getRaw('PageLabels');

      if (!obj) {
        return null;
      }

      var pageLabels = new Array(this.numPages);
      var style = null,
          prefix = '';
      var numberTree = new NumberTree(obj, this.xref);
      var nums = numberTree.getAll();
      var currentLabel = '',
          currentIndex = 1;

      for (var i = 0, ii = this.numPages; i < ii; i++) {
        if (i in nums) {
          var labelDict = nums[i];

          if (!(0, _primitives.isDict)(labelDict)) {
            throw new _util.FormatError('PageLabel is not a dictionary.');
          }

          if (labelDict.has('Type') && !(0, _primitives.isName)(labelDict.get('Type'), 'PageLabel')) {
            throw new _util.FormatError('Invalid type in PageLabel dictionary.');
          }

          if (labelDict.has('S')) {
            var s = labelDict.get('S');

            if (!(0, _primitives.isName)(s)) {
              throw new _util.FormatError('Invalid style in PageLabel dictionary.');
            }

            style = s.name;
          } else {
            style = null;
          }

          if (labelDict.has('P')) {
            var p = labelDict.get('P');

            if (!(0, _util.isString)(p)) {
              throw new _util.FormatError('Invalid prefix in PageLabel dictionary.');
            }

            prefix = (0, _util.stringToPDFString)(p);
          } else {
            prefix = '';
          }

          if (labelDict.has('St')) {
            var st = labelDict.get('St');

            if (!(Number.isInteger(st) && st >= 1)) {
              throw new _util.FormatError('Invalid start in PageLabel dictionary.');
            }

            currentIndex = st;
          } else {
            currentIndex = 1;
          }
        }

        switch (style) {
          case 'D':
            currentLabel = currentIndex;
            break;

          case 'R':
          case 'r':
            currentLabel = (0, _util.toRomanNumerals)(currentIndex, style === 'r');
            break;

          case 'A':
          case 'a':
            var LIMIT = 26;
            var A_UPPER_CASE = 0x41,
                A_LOWER_CASE = 0x61;
            var baseCharCode = style === 'a' ? A_LOWER_CASE : A_UPPER_CASE;
            var letterIndex = currentIndex - 1;
            var character = String.fromCharCode(baseCharCode + letterIndex % LIMIT);
            var charBuf = [];

            for (var j = 0, jj = letterIndex / LIMIT | 0; j <= jj; j++) {
              charBuf.push(character);
            }

            currentLabel = charBuf.join('');
            break;

          default:
            if (style) {
              throw new _util.FormatError("Invalid style \"".concat(style, "\" in PageLabel dictionary."));
            }

            currentLabel = '';
        }

        pageLabels[i] = prefix + currentLabel;
        currentIndex++;
      }

      return pageLabels;
    }
  }, {
    key: "fontFallback",
    value: function fontFallback(id, handler) {
      var promises = [];
      this.fontCache.forEach(function (promise) {
        promises.push(promise);
      });
      return Promise.all(promises).then(function (translatedFonts) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = translatedFonts[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var translatedFont = _step.value;

            if (translatedFont.loadedName === id) {
              translatedFont.fallback(handler);
              return;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      });
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      var _this = this;

      this.pageKidsCountCache.clear();
      var promises = [];
      this.fontCache.forEach(function (promise) {
        promises.push(promise);
      });
      return Promise.all(promises).then(function (translatedFonts) {
        for (var i = 0, ii = translatedFonts.length; i < ii; i++) {
          var font = translatedFonts[i].dict;
          delete font.translated;
        }

        _this.fontCache.clear();

        _this.builtInCMapCache.clear();
      });
    }
  }, {
    key: "getPageDict",
    value: function getPageDict(pageIndex) {
      var capability = (0, _util.createPromiseCapability)();
      var nodesToVisit = [this.catDict.getRaw('Pages')];
      var xref = this.xref,
          pageKidsCountCache = this.pageKidsCountCache;
      var count,
          currentPageIndex = 0;

      function next() {
        var _loop = function _loop() {
          var currentNode = nodesToVisit.pop();

          if ((0, _primitives.isRef)(currentNode)) {
            count = pageKidsCountCache.get(currentNode);

            if (count > 0 && currentPageIndex + count < pageIndex) {
              currentPageIndex += count;
              return "continue";
            }

            xref.fetchAsync(currentNode).then(function (obj) {
              if ((0, _primitives.isDict)(obj, 'Page') || (0, _primitives.isDict)(obj) && !obj.has('Kids')) {
                if (pageIndex === currentPageIndex) {
                  if (currentNode && !pageKidsCountCache.has(currentNode)) {
                    pageKidsCountCache.put(currentNode, 1);
                  }

                  capability.resolve([obj, currentNode]);
                } else {
                  currentPageIndex++;
                  next();
                }

                return;
              }

              nodesToVisit.push(obj);
              next();
            }, capability.reject);
            return {
              v: void 0
            };
          }

          if (!(0, _primitives.isDict)(currentNode)) {
            capability.reject(new _util.FormatError('Page dictionary kid reference points to wrong type of object.'));
            return {
              v: void 0
            };
          }

          count = currentNode.get('Count');

          if (Number.isInteger(count) && count >= 0) {
            var objId = currentNode.objId;

            if (objId && !pageKidsCountCache.has(objId)) {
              pageKidsCountCache.put(objId, count);
            }

            if (currentPageIndex + count <= pageIndex) {
              currentPageIndex += count;
              return "continue";
            }
          }

          var kids = currentNode.get('Kids');

          if (!Array.isArray(kids)) {
            if ((0, _primitives.isName)(currentNode.get('Type'), 'Page') || !currentNode.has('Type') && currentNode.has('Contents')) {
              if (currentPageIndex === pageIndex) {
                capability.resolve([currentNode, null]);
                return {
                  v: void 0
                };
              }

              currentPageIndex++;
              return "continue";
            }

            capability.reject(new _util.FormatError('Page dictionary kids object is not an array.'));
            return {
              v: void 0
            };
          }

          for (var last = kids.length - 1; last >= 0; last--) {
            nodesToVisit.push(kids[last]);
          }
        };

        while (nodesToVisit.length) {
          var _ret = _loop();

          switch (_ret) {
            case "continue":
              continue;

            default:
              if (_typeof(_ret) === "object") return _ret.v;
          }
        }

        capability.reject(new Error("Page index ".concat(pageIndex, " not found.")));
      }

      next();
      return capability.promise;
    }
  }, {
    key: "getPageIndex",
    value: function getPageIndex(pageRef) {
      var xref = this.xref;

      function pagesBeforeRef(kidRef) {
        var total = 0,
            parentRef;
        return xref.fetchAsync(kidRef).then(function (node) {
          if ((0, _primitives.isRefsEqual)(kidRef, pageRef) && !(0, _primitives.isDict)(node, 'Page') && !((0, _primitives.isDict)(node) && !node.has('Type') && node.has('Contents'))) {
            throw new _util.FormatError('The reference does not point to a /Page dictionary.');
          }

          if (!node) {
            return null;
          }

          if (!(0, _primitives.isDict)(node)) {
            throw new _util.FormatError('Node must be a dictionary.');
          }

          parentRef = node.getRaw('Parent');
          return node.getAsync('Parent');
        }).then(function (parent) {
          if (!parent) {
            return null;
          }

          if (!(0, _primitives.isDict)(parent)) {
            throw new _util.FormatError('Parent must be a dictionary.');
          }

          return parent.getAsync('Kids');
        }).then(function (kids) {
          if (!kids) {
            return null;
          }

          var kidPromises = [];
          var found = false;

          for (var i = 0, ii = kids.length; i < ii; i++) {
            var kid = kids[i];

            if (!(0, _primitives.isRef)(kid)) {
              throw new _util.FormatError('Kid must be a reference.');
            }

            if ((0, _primitives.isRefsEqual)(kid, kidRef)) {
              found = true;
              break;
            }

            kidPromises.push(xref.fetchAsync(kid).then(function (kid) {
              if (!(0, _primitives.isDict)(kid)) {
                throw new _util.FormatError('Kid node must be a dictionary.');
              }

              if (kid.has('Count')) {
                total += kid.get('Count');
              } else {
                total++;
              }
            }));
          }

          if (!found) {
            throw new _util.FormatError('Kid reference not found in parent\'s kids.');
          }

          return Promise.all(kidPromises).then(function () {
            return [total, parentRef];
          });
        });
      }

      var total = 0;

      function next(ref) {
        return pagesBeforeRef(ref).then(function (args) {
          if (!args) {
            return total;
          }

          var _args = _slicedToArray(args, 2),
              count = _args[0],
              parentRef = _args[1];

          total += count;
          return next(parentRef);
        });
      }

      return next(pageRef);
    }
  }, {
    key: "metadata",
    get: function get() {
      var streamRef = this.catDict.getRaw('Metadata');

      if (!(0, _primitives.isRef)(streamRef)) {
        return (0, _util.shadow)(this, 'metadata', null);
      }

      var suppressEncryption = !(this.xref.encrypt && this.xref.encrypt.encryptMetadata);
      var stream = this.xref.fetch(streamRef, suppressEncryption);
      var metadata;

      if (stream && (0, _primitives.isDict)(stream.dict)) {
        var type = stream.dict.get('Type');
        var subtype = stream.dict.get('Subtype');

        if ((0, _primitives.isName)(type, 'Metadata') && (0, _primitives.isName)(subtype, 'XML')) {
          try {
            metadata = (0, _util.stringToUTF8String)((0, _util.bytesToString)(stream.getBytes()));
          } catch (e) {
            if (e instanceof _util.MissingDataException) {
              throw e;
            }

            (0, _util.info)('Skipping invalid metadata.');
          }
        }
      }

      return (0, _util.shadow)(this, 'metadata', metadata);
    }
  }, {
    key: "toplevelPagesDict",
    get: function get() {
      var pagesObj = this.catDict.get('Pages');

      if (!(0, _primitives.isDict)(pagesObj)) {
        throw new _util.FormatError('Invalid top-level pages dictionary.');
      }

      return (0, _util.shadow)(this, 'toplevelPagesDict', pagesObj);
    }
  }, {
    key: "documentOutline",
    get: function get() {
      var obj = null;

      try {
        obj = this._readDocumentOutline();
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.warn)('Unable to read document outline.');
      }

      return (0, _util.shadow)(this, 'documentOutline', obj);
    }
  }, {
    key: "permissions",
    get: function get() {
      var permissions = null;

      try {
        permissions = this._readPermissions();
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.warn)('Unable to read permissions.');
      }

      return (0, _util.shadow)(this, 'permissions', permissions);
    }
  }, {
    key: "numPages",
    get: function get() {
      var obj = this.toplevelPagesDict.get('Count');

      if (!Number.isInteger(obj)) {
        throw new _util.FormatError('Page count in top-level pages dictionary is not an integer.');
      }

      return (0, _util.shadow)(this, 'numPages', obj);
    }
  }, {
    key: "destinations",
    get: function get() {
      var obj = this._readDests(),
          dests = Object.create(null);

      if (obj instanceof NameTree) {
        var names = obj.getAll();

        for (var name in names) {
          dests[name] = fetchDestination(names[name]);
        }
      } else if (obj instanceof _primitives.Dict) {
        obj.forEach(function (key, value) {
          if (value) {
            dests[key] = fetchDestination(value);
          }
        });
      }

      return (0, _util.shadow)(this, 'destinations', dests);
    }
  }, {
    key: "pageLabels",
    get: function get() {
      var obj = null;

      try {
        obj = this._readPageLabels();
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.warn)('Unable to read page labels.');
      }

      return (0, _util.shadow)(this, 'pageLabels', obj);
    }
  }, {
    key: "pageMode",
    get: function get() {
      var obj = this.catDict.get('PageMode');
      var pageMode = 'UseNone';

      if ((0, _primitives.isName)(obj)) {
        switch (obj.name) {
          case 'UseNone':
          case 'UseOutlines':
          case 'UseThumbs':
          case 'FullScreen':
          case 'UseOC':
          case 'UseAttachments':
            pageMode = obj.name;
        }
      }

      return (0, _util.shadow)(this, 'pageMode', pageMode);
    }
  }, {
    key: "openActionDestination",
    get: function get() {
      var obj = this.catDict.get('OpenAction');
      var openActionDest = null;

      if ((0, _primitives.isDict)(obj)) {
        var destDict = new _primitives.Dict(this.xref);
        destDict.set('A', obj);
        var resultObj = {
          url: null,
          dest: null
        };
        Catalog.parseDestDictionary({
          destDict: destDict,
          resultObj: resultObj
        });

        if (Array.isArray(resultObj.dest)) {
          openActionDest = resultObj.dest;
        }
      } else if (Array.isArray(obj)) {
        openActionDest = obj;
      }

      return (0, _util.shadow)(this, 'openActionDestination', openActionDest);
    }
  }, {
    key: "attachments",
    get: function get() {
      var obj = this.catDict.get('Names');
      var attachments = null;

      if (obj && obj.has('EmbeddedFiles')) {
        var nameTree = new NameTree(obj.getRaw('EmbeddedFiles'), this.xref);
        var names = nameTree.getAll();

        for (var name in names) {
          var fs = new FileSpec(names[name], this.xref);

          if (!attachments) {
            attachments = Object.create(null);
          }

          attachments[(0, _util.stringToPDFString)(name)] = fs.serializable;
        }
      }

      return (0, _util.shadow)(this, 'attachments', attachments);
    }
  }, {
    key: "javaScript",
    get: function get() {
      var obj = this.catDict.get('Names');
      var javaScript = null;

      function appendIfJavaScriptDict(jsDict) {
        var type = jsDict.get('S');

        if (!(0, _primitives.isName)(type, 'JavaScript')) {
          return;
        }

        var js = jsDict.get('JS');

        if ((0, _primitives.isStream)(js)) {
          js = (0, _util.bytesToString)(js.getBytes());
        } else if (!(0, _util.isString)(js)) {
          return;
        }

        if (!javaScript) {
          javaScript = [];
        }

        javaScript.push((0, _util.stringToPDFString)(js));
      }

      if (obj && obj.has('JavaScript')) {
        var nameTree = new NameTree(obj.getRaw('JavaScript'), this.xref);
        var names = nameTree.getAll();

        for (var name in names) {
          var jsDict = names[name];

          if ((0, _primitives.isDict)(jsDict)) {
            appendIfJavaScriptDict(jsDict);
          }
        }
      }

      var openActionDict = this.catDict.get('OpenAction');

      if ((0, _primitives.isDict)(openActionDict, 'Action')) {
        var actionType = openActionDict.get('S');

        if ((0, _primitives.isName)(actionType, 'Named')) {
          var action = openActionDict.get('N');

          if ((0, _primitives.isName)(action, 'Print')) {
            if (!javaScript) {
              javaScript = [];
            }

            javaScript.push('print({});');
          }
        } else {
          appendIfJavaScriptDict(openActionDict);
        }
      }

      return (0, _util.shadow)(this, 'javaScript', javaScript);
    }
  }], [{
    key: "parseDestDictionary",
    value: function parseDestDictionary(params) {
      function addDefaultProtocolToUrl(url) {
        return url.startsWith('www.') ? "http://".concat(url) : url;
      }

      function tryConvertUrlEncoding(url) {
        try {
          return (0, _util.stringToUTF8String)(url);
        } catch (e) {
          return url;
        }
      }

      var destDict = params.destDict;

      if (!(0, _primitives.isDict)(destDict)) {
        (0, _util.warn)('parseDestDictionary: `destDict` must be a dictionary.');
        return;
      }

      var resultObj = params.resultObj;

      if (_typeof(resultObj) !== 'object') {
        (0, _util.warn)('parseDestDictionary: `resultObj` must be an object.');
        return;
      }

      var docBaseUrl = params.docBaseUrl || null;
      var action = destDict.get('A'),
          url,
          dest;

      if (!(0, _primitives.isDict)(action) && destDict.has('Dest')) {
        action = destDict.get('Dest');
      }

      if ((0, _primitives.isDict)(action)) {
        var actionType = action.get('S');

        if (!(0, _primitives.isName)(actionType)) {
          (0, _util.warn)('parseDestDictionary: Invalid type in Action dictionary.');
          return;
        }

        var actionName = actionType.name;

        switch (actionName) {
          case 'URI':
            url = action.get('URI');

            if ((0, _primitives.isName)(url)) {
              url = '/' + url.name;
            } else if ((0, _util.isString)(url)) {
              url = addDefaultProtocolToUrl(url);
            }

            break;

          case 'GoTo':
            dest = action.get('D');
            break;

          case 'Launch':
          case 'GoToR':
            var urlDict = action.get('F');

            if ((0, _primitives.isDict)(urlDict)) {
              url = urlDict.get('F') || null;
            } else if ((0, _util.isString)(urlDict)) {
              url = urlDict;
            }

            var remoteDest = action.get('D');

            if (remoteDest) {
              if ((0, _primitives.isName)(remoteDest)) {
                remoteDest = remoteDest.name;
              }

              if ((0, _util.isString)(url)) {
                var baseUrl = url.split('#')[0];

                if ((0, _util.isString)(remoteDest)) {
                  url = baseUrl + '#' + remoteDest;
                } else if (Array.isArray(remoteDest)) {
                  url = baseUrl + '#' + JSON.stringify(remoteDest);
                }
              }
            }

            var newWindow = action.get('NewWindow');

            if ((0, _util.isBool)(newWindow)) {
              resultObj.newWindow = newWindow;
            }

            break;

          case 'Named':
            var namedAction = action.get('N');

            if ((0, _primitives.isName)(namedAction)) {
              resultObj.action = namedAction.name;
            }

            break;

          case 'JavaScript':
            var jsAction = action.get('JS');
            var js;

            if ((0, _primitives.isStream)(jsAction)) {
              js = (0, _util.bytesToString)(jsAction.getBytes());
            } else if ((0, _util.isString)(jsAction)) {
              js = jsAction;
            }

            if (js) {
              var URL_OPEN_METHODS = ['app.launchURL', 'window.open'];
              var regex = new RegExp('^\\s*(' + URL_OPEN_METHODS.join('|').split('.').join('\\.') + ')\\((?:\'|\")([^\'\"]*)(?:\'|\")(?:,\\s*(\\w+)\\)|\\))', 'i');
              var jsUrl = regex.exec((0, _util.stringToPDFString)(js));

              if (jsUrl && jsUrl[2]) {
                url = jsUrl[2];

                if (jsUrl[3] === 'true' && jsUrl[1] === 'app.launchURL') {
                  resultObj.newWindow = true;
                }

                break;
              }
            }

          default:
            (0, _util.warn)("parseDestDictionary: unsupported action type \"".concat(actionName, "\"."));
            break;
        }
      } else if (destDict.has('Dest')) {
        dest = destDict.get('Dest');
      }

      if ((0, _util.isString)(url)) {
        url = tryConvertUrlEncoding(url);
        var absoluteUrl = (0, _util.createValidAbsoluteUrl)(url, docBaseUrl);

        if (absoluteUrl) {
          resultObj.url = absoluteUrl.href;
        }

        resultObj.unsafeUrl = url;
      }

      if (dest) {
        if ((0, _primitives.isName)(dest)) {
          dest = dest.name;
        }

        if ((0, _util.isString)(dest) || Array.isArray(dest)) {
          resultObj.dest = dest;
        }
      }
    }
  }]);

  return Catalog;
}();

exports.Catalog = Catalog;

var XRef = function XRefClosure() {
  function XRef(stream, pdfManager) {
    this.stream = stream;
    this.pdfManager = pdfManager;
    this.entries = [];
    this.xrefstms = Object.create(null);
    this.cache = [];
    this.stats = {
      streamTypes: [],
      fontTypes: []
    };
  }

  XRef.prototype = {
    setStartXRef: function XRef_setStartXRef(startXRef) {
      this.startXRefQueue = [startXRef];
    },
    parse: function XRef_parse(recoveryMode) {
      var trailerDict;

      if (!recoveryMode) {
        trailerDict = this.readXRef();
      } else {
        (0, _util.warn)('Indexing all PDF objects');
        trailerDict = this.indexObjects();
      }

      trailerDict.assignXref(this);
      this.trailer = trailerDict;
      var encrypt;

      try {
        encrypt = trailerDict.get('Encrypt');
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.warn)("XRef.parse - Invalid \"Encrypt\" reference: \"".concat(ex, "\"."));
      }

      if ((0, _primitives.isDict)(encrypt)) {
        var ids = trailerDict.get('ID');
        var fileId = ids && ids.length ? ids[0] : '';
        encrypt.suppressEncryption = true;
        this.encrypt = new _crypto.CipherTransformFactory(encrypt, fileId, this.pdfManager.password);
      }

      var root;

      try {
        root = trailerDict.get('Root');
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.warn)("XRef.parse - Invalid \"Root\" reference: \"".concat(ex, "\"."));
      }

      if ((0, _primitives.isDict)(root) && root.has('Pages')) {
        this.root = root;
      } else {
        if (!recoveryMode) {
          throw new _util.XRefParseException();
        }

        throw new _util.FormatError('Invalid root reference');
      }
    },
    processXRefTable: function XRef_processXRefTable(parser) {
      if (!('tableState' in this)) {
        this.tableState = {
          entryNum: 0,
          streamPos: parser.lexer.stream.pos,
          parserBuf1: parser.buf1,
          parserBuf2: parser.buf2
        };
      }

      var obj = this.readXRefTable(parser);

      if (!(0, _primitives.isCmd)(obj, 'trailer')) {
        throw new _util.FormatError('Invalid XRef table: could not find trailer dictionary');
      }

      var dict = parser.getObj();

      if (!(0, _primitives.isDict)(dict) && dict.dict) {
        dict = dict.dict;
      }

      if (!(0, _primitives.isDict)(dict)) {
        throw new _util.FormatError('Invalid XRef table: could not parse trailer dictionary');
      }

      delete this.tableState;
      return dict;
    },
    readXRefTable: function XRef_readXRefTable(parser) {
      var stream = parser.lexer.stream;
      var tableState = this.tableState;
      stream.pos = tableState.streamPos;
      parser.buf1 = tableState.parserBuf1;
      parser.buf2 = tableState.parserBuf2;
      var obj;

      while (true) {
        if (!('firstEntryNum' in tableState) || !('entryCount' in tableState)) {
          if ((0, _primitives.isCmd)(obj = parser.getObj(), 'trailer')) {
            break;
          }

          tableState.firstEntryNum = obj;
          tableState.entryCount = parser.getObj();
        }

        var first = tableState.firstEntryNum;
        var count = tableState.entryCount;

        if (!Number.isInteger(first) || !Number.isInteger(count)) {
          throw new _util.FormatError('Invalid XRef table: wrong types in subsection header');
        }

        for (var i = tableState.entryNum; i < count; i++) {
          tableState.streamPos = stream.pos;
          tableState.entryNum = i;
          tableState.parserBuf1 = parser.buf1;
          tableState.parserBuf2 = parser.buf2;
          var entry = {};
          entry.offset = parser.getObj();
          entry.gen = parser.getObj();
          var type = parser.getObj();

          if ((0, _primitives.isCmd)(type, 'f')) {
            entry.free = true;
          } else if ((0, _primitives.isCmd)(type, 'n')) {
            entry.uncompressed = true;
          }

          if (!Number.isInteger(entry.offset) || !Number.isInteger(entry.gen) || !(entry.free || entry.uncompressed)) {
            throw new _util.FormatError("Invalid entry in XRef subsection: ".concat(first, ", ").concat(count));
          }

          if (i === 0 && entry.free && first === 1) {
            first = 0;
          }

          if (!this.entries[i + first]) {
            this.entries[i + first] = entry;
          }
        }

        tableState.entryNum = 0;
        tableState.streamPos = stream.pos;
        tableState.parserBuf1 = parser.buf1;
        tableState.parserBuf2 = parser.buf2;
        delete tableState.firstEntryNum;
        delete tableState.entryCount;
      }

      if (this.entries[0] && !this.entries[0].free) {
        throw new _util.FormatError('Invalid XRef table: unexpected first object');
      }

      return obj;
    },
    processXRefStream: function XRef_processXRefStream(stream) {
      if (!('streamState' in this)) {
        var streamParameters = stream.dict;
        var byteWidths = streamParameters.get('W');
        var range = streamParameters.get('Index');

        if (!range) {
          range = [0, streamParameters.get('Size')];
        }

        this.streamState = {
          entryRanges: range,
          byteWidths: byteWidths,
          entryNum: 0,
          streamPos: stream.pos
        };
      }

      this.readXRefStream(stream);
      delete this.streamState;
      return stream.dict;
    },
    readXRefStream: function XRef_readXRefStream(stream) {
      var i, j;
      var streamState = this.streamState;
      stream.pos = streamState.streamPos;
      var byteWidths = streamState.byteWidths;
      var typeFieldWidth = byteWidths[0];
      var offsetFieldWidth = byteWidths[1];
      var generationFieldWidth = byteWidths[2];
      var entryRanges = streamState.entryRanges;

      while (entryRanges.length > 0) {
        var first = entryRanges[0];
        var n = entryRanges[1];

        if (!Number.isInteger(first) || !Number.isInteger(n)) {
          throw new _util.FormatError("Invalid XRef range fields: ".concat(first, ", ").concat(n));
        }

        if (!Number.isInteger(typeFieldWidth) || !Number.isInteger(offsetFieldWidth) || !Number.isInteger(generationFieldWidth)) {
          throw new _util.FormatError("Invalid XRef entry fields length: ".concat(first, ", ").concat(n));
        }

        for (i = streamState.entryNum; i < n; ++i) {
          streamState.entryNum = i;
          streamState.streamPos = stream.pos;
          var type = 0,
              offset = 0,
              generation = 0;

          for (j = 0; j < typeFieldWidth; ++j) {
            type = type << 8 | stream.getByte();
          }

          if (typeFieldWidth === 0) {
            type = 1;
          }

          for (j = 0; j < offsetFieldWidth; ++j) {
            offset = offset << 8 | stream.getByte();
          }

          for (j = 0; j < generationFieldWidth; ++j) {
            generation = generation << 8 | stream.getByte();
          }

          var entry = {};
          entry.offset = offset;
          entry.gen = generation;

          switch (type) {
            case 0:
              entry.free = true;
              break;

            case 1:
              entry.uncompressed = true;
              break;

            case 2:
              break;

            default:
              throw new _util.FormatError("Invalid XRef entry type: ".concat(type));
          }

          if (!this.entries[first + i]) {
            this.entries[first + i] = entry;
          }
        }

        streamState.entryNum = 0;
        streamState.streamPos = stream.pos;
        entryRanges.splice(0, 2);
      }
    },
    indexObjects: function XRef_indexObjects() {
      var TAB = 0x9,
          LF = 0xA,
          CR = 0xD,
          SPACE = 0x20;
      var PERCENT = 0x25,
          LT = 0x3C;

      function readToken(data, offset) {
        var token = '',
            ch = data[offset];

        while (ch !== LF && ch !== CR && ch !== LT) {
          if (++offset >= data.length) {
            break;
          }

          token += String.fromCharCode(ch);
          ch = data[offset];
        }

        return token;
      }

      function skipUntil(data, offset, what) {
        var length = what.length,
            dataLength = data.length;
        var skipped = 0;

        while (offset < dataLength) {
          var i = 0;

          while (i < length && data[offset + i] === what[i]) {
            ++i;
          }

          if (i >= length) {
            break;
          }

          offset++;
          skipped++;
        }

        return skipped;
      }

      var objRegExp = /^(\d+)\s+(\d+)\s+obj\b/;
      var endobjRegExp = /\bendobj[\b\s]$/;
      var nestedObjRegExp = /\s+(\d+\s+\d+\s+obj[\b\s<])$/;
      var CHECK_CONTENT_LENGTH = 25;
      var trailerBytes = new Uint8Array([116, 114, 97, 105, 108, 101, 114]);
      var startxrefBytes = new Uint8Array([115, 116, 97, 114, 116, 120, 114, 101, 102]);
      var objBytes = new Uint8Array([111, 98, 106]);
      var xrefBytes = new Uint8Array([47, 88, 82, 101, 102]);
      this.entries.length = 0;
      var stream = this.stream;
      stream.pos = 0;
      var buffer = stream.getBytes();
      var position = stream.start,
          length = buffer.length;
      var trailers = [],
          xrefStms = [];

      while (position < length) {
        var ch = buffer[position];

        if (ch === TAB || ch === LF || ch === CR || ch === SPACE) {
          ++position;
          continue;
        }

        if (ch === PERCENT) {
          do {
            ++position;

            if (position >= length) {
              break;
            }

            ch = buffer[position];
          } while (ch !== LF && ch !== CR);

          continue;
        }

        var token = readToken(buffer, position);
        var m;

        if (token.startsWith('xref') && (token.length === 4 || /\s/.test(token[4]))) {
          position += skipUntil(buffer, position, trailerBytes);
          trailers.push(position);
          position += skipUntil(buffer, position, startxrefBytes);
        } else if (m = objRegExp.exec(token)) {
          var num = m[1] | 0,
              gen = m[2] | 0;

          if (typeof this.entries[num] === 'undefined') {
            this.entries[num] = {
              offset: position - stream.start,
              gen: gen,
              uncompressed: true
            };
          }

          var contentLength = void 0,
              startPos = position + token.length;

          while (startPos < buffer.length) {
            var endPos = startPos + skipUntil(buffer, startPos, objBytes) + 4;
            contentLength = endPos - position;
            var checkPos = Math.max(endPos - CHECK_CONTENT_LENGTH, startPos);
            var tokenStr = (0, _util.bytesToString)(buffer.subarray(checkPos, endPos));

            if (endobjRegExp.test(tokenStr)) {
              break;
            } else {
              var objToken = nestedObjRegExp.exec(tokenStr);

              if (objToken && objToken[1]) {
                (0, _util.warn)('indexObjects: Found new "obj" inside of another "obj", ' + 'caused by missing "endobj" -- trying to recover.');
                contentLength -= objToken[1].length;
                break;
              }
            }

            startPos = endPos;
          }

          var content = buffer.subarray(position, position + contentLength);
          var xrefTagOffset = skipUntil(content, 0, xrefBytes);

          if (xrefTagOffset < contentLength && content[xrefTagOffset + 5] < 64) {
            xrefStms.push(position - stream.start);
            this.xrefstms[position - stream.start] = 1;
          }

          position += contentLength;
        } else if (token.startsWith('trailer') && (token.length === 7 || /\s/.test(token[7]))) {
          trailers.push(position);
          position += skipUntil(buffer, position, startxrefBytes);
        } else {
          position += token.length + 1;
        }
      }

      var i, ii;

      for (i = 0, ii = xrefStms.length; i < ii; ++i) {
        this.startXRefQueue.push(xrefStms[i]);
        this.readXRef(true);
      }

      var trailerDict;

      for (i = 0, ii = trailers.length; i < ii; ++i) {
        stream.pos = trailers[i];
        var parser = new _parser.Parser(new _parser.Lexer(stream), true, this, true);
        var obj = parser.getObj();

        if (!(0, _primitives.isCmd)(obj, 'trailer')) {
          continue;
        }

        var dict = parser.getObj();

        if (!(0, _primitives.isDict)(dict)) {
          continue;
        }

        var rootDict = void 0;

        try {
          rootDict = dict.get('Root');
        } catch (ex) {
          if (ex instanceof _util.MissingDataException) {
            throw ex;
          }

          continue;
        }

        if (!(0, _primitives.isDict)(rootDict) || !rootDict.has('Pages')) {
          continue;
        }

        if (dict.has('ID')) {
          return dict;
        }

        trailerDict = dict;
      }

      if (trailerDict) {
        return trailerDict;
      }

      throw new _util.InvalidPDFException('Invalid PDF structure');
    },
    readXRef: function XRef_readXRef(recoveryMode) {
      var stream = this.stream;
      var startXRefParsedCache = Object.create(null);

      try {
        while (this.startXRefQueue.length) {
          var startXRef = this.startXRefQueue[0];

          if (startXRefParsedCache[startXRef]) {
            (0, _util.warn)('readXRef - skipping XRef table since it was already parsed.');
            this.startXRefQueue.shift();
            continue;
          }

          startXRefParsedCache[startXRef] = true;
          stream.pos = startXRef + stream.start;
          var parser = new _parser.Parser(new _parser.Lexer(stream), true, this);
          var obj = parser.getObj();
          var dict;

          if ((0, _primitives.isCmd)(obj, 'xref')) {
            dict = this.processXRefTable(parser);

            if (!this.topDict) {
              this.topDict = dict;
            }

            obj = dict.get('XRefStm');

            if (Number.isInteger(obj)) {
              var pos = obj;

              if (!(pos in this.xrefstms)) {
                this.xrefstms[pos] = 1;
                this.startXRefQueue.push(pos);
              }
            }
          } else if (Number.isInteger(obj)) {
            if (!Number.isInteger(parser.getObj()) || !(0, _primitives.isCmd)(parser.getObj(), 'obj') || !(0, _primitives.isStream)(obj = parser.getObj())) {
              throw new _util.FormatError('Invalid XRef stream');
            }

            dict = this.processXRefStream(obj);

            if (!this.topDict) {
              this.topDict = dict;
            }

            if (!dict) {
              throw new _util.FormatError('Failed to read XRef stream');
            }
          } else {
            throw new _util.FormatError('Invalid XRef stream header');
          }

          obj = dict.get('Prev');

          if (Number.isInteger(obj)) {
            this.startXRefQueue.push(obj);
          } else if ((0, _primitives.isRef)(obj)) {
            this.startXRefQueue.push(obj.num);
          }

          this.startXRefQueue.shift();
        }

        return this.topDict;
      } catch (e) {
        if (e instanceof _util.MissingDataException) {
          throw e;
        }

        (0, _util.info)('(while reading XRef): ' + e);
      }

      if (recoveryMode) {
        return;
      }

      throw new _util.XRefParseException();
    },
    getEntry: function XRef_getEntry(i) {
      var xrefEntry = this.entries[i];

      if (xrefEntry && !xrefEntry.free && xrefEntry.offset) {
        return xrefEntry;
      }

      return null;
    },
    fetchIfRef: function XRef_fetchIfRef(obj, suppressEncryption) {
      if (!(0, _primitives.isRef)(obj)) {
        return obj;
      }

      return this.fetch(obj, suppressEncryption);
    },
    fetch: function XRef_fetch(ref, suppressEncryption) {
      if (!(0, _primitives.isRef)(ref)) {
        throw new Error('ref object is not a reference');
      }

      var num = ref.num;

      if (num in this.cache) {
        var cacheEntry = this.cache[num];

        if (cacheEntry instanceof _primitives.Dict && !cacheEntry.objId) {
          cacheEntry.objId = ref.toString();
        }

        return cacheEntry;
      }

      var xrefEntry = this.getEntry(num);

      if (xrefEntry === null) {
        return this.cache[num] = null;
      }

      if (xrefEntry.uncompressed) {
        xrefEntry = this.fetchUncompressed(ref, xrefEntry, suppressEncryption);
      } else {
        xrefEntry = this.fetchCompressed(ref, xrefEntry, suppressEncryption);
      }

      if ((0, _primitives.isDict)(xrefEntry)) {
        xrefEntry.objId = ref.toString();
      } else if ((0, _primitives.isStream)(xrefEntry)) {
        xrefEntry.dict.objId = ref.toString();
      }

      return xrefEntry;
    },
    fetchUncompressed: function fetchUncompressed(ref, xrefEntry) {
      var suppressEncryption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var gen = ref.gen;
      var num = ref.num;

      if (xrefEntry.gen !== gen) {
        throw new _util.XRefEntryException("Inconsistent generation in XRef: ".concat(ref));
      }

      var stream = this.stream.makeSubStream(xrefEntry.offset + this.stream.start);
      var parser = new _parser.Parser(new _parser.Lexer(stream), true, this);
      var obj1 = parser.getObj();
      var obj2 = parser.getObj();
      var obj3 = parser.getObj();

      if (!Number.isInteger(obj1)) {
        obj1 = parseInt(obj1, 10);
      }

      if (!Number.isInteger(obj2)) {
        obj2 = parseInt(obj2, 10);
      }

      if (obj1 !== num || obj2 !== gen || !(0, _primitives.isCmd)(obj3)) {
        throw new _util.XRefEntryException("Bad (uncompressed) XRef entry: ".concat(ref));
      }

      if (obj3.cmd !== 'obj') {
        if (obj3.cmd.startsWith('obj')) {
          num = parseInt(obj3.cmd.substring(3), 10);

          if (!Number.isNaN(num)) {
            return num;
          }
        }

        throw new _util.XRefEntryException("Bad (uncompressed) XRef entry: ".concat(ref));
      }

      if (this.encrypt && !suppressEncryption) {
        xrefEntry = parser.getObj(this.encrypt.createCipherTransform(num, gen));
      } else {
        xrefEntry = parser.getObj();
      }

      if (!(0, _primitives.isStream)(xrefEntry)) {
        this.cache[num] = xrefEntry;
      }

      return xrefEntry;
    },
    fetchCompressed: function fetchCompressed(ref, xrefEntry) {
      var suppressEncryption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var tableOffset = xrefEntry.offset;
      var stream = this.fetch(new _primitives.Ref(tableOffset, 0));

      if (!(0, _primitives.isStream)(stream)) {
        throw new _util.FormatError('bad ObjStm stream');
      }

      var first = stream.dict.get('First');
      var n = stream.dict.get('N');

      if (!Number.isInteger(first) || !Number.isInteger(n)) {
        throw new _util.FormatError('invalid first and n parameters for ObjStm stream');
      }

      var parser = new _parser.Parser(new _parser.Lexer(stream), false, this);
      parser.allowStreams = true;
      var i,
          entries = [],
          num,
          nums = [];

      for (i = 0; i < n; ++i) {
        num = parser.getObj();

        if (!Number.isInteger(num)) {
          throw new _util.FormatError("invalid object number in the ObjStm stream: ".concat(num));
        }

        nums.push(num);
        var offset = parser.getObj();

        if (!Number.isInteger(offset)) {
          throw new _util.FormatError("invalid object offset in the ObjStm stream: ".concat(offset));
        }
      }

      for (i = 0; i < n; ++i) {
        entries.push(parser.getObj());

        if ((0, _primitives.isCmd)(parser.buf1, 'endobj')) {
          parser.shift();
        }

        num = nums[i];
        var entry = this.entries[num];

        if (entry && entry.offset === tableOffset && entry.gen === i) {
          this.cache[num] = entries[i];
        }
      }

      xrefEntry = entries[xrefEntry.gen];

      if (xrefEntry === undefined) {
        throw new _util.XRefEntryException("Bad (compressed) XRef entry: ".concat(ref));
      }

      return xrefEntry;
    },
    fetchIfRefAsync: function () {
      var _fetchIfRefAsync = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(obj, suppressEncryption) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if ((0, _primitives.isRef)(obj)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", obj);

              case 2:
                return _context.abrupt("return", this.fetchAsync(obj, suppressEncryption));

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function fetchIfRefAsync(_x, _x2) {
        return _fetchIfRefAsync.apply(this, arguments);
      }

      return fetchIfRefAsync;
    }(),
    fetchAsync: function () {
      var _fetchAsync = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(ref, suppressEncryption) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                return _context2.abrupt("return", this.fetch(ref, suppressEncryption));

              case 4:
                _context2.prev = 4;
                _context2.t0 = _context2["catch"](0);

                if (_context2.t0 instanceof _util.MissingDataException) {
                  _context2.next = 8;
                  break;
                }

                throw _context2.t0;

              case 8:
                _context2.next = 10;
                return this.pdfManager.requestRange(_context2.t0.begin, _context2.t0.end);

              case 10:
                return _context2.abrupt("return", this.fetchAsync(ref, suppressEncryption));

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[0, 4]]);
      }));

      function fetchAsync(_x3, _x4) {
        return _fetchAsync.apply(this, arguments);
      }

      return fetchAsync;
    }(),
    getCatalogObj: function XRef_getCatalogObj() {
      return this.root;
    }
  };
  return XRef;
}();

exports.XRef = XRef;

var NameOrNumberTree =
/*#__PURE__*/
function () {
  function NameOrNumberTree(root, xref, type) {
    _classCallCheck(this, NameOrNumberTree);

    if (this.constructor === NameOrNumberTree) {
      (0, _util.unreachable)('Cannot initialize NameOrNumberTree.');
    }

    this.root = root;
    this.xref = xref;
    this._type = type;
  }

  _createClass(NameOrNumberTree, [{
    key: "getAll",
    value: function getAll() {
      var dict = Object.create(null);

      if (!this.root) {
        return dict;
      }

      var xref = this.xref;
      var processed = new _primitives.RefSet();
      processed.put(this.root);
      var queue = [this.root];

      while (queue.length > 0) {
        var obj = xref.fetchIfRef(queue.shift());

        if (!(0, _primitives.isDict)(obj)) {
          continue;
        }

        if (obj.has('Kids')) {
          var kids = obj.get('Kids');

          for (var i = 0, ii = kids.length; i < ii; i++) {
            var kid = kids[i];

            if (processed.has(kid)) {
              throw new _util.FormatError("Duplicate entry in \"".concat(this._type, "\" tree."));
            }

            queue.push(kid);
            processed.put(kid);
          }

          continue;
        }

        var entries = obj.get(this._type);

        if (Array.isArray(entries)) {
          for (var _i2 = 0, _ii = entries.length; _i2 < _ii; _i2 += 2) {
            dict[xref.fetchIfRef(entries[_i2])] = xref.fetchIfRef(entries[_i2 + 1]);
          }
        }
      }

      return dict;
    }
  }, {
    key: "get",
    value: function get(key) {
      if (!this.root) {
        return null;
      }

      var xref = this.xref;
      var kidsOrEntries = xref.fetchIfRef(this.root);
      var loopCount = 0;
      var MAX_LEVELS = 10;

      while (kidsOrEntries.has('Kids')) {
        if (++loopCount > MAX_LEVELS) {
          (0, _util.warn)("Search depth limit reached for \"".concat(this._type, "\" tree."));
          return null;
        }

        var kids = kidsOrEntries.get('Kids');

        if (!Array.isArray(kids)) {
          return null;
        }

        var l = 0,
            r = kids.length - 1;

        while (l <= r) {
          var m = l + r >> 1;
          var kid = xref.fetchIfRef(kids[m]);
          var limits = kid.get('Limits');

          if (key < xref.fetchIfRef(limits[0])) {
            r = m - 1;
          } else if (key > xref.fetchIfRef(limits[1])) {
            l = m + 1;
          } else {
            kidsOrEntries = xref.fetchIfRef(kids[m]);
            break;
          }
        }

        if (l > r) {
          return null;
        }
      }

      var entries = kidsOrEntries.get(this._type);

      if (Array.isArray(entries)) {
        var _l = 0,
            _r = entries.length - 2;

        while (_l <= _r) {
          var tmp = _l + _r >> 1,
              _m = tmp + (tmp & 1);

          var currentKey = xref.fetchIfRef(entries[_m]);

          if (key < currentKey) {
            _r = _m - 2;
          } else if (key > currentKey) {
            _l = _m + 2;
          } else {
            return xref.fetchIfRef(entries[_m + 1]);
          }
        }

        (0, _util.info)("Falling back to an exhaustive search, for key \"".concat(key, "\", ") + "in \"".concat(this._type, "\" tree."));

        for (var _m2 = 0, mm = entries.length; _m2 < mm; _m2 += 2) {
          var _currentKey = xref.fetchIfRef(entries[_m2]);

          if (_currentKey === key) {
            (0, _util.warn)("The \"".concat(key, "\" key was found at an incorrect, ") + "i.e. out-of-order, position in \"".concat(this._type, "\" tree."));
            return xref.fetchIfRef(entries[_m2 + 1]);
          }
        }
      }

      return null;
    }
  }]);

  return NameOrNumberTree;
}();

var NameTree =
/*#__PURE__*/
function (_NameOrNumberTree) {
  _inherits(NameTree, _NameOrNumberTree);

  function NameTree(root, xref) {
    _classCallCheck(this, NameTree);

    return _possibleConstructorReturn(this, _getPrototypeOf(NameTree).call(this, root, xref, 'Names'));
  }

  return NameTree;
}(NameOrNumberTree);

var NumberTree =
/*#__PURE__*/
function (_NameOrNumberTree2) {
  _inherits(NumberTree, _NameOrNumberTree2);

  function NumberTree(root, xref) {
    _classCallCheck(this, NumberTree);

    return _possibleConstructorReturn(this, _getPrototypeOf(NumberTree).call(this, root, xref, 'Nums'));
  }

  return NumberTree;
}(NameOrNumberTree);

var FileSpec = function FileSpecClosure() {
  function FileSpec(root, xref) {
    if (!root || !(0, _primitives.isDict)(root)) {
      return;
    }

    this.xref = xref;
    this.root = root;

    if (root.has('FS')) {
      this.fs = root.get('FS');
    }

    this.description = root.has('Desc') ? (0, _util.stringToPDFString)(root.get('Desc')) : '';

    if (root.has('RF')) {
      (0, _util.warn)('Related file specifications are not supported');
    }

    this.contentAvailable = true;

    if (!root.has('EF')) {
      this.contentAvailable = false;
      (0, _util.warn)('Non-embedded file specifications are not supported');
    }
  }

  function pickPlatformItem(dict) {
    if (dict.has('UF')) {
      return dict.get('UF');
    } else if (dict.has('F')) {
      return dict.get('F');
    } else if (dict.has('Unix')) {
      return dict.get('Unix');
    } else if (dict.has('Mac')) {
      return dict.get('Mac');
    } else if (dict.has('DOS')) {
      return dict.get('DOS');
    }

    return null;
  }

  FileSpec.prototype = {
    get filename() {
      if (!this._filename && this.root) {
        var filename = pickPlatformItem(this.root) || 'unnamed';
        this._filename = (0, _util.stringToPDFString)(filename).replace(/\\\\/g, '\\').replace(/\\\//g, '/').replace(/\\/g, '/');
      }

      return this._filename;
    },

    get content() {
      if (!this.contentAvailable) {
        return null;
      }

      if (!this.contentRef && this.root) {
        this.contentRef = pickPlatformItem(this.root.get('EF'));
      }

      var content = null;

      if (this.contentRef) {
        var xref = this.xref;
        var fileObj = xref.fetchIfRef(this.contentRef);

        if (fileObj && (0, _primitives.isStream)(fileObj)) {
          content = fileObj.getBytes();
        } else {
          (0, _util.warn)('Embedded file specification points to non-existing/invalid ' + 'content');
        }
      } else {
        (0, _util.warn)('Embedded file specification does not have a content');
      }

      return content;
    },

    get serializable() {
      return {
        filename: this.filename,
        content: this.content
      };
    }

  };
  return FileSpec;
}();

exports.FileSpec = FileSpec;

var ObjectLoader = function () {
  function mayHaveChildren(value) {
    return (0, _primitives.isRef)(value) || (0, _primitives.isDict)(value) || Array.isArray(value) || (0, _primitives.isStream)(value);
  }

  function addChildren(node, nodesToVisit) {
    if ((0, _primitives.isDict)(node) || (0, _primitives.isStream)(node)) {
      var dict = (0, _primitives.isDict)(node) ? node : node.dict;
      var dictKeys = dict.getKeys();

      for (var i = 0, ii = dictKeys.length; i < ii; i++) {
        var rawValue = dict.getRaw(dictKeys[i]);

        if (mayHaveChildren(rawValue)) {
          nodesToVisit.push(rawValue);
        }
      }
    } else if (Array.isArray(node)) {
      for (var _i3 = 0, _ii2 = node.length; _i3 < _ii2; _i3++) {
        var value = node[_i3];

        if (mayHaveChildren(value)) {
          nodesToVisit.push(value);
        }
      }
    }
  }

  function ObjectLoader(dict, keys, xref) {
    this.dict = dict;
    this.keys = keys;
    this.xref = xref;
    this.refSet = null;
    this.capability = null;
  }

  ObjectLoader.prototype = {
    load: function load() {
      this.capability = (0, _util.createPromiseCapability)();

      if (!(this.xref.stream instanceof _chunked_stream.ChunkedStream) || this.xref.stream.getMissingChunks().length === 0) {
        this.capability.resolve();
        return this.capability.promise;
      }

      var keys = this.keys,
          dict = this.dict;
      this.refSet = new _primitives.RefSet();
      var nodesToVisit = [];

      for (var i = 0, ii = keys.length; i < ii; i++) {
        var rawValue = dict.getRaw(keys[i]);

        if (rawValue !== undefined) {
          nodesToVisit.push(rawValue);
        }
      }

      this._walk(nodesToVisit);

      return this.capability.promise;
    },
    _walk: function _walk(nodesToVisit) {
      var _this2 = this;

      var nodesToRevisit = [];
      var pendingRequests = [];

      while (nodesToVisit.length) {
        var currentNode = nodesToVisit.pop();

        if ((0, _primitives.isRef)(currentNode)) {
          if (this.refSet.has(currentNode)) {
            continue;
          }

          try {
            this.refSet.put(currentNode);
            currentNode = this.xref.fetch(currentNode);
          } catch (ex) {
            if (!(ex instanceof _util.MissingDataException)) {
              throw ex;
            }

            nodesToRevisit.push(currentNode);
            pendingRequests.push({
              begin: ex.begin,
              end: ex.end
            });
          }
        }

        if (currentNode && currentNode.getBaseStreams) {
          var baseStreams = currentNode.getBaseStreams();
          var foundMissingData = false;

          for (var i = 0, ii = baseStreams.length; i < ii; i++) {
            var stream = baseStreams[i];

            if (stream.getMissingChunks && stream.getMissingChunks().length) {
              foundMissingData = true;
              pendingRequests.push({
                begin: stream.start,
                end: stream.end
              });
            }
          }

          if (foundMissingData) {
            nodesToRevisit.push(currentNode);
          }
        }

        addChildren(currentNode, nodesToVisit);
      }

      if (pendingRequests.length) {
        this.xref.stream.manager.requestRanges(pendingRequests).then(function () {
          for (var _i4 = 0, _ii3 = nodesToRevisit.length; _i4 < _ii3; _i4++) {
            var node = nodesToRevisit[_i4];

            if ((0, _primitives.isRef)(node)) {
              _this2.refSet.remove(node);
            }
          }

          _this2._walk(nodesToRevisit);
        }, this.capability.reject);
        return;
      }

      this.refSet = null;
      this.capability.resolve();
    }
  };
  return ObjectLoader;
}();

exports.ObjectLoader = ObjectLoader;

/***/ }),
/* 155 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isEOF = isEOF;
exports.isCmd = isCmd;
exports.isDict = isDict;
exports.isName = isName;
exports.isRef = isRef;
exports.isRefsEqual = isRefsEqual;
exports.isStream = isStream;
exports.RefSetCache = exports.RefSet = exports.Ref = exports.Name = exports.Dict = exports.Cmd = exports.EOF = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var EOF = {};
exports.EOF = EOF;

var Name = function NameClosure() {
  function Name(name) {
    this.name = name;
  }

  Name.prototype = {};
  var nameCache = Object.create(null);

  Name.get = function Name_get(name) {
    var nameValue = nameCache[name];
    return nameValue ? nameValue : nameCache[name] = new Name(name);
  };

  return Name;
}();

exports.Name = Name;

var Cmd = function CmdClosure() {
  function Cmd(cmd) {
    this.cmd = cmd;
  }

  Cmd.prototype = {};
  var cmdCache = Object.create(null);

  Cmd.get = function Cmd_get(cmd) {
    var cmdValue = cmdCache[cmd];
    return cmdValue ? cmdValue : cmdCache[cmd] = new Cmd(cmd);
  };

  return Cmd;
}();

exports.Cmd = Cmd;

var Dict = function DictClosure() {
  var nonSerializable = function nonSerializableClosure() {
    return nonSerializable;
  };

  function Dict(xref) {
    this._map = Object.create(null);
    this.xref = xref;
    this.objId = null;
    this.suppressEncryption = false;
    this.__nonSerializable__ = nonSerializable;
  }

  Dict.prototype = {
    assignXref: function Dict_assignXref(newXref) {
      this.xref = newXref;
    },
    get: function Dict_get(key1, key2, key3) {
      var value;
      var xref = this.xref,
          suppressEncryption = this.suppressEncryption;

      if (typeof (value = this._map[key1]) !== 'undefined' || key1 in this._map || typeof key2 === 'undefined') {
        return xref ? xref.fetchIfRef(value, suppressEncryption) : value;
      }

      if (typeof (value = this._map[key2]) !== 'undefined' || key2 in this._map || typeof key3 === 'undefined') {
        return xref ? xref.fetchIfRef(value, suppressEncryption) : value;
      }

      value = this._map[key3] || null;
      return xref ? xref.fetchIfRef(value, suppressEncryption) : value;
    },
    getAsync: function Dict_getAsync(key1, key2, key3) {
      var value;
      var xref = this.xref,
          suppressEncryption = this.suppressEncryption;

      if (typeof (value = this._map[key1]) !== 'undefined' || key1 in this._map || typeof key2 === 'undefined') {
        if (xref) {
          return xref.fetchIfRefAsync(value, suppressEncryption);
        }

        return Promise.resolve(value);
      }

      if (typeof (value = this._map[key2]) !== 'undefined' || key2 in this._map || typeof key3 === 'undefined') {
        if (xref) {
          return xref.fetchIfRefAsync(value, suppressEncryption);
        }

        return Promise.resolve(value);
      }

      value = this._map[key3] || null;

      if (xref) {
        return xref.fetchIfRefAsync(value, suppressEncryption);
      }

      return Promise.resolve(value);
    },
    getArray: function Dict_getArray(key1, key2, key3) {
      var value = this.get(key1, key2, key3);
      var xref = this.xref,
          suppressEncryption = this.suppressEncryption;

      if (!Array.isArray(value) || !xref) {
        return value;
      }

      value = value.slice();

      for (var i = 0, ii = value.length; i < ii; i++) {
        if (!isRef(value[i])) {
          continue;
        }

        value[i] = xref.fetch(value[i], suppressEncryption);
      }

      return value;
    },
    getRaw: function Dict_getRaw(key) {
      return this._map[key];
    },
    getKeys: function Dict_getKeys() {
      return Object.keys(this._map);
    },
    set: function Dict_set(key, value) {
      this._map[key] = value;
    },
    has: function Dict_has(key) {
      return key in this._map;
    },
    forEach: function Dict_forEach(callback) {
      for (var key in this._map) {
        callback(key, this.get(key));
      }
    }
  };
  Dict.empty = new Dict(null);

  Dict.merge = function (xref, dictArray) {
    var mergedDict = new Dict(xref);

    for (var i = 0, ii = dictArray.length; i < ii; i++) {
      var dict = dictArray[i];

      if (!isDict(dict)) {
        continue;
      }

      for (var keyName in dict._map) {
        if (mergedDict._map[keyName] !== undefined) {
          continue;
        }

        mergedDict._map[keyName] = dict._map[keyName];
      }
    }

    return mergedDict;
  };

  return Dict;
}();

exports.Dict = Dict;

var Ref = function RefClosure() {
  function Ref(num, gen) {
    this.num = num;
    this.gen = gen;
  }

  Ref.prototype = {
    toString: function Ref_toString() {
      if (this.gen !== 0) {
        return "".concat(this.num, "R").concat(this.gen);
      }

      return "".concat(this.num, "R");
    }
  };
  return Ref;
}();

exports.Ref = Ref;

var RefSet = function RefSetClosure() {
  function RefSet() {
    this.dict = Object.create(null);
  }

  RefSet.prototype = {
    has: function RefSet_has(ref) {
      return ref.toString() in this.dict;
    },
    put: function RefSet_put(ref) {
      this.dict[ref.toString()] = true;
    },
    remove: function RefSet_remove(ref) {
      delete this.dict[ref.toString()];
    }
  };
  return RefSet;
}();

exports.RefSet = RefSet;

var RefSetCache = function RefSetCacheClosure() {
  function RefSetCache() {
    this.dict = Object.create(null);
  }

  RefSetCache.prototype = {
    get: function RefSetCache_get(ref) {
      return this.dict[ref.toString()];
    },
    has: function RefSetCache_has(ref) {
      return ref.toString() in this.dict;
    },
    put: function RefSetCache_put(ref, obj) {
      this.dict[ref.toString()] = obj;
    },
    putAlias: function RefSetCache_putAlias(ref, aliasRef) {
      this.dict[ref.toString()] = this.get(aliasRef);
    },
    forEach: function RefSetCache_forEach(fn, thisArg) {
      for (var i in this.dict) {
        fn.call(thisArg, this.dict[i]);
      }
    },
    clear: function RefSetCache_clear() {
      this.dict = Object.create(null);
    }
  };
  return RefSetCache;
}();

exports.RefSetCache = RefSetCache;

function isEOF(v) {
  return v === EOF;
}

function isName(v, name) {
  return v instanceof Name && (name === undefined || v.name === name);
}

function isCmd(v, cmd) {
  return v instanceof Cmd && (cmd === undefined || v.cmd === cmd);
}

function isDict(v, type) {
  return v instanceof Dict && (type === undefined || isName(v.get('Type'), type));
}

function isRef(v) {
  return v instanceof Ref;
}

function isRefsEqual(v1, v2) {
  return v1.num === v2.num && v1.gen === v2.gen;
}

function isStream(v) {
  return _typeof(v) === 'object' && v !== null && v.getBytes !== undefined;
}

/***/ }),
/* 156 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Parser = exports.Linearization = exports.Lexer = void 0;

var _stream = __w_pdfjs_require__(157);

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

var _ccitt_stream = __w_pdfjs_require__(158);

var _jbig2_stream = __w_pdfjs_require__(160);

var _jpeg_stream = __w_pdfjs_require__(163);

var _jpx_stream = __w_pdfjs_require__(165);

var MAX_LENGTH_TO_CACHE = 1000;
var MAX_ADLER32_LENGTH = 5552;

function computeAdler32(bytes) {
  var bytesLength = bytes.length;
  var a = 1,
      b = 0;

  for (var i = 0; i < bytesLength; ++i) {
    a += bytes[i] & 0xFF;
    b += a;
  }

  return b % 65521 << 16 | a % 65521;
}

var Parser = function ParserClosure() {
  function Parser(lexer, allowStreams, xref, recoveryMode) {
    this.lexer = lexer;
    this.allowStreams = allowStreams;
    this.xref = xref;
    this.recoveryMode = recoveryMode || false;
    this.imageCache = Object.create(null);
    this.refill();
  }

  Parser.prototype = {
    refill: function Parser_refill() {
      this.buf1 = this.lexer.getObj();
      this.buf2 = this.lexer.getObj();
    },
    shift: function Parser_shift() {
      if ((0, _primitives.isCmd)(this.buf2, 'ID')) {
        this.buf1 = this.buf2;
        this.buf2 = null;
      } else {
        this.buf1 = this.buf2;
        this.buf2 = this.lexer.getObj();
      }
    },
    tryShift: function Parser_tryShift() {
      try {
        this.shift();
        return true;
      } catch (e) {
        if (e instanceof _util.MissingDataException) {
          throw e;
        }

        return false;
      }
    },
    getObj: function Parser_getObj(cipherTransform) {
      var buf1 = this.buf1;
      this.shift();

      if (buf1 instanceof _primitives.Cmd) {
        switch (buf1.cmd) {
          case 'BI':
            return this.makeInlineImage(cipherTransform);

          case '[':
            var array = [];

            while (!(0, _primitives.isCmd)(this.buf1, ']') && !(0, _primitives.isEOF)(this.buf1)) {
              array.push(this.getObj(cipherTransform));
            }

            if ((0, _primitives.isEOF)(this.buf1)) {
              if (!this.recoveryMode) {
                throw new _util.FormatError('End of file inside array');
              }

              return array;
            }

            this.shift();
            return array;

          case '<<':
            var dict = new _primitives.Dict(this.xref);

            while (!(0, _primitives.isCmd)(this.buf1, '>>') && !(0, _primitives.isEOF)(this.buf1)) {
              if (!(0, _primitives.isName)(this.buf1)) {
                (0, _util.info)('Malformed dictionary: key must be a name object');
                this.shift();
                continue;
              }

              var key = this.buf1.name;
              this.shift();

              if ((0, _primitives.isEOF)(this.buf1)) {
                break;
              }

              dict.set(key, this.getObj(cipherTransform));
            }

            if ((0, _primitives.isEOF)(this.buf1)) {
              if (!this.recoveryMode) {
                throw new _util.FormatError('End of file inside dictionary');
              }

              return dict;
            }

            if ((0, _primitives.isCmd)(this.buf2, 'stream')) {
              return this.allowStreams ? this.makeStream(dict, cipherTransform) : dict;
            }

            this.shift();
            return dict;

          default:
            return buf1;
        }
      }

      if (Number.isInteger(buf1)) {
        var num = buf1;

        if (Number.isInteger(this.buf1) && (0, _primitives.isCmd)(this.buf2, 'R')) {
          var ref = new _primitives.Ref(num, this.buf1);
          this.shift();
          this.shift();
          return ref;
        }

        return num;
      }

      if ((0, _util.isString)(buf1)) {
        var str = buf1;

        if (cipherTransform) {
          str = cipherTransform.decryptString(str);
        }

        return str;
      }

      return buf1;
    },
    findDefaultInlineStreamEnd: function findDefaultInlineStreamEnd(stream) {
      var E = 0x45,
          I = 0x49,
          SPACE = 0x20,
          LF = 0xA,
          CR = 0xD;
      var n = 10,
          NUL = 0x0;
      var startPos = stream.pos,
          state = 0,
          ch,
          maybeEIPos;

      while ((ch = stream.getByte()) !== -1) {
        if (state === 0) {
          state = ch === E ? 1 : 0;
        } else if (state === 1) {
          state = ch === I ? 2 : 0;
        } else {
          (0, _util.assert)(state === 2);

          if (ch === SPACE || ch === LF || ch === CR) {
            maybeEIPos = stream.pos;
            var followingBytes = stream.peekBytes(n);

            for (var i = 0, ii = followingBytes.length; i < ii; i++) {
              ch = followingBytes[i];

              if (ch === NUL && followingBytes[i + 1] !== NUL) {
                continue;
              }

              if (ch !== LF && ch !== CR && (ch < SPACE || ch > 0x7F)) {
                state = 0;
                break;
              }
            }

            if (state === 2) {
              break;
            }
          } else {
            state = 0;
          }
        }
      }

      if (ch === -1) {
        (0, _util.warn)('findDefaultInlineStreamEnd: ' + 'Reached the end of the stream without finding a valid EI marker');

        if (maybeEIPos) {
          (0, _util.warn)('... trying to recover by using the last "EI" occurrence.');
          stream.skip(-(stream.pos - maybeEIPos));
        }
      }

      var endOffset = 4;
      stream.skip(-endOffset);
      ch = stream.peekByte();
      stream.skip(endOffset);

      if (!(0, _util.isSpace)(ch)) {
        endOffset--;
      }

      return stream.pos - endOffset - startPos;
    },
    findDCTDecodeInlineStreamEnd: function Parser_findDCTDecodeInlineStreamEnd(stream) {
      var startPos = stream.pos,
          foundEOI = false,
          b,
          markerLength,
          length;

      while ((b = stream.getByte()) !== -1) {
        if (b !== 0xFF) {
          continue;
        }

        switch (stream.getByte()) {
          case 0x00:
            break;

          case 0xFF:
            stream.skip(-1);
            break;

          case 0xD9:
            foundEOI = true;
            break;

          case 0xC0:
          case 0xC1:
          case 0xC2:
          case 0xC3:
          case 0xC5:
          case 0xC6:
          case 0xC7:
          case 0xC9:
          case 0xCA:
          case 0xCB:
          case 0xCD:
          case 0xCE:
          case 0xCF:
          case 0xC4:
          case 0xCC:
          case 0xDA:
          case 0xDB:
          case 0xDC:
          case 0xDD:
          case 0xDE:
          case 0xDF:
          case 0xE0:
          case 0xE1:
          case 0xE2:
          case 0xE3:
          case 0xE4:
          case 0xE5:
          case 0xE6:
          case 0xE7:
          case 0xE8:
          case 0xE9:
          case 0xEA:
          case 0xEB:
          case 0xEC:
          case 0xED:
          case 0xEE:
          case 0xEF:
          case 0xFE:
            markerLength = stream.getUint16();

            if (markerLength > 2) {
              stream.skip(markerLength - 2);
            } else {
              stream.skip(-2);
            }

            break;
        }

        if (foundEOI) {
          break;
        }
      }

      length = stream.pos - startPos;

      if (b === -1) {
        (0, _util.warn)('Inline DCTDecode image stream: ' + 'EOI marker not found, searching for /EI/ instead.');
        stream.skip(-length);
        return this.findDefaultInlineStreamEnd(stream);
      }

      this.inlineStreamSkipEI(stream);
      return length;
    },
    findASCII85DecodeInlineStreamEnd: function Parser_findASCII85DecodeInlineStreamEnd(stream) {
      var TILDE = 0x7E,
          GT = 0x3E;
      var startPos = stream.pos,
          ch,
          length;

      while ((ch = stream.getByte()) !== -1) {
        if (ch === TILDE && stream.peekByte() === GT) {
          stream.skip();
          break;
        }
      }

      length = stream.pos - startPos;

      if (ch === -1) {
        (0, _util.warn)('Inline ASCII85Decode image stream: ' + 'EOD marker not found, searching for /EI/ instead.');
        stream.skip(-length);
        return this.findDefaultInlineStreamEnd(stream);
      }

      this.inlineStreamSkipEI(stream);
      return length;
    },
    findASCIIHexDecodeInlineStreamEnd: function Parser_findASCIIHexDecodeInlineStreamEnd(stream) {
      var GT = 0x3E;
      var startPos = stream.pos,
          ch,
          length;

      while ((ch = stream.getByte()) !== -1) {
        if (ch === GT) {
          break;
        }
      }

      length = stream.pos - startPos;

      if (ch === -1) {
        (0, _util.warn)('Inline ASCIIHexDecode image stream: ' + 'EOD marker not found, searching for /EI/ instead.');
        stream.skip(-length);
        return this.findDefaultInlineStreamEnd(stream);
      }

      this.inlineStreamSkipEI(stream);
      return length;
    },
    inlineStreamSkipEI: function Parser_inlineStreamSkipEI(stream) {
      var E = 0x45,
          I = 0x49;
      var state = 0,
          ch;

      while ((ch = stream.getByte()) !== -1) {
        if (state === 0) {
          state = ch === E ? 1 : 0;
        } else if (state === 1) {
          state = ch === I ? 2 : 0;
        } else if (state === 2) {
          break;
        }
      }
    },
    makeInlineImage: function Parser_makeInlineImage(cipherTransform) {
      var lexer = this.lexer;
      var stream = lexer.stream;
      var dict = new _primitives.Dict(this.xref),
          dictLength;

      while (!(0, _primitives.isCmd)(this.buf1, 'ID') && !(0, _primitives.isEOF)(this.buf1)) {
        if (!(0, _primitives.isName)(this.buf1)) {
          throw new _util.FormatError('Dictionary key must be a name object');
        }

        var key = this.buf1.name;
        this.shift();

        if ((0, _primitives.isEOF)(this.buf1)) {
          break;
        }

        dict.set(key, this.getObj(cipherTransform));
      }

      if (lexer.beginInlineImagePos !== -1) {
        dictLength = stream.pos - lexer.beginInlineImagePos;
      }

      var filter = dict.get('Filter', 'F'),
          filterName;

      if ((0, _primitives.isName)(filter)) {
        filterName = filter.name;
      } else if (Array.isArray(filter)) {
        var filterZero = this.xref.fetchIfRef(filter[0]);

        if ((0, _primitives.isName)(filterZero)) {
          filterName = filterZero.name;
        }
      }

      var startPos = stream.pos,
          length;

      if (filterName === 'DCTDecode' || filterName === 'DCT') {
        length = this.findDCTDecodeInlineStreamEnd(stream);
      } else if (filterName === 'ASCII85Decode' || filterName === 'A85') {
        length = this.findASCII85DecodeInlineStreamEnd(stream);
      } else if (filterName === 'ASCIIHexDecode' || filterName === 'AHx') {
        length = this.findASCIIHexDecodeInlineStreamEnd(stream);
      } else {
        length = this.findDefaultInlineStreamEnd(stream);
      }

      var imageStream = stream.makeSubStream(startPos, length, dict);
      var cacheKey;

      if (length < MAX_LENGTH_TO_CACHE && dictLength < MAX_ADLER32_LENGTH) {
        var imageBytes = imageStream.getBytes();
        imageStream.reset();
        var initialStreamPos = stream.pos;
        stream.pos = lexer.beginInlineImagePos;
        var dictBytes = stream.getBytes(dictLength);
        stream.pos = initialStreamPos;
        cacheKey = computeAdler32(imageBytes) + '_' + computeAdler32(dictBytes);
        var cacheEntry = this.imageCache[cacheKey];

        if (cacheEntry !== undefined) {
          this.buf2 = _primitives.Cmd.get('EI');
          this.shift();
          cacheEntry.reset();
          return cacheEntry;
        }
      }

      if (cipherTransform) {
        imageStream = cipherTransform.createStream(imageStream, length);
      }

      imageStream = this.filter(imageStream, dict, length);
      imageStream.dict = dict;

      if (cacheKey !== undefined) {
        imageStream.cacheKey = 'inline_' + length + '_' + cacheKey;
        this.imageCache[cacheKey] = imageStream;
      }

      this.buf2 = _primitives.Cmd.get('EI');
      this.shift();
      return imageStream;
    },
    _findStreamLength: function _findStreamLength(startPos, signature) {
      var stream = this.lexer.stream;
      stream.pos = startPos;
      var SCAN_BLOCK_LENGTH = 2048;
      var signatureLength = signature.length;

      while (stream.pos < stream.end) {
        var scanBytes = stream.peekBytes(SCAN_BLOCK_LENGTH);
        var scanLength = scanBytes.length - signatureLength;

        if (scanLength <= 0) {
          break;
        }

        var pos = 0;

        while (pos < scanLength) {
          var j = 0;

          while (j < signatureLength && scanBytes[pos + j] === signature[j]) {
            j++;
          }

          if (j >= signatureLength) {
            stream.pos += pos;
            return stream.pos - startPos;
          }

          pos++;
        }

        stream.pos += scanLength;
      }

      return -1;
    },
    makeStream: function Parser_makeStream(dict, cipherTransform) {
      var lexer = this.lexer;
      var stream = lexer.stream;
      lexer.skipToNextLine();
      var startPos = stream.pos - 1;
      var length = dict.get('Length');

      if (!Number.isInteger(length)) {
        (0, _util.info)('Bad ' + length + ' attribute in stream');
        length = 0;
      }

      stream.pos = startPos + length;
      lexer.nextChar();

      if (this.tryShift() && (0, _primitives.isCmd)(this.buf2, 'endstream')) {
        this.shift();
      } else {
        var ENDSTREAM_SIGNATURE = new Uint8Array([0x65, 0x6E, 0x64, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6D]);

        var actualLength = this._findStreamLength(startPos, ENDSTREAM_SIGNATURE);

        if (actualLength < 0) {
          var MAX_TRUNCATION = 1;

          for (var i = 1; i <= MAX_TRUNCATION; i++) {
            var end = ENDSTREAM_SIGNATURE.length - i;
            var TRUNCATED_SIGNATURE = ENDSTREAM_SIGNATURE.slice(0, end);

            var maybeLength = this._findStreamLength(startPos, TRUNCATED_SIGNATURE);

            if (maybeLength >= 0) {
              var lastByte = stream.peekBytes(end + 1)[end];

              if (!(0, _util.isSpace)(lastByte)) {
                break;
              }

              (0, _util.info)("Found \"".concat((0, _util.bytesToString)(TRUNCATED_SIGNATURE), "\" when ") + 'searching for endstream command.');
              actualLength = maybeLength;
              break;
            }
          }

          if (actualLength < 0) {
            throw new _util.FormatError('Missing endstream command.');
          }
        }

        length = actualLength;
        lexer.nextChar();
        this.shift();
        this.shift();
      }

      this.shift();
      stream = stream.makeSubStream(startPos, length, dict);

      if (cipherTransform) {
        stream = cipherTransform.createStream(stream, length);
      }

      stream = this.filter(stream, dict, length);
      stream.dict = dict;
      return stream;
    },
    filter: function Parser_filter(stream, dict, length) {
      var filter = dict.get('Filter', 'F');
      var params = dict.get('DecodeParms', 'DP');

      if ((0, _primitives.isName)(filter)) {
        if (Array.isArray(params)) {
          (0, _util.warn)('/DecodeParms should not contain an Array, ' + 'when /Filter contains a Name.');
        }

        return this.makeFilter(stream, filter.name, length, params);
      }

      var maybeLength = length;

      if (Array.isArray(filter)) {
        var filterArray = filter;
        var paramsArray = params;

        for (var i = 0, ii = filterArray.length; i < ii; ++i) {
          filter = this.xref.fetchIfRef(filterArray[i]);

          if (!(0, _primitives.isName)(filter)) {
            throw new _util.FormatError('Bad filter name: ' + filter);
          }

          params = null;

          if (Array.isArray(paramsArray) && i in paramsArray) {
            params = this.xref.fetchIfRef(paramsArray[i]);
          }

          stream = this.makeFilter(stream, filter.name, maybeLength, params);
          maybeLength = null;
        }
      }

      return stream;
    },
    makeFilter: function Parser_makeFilter(stream, name, maybeLength, params) {
      if (maybeLength === 0) {
        (0, _util.warn)('Empty "' + name + '" stream.');
        return new _stream.NullStream();
      }

      try {
        var xrefStreamStats = this.xref.stats.streamTypes;

        if (name === 'FlateDecode' || name === 'Fl') {
          xrefStreamStats[_util.StreamType.FLATE] = true;

          if (params) {
            return new _stream.PredictorStream(new _stream.FlateStream(stream, maybeLength), maybeLength, params);
          }

          return new _stream.FlateStream(stream, maybeLength);
        }

        if (name === 'LZWDecode' || name === 'LZW') {
          xrefStreamStats[_util.StreamType.LZW] = true;
          var earlyChange = 1;

          if (params) {
            if (params.has('EarlyChange')) {
              earlyChange = params.get('EarlyChange');
            }

            return new _stream.PredictorStream(new _stream.LZWStream(stream, maybeLength, earlyChange), maybeLength, params);
          }

          return new _stream.LZWStream(stream, maybeLength, earlyChange);
        }

        if (name === 'DCTDecode' || name === 'DCT') {
          xrefStreamStats[_util.StreamType.DCT] = true;
          return new _jpeg_stream.JpegStream(stream, maybeLength, stream.dict, params);
        }

        if (name === 'JPXDecode' || name === 'JPX') {
          xrefStreamStats[_util.StreamType.JPX] = true;
          return new _jpx_stream.JpxStream(stream, maybeLength, stream.dict, params);
        }

        if (name === 'ASCII85Decode' || name === 'A85') {
          xrefStreamStats[_util.StreamType.A85] = true;
          return new _stream.Ascii85Stream(stream, maybeLength);
        }

        if (name === 'ASCIIHexDecode' || name === 'AHx') {
          xrefStreamStats[_util.StreamType.AHX] = true;
          return new _stream.AsciiHexStream(stream, maybeLength);
        }

        if (name === 'CCITTFaxDecode' || name === 'CCF') {
          xrefStreamStats[_util.StreamType.CCF] = true;
          return new _ccitt_stream.CCITTFaxStream(stream, maybeLength, params);
        }

        if (name === 'RunLengthDecode' || name === 'RL') {
          xrefStreamStats[_util.StreamType.RL] = true;
          return new _stream.RunLengthStream(stream, maybeLength);
        }

        if (name === 'JBIG2Decode') {
          xrefStreamStats[_util.StreamType.JBIG] = true;
          return new _jbig2_stream.Jbig2Stream(stream, maybeLength, stream.dict, params);
        }

        (0, _util.warn)('filter "' + name + '" not supported yet');
        return stream;
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.warn)('Invalid stream: \"' + ex + '\"');
        return new _stream.NullStream();
      }
    }
  };
  return Parser;
}();

exports.Parser = Parser;

var Lexer = function LexerClosure() {
  function Lexer(stream, knownCommands) {
    this.stream = stream;
    this.nextChar();
    this.strBuf = [];
    this.knownCommands = knownCommands;
    this.beginInlineImagePos = -1;
  }

  var specialChars = [1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 2, 0, 0, 2, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];

  function toHexDigit(ch) {
    if (ch >= 0x30 && ch <= 0x39) {
      return ch & 0x0F;
    }

    if (ch >= 0x41 && ch <= 0x46 || ch >= 0x61 && ch <= 0x66) {
      return (ch & 0x0F) + 9;
    }

    return -1;
  }

  Lexer.prototype = {
    nextChar: function Lexer_nextChar() {
      return this.currentChar = this.stream.getByte();
    },
    peekChar: function Lexer_peekChar() {
      return this.stream.peekByte();
    },
    getNumber: function Lexer_getNumber() {
      var ch = this.currentChar;
      var eNotation = false;
      var divideBy = 0;
      var sign = 0;

      if (ch === 0x2D) {
        sign = -1;
        ch = this.nextChar();

        if (ch === 0x2D) {
          ch = this.nextChar();
        }
      } else if (ch === 0x2B) {
        sign = 1;
        ch = this.nextChar();
      }

      if (ch === 0x0A || ch === 0x0D) {
        do {
          ch = this.nextChar();
        } while (ch === 0x0A || ch === 0x0D);
      }

      if (ch === 0x2E) {
        divideBy = 10;
        ch = this.nextChar();
      }

      if (ch < 0x30 || ch > 0x39) {
        if (divideBy === 10 && sign === 0 && ((0, _util.isSpace)(ch) || ch === -1)) {
          (0, _util.warn)('Lexer.getNumber - treating a single decimal point as zero.');
          return 0;
        }

        throw new _util.FormatError("Invalid number: ".concat(String.fromCharCode(ch), " (charCode ").concat(ch, ")"));
      }

      sign = sign || 1;
      var baseValue = ch - 0x30;
      var powerValue = 0;
      var powerValueSign = 1;

      while ((ch = this.nextChar()) >= 0) {
        if (0x30 <= ch && ch <= 0x39) {
          var currentDigit = ch - 0x30;

          if (eNotation) {
            powerValue = powerValue * 10 + currentDigit;
          } else {
            if (divideBy !== 0) {
              divideBy *= 10;
            }

            baseValue = baseValue * 10 + currentDigit;
          }
        } else if (ch === 0x2E) {
          if (divideBy === 0) {
            divideBy = 1;
          } else {
            break;
          }
        } else if (ch === 0x2D) {
          (0, _util.warn)('Badly formatted number');
        } else if (ch === 0x45 || ch === 0x65) {
          ch = this.peekChar();

          if (ch === 0x2B || ch === 0x2D) {
            powerValueSign = ch === 0x2D ? -1 : 1;
            this.nextChar();
          } else if (ch < 0x30 || ch > 0x39) {
            break;
          }

          eNotation = true;
        } else {
          break;
        }
      }

      if (divideBy !== 0) {
        baseValue /= divideBy;
      }

      if (eNotation) {
        baseValue *= Math.pow(10, powerValueSign * powerValue);
      }

      return sign * baseValue;
    },
    getString: function Lexer_getString() {
      var numParen = 1;
      var done = false;
      var strBuf = this.strBuf;
      strBuf.length = 0;
      var ch = this.nextChar();

      while (true) {
        var charBuffered = false;

        switch (ch | 0) {
          case -1:
            (0, _util.warn)('Unterminated string');
            done = true;
            break;

          case 0x28:
            ++numParen;
            strBuf.push('(');
            break;

          case 0x29:
            if (--numParen === 0) {
              this.nextChar();
              done = true;
            } else {
              strBuf.push(')');
            }

            break;

          case 0x5C:
            ch = this.nextChar();

            switch (ch) {
              case -1:
                (0, _util.warn)('Unterminated string');
                done = true;
                break;

              case 0x6E:
                strBuf.push('\n');
                break;

              case 0x72:
                strBuf.push('\r');
                break;

              case 0x74:
                strBuf.push('\t');
                break;

              case 0x62:
                strBuf.push('\b');
                break;

              case 0x66:
                strBuf.push('\f');
                break;

              case 0x5C:
              case 0x28:
              case 0x29:
                strBuf.push(String.fromCharCode(ch));
                break;

              case 0x30:
              case 0x31:
              case 0x32:
              case 0x33:
              case 0x34:
              case 0x35:
              case 0x36:
              case 0x37:
                var x = ch & 0x0F;
                ch = this.nextChar();
                charBuffered = true;

                if (ch >= 0x30 && ch <= 0x37) {
                  x = (x << 3) + (ch & 0x0F);
                  ch = this.nextChar();

                  if (ch >= 0x30 && ch <= 0x37) {
                    charBuffered = false;
                    x = (x << 3) + (ch & 0x0F);
                  }
                }

                strBuf.push(String.fromCharCode(x));
                break;

              case 0x0D:
                if (this.peekChar() === 0x0A) {
                  this.nextChar();
                }

                break;

              case 0x0A:
                break;

              default:
                strBuf.push(String.fromCharCode(ch));
                break;
            }

            break;

          default:
            strBuf.push(String.fromCharCode(ch));
            break;
        }

        if (done) {
          break;
        }

        if (!charBuffered) {
          ch = this.nextChar();
        }
      }

      return strBuf.join('');
    },
    getName: function Lexer_getName() {
      var ch, previousCh;
      var strBuf = this.strBuf;
      strBuf.length = 0;

      while ((ch = this.nextChar()) >= 0 && !specialChars[ch]) {
        if (ch === 0x23) {
          ch = this.nextChar();

          if (specialChars[ch]) {
            (0, _util.warn)('Lexer_getName: ' + 'NUMBER SIGN (#) should be followed by a hexadecimal number.');
            strBuf.push('#');
            break;
          }

          var x = toHexDigit(ch);

          if (x !== -1) {
            previousCh = ch;
            ch = this.nextChar();
            var x2 = toHexDigit(ch);

            if (x2 === -1) {
              (0, _util.warn)('Lexer_getName: Illegal digit (' + String.fromCharCode(ch) + ') in hexadecimal number.');
              strBuf.push('#', String.fromCharCode(previousCh));

              if (specialChars[ch]) {
                break;
              }

              strBuf.push(String.fromCharCode(ch));
              continue;
            }

            strBuf.push(String.fromCharCode(x << 4 | x2));
          } else {
            strBuf.push('#', String.fromCharCode(ch));
          }
        } else {
          strBuf.push(String.fromCharCode(ch));
        }
      }

      if (strBuf.length > 127) {
        (0, _util.warn)('name token is longer than allowed by the spec: ' + strBuf.length);
      }

      return _primitives.Name.get(strBuf.join(''));
    },
    getHexString: function Lexer_getHexString() {
      var strBuf = this.strBuf;
      strBuf.length = 0;
      var ch = this.currentChar;
      var isFirstHex = true;
      var firstDigit;
      var secondDigit;

      while (true) {
        if (ch < 0) {
          (0, _util.warn)('Unterminated hex string');
          break;
        } else if (ch === 0x3E) {
          this.nextChar();
          break;
        } else if (specialChars[ch] === 1) {
          ch = this.nextChar();
          continue;
        } else {
          if (isFirstHex) {
            firstDigit = toHexDigit(ch);

            if (firstDigit === -1) {
              (0, _util.warn)('Ignoring invalid character "' + ch + '" in hex string');
              ch = this.nextChar();
              continue;
            }
          } else {
            secondDigit = toHexDigit(ch);

            if (secondDigit === -1) {
              (0, _util.warn)('Ignoring invalid character "' + ch + '" in hex string');
              ch = this.nextChar();
              continue;
            }

            strBuf.push(String.fromCharCode(firstDigit << 4 | secondDigit));
          }

          isFirstHex = !isFirstHex;
          ch = this.nextChar();
        }
      }

      return strBuf.join('');
    },
    getObj: function Lexer_getObj() {
      var comment = false;
      var ch = this.currentChar;

      while (true) {
        if (ch < 0) {
          return _primitives.EOF;
        }

        if (comment) {
          if (ch === 0x0A || ch === 0x0D) {
            comment = false;
          }
        } else if (ch === 0x25) {
          comment = true;
        } else if (specialChars[ch] !== 1) {
          break;
        }

        ch = this.nextChar();
      }

      switch (ch | 0) {
        case 0x30:
        case 0x31:
        case 0x32:
        case 0x33:
        case 0x34:
        case 0x35:
        case 0x36:
        case 0x37:
        case 0x38:
        case 0x39:
        case 0x2B:
        case 0x2D:
        case 0x2E:
          return this.getNumber();

        case 0x28:
          return this.getString();

        case 0x2F:
          return this.getName();

        case 0x5B:
          this.nextChar();
          return _primitives.Cmd.get('[');

        case 0x5D:
          this.nextChar();
          return _primitives.Cmd.get(']');

        case 0x3C:
          ch = this.nextChar();

          if (ch === 0x3C) {
            this.nextChar();
            return _primitives.Cmd.get('<<');
          }

          return this.getHexString();

        case 0x3E:
          ch = this.nextChar();

          if (ch === 0x3E) {
            this.nextChar();
            return _primitives.Cmd.get('>>');
          }

          return _primitives.Cmd.get('>');

        case 0x7B:
          this.nextChar();
          return _primitives.Cmd.get('{');

        case 0x7D:
          this.nextChar();
          return _primitives.Cmd.get('}');

        case 0x29:
          this.nextChar();
          throw new _util.FormatError("Illegal character: ".concat(ch));
      }

      var str = String.fromCharCode(ch);
      var knownCommands = this.knownCommands;
      var knownCommandFound = knownCommands && knownCommands[str] !== undefined;

      while ((ch = this.nextChar()) >= 0 && !specialChars[ch]) {
        var possibleCommand = str + String.fromCharCode(ch);

        if (knownCommandFound && knownCommands[possibleCommand] === undefined) {
          break;
        }

        if (str.length === 128) {
          throw new _util.FormatError("Command token too long: ".concat(str.length));
        }

        str = possibleCommand;
        knownCommandFound = knownCommands && knownCommands[str] !== undefined;
      }

      if (str === 'true') {
        return true;
      }

      if (str === 'false') {
        return false;
      }

      if (str === 'null') {
        return null;
      }

      if (str === 'BI') {
        this.beginInlineImagePos = this.stream.pos;
      }

      return _primitives.Cmd.get(str);
    },
    skipToNextLine: function Lexer_skipToNextLine() {
      var ch = this.currentChar;

      while (ch >= 0) {
        if (ch === 0x0D) {
          ch = this.nextChar();

          if (ch === 0x0A) {
            this.nextChar();
          }

          break;
        } else if (ch === 0x0A) {
          this.nextChar();
          break;
        }

        ch = this.nextChar();
      }
    }
  };
  return Lexer;
}();

exports.Lexer = Lexer;
var Linearization = {
  create: function LinearizationCreate(stream) {
    function getInt(name, allowZeroValue) {
      var obj = linDict.get(name);

      if (Number.isInteger(obj) && (allowZeroValue ? obj >= 0 : obj > 0)) {
        return obj;
      }

      throw new Error('The "' + name + '" parameter in the linearization ' + 'dictionary is invalid.');
    }

    function getHints() {
      var hints = linDict.get('H'),
          hintsLength,
          item;

      if (Array.isArray(hints) && ((hintsLength = hints.length) === 2 || hintsLength === 4)) {
        for (var index = 0; index < hintsLength; index++) {
          if (!(Number.isInteger(item = hints[index]) && item > 0)) {
            throw new Error('Hint (' + index + ') in the linearization dictionary is invalid.');
          }
        }

        return hints;
      }

      throw new Error('Hint array in the linearization dictionary is invalid.');
    }

    var parser = new Parser(new Lexer(stream), false, null);
    var obj1 = parser.getObj();
    var obj2 = parser.getObj();
    var obj3 = parser.getObj();
    var linDict = parser.getObj();
    var obj, length;

    if (!(Number.isInteger(obj1) && Number.isInteger(obj2) && (0, _primitives.isCmd)(obj3, 'obj') && (0, _primitives.isDict)(linDict) && (0, _util.isNum)(obj = linDict.get('Linearized')) && obj > 0)) {
      return null;
    } else if ((length = getInt('L')) !== stream.length) {
      throw new Error('The "L" parameter in the linearization dictionary ' + 'does not equal the stream length.');
    }

    return {
      length: length,
      hints: getHints(),
      objectNumberFirst: getInt('O'),
      endFirst: getInt('E'),
      numPages: getInt('N'),
      mainXRefEntriesOffset: getInt('T'),
      pageFirst: linDict.has('P') ? getInt('P', true) : 0
    };
  }
};
exports.Linearization = Linearization;

/***/ }),
/* 157 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LZWStream = exports.StringStream = exports.StreamsSequenceStream = exports.Stream = exports.RunLengthStream = exports.PredictorStream = exports.NullStream = exports.FlateStream = exports.DecodeStream = exports.DecryptStream = exports.AsciiHexStream = exports.Ascii85Stream = void 0;

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var Stream = function StreamClosure() {
  function Stream(arrayBuffer, start, length, dict) {
    this.bytes = arrayBuffer instanceof Uint8Array ? arrayBuffer : new Uint8Array(arrayBuffer);
    this.start = start || 0;
    this.pos = this.start;
    this.end = start + length || this.bytes.length;
    this.dict = dict;
  }

  Stream.prototype = {
    get length() {
      return this.end - this.start;
    },

    get isEmpty() {
      return this.length === 0;
    },

    getByte: function Stream_getByte() {
      if (this.pos >= this.end) {
        return -1;
      }

      return this.bytes[this.pos++];
    },
    getUint16: function Stream_getUint16() {
      var b0 = this.getByte();
      var b1 = this.getByte();

      if (b0 === -1 || b1 === -1) {
        return -1;
      }

      return (b0 << 8) + b1;
    },
    getInt32: function Stream_getInt32() {
      var b0 = this.getByte();
      var b1 = this.getByte();
      var b2 = this.getByte();
      var b3 = this.getByte();
      return (b0 << 24) + (b1 << 16) + (b2 << 8) + b3;
    },
    getBytes: function getBytes(length) {
      var forceClamped = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var bytes = this.bytes;
      var pos = this.pos;
      var strEnd = this.end;

      if (!length) {
        var _subarray = bytes.subarray(pos, strEnd);

        return forceClamped ? new Uint8ClampedArray(_subarray) : _subarray;
      }

      var end = pos + length;

      if (end > strEnd) {
        end = strEnd;
      }

      this.pos = end;
      var subarray = bytes.subarray(pos, end);
      return forceClamped ? new Uint8ClampedArray(subarray) : subarray;
    },
    peekByte: function Stream_peekByte() {
      var peekedByte = this.getByte();
      this.pos--;
      return peekedByte;
    },
    peekBytes: function peekBytes(length) {
      var forceClamped = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var bytes = this.getBytes(length, forceClamped);
      this.pos -= bytes.length;
      return bytes;
    },
    skip: function Stream_skip(n) {
      if (!n) {
        n = 1;
      }

      this.pos += n;
    },
    reset: function Stream_reset() {
      this.pos = this.start;
    },
    moveStart: function Stream_moveStart() {
      this.start = this.pos;
    },
    makeSubStream: function Stream_makeSubStream(start, length, dict) {
      return new Stream(this.bytes.buffer, start, length, dict);
    }
  };
  return Stream;
}();

exports.Stream = Stream;

var StringStream = function StringStreamClosure() {
  function StringStream(str) {
    var bytes = (0, _util.stringToBytes)(str);
    Stream.call(this, bytes);
  }

  StringStream.prototype = Stream.prototype;
  return StringStream;
}();

exports.StringStream = StringStream;

var DecodeStream = function DecodeStreamClosure() {
  var emptyBuffer = new Uint8Array(0);

  function DecodeStream(maybeMinBufferLength) {
    this._rawMinBufferLength = maybeMinBufferLength || 0;
    this.pos = 0;
    this.bufferLength = 0;
    this.eof = false;
    this.buffer = emptyBuffer;
    this.minBufferLength = 512;

    if (maybeMinBufferLength) {
      while (this.minBufferLength < maybeMinBufferLength) {
        this.minBufferLength *= 2;
      }
    }
  }

  DecodeStream.prototype = {
    get isEmpty() {
      while (!this.eof && this.bufferLength === 0) {
        this.readBlock();
      }

      return this.bufferLength === 0;
    },

    ensureBuffer: function DecodeStream_ensureBuffer(requested) {
      var buffer = this.buffer;

      if (requested <= buffer.byteLength) {
        return buffer;
      }

      var size = this.minBufferLength;

      while (size < requested) {
        size *= 2;
      }

      var buffer2 = new Uint8Array(size);
      buffer2.set(buffer);
      return this.buffer = buffer2;
    },
    getByte: function DecodeStream_getByte() {
      var pos = this.pos;

      while (this.bufferLength <= pos) {
        if (this.eof) {
          return -1;
        }

        this.readBlock();
      }

      return this.buffer[this.pos++];
    },
    getUint16: function DecodeStream_getUint16() {
      var b0 = this.getByte();
      var b1 = this.getByte();

      if (b0 === -1 || b1 === -1) {
        return -1;
      }

      return (b0 << 8) + b1;
    },
    getInt32: function DecodeStream_getInt32() {
      var b0 = this.getByte();
      var b1 = this.getByte();
      var b2 = this.getByte();
      var b3 = this.getByte();
      return (b0 << 24) + (b1 << 16) + (b2 << 8) + b3;
    },
    getBytes: function getBytes(length) {
      var forceClamped = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var end,
          pos = this.pos;

      if (length) {
        this.ensureBuffer(pos + length);
        end = pos + length;

        while (!this.eof && this.bufferLength < end) {
          this.readBlock();
        }

        var bufEnd = this.bufferLength;

        if (end > bufEnd) {
          end = bufEnd;
        }
      } else {
        while (!this.eof) {
          this.readBlock();
        }

        end = this.bufferLength;
      }

      this.pos = end;
      var subarray = this.buffer.subarray(pos, end);
      return forceClamped && !(subarray instanceof Uint8ClampedArray) ? new Uint8ClampedArray(subarray) : subarray;
    },
    peekByte: function DecodeStream_peekByte() {
      var peekedByte = this.getByte();
      this.pos--;
      return peekedByte;
    },
    peekBytes: function peekBytes(length) {
      var forceClamped = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var bytes = this.getBytes(length, forceClamped);
      this.pos -= bytes.length;
      return bytes;
    },
    makeSubStream: function DecodeStream_makeSubStream(start, length, dict) {
      var end = start + length;

      while (this.bufferLength <= end && !this.eof) {
        this.readBlock();
      }

      return new Stream(this.buffer, start, length, dict);
    },
    skip: function DecodeStream_skip(n) {
      if (!n) {
        n = 1;
      }

      this.pos += n;
    },
    reset: function DecodeStream_reset() {
      this.pos = 0;
    },
    getBaseStreams: function DecodeStream_getBaseStreams() {
      if (this.str && this.str.getBaseStreams) {
        return this.str.getBaseStreams();
      }

      return [];
    }
  };
  return DecodeStream;
}();

exports.DecodeStream = DecodeStream;

var StreamsSequenceStream = function StreamsSequenceStreamClosure() {
  function StreamsSequenceStream(streams) {
    this.streams = streams;
    var maybeLength = 0;

    for (var i = 0, ii = streams.length; i < ii; i++) {
      var stream = streams[i];

      if (stream instanceof DecodeStream) {
        maybeLength += stream._rawMinBufferLength;
      } else {
        maybeLength += stream.length;
      }
    }

    DecodeStream.call(this, maybeLength);
  }

  StreamsSequenceStream.prototype = Object.create(DecodeStream.prototype);

  StreamsSequenceStream.prototype.readBlock = function streamSequenceStreamReadBlock() {
    var streams = this.streams;

    if (streams.length === 0) {
      this.eof = true;
      return;
    }

    var stream = streams.shift();
    var chunk = stream.getBytes();
    var bufferLength = this.bufferLength;
    var newLength = bufferLength + chunk.length;
    var buffer = this.ensureBuffer(newLength);
    buffer.set(chunk, bufferLength);
    this.bufferLength = newLength;
  };

  StreamsSequenceStream.prototype.getBaseStreams = function StreamsSequenceStream_getBaseStreams() {
    var baseStreams = [];

    for (var i = 0, ii = this.streams.length; i < ii; i++) {
      var stream = this.streams[i];

      if (stream.getBaseStreams) {
        baseStreams.push.apply(baseStreams, _toConsumableArray(stream.getBaseStreams()));
      }
    }

    return baseStreams;
  };

  return StreamsSequenceStream;
}();

exports.StreamsSequenceStream = StreamsSequenceStream;

var FlateStream = function FlateStreamClosure() {
  var codeLenCodeMap = new Int32Array([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]);
  var lengthDecode = new Int32Array([0x00003, 0x00004, 0x00005, 0x00006, 0x00007, 0x00008, 0x00009, 0x0000a, 0x1000b, 0x1000d, 0x1000f, 0x10011, 0x20013, 0x20017, 0x2001b, 0x2001f, 0x30023, 0x3002b, 0x30033, 0x3003b, 0x40043, 0x40053, 0x40063, 0x40073, 0x50083, 0x500a3, 0x500c3, 0x500e3, 0x00102, 0x00102, 0x00102]);
  var distDecode = new Int32Array([0x00001, 0x00002, 0x00003, 0x00004, 0x10005, 0x10007, 0x20009, 0x2000d, 0x30011, 0x30019, 0x40021, 0x40031, 0x50041, 0x50061, 0x60081, 0x600c1, 0x70101, 0x70181, 0x80201, 0x80301, 0x90401, 0x90601, 0xa0801, 0xa0c01, 0xb1001, 0xb1801, 0xc2001, 0xc3001, 0xd4001, 0xd6001]);
  var fixedLitCodeTab = [new Int32Array([0x70100, 0x80050, 0x80010, 0x80118, 0x70110, 0x80070, 0x80030, 0x900c0, 0x70108, 0x80060, 0x80020, 0x900a0, 0x80000, 0x80080, 0x80040, 0x900e0, 0x70104, 0x80058, 0x80018, 0x90090, 0x70114, 0x80078, 0x80038, 0x900d0, 0x7010c, 0x80068, 0x80028, 0x900b0, 0x80008, 0x80088, 0x80048, 0x900f0, 0x70102, 0x80054, 0x80014, 0x8011c, 0x70112, 0x80074, 0x80034, 0x900c8, 0x7010a, 0x80064, 0x80024, 0x900a8, 0x80004, 0x80084, 0x80044, 0x900e8, 0x70106, 0x8005c, 0x8001c, 0x90098, 0x70116, 0x8007c, 0x8003c, 0x900d8, 0x7010e, 0x8006c, 0x8002c, 0x900b8, 0x8000c, 0x8008c, 0x8004c, 0x900f8, 0x70101, 0x80052, 0x80012, 0x8011a, 0x70111, 0x80072, 0x80032, 0x900c4, 0x70109, 0x80062, 0x80022, 0x900a4, 0x80002, 0x80082, 0x80042, 0x900e4, 0x70105, 0x8005a, 0x8001a, 0x90094, 0x70115, 0x8007a, 0x8003a, 0x900d4, 0x7010d, 0x8006a, 0x8002a, 0x900b4, 0x8000a, 0x8008a, 0x8004a, 0x900f4, 0x70103, 0x80056, 0x80016, 0x8011e, 0x70113, 0x80076, 0x80036, 0x900cc, 0x7010b, 0x80066, 0x80026, 0x900ac, 0x80006, 0x80086, 0x80046, 0x900ec, 0x70107, 0x8005e, 0x8001e, 0x9009c, 0x70117, 0x8007e, 0x8003e, 0x900dc, 0x7010f, 0x8006e, 0x8002e, 0x900bc, 0x8000e, 0x8008e, 0x8004e, 0x900fc, 0x70100, 0x80051, 0x80011, 0x80119, 0x70110, 0x80071, 0x80031, 0x900c2, 0x70108, 0x80061, 0x80021, 0x900a2, 0x80001, 0x80081, 0x80041, 0x900e2, 0x70104, 0x80059, 0x80019, 0x90092, 0x70114, 0x80079, 0x80039, 0x900d2, 0x7010c, 0x80069, 0x80029, 0x900b2, 0x80009, 0x80089, 0x80049, 0x900f2, 0x70102, 0x80055, 0x80015, 0x8011d, 0x70112, 0x80075, 0x80035, 0x900ca, 0x7010a, 0x80065, 0x80025, 0x900aa, 0x80005, 0x80085, 0x80045, 0x900ea, 0x70106, 0x8005d, 0x8001d, 0x9009a, 0x70116, 0x8007d, 0x8003d, 0x900da, 0x7010e, 0x8006d, 0x8002d, 0x900ba, 0x8000d, 0x8008d, 0x8004d, 0x900fa, 0x70101, 0x80053, 0x80013, 0x8011b, 0x70111, 0x80073, 0x80033, 0x900c6, 0x70109, 0x80063, 0x80023, 0x900a6, 0x80003, 0x80083, 0x80043, 0x900e6, 0x70105, 0x8005b, 0x8001b, 0x90096, 0x70115, 0x8007b, 0x8003b, 0x900d6, 0x7010d, 0x8006b, 0x8002b, 0x900b6, 0x8000b, 0x8008b, 0x8004b, 0x900f6, 0x70103, 0x80057, 0x80017, 0x8011f, 0x70113, 0x80077, 0x80037, 0x900ce, 0x7010b, 0x80067, 0x80027, 0x900ae, 0x80007, 0x80087, 0x80047, 0x900ee, 0x70107, 0x8005f, 0x8001f, 0x9009e, 0x70117, 0x8007f, 0x8003f, 0x900de, 0x7010f, 0x8006f, 0x8002f, 0x900be, 0x8000f, 0x8008f, 0x8004f, 0x900fe, 0x70100, 0x80050, 0x80010, 0x80118, 0x70110, 0x80070, 0x80030, 0x900c1, 0x70108, 0x80060, 0x80020, 0x900a1, 0x80000, 0x80080, 0x80040, 0x900e1, 0x70104, 0x80058, 0x80018, 0x90091, 0x70114, 0x80078, 0x80038, 0x900d1, 0x7010c, 0x80068, 0x80028, 0x900b1, 0x80008, 0x80088, 0x80048, 0x900f1, 0x70102, 0x80054, 0x80014, 0x8011c, 0x70112, 0x80074, 0x80034, 0x900c9, 0x7010a, 0x80064, 0x80024, 0x900a9, 0x80004, 0x80084, 0x80044, 0x900e9, 0x70106, 0x8005c, 0x8001c, 0x90099, 0x70116, 0x8007c, 0x8003c, 0x900d9, 0x7010e, 0x8006c, 0x8002c, 0x900b9, 0x8000c, 0x8008c, 0x8004c, 0x900f9, 0x70101, 0x80052, 0x80012, 0x8011a, 0x70111, 0x80072, 0x80032, 0x900c5, 0x70109, 0x80062, 0x80022, 0x900a5, 0x80002, 0x80082, 0x80042, 0x900e5, 0x70105, 0x8005a, 0x8001a, 0x90095, 0x70115, 0x8007a, 0x8003a, 0x900d5, 0x7010d, 0x8006a, 0x8002a, 0x900b5, 0x8000a, 0x8008a, 0x8004a, 0x900f5, 0x70103, 0x80056, 0x80016, 0x8011e, 0x70113, 0x80076, 0x80036, 0x900cd, 0x7010b, 0x80066, 0x80026, 0x900ad, 0x80006, 0x80086, 0x80046, 0x900ed, 0x70107, 0x8005e, 0x8001e, 0x9009d, 0x70117, 0x8007e, 0x8003e, 0x900dd, 0x7010f, 0x8006e, 0x8002e, 0x900bd, 0x8000e, 0x8008e, 0x8004e, 0x900fd, 0x70100, 0x80051, 0x80011, 0x80119, 0x70110, 0x80071, 0x80031, 0x900c3, 0x70108, 0x80061, 0x80021, 0x900a3, 0x80001, 0x80081, 0x80041, 0x900e3, 0x70104, 0x80059, 0x80019, 0x90093, 0x70114, 0x80079, 0x80039, 0x900d3, 0x7010c, 0x80069, 0x80029, 0x900b3, 0x80009, 0x80089, 0x80049, 0x900f3, 0x70102, 0x80055, 0x80015, 0x8011d, 0x70112, 0x80075, 0x80035, 0x900cb, 0x7010a, 0x80065, 0x80025, 0x900ab, 0x80005, 0x80085, 0x80045, 0x900eb, 0x70106, 0x8005d, 0x8001d, 0x9009b, 0x70116, 0x8007d, 0x8003d, 0x900db, 0x7010e, 0x8006d, 0x8002d, 0x900bb, 0x8000d, 0x8008d, 0x8004d, 0x900fb, 0x70101, 0x80053, 0x80013, 0x8011b, 0x70111, 0x80073, 0x80033, 0x900c7, 0x70109, 0x80063, 0x80023, 0x900a7, 0x80003, 0x80083, 0x80043, 0x900e7, 0x70105, 0x8005b, 0x8001b, 0x90097, 0x70115, 0x8007b, 0x8003b, 0x900d7, 0x7010d, 0x8006b, 0x8002b, 0x900b7, 0x8000b, 0x8008b, 0x8004b, 0x900f7, 0x70103, 0x80057, 0x80017, 0x8011f, 0x70113, 0x80077, 0x80037, 0x900cf, 0x7010b, 0x80067, 0x80027, 0x900af, 0x80007, 0x80087, 0x80047, 0x900ef, 0x70107, 0x8005f, 0x8001f, 0x9009f, 0x70117, 0x8007f, 0x8003f, 0x900df, 0x7010f, 0x8006f, 0x8002f, 0x900bf, 0x8000f, 0x8008f, 0x8004f, 0x900ff]), 9];
  var fixedDistCodeTab = [new Int32Array([0x50000, 0x50010, 0x50008, 0x50018, 0x50004, 0x50014, 0x5000c, 0x5001c, 0x50002, 0x50012, 0x5000a, 0x5001a, 0x50006, 0x50016, 0x5000e, 0x00000, 0x50001, 0x50011, 0x50009, 0x50019, 0x50005, 0x50015, 0x5000d, 0x5001d, 0x50003, 0x50013, 0x5000b, 0x5001b, 0x50007, 0x50017, 0x5000f, 0x00000]), 5];

  function FlateStream(str, maybeLength) {
    this.str = str;
    this.dict = str.dict;
    var cmf = str.getByte();
    var flg = str.getByte();

    if (cmf === -1 || flg === -1) {
      throw new _util.FormatError("Invalid header in flate stream: ".concat(cmf, ", ").concat(flg));
    }

    if ((cmf & 0x0f) !== 0x08) {
      throw new _util.FormatError("Unknown compression method in flate stream: ".concat(cmf, ", ").concat(flg));
    }

    if (((cmf << 8) + flg) % 31 !== 0) {
      throw new _util.FormatError("Bad FCHECK in flate stream: ".concat(cmf, ", ").concat(flg));
    }

    if (flg & 0x20) {
      throw new _util.FormatError("FDICT bit set in flate stream: ".concat(cmf, ", ").concat(flg));
    }

    this.codeSize = 0;
    this.codeBuf = 0;
    DecodeStream.call(this, maybeLength);
  }

  FlateStream.prototype = Object.create(DecodeStream.prototype);

  FlateStream.prototype.getBits = function FlateStream_getBits(bits) {
    var str = this.str;
    var codeSize = this.codeSize;
    var codeBuf = this.codeBuf;
    var b;

    while (codeSize < bits) {
      if ((b = str.getByte()) === -1) {
        throw new _util.FormatError('Bad encoding in flate stream');
      }

      codeBuf |= b << codeSize;
      codeSize += 8;
    }

    b = codeBuf & (1 << bits) - 1;
    this.codeBuf = codeBuf >> bits;
    this.codeSize = codeSize -= bits;
    return b;
  };

  FlateStream.prototype.getCode = function FlateStream_getCode(table) {
    var str = this.str;
    var codes = table[0];
    var maxLen = table[1];
    var codeSize = this.codeSize;
    var codeBuf = this.codeBuf;
    var b;

    while (codeSize < maxLen) {
      if ((b = str.getByte()) === -1) {
        break;
      }

      codeBuf |= b << codeSize;
      codeSize += 8;
    }

    var code = codes[codeBuf & (1 << maxLen) - 1];
    var codeLen = code >> 16;
    var codeVal = code & 0xffff;

    if (codeLen < 1 || codeSize < codeLen) {
      throw new _util.FormatError('Bad encoding in flate stream');
    }

    this.codeBuf = codeBuf >> codeLen;
    this.codeSize = codeSize - codeLen;
    return codeVal;
  };

  FlateStream.prototype.generateHuffmanTable = function flateStreamGenerateHuffmanTable(lengths) {
    var n = lengths.length;
    var maxLen = 0;
    var i;

    for (i = 0; i < n; ++i) {
      if (lengths[i] > maxLen) {
        maxLen = lengths[i];
      }
    }

    var size = 1 << maxLen;
    var codes = new Int32Array(size);

    for (var len = 1, code = 0, skip = 2; len <= maxLen; ++len, code <<= 1, skip <<= 1) {
      for (var val = 0; val < n; ++val) {
        if (lengths[val] === len) {
          var code2 = 0;
          var t = code;

          for (i = 0; i < len; ++i) {
            code2 = code2 << 1 | t & 1;
            t >>= 1;
          }

          for (i = code2; i < size; i += skip) {
            codes[i] = len << 16 | val;
          }

          ++code;
        }
      }
    }

    return [codes, maxLen];
  };

  FlateStream.prototype.readBlock = function FlateStream_readBlock() {
    var buffer, len;
    var str = this.str;
    var hdr = this.getBits(3);

    if (hdr & 1) {
      this.eof = true;
    }

    hdr >>= 1;

    if (hdr === 0) {
      var b;

      if ((b = str.getByte()) === -1) {
        throw new _util.FormatError('Bad block header in flate stream');
      }

      var blockLen = b;

      if ((b = str.getByte()) === -1) {
        throw new _util.FormatError('Bad block header in flate stream');
      }

      blockLen |= b << 8;

      if ((b = str.getByte()) === -1) {
        throw new _util.FormatError('Bad block header in flate stream');
      }

      var check = b;

      if ((b = str.getByte()) === -1) {
        throw new _util.FormatError('Bad block header in flate stream');
      }

      check |= b << 8;

      if (check !== (~blockLen & 0xffff) && (blockLen !== 0 || check !== 0)) {
        throw new _util.FormatError('Bad uncompressed block length in flate stream');
      }

      this.codeBuf = 0;
      this.codeSize = 0;
      var bufferLength = this.bufferLength;
      buffer = this.ensureBuffer(bufferLength + blockLen);
      var end = bufferLength + blockLen;
      this.bufferLength = end;

      if (blockLen === 0) {
        if (str.peekByte() === -1) {
          this.eof = true;
        }
      } else {
        for (var n = bufferLength; n < end; ++n) {
          if ((b = str.getByte()) === -1) {
            this.eof = true;
            break;
          }

          buffer[n] = b;
        }
      }

      return;
    }

    var litCodeTable;
    var distCodeTable;

    if (hdr === 1) {
      litCodeTable = fixedLitCodeTab;
      distCodeTable = fixedDistCodeTab;
    } else if (hdr === 2) {
      var numLitCodes = this.getBits(5) + 257;
      var numDistCodes = this.getBits(5) + 1;
      var numCodeLenCodes = this.getBits(4) + 4;
      var codeLenCodeLengths = new Uint8Array(codeLenCodeMap.length);
      var i;

      for (i = 0; i < numCodeLenCodes; ++i) {
        codeLenCodeLengths[codeLenCodeMap[i]] = this.getBits(3);
      }

      var codeLenCodeTab = this.generateHuffmanTable(codeLenCodeLengths);
      len = 0;
      i = 0;
      var codes = numLitCodes + numDistCodes;
      var codeLengths = new Uint8Array(codes);
      var bitsLength, bitsOffset, what;

      while (i < codes) {
        var code = this.getCode(codeLenCodeTab);

        if (code === 16) {
          bitsLength = 2;
          bitsOffset = 3;
          what = len;
        } else if (code === 17) {
          bitsLength = 3;
          bitsOffset = 3;
          what = len = 0;
        } else if (code === 18) {
          bitsLength = 7;
          bitsOffset = 11;
          what = len = 0;
        } else {
          codeLengths[i++] = len = code;
          continue;
        }

        var repeatLength = this.getBits(bitsLength) + bitsOffset;

        while (repeatLength-- > 0) {
          codeLengths[i++] = what;
        }
      }

      litCodeTable = this.generateHuffmanTable(codeLengths.subarray(0, numLitCodes));
      distCodeTable = this.generateHuffmanTable(codeLengths.subarray(numLitCodes, codes));
    } else {
      throw new _util.FormatError('Unknown block type in flate stream');
    }

    buffer = this.buffer;
    var limit = buffer ? buffer.length : 0;
    var pos = this.bufferLength;

    while (true) {
      var code1 = this.getCode(litCodeTable);

      if (code1 < 256) {
        if (pos + 1 >= limit) {
          buffer = this.ensureBuffer(pos + 1);
          limit = buffer.length;
        }

        buffer[pos++] = code1;
        continue;
      }

      if (code1 === 256) {
        this.bufferLength = pos;
        return;
      }

      code1 -= 257;
      code1 = lengthDecode[code1];
      var code2 = code1 >> 16;

      if (code2 > 0) {
        code2 = this.getBits(code2);
      }

      len = (code1 & 0xffff) + code2;
      code1 = this.getCode(distCodeTable);
      code1 = distDecode[code1];
      code2 = code1 >> 16;

      if (code2 > 0) {
        code2 = this.getBits(code2);
      }

      var dist = (code1 & 0xffff) + code2;

      if (pos + len >= limit) {
        buffer = this.ensureBuffer(pos + len);
        limit = buffer.length;
      }

      for (var k = 0; k < len; ++k, ++pos) {
        buffer[pos] = buffer[pos - dist];
      }
    }
  };

  return FlateStream;
}();

exports.FlateStream = FlateStream;

var PredictorStream = function PredictorStreamClosure() {
  function PredictorStream(str, maybeLength, params) {
    if (!(0, _primitives.isDict)(params)) {
      return str;
    }

    var predictor = this.predictor = params.get('Predictor') || 1;

    if (predictor <= 1) {
      return str;
    }

    if (predictor !== 2 && (predictor < 10 || predictor > 15)) {
      throw new _util.FormatError("Unsupported predictor: ".concat(predictor));
    }

    if (predictor === 2) {
      this.readBlock = this.readBlockTiff;
    } else {
      this.readBlock = this.readBlockPng;
    }

    this.str = str;
    this.dict = str.dict;
    var colors = this.colors = params.get('Colors') || 1;
    var bits = this.bits = params.get('BitsPerComponent') || 8;
    var columns = this.columns = params.get('Columns') || 1;
    this.pixBytes = colors * bits + 7 >> 3;
    this.rowBytes = columns * colors * bits + 7 >> 3;
    DecodeStream.call(this, maybeLength);
    return this;
  }

  PredictorStream.prototype = Object.create(DecodeStream.prototype);

  PredictorStream.prototype.readBlockTiff = function predictorStreamReadBlockTiff() {
    var rowBytes = this.rowBytes;
    var bufferLength = this.bufferLength;
    var buffer = this.ensureBuffer(bufferLength + rowBytes);
    var bits = this.bits;
    var colors = this.colors;
    var rawBytes = this.str.getBytes(rowBytes);
    this.eof = !rawBytes.length;

    if (this.eof) {
      return;
    }

    var inbuf = 0,
        outbuf = 0;
    var inbits = 0,
        outbits = 0;
    var pos = bufferLength;
    var i;

    if (bits === 1 && colors === 1) {
      for (i = 0; i < rowBytes; ++i) {
        var c = rawBytes[i] ^ inbuf;
        c ^= c >> 1;
        c ^= c >> 2;
        c ^= c >> 4;
        inbuf = (c & 1) << 7;
        buffer[pos++] = c;
      }
    } else if (bits === 8) {
      for (i = 0; i < colors; ++i) {
        buffer[pos++] = rawBytes[i];
      }

      for (; i < rowBytes; ++i) {
        buffer[pos] = buffer[pos - colors] + rawBytes[i];
        pos++;
      }
    } else if (bits === 16) {
      var bytesPerPixel = colors * 2;

      for (i = 0; i < bytesPerPixel; ++i) {
        buffer[pos++] = rawBytes[i];
      }

      for (; i < rowBytes; i += 2) {
        var sum = ((rawBytes[i] & 0xFF) << 8) + (rawBytes[i + 1] & 0xFF) + ((buffer[pos - bytesPerPixel] & 0xFF) << 8) + (buffer[pos - bytesPerPixel + 1] & 0xFF);
        buffer[pos++] = sum >> 8 & 0xFF;
        buffer[pos++] = sum & 0xFF;
      }
    } else {
      var compArray = new Uint8Array(colors + 1);
      var bitMask = (1 << bits) - 1;
      var j = 0,
          k = bufferLength;
      var columns = this.columns;

      for (i = 0; i < columns; ++i) {
        for (var kk = 0; kk < colors; ++kk) {
          if (inbits < bits) {
            inbuf = inbuf << 8 | rawBytes[j++] & 0xFF;
            inbits += 8;
          }

          compArray[kk] = compArray[kk] + (inbuf >> inbits - bits) & bitMask;
          inbits -= bits;
          outbuf = outbuf << bits | compArray[kk];
          outbits += bits;

          if (outbits >= 8) {
            buffer[k++] = outbuf >> outbits - 8 & 0xFF;
            outbits -= 8;
          }
        }
      }

      if (outbits > 0) {
        buffer[k++] = (outbuf << 8 - outbits) + (inbuf & (1 << 8 - outbits) - 1);
      }
    }

    this.bufferLength += rowBytes;
  };

  PredictorStream.prototype.readBlockPng = function predictorStreamReadBlockPng() {
    var rowBytes = this.rowBytes;
    var pixBytes = this.pixBytes;
    var predictor = this.str.getByte();
    var rawBytes = this.str.getBytes(rowBytes);
    this.eof = !rawBytes.length;

    if (this.eof) {
      return;
    }

    var bufferLength = this.bufferLength;
    var buffer = this.ensureBuffer(bufferLength + rowBytes);
    var prevRow = buffer.subarray(bufferLength - rowBytes, bufferLength);

    if (prevRow.length === 0) {
      prevRow = new Uint8Array(rowBytes);
    }

    var i,
        j = bufferLength,
        up,
        c;

    switch (predictor) {
      case 0:
        for (i = 0; i < rowBytes; ++i) {
          buffer[j++] = rawBytes[i];
        }

        break;

      case 1:
        for (i = 0; i < pixBytes; ++i) {
          buffer[j++] = rawBytes[i];
        }

        for (; i < rowBytes; ++i) {
          buffer[j] = buffer[j - pixBytes] + rawBytes[i] & 0xFF;
          j++;
        }

        break;

      case 2:
        for (i = 0; i < rowBytes; ++i) {
          buffer[j++] = prevRow[i] + rawBytes[i] & 0xFF;
        }

        break;

      case 3:
        for (i = 0; i < pixBytes; ++i) {
          buffer[j++] = (prevRow[i] >> 1) + rawBytes[i];
        }

        for (; i < rowBytes; ++i) {
          buffer[j] = (prevRow[i] + buffer[j - pixBytes] >> 1) + rawBytes[i] & 0xFF;
          j++;
        }

        break;

      case 4:
        for (i = 0; i < pixBytes; ++i) {
          up = prevRow[i];
          c = rawBytes[i];
          buffer[j++] = up + c;
        }

        for (; i < rowBytes; ++i) {
          up = prevRow[i];
          var upLeft = prevRow[i - pixBytes];
          var left = buffer[j - pixBytes];
          var p = left + up - upLeft;
          var pa = p - left;

          if (pa < 0) {
            pa = -pa;
          }

          var pb = p - up;

          if (pb < 0) {
            pb = -pb;
          }

          var pc = p - upLeft;

          if (pc < 0) {
            pc = -pc;
          }

          c = rawBytes[i];

          if (pa <= pb && pa <= pc) {
            buffer[j++] = left + c;
          } else if (pb <= pc) {
            buffer[j++] = up + c;
          } else {
            buffer[j++] = upLeft + c;
          }
        }

        break;

      default:
        throw new _util.FormatError("Unsupported predictor: ".concat(predictor));
    }

    this.bufferLength += rowBytes;
  };

  return PredictorStream;
}();

exports.PredictorStream = PredictorStream;

var DecryptStream = function DecryptStreamClosure() {
  function DecryptStream(str, maybeLength, decrypt) {
    this.str = str;
    this.dict = str.dict;
    this.decrypt = decrypt;
    this.nextChunk = null;
    this.initialized = false;
    DecodeStream.call(this, maybeLength);
  }

  var chunkSize = 512;
  DecryptStream.prototype = Object.create(DecodeStream.prototype);

  DecryptStream.prototype.readBlock = function DecryptStream_readBlock() {
    var chunk;

    if (this.initialized) {
      chunk = this.nextChunk;
    } else {
      chunk = this.str.getBytes(chunkSize);
      this.initialized = true;
    }

    if (!chunk || chunk.length === 0) {
      this.eof = true;
      return;
    }

    this.nextChunk = this.str.getBytes(chunkSize);
    var hasMoreData = this.nextChunk && this.nextChunk.length > 0;
    var decrypt = this.decrypt;
    chunk = decrypt(chunk, !hasMoreData);
    var bufferLength = this.bufferLength;
    var i,
        n = chunk.length;
    var buffer = this.ensureBuffer(bufferLength + n);

    for (i = 0; i < n; i++) {
      buffer[bufferLength++] = chunk[i];
    }

    this.bufferLength = bufferLength;
  };

  return DecryptStream;
}();

exports.DecryptStream = DecryptStream;

var Ascii85Stream = function Ascii85StreamClosure() {
  function Ascii85Stream(str, maybeLength) {
    this.str = str;
    this.dict = str.dict;
    this.input = new Uint8Array(5);

    if (maybeLength) {
      maybeLength = 0.8 * maybeLength;
    }

    DecodeStream.call(this, maybeLength);
  }

  Ascii85Stream.prototype = Object.create(DecodeStream.prototype);

  Ascii85Stream.prototype.readBlock = function Ascii85Stream_readBlock() {
    var TILDA_CHAR = 0x7E;
    var Z_LOWER_CHAR = 0x7A;
    var EOF = -1;
    var str = this.str;
    var c = str.getByte();

    while ((0, _util.isSpace)(c)) {
      c = str.getByte();
    }

    if (c === EOF || c === TILDA_CHAR) {
      this.eof = true;
      return;
    }

    var bufferLength = this.bufferLength,
        buffer;
    var i;

    if (c === Z_LOWER_CHAR) {
      buffer = this.ensureBuffer(bufferLength + 4);

      for (i = 0; i < 4; ++i) {
        buffer[bufferLength + i] = 0;
      }

      this.bufferLength += 4;
    } else {
      var input = this.input;
      input[0] = c;

      for (i = 1; i < 5; ++i) {
        c = str.getByte();

        while ((0, _util.isSpace)(c)) {
          c = str.getByte();
        }

        input[i] = c;

        if (c === EOF || c === TILDA_CHAR) {
          break;
        }
      }

      buffer = this.ensureBuffer(bufferLength + i - 1);
      this.bufferLength += i - 1;

      if (i < 5) {
        for (; i < 5; ++i) {
          input[i] = 0x21 + 84;
        }

        this.eof = true;
      }

      var t = 0;

      for (i = 0; i < 5; ++i) {
        t = t * 85 + (input[i] - 0x21);
      }

      for (i = 3; i >= 0; --i) {
        buffer[bufferLength + i] = t & 0xFF;
        t >>= 8;
      }
    }
  };

  return Ascii85Stream;
}();

exports.Ascii85Stream = Ascii85Stream;

var AsciiHexStream = function AsciiHexStreamClosure() {
  function AsciiHexStream(str, maybeLength) {
    this.str = str;
    this.dict = str.dict;
    this.firstDigit = -1;

    if (maybeLength) {
      maybeLength = 0.5 * maybeLength;
    }

    DecodeStream.call(this, maybeLength);
  }

  AsciiHexStream.prototype = Object.create(DecodeStream.prototype);

  AsciiHexStream.prototype.readBlock = function AsciiHexStream_readBlock() {
    var UPSTREAM_BLOCK_SIZE = 8000;
    var bytes = this.str.getBytes(UPSTREAM_BLOCK_SIZE);

    if (!bytes.length) {
      this.eof = true;
      return;
    }

    var maxDecodeLength = bytes.length + 1 >> 1;
    var buffer = this.ensureBuffer(this.bufferLength + maxDecodeLength);
    var bufferLength = this.bufferLength;
    var firstDigit = this.firstDigit;

    for (var i = 0, ii = bytes.length; i < ii; i++) {
      var ch = bytes[i],
          digit;

      if (ch >= 0x30 && ch <= 0x39) {
        digit = ch & 0x0F;
      } else if (ch >= 0x41 && ch <= 0x46 || ch >= 0x61 && ch <= 0x66) {
        digit = (ch & 0x0F) + 9;
      } else if (ch === 0x3E) {
        this.eof = true;
        break;
      } else {
        continue;
      }

      if (firstDigit < 0) {
        firstDigit = digit;
      } else {
        buffer[bufferLength++] = firstDigit << 4 | digit;
        firstDigit = -1;
      }
    }

    if (firstDigit >= 0 && this.eof) {
      buffer[bufferLength++] = firstDigit << 4;
      firstDigit = -1;
    }

    this.firstDigit = firstDigit;
    this.bufferLength = bufferLength;
  };

  return AsciiHexStream;
}();

exports.AsciiHexStream = AsciiHexStream;

var RunLengthStream = function RunLengthStreamClosure() {
  function RunLengthStream(str, maybeLength) {
    this.str = str;
    this.dict = str.dict;
    DecodeStream.call(this, maybeLength);
  }

  RunLengthStream.prototype = Object.create(DecodeStream.prototype);

  RunLengthStream.prototype.readBlock = function RunLengthStream_readBlock() {
    var repeatHeader = this.str.getBytes(2);

    if (!repeatHeader || repeatHeader.length < 2 || repeatHeader[0] === 128) {
      this.eof = true;
      return;
    }

    var buffer;
    var bufferLength = this.bufferLength;
    var n = repeatHeader[0];

    if (n < 128) {
      buffer = this.ensureBuffer(bufferLength + n + 1);
      buffer[bufferLength++] = repeatHeader[1];

      if (n > 0) {
        var source = this.str.getBytes(n);
        buffer.set(source, bufferLength);
        bufferLength += n;
      }
    } else {
      n = 257 - n;
      var b = repeatHeader[1];
      buffer = this.ensureBuffer(bufferLength + n + 1);

      for (var i = 0; i < n; i++) {
        buffer[bufferLength++] = b;
      }
    }

    this.bufferLength = bufferLength;
  };

  return RunLengthStream;
}();

exports.RunLengthStream = RunLengthStream;

var LZWStream = function LZWStreamClosure() {
  function LZWStream(str, maybeLength, earlyChange) {
    this.str = str;
    this.dict = str.dict;
    this.cachedData = 0;
    this.bitsCached = 0;
    var maxLzwDictionarySize = 4096;
    var lzwState = {
      earlyChange: earlyChange,
      codeLength: 9,
      nextCode: 258,
      dictionaryValues: new Uint8Array(maxLzwDictionarySize),
      dictionaryLengths: new Uint16Array(maxLzwDictionarySize),
      dictionaryPrevCodes: new Uint16Array(maxLzwDictionarySize),
      currentSequence: new Uint8Array(maxLzwDictionarySize),
      currentSequenceLength: 0
    };

    for (var i = 0; i < 256; ++i) {
      lzwState.dictionaryValues[i] = i;
      lzwState.dictionaryLengths[i] = 1;
    }

    this.lzwState = lzwState;
    DecodeStream.call(this, maybeLength);
  }

  LZWStream.prototype = Object.create(DecodeStream.prototype);

  LZWStream.prototype.readBits = function LZWStream_readBits(n) {
    var bitsCached = this.bitsCached;
    var cachedData = this.cachedData;

    while (bitsCached < n) {
      var c = this.str.getByte();

      if (c === -1) {
        this.eof = true;
        return null;
      }

      cachedData = cachedData << 8 | c;
      bitsCached += 8;
    }

    this.bitsCached = bitsCached -= n;
    this.cachedData = cachedData;
    this.lastCode = null;
    return cachedData >>> bitsCached & (1 << n) - 1;
  };

  LZWStream.prototype.readBlock = function LZWStream_readBlock() {
    var blockSize = 512;
    var estimatedDecodedSize = blockSize * 2,
        decodedSizeDelta = blockSize;
    var i, j, q;
    var lzwState = this.lzwState;

    if (!lzwState) {
      return;
    }

    var earlyChange = lzwState.earlyChange;
    var nextCode = lzwState.nextCode;
    var dictionaryValues = lzwState.dictionaryValues;
    var dictionaryLengths = lzwState.dictionaryLengths;
    var dictionaryPrevCodes = lzwState.dictionaryPrevCodes;
    var codeLength = lzwState.codeLength;
    var prevCode = lzwState.prevCode;
    var currentSequence = lzwState.currentSequence;
    var currentSequenceLength = lzwState.currentSequenceLength;
    var decodedLength = 0;
    var currentBufferLength = this.bufferLength;
    var buffer = this.ensureBuffer(this.bufferLength + estimatedDecodedSize);

    for (i = 0; i < blockSize; i++) {
      var code = this.readBits(codeLength);
      var hasPrev = currentSequenceLength > 0;

      if (code < 256) {
        currentSequence[0] = code;
        currentSequenceLength = 1;
      } else if (code >= 258) {
        if (code < nextCode) {
          currentSequenceLength = dictionaryLengths[code];

          for (j = currentSequenceLength - 1, q = code; j >= 0; j--) {
            currentSequence[j] = dictionaryValues[q];
            q = dictionaryPrevCodes[q];
          }
        } else {
          currentSequence[currentSequenceLength++] = currentSequence[0];
        }
      } else if (code === 256) {
        codeLength = 9;
        nextCode = 258;
        currentSequenceLength = 0;
        continue;
      } else {
        this.eof = true;
        delete this.lzwState;
        break;
      }

      if (hasPrev) {
        dictionaryPrevCodes[nextCode] = prevCode;
        dictionaryLengths[nextCode] = dictionaryLengths[prevCode] + 1;
        dictionaryValues[nextCode] = currentSequence[0];
        nextCode++;
        codeLength = nextCode + earlyChange & nextCode + earlyChange - 1 ? codeLength : Math.min(Math.log(nextCode + earlyChange) / 0.6931471805599453 + 1, 12) | 0;
      }

      prevCode = code;
      decodedLength += currentSequenceLength;

      if (estimatedDecodedSize < decodedLength) {
        do {
          estimatedDecodedSize += decodedSizeDelta;
        } while (estimatedDecodedSize < decodedLength);

        buffer = this.ensureBuffer(this.bufferLength + estimatedDecodedSize);
      }

      for (j = 0; j < currentSequenceLength; j++) {
        buffer[currentBufferLength++] = currentSequence[j];
      }
    }

    lzwState.nextCode = nextCode;
    lzwState.codeLength = codeLength;
    lzwState.prevCode = prevCode;
    lzwState.currentSequenceLength = currentSequenceLength;
    this.bufferLength = currentBufferLength;
  };

  return LZWStream;
}();

exports.LZWStream = LZWStream;

var NullStream = function NullStreamClosure() {
  function NullStream() {
    Stream.call(this, new Uint8Array(0));
  }

  NullStream.prototype = Stream.prototype;
  return NullStream;
}();

exports.NullStream = NullStream;

/***/ }),
/* 158 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CCITTFaxStream = void 0;

var _primitives = __w_pdfjs_require__(155);

var _ccitt = __w_pdfjs_require__(159);

var _stream = __w_pdfjs_require__(157);

var CCITTFaxStream = function CCITTFaxStreamClosure() {
  function CCITTFaxStream(str, maybeLength, params) {
    this.str = str;
    this.dict = str.dict;

    if (!(0, _primitives.isDict)(params)) {
      params = _primitives.Dict.empty;
    }

    var source = {
      next: function next() {
        return str.getByte();
      }
    };
    this.ccittFaxDecoder = new _ccitt.CCITTFaxDecoder(source, {
      K: params.get('K'),
      EndOfLine: params.get('EndOfLine'),
      EncodedByteAlign: params.get('EncodedByteAlign'),
      Columns: params.get('Columns'),
      Rows: params.get('Rows'),
      EndOfBlock: params.get('EndOfBlock'),
      BlackIs1: params.get('BlackIs1')
    });

    _stream.DecodeStream.call(this, maybeLength);
  }

  CCITTFaxStream.prototype = Object.create(_stream.DecodeStream.prototype);

  CCITTFaxStream.prototype.readBlock = function () {
    while (!this.eof) {
      var c = this.ccittFaxDecoder.readNextChar();

      if (c === -1) {
        this.eof = true;
        return;
      }

      this.ensureBuffer(this.bufferLength + 1);
      this.buffer[this.bufferLength++] = c;
    }
  };

  return CCITTFaxStream;
}();

exports.CCITTFaxStream = CCITTFaxStream;

/***/ }),
/* 159 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CCITTFaxDecoder = void 0;

var _util = __w_pdfjs_require__(6);

var CCITTFaxDecoder = function CCITTFaxDecoder() {
  var ccittEOL = -2;
  var ccittEOF = -1;
  var twoDimPass = 0;
  var twoDimHoriz = 1;
  var twoDimVert0 = 2;
  var twoDimVertR1 = 3;
  var twoDimVertL1 = 4;
  var twoDimVertR2 = 5;
  var twoDimVertL2 = 6;
  var twoDimVertR3 = 7;
  var twoDimVertL3 = 8;
  var twoDimTable = [[-1, -1], [-1, -1], [7, twoDimVertL3], [7, twoDimVertR3], [6, twoDimVertL2], [6, twoDimVertL2], [6, twoDimVertR2], [6, twoDimVertR2], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0]];
  var whiteTable1 = [[-1, -1], [12, ccittEOL], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [11, 1792], [11, 1792], [12, 1984], [12, 2048], [12, 2112], [12, 2176], [12, 2240], [12, 2304], [11, 1856], [11, 1856], [11, 1920], [11, 1920], [12, 2368], [12, 2432], [12, 2496], [12, 2560]];
  var whiteTable2 = [[-1, -1], [-1, -1], [-1, -1], [-1, -1], [8, 29], [8, 29], [8, 30], [8, 30], [8, 45], [8, 45], [8, 46], [8, 46], [7, 22], [7, 22], [7, 22], [7, 22], [7, 23], [7, 23], [7, 23], [7, 23], [8, 47], [8, 47], [8, 48], [8, 48], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [7, 20], [7, 20], [7, 20], [7, 20], [8, 33], [8, 33], [8, 34], [8, 34], [8, 35], [8, 35], [8, 36], [8, 36], [8, 37], [8, 37], [8, 38], [8, 38], [7, 19], [7, 19], [7, 19], [7, 19], [8, 31], [8, 31], [8, 32], [8, 32], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [8, 53], [8, 53], [8, 54], [8, 54], [7, 26], [7, 26], [7, 26], [7, 26], [8, 39], [8, 39], [8, 40], [8, 40], [8, 41], [8, 41], [8, 42], [8, 42], [8, 43], [8, 43], [8, 44], [8, 44], [7, 21], [7, 21], [7, 21], [7, 21], [7, 28], [7, 28], [7, 28], [7, 28], [8, 61], [8, 61], [8, 62], [8, 62], [8, 63], [8, 63], [8, 0], [8, 0], [8, 320], [8, 320], [8, 384], [8, 384], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [7, 27], [7, 27], [7, 27], [7, 27], [8, 59], [8, 59], [8, 60], [8, 60], [9, 1472], [9, 1536], [9, 1600], [9, 1728], [7, 18], [7, 18], [7, 18], [7, 18], [7, 24], [7, 24], [7, 24], [7, 24], [8, 49], [8, 49], [8, 50], [8, 50], [8, 51], [8, 51], [8, 52], [8, 52], [7, 25], [7, 25], [7, 25], [7, 25], [8, 55], [8, 55], [8, 56], [8, 56], [8, 57], [8, 57], [8, 58], [8, 58], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [8, 448], [8, 448], [8, 512], [8, 512], [9, 704], [9, 768], [8, 640], [8, 640], [8, 576], [8, 576], [9, 832], [9, 896], [9, 960], [9, 1024], [9, 1088], [9, 1152], [9, 1216], [9, 1280], [9, 1344], [9, 1408], [7, 256], [7, 256], [7, 256], [7, 256], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7]];
  var blackTable1 = [[-1, -1], [-1, -1], [12, ccittEOL], [12, ccittEOL], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [11, 1792], [11, 1792], [11, 1792], [11, 1792], [12, 1984], [12, 1984], [12, 2048], [12, 2048], [12, 2112], [12, 2112], [12, 2176], [12, 2176], [12, 2240], [12, 2240], [12, 2304], [12, 2304], [11, 1856], [11, 1856], [11, 1856], [11, 1856], [11, 1920], [11, 1920], [11, 1920], [11, 1920], [12, 2368], [12, 2368], [12, 2432], [12, 2432], [12, 2496], [12, 2496], [12, 2560], [12, 2560], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [12, 52], [12, 52], [13, 640], [13, 704], [13, 768], [13, 832], [12, 55], [12, 55], [12, 56], [12, 56], [13, 1280], [13, 1344], [13, 1408], [13, 1472], [12, 59], [12, 59], [12, 60], [12, 60], [13, 1536], [13, 1600], [11, 24], [11, 24], [11, 24], [11, 24], [11, 25], [11, 25], [11, 25], [11, 25], [13, 1664], [13, 1728], [12, 320], [12, 320], [12, 384], [12, 384], [12, 448], [12, 448], [13, 512], [13, 576], [12, 53], [12, 53], [12, 54], [12, 54], [13, 896], [13, 960], [13, 1024], [13, 1088], [13, 1152], [13, 1216], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64]];
  var blackTable2 = [[8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [11, 23], [11, 23], [12, 50], [12, 51], [12, 44], [12, 45], [12, 46], [12, 47], [12, 57], [12, 58], [12, 61], [12, 256], [10, 16], [10, 16], [10, 16], [10, 16], [10, 17], [10, 17], [10, 17], [10, 17], [12, 48], [12, 49], [12, 62], [12, 63], [12, 30], [12, 31], [12, 32], [12, 33], [12, 40], [12, 41], [11, 22], [11, 22], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [12, 128], [12, 192], [12, 26], [12, 27], [12, 28], [12, 29], [11, 19], [11, 19], [11, 20], [11, 20], [12, 34], [12, 35], [12, 36], [12, 37], [12, 38], [12, 39], [11, 21], [11, 21], [12, 42], [12, 43], [10, 0], [10, 0], [10, 0], [10, 0], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12]];
  var blackTable3 = [[-1, -1], [-1, -1], [-1, -1], [-1, -1], [6, 9], [6, 8], [5, 7], [5, 7], [4, 6], [4, 6], [4, 6], [4, 6], [4, 5], [4, 5], [4, 5], [4, 5], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2]];

  function CCITTFaxDecoder(source) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (!source || typeof source.next !== 'function') {
      throw new Error('CCITTFaxDecoder - invalid "source" parameter.');
    }

    this.source = source;
    this.eof = false;
    this.encoding = options['K'] || 0;
    this.eoline = options['EndOfLine'] || false;
    this.byteAlign = options['EncodedByteAlign'] || false;
    this.columns = options['Columns'] || 1728;
    this.rows = options['Rows'] || 0;
    var eoblock = options['EndOfBlock'];

    if (eoblock === null || eoblock === undefined) {
      eoblock = true;
    }

    this.eoblock = eoblock;
    this.black = options['BlackIs1'] || false;
    this.codingLine = new Uint32Array(this.columns + 1);
    this.refLine = new Uint32Array(this.columns + 2);
    this.codingLine[0] = this.columns;
    this.codingPos = 0;
    this.row = 0;
    this.nextLine2D = this.encoding < 0;
    this.inputBits = 0;
    this.inputBuf = 0;
    this.outputBits = 0;
    this.rowsDone = false;
    var code1;

    while ((code1 = this._lookBits(12)) === 0) {
      this._eatBits(1);
    }

    if (code1 === 1) {
      this._eatBits(12);
    }

    if (this.encoding > 0) {
      this.nextLine2D = !this._lookBits(1);

      this._eatBits(1);
    }
  }

  CCITTFaxDecoder.prototype = {
    readNextChar: function readNextChar() {
      if (this.eof) {
        return -1;
      }

      var refLine = this.refLine;
      var codingLine = this.codingLine;
      var columns = this.columns;
      var refPos, blackPixels, bits, i;

      if (this.outputBits === 0) {
        if (this.rowsDone) {
          this.eof = true;
        }

        if (this.eof) {
          return -1;
        }

        this.err = false;
        var code1, code2, code3;

        if (this.nextLine2D) {
          for (i = 0; codingLine[i] < columns; ++i) {
            refLine[i] = codingLine[i];
          }

          refLine[i++] = columns;
          refLine[i] = columns;
          codingLine[0] = 0;
          this.codingPos = 0;
          refPos = 0;
          blackPixels = 0;

          while (codingLine[this.codingPos] < columns) {
            code1 = this._getTwoDimCode();

            switch (code1) {
              case twoDimPass:
                this._addPixels(refLine[refPos + 1], blackPixels);

                if (refLine[refPos + 1] < columns) {
                  refPos += 2;
                }

                break;

              case twoDimHoriz:
                code1 = code2 = 0;

                if (blackPixels) {
                  do {
                    code1 += code3 = this._getBlackCode();
                  } while (code3 >= 64);

                  do {
                    code2 += code3 = this._getWhiteCode();
                  } while (code3 >= 64);
                } else {
                  do {
                    code1 += code3 = this._getWhiteCode();
                  } while (code3 >= 64);

                  do {
                    code2 += code3 = this._getBlackCode();
                  } while (code3 >= 64);
                }

                this._addPixels(codingLine[this.codingPos] + code1, blackPixels);

                if (codingLine[this.codingPos] < columns) {
                  this._addPixels(codingLine[this.codingPos] + code2, blackPixels ^ 1);
                }

                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                  refPos += 2;
                }

                break;

              case twoDimVertR3:
                this._addPixels(refLine[refPos] + 3, blackPixels);

                blackPixels ^= 1;

                if (codingLine[this.codingPos] < columns) {
                  ++refPos;

                  while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                    refPos += 2;
                  }
                }

                break;

              case twoDimVertR2:
                this._addPixels(refLine[refPos] + 2, blackPixels);

                blackPixels ^= 1;

                if (codingLine[this.codingPos] < columns) {
                  ++refPos;

                  while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                    refPos += 2;
                  }
                }

                break;

              case twoDimVertR1:
                this._addPixels(refLine[refPos] + 1, blackPixels);

                blackPixels ^= 1;

                if (codingLine[this.codingPos] < columns) {
                  ++refPos;

                  while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                    refPos += 2;
                  }
                }

                break;

              case twoDimVert0:
                this._addPixels(refLine[refPos], blackPixels);

                blackPixels ^= 1;

                if (codingLine[this.codingPos] < columns) {
                  ++refPos;

                  while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                    refPos += 2;
                  }
                }

                break;

              case twoDimVertL3:
                this._addPixelsNeg(refLine[refPos] - 3, blackPixels);

                blackPixels ^= 1;

                if (codingLine[this.codingPos] < columns) {
                  if (refPos > 0) {
                    --refPos;
                  } else {
                    ++refPos;
                  }

                  while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                    refPos += 2;
                  }
                }

                break;

              case twoDimVertL2:
                this._addPixelsNeg(refLine[refPos] - 2, blackPixels);

                blackPixels ^= 1;

                if (codingLine[this.codingPos] < columns) {
                  if (refPos > 0) {
                    --refPos;
                  } else {
                    ++refPos;
                  }

                  while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                    refPos += 2;
                  }
                }

                break;

              case twoDimVertL1:
                this._addPixelsNeg(refLine[refPos] - 1, blackPixels);

                blackPixels ^= 1;

                if (codingLine[this.codingPos] < columns) {
                  if (refPos > 0) {
                    --refPos;
                  } else {
                    ++refPos;
                  }

                  while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
                    refPos += 2;
                  }
                }

                break;

              case ccittEOF:
                this._addPixels(columns, 0);

                this.eof = true;
                break;

              default:
                (0, _util.info)('bad 2d code');

                this._addPixels(columns, 0);

                this.err = true;
            }
          }
        } else {
          codingLine[0] = 0;
          this.codingPos = 0;
          blackPixels = 0;

          while (codingLine[this.codingPos] < columns) {
            code1 = 0;

            if (blackPixels) {
              do {
                code1 += code3 = this._getBlackCode();
              } while (code3 >= 64);
            } else {
              do {
                code1 += code3 = this._getWhiteCode();
              } while (code3 >= 64);
            }

            this._addPixels(codingLine[this.codingPos] + code1, blackPixels);

            blackPixels ^= 1;
          }
        }

        var gotEOL = false;

        if (this.byteAlign) {
          this.inputBits &= ~7;
        }

        if (!this.eoblock && this.row === this.rows - 1) {
          this.rowsDone = true;
        } else {
          code1 = this._lookBits(12);

          if (this.eoline) {
            while (code1 !== ccittEOF && code1 !== 1) {
              this._eatBits(1);

              code1 = this._lookBits(12);
            }
          } else {
            while (code1 === 0) {
              this._eatBits(1);

              code1 = this._lookBits(12);
            }
          }

          if (code1 === 1) {
            this._eatBits(12);

            gotEOL = true;
          } else if (code1 === ccittEOF) {
            this.eof = true;
          }
        }

        if (!this.eof && this.encoding > 0 && !this.rowsDone) {
          this.nextLine2D = !this._lookBits(1);

          this._eatBits(1);
        }

        if (this.eoblock && gotEOL && this.byteAlign) {
          code1 = this._lookBits(12);

          if (code1 === 1) {
            this._eatBits(12);

            if (this.encoding > 0) {
              this._lookBits(1);

              this._eatBits(1);
            }

            if (this.encoding >= 0) {
              for (i = 0; i < 4; ++i) {
                code1 = this._lookBits(12);

                if (code1 !== 1) {
                  (0, _util.info)('bad rtc code: ' + code1);
                }

                this._eatBits(12);

                if (this.encoding > 0) {
                  this._lookBits(1);

                  this._eatBits(1);
                }
              }
            }

            this.eof = true;
          }
        } else if (this.err && this.eoline) {
          while (true) {
            code1 = this._lookBits(13);

            if (code1 === ccittEOF) {
              this.eof = true;
              return -1;
            }

            if (code1 >> 1 === 1) {
              break;
            }

            this._eatBits(1);
          }

          this._eatBits(12);

          if (this.encoding > 0) {
            this._eatBits(1);

            this.nextLine2D = !(code1 & 1);
          }
        }

        if (codingLine[0] > 0) {
          this.outputBits = codingLine[this.codingPos = 0];
        } else {
          this.outputBits = codingLine[this.codingPos = 1];
        }

        this.row++;
      }

      var c;

      if (this.outputBits >= 8) {
        c = this.codingPos & 1 ? 0 : 0xFF;
        this.outputBits -= 8;

        if (this.outputBits === 0 && codingLine[this.codingPos] < columns) {
          this.codingPos++;
          this.outputBits = codingLine[this.codingPos] - codingLine[this.codingPos - 1];
        }
      } else {
        bits = 8;
        c = 0;

        do {
          if (this.outputBits > bits) {
            c <<= bits;

            if (!(this.codingPos & 1)) {
              c |= 0xFF >> 8 - bits;
            }

            this.outputBits -= bits;
            bits = 0;
          } else {
            c <<= this.outputBits;

            if (!(this.codingPos & 1)) {
              c |= 0xFF >> 8 - this.outputBits;
            }

            bits -= this.outputBits;
            this.outputBits = 0;

            if (codingLine[this.codingPos] < columns) {
              this.codingPos++;
              this.outputBits = codingLine[this.codingPos] - codingLine[this.codingPos - 1];
            } else if (bits > 0) {
              c <<= bits;
              bits = 0;
            }
          }
        } while (bits);
      }

      if (this.black) {
        c ^= 0xFF;
      }

      return c;
    },
    _addPixels: function _addPixels(a1, blackPixels) {
      var codingLine = this.codingLine;
      var codingPos = this.codingPos;

      if (a1 > codingLine[codingPos]) {
        if (a1 > this.columns) {
          (0, _util.info)('row is wrong length');
          this.err = true;
          a1 = this.columns;
        }

        if (codingPos & 1 ^ blackPixels) {
          ++codingPos;
        }

        codingLine[codingPos] = a1;
      }

      this.codingPos = codingPos;
    },
    _addPixelsNeg: function _addPixelsNeg(a1, blackPixels) {
      var codingLine = this.codingLine;
      var codingPos = this.codingPos;

      if (a1 > codingLine[codingPos]) {
        if (a1 > this.columns) {
          (0, _util.info)('row is wrong length');
          this.err = true;
          a1 = this.columns;
        }

        if (codingPos & 1 ^ blackPixels) {
          ++codingPos;
        }

        codingLine[codingPos] = a1;
      } else if (a1 < codingLine[codingPos]) {
        if (a1 < 0) {
          (0, _util.info)('invalid code');
          this.err = true;
          a1 = 0;
        }

        while (codingPos > 0 && a1 < codingLine[codingPos - 1]) {
          --codingPos;
        }

        codingLine[codingPos] = a1;
      }

      this.codingPos = codingPos;
    },
    _findTableCode: function _findTableCode(start, end, table, limit) {
      var limitValue = limit || 0;

      for (var i = start; i <= end; ++i) {
        var code = this._lookBits(i);

        if (code === ccittEOF) {
          return [true, 1, false];
        }

        if (i < end) {
          code <<= end - i;
        }

        if (!limitValue || code >= limitValue) {
          var p = table[code - limitValue];

          if (p[0] === i) {
            this._eatBits(i);

            return [true, p[1], true];
          }
        }
      }

      return [false, 0, false];
    },
    _getTwoDimCode: function _getTwoDimCode() {
      var code = 0;
      var p;

      if (this.eoblock) {
        code = this._lookBits(7);
        p = twoDimTable[code];

        if (p && p[0] > 0) {
          this._eatBits(p[0]);

          return p[1];
        }
      } else {
        var result = this._findTableCode(1, 7, twoDimTable);

        if (result[0] && result[2]) {
          return result[1];
        }
      }

      (0, _util.info)('Bad two dim code');
      return ccittEOF;
    },
    _getWhiteCode: function _getWhiteCode() {
      var code = 0;
      var p;

      if (this.eoblock) {
        code = this._lookBits(12);

        if (code === ccittEOF) {
          return 1;
        }

        if (code >> 5 === 0) {
          p = whiteTable1[code];
        } else {
          p = whiteTable2[code >> 3];
        }

        if (p[0] > 0) {
          this._eatBits(p[0]);

          return p[1];
        }
      } else {
        var result = this._findTableCode(1, 9, whiteTable2);

        if (result[0]) {
          return result[1];
        }

        result = this._findTableCode(11, 12, whiteTable1);

        if (result[0]) {
          return result[1];
        }
      }

      (0, _util.info)('bad white code');

      this._eatBits(1);

      return 1;
    },
    _getBlackCode: function _getBlackCode() {
      var code, p;

      if (this.eoblock) {
        code = this._lookBits(13);

        if (code === ccittEOF) {
          return 1;
        }

        if (code >> 7 === 0) {
          p = blackTable1[code];
        } else if (code >> 9 === 0 && code >> 7 !== 0) {
          p = blackTable2[(code >> 1) - 64];
        } else {
          p = blackTable3[code >> 7];
        }

        if (p[0] > 0) {
          this._eatBits(p[0]);

          return p[1];
        }
      } else {
        var result = this._findTableCode(2, 6, blackTable3);

        if (result[0]) {
          return result[1];
        }

        result = this._findTableCode(7, 12, blackTable2, 64);

        if (result[0]) {
          return result[1];
        }

        result = this._findTableCode(10, 13, blackTable1);

        if (result[0]) {
          return result[1];
        }
      }

      (0, _util.info)('bad black code');

      this._eatBits(1);

      return 1;
    },
    _lookBits: function _lookBits(n) {
      var c;

      while (this.inputBits < n) {
        if ((c = this.source.next()) === -1) {
          if (this.inputBits === 0) {
            return ccittEOF;
          }

          return this.inputBuf << n - this.inputBits & 0xFFFF >> 16 - n;
        }

        this.inputBuf = this.inputBuf << 8 | c;
        this.inputBits += 8;
      }

      return this.inputBuf >> this.inputBits - n & 0xFFFF >> 16 - n;
    },
    _eatBits: function _eatBits(n) {
      if ((this.inputBits -= n) < 0) {
        this.inputBits = 0;
      }
    }
  };
  return CCITTFaxDecoder;
}();

exports.CCITTFaxDecoder = CCITTFaxDecoder;

/***/ }),
/* 160 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Jbig2Stream = void 0;

var _primitives = __w_pdfjs_require__(155);

var _stream = __w_pdfjs_require__(157);

var _jbig = __w_pdfjs_require__(161);

var _util = __w_pdfjs_require__(6);

var Jbig2Stream = function Jbig2StreamClosure() {
  function Jbig2Stream(stream, maybeLength, dict, params) {
    this.stream = stream;
    this.maybeLength = maybeLength;
    this.dict = dict;
    this.params = params;

    _stream.DecodeStream.call(this, maybeLength);
  }

  Jbig2Stream.prototype = Object.create(_stream.DecodeStream.prototype);
  Object.defineProperty(Jbig2Stream.prototype, 'bytes', {
    get: function get() {
      return (0, _util.shadow)(this, 'bytes', this.stream.getBytes(this.maybeLength));
    },
    configurable: true
  });

  Jbig2Stream.prototype.ensureBuffer = function (requested) {};

  Jbig2Stream.prototype.readBlock = function () {
    if (this.eof) {
      return;
    }

    var jbig2Image = new _jbig.Jbig2Image();
    var chunks = [];

    if ((0, _primitives.isDict)(this.params)) {
      var globalsStream = this.params.get('JBIG2Globals');

      if ((0, _primitives.isStream)(globalsStream)) {
        var globals = globalsStream.getBytes();
        chunks.push({
          data: globals,
          start: 0,
          end: globals.length
        });
      }
    }

    chunks.push({
      data: this.bytes,
      start: 0,
      end: this.bytes.length
    });
    var data = jbig2Image.parseChunks(chunks);
    var dataLength = data.length;

    for (var i = 0; i < dataLength; i++) {
      data[i] ^= 0xFF;
    }

    this.buffer = data;
    this.bufferLength = dataLength;
    this.eof = true;
  };

  return Jbig2Stream;
}();

exports.Jbig2Stream = Jbig2Stream;

/***/ }),
/* 161 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Jbig2Image = void 0;

var _util = __w_pdfjs_require__(6);

var _arithmetic_decoder = __w_pdfjs_require__(162);

var _ccitt = __w_pdfjs_require__(159);

var Jbig2Error = function Jbig2ErrorClosure() {
  function Jbig2Error(msg) {
    this.message = 'JBIG2 error: ' + msg;
  }

  Jbig2Error.prototype = new Error();
  Jbig2Error.prototype.name = 'Jbig2Error';
  Jbig2Error.constructor = Jbig2Error;
  return Jbig2Error;
}();

var Jbig2Image = function Jbig2ImageClosure() {
  function ContextCache() {}

  ContextCache.prototype = {
    getContexts: function getContexts(id) {
      if (id in this) {
        return this[id];
      }

      return this[id] = new Int8Array(1 << 16);
    }
  };

  function DecodingContext(data, start, end) {
    this.data = data;
    this.start = start;
    this.end = end;
  }

  DecodingContext.prototype = {
    get decoder() {
      var decoder = new _arithmetic_decoder.ArithmeticDecoder(this.data, this.start, this.end);
      return (0, _util.shadow)(this, 'decoder', decoder);
    },

    get contextCache() {
      var cache = new ContextCache();
      return (0, _util.shadow)(this, 'contextCache', cache);
    }

  };

  function decodeInteger(contextCache, procedure, decoder) {
    var contexts = contextCache.getContexts(procedure);
    var prev = 1;

    function readBits(length) {
      var v = 0;

      for (var i = 0; i < length; i++) {
        var bit = decoder.readBit(contexts, prev);
        prev = prev < 256 ? prev << 1 | bit : (prev << 1 | bit) & 511 | 256;
        v = v << 1 | bit;
      }

      return v >>> 0;
    }

    var sign = readBits(1);
    var value = readBits(1) ? readBits(1) ? readBits(1) ? readBits(1) ? readBits(1) ? readBits(32) + 4436 : readBits(12) + 340 : readBits(8) + 84 : readBits(6) + 20 : readBits(4) + 4 : readBits(2);
    return sign === 0 ? value : value > 0 ? -value : null;
  }

  function decodeIAID(contextCache, decoder, codeLength) {
    var contexts = contextCache.getContexts('IAID');
    var prev = 1;

    for (var i = 0; i < codeLength; i++) {
      var bit = decoder.readBit(contexts, prev);
      prev = prev << 1 | bit;
    }

    if (codeLength < 31) {
      return prev & (1 << codeLength) - 1;
    }

    return prev & 0x7FFFFFFF;
  }

  var SegmentTypes = ['SymbolDictionary', null, null, null, 'IntermediateTextRegion', null, 'ImmediateTextRegion', 'ImmediateLosslessTextRegion', null, null, null, null, null, null, null, null, 'PatternDictionary', null, null, null, 'IntermediateHalftoneRegion', null, 'ImmediateHalftoneRegion', 'ImmediateLosslessHalftoneRegion', null, null, null, null, null, null, null, null, null, null, null, null, 'IntermediateGenericRegion', null, 'ImmediateGenericRegion', 'ImmediateLosslessGenericRegion', 'IntermediateGenericRefinementRegion', null, 'ImmediateGenericRefinementRegion', 'ImmediateLosslessGenericRefinementRegion', null, null, null, null, 'PageInformation', 'EndOfPage', 'EndOfStripe', 'EndOfFile', 'Profiles', 'Tables', null, null, null, null, null, null, null, null, 'Extension'];
  var CodingTemplates = [[{
    x: -1,
    y: -2
  }, {
    x: 0,
    y: -2
  }, {
    x: 1,
    y: -2
  }, {
    x: -2,
    y: -1
  }, {
    x: -1,
    y: -1
  }, {
    x: 0,
    y: -1
  }, {
    x: 1,
    y: -1
  }, {
    x: 2,
    y: -1
  }, {
    x: -4,
    y: 0
  }, {
    x: -3,
    y: 0
  }, {
    x: -2,
    y: 0
  }, {
    x: -1,
    y: 0
  }], [{
    x: -1,
    y: -2
  }, {
    x: 0,
    y: -2
  }, {
    x: 1,
    y: -2
  }, {
    x: 2,
    y: -2
  }, {
    x: -2,
    y: -1
  }, {
    x: -1,
    y: -1
  }, {
    x: 0,
    y: -1
  }, {
    x: 1,
    y: -1
  }, {
    x: 2,
    y: -1
  }, {
    x: -3,
    y: 0
  }, {
    x: -2,
    y: 0
  }, {
    x: -1,
    y: 0
  }], [{
    x: -1,
    y: -2
  }, {
    x: 0,
    y: -2
  }, {
    x: 1,
    y: -2
  }, {
    x: -2,
    y: -1
  }, {
    x: -1,
    y: -1
  }, {
    x: 0,
    y: -1
  }, {
    x: 1,
    y: -1
  }, {
    x: -2,
    y: 0
  }, {
    x: -1,
    y: 0
  }], [{
    x: -3,
    y: -1
  }, {
    x: -2,
    y: -1
  }, {
    x: -1,
    y: -1
  }, {
    x: 0,
    y: -1
  }, {
    x: 1,
    y: -1
  }, {
    x: -4,
    y: 0
  }, {
    x: -3,
    y: 0
  }, {
    x: -2,
    y: 0
  }, {
    x: -1,
    y: 0
  }]];
  var RefinementTemplates = [{
    coding: [{
      x: 0,
      y: -1
    }, {
      x: 1,
      y: -1
    }, {
      x: -1,
      y: 0
    }],
    reference: [{
      x: 0,
      y: -1
    }, {
      x: 1,
      y: -1
    }, {
      x: -1,
      y: 0
    }, {
      x: 0,
      y: 0
    }, {
      x: 1,
      y: 0
    }, {
      x: -1,
      y: 1
    }, {
      x: 0,
      y: 1
    }, {
      x: 1,
      y: 1
    }]
  }, {
    coding: [{
      x: -1,
      y: -1
    }, {
      x: 0,
      y: -1
    }, {
      x: 1,
      y: -1
    }, {
      x: -1,
      y: 0
    }],
    reference: [{
      x: 0,
      y: -1
    }, {
      x: -1,
      y: 0
    }, {
      x: 0,
      y: 0
    }, {
      x: 1,
      y: 0
    }, {
      x: 0,
      y: 1
    }, {
      x: 1,
      y: 1
    }]
  }];
  var ReusedContexts = [0x9B25, 0x0795, 0x00E5, 0x0195];
  var RefinementReusedContexts = [0x0020, 0x0008];

  function decodeBitmapTemplate0(width, height, decodingContext) {
    var decoder = decodingContext.decoder;
    var contexts = decodingContext.contextCache.getContexts('GB');
    var contextLabel,
        i,
        j,
        pixel,
        row,
        row1,
        row2,
        bitmap = [];
    var OLD_PIXEL_MASK = 0x7BF7;

    for (i = 0; i < height; i++) {
      row = bitmap[i] = new Uint8Array(width);
      row1 = i < 1 ? row : bitmap[i - 1];
      row2 = i < 2 ? row : bitmap[i - 2];
      contextLabel = row2[0] << 13 | row2[1] << 12 | row2[2] << 11 | row1[0] << 7 | row1[1] << 6 | row1[2] << 5 | row1[3] << 4;

      for (j = 0; j < width; j++) {
        row[j] = pixel = decoder.readBit(contexts, contextLabel);
        contextLabel = (contextLabel & OLD_PIXEL_MASK) << 1 | (j + 3 < width ? row2[j + 3] << 11 : 0) | (j + 4 < width ? row1[j + 4] << 4 : 0) | pixel;
      }
    }

    return bitmap;
  }

  function decodeBitmap(mmr, width, height, templateIndex, prediction, skip, at, decodingContext) {
    if (mmr) {
      var input = new Reader(decodingContext.data, decodingContext.start, decodingContext.end);
      return decodeMMRBitmap(input, width, height, false);
    }

    if (templateIndex === 0 && !skip && !prediction && at.length === 4 && at[0].x === 3 && at[0].y === -1 && at[1].x === -3 && at[1].y === -1 && at[2].x === 2 && at[2].y === -2 && at[3].x === -2 && at[3].y === -2) {
      return decodeBitmapTemplate0(width, height, decodingContext);
    }

    var useskip = !!skip;
    var template = CodingTemplates[templateIndex].concat(at);
    template.sort(function (a, b) {
      return a.y - b.y || a.x - b.x;
    });
    var templateLength = template.length;
    var templateX = new Int8Array(templateLength);
    var templateY = new Int8Array(templateLength);
    var changingTemplateEntries = [];
    var reuseMask = 0,
        minX = 0,
        maxX = 0,
        minY = 0;
    var c, k;

    for (k = 0; k < templateLength; k++) {
      templateX[k] = template[k].x;
      templateY[k] = template[k].y;
      minX = Math.min(minX, template[k].x);
      maxX = Math.max(maxX, template[k].x);
      minY = Math.min(minY, template[k].y);

      if (k < templateLength - 1 && template[k].y === template[k + 1].y && template[k].x === template[k + 1].x - 1) {
        reuseMask |= 1 << templateLength - 1 - k;
      } else {
        changingTemplateEntries.push(k);
      }
    }

    var changingEntriesLength = changingTemplateEntries.length;
    var changingTemplateX = new Int8Array(changingEntriesLength);
    var changingTemplateY = new Int8Array(changingEntriesLength);
    var changingTemplateBit = new Uint16Array(changingEntriesLength);

    for (c = 0; c < changingEntriesLength; c++) {
      k = changingTemplateEntries[c];
      changingTemplateX[c] = template[k].x;
      changingTemplateY[c] = template[k].y;
      changingTemplateBit[c] = 1 << templateLength - 1 - k;
    }

    var sbb_left = -minX;
    var sbb_top = -minY;
    var sbb_right = width - maxX;
    var pseudoPixelContext = ReusedContexts[templateIndex];
    var row = new Uint8Array(width);
    var bitmap = [];
    var decoder = decodingContext.decoder;
    var contexts = decodingContext.contextCache.getContexts('GB');
    var ltp = 0,
        j,
        i0,
        j0,
        contextLabel = 0,
        bit,
        shift;

    for (var i = 0; i < height; i++) {
      if (prediction) {
        var sltp = decoder.readBit(contexts, pseudoPixelContext);
        ltp ^= sltp;

        if (ltp) {
          bitmap.push(row);
          continue;
        }
      }

      row = new Uint8Array(row);
      bitmap.push(row);

      for (j = 0; j < width; j++) {
        if (useskip && skip[i][j]) {
          row[j] = 0;
          continue;
        }

        if (j >= sbb_left && j < sbb_right && i >= sbb_top) {
          contextLabel = contextLabel << 1 & reuseMask;

          for (k = 0; k < changingEntriesLength; k++) {
            i0 = i + changingTemplateY[k];
            j0 = j + changingTemplateX[k];
            bit = bitmap[i0][j0];

            if (bit) {
              bit = changingTemplateBit[k];
              contextLabel |= bit;
            }
          }
        } else {
          contextLabel = 0;
          shift = templateLength - 1;

          for (k = 0; k < templateLength; k++, shift--) {
            j0 = j + templateX[k];

            if (j0 >= 0 && j0 < width) {
              i0 = i + templateY[k];

              if (i0 >= 0) {
                bit = bitmap[i0][j0];

                if (bit) {
                  contextLabel |= bit << shift;
                }
              }
            }
          }
        }

        var pixel = decoder.readBit(contexts, contextLabel);
        row[j] = pixel;
      }
    }

    return bitmap;
  }

  function decodeRefinement(width, height, templateIndex, referenceBitmap, offsetX, offsetY, prediction, at, decodingContext) {
    var codingTemplate = RefinementTemplates[templateIndex].coding;

    if (templateIndex === 0) {
      codingTemplate = codingTemplate.concat([at[0]]);
    }

    var codingTemplateLength = codingTemplate.length;
    var codingTemplateX = new Int32Array(codingTemplateLength);
    var codingTemplateY = new Int32Array(codingTemplateLength);
    var k;

    for (k = 0; k < codingTemplateLength; k++) {
      codingTemplateX[k] = codingTemplate[k].x;
      codingTemplateY[k] = codingTemplate[k].y;
    }

    var referenceTemplate = RefinementTemplates[templateIndex].reference;

    if (templateIndex === 0) {
      referenceTemplate = referenceTemplate.concat([at[1]]);
    }

    var referenceTemplateLength = referenceTemplate.length;
    var referenceTemplateX = new Int32Array(referenceTemplateLength);
    var referenceTemplateY = new Int32Array(referenceTemplateLength);

    for (k = 0; k < referenceTemplateLength; k++) {
      referenceTemplateX[k] = referenceTemplate[k].x;
      referenceTemplateY[k] = referenceTemplate[k].y;
    }

    var referenceWidth = referenceBitmap[0].length;
    var referenceHeight = referenceBitmap.length;
    var pseudoPixelContext = RefinementReusedContexts[templateIndex];
    var bitmap = [];
    var decoder = decodingContext.decoder;
    var contexts = decodingContext.contextCache.getContexts('GR');
    var ltp = 0;

    for (var i = 0; i < height; i++) {
      if (prediction) {
        var sltp = decoder.readBit(contexts, pseudoPixelContext);
        ltp ^= sltp;

        if (ltp) {
          throw new Jbig2Error('prediction is not supported');
        }
      }

      var row = new Uint8Array(width);
      bitmap.push(row);

      for (var j = 0; j < width; j++) {
        var i0, j0;
        var contextLabel = 0;

        for (k = 0; k < codingTemplateLength; k++) {
          i0 = i + codingTemplateY[k];
          j0 = j + codingTemplateX[k];

          if (i0 < 0 || j0 < 0 || j0 >= width) {
            contextLabel <<= 1;
          } else {
            contextLabel = contextLabel << 1 | bitmap[i0][j0];
          }
        }

        for (k = 0; k < referenceTemplateLength; k++) {
          i0 = i + referenceTemplateY[k] - offsetY;
          j0 = j + referenceTemplateX[k] - offsetX;

          if (i0 < 0 || i0 >= referenceHeight || j0 < 0 || j0 >= referenceWidth) {
            contextLabel <<= 1;
          } else {
            contextLabel = contextLabel << 1 | referenceBitmap[i0][j0];
          }
        }

        var pixel = decoder.readBit(contexts, contextLabel);
        row[j] = pixel;
      }
    }

    return bitmap;
  }

  function decodeSymbolDictionary(huffman, refinement, symbols, numberOfNewSymbols, numberOfExportedSymbols, huffmanTables, templateIndex, at, refinementTemplateIndex, refinementAt, decodingContext, huffmanInput) {
    if (huffman && refinement) {
      throw new Jbig2Error('symbol refinement with Huffman is not supported');
    }

    var newSymbols = [];
    var currentHeight = 0;
    var symbolCodeLength = (0, _util.log2)(symbols.length + numberOfNewSymbols);
    var decoder = decodingContext.decoder;
    var contextCache = decodingContext.contextCache;
    var tableB1, symbolWidths;

    if (huffman) {
      tableB1 = getStandardTable(1);
      symbolWidths = [];
      symbolCodeLength = Math.max(symbolCodeLength, 1);
    }

    while (newSymbols.length < numberOfNewSymbols) {
      var deltaHeight = huffman ? huffmanTables.tableDeltaHeight.decode(huffmanInput) : decodeInteger(contextCache, 'IADH', decoder);
      currentHeight += deltaHeight;
      var currentWidth = 0,
          totalWidth = 0;
      var firstSymbol = huffman ? symbolWidths.length : 0;

      while (true) {
        var deltaWidth = huffman ? huffmanTables.tableDeltaWidth.decode(huffmanInput) : decodeInteger(contextCache, 'IADW', decoder);

        if (deltaWidth === null) {
          break;
        }

        currentWidth += deltaWidth;
        totalWidth += currentWidth;
        var bitmap;

        if (refinement) {
          var numberOfInstances = decodeInteger(contextCache, 'IAAI', decoder);

          if (numberOfInstances > 1) {
            bitmap = decodeTextRegion(huffman, refinement, currentWidth, currentHeight, 0, numberOfInstances, 1, symbols.concat(newSymbols), symbolCodeLength, 0, 0, 1, 0, huffmanTables, refinementTemplateIndex, refinementAt, decodingContext, 0, huffmanInput);
          } else {
            var symbolId = decodeIAID(contextCache, decoder, symbolCodeLength);
            var rdx = decodeInteger(contextCache, 'IARDX', decoder);
            var rdy = decodeInteger(contextCache, 'IARDY', decoder);
            var symbol = symbolId < symbols.length ? symbols[symbolId] : newSymbols[symbolId - symbols.length];
            bitmap = decodeRefinement(currentWidth, currentHeight, refinementTemplateIndex, symbol, rdx, rdy, false, refinementAt, decodingContext);
          }

          newSymbols.push(bitmap);
        } else if (huffman) {
          symbolWidths.push(currentWidth);
        } else {
          bitmap = decodeBitmap(false, currentWidth, currentHeight, templateIndex, false, null, at, decodingContext);
          newSymbols.push(bitmap);
        }
      }

      if (huffman && !refinement) {
        var bitmapSize = huffmanTables.tableBitmapSize.decode(huffmanInput);
        huffmanInput.byteAlign();
        var collectiveBitmap = void 0;

        if (bitmapSize === 0) {
          collectiveBitmap = readUncompressedBitmap(huffmanInput, totalWidth, currentHeight);
        } else {
          var originalEnd = huffmanInput.end;
          var bitmapEnd = huffmanInput.position + bitmapSize;
          huffmanInput.end = bitmapEnd;
          collectiveBitmap = decodeMMRBitmap(huffmanInput, totalWidth, currentHeight, false);
          huffmanInput.end = originalEnd;
          huffmanInput.position = bitmapEnd;
        }

        var numberOfSymbolsDecoded = symbolWidths.length;

        if (firstSymbol === numberOfSymbolsDecoded - 1) {
          newSymbols.push(collectiveBitmap);
        } else {
          var _i = void 0,
              y = void 0,
              xMin = 0,
              xMax = void 0,
              bitmapWidth = void 0,
              symbolBitmap = void 0;

          for (_i = firstSymbol; _i < numberOfSymbolsDecoded; _i++) {
            bitmapWidth = symbolWidths[_i];
            xMax = xMin + bitmapWidth;
            symbolBitmap = [];

            for (y = 0; y < currentHeight; y++) {
              symbolBitmap.push(collectiveBitmap[y].subarray(xMin, xMax));
            }

            newSymbols.push(symbolBitmap);
            xMin = xMax;
          }
        }
      }
    }

    var exportedSymbols = [];
    var flags = [],
        currentFlag = false;
    var totalSymbolsLength = symbols.length + numberOfNewSymbols;

    while (flags.length < totalSymbolsLength) {
      var runLength = huffman ? tableB1.decode(huffmanInput) : decodeInteger(contextCache, 'IAEX', decoder);

      while (runLength--) {
        flags.push(currentFlag);
      }

      currentFlag = !currentFlag;
    }

    for (var i = 0, ii = symbols.length; i < ii; i++) {
      if (flags[i]) {
        exportedSymbols.push(symbols[i]);
      }
    }

    for (var j = 0; j < numberOfNewSymbols; i++, j++) {
      if (flags[i]) {
        exportedSymbols.push(newSymbols[j]);
      }
    }

    return exportedSymbols;
  }

  function decodeTextRegion(huffman, refinement, width, height, defaultPixelValue, numberOfSymbolInstances, stripSize, inputSymbols, symbolCodeLength, transposed, dsOffset, referenceCorner, combinationOperator, huffmanTables, refinementTemplateIndex, refinementAt, decodingContext, logStripSize, huffmanInput) {
    if (huffman && refinement) {
      throw new Jbig2Error('refinement with Huffman is not supported');
    }

    var bitmap = [];
    var i, row;

    for (i = 0; i < height; i++) {
      row = new Uint8Array(width);

      if (defaultPixelValue) {
        for (var j = 0; j < width; j++) {
          row[j] = defaultPixelValue;
        }
      }

      bitmap.push(row);
    }

    var decoder = decodingContext.decoder;
    var contextCache = decodingContext.contextCache;
    var stripT = huffman ? -huffmanTables.tableDeltaT.decode(huffmanInput) : -decodeInteger(contextCache, 'IADT', decoder);
    var firstS = 0;
    i = 0;

    while (i < numberOfSymbolInstances) {
      var deltaT = huffman ? huffmanTables.tableDeltaT.decode(huffmanInput) : decodeInteger(contextCache, 'IADT', decoder);
      stripT += deltaT;
      var deltaFirstS = huffman ? huffmanTables.tableFirstS.decode(huffmanInput) : decodeInteger(contextCache, 'IAFS', decoder);
      firstS += deltaFirstS;
      var currentS = firstS;

      do {
        var currentT = 0;

        if (stripSize > 1) {
          currentT = huffman ? huffmanInput.readBits(logStripSize) : decodeInteger(contextCache, 'IAIT', decoder);
        }

        var t = stripSize * stripT + currentT;
        var symbolId = huffman ? huffmanTables.symbolIDTable.decode(huffmanInput) : decodeIAID(contextCache, decoder, symbolCodeLength);
        var applyRefinement = refinement && (huffman ? huffmanInput.readBit() : decodeInteger(contextCache, 'IARI', decoder));
        var symbolBitmap = inputSymbols[symbolId];
        var symbolWidth = symbolBitmap[0].length;
        var symbolHeight = symbolBitmap.length;

        if (applyRefinement) {
          var rdw = decodeInteger(contextCache, 'IARDW', decoder);
          var rdh = decodeInteger(contextCache, 'IARDH', decoder);
          var rdx = decodeInteger(contextCache, 'IARDX', decoder);
          var rdy = decodeInteger(contextCache, 'IARDY', decoder);
          symbolWidth += rdw;
          symbolHeight += rdh;
          symbolBitmap = decodeRefinement(symbolWidth, symbolHeight, refinementTemplateIndex, symbolBitmap, (rdw >> 1) + rdx, (rdh >> 1) + rdy, false, refinementAt, decodingContext);
        }

        var offsetT = t - (referenceCorner & 1 ? 0 : symbolHeight - 1);
        var offsetS = currentS - (referenceCorner & 2 ? symbolWidth - 1 : 0);
        var s2, t2, symbolRow;

        if (transposed) {
          for (s2 = 0; s2 < symbolHeight; s2++) {
            row = bitmap[offsetS + s2];

            if (!row) {
              continue;
            }

            symbolRow = symbolBitmap[s2];
            var maxWidth = Math.min(width - offsetT, symbolWidth);

            switch (combinationOperator) {
              case 0:
                for (t2 = 0; t2 < maxWidth; t2++) {
                  row[offsetT + t2] |= symbolRow[t2];
                }

                break;

              case 2:
                for (t2 = 0; t2 < maxWidth; t2++) {
                  row[offsetT + t2] ^= symbolRow[t2];
                }

                break;

              default:
                throw new Jbig2Error("operator ".concat(combinationOperator, " is not supported"));
            }
          }

          currentS += symbolHeight - 1;
        } else {
          for (t2 = 0; t2 < symbolHeight; t2++) {
            row = bitmap[offsetT + t2];

            if (!row) {
              continue;
            }

            symbolRow = symbolBitmap[t2];

            switch (combinationOperator) {
              case 0:
                for (s2 = 0; s2 < symbolWidth; s2++) {
                  row[offsetS + s2] |= symbolRow[s2];
                }

                break;

              case 2:
                for (s2 = 0; s2 < symbolWidth; s2++) {
                  row[offsetS + s2] ^= symbolRow[s2];
                }

                break;

              default:
                throw new Jbig2Error("operator ".concat(combinationOperator, " is not supported"));
            }
          }

          currentS += symbolWidth - 1;
        }

        i++;
        var deltaS = huffman ? huffmanTables.tableDeltaS.decode(huffmanInput) : decodeInteger(contextCache, 'IADS', decoder);

        if (deltaS === null) {
          break;
        }

        currentS += deltaS + dsOffset;
      } while (true);
    }

    return bitmap;
  }

  function decodePatternDictionary(mmr, patternWidth, patternHeight, maxPatternIndex, template, decodingContext) {
    var at = [];

    if (!mmr) {
      at.push({
        x: -patternWidth,
        y: 0
      });

      if (template === 0) {
        at.push({
          x: -3,
          y: -1
        });
        at.push({
          x: 2,
          y: -2
        });
        at.push({
          x: -2,
          y: -2
        });
      }
    }

    var collectiveWidth = (maxPatternIndex + 1) * patternWidth;
    var collectiveBitmap = decodeBitmap(mmr, collectiveWidth, patternHeight, template, false, null, at, decodingContext);
    var patterns = [],
        i = 0,
        patternBitmap,
        xMin,
        xMax,
        y;

    while (i <= maxPatternIndex) {
      patternBitmap = [];
      xMin = patternWidth * i;
      xMax = xMin + patternWidth;

      for (y = 0; y < patternHeight; y++) {
        patternBitmap.push(collectiveBitmap[y].subarray(xMin, xMax));
      }

      patterns.push(patternBitmap);
      i++;
    }

    return patterns;
  }

  function decodeHalftoneRegion(mmr, patterns, template, regionWidth, regionHeight, defaultPixelValue, enableSkip, combinationOperator, gridWidth, gridHeight, gridOffsetX, gridOffsetY, gridVectorX, gridVectorY, decodingContext) {
    var skip = null;

    if (enableSkip) {
      throw new Jbig2Error('skip is not supported');
    }

    if (combinationOperator !== 0) {
      throw new Jbig2Error('operator ' + combinationOperator + ' is not supported in halftone region');
    }

    var regionBitmap = [];
    var i, j, row;

    for (i = 0; i < regionHeight; i++) {
      row = new Uint8Array(regionWidth);

      if (defaultPixelValue) {
        for (j = 0; j < regionWidth; j++) {
          row[j] = defaultPixelValue;
        }
      }

      regionBitmap.push(row);
    }

    var numberOfPatterns = patterns.length;
    var pattern0 = patterns[0];
    var patternWidth = pattern0[0].length,
        patternHeight = pattern0.length;
    var bitsPerValue = (0, _util.log2)(numberOfPatterns);
    var at = [];

    if (!mmr) {
      at.push({
        x: template <= 1 ? 3 : 2,
        y: -1
      });

      if (template === 0) {
        at.push({
          x: -3,
          y: -1
        });
        at.push({
          x: 2,
          y: -2
        });
        at.push({
          x: -2,
          y: -2
        });
      }
    }

    var grayScaleBitPlanes = [],
        mmrInput,
        bitmap;

    if (mmr) {
      mmrInput = new Reader(decodingContext.data, decodingContext.start, decodingContext.end);
    }

    for (i = bitsPerValue - 1; i >= 0; i--) {
      if (mmr) {
        bitmap = decodeMMRBitmap(mmrInput, gridWidth, gridHeight, true);
      } else {
        bitmap = decodeBitmap(false, gridWidth, gridHeight, template, false, skip, at, decodingContext);
      }

      grayScaleBitPlanes[i] = bitmap;
    }

    var mg, ng, bit, patternIndex, patternBitmap, x, y, patternRow, regionRow;

    for (mg = 0; mg < gridHeight; mg++) {
      for (ng = 0; ng < gridWidth; ng++) {
        bit = 0;
        patternIndex = 0;

        for (j = bitsPerValue - 1; j >= 0; j--) {
          bit = grayScaleBitPlanes[j][mg][ng] ^ bit;
          patternIndex |= bit << j;
        }

        patternBitmap = patterns[patternIndex];
        x = gridOffsetX + mg * gridVectorY + ng * gridVectorX >> 8;
        y = gridOffsetY + mg * gridVectorX - ng * gridVectorY >> 8;

        if (x >= 0 && x + patternWidth <= regionWidth && y >= 0 && y + patternHeight <= regionHeight) {
          for (i = 0; i < patternHeight; i++) {
            regionRow = regionBitmap[y + i];
            patternRow = patternBitmap[i];

            for (j = 0; j < patternWidth; j++) {
              regionRow[x + j] |= patternRow[j];
            }
          }
        } else {
          var regionX = void 0,
              regionY = void 0;

          for (i = 0; i < patternHeight; i++) {
            regionY = y + i;

            if (regionY < 0 || regionY >= regionHeight) {
              continue;
            }

            regionRow = regionBitmap[regionY];
            patternRow = patternBitmap[i];

            for (j = 0; j < patternWidth; j++) {
              regionX = x + j;

              if (regionX >= 0 && regionX < regionWidth) {
                regionRow[regionX] |= patternRow[j];
              }
            }
          }
        }
      }
    }

    return regionBitmap;
  }

  function readSegmentHeader(data, start) {
    var segmentHeader = {};
    segmentHeader.number = (0, _util.readUint32)(data, start);
    var flags = data[start + 4];
    var segmentType = flags & 0x3F;

    if (!SegmentTypes[segmentType]) {
      throw new Jbig2Error('invalid segment type: ' + segmentType);
    }

    segmentHeader.type = segmentType;
    segmentHeader.typeName = SegmentTypes[segmentType];
    segmentHeader.deferredNonRetain = !!(flags & 0x80);
    var pageAssociationFieldSize = !!(flags & 0x40);
    var referredFlags = data[start + 5];
    var referredToCount = referredFlags >> 5 & 7;
    var retainBits = [referredFlags & 31];
    var position = start + 6;

    if (referredFlags === 7) {
      referredToCount = (0, _util.readUint32)(data, position - 1) & 0x1FFFFFFF;
      position += 3;
      var bytes = referredToCount + 7 >> 3;
      retainBits[0] = data[position++];

      while (--bytes > 0) {
        retainBits.push(data[position++]);
      }
    } else if (referredFlags === 5 || referredFlags === 6) {
      throw new Jbig2Error('invalid referred-to flags');
    }

    segmentHeader.retainBits = retainBits;
    var referredToSegmentNumberSize = segmentHeader.number <= 256 ? 1 : segmentHeader.number <= 65536 ? 2 : 4;
    var referredTo = [];
    var i, ii;

    for (i = 0; i < referredToCount; i++) {
      var number = referredToSegmentNumberSize === 1 ? data[position] : referredToSegmentNumberSize === 2 ? (0, _util.readUint16)(data, position) : (0, _util.readUint32)(data, position);
      referredTo.push(number);
      position += referredToSegmentNumberSize;
    }

    segmentHeader.referredTo = referredTo;

    if (!pageAssociationFieldSize) {
      segmentHeader.pageAssociation = data[position++];
    } else {
      segmentHeader.pageAssociation = (0, _util.readUint32)(data, position);
      position += 4;
    }

    segmentHeader.length = (0, _util.readUint32)(data, position);
    position += 4;

    if (segmentHeader.length === 0xFFFFFFFF) {
      if (segmentType === 38) {
        var genericRegionInfo = readRegionSegmentInformation(data, position);
        var genericRegionSegmentFlags = data[position + RegionSegmentInformationFieldLength];
        var genericRegionMmr = !!(genericRegionSegmentFlags & 1);
        var searchPatternLength = 6;
        var searchPattern = new Uint8Array(searchPatternLength);

        if (!genericRegionMmr) {
          searchPattern[0] = 0xFF;
          searchPattern[1] = 0xAC;
        }

        searchPattern[2] = genericRegionInfo.height >>> 24 & 0xFF;
        searchPattern[3] = genericRegionInfo.height >> 16 & 0xFF;
        searchPattern[4] = genericRegionInfo.height >> 8 & 0xFF;
        searchPattern[5] = genericRegionInfo.height & 0xFF;

        for (i = position, ii = data.length; i < ii; i++) {
          var j = 0;

          while (j < searchPatternLength && searchPattern[j] === data[i + j]) {
            j++;
          }

          if (j === searchPatternLength) {
            segmentHeader.length = i + searchPatternLength;
            break;
          }
        }

        if (segmentHeader.length === 0xFFFFFFFF) {
          throw new Jbig2Error('segment end was not found');
        }
      } else {
        throw new Jbig2Error('invalid unknown segment length');
      }
    }

    segmentHeader.headerEnd = position;
    return segmentHeader;
  }

  function readSegments(header, data, start, end) {
    var segments = [];
    var position = start;

    while (position < end) {
      var segmentHeader = readSegmentHeader(data, position);
      position = segmentHeader.headerEnd;
      var segment = {
        header: segmentHeader,
        data: data
      };

      if (!header.randomAccess) {
        segment.start = position;
        position += segmentHeader.length;
        segment.end = position;
      }

      segments.push(segment);

      if (segmentHeader.type === 51) {
        break;
      }
    }

    if (header.randomAccess) {
      for (var i = 0, ii = segments.length; i < ii; i++) {
        segments[i].start = position;
        position += segments[i].header.length;
        segments[i].end = position;
      }
    }

    return segments;
  }

  function readRegionSegmentInformation(data, start) {
    return {
      width: (0, _util.readUint32)(data, start),
      height: (0, _util.readUint32)(data, start + 4),
      x: (0, _util.readUint32)(data, start + 8),
      y: (0, _util.readUint32)(data, start + 12),
      combinationOperator: data[start + 16] & 7
    };
  }

  var RegionSegmentInformationFieldLength = 17;

  function processSegment(segment, visitor) {
    var header = segment.header;
    var data = segment.data,
        position = segment.start,
        end = segment.end;
    var args, at, i, atLength;

    switch (header.type) {
      case 0:
        var dictionary = {};
        var dictionaryFlags = (0, _util.readUint16)(data, position);
        dictionary.huffman = !!(dictionaryFlags & 1);
        dictionary.refinement = !!(dictionaryFlags & 2);
        dictionary.huffmanDHSelector = dictionaryFlags >> 2 & 3;
        dictionary.huffmanDWSelector = dictionaryFlags >> 4 & 3;
        dictionary.bitmapSizeSelector = dictionaryFlags >> 6 & 1;
        dictionary.aggregationInstancesSelector = dictionaryFlags >> 7 & 1;
        dictionary.bitmapCodingContextUsed = !!(dictionaryFlags & 256);
        dictionary.bitmapCodingContextRetained = !!(dictionaryFlags & 512);
        dictionary.template = dictionaryFlags >> 10 & 3;
        dictionary.refinementTemplate = dictionaryFlags >> 12 & 1;
        position += 2;

        if (!dictionary.huffman) {
          atLength = dictionary.template === 0 ? 4 : 1;
          at = [];

          for (i = 0; i < atLength; i++) {
            at.push({
              x: (0, _util.readInt8)(data, position),
              y: (0, _util.readInt8)(data, position + 1)
            });
            position += 2;
          }

          dictionary.at = at;
        }

        if (dictionary.refinement && !dictionary.refinementTemplate) {
          at = [];

          for (i = 0; i < 2; i++) {
            at.push({
              x: (0, _util.readInt8)(data, position),
              y: (0, _util.readInt8)(data, position + 1)
            });
            position += 2;
          }

          dictionary.refinementAt = at;
        }

        dictionary.numberOfExportedSymbols = (0, _util.readUint32)(data, position);
        position += 4;
        dictionary.numberOfNewSymbols = (0, _util.readUint32)(data, position);
        position += 4;
        args = [dictionary, header.number, header.referredTo, data, position, end];
        break;

      case 6:
      case 7:
        var textRegion = {};
        textRegion.info = readRegionSegmentInformation(data, position);
        position += RegionSegmentInformationFieldLength;
        var textRegionSegmentFlags = (0, _util.readUint16)(data, position);
        position += 2;
        textRegion.huffman = !!(textRegionSegmentFlags & 1);
        textRegion.refinement = !!(textRegionSegmentFlags & 2);
        textRegion.logStripSize = textRegionSegmentFlags >> 2 & 3;
        textRegion.stripSize = 1 << textRegion.logStripSize;
        textRegion.referenceCorner = textRegionSegmentFlags >> 4 & 3;
        textRegion.transposed = !!(textRegionSegmentFlags & 64);
        textRegion.combinationOperator = textRegionSegmentFlags >> 7 & 3;
        textRegion.defaultPixelValue = textRegionSegmentFlags >> 9 & 1;
        textRegion.dsOffset = textRegionSegmentFlags << 17 >> 27;
        textRegion.refinementTemplate = textRegionSegmentFlags >> 15 & 1;

        if (textRegion.huffman) {
          var textRegionHuffmanFlags = (0, _util.readUint16)(data, position);
          position += 2;
          textRegion.huffmanFS = textRegionHuffmanFlags & 3;
          textRegion.huffmanDS = textRegionHuffmanFlags >> 2 & 3;
          textRegion.huffmanDT = textRegionHuffmanFlags >> 4 & 3;
          textRegion.huffmanRefinementDW = textRegionHuffmanFlags >> 6 & 3;
          textRegion.huffmanRefinementDH = textRegionHuffmanFlags >> 8 & 3;
          textRegion.huffmanRefinementDX = textRegionHuffmanFlags >> 10 & 3;
          textRegion.huffmanRefinementDY = textRegionHuffmanFlags >> 12 & 3;
          textRegion.huffmanRefinementSizeSelector = !!(textRegionHuffmanFlags & 0x4000);
        }

        if (textRegion.refinement && !textRegion.refinementTemplate) {
          at = [];

          for (i = 0; i < 2; i++) {
            at.push({
              x: (0, _util.readInt8)(data, position),
              y: (0, _util.readInt8)(data, position + 1)
            });
            position += 2;
          }

          textRegion.refinementAt = at;
        }

        textRegion.numberOfSymbolInstances = (0, _util.readUint32)(data, position);
        position += 4;
        args = [textRegion, header.referredTo, data, position, end];
        break;

      case 16:
        var patternDictionary = {};
        var patternDictionaryFlags = data[position++];
        patternDictionary.mmr = !!(patternDictionaryFlags & 1);
        patternDictionary.template = patternDictionaryFlags >> 1 & 3;
        patternDictionary.patternWidth = data[position++];
        patternDictionary.patternHeight = data[position++];
        patternDictionary.maxPatternIndex = (0, _util.readUint32)(data, position);
        position += 4;
        args = [patternDictionary, header.number, data, position, end];
        break;

      case 22:
      case 23:
        var halftoneRegion = {};
        halftoneRegion.info = readRegionSegmentInformation(data, position);
        position += RegionSegmentInformationFieldLength;
        var halftoneRegionFlags = data[position++];
        halftoneRegion.mmr = !!(halftoneRegionFlags & 1);
        halftoneRegion.template = halftoneRegionFlags >> 1 & 3;
        halftoneRegion.enableSkip = !!(halftoneRegionFlags & 8);
        halftoneRegion.combinationOperator = halftoneRegionFlags >> 4 & 7;
        halftoneRegion.defaultPixelValue = halftoneRegionFlags >> 7 & 1;
        halftoneRegion.gridWidth = (0, _util.readUint32)(data, position);
        position += 4;
        halftoneRegion.gridHeight = (0, _util.readUint32)(data, position);
        position += 4;
        halftoneRegion.gridOffsetX = (0, _util.readUint32)(data, position) & 0xFFFFFFFF;
        position += 4;
        halftoneRegion.gridOffsetY = (0, _util.readUint32)(data, position) & 0xFFFFFFFF;
        position += 4;
        halftoneRegion.gridVectorX = (0, _util.readUint16)(data, position);
        position += 2;
        halftoneRegion.gridVectorY = (0, _util.readUint16)(data, position);
        position += 2;
        args = [halftoneRegion, header.referredTo, data, position, end];
        break;

      case 38:
      case 39:
        var genericRegion = {};
        genericRegion.info = readRegionSegmentInformation(data, position);
        position += RegionSegmentInformationFieldLength;
        var genericRegionSegmentFlags = data[position++];
        genericRegion.mmr = !!(genericRegionSegmentFlags & 1);
        genericRegion.template = genericRegionSegmentFlags >> 1 & 3;
        genericRegion.prediction = !!(genericRegionSegmentFlags & 8);

        if (!genericRegion.mmr) {
          atLength = genericRegion.template === 0 ? 4 : 1;
          at = [];

          for (i = 0; i < atLength; i++) {
            at.push({
              x: (0, _util.readInt8)(data, position),
              y: (0, _util.readInt8)(data, position + 1)
            });
            position += 2;
          }

          genericRegion.at = at;
        }

        args = [genericRegion, data, position, end];
        break;

      case 48:
        var pageInfo = {
          width: (0, _util.readUint32)(data, position),
          height: (0, _util.readUint32)(data, position + 4),
          resolutionX: (0, _util.readUint32)(data, position + 8),
          resolutionY: (0, _util.readUint32)(data, position + 12)
        };

        if (pageInfo.height === 0xFFFFFFFF) {
          delete pageInfo.height;
        }

        var pageSegmentFlags = data[position + 16];
        (0, _util.readUint16)(data, position + 17);
        pageInfo.lossless = !!(pageSegmentFlags & 1);
        pageInfo.refinement = !!(pageSegmentFlags & 2);
        pageInfo.defaultPixelValue = pageSegmentFlags >> 2 & 1;
        pageInfo.combinationOperator = pageSegmentFlags >> 3 & 3;
        pageInfo.requiresBuffer = !!(pageSegmentFlags & 32);
        pageInfo.combinationOperatorOverride = !!(pageSegmentFlags & 64);
        args = [pageInfo];
        break;

      case 49:
        break;

      case 50:
        break;

      case 51:
        break;

      case 53:
        args = [header.number, data, position, end];
        break;

      case 62:
        break;

      default:
        throw new Jbig2Error("segment type ".concat(header.typeName, "(").concat(header.type, ")") + ' is not implemented');
    }

    var callbackName = 'on' + header.typeName;

    if (callbackName in visitor) {
      visitor[callbackName].apply(visitor, args);
    }
  }

  function processSegments(segments, visitor) {
    for (var i = 0, ii = segments.length; i < ii; i++) {
      processSegment(segments[i], visitor);
    }
  }

  function parseJbig2Chunks(chunks) {
    var visitor = new SimpleSegmentVisitor();

    for (var i = 0, ii = chunks.length; i < ii; i++) {
      var chunk = chunks[i];
      var segments = readSegments({}, chunk.data, chunk.start, chunk.end);
      processSegments(segments, visitor);
    }

    return visitor.buffer;
  }

  function parseJbig2(data) {
    var position = 0,
        end = data.length;

    if (data[position] !== 0x97 || data[position + 1] !== 0x4A || data[position + 2] !== 0x42 || data[position + 3] !== 0x32 || data[position + 4] !== 0x0D || data[position + 5] !== 0x0A || data[position + 6] !== 0x1A || data[position + 7] !== 0x0A) {
      throw new Jbig2Error('parseJbig2 - invalid header.');
    }

    var header = Object.create(null);
    position += 8;
    var flags = data[position++];
    header.randomAccess = !(flags & 1);

    if (!(flags & 2)) {
      header.numberOfPages = (0, _util.readUint32)(data, position);
      position += 4;
    }

    var segments = readSegments(header, data, position, end);
    var visitor = new SimpleSegmentVisitor();
    processSegments(segments, visitor);
    var _visitor$currentPageI = visitor.currentPageInfo,
        width = _visitor$currentPageI.width,
        height = _visitor$currentPageI.height;
    var bitPacked = visitor.buffer;
    var imgData = new Uint8ClampedArray(width * height);
    var q = 0,
        k = 0;

    for (var i = 0; i < height; i++) {
      var mask = 0,
          buffer = void 0;

      for (var j = 0; j < width; j++) {
        if (!mask) {
          mask = 128;
          buffer = bitPacked[k++];
        }

        imgData[q++] = buffer & mask ? 0 : 255;
        mask >>= 1;
      }
    }

    return {
      imgData: imgData,
      width: width,
      height: height
    };
  }

  function SimpleSegmentVisitor() {}

  SimpleSegmentVisitor.prototype = {
    onPageInformation: function SimpleSegmentVisitor_onPageInformation(info) {
      this.currentPageInfo = info;
      var rowSize = info.width + 7 >> 3;
      var buffer = new Uint8ClampedArray(rowSize * info.height);

      if (info.defaultPixelValue) {
        for (var i = 0, ii = buffer.length; i < ii; i++) {
          buffer[i] = 0xFF;
        }
      }

      this.buffer = buffer;
    },
    drawBitmap: function SimpleSegmentVisitor_drawBitmap(regionInfo, bitmap) {
      var pageInfo = this.currentPageInfo;
      var width = regionInfo.width,
          height = regionInfo.height;
      var rowSize = pageInfo.width + 7 >> 3;
      var combinationOperator = pageInfo.combinationOperatorOverride ? regionInfo.combinationOperator : pageInfo.combinationOperator;
      var buffer = this.buffer;
      var mask0 = 128 >> (regionInfo.x & 7);
      var offset0 = regionInfo.y * rowSize + (regionInfo.x >> 3);
      var i, j, mask, offset;

      switch (combinationOperator) {
        case 0:
          for (i = 0; i < height; i++) {
            mask = mask0;
            offset = offset0;

            for (j = 0; j < width; j++) {
              if (bitmap[i][j]) {
                buffer[offset] |= mask;
              }

              mask >>= 1;

              if (!mask) {
                mask = 128;
                offset++;
              }
            }

            offset0 += rowSize;
          }

          break;

        case 2:
          for (i = 0; i < height; i++) {
            mask = mask0;
            offset = offset0;

            for (j = 0; j < width; j++) {
              if (bitmap[i][j]) {
                buffer[offset] ^= mask;
              }

              mask >>= 1;

              if (!mask) {
                mask = 128;
                offset++;
              }
            }

            offset0 += rowSize;
          }

          break;

        default:
          throw new Jbig2Error("operator ".concat(combinationOperator, " is not supported"));
      }
    },
    onImmediateGenericRegion: function SimpleSegmentVisitor_onImmediateGenericRegion(region, data, start, end) {
      var regionInfo = region.info;
      var decodingContext = new DecodingContext(data, start, end);
      var bitmap = decodeBitmap(region.mmr, regionInfo.width, regionInfo.height, region.template, region.prediction, null, region.at, decodingContext);
      this.drawBitmap(regionInfo, bitmap);
    },
    onImmediateLosslessGenericRegion: function SimpleSegmentVisitor_onImmediateLosslessGenericRegion() {
      this.onImmediateGenericRegion.apply(this, arguments);
    },
    onSymbolDictionary: function SimpleSegmentVisitor_onSymbolDictionary(dictionary, currentSegment, referredSegments, data, start, end) {
      var huffmanTables, huffmanInput;

      if (dictionary.huffman) {
        huffmanTables = getSymbolDictionaryHuffmanTables(dictionary, referredSegments, this.customTables);
        huffmanInput = new Reader(data, start, end);
      }

      var symbols = this.symbols;

      if (!symbols) {
        this.symbols = symbols = {};
      }

      var inputSymbols = [];

      for (var i = 0, ii = referredSegments.length; i < ii; i++) {
        var referredSymbols = symbols[referredSegments[i]];

        if (referredSymbols) {
          inputSymbols = inputSymbols.concat(referredSymbols);
        }
      }

      var decodingContext = new DecodingContext(data, start, end);
      symbols[currentSegment] = decodeSymbolDictionary(dictionary.huffman, dictionary.refinement, inputSymbols, dictionary.numberOfNewSymbols, dictionary.numberOfExportedSymbols, huffmanTables, dictionary.template, dictionary.at, dictionary.refinementTemplate, dictionary.refinementAt, decodingContext, huffmanInput);
    },
    onImmediateTextRegion: function SimpleSegmentVisitor_onImmediateTextRegion(region, referredSegments, data, start, end) {
      var regionInfo = region.info;
      var huffmanTables, huffmanInput;
      var symbols = this.symbols;
      var inputSymbols = [];

      for (var i = 0, ii = referredSegments.length; i < ii; i++) {
        var referredSymbols = symbols[referredSegments[i]];

        if (referredSymbols) {
          inputSymbols = inputSymbols.concat(referredSymbols);
        }
      }

      var symbolCodeLength = (0, _util.log2)(inputSymbols.length);

      if (region.huffman) {
        huffmanInput = new Reader(data, start, end);
        huffmanTables = getTextRegionHuffmanTables(region, referredSegments, this.customTables, inputSymbols.length, huffmanInput);
      }

      var decodingContext = new DecodingContext(data, start, end);
      var bitmap = decodeTextRegion(region.huffman, region.refinement, regionInfo.width, regionInfo.height, region.defaultPixelValue, region.numberOfSymbolInstances, region.stripSize, inputSymbols, symbolCodeLength, region.transposed, region.dsOffset, region.referenceCorner, region.combinationOperator, huffmanTables, region.refinementTemplate, region.refinementAt, decodingContext, region.logStripSize, huffmanInput);
      this.drawBitmap(regionInfo, bitmap);
    },
    onImmediateLosslessTextRegion: function SimpleSegmentVisitor_onImmediateLosslessTextRegion() {
      this.onImmediateTextRegion.apply(this, arguments);
    },
    onPatternDictionary: function onPatternDictionary(dictionary, currentSegment, data, start, end) {
      var patterns = this.patterns;

      if (!patterns) {
        this.patterns = patterns = {};
      }

      var decodingContext = new DecodingContext(data, start, end);
      patterns[currentSegment] = decodePatternDictionary(dictionary.mmr, dictionary.patternWidth, dictionary.patternHeight, dictionary.maxPatternIndex, dictionary.template, decodingContext);
    },
    onImmediateHalftoneRegion: function onImmediateHalftoneRegion(region, referredSegments, data, start, end) {
      var patterns = this.patterns[referredSegments[0]];
      var regionInfo = region.info;
      var decodingContext = new DecodingContext(data, start, end);
      var bitmap = decodeHalftoneRegion(region.mmr, patterns, region.template, regionInfo.width, regionInfo.height, region.defaultPixelValue, region.enableSkip, region.combinationOperator, region.gridWidth, region.gridHeight, region.gridOffsetX, region.gridOffsetY, region.gridVectorX, region.gridVectorY, decodingContext);
      this.drawBitmap(regionInfo, bitmap);
    },
    onImmediateLosslessHalftoneRegion: function onImmediateLosslessHalftoneRegion() {
      this.onImmediateHalftoneRegion.apply(this, arguments);
    },
    onTables: function onTables(currentSegment, data, start, end) {
      var customTables = this.customTables;

      if (!customTables) {
        this.customTables = customTables = {};
      }

      customTables[currentSegment] = decodeTablesSegment(data, start, end);
    }
  };

  function HuffmanLine(lineData) {
    if (lineData.length === 2) {
      this.isOOB = true;
      this.rangeLow = 0;
      this.prefixLength = lineData[0];
      this.rangeLength = 0;
      this.prefixCode = lineData[1];
      this.isLowerRange = false;
    } else {
      this.isOOB = false;
      this.rangeLow = lineData[0];
      this.prefixLength = lineData[1];
      this.rangeLength = lineData[2];
      this.prefixCode = lineData[3];
      this.isLowerRange = lineData[4] === 'lower';
    }
  }

  function HuffmanTreeNode(line) {
    this.children = [];

    if (line) {
      this.isLeaf = true;
      this.rangeLength = line.rangeLength;
      this.rangeLow = line.rangeLow;
      this.isLowerRange = line.isLowerRange;
      this.isOOB = line.isOOB;
    } else {
      this.isLeaf = false;
    }
  }

  HuffmanTreeNode.prototype = {
    buildTree: function buildTree(line, shift) {
      var bit = line.prefixCode >> shift & 1;

      if (shift <= 0) {
        this.children[bit] = new HuffmanTreeNode(line);
      } else {
        var node = this.children[bit];

        if (!node) {
          this.children[bit] = node = new HuffmanTreeNode(null);
        }

        node.buildTree(line, shift - 1);
      }
    },
    decodeNode: function decodeNode(reader) {
      if (this.isLeaf) {
        if (this.isOOB) {
          return null;
        }

        var htOffset = reader.readBits(this.rangeLength);
        return this.rangeLow + (this.isLowerRange ? -htOffset : htOffset);
      }

      var node = this.children[reader.readBit()];

      if (!node) {
        throw new Jbig2Error('invalid Huffman data');
      }

      return node.decodeNode(reader);
    }
  };

  function HuffmanTable(lines, prefixCodesDone) {
    if (!prefixCodesDone) {
      this.assignPrefixCodes(lines);
    }

    this.rootNode = new HuffmanTreeNode(null);
    var i,
        ii = lines.length,
        line;

    for (i = 0; i < ii; i++) {
      line = lines[i];

      if (line.prefixLength > 0) {
        this.rootNode.buildTree(line, line.prefixLength - 1);
      }
    }
  }

  HuffmanTable.prototype = {
    decode: function decode(reader) {
      return this.rootNode.decodeNode(reader);
    },
    assignPrefixCodes: function assignPrefixCodes(lines) {
      var linesLength = lines.length,
          prefixLengthMax = 0,
          i;

      for (i = 0; i < linesLength; i++) {
        prefixLengthMax = Math.max(prefixLengthMax, lines[i].prefixLength);
      }

      var histogram = new Uint32Array(prefixLengthMax + 1);

      for (i = 0; i < linesLength; i++) {
        histogram[lines[i].prefixLength]++;
      }

      var currentLength = 1,
          firstCode = 0,
          currentCode,
          currentTemp,
          line;
      histogram[0] = 0;

      while (currentLength <= prefixLengthMax) {
        firstCode = firstCode + histogram[currentLength - 1] << 1;
        currentCode = firstCode;
        currentTemp = 0;

        while (currentTemp < linesLength) {
          line = lines[currentTemp];

          if (line.prefixLength === currentLength) {
            line.prefixCode = currentCode;
            currentCode++;
          }

          currentTemp++;
        }

        currentLength++;
      }
    }
  };

  function decodeTablesSegment(data, start, end) {
    var flags = data[start];
    var lowestValue = (0, _util.readUint32)(data, start + 1) & 0xFFFFFFFF;
    var highestValue = (0, _util.readUint32)(data, start + 5) & 0xFFFFFFFF;
    var reader = new Reader(data, start + 9, end);
    var prefixSizeBits = (flags >> 1 & 7) + 1;
    var rangeSizeBits = (flags >> 4 & 7) + 1;
    var lines = [];
    var prefixLength,
        rangeLength,
        currentRangeLow = lowestValue;

    do {
      prefixLength = reader.readBits(prefixSizeBits);
      rangeLength = reader.readBits(rangeSizeBits);
      lines.push(new HuffmanLine([currentRangeLow, prefixLength, rangeLength, 0]));
      currentRangeLow += 1 << rangeLength;
    } while (currentRangeLow < highestValue);

    prefixLength = reader.readBits(prefixSizeBits);
    lines.push(new HuffmanLine([lowestValue - 1, prefixLength, 32, 0, 'lower']));
    prefixLength = reader.readBits(prefixSizeBits);
    lines.push(new HuffmanLine([highestValue, prefixLength, 32, 0]));

    if (flags & 1) {
      prefixLength = reader.readBits(prefixSizeBits);
      lines.push(new HuffmanLine([prefixLength, 0]));
    }

    return new HuffmanTable(lines, false);
  }

  var standardTablesCache = {};

  function getStandardTable(number) {
    var table = standardTablesCache[number];

    if (table) {
      return table;
    }

    var lines;

    switch (number) {
      case 1:
        lines = [[0, 1, 4, 0x0], [16, 2, 8, 0x2], [272, 3, 16, 0x6], [65808, 3, 32, 0x7]];
        break;

      case 2:
        lines = [[0, 1, 0, 0x0], [1, 2, 0, 0x2], [2, 3, 0, 0x6], [3, 4, 3, 0xE], [11, 5, 6, 0x1E], [75, 6, 32, 0x3E], [6, 0x3F]];
        break;

      case 3:
        lines = [[-256, 8, 8, 0xFE], [0, 1, 0, 0x0], [1, 2, 0, 0x2], [2, 3, 0, 0x6], [3, 4, 3, 0xE], [11, 5, 6, 0x1E], [-257, 8, 32, 0xFF, 'lower'], [75, 7, 32, 0x7E], [6, 0x3E]];
        break;

      case 4:
        lines = [[1, 1, 0, 0x0], [2, 2, 0, 0x2], [3, 3, 0, 0x6], [4, 4, 3, 0xE], [12, 5, 6, 0x1E], [76, 5, 32, 0x1F]];
        break;

      case 5:
        lines = [[-255, 7, 8, 0x7E], [1, 1, 0, 0x0], [2, 2, 0, 0x2], [3, 3, 0, 0x6], [4, 4, 3, 0xE], [12, 5, 6, 0x1E], [-256, 7, 32, 0x7F, 'lower'], [76, 6, 32, 0x3E]];
        break;

      case 6:
        lines = [[-2048, 5, 10, 0x1C], [-1024, 4, 9, 0x8], [-512, 4, 8, 0x9], [-256, 4, 7, 0xA], [-128, 5, 6, 0x1D], [-64, 5, 5, 0x1E], [-32, 4, 5, 0xB], [0, 2, 7, 0x0], [128, 3, 7, 0x2], [256, 3, 8, 0x3], [512, 4, 9, 0xC], [1024, 4, 10, 0xD], [-2049, 6, 32, 0x3E, 'lower'], [2048, 6, 32, 0x3F]];
        break;

      case 7:
        lines = [[-1024, 4, 9, 0x8], [-512, 3, 8, 0x0], [-256, 4, 7, 0x9], [-128, 5, 6, 0x1A], [-64, 5, 5, 0x1B], [-32, 4, 5, 0xA], [0, 4, 5, 0xB], [32, 5, 5, 0x1C], [64, 5, 6, 0x1D], [128, 4, 7, 0xC], [256, 3, 8, 0x1], [512, 3, 9, 0x2], [1024, 3, 10, 0x3], [-1025, 5, 32, 0x1E, 'lower'], [2048, 5, 32, 0x1F]];
        break;

      case 8:
        lines = [[-15, 8, 3, 0xFC], [-7, 9, 1, 0x1FC], [-5, 8, 1, 0xFD], [-3, 9, 0, 0x1FD], [-2, 7, 0, 0x7C], [-1, 4, 0, 0xA], [0, 2, 1, 0x0], [2, 5, 0, 0x1A], [3, 6, 0, 0x3A], [4, 3, 4, 0x4], [20, 6, 1, 0x3B], [22, 4, 4, 0xB], [38, 4, 5, 0xC], [70, 5, 6, 0x1B], [134, 5, 7, 0x1C], [262, 6, 7, 0x3C], [390, 7, 8, 0x7D], [646, 6, 10, 0x3D], [-16, 9, 32, 0x1FE, 'lower'], [1670, 9, 32, 0x1FF], [2, 0x1]];
        break;

      case 9:
        lines = [[-31, 8, 4, 0xFC], [-15, 9, 2, 0x1FC], [-11, 8, 2, 0xFD], [-7, 9, 1, 0x1FD], [-5, 7, 1, 0x7C], [-3, 4, 1, 0xA], [-1, 3, 1, 0x2], [1, 3, 1, 0x3], [3, 5, 1, 0x1A], [5, 6, 1, 0x3A], [7, 3, 5, 0x4], [39, 6, 2, 0x3B], [43, 4, 5, 0xB], [75, 4, 6, 0xC], [139, 5, 7, 0x1B], [267, 5, 8, 0x1C], [523, 6, 8, 0x3C], [779, 7, 9, 0x7D], [1291, 6, 11, 0x3D], [-32, 9, 32, 0x1FE, 'lower'], [3339, 9, 32, 0x1FF], [2, 0x0]];
        break;

      case 10:
        lines = [[-21, 7, 4, 0x7A], [-5, 8, 0, 0xFC], [-4, 7, 0, 0x7B], [-3, 5, 0, 0x18], [-2, 2, 2, 0x0], [2, 5, 0, 0x19], [3, 6, 0, 0x36], [4, 7, 0, 0x7C], [5, 8, 0, 0xFD], [6, 2, 6, 0x1], [70, 5, 5, 0x1A], [102, 6, 5, 0x37], [134, 6, 6, 0x38], [198, 6, 7, 0x39], [326, 6, 8, 0x3A], [582, 6, 9, 0x3B], [1094, 6, 10, 0x3C], [2118, 7, 11, 0x7D], [-22, 8, 32, 0xFE, 'lower'], [4166, 8, 32, 0xFF], [2, 0x2]];
        break;

      case 11:
        lines = [[1, 1, 0, 0x0], [2, 2, 1, 0x2], [4, 4, 0, 0xC], [5, 4, 1, 0xD], [7, 5, 1, 0x1C], [9, 5, 2, 0x1D], [13, 6, 2, 0x3C], [17, 7, 2, 0x7A], [21, 7, 3, 0x7B], [29, 7, 4, 0x7C], [45, 7, 5, 0x7D], [77, 7, 6, 0x7E], [141, 7, 32, 0x7F]];
        break;

      case 12:
        lines = [[1, 1, 0, 0x0], [2, 2, 0, 0x2], [3, 3, 1, 0x6], [5, 5, 0, 0x1C], [6, 5, 1, 0x1D], [8, 6, 1, 0x3C], [10, 7, 0, 0x7A], [11, 7, 1, 0x7B], [13, 7, 2, 0x7C], [17, 7, 3, 0x7D], [25, 7, 4, 0x7E], [41, 8, 5, 0xFE], [73, 8, 32, 0xFF]];
        break;

      case 13:
        lines = [[1, 1, 0, 0x0], [2, 3, 0, 0x4], [3, 4, 0, 0xC], [4, 5, 0, 0x1C], [5, 4, 1, 0xD], [7, 3, 3, 0x5], [15, 6, 1, 0x3A], [17, 6, 2, 0x3B], [21, 6, 3, 0x3C], [29, 6, 4, 0x3D], [45, 6, 5, 0x3E], [77, 7, 6, 0x7E], [141, 7, 32, 0x7F]];
        break;

      case 14:
        lines = [[-2, 3, 0, 0x4], [-1, 3, 0, 0x5], [0, 1, 0, 0x0], [1, 3, 0, 0x6], [2, 3, 0, 0x7]];
        break;

      case 15:
        lines = [[-24, 7, 4, 0x7C], [-8, 6, 2, 0x3C], [-4, 5, 1, 0x1C], [-2, 4, 0, 0xC], [-1, 3, 0, 0x4], [0, 1, 0, 0x0], [1, 3, 0, 0x5], [2, 4, 0, 0xD], [3, 5, 1, 0x1D], [5, 6, 2, 0x3D], [9, 7, 4, 0x7D], [-25, 7, 32, 0x7E, 'lower'], [25, 7, 32, 0x7F]];
        break;

      default:
        throw new Jbig2Error("standard table B.".concat(number, " does not exist"));
    }

    var length = lines.length,
        i;

    for (i = 0; i < length; i++) {
      lines[i] = new HuffmanLine(lines[i]);
    }

    table = new HuffmanTable(lines, true);
    standardTablesCache[number] = table;
    return table;
  }

  function Reader(data, start, end) {
    this.data = data;
    this.start = start;
    this.end = end;
    this.position = start;
    this.shift = -1;
    this.currentByte = 0;
  }

  Reader.prototype = {
    readBit: function readBit() {
      if (this.shift < 0) {
        if (this.position >= this.end) {
          throw new Jbig2Error('end of data while reading bit');
        }

        this.currentByte = this.data[this.position++];
        this.shift = 7;
      }

      var bit = this.currentByte >> this.shift & 1;
      this.shift--;
      return bit;
    },
    readBits: function readBits(numBits) {
      var result = 0,
          i;

      for (i = numBits - 1; i >= 0; i--) {
        result |= this.readBit() << i;
      }

      return result;
    },
    byteAlign: function byteAlign() {
      this.shift = -1;
    },
    next: function next() {
      if (this.position >= this.end) {
        return -1;
      }

      return this.data[this.position++];
    }
  };

  function getCustomHuffmanTable(index, referredTo, customTables) {
    var currentIndex = 0,
        i,
        ii = referredTo.length,
        table;

    for (i = 0; i < ii; i++) {
      table = customTables[referredTo[i]];

      if (table) {
        if (index === currentIndex) {
          return table;
        }

        currentIndex++;
      }
    }

    throw new Jbig2Error('can\'t find custom Huffman table');
  }

  function getTextRegionHuffmanTables(textRegion, referredTo, customTables, numberOfSymbols, reader) {
    var codes = [],
        i,
        codeLength;

    for (i = 0; i <= 34; i++) {
      codeLength = reader.readBits(4);
      codes.push(new HuffmanLine([i, codeLength, 0, 0]));
    }

    var runCodesTable = new HuffmanTable(codes, false);
    codes.length = 0;

    for (i = 0; i < numberOfSymbols;) {
      codeLength = runCodesTable.decode(reader);

      if (codeLength >= 32) {
        var repeatedLength = void 0,
            numberOfRepeats = void 0,
            j = void 0;

        switch (codeLength) {
          case 32:
            if (i === 0) {
              throw new Jbig2Error('no previous value in symbol ID table');
            }

            numberOfRepeats = reader.readBits(2) + 3;
            repeatedLength = codes[i - 1].prefixLength;
            break;

          case 33:
            numberOfRepeats = reader.readBits(3) + 3;
            repeatedLength = 0;
            break;

          case 34:
            numberOfRepeats = reader.readBits(7) + 11;
            repeatedLength = 0;
            break;

          default:
            throw new Jbig2Error('invalid code length in symbol ID table');
        }

        for (j = 0; j < numberOfRepeats; j++) {
          codes.push(new HuffmanLine([i, repeatedLength, 0, 0]));
          i++;
        }
      } else {
        codes.push(new HuffmanLine([i, codeLength, 0, 0]));
        i++;
      }
    }

    reader.byteAlign();
    var symbolIDTable = new HuffmanTable(codes, false);
    var customIndex = 0,
        tableFirstS,
        tableDeltaS,
        tableDeltaT;

    switch (textRegion.huffmanFS) {
      case 0:
      case 1:
        tableFirstS = getStandardTable(textRegion.huffmanFS + 6);
        break;

      case 3:
        tableFirstS = getCustomHuffmanTable(customIndex, referredTo, customTables);
        customIndex++;
        break;

      default:
        throw new Jbig2Error('invalid Huffman FS selector');
    }

    switch (textRegion.huffmanDS) {
      case 0:
      case 1:
      case 2:
        tableDeltaS = getStandardTable(textRegion.huffmanDS + 8);
        break;

      case 3:
        tableDeltaS = getCustomHuffmanTable(customIndex, referredTo, customTables);
        customIndex++;
        break;

      default:
        throw new Jbig2Error('invalid Huffman DS selector');
    }

    switch (textRegion.huffmanDT) {
      case 0:
      case 1:
      case 2:
        tableDeltaT = getStandardTable(textRegion.huffmanDT + 11);
        break;

      case 3:
        tableDeltaT = getCustomHuffmanTable(customIndex, referredTo, customTables);
        customIndex++;
        break;

      default:
        throw new Jbig2Error('invalid Huffman DT selector');
    }

    if (textRegion.refinement) {
      throw new Jbig2Error('refinement with Huffman is not supported');
    }

    return {
      symbolIDTable: symbolIDTable,
      tableFirstS: tableFirstS,
      tableDeltaS: tableDeltaS,
      tableDeltaT: tableDeltaT
    };
  }

  function getSymbolDictionaryHuffmanTables(dictionary, referredTo, customTables) {
    var customIndex = 0,
        tableDeltaHeight,
        tableDeltaWidth;

    switch (dictionary.huffmanDHSelector) {
      case 0:
      case 1:
        tableDeltaHeight = getStandardTable(dictionary.huffmanDHSelector + 4);
        break;

      case 3:
        tableDeltaHeight = getCustomHuffmanTable(customIndex, referredTo, customTables);
        customIndex++;
        break;

      default:
        throw new Jbig2Error('invalid Huffman DH selector');
    }

    switch (dictionary.huffmanDWSelector) {
      case 0:
      case 1:
        tableDeltaWidth = getStandardTable(dictionary.huffmanDWSelector + 2);
        break;

      case 3:
        tableDeltaWidth = getCustomHuffmanTable(customIndex, referredTo, customTables);
        customIndex++;
        break;

      default:
        throw new Jbig2Error('invalid Huffman DW selector');
    }

    var tableBitmapSize, tableAggregateInstances;

    if (dictionary.bitmapSizeSelector) {
      tableBitmapSize = getCustomHuffmanTable(customIndex, referredTo, customTables);
      customIndex++;
    } else {
      tableBitmapSize = getStandardTable(1);
    }

    if (dictionary.aggregationInstancesSelector) {
      tableAggregateInstances = getCustomHuffmanTable(customIndex, referredTo, customTables);
    } else {
      tableAggregateInstances = getStandardTable(1);
    }

    return {
      tableDeltaHeight: tableDeltaHeight,
      tableDeltaWidth: tableDeltaWidth,
      tableBitmapSize: tableBitmapSize,
      tableAggregateInstances: tableAggregateInstances
    };
  }

  function readUncompressedBitmap(reader, width, height) {
    var bitmap = [],
        x,
        y,
        row;

    for (y = 0; y < height; y++) {
      row = new Uint8Array(width);
      bitmap.push(row);

      for (x = 0; x < width; x++) {
        row[x] = reader.readBit();
      }

      reader.byteAlign();
    }

    return bitmap;
  }

  function decodeMMRBitmap(input, width, height, endOfBlock) {
    var params = {
      K: -1,
      Columns: width,
      Rows: height,
      BlackIs1: true,
      EndOfBlock: endOfBlock
    };
    var decoder = new _ccitt.CCITTFaxDecoder(input, params);
    var bitmap = [],
        x,
        y,
        row,
        currentByte,
        shift,
        eof = false;

    for (y = 0; y < height; y++) {
      row = new Uint8Array(width);
      bitmap.push(row);
      shift = -1;

      for (x = 0; x < width; x++) {
        if (shift < 0) {
          currentByte = decoder.readNextChar();

          if (currentByte === -1) {
            currentByte = 0;
            eof = true;
          }

          shift = 7;
        }

        row[x] = currentByte >> shift & 1;
        shift--;
      }
    }

    if (endOfBlock && !eof) {
      var lookForEOFLimit = 5;

      for (var i = 0; i < lookForEOFLimit; i++) {
        if (decoder.readNextChar() === -1) {
          break;
        }
      }
    }

    return bitmap;
  }

  function Jbig2Image() {}

  Jbig2Image.prototype = {
    parseChunks: function parseChunks(chunks) {
      return parseJbig2Chunks(chunks);
    },
    parse: function parse(data) {
      var _parseJbig = parseJbig2(data),
          imgData = _parseJbig.imgData,
          width = _parseJbig.width,
          height = _parseJbig.height;

      this.width = width;
      this.height = height;
      return imgData;
    }
  };
  return Jbig2Image;
}();

exports.Jbig2Image = Jbig2Image;

/***/ }),
/* 162 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ArithmeticDecoder = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var QeTable = [{
  qe: 0x5601,
  nmps: 1,
  nlps: 1,
  switchFlag: 1
}, {
  qe: 0x3401,
  nmps: 2,
  nlps: 6,
  switchFlag: 0
}, {
  qe: 0x1801,
  nmps: 3,
  nlps: 9,
  switchFlag: 0
}, {
  qe: 0x0AC1,
  nmps: 4,
  nlps: 12,
  switchFlag: 0
}, {
  qe: 0x0521,
  nmps: 5,
  nlps: 29,
  switchFlag: 0
}, {
  qe: 0x0221,
  nmps: 38,
  nlps: 33,
  switchFlag: 0
}, {
  qe: 0x5601,
  nmps: 7,
  nlps: 6,
  switchFlag: 1
}, {
  qe: 0x5401,
  nmps: 8,
  nlps: 14,
  switchFlag: 0
}, {
  qe: 0x4801,
  nmps: 9,
  nlps: 14,
  switchFlag: 0
}, {
  qe: 0x3801,
  nmps: 10,
  nlps: 14,
  switchFlag: 0
}, {
  qe: 0x3001,
  nmps: 11,
  nlps: 17,
  switchFlag: 0
}, {
  qe: 0x2401,
  nmps: 12,
  nlps: 18,
  switchFlag: 0
}, {
  qe: 0x1C01,
  nmps: 13,
  nlps: 20,
  switchFlag: 0
}, {
  qe: 0x1601,
  nmps: 29,
  nlps: 21,
  switchFlag: 0
}, {
  qe: 0x5601,
  nmps: 15,
  nlps: 14,
  switchFlag: 1
}, {
  qe: 0x5401,
  nmps: 16,
  nlps: 14,
  switchFlag: 0
}, {
  qe: 0x5101,
  nmps: 17,
  nlps: 15,
  switchFlag: 0
}, {
  qe: 0x4801,
  nmps: 18,
  nlps: 16,
  switchFlag: 0
}, {
  qe: 0x3801,
  nmps: 19,
  nlps: 17,
  switchFlag: 0
}, {
  qe: 0x3401,
  nmps: 20,
  nlps: 18,
  switchFlag: 0
}, {
  qe: 0x3001,
  nmps: 21,
  nlps: 19,
  switchFlag: 0
}, {
  qe: 0x2801,
  nmps: 22,
  nlps: 19,
  switchFlag: 0
}, {
  qe: 0x2401,
  nmps: 23,
  nlps: 20,
  switchFlag: 0
}, {
  qe: 0x2201,
  nmps: 24,
  nlps: 21,
  switchFlag: 0
}, {
  qe: 0x1C01,
  nmps: 25,
  nlps: 22,
  switchFlag: 0
}, {
  qe: 0x1801,
  nmps: 26,
  nlps: 23,
  switchFlag: 0
}, {
  qe: 0x1601,
  nmps: 27,
  nlps: 24,
  switchFlag: 0
}, {
  qe: 0x1401,
  nmps: 28,
  nlps: 25,
  switchFlag: 0
}, {
  qe: 0x1201,
  nmps: 29,
  nlps: 26,
  switchFlag: 0
}, {
  qe: 0x1101,
  nmps: 30,
  nlps: 27,
  switchFlag: 0
}, {
  qe: 0x0AC1,
  nmps: 31,
  nlps: 28,
  switchFlag: 0
}, {
  qe: 0x09C1,
  nmps: 32,
  nlps: 29,
  switchFlag: 0
}, {
  qe: 0x08A1,
  nmps: 33,
  nlps: 30,
  switchFlag: 0
}, {
  qe: 0x0521,
  nmps: 34,
  nlps: 31,
  switchFlag: 0
}, {
  qe: 0x0441,
  nmps: 35,
  nlps: 32,
  switchFlag: 0
}, {
  qe: 0x02A1,
  nmps: 36,
  nlps: 33,
  switchFlag: 0
}, {
  qe: 0x0221,
  nmps: 37,
  nlps: 34,
  switchFlag: 0
}, {
  qe: 0x0141,
  nmps: 38,
  nlps: 35,
  switchFlag: 0
}, {
  qe: 0x0111,
  nmps: 39,
  nlps: 36,
  switchFlag: 0
}, {
  qe: 0x0085,
  nmps: 40,
  nlps: 37,
  switchFlag: 0
}, {
  qe: 0x0049,
  nmps: 41,
  nlps: 38,
  switchFlag: 0
}, {
  qe: 0x0025,
  nmps: 42,
  nlps: 39,
  switchFlag: 0
}, {
  qe: 0x0015,
  nmps: 43,
  nlps: 40,
  switchFlag: 0
}, {
  qe: 0x0009,
  nmps: 44,
  nlps: 41,
  switchFlag: 0
}, {
  qe: 0x0005,
  nmps: 45,
  nlps: 42,
  switchFlag: 0
}, {
  qe: 0x0001,
  nmps: 45,
  nlps: 43,
  switchFlag: 0
}, {
  qe: 0x5601,
  nmps: 46,
  nlps: 46,
  switchFlag: 0
}];

var ArithmeticDecoder =
/*#__PURE__*/
function () {
  function ArithmeticDecoder(data, start, end) {
    _classCallCheck(this, ArithmeticDecoder);

    this.data = data;
    this.bp = start;
    this.dataEnd = end;
    this.chigh = data[start];
    this.clow = 0;
    this.byteIn();
    this.chigh = this.chigh << 7 & 0xFFFF | this.clow >> 9 & 0x7F;
    this.clow = this.clow << 7 & 0xFFFF;
    this.ct -= 7;
    this.a = 0x8000;
  }

  _createClass(ArithmeticDecoder, [{
    key: "byteIn",
    value: function byteIn() {
      var data = this.data;
      var bp = this.bp;

      if (data[bp] === 0xFF) {
        if (data[bp + 1] > 0x8F) {
          this.clow += 0xFF00;
          this.ct = 8;
        } else {
          bp++;
          this.clow += data[bp] << 9;
          this.ct = 7;
          this.bp = bp;
        }
      } else {
        bp++;
        this.clow += bp < this.dataEnd ? data[bp] << 8 : 0xFF00;
        this.ct = 8;
        this.bp = bp;
      }

      if (this.clow > 0xFFFF) {
        this.chigh += this.clow >> 16;
        this.clow &= 0xFFFF;
      }
    }
  }, {
    key: "readBit",
    value: function readBit(contexts, pos) {
      var cx_index = contexts[pos] >> 1,
          cx_mps = contexts[pos] & 1;
      var qeTableIcx = QeTable[cx_index];
      var qeIcx = qeTableIcx.qe;
      var d;
      var a = this.a - qeIcx;

      if (this.chigh < qeIcx) {
        if (a < qeIcx) {
          a = qeIcx;
          d = cx_mps;
          cx_index = qeTableIcx.nmps;
        } else {
          a = qeIcx;
          d = 1 ^ cx_mps;

          if (qeTableIcx.switchFlag === 1) {
            cx_mps = d;
          }

          cx_index = qeTableIcx.nlps;
        }
      } else {
        this.chigh -= qeIcx;

        if ((a & 0x8000) !== 0) {
          this.a = a;
          return cx_mps;
        }

        if (a < qeIcx) {
          d = 1 ^ cx_mps;

          if (qeTableIcx.switchFlag === 1) {
            cx_mps = d;
          }

          cx_index = qeTableIcx.nlps;
        } else {
          d = cx_mps;
          cx_index = qeTableIcx.nmps;
        }
      }

      do {
        if (this.ct === 0) {
          this.byteIn();
        }

        a <<= 1;
        this.chigh = this.chigh << 1 & 0xFFFF | this.clow >> 15 & 1;
        this.clow = this.clow << 1 & 0xFFFF;
        this.ct--;
      } while ((a & 0x8000) === 0);

      this.a = a;
      contexts[pos] = cx_index << 1 | cx_mps;
      return d;
    }
  }]);

  return ArithmeticDecoder;
}();

exports.ArithmeticDecoder = ArithmeticDecoder;

/***/ }),
/* 163 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JpegStream = void 0;

var _util = __w_pdfjs_require__(6);

var _stream = __w_pdfjs_require__(157);

var _primitives = __w_pdfjs_require__(155);

var _jpg = __w_pdfjs_require__(164);

var JpegStream = function JpegStreamClosure() {
  function JpegStream(stream, maybeLength, dict, params) {
    var ch;

    while ((ch = stream.getByte()) !== -1) {
      if (ch === 0xFF) {
        stream.skip(-1);
        break;
      }
    }

    this.stream = stream;
    this.maybeLength = maybeLength;
    this.dict = dict;
    this.params = params;

    _stream.DecodeStream.call(this, maybeLength);
  }

  JpegStream.prototype = Object.create(_stream.DecodeStream.prototype);
  Object.defineProperty(JpegStream.prototype, 'bytes', {
    get: function JpegStream_bytes() {
      return (0, _util.shadow)(this, 'bytes', this.stream.getBytes(this.maybeLength));
    },
    configurable: true
  });

  JpegStream.prototype.ensureBuffer = function (requested) {};

  JpegStream.prototype.readBlock = function () {
    if (this.eof) {
      return;
    }

    var jpegOptions = {
      decodeTransform: undefined,
      colorTransform: undefined
    };
    var decodeArr = this.dict.getArray('Decode', 'D');

    if (this.forceRGB && Array.isArray(decodeArr)) {
      var bitsPerComponent = this.dict.get('BitsPerComponent') || 8;
      var decodeArrLength = decodeArr.length;
      var transform = new Int32Array(decodeArrLength);
      var transformNeeded = false;
      var maxValue = (1 << bitsPerComponent) - 1;

      for (var i = 0; i < decodeArrLength; i += 2) {
        transform[i] = (decodeArr[i + 1] - decodeArr[i]) * 256 | 0;
        transform[i + 1] = decodeArr[i] * maxValue | 0;

        if (transform[i] !== 256 || transform[i + 1] !== 0) {
          transformNeeded = true;
        }
      }

      if (transformNeeded) {
        jpegOptions.decodeTransform = transform;
      }
    }

    if ((0, _primitives.isDict)(this.params)) {
      var colorTransform = this.params.get('ColorTransform');

      if (Number.isInteger(colorTransform)) {
        jpegOptions.colorTransform = colorTransform;
      }
    }

    var jpegImage = new _jpg.JpegImage(jpegOptions);
    jpegImage.parse(this.bytes);
    var data = jpegImage.getData({
      width: this.drawWidth,
      height: this.drawHeight,
      forceRGB: this.forceRGB,
      isSourcePDF: true
    });
    this.buffer = data;
    this.bufferLength = data.length;
    this.eof = true;
  };

  JpegStream.prototype.getIR = function () {
    var forceDataSchema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    return (0, _util.createObjectURL)(this.bytes, 'image/jpeg', forceDataSchema);
  };

  return JpegStream;
}();

exports.JpegStream = JpegStream;

/***/ }),
/* 164 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JpegImage = void 0;

var _util = __w_pdfjs_require__(6);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var JpegError = function JpegErrorClosure() {
  function JpegError(msg) {
    this.message = 'JPEG error: ' + msg;
  }

  JpegError.prototype = new Error();
  JpegError.prototype.name = 'JpegError';
  JpegError.constructor = JpegError;
  return JpegError;
}();

var DNLMarkerError = function DNLMarkerErrorClosure() {
  function DNLMarkerError(message, scanLines) {
    this.message = message;
    this.scanLines = scanLines;
  }

  DNLMarkerError.prototype = new Error();
  DNLMarkerError.prototype.name = 'DNLMarkerError';
  DNLMarkerError.constructor = DNLMarkerError;
  return DNLMarkerError;
}();

var EOIMarkerError = function EOIMarkerErrorClosure() {
  function EOIMarkerError(message) {
    this.message = message;
  }

  EOIMarkerError.prototype = new Error();
  EOIMarkerError.prototype.name = 'EOIMarkerError';
  EOIMarkerError.constructor = EOIMarkerError;
  return EOIMarkerError;
}();

var JpegImage = function JpegImageClosure() {
  var dctZigZag = new Uint8Array([0, 1, 8, 16, 9, 2, 3, 10, 17, 24, 32, 25, 18, 11, 4, 5, 12, 19, 26, 33, 40, 48, 41, 34, 27, 20, 13, 6, 7, 14, 21, 28, 35, 42, 49, 56, 57, 50, 43, 36, 29, 22, 15, 23, 30, 37, 44, 51, 58, 59, 52, 45, 38, 31, 39, 46, 53, 60, 61, 54, 47, 55, 62, 63]);
  var dctCos1 = 4017;
  var dctSin1 = 799;
  var dctCos3 = 3406;
  var dctSin3 = 2276;
  var dctCos6 = 1567;
  var dctSin6 = 3784;
  var dctSqrt2 = 5793;
  var dctSqrt1d2 = 2896;

  function JpegImage() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$decodeTransform = _ref.decodeTransform,
        decodeTransform = _ref$decodeTransform === void 0 ? null : _ref$decodeTransform,
        _ref$colorTransform = _ref.colorTransform,
        colorTransform = _ref$colorTransform === void 0 ? -1 : _ref$colorTransform;

    this._decodeTransform = decodeTransform;
    this._colorTransform = colorTransform;
  }

  function buildHuffmanTable(codeLengths, values) {
    var k = 0,
        code = [],
        i,
        j,
        length = 16;

    while (length > 0 && !codeLengths[length - 1]) {
      length--;
    }

    code.push({
      children: [],
      index: 0
    });
    var p = code[0],
        q;

    for (i = 0; i < length; i++) {
      for (j = 0; j < codeLengths[i]; j++) {
        p = code.pop();
        p.children[p.index] = values[k];

        while (p.index > 0) {
          p = code.pop();
        }

        p.index++;
        code.push(p);

        while (code.length <= i) {
          code.push(q = {
            children: [],
            index: 0
          });
          p.children[p.index] = q.children;
          p = q;
        }

        k++;
      }

      if (i + 1 < length) {
        code.push(q = {
          children: [],
          index: 0
        });
        p.children[p.index] = q.children;
        p = q;
      }
    }

    return code[0].children;
  }

  function getBlockBufferOffset(component, row, col) {
    return 64 * ((component.blocksPerLine + 1) * row + col);
  }

  function decodeScan(data, offset, frame, components, resetInterval, spectralStart, spectralEnd, successivePrev, successive) {
    var parseDNLMarker = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : false;
    var mcusPerLine = frame.mcusPerLine;
    var progressive = frame.progressive;
    var startOffset = offset,
        bitsData = 0,
        bitsCount = 0;

    function readBit() {
      if (bitsCount > 0) {
        bitsCount--;
        return bitsData >> bitsCount & 1;
      }

      bitsData = data[offset++];

      if (bitsData === 0xFF) {
        var nextByte = data[offset++];

        if (nextByte) {
          if (nextByte === 0xDC && parseDNLMarker) {
            offset += 2;
            var scanLines = data[offset++] << 8 | data[offset++];

            if (scanLines > 0 && scanLines !== frame.scanLines) {
              throw new DNLMarkerError('Found DNL marker (0xFFDC) while parsing scan data', scanLines);
            }
          } else if (nextByte === 0xD9) {
            throw new EOIMarkerError('Found EOI marker (0xFFD9) while parsing scan data');
          }

          throw new JpegError("unexpected marker ".concat((bitsData << 8 | nextByte).toString(16)));
        }
      }

      bitsCount = 7;
      return bitsData >>> 7;
    }

    function decodeHuffman(tree) {
      var node = tree;

      while (true) {
        node = node[readBit()];

        if (typeof node === 'number') {
          return node;
        }

        if (_typeof(node) !== 'object') {
          throw new JpegError('invalid huffman sequence');
        }
      }
    }

    function receive(length) {
      var n = 0;

      while (length > 0) {
        n = n << 1 | readBit();
        length--;
      }

      return n;
    }

    function receiveAndExtend(length) {
      if (length === 1) {
        return readBit() === 1 ? 1 : -1;
      }

      var n = receive(length);

      if (n >= 1 << length - 1) {
        return n;
      }

      return n + (-1 << length) + 1;
    }

    function decodeBaseline(component, offset) {
      var t = decodeHuffman(component.huffmanTableDC);
      var diff = t === 0 ? 0 : receiveAndExtend(t);
      component.blockData[offset] = component.pred += diff;
      var k = 1;

      while (k < 64) {
        var rs = decodeHuffman(component.huffmanTableAC);
        var s = rs & 15,
            r = rs >> 4;

        if (s === 0) {
          if (r < 15) {
            break;
          }

          k += 16;
          continue;
        }

        k += r;
        var z = dctZigZag[k];
        component.blockData[offset + z] = receiveAndExtend(s);
        k++;
      }
    }

    function decodeDCFirst(component, offset) {
      var t = decodeHuffman(component.huffmanTableDC);
      var diff = t === 0 ? 0 : receiveAndExtend(t) << successive;
      component.blockData[offset] = component.pred += diff;
    }

    function decodeDCSuccessive(component, offset) {
      component.blockData[offset] |= readBit() << successive;
    }

    var eobrun = 0;

    function decodeACFirst(component, offset) {
      if (eobrun > 0) {
        eobrun--;
        return;
      }

      var k = spectralStart,
          e = spectralEnd;

      while (k <= e) {
        var rs = decodeHuffman(component.huffmanTableAC);
        var s = rs & 15,
            r = rs >> 4;

        if (s === 0) {
          if (r < 15) {
            eobrun = receive(r) + (1 << r) - 1;
            break;
          }

          k += 16;
          continue;
        }

        k += r;
        var z = dctZigZag[k];
        component.blockData[offset + z] = receiveAndExtend(s) * (1 << successive);
        k++;
      }
    }

    var successiveACState = 0,
        successiveACNextValue;

    function decodeACSuccessive(component, offset) {
      var k = spectralStart;
      var e = spectralEnd;
      var r = 0;
      var s;
      var rs;

      while (k <= e) {
        var offsetZ = offset + dctZigZag[k];
        var sign = component.blockData[offsetZ] < 0 ? -1 : 1;

        switch (successiveACState) {
          case 0:
            rs = decodeHuffman(component.huffmanTableAC);
            s = rs & 15;
            r = rs >> 4;

            if (s === 0) {
              if (r < 15) {
                eobrun = receive(r) + (1 << r);
                successiveACState = 4;
              } else {
                r = 16;
                successiveACState = 1;
              }
            } else {
              if (s !== 1) {
                throw new JpegError('invalid ACn encoding');
              }

              successiveACNextValue = receiveAndExtend(s);
              successiveACState = r ? 2 : 3;
            }

            continue;

          case 1:
          case 2:
            if (component.blockData[offsetZ]) {
              component.blockData[offsetZ] += sign * (readBit() << successive);
            } else {
              r--;

              if (r === 0) {
                successiveACState = successiveACState === 2 ? 3 : 0;
              }
            }

            break;

          case 3:
            if (component.blockData[offsetZ]) {
              component.blockData[offsetZ] += sign * (readBit() << successive);
            } else {
              component.blockData[offsetZ] = successiveACNextValue << successive;
              successiveACState = 0;
            }

            break;

          case 4:
            if (component.blockData[offsetZ]) {
              component.blockData[offsetZ] += sign * (readBit() << successive);
            }

            break;
        }

        k++;
      }

      if (successiveACState === 4) {
        eobrun--;

        if (eobrun === 0) {
          successiveACState = 0;
        }
      }
    }

    function decodeMcu(component, decode, mcu, row, col) {
      var mcuRow = mcu / mcusPerLine | 0;
      var mcuCol = mcu % mcusPerLine;
      var blockRow = mcuRow * component.v + row;
      var blockCol = mcuCol * component.h + col;
      var offset = getBlockBufferOffset(component, blockRow, blockCol);
      decode(component, offset);
    }

    function decodeBlock(component, decode, mcu) {
      var blockRow = mcu / component.blocksPerLine | 0;
      var blockCol = mcu % component.blocksPerLine;
      var offset = getBlockBufferOffset(component, blockRow, blockCol);
      decode(component, offset);
    }

    var componentsLength = components.length;
    var component, i, j, k, n;
    var decodeFn;

    if (progressive) {
      if (spectralStart === 0) {
        decodeFn = successivePrev === 0 ? decodeDCFirst : decodeDCSuccessive;
      } else {
        decodeFn = successivePrev === 0 ? decodeACFirst : decodeACSuccessive;
      }
    } else {
      decodeFn = decodeBaseline;
    }

    var mcu = 0,
        fileMarker;
    var mcuExpected;

    if (componentsLength === 1) {
      mcuExpected = components[0].blocksPerLine * components[0].blocksPerColumn;
    } else {
      mcuExpected = mcusPerLine * frame.mcusPerColumn;
    }

    var h, v;

    while (mcu < mcuExpected) {
      var mcuToRead = resetInterval ? Math.min(mcuExpected - mcu, resetInterval) : mcuExpected;

      for (i = 0; i < componentsLength; i++) {
        components[i].pred = 0;
      }

      eobrun = 0;

      if (componentsLength === 1) {
        component = components[0];

        for (n = 0; n < mcuToRead; n++) {
          decodeBlock(component, decodeFn, mcu);
          mcu++;
        }
      } else {
        for (n = 0; n < mcuToRead; n++) {
          for (i = 0; i < componentsLength; i++) {
            component = components[i];
            h = component.h;
            v = component.v;

            for (j = 0; j < v; j++) {
              for (k = 0; k < h; k++) {
                decodeMcu(component, decodeFn, mcu, j, k);
              }
            }
          }

          mcu++;
        }
      }

      bitsCount = 0;
      fileMarker = findNextFileMarker(data, offset);

      if (fileMarker && fileMarker.invalid) {
        (0, _util.warn)('decodeScan - unexpected MCU data, current marker is: ' + fileMarker.invalid);
        offset = fileMarker.offset;
      }

      var marker = fileMarker && fileMarker.marker;

      if (!marker || marker <= 0xFF00) {
        throw new JpegError('marker was not found');
      }

      if (marker >= 0xFFD0 && marker <= 0xFFD7) {
        offset += 2;
      } else {
        break;
      }
    }

    fileMarker = findNextFileMarker(data, offset);

    if (fileMarker && fileMarker.invalid) {
      (0, _util.warn)('decodeScan - unexpected Scan data, current marker is: ' + fileMarker.invalid);
      offset = fileMarker.offset;
    }

    return offset - startOffset;
  }

  function quantizeAndInverse(component, blockBufferOffset, p) {
    var qt = component.quantizationTable,
        blockData = component.blockData;
    var v0, v1, v2, v3, v4, v5, v6, v7;
    var p0, p1, p2, p3, p4, p5, p6, p7;
    var t;

    if (!qt) {
      throw new JpegError('missing required Quantization Table.');
    }

    for (var row = 0; row < 64; row += 8) {
      p0 = blockData[blockBufferOffset + row];
      p1 = blockData[blockBufferOffset + row + 1];
      p2 = blockData[blockBufferOffset + row + 2];
      p3 = blockData[blockBufferOffset + row + 3];
      p4 = blockData[blockBufferOffset + row + 4];
      p5 = blockData[blockBufferOffset + row + 5];
      p6 = blockData[blockBufferOffset + row + 6];
      p7 = blockData[blockBufferOffset + row + 7];
      p0 *= qt[row];

      if ((p1 | p2 | p3 | p4 | p5 | p6 | p7) === 0) {
        t = dctSqrt2 * p0 + 512 >> 10;
        p[row] = t;
        p[row + 1] = t;
        p[row + 2] = t;
        p[row + 3] = t;
        p[row + 4] = t;
        p[row + 5] = t;
        p[row + 6] = t;
        p[row + 7] = t;
        continue;
      }

      p1 *= qt[row + 1];
      p2 *= qt[row + 2];
      p3 *= qt[row + 3];
      p4 *= qt[row + 4];
      p5 *= qt[row + 5];
      p6 *= qt[row + 6];
      p7 *= qt[row + 7];
      v0 = dctSqrt2 * p0 + 128 >> 8;
      v1 = dctSqrt2 * p4 + 128 >> 8;
      v2 = p2;
      v3 = p6;
      v4 = dctSqrt1d2 * (p1 - p7) + 128 >> 8;
      v7 = dctSqrt1d2 * (p1 + p7) + 128 >> 8;
      v5 = p3 << 4;
      v6 = p5 << 4;
      v0 = v0 + v1 + 1 >> 1;
      v1 = v0 - v1;
      t = v2 * dctSin6 + v3 * dctCos6 + 128 >> 8;
      v2 = v2 * dctCos6 - v3 * dctSin6 + 128 >> 8;
      v3 = t;
      v4 = v4 + v6 + 1 >> 1;
      v6 = v4 - v6;
      v7 = v7 + v5 + 1 >> 1;
      v5 = v7 - v5;
      v0 = v0 + v3 + 1 >> 1;
      v3 = v0 - v3;
      v1 = v1 + v2 + 1 >> 1;
      v2 = v1 - v2;
      t = v4 * dctSin3 + v7 * dctCos3 + 2048 >> 12;
      v4 = v4 * dctCos3 - v7 * dctSin3 + 2048 >> 12;
      v7 = t;
      t = v5 * dctSin1 + v6 * dctCos1 + 2048 >> 12;
      v5 = v5 * dctCos1 - v6 * dctSin1 + 2048 >> 12;
      v6 = t;
      p[row] = v0 + v7;
      p[row + 7] = v0 - v7;
      p[row + 1] = v1 + v6;
      p[row + 6] = v1 - v6;
      p[row + 2] = v2 + v5;
      p[row + 5] = v2 - v5;
      p[row + 3] = v3 + v4;
      p[row + 4] = v3 - v4;
    }

    for (var col = 0; col < 8; ++col) {
      p0 = p[col];
      p1 = p[col + 8];
      p2 = p[col + 16];
      p3 = p[col + 24];
      p4 = p[col + 32];
      p5 = p[col + 40];
      p6 = p[col + 48];
      p7 = p[col + 56];

      if ((p1 | p2 | p3 | p4 | p5 | p6 | p7) === 0) {
        t = dctSqrt2 * p0 + 8192 >> 14;
        t = t < -2040 ? 0 : t >= 2024 ? 255 : t + 2056 >> 4;
        blockData[blockBufferOffset + col] = t;
        blockData[blockBufferOffset + col + 8] = t;
        blockData[blockBufferOffset + col + 16] = t;
        blockData[blockBufferOffset + col + 24] = t;
        blockData[blockBufferOffset + col + 32] = t;
        blockData[blockBufferOffset + col + 40] = t;
        blockData[blockBufferOffset + col + 48] = t;
        blockData[blockBufferOffset + col + 56] = t;
        continue;
      }

      v0 = dctSqrt2 * p0 + 2048 >> 12;
      v1 = dctSqrt2 * p4 + 2048 >> 12;
      v2 = p2;
      v3 = p6;
      v4 = dctSqrt1d2 * (p1 - p7) + 2048 >> 12;
      v7 = dctSqrt1d2 * (p1 + p7) + 2048 >> 12;
      v5 = p3;
      v6 = p5;
      v0 = (v0 + v1 + 1 >> 1) + 4112;
      v1 = v0 - v1;
      t = v2 * dctSin6 + v3 * dctCos6 + 2048 >> 12;
      v2 = v2 * dctCos6 - v3 * dctSin6 + 2048 >> 12;
      v3 = t;
      v4 = v4 + v6 + 1 >> 1;
      v6 = v4 - v6;
      v7 = v7 + v5 + 1 >> 1;
      v5 = v7 - v5;
      v0 = v0 + v3 + 1 >> 1;
      v3 = v0 - v3;
      v1 = v1 + v2 + 1 >> 1;
      v2 = v1 - v2;
      t = v4 * dctSin3 + v7 * dctCos3 + 2048 >> 12;
      v4 = v4 * dctCos3 - v7 * dctSin3 + 2048 >> 12;
      v7 = t;
      t = v5 * dctSin1 + v6 * dctCos1 + 2048 >> 12;
      v5 = v5 * dctCos1 - v6 * dctSin1 + 2048 >> 12;
      v6 = t;
      p0 = v0 + v7;
      p7 = v0 - v7;
      p1 = v1 + v6;
      p6 = v1 - v6;
      p2 = v2 + v5;
      p5 = v2 - v5;
      p3 = v3 + v4;
      p4 = v3 - v4;
      p0 = p0 < 16 ? 0 : p0 >= 4080 ? 255 : p0 >> 4;
      p1 = p1 < 16 ? 0 : p1 >= 4080 ? 255 : p1 >> 4;
      p2 = p2 < 16 ? 0 : p2 >= 4080 ? 255 : p2 >> 4;
      p3 = p3 < 16 ? 0 : p3 >= 4080 ? 255 : p3 >> 4;
      p4 = p4 < 16 ? 0 : p4 >= 4080 ? 255 : p4 >> 4;
      p5 = p5 < 16 ? 0 : p5 >= 4080 ? 255 : p5 >> 4;
      p6 = p6 < 16 ? 0 : p6 >= 4080 ? 255 : p6 >> 4;
      p7 = p7 < 16 ? 0 : p7 >= 4080 ? 255 : p7 >> 4;
      blockData[blockBufferOffset + col] = p0;
      blockData[blockBufferOffset + col + 8] = p1;
      blockData[blockBufferOffset + col + 16] = p2;
      blockData[blockBufferOffset + col + 24] = p3;
      blockData[blockBufferOffset + col + 32] = p4;
      blockData[blockBufferOffset + col + 40] = p5;
      blockData[blockBufferOffset + col + 48] = p6;
      blockData[blockBufferOffset + col + 56] = p7;
    }
  }

  function buildComponentData(frame, component) {
    var blocksPerLine = component.blocksPerLine;
    var blocksPerColumn = component.blocksPerColumn;
    var computationBuffer = new Int16Array(64);

    for (var blockRow = 0; blockRow < blocksPerColumn; blockRow++) {
      for (var blockCol = 0; blockCol < blocksPerLine; blockCol++) {
        var offset = getBlockBufferOffset(component, blockRow, blockCol);
        quantizeAndInverse(component, offset, computationBuffer);
      }
    }

    return component.blockData;
  }

  function findNextFileMarker(data, currentPos) {
    var startPos = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : currentPos;

    function peekUint16(pos) {
      return data[pos] << 8 | data[pos + 1];
    }

    var maxPos = data.length - 1;
    var newPos = startPos < currentPos ? startPos : currentPos;

    if (currentPos >= maxPos) {
      return null;
    }

    var currentMarker = peekUint16(currentPos);

    if (currentMarker >= 0xFFC0 && currentMarker <= 0xFFFE) {
      return {
        invalid: null,
        marker: currentMarker,
        offset: currentPos
      };
    }

    var newMarker = peekUint16(newPos);

    while (!(newMarker >= 0xFFC0 && newMarker <= 0xFFFE)) {
      if (++newPos >= maxPos) {
        return null;
      }

      newMarker = peekUint16(newPos);
    }

    return {
      invalid: currentMarker.toString(16),
      marker: newMarker,
      offset: newPos
    };
  }

  JpegImage.prototype = {
    parse: function parse(data) {
      var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref2$dnlScanLines = _ref2.dnlScanLines,
          dnlScanLines = _ref2$dnlScanLines === void 0 ? null : _ref2$dnlScanLines;

      function readUint16() {
        var value = data[offset] << 8 | data[offset + 1];
        offset += 2;
        return value;
      }

      function readDataBlock() {
        var length = readUint16();
        var endOffset = offset + length - 2;
        var fileMarker = findNextFileMarker(data, endOffset, offset);

        if (fileMarker && fileMarker.invalid) {
          (0, _util.warn)('readDataBlock - incorrect length, current marker is: ' + fileMarker.invalid);
          endOffset = fileMarker.offset;
        }

        var array = data.subarray(offset, endOffset);
        offset += array.length;
        return array;
      }

      function prepareComponents(frame) {
        var mcusPerLine = Math.ceil(frame.samplesPerLine / 8 / frame.maxH);
        var mcusPerColumn = Math.ceil(frame.scanLines / 8 / frame.maxV);

        for (var i = 0; i < frame.components.length; i++) {
          component = frame.components[i];
          var blocksPerLine = Math.ceil(Math.ceil(frame.samplesPerLine / 8) * component.h / frame.maxH);
          var blocksPerColumn = Math.ceil(Math.ceil(frame.scanLines / 8) * component.v / frame.maxV);
          var blocksPerLineForMcu = mcusPerLine * component.h;
          var blocksPerColumnForMcu = mcusPerColumn * component.v;
          var blocksBufferSize = 64 * blocksPerColumnForMcu * (blocksPerLineForMcu + 1);
          component.blockData = new Int16Array(blocksBufferSize);
          component.blocksPerLine = blocksPerLine;
          component.blocksPerColumn = blocksPerColumn;
        }

        frame.mcusPerLine = mcusPerLine;
        frame.mcusPerColumn = mcusPerColumn;
      }

      var offset = 0;
      var jfif = null;
      var adobe = null;
      var frame, resetInterval;
      var numSOSMarkers = 0;
      var quantizationTables = [];
      var huffmanTablesAC = [],
          huffmanTablesDC = [];
      var fileMarker = readUint16();

      if (fileMarker !== 0xFFD8) {
        throw new JpegError('SOI not found');
      }

      fileMarker = readUint16();

      markerLoop: while (fileMarker !== 0xFFD9) {
        var i, j, l;

        switch (fileMarker) {
          case 0xFFE0:
          case 0xFFE1:
          case 0xFFE2:
          case 0xFFE3:
          case 0xFFE4:
          case 0xFFE5:
          case 0xFFE6:
          case 0xFFE7:
          case 0xFFE8:
          case 0xFFE9:
          case 0xFFEA:
          case 0xFFEB:
          case 0xFFEC:
          case 0xFFED:
          case 0xFFEE:
          case 0xFFEF:
          case 0xFFFE:
            var appData = readDataBlock();

            if (fileMarker === 0xFFE0) {
              if (appData[0] === 0x4A && appData[1] === 0x46 && appData[2] === 0x49 && appData[3] === 0x46 && appData[4] === 0) {
                jfif = {
                  version: {
                    major: appData[5],
                    minor: appData[6]
                  },
                  densityUnits: appData[7],
                  xDensity: appData[8] << 8 | appData[9],
                  yDensity: appData[10] << 8 | appData[11],
                  thumbWidth: appData[12],
                  thumbHeight: appData[13],
                  thumbData: appData.subarray(14, 14 + 3 * appData[12] * appData[13])
                };
              }
            }

            if (fileMarker === 0xFFEE) {
              if (appData[0] === 0x41 && appData[1] === 0x64 && appData[2] === 0x6F && appData[3] === 0x62 && appData[4] === 0x65) {
                adobe = {
                  version: appData[5] << 8 | appData[6],
                  flags0: appData[7] << 8 | appData[8],
                  flags1: appData[9] << 8 | appData[10],
                  transformCode: appData[11]
                };
              }
            }

            break;

          case 0xFFDB:
            var quantizationTablesLength = readUint16();
            var quantizationTablesEnd = quantizationTablesLength + offset - 2;
            var z;

            while (offset < quantizationTablesEnd) {
              var quantizationTableSpec = data[offset++];
              var tableData = new Uint16Array(64);

              if (quantizationTableSpec >> 4 === 0) {
                for (j = 0; j < 64; j++) {
                  z = dctZigZag[j];
                  tableData[z] = data[offset++];
                }
              } else if (quantizationTableSpec >> 4 === 1) {
                for (j = 0; j < 64; j++) {
                  z = dctZigZag[j];
                  tableData[z] = readUint16();
                }
              } else {
                throw new JpegError('DQT - invalid table spec');
              }

              quantizationTables[quantizationTableSpec & 15] = tableData;
            }

            break;

          case 0xFFC0:
          case 0xFFC1:
          case 0xFFC2:
            if (frame) {
              throw new JpegError('Only single frame JPEGs supported');
            }

            readUint16();
            frame = {};
            frame.extended = fileMarker === 0xFFC1;
            frame.progressive = fileMarker === 0xFFC2;
            frame.precision = data[offset++];
            var sofScanLines = readUint16();
            frame.scanLines = dnlScanLines || sofScanLines;
            frame.samplesPerLine = readUint16();
            frame.components = [];
            frame.componentIds = {};
            var componentsCount = data[offset++],
                componentId;
            var maxH = 0,
                maxV = 0;

            for (i = 0; i < componentsCount; i++) {
              componentId = data[offset];
              var h = data[offset + 1] >> 4;
              var v = data[offset + 1] & 15;

              if (maxH < h) {
                maxH = h;
              }

              if (maxV < v) {
                maxV = v;
              }

              var qId = data[offset + 2];
              l = frame.components.push({
                h: h,
                v: v,
                quantizationId: qId,
                quantizationTable: null
              });
              frame.componentIds[componentId] = l - 1;
              offset += 3;
            }

            frame.maxH = maxH;
            frame.maxV = maxV;
            prepareComponents(frame);
            break;

          case 0xFFC4:
            var huffmanLength = readUint16();

            for (i = 2; i < huffmanLength;) {
              var huffmanTableSpec = data[offset++];
              var codeLengths = new Uint8Array(16);
              var codeLengthSum = 0;

              for (j = 0; j < 16; j++, offset++) {
                codeLengthSum += codeLengths[j] = data[offset];
              }

              var huffmanValues = new Uint8Array(codeLengthSum);

              for (j = 0; j < codeLengthSum; j++, offset++) {
                huffmanValues[j] = data[offset];
              }

              i += 17 + codeLengthSum;
              (huffmanTableSpec >> 4 === 0 ? huffmanTablesDC : huffmanTablesAC)[huffmanTableSpec & 15] = buildHuffmanTable(codeLengths, huffmanValues);
            }

            break;

          case 0xFFDD:
            readUint16();
            resetInterval = readUint16();
            break;

          case 0xFFDA:
            var parseDNLMarker = ++numSOSMarkers === 1 && !dnlScanLines;
            readUint16();
            var selectorsCount = data[offset++];
            var components = [],
                component;

            for (i = 0; i < selectorsCount; i++) {
              var componentIndex = frame.componentIds[data[offset++]];
              component = frame.components[componentIndex];
              var tableSpec = data[offset++];
              component.huffmanTableDC = huffmanTablesDC[tableSpec >> 4];
              component.huffmanTableAC = huffmanTablesAC[tableSpec & 15];
              components.push(component);
            }

            var spectralStart = data[offset++];
            var spectralEnd = data[offset++];
            var successiveApproximation = data[offset++];

            try {
              var processed = decodeScan(data, offset, frame, components, resetInterval, spectralStart, spectralEnd, successiveApproximation >> 4, successiveApproximation & 15, parseDNLMarker);
              offset += processed;
            } catch (ex) {
              if (ex instanceof DNLMarkerError) {
                (0, _util.warn)("".concat(ex.message, " -- attempting to re-parse the JPEG image."));
                return this.parse(data, {
                  dnlScanLines: ex.scanLines
                });
              } else if (ex instanceof EOIMarkerError) {
                (0, _util.warn)("".concat(ex.message, " -- ignoring the rest of the image data."));
                break markerLoop;
              }

              throw ex;
            }

            break;

          case 0xFFDC:
            offset += 4;
            break;

          case 0xFFFF:
            if (data[offset] !== 0xFF) {
              offset--;
            }

            break;

          default:
            if (data[offset - 3] === 0xFF && data[offset - 2] >= 0xC0 && data[offset - 2] <= 0xFE) {
              offset -= 3;
              break;
            }

            var nextFileMarker = findNextFileMarker(data, offset - 2);

            if (nextFileMarker && nextFileMarker.invalid) {
              (0, _util.warn)('JpegImage.parse - unexpected data, current marker is: ' + nextFileMarker.invalid);
              offset = nextFileMarker.offset;
              break;
            }

            throw new JpegError('unknown marker ' + fileMarker.toString(16));
        }

        fileMarker = readUint16();
      }

      this.width = frame.samplesPerLine;
      this.height = frame.scanLines;
      this.jfif = jfif;
      this.adobe = adobe;
      this.components = [];

      for (i = 0; i < frame.components.length; i++) {
        component = frame.components[i];
        var quantizationTable = quantizationTables[component.quantizationId];

        if (quantizationTable) {
          component.quantizationTable = quantizationTable;
        }

        this.components.push({
          output: buildComponentData(frame, component),
          scaleX: component.h / frame.maxH,
          scaleY: component.v / frame.maxV,
          blocksPerLine: component.blocksPerLine,
          blocksPerColumn: component.blocksPerColumn
        });
      }

      this.numComponents = this.components.length;
    },
    _getLinearizedBlockData: function _getLinearizedBlockData(width, height) {
      var isSourcePDF = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var scaleX = this.width / width,
          scaleY = this.height / height;
      var component, componentScaleX, componentScaleY, blocksPerScanline;
      var x, y, i, j, k;
      var index;
      var offset = 0;
      var output;
      var numComponents = this.components.length;
      var dataLength = width * height * numComponents;
      var data = new Uint8ClampedArray(dataLength);
      var xScaleBlockOffset = new Uint32Array(width);
      var mask3LSB = 0xfffffff8;

      for (i = 0; i < numComponents; i++) {
        component = this.components[i];
        componentScaleX = component.scaleX * scaleX;
        componentScaleY = component.scaleY * scaleY;
        offset = i;
        output = component.output;
        blocksPerScanline = component.blocksPerLine + 1 << 3;

        for (x = 0; x < width; x++) {
          j = 0 | x * componentScaleX;
          xScaleBlockOffset[x] = (j & mask3LSB) << 3 | j & 7;
        }

        for (y = 0; y < height; y++) {
          j = 0 | y * componentScaleY;
          index = blocksPerScanline * (j & mask3LSB) | (j & 7) << 3;

          for (x = 0; x < width; x++) {
            data[offset] = output[index + xScaleBlockOffset[x]];
            offset += numComponents;
          }
        }
      }

      var transform = this._decodeTransform;

      if (!isSourcePDF && numComponents === 4 && !transform) {
        transform = new Int32Array([-256, 255, -256, 255, -256, 255, -256, 255]);
      }

      if (transform) {
        for (i = 0; i < dataLength;) {
          for (j = 0, k = 0; j < numComponents; j++, i++, k += 2) {
            data[i] = (data[i] * transform[k] >> 8) + transform[k + 1];
          }
        }
      }

      return data;
    },

    get _isColorConversionNeeded() {
      if (this.adobe) {
        return !!this.adobe.transformCode;
      }

      if (this.numComponents === 3) {
        if (this._colorTransform === 0) {
          return false;
        }

        return true;
      }

      if (this._colorTransform === 1) {
        return true;
      }

      return false;
    },

    _convertYccToRgb: function convertYccToRgb(data) {
      var Y, Cb, Cr;

      for (var i = 0, length = data.length; i < length; i += 3) {
        Y = data[i];
        Cb = data[i + 1];
        Cr = data[i + 2];
        data[i] = Y - 179.456 + 1.402 * Cr;
        data[i + 1] = Y + 135.459 - 0.344 * Cb - 0.714 * Cr;
        data[i + 2] = Y - 226.816 + 1.772 * Cb;
      }

      return data;
    },
    _convertYcckToRgb: function convertYcckToRgb(data) {
      var Y, Cb, Cr, k;
      var offset = 0;

      for (var i = 0, length = data.length; i < length; i += 4) {
        Y = data[i];
        Cb = data[i + 1];
        Cr = data[i + 2];
        k = data[i + 3];
        data[offset++] = -122.67195406894 + Cb * (-6.60635669420364e-5 * Cb + 0.000437130475926232 * Cr - 5.4080610064599e-5 * Y + 0.00048449797120281 * k - 0.154362151871126) + Cr * (-0.000957964378445773 * Cr + 0.000817076911346625 * Y - 0.00477271405408747 * k + 1.53380253221734) + Y * (0.000961250184130688 * Y - 0.00266257332283933 * k + 0.48357088451265) + k * (-0.000336197177618394 * k + 0.484791561490776);
        data[offset++] = 107.268039397724 + Cb * (2.19927104525741e-5 * Cb - 0.000640992018297945 * Cr + 0.000659397001245577 * Y + 0.000426105652938837 * k - 0.176491792462875) + Cr * (-0.000778269941513683 * Cr + 0.00130872261408275 * Y + 0.000770482631801132 * k - 0.151051492775562) + Y * (0.00126935368114843 * Y - 0.00265090189010898 * k + 0.25802910206845) + k * (-0.000318913117588328 * k - 0.213742400323665);
        data[offset++] = -20.810012546947 + Cb * (-0.000570115196973677 * Cb - 2.63409051004589e-5 * Cr + 0.0020741088115012 * Y - 0.00288260236853442 * k + 0.814272968359295) + Cr * (-1.53496057440975e-5 * Cr - 0.000132689043961446 * Y + 0.000560833691242812 * k - 0.195152027534049) + Y * (0.00174418132927582 * Y - 0.00255243321439347 * k + 0.116935020465145) + k * (-0.000343531996510555 * k + 0.24165260232407);
      }

      return data.subarray(0, offset);
    },
    _convertYcckToCmyk: function convertYcckToCmyk(data) {
      var Y, Cb, Cr;

      for (var i = 0, length = data.length; i < length; i += 4) {
        Y = data[i];
        Cb = data[i + 1];
        Cr = data[i + 2];
        data[i] = 434.456 - Y - 1.402 * Cr;
        data[i + 1] = 119.541 - Y + 0.344 * Cb + 0.714 * Cr;
        data[i + 2] = 481.816 - Y - 1.772 * Cb;
      }

      return data;
    },
    _convertCmykToRgb: function convertCmykToRgb(data) {
      var c, m, y, k;
      var offset = 0;
      var scale = 1 / 255;

      for (var i = 0, length = data.length; i < length; i += 4) {
        c = data[i] * scale;
        m = data[i + 1] * scale;
        y = data[i + 2] * scale;
        k = data[i + 3] * scale;
        data[offset++] = 255 + c * (-4.387332384609988 * c + 54.48615194189176 * m + 18.82290502165302 * y + 212.25662451639585 * k - 285.2331026137004) + m * (1.7149763477362134 * m - 5.6096736904047315 * y - 17.873870861415444 * k - 5.497006427196366) + y * (-2.5217340131683033 * y - 21.248923337353073 * k + 17.5119270841813) - k * (21.86122147463605 * k + 189.48180835922747);
        data[offset++] = 255 + c * (8.841041422036149 * c + 60.118027045597366 * m + 6.871425592049007 * y + 31.159100130055922 * k - 79.2970844816548) + m * (-15.310361306967817 * m + 17.575251261109482 * y + 131.35250912493976 * k - 190.9453302588951) + y * (4.444339102852739 * y + 9.8632861493405 * k - 24.86741582555878) - k * (20.737325471181034 * k + 187.80453709719578);
        data[offset++] = 255 + c * (0.8842522430003296 * c + 8.078677503112928 * m + 30.89978309703729 * y - 0.23883238689178934 * k - 14.183576799673286) + m * (10.49593273432072 * m + 63.02378494754052 * y + 50.606957656360734 * k - 112.23884253719248) + y * (0.03296041114873217 * y + 115.60384449646641 * k - 193.58209356861505) - k * (22.33816807309886 * k + 180.12613974708367);
      }

      return data.subarray(0, offset);
    },
    getData: function getData(_ref3) {
      var width = _ref3.width,
          height = _ref3.height,
          _ref3$forceRGB = _ref3.forceRGB,
          forceRGB = _ref3$forceRGB === void 0 ? false : _ref3$forceRGB,
          _ref3$isSourcePDF = _ref3.isSourcePDF,
          isSourcePDF = _ref3$isSourcePDF === void 0 ? false : _ref3$isSourcePDF;

      if (this.numComponents > 4) {
        throw new JpegError('Unsupported color mode');
      }

      var data = this._getLinearizedBlockData(width, height, isSourcePDF);

      if (this.numComponents === 1 && forceRGB) {
        var dataLength = data.length;
        var rgbData = new Uint8ClampedArray(dataLength * 3);
        var offset = 0;

        for (var i = 0; i < dataLength; i++) {
          var grayColor = data[i];
          rgbData[offset++] = grayColor;
          rgbData[offset++] = grayColor;
          rgbData[offset++] = grayColor;
        }

        return rgbData;
      } else if (this.numComponents === 3 && this._isColorConversionNeeded) {
        return this._convertYccToRgb(data);
      } else if (this.numComponents === 4) {
        if (this._isColorConversionNeeded) {
          if (forceRGB) {
            return this._convertYcckToRgb(data);
          }

          return this._convertYcckToCmyk(data);
        } else if (forceRGB) {
          return this._convertCmykToRgb(data);
        }
      }

      return data;
    }
  };
  return JpegImage;
}();

exports.JpegImage = JpegImage;

/***/ }),
/* 165 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JpxStream = void 0;

var _stream = __w_pdfjs_require__(157);

var _jpx = __w_pdfjs_require__(166);

var _util = __w_pdfjs_require__(6);

var JpxStream = function JpxStreamClosure() {
  function JpxStream(stream, maybeLength, dict, params) {
    this.stream = stream;
    this.maybeLength = maybeLength;
    this.dict = dict;
    this.params = params;

    _stream.DecodeStream.call(this, maybeLength);
  }

  JpxStream.prototype = Object.create(_stream.DecodeStream.prototype);
  Object.defineProperty(JpxStream.prototype, 'bytes', {
    get: function JpxStream_bytes() {
      return (0, _util.shadow)(this, 'bytes', this.stream.getBytes(this.maybeLength));
    },
    configurable: true
  });

  JpxStream.prototype.ensureBuffer = function (requested) {};

  JpxStream.prototype.readBlock = function () {
    if (this.eof) {
      return;
    }

    var jpxImage = new _jpx.JpxImage();
    jpxImage.parse(this.bytes);
    var width = jpxImage.width;
    var height = jpxImage.height;
    var componentsCount = jpxImage.componentsCount;
    var tileCount = jpxImage.tiles.length;

    if (tileCount === 1) {
      this.buffer = jpxImage.tiles[0].items;
    } else {
      var data = new Uint8ClampedArray(width * height * componentsCount);

      for (var k = 0; k < tileCount; k++) {
        var tileComponents = jpxImage.tiles[k];
        var tileWidth = tileComponents.width;
        var tileHeight = tileComponents.height;
        var tileLeft = tileComponents.left;
        var tileTop = tileComponents.top;
        var src = tileComponents.items;
        var srcPosition = 0;
        var dataPosition = (width * tileTop + tileLeft) * componentsCount;
        var imgRowSize = width * componentsCount;
        var tileRowSize = tileWidth * componentsCount;

        for (var j = 0; j < tileHeight; j++) {
          var rowBytes = src.subarray(srcPosition, srcPosition + tileRowSize);
          data.set(rowBytes, dataPosition);
          srcPosition += tileRowSize;
          dataPosition += imgRowSize;
        }
      }

      this.buffer = data;
    }

    this.bufferLength = this.buffer.length;
    this.eof = true;
  };

  return JpxStream;
}();

exports.JpxStream = JpxStream;

/***/ }),
/* 166 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JpxImage = void 0;

var _util = __w_pdfjs_require__(6);

var _arithmetic_decoder = __w_pdfjs_require__(162);

var JpxError = function JpxErrorClosure() {
  function JpxError(msg) {
    this.message = 'JPX error: ' + msg;
  }

  JpxError.prototype = new Error();
  JpxError.prototype.name = 'JpxError';
  JpxError.constructor = JpxError;
  return JpxError;
}();

var JpxImage = function JpxImageClosure() {
  var SubbandsGainLog2 = {
    'LL': 0,
    'LH': 1,
    'HL': 1,
    'HH': 2
  };

  function JpxImage() {
    this.failOnCorruptedImage = false;
  }

  JpxImage.prototype = {
    parse: function JpxImage_parse(data) {
      var head = (0, _util.readUint16)(data, 0);

      if (head === 0xFF4F) {
        this.parseCodestream(data, 0, data.length);
        return;
      }

      var position = 0,
          length = data.length;

      while (position < length) {
        var headerSize = 8;
        var lbox = (0, _util.readUint32)(data, position);
        var tbox = (0, _util.readUint32)(data, position + 4);
        position += headerSize;

        if (lbox === 1) {
          lbox = (0, _util.readUint32)(data, position) * 4294967296 + (0, _util.readUint32)(data, position + 4);
          position += 8;
          headerSize += 8;
        }

        if (lbox === 0) {
          lbox = length - position + headerSize;
        }

        if (lbox < headerSize) {
          throw new JpxError('Invalid box field size');
        }

        var dataLength = lbox - headerSize;
        var jumpDataLength = true;

        switch (tbox) {
          case 0x6A703268:
            jumpDataLength = false;
            break;

          case 0x636F6C72:
            var method = data[position];

            if (method === 1) {
              var colorspace = (0, _util.readUint32)(data, position + 3);

              switch (colorspace) {
                case 16:
                case 17:
                case 18:
                  break;

                default:
                  (0, _util.warn)('Unknown colorspace ' + colorspace);
                  break;
              }
            } else if (method === 2) {
              (0, _util.info)('ICC profile not supported');
            }

            break;

          case 0x6A703263:
            this.parseCodestream(data, position, position + dataLength);
            break;

          case 0x6A502020:
            if ((0, _util.readUint32)(data, position) !== 0x0d0a870a) {
              (0, _util.warn)('Invalid JP2 signature');
            }

            break;

          case 0x6A501A1A:
          case 0x66747970:
          case 0x72726571:
          case 0x72657320:
          case 0x69686472:
            break;

          default:
            var headerType = String.fromCharCode(tbox >> 24 & 0xFF, tbox >> 16 & 0xFF, tbox >> 8 & 0xFF, tbox & 0xFF);
            (0, _util.warn)('Unsupported header type ' + tbox + ' (' + headerType + ')');
            break;
        }

        if (jumpDataLength) {
          position += dataLength;
        }
      }
    },
    parseImageProperties: function JpxImage_parseImageProperties(stream) {
      var newByte = stream.getByte();

      while (newByte >= 0) {
        var oldByte = newByte;
        newByte = stream.getByte();
        var code = oldByte << 8 | newByte;

        if (code === 0xFF51) {
          stream.skip(4);
          var Xsiz = stream.getInt32() >>> 0;
          var Ysiz = stream.getInt32() >>> 0;
          var XOsiz = stream.getInt32() >>> 0;
          var YOsiz = stream.getInt32() >>> 0;
          stream.skip(16);
          var Csiz = stream.getUint16();
          this.width = Xsiz - XOsiz;
          this.height = Ysiz - YOsiz;
          this.componentsCount = Csiz;
          this.bitsPerComponent = 8;
          return;
        }
      }

      throw new JpxError('No size marker found in JPX stream');
    },
    parseCodestream: function JpxImage_parseCodestream(data, start, end) {
      var context = {};
      var doNotRecover = false;

      try {
        var position = start;

        while (position + 1 < end) {
          var code = (0, _util.readUint16)(data, position);
          position += 2;
          var length = 0,
              j,
              sqcd,
              spqcds,
              spqcdSize,
              scalarExpounded,
              tile;

          switch (code) {
            case 0xFF4F:
              context.mainHeader = true;
              break;

            case 0xFFD9:
              break;

            case 0xFF51:
              length = (0, _util.readUint16)(data, position);
              var siz = {};
              siz.Xsiz = (0, _util.readUint32)(data, position + 4);
              siz.Ysiz = (0, _util.readUint32)(data, position + 8);
              siz.XOsiz = (0, _util.readUint32)(data, position + 12);
              siz.YOsiz = (0, _util.readUint32)(data, position + 16);
              siz.XTsiz = (0, _util.readUint32)(data, position + 20);
              siz.YTsiz = (0, _util.readUint32)(data, position + 24);
              siz.XTOsiz = (0, _util.readUint32)(data, position + 28);
              siz.YTOsiz = (0, _util.readUint32)(data, position + 32);
              var componentsCount = (0, _util.readUint16)(data, position + 36);
              siz.Csiz = componentsCount;
              var components = [];
              j = position + 38;

              for (var i = 0; i < componentsCount; i++) {
                var component = {
                  precision: (data[j] & 0x7F) + 1,
                  isSigned: !!(data[j] & 0x80),
                  XRsiz: data[j + 1],
                  YRsiz: data[j + 2]
                };
                j += 3;
                calculateComponentDimensions(component, siz);
                components.push(component);
              }

              context.SIZ = siz;
              context.components = components;
              calculateTileGrids(context, components);
              context.QCC = [];
              context.COC = [];
              break;

            case 0xFF5C:
              length = (0, _util.readUint16)(data, position);
              var qcd = {};
              j = position + 2;
              sqcd = data[j++];

              switch (sqcd & 0x1F) {
                case 0:
                  spqcdSize = 8;
                  scalarExpounded = true;
                  break;

                case 1:
                  spqcdSize = 16;
                  scalarExpounded = false;
                  break;

                case 2:
                  spqcdSize = 16;
                  scalarExpounded = true;
                  break;

                default:
                  throw new Error('Invalid SQcd value ' + sqcd);
              }

              qcd.noQuantization = spqcdSize === 8;
              qcd.scalarExpounded = scalarExpounded;
              qcd.guardBits = sqcd >> 5;
              spqcds = [];

              while (j < length + position) {
                var spqcd = {};

                if (spqcdSize === 8) {
                  spqcd.epsilon = data[j++] >> 3;
                  spqcd.mu = 0;
                } else {
                  spqcd.epsilon = data[j] >> 3;
                  spqcd.mu = (data[j] & 0x7) << 8 | data[j + 1];
                  j += 2;
                }

                spqcds.push(spqcd);
              }

              qcd.SPqcds = spqcds;

              if (context.mainHeader) {
                context.QCD = qcd;
              } else {
                context.currentTile.QCD = qcd;
                context.currentTile.QCC = [];
              }

              break;

            case 0xFF5D:
              length = (0, _util.readUint16)(data, position);
              var qcc = {};
              j = position + 2;
              var cqcc;

              if (context.SIZ.Csiz < 257) {
                cqcc = data[j++];
              } else {
                cqcc = (0, _util.readUint16)(data, j);
                j += 2;
              }

              sqcd = data[j++];

              switch (sqcd & 0x1F) {
                case 0:
                  spqcdSize = 8;
                  scalarExpounded = true;
                  break;

                case 1:
                  spqcdSize = 16;
                  scalarExpounded = false;
                  break;

                case 2:
                  spqcdSize = 16;
                  scalarExpounded = true;
                  break;

                default:
                  throw new Error('Invalid SQcd value ' + sqcd);
              }

              qcc.noQuantization = spqcdSize === 8;
              qcc.scalarExpounded = scalarExpounded;
              qcc.guardBits = sqcd >> 5;
              spqcds = [];

              while (j < length + position) {
                spqcd = {};

                if (spqcdSize === 8) {
                  spqcd.epsilon = data[j++] >> 3;
                  spqcd.mu = 0;
                } else {
                  spqcd.epsilon = data[j] >> 3;
                  spqcd.mu = (data[j] & 0x7) << 8 | data[j + 1];
                  j += 2;
                }

                spqcds.push(spqcd);
              }

              qcc.SPqcds = spqcds;

              if (context.mainHeader) {
                context.QCC[cqcc] = qcc;
              } else {
                context.currentTile.QCC[cqcc] = qcc;
              }

              break;

            case 0xFF52:
              length = (0, _util.readUint16)(data, position);
              var cod = {};
              j = position + 2;
              var scod = data[j++];
              cod.entropyCoderWithCustomPrecincts = !!(scod & 1);
              cod.sopMarkerUsed = !!(scod & 2);
              cod.ephMarkerUsed = !!(scod & 4);
              cod.progressionOrder = data[j++];
              cod.layersCount = (0, _util.readUint16)(data, j);
              j += 2;
              cod.multipleComponentTransform = data[j++];
              cod.decompositionLevelsCount = data[j++];
              cod.xcb = (data[j++] & 0xF) + 2;
              cod.ycb = (data[j++] & 0xF) + 2;
              var blockStyle = data[j++];
              cod.selectiveArithmeticCodingBypass = !!(blockStyle & 1);
              cod.resetContextProbabilities = !!(blockStyle & 2);
              cod.terminationOnEachCodingPass = !!(blockStyle & 4);
              cod.verticallyStripe = !!(blockStyle & 8);
              cod.predictableTermination = !!(blockStyle & 16);
              cod.segmentationSymbolUsed = !!(blockStyle & 32);
              cod.reversibleTransformation = data[j++];

              if (cod.entropyCoderWithCustomPrecincts) {
                var precinctsSizes = [];

                while (j < length + position) {
                  var precinctsSize = data[j++];
                  precinctsSizes.push({
                    PPx: precinctsSize & 0xF,
                    PPy: precinctsSize >> 4
                  });
                }

                cod.precinctsSizes = precinctsSizes;
              }

              var unsupported = [];

              if (cod.selectiveArithmeticCodingBypass) {
                unsupported.push('selectiveArithmeticCodingBypass');
              }

              if (cod.resetContextProbabilities) {
                unsupported.push('resetContextProbabilities');
              }

              if (cod.terminationOnEachCodingPass) {
                unsupported.push('terminationOnEachCodingPass');
              }

              if (cod.verticallyStripe) {
                unsupported.push('verticallyStripe');
              }

              if (cod.predictableTermination) {
                unsupported.push('predictableTermination');
              }

              if (unsupported.length > 0) {
                doNotRecover = true;
                throw new Error('Unsupported COD options (' + unsupported.join(', ') + ')');
              }

              if (context.mainHeader) {
                context.COD = cod;
              } else {
                context.currentTile.COD = cod;
                context.currentTile.COC = [];
              }

              break;

            case 0xFF90:
              length = (0, _util.readUint16)(data, position);
              tile = {};
              tile.index = (0, _util.readUint16)(data, position + 2);
              tile.length = (0, _util.readUint32)(data, position + 4);
              tile.dataEnd = tile.length + position - 2;
              tile.partIndex = data[position + 8];
              tile.partsCount = data[position + 9];
              context.mainHeader = false;

              if (tile.partIndex === 0) {
                tile.COD = context.COD;
                tile.COC = context.COC.slice(0);
                tile.QCD = context.QCD;
                tile.QCC = context.QCC.slice(0);
              }

              context.currentTile = tile;
              break;

            case 0xFF93:
              tile = context.currentTile;

              if (tile.partIndex === 0) {
                initializeTile(context, tile.index);
                buildPackets(context);
              }

              length = tile.dataEnd - position;
              parseTilePackets(context, data, position, length);
              break;

            case 0xFF55:
            case 0xFF57:
            case 0xFF58:
            case 0xFF64:
              length = (0, _util.readUint16)(data, position);
              break;

            case 0xFF53:
              throw new Error('Codestream code 0xFF53 (COC) is ' + 'not implemented');

            default:
              throw new Error('Unknown codestream code: ' + code.toString(16));
          }

          position += length;
        }
      } catch (e) {
        if (doNotRecover || this.failOnCorruptedImage) {
          throw new JpxError(e.message);
        } else {
          (0, _util.warn)('JPX: Trying to recover from: ' + e.message);
        }
      }

      this.tiles = transformComponents(context);
      this.width = context.SIZ.Xsiz - context.SIZ.XOsiz;
      this.height = context.SIZ.Ysiz - context.SIZ.YOsiz;
      this.componentsCount = context.SIZ.Csiz;
    }
  };

  function calculateComponentDimensions(component, siz) {
    component.x0 = Math.ceil(siz.XOsiz / component.XRsiz);
    component.x1 = Math.ceil(siz.Xsiz / component.XRsiz);
    component.y0 = Math.ceil(siz.YOsiz / component.YRsiz);
    component.y1 = Math.ceil(siz.Ysiz / component.YRsiz);
    component.width = component.x1 - component.x0;
    component.height = component.y1 - component.y0;
  }

  function calculateTileGrids(context, components) {
    var siz = context.SIZ;
    var tile,
        tiles = [];
    var numXtiles = Math.ceil((siz.Xsiz - siz.XTOsiz) / siz.XTsiz);
    var numYtiles = Math.ceil((siz.Ysiz - siz.YTOsiz) / siz.YTsiz);

    for (var q = 0; q < numYtiles; q++) {
      for (var p = 0; p < numXtiles; p++) {
        tile = {};
        tile.tx0 = Math.max(siz.XTOsiz + p * siz.XTsiz, siz.XOsiz);
        tile.ty0 = Math.max(siz.YTOsiz + q * siz.YTsiz, siz.YOsiz);
        tile.tx1 = Math.min(siz.XTOsiz + (p + 1) * siz.XTsiz, siz.Xsiz);
        tile.ty1 = Math.min(siz.YTOsiz + (q + 1) * siz.YTsiz, siz.Ysiz);
        tile.width = tile.tx1 - tile.tx0;
        tile.height = tile.ty1 - tile.ty0;
        tile.components = [];
        tiles.push(tile);
      }
    }

    context.tiles = tiles;
    var componentsCount = siz.Csiz;

    for (var i = 0, ii = componentsCount; i < ii; i++) {
      var component = components[i];

      for (var j = 0, jj = tiles.length; j < jj; j++) {
        var tileComponent = {};
        tile = tiles[j];
        tileComponent.tcx0 = Math.ceil(tile.tx0 / component.XRsiz);
        tileComponent.tcy0 = Math.ceil(tile.ty0 / component.YRsiz);
        tileComponent.tcx1 = Math.ceil(tile.tx1 / component.XRsiz);
        tileComponent.tcy1 = Math.ceil(tile.ty1 / component.YRsiz);
        tileComponent.width = tileComponent.tcx1 - tileComponent.tcx0;
        tileComponent.height = tileComponent.tcy1 - tileComponent.tcy0;
        tile.components[i] = tileComponent;
      }
    }
  }

  function getBlocksDimensions(context, component, r) {
    var codOrCoc = component.codingStyleParameters;
    var result = {};

    if (!codOrCoc.entropyCoderWithCustomPrecincts) {
      result.PPx = 15;
      result.PPy = 15;
    } else {
      result.PPx = codOrCoc.precinctsSizes[r].PPx;
      result.PPy = codOrCoc.precinctsSizes[r].PPy;
    }

    result.xcb_ = r > 0 ? Math.min(codOrCoc.xcb, result.PPx - 1) : Math.min(codOrCoc.xcb, result.PPx);
    result.ycb_ = r > 0 ? Math.min(codOrCoc.ycb, result.PPy - 1) : Math.min(codOrCoc.ycb, result.PPy);
    return result;
  }

  function buildPrecincts(context, resolution, dimensions) {
    var precinctWidth = 1 << dimensions.PPx;
    var precinctHeight = 1 << dimensions.PPy;
    var isZeroRes = resolution.resLevel === 0;
    var precinctWidthInSubband = 1 << dimensions.PPx + (isZeroRes ? 0 : -1);
    var precinctHeightInSubband = 1 << dimensions.PPy + (isZeroRes ? 0 : -1);
    var numprecinctswide = resolution.trx1 > resolution.trx0 ? Math.ceil(resolution.trx1 / precinctWidth) - Math.floor(resolution.trx0 / precinctWidth) : 0;
    var numprecinctshigh = resolution.try1 > resolution.try0 ? Math.ceil(resolution.try1 / precinctHeight) - Math.floor(resolution.try0 / precinctHeight) : 0;
    var numprecincts = numprecinctswide * numprecinctshigh;
    resolution.precinctParameters = {
      precinctWidth: precinctWidth,
      precinctHeight: precinctHeight,
      numprecinctswide: numprecinctswide,
      numprecinctshigh: numprecinctshigh,
      numprecincts: numprecincts,
      precinctWidthInSubband: precinctWidthInSubband,
      precinctHeightInSubband: precinctHeightInSubband
    };
  }

  function buildCodeblocks(context, subband, dimensions) {
    var xcb_ = dimensions.xcb_;
    var ycb_ = dimensions.ycb_;
    var codeblockWidth = 1 << xcb_;
    var codeblockHeight = 1 << ycb_;
    var cbx0 = subband.tbx0 >> xcb_;
    var cby0 = subband.tby0 >> ycb_;
    var cbx1 = subband.tbx1 + codeblockWidth - 1 >> xcb_;
    var cby1 = subband.tby1 + codeblockHeight - 1 >> ycb_;
    var precinctParameters = subband.resolution.precinctParameters;
    var codeblocks = [];
    var precincts = [];
    var i, j, codeblock, precinctNumber;

    for (j = cby0; j < cby1; j++) {
      for (i = cbx0; i < cbx1; i++) {
        codeblock = {
          cbx: i,
          cby: j,
          tbx0: codeblockWidth * i,
          tby0: codeblockHeight * j,
          tbx1: codeblockWidth * (i + 1),
          tby1: codeblockHeight * (j + 1)
        };
        codeblock.tbx0_ = Math.max(subband.tbx0, codeblock.tbx0);
        codeblock.tby0_ = Math.max(subband.tby0, codeblock.tby0);
        codeblock.tbx1_ = Math.min(subband.tbx1, codeblock.tbx1);
        codeblock.tby1_ = Math.min(subband.tby1, codeblock.tby1);
        var pi = Math.floor((codeblock.tbx0_ - subband.tbx0) / precinctParameters.precinctWidthInSubband);
        var pj = Math.floor((codeblock.tby0_ - subband.tby0) / precinctParameters.precinctHeightInSubband);
        precinctNumber = pi + pj * precinctParameters.numprecinctswide;
        codeblock.precinctNumber = precinctNumber;
        codeblock.subbandType = subband.type;
        codeblock.Lblock = 3;

        if (codeblock.tbx1_ <= codeblock.tbx0_ || codeblock.tby1_ <= codeblock.tby0_) {
          continue;
        }

        codeblocks.push(codeblock);
        var precinct = precincts[precinctNumber];

        if (precinct !== undefined) {
          if (i < precinct.cbxMin) {
            precinct.cbxMin = i;
          } else if (i > precinct.cbxMax) {
            precinct.cbxMax = i;
          }

          if (j < precinct.cbyMin) {
            precinct.cbxMin = j;
          } else if (j > precinct.cbyMax) {
            precinct.cbyMax = j;
          }
        } else {
          precincts[precinctNumber] = precinct = {
            cbxMin: i,
            cbyMin: j,
            cbxMax: i,
            cbyMax: j
          };
        }

        codeblock.precinct = precinct;
      }
    }

    subband.codeblockParameters = {
      codeblockWidth: xcb_,
      codeblockHeight: ycb_,
      numcodeblockwide: cbx1 - cbx0 + 1,
      numcodeblockhigh: cby1 - cby0 + 1
    };
    subband.codeblocks = codeblocks;
    subband.precincts = precincts;
  }

  function createPacket(resolution, precinctNumber, layerNumber) {
    var precinctCodeblocks = [];
    var subbands = resolution.subbands;

    for (var i = 0, ii = subbands.length; i < ii; i++) {
      var subband = subbands[i];
      var codeblocks = subband.codeblocks;

      for (var j = 0, jj = codeblocks.length; j < jj; j++) {
        var codeblock = codeblocks[j];

        if (codeblock.precinctNumber !== precinctNumber) {
          continue;
        }

        precinctCodeblocks.push(codeblock);
      }
    }

    return {
      layerNumber: layerNumber,
      codeblocks: precinctCodeblocks
    };
  }

  function LayerResolutionComponentPositionIterator(context) {
    var siz = context.SIZ;
    var tileIndex = context.currentTile.index;
    var tile = context.tiles[tileIndex];
    var layersCount = tile.codingStyleDefaultParameters.layersCount;
    var componentsCount = siz.Csiz;
    var maxDecompositionLevelsCount = 0;

    for (var q = 0; q < componentsCount; q++) {
      maxDecompositionLevelsCount = Math.max(maxDecompositionLevelsCount, tile.components[q].codingStyleParameters.decompositionLevelsCount);
    }

    var l = 0,
        r = 0,
        i = 0,
        k = 0;

    this.nextPacket = function JpxImage_nextPacket() {
      for (; l < layersCount; l++) {
        for (; r <= maxDecompositionLevelsCount; r++) {
          for (; i < componentsCount; i++) {
            var component = tile.components[i];

            if (r > component.codingStyleParameters.decompositionLevelsCount) {
              continue;
            }

            var resolution = component.resolutions[r];
            var numprecincts = resolution.precinctParameters.numprecincts;

            for (; k < numprecincts;) {
              var packet = createPacket(resolution, k, l);
              k++;
              return packet;
            }

            k = 0;
          }

          i = 0;
        }

        r = 0;
      }

      throw new JpxError('Out of packets');
    };
  }

  function ResolutionLayerComponentPositionIterator(context) {
    var siz = context.SIZ;
    var tileIndex = context.currentTile.index;
    var tile = context.tiles[tileIndex];
    var layersCount = tile.codingStyleDefaultParameters.layersCount;
    var componentsCount = siz.Csiz;
    var maxDecompositionLevelsCount = 0;

    for (var q = 0; q < componentsCount; q++) {
      maxDecompositionLevelsCount = Math.max(maxDecompositionLevelsCount, tile.components[q].codingStyleParameters.decompositionLevelsCount);
    }

    var r = 0,
        l = 0,
        i = 0,
        k = 0;

    this.nextPacket = function JpxImage_nextPacket() {
      for (; r <= maxDecompositionLevelsCount; r++) {
        for (; l < layersCount; l++) {
          for (; i < componentsCount; i++) {
            var component = tile.components[i];

            if (r > component.codingStyleParameters.decompositionLevelsCount) {
              continue;
            }

            var resolution = component.resolutions[r];
            var numprecincts = resolution.precinctParameters.numprecincts;

            for (; k < numprecincts;) {
              var packet = createPacket(resolution, k, l);
              k++;
              return packet;
            }

            k = 0;
          }

          i = 0;
        }

        l = 0;
      }

      throw new JpxError('Out of packets');
    };
  }

  function ResolutionPositionComponentLayerIterator(context) {
    var siz = context.SIZ;
    var tileIndex = context.currentTile.index;
    var tile = context.tiles[tileIndex];
    var layersCount = tile.codingStyleDefaultParameters.layersCount;
    var componentsCount = siz.Csiz;
    var l, r, c, p;
    var maxDecompositionLevelsCount = 0;

    for (c = 0; c < componentsCount; c++) {
      var component = tile.components[c];
      maxDecompositionLevelsCount = Math.max(maxDecompositionLevelsCount, component.codingStyleParameters.decompositionLevelsCount);
    }

    var maxNumPrecinctsInLevel = new Int32Array(maxDecompositionLevelsCount + 1);

    for (r = 0; r <= maxDecompositionLevelsCount; ++r) {
      var maxNumPrecincts = 0;

      for (c = 0; c < componentsCount; ++c) {
        var resolutions = tile.components[c].resolutions;

        if (r < resolutions.length) {
          maxNumPrecincts = Math.max(maxNumPrecincts, resolutions[r].precinctParameters.numprecincts);
        }
      }

      maxNumPrecinctsInLevel[r] = maxNumPrecincts;
    }

    l = 0;
    r = 0;
    c = 0;
    p = 0;

    this.nextPacket = function JpxImage_nextPacket() {
      for (; r <= maxDecompositionLevelsCount; r++) {
        for (; p < maxNumPrecinctsInLevel[r]; p++) {
          for (; c < componentsCount; c++) {
            var component = tile.components[c];

            if (r > component.codingStyleParameters.decompositionLevelsCount) {
              continue;
            }

            var resolution = component.resolutions[r];
            var numprecincts = resolution.precinctParameters.numprecincts;

            if (p >= numprecincts) {
              continue;
            }

            for (; l < layersCount;) {
              var packet = createPacket(resolution, p, l);
              l++;
              return packet;
            }

            l = 0;
          }

          c = 0;
        }

        p = 0;
      }

      throw new JpxError('Out of packets');
    };
  }

  function PositionComponentResolutionLayerIterator(context) {
    var siz = context.SIZ;
    var tileIndex = context.currentTile.index;
    var tile = context.tiles[tileIndex];
    var layersCount = tile.codingStyleDefaultParameters.layersCount;
    var componentsCount = siz.Csiz;
    var precinctsSizes = getPrecinctSizesInImageScale(tile);
    var precinctsIterationSizes = precinctsSizes;
    var l = 0,
        r = 0,
        c = 0,
        px = 0,
        py = 0;

    this.nextPacket = function JpxImage_nextPacket() {
      for (; py < precinctsIterationSizes.maxNumHigh; py++) {
        for (; px < precinctsIterationSizes.maxNumWide; px++) {
          for (; c < componentsCount; c++) {
            var component = tile.components[c];
            var decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;

            for (; r <= decompositionLevelsCount; r++) {
              var resolution = component.resolutions[r];
              var sizeInImageScale = precinctsSizes.components[c].resolutions[r];
              var k = getPrecinctIndexIfExist(px, py, sizeInImageScale, precinctsIterationSizes, resolution);

              if (k === null) {
                continue;
              }

              for (; l < layersCount;) {
                var packet = createPacket(resolution, k, l);
                l++;
                return packet;
              }

              l = 0;
            }

            r = 0;
          }

          c = 0;
        }

        px = 0;
      }

      throw new JpxError('Out of packets');
    };
  }

  function ComponentPositionResolutionLayerIterator(context) {
    var siz = context.SIZ;
    var tileIndex = context.currentTile.index;
    var tile = context.tiles[tileIndex];
    var layersCount = tile.codingStyleDefaultParameters.layersCount;
    var componentsCount = siz.Csiz;
    var precinctsSizes = getPrecinctSizesInImageScale(tile);
    var l = 0,
        r = 0,
        c = 0,
        px = 0,
        py = 0;

    this.nextPacket = function JpxImage_nextPacket() {
      for (; c < componentsCount; ++c) {
        var component = tile.components[c];
        var precinctsIterationSizes = precinctsSizes.components[c];
        var decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;

        for (; py < precinctsIterationSizes.maxNumHigh; py++) {
          for (; px < precinctsIterationSizes.maxNumWide; px++) {
            for (; r <= decompositionLevelsCount; r++) {
              var resolution = component.resolutions[r];
              var sizeInImageScale = precinctsIterationSizes.resolutions[r];
              var k = getPrecinctIndexIfExist(px, py, sizeInImageScale, precinctsIterationSizes, resolution);

              if (k === null) {
                continue;
              }

              for (; l < layersCount;) {
                var packet = createPacket(resolution, k, l);
                l++;
                return packet;
              }

              l = 0;
            }

            r = 0;
          }

          px = 0;
        }

        py = 0;
      }

      throw new JpxError('Out of packets');
    };
  }

  function getPrecinctIndexIfExist(pxIndex, pyIndex, sizeInImageScale, precinctIterationSizes, resolution) {
    var posX = pxIndex * precinctIterationSizes.minWidth;
    var posY = pyIndex * precinctIterationSizes.minHeight;

    if (posX % sizeInImageScale.width !== 0 || posY % sizeInImageScale.height !== 0) {
      return null;
    }

    var startPrecinctRowIndex = posY / sizeInImageScale.width * resolution.precinctParameters.numprecinctswide;
    return posX / sizeInImageScale.height + startPrecinctRowIndex;
  }

  function getPrecinctSizesInImageScale(tile) {
    var componentsCount = tile.components.length;
    var minWidth = Number.MAX_VALUE;
    var minHeight = Number.MAX_VALUE;
    var maxNumWide = 0;
    var maxNumHigh = 0;
    var sizePerComponent = new Array(componentsCount);

    for (var c = 0; c < componentsCount; c++) {
      var component = tile.components[c];
      var decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;
      var sizePerResolution = new Array(decompositionLevelsCount + 1);
      var minWidthCurrentComponent = Number.MAX_VALUE;
      var minHeightCurrentComponent = Number.MAX_VALUE;
      var maxNumWideCurrentComponent = 0;
      var maxNumHighCurrentComponent = 0;
      var scale = 1;

      for (var r = decompositionLevelsCount; r >= 0; --r) {
        var resolution = component.resolutions[r];
        var widthCurrentResolution = scale * resolution.precinctParameters.precinctWidth;
        var heightCurrentResolution = scale * resolution.precinctParameters.precinctHeight;
        minWidthCurrentComponent = Math.min(minWidthCurrentComponent, widthCurrentResolution);
        minHeightCurrentComponent = Math.min(minHeightCurrentComponent, heightCurrentResolution);
        maxNumWideCurrentComponent = Math.max(maxNumWideCurrentComponent, resolution.precinctParameters.numprecinctswide);
        maxNumHighCurrentComponent = Math.max(maxNumHighCurrentComponent, resolution.precinctParameters.numprecinctshigh);
        sizePerResolution[r] = {
          width: widthCurrentResolution,
          height: heightCurrentResolution
        };
        scale <<= 1;
      }

      minWidth = Math.min(minWidth, minWidthCurrentComponent);
      minHeight = Math.min(minHeight, minHeightCurrentComponent);
      maxNumWide = Math.max(maxNumWide, maxNumWideCurrentComponent);
      maxNumHigh = Math.max(maxNumHigh, maxNumHighCurrentComponent);
      sizePerComponent[c] = {
        resolutions: sizePerResolution,
        minWidth: minWidthCurrentComponent,
        minHeight: minHeightCurrentComponent,
        maxNumWide: maxNumWideCurrentComponent,
        maxNumHigh: maxNumHighCurrentComponent
      };
    }

    return {
      components: sizePerComponent,
      minWidth: minWidth,
      minHeight: minHeight,
      maxNumWide: maxNumWide,
      maxNumHigh: maxNumHigh
    };
  }

  function buildPackets(context) {
    var siz = context.SIZ;
    var tileIndex = context.currentTile.index;
    var tile = context.tiles[tileIndex];
    var componentsCount = siz.Csiz;

    for (var c = 0; c < componentsCount; c++) {
      var component = tile.components[c];
      var decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;
      var resolutions = [];
      var subbands = [];

      for (var r = 0; r <= decompositionLevelsCount; r++) {
        var blocksDimensions = getBlocksDimensions(context, component, r);
        var resolution = {};
        var scale = 1 << decompositionLevelsCount - r;
        resolution.trx0 = Math.ceil(component.tcx0 / scale);
        resolution.try0 = Math.ceil(component.tcy0 / scale);
        resolution.trx1 = Math.ceil(component.tcx1 / scale);
        resolution.try1 = Math.ceil(component.tcy1 / scale);
        resolution.resLevel = r;
        buildPrecincts(context, resolution, blocksDimensions);
        resolutions.push(resolution);
        var subband;

        if (r === 0) {
          subband = {};
          subband.type = 'LL';
          subband.tbx0 = Math.ceil(component.tcx0 / scale);
          subband.tby0 = Math.ceil(component.tcy0 / scale);
          subband.tbx1 = Math.ceil(component.tcx1 / scale);
          subband.tby1 = Math.ceil(component.tcy1 / scale);
          subband.resolution = resolution;
          buildCodeblocks(context, subband, blocksDimensions);
          subbands.push(subband);
          resolution.subbands = [subband];
        } else {
          var bscale = 1 << decompositionLevelsCount - r + 1;
          var resolutionSubbands = [];
          subband = {};
          subband.type = 'HL';
          subband.tbx0 = Math.ceil(component.tcx0 / bscale - 0.5);
          subband.tby0 = Math.ceil(component.tcy0 / bscale);
          subband.tbx1 = Math.ceil(component.tcx1 / bscale - 0.5);
          subband.tby1 = Math.ceil(component.tcy1 / bscale);
          subband.resolution = resolution;
          buildCodeblocks(context, subband, blocksDimensions);
          subbands.push(subband);
          resolutionSubbands.push(subband);
          subband = {};
          subband.type = 'LH';
          subband.tbx0 = Math.ceil(component.tcx0 / bscale);
          subband.tby0 = Math.ceil(component.tcy0 / bscale - 0.5);
          subband.tbx1 = Math.ceil(component.tcx1 / bscale);
          subband.tby1 = Math.ceil(component.tcy1 / bscale - 0.5);
          subband.resolution = resolution;
          buildCodeblocks(context, subband, blocksDimensions);
          subbands.push(subband);
          resolutionSubbands.push(subband);
          subband = {};
          subband.type = 'HH';
          subband.tbx0 = Math.ceil(component.tcx0 / bscale - 0.5);
          subband.tby0 = Math.ceil(component.tcy0 / bscale - 0.5);
          subband.tbx1 = Math.ceil(component.tcx1 / bscale - 0.5);
          subband.tby1 = Math.ceil(component.tcy1 / bscale - 0.5);
          subband.resolution = resolution;
          buildCodeblocks(context, subband, blocksDimensions);
          subbands.push(subband);
          resolutionSubbands.push(subband);
          resolution.subbands = resolutionSubbands;
        }
      }

      component.resolutions = resolutions;
      component.subbands = subbands;
    }

    var progressionOrder = tile.codingStyleDefaultParameters.progressionOrder;

    switch (progressionOrder) {
      case 0:
        tile.packetsIterator = new LayerResolutionComponentPositionIterator(context);
        break;

      case 1:
        tile.packetsIterator = new ResolutionLayerComponentPositionIterator(context);
        break;

      case 2:
        tile.packetsIterator = new ResolutionPositionComponentLayerIterator(context);
        break;

      case 3:
        tile.packetsIterator = new PositionComponentResolutionLayerIterator(context);
        break;

      case 4:
        tile.packetsIterator = new ComponentPositionResolutionLayerIterator(context);
        break;

      default:
        throw new JpxError("Unsupported progression order ".concat(progressionOrder));
    }
  }

  function parseTilePackets(context, data, offset, dataLength) {
    var position = 0;
    var buffer,
        bufferSize = 0,
        skipNextBit = false;

    function readBits(count) {
      while (bufferSize < count) {
        var b = data[offset + position];
        position++;

        if (skipNextBit) {
          buffer = buffer << 7 | b;
          bufferSize += 7;
          skipNextBit = false;
        } else {
          buffer = buffer << 8 | b;
          bufferSize += 8;
        }

        if (b === 0xFF) {
          skipNextBit = true;
        }
      }

      bufferSize -= count;
      return buffer >>> bufferSize & (1 << count) - 1;
    }

    function skipMarkerIfEqual(value) {
      if (data[offset + position - 1] === 0xFF && data[offset + position] === value) {
        skipBytes(1);
        return true;
      } else if (data[offset + position] === 0xFF && data[offset + position + 1] === value) {
        skipBytes(2);
        return true;
      }

      return false;
    }

    function skipBytes(count) {
      position += count;
    }

    function alignToByte() {
      bufferSize = 0;

      if (skipNextBit) {
        position++;
        skipNextBit = false;
      }
    }

    function readCodingpasses() {
      if (readBits(1) === 0) {
        return 1;
      }

      if (readBits(1) === 0) {
        return 2;
      }

      var value = readBits(2);

      if (value < 3) {
        return value + 3;
      }

      value = readBits(5);

      if (value < 31) {
        return value + 6;
      }

      value = readBits(7);
      return value + 37;
    }

    var tileIndex = context.currentTile.index;
    var tile = context.tiles[tileIndex];
    var sopMarkerUsed = context.COD.sopMarkerUsed;
    var ephMarkerUsed = context.COD.ephMarkerUsed;
    var packetsIterator = tile.packetsIterator;

    while (position < dataLength) {
      alignToByte();

      if (sopMarkerUsed && skipMarkerIfEqual(0x91)) {
        skipBytes(4);
      }

      var packet = packetsIterator.nextPacket();

      if (!readBits(1)) {
        continue;
      }

      var layerNumber = packet.layerNumber;
      var queue = [],
          codeblock;

      for (var i = 0, ii = packet.codeblocks.length; i < ii; i++) {
        codeblock = packet.codeblocks[i];
        var precinct = codeblock.precinct;
        var codeblockColumn = codeblock.cbx - precinct.cbxMin;
        var codeblockRow = codeblock.cby - precinct.cbyMin;
        var codeblockIncluded = false;
        var firstTimeInclusion = false;
        var valueReady;

        if (codeblock['included'] !== undefined) {
          codeblockIncluded = !!readBits(1);
        } else {
          precinct = codeblock.precinct;
          var inclusionTree, zeroBitPlanesTree;

          if (precinct['inclusionTree'] !== undefined) {
            inclusionTree = precinct.inclusionTree;
          } else {
            var width = precinct.cbxMax - precinct.cbxMin + 1;
            var height = precinct.cbyMax - precinct.cbyMin + 1;
            inclusionTree = new InclusionTree(width, height, layerNumber);
            zeroBitPlanesTree = new TagTree(width, height);
            precinct.inclusionTree = inclusionTree;
            precinct.zeroBitPlanesTree = zeroBitPlanesTree;
          }

          if (inclusionTree.reset(codeblockColumn, codeblockRow, layerNumber)) {
            while (true) {
              if (readBits(1)) {
                valueReady = !inclusionTree.nextLevel();

                if (valueReady) {
                  codeblock.included = true;
                  codeblockIncluded = firstTimeInclusion = true;
                  break;
                }
              } else {
                inclusionTree.incrementValue(layerNumber);
                break;
              }
            }
          }
        }

        if (!codeblockIncluded) {
          continue;
        }

        if (firstTimeInclusion) {
          zeroBitPlanesTree = precinct.zeroBitPlanesTree;
          zeroBitPlanesTree.reset(codeblockColumn, codeblockRow);

          while (true) {
            if (readBits(1)) {
              valueReady = !zeroBitPlanesTree.nextLevel();

              if (valueReady) {
                break;
              }
            } else {
              zeroBitPlanesTree.incrementValue();
            }
          }

          codeblock.zeroBitPlanes = zeroBitPlanesTree.value;
        }

        var codingpasses = readCodingpasses();

        while (readBits(1)) {
          codeblock.Lblock++;
        }

        var codingpassesLog2 = (0, _util.log2)(codingpasses);
        var bits = (codingpasses < 1 << codingpassesLog2 ? codingpassesLog2 - 1 : codingpassesLog2) + codeblock.Lblock;
        var codedDataLength = readBits(bits);
        queue.push({
          codeblock: codeblock,
          codingpasses: codingpasses,
          dataLength: codedDataLength
        });
      }

      alignToByte();

      if (ephMarkerUsed) {
        skipMarkerIfEqual(0x92);
      }

      while (queue.length > 0) {
        var packetItem = queue.shift();
        codeblock = packetItem.codeblock;

        if (codeblock['data'] === undefined) {
          codeblock.data = [];
        }

        codeblock.data.push({
          data: data,
          start: offset + position,
          end: offset + position + packetItem.dataLength,
          codingpasses: packetItem.codingpasses
        });
        position += packetItem.dataLength;
      }
    }

    return position;
  }

  function copyCoefficients(coefficients, levelWidth, levelHeight, subband, delta, mb, reversible, segmentationSymbolUsed) {
    var x0 = subband.tbx0;
    var y0 = subband.tby0;
    var width = subband.tbx1 - subband.tbx0;
    var codeblocks = subband.codeblocks;
    var right = subband.type.charAt(0) === 'H' ? 1 : 0;
    var bottom = subband.type.charAt(1) === 'H' ? levelWidth : 0;

    for (var i = 0, ii = codeblocks.length; i < ii; ++i) {
      var codeblock = codeblocks[i];
      var blockWidth = codeblock.tbx1_ - codeblock.tbx0_;
      var blockHeight = codeblock.tby1_ - codeblock.tby0_;

      if (blockWidth === 0 || blockHeight === 0) {
        continue;
      }

      if (codeblock['data'] === undefined) {
        continue;
      }

      var bitModel, currentCodingpassType;
      bitModel = new BitModel(blockWidth, blockHeight, codeblock.subbandType, codeblock.zeroBitPlanes, mb);
      currentCodingpassType = 2;
      var data = codeblock.data,
          totalLength = 0,
          codingpasses = 0;
      var j, jj, dataItem;

      for (j = 0, jj = data.length; j < jj; j++) {
        dataItem = data[j];
        totalLength += dataItem.end - dataItem.start;
        codingpasses += dataItem.codingpasses;
      }

      var encodedData = new Uint8Array(totalLength);
      var position = 0;

      for (j = 0, jj = data.length; j < jj; j++) {
        dataItem = data[j];
        var chunk = dataItem.data.subarray(dataItem.start, dataItem.end);
        encodedData.set(chunk, position);
        position += chunk.length;
      }

      var decoder = new _arithmetic_decoder.ArithmeticDecoder(encodedData, 0, totalLength);
      bitModel.setDecoder(decoder);

      for (j = 0; j < codingpasses; j++) {
        switch (currentCodingpassType) {
          case 0:
            bitModel.runSignificancePropagationPass();
            break;

          case 1:
            bitModel.runMagnitudeRefinementPass();
            break;

          case 2:
            bitModel.runCleanupPass();

            if (segmentationSymbolUsed) {
              bitModel.checkSegmentationSymbol();
            }

            break;
        }

        currentCodingpassType = (currentCodingpassType + 1) % 3;
      }

      var offset = codeblock.tbx0_ - x0 + (codeblock.tby0_ - y0) * width;
      var sign = bitModel.coefficentsSign;
      var magnitude = bitModel.coefficentsMagnitude;
      var bitsDecoded = bitModel.bitsDecoded;
      var magnitudeCorrection = reversible ? 0 : 0.5;
      var k, n, nb;
      position = 0;
      var interleave = subband.type !== 'LL';

      for (j = 0; j < blockHeight; j++) {
        var row = offset / width | 0;
        var levelOffset = 2 * row * (levelWidth - width) + right + bottom;

        for (k = 0; k < blockWidth; k++) {
          n = magnitude[position];

          if (n !== 0) {
            n = (n + magnitudeCorrection) * delta;

            if (sign[position] !== 0) {
              n = -n;
            }

            nb = bitsDecoded[position];
            var pos = interleave ? levelOffset + (offset << 1) : offset;

            if (reversible && nb >= mb) {
              coefficients[pos] = n;
            } else {
              coefficients[pos] = n * (1 << mb - nb);
            }
          }

          offset++;
          position++;
        }

        offset += width - blockWidth;
      }
    }
  }

  function transformTile(context, tile, c) {
    var component = tile.components[c];
    var codingStyleParameters = component.codingStyleParameters;
    var quantizationParameters = component.quantizationParameters;
    var decompositionLevelsCount = codingStyleParameters.decompositionLevelsCount;
    var spqcds = quantizationParameters.SPqcds;
    var scalarExpounded = quantizationParameters.scalarExpounded;
    var guardBits = quantizationParameters.guardBits;
    var segmentationSymbolUsed = codingStyleParameters.segmentationSymbolUsed;
    var precision = context.components[c].precision;
    var reversible = codingStyleParameters.reversibleTransformation;
    var transform = reversible ? new ReversibleTransform() : new IrreversibleTransform();
    var subbandCoefficients = [];
    var b = 0;

    for (var i = 0; i <= decompositionLevelsCount; i++) {
      var resolution = component.resolutions[i];
      var width = resolution.trx1 - resolution.trx0;
      var height = resolution.try1 - resolution.try0;
      var coefficients = new Float32Array(width * height);

      for (var j = 0, jj = resolution.subbands.length; j < jj; j++) {
        var mu, epsilon;

        if (!scalarExpounded) {
          mu = spqcds[0].mu;
          epsilon = spqcds[0].epsilon + (i > 0 ? 1 - i : 0);
        } else {
          mu = spqcds[b].mu;
          epsilon = spqcds[b].epsilon;
          b++;
        }

        var subband = resolution.subbands[j];
        var gainLog2 = SubbandsGainLog2[subband.type];
        var delta = reversible ? 1 : Math.pow(2, precision + gainLog2 - epsilon) * (1 + mu / 2048);
        var mb = guardBits + epsilon - 1;
        copyCoefficients(coefficients, width, height, subband, delta, mb, reversible, segmentationSymbolUsed);
      }

      subbandCoefficients.push({
        width: width,
        height: height,
        items: coefficients
      });
    }

    var result = transform.calculate(subbandCoefficients, component.tcx0, component.tcy0);
    return {
      left: component.tcx0,
      top: component.tcy0,
      width: result.width,
      height: result.height,
      items: result.items
    };
  }

  function transformComponents(context) {
    var siz = context.SIZ;
    var components = context.components;
    var componentsCount = siz.Csiz;
    var resultImages = [];

    for (var i = 0, ii = context.tiles.length; i < ii; i++) {
      var tile = context.tiles[i];
      var transformedTiles = [];
      var c;

      for (c = 0; c < componentsCount; c++) {
        transformedTiles[c] = transformTile(context, tile, c);
      }

      var tile0 = transformedTiles[0];
      var out = new Uint8ClampedArray(tile0.items.length * componentsCount);
      var result = {
        left: tile0.left,
        top: tile0.top,
        width: tile0.width,
        height: tile0.height,
        items: out
      };
      var shift, offset;
      var pos = 0,
          j,
          jj,
          y0,
          y1,
          y2;

      if (tile.codingStyleDefaultParameters.multipleComponentTransform) {
        var fourComponents = componentsCount === 4;
        var y0items = transformedTiles[0].items;
        var y1items = transformedTiles[1].items;
        var y2items = transformedTiles[2].items;
        var y3items = fourComponents ? transformedTiles[3].items : null;
        shift = components[0].precision - 8;
        offset = (128 << shift) + 0.5;
        var component0 = tile.components[0];
        var alpha01 = componentsCount - 3;
        jj = y0items.length;

        if (!component0.codingStyleParameters.reversibleTransformation) {
          for (j = 0; j < jj; j++, pos += alpha01) {
            y0 = y0items[j] + offset;
            y1 = y1items[j];
            y2 = y2items[j];
            out[pos++] = y0 + 1.402 * y2 >> shift;
            out[pos++] = y0 - 0.34413 * y1 - 0.71414 * y2 >> shift;
            out[pos++] = y0 + 1.772 * y1 >> shift;
          }
        } else {
          for (j = 0; j < jj; j++, pos += alpha01) {
            y0 = y0items[j] + offset;
            y1 = y1items[j];
            y2 = y2items[j];
            var g = y0 - (y2 + y1 >> 2);
            out[pos++] = g + y2 >> shift;
            out[pos++] = g >> shift;
            out[pos++] = g + y1 >> shift;
          }
        }

        if (fourComponents) {
          for (j = 0, pos = 3; j < jj; j++, pos += 4) {
            out[pos] = y3items[j] + offset >> shift;
          }
        }
      } else {
        for (c = 0; c < componentsCount; c++) {
          var items = transformedTiles[c].items;
          shift = components[c].precision - 8;
          offset = (128 << shift) + 0.5;

          for (pos = c, j = 0, jj = items.length; j < jj; j++) {
            out[pos] = items[j] + offset >> shift;
            pos += componentsCount;
          }
        }
      }

      resultImages.push(result);
    }

    return resultImages;
  }

  function initializeTile(context, tileIndex) {
    var siz = context.SIZ;
    var componentsCount = siz.Csiz;
    var tile = context.tiles[tileIndex];

    for (var c = 0; c < componentsCount; c++) {
      var component = tile.components[c];
      var qcdOrQcc = context.currentTile.QCC[c] !== undefined ? context.currentTile.QCC[c] : context.currentTile.QCD;
      component.quantizationParameters = qcdOrQcc;
      var codOrCoc = context.currentTile.COC[c] !== undefined ? context.currentTile.COC[c] : context.currentTile.COD;
      component.codingStyleParameters = codOrCoc;
    }

    tile.codingStyleDefaultParameters = context.currentTile.COD;
  }

  var TagTree = function TagTreeClosure() {
    function TagTree(width, height) {
      var levelsLength = (0, _util.log2)(Math.max(width, height)) + 1;
      this.levels = [];

      for (var i = 0; i < levelsLength; i++) {
        var level = {
          width: width,
          height: height,
          items: []
        };
        this.levels.push(level);
        width = Math.ceil(width / 2);
        height = Math.ceil(height / 2);
      }
    }

    TagTree.prototype = {
      reset: function TagTree_reset(i, j) {
        var currentLevel = 0,
            value = 0,
            level;

        while (currentLevel < this.levels.length) {
          level = this.levels[currentLevel];
          var index = i + j * level.width;

          if (level.items[index] !== undefined) {
            value = level.items[index];
            break;
          }

          level.index = index;
          i >>= 1;
          j >>= 1;
          currentLevel++;
        }

        currentLevel--;
        level = this.levels[currentLevel];
        level.items[level.index] = value;
        this.currentLevel = currentLevel;
        delete this.value;
      },
      incrementValue: function TagTree_incrementValue() {
        var level = this.levels[this.currentLevel];
        level.items[level.index]++;
      },
      nextLevel: function TagTree_nextLevel() {
        var currentLevel = this.currentLevel;
        var level = this.levels[currentLevel];
        var value = level.items[level.index];
        currentLevel--;

        if (currentLevel < 0) {
          this.value = value;
          return false;
        }

        this.currentLevel = currentLevel;
        level = this.levels[currentLevel];
        level.items[level.index] = value;
        return true;
      }
    };
    return TagTree;
  }();

  var InclusionTree = function InclusionTreeClosure() {
    function InclusionTree(width, height, defaultValue) {
      var levelsLength = (0, _util.log2)(Math.max(width, height)) + 1;
      this.levels = [];

      for (var i = 0; i < levelsLength; i++) {
        var items = new Uint8Array(width * height);

        for (var j = 0, jj = items.length; j < jj; j++) {
          items[j] = defaultValue;
        }

        var level = {
          width: width,
          height: height,
          items: items
        };
        this.levels.push(level);
        width = Math.ceil(width / 2);
        height = Math.ceil(height / 2);
      }
    }

    InclusionTree.prototype = {
      reset: function InclusionTree_reset(i, j, stopValue) {
        var currentLevel = 0;

        while (currentLevel < this.levels.length) {
          var level = this.levels[currentLevel];
          var index = i + j * level.width;
          level.index = index;
          var value = level.items[index];

          if (value === 0xFF) {
            break;
          }

          if (value > stopValue) {
            this.currentLevel = currentLevel;
            this.propagateValues();
            return false;
          }

          i >>= 1;
          j >>= 1;
          currentLevel++;
        }

        this.currentLevel = currentLevel - 1;
        return true;
      },
      incrementValue: function InclusionTree_incrementValue(stopValue) {
        var level = this.levels[this.currentLevel];
        level.items[level.index] = stopValue + 1;
        this.propagateValues();
      },
      propagateValues: function InclusionTree_propagateValues() {
        var levelIndex = this.currentLevel;
        var level = this.levels[levelIndex];
        var currentValue = level.items[level.index];

        while (--levelIndex >= 0) {
          level = this.levels[levelIndex];
          level.items[level.index] = currentValue;
        }
      },
      nextLevel: function InclusionTree_nextLevel() {
        var currentLevel = this.currentLevel;
        var level = this.levels[currentLevel];
        var value = level.items[level.index];
        level.items[level.index] = 0xFF;
        currentLevel--;

        if (currentLevel < 0) {
          return false;
        }

        this.currentLevel = currentLevel;
        level = this.levels[currentLevel];
        level.items[level.index] = value;
        return true;
      }
    };
    return InclusionTree;
  }();

  var BitModel = function BitModelClosure() {
    var UNIFORM_CONTEXT = 17;
    var RUNLENGTH_CONTEXT = 18;
    var LLAndLHContextsLabel = new Uint8Array([0, 5, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 1, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 2, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 2, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 2, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8]);
    var HLContextLabel = new Uint8Array([0, 3, 4, 0, 5, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 1, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 2, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 2, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 2, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8]);
    var HHContextLabel = new Uint8Array([0, 1, 2, 0, 1, 2, 2, 0, 2, 2, 2, 0, 0, 0, 0, 0, 3, 4, 5, 0, 4, 5, 5, 0, 5, 5, 5, 0, 0, 0, 0, 0, 6, 7, 7, 0, 7, 7, 7, 0, 7, 7, 7, 0, 0, 0, 0, 0, 8, 8, 8, 0, 8, 8, 8, 0, 8, 8, 8, 0, 0, 0, 0, 0, 8, 8, 8, 0, 8, 8, 8, 0, 8, 8, 8]);

    function BitModel(width, height, subband, zeroBitPlanes, mb) {
      this.width = width;
      this.height = height;
      this.contextLabelTable = subband === 'HH' ? HHContextLabel : subband === 'HL' ? HLContextLabel : LLAndLHContextsLabel;
      var coefficientCount = width * height;
      this.neighborsSignificance = new Uint8Array(coefficientCount);
      this.coefficentsSign = new Uint8Array(coefficientCount);
      this.coefficentsMagnitude = mb > 14 ? new Uint32Array(coefficientCount) : mb > 6 ? new Uint16Array(coefficientCount) : new Uint8Array(coefficientCount);
      this.processingFlags = new Uint8Array(coefficientCount);
      var bitsDecoded = new Uint8Array(coefficientCount);

      if (zeroBitPlanes !== 0) {
        for (var i = 0; i < coefficientCount; i++) {
          bitsDecoded[i] = zeroBitPlanes;
        }
      }

      this.bitsDecoded = bitsDecoded;
      this.reset();
    }

    BitModel.prototype = {
      setDecoder: function BitModel_setDecoder(decoder) {
        this.decoder = decoder;
      },
      reset: function BitModel_reset() {
        this.contexts = new Int8Array(19);
        this.contexts[0] = 4 << 1 | 0;
        this.contexts[UNIFORM_CONTEXT] = 46 << 1 | 0;
        this.contexts[RUNLENGTH_CONTEXT] = 3 << 1 | 0;
      },
      setNeighborsSignificance: function BitModel_setNeighborsSignificance(row, column, index) {
        var neighborsSignificance = this.neighborsSignificance;
        var width = this.width,
            height = this.height;
        var left = column > 0;
        var right = column + 1 < width;
        var i;

        if (row > 0) {
          i = index - width;

          if (left) {
            neighborsSignificance[i - 1] += 0x10;
          }

          if (right) {
            neighborsSignificance[i + 1] += 0x10;
          }

          neighborsSignificance[i] += 0x04;
        }

        if (row + 1 < height) {
          i = index + width;

          if (left) {
            neighborsSignificance[i - 1] += 0x10;
          }

          if (right) {
            neighborsSignificance[i + 1] += 0x10;
          }

          neighborsSignificance[i] += 0x04;
        }

        if (left) {
          neighborsSignificance[index - 1] += 0x01;
        }

        if (right) {
          neighborsSignificance[index + 1] += 0x01;
        }

        neighborsSignificance[index] |= 0x80;
      },
      runSignificancePropagationPass: function BitModel_runSignificancePropagationPass() {
        var decoder = this.decoder;
        var width = this.width,
            height = this.height;
        var coefficentsMagnitude = this.coefficentsMagnitude;
        var coefficentsSign = this.coefficentsSign;
        var neighborsSignificance = this.neighborsSignificance;
        var processingFlags = this.processingFlags;
        var contexts = this.contexts;
        var labels = this.contextLabelTable;
        var bitsDecoded = this.bitsDecoded;
        var processedInverseMask = ~1;
        var processedMask = 1;
        var firstMagnitudeBitMask = 2;

        for (var i0 = 0; i0 < height; i0 += 4) {
          for (var j = 0; j < width; j++) {
            var index = i0 * width + j;

            for (var i1 = 0; i1 < 4; i1++, index += width) {
              var i = i0 + i1;

              if (i >= height) {
                break;
              }

              processingFlags[index] &= processedInverseMask;

              if (coefficentsMagnitude[index] || !neighborsSignificance[index]) {
                continue;
              }

              var contextLabel = labels[neighborsSignificance[index]];
              var decision = decoder.readBit(contexts, contextLabel);

              if (decision) {
                var sign = this.decodeSignBit(i, j, index);
                coefficentsSign[index] = sign;
                coefficentsMagnitude[index] = 1;
                this.setNeighborsSignificance(i, j, index);
                processingFlags[index] |= firstMagnitudeBitMask;
              }

              bitsDecoded[index]++;
              processingFlags[index] |= processedMask;
            }
          }
        }
      },
      decodeSignBit: function BitModel_decodeSignBit(row, column, index) {
        var width = this.width,
            height = this.height;
        var coefficentsMagnitude = this.coefficentsMagnitude;
        var coefficentsSign = this.coefficentsSign;
        var contribution, sign0, sign1, significance1;
        var contextLabel, decoded;
        significance1 = column > 0 && coefficentsMagnitude[index - 1] !== 0;

        if (column + 1 < width && coefficentsMagnitude[index + 1] !== 0) {
          sign1 = coefficentsSign[index + 1];

          if (significance1) {
            sign0 = coefficentsSign[index - 1];
            contribution = 1 - sign1 - sign0;
          } else {
            contribution = 1 - sign1 - sign1;
          }
        } else if (significance1) {
          sign0 = coefficentsSign[index - 1];
          contribution = 1 - sign0 - sign0;
        } else {
          contribution = 0;
        }

        var horizontalContribution = 3 * contribution;
        significance1 = row > 0 && coefficentsMagnitude[index - width] !== 0;

        if (row + 1 < height && coefficentsMagnitude[index + width] !== 0) {
          sign1 = coefficentsSign[index + width];

          if (significance1) {
            sign0 = coefficentsSign[index - width];
            contribution = 1 - sign1 - sign0 + horizontalContribution;
          } else {
            contribution = 1 - sign1 - sign1 + horizontalContribution;
          }
        } else if (significance1) {
          sign0 = coefficentsSign[index - width];
          contribution = 1 - sign0 - sign0 + horizontalContribution;
        } else {
          contribution = horizontalContribution;
        }

        if (contribution >= 0) {
          contextLabel = 9 + contribution;
          decoded = this.decoder.readBit(this.contexts, contextLabel);
        } else {
          contextLabel = 9 - contribution;
          decoded = this.decoder.readBit(this.contexts, contextLabel) ^ 1;
        }

        return decoded;
      },
      runMagnitudeRefinementPass: function BitModel_runMagnitudeRefinementPass() {
        var decoder = this.decoder;
        var width = this.width,
            height = this.height;
        var coefficentsMagnitude = this.coefficentsMagnitude;
        var neighborsSignificance = this.neighborsSignificance;
        var contexts = this.contexts;
        var bitsDecoded = this.bitsDecoded;
        var processingFlags = this.processingFlags;
        var processedMask = 1;
        var firstMagnitudeBitMask = 2;
        var length = width * height;
        var width4 = width * 4;

        for (var index0 = 0, indexNext; index0 < length; index0 = indexNext) {
          indexNext = Math.min(length, index0 + width4);

          for (var j = 0; j < width; j++) {
            for (var index = index0 + j; index < indexNext; index += width) {
              if (!coefficentsMagnitude[index] || (processingFlags[index] & processedMask) !== 0) {
                continue;
              }

              var contextLabel = 16;

              if ((processingFlags[index] & firstMagnitudeBitMask) !== 0) {
                processingFlags[index] ^= firstMagnitudeBitMask;
                var significance = neighborsSignificance[index] & 127;
                contextLabel = significance === 0 ? 15 : 14;
              }

              var bit = decoder.readBit(contexts, contextLabel);
              coefficentsMagnitude[index] = coefficentsMagnitude[index] << 1 | bit;
              bitsDecoded[index]++;
              processingFlags[index] |= processedMask;
            }
          }
        }
      },
      runCleanupPass: function BitModel_runCleanupPass() {
        var decoder = this.decoder;
        var width = this.width,
            height = this.height;
        var neighborsSignificance = this.neighborsSignificance;
        var coefficentsMagnitude = this.coefficentsMagnitude;
        var coefficentsSign = this.coefficentsSign;
        var contexts = this.contexts;
        var labels = this.contextLabelTable;
        var bitsDecoded = this.bitsDecoded;
        var processingFlags = this.processingFlags;
        var processedMask = 1;
        var firstMagnitudeBitMask = 2;
        var oneRowDown = width;
        var twoRowsDown = width * 2;
        var threeRowsDown = width * 3;
        var iNext;

        for (var i0 = 0; i0 < height; i0 = iNext) {
          iNext = Math.min(i0 + 4, height);
          var indexBase = i0 * width;
          var checkAllEmpty = i0 + 3 < height;

          for (var j = 0; j < width; j++) {
            var index0 = indexBase + j;
            var allEmpty = checkAllEmpty && processingFlags[index0] === 0 && processingFlags[index0 + oneRowDown] === 0 && processingFlags[index0 + twoRowsDown] === 0 && processingFlags[index0 + threeRowsDown] === 0 && neighborsSignificance[index0] === 0 && neighborsSignificance[index0 + oneRowDown] === 0 && neighborsSignificance[index0 + twoRowsDown] === 0 && neighborsSignificance[index0 + threeRowsDown] === 0;
            var i1 = 0,
                index = index0;
            var i = i0,
                sign;

            if (allEmpty) {
              var hasSignificantCoefficent = decoder.readBit(contexts, RUNLENGTH_CONTEXT);

              if (!hasSignificantCoefficent) {
                bitsDecoded[index0]++;
                bitsDecoded[index0 + oneRowDown]++;
                bitsDecoded[index0 + twoRowsDown]++;
                bitsDecoded[index0 + threeRowsDown]++;
                continue;
              }

              i1 = decoder.readBit(contexts, UNIFORM_CONTEXT) << 1 | decoder.readBit(contexts, UNIFORM_CONTEXT);

              if (i1 !== 0) {
                i = i0 + i1;
                index += i1 * width;
              }

              sign = this.decodeSignBit(i, j, index);
              coefficentsSign[index] = sign;
              coefficentsMagnitude[index] = 1;
              this.setNeighborsSignificance(i, j, index);
              processingFlags[index] |= firstMagnitudeBitMask;
              index = index0;

              for (var i2 = i0; i2 <= i; i2++, index += width) {
                bitsDecoded[index]++;
              }

              i1++;
            }

            for (i = i0 + i1; i < iNext; i++, index += width) {
              if (coefficentsMagnitude[index] || (processingFlags[index] & processedMask) !== 0) {
                continue;
              }

              var contextLabel = labels[neighborsSignificance[index]];
              var decision = decoder.readBit(contexts, contextLabel);

              if (decision === 1) {
                sign = this.decodeSignBit(i, j, index);
                coefficentsSign[index] = sign;
                coefficentsMagnitude[index] = 1;
                this.setNeighborsSignificance(i, j, index);
                processingFlags[index] |= firstMagnitudeBitMask;
              }

              bitsDecoded[index]++;
            }
          }
        }
      },
      checkSegmentationSymbol: function BitModel_checkSegmentationSymbol() {
        var decoder = this.decoder;
        var contexts = this.contexts;
        var symbol = decoder.readBit(contexts, UNIFORM_CONTEXT) << 3 | decoder.readBit(contexts, UNIFORM_CONTEXT) << 2 | decoder.readBit(contexts, UNIFORM_CONTEXT) << 1 | decoder.readBit(contexts, UNIFORM_CONTEXT);

        if (symbol !== 0xA) {
          throw new JpxError('Invalid segmentation symbol');
        }
      }
    };
    return BitModel;
  }();

  var Transform = function TransformClosure() {
    function Transform() {}

    Transform.prototype.calculate = function transformCalculate(subbands, u0, v0) {
      var ll = subbands[0];

      for (var i = 1, ii = subbands.length; i < ii; i++) {
        ll = this.iterate(ll, subbands[i], u0, v0);
      }

      return ll;
    };

    Transform.prototype.extend = function extend(buffer, offset, size) {
      var i1 = offset - 1,
          j1 = offset + 1;
      var i2 = offset + size - 2,
          j2 = offset + size;
      buffer[i1--] = buffer[j1++];
      buffer[j2++] = buffer[i2--];
      buffer[i1--] = buffer[j1++];
      buffer[j2++] = buffer[i2--];
      buffer[i1--] = buffer[j1++];
      buffer[j2++] = buffer[i2--];
      buffer[i1] = buffer[j1];
      buffer[j2] = buffer[i2];
    };

    Transform.prototype.iterate = function Transform_iterate(ll, hl_lh_hh, u0, v0) {
      var llWidth = ll.width,
          llHeight = ll.height,
          llItems = ll.items;
      var width = hl_lh_hh.width;
      var height = hl_lh_hh.height;
      var items = hl_lh_hh.items;
      var i, j, k, l, u, v;

      for (k = 0, i = 0; i < llHeight; i++) {
        l = i * 2 * width;

        for (j = 0; j < llWidth; j++, k++, l += 2) {
          items[l] = llItems[k];
        }
      }

      llItems = ll.items = null;
      var bufferPadding = 4;
      var rowBuffer = new Float32Array(width + 2 * bufferPadding);

      if (width === 1) {
        if ((u0 & 1) !== 0) {
          for (v = 0, k = 0; v < height; v++, k += width) {
            items[k] *= 0.5;
          }
        }
      } else {
        for (v = 0, k = 0; v < height; v++, k += width) {
          rowBuffer.set(items.subarray(k, k + width), bufferPadding);
          this.extend(rowBuffer, bufferPadding, width);
          this.filter(rowBuffer, bufferPadding, width);
          items.set(rowBuffer.subarray(bufferPadding, bufferPadding + width), k);
        }
      }

      var numBuffers = 16;
      var colBuffers = [];

      for (i = 0; i < numBuffers; i++) {
        colBuffers.push(new Float32Array(height + 2 * bufferPadding));
      }

      var b,
          currentBuffer = 0;
      ll = bufferPadding + height;

      if (height === 1) {
        if ((v0 & 1) !== 0) {
          for (u = 0; u < width; u++) {
            items[u] *= 0.5;
          }
        }
      } else {
        for (u = 0; u < width; u++) {
          if (currentBuffer === 0) {
            numBuffers = Math.min(width - u, numBuffers);

            for (k = u, l = bufferPadding; l < ll; k += width, l++) {
              for (b = 0; b < numBuffers; b++) {
                colBuffers[b][l] = items[k + b];
              }
            }

            currentBuffer = numBuffers;
          }

          currentBuffer--;
          var buffer = colBuffers[currentBuffer];
          this.extend(buffer, bufferPadding, height);
          this.filter(buffer, bufferPadding, height);

          if (currentBuffer === 0) {
            k = u - numBuffers + 1;

            for (l = bufferPadding; l < ll; k += width, l++) {
              for (b = 0; b < numBuffers; b++) {
                items[k + b] = colBuffers[b][l];
              }
            }
          }
        }
      }

      return {
        width: width,
        height: height,
        items: items
      };
    };

    return Transform;
  }();

  var IrreversibleTransform = function IrreversibleTransformClosure() {
    function IrreversibleTransform() {
      Transform.call(this);
    }

    IrreversibleTransform.prototype = Object.create(Transform.prototype);

    IrreversibleTransform.prototype.filter = function irreversibleTransformFilter(x, offset, length) {
      var len = length >> 1;
      offset = offset | 0;
      var j, n, current, next;
      var alpha = -1.586134342059924;
      var beta = -0.052980118572961;
      var gamma = 0.882911075530934;
      var delta = 0.443506852043971;
      var K = 1.230174104914001;
      var K_ = 1 / K;
      j = offset - 3;

      for (n = len + 4; n--; j += 2) {
        x[j] *= K_;
      }

      j = offset - 2;
      current = delta * x[j - 1];

      for (n = len + 3; n--; j += 2) {
        next = delta * x[j + 1];
        x[j] = K * x[j] - current - next;

        if (n--) {
          j += 2;
          current = delta * x[j + 1];
          x[j] = K * x[j] - current - next;
        } else {
          break;
        }
      }

      j = offset - 1;
      current = gamma * x[j - 1];

      for (n = len + 2; n--; j += 2) {
        next = gamma * x[j + 1];
        x[j] -= current + next;

        if (n--) {
          j += 2;
          current = gamma * x[j + 1];
          x[j] -= current + next;
        } else {
          break;
        }
      }

      j = offset;
      current = beta * x[j - 1];

      for (n = len + 1; n--; j += 2) {
        next = beta * x[j + 1];
        x[j] -= current + next;

        if (n--) {
          j += 2;
          current = beta * x[j + 1];
          x[j] -= current + next;
        } else {
          break;
        }
      }

      if (len !== 0) {
        j = offset + 1;
        current = alpha * x[j - 1];

        for (n = len; n--; j += 2) {
          next = alpha * x[j + 1];
          x[j] -= current + next;

          if (n--) {
            j += 2;
            current = alpha * x[j + 1];
            x[j] -= current + next;
          } else {
            break;
          }
        }
      }
    };

    return IrreversibleTransform;
  }();

  var ReversibleTransform = function ReversibleTransformClosure() {
    function ReversibleTransform() {
      Transform.call(this);
    }

    ReversibleTransform.prototype = Object.create(Transform.prototype);

    ReversibleTransform.prototype.filter = function reversibleTransformFilter(x, offset, length) {
      var len = length >> 1;
      offset = offset | 0;
      var j, n;

      for (j = offset, n = len + 1; n--; j += 2) {
        x[j] -= x[j - 1] + x[j + 1] + 2 >> 2;
      }

      for (j = offset + 1, n = len; n--; j += 2) {
        x[j] += x[j - 1] + x[j + 1] >> 1;
      }
    };

    return ReversibleTransform;
  }();

  return JpxImage;
}();

exports.JpxImage = JpxImage;

/***/ }),
/* 167 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.calculateSHA512 = exports.calculateSHA384 = exports.calculateSHA256 = exports.calculateMD5 = exports.PDF20 = exports.PDF17 = exports.CipherTransformFactory = exports.ARCFourCipher = exports.AES256Cipher = exports.AES128Cipher = void 0;

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

var _stream = __w_pdfjs_require__(157);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ARCFourCipher = function ARCFourCipherClosure() {
  function ARCFourCipher(key) {
    this.a = 0;
    this.b = 0;
    var s = new Uint8Array(256);
    var i,
        j = 0,
        tmp,
        keyLength = key.length;

    for (i = 0; i < 256; ++i) {
      s[i] = i;
    }

    for (i = 0; i < 256; ++i) {
      tmp = s[i];
      j = j + tmp + key[i % keyLength] & 0xFF;
      s[i] = s[j];
      s[j] = tmp;
    }

    this.s = s;
  }

  ARCFourCipher.prototype = {
    encryptBlock: function ARCFourCipher_encryptBlock(data) {
      var i,
          n = data.length,
          tmp,
          tmp2;
      var a = this.a,
          b = this.b,
          s = this.s;
      var output = new Uint8Array(n);

      for (i = 0; i < n; ++i) {
        a = a + 1 & 0xFF;
        tmp = s[a];
        b = b + tmp & 0xFF;
        tmp2 = s[b];
        s[a] = tmp2;
        s[b] = tmp;
        output[i] = data[i] ^ s[tmp + tmp2 & 0xFF];
      }

      this.a = a;
      this.b = b;
      return output;
    }
  };
  ARCFourCipher.prototype.decryptBlock = ARCFourCipher.prototype.encryptBlock;
  return ARCFourCipher;
}();

exports.ARCFourCipher = ARCFourCipher;

var calculateMD5 = function calculateMD5Closure() {
  var r = new Uint8Array([7, 12, 17, 22, 7, 12, 17, 22, 7, 12, 17, 22, 7, 12, 17, 22, 5, 9, 14, 20, 5, 9, 14, 20, 5, 9, 14, 20, 5, 9, 14, 20, 4, 11, 16, 23, 4, 11, 16, 23, 4, 11, 16, 23, 4, 11, 16, 23, 6, 10, 15, 21, 6, 10, 15, 21, 6, 10, 15, 21, 6, 10, 15, 21]);
  var k = new Int32Array([-680876936, -389564586, 606105819, -1044525330, -176418897, 1200080426, -1473231341, -45705983, 1770035416, -1958414417, -42063, -1990404162, 1804603682, -40341101, -1502002290, 1236535329, -165796510, -1069501632, 643717713, -373897302, -701558691, 38016083, -660478335, -405537848, 568446438, -1019803690, -187363961, 1163531501, -1444681467, -51403784, 1735328473, -1926607734, -378558, -2022574463, 1839030562, -35309556, -1530992060, 1272893353, -155497632, -1094730640, 681279174, -358537222, -722521979, 76029189, -640364487, -421815835, 530742520, -995338651, -198630844, 1126891415, -1416354905, -57434055, 1700485571, -1894986606, -1051523, -2054922799, 1873313359, -30611744, -1560198380, 1309151649, -145523070, -1120210379, 718787259, -343485551]);

  function hash(data, offset, length) {
    var h0 = 1732584193,
        h1 = -271733879,
        h2 = -1732584194,
        h3 = 271733878;
    var paddedLength = length + 72 & ~63;
    var padded = new Uint8Array(paddedLength);
    var i, j, n;

    for (i = 0; i < length; ++i) {
      padded[i] = data[offset++];
    }

    padded[i++] = 0x80;
    n = paddedLength - 8;

    while (i < n) {
      padded[i++] = 0;
    }

    padded[i++] = length << 3 & 0xFF;
    padded[i++] = length >> 5 & 0xFF;
    padded[i++] = length >> 13 & 0xFF;
    padded[i++] = length >> 21 & 0xFF;
    padded[i++] = length >>> 29 & 0xFF;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    var w = new Int32Array(16);

    for (i = 0; i < paddedLength;) {
      for (j = 0; j < 16; ++j, i += 4) {
        w[j] = padded[i] | padded[i + 1] << 8 | padded[i + 2] << 16 | padded[i + 3] << 24;
      }

      var a = h0,
          b = h1,
          c = h2,
          d = h3,
          f,
          g;

      for (j = 0; j < 64; ++j) {
        if (j < 16) {
          f = b & c | ~b & d;
          g = j;
        } else if (j < 32) {
          f = d & b | ~d & c;
          g = 5 * j + 1 & 15;
        } else if (j < 48) {
          f = b ^ c ^ d;
          g = 3 * j + 5 & 15;
        } else {
          f = c ^ (b | ~d);
          g = 7 * j & 15;
        }

        var tmp = d,
            rotateArg = a + f + k[j] + w[g] | 0,
            rotate = r[j];
        d = c;
        c = b;
        b = b + (rotateArg << rotate | rotateArg >>> 32 - rotate) | 0;
        a = tmp;
      }

      h0 = h0 + a | 0;
      h1 = h1 + b | 0;
      h2 = h2 + c | 0;
      h3 = h3 + d | 0;
    }

    return new Uint8Array([h0 & 0xFF, h0 >> 8 & 0xFF, h0 >> 16 & 0xFF, h0 >>> 24 & 0xFF, h1 & 0xFF, h1 >> 8 & 0xFF, h1 >> 16 & 0xFF, h1 >>> 24 & 0xFF, h2 & 0xFF, h2 >> 8 & 0xFF, h2 >> 16 & 0xFF, h2 >>> 24 & 0xFF, h3 & 0xFF, h3 >> 8 & 0xFF, h3 >> 16 & 0xFF, h3 >>> 24 & 0xFF]);
  }

  return hash;
}();

exports.calculateMD5 = calculateMD5;

var Word64 = function Word64Closure() {
  function Word64(highInteger, lowInteger) {
    this.high = highInteger | 0;
    this.low = lowInteger | 0;
  }

  Word64.prototype = {
    and: function Word64_and(word) {
      this.high &= word.high;
      this.low &= word.low;
    },
    xor: function Word64_xor(word) {
      this.high ^= word.high;
      this.low ^= word.low;
    },
    or: function Word64_or(word) {
      this.high |= word.high;
      this.low |= word.low;
    },
    shiftRight: function Word64_shiftRight(places) {
      if (places >= 32) {
        this.low = this.high >>> places - 32 | 0;
        this.high = 0;
      } else {
        this.low = this.low >>> places | this.high << 32 - places;
        this.high = this.high >>> places | 0;
      }
    },
    shiftLeft: function Word64_shiftLeft(places) {
      if (places >= 32) {
        this.high = this.low << places - 32;
        this.low = 0;
      } else {
        this.high = this.high << places | this.low >>> 32 - places;
        this.low = this.low << places;
      }
    },
    rotateRight: function Word64_rotateRight(places) {
      var low, high;

      if (places & 32) {
        high = this.low;
        low = this.high;
      } else {
        low = this.low;
        high = this.high;
      }

      places &= 31;
      this.low = low >>> places | high << 32 - places;
      this.high = high >>> places | low << 32 - places;
    },
    not: function Word64_not() {
      this.high = ~this.high;
      this.low = ~this.low;
    },
    add: function Word64_add(word) {
      var lowAdd = (this.low >>> 0) + (word.low >>> 0);
      var highAdd = (this.high >>> 0) + (word.high >>> 0);

      if (lowAdd > 0xFFFFFFFF) {
        highAdd += 1;
      }

      this.low = lowAdd | 0;
      this.high = highAdd | 0;
    },
    copyTo: function Word64_copyTo(bytes, offset) {
      bytes[offset] = this.high >>> 24 & 0xFF;
      bytes[offset + 1] = this.high >> 16 & 0xFF;
      bytes[offset + 2] = this.high >> 8 & 0xFF;
      bytes[offset + 3] = this.high & 0xFF;
      bytes[offset + 4] = this.low >>> 24 & 0xFF;
      bytes[offset + 5] = this.low >> 16 & 0xFF;
      bytes[offset + 6] = this.low >> 8 & 0xFF;
      bytes[offset + 7] = this.low & 0xFF;
    },
    assign: function Word64_assign(word) {
      this.high = word.high;
      this.low = word.low;
    }
  };
  return Word64;
}();

var calculateSHA256 = function calculateSHA256Closure() {
  function rotr(x, n) {
    return x >>> n | x << 32 - n;
  }

  function ch(x, y, z) {
    return x & y ^ ~x & z;
  }

  function maj(x, y, z) {
    return x & y ^ x & z ^ y & z;
  }

  function sigma(x) {
    return rotr(x, 2) ^ rotr(x, 13) ^ rotr(x, 22);
  }

  function sigmaPrime(x) {
    return rotr(x, 6) ^ rotr(x, 11) ^ rotr(x, 25);
  }

  function littleSigma(x) {
    return rotr(x, 7) ^ rotr(x, 18) ^ x >>> 3;
  }

  function littleSigmaPrime(x) {
    return rotr(x, 17) ^ rotr(x, 19) ^ x >>> 10;
  }

  var k = [0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5, 0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174, 0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da, 0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967, 0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85, 0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070, 0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3, 0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2];

  function hash(data, offset, length) {
    var h0 = 0x6a09e667,
        h1 = 0xbb67ae85,
        h2 = 0x3c6ef372,
        h3 = 0xa54ff53a,
        h4 = 0x510e527f,
        h5 = 0x9b05688c,
        h6 = 0x1f83d9ab,
        h7 = 0x5be0cd19;
    var paddedLength = Math.ceil((length + 9) / 64) * 64;
    var padded = new Uint8Array(paddedLength);
    var i, j, n;

    for (i = 0; i < length; ++i) {
      padded[i] = data[offset++];
    }

    padded[i++] = 0x80;
    n = paddedLength - 8;

    while (i < n) {
      padded[i++] = 0;
    }

    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = length >>> 29 & 0xFF;
    padded[i++] = length >> 21 & 0xFF;
    padded[i++] = length >> 13 & 0xFF;
    padded[i++] = length >> 5 & 0xFF;
    padded[i++] = length << 3 & 0xFF;
    var w = new Uint32Array(64);

    for (i = 0; i < paddedLength;) {
      for (j = 0; j < 16; ++j) {
        w[j] = padded[i] << 24 | padded[i + 1] << 16 | padded[i + 2] << 8 | padded[i + 3];
        i += 4;
      }

      for (j = 16; j < 64; ++j) {
        w[j] = littleSigmaPrime(w[j - 2]) + w[j - 7] + littleSigma(w[j - 15]) + w[j - 16] | 0;
      }

      var a = h0,
          b = h1,
          c = h2,
          d = h3,
          e = h4,
          f = h5,
          g = h6,
          h = h7,
          t1,
          t2;

      for (j = 0; j < 64; ++j) {
        t1 = h + sigmaPrime(e) + ch(e, f, g) + k[j] + w[j];
        t2 = sigma(a) + maj(a, b, c);
        h = g;
        g = f;
        f = e;
        e = d + t1 | 0;
        d = c;
        c = b;
        b = a;
        a = t1 + t2 | 0;
      }

      h0 = h0 + a | 0;
      h1 = h1 + b | 0;
      h2 = h2 + c | 0;
      h3 = h3 + d | 0;
      h4 = h4 + e | 0;
      h5 = h5 + f | 0;
      h6 = h6 + g | 0;
      h7 = h7 + h | 0;
    }

    return new Uint8Array([h0 >> 24 & 0xFF, h0 >> 16 & 0xFF, h0 >> 8 & 0xFF, h0 & 0xFF, h1 >> 24 & 0xFF, h1 >> 16 & 0xFF, h1 >> 8 & 0xFF, h1 & 0xFF, h2 >> 24 & 0xFF, h2 >> 16 & 0xFF, h2 >> 8 & 0xFF, h2 & 0xFF, h3 >> 24 & 0xFF, h3 >> 16 & 0xFF, h3 >> 8 & 0xFF, h3 & 0xFF, h4 >> 24 & 0xFF, h4 >> 16 & 0xFF, h4 >> 8 & 0xFF, h4 & 0xFF, h5 >> 24 & 0xFF, h5 >> 16 & 0xFF, h5 >> 8 & 0xFF, h5 & 0xFF, h6 >> 24 & 0xFF, h6 >> 16 & 0xFF, h6 >> 8 & 0xFF, h6 & 0xFF, h7 >> 24 & 0xFF, h7 >> 16 & 0xFF, h7 >> 8 & 0xFF, h7 & 0xFF]);
  }

  return hash;
}();

exports.calculateSHA256 = calculateSHA256;

var calculateSHA512 = function calculateSHA512Closure() {
  function ch(result, x, y, z, tmp) {
    result.assign(x);
    result.and(y);
    tmp.assign(x);
    tmp.not();
    tmp.and(z);
    result.xor(tmp);
  }

  function maj(result, x, y, z, tmp) {
    result.assign(x);
    result.and(y);
    tmp.assign(x);
    tmp.and(z);
    result.xor(tmp);
    tmp.assign(y);
    tmp.and(z);
    result.xor(tmp);
  }

  function sigma(result, x, tmp) {
    result.assign(x);
    result.rotateRight(28);
    tmp.assign(x);
    tmp.rotateRight(34);
    result.xor(tmp);
    tmp.assign(x);
    tmp.rotateRight(39);
    result.xor(tmp);
  }

  function sigmaPrime(result, x, tmp) {
    result.assign(x);
    result.rotateRight(14);
    tmp.assign(x);
    tmp.rotateRight(18);
    result.xor(tmp);
    tmp.assign(x);
    tmp.rotateRight(41);
    result.xor(tmp);
  }

  function littleSigma(result, x, tmp) {
    result.assign(x);
    result.rotateRight(1);
    tmp.assign(x);
    tmp.rotateRight(8);
    result.xor(tmp);
    tmp.assign(x);
    tmp.shiftRight(7);
    result.xor(tmp);
  }

  function littleSigmaPrime(result, x, tmp) {
    result.assign(x);
    result.rotateRight(19);
    tmp.assign(x);
    tmp.rotateRight(61);
    result.xor(tmp);
    tmp.assign(x);
    tmp.shiftRight(6);
    result.xor(tmp);
  }

  var k = [new Word64(0x428a2f98, 0xd728ae22), new Word64(0x71374491, 0x23ef65cd), new Word64(0xb5c0fbcf, 0xec4d3b2f), new Word64(0xe9b5dba5, 0x8189dbbc), new Word64(0x3956c25b, 0xf348b538), new Word64(0x59f111f1, 0xb605d019), new Word64(0x923f82a4, 0xaf194f9b), new Word64(0xab1c5ed5, 0xda6d8118), new Word64(0xd807aa98, 0xa3030242), new Word64(0x12835b01, 0x45706fbe), new Word64(0x243185be, 0x4ee4b28c), new Word64(0x550c7dc3, 0xd5ffb4e2), new Word64(0x72be5d74, 0xf27b896f), new Word64(0x80deb1fe, 0x3b1696b1), new Word64(0x9bdc06a7, 0x25c71235), new Word64(0xc19bf174, 0xcf692694), new Word64(0xe49b69c1, 0x9ef14ad2), new Word64(0xefbe4786, 0x384f25e3), new Word64(0x0fc19dc6, 0x8b8cd5b5), new Word64(0x240ca1cc, 0x77ac9c65), new Word64(0x2de92c6f, 0x592b0275), new Word64(0x4a7484aa, 0x6ea6e483), new Word64(0x5cb0a9dc, 0xbd41fbd4), new Word64(0x76f988da, 0x831153b5), new Word64(0x983e5152, 0xee66dfab), new Word64(0xa831c66d, 0x2db43210), new Word64(0xb00327c8, 0x98fb213f), new Word64(0xbf597fc7, 0xbeef0ee4), new Word64(0xc6e00bf3, 0x3da88fc2), new Word64(0xd5a79147, 0x930aa725), new Word64(0x06ca6351, 0xe003826f), new Word64(0x14292967, 0x0a0e6e70), new Word64(0x27b70a85, 0x46d22ffc), new Word64(0x2e1b2138, 0x5c26c926), new Word64(0x4d2c6dfc, 0x5ac42aed), new Word64(0x53380d13, 0x9d95b3df), new Word64(0x650a7354, 0x8baf63de), new Word64(0x766a0abb, 0x3c77b2a8), new Word64(0x81c2c92e, 0x47edaee6), new Word64(0x92722c85, 0x1482353b), new Word64(0xa2bfe8a1, 0x4cf10364), new Word64(0xa81a664b, 0xbc423001), new Word64(0xc24b8b70, 0xd0f89791), new Word64(0xc76c51a3, 0x0654be30), new Word64(0xd192e819, 0xd6ef5218), new Word64(0xd6990624, 0x5565a910), new Word64(0xf40e3585, 0x5771202a), new Word64(0x106aa070, 0x32bbd1b8), new Word64(0x19a4c116, 0xb8d2d0c8), new Word64(0x1e376c08, 0x5141ab53), new Word64(0x2748774c, 0xdf8eeb99), new Word64(0x34b0bcb5, 0xe19b48a8), new Word64(0x391c0cb3, 0xc5c95a63), new Word64(0x4ed8aa4a, 0xe3418acb), new Word64(0x5b9cca4f, 0x7763e373), new Word64(0x682e6ff3, 0xd6b2b8a3), new Word64(0x748f82ee, 0x5defb2fc), new Word64(0x78a5636f, 0x43172f60), new Word64(0x84c87814, 0xa1f0ab72), new Word64(0x8cc70208, 0x1a6439ec), new Word64(0x90befffa, 0x23631e28), new Word64(0xa4506ceb, 0xde82bde9), new Word64(0xbef9a3f7, 0xb2c67915), new Word64(0xc67178f2, 0xe372532b), new Word64(0xca273ece, 0xea26619c), new Word64(0xd186b8c7, 0x21c0c207), new Word64(0xeada7dd6, 0xcde0eb1e), new Word64(0xf57d4f7f, 0xee6ed178), new Word64(0x06f067aa, 0x72176fba), new Word64(0x0a637dc5, 0xa2c898a6), new Word64(0x113f9804, 0xbef90dae), new Word64(0x1b710b35, 0x131c471b), new Word64(0x28db77f5, 0x23047d84), new Word64(0x32caab7b, 0x40c72493), new Word64(0x3c9ebe0a, 0x15c9bebc), new Word64(0x431d67c4, 0x9c100d4c), new Word64(0x4cc5d4be, 0xcb3e42b6), new Word64(0x597f299c, 0xfc657e2a), new Word64(0x5fcb6fab, 0x3ad6faec), new Word64(0x6c44198c, 0x4a475817)];

  function hash(data, offset, length, mode384) {
    mode384 = !!mode384;
    var h0, h1, h2, h3, h4, h5, h6, h7;

    if (!mode384) {
      h0 = new Word64(0x6a09e667, 0xf3bcc908);
      h1 = new Word64(0xbb67ae85, 0x84caa73b);
      h2 = new Word64(0x3c6ef372, 0xfe94f82b);
      h3 = new Word64(0xa54ff53a, 0x5f1d36f1);
      h4 = new Word64(0x510e527f, 0xade682d1);
      h5 = new Word64(0x9b05688c, 0x2b3e6c1f);
      h6 = new Word64(0x1f83d9ab, 0xfb41bd6b);
      h7 = new Word64(0x5be0cd19, 0x137e2179);
    } else {
      h0 = new Word64(0xcbbb9d5d, 0xc1059ed8);
      h1 = new Word64(0x629a292a, 0x367cd507);
      h2 = new Word64(0x9159015a, 0x3070dd17);
      h3 = new Word64(0x152fecd8, 0xf70e5939);
      h4 = new Word64(0x67332667, 0xffc00b31);
      h5 = new Word64(0x8eb44a87, 0x68581511);
      h6 = new Word64(0xdb0c2e0d, 0x64f98fa7);
      h7 = new Word64(0x47b5481d, 0xbefa4fa4);
    }

    var paddedLength = Math.ceil((length + 17) / 128) * 128;
    var padded = new Uint8Array(paddedLength);
    var i, j, n;

    for (i = 0; i < length; ++i) {
      padded[i] = data[offset++];
    }

    padded[i++] = 0x80;
    n = paddedLength - 16;

    while (i < n) {
      padded[i++] = 0;
    }

    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = 0;
    padded[i++] = length >>> 29 & 0xFF;
    padded[i++] = length >> 21 & 0xFF;
    padded[i++] = length >> 13 & 0xFF;
    padded[i++] = length >> 5 & 0xFF;
    padded[i++] = length << 3 & 0xFF;
    var w = new Array(80);

    for (i = 0; i < 80; i++) {
      w[i] = new Word64(0, 0);
    }

    var a = new Word64(0, 0),
        b = new Word64(0, 0),
        c = new Word64(0, 0);
    var d = new Word64(0, 0),
        e = new Word64(0, 0),
        f = new Word64(0, 0);
    var g = new Word64(0, 0),
        h = new Word64(0, 0);
    var t1 = new Word64(0, 0),
        t2 = new Word64(0, 0);
    var tmp1 = new Word64(0, 0),
        tmp2 = new Word64(0, 0),
        tmp3;

    for (i = 0; i < paddedLength;) {
      for (j = 0; j < 16; ++j) {
        w[j].high = padded[i] << 24 | padded[i + 1] << 16 | padded[i + 2] << 8 | padded[i + 3];
        w[j].low = padded[i + 4] << 24 | padded[i + 5] << 16 | padded[i + 6] << 8 | padded[i + 7];
        i += 8;
      }

      for (j = 16; j < 80; ++j) {
        tmp3 = w[j];
        littleSigmaPrime(tmp3, w[j - 2], tmp2);
        tmp3.add(w[j - 7]);
        littleSigma(tmp1, w[j - 15], tmp2);
        tmp3.add(tmp1);
        tmp3.add(w[j - 16]);
      }

      a.assign(h0);
      b.assign(h1);
      c.assign(h2);
      d.assign(h3);
      e.assign(h4);
      f.assign(h5);
      g.assign(h6);
      h.assign(h7);

      for (j = 0; j < 80; ++j) {
        t1.assign(h);
        sigmaPrime(tmp1, e, tmp2);
        t1.add(tmp1);
        ch(tmp1, e, f, g, tmp2);
        t1.add(tmp1);
        t1.add(k[j]);
        t1.add(w[j]);
        sigma(t2, a, tmp2);
        maj(tmp1, a, b, c, tmp2);
        t2.add(tmp1);
        tmp3 = h;
        h = g;
        g = f;
        f = e;
        d.add(t1);
        e = d;
        d = c;
        c = b;
        b = a;
        tmp3.assign(t1);
        tmp3.add(t2);
        a = tmp3;
      }

      h0.add(a);
      h1.add(b);
      h2.add(c);
      h3.add(d);
      h4.add(e);
      h5.add(f);
      h6.add(g);
      h7.add(h);
    }

    var result;

    if (!mode384) {
      result = new Uint8Array(64);
      h0.copyTo(result, 0);
      h1.copyTo(result, 8);
      h2.copyTo(result, 16);
      h3.copyTo(result, 24);
      h4.copyTo(result, 32);
      h5.copyTo(result, 40);
      h6.copyTo(result, 48);
      h7.copyTo(result, 56);
    } else {
      result = new Uint8Array(48);
      h0.copyTo(result, 0);
      h1.copyTo(result, 8);
      h2.copyTo(result, 16);
      h3.copyTo(result, 24);
      h4.copyTo(result, 32);
      h5.copyTo(result, 40);
    }

    return result;
  }

  return hash;
}();

exports.calculateSHA512 = calculateSHA512;

var calculateSHA384 = function calculateSHA384Closure() {
  function hash(data, offset, length) {
    return calculateSHA512(data, offset, length, true);
  }

  return hash;
}();

exports.calculateSHA384 = calculateSHA384;

var NullCipher = function NullCipherClosure() {
  function NullCipher() {}

  NullCipher.prototype = {
    decryptBlock: function NullCipher_decryptBlock(data) {
      return data;
    }
  };
  return NullCipher;
}();

var AESBaseCipher =
/*#__PURE__*/
function () {
  function AESBaseCipher() {
    _classCallCheck(this, AESBaseCipher);

    if (this.constructor === AESBaseCipher) {
      (0, _util.unreachable)('Cannot initialize AESBaseCipher.');
    }

    this._s = new Uint8Array([0x63, 0x7c, 0x77, 0x7b, 0xf2, 0x6b, 0x6f, 0xc5, 0x30, 0x01, 0x67, 0x2b, 0xfe, 0xd7, 0xab, 0x76, 0xca, 0x82, 0xc9, 0x7d, 0xfa, 0x59, 0x47, 0xf0, 0xad, 0xd4, 0xa2, 0xaf, 0x9c, 0xa4, 0x72, 0xc0, 0xb7, 0xfd, 0x93, 0x26, 0x36, 0x3f, 0xf7, 0xcc, 0x34, 0xa5, 0xe5, 0xf1, 0x71, 0xd8, 0x31, 0x15, 0x04, 0xc7, 0x23, 0xc3, 0x18, 0x96, 0x05, 0x9a, 0x07, 0x12, 0x80, 0xe2, 0xeb, 0x27, 0xb2, 0x75, 0x09, 0x83, 0x2c, 0x1a, 0x1b, 0x6e, 0x5a, 0xa0, 0x52, 0x3b, 0xd6, 0xb3, 0x29, 0xe3, 0x2f, 0x84, 0x53, 0xd1, 0x00, 0xed, 0x20, 0xfc, 0xb1, 0x5b, 0x6a, 0xcb, 0xbe, 0x39, 0x4a, 0x4c, 0x58, 0xcf, 0xd0, 0xef, 0xaa, 0xfb, 0x43, 0x4d, 0x33, 0x85, 0x45, 0xf9, 0x02, 0x7f, 0x50, 0x3c, 0x9f, 0xa8, 0x51, 0xa3, 0x40, 0x8f, 0x92, 0x9d, 0x38, 0xf5, 0xbc, 0xb6, 0xda, 0x21, 0x10, 0xff, 0xf3, 0xd2, 0xcd, 0x0c, 0x13, 0xec, 0x5f, 0x97, 0x44, 0x17, 0xc4, 0xa7, 0x7e, 0x3d, 0x64, 0x5d, 0x19, 0x73, 0x60, 0x81, 0x4f, 0xdc, 0x22, 0x2a, 0x90, 0x88, 0x46, 0xee, 0xb8, 0x14, 0xde, 0x5e, 0x0b, 0xdb, 0xe0, 0x32, 0x3a, 0x0a, 0x49, 0x06, 0x24, 0x5c, 0xc2, 0xd3, 0xac, 0x62, 0x91, 0x95, 0xe4, 0x79, 0xe7, 0xc8, 0x37, 0x6d, 0x8d, 0xd5, 0x4e, 0xa9, 0x6c, 0x56, 0xf4, 0xea, 0x65, 0x7a, 0xae, 0x08, 0xba, 0x78, 0x25, 0x2e, 0x1c, 0xa6, 0xb4, 0xc6, 0xe8, 0xdd, 0x74, 0x1f, 0x4b, 0xbd, 0x8b, 0x8a, 0x70, 0x3e, 0xb5, 0x66, 0x48, 0x03, 0xf6, 0x0e, 0x61, 0x35, 0x57, 0xb9, 0x86, 0xc1, 0x1d, 0x9e, 0xe1, 0xf8, 0x98, 0x11, 0x69, 0xd9, 0x8e, 0x94, 0x9b, 0x1e, 0x87, 0xe9, 0xce, 0x55, 0x28, 0xdf, 0x8c, 0xa1, 0x89, 0x0d, 0xbf, 0xe6, 0x42, 0x68, 0x41, 0x99, 0x2d, 0x0f, 0xb0, 0x54, 0xbb, 0x16]);
    this._inv_s = new Uint8Array([0x52, 0x09, 0x6a, 0xd5, 0x30, 0x36, 0xa5, 0x38, 0xbf, 0x40, 0xa3, 0x9e, 0x81, 0xf3, 0xd7, 0xfb, 0x7c, 0xe3, 0x39, 0x82, 0x9b, 0x2f, 0xff, 0x87, 0x34, 0x8e, 0x43, 0x44, 0xc4, 0xde, 0xe9, 0xcb, 0x54, 0x7b, 0x94, 0x32, 0xa6, 0xc2, 0x23, 0x3d, 0xee, 0x4c, 0x95, 0x0b, 0x42, 0xfa, 0xc3, 0x4e, 0x08, 0x2e, 0xa1, 0x66, 0x28, 0xd9, 0x24, 0xb2, 0x76, 0x5b, 0xa2, 0x49, 0x6d, 0x8b, 0xd1, 0x25, 0x72, 0xf8, 0xf6, 0x64, 0x86, 0x68, 0x98, 0x16, 0xd4, 0xa4, 0x5c, 0xcc, 0x5d, 0x65, 0xb6, 0x92, 0x6c, 0x70, 0x48, 0x50, 0xfd, 0xed, 0xb9, 0xda, 0x5e, 0x15, 0x46, 0x57, 0xa7, 0x8d, 0x9d, 0x84, 0x90, 0xd8, 0xab, 0x00, 0x8c, 0xbc, 0xd3, 0x0a, 0xf7, 0xe4, 0x58, 0x05, 0xb8, 0xb3, 0x45, 0x06, 0xd0, 0x2c, 0x1e, 0x8f, 0xca, 0x3f, 0x0f, 0x02, 0xc1, 0xaf, 0xbd, 0x03, 0x01, 0x13, 0x8a, 0x6b, 0x3a, 0x91, 0x11, 0x41, 0x4f, 0x67, 0xdc, 0xea, 0x97, 0xf2, 0xcf, 0xce, 0xf0, 0xb4, 0xe6, 0x73, 0x96, 0xac, 0x74, 0x22, 0xe7, 0xad, 0x35, 0x85, 0xe2, 0xf9, 0x37, 0xe8, 0x1c, 0x75, 0xdf, 0x6e, 0x47, 0xf1, 0x1a, 0x71, 0x1d, 0x29, 0xc5, 0x89, 0x6f, 0xb7, 0x62, 0x0e, 0xaa, 0x18, 0xbe, 0x1b, 0xfc, 0x56, 0x3e, 0x4b, 0xc6, 0xd2, 0x79, 0x20, 0x9a, 0xdb, 0xc0, 0xfe, 0x78, 0xcd, 0x5a, 0xf4, 0x1f, 0xdd, 0xa8, 0x33, 0x88, 0x07, 0xc7, 0x31, 0xb1, 0x12, 0x10, 0x59, 0x27, 0x80, 0xec, 0x5f, 0x60, 0x51, 0x7f, 0xa9, 0x19, 0xb5, 0x4a, 0x0d, 0x2d, 0xe5, 0x7a, 0x9f, 0x93, 0xc9, 0x9c, 0xef, 0xa0, 0xe0, 0x3b, 0x4d, 0xae, 0x2a, 0xf5, 0xb0, 0xc8, 0xeb, 0xbb, 0x3c, 0x83, 0x53, 0x99, 0x61, 0x17, 0x2b, 0x04, 0x7e, 0xba, 0x77, 0xd6, 0x26, 0xe1, 0x69, 0x14, 0x63, 0x55, 0x21, 0x0c, 0x7d]);
    this._mix = new Uint32Array([0x00000000, 0x0e090d0b, 0x1c121a16, 0x121b171d, 0x3824342c, 0x362d3927, 0x24362e3a, 0x2a3f2331, 0x70486858, 0x7e416553, 0x6c5a724e, 0x62537f45, 0x486c5c74, 0x4665517f, 0x547e4662, 0x5a774b69, 0xe090d0b0, 0xee99ddbb, 0xfc82caa6, 0xf28bc7ad, 0xd8b4e49c, 0xd6bde997, 0xc4a6fe8a, 0xcaaff381, 0x90d8b8e8, 0x9ed1b5e3, 0x8ccaa2fe, 0x82c3aff5, 0xa8fc8cc4, 0xa6f581cf, 0xb4ee96d2, 0xbae79bd9, 0xdb3bbb7b, 0xd532b670, 0xc729a16d, 0xc920ac66, 0xe31f8f57, 0xed16825c, 0xff0d9541, 0xf104984a, 0xab73d323, 0xa57ade28, 0xb761c935, 0xb968c43e, 0x9357e70f, 0x9d5eea04, 0x8f45fd19, 0x814cf012, 0x3bab6bcb, 0x35a266c0, 0x27b971dd, 0x29b07cd6, 0x038f5fe7, 0x0d8652ec, 0x1f9d45f1, 0x119448fa, 0x4be30393, 0x45ea0e98, 0x57f11985, 0x59f8148e, 0x73c737bf, 0x7dce3ab4, 0x6fd52da9, 0x61dc20a2, 0xad766df6, 0xa37f60fd, 0xb16477e0, 0xbf6d7aeb, 0x955259da, 0x9b5b54d1, 0x894043cc, 0x87494ec7, 0xdd3e05ae, 0xd33708a5, 0xc12c1fb8, 0xcf2512b3, 0xe51a3182, 0xeb133c89, 0xf9082b94, 0xf701269f, 0x4de6bd46, 0x43efb04d, 0x51f4a750, 0x5ffdaa5b, 0x75c2896a, 0x7bcb8461, 0x69d0937c, 0x67d99e77, 0x3daed51e, 0x33a7d815, 0x21bccf08, 0x2fb5c203, 0x058ae132, 0x0b83ec39, 0x1998fb24, 0x1791f62f, 0x764dd68d, 0x7844db86, 0x6a5fcc9b, 0x6456c190, 0x4e69e2a1, 0x4060efaa, 0x527bf8b7, 0x5c72f5bc, 0x0605bed5, 0x080cb3de, 0x1a17a4c3, 0x141ea9c8, 0x3e218af9, 0x302887f2, 0x223390ef, 0x2c3a9de4, 0x96dd063d, 0x98d40b36, 0x8acf1c2b, 0x84c61120, 0xaef93211, 0xa0f03f1a, 0xb2eb2807, 0xbce2250c, 0xe6956e65, 0xe89c636e, 0xfa877473, 0xf48e7978, 0xdeb15a49, 0xd0b85742, 0xc2a3405f, 0xccaa4d54, 0x41ecdaf7, 0x4fe5d7fc, 0x5dfec0e1, 0x53f7cdea, 0x79c8eedb, 0x77c1e3d0, 0x65daf4cd, 0x6bd3f9c6, 0x31a4b2af, 0x3fadbfa4, 0x2db6a8b9, 0x23bfa5b2, 0x09808683, 0x07898b88, 0x15929c95, 0x1b9b919e, 0xa17c0a47, 0xaf75074c, 0xbd6e1051, 0xb3671d5a, 0x99583e6b, 0x97513360, 0x854a247d, 0x8b432976, 0xd134621f, 0xdf3d6f14, 0xcd267809, 0xc32f7502, 0xe9105633, 0xe7195b38, 0xf5024c25, 0xfb0b412e, 0x9ad7618c, 0x94de6c87, 0x86c57b9a, 0x88cc7691, 0xa2f355a0, 0xacfa58ab, 0xbee14fb6, 0xb0e842bd, 0xea9f09d4, 0xe49604df, 0xf68d13c2, 0xf8841ec9, 0xd2bb3df8, 0xdcb230f3, 0xcea927ee, 0xc0a02ae5, 0x7a47b13c, 0x744ebc37, 0x6655ab2a, 0x685ca621, 0x42638510, 0x4c6a881b, 0x5e719f06, 0x5078920d, 0x0a0fd964, 0x0406d46f, 0x161dc372, 0x1814ce79, 0x322bed48, 0x3c22e043, 0x2e39f75e, 0x2030fa55, 0xec9ab701, 0xe293ba0a, 0xf088ad17, 0xfe81a01c, 0xd4be832d, 0xdab78e26, 0xc8ac993b, 0xc6a59430, 0x9cd2df59, 0x92dbd252, 0x80c0c54f, 0x8ec9c844, 0xa4f6eb75, 0xaaffe67e, 0xb8e4f163, 0xb6edfc68, 0x0c0a67b1, 0x02036aba, 0x10187da7, 0x1e1170ac, 0x342e539d, 0x3a275e96, 0x283c498b, 0x26354480, 0x7c420fe9, 0x724b02e2, 0x605015ff, 0x6e5918f4, 0x44663bc5, 0x4a6f36ce, 0x587421d3, 0x567d2cd8, 0x37a10c7a, 0x39a80171, 0x2bb3166c, 0x25ba1b67, 0x0f853856, 0x018c355d, 0x13972240, 0x1d9e2f4b, 0x47e96422, 0x49e06929, 0x5bfb7e34, 0x55f2733f, 0x7fcd500e, 0x71c45d05, 0x63df4a18, 0x6dd64713, 0xd731dcca, 0xd938d1c1, 0xcb23c6dc, 0xc52acbd7, 0xef15e8e6, 0xe11ce5ed, 0xf307f2f0, 0xfd0efffb, 0xa779b492, 0xa970b999, 0xbb6bae84, 0xb562a38f, 0x9f5d80be, 0x91548db5, 0x834f9aa8, 0x8d4697a3]);
    this._mixCol = new Uint8Array(256);

    for (var i = 0; i < 256; i++) {
      if (i < 128) {
        this._mixCol[i] = i << 1;
      } else {
        this._mixCol[i] = i << 1 ^ 0x1b;
      }
    }

    this.buffer = new Uint8Array(16);
    this.bufferPosition = 0;
  }

  _createClass(AESBaseCipher, [{
    key: "_expandKey",
    value: function _expandKey(cipherKey) {
      (0, _util.unreachable)('Cannot call `_expandKey` on the base class');
    }
  }, {
    key: "_decrypt",
    value: function _decrypt(input, key) {
      var t, u, v;
      var state = new Uint8Array(16);
      state.set(input);

      for (var j = 0, k = this._keySize; j < 16; ++j, ++k) {
        state[j] ^= key[k];
      }

      for (var i = this._cyclesOfRepetition - 1; i >= 1; --i) {
        t = state[13];
        state[13] = state[9];
        state[9] = state[5];
        state[5] = state[1];
        state[1] = t;
        t = state[14];
        u = state[10];
        state[14] = state[6];
        state[10] = state[2];
        state[6] = t;
        state[2] = u;
        t = state[15];
        u = state[11];
        v = state[7];
        state[15] = state[3];
        state[11] = t;
        state[7] = u;
        state[3] = v;

        for (var _j = 0; _j < 16; ++_j) {
          state[_j] = this._inv_s[state[_j]];
        }

        for (var _j2 = 0, _k = i * 16; _j2 < 16; ++_j2, ++_k) {
          state[_j2] ^= key[_k];
        }

        for (var _j3 = 0; _j3 < 16; _j3 += 4) {
          var s0 = this._mix[state[_j3]];
          var s1 = this._mix[state[_j3 + 1]];
          var s2 = this._mix[state[_j3 + 2]];
          var s3 = this._mix[state[_j3 + 3]];
          t = s0 ^ s1 >>> 8 ^ s1 << 24 ^ s2 >>> 16 ^ s2 << 16 ^ s3 >>> 24 ^ s3 << 8;
          state[_j3] = t >>> 24 & 0xFF;
          state[_j3 + 1] = t >> 16 & 0xFF;
          state[_j3 + 2] = t >> 8 & 0xFF;
          state[_j3 + 3] = t & 0xFF;
        }
      }

      t = state[13];
      state[13] = state[9];
      state[9] = state[5];
      state[5] = state[1];
      state[1] = t;
      t = state[14];
      u = state[10];
      state[14] = state[6];
      state[10] = state[2];
      state[6] = t;
      state[2] = u;
      t = state[15];
      u = state[11];
      v = state[7];
      state[15] = state[3];
      state[11] = t;
      state[7] = u;
      state[3] = v;

      for (var _j4 = 0; _j4 < 16; ++_j4) {
        state[_j4] = this._inv_s[state[_j4]];
        state[_j4] ^= key[_j4];
      }

      return state;
    }
  }, {
    key: "_encrypt",
    value: function _encrypt(input, key) {
      var s = this._s;
      var t, u, v;
      var state = new Uint8Array(16);
      state.set(input);

      for (var j = 0; j < 16; ++j) {
        state[j] ^= key[j];
      }

      for (var i = 1; i < this._cyclesOfRepetition; i++) {
        for (var _j5 = 0; _j5 < 16; ++_j5) {
          state[_j5] = s[state[_j5]];
        }

        v = state[1];
        state[1] = state[5];
        state[5] = state[9];
        state[9] = state[13];
        state[13] = v;
        v = state[2];
        u = state[6];
        state[2] = state[10];
        state[6] = state[14];
        state[10] = v;
        state[14] = u;
        v = state[3];
        u = state[7];
        t = state[11];
        state[3] = state[15];
        state[7] = v;
        state[11] = u;
        state[15] = t;

        for (var _j6 = 0; _j6 < 16; _j6 += 4) {
          var s0 = state[_j6 + 0];
          var s1 = state[_j6 + 1];
          var s2 = state[_j6 + 2];
          var s3 = state[_j6 + 3];
          t = s0 ^ s1 ^ s2 ^ s3;
          state[_j6 + 0] ^= t ^ this._mixCol[s0 ^ s1];
          state[_j6 + 1] ^= t ^ this._mixCol[s1 ^ s2];
          state[_j6 + 2] ^= t ^ this._mixCol[s2 ^ s3];
          state[_j6 + 3] ^= t ^ this._mixCol[s3 ^ s0];
        }

        for (var _j7 = 0, k = i * 16; _j7 < 16; ++_j7, ++k) {
          state[_j7] ^= key[k];
        }
      }

      for (var _j8 = 0; _j8 < 16; ++_j8) {
        state[_j8] = s[state[_j8]];
      }

      v = state[1];
      state[1] = state[5];
      state[5] = state[9];
      state[9] = state[13];
      state[13] = v;
      v = state[2];
      u = state[6];
      state[2] = state[10];
      state[6] = state[14];
      state[10] = v;
      state[14] = u;
      v = state[3];
      u = state[7];
      t = state[11];
      state[3] = state[15];
      state[7] = v;
      state[11] = u;
      state[15] = t;

      for (var _j9 = 0, _k2 = this._keySize; _j9 < 16; ++_j9, ++_k2) {
        state[_j9] ^= key[_k2];
      }

      return state;
    }
  }, {
    key: "_decryptBlock2",
    value: function _decryptBlock2(data, finalize) {
      var sourceLength = data.length;
      var buffer = this.buffer,
          bufferLength = this.bufferPosition;
      var result = [],
          iv = this.iv;

      for (var i = 0; i < sourceLength; ++i) {
        buffer[bufferLength] = data[i];
        ++bufferLength;

        if (bufferLength < 16) {
          continue;
        }

        var plain = this._decrypt(buffer, this._key);

        for (var j = 0; j < 16; ++j) {
          plain[j] ^= iv[j];
        }

        iv = buffer;
        result.push(plain);
        buffer = new Uint8Array(16);
        bufferLength = 0;
      }

      this.buffer = buffer;
      this.bufferLength = bufferLength;
      this.iv = iv;

      if (result.length === 0) {
        return new Uint8Array(0);
      }

      var outputLength = 16 * result.length;

      if (finalize) {
        var lastBlock = result[result.length - 1];
        var psLen = lastBlock[15];

        if (psLen <= 16) {
          for (var _i = 15, ii = 16 - psLen; _i >= ii; --_i) {
            if (lastBlock[_i] !== psLen) {
              psLen = 0;
              break;
            }
          }

          outputLength -= psLen;
          result[result.length - 1] = lastBlock.subarray(0, 16 - psLen);
        }
      }

      var output = new Uint8Array(outputLength);

      for (var _i2 = 0, _j10 = 0, _ii = result.length; _i2 < _ii; ++_i2, _j10 += 16) {
        output.set(result[_i2], _j10);
      }

      return output;
    }
  }, {
    key: "decryptBlock",
    value: function decryptBlock(data, finalize) {
      var iv = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var sourceLength = data.length;
      var buffer = this.buffer,
          bufferLength = this.bufferPosition;

      if (iv) {
        this.iv = iv;
      } else {
        for (var i = 0; bufferLength < 16 && i < sourceLength; ++i, ++bufferLength) {
          buffer[bufferLength] = data[i];
        }

        if (bufferLength < 16) {
          this.bufferLength = bufferLength;
          return new Uint8Array(0);
        }

        this.iv = buffer;
        data = data.subarray(16);
      }

      this.buffer = new Uint8Array(16);
      this.bufferLength = 0;
      this.decryptBlock = this._decryptBlock2;
      return this.decryptBlock(data, finalize);
    }
  }, {
    key: "encrypt",
    value: function encrypt(data, iv) {
      var sourceLength = data.length;
      var buffer = this.buffer,
          bufferLength = this.bufferPosition;
      var result = [];

      if (!iv) {
        iv = new Uint8Array(16);
      }

      for (var i = 0; i < sourceLength; ++i) {
        buffer[bufferLength] = data[i];
        ++bufferLength;

        if (bufferLength < 16) {
          continue;
        }

        for (var j = 0; j < 16; ++j) {
          buffer[j] ^= iv[j];
        }

        var cipher = this._encrypt(buffer, this._key);

        iv = cipher;
        result.push(cipher);
        buffer = new Uint8Array(16);
        bufferLength = 0;
      }

      this.buffer = buffer;
      this.bufferLength = bufferLength;
      this.iv = iv;

      if (result.length === 0) {
        return new Uint8Array(0);
      }

      var outputLength = 16 * result.length;
      var output = new Uint8Array(outputLength);

      for (var _i3 = 0, _j11 = 0, ii = result.length; _i3 < ii; ++_i3, _j11 += 16) {
        output.set(result[_i3], _j11);
      }

      return output;
    }
  }]);

  return AESBaseCipher;
}();

var AES128Cipher =
/*#__PURE__*/
function (_AESBaseCipher) {
  _inherits(AES128Cipher, _AESBaseCipher);

  function AES128Cipher(key) {
    var _this;

    _classCallCheck(this, AES128Cipher);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AES128Cipher).call(this));
    _this._cyclesOfRepetition = 10;
    _this._keySize = 160;
    _this._rcon = new Uint8Array([0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d]);
    _this._key = _this._expandKey(key);
    return _this;
  }

  _createClass(AES128Cipher, [{
    key: "_expandKey",
    value: function _expandKey(cipherKey) {
      var b = 176;
      var s = this._s;
      var rcon = this._rcon;
      var result = new Uint8Array(b);
      result.set(cipherKey);

      for (var j = 16, i = 1; j < b; ++i) {
        var t1 = result[j - 3];
        var t2 = result[j - 2];
        var t3 = result[j - 1];
        var t4 = result[j - 4];
        t1 = s[t1];
        t2 = s[t2];
        t3 = s[t3];
        t4 = s[t4];
        t1 = t1 ^ rcon[i];

        for (var n = 0; n < 4; ++n) {
          result[j] = t1 ^= result[j - 16];
          j++;
          result[j] = t2 ^= result[j - 16];
          j++;
          result[j] = t3 ^= result[j - 16];
          j++;
          result[j] = t4 ^= result[j - 16];
          j++;
        }
      }

      return result;
    }
  }]);

  return AES128Cipher;
}(AESBaseCipher);

exports.AES128Cipher = AES128Cipher;

var AES256Cipher =
/*#__PURE__*/
function (_AESBaseCipher2) {
  _inherits(AES256Cipher, _AESBaseCipher2);

  function AES256Cipher(key) {
    var _this2;

    _classCallCheck(this, AES256Cipher);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(AES256Cipher).call(this));
    _this2._cyclesOfRepetition = 14;
    _this2._keySize = 224;
    _this2._key = _this2._expandKey(key);
    return _this2;
  }

  _createClass(AES256Cipher, [{
    key: "_expandKey",
    value: function _expandKey(cipherKey) {
      var b = 240;
      var s = this._s;
      var result = new Uint8Array(b);
      result.set(cipherKey);
      var r = 1;
      var t1, t2, t3, t4;

      for (var j = 32, i = 1; j < b; ++i) {
        if (j % 32 === 16) {
          t1 = s[t1];
          t2 = s[t2];
          t3 = s[t3];
          t4 = s[t4];
        } else if (j % 32 === 0) {
          t1 = result[j - 3];
          t2 = result[j - 2];
          t3 = result[j - 1];
          t4 = result[j - 4];
          t1 = s[t1];
          t2 = s[t2];
          t3 = s[t3];
          t4 = s[t4];
          t1 = t1 ^ r;

          if ((r <<= 1) >= 256) {
            r = (r ^ 0x1b) & 0xFF;
          }
        }

        for (var n = 0; n < 4; ++n) {
          result[j] = t1 ^= result[j - 32];
          j++;
          result[j] = t2 ^= result[j - 32];
          j++;
          result[j] = t3 ^= result[j - 32];
          j++;
          result[j] = t4 ^= result[j - 32];
          j++;
        }
      }

      return result;
    }
  }]);

  return AES256Cipher;
}(AESBaseCipher);

exports.AES256Cipher = AES256Cipher;

var PDF17 = function PDF17Closure() {
  function compareByteArrays(array1, array2) {
    if (array1.length !== array2.length) {
      return false;
    }

    for (var i = 0; i < array1.length; i++) {
      if (array1[i] !== array2[i]) {
        return false;
      }
    }

    return true;
  }

  function PDF17() {}

  PDF17.prototype = {
    checkOwnerPassword: function PDF17_checkOwnerPassword(password, ownerValidationSalt, userBytes, ownerPassword) {
      var hashData = new Uint8Array(password.length + 56);
      hashData.set(password, 0);
      hashData.set(ownerValidationSalt, password.length);
      hashData.set(userBytes, password.length + ownerValidationSalt.length);
      var result = calculateSHA256(hashData, 0, hashData.length);
      return compareByteArrays(result, ownerPassword);
    },
    checkUserPassword: function PDF17_checkUserPassword(password, userValidationSalt, userPassword) {
      var hashData = new Uint8Array(password.length + 8);
      hashData.set(password, 0);
      hashData.set(userValidationSalt, password.length);
      var result = calculateSHA256(hashData, 0, hashData.length);
      return compareByteArrays(result, userPassword);
    },
    getOwnerKey: function PDF17_getOwnerKey(password, ownerKeySalt, userBytes, ownerEncryption) {
      var hashData = new Uint8Array(password.length + 56);
      hashData.set(password, 0);
      hashData.set(ownerKeySalt, password.length);
      hashData.set(userBytes, password.length + ownerKeySalt.length);
      var key = calculateSHA256(hashData, 0, hashData.length);
      var cipher = new AES256Cipher(key);
      return cipher.decryptBlock(ownerEncryption, false, new Uint8Array(16));
    },
    getUserKey: function PDF17_getUserKey(password, userKeySalt, userEncryption) {
      var hashData = new Uint8Array(password.length + 8);
      hashData.set(password, 0);
      hashData.set(userKeySalt, password.length);
      var key = calculateSHA256(hashData, 0, hashData.length);
      var cipher = new AES256Cipher(key);
      return cipher.decryptBlock(userEncryption, false, new Uint8Array(16));
    }
  };
  return PDF17;
}();

exports.PDF17 = PDF17;

var PDF20 = function PDF20Closure() {
  function concatArrays(array1, array2) {
    var t = new Uint8Array(array1.length + array2.length);
    t.set(array1, 0);
    t.set(array2, array1.length);
    return t;
  }

  function calculatePDF20Hash(password, input, userBytes) {
    var k = calculateSHA256(input, 0, input.length).subarray(0, 32);
    var e = [0];
    var i = 0;

    while (i < 64 || e[e.length - 1] > i - 32) {
      var arrayLength = password.length + k.length + userBytes.length;
      var k1 = new Uint8Array(arrayLength * 64);
      var array = concatArrays(password, k);
      array = concatArrays(array, userBytes);

      for (var j = 0, pos = 0; j < 64; j++, pos += arrayLength) {
        k1.set(array, pos);
      }

      var cipher = new AES128Cipher(k.subarray(0, 16));
      e = cipher.encrypt(k1, k.subarray(16, 32));
      var remainder = 0;

      for (var z = 0; z < 16; z++) {
        remainder *= 256 % 3;
        remainder %= 3;
        remainder += (e[z] >>> 0) % 3;
        remainder %= 3;
      }

      if (remainder === 0) {
        k = calculateSHA256(e, 0, e.length);
      } else if (remainder === 1) {
        k = calculateSHA384(e, 0, e.length);
      } else if (remainder === 2) {
        k = calculateSHA512(e, 0, e.length);
      }

      i++;
    }

    return k.subarray(0, 32);
  }

  function PDF20() {}

  function compareByteArrays(array1, array2) {
    if (array1.length !== array2.length) {
      return false;
    }

    for (var i = 0; i < array1.length; i++) {
      if (array1[i] !== array2[i]) {
        return false;
      }
    }

    return true;
  }

  PDF20.prototype = {
    hash: function PDF20_hash(password, concatBytes, userBytes) {
      return calculatePDF20Hash(password, concatBytes, userBytes);
    },
    checkOwnerPassword: function PDF20_checkOwnerPassword(password, ownerValidationSalt, userBytes, ownerPassword) {
      var hashData = new Uint8Array(password.length + 56);
      hashData.set(password, 0);
      hashData.set(ownerValidationSalt, password.length);
      hashData.set(userBytes, password.length + ownerValidationSalt.length);
      var result = calculatePDF20Hash(password, hashData, userBytes);
      return compareByteArrays(result, ownerPassword);
    },
    checkUserPassword: function PDF20_checkUserPassword(password, userValidationSalt, userPassword) {
      var hashData = new Uint8Array(password.length + 8);
      hashData.set(password, 0);
      hashData.set(userValidationSalt, password.length);
      var result = calculatePDF20Hash(password, hashData, []);
      return compareByteArrays(result, userPassword);
    },
    getOwnerKey: function PDF20_getOwnerKey(password, ownerKeySalt, userBytes, ownerEncryption) {
      var hashData = new Uint8Array(password.length + 56);
      hashData.set(password, 0);
      hashData.set(ownerKeySalt, password.length);
      hashData.set(userBytes, password.length + ownerKeySalt.length);
      var key = calculatePDF20Hash(password, hashData, userBytes);
      var cipher = new AES256Cipher(key);
      return cipher.decryptBlock(ownerEncryption, false, new Uint8Array(16));
    },
    getUserKey: function PDF20_getUserKey(password, userKeySalt, userEncryption) {
      var hashData = new Uint8Array(password.length + 8);
      hashData.set(password, 0);
      hashData.set(userKeySalt, password.length);
      var key = calculatePDF20Hash(password, hashData, []);
      var cipher = new AES256Cipher(key);
      return cipher.decryptBlock(userEncryption, false, new Uint8Array(16));
    }
  };
  return PDF20;
}();

exports.PDF20 = PDF20;

var CipherTransform = function CipherTransformClosure() {
  function CipherTransform(stringCipherConstructor, streamCipherConstructor) {
    this.StringCipherConstructor = stringCipherConstructor;
    this.StreamCipherConstructor = streamCipherConstructor;
  }

  CipherTransform.prototype = {
    createStream: function CipherTransform_createStream(stream, length) {
      var cipher = new this.StreamCipherConstructor();
      return new _stream.DecryptStream(stream, length, function cipherTransformDecryptStream(data, finalize) {
        return cipher.decryptBlock(data, finalize);
      });
    },
    decryptString: function CipherTransform_decryptString(s) {
      var cipher = new this.StringCipherConstructor();
      var data = (0, _util.stringToBytes)(s);
      data = cipher.decryptBlock(data, true);
      return (0, _util.bytesToString)(data);
    }
  };
  return CipherTransform;
}();

var CipherTransformFactory = function CipherTransformFactoryClosure() {
  var defaultPasswordBytes = new Uint8Array([0x28, 0xBF, 0x4E, 0x5E, 0x4E, 0x75, 0x8A, 0x41, 0x64, 0x00, 0x4E, 0x56, 0xFF, 0xFA, 0x01, 0x08, 0x2E, 0x2E, 0x00, 0xB6, 0xD0, 0x68, 0x3E, 0x80, 0x2F, 0x0C, 0xA9, 0xFE, 0x64, 0x53, 0x69, 0x7A]);

  function createEncryptionKey20(revision, password, ownerPassword, ownerValidationSalt, ownerKeySalt, uBytes, userPassword, userValidationSalt, userKeySalt, ownerEncryption, userEncryption, perms) {
    if (password) {
      var passwordLength = Math.min(127, password.length);
      password = password.subarray(0, passwordLength);
    } else {
      password = [];
    }

    var pdfAlgorithm;

    if (revision === 6) {
      pdfAlgorithm = new PDF20();
    } else {
      pdfAlgorithm = new PDF17();
    }

    if (pdfAlgorithm.checkUserPassword(password, userValidationSalt, userPassword)) {
      return pdfAlgorithm.getUserKey(password, userKeySalt, userEncryption);
    } else if (password.length && pdfAlgorithm.checkOwnerPassword(password, ownerValidationSalt, uBytes, ownerPassword)) {
      return pdfAlgorithm.getOwnerKey(password, ownerKeySalt, uBytes, ownerEncryption);
    }

    return null;
  }

  function prepareKeyData(fileId, password, ownerPassword, userPassword, flags, revision, keyLength, encryptMetadata) {
    var hashDataSize = 40 + ownerPassword.length + fileId.length;
    var hashData = new Uint8Array(hashDataSize),
        i = 0,
        j,
        n;

    if (password) {
      n = Math.min(32, password.length);

      for (; i < n; ++i) {
        hashData[i] = password[i];
      }
    }

    j = 0;

    while (i < 32) {
      hashData[i++] = defaultPasswordBytes[j++];
    }

    for (j = 0, n = ownerPassword.length; j < n; ++j) {
      hashData[i++] = ownerPassword[j];
    }

    hashData[i++] = flags & 0xFF;
    hashData[i++] = flags >> 8 & 0xFF;
    hashData[i++] = flags >> 16 & 0xFF;
    hashData[i++] = flags >>> 24 & 0xFF;

    for (j = 0, n = fileId.length; j < n; ++j) {
      hashData[i++] = fileId[j];
    }

    if (revision >= 4 && !encryptMetadata) {
      hashData[i++] = 0xFF;
      hashData[i++] = 0xFF;
      hashData[i++] = 0xFF;
      hashData[i++] = 0xFF;
    }

    var hash = calculateMD5(hashData, 0, i);
    var keyLengthInBytes = keyLength >> 3;

    if (revision >= 3) {
      for (j = 0; j < 50; ++j) {
        hash = calculateMD5(hash, 0, keyLengthInBytes);
      }
    }

    var encryptionKey = hash.subarray(0, keyLengthInBytes);
    var cipher, checkData;

    if (revision >= 3) {
      for (i = 0; i < 32; ++i) {
        hashData[i] = defaultPasswordBytes[i];
      }

      for (j = 0, n = fileId.length; j < n; ++j) {
        hashData[i++] = fileId[j];
      }

      cipher = new ARCFourCipher(encryptionKey);
      checkData = cipher.encryptBlock(calculateMD5(hashData, 0, i));
      n = encryptionKey.length;
      var derivedKey = new Uint8Array(n),
          k;

      for (j = 1; j <= 19; ++j) {
        for (k = 0; k < n; ++k) {
          derivedKey[k] = encryptionKey[k] ^ j;
        }

        cipher = new ARCFourCipher(derivedKey);
        checkData = cipher.encryptBlock(checkData);
      }

      for (j = 0, n = checkData.length; j < n; ++j) {
        if (userPassword[j] !== checkData[j]) {
          return null;
        }
      }
    } else {
      cipher = new ARCFourCipher(encryptionKey);
      checkData = cipher.encryptBlock(defaultPasswordBytes);

      for (j = 0, n = checkData.length; j < n; ++j) {
        if (userPassword[j] !== checkData[j]) {
          return null;
        }
      }
    }

    return encryptionKey;
  }

  function decodeUserPassword(password, ownerPassword, revision, keyLength) {
    var hashData = new Uint8Array(32),
        i = 0,
        j,
        n;
    n = Math.min(32, password.length);

    for (; i < n; ++i) {
      hashData[i] = password[i];
    }

    j = 0;

    while (i < 32) {
      hashData[i++] = defaultPasswordBytes[j++];
    }

    var hash = calculateMD5(hashData, 0, i);
    var keyLengthInBytes = keyLength >> 3;

    if (revision >= 3) {
      for (j = 0; j < 50; ++j) {
        hash = calculateMD5(hash, 0, hash.length);
      }
    }

    var cipher, userPassword;

    if (revision >= 3) {
      userPassword = ownerPassword;
      var derivedKey = new Uint8Array(keyLengthInBytes),
          k;

      for (j = 19; j >= 0; j--) {
        for (k = 0; k < keyLengthInBytes; ++k) {
          derivedKey[k] = hash[k] ^ j;
        }

        cipher = new ARCFourCipher(derivedKey);
        userPassword = cipher.encryptBlock(userPassword);
      }
    } else {
      cipher = new ARCFourCipher(hash.subarray(0, keyLengthInBytes));
      userPassword = cipher.encryptBlock(ownerPassword);
    }

    return userPassword;
  }

  var identityName = _primitives.Name.get('Identity');

  function CipherTransformFactory(dict, fileId, password) {
    var filter = dict.get('Filter');

    if (!(0, _primitives.isName)(filter, 'Standard')) {
      throw new _util.FormatError('unknown encryption method');
    }

    this.dict = dict;
    var algorithm = dict.get('V');

    if (!Number.isInteger(algorithm) || algorithm !== 1 && algorithm !== 2 && algorithm !== 4 && algorithm !== 5) {
      throw new _util.FormatError('unsupported encryption algorithm');
    }

    this.algorithm = algorithm;
    var keyLength = dict.get('Length');

    if (!keyLength) {
      if (algorithm <= 3) {
        keyLength = 40;
      } else {
        var cfDict = dict.get('CF');
        var streamCryptoName = dict.get('StmF');

        if ((0, _primitives.isDict)(cfDict) && (0, _primitives.isName)(streamCryptoName)) {
          cfDict.suppressEncryption = true;
          var handlerDict = cfDict.get(streamCryptoName.name);
          keyLength = handlerDict && handlerDict.get('Length') || 128;

          if (keyLength < 40) {
            keyLength <<= 3;
          }
        }
      }
    }

    if (!Number.isInteger(keyLength) || keyLength < 40 || keyLength % 8 !== 0) {
      throw new _util.FormatError('invalid key length');
    }

    var ownerPassword = (0, _util.stringToBytes)(dict.get('O')).subarray(0, 32);
    var userPassword = (0, _util.stringToBytes)(dict.get('U')).subarray(0, 32);
    var flags = dict.get('P');
    var revision = dict.get('R');
    var encryptMetadata = (algorithm === 4 || algorithm === 5) && dict.get('EncryptMetadata') !== false;
    this.encryptMetadata = encryptMetadata;
    var fileIdBytes = (0, _util.stringToBytes)(fileId);
    var passwordBytes;

    if (password) {
      if (revision === 6) {
        try {
          password = (0, _util.utf8StringToString)(password);
        } catch (ex) {
          (0, _util.warn)('CipherTransformFactory: ' + 'Unable to convert UTF8 encoded password.');
        }
      }

      passwordBytes = (0, _util.stringToBytes)(password);
    }

    var encryptionKey;

    if (algorithm !== 5) {
      encryptionKey = prepareKeyData(fileIdBytes, passwordBytes, ownerPassword, userPassword, flags, revision, keyLength, encryptMetadata);
    } else {
      var ownerValidationSalt = (0, _util.stringToBytes)(dict.get('O')).subarray(32, 40);
      var ownerKeySalt = (0, _util.stringToBytes)(dict.get('O')).subarray(40, 48);
      var uBytes = (0, _util.stringToBytes)(dict.get('U')).subarray(0, 48);
      var userValidationSalt = (0, _util.stringToBytes)(dict.get('U')).subarray(32, 40);
      var userKeySalt = (0, _util.stringToBytes)(dict.get('U')).subarray(40, 48);
      var ownerEncryption = (0, _util.stringToBytes)(dict.get('OE'));
      var userEncryption = (0, _util.stringToBytes)(dict.get('UE'));
      var perms = (0, _util.stringToBytes)(dict.get('Perms'));
      encryptionKey = createEncryptionKey20(revision, passwordBytes, ownerPassword, ownerValidationSalt, ownerKeySalt, uBytes, userPassword, userValidationSalt, userKeySalt, ownerEncryption, userEncryption, perms);
    }

    if (!encryptionKey && !password) {
      throw new _util.PasswordException('No password given', _util.PasswordResponses.NEED_PASSWORD);
    } else if (!encryptionKey && password) {
      var decodedPassword = decodeUserPassword(passwordBytes, ownerPassword, revision, keyLength);
      encryptionKey = prepareKeyData(fileIdBytes, decodedPassword, ownerPassword, userPassword, flags, revision, keyLength, encryptMetadata);
    }

    if (!encryptionKey) {
      throw new _util.PasswordException('Incorrect Password', _util.PasswordResponses.INCORRECT_PASSWORD);
    }

    this.encryptionKey = encryptionKey;

    if (algorithm >= 4) {
      var cf = dict.get('CF');

      if ((0, _primitives.isDict)(cf)) {
        cf.suppressEncryption = true;
      }

      this.cf = cf;
      this.stmf = dict.get('StmF') || identityName;
      this.strf = dict.get('StrF') || identityName;
      this.eff = dict.get('EFF') || this.stmf;
    }
  }

  function buildObjectKey(num, gen, encryptionKey, isAes) {
    var key = new Uint8Array(encryptionKey.length + 9),
        i,
        n;

    for (i = 0, n = encryptionKey.length; i < n; ++i) {
      key[i] = encryptionKey[i];
    }

    key[i++] = num & 0xFF;
    key[i++] = num >> 8 & 0xFF;
    key[i++] = num >> 16 & 0xFF;
    key[i++] = gen & 0xFF;
    key[i++] = gen >> 8 & 0xFF;

    if (isAes) {
      key[i++] = 0x73;
      key[i++] = 0x41;
      key[i++] = 0x6C;
      key[i++] = 0x54;
    }

    var hash = calculateMD5(key, 0, i);
    return hash.subarray(0, Math.min(encryptionKey.length + 5, 16));
  }

  function buildCipherConstructor(cf, name, num, gen, key) {
    if (!(0, _primitives.isName)(name)) {
      throw new _util.FormatError('Invalid crypt filter name.');
    }

    var cryptFilter = cf.get(name.name);
    var cfm;

    if (cryptFilter !== null && cryptFilter !== undefined) {
      cfm = cryptFilter.get('CFM');
    }

    if (!cfm || cfm.name === 'None') {
      return function cipherTransformFactoryBuildCipherConstructorNone() {
        return new NullCipher();
      };
    }

    if (cfm.name === 'V2') {
      return function cipherTransformFactoryBuildCipherConstructorV2() {
        return new ARCFourCipher(buildObjectKey(num, gen, key, false));
      };
    }

    if (cfm.name === 'AESV2') {
      return function cipherTransformFactoryBuildCipherConstructorAESV2() {
        return new AES128Cipher(buildObjectKey(num, gen, key, true));
      };
    }

    if (cfm.name === 'AESV3') {
      return function cipherTransformFactoryBuildCipherConstructorAESV3() {
        return new AES256Cipher(key);
      };
    }

    throw new _util.FormatError('Unknown crypto method');
  }

  CipherTransformFactory.prototype = {
    createCipherTransform: function CipherTransformFactory_createCipherTransform(num, gen) {
      if (this.algorithm === 4 || this.algorithm === 5) {
        return new CipherTransform(buildCipherConstructor(this.cf, this.stmf, num, gen, this.encryptionKey), buildCipherConstructor(this.cf, this.strf, num, gen, this.encryptionKey));
      }

      var key = buildObjectKey(num, gen, this.encryptionKey, false);

      var cipherConstructor = function buildCipherCipherConstructor() {
        return new ARCFourCipher(key);
      };

      return new CipherTransform(cipherConstructor, cipherConstructor);
    }
  };
  return CipherTransformFactory;
}();

exports.CipherTransformFactory = CipherTransformFactory;

/***/ }),
/* 168 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ColorSpace = void 0;

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function resizeRgbImage(src, dest, w1, h1, w2, h2, alpha01) {
  var COMPONENTS = 3;
  alpha01 = alpha01 !== 1 ? 0 : alpha01;
  var xRatio = w1 / w2;
  var yRatio = h1 / h2;
  var newIndex = 0,
      oldIndex;
  var xScaled = new Uint16Array(w2);
  var w1Scanline = w1 * COMPONENTS;

  for (var i = 0; i < w2; i++) {
    xScaled[i] = Math.floor(i * xRatio) * COMPONENTS;
  }

  for (var _i = 0; _i < h2; _i++) {
    var py = Math.floor(_i * yRatio) * w1Scanline;

    for (var j = 0; j < w2; j++) {
      oldIndex = py + xScaled[j];
      dest[newIndex++] = src[oldIndex++];
      dest[newIndex++] = src[oldIndex++];
      dest[newIndex++] = src[oldIndex++];
      newIndex += alpha01;
    }
  }
}

var ColorSpace =
/*#__PURE__*/
function () {
  function ColorSpace(name, numComps) {
    _classCallCheck(this, ColorSpace);

    if (this.constructor === ColorSpace) {
      (0, _util.unreachable)('Cannot initialize ColorSpace.');
    }

    this.name = name;
    this.numComps = numComps;
  }

  _createClass(ColorSpace, [{
    key: "getRgb",
    value: function getRgb(src, srcOffset) {
      var rgb = new Uint8ClampedArray(3);
      this.getRgbItem(src, srcOffset, rgb, 0);
      return rgb;
    }
  }, {
    key: "getRgbItem",
    value: function getRgbItem(src, srcOffset, dest, destOffset) {
      (0, _util.unreachable)('Should not call ColorSpace.getRgbItem');
    }
  }, {
    key: "getRgbBuffer",
    value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
      (0, _util.unreachable)('Should not call ColorSpace.getRgbBuffer');
    }
  }, {
    key: "getOutputLength",
    value: function getOutputLength(inputLength, alpha01) {
      (0, _util.unreachable)('Should not call ColorSpace.getOutputLength');
    }
  }, {
    key: "isPassthrough",
    value: function isPassthrough(bits) {
      return false;
    }
  }, {
    key: "isDefaultDecode",
    value: function isDefaultDecode(decodeMap, bpc) {
      return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
    }
  }, {
    key: "fillRgb",
    value: function fillRgb(dest, originalWidth, originalHeight, width, height, actualHeight, bpc, comps, alpha01) {
      var count = originalWidth * originalHeight;
      var rgbBuf = null;
      var numComponentColors = 1 << bpc;
      var needsResizing = originalHeight !== height || originalWidth !== width;

      if (this.isPassthrough(bpc)) {
        rgbBuf = comps;
      } else if (this.numComps === 1 && count > numComponentColors && this.name !== 'DeviceGray' && this.name !== 'DeviceRGB') {
        var allColors = bpc <= 8 ? new Uint8Array(numComponentColors) : new Uint16Array(numComponentColors);

        for (var i = 0; i < numComponentColors; i++) {
          allColors[i] = i;
        }

        var colorMap = new Uint8ClampedArray(numComponentColors * 3);
        this.getRgbBuffer(allColors, 0, numComponentColors, colorMap, 0, bpc, 0);

        if (!needsResizing) {
          var destPos = 0;

          for (var _i2 = 0; _i2 < count; ++_i2) {
            var key = comps[_i2] * 3;
            dest[destPos++] = colorMap[key];
            dest[destPos++] = colorMap[key + 1];
            dest[destPos++] = colorMap[key + 2];
            destPos += alpha01;
          }
        } else {
          rgbBuf = new Uint8Array(count * 3);
          var rgbPos = 0;

          for (var _i3 = 0; _i3 < count; ++_i3) {
            var _key = comps[_i3] * 3;

            rgbBuf[rgbPos++] = colorMap[_key];
            rgbBuf[rgbPos++] = colorMap[_key + 1];
            rgbBuf[rgbPos++] = colorMap[_key + 2];
          }
        }
      } else {
        if (!needsResizing) {
          this.getRgbBuffer(comps, 0, width * actualHeight, dest, 0, bpc, alpha01);
        } else {
          rgbBuf = new Uint8ClampedArray(count * 3);
          this.getRgbBuffer(comps, 0, count, rgbBuf, 0, bpc, 0);
        }
      }

      if (rgbBuf) {
        if (needsResizing) {
          resizeRgbImage(rgbBuf, dest, originalWidth, originalHeight, width, height, alpha01);
        } else {
          var _destPos = 0,
              _rgbPos = 0;

          for (var _i4 = 0, ii = width * actualHeight; _i4 < ii; _i4++) {
            dest[_destPos++] = rgbBuf[_rgbPos++];
            dest[_destPos++] = rgbBuf[_rgbPos++];
            dest[_destPos++] = rgbBuf[_rgbPos++];
            _destPos += alpha01;
          }
        }
      }
    }
  }, {
    key: "usesZeroToOneRange",
    get: function get() {
      return (0, _util.shadow)(this, 'usesZeroToOneRange', true);
    }
  }], [{
    key: "parse",
    value: function parse(cs, xref, res, pdfFunctionFactory) {
      var IR = this.parseToIR(cs, xref, res, pdfFunctionFactory);
      return this.fromIR(IR);
    }
  }, {
    key: "fromIR",
    value: function fromIR(IR) {
      var name = Array.isArray(IR) ? IR[0] : IR;
      var whitePoint, blackPoint, gamma;

      switch (name) {
        case 'DeviceGrayCS':
          return this.singletons.gray;

        case 'DeviceRgbCS':
          return this.singletons.rgb;

        case 'DeviceCmykCS':
          return this.singletons.cmyk;

        case 'CalGrayCS':
          whitePoint = IR[1];
          blackPoint = IR[2];
          gamma = IR[3];
          return new CalGrayCS(whitePoint, blackPoint, gamma);

        case 'CalRGBCS':
          whitePoint = IR[1];
          blackPoint = IR[2];
          gamma = IR[3];
          var matrix = IR[4];
          return new CalRGBCS(whitePoint, blackPoint, gamma, matrix);

        case 'PatternCS':
          var basePatternCS = IR[1];

          if (basePatternCS) {
            basePatternCS = this.fromIR(basePatternCS);
          }

          return new PatternCS(basePatternCS);

        case 'IndexedCS':
          var baseIndexedCS = IR[1];
          var hiVal = IR[2];
          var lookup = IR[3];
          return new IndexedCS(this.fromIR(baseIndexedCS), hiVal, lookup);

        case 'AlternateCS':
          var numComps = IR[1];
          var alt = IR[2];
          var tintFn = IR[3];
          return new AlternateCS(numComps, this.fromIR(alt), tintFn);

        case 'LabCS':
          whitePoint = IR[1];
          blackPoint = IR[2];
          var range = IR[3];
          return new LabCS(whitePoint, blackPoint, range);

        default:
          throw new _util.FormatError("Unknown colorspace name: ".concat(name));
      }
    }
  }, {
    key: "parseToIR",
    value: function parseToIR(cs, xref) {
      var res = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var pdfFunctionFactory = arguments.length > 3 ? arguments[3] : undefined;
      cs = xref.fetchIfRef(cs);

      if ((0, _primitives.isName)(cs)) {
        switch (cs.name) {
          case 'DeviceGray':
          case 'G':
            return 'DeviceGrayCS';

          case 'DeviceRGB':
          case 'RGB':
            return 'DeviceRgbCS';

          case 'DeviceCMYK':
          case 'CMYK':
            return 'DeviceCmykCS';

          case 'Pattern':
            return ['PatternCS', null];

          default:
            if ((0, _primitives.isDict)(res)) {
              var colorSpaces = res.get('ColorSpace');

              if ((0, _primitives.isDict)(colorSpaces)) {
                var resCS = colorSpaces.get(cs.name);

                if (resCS) {
                  if ((0, _primitives.isName)(resCS)) {
                    return this.parseToIR(resCS, xref, res, pdfFunctionFactory);
                  }

                  cs = resCS;
                  break;
                }
              }
            }

            throw new _util.FormatError("unrecognized colorspace ".concat(cs.name));
        }
      }

      if (Array.isArray(cs)) {
        var mode = xref.fetchIfRef(cs[0]).name;
        var numComps, params, alt, whitePoint, blackPoint, gamma;

        switch (mode) {
          case 'DeviceGray':
          case 'G':
            return 'DeviceGrayCS';

          case 'DeviceRGB':
          case 'RGB':
            return 'DeviceRgbCS';

          case 'DeviceCMYK':
          case 'CMYK':
            return 'DeviceCmykCS';

          case 'CalGray':
            params = xref.fetchIfRef(cs[1]);
            whitePoint = params.getArray('WhitePoint');
            blackPoint = params.getArray('BlackPoint');
            gamma = params.get('Gamma');
            return ['CalGrayCS', whitePoint, blackPoint, gamma];

          case 'CalRGB':
            params = xref.fetchIfRef(cs[1]);
            whitePoint = params.getArray('WhitePoint');
            blackPoint = params.getArray('BlackPoint');
            gamma = params.getArray('Gamma');
            var matrix = params.getArray('Matrix');
            return ['CalRGBCS', whitePoint, blackPoint, gamma, matrix];

          case 'ICCBased':
            var stream = xref.fetchIfRef(cs[1]);
            var dict = stream.dict;
            numComps = dict.get('N');
            alt = dict.get('Alternate');

            if (alt) {
              var altIR = this.parseToIR(alt, xref, res, pdfFunctionFactory);
              var altCS = this.fromIR(altIR, pdfFunctionFactory);

              if (altCS.numComps === numComps) {
                return altIR;
              }

              (0, _util.warn)('ICCBased color space: Ignoring incorrect /Alternate entry.');
            }

            if (numComps === 1) {
              return 'DeviceGrayCS';
            } else if (numComps === 3) {
              return 'DeviceRgbCS';
            } else if (numComps === 4) {
              return 'DeviceCmykCS';
            }

            break;

          case 'Pattern':
            var basePatternCS = cs[1] || null;

            if (basePatternCS) {
              basePatternCS = this.parseToIR(basePatternCS, xref, res, pdfFunctionFactory);
            }

            return ['PatternCS', basePatternCS];

          case 'Indexed':
          case 'I':
            var baseIndexedCS = this.parseToIR(cs[1], xref, res, pdfFunctionFactory);
            var hiVal = xref.fetchIfRef(cs[2]) + 1;
            var lookup = xref.fetchIfRef(cs[3]);

            if ((0, _primitives.isStream)(lookup)) {
              lookup = lookup.getBytes();
            }

            return ['IndexedCS', baseIndexedCS, hiVal, lookup];

          case 'Separation':
          case 'DeviceN':
            var name = xref.fetchIfRef(cs[1]);
            numComps = Array.isArray(name) ? name.length : 1;
            alt = this.parseToIR(cs[2], xref, res, pdfFunctionFactory);
            var tintFn = pdfFunctionFactory.create(xref.fetchIfRef(cs[3]));
            return ['AlternateCS', numComps, alt, tintFn];

          case 'Lab':
            params = xref.fetchIfRef(cs[1]);
            whitePoint = params.getArray('WhitePoint');
            blackPoint = params.getArray('BlackPoint');
            var range = params.getArray('Range');
            return ['LabCS', whitePoint, blackPoint, range];

          default:
            throw new _util.FormatError("unimplemented color space object \"".concat(mode, "\""));
        }
      }

      throw new _util.FormatError("unrecognized color space object: \"".concat(cs, "\""));
    }
  }, {
    key: "isDefaultDecode",
    value: function isDefaultDecode(decode, numComps) {
      if (!Array.isArray(decode)) {
        return true;
      }

      if (numComps * 2 !== decode.length) {
        (0, _util.warn)('The decode map is not the correct length');
        return true;
      }

      for (var i = 0, ii = decode.length; i < ii; i += 2) {
        if (decode[i] !== 0 || decode[i + 1] !== 1) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "singletons",
    get: function get() {
      return (0, _util.shadow)(this, 'singletons', {
        get gray() {
          return (0, _util.shadow)(this, 'gray', new DeviceGrayCS());
        },

        get rgb() {
          return (0, _util.shadow)(this, 'rgb', new DeviceRgbCS());
        },

        get cmyk() {
          return (0, _util.shadow)(this, 'cmyk', new DeviceCmykCS());
        }

      });
    }
  }]);

  return ColorSpace;
}();

exports.ColorSpace = ColorSpace;

var AlternateCS =
/*#__PURE__*/
function (_ColorSpace) {
  _inherits(AlternateCS, _ColorSpace);

  function AlternateCS(numComps, base, tintFn) {
    var _this;

    _classCallCheck(this, AlternateCS);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AlternateCS).call(this, 'Alternate', numComps));
    _this.base = base;
    _this.tintFn = tintFn;
    _this.tmpBuf = new Float32Array(base.numComps);
    return _this;
  }

  _createClass(AlternateCS, [{
    key: "getRgbItem",
    value: function getRgbItem(src, srcOffset, dest, destOffset) {
      var tmpBuf = this.tmpBuf;
      this.tintFn(src, srcOffset, tmpBuf, 0);
      this.base.getRgbItem(tmpBuf, 0, dest, destOffset);
    }
  }, {
    key: "getRgbBuffer",
    value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
      var tintFn = this.tintFn;
      var base = this.base;
      var scale = 1 / ((1 << bits) - 1);
      var baseNumComps = base.numComps;
      var usesZeroToOneRange = base.usesZeroToOneRange;
      var isPassthrough = (base.isPassthrough(8) || !usesZeroToOneRange) && alpha01 === 0;
      var pos = isPassthrough ? destOffset : 0;
      var baseBuf = isPassthrough ? dest : new Uint8ClampedArray(baseNumComps * count);
      var numComps = this.numComps;
      var scaled = new Float32Array(numComps);
      var tinted = new Float32Array(baseNumComps);
      var i, j;

      for (i = 0; i < count; i++) {
        for (j = 0; j < numComps; j++) {
          scaled[j] = src[srcOffset++] * scale;
        }

        tintFn(scaled, 0, tinted, 0);

        if (usesZeroToOneRange) {
          for (j = 0; j < baseNumComps; j++) {
            baseBuf[pos++] = tinted[j] * 255;
          }
        } else {
          base.getRgbItem(tinted, 0, baseBuf, pos);
          pos += baseNumComps;
        }
      }

      if (!isPassthrough) {
        base.getRgbBuffer(baseBuf, 0, count, dest, destOffset, 8, alpha01);
      }
    }
  }, {
    key: "getOutputLength",
    value: function getOutputLength(inputLength, alpha01) {
      return this.base.getOutputLength(inputLength * this.base.numComps / this.numComps, alpha01);
    }
  }]);

  return AlternateCS;
}(ColorSpace);

var PatternCS =
/*#__PURE__*/
function (_ColorSpace2) {
  _inherits(PatternCS, _ColorSpace2);

  function PatternCS(baseCS) {
    var _this2;

    _classCallCheck(this, PatternCS);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(PatternCS).call(this, 'Pattern', null));
    _this2.base = baseCS;
    return _this2;
  }

  _createClass(PatternCS, [{
    key: "isDefaultDecode",
    value: function isDefaultDecode(decodeMap, bpc) {
      (0, _util.unreachable)('Should not call PatternCS.isDefaultDecode');
    }
  }]);

  return PatternCS;
}(ColorSpace);

var IndexedCS =
/*#__PURE__*/
function (_ColorSpace3) {
  _inherits(IndexedCS, _ColorSpace3);

  function IndexedCS(base, highVal, lookup) {
    var _this3;

    _classCallCheck(this, IndexedCS);

    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(IndexedCS).call(this, 'Indexed', 1));
    _this3.base = base;
    _this3.highVal = highVal;
    var baseNumComps = base.numComps;
    var length = baseNumComps * highVal;

    if ((0, _primitives.isStream)(lookup)) {
      _this3.lookup = new Uint8Array(length);
      var bytes = lookup.getBytes(length);

      _this3.lookup.set(bytes);
    } else if ((0, _util.isString)(lookup)) {
      _this3.lookup = new Uint8Array(length);

      for (var i = 0; i < length; ++i) {
        _this3.lookup[i] = lookup.charCodeAt(i);
      }
    } else if (lookup instanceof Uint8Array) {
      _this3.lookup = lookup;
    } else {
      throw new _util.FormatError("Unrecognized lookup table: ".concat(lookup));
    }

    return _this3;
  }

  _createClass(IndexedCS, [{
    key: "getRgbItem",
    value: function getRgbItem(src, srcOffset, dest, destOffset) {
      var numComps = this.base.numComps;
      var start = src[srcOffset] * numComps;
      this.base.getRgbBuffer(this.lookup, start, 1, dest, destOffset, 8, 0);
    }
  }, {
    key: "getRgbBuffer",
    value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
      var base = this.base;
      var numComps = base.numComps;
      var outputDelta = base.getOutputLength(numComps, alpha01);
      var lookup = this.lookup;

      for (var i = 0; i < count; ++i) {
        var lookupPos = src[srcOffset++] * numComps;
        base.getRgbBuffer(lookup, lookupPos, 1, dest, destOffset, 8, alpha01);
        destOffset += outputDelta;
      }
    }
  }, {
    key: "getOutputLength",
    value: function getOutputLength(inputLength, alpha01) {
      return this.base.getOutputLength(inputLength * this.base.numComps, alpha01);
    }
  }, {
    key: "isDefaultDecode",
    value: function isDefaultDecode(decodeMap, bpc) {
      if (!Array.isArray(decodeMap)) {
        return true;
      }

      if (decodeMap.length !== 2) {
        (0, _util.warn)('Decode map length is not correct');
        return true;
      }

      if (!Number.isInteger(bpc) || bpc < 1) {
        (0, _util.warn)('Bits per component is not correct');
        return true;
      }

      return decodeMap[0] === 0 && decodeMap[1] === (1 << bpc) - 1;
    }
  }]);

  return IndexedCS;
}(ColorSpace);

var DeviceGrayCS =
/*#__PURE__*/
function (_ColorSpace4) {
  _inherits(DeviceGrayCS, _ColorSpace4);

  function DeviceGrayCS() {
    _classCallCheck(this, DeviceGrayCS);

    return _possibleConstructorReturn(this, _getPrototypeOf(DeviceGrayCS).call(this, 'DeviceGray', 1));
  }

  _createClass(DeviceGrayCS, [{
    key: "getRgbItem",
    value: function getRgbItem(src, srcOffset, dest, destOffset) {
      var c = src[srcOffset] * 255;
      dest[destOffset] = dest[destOffset + 1] = dest[destOffset + 2] = c;
    }
  }, {
    key: "getRgbBuffer",
    value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
      var scale = 255 / ((1 << bits) - 1);
      var j = srcOffset,
          q = destOffset;

      for (var i = 0; i < count; ++i) {
        var c = scale * src[j++];
        dest[q++] = c;
        dest[q++] = c;
        dest[q++] = c;
        q += alpha01;
      }
    }
  }, {
    key: "getOutputLength",
    value: function getOutputLength(inputLength, alpha01) {
      return inputLength * (3 + alpha01);
    }
  }]);

  return DeviceGrayCS;
}(ColorSpace);

var DeviceRgbCS =
/*#__PURE__*/
function (_ColorSpace5) {
  _inherits(DeviceRgbCS, _ColorSpace5);

  function DeviceRgbCS() {
    _classCallCheck(this, DeviceRgbCS);

    return _possibleConstructorReturn(this, _getPrototypeOf(DeviceRgbCS).call(this, 'DeviceRGB', 3));
  }

  _createClass(DeviceRgbCS, [{
    key: "getRgbItem",
    value: function getRgbItem(src, srcOffset, dest, destOffset) {
      dest[destOffset] = src[srcOffset] * 255;
      dest[destOffset + 1] = src[srcOffset + 1] * 255;
      dest[destOffset + 2] = src[srcOffset + 2] * 255;
    }
  }, {
    key: "getRgbBuffer",
    value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
      if (bits === 8 && alpha01 === 0) {
        dest.set(src.subarray(srcOffset, srcOffset + count * 3), destOffset);
        return;
      }

      var scale = 255 / ((1 << bits) - 1);
      var j = srcOffset,
          q = destOffset;

      for (var i = 0; i < count; ++i) {
        dest[q++] = scale * src[j++];
        dest[q++] = scale * src[j++];
        dest[q++] = scale * src[j++];
        q += alpha01;
      }
    }
  }, {
    key: "getOutputLength",
    value: function getOutputLength(inputLength, alpha01) {
      return inputLength * (3 + alpha01) / 3 | 0;
    }
  }, {
    key: "isPassthrough",
    value: function isPassthrough(bits) {
      return bits === 8;
    }
  }]);

  return DeviceRgbCS;
}(ColorSpace);

var DeviceCmykCS = function DeviceCmykCSClosure() {
  function convertToRgb(src, srcOffset, srcScale, dest, destOffset) {
    var c = src[srcOffset] * srcScale;
    var m = src[srcOffset + 1] * srcScale;
    var y = src[srcOffset + 2] * srcScale;
    var k = src[srcOffset + 3] * srcScale;
    dest[destOffset] = 255 + c * (-4.387332384609988 * c + 54.48615194189176 * m + 18.82290502165302 * y + 212.25662451639585 * k + -285.2331026137004) + m * (1.7149763477362134 * m - 5.6096736904047315 * y + -17.873870861415444 * k - 5.497006427196366) + y * (-2.5217340131683033 * y - 21.248923337353073 * k + 17.5119270841813) + k * (-21.86122147463605 * k - 189.48180835922747);
    dest[destOffset + 1] = 255 + c * (8.841041422036149 * c + 60.118027045597366 * m + 6.871425592049007 * y + 31.159100130055922 * k + -79.2970844816548) + m * (-15.310361306967817 * m + 17.575251261109482 * y + 131.35250912493976 * k - 190.9453302588951) + y * (4.444339102852739 * y + 9.8632861493405 * k - 24.86741582555878) + k * (-20.737325471181034 * k - 187.80453709719578);
    dest[destOffset + 2] = 255 + c * (0.8842522430003296 * c + 8.078677503112928 * m + 30.89978309703729 * y - 0.23883238689178934 * k + -14.183576799673286) + m * (10.49593273432072 * m + 63.02378494754052 * y + 50.606957656360734 * k - 112.23884253719248) + y * (0.03296041114873217 * y + 115.60384449646641 * k + -193.58209356861505) + k * (-22.33816807309886 * k - 180.12613974708367);
  }

  var DeviceCmykCS =
  /*#__PURE__*/
  function (_ColorSpace6) {
    _inherits(DeviceCmykCS, _ColorSpace6);

    function DeviceCmykCS() {
      _classCallCheck(this, DeviceCmykCS);

      return _possibleConstructorReturn(this, _getPrototypeOf(DeviceCmykCS).call(this, 'DeviceCMYK', 4));
    }

    _createClass(DeviceCmykCS, [{
      key: "getRgbItem",
      value: function getRgbItem(src, srcOffset, dest, destOffset) {
        convertToRgb(src, srcOffset, 1, dest, destOffset);
      }
    }, {
      key: "getRgbBuffer",
      value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
        var scale = 1 / ((1 << bits) - 1);

        for (var i = 0; i < count; i++) {
          convertToRgb(src, srcOffset, scale, dest, destOffset);
          srcOffset += 4;
          destOffset += 3 + alpha01;
        }
      }
    }, {
      key: "getOutputLength",
      value: function getOutputLength(inputLength, alpha01) {
        return inputLength / 4 * (3 + alpha01) | 0;
      }
    }]);

    return DeviceCmykCS;
  }(ColorSpace);

  return DeviceCmykCS;
}();

var CalGrayCS = function CalGrayCSClosure() {
  function convertToRgb(cs, src, srcOffset, dest, destOffset, scale) {
    var A = src[srcOffset] * scale;
    var AG = Math.pow(A, cs.G);
    var L = cs.YW * AG;
    var val = Math.max(295.8 * Math.pow(L, 0.333333333333333333) - 40.8, 0);
    dest[destOffset] = val;
    dest[destOffset + 1] = val;
    dest[destOffset + 2] = val;
  }

  var CalGrayCS =
  /*#__PURE__*/
  function (_ColorSpace7) {
    _inherits(CalGrayCS, _ColorSpace7);

    function CalGrayCS(whitePoint, blackPoint, gamma) {
      var _this4;

      _classCallCheck(this, CalGrayCS);

      _this4 = _possibleConstructorReturn(this, _getPrototypeOf(CalGrayCS).call(this, 'CalGray', 1));

      if (!whitePoint) {
        throw new _util.FormatError('WhitePoint missing - required for color space CalGray');
      }

      blackPoint = blackPoint || [0, 0, 0];
      gamma = gamma || 1;
      _this4.XW = whitePoint[0];
      _this4.YW = whitePoint[1];
      _this4.ZW = whitePoint[2];
      _this4.XB = blackPoint[0];
      _this4.YB = blackPoint[1];
      _this4.ZB = blackPoint[2];
      _this4.G = gamma;

      if (_this4.XW < 0 || _this4.ZW < 0 || _this4.YW !== 1) {
        throw new _util.FormatError("Invalid WhitePoint components for ".concat(_this4.name) + ', no fallback available');
      }

      if (_this4.XB < 0 || _this4.YB < 0 || _this4.ZB < 0) {
        (0, _util.info)("Invalid BlackPoint for ".concat(_this4.name, ", falling back to default."));
        _this4.XB = _this4.YB = _this4.ZB = 0;
      }

      if (_this4.XB !== 0 || _this4.YB !== 0 || _this4.ZB !== 0) {
        (0, _util.warn)("".concat(_this4.name, ", BlackPoint: XB: ").concat(_this4.XB, ", YB: ").concat(_this4.YB, ", ") + "ZB: ".concat(_this4.ZB, ", only default values are supported."));
      }

      if (_this4.G < 1) {
        (0, _util.info)("Invalid Gamma: ".concat(_this4.G, " for ").concat(_this4.name, ", ") + 'falling back to default.');
        _this4.G = 1;
      }

      return _this4;
    }

    _createClass(CalGrayCS, [{
      key: "getRgbItem",
      value: function getRgbItem(src, srcOffset, dest, destOffset) {
        convertToRgb(this, src, srcOffset, dest, destOffset, 1);
      }
    }, {
      key: "getRgbBuffer",
      value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
        var scale = 1 / ((1 << bits) - 1);

        for (var i = 0; i < count; ++i) {
          convertToRgb(this, src, srcOffset, dest, destOffset, scale);
          srcOffset += 1;
          destOffset += 3 + alpha01;
        }
      }
    }, {
      key: "getOutputLength",
      value: function getOutputLength(inputLength, alpha01) {
        return inputLength * (3 + alpha01);
      }
    }]);

    return CalGrayCS;
  }(ColorSpace);

  return CalGrayCS;
}();

var CalRGBCS = function CalRGBCSClosure() {
  var BRADFORD_SCALE_MATRIX = new Float32Array([0.8951, 0.2664, -0.1614, -0.7502, 1.7135, 0.0367, 0.0389, -0.0685, 1.0296]);
  var BRADFORD_SCALE_INVERSE_MATRIX = new Float32Array([0.9869929, -0.1470543, 0.1599627, 0.4323053, 0.5183603, 0.0492912, -0.0085287, 0.0400428, 0.9684867]);
  var SRGB_D65_XYZ_TO_RGB_MATRIX = new Float32Array([3.2404542, -1.5371385, -0.4985314, -0.9692660, 1.8760108, 0.0415560, 0.0556434, -0.2040259, 1.0572252]);
  var FLAT_WHITEPOINT_MATRIX = new Float32Array([1, 1, 1]);
  var tempNormalizeMatrix = new Float32Array(3);
  var tempConvertMatrix1 = new Float32Array(3);
  var tempConvertMatrix2 = new Float32Array(3);
  var DECODE_L_CONSTANT = Math.pow((8 + 16) / 116, 3) / 8.0;

  function matrixProduct(a, b, result) {
    result[0] = a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
    result[1] = a[3] * b[0] + a[4] * b[1] + a[5] * b[2];
    result[2] = a[6] * b[0] + a[7] * b[1] + a[8] * b[2];
  }

  function convertToFlat(sourceWhitePoint, LMS, result) {
    result[0] = LMS[0] * 1 / sourceWhitePoint[0];
    result[1] = LMS[1] * 1 / sourceWhitePoint[1];
    result[2] = LMS[2] * 1 / sourceWhitePoint[2];
  }

  function convertToD65(sourceWhitePoint, LMS, result) {
    var D65X = 0.95047;
    var D65Y = 1;
    var D65Z = 1.08883;
    result[0] = LMS[0] * D65X / sourceWhitePoint[0];
    result[1] = LMS[1] * D65Y / sourceWhitePoint[1];
    result[2] = LMS[2] * D65Z / sourceWhitePoint[2];
  }

  function sRGBTransferFunction(color) {
    if (color <= 0.0031308) {
      return adjustToRange(0, 1, 12.92 * color);
    }

    return adjustToRange(0, 1, (1 + 0.055) * Math.pow(color, 1 / 2.4) - 0.055);
  }

  function adjustToRange(min, max, value) {
    return Math.max(min, Math.min(max, value));
  }

  function decodeL(L) {
    if (L < 0) {
      return -decodeL(-L);
    }

    if (L > 8.0) {
      return Math.pow((L + 16) / 116, 3);
    }

    return L * DECODE_L_CONSTANT;
  }

  function compensateBlackPoint(sourceBlackPoint, XYZ_Flat, result) {
    if (sourceBlackPoint[0] === 0 && sourceBlackPoint[1] === 0 && sourceBlackPoint[2] === 0) {
      result[0] = XYZ_Flat[0];
      result[1] = XYZ_Flat[1];
      result[2] = XYZ_Flat[2];
      return;
    }

    var zeroDecodeL = decodeL(0);
    var X_DST = zeroDecodeL;
    var X_SRC = decodeL(sourceBlackPoint[0]);
    var Y_DST = zeroDecodeL;
    var Y_SRC = decodeL(sourceBlackPoint[1]);
    var Z_DST = zeroDecodeL;
    var Z_SRC = decodeL(sourceBlackPoint[2]);
    var X_Scale = (1 - X_DST) / (1 - X_SRC);
    var X_Offset = 1 - X_Scale;
    var Y_Scale = (1 - Y_DST) / (1 - Y_SRC);
    var Y_Offset = 1 - Y_Scale;
    var Z_Scale = (1 - Z_DST) / (1 - Z_SRC);
    var Z_Offset = 1 - Z_Scale;
    result[0] = XYZ_Flat[0] * X_Scale + X_Offset;
    result[1] = XYZ_Flat[1] * Y_Scale + Y_Offset;
    result[2] = XYZ_Flat[2] * Z_Scale + Z_Offset;
  }

  function normalizeWhitePointToFlat(sourceWhitePoint, XYZ_In, result) {
    if (sourceWhitePoint[0] === 1 && sourceWhitePoint[2] === 1) {
      result[0] = XYZ_In[0];
      result[1] = XYZ_In[1];
      result[2] = XYZ_In[2];
      return;
    }

    var LMS = result;
    matrixProduct(BRADFORD_SCALE_MATRIX, XYZ_In, LMS);
    var LMS_Flat = tempNormalizeMatrix;
    convertToFlat(sourceWhitePoint, LMS, LMS_Flat);
    matrixProduct(BRADFORD_SCALE_INVERSE_MATRIX, LMS_Flat, result);
  }

  function normalizeWhitePointToD65(sourceWhitePoint, XYZ_In, result) {
    var LMS = result;
    matrixProduct(BRADFORD_SCALE_MATRIX, XYZ_In, LMS);
    var LMS_D65 = tempNormalizeMatrix;
    convertToD65(sourceWhitePoint, LMS, LMS_D65);
    matrixProduct(BRADFORD_SCALE_INVERSE_MATRIX, LMS_D65, result);
  }

  function convertToRgb(cs, src, srcOffset, dest, destOffset, scale) {
    var A = adjustToRange(0, 1, src[srcOffset] * scale);
    var B = adjustToRange(0, 1, src[srcOffset + 1] * scale);
    var C = adjustToRange(0, 1, src[srcOffset + 2] * scale);
    var AGR = Math.pow(A, cs.GR);
    var BGG = Math.pow(B, cs.GG);
    var CGB = Math.pow(C, cs.GB);
    var X = cs.MXA * AGR + cs.MXB * BGG + cs.MXC * CGB;
    var Y = cs.MYA * AGR + cs.MYB * BGG + cs.MYC * CGB;
    var Z = cs.MZA * AGR + cs.MZB * BGG + cs.MZC * CGB;
    var XYZ = tempConvertMatrix1;
    XYZ[0] = X;
    XYZ[1] = Y;
    XYZ[2] = Z;
    var XYZ_Flat = tempConvertMatrix2;
    normalizeWhitePointToFlat(cs.whitePoint, XYZ, XYZ_Flat);
    var XYZ_Black = tempConvertMatrix1;
    compensateBlackPoint(cs.blackPoint, XYZ_Flat, XYZ_Black);
    var XYZ_D65 = tempConvertMatrix2;
    normalizeWhitePointToD65(FLAT_WHITEPOINT_MATRIX, XYZ_Black, XYZ_D65);
    var SRGB = tempConvertMatrix1;
    matrixProduct(SRGB_D65_XYZ_TO_RGB_MATRIX, XYZ_D65, SRGB);
    dest[destOffset] = sRGBTransferFunction(SRGB[0]) * 255;
    dest[destOffset + 1] = sRGBTransferFunction(SRGB[1]) * 255;
    dest[destOffset + 2] = sRGBTransferFunction(SRGB[2]) * 255;
  }

  var CalRGBCS =
  /*#__PURE__*/
  function (_ColorSpace8) {
    _inherits(CalRGBCS, _ColorSpace8);

    function CalRGBCS(whitePoint, blackPoint, gamma, matrix) {
      var _this5;

      _classCallCheck(this, CalRGBCS);

      _this5 = _possibleConstructorReturn(this, _getPrototypeOf(CalRGBCS).call(this, 'CalRGB', 3));

      if (!whitePoint) {
        throw new _util.FormatError('WhitePoint missing - required for color space CalRGB');
      }

      blackPoint = blackPoint || new Float32Array(3);
      gamma = gamma || new Float32Array([1, 1, 1]);
      matrix = matrix || new Float32Array([1, 0, 0, 0, 1, 0, 0, 0, 1]);
      var XW = whitePoint[0];
      var YW = whitePoint[1];
      var ZW = whitePoint[2];
      _this5.whitePoint = whitePoint;
      var XB = blackPoint[0];
      var YB = blackPoint[1];
      var ZB = blackPoint[2];
      _this5.blackPoint = blackPoint;
      _this5.GR = gamma[0];
      _this5.GG = gamma[1];
      _this5.GB = gamma[2];
      _this5.MXA = matrix[0];
      _this5.MYA = matrix[1];
      _this5.MZA = matrix[2];
      _this5.MXB = matrix[3];
      _this5.MYB = matrix[4];
      _this5.MZB = matrix[5];
      _this5.MXC = matrix[6];
      _this5.MYC = matrix[7];
      _this5.MZC = matrix[8];

      if (XW < 0 || ZW < 0 || YW !== 1) {
        throw new _util.FormatError("Invalid WhitePoint components for ".concat(_this5.name) + ', no fallback available');
      }

      if (XB < 0 || YB < 0 || ZB < 0) {
        (0, _util.info)("Invalid BlackPoint for ".concat(_this5.name, " [").concat(XB, ", ").concat(YB, ", ").concat(ZB, "], ") + 'falling back to default.');
        _this5.blackPoint = new Float32Array(3);
      }

      if (_this5.GR < 0 || _this5.GG < 0 || _this5.GB < 0) {
        (0, _util.info)("Invalid Gamma [".concat(_this5.GR, ", ").concat(_this5.GG, ", ").concat(_this5.GB, "] for ") + "".concat(_this5.name, ", falling back to default."));
        _this5.GR = _this5.GG = _this5.GB = 1;
      }

      return _this5;
    }

    _createClass(CalRGBCS, [{
      key: "getRgbItem",
      value: function getRgbItem(src, srcOffset, dest, destOffset) {
        convertToRgb(this, src, srcOffset, dest, destOffset, 1);
      }
    }, {
      key: "getRgbBuffer",
      value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
        var scale = 1 / ((1 << bits) - 1);

        for (var i = 0; i < count; ++i) {
          convertToRgb(this, src, srcOffset, dest, destOffset, scale);
          srcOffset += 3;
          destOffset += 3 + alpha01;
        }
      }
    }, {
      key: "getOutputLength",
      value: function getOutputLength(inputLength, alpha01) {
        return inputLength * (3 + alpha01) / 3 | 0;
      }
    }]);

    return CalRGBCS;
  }(ColorSpace);

  return CalRGBCS;
}();

var LabCS = function LabCSClosure() {
  function fn_g(x) {
    var result;

    if (x >= 6 / 29) {
      result = x * x * x;
    } else {
      result = 108 / 841 * (x - 4 / 29);
    }

    return result;
  }

  function decode(value, high1, low2, high2) {
    return low2 + value * (high2 - low2) / high1;
  }

  function convertToRgb(cs, src, srcOffset, maxVal, dest, destOffset) {
    var Ls = src[srcOffset];
    var as = src[srcOffset + 1];
    var bs = src[srcOffset + 2];

    if (maxVal !== false) {
      Ls = decode(Ls, maxVal, 0, 100);
      as = decode(as, maxVal, cs.amin, cs.amax);
      bs = decode(bs, maxVal, cs.bmin, cs.bmax);
    }

    as = as > cs.amax ? cs.amax : as < cs.amin ? cs.amin : as;
    bs = bs > cs.bmax ? cs.bmax : bs < cs.bmin ? cs.bmin : bs;
    var M = (Ls + 16) / 116;
    var L = M + as / 500;
    var N = M - bs / 200;
    var X = cs.XW * fn_g(L);
    var Y = cs.YW * fn_g(M);
    var Z = cs.ZW * fn_g(N);
    var r, g, b;

    if (cs.ZW < 1) {
      r = X * 3.1339 + Y * -1.6170 + Z * -0.4906;
      g = X * -0.9785 + Y * 1.9160 + Z * 0.0333;
      b = X * 0.0720 + Y * -0.2290 + Z * 1.4057;
    } else {
      r = X * 3.2406 + Y * -1.5372 + Z * -0.4986;
      g = X * -0.9689 + Y * 1.8758 + Z * 0.0415;
      b = X * 0.0557 + Y * -0.2040 + Z * 1.0570;
    }

    dest[destOffset] = Math.sqrt(r) * 255;
    dest[destOffset + 1] = Math.sqrt(g) * 255;
    dest[destOffset + 2] = Math.sqrt(b) * 255;
  }

  var LabCS =
  /*#__PURE__*/
  function (_ColorSpace9) {
    _inherits(LabCS, _ColorSpace9);

    function LabCS(whitePoint, blackPoint, range) {
      var _this6;

      _classCallCheck(this, LabCS);

      _this6 = _possibleConstructorReturn(this, _getPrototypeOf(LabCS).call(this, 'Lab', 3));

      if (!whitePoint) {
        throw new _util.FormatError('WhitePoint missing - required for color space Lab');
      }

      blackPoint = blackPoint || [0, 0, 0];
      range = range || [-100, 100, -100, 100];
      _this6.XW = whitePoint[0];
      _this6.YW = whitePoint[1];
      _this6.ZW = whitePoint[2];
      _this6.amin = range[0];
      _this6.amax = range[1];
      _this6.bmin = range[2];
      _this6.bmax = range[3];
      _this6.XB = blackPoint[0];
      _this6.YB = blackPoint[1];
      _this6.ZB = blackPoint[2];

      if (_this6.XW < 0 || _this6.ZW < 0 || _this6.YW !== 1) {
        throw new _util.FormatError('Invalid WhitePoint components, no fallback available');
      }

      if (_this6.XB < 0 || _this6.YB < 0 || _this6.ZB < 0) {
        (0, _util.info)('Invalid BlackPoint, falling back to default');
        _this6.XB = _this6.YB = _this6.ZB = 0;
      }

      if (_this6.amin > _this6.amax || _this6.bmin > _this6.bmax) {
        (0, _util.info)('Invalid Range, falling back to defaults');
        _this6.amin = -100;
        _this6.amax = 100;
        _this6.bmin = -100;
        _this6.bmax = 100;
      }

      return _this6;
    }

    _createClass(LabCS, [{
      key: "getRgbItem",
      value: function getRgbItem(src, srcOffset, dest, destOffset) {
        convertToRgb(this, src, srcOffset, false, dest, destOffset);
      }
    }, {
      key: "getRgbBuffer",
      value: function getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
        var maxVal = (1 << bits) - 1;

        for (var i = 0; i < count; i++) {
          convertToRgb(this, src, srcOffset, maxVal, dest, destOffset);
          srcOffset += 3;
          destOffset += 3 + alpha01;
        }
      }
    }, {
      key: "getOutputLength",
      value: function getOutputLength(inputLength, alpha01) {
        return inputLength * (3 + alpha01) / 3 | 0;
      }
    }, {
      key: "isDefaultDecode",
      value: function isDefaultDecode(decodeMap, bpc) {
        return true;
      }
    }, {
      key: "usesZeroToOneRange",
      get: function get() {
        return (0, _util.shadow)(this, 'usesZeroToOneRange', false);
      }
    }]);

    return LabCS;
  }(ColorSpace);

  return LabCS;
}();

/***/ }),
/* 169 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnnotationFactory = exports.AnnotationBorderStyle = exports.Annotation = void 0;

var _util = __w_pdfjs_require__(6);

var _obj = __w_pdfjs_require__(154);

var _primitives = __w_pdfjs_require__(155);

var _colorspace = __w_pdfjs_require__(168);

var _operator_list = __w_pdfjs_require__(170);

var _stream = __w_pdfjs_require__(157);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var AnnotationFactory =
/*#__PURE__*/
function () {
  function AnnotationFactory() {
    _classCallCheck(this, AnnotationFactory);
  }

  _createClass(AnnotationFactory, null, [{
    key: "create",
    value: function create(xref, ref, pdfManager, idFactory) {
      return pdfManager.ensure(this, '_create', [xref, ref, pdfManager, idFactory]);
    }
  }, {
    key: "_create",
    value: function _create(xref, ref, pdfManager, idFactory) {
      var dict = xref.fetchIfRef(ref);

      if (!(0, _primitives.isDict)(dict)) {
        return;
      }

      var id = (0, _primitives.isRef)(ref) ? ref.toString() : 'annot_' + idFactory.createObjId();
      var subtype = dict.get('Subtype');
      subtype = (0, _primitives.isName)(subtype) ? subtype.name : null;
      var parameters = {
        xref: xref,
        dict: dict,
        ref: (0, _primitives.isRef)(ref) ? ref : null,
        subtype: subtype,
        id: id,
        pdfManager: pdfManager
      };

      switch (subtype) {
        case 'Link':
          return new LinkAnnotation(parameters);

        case 'Text':
          return new TextAnnotation(parameters);

        case 'Widget':
          var fieldType = (0, _util.getInheritableProperty)({
            dict: dict,
            key: 'FT'
          });
          fieldType = (0, _primitives.isName)(fieldType) ? fieldType.name : null;

          switch (fieldType) {
            case 'Tx':
              return new TextWidgetAnnotation(parameters);

            case 'Btn':
              return new ButtonWidgetAnnotation(parameters);

            case 'Ch':
              return new ChoiceWidgetAnnotation(parameters);
          }

          (0, _util.warn)('Unimplemented widget field type "' + fieldType + '", ' + 'falling back to base field type.');
          return new WidgetAnnotation(parameters);

        case 'Popup':
          return new PopupAnnotation(parameters);

        case 'Line':
          return new LineAnnotation(parameters);

        case 'Square':
          return new SquareAnnotation(parameters);

        case 'Circle':
          return new CircleAnnotation(parameters);

        case 'PolyLine':
          return new PolylineAnnotation(parameters);

        case 'Polygon':
          return new PolygonAnnotation(parameters);

        case 'Ink':
          return new InkAnnotation(parameters);

        case 'Highlight':
          return new HighlightAnnotation(parameters);

        case 'Underline':
          return new UnderlineAnnotation(parameters);

        case 'Squiggly':
          return new SquigglyAnnotation(parameters);

        case 'StrikeOut':
          return new StrikeOutAnnotation(parameters);

        case 'Stamp':
          return new StampAnnotation(parameters);

        case 'FileAttachment':
          return new FileAttachmentAnnotation(parameters);

        default:
          if (!subtype) {
            (0, _util.warn)('Annotation is missing the required /Subtype.');
          } else {
            (0, _util.warn)('Unimplemented annotation type "' + subtype + '", ' + 'falling back to base annotation.');
          }

          return new Annotation(parameters);
      }
    }
  }]);

  return AnnotationFactory;
}();

exports.AnnotationFactory = AnnotationFactory;

function getTransformMatrix(rect, bbox, matrix) {
  var bounds = _util.Util.getAxialAlignedBoundingBox(bbox, matrix);

  var minX = bounds[0];
  var minY = bounds[1];
  var maxX = bounds[2];
  var maxY = bounds[3];

  if (minX === maxX || minY === maxY) {
    return [1, 0, 0, 1, rect[0], rect[1]];
  }

  var xRatio = (rect[2] - rect[0]) / (maxX - minX);
  var yRatio = (rect[3] - rect[1]) / (maxY - minY);
  return [xRatio, 0, 0, yRatio, rect[0] - minX * xRatio, rect[1] - minY * yRatio];
}

var Annotation =
/*#__PURE__*/
function () {
  function Annotation(params) {
    _classCallCheck(this, Annotation);

    var dict = params.dict;
    this.setFlags(dict.get('F'));
    this.setRectangle(dict.getArray('Rect'));
    this.setColor(dict.getArray('C'));
    this.setBorderStyle(dict);
    this.setAppearance(dict);
    this.data = {
      annotationFlags: this.flags,
      borderStyle: this.borderStyle,
      color: this.color,
      hasAppearance: !!this.appearance,
      id: params.id,
      rect: this.rectangle,
      subtype: params.subtype
    };
  }

  _createClass(Annotation, [{
    key: "_hasFlag",
    value: function _hasFlag(flags, flag) {
      return !!(flags & flag);
    }
  }, {
    key: "_isViewable",
    value: function _isViewable(flags) {
      return !this._hasFlag(flags, _util.AnnotationFlag.INVISIBLE) && !this._hasFlag(flags, _util.AnnotationFlag.HIDDEN) && !this._hasFlag(flags, _util.AnnotationFlag.NOVIEW);
    }
  }, {
    key: "_isPrintable",
    value: function _isPrintable(flags) {
      return this._hasFlag(flags, _util.AnnotationFlag.PRINT) && !this._hasFlag(flags, _util.AnnotationFlag.INVISIBLE) && !this._hasFlag(flags, _util.AnnotationFlag.HIDDEN);
    }
  }, {
    key: "setFlags",
    value: function setFlags(flags) {
      this.flags = Number.isInteger(flags) && flags > 0 ? flags : 0;
    }
  }, {
    key: "hasFlag",
    value: function hasFlag(flag) {
      return this._hasFlag(this.flags, flag);
    }
  }, {
    key: "setRectangle",
    value: function setRectangle(rectangle) {
      if (Array.isArray(rectangle) && rectangle.length === 4) {
        this.rectangle = _util.Util.normalizeRect(rectangle);
      } else {
        this.rectangle = [0, 0, 0, 0];
      }
    }
  }, {
    key: "setColor",
    value: function setColor(color) {
      var rgbColor = new Uint8ClampedArray(3);

      if (!Array.isArray(color)) {
        this.color = rgbColor;
        return;
      }

      switch (color.length) {
        case 0:
          this.color = null;
          break;

        case 1:
          _colorspace.ColorSpace.singletons.gray.getRgbItem(color, 0, rgbColor, 0);

          this.color = rgbColor;
          break;

        case 3:
          _colorspace.ColorSpace.singletons.rgb.getRgbItem(color, 0, rgbColor, 0);

          this.color = rgbColor;
          break;

        case 4:
          _colorspace.ColorSpace.singletons.cmyk.getRgbItem(color, 0, rgbColor, 0);

          this.color = rgbColor;
          break;

        default:
          this.color = rgbColor;
          break;
      }
    }
  }, {
    key: "setBorderStyle",
    value: function setBorderStyle(borderStyle) {
      this.borderStyle = new AnnotationBorderStyle();

      if (!(0, _primitives.isDict)(borderStyle)) {
        return;
      }

      if (borderStyle.has('BS')) {
        var dict = borderStyle.get('BS');
        var dictType = dict.get('Type');

        if (!dictType || (0, _primitives.isName)(dictType, 'Border')) {
          this.borderStyle.setWidth(dict.get('W'));
          this.borderStyle.setStyle(dict.get('S'));
          this.borderStyle.setDashArray(dict.getArray('D'));
        }
      } else if (borderStyle.has('Border')) {
        var array = borderStyle.getArray('Border');

        if (Array.isArray(array) && array.length >= 3) {
          this.borderStyle.setHorizontalCornerRadius(array[0]);
          this.borderStyle.setVerticalCornerRadius(array[1]);
          this.borderStyle.setWidth(array[2]);

          if (array.length === 4) {
            this.borderStyle.setDashArray(array[3]);
          }
        }
      } else {
        this.borderStyle.setWidth(0);
      }
    }
  }, {
    key: "setAppearance",
    value: function setAppearance(dict) {
      this.appearance = null;
      var appearanceStates = dict.get('AP');

      if (!(0, _primitives.isDict)(appearanceStates)) {
        return;
      }

      var normalAppearanceState = appearanceStates.get('N');

      if ((0, _primitives.isStream)(normalAppearanceState)) {
        this.appearance = normalAppearanceState;
        return;
      }

      if (!(0, _primitives.isDict)(normalAppearanceState)) {
        return;
      }

      var as = dict.get('AS');

      if (!(0, _primitives.isName)(as) || !normalAppearanceState.has(as.name)) {
        return;
      }

      this.appearance = normalAppearanceState.get(as.name);
    }
  }, {
    key: "_preparePopup",
    value: function _preparePopup(dict) {
      if (!dict.has('C')) {
        this.data.color = null;
      }

      this.data.hasPopup = dict.has('Popup');
      this.data.title = (0, _util.stringToPDFString)(dict.get('T') || '');
      this.data.contents = (0, _util.stringToPDFString)(dict.get('Contents') || '');
    }
  }, {
    key: "loadResources",
    value: function loadResources(keys) {
      return this.appearance.dict.getAsync('Resources').then(function (resources) {
        if (!resources) {
          return;
        }

        var objectLoader = new _obj.ObjectLoader(resources, keys, resources.xref);
        return objectLoader.load().then(function () {
          return resources;
        });
      });
    }
  }, {
    key: "getOperatorList",
    value: function getOperatorList(evaluator, task, renderForms) {
      var _this = this;

      if (!this.appearance) {
        return Promise.resolve(new _operator_list.OperatorList());
      }

      var data = this.data;
      var appearanceDict = this.appearance.dict;
      var resourcesPromise = this.loadResources(['ExtGState', 'ColorSpace', 'Pattern', 'Shading', 'XObject', 'Font']);
      var bbox = appearanceDict.getArray('BBox') || [0, 0, 1, 1];
      var matrix = appearanceDict.getArray('Matrix') || [1, 0, 0, 1, 0, 0];
      var transform = getTransformMatrix(data.rect, bbox, matrix);
      return resourcesPromise.then(function (resources) {
        var opList = new _operator_list.OperatorList();
        opList.addOp(_util.OPS.beginAnnotation, [data.rect, transform, matrix]);
        return evaluator.getOperatorList({
          stream: _this.appearance,
          task: task,
          resources: resources,
          operatorList: opList
        }).then(function () {
          opList.addOp(_util.OPS.endAnnotation, []);

          _this.appearance.reset();

          return opList;
        });
      });
    }
  }, {
    key: "viewable",
    get: function get() {
      if (this.flags === 0) {
        return true;
      }

      return this._isViewable(this.flags);
    }
  }, {
    key: "printable",
    get: function get() {
      if (this.flags === 0) {
        return false;
      }

      return this._isPrintable(this.flags);
    }
  }]);

  return Annotation;
}();

exports.Annotation = Annotation;

var AnnotationBorderStyle =
/*#__PURE__*/
function () {
  function AnnotationBorderStyle() {
    _classCallCheck(this, AnnotationBorderStyle);

    this.width = 1;
    this.style = _util.AnnotationBorderStyleType.SOLID;
    this.dashArray = [3];
    this.horizontalCornerRadius = 0;
    this.verticalCornerRadius = 0;
  }

  _createClass(AnnotationBorderStyle, [{
    key: "setWidth",
    value: function setWidth(width) {
      if ((0, _primitives.isName)(width)) {
        this.width = 0;
        return;
      }

      if (Number.isInteger(width)) {
        this.width = width;
      }
    }
  }, {
    key: "setStyle",
    value: function setStyle(style) {
      if (!(0, _primitives.isName)(style)) {
        return;
      }

      switch (style.name) {
        case 'S':
          this.style = _util.AnnotationBorderStyleType.SOLID;
          break;

        case 'D':
          this.style = _util.AnnotationBorderStyleType.DASHED;
          break;

        case 'B':
          this.style = _util.AnnotationBorderStyleType.BEVELED;
          break;

        case 'I':
          this.style = _util.AnnotationBorderStyleType.INSET;
          break;

        case 'U':
          this.style = _util.AnnotationBorderStyleType.UNDERLINE;
          break;

        default:
          break;
      }
    }
  }, {
    key: "setDashArray",
    value: function setDashArray(dashArray) {
      if (Array.isArray(dashArray) && dashArray.length > 0) {
        var isValid = true;
        var allZeros = true;

        for (var i = 0, len = dashArray.length; i < len; i++) {
          var element = dashArray[i];
          var validNumber = +element >= 0;

          if (!validNumber) {
            isValid = false;
            break;
          } else if (element > 0) {
            allZeros = false;
          }
        }

        if (isValid && !allZeros) {
          this.dashArray = dashArray;
        } else {
          this.width = 0;
        }
      } else if (dashArray) {
        this.width = 0;
      }
    }
  }, {
    key: "setHorizontalCornerRadius",
    value: function setHorizontalCornerRadius(radius) {
      if (Number.isInteger(radius)) {
        this.horizontalCornerRadius = radius;
      }
    }
  }, {
    key: "setVerticalCornerRadius",
    value: function setVerticalCornerRadius(radius) {
      if (Number.isInteger(radius)) {
        this.verticalCornerRadius = radius;
      }
    }
  }]);

  return AnnotationBorderStyle;
}();

exports.AnnotationBorderStyle = AnnotationBorderStyle;

var WidgetAnnotation =
/*#__PURE__*/
function (_Annotation) {
  _inherits(WidgetAnnotation, _Annotation);

  function WidgetAnnotation(params) {
    var _this2;

    _classCallCheck(this, WidgetAnnotation);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(WidgetAnnotation).call(this, params));
    var dict = params.dict;
    var data = _this2.data;
    data.annotationType = _util.AnnotationType.WIDGET;
    data.fieldName = _this2._constructFieldName(dict);
    data.fieldValue = (0, _util.getInheritableProperty)({
      dict: dict,
      key: 'V',
      getArray: true
    });
    data.alternativeText = (0, _util.stringToPDFString)(dict.get('TU') || '');
    data.defaultAppearance = (0, _util.getInheritableProperty)({
      dict: dict,
      key: 'DA'
    }) || '';
    var fieldType = (0, _util.getInheritableProperty)({
      dict: dict,
      key: 'FT'
    });
    data.fieldType = (0, _primitives.isName)(fieldType) ? fieldType.name : null;
    _this2.fieldResources = (0, _util.getInheritableProperty)({
      dict: dict,
      key: 'DR'
    }) || _primitives.Dict.empty;
    data.fieldFlags = (0, _util.getInheritableProperty)({
      dict: dict,
      key: 'Ff'
    });

    if (!Number.isInteger(data.fieldFlags) || data.fieldFlags < 0) {
      data.fieldFlags = 0;
    }

    data.readOnly = _this2.hasFieldFlag(_util.AnnotationFieldFlag.READONLY);

    if (data.fieldType === 'Sig') {
      data.fieldValue = null;

      _this2.setFlags(_util.AnnotationFlag.HIDDEN);
    }

    return _this2;
  }

  _createClass(WidgetAnnotation, [{
    key: "_constructFieldName",
    value: function _constructFieldName(dict) {
      if (!dict.has('T') && !dict.has('Parent')) {
        (0, _util.warn)('Unknown field name, falling back to empty field name.');
        return '';
      }

      if (!dict.has('Parent')) {
        return (0, _util.stringToPDFString)(dict.get('T'));
      }

      var fieldName = [];

      if (dict.has('T')) {
        fieldName.unshift((0, _util.stringToPDFString)(dict.get('T')));
      }

      var loopDict = dict;

      while (loopDict.has('Parent')) {
        loopDict = loopDict.get('Parent');

        if (!(0, _primitives.isDict)(loopDict)) {
          break;
        }

        if (loopDict.has('T')) {
          fieldName.unshift((0, _util.stringToPDFString)(loopDict.get('T')));
        }
      }

      return fieldName.join('.');
    }
  }, {
    key: "hasFieldFlag",
    value: function hasFieldFlag(flag) {
      return !!(this.data.fieldFlags & flag);
    }
  }, {
    key: "getOperatorList",
    value: function getOperatorList(evaluator, task, renderForms) {
      if (renderForms) {
        return Promise.resolve(new _operator_list.OperatorList());
      }

      return _get(_getPrototypeOf(WidgetAnnotation.prototype), "getOperatorList", this).call(this, evaluator, task, renderForms);
    }
  }]);

  return WidgetAnnotation;
}(Annotation);

var TextWidgetAnnotation =
/*#__PURE__*/
function (_WidgetAnnotation) {
  _inherits(TextWidgetAnnotation, _WidgetAnnotation);

  function TextWidgetAnnotation(params) {
    var _this3;

    _classCallCheck(this, TextWidgetAnnotation);

    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(TextWidgetAnnotation).call(this, params));
    var dict = params.dict;
    _this3.data.fieldValue = (0, _util.stringToPDFString)(_this3.data.fieldValue || '');
    var alignment = (0, _util.getInheritableProperty)({
      dict: dict,
      key: 'Q'
    });

    if (!Number.isInteger(alignment) || alignment < 0 || alignment > 2) {
      alignment = null;
    }

    _this3.data.textAlignment = alignment;
    var maximumLength = (0, _util.getInheritableProperty)({
      dict: dict,
      key: 'MaxLen'
    });

    if (!Number.isInteger(maximumLength) || maximumLength < 0) {
      maximumLength = null;
    }

    _this3.data.maxLen = maximumLength;
    _this3.data.multiLine = _this3.hasFieldFlag(_util.AnnotationFieldFlag.MULTILINE);
    _this3.data.comb = _this3.hasFieldFlag(_util.AnnotationFieldFlag.COMB) && !_this3.hasFieldFlag(_util.AnnotationFieldFlag.MULTILINE) && !_this3.hasFieldFlag(_util.AnnotationFieldFlag.PASSWORD) && !_this3.hasFieldFlag(_util.AnnotationFieldFlag.FILESELECT) && _this3.data.maxLen !== null;
    return _this3;
  }

  _createClass(TextWidgetAnnotation, [{
    key: "getOperatorList",
    value: function getOperatorList(evaluator, task, renderForms) {
      if (renderForms || this.appearance) {
        return _get(_getPrototypeOf(TextWidgetAnnotation.prototype), "getOperatorList", this).call(this, evaluator, task, renderForms);
      }

      var operatorList = new _operator_list.OperatorList();

      if (!this.data.defaultAppearance) {
        return Promise.resolve(operatorList);
      }

      var stream = new _stream.Stream((0, _util.stringToBytes)(this.data.defaultAppearance));
      return evaluator.getOperatorList({
        stream: stream,
        task: task,
        resources: this.fieldResources,
        operatorList: operatorList
      }).then(function () {
        return operatorList;
      });
    }
  }]);

  return TextWidgetAnnotation;
}(WidgetAnnotation);

var ButtonWidgetAnnotation =
/*#__PURE__*/
function (_WidgetAnnotation2) {
  _inherits(ButtonWidgetAnnotation, _WidgetAnnotation2);

  function ButtonWidgetAnnotation(params) {
    var _this4;

    _classCallCheck(this, ButtonWidgetAnnotation);

    _this4 = _possibleConstructorReturn(this, _getPrototypeOf(ButtonWidgetAnnotation).call(this, params));
    _this4.data.checkBox = !_this4.hasFieldFlag(_util.AnnotationFieldFlag.RADIO) && !_this4.hasFieldFlag(_util.AnnotationFieldFlag.PUSHBUTTON);
    _this4.data.radioButton = _this4.hasFieldFlag(_util.AnnotationFieldFlag.RADIO) && !_this4.hasFieldFlag(_util.AnnotationFieldFlag.PUSHBUTTON);
    _this4.data.pushButton = _this4.hasFieldFlag(_util.AnnotationFieldFlag.PUSHBUTTON);

    if (_this4.data.checkBox) {
      _this4._processCheckBox(params);
    } else if (_this4.data.radioButton) {
      _this4._processRadioButton(params);
    } else if (_this4.data.pushButton) {
      _this4._processPushButton(params);
    } else {
      (0, _util.warn)('Invalid field flags for button widget annotation');
    }

    return _this4;
  }

  _createClass(ButtonWidgetAnnotation, [{
    key: "_processCheckBox",
    value: function _processCheckBox(params) {
      if ((0, _primitives.isName)(this.data.fieldValue)) {
        this.data.fieldValue = this.data.fieldValue.name;
      }

      var customAppearance = params.dict.get('AP');

      if (!(0, _primitives.isDict)(customAppearance)) {
        return;
      }

      var exportValueOptionsDict = customAppearance.get('D');

      if (!(0, _primitives.isDict)(exportValueOptionsDict)) {
        return;
      }

      var exportValues = exportValueOptionsDict.getKeys();
      var hasCorrectOptionCount = exportValues.length === 2;

      if (!hasCorrectOptionCount) {
        return;
      }

      this.data.exportValue = exportValues[0] === 'Off' ? exportValues[1] : exportValues[0];
    }
  }, {
    key: "_processRadioButton",
    value: function _processRadioButton(params) {
      this.data.fieldValue = this.data.buttonValue = null;
      var fieldParent = params.dict.get('Parent');

      if ((0, _primitives.isDict)(fieldParent) && fieldParent.has('V')) {
        var fieldParentValue = fieldParent.get('V');

        if ((0, _primitives.isName)(fieldParentValue)) {
          this.data.fieldValue = fieldParentValue.name;
        }
      }

      var appearanceStates = params.dict.get('AP');

      if (!(0, _primitives.isDict)(appearanceStates)) {
        return;
      }

      var normalAppearanceState = appearanceStates.get('N');

      if (!(0, _primitives.isDict)(normalAppearanceState)) {
        return;
      }

      var keys = normalAppearanceState.getKeys();

      for (var i = 0, ii = keys.length; i < ii; i++) {
        if (keys[i] !== 'Off') {
          this.data.buttonValue = keys[i];
          break;
        }
      }
    }
  }, {
    key: "_processPushButton",
    value: function _processPushButton(params) {
      if (!params.dict.has('A')) {
        (0, _util.warn)('Push buttons without action dictionaries are not supported');
        return;
      }

      _obj.Catalog.parseDestDictionary({
        destDict: params.dict,
        resultObj: this.data,
        docBaseUrl: params.pdfManager.docBaseUrl
      });
    }
  }]);

  return ButtonWidgetAnnotation;
}(WidgetAnnotation);

var ChoiceWidgetAnnotation =
/*#__PURE__*/
function (_WidgetAnnotation3) {
  _inherits(ChoiceWidgetAnnotation, _WidgetAnnotation3);

  function ChoiceWidgetAnnotation(params) {
    var _this5;

    _classCallCheck(this, ChoiceWidgetAnnotation);

    _this5 = _possibleConstructorReturn(this, _getPrototypeOf(ChoiceWidgetAnnotation).call(this, params));
    _this5.data.options = [];
    var options = (0, _util.getInheritableProperty)({
      dict: params.dict,
      key: 'Opt'
    });

    if (Array.isArray(options)) {
      var xref = params.xref;

      for (var i = 0, ii = options.length; i < ii; i++) {
        var option = xref.fetchIfRef(options[i]);
        var isOptionArray = Array.isArray(option);
        _this5.data.options[i] = {
          exportValue: isOptionArray ? xref.fetchIfRef(option[0]) : option,
          displayValue: (0, _util.stringToPDFString)(isOptionArray ? xref.fetchIfRef(option[1]) : option)
        };
      }
    }

    if (!Array.isArray(_this5.data.fieldValue)) {
      _this5.data.fieldValue = [_this5.data.fieldValue];
    }

    _this5.data.combo = _this5.hasFieldFlag(_util.AnnotationFieldFlag.COMBO);
    _this5.data.multiSelect = _this5.hasFieldFlag(_util.AnnotationFieldFlag.MULTISELECT);
    return _this5;
  }

  return ChoiceWidgetAnnotation;
}(WidgetAnnotation);

var TextAnnotation =
/*#__PURE__*/
function (_Annotation2) {
  _inherits(TextAnnotation, _Annotation2);

  function TextAnnotation(parameters) {
    var _this6;

    _classCallCheck(this, TextAnnotation);

    var DEFAULT_ICON_SIZE = 22;
    _this6 = _possibleConstructorReturn(this, _getPrototypeOf(TextAnnotation).call(this, parameters));
    _this6.data.annotationType = _util.AnnotationType.TEXT;

    if (_this6.data.hasAppearance) {
      _this6.data.name = 'NoIcon';
    } else {
      _this6.data.rect[1] = _this6.data.rect[3] - DEFAULT_ICON_SIZE;
      _this6.data.rect[2] = _this6.data.rect[0] + DEFAULT_ICON_SIZE;
      _this6.data.name = parameters.dict.has('Name') ? parameters.dict.get('Name').name : 'Note';
    }

    _this6._preparePopup(parameters.dict);

    return _this6;
  }

  return TextAnnotation;
}(Annotation);

var LinkAnnotation =
/*#__PURE__*/
function (_Annotation3) {
  _inherits(LinkAnnotation, _Annotation3);

  function LinkAnnotation(params) {
    var _this7;

    _classCallCheck(this, LinkAnnotation);

    _this7 = _possibleConstructorReturn(this, _getPrototypeOf(LinkAnnotation).call(this, params));
    _this7.data.annotationType = _util.AnnotationType.LINK;

    _obj.Catalog.parseDestDictionary({
      destDict: params.dict,
      resultObj: _this7.data,
      docBaseUrl: params.pdfManager.docBaseUrl
    });

    return _this7;
  }

  return LinkAnnotation;
}(Annotation);

var PopupAnnotation =
/*#__PURE__*/
function (_Annotation4) {
  _inherits(PopupAnnotation, _Annotation4);

  function PopupAnnotation(parameters) {
    var _this8;

    _classCallCheck(this, PopupAnnotation);

    _this8 = _possibleConstructorReturn(this, _getPrototypeOf(PopupAnnotation).call(this, parameters));
    _this8.data.annotationType = _util.AnnotationType.POPUP;
    var dict = parameters.dict;
    var parentItem = dict.get('Parent');

    if (!parentItem) {
      (0, _util.warn)('Popup annotation has a missing or invalid parent annotation.');
      return _possibleConstructorReturn(_this8);
    }

    var parentSubtype = parentItem.get('Subtype');
    _this8.data.parentType = (0, _primitives.isName)(parentSubtype) ? parentSubtype.name : null;
    _this8.data.parentId = dict.getRaw('Parent').toString();
    _this8.data.title = (0, _util.stringToPDFString)(parentItem.get('T') || '');
    _this8.data.contents = (0, _util.stringToPDFString)(parentItem.get('Contents') || '');

    if (!parentItem.has('C')) {
      _this8.data.color = null;
    } else {
      _this8.setColor(parentItem.getArray('C'));

      _this8.data.color = _this8.color;
    }

    if (!_this8.viewable) {
      var parentFlags = parentItem.get('F');

      if (_this8._isViewable(parentFlags)) {
        _this8.setFlags(parentFlags);
      }
    }

    return _this8;
  }

  return PopupAnnotation;
}(Annotation);

var LineAnnotation =
/*#__PURE__*/
function (_Annotation5) {
  _inherits(LineAnnotation, _Annotation5);

  function LineAnnotation(parameters) {
    var _this9;

    _classCallCheck(this, LineAnnotation);

    _this9 = _possibleConstructorReturn(this, _getPrototypeOf(LineAnnotation).call(this, parameters));
    _this9.data.annotationType = _util.AnnotationType.LINE;
    var dict = parameters.dict;
    _this9.data.lineCoordinates = _util.Util.normalizeRect(dict.getArray('L'));

    _this9._preparePopup(dict);

    return _this9;
  }

  return LineAnnotation;
}(Annotation);

var SquareAnnotation =
/*#__PURE__*/
function (_Annotation6) {
  _inherits(SquareAnnotation, _Annotation6);

  function SquareAnnotation(parameters) {
    var _this10;

    _classCallCheck(this, SquareAnnotation);

    _this10 = _possibleConstructorReturn(this, _getPrototypeOf(SquareAnnotation).call(this, parameters));
    _this10.data.annotationType = _util.AnnotationType.SQUARE;

    _this10._preparePopup(parameters.dict);

    return _this10;
  }

  return SquareAnnotation;
}(Annotation);

var CircleAnnotation =
/*#__PURE__*/
function (_Annotation7) {
  _inherits(CircleAnnotation, _Annotation7);

  function CircleAnnotation(parameters) {
    var _this11;

    _classCallCheck(this, CircleAnnotation);

    _this11 = _possibleConstructorReturn(this, _getPrototypeOf(CircleAnnotation).call(this, parameters));
    _this11.data.annotationType = _util.AnnotationType.CIRCLE;

    _this11._preparePopup(parameters.dict);

    return _this11;
  }

  return CircleAnnotation;
}(Annotation);

var PolylineAnnotation =
/*#__PURE__*/
function (_Annotation8) {
  _inherits(PolylineAnnotation, _Annotation8);

  function PolylineAnnotation(parameters) {
    var _this12;

    _classCallCheck(this, PolylineAnnotation);

    _this12 = _possibleConstructorReturn(this, _getPrototypeOf(PolylineAnnotation).call(this, parameters));
    _this12.data.annotationType = _util.AnnotationType.POLYLINE;
    var dict = parameters.dict;
    var rawVertices = dict.getArray('Vertices');
    _this12.data.vertices = [];

    for (var i = 0, ii = rawVertices.length; i < ii; i += 2) {
      _this12.data.vertices.push({
        x: rawVertices[i],
        y: rawVertices[i + 1]
      });
    }

    _this12._preparePopup(dict);

    return _this12;
  }

  return PolylineAnnotation;
}(Annotation);

var PolygonAnnotation =
/*#__PURE__*/
function (_PolylineAnnotation) {
  _inherits(PolygonAnnotation, _PolylineAnnotation);

  function PolygonAnnotation(parameters) {
    var _this13;

    _classCallCheck(this, PolygonAnnotation);

    _this13 = _possibleConstructorReturn(this, _getPrototypeOf(PolygonAnnotation).call(this, parameters));
    _this13.data.annotationType = _util.AnnotationType.POLYGON;
    return _this13;
  }

  return PolygonAnnotation;
}(PolylineAnnotation);

var InkAnnotation =
/*#__PURE__*/
function (_Annotation9) {
  _inherits(InkAnnotation, _Annotation9);

  function InkAnnotation(parameters) {
    var _this14;

    _classCallCheck(this, InkAnnotation);

    _this14 = _possibleConstructorReturn(this, _getPrototypeOf(InkAnnotation).call(this, parameters));
    _this14.data.annotationType = _util.AnnotationType.INK;
    var dict = parameters.dict;
    var xref = parameters.xref;
    var originalInkLists = dict.getArray('InkList');
    _this14.data.inkLists = [];

    for (var i = 0, ii = originalInkLists.length; i < ii; ++i) {
      _this14.data.inkLists.push([]);

      for (var j = 0, jj = originalInkLists[i].length; j < jj; j += 2) {
        _this14.data.inkLists[i].push({
          x: xref.fetchIfRef(originalInkLists[i][j]),
          y: xref.fetchIfRef(originalInkLists[i][j + 1])
        });
      }
    }

    _this14._preparePopup(dict);

    return _this14;
  }

  return InkAnnotation;
}(Annotation);

var HighlightAnnotation =
/*#__PURE__*/
function (_Annotation10) {
  _inherits(HighlightAnnotation, _Annotation10);

  function HighlightAnnotation(parameters) {
    var _this15;

    _classCallCheck(this, HighlightAnnotation);

    _this15 = _possibleConstructorReturn(this, _getPrototypeOf(HighlightAnnotation).call(this, parameters));
    _this15.data.annotationType = _util.AnnotationType.HIGHLIGHT;

    _this15._preparePopup(parameters.dict);

    return _this15;
  }

  return HighlightAnnotation;
}(Annotation);

var UnderlineAnnotation =
/*#__PURE__*/
function (_Annotation11) {
  _inherits(UnderlineAnnotation, _Annotation11);

  function UnderlineAnnotation(parameters) {
    var _this16;

    _classCallCheck(this, UnderlineAnnotation);

    _this16 = _possibleConstructorReturn(this, _getPrototypeOf(UnderlineAnnotation).call(this, parameters));
    _this16.data.annotationType = _util.AnnotationType.UNDERLINE;

    _this16._preparePopup(parameters.dict);

    return _this16;
  }

  return UnderlineAnnotation;
}(Annotation);

var SquigglyAnnotation =
/*#__PURE__*/
function (_Annotation12) {
  _inherits(SquigglyAnnotation, _Annotation12);

  function SquigglyAnnotation(parameters) {
    var _this17;

    _classCallCheck(this, SquigglyAnnotation);

    _this17 = _possibleConstructorReturn(this, _getPrototypeOf(SquigglyAnnotation).call(this, parameters));
    _this17.data.annotationType = _util.AnnotationType.SQUIGGLY;

    _this17._preparePopup(parameters.dict);

    return _this17;
  }

  return SquigglyAnnotation;
}(Annotation);

var StrikeOutAnnotation =
/*#__PURE__*/
function (_Annotation13) {
  _inherits(StrikeOutAnnotation, _Annotation13);

  function StrikeOutAnnotation(parameters) {
    var _this18;

    _classCallCheck(this, StrikeOutAnnotation);

    _this18 = _possibleConstructorReturn(this, _getPrototypeOf(StrikeOutAnnotation).call(this, parameters));
    _this18.data.annotationType = _util.AnnotationType.STRIKEOUT;

    _this18._preparePopup(parameters.dict);

    return _this18;
  }

  return StrikeOutAnnotation;
}(Annotation);

var StampAnnotation =
/*#__PURE__*/
function (_Annotation14) {
  _inherits(StampAnnotation, _Annotation14);

  function StampAnnotation(parameters) {
    var _this19;

    _classCallCheck(this, StampAnnotation);

    _this19 = _possibleConstructorReturn(this, _getPrototypeOf(StampAnnotation).call(this, parameters));
    _this19.data.annotationType = _util.AnnotationType.STAMP;

    _this19._preparePopup(parameters.dict);

    return _this19;
  }

  return StampAnnotation;
}(Annotation);

var FileAttachmentAnnotation =
/*#__PURE__*/
function (_Annotation15) {
  _inherits(FileAttachmentAnnotation, _Annotation15);

  function FileAttachmentAnnotation(parameters) {
    var _this20;

    _classCallCheck(this, FileAttachmentAnnotation);

    _this20 = _possibleConstructorReturn(this, _getPrototypeOf(FileAttachmentAnnotation).call(this, parameters));
    var file = new _obj.FileSpec(parameters.dict.get('FS'), parameters.xref);
    _this20.data.annotationType = _util.AnnotationType.FILEATTACHMENT;
    _this20.data.file = file.serializable;

    _this20._preparePopup(parameters.dict);

    return _this20;
  }

  return FileAttachmentAnnotation;
}(Annotation);

/***/ }),
/* 170 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OperatorList = void 0;

var _util = __w_pdfjs_require__(6);

var QueueOptimizer = function QueueOptimizerClosure() {
  function addState(parentState, pattern, checkFn, iterateFn, processFn) {
    var state = parentState;

    for (var i = 0, ii = pattern.length - 1; i < ii; i++) {
      var item = pattern[i];
      state = state[item] || (state[item] = []);
    }

    state[pattern[pattern.length - 1]] = {
      checkFn: checkFn,
      iterateFn: iterateFn,
      processFn: processFn
    };
  }

  function handlePaintSolidColorImageMask(iFirstSave, count, fnArray, argsArray) {
    var iFirstPIMXO = iFirstSave + 2;

    for (var i = 0; i < count; i++) {
      var arg = argsArray[iFirstPIMXO + 4 * i];
      var imageMask = arg.length === 1 && arg[0];

      if (imageMask && imageMask.width === 1 && imageMask.height === 1 && (!imageMask.data.length || imageMask.data.length === 1 && imageMask.data[0] === 0)) {
        fnArray[iFirstPIMXO + 4 * i] = _util.OPS.paintSolidColorImageMask;
        continue;
      }

      break;
    }

    return count - i;
  }

  var InitialState = [];
  addState(InitialState, [_util.OPS.save, _util.OPS.transform, _util.OPS.paintInlineImageXObject, _util.OPS.restore], null, function iterateInlineImageGroup(context, i) {
    var fnArray = context.fnArray;
    var iFirstSave = context.iCurr - 3;
    var pos = (i - iFirstSave) % 4;

    switch (pos) {
      case 0:
        return fnArray[i] === _util.OPS.save;

      case 1:
        return fnArray[i] === _util.OPS.transform;

      case 2:
        return fnArray[i] === _util.OPS.paintInlineImageXObject;

      case 3:
        return fnArray[i] === _util.OPS.restore;
    }
  }, function foundInlineImageGroup(context, i) {
    var MIN_IMAGES_IN_INLINE_IMAGES_BLOCK = 10;
    var MAX_IMAGES_IN_INLINE_IMAGES_BLOCK = 200;
    var MAX_WIDTH = 1000;
    var IMAGE_PADDING = 1;
    var fnArray = context.fnArray,
        argsArray = context.argsArray;
    var curr = context.iCurr;
    var iFirstSave = curr - 3;
    var iFirstTransform = curr - 2;
    var iFirstPIIXO = curr - 1;
    var count = Math.min(Math.floor((i - iFirstSave) / 4), MAX_IMAGES_IN_INLINE_IMAGES_BLOCK);

    if (count < MIN_IMAGES_IN_INLINE_IMAGES_BLOCK) {
      return i - (i - iFirstSave) % 4;
    }

    var maxX = 0;
    var map = [],
        maxLineHeight = 0;
    var currentX = IMAGE_PADDING,
        currentY = IMAGE_PADDING;
    var q;

    for (q = 0; q < count; q++) {
      var transform = argsArray[iFirstTransform + (q << 2)];
      var img = argsArray[iFirstPIIXO + (q << 2)][0];

      if (currentX + img.width > MAX_WIDTH) {
        maxX = Math.max(maxX, currentX);
        currentY += maxLineHeight + 2 * IMAGE_PADDING;
        currentX = 0;
        maxLineHeight = 0;
      }

      map.push({
        transform: transform,
        x: currentX,
        y: currentY,
        w: img.width,
        h: img.height
      });
      currentX += img.width + 2 * IMAGE_PADDING;
      maxLineHeight = Math.max(maxLineHeight, img.height);
    }

    var imgWidth = Math.max(maxX, currentX) + IMAGE_PADDING;
    var imgHeight = currentY + maxLineHeight + IMAGE_PADDING;
    var imgData = new Uint8ClampedArray(imgWidth * imgHeight * 4);
    var imgRowSize = imgWidth << 2;

    for (q = 0; q < count; q++) {
      var data = argsArray[iFirstPIIXO + (q << 2)][0].data;
      var rowSize = map[q].w << 2;
      var dataOffset = 0;
      var offset = map[q].x + map[q].y * imgWidth << 2;
      imgData.set(data.subarray(0, rowSize), offset - imgRowSize);

      for (var k = 0, kk = map[q].h; k < kk; k++) {
        imgData.set(data.subarray(dataOffset, dataOffset + rowSize), offset);
        dataOffset += rowSize;
        offset += imgRowSize;
      }

      imgData.set(data.subarray(dataOffset - rowSize, dataOffset), offset);

      while (offset >= 0) {
        data[offset - 4] = data[offset];
        data[offset - 3] = data[offset + 1];
        data[offset - 2] = data[offset + 2];
        data[offset - 1] = data[offset + 3];
        data[offset + rowSize] = data[offset + rowSize - 4];
        data[offset + rowSize + 1] = data[offset + rowSize - 3];
        data[offset + rowSize + 2] = data[offset + rowSize - 2];
        data[offset + rowSize + 3] = data[offset + rowSize - 1];
        offset -= imgRowSize;
      }
    }

    fnArray.splice(iFirstSave, count * 4, _util.OPS.paintInlineImageXObjectGroup);
    argsArray.splice(iFirstSave, count * 4, [{
      width: imgWidth,
      height: imgHeight,
      kind: _util.ImageKind.RGBA_32BPP,
      data: imgData
    }, map]);
    return iFirstSave + 1;
  });
  addState(InitialState, [_util.OPS.save, _util.OPS.transform, _util.OPS.paintImageMaskXObject, _util.OPS.restore], null, function iterateImageMaskGroup(context, i) {
    var fnArray = context.fnArray;
    var iFirstSave = context.iCurr - 3;
    var pos = (i - iFirstSave) % 4;

    switch (pos) {
      case 0:
        return fnArray[i] === _util.OPS.save;

      case 1:
        return fnArray[i] === _util.OPS.transform;

      case 2:
        return fnArray[i] === _util.OPS.paintImageMaskXObject;

      case 3:
        return fnArray[i] === _util.OPS.restore;
    }
  }, function foundImageMaskGroup(context, i) {
    var MIN_IMAGES_IN_MASKS_BLOCK = 10;
    var MAX_IMAGES_IN_MASKS_BLOCK = 100;
    var MAX_SAME_IMAGES_IN_MASKS_BLOCK = 1000;
    var fnArray = context.fnArray,
        argsArray = context.argsArray;
    var curr = context.iCurr;
    var iFirstSave = curr - 3;
    var iFirstTransform = curr - 2;
    var iFirstPIMXO = curr - 1;
    var count = Math.floor((i - iFirstSave) / 4);
    count = handlePaintSolidColorImageMask(iFirstSave, count, fnArray, argsArray);

    if (count < MIN_IMAGES_IN_MASKS_BLOCK) {
      return i - (i - iFirstSave) % 4;
    }

    var q;
    var isSameImage = false;
    var iTransform, transformArgs;
    var firstPIMXOArg0 = argsArray[iFirstPIMXO][0];

    if (argsArray[iFirstTransform][1] === 0 && argsArray[iFirstTransform][2] === 0) {
      isSameImage = true;
      var firstTransformArg0 = argsArray[iFirstTransform][0];
      var firstTransformArg3 = argsArray[iFirstTransform][3];
      iTransform = iFirstTransform + 4;
      var iPIMXO = iFirstPIMXO + 4;

      for (q = 1; q < count; q++, iTransform += 4, iPIMXO += 4) {
        transformArgs = argsArray[iTransform];

        if (argsArray[iPIMXO][0] !== firstPIMXOArg0 || transformArgs[0] !== firstTransformArg0 || transformArgs[1] !== 0 || transformArgs[2] !== 0 || transformArgs[3] !== firstTransformArg3) {
          if (q < MIN_IMAGES_IN_MASKS_BLOCK) {
            isSameImage = false;
          } else {
            count = q;
          }

          break;
        }
      }
    }

    if (isSameImage) {
      count = Math.min(count, MAX_SAME_IMAGES_IN_MASKS_BLOCK);
      var positions = new Float32Array(count * 2);
      iTransform = iFirstTransform;

      for (q = 0; q < count; q++, iTransform += 4) {
        transformArgs = argsArray[iTransform];
        positions[q << 1] = transformArgs[4];
        positions[(q << 1) + 1] = transformArgs[5];
      }

      fnArray.splice(iFirstSave, count * 4, _util.OPS.paintImageMaskXObjectRepeat);
      argsArray.splice(iFirstSave, count * 4, [firstPIMXOArg0, firstTransformArg0, firstTransformArg3, positions]);
    } else {
      count = Math.min(count, MAX_IMAGES_IN_MASKS_BLOCK);
      var images = [];

      for (q = 0; q < count; q++) {
        transformArgs = argsArray[iFirstTransform + (q << 2)];
        var maskParams = argsArray[iFirstPIMXO + (q << 2)][0];
        images.push({
          data: maskParams.data,
          width: maskParams.width,
          height: maskParams.height,
          transform: transformArgs
        });
      }

      fnArray.splice(iFirstSave, count * 4, _util.OPS.paintImageMaskXObjectGroup);
      argsArray.splice(iFirstSave, count * 4, [images]);
    }

    return iFirstSave + 1;
  });
  addState(InitialState, [_util.OPS.save, _util.OPS.transform, _util.OPS.paintImageXObject, _util.OPS.restore], function (context) {
    var argsArray = context.argsArray;
    var iFirstTransform = context.iCurr - 2;
    return argsArray[iFirstTransform][1] === 0 && argsArray[iFirstTransform][2] === 0;
  }, function (context, i) {
    var fnArray = context.fnArray,
        argsArray = context.argsArray;
    var iFirstSave = context.iCurr - 3;
    var pos = (i - iFirstSave) % 4;

    switch (pos) {
      case 0:
        return fnArray[i] === _util.OPS.save;

      case 1:
        if (fnArray[i] !== _util.OPS.transform) {
          return false;
        }

        var iFirstTransform = context.iCurr - 2;
        var firstTransformArg0 = argsArray[iFirstTransform][0];
        var firstTransformArg3 = argsArray[iFirstTransform][3];

        if (argsArray[i][0] !== firstTransformArg0 || argsArray[i][1] !== 0 || argsArray[i][2] !== 0 || argsArray[i][3] !== firstTransformArg3) {
          return false;
        }

        return true;

      case 2:
        if (fnArray[i] !== _util.OPS.paintImageXObject) {
          return false;
        }

        var iFirstPIXO = context.iCurr - 1;
        var firstPIXOArg0 = argsArray[iFirstPIXO][0];

        if (argsArray[i][0] !== firstPIXOArg0) {
          return false;
        }

        return true;

      case 3:
        return fnArray[i] === _util.OPS.restore;
    }
  }, function (context, i) {
    var MIN_IMAGES_IN_BLOCK = 3;
    var MAX_IMAGES_IN_BLOCK = 1000;
    var fnArray = context.fnArray,
        argsArray = context.argsArray;
    var curr = context.iCurr;
    var iFirstSave = curr - 3;
    var iFirstTransform = curr - 2;
    var iFirstPIXO = curr - 1;
    var firstPIXOArg0 = argsArray[iFirstPIXO][0];
    var firstTransformArg0 = argsArray[iFirstTransform][0];
    var firstTransformArg3 = argsArray[iFirstTransform][3];
    var count = Math.min(Math.floor((i - iFirstSave) / 4), MAX_IMAGES_IN_BLOCK);

    if (count < MIN_IMAGES_IN_BLOCK) {
      return i - (i - iFirstSave) % 4;
    }

    var positions = new Float32Array(count * 2);
    var iTransform = iFirstTransform;

    for (var q = 0; q < count; q++, iTransform += 4) {
      var transformArgs = argsArray[iTransform];
      positions[q << 1] = transformArgs[4];
      positions[(q << 1) + 1] = transformArgs[5];
    }

    var args = [firstPIXOArg0, firstTransformArg0, firstTransformArg3, positions];
    fnArray.splice(iFirstSave, count * 4, _util.OPS.paintImageXObjectRepeat);
    argsArray.splice(iFirstSave, count * 4, args);
    return iFirstSave + 1;
  });
  addState(InitialState, [_util.OPS.beginText, _util.OPS.setFont, _util.OPS.setTextMatrix, _util.OPS.showText, _util.OPS.endText], null, function (context, i) {
    var fnArray = context.fnArray,
        argsArray = context.argsArray;
    var iFirstSave = context.iCurr - 4;
    var pos = (i - iFirstSave) % 5;

    switch (pos) {
      case 0:
        return fnArray[i] === _util.OPS.beginText;

      case 1:
        return fnArray[i] === _util.OPS.setFont;

      case 2:
        return fnArray[i] === _util.OPS.setTextMatrix;

      case 3:
        if (fnArray[i] !== _util.OPS.showText) {
          return false;
        }

        var iFirstSetFont = context.iCurr - 3;
        var firstSetFontArg0 = argsArray[iFirstSetFont][0];
        var firstSetFontArg1 = argsArray[iFirstSetFont][1];

        if (argsArray[i][0] !== firstSetFontArg0 || argsArray[i][1] !== firstSetFontArg1) {
          return false;
        }

        return true;

      case 4:
        return fnArray[i] === _util.OPS.endText;
    }
  }, function (context, i) {
    var MIN_CHARS_IN_BLOCK = 3;
    var MAX_CHARS_IN_BLOCK = 1000;
    var fnArray = context.fnArray,
        argsArray = context.argsArray;
    var curr = context.iCurr;
    var iFirstBeginText = curr - 4;
    var iFirstSetFont = curr - 3;
    var iFirstSetTextMatrix = curr - 2;
    var iFirstShowText = curr - 1;
    var iFirstEndText = curr;
    var firstSetFontArg0 = argsArray[iFirstSetFont][0];
    var firstSetFontArg1 = argsArray[iFirstSetFont][1];
    var count = Math.min(Math.floor((i - iFirstBeginText) / 5), MAX_CHARS_IN_BLOCK);

    if (count < MIN_CHARS_IN_BLOCK) {
      return i - (i - iFirstBeginText) % 5;
    }

    var iFirst = iFirstBeginText;

    if (iFirstBeginText >= 4 && fnArray[iFirstBeginText - 4] === fnArray[iFirstSetFont] && fnArray[iFirstBeginText - 3] === fnArray[iFirstSetTextMatrix] && fnArray[iFirstBeginText - 2] === fnArray[iFirstShowText] && fnArray[iFirstBeginText - 1] === fnArray[iFirstEndText] && argsArray[iFirstBeginText - 4][0] === firstSetFontArg0 && argsArray[iFirstBeginText - 4][1] === firstSetFontArg1) {
      count++;
      iFirst -= 5;
    }

    var iEndText = iFirst + 4;

    for (var q = 1; q < count; q++) {
      fnArray.splice(iEndText, 3);
      argsArray.splice(iEndText, 3);
      iEndText += 2;
    }

    return iEndText + 1;
  });

  function QueueOptimizer(queue) {
    this.queue = queue;
    this.state = null;
    this.context = {
      iCurr: 0,
      fnArray: queue.fnArray,
      argsArray: queue.argsArray
    };
    this.match = null;
    this.lastProcessed = 0;
  }

  QueueOptimizer.prototype = {
    _optimize: function _optimize() {
      var fnArray = this.queue.fnArray;
      var i = this.lastProcessed,
          ii = fnArray.length;
      var state = this.state;
      var match = this.match;

      if (!state && !match && i + 1 === ii && !InitialState[fnArray[i]]) {
        this.lastProcessed = ii;
        return;
      }

      var context = this.context;

      while (i < ii) {
        if (match) {
          var iterate = (0, match.iterateFn)(context, i);

          if (iterate) {
            i++;
            continue;
          }

          i = (0, match.processFn)(context, i + 1);
          ii = fnArray.length;
          match = null;
          state = null;

          if (i >= ii) {
            break;
          }
        }

        state = (state || InitialState)[fnArray[i]];

        if (!state || Array.isArray(state)) {
          i++;
          continue;
        }

        context.iCurr = i;
        i++;

        if (state.checkFn && !(0, state.checkFn)(context)) {
          state = null;
          continue;
        }

        match = state;
        state = null;
      }

      this.state = state;
      this.match = match;
      this.lastProcessed = i;
    },
    push: function push(fn, args) {
      this.queue.fnArray.push(fn);
      this.queue.argsArray.push(args);

      this._optimize();
    },
    flush: function flush() {
      while (this.match) {
        var length = this.queue.fnArray.length;
        this.lastProcessed = (0, this.match.processFn)(this.context, length);
        this.match = null;
        this.state = null;

        this._optimize();
      }
    },
    reset: function reset() {
      this.state = null;
      this.match = null;
      this.lastProcessed = 0;
    }
  };
  return QueueOptimizer;
}();

var NullOptimizer = function NullOptimizerClosure() {
  function NullOptimizer(queue) {
    this.queue = queue;
  }

  NullOptimizer.prototype = {
    push: function push(fn, args) {
      this.queue.fnArray.push(fn);
      this.queue.argsArray.push(args);
    },
    flush: function flush() {}
  };
  return NullOptimizer;
}();

var OperatorList = function OperatorListClosure() {
  var CHUNK_SIZE = 1000;
  var CHUNK_SIZE_ABOUT = CHUNK_SIZE - 5;

  function getTransfers(queue) {
    var transfers = [];
    var fnArray = queue.fnArray,
        argsArray = queue.argsArray;

    for (var i = 0, ii = queue.length; i < ii; i++) {
      switch (fnArray[i]) {
        case _util.OPS.paintInlineImageXObject:
        case _util.OPS.paintInlineImageXObjectGroup:
        case _util.OPS.paintImageMaskXObject:
          var arg = argsArray[i][0];
          ;

          if (!arg.cached) {
            transfers.push(arg.data.buffer);
          }

          break;
      }
    }

    return transfers;
  }

  function OperatorList(intent, messageHandler, pageIndex) {
    this.messageHandler = messageHandler;
    this.fnArray = [];
    this.argsArray = [];

    if (messageHandler && this.intent !== 'oplist') {
      this.optimizer = new QueueOptimizer(this);
    } else {
      this.optimizer = new NullOptimizer(this);
    }

    this.dependencies = Object.create(null);
    this._totalLength = 0;
    this.pageIndex = pageIndex;
    this.intent = intent;
    this.weight = 0;
  }

  OperatorList.prototype = {
    get length() {
      return this.argsArray.length;
    },

    get totalLength() {
      return this._totalLength + this.length;
    },

    addOp: function addOp(fn, args) {
      this.optimizer.push(fn, args);
      this.weight++;

      if (this.messageHandler) {
        if (this.weight >= CHUNK_SIZE) {
          this.flush();
        } else if (this.weight >= CHUNK_SIZE_ABOUT && (fn === _util.OPS.restore || fn === _util.OPS.endText)) {
          this.flush();
        }
      }
    },
    addDependency: function addDependency(dependency) {
      if (dependency in this.dependencies) {
        return;
      }

      this.dependencies[dependency] = true;
      this.addOp(_util.OPS.dependency, [dependency]);
    },
    addDependencies: function addDependencies(dependencies) {
      for (var key in dependencies) {
        this.addDependency(key);
      }
    },
    addOpList: function addOpList(opList) {
      Object.assign(this.dependencies, opList.dependencies);

      for (var i = 0, ii = opList.length; i < ii; i++) {
        this.addOp(opList.fnArray[i], opList.argsArray[i]);
      }
    },
    getIR: function getIR() {
      return {
        fnArray: this.fnArray,
        argsArray: this.argsArray,
        length: this.length
      };
    },
    flush: function flush(lastChunk) {
      this.optimizer.flush();
      var transfers = getTransfers(this);
      var length = this.length;
      this._totalLength += length;
      this.messageHandler.send('RenderPageChunk', {
        operatorList: {
          fnArray: this.fnArray,
          argsArray: this.argsArray,
          lastChunk: lastChunk,
          length: length
        },
        pageIndex: this.pageIndex,
        intent: this.intent
      }, transfers);
      this.dependencies = Object.create(null);
      this.fnArray.length = 0;
      this.argsArray.length = 0;
      this.weight = 0;
      this.optimizer.reset();
    }
  };
  return OperatorList;
}();

exports.OperatorList = OperatorList;

/***/ }),
/* 171 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PartialEvaluator = void 0;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(2));

var _util = __w_pdfjs_require__(6);

var _cmap = __w_pdfjs_require__(172);

var _stream = __w_pdfjs_require__(157);

var _primitives = __w_pdfjs_require__(155);

var _fonts = __w_pdfjs_require__(173);

var _encodings = __w_pdfjs_require__(176);

var _unicode = __w_pdfjs_require__(179);

var _standard_fonts = __w_pdfjs_require__(178);

var _pattern = __w_pdfjs_require__(182);

var _parser = __w_pdfjs_require__(156);

var _bidi = __w_pdfjs_require__(183);

var _colorspace = __w_pdfjs_require__(168);

var _glyphlist = __w_pdfjs_require__(177);

var _metrics = __w_pdfjs_require__(184);

var _function = __w_pdfjs_require__(185);

var _jpeg_stream = __w_pdfjs_require__(163);

var _murmurhash = __w_pdfjs_require__(187);

var _operator_list = __w_pdfjs_require__(170);

var _image = __w_pdfjs_require__(188);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var PartialEvaluator = function PartialEvaluatorClosure() {
  var DefaultPartialEvaluatorOptions = {
    forceDataSchema: false,
    maxImageSize: -1,
    disableFontFace: false,
    nativeImageDecoderSupport: _util.NativeImageDecoding.DECODE,
    ignoreErrors: false,
    isEvalSupported: true
  };

  function NativeImageDecoder(_ref) {
    var xref = _ref.xref,
        resources = _ref.resources,
        handler = _ref.handler,
        _ref$forceDataSchema = _ref.forceDataSchema,
        forceDataSchema = _ref$forceDataSchema === void 0 ? false : _ref$forceDataSchema,
        pdfFunctionFactory = _ref.pdfFunctionFactory;
    this.xref = xref;
    this.resources = resources;
    this.handler = handler;
    this.forceDataSchema = forceDataSchema;
    this.pdfFunctionFactory = pdfFunctionFactory;
  }

  NativeImageDecoder.prototype = {
    canDecode: function canDecode(image) {
      return image instanceof _jpeg_stream.JpegStream && NativeImageDecoder.isDecodable(image, this.xref, this.resources, this.pdfFunctionFactory);
    },
    decode: function decode(image) {
      var dict = image.dict;
      var colorSpace = dict.get('ColorSpace', 'CS');
      colorSpace = _colorspace.ColorSpace.parse(colorSpace, this.xref, this.resources, this.pdfFunctionFactory);
      return this.handler.sendWithPromise('JpegDecode', [image.getIR(this.forceDataSchema), colorSpace.numComps]).then(function (_ref2) {
        var data = _ref2.data,
            width = _ref2.width,
            height = _ref2.height;
        return new _stream.Stream(data, 0, data.length, image.dict);
      });
    }
  };

  NativeImageDecoder.isSupported = function (image, xref, res, pdfFunctionFactory) {
    var dict = image.dict;

    if (dict.has('DecodeParms') || dict.has('DP')) {
      return false;
    }

    var cs = _colorspace.ColorSpace.parse(dict.get('ColorSpace', 'CS'), xref, res, pdfFunctionFactory);

    return (cs.name === 'DeviceGray' || cs.name === 'DeviceRGB') && cs.isDefaultDecode(dict.getArray('Decode', 'D'));
  };

  NativeImageDecoder.isDecodable = function (image, xref, res, pdfFunctionFactory) {
    var dict = image.dict;

    if (dict.has('DecodeParms') || dict.has('DP')) {
      return false;
    }

    var cs = _colorspace.ColorSpace.parse(dict.get('ColorSpace', 'CS'), xref, res, pdfFunctionFactory);

    var bpc = dict.get('BitsPerComponent', 'BPC') || 1;
    return (cs.numComps === 1 || cs.numComps === 3) && cs.isDefaultDecode(dict.getArray('Decode', 'D'), bpc);
  };

  function PartialEvaluator(_ref3) {
    var _this = this;

    var pdfManager = _ref3.pdfManager,
        xref = _ref3.xref,
        handler = _ref3.handler,
        pageIndex = _ref3.pageIndex,
        idFactory = _ref3.idFactory,
        fontCache = _ref3.fontCache,
        builtInCMapCache = _ref3.builtInCMapCache,
        _ref3$options = _ref3.options,
        options = _ref3$options === void 0 ? null : _ref3$options,
        pdfFunctionFactory = _ref3.pdfFunctionFactory;
    this.pdfManager = pdfManager;
    this.xref = xref;
    this.handler = handler;
    this.pageIndex = pageIndex;
    this.idFactory = idFactory;
    this.fontCache = fontCache;
    this.builtInCMapCache = builtInCMapCache;
    this.options = options || DefaultPartialEvaluatorOptions;
    this.pdfFunctionFactory = pdfFunctionFactory;

    this.fetchBuiltInCMap =
    /*#__PURE__*/
    function () {
      var _ref4 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(name) {
        var data;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!_this.builtInCMapCache.has(name)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", _this.builtInCMapCache.get(name));

              case 2:
                _context.next = 4;
                return _this.handler.sendWithPromise('FetchBuiltInCMap', {
                  name: name
                });

              case 4:
                data = _context.sent;

                if (data.compressionType !== _util.CMapCompressionType.NONE) {
                  _this.builtInCMapCache.set(name, data);
                }

                return _context.abrupt("return", data);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref4.apply(this, arguments);
      };
    }();
  }

  var TIME_SLOT_DURATION_MS = 20;
  var CHECK_TIME_EVERY = 100;

  function TimeSlotManager() {
    this.reset();
  }

  TimeSlotManager.prototype = {
    check: function TimeSlotManager_check() {
      if (++this.checked < CHECK_TIME_EVERY) {
        return false;
      }

      this.checked = 0;
      return this.endTime <= Date.now();
    },
    reset: function TimeSlotManager_reset() {
      this.endTime = Date.now() + TIME_SLOT_DURATION_MS;
      this.checked = 0;
    }
  };

  function normalizeBlendMode(value) {
    if (!(0, _primitives.isName)(value)) {
      return 'source-over';
    }

    switch (value.name) {
      case 'Normal':
      case 'Compatible':
        return 'source-over';

      case 'Multiply':
        return 'multiply';

      case 'Screen':
        return 'screen';

      case 'Overlay':
        return 'overlay';

      case 'Darken':
        return 'darken';

      case 'Lighten':
        return 'lighten';

      case 'ColorDodge':
        return 'color-dodge';

      case 'ColorBurn':
        return 'color-burn';

      case 'HardLight':
        return 'hard-light';

      case 'SoftLight':
        return 'soft-light';

      case 'Difference':
        return 'difference';

      case 'Exclusion':
        return 'exclusion';

      case 'Hue':
        return 'hue';

      case 'Saturation':
        return 'saturation';

      case 'Color':
        return 'color';

      case 'Luminosity':
        return 'luminosity';
    }

    (0, _util.warn)('Unsupported blend mode: ' + value.name);
    return 'source-over';
  }

  var deferred = Promise.resolve();
  var TILING_PATTERN = 1,
      SHADING_PATTERN = 2;
  PartialEvaluator.prototype = {
    clone: function clone() {
      var newOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DefaultPartialEvaluatorOptions;
      var newEvaluator = Object.create(this);
      newEvaluator.options = newOptions;
      return newEvaluator;
    },
    hasBlendModes: function PartialEvaluator_hasBlendModes(resources) {
      if (!(0, _primitives.isDict)(resources)) {
        return false;
      }

      var processed = Object.create(null);

      if (resources.objId) {
        processed[resources.objId] = true;
      }

      var nodes = [resources],
          xref = this.xref;

      while (nodes.length) {
        var key, i, ii;
        var node = nodes.shift();
        var graphicStates = node.get('ExtGState');

        if ((0, _primitives.isDict)(graphicStates)) {
          var graphicStatesKeys = graphicStates.getKeys();

          for (i = 0, ii = graphicStatesKeys.length; i < ii; i++) {
            key = graphicStatesKeys[i];
            var graphicState = graphicStates.get(key);
            var bm = graphicState.get('BM');

            if ((0, _primitives.isName)(bm) && bm.name !== 'Normal') {
              return true;
            }
          }
        }

        var xObjects = node.get('XObject');

        if (!(0, _primitives.isDict)(xObjects)) {
          continue;
        }

        var xObjectsKeys = xObjects.getKeys();

        for (i = 0, ii = xObjectsKeys.length; i < ii; i++) {
          key = xObjectsKeys[i];
          var xObject = xObjects.getRaw(key);

          if ((0, _primitives.isRef)(xObject)) {
            if (processed[xObject.toString()]) {
              continue;
            }

            xObject = xref.fetch(xObject);
          }

          if (!(0, _primitives.isStream)(xObject)) {
            continue;
          }

          if (xObject.dict.objId) {
            if (processed[xObject.dict.objId]) {
              continue;
            }

            processed[xObject.dict.objId] = true;
          }

          var xResources = xObject.dict.get('Resources');

          if ((0, _primitives.isDict)(xResources) && (!xResources.objId || !processed[xResources.objId])) {
            nodes.push(xResources);

            if (xResources.objId) {
              processed[xResources.objId] = true;
            }
          }
        }
      }

      return false;
    },
    buildFormXObject: function PartialEvaluator_buildFormXObject(resources, xobj, smask, operatorList, task, initialState) {
      var dict = xobj.dict;
      var matrix = dict.getArray('Matrix');
      var bbox = dict.getArray('BBox');

      if (Array.isArray(bbox) && bbox.length === 4) {
        bbox = _util.Util.normalizeRect(bbox);
      } else {
        bbox = null;
      }

      var group = dict.get('Group');

      if (group) {
        var groupOptions = {
          matrix: matrix,
          bbox: bbox,
          smask: smask,
          isolated: false,
          knockout: false
        };
        var groupSubtype = group.get('S');
        var colorSpace = null;

        if ((0, _primitives.isName)(groupSubtype, 'Transparency')) {
          groupOptions.isolated = group.get('I') || false;
          groupOptions.knockout = group.get('K') || false;

          if (group.has('CS')) {
            colorSpace = _colorspace.ColorSpace.parse(group.get('CS'), this.xref, resources, this.pdfFunctionFactory);
          }
        }

        if (smask && smask.backdrop) {
          colorSpace = colorSpace || _colorspace.ColorSpace.singletons.rgb;
          smask.backdrop = colorSpace.getRgb(smask.backdrop, 0);
        }

        operatorList.addOp(_util.OPS.beginGroup, [groupOptions]);
      }

      operatorList.addOp(_util.OPS.paintFormXObjectBegin, [matrix, bbox]);
      return this.getOperatorList({
        stream: xobj,
        task: task,
        resources: dict.get('Resources') || resources,
        operatorList: operatorList,
        initialState: initialState
      }).then(function () {
        operatorList.addOp(_util.OPS.paintFormXObjectEnd, []);

        if (group) {
          operatorList.addOp(_util.OPS.endGroup, [groupOptions]);
        }
      });
    },
    buildPaintImageXObject: function buildPaintImageXObject(_ref5) {
      var _this2 = this;

      var resources = _ref5.resources,
          image = _ref5.image,
          _ref5$isInline = _ref5.isInline,
          isInline = _ref5$isInline === void 0 ? false : _ref5$isInline,
          operatorList = _ref5.operatorList,
          cacheKey = _ref5.cacheKey,
          imageCache = _ref5.imageCache,
          _ref5$forceDisableNat = _ref5.forceDisableNativeImageDecoder,
          forceDisableNativeImageDecoder = _ref5$forceDisableNat === void 0 ? false : _ref5$forceDisableNat;
      var dict = image.dict;
      var w = dict.get('Width', 'W');
      var h = dict.get('Height', 'H');

      if (!(w && (0, _util.isNum)(w)) || !(h && (0, _util.isNum)(h))) {
        (0, _util.warn)('Image dimensions are missing, or not numbers.');
        return Promise.resolve();
      }

      var maxImageSize = this.options.maxImageSize;

      if (maxImageSize !== -1 && w * h > maxImageSize) {
        (0, _util.warn)('Image exceeded maximum allowed size and was removed.');
        return Promise.resolve();
      }

      var imageMask = dict.get('ImageMask', 'IM') || false;
      var imgData, args;

      if (imageMask) {
        var width = dict.get('Width', 'W');
        var height = dict.get('Height', 'H');
        var bitStrideLength = width + 7 >> 3;
        var imgArray = image.getBytes(bitStrideLength * height, true);
        var decode = dict.getArray('Decode', 'D');
        imgData = _image.PDFImage.createMask({
          imgArray: imgArray,
          width: width,
          height: height,
          imageIsFromDecodeStream: image instanceof _stream.DecodeStream,
          inverseDecode: !!decode && decode[0] > 0
        });
        imgData.cached = true;
        args = [imgData];
        operatorList.addOp(_util.OPS.paintImageMaskXObject, args);

        if (cacheKey) {
          imageCache[cacheKey] = {
            fn: _util.OPS.paintImageMaskXObject,
            args: args
          };
        }

        return Promise.resolve();
      }

      var softMask = dict.get('SMask', 'SM') || false;
      var mask = dict.get('Mask') || false;
      var SMALL_IMAGE_DIMENSIONS = 200;

      if (isInline && !softMask && !mask && !(image instanceof _jpeg_stream.JpegStream) && w + h < SMALL_IMAGE_DIMENSIONS) {
        var imageObj = new _image.PDFImage({
          xref: this.xref,
          res: resources,
          image: image,
          isInline: isInline,
          pdfFunctionFactory: this.pdfFunctionFactory
        });
        imgData = imageObj.createImageData(true);
        operatorList.addOp(_util.OPS.paintInlineImageXObject, [imgData]);
        return Promise.resolve();
      }

      var nativeImageDecoderSupport = forceDisableNativeImageDecoder ? _util.NativeImageDecoding.NONE : this.options.nativeImageDecoderSupport;
      var objId = 'img_' + this.idFactory.createObjId();

      if (nativeImageDecoderSupport !== _util.NativeImageDecoding.NONE && !softMask && !mask && image instanceof _jpeg_stream.JpegStream && NativeImageDecoder.isSupported(image, this.xref, resources, this.pdfFunctionFactory)) {
        return this.handler.sendWithPromise('obj', [objId, this.pageIndex, 'JpegStream', image.getIR(this.options.forceDataSchema)]).then(function () {
          operatorList.addDependency(objId);
          args = [objId, w, h];
          operatorList.addOp(_util.OPS.paintJpegXObject, args);

          if (cacheKey) {
            imageCache[cacheKey] = {
              fn: _util.OPS.paintJpegXObject,
              args: args
            };
          }
        }, function (reason) {
          (0, _util.warn)('Native JPEG decoding failed -- trying to recover: ' + (reason && reason.message));
          return _this2.buildPaintImageXObject({
            resources: resources,
            image: image,
            isInline: isInline,
            operatorList: operatorList,
            cacheKey: cacheKey,
            imageCache: imageCache,
            forceDisableNativeImageDecoder: true
          });
        });
      }

      var nativeImageDecoder = null;

      if (nativeImageDecoderSupport === _util.NativeImageDecoding.DECODE && (image instanceof _jpeg_stream.JpegStream || mask instanceof _jpeg_stream.JpegStream || softMask instanceof _jpeg_stream.JpegStream)) {
        nativeImageDecoder = new NativeImageDecoder({
          xref: this.xref,
          resources: resources,
          handler: this.handler,
          forceDataSchema: this.options.forceDataSchema,
          pdfFunctionFactory: this.pdfFunctionFactory
        });
      }

      operatorList.addDependency(objId);
      args = [objId, w, h];

      _image.PDFImage.buildImage({
        handler: this.handler,
        xref: this.xref,
        res: resources,
        image: image,
        isInline: isInline,
        nativeDecoder: nativeImageDecoder,
        pdfFunctionFactory: this.pdfFunctionFactory
      }).then(function (imageObj) {
        var imgData = imageObj.createImageData(false);

        _this2.handler.send('obj', [objId, _this2.pageIndex, 'Image', imgData], [imgData.data.buffer]);
      }).catch(function (reason) {
        (0, _util.warn)('Unable to decode image: ' + reason);

        _this2.handler.send('obj', [objId, _this2.pageIndex, 'Image', null]);
      });

      operatorList.addOp(_util.OPS.paintImageXObject, args);

      if (cacheKey) {
        imageCache[cacheKey] = {
          fn: _util.OPS.paintImageXObject,
          args: args
        };
      }

      return Promise.resolve();
    },
    handleSMask: function PartialEvaluator_handleSmask(smask, resources, operatorList, task, stateManager) {
      var smaskContent = smask.get('G');
      var smaskOptions = {
        subtype: smask.get('S').name,
        backdrop: smask.get('BC')
      };
      var transferObj = smask.get('TR');

      if ((0, _function.isPDFFunction)(transferObj)) {
        var transferFn = this.pdfFunctionFactory.create(transferObj);
        var transferMap = new Uint8Array(256);
        var tmp = new Float32Array(1);

        for (var i = 0; i < 256; i++) {
          tmp[0] = i / 255;
          transferFn(tmp, 0, tmp, 0);
          transferMap[i] = tmp[0] * 255 | 0;
        }

        smaskOptions.transferMap = transferMap;
      }

      return this.buildFormXObject(resources, smaskContent, smaskOptions, operatorList, task, stateManager.state.clone());
    },
    handleTilingType: function handleTilingType(fn, args, resources, pattern, patternDict, operatorList, task) {
      var _this3 = this;

      var tilingOpList = new _operator_list.OperatorList();
      var resourcesArray = [patternDict.get('Resources'), resources];

      var patternResources = _primitives.Dict.merge(this.xref, resourcesArray);

      return this.getOperatorList({
        stream: pattern,
        task: task,
        resources: patternResources,
        operatorList: tilingOpList
      }).then(function () {
        return (0, _pattern.getTilingPatternIR)({
          fnArray: tilingOpList.fnArray,
          argsArray: tilingOpList.argsArray
        }, patternDict, args);
      }).then(function (tilingPatternIR) {
        operatorList.addDependencies(tilingOpList.dependencies);
        operatorList.addOp(fn, tilingPatternIR);
      }, function (reason) {
        if (_this3.options.ignoreErrors) {
          _this3.handler.send('UnsupportedFeature', {
            featureId: _util.UNSUPPORTED_FEATURES.unknown
          });

          (0, _util.warn)("handleTilingType - ignoring pattern: \"".concat(reason, "\"."));
          return;
        }

        throw reason;
      });
    },
    handleSetFont: function PartialEvaluator_handleSetFont(resources, fontArgs, fontRef, operatorList, task, state) {
      var _this4 = this;

      var fontName;

      if (fontArgs) {
        fontArgs = fontArgs.slice();
        fontName = fontArgs[0].name;
      }

      return this.loadFont(fontName, fontRef, resources).then(function (translated) {
        if (!translated.font.isType3Font) {
          return translated;
        }

        return translated.loadType3Data(_this4, resources, operatorList, task).then(function () {
          return translated;
        }).catch(function (reason) {
          _this4.handler.send('UnsupportedFeature', {
            featureId: _util.UNSUPPORTED_FEATURES.font
          });

          return new TranslatedFont('g_font_error', new _fonts.ErrorFont('Type3 font load error: ' + reason), translated.font);
        });
      }).then(function (translated) {
        state.font = translated.font;
        translated.send(_this4.handler);
        return translated.loadedName;
      });
    },
    handleText: function handleText(chars, state) {
      var font = state.font;
      var glyphs = font.charsToGlyphs(chars);

      if (font.data) {
        var isAddToPathSet = !!(state.textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG);

        if (isAddToPathSet || state.fillColorSpace.name === 'Pattern' || font.disableFontFace || this.options.disableFontFace) {
          PartialEvaluator.buildFontPaths(font, glyphs, this.handler);
        }
      }

      return glyphs;
    },
    setGState: function PartialEvaluator_setGState(resources, gState, operatorList, task, stateManager) {
      var _this5 = this;

      var gStateObj = [];
      var gStateKeys = gState.getKeys();
      var promise = Promise.resolve();

      var _loop = function _loop() {
        var key = gStateKeys[i];
        var value = gState.get(key);

        switch (key) {
          case 'Type':
            break;

          case 'LW':
          case 'LC':
          case 'LJ':
          case 'ML':
          case 'D':
          case 'RI':
          case 'FL':
          case 'CA':
          case 'ca':
            gStateObj.push([key, value]);
            break;

          case 'Font':
            promise = promise.then(function () {
              return _this5.handleSetFont(resources, null, value[0], operatorList, task, stateManager.state).then(function (loadedName) {
                operatorList.addDependency(loadedName);
                gStateObj.push([key, [loadedName, value[1]]]);
              });
            });
            break;

          case 'BM':
            gStateObj.push([key, normalizeBlendMode(value)]);
            break;

          case 'SMask':
            if ((0, _primitives.isName)(value, 'None')) {
              gStateObj.push([key, false]);
              break;
            }

            if ((0, _primitives.isDict)(value)) {
              promise = promise.then(function () {
                return _this5.handleSMask(value, resources, operatorList, task, stateManager);
              });
              gStateObj.push([key, true]);
            } else {
              (0, _util.warn)('Unsupported SMask type');
            }

            break;

          case 'OP':
          case 'op':
          case 'OPM':
          case 'BG':
          case 'BG2':
          case 'UCR':
          case 'UCR2':
          case 'TR':
          case 'TR2':
          case 'HT':
          case 'SM':
          case 'SA':
          case 'AIS':
          case 'TK':
            (0, _util.info)('graphic state operator ' + key);
            break;

          default:
            (0, _util.info)('Unknown graphic state operator ' + key);
            break;
        }
      };

      for (var i = 0, ii = gStateKeys.length; i < ii; i++) {
        _loop();
      }

      return promise.then(function () {
        if (gStateObj.length > 0) {
          operatorList.addOp(_util.OPS.setGState, [gStateObj]);
        }
      });
    },
    loadFont: function PartialEvaluator_loadFont(fontName, font, resources) {
      var _this6 = this;

      function errorFont() {
        return Promise.resolve(new TranslatedFont('g_font_error', new _fonts.ErrorFont('Font ' + fontName + ' is not available'), font));
      }

      var fontRef,
          xref = this.xref;

      if (font) {
        if (!(0, _primitives.isRef)(font)) {
          throw new Error('The "font" object should be a reference.');
        }

        fontRef = font;
      } else {
        var fontRes = resources.get('Font');

        if (fontRes) {
          fontRef = fontRes.getRaw(fontName);
        } else {
          (0, _util.warn)('fontRes not available');
          return errorFont();
        }
      }

      if (!fontRef) {
        (0, _util.warn)('fontRef not available');
        return errorFont();
      }

      if (this.fontCache.has(fontRef)) {
        return this.fontCache.get(fontRef);
      }

      font = xref.fetchIfRef(fontRef);

      if (!(0, _primitives.isDict)(font)) {
        return errorFont();
      }

      if (font.translated) {
        return font.translated;
      }

      var fontCapability = (0, _util.createPromiseCapability)();
      var preEvaluatedFont = this.preEvaluateFont(font);
      var descriptor = preEvaluatedFont.descriptor;
      var fontRefIsRef = (0, _primitives.isRef)(fontRef),
          fontID;

      if (fontRefIsRef) {
        fontID = fontRef.toString();
      }

      if ((0, _primitives.isDict)(descriptor)) {
        if (!descriptor.fontAliases) {
          descriptor.fontAliases = Object.create(null);
        }

        var fontAliases = descriptor.fontAliases;
        var hash = preEvaluatedFont.hash;

        if (fontAliases[hash]) {
          var aliasFontRef = fontAliases[hash].aliasRef;

          if (fontRefIsRef && aliasFontRef && this.fontCache.has(aliasFontRef)) {
            this.fontCache.putAlias(fontRef, aliasFontRef);
            return this.fontCache.get(fontRef);
          }
        } else {
          fontAliases[hash] = {
            fontID: _fonts.Font.getFontID()
          };
        }

        if (fontRefIsRef) {
          fontAliases[hash].aliasRef = fontRef;
        }

        fontID = fontAliases[hash].fontID;
      }

      if (fontRefIsRef) {
        this.fontCache.put(fontRef, fontCapability.promise);
      } else {
        if (!fontID) {
          fontID = this.idFactory.createObjId();
        }

        this.fontCache.put('id_' + fontID, fontCapability.promise);
      }

      (0, _util.assert)(fontID, 'The "fontID" must be defined.');
      font.loadedName = 'g_' + this.pdfManager.docId + '_f' + fontID;
      font.translated = fontCapability.promise;
      var translatedPromise;

      try {
        translatedPromise = this.translateFont(preEvaluatedFont);
      } catch (e) {
        translatedPromise = Promise.reject(e);
      }

      translatedPromise.then(function (translatedFont) {
        if (translatedFont.fontType !== undefined) {
          var xrefFontStats = xref.stats.fontTypes;
          xrefFontStats[translatedFont.fontType] = true;
        }

        fontCapability.resolve(new TranslatedFont(font.loadedName, translatedFont, font));
      }).catch(function (reason) {
        _this6.handler.send('UnsupportedFeature', {
          featureId: _util.UNSUPPORTED_FEATURES.font
        });

        try {
          var descriptor = preEvaluatedFont.descriptor;
          var fontFile3 = descriptor && descriptor.get('FontFile3');
          var subtype = fontFile3 && fontFile3.get('Subtype');
          var fontType = (0, _fonts.getFontType)(preEvaluatedFont.type, subtype && subtype.name);
          var xrefFontStats = xref.stats.fontTypes;
          xrefFontStats[fontType] = true;
        } catch (ex) {}

        fontCapability.resolve(new TranslatedFont(font.loadedName, new _fonts.ErrorFont(reason instanceof Error ? reason.message : reason), font));
      });
      return fontCapability.promise;
    },
    buildPath: function PartialEvaluator_buildPath(operatorList, fn, args) {
      var lastIndex = operatorList.length - 1;

      if (!args) {
        args = [];
      }

      if (lastIndex < 0 || operatorList.fnArray[lastIndex] !== _util.OPS.constructPath) {
        operatorList.addOp(_util.OPS.constructPath, [[fn], args]);
      } else {
        var opArgs = operatorList.argsArray[lastIndex];
        opArgs[0].push(fn);
        Array.prototype.push.apply(opArgs[1], args);
      }
    },
    handleColorN: function PartialEvaluator_handleColorN(operatorList, fn, args, cs, patterns, resources, task) {
      var patternName = args[args.length - 1];
      var pattern;

      if ((0, _primitives.isName)(patternName) && (pattern = patterns.get(patternName.name))) {
        var dict = (0, _primitives.isStream)(pattern) ? pattern.dict : pattern;
        var typeNum = dict.get('PatternType');

        if (typeNum === TILING_PATTERN) {
          var color = cs.base ? cs.base.getRgb(args, 0) : null;
          return this.handleTilingType(fn, color, resources, pattern, dict, operatorList, task);
        } else if (typeNum === SHADING_PATTERN) {
          var shading = dict.get('Shading');
          var matrix = dict.getArray('Matrix');
          pattern = _pattern.Pattern.parseShading(shading, matrix, this.xref, resources, this.handler, this.pdfFunctionFactory);
          operatorList.addOp(fn, pattern.getIR());
          return Promise.resolve();
        }

        return Promise.reject(new Error('Unknown PatternType: ' + typeNum));
      }

      operatorList.addOp(fn, args);
      return Promise.resolve();
    },
    getOperatorList: function getOperatorList(_ref6) {
      var _this7 = this;

      var stream = _ref6.stream,
          task = _ref6.task,
          resources = _ref6.resources,
          operatorList = _ref6.operatorList,
          _ref6$initialState = _ref6.initialState,
          initialState = _ref6$initialState === void 0 ? null : _ref6$initialState;
      resources = resources || _primitives.Dict.empty;
      initialState = initialState || new EvalState();

      if (!operatorList) {
        throw new Error('getOperatorList: missing "operatorList" parameter');
      }

      var self = this;
      var xref = this.xref;
      var imageCache = Object.create(null);

      var xobjs = resources.get('XObject') || _primitives.Dict.empty;

      var patterns = resources.get('Pattern') || _primitives.Dict.empty;

      var stateManager = new StateManager(initialState);
      var preprocessor = new EvaluatorPreprocessor(stream, xref, stateManager);
      var timeSlotManager = new TimeSlotManager();

      function closePendingRestoreOPS(argument) {
        for (var i = 0, ii = preprocessor.savedStatesDepth; i < ii; i++) {
          operatorList.addOp(_util.OPS.restore, []);
        }
      }

      return new Promise(function promiseBody(resolve, reject) {
        var next = function next(promise) {
          promise.then(function () {
            try {
              promiseBody(resolve, reject);
            } catch (ex) {
              reject(ex);
            }
          }, reject);
        };

        task.ensureNotTerminated();
        timeSlotManager.reset();
        var stop,
            operation = {},
            i,
            ii,
            cs;

        while (!(stop = timeSlotManager.check())) {
          operation.args = null;

          if (!preprocessor.read(operation)) {
            break;
          }

          var args = operation.args;
          var fn = operation.fn;

          switch (fn | 0) {
            case _util.OPS.paintXObject:
              var name = args[0].name;

              if (name && imageCache[name] !== undefined) {
                operatorList.addOp(imageCache[name].fn, imageCache[name].args);
                args = null;
                continue;
              }

              next(new Promise(function (resolveXObject, rejectXObject) {
                if (!name) {
                  throw new _util.FormatError('XObject must be referred to by name.');
                }

                var xobj = xobjs.get(name);

                if (!xobj) {
                  operatorList.addOp(fn, args);
                  resolveXObject();
                  return;
                }

                if (!(0, _primitives.isStream)(xobj)) {
                  throw new _util.FormatError('XObject should be a stream');
                }

                var type = xobj.dict.get('Subtype');

                if (!(0, _primitives.isName)(type)) {
                  throw new _util.FormatError('XObject should have a Name subtype');
                }

                if (type.name === 'Form') {
                  stateManager.save();
                  self.buildFormXObject(resources, xobj, null, operatorList, task, stateManager.state.clone()).then(function () {
                    stateManager.restore();
                    resolveXObject();
                  }, rejectXObject);
                  return;
                } else if (type.name === 'Image') {
                  self.buildPaintImageXObject({
                    resources: resources,
                    image: xobj,
                    operatorList: operatorList,
                    cacheKey: name,
                    imageCache: imageCache
                  }).then(resolveXObject, rejectXObject);
                  return;
                } else if (type.name === 'PS') {
                  (0, _util.info)('Ignored XObject subtype PS');
                } else {
                  throw new _util.FormatError("Unhandled XObject subtype ".concat(type.name));
                }

                resolveXObject();
              }).catch(function (reason) {
                if (self.options.ignoreErrors) {
                  self.handler.send('UnsupportedFeature', {
                    featureId: _util.UNSUPPORTED_FEATURES.unknown
                  });
                  (0, _util.warn)("getOperatorList - ignoring XObject: \"".concat(reason, "\"."));
                  return;
                }

                throw reason;
              }));
              return;

            case _util.OPS.setFont:
              var fontSize = args[1];
              next(self.handleSetFont(resources, args, null, operatorList, task, stateManager.state).then(function (loadedName) {
                operatorList.addDependency(loadedName);
                operatorList.addOp(_util.OPS.setFont, [loadedName, fontSize]);
              }));
              return;

            case _util.OPS.endInlineImage:
              var cacheKey = args[0].cacheKey;

              if (cacheKey) {
                var cacheEntry = imageCache[cacheKey];

                if (cacheEntry !== undefined) {
                  operatorList.addOp(cacheEntry.fn, cacheEntry.args);
                  args = null;
                  continue;
                }
              }

              next(self.buildPaintImageXObject({
                resources: resources,
                image: args[0],
                isInline: true,
                operatorList: operatorList,
                cacheKey: cacheKey,
                imageCache: imageCache
              }));
              return;

            case _util.OPS.showText:
              args[0] = self.handleText(args[0], stateManager.state);
              break;

            case _util.OPS.showSpacedText:
              var arr = args[0];
              var combinedGlyphs = [];
              var arrLength = arr.length;
              var state = stateManager.state;

              for (i = 0; i < arrLength; ++i) {
                var arrItem = arr[i];

                if ((0, _util.isString)(arrItem)) {
                  Array.prototype.push.apply(combinedGlyphs, self.handleText(arrItem, state));
                } else if ((0, _util.isNum)(arrItem)) {
                  combinedGlyphs.push(arrItem);
                }
              }

              args[0] = combinedGlyphs;
              fn = _util.OPS.showText;
              break;

            case _util.OPS.nextLineShowText:
              operatorList.addOp(_util.OPS.nextLine);
              args[0] = self.handleText(args[0], stateManager.state);
              fn = _util.OPS.showText;
              break;

            case _util.OPS.nextLineSetSpacingShowText:
              operatorList.addOp(_util.OPS.nextLine);
              operatorList.addOp(_util.OPS.setWordSpacing, [args.shift()]);
              operatorList.addOp(_util.OPS.setCharSpacing, [args.shift()]);
              args[0] = self.handleText(args[0], stateManager.state);
              fn = _util.OPS.showText;
              break;

            case _util.OPS.setTextRenderingMode:
              stateManager.state.textRenderingMode = args[0];
              break;

            case _util.OPS.setFillColorSpace:
              stateManager.state.fillColorSpace = _colorspace.ColorSpace.parse(args[0], xref, resources, self.pdfFunctionFactory);
              continue;

            case _util.OPS.setStrokeColorSpace:
              stateManager.state.strokeColorSpace = _colorspace.ColorSpace.parse(args[0], xref, resources, self.pdfFunctionFactory);
              continue;

            case _util.OPS.setFillColor:
              cs = stateManager.state.fillColorSpace;
              args = cs.getRgb(args, 0);
              fn = _util.OPS.setFillRGBColor;
              break;

            case _util.OPS.setStrokeColor:
              cs = stateManager.state.strokeColorSpace;
              args = cs.getRgb(args, 0);
              fn = _util.OPS.setStrokeRGBColor;
              break;

            case _util.OPS.setFillGray:
              stateManager.state.fillColorSpace = _colorspace.ColorSpace.singletons.gray;
              args = _colorspace.ColorSpace.singletons.gray.getRgb(args, 0);
              fn = _util.OPS.setFillRGBColor;
              break;

            case _util.OPS.setStrokeGray:
              stateManager.state.strokeColorSpace = _colorspace.ColorSpace.singletons.gray;
              args = _colorspace.ColorSpace.singletons.gray.getRgb(args, 0);
              fn = _util.OPS.setStrokeRGBColor;
              break;

            case _util.OPS.setFillCMYKColor:
              stateManager.state.fillColorSpace = _colorspace.ColorSpace.singletons.cmyk;
              args = _colorspace.ColorSpace.singletons.cmyk.getRgb(args, 0);
              fn = _util.OPS.setFillRGBColor;
              break;

            case _util.OPS.setStrokeCMYKColor:
              stateManager.state.strokeColorSpace = _colorspace.ColorSpace.singletons.cmyk;
              args = _colorspace.ColorSpace.singletons.cmyk.getRgb(args, 0);
              fn = _util.OPS.setStrokeRGBColor;
              break;

            case _util.OPS.setFillRGBColor:
              stateManager.state.fillColorSpace = _colorspace.ColorSpace.singletons.rgb;
              args = _colorspace.ColorSpace.singletons.rgb.getRgb(args, 0);
              break;

            case _util.OPS.setStrokeRGBColor:
              stateManager.state.strokeColorSpace = _colorspace.ColorSpace.singletons.rgb;
              args = _colorspace.ColorSpace.singletons.rgb.getRgb(args, 0);
              break;

            case _util.OPS.setFillColorN:
              cs = stateManager.state.fillColorSpace;

              if (cs.name === 'Pattern') {
                next(self.handleColorN(operatorList, _util.OPS.setFillColorN, args, cs, patterns, resources, task));
                return;
              }

              args = cs.getRgb(args, 0);
              fn = _util.OPS.setFillRGBColor;
              break;

            case _util.OPS.setStrokeColorN:
              cs = stateManager.state.strokeColorSpace;

              if (cs.name === 'Pattern') {
                next(self.handleColorN(operatorList, _util.OPS.setStrokeColorN, args, cs, patterns, resources, task));
                return;
              }

              args = cs.getRgb(args, 0);
              fn = _util.OPS.setStrokeRGBColor;
              break;

            case _util.OPS.shadingFill:
              var shadingRes = resources.get('Shading');

              if (!shadingRes) {
                throw new _util.FormatError('No shading resource found');
              }

              var shading = shadingRes.get(args[0].name);

              if (!shading) {
                throw new _util.FormatError('No shading object found');
              }

              var shadingFill = _pattern.Pattern.parseShading(shading, null, xref, resources, self.handler, self.pdfFunctionFactory);

              var patternIR = shadingFill.getIR();
              args = [patternIR];
              fn = _util.OPS.shadingFill;
              break;

            case _util.OPS.setGState:
              var dictName = args[0];
              var extGState = resources.get('ExtGState');

              if (!(0, _primitives.isDict)(extGState) || !extGState.has(dictName.name)) {
                break;
              }

              var gState = extGState.get(dictName.name);
              next(self.setGState(resources, gState, operatorList, task, stateManager));
              return;

            case _util.OPS.moveTo:
            case _util.OPS.lineTo:
            case _util.OPS.curveTo:
            case _util.OPS.curveTo2:
            case _util.OPS.curveTo3:
            case _util.OPS.closePath:
              self.buildPath(operatorList, fn, args);
              continue;

            case _util.OPS.rectangle:
              self.buildPath(operatorList, fn, args);
              continue;

            case _util.OPS.markPoint:
            case _util.OPS.markPointProps:
            case _util.OPS.beginMarkedContent:
            case _util.OPS.beginMarkedContentProps:
            case _util.OPS.endMarkedContent:
            case _util.OPS.beginCompat:
            case _util.OPS.endCompat:
              continue;

            default:
              if (args !== null) {
                for (i = 0, ii = args.length; i < ii; i++) {
                  if (args[i] instanceof _primitives.Dict) {
                    break;
                  }
                }

                if (i < ii) {
                  (0, _util.warn)('getOperatorList - ignoring operator: ' + fn);
                  continue;
                }
              }

          }

          operatorList.addOp(fn, args);
        }

        if (stop) {
          next(deferred);
          return;
        }

        closePendingRestoreOPS();
        resolve();
      }).catch(function (reason) {
        if (_this7.options.ignoreErrors) {
          _this7.handler.send('UnsupportedFeature', {
            featureId: _util.UNSUPPORTED_FEATURES.unknown
          });

          (0, _util.warn)("getOperatorList - ignoring errors during \"".concat(task.name, "\" ") + "task: \"".concat(reason, "\"."));
          closePendingRestoreOPS();
          return;
        }

        throw reason;
      });
    },
    getTextContent: function getTextContent(_ref7) {
      var _this8 = this;

      var stream = _ref7.stream,
          task = _ref7.task,
          resources = _ref7.resources,
          _ref7$stateManager = _ref7.stateManager,
          stateManager = _ref7$stateManager === void 0 ? null : _ref7$stateManager,
          _ref7$normalizeWhites = _ref7.normalizeWhitespace,
          normalizeWhitespace = _ref7$normalizeWhites === void 0 ? false : _ref7$normalizeWhites,
          _ref7$combineTextItem = _ref7.combineTextItems,
          combineTextItems = _ref7$combineTextItem === void 0 ? false : _ref7$combineTextItem,
          sink = _ref7.sink,
          _ref7$seenStyles = _ref7.seenStyles,
          seenStyles = _ref7$seenStyles === void 0 ? Object.create(null) : _ref7$seenStyles;
      resources = resources || _primitives.Dict.empty;
      stateManager = stateManager || new StateManager(new TextState());
      var WhitespaceRegexp = /\s/g;
      var textContent = {
        items: [],
        styles: Object.create(null)
      };
      var textContentItem = {
        initialized: false,
        str: [],
        width: 0,
        height: 0,
        vertical: false,
        lastAdvanceWidth: 0,
        lastAdvanceHeight: 0,
        textAdvanceScale: 0,
        spaceWidth: 0,
        fakeSpaceMin: Infinity,
        fakeMultiSpaceMin: Infinity,
        fakeMultiSpaceMax: -0,
        textRunBreakAllowed: false,
        transform: null,
        fontName: null
      };
      var SPACE_FACTOR = 0.3;
      var MULTI_SPACE_FACTOR = 1.5;
      var MULTI_SPACE_FACTOR_MAX = 4;
      var self = this;
      var xref = this.xref;
      var xobjs = null;
      var skipEmptyXObjs = Object.create(null);
      var preprocessor = new EvaluatorPreprocessor(stream, xref, stateManager);
      var textState;

      function ensureTextContentItem() {
        if (textContentItem.initialized) {
          return textContentItem;
        }

        var font = textState.font;

        if (!(font.loadedName in seenStyles)) {
          seenStyles[font.loadedName] = true;
          textContent.styles[font.loadedName] = {
            fontFamily: font.fallbackName,
            ascent: font.ascent,
            descent: font.descent,
            vertical: !!font.vertical
          };
        }

        textContentItem.fontName = font.loadedName;
        var tsm = [textState.fontSize * textState.textHScale, 0, 0, textState.fontSize, 0, textState.textRise];

        if (font.isType3Font && textState.fontMatrix !== _util.FONT_IDENTITY_MATRIX && textState.fontSize === 1) {
          var glyphHeight = font.bbox[3] - font.bbox[1];

          if (glyphHeight > 0) {
            glyphHeight = glyphHeight * textState.fontMatrix[3];
            tsm[3] *= glyphHeight;
          }
        }

        var trm = _util.Util.transform(textState.ctm, _util.Util.transform(textState.textMatrix, tsm));

        textContentItem.transform = trm;

        if (!font.vertical) {
          textContentItem.width = 0;
          textContentItem.height = Math.sqrt(trm[2] * trm[2] + trm[3] * trm[3]);
          textContentItem.vertical = false;
        } else {
          textContentItem.width = Math.sqrt(trm[0] * trm[0] + trm[1] * trm[1]);
          textContentItem.height = 0;
          textContentItem.vertical = true;
        }

        var a = textState.textLineMatrix[0];
        var b = textState.textLineMatrix[1];
        var scaleLineX = Math.sqrt(a * a + b * b);
        a = textState.ctm[0];
        b = textState.ctm[1];
        var scaleCtmX = Math.sqrt(a * a + b * b);
        textContentItem.textAdvanceScale = scaleCtmX * scaleLineX;
        textContentItem.lastAdvanceWidth = 0;
        textContentItem.lastAdvanceHeight = 0;
        var spaceWidth = font.spaceWidth / 1000 * textState.fontSize;

        if (spaceWidth) {
          textContentItem.spaceWidth = spaceWidth;
          textContentItem.fakeSpaceMin = spaceWidth * SPACE_FACTOR;
          textContentItem.fakeMultiSpaceMin = spaceWidth * MULTI_SPACE_FACTOR;
          textContentItem.fakeMultiSpaceMax = spaceWidth * MULTI_SPACE_FACTOR_MAX;
          textContentItem.textRunBreakAllowed = !font.isMonospace;
        } else {
          textContentItem.spaceWidth = 0;
          textContentItem.fakeSpaceMin = Infinity;
          textContentItem.fakeMultiSpaceMin = Infinity;
          textContentItem.fakeMultiSpaceMax = 0;
          textContentItem.textRunBreakAllowed = false;
        }

        textContentItem.initialized = true;
        return textContentItem;
      }

      function replaceWhitespace(str) {
        var i = 0,
            ii = str.length,
            code;

        while (i < ii && (code = str.charCodeAt(i)) >= 0x20 && code <= 0x7F) {
          i++;
        }

        return i < ii ? str.replace(WhitespaceRegexp, ' ') : str;
      }

      function runBidiTransform(textChunk) {
        var str = textChunk.str.join('');
        var bidiResult = (0, _bidi.bidi)(str, -1, textChunk.vertical);
        return {
          str: normalizeWhitespace ? replaceWhitespace(bidiResult.str) : bidiResult.str,
          dir: bidiResult.dir,
          width: textChunk.width,
          height: textChunk.height,
          transform: textChunk.transform,
          fontName: textChunk.fontName
        };
      }

      function handleSetFont(fontName, fontRef) {
        return self.loadFont(fontName, fontRef, resources).then(function (translated) {
          textState.font = translated.font;
          textState.fontMatrix = translated.font.fontMatrix || _util.FONT_IDENTITY_MATRIX;
        });
      }

      function buildTextContentItem(chars) {
        var font = textState.font;
        var textChunk = ensureTextContentItem();
        var width = 0;
        var height = 0;
        var glyphs = font.charsToGlyphs(chars);

        for (var i = 0; i < glyphs.length; i++) {
          var glyph = glyphs[i];
          var glyphWidth = null;

          if (font.vertical && glyph.vmetric) {
            glyphWidth = glyph.vmetric[0];
          } else {
            glyphWidth = glyph.width;
          }

          var glyphUnicode = glyph.unicode;
          var NormalizedUnicodes = (0, _unicode.getNormalizedUnicodes)();

          if (NormalizedUnicodes[glyphUnicode] !== undefined) {
            glyphUnicode = NormalizedUnicodes[glyphUnicode];
          }

          glyphUnicode = (0, _unicode.reverseIfRtl)(glyphUnicode);
          var charSpacing = textState.charSpacing;

          if (glyph.isSpace) {
            var wordSpacing = textState.wordSpacing;
            charSpacing += wordSpacing;

            if (wordSpacing > 0) {
              addFakeSpaces(wordSpacing, textChunk.str);
            }
          }

          var tx = 0;
          var ty = 0;

          if (!font.vertical) {
            var w0 = glyphWidth * textState.fontMatrix[0];
            tx = (w0 * textState.fontSize + charSpacing) * textState.textHScale;
            width += tx;
          } else {
            var w1 = glyphWidth * textState.fontMatrix[0];
            ty = w1 * textState.fontSize + charSpacing;
            height += ty;
          }

          textState.translateTextMatrix(tx, ty);
          textChunk.str.push(glyphUnicode);
        }

        if (!font.vertical) {
          textChunk.lastAdvanceWidth = width;
          textChunk.width += width;
        } else {
          textChunk.lastAdvanceHeight = height;
          textChunk.height += Math.abs(height);
        }

        return textChunk;
      }

      function addFakeSpaces(width, strBuf) {
        if (width < textContentItem.fakeSpaceMin) {
          return;
        }

        if (width < textContentItem.fakeMultiSpaceMin) {
          strBuf.push(' ');
          return;
        }

        var fakeSpaces = Math.round(width / textContentItem.spaceWidth);

        while (fakeSpaces-- > 0) {
          strBuf.push(' ');
        }
      }

      function flushTextContentItem() {
        if (!textContentItem.initialized) {
          return;
        }

        if (!textContentItem.vertical) {
          textContentItem.width *= textContentItem.textAdvanceScale;
        } else {
          textContentItem.height *= textContentItem.textAdvanceScale;
        }

        textContent.items.push(runBidiTransform(textContentItem));
        textContentItem.initialized = false;
        textContentItem.str.length = 0;
      }

      function enqueueChunk() {
        var length = textContent.items.length;

        if (length > 0) {
          sink.enqueue(textContent, length);
          textContent.items = [];
          textContent.styles = Object.create(null);
        }
      }

      var timeSlotManager = new TimeSlotManager();
      return new Promise(function promiseBody(resolve, reject) {
        var next = function next(promise) {
          enqueueChunk();
          Promise.all([promise, sink.ready]).then(function () {
            try {
              promiseBody(resolve, reject);
            } catch (ex) {
              reject(ex);
            }
          }, reject);
        };

        task.ensureNotTerminated();
        timeSlotManager.reset();
        var stop,
            operation = {},
            args = [];

        while (!(stop = timeSlotManager.check())) {
          args.length = 0;
          operation.args = args;

          if (!preprocessor.read(operation)) {
            break;
          }

          textState = stateManager.state;
          var fn = operation.fn;
          args = operation.args;
          var advance, diff;

          switch (fn | 0) {
            case _util.OPS.setFont:
              var fontNameArg = args[0].name,
                  fontSizeArg = args[1];

              if (textState.font && fontNameArg === textState.fontName && fontSizeArg === textState.fontSize) {
                break;
              }

              flushTextContentItem();
              textState.fontName = fontNameArg;
              textState.fontSize = fontSizeArg;
              next(handleSetFont(fontNameArg, null));
              return;

            case _util.OPS.setTextRise:
              flushTextContentItem();
              textState.textRise = args[0];
              break;

            case _util.OPS.setHScale:
              flushTextContentItem();
              textState.textHScale = args[0] / 100;
              break;

            case _util.OPS.setLeading:
              flushTextContentItem();
              textState.leading = args[0];
              break;

            case _util.OPS.moveText:
              var isSameTextLine = !textState.font ? false : (textState.font.vertical ? args[0] : args[1]) === 0;
              advance = args[0] - args[1];

              if (combineTextItems && isSameTextLine && textContentItem.initialized && advance > 0 && advance <= textContentItem.fakeMultiSpaceMax) {
                textState.translateTextLineMatrix(args[0], args[1]);
                textContentItem.width += args[0] - textContentItem.lastAdvanceWidth;
                textContentItem.height += args[1] - textContentItem.lastAdvanceHeight;
                diff = args[0] - textContentItem.lastAdvanceWidth - (args[1] - textContentItem.lastAdvanceHeight);
                addFakeSpaces(diff, textContentItem.str);
                break;
              }

              flushTextContentItem();
              textState.translateTextLineMatrix(args[0], args[1]);
              textState.textMatrix = textState.textLineMatrix.slice();
              break;

            case _util.OPS.setLeadingMoveText:
              flushTextContentItem();
              textState.leading = -args[1];
              textState.translateTextLineMatrix(args[0], args[1]);
              textState.textMatrix = textState.textLineMatrix.slice();
              break;

            case _util.OPS.nextLine:
              flushTextContentItem();
              textState.carriageReturn();
              break;

            case _util.OPS.setTextMatrix:
              advance = textState.calcTextLineMatrixAdvance(args[0], args[1], args[2], args[3], args[4], args[5]);

              if (combineTextItems && advance !== null && textContentItem.initialized && advance.value > 0 && advance.value <= textContentItem.fakeMultiSpaceMax) {
                textState.translateTextLineMatrix(advance.width, advance.height);
                textContentItem.width += advance.width - textContentItem.lastAdvanceWidth;
                textContentItem.height += advance.height - textContentItem.lastAdvanceHeight;
                diff = advance.width - textContentItem.lastAdvanceWidth - (advance.height - textContentItem.lastAdvanceHeight);
                addFakeSpaces(diff, textContentItem.str);
                break;
              }

              flushTextContentItem();
              textState.setTextMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
              textState.setTextLineMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
              break;

            case _util.OPS.setCharSpacing:
              textState.charSpacing = args[0];
              break;

            case _util.OPS.setWordSpacing:
              textState.wordSpacing = args[0];
              break;

            case _util.OPS.beginText:
              flushTextContentItem();
              textState.textMatrix = _util.IDENTITY_MATRIX.slice();
              textState.textLineMatrix = _util.IDENTITY_MATRIX.slice();
              break;

            case _util.OPS.showSpacedText:
              var items = args[0];
              var offset;

              for (var j = 0, jj = items.length; j < jj; j++) {
                if (typeof items[j] === 'string') {
                  buildTextContentItem(items[j]);
                } else if ((0, _util.isNum)(items[j])) {
                  ensureTextContentItem();
                  advance = items[j] * textState.fontSize / 1000;
                  var breakTextRun = false;

                  if (textState.font.vertical) {
                    offset = advance;
                    textState.translateTextMatrix(0, offset);
                    breakTextRun = textContentItem.textRunBreakAllowed && advance > textContentItem.fakeMultiSpaceMax;

                    if (!breakTextRun) {
                      textContentItem.height += offset;
                    }
                  } else {
                    advance = -advance;
                    offset = advance * textState.textHScale;
                    textState.translateTextMatrix(offset, 0);
                    breakTextRun = textContentItem.textRunBreakAllowed && advance > textContentItem.fakeMultiSpaceMax;

                    if (!breakTextRun) {
                      textContentItem.width += offset;
                    }
                  }

                  if (breakTextRun) {
                    flushTextContentItem();
                  } else if (advance > 0) {
                    addFakeSpaces(advance, textContentItem.str);
                  }
                }
              }

              break;

            case _util.OPS.showText:
              buildTextContentItem(args[0]);
              break;

            case _util.OPS.nextLineShowText:
              flushTextContentItem();
              textState.carriageReturn();
              buildTextContentItem(args[0]);
              break;

            case _util.OPS.nextLineSetSpacingShowText:
              flushTextContentItem();
              textState.wordSpacing = args[0];
              textState.charSpacing = args[1];
              textState.carriageReturn();
              buildTextContentItem(args[2]);
              break;

            case _util.OPS.paintXObject:
              flushTextContentItem();

              if (!xobjs) {
                xobjs = resources.get('XObject') || _primitives.Dict.empty;
              }

              var name = args[0].name;

              if (name && skipEmptyXObjs[name] !== undefined) {
                break;
              }

              next(new Promise(function (resolveXObject, rejectXObject) {
                if (!name) {
                  throw new _util.FormatError('XObject must be referred to by name.');
                }

                var xobj = xobjs.get(name);

                if (!xobj) {
                  resolveXObject();
                  return;
                }

                if (!(0, _primitives.isStream)(xobj)) {
                  throw new _util.FormatError('XObject should be a stream');
                }

                var type = xobj.dict.get('Subtype');

                if (!(0, _primitives.isName)(type)) {
                  throw new _util.FormatError('XObject should have a Name subtype');
                }

                if (type.name !== 'Form') {
                  skipEmptyXObjs[name] = true;
                  resolveXObject();
                  return;
                }

                var currentState = stateManager.state.clone();
                var xObjStateManager = new StateManager(currentState);
                var matrix = xobj.dict.getArray('Matrix');

                if (Array.isArray(matrix) && matrix.length === 6) {
                  xObjStateManager.transform(matrix);
                }

                enqueueChunk();
                var sinkWrapper = {
                  enqueueInvoked: false,
                  enqueue: function enqueue(chunk, size) {
                    this.enqueueInvoked = true;
                    sink.enqueue(chunk, size);
                  },

                  get desiredSize() {
                    return sink.desiredSize;
                  },

                  get ready() {
                    return sink.ready;
                  }

                };
                self.getTextContent({
                  stream: xobj,
                  task: task,
                  resources: xobj.dict.get('Resources') || resources,
                  stateManager: xObjStateManager,
                  normalizeWhitespace: normalizeWhitespace,
                  combineTextItems: combineTextItems,
                  sink: sinkWrapper,
                  seenStyles: seenStyles
                }).then(function () {
                  if (!sinkWrapper.enqueueInvoked) {
                    skipEmptyXObjs[name] = true;
                  }

                  resolveXObject();
                }, rejectXObject);
              }).catch(function (reason) {
                if (reason instanceof _util.AbortException) {
                  return;
                }

                if (self.options.ignoreErrors) {
                  (0, _util.warn)("getTextContent - ignoring XObject: \"".concat(reason, "\"."));
                  return;
                }

                throw reason;
              }));
              return;

            case _util.OPS.setGState:
              flushTextContentItem();
              var dictName = args[0];
              var extGState = resources.get('ExtGState');

              if (!(0, _primitives.isDict)(extGState) || !(0, _primitives.isName)(dictName)) {
                break;
              }

              var gState = extGState.get(dictName.name);

              if (!(0, _primitives.isDict)(gState)) {
                break;
              }

              var gStateFont = gState.get('Font');

              if (gStateFont) {
                textState.fontName = null;
                textState.fontSize = gStateFont[1];
                next(handleSetFont(null, gStateFont[0]));
                return;
              }

              break;
          }

          if (textContent.items.length >= sink.desiredSize) {
            stop = true;
            break;
          }
        }

        if (stop) {
          next(deferred);
          return;
        }

        flushTextContentItem();
        enqueueChunk();
        resolve();
      }).catch(function (reason) {
        if (reason instanceof _util.AbortException) {
          return;
        }

        if (_this8.options.ignoreErrors) {
          (0, _util.warn)("getTextContent - ignoring errors during \"".concat(task.name, "\" ") + "task: \"".concat(reason, "\"."));
          flushTextContentItem();
          enqueueChunk();
          return;
        }

        throw reason;
      });
    },
    extractDataStructures: function PartialEvaluator_extractDataStructures(dict, baseDict, properties) {
      var _this9 = this;

      var xref = this.xref;
      var toUnicode = dict.get('ToUnicode') || baseDict.get('ToUnicode');
      var toUnicodePromise = toUnicode ? this.readToUnicode(toUnicode) : Promise.resolve(undefined);

      if (properties.composite) {
        var cidSystemInfo = dict.get('CIDSystemInfo');

        if ((0, _primitives.isDict)(cidSystemInfo)) {
          properties.cidSystemInfo = {
            registry: (0, _util.stringToPDFString)(cidSystemInfo.get('Registry')),
            ordering: (0, _util.stringToPDFString)(cidSystemInfo.get('Ordering')),
            supplement: cidSystemInfo.get('Supplement')
          };
        }

        var cidToGidMap = dict.get('CIDToGIDMap');

        if ((0, _primitives.isStream)(cidToGidMap)) {
          properties.cidToGidMap = this.readCidToGidMap(cidToGidMap);
        }
      }

      var differences = [];
      var baseEncodingName = null;
      var encoding;

      if (dict.has('Encoding')) {
        encoding = dict.get('Encoding');

        if ((0, _primitives.isDict)(encoding)) {
          baseEncodingName = encoding.get('BaseEncoding');
          baseEncodingName = (0, _primitives.isName)(baseEncodingName) ? baseEncodingName.name : null;

          if (encoding.has('Differences')) {
            var diffEncoding = encoding.get('Differences');
            var index = 0;

            for (var j = 0, jj = diffEncoding.length; j < jj; j++) {
              var data = xref.fetchIfRef(diffEncoding[j]);

              if ((0, _util.isNum)(data)) {
                index = data;
              } else if ((0, _primitives.isName)(data)) {
                differences[index++] = data.name;
              } else {
                throw new _util.FormatError("Invalid entry in 'Differences' array: ".concat(data));
              }
            }
          }
        } else if ((0, _primitives.isName)(encoding)) {
          baseEncodingName = encoding.name;
        } else {
          throw new _util.FormatError('Encoding is not a Name nor a Dict');
        }

        if (baseEncodingName !== 'MacRomanEncoding' && baseEncodingName !== 'MacExpertEncoding' && baseEncodingName !== 'WinAnsiEncoding') {
          baseEncodingName = null;
        }
      }

      if (baseEncodingName) {
        properties.defaultEncoding = (0, _encodings.getEncoding)(baseEncodingName).slice();
      } else {
        var isSymbolicFont = !!(properties.flags & _fonts.FontFlags.Symbolic);
        var isNonsymbolicFont = !!(properties.flags & _fonts.FontFlags.Nonsymbolic);
        encoding = _encodings.StandardEncoding;

        if (properties.type === 'TrueType' && !isNonsymbolicFont) {
          encoding = _encodings.WinAnsiEncoding;
        }

        if (isSymbolicFont) {
          encoding = _encodings.MacRomanEncoding;

          if (!properties.file) {
            if (/Symbol/i.test(properties.name)) {
              encoding = _encodings.SymbolSetEncoding;
            } else if (/Dingbats/i.test(properties.name)) {
              encoding = _encodings.ZapfDingbatsEncoding;
            }
          }
        }

        properties.defaultEncoding = encoding;
      }

      properties.differences = differences;
      properties.baseEncodingName = baseEncodingName;
      properties.hasEncoding = !!baseEncodingName || differences.length > 0;
      properties.dict = dict;
      return toUnicodePromise.then(function (toUnicode) {
        properties.toUnicode = toUnicode;
        return _this9.buildToUnicode(properties);
      }).then(function (toUnicode) {
        properties.toUnicode = toUnicode;
        return properties;
      });
    },
    _buildSimpleFontToUnicode: function _buildSimpleFontToUnicode(properties) {
      (0, _util.assert)(!properties.composite, 'Must be a simple font.');
      var toUnicode = [],
          charcode,
          glyphName;
      var encoding = properties.defaultEncoding.slice();
      var baseEncodingName = properties.baseEncodingName;
      var differences = properties.differences;

      for (charcode in differences) {
        glyphName = differences[charcode];

        if (glyphName === '.notdef') {
          continue;
        }

        encoding[charcode] = glyphName;
      }

      var glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();

      for (charcode in encoding) {
        glyphName = encoding[charcode];

        if (glyphName === '') {
          continue;
        } else if (glyphsUnicodeMap[glyphName] === undefined) {
          var code = 0;

          switch (glyphName[0]) {
            case 'G':
              if (glyphName.length === 3) {
                code = parseInt(glyphName.substring(1), 16);
              }

              break;

            case 'g':
              if (glyphName.length === 5) {
                code = parseInt(glyphName.substring(1), 16);
              }

              break;

            case 'C':
            case 'c':
              if (glyphName.length >= 3) {
                code = +glyphName.substring(1);
              }

              break;

            default:
              var unicode = (0, _unicode.getUnicodeForGlyph)(glyphName, glyphsUnicodeMap);

              if (unicode !== -1) {
                code = unicode;
              }

          }

          if (code) {
            if (baseEncodingName && code === +charcode) {
              var baseEncoding = (0, _encodings.getEncoding)(baseEncodingName);

              if (baseEncoding && (glyphName = baseEncoding[charcode])) {
                toUnicode[charcode] = String.fromCharCode(glyphsUnicodeMap[glyphName]);
                continue;
              }
            }

            toUnicode[charcode] = String.fromCodePoint(code);
          }

          continue;
        }

        toUnicode[charcode] = String.fromCharCode(glyphsUnicodeMap[glyphName]);
      }

      return new _fonts.ToUnicodeMap(toUnicode);
    },
    buildToUnicode: function buildToUnicode(properties) {
      properties.hasIncludedToUnicodeMap = !!properties.toUnicode && properties.toUnicode.length > 0;

      if (properties.hasIncludedToUnicodeMap) {
        if (!properties.composite && properties.hasEncoding) {
          properties.fallbackToUnicode = this._buildSimpleFontToUnicode(properties);
        }

        return Promise.resolve(properties.toUnicode);
      }

      if (!properties.composite) {
        return Promise.resolve(this._buildSimpleFontToUnicode(properties));
      }

      if (properties.composite && (properties.cMap.builtInCMap && !(properties.cMap instanceof _cmap.IdentityCMap) || properties.cidSystemInfo.registry === 'Adobe' && (properties.cidSystemInfo.ordering === 'GB1' || properties.cidSystemInfo.ordering === 'CNS1' || properties.cidSystemInfo.ordering === 'Japan1' || properties.cidSystemInfo.ordering === 'Korea1'))) {
        var registry = properties.cidSystemInfo.registry;
        var ordering = properties.cidSystemInfo.ordering;

        var ucs2CMapName = _primitives.Name.get(registry + '-' + ordering + '-UCS2');

        return _cmap.CMapFactory.create({
          encoding: ucs2CMapName,
          fetchBuiltInCMap: this.fetchBuiltInCMap,
          useCMap: null
        }).then(function (ucs2CMap) {
          var cMap = properties.cMap;
          var toUnicode = [];
          cMap.forEach(function (charcode, cid) {
            if (cid > 0xffff) {
              throw new _util.FormatError('Max size of CID is 65,535');
            }

            var ucs2 = ucs2CMap.lookup(cid);

            if (ucs2) {
              toUnicode[charcode] = String.fromCharCode((ucs2.charCodeAt(0) << 8) + ucs2.charCodeAt(1));
            }
          });
          return new _fonts.ToUnicodeMap(toUnicode);
        });
      }

      return Promise.resolve(new _fonts.IdentityToUnicodeMap(properties.firstChar, properties.lastChar));
    },
    readToUnicode: function PartialEvaluator_readToUnicode(toUnicode) {
      var cmapObj = toUnicode;

      if ((0, _primitives.isName)(cmapObj)) {
        return _cmap.CMapFactory.create({
          encoding: cmapObj,
          fetchBuiltInCMap: this.fetchBuiltInCMap,
          useCMap: null
        }).then(function (cmap) {
          if (cmap instanceof _cmap.IdentityCMap) {
            return new _fonts.IdentityToUnicodeMap(0, 0xFFFF);
          }

          return new _fonts.ToUnicodeMap(cmap.getMap());
        });
      } else if ((0, _primitives.isStream)(cmapObj)) {
        return _cmap.CMapFactory.create({
          encoding: cmapObj,
          fetchBuiltInCMap: this.fetchBuiltInCMap,
          useCMap: null
        }).then(function (cmap) {
          if (cmap instanceof _cmap.IdentityCMap) {
            return new _fonts.IdentityToUnicodeMap(0, 0xFFFF);
          }

          var map = new Array(cmap.length);
          cmap.forEach(function (charCode, token) {
            var str = [];

            for (var k = 0; k < token.length; k += 2) {
              var w1 = token.charCodeAt(k) << 8 | token.charCodeAt(k + 1);

              if ((w1 & 0xF800) !== 0xD800) {
                str.push(w1);
                continue;
              }

              k += 2;
              var w2 = token.charCodeAt(k) << 8 | token.charCodeAt(k + 1);
              str.push(((w1 & 0x3ff) << 10) + (w2 & 0x3ff) + 0x10000);
            }

            map[charCode] = String.fromCodePoint.apply(String, str);
          });
          return new _fonts.ToUnicodeMap(map);
        });
      }

      return Promise.resolve(null);
    },
    readCidToGidMap: function PartialEvaluator_readCidToGidMap(cidToGidStream) {
      var glyphsData = cidToGidStream.getBytes();
      var result = [];

      for (var j = 0, jj = glyphsData.length; j < jj; j++) {
        var glyphID = glyphsData[j++] << 8 | glyphsData[j];

        if (glyphID === 0) {
          continue;
        }

        var code = j >> 1;
        result[code] = glyphID;
      }

      return result;
    },
    extractWidths: function PartialEvaluator_extractWidths(dict, descriptor, properties) {
      var xref = this.xref;
      var glyphsWidths = [];
      var defaultWidth = 0;
      var glyphsVMetrics = [];
      var defaultVMetrics;
      var i, ii, j, jj, start, code, widths;

      if (properties.composite) {
        defaultWidth = dict.has('DW') ? dict.get('DW') : 1000;
        widths = dict.get('W');

        if (widths) {
          for (i = 0, ii = widths.length; i < ii; i++) {
            start = xref.fetchIfRef(widths[i++]);
            code = xref.fetchIfRef(widths[i]);

            if (Array.isArray(code)) {
              for (j = 0, jj = code.length; j < jj; j++) {
                glyphsWidths[start++] = xref.fetchIfRef(code[j]);
              }
            } else {
              var width = xref.fetchIfRef(widths[++i]);

              for (j = start; j <= code; j++) {
                glyphsWidths[j] = width;
              }
            }
          }
        }

        if (properties.vertical) {
          var vmetrics = dict.getArray('DW2') || [880, -1000];
          defaultVMetrics = [vmetrics[1], defaultWidth * 0.5, vmetrics[0]];
          vmetrics = dict.get('W2');

          if (vmetrics) {
            for (i = 0, ii = vmetrics.length; i < ii; i++) {
              start = xref.fetchIfRef(vmetrics[i++]);
              code = xref.fetchIfRef(vmetrics[i]);

              if (Array.isArray(code)) {
                for (j = 0, jj = code.length; j < jj; j++) {
                  glyphsVMetrics[start++] = [xref.fetchIfRef(code[j++]), xref.fetchIfRef(code[j++]), xref.fetchIfRef(code[j])];
                }
              } else {
                var vmetric = [xref.fetchIfRef(vmetrics[++i]), xref.fetchIfRef(vmetrics[++i]), xref.fetchIfRef(vmetrics[++i])];

                for (j = start; j <= code; j++) {
                  glyphsVMetrics[j] = vmetric;
                }
              }
            }
          }
        }
      } else {
        var firstChar = properties.firstChar;
        widths = dict.get('Widths');

        if (widths) {
          j = firstChar;

          for (i = 0, ii = widths.length; i < ii; i++) {
            glyphsWidths[j++] = xref.fetchIfRef(widths[i]);
          }

          defaultWidth = parseFloat(descriptor.get('MissingWidth')) || 0;
        } else {
          var baseFontName = dict.get('BaseFont');

          if ((0, _primitives.isName)(baseFontName)) {
            var metrics = this.getBaseFontMetrics(baseFontName.name);
            glyphsWidths = this.buildCharCodeToWidth(metrics.widths, properties);
            defaultWidth = metrics.defaultWidth;
          }
        }
      }

      var isMonospace = true;
      var firstWidth = defaultWidth;

      for (var glyph in glyphsWidths) {
        var glyphWidth = glyphsWidths[glyph];

        if (!glyphWidth) {
          continue;
        }

        if (!firstWidth) {
          firstWidth = glyphWidth;
          continue;
        }

        if (firstWidth !== glyphWidth) {
          isMonospace = false;
          break;
        }
      }

      if (isMonospace) {
        properties.flags |= _fonts.FontFlags.FixedPitch;
      }

      properties.defaultWidth = defaultWidth;
      properties.widths = glyphsWidths;
      properties.defaultVMetrics = defaultVMetrics;
      properties.vmetrics = glyphsVMetrics;
    },
    isSerifFont: function PartialEvaluator_isSerifFont(baseFontName) {
      var fontNameWoStyle = baseFontName.split('-')[0];
      return fontNameWoStyle in (0, _standard_fonts.getSerifFonts)() || fontNameWoStyle.search(/serif/gi) !== -1;
    },
    getBaseFontMetrics: function PartialEvaluator_getBaseFontMetrics(name) {
      var defaultWidth = 0;
      var widths = [];
      var monospace = false;
      var stdFontMap = (0, _standard_fonts.getStdFontMap)();
      var lookupName = stdFontMap[name] || name;
      var Metrics = (0, _metrics.getMetrics)();

      if (!(lookupName in Metrics)) {
        if (this.isSerifFont(name)) {
          lookupName = 'Times-Roman';
        } else {
          lookupName = 'Helvetica';
        }
      }

      var glyphWidths = Metrics[lookupName];

      if ((0, _util.isNum)(glyphWidths)) {
        defaultWidth = glyphWidths;
        monospace = true;
      } else {
        widths = glyphWidths();
      }

      return {
        defaultWidth: defaultWidth,
        monospace: monospace,
        widths: widths
      };
    },
    buildCharCodeToWidth: function PartialEvaluator_bulildCharCodeToWidth(widthsByGlyphName, properties) {
      var widths = Object.create(null);
      var differences = properties.differences;
      var encoding = properties.defaultEncoding;

      for (var charCode = 0; charCode < 256; charCode++) {
        if (charCode in differences && widthsByGlyphName[differences[charCode]]) {
          widths[charCode] = widthsByGlyphName[differences[charCode]];
          continue;
        }

        if (charCode in encoding && widthsByGlyphName[encoding[charCode]]) {
          widths[charCode] = widthsByGlyphName[encoding[charCode]];
          continue;
        }
      }

      return widths;
    },
    preEvaluateFont: function PartialEvaluator_preEvaluateFont(dict) {
      var baseDict = dict;
      var type = dict.get('Subtype');

      if (!(0, _primitives.isName)(type)) {
        throw new _util.FormatError('invalid font Subtype');
      }

      var composite = false;
      var uint8array;

      if (type.name === 'Type0') {
        var df = dict.get('DescendantFonts');

        if (!df) {
          throw new _util.FormatError('Descendant fonts are not specified');
        }

        dict = Array.isArray(df) ? this.xref.fetchIfRef(df[0]) : df;
        type = dict.get('Subtype');

        if (!(0, _primitives.isName)(type)) {
          throw new _util.FormatError('invalid font Subtype');
        }

        composite = true;
      }

      var descriptor = dict.get('FontDescriptor');

      if (descriptor) {
        var hash = new _murmurhash.MurmurHash3_64();
        var encoding = baseDict.getRaw('Encoding');

        if ((0, _primitives.isName)(encoding)) {
          hash.update(encoding.name);
        } else if ((0, _primitives.isRef)(encoding)) {
          hash.update(encoding.toString());
        } else if ((0, _primitives.isDict)(encoding)) {
          var keys = encoding.getKeys();

          for (var i = 0, ii = keys.length; i < ii; i++) {
            var entry = encoding.getRaw(keys[i]);

            if ((0, _primitives.isName)(entry)) {
              hash.update(entry.name);
            } else if ((0, _primitives.isRef)(entry)) {
              hash.update(entry.toString());
            } else if (Array.isArray(entry)) {
              var diffLength = entry.length,
                  diffBuf = new Array(diffLength);

              for (var j = 0; j < diffLength; j++) {
                var diffEntry = entry[j];

                if ((0, _primitives.isName)(diffEntry)) {
                  diffBuf[j] = diffEntry.name;
                } else if ((0, _util.isNum)(diffEntry) || (0, _primitives.isRef)(diffEntry)) {
                  diffBuf[j] = diffEntry.toString();
                }
              }

              hash.update(diffBuf.join());
            }
          }
        }

        var toUnicode = dict.get('ToUnicode') || baseDict.get('ToUnicode');

        if ((0, _primitives.isStream)(toUnicode)) {
          var stream = toUnicode.str || toUnicode;
          uint8array = stream.buffer ? new Uint8Array(stream.buffer.buffer, 0, stream.bufferLength) : new Uint8Array(stream.bytes.buffer, stream.start, stream.end - stream.start);
          hash.update(uint8array);
        } else if ((0, _primitives.isName)(toUnicode)) {
          hash.update(toUnicode.name);
        }

        var widths = dict.get('Widths') || baseDict.get('Widths');

        if (widths) {
          uint8array = new Uint8Array(new Uint32Array(widths).buffer);
          hash.update(uint8array);
        }
      }

      return {
        descriptor: descriptor,
        dict: dict,
        baseDict: baseDict,
        composite: composite,
        type: type.name,
        hash: hash ? hash.hexdigest() : ''
      };
    },
    translateFont: function PartialEvaluator_translateFont(preEvaluatedFont) {
      var _this10 = this;

      var baseDict = preEvaluatedFont.baseDict;
      var dict = preEvaluatedFont.dict;
      var composite = preEvaluatedFont.composite;
      var descriptor = preEvaluatedFont.descriptor;
      var type = preEvaluatedFont.type;
      var maxCharIndex = composite ? 0xFFFF : 0xFF;
      var properties;

      if (!descriptor) {
        if (type === 'Type3') {
          descriptor = new _primitives.Dict(null);
          descriptor.set('FontName', _primitives.Name.get(type));
          descriptor.set('FontBBox', dict.getArray('FontBBox'));
        } else {
          var baseFontName = dict.get('BaseFont');

          if (!(0, _primitives.isName)(baseFontName)) {
            throw new _util.FormatError('Base font is not specified');
          }

          baseFontName = baseFontName.name.replace(/[,_]/g, '-');
          var metrics = this.getBaseFontMetrics(baseFontName);
          var fontNameWoStyle = baseFontName.split('-')[0];
          var flags = (this.isSerifFont(fontNameWoStyle) ? _fonts.FontFlags.Serif : 0) | (metrics.monospace ? _fonts.FontFlags.FixedPitch : 0) | ((0, _standard_fonts.getSymbolsFonts)()[fontNameWoStyle] ? _fonts.FontFlags.Symbolic : _fonts.FontFlags.Nonsymbolic);
          properties = {
            type: type,
            name: baseFontName,
            widths: metrics.widths,
            defaultWidth: metrics.defaultWidth,
            flags: flags,
            firstChar: 0,
            lastChar: maxCharIndex
          };
          return this.extractDataStructures(dict, dict, properties).then(function (properties) {
            properties.widths = _this10.buildCharCodeToWidth(metrics.widths, properties);
            return new _fonts.Font(baseFontName, null, properties);
          });
        }
      }

      var firstChar = dict.get('FirstChar') || 0;
      var lastChar = dict.get('LastChar') || maxCharIndex;
      var fontName = descriptor.get('FontName');
      var baseFont = dict.get('BaseFont');

      if ((0, _util.isString)(fontName)) {
        fontName = _primitives.Name.get(fontName);
      }

      if ((0, _util.isString)(baseFont)) {
        baseFont = _primitives.Name.get(baseFont);
      }

      if (type !== 'Type3') {
        var fontNameStr = fontName && fontName.name;
        var baseFontStr = baseFont && baseFont.name;

        if (fontNameStr !== baseFontStr) {
          (0, _util.info)("The FontDescriptor's FontName is \"".concat(fontNameStr, "\" but ") + "should be the same as the Font's BaseFont \"".concat(baseFontStr, "\"."));

          if (fontNameStr && baseFontStr && baseFontStr.startsWith(fontNameStr)) {
            fontName = baseFont;
          }
        }
      }

      fontName = fontName || baseFont;

      if (!(0, _primitives.isName)(fontName)) {
        throw new _util.FormatError('invalid font name');
      }

      var fontFile = descriptor.get('FontFile', 'FontFile2', 'FontFile3');

      if (fontFile) {
        if (fontFile.dict) {
          var subtype = fontFile.dict.get('Subtype');

          if (subtype) {
            subtype = subtype.name;
          }

          var length1 = fontFile.dict.get('Length1');
          var length2 = fontFile.dict.get('Length2');
          var length3 = fontFile.dict.get('Length3');
        }
      }

      properties = {
        type: type,
        name: fontName.name,
        subtype: subtype,
        file: fontFile,
        length1: length1,
        length2: length2,
        length3: length3,
        loadedName: baseDict.loadedName,
        composite: composite,
        wideChars: composite,
        fixedPitch: false,
        fontMatrix: dict.getArray('FontMatrix') || _util.FONT_IDENTITY_MATRIX,
        firstChar: firstChar || 0,
        lastChar: lastChar || maxCharIndex,
        bbox: descriptor.getArray('FontBBox'),
        ascent: descriptor.get('Ascent'),
        descent: descriptor.get('Descent'),
        xHeight: descriptor.get('XHeight'),
        capHeight: descriptor.get('CapHeight'),
        flags: descriptor.get('Flags'),
        italicAngle: descriptor.get('ItalicAngle'),
        isType3Font: false
      };
      var cMapPromise;

      if (composite) {
        var cidEncoding = baseDict.get('Encoding');

        if ((0, _primitives.isName)(cidEncoding)) {
          properties.cidEncoding = cidEncoding.name;
        }

        cMapPromise = _cmap.CMapFactory.create({
          encoding: cidEncoding,
          fetchBuiltInCMap: this.fetchBuiltInCMap,
          useCMap: null
        }).then(function (cMap) {
          properties.cMap = cMap;
          properties.vertical = properties.cMap.vertical;
        });
      } else {
        cMapPromise = Promise.resolve(undefined);
      }

      return cMapPromise.then(function () {
        return _this10.extractDataStructures(dict, baseDict, properties);
      }).then(function (properties) {
        _this10.extractWidths(dict, descriptor, properties);

        if (type === 'Type3') {
          properties.isType3Font = true;
        }

        return new _fonts.Font(fontName.name, fontFile, properties);
      });
    }
  };

  PartialEvaluator.buildFontPaths = function (font, glyphs, handler) {
    function buildPath(fontChar) {
      if (font.renderer.hasBuiltPath(fontChar)) {
        return;
      }

      handler.send('commonobj', ["".concat(font.loadedName, "_path_").concat(fontChar), 'FontPath', font.renderer.getPathJs(fontChar)]);
    }

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = glyphs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var glyph = _step.value;
        buildPath(glyph.fontChar);
        var accent = glyph.accent;

        if (accent && accent.fontChar) {
          buildPath(accent.fontChar);
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  };

  return PartialEvaluator;
}();

exports.PartialEvaluator = PartialEvaluator;

var TranslatedFont = function TranslatedFontClosure() {
  function TranslatedFont(loadedName, font, dict) {
    this.loadedName = loadedName;
    this.font = font;
    this.dict = dict;
    this.type3Loaded = null;
    this.sent = false;
  }

  TranslatedFont.prototype = {
    send: function send(handler) {
      if (this.sent) {
        return;
      }

      this.sent = true;
      handler.send('commonobj', [this.loadedName, 'Font', this.font.exportData()]);
    },
    fallback: function fallback(handler) {
      if (!this.font.data) {
        return;
      }

      this.font.disableFontFace = true;
      var glyphs = this.font.glyphCacheValues;
      PartialEvaluator.buildFontPaths(this.font, glyphs, handler);
    },
    loadType3Data: function loadType3Data(evaluator, resources, parentOperatorList, task) {
      if (!this.font.isType3Font) {
        throw new Error('Must be a Type3 font.');
      }

      if (this.type3Loaded) {
        return this.type3Loaded;
      }

      var type3Options = Object.create(evaluator.options);
      type3Options.ignoreErrors = false;
      var type3Evaluator = evaluator.clone(type3Options);
      var translatedFont = this.font;
      var loadCharProcsPromise = Promise.resolve();
      var charProcs = this.dict.get('CharProcs');
      var fontResources = this.dict.get('Resources') || resources;
      var charProcKeys = charProcs.getKeys();
      var charProcOperatorList = Object.create(null);

      var _loop2 = function _loop2() {
        var key = charProcKeys[i];
        loadCharProcsPromise = loadCharProcsPromise.then(function () {
          var glyphStream = charProcs.get(key);
          var operatorList = new _operator_list.OperatorList();
          return type3Evaluator.getOperatorList({
            stream: glyphStream,
            task: task,
            resources: fontResources,
            operatorList: operatorList
          }).then(function () {
            charProcOperatorList[key] = operatorList.getIR();
            parentOperatorList.addDependencies(operatorList.dependencies);
          }).catch(function (reason) {
            (0, _util.warn)("Type3 font resource \"".concat(key, "\" is not available."));
            var operatorList = new _operator_list.OperatorList();
            charProcOperatorList[key] = operatorList.getIR();
          });
        });
      };

      for (var i = 0, n = charProcKeys.length; i < n; ++i) {
        _loop2();
      }

      this.type3Loaded = loadCharProcsPromise.then(function () {
        translatedFont.charProcOperatorList = charProcOperatorList;
      });
      return this.type3Loaded;
    }
  };
  return TranslatedFont;
}();

var StateManager = function StateManagerClosure() {
  function StateManager(initialState) {
    this.state = initialState;
    this.stateStack = [];
  }

  StateManager.prototype = {
    save: function save() {
      var old = this.state;
      this.stateStack.push(this.state);
      this.state = old.clone();
    },
    restore: function restore() {
      var prev = this.stateStack.pop();

      if (prev) {
        this.state = prev;
      }
    },
    transform: function transform(args) {
      this.state.ctm = _util.Util.transform(this.state.ctm, args);
    }
  };
  return StateManager;
}();

var TextState = function TextStateClosure() {
  function TextState() {
    this.ctm = new Float32Array(_util.IDENTITY_MATRIX);
    this.fontName = null;
    this.fontSize = 0;
    this.font = null;
    this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
    this.textMatrix = _util.IDENTITY_MATRIX.slice();
    this.textLineMatrix = _util.IDENTITY_MATRIX.slice();
    this.charSpacing = 0;
    this.wordSpacing = 0;
    this.leading = 0;
    this.textHScale = 1;
    this.textRise = 0;
  }

  TextState.prototype = {
    setTextMatrix: function TextState_setTextMatrix(a, b, c, d, e, f) {
      var m = this.textMatrix;
      m[0] = a;
      m[1] = b;
      m[2] = c;
      m[3] = d;
      m[4] = e;
      m[5] = f;
    },
    setTextLineMatrix: function TextState_setTextMatrix(a, b, c, d, e, f) {
      var m = this.textLineMatrix;
      m[0] = a;
      m[1] = b;
      m[2] = c;
      m[3] = d;
      m[4] = e;
      m[5] = f;
    },
    translateTextMatrix: function TextState_translateTextMatrix(x, y) {
      var m = this.textMatrix;
      m[4] = m[0] * x + m[2] * y + m[4];
      m[5] = m[1] * x + m[3] * y + m[5];
    },
    translateTextLineMatrix: function TextState_translateTextMatrix(x, y) {
      var m = this.textLineMatrix;
      m[4] = m[0] * x + m[2] * y + m[4];
      m[5] = m[1] * x + m[3] * y + m[5];
    },
    calcTextLineMatrixAdvance: function TextState_calcTextLineMatrixAdvance(a, b, c, d, e, f) {
      var font = this.font;

      if (!font) {
        return null;
      }

      var m = this.textLineMatrix;

      if (!(a === m[0] && b === m[1] && c === m[2] && d === m[3])) {
        return null;
      }

      var txDiff = e - m[4],
          tyDiff = f - m[5];

      if (font.vertical && txDiff !== 0 || !font.vertical && tyDiff !== 0) {
        return null;
      }

      var tx,
          ty,
          denominator = a * d - b * c;

      if (font.vertical) {
        tx = -tyDiff * c / denominator;
        ty = tyDiff * a / denominator;
      } else {
        tx = txDiff * d / denominator;
        ty = -txDiff * b / denominator;
      }

      return {
        width: tx,
        height: ty,
        value: font.vertical ? ty : tx
      };
    },
    calcRenderMatrix: function TextState_calcRendeMatrix(ctm) {
      var tsm = [this.fontSize * this.textHScale, 0, 0, this.fontSize, 0, this.textRise];
      return _util.Util.transform(ctm, _util.Util.transform(this.textMatrix, tsm));
    },
    carriageReturn: function TextState_carriageReturn() {
      this.translateTextLineMatrix(0, -this.leading);
      this.textMatrix = this.textLineMatrix.slice();
    },
    clone: function TextState_clone() {
      var clone = Object.create(this);
      clone.textMatrix = this.textMatrix.slice();
      clone.textLineMatrix = this.textLineMatrix.slice();
      clone.fontMatrix = this.fontMatrix.slice();
      return clone;
    }
  };
  return TextState;
}();

var EvalState = function EvalStateClosure() {
  function EvalState() {
    this.ctm = new Float32Array(_util.IDENTITY_MATRIX);
    this.font = null;
    this.textRenderingMode = _util.TextRenderingMode.FILL;
    this.fillColorSpace = _colorspace.ColorSpace.singletons.gray;
    this.strokeColorSpace = _colorspace.ColorSpace.singletons.gray;
  }

  EvalState.prototype = {
    clone: function CanvasExtraState_clone() {
      return Object.create(this);
    }
  };
  return EvalState;
}();

var EvaluatorPreprocessor = function EvaluatorPreprocessorClosure() {
  var getOPMap = (0, _util.getLookupTableFactory)(function (t) {
    t['w'] = {
      id: _util.OPS.setLineWidth,
      numArgs: 1,
      variableArgs: false
    };
    t['J'] = {
      id: _util.OPS.setLineCap,
      numArgs: 1,
      variableArgs: false
    };
    t['j'] = {
      id: _util.OPS.setLineJoin,
      numArgs: 1,
      variableArgs: false
    };
    t['M'] = {
      id: _util.OPS.setMiterLimit,
      numArgs: 1,
      variableArgs: false
    };
    t['d'] = {
      id: _util.OPS.setDash,
      numArgs: 2,
      variableArgs: false
    };
    t['ri'] = {
      id: _util.OPS.setRenderingIntent,
      numArgs: 1,
      variableArgs: false
    };
    t['i'] = {
      id: _util.OPS.setFlatness,
      numArgs: 1,
      variableArgs: false
    };
    t['gs'] = {
      id: _util.OPS.setGState,
      numArgs: 1,
      variableArgs: false
    };
    t['q'] = {
      id: _util.OPS.save,
      numArgs: 0,
      variableArgs: false
    };
    t['Q'] = {
      id: _util.OPS.restore,
      numArgs: 0,
      variableArgs: false
    };
    t['cm'] = {
      id: _util.OPS.transform,
      numArgs: 6,
      variableArgs: false
    };
    t['m'] = {
      id: _util.OPS.moveTo,
      numArgs: 2,
      variableArgs: false
    };
    t['l'] = {
      id: _util.OPS.lineTo,
      numArgs: 2,
      variableArgs: false
    };
    t['c'] = {
      id: _util.OPS.curveTo,
      numArgs: 6,
      variableArgs: false
    };
    t['v'] = {
      id: _util.OPS.curveTo2,
      numArgs: 4,
      variableArgs: false
    };
    t['y'] = {
      id: _util.OPS.curveTo3,
      numArgs: 4,
      variableArgs: false
    };
    t['h'] = {
      id: _util.OPS.closePath,
      numArgs: 0,
      variableArgs: false
    };
    t['re'] = {
      id: _util.OPS.rectangle,
      numArgs: 4,
      variableArgs: false
    };
    t['S'] = {
      id: _util.OPS.stroke,
      numArgs: 0,
      variableArgs: false
    };
    t['s'] = {
      id: _util.OPS.closeStroke,
      numArgs: 0,
      variableArgs: false
    };
    t['f'] = {
      id: _util.OPS.fill,
      numArgs: 0,
      variableArgs: false
    };
    t['F'] = {
      id: _util.OPS.fill,
      numArgs: 0,
      variableArgs: false
    };
    t['f*'] = {
      id: _util.OPS.eoFill,
      numArgs: 0,
      variableArgs: false
    };
    t['B'] = {
      id: _util.OPS.fillStroke,
      numArgs: 0,
      variableArgs: false
    };
    t['B*'] = {
      id: _util.OPS.eoFillStroke,
      numArgs: 0,
      variableArgs: false
    };
    t['b'] = {
      id: _util.OPS.closeFillStroke,
      numArgs: 0,
      variableArgs: false
    };
    t['b*'] = {
      id: _util.OPS.closeEOFillStroke,
      numArgs: 0,
      variableArgs: false
    };
    t['n'] = {
      id: _util.OPS.endPath,
      numArgs: 0,
      variableArgs: false
    };
    t['W'] = {
      id: _util.OPS.clip,
      numArgs: 0,
      variableArgs: false
    };
    t['W*'] = {
      id: _util.OPS.eoClip,
      numArgs: 0,
      variableArgs: false
    };
    t['BT'] = {
      id: _util.OPS.beginText,
      numArgs: 0,
      variableArgs: false
    };
    t['ET'] = {
      id: _util.OPS.endText,
      numArgs: 0,
      variableArgs: false
    };
    t['Tc'] = {
      id: _util.OPS.setCharSpacing,
      numArgs: 1,
      variableArgs: false
    };
    t['Tw'] = {
      id: _util.OPS.setWordSpacing,
      numArgs: 1,
      variableArgs: false
    };
    t['Tz'] = {
      id: _util.OPS.setHScale,
      numArgs: 1,
      variableArgs: false
    };
    t['TL'] = {
      id: _util.OPS.setLeading,
      numArgs: 1,
      variableArgs: false
    };
    t['Tf'] = {
      id: _util.OPS.setFont,
      numArgs: 2,
      variableArgs: false
    };
    t['Tr'] = {
      id: _util.OPS.setTextRenderingMode,
      numArgs: 1,
      variableArgs: false
    };
    t['Ts'] = {
      id: _util.OPS.setTextRise,
      numArgs: 1,
      variableArgs: false
    };
    t['Td'] = {
      id: _util.OPS.moveText,
      numArgs: 2,
      variableArgs: false
    };
    t['TD'] = {
      id: _util.OPS.setLeadingMoveText,
      numArgs: 2,
      variableArgs: false
    };
    t['Tm'] = {
      id: _util.OPS.setTextMatrix,
      numArgs: 6,
      variableArgs: false
    };
    t['T*'] = {
      id: _util.OPS.nextLine,
      numArgs: 0,
      variableArgs: false
    };
    t['Tj'] = {
      id: _util.OPS.showText,
      numArgs: 1,
      variableArgs: false
    };
    t['TJ'] = {
      id: _util.OPS.showSpacedText,
      numArgs: 1,
      variableArgs: false
    };
    t['\''] = {
      id: _util.OPS.nextLineShowText,
      numArgs: 1,
      variableArgs: false
    };
    t['"'] = {
      id: _util.OPS.nextLineSetSpacingShowText,
      numArgs: 3,
      variableArgs: false
    };
    t['d0'] = {
      id: _util.OPS.setCharWidth,
      numArgs: 2,
      variableArgs: false
    };
    t['d1'] = {
      id: _util.OPS.setCharWidthAndBounds,
      numArgs: 6,
      variableArgs: false
    };
    t['CS'] = {
      id: _util.OPS.setStrokeColorSpace,
      numArgs: 1,
      variableArgs: false
    };
    t['cs'] = {
      id: _util.OPS.setFillColorSpace,
      numArgs: 1,
      variableArgs: false
    };
    t['SC'] = {
      id: _util.OPS.setStrokeColor,
      numArgs: 4,
      variableArgs: true
    };
    t['SCN'] = {
      id: _util.OPS.setStrokeColorN,
      numArgs: 33,
      variableArgs: true
    };
    t['sc'] = {
      id: _util.OPS.setFillColor,
      numArgs: 4,
      variableArgs: true
    };
    t['scn'] = {
      id: _util.OPS.setFillColorN,
      numArgs: 33,
      variableArgs: true
    };
    t['G'] = {
      id: _util.OPS.setStrokeGray,
      numArgs: 1,
      variableArgs: false
    };
    t['g'] = {
      id: _util.OPS.setFillGray,
      numArgs: 1,
      variableArgs: false
    };
    t['RG'] = {
      id: _util.OPS.setStrokeRGBColor,
      numArgs: 3,
      variableArgs: false
    };
    t['rg'] = {
      id: _util.OPS.setFillRGBColor,
      numArgs: 3,
      variableArgs: false
    };
    t['K'] = {
      id: _util.OPS.setStrokeCMYKColor,
      numArgs: 4,
      variableArgs: false
    };
    t['k'] = {
      id: _util.OPS.setFillCMYKColor,
      numArgs: 4,
      variableArgs: false
    };
    t['sh'] = {
      id: _util.OPS.shadingFill,
      numArgs: 1,
      variableArgs: false
    };
    t['BI'] = {
      id: _util.OPS.beginInlineImage,
      numArgs: 0,
      variableArgs: false
    };
    t['ID'] = {
      id: _util.OPS.beginImageData,
      numArgs: 0,
      variableArgs: false
    };
    t['EI'] = {
      id: _util.OPS.endInlineImage,
      numArgs: 1,
      variableArgs: false
    };
    t['Do'] = {
      id: _util.OPS.paintXObject,
      numArgs: 1,
      variableArgs: false
    };
    t['MP'] = {
      id: _util.OPS.markPoint,
      numArgs: 1,
      variableArgs: false
    };
    t['DP'] = {
      id: _util.OPS.markPointProps,
      numArgs: 2,
      variableArgs: false
    };
    t['BMC'] = {
      id: _util.OPS.beginMarkedContent,
      numArgs: 1,
      variableArgs: false
    };
    t['BDC'] = {
      id: _util.OPS.beginMarkedContentProps,
      numArgs: 2,
      variableArgs: false
    };
    t['EMC'] = {
      id: _util.OPS.endMarkedContent,
      numArgs: 0,
      variableArgs: false
    };
    t['BX'] = {
      id: _util.OPS.beginCompat,
      numArgs: 0,
      variableArgs: false
    };
    t['EX'] = {
      id: _util.OPS.endCompat,
      numArgs: 0,
      variableArgs: false
    };
    t['BM'] = null;
    t['BD'] = null;
    t['true'] = null;
    t['fa'] = null;
    t['fal'] = null;
    t['fals'] = null;
    t['false'] = null;
    t['nu'] = null;
    t['nul'] = null;
    t['null'] = null;
  });
  var MAX_INVALID_PATH_OPS = 20;

  function EvaluatorPreprocessor(stream, xref, stateManager) {
    this.opMap = getOPMap();
    this.parser = new _parser.Parser(new _parser.Lexer(stream, this.opMap), false, xref);
    this.stateManager = stateManager;
    this.nonProcessedArgs = [];
    this._numInvalidPathOPS = 0;
  }

  EvaluatorPreprocessor.prototype = {
    get savedStatesDepth() {
      return this.stateManager.stateStack.length;
    },

    read: function EvaluatorPreprocessor_read(operation) {
      var args = operation.args;

      while (true) {
        var obj = this.parser.getObj();

        if ((0, _primitives.isCmd)(obj)) {
          var cmd = obj.cmd;
          var opSpec = this.opMap[cmd];

          if (!opSpec) {
            (0, _util.warn)("Unknown command \"".concat(cmd, "\"."));
            continue;
          }

          var fn = opSpec.id;
          var numArgs = opSpec.numArgs;
          var argsLength = args !== null ? args.length : 0;

          if (!opSpec.variableArgs) {
            if (argsLength !== numArgs) {
              var nonProcessedArgs = this.nonProcessedArgs;

              while (argsLength > numArgs) {
                nonProcessedArgs.push(args.shift());
                argsLength--;
              }

              while (argsLength < numArgs && nonProcessedArgs.length !== 0) {
                if (args === null) {
                  args = [];
                }

                args.unshift(nonProcessedArgs.pop());
                argsLength++;
              }
            }

            if (argsLength < numArgs) {
              var partialMsg = "command ".concat(cmd, ": expected ").concat(numArgs, " args, ") + "but received ".concat(argsLength, " args.");

              if (fn >= _util.OPS.moveTo && fn <= _util.OPS.endPath && ++this._numInvalidPathOPS > MAX_INVALID_PATH_OPS) {
                throw new _util.FormatError("Invalid ".concat(partialMsg));
              }

              (0, _util.warn)("Skipping ".concat(partialMsg));

              if (args !== null) {
                args.length = 0;
              }

              continue;
            }
          } else if (argsLength > numArgs) {
            (0, _util.info)("Command ".concat(cmd, ": expected [0, ").concat(numArgs, "] args, ") + "but received ".concat(argsLength, " args."));
          }

          this.preprocessCommand(fn, args);
          operation.fn = fn;
          operation.args = args;
          return true;
        }

        if ((0, _primitives.isEOF)(obj)) {
          return false;
        }

        if (obj !== null) {
          if (args === null) {
            args = [];
          }

          args.push(obj);

          if (args.length > 33) {
            throw new _util.FormatError('Too many arguments');
          }
        }
      }
    },
    preprocessCommand: function EvaluatorPreprocessor_preprocessCommand(fn, args) {
      switch (fn | 0) {
        case _util.OPS.save:
          this.stateManager.save();
          break;

        case _util.OPS.restore:
          this.stateManager.restore();
          break;

        case _util.OPS.transform:
          this.stateManager.transform(args);
          break;
      }
    }
  };
  return EvaluatorPreprocessor;
}();

/***/ }),
/* 172 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CMapFactory = exports.IdentityCMap = exports.CMap = void 0;

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

var _parser = __w_pdfjs_require__(156);

var _stream = __w_pdfjs_require__(157);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var BUILT_IN_CMAPS = ['Adobe-GB1-UCS2', 'Adobe-CNS1-UCS2', 'Adobe-Japan1-UCS2', 'Adobe-Korea1-UCS2', '78-EUC-H', '78-EUC-V', '78-H', '78-RKSJ-H', '78-RKSJ-V', '78-V', '78ms-RKSJ-H', '78ms-RKSJ-V', '83pv-RKSJ-H', '90ms-RKSJ-H', '90ms-RKSJ-V', '90msp-RKSJ-H', '90msp-RKSJ-V', '90pv-RKSJ-H', '90pv-RKSJ-V', 'Add-H', 'Add-RKSJ-H', 'Add-RKSJ-V', 'Add-V', 'Adobe-CNS1-0', 'Adobe-CNS1-1', 'Adobe-CNS1-2', 'Adobe-CNS1-3', 'Adobe-CNS1-4', 'Adobe-CNS1-5', 'Adobe-CNS1-6', 'Adobe-GB1-0', 'Adobe-GB1-1', 'Adobe-GB1-2', 'Adobe-GB1-3', 'Adobe-GB1-4', 'Adobe-GB1-5', 'Adobe-Japan1-0', 'Adobe-Japan1-1', 'Adobe-Japan1-2', 'Adobe-Japan1-3', 'Adobe-Japan1-4', 'Adobe-Japan1-5', 'Adobe-Japan1-6', 'Adobe-Korea1-0', 'Adobe-Korea1-1', 'Adobe-Korea1-2', 'B5-H', 'B5-V', 'B5pc-H', 'B5pc-V', 'CNS-EUC-H', 'CNS-EUC-V', 'CNS1-H', 'CNS1-V', 'CNS2-H', 'CNS2-V', 'ETHK-B5-H', 'ETHK-B5-V', 'ETen-B5-H', 'ETen-B5-V', 'ETenms-B5-H', 'ETenms-B5-V', 'EUC-H', 'EUC-V', 'Ext-H', 'Ext-RKSJ-H', 'Ext-RKSJ-V', 'Ext-V', 'GB-EUC-H', 'GB-EUC-V', 'GB-H', 'GB-V', 'GBK-EUC-H', 'GBK-EUC-V', 'GBK2K-H', 'GBK2K-V', 'GBKp-EUC-H', 'GBKp-EUC-V', 'GBT-EUC-H', 'GBT-EUC-V', 'GBT-H', 'GBT-V', 'GBTpc-EUC-H', 'GBTpc-EUC-V', 'GBpc-EUC-H', 'GBpc-EUC-V', 'H', 'HKdla-B5-H', 'HKdla-B5-V', 'HKdlb-B5-H', 'HKdlb-B5-V', 'HKgccs-B5-H', 'HKgccs-B5-V', 'HKm314-B5-H', 'HKm314-B5-V', 'HKm471-B5-H', 'HKm471-B5-V', 'HKscs-B5-H', 'HKscs-B5-V', 'Hankaku', 'Hiragana', 'KSC-EUC-H', 'KSC-EUC-V', 'KSC-H', 'KSC-Johab-H', 'KSC-Johab-V', 'KSC-V', 'KSCms-UHC-H', 'KSCms-UHC-HW-H', 'KSCms-UHC-HW-V', 'KSCms-UHC-V', 'KSCpc-EUC-H', 'KSCpc-EUC-V', 'Katakana', 'NWP-H', 'NWP-V', 'RKSJ-H', 'RKSJ-V', 'Roman', 'UniCNS-UCS2-H', 'UniCNS-UCS2-V', 'UniCNS-UTF16-H', 'UniCNS-UTF16-V', 'UniCNS-UTF32-H', 'UniCNS-UTF32-V', 'UniCNS-UTF8-H', 'UniCNS-UTF8-V', 'UniGB-UCS2-H', 'UniGB-UCS2-V', 'UniGB-UTF16-H', 'UniGB-UTF16-V', 'UniGB-UTF32-H', 'UniGB-UTF32-V', 'UniGB-UTF8-H', 'UniGB-UTF8-V', 'UniJIS-UCS2-H', 'UniJIS-UCS2-HW-H', 'UniJIS-UCS2-HW-V', 'UniJIS-UCS2-V', 'UniJIS-UTF16-H', 'UniJIS-UTF16-V', 'UniJIS-UTF32-H', 'UniJIS-UTF32-V', 'UniJIS-UTF8-H', 'UniJIS-UTF8-V', 'UniJIS2004-UTF16-H', 'UniJIS2004-UTF16-V', 'UniJIS2004-UTF32-H', 'UniJIS2004-UTF32-V', 'UniJIS2004-UTF8-H', 'UniJIS2004-UTF8-V', 'UniJISPro-UCS2-HW-V', 'UniJISPro-UCS2-V', 'UniJISPro-UTF8-V', 'UniJISX0213-UTF32-H', 'UniJISX0213-UTF32-V', 'UniJISX02132004-UTF32-H', 'UniJISX02132004-UTF32-V', 'UniKS-UCS2-H', 'UniKS-UCS2-V', 'UniKS-UTF16-H', 'UniKS-UTF16-V', 'UniKS-UTF32-H', 'UniKS-UTF32-V', 'UniKS-UTF8-H', 'UniKS-UTF8-V', 'V', 'WP-Symbol'];

var CMap =
/*#__PURE__*/
function () {
  function CMap() {
    var builtInCMap = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    _classCallCheck(this, CMap);

    this.codespaceRanges = [[], [], [], []];
    this.numCodespaceRanges = 0;
    this._map = [];
    this.name = '';
    this.vertical = false;
    this.useCMap = null;
    this.builtInCMap = builtInCMap;
  }

  _createClass(CMap, [{
    key: "addCodespaceRange",
    value: function addCodespaceRange(n, low, high) {
      this.codespaceRanges[n - 1].push(low, high);
      this.numCodespaceRanges++;
    }
  }, {
    key: "mapCidRange",
    value: function mapCidRange(low, high, dstLow) {
      while (low <= high) {
        this._map[low++] = dstLow++;
      }
    }
  }, {
    key: "mapBfRange",
    value: function mapBfRange(low, high, dstLow) {
      var lastByte = dstLow.length - 1;

      while (low <= high) {
        this._map[low++] = dstLow;
        dstLow = dstLow.substring(0, lastByte) + String.fromCharCode(dstLow.charCodeAt(lastByte) + 1);
      }
    }
  }, {
    key: "mapBfRangeToArray",
    value: function mapBfRangeToArray(low, high, array) {
      var i = 0,
          ii = array.length;

      while (low <= high && i < ii) {
        this._map[low] = array[i++];
        ++low;
      }
    }
  }, {
    key: "mapOne",
    value: function mapOne(src, dst) {
      this._map[src] = dst;
    }
  }, {
    key: "lookup",
    value: function lookup(code) {
      return this._map[code];
    }
  }, {
    key: "contains",
    value: function contains(code) {
      return this._map[code] !== undefined;
    }
  }, {
    key: "forEach",
    value: function forEach(callback) {
      var map = this._map;
      var length = map.length;

      if (length <= 0x10000) {
        for (var i = 0; i < length; i++) {
          if (map[i] !== undefined) {
            callback(i, map[i]);
          }
        }
      } else {
        for (var _i in map) {
          callback(_i, map[_i]);
        }
      }
    }
  }, {
    key: "charCodeOf",
    value: function charCodeOf(value) {
      var map = this._map;

      if (map.length <= 0x10000) {
        return map.indexOf(value);
      }

      for (var charCode in map) {
        if (map[charCode] === value) {
          return charCode | 0;
        }
      }

      return -1;
    }
  }, {
    key: "getMap",
    value: function getMap() {
      return this._map;
    }
  }, {
    key: "readCharCode",
    value: function readCharCode(str, offset, out) {
      var c = 0;
      var codespaceRanges = this.codespaceRanges;

      for (var n = 0, nn = codespaceRanges.length; n < nn; n++) {
        c = (c << 8 | str.charCodeAt(offset + n)) >>> 0;
        var codespaceRange = codespaceRanges[n];

        for (var k = 0, kk = codespaceRange.length; k < kk;) {
          var low = codespaceRange[k++];
          var high = codespaceRange[k++];

          if (c >= low && c <= high) {
            out.charcode = c;
            out.length = n + 1;
            return;
          }
        }
      }

      out.charcode = 0;
      out.length = 1;
    }
  }, {
    key: "length",
    get: function get() {
      return this._map.length;
    }
  }, {
    key: "isIdentityCMap",
    get: function get() {
      if (!(this.name === 'Identity-H' || this.name === 'Identity-V')) {
        return false;
      }

      if (this._map.length !== 0x10000) {
        return false;
      }

      for (var i = 0; i < 0x10000; i++) {
        if (this._map[i] !== i) {
          return false;
        }
      }

      return true;
    }
  }]);

  return CMap;
}();

exports.CMap = CMap;

var IdentityCMap =
/*#__PURE__*/
function (_CMap) {
  _inherits(IdentityCMap, _CMap);

  function IdentityCMap(vertical, n) {
    var _this;

    _classCallCheck(this, IdentityCMap);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(IdentityCMap).call(this));
    _this.vertical = vertical;

    _this.addCodespaceRange(n, 0, 0xffff);

    return _this;
  }

  _createClass(IdentityCMap, [{
    key: "mapCidRange",
    value: function mapCidRange(low, high, dstLow) {
      (0, _util.unreachable)('should not call mapCidRange');
    }
  }, {
    key: "mapBfRange",
    value: function mapBfRange(low, high, dstLow) {
      (0, _util.unreachable)('should not call mapBfRange');
    }
  }, {
    key: "mapBfRangeToArray",
    value: function mapBfRangeToArray(low, high, array) {
      (0, _util.unreachable)('should not call mapBfRangeToArray');
    }
  }, {
    key: "mapOne",
    value: function mapOne(src, dst) {
      (0, _util.unreachable)('should not call mapCidOne');
    }
  }, {
    key: "lookup",
    value: function lookup(code) {
      return Number.isInteger(code) && code <= 0xffff ? code : undefined;
    }
  }, {
    key: "contains",
    value: function contains(code) {
      return Number.isInteger(code) && code <= 0xffff;
    }
  }, {
    key: "forEach",
    value: function forEach(callback) {
      for (var i = 0; i <= 0xffff; i++) {
        callback(i, i);
      }
    }
  }, {
    key: "charCodeOf",
    value: function charCodeOf(value) {
      return Number.isInteger(value) && value <= 0xffff ? value : -1;
    }
  }, {
    key: "getMap",
    value: function getMap() {
      var map = new Array(0x10000);

      for (var i = 0; i <= 0xffff; i++) {
        map[i] = i;
      }

      return map;
    }
  }, {
    key: "length",
    get: function get() {
      return 0x10000;
    }
  }, {
    key: "isIdentityCMap",
    get: function get() {
      (0, _util.unreachable)('should not access .isIdentityCMap');
    }
  }]);

  return IdentityCMap;
}(CMap);

exports.IdentityCMap = IdentityCMap;

var BinaryCMapReader = function BinaryCMapReaderClosure() {
  function hexToInt(a, size) {
    var n = 0;

    for (var i = 0; i <= size; i++) {
      n = n << 8 | a[i];
    }

    return n >>> 0;
  }

  function hexToStr(a, size) {
    if (size === 1) {
      return String.fromCharCode(a[0], a[1]);
    }

    if (size === 3) {
      return String.fromCharCode(a[0], a[1], a[2], a[3]);
    }

    return String.fromCharCode.apply(null, a.subarray(0, size + 1));
  }

  function addHex(a, b, size) {
    var c = 0;

    for (var i = size; i >= 0; i--) {
      c += a[i] + b[i];
      a[i] = c & 255;
      c >>= 8;
    }
  }

  function incHex(a, size) {
    var c = 1;

    for (var i = size; i >= 0 && c > 0; i--) {
      c += a[i];
      a[i] = c & 255;
      c >>= 8;
    }
  }

  var MAX_NUM_SIZE = 16;
  var MAX_ENCODED_NUM_SIZE = 19;

  function BinaryCMapStream(data) {
    this.buffer = data;
    this.pos = 0;
    this.end = data.length;
    this.tmpBuf = new Uint8Array(MAX_ENCODED_NUM_SIZE);
  }

  BinaryCMapStream.prototype = {
    readByte: function readByte() {
      if (this.pos >= this.end) {
        return -1;
      }

      return this.buffer[this.pos++];
    },
    readNumber: function readNumber() {
      var n = 0;
      var last;

      do {
        var b = this.readByte();

        if (b < 0) {
          throw new _util.FormatError('unexpected EOF in bcmap');
        }

        last = !(b & 0x80);
        n = n << 7 | b & 0x7F;
      } while (!last);

      return n;
    },
    readSigned: function readSigned() {
      var n = this.readNumber();
      return n & 1 ? ~(n >>> 1) : n >>> 1;
    },
    readHex: function readHex(num, size) {
      num.set(this.buffer.subarray(this.pos, this.pos + size + 1));
      this.pos += size + 1;
    },
    readHexNumber: function readHexNumber(num, size) {
      var last;
      var stack = this.tmpBuf,
          sp = 0;

      do {
        var b = this.readByte();

        if (b < 0) {
          throw new _util.FormatError('unexpected EOF in bcmap');
        }

        last = !(b & 0x80);
        stack[sp++] = b & 0x7F;
      } while (!last);

      var i = size,
          buffer = 0,
          bufferSize = 0;

      while (i >= 0) {
        while (bufferSize < 8 && stack.length > 0) {
          buffer = stack[--sp] << bufferSize | buffer;
          bufferSize += 7;
        }

        num[i] = buffer & 255;
        i--;
        buffer >>= 8;
        bufferSize -= 8;
      }
    },
    readHexSigned: function readHexSigned(num, size) {
      this.readHexNumber(num, size);
      var sign = num[size] & 1 ? 255 : 0;
      var c = 0;

      for (var i = 0; i <= size; i++) {
        c = (c & 1) << 8 | num[i];
        num[i] = c >> 1 ^ sign;
      }
    },
    readString: function readString() {
      var len = this.readNumber();
      var s = '';

      for (var i = 0; i < len; i++) {
        s += String.fromCharCode(this.readNumber());
      }

      return s;
    }
  };

  function processBinaryCMap(data, cMap, extend) {
    return new Promise(function (resolve, reject) {
      var stream = new BinaryCMapStream(data);
      var header = stream.readByte();
      cMap.vertical = !!(header & 1);
      var useCMap = null;
      var start = new Uint8Array(MAX_NUM_SIZE);
      var end = new Uint8Array(MAX_NUM_SIZE);
      var char = new Uint8Array(MAX_NUM_SIZE);
      var charCode = new Uint8Array(MAX_NUM_SIZE);
      var tmp = new Uint8Array(MAX_NUM_SIZE);
      var code;
      var b;

      while ((b = stream.readByte()) >= 0) {
        var type = b >> 5;

        if (type === 7) {
          switch (b & 0x1F) {
            case 0:
              stream.readString();
              break;

            case 1:
              useCMap = stream.readString();
              break;
          }

          continue;
        }

        var sequence = !!(b & 0x10);
        var dataSize = b & 15;

        if (dataSize + 1 > MAX_NUM_SIZE) {
          throw new Error('processBinaryCMap: Invalid dataSize.');
        }

        var ucs2DataSize = 1;
        var subitemsCount = stream.readNumber();
        var i;

        switch (type) {
          case 0:
            stream.readHex(start, dataSize);
            stream.readHexNumber(end, dataSize);
            addHex(end, start, dataSize);
            cMap.addCodespaceRange(dataSize + 1, hexToInt(start, dataSize), hexToInt(end, dataSize));

            for (i = 1; i < subitemsCount; i++) {
              incHex(end, dataSize);
              stream.readHexNumber(start, dataSize);
              addHex(start, end, dataSize);
              stream.readHexNumber(end, dataSize);
              addHex(end, start, dataSize);
              cMap.addCodespaceRange(dataSize + 1, hexToInt(start, dataSize), hexToInt(end, dataSize));
            }

            break;

          case 1:
            stream.readHex(start, dataSize);
            stream.readHexNumber(end, dataSize);
            addHex(end, start, dataSize);
            stream.readNumber();

            for (i = 1; i < subitemsCount; i++) {
              incHex(end, dataSize);
              stream.readHexNumber(start, dataSize);
              addHex(start, end, dataSize);
              stream.readHexNumber(end, dataSize);
              addHex(end, start, dataSize);
              stream.readNumber();
            }

            break;

          case 2:
            stream.readHex(char, dataSize);
            code = stream.readNumber();
            cMap.mapOne(hexToInt(char, dataSize), code);

            for (i = 1; i < subitemsCount; i++) {
              incHex(char, dataSize);

              if (!sequence) {
                stream.readHexNumber(tmp, dataSize);
                addHex(char, tmp, dataSize);
              }

              code = stream.readSigned() + (code + 1);
              cMap.mapOne(hexToInt(char, dataSize), code);
            }

            break;

          case 3:
            stream.readHex(start, dataSize);
            stream.readHexNumber(end, dataSize);
            addHex(end, start, dataSize);
            code = stream.readNumber();
            cMap.mapCidRange(hexToInt(start, dataSize), hexToInt(end, dataSize), code);

            for (i = 1; i < subitemsCount; i++) {
              incHex(end, dataSize);

              if (!sequence) {
                stream.readHexNumber(start, dataSize);
                addHex(start, end, dataSize);
              } else {
                start.set(end);
              }

              stream.readHexNumber(end, dataSize);
              addHex(end, start, dataSize);
              code = stream.readNumber();
              cMap.mapCidRange(hexToInt(start, dataSize), hexToInt(end, dataSize), code);
            }

            break;

          case 4:
            stream.readHex(char, ucs2DataSize);
            stream.readHex(charCode, dataSize);
            cMap.mapOne(hexToInt(char, ucs2DataSize), hexToStr(charCode, dataSize));

            for (i = 1; i < subitemsCount; i++) {
              incHex(char, ucs2DataSize);

              if (!sequence) {
                stream.readHexNumber(tmp, ucs2DataSize);
                addHex(char, tmp, ucs2DataSize);
              }

              incHex(charCode, dataSize);
              stream.readHexSigned(tmp, dataSize);
              addHex(charCode, tmp, dataSize);
              cMap.mapOne(hexToInt(char, ucs2DataSize), hexToStr(charCode, dataSize));
            }

            break;

          case 5:
            stream.readHex(start, ucs2DataSize);
            stream.readHexNumber(end, ucs2DataSize);
            addHex(end, start, ucs2DataSize);
            stream.readHex(charCode, dataSize);
            cMap.mapBfRange(hexToInt(start, ucs2DataSize), hexToInt(end, ucs2DataSize), hexToStr(charCode, dataSize));

            for (i = 1; i < subitemsCount; i++) {
              incHex(end, ucs2DataSize);

              if (!sequence) {
                stream.readHexNumber(start, ucs2DataSize);
                addHex(start, end, ucs2DataSize);
              } else {
                start.set(end);
              }

              stream.readHexNumber(end, ucs2DataSize);
              addHex(end, start, ucs2DataSize);
              stream.readHex(charCode, dataSize);
              cMap.mapBfRange(hexToInt(start, ucs2DataSize), hexToInt(end, ucs2DataSize), hexToStr(charCode, dataSize));
            }

            break;

          default:
            reject(new Error('processBinaryCMap: Unknown type: ' + type));
            return;
        }
      }

      if (useCMap) {
        resolve(extend(useCMap));
        return;
      }

      resolve(cMap);
    });
  }

  function BinaryCMapReader() {}

  BinaryCMapReader.prototype = {
    process: processBinaryCMap
  };
  return BinaryCMapReader;
}();

var CMapFactory = function CMapFactoryClosure() {
  function strToInt(str) {
    var a = 0;

    for (var i = 0; i < str.length; i++) {
      a = a << 8 | str.charCodeAt(i);
    }

    return a >>> 0;
  }

  function expectString(obj) {
    if (!(0, _util.isString)(obj)) {
      throw new _util.FormatError('Malformed CMap: expected string.');
    }
  }

  function expectInt(obj) {
    if (!Number.isInteger(obj)) {
      throw new _util.FormatError('Malformed CMap: expected int.');
    }
  }

  function parseBfChar(cMap, lexer) {
    while (true) {
      var obj = lexer.getObj();

      if ((0, _primitives.isEOF)(obj)) {
        break;
      }

      if ((0, _primitives.isCmd)(obj, 'endbfchar')) {
        return;
      }

      expectString(obj);
      var src = strToInt(obj);
      obj = lexer.getObj();
      expectString(obj);
      var dst = obj;
      cMap.mapOne(src, dst);
    }
  }

  function parseBfRange(cMap, lexer) {
    while (true) {
      var obj = lexer.getObj();

      if ((0, _primitives.isEOF)(obj)) {
        break;
      }

      if ((0, _primitives.isCmd)(obj, 'endbfrange')) {
        return;
      }

      expectString(obj);
      var low = strToInt(obj);
      obj = lexer.getObj();
      expectString(obj);
      var high = strToInt(obj);
      obj = lexer.getObj();

      if (Number.isInteger(obj) || (0, _util.isString)(obj)) {
        var dstLow = Number.isInteger(obj) ? String.fromCharCode(obj) : obj;
        cMap.mapBfRange(low, high, dstLow);
      } else if ((0, _primitives.isCmd)(obj, '[')) {
        obj = lexer.getObj();
        var array = [];

        while (!(0, _primitives.isCmd)(obj, ']') && !(0, _primitives.isEOF)(obj)) {
          array.push(obj);
          obj = lexer.getObj();
        }

        cMap.mapBfRangeToArray(low, high, array);
      } else {
        break;
      }
    }

    throw new _util.FormatError('Invalid bf range.');
  }

  function parseCidChar(cMap, lexer) {
    while (true) {
      var obj = lexer.getObj();

      if ((0, _primitives.isEOF)(obj)) {
        break;
      }

      if ((0, _primitives.isCmd)(obj, 'endcidchar')) {
        return;
      }

      expectString(obj);
      var src = strToInt(obj);
      obj = lexer.getObj();
      expectInt(obj);
      var dst = obj;
      cMap.mapOne(src, dst);
    }
  }

  function parseCidRange(cMap, lexer) {
    while (true) {
      var obj = lexer.getObj();

      if ((0, _primitives.isEOF)(obj)) {
        break;
      }

      if ((0, _primitives.isCmd)(obj, 'endcidrange')) {
        return;
      }

      expectString(obj);
      var low = strToInt(obj);
      obj = lexer.getObj();
      expectString(obj);
      var high = strToInt(obj);
      obj = lexer.getObj();
      expectInt(obj);
      var dstLow = obj;
      cMap.mapCidRange(low, high, dstLow);
    }
  }

  function parseCodespaceRange(cMap, lexer) {
    while (true) {
      var obj = lexer.getObj();

      if ((0, _primitives.isEOF)(obj)) {
        break;
      }

      if ((0, _primitives.isCmd)(obj, 'endcodespacerange')) {
        return;
      }

      if (!(0, _util.isString)(obj)) {
        break;
      }

      var low = strToInt(obj);
      obj = lexer.getObj();

      if (!(0, _util.isString)(obj)) {
        break;
      }

      var high = strToInt(obj);
      cMap.addCodespaceRange(obj.length, low, high);
    }

    throw new _util.FormatError('Invalid codespace range.');
  }

  function parseWMode(cMap, lexer) {
    var obj = lexer.getObj();

    if (Number.isInteger(obj)) {
      cMap.vertical = !!obj;
    }
  }

  function parseCMapName(cMap, lexer) {
    var obj = lexer.getObj();

    if ((0, _primitives.isName)(obj) && (0, _util.isString)(obj.name)) {
      cMap.name = obj.name;
    }
  }

  function parseCMap(cMap, lexer, fetchBuiltInCMap, useCMap) {
    var previous;
    var embeddedUseCMap;

    objLoop: while (true) {
      try {
        var obj = lexer.getObj();

        if ((0, _primitives.isEOF)(obj)) {
          break;
        } else if ((0, _primitives.isName)(obj)) {
          if (obj.name === 'WMode') {
            parseWMode(cMap, lexer);
          } else if (obj.name === 'CMapName') {
            parseCMapName(cMap, lexer);
          }

          previous = obj;
        } else if ((0, _primitives.isCmd)(obj)) {
          switch (obj.cmd) {
            case 'endcmap':
              break objLoop;

            case 'usecmap':
              if ((0, _primitives.isName)(previous)) {
                embeddedUseCMap = previous.name;
              }

              break;

            case 'begincodespacerange':
              parseCodespaceRange(cMap, lexer);
              break;

            case 'beginbfchar':
              parseBfChar(cMap, lexer);
              break;

            case 'begincidchar':
              parseCidChar(cMap, lexer);
              break;

            case 'beginbfrange':
              parseBfRange(cMap, lexer);
              break;

            case 'begincidrange':
              parseCidRange(cMap, lexer);
              break;
          }
        }
      } catch (ex) {
        if (ex instanceof _util.MissingDataException) {
          throw ex;
        }

        (0, _util.warn)('Invalid cMap data: ' + ex);
        continue;
      }
    }

    if (!useCMap && embeddedUseCMap) {
      useCMap = embeddedUseCMap;
    }

    if (useCMap) {
      return extendCMap(cMap, fetchBuiltInCMap, useCMap);
    }

    return Promise.resolve(cMap);
  }

  function extendCMap(cMap, fetchBuiltInCMap, useCMap) {
    return createBuiltInCMap(useCMap, fetchBuiltInCMap).then(function (newCMap) {
      cMap.useCMap = newCMap;

      if (cMap.numCodespaceRanges === 0) {
        var useCodespaceRanges = cMap.useCMap.codespaceRanges;

        for (var i = 0; i < useCodespaceRanges.length; i++) {
          cMap.codespaceRanges[i] = useCodespaceRanges[i].slice();
        }

        cMap.numCodespaceRanges = cMap.useCMap.numCodespaceRanges;
      }

      cMap.useCMap.forEach(function (key, value) {
        if (!cMap.contains(key)) {
          cMap.mapOne(key, cMap.useCMap.lookup(key));
        }
      });
      return cMap;
    });
  }

  function createBuiltInCMap(name, fetchBuiltInCMap) {
    if (name === 'Identity-H') {
      return Promise.resolve(new IdentityCMap(false, 2));
    } else if (name === 'Identity-V') {
      return Promise.resolve(new IdentityCMap(true, 2));
    }

    if (!BUILT_IN_CMAPS.includes(name)) {
      return Promise.reject(new Error('Unknown CMap name: ' + name));
    }

    if (!fetchBuiltInCMap) {
      return Promise.reject(new Error('Built-in CMap parameters are not provided.'));
    }

    return fetchBuiltInCMap(name).then(function (data) {
      var cMapData = data.cMapData,
          compressionType = data.compressionType;
      var cMap = new CMap(true);

      if (compressionType === _util.CMapCompressionType.BINARY) {
        return new BinaryCMapReader().process(cMapData, cMap, function (useCMap) {
          return extendCMap(cMap, fetchBuiltInCMap, useCMap);
        });
      }

      if (compressionType === _util.CMapCompressionType.NONE) {
        var lexer = new _parser.Lexer(new _stream.Stream(cMapData));
        return parseCMap(cMap, lexer, fetchBuiltInCMap, null);
      }

      return Promise.reject(new Error('TODO: Only BINARY/NONE CMap compression is currently supported.'));
    });
  }

  return {
    create: function create(params) {
      var encoding = params.encoding;
      var fetchBuiltInCMap = params.fetchBuiltInCMap;
      var useCMap = params.useCMap;

      if ((0, _primitives.isName)(encoding)) {
        return createBuiltInCMap(encoding.name, fetchBuiltInCMap);
      } else if ((0, _primitives.isStream)(encoding)) {
        var cMap = new CMap();
        var lexer = new _parser.Lexer(encoding);
        return parseCMap(cMap, lexer, fetchBuiltInCMap, useCMap).then(function (parsedCMap) {
          if (parsedCMap.isIdentityCMap) {
            return createBuiltInCMap(parsedCMap.name, fetchBuiltInCMap);
          }

          return parsedCMap;
        });
      }

      return Promise.reject(new Error('Encoding required.'));
    }
  };
}();

exports.CMapFactory = CMapFactory;

/***/ }),
/* 173 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFontType = getFontType;
exports.IdentityToUnicodeMap = exports.ToUnicodeMap = exports.FontFlags = exports.Font = exports.ErrorFont = exports.SEAC_ANALYSIS_ENABLED = void 0;

var _util = __w_pdfjs_require__(6);

var _cff_parser = __w_pdfjs_require__(174);

var _glyphlist = __w_pdfjs_require__(177);

var _encodings = __w_pdfjs_require__(176);

var _standard_fonts = __w_pdfjs_require__(178);

var _unicode = __w_pdfjs_require__(179);

var _font_renderer = __w_pdfjs_require__(180);

var _cmap = __w_pdfjs_require__(172);

var _stream = __w_pdfjs_require__(157);

var _type1_parser = __w_pdfjs_require__(181);

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var PRIVATE_USE_AREAS = [[0xE000, 0xF8FF], [0x100000, 0x10FFFD]];
var PDF_GLYPH_SPACE_UNITS = 1000;
var SEAC_ANALYSIS_ENABLED = true;
exports.SEAC_ANALYSIS_ENABLED = SEAC_ANALYSIS_ENABLED;
var FontFlags = {
  FixedPitch: 1,
  Serif: 2,
  Symbolic: 4,
  Script: 8,
  Nonsymbolic: 32,
  Italic: 64,
  AllCap: 65536,
  SmallCap: 131072,
  ForceBold: 262144
};
exports.FontFlags = FontFlags;
var MacStandardGlyphOrdering = ['.notdef', '.null', 'nonmarkingreturn', 'space', 'exclam', 'quotedbl', 'numbersign', 'dollar', 'percent', 'ampersand', 'quotesingle', 'parenleft', 'parenright', 'asterisk', 'plus', 'comma', 'hyphen', 'period', 'slash', 'zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine', 'colon', 'semicolon', 'less', 'equal', 'greater', 'question', 'at', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'bracketleft', 'backslash', 'bracketright', 'asciicircum', 'underscore', 'grave', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'braceleft', 'bar', 'braceright', 'asciitilde', 'Adieresis', 'Aring', 'Ccedilla', 'Eacute', 'Ntilde', 'Odieresis', 'Udieresis', 'aacute', 'agrave', 'acircumflex', 'adieresis', 'atilde', 'aring', 'ccedilla', 'eacute', 'egrave', 'ecircumflex', 'edieresis', 'iacute', 'igrave', 'icircumflex', 'idieresis', 'ntilde', 'oacute', 'ograve', 'ocircumflex', 'odieresis', 'otilde', 'uacute', 'ugrave', 'ucircumflex', 'udieresis', 'dagger', 'degree', 'cent', 'sterling', 'section', 'bullet', 'paragraph', 'germandbls', 'registered', 'copyright', 'trademark', 'acute', 'dieresis', 'notequal', 'AE', 'Oslash', 'infinity', 'plusminus', 'lessequal', 'greaterequal', 'yen', 'mu', 'partialdiff', 'summation', 'product', 'pi', 'integral', 'ordfeminine', 'ordmasculine', 'Omega', 'ae', 'oslash', 'questiondown', 'exclamdown', 'logicalnot', 'radical', 'florin', 'approxequal', 'Delta', 'guillemotleft', 'guillemotright', 'ellipsis', 'nonbreakingspace', 'Agrave', 'Atilde', 'Otilde', 'OE', 'oe', 'endash', 'emdash', 'quotedblleft', 'quotedblright', 'quoteleft', 'quoteright', 'divide', 'lozenge', 'ydieresis', 'Ydieresis', 'fraction', 'currency', 'guilsinglleft', 'guilsinglright', 'fi', 'fl', 'daggerdbl', 'periodcentered', 'quotesinglbase', 'quotedblbase', 'perthousand', 'Acircumflex', 'Ecircumflex', 'Aacute', 'Edieresis', 'Egrave', 'Iacute', 'Icircumflex', 'Idieresis', 'Igrave', 'Oacute', 'Ocircumflex', 'apple', 'Ograve', 'Uacute', 'Ucircumflex', 'Ugrave', 'dotlessi', 'circumflex', 'tilde', 'macron', 'breve', 'dotaccent', 'ring', 'cedilla', 'hungarumlaut', 'ogonek', 'caron', 'Lslash', 'lslash', 'Scaron', 'scaron', 'Zcaron', 'zcaron', 'brokenbar', 'Eth', 'eth', 'Yacute', 'yacute', 'Thorn', 'thorn', 'minus', 'multiply', 'onesuperior', 'twosuperior', 'threesuperior', 'onehalf', 'onequarter', 'threequarters', 'franc', 'Gbreve', 'gbreve', 'Idotaccent', 'Scedilla', 'scedilla', 'Cacute', 'cacute', 'Ccaron', 'ccaron', 'dcroat'];

function adjustWidths(properties) {
  if (!properties.fontMatrix) {
    return;
  }

  if (properties.fontMatrix[0] === _util.FONT_IDENTITY_MATRIX[0]) {
    return;
  }

  var scale = 0.001 / properties.fontMatrix[0];
  var glyphsWidths = properties.widths;

  for (var glyph in glyphsWidths) {
    glyphsWidths[glyph] *= scale;
  }

  properties.defaultWidth *= scale;
}

function adjustToUnicode(properties, builtInEncoding) {
  if (properties.hasIncludedToUnicodeMap) {
    return;
  }

  if (properties.hasEncoding) {
    return;
  }

  if (builtInEncoding === properties.defaultEncoding) {
    return;
  }

  if (properties.toUnicode instanceof IdentityToUnicodeMap) {
    return;
  }

  var toUnicode = [],
      glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();

  for (var charCode in builtInEncoding) {
    var glyphName = builtInEncoding[charCode];
    var unicode = (0, _unicode.getUnicodeForGlyph)(glyphName, glyphsUnicodeMap);

    if (unicode !== -1) {
      toUnicode[charCode] = String.fromCharCode(unicode);
    }
  }

  properties.toUnicode.amend(toUnicode);
}

function getFontType(type, subtype) {
  switch (type) {
    case 'Type1':
      return subtype === 'Type1C' ? _util.FontType.TYPE1C : _util.FontType.TYPE1;

    case 'CIDFontType0':
      return subtype === 'CIDFontType0C' ? _util.FontType.CIDFONTTYPE0C : _util.FontType.CIDFONTTYPE0;

    case 'OpenType':
      return _util.FontType.OPENTYPE;

    case 'TrueType':
      return _util.FontType.TRUETYPE;

    case 'CIDFontType2':
      return _util.FontType.CIDFONTTYPE2;

    case 'MMType1':
      return _util.FontType.MMTYPE1;

    case 'Type0':
      return _util.FontType.TYPE0;

    default:
      return _util.FontType.UNKNOWN;
  }
}

function recoverGlyphName(name, glyphsUnicodeMap) {
  if (glyphsUnicodeMap[name] !== undefined) {
    return name;
  }

  var unicode = (0, _unicode.getUnicodeForGlyph)(name, glyphsUnicodeMap);

  if (unicode !== -1) {
    for (var key in glyphsUnicodeMap) {
      if (glyphsUnicodeMap[key] === unicode) {
        return key;
      }
    }
  }

  (0, _util.info)('Unable to recover a standard glyph name for: ' + name);
  return name;
}

var Glyph = function GlyphClosure() {
  function Glyph(fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont) {
    this.fontChar = fontChar;
    this.unicode = unicode;
    this.accent = accent;
    this.width = width;
    this.vmetric = vmetric;
    this.operatorListId = operatorListId;
    this.isSpace = isSpace;
    this.isInFont = isInFont;
  }

  Glyph.prototype.matchesForCache = function (fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont) {
    return this.fontChar === fontChar && this.unicode === unicode && this.accent === accent && this.width === width && this.vmetric === vmetric && this.operatorListId === operatorListId && this.isSpace === isSpace && this.isInFont === isInFont;
  };

  return Glyph;
}();

var ToUnicodeMap = function ToUnicodeMapClosure() {
  function ToUnicodeMap() {
    var cmap = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    this._map = cmap;
  }

  ToUnicodeMap.prototype = {
    get length() {
      return this._map.length;
    },

    forEach: function forEach(callback) {
      for (var charCode in this._map) {
        callback(charCode, this._map[charCode].charCodeAt(0));
      }
    },
    has: function has(i) {
      return this._map[i] !== undefined;
    },
    get: function get(i) {
      return this._map[i];
    },
    charCodeOf: function charCodeOf(value) {
      var map = this._map;

      if (map.length <= 0x10000) {
        return map.indexOf(value);
      }

      for (var charCode in map) {
        if (map[charCode] === value) {
          return charCode | 0;
        }
      }

      return -1;
    },
    amend: function amend(map) {
      for (var charCode in map) {
        this._map[charCode] = map[charCode];
      }
    }
  };
  return ToUnicodeMap;
}();

exports.ToUnicodeMap = ToUnicodeMap;

var IdentityToUnicodeMap = function IdentityToUnicodeMapClosure() {
  function IdentityToUnicodeMap(firstChar, lastChar) {
    this.firstChar = firstChar;
    this.lastChar = lastChar;
  }

  IdentityToUnicodeMap.prototype = {
    get length() {
      return this.lastChar + 1 - this.firstChar;
    },

    forEach: function forEach(callback) {
      for (var i = this.firstChar, ii = this.lastChar; i <= ii; i++) {
        callback(i, i);
      }
    },
    has: function has(i) {
      return this.firstChar <= i && i <= this.lastChar;
    },
    get: function get(i) {
      if (this.firstChar <= i && i <= this.lastChar) {
        return String.fromCharCode(i);
      }

      return undefined;
    },
    charCodeOf: function charCodeOf(v) {
      return Number.isInteger(v) && v >= this.firstChar && v <= this.lastChar ? v : -1;
    },
    amend: function amend(map) {
      (0, _util.unreachable)('Should not call amend()');
    }
  };
  return IdentityToUnicodeMap;
}();

exports.IdentityToUnicodeMap = IdentityToUnicodeMap;

var OpenTypeFileBuilder = function OpenTypeFileBuilderClosure() {
  function writeInt16(dest, offset, num) {
    dest[offset] = num >> 8 & 0xFF;
    dest[offset + 1] = num & 0xFF;
  }

  function writeInt32(dest, offset, num) {
    dest[offset] = num >> 24 & 0xFF;
    dest[offset + 1] = num >> 16 & 0xFF;
    dest[offset + 2] = num >> 8 & 0xFF;
    dest[offset + 3] = num & 0xFF;
  }

  function writeData(dest, offset, data) {
    var i, ii;

    if (data instanceof Uint8Array) {
      dest.set(data, offset);
    } else if (typeof data === 'string') {
      for (i = 0, ii = data.length; i < ii; i++) {
        dest[offset++] = data.charCodeAt(i) & 0xFF;
      }
    } else {
      for (i = 0, ii = data.length; i < ii; i++) {
        dest[offset++] = data[i] & 0xFF;
      }
    }
  }

  function OpenTypeFileBuilder(sfnt) {
    this.sfnt = sfnt;
    this.tables = Object.create(null);
  }

  OpenTypeFileBuilder.getSearchParams = function OpenTypeFileBuilder_getSearchParams(entriesCount, entrySize) {
    var maxPower2 = 1,
        log2 = 0;

    while ((maxPower2 ^ entriesCount) > maxPower2) {
      maxPower2 <<= 1;
      log2++;
    }

    var searchRange = maxPower2 * entrySize;
    return {
      range: searchRange,
      entry: log2,
      rangeShift: entrySize * entriesCount - searchRange
    };
  };

  var OTF_HEADER_SIZE = 12;
  var OTF_TABLE_ENTRY_SIZE = 16;
  OpenTypeFileBuilder.prototype = {
    toArray: function OpenTypeFileBuilder_toArray() {
      var sfnt = this.sfnt;
      var tables = this.tables;
      var tablesNames = Object.keys(tables);
      tablesNames.sort();
      var numTables = tablesNames.length;
      var i, j, jj, table, tableName;
      var offset = OTF_HEADER_SIZE + numTables * OTF_TABLE_ENTRY_SIZE;
      var tableOffsets = [offset];

      for (i = 0; i < numTables; i++) {
        table = tables[tablesNames[i]];
        var paddedLength = (table.length + 3 & ~3) >>> 0;
        offset += paddedLength;
        tableOffsets.push(offset);
      }

      var file = new Uint8Array(offset);

      for (i = 0; i < numTables; i++) {
        table = tables[tablesNames[i]];
        writeData(file, tableOffsets[i], table);
      }

      if (sfnt === 'true') {
        sfnt = (0, _util.string32)(0x00010000);
      }

      file[0] = sfnt.charCodeAt(0) & 0xFF;
      file[1] = sfnt.charCodeAt(1) & 0xFF;
      file[2] = sfnt.charCodeAt(2) & 0xFF;
      file[3] = sfnt.charCodeAt(3) & 0xFF;
      writeInt16(file, 4, numTables);
      var searchParams = OpenTypeFileBuilder.getSearchParams(numTables, 16);
      writeInt16(file, 6, searchParams.range);
      writeInt16(file, 8, searchParams.entry);
      writeInt16(file, 10, searchParams.rangeShift);
      offset = OTF_HEADER_SIZE;

      for (i = 0; i < numTables; i++) {
        tableName = tablesNames[i];
        file[offset] = tableName.charCodeAt(0) & 0xFF;
        file[offset + 1] = tableName.charCodeAt(1) & 0xFF;
        file[offset + 2] = tableName.charCodeAt(2) & 0xFF;
        file[offset + 3] = tableName.charCodeAt(3) & 0xFF;
        var checksum = 0;

        for (j = tableOffsets[i], jj = tableOffsets[i + 1]; j < jj; j += 4) {
          var quad = (0, _util.readUint32)(file, j);
          checksum = checksum + quad >>> 0;
        }

        writeInt32(file, offset + 4, checksum);
        writeInt32(file, offset + 8, tableOffsets[i]);
        writeInt32(file, offset + 12, tables[tableName].length);
        offset += OTF_TABLE_ENTRY_SIZE;
      }

      return file;
    },
    addTable: function OpenTypeFileBuilder_addTable(tag, data) {
      if (tag in this.tables) {
        throw new Error('Table ' + tag + ' already exists');
      }

      this.tables[tag] = data;
    }
  };
  return OpenTypeFileBuilder;
}();

var Font = function FontClosure() {
  function Font(name, file, properties) {
    var charCode;
    this.name = name;
    this.loadedName = properties.loadedName;
    this.isType3Font = properties.isType3Font;
    this.sizes = [];
    this.missingFile = false;
    this.glyphCache = Object.create(null);
    this.isSerifFont = !!(properties.flags & FontFlags.Serif);
    this.isSymbolicFont = !!(properties.flags & FontFlags.Symbolic);
    this.isMonospace = !!(properties.flags & FontFlags.FixedPitch);
    var type = properties.type;
    var subtype = properties.subtype;
    this.type = type;
    this.subtype = subtype;
    this.fallbackName = this.isMonospace ? 'monospace' : this.isSerifFont ? 'serif' : 'sans-serif';
    this.differences = properties.differences;
    this.widths = properties.widths;
    this.defaultWidth = properties.defaultWidth;
    this.composite = properties.composite;
    this.wideChars = properties.wideChars;
    this.cMap = properties.cMap;
    this.ascent = properties.ascent / PDF_GLYPH_SPACE_UNITS;
    this.descent = properties.descent / PDF_GLYPH_SPACE_UNITS;
    this.fontMatrix = properties.fontMatrix;
    this.bbox = properties.bbox;
    this.defaultEncoding = properties.defaultEncoding;
    this.toUnicode = properties.toUnicode;
    this.fallbackToUnicode = properties.fallbackToUnicode || new ToUnicodeMap();
    this.toFontChar = [];

    if (properties.type === 'Type3') {
      for (charCode = 0; charCode < 256; charCode++) {
        this.toFontChar[charCode] = this.differences[charCode] || properties.defaultEncoding[charCode];
      }

      this.fontType = _util.FontType.TYPE3;
      return;
    }

    this.cidEncoding = properties.cidEncoding;
    this.vertical = properties.vertical;

    if (this.vertical) {
      this.vmetrics = properties.vmetrics;
      this.defaultVMetrics = properties.defaultVMetrics;
    }

    if (!file || file.isEmpty) {
      if (file) {
        (0, _util.warn)('Font file is empty in "' + name + '" (' + this.loadedName + ')');
      }

      this.fallbackToSystemFont();
      return;
    }

    var _getFontFileType = getFontFileType(file, properties);

    var _getFontFileType2 = _slicedToArray(_getFontFileType, 2);

    type = _getFontFileType2[0];
    subtype = _getFontFileType2[1];

    if (type !== this.type || subtype !== this.subtype) {
      (0, _util.info)('Inconsistent font file Type/SubType, expected: ' + "".concat(this.type, "/").concat(this.subtype, " but found: ").concat(type, "/").concat(subtype, "."));
    }

    try {
      var data;

      switch (type) {
        case 'MMType1':
          (0, _util.info)('MMType1 font (' + name + '), falling back to Type1.');

        case 'Type1':
        case 'CIDFontType0':
          this.mimetype = 'font/opentype';
          var cff = subtype === 'Type1C' || subtype === 'CIDFontType0C' ? new CFFFont(file, properties) : new Type1Font(name, file, properties);
          adjustWidths(properties);
          data = this.convert(name, cff, properties);
          break;

        case 'OpenType':
        case 'TrueType':
        case 'CIDFontType2':
          this.mimetype = 'font/opentype';
          data = this.checkAndRepair(name, file, properties);

          if (this.isOpenType) {
            adjustWidths(properties);
            type = 'OpenType';
          }

          break;

        default:
          throw new _util.FormatError("Font ".concat(type, " is not supported"));
      }
    } catch (e) {
      (0, _util.warn)(e);
      this.fallbackToSystemFont();
      return;
    }

    this.data = data;
    this.fontType = getFontType(type, subtype);
    this.fontMatrix = properties.fontMatrix;
    this.widths = properties.widths;
    this.defaultWidth = properties.defaultWidth;
    this.toUnicode = properties.toUnicode;
    this.encoding = properties.baseEncoding;
    this.seacMap = properties.seacMap;
  }

  Font.getFontID = function () {
    var ID = 1;
    return function Font_getFontID() {
      return String(ID++);
    };
  }();

  function int16(b0, b1) {
    return (b0 << 8) + b1;
  }

  function writeSignedInt16(bytes, index, value) {
    bytes[index + 1] = value;
    bytes[index] = value >>> 8;
  }

  function signedInt16(b0, b1) {
    var value = (b0 << 8) + b1;
    return value & 1 << 15 ? value - 0x10000 : value;
  }

  function int32(b0, b1, b2, b3) {
    return (b0 << 24) + (b1 << 16) + (b2 << 8) + b3;
  }

  function string16(value) {
    return String.fromCharCode(value >> 8 & 0xff, value & 0xff);
  }

  function safeString16(value) {
    value = value > 0x7FFF ? 0x7FFF : value < -0x8000 ? -0x8000 : value;
    return String.fromCharCode(value >> 8 & 0xff, value & 0xff);
  }

  function isTrueTypeFile(file) {
    var header = file.peekBytes(4);
    return (0, _util.readUint32)(header, 0) === 0x00010000 || (0, _util.bytesToString)(header) === 'true';
  }

  function isTrueTypeCollectionFile(file) {
    var header = file.peekBytes(4);
    return (0, _util.bytesToString)(header) === 'ttcf';
  }

  function isOpenTypeFile(file) {
    var header = file.peekBytes(4);
    return (0, _util.bytesToString)(header) === 'OTTO';
  }

  function isType1File(file) {
    var header = file.peekBytes(2);

    if (header[0] === 0x25 && header[1] === 0x21) {
      return true;
    }

    if (header[0] === 0x80 && header[1] === 0x01) {
      return true;
    }

    return false;
  }

  function isCFFFile(file) {
    var header = file.peekBytes(4);

    if (header[0] >= 1 && header[3] >= 1 && header[3] <= 4) {
      return true;
    }

    return false;
  }

  function getFontFileType(file, _ref) {
    var type = _ref.type,
        subtype = _ref.subtype,
        composite = _ref.composite;
    var fileType, fileSubtype;

    if (isTrueTypeFile(file) || isTrueTypeCollectionFile(file)) {
      if (composite) {
        fileType = 'CIDFontType2';
      } else {
        fileType = 'TrueType';
      }
    } else if (isOpenTypeFile(file)) {
      if (composite) {
        fileType = 'CIDFontType2';
      } else {
        fileType = 'OpenType';
      }
    } else if (isType1File(file)) {
      if (composite) {
        fileType = 'CIDFontType0';
      } else {
        fileType = type === 'MMType1' ? 'MMType1' : 'Type1';
      }
    } else if (isCFFFile(file)) {
      if (composite) {
        fileType = 'CIDFontType0';
        fileSubtype = 'CIDFontType0C';
      } else {
        fileType = type === 'MMType1' ? 'MMType1' : 'Type1';
        fileSubtype = 'Type1C';
      }
    } else {
      (0, _util.warn)('getFontFileType: Unable to detect correct font file Type/Subtype.');
      fileType = type;
      fileSubtype = subtype;
    }

    return [fileType, fileSubtype];
  }

  function buildToFontChar(encoding, glyphsUnicodeMap, differences) {
    var toFontChar = [],
        unicode;

    for (var i = 0, ii = encoding.length; i < ii; i++) {
      unicode = (0, _unicode.getUnicodeForGlyph)(encoding[i], glyphsUnicodeMap);

      if (unicode !== -1) {
        toFontChar[i] = unicode;
      }
    }

    for (var charCode in differences) {
      unicode = (0, _unicode.getUnicodeForGlyph)(differences[charCode], glyphsUnicodeMap);

      if (unicode !== -1) {
        toFontChar[+charCode] = unicode;
      }
    }

    return toFontChar;
  }

  function adjustMapping(charCodeToGlyphId, hasGlyph, newGlyphZeroId) {
    var newMap = Object.create(null);
    var toFontChar = [];
    var privateUseAreaIndex = 0;
    var nextAvailableFontCharCode = PRIVATE_USE_AREAS[privateUseAreaIndex][0];
    var privateUseOffetEnd = PRIVATE_USE_AREAS[privateUseAreaIndex][1];

    for (var originalCharCode in charCodeToGlyphId) {
      originalCharCode |= 0;
      var glyphId = charCodeToGlyphId[originalCharCode];

      if (!hasGlyph(glyphId)) {
        continue;
      }

      if (nextAvailableFontCharCode > privateUseOffetEnd) {
        privateUseAreaIndex++;

        if (privateUseAreaIndex >= PRIVATE_USE_AREAS.length) {
          (0, _util.warn)('Ran out of space in font private use area.');
          break;
        }

        nextAvailableFontCharCode = PRIVATE_USE_AREAS[privateUseAreaIndex][0];
        privateUseOffetEnd = PRIVATE_USE_AREAS[privateUseAreaIndex][1];
      }

      var fontCharCode = nextAvailableFontCharCode++;

      if (glyphId === 0) {
        glyphId = newGlyphZeroId;
      }

      newMap[fontCharCode] = glyphId;
      toFontChar[originalCharCode] = fontCharCode;
    }

    return {
      toFontChar: toFontChar,
      charCodeToGlyphId: newMap,
      nextAvailableFontCharCode: nextAvailableFontCharCode
    };
  }

  function getRanges(glyphs, numGlyphs) {
    var codes = [];

    for (var charCode in glyphs) {
      if (glyphs[charCode] >= numGlyphs) {
        continue;
      }

      codes.push({
        fontCharCode: charCode | 0,
        glyphId: glyphs[charCode]
      });
    }

    if (codes.length === 0) {
      codes.push({
        fontCharCode: 0,
        glyphId: 0
      });
    }

    codes.sort(function fontGetRangesSort(a, b) {
      return a.fontCharCode - b.fontCharCode;
    });
    var ranges = [];
    var length = codes.length;

    for (var n = 0; n < length;) {
      var start = codes[n].fontCharCode;
      var codeIndices = [codes[n].glyphId];
      ++n;
      var end = start;

      while (n < length && end + 1 === codes[n].fontCharCode) {
        codeIndices.push(codes[n].glyphId);
        ++end;
        ++n;

        if (end === 0xFFFF) {
          break;
        }
      }

      ranges.push([start, end, codeIndices]);
    }

    return ranges;
  }

  function createCmapTable(glyphs, numGlyphs) {
    var ranges = getRanges(glyphs, numGlyphs);
    var numTables = ranges[ranges.length - 1][1] > 0xFFFF ? 2 : 1;
    var cmap = '\x00\x00' + string16(numTables) + '\x00\x03' + '\x00\x01' + (0, _util.string32)(4 + numTables * 8);
    var i, ii, j, jj;

    for (i = ranges.length - 1; i >= 0; --i) {
      if (ranges[i][0] <= 0xFFFF) {
        break;
      }
    }

    var bmpLength = i + 1;

    if (ranges[i][0] < 0xFFFF && ranges[i][1] === 0xFFFF) {
      ranges[i][1] = 0xFFFE;
    }

    var trailingRangesCount = ranges[i][1] < 0xFFFF ? 1 : 0;
    var segCount = bmpLength + trailingRangesCount;
    var searchParams = OpenTypeFileBuilder.getSearchParams(segCount, 2);
    var startCount = '';
    var endCount = '';
    var idDeltas = '';
    var idRangeOffsets = '';
    var glyphsIds = '';
    var bias = 0;
    var range, start, end, codes;

    for (i = 0, ii = bmpLength; i < ii; i++) {
      range = ranges[i];
      start = range[0];
      end = range[1];
      startCount += string16(start);
      endCount += string16(end);
      codes = range[2];
      var contiguous = true;

      for (j = 1, jj = codes.length; j < jj; ++j) {
        if (codes[j] !== codes[j - 1] + 1) {
          contiguous = false;
          break;
        }
      }

      if (!contiguous) {
        var offset = (segCount - i) * 2 + bias * 2;
        bias += end - start + 1;
        idDeltas += string16(0);
        idRangeOffsets += string16(offset);

        for (j = 0, jj = codes.length; j < jj; ++j) {
          glyphsIds += string16(codes[j]);
        }
      } else {
        var startCode = codes[0];
        idDeltas += string16(startCode - start & 0xFFFF);
        idRangeOffsets += string16(0);
      }
    }

    if (trailingRangesCount > 0) {
      endCount += '\xFF\xFF';
      startCount += '\xFF\xFF';
      idDeltas += '\x00\x01';
      idRangeOffsets += '\x00\x00';
    }

    var format314 = '\x00\x00' + string16(2 * segCount) + string16(searchParams.range) + string16(searchParams.entry) + string16(searchParams.rangeShift) + endCount + '\x00\x00' + startCount + idDeltas + idRangeOffsets + glyphsIds;
    var format31012 = '';
    var header31012 = '';

    if (numTables > 1) {
      cmap += '\x00\x03' + '\x00\x0A' + (0, _util.string32)(4 + numTables * 8 + 4 + format314.length);
      format31012 = '';

      for (i = 0, ii = ranges.length; i < ii; i++) {
        range = ranges[i];
        start = range[0];
        codes = range[2];
        var code = codes[0];

        for (j = 1, jj = codes.length; j < jj; ++j) {
          if (codes[j] !== codes[j - 1] + 1) {
            end = range[0] + j - 1;
            format31012 += (0, _util.string32)(start) + (0, _util.string32)(end) + (0, _util.string32)(code);
            start = end + 1;
            code = codes[j];
          }
        }

        format31012 += (0, _util.string32)(start) + (0, _util.string32)(range[1]) + (0, _util.string32)(code);
      }

      header31012 = '\x00\x0C' + '\x00\x00' + (0, _util.string32)(format31012.length + 16) + '\x00\x00\x00\x00' + (0, _util.string32)(format31012.length / 12);
    }

    return cmap + '\x00\x04' + string16(format314.length + 4) + format314 + header31012 + format31012;
  }

  function validateOS2Table(os2) {
    var stream = new _stream.Stream(os2.data);
    var version = stream.getUint16();
    stream.getBytes(60);
    var selection = stream.getUint16();

    if (version < 4 && selection & 0x0300) {
      return false;
    }

    var firstChar = stream.getUint16();
    var lastChar = stream.getUint16();

    if (firstChar > lastChar) {
      return false;
    }

    stream.getBytes(6);
    var usWinAscent = stream.getUint16();

    if (usWinAscent === 0) {
      return false;
    }

    os2.data[8] = os2.data[9] = 0;
    return true;
  }

  function createOS2Table(properties, charstrings, override) {
    override = override || {
      unitsPerEm: 0,
      yMax: 0,
      yMin: 0,
      ascent: 0,
      descent: 0
    };
    var ulUnicodeRange1 = 0;
    var ulUnicodeRange2 = 0;
    var ulUnicodeRange3 = 0;
    var ulUnicodeRange4 = 0;
    var firstCharIndex = null;
    var lastCharIndex = 0;

    if (charstrings) {
      for (var code in charstrings) {
        code |= 0;

        if (firstCharIndex > code || !firstCharIndex) {
          firstCharIndex = code;
        }

        if (lastCharIndex < code) {
          lastCharIndex = code;
        }

        var position = (0, _unicode.getUnicodeRangeFor)(code);

        if (position < 32) {
          ulUnicodeRange1 |= 1 << position;
        } else if (position < 64) {
          ulUnicodeRange2 |= 1 << position - 32;
        } else if (position < 96) {
          ulUnicodeRange3 |= 1 << position - 64;
        } else if (position < 123) {
          ulUnicodeRange4 |= 1 << position - 96;
        } else {
          throw new _util.FormatError('Unicode ranges Bits > 123 are reserved for internal usage');
        }
      }

      if (lastCharIndex > 0xFFFF) {
        lastCharIndex = 0xFFFF;
      }
    } else {
      firstCharIndex = 0;
      lastCharIndex = 255;
    }

    var bbox = properties.bbox || [0, 0, 0, 0];
    var unitsPerEm = override.unitsPerEm || 1 / (properties.fontMatrix || _util.FONT_IDENTITY_MATRIX)[0];
    var scale = properties.ascentScaled ? 1.0 : unitsPerEm / PDF_GLYPH_SPACE_UNITS;
    var typoAscent = override.ascent || Math.round(scale * (properties.ascent || bbox[3]));
    var typoDescent = override.descent || Math.round(scale * (properties.descent || bbox[1]));

    if (typoDescent > 0 && properties.descent > 0 && bbox[1] < 0) {
      typoDescent = -typoDescent;
    }

    var winAscent = override.yMax || typoAscent;
    var winDescent = -override.yMin || -typoDescent;
    return '\x00\x03' + '\x02\x24' + '\x01\xF4' + '\x00\x05' + '\x00\x00' + '\x02\x8A' + '\x02\xBB' + '\x00\x00' + '\x00\x8C' + '\x02\x8A' + '\x02\xBB' + '\x00\x00' + '\x01\xDF' + '\x00\x31' + '\x01\x02' + '\x00\x00' + '\x00\x00\x06' + String.fromCharCode(properties.fixedPitch ? 0x09 : 0x00) + '\x00\x00\x00\x00\x00\x00' + (0, _util.string32)(ulUnicodeRange1) + (0, _util.string32)(ulUnicodeRange2) + (0, _util.string32)(ulUnicodeRange3) + (0, _util.string32)(ulUnicodeRange4) + '\x2A\x32\x31\x2A' + string16(properties.italicAngle ? 1 : 0) + string16(firstCharIndex || properties.firstChar) + string16(lastCharIndex || properties.lastChar) + string16(typoAscent) + string16(typoDescent) + '\x00\x64' + string16(winAscent) + string16(winDescent) + '\x00\x00\x00\x00' + '\x00\x00\x00\x00' + string16(properties.xHeight) + string16(properties.capHeight) + string16(0) + string16(firstCharIndex || properties.firstChar) + '\x00\x03';
  }

  function createPostTable(properties) {
    var angle = Math.floor(properties.italicAngle * Math.pow(2, 16));
    return '\x00\x03\x00\x00' + (0, _util.string32)(angle) + '\x00\x00' + '\x00\x00' + (0, _util.string32)(properties.fixedPitch) + '\x00\x00\x00\x00' + '\x00\x00\x00\x00' + '\x00\x00\x00\x00' + '\x00\x00\x00\x00';
  }

  function createNameTable(name, proto) {
    if (!proto) {
      proto = [[], []];
    }

    var strings = [proto[0][0] || 'Original licence', proto[0][1] || name, proto[0][2] || 'Unknown', proto[0][3] || 'uniqueID', proto[0][4] || name, proto[0][5] || 'Version 0.11', proto[0][6] || '', proto[0][7] || 'Unknown', proto[0][8] || 'Unknown', proto[0][9] || 'Unknown'];
    var stringsUnicode = [];
    var i, ii, j, jj, str;

    for (i = 0, ii = strings.length; i < ii; i++) {
      str = proto[1][i] || strings[i];
      var strBufUnicode = [];

      for (j = 0, jj = str.length; j < jj; j++) {
        strBufUnicode.push(string16(str.charCodeAt(j)));
      }

      stringsUnicode.push(strBufUnicode.join(''));
    }

    var names = [strings, stringsUnicode];
    var platforms = ['\x00\x01', '\x00\x03'];
    var encodings = ['\x00\x00', '\x00\x01'];
    var languages = ['\x00\x00', '\x04\x09'];
    var namesRecordCount = strings.length * platforms.length;
    var nameTable = '\x00\x00' + string16(namesRecordCount) + string16(namesRecordCount * 12 + 6);
    var strOffset = 0;

    for (i = 0, ii = platforms.length; i < ii; i++) {
      var strs = names[i];

      for (j = 0, jj = strs.length; j < jj; j++) {
        str = strs[j];
        var nameRecord = platforms[i] + encodings[i] + languages[i] + string16(j) + string16(str.length) + string16(strOffset);
        nameTable += nameRecord;
        strOffset += str.length;
      }
    }

    nameTable += strings.join('') + stringsUnicode.join('');
    return nameTable;
  }

  Font.prototype = {
    name: null,
    font: null,
    mimetype: null,
    encoding: null,
    disableFontFace: false,

    get renderer() {
      var renderer = _font_renderer.FontRendererFactory.create(this, SEAC_ANALYSIS_ENABLED);

      return (0, _util.shadow)(this, 'renderer', renderer);
    },

    exportData: function Font_exportData() {
      var data = {};

      for (var i in this) {
        if (this.hasOwnProperty(i)) {
          data[i] = this[i];
        }
      }

      return data;
    },
    fallbackToSystemFont: function Font_fallbackToSystemFont() {
      var _this = this;

      this.missingFile = true;
      var charCode, unicode;
      var name = this.name;
      var type = this.type;
      var subtype = this.subtype;
      var fontName = name.replace(/[,_]/g, '-');
      var stdFontMap = (0, _standard_fonts.getStdFontMap)(),
          nonStdFontMap = (0, _standard_fonts.getNonStdFontMap)();
      var isStandardFont = !!stdFontMap[fontName] || !!(nonStdFontMap[fontName] && stdFontMap[nonStdFontMap[fontName]]);
      fontName = stdFontMap[fontName] || nonStdFontMap[fontName] || fontName;
      this.bold = fontName.search(/bold/gi) !== -1;
      this.italic = fontName.search(/oblique/gi) !== -1 || fontName.search(/italic/gi) !== -1;
      this.black = name.search(/Black/g) !== -1;
      this.remeasure = Object.keys(this.widths).length > 0;

      if (isStandardFont && type === 'CIDFontType2' && this.cidEncoding.startsWith('Identity-')) {
        var GlyphMapForStandardFonts = (0, _standard_fonts.getGlyphMapForStandardFonts)();
        var map = [];

        for (charCode in GlyphMapForStandardFonts) {
          map[+charCode] = GlyphMapForStandardFonts[charCode];
        }

        if (/Arial-?Black/i.test(name)) {
          var SupplementalGlyphMapForArialBlack = (0, _standard_fonts.getSupplementalGlyphMapForArialBlack)();

          for (charCode in SupplementalGlyphMapForArialBlack) {
            map[+charCode] = SupplementalGlyphMapForArialBlack[charCode];
          }
        } else if (/Calibri/i.test(name)) {
          var SupplementalGlyphMapForCalibri = (0, _standard_fonts.getSupplementalGlyphMapForCalibri)();

          for (charCode in SupplementalGlyphMapForCalibri) {
            map[+charCode] = SupplementalGlyphMapForCalibri[charCode];
          }
        }

        var isIdentityUnicode = this.toUnicode instanceof IdentityToUnicodeMap;

        if (!isIdentityUnicode) {
          this.toUnicode.forEach(function (charCode, unicodeCharCode) {
            map[+charCode] = unicodeCharCode;
          });
        }

        this.toFontChar = map;
        this.toUnicode = new ToUnicodeMap(map);
      } else if (/Symbol/i.test(fontName)) {
        this.toFontChar = buildToFontChar(_encodings.SymbolSetEncoding, (0, _glyphlist.getGlyphsUnicode)(), this.differences);
      } else if (/Dingbats/i.test(fontName)) {
        if (/Wingdings/i.test(name)) {
          (0, _util.warn)('Non-embedded Wingdings font, falling back to ZapfDingbats.');
        }

        this.toFontChar = buildToFontChar(_encodings.ZapfDingbatsEncoding, (0, _glyphlist.getDingbatsGlyphsUnicode)(), this.differences);
      } else if (isStandardFont) {
        this.toFontChar = buildToFontChar(this.defaultEncoding, (0, _glyphlist.getGlyphsUnicode)(), this.differences);
      } else {
        var glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();
        this.toUnicode.forEach(function (charCode, unicodeCharCode) {
          if (!_this.composite) {
            var glyphName = _this.differences[charCode] || _this.defaultEncoding[charCode];
            unicode = (0, _unicode.getUnicodeForGlyph)(glyphName, glyphsUnicodeMap);

            if (unicode !== -1) {
              unicodeCharCode = unicode;
            }
          }

          _this.toFontChar[charCode] = unicodeCharCode;
        });
      }

      this.loadedName = fontName.split('-')[0];
      this.fontType = getFontType(type, subtype);
    },
    checkAndRepair: function Font_checkAndRepair(name, font, properties) {
      var VALID_TABLES = ['OS/2', 'cmap', 'head', 'hhea', 'hmtx', 'maxp', 'name', 'post', 'loca', 'glyf', 'fpgm', 'prep', 'cvt ', 'CFF '];

      function readTables(file, numTables) {
        var tables = Object.create(null);
        tables['OS/2'] = null;
        tables['cmap'] = null;
        tables['head'] = null;
        tables['hhea'] = null;
        tables['hmtx'] = null;
        tables['maxp'] = null;
        tables['name'] = null;
        tables['post'] = null;

        for (var i = 0; i < numTables; i++) {
          var table = readTableEntry(font);

          if (!VALID_TABLES.includes(table.tag)) {
            continue;
          }

          if (table.length === 0) {
            continue;
          }

          tables[table.tag] = table;
        }

        return tables;
      }

      function readTableEntry(file) {
        var tag = (0, _util.bytesToString)(file.getBytes(4));
        var checksum = file.getInt32() >>> 0;
        var offset = file.getInt32() >>> 0;
        var length = file.getInt32() >>> 0;
        var previousPosition = file.pos;
        file.pos = file.start ? file.start : 0;
        file.skip(offset);
        var data = file.getBytes(length);
        file.pos = previousPosition;

        if (tag === 'head') {
          data[8] = data[9] = data[10] = data[11] = 0;
          data[17] |= 0x20;
        }

        return {
          tag: tag,
          checksum: checksum,
          length: length,
          offset: offset,
          data: data
        };
      }

      function readOpenTypeHeader(ttf) {
        return {
          version: (0, _util.bytesToString)(ttf.getBytes(4)),
          numTables: ttf.getUint16(),
          searchRange: ttf.getUint16(),
          entrySelector: ttf.getUint16(),
          rangeShift: ttf.getUint16()
        };
      }

      function readTrueTypeCollectionHeader(ttc) {
        var ttcTag = (0, _util.bytesToString)(ttc.getBytes(4));
        (0, _util.assert)(ttcTag === 'ttcf', 'Must be a TrueType Collection font.');
        var majorVersion = ttc.getUint16();
        var minorVersion = ttc.getUint16();
        var numFonts = ttc.getInt32() >>> 0;
        var offsetTable = [];

        for (var i = 0; i < numFonts; i++) {
          offsetTable.push(ttc.getInt32() >>> 0);
        }

        var header = {
          ttcTag: ttcTag,
          majorVersion: majorVersion,
          minorVersion: minorVersion,
          numFonts: numFonts,
          offsetTable: offsetTable
        };

        switch (majorVersion) {
          case 1:
            return header;

          case 2:
            header.dsigTag = ttc.getInt32() >>> 0;
            header.dsigLength = ttc.getInt32() >>> 0;
            header.dsigOffset = ttc.getInt32() >>> 0;
            return header;
        }

        throw new _util.FormatError("Invalid TrueType Collection majorVersion: ".concat(majorVersion, "."));
      }

      function readTrueTypeCollectionData(ttc, fontName) {
        var _readTrueTypeCollecti = readTrueTypeCollectionHeader(ttc),
            numFonts = _readTrueTypeCollecti.numFonts,
            offsetTable = _readTrueTypeCollecti.offsetTable;

        for (var i = 0; i < numFonts; i++) {
          ttc.pos = (ttc.start || 0) + offsetTable[i];
          var potentialHeader = readOpenTypeHeader(ttc);
          var potentialTables = readTables(ttc, potentialHeader.numTables);

          if (!potentialTables['name']) {
            throw new _util.FormatError('TrueType Collection font must contain a "name" table.');
          }

          var nameTable = readNameTable(potentialTables['name']);

          for (var j = 0, jj = nameTable.length; j < jj; j++) {
            for (var k = 0, kk = nameTable[j].length; k < kk; k++) {
              var nameEntry = nameTable[j][k];

              if (nameEntry && nameEntry.replace(/\s/g, '') === fontName) {
                return {
                  header: potentialHeader,
                  tables: potentialTables
                };
              }
            }
          }
        }

        throw new _util.FormatError("TrueType Collection does not contain \"".concat(fontName, "\" font."));
      }

      function readCmapTable(cmap, font, isSymbolicFont, hasEncoding) {
        if (!cmap) {
          (0, _util.warn)('No cmap table available.');
          return {
            platformId: -1,
            encodingId: -1,
            mappings: [],
            hasShortCmap: false
          };
        }

        var segment;
        var start = (font.start ? font.start : 0) + cmap.offset;
        font.pos = start;
        font.getUint16();
        var numTables = font.getUint16();
        var potentialTable;
        var canBreak = false;

        for (var i = 0; i < numTables; i++) {
          var platformId = font.getUint16();
          var encodingId = font.getUint16();
          var offset = font.getInt32() >>> 0;
          var useTable = false;

          if (potentialTable && potentialTable.platformId === platformId && potentialTable.encodingId === encodingId) {
            continue;
          }

          if (platformId === 0 && encodingId === 0) {
            useTable = true;
          } else if (platformId === 1 && encodingId === 0) {
            useTable = true;
          } else if (platformId === 3 && encodingId === 1 && (hasEncoding || !potentialTable)) {
            useTable = true;

            if (!isSymbolicFont) {
              canBreak = true;
            }
          } else if (isSymbolicFont && platformId === 3 && encodingId === 0) {
            useTable = true;
            canBreak = true;
          }

          if (useTable) {
            potentialTable = {
              platformId: platformId,
              encodingId: encodingId,
              offset: offset
            };
          }

          if (canBreak) {
            break;
          }
        }

        if (potentialTable) {
          font.pos = start + potentialTable.offset;
        }

        if (!potentialTable || font.peekByte() === -1) {
          (0, _util.warn)('Could not find a preferred cmap table.');
          return {
            platformId: -1,
            encodingId: -1,
            mappings: [],
            hasShortCmap: false
          };
        }

        var format = font.getUint16();
        font.getUint16();
        font.getUint16();
        var hasShortCmap = false;
        var mappings = [];
        var j, glyphId;

        if (format === 0) {
          for (j = 0; j < 256; j++) {
            var index = font.getByte();

            if (!index) {
              continue;
            }

            mappings.push({
              charCode: j,
              glyphId: index
            });
          }

          hasShortCmap = true;
        } else if (format === 4) {
          var segCount = font.getUint16() >> 1;
          font.getBytes(6);
          var segIndex,
              segments = [];

          for (segIndex = 0; segIndex < segCount; segIndex++) {
            segments.push({
              end: font.getUint16()
            });
          }

          font.getUint16();

          for (segIndex = 0; segIndex < segCount; segIndex++) {
            segments[segIndex].start = font.getUint16();
          }

          for (segIndex = 0; segIndex < segCount; segIndex++) {
            segments[segIndex].delta = font.getUint16();
          }

          var offsetsCount = 0;

          for (segIndex = 0; segIndex < segCount; segIndex++) {
            segment = segments[segIndex];
            var rangeOffset = font.getUint16();

            if (!rangeOffset) {
              segment.offsetIndex = -1;
              continue;
            }

            var offsetIndex = (rangeOffset >> 1) - (segCount - segIndex);
            segment.offsetIndex = offsetIndex;
            offsetsCount = Math.max(offsetsCount, offsetIndex + segment.end - segment.start + 1);
          }

          var offsets = [];

          for (j = 0; j < offsetsCount; j++) {
            offsets.push(font.getUint16());
          }

          for (segIndex = 0; segIndex < segCount; segIndex++) {
            segment = segments[segIndex];
            start = segment.start;
            var end = segment.end;
            var delta = segment.delta;
            offsetIndex = segment.offsetIndex;

            for (j = start; j <= end; j++) {
              if (j === 0xFFFF) {
                continue;
              }

              glyphId = offsetIndex < 0 ? j : offsets[offsetIndex + j - start];
              glyphId = glyphId + delta & 0xFFFF;
              mappings.push({
                charCode: j,
                glyphId: glyphId
              });
            }
          }
        } else if (format === 6) {
          var firstCode = font.getUint16();
          var entryCount = font.getUint16();

          for (j = 0; j < entryCount; j++) {
            glyphId = font.getUint16();
            var charCode = firstCode + j;
            mappings.push({
              charCode: charCode,
              glyphId: glyphId
            });
          }
        } else {
          (0, _util.warn)('cmap table has unsupported format: ' + format);
          return {
            platformId: -1,
            encodingId: -1,
            mappings: [],
            hasShortCmap: false
          };
        }

        mappings.sort(function (a, b) {
          return a.charCode - b.charCode;
        });

        for (i = 1; i < mappings.length; i++) {
          if (mappings[i - 1].charCode === mappings[i].charCode) {
            mappings.splice(i, 1);
            i--;
          }
        }

        return {
          platformId: potentialTable.platformId,
          encodingId: potentialTable.encodingId,
          mappings: mappings,
          hasShortCmap: hasShortCmap
        };
      }

      function sanitizeMetrics(font, header, metrics, numGlyphs) {
        if (!header) {
          if (metrics) {
            metrics.data = null;
          }

          return;
        }

        font.pos = (font.start ? font.start : 0) + header.offset;
        font.pos += 4;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 2;
        font.pos += 8;
        font.pos += 2;
        var numOfMetrics = font.getUint16();

        if (numOfMetrics > numGlyphs) {
          (0, _util.info)('The numOfMetrics (' + numOfMetrics + ') should not be ' + 'greater than the numGlyphs (' + numGlyphs + ')');
          numOfMetrics = numGlyphs;
          header.data[34] = (numOfMetrics & 0xff00) >> 8;
          header.data[35] = numOfMetrics & 0x00ff;
        }

        var numOfSidebearings = numGlyphs - numOfMetrics;
        var numMissing = numOfSidebearings - (metrics.length - numOfMetrics * 4 >> 1);

        if (numMissing > 0) {
          var entries = new Uint8Array(metrics.length + numMissing * 2);
          entries.set(metrics.data);
          metrics.data = entries;
        }
      }

      function sanitizeGlyph(source, sourceStart, sourceEnd, dest, destStart, hintsValid) {
        var glyphProfile = {
          length: 0,
          sizeOfInstructions: 0
        };

        if (sourceEnd - sourceStart <= 12) {
          return glyphProfile;
        }

        var glyf = source.subarray(sourceStart, sourceEnd);
        var contoursCount = signedInt16(glyf[0], glyf[1]);

        if (contoursCount < 0) {
          contoursCount = -1;
          writeSignedInt16(glyf, 0, contoursCount);
          dest.set(glyf, destStart);
          glyphProfile.length = glyf.length;
          return glyphProfile;
        }

        var i,
            j = 10,
            flagsCount = 0;

        for (i = 0; i < contoursCount; i++) {
          var endPoint = glyf[j] << 8 | glyf[j + 1];
          flagsCount = endPoint + 1;
          j += 2;
        }

        var instructionsStart = j;
        var instructionsLength = glyf[j] << 8 | glyf[j + 1];
        glyphProfile.sizeOfInstructions = instructionsLength;
        j += 2 + instructionsLength;
        var instructionsEnd = j;
        var coordinatesLength = 0;

        for (i = 0; i < flagsCount; i++) {
          var flag = glyf[j++];

          if (flag & 0xC0) {
            glyf[j - 1] = flag & 0x3F;
          }

          var xyLength = (flag & 2 ? 1 : flag & 16 ? 0 : 2) + (flag & 4 ? 1 : flag & 32 ? 0 : 2);
          coordinatesLength += xyLength;

          if (flag & 8) {
            var repeat = glyf[j++];
            i += repeat;
            coordinatesLength += repeat * xyLength;
          }
        }

        if (coordinatesLength === 0) {
          return glyphProfile;
        }

        var glyphDataLength = j + coordinatesLength;

        if (glyphDataLength > glyf.length) {
          return glyphProfile;
        }

        if (!hintsValid && instructionsLength > 0) {
          dest.set(glyf.subarray(0, instructionsStart), destStart);
          dest.set([0, 0], destStart + instructionsStart);
          dest.set(glyf.subarray(instructionsEnd, glyphDataLength), destStart + instructionsStart + 2);
          glyphDataLength -= instructionsLength;

          if (glyf.length - glyphDataLength > 3) {
            glyphDataLength = glyphDataLength + 3 & ~3;
          }

          glyphProfile.length = glyphDataLength;
          return glyphProfile;
        }

        if (glyf.length - glyphDataLength > 3) {
          glyphDataLength = glyphDataLength + 3 & ~3;
          dest.set(glyf.subarray(0, glyphDataLength), destStart);
          glyphProfile.length = glyphDataLength;
          return glyphProfile;
        }

        dest.set(glyf, destStart);
        glyphProfile.length = glyf.length;
        return glyphProfile;
      }

      function sanitizeHead(head, numGlyphs, locaLength) {
        var data = head.data;
        var version = int32(data[0], data[1], data[2], data[3]);

        if (version >> 16 !== 1) {
          (0, _util.info)('Attempting to fix invalid version in head table: ' + version);
          data[0] = 0;
          data[1] = 1;
          data[2] = 0;
          data[3] = 0;
        }

        var indexToLocFormat = int16(data[50], data[51]);

        if (indexToLocFormat < 0 || indexToLocFormat > 1) {
          (0, _util.info)('Attempting to fix invalid indexToLocFormat in head table: ' + indexToLocFormat);
          var numGlyphsPlusOne = numGlyphs + 1;

          if (locaLength === numGlyphsPlusOne << 1) {
            data[50] = 0;
            data[51] = 0;
          } else if (locaLength === numGlyphsPlusOne << 2) {
            data[50] = 0;
            data[51] = 1;
          } else {
            throw new _util.FormatError('Could not fix indexToLocFormat: ' + indexToLocFormat);
          }
        }
      }

      function sanitizeGlyphLocations(loca, glyf, numGlyphs, isGlyphLocationsLong, hintsValid, dupFirstEntry, maxSizeOfInstructions) {
        var itemSize, itemDecode, itemEncode;

        if (isGlyphLocationsLong) {
          itemSize = 4;

          itemDecode = function fontItemDecodeLong(data, offset) {
            return data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3];
          };

          itemEncode = function fontItemEncodeLong(data, offset, value) {
            data[offset] = value >>> 24 & 0xFF;
            data[offset + 1] = value >> 16 & 0xFF;
            data[offset + 2] = value >> 8 & 0xFF;
            data[offset + 3] = value & 0xFF;
          };
        } else {
          itemSize = 2;

          itemDecode = function fontItemDecode(data, offset) {
            return data[offset] << 9 | data[offset + 1] << 1;
          };

          itemEncode = function fontItemEncode(data, offset, value) {
            data[offset] = value >> 9 & 0xFF;
            data[offset + 1] = value >> 1 & 0xFF;
          };
        }

        var numGlyphsOut = dupFirstEntry ? numGlyphs + 1 : numGlyphs;
        var locaData = loca.data;
        var locaDataSize = itemSize * (1 + numGlyphsOut);
        locaData = new Uint8Array(locaDataSize);
        locaData.set(loca.data.subarray(0, locaDataSize));
        loca.data = locaData;
        var oldGlyfData = glyf.data;
        var oldGlyfDataLength = oldGlyfData.length;
        var newGlyfData = new Uint8Array(oldGlyfDataLength);
        var startOffset = itemDecode(locaData, 0);
        var writeOffset = 0;
        var missingGlyphs = Object.create(null);
        itemEncode(locaData, 0, writeOffset);
        var i, j;

        for (i = 0, j = itemSize; i < numGlyphs; i++, j += itemSize) {
          var endOffset = itemDecode(locaData, j);

          if (endOffset === 0) {
            endOffset = startOffset;
          }

          if (endOffset > oldGlyfDataLength && (oldGlyfDataLength + 3 & ~3) === endOffset) {
            endOffset = oldGlyfDataLength;
          }

          if (endOffset > oldGlyfDataLength) {
            startOffset = endOffset;
          }

          var glyphProfile = sanitizeGlyph(oldGlyfData, startOffset, endOffset, newGlyfData, writeOffset, hintsValid);
          var newLength = glyphProfile.length;

          if (newLength === 0) {
            missingGlyphs[i] = true;
          }

          if (glyphProfile.sizeOfInstructions > maxSizeOfInstructions) {
            maxSizeOfInstructions = glyphProfile.sizeOfInstructions;
          }

          writeOffset += newLength;
          itemEncode(locaData, j, writeOffset);
          startOffset = endOffset;
        }

        if (writeOffset === 0) {
          var simpleGlyph = new Uint8Array([0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 0]);

          for (i = 0, j = itemSize; i < numGlyphsOut; i++, j += itemSize) {
            itemEncode(locaData, j, simpleGlyph.length);
          }

          glyf.data = simpleGlyph;
        } else if (dupFirstEntry) {
          var firstEntryLength = itemDecode(locaData, itemSize);

          if (newGlyfData.length > firstEntryLength + writeOffset) {
            glyf.data = newGlyfData.subarray(0, firstEntryLength + writeOffset);
          } else {
            glyf.data = new Uint8Array(firstEntryLength + writeOffset);
            glyf.data.set(newGlyfData.subarray(0, writeOffset));
          }

          glyf.data.set(newGlyfData.subarray(0, firstEntryLength), writeOffset);
          itemEncode(loca.data, locaData.length - itemSize, writeOffset + firstEntryLength);
        } else {
          glyf.data = newGlyfData.subarray(0, writeOffset);
        }

        return {
          missingGlyphs: missingGlyphs,
          maxSizeOfInstructions: maxSizeOfInstructions
        };
      }

      function readPostScriptTable(post, properties, maxpNumGlyphs) {
        var start = (font.start ? font.start : 0) + post.offset;
        font.pos = start;
        var length = post.length,
            end = start + length;
        var version = font.getInt32();
        font.getBytes(28);
        var glyphNames;
        var valid = true;
        var i;

        switch (version) {
          case 0x00010000:
            glyphNames = MacStandardGlyphOrdering;
            break;

          case 0x00020000:
            var numGlyphs = font.getUint16();

            if (numGlyphs !== maxpNumGlyphs) {
              valid = false;
              break;
            }

            var glyphNameIndexes = [];

            for (i = 0; i < numGlyphs; ++i) {
              var index = font.getUint16();

              if (index >= 32768) {
                valid = false;
                break;
              }

              glyphNameIndexes.push(index);
            }

            if (!valid) {
              break;
            }

            var customNames = [];
            var strBuf = [];

            while (font.pos < end) {
              var stringLength = font.getByte();
              strBuf.length = stringLength;

              for (i = 0; i < stringLength; ++i) {
                strBuf[i] = String.fromCharCode(font.getByte());
              }

              customNames.push(strBuf.join(''));
            }

            glyphNames = [];

            for (i = 0; i < numGlyphs; ++i) {
              var j = glyphNameIndexes[i];

              if (j < 258) {
                glyphNames.push(MacStandardGlyphOrdering[j]);
                continue;
              }

              glyphNames.push(customNames[j - 258]);
            }

            break;

          case 0x00030000:
            break;

          default:
            (0, _util.warn)('Unknown/unsupported post table version ' + version);
            valid = false;

            if (properties.defaultEncoding) {
              glyphNames = properties.defaultEncoding;
            }

            break;
        }

        properties.glyphNames = glyphNames;
        return valid;
      }

      function readNameTable(nameTable) {
        var start = (font.start ? font.start : 0) + nameTable.offset;
        font.pos = start;
        var names = [[], []];
        var length = nameTable.length,
            end = start + length;
        var format = font.getUint16();
        var FORMAT_0_HEADER_LENGTH = 6;

        if (format !== 0 || length < FORMAT_0_HEADER_LENGTH) {
          return names;
        }

        var numRecords = font.getUint16();
        var stringsStart = font.getUint16();
        var records = [];
        var NAME_RECORD_LENGTH = 12;
        var i, ii;

        for (i = 0; i < numRecords && font.pos + NAME_RECORD_LENGTH <= end; i++) {
          var r = {
            platform: font.getUint16(),
            encoding: font.getUint16(),
            language: font.getUint16(),
            name: font.getUint16(),
            length: font.getUint16(),
            offset: font.getUint16()
          };

          if (r.platform === 1 && r.encoding === 0 && r.language === 0 || r.platform === 3 && r.encoding === 1 && r.language === 0x409) {
            records.push(r);
          }
        }

        for (i = 0, ii = records.length; i < ii; i++) {
          var record = records[i];

          if (record.length <= 0) {
            continue;
          }

          var pos = start + stringsStart + record.offset;

          if (pos + record.length > end) {
            continue;
          }

          font.pos = pos;
          var nameIndex = record.name;

          if (record.encoding) {
            var str = '';

            for (var j = 0, jj = record.length; j < jj; j += 2) {
              str += String.fromCharCode(font.getUint16());
            }

            names[1][nameIndex] = str;
          } else {
            names[0][nameIndex] = (0, _util.bytesToString)(font.getBytes(record.length));
          }
        }

        return names;
      }

      var TTOpsStackDeltas = [0, 0, 0, 0, 0, 0, 0, 0, -2, -2, -2, -2, 0, 0, -2, -5, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, -1, 0, -1, -1, -1, -1, 1, -1, -999, 0, 1, 0, -1, -2, 0, -1, -2, -1, -1, 0, -1, -1, 0, 0, -999, -999, -1, -1, -1, -1, -2, -999, -2, -2, -999, 0, -2, -2, 0, 0, -2, 0, -2, 0, 0, 0, -2, -1, -1, 1, 1, 0, 0, -1, -1, -1, -1, -1, -1, -1, 0, 0, -1, 0, -1, -1, 0, -999, -1, -1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, -999, -999, -999, -999, -999, -1, -1, -2, -2, 0, 0, 0, 0, -1, -1, -999, -2, -2, 0, 0, -1, -2, -2, 0, 0, 0, -1, -1, -1, -2];

      function sanitizeTTProgram(table, ttContext) {
        var data = table.data;
        var i = 0,
            j,
            n,
            b,
            funcId,
            pc,
            lastEndf = 0,
            lastDeff = 0;
        var stack = [];
        var callstack = [];
        var functionsCalled = [];
        var tooComplexToFollowFunctions = ttContext.tooComplexToFollowFunctions;
        var inFDEF = false,
            ifLevel = 0,
            inELSE = 0;

        for (var ii = data.length; i < ii;) {
          var op = data[i++];

          if (op === 0x40) {
            n = data[i++];

            if (inFDEF || inELSE) {
              i += n;
            } else {
              for (j = 0; j < n; j++) {
                stack.push(data[i++]);
              }
            }
          } else if (op === 0x41) {
            n = data[i++];

            if (inFDEF || inELSE) {
              i += n * 2;
            } else {
              for (j = 0; j < n; j++) {
                b = data[i++];
                stack.push(b << 8 | data[i++]);
              }
            }
          } else if ((op & 0xF8) === 0xB0) {
            n = op - 0xB0 + 1;

            if (inFDEF || inELSE) {
              i += n;
            } else {
              for (j = 0; j < n; j++) {
                stack.push(data[i++]);
              }
            }
          } else if ((op & 0xF8) === 0xB8) {
            n = op - 0xB8 + 1;

            if (inFDEF || inELSE) {
              i += n * 2;
            } else {
              for (j = 0; j < n; j++) {
                b = data[i++];
                stack.push(b << 8 | data[i++]);
              }
            }
          } else if (op === 0x2B && !tooComplexToFollowFunctions) {
            if (!inFDEF && !inELSE) {
              funcId = stack[stack.length - 1];

              if (isNaN(funcId)) {
                (0, _util.info)('TT: CALL empty stack (or invalid entry).');
              } else {
                ttContext.functionsUsed[funcId] = true;

                if (funcId in ttContext.functionsStackDeltas) {
                  var newStackLength = stack.length + ttContext.functionsStackDeltas[funcId];

                  if (newStackLength < 0) {
                    (0, _util.warn)('TT: CALL invalid functions stack delta.');
                    ttContext.hintsValid = false;
                    return;
                  }

                  stack.length = newStackLength;
                } else if (funcId in ttContext.functionsDefined && !functionsCalled.includes(funcId)) {
                  callstack.push({
                    data: data,
                    i: i,
                    stackTop: stack.length - 1
                  });
                  functionsCalled.push(funcId);
                  pc = ttContext.functionsDefined[funcId];

                  if (!pc) {
                    (0, _util.warn)('TT: CALL non-existent function');
                    ttContext.hintsValid = false;
                    return;
                  }

                  data = pc.data;
                  i = pc.i;
                }
              }
            }
          } else if (op === 0x2C && !tooComplexToFollowFunctions) {
            if (inFDEF || inELSE) {
              (0, _util.warn)('TT: nested FDEFs not allowed');
              tooComplexToFollowFunctions = true;
            }

            inFDEF = true;
            lastDeff = i;
            funcId = stack.pop();
            ttContext.functionsDefined[funcId] = {
              data: data,
              i: i
            };
          } else if (op === 0x2D) {
            if (inFDEF) {
              inFDEF = false;
              lastEndf = i;
            } else {
              pc = callstack.pop();

              if (!pc) {
                (0, _util.warn)('TT: ENDF bad stack');
                ttContext.hintsValid = false;
                return;
              }

              funcId = functionsCalled.pop();
              data = pc.data;
              i = pc.i;
              ttContext.functionsStackDeltas[funcId] = stack.length - pc.stackTop;
            }
          } else if (op === 0x89) {
            if (inFDEF || inELSE) {
              (0, _util.warn)('TT: nested IDEFs not allowed');
              tooComplexToFollowFunctions = true;
            }

            inFDEF = true;
            lastDeff = i;
          } else if (op === 0x58) {
            ++ifLevel;
          } else if (op === 0x1B) {
            inELSE = ifLevel;
          } else if (op === 0x59) {
            if (inELSE === ifLevel) {
              inELSE = 0;
            }

            --ifLevel;
          } else if (op === 0x1C) {
            if (!inFDEF && !inELSE) {
              var offset = stack[stack.length - 1];

              if (offset > 0) {
                i += offset - 1;
              }
            }
          }

          if (!inFDEF && !inELSE) {
            var stackDelta = op <= 0x8E ? TTOpsStackDeltas[op] : op >= 0xC0 && op <= 0xDF ? -1 : op >= 0xE0 ? -2 : 0;

            if (op >= 0x71 && op <= 0x75) {
              n = stack.pop();

              if (!isNaN(n)) {
                stackDelta = -n * 2;
              }
            }

            while (stackDelta < 0 && stack.length > 0) {
              stack.pop();
              stackDelta++;
            }

            while (stackDelta > 0) {
              stack.push(NaN);
              stackDelta--;
            }
          }
        }

        ttContext.tooComplexToFollowFunctions = tooComplexToFollowFunctions;
        var content = [data];

        if (i > data.length) {
          content.push(new Uint8Array(i - data.length));
        }

        if (lastDeff > lastEndf) {
          (0, _util.warn)('TT: complementing a missing function tail');
          content.push(new Uint8Array([0x22, 0x2D]));
        }

        foldTTTable(table, content);
      }

      function checkInvalidFunctions(ttContext, maxFunctionDefs) {
        if (ttContext.tooComplexToFollowFunctions) {
          return;
        }

        if (ttContext.functionsDefined.length > maxFunctionDefs) {
          (0, _util.warn)('TT: more functions defined than expected');
          ttContext.hintsValid = false;
          return;
        }

        for (var j = 0, jj = ttContext.functionsUsed.length; j < jj; j++) {
          if (j > maxFunctionDefs) {
            (0, _util.warn)('TT: invalid function id: ' + j);
            ttContext.hintsValid = false;
            return;
          }

          if (ttContext.functionsUsed[j] && !ttContext.functionsDefined[j]) {
            (0, _util.warn)('TT: undefined function: ' + j);
            ttContext.hintsValid = false;
            return;
          }
        }
      }

      function foldTTTable(table, content) {
        if (content.length > 1) {
          var newLength = 0;
          var j, jj;

          for (j = 0, jj = content.length; j < jj; j++) {
            newLength += content[j].length;
          }

          newLength = newLength + 3 & ~3;
          var result = new Uint8Array(newLength);
          var pos = 0;

          for (j = 0, jj = content.length; j < jj; j++) {
            result.set(content[j], pos);
            pos += content[j].length;
          }

          table.data = result;
          table.length = newLength;
        }
      }

      function sanitizeTTPrograms(fpgm, prep, cvt, maxFunctionDefs) {
        var ttContext = {
          functionsDefined: [],
          functionsUsed: [],
          functionsStackDeltas: [],
          tooComplexToFollowFunctions: false,
          hintsValid: true
        };

        if (fpgm) {
          sanitizeTTProgram(fpgm, ttContext);
        }

        if (prep) {
          sanitizeTTProgram(prep, ttContext);
        }

        if (fpgm) {
          checkInvalidFunctions(ttContext, maxFunctionDefs);
        }

        if (cvt && cvt.length & 1) {
          var cvtData = new Uint8Array(cvt.length + 1);
          cvtData.set(cvt.data);
          cvt.data = cvtData;
        }

        return ttContext.hintsValid;
      }

      font = new _stream.Stream(new Uint8Array(font.getBytes()));
      var header, tables;

      if (isTrueTypeCollectionFile(font)) {
        var ttcData = readTrueTypeCollectionData(font, this.name);
        header = ttcData.header;
        tables = ttcData.tables;
      } else {
        header = readOpenTypeHeader(font);
        tables = readTables(font, header.numTables);
      }

      var cff, cffFile;
      var isTrueType = !tables['CFF '];

      if (!isTrueType) {
        var isComposite = properties.composite && ((properties.cidToGidMap || []).length > 0 || !(properties.cMap instanceof _cmap.IdentityCMap));

        if (header.version === 'OTTO' && !isComposite || !tables['head'] || !tables['hhea'] || !tables['maxp'] || !tables['post']) {
          cffFile = new _stream.Stream(tables['CFF '].data);
          cff = new CFFFont(cffFile, properties);
          adjustWidths(properties);
          return this.convert(name, cff, properties);
        }

        delete tables['glyf'];
        delete tables['loca'];
        delete tables['fpgm'];
        delete tables['prep'];
        delete tables['cvt '];
        this.isOpenType = true;
      } else {
        if (!tables['loca']) {
          throw new _util.FormatError('Required "loca" table is not found');
        }

        if (!tables['glyf']) {
          (0, _util.warn)('Required "glyf" table is not found -- trying to recover.');
          tables['glyf'] = {
            tag: 'glyf',
            data: new Uint8Array(0)
          };
        }

        this.isOpenType = false;
      }

      if (!tables['maxp']) {
        throw new _util.FormatError('Required "maxp" table is not found');
      }

      font.pos = (font.start || 0) + tables['maxp'].offset;
      var version = font.getInt32();
      var numGlyphs = font.getUint16();
      var numGlyphsOut = numGlyphs + 1;
      var dupFirstEntry = true;

      if (numGlyphsOut > 0xFFFF) {
        dupFirstEntry = false;
        numGlyphsOut = numGlyphs;
        (0, _util.warn)('Not enough space in glyfs to duplicate first glyph.');
      }

      var maxFunctionDefs = 0;
      var maxSizeOfInstructions = 0;

      if (version >= 0x00010000 && tables['maxp'].length >= 22) {
        font.pos += 8;
        var maxZones = font.getUint16();

        if (maxZones > 2) {
          tables['maxp'].data[14] = 0;
          tables['maxp'].data[15] = 2;
        }

        font.pos += 4;
        maxFunctionDefs = font.getUint16();
        font.pos += 4;
        maxSizeOfInstructions = font.getUint16();
      }

      tables['maxp'].data[4] = numGlyphsOut >> 8;
      tables['maxp'].data[5] = numGlyphsOut & 255;
      var hintsValid = sanitizeTTPrograms(tables['fpgm'], tables['prep'], tables['cvt '], maxFunctionDefs);

      if (!hintsValid) {
        delete tables['fpgm'];
        delete tables['prep'];
        delete tables['cvt '];
      }

      sanitizeMetrics(font, tables['hhea'], tables['hmtx'], numGlyphsOut);

      if (!tables['head']) {
        throw new _util.FormatError('Required "head" table is not found');
      }

      sanitizeHead(tables['head'], numGlyphs, isTrueType ? tables['loca'].length : 0);
      var missingGlyphs = Object.create(null);

      if (isTrueType) {
        var isGlyphLocationsLong = int16(tables['head'].data[50], tables['head'].data[51]);
        var glyphsInfo = sanitizeGlyphLocations(tables['loca'], tables['glyf'], numGlyphs, isGlyphLocationsLong, hintsValid, dupFirstEntry, maxSizeOfInstructions);
        missingGlyphs = glyphsInfo.missingGlyphs;

        if (version >= 0x00010000 && tables['maxp'].length >= 22) {
          tables['maxp'].data[26] = glyphsInfo.maxSizeOfInstructions >> 8;
          tables['maxp'].data[27] = glyphsInfo.maxSizeOfInstructions & 255;
        }
      }

      if (!tables['hhea']) {
        throw new _util.FormatError('Required "hhea" table is not found');
      }

      if (tables['hhea'].data[10] === 0 && tables['hhea'].data[11] === 0) {
        tables['hhea'].data[10] = 0xFF;
        tables['hhea'].data[11] = 0xFF;
      }

      var metricsOverride = {
        unitsPerEm: int16(tables['head'].data[18], tables['head'].data[19]),
        yMax: int16(tables['head'].data[42], tables['head'].data[43]),
        yMin: signedInt16(tables['head'].data[38], tables['head'].data[39]),
        ascent: int16(tables['hhea'].data[4], tables['hhea'].data[5]),
        descent: signedInt16(tables['hhea'].data[6], tables['hhea'].data[7])
      };
      this.ascent = metricsOverride.ascent / metricsOverride.unitsPerEm;
      this.descent = metricsOverride.descent / metricsOverride.unitsPerEm;

      if (tables['post']) {
        readPostScriptTable(tables['post'], properties, numGlyphs);
      }

      tables['post'] = {
        tag: 'post',
        data: createPostTable(properties)
      };
      var charCodeToGlyphId = [],
          charCode;

      function hasGlyph(glyphId) {
        return !missingGlyphs[glyphId];
      }

      if (properties.composite) {
        var cidToGidMap = properties.cidToGidMap || [];
        var isCidToGidMapEmpty = cidToGidMap.length === 0;
        properties.cMap.forEach(function (charCode, cid) {
          if (cid > 0xffff) {
            throw new _util.FormatError('Max size of CID is 65,535');
          }

          var glyphId = -1;

          if (isCidToGidMapEmpty) {
            glyphId = cid;
          } else if (cidToGidMap[cid] !== undefined) {
            glyphId = cidToGidMap[cid];
          }

          if (glyphId >= 0 && glyphId < numGlyphs && hasGlyph(glyphId)) {
            charCodeToGlyphId[charCode] = glyphId;
          }
        });
      } else {
        var cmapTable = readCmapTable(tables['cmap'], font, this.isSymbolicFont, properties.hasEncoding);
        var cmapPlatformId = cmapTable.platformId;
        var cmapEncodingId = cmapTable.encodingId;
        var cmapMappings = cmapTable.mappings;
        var cmapMappingsLength = cmapMappings.length;

        if (properties.hasEncoding && (cmapPlatformId === 3 && cmapEncodingId === 1 || cmapPlatformId === 1 && cmapEncodingId === 0) || cmapPlatformId === -1 && cmapEncodingId === -1 && !!(0, _encodings.getEncoding)(properties.baseEncodingName)) {
          var baseEncoding = [];

          if (properties.baseEncodingName === 'MacRomanEncoding' || properties.baseEncodingName === 'WinAnsiEncoding') {
            baseEncoding = (0, _encodings.getEncoding)(properties.baseEncodingName);
          }

          var glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();

          for (charCode = 0; charCode < 256; charCode++) {
            var glyphName, standardGlyphName;

            if (this.differences && charCode in this.differences) {
              glyphName = this.differences[charCode];
            } else if (charCode in baseEncoding && baseEncoding[charCode] !== '') {
              glyphName = baseEncoding[charCode];
            } else {
              glyphName = _encodings.StandardEncoding[charCode];
            }

            if (!glyphName) {
              continue;
            }

            standardGlyphName = recoverGlyphName(glyphName, glyphsUnicodeMap);
            var unicodeOrCharCode;

            if (cmapPlatformId === 3 && cmapEncodingId === 1) {
              unicodeOrCharCode = glyphsUnicodeMap[standardGlyphName];
            } else if (cmapPlatformId === 1 && cmapEncodingId === 0) {
              unicodeOrCharCode = _encodings.MacRomanEncoding.indexOf(standardGlyphName);
            }

            var found = false;

            for (var i = 0; i < cmapMappingsLength; ++i) {
              if (cmapMappings[i].charCode !== unicodeOrCharCode) {
                continue;
              }

              charCodeToGlyphId[charCode] = cmapMappings[i].glyphId;
              found = true;
              break;
            }

            if (!found && properties.glyphNames) {
              var glyphId = properties.glyphNames.indexOf(glyphName);

              if (glyphId === -1 && standardGlyphName !== glyphName) {
                glyphId = properties.glyphNames.indexOf(standardGlyphName);
              }

              if (glyphId > 0 && hasGlyph(glyphId)) {
                charCodeToGlyphId[charCode] = glyphId;
              }
            }
          }
        } else if (cmapPlatformId === 0 && cmapEncodingId === 0) {
          for (var _i2 = 0; _i2 < cmapMappingsLength; ++_i2) {
            charCodeToGlyphId[cmapMappings[_i2].charCode] = cmapMappings[_i2].glyphId;
          }
        } else {
          for (var _i3 = 0; _i3 < cmapMappingsLength; ++_i3) {
            charCode = cmapMappings[_i3].charCode;

            if (cmapPlatformId === 3 && charCode >= 0xF000 && charCode <= 0xF0FF) {
              charCode &= 0xFF;
            }

            charCodeToGlyphId[charCode] = cmapMappings[_i3].glyphId;
          }
        }
      }

      if (charCodeToGlyphId.length === 0) {
        charCodeToGlyphId[0] = 0;
      }

      var glyphZeroId = numGlyphsOut - 1;

      if (!dupFirstEntry) {
        glyphZeroId = 0;
      }

      var newMapping = adjustMapping(charCodeToGlyphId, hasGlyph, glyphZeroId);
      this.toFontChar = newMapping.toFontChar;
      tables['cmap'] = {
        tag: 'cmap',
        data: createCmapTable(newMapping.charCodeToGlyphId, numGlyphsOut)
      };

      if (!tables['OS/2'] || !validateOS2Table(tables['OS/2'])) {
        tables['OS/2'] = {
          tag: 'OS/2',
          data: createOS2Table(properties, newMapping.charCodeToGlyphId, metricsOverride)
        };
      }

      if (!isTrueType) {
        try {
          cffFile = new _stream.Stream(tables['CFF '].data);
          var parser = new _cff_parser.CFFParser(cffFile, properties, SEAC_ANALYSIS_ENABLED);
          cff = parser.parse();
          cff.duplicateFirstGlyph();
          var compiler = new _cff_parser.CFFCompiler(cff);
          tables['CFF '].data = compiler.compile();
        } catch (e) {
          (0, _util.warn)('Failed to compile font ' + properties.loadedName);
        }
      }

      if (!tables['name']) {
        tables['name'] = {
          tag: 'name',
          data: createNameTable(this.name)
        };
      } else {
        var namePrototype = readNameTable(tables['name']);
        tables['name'].data = createNameTable(name, namePrototype);
      }

      var builder = new OpenTypeFileBuilder(header.version);

      for (var tableTag in tables) {
        builder.addTable(tableTag, tables[tableTag].data);
      }

      return builder.toArray();
    },
    convert: function Font_convert(fontName, font, properties) {
      properties.fixedPitch = false;

      if (properties.builtInEncoding) {
        adjustToUnicode(properties, properties.builtInEncoding);
      }

      var glyphZeroId = 1;

      if (font instanceof CFFFont) {
        glyphZeroId = font.numGlyphs - 1;
      }

      var mapping = font.getGlyphMapping(properties);
      var newMapping = adjustMapping(mapping, font.hasGlyphId.bind(font), glyphZeroId);
      this.toFontChar = newMapping.toFontChar;
      var numGlyphs = font.numGlyphs;

      function getCharCodes(charCodeToGlyphId, glyphId) {
        var charCodes = null;

        for (var charCode in charCodeToGlyphId) {
          if (glyphId === charCodeToGlyphId[charCode]) {
            if (!charCodes) {
              charCodes = [];
            }

            charCodes.push(charCode | 0);
          }
        }

        return charCodes;
      }

      function createCharCode(charCodeToGlyphId, glyphId) {
        for (var charCode in charCodeToGlyphId) {
          if (glyphId === charCodeToGlyphId[charCode]) {
            return charCode | 0;
          }
        }

        newMapping.charCodeToGlyphId[newMapping.nextAvailableFontCharCode] = glyphId;
        return newMapping.nextAvailableFontCharCode++;
      }

      var seacs = font.seacs;

      if (SEAC_ANALYSIS_ENABLED && seacs && seacs.length) {
        var matrix = properties.fontMatrix || _util.FONT_IDENTITY_MATRIX;
        var charset = font.getCharset();
        var seacMap = Object.create(null);

        for (var glyphId in seacs) {
          glyphId |= 0;
          var seac = seacs[glyphId];
          var baseGlyphName = _encodings.StandardEncoding[seac[2]];
          var accentGlyphName = _encodings.StandardEncoding[seac[3]];
          var baseGlyphId = charset.indexOf(baseGlyphName);
          var accentGlyphId = charset.indexOf(accentGlyphName);

          if (baseGlyphId < 0 || accentGlyphId < 0) {
            continue;
          }

          var accentOffset = {
            x: seac[0] * matrix[0] + seac[1] * matrix[2] + matrix[4],
            y: seac[0] * matrix[1] + seac[1] * matrix[3] + matrix[5]
          };
          var charCodes = getCharCodes(mapping, glyphId);

          if (!charCodes) {
            continue;
          }

          for (var i = 0, ii = charCodes.length; i < ii; i++) {
            var charCode = charCodes[i];
            var charCodeToGlyphId = newMapping.charCodeToGlyphId;
            var baseFontCharCode = createCharCode(charCodeToGlyphId, baseGlyphId);
            var accentFontCharCode = createCharCode(charCodeToGlyphId, accentGlyphId);
            seacMap[charCode] = {
              baseFontCharCode: baseFontCharCode,
              accentFontCharCode: accentFontCharCode,
              accentOffset: accentOffset
            };
          }
        }

        properties.seacMap = seacMap;
      }

      var unitsPerEm = 1 / (properties.fontMatrix || _util.FONT_IDENTITY_MATRIX)[0];
      var builder = new OpenTypeFileBuilder('\x4F\x54\x54\x4F');
      builder.addTable('CFF ', font.data);
      builder.addTable('OS/2', createOS2Table(properties, newMapping.charCodeToGlyphId));
      builder.addTable('cmap', createCmapTable(newMapping.charCodeToGlyphId, numGlyphs));
      builder.addTable('head', '\x00\x01\x00\x00' + '\x00\x00\x10\x00' + '\x00\x00\x00\x00' + '\x5F\x0F\x3C\xF5' + '\x00\x00' + safeString16(unitsPerEm) + '\x00\x00\x00\x00\x9e\x0b\x7e\x27' + '\x00\x00\x00\x00\x9e\x0b\x7e\x27' + '\x00\x00' + safeString16(properties.descent) + '\x0F\xFF' + safeString16(properties.ascent) + string16(properties.italicAngle ? 2 : 0) + '\x00\x11' + '\x00\x00' + '\x00\x00' + '\x00\x00');
      builder.addTable('hhea', '\x00\x01\x00\x00' + safeString16(properties.ascent) + safeString16(properties.descent) + '\x00\x00' + '\xFF\xFF' + '\x00\x00' + '\x00\x00' + '\x00\x00' + safeString16(properties.capHeight) + safeString16(Math.tan(properties.italicAngle) * properties.xHeight) + '\x00\x00' + '\x00\x00' + '\x00\x00' + '\x00\x00' + '\x00\x00' + '\x00\x00' + string16(numGlyphs));
      builder.addTable('hmtx', function fontFieldsHmtx() {
        var charstrings = font.charstrings;
        var cffWidths = font.cff ? font.cff.widths : null;
        var hmtx = '\x00\x00\x00\x00';

        for (var i = 1, ii = numGlyphs; i < ii; i++) {
          var width = 0;

          if (charstrings) {
            var charstring = charstrings[i - 1];
            width = 'width' in charstring ? charstring.width : 0;
          } else if (cffWidths) {
            width = Math.ceil(cffWidths[i] || 0);
          }

          hmtx += string16(width) + string16(0);
        }

        return hmtx;
      }());
      builder.addTable('maxp', '\x00\x00\x50\x00' + string16(numGlyphs));
      builder.addTable('name', createNameTable(fontName));
      builder.addTable('post', createPostTable(properties));
      return builder.toArray();
    },

    get spaceWidth() {
      if ('_shadowWidth' in this) {
        return this._shadowWidth;
      }

      var possibleSpaceReplacements = ['space', 'minus', 'one', 'i', 'I'];
      var width;

      for (var i = 0, ii = possibleSpaceReplacements.length; i < ii; i++) {
        var glyphName = possibleSpaceReplacements[i];

        if (glyphName in this.widths) {
          width = this.widths[glyphName];
          break;
        }

        var glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();
        var glyphUnicode = glyphsUnicodeMap[glyphName];
        var charcode = 0;

        if (this.composite) {
          if (this.cMap.contains(glyphUnicode)) {
            charcode = this.cMap.lookup(glyphUnicode);
          }
        }

        if (!charcode && this.toUnicode) {
          charcode = this.toUnicode.charCodeOf(glyphUnicode);
        }

        if (charcode <= 0) {
          charcode = glyphUnicode;
        }

        width = this.widths[charcode];

        if (width) {
          break;
        }
      }

      width = width || this.defaultWidth;
      this._shadowWidth = width;
      return width;
    },

    charToGlyph: function Font_charToGlyph(charcode, isSpace) {
      var fontCharCode, width, operatorListId;
      var widthCode = charcode;

      if (this.cMap && this.cMap.contains(charcode)) {
        widthCode = this.cMap.lookup(charcode);
      }

      width = this.widths[widthCode];
      width = (0, _util.isNum)(width) ? width : this.defaultWidth;
      var vmetric = this.vmetrics && this.vmetrics[widthCode];
      var unicode = this.toUnicode.get(charcode) || this.fallbackToUnicode.get(charcode) || charcode;

      if (typeof unicode === 'number') {
        unicode = String.fromCharCode(unicode);
      }

      var isInFont = charcode in this.toFontChar;
      fontCharCode = this.toFontChar[charcode] || charcode;

      if (this.missingFile) {
        fontCharCode = (0, _unicode.mapSpecialUnicodeValues)(fontCharCode);
      }

      if (this.isType3Font) {
        operatorListId = fontCharCode;
      }

      var accent = null;

      if (this.seacMap && this.seacMap[charcode]) {
        isInFont = true;
        var seac = this.seacMap[charcode];
        fontCharCode = seac.baseFontCharCode;
        accent = {
          fontChar: String.fromCodePoint(seac.accentFontCharCode),
          offset: seac.accentOffset
        };
      }

      var fontChar = typeof fontCharCode === 'number' ? String.fromCodePoint(fontCharCode) : '';
      var glyph = this.glyphCache[charcode];

      if (!glyph || !glyph.matchesForCache(fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont)) {
        glyph = new Glyph(fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont);
        this.glyphCache[charcode] = glyph;
      }

      return glyph;
    },
    charsToGlyphs: function Font_charsToGlyphs(chars) {
      var charsCache = this.charsCache;
      var glyphs, glyph, charcode;

      if (charsCache) {
        glyphs = charsCache[chars];

        if (glyphs) {
          return glyphs;
        }
      }

      if (!charsCache) {
        charsCache = this.charsCache = Object.create(null);
      }

      glyphs = [];
      var charsCacheKey = chars;
      var i = 0,
          ii;

      if (this.cMap) {
        var c = Object.create(null);

        while (i < chars.length) {
          this.cMap.readCharCode(chars, i, c);
          charcode = c.charcode;
          var length = c.length;
          i += length;
          var isSpace = length === 1 && chars.charCodeAt(i - 1) === 0x20;
          glyph = this.charToGlyph(charcode, isSpace);
          glyphs.push(glyph);
        }
      } else {
        for (i = 0, ii = chars.length; i < ii; ++i) {
          charcode = chars.charCodeAt(i);
          glyph = this.charToGlyph(charcode, charcode === 0x20);
          glyphs.push(glyph);
        }
      }

      return charsCache[charsCacheKey] = glyphs;
    },

    get glyphCacheValues() {
      return Object.values(this.glyphCache);
    }

  };
  return Font;
}();

exports.Font = Font;

var ErrorFont = function ErrorFontClosure() {
  function ErrorFont(error) {
    this.error = error;
    this.loadedName = 'g_font_error';
    this.missingFile = true;
  }

  ErrorFont.prototype = {
    charsToGlyphs: function ErrorFont_charsToGlyphs() {
      return [];
    },
    exportData: function ErrorFont_exportData() {
      return {
        error: this.error
      };
    }
  };
  return ErrorFont;
}();

exports.ErrorFont = ErrorFont;

function type1FontGlyphMapping(properties, builtInEncoding, glyphNames) {
  var charCodeToGlyphId = Object.create(null);
  var glyphId, charCode, baseEncoding;
  var isSymbolicFont = !!(properties.flags & FontFlags.Symbolic);

  if (properties.baseEncodingName) {
    baseEncoding = (0, _encodings.getEncoding)(properties.baseEncodingName);

    for (charCode = 0; charCode < baseEncoding.length; charCode++) {
      glyphId = glyphNames.indexOf(baseEncoding[charCode]);

      if (glyphId >= 0) {
        charCodeToGlyphId[charCode] = glyphId;
      } else {
        charCodeToGlyphId[charCode] = 0;
      }
    }
  } else if (isSymbolicFont) {
    for (charCode in builtInEncoding) {
      charCodeToGlyphId[charCode] = builtInEncoding[charCode];
    }
  } else {
    baseEncoding = _encodings.StandardEncoding;

    for (charCode = 0; charCode < baseEncoding.length; charCode++) {
      glyphId = glyphNames.indexOf(baseEncoding[charCode]);

      if (glyphId >= 0) {
        charCodeToGlyphId[charCode] = glyphId;
      } else {
        charCodeToGlyphId[charCode] = 0;
      }
    }
  }

  var differences = properties.differences,
      glyphsUnicodeMap;

  if (differences) {
    for (charCode in differences) {
      var glyphName = differences[charCode];
      glyphId = glyphNames.indexOf(glyphName);

      if (glyphId === -1) {
        if (!glyphsUnicodeMap) {
          glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();
        }

        var standardGlyphName = recoverGlyphName(glyphName, glyphsUnicodeMap);

        if (standardGlyphName !== glyphName) {
          glyphId = glyphNames.indexOf(standardGlyphName);
        }
      }

      if (glyphId >= 0) {
        charCodeToGlyphId[charCode] = glyphId;
      } else {
        charCodeToGlyphId[charCode] = 0;
      }
    }
  }

  return charCodeToGlyphId;
}

var Type1Font = function Type1FontClosure() {
  function findBlock(streamBytes, signature, startIndex) {
    var streamBytesLength = streamBytes.length;
    var signatureLength = signature.length;
    var scanLength = streamBytesLength - signatureLength;
    var i = startIndex,
        j,
        found = false;

    while (i < scanLength) {
      j = 0;

      while (j < signatureLength && streamBytes[i + j] === signature[j]) {
        j++;
      }

      if (j >= signatureLength) {
        i += j;

        while (i < streamBytesLength && (0, _util.isSpace)(streamBytes[i])) {
          i++;
        }

        found = true;
        break;
      }

      i++;
    }

    return {
      found: found,
      length: i
    };
  }

  function getHeaderBlock(stream, suggestedLength) {
    var EEXEC_SIGNATURE = [0x65, 0x65, 0x78, 0x65, 0x63];
    var streamStartPos = stream.pos;
    var headerBytes, headerBytesLength, block;

    try {
      headerBytes = stream.getBytes(suggestedLength);
      headerBytesLength = headerBytes.length;
    } catch (ex) {
      if (ex instanceof _util.MissingDataException) {
        throw ex;
      }
    }

    if (headerBytesLength === suggestedLength) {
      block = findBlock(headerBytes, EEXEC_SIGNATURE, suggestedLength - 2 * EEXEC_SIGNATURE.length);

      if (block.found && block.length === suggestedLength) {
        return {
          stream: new _stream.Stream(headerBytes),
          length: suggestedLength
        };
      }
    }

    (0, _util.warn)('Invalid "Length1" property in Type1 font -- trying to recover.');
    stream.pos = streamStartPos;
    var SCAN_BLOCK_LENGTH = 2048;
    var actualLength;

    while (true) {
      var scanBytes = stream.peekBytes(SCAN_BLOCK_LENGTH);
      block = findBlock(scanBytes, EEXEC_SIGNATURE, 0);

      if (block.length === 0) {
        break;
      }

      stream.pos += block.length;

      if (block.found) {
        actualLength = stream.pos - streamStartPos;
        break;
      }
    }

    stream.pos = streamStartPos;

    if (actualLength) {
      return {
        stream: new _stream.Stream(stream.getBytes(actualLength)),
        length: actualLength
      };
    }

    (0, _util.warn)('Unable to recover "Length1" property in Type1 font -- using as is.');
    return {
      stream: new _stream.Stream(stream.getBytes(suggestedLength)),
      length: suggestedLength
    };
  }

  function getEexecBlock(stream, suggestedLength) {
    var eexecBytes = stream.getBytes();
    return {
      stream: new _stream.Stream(eexecBytes),
      length: eexecBytes.length
    };
  }

  function Type1Font(name, file, properties) {
    var PFB_HEADER_SIZE = 6;
    var headerBlockLength = properties.length1;
    var eexecBlockLength = properties.length2;
    var pfbHeader = file.peekBytes(PFB_HEADER_SIZE);
    var pfbHeaderPresent = pfbHeader[0] === 0x80 && pfbHeader[1] === 0x01;

    if (pfbHeaderPresent) {
      file.skip(PFB_HEADER_SIZE);
      headerBlockLength = pfbHeader[5] << 24 | pfbHeader[4] << 16 | pfbHeader[3] << 8 | pfbHeader[2];
    }

    var headerBlock = getHeaderBlock(file, headerBlockLength);
    var headerBlockParser = new _type1_parser.Type1Parser(headerBlock.stream, false, SEAC_ANALYSIS_ENABLED);
    headerBlockParser.extractFontHeader(properties);

    if (pfbHeaderPresent) {
      pfbHeader = file.getBytes(PFB_HEADER_SIZE);
      eexecBlockLength = pfbHeader[5] << 24 | pfbHeader[4] << 16 | pfbHeader[3] << 8 | pfbHeader[2];
    }

    var eexecBlock = getEexecBlock(file, eexecBlockLength);
    var eexecBlockParser = new _type1_parser.Type1Parser(eexecBlock.stream, true, SEAC_ANALYSIS_ENABLED);
    var data = eexecBlockParser.extractFontProgram();

    for (var info in data.properties) {
      properties[info] = data.properties[info];
    }

    var charstrings = data.charstrings;
    var type2Charstrings = this.getType2Charstrings(charstrings);
    var subrs = this.getType2Subrs(data.subrs);
    this.charstrings = charstrings;
    this.data = this.wrap(name, type2Charstrings, this.charstrings, subrs, properties);
    this.seacs = this.getSeacs(data.charstrings);
  }

  Type1Font.prototype = {
    get numGlyphs() {
      return this.charstrings.length + 1;
    },

    getCharset: function Type1Font_getCharset() {
      var charset = ['.notdef'];
      var charstrings = this.charstrings;

      for (var glyphId = 0; glyphId < charstrings.length; glyphId++) {
        charset.push(charstrings[glyphId].glyphName);
      }

      return charset;
    },
    getGlyphMapping: function Type1Font_getGlyphMapping(properties) {
      var charstrings = this.charstrings;
      var glyphNames = ['.notdef'],
          glyphId;

      for (glyphId = 0; glyphId < charstrings.length; glyphId++) {
        glyphNames.push(charstrings[glyphId].glyphName);
      }

      var encoding = properties.builtInEncoding;

      if (encoding) {
        var builtInEncoding = Object.create(null);

        for (var charCode in encoding) {
          glyphId = glyphNames.indexOf(encoding[charCode]);

          if (glyphId >= 0) {
            builtInEncoding[charCode] = glyphId;
          }
        }
      }

      return type1FontGlyphMapping(properties, builtInEncoding, glyphNames);
    },
    hasGlyphId: function Type1Font_hasGlyphID(id) {
      if (id < 0 || id >= this.numGlyphs) {
        return false;
      }

      if (id === 0) {
        return true;
      }

      var glyph = this.charstrings[id - 1];
      return glyph.charstring.length > 0;
    },
    getSeacs: function Type1Font_getSeacs(charstrings) {
      var i, ii;
      var seacMap = [];

      for (i = 0, ii = charstrings.length; i < ii; i++) {
        var charstring = charstrings[i];

        if (charstring.seac) {
          seacMap[i + 1] = charstring.seac;
        }
      }

      return seacMap;
    },
    getType2Charstrings: function Type1Font_getType2Charstrings(type1Charstrings) {
      var type2Charstrings = [];

      for (var i = 0, ii = type1Charstrings.length; i < ii; i++) {
        type2Charstrings.push(type1Charstrings[i].charstring);
      }

      return type2Charstrings;
    },
    getType2Subrs: function Type1Font_getType2Subrs(type1Subrs) {
      var bias = 0;
      var count = type1Subrs.length;

      if (count < 1133) {
        bias = 107;
      } else if (count < 33769) {
        bias = 1131;
      } else {
        bias = 32768;
      }

      var type2Subrs = [];
      var i;

      for (i = 0; i < bias; i++) {
        type2Subrs.push([0x0B]);
      }

      for (i = 0; i < count; i++) {
        type2Subrs.push(type1Subrs[i]);
      }

      return type2Subrs;
    },
    wrap: function Type1Font_wrap(name, glyphs, charstrings, subrs, properties) {
      var cff = new _cff_parser.CFF();
      cff.header = new _cff_parser.CFFHeader(1, 0, 4, 4);
      cff.names = [name];
      var topDict = new _cff_parser.CFFTopDict();
      topDict.setByName('version', 391);
      topDict.setByName('Notice', 392);
      topDict.setByName('FullName', 393);
      topDict.setByName('FamilyName', 394);
      topDict.setByName('Weight', 395);
      topDict.setByName('Encoding', null);
      topDict.setByName('FontMatrix', properties.fontMatrix);
      topDict.setByName('FontBBox', properties.bbox);
      topDict.setByName('charset', null);
      topDict.setByName('CharStrings', null);
      topDict.setByName('Private', null);
      cff.topDict = topDict;
      var strings = new _cff_parser.CFFStrings();
      strings.add('Version 0.11');
      strings.add('See original notice');
      strings.add(name);
      strings.add(name);
      strings.add('Medium');
      cff.strings = strings;
      cff.globalSubrIndex = new _cff_parser.CFFIndex();
      var count = glyphs.length;
      var charsetArray = [0];
      var i, ii;

      for (i = 0; i < count; i++) {
        var index = _cff_parser.CFFStandardStrings.indexOf(charstrings[i].glyphName);

        if (index === -1) {
          index = 0;
        }

        charsetArray.push(index >> 8 & 0xff, index & 0xff);
      }

      cff.charset = new _cff_parser.CFFCharset(false, 0, [], charsetArray);
      var charStringsIndex = new _cff_parser.CFFIndex();
      charStringsIndex.add([0x8B, 0x0E]);

      for (i = 0; i < count; i++) {
        charStringsIndex.add(glyphs[i]);
      }

      cff.charStrings = charStringsIndex;
      var privateDict = new _cff_parser.CFFPrivateDict();
      privateDict.setByName('Subrs', null);
      var fields = ['BlueValues', 'OtherBlues', 'FamilyBlues', 'FamilyOtherBlues', 'StemSnapH', 'StemSnapV', 'BlueShift', 'BlueFuzz', 'BlueScale', 'LanguageGroup', 'ExpansionFactor', 'ForceBold', 'StdHW', 'StdVW'];

      for (i = 0, ii = fields.length; i < ii; i++) {
        var field = fields[i];

        if (!(field in properties.privateData)) {
          continue;
        }

        var value = properties.privateData[field];

        if (Array.isArray(value)) {
          for (var j = value.length - 1; j > 0; j--) {
            value[j] -= value[j - 1];
          }
        }

        privateDict.setByName(field, value);
      }

      cff.topDict.privateDict = privateDict;
      var subrIndex = new _cff_parser.CFFIndex();

      for (i = 0, ii = subrs.length; i < ii; i++) {
        subrIndex.add(subrs[i]);
      }

      privateDict.subrsIndex = subrIndex;
      var compiler = new _cff_parser.CFFCompiler(cff);
      return compiler.compile();
    }
  };
  return Type1Font;
}();

var CFFFont = function CFFFontClosure() {
  function CFFFont(file, properties) {
    this.properties = properties;
    var parser = new _cff_parser.CFFParser(file, properties, SEAC_ANALYSIS_ENABLED);
    this.cff = parser.parse();
    this.cff.duplicateFirstGlyph();
    var compiler = new _cff_parser.CFFCompiler(this.cff);
    this.seacs = this.cff.seacs;

    try {
      this.data = compiler.compile();
    } catch (e) {
      (0, _util.warn)('Failed to compile font ' + properties.loadedName);
      this.data = file;
    }
  }

  CFFFont.prototype = {
    get numGlyphs() {
      return this.cff.charStrings.count;
    },

    getCharset: function CFFFont_getCharset() {
      return this.cff.charset.charset;
    },
    getGlyphMapping: function CFFFont_getGlyphMapping() {
      var cff = this.cff;
      var properties = this.properties;
      var charsets = cff.charset.charset;
      var charCodeToGlyphId;
      var glyphId;

      if (properties.composite) {
        charCodeToGlyphId = Object.create(null);

        if (cff.isCIDFont) {
          for (glyphId = 0; glyphId < charsets.length; glyphId++) {
            var cid = charsets[glyphId];
            var charCode = properties.cMap.charCodeOf(cid);
            charCodeToGlyphId[charCode] = glyphId;
          }
        } else {
          for (glyphId = 0; glyphId < cff.charStrings.count; glyphId++) {
            charCodeToGlyphId[glyphId] = glyphId;
          }
        }

        return charCodeToGlyphId;
      }

      var encoding = cff.encoding ? cff.encoding.encoding : null;
      charCodeToGlyphId = type1FontGlyphMapping(properties, encoding, charsets);
      return charCodeToGlyphId;
    },
    hasGlyphId: function CFFFont_hasGlyphID(id) {
      return this.cff.hasGlyphId(id);
    }
  };
  return CFFFont;
}();

/***/ }),
/* 174 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CFFFDSelect = exports.CFFCompiler = exports.CFFPrivateDict = exports.CFFTopDict = exports.CFFCharset = exports.CFFIndex = exports.CFFStrings = exports.CFFHeader = exports.CFF = exports.CFFParser = exports.CFFStandardStrings = void 0;

var _util = __w_pdfjs_require__(6);

var _charsets = __w_pdfjs_require__(175);

var _encodings = __w_pdfjs_require__(176);

var MAX_SUBR_NESTING = 10;
var CFFStandardStrings = ['.notdef', 'space', 'exclam', 'quotedbl', 'numbersign', 'dollar', 'percent', 'ampersand', 'quoteright', 'parenleft', 'parenright', 'asterisk', 'plus', 'comma', 'hyphen', 'period', 'slash', 'zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine', 'colon', 'semicolon', 'less', 'equal', 'greater', 'question', 'at', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'bracketleft', 'backslash', 'bracketright', 'asciicircum', 'underscore', 'quoteleft', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'braceleft', 'bar', 'braceright', 'asciitilde', 'exclamdown', 'cent', 'sterling', 'fraction', 'yen', 'florin', 'section', 'currency', 'quotesingle', 'quotedblleft', 'guillemotleft', 'guilsinglleft', 'guilsinglright', 'fi', 'fl', 'endash', 'dagger', 'daggerdbl', 'periodcentered', 'paragraph', 'bullet', 'quotesinglbase', 'quotedblbase', 'quotedblright', 'guillemotright', 'ellipsis', 'perthousand', 'questiondown', 'grave', 'acute', 'circumflex', 'tilde', 'macron', 'breve', 'dotaccent', 'dieresis', 'ring', 'cedilla', 'hungarumlaut', 'ogonek', 'caron', 'emdash', 'AE', 'ordfeminine', 'Lslash', 'Oslash', 'OE', 'ordmasculine', 'ae', 'dotlessi', 'lslash', 'oslash', 'oe', 'germandbls', 'onesuperior', 'logicalnot', 'mu', 'trademark', 'Eth', 'onehalf', 'plusminus', 'Thorn', 'onequarter', 'divide', 'brokenbar', 'degree', 'thorn', 'threequarters', 'twosuperior', 'registered', 'minus', 'eth', 'multiply', 'threesuperior', 'copyright', 'Aacute', 'Acircumflex', 'Adieresis', 'Agrave', 'Aring', 'Atilde', 'Ccedilla', 'Eacute', 'Ecircumflex', 'Edieresis', 'Egrave', 'Iacute', 'Icircumflex', 'Idieresis', 'Igrave', 'Ntilde', 'Oacute', 'Ocircumflex', 'Odieresis', 'Ograve', 'Otilde', 'Scaron', 'Uacute', 'Ucircumflex', 'Udieresis', 'Ugrave', 'Yacute', 'Ydieresis', 'Zcaron', 'aacute', 'acircumflex', 'adieresis', 'agrave', 'aring', 'atilde', 'ccedilla', 'eacute', 'ecircumflex', 'edieresis', 'egrave', 'iacute', 'icircumflex', 'idieresis', 'igrave', 'ntilde', 'oacute', 'ocircumflex', 'odieresis', 'ograve', 'otilde', 'scaron', 'uacute', 'ucircumflex', 'udieresis', 'ugrave', 'yacute', 'ydieresis', 'zcaron', 'exclamsmall', 'Hungarumlautsmall', 'dollaroldstyle', 'dollarsuperior', 'ampersandsmall', 'Acutesmall', 'parenleftsuperior', 'parenrightsuperior', 'twodotenleader', 'onedotenleader', 'zerooldstyle', 'oneoldstyle', 'twooldstyle', 'threeoldstyle', 'fouroldstyle', 'fiveoldstyle', 'sixoldstyle', 'sevenoldstyle', 'eightoldstyle', 'nineoldstyle', 'commasuperior', 'threequartersemdash', 'periodsuperior', 'questionsmall', 'asuperior', 'bsuperior', 'centsuperior', 'dsuperior', 'esuperior', 'isuperior', 'lsuperior', 'msuperior', 'nsuperior', 'osuperior', 'rsuperior', 'ssuperior', 'tsuperior', 'ff', 'ffi', 'ffl', 'parenleftinferior', 'parenrightinferior', 'Circumflexsmall', 'hyphensuperior', 'Gravesmall', 'Asmall', 'Bsmall', 'Csmall', 'Dsmall', 'Esmall', 'Fsmall', 'Gsmall', 'Hsmall', 'Ismall', 'Jsmall', 'Ksmall', 'Lsmall', 'Msmall', 'Nsmall', 'Osmall', 'Psmall', 'Qsmall', 'Rsmall', 'Ssmall', 'Tsmall', 'Usmall', 'Vsmall', 'Wsmall', 'Xsmall', 'Ysmall', 'Zsmall', 'colonmonetary', 'onefitted', 'rupiah', 'Tildesmall', 'exclamdownsmall', 'centoldstyle', 'Lslashsmall', 'Scaronsmall', 'Zcaronsmall', 'Dieresissmall', 'Brevesmall', 'Caronsmall', 'Dotaccentsmall', 'Macronsmall', 'figuredash', 'hypheninferior', 'Ogoneksmall', 'Ringsmall', 'Cedillasmall', 'questiondownsmall', 'oneeighth', 'threeeighths', 'fiveeighths', 'seveneighths', 'onethird', 'twothirds', 'zerosuperior', 'foursuperior', 'fivesuperior', 'sixsuperior', 'sevensuperior', 'eightsuperior', 'ninesuperior', 'zeroinferior', 'oneinferior', 'twoinferior', 'threeinferior', 'fourinferior', 'fiveinferior', 'sixinferior', 'seveninferior', 'eightinferior', 'nineinferior', 'centinferior', 'dollarinferior', 'periodinferior', 'commainferior', 'Agravesmall', 'Aacutesmall', 'Acircumflexsmall', 'Atildesmall', 'Adieresissmall', 'Aringsmall', 'AEsmall', 'Ccedillasmall', 'Egravesmall', 'Eacutesmall', 'Ecircumflexsmall', 'Edieresissmall', 'Igravesmall', 'Iacutesmall', 'Icircumflexsmall', 'Idieresissmall', 'Ethsmall', 'Ntildesmall', 'Ogravesmall', 'Oacutesmall', 'Ocircumflexsmall', 'Otildesmall', 'Odieresissmall', 'OEsmall', 'Oslashsmall', 'Ugravesmall', 'Uacutesmall', 'Ucircumflexsmall', 'Udieresissmall', 'Yacutesmall', 'Thornsmall', 'Ydieresissmall', '001.000', '001.001', '001.002', '001.003', 'Black', 'Bold', 'Book', 'Light', 'Medium', 'Regular', 'Roman', 'Semibold'];
exports.CFFStandardStrings = CFFStandardStrings;

var CFFParser = function CFFParserClosure() {
  var CharstringValidationData = [null, {
    id: 'hstem',
    min: 2,
    stackClearing: true,
    stem: true
  }, null, {
    id: 'vstem',
    min: 2,
    stackClearing: true,
    stem: true
  }, {
    id: 'vmoveto',
    min: 1,
    stackClearing: true
  }, {
    id: 'rlineto',
    min: 2,
    resetStack: true
  }, {
    id: 'hlineto',
    min: 1,
    resetStack: true
  }, {
    id: 'vlineto',
    min: 1,
    resetStack: true
  }, {
    id: 'rrcurveto',
    min: 6,
    resetStack: true
  }, null, {
    id: 'callsubr',
    min: 1,
    undefStack: true
  }, {
    id: 'return',
    min: 0,
    undefStack: true
  }, null, null, {
    id: 'endchar',
    min: 0,
    stackClearing: true
  }, null, null, null, {
    id: 'hstemhm',
    min: 2,
    stackClearing: true,
    stem: true
  }, {
    id: 'hintmask',
    min: 0,
    stackClearing: true
  }, {
    id: 'cntrmask',
    min: 0,
    stackClearing: true
  }, {
    id: 'rmoveto',
    min: 2,
    stackClearing: true
  }, {
    id: 'hmoveto',
    min: 1,
    stackClearing: true
  }, {
    id: 'vstemhm',
    min: 2,
    stackClearing: true,
    stem: true
  }, {
    id: 'rcurveline',
    min: 8,
    resetStack: true
  }, {
    id: 'rlinecurve',
    min: 8,
    resetStack: true
  }, {
    id: 'vvcurveto',
    min: 4,
    resetStack: true
  }, {
    id: 'hhcurveto',
    min: 4,
    resetStack: true
  }, null, {
    id: 'callgsubr',
    min: 1,
    undefStack: true
  }, {
    id: 'vhcurveto',
    min: 4,
    resetStack: true
  }, {
    id: 'hvcurveto',
    min: 4,
    resetStack: true
  }];
  var CharstringValidationData12 = [null, null, null, {
    id: 'and',
    min: 2,
    stackDelta: -1
  }, {
    id: 'or',
    min: 2,
    stackDelta: -1
  }, {
    id: 'not',
    min: 1,
    stackDelta: 0
  }, null, null, null, {
    id: 'abs',
    min: 1,
    stackDelta: 0
  }, {
    id: 'add',
    min: 2,
    stackDelta: -1,
    stackFn: function stack_div(stack, index) {
      stack[index - 2] = stack[index - 2] + stack[index - 1];
    }
  }, {
    id: 'sub',
    min: 2,
    stackDelta: -1,
    stackFn: function stack_div(stack, index) {
      stack[index - 2] = stack[index - 2] - stack[index - 1];
    }
  }, {
    id: 'div',
    min: 2,
    stackDelta: -1,
    stackFn: function stack_div(stack, index) {
      stack[index - 2] = stack[index - 2] / stack[index - 1];
    }
  }, null, {
    id: 'neg',
    min: 1,
    stackDelta: 0,
    stackFn: function stack_div(stack, index) {
      stack[index - 1] = -stack[index - 1];
    }
  }, {
    id: 'eq',
    min: 2,
    stackDelta: -1
  }, null, null, {
    id: 'drop',
    min: 1,
    stackDelta: -1
  }, null, {
    id: 'put',
    min: 2,
    stackDelta: -2
  }, {
    id: 'get',
    min: 1,
    stackDelta: 0
  }, {
    id: 'ifelse',
    min: 4,
    stackDelta: -3
  }, {
    id: 'random',
    min: 0,
    stackDelta: 1
  }, {
    id: 'mul',
    min: 2,
    stackDelta: -1,
    stackFn: function stack_div(stack, index) {
      stack[index - 2] = stack[index - 2] * stack[index - 1];
    }
  }, null, {
    id: 'sqrt',
    min: 1,
    stackDelta: 0
  }, {
    id: 'dup',
    min: 1,
    stackDelta: 1
  }, {
    id: 'exch',
    min: 2,
    stackDelta: 0
  }, {
    id: 'index',
    min: 2,
    stackDelta: 0
  }, {
    id: 'roll',
    min: 3,
    stackDelta: -2
  }, null, null, null, {
    id: 'hflex',
    min: 7,
    resetStack: true
  }, {
    id: 'flex',
    min: 13,
    resetStack: true
  }, {
    id: 'hflex1',
    min: 9,
    resetStack: true
  }, {
    id: 'flex1',
    min: 11,
    resetStack: true
  }];

  function CFFParser(file, properties, seacAnalysisEnabled) {
    this.bytes = file.getBytes();
    this.properties = properties;
    this.seacAnalysisEnabled = !!seacAnalysisEnabled;
  }

  CFFParser.prototype = {
    parse: function CFFParser_parse() {
      var properties = this.properties;
      var cff = new CFF();
      this.cff = cff;
      var header = this.parseHeader();
      var nameIndex = this.parseIndex(header.endPos);
      var topDictIndex = this.parseIndex(nameIndex.endPos);
      var stringIndex = this.parseIndex(topDictIndex.endPos);
      var globalSubrIndex = this.parseIndex(stringIndex.endPos);
      var topDictParsed = this.parseDict(topDictIndex.obj.get(0));
      var topDict = this.createDict(CFFTopDict, topDictParsed, cff.strings);
      cff.header = header.obj;
      cff.names = this.parseNameIndex(nameIndex.obj);
      cff.strings = this.parseStringIndex(stringIndex.obj);
      cff.topDict = topDict;
      cff.globalSubrIndex = globalSubrIndex.obj;
      this.parsePrivateDict(cff.topDict);
      cff.isCIDFont = topDict.hasName('ROS');
      var charStringOffset = topDict.getByName('CharStrings');
      var charStringIndex = this.parseIndex(charStringOffset).obj;
      var fontMatrix = topDict.getByName('FontMatrix');

      if (fontMatrix) {
        properties.fontMatrix = fontMatrix;
      }

      var fontBBox = topDict.getByName('FontBBox');

      if (fontBBox) {
        properties.ascent = Math.max(fontBBox[3], fontBBox[1]);
        properties.descent = Math.min(fontBBox[1], fontBBox[3]);
        properties.ascentScaled = true;
      }

      var charset, encoding;

      if (cff.isCIDFont) {
        var fdArrayIndex = this.parseIndex(topDict.getByName('FDArray')).obj;

        for (var i = 0, ii = fdArrayIndex.count; i < ii; ++i) {
          var dictRaw = fdArrayIndex.get(i);
          var fontDict = this.createDict(CFFTopDict, this.parseDict(dictRaw), cff.strings);
          this.parsePrivateDict(fontDict);
          cff.fdArray.push(fontDict);
        }

        encoding = null;
        charset = this.parseCharsets(topDict.getByName('charset'), charStringIndex.count, cff.strings, true);
        cff.fdSelect = this.parseFDSelect(topDict.getByName('FDSelect'), charStringIndex.count);
      } else {
        charset = this.parseCharsets(topDict.getByName('charset'), charStringIndex.count, cff.strings, false);
        encoding = this.parseEncoding(topDict.getByName('Encoding'), properties, cff.strings, charset.charset);
      }

      cff.charset = charset;
      cff.encoding = encoding;
      var charStringsAndSeacs = this.parseCharStrings({
        charStrings: charStringIndex,
        localSubrIndex: topDict.privateDict.subrsIndex,
        globalSubrIndex: globalSubrIndex.obj,
        fdSelect: cff.fdSelect,
        fdArray: cff.fdArray,
        privateDict: topDict.privateDict
      });
      cff.charStrings = charStringsAndSeacs.charStrings;
      cff.seacs = charStringsAndSeacs.seacs;
      cff.widths = charStringsAndSeacs.widths;
      return cff;
    },
    parseHeader: function CFFParser_parseHeader() {
      var bytes = this.bytes;
      var bytesLength = bytes.length;
      var offset = 0;

      while (offset < bytesLength && bytes[offset] !== 1) {
        ++offset;
      }

      if (offset >= bytesLength) {
        throw new _util.FormatError('Invalid CFF header');
      }

      if (offset !== 0) {
        (0, _util.info)('cff data is shifted');
        bytes = bytes.subarray(offset);
        this.bytes = bytes;
      }

      var major = bytes[0];
      var minor = bytes[1];
      var hdrSize = bytes[2];
      var offSize = bytes[3];
      var header = new CFFHeader(major, minor, hdrSize, offSize);
      return {
        obj: header,
        endPos: hdrSize
      };
    },
    parseDict: function CFFParser_parseDict(dict) {
      var pos = 0;

      function parseOperand() {
        var value = dict[pos++];

        if (value === 30) {
          return parseFloatOperand();
        } else if (value === 28) {
          value = dict[pos++];
          value = (value << 24 | dict[pos++] << 16) >> 16;
          return value;
        } else if (value === 29) {
          value = dict[pos++];
          value = value << 8 | dict[pos++];
          value = value << 8 | dict[pos++];
          value = value << 8 | dict[pos++];
          return value;
        } else if (value >= 32 && value <= 246) {
          return value - 139;
        } else if (value >= 247 && value <= 250) {
          return (value - 247) * 256 + dict[pos++] + 108;
        } else if (value >= 251 && value <= 254) {
          return -((value - 251) * 256) - dict[pos++] - 108;
        }

        (0, _util.warn)('CFFParser_parseDict: "' + value + '" is a reserved command.');
        return NaN;
      }

      function parseFloatOperand() {
        var str = '';
        var eof = 15;
        var lookup = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.', 'E', 'E-', null, '-'];
        var length = dict.length;

        while (pos < length) {
          var b = dict[pos++];
          var b1 = b >> 4;
          var b2 = b & 15;

          if (b1 === eof) {
            break;
          }

          str += lookup[b1];

          if (b2 === eof) {
            break;
          }

          str += lookup[b2];
        }

        return parseFloat(str);
      }

      var operands = [];
      var entries = [];
      pos = 0;
      var end = dict.length;

      while (pos < end) {
        var b = dict[pos];

        if (b <= 21) {
          if (b === 12) {
            b = b << 8 | dict[++pos];
          }

          entries.push([b, operands]);
          operands = [];
          ++pos;
        } else {
          operands.push(parseOperand());
        }
      }

      return entries;
    },
    parseIndex: function CFFParser_parseIndex(pos) {
      var cffIndex = new CFFIndex();
      var bytes = this.bytes;
      var count = bytes[pos++] << 8 | bytes[pos++];
      var offsets = [];
      var end = pos;
      var i, ii;

      if (count !== 0) {
        var offsetSize = bytes[pos++];
        var startPos = pos + (count + 1) * offsetSize - 1;

        for (i = 0, ii = count + 1; i < ii; ++i) {
          var offset = 0;

          for (var j = 0; j < offsetSize; ++j) {
            offset <<= 8;
            offset += bytes[pos++];
          }

          offsets.push(startPos + offset);
        }

        end = offsets[count];
      }

      for (i = 0, ii = offsets.length - 1; i < ii; ++i) {
        var offsetStart = offsets[i];
        var offsetEnd = offsets[i + 1];
        cffIndex.add(bytes.subarray(offsetStart, offsetEnd));
      }

      return {
        obj: cffIndex,
        endPos: end
      };
    },
    parseNameIndex: function CFFParser_parseNameIndex(index) {
      var names = [];

      for (var i = 0, ii = index.count; i < ii; ++i) {
        var name = index.get(i);
        names.push((0, _util.bytesToString)(name));
      }

      return names;
    },
    parseStringIndex: function CFFParser_parseStringIndex(index) {
      var strings = new CFFStrings();

      for (var i = 0, ii = index.count; i < ii; ++i) {
        var data = index.get(i);
        strings.add((0, _util.bytesToString)(data));
      }

      return strings;
    },
    createDict: function CFFParser_createDict(Type, dict, strings) {
      var cffDict = new Type(strings);

      for (var i = 0, ii = dict.length; i < ii; ++i) {
        var pair = dict[i];
        var key = pair[0];
        var value = pair[1];
        cffDict.setByKey(key, value);
      }

      return cffDict;
    },
    parseCharString: function CFFParser_parseCharString(state, data, localSubrIndex, globalSubrIndex) {
      if (!data || state.callDepth > MAX_SUBR_NESTING) {
        return false;
      }

      var stackSize = state.stackSize;
      var stack = state.stack;
      var length = data.length;

      for (var j = 0; j < length;) {
        var value = data[j++];
        var validationCommand = null;

        if (value === 12) {
          var q = data[j++];

          if (q === 0) {
            data[j - 2] = 139;
            data[j - 1] = 22;
            stackSize = 0;
          } else {
            validationCommand = CharstringValidationData12[q];
          }
        } else if (value === 28) {
          stack[stackSize] = (data[j] << 24 | data[j + 1] << 16) >> 16;
          j += 2;
          stackSize++;
        } else if (value === 14) {
          if (stackSize >= 4) {
            stackSize -= 4;

            if (this.seacAnalysisEnabled) {
              state.seac = stack.slice(stackSize, stackSize + 4);
              return false;
            }
          }

          validationCommand = CharstringValidationData[value];
        } else if (value >= 32 && value <= 246) {
          stack[stackSize] = value - 139;
          stackSize++;
        } else if (value >= 247 && value <= 254) {
          stack[stackSize] = value < 251 ? (value - 247 << 8) + data[j] + 108 : -(value - 251 << 8) - data[j] - 108;
          j++;
          stackSize++;
        } else if (value === 255) {
          stack[stackSize] = (data[j] << 24 | data[j + 1] << 16 | data[j + 2] << 8 | data[j + 3]) / 65536;
          j += 4;
          stackSize++;
        } else if (value === 19 || value === 20) {
          state.hints += stackSize >> 1;
          j += state.hints + 7 >> 3;
          stackSize %= 2;
          validationCommand = CharstringValidationData[value];
        } else if (value === 10 || value === 29) {
          var subrsIndex;

          if (value === 10) {
            subrsIndex = localSubrIndex;
          } else {
            subrsIndex = globalSubrIndex;
          }

          if (!subrsIndex) {
            validationCommand = CharstringValidationData[value];
            (0, _util.warn)('Missing subrsIndex for ' + validationCommand.id);
            return false;
          }

          var bias = 32768;

          if (subrsIndex.count < 1240) {
            bias = 107;
          } else if (subrsIndex.count < 33900) {
            bias = 1131;
          }

          var subrNumber = stack[--stackSize] + bias;

          if (subrNumber < 0 || subrNumber >= subrsIndex.count || isNaN(subrNumber)) {
            validationCommand = CharstringValidationData[value];
            (0, _util.warn)('Out of bounds subrIndex for ' + validationCommand.id);
            return false;
          }

          state.stackSize = stackSize;
          state.callDepth++;
          var valid = this.parseCharString(state, subrsIndex.get(subrNumber), localSubrIndex, globalSubrIndex);

          if (!valid) {
            return false;
          }

          state.callDepth--;
          stackSize = state.stackSize;
          continue;
        } else if (value === 11) {
          state.stackSize = stackSize;
          return true;
        } else {
          validationCommand = CharstringValidationData[value];
        }

        if (validationCommand) {
          if (validationCommand.stem) {
            state.hints += stackSize >> 1;

            if (value === 3 || value === 23) {
              state.hasVStems = true;
            } else if (state.hasVStems && (value === 1 || value === 18)) {
              (0, _util.warn)('CFF stem hints are in wrong order');
              data[j - 1] = value === 1 ? 3 : 23;
            }
          }

          if ('min' in validationCommand) {
            if (!state.undefStack && stackSize < validationCommand.min) {
              (0, _util.warn)('Not enough parameters for ' + validationCommand.id + '; actual: ' + stackSize + ', expected: ' + validationCommand.min);
              return false;
            }
          }

          if (state.firstStackClearing && validationCommand.stackClearing) {
            state.firstStackClearing = false;
            stackSize -= validationCommand.min;

            if (stackSize >= 2 && validationCommand.stem) {
              stackSize %= 2;
            } else if (stackSize > 1) {
              (0, _util.warn)('Found too many parameters for stack-clearing command');
            }

            if (stackSize > 0 && stack[stackSize - 1] >= 0) {
              state.width = stack[stackSize - 1];
            }
          }

          if ('stackDelta' in validationCommand) {
            if ('stackFn' in validationCommand) {
              validationCommand.stackFn(stack, stackSize);
            }

            stackSize += validationCommand.stackDelta;
          } else if (validationCommand.stackClearing) {
            stackSize = 0;
          } else if (validationCommand.resetStack) {
            stackSize = 0;
            state.undefStack = false;
          } else if (validationCommand.undefStack) {
            stackSize = 0;
            state.undefStack = true;
            state.firstStackClearing = false;
          }
        }
      }

      state.stackSize = stackSize;
      return true;
    },
    parseCharStrings: function parseCharStrings(_ref) {
      var charStrings = _ref.charStrings,
          localSubrIndex = _ref.localSubrIndex,
          globalSubrIndex = _ref.globalSubrIndex,
          fdSelect = _ref.fdSelect,
          fdArray = _ref.fdArray,
          privateDict = _ref.privateDict;
      var seacs = [];
      var widths = [];
      var count = charStrings.count;

      for (var i = 0; i < count; i++) {
        var charstring = charStrings.get(i);
        var state = {
          callDepth: 0,
          stackSize: 0,
          stack: [],
          undefStack: true,
          hints: 0,
          firstStackClearing: true,
          seac: null,
          width: null,
          hasVStems: false
        };
        var valid = true;
        var localSubrToUse = null;
        var privateDictToUse = privateDict;

        if (fdSelect && fdArray.length) {
          var fdIndex = fdSelect.getFDIndex(i);

          if (fdIndex === -1) {
            (0, _util.warn)('Glyph index is not in fd select.');
            valid = false;
          }

          if (fdIndex >= fdArray.length) {
            (0, _util.warn)('Invalid fd index for glyph index.');
            valid = false;
          }

          if (valid) {
            privateDictToUse = fdArray[fdIndex].privateDict;
            localSubrToUse = privateDictToUse.subrsIndex;
          }
        } else if (localSubrIndex) {
          localSubrToUse = localSubrIndex;
        }

        if (valid) {
          valid = this.parseCharString(state, charstring, localSubrToUse, globalSubrIndex);
        }

        if (state.width !== null) {
          var nominalWidth = privateDictToUse.getByName('nominalWidthX');
          widths[i] = nominalWidth + state.width;
        } else {
          var defaultWidth = privateDictToUse.getByName('defaultWidthX');
          widths[i] = defaultWidth;
        }

        if (state.seac !== null) {
          seacs[i] = state.seac;
        }

        if (!valid) {
          charStrings.set(i, new Uint8Array([14]));
        }
      }

      return {
        charStrings: charStrings,
        seacs: seacs,
        widths: widths
      };
    },
    emptyPrivateDictionary: function CFFParser_emptyPrivateDictionary(parentDict) {
      var privateDict = this.createDict(CFFPrivateDict, [], parentDict.strings);
      parentDict.setByKey(18, [0, 0]);
      parentDict.privateDict = privateDict;
    },
    parsePrivateDict: function CFFParser_parsePrivateDict(parentDict) {
      if (!parentDict.hasName('Private')) {
        this.emptyPrivateDictionary(parentDict);
        return;
      }

      var privateOffset = parentDict.getByName('Private');

      if (!Array.isArray(privateOffset) || privateOffset.length !== 2) {
        parentDict.removeByName('Private');
        return;
      }

      var size = privateOffset[0];
      var offset = privateOffset[1];

      if (size === 0 || offset >= this.bytes.length) {
        this.emptyPrivateDictionary(parentDict);
        return;
      }

      var privateDictEnd = offset + size;
      var dictData = this.bytes.subarray(offset, privateDictEnd);
      var dict = this.parseDict(dictData);
      var privateDict = this.createDict(CFFPrivateDict, dict, parentDict.strings);
      parentDict.privateDict = privateDict;

      if (!privateDict.getByName('Subrs')) {
        return;
      }

      var subrsOffset = privateDict.getByName('Subrs');
      var relativeOffset = offset + subrsOffset;

      if (subrsOffset === 0 || relativeOffset >= this.bytes.length) {
        this.emptyPrivateDictionary(parentDict);
        return;
      }

      var subrsIndex = this.parseIndex(relativeOffset);
      privateDict.subrsIndex = subrsIndex.obj;
    },
    parseCharsets: function CFFParser_parseCharsets(pos, length, strings, cid) {
      if (pos === 0) {
        return new CFFCharset(true, CFFCharsetPredefinedTypes.ISO_ADOBE, _charsets.ISOAdobeCharset);
      } else if (pos === 1) {
        return new CFFCharset(true, CFFCharsetPredefinedTypes.EXPERT, _charsets.ExpertCharset);
      } else if (pos === 2) {
        return new CFFCharset(true, CFFCharsetPredefinedTypes.EXPERT_SUBSET, _charsets.ExpertSubsetCharset);
      }

      var bytes = this.bytes;
      var start = pos;
      var format = bytes[pos++];
      var charset = ['.notdef'];
      var id, count, i;
      length -= 1;

      switch (format) {
        case 0:
          for (i = 0; i < length; i++) {
            id = bytes[pos++] << 8 | bytes[pos++];
            charset.push(cid ? id : strings.get(id));
          }

          break;

        case 1:
          while (charset.length <= length) {
            id = bytes[pos++] << 8 | bytes[pos++];
            count = bytes[pos++];

            for (i = 0; i <= count; i++) {
              charset.push(cid ? id++ : strings.get(id++));
            }
          }

          break;

        case 2:
          while (charset.length <= length) {
            id = bytes[pos++] << 8 | bytes[pos++];
            count = bytes[pos++] << 8 | bytes[pos++];

            for (i = 0; i <= count; i++) {
              charset.push(cid ? id++ : strings.get(id++));
            }
          }

          break;

        default:
          throw new _util.FormatError('Unknown charset format');
      }

      var end = pos;
      var raw = bytes.subarray(start, end);
      return new CFFCharset(false, format, charset, raw);
    },
    parseEncoding: function CFFParser_parseEncoding(pos, properties, strings, charset) {
      var encoding = Object.create(null);
      var bytes = this.bytes;
      var predefined = false;
      var format, i, ii;
      var raw = null;

      function readSupplement() {
        var supplementsCount = bytes[pos++];

        for (i = 0; i < supplementsCount; i++) {
          var code = bytes[pos++];
          var sid = (bytes[pos++] << 8) + (bytes[pos++] & 0xff);
          encoding[code] = charset.indexOf(strings.get(sid));
        }
      }

      if (pos === 0 || pos === 1) {
        predefined = true;
        format = pos;
        var baseEncoding = pos ? _encodings.ExpertEncoding : _encodings.StandardEncoding;

        for (i = 0, ii = charset.length; i < ii; i++) {
          var index = baseEncoding.indexOf(charset[i]);

          if (index !== -1) {
            encoding[index] = i;
          }
        }
      } else {
        var dataStart = pos;
        format = bytes[pos++];

        switch (format & 0x7f) {
          case 0:
            var glyphsCount = bytes[pos++];

            for (i = 1; i <= glyphsCount; i++) {
              encoding[bytes[pos++]] = i;
            }

            break;

          case 1:
            var rangesCount = bytes[pos++];
            var gid = 1;

            for (i = 0; i < rangesCount; i++) {
              var start = bytes[pos++];
              var left = bytes[pos++];

              for (var j = start; j <= start + left; j++) {
                encoding[j] = gid++;
              }
            }

            break;

          default:
            throw new _util.FormatError("Unknown encoding format: ".concat(format, " in CFF"));
        }

        var dataEnd = pos;

        if (format & 0x80) {
          bytes[dataStart] &= 0x7f;
          readSupplement();
        }

        raw = bytes.subarray(dataStart, dataEnd);
      }

      format = format & 0x7f;
      return new CFFEncoding(predefined, format, encoding, raw);
    },
    parseFDSelect: function CFFParser_parseFDSelect(pos, length) {
      var bytes = this.bytes;
      var format = bytes[pos++];
      var fdSelect = [];
      var i;

      switch (format) {
        case 0:
          for (i = 0; i < length; ++i) {
            var id = bytes[pos++];
            fdSelect.push(id);
          }

          break;

        case 3:
          var rangesCount = bytes[pos++] << 8 | bytes[pos++];

          for (i = 0; i < rangesCount; ++i) {
            var first = bytes[pos++] << 8 | bytes[pos++];

            if (i === 0 && first !== 0) {
              (0, _util.warn)('parseFDSelect: The first range must have a first GID of 0' + ' -- trying to recover.');
              first = 0;
            }

            var fdIndex = bytes[pos++];
            var next = bytes[pos] << 8 | bytes[pos + 1];

            for (var j = first; j < next; ++j) {
              fdSelect.push(fdIndex);
            }
          }

          pos += 2;
          break;

        default:
          throw new _util.FormatError("parseFDSelect: Unknown format \"".concat(format, "\"."));
      }

      if (fdSelect.length !== length) {
        throw new _util.FormatError('parseFDSelect: Invalid font data.');
      }

      return new CFFFDSelect(format, fdSelect);
    }
  };
  return CFFParser;
}();

exports.CFFParser = CFFParser;

var CFF = function CFFClosure() {
  function CFF() {
    this.header = null;
    this.names = [];
    this.topDict = null;
    this.strings = new CFFStrings();
    this.globalSubrIndex = null;
    this.encoding = null;
    this.charset = null;
    this.charStrings = null;
    this.fdArray = [];
    this.fdSelect = null;
    this.isCIDFont = false;
  }

  CFF.prototype = {
    duplicateFirstGlyph: function CFF_duplicateFirstGlyph() {
      if (this.charStrings.count >= 65535) {
        (0, _util.warn)('Not enough space in charstrings to duplicate first glyph.');
        return;
      }

      var glyphZero = this.charStrings.get(0);
      this.charStrings.add(glyphZero);

      if (this.isCIDFont) {
        this.fdSelect.fdSelect.push(this.fdSelect.fdSelect[0]);
      }
    },
    hasGlyphId: function CFF_hasGlyphID(id) {
      if (id < 0 || id >= this.charStrings.count) {
        return false;
      }

      var glyph = this.charStrings.get(id);
      return glyph.length > 0;
    }
  };
  return CFF;
}();

exports.CFF = CFF;

var CFFHeader = function CFFHeaderClosure() {
  function CFFHeader(major, minor, hdrSize, offSize) {
    this.major = major;
    this.minor = minor;
    this.hdrSize = hdrSize;
    this.offSize = offSize;
  }

  return CFFHeader;
}();

exports.CFFHeader = CFFHeader;

var CFFStrings = function CFFStringsClosure() {
  function CFFStrings() {
    this.strings = [];
  }

  CFFStrings.prototype = {
    get: function CFFStrings_get(index) {
      if (index >= 0 && index <= 390) {
        return CFFStandardStrings[index];
      }

      if (index - 391 <= this.strings.length) {
        return this.strings[index - 391];
      }

      return CFFStandardStrings[0];
    },
    add: function CFFStrings_add(value) {
      this.strings.push(value);
    },

    get count() {
      return this.strings.length;
    }

  };
  return CFFStrings;
}();

exports.CFFStrings = CFFStrings;

var CFFIndex = function CFFIndexClosure() {
  function CFFIndex() {
    this.objects = [];
    this.length = 0;
  }

  CFFIndex.prototype = {
    add: function CFFIndex_add(data) {
      this.length += data.length;
      this.objects.push(data);
    },
    set: function CFFIndex_set(index, data) {
      this.length += data.length - this.objects[index].length;
      this.objects[index] = data;
    },
    get: function CFFIndex_get(index) {
      return this.objects[index];
    },

    get count() {
      return this.objects.length;
    }

  };
  return CFFIndex;
}();

exports.CFFIndex = CFFIndex;

var CFFDict = function CFFDictClosure() {
  function CFFDict(tables, strings) {
    this.keyToNameMap = tables.keyToNameMap;
    this.nameToKeyMap = tables.nameToKeyMap;
    this.defaults = tables.defaults;
    this.types = tables.types;
    this.opcodes = tables.opcodes;
    this.order = tables.order;
    this.strings = strings;
    this.values = Object.create(null);
  }

  CFFDict.prototype = {
    setByKey: function CFFDict_setByKey(key, value) {
      if (!(key in this.keyToNameMap)) {
        return false;
      }

      var valueLength = value.length;

      if (valueLength === 0) {
        return true;
      }

      for (var i = 0; i < valueLength; i++) {
        if (isNaN(value[i])) {
          (0, _util.warn)('Invalid CFFDict value: "' + value + '" for key "' + key + '".');
          return true;
        }
      }

      var type = this.types[key];

      if (type === 'num' || type === 'sid' || type === 'offset') {
        value = value[0];
      }

      this.values[key] = value;
      return true;
    },
    setByName: function CFFDict_setByName(name, value) {
      if (!(name in this.nameToKeyMap)) {
        throw new _util.FormatError("Invalid dictionary name \"".concat(name, "\""));
      }

      this.values[this.nameToKeyMap[name]] = value;
    },
    hasName: function CFFDict_hasName(name) {
      return this.nameToKeyMap[name] in this.values;
    },
    getByName: function CFFDict_getByName(name) {
      if (!(name in this.nameToKeyMap)) {
        throw new _util.FormatError("Invalid dictionary name ".concat(name, "\""));
      }

      var key = this.nameToKeyMap[name];

      if (!(key in this.values)) {
        return this.defaults[key];
      }

      return this.values[key];
    },
    removeByName: function CFFDict_removeByName(name) {
      delete this.values[this.nameToKeyMap[name]];
    }
  };

  CFFDict.createTables = function CFFDict_createTables(layout) {
    var tables = {
      keyToNameMap: {},
      nameToKeyMap: {},
      defaults: {},
      types: {},
      opcodes: {},
      order: []
    };

    for (var i = 0, ii = layout.length; i < ii; ++i) {
      var entry = layout[i];
      var key = Array.isArray(entry[0]) ? (entry[0][0] << 8) + entry[0][1] : entry[0];
      tables.keyToNameMap[key] = entry[1];
      tables.nameToKeyMap[entry[1]] = key;
      tables.types[key] = entry[2];
      tables.defaults[key] = entry[3];
      tables.opcodes[key] = Array.isArray(entry[0]) ? entry[0] : [entry[0]];
      tables.order.push(key);
    }

    return tables;
  };

  return CFFDict;
}();

var CFFTopDict = function CFFTopDictClosure() {
  var layout = [[[12, 30], 'ROS', ['sid', 'sid', 'num'], null], [[12, 20], 'SyntheticBase', 'num', null], [0, 'version', 'sid', null], [1, 'Notice', 'sid', null], [[12, 0], 'Copyright', 'sid', null], [2, 'FullName', 'sid', null], [3, 'FamilyName', 'sid', null], [4, 'Weight', 'sid', null], [[12, 1], 'isFixedPitch', 'num', 0], [[12, 2], 'ItalicAngle', 'num', 0], [[12, 3], 'UnderlinePosition', 'num', -100], [[12, 4], 'UnderlineThickness', 'num', 50], [[12, 5], 'PaintType', 'num', 0], [[12, 6], 'CharstringType', 'num', 2], [[12, 7], 'FontMatrix', ['num', 'num', 'num', 'num', 'num', 'num'], [0.001, 0, 0, 0.001, 0, 0]], [13, 'UniqueID', 'num', null], [5, 'FontBBox', ['num', 'num', 'num', 'num'], [0, 0, 0, 0]], [[12, 8], 'StrokeWidth', 'num', 0], [14, 'XUID', 'array', null], [15, 'charset', 'offset', 0], [16, 'Encoding', 'offset', 0], [17, 'CharStrings', 'offset', 0], [18, 'Private', ['offset', 'offset'], null], [[12, 21], 'PostScript', 'sid', null], [[12, 22], 'BaseFontName', 'sid', null], [[12, 23], 'BaseFontBlend', 'delta', null], [[12, 31], 'CIDFontVersion', 'num', 0], [[12, 32], 'CIDFontRevision', 'num', 0], [[12, 33], 'CIDFontType', 'num', 0], [[12, 34], 'CIDCount', 'num', 8720], [[12, 35], 'UIDBase', 'num', null], [[12, 37], 'FDSelect', 'offset', null], [[12, 36], 'FDArray', 'offset', null], [[12, 38], 'FontName', 'sid', null]];
  var tables = null;

  function CFFTopDict(strings) {
    if (tables === null) {
      tables = CFFDict.createTables(layout);
    }

    CFFDict.call(this, tables, strings);
    this.privateDict = null;
  }

  CFFTopDict.prototype = Object.create(CFFDict.prototype);
  return CFFTopDict;
}();

exports.CFFTopDict = CFFTopDict;

var CFFPrivateDict = function CFFPrivateDictClosure() {
  var layout = [[6, 'BlueValues', 'delta', null], [7, 'OtherBlues', 'delta', null], [8, 'FamilyBlues', 'delta', null], [9, 'FamilyOtherBlues', 'delta', null], [[12, 9], 'BlueScale', 'num', 0.039625], [[12, 10], 'BlueShift', 'num', 7], [[12, 11], 'BlueFuzz', 'num', 1], [10, 'StdHW', 'num', null], [11, 'StdVW', 'num', null], [[12, 12], 'StemSnapH', 'delta', null], [[12, 13], 'StemSnapV', 'delta', null], [[12, 14], 'ForceBold', 'num', 0], [[12, 17], 'LanguageGroup', 'num', 0], [[12, 18], 'ExpansionFactor', 'num', 0.06], [[12, 19], 'initialRandomSeed', 'num', 0], [20, 'defaultWidthX', 'num', 0], [21, 'nominalWidthX', 'num', 0], [19, 'Subrs', 'offset', null]];
  var tables = null;

  function CFFPrivateDict(strings) {
    if (tables === null) {
      tables = CFFDict.createTables(layout);
    }

    CFFDict.call(this, tables, strings);
    this.subrsIndex = null;
  }

  CFFPrivateDict.prototype = Object.create(CFFDict.prototype);
  return CFFPrivateDict;
}();

exports.CFFPrivateDict = CFFPrivateDict;
var CFFCharsetPredefinedTypes = {
  ISO_ADOBE: 0,
  EXPERT: 1,
  EXPERT_SUBSET: 2
};

var CFFCharset = function CFFCharsetClosure() {
  function CFFCharset(predefined, format, charset, raw) {
    this.predefined = predefined;
    this.format = format;
    this.charset = charset;
    this.raw = raw;
  }

  return CFFCharset;
}();

exports.CFFCharset = CFFCharset;

var CFFEncoding = function CFFEncodingClosure() {
  function CFFEncoding(predefined, format, encoding, raw) {
    this.predefined = predefined;
    this.format = format;
    this.encoding = encoding;
    this.raw = raw;
  }

  return CFFEncoding;
}();

var CFFFDSelect = function CFFFDSelectClosure() {
  function CFFFDSelect(format, fdSelect) {
    this.format = format;
    this.fdSelect = fdSelect;
  }

  CFFFDSelect.prototype = {
    getFDIndex: function CFFFDSelect_get(glyphIndex) {
      if (glyphIndex < 0 || glyphIndex >= this.fdSelect.length) {
        return -1;
      }

      return this.fdSelect[glyphIndex];
    }
  };
  return CFFFDSelect;
}();

exports.CFFFDSelect = CFFFDSelect;

var CFFOffsetTracker = function CFFOffsetTrackerClosure() {
  function CFFOffsetTracker() {
    this.offsets = Object.create(null);
  }

  CFFOffsetTracker.prototype = {
    isTracking: function CFFOffsetTracker_isTracking(key) {
      return key in this.offsets;
    },
    track: function CFFOffsetTracker_track(key, location) {
      if (key in this.offsets) {
        throw new _util.FormatError("Already tracking location of ".concat(key));
      }

      this.offsets[key] = location;
    },
    offset: function CFFOffsetTracker_offset(value) {
      for (var key in this.offsets) {
        this.offsets[key] += value;
      }
    },
    setEntryLocation: function CFFOffsetTracker_setEntryLocation(key, values, output) {
      if (!(key in this.offsets)) {
        throw new _util.FormatError("Not tracking location of ".concat(key));
      }

      var data = output.data;
      var dataOffset = this.offsets[key];
      var size = 5;

      for (var i = 0, ii = values.length; i < ii; ++i) {
        var offset0 = i * size + dataOffset;
        var offset1 = offset0 + 1;
        var offset2 = offset0 + 2;
        var offset3 = offset0 + 3;
        var offset4 = offset0 + 4;

        if (data[offset0] !== 0x1d || data[offset1] !== 0 || data[offset2] !== 0 || data[offset3] !== 0 || data[offset4] !== 0) {
          throw new _util.FormatError('writing to an offset that is not empty');
        }

        var value = values[i];
        data[offset0] = 0x1d;
        data[offset1] = value >> 24 & 0xFF;
        data[offset2] = value >> 16 & 0xFF;
        data[offset3] = value >> 8 & 0xFF;
        data[offset4] = value & 0xFF;
      }
    }
  };
  return CFFOffsetTracker;
}();

var CFFCompiler = function CFFCompilerClosure() {
  function CFFCompiler(cff) {
    this.cff = cff;
  }

  CFFCompiler.prototype = {
    compile: function CFFCompiler_compile() {
      var cff = this.cff;
      var output = {
        data: [],
        length: 0,
        add: function CFFCompiler_add(data) {
          this.data = this.data.concat(data);
          this.length = this.data.length;
        }
      };
      var header = this.compileHeader(cff.header);
      output.add(header);
      var nameIndex = this.compileNameIndex(cff.names);
      output.add(nameIndex);

      if (cff.isCIDFont) {
        if (cff.topDict.hasName('FontMatrix')) {
          var base = cff.topDict.getByName('FontMatrix');
          cff.topDict.removeByName('FontMatrix');

          for (var i = 0, ii = cff.fdArray.length; i < ii; i++) {
            var subDict = cff.fdArray[i];
            var matrix = base.slice(0);

            if (subDict.hasName('FontMatrix')) {
              matrix = _util.Util.transform(matrix, subDict.getByName('FontMatrix'));
            }

            subDict.setByName('FontMatrix', matrix);
          }
        }
      }

      cff.topDict.setByName('charset', 0);
      var compiled = this.compileTopDicts([cff.topDict], output.length, cff.isCIDFont);
      output.add(compiled.output);
      var topDictTracker = compiled.trackers[0];
      var stringIndex = this.compileStringIndex(cff.strings.strings);
      output.add(stringIndex);
      var globalSubrIndex = this.compileIndex(cff.globalSubrIndex);
      output.add(globalSubrIndex);

      if (cff.encoding && cff.topDict.hasName('Encoding')) {
        if (cff.encoding.predefined) {
          topDictTracker.setEntryLocation('Encoding', [cff.encoding.format], output);
        } else {
          var encoding = this.compileEncoding(cff.encoding);
          topDictTracker.setEntryLocation('Encoding', [output.length], output);
          output.add(encoding);
        }
      }

      var charset = this.compileCharset(cff.charset);
      topDictTracker.setEntryLocation('charset', [output.length], output);
      output.add(charset);
      var charStrings = this.compileCharStrings(cff.charStrings);
      topDictTracker.setEntryLocation('CharStrings', [output.length], output);
      output.add(charStrings);

      if (cff.isCIDFont) {
        topDictTracker.setEntryLocation('FDSelect', [output.length], output);
        var fdSelect = this.compileFDSelect(cff.fdSelect);
        output.add(fdSelect);
        compiled = this.compileTopDicts(cff.fdArray, output.length, true);
        topDictTracker.setEntryLocation('FDArray', [output.length], output);
        output.add(compiled.output);
        var fontDictTrackers = compiled.trackers;
        this.compilePrivateDicts(cff.fdArray, fontDictTrackers, output);
      }

      this.compilePrivateDicts([cff.topDict], [topDictTracker], output);
      output.add([0]);
      return output.data;
    },
    encodeNumber: function CFFCompiler_encodeNumber(value) {
      if (parseFloat(value) === parseInt(value, 10) && !isNaN(value)) {
        return this.encodeInteger(value);
      }

      return this.encodeFloat(value);
    },
    encodeFloat: function CFFCompiler_encodeFloat(num) {
      var value = num.toString();
      var m = /\.(\d*?)(?:9{5,20}|0{5,20})\d{0,2}(?:e(.+)|$)/.exec(value);

      if (m) {
        var epsilon = parseFloat('1e' + ((m[2] ? +m[2] : 0) + m[1].length));
        value = (Math.round(num * epsilon) / epsilon).toString();
      }

      var nibbles = '';
      var i, ii;

      for (i = 0, ii = value.length; i < ii; ++i) {
        var a = value[i];

        if (a === 'e') {
          nibbles += value[++i] === '-' ? 'c' : 'b';
        } else if (a === '.') {
          nibbles += 'a';
        } else if (a === '-') {
          nibbles += 'e';
        } else {
          nibbles += a;
        }
      }

      nibbles += nibbles.length & 1 ? 'f' : 'ff';
      var out = [30];

      for (i = 0, ii = nibbles.length; i < ii; i += 2) {
        out.push(parseInt(nibbles.substring(i, i + 2), 16));
      }

      return out;
    },
    encodeInteger: function CFFCompiler_encodeInteger(value) {
      var code;

      if (value >= -107 && value <= 107) {
        code = [value + 139];
      } else if (value >= 108 && value <= 1131) {
        value = value - 108;
        code = [(value >> 8) + 247, value & 0xFF];
      } else if (value >= -1131 && value <= -108) {
        value = -value - 108;
        code = [(value >> 8) + 251, value & 0xFF];
      } else if (value >= -32768 && value <= 32767) {
        code = [0x1c, value >> 8 & 0xFF, value & 0xFF];
      } else {
        code = [0x1d, value >> 24 & 0xFF, value >> 16 & 0xFF, value >> 8 & 0xFF, value & 0xFF];
      }

      return code;
    },
    compileHeader: function CFFCompiler_compileHeader(header) {
      return [header.major, header.minor, header.hdrSize, header.offSize];
    },
    compileNameIndex: function CFFCompiler_compileNameIndex(names) {
      var nameIndex = new CFFIndex();

      for (var i = 0, ii = names.length; i < ii; ++i) {
        var name = names[i];
        var length = Math.min(name.length, 127);
        var sanitizedName = new Array(length);

        for (var j = 0; j < length; j++) {
          var char = name[j];

          if (char < '!' || char > '~' || char === '[' || char === ']' || char === '(' || char === ')' || char === '{' || char === '}' || char === '<' || char === '>' || char === '/' || char === '%') {
            char = '_';
          }

          sanitizedName[j] = char;
        }

        sanitizedName = sanitizedName.join('');

        if (sanitizedName === '') {
          sanitizedName = 'Bad_Font_Name';
        }

        nameIndex.add((0, _util.stringToBytes)(sanitizedName));
      }

      return this.compileIndex(nameIndex);
    },
    compileTopDicts: function CFFCompiler_compileTopDicts(dicts, length, removeCidKeys) {
      var fontDictTrackers = [];
      var fdArrayIndex = new CFFIndex();

      for (var i = 0, ii = dicts.length; i < ii; ++i) {
        var fontDict = dicts[i];

        if (removeCidKeys) {
          fontDict.removeByName('CIDFontVersion');
          fontDict.removeByName('CIDFontRevision');
          fontDict.removeByName('CIDFontType');
          fontDict.removeByName('CIDCount');
          fontDict.removeByName('UIDBase');
        }

        var fontDictTracker = new CFFOffsetTracker();
        var fontDictData = this.compileDict(fontDict, fontDictTracker);
        fontDictTrackers.push(fontDictTracker);
        fdArrayIndex.add(fontDictData);
        fontDictTracker.offset(length);
      }

      fdArrayIndex = this.compileIndex(fdArrayIndex, fontDictTrackers);
      return {
        trackers: fontDictTrackers,
        output: fdArrayIndex
      };
    },
    compilePrivateDicts: function CFFCompiler_compilePrivateDicts(dicts, trackers, output) {
      for (var i = 0, ii = dicts.length; i < ii; ++i) {
        var fontDict = dicts[i];
        var privateDict = fontDict.privateDict;

        if (!privateDict || !fontDict.hasName('Private')) {
          throw new _util.FormatError('There must be a private dictionary.');
        }

        var privateDictTracker = new CFFOffsetTracker();
        var privateDictData = this.compileDict(privateDict, privateDictTracker);
        var outputLength = output.length;
        privateDictTracker.offset(outputLength);

        if (!privateDictData.length) {
          outputLength = 0;
        }

        trackers[i].setEntryLocation('Private', [privateDictData.length, outputLength], output);
        output.add(privateDictData);

        if (privateDict.subrsIndex && privateDict.hasName('Subrs')) {
          var subrs = this.compileIndex(privateDict.subrsIndex);
          privateDictTracker.setEntryLocation('Subrs', [privateDictData.length], output);
          output.add(subrs);
        }
      }
    },
    compileDict: function CFFCompiler_compileDict(dict, offsetTracker) {
      var out = [];
      var order = dict.order;

      for (var i = 0; i < order.length; ++i) {
        var key = order[i];

        if (!(key in dict.values)) {
          continue;
        }

        var values = dict.values[key];
        var types = dict.types[key];

        if (!Array.isArray(types)) {
          types = [types];
        }

        if (!Array.isArray(values)) {
          values = [values];
        }

        if (values.length === 0) {
          continue;
        }

        for (var j = 0, jj = types.length; j < jj; ++j) {
          var type = types[j];
          var value = values[j];

          switch (type) {
            case 'num':
            case 'sid':
              out = out.concat(this.encodeNumber(value));
              break;

            case 'offset':
              var name = dict.keyToNameMap[key];

              if (!offsetTracker.isTracking(name)) {
                offsetTracker.track(name, out.length);
              }

              out = out.concat([0x1d, 0, 0, 0, 0]);
              break;

            case 'array':
            case 'delta':
              out = out.concat(this.encodeNumber(value));

              for (var k = 1, kk = values.length; k < kk; ++k) {
                out = out.concat(this.encodeNumber(values[k]));
              }

              break;

            default:
              throw new _util.FormatError("Unknown data type of ".concat(type));
          }
        }

        out = out.concat(dict.opcodes[key]);
      }

      return out;
    },
    compileStringIndex: function CFFCompiler_compileStringIndex(strings) {
      var stringIndex = new CFFIndex();

      for (var i = 0, ii = strings.length; i < ii; ++i) {
        stringIndex.add((0, _util.stringToBytes)(strings[i]));
      }

      return this.compileIndex(stringIndex);
    },
    compileGlobalSubrIndex: function CFFCompiler_compileGlobalSubrIndex() {
      var globalSubrIndex = this.cff.globalSubrIndex;
      this.out.writeByteArray(this.compileIndex(globalSubrIndex));
    },
    compileCharStrings: function CFFCompiler_compileCharStrings(charStrings) {
      var charStringsIndex = new CFFIndex();

      for (var i = 0; i < charStrings.count; i++) {
        var glyph = charStrings.get(i);

        if (glyph.length === 0) {
          charStringsIndex.add(new Uint8Array([0x8B, 0x0E]));
          continue;
        }

        charStringsIndex.add(glyph);
      }

      return this.compileIndex(charStringsIndex);
    },
    compileCharset: function CFFCompiler_compileCharset(charset) {
      var length = 1 + (this.cff.charStrings.count - 1) * 2;
      var out = new Uint8Array(length);
      return this.compileTypedArray(out);
    },
    compileEncoding: function CFFCompiler_compileEncoding(encoding) {
      return this.compileTypedArray(encoding.raw);
    },
    compileFDSelect: function CFFCompiler_compileFDSelect(fdSelect) {
      var format = fdSelect.format;
      var out, i;

      switch (format) {
        case 0:
          out = new Uint8Array(1 + fdSelect.fdSelect.length);
          out[0] = format;

          for (i = 0; i < fdSelect.fdSelect.length; i++) {
            out[i + 1] = fdSelect.fdSelect[i];
          }

          break;

        case 3:
          var start = 0;
          var lastFD = fdSelect.fdSelect[0];
          var ranges = [format, 0, 0, start >> 8 & 0xFF, start & 0xFF, lastFD];

          for (i = 1; i < fdSelect.fdSelect.length; i++) {
            var currentFD = fdSelect.fdSelect[i];

            if (currentFD !== lastFD) {
              ranges.push(i >> 8 & 0xFF, i & 0xFF, currentFD);
              lastFD = currentFD;
            }
          }

          var numRanges = (ranges.length - 3) / 3;
          ranges[1] = numRanges >> 8 & 0xFF;
          ranges[2] = numRanges & 0xFF;
          ranges.push(i >> 8 & 0xFF, i & 0xFF);
          out = new Uint8Array(ranges);
          break;
      }

      return this.compileTypedArray(out);
    },
    compileTypedArray: function CFFCompiler_compileTypedArray(data) {
      var out = [];

      for (var i = 0, ii = data.length; i < ii; ++i) {
        out[i] = data[i];
      }

      return out;
    },
    compileIndex: function CFFCompiler_compileIndex(index, trackers) {
      trackers = trackers || [];
      var objects = index.objects;
      var count = objects.length;

      if (count === 0) {
        return [0, 0, 0];
      }

      var data = [count >> 8 & 0xFF, count & 0xff];
      var lastOffset = 1,
          i;

      for (i = 0; i < count; ++i) {
        lastOffset += objects[i].length;
      }

      var offsetSize;

      if (lastOffset < 0x100) {
        offsetSize = 1;
      } else if (lastOffset < 0x10000) {
        offsetSize = 2;
      } else if (lastOffset < 0x1000000) {
        offsetSize = 3;
      } else {
        offsetSize = 4;
      }

      data.push(offsetSize);
      var relativeOffset = 1;

      for (i = 0; i < count + 1; i++) {
        if (offsetSize === 1) {
          data.push(relativeOffset & 0xFF);
        } else if (offsetSize === 2) {
          data.push(relativeOffset >> 8 & 0xFF, relativeOffset & 0xFF);
        } else if (offsetSize === 3) {
          data.push(relativeOffset >> 16 & 0xFF, relativeOffset >> 8 & 0xFF, relativeOffset & 0xFF);
        } else {
          data.push(relativeOffset >>> 24 & 0xFF, relativeOffset >> 16 & 0xFF, relativeOffset >> 8 & 0xFF, relativeOffset & 0xFF);
        }

        if (objects[i]) {
          relativeOffset += objects[i].length;
        }
      }

      for (i = 0; i < count; i++) {
        if (trackers[i]) {
          trackers[i].offset(data.length);
        }

        for (var j = 0, jj = objects[i].length; j < jj; j++) {
          data.push(objects[i][j]);
        }
      }

      return data;
    }
  };
  return CFFCompiler;
}();

exports.CFFCompiler = CFFCompiler;

/***/ }),
/* 175 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExpertSubsetCharset = exports.ExpertCharset = exports.ISOAdobeCharset = void 0;
var ISOAdobeCharset = ['.notdef', 'space', 'exclam', 'quotedbl', 'numbersign', 'dollar', 'percent', 'ampersand', 'quoteright', 'parenleft', 'parenright', 'asterisk', 'plus', 'comma', 'hyphen', 'period', 'slash', 'zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine', 'colon', 'semicolon', 'less', 'equal', 'greater', 'question', 'at', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'bracketleft', 'backslash', 'bracketright', 'asciicircum', 'underscore', 'quoteleft', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'braceleft', 'bar', 'braceright', 'asciitilde', 'exclamdown', 'cent', 'sterling', 'fraction', 'yen', 'florin', 'section', 'currency', 'quotesingle', 'quotedblleft', 'guillemotleft', 'guilsinglleft', 'guilsinglright', 'fi', 'fl', 'endash', 'dagger', 'daggerdbl', 'periodcentered', 'paragraph', 'bullet', 'quotesinglbase', 'quotedblbase', 'quotedblright', 'guillemotright', 'ellipsis', 'perthousand', 'questiondown', 'grave', 'acute', 'circumflex', 'tilde', 'macron', 'breve', 'dotaccent', 'dieresis', 'ring', 'cedilla', 'hungarumlaut', 'ogonek', 'caron', 'emdash', 'AE', 'ordfeminine', 'Lslash', 'Oslash', 'OE', 'ordmasculine', 'ae', 'dotlessi', 'lslash', 'oslash', 'oe', 'germandbls', 'onesuperior', 'logicalnot', 'mu', 'trademark', 'Eth', 'onehalf', 'plusminus', 'Thorn', 'onequarter', 'divide', 'brokenbar', 'degree', 'thorn', 'threequarters', 'twosuperior', 'registered', 'minus', 'eth', 'multiply', 'threesuperior', 'copyright', 'Aacute', 'Acircumflex', 'Adieresis', 'Agrave', 'Aring', 'Atilde', 'Ccedilla', 'Eacute', 'Ecircumflex', 'Edieresis', 'Egrave', 'Iacute', 'Icircumflex', 'Idieresis', 'Igrave', 'Ntilde', 'Oacute', 'Ocircumflex', 'Odieresis', 'Ograve', 'Otilde', 'Scaron', 'Uacute', 'Ucircumflex', 'Udieresis', 'Ugrave', 'Yacute', 'Ydieresis', 'Zcaron', 'aacute', 'acircumflex', 'adieresis', 'agrave', 'aring', 'atilde', 'ccedilla', 'eacute', 'ecircumflex', 'edieresis', 'egrave', 'iacute', 'icircumflex', 'idieresis', 'igrave', 'ntilde', 'oacute', 'ocircumflex', 'odieresis', 'ograve', 'otilde', 'scaron', 'uacute', 'ucircumflex', 'udieresis', 'ugrave', 'yacute', 'ydieresis', 'zcaron'];
exports.ISOAdobeCharset = ISOAdobeCharset;
var ExpertCharset = ['.notdef', 'space', 'exclamsmall', 'Hungarumlautsmall', 'dollaroldstyle', 'dollarsuperior', 'ampersandsmall', 'Acutesmall', 'parenleftsuperior', 'parenrightsuperior', 'twodotenleader', 'onedotenleader', 'comma', 'hyphen', 'period', 'fraction', 'zerooldstyle', 'oneoldstyle', 'twooldstyle', 'threeoldstyle', 'fouroldstyle', 'fiveoldstyle', 'sixoldstyle', 'sevenoldstyle', 'eightoldstyle', 'nineoldstyle', 'colon', 'semicolon', 'commasuperior', 'threequartersemdash', 'periodsuperior', 'questionsmall', 'asuperior', 'bsuperior', 'centsuperior', 'dsuperior', 'esuperior', 'isuperior', 'lsuperior', 'msuperior', 'nsuperior', 'osuperior', 'rsuperior', 'ssuperior', 'tsuperior', 'ff', 'fi', 'fl', 'ffi', 'ffl', 'parenleftinferior', 'parenrightinferior', 'Circumflexsmall', 'hyphensuperior', 'Gravesmall', 'Asmall', 'Bsmall', 'Csmall', 'Dsmall', 'Esmall', 'Fsmall', 'Gsmall', 'Hsmall', 'Ismall', 'Jsmall', 'Ksmall', 'Lsmall', 'Msmall', 'Nsmall', 'Osmall', 'Psmall', 'Qsmall', 'Rsmall', 'Ssmall', 'Tsmall', 'Usmall', 'Vsmall', 'Wsmall', 'Xsmall', 'Ysmall', 'Zsmall', 'colonmonetary', 'onefitted', 'rupiah', 'Tildesmall', 'exclamdownsmall', 'centoldstyle', 'Lslashsmall', 'Scaronsmall', 'Zcaronsmall', 'Dieresissmall', 'Brevesmall', 'Caronsmall', 'Dotaccentsmall', 'Macronsmall', 'figuredash', 'hypheninferior', 'Ogoneksmall', 'Ringsmall', 'Cedillasmall', 'onequarter', 'onehalf', 'threequarters', 'questiondownsmall', 'oneeighth', 'threeeighths', 'fiveeighths', 'seveneighths', 'onethird', 'twothirds', 'zerosuperior', 'onesuperior', 'twosuperior', 'threesuperior', 'foursuperior', 'fivesuperior', 'sixsuperior', 'sevensuperior', 'eightsuperior', 'ninesuperior', 'zeroinferior', 'oneinferior', 'twoinferior', 'threeinferior', 'fourinferior', 'fiveinferior', 'sixinferior', 'seveninferior', 'eightinferior', 'nineinferior', 'centinferior', 'dollarinferior', 'periodinferior', 'commainferior', 'Agravesmall', 'Aacutesmall', 'Acircumflexsmall', 'Atildesmall', 'Adieresissmall', 'Aringsmall', 'AEsmall', 'Ccedillasmall', 'Egravesmall', 'Eacutesmall', 'Ecircumflexsmall', 'Edieresissmall', 'Igravesmall', 'Iacutesmall', 'Icircumflexsmall', 'Idieresissmall', 'Ethsmall', 'Ntildesmall', 'Ogravesmall', 'Oacutesmall', 'Ocircumflexsmall', 'Otildesmall', 'Odieresissmall', 'OEsmall', 'Oslashsmall', 'Ugravesmall', 'Uacutesmall', 'Ucircumflexsmall', 'Udieresissmall', 'Yacutesmall', 'Thornsmall', 'Ydieresissmall'];
exports.ExpertCharset = ExpertCharset;
var ExpertSubsetCharset = ['.notdef', 'space', 'dollaroldstyle', 'dollarsuperior', 'parenleftsuperior', 'parenrightsuperior', 'twodotenleader', 'onedotenleader', 'comma', 'hyphen', 'period', 'fraction', 'zerooldstyle', 'oneoldstyle', 'twooldstyle', 'threeoldstyle', 'fouroldstyle', 'fiveoldstyle', 'sixoldstyle', 'sevenoldstyle', 'eightoldstyle', 'nineoldstyle', 'colon', 'semicolon', 'commasuperior', 'threequartersemdash', 'periodsuperior', 'asuperior', 'bsuperior', 'centsuperior', 'dsuperior', 'esuperior', 'isuperior', 'lsuperior', 'msuperior', 'nsuperior', 'osuperior', 'rsuperior', 'ssuperior', 'tsuperior', 'ff', 'fi', 'fl', 'ffi', 'ffl', 'parenleftinferior', 'parenrightinferior', 'hyphensuperior', 'colonmonetary', 'onefitted', 'rupiah', 'centoldstyle', 'figuredash', 'hypheninferior', 'onequarter', 'onehalf', 'threequarters', 'oneeighth', 'threeeighths', 'fiveeighths', 'seveneighths', 'onethird', 'twothirds', 'zerosuperior', 'onesuperior', 'twosuperior', 'threesuperior', 'foursuperior', 'fivesuperior', 'sixsuperior', 'sevensuperior', 'eightsuperior', 'ninesuperior', 'zeroinferior', 'oneinferior', 'twoinferior', 'threeinferior', 'fourinferior', 'fiveinferior', 'sixinferior', 'seveninferior', 'eightinferior', 'nineinferior', 'centinferior', 'dollarinferior', 'periodinferior', 'commainferior'];
exports.ExpertSubsetCharset = ExpertSubsetCharset;

/***/ }),
/* 176 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getEncoding = getEncoding;
exports.ExpertEncoding = exports.ZapfDingbatsEncoding = exports.SymbolSetEncoding = exports.MacRomanEncoding = exports.StandardEncoding = exports.WinAnsiEncoding = void 0;
var ExpertEncoding = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'space', 'exclamsmall', 'Hungarumlautsmall', '', 'dollaroldstyle', 'dollarsuperior', 'ampersandsmall', 'Acutesmall', 'parenleftsuperior', 'parenrightsuperior', 'twodotenleader', 'onedotenleader', 'comma', 'hyphen', 'period', 'fraction', 'zerooldstyle', 'oneoldstyle', 'twooldstyle', 'threeoldstyle', 'fouroldstyle', 'fiveoldstyle', 'sixoldstyle', 'sevenoldstyle', 'eightoldstyle', 'nineoldstyle', 'colon', 'semicolon', 'commasuperior', 'threequartersemdash', 'periodsuperior', 'questionsmall', '', 'asuperior', 'bsuperior', 'centsuperior', 'dsuperior', 'esuperior', '', '', '', 'isuperior', '', '', 'lsuperior', 'msuperior', 'nsuperior', 'osuperior', '', '', 'rsuperior', 'ssuperior', 'tsuperior', '', 'ff', 'fi', 'fl', 'ffi', 'ffl', 'parenleftinferior', '', 'parenrightinferior', 'Circumflexsmall', 'hyphensuperior', 'Gravesmall', 'Asmall', 'Bsmall', 'Csmall', 'Dsmall', 'Esmall', 'Fsmall', 'Gsmall', 'Hsmall', 'Ismall', 'Jsmall', 'Ksmall', 'Lsmall', 'Msmall', 'Nsmall', 'Osmall', 'Psmall', 'Qsmall', 'Rsmall', 'Ssmall', 'Tsmall', 'Usmall', 'Vsmall', 'Wsmall', 'Xsmall', 'Ysmall', 'Zsmall', 'colonmonetary', 'onefitted', 'rupiah', 'Tildesmall', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'exclamdownsmall', 'centoldstyle', 'Lslashsmall', '', '', 'Scaronsmall', 'Zcaronsmall', 'Dieresissmall', 'Brevesmall', 'Caronsmall', '', 'Dotaccentsmall', '', '', 'Macronsmall', '', '', 'figuredash', 'hypheninferior', '', '', 'Ogoneksmall', 'Ringsmall', 'Cedillasmall', '', '', '', 'onequarter', 'onehalf', 'threequarters', 'questiondownsmall', 'oneeighth', 'threeeighths', 'fiveeighths', 'seveneighths', 'onethird', 'twothirds', '', '', 'zerosuperior', 'onesuperior', 'twosuperior', 'threesuperior', 'foursuperior', 'fivesuperior', 'sixsuperior', 'sevensuperior', 'eightsuperior', 'ninesuperior', 'zeroinferior', 'oneinferior', 'twoinferior', 'threeinferior', 'fourinferior', 'fiveinferior', 'sixinferior', 'seveninferior', 'eightinferior', 'nineinferior', 'centinferior', 'dollarinferior', 'periodinferior', 'commainferior', 'Agravesmall', 'Aacutesmall', 'Acircumflexsmall', 'Atildesmall', 'Adieresissmall', 'Aringsmall', 'AEsmall', 'Ccedillasmall', 'Egravesmall', 'Eacutesmall', 'Ecircumflexsmall', 'Edieresissmall', 'Igravesmall', 'Iacutesmall', 'Icircumflexsmall', 'Idieresissmall', 'Ethsmall', 'Ntildesmall', 'Ogravesmall', 'Oacutesmall', 'Ocircumflexsmall', 'Otildesmall', 'Odieresissmall', 'OEsmall', 'Oslashsmall', 'Ugravesmall', 'Uacutesmall', 'Ucircumflexsmall', 'Udieresissmall', 'Yacutesmall', 'Thornsmall', 'Ydieresissmall'];
exports.ExpertEncoding = ExpertEncoding;
var MacExpertEncoding = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'space', 'exclamsmall', 'Hungarumlautsmall', 'centoldstyle', 'dollaroldstyle', 'dollarsuperior', 'ampersandsmall', 'Acutesmall', 'parenleftsuperior', 'parenrightsuperior', 'twodotenleader', 'onedotenleader', 'comma', 'hyphen', 'period', 'fraction', 'zerooldstyle', 'oneoldstyle', 'twooldstyle', 'threeoldstyle', 'fouroldstyle', 'fiveoldstyle', 'sixoldstyle', 'sevenoldstyle', 'eightoldstyle', 'nineoldstyle', 'colon', 'semicolon', '', 'threequartersemdash', '', 'questionsmall', '', '', '', '', 'Ethsmall', '', '', 'onequarter', 'onehalf', 'threequarters', 'oneeighth', 'threeeighths', 'fiveeighths', 'seveneighths', 'onethird', 'twothirds', '', '', '', '', '', '', 'ff', 'fi', 'fl', 'ffi', 'ffl', 'parenleftinferior', '', 'parenrightinferior', 'Circumflexsmall', 'hypheninferior', 'Gravesmall', 'Asmall', 'Bsmall', 'Csmall', 'Dsmall', 'Esmall', 'Fsmall', 'Gsmall', 'Hsmall', 'Ismall', 'Jsmall', 'Ksmall', 'Lsmall', 'Msmall', 'Nsmall', 'Osmall', 'Psmall', 'Qsmall', 'Rsmall', 'Ssmall', 'Tsmall', 'Usmall', 'Vsmall', 'Wsmall', 'Xsmall', 'Ysmall', 'Zsmall', 'colonmonetary', 'onefitted', 'rupiah', 'Tildesmall', '', '', 'asuperior', 'centsuperior', '', '', '', '', 'Aacutesmall', 'Agravesmall', 'Acircumflexsmall', 'Adieresissmall', 'Atildesmall', 'Aringsmall', 'Ccedillasmall', 'Eacutesmall', 'Egravesmall', 'Ecircumflexsmall', 'Edieresissmall', 'Iacutesmall', 'Igravesmall', 'Icircumflexsmall', 'Idieresissmall', 'Ntildesmall', 'Oacutesmall', 'Ogravesmall', 'Ocircumflexsmall', 'Odieresissmall', 'Otildesmall', 'Uacutesmall', 'Ugravesmall', 'Ucircumflexsmall', 'Udieresissmall', '', 'eightsuperior', 'fourinferior', 'threeinferior', 'sixinferior', 'eightinferior', 'seveninferior', 'Scaronsmall', '', 'centinferior', 'twoinferior', '', 'Dieresissmall', '', 'Caronsmall', 'osuperior', 'fiveinferior', '', 'commainferior', 'periodinferior', 'Yacutesmall', '', 'dollarinferior', '', '', 'Thornsmall', '', 'nineinferior', 'zeroinferior', 'Zcaronsmall', 'AEsmall', 'Oslashsmall', 'questiondownsmall', 'oneinferior', 'Lslashsmall', '', '', '', '', '', '', 'Cedillasmall', '', '', '', '', '', 'OEsmall', 'figuredash', 'hyphensuperior', '', '', '', '', 'exclamdownsmall', '', 'Ydieresissmall', '', 'onesuperior', 'twosuperior', 'threesuperior', 'foursuperior', 'fivesuperior', 'sixsuperior', 'sevensuperior', 'ninesuperior', 'zerosuperior', '', 'esuperior', 'rsuperior', 'tsuperior', '', '', 'isuperior', 'ssuperior', 'dsuperior', '', '', '', '', '', 'lsuperior', 'Ogoneksmall', 'Brevesmall', 'Macronsmall', 'bsuperior', 'nsuperior', 'msuperior', 'commasuperior', 'periodsuperior', 'Dotaccentsmall', 'Ringsmall', '', '', '', ''];
var MacRomanEncoding = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'space', 'exclam', 'quotedbl', 'numbersign', 'dollar', 'percent', 'ampersand', 'quotesingle', 'parenleft', 'parenright', 'asterisk', 'plus', 'comma', 'hyphen', 'period', 'slash', 'zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine', 'colon', 'semicolon', 'less', 'equal', 'greater', 'question', 'at', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'bracketleft', 'backslash', 'bracketright', 'asciicircum', 'underscore', 'grave', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'braceleft', 'bar', 'braceright', 'asciitilde', '', 'Adieresis', 'Aring', 'Ccedilla', 'Eacute', 'Ntilde', 'Odieresis', 'Udieresis', 'aacute', 'agrave', 'acircumflex', 'adieresis', 'atilde', 'aring', 'ccedilla', 'eacute', 'egrave', 'ecircumflex', 'edieresis', 'iacute', 'igrave', 'icircumflex', 'idieresis', 'ntilde', 'oacute', 'ograve', 'ocircumflex', 'odieresis', 'otilde', 'uacute', 'ugrave', 'ucircumflex', 'udieresis', 'dagger', 'degree', 'cent', 'sterling', 'section', 'bullet', 'paragraph', 'germandbls', 'registered', 'copyright', 'trademark', 'acute', 'dieresis', 'notequal', 'AE', 'Oslash', 'infinity', 'plusminus', 'lessequal', 'greaterequal', 'yen', 'mu', 'partialdiff', 'summation', 'product', 'pi', 'integral', 'ordfeminine', 'ordmasculine', 'Omega', 'ae', 'oslash', 'questiondown', 'exclamdown', 'logicalnot', 'radical', 'florin', 'approxequal', 'Delta', 'guillemotleft', 'guillemotright', 'ellipsis', 'space', 'Agrave', 'Atilde', 'Otilde', 'OE', 'oe', 'endash', 'emdash', 'quotedblleft', 'quotedblright', 'quoteleft', 'quoteright', 'divide', 'lozenge', 'ydieresis', 'Ydieresis', 'fraction', 'currency', 'guilsinglleft', 'guilsinglright', 'fi', 'fl', 'daggerdbl', 'periodcentered', 'quotesinglbase', 'quotedblbase', 'perthousand', 'Acircumflex', 'Ecircumflex', 'Aacute', 'Edieresis', 'Egrave', 'Iacute', 'Icircumflex', 'Idieresis', 'Igrave', 'Oacute', 'Ocircumflex', 'apple', 'Ograve', 'Uacute', 'Ucircumflex', 'Ugrave', 'dotlessi', 'circumflex', 'tilde', 'macron', 'breve', 'dotaccent', 'ring', 'cedilla', 'hungarumlaut', 'ogonek', 'caron'];
exports.MacRomanEncoding = MacRomanEncoding;
var StandardEncoding = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'space', 'exclam', 'quotedbl', 'numbersign', 'dollar', 'percent', 'ampersand', 'quoteright', 'parenleft', 'parenright', 'asterisk', 'plus', 'comma', 'hyphen', 'period', 'slash', 'zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine', 'colon', 'semicolon', 'less', 'equal', 'greater', 'question', 'at', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'bracketleft', 'backslash', 'bracketright', 'asciicircum', 'underscore', 'quoteleft', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'braceleft', 'bar', 'braceright', 'asciitilde', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'exclamdown', 'cent', 'sterling', 'fraction', 'yen', 'florin', 'section', 'currency', 'quotesingle', 'quotedblleft', 'guillemotleft', 'guilsinglleft', 'guilsinglright', 'fi', 'fl', '', 'endash', 'dagger', 'daggerdbl', 'periodcentered', '', 'paragraph', 'bullet', 'quotesinglbase', 'quotedblbase', 'quotedblright', 'guillemotright', 'ellipsis', 'perthousand', '', 'questiondown', '', 'grave', 'acute', 'circumflex', 'tilde', 'macron', 'breve', 'dotaccent', 'dieresis', '', 'ring', 'cedilla', '', 'hungarumlaut', 'ogonek', 'caron', 'emdash', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'AE', '', 'ordfeminine', '', '', '', '', 'Lslash', 'Oslash', 'OE', 'ordmasculine', '', '', '', '', '', 'ae', '', '', '', 'dotlessi', '', '', 'lslash', 'oslash', 'oe', 'germandbls', '', '', '', ''];
exports.StandardEncoding = StandardEncoding;
var WinAnsiEncoding = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'space', 'exclam', 'quotedbl', 'numbersign', 'dollar', 'percent', 'ampersand', 'quotesingle', 'parenleft', 'parenright', 'asterisk', 'plus', 'comma', 'hyphen', 'period', 'slash', 'zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine', 'colon', 'semicolon', 'less', 'equal', 'greater', 'question', 'at', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'bracketleft', 'backslash', 'bracketright', 'asciicircum', 'underscore', 'grave', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'braceleft', 'bar', 'braceright', 'asciitilde', 'bullet', 'Euro', 'bullet', 'quotesinglbase', 'florin', 'quotedblbase', 'ellipsis', 'dagger', 'daggerdbl', 'circumflex', 'perthousand', 'Scaron', 'guilsinglleft', 'OE', 'bullet', 'Zcaron', 'bullet', 'bullet', 'quoteleft', 'quoteright', 'quotedblleft', 'quotedblright', 'bullet', 'endash', 'emdash', 'tilde', 'trademark', 'scaron', 'guilsinglright', 'oe', 'bullet', 'zcaron', 'Ydieresis', 'space', 'exclamdown', 'cent', 'sterling', 'currency', 'yen', 'brokenbar', 'section', 'dieresis', 'copyright', 'ordfeminine', 'guillemotleft', 'logicalnot', 'hyphen', 'registered', 'macron', 'degree', 'plusminus', 'twosuperior', 'threesuperior', 'acute', 'mu', 'paragraph', 'periodcentered', 'cedilla', 'onesuperior', 'ordmasculine', 'guillemotright', 'onequarter', 'onehalf', 'threequarters', 'questiondown', 'Agrave', 'Aacute', 'Acircumflex', 'Atilde', 'Adieresis', 'Aring', 'AE', 'Ccedilla', 'Egrave', 'Eacute', 'Ecircumflex', 'Edieresis', 'Igrave', 'Iacute', 'Icircumflex', 'Idieresis', 'Eth', 'Ntilde', 'Ograve', 'Oacute', 'Ocircumflex', 'Otilde', 'Odieresis', 'multiply', 'Oslash', 'Ugrave', 'Uacute', 'Ucircumflex', 'Udieresis', 'Yacute', 'Thorn', 'germandbls', 'agrave', 'aacute', 'acircumflex', 'atilde', 'adieresis', 'aring', 'ae', 'ccedilla', 'egrave', 'eacute', 'ecircumflex', 'edieresis', 'igrave', 'iacute', 'icircumflex', 'idieresis', 'eth', 'ntilde', 'ograve', 'oacute', 'ocircumflex', 'otilde', 'odieresis', 'divide', 'oslash', 'ugrave', 'uacute', 'ucircumflex', 'udieresis', 'yacute', 'thorn', 'ydieresis'];
exports.WinAnsiEncoding = WinAnsiEncoding;
var SymbolSetEncoding = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'space', 'exclam', 'universal', 'numbersign', 'existential', 'percent', 'ampersand', 'suchthat', 'parenleft', 'parenright', 'asteriskmath', 'plus', 'comma', 'minus', 'period', 'slash', 'zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine', 'colon', 'semicolon', 'less', 'equal', 'greater', 'question', 'congruent', 'Alpha', 'Beta', 'Chi', 'Delta', 'Epsilon', 'Phi', 'Gamma', 'Eta', 'Iota', 'theta1', 'Kappa', 'Lambda', 'Mu', 'Nu', 'Omicron', 'Pi', 'Theta', 'Rho', 'Sigma', 'Tau', 'Upsilon', 'sigma1', 'Omega', 'Xi', 'Psi', 'Zeta', 'bracketleft', 'therefore', 'bracketright', 'perpendicular', 'underscore', 'radicalex', 'alpha', 'beta', 'chi', 'delta', 'epsilon', 'phi', 'gamma', 'eta', 'iota', 'phi1', 'kappa', 'lambda', 'mu', 'nu', 'omicron', 'pi', 'theta', 'rho', 'sigma', 'tau', 'upsilon', 'omega1', 'omega', 'xi', 'psi', 'zeta', 'braceleft', 'bar', 'braceright', 'similar', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'Euro', 'Upsilon1', 'minute', 'lessequal', 'fraction', 'infinity', 'florin', 'club', 'diamond', 'heart', 'spade', 'arrowboth', 'arrowleft', 'arrowup', 'arrowright', 'arrowdown', 'degree', 'plusminus', 'second', 'greaterequal', 'multiply', 'proportional', 'partialdiff', 'bullet', 'divide', 'notequal', 'equivalence', 'approxequal', 'ellipsis', 'arrowvertex', 'arrowhorizex', 'carriagereturn', 'aleph', 'Ifraktur', 'Rfraktur', 'weierstrass', 'circlemultiply', 'circleplus', 'emptyset', 'intersection', 'union', 'propersuperset', 'reflexsuperset', 'notsubset', 'propersubset', 'reflexsubset', 'element', 'notelement', 'angle', 'gradient', 'registerserif', 'copyrightserif', 'trademarkserif', 'product', 'radical', 'dotmath', 'logicalnot', 'logicaland', 'logicalor', 'arrowdblboth', 'arrowdblleft', 'arrowdblup', 'arrowdblright', 'arrowdbldown', 'lozenge', 'angleleft', 'registersans', 'copyrightsans', 'trademarksans', 'summation', 'parenlefttp', 'parenleftex', 'parenleftbt', 'bracketlefttp', 'bracketleftex', 'bracketleftbt', 'bracelefttp', 'braceleftmid', 'braceleftbt', 'braceex', '', 'angleright', 'integral', 'integraltp', 'integralex', 'integralbt', 'parenrighttp', 'parenrightex', 'parenrightbt', 'bracketrighttp', 'bracketrightex', 'bracketrightbt', 'bracerighttp', 'bracerightmid', 'bracerightbt', ''];
exports.SymbolSetEncoding = SymbolSetEncoding;
var ZapfDingbatsEncoding = ['', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'space', 'a1', 'a2', 'a202', 'a3', 'a4', 'a5', 'a119', 'a118', 'a117', 'a11', 'a12', 'a13', 'a14', 'a15', 'a16', 'a105', 'a17', 'a18', 'a19', 'a20', 'a21', 'a22', 'a23', 'a24', 'a25', 'a26', 'a27', 'a28', 'a6', 'a7', 'a8', 'a9', 'a10', 'a29', 'a30', 'a31', 'a32', 'a33', 'a34', 'a35', 'a36', 'a37', 'a38', 'a39', 'a40', 'a41', 'a42', 'a43', 'a44', 'a45', 'a46', 'a47', 'a48', 'a49', 'a50', 'a51', 'a52', 'a53', 'a54', 'a55', 'a56', 'a57', 'a58', 'a59', 'a60', 'a61', 'a62', 'a63', 'a64', 'a65', 'a66', 'a67', 'a68', 'a69', 'a70', 'a71', 'a72', 'a73', 'a74', 'a203', 'a75', 'a204', 'a76', 'a77', 'a78', 'a79', 'a81', 'a82', 'a83', 'a84', 'a97', 'a98', 'a99', 'a100', '', 'a89', 'a90', 'a93', 'a94', 'a91', 'a92', 'a205', 'a85', 'a206', 'a86', 'a87', 'a88', 'a95', 'a96', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'a101', 'a102', 'a103', 'a104', 'a106', 'a107', 'a108', 'a112', 'a111', 'a110', 'a109', 'a120', 'a121', 'a122', 'a123', 'a124', 'a125', 'a126', 'a127', 'a128', 'a129', 'a130', 'a131', 'a132', 'a133', 'a134', 'a135', 'a136', 'a137', 'a138', 'a139', 'a140', 'a141', 'a142', 'a143', 'a144', 'a145', 'a146', 'a147', 'a148', 'a149', 'a150', 'a151', 'a152', 'a153', 'a154', 'a155', 'a156', 'a157', 'a158', 'a159', 'a160', 'a161', 'a163', 'a164', 'a196', 'a165', 'a192', 'a166', 'a167', 'a168', 'a169', 'a170', 'a171', 'a172', 'a173', 'a162', 'a174', 'a175', 'a176', 'a177', 'a178', 'a179', 'a193', 'a180', 'a199', 'a181', 'a200', 'a182', '', 'a201', 'a183', 'a184', 'a197', 'a185', 'a194', 'a198', 'a186', 'a195', 'a187', 'a188', 'a189', 'a190', 'a191', ''];
exports.ZapfDingbatsEncoding = ZapfDingbatsEncoding;

function getEncoding(encodingName) {
  switch (encodingName) {
    case 'WinAnsiEncoding':
      return WinAnsiEncoding;

    case 'StandardEncoding':
      return StandardEncoding;

    case 'MacRomanEncoding':
      return MacRomanEncoding;

    case 'SymbolSetEncoding':
      return SymbolSetEncoding;

    case 'ZapfDingbatsEncoding':
      return ZapfDingbatsEncoding;

    case 'ExpertEncoding':
      return ExpertEncoding;

    case 'MacExpertEncoding':
      return MacExpertEncoding;

    default:
      return null;
  }
}

/***/ }),
/* 177 */
/***/ (function(module, exports, __w_pdfjs_require__) {

var getLookupTableFactory = __w_pdfjs_require__(6).getLookupTableFactory;
var getGlyphsUnicode = getLookupTableFactory(function (t) {
 t['A'] = 0x0041;
 t['AE'] = 0x00C6;
 t['AEacute'] = 0x01FC;
 t['AEmacron'] = 0x01E2;
 t['AEsmall'] = 0xF7E6;
 t['Aacute'] = 0x00C1;
 t['Aacutesmall'] = 0xF7E1;
 t['Abreve'] = 0x0102;
 t['Abreveacute'] = 0x1EAE;
 t['Abrevecyrillic'] = 0x04D0;
 t['Abrevedotbelow'] = 0x1EB6;
 t['Abrevegrave'] = 0x1EB0;
 t['Abrevehookabove'] = 0x1EB2;
 t['Abrevetilde'] = 0x1EB4;
 t['Acaron'] = 0x01CD;
 t['Acircle'] = 0x24B6;
 t['Acircumflex'] = 0x00C2;
 t['Acircumflexacute'] = 0x1EA4;
 t['Acircumflexdotbelow'] = 0x1EAC;
 t['Acircumflexgrave'] = 0x1EA6;
 t['Acircumflexhookabove'] = 0x1EA8;
 t['Acircumflexsmall'] = 0xF7E2;
 t['Acircumflextilde'] = 0x1EAA;
 t['Acute'] = 0xF6C9;
 t['Acutesmall'] = 0xF7B4;
 t['Acyrillic'] = 0x0410;
 t['Adblgrave'] = 0x0200;
 t['Adieresis'] = 0x00C4;
 t['Adieresiscyrillic'] = 0x04D2;
 t['Adieresismacron'] = 0x01DE;
 t['Adieresissmall'] = 0xF7E4;
 t['Adotbelow'] = 0x1EA0;
 t['Adotmacron'] = 0x01E0;
 t['Agrave'] = 0x00C0;
 t['Agravesmall'] = 0xF7E0;
 t['Ahookabove'] = 0x1EA2;
 t['Aiecyrillic'] = 0x04D4;
 t['Ainvertedbreve'] = 0x0202;
 t['Alpha'] = 0x0391;
 t['Alphatonos'] = 0x0386;
 t['Amacron'] = 0x0100;
 t['Amonospace'] = 0xFF21;
 t['Aogonek'] = 0x0104;
 t['Aring'] = 0x00C5;
 t['Aringacute'] = 0x01FA;
 t['Aringbelow'] = 0x1E00;
 t['Aringsmall'] = 0xF7E5;
 t['Asmall'] = 0xF761;
 t['Atilde'] = 0x00C3;
 t['Atildesmall'] = 0xF7E3;
 t['Aybarmenian'] = 0x0531;
 t['B'] = 0x0042;
 t['Bcircle'] = 0x24B7;
 t['Bdotaccent'] = 0x1E02;
 t['Bdotbelow'] = 0x1E04;
 t['Becyrillic'] = 0x0411;
 t['Benarmenian'] = 0x0532;
 t['Beta'] = 0x0392;
 t['Bhook'] = 0x0181;
 t['Blinebelow'] = 0x1E06;
 t['Bmonospace'] = 0xFF22;
 t['Brevesmall'] = 0xF6F4;
 t['Bsmall'] = 0xF762;
 t['Btopbar'] = 0x0182;
 t['C'] = 0x0043;
 t['Caarmenian'] = 0x053E;
 t['Cacute'] = 0x0106;
 t['Caron'] = 0xF6CA;
 t['Caronsmall'] = 0xF6F5;
 t['Ccaron'] = 0x010C;
 t['Ccedilla'] = 0x00C7;
 t['Ccedillaacute'] = 0x1E08;
 t['Ccedillasmall'] = 0xF7E7;
 t['Ccircle'] = 0x24B8;
 t['Ccircumflex'] = 0x0108;
 t['Cdot'] = 0x010A;
 t['Cdotaccent'] = 0x010A;
 t['Cedillasmall'] = 0xF7B8;
 t['Chaarmenian'] = 0x0549;
 t['Cheabkhasiancyrillic'] = 0x04BC;
 t['Checyrillic'] = 0x0427;
 t['Chedescenderabkhasiancyrillic'] = 0x04BE;
 t['Chedescendercyrillic'] = 0x04B6;
 t['Chedieresiscyrillic'] = 0x04F4;
 t['Cheharmenian'] = 0x0543;
 t['Chekhakassiancyrillic'] = 0x04CB;
 t['Cheverticalstrokecyrillic'] = 0x04B8;
 t['Chi'] = 0x03A7;
 t['Chook'] = 0x0187;
 t['Circumflexsmall'] = 0xF6F6;
 t['Cmonospace'] = 0xFF23;
 t['Coarmenian'] = 0x0551;
 t['Csmall'] = 0xF763;
 t['D'] = 0x0044;
 t['DZ'] = 0x01F1;
 t['DZcaron'] = 0x01C4;
 t['Daarmenian'] = 0x0534;
 t['Dafrican'] = 0x0189;
 t['Dcaron'] = 0x010E;
 t['Dcedilla'] = 0x1E10;
 t['Dcircle'] = 0x24B9;
 t['Dcircumflexbelow'] = 0x1E12;
 t['Dcroat'] = 0x0110;
 t['Ddotaccent'] = 0x1E0A;
 t['Ddotbelow'] = 0x1E0C;
 t['Decyrillic'] = 0x0414;
 t['Deicoptic'] = 0x03EE;
 t['Delta'] = 0x2206;
 t['Deltagreek'] = 0x0394;
 t['Dhook'] = 0x018A;
 t['Dieresis'] = 0xF6CB;
 t['DieresisAcute'] = 0xF6CC;
 t['DieresisGrave'] = 0xF6CD;
 t['Dieresissmall'] = 0xF7A8;
 t['Digammagreek'] = 0x03DC;
 t['Djecyrillic'] = 0x0402;
 t['Dlinebelow'] = 0x1E0E;
 t['Dmonospace'] = 0xFF24;
 t['Dotaccentsmall'] = 0xF6F7;
 t['Dslash'] = 0x0110;
 t['Dsmall'] = 0xF764;
 t['Dtopbar'] = 0x018B;
 t['Dz'] = 0x01F2;
 t['Dzcaron'] = 0x01C5;
 t['Dzeabkhasiancyrillic'] = 0x04E0;
 t['Dzecyrillic'] = 0x0405;
 t['Dzhecyrillic'] = 0x040F;
 t['E'] = 0x0045;
 t['Eacute'] = 0x00C9;
 t['Eacutesmall'] = 0xF7E9;
 t['Ebreve'] = 0x0114;
 t['Ecaron'] = 0x011A;
 t['Ecedillabreve'] = 0x1E1C;
 t['Echarmenian'] = 0x0535;
 t['Ecircle'] = 0x24BA;
 t['Ecircumflex'] = 0x00CA;
 t['Ecircumflexacute'] = 0x1EBE;
 t['Ecircumflexbelow'] = 0x1E18;
 t['Ecircumflexdotbelow'] = 0x1EC6;
 t['Ecircumflexgrave'] = 0x1EC0;
 t['Ecircumflexhookabove'] = 0x1EC2;
 t['Ecircumflexsmall'] = 0xF7EA;
 t['Ecircumflextilde'] = 0x1EC4;
 t['Ecyrillic'] = 0x0404;
 t['Edblgrave'] = 0x0204;
 t['Edieresis'] = 0x00CB;
 t['Edieresissmall'] = 0xF7EB;
 t['Edot'] = 0x0116;
 t['Edotaccent'] = 0x0116;
 t['Edotbelow'] = 0x1EB8;
 t['Efcyrillic'] = 0x0424;
 t['Egrave'] = 0x00C8;
 t['Egravesmall'] = 0xF7E8;
 t['Eharmenian'] = 0x0537;
 t['Ehookabove'] = 0x1EBA;
 t['Eightroman'] = 0x2167;
 t['Einvertedbreve'] = 0x0206;
 t['Eiotifiedcyrillic'] = 0x0464;
 t['Elcyrillic'] = 0x041B;
 t['Elevenroman'] = 0x216A;
 t['Emacron'] = 0x0112;
 t['Emacronacute'] = 0x1E16;
 t['Emacrongrave'] = 0x1E14;
 t['Emcyrillic'] = 0x041C;
 t['Emonospace'] = 0xFF25;
 t['Encyrillic'] = 0x041D;
 t['Endescendercyrillic'] = 0x04A2;
 t['Eng'] = 0x014A;
 t['Enghecyrillic'] = 0x04A4;
 t['Enhookcyrillic'] = 0x04C7;
 t['Eogonek'] = 0x0118;
 t['Eopen'] = 0x0190;
 t['Epsilon'] = 0x0395;
 t['Epsilontonos'] = 0x0388;
 t['Ercyrillic'] = 0x0420;
 t['Ereversed'] = 0x018E;
 t['Ereversedcyrillic'] = 0x042D;
 t['Escyrillic'] = 0x0421;
 t['Esdescendercyrillic'] = 0x04AA;
 t['Esh'] = 0x01A9;
 t['Esmall'] = 0xF765;
 t['Eta'] = 0x0397;
 t['Etarmenian'] = 0x0538;
 t['Etatonos'] = 0x0389;
 t['Eth'] = 0x00D0;
 t['Ethsmall'] = 0xF7F0;
 t['Etilde'] = 0x1EBC;
 t['Etildebelow'] = 0x1E1A;
 t['Euro'] = 0x20AC;
 t['Ezh'] = 0x01B7;
 t['Ezhcaron'] = 0x01EE;
 t['Ezhreversed'] = 0x01B8;
 t['F'] = 0x0046;
 t['Fcircle'] = 0x24BB;
 t['Fdotaccent'] = 0x1E1E;
 t['Feharmenian'] = 0x0556;
 t['Feicoptic'] = 0x03E4;
 t['Fhook'] = 0x0191;
 t['Fitacyrillic'] = 0x0472;
 t['Fiveroman'] = 0x2164;
 t['Fmonospace'] = 0xFF26;
 t['Fourroman'] = 0x2163;
 t['Fsmall'] = 0xF766;
 t['G'] = 0x0047;
 t['GBsquare'] = 0x3387;
 t['Gacute'] = 0x01F4;
 t['Gamma'] = 0x0393;
 t['Gammaafrican'] = 0x0194;
 t['Gangiacoptic'] = 0x03EA;
 t['Gbreve'] = 0x011E;
 t['Gcaron'] = 0x01E6;
 t['Gcedilla'] = 0x0122;
 t['Gcircle'] = 0x24BC;
 t['Gcircumflex'] = 0x011C;
 t['Gcommaaccent'] = 0x0122;
 t['Gdot'] = 0x0120;
 t['Gdotaccent'] = 0x0120;
 t['Gecyrillic'] = 0x0413;
 t['Ghadarmenian'] = 0x0542;
 t['Ghemiddlehookcyrillic'] = 0x0494;
 t['Ghestrokecyrillic'] = 0x0492;
 t['Gheupturncyrillic'] = 0x0490;
 t['Ghook'] = 0x0193;
 t['Gimarmenian'] = 0x0533;
 t['Gjecyrillic'] = 0x0403;
 t['Gmacron'] = 0x1E20;
 t['Gmonospace'] = 0xFF27;
 t['Grave'] = 0xF6CE;
 t['Gravesmall'] = 0xF760;
 t['Gsmall'] = 0xF767;
 t['Gsmallhook'] = 0x029B;
 t['Gstroke'] = 0x01E4;
 t['H'] = 0x0048;
 t['H18533'] = 0x25CF;
 t['H18543'] = 0x25AA;
 t['H18551'] = 0x25AB;
 t['H22073'] = 0x25A1;
 t['HPsquare'] = 0x33CB;
 t['Haabkhasiancyrillic'] = 0x04A8;
 t['Hadescendercyrillic'] = 0x04B2;
 t['Hardsigncyrillic'] = 0x042A;
 t['Hbar'] = 0x0126;
 t['Hbrevebelow'] = 0x1E2A;
 t['Hcedilla'] = 0x1E28;
 t['Hcircle'] = 0x24BD;
 t['Hcircumflex'] = 0x0124;
 t['Hdieresis'] = 0x1E26;
 t['Hdotaccent'] = 0x1E22;
 t['Hdotbelow'] = 0x1E24;
 t['Hmonospace'] = 0xFF28;
 t['Hoarmenian'] = 0x0540;
 t['Horicoptic'] = 0x03E8;
 t['Hsmall'] = 0xF768;
 t['Hungarumlaut'] = 0xF6CF;
 t['Hungarumlautsmall'] = 0xF6F8;
 t['Hzsquare'] = 0x3390;
 t['I'] = 0x0049;
 t['IAcyrillic'] = 0x042F;
 t['IJ'] = 0x0132;
 t['IUcyrillic'] = 0x042E;
 t['Iacute'] = 0x00CD;
 t['Iacutesmall'] = 0xF7ED;
 t['Ibreve'] = 0x012C;
 t['Icaron'] = 0x01CF;
 t['Icircle'] = 0x24BE;
 t['Icircumflex'] = 0x00CE;
 t['Icircumflexsmall'] = 0xF7EE;
 t['Icyrillic'] = 0x0406;
 t['Idblgrave'] = 0x0208;
 t['Idieresis'] = 0x00CF;
 t['Idieresisacute'] = 0x1E2E;
 t['Idieresiscyrillic'] = 0x04E4;
 t['Idieresissmall'] = 0xF7EF;
 t['Idot'] = 0x0130;
 t['Idotaccent'] = 0x0130;
 t['Idotbelow'] = 0x1ECA;
 t['Iebrevecyrillic'] = 0x04D6;
 t['Iecyrillic'] = 0x0415;
 t['Ifraktur'] = 0x2111;
 t['Igrave'] = 0x00CC;
 t['Igravesmall'] = 0xF7EC;
 t['Ihookabove'] = 0x1EC8;
 t['Iicyrillic'] = 0x0418;
 t['Iinvertedbreve'] = 0x020A;
 t['Iishortcyrillic'] = 0x0419;
 t['Imacron'] = 0x012A;
 t['Imacroncyrillic'] = 0x04E2;
 t['Imonospace'] = 0xFF29;
 t['Iniarmenian'] = 0x053B;
 t['Iocyrillic'] = 0x0401;
 t['Iogonek'] = 0x012E;
 t['Iota'] = 0x0399;
 t['Iotaafrican'] = 0x0196;
 t['Iotadieresis'] = 0x03AA;
 t['Iotatonos'] = 0x038A;
 t['Ismall'] = 0xF769;
 t['Istroke'] = 0x0197;
 t['Itilde'] = 0x0128;
 t['Itildebelow'] = 0x1E2C;
 t['Izhitsacyrillic'] = 0x0474;
 t['Izhitsadblgravecyrillic'] = 0x0476;
 t['J'] = 0x004A;
 t['Jaarmenian'] = 0x0541;
 t['Jcircle'] = 0x24BF;
 t['Jcircumflex'] = 0x0134;
 t['Jecyrillic'] = 0x0408;
 t['Jheharmenian'] = 0x054B;
 t['Jmonospace'] = 0xFF2A;
 t['Jsmall'] = 0xF76A;
 t['K'] = 0x004B;
 t['KBsquare'] = 0x3385;
 t['KKsquare'] = 0x33CD;
 t['Kabashkircyrillic'] = 0x04A0;
 t['Kacute'] = 0x1E30;
 t['Kacyrillic'] = 0x041A;
 t['Kadescendercyrillic'] = 0x049A;
 t['Kahookcyrillic'] = 0x04C3;
 t['Kappa'] = 0x039A;
 t['Kastrokecyrillic'] = 0x049E;
 t['Kaverticalstrokecyrillic'] = 0x049C;
 t['Kcaron'] = 0x01E8;
 t['Kcedilla'] = 0x0136;
 t['Kcircle'] = 0x24C0;
 t['Kcommaaccent'] = 0x0136;
 t['Kdotbelow'] = 0x1E32;
 t['Keharmenian'] = 0x0554;
 t['Kenarmenian'] = 0x053F;
 t['Khacyrillic'] = 0x0425;
 t['Kheicoptic'] = 0x03E6;
 t['Khook'] = 0x0198;
 t['Kjecyrillic'] = 0x040C;
 t['Klinebelow'] = 0x1E34;
 t['Kmonospace'] = 0xFF2B;
 t['Koppacyrillic'] = 0x0480;
 t['Koppagreek'] = 0x03DE;
 t['Ksicyrillic'] = 0x046E;
 t['Ksmall'] = 0xF76B;
 t['L'] = 0x004C;
 t['LJ'] = 0x01C7;
 t['LL'] = 0xF6BF;
 t['Lacute'] = 0x0139;
 t['Lambda'] = 0x039B;
 t['Lcaron'] = 0x013D;
 t['Lcedilla'] = 0x013B;
 t['Lcircle'] = 0x24C1;
 t['Lcircumflexbelow'] = 0x1E3C;
 t['Lcommaaccent'] = 0x013B;
 t['Ldot'] = 0x013F;
 t['Ldotaccent'] = 0x013F;
 t['Ldotbelow'] = 0x1E36;
 t['Ldotbelowmacron'] = 0x1E38;
 t['Liwnarmenian'] = 0x053C;
 t['Lj'] = 0x01C8;
 t['Ljecyrillic'] = 0x0409;
 t['Llinebelow'] = 0x1E3A;
 t['Lmonospace'] = 0xFF2C;
 t['Lslash'] = 0x0141;
 t['Lslashsmall'] = 0xF6F9;
 t['Lsmall'] = 0xF76C;
 t['M'] = 0x004D;
 t['MBsquare'] = 0x3386;
 t['Macron'] = 0xF6D0;
 t['Macronsmall'] = 0xF7AF;
 t['Macute'] = 0x1E3E;
 t['Mcircle'] = 0x24C2;
 t['Mdotaccent'] = 0x1E40;
 t['Mdotbelow'] = 0x1E42;
 t['Menarmenian'] = 0x0544;
 t['Mmonospace'] = 0xFF2D;
 t['Msmall'] = 0xF76D;
 t['Mturned'] = 0x019C;
 t['Mu'] = 0x039C;
 t['N'] = 0x004E;
 t['NJ'] = 0x01CA;
 t['Nacute'] = 0x0143;
 t['Ncaron'] = 0x0147;
 t['Ncedilla'] = 0x0145;
 t['Ncircle'] = 0x24C3;
 t['Ncircumflexbelow'] = 0x1E4A;
 t['Ncommaaccent'] = 0x0145;
 t['Ndotaccent'] = 0x1E44;
 t['Ndotbelow'] = 0x1E46;
 t['Nhookleft'] = 0x019D;
 t['Nineroman'] = 0x2168;
 t['Nj'] = 0x01CB;
 t['Njecyrillic'] = 0x040A;
 t['Nlinebelow'] = 0x1E48;
 t['Nmonospace'] = 0xFF2E;
 t['Nowarmenian'] = 0x0546;
 t['Nsmall'] = 0xF76E;
 t['Ntilde'] = 0x00D1;
 t['Ntildesmall'] = 0xF7F1;
 t['Nu'] = 0x039D;
 t['O'] = 0x004F;
 t['OE'] = 0x0152;
 t['OEsmall'] = 0xF6FA;
 t['Oacute'] = 0x00D3;
 t['Oacutesmall'] = 0xF7F3;
 t['Obarredcyrillic'] = 0x04E8;
 t['Obarreddieresiscyrillic'] = 0x04EA;
 t['Obreve'] = 0x014E;
 t['Ocaron'] = 0x01D1;
 t['Ocenteredtilde'] = 0x019F;
 t['Ocircle'] = 0x24C4;
 t['Ocircumflex'] = 0x00D4;
 t['Ocircumflexacute'] = 0x1ED0;
 t['Ocircumflexdotbelow'] = 0x1ED8;
 t['Ocircumflexgrave'] = 0x1ED2;
 t['Ocircumflexhookabove'] = 0x1ED4;
 t['Ocircumflexsmall'] = 0xF7F4;
 t['Ocircumflextilde'] = 0x1ED6;
 t['Ocyrillic'] = 0x041E;
 t['Odblacute'] = 0x0150;
 t['Odblgrave'] = 0x020C;
 t['Odieresis'] = 0x00D6;
 t['Odieresiscyrillic'] = 0x04E6;
 t['Odieresissmall'] = 0xF7F6;
 t['Odotbelow'] = 0x1ECC;
 t['Ogoneksmall'] = 0xF6FB;
 t['Ograve'] = 0x00D2;
 t['Ogravesmall'] = 0xF7F2;
 t['Oharmenian'] = 0x0555;
 t['Ohm'] = 0x2126;
 t['Ohookabove'] = 0x1ECE;
 t['Ohorn'] = 0x01A0;
 t['Ohornacute'] = 0x1EDA;
 t['Ohorndotbelow'] = 0x1EE2;
 t['Ohorngrave'] = 0x1EDC;
 t['Ohornhookabove'] = 0x1EDE;
 t['Ohorntilde'] = 0x1EE0;
 t['Ohungarumlaut'] = 0x0150;
 t['Oi'] = 0x01A2;
 t['Oinvertedbreve'] = 0x020E;
 t['Omacron'] = 0x014C;
 t['Omacronacute'] = 0x1E52;
 t['Omacrongrave'] = 0x1E50;
 t['Omega'] = 0x2126;
 t['Omegacyrillic'] = 0x0460;
 t['Omegagreek'] = 0x03A9;
 t['Omegaroundcyrillic'] = 0x047A;
 t['Omegatitlocyrillic'] = 0x047C;
 t['Omegatonos'] = 0x038F;
 t['Omicron'] = 0x039F;
 t['Omicrontonos'] = 0x038C;
 t['Omonospace'] = 0xFF2F;
 t['Oneroman'] = 0x2160;
 t['Oogonek'] = 0x01EA;
 t['Oogonekmacron'] = 0x01EC;
 t['Oopen'] = 0x0186;
 t['Oslash'] = 0x00D8;
 t['Oslashacute'] = 0x01FE;
 t['Oslashsmall'] = 0xF7F8;
 t['Osmall'] = 0xF76F;
 t['Ostrokeacute'] = 0x01FE;
 t['Otcyrillic'] = 0x047E;
 t['Otilde'] = 0x00D5;
 t['Otildeacute'] = 0x1E4C;
 t['Otildedieresis'] = 0x1E4E;
 t['Otildesmall'] = 0xF7F5;
 t['P'] = 0x0050;
 t['Pacute'] = 0x1E54;
 t['Pcircle'] = 0x24C5;
 t['Pdotaccent'] = 0x1E56;
 t['Pecyrillic'] = 0x041F;
 t['Peharmenian'] = 0x054A;
 t['Pemiddlehookcyrillic'] = 0x04A6;
 t['Phi'] = 0x03A6;
 t['Phook'] = 0x01A4;
 t['Pi'] = 0x03A0;
 t['Piwrarmenian'] = 0x0553;
 t['Pmonospace'] = 0xFF30;
 t['Psi'] = 0x03A8;
 t['Psicyrillic'] = 0x0470;
 t['Psmall'] = 0xF770;
 t['Q'] = 0x0051;
 t['Qcircle'] = 0x24C6;
 t['Qmonospace'] = 0xFF31;
 t['Qsmall'] = 0xF771;
 t['R'] = 0x0052;
 t['Raarmenian'] = 0x054C;
 t['Racute'] = 0x0154;
 t['Rcaron'] = 0x0158;
 t['Rcedilla'] = 0x0156;
 t['Rcircle'] = 0x24C7;
 t['Rcommaaccent'] = 0x0156;
 t['Rdblgrave'] = 0x0210;
 t['Rdotaccent'] = 0x1E58;
 t['Rdotbelow'] = 0x1E5A;
 t['Rdotbelowmacron'] = 0x1E5C;
 t['Reharmenian'] = 0x0550;
 t['Rfraktur'] = 0x211C;
 t['Rho'] = 0x03A1;
 t['Ringsmall'] = 0xF6FC;
 t['Rinvertedbreve'] = 0x0212;
 t['Rlinebelow'] = 0x1E5E;
 t['Rmonospace'] = 0xFF32;
 t['Rsmall'] = 0xF772;
 t['Rsmallinverted'] = 0x0281;
 t['Rsmallinvertedsuperior'] = 0x02B6;
 t['S'] = 0x0053;
 t['SF010000'] = 0x250C;
 t['SF020000'] = 0x2514;
 t['SF030000'] = 0x2510;
 t['SF040000'] = 0x2518;
 t['SF050000'] = 0x253C;
 t['SF060000'] = 0x252C;
 t['SF070000'] = 0x2534;
 t['SF080000'] = 0x251C;
 t['SF090000'] = 0x2524;
 t['SF100000'] = 0x2500;
 t['SF110000'] = 0x2502;
 t['SF190000'] = 0x2561;
 t['SF200000'] = 0x2562;
 t['SF210000'] = 0x2556;
 t['SF220000'] = 0x2555;
 t['SF230000'] = 0x2563;
 t['SF240000'] = 0x2551;
 t['SF250000'] = 0x2557;
 t['SF260000'] = 0x255D;
 t['SF270000'] = 0x255C;
 t['SF280000'] = 0x255B;
 t['SF360000'] = 0x255E;
 t['SF370000'] = 0x255F;
 t['SF380000'] = 0x255A;
 t['SF390000'] = 0x2554;
 t['SF400000'] = 0x2569;
 t['SF410000'] = 0x2566;
 t['SF420000'] = 0x2560;
 t['SF430000'] = 0x2550;
 t['SF440000'] = 0x256C;
 t['SF450000'] = 0x2567;
 t['SF460000'] = 0x2568;
 t['SF470000'] = 0x2564;
 t['SF480000'] = 0x2565;
 t['SF490000'] = 0x2559;
 t['SF500000'] = 0x2558;
 t['SF510000'] = 0x2552;
 t['SF520000'] = 0x2553;
 t['SF530000'] = 0x256B;
 t['SF540000'] = 0x256A;
 t['Sacute'] = 0x015A;
 t['Sacutedotaccent'] = 0x1E64;
 t['Sampigreek'] = 0x03E0;
 t['Scaron'] = 0x0160;
 t['Scarondotaccent'] = 0x1E66;
 t['Scaronsmall'] = 0xF6FD;
 t['Scedilla'] = 0x015E;
 t['Schwa'] = 0x018F;
 t['Schwacyrillic'] = 0x04D8;
 t['Schwadieresiscyrillic'] = 0x04DA;
 t['Scircle'] = 0x24C8;
 t['Scircumflex'] = 0x015C;
 t['Scommaaccent'] = 0x0218;
 t['Sdotaccent'] = 0x1E60;
 t['Sdotbelow'] = 0x1E62;
 t['Sdotbelowdotaccent'] = 0x1E68;
 t['Seharmenian'] = 0x054D;
 t['Sevenroman'] = 0x2166;
 t['Shaarmenian'] = 0x0547;
 t['Shacyrillic'] = 0x0428;
 t['Shchacyrillic'] = 0x0429;
 t['Sheicoptic'] = 0x03E2;
 t['Shhacyrillic'] = 0x04BA;
 t['Shimacoptic'] = 0x03EC;
 t['Sigma'] = 0x03A3;
 t['Sixroman'] = 0x2165;
 t['Smonospace'] = 0xFF33;
 t['Softsigncyrillic'] = 0x042C;
 t['Ssmall'] = 0xF773;
 t['Stigmagreek'] = 0x03DA;
 t['T'] = 0x0054;
 t['Tau'] = 0x03A4;
 t['Tbar'] = 0x0166;
 t['Tcaron'] = 0x0164;
 t['Tcedilla'] = 0x0162;
 t['Tcircle'] = 0x24C9;
 t['Tcircumflexbelow'] = 0x1E70;
 t['Tcommaaccent'] = 0x0162;
 t['Tdotaccent'] = 0x1E6A;
 t['Tdotbelow'] = 0x1E6C;
 t['Tecyrillic'] = 0x0422;
 t['Tedescendercyrillic'] = 0x04AC;
 t['Tenroman'] = 0x2169;
 t['Tetsecyrillic'] = 0x04B4;
 t['Theta'] = 0x0398;
 t['Thook'] = 0x01AC;
 t['Thorn'] = 0x00DE;
 t['Thornsmall'] = 0xF7FE;
 t['Threeroman'] = 0x2162;
 t['Tildesmall'] = 0xF6FE;
 t['Tiwnarmenian'] = 0x054F;
 t['Tlinebelow'] = 0x1E6E;
 t['Tmonospace'] = 0xFF34;
 t['Toarmenian'] = 0x0539;
 t['Tonefive'] = 0x01BC;
 t['Tonesix'] = 0x0184;
 t['Tonetwo'] = 0x01A7;
 t['Tretroflexhook'] = 0x01AE;
 t['Tsecyrillic'] = 0x0426;
 t['Tshecyrillic'] = 0x040B;
 t['Tsmall'] = 0xF774;
 t['Twelveroman'] = 0x216B;
 t['Tworoman'] = 0x2161;
 t['U'] = 0x0055;
 t['Uacute'] = 0x00DA;
 t['Uacutesmall'] = 0xF7FA;
 t['Ubreve'] = 0x016C;
 t['Ucaron'] = 0x01D3;
 t['Ucircle'] = 0x24CA;
 t['Ucircumflex'] = 0x00DB;
 t['Ucircumflexbelow'] = 0x1E76;
 t['Ucircumflexsmall'] = 0xF7FB;
 t['Ucyrillic'] = 0x0423;
 t['Udblacute'] = 0x0170;
 t['Udblgrave'] = 0x0214;
 t['Udieresis'] = 0x00DC;
 t['Udieresisacute'] = 0x01D7;
 t['Udieresisbelow'] = 0x1E72;
 t['Udieresiscaron'] = 0x01D9;
 t['Udieresiscyrillic'] = 0x04F0;
 t['Udieresisgrave'] = 0x01DB;
 t['Udieresismacron'] = 0x01D5;
 t['Udieresissmall'] = 0xF7FC;
 t['Udotbelow'] = 0x1EE4;
 t['Ugrave'] = 0x00D9;
 t['Ugravesmall'] = 0xF7F9;
 t['Uhookabove'] = 0x1EE6;
 t['Uhorn'] = 0x01AF;
 t['Uhornacute'] = 0x1EE8;
 t['Uhorndotbelow'] = 0x1EF0;
 t['Uhorngrave'] = 0x1EEA;
 t['Uhornhookabove'] = 0x1EEC;
 t['Uhorntilde'] = 0x1EEE;
 t['Uhungarumlaut'] = 0x0170;
 t['Uhungarumlautcyrillic'] = 0x04F2;
 t['Uinvertedbreve'] = 0x0216;
 t['Ukcyrillic'] = 0x0478;
 t['Umacron'] = 0x016A;
 t['Umacroncyrillic'] = 0x04EE;
 t['Umacrondieresis'] = 0x1E7A;
 t['Umonospace'] = 0xFF35;
 t['Uogonek'] = 0x0172;
 t['Upsilon'] = 0x03A5;
 t['Upsilon1'] = 0x03D2;
 t['Upsilonacutehooksymbolgreek'] = 0x03D3;
 t['Upsilonafrican'] = 0x01B1;
 t['Upsilondieresis'] = 0x03AB;
 t['Upsilondieresishooksymbolgreek'] = 0x03D4;
 t['Upsilonhooksymbol'] = 0x03D2;
 t['Upsilontonos'] = 0x038E;
 t['Uring'] = 0x016E;
 t['Ushortcyrillic'] = 0x040E;
 t['Usmall'] = 0xF775;
 t['Ustraightcyrillic'] = 0x04AE;
 t['Ustraightstrokecyrillic'] = 0x04B0;
 t['Utilde'] = 0x0168;
 t['Utildeacute'] = 0x1E78;
 t['Utildebelow'] = 0x1E74;
 t['V'] = 0x0056;
 t['Vcircle'] = 0x24CB;
 t['Vdotbelow'] = 0x1E7E;
 t['Vecyrillic'] = 0x0412;
 t['Vewarmenian'] = 0x054E;
 t['Vhook'] = 0x01B2;
 t['Vmonospace'] = 0xFF36;
 t['Voarmenian'] = 0x0548;
 t['Vsmall'] = 0xF776;
 t['Vtilde'] = 0x1E7C;
 t['W'] = 0x0057;
 t['Wacute'] = 0x1E82;
 t['Wcircle'] = 0x24CC;
 t['Wcircumflex'] = 0x0174;
 t['Wdieresis'] = 0x1E84;
 t['Wdotaccent'] = 0x1E86;
 t['Wdotbelow'] = 0x1E88;
 t['Wgrave'] = 0x1E80;
 t['Wmonospace'] = 0xFF37;
 t['Wsmall'] = 0xF777;
 t['X'] = 0x0058;
 t['Xcircle'] = 0x24CD;
 t['Xdieresis'] = 0x1E8C;
 t['Xdotaccent'] = 0x1E8A;
 t['Xeharmenian'] = 0x053D;
 t['Xi'] = 0x039E;
 t['Xmonospace'] = 0xFF38;
 t['Xsmall'] = 0xF778;
 t['Y'] = 0x0059;
 t['Yacute'] = 0x00DD;
 t['Yacutesmall'] = 0xF7FD;
 t['Yatcyrillic'] = 0x0462;
 t['Ycircle'] = 0x24CE;
 t['Ycircumflex'] = 0x0176;
 t['Ydieresis'] = 0x0178;
 t['Ydieresissmall'] = 0xF7FF;
 t['Ydotaccent'] = 0x1E8E;
 t['Ydotbelow'] = 0x1EF4;
 t['Yericyrillic'] = 0x042B;
 t['Yerudieresiscyrillic'] = 0x04F8;
 t['Ygrave'] = 0x1EF2;
 t['Yhook'] = 0x01B3;
 t['Yhookabove'] = 0x1EF6;
 t['Yiarmenian'] = 0x0545;
 t['Yicyrillic'] = 0x0407;
 t['Yiwnarmenian'] = 0x0552;
 t['Ymonospace'] = 0xFF39;
 t['Ysmall'] = 0xF779;
 t['Ytilde'] = 0x1EF8;
 t['Yusbigcyrillic'] = 0x046A;
 t['Yusbigiotifiedcyrillic'] = 0x046C;
 t['Yuslittlecyrillic'] = 0x0466;
 t['Yuslittleiotifiedcyrillic'] = 0x0468;
 t['Z'] = 0x005A;
 t['Zaarmenian'] = 0x0536;
 t['Zacute'] = 0x0179;
 t['Zcaron'] = 0x017D;
 t['Zcaronsmall'] = 0xF6FF;
 t['Zcircle'] = 0x24CF;
 t['Zcircumflex'] = 0x1E90;
 t['Zdot'] = 0x017B;
 t['Zdotaccent'] = 0x017B;
 t['Zdotbelow'] = 0x1E92;
 t['Zecyrillic'] = 0x0417;
 t['Zedescendercyrillic'] = 0x0498;
 t['Zedieresiscyrillic'] = 0x04DE;
 t['Zeta'] = 0x0396;
 t['Zhearmenian'] = 0x053A;
 t['Zhebrevecyrillic'] = 0x04C1;
 t['Zhecyrillic'] = 0x0416;
 t['Zhedescendercyrillic'] = 0x0496;
 t['Zhedieresiscyrillic'] = 0x04DC;
 t['Zlinebelow'] = 0x1E94;
 t['Zmonospace'] = 0xFF3A;
 t['Zsmall'] = 0xF77A;
 t['Zstroke'] = 0x01B5;
 t['a'] = 0x0061;
 t['aabengali'] = 0x0986;
 t['aacute'] = 0x00E1;
 t['aadeva'] = 0x0906;
 t['aagujarati'] = 0x0A86;
 t['aagurmukhi'] = 0x0A06;
 t['aamatragurmukhi'] = 0x0A3E;
 t['aarusquare'] = 0x3303;
 t['aavowelsignbengali'] = 0x09BE;
 t['aavowelsigndeva'] = 0x093E;
 t['aavowelsigngujarati'] = 0x0ABE;
 t['abbreviationmarkarmenian'] = 0x055F;
 t['abbreviationsigndeva'] = 0x0970;
 t['abengali'] = 0x0985;
 t['abopomofo'] = 0x311A;
 t['abreve'] = 0x0103;
 t['abreveacute'] = 0x1EAF;
 t['abrevecyrillic'] = 0x04D1;
 t['abrevedotbelow'] = 0x1EB7;
 t['abrevegrave'] = 0x1EB1;
 t['abrevehookabove'] = 0x1EB3;
 t['abrevetilde'] = 0x1EB5;
 t['acaron'] = 0x01CE;
 t['acircle'] = 0x24D0;
 t['acircumflex'] = 0x00E2;
 t['acircumflexacute'] = 0x1EA5;
 t['acircumflexdotbelow'] = 0x1EAD;
 t['acircumflexgrave'] = 0x1EA7;
 t['acircumflexhookabove'] = 0x1EA9;
 t['acircumflextilde'] = 0x1EAB;
 t['acute'] = 0x00B4;
 t['acutebelowcmb'] = 0x0317;
 t['acutecmb'] = 0x0301;
 t['acutecomb'] = 0x0301;
 t['acutedeva'] = 0x0954;
 t['acutelowmod'] = 0x02CF;
 t['acutetonecmb'] = 0x0341;
 t['acyrillic'] = 0x0430;
 t['adblgrave'] = 0x0201;
 t['addakgurmukhi'] = 0x0A71;
 t['adeva'] = 0x0905;
 t['adieresis'] = 0x00E4;
 t['adieresiscyrillic'] = 0x04D3;
 t['adieresismacron'] = 0x01DF;
 t['adotbelow'] = 0x1EA1;
 t['adotmacron'] = 0x01E1;
 t['ae'] = 0x00E6;
 t['aeacute'] = 0x01FD;
 t['aekorean'] = 0x3150;
 t['aemacron'] = 0x01E3;
 t['afii00208'] = 0x2015;
 t['afii08941'] = 0x20A4;
 t['afii10017'] = 0x0410;
 t['afii10018'] = 0x0411;
 t['afii10019'] = 0x0412;
 t['afii10020'] = 0x0413;
 t['afii10021'] = 0x0414;
 t['afii10022'] = 0x0415;
 t['afii10023'] = 0x0401;
 t['afii10024'] = 0x0416;
 t['afii10025'] = 0x0417;
 t['afii10026'] = 0x0418;
 t['afii10027'] = 0x0419;
 t['afii10028'] = 0x041A;
 t['afii10029'] = 0x041B;
 t['afii10030'] = 0x041C;
 t['afii10031'] = 0x041D;
 t['afii10032'] = 0x041E;
 t['afii10033'] = 0x041F;
 t['afii10034'] = 0x0420;
 t['afii10035'] = 0x0421;
 t['afii10036'] = 0x0422;
 t['afii10037'] = 0x0423;
 t['afii10038'] = 0x0424;
 t['afii10039'] = 0x0425;
 t['afii10040'] = 0x0426;
 t['afii10041'] = 0x0427;
 t['afii10042'] = 0x0428;
 t['afii10043'] = 0x0429;
 t['afii10044'] = 0x042A;
 t['afii10045'] = 0x042B;
 t['afii10046'] = 0x042C;
 t['afii10047'] = 0x042D;
 t['afii10048'] = 0x042E;
 t['afii10049'] = 0x042F;
 t['afii10050'] = 0x0490;
 t['afii10051'] = 0x0402;
 t['afii10052'] = 0x0403;
 t['afii10053'] = 0x0404;
 t['afii10054'] = 0x0405;
 t['afii10055'] = 0x0406;
 t['afii10056'] = 0x0407;
 t['afii10057'] = 0x0408;
 t['afii10058'] = 0x0409;
 t['afii10059'] = 0x040A;
 t['afii10060'] = 0x040B;
 t['afii10061'] = 0x040C;
 t['afii10062'] = 0x040E;
 t['afii10063'] = 0xF6C4;
 t['afii10064'] = 0xF6C5;
 t['afii10065'] = 0x0430;
 t['afii10066'] = 0x0431;
 t['afii10067'] = 0x0432;
 t['afii10068'] = 0x0433;
 t['afii10069'] = 0x0434;
 t['afii10070'] = 0x0435;
 t['afii10071'] = 0x0451;
 t['afii10072'] = 0x0436;
 t['afii10073'] = 0x0437;
 t['afii10074'] = 0x0438;
 t['afii10075'] = 0x0439;
 t['afii10076'] = 0x043A;
 t['afii10077'] = 0x043B;
 t['afii10078'] = 0x043C;
 t['afii10079'] = 0x043D;
 t['afii10080'] = 0x043E;
 t['afii10081'] = 0x043F;
 t['afii10082'] = 0x0440;
 t['afii10083'] = 0x0441;
 t['afii10084'] = 0x0442;
 t['afii10085'] = 0x0443;
 t['afii10086'] = 0x0444;
 t['afii10087'] = 0x0445;
 t['afii10088'] = 0x0446;
 t['afii10089'] = 0x0447;
 t['afii10090'] = 0x0448;
 t['afii10091'] = 0x0449;
 t['afii10092'] = 0x044A;
 t['afii10093'] = 0x044B;
 t['afii10094'] = 0x044C;
 t['afii10095'] = 0x044D;
 t['afii10096'] = 0x044E;
 t['afii10097'] = 0x044F;
 t['afii10098'] = 0x0491;
 t['afii10099'] = 0x0452;
 t['afii10100'] = 0x0453;
 t['afii10101'] = 0x0454;
 t['afii10102'] = 0x0455;
 t['afii10103'] = 0x0456;
 t['afii10104'] = 0x0457;
 t['afii10105'] = 0x0458;
 t['afii10106'] = 0x0459;
 t['afii10107'] = 0x045A;
 t['afii10108'] = 0x045B;
 t['afii10109'] = 0x045C;
 t['afii10110'] = 0x045E;
 t['afii10145'] = 0x040F;
 t['afii10146'] = 0x0462;
 t['afii10147'] = 0x0472;
 t['afii10148'] = 0x0474;
 t['afii10192'] = 0xF6C6;
 t['afii10193'] = 0x045F;
 t['afii10194'] = 0x0463;
 t['afii10195'] = 0x0473;
 t['afii10196'] = 0x0475;
 t['afii10831'] = 0xF6C7;
 t['afii10832'] = 0xF6C8;
 t['afii10846'] = 0x04D9;
 t['afii299'] = 0x200E;
 t['afii300'] = 0x200F;
 t['afii301'] = 0x200D;
 t['afii57381'] = 0x066A;
 t['afii57388'] = 0x060C;
 t['afii57392'] = 0x0660;
 t['afii57393'] = 0x0661;
 t['afii57394'] = 0x0662;
 t['afii57395'] = 0x0663;
 t['afii57396'] = 0x0664;
 t['afii57397'] = 0x0665;
 t['afii57398'] = 0x0666;
 t['afii57399'] = 0x0667;
 t['afii57400'] = 0x0668;
 t['afii57401'] = 0x0669;
 t['afii57403'] = 0x061B;
 t['afii57407'] = 0x061F;
 t['afii57409'] = 0x0621;
 t['afii57410'] = 0x0622;
 t['afii57411'] = 0x0623;
 t['afii57412'] = 0x0624;
 t['afii57413'] = 0x0625;
 t['afii57414'] = 0x0626;
 t['afii57415'] = 0x0627;
 t['afii57416'] = 0x0628;
 t['afii57417'] = 0x0629;
 t['afii57418'] = 0x062A;
 t['afii57419'] = 0x062B;
 t['afii57420'] = 0x062C;
 t['afii57421'] = 0x062D;
 t['afii57422'] = 0x062E;
 t['afii57423'] = 0x062F;
 t['afii57424'] = 0x0630;
 t['afii57425'] = 0x0631;
 t['afii57426'] = 0x0632;
 t['afii57427'] = 0x0633;
 t['afii57428'] = 0x0634;
 t['afii57429'] = 0x0635;
 t['afii57430'] = 0x0636;
 t['afii57431'] = 0x0637;
 t['afii57432'] = 0x0638;
 t['afii57433'] = 0x0639;
 t['afii57434'] = 0x063A;
 t['afii57440'] = 0x0640;
 t['afii57441'] = 0x0641;
 t['afii57442'] = 0x0642;
 t['afii57443'] = 0x0643;
 t['afii57444'] = 0x0644;
 t['afii57445'] = 0x0645;
 t['afii57446'] = 0x0646;
 t['afii57448'] = 0x0648;
 t['afii57449'] = 0x0649;
 t['afii57450'] = 0x064A;
 t['afii57451'] = 0x064B;
 t['afii57452'] = 0x064C;
 t['afii57453'] = 0x064D;
 t['afii57454'] = 0x064E;
 t['afii57455'] = 0x064F;
 t['afii57456'] = 0x0650;
 t['afii57457'] = 0x0651;
 t['afii57458'] = 0x0652;
 t['afii57470'] = 0x0647;
 t['afii57505'] = 0x06A4;
 t['afii57506'] = 0x067E;
 t['afii57507'] = 0x0686;
 t['afii57508'] = 0x0698;
 t['afii57509'] = 0x06AF;
 t['afii57511'] = 0x0679;
 t['afii57512'] = 0x0688;
 t['afii57513'] = 0x0691;
 t['afii57514'] = 0x06BA;
 t['afii57519'] = 0x06D2;
 t['afii57534'] = 0x06D5;
 t['afii57636'] = 0x20AA;
 t['afii57645'] = 0x05BE;
 t['afii57658'] = 0x05C3;
 t['afii57664'] = 0x05D0;
 t['afii57665'] = 0x05D1;
 t['afii57666'] = 0x05D2;
 t['afii57667'] = 0x05D3;
 t['afii57668'] = 0x05D4;
 t['afii57669'] = 0x05D5;
 t['afii57670'] = 0x05D6;
 t['afii57671'] = 0x05D7;
 t['afii57672'] = 0x05D8;
 t['afii57673'] = 0x05D9;
 t['afii57674'] = 0x05DA;
 t['afii57675'] = 0x05DB;
 t['afii57676'] = 0x05DC;
 t['afii57677'] = 0x05DD;
 t['afii57678'] = 0x05DE;
 t['afii57679'] = 0x05DF;
 t['afii57680'] = 0x05E0;
 t['afii57681'] = 0x05E1;
 t['afii57682'] = 0x05E2;
 t['afii57683'] = 0x05E3;
 t['afii57684'] = 0x05E4;
 t['afii57685'] = 0x05E5;
 t['afii57686'] = 0x05E6;
 t['afii57687'] = 0x05E7;
 t['afii57688'] = 0x05E8;
 t['afii57689'] = 0x05E9;
 t['afii57690'] = 0x05EA;
 t['afii57694'] = 0xFB2A;
 t['afii57695'] = 0xFB2B;
 t['afii57700'] = 0xFB4B;
 t['afii57705'] = 0xFB1F;
 t['afii57716'] = 0x05F0;
 t['afii57717'] = 0x05F1;
 t['afii57718'] = 0x05F2;
 t['afii57723'] = 0xFB35;
 t['afii57793'] = 0x05B4;
 t['afii57794'] = 0x05B5;
 t['afii57795'] = 0x05B6;
 t['afii57796'] = 0x05BB;
 t['afii57797'] = 0x05B8;
 t['afii57798'] = 0x05B7;
 t['afii57799'] = 0x05B0;
 t['afii57800'] = 0x05B2;
 t['afii57801'] = 0x05B1;
 t['afii57802'] = 0x05B3;
 t['afii57803'] = 0x05C2;
 t['afii57804'] = 0x05C1;
 t['afii57806'] = 0x05B9;
 t['afii57807'] = 0x05BC;
 t['afii57839'] = 0x05BD;
 t['afii57841'] = 0x05BF;
 t['afii57842'] = 0x05C0;
 t['afii57929'] = 0x02BC;
 t['afii61248'] = 0x2105;
 t['afii61289'] = 0x2113;
 t['afii61352'] = 0x2116;
 t['afii61573'] = 0x202C;
 t['afii61574'] = 0x202D;
 t['afii61575'] = 0x202E;
 t['afii61664'] = 0x200C;
 t['afii63167'] = 0x066D;
 t['afii64937'] = 0x02BD;
 t['agrave'] = 0x00E0;
 t['agujarati'] = 0x0A85;
 t['agurmukhi'] = 0x0A05;
 t['ahiragana'] = 0x3042;
 t['ahookabove'] = 0x1EA3;
 t['aibengali'] = 0x0990;
 t['aibopomofo'] = 0x311E;
 t['aideva'] = 0x0910;
 t['aiecyrillic'] = 0x04D5;
 t['aigujarati'] = 0x0A90;
 t['aigurmukhi'] = 0x0A10;
 t['aimatragurmukhi'] = 0x0A48;
 t['ainarabic'] = 0x0639;
 t['ainfinalarabic'] = 0xFECA;
 t['aininitialarabic'] = 0xFECB;
 t['ainmedialarabic'] = 0xFECC;
 t['ainvertedbreve'] = 0x0203;
 t['aivowelsignbengali'] = 0x09C8;
 t['aivowelsigndeva'] = 0x0948;
 t['aivowelsigngujarati'] = 0x0AC8;
 t['akatakana'] = 0x30A2;
 t['akatakanahalfwidth'] = 0xFF71;
 t['akorean'] = 0x314F;
 t['alef'] = 0x05D0;
 t['alefarabic'] = 0x0627;
 t['alefdageshhebrew'] = 0xFB30;
 t['aleffinalarabic'] = 0xFE8E;
 t['alefhamzaabovearabic'] = 0x0623;
 t['alefhamzaabovefinalarabic'] = 0xFE84;
 t['alefhamzabelowarabic'] = 0x0625;
 t['alefhamzabelowfinalarabic'] = 0xFE88;
 t['alefhebrew'] = 0x05D0;
 t['aleflamedhebrew'] = 0xFB4F;
 t['alefmaddaabovearabic'] = 0x0622;
 t['alefmaddaabovefinalarabic'] = 0xFE82;
 t['alefmaksuraarabic'] = 0x0649;
 t['alefmaksurafinalarabic'] = 0xFEF0;
 t['alefmaksurainitialarabic'] = 0xFEF3;
 t['alefmaksuramedialarabic'] = 0xFEF4;
 t['alefpatahhebrew'] = 0xFB2E;
 t['alefqamatshebrew'] = 0xFB2F;
 t['aleph'] = 0x2135;
 t['allequal'] = 0x224C;
 t['alpha'] = 0x03B1;
 t['alphatonos'] = 0x03AC;
 t['amacron'] = 0x0101;
 t['amonospace'] = 0xFF41;
 t['ampersand'] = 0x0026;
 t['ampersandmonospace'] = 0xFF06;
 t['ampersandsmall'] = 0xF726;
 t['amsquare'] = 0x33C2;
 t['anbopomofo'] = 0x3122;
 t['angbopomofo'] = 0x3124;
 t['angbracketleft'] = 0x3008;
 t['angbracketright'] = 0x3009;
 t['angkhankhuthai'] = 0x0E5A;
 t['angle'] = 0x2220;
 t['anglebracketleft'] = 0x3008;
 t['anglebracketleftvertical'] = 0xFE3F;
 t['anglebracketright'] = 0x3009;
 t['anglebracketrightvertical'] = 0xFE40;
 t['angleleft'] = 0x2329;
 t['angleright'] = 0x232A;
 t['angstrom'] = 0x212B;
 t['anoteleia'] = 0x0387;
 t['anudattadeva'] = 0x0952;
 t['anusvarabengali'] = 0x0982;
 t['anusvaradeva'] = 0x0902;
 t['anusvaragujarati'] = 0x0A82;
 t['aogonek'] = 0x0105;
 t['apaatosquare'] = 0x3300;
 t['aparen'] = 0x249C;
 t['apostrophearmenian'] = 0x055A;
 t['apostrophemod'] = 0x02BC;
 t['apple'] = 0xF8FF;
 t['approaches'] = 0x2250;
 t['approxequal'] = 0x2248;
 t['approxequalorimage'] = 0x2252;
 t['approximatelyequal'] = 0x2245;
 t['araeaekorean'] = 0x318E;
 t['araeakorean'] = 0x318D;
 t['arc'] = 0x2312;
 t['arighthalfring'] = 0x1E9A;
 t['aring'] = 0x00E5;
 t['aringacute'] = 0x01FB;
 t['aringbelow'] = 0x1E01;
 t['arrowboth'] = 0x2194;
 t['arrowdashdown'] = 0x21E3;
 t['arrowdashleft'] = 0x21E0;
 t['arrowdashright'] = 0x21E2;
 t['arrowdashup'] = 0x21E1;
 t['arrowdblboth'] = 0x21D4;
 t['arrowdbldown'] = 0x21D3;
 t['arrowdblleft'] = 0x21D0;
 t['arrowdblright'] = 0x21D2;
 t['arrowdblup'] = 0x21D1;
 t['arrowdown'] = 0x2193;
 t['arrowdownleft'] = 0x2199;
 t['arrowdownright'] = 0x2198;
 t['arrowdownwhite'] = 0x21E9;
 t['arrowheaddownmod'] = 0x02C5;
 t['arrowheadleftmod'] = 0x02C2;
 t['arrowheadrightmod'] = 0x02C3;
 t['arrowheadupmod'] = 0x02C4;
 t['arrowhorizex'] = 0xF8E7;
 t['arrowleft'] = 0x2190;
 t['arrowleftdbl'] = 0x21D0;
 t['arrowleftdblstroke'] = 0x21CD;
 t['arrowleftoverright'] = 0x21C6;
 t['arrowleftwhite'] = 0x21E6;
 t['arrowright'] = 0x2192;
 t['arrowrightdblstroke'] = 0x21CF;
 t['arrowrightheavy'] = 0x279E;
 t['arrowrightoverleft'] = 0x21C4;
 t['arrowrightwhite'] = 0x21E8;
 t['arrowtableft'] = 0x21E4;
 t['arrowtabright'] = 0x21E5;
 t['arrowup'] = 0x2191;
 t['arrowupdn'] = 0x2195;
 t['arrowupdnbse'] = 0x21A8;
 t['arrowupdownbase'] = 0x21A8;
 t['arrowupleft'] = 0x2196;
 t['arrowupleftofdown'] = 0x21C5;
 t['arrowupright'] = 0x2197;
 t['arrowupwhite'] = 0x21E7;
 t['arrowvertex'] = 0xF8E6;
 t['asciicircum'] = 0x005E;
 t['asciicircummonospace'] = 0xFF3E;
 t['asciitilde'] = 0x007E;
 t['asciitildemonospace'] = 0xFF5E;
 t['ascript'] = 0x0251;
 t['ascriptturned'] = 0x0252;
 t['asmallhiragana'] = 0x3041;
 t['asmallkatakana'] = 0x30A1;
 t['asmallkatakanahalfwidth'] = 0xFF67;
 t['asterisk'] = 0x002A;
 t['asteriskaltonearabic'] = 0x066D;
 t['asteriskarabic'] = 0x066D;
 t['asteriskmath'] = 0x2217;
 t['asteriskmonospace'] = 0xFF0A;
 t['asterisksmall'] = 0xFE61;
 t['asterism'] = 0x2042;
 t['asuperior'] = 0xF6E9;
 t['asymptoticallyequal'] = 0x2243;
 t['at'] = 0x0040;
 t['atilde'] = 0x00E3;
 t['atmonospace'] = 0xFF20;
 t['atsmall'] = 0xFE6B;
 t['aturned'] = 0x0250;
 t['aubengali'] = 0x0994;
 t['aubopomofo'] = 0x3120;
 t['audeva'] = 0x0914;
 t['augujarati'] = 0x0A94;
 t['augurmukhi'] = 0x0A14;
 t['aulengthmarkbengali'] = 0x09D7;
 t['aumatragurmukhi'] = 0x0A4C;
 t['auvowelsignbengali'] = 0x09CC;
 t['auvowelsigndeva'] = 0x094C;
 t['auvowelsigngujarati'] = 0x0ACC;
 t['avagrahadeva'] = 0x093D;
 t['aybarmenian'] = 0x0561;
 t['ayin'] = 0x05E2;
 t['ayinaltonehebrew'] = 0xFB20;
 t['ayinhebrew'] = 0x05E2;
 t['b'] = 0x0062;
 t['babengali'] = 0x09AC;
 t['backslash'] = 0x005C;
 t['backslashmonospace'] = 0xFF3C;
 t['badeva'] = 0x092C;
 t['bagujarati'] = 0x0AAC;
 t['bagurmukhi'] = 0x0A2C;
 t['bahiragana'] = 0x3070;
 t['bahtthai'] = 0x0E3F;
 t['bakatakana'] = 0x30D0;
 t['bar'] = 0x007C;
 t['barmonospace'] = 0xFF5C;
 t['bbopomofo'] = 0x3105;
 t['bcircle'] = 0x24D1;
 t['bdotaccent'] = 0x1E03;
 t['bdotbelow'] = 0x1E05;
 t['beamedsixteenthnotes'] = 0x266C;
 t['because'] = 0x2235;
 t['becyrillic'] = 0x0431;
 t['beharabic'] = 0x0628;
 t['behfinalarabic'] = 0xFE90;
 t['behinitialarabic'] = 0xFE91;
 t['behiragana'] = 0x3079;
 t['behmedialarabic'] = 0xFE92;
 t['behmeeminitialarabic'] = 0xFC9F;
 t['behmeemisolatedarabic'] = 0xFC08;
 t['behnoonfinalarabic'] = 0xFC6D;
 t['bekatakana'] = 0x30D9;
 t['benarmenian'] = 0x0562;
 t['bet'] = 0x05D1;
 t['beta'] = 0x03B2;
 t['betasymbolgreek'] = 0x03D0;
 t['betdagesh'] = 0xFB31;
 t['betdageshhebrew'] = 0xFB31;
 t['bethebrew'] = 0x05D1;
 t['betrafehebrew'] = 0xFB4C;
 t['bhabengali'] = 0x09AD;
 t['bhadeva'] = 0x092D;
 t['bhagujarati'] = 0x0AAD;
 t['bhagurmukhi'] = 0x0A2D;
 t['bhook'] = 0x0253;
 t['bihiragana'] = 0x3073;
 t['bikatakana'] = 0x30D3;
 t['bilabialclick'] = 0x0298;
 t['bindigurmukhi'] = 0x0A02;
 t['birusquare'] = 0x3331;
 t['blackcircle'] = 0x25CF;
 t['blackdiamond'] = 0x25C6;
 t['blackdownpointingtriangle'] = 0x25BC;
 t['blackleftpointingpointer'] = 0x25C4;
 t['blackleftpointingtriangle'] = 0x25C0;
 t['blacklenticularbracketleft'] = 0x3010;
 t['blacklenticularbracketleftvertical'] = 0xFE3B;
 t['blacklenticularbracketright'] = 0x3011;
 t['blacklenticularbracketrightvertical'] = 0xFE3C;
 t['blacklowerlefttriangle'] = 0x25E3;
 t['blacklowerrighttriangle'] = 0x25E2;
 t['blackrectangle'] = 0x25AC;
 t['blackrightpointingpointer'] = 0x25BA;
 t['blackrightpointingtriangle'] = 0x25B6;
 t['blacksmallsquare'] = 0x25AA;
 t['blacksmilingface'] = 0x263B;
 t['blacksquare'] = 0x25A0;
 t['blackstar'] = 0x2605;
 t['blackupperlefttriangle'] = 0x25E4;
 t['blackupperrighttriangle'] = 0x25E5;
 t['blackuppointingsmalltriangle'] = 0x25B4;
 t['blackuppointingtriangle'] = 0x25B2;
 t['blank'] = 0x2423;
 t['blinebelow'] = 0x1E07;
 t['block'] = 0x2588;
 t['bmonospace'] = 0xFF42;
 t['bobaimaithai'] = 0x0E1A;
 t['bohiragana'] = 0x307C;
 t['bokatakana'] = 0x30DC;
 t['bparen'] = 0x249D;
 t['bqsquare'] = 0x33C3;
 t['braceex'] = 0xF8F4;
 t['braceleft'] = 0x007B;
 t['braceleftbt'] = 0xF8F3;
 t['braceleftmid'] = 0xF8F2;
 t['braceleftmonospace'] = 0xFF5B;
 t['braceleftsmall'] = 0xFE5B;
 t['bracelefttp'] = 0xF8F1;
 t['braceleftvertical'] = 0xFE37;
 t['braceright'] = 0x007D;
 t['bracerightbt'] = 0xF8FE;
 t['bracerightmid'] = 0xF8FD;
 t['bracerightmonospace'] = 0xFF5D;
 t['bracerightsmall'] = 0xFE5C;
 t['bracerighttp'] = 0xF8FC;
 t['bracerightvertical'] = 0xFE38;
 t['bracketleft'] = 0x005B;
 t['bracketleftbt'] = 0xF8F0;
 t['bracketleftex'] = 0xF8EF;
 t['bracketleftmonospace'] = 0xFF3B;
 t['bracketlefttp'] = 0xF8EE;
 t['bracketright'] = 0x005D;
 t['bracketrightbt'] = 0xF8FB;
 t['bracketrightex'] = 0xF8FA;
 t['bracketrightmonospace'] = 0xFF3D;
 t['bracketrighttp'] = 0xF8F9;
 t['breve'] = 0x02D8;
 t['brevebelowcmb'] = 0x032E;
 t['brevecmb'] = 0x0306;
 t['breveinvertedbelowcmb'] = 0x032F;
 t['breveinvertedcmb'] = 0x0311;
 t['breveinverteddoublecmb'] = 0x0361;
 t['bridgebelowcmb'] = 0x032A;
 t['bridgeinvertedbelowcmb'] = 0x033A;
 t['brokenbar'] = 0x00A6;
 t['bstroke'] = 0x0180;
 t['bsuperior'] = 0xF6EA;
 t['btopbar'] = 0x0183;
 t['buhiragana'] = 0x3076;
 t['bukatakana'] = 0x30D6;
 t['bullet'] = 0x2022;
 t['bulletinverse'] = 0x25D8;
 t['bulletoperator'] = 0x2219;
 t['bullseye'] = 0x25CE;
 t['c'] = 0x0063;
 t['caarmenian'] = 0x056E;
 t['cabengali'] = 0x099A;
 t['cacute'] = 0x0107;
 t['cadeva'] = 0x091A;
 t['cagujarati'] = 0x0A9A;
 t['cagurmukhi'] = 0x0A1A;
 t['calsquare'] = 0x3388;
 t['candrabindubengali'] = 0x0981;
 t['candrabinducmb'] = 0x0310;
 t['candrabindudeva'] = 0x0901;
 t['candrabindugujarati'] = 0x0A81;
 t['capslock'] = 0x21EA;
 t['careof'] = 0x2105;
 t['caron'] = 0x02C7;
 t['caronbelowcmb'] = 0x032C;
 t['caroncmb'] = 0x030C;
 t['carriagereturn'] = 0x21B5;
 t['cbopomofo'] = 0x3118;
 t['ccaron'] = 0x010D;
 t['ccedilla'] = 0x00E7;
 t['ccedillaacute'] = 0x1E09;
 t['ccircle'] = 0x24D2;
 t['ccircumflex'] = 0x0109;
 t['ccurl'] = 0x0255;
 t['cdot'] = 0x010B;
 t['cdotaccent'] = 0x010B;
 t['cdsquare'] = 0x33C5;
 t['cedilla'] = 0x00B8;
 t['cedillacmb'] = 0x0327;
 t['cent'] = 0x00A2;
 t['centigrade'] = 0x2103;
 t['centinferior'] = 0xF6DF;
 t['centmonospace'] = 0xFFE0;
 t['centoldstyle'] = 0xF7A2;
 t['centsuperior'] = 0xF6E0;
 t['chaarmenian'] = 0x0579;
 t['chabengali'] = 0x099B;
 t['chadeva'] = 0x091B;
 t['chagujarati'] = 0x0A9B;
 t['chagurmukhi'] = 0x0A1B;
 t['chbopomofo'] = 0x3114;
 t['cheabkhasiancyrillic'] = 0x04BD;
 t['checkmark'] = 0x2713;
 t['checyrillic'] = 0x0447;
 t['chedescenderabkhasiancyrillic'] = 0x04BF;
 t['chedescendercyrillic'] = 0x04B7;
 t['chedieresiscyrillic'] = 0x04F5;
 t['cheharmenian'] = 0x0573;
 t['chekhakassiancyrillic'] = 0x04CC;
 t['cheverticalstrokecyrillic'] = 0x04B9;
 t['chi'] = 0x03C7;
 t['chieuchacirclekorean'] = 0x3277;
 t['chieuchaparenkorean'] = 0x3217;
 t['chieuchcirclekorean'] = 0x3269;
 t['chieuchkorean'] = 0x314A;
 t['chieuchparenkorean'] = 0x3209;
 t['chochangthai'] = 0x0E0A;
 t['chochanthai'] = 0x0E08;
 t['chochingthai'] = 0x0E09;
 t['chochoethai'] = 0x0E0C;
 t['chook'] = 0x0188;
 t['cieucacirclekorean'] = 0x3276;
 t['cieucaparenkorean'] = 0x3216;
 t['cieuccirclekorean'] = 0x3268;
 t['cieuckorean'] = 0x3148;
 t['cieucparenkorean'] = 0x3208;
 t['cieucuparenkorean'] = 0x321C;
 t['circle'] = 0x25CB;
 t['circlecopyrt'] = 0x00A9;
 t['circlemultiply'] = 0x2297;
 t['circleot'] = 0x2299;
 t['circleplus'] = 0x2295;
 t['circlepostalmark'] = 0x3036;
 t['circlewithlefthalfblack'] = 0x25D0;
 t['circlewithrighthalfblack'] = 0x25D1;
 t['circumflex'] = 0x02C6;
 t['circumflexbelowcmb'] = 0x032D;
 t['circumflexcmb'] = 0x0302;
 t['clear'] = 0x2327;
 t['clickalveolar'] = 0x01C2;
 t['clickdental'] = 0x01C0;
 t['clicklateral'] = 0x01C1;
 t['clickretroflex'] = 0x01C3;
 t['club'] = 0x2663;
 t['clubsuitblack'] = 0x2663;
 t['clubsuitwhite'] = 0x2667;
 t['cmcubedsquare'] = 0x33A4;
 t['cmonospace'] = 0xFF43;
 t['cmsquaredsquare'] = 0x33A0;
 t['coarmenian'] = 0x0581;
 t['colon'] = 0x003A;
 t['colonmonetary'] = 0x20A1;
 t['colonmonospace'] = 0xFF1A;
 t['colonsign'] = 0x20A1;
 t['colonsmall'] = 0xFE55;
 t['colontriangularhalfmod'] = 0x02D1;
 t['colontriangularmod'] = 0x02D0;
 t['comma'] = 0x002C;
 t['commaabovecmb'] = 0x0313;
 t['commaaboverightcmb'] = 0x0315;
 t['commaaccent'] = 0xF6C3;
 t['commaarabic'] = 0x060C;
 t['commaarmenian'] = 0x055D;
 t['commainferior'] = 0xF6E1;
 t['commamonospace'] = 0xFF0C;
 t['commareversedabovecmb'] = 0x0314;
 t['commareversedmod'] = 0x02BD;
 t['commasmall'] = 0xFE50;
 t['commasuperior'] = 0xF6E2;
 t['commaturnedabovecmb'] = 0x0312;
 t['commaturnedmod'] = 0x02BB;
 t['compass'] = 0x263C;
 t['congruent'] = 0x2245;
 t['contourintegral'] = 0x222E;
 t['control'] = 0x2303;
 t['controlACK'] = 0x0006;
 t['controlBEL'] = 0x0007;
 t['controlBS'] = 0x0008;
 t['controlCAN'] = 0x0018;
 t['controlCR'] = 0x000D;
 t['controlDC1'] = 0x0011;
 t['controlDC2'] = 0x0012;
 t['controlDC3'] = 0x0013;
 t['controlDC4'] = 0x0014;
 t['controlDEL'] = 0x007F;
 t['controlDLE'] = 0x0010;
 t['controlEM'] = 0x0019;
 t['controlENQ'] = 0x0005;
 t['controlEOT'] = 0x0004;
 t['controlESC'] = 0x001B;
 t['controlETB'] = 0x0017;
 t['controlETX'] = 0x0003;
 t['controlFF'] = 0x000C;
 t['controlFS'] = 0x001C;
 t['controlGS'] = 0x001D;
 t['controlHT'] = 0x0009;
 t['controlLF'] = 0x000A;
 t['controlNAK'] = 0x0015;
 t['controlNULL'] = 0x0000;
 t['controlRS'] = 0x001E;
 t['controlSI'] = 0x000F;
 t['controlSO'] = 0x000E;
 t['controlSOT'] = 0x0002;
 t['controlSTX'] = 0x0001;
 t['controlSUB'] = 0x001A;
 t['controlSYN'] = 0x0016;
 t['controlUS'] = 0x001F;
 t['controlVT'] = 0x000B;
 t['copyright'] = 0x00A9;
 t['copyrightsans'] = 0xF8E9;
 t['copyrightserif'] = 0xF6D9;
 t['cornerbracketleft'] = 0x300C;
 t['cornerbracketlefthalfwidth'] = 0xFF62;
 t['cornerbracketleftvertical'] = 0xFE41;
 t['cornerbracketright'] = 0x300D;
 t['cornerbracketrighthalfwidth'] = 0xFF63;
 t['cornerbracketrightvertical'] = 0xFE42;
 t['corporationsquare'] = 0x337F;
 t['cosquare'] = 0x33C7;
 t['coverkgsquare'] = 0x33C6;
 t['cparen'] = 0x249E;
 t['cruzeiro'] = 0x20A2;
 t['cstretched'] = 0x0297;
 t['curlyand'] = 0x22CF;
 t['curlyor'] = 0x22CE;
 t['currency'] = 0x00A4;
 t['cyrBreve'] = 0xF6D1;
 t['cyrFlex'] = 0xF6D2;
 t['cyrbreve'] = 0xF6D4;
 t['cyrflex'] = 0xF6D5;
 t['d'] = 0x0064;
 t['daarmenian'] = 0x0564;
 t['dabengali'] = 0x09A6;
 t['dadarabic'] = 0x0636;
 t['dadeva'] = 0x0926;
 t['dadfinalarabic'] = 0xFEBE;
 t['dadinitialarabic'] = 0xFEBF;
 t['dadmedialarabic'] = 0xFEC0;
 t['dagesh'] = 0x05BC;
 t['dageshhebrew'] = 0x05BC;
 t['dagger'] = 0x2020;
 t['daggerdbl'] = 0x2021;
 t['dagujarati'] = 0x0AA6;
 t['dagurmukhi'] = 0x0A26;
 t['dahiragana'] = 0x3060;
 t['dakatakana'] = 0x30C0;
 t['dalarabic'] = 0x062F;
 t['dalet'] = 0x05D3;
 t['daletdagesh'] = 0xFB33;
 t['daletdageshhebrew'] = 0xFB33;
 t['dalethebrew'] = 0x05D3;
 t['dalfinalarabic'] = 0xFEAA;
 t['dammaarabic'] = 0x064F;
 t['dammalowarabic'] = 0x064F;
 t['dammatanaltonearabic'] = 0x064C;
 t['dammatanarabic'] = 0x064C;
 t['danda'] = 0x0964;
 t['dargahebrew'] = 0x05A7;
 t['dargalefthebrew'] = 0x05A7;
 t['dasiapneumatacyrilliccmb'] = 0x0485;
 t['dblGrave'] = 0xF6D3;
 t['dblanglebracketleft'] = 0x300A;
 t['dblanglebracketleftvertical'] = 0xFE3D;
 t['dblanglebracketright'] = 0x300B;
 t['dblanglebracketrightvertical'] = 0xFE3E;
 t['dblarchinvertedbelowcmb'] = 0x032B;
 t['dblarrowleft'] = 0x21D4;
 t['dblarrowright'] = 0x21D2;
 t['dbldanda'] = 0x0965;
 t['dblgrave'] = 0xF6D6;
 t['dblgravecmb'] = 0x030F;
 t['dblintegral'] = 0x222C;
 t['dbllowline'] = 0x2017;
 t['dbllowlinecmb'] = 0x0333;
 t['dbloverlinecmb'] = 0x033F;
 t['dblprimemod'] = 0x02BA;
 t['dblverticalbar'] = 0x2016;
 t['dblverticallineabovecmb'] = 0x030E;
 t['dbopomofo'] = 0x3109;
 t['dbsquare'] = 0x33C8;
 t['dcaron'] = 0x010F;
 t['dcedilla'] = 0x1E11;
 t['dcircle'] = 0x24D3;
 t['dcircumflexbelow'] = 0x1E13;
 t['dcroat'] = 0x0111;
 t['ddabengali'] = 0x09A1;
 t['ddadeva'] = 0x0921;
 t['ddagujarati'] = 0x0AA1;
 t['ddagurmukhi'] = 0x0A21;
 t['ddalarabic'] = 0x0688;
 t['ddalfinalarabic'] = 0xFB89;
 t['dddhadeva'] = 0x095C;
 t['ddhabengali'] = 0x09A2;
 t['ddhadeva'] = 0x0922;
 t['ddhagujarati'] = 0x0AA2;
 t['ddhagurmukhi'] = 0x0A22;
 t['ddotaccent'] = 0x1E0B;
 t['ddotbelow'] = 0x1E0D;
 t['decimalseparatorarabic'] = 0x066B;
 t['decimalseparatorpersian'] = 0x066B;
 t['decyrillic'] = 0x0434;
 t['degree'] = 0x00B0;
 t['dehihebrew'] = 0x05AD;
 t['dehiragana'] = 0x3067;
 t['deicoptic'] = 0x03EF;
 t['dekatakana'] = 0x30C7;
 t['deleteleft'] = 0x232B;
 t['deleteright'] = 0x2326;
 t['delta'] = 0x03B4;
 t['deltaturned'] = 0x018D;
 t['denominatorminusonenumeratorbengali'] = 0x09F8;
 t['dezh'] = 0x02A4;
 t['dhabengali'] = 0x09A7;
 t['dhadeva'] = 0x0927;
 t['dhagujarati'] = 0x0AA7;
 t['dhagurmukhi'] = 0x0A27;
 t['dhook'] = 0x0257;
 t['dialytikatonos'] = 0x0385;
 t['dialytikatonoscmb'] = 0x0344;
 t['diamond'] = 0x2666;
 t['diamondsuitwhite'] = 0x2662;
 t['dieresis'] = 0x00A8;
 t['dieresisacute'] = 0xF6D7;
 t['dieresisbelowcmb'] = 0x0324;
 t['dieresiscmb'] = 0x0308;
 t['dieresisgrave'] = 0xF6D8;
 t['dieresistonos'] = 0x0385;
 t['dihiragana'] = 0x3062;
 t['dikatakana'] = 0x30C2;
 t['dittomark'] = 0x3003;
 t['divide'] = 0x00F7;
 t['divides'] = 0x2223;
 t['divisionslash'] = 0x2215;
 t['djecyrillic'] = 0x0452;
 t['dkshade'] = 0x2593;
 t['dlinebelow'] = 0x1E0F;
 t['dlsquare'] = 0x3397;
 t['dmacron'] = 0x0111;
 t['dmonospace'] = 0xFF44;
 t['dnblock'] = 0x2584;
 t['dochadathai'] = 0x0E0E;
 t['dodekthai'] = 0x0E14;
 t['dohiragana'] = 0x3069;
 t['dokatakana'] = 0x30C9;
 t['dollar'] = 0x0024;
 t['dollarinferior'] = 0xF6E3;
 t['dollarmonospace'] = 0xFF04;
 t['dollaroldstyle'] = 0xF724;
 t['dollarsmall'] = 0xFE69;
 t['dollarsuperior'] = 0xF6E4;
 t['dong'] = 0x20AB;
 t['dorusquare'] = 0x3326;
 t['dotaccent'] = 0x02D9;
 t['dotaccentcmb'] = 0x0307;
 t['dotbelowcmb'] = 0x0323;
 t['dotbelowcomb'] = 0x0323;
 t['dotkatakana'] = 0x30FB;
 t['dotlessi'] = 0x0131;
 t['dotlessj'] = 0xF6BE;
 t['dotlessjstrokehook'] = 0x0284;
 t['dotmath'] = 0x22C5;
 t['dottedcircle'] = 0x25CC;
 t['doubleyodpatah'] = 0xFB1F;
 t['doubleyodpatahhebrew'] = 0xFB1F;
 t['downtackbelowcmb'] = 0x031E;
 t['downtackmod'] = 0x02D5;
 t['dparen'] = 0x249F;
 t['dsuperior'] = 0xF6EB;
 t['dtail'] = 0x0256;
 t['dtopbar'] = 0x018C;
 t['duhiragana'] = 0x3065;
 t['dukatakana'] = 0x30C5;
 t['dz'] = 0x01F3;
 t['dzaltone'] = 0x02A3;
 t['dzcaron'] = 0x01C6;
 t['dzcurl'] = 0x02A5;
 t['dzeabkhasiancyrillic'] = 0x04E1;
 t['dzecyrillic'] = 0x0455;
 t['dzhecyrillic'] = 0x045F;
 t['e'] = 0x0065;
 t['eacute'] = 0x00E9;
 t['earth'] = 0x2641;
 t['ebengali'] = 0x098F;
 t['ebopomofo'] = 0x311C;
 t['ebreve'] = 0x0115;
 t['ecandradeva'] = 0x090D;
 t['ecandragujarati'] = 0x0A8D;
 t['ecandravowelsigndeva'] = 0x0945;
 t['ecandravowelsigngujarati'] = 0x0AC5;
 t['ecaron'] = 0x011B;
 t['ecedillabreve'] = 0x1E1D;
 t['echarmenian'] = 0x0565;
 t['echyiwnarmenian'] = 0x0587;
 t['ecircle'] = 0x24D4;
 t['ecircumflex'] = 0x00EA;
 t['ecircumflexacute'] = 0x1EBF;
 t['ecircumflexbelow'] = 0x1E19;
 t['ecircumflexdotbelow'] = 0x1EC7;
 t['ecircumflexgrave'] = 0x1EC1;
 t['ecircumflexhookabove'] = 0x1EC3;
 t['ecircumflextilde'] = 0x1EC5;
 t['ecyrillic'] = 0x0454;
 t['edblgrave'] = 0x0205;
 t['edeva'] = 0x090F;
 t['edieresis'] = 0x00EB;
 t['edot'] = 0x0117;
 t['edotaccent'] = 0x0117;
 t['edotbelow'] = 0x1EB9;
 t['eegurmukhi'] = 0x0A0F;
 t['eematragurmukhi'] = 0x0A47;
 t['efcyrillic'] = 0x0444;
 t['egrave'] = 0x00E8;
 t['egujarati'] = 0x0A8F;
 t['eharmenian'] = 0x0567;
 t['ehbopomofo'] = 0x311D;
 t['ehiragana'] = 0x3048;
 t['ehookabove'] = 0x1EBB;
 t['eibopomofo'] = 0x311F;
 t['eight'] = 0x0038;
 t['eightarabic'] = 0x0668;
 t['eightbengali'] = 0x09EE;
 t['eightcircle'] = 0x2467;
 t['eightcircleinversesansserif'] = 0x2791;
 t['eightdeva'] = 0x096E;
 t['eighteencircle'] = 0x2471;
 t['eighteenparen'] = 0x2485;
 t['eighteenperiod'] = 0x2499;
 t['eightgujarati'] = 0x0AEE;
 t['eightgurmukhi'] = 0x0A6E;
 t['eighthackarabic'] = 0x0668;
 t['eighthangzhou'] = 0x3028;
 t['eighthnotebeamed'] = 0x266B;
 t['eightideographicparen'] = 0x3227;
 t['eightinferior'] = 0x2088;
 t['eightmonospace'] = 0xFF18;
 t['eightoldstyle'] = 0xF738;
 t['eightparen'] = 0x247B;
 t['eightperiod'] = 0x248F;
 t['eightpersian'] = 0x06F8;
 t['eightroman'] = 0x2177;
 t['eightsuperior'] = 0x2078;
 t['eightthai'] = 0x0E58;
 t['einvertedbreve'] = 0x0207;
 t['eiotifiedcyrillic'] = 0x0465;
 t['ekatakana'] = 0x30A8;
 t['ekatakanahalfwidth'] = 0xFF74;
 t['ekonkargurmukhi'] = 0x0A74;
 t['ekorean'] = 0x3154;
 t['elcyrillic'] = 0x043B;
 t['element'] = 0x2208;
 t['elevencircle'] = 0x246A;
 t['elevenparen'] = 0x247E;
 t['elevenperiod'] = 0x2492;
 t['elevenroman'] = 0x217A;
 t['ellipsis'] = 0x2026;
 t['ellipsisvertical'] = 0x22EE;
 t['emacron'] = 0x0113;
 t['emacronacute'] = 0x1E17;
 t['emacrongrave'] = 0x1E15;
 t['emcyrillic'] = 0x043C;
 t['emdash'] = 0x2014;
 t['emdashvertical'] = 0xFE31;
 t['emonospace'] = 0xFF45;
 t['emphasismarkarmenian'] = 0x055B;
 t['emptyset'] = 0x2205;
 t['enbopomofo'] = 0x3123;
 t['encyrillic'] = 0x043D;
 t['endash'] = 0x2013;
 t['endashvertical'] = 0xFE32;
 t['endescendercyrillic'] = 0x04A3;
 t['eng'] = 0x014B;
 t['engbopomofo'] = 0x3125;
 t['enghecyrillic'] = 0x04A5;
 t['enhookcyrillic'] = 0x04C8;
 t['enspace'] = 0x2002;
 t['eogonek'] = 0x0119;
 t['eokorean'] = 0x3153;
 t['eopen'] = 0x025B;
 t['eopenclosed'] = 0x029A;
 t['eopenreversed'] = 0x025C;
 t['eopenreversedclosed'] = 0x025E;
 t['eopenreversedhook'] = 0x025D;
 t['eparen'] = 0x24A0;
 t['epsilon'] = 0x03B5;
 t['epsilontonos'] = 0x03AD;
 t['equal'] = 0x003D;
 t['equalmonospace'] = 0xFF1D;
 t['equalsmall'] = 0xFE66;
 t['equalsuperior'] = 0x207C;
 t['equivalence'] = 0x2261;
 t['erbopomofo'] = 0x3126;
 t['ercyrillic'] = 0x0440;
 t['ereversed'] = 0x0258;
 t['ereversedcyrillic'] = 0x044D;
 t['escyrillic'] = 0x0441;
 t['esdescendercyrillic'] = 0x04AB;
 t['esh'] = 0x0283;
 t['eshcurl'] = 0x0286;
 t['eshortdeva'] = 0x090E;
 t['eshortvowelsigndeva'] = 0x0946;
 t['eshreversedloop'] = 0x01AA;
 t['eshsquatreversed'] = 0x0285;
 t['esmallhiragana'] = 0x3047;
 t['esmallkatakana'] = 0x30A7;
 t['esmallkatakanahalfwidth'] = 0xFF6A;
 t['estimated'] = 0x212E;
 t['esuperior'] = 0xF6EC;
 t['eta'] = 0x03B7;
 t['etarmenian'] = 0x0568;
 t['etatonos'] = 0x03AE;
 t['eth'] = 0x00F0;
 t['etilde'] = 0x1EBD;
 t['etildebelow'] = 0x1E1B;
 t['etnahtafoukhhebrew'] = 0x0591;
 t['etnahtafoukhlefthebrew'] = 0x0591;
 t['etnahtahebrew'] = 0x0591;
 t['etnahtalefthebrew'] = 0x0591;
 t['eturned'] = 0x01DD;
 t['eukorean'] = 0x3161;
 t['euro'] = 0x20AC;
 t['evowelsignbengali'] = 0x09C7;
 t['evowelsigndeva'] = 0x0947;
 t['evowelsigngujarati'] = 0x0AC7;
 t['exclam'] = 0x0021;
 t['exclamarmenian'] = 0x055C;
 t['exclamdbl'] = 0x203C;
 t['exclamdown'] = 0x00A1;
 t['exclamdownsmall'] = 0xF7A1;
 t['exclammonospace'] = 0xFF01;
 t['exclamsmall'] = 0xF721;
 t['existential'] = 0x2203;
 t['ezh'] = 0x0292;
 t['ezhcaron'] = 0x01EF;
 t['ezhcurl'] = 0x0293;
 t['ezhreversed'] = 0x01B9;
 t['ezhtail'] = 0x01BA;
 t['f'] = 0x0066;
 t['fadeva'] = 0x095E;
 t['fagurmukhi'] = 0x0A5E;
 t['fahrenheit'] = 0x2109;
 t['fathaarabic'] = 0x064E;
 t['fathalowarabic'] = 0x064E;
 t['fathatanarabic'] = 0x064B;
 t['fbopomofo'] = 0x3108;
 t['fcircle'] = 0x24D5;
 t['fdotaccent'] = 0x1E1F;
 t['feharabic'] = 0x0641;
 t['feharmenian'] = 0x0586;
 t['fehfinalarabic'] = 0xFED2;
 t['fehinitialarabic'] = 0xFED3;
 t['fehmedialarabic'] = 0xFED4;
 t['feicoptic'] = 0x03E5;
 t['female'] = 0x2640;
 t['ff'] = 0xFB00;
 t['ffi'] = 0xFB03;
 t['ffl'] = 0xFB04;
 t['fi'] = 0xFB01;
 t['fifteencircle'] = 0x246E;
 t['fifteenparen'] = 0x2482;
 t['fifteenperiod'] = 0x2496;
 t['figuredash'] = 0x2012;
 t['filledbox'] = 0x25A0;
 t['filledrect'] = 0x25AC;
 t['finalkaf'] = 0x05DA;
 t['finalkafdagesh'] = 0xFB3A;
 t['finalkafdageshhebrew'] = 0xFB3A;
 t['finalkafhebrew'] = 0x05DA;
 t['finalmem'] = 0x05DD;
 t['finalmemhebrew'] = 0x05DD;
 t['finalnun'] = 0x05DF;
 t['finalnunhebrew'] = 0x05DF;
 t['finalpe'] = 0x05E3;
 t['finalpehebrew'] = 0x05E3;
 t['finaltsadi'] = 0x05E5;
 t['finaltsadihebrew'] = 0x05E5;
 t['firsttonechinese'] = 0x02C9;
 t['fisheye'] = 0x25C9;
 t['fitacyrillic'] = 0x0473;
 t['five'] = 0x0035;
 t['fivearabic'] = 0x0665;
 t['fivebengali'] = 0x09EB;
 t['fivecircle'] = 0x2464;
 t['fivecircleinversesansserif'] = 0x278E;
 t['fivedeva'] = 0x096B;
 t['fiveeighths'] = 0x215D;
 t['fivegujarati'] = 0x0AEB;
 t['fivegurmukhi'] = 0x0A6B;
 t['fivehackarabic'] = 0x0665;
 t['fivehangzhou'] = 0x3025;
 t['fiveideographicparen'] = 0x3224;
 t['fiveinferior'] = 0x2085;
 t['fivemonospace'] = 0xFF15;
 t['fiveoldstyle'] = 0xF735;
 t['fiveparen'] = 0x2478;
 t['fiveperiod'] = 0x248C;
 t['fivepersian'] = 0x06F5;
 t['fiveroman'] = 0x2174;
 t['fivesuperior'] = 0x2075;
 t['fivethai'] = 0x0E55;
 t['fl'] = 0xFB02;
 t['florin'] = 0x0192;
 t['fmonospace'] = 0xFF46;
 t['fmsquare'] = 0x3399;
 t['fofanthai'] = 0x0E1F;
 t['fofathai'] = 0x0E1D;
 t['fongmanthai'] = 0x0E4F;
 t['forall'] = 0x2200;
 t['four'] = 0x0034;
 t['fourarabic'] = 0x0664;
 t['fourbengali'] = 0x09EA;
 t['fourcircle'] = 0x2463;
 t['fourcircleinversesansserif'] = 0x278D;
 t['fourdeva'] = 0x096A;
 t['fourgujarati'] = 0x0AEA;
 t['fourgurmukhi'] = 0x0A6A;
 t['fourhackarabic'] = 0x0664;
 t['fourhangzhou'] = 0x3024;
 t['fourideographicparen'] = 0x3223;
 t['fourinferior'] = 0x2084;
 t['fourmonospace'] = 0xFF14;
 t['fournumeratorbengali'] = 0x09F7;
 t['fouroldstyle'] = 0xF734;
 t['fourparen'] = 0x2477;
 t['fourperiod'] = 0x248B;
 t['fourpersian'] = 0x06F4;
 t['fourroman'] = 0x2173;
 t['foursuperior'] = 0x2074;
 t['fourteencircle'] = 0x246D;
 t['fourteenparen'] = 0x2481;
 t['fourteenperiod'] = 0x2495;
 t['fourthai'] = 0x0E54;
 t['fourthtonechinese'] = 0x02CB;
 t['fparen'] = 0x24A1;
 t['fraction'] = 0x2044;
 t['franc'] = 0x20A3;
 t['g'] = 0x0067;
 t['gabengali'] = 0x0997;
 t['gacute'] = 0x01F5;
 t['gadeva'] = 0x0917;
 t['gafarabic'] = 0x06AF;
 t['gaffinalarabic'] = 0xFB93;
 t['gafinitialarabic'] = 0xFB94;
 t['gafmedialarabic'] = 0xFB95;
 t['gagujarati'] = 0x0A97;
 t['gagurmukhi'] = 0x0A17;
 t['gahiragana'] = 0x304C;
 t['gakatakana'] = 0x30AC;
 t['gamma'] = 0x03B3;
 t['gammalatinsmall'] = 0x0263;
 t['gammasuperior'] = 0x02E0;
 t['gangiacoptic'] = 0x03EB;
 t['gbopomofo'] = 0x310D;
 t['gbreve'] = 0x011F;
 t['gcaron'] = 0x01E7;
 t['gcedilla'] = 0x0123;
 t['gcircle'] = 0x24D6;
 t['gcircumflex'] = 0x011D;
 t['gcommaaccent'] = 0x0123;
 t['gdot'] = 0x0121;
 t['gdotaccent'] = 0x0121;
 t['gecyrillic'] = 0x0433;
 t['gehiragana'] = 0x3052;
 t['gekatakana'] = 0x30B2;
 t['geometricallyequal'] = 0x2251;
 t['gereshaccenthebrew'] = 0x059C;
 t['gereshhebrew'] = 0x05F3;
 t['gereshmuqdamhebrew'] = 0x059D;
 t['germandbls'] = 0x00DF;
 t['gershayimaccenthebrew'] = 0x059E;
 t['gershayimhebrew'] = 0x05F4;
 t['getamark'] = 0x3013;
 t['ghabengali'] = 0x0998;
 t['ghadarmenian'] = 0x0572;
 t['ghadeva'] = 0x0918;
 t['ghagujarati'] = 0x0A98;
 t['ghagurmukhi'] = 0x0A18;
 t['ghainarabic'] = 0x063A;
 t['ghainfinalarabic'] = 0xFECE;
 t['ghaininitialarabic'] = 0xFECF;
 t['ghainmedialarabic'] = 0xFED0;
 t['ghemiddlehookcyrillic'] = 0x0495;
 t['ghestrokecyrillic'] = 0x0493;
 t['gheupturncyrillic'] = 0x0491;
 t['ghhadeva'] = 0x095A;
 t['ghhagurmukhi'] = 0x0A5A;
 t['ghook'] = 0x0260;
 t['ghzsquare'] = 0x3393;
 t['gihiragana'] = 0x304E;
 t['gikatakana'] = 0x30AE;
 t['gimarmenian'] = 0x0563;
 t['gimel'] = 0x05D2;
 t['gimeldagesh'] = 0xFB32;
 t['gimeldageshhebrew'] = 0xFB32;
 t['gimelhebrew'] = 0x05D2;
 t['gjecyrillic'] = 0x0453;
 t['glottalinvertedstroke'] = 0x01BE;
 t['glottalstop'] = 0x0294;
 t['glottalstopinverted'] = 0x0296;
 t['glottalstopmod'] = 0x02C0;
 t['glottalstopreversed'] = 0x0295;
 t['glottalstopreversedmod'] = 0x02C1;
 t['glottalstopreversedsuperior'] = 0x02E4;
 t['glottalstopstroke'] = 0x02A1;
 t['glottalstopstrokereversed'] = 0x02A2;
 t['gmacron'] = 0x1E21;
 t['gmonospace'] = 0xFF47;
 t['gohiragana'] = 0x3054;
 t['gokatakana'] = 0x30B4;
 t['gparen'] = 0x24A2;
 t['gpasquare'] = 0x33AC;
 t['gradient'] = 0x2207;
 t['grave'] = 0x0060;
 t['gravebelowcmb'] = 0x0316;
 t['gravecmb'] = 0x0300;
 t['gravecomb'] = 0x0300;
 t['gravedeva'] = 0x0953;
 t['gravelowmod'] = 0x02CE;
 t['gravemonospace'] = 0xFF40;
 t['gravetonecmb'] = 0x0340;
 t['greater'] = 0x003E;
 t['greaterequal'] = 0x2265;
 t['greaterequalorless'] = 0x22DB;
 t['greatermonospace'] = 0xFF1E;
 t['greaterorequivalent'] = 0x2273;
 t['greaterorless'] = 0x2277;
 t['greateroverequal'] = 0x2267;
 t['greatersmall'] = 0xFE65;
 t['gscript'] = 0x0261;
 t['gstroke'] = 0x01E5;
 t['guhiragana'] = 0x3050;
 t['guillemotleft'] = 0x00AB;
 t['guillemotright'] = 0x00BB;
 t['guilsinglleft'] = 0x2039;
 t['guilsinglright'] = 0x203A;
 t['gukatakana'] = 0x30B0;
 t['guramusquare'] = 0x3318;
 t['gysquare'] = 0x33C9;
 t['h'] = 0x0068;
 t['haabkhasiancyrillic'] = 0x04A9;
 t['haaltonearabic'] = 0x06C1;
 t['habengali'] = 0x09B9;
 t['hadescendercyrillic'] = 0x04B3;
 t['hadeva'] = 0x0939;
 t['hagujarati'] = 0x0AB9;
 t['hagurmukhi'] = 0x0A39;
 t['haharabic'] = 0x062D;
 t['hahfinalarabic'] = 0xFEA2;
 t['hahinitialarabic'] = 0xFEA3;
 t['hahiragana'] = 0x306F;
 t['hahmedialarabic'] = 0xFEA4;
 t['haitusquare'] = 0x332A;
 t['hakatakana'] = 0x30CF;
 t['hakatakanahalfwidth'] = 0xFF8A;
 t['halantgurmukhi'] = 0x0A4D;
 t['hamzaarabic'] = 0x0621;
 t['hamzalowarabic'] = 0x0621;
 t['hangulfiller'] = 0x3164;
 t['hardsigncyrillic'] = 0x044A;
 t['harpoonleftbarbup'] = 0x21BC;
 t['harpoonrightbarbup'] = 0x21C0;
 t['hasquare'] = 0x33CA;
 t['hatafpatah'] = 0x05B2;
 t['hatafpatah16'] = 0x05B2;
 t['hatafpatah23'] = 0x05B2;
 t['hatafpatah2f'] = 0x05B2;
 t['hatafpatahhebrew'] = 0x05B2;
 t['hatafpatahnarrowhebrew'] = 0x05B2;
 t['hatafpatahquarterhebrew'] = 0x05B2;
 t['hatafpatahwidehebrew'] = 0x05B2;
 t['hatafqamats'] = 0x05B3;
 t['hatafqamats1b'] = 0x05B3;
 t['hatafqamats28'] = 0x05B3;
 t['hatafqamats34'] = 0x05B3;
 t['hatafqamatshebrew'] = 0x05B3;
 t['hatafqamatsnarrowhebrew'] = 0x05B3;
 t['hatafqamatsquarterhebrew'] = 0x05B3;
 t['hatafqamatswidehebrew'] = 0x05B3;
 t['hatafsegol'] = 0x05B1;
 t['hatafsegol17'] = 0x05B1;
 t['hatafsegol24'] = 0x05B1;
 t['hatafsegol30'] = 0x05B1;
 t['hatafsegolhebrew'] = 0x05B1;
 t['hatafsegolnarrowhebrew'] = 0x05B1;
 t['hatafsegolquarterhebrew'] = 0x05B1;
 t['hatafsegolwidehebrew'] = 0x05B1;
 t['hbar'] = 0x0127;
 t['hbopomofo'] = 0x310F;
 t['hbrevebelow'] = 0x1E2B;
 t['hcedilla'] = 0x1E29;
 t['hcircle'] = 0x24D7;
 t['hcircumflex'] = 0x0125;
 t['hdieresis'] = 0x1E27;
 t['hdotaccent'] = 0x1E23;
 t['hdotbelow'] = 0x1E25;
 t['he'] = 0x05D4;
 t['heart'] = 0x2665;
 t['heartsuitblack'] = 0x2665;
 t['heartsuitwhite'] = 0x2661;
 t['hedagesh'] = 0xFB34;
 t['hedageshhebrew'] = 0xFB34;
 t['hehaltonearabic'] = 0x06C1;
 t['heharabic'] = 0x0647;
 t['hehebrew'] = 0x05D4;
 t['hehfinalaltonearabic'] = 0xFBA7;
 t['hehfinalalttwoarabic'] = 0xFEEA;
 t['hehfinalarabic'] = 0xFEEA;
 t['hehhamzaabovefinalarabic'] = 0xFBA5;
 t['hehhamzaaboveisolatedarabic'] = 0xFBA4;
 t['hehinitialaltonearabic'] = 0xFBA8;
 t['hehinitialarabic'] = 0xFEEB;
 t['hehiragana'] = 0x3078;
 t['hehmedialaltonearabic'] = 0xFBA9;
 t['hehmedialarabic'] = 0xFEEC;
 t['heiseierasquare'] = 0x337B;
 t['hekatakana'] = 0x30D8;
 t['hekatakanahalfwidth'] = 0xFF8D;
 t['hekutaarusquare'] = 0x3336;
 t['henghook'] = 0x0267;
 t['herutusquare'] = 0x3339;
 t['het'] = 0x05D7;
 t['hethebrew'] = 0x05D7;
 t['hhook'] = 0x0266;
 t['hhooksuperior'] = 0x02B1;
 t['hieuhacirclekorean'] = 0x327B;
 t['hieuhaparenkorean'] = 0x321B;
 t['hieuhcirclekorean'] = 0x326D;
 t['hieuhkorean'] = 0x314E;
 t['hieuhparenkorean'] = 0x320D;
 t['hihiragana'] = 0x3072;
 t['hikatakana'] = 0x30D2;
 t['hikatakanahalfwidth'] = 0xFF8B;
 t['hiriq'] = 0x05B4;
 t['hiriq14'] = 0x05B4;
 t['hiriq21'] = 0x05B4;
 t['hiriq2d'] = 0x05B4;
 t['hiriqhebrew'] = 0x05B4;
 t['hiriqnarrowhebrew'] = 0x05B4;
 t['hiriqquarterhebrew'] = 0x05B4;
 t['hiriqwidehebrew'] = 0x05B4;
 t['hlinebelow'] = 0x1E96;
 t['hmonospace'] = 0xFF48;
 t['hoarmenian'] = 0x0570;
 t['hohipthai'] = 0x0E2B;
 t['hohiragana'] = 0x307B;
 t['hokatakana'] = 0x30DB;
 t['hokatakanahalfwidth'] = 0xFF8E;
 t['holam'] = 0x05B9;
 t['holam19'] = 0x05B9;
 t['holam26'] = 0x05B9;
 t['holam32'] = 0x05B9;
 t['holamhebrew'] = 0x05B9;
 t['holamnarrowhebrew'] = 0x05B9;
 t['holamquarterhebrew'] = 0x05B9;
 t['holamwidehebrew'] = 0x05B9;
 t['honokhukthai'] = 0x0E2E;
 t['hookabovecomb'] = 0x0309;
 t['hookcmb'] = 0x0309;
 t['hookpalatalizedbelowcmb'] = 0x0321;
 t['hookretroflexbelowcmb'] = 0x0322;
 t['hoonsquare'] = 0x3342;
 t['horicoptic'] = 0x03E9;
 t['horizontalbar'] = 0x2015;
 t['horncmb'] = 0x031B;
 t['hotsprings'] = 0x2668;
 t['house'] = 0x2302;
 t['hparen'] = 0x24A3;
 t['hsuperior'] = 0x02B0;
 t['hturned'] = 0x0265;
 t['huhiragana'] = 0x3075;
 t['huiitosquare'] = 0x3333;
 t['hukatakana'] = 0x30D5;
 t['hukatakanahalfwidth'] = 0xFF8C;
 t['hungarumlaut'] = 0x02DD;
 t['hungarumlautcmb'] = 0x030B;
 t['hv'] = 0x0195;
 t['hyphen'] = 0x002D;
 t['hypheninferior'] = 0xF6E5;
 t['hyphenmonospace'] = 0xFF0D;
 t['hyphensmall'] = 0xFE63;
 t['hyphensuperior'] = 0xF6E6;
 t['hyphentwo'] = 0x2010;
 t['i'] = 0x0069;
 t['iacute'] = 0x00ED;
 t['iacyrillic'] = 0x044F;
 t['ibengali'] = 0x0987;
 t['ibopomofo'] = 0x3127;
 t['ibreve'] = 0x012D;
 t['icaron'] = 0x01D0;
 t['icircle'] = 0x24D8;
 t['icircumflex'] = 0x00EE;
 t['icyrillic'] = 0x0456;
 t['idblgrave'] = 0x0209;
 t['ideographearthcircle'] = 0x328F;
 t['ideographfirecircle'] = 0x328B;
 t['ideographicallianceparen'] = 0x323F;
 t['ideographiccallparen'] = 0x323A;
 t['ideographiccentrecircle'] = 0x32A5;
 t['ideographicclose'] = 0x3006;
 t['ideographiccomma'] = 0x3001;
 t['ideographiccommaleft'] = 0xFF64;
 t['ideographiccongratulationparen'] = 0x3237;
 t['ideographiccorrectcircle'] = 0x32A3;
 t['ideographicearthparen'] = 0x322F;
 t['ideographicenterpriseparen'] = 0x323D;
 t['ideographicexcellentcircle'] = 0x329D;
 t['ideographicfestivalparen'] = 0x3240;
 t['ideographicfinancialcircle'] = 0x3296;
 t['ideographicfinancialparen'] = 0x3236;
 t['ideographicfireparen'] = 0x322B;
 t['ideographichaveparen'] = 0x3232;
 t['ideographichighcircle'] = 0x32A4;
 t['ideographiciterationmark'] = 0x3005;
 t['ideographiclaborcircle'] = 0x3298;
 t['ideographiclaborparen'] = 0x3238;
 t['ideographicleftcircle'] = 0x32A7;
 t['ideographiclowcircle'] = 0x32A6;
 t['ideographicmedicinecircle'] = 0x32A9;
 t['ideographicmetalparen'] = 0x322E;
 t['ideographicmoonparen'] = 0x322A;
 t['ideographicnameparen'] = 0x3234;
 t['ideographicperiod'] = 0x3002;
 t['ideographicprintcircle'] = 0x329E;
 t['ideographicreachparen'] = 0x3243;
 t['ideographicrepresentparen'] = 0x3239;
 t['ideographicresourceparen'] = 0x323E;
 t['ideographicrightcircle'] = 0x32A8;
 t['ideographicsecretcircle'] = 0x3299;
 t['ideographicselfparen'] = 0x3242;
 t['ideographicsocietyparen'] = 0x3233;
 t['ideographicspace'] = 0x3000;
 t['ideographicspecialparen'] = 0x3235;
 t['ideographicstockparen'] = 0x3231;
 t['ideographicstudyparen'] = 0x323B;
 t['ideographicsunparen'] = 0x3230;
 t['ideographicsuperviseparen'] = 0x323C;
 t['ideographicwaterparen'] = 0x322C;
 t['ideographicwoodparen'] = 0x322D;
 t['ideographiczero'] = 0x3007;
 t['ideographmetalcircle'] = 0x328E;
 t['ideographmooncircle'] = 0x328A;
 t['ideographnamecircle'] = 0x3294;
 t['ideographsuncircle'] = 0x3290;
 t['ideographwatercircle'] = 0x328C;
 t['ideographwoodcircle'] = 0x328D;
 t['ideva'] = 0x0907;
 t['idieresis'] = 0x00EF;
 t['idieresisacute'] = 0x1E2F;
 t['idieresiscyrillic'] = 0x04E5;
 t['idotbelow'] = 0x1ECB;
 t['iebrevecyrillic'] = 0x04D7;
 t['iecyrillic'] = 0x0435;
 t['ieungacirclekorean'] = 0x3275;
 t['ieungaparenkorean'] = 0x3215;
 t['ieungcirclekorean'] = 0x3267;
 t['ieungkorean'] = 0x3147;
 t['ieungparenkorean'] = 0x3207;
 t['igrave'] = 0x00EC;
 t['igujarati'] = 0x0A87;
 t['igurmukhi'] = 0x0A07;
 t['ihiragana'] = 0x3044;
 t['ihookabove'] = 0x1EC9;
 t['iibengali'] = 0x0988;
 t['iicyrillic'] = 0x0438;
 t['iideva'] = 0x0908;
 t['iigujarati'] = 0x0A88;
 t['iigurmukhi'] = 0x0A08;
 t['iimatragurmukhi'] = 0x0A40;
 t['iinvertedbreve'] = 0x020B;
 t['iishortcyrillic'] = 0x0439;
 t['iivowelsignbengali'] = 0x09C0;
 t['iivowelsigndeva'] = 0x0940;
 t['iivowelsigngujarati'] = 0x0AC0;
 t['ij'] = 0x0133;
 t['ikatakana'] = 0x30A4;
 t['ikatakanahalfwidth'] = 0xFF72;
 t['ikorean'] = 0x3163;
 t['ilde'] = 0x02DC;
 t['iluyhebrew'] = 0x05AC;
 t['imacron'] = 0x012B;
 t['imacroncyrillic'] = 0x04E3;
 t['imageorapproximatelyequal'] = 0x2253;
 t['imatragurmukhi'] = 0x0A3F;
 t['imonospace'] = 0xFF49;
 t['increment'] = 0x2206;
 t['infinity'] = 0x221E;
 t['iniarmenian'] = 0x056B;
 t['integral'] = 0x222B;
 t['integralbottom'] = 0x2321;
 t['integralbt'] = 0x2321;
 t['integralex'] = 0xF8F5;
 t['integraltop'] = 0x2320;
 t['integraltp'] = 0x2320;
 t['intersection'] = 0x2229;
 t['intisquare'] = 0x3305;
 t['invbullet'] = 0x25D8;
 t['invcircle'] = 0x25D9;
 t['invsmileface'] = 0x263B;
 t['iocyrillic'] = 0x0451;
 t['iogonek'] = 0x012F;
 t['iota'] = 0x03B9;
 t['iotadieresis'] = 0x03CA;
 t['iotadieresistonos'] = 0x0390;
 t['iotalatin'] = 0x0269;
 t['iotatonos'] = 0x03AF;
 t['iparen'] = 0x24A4;
 t['irigurmukhi'] = 0x0A72;
 t['ismallhiragana'] = 0x3043;
 t['ismallkatakana'] = 0x30A3;
 t['ismallkatakanahalfwidth'] = 0xFF68;
 t['issharbengali'] = 0x09FA;
 t['istroke'] = 0x0268;
 t['isuperior'] = 0xF6ED;
 t['iterationhiragana'] = 0x309D;
 t['iterationkatakana'] = 0x30FD;
 t['itilde'] = 0x0129;
 t['itildebelow'] = 0x1E2D;
 t['iubopomofo'] = 0x3129;
 t['iucyrillic'] = 0x044E;
 t['ivowelsignbengali'] = 0x09BF;
 t['ivowelsigndeva'] = 0x093F;
 t['ivowelsigngujarati'] = 0x0ABF;
 t['izhitsacyrillic'] = 0x0475;
 t['izhitsadblgravecyrillic'] = 0x0477;
 t['j'] = 0x006A;
 t['jaarmenian'] = 0x0571;
 t['jabengali'] = 0x099C;
 t['jadeva'] = 0x091C;
 t['jagujarati'] = 0x0A9C;
 t['jagurmukhi'] = 0x0A1C;
 t['jbopomofo'] = 0x3110;
 t['jcaron'] = 0x01F0;
 t['jcircle'] = 0x24D9;
 t['jcircumflex'] = 0x0135;
 t['jcrossedtail'] = 0x029D;
 t['jdotlessstroke'] = 0x025F;
 t['jecyrillic'] = 0x0458;
 t['jeemarabic'] = 0x062C;
 t['jeemfinalarabic'] = 0xFE9E;
 t['jeeminitialarabic'] = 0xFE9F;
 t['jeemmedialarabic'] = 0xFEA0;
 t['jeharabic'] = 0x0698;
 t['jehfinalarabic'] = 0xFB8B;
 t['jhabengali'] = 0x099D;
 t['jhadeva'] = 0x091D;
 t['jhagujarati'] = 0x0A9D;
 t['jhagurmukhi'] = 0x0A1D;
 t['jheharmenian'] = 0x057B;
 t['jis'] = 0x3004;
 t['jmonospace'] = 0xFF4A;
 t['jparen'] = 0x24A5;
 t['jsuperior'] = 0x02B2;
 t['k'] = 0x006B;
 t['kabashkircyrillic'] = 0x04A1;
 t['kabengali'] = 0x0995;
 t['kacute'] = 0x1E31;
 t['kacyrillic'] = 0x043A;
 t['kadescendercyrillic'] = 0x049B;
 t['kadeva'] = 0x0915;
 t['kaf'] = 0x05DB;
 t['kafarabic'] = 0x0643;
 t['kafdagesh'] = 0xFB3B;
 t['kafdageshhebrew'] = 0xFB3B;
 t['kaffinalarabic'] = 0xFEDA;
 t['kafhebrew'] = 0x05DB;
 t['kafinitialarabic'] = 0xFEDB;
 t['kafmedialarabic'] = 0xFEDC;
 t['kafrafehebrew'] = 0xFB4D;
 t['kagujarati'] = 0x0A95;
 t['kagurmukhi'] = 0x0A15;
 t['kahiragana'] = 0x304B;
 t['kahookcyrillic'] = 0x04C4;
 t['kakatakana'] = 0x30AB;
 t['kakatakanahalfwidth'] = 0xFF76;
 t['kappa'] = 0x03BA;
 t['kappasymbolgreek'] = 0x03F0;
 t['kapyeounmieumkorean'] = 0x3171;
 t['kapyeounphieuphkorean'] = 0x3184;
 t['kapyeounpieupkorean'] = 0x3178;
 t['kapyeounssangpieupkorean'] = 0x3179;
 t['karoriisquare'] = 0x330D;
 t['kashidaautoarabic'] = 0x0640;
 t['kashidaautonosidebearingarabic'] = 0x0640;
 t['kasmallkatakana'] = 0x30F5;
 t['kasquare'] = 0x3384;
 t['kasraarabic'] = 0x0650;
 t['kasratanarabic'] = 0x064D;
 t['kastrokecyrillic'] = 0x049F;
 t['katahiraprolongmarkhalfwidth'] = 0xFF70;
 t['kaverticalstrokecyrillic'] = 0x049D;
 t['kbopomofo'] = 0x310E;
 t['kcalsquare'] = 0x3389;
 t['kcaron'] = 0x01E9;
 t['kcedilla'] = 0x0137;
 t['kcircle'] = 0x24DA;
 t['kcommaaccent'] = 0x0137;
 t['kdotbelow'] = 0x1E33;
 t['keharmenian'] = 0x0584;
 t['kehiragana'] = 0x3051;
 t['kekatakana'] = 0x30B1;
 t['kekatakanahalfwidth'] = 0xFF79;
 t['kenarmenian'] = 0x056F;
 t['kesmallkatakana'] = 0x30F6;
 t['kgreenlandic'] = 0x0138;
 t['khabengali'] = 0x0996;
 t['khacyrillic'] = 0x0445;
 t['khadeva'] = 0x0916;
 t['khagujarati'] = 0x0A96;
 t['khagurmukhi'] = 0x0A16;
 t['khaharabic'] = 0x062E;
 t['khahfinalarabic'] = 0xFEA6;
 t['khahinitialarabic'] = 0xFEA7;
 t['khahmedialarabic'] = 0xFEA8;
 t['kheicoptic'] = 0x03E7;
 t['khhadeva'] = 0x0959;
 t['khhagurmukhi'] = 0x0A59;
 t['khieukhacirclekorean'] = 0x3278;
 t['khieukhaparenkorean'] = 0x3218;
 t['khieukhcirclekorean'] = 0x326A;
 t['khieukhkorean'] = 0x314B;
 t['khieukhparenkorean'] = 0x320A;
 t['khokhaithai'] = 0x0E02;
 t['khokhonthai'] = 0x0E05;
 t['khokhuatthai'] = 0x0E03;
 t['khokhwaithai'] = 0x0E04;
 t['khomutthai'] = 0x0E5B;
 t['khook'] = 0x0199;
 t['khorakhangthai'] = 0x0E06;
 t['khzsquare'] = 0x3391;
 t['kihiragana'] = 0x304D;
 t['kikatakana'] = 0x30AD;
 t['kikatakanahalfwidth'] = 0xFF77;
 t['kiroguramusquare'] = 0x3315;
 t['kiromeetorusquare'] = 0x3316;
 t['kirosquare'] = 0x3314;
 t['kiyeokacirclekorean'] = 0x326E;
 t['kiyeokaparenkorean'] = 0x320E;
 t['kiyeokcirclekorean'] = 0x3260;
 t['kiyeokkorean'] = 0x3131;
 t['kiyeokparenkorean'] = 0x3200;
 t['kiyeoksioskorean'] = 0x3133;
 t['kjecyrillic'] = 0x045C;
 t['klinebelow'] = 0x1E35;
 t['klsquare'] = 0x3398;
 t['kmcubedsquare'] = 0x33A6;
 t['kmonospace'] = 0xFF4B;
 t['kmsquaredsquare'] = 0x33A2;
 t['kohiragana'] = 0x3053;
 t['kohmsquare'] = 0x33C0;
 t['kokaithai'] = 0x0E01;
 t['kokatakana'] = 0x30B3;
 t['kokatakanahalfwidth'] = 0xFF7A;
 t['kooposquare'] = 0x331E;
 t['koppacyrillic'] = 0x0481;
 t['koreanstandardsymbol'] = 0x327F;
 t['koroniscmb'] = 0x0343;
 t['kparen'] = 0x24A6;
 t['kpasquare'] = 0x33AA;
 t['ksicyrillic'] = 0x046F;
 t['ktsquare'] = 0x33CF;
 t['kturned'] = 0x029E;
 t['kuhiragana'] = 0x304F;
 t['kukatakana'] = 0x30AF;
 t['kukatakanahalfwidth'] = 0xFF78;
 t['kvsquare'] = 0x33B8;
 t['kwsquare'] = 0x33BE;
 t['l'] = 0x006C;
 t['labengali'] = 0x09B2;
 t['lacute'] = 0x013A;
 t['ladeva'] = 0x0932;
 t['lagujarati'] = 0x0AB2;
 t['lagurmukhi'] = 0x0A32;
 t['lakkhangyaothai'] = 0x0E45;
 t['lamaleffinalarabic'] = 0xFEFC;
 t['lamalefhamzaabovefinalarabic'] = 0xFEF8;
 t['lamalefhamzaaboveisolatedarabic'] = 0xFEF7;
 t['lamalefhamzabelowfinalarabic'] = 0xFEFA;
 t['lamalefhamzabelowisolatedarabic'] = 0xFEF9;
 t['lamalefisolatedarabic'] = 0xFEFB;
 t['lamalefmaddaabovefinalarabic'] = 0xFEF6;
 t['lamalefmaddaaboveisolatedarabic'] = 0xFEF5;
 t['lamarabic'] = 0x0644;
 t['lambda'] = 0x03BB;
 t['lambdastroke'] = 0x019B;
 t['lamed'] = 0x05DC;
 t['lameddagesh'] = 0xFB3C;
 t['lameddageshhebrew'] = 0xFB3C;
 t['lamedhebrew'] = 0x05DC;
 t['lamfinalarabic'] = 0xFEDE;
 t['lamhahinitialarabic'] = 0xFCCA;
 t['laminitialarabic'] = 0xFEDF;
 t['lamjeeminitialarabic'] = 0xFCC9;
 t['lamkhahinitialarabic'] = 0xFCCB;
 t['lamlamhehisolatedarabic'] = 0xFDF2;
 t['lammedialarabic'] = 0xFEE0;
 t['lammeemhahinitialarabic'] = 0xFD88;
 t['lammeeminitialarabic'] = 0xFCCC;
 t['largecircle'] = 0x25EF;
 t['lbar'] = 0x019A;
 t['lbelt'] = 0x026C;
 t['lbopomofo'] = 0x310C;
 t['lcaron'] = 0x013E;
 t['lcedilla'] = 0x013C;
 t['lcircle'] = 0x24DB;
 t['lcircumflexbelow'] = 0x1E3D;
 t['lcommaaccent'] = 0x013C;
 t['ldot'] = 0x0140;
 t['ldotaccent'] = 0x0140;
 t['ldotbelow'] = 0x1E37;
 t['ldotbelowmacron'] = 0x1E39;
 t['leftangleabovecmb'] = 0x031A;
 t['lefttackbelowcmb'] = 0x0318;
 t['less'] = 0x003C;
 t['lessequal'] = 0x2264;
 t['lessequalorgreater'] = 0x22DA;
 t['lessmonospace'] = 0xFF1C;
 t['lessorequivalent'] = 0x2272;
 t['lessorgreater'] = 0x2276;
 t['lessoverequal'] = 0x2266;
 t['lesssmall'] = 0xFE64;
 t['lezh'] = 0x026E;
 t['lfblock'] = 0x258C;
 t['lhookretroflex'] = 0x026D;
 t['lira'] = 0x20A4;
 t['liwnarmenian'] = 0x056C;
 t['lj'] = 0x01C9;
 t['ljecyrillic'] = 0x0459;
 t['ll'] = 0xF6C0;
 t['lladeva'] = 0x0933;
 t['llagujarati'] = 0x0AB3;
 t['llinebelow'] = 0x1E3B;
 t['llladeva'] = 0x0934;
 t['llvocalicbengali'] = 0x09E1;
 t['llvocalicdeva'] = 0x0961;
 t['llvocalicvowelsignbengali'] = 0x09E3;
 t['llvocalicvowelsigndeva'] = 0x0963;
 t['lmiddletilde'] = 0x026B;
 t['lmonospace'] = 0xFF4C;
 t['lmsquare'] = 0x33D0;
 t['lochulathai'] = 0x0E2C;
 t['logicaland'] = 0x2227;
 t['logicalnot'] = 0x00AC;
 t['logicalnotreversed'] = 0x2310;
 t['logicalor'] = 0x2228;
 t['lolingthai'] = 0x0E25;
 t['longs'] = 0x017F;
 t['lowlinecenterline'] = 0xFE4E;
 t['lowlinecmb'] = 0x0332;
 t['lowlinedashed'] = 0xFE4D;
 t['lozenge'] = 0x25CA;
 t['lparen'] = 0x24A7;
 t['lslash'] = 0x0142;
 t['lsquare'] = 0x2113;
 t['lsuperior'] = 0xF6EE;
 t['ltshade'] = 0x2591;
 t['luthai'] = 0x0E26;
 t['lvocalicbengali'] = 0x098C;
 t['lvocalicdeva'] = 0x090C;
 t['lvocalicvowelsignbengali'] = 0x09E2;
 t['lvocalicvowelsigndeva'] = 0x0962;
 t['lxsquare'] = 0x33D3;
 t['m'] = 0x006D;
 t['mabengali'] = 0x09AE;
 t['macron'] = 0x00AF;
 t['macronbelowcmb'] = 0x0331;
 t['macroncmb'] = 0x0304;
 t['macronlowmod'] = 0x02CD;
 t['macronmonospace'] = 0xFFE3;
 t['macute'] = 0x1E3F;
 t['madeva'] = 0x092E;
 t['magujarati'] = 0x0AAE;
 t['magurmukhi'] = 0x0A2E;
 t['mahapakhhebrew'] = 0x05A4;
 t['mahapakhlefthebrew'] = 0x05A4;
 t['mahiragana'] = 0x307E;
 t['maichattawalowleftthai'] = 0xF895;
 t['maichattawalowrightthai'] = 0xF894;
 t['maichattawathai'] = 0x0E4B;
 t['maichattawaupperleftthai'] = 0xF893;
 t['maieklowleftthai'] = 0xF88C;
 t['maieklowrightthai'] = 0xF88B;
 t['maiekthai'] = 0x0E48;
 t['maiekupperleftthai'] = 0xF88A;
 t['maihanakatleftthai'] = 0xF884;
 t['maihanakatthai'] = 0x0E31;
 t['maitaikhuleftthai'] = 0xF889;
 t['maitaikhuthai'] = 0x0E47;
 t['maitholowleftthai'] = 0xF88F;
 t['maitholowrightthai'] = 0xF88E;
 t['maithothai'] = 0x0E49;
 t['maithoupperleftthai'] = 0xF88D;
 t['maitrilowleftthai'] = 0xF892;
 t['maitrilowrightthai'] = 0xF891;
 t['maitrithai'] = 0x0E4A;
 t['maitriupperleftthai'] = 0xF890;
 t['maiyamokthai'] = 0x0E46;
 t['makatakana'] = 0x30DE;
 t['makatakanahalfwidth'] = 0xFF8F;
 t['male'] = 0x2642;
 t['mansyonsquare'] = 0x3347;
 t['maqafhebrew'] = 0x05BE;
 t['mars'] = 0x2642;
 t['masoracirclehebrew'] = 0x05AF;
 t['masquare'] = 0x3383;
 t['mbopomofo'] = 0x3107;
 t['mbsquare'] = 0x33D4;
 t['mcircle'] = 0x24DC;
 t['mcubedsquare'] = 0x33A5;
 t['mdotaccent'] = 0x1E41;
 t['mdotbelow'] = 0x1E43;
 t['meemarabic'] = 0x0645;
 t['meemfinalarabic'] = 0xFEE2;
 t['meeminitialarabic'] = 0xFEE3;
 t['meemmedialarabic'] = 0xFEE4;
 t['meemmeeminitialarabic'] = 0xFCD1;
 t['meemmeemisolatedarabic'] = 0xFC48;
 t['meetorusquare'] = 0x334D;
 t['mehiragana'] = 0x3081;
 t['meizierasquare'] = 0x337E;
 t['mekatakana'] = 0x30E1;
 t['mekatakanahalfwidth'] = 0xFF92;
 t['mem'] = 0x05DE;
 t['memdagesh'] = 0xFB3E;
 t['memdageshhebrew'] = 0xFB3E;
 t['memhebrew'] = 0x05DE;
 t['menarmenian'] = 0x0574;
 t['merkhahebrew'] = 0x05A5;
 t['merkhakefulahebrew'] = 0x05A6;
 t['merkhakefulalefthebrew'] = 0x05A6;
 t['merkhalefthebrew'] = 0x05A5;
 t['mhook'] = 0x0271;
 t['mhzsquare'] = 0x3392;
 t['middledotkatakanahalfwidth'] = 0xFF65;
 t['middot'] = 0x00B7;
 t['mieumacirclekorean'] = 0x3272;
 t['mieumaparenkorean'] = 0x3212;
 t['mieumcirclekorean'] = 0x3264;
 t['mieumkorean'] = 0x3141;
 t['mieumpansioskorean'] = 0x3170;
 t['mieumparenkorean'] = 0x3204;
 t['mieumpieupkorean'] = 0x316E;
 t['mieumsioskorean'] = 0x316F;
 t['mihiragana'] = 0x307F;
 t['mikatakana'] = 0x30DF;
 t['mikatakanahalfwidth'] = 0xFF90;
 t['minus'] = 0x2212;
 t['minusbelowcmb'] = 0x0320;
 t['minuscircle'] = 0x2296;
 t['minusmod'] = 0x02D7;
 t['minusplus'] = 0x2213;
 t['minute'] = 0x2032;
 t['miribaarusquare'] = 0x334A;
 t['mirisquare'] = 0x3349;
 t['mlonglegturned'] = 0x0270;
 t['mlsquare'] = 0x3396;
 t['mmcubedsquare'] = 0x33A3;
 t['mmonospace'] = 0xFF4D;
 t['mmsquaredsquare'] = 0x339F;
 t['mohiragana'] = 0x3082;
 t['mohmsquare'] = 0x33C1;
 t['mokatakana'] = 0x30E2;
 t['mokatakanahalfwidth'] = 0xFF93;
 t['molsquare'] = 0x33D6;
 t['momathai'] = 0x0E21;
 t['moverssquare'] = 0x33A7;
 t['moverssquaredsquare'] = 0x33A8;
 t['mparen'] = 0x24A8;
 t['mpasquare'] = 0x33AB;
 t['mssquare'] = 0x33B3;
 t['msuperior'] = 0xF6EF;
 t['mturned'] = 0x026F;
 t['mu'] = 0x00B5;
 t['mu1'] = 0x00B5;
 t['muasquare'] = 0x3382;
 t['muchgreater'] = 0x226B;
 t['muchless'] = 0x226A;
 t['mufsquare'] = 0x338C;
 t['mugreek'] = 0x03BC;
 t['mugsquare'] = 0x338D;
 t['muhiragana'] = 0x3080;
 t['mukatakana'] = 0x30E0;
 t['mukatakanahalfwidth'] = 0xFF91;
 t['mulsquare'] = 0x3395;
 t['multiply'] = 0x00D7;
 t['mumsquare'] = 0x339B;
 t['munahhebrew'] = 0x05A3;
 t['munahlefthebrew'] = 0x05A3;
 t['musicalnote'] = 0x266A;
 t['musicalnotedbl'] = 0x266B;
 t['musicflatsign'] = 0x266D;
 t['musicsharpsign'] = 0x266F;
 t['mussquare'] = 0x33B2;
 t['muvsquare'] = 0x33B6;
 t['muwsquare'] = 0x33BC;
 t['mvmegasquare'] = 0x33B9;
 t['mvsquare'] = 0x33B7;
 t['mwmegasquare'] = 0x33BF;
 t['mwsquare'] = 0x33BD;
 t['n'] = 0x006E;
 t['nabengali'] = 0x09A8;
 t['nabla'] = 0x2207;
 t['nacute'] = 0x0144;
 t['nadeva'] = 0x0928;
 t['nagujarati'] = 0x0AA8;
 t['nagurmukhi'] = 0x0A28;
 t['nahiragana'] = 0x306A;
 t['nakatakana'] = 0x30CA;
 t['nakatakanahalfwidth'] = 0xFF85;
 t['napostrophe'] = 0x0149;
 t['nasquare'] = 0x3381;
 t['nbopomofo'] = 0x310B;
 t['nbspace'] = 0x00A0;
 t['ncaron'] = 0x0148;
 t['ncedilla'] = 0x0146;
 t['ncircle'] = 0x24DD;
 t['ncircumflexbelow'] = 0x1E4B;
 t['ncommaaccent'] = 0x0146;
 t['ndotaccent'] = 0x1E45;
 t['ndotbelow'] = 0x1E47;
 t['nehiragana'] = 0x306D;
 t['nekatakana'] = 0x30CD;
 t['nekatakanahalfwidth'] = 0xFF88;
 t['newsheqelsign'] = 0x20AA;
 t['nfsquare'] = 0x338B;
 t['ngabengali'] = 0x0999;
 t['ngadeva'] = 0x0919;
 t['ngagujarati'] = 0x0A99;
 t['ngagurmukhi'] = 0x0A19;
 t['ngonguthai'] = 0x0E07;
 t['nhiragana'] = 0x3093;
 t['nhookleft'] = 0x0272;
 t['nhookretroflex'] = 0x0273;
 t['nieunacirclekorean'] = 0x326F;
 t['nieunaparenkorean'] = 0x320F;
 t['nieuncieuckorean'] = 0x3135;
 t['nieuncirclekorean'] = 0x3261;
 t['nieunhieuhkorean'] = 0x3136;
 t['nieunkorean'] = 0x3134;
 t['nieunpansioskorean'] = 0x3168;
 t['nieunparenkorean'] = 0x3201;
 t['nieunsioskorean'] = 0x3167;
 t['nieuntikeutkorean'] = 0x3166;
 t['nihiragana'] = 0x306B;
 t['nikatakana'] = 0x30CB;
 t['nikatakanahalfwidth'] = 0xFF86;
 t['nikhahitleftthai'] = 0xF899;
 t['nikhahitthai'] = 0x0E4D;
 t['nine'] = 0x0039;
 t['ninearabic'] = 0x0669;
 t['ninebengali'] = 0x09EF;
 t['ninecircle'] = 0x2468;
 t['ninecircleinversesansserif'] = 0x2792;
 t['ninedeva'] = 0x096F;
 t['ninegujarati'] = 0x0AEF;
 t['ninegurmukhi'] = 0x0A6F;
 t['ninehackarabic'] = 0x0669;
 t['ninehangzhou'] = 0x3029;
 t['nineideographicparen'] = 0x3228;
 t['nineinferior'] = 0x2089;
 t['ninemonospace'] = 0xFF19;
 t['nineoldstyle'] = 0xF739;
 t['nineparen'] = 0x247C;
 t['nineperiod'] = 0x2490;
 t['ninepersian'] = 0x06F9;
 t['nineroman'] = 0x2178;
 t['ninesuperior'] = 0x2079;
 t['nineteencircle'] = 0x2472;
 t['nineteenparen'] = 0x2486;
 t['nineteenperiod'] = 0x249A;
 t['ninethai'] = 0x0E59;
 t['nj'] = 0x01CC;
 t['njecyrillic'] = 0x045A;
 t['nkatakana'] = 0x30F3;
 t['nkatakanahalfwidth'] = 0xFF9D;
 t['nlegrightlong'] = 0x019E;
 t['nlinebelow'] = 0x1E49;
 t['nmonospace'] = 0xFF4E;
 t['nmsquare'] = 0x339A;
 t['nnabengali'] = 0x09A3;
 t['nnadeva'] = 0x0923;
 t['nnagujarati'] = 0x0AA3;
 t['nnagurmukhi'] = 0x0A23;
 t['nnnadeva'] = 0x0929;
 t['nohiragana'] = 0x306E;
 t['nokatakana'] = 0x30CE;
 t['nokatakanahalfwidth'] = 0xFF89;
 t['nonbreakingspace'] = 0x00A0;
 t['nonenthai'] = 0x0E13;
 t['nonuthai'] = 0x0E19;
 t['noonarabic'] = 0x0646;
 t['noonfinalarabic'] = 0xFEE6;
 t['noonghunnaarabic'] = 0x06BA;
 t['noonghunnafinalarabic'] = 0xFB9F;
 t['nooninitialarabic'] = 0xFEE7;
 t['noonjeeminitialarabic'] = 0xFCD2;
 t['noonjeemisolatedarabic'] = 0xFC4B;
 t['noonmedialarabic'] = 0xFEE8;
 t['noonmeeminitialarabic'] = 0xFCD5;
 t['noonmeemisolatedarabic'] = 0xFC4E;
 t['noonnoonfinalarabic'] = 0xFC8D;
 t['notcontains'] = 0x220C;
 t['notelement'] = 0x2209;
 t['notelementof'] = 0x2209;
 t['notequal'] = 0x2260;
 t['notgreater'] = 0x226F;
 t['notgreaternorequal'] = 0x2271;
 t['notgreaternorless'] = 0x2279;
 t['notidentical'] = 0x2262;
 t['notless'] = 0x226E;
 t['notlessnorequal'] = 0x2270;
 t['notparallel'] = 0x2226;
 t['notprecedes'] = 0x2280;
 t['notsubset'] = 0x2284;
 t['notsucceeds'] = 0x2281;
 t['notsuperset'] = 0x2285;
 t['nowarmenian'] = 0x0576;
 t['nparen'] = 0x24A9;
 t['nssquare'] = 0x33B1;
 t['nsuperior'] = 0x207F;
 t['ntilde'] = 0x00F1;
 t['nu'] = 0x03BD;
 t['nuhiragana'] = 0x306C;
 t['nukatakana'] = 0x30CC;
 t['nukatakanahalfwidth'] = 0xFF87;
 t['nuktabengali'] = 0x09BC;
 t['nuktadeva'] = 0x093C;
 t['nuktagujarati'] = 0x0ABC;
 t['nuktagurmukhi'] = 0x0A3C;
 t['numbersign'] = 0x0023;
 t['numbersignmonospace'] = 0xFF03;
 t['numbersignsmall'] = 0xFE5F;
 t['numeralsigngreek'] = 0x0374;
 t['numeralsignlowergreek'] = 0x0375;
 t['numero'] = 0x2116;
 t['nun'] = 0x05E0;
 t['nundagesh'] = 0xFB40;
 t['nundageshhebrew'] = 0xFB40;
 t['nunhebrew'] = 0x05E0;
 t['nvsquare'] = 0x33B5;
 t['nwsquare'] = 0x33BB;
 t['nyabengali'] = 0x099E;
 t['nyadeva'] = 0x091E;
 t['nyagujarati'] = 0x0A9E;
 t['nyagurmukhi'] = 0x0A1E;
 t['o'] = 0x006F;
 t['oacute'] = 0x00F3;
 t['oangthai'] = 0x0E2D;
 t['obarred'] = 0x0275;
 t['obarredcyrillic'] = 0x04E9;
 t['obarreddieresiscyrillic'] = 0x04EB;
 t['obengali'] = 0x0993;
 t['obopomofo'] = 0x311B;
 t['obreve'] = 0x014F;
 t['ocandradeva'] = 0x0911;
 t['ocandragujarati'] = 0x0A91;
 t['ocandravowelsigndeva'] = 0x0949;
 t['ocandravowelsigngujarati'] = 0x0AC9;
 t['ocaron'] = 0x01D2;
 t['ocircle'] = 0x24DE;
 t['ocircumflex'] = 0x00F4;
 t['ocircumflexacute'] = 0x1ED1;
 t['ocircumflexdotbelow'] = 0x1ED9;
 t['ocircumflexgrave'] = 0x1ED3;
 t['ocircumflexhookabove'] = 0x1ED5;
 t['ocircumflextilde'] = 0x1ED7;
 t['ocyrillic'] = 0x043E;
 t['odblacute'] = 0x0151;
 t['odblgrave'] = 0x020D;
 t['odeva'] = 0x0913;
 t['odieresis'] = 0x00F6;
 t['odieresiscyrillic'] = 0x04E7;
 t['odotbelow'] = 0x1ECD;
 t['oe'] = 0x0153;
 t['oekorean'] = 0x315A;
 t['ogonek'] = 0x02DB;
 t['ogonekcmb'] = 0x0328;
 t['ograve'] = 0x00F2;
 t['ogujarati'] = 0x0A93;
 t['oharmenian'] = 0x0585;
 t['ohiragana'] = 0x304A;
 t['ohookabove'] = 0x1ECF;
 t['ohorn'] = 0x01A1;
 t['ohornacute'] = 0x1EDB;
 t['ohorndotbelow'] = 0x1EE3;
 t['ohorngrave'] = 0x1EDD;
 t['ohornhookabove'] = 0x1EDF;
 t['ohorntilde'] = 0x1EE1;
 t['ohungarumlaut'] = 0x0151;
 t['oi'] = 0x01A3;
 t['oinvertedbreve'] = 0x020F;
 t['okatakana'] = 0x30AA;
 t['okatakanahalfwidth'] = 0xFF75;
 t['okorean'] = 0x3157;
 t['olehebrew'] = 0x05AB;
 t['omacron'] = 0x014D;
 t['omacronacute'] = 0x1E53;
 t['omacrongrave'] = 0x1E51;
 t['omdeva'] = 0x0950;
 t['omega'] = 0x03C9;
 t['omega1'] = 0x03D6;
 t['omegacyrillic'] = 0x0461;
 t['omegalatinclosed'] = 0x0277;
 t['omegaroundcyrillic'] = 0x047B;
 t['omegatitlocyrillic'] = 0x047D;
 t['omegatonos'] = 0x03CE;
 t['omgujarati'] = 0x0AD0;
 t['omicron'] = 0x03BF;
 t['omicrontonos'] = 0x03CC;
 t['omonospace'] = 0xFF4F;
 t['one'] = 0x0031;
 t['onearabic'] = 0x0661;
 t['onebengali'] = 0x09E7;
 t['onecircle'] = 0x2460;
 t['onecircleinversesansserif'] = 0x278A;
 t['onedeva'] = 0x0967;
 t['onedotenleader'] = 0x2024;
 t['oneeighth'] = 0x215B;
 t['onefitted'] = 0xF6DC;
 t['onegujarati'] = 0x0AE7;
 t['onegurmukhi'] = 0x0A67;
 t['onehackarabic'] = 0x0661;
 t['onehalf'] = 0x00BD;
 t['onehangzhou'] = 0x3021;
 t['oneideographicparen'] = 0x3220;
 t['oneinferior'] = 0x2081;
 t['onemonospace'] = 0xFF11;
 t['onenumeratorbengali'] = 0x09F4;
 t['oneoldstyle'] = 0xF731;
 t['oneparen'] = 0x2474;
 t['oneperiod'] = 0x2488;
 t['onepersian'] = 0x06F1;
 t['onequarter'] = 0x00BC;
 t['oneroman'] = 0x2170;
 t['onesuperior'] = 0x00B9;
 t['onethai'] = 0x0E51;
 t['onethird'] = 0x2153;
 t['oogonek'] = 0x01EB;
 t['oogonekmacron'] = 0x01ED;
 t['oogurmukhi'] = 0x0A13;
 t['oomatragurmukhi'] = 0x0A4B;
 t['oopen'] = 0x0254;
 t['oparen'] = 0x24AA;
 t['openbullet'] = 0x25E6;
 t['option'] = 0x2325;
 t['ordfeminine'] = 0x00AA;
 t['ordmasculine'] = 0x00BA;
 t['orthogonal'] = 0x221F;
 t['oshortdeva'] = 0x0912;
 t['oshortvowelsigndeva'] = 0x094A;
 t['oslash'] = 0x00F8;
 t['oslashacute'] = 0x01FF;
 t['osmallhiragana'] = 0x3049;
 t['osmallkatakana'] = 0x30A9;
 t['osmallkatakanahalfwidth'] = 0xFF6B;
 t['ostrokeacute'] = 0x01FF;
 t['osuperior'] = 0xF6F0;
 t['otcyrillic'] = 0x047F;
 t['otilde'] = 0x00F5;
 t['otildeacute'] = 0x1E4D;
 t['otildedieresis'] = 0x1E4F;
 t['oubopomofo'] = 0x3121;
 t['overline'] = 0x203E;
 t['overlinecenterline'] = 0xFE4A;
 t['overlinecmb'] = 0x0305;
 t['overlinedashed'] = 0xFE49;
 t['overlinedblwavy'] = 0xFE4C;
 t['overlinewavy'] = 0xFE4B;
 t['overscore'] = 0x00AF;
 t['ovowelsignbengali'] = 0x09CB;
 t['ovowelsigndeva'] = 0x094B;
 t['ovowelsigngujarati'] = 0x0ACB;
 t['p'] = 0x0070;
 t['paampssquare'] = 0x3380;
 t['paasentosquare'] = 0x332B;
 t['pabengali'] = 0x09AA;
 t['pacute'] = 0x1E55;
 t['padeva'] = 0x092A;
 t['pagedown'] = 0x21DF;
 t['pageup'] = 0x21DE;
 t['pagujarati'] = 0x0AAA;
 t['pagurmukhi'] = 0x0A2A;
 t['pahiragana'] = 0x3071;
 t['paiyannoithai'] = 0x0E2F;
 t['pakatakana'] = 0x30D1;
 t['palatalizationcyrilliccmb'] = 0x0484;
 t['palochkacyrillic'] = 0x04C0;
 t['pansioskorean'] = 0x317F;
 t['paragraph'] = 0x00B6;
 t['parallel'] = 0x2225;
 t['parenleft'] = 0x0028;
 t['parenleftaltonearabic'] = 0xFD3E;
 t['parenleftbt'] = 0xF8ED;
 t['parenleftex'] = 0xF8EC;
 t['parenleftinferior'] = 0x208D;
 t['parenleftmonospace'] = 0xFF08;
 t['parenleftsmall'] = 0xFE59;
 t['parenleftsuperior'] = 0x207D;
 t['parenlefttp'] = 0xF8EB;
 t['parenleftvertical'] = 0xFE35;
 t['parenright'] = 0x0029;
 t['parenrightaltonearabic'] = 0xFD3F;
 t['parenrightbt'] = 0xF8F8;
 t['parenrightex'] = 0xF8F7;
 t['parenrightinferior'] = 0x208E;
 t['parenrightmonospace'] = 0xFF09;
 t['parenrightsmall'] = 0xFE5A;
 t['parenrightsuperior'] = 0x207E;
 t['parenrighttp'] = 0xF8F6;
 t['parenrightvertical'] = 0xFE36;
 t['partialdiff'] = 0x2202;
 t['paseqhebrew'] = 0x05C0;
 t['pashtahebrew'] = 0x0599;
 t['pasquare'] = 0x33A9;
 t['patah'] = 0x05B7;
 t['patah11'] = 0x05B7;
 t['patah1d'] = 0x05B7;
 t['patah2a'] = 0x05B7;
 t['patahhebrew'] = 0x05B7;
 t['patahnarrowhebrew'] = 0x05B7;
 t['patahquarterhebrew'] = 0x05B7;
 t['patahwidehebrew'] = 0x05B7;
 t['pazerhebrew'] = 0x05A1;
 t['pbopomofo'] = 0x3106;
 t['pcircle'] = 0x24DF;
 t['pdotaccent'] = 0x1E57;
 t['pe'] = 0x05E4;
 t['pecyrillic'] = 0x043F;
 t['pedagesh'] = 0xFB44;
 t['pedageshhebrew'] = 0xFB44;
 t['peezisquare'] = 0x333B;
 t['pefinaldageshhebrew'] = 0xFB43;
 t['peharabic'] = 0x067E;
 t['peharmenian'] = 0x057A;
 t['pehebrew'] = 0x05E4;
 t['pehfinalarabic'] = 0xFB57;
 t['pehinitialarabic'] = 0xFB58;
 t['pehiragana'] = 0x307A;
 t['pehmedialarabic'] = 0xFB59;
 t['pekatakana'] = 0x30DA;
 t['pemiddlehookcyrillic'] = 0x04A7;
 t['perafehebrew'] = 0xFB4E;
 t['percent'] = 0x0025;
 t['percentarabic'] = 0x066A;
 t['percentmonospace'] = 0xFF05;
 t['percentsmall'] = 0xFE6A;
 t['period'] = 0x002E;
 t['periodarmenian'] = 0x0589;
 t['periodcentered'] = 0x00B7;
 t['periodhalfwidth'] = 0xFF61;
 t['periodinferior'] = 0xF6E7;
 t['periodmonospace'] = 0xFF0E;
 t['periodsmall'] = 0xFE52;
 t['periodsuperior'] = 0xF6E8;
 t['perispomenigreekcmb'] = 0x0342;
 t['perpendicular'] = 0x22A5;
 t['perthousand'] = 0x2030;
 t['peseta'] = 0x20A7;
 t['pfsquare'] = 0x338A;
 t['phabengali'] = 0x09AB;
 t['phadeva'] = 0x092B;
 t['phagujarati'] = 0x0AAB;
 t['phagurmukhi'] = 0x0A2B;
 t['phi'] = 0x03C6;
 t['phi1'] = 0x03D5;
 t['phieuphacirclekorean'] = 0x327A;
 t['phieuphaparenkorean'] = 0x321A;
 t['phieuphcirclekorean'] = 0x326C;
 t['phieuphkorean'] = 0x314D;
 t['phieuphparenkorean'] = 0x320C;
 t['philatin'] = 0x0278;
 t['phinthuthai'] = 0x0E3A;
 t['phisymbolgreek'] = 0x03D5;
 t['phook'] = 0x01A5;
 t['phophanthai'] = 0x0E1E;
 t['phophungthai'] = 0x0E1C;
 t['phosamphaothai'] = 0x0E20;
 t['pi'] = 0x03C0;
 t['pieupacirclekorean'] = 0x3273;
 t['pieupaparenkorean'] = 0x3213;
 t['pieupcieuckorean'] = 0x3176;
 t['pieupcirclekorean'] = 0x3265;
 t['pieupkiyeokkorean'] = 0x3172;
 t['pieupkorean'] = 0x3142;
 t['pieupparenkorean'] = 0x3205;
 t['pieupsioskiyeokkorean'] = 0x3174;
 t['pieupsioskorean'] = 0x3144;
 t['pieupsiostikeutkorean'] = 0x3175;
 t['pieupthieuthkorean'] = 0x3177;
 t['pieuptikeutkorean'] = 0x3173;
 t['pihiragana'] = 0x3074;
 t['pikatakana'] = 0x30D4;
 t['pisymbolgreek'] = 0x03D6;
 t['piwrarmenian'] = 0x0583;
 t['plus'] = 0x002B;
 t['plusbelowcmb'] = 0x031F;
 t['pluscircle'] = 0x2295;
 t['plusminus'] = 0x00B1;
 t['plusmod'] = 0x02D6;
 t['plusmonospace'] = 0xFF0B;
 t['plussmall'] = 0xFE62;
 t['plussuperior'] = 0x207A;
 t['pmonospace'] = 0xFF50;
 t['pmsquare'] = 0x33D8;
 t['pohiragana'] = 0x307D;
 t['pointingindexdownwhite'] = 0x261F;
 t['pointingindexleftwhite'] = 0x261C;
 t['pointingindexrightwhite'] = 0x261E;
 t['pointingindexupwhite'] = 0x261D;
 t['pokatakana'] = 0x30DD;
 t['poplathai'] = 0x0E1B;
 t['postalmark'] = 0x3012;
 t['postalmarkface'] = 0x3020;
 t['pparen'] = 0x24AB;
 t['precedes'] = 0x227A;
 t['prescription'] = 0x211E;
 t['primemod'] = 0x02B9;
 t['primereversed'] = 0x2035;
 t['product'] = 0x220F;
 t['projective'] = 0x2305;
 t['prolongedkana'] = 0x30FC;
 t['propellor'] = 0x2318;
 t['propersubset'] = 0x2282;
 t['propersuperset'] = 0x2283;
 t['proportion'] = 0x2237;
 t['proportional'] = 0x221D;
 t['psi'] = 0x03C8;
 t['psicyrillic'] = 0x0471;
 t['psilipneumatacyrilliccmb'] = 0x0486;
 t['pssquare'] = 0x33B0;
 t['puhiragana'] = 0x3077;
 t['pukatakana'] = 0x30D7;
 t['pvsquare'] = 0x33B4;
 t['pwsquare'] = 0x33BA;
 t['q'] = 0x0071;
 t['qadeva'] = 0x0958;
 t['qadmahebrew'] = 0x05A8;
 t['qafarabic'] = 0x0642;
 t['qaffinalarabic'] = 0xFED6;
 t['qafinitialarabic'] = 0xFED7;
 t['qafmedialarabic'] = 0xFED8;
 t['qamats'] = 0x05B8;
 t['qamats10'] = 0x05B8;
 t['qamats1a'] = 0x05B8;
 t['qamats1c'] = 0x05B8;
 t['qamats27'] = 0x05B8;
 t['qamats29'] = 0x05B8;
 t['qamats33'] = 0x05B8;
 t['qamatsde'] = 0x05B8;
 t['qamatshebrew'] = 0x05B8;
 t['qamatsnarrowhebrew'] = 0x05B8;
 t['qamatsqatanhebrew'] = 0x05B8;
 t['qamatsqatannarrowhebrew'] = 0x05B8;
 t['qamatsqatanquarterhebrew'] = 0x05B8;
 t['qamatsqatanwidehebrew'] = 0x05B8;
 t['qamatsquarterhebrew'] = 0x05B8;
 t['qamatswidehebrew'] = 0x05B8;
 t['qarneyparahebrew'] = 0x059F;
 t['qbopomofo'] = 0x3111;
 t['qcircle'] = 0x24E0;
 t['qhook'] = 0x02A0;
 t['qmonospace'] = 0xFF51;
 t['qof'] = 0x05E7;
 t['qofdagesh'] = 0xFB47;
 t['qofdageshhebrew'] = 0xFB47;
 t['qofhebrew'] = 0x05E7;
 t['qparen'] = 0x24AC;
 t['quarternote'] = 0x2669;
 t['qubuts'] = 0x05BB;
 t['qubuts18'] = 0x05BB;
 t['qubuts25'] = 0x05BB;
 t['qubuts31'] = 0x05BB;
 t['qubutshebrew'] = 0x05BB;
 t['qubutsnarrowhebrew'] = 0x05BB;
 t['qubutsquarterhebrew'] = 0x05BB;
 t['qubutswidehebrew'] = 0x05BB;
 t['question'] = 0x003F;
 t['questionarabic'] = 0x061F;
 t['questionarmenian'] = 0x055E;
 t['questiondown'] = 0x00BF;
 t['questiondownsmall'] = 0xF7BF;
 t['questiongreek'] = 0x037E;
 t['questionmonospace'] = 0xFF1F;
 t['questionsmall'] = 0xF73F;
 t['quotedbl'] = 0x0022;
 t['quotedblbase'] = 0x201E;
 t['quotedblleft'] = 0x201C;
 t['quotedblmonospace'] = 0xFF02;
 t['quotedblprime'] = 0x301E;
 t['quotedblprimereversed'] = 0x301D;
 t['quotedblright'] = 0x201D;
 t['quoteleft'] = 0x2018;
 t['quoteleftreversed'] = 0x201B;
 t['quotereversed'] = 0x201B;
 t['quoteright'] = 0x2019;
 t['quoterightn'] = 0x0149;
 t['quotesinglbase'] = 0x201A;
 t['quotesingle'] = 0x0027;
 t['quotesinglemonospace'] = 0xFF07;
 t['r'] = 0x0072;
 t['raarmenian'] = 0x057C;
 t['rabengali'] = 0x09B0;
 t['racute'] = 0x0155;
 t['radeva'] = 0x0930;
 t['radical'] = 0x221A;
 t['radicalex'] = 0xF8E5;
 t['radoverssquare'] = 0x33AE;
 t['radoverssquaredsquare'] = 0x33AF;
 t['radsquare'] = 0x33AD;
 t['rafe'] = 0x05BF;
 t['rafehebrew'] = 0x05BF;
 t['ragujarati'] = 0x0AB0;
 t['ragurmukhi'] = 0x0A30;
 t['rahiragana'] = 0x3089;
 t['rakatakana'] = 0x30E9;
 t['rakatakanahalfwidth'] = 0xFF97;
 t['ralowerdiagonalbengali'] = 0x09F1;
 t['ramiddlediagonalbengali'] = 0x09F0;
 t['ramshorn'] = 0x0264;
 t['ratio'] = 0x2236;
 t['rbopomofo'] = 0x3116;
 t['rcaron'] = 0x0159;
 t['rcedilla'] = 0x0157;
 t['rcircle'] = 0x24E1;
 t['rcommaaccent'] = 0x0157;
 t['rdblgrave'] = 0x0211;
 t['rdotaccent'] = 0x1E59;
 t['rdotbelow'] = 0x1E5B;
 t['rdotbelowmacron'] = 0x1E5D;
 t['referencemark'] = 0x203B;
 t['reflexsubset'] = 0x2286;
 t['reflexsuperset'] = 0x2287;
 t['registered'] = 0x00AE;
 t['registersans'] = 0xF8E8;
 t['registerserif'] = 0xF6DA;
 t['reharabic'] = 0x0631;
 t['reharmenian'] = 0x0580;
 t['rehfinalarabic'] = 0xFEAE;
 t['rehiragana'] = 0x308C;
 t['rekatakana'] = 0x30EC;
 t['rekatakanahalfwidth'] = 0xFF9A;
 t['resh'] = 0x05E8;
 t['reshdageshhebrew'] = 0xFB48;
 t['reshhebrew'] = 0x05E8;
 t['reversedtilde'] = 0x223D;
 t['reviahebrew'] = 0x0597;
 t['reviamugrashhebrew'] = 0x0597;
 t['revlogicalnot'] = 0x2310;
 t['rfishhook'] = 0x027E;
 t['rfishhookreversed'] = 0x027F;
 t['rhabengali'] = 0x09DD;
 t['rhadeva'] = 0x095D;
 t['rho'] = 0x03C1;
 t['rhook'] = 0x027D;
 t['rhookturned'] = 0x027B;
 t['rhookturnedsuperior'] = 0x02B5;
 t['rhosymbolgreek'] = 0x03F1;
 t['rhotichookmod'] = 0x02DE;
 t['rieulacirclekorean'] = 0x3271;
 t['rieulaparenkorean'] = 0x3211;
 t['rieulcirclekorean'] = 0x3263;
 t['rieulhieuhkorean'] = 0x3140;
 t['rieulkiyeokkorean'] = 0x313A;
 t['rieulkiyeoksioskorean'] = 0x3169;
 t['rieulkorean'] = 0x3139;
 t['rieulmieumkorean'] = 0x313B;
 t['rieulpansioskorean'] = 0x316C;
 t['rieulparenkorean'] = 0x3203;
 t['rieulphieuphkorean'] = 0x313F;
 t['rieulpieupkorean'] = 0x313C;
 t['rieulpieupsioskorean'] = 0x316B;
 t['rieulsioskorean'] = 0x313D;
 t['rieulthieuthkorean'] = 0x313E;
 t['rieultikeutkorean'] = 0x316A;
 t['rieulyeorinhieuhkorean'] = 0x316D;
 t['rightangle'] = 0x221F;
 t['righttackbelowcmb'] = 0x0319;
 t['righttriangle'] = 0x22BF;
 t['rihiragana'] = 0x308A;
 t['rikatakana'] = 0x30EA;
 t['rikatakanahalfwidth'] = 0xFF98;
 t['ring'] = 0x02DA;
 t['ringbelowcmb'] = 0x0325;
 t['ringcmb'] = 0x030A;
 t['ringhalfleft'] = 0x02BF;
 t['ringhalfleftarmenian'] = 0x0559;
 t['ringhalfleftbelowcmb'] = 0x031C;
 t['ringhalfleftcentered'] = 0x02D3;
 t['ringhalfright'] = 0x02BE;
 t['ringhalfrightbelowcmb'] = 0x0339;
 t['ringhalfrightcentered'] = 0x02D2;
 t['rinvertedbreve'] = 0x0213;
 t['rittorusquare'] = 0x3351;
 t['rlinebelow'] = 0x1E5F;
 t['rlongleg'] = 0x027C;
 t['rlonglegturned'] = 0x027A;
 t['rmonospace'] = 0xFF52;
 t['rohiragana'] = 0x308D;
 t['rokatakana'] = 0x30ED;
 t['rokatakanahalfwidth'] = 0xFF9B;
 t['roruathai'] = 0x0E23;
 t['rparen'] = 0x24AD;
 t['rrabengali'] = 0x09DC;
 t['rradeva'] = 0x0931;
 t['rragurmukhi'] = 0x0A5C;
 t['rreharabic'] = 0x0691;
 t['rrehfinalarabic'] = 0xFB8D;
 t['rrvocalicbengali'] = 0x09E0;
 t['rrvocalicdeva'] = 0x0960;
 t['rrvocalicgujarati'] = 0x0AE0;
 t['rrvocalicvowelsignbengali'] = 0x09C4;
 t['rrvocalicvowelsigndeva'] = 0x0944;
 t['rrvocalicvowelsigngujarati'] = 0x0AC4;
 t['rsuperior'] = 0xF6F1;
 t['rtblock'] = 0x2590;
 t['rturned'] = 0x0279;
 t['rturnedsuperior'] = 0x02B4;
 t['ruhiragana'] = 0x308B;
 t['rukatakana'] = 0x30EB;
 t['rukatakanahalfwidth'] = 0xFF99;
 t['rupeemarkbengali'] = 0x09F2;
 t['rupeesignbengali'] = 0x09F3;
 t['rupiah'] = 0xF6DD;
 t['ruthai'] = 0x0E24;
 t['rvocalicbengali'] = 0x098B;
 t['rvocalicdeva'] = 0x090B;
 t['rvocalicgujarati'] = 0x0A8B;
 t['rvocalicvowelsignbengali'] = 0x09C3;
 t['rvocalicvowelsigndeva'] = 0x0943;
 t['rvocalicvowelsigngujarati'] = 0x0AC3;
 t['s'] = 0x0073;
 t['sabengali'] = 0x09B8;
 t['sacute'] = 0x015B;
 t['sacutedotaccent'] = 0x1E65;
 t['sadarabic'] = 0x0635;
 t['sadeva'] = 0x0938;
 t['sadfinalarabic'] = 0xFEBA;
 t['sadinitialarabic'] = 0xFEBB;
 t['sadmedialarabic'] = 0xFEBC;
 t['sagujarati'] = 0x0AB8;
 t['sagurmukhi'] = 0x0A38;
 t['sahiragana'] = 0x3055;
 t['sakatakana'] = 0x30B5;
 t['sakatakanahalfwidth'] = 0xFF7B;
 t['sallallahoualayhewasallamarabic'] = 0xFDFA;
 t['samekh'] = 0x05E1;
 t['samekhdagesh'] = 0xFB41;
 t['samekhdageshhebrew'] = 0xFB41;
 t['samekhhebrew'] = 0x05E1;
 t['saraaathai'] = 0x0E32;
 t['saraaethai'] = 0x0E41;
 t['saraaimaimalaithai'] = 0x0E44;
 t['saraaimaimuanthai'] = 0x0E43;
 t['saraamthai'] = 0x0E33;
 t['saraathai'] = 0x0E30;
 t['saraethai'] = 0x0E40;
 t['saraiileftthai'] = 0xF886;
 t['saraiithai'] = 0x0E35;
 t['saraileftthai'] = 0xF885;
 t['saraithai'] = 0x0E34;
 t['saraothai'] = 0x0E42;
 t['saraueeleftthai'] = 0xF888;
 t['saraueethai'] = 0x0E37;
 t['saraueleftthai'] = 0xF887;
 t['sarauethai'] = 0x0E36;
 t['sarauthai'] = 0x0E38;
 t['sarauuthai'] = 0x0E39;
 t['sbopomofo'] = 0x3119;
 t['scaron'] = 0x0161;
 t['scarondotaccent'] = 0x1E67;
 t['scedilla'] = 0x015F;
 t['schwa'] = 0x0259;
 t['schwacyrillic'] = 0x04D9;
 t['schwadieresiscyrillic'] = 0x04DB;
 t['schwahook'] = 0x025A;
 t['scircle'] = 0x24E2;
 t['scircumflex'] = 0x015D;
 t['scommaaccent'] = 0x0219;
 t['sdotaccent'] = 0x1E61;
 t['sdotbelow'] = 0x1E63;
 t['sdotbelowdotaccent'] = 0x1E69;
 t['seagullbelowcmb'] = 0x033C;
 t['second'] = 0x2033;
 t['secondtonechinese'] = 0x02CA;
 t['section'] = 0x00A7;
 t['seenarabic'] = 0x0633;
 t['seenfinalarabic'] = 0xFEB2;
 t['seeninitialarabic'] = 0xFEB3;
 t['seenmedialarabic'] = 0xFEB4;
 t['segol'] = 0x05B6;
 t['segol13'] = 0x05B6;
 t['segol1f'] = 0x05B6;
 t['segol2c'] = 0x05B6;
 t['segolhebrew'] = 0x05B6;
 t['segolnarrowhebrew'] = 0x05B6;
 t['segolquarterhebrew'] = 0x05B6;
 t['segoltahebrew'] = 0x0592;
 t['segolwidehebrew'] = 0x05B6;
 t['seharmenian'] = 0x057D;
 t['sehiragana'] = 0x305B;
 t['sekatakana'] = 0x30BB;
 t['sekatakanahalfwidth'] = 0xFF7E;
 t['semicolon'] = 0x003B;
 t['semicolonarabic'] = 0x061B;
 t['semicolonmonospace'] = 0xFF1B;
 t['semicolonsmall'] = 0xFE54;
 t['semivoicedmarkkana'] = 0x309C;
 t['semivoicedmarkkanahalfwidth'] = 0xFF9F;
 t['sentisquare'] = 0x3322;
 t['sentosquare'] = 0x3323;
 t['seven'] = 0x0037;
 t['sevenarabic'] = 0x0667;
 t['sevenbengali'] = 0x09ED;
 t['sevencircle'] = 0x2466;
 t['sevencircleinversesansserif'] = 0x2790;
 t['sevendeva'] = 0x096D;
 t['seveneighths'] = 0x215E;
 t['sevengujarati'] = 0x0AED;
 t['sevengurmukhi'] = 0x0A6D;
 t['sevenhackarabic'] = 0x0667;
 t['sevenhangzhou'] = 0x3027;
 t['sevenideographicparen'] = 0x3226;
 t['seveninferior'] = 0x2087;
 t['sevenmonospace'] = 0xFF17;
 t['sevenoldstyle'] = 0xF737;
 t['sevenparen'] = 0x247A;
 t['sevenperiod'] = 0x248E;
 t['sevenpersian'] = 0x06F7;
 t['sevenroman'] = 0x2176;
 t['sevensuperior'] = 0x2077;
 t['seventeencircle'] = 0x2470;
 t['seventeenparen'] = 0x2484;
 t['seventeenperiod'] = 0x2498;
 t['seventhai'] = 0x0E57;
 t['sfthyphen'] = 0x00AD;
 t['shaarmenian'] = 0x0577;
 t['shabengali'] = 0x09B6;
 t['shacyrillic'] = 0x0448;
 t['shaddaarabic'] = 0x0651;
 t['shaddadammaarabic'] = 0xFC61;
 t['shaddadammatanarabic'] = 0xFC5E;
 t['shaddafathaarabic'] = 0xFC60;
 t['shaddakasraarabic'] = 0xFC62;
 t['shaddakasratanarabic'] = 0xFC5F;
 t['shade'] = 0x2592;
 t['shadedark'] = 0x2593;
 t['shadelight'] = 0x2591;
 t['shademedium'] = 0x2592;
 t['shadeva'] = 0x0936;
 t['shagujarati'] = 0x0AB6;
 t['shagurmukhi'] = 0x0A36;
 t['shalshelethebrew'] = 0x0593;
 t['shbopomofo'] = 0x3115;
 t['shchacyrillic'] = 0x0449;
 t['sheenarabic'] = 0x0634;
 t['sheenfinalarabic'] = 0xFEB6;
 t['sheeninitialarabic'] = 0xFEB7;
 t['sheenmedialarabic'] = 0xFEB8;
 t['sheicoptic'] = 0x03E3;
 t['sheqel'] = 0x20AA;
 t['sheqelhebrew'] = 0x20AA;
 t['sheva'] = 0x05B0;
 t['sheva115'] = 0x05B0;
 t['sheva15'] = 0x05B0;
 t['sheva22'] = 0x05B0;
 t['sheva2e'] = 0x05B0;
 t['shevahebrew'] = 0x05B0;
 t['shevanarrowhebrew'] = 0x05B0;
 t['shevaquarterhebrew'] = 0x05B0;
 t['shevawidehebrew'] = 0x05B0;
 t['shhacyrillic'] = 0x04BB;
 t['shimacoptic'] = 0x03ED;
 t['shin'] = 0x05E9;
 t['shindagesh'] = 0xFB49;
 t['shindageshhebrew'] = 0xFB49;
 t['shindageshshindot'] = 0xFB2C;
 t['shindageshshindothebrew'] = 0xFB2C;
 t['shindageshsindot'] = 0xFB2D;
 t['shindageshsindothebrew'] = 0xFB2D;
 t['shindothebrew'] = 0x05C1;
 t['shinhebrew'] = 0x05E9;
 t['shinshindot'] = 0xFB2A;
 t['shinshindothebrew'] = 0xFB2A;
 t['shinsindot'] = 0xFB2B;
 t['shinsindothebrew'] = 0xFB2B;
 t['shook'] = 0x0282;
 t['sigma'] = 0x03C3;
 t['sigma1'] = 0x03C2;
 t['sigmafinal'] = 0x03C2;
 t['sigmalunatesymbolgreek'] = 0x03F2;
 t['sihiragana'] = 0x3057;
 t['sikatakana'] = 0x30B7;
 t['sikatakanahalfwidth'] = 0xFF7C;
 t['siluqhebrew'] = 0x05BD;
 t['siluqlefthebrew'] = 0x05BD;
 t['similar'] = 0x223C;
 t['sindothebrew'] = 0x05C2;
 t['siosacirclekorean'] = 0x3274;
 t['siosaparenkorean'] = 0x3214;
 t['sioscieuckorean'] = 0x317E;
 t['sioscirclekorean'] = 0x3266;
 t['sioskiyeokkorean'] = 0x317A;
 t['sioskorean'] = 0x3145;
 t['siosnieunkorean'] = 0x317B;
 t['siosparenkorean'] = 0x3206;
 t['siospieupkorean'] = 0x317D;
 t['siostikeutkorean'] = 0x317C;
 t['six'] = 0x0036;
 t['sixarabic'] = 0x0666;
 t['sixbengali'] = 0x09EC;
 t['sixcircle'] = 0x2465;
 t['sixcircleinversesansserif'] = 0x278F;
 t['sixdeva'] = 0x096C;
 t['sixgujarati'] = 0x0AEC;
 t['sixgurmukhi'] = 0x0A6C;
 t['sixhackarabic'] = 0x0666;
 t['sixhangzhou'] = 0x3026;
 t['sixideographicparen'] = 0x3225;
 t['sixinferior'] = 0x2086;
 t['sixmonospace'] = 0xFF16;
 t['sixoldstyle'] = 0xF736;
 t['sixparen'] = 0x2479;
 t['sixperiod'] = 0x248D;
 t['sixpersian'] = 0x06F6;
 t['sixroman'] = 0x2175;
 t['sixsuperior'] = 0x2076;
 t['sixteencircle'] = 0x246F;
 t['sixteencurrencydenominatorbengali'] = 0x09F9;
 t['sixteenparen'] = 0x2483;
 t['sixteenperiod'] = 0x2497;
 t['sixthai'] = 0x0E56;
 t['slash'] = 0x002F;
 t['slashmonospace'] = 0xFF0F;
 t['slong'] = 0x017F;
 t['slongdotaccent'] = 0x1E9B;
 t['smileface'] = 0x263A;
 t['smonospace'] = 0xFF53;
 t['sofpasuqhebrew'] = 0x05C3;
 t['softhyphen'] = 0x00AD;
 t['softsigncyrillic'] = 0x044C;
 t['sohiragana'] = 0x305D;
 t['sokatakana'] = 0x30BD;
 t['sokatakanahalfwidth'] = 0xFF7F;
 t['soliduslongoverlaycmb'] = 0x0338;
 t['solidusshortoverlaycmb'] = 0x0337;
 t['sorusithai'] = 0x0E29;
 t['sosalathai'] = 0x0E28;
 t['sosothai'] = 0x0E0B;
 t['sosuathai'] = 0x0E2A;
 t['space'] = 0x0020;
 t['spacehackarabic'] = 0x0020;
 t['spade'] = 0x2660;
 t['spadesuitblack'] = 0x2660;
 t['spadesuitwhite'] = 0x2664;
 t['sparen'] = 0x24AE;
 t['squarebelowcmb'] = 0x033B;
 t['squarecc'] = 0x33C4;
 t['squarecm'] = 0x339D;
 t['squarediagonalcrosshatchfill'] = 0x25A9;
 t['squarehorizontalfill'] = 0x25A4;
 t['squarekg'] = 0x338F;
 t['squarekm'] = 0x339E;
 t['squarekmcapital'] = 0x33CE;
 t['squareln'] = 0x33D1;
 t['squarelog'] = 0x33D2;
 t['squaremg'] = 0x338E;
 t['squaremil'] = 0x33D5;
 t['squaremm'] = 0x339C;
 t['squaremsquared'] = 0x33A1;
 t['squareorthogonalcrosshatchfill'] = 0x25A6;
 t['squareupperlefttolowerrightfill'] = 0x25A7;
 t['squareupperrighttolowerleftfill'] = 0x25A8;
 t['squareverticalfill'] = 0x25A5;
 t['squarewhitewithsmallblack'] = 0x25A3;
 t['srsquare'] = 0x33DB;
 t['ssabengali'] = 0x09B7;
 t['ssadeva'] = 0x0937;
 t['ssagujarati'] = 0x0AB7;
 t['ssangcieuckorean'] = 0x3149;
 t['ssanghieuhkorean'] = 0x3185;
 t['ssangieungkorean'] = 0x3180;
 t['ssangkiyeokkorean'] = 0x3132;
 t['ssangnieunkorean'] = 0x3165;
 t['ssangpieupkorean'] = 0x3143;
 t['ssangsioskorean'] = 0x3146;
 t['ssangtikeutkorean'] = 0x3138;
 t['ssuperior'] = 0xF6F2;
 t['sterling'] = 0x00A3;
 t['sterlingmonospace'] = 0xFFE1;
 t['strokelongoverlaycmb'] = 0x0336;
 t['strokeshortoverlaycmb'] = 0x0335;
 t['subset'] = 0x2282;
 t['subsetnotequal'] = 0x228A;
 t['subsetorequal'] = 0x2286;
 t['succeeds'] = 0x227B;
 t['suchthat'] = 0x220B;
 t['suhiragana'] = 0x3059;
 t['sukatakana'] = 0x30B9;
 t['sukatakanahalfwidth'] = 0xFF7D;
 t['sukunarabic'] = 0x0652;
 t['summation'] = 0x2211;
 t['sun'] = 0x263C;
 t['superset'] = 0x2283;
 t['supersetnotequal'] = 0x228B;
 t['supersetorequal'] = 0x2287;
 t['svsquare'] = 0x33DC;
 t['syouwaerasquare'] = 0x337C;
 t['t'] = 0x0074;
 t['tabengali'] = 0x09A4;
 t['tackdown'] = 0x22A4;
 t['tackleft'] = 0x22A3;
 t['tadeva'] = 0x0924;
 t['tagujarati'] = 0x0AA4;
 t['tagurmukhi'] = 0x0A24;
 t['taharabic'] = 0x0637;
 t['tahfinalarabic'] = 0xFEC2;
 t['tahinitialarabic'] = 0xFEC3;
 t['tahiragana'] = 0x305F;
 t['tahmedialarabic'] = 0xFEC4;
 t['taisyouerasquare'] = 0x337D;
 t['takatakana'] = 0x30BF;
 t['takatakanahalfwidth'] = 0xFF80;
 t['tatweelarabic'] = 0x0640;
 t['tau'] = 0x03C4;
 t['tav'] = 0x05EA;
 t['tavdages'] = 0xFB4A;
 t['tavdagesh'] = 0xFB4A;
 t['tavdageshhebrew'] = 0xFB4A;
 t['tavhebrew'] = 0x05EA;
 t['tbar'] = 0x0167;
 t['tbopomofo'] = 0x310A;
 t['tcaron'] = 0x0165;
 t['tccurl'] = 0x02A8;
 t['tcedilla'] = 0x0163;
 t['tcheharabic'] = 0x0686;
 t['tchehfinalarabic'] = 0xFB7B;
 t['tchehinitialarabic'] = 0xFB7C;
 t['tchehmedialarabic'] = 0xFB7D;
 t['tcircle'] = 0x24E3;
 t['tcircumflexbelow'] = 0x1E71;
 t['tcommaaccent'] = 0x0163;
 t['tdieresis'] = 0x1E97;
 t['tdotaccent'] = 0x1E6B;
 t['tdotbelow'] = 0x1E6D;
 t['tecyrillic'] = 0x0442;
 t['tedescendercyrillic'] = 0x04AD;
 t['teharabic'] = 0x062A;
 t['tehfinalarabic'] = 0xFE96;
 t['tehhahinitialarabic'] = 0xFCA2;
 t['tehhahisolatedarabic'] = 0xFC0C;
 t['tehinitialarabic'] = 0xFE97;
 t['tehiragana'] = 0x3066;
 t['tehjeeminitialarabic'] = 0xFCA1;
 t['tehjeemisolatedarabic'] = 0xFC0B;
 t['tehmarbutaarabic'] = 0x0629;
 t['tehmarbutafinalarabic'] = 0xFE94;
 t['tehmedialarabic'] = 0xFE98;
 t['tehmeeminitialarabic'] = 0xFCA4;
 t['tehmeemisolatedarabic'] = 0xFC0E;
 t['tehnoonfinalarabic'] = 0xFC73;
 t['tekatakana'] = 0x30C6;
 t['tekatakanahalfwidth'] = 0xFF83;
 t['telephone'] = 0x2121;
 t['telephoneblack'] = 0x260E;
 t['telishagedolahebrew'] = 0x05A0;
 t['telishaqetanahebrew'] = 0x05A9;
 t['tencircle'] = 0x2469;
 t['tenideographicparen'] = 0x3229;
 t['tenparen'] = 0x247D;
 t['tenperiod'] = 0x2491;
 t['tenroman'] = 0x2179;
 t['tesh'] = 0x02A7;
 t['tet'] = 0x05D8;
 t['tetdagesh'] = 0xFB38;
 t['tetdageshhebrew'] = 0xFB38;
 t['tethebrew'] = 0x05D8;
 t['tetsecyrillic'] = 0x04B5;
 t['tevirhebrew'] = 0x059B;
 t['tevirlefthebrew'] = 0x059B;
 t['thabengali'] = 0x09A5;
 t['thadeva'] = 0x0925;
 t['thagujarati'] = 0x0AA5;
 t['thagurmukhi'] = 0x0A25;
 t['thalarabic'] = 0x0630;
 t['thalfinalarabic'] = 0xFEAC;
 t['thanthakhatlowleftthai'] = 0xF898;
 t['thanthakhatlowrightthai'] = 0xF897;
 t['thanthakhatthai'] = 0x0E4C;
 t['thanthakhatupperleftthai'] = 0xF896;
 t['theharabic'] = 0x062B;
 t['thehfinalarabic'] = 0xFE9A;
 t['thehinitialarabic'] = 0xFE9B;
 t['thehmedialarabic'] = 0xFE9C;
 t['thereexists'] = 0x2203;
 t['therefore'] = 0x2234;
 t['theta'] = 0x03B8;
 t['theta1'] = 0x03D1;
 t['thetasymbolgreek'] = 0x03D1;
 t['thieuthacirclekorean'] = 0x3279;
 t['thieuthaparenkorean'] = 0x3219;
 t['thieuthcirclekorean'] = 0x326B;
 t['thieuthkorean'] = 0x314C;
 t['thieuthparenkorean'] = 0x320B;
 t['thirteencircle'] = 0x246C;
 t['thirteenparen'] = 0x2480;
 t['thirteenperiod'] = 0x2494;
 t['thonangmonthothai'] = 0x0E11;
 t['thook'] = 0x01AD;
 t['thophuthaothai'] = 0x0E12;
 t['thorn'] = 0x00FE;
 t['thothahanthai'] = 0x0E17;
 t['thothanthai'] = 0x0E10;
 t['thothongthai'] = 0x0E18;
 t['thothungthai'] = 0x0E16;
 t['thousandcyrillic'] = 0x0482;
 t['thousandsseparatorarabic'] = 0x066C;
 t['thousandsseparatorpersian'] = 0x066C;
 t['three'] = 0x0033;
 t['threearabic'] = 0x0663;
 t['threebengali'] = 0x09E9;
 t['threecircle'] = 0x2462;
 t['threecircleinversesansserif'] = 0x278C;
 t['threedeva'] = 0x0969;
 t['threeeighths'] = 0x215C;
 t['threegujarati'] = 0x0AE9;
 t['threegurmukhi'] = 0x0A69;
 t['threehackarabic'] = 0x0663;
 t['threehangzhou'] = 0x3023;
 t['threeideographicparen'] = 0x3222;
 t['threeinferior'] = 0x2083;
 t['threemonospace'] = 0xFF13;
 t['threenumeratorbengali'] = 0x09F6;
 t['threeoldstyle'] = 0xF733;
 t['threeparen'] = 0x2476;
 t['threeperiod'] = 0x248A;
 t['threepersian'] = 0x06F3;
 t['threequarters'] = 0x00BE;
 t['threequartersemdash'] = 0xF6DE;
 t['threeroman'] = 0x2172;
 t['threesuperior'] = 0x00B3;
 t['threethai'] = 0x0E53;
 t['thzsquare'] = 0x3394;
 t['tihiragana'] = 0x3061;
 t['tikatakana'] = 0x30C1;
 t['tikatakanahalfwidth'] = 0xFF81;
 t['tikeutacirclekorean'] = 0x3270;
 t['tikeutaparenkorean'] = 0x3210;
 t['tikeutcirclekorean'] = 0x3262;
 t['tikeutkorean'] = 0x3137;
 t['tikeutparenkorean'] = 0x3202;
 t['tilde'] = 0x02DC;
 t['tildebelowcmb'] = 0x0330;
 t['tildecmb'] = 0x0303;
 t['tildecomb'] = 0x0303;
 t['tildedoublecmb'] = 0x0360;
 t['tildeoperator'] = 0x223C;
 t['tildeoverlaycmb'] = 0x0334;
 t['tildeverticalcmb'] = 0x033E;
 t['timescircle'] = 0x2297;
 t['tipehahebrew'] = 0x0596;
 t['tipehalefthebrew'] = 0x0596;
 t['tippigurmukhi'] = 0x0A70;
 t['titlocyrilliccmb'] = 0x0483;
 t['tiwnarmenian'] = 0x057F;
 t['tlinebelow'] = 0x1E6F;
 t['tmonospace'] = 0xFF54;
 t['toarmenian'] = 0x0569;
 t['tohiragana'] = 0x3068;
 t['tokatakana'] = 0x30C8;
 t['tokatakanahalfwidth'] = 0xFF84;
 t['tonebarextrahighmod'] = 0x02E5;
 t['tonebarextralowmod'] = 0x02E9;
 t['tonebarhighmod'] = 0x02E6;
 t['tonebarlowmod'] = 0x02E8;
 t['tonebarmidmod'] = 0x02E7;
 t['tonefive'] = 0x01BD;
 t['tonesix'] = 0x0185;
 t['tonetwo'] = 0x01A8;
 t['tonos'] = 0x0384;
 t['tonsquare'] = 0x3327;
 t['topatakthai'] = 0x0E0F;
 t['tortoiseshellbracketleft'] = 0x3014;
 t['tortoiseshellbracketleftsmall'] = 0xFE5D;
 t['tortoiseshellbracketleftvertical'] = 0xFE39;
 t['tortoiseshellbracketright'] = 0x3015;
 t['tortoiseshellbracketrightsmall'] = 0xFE5E;
 t['tortoiseshellbracketrightvertical'] = 0xFE3A;
 t['totaothai'] = 0x0E15;
 t['tpalatalhook'] = 0x01AB;
 t['tparen'] = 0x24AF;
 t['trademark'] = 0x2122;
 t['trademarksans'] = 0xF8EA;
 t['trademarkserif'] = 0xF6DB;
 t['tretroflexhook'] = 0x0288;
 t['triagdn'] = 0x25BC;
 t['triaglf'] = 0x25C4;
 t['triagrt'] = 0x25BA;
 t['triagup'] = 0x25B2;
 t['ts'] = 0x02A6;
 t['tsadi'] = 0x05E6;
 t['tsadidagesh'] = 0xFB46;
 t['tsadidageshhebrew'] = 0xFB46;
 t['tsadihebrew'] = 0x05E6;
 t['tsecyrillic'] = 0x0446;
 t['tsere'] = 0x05B5;
 t['tsere12'] = 0x05B5;
 t['tsere1e'] = 0x05B5;
 t['tsere2b'] = 0x05B5;
 t['tserehebrew'] = 0x05B5;
 t['tserenarrowhebrew'] = 0x05B5;
 t['tserequarterhebrew'] = 0x05B5;
 t['tserewidehebrew'] = 0x05B5;
 t['tshecyrillic'] = 0x045B;
 t['tsuperior'] = 0xF6F3;
 t['ttabengali'] = 0x099F;
 t['ttadeva'] = 0x091F;
 t['ttagujarati'] = 0x0A9F;
 t['ttagurmukhi'] = 0x0A1F;
 t['tteharabic'] = 0x0679;
 t['ttehfinalarabic'] = 0xFB67;
 t['ttehinitialarabic'] = 0xFB68;
 t['ttehmedialarabic'] = 0xFB69;
 t['tthabengali'] = 0x09A0;
 t['tthadeva'] = 0x0920;
 t['tthagujarati'] = 0x0AA0;
 t['tthagurmukhi'] = 0x0A20;
 t['tturned'] = 0x0287;
 t['tuhiragana'] = 0x3064;
 t['tukatakana'] = 0x30C4;
 t['tukatakanahalfwidth'] = 0xFF82;
 t['tusmallhiragana'] = 0x3063;
 t['tusmallkatakana'] = 0x30C3;
 t['tusmallkatakanahalfwidth'] = 0xFF6F;
 t['twelvecircle'] = 0x246B;
 t['twelveparen'] = 0x247F;
 t['twelveperiod'] = 0x2493;
 t['twelveroman'] = 0x217B;
 t['twentycircle'] = 0x2473;
 t['twentyhangzhou'] = 0x5344;
 t['twentyparen'] = 0x2487;
 t['twentyperiod'] = 0x249B;
 t['two'] = 0x0032;
 t['twoarabic'] = 0x0662;
 t['twobengali'] = 0x09E8;
 t['twocircle'] = 0x2461;
 t['twocircleinversesansserif'] = 0x278B;
 t['twodeva'] = 0x0968;
 t['twodotenleader'] = 0x2025;
 t['twodotleader'] = 0x2025;
 t['twodotleadervertical'] = 0xFE30;
 t['twogujarati'] = 0x0AE8;
 t['twogurmukhi'] = 0x0A68;
 t['twohackarabic'] = 0x0662;
 t['twohangzhou'] = 0x3022;
 t['twoideographicparen'] = 0x3221;
 t['twoinferior'] = 0x2082;
 t['twomonospace'] = 0xFF12;
 t['twonumeratorbengali'] = 0x09F5;
 t['twooldstyle'] = 0xF732;
 t['twoparen'] = 0x2475;
 t['twoperiod'] = 0x2489;
 t['twopersian'] = 0x06F2;
 t['tworoman'] = 0x2171;
 t['twostroke'] = 0x01BB;
 t['twosuperior'] = 0x00B2;
 t['twothai'] = 0x0E52;
 t['twothirds'] = 0x2154;
 t['u'] = 0x0075;
 t['uacute'] = 0x00FA;
 t['ubar'] = 0x0289;
 t['ubengali'] = 0x0989;
 t['ubopomofo'] = 0x3128;
 t['ubreve'] = 0x016D;
 t['ucaron'] = 0x01D4;
 t['ucircle'] = 0x24E4;
 t['ucircumflex'] = 0x00FB;
 t['ucircumflexbelow'] = 0x1E77;
 t['ucyrillic'] = 0x0443;
 t['udattadeva'] = 0x0951;
 t['udblacute'] = 0x0171;
 t['udblgrave'] = 0x0215;
 t['udeva'] = 0x0909;
 t['udieresis'] = 0x00FC;
 t['udieresisacute'] = 0x01D8;
 t['udieresisbelow'] = 0x1E73;
 t['udieresiscaron'] = 0x01DA;
 t['udieresiscyrillic'] = 0x04F1;
 t['udieresisgrave'] = 0x01DC;
 t['udieresismacron'] = 0x01D6;
 t['udotbelow'] = 0x1EE5;
 t['ugrave'] = 0x00F9;
 t['ugujarati'] = 0x0A89;
 t['ugurmukhi'] = 0x0A09;
 t['uhiragana'] = 0x3046;
 t['uhookabove'] = 0x1EE7;
 t['uhorn'] = 0x01B0;
 t['uhornacute'] = 0x1EE9;
 t['uhorndotbelow'] = 0x1EF1;
 t['uhorngrave'] = 0x1EEB;
 t['uhornhookabove'] = 0x1EED;
 t['uhorntilde'] = 0x1EEF;
 t['uhungarumlaut'] = 0x0171;
 t['uhungarumlautcyrillic'] = 0x04F3;
 t['uinvertedbreve'] = 0x0217;
 t['ukatakana'] = 0x30A6;
 t['ukatakanahalfwidth'] = 0xFF73;
 t['ukcyrillic'] = 0x0479;
 t['ukorean'] = 0x315C;
 t['umacron'] = 0x016B;
 t['umacroncyrillic'] = 0x04EF;
 t['umacrondieresis'] = 0x1E7B;
 t['umatragurmukhi'] = 0x0A41;
 t['umonospace'] = 0xFF55;
 t['underscore'] = 0x005F;
 t['underscoredbl'] = 0x2017;
 t['underscoremonospace'] = 0xFF3F;
 t['underscorevertical'] = 0xFE33;
 t['underscorewavy'] = 0xFE4F;
 t['union'] = 0x222A;
 t['universal'] = 0x2200;
 t['uogonek'] = 0x0173;
 t['uparen'] = 0x24B0;
 t['upblock'] = 0x2580;
 t['upperdothebrew'] = 0x05C4;
 t['upsilon'] = 0x03C5;
 t['upsilondieresis'] = 0x03CB;
 t['upsilondieresistonos'] = 0x03B0;
 t['upsilonlatin'] = 0x028A;
 t['upsilontonos'] = 0x03CD;
 t['uptackbelowcmb'] = 0x031D;
 t['uptackmod'] = 0x02D4;
 t['uragurmukhi'] = 0x0A73;
 t['uring'] = 0x016F;
 t['ushortcyrillic'] = 0x045E;
 t['usmallhiragana'] = 0x3045;
 t['usmallkatakana'] = 0x30A5;
 t['usmallkatakanahalfwidth'] = 0xFF69;
 t['ustraightcyrillic'] = 0x04AF;
 t['ustraightstrokecyrillic'] = 0x04B1;
 t['utilde'] = 0x0169;
 t['utildeacute'] = 0x1E79;
 t['utildebelow'] = 0x1E75;
 t['uubengali'] = 0x098A;
 t['uudeva'] = 0x090A;
 t['uugujarati'] = 0x0A8A;
 t['uugurmukhi'] = 0x0A0A;
 t['uumatragurmukhi'] = 0x0A42;
 t['uuvowelsignbengali'] = 0x09C2;
 t['uuvowelsigndeva'] = 0x0942;
 t['uuvowelsigngujarati'] = 0x0AC2;
 t['uvowelsignbengali'] = 0x09C1;
 t['uvowelsigndeva'] = 0x0941;
 t['uvowelsigngujarati'] = 0x0AC1;
 t['v'] = 0x0076;
 t['vadeva'] = 0x0935;
 t['vagujarati'] = 0x0AB5;
 t['vagurmukhi'] = 0x0A35;
 t['vakatakana'] = 0x30F7;
 t['vav'] = 0x05D5;
 t['vavdagesh'] = 0xFB35;
 t['vavdagesh65'] = 0xFB35;
 t['vavdageshhebrew'] = 0xFB35;
 t['vavhebrew'] = 0x05D5;
 t['vavholam'] = 0xFB4B;
 t['vavholamhebrew'] = 0xFB4B;
 t['vavvavhebrew'] = 0x05F0;
 t['vavyodhebrew'] = 0x05F1;
 t['vcircle'] = 0x24E5;
 t['vdotbelow'] = 0x1E7F;
 t['vecyrillic'] = 0x0432;
 t['veharabic'] = 0x06A4;
 t['vehfinalarabic'] = 0xFB6B;
 t['vehinitialarabic'] = 0xFB6C;
 t['vehmedialarabic'] = 0xFB6D;
 t['vekatakana'] = 0x30F9;
 t['venus'] = 0x2640;
 t['verticalbar'] = 0x007C;
 t['verticallineabovecmb'] = 0x030D;
 t['verticallinebelowcmb'] = 0x0329;
 t['verticallinelowmod'] = 0x02CC;
 t['verticallinemod'] = 0x02C8;
 t['vewarmenian'] = 0x057E;
 t['vhook'] = 0x028B;
 t['vikatakana'] = 0x30F8;
 t['viramabengali'] = 0x09CD;
 t['viramadeva'] = 0x094D;
 t['viramagujarati'] = 0x0ACD;
 t['visargabengali'] = 0x0983;
 t['visargadeva'] = 0x0903;
 t['visargagujarati'] = 0x0A83;
 t['vmonospace'] = 0xFF56;
 t['voarmenian'] = 0x0578;
 t['voicediterationhiragana'] = 0x309E;
 t['voicediterationkatakana'] = 0x30FE;
 t['voicedmarkkana'] = 0x309B;
 t['voicedmarkkanahalfwidth'] = 0xFF9E;
 t['vokatakana'] = 0x30FA;
 t['vparen'] = 0x24B1;
 t['vtilde'] = 0x1E7D;
 t['vturned'] = 0x028C;
 t['vuhiragana'] = 0x3094;
 t['vukatakana'] = 0x30F4;
 t['w'] = 0x0077;
 t['wacute'] = 0x1E83;
 t['waekorean'] = 0x3159;
 t['wahiragana'] = 0x308F;
 t['wakatakana'] = 0x30EF;
 t['wakatakanahalfwidth'] = 0xFF9C;
 t['wakorean'] = 0x3158;
 t['wasmallhiragana'] = 0x308E;
 t['wasmallkatakana'] = 0x30EE;
 t['wattosquare'] = 0x3357;
 t['wavedash'] = 0x301C;
 t['wavyunderscorevertical'] = 0xFE34;
 t['wawarabic'] = 0x0648;
 t['wawfinalarabic'] = 0xFEEE;
 t['wawhamzaabovearabic'] = 0x0624;
 t['wawhamzaabovefinalarabic'] = 0xFE86;
 t['wbsquare'] = 0x33DD;
 t['wcircle'] = 0x24E6;
 t['wcircumflex'] = 0x0175;
 t['wdieresis'] = 0x1E85;
 t['wdotaccent'] = 0x1E87;
 t['wdotbelow'] = 0x1E89;
 t['wehiragana'] = 0x3091;
 t['weierstrass'] = 0x2118;
 t['wekatakana'] = 0x30F1;
 t['wekorean'] = 0x315E;
 t['weokorean'] = 0x315D;
 t['wgrave'] = 0x1E81;
 t['whitebullet'] = 0x25E6;
 t['whitecircle'] = 0x25CB;
 t['whitecircleinverse'] = 0x25D9;
 t['whitecornerbracketleft'] = 0x300E;
 t['whitecornerbracketleftvertical'] = 0xFE43;
 t['whitecornerbracketright'] = 0x300F;
 t['whitecornerbracketrightvertical'] = 0xFE44;
 t['whitediamond'] = 0x25C7;
 t['whitediamondcontainingblacksmalldiamond'] = 0x25C8;
 t['whitedownpointingsmalltriangle'] = 0x25BF;
 t['whitedownpointingtriangle'] = 0x25BD;
 t['whiteleftpointingsmalltriangle'] = 0x25C3;
 t['whiteleftpointingtriangle'] = 0x25C1;
 t['whitelenticularbracketleft'] = 0x3016;
 t['whitelenticularbracketright'] = 0x3017;
 t['whiterightpointingsmalltriangle'] = 0x25B9;
 t['whiterightpointingtriangle'] = 0x25B7;
 t['whitesmallsquare'] = 0x25AB;
 t['whitesmilingface'] = 0x263A;
 t['whitesquare'] = 0x25A1;
 t['whitestar'] = 0x2606;
 t['whitetelephone'] = 0x260F;
 t['whitetortoiseshellbracketleft'] = 0x3018;
 t['whitetortoiseshellbracketright'] = 0x3019;
 t['whiteuppointingsmalltriangle'] = 0x25B5;
 t['whiteuppointingtriangle'] = 0x25B3;
 t['wihiragana'] = 0x3090;
 t['wikatakana'] = 0x30F0;
 t['wikorean'] = 0x315F;
 t['wmonospace'] = 0xFF57;
 t['wohiragana'] = 0x3092;
 t['wokatakana'] = 0x30F2;
 t['wokatakanahalfwidth'] = 0xFF66;
 t['won'] = 0x20A9;
 t['wonmonospace'] = 0xFFE6;
 t['wowaenthai'] = 0x0E27;
 t['wparen'] = 0x24B2;
 t['wring'] = 0x1E98;
 t['wsuperior'] = 0x02B7;
 t['wturned'] = 0x028D;
 t['wynn'] = 0x01BF;
 t['x'] = 0x0078;
 t['xabovecmb'] = 0x033D;
 t['xbopomofo'] = 0x3112;
 t['xcircle'] = 0x24E7;
 t['xdieresis'] = 0x1E8D;
 t['xdotaccent'] = 0x1E8B;
 t['xeharmenian'] = 0x056D;
 t['xi'] = 0x03BE;
 t['xmonospace'] = 0xFF58;
 t['xparen'] = 0x24B3;
 t['xsuperior'] = 0x02E3;
 t['y'] = 0x0079;
 t['yaadosquare'] = 0x334E;
 t['yabengali'] = 0x09AF;
 t['yacute'] = 0x00FD;
 t['yadeva'] = 0x092F;
 t['yaekorean'] = 0x3152;
 t['yagujarati'] = 0x0AAF;
 t['yagurmukhi'] = 0x0A2F;
 t['yahiragana'] = 0x3084;
 t['yakatakana'] = 0x30E4;
 t['yakatakanahalfwidth'] = 0xFF94;
 t['yakorean'] = 0x3151;
 t['yamakkanthai'] = 0x0E4E;
 t['yasmallhiragana'] = 0x3083;
 t['yasmallkatakana'] = 0x30E3;
 t['yasmallkatakanahalfwidth'] = 0xFF6C;
 t['yatcyrillic'] = 0x0463;
 t['ycircle'] = 0x24E8;
 t['ycircumflex'] = 0x0177;
 t['ydieresis'] = 0x00FF;
 t['ydotaccent'] = 0x1E8F;
 t['ydotbelow'] = 0x1EF5;
 t['yeharabic'] = 0x064A;
 t['yehbarreearabic'] = 0x06D2;
 t['yehbarreefinalarabic'] = 0xFBAF;
 t['yehfinalarabic'] = 0xFEF2;
 t['yehhamzaabovearabic'] = 0x0626;
 t['yehhamzaabovefinalarabic'] = 0xFE8A;
 t['yehhamzaaboveinitialarabic'] = 0xFE8B;
 t['yehhamzaabovemedialarabic'] = 0xFE8C;
 t['yehinitialarabic'] = 0xFEF3;
 t['yehmedialarabic'] = 0xFEF4;
 t['yehmeeminitialarabic'] = 0xFCDD;
 t['yehmeemisolatedarabic'] = 0xFC58;
 t['yehnoonfinalarabic'] = 0xFC94;
 t['yehthreedotsbelowarabic'] = 0x06D1;
 t['yekorean'] = 0x3156;
 t['yen'] = 0x00A5;
 t['yenmonospace'] = 0xFFE5;
 t['yeokorean'] = 0x3155;
 t['yeorinhieuhkorean'] = 0x3186;
 t['yerahbenyomohebrew'] = 0x05AA;
 t['yerahbenyomolefthebrew'] = 0x05AA;
 t['yericyrillic'] = 0x044B;
 t['yerudieresiscyrillic'] = 0x04F9;
 t['yesieungkorean'] = 0x3181;
 t['yesieungpansioskorean'] = 0x3183;
 t['yesieungsioskorean'] = 0x3182;
 t['yetivhebrew'] = 0x059A;
 t['ygrave'] = 0x1EF3;
 t['yhook'] = 0x01B4;
 t['yhookabove'] = 0x1EF7;
 t['yiarmenian'] = 0x0575;
 t['yicyrillic'] = 0x0457;
 t['yikorean'] = 0x3162;
 t['yinyang'] = 0x262F;
 t['yiwnarmenian'] = 0x0582;
 t['ymonospace'] = 0xFF59;
 t['yod'] = 0x05D9;
 t['yoddagesh'] = 0xFB39;
 t['yoddageshhebrew'] = 0xFB39;
 t['yodhebrew'] = 0x05D9;
 t['yodyodhebrew'] = 0x05F2;
 t['yodyodpatahhebrew'] = 0xFB1F;
 t['yohiragana'] = 0x3088;
 t['yoikorean'] = 0x3189;
 t['yokatakana'] = 0x30E8;
 t['yokatakanahalfwidth'] = 0xFF96;
 t['yokorean'] = 0x315B;
 t['yosmallhiragana'] = 0x3087;
 t['yosmallkatakana'] = 0x30E7;
 t['yosmallkatakanahalfwidth'] = 0xFF6E;
 t['yotgreek'] = 0x03F3;
 t['yoyaekorean'] = 0x3188;
 t['yoyakorean'] = 0x3187;
 t['yoyakthai'] = 0x0E22;
 t['yoyingthai'] = 0x0E0D;
 t['yparen'] = 0x24B4;
 t['ypogegrammeni'] = 0x037A;
 t['ypogegrammenigreekcmb'] = 0x0345;
 t['yr'] = 0x01A6;
 t['yring'] = 0x1E99;
 t['ysuperior'] = 0x02B8;
 t['ytilde'] = 0x1EF9;
 t['yturned'] = 0x028E;
 t['yuhiragana'] = 0x3086;
 t['yuikorean'] = 0x318C;
 t['yukatakana'] = 0x30E6;
 t['yukatakanahalfwidth'] = 0xFF95;
 t['yukorean'] = 0x3160;
 t['yusbigcyrillic'] = 0x046B;
 t['yusbigiotifiedcyrillic'] = 0x046D;
 t['yuslittlecyrillic'] = 0x0467;
 t['yuslittleiotifiedcyrillic'] = 0x0469;
 t['yusmallhiragana'] = 0x3085;
 t['yusmallkatakana'] = 0x30E5;
 t['yusmallkatakanahalfwidth'] = 0xFF6D;
 t['yuyekorean'] = 0x318B;
 t['yuyeokorean'] = 0x318A;
 t['yyabengali'] = 0x09DF;
 t['yyadeva'] = 0x095F;
 t['z'] = 0x007A;
 t['zaarmenian'] = 0x0566;
 t['zacute'] = 0x017A;
 t['zadeva'] = 0x095B;
 t['zagurmukhi'] = 0x0A5B;
 t['zaharabic'] = 0x0638;
 t['zahfinalarabic'] = 0xFEC6;
 t['zahinitialarabic'] = 0xFEC7;
 t['zahiragana'] = 0x3056;
 t['zahmedialarabic'] = 0xFEC8;
 t['zainarabic'] = 0x0632;
 t['zainfinalarabic'] = 0xFEB0;
 t['zakatakana'] = 0x30B6;
 t['zaqefgadolhebrew'] = 0x0595;
 t['zaqefqatanhebrew'] = 0x0594;
 t['zarqahebrew'] = 0x0598;
 t['zayin'] = 0x05D6;
 t['zayindagesh'] = 0xFB36;
 t['zayindageshhebrew'] = 0xFB36;
 t['zayinhebrew'] = 0x05D6;
 t['zbopomofo'] = 0x3117;
 t['zcaron'] = 0x017E;
 t['zcircle'] = 0x24E9;
 t['zcircumflex'] = 0x1E91;
 t['zcurl'] = 0x0291;
 t['zdot'] = 0x017C;
 t['zdotaccent'] = 0x017C;
 t['zdotbelow'] = 0x1E93;
 t['zecyrillic'] = 0x0437;
 t['zedescendercyrillic'] = 0x0499;
 t['zedieresiscyrillic'] = 0x04DF;
 t['zehiragana'] = 0x305C;
 t['zekatakana'] = 0x30BC;
 t['zero'] = 0x0030;
 t['zeroarabic'] = 0x0660;
 t['zerobengali'] = 0x09E6;
 t['zerodeva'] = 0x0966;
 t['zerogujarati'] = 0x0AE6;
 t['zerogurmukhi'] = 0x0A66;
 t['zerohackarabic'] = 0x0660;
 t['zeroinferior'] = 0x2080;
 t['zeromonospace'] = 0xFF10;
 t['zerooldstyle'] = 0xF730;
 t['zeropersian'] = 0x06F0;
 t['zerosuperior'] = 0x2070;
 t['zerothai'] = 0x0E50;
 t['zerowidthjoiner'] = 0xFEFF;
 t['zerowidthnonjoiner'] = 0x200C;
 t['zerowidthspace'] = 0x200B;
 t['zeta'] = 0x03B6;
 t['zhbopomofo'] = 0x3113;
 t['zhearmenian'] = 0x056A;
 t['zhebrevecyrillic'] = 0x04C2;
 t['zhecyrillic'] = 0x0436;
 t['zhedescendercyrillic'] = 0x0497;
 t['zhedieresiscyrillic'] = 0x04DD;
 t['zihiragana'] = 0x3058;
 t['zikatakana'] = 0x30B8;
 t['zinorhebrew'] = 0x05AE;
 t['zlinebelow'] = 0x1E95;
 t['zmonospace'] = 0xFF5A;
 t['zohiragana'] = 0x305E;
 t['zokatakana'] = 0x30BE;
 t['zparen'] = 0x24B5;
 t['zretroflexhook'] = 0x0290;
 t['zstroke'] = 0x01B6;
 t['zuhiragana'] = 0x305A;
 t['zukatakana'] = 0x30BA;
 t['.notdef'] = 0x0000;
 t['angbracketleftbig'] = 0x2329;
 t['angbracketleftBig'] = 0x2329;
 t['angbracketleftbigg'] = 0x2329;
 t['angbracketleftBigg'] = 0x2329;
 t['angbracketrightBig'] = 0x232A;
 t['angbracketrightbig'] = 0x232A;
 t['angbracketrightBigg'] = 0x232A;
 t['angbracketrightbigg'] = 0x232A;
 t['arrowhookleft'] = 0x21AA;
 t['arrowhookright'] = 0x21A9;
 t['arrowlefttophalf'] = 0x21BC;
 t['arrowleftbothalf'] = 0x21BD;
 t['arrownortheast'] = 0x2197;
 t['arrownorthwest'] = 0x2196;
 t['arrowrighttophalf'] = 0x21C0;
 t['arrowrightbothalf'] = 0x21C1;
 t['arrowsoutheast'] = 0x2198;
 t['arrowsouthwest'] = 0x2199;
 t['backslashbig'] = 0x2216;
 t['backslashBig'] = 0x2216;
 t['backslashBigg'] = 0x2216;
 t['backslashbigg'] = 0x2216;
 t['bardbl'] = 0x2016;
 t['bracehtipdownleft'] = 0xFE37;
 t['bracehtipdownright'] = 0xFE37;
 t['bracehtipupleft'] = 0xFE38;
 t['bracehtipupright'] = 0xFE38;
 t['braceleftBig'] = 0x007B;
 t['braceleftbig'] = 0x007B;
 t['braceleftbigg'] = 0x007B;
 t['braceleftBigg'] = 0x007B;
 t['bracerightBig'] = 0x007D;
 t['bracerightbig'] = 0x007D;
 t['bracerightbigg'] = 0x007D;
 t['bracerightBigg'] = 0x007D;
 t['bracketleftbig'] = 0x005B;
 t['bracketleftBig'] = 0x005B;
 t['bracketleftbigg'] = 0x005B;
 t['bracketleftBigg'] = 0x005B;
 t['bracketrightBig'] = 0x005D;
 t['bracketrightbig'] = 0x005D;
 t['bracketrightbigg'] = 0x005D;
 t['bracketrightBigg'] = 0x005D;
 t['ceilingleftbig'] = 0x2308;
 t['ceilingleftBig'] = 0x2308;
 t['ceilingleftBigg'] = 0x2308;
 t['ceilingleftbigg'] = 0x2308;
 t['ceilingrightbig'] = 0x2309;
 t['ceilingrightBig'] = 0x2309;
 t['ceilingrightbigg'] = 0x2309;
 t['ceilingrightBigg'] = 0x2309;
 t['circledotdisplay'] = 0x2299;
 t['circledottext'] = 0x2299;
 t['circlemultiplydisplay'] = 0x2297;
 t['circlemultiplytext'] = 0x2297;
 t['circleplusdisplay'] = 0x2295;
 t['circleplustext'] = 0x2295;
 t['contintegraldisplay'] = 0x222E;
 t['contintegraltext'] = 0x222E;
 t['coproductdisplay'] = 0x2210;
 t['coproducttext'] = 0x2210;
 t['floorleftBig'] = 0x230A;
 t['floorleftbig'] = 0x230A;
 t['floorleftbigg'] = 0x230A;
 t['floorleftBigg'] = 0x230A;
 t['floorrightbig'] = 0x230B;
 t['floorrightBig'] = 0x230B;
 t['floorrightBigg'] = 0x230B;
 t['floorrightbigg'] = 0x230B;
 t['hatwide'] = 0x0302;
 t['hatwider'] = 0x0302;
 t['hatwidest'] = 0x0302;
 t['intercal'] = 0x1D40;
 t['integraldisplay'] = 0x222B;
 t['integraltext'] = 0x222B;
 t['intersectiondisplay'] = 0x22C2;
 t['intersectiontext'] = 0x22C2;
 t['logicalanddisplay'] = 0x2227;
 t['logicalandtext'] = 0x2227;
 t['logicalordisplay'] = 0x2228;
 t['logicalortext'] = 0x2228;
 t['parenleftBig'] = 0x0028;
 t['parenleftbig'] = 0x0028;
 t['parenleftBigg'] = 0x0028;
 t['parenleftbigg'] = 0x0028;
 t['parenrightBig'] = 0x0029;
 t['parenrightbig'] = 0x0029;
 t['parenrightBigg'] = 0x0029;
 t['parenrightbigg'] = 0x0029;
 t['prime'] = 0x2032;
 t['productdisplay'] = 0x220F;
 t['producttext'] = 0x220F;
 t['radicalbig'] = 0x221A;
 t['radicalBig'] = 0x221A;
 t['radicalBigg'] = 0x221A;
 t['radicalbigg'] = 0x221A;
 t['radicalbt'] = 0x221A;
 t['radicaltp'] = 0x221A;
 t['radicalvertex'] = 0x221A;
 t['slashbig'] = 0x002F;
 t['slashBig'] = 0x002F;
 t['slashBigg'] = 0x002F;
 t['slashbigg'] = 0x002F;
 t['summationdisplay'] = 0x2211;
 t['summationtext'] = 0x2211;
 t['tildewide'] = 0x02DC;
 t['tildewider'] = 0x02DC;
 t['tildewidest'] = 0x02DC;
 t['uniondisplay'] = 0x22C3;
 t['unionmultidisplay'] = 0x228E;
 t['unionmultitext'] = 0x228E;
 t['unionsqdisplay'] = 0x2294;
 t['unionsqtext'] = 0x2294;
 t['uniontext'] = 0x22C3;
 t['vextenddouble'] = 0x2225;
 t['vextendsingle'] = 0x2223;
});
var getDingbatsGlyphsUnicode = getLookupTableFactory(function (t) {
 t['space'] = 0x0020;
 t['a1'] = 0x2701;
 t['a2'] = 0x2702;
 t['a202'] = 0x2703;
 t['a3'] = 0x2704;
 t['a4'] = 0x260E;
 t['a5'] = 0x2706;
 t['a119'] = 0x2707;
 t['a118'] = 0x2708;
 t['a117'] = 0x2709;
 t['a11'] = 0x261B;
 t['a12'] = 0x261E;
 t['a13'] = 0x270C;
 t['a14'] = 0x270D;
 t['a15'] = 0x270E;
 t['a16'] = 0x270F;
 t['a105'] = 0x2710;
 t['a17'] = 0x2711;
 t['a18'] = 0x2712;
 t['a19'] = 0x2713;
 t['a20'] = 0x2714;
 t['a21'] = 0x2715;
 t['a22'] = 0x2716;
 t['a23'] = 0x2717;
 t['a24'] = 0x2718;
 t['a25'] = 0x2719;
 t['a26'] = 0x271A;
 t['a27'] = 0x271B;
 t['a28'] = 0x271C;
 t['a6'] = 0x271D;
 t['a7'] = 0x271E;
 t['a8'] = 0x271F;
 t['a9'] = 0x2720;
 t['a10'] = 0x2721;
 t['a29'] = 0x2722;
 t['a30'] = 0x2723;
 t['a31'] = 0x2724;
 t['a32'] = 0x2725;
 t['a33'] = 0x2726;
 t['a34'] = 0x2727;
 t['a35'] = 0x2605;
 t['a36'] = 0x2729;
 t['a37'] = 0x272A;
 t['a38'] = 0x272B;
 t['a39'] = 0x272C;
 t['a40'] = 0x272D;
 t['a41'] = 0x272E;
 t['a42'] = 0x272F;
 t['a43'] = 0x2730;
 t['a44'] = 0x2731;
 t['a45'] = 0x2732;
 t['a46'] = 0x2733;
 t['a47'] = 0x2734;
 t['a48'] = 0x2735;
 t['a49'] = 0x2736;
 t['a50'] = 0x2737;
 t['a51'] = 0x2738;
 t['a52'] = 0x2739;
 t['a53'] = 0x273A;
 t['a54'] = 0x273B;
 t['a55'] = 0x273C;
 t['a56'] = 0x273D;
 t['a57'] = 0x273E;
 t['a58'] = 0x273F;
 t['a59'] = 0x2740;
 t['a60'] = 0x2741;
 t['a61'] = 0x2742;
 t['a62'] = 0x2743;
 t['a63'] = 0x2744;
 t['a64'] = 0x2745;
 t['a65'] = 0x2746;
 t['a66'] = 0x2747;
 t['a67'] = 0x2748;
 t['a68'] = 0x2749;
 t['a69'] = 0x274A;
 t['a70'] = 0x274B;
 t['a71'] = 0x25CF;
 t['a72'] = 0x274D;
 t['a73'] = 0x25A0;
 t['a74'] = 0x274F;
 t['a203'] = 0x2750;
 t['a75'] = 0x2751;
 t['a204'] = 0x2752;
 t['a76'] = 0x25B2;
 t['a77'] = 0x25BC;
 t['a78'] = 0x25C6;
 t['a79'] = 0x2756;
 t['a81'] = 0x25D7;
 t['a82'] = 0x2758;
 t['a83'] = 0x2759;
 t['a84'] = 0x275A;
 t['a97'] = 0x275B;
 t['a98'] = 0x275C;
 t['a99'] = 0x275D;
 t['a100'] = 0x275E;
 t['a101'] = 0x2761;
 t['a102'] = 0x2762;
 t['a103'] = 0x2763;
 t['a104'] = 0x2764;
 t['a106'] = 0x2765;
 t['a107'] = 0x2766;
 t['a108'] = 0x2767;
 t['a112'] = 0x2663;
 t['a111'] = 0x2666;
 t['a110'] = 0x2665;
 t['a109'] = 0x2660;
 t['a120'] = 0x2460;
 t['a121'] = 0x2461;
 t['a122'] = 0x2462;
 t['a123'] = 0x2463;
 t['a124'] = 0x2464;
 t['a125'] = 0x2465;
 t['a126'] = 0x2466;
 t['a127'] = 0x2467;
 t['a128'] = 0x2468;
 t['a129'] = 0x2469;
 t['a130'] = 0x2776;
 t['a131'] = 0x2777;
 t['a132'] = 0x2778;
 t['a133'] = 0x2779;
 t['a134'] = 0x277A;
 t['a135'] = 0x277B;
 t['a136'] = 0x277C;
 t['a137'] = 0x277D;
 t['a138'] = 0x277E;
 t['a139'] = 0x277F;
 t['a140'] = 0x2780;
 t['a141'] = 0x2781;
 t['a142'] = 0x2782;
 t['a143'] = 0x2783;
 t['a144'] = 0x2784;
 t['a145'] = 0x2785;
 t['a146'] = 0x2786;
 t['a147'] = 0x2787;
 t['a148'] = 0x2788;
 t['a149'] = 0x2789;
 t['a150'] = 0x278A;
 t['a151'] = 0x278B;
 t['a152'] = 0x278C;
 t['a153'] = 0x278D;
 t['a154'] = 0x278E;
 t['a155'] = 0x278F;
 t['a156'] = 0x2790;
 t['a157'] = 0x2791;
 t['a158'] = 0x2792;
 t['a159'] = 0x2793;
 t['a160'] = 0x2794;
 t['a161'] = 0x2192;
 t['a163'] = 0x2194;
 t['a164'] = 0x2195;
 t['a196'] = 0x2798;
 t['a165'] = 0x2799;
 t['a192'] = 0x279A;
 t['a166'] = 0x279B;
 t['a167'] = 0x279C;
 t['a168'] = 0x279D;
 t['a169'] = 0x279E;
 t['a170'] = 0x279F;
 t['a171'] = 0x27A0;
 t['a172'] = 0x27A1;
 t['a173'] = 0x27A2;
 t['a162'] = 0x27A3;
 t['a174'] = 0x27A4;
 t['a175'] = 0x27A5;
 t['a176'] = 0x27A6;
 t['a177'] = 0x27A7;
 t['a178'] = 0x27A8;
 t['a179'] = 0x27A9;
 t['a193'] = 0x27AA;
 t['a180'] = 0x27AB;
 t['a199'] = 0x27AC;
 t['a181'] = 0x27AD;
 t['a200'] = 0x27AE;
 t['a182'] = 0x27AF;
 t['a201'] = 0x27B1;
 t['a183'] = 0x27B2;
 t['a184'] = 0x27B3;
 t['a197'] = 0x27B4;
 t['a185'] = 0x27B5;
 t['a194'] = 0x27B6;
 t['a198'] = 0x27B7;
 t['a186'] = 0x27B8;
 t['a195'] = 0x27B9;
 t['a187'] = 0x27BA;
 t['a188'] = 0x27BB;
 t['a189'] = 0x27BC;
 t['a190'] = 0x27BD;
 t['a191'] = 0x27BE;
 t['a89'] = 0x2768;
 t['a90'] = 0x2769;
 t['a93'] = 0x276A;
 t['a94'] = 0x276B;
 t['a91'] = 0x276C;
 t['a92'] = 0x276D;
 t['a205'] = 0x276E;
 t['a85'] = 0x276F;
 t['a206'] = 0x2770;
 t['a86'] = 0x2771;
 t['a87'] = 0x2772;
 t['a88'] = 0x2773;
 t['a95'] = 0x2774;
 t['a96'] = 0x2775;
 t['.notdef'] = 0x0000;
});
exports.getGlyphsUnicode = getGlyphsUnicode;
exports.getDingbatsGlyphsUnicode = getDingbatsGlyphsUnicode;

/***/ }),
/* 178 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSupplementalGlyphMapForCalibri = exports.getSupplementalGlyphMapForArialBlack = exports.getGlyphMapForStandardFonts = exports.getSymbolsFonts = exports.getSerifFonts = exports.getNonStdFontMap = exports.getStdFontMap = void 0;

var _util = __w_pdfjs_require__(6);

var getStdFontMap = (0, _util.getLookupTableFactory)(function (t) {
  t['ArialNarrow'] = 'Helvetica';
  t['ArialNarrow-Bold'] = 'Helvetica-Bold';
  t['ArialNarrow-BoldItalic'] = 'Helvetica-BoldOblique';
  t['ArialNarrow-Italic'] = 'Helvetica-Oblique';
  t['ArialBlack'] = 'Helvetica';
  t['ArialBlack-Bold'] = 'Helvetica-Bold';
  t['ArialBlack-BoldItalic'] = 'Helvetica-BoldOblique';
  t['ArialBlack-Italic'] = 'Helvetica-Oblique';
  t['Arial-Black'] = 'Helvetica';
  t['Arial-Black-Bold'] = 'Helvetica-Bold';
  t['Arial-Black-BoldItalic'] = 'Helvetica-BoldOblique';
  t['Arial-Black-Italic'] = 'Helvetica-Oblique';
  t['Arial'] = 'Helvetica';
  t['Arial-Bold'] = 'Helvetica-Bold';
  t['Arial-BoldItalic'] = 'Helvetica-BoldOblique';
  t['Arial-Italic'] = 'Helvetica-Oblique';
  t['Arial-BoldItalicMT'] = 'Helvetica-BoldOblique';
  t['Arial-BoldMT'] = 'Helvetica-Bold';
  t['Arial-ItalicMT'] = 'Helvetica-Oblique';
  t['ArialMT'] = 'Helvetica';
  t['Courier-Bold'] = 'Courier-Bold';
  t['Courier-BoldItalic'] = 'Courier-BoldOblique';
  t['Courier-Italic'] = 'Courier-Oblique';
  t['CourierNew'] = 'Courier';
  t['CourierNew-Bold'] = 'Courier-Bold';
  t['CourierNew-BoldItalic'] = 'Courier-BoldOblique';
  t['CourierNew-Italic'] = 'Courier-Oblique';
  t['CourierNewPS-BoldItalicMT'] = 'Courier-BoldOblique';
  t['CourierNewPS-BoldMT'] = 'Courier-Bold';
  t['CourierNewPS-ItalicMT'] = 'Courier-Oblique';
  t['CourierNewPSMT'] = 'Courier';
  t['Helvetica'] = 'Helvetica';
  t['Helvetica-Bold'] = 'Helvetica-Bold';
  t['Helvetica-BoldItalic'] = 'Helvetica-BoldOblique';
  t['Helvetica-BoldOblique'] = 'Helvetica-BoldOblique';
  t['Helvetica-Italic'] = 'Helvetica-Oblique';
  t['Helvetica-Oblique'] = 'Helvetica-Oblique';
  t['SegoeUISymbol'] = 'Helvetica';
  t['Symbol-Bold'] = 'Symbol';
  t['Symbol-BoldItalic'] = 'Symbol';
  t['Symbol-Italic'] = 'Symbol';
  t['TimesNewRoman'] = 'Times-Roman';
  t['TimesNewRoman-Bold'] = 'Times-Bold';
  t['TimesNewRoman-BoldItalic'] = 'Times-BoldItalic';
  t['TimesNewRoman-Italic'] = 'Times-Italic';
  t['TimesNewRomanPS'] = 'Times-Roman';
  t['TimesNewRomanPS-Bold'] = 'Times-Bold';
  t['TimesNewRomanPS-BoldItalic'] = 'Times-BoldItalic';
  t['TimesNewRomanPS-BoldItalicMT'] = 'Times-BoldItalic';
  t['TimesNewRomanPS-BoldMT'] = 'Times-Bold';
  t['TimesNewRomanPS-Italic'] = 'Times-Italic';
  t['TimesNewRomanPS-ItalicMT'] = 'Times-Italic';
  t['TimesNewRomanPSMT'] = 'Times-Roman';
  t['TimesNewRomanPSMT-Bold'] = 'Times-Bold';
  t['TimesNewRomanPSMT-BoldItalic'] = 'Times-BoldItalic';
  t['TimesNewRomanPSMT-Italic'] = 'Times-Italic';
});
exports.getStdFontMap = getStdFontMap;
var getNonStdFontMap = (0, _util.getLookupTableFactory)(function (t) {
  t['Calibri'] = 'Helvetica';
  t['Calibri-Bold'] = 'Helvetica-Bold';
  t['Calibri-BoldItalic'] = 'Helvetica-BoldOblique';
  t['Calibri-Italic'] = 'Helvetica-Oblique';
  t['CenturyGothic'] = 'Helvetica';
  t['CenturyGothic-Bold'] = 'Helvetica-Bold';
  t['CenturyGothic-BoldItalic'] = 'Helvetica-BoldOblique';
  t['CenturyGothic-Italic'] = 'Helvetica-Oblique';
  t['ComicSansMS'] = 'Comic Sans MS';
  t['ComicSansMS-Bold'] = 'Comic Sans MS-Bold';
  t['ComicSansMS-BoldItalic'] = 'Comic Sans MS-BoldItalic';
  t['ComicSansMS-Italic'] = 'Comic Sans MS-Italic';
  t['LucidaConsole'] = 'Courier';
  t['LucidaConsole-Bold'] = 'Courier-Bold';
  t['LucidaConsole-BoldItalic'] = 'Courier-BoldOblique';
  t['LucidaConsole-Italic'] = 'Courier-Oblique';
  t['LucidaSans-Demi'] = 'Helvetica-Bold';
  t['MS-Gothic'] = 'MS Gothic';
  t['MS-Gothic-Bold'] = 'MS Gothic-Bold';
  t['MS-Gothic-BoldItalic'] = 'MS Gothic-BoldItalic';
  t['MS-Gothic-Italic'] = 'MS Gothic-Italic';
  t['MS-Mincho'] = 'MS Mincho';
  t['MS-Mincho-Bold'] = 'MS Mincho-Bold';
  t['MS-Mincho-BoldItalic'] = 'MS Mincho-BoldItalic';
  t['MS-Mincho-Italic'] = 'MS Mincho-Italic';
  t['MS-PGothic'] = 'MS PGothic';
  t['MS-PGothic-Bold'] = 'MS PGothic-Bold';
  t['MS-PGothic-BoldItalic'] = 'MS PGothic-BoldItalic';
  t['MS-PGothic-Italic'] = 'MS PGothic-Italic';
  t['MS-PMincho'] = 'MS PMincho';
  t['MS-PMincho-Bold'] = 'MS PMincho-Bold';
  t['MS-PMincho-BoldItalic'] = 'MS PMincho-BoldItalic';
  t['MS-PMincho-Italic'] = 'MS PMincho-Italic';
  t['NuptialScript'] = 'Times-Italic';
  t['Wingdings'] = 'ZapfDingbats';
});
exports.getNonStdFontMap = getNonStdFontMap;
var getSerifFonts = (0, _util.getLookupTableFactory)(function (t) {
  t['Adobe Jenson'] = true;
  t['Adobe Text'] = true;
  t['Albertus'] = true;
  t['Aldus'] = true;
  t['Alexandria'] = true;
  t['Algerian'] = true;
  t['American Typewriter'] = true;
  t['Antiqua'] = true;
  t['Apex'] = true;
  t['Arno'] = true;
  t['Aster'] = true;
  t['Aurora'] = true;
  t['Baskerville'] = true;
  t['Bell'] = true;
  t['Bembo'] = true;
  t['Bembo Schoolbook'] = true;
  t['Benguiat'] = true;
  t['Berkeley Old Style'] = true;
  t['Bernhard Modern'] = true;
  t['Berthold City'] = true;
  t['Bodoni'] = true;
  t['Bauer Bodoni'] = true;
  t['Book Antiqua'] = true;
  t['Bookman'] = true;
  t['Bordeaux Roman'] = true;
  t['Californian FB'] = true;
  t['Calisto'] = true;
  t['Calvert'] = true;
  t['Capitals'] = true;
  t['Cambria'] = true;
  t['Cartier'] = true;
  t['Caslon'] = true;
  t['Catull'] = true;
  t['Centaur'] = true;
  t['Century Old Style'] = true;
  t['Century Schoolbook'] = true;
  t['Chaparral'] = true;
  t['Charis SIL'] = true;
  t['Cheltenham'] = true;
  t['Cholla Slab'] = true;
  t['Clarendon'] = true;
  t['Clearface'] = true;
  t['Cochin'] = true;
  t['Colonna'] = true;
  t['Computer Modern'] = true;
  t['Concrete Roman'] = true;
  t['Constantia'] = true;
  t['Cooper Black'] = true;
  t['Corona'] = true;
  t['Ecotype'] = true;
  t['Egyptienne'] = true;
  t['Elephant'] = true;
  t['Excelsior'] = true;
  t['Fairfield'] = true;
  t['FF Scala'] = true;
  t['Folkard'] = true;
  t['Footlight'] = true;
  t['FreeSerif'] = true;
  t['Friz Quadrata'] = true;
  t['Garamond'] = true;
  t['Gentium'] = true;
  t['Georgia'] = true;
  t['Gloucester'] = true;
  t['Goudy Old Style'] = true;
  t['Goudy Schoolbook'] = true;
  t['Goudy Pro Font'] = true;
  t['Granjon'] = true;
  t['Guardian Egyptian'] = true;
  t['Heather'] = true;
  t['Hercules'] = true;
  t['High Tower Text'] = true;
  t['Hiroshige'] = true;
  t['Hoefler Text'] = true;
  t['Humana Serif'] = true;
  t['Imprint'] = true;
  t['Ionic No. 5'] = true;
  t['Janson'] = true;
  t['Joanna'] = true;
  t['Korinna'] = true;
  t['Lexicon'] = true;
  t['Liberation Serif'] = true;
  t['Linux Libertine'] = true;
  t['Literaturnaya'] = true;
  t['Lucida'] = true;
  t['Lucida Bright'] = true;
  t['Melior'] = true;
  t['Memphis'] = true;
  t['Miller'] = true;
  t['Minion'] = true;
  t['Modern'] = true;
  t['Mona Lisa'] = true;
  t['Mrs Eaves'] = true;
  t['MS Serif'] = true;
  t['Museo Slab'] = true;
  t['New York'] = true;
  t['Nimbus Roman'] = true;
  t['NPS Rawlinson Roadway'] = true;
  t['NuptialScript'] = true;
  t['Palatino'] = true;
  t['Perpetua'] = true;
  t['Plantin'] = true;
  t['Plantin Schoolbook'] = true;
  t['Playbill'] = true;
  t['Poor Richard'] = true;
  t['Rawlinson Roadway'] = true;
  t['Renault'] = true;
  t['Requiem'] = true;
  t['Rockwell'] = true;
  t['Roman'] = true;
  t['Rotis Serif'] = true;
  t['Sabon'] = true;
  t['Scala'] = true;
  t['Seagull'] = true;
  t['Sistina'] = true;
  t['Souvenir'] = true;
  t['STIX'] = true;
  t['Stone Informal'] = true;
  t['Stone Serif'] = true;
  t['Sylfaen'] = true;
  t['Times'] = true;
  t['Trajan'] = true;
  t['Trinité'] = true;
  t['Trump Mediaeval'] = true;
  t['Utopia'] = true;
  t['Vale Type'] = true;
  t['Bitstream Vera'] = true;
  t['Vera Serif'] = true;
  t['Versailles'] = true;
  t['Wanted'] = true;
  t['Weiss'] = true;
  t['Wide Latin'] = true;
  t['Windsor'] = true;
  t['XITS'] = true;
});
exports.getSerifFonts = getSerifFonts;
var getSymbolsFonts = (0, _util.getLookupTableFactory)(function (t) {
  t['Dingbats'] = true;
  t['Symbol'] = true;
  t['ZapfDingbats'] = true;
});
exports.getSymbolsFonts = getSymbolsFonts;
var getGlyphMapForStandardFonts = (0, _util.getLookupTableFactory)(function (t) {
  t[2] = 10;
  t[3] = 32;
  t[4] = 33;
  t[5] = 34;
  t[6] = 35;
  t[7] = 36;
  t[8] = 37;
  t[9] = 38;
  t[10] = 39;
  t[11] = 40;
  t[12] = 41;
  t[13] = 42;
  t[14] = 43;
  t[15] = 44;
  t[16] = 45;
  t[17] = 46;
  t[18] = 47;
  t[19] = 48;
  t[20] = 49;
  t[21] = 50;
  t[22] = 51;
  t[23] = 52;
  t[24] = 53;
  t[25] = 54;
  t[26] = 55;
  t[27] = 56;
  t[28] = 57;
  t[29] = 58;
  t[30] = 894;
  t[31] = 60;
  t[32] = 61;
  t[33] = 62;
  t[34] = 63;
  t[35] = 64;
  t[36] = 65;
  t[37] = 66;
  t[38] = 67;
  t[39] = 68;
  t[40] = 69;
  t[41] = 70;
  t[42] = 71;
  t[43] = 72;
  t[44] = 73;
  t[45] = 74;
  t[46] = 75;
  t[47] = 76;
  t[48] = 77;
  t[49] = 78;
  t[50] = 79;
  t[51] = 80;
  t[52] = 81;
  t[53] = 82;
  t[54] = 83;
  t[55] = 84;
  t[56] = 85;
  t[57] = 86;
  t[58] = 87;
  t[59] = 88;
  t[60] = 89;
  t[61] = 90;
  t[62] = 91;
  t[63] = 92;
  t[64] = 93;
  t[65] = 94;
  t[66] = 95;
  t[67] = 96;
  t[68] = 97;
  t[69] = 98;
  t[70] = 99;
  t[71] = 100;
  t[72] = 101;
  t[73] = 102;
  t[74] = 103;
  t[75] = 104;
  t[76] = 105;
  t[77] = 106;
  t[78] = 107;
  t[79] = 108;
  t[80] = 109;
  t[81] = 110;
  t[82] = 111;
  t[83] = 112;
  t[84] = 113;
  t[85] = 114;
  t[86] = 115;
  t[87] = 116;
  t[88] = 117;
  t[89] = 118;
  t[90] = 119;
  t[91] = 120;
  t[92] = 121;
  t[93] = 122;
  t[94] = 123;
  t[95] = 124;
  t[96] = 125;
  t[97] = 126;
  t[98] = 196;
  t[99] = 197;
  t[100] = 199;
  t[101] = 201;
  t[102] = 209;
  t[103] = 214;
  t[104] = 220;
  t[105] = 225;
  t[106] = 224;
  t[107] = 226;
  t[108] = 228;
  t[109] = 227;
  t[110] = 229;
  t[111] = 231;
  t[112] = 233;
  t[113] = 232;
  t[114] = 234;
  t[115] = 235;
  t[116] = 237;
  t[117] = 236;
  t[118] = 238;
  t[119] = 239;
  t[120] = 241;
  t[121] = 243;
  t[122] = 242;
  t[123] = 244;
  t[124] = 246;
  t[125] = 245;
  t[126] = 250;
  t[127] = 249;
  t[128] = 251;
  t[129] = 252;
  t[130] = 8224;
  t[131] = 176;
  t[132] = 162;
  t[133] = 163;
  t[134] = 167;
  t[135] = 8226;
  t[136] = 182;
  t[137] = 223;
  t[138] = 174;
  t[139] = 169;
  t[140] = 8482;
  t[141] = 180;
  t[142] = 168;
  t[143] = 8800;
  t[144] = 198;
  t[145] = 216;
  t[146] = 8734;
  t[147] = 177;
  t[148] = 8804;
  t[149] = 8805;
  t[150] = 165;
  t[151] = 181;
  t[152] = 8706;
  t[153] = 8721;
  t[154] = 8719;
  t[156] = 8747;
  t[157] = 170;
  t[158] = 186;
  t[159] = 8486;
  t[160] = 230;
  t[161] = 248;
  t[162] = 191;
  t[163] = 161;
  t[164] = 172;
  t[165] = 8730;
  t[166] = 402;
  t[167] = 8776;
  t[168] = 8710;
  t[169] = 171;
  t[170] = 187;
  t[171] = 8230;
  t[210] = 218;
  t[223] = 711;
  t[224] = 321;
  t[225] = 322;
  t[227] = 353;
  t[229] = 382;
  t[234] = 253;
  t[252] = 263;
  t[253] = 268;
  t[254] = 269;
  t[258] = 258;
  t[260] = 260;
  t[261] = 261;
  t[265] = 280;
  t[266] = 281;
  t[268] = 283;
  t[269] = 313;
  t[275] = 323;
  t[276] = 324;
  t[278] = 328;
  t[284] = 345;
  t[285] = 346;
  t[286] = 347;
  t[292] = 367;
  t[295] = 377;
  t[296] = 378;
  t[298] = 380;
  t[305] = 963;
  t[306] = 964;
  t[307] = 966;
  t[308] = 8215;
  t[309] = 8252;
  t[310] = 8319;
  t[311] = 8359;
  t[312] = 8592;
  t[313] = 8593;
  t[337] = 9552;
  t[493] = 1039;
  t[494] = 1040;
  t[705] = 1524;
  t[706] = 8362;
  t[710] = 64288;
  t[711] = 64298;
  t[759] = 1617;
  t[761] = 1776;
  t[763] = 1778;
  t[775] = 1652;
  t[777] = 1764;
  t[778] = 1780;
  t[779] = 1781;
  t[780] = 1782;
  t[782] = 771;
  t[783] = 64726;
  t[786] = 8363;
  t[788] = 8532;
  t[790] = 768;
  t[791] = 769;
  t[792] = 768;
  t[795] = 803;
  t[797] = 64336;
  t[798] = 64337;
  t[799] = 64342;
  t[800] = 64343;
  t[801] = 64344;
  t[802] = 64345;
  t[803] = 64362;
  t[804] = 64363;
  t[805] = 64364;
  t[2424] = 7821;
  t[2425] = 7822;
  t[2426] = 7823;
  t[2427] = 7824;
  t[2428] = 7825;
  t[2429] = 7826;
  t[2430] = 7827;
  t[2433] = 7682;
  t[2678] = 8045;
  t[2679] = 8046;
  t[2830] = 1552;
  t[2838] = 686;
  t[2840] = 751;
  t[2842] = 753;
  t[2843] = 754;
  t[2844] = 755;
  t[2846] = 757;
  t[2856] = 767;
  t[2857] = 848;
  t[2858] = 849;
  t[2862] = 853;
  t[2863] = 854;
  t[2864] = 855;
  t[2865] = 861;
  t[2866] = 862;
  t[2906] = 7460;
  t[2908] = 7462;
  t[2909] = 7463;
  t[2910] = 7464;
  t[2912] = 7466;
  t[2913] = 7467;
  t[2914] = 7468;
  t[2916] = 7470;
  t[2917] = 7471;
  t[2918] = 7472;
  t[2920] = 7474;
  t[2921] = 7475;
  t[2922] = 7476;
  t[2924] = 7478;
  t[2925] = 7479;
  t[2926] = 7480;
  t[2928] = 7482;
  t[2929] = 7483;
  t[2930] = 7484;
  t[2932] = 7486;
  t[2933] = 7487;
  t[2934] = 7488;
  t[2936] = 7490;
  t[2937] = 7491;
  t[2938] = 7492;
  t[2940] = 7494;
  t[2941] = 7495;
  t[2942] = 7496;
  t[2944] = 7498;
  t[2946] = 7500;
  t[2948] = 7502;
  t[2950] = 7504;
  t[2951] = 7505;
  t[2952] = 7506;
  t[2954] = 7508;
  t[2955] = 7509;
  t[2956] = 7510;
  t[2958] = 7512;
  t[2959] = 7513;
  t[2960] = 7514;
  t[2962] = 7516;
  t[2963] = 7517;
  t[2964] = 7518;
  t[2966] = 7520;
  t[2967] = 7521;
  t[2968] = 7522;
  t[2970] = 7524;
  t[2971] = 7525;
  t[2972] = 7526;
  t[2974] = 7528;
  t[2975] = 7529;
  t[2976] = 7530;
  t[2978] = 1537;
  t[2979] = 1538;
  t[2980] = 1539;
  t[2982] = 1549;
  t[2983] = 1551;
  t[2984] = 1552;
  t[2986] = 1554;
  t[2987] = 1555;
  t[2988] = 1556;
  t[2990] = 1623;
  t[2991] = 1624;
  t[2995] = 1775;
  t[2999] = 1791;
  t[3002] = 64290;
  t[3003] = 64291;
  t[3004] = 64292;
  t[3006] = 64294;
  t[3007] = 64295;
  t[3008] = 64296;
  t[3011] = 1900;
  t[3014] = 8223;
  t[3015] = 8244;
  t[3017] = 7532;
  t[3018] = 7533;
  t[3019] = 7534;
  t[3075] = 7590;
  t[3076] = 7591;
  t[3079] = 7594;
  t[3080] = 7595;
  t[3083] = 7598;
  t[3084] = 7599;
  t[3087] = 7602;
  t[3088] = 7603;
  t[3091] = 7606;
  t[3092] = 7607;
  t[3095] = 7610;
  t[3096] = 7611;
  t[3099] = 7614;
  t[3100] = 7615;
  t[3103] = 7618;
  t[3104] = 7619;
  t[3107] = 8337;
  t[3108] = 8338;
  t[3116] = 1884;
  t[3119] = 1885;
  t[3120] = 1885;
  t[3123] = 1886;
  t[3124] = 1886;
  t[3127] = 1887;
  t[3128] = 1887;
  t[3131] = 1888;
  t[3132] = 1888;
  t[3135] = 1889;
  t[3136] = 1889;
  t[3139] = 1890;
  t[3140] = 1890;
  t[3143] = 1891;
  t[3144] = 1891;
  t[3147] = 1892;
  t[3148] = 1892;
  t[3153] = 580;
  t[3154] = 581;
  t[3157] = 584;
  t[3158] = 585;
  t[3161] = 588;
  t[3162] = 589;
  t[3165] = 891;
  t[3166] = 892;
  t[3169] = 1274;
  t[3170] = 1275;
  t[3173] = 1278;
  t[3174] = 1279;
  t[3181] = 7622;
  t[3182] = 7623;
  t[3282] = 11799;
  t[3316] = 578;
  t[3379] = 42785;
  t[3393] = 1159;
  t[3416] = 8377;
});
exports.getGlyphMapForStandardFonts = getGlyphMapForStandardFonts;
var getSupplementalGlyphMapForArialBlack = (0, _util.getLookupTableFactory)(function (t) {
  t[227] = 322;
  t[264] = 261;
  t[291] = 346;
});
exports.getSupplementalGlyphMapForArialBlack = getSupplementalGlyphMapForArialBlack;
var getSupplementalGlyphMapForCalibri = (0, _util.getLookupTableFactory)(function (t) {
  t[1] = 32;
  t[4] = 65;
  t[17] = 66;
  t[18] = 67;
  t[24] = 68;
  t[28] = 69;
  t[38] = 70;
  t[39] = 71;
  t[44] = 72;
  t[47] = 73;
  t[58] = 74;
  t[60] = 75;
  t[62] = 76;
  t[68] = 77;
  t[69] = 78;
  t[75] = 79;
  t[87] = 80;
  t[89] = 81;
  t[90] = 82;
  t[94] = 83;
  t[100] = 84;
  t[104] = 85;
  t[115] = 86;
  t[116] = 87;
  t[121] = 88;
  t[122] = 89;
  t[127] = 90;
  t[258] = 97;
  t[268] = 261;
  t[271] = 98;
  t[272] = 99;
  t[273] = 263;
  t[282] = 100;
  t[286] = 101;
  t[295] = 281;
  t[296] = 102;
  t[336] = 103;
  t[346] = 104;
  t[349] = 105;
  t[361] = 106;
  t[364] = 107;
  t[367] = 108;
  t[371] = 322;
  t[373] = 109;
  t[374] = 110;
  t[381] = 111;
  t[383] = 243;
  t[393] = 112;
  t[395] = 113;
  t[396] = 114;
  t[400] = 115;
  t[401] = 347;
  t[410] = 116;
  t[437] = 117;
  t[448] = 118;
  t[449] = 119;
  t[454] = 120;
  t[455] = 121;
  t[460] = 122;
  t[463] = 380;
  t[853] = 44;
  t[855] = 58;
  t[856] = 46;
  t[876] = 47;
  t[878] = 45;
  t[882] = 45;
  t[894] = 40;
  t[895] = 41;
  t[896] = 91;
  t[897] = 93;
  t[923] = 64;
  t[1004] = 48;
  t[1005] = 49;
  t[1006] = 50;
  t[1007] = 51;
  t[1008] = 52;
  t[1009] = 53;
  t[1010] = 54;
  t[1011] = 55;
  t[1012] = 56;
  t[1013] = 57;
  t[1081] = 37;
  t[1085] = 43;
  t[1086] = 45;
});
exports.getSupplementalGlyphMapForCalibri = getSupplementalGlyphMapForCalibri;

/***/ }),
/* 179 */
/***/ (function(module, exports, __w_pdfjs_require__) {

var getLookupTableFactory = __w_pdfjs_require__(6).getLookupTableFactory;
var getSpecialPUASymbols = getLookupTableFactory(function (t) {
 t[63721] = 0x00A9;
 t[63193] = 0x00A9;
 t[63720] = 0x00AE;
 t[63194] = 0x00AE;
 t[63722] = 0x2122;
 t[63195] = 0x2122;
 t[63729] = 0x23A7;
 t[63730] = 0x23A8;
 t[63731] = 0x23A9;
 t[63740] = 0x23AB;
 t[63741] = 0x23AC;
 t[63742] = 0x23AD;
 t[63726] = 0x23A1;
 t[63727] = 0x23A2;
 t[63728] = 0x23A3;
 t[63737] = 0x23A4;
 t[63738] = 0x23A5;
 t[63739] = 0x23A6;
 t[63723] = 0x239B;
 t[63724] = 0x239C;
 t[63725] = 0x239D;
 t[63734] = 0x239E;
 t[63735] = 0x239F;
 t[63736] = 0x23A0;
});
function mapSpecialUnicodeValues(code) {
 if (code >= 0xFFF0 && code <= 0xFFFF) {
  return 0;
 } else if (code >= 0xF600 && code <= 0xF8FF) {
  return getSpecialPUASymbols()[code] || code;
 } else if (code === 0x00AD) {
  return 0x002D;
 }
 return code;
}
function getUnicodeForGlyph(name, glyphsUnicodeMap) {
 var unicode = glyphsUnicodeMap[name];
 if (unicode !== undefined) {
  return unicode;
 }
 if (!name) {
  return -1;
 }
 if (name[0] === 'u') {
  var nameLen = name.length, hexStr;
  if (nameLen === 7 && name[1] === 'n' && name[2] === 'i') {
   hexStr = name.substring(3);
  } else if (nameLen >= 5 && nameLen <= 7) {
   hexStr = name.substring(1);
  } else {
   return -1;
  }
  if (hexStr === hexStr.toUpperCase()) {
   unicode = parseInt(hexStr, 16);
   if (unicode >= 0) {
    return unicode;
   }
  }
 }
 return -1;
}
var UnicodeRanges = [
 {
  'begin': 0x0000,
  'end': 0x007F
 },
 {
  'begin': 0x0080,
  'end': 0x00FF
 },
 {
  'begin': 0x0100,
  'end': 0x017F
 },
 {
  'begin': 0x0180,
  'end': 0x024F
 },
 {
  'begin': 0x0250,
  'end': 0x02AF
 },
 {
  'begin': 0x02B0,
  'end': 0x02FF
 },
 {
  'begin': 0x0300,
  'end': 0x036F
 },
 {
  'begin': 0x0370,
  'end': 0x03FF
 },
 {
  'begin': 0x2C80,
  'end': 0x2CFF
 },
 {
  'begin': 0x0400,
  'end': 0x04FF
 },
 {
  'begin': 0x0530,
  'end': 0x058F
 },
 {
  'begin': 0x0590,
  'end': 0x05FF
 },
 {
  'begin': 0xA500,
  'end': 0xA63F
 },
 {
  'begin': 0x0600,
  'end': 0x06FF
 },
 {
  'begin': 0x07C0,
  'end': 0x07FF
 },
 {
  'begin': 0x0900,
  'end': 0x097F
 },
 {
  'begin': 0x0980,
  'end': 0x09FF
 },
 {
  'begin': 0x0A00,
  'end': 0x0A7F
 },
 {
  'begin': 0x0A80,
  'end': 0x0AFF
 },
 {
  'begin': 0x0B00,
  'end': 0x0B7F
 },
 {
  'begin': 0x0B80,
  'end': 0x0BFF
 },
 {
  'begin': 0x0C00,
  'end': 0x0C7F
 },
 {
  'begin': 0x0C80,
  'end': 0x0CFF
 },
 {
  'begin': 0x0D00,
  'end': 0x0D7F
 },
 {
  'begin': 0x0E00,
  'end': 0x0E7F
 },
 {
  'begin': 0x0E80,
  'end': 0x0EFF
 },
 {
  'begin': 0x10A0,
  'end': 0x10FF
 },
 {
  'begin': 0x1B00,
  'end': 0x1B7F
 },
 {
  'begin': 0x1100,
  'end': 0x11FF
 },
 {
  'begin': 0x1E00,
  'end': 0x1EFF
 },
 {
  'begin': 0x1F00,
  'end': 0x1FFF
 },
 {
  'begin': 0x2000,
  'end': 0x206F
 },
 {
  'begin': 0x2070,
  'end': 0x209F
 },
 {
  'begin': 0x20A0,
  'end': 0x20CF
 },
 {
  'begin': 0x20D0,
  'end': 0x20FF
 },
 {
  'begin': 0x2100,
  'end': 0x214F
 },
 {
  'begin': 0x2150,
  'end': 0x218F
 },
 {
  'begin': 0x2190,
  'end': 0x21FF
 },
 {
  'begin': 0x2200,
  'end': 0x22FF
 },
 {
  'begin': 0x2300,
  'end': 0x23FF
 },
 {
  'begin': 0x2400,
  'end': 0x243F
 },
 {
  'begin': 0x2440,
  'end': 0x245F
 },
 {
  'begin': 0x2460,
  'end': 0x24FF
 },
 {
  'begin': 0x2500,
  'end': 0x257F
 },
 {
  'begin': 0x2580,
  'end': 0x259F
 },
 {
  'begin': 0x25A0,
  'end': 0x25FF
 },
 {
  'begin': 0x2600,
  'end': 0x26FF
 },
 {
  'begin': 0x2700,
  'end': 0x27BF
 },
 {
  'begin': 0x3000,
  'end': 0x303F
 },
 {
  'begin': 0x3040,
  'end': 0x309F
 },
 {
  'begin': 0x30A0,
  'end': 0x30FF
 },
 {
  'begin': 0x3100,
  'end': 0x312F
 },
 {
  'begin': 0x3130,
  'end': 0x318F
 },
 {
  'begin': 0xA840,
  'end': 0xA87F
 },
 {
  'begin': 0x3200,
  'end': 0x32FF
 },
 {
  'begin': 0x3300,
  'end': 0x33FF
 },
 {
  'begin': 0xAC00,
  'end': 0xD7AF
 },
 {
  'begin': 0xD800,
  'end': 0xDFFF
 },
 {
  'begin': 0x10900,
  'end': 0x1091F
 },
 {
  'begin': 0x4E00,
  'end': 0x9FFF
 },
 {
  'begin': 0xE000,
  'end': 0xF8FF
 },
 {
  'begin': 0x31C0,
  'end': 0x31EF
 },
 {
  'begin': 0xFB00,
  'end': 0xFB4F
 },
 {
  'begin': 0xFB50,
  'end': 0xFDFF
 },
 {
  'begin': 0xFE20,
  'end': 0xFE2F
 },
 {
  'begin': 0xFE10,
  'end': 0xFE1F
 },
 {
  'begin': 0xFE50,
  'end': 0xFE6F
 },
 {
  'begin': 0xFE70,
  'end': 0xFEFF
 },
 {
  'begin': 0xFF00,
  'end': 0xFFEF
 },
 {
  'begin': 0xFFF0,
  'end': 0xFFFF
 },
 {
  'begin': 0x0F00,
  'end': 0x0FFF
 },
 {
  'begin': 0x0700,
  'end': 0x074F
 },
 {
  'begin': 0x0780,
  'end': 0x07BF
 },
 {
  'begin': 0x0D80,
  'end': 0x0DFF
 },
 {
  'begin': 0x1000,
  'end': 0x109F
 },
 {
  'begin': 0x1200,
  'end': 0x137F
 },
 {
  'begin': 0x13A0,
  'end': 0x13FF
 },
 {
  'begin': 0x1400,
  'end': 0x167F
 },
 {
  'begin': 0x1680,
  'end': 0x169F
 },
 {
  'begin': 0x16A0,
  'end': 0x16FF
 },
 {
  'begin': 0x1780,
  'end': 0x17FF
 },
 {
  'begin': 0x1800,
  'end': 0x18AF
 },
 {
  'begin': 0x2800,
  'end': 0x28FF
 },
 {
  'begin': 0xA000,
  'end': 0xA48F
 },
 {
  'begin': 0x1700,
  'end': 0x171F
 },
 {
  'begin': 0x10300,
  'end': 0x1032F
 },
 {
  'begin': 0x10330,
  'end': 0x1034F
 },
 {
  'begin': 0x10400,
  'end': 0x1044F
 },
 {
  'begin': 0x1D000,
  'end': 0x1D0FF
 },
 {
  'begin': 0x1D400,
  'end': 0x1D7FF
 },
 {
  'begin': 0xFF000,
  'end': 0xFFFFD
 },
 {
  'begin': 0xFE00,
  'end': 0xFE0F
 },
 {
  'begin': 0xE0000,
  'end': 0xE007F
 },
 {
  'begin': 0x1900,
  'end': 0x194F
 },
 {
  'begin': 0x1950,
  'end': 0x197F
 },
 {
  'begin': 0x1980,
  'end': 0x19DF
 },
 {
  'begin': 0x1A00,
  'end': 0x1A1F
 },
 {
  'begin': 0x2C00,
  'end': 0x2C5F
 },
 {
  'begin': 0x2D30,
  'end': 0x2D7F
 },
 {
  'begin': 0x4DC0,
  'end': 0x4DFF
 },
 {
  'begin': 0xA800,
  'end': 0xA82F
 },
 {
  'begin': 0x10000,
  'end': 0x1007F
 },
 {
  'begin': 0x10140,
  'end': 0x1018F
 },
 {
  'begin': 0x10380,
  'end': 0x1039F
 },
 {
  'begin': 0x103A0,
  'end': 0x103DF
 },
 {
  'begin': 0x10450,
  'end': 0x1047F
 },
 {
  'begin': 0x10480,
  'end': 0x104AF
 },
 {
  'begin': 0x10800,
  'end': 0x1083F
 },
 {
  'begin': 0x10A00,
  'end': 0x10A5F
 },
 {
  'begin': 0x1D300,
  'end': 0x1D35F
 },
 {
  'begin': 0x12000,
  'end': 0x123FF
 },
 {
  'begin': 0x1D360,
  'end': 0x1D37F
 },
 {
  'begin': 0x1B80,
  'end': 0x1BBF
 },
 {
  'begin': 0x1C00,
  'end': 0x1C4F
 },
 {
  'begin': 0x1C50,
  'end': 0x1C7F
 },
 {
  'begin': 0xA880,
  'end': 0xA8DF
 },
 {
  'begin': 0xA900,
  'end': 0xA92F
 },
 {
  'begin': 0xA930,
  'end': 0xA95F
 },
 {
  'begin': 0xAA00,
  'end': 0xAA5F
 },
 {
  'begin': 0x10190,
  'end': 0x101CF
 },
 {
  'begin': 0x101D0,
  'end': 0x101FF
 },
 {
  'begin': 0x102A0,
  'end': 0x102DF
 },
 {
  'begin': 0x1F030,
  'end': 0x1F09F
 }
];
function getUnicodeRangeFor(value) {
 for (var i = 0, ii = UnicodeRanges.length; i < ii; i++) {
  var range = UnicodeRanges[i];
  if (value >= range.begin && value < range.end) {
   return i;
  }
 }
 return -1;
}
function isRTLRangeFor(value) {
 var range = UnicodeRanges[13];
 if (value >= range.begin && value < range.end) {
  return true;
 }
 range = UnicodeRanges[11];
 if (value >= range.begin && value < range.end) {
  return true;
 }
 return false;
}
var getNormalizedUnicodes = getLookupTableFactory(function (t) {
 t['\u00A8'] = '\u0020\u0308';
 t['\u00AF'] = '\u0020\u0304';
 t['\u00B4'] = '\u0020\u0301';
 t['\u00B5'] = '\u03BC';
 t['\u00B8'] = '\u0020\u0327';
 t['\u0132'] = '\u0049\u004A';
 t['\u0133'] = '\u0069\u006A';
 t['\u013F'] = '\u004C\u00B7';
 t['\u0140'] = '\u006C\u00B7';
 t['\u0149'] = '\u02BC\u006E';
 t['\u017F'] = '\u0073';
 t['\u01C4'] = '\u0044\u017D';
 t['\u01C5'] = '\u0044\u017E';
 t['\u01C6'] = '\u0064\u017E';
 t['\u01C7'] = '\u004C\u004A';
 t['\u01C8'] = '\u004C\u006A';
 t['\u01C9'] = '\u006C\u006A';
 t['\u01CA'] = '\u004E\u004A';
 t['\u01CB'] = '\u004E\u006A';
 t['\u01CC'] = '\u006E\u006A';
 t['\u01F1'] = '\u0044\u005A';
 t['\u01F2'] = '\u0044\u007A';
 t['\u01F3'] = '\u0064\u007A';
 t['\u02D8'] = '\u0020\u0306';
 t['\u02D9'] = '\u0020\u0307';
 t['\u02DA'] = '\u0020\u030A';
 t['\u02DB'] = '\u0020\u0328';
 t['\u02DC'] = '\u0020\u0303';
 t['\u02DD'] = '\u0020\u030B';
 t['\u037A'] = '\u0020\u0345';
 t['\u0384'] = '\u0020\u0301';
 t['\u03D0'] = '\u03B2';
 t['\u03D1'] = '\u03B8';
 t['\u03D2'] = '\u03A5';
 t['\u03D5'] = '\u03C6';
 t['\u03D6'] = '\u03C0';
 t['\u03F0'] = '\u03BA';
 t['\u03F1'] = '\u03C1';
 t['\u03F2'] = '\u03C2';
 t['\u03F4'] = '\u0398';
 t['\u03F5'] = '\u03B5';
 t['\u03F9'] = '\u03A3';
 t['\u0587'] = '\u0565\u0582';
 t['\u0675'] = '\u0627\u0674';
 t['\u0676'] = '\u0648\u0674';
 t['\u0677'] = '\u06C7\u0674';
 t['\u0678'] = '\u064A\u0674';
 t['\u0E33'] = '\u0E4D\u0E32';
 t['\u0EB3'] = '\u0ECD\u0EB2';
 t['\u0EDC'] = '\u0EAB\u0E99';
 t['\u0EDD'] = '\u0EAB\u0EA1';
 t['\u0F77'] = '\u0FB2\u0F81';
 t['\u0F79'] = '\u0FB3\u0F81';
 t['\u1E9A'] = '\u0061\u02BE';
 t['\u1FBD'] = '\u0020\u0313';
 t['\u1FBF'] = '\u0020\u0313';
 t['\u1FC0'] = '\u0020\u0342';
 t['\u1FFE'] = '\u0020\u0314';
 t['\u2002'] = '\u0020';
 t['\u2003'] = '\u0020';
 t['\u2004'] = '\u0020';
 t['\u2005'] = '\u0020';
 t['\u2006'] = '\u0020';
 t['\u2008'] = '\u0020';
 t['\u2009'] = '\u0020';
 t['\u200A'] = '\u0020';
 t['\u2017'] = '\u0020\u0333';
 t['\u2024'] = '\u002E';
 t['\u2025'] = '\u002E\u002E';
 t['\u2026'] = '\u002E\u002E\u002E';
 t['\u2033'] = '\u2032\u2032';
 t['\u2034'] = '\u2032\u2032\u2032';
 t['\u2036'] = '\u2035\u2035';
 t['\u2037'] = '\u2035\u2035\u2035';
 t['\u203C'] = '\u0021\u0021';
 t['\u203E'] = '\u0020\u0305';
 t['\u2047'] = '\u003F\u003F';
 t['\u2048'] = '\u003F\u0021';
 t['\u2049'] = '\u0021\u003F';
 t['\u2057'] = '\u2032\u2032\u2032\u2032';
 t['\u205F'] = '\u0020';
 t['\u20A8'] = '\u0052\u0073';
 t['\u2100'] = '\u0061\u002F\u0063';
 t['\u2101'] = '\u0061\u002F\u0073';
 t['\u2103'] = '\u00B0\u0043';
 t['\u2105'] = '\u0063\u002F\u006F';
 t['\u2106'] = '\u0063\u002F\u0075';
 t['\u2107'] = '\u0190';
 t['\u2109'] = '\u00B0\u0046';
 t['\u2116'] = '\u004E\u006F';
 t['\u2121'] = '\u0054\u0045\u004C';
 t['\u2135'] = '\u05D0';
 t['\u2136'] = '\u05D1';
 t['\u2137'] = '\u05D2';
 t['\u2138'] = '\u05D3';
 t['\u213B'] = '\u0046\u0041\u0058';
 t['\u2160'] = '\u0049';
 t['\u2161'] = '\u0049\u0049';
 t['\u2162'] = '\u0049\u0049\u0049';
 t['\u2163'] = '\u0049\u0056';
 t['\u2164'] = '\u0056';
 t['\u2165'] = '\u0056\u0049';
 t['\u2166'] = '\u0056\u0049\u0049';
 t['\u2167'] = '\u0056\u0049\u0049\u0049';
 t['\u2168'] = '\u0049\u0058';
 t['\u2169'] = '\u0058';
 t['\u216A'] = '\u0058\u0049';
 t['\u216B'] = '\u0058\u0049\u0049';
 t['\u216C'] = '\u004C';
 t['\u216D'] = '\u0043';
 t['\u216E'] = '\u0044';
 t['\u216F'] = '\u004D';
 t['\u2170'] = '\u0069';
 t['\u2171'] = '\u0069\u0069';
 t['\u2172'] = '\u0069\u0069\u0069';
 t['\u2173'] = '\u0069\u0076';
 t['\u2174'] = '\u0076';
 t['\u2175'] = '\u0076\u0069';
 t['\u2176'] = '\u0076\u0069\u0069';
 t['\u2177'] = '\u0076\u0069\u0069\u0069';
 t['\u2178'] = '\u0069\u0078';
 t['\u2179'] = '\u0078';
 t['\u217A'] = '\u0078\u0069';
 t['\u217B'] = '\u0078\u0069\u0069';
 t['\u217C'] = '\u006C';
 t['\u217D'] = '\u0063';
 t['\u217E'] = '\u0064';
 t['\u217F'] = '\u006D';
 t['\u222C'] = '\u222B\u222B';
 t['\u222D'] = '\u222B\u222B\u222B';
 t['\u222F'] = '\u222E\u222E';
 t['\u2230'] = '\u222E\u222E\u222E';
 t['\u2474'] = '\u0028\u0031\u0029';
 t['\u2475'] = '\u0028\u0032\u0029';
 t['\u2476'] = '\u0028\u0033\u0029';
 t['\u2477'] = '\u0028\u0034\u0029';
 t['\u2478'] = '\u0028\u0035\u0029';
 t['\u2479'] = '\u0028\u0036\u0029';
 t['\u247A'] = '\u0028\u0037\u0029';
 t['\u247B'] = '\u0028\u0038\u0029';
 t['\u247C'] = '\u0028\u0039\u0029';
 t['\u247D'] = '\u0028\u0031\u0030\u0029';
 t['\u247E'] = '\u0028\u0031\u0031\u0029';
 t['\u247F'] = '\u0028\u0031\u0032\u0029';
 t['\u2480'] = '\u0028\u0031\u0033\u0029';
 t['\u2481'] = '\u0028\u0031\u0034\u0029';
 t['\u2482'] = '\u0028\u0031\u0035\u0029';
 t['\u2483'] = '\u0028\u0031\u0036\u0029';
 t['\u2484'] = '\u0028\u0031\u0037\u0029';
 t['\u2485'] = '\u0028\u0031\u0038\u0029';
 t['\u2486'] = '\u0028\u0031\u0039\u0029';
 t['\u2487'] = '\u0028\u0032\u0030\u0029';
 t['\u2488'] = '\u0031\u002E';
 t['\u2489'] = '\u0032\u002E';
 t['\u248A'] = '\u0033\u002E';
 t['\u248B'] = '\u0034\u002E';
 t['\u248C'] = '\u0035\u002E';
 t['\u248D'] = '\u0036\u002E';
 t['\u248E'] = '\u0037\u002E';
 t['\u248F'] = '\u0038\u002E';
 t['\u2490'] = '\u0039\u002E';
 t['\u2491'] = '\u0031\u0030\u002E';
 t['\u2492'] = '\u0031\u0031\u002E';
 t['\u2493'] = '\u0031\u0032\u002E';
 t['\u2494'] = '\u0031\u0033\u002E';
 t['\u2495'] = '\u0031\u0034\u002E';
 t['\u2496'] = '\u0031\u0035\u002E';
 t['\u2497'] = '\u0031\u0036\u002E';
 t['\u2498'] = '\u0031\u0037\u002E';
 t['\u2499'] = '\u0031\u0038\u002E';
 t['\u249A'] = '\u0031\u0039\u002E';
 t['\u249B'] = '\u0032\u0030\u002E';
 t['\u249C'] = '\u0028\u0061\u0029';
 t['\u249D'] = '\u0028\u0062\u0029';
 t['\u249E'] = '\u0028\u0063\u0029';
 t['\u249F'] = '\u0028\u0064\u0029';
 t['\u24A0'] = '\u0028\u0065\u0029';
 t['\u24A1'] = '\u0028\u0066\u0029';
 t['\u24A2'] = '\u0028\u0067\u0029';
 t['\u24A3'] = '\u0028\u0068\u0029';
 t['\u24A4'] = '\u0028\u0069\u0029';
 t['\u24A5'] = '\u0028\u006A\u0029';
 t['\u24A6'] = '\u0028\u006B\u0029';
 t['\u24A7'] = '\u0028\u006C\u0029';
 t['\u24A8'] = '\u0028\u006D\u0029';
 t['\u24A9'] = '\u0028\u006E\u0029';
 t['\u24AA'] = '\u0028\u006F\u0029';
 t['\u24AB'] = '\u0028\u0070\u0029';
 t['\u24AC'] = '\u0028\u0071\u0029';
 t['\u24AD'] = '\u0028\u0072\u0029';
 t['\u24AE'] = '\u0028\u0073\u0029';
 t['\u24AF'] = '\u0028\u0074\u0029';
 t['\u24B0'] = '\u0028\u0075\u0029';
 t['\u24B1'] = '\u0028\u0076\u0029';
 t['\u24B2'] = '\u0028\u0077\u0029';
 t['\u24B3'] = '\u0028\u0078\u0029';
 t['\u24B4'] = '\u0028\u0079\u0029';
 t['\u24B5'] = '\u0028\u007A\u0029';
 t['\u2A0C'] = '\u222B\u222B\u222B\u222B';
 t['\u2A74'] = '\u003A\u003A\u003D';
 t['\u2A75'] = '\u003D\u003D';
 t['\u2A76'] = '\u003D\u003D\u003D';
 t['\u2E9F'] = '\u6BCD';
 t['\u2EF3'] = '\u9F9F';
 t['\u2F00'] = '\u4E00';
 t['\u2F01'] = '\u4E28';
 t['\u2F02'] = '\u4E36';
 t['\u2F03'] = '\u4E3F';
 t['\u2F04'] = '\u4E59';
 t['\u2F05'] = '\u4E85';
 t['\u2F06'] = '\u4E8C';
 t['\u2F07'] = '\u4EA0';
 t['\u2F08'] = '\u4EBA';
 t['\u2F09'] = '\u513F';
 t['\u2F0A'] = '\u5165';
 t['\u2F0B'] = '\u516B';
 t['\u2F0C'] = '\u5182';
 t['\u2F0D'] = '\u5196';
 t['\u2F0E'] = '\u51AB';
 t['\u2F0F'] = '\u51E0';
 t['\u2F10'] = '\u51F5';
 t['\u2F11'] = '\u5200';
 t['\u2F12'] = '\u529B';
 t['\u2F13'] = '\u52F9';
 t['\u2F14'] = '\u5315';
 t['\u2F15'] = '\u531A';
 t['\u2F16'] = '\u5338';
 t['\u2F17'] = '\u5341';
 t['\u2F18'] = '\u535C';
 t['\u2F19'] = '\u5369';
 t['\u2F1A'] = '\u5382';
 t['\u2F1B'] = '\u53B6';
 t['\u2F1C'] = '\u53C8';
 t['\u2F1D'] = '\u53E3';
 t['\u2F1E'] = '\u56D7';
 t['\u2F1F'] = '\u571F';
 t['\u2F20'] = '\u58EB';
 t['\u2F21'] = '\u5902';
 t['\u2F22'] = '\u590A';
 t['\u2F23'] = '\u5915';
 t['\u2F24'] = '\u5927';
 t['\u2F25'] = '\u5973';
 t['\u2F26'] = '\u5B50';
 t['\u2F27'] = '\u5B80';
 t['\u2F28'] = '\u5BF8';
 t['\u2F29'] = '\u5C0F';
 t['\u2F2A'] = '\u5C22';
 t['\u2F2B'] = '\u5C38';
 t['\u2F2C'] = '\u5C6E';
 t['\u2F2D'] = '\u5C71';
 t['\u2F2E'] = '\u5DDB';
 t['\u2F2F'] = '\u5DE5';
 t['\u2F30'] = '\u5DF1';
 t['\u2F31'] = '\u5DFE';
 t['\u2F32'] = '\u5E72';
 t['\u2F33'] = '\u5E7A';
 t['\u2F34'] = '\u5E7F';
 t['\u2F35'] = '\u5EF4';
 t['\u2F36'] = '\u5EFE';
 t['\u2F37'] = '\u5F0B';
 t['\u2F38'] = '\u5F13';
 t['\u2F39'] = '\u5F50';
 t['\u2F3A'] = '\u5F61';
 t['\u2F3B'] = '\u5F73';
 t['\u2F3C'] = '\u5FC3';
 t['\u2F3D'] = '\u6208';
 t['\u2F3E'] = '\u6236';
 t['\u2F3F'] = '\u624B';
 t['\u2F40'] = '\u652F';
 t['\u2F41'] = '\u6534';
 t['\u2F42'] = '\u6587';
 t['\u2F43'] = '\u6597';
 t['\u2F44'] = '\u65A4';
 t['\u2F45'] = '\u65B9';
 t['\u2F46'] = '\u65E0';
 t['\u2F47'] = '\u65E5';
 t['\u2F48'] = '\u66F0';
 t['\u2F49'] = '\u6708';
 t['\u2F4A'] = '\u6728';
 t['\u2F4B'] = '\u6B20';
 t['\u2F4C'] = '\u6B62';
 t['\u2F4D'] = '\u6B79';
 t['\u2F4E'] = '\u6BB3';
 t['\u2F4F'] = '\u6BCB';
 t['\u2F50'] = '\u6BD4';
 t['\u2F51'] = '\u6BDB';
 t['\u2F52'] = '\u6C0F';
 t['\u2F53'] = '\u6C14';
 t['\u2F54'] = '\u6C34';
 t['\u2F55'] = '\u706B';
 t['\u2F56'] = '\u722A';
 t['\u2F57'] = '\u7236';
 t['\u2F58'] = '\u723B';
 t['\u2F59'] = '\u723F';
 t['\u2F5A'] = '\u7247';
 t['\u2F5B'] = '\u7259';
 t['\u2F5C'] = '\u725B';
 t['\u2F5D'] = '\u72AC';
 t['\u2F5E'] = '\u7384';
 t['\u2F5F'] = '\u7389';
 t['\u2F60'] = '\u74DC';
 t['\u2F61'] = '\u74E6';
 t['\u2F62'] = '\u7518';
 t['\u2F63'] = '\u751F';
 t['\u2F64'] = '\u7528';
 t['\u2F65'] = '\u7530';
 t['\u2F66'] = '\u758B';
 t['\u2F67'] = '\u7592';
 t['\u2F68'] = '\u7676';
 t['\u2F69'] = '\u767D';
 t['\u2F6A'] = '\u76AE';
 t['\u2F6B'] = '\u76BF';
 t['\u2F6C'] = '\u76EE';
 t['\u2F6D'] = '\u77DB';
 t['\u2F6E'] = '\u77E2';
 t['\u2F6F'] = '\u77F3';
 t['\u2F70'] = '\u793A';
 t['\u2F71'] = '\u79B8';
 t['\u2F72'] = '\u79BE';
 t['\u2F73'] = '\u7A74';
 t['\u2F74'] = '\u7ACB';
 t['\u2F75'] = '\u7AF9';
 t['\u2F76'] = '\u7C73';
 t['\u2F77'] = '\u7CF8';
 t['\u2F78'] = '\u7F36';
 t['\u2F79'] = '\u7F51';
 t['\u2F7A'] = '\u7F8A';
 t['\u2F7B'] = '\u7FBD';
 t['\u2F7C'] = '\u8001';
 t['\u2F7D'] = '\u800C';
 t['\u2F7E'] = '\u8012';
 t['\u2F7F'] = '\u8033';
 t['\u2F80'] = '\u807F';
 t['\u2F81'] = '\u8089';
 t['\u2F82'] = '\u81E3';
 t['\u2F83'] = '\u81EA';
 t['\u2F84'] = '\u81F3';
 t['\u2F85'] = '\u81FC';
 t['\u2F86'] = '\u820C';
 t['\u2F87'] = '\u821B';
 t['\u2F88'] = '\u821F';
 t['\u2F89'] = '\u826E';
 t['\u2F8A'] = '\u8272';
 t['\u2F8B'] = '\u8278';
 t['\u2F8C'] = '\u864D';
 t['\u2F8D'] = '\u866B';
 t['\u2F8E'] = '\u8840';
 t['\u2F8F'] = '\u884C';
 t['\u2F90'] = '\u8863';
 t['\u2F91'] = '\u897E';
 t['\u2F92'] = '\u898B';
 t['\u2F93'] = '\u89D2';
 t['\u2F94'] = '\u8A00';
 t['\u2F95'] = '\u8C37';
 t['\u2F96'] = '\u8C46';
 t['\u2F97'] = '\u8C55';
 t['\u2F98'] = '\u8C78';
 t['\u2F99'] = '\u8C9D';
 t['\u2F9A'] = '\u8D64';
 t['\u2F9B'] = '\u8D70';
 t['\u2F9C'] = '\u8DB3';
 t['\u2F9D'] = '\u8EAB';
 t['\u2F9E'] = '\u8ECA';
 t['\u2F9F'] = '\u8F9B';
 t['\u2FA0'] = '\u8FB0';
 t['\u2FA1'] = '\u8FB5';
 t['\u2FA2'] = '\u9091';
 t['\u2FA3'] = '\u9149';
 t['\u2FA4'] = '\u91C6';
 t['\u2FA5'] = '\u91CC';
 t['\u2FA6'] = '\u91D1';
 t['\u2FA7'] = '\u9577';
 t['\u2FA8'] = '\u9580';
 t['\u2FA9'] = '\u961C';
 t['\u2FAA'] = '\u96B6';
 t['\u2FAB'] = '\u96B9';
 t['\u2FAC'] = '\u96E8';
 t['\u2FAD'] = '\u9751';
 t['\u2FAE'] = '\u975E';
 t['\u2FAF'] = '\u9762';
 t['\u2FB0'] = '\u9769';
 t['\u2FB1'] = '\u97CB';
 t['\u2FB2'] = '\u97ED';
 t['\u2FB3'] = '\u97F3';
 t['\u2FB4'] = '\u9801';
 t['\u2FB5'] = '\u98A8';
 t['\u2FB6'] = '\u98DB';
 t['\u2FB7'] = '\u98DF';
 t['\u2FB8'] = '\u9996';
 t['\u2FB9'] = '\u9999';
 t['\u2FBA'] = '\u99AC';
 t['\u2FBB'] = '\u9AA8';
 t['\u2FBC'] = '\u9AD8';
 t['\u2FBD'] = '\u9ADF';
 t['\u2FBE'] = '\u9B25';
 t['\u2FBF'] = '\u9B2F';
 t['\u2FC0'] = '\u9B32';
 t['\u2FC1'] = '\u9B3C';
 t['\u2FC2'] = '\u9B5A';
 t['\u2FC3'] = '\u9CE5';
 t['\u2FC4'] = '\u9E75';
 t['\u2FC5'] = '\u9E7F';
 t['\u2FC6'] = '\u9EA5';
 t['\u2FC7'] = '\u9EBB';
 t['\u2FC8'] = '\u9EC3';
 t['\u2FC9'] = '\u9ECD';
 t['\u2FCA'] = '\u9ED1';
 t['\u2FCB'] = '\u9EF9';
 t['\u2FCC'] = '\u9EFD';
 t['\u2FCD'] = '\u9F0E';
 t['\u2FCE'] = '\u9F13';
 t['\u2FCF'] = '\u9F20';
 t['\u2FD0'] = '\u9F3B';
 t['\u2FD1'] = '\u9F4A';
 t['\u2FD2'] = '\u9F52';
 t['\u2FD3'] = '\u9F8D';
 t['\u2FD4'] = '\u9F9C';
 t['\u2FD5'] = '\u9FA0';
 t['\u3036'] = '\u3012';
 t['\u3038'] = '\u5341';
 t['\u3039'] = '\u5344';
 t['\u303A'] = '\u5345';
 t['\u309B'] = '\u0020\u3099';
 t['\u309C'] = '\u0020\u309A';
 t['\u3131'] = '\u1100';
 t['\u3132'] = '\u1101';
 t['\u3133'] = '\u11AA';
 t['\u3134'] = '\u1102';
 t['\u3135'] = '\u11AC';
 t['\u3136'] = '\u11AD';
 t['\u3137'] = '\u1103';
 t['\u3138'] = '\u1104';
 t['\u3139'] = '\u1105';
 t['\u313A'] = '\u11B0';
 t['\u313B'] = '\u11B1';
 t['\u313C'] = '\u11B2';
 t['\u313D'] = '\u11B3';
 t['\u313E'] = '\u11B4';
 t['\u313F'] = '\u11B5';
 t['\u3140'] = '\u111A';
 t['\u3141'] = '\u1106';
 t['\u3142'] = '\u1107';
 t['\u3143'] = '\u1108';
 t['\u3144'] = '\u1121';
 t['\u3145'] = '\u1109';
 t['\u3146'] = '\u110A';
 t['\u3147'] = '\u110B';
 t['\u3148'] = '\u110C';
 t['\u3149'] = '\u110D';
 t['\u314A'] = '\u110E';
 t['\u314B'] = '\u110F';
 t['\u314C'] = '\u1110';
 t['\u314D'] = '\u1111';
 t['\u314E'] = '\u1112';
 t['\u314F'] = '\u1161';
 t['\u3150'] = '\u1162';
 t['\u3151'] = '\u1163';
 t['\u3152'] = '\u1164';
 t['\u3153'] = '\u1165';
 t['\u3154'] = '\u1166';
 t['\u3155'] = '\u1167';
 t['\u3156'] = '\u1168';
 t['\u3157'] = '\u1169';
 t['\u3158'] = '\u116A';
 t['\u3159'] = '\u116B';
 t['\u315A'] = '\u116C';
 t['\u315B'] = '\u116D';
 t['\u315C'] = '\u116E';
 t['\u315D'] = '\u116F';
 t['\u315E'] = '\u1170';
 t['\u315F'] = '\u1171';
 t['\u3160'] = '\u1172';
 t['\u3161'] = '\u1173';
 t['\u3162'] = '\u1174';
 t['\u3163'] = '\u1175';
 t['\u3164'] = '\u1160';
 t['\u3165'] = '\u1114';
 t['\u3166'] = '\u1115';
 t['\u3167'] = '\u11C7';
 t['\u3168'] = '\u11C8';
 t['\u3169'] = '\u11CC';
 t['\u316A'] = '\u11CE';
 t['\u316B'] = '\u11D3';
 t['\u316C'] = '\u11D7';
 t['\u316D'] = '\u11D9';
 t['\u316E'] = '\u111C';
 t['\u316F'] = '\u11DD';
 t['\u3170'] = '\u11DF';
 t['\u3171'] = '\u111D';
 t['\u3172'] = '\u111E';
 t['\u3173'] = '\u1120';
 t['\u3174'] = '\u1122';
 t['\u3175'] = '\u1123';
 t['\u3176'] = '\u1127';
 t['\u3177'] = '\u1129';
 t['\u3178'] = '\u112B';
 t['\u3179'] = '\u112C';
 t['\u317A'] = '\u112D';
 t['\u317B'] = '\u112E';
 t['\u317C'] = '\u112F';
 t['\u317D'] = '\u1132';
 t['\u317E'] = '\u1136';
 t['\u317F'] = '\u1140';
 t['\u3180'] = '\u1147';
 t['\u3181'] = '\u114C';
 t['\u3182'] = '\u11F1';
 t['\u3183'] = '\u11F2';
 t['\u3184'] = '\u1157';
 t['\u3185'] = '\u1158';
 t['\u3186'] = '\u1159';
 t['\u3187'] = '\u1184';
 t['\u3188'] = '\u1185';
 t['\u3189'] = '\u1188';
 t['\u318A'] = '\u1191';
 t['\u318B'] = '\u1192';
 t['\u318C'] = '\u1194';
 t['\u318D'] = '\u119E';
 t['\u318E'] = '\u11A1';
 t['\u3200'] = '\u0028\u1100\u0029';
 t['\u3201'] = '\u0028\u1102\u0029';
 t['\u3202'] = '\u0028\u1103\u0029';
 t['\u3203'] = '\u0028\u1105\u0029';
 t['\u3204'] = '\u0028\u1106\u0029';
 t['\u3205'] = '\u0028\u1107\u0029';
 t['\u3206'] = '\u0028\u1109\u0029';
 t['\u3207'] = '\u0028\u110B\u0029';
 t['\u3208'] = '\u0028\u110C\u0029';
 t['\u3209'] = '\u0028\u110E\u0029';
 t['\u320A'] = '\u0028\u110F\u0029';
 t['\u320B'] = '\u0028\u1110\u0029';
 t['\u320C'] = '\u0028\u1111\u0029';
 t['\u320D'] = '\u0028\u1112\u0029';
 t['\u320E'] = '\u0028\u1100\u1161\u0029';
 t['\u320F'] = '\u0028\u1102\u1161\u0029';
 t['\u3210'] = '\u0028\u1103\u1161\u0029';
 t['\u3211'] = '\u0028\u1105\u1161\u0029';
 t['\u3212'] = '\u0028\u1106\u1161\u0029';
 t['\u3213'] = '\u0028\u1107\u1161\u0029';
 t['\u3214'] = '\u0028\u1109\u1161\u0029';
 t['\u3215'] = '\u0028\u110B\u1161\u0029';
 t['\u3216'] = '\u0028\u110C\u1161\u0029';
 t['\u3217'] = '\u0028\u110E\u1161\u0029';
 t['\u3218'] = '\u0028\u110F\u1161\u0029';
 t['\u3219'] = '\u0028\u1110\u1161\u0029';
 t['\u321A'] = '\u0028\u1111\u1161\u0029';
 t['\u321B'] = '\u0028\u1112\u1161\u0029';
 t['\u321C'] = '\u0028\u110C\u116E\u0029';
 t['\u321D'] = '\u0028\u110B\u1169\u110C\u1165\u11AB\u0029';
 t['\u321E'] = '\u0028\u110B\u1169\u1112\u116E\u0029';
 t['\u3220'] = '\u0028\u4E00\u0029';
 t['\u3221'] = '\u0028\u4E8C\u0029';
 t['\u3222'] = '\u0028\u4E09\u0029';
 t['\u3223'] = '\u0028\u56DB\u0029';
 t['\u3224'] = '\u0028\u4E94\u0029';
 t['\u3225'] = '\u0028\u516D\u0029';
 t['\u3226'] = '\u0028\u4E03\u0029';
 t['\u3227'] = '\u0028\u516B\u0029';
 t['\u3228'] = '\u0028\u4E5D\u0029';
 t['\u3229'] = '\u0028\u5341\u0029';
 t['\u322A'] = '\u0028\u6708\u0029';
 t['\u322B'] = '\u0028\u706B\u0029';
 t['\u322C'] = '\u0028\u6C34\u0029';
 t['\u322D'] = '\u0028\u6728\u0029';
 t['\u322E'] = '\u0028\u91D1\u0029';
 t['\u322F'] = '\u0028\u571F\u0029';
 t['\u3230'] = '\u0028\u65E5\u0029';
 t['\u3231'] = '\u0028\u682A\u0029';
 t['\u3232'] = '\u0028\u6709\u0029';
 t['\u3233'] = '\u0028\u793E\u0029';
 t['\u3234'] = '\u0028\u540D\u0029';
 t['\u3235'] = '\u0028\u7279\u0029';
 t['\u3236'] = '\u0028\u8CA1\u0029';
 t['\u3237'] = '\u0028\u795D\u0029';
 t['\u3238'] = '\u0028\u52B4\u0029';
 t['\u3239'] = '\u0028\u4EE3\u0029';
 t['\u323A'] = '\u0028\u547C\u0029';
 t['\u323B'] = '\u0028\u5B66\u0029';
 t['\u323C'] = '\u0028\u76E3\u0029';
 t['\u323D'] = '\u0028\u4F01\u0029';
 t['\u323E'] = '\u0028\u8CC7\u0029';
 t['\u323F'] = '\u0028\u5354\u0029';
 t['\u3240'] = '\u0028\u796D\u0029';
 t['\u3241'] = '\u0028\u4F11\u0029';
 t['\u3242'] = '\u0028\u81EA\u0029';
 t['\u3243'] = '\u0028\u81F3\u0029';
 t['\u32C0'] = '\u0031\u6708';
 t['\u32C1'] = '\u0032\u6708';
 t['\u32C2'] = '\u0033\u6708';
 t['\u32C3'] = '\u0034\u6708';
 t['\u32C4'] = '\u0035\u6708';
 t['\u32C5'] = '\u0036\u6708';
 t['\u32C6'] = '\u0037\u6708';
 t['\u32C7'] = '\u0038\u6708';
 t['\u32C8'] = '\u0039\u6708';
 t['\u32C9'] = '\u0031\u0030\u6708';
 t['\u32CA'] = '\u0031\u0031\u6708';
 t['\u32CB'] = '\u0031\u0032\u6708';
 t['\u3358'] = '\u0030\u70B9';
 t['\u3359'] = '\u0031\u70B9';
 t['\u335A'] = '\u0032\u70B9';
 t['\u335B'] = '\u0033\u70B9';
 t['\u335C'] = '\u0034\u70B9';
 t['\u335D'] = '\u0035\u70B9';
 t['\u335E'] = '\u0036\u70B9';
 t['\u335F'] = '\u0037\u70B9';
 t['\u3360'] = '\u0038\u70B9';
 t['\u3361'] = '\u0039\u70B9';
 t['\u3362'] = '\u0031\u0030\u70B9';
 t['\u3363'] = '\u0031\u0031\u70B9';
 t['\u3364'] = '\u0031\u0032\u70B9';
 t['\u3365'] = '\u0031\u0033\u70B9';
 t['\u3366'] = '\u0031\u0034\u70B9';
 t['\u3367'] = '\u0031\u0035\u70B9';
 t['\u3368'] = '\u0031\u0036\u70B9';
 t['\u3369'] = '\u0031\u0037\u70B9';
 t['\u336A'] = '\u0031\u0038\u70B9';
 t['\u336B'] = '\u0031\u0039\u70B9';
 t['\u336C'] = '\u0032\u0030\u70B9';
 t['\u336D'] = '\u0032\u0031\u70B9';
 t['\u336E'] = '\u0032\u0032\u70B9';
 t['\u336F'] = '\u0032\u0033\u70B9';
 t['\u3370'] = '\u0032\u0034\u70B9';
 t['\u33E0'] = '\u0031\u65E5';
 t['\u33E1'] = '\u0032\u65E5';
 t['\u33E2'] = '\u0033\u65E5';
 t['\u33E3'] = '\u0034\u65E5';
 t['\u33E4'] = '\u0035\u65E5';
 t['\u33E5'] = '\u0036\u65E5';
 t['\u33E6'] = '\u0037\u65E5';
 t['\u33E7'] = '\u0038\u65E5';
 t['\u33E8'] = '\u0039\u65E5';
 t['\u33E9'] = '\u0031\u0030\u65E5';
 t['\u33EA'] = '\u0031\u0031\u65E5';
 t['\u33EB'] = '\u0031\u0032\u65E5';
 t['\u33EC'] = '\u0031\u0033\u65E5';
 t['\u33ED'] = '\u0031\u0034\u65E5';
 t['\u33EE'] = '\u0031\u0035\u65E5';
 t['\u33EF'] = '\u0031\u0036\u65E5';
 t['\u33F0'] = '\u0031\u0037\u65E5';
 t['\u33F1'] = '\u0031\u0038\u65E5';
 t['\u33F2'] = '\u0031\u0039\u65E5';
 t['\u33F3'] = '\u0032\u0030\u65E5';
 t['\u33F4'] = '\u0032\u0031\u65E5';
 t['\u33F5'] = '\u0032\u0032\u65E5';
 t['\u33F6'] = '\u0032\u0033\u65E5';
 t['\u33F7'] = '\u0032\u0034\u65E5';
 t['\u33F8'] = '\u0032\u0035\u65E5';
 t['\u33F9'] = '\u0032\u0036\u65E5';
 t['\u33FA'] = '\u0032\u0037\u65E5';
 t['\u33FB'] = '\u0032\u0038\u65E5';
 t['\u33FC'] = '\u0032\u0039\u65E5';
 t['\u33FD'] = '\u0033\u0030\u65E5';
 t['\u33FE'] = '\u0033\u0031\u65E5';
 t['\uFB00'] = '\u0066\u0066';
 t['\uFB01'] = '\u0066\u0069';
 t['\uFB02'] = '\u0066\u006C';
 t['\uFB03'] = '\u0066\u0066\u0069';
 t['\uFB04'] = '\u0066\u0066\u006C';
 t['\uFB05'] = '\u017F\u0074';
 t['\uFB06'] = '\u0073\u0074';
 t['\uFB13'] = '\u0574\u0576';
 t['\uFB14'] = '\u0574\u0565';
 t['\uFB15'] = '\u0574\u056B';
 t['\uFB16'] = '\u057E\u0576';
 t['\uFB17'] = '\u0574\u056D';
 t['\uFB4F'] = '\u05D0\u05DC';
 t['\uFB50'] = '\u0671';
 t['\uFB51'] = '\u0671';
 t['\uFB52'] = '\u067B';
 t['\uFB53'] = '\u067B';
 t['\uFB54'] = '\u067B';
 t['\uFB55'] = '\u067B';
 t['\uFB56'] = '\u067E';
 t['\uFB57'] = '\u067E';
 t['\uFB58'] = '\u067E';
 t['\uFB59'] = '\u067E';
 t['\uFB5A'] = '\u0680';
 t['\uFB5B'] = '\u0680';
 t['\uFB5C'] = '\u0680';
 t['\uFB5D'] = '\u0680';
 t['\uFB5E'] = '\u067A';
 t['\uFB5F'] = '\u067A';
 t['\uFB60'] = '\u067A';
 t['\uFB61'] = '\u067A';
 t['\uFB62'] = '\u067F';
 t['\uFB63'] = '\u067F';
 t['\uFB64'] = '\u067F';
 t['\uFB65'] = '\u067F';
 t['\uFB66'] = '\u0679';
 t['\uFB67'] = '\u0679';
 t['\uFB68'] = '\u0679';
 t['\uFB69'] = '\u0679';
 t['\uFB6A'] = '\u06A4';
 t['\uFB6B'] = '\u06A4';
 t['\uFB6C'] = '\u06A4';
 t['\uFB6D'] = '\u06A4';
 t['\uFB6E'] = '\u06A6';
 t['\uFB6F'] = '\u06A6';
 t['\uFB70'] = '\u06A6';
 t['\uFB71'] = '\u06A6';
 t['\uFB72'] = '\u0684';
 t['\uFB73'] = '\u0684';
 t['\uFB74'] = '\u0684';
 t['\uFB75'] = '\u0684';
 t['\uFB76'] = '\u0683';
 t['\uFB77'] = '\u0683';
 t['\uFB78'] = '\u0683';
 t['\uFB79'] = '\u0683';
 t['\uFB7A'] = '\u0686';
 t['\uFB7B'] = '\u0686';
 t['\uFB7C'] = '\u0686';
 t['\uFB7D'] = '\u0686';
 t['\uFB7E'] = '\u0687';
 t['\uFB7F'] = '\u0687';
 t['\uFB80'] = '\u0687';
 t['\uFB81'] = '\u0687';
 t['\uFB82'] = '\u068D';
 t['\uFB83'] = '\u068D';
 t['\uFB84'] = '\u068C';
 t['\uFB85'] = '\u068C';
 t['\uFB86'] = '\u068E';
 t['\uFB87'] = '\u068E';
 t['\uFB88'] = '\u0688';
 t['\uFB89'] = '\u0688';
 t['\uFB8A'] = '\u0698';
 t['\uFB8B'] = '\u0698';
 t['\uFB8C'] = '\u0691';
 t['\uFB8D'] = '\u0691';
 t['\uFB8E'] = '\u06A9';
 t['\uFB8F'] = '\u06A9';
 t['\uFB90'] = '\u06A9';
 t['\uFB91'] = '\u06A9';
 t['\uFB92'] = '\u06AF';
 t['\uFB93'] = '\u06AF';
 t['\uFB94'] = '\u06AF';
 t['\uFB95'] = '\u06AF';
 t['\uFB96'] = '\u06B3';
 t['\uFB97'] = '\u06B3';
 t['\uFB98'] = '\u06B3';
 t['\uFB99'] = '\u06B3';
 t['\uFB9A'] = '\u06B1';
 t['\uFB9B'] = '\u06B1';
 t['\uFB9C'] = '\u06B1';
 t['\uFB9D'] = '\u06B1';
 t['\uFB9E'] = '\u06BA';
 t['\uFB9F'] = '\u06BA';
 t['\uFBA0'] = '\u06BB';
 t['\uFBA1'] = '\u06BB';
 t['\uFBA2'] = '\u06BB';
 t['\uFBA3'] = '\u06BB';
 t['\uFBA4'] = '\u06C0';
 t['\uFBA5'] = '\u06C0';
 t['\uFBA6'] = '\u06C1';
 t['\uFBA7'] = '\u06C1';
 t['\uFBA8'] = '\u06C1';
 t['\uFBA9'] = '\u06C1';
 t['\uFBAA'] = '\u06BE';
 t['\uFBAB'] = '\u06BE';
 t['\uFBAC'] = '\u06BE';
 t['\uFBAD'] = '\u06BE';
 t['\uFBAE'] = '\u06D2';
 t['\uFBAF'] = '\u06D2';
 t['\uFBB0'] = '\u06D3';
 t['\uFBB1'] = '\u06D3';
 t['\uFBD3'] = '\u06AD';
 t['\uFBD4'] = '\u06AD';
 t['\uFBD5'] = '\u06AD';
 t['\uFBD6'] = '\u06AD';
 t['\uFBD7'] = '\u06C7';
 t['\uFBD8'] = '\u06C7';
 t['\uFBD9'] = '\u06C6';
 t['\uFBDA'] = '\u06C6';
 t['\uFBDB'] = '\u06C8';
 t['\uFBDC'] = '\u06C8';
 t['\uFBDD'] = '\u0677';
 t['\uFBDE'] = '\u06CB';
 t['\uFBDF'] = '\u06CB';
 t['\uFBE0'] = '\u06C5';
 t['\uFBE1'] = '\u06C5';
 t['\uFBE2'] = '\u06C9';
 t['\uFBE3'] = '\u06C9';
 t['\uFBE4'] = '\u06D0';
 t['\uFBE5'] = '\u06D0';
 t['\uFBE6'] = '\u06D0';
 t['\uFBE7'] = '\u06D0';
 t['\uFBE8'] = '\u0649';
 t['\uFBE9'] = '\u0649';
 t['\uFBEA'] = '\u0626\u0627';
 t['\uFBEB'] = '\u0626\u0627';
 t['\uFBEC'] = '\u0626\u06D5';
 t['\uFBED'] = '\u0626\u06D5';
 t['\uFBEE'] = '\u0626\u0648';
 t['\uFBEF'] = '\u0626\u0648';
 t['\uFBF0'] = '\u0626\u06C7';
 t['\uFBF1'] = '\u0626\u06C7';
 t['\uFBF2'] = '\u0626\u06C6';
 t['\uFBF3'] = '\u0626\u06C6';
 t['\uFBF4'] = '\u0626\u06C8';
 t['\uFBF5'] = '\u0626\u06C8';
 t['\uFBF6'] = '\u0626\u06D0';
 t['\uFBF7'] = '\u0626\u06D0';
 t['\uFBF8'] = '\u0626\u06D0';
 t['\uFBF9'] = '\u0626\u0649';
 t['\uFBFA'] = '\u0626\u0649';
 t['\uFBFB'] = '\u0626\u0649';
 t['\uFBFC'] = '\u06CC';
 t['\uFBFD'] = '\u06CC';
 t['\uFBFE'] = '\u06CC';
 t['\uFBFF'] = '\u06CC';
 t['\uFC00'] = '\u0626\u062C';
 t['\uFC01'] = '\u0626\u062D';
 t['\uFC02'] = '\u0626\u0645';
 t['\uFC03'] = '\u0626\u0649';
 t['\uFC04'] = '\u0626\u064A';
 t['\uFC05'] = '\u0628\u062C';
 t['\uFC06'] = '\u0628\u062D';
 t['\uFC07'] = '\u0628\u062E';
 t['\uFC08'] = '\u0628\u0645';
 t['\uFC09'] = '\u0628\u0649';
 t['\uFC0A'] = '\u0628\u064A';
 t['\uFC0B'] = '\u062A\u062C';
 t['\uFC0C'] = '\u062A\u062D';
 t['\uFC0D'] = '\u062A\u062E';
 t['\uFC0E'] = '\u062A\u0645';
 t['\uFC0F'] = '\u062A\u0649';
 t['\uFC10'] = '\u062A\u064A';
 t['\uFC11'] = '\u062B\u062C';
 t['\uFC12'] = '\u062B\u0645';
 t['\uFC13'] = '\u062B\u0649';
 t['\uFC14'] = '\u062B\u064A';
 t['\uFC15'] = '\u062C\u062D';
 t['\uFC16'] = '\u062C\u0645';
 t['\uFC17'] = '\u062D\u062C';
 t['\uFC18'] = '\u062D\u0645';
 t['\uFC19'] = '\u062E\u062C';
 t['\uFC1A'] = '\u062E\u062D';
 t['\uFC1B'] = '\u062E\u0645';
 t['\uFC1C'] = '\u0633\u062C';
 t['\uFC1D'] = '\u0633\u062D';
 t['\uFC1E'] = '\u0633\u062E';
 t['\uFC1F'] = '\u0633\u0645';
 t['\uFC20'] = '\u0635\u062D';
 t['\uFC21'] = '\u0635\u0645';
 t['\uFC22'] = '\u0636\u062C';
 t['\uFC23'] = '\u0636\u062D';
 t['\uFC24'] = '\u0636\u062E';
 t['\uFC25'] = '\u0636\u0645';
 t['\uFC26'] = '\u0637\u062D';
 t['\uFC27'] = '\u0637\u0645';
 t['\uFC28'] = '\u0638\u0645';
 t['\uFC29'] = '\u0639\u062C';
 t['\uFC2A'] = '\u0639\u0645';
 t['\uFC2B'] = '\u063A\u062C';
 t['\uFC2C'] = '\u063A\u0645';
 t['\uFC2D'] = '\u0641\u062C';
 t['\uFC2E'] = '\u0641\u062D';
 t['\uFC2F'] = '\u0641\u062E';
 t['\uFC30'] = '\u0641\u0645';
 t['\uFC31'] = '\u0641\u0649';
 t['\uFC32'] = '\u0641\u064A';
 t['\uFC33'] = '\u0642\u062D';
 t['\uFC34'] = '\u0642\u0645';
 t['\uFC35'] = '\u0642\u0649';
 t['\uFC36'] = '\u0642\u064A';
 t['\uFC37'] = '\u0643\u0627';
 t['\uFC38'] = '\u0643\u062C';
 t['\uFC39'] = '\u0643\u062D';
 t['\uFC3A'] = '\u0643\u062E';
 t['\uFC3B'] = '\u0643\u0644';
 t['\uFC3C'] = '\u0643\u0645';
 t['\uFC3D'] = '\u0643\u0649';
 t['\uFC3E'] = '\u0643\u064A';
 t['\uFC3F'] = '\u0644\u062C';
 t['\uFC40'] = '\u0644\u062D';
 t['\uFC41'] = '\u0644\u062E';
 t['\uFC42'] = '\u0644\u0645';
 t['\uFC43'] = '\u0644\u0649';
 t['\uFC44'] = '\u0644\u064A';
 t['\uFC45'] = '\u0645\u062C';
 t['\uFC46'] = '\u0645\u062D';
 t['\uFC47'] = '\u0645\u062E';
 t['\uFC48'] = '\u0645\u0645';
 t['\uFC49'] = '\u0645\u0649';
 t['\uFC4A'] = '\u0645\u064A';
 t['\uFC4B'] = '\u0646\u062C';
 t['\uFC4C'] = '\u0646\u062D';
 t['\uFC4D'] = '\u0646\u062E';
 t['\uFC4E'] = '\u0646\u0645';
 t['\uFC4F'] = '\u0646\u0649';
 t['\uFC50'] = '\u0646\u064A';
 t['\uFC51'] = '\u0647\u062C';
 t['\uFC52'] = '\u0647\u0645';
 t['\uFC53'] = '\u0647\u0649';
 t['\uFC54'] = '\u0647\u064A';
 t['\uFC55'] = '\u064A\u062C';
 t['\uFC56'] = '\u064A\u062D';
 t['\uFC57'] = '\u064A\u062E';
 t['\uFC58'] = '\u064A\u0645';
 t['\uFC59'] = '\u064A\u0649';
 t['\uFC5A'] = '\u064A\u064A';
 t['\uFC5B'] = '\u0630\u0670';
 t['\uFC5C'] = '\u0631\u0670';
 t['\uFC5D'] = '\u0649\u0670';
 t['\uFC5E'] = '\u0020\u064C\u0651';
 t['\uFC5F'] = '\u0020\u064D\u0651';
 t['\uFC60'] = '\u0020\u064E\u0651';
 t['\uFC61'] = '\u0020\u064F\u0651';
 t['\uFC62'] = '\u0020\u0650\u0651';
 t['\uFC63'] = '\u0020\u0651\u0670';
 t['\uFC64'] = '\u0626\u0631';
 t['\uFC65'] = '\u0626\u0632';
 t['\uFC66'] = '\u0626\u0645';
 t['\uFC67'] = '\u0626\u0646';
 t['\uFC68'] = '\u0626\u0649';
 t['\uFC69'] = '\u0626\u064A';
 t['\uFC6A'] = '\u0628\u0631';
 t['\uFC6B'] = '\u0628\u0632';
 t['\uFC6C'] = '\u0628\u0645';
 t['\uFC6D'] = '\u0628\u0646';
 t['\uFC6E'] = '\u0628\u0649';
 t['\uFC6F'] = '\u0628\u064A';
 t['\uFC70'] = '\u062A\u0631';
 t['\uFC71'] = '\u062A\u0632';
 t['\uFC72'] = '\u062A\u0645';
 t['\uFC73'] = '\u062A\u0646';
 t['\uFC74'] = '\u062A\u0649';
 t['\uFC75'] = '\u062A\u064A';
 t['\uFC76'] = '\u062B\u0631';
 t['\uFC77'] = '\u062B\u0632';
 t['\uFC78'] = '\u062B\u0645';
 t['\uFC79'] = '\u062B\u0646';
 t['\uFC7A'] = '\u062B\u0649';
 t['\uFC7B'] = '\u062B\u064A';
 t['\uFC7C'] = '\u0641\u0649';
 t['\uFC7D'] = '\u0641\u064A';
 t['\uFC7E'] = '\u0642\u0649';
 t['\uFC7F'] = '\u0642\u064A';
 t['\uFC80'] = '\u0643\u0627';
 t['\uFC81'] = '\u0643\u0644';
 t['\uFC82'] = '\u0643\u0645';
 t['\uFC83'] = '\u0643\u0649';
 t['\uFC84'] = '\u0643\u064A';
 t['\uFC85'] = '\u0644\u0645';
 t['\uFC86'] = '\u0644\u0649';
 t['\uFC87'] = '\u0644\u064A';
 t['\uFC88'] = '\u0645\u0627';
 t['\uFC89'] = '\u0645\u0645';
 t['\uFC8A'] = '\u0646\u0631';
 t['\uFC8B'] = '\u0646\u0632';
 t['\uFC8C'] = '\u0646\u0645';
 t['\uFC8D'] = '\u0646\u0646';
 t['\uFC8E'] = '\u0646\u0649';
 t['\uFC8F'] = '\u0646\u064A';
 t['\uFC90'] = '\u0649\u0670';
 t['\uFC91'] = '\u064A\u0631';
 t['\uFC92'] = '\u064A\u0632';
 t['\uFC93'] = '\u064A\u0645';
 t['\uFC94'] = '\u064A\u0646';
 t['\uFC95'] = '\u064A\u0649';
 t['\uFC96'] = '\u064A\u064A';
 t['\uFC97'] = '\u0626\u062C';
 t['\uFC98'] = '\u0626\u062D';
 t['\uFC99'] = '\u0626\u062E';
 t['\uFC9A'] = '\u0626\u0645';
 t['\uFC9B'] = '\u0626\u0647';
 t['\uFC9C'] = '\u0628\u062C';
 t['\uFC9D'] = '\u0628\u062D';
 t['\uFC9E'] = '\u0628\u062E';
 t['\uFC9F'] = '\u0628\u0645';
 t['\uFCA0'] = '\u0628\u0647';
 t['\uFCA1'] = '\u062A\u062C';
 t['\uFCA2'] = '\u062A\u062D';
 t['\uFCA3'] = '\u062A\u062E';
 t['\uFCA4'] = '\u062A\u0645';
 t['\uFCA5'] = '\u062A\u0647';
 t['\uFCA6'] = '\u062B\u0645';
 t['\uFCA7'] = '\u062C\u062D';
 t['\uFCA8'] = '\u062C\u0645';
 t['\uFCA9'] = '\u062D\u062C';
 t['\uFCAA'] = '\u062D\u0645';
 t['\uFCAB'] = '\u062E\u062C';
 t['\uFCAC'] = '\u062E\u0645';
 t['\uFCAD'] = '\u0633\u062C';
 t['\uFCAE'] = '\u0633\u062D';
 t['\uFCAF'] = '\u0633\u062E';
 t['\uFCB0'] = '\u0633\u0645';
 t['\uFCB1'] = '\u0635\u062D';
 t['\uFCB2'] = '\u0635\u062E';
 t['\uFCB3'] = '\u0635\u0645';
 t['\uFCB4'] = '\u0636\u062C';
 t['\uFCB5'] = '\u0636\u062D';
 t['\uFCB6'] = '\u0636\u062E';
 t['\uFCB7'] = '\u0636\u0645';
 t['\uFCB8'] = '\u0637\u062D';
 t['\uFCB9'] = '\u0638\u0645';
 t['\uFCBA'] = '\u0639\u062C';
 t['\uFCBB'] = '\u0639\u0645';
 t['\uFCBC'] = '\u063A\u062C';
 t['\uFCBD'] = '\u063A\u0645';
 t['\uFCBE'] = '\u0641\u062C';
 t['\uFCBF'] = '\u0641\u062D';
 t['\uFCC0'] = '\u0641\u062E';
 t['\uFCC1'] = '\u0641\u0645';
 t['\uFCC2'] = '\u0642\u062D';
 t['\uFCC3'] = '\u0642\u0645';
 t['\uFCC4'] = '\u0643\u062C';
 t['\uFCC5'] = '\u0643\u062D';
 t['\uFCC6'] = '\u0643\u062E';
 t['\uFCC7'] = '\u0643\u0644';
 t['\uFCC8'] = '\u0643\u0645';
 t['\uFCC9'] = '\u0644\u062C';
 t['\uFCCA'] = '\u0644\u062D';
 t['\uFCCB'] = '\u0644\u062E';
 t['\uFCCC'] = '\u0644\u0645';
 t['\uFCCD'] = '\u0644\u0647';
 t['\uFCCE'] = '\u0645\u062C';
 t['\uFCCF'] = '\u0645\u062D';
 t['\uFCD0'] = '\u0645\u062E';
 t['\uFCD1'] = '\u0645\u0645';
 t['\uFCD2'] = '\u0646\u062C';
 t['\uFCD3'] = '\u0646\u062D';
 t['\uFCD4'] = '\u0646\u062E';
 t['\uFCD5'] = '\u0646\u0645';
 t['\uFCD6'] = '\u0646\u0647';
 t['\uFCD7'] = '\u0647\u062C';
 t['\uFCD8'] = '\u0647\u0645';
 t['\uFCD9'] = '\u0647\u0670';
 t['\uFCDA'] = '\u064A\u062C';
 t['\uFCDB'] = '\u064A\u062D';
 t['\uFCDC'] = '\u064A\u062E';
 t['\uFCDD'] = '\u064A\u0645';
 t['\uFCDE'] = '\u064A\u0647';
 t['\uFCDF'] = '\u0626\u0645';
 t['\uFCE0'] = '\u0626\u0647';
 t['\uFCE1'] = '\u0628\u0645';
 t['\uFCE2'] = '\u0628\u0647';
 t['\uFCE3'] = '\u062A\u0645';
 t['\uFCE4'] = '\u062A\u0647';
 t['\uFCE5'] = '\u062B\u0645';
 t['\uFCE6'] = '\u062B\u0647';
 t['\uFCE7'] = '\u0633\u0645';
 t['\uFCE8'] = '\u0633\u0647';
 t['\uFCE9'] = '\u0634\u0645';
 t['\uFCEA'] = '\u0634\u0647';
 t['\uFCEB'] = '\u0643\u0644';
 t['\uFCEC'] = '\u0643\u0645';
 t['\uFCED'] = '\u0644\u0645';
 t['\uFCEE'] = '\u0646\u0645';
 t['\uFCEF'] = '\u0646\u0647';
 t['\uFCF0'] = '\u064A\u0645';
 t['\uFCF1'] = '\u064A\u0647';
 t['\uFCF2'] = '\u0640\u064E\u0651';
 t['\uFCF3'] = '\u0640\u064F\u0651';
 t['\uFCF4'] = '\u0640\u0650\u0651';
 t['\uFCF5'] = '\u0637\u0649';
 t['\uFCF6'] = '\u0637\u064A';
 t['\uFCF7'] = '\u0639\u0649';
 t['\uFCF8'] = '\u0639\u064A';
 t['\uFCF9'] = '\u063A\u0649';
 t['\uFCFA'] = '\u063A\u064A';
 t['\uFCFB'] = '\u0633\u0649';
 t['\uFCFC'] = '\u0633\u064A';
 t['\uFCFD'] = '\u0634\u0649';
 t['\uFCFE'] = '\u0634\u064A';
 t['\uFCFF'] = '\u062D\u0649';
 t['\uFD00'] = '\u062D\u064A';
 t['\uFD01'] = '\u062C\u0649';
 t['\uFD02'] = '\u062C\u064A';
 t['\uFD03'] = '\u062E\u0649';
 t['\uFD04'] = '\u062E\u064A';
 t['\uFD05'] = '\u0635\u0649';
 t['\uFD06'] = '\u0635\u064A';
 t['\uFD07'] = '\u0636\u0649';
 t['\uFD08'] = '\u0636\u064A';
 t['\uFD09'] = '\u0634\u062C';
 t['\uFD0A'] = '\u0634\u062D';
 t['\uFD0B'] = '\u0634\u062E';
 t['\uFD0C'] = '\u0634\u0645';
 t['\uFD0D'] = '\u0634\u0631';
 t['\uFD0E'] = '\u0633\u0631';
 t['\uFD0F'] = '\u0635\u0631';
 t['\uFD10'] = '\u0636\u0631';
 t['\uFD11'] = '\u0637\u0649';
 t['\uFD12'] = '\u0637\u064A';
 t['\uFD13'] = '\u0639\u0649';
 t['\uFD14'] = '\u0639\u064A';
 t['\uFD15'] = '\u063A\u0649';
 t['\uFD16'] = '\u063A\u064A';
 t['\uFD17'] = '\u0633\u0649';
 t['\uFD18'] = '\u0633\u064A';
 t['\uFD19'] = '\u0634\u0649';
 t['\uFD1A'] = '\u0634\u064A';
 t['\uFD1B'] = '\u062D\u0649';
 t['\uFD1C'] = '\u062D\u064A';
 t['\uFD1D'] = '\u062C\u0649';
 t['\uFD1E'] = '\u062C\u064A';
 t['\uFD1F'] = '\u062E\u0649';
 t['\uFD20'] = '\u062E\u064A';
 t['\uFD21'] = '\u0635\u0649';
 t['\uFD22'] = '\u0635\u064A';
 t['\uFD23'] = '\u0636\u0649';
 t['\uFD24'] = '\u0636\u064A';
 t['\uFD25'] = '\u0634\u062C';
 t['\uFD26'] = '\u0634\u062D';
 t['\uFD27'] = '\u0634\u062E';
 t['\uFD28'] = '\u0634\u0645';
 t['\uFD29'] = '\u0634\u0631';
 t['\uFD2A'] = '\u0633\u0631';
 t['\uFD2B'] = '\u0635\u0631';
 t['\uFD2C'] = '\u0636\u0631';
 t['\uFD2D'] = '\u0634\u062C';
 t['\uFD2E'] = '\u0634\u062D';
 t['\uFD2F'] = '\u0634\u062E';
 t['\uFD30'] = '\u0634\u0645';
 t['\uFD31'] = '\u0633\u0647';
 t['\uFD32'] = '\u0634\u0647';
 t['\uFD33'] = '\u0637\u0645';
 t['\uFD34'] = '\u0633\u062C';
 t['\uFD35'] = '\u0633\u062D';
 t['\uFD36'] = '\u0633\u062E';
 t['\uFD37'] = '\u0634\u062C';
 t['\uFD38'] = '\u0634\u062D';
 t['\uFD39'] = '\u0634\u062E';
 t['\uFD3A'] = '\u0637\u0645';
 t['\uFD3B'] = '\u0638\u0645';
 t['\uFD3C'] = '\u0627\u064B';
 t['\uFD3D'] = '\u0627\u064B';
 t['\uFD50'] = '\u062A\u062C\u0645';
 t['\uFD51'] = '\u062A\u062D\u062C';
 t['\uFD52'] = '\u062A\u062D\u062C';
 t['\uFD53'] = '\u062A\u062D\u0645';
 t['\uFD54'] = '\u062A\u062E\u0645';
 t['\uFD55'] = '\u062A\u0645\u062C';
 t['\uFD56'] = '\u062A\u0645\u062D';
 t['\uFD57'] = '\u062A\u0645\u062E';
 t['\uFD58'] = '\u062C\u0645\u062D';
 t['\uFD59'] = '\u062C\u0645\u062D';
 t['\uFD5A'] = '\u062D\u0645\u064A';
 t['\uFD5B'] = '\u062D\u0645\u0649';
 t['\uFD5C'] = '\u0633\u062D\u062C';
 t['\uFD5D'] = '\u0633\u062C\u062D';
 t['\uFD5E'] = '\u0633\u062C\u0649';
 t['\uFD5F'] = '\u0633\u0645\u062D';
 t['\uFD60'] = '\u0633\u0645\u062D';
 t['\uFD61'] = '\u0633\u0645\u062C';
 t['\uFD62'] = '\u0633\u0645\u0645';
 t['\uFD63'] = '\u0633\u0645\u0645';
 t['\uFD64'] = '\u0635\u062D\u062D';
 t['\uFD65'] = '\u0635\u062D\u062D';
 t['\uFD66'] = '\u0635\u0645\u0645';
 t['\uFD67'] = '\u0634\u062D\u0645';
 t['\uFD68'] = '\u0634\u062D\u0645';
 t['\uFD69'] = '\u0634\u062C\u064A';
 t['\uFD6A'] = '\u0634\u0645\u062E';
 t['\uFD6B'] = '\u0634\u0645\u062E';
 t['\uFD6C'] = '\u0634\u0645\u0645';
 t['\uFD6D'] = '\u0634\u0645\u0645';
 t['\uFD6E'] = '\u0636\u062D\u0649';
 t['\uFD6F'] = '\u0636\u062E\u0645';
 t['\uFD70'] = '\u0636\u062E\u0645';
 t['\uFD71'] = '\u0637\u0645\u062D';
 t['\uFD72'] = '\u0637\u0645\u062D';
 t['\uFD73'] = '\u0637\u0645\u0645';
 t['\uFD74'] = '\u0637\u0645\u064A';
 t['\uFD75'] = '\u0639\u062C\u0645';
 t['\uFD76'] = '\u0639\u0645\u0645';
 t['\uFD77'] = '\u0639\u0645\u0645';
 t['\uFD78'] = '\u0639\u0645\u0649';
 t['\uFD79'] = '\u063A\u0645\u0645';
 t['\uFD7A'] = '\u063A\u0645\u064A';
 t['\uFD7B'] = '\u063A\u0645\u0649';
 t['\uFD7C'] = '\u0641\u062E\u0645';
 t['\uFD7D'] = '\u0641\u062E\u0645';
 t['\uFD7E'] = '\u0642\u0645\u062D';
 t['\uFD7F'] = '\u0642\u0645\u0645';
 t['\uFD80'] = '\u0644\u062D\u0645';
 t['\uFD81'] = '\u0644\u062D\u064A';
 t['\uFD82'] = '\u0644\u062D\u0649';
 t['\uFD83'] = '\u0644\u062C\u062C';
 t['\uFD84'] = '\u0644\u062C\u062C';
 t['\uFD85'] = '\u0644\u062E\u0645';
 t['\uFD86'] = '\u0644\u062E\u0645';
 t['\uFD87'] = '\u0644\u0645\u062D';
 t['\uFD88'] = '\u0644\u0645\u062D';
 t['\uFD89'] = '\u0645\u062D\u062C';
 t['\uFD8A'] = '\u0645\u062D\u0645';
 t['\uFD8B'] = '\u0645\u062D\u064A';
 t['\uFD8C'] = '\u0645\u062C\u062D';
 t['\uFD8D'] = '\u0645\u062C\u0645';
 t['\uFD8E'] = '\u0645\u062E\u062C';
 t['\uFD8F'] = '\u0645\u062E\u0645';
 t['\uFD92'] = '\u0645\u062C\u062E';
 t['\uFD93'] = '\u0647\u0645\u062C';
 t['\uFD94'] = '\u0647\u0645\u0645';
 t['\uFD95'] = '\u0646\u062D\u0645';
 t['\uFD96'] = '\u0646\u062D\u0649';
 t['\uFD97'] = '\u0646\u062C\u0645';
 t['\uFD98'] = '\u0646\u062C\u0645';
 t['\uFD99'] = '\u0646\u062C\u0649';
 t['\uFD9A'] = '\u0646\u0645\u064A';
 t['\uFD9B'] = '\u0646\u0645\u0649';
 t['\uFD9C'] = '\u064A\u0645\u0645';
 t['\uFD9D'] = '\u064A\u0645\u0645';
 t['\uFD9E'] = '\u0628\u062E\u064A';
 t['\uFD9F'] = '\u062A\u062C\u064A';
 t['\uFDA0'] = '\u062A\u062C\u0649';
 t['\uFDA1'] = '\u062A\u062E\u064A';
 t['\uFDA2'] = '\u062A\u062E\u0649';
 t['\uFDA3'] = '\u062A\u0645\u064A';
 t['\uFDA4'] = '\u062A\u0645\u0649';
 t['\uFDA5'] = '\u062C\u0645\u064A';
 t['\uFDA6'] = '\u062C\u062D\u0649';
 t['\uFDA7'] = '\u062C\u0645\u0649';
 t['\uFDA8'] = '\u0633\u062E\u0649';
 t['\uFDA9'] = '\u0635\u062D\u064A';
 t['\uFDAA'] = '\u0634\u062D\u064A';
 t['\uFDAB'] = '\u0636\u062D\u064A';
 t['\uFDAC'] = '\u0644\u062C\u064A';
 t['\uFDAD'] = '\u0644\u0645\u064A';
 t['\uFDAE'] = '\u064A\u062D\u064A';
 t['\uFDAF'] = '\u064A\u062C\u064A';
 t['\uFDB0'] = '\u064A\u0645\u064A';
 t['\uFDB1'] = '\u0645\u0645\u064A';
 t['\uFDB2'] = '\u0642\u0645\u064A';
 t['\uFDB3'] = '\u0646\u062D\u064A';
 t['\uFDB4'] = '\u0642\u0645\u062D';
 t['\uFDB5'] = '\u0644\u062D\u0645';
 t['\uFDB6'] = '\u0639\u0645\u064A';
 t['\uFDB7'] = '\u0643\u0645\u064A';
 t['\uFDB8'] = '\u0646\u062C\u062D';
 t['\uFDB9'] = '\u0645\u062E\u064A';
 t['\uFDBA'] = '\u0644\u062C\u0645';
 t['\uFDBB'] = '\u0643\u0645\u0645';
 t['\uFDBC'] = '\u0644\u062C\u0645';
 t['\uFDBD'] = '\u0646\u062C\u062D';
 t['\uFDBE'] = '\u062C\u062D\u064A';
 t['\uFDBF'] = '\u062D\u062C\u064A';
 t['\uFDC0'] = '\u0645\u062C\u064A';
 t['\uFDC1'] = '\u0641\u0645\u064A';
 t['\uFDC2'] = '\u0628\u062D\u064A';
 t['\uFDC3'] = '\u0643\u0645\u0645';
 t['\uFDC4'] = '\u0639\u062C\u0645';
 t['\uFDC5'] = '\u0635\u0645\u0645';
 t['\uFDC6'] = '\u0633\u062E\u064A';
 t['\uFDC7'] = '\u0646\u062C\u064A';
 t['\uFE49'] = '\u203E';
 t['\uFE4A'] = '\u203E';
 t['\uFE4B'] = '\u203E';
 t['\uFE4C'] = '\u203E';
 t['\uFE4D'] = '\u005F';
 t['\uFE4E'] = '\u005F';
 t['\uFE4F'] = '\u005F';
 t['\uFE80'] = '\u0621';
 t['\uFE81'] = '\u0622';
 t['\uFE82'] = '\u0622';
 t['\uFE83'] = '\u0623';
 t['\uFE84'] = '\u0623';
 t['\uFE85'] = '\u0624';
 t['\uFE86'] = '\u0624';
 t['\uFE87'] = '\u0625';
 t['\uFE88'] = '\u0625';
 t['\uFE89'] = '\u0626';
 t['\uFE8A'] = '\u0626';
 t['\uFE8B'] = '\u0626';
 t['\uFE8C'] = '\u0626';
 t['\uFE8D'] = '\u0627';
 t['\uFE8E'] = '\u0627';
 t['\uFE8F'] = '\u0628';
 t['\uFE90'] = '\u0628';
 t['\uFE91'] = '\u0628';
 t['\uFE92'] = '\u0628';
 t['\uFE93'] = '\u0629';
 t['\uFE94'] = '\u0629';
 t['\uFE95'] = '\u062A';
 t['\uFE96'] = '\u062A';
 t['\uFE97'] = '\u062A';
 t['\uFE98'] = '\u062A';
 t['\uFE99'] = '\u062B';
 t['\uFE9A'] = '\u062B';
 t['\uFE9B'] = '\u062B';
 t['\uFE9C'] = '\u062B';
 t['\uFE9D'] = '\u062C';
 t['\uFE9E'] = '\u062C';
 t['\uFE9F'] = '\u062C';
 t['\uFEA0'] = '\u062C';
 t['\uFEA1'] = '\u062D';
 t['\uFEA2'] = '\u062D';
 t['\uFEA3'] = '\u062D';
 t['\uFEA4'] = '\u062D';
 t['\uFEA5'] = '\u062E';
 t['\uFEA6'] = '\u062E';
 t['\uFEA7'] = '\u062E';
 t['\uFEA8'] = '\u062E';
 t['\uFEA9'] = '\u062F';
 t['\uFEAA'] = '\u062F';
 t['\uFEAB'] = '\u0630';
 t['\uFEAC'] = '\u0630';
 t['\uFEAD'] = '\u0631';
 t['\uFEAE'] = '\u0631';
 t['\uFEAF'] = '\u0632';
 t['\uFEB0'] = '\u0632';
 t['\uFEB1'] = '\u0633';
 t['\uFEB2'] = '\u0633';
 t['\uFEB3'] = '\u0633';
 t['\uFEB4'] = '\u0633';
 t['\uFEB5'] = '\u0634';
 t['\uFEB6'] = '\u0634';
 t['\uFEB7'] = '\u0634';
 t['\uFEB8'] = '\u0634';
 t['\uFEB9'] = '\u0635';
 t['\uFEBA'] = '\u0635';
 t['\uFEBB'] = '\u0635';
 t['\uFEBC'] = '\u0635';
 t['\uFEBD'] = '\u0636';
 t['\uFEBE'] = '\u0636';
 t['\uFEBF'] = '\u0636';
 t['\uFEC0'] = '\u0636';
 t['\uFEC1'] = '\u0637';
 t['\uFEC2'] = '\u0637';
 t['\uFEC3'] = '\u0637';
 t['\uFEC4'] = '\u0637';
 t['\uFEC5'] = '\u0638';
 t['\uFEC6'] = '\u0638';
 t['\uFEC7'] = '\u0638';
 t['\uFEC8'] = '\u0638';
 t['\uFEC9'] = '\u0639';
 t['\uFECA'] = '\u0639';
 t['\uFECB'] = '\u0639';
 t['\uFECC'] = '\u0639';
 t['\uFECD'] = '\u063A';
 t['\uFECE'] = '\u063A';
 t['\uFECF'] = '\u063A';
 t['\uFED0'] = '\u063A';
 t['\uFED1'] = '\u0641';
 t['\uFED2'] = '\u0641';
 t['\uFED3'] = '\u0641';
 t['\uFED4'] = '\u0641';
 t['\uFED5'] = '\u0642';
 t['\uFED6'] = '\u0642';
 t['\uFED7'] = '\u0642';
 t['\uFED8'] = '\u0642';
 t['\uFED9'] = '\u0643';
 t['\uFEDA'] = '\u0643';
 t['\uFEDB'] = '\u0643';
 t['\uFEDC'] = '\u0643';
 t['\uFEDD'] = '\u0644';
 t['\uFEDE'] = '\u0644';
 t['\uFEDF'] = '\u0644';
 t['\uFEE0'] = '\u0644';
 t['\uFEE1'] = '\u0645';
 t['\uFEE2'] = '\u0645';
 t['\uFEE3'] = '\u0645';
 t['\uFEE4'] = '\u0645';
 t['\uFEE5'] = '\u0646';
 t['\uFEE6'] = '\u0646';
 t['\uFEE7'] = '\u0646';
 t['\uFEE8'] = '\u0646';
 t['\uFEE9'] = '\u0647';
 t['\uFEEA'] = '\u0647';
 t['\uFEEB'] = '\u0647';
 t['\uFEEC'] = '\u0647';
 t['\uFEED'] = '\u0648';
 t['\uFEEE'] = '\u0648';
 t['\uFEEF'] = '\u0649';
 t['\uFEF0'] = '\u0649';
 t['\uFEF1'] = '\u064A';
 t['\uFEF2'] = '\u064A';
 t['\uFEF3'] = '\u064A';
 t['\uFEF4'] = '\u064A';
 t['\uFEF5'] = '\u0644\u0622';
 t['\uFEF6'] = '\u0644\u0622';
 t['\uFEF7'] = '\u0644\u0623';
 t['\uFEF8'] = '\u0644\u0623';
 t['\uFEF9'] = '\u0644\u0625';
 t['\uFEFA'] = '\u0644\u0625';
 t['\uFEFB'] = '\u0644\u0627';
 t['\uFEFC'] = '\u0644\u0627';
});
function reverseIfRtl(chars) {
 var charsLength = chars.length;
 if (charsLength <= 1 || !isRTLRangeFor(chars.charCodeAt(0))) {
  return chars;
 }
 var s = '';
 for (var ii = charsLength - 1; ii >= 0; ii--) {
  s += chars[ii];
 }
 return s;
}
exports.mapSpecialUnicodeValues = mapSpecialUnicodeValues;
exports.reverseIfRtl = reverseIfRtl;
exports.getUnicodeRangeFor = getUnicodeRangeFor;
exports.getNormalizedUnicodes = getNormalizedUnicodes;
exports.getUnicodeForGlyph = getUnicodeForGlyph;

/***/ }),
/* 180 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FontRendererFactory = void 0;

var _util = __w_pdfjs_require__(6);

var _cff_parser = __w_pdfjs_require__(174);

var _glyphlist = __w_pdfjs_require__(177);

var _encodings = __w_pdfjs_require__(176);

var _stream = __w_pdfjs_require__(157);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var FontRendererFactory = function FontRendererFactoryClosure() {
  function getLong(data, offset) {
    return data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3];
  }

  function getUshort(data, offset) {
    return data[offset] << 8 | data[offset + 1];
  }

  function parseCmap(data, start, end) {
    var offset = getUshort(data, start + 2) === 1 ? getLong(data, start + 8) : getLong(data, start + 16);
    var format = getUshort(data, start + offset);
    var ranges, p, i;

    if (format === 4) {
      getUshort(data, start + offset + 2);
      var segCount = getUshort(data, start + offset + 6) >> 1;
      p = start + offset + 14;
      ranges = [];

      for (i = 0; i < segCount; i++, p += 2) {
        ranges[i] = {
          end: getUshort(data, p)
        };
      }

      p += 2;

      for (i = 0; i < segCount; i++, p += 2) {
        ranges[i].start = getUshort(data, p);
      }

      for (i = 0; i < segCount; i++, p += 2) {
        ranges[i].idDelta = getUshort(data, p);
      }

      for (i = 0; i < segCount; i++, p += 2) {
        var idOffset = getUshort(data, p);

        if (idOffset === 0) {
          continue;
        }

        ranges[i].ids = [];

        for (var j = 0, jj = ranges[i].end - ranges[i].start + 1; j < jj; j++) {
          ranges[i].ids[j] = getUshort(data, p + idOffset);
          idOffset += 2;
        }
      }

      return ranges;
    } else if (format === 12) {
      getLong(data, start + offset + 4);
      var groups = getLong(data, start + offset + 12);
      p = start + offset + 16;
      ranges = [];

      for (i = 0; i < groups; i++) {
        ranges.push({
          start: getLong(data, p),
          end: getLong(data, p + 4),
          idDelta: getLong(data, p + 8) - getLong(data, p)
        });
        p += 12;
      }

      return ranges;
    }

    throw new _util.FormatError("unsupported cmap: ".concat(format));
  }

  function parseCff(data, start, end, seacAnalysisEnabled) {
    var properties = {};
    var parser = new _cff_parser.CFFParser(new _stream.Stream(data, start, end - start), properties, seacAnalysisEnabled);
    var cff = parser.parse();
    return {
      glyphs: cff.charStrings.objects,
      subrs: cff.topDict.privateDict && cff.topDict.privateDict.subrsIndex && cff.topDict.privateDict.subrsIndex.objects,
      gsubrs: cff.globalSubrIndex && cff.globalSubrIndex.objects,
      isCFFCIDFont: cff.isCIDFont,
      fdSelect: cff.fdSelect,
      fdArray: cff.fdArray
    };
  }

  function parseGlyfTable(glyf, loca, isGlyphLocationsLong) {
    var itemSize, itemDecode;

    if (isGlyphLocationsLong) {
      itemSize = 4;

      itemDecode = function fontItemDecodeLong(data, offset) {
        return data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3];
      };
    } else {
      itemSize = 2;

      itemDecode = function fontItemDecode(data, offset) {
        return data[offset] << 9 | data[offset + 1] << 1;
      };
    }

    var glyphs = [];
    var startOffset = itemDecode(loca, 0);

    for (var j = itemSize; j < loca.length; j += itemSize) {
      var endOffset = itemDecode(loca, j);
      glyphs.push(glyf.subarray(startOffset, endOffset));
      startOffset = endOffset;
    }

    return glyphs;
  }

  function lookupCmap(ranges, unicode) {
    var code = unicode.codePointAt(0),
        gid = 0;
    var l = 0,
        r = ranges.length - 1;

    while (l < r) {
      var c = l + r + 1 >> 1;

      if (code < ranges[c].start) {
        r = c - 1;
      } else {
        l = c;
      }
    }

    if (ranges[l].start <= code && code <= ranges[l].end) {
      gid = ranges[l].idDelta + (ranges[l].ids ? ranges[l].ids[code - ranges[l].start] : code) & 0xFFFF;
    }

    return {
      charCode: code,
      glyphId: gid
    };
  }

  function compileGlyf(code, cmds, font) {
    function moveTo(x, y) {
      cmds.push({
        cmd: 'moveTo',
        args: [x, y]
      });
    }

    function lineTo(x, y) {
      cmds.push({
        cmd: 'lineTo',
        args: [x, y]
      });
    }

    function quadraticCurveTo(xa, ya, x, y) {
      cmds.push({
        cmd: 'quadraticCurveTo',
        args: [xa, ya, x, y]
      });
    }

    var i = 0;
    var numberOfContours = (code[i] << 24 | code[i + 1] << 16) >> 16;
    var flags;
    var x = 0,
        y = 0;
    i += 10;

    if (numberOfContours < 0) {
      do {
        flags = code[i] << 8 | code[i + 1];
        var glyphIndex = code[i + 2] << 8 | code[i + 3];
        i += 4;
        var arg1, arg2;

        if (flags & 0x01) {
          arg1 = (code[i] << 24 | code[i + 1] << 16) >> 16;
          arg2 = (code[i + 2] << 24 | code[i + 3] << 16) >> 16;
          i += 4;
        } else {
          arg1 = code[i++];
          arg2 = code[i++];
        }

        if (flags & 0x02) {
          x = arg1;
          y = arg2;
        } else {
          x = 0;
          y = 0;
        }

        var scaleX = 1,
            scaleY = 1,
            scale01 = 0,
            scale10 = 0;

        if (flags & 0x08) {
          scaleX = scaleY = (code[i] << 24 | code[i + 1] << 16) / 1073741824;
          i += 2;
        } else if (flags & 0x40) {
          scaleX = (code[i] << 24 | code[i + 1] << 16) / 1073741824;
          scaleY = (code[i + 2] << 24 | code[i + 3] << 16) / 1073741824;
          i += 4;
        } else if (flags & 0x80) {
          scaleX = (code[i] << 24 | code[i + 1] << 16) / 1073741824;
          scale01 = (code[i + 2] << 24 | code[i + 3] << 16) / 1073741824;
          scale10 = (code[i + 4] << 24 | code[i + 5] << 16) / 1073741824;
          scaleY = (code[i + 6] << 24 | code[i + 7] << 16) / 1073741824;
          i += 8;
        }

        var subglyph = font.glyphs[glyphIndex];

        if (subglyph) {
          cmds.push({
            cmd: 'save'
          });
          cmds.push({
            cmd: 'transform',
            args: [scaleX, scale01, scale10, scaleY, x, y]
          });
          compileGlyf(subglyph, cmds, font);
          cmds.push({
            cmd: 'restore'
          });
        }
      } while (flags & 0x20);
    } else {
      var endPtsOfContours = [];
      var j, jj;

      for (j = 0; j < numberOfContours; j++) {
        endPtsOfContours.push(code[i] << 8 | code[i + 1]);
        i += 2;
      }

      var instructionLength = code[i] << 8 | code[i + 1];
      i += 2 + instructionLength;
      var numberOfPoints = endPtsOfContours[endPtsOfContours.length - 1] + 1;
      var points = [];

      while (points.length < numberOfPoints) {
        flags = code[i++];
        var repeat = 1;

        if (flags & 0x08) {
          repeat += code[i++];
        }

        while (repeat-- > 0) {
          points.push({
            flags: flags
          });
        }
      }

      for (j = 0; j < numberOfPoints; j++) {
        switch (points[j].flags & 0x12) {
          case 0x00:
            x += (code[i] << 24 | code[i + 1] << 16) >> 16;
            i += 2;
            break;

          case 0x02:
            x -= code[i++];
            break;

          case 0x12:
            x += code[i++];
            break;
        }

        points[j].x = x;
      }

      for (j = 0; j < numberOfPoints; j++) {
        switch (points[j].flags & 0x24) {
          case 0x00:
            y += (code[i] << 24 | code[i + 1] << 16) >> 16;
            i += 2;
            break;

          case 0x04:
            y -= code[i++];
            break;

          case 0x24:
            y += code[i++];
            break;
        }

        points[j].y = y;
      }

      var startPoint = 0;

      for (i = 0; i < numberOfContours; i++) {
        var endPoint = endPtsOfContours[i];
        var contour = points.slice(startPoint, endPoint + 1);

        if (contour[0].flags & 1) {
          contour.push(contour[0]);
        } else if (contour[contour.length - 1].flags & 1) {
          contour.unshift(contour[contour.length - 1]);
        } else {
          var p = {
            flags: 1,
            x: (contour[0].x + contour[contour.length - 1].x) / 2,
            y: (contour[0].y + contour[contour.length - 1].y) / 2
          };
          contour.unshift(p);
          contour.push(p);
        }

        moveTo(contour[0].x, contour[0].y);

        for (j = 1, jj = contour.length; j < jj; j++) {
          if (contour[j].flags & 1) {
            lineTo(contour[j].x, contour[j].y);
          } else if (contour[j + 1].flags & 1) {
            quadraticCurveTo(contour[j].x, contour[j].y, contour[j + 1].x, contour[j + 1].y);
            j++;
          } else {
            quadraticCurveTo(contour[j].x, contour[j].y, (contour[j].x + contour[j + 1].x) / 2, (contour[j].y + contour[j + 1].y) / 2);
          }
        }

        startPoint = endPoint + 1;
      }
    }
  }

  function compileCharString(code, cmds, font, glyphId) {
    var stack = [];
    var x = 0,
        y = 0;
    var stems = 0;

    function moveTo(x, y) {
      cmds.push({
        cmd: 'moveTo',
        args: [x, y]
      });
    }

    function lineTo(x, y) {
      cmds.push({
        cmd: 'lineTo',
        args: [x, y]
      });
    }

    function bezierCurveTo(x1, y1, x2, y2, x, y) {
      cmds.push({
        cmd: 'bezierCurveTo',
        args: [x1, y1, x2, y2, x, y]
      });
    }

    function parse(code) {
      var i = 0;

      while (i < code.length) {
        var stackClean = false;
        var v = code[i++];
        var xa, xb, ya, yb, y1, y2, y3, n, subrCode;

        switch (v) {
          case 1:
            stems += stack.length >> 1;
            stackClean = true;
            break;

          case 3:
            stems += stack.length >> 1;
            stackClean = true;
            break;

          case 4:
            y += stack.pop();
            moveTo(x, y);
            stackClean = true;
            break;

          case 5:
            while (stack.length > 0) {
              x += stack.shift();
              y += stack.shift();
              lineTo(x, y);
            }

            break;

          case 6:
            while (stack.length > 0) {
              x += stack.shift();
              lineTo(x, y);

              if (stack.length === 0) {
                break;
              }

              y += stack.shift();
              lineTo(x, y);
            }

            break;

          case 7:
            while (stack.length > 0) {
              y += stack.shift();
              lineTo(x, y);

              if (stack.length === 0) {
                break;
              }

              x += stack.shift();
              lineTo(x, y);
            }

            break;

          case 8:
            while (stack.length > 0) {
              xa = x + stack.shift();
              ya = y + stack.shift();
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              x = xb + stack.shift();
              y = yb + stack.shift();
              bezierCurveTo(xa, ya, xb, yb, x, y);
            }

            break;

          case 10:
            n = stack.pop();
            subrCode = null;

            if (font.isCFFCIDFont) {
              var fdIndex = font.fdSelect.getFDIndex(glyphId);

              if (fdIndex >= 0 && fdIndex < font.fdArray.length) {
                var fontDict = font.fdArray[fdIndex],
                    subrs = void 0;

                if (fontDict.privateDict && fontDict.privateDict.subrsIndex) {
                  subrs = fontDict.privateDict.subrsIndex.objects;
                }

                if (subrs) {
                  var numSubrs = subrs.length;
                  n += numSubrs < 1240 ? 107 : numSubrs < 33900 ? 1131 : 32768;
                  subrCode = subrs[n];
                }
              } else {
                (0, _util.warn)('Invalid fd index for glyph index.');
              }
            } else {
              subrCode = font.subrs[n + font.subrsBias];
            }

            if (subrCode) {
              parse(subrCode);
            }

            break;

          case 11:
            return;

          case 12:
            v = code[i++];

            switch (v) {
              case 34:
                xa = x + stack.shift();
                xb = xa + stack.shift();
                y1 = y + stack.shift();
                x = xb + stack.shift();
                bezierCurveTo(xa, y, xb, y1, x, y1);
                xa = x + stack.shift();
                xb = xa + stack.shift();
                x = xb + stack.shift();
                bezierCurveTo(xa, y1, xb, y, x, y);
                break;

              case 35:
                xa = x + stack.shift();
                ya = y + stack.shift();
                xb = xa + stack.shift();
                yb = ya + stack.shift();
                x = xb + stack.shift();
                y = yb + stack.shift();
                bezierCurveTo(xa, ya, xb, yb, x, y);
                xa = x + stack.shift();
                ya = y + stack.shift();
                xb = xa + stack.shift();
                yb = ya + stack.shift();
                x = xb + stack.shift();
                y = yb + stack.shift();
                bezierCurveTo(xa, ya, xb, yb, x, y);
                stack.pop();
                break;

              case 36:
                xa = x + stack.shift();
                y1 = y + stack.shift();
                xb = xa + stack.shift();
                y2 = y1 + stack.shift();
                x = xb + stack.shift();
                bezierCurveTo(xa, y1, xb, y2, x, y2);
                xa = x + stack.shift();
                xb = xa + stack.shift();
                y3 = y2 + stack.shift();
                x = xb + stack.shift();
                bezierCurveTo(xa, y2, xb, y3, x, y);
                break;

              case 37:
                var x0 = x,
                    y0 = y;
                xa = x + stack.shift();
                ya = y + stack.shift();
                xb = xa + stack.shift();
                yb = ya + stack.shift();
                x = xb + stack.shift();
                y = yb + stack.shift();
                bezierCurveTo(xa, ya, xb, yb, x, y);
                xa = x + stack.shift();
                ya = y + stack.shift();
                xb = xa + stack.shift();
                yb = ya + stack.shift();
                x = xb;
                y = yb;

                if (Math.abs(x - x0) > Math.abs(y - y0)) {
                  x += stack.shift();
                } else {
                  y += stack.shift();
                }

                bezierCurveTo(xa, ya, xb, yb, x, y);
                break;

              default:
                throw new _util.FormatError("unknown operator: 12 ".concat(v));
            }

            break;

          case 14:
            if (stack.length >= 4) {
              var achar = stack.pop();
              var bchar = stack.pop();
              y = stack.pop();
              x = stack.pop();
              cmds.push({
                cmd: 'save'
              });
              cmds.push({
                cmd: 'translate',
                args: [x, y]
              });
              var cmap = lookupCmap(font.cmap, String.fromCharCode(font.glyphNameMap[_encodings.StandardEncoding[achar]]));
              compileCharString(font.glyphs[cmap.glyphId], cmds, font, cmap.glyphId);
              cmds.push({
                cmd: 'restore'
              });
              cmap = lookupCmap(font.cmap, String.fromCharCode(font.glyphNameMap[_encodings.StandardEncoding[bchar]]));
              compileCharString(font.glyphs[cmap.glyphId], cmds, font, cmap.glyphId);
            }

            return;

          case 18:
            stems += stack.length >> 1;
            stackClean = true;
            break;

          case 19:
            stems += stack.length >> 1;
            i += stems + 7 >> 3;
            stackClean = true;
            break;

          case 20:
            stems += stack.length >> 1;
            i += stems + 7 >> 3;
            stackClean = true;
            break;

          case 21:
            y += stack.pop();
            x += stack.pop();
            moveTo(x, y);
            stackClean = true;
            break;

          case 22:
            x += stack.pop();
            moveTo(x, y);
            stackClean = true;
            break;

          case 23:
            stems += stack.length >> 1;
            stackClean = true;
            break;

          case 24:
            while (stack.length > 2) {
              xa = x + stack.shift();
              ya = y + stack.shift();
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              x = xb + stack.shift();
              y = yb + stack.shift();
              bezierCurveTo(xa, ya, xb, yb, x, y);
            }

            x += stack.shift();
            y += stack.shift();
            lineTo(x, y);
            break;

          case 25:
            while (stack.length > 6) {
              x += stack.shift();
              y += stack.shift();
              lineTo(x, y);
            }

            xa = x + stack.shift();
            ya = y + stack.shift();
            xb = xa + stack.shift();
            yb = ya + stack.shift();
            x = xb + stack.shift();
            y = yb + stack.shift();
            bezierCurveTo(xa, ya, xb, yb, x, y);
            break;

          case 26:
            if (stack.length % 2) {
              x += stack.shift();
            }

            while (stack.length > 0) {
              xa = x;
              ya = y + stack.shift();
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              x = xb;
              y = yb + stack.shift();
              bezierCurveTo(xa, ya, xb, yb, x, y);
            }

            break;

          case 27:
            if (stack.length % 2) {
              y += stack.shift();
            }

            while (stack.length > 0) {
              xa = x + stack.shift();
              ya = y;
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              x = xb + stack.shift();
              y = yb;
              bezierCurveTo(xa, ya, xb, yb, x, y);
            }

            break;

          case 28:
            stack.push((code[i] << 24 | code[i + 1] << 16) >> 16);
            i += 2;
            break;

          case 29:
            n = stack.pop() + font.gsubrsBias;
            subrCode = font.gsubrs[n];

            if (subrCode) {
              parse(subrCode);
            }

            break;

          case 30:
            while (stack.length > 0) {
              xa = x;
              ya = y + stack.shift();
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              x = xb + stack.shift();
              y = yb + (stack.length === 1 ? stack.shift() : 0);
              bezierCurveTo(xa, ya, xb, yb, x, y);

              if (stack.length === 0) {
                break;
              }

              xa = x + stack.shift();
              ya = y;
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              y = yb + stack.shift();
              x = xb + (stack.length === 1 ? stack.shift() : 0);
              bezierCurveTo(xa, ya, xb, yb, x, y);
            }

            break;

          case 31:
            while (stack.length > 0) {
              xa = x + stack.shift();
              ya = y;
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              y = yb + stack.shift();
              x = xb + (stack.length === 1 ? stack.shift() : 0);
              bezierCurveTo(xa, ya, xb, yb, x, y);

              if (stack.length === 0) {
                break;
              }

              xa = x;
              ya = y + stack.shift();
              xb = xa + stack.shift();
              yb = ya + stack.shift();
              x = xb + stack.shift();
              y = yb + (stack.length === 1 ? stack.shift() : 0);
              bezierCurveTo(xa, ya, xb, yb, x, y);
            }

            break;

          default:
            if (v < 32) {
              throw new _util.FormatError("unknown operator: ".concat(v));
            }

            if (v < 247) {
              stack.push(v - 139);
            } else if (v < 251) {
              stack.push((v - 247) * 256 + code[i++] + 108);
            } else if (v < 255) {
              stack.push(-(v - 251) * 256 - code[i++] - 108);
            } else {
              stack.push((code[i] << 24 | code[i + 1] << 16 | code[i + 2] << 8 | code[i + 3]) / 65536);
              i += 4;
            }

            break;
        }

        if (stackClean) {
          stack.length = 0;
        }
      }
    }

    parse(code);
  }

  var NOOP = [];

  var CompiledFont =
  /*#__PURE__*/
  function () {
    function CompiledFont(fontMatrix) {
      _classCallCheck(this, CompiledFont);

      if (this.constructor === CompiledFont) {
        (0, _util.unreachable)('Cannot initialize CompiledFont.');
      }

      this.fontMatrix = fontMatrix;
      this.compiledGlyphs = Object.create(null);
      this.compiledCharCodeToGlyphId = Object.create(null);
    }

    _createClass(CompiledFont, [{
      key: "getPathJs",
      value: function getPathJs(unicode) {
        var cmap = lookupCmap(this.cmap, unicode);
        var fn = this.compiledGlyphs[cmap.glyphId];

        if (!fn) {
          fn = this.compileGlyph(this.glyphs[cmap.glyphId], cmap.glyphId);
          this.compiledGlyphs[cmap.glyphId] = fn;
        }

        if (this.compiledCharCodeToGlyphId[cmap.charCode] === undefined) {
          this.compiledCharCodeToGlyphId[cmap.charCode] = cmap.glyphId;
        }

        return fn;
      }
    }, {
      key: "compileGlyph",
      value: function compileGlyph(code, glyphId) {
        if (!code || code.length === 0 || code[0] === 14) {
          return NOOP;
        }

        var fontMatrix = this.fontMatrix;

        if (this.isCFFCIDFont) {
          var fdIndex = this.fdSelect.getFDIndex(glyphId);

          if (fdIndex >= 0 && fdIndex < this.fdArray.length) {
            var fontDict = this.fdArray[fdIndex];
            fontMatrix = fontDict.getByName('FontMatrix') || _util.FONT_IDENTITY_MATRIX;
          } else {
            (0, _util.warn)('Invalid fd index for glyph index.');
          }
        }

        var cmds = [];
        cmds.push({
          cmd: 'save'
        });
        cmds.push({
          cmd: 'transform',
          args: fontMatrix.slice()
        });
        cmds.push({
          cmd: 'scale',
          args: ['size', '-size']
        });
        this.compileGlyphImpl(code, cmds, glyphId);
        cmds.push({
          cmd: 'restore'
        });
        return cmds;
      }
    }, {
      key: "compileGlyphImpl",
      value: function compileGlyphImpl() {
        (0, _util.unreachable)('Children classes should implement this.');
      }
    }, {
      key: "hasBuiltPath",
      value: function hasBuiltPath(unicode) {
        var cmap = lookupCmap(this.cmap, unicode);
        return this.compiledGlyphs[cmap.glyphId] !== undefined && this.compiledCharCodeToGlyphId[cmap.charCode] !== undefined;
      }
    }]);

    return CompiledFont;
  }();

  var TrueTypeCompiled =
  /*#__PURE__*/
  function (_CompiledFont) {
    _inherits(TrueTypeCompiled, _CompiledFont);

    function TrueTypeCompiled(glyphs, cmap, fontMatrix) {
      var _this;

      _classCallCheck(this, TrueTypeCompiled);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(TrueTypeCompiled).call(this, fontMatrix || [0.000488, 0, 0, 0.000488, 0, 0]));
      _this.glyphs = glyphs;
      _this.cmap = cmap;
      return _this;
    }

    _createClass(TrueTypeCompiled, [{
      key: "compileGlyphImpl",
      value: function compileGlyphImpl(code, cmds) {
        compileGlyf(code, cmds, this);
      }
    }]);

    return TrueTypeCompiled;
  }(CompiledFont);

  var Type2Compiled =
  /*#__PURE__*/
  function (_CompiledFont2) {
    _inherits(Type2Compiled, _CompiledFont2);

    function Type2Compiled(cffInfo, cmap, fontMatrix, glyphNameMap) {
      var _this2;

      _classCallCheck(this, Type2Compiled);

      _this2 = _possibleConstructorReturn(this, _getPrototypeOf(Type2Compiled).call(this, fontMatrix || [0.001, 0, 0, 0.001, 0, 0]));
      _this2.glyphs = cffInfo.glyphs;
      _this2.gsubrs = cffInfo.gsubrs || [];
      _this2.subrs = cffInfo.subrs || [];
      _this2.cmap = cmap;
      _this2.glyphNameMap = glyphNameMap || (0, _glyphlist.getGlyphsUnicode)();
      _this2.gsubrsBias = _this2.gsubrs.length < 1240 ? 107 : _this2.gsubrs.length < 33900 ? 1131 : 32768;
      _this2.subrsBias = _this2.subrs.length < 1240 ? 107 : _this2.subrs.length < 33900 ? 1131 : 32768;
      _this2.isCFFCIDFont = cffInfo.isCFFCIDFont;
      _this2.fdSelect = cffInfo.fdSelect;
      _this2.fdArray = cffInfo.fdArray;
      return _this2;
    }

    _createClass(Type2Compiled, [{
      key: "compileGlyphImpl",
      value: function compileGlyphImpl(code, cmds, glyphId) {
        compileCharString(code, cmds, this, glyphId);
      }
    }]);

    return Type2Compiled;
  }(CompiledFont);

  return {
    create: function FontRendererFactory_create(font, seacAnalysisEnabled) {
      var data = new Uint8Array(font.data);
      var cmap, glyf, loca, cff, indexToLocFormat, unitsPerEm;
      var numTables = getUshort(data, 4);

      for (var i = 0, p = 12; i < numTables; i++, p += 16) {
        var tag = (0, _util.bytesToString)(data.subarray(p, p + 4));
        var offset = getLong(data, p + 8);
        var length = getLong(data, p + 12);

        switch (tag) {
          case 'cmap':
            cmap = parseCmap(data, offset, offset + length);
            break;

          case 'glyf':
            glyf = data.subarray(offset, offset + length);
            break;

          case 'loca':
            loca = data.subarray(offset, offset + length);
            break;

          case 'head':
            unitsPerEm = getUshort(data, offset + 18);
            indexToLocFormat = getUshort(data, offset + 50);
            break;

          case 'CFF ':
            cff = parseCff(data, offset, offset + length, seacAnalysisEnabled);
            break;
        }
      }

      if (glyf) {
        var fontMatrix = !unitsPerEm ? font.fontMatrix : [1 / unitsPerEm, 0, 0, 1 / unitsPerEm, 0, 0];
        return new TrueTypeCompiled(parseGlyfTable(glyf, loca, indexToLocFormat), cmap, fontMatrix);
      }

      return new Type2Compiled(cff, cmap, font.fontMatrix, font.glyphNameMap);
    }
  };
}();

exports.FontRendererFactory = FontRendererFactory;

/***/ }),
/* 181 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Type1Parser = void 0;

var _util = __w_pdfjs_require__(6);

var _encodings = __w_pdfjs_require__(176);

var _stream = __w_pdfjs_require__(157);

var HINTING_ENABLED = false;

var Type1CharString = function Type1CharStringClosure() {
  var COMMAND_MAP = {
    'hstem': [1],
    'vstem': [3],
    'vmoveto': [4],
    'rlineto': [5],
    'hlineto': [6],
    'vlineto': [7],
    'rrcurveto': [8],
    'callsubr': [10],
    'flex': [12, 35],
    'drop': [12, 18],
    'endchar': [14],
    'rmoveto': [21],
    'hmoveto': [22],
    'vhcurveto': [30],
    'hvcurveto': [31]
  };

  function Type1CharString() {
    this.width = 0;
    this.lsb = 0;
    this.flexing = false;
    this.output = [];
    this.stack = [];
  }

  Type1CharString.prototype = {
    convert: function Type1CharString_convert(encoded, subrs, seacAnalysisEnabled) {
      var count = encoded.length;
      var error = false;
      var wx, sbx, subrNumber;

      for (var i = 0; i < count; i++) {
        var value = encoded[i];

        if (value < 32) {
          if (value === 12) {
            value = (value << 8) + encoded[++i];
          }

          switch (value) {
            case 1:
              if (!HINTING_ENABLED) {
                this.stack = [];
                break;
              }

              error = this.executeCommand(2, COMMAND_MAP.hstem);
              break;

            case 3:
              if (!HINTING_ENABLED) {
                this.stack = [];
                break;
              }

              error = this.executeCommand(2, COMMAND_MAP.vstem);
              break;

            case 4:
              if (this.flexing) {
                if (this.stack.length < 1) {
                  error = true;
                  break;
                }

                var dy = this.stack.pop();
                this.stack.push(0, dy);
                break;
              }

              error = this.executeCommand(1, COMMAND_MAP.vmoveto);
              break;

            case 5:
              error = this.executeCommand(2, COMMAND_MAP.rlineto);
              break;

            case 6:
              error = this.executeCommand(1, COMMAND_MAP.hlineto);
              break;

            case 7:
              error = this.executeCommand(1, COMMAND_MAP.vlineto);
              break;

            case 8:
              error = this.executeCommand(6, COMMAND_MAP.rrcurveto);
              break;

            case 9:
              this.stack = [];
              break;

            case 10:
              if (this.stack.length < 1) {
                error = true;
                break;
              }

              subrNumber = this.stack.pop();

              if (!subrs[subrNumber]) {
                error = true;
                break;
              }

              error = this.convert(subrs[subrNumber], subrs, seacAnalysisEnabled);
              break;

            case 11:
              return error;

            case 13:
              if (this.stack.length < 2) {
                error = true;
                break;
              }

              wx = this.stack.pop();
              sbx = this.stack.pop();
              this.lsb = sbx;
              this.width = wx;
              this.stack.push(wx, sbx);
              error = this.executeCommand(2, COMMAND_MAP.hmoveto);
              break;

            case 14:
              this.output.push(COMMAND_MAP.endchar[0]);
              break;

            case 21:
              if (this.flexing) {
                break;
              }

              error = this.executeCommand(2, COMMAND_MAP.rmoveto);
              break;

            case 22:
              if (this.flexing) {
                this.stack.push(0);
                break;
              }

              error = this.executeCommand(1, COMMAND_MAP.hmoveto);
              break;

            case 30:
              error = this.executeCommand(4, COMMAND_MAP.vhcurveto);
              break;

            case 31:
              error = this.executeCommand(4, COMMAND_MAP.hvcurveto);
              break;

            case (12 << 8) + 0:
              this.stack = [];
              break;

            case (12 << 8) + 1:
              if (!HINTING_ENABLED) {
                this.stack = [];
                break;
              }

              error = this.executeCommand(2, COMMAND_MAP.vstem);
              break;

            case (12 << 8) + 2:
              if (!HINTING_ENABLED) {
                this.stack = [];
                break;
              }

              error = this.executeCommand(2, COMMAND_MAP.hstem);
              break;

            case (12 << 8) + 6:
              if (seacAnalysisEnabled) {
                this.seac = this.stack.splice(-4, 4);
                error = this.executeCommand(0, COMMAND_MAP.endchar);
              } else {
                error = this.executeCommand(4, COMMAND_MAP.endchar);
              }

              break;

            case (12 << 8) + 7:
              if (this.stack.length < 4) {
                error = true;
                break;
              }

              this.stack.pop();
              wx = this.stack.pop();
              var sby = this.stack.pop();
              sbx = this.stack.pop();
              this.lsb = sbx;
              this.width = wx;
              this.stack.push(wx, sbx, sby);
              error = this.executeCommand(3, COMMAND_MAP.rmoveto);
              break;

            case (12 << 8) + 12:
              if (this.stack.length < 2) {
                error = true;
                break;
              }

              var num2 = this.stack.pop();
              var num1 = this.stack.pop();
              this.stack.push(num1 / num2);
              break;

            case (12 << 8) + 16:
              if (this.stack.length < 2) {
                error = true;
                break;
              }

              subrNumber = this.stack.pop();
              var numArgs = this.stack.pop();

              if (subrNumber === 0 && numArgs === 3) {
                var flexArgs = this.stack.splice(this.stack.length - 17, 17);
                this.stack.push(flexArgs[2] + flexArgs[0], flexArgs[3] + flexArgs[1], flexArgs[4], flexArgs[5], flexArgs[6], flexArgs[7], flexArgs[8], flexArgs[9], flexArgs[10], flexArgs[11], flexArgs[12], flexArgs[13], flexArgs[14]);
                error = this.executeCommand(13, COMMAND_MAP.flex, true);
                this.flexing = false;
                this.stack.push(flexArgs[15], flexArgs[16]);
              } else if (subrNumber === 1 && numArgs === 0) {
                this.flexing = true;
              }

              break;

            case (12 << 8) + 17:
              break;

            case (12 << 8) + 33:
              this.stack = [];
              break;

            default:
              (0, _util.warn)('Unknown type 1 charstring command of "' + value + '"');
              break;
          }

          if (error) {
            break;
          }

          continue;
        } else if (value <= 246) {
          value = value - 139;
        } else if (value <= 250) {
          value = (value - 247) * 256 + encoded[++i] + 108;
        } else if (value <= 254) {
          value = -((value - 251) * 256) - encoded[++i] - 108;
        } else {
          value = (encoded[++i] & 0xff) << 24 | (encoded[++i] & 0xff) << 16 | (encoded[++i] & 0xff) << 8 | (encoded[++i] & 0xff) << 0;
        }

        this.stack.push(value);
      }

      return error;
    },
    executeCommand: function executeCommand(howManyArgs, command, keepStack) {
      var stackLength = this.stack.length;

      if (howManyArgs > stackLength) {
        return true;
      }

      var start = stackLength - howManyArgs;

      for (var i = start; i < stackLength; i++) {
        var value = this.stack[i];

        if (Number.isInteger(value)) {
          this.output.push(28, value >> 8 & 0xff, value & 0xff);
        } else {
          value = 65536 * value | 0;
          this.output.push(255, value >> 24 & 0xFF, value >> 16 & 0xFF, value >> 8 & 0xFF, value & 0xFF);
        }
      }

      this.output.push.apply(this.output, command);

      if (keepStack) {
        this.stack.splice(start, howManyArgs);
      } else {
        this.stack.length = 0;
      }

      return false;
    }
  };
  return Type1CharString;
}();

var Type1Parser = function Type1ParserClosure() {
  var EEXEC_ENCRYPT_KEY = 55665;
  var CHAR_STRS_ENCRYPT_KEY = 4330;

  function isHexDigit(code) {
    return code >= 48 && code <= 57 || code >= 65 && code <= 70 || code >= 97 && code <= 102;
  }

  function decrypt(data, key, discardNumber) {
    if (discardNumber >= data.length) {
      return new Uint8Array(0);
    }

    var r = key | 0,
        c1 = 52845,
        c2 = 22719,
        i,
        j;

    for (i = 0; i < discardNumber; i++) {
      r = (data[i] + r) * c1 + c2 & (1 << 16) - 1;
    }

    var count = data.length - discardNumber;
    var decrypted = new Uint8Array(count);

    for (i = discardNumber, j = 0; j < count; i++, j++) {
      var value = data[i];
      decrypted[j] = value ^ r >> 8;
      r = (value + r) * c1 + c2 & (1 << 16) - 1;
    }

    return decrypted;
  }

  function decryptAscii(data, key, discardNumber) {
    var r = key | 0,
        c1 = 52845,
        c2 = 22719;
    var count = data.length,
        maybeLength = count >>> 1;
    var decrypted = new Uint8Array(maybeLength);
    var i, j;

    for (i = 0, j = 0; i < count; i++) {
      var digit1 = data[i];

      if (!isHexDigit(digit1)) {
        continue;
      }

      i++;
      var digit2;

      while (i < count && !isHexDigit(digit2 = data[i])) {
        i++;
      }

      if (i < count) {
        var value = parseInt(String.fromCharCode(digit1, digit2), 16);
        decrypted[j++] = value ^ r >> 8;
        r = (value + r) * c1 + c2 & (1 << 16) - 1;
      }
    }

    return Array.prototype.slice.call(decrypted, discardNumber, j);
  }

  function isSpecial(c) {
    return c === 0x2F || c === 0x5B || c === 0x5D || c === 0x7B || c === 0x7D || c === 0x28 || c === 0x29;
  }

  function Type1Parser(stream, encrypted, seacAnalysisEnabled) {
    if (encrypted) {
      var data = stream.getBytes();
      var isBinary = !(isHexDigit(data[0]) && isHexDigit(data[1]) && isHexDigit(data[2]) && isHexDigit(data[3]));
      stream = new _stream.Stream(isBinary ? decrypt(data, EEXEC_ENCRYPT_KEY, 4) : decryptAscii(data, EEXEC_ENCRYPT_KEY, 4));
    }

    this.seacAnalysisEnabled = !!seacAnalysisEnabled;
    this.stream = stream;
    this.nextChar();
  }

  Type1Parser.prototype = {
    readNumberArray: function Type1Parser_readNumberArray() {
      this.getToken();
      var array = [];

      while (true) {
        var token = this.getToken();

        if (token === null || token === ']' || token === '}') {
          break;
        }

        array.push(parseFloat(token || 0));
      }

      return array;
    },
    readNumber: function Type1Parser_readNumber() {
      var token = this.getToken();
      return parseFloat(token || 0);
    },
    readInt: function Type1Parser_readInt() {
      var token = this.getToken();
      return parseInt(token || 0, 10) | 0;
    },
    readBoolean: function Type1Parser_readBoolean() {
      var token = this.getToken();
      return token === 'true' ? 1 : 0;
    },
    nextChar: function Type1_nextChar() {
      return this.currentChar = this.stream.getByte();
    },
    getToken: function Type1Parser_getToken() {
      var comment = false;
      var ch = this.currentChar;

      while (true) {
        if (ch === -1) {
          return null;
        }

        if (comment) {
          if (ch === 0x0A || ch === 0x0D) {
            comment = false;
          }
        } else if (ch === 0x25) {
          comment = true;
        } else if (!(0, _util.isSpace)(ch)) {
          break;
        }

        ch = this.nextChar();
      }

      if (isSpecial(ch)) {
        this.nextChar();
        return String.fromCharCode(ch);
      }

      var token = '';

      do {
        token += String.fromCharCode(ch);
        ch = this.nextChar();
      } while (ch >= 0 && !(0, _util.isSpace)(ch) && !isSpecial(ch));

      return token;
    },
    readCharStrings: function Type1Parser_readCharStrings(bytes, lenIV) {
      if (lenIV === -1) {
        return bytes;
      }

      return decrypt(bytes, CHAR_STRS_ENCRYPT_KEY, lenIV);
    },
    extractFontProgram: function Type1Parser_extractFontProgram() {
      var stream = this.stream;
      var subrs = [],
          charstrings = [];
      var privateData = Object.create(null);
      privateData['lenIV'] = 4;
      var program = {
        subrs: [],
        charstrings: [],
        properties: {
          'privateData': privateData
        }
      };
      var token, length, data, lenIV, encoded;

      while ((token = this.getToken()) !== null) {
        if (token !== '/') {
          continue;
        }

        token = this.getToken();

        switch (token) {
          case 'CharStrings':
            this.getToken();
            this.getToken();
            this.getToken();
            this.getToken();

            while (true) {
              token = this.getToken();

              if (token === null || token === 'end') {
                break;
              }

              if (token !== '/') {
                continue;
              }

              var glyph = this.getToken();
              length = this.readInt();
              this.getToken();
              data = length > 0 ? stream.getBytes(length) : new Uint8Array(0);
              lenIV = program.properties.privateData['lenIV'];
              encoded = this.readCharStrings(data, lenIV);
              this.nextChar();
              token = this.getToken();

              if (token === 'noaccess') {
                this.getToken();
              }

              charstrings.push({
                glyph: glyph,
                encoded: encoded
              });
            }

            break;

          case 'Subrs':
            this.readInt();
            this.getToken();

            while (this.getToken() === 'dup') {
              var index = this.readInt();
              length = this.readInt();
              this.getToken();
              data = length > 0 ? stream.getBytes(length) : new Uint8Array(0);
              lenIV = program.properties.privateData['lenIV'];
              encoded = this.readCharStrings(data, lenIV);
              this.nextChar();
              token = this.getToken();

              if (token === 'noaccess') {
                this.getToken();
              }

              subrs[index] = encoded;
            }

            break;

          case 'BlueValues':
          case 'OtherBlues':
          case 'FamilyBlues':
          case 'FamilyOtherBlues':
            var blueArray = this.readNumberArray();

            if (blueArray.length > 0 && blueArray.length % 2 === 0 && HINTING_ENABLED) {
              program.properties.privateData[token] = blueArray;
            }

            break;

          case 'StemSnapH':
          case 'StemSnapV':
            program.properties.privateData[token] = this.readNumberArray();
            break;

          case 'StdHW':
          case 'StdVW':
            program.properties.privateData[token] = this.readNumberArray()[0];
            break;

          case 'BlueShift':
          case 'lenIV':
          case 'BlueFuzz':
          case 'BlueScale':
          case 'LanguageGroup':
          case 'ExpansionFactor':
            program.properties.privateData[token] = this.readNumber();
            break;

          case 'ForceBold':
            program.properties.privateData[token] = this.readBoolean();
            break;
        }
      }

      for (var i = 0; i < charstrings.length; i++) {
        glyph = charstrings[i].glyph;
        encoded = charstrings[i].encoded;
        var charString = new Type1CharString();
        var error = charString.convert(encoded, subrs, this.seacAnalysisEnabled);
        var output = charString.output;

        if (error) {
          output = [14];
        }

        program.charstrings.push({
          glyphName: glyph,
          charstring: output,
          width: charString.width,
          lsb: charString.lsb,
          seac: charString.seac
        });
      }

      return program;
    },
    extractFontHeader: function Type1Parser_extractFontHeader(properties) {
      var token;

      while ((token = this.getToken()) !== null) {
        if (token !== '/') {
          continue;
        }

        token = this.getToken();

        switch (token) {
          case 'FontMatrix':
            var matrix = this.readNumberArray();
            properties.fontMatrix = matrix;
            break;

          case 'Encoding':
            var encodingArg = this.getToken();
            var encoding;

            if (!/^\d+$/.test(encodingArg)) {
              encoding = (0, _encodings.getEncoding)(encodingArg);
            } else {
              encoding = [];
              var size = parseInt(encodingArg, 10) | 0;
              this.getToken();

              for (var j = 0; j < size; j++) {
                token = this.getToken();

                while (token !== 'dup' && token !== 'def') {
                  token = this.getToken();

                  if (token === null) {
                    return;
                  }
                }

                if (token === 'def') {
                  break;
                }

                var index = this.readInt();
                this.getToken();
                var glyph = this.getToken();
                encoding[index] = glyph;
                this.getToken();
              }
            }

            properties.builtInEncoding = encoding;
            break;

          case 'FontBBox':
            var fontBBox = this.readNumberArray();
            properties.ascent = Math.max(fontBBox[3], fontBBox[1]);
            properties.descent = Math.min(fontBBox[1], fontBBox[3]);
            properties.ascentScaled = true;
            break;
        }
      }
    }
  };
  return Type1Parser;
}();

exports.Type1Parser = Type1Parser;

/***/ }),
/* 182 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTilingPatternIR = getTilingPatternIR;
exports.Pattern = void 0;

var _util = __w_pdfjs_require__(6);

var _colorspace = __w_pdfjs_require__(168);

var _primitives = __w_pdfjs_require__(155);

var ShadingType = {
  FUNCTION_BASED: 1,
  AXIAL: 2,
  RADIAL: 3,
  FREE_FORM_MESH: 4,
  LATTICE_FORM_MESH: 5,
  COONS_PATCH_MESH: 6,
  TENSOR_PATCH_MESH: 7
};

var Pattern = function PatternClosure() {
  function Pattern() {
    (0, _util.unreachable)('should not call Pattern constructor');
  }

  Pattern.prototype = {
    getPattern: function Pattern_getPattern(ctx) {
      (0, _util.unreachable)("Should not call Pattern.getStyle: ".concat(ctx));
    }
  };

  Pattern.parseShading = function (shading, matrix, xref, res, handler, pdfFunctionFactory) {
    var dict = (0, _primitives.isStream)(shading) ? shading.dict : shading;
    var type = dict.get('ShadingType');

    try {
      switch (type) {
        case ShadingType.AXIAL:
        case ShadingType.RADIAL:
          return new Shadings.RadialAxial(dict, matrix, xref, res, pdfFunctionFactory);

        case ShadingType.FREE_FORM_MESH:
        case ShadingType.LATTICE_FORM_MESH:
        case ShadingType.COONS_PATCH_MESH:
        case ShadingType.TENSOR_PATCH_MESH:
          return new Shadings.Mesh(shading, matrix, xref, res, pdfFunctionFactory);

        default:
          throw new _util.FormatError('Unsupported ShadingType: ' + type);
      }
    } catch (ex) {
      if (ex instanceof _util.MissingDataException) {
        throw ex;
      }

      handler.send('UnsupportedFeature', {
        featureId: _util.UNSUPPORTED_FEATURES.shadingPattern
      });
      (0, _util.warn)(ex);
      return new Shadings.Dummy();
    }
  };

  return Pattern;
}();

exports.Pattern = Pattern;
var Shadings = {};
Shadings.SMALL_NUMBER = 1e-6;

Shadings.RadialAxial = function RadialAxialClosure() {
  function RadialAxial(dict, matrix, xref, res, pdfFunctionFactory) {
    this.matrix = matrix;
    this.coordsArr = dict.getArray('Coords');
    this.shadingType = dict.get('ShadingType');
    this.type = 'Pattern';
    var cs = dict.get('ColorSpace', 'CS');
    cs = _colorspace.ColorSpace.parse(cs, xref, res, pdfFunctionFactory);
    this.cs = cs;
    var t0 = 0.0,
        t1 = 1.0;

    if (dict.has('Domain')) {
      var domainArr = dict.getArray('Domain');
      t0 = domainArr[0];
      t1 = domainArr[1];
    }

    var extendStart = false,
        extendEnd = false;

    if (dict.has('Extend')) {
      var extendArr = dict.getArray('Extend');
      extendStart = extendArr[0];
      extendEnd = extendArr[1];
    }

    if (this.shadingType === ShadingType.RADIAL && (!extendStart || !extendEnd)) {
      var x1 = this.coordsArr[0];
      var y1 = this.coordsArr[1];
      var r1 = this.coordsArr[2];
      var x2 = this.coordsArr[3];
      var y2 = this.coordsArr[4];
      var r2 = this.coordsArr[5];
      var distance = Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));

      if (r1 <= r2 + distance && r2 <= r1 + distance) {
        (0, _util.warn)('Unsupported radial gradient.');
      }
    }

    this.extendStart = extendStart;
    this.extendEnd = extendEnd;
    var fnObj = dict.get('Function');
    var fn = pdfFunctionFactory.createFromArray(fnObj);
    var diff = t1 - t0;
    var step = diff / 10;
    var colorStops = this.colorStops = [];

    if (t0 >= t1 || step <= 0) {
      (0, _util.info)('Bad shading domain.');
      return;
    }

    var color = new Float32Array(cs.numComps),
        ratio = new Float32Array(1);
    var rgbColor;

    for (var i = t0; i <= t1; i += step) {
      ratio[0] = i;
      fn(ratio, 0, color, 0);
      rgbColor = cs.getRgb(color, 0);

      var cssColor = _util.Util.makeCssRgb(rgbColor[0], rgbColor[1], rgbColor[2]);

      colorStops.push([(i - t0) / diff, cssColor]);
    }

    var background = 'transparent';

    if (dict.has('Background')) {
      rgbColor = cs.getRgb(dict.get('Background'), 0);
      background = _util.Util.makeCssRgb(rgbColor[0], rgbColor[1], rgbColor[2]);
    }

    if (!extendStart) {
      colorStops.unshift([0, background]);
      colorStops[1][0] += Shadings.SMALL_NUMBER;
    }

    if (!extendEnd) {
      colorStops[colorStops.length - 1][0] -= Shadings.SMALL_NUMBER;
      colorStops.push([1, background]);
    }

    this.colorStops = colorStops;
  }

  RadialAxial.prototype = {
    getIR: function RadialAxial_getIR() {
      var coordsArr = this.coordsArr;
      var shadingType = this.shadingType;
      var type, p0, p1, r0, r1;

      if (shadingType === ShadingType.AXIAL) {
        p0 = [coordsArr[0], coordsArr[1]];
        p1 = [coordsArr[2], coordsArr[3]];
        r0 = null;
        r1 = null;
        type = 'axial';
      } else if (shadingType === ShadingType.RADIAL) {
        p0 = [coordsArr[0], coordsArr[1]];
        p1 = [coordsArr[3], coordsArr[4]];
        r0 = coordsArr[2];
        r1 = coordsArr[5];
        type = 'radial';
      } else {
        (0, _util.unreachable)("getPattern type unknown: ".concat(shadingType));
      }

      var matrix = this.matrix;

      if (matrix) {
        p0 = _util.Util.applyTransform(p0, matrix);
        p1 = _util.Util.applyTransform(p1, matrix);

        if (shadingType === ShadingType.RADIAL) {
          var scale = _util.Util.singularValueDecompose2dScale(matrix);

          r0 *= scale[0];
          r1 *= scale[1];
        }
      }

      return ['RadialAxial', type, this.colorStops, p0, p1, r0, r1];
    }
  };
  return RadialAxial;
}();

Shadings.Mesh = function MeshClosure() {
  function MeshStreamReader(stream, context) {
    this.stream = stream;
    this.context = context;
    this.buffer = 0;
    this.bufferLength = 0;
    var numComps = context.numComps;
    this.tmpCompsBuf = new Float32Array(numComps);
    var csNumComps = context.colorSpace.numComps;
    this.tmpCsCompsBuf = context.colorFn ? new Float32Array(csNumComps) : this.tmpCompsBuf;
  }

  MeshStreamReader.prototype = {
    get hasData() {
      if (this.stream.end) {
        return this.stream.pos < this.stream.end;
      }

      if (this.bufferLength > 0) {
        return true;
      }

      var nextByte = this.stream.getByte();

      if (nextByte < 0) {
        return false;
      }

      this.buffer = nextByte;
      this.bufferLength = 8;
      return true;
    },

    readBits: function MeshStreamReader_readBits(n) {
      var buffer = this.buffer;
      var bufferLength = this.bufferLength;

      if (n === 32) {
        if (bufferLength === 0) {
          return (this.stream.getByte() << 24 | this.stream.getByte() << 16 | this.stream.getByte() << 8 | this.stream.getByte()) >>> 0;
        }

        buffer = buffer << 24 | this.stream.getByte() << 16 | this.stream.getByte() << 8 | this.stream.getByte();
        var nextByte = this.stream.getByte();
        this.buffer = nextByte & (1 << bufferLength) - 1;
        return (buffer << 8 - bufferLength | (nextByte & 0xFF) >> bufferLength) >>> 0;
      }

      if (n === 8 && bufferLength === 0) {
        return this.stream.getByte();
      }

      while (bufferLength < n) {
        buffer = buffer << 8 | this.stream.getByte();
        bufferLength += 8;
      }

      bufferLength -= n;
      this.bufferLength = bufferLength;
      this.buffer = buffer & (1 << bufferLength) - 1;
      return buffer >> bufferLength;
    },
    align: function MeshStreamReader_align() {
      this.buffer = 0;
      this.bufferLength = 0;
    },
    readFlag: function MeshStreamReader_readFlag() {
      return this.readBits(this.context.bitsPerFlag);
    },
    readCoordinate: function MeshStreamReader_readCoordinate() {
      var bitsPerCoordinate = this.context.bitsPerCoordinate;
      var xi = this.readBits(bitsPerCoordinate);
      var yi = this.readBits(bitsPerCoordinate);
      var decode = this.context.decode;
      var scale = bitsPerCoordinate < 32 ? 1 / ((1 << bitsPerCoordinate) - 1) : 2.3283064365386963e-10;
      return [xi * scale * (decode[1] - decode[0]) + decode[0], yi * scale * (decode[3] - decode[2]) + decode[2]];
    },
    readComponents: function MeshStreamReader_readComponents() {
      var numComps = this.context.numComps;
      var bitsPerComponent = this.context.bitsPerComponent;
      var scale = bitsPerComponent < 32 ? 1 / ((1 << bitsPerComponent) - 1) : 2.3283064365386963e-10;
      var decode = this.context.decode;
      var components = this.tmpCompsBuf;

      for (var i = 0, j = 4; i < numComps; i++, j += 2) {
        var ci = this.readBits(bitsPerComponent);
        components[i] = ci * scale * (decode[j + 1] - decode[j]) + decode[j];
      }

      var color = this.tmpCsCompsBuf;

      if (this.context.colorFn) {
        this.context.colorFn(components, 0, color, 0);
      }

      return this.context.colorSpace.getRgb(color, 0);
    }
  };

  function decodeType4Shading(mesh, reader) {
    var coords = mesh.coords;
    var colors = mesh.colors;
    var operators = [];
    var ps = [];
    var verticesLeft = 0;

    while (reader.hasData) {
      var f = reader.readFlag();
      var coord = reader.readCoordinate();
      var color = reader.readComponents();

      if (verticesLeft === 0) {
        if (!(0 <= f && f <= 2)) {
          throw new _util.FormatError('Unknown type4 flag');
        }

        switch (f) {
          case 0:
            verticesLeft = 3;
            break;

          case 1:
            ps.push(ps[ps.length - 2], ps[ps.length - 1]);
            verticesLeft = 1;
            break;

          case 2:
            ps.push(ps[ps.length - 3], ps[ps.length - 1]);
            verticesLeft = 1;
            break;
        }

        operators.push(f);
      }

      ps.push(coords.length);
      coords.push(coord);
      colors.push(color);
      verticesLeft--;
      reader.align();
    }

    mesh.figures.push({
      type: 'triangles',
      coords: new Int32Array(ps),
      colors: new Int32Array(ps)
    });
  }

  function decodeType5Shading(mesh, reader, verticesPerRow) {
    var coords = mesh.coords;
    var colors = mesh.colors;
    var ps = [];

    while (reader.hasData) {
      var coord = reader.readCoordinate();
      var color = reader.readComponents();
      ps.push(coords.length);
      coords.push(coord);
      colors.push(color);
    }

    mesh.figures.push({
      type: 'lattice',
      coords: new Int32Array(ps),
      colors: new Int32Array(ps),
      verticesPerRow: verticesPerRow
    });
  }

  var MIN_SPLIT_PATCH_CHUNKS_AMOUNT = 3;
  var MAX_SPLIT_PATCH_CHUNKS_AMOUNT = 20;
  var TRIANGLE_DENSITY = 20;

  var getB = function getBClosure() {
    function buildB(count) {
      var lut = [];

      for (var i = 0; i <= count; i++) {
        var t = i / count,
            t_ = 1 - t;
        lut.push(new Float32Array([t_ * t_ * t_, 3 * t * t_ * t_, 3 * t * t * t_, t * t * t]));
      }

      return lut;
    }

    var cache = [];
    return function getB(count) {
      if (!cache[count]) {
        cache[count] = buildB(count);
      }

      return cache[count];
    };
  }();

  function buildFigureFromPatch(mesh, index) {
    var figure = mesh.figures[index];
    (0, _util.assert)(figure.type === 'patch', 'Unexpected patch mesh figure');
    var coords = mesh.coords,
        colors = mesh.colors;
    var pi = figure.coords;
    var ci = figure.colors;
    var figureMinX = Math.min(coords[pi[0]][0], coords[pi[3]][0], coords[pi[12]][0], coords[pi[15]][0]);
    var figureMinY = Math.min(coords[pi[0]][1], coords[pi[3]][1], coords[pi[12]][1], coords[pi[15]][1]);
    var figureMaxX = Math.max(coords[pi[0]][0], coords[pi[3]][0], coords[pi[12]][0], coords[pi[15]][0]);
    var figureMaxY = Math.max(coords[pi[0]][1], coords[pi[3]][1], coords[pi[12]][1], coords[pi[15]][1]);
    var splitXBy = Math.ceil((figureMaxX - figureMinX) * TRIANGLE_DENSITY / (mesh.bounds[2] - mesh.bounds[0]));
    splitXBy = Math.max(MIN_SPLIT_PATCH_CHUNKS_AMOUNT, Math.min(MAX_SPLIT_PATCH_CHUNKS_AMOUNT, splitXBy));
    var splitYBy = Math.ceil((figureMaxY - figureMinY) * TRIANGLE_DENSITY / (mesh.bounds[3] - mesh.bounds[1]));
    splitYBy = Math.max(MIN_SPLIT_PATCH_CHUNKS_AMOUNT, Math.min(MAX_SPLIT_PATCH_CHUNKS_AMOUNT, splitYBy));
    var verticesPerRow = splitXBy + 1;
    var figureCoords = new Int32Array((splitYBy + 1) * verticesPerRow);
    var figureColors = new Int32Array((splitYBy + 1) * verticesPerRow);
    var k = 0;
    var cl = new Uint8Array(3),
        cr = new Uint8Array(3);
    var c0 = colors[ci[0]],
        c1 = colors[ci[1]],
        c2 = colors[ci[2]],
        c3 = colors[ci[3]];
    var bRow = getB(splitYBy),
        bCol = getB(splitXBy);

    for (var row = 0; row <= splitYBy; row++) {
      cl[0] = (c0[0] * (splitYBy - row) + c2[0] * row) / splitYBy | 0;
      cl[1] = (c0[1] * (splitYBy - row) + c2[1] * row) / splitYBy | 0;
      cl[2] = (c0[2] * (splitYBy - row) + c2[2] * row) / splitYBy | 0;
      cr[0] = (c1[0] * (splitYBy - row) + c3[0] * row) / splitYBy | 0;
      cr[1] = (c1[1] * (splitYBy - row) + c3[1] * row) / splitYBy | 0;
      cr[2] = (c1[2] * (splitYBy - row) + c3[2] * row) / splitYBy | 0;

      for (var col = 0; col <= splitXBy; col++, k++) {
        if ((row === 0 || row === splitYBy) && (col === 0 || col === splitXBy)) {
          continue;
        }

        var x = 0,
            y = 0;
        var q = 0;

        for (var i = 0; i <= 3; i++) {
          for (var j = 0; j <= 3; j++, q++) {
            var m = bRow[row][i] * bCol[col][j];
            x += coords[pi[q]][0] * m;
            y += coords[pi[q]][1] * m;
          }
        }

        figureCoords[k] = coords.length;
        coords.push([x, y]);
        figureColors[k] = colors.length;
        var newColor = new Uint8Array(3);
        newColor[0] = (cl[0] * (splitXBy - col) + cr[0] * col) / splitXBy | 0;
        newColor[1] = (cl[1] * (splitXBy - col) + cr[1] * col) / splitXBy | 0;
        newColor[2] = (cl[2] * (splitXBy - col) + cr[2] * col) / splitXBy | 0;
        colors.push(newColor);
      }
    }

    figureCoords[0] = pi[0];
    figureColors[0] = ci[0];
    figureCoords[splitXBy] = pi[3];
    figureColors[splitXBy] = ci[1];
    figureCoords[verticesPerRow * splitYBy] = pi[12];
    figureColors[verticesPerRow * splitYBy] = ci[2];
    figureCoords[verticesPerRow * splitYBy + splitXBy] = pi[15];
    figureColors[verticesPerRow * splitYBy + splitXBy] = ci[3];
    mesh.figures[index] = {
      type: 'lattice',
      coords: figureCoords,
      colors: figureColors,
      verticesPerRow: verticesPerRow
    };
  }

  function decodeType6Shading(mesh, reader) {
    var coords = mesh.coords;
    var colors = mesh.colors;
    var ps = new Int32Array(16);
    var cs = new Int32Array(4);

    while (reader.hasData) {
      var f = reader.readFlag();

      if (!(0 <= f && f <= 3)) {
        throw new _util.FormatError('Unknown type6 flag');
      }

      var i, ii;
      var pi = coords.length;

      for (i = 0, ii = f !== 0 ? 8 : 12; i < ii; i++) {
        coords.push(reader.readCoordinate());
      }

      var ci = colors.length;

      for (i = 0, ii = f !== 0 ? 2 : 4; i < ii; i++) {
        colors.push(reader.readComponents());
      }

      var tmp1, tmp2, tmp3, tmp4;

      switch (f) {
        case 0:
          ps[12] = pi + 3;
          ps[13] = pi + 4;
          ps[14] = pi + 5;
          ps[15] = pi + 6;
          ps[8] = pi + 2;
          ps[11] = pi + 7;
          ps[4] = pi + 1;
          ps[7] = pi + 8;
          ps[0] = pi;
          ps[1] = pi + 11;
          ps[2] = pi + 10;
          ps[3] = pi + 9;
          cs[2] = ci + 1;
          cs[3] = ci + 2;
          cs[0] = ci;
          cs[1] = ci + 3;
          break;

        case 1:
          tmp1 = ps[12];
          tmp2 = ps[13];
          tmp3 = ps[14];
          tmp4 = ps[15];
          ps[12] = tmp4;
          ps[13] = pi + 0;
          ps[14] = pi + 1;
          ps[15] = pi + 2;
          ps[8] = tmp3;
          ps[11] = pi + 3;
          ps[4] = tmp2;
          ps[7] = pi + 4;
          ps[0] = tmp1;
          ps[1] = pi + 7;
          ps[2] = pi + 6;
          ps[3] = pi + 5;
          tmp1 = cs[2];
          tmp2 = cs[3];
          cs[2] = tmp2;
          cs[3] = ci;
          cs[0] = tmp1;
          cs[1] = ci + 1;
          break;

        case 2:
          tmp1 = ps[15];
          tmp2 = ps[11];
          ps[12] = ps[3];
          ps[13] = pi + 0;
          ps[14] = pi + 1;
          ps[15] = pi + 2;
          ps[8] = ps[7];
          ps[11] = pi + 3;
          ps[4] = tmp2;
          ps[7] = pi + 4;
          ps[0] = tmp1;
          ps[1] = pi + 7;
          ps[2] = pi + 6;
          ps[3] = pi + 5;
          tmp1 = cs[3];
          cs[2] = cs[1];
          cs[3] = ci;
          cs[0] = tmp1;
          cs[1] = ci + 1;
          break;

        case 3:
          ps[12] = ps[0];
          ps[13] = pi + 0;
          ps[14] = pi + 1;
          ps[15] = pi + 2;
          ps[8] = ps[1];
          ps[11] = pi + 3;
          ps[4] = ps[2];
          ps[7] = pi + 4;
          ps[0] = ps[3];
          ps[1] = pi + 7;
          ps[2] = pi + 6;
          ps[3] = pi + 5;
          cs[2] = cs[0];
          cs[3] = ci;
          cs[0] = cs[1];
          cs[1] = ci + 1;
          break;
      }

      ps[5] = coords.length;
      coords.push([(-4 * coords[ps[0]][0] - coords[ps[15]][0] + 6 * (coords[ps[4]][0] + coords[ps[1]][0]) - 2 * (coords[ps[12]][0] + coords[ps[3]][0]) + 3 * (coords[ps[13]][0] + coords[ps[7]][0])) / 9, (-4 * coords[ps[0]][1] - coords[ps[15]][1] + 6 * (coords[ps[4]][1] + coords[ps[1]][1]) - 2 * (coords[ps[12]][1] + coords[ps[3]][1]) + 3 * (coords[ps[13]][1] + coords[ps[7]][1])) / 9]);
      ps[6] = coords.length;
      coords.push([(-4 * coords[ps[3]][0] - coords[ps[12]][0] + 6 * (coords[ps[2]][0] + coords[ps[7]][0]) - 2 * (coords[ps[0]][0] + coords[ps[15]][0]) + 3 * (coords[ps[4]][0] + coords[ps[14]][0])) / 9, (-4 * coords[ps[3]][1] - coords[ps[12]][1] + 6 * (coords[ps[2]][1] + coords[ps[7]][1]) - 2 * (coords[ps[0]][1] + coords[ps[15]][1]) + 3 * (coords[ps[4]][1] + coords[ps[14]][1])) / 9]);
      ps[9] = coords.length;
      coords.push([(-4 * coords[ps[12]][0] - coords[ps[3]][0] + 6 * (coords[ps[8]][0] + coords[ps[13]][0]) - 2 * (coords[ps[0]][0] + coords[ps[15]][0]) + 3 * (coords[ps[11]][0] + coords[ps[1]][0])) / 9, (-4 * coords[ps[12]][1] - coords[ps[3]][1] + 6 * (coords[ps[8]][1] + coords[ps[13]][1]) - 2 * (coords[ps[0]][1] + coords[ps[15]][1]) + 3 * (coords[ps[11]][1] + coords[ps[1]][1])) / 9]);
      ps[10] = coords.length;
      coords.push([(-4 * coords[ps[15]][0] - coords[ps[0]][0] + 6 * (coords[ps[11]][0] + coords[ps[14]][0]) - 2 * (coords[ps[12]][0] + coords[ps[3]][0]) + 3 * (coords[ps[2]][0] + coords[ps[8]][0])) / 9, (-4 * coords[ps[15]][1] - coords[ps[0]][1] + 6 * (coords[ps[11]][1] + coords[ps[14]][1]) - 2 * (coords[ps[12]][1] + coords[ps[3]][1]) + 3 * (coords[ps[2]][1] + coords[ps[8]][1])) / 9]);
      mesh.figures.push({
        type: 'patch',
        coords: new Int32Array(ps),
        colors: new Int32Array(cs)
      });
    }
  }

  function decodeType7Shading(mesh, reader) {
    var coords = mesh.coords;
    var colors = mesh.colors;
    var ps = new Int32Array(16);
    var cs = new Int32Array(4);

    while (reader.hasData) {
      var f = reader.readFlag();

      if (!(0 <= f && f <= 3)) {
        throw new _util.FormatError('Unknown type7 flag');
      }

      var i, ii;
      var pi = coords.length;

      for (i = 0, ii = f !== 0 ? 12 : 16; i < ii; i++) {
        coords.push(reader.readCoordinate());
      }

      var ci = colors.length;

      for (i = 0, ii = f !== 0 ? 2 : 4; i < ii; i++) {
        colors.push(reader.readComponents());
      }

      var tmp1, tmp2, tmp3, tmp4;

      switch (f) {
        case 0:
          ps[12] = pi + 3;
          ps[13] = pi + 4;
          ps[14] = pi + 5;
          ps[15] = pi + 6;
          ps[8] = pi + 2;
          ps[9] = pi + 13;
          ps[10] = pi + 14;
          ps[11] = pi + 7;
          ps[4] = pi + 1;
          ps[5] = pi + 12;
          ps[6] = pi + 15;
          ps[7] = pi + 8;
          ps[0] = pi;
          ps[1] = pi + 11;
          ps[2] = pi + 10;
          ps[3] = pi + 9;
          cs[2] = ci + 1;
          cs[3] = ci + 2;
          cs[0] = ci;
          cs[1] = ci + 3;
          break;

        case 1:
          tmp1 = ps[12];
          tmp2 = ps[13];
          tmp3 = ps[14];
          tmp4 = ps[15];
          ps[12] = tmp4;
          ps[13] = pi + 0;
          ps[14] = pi + 1;
          ps[15] = pi + 2;
          ps[8] = tmp3;
          ps[9] = pi + 9;
          ps[10] = pi + 10;
          ps[11] = pi + 3;
          ps[4] = tmp2;
          ps[5] = pi + 8;
          ps[6] = pi + 11;
          ps[7] = pi + 4;
          ps[0] = tmp1;
          ps[1] = pi + 7;
          ps[2] = pi + 6;
          ps[3] = pi + 5;
          tmp1 = cs[2];
          tmp2 = cs[3];
          cs[2] = tmp2;
          cs[3] = ci;
          cs[0] = tmp1;
          cs[1] = ci + 1;
          break;

        case 2:
          tmp1 = ps[15];
          tmp2 = ps[11];
          ps[12] = ps[3];
          ps[13] = pi + 0;
          ps[14] = pi + 1;
          ps[15] = pi + 2;
          ps[8] = ps[7];
          ps[9] = pi + 9;
          ps[10] = pi + 10;
          ps[11] = pi + 3;
          ps[4] = tmp2;
          ps[5] = pi + 8;
          ps[6] = pi + 11;
          ps[7] = pi + 4;
          ps[0] = tmp1;
          ps[1] = pi + 7;
          ps[2] = pi + 6;
          ps[3] = pi + 5;
          tmp1 = cs[3];
          cs[2] = cs[1];
          cs[3] = ci;
          cs[0] = tmp1;
          cs[1] = ci + 1;
          break;

        case 3:
          ps[12] = ps[0];
          ps[13] = pi + 0;
          ps[14] = pi + 1;
          ps[15] = pi + 2;
          ps[8] = ps[1];
          ps[9] = pi + 9;
          ps[10] = pi + 10;
          ps[11] = pi + 3;
          ps[4] = ps[2];
          ps[5] = pi + 8;
          ps[6] = pi + 11;
          ps[7] = pi + 4;
          ps[0] = ps[3];
          ps[1] = pi + 7;
          ps[2] = pi + 6;
          ps[3] = pi + 5;
          cs[2] = cs[0];
          cs[3] = ci;
          cs[0] = cs[1];
          cs[1] = ci + 1;
          break;
      }

      mesh.figures.push({
        type: 'patch',
        coords: new Int32Array(ps),
        colors: new Int32Array(cs)
      });
    }
  }

  function updateBounds(mesh) {
    var minX = mesh.coords[0][0],
        minY = mesh.coords[0][1],
        maxX = minX,
        maxY = minY;

    for (var i = 1, ii = mesh.coords.length; i < ii; i++) {
      var x = mesh.coords[i][0],
          y = mesh.coords[i][1];
      minX = minX > x ? x : minX;
      minY = minY > y ? y : minY;
      maxX = maxX < x ? x : maxX;
      maxY = maxY < y ? y : maxY;
    }

    mesh.bounds = [minX, minY, maxX, maxY];
  }

  function packData(mesh) {
    var i, ii, j, jj;
    var coords = mesh.coords;
    var coordsPacked = new Float32Array(coords.length * 2);

    for (i = 0, j = 0, ii = coords.length; i < ii; i++) {
      var xy = coords[i];
      coordsPacked[j++] = xy[0];
      coordsPacked[j++] = xy[1];
    }

    mesh.coords = coordsPacked;
    var colors = mesh.colors;
    var colorsPacked = new Uint8Array(colors.length * 3);

    for (i = 0, j = 0, ii = colors.length; i < ii; i++) {
      var c = colors[i];
      colorsPacked[j++] = c[0];
      colorsPacked[j++] = c[1];
      colorsPacked[j++] = c[2];
    }

    mesh.colors = colorsPacked;
    var figures = mesh.figures;

    for (i = 0, ii = figures.length; i < ii; i++) {
      var figure = figures[i],
          ps = figure.coords,
          cs = figure.colors;

      for (j = 0, jj = ps.length; j < jj; j++) {
        ps[j] *= 2;
        cs[j] *= 3;
      }
    }
  }

  function Mesh(stream, matrix, xref, res, pdfFunctionFactory) {
    if (!(0, _primitives.isStream)(stream)) {
      throw new _util.FormatError('Mesh data is not a stream');
    }

    var dict = stream.dict;
    this.matrix = matrix;
    this.shadingType = dict.get('ShadingType');
    this.type = 'Pattern';
    this.bbox = dict.getArray('BBox');
    var cs = dict.get('ColorSpace', 'CS');
    cs = _colorspace.ColorSpace.parse(cs, xref, res, pdfFunctionFactory);
    this.cs = cs;
    this.background = dict.has('Background') ? cs.getRgb(dict.get('Background'), 0) : null;
    var fnObj = dict.get('Function');
    var fn = fnObj ? pdfFunctionFactory.createFromArray(fnObj) : null;
    this.coords = [];
    this.colors = [];
    this.figures = [];
    var decodeContext = {
      bitsPerCoordinate: dict.get('BitsPerCoordinate'),
      bitsPerComponent: dict.get('BitsPerComponent'),
      bitsPerFlag: dict.get('BitsPerFlag'),
      decode: dict.getArray('Decode'),
      colorFn: fn,
      colorSpace: cs,
      numComps: fn ? 1 : cs.numComps
    };
    var reader = new MeshStreamReader(stream, decodeContext);
    var patchMesh = false;

    switch (this.shadingType) {
      case ShadingType.FREE_FORM_MESH:
        decodeType4Shading(this, reader);
        break;

      case ShadingType.LATTICE_FORM_MESH:
        var verticesPerRow = dict.get('VerticesPerRow') | 0;

        if (verticesPerRow < 2) {
          throw new _util.FormatError('Invalid VerticesPerRow');
        }

        decodeType5Shading(this, reader, verticesPerRow);
        break;

      case ShadingType.COONS_PATCH_MESH:
        decodeType6Shading(this, reader);
        patchMesh = true;
        break;

      case ShadingType.TENSOR_PATCH_MESH:
        decodeType7Shading(this, reader);
        patchMesh = true;
        break;

      default:
        (0, _util.unreachable)('Unsupported mesh type.');
        break;
    }

    if (patchMesh) {
      updateBounds(this);

      for (var i = 0, ii = this.figures.length; i < ii; i++) {
        buildFigureFromPatch(this, i);
      }
    }

    updateBounds(this);
    packData(this);
  }

  Mesh.prototype = {
    getIR: function Mesh_getIR() {
      return ['Mesh', this.shadingType, this.coords, this.colors, this.figures, this.bounds, this.matrix, this.bbox, this.background];
    }
  };
  return Mesh;
}();

Shadings.Dummy = function DummyClosure() {
  function Dummy() {
    this.type = 'Pattern';
  }

  Dummy.prototype = {
    getIR: function Dummy_getIR() {
      return ['Dummy'];
    }
  };
  return Dummy;
}();

function getTilingPatternIR(operatorList, dict, args) {
  var matrix = dict.getArray('Matrix');

  var bbox = _util.Util.normalizeRect(dict.getArray('BBox'));

  var xstep = dict.get('XStep');
  var ystep = dict.get('YStep');
  var paintType = dict.get('PaintType');
  var tilingType = dict.get('TilingType');

  if (bbox[2] - bbox[0] === 0 || bbox[3] - bbox[1] === 0) {
    throw new _util.FormatError("Invalid getTilingPatternIR /BBox array: [".concat(bbox, "]."));
  }

  return ['TilingPattern', args, operatorList, matrix, bbox, xstep, ystep, paintType, tilingType];
}

/***/ }),
/* 183 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bidi = bidi;

var _util = __w_pdfjs_require__(6);

var baseTypes = ['BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'S', 'B', 'S', 'WS', 'B', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'B', 'B', 'B', 'S', 'WS', 'ON', 'ON', 'ET', 'ET', 'ET', 'ON', 'ON', 'ON', 'ON', 'ON', 'ES', 'CS', 'ES', 'CS', 'CS', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'CS', 'ON', 'ON', 'ON', 'ON', 'ON', 'ON', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'ON', 'ON', 'ON', 'ON', 'ON', 'ON', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'ON', 'ON', 'ON', 'ON', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'B', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'BN', 'CS', 'ON', 'ET', 'ET', 'ET', 'ET', 'ON', 'ON', 'ON', 'ON', 'L', 'ON', 'ON', 'BN', 'ON', 'ON', 'ET', 'ET', 'EN', 'EN', 'ON', 'L', 'ON', 'ON', 'ON', 'EN', 'L', 'ON', 'ON', 'ON', 'ON', 'ON', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'ON', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'ON', 'L', 'L', 'L', 'L', 'L', 'L', 'L', 'L'];
var arabicTypes = ['AN', 'AN', 'AN', 'AN', 'AN', 'AN', 'ON', 'ON', 'AL', 'ET', 'ET', 'AL', 'CS', 'AL', 'ON', 'ON', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'AL', 'AL', '', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'AN', 'AN', 'AN', 'AN', 'AN', 'AN', 'AN', 'AN', 'AN', 'AN', 'ET', 'AN', 'AN', 'AL', 'AL', 'AL', 'NSM', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'AN', 'ON', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'NSM', 'AL', 'AL', 'NSM', 'NSM', 'ON', 'NSM', 'NSM', 'NSM', 'NSM', 'AL', 'AL', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'EN', 'AL', 'AL', 'AL', 'AL', 'AL', 'AL'];

function isOdd(i) {
  return (i & 1) !== 0;
}

function isEven(i) {
  return (i & 1) === 0;
}

function findUnequal(arr, start, value) {
  for (var j = start, jj = arr.length; j < jj; ++j) {
    if (arr[j] !== value) {
      return j;
    }
  }

  return j;
}

function setValues(arr, start, end, value) {
  for (var j = start; j < end; ++j) {
    arr[j] = value;
  }
}

function reverseValues(arr, start, end) {
  for (var i = start, j = end - 1; i < j; ++i, --j) {
    var temp = arr[i];
    arr[i] = arr[j];
    arr[j] = temp;
  }
}

function createBidiText(str, isLTR, vertical) {
  return {
    str: str,
    dir: vertical ? 'ttb' : isLTR ? 'ltr' : 'rtl'
  };
}

var chars = [];
var types = [];

function bidi(str, startLevel, vertical) {
  var isLTR = true;
  var strLength = str.length;

  if (strLength === 0 || vertical) {
    return createBidiText(str, isLTR, vertical);
  }

  chars.length = strLength;
  types.length = strLength;
  var numBidi = 0;
  var i, ii;

  for (i = 0; i < strLength; ++i) {
    chars[i] = str.charAt(i);
    var charCode = str.charCodeAt(i);
    var charType = 'L';

    if (charCode <= 0x00ff) {
      charType = baseTypes[charCode];
    } else if (0x0590 <= charCode && charCode <= 0x05f4) {
      charType = 'R';
    } else if (0x0600 <= charCode && charCode <= 0x06ff) {
      charType = arabicTypes[charCode & 0xff];

      if (!charType) {
        (0, _util.warn)('Bidi: invalid Unicode character ' + charCode.toString(16));
      }
    } else if (0x0700 <= charCode && charCode <= 0x08AC) {
      charType = 'AL';
    }

    if (charType === 'R' || charType === 'AL' || charType === 'AN') {
      numBidi++;
    }

    types[i] = charType;
  }

  if (numBidi === 0) {
    isLTR = true;
    return createBidiText(str, isLTR);
  }

  if (startLevel === -1) {
    if (numBidi / strLength < 0.3) {
      isLTR = true;
      startLevel = 0;
    } else {
      isLTR = false;
      startLevel = 1;
    }
  }

  var levels = [];

  for (i = 0; i < strLength; ++i) {
    levels[i] = startLevel;
  }

  var e = isOdd(startLevel) ? 'R' : 'L';
  var sor = e;
  var eor = sor;
  var lastType = sor;

  for (i = 0; i < strLength; ++i) {
    if (types[i] === 'NSM') {
      types[i] = lastType;
    } else {
      lastType = types[i];
    }
  }

  lastType = sor;
  var t;

  for (i = 0; i < strLength; ++i) {
    t = types[i];

    if (t === 'EN') {
      types[i] = lastType === 'AL' ? 'AN' : 'EN';
    } else if (t === 'R' || t === 'L' || t === 'AL') {
      lastType = t;
    }
  }

  for (i = 0; i < strLength; ++i) {
    t = types[i];

    if (t === 'AL') {
      types[i] = 'R';
    }
  }

  for (i = 1; i < strLength - 1; ++i) {
    if (types[i] === 'ES' && types[i - 1] === 'EN' && types[i + 1] === 'EN') {
      types[i] = 'EN';
    }

    if (types[i] === 'CS' && (types[i - 1] === 'EN' || types[i - 1] === 'AN') && types[i + 1] === types[i - 1]) {
      types[i] = types[i - 1];
    }
  }

  for (i = 0; i < strLength; ++i) {
    if (types[i] === 'EN') {
      var j;

      for (j = i - 1; j >= 0; --j) {
        if (types[j] !== 'ET') {
          break;
        }

        types[j] = 'EN';
      }

      for (j = i + 1; j < strLength; ++j) {
        if (types[j] !== 'ET') {
          break;
        }

        types[j] = 'EN';
      }
    }
  }

  for (i = 0; i < strLength; ++i) {
    t = types[i];

    if (t === 'WS' || t === 'ES' || t === 'ET' || t === 'CS') {
      types[i] = 'ON';
    }
  }

  lastType = sor;

  for (i = 0; i < strLength; ++i) {
    t = types[i];

    if (t === 'EN') {
      types[i] = lastType === 'L' ? 'L' : 'EN';
    } else if (t === 'R' || t === 'L') {
      lastType = t;
    }
  }

  for (i = 0; i < strLength; ++i) {
    if (types[i] === 'ON') {
      var end = findUnequal(types, i + 1, 'ON');
      var before = sor;

      if (i > 0) {
        before = types[i - 1];
      }

      var after = eor;

      if (end + 1 < strLength) {
        after = types[end + 1];
      }

      if (before !== 'L') {
        before = 'R';
      }

      if (after !== 'L') {
        after = 'R';
      }

      if (before === after) {
        setValues(types, i, end, before);
      }

      i = end - 1;
    }
  }

  for (i = 0; i < strLength; ++i) {
    if (types[i] === 'ON') {
      types[i] = e;
    }
  }

  for (i = 0; i < strLength; ++i) {
    t = types[i];

    if (isEven(levels[i])) {
      if (t === 'R') {
        levels[i] += 1;
      } else if (t === 'AN' || t === 'EN') {
        levels[i] += 2;
      }
    } else {
      if (t === 'L' || t === 'AN' || t === 'EN') {
        levels[i] += 1;
      }
    }
  }

  var highestLevel = -1;
  var lowestOddLevel = 99;
  var level;

  for (i = 0, ii = levels.length; i < ii; ++i) {
    level = levels[i];

    if (highestLevel < level) {
      highestLevel = level;
    }

    if (lowestOddLevel > level && isOdd(level)) {
      lowestOddLevel = level;
    }
  }

  for (level = highestLevel; level >= lowestOddLevel; --level) {
    var start = -1;

    for (i = 0, ii = levels.length; i < ii; ++i) {
      if (levels[i] < level) {
        if (start >= 0) {
          reverseValues(chars, start, i);
          start = -1;
        }
      } else if (start < 0) {
        start = i;
      }
    }

    if (start >= 0) {
      reverseValues(chars, start, levels.length);
    }
  }

  for (i = 0, ii = chars.length; i < ii; ++i) {
    var ch = chars[i];

    if (ch === '<' || ch === '>') {
      chars[i] = '';
    }
  }

  return createBidiText(chars.join(''), isLTR);
}

/***/ }),
/* 184 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMetrics = void 0;

var _util = __w_pdfjs_require__(6);

var getMetrics = (0, _util.getLookupTableFactory)(function (t) {
  t['Courier'] = 600;
  t['Courier-Bold'] = 600;
  t['Courier-BoldOblique'] = 600;
  t['Courier-Oblique'] = 600;
  t['Helvetica'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 278;
    t['exclam'] = 278;
    t['quotedbl'] = 355;
    t['numbersign'] = 556;
    t['dollar'] = 556;
    t['percent'] = 889;
    t['ampersand'] = 667;
    t['quoteright'] = 222;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 389;
    t['plus'] = 584;
    t['comma'] = 278;
    t['hyphen'] = 333;
    t['period'] = 278;
    t['slash'] = 278;
    t['zero'] = 556;
    t['one'] = 556;
    t['two'] = 556;
    t['three'] = 556;
    t['four'] = 556;
    t['five'] = 556;
    t['six'] = 556;
    t['seven'] = 556;
    t['eight'] = 556;
    t['nine'] = 556;
    t['colon'] = 278;
    t['semicolon'] = 278;
    t['less'] = 584;
    t['equal'] = 584;
    t['greater'] = 584;
    t['question'] = 556;
    t['at'] = 1015;
    t['A'] = 667;
    t['B'] = 667;
    t['C'] = 722;
    t['D'] = 722;
    t['E'] = 667;
    t['F'] = 611;
    t['G'] = 778;
    t['H'] = 722;
    t['I'] = 278;
    t['J'] = 500;
    t['K'] = 667;
    t['L'] = 556;
    t['M'] = 833;
    t['N'] = 722;
    t['O'] = 778;
    t['P'] = 667;
    t['Q'] = 778;
    t['R'] = 722;
    t['S'] = 667;
    t['T'] = 611;
    t['U'] = 722;
    t['V'] = 667;
    t['W'] = 944;
    t['X'] = 667;
    t['Y'] = 667;
    t['Z'] = 611;
    t['bracketleft'] = 278;
    t['backslash'] = 278;
    t['bracketright'] = 278;
    t['asciicircum'] = 469;
    t['underscore'] = 556;
    t['quoteleft'] = 222;
    t['a'] = 556;
    t['b'] = 556;
    t['c'] = 500;
    t['d'] = 556;
    t['e'] = 556;
    t['f'] = 278;
    t['g'] = 556;
    t['h'] = 556;
    t['i'] = 222;
    t['j'] = 222;
    t['k'] = 500;
    t['l'] = 222;
    t['m'] = 833;
    t['n'] = 556;
    t['o'] = 556;
    t['p'] = 556;
    t['q'] = 556;
    t['r'] = 333;
    t['s'] = 500;
    t['t'] = 278;
    t['u'] = 556;
    t['v'] = 500;
    t['w'] = 722;
    t['x'] = 500;
    t['y'] = 500;
    t['z'] = 500;
    t['braceleft'] = 334;
    t['bar'] = 260;
    t['braceright'] = 334;
    t['asciitilde'] = 584;
    t['exclamdown'] = 333;
    t['cent'] = 556;
    t['sterling'] = 556;
    t['fraction'] = 167;
    t['yen'] = 556;
    t['florin'] = 556;
    t['section'] = 556;
    t['currency'] = 556;
    t['quotesingle'] = 191;
    t['quotedblleft'] = 333;
    t['guillemotleft'] = 556;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 500;
    t['fl'] = 500;
    t['endash'] = 556;
    t['dagger'] = 556;
    t['daggerdbl'] = 556;
    t['periodcentered'] = 278;
    t['paragraph'] = 537;
    t['bullet'] = 350;
    t['quotesinglbase'] = 222;
    t['quotedblbase'] = 333;
    t['quotedblright'] = 333;
    t['guillemotright'] = 556;
    t['ellipsis'] = 1000;
    t['perthousand'] = 1000;
    t['questiondown'] = 611;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 1000;
    t['AE'] = 1000;
    t['ordfeminine'] = 370;
    t['Lslash'] = 556;
    t['Oslash'] = 778;
    t['OE'] = 1000;
    t['ordmasculine'] = 365;
    t['ae'] = 889;
    t['dotlessi'] = 278;
    t['lslash'] = 222;
    t['oslash'] = 611;
    t['oe'] = 944;
    t['germandbls'] = 611;
    t['Idieresis'] = 278;
    t['eacute'] = 556;
    t['abreve'] = 556;
    t['uhungarumlaut'] = 556;
    t['ecaron'] = 556;
    t['Ydieresis'] = 667;
    t['divide'] = 584;
    t['Yacute'] = 667;
    t['Acircumflex'] = 667;
    t['aacute'] = 556;
    t['Ucircumflex'] = 722;
    t['yacute'] = 500;
    t['scommaaccent'] = 500;
    t['ecircumflex'] = 556;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 556;
    t['Uacute'] = 722;
    t['uogonek'] = 556;
    t['Edieresis'] = 667;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 737;
    t['Emacron'] = 667;
    t['ccaron'] = 500;
    t['aring'] = 556;
    t['Ncommaaccent'] = 722;
    t['lacute'] = 222;
    t['agrave'] = 556;
    t['Tcommaaccent'] = 611;
    t['Cacute'] = 722;
    t['atilde'] = 556;
    t['Edotaccent'] = 667;
    t['scaron'] = 500;
    t['scedilla'] = 500;
    t['iacute'] = 278;
    t['lozenge'] = 471;
    t['Rcaron'] = 722;
    t['Gcommaaccent'] = 778;
    t['ucircumflex'] = 556;
    t['acircumflex'] = 556;
    t['Amacron'] = 667;
    t['rcaron'] = 333;
    t['ccedilla'] = 500;
    t['Zdotaccent'] = 611;
    t['Thorn'] = 667;
    t['Omacron'] = 778;
    t['Racute'] = 722;
    t['Sacute'] = 667;
    t['dcaron'] = 643;
    t['Umacron'] = 722;
    t['uring'] = 556;
    t['threesuperior'] = 333;
    t['Ograve'] = 778;
    t['Agrave'] = 667;
    t['Abreve'] = 667;
    t['multiply'] = 584;
    t['uacute'] = 556;
    t['Tcaron'] = 611;
    t['partialdiff'] = 476;
    t['ydieresis'] = 500;
    t['Nacute'] = 722;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 667;
    t['adieresis'] = 556;
    t['edieresis'] = 556;
    t['cacute'] = 500;
    t['nacute'] = 556;
    t['umacron'] = 556;
    t['Ncaron'] = 722;
    t['Iacute'] = 278;
    t['plusminus'] = 584;
    t['brokenbar'] = 260;
    t['registered'] = 737;
    t['Gbreve'] = 778;
    t['Idotaccent'] = 278;
    t['summation'] = 600;
    t['Egrave'] = 667;
    t['racute'] = 333;
    t['omacron'] = 556;
    t['Zacute'] = 611;
    t['Zcaron'] = 611;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 722;
    t['lcommaaccent'] = 222;
    t['tcaron'] = 317;
    t['eogonek'] = 556;
    t['Uogonek'] = 722;
    t['Aacute'] = 667;
    t['Adieresis'] = 667;
    t['egrave'] = 556;
    t['zacute'] = 500;
    t['iogonek'] = 222;
    t['Oacute'] = 778;
    t['oacute'] = 556;
    t['amacron'] = 556;
    t['sacute'] = 500;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 778;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 556;
    t['twosuperior'] = 333;
    t['Odieresis'] = 778;
    t['mu'] = 556;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 556;
    t['Eogonek'] = 667;
    t['dcroat'] = 556;
    t['threequarters'] = 834;
    t['Scedilla'] = 667;
    t['lcaron'] = 299;
    t['Kcommaaccent'] = 667;
    t['Lacute'] = 556;
    t['trademark'] = 1000;
    t['edotaccent'] = 556;
    t['Igrave'] = 278;
    t['Imacron'] = 278;
    t['Lcaron'] = 556;
    t['onehalf'] = 834;
    t['lessequal'] = 549;
    t['ocircumflex'] = 556;
    t['ntilde'] = 556;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 667;
    t['emacron'] = 556;
    t['gbreve'] = 556;
    t['onequarter'] = 834;
    t['Scaron'] = 667;
    t['Scommaaccent'] = 667;
    t['Ohungarumlaut'] = 778;
    t['degree'] = 400;
    t['ograve'] = 556;
    t['Ccaron'] = 722;
    t['ugrave'] = 556;
    t['radical'] = 453;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 333;
    t['Ntilde'] = 722;
    t['otilde'] = 556;
    t['Rcommaaccent'] = 722;
    t['Lcommaaccent'] = 556;
    t['Atilde'] = 667;
    t['Aogonek'] = 667;
    t['Aring'] = 667;
    t['Otilde'] = 778;
    t['zdotaccent'] = 500;
    t['Ecaron'] = 667;
    t['Iogonek'] = 278;
    t['kcommaaccent'] = 500;
    t['minus'] = 584;
    t['Icircumflex'] = 278;
    t['ncaron'] = 556;
    t['tcommaaccent'] = 278;
    t['logicalnot'] = 584;
    t['odieresis'] = 556;
    t['udieresis'] = 556;
    t['notequal'] = 549;
    t['gcommaaccent'] = 556;
    t['eth'] = 556;
    t['zcaron'] = 500;
    t['ncommaaccent'] = 556;
    t['onesuperior'] = 333;
    t['imacron'] = 278;
    t['Euro'] = 556;
  });
  t['Helvetica-Bold'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 278;
    t['exclam'] = 333;
    t['quotedbl'] = 474;
    t['numbersign'] = 556;
    t['dollar'] = 556;
    t['percent'] = 889;
    t['ampersand'] = 722;
    t['quoteright'] = 278;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 389;
    t['plus'] = 584;
    t['comma'] = 278;
    t['hyphen'] = 333;
    t['period'] = 278;
    t['slash'] = 278;
    t['zero'] = 556;
    t['one'] = 556;
    t['two'] = 556;
    t['three'] = 556;
    t['four'] = 556;
    t['five'] = 556;
    t['six'] = 556;
    t['seven'] = 556;
    t['eight'] = 556;
    t['nine'] = 556;
    t['colon'] = 333;
    t['semicolon'] = 333;
    t['less'] = 584;
    t['equal'] = 584;
    t['greater'] = 584;
    t['question'] = 611;
    t['at'] = 975;
    t['A'] = 722;
    t['B'] = 722;
    t['C'] = 722;
    t['D'] = 722;
    t['E'] = 667;
    t['F'] = 611;
    t['G'] = 778;
    t['H'] = 722;
    t['I'] = 278;
    t['J'] = 556;
    t['K'] = 722;
    t['L'] = 611;
    t['M'] = 833;
    t['N'] = 722;
    t['O'] = 778;
    t['P'] = 667;
    t['Q'] = 778;
    t['R'] = 722;
    t['S'] = 667;
    t['T'] = 611;
    t['U'] = 722;
    t['V'] = 667;
    t['W'] = 944;
    t['X'] = 667;
    t['Y'] = 667;
    t['Z'] = 611;
    t['bracketleft'] = 333;
    t['backslash'] = 278;
    t['bracketright'] = 333;
    t['asciicircum'] = 584;
    t['underscore'] = 556;
    t['quoteleft'] = 278;
    t['a'] = 556;
    t['b'] = 611;
    t['c'] = 556;
    t['d'] = 611;
    t['e'] = 556;
    t['f'] = 333;
    t['g'] = 611;
    t['h'] = 611;
    t['i'] = 278;
    t['j'] = 278;
    t['k'] = 556;
    t['l'] = 278;
    t['m'] = 889;
    t['n'] = 611;
    t['o'] = 611;
    t['p'] = 611;
    t['q'] = 611;
    t['r'] = 389;
    t['s'] = 556;
    t['t'] = 333;
    t['u'] = 611;
    t['v'] = 556;
    t['w'] = 778;
    t['x'] = 556;
    t['y'] = 556;
    t['z'] = 500;
    t['braceleft'] = 389;
    t['bar'] = 280;
    t['braceright'] = 389;
    t['asciitilde'] = 584;
    t['exclamdown'] = 333;
    t['cent'] = 556;
    t['sterling'] = 556;
    t['fraction'] = 167;
    t['yen'] = 556;
    t['florin'] = 556;
    t['section'] = 556;
    t['currency'] = 556;
    t['quotesingle'] = 238;
    t['quotedblleft'] = 500;
    t['guillemotleft'] = 556;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 611;
    t['fl'] = 611;
    t['endash'] = 556;
    t['dagger'] = 556;
    t['daggerdbl'] = 556;
    t['periodcentered'] = 278;
    t['paragraph'] = 556;
    t['bullet'] = 350;
    t['quotesinglbase'] = 278;
    t['quotedblbase'] = 500;
    t['quotedblright'] = 500;
    t['guillemotright'] = 556;
    t['ellipsis'] = 1000;
    t['perthousand'] = 1000;
    t['questiondown'] = 611;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 1000;
    t['AE'] = 1000;
    t['ordfeminine'] = 370;
    t['Lslash'] = 611;
    t['Oslash'] = 778;
    t['OE'] = 1000;
    t['ordmasculine'] = 365;
    t['ae'] = 889;
    t['dotlessi'] = 278;
    t['lslash'] = 278;
    t['oslash'] = 611;
    t['oe'] = 944;
    t['germandbls'] = 611;
    t['Idieresis'] = 278;
    t['eacute'] = 556;
    t['abreve'] = 556;
    t['uhungarumlaut'] = 611;
    t['ecaron'] = 556;
    t['Ydieresis'] = 667;
    t['divide'] = 584;
    t['Yacute'] = 667;
    t['Acircumflex'] = 722;
    t['aacute'] = 556;
    t['Ucircumflex'] = 722;
    t['yacute'] = 556;
    t['scommaaccent'] = 556;
    t['ecircumflex'] = 556;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 556;
    t['Uacute'] = 722;
    t['uogonek'] = 611;
    t['Edieresis'] = 667;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 737;
    t['Emacron'] = 667;
    t['ccaron'] = 556;
    t['aring'] = 556;
    t['Ncommaaccent'] = 722;
    t['lacute'] = 278;
    t['agrave'] = 556;
    t['Tcommaaccent'] = 611;
    t['Cacute'] = 722;
    t['atilde'] = 556;
    t['Edotaccent'] = 667;
    t['scaron'] = 556;
    t['scedilla'] = 556;
    t['iacute'] = 278;
    t['lozenge'] = 494;
    t['Rcaron'] = 722;
    t['Gcommaaccent'] = 778;
    t['ucircumflex'] = 611;
    t['acircumflex'] = 556;
    t['Amacron'] = 722;
    t['rcaron'] = 389;
    t['ccedilla'] = 556;
    t['Zdotaccent'] = 611;
    t['Thorn'] = 667;
    t['Omacron'] = 778;
    t['Racute'] = 722;
    t['Sacute'] = 667;
    t['dcaron'] = 743;
    t['Umacron'] = 722;
    t['uring'] = 611;
    t['threesuperior'] = 333;
    t['Ograve'] = 778;
    t['Agrave'] = 722;
    t['Abreve'] = 722;
    t['multiply'] = 584;
    t['uacute'] = 611;
    t['Tcaron'] = 611;
    t['partialdiff'] = 494;
    t['ydieresis'] = 556;
    t['Nacute'] = 722;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 667;
    t['adieresis'] = 556;
    t['edieresis'] = 556;
    t['cacute'] = 556;
    t['nacute'] = 611;
    t['umacron'] = 611;
    t['Ncaron'] = 722;
    t['Iacute'] = 278;
    t['plusminus'] = 584;
    t['brokenbar'] = 280;
    t['registered'] = 737;
    t['Gbreve'] = 778;
    t['Idotaccent'] = 278;
    t['summation'] = 600;
    t['Egrave'] = 667;
    t['racute'] = 389;
    t['omacron'] = 611;
    t['Zacute'] = 611;
    t['Zcaron'] = 611;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 722;
    t['lcommaaccent'] = 278;
    t['tcaron'] = 389;
    t['eogonek'] = 556;
    t['Uogonek'] = 722;
    t['Aacute'] = 722;
    t['Adieresis'] = 722;
    t['egrave'] = 556;
    t['zacute'] = 500;
    t['iogonek'] = 278;
    t['Oacute'] = 778;
    t['oacute'] = 611;
    t['amacron'] = 556;
    t['sacute'] = 556;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 778;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 611;
    t['twosuperior'] = 333;
    t['Odieresis'] = 778;
    t['mu'] = 611;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 611;
    t['Eogonek'] = 667;
    t['dcroat'] = 611;
    t['threequarters'] = 834;
    t['Scedilla'] = 667;
    t['lcaron'] = 400;
    t['Kcommaaccent'] = 722;
    t['Lacute'] = 611;
    t['trademark'] = 1000;
    t['edotaccent'] = 556;
    t['Igrave'] = 278;
    t['Imacron'] = 278;
    t['Lcaron'] = 611;
    t['onehalf'] = 834;
    t['lessequal'] = 549;
    t['ocircumflex'] = 611;
    t['ntilde'] = 611;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 667;
    t['emacron'] = 556;
    t['gbreve'] = 611;
    t['onequarter'] = 834;
    t['Scaron'] = 667;
    t['Scommaaccent'] = 667;
    t['Ohungarumlaut'] = 778;
    t['degree'] = 400;
    t['ograve'] = 611;
    t['Ccaron'] = 722;
    t['ugrave'] = 611;
    t['radical'] = 549;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 389;
    t['Ntilde'] = 722;
    t['otilde'] = 611;
    t['Rcommaaccent'] = 722;
    t['Lcommaaccent'] = 611;
    t['Atilde'] = 722;
    t['Aogonek'] = 722;
    t['Aring'] = 722;
    t['Otilde'] = 778;
    t['zdotaccent'] = 500;
    t['Ecaron'] = 667;
    t['Iogonek'] = 278;
    t['kcommaaccent'] = 556;
    t['minus'] = 584;
    t['Icircumflex'] = 278;
    t['ncaron'] = 611;
    t['tcommaaccent'] = 333;
    t['logicalnot'] = 584;
    t['odieresis'] = 611;
    t['udieresis'] = 611;
    t['notequal'] = 549;
    t['gcommaaccent'] = 611;
    t['eth'] = 611;
    t['zcaron'] = 500;
    t['ncommaaccent'] = 611;
    t['onesuperior'] = 333;
    t['imacron'] = 278;
    t['Euro'] = 556;
  });
  t['Helvetica-BoldOblique'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 278;
    t['exclam'] = 333;
    t['quotedbl'] = 474;
    t['numbersign'] = 556;
    t['dollar'] = 556;
    t['percent'] = 889;
    t['ampersand'] = 722;
    t['quoteright'] = 278;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 389;
    t['plus'] = 584;
    t['comma'] = 278;
    t['hyphen'] = 333;
    t['period'] = 278;
    t['slash'] = 278;
    t['zero'] = 556;
    t['one'] = 556;
    t['two'] = 556;
    t['three'] = 556;
    t['four'] = 556;
    t['five'] = 556;
    t['six'] = 556;
    t['seven'] = 556;
    t['eight'] = 556;
    t['nine'] = 556;
    t['colon'] = 333;
    t['semicolon'] = 333;
    t['less'] = 584;
    t['equal'] = 584;
    t['greater'] = 584;
    t['question'] = 611;
    t['at'] = 975;
    t['A'] = 722;
    t['B'] = 722;
    t['C'] = 722;
    t['D'] = 722;
    t['E'] = 667;
    t['F'] = 611;
    t['G'] = 778;
    t['H'] = 722;
    t['I'] = 278;
    t['J'] = 556;
    t['K'] = 722;
    t['L'] = 611;
    t['M'] = 833;
    t['N'] = 722;
    t['O'] = 778;
    t['P'] = 667;
    t['Q'] = 778;
    t['R'] = 722;
    t['S'] = 667;
    t['T'] = 611;
    t['U'] = 722;
    t['V'] = 667;
    t['W'] = 944;
    t['X'] = 667;
    t['Y'] = 667;
    t['Z'] = 611;
    t['bracketleft'] = 333;
    t['backslash'] = 278;
    t['bracketright'] = 333;
    t['asciicircum'] = 584;
    t['underscore'] = 556;
    t['quoteleft'] = 278;
    t['a'] = 556;
    t['b'] = 611;
    t['c'] = 556;
    t['d'] = 611;
    t['e'] = 556;
    t['f'] = 333;
    t['g'] = 611;
    t['h'] = 611;
    t['i'] = 278;
    t['j'] = 278;
    t['k'] = 556;
    t['l'] = 278;
    t['m'] = 889;
    t['n'] = 611;
    t['o'] = 611;
    t['p'] = 611;
    t['q'] = 611;
    t['r'] = 389;
    t['s'] = 556;
    t['t'] = 333;
    t['u'] = 611;
    t['v'] = 556;
    t['w'] = 778;
    t['x'] = 556;
    t['y'] = 556;
    t['z'] = 500;
    t['braceleft'] = 389;
    t['bar'] = 280;
    t['braceright'] = 389;
    t['asciitilde'] = 584;
    t['exclamdown'] = 333;
    t['cent'] = 556;
    t['sterling'] = 556;
    t['fraction'] = 167;
    t['yen'] = 556;
    t['florin'] = 556;
    t['section'] = 556;
    t['currency'] = 556;
    t['quotesingle'] = 238;
    t['quotedblleft'] = 500;
    t['guillemotleft'] = 556;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 611;
    t['fl'] = 611;
    t['endash'] = 556;
    t['dagger'] = 556;
    t['daggerdbl'] = 556;
    t['periodcentered'] = 278;
    t['paragraph'] = 556;
    t['bullet'] = 350;
    t['quotesinglbase'] = 278;
    t['quotedblbase'] = 500;
    t['quotedblright'] = 500;
    t['guillemotright'] = 556;
    t['ellipsis'] = 1000;
    t['perthousand'] = 1000;
    t['questiondown'] = 611;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 1000;
    t['AE'] = 1000;
    t['ordfeminine'] = 370;
    t['Lslash'] = 611;
    t['Oslash'] = 778;
    t['OE'] = 1000;
    t['ordmasculine'] = 365;
    t['ae'] = 889;
    t['dotlessi'] = 278;
    t['lslash'] = 278;
    t['oslash'] = 611;
    t['oe'] = 944;
    t['germandbls'] = 611;
    t['Idieresis'] = 278;
    t['eacute'] = 556;
    t['abreve'] = 556;
    t['uhungarumlaut'] = 611;
    t['ecaron'] = 556;
    t['Ydieresis'] = 667;
    t['divide'] = 584;
    t['Yacute'] = 667;
    t['Acircumflex'] = 722;
    t['aacute'] = 556;
    t['Ucircumflex'] = 722;
    t['yacute'] = 556;
    t['scommaaccent'] = 556;
    t['ecircumflex'] = 556;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 556;
    t['Uacute'] = 722;
    t['uogonek'] = 611;
    t['Edieresis'] = 667;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 737;
    t['Emacron'] = 667;
    t['ccaron'] = 556;
    t['aring'] = 556;
    t['Ncommaaccent'] = 722;
    t['lacute'] = 278;
    t['agrave'] = 556;
    t['Tcommaaccent'] = 611;
    t['Cacute'] = 722;
    t['atilde'] = 556;
    t['Edotaccent'] = 667;
    t['scaron'] = 556;
    t['scedilla'] = 556;
    t['iacute'] = 278;
    t['lozenge'] = 494;
    t['Rcaron'] = 722;
    t['Gcommaaccent'] = 778;
    t['ucircumflex'] = 611;
    t['acircumflex'] = 556;
    t['Amacron'] = 722;
    t['rcaron'] = 389;
    t['ccedilla'] = 556;
    t['Zdotaccent'] = 611;
    t['Thorn'] = 667;
    t['Omacron'] = 778;
    t['Racute'] = 722;
    t['Sacute'] = 667;
    t['dcaron'] = 743;
    t['Umacron'] = 722;
    t['uring'] = 611;
    t['threesuperior'] = 333;
    t['Ograve'] = 778;
    t['Agrave'] = 722;
    t['Abreve'] = 722;
    t['multiply'] = 584;
    t['uacute'] = 611;
    t['Tcaron'] = 611;
    t['partialdiff'] = 494;
    t['ydieresis'] = 556;
    t['Nacute'] = 722;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 667;
    t['adieresis'] = 556;
    t['edieresis'] = 556;
    t['cacute'] = 556;
    t['nacute'] = 611;
    t['umacron'] = 611;
    t['Ncaron'] = 722;
    t['Iacute'] = 278;
    t['plusminus'] = 584;
    t['brokenbar'] = 280;
    t['registered'] = 737;
    t['Gbreve'] = 778;
    t['Idotaccent'] = 278;
    t['summation'] = 600;
    t['Egrave'] = 667;
    t['racute'] = 389;
    t['omacron'] = 611;
    t['Zacute'] = 611;
    t['Zcaron'] = 611;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 722;
    t['lcommaaccent'] = 278;
    t['tcaron'] = 389;
    t['eogonek'] = 556;
    t['Uogonek'] = 722;
    t['Aacute'] = 722;
    t['Adieresis'] = 722;
    t['egrave'] = 556;
    t['zacute'] = 500;
    t['iogonek'] = 278;
    t['Oacute'] = 778;
    t['oacute'] = 611;
    t['amacron'] = 556;
    t['sacute'] = 556;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 778;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 611;
    t['twosuperior'] = 333;
    t['Odieresis'] = 778;
    t['mu'] = 611;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 611;
    t['Eogonek'] = 667;
    t['dcroat'] = 611;
    t['threequarters'] = 834;
    t['Scedilla'] = 667;
    t['lcaron'] = 400;
    t['Kcommaaccent'] = 722;
    t['Lacute'] = 611;
    t['trademark'] = 1000;
    t['edotaccent'] = 556;
    t['Igrave'] = 278;
    t['Imacron'] = 278;
    t['Lcaron'] = 611;
    t['onehalf'] = 834;
    t['lessequal'] = 549;
    t['ocircumflex'] = 611;
    t['ntilde'] = 611;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 667;
    t['emacron'] = 556;
    t['gbreve'] = 611;
    t['onequarter'] = 834;
    t['Scaron'] = 667;
    t['Scommaaccent'] = 667;
    t['Ohungarumlaut'] = 778;
    t['degree'] = 400;
    t['ograve'] = 611;
    t['Ccaron'] = 722;
    t['ugrave'] = 611;
    t['radical'] = 549;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 389;
    t['Ntilde'] = 722;
    t['otilde'] = 611;
    t['Rcommaaccent'] = 722;
    t['Lcommaaccent'] = 611;
    t['Atilde'] = 722;
    t['Aogonek'] = 722;
    t['Aring'] = 722;
    t['Otilde'] = 778;
    t['zdotaccent'] = 500;
    t['Ecaron'] = 667;
    t['Iogonek'] = 278;
    t['kcommaaccent'] = 556;
    t['minus'] = 584;
    t['Icircumflex'] = 278;
    t['ncaron'] = 611;
    t['tcommaaccent'] = 333;
    t['logicalnot'] = 584;
    t['odieresis'] = 611;
    t['udieresis'] = 611;
    t['notequal'] = 549;
    t['gcommaaccent'] = 611;
    t['eth'] = 611;
    t['zcaron'] = 500;
    t['ncommaaccent'] = 611;
    t['onesuperior'] = 333;
    t['imacron'] = 278;
    t['Euro'] = 556;
  });
  t['Helvetica-Oblique'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 278;
    t['exclam'] = 278;
    t['quotedbl'] = 355;
    t['numbersign'] = 556;
    t['dollar'] = 556;
    t['percent'] = 889;
    t['ampersand'] = 667;
    t['quoteright'] = 222;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 389;
    t['plus'] = 584;
    t['comma'] = 278;
    t['hyphen'] = 333;
    t['period'] = 278;
    t['slash'] = 278;
    t['zero'] = 556;
    t['one'] = 556;
    t['two'] = 556;
    t['three'] = 556;
    t['four'] = 556;
    t['five'] = 556;
    t['six'] = 556;
    t['seven'] = 556;
    t['eight'] = 556;
    t['nine'] = 556;
    t['colon'] = 278;
    t['semicolon'] = 278;
    t['less'] = 584;
    t['equal'] = 584;
    t['greater'] = 584;
    t['question'] = 556;
    t['at'] = 1015;
    t['A'] = 667;
    t['B'] = 667;
    t['C'] = 722;
    t['D'] = 722;
    t['E'] = 667;
    t['F'] = 611;
    t['G'] = 778;
    t['H'] = 722;
    t['I'] = 278;
    t['J'] = 500;
    t['K'] = 667;
    t['L'] = 556;
    t['M'] = 833;
    t['N'] = 722;
    t['O'] = 778;
    t['P'] = 667;
    t['Q'] = 778;
    t['R'] = 722;
    t['S'] = 667;
    t['T'] = 611;
    t['U'] = 722;
    t['V'] = 667;
    t['W'] = 944;
    t['X'] = 667;
    t['Y'] = 667;
    t['Z'] = 611;
    t['bracketleft'] = 278;
    t['backslash'] = 278;
    t['bracketright'] = 278;
    t['asciicircum'] = 469;
    t['underscore'] = 556;
    t['quoteleft'] = 222;
    t['a'] = 556;
    t['b'] = 556;
    t['c'] = 500;
    t['d'] = 556;
    t['e'] = 556;
    t['f'] = 278;
    t['g'] = 556;
    t['h'] = 556;
    t['i'] = 222;
    t['j'] = 222;
    t['k'] = 500;
    t['l'] = 222;
    t['m'] = 833;
    t['n'] = 556;
    t['o'] = 556;
    t['p'] = 556;
    t['q'] = 556;
    t['r'] = 333;
    t['s'] = 500;
    t['t'] = 278;
    t['u'] = 556;
    t['v'] = 500;
    t['w'] = 722;
    t['x'] = 500;
    t['y'] = 500;
    t['z'] = 500;
    t['braceleft'] = 334;
    t['bar'] = 260;
    t['braceright'] = 334;
    t['asciitilde'] = 584;
    t['exclamdown'] = 333;
    t['cent'] = 556;
    t['sterling'] = 556;
    t['fraction'] = 167;
    t['yen'] = 556;
    t['florin'] = 556;
    t['section'] = 556;
    t['currency'] = 556;
    t['quotesingle'] = 191;
    t['quotedblleft'] = 333;
    t['guillemotleft'] = 556;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 500;
    t['fl'] = 500;
    t['endash'] = 556;
    t['dagger'] = 556;
    t['daggerdbl'] = 556;
    t['periodcentered'] = 278;
    t['paragraph'] = 537;
    t['bullet'] = 350;
    t['quotesinglbase'] = 222;
    t['quotedblbase'] = 333;
    t['quotedblright'] = 333;
    t['guillemotright'] = 556;
    t['ellipsis'] = 1000;
    t['perthousand'] = 1000;
    t['questiondown'] = 611;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 1000;
    t['AE'] = 1000;
    t['ordfeminine'] = 370;
    t['Lslash'] = 556;
    t['Oslash'] = 778;
    t['OE'] = 1000;
    t['ordmasculine'] = 365;
    t['ae'] = 889;
    t['dotlessi'] = 278;
    t['lslash'] = 222;
    t['oslash'] = 611;
    t['oe'] = 944;
    t['germandbls'] = 611;
    t['Idieresis'] = 278;
    t['eacute'] = 556;
    t['abreve'] = 556;
    t['uhungarumlaut'] = 556;
    t['ecaron'] = 556;
    t['Ydieresis'] = 667;
    t['divide'] = 584;
    t['Yacute'] = 667;
    t['Acircumflex'] = 667;
    t['aacute'] = 556;
    t['Ucircumflex'] = 722;
    t['yacute'] = 500;
    t['scommaaccent'] = 500;
    t['ecircumflex'] = 556;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 556;
    t['Uacute'] = 722;
    t['uogonek'] = 556;
    t['Edieresis'] = 667;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 737;
    t['Emacron'] = 667;
    t['ccaron'] = 500;
    t['aring'] = 556;
    t['Ncommaaccent'] = 722;
    t['lacute'] = 222;
    t['agrave'] = 556;
    t['Tcommaaccent'] = 611;
    t['Cacute'] = 722;
    t['atilde'] = 556;
    t['Edotaccent'] = 667;
    t['scaron'] = 500;
    t['scedilla'] = 500;
    t['iacute'] = 278;
    t['lozenge'] = 471;
    t['Rcaron'] = 722;
    t['Gcommaaccent'] = 778;
    t['ucircumflex'] = 556;
    t['acircumflex'] = 556;
    t['Amacron'] = 667;
    t['rcaron'] = 333;
    t['ccedilla'] = 500;
    t['Zdotaccent'] = 611;
    t['Thorn'] = 667;
    t['Omacron'] = 778;
    t['Racute'] = 722;
    t['Sacute'] = 667;
    t['dcaron'] = 643;
    t['Umacron'] = 722;
    t['uring'] = 556;
    t['threesuperior'] = 333;
    t['Ograve'] = 778;
    t['Agrave'] = 667;
    t['Abreve'] = 667;
    t['multiply'] = 584;
    t['uacute'] = 556;
    t['Tcaron'] = 611;
    t['partialdiff'] = 476;
    t['ydieresis'] = 500;
    t['Nacute'] = 722;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 667;
    t['adieresis'] = 556;
    t['edieresis'] = 556;
    t['cacute'] = 500;
    t['nacute'] = 556;
    t['umacron'] = 556;
    t['Ncaron'] = 722;
    t['Iacute'] = 278;
    t['plusminus'] = 584;
    t['brokenbar'] = 260;
    t['registered'] = 737;
    t['Gbreve'] = 778;
    t['Idotaccent'] = 278;
    t['summation'] = 600;
    t['Egrave'] = 667;
    t['racute'] = 333;
    t['omacron'] = 556;
    t['Zacute'] = 611;
    t['Zcaron'] = 611;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 722;
    t['lcommaaccent'] = 222;
    t['tcaron'] = 317;
    t['eogonek'] = 556;
    t['Uogonek'] = 722;
    t['Aacute'] = 667;
    t['Adieresis'] = 667;
    t['egrave'] = 556;
    t['zacute'] = 500;
    t['iogonek'] = 222;
    t['Oacute'] = 778;
    t['oacute'] = 556;
    t['amacron'] = 556;
    t['sacute'] = 500;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 778;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 556;
    t['twosuperior'] = 333;
    t['Odieresis'] = 778;
    t['mu'] = 556;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 556;
    t['Eogonek'] = 667;
    t['dcroat'] = 556;
    t['threequarters'] = 834;
    t['Scedilla'] = 667;
    t['lcaron'] = 299;
    t['Kcommaaccent'] = 667;
    t['Lacute'] = 556;
    t['trademark'] = 1000;
    t['edotaccent'] = 556;
    t['Igrave'] = 278;
    t['Imacron'] = 278;
    t['Lcaron'] = 556;
    t['onehalf'] = 834;
    t['lessequal'] = 549;
    t['ocircumflex'] = 556;
    t['ntilde'] = 556;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 667;
    t['emacron'] = 556;
    t['gbreve'] = 556;
    t['onequarter'] = 834;
    t['Scaron'] = 667;
    t['Scommaaccent'] = 667;
    t['Ohungarumlaut'] = 778;
    t['degree'] = 400;
    t['ograve'] = 556;
    t['Ccaron'] = 722;
    t['ugrave'] = 556;
    t['radical'] = 453;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 333;
    t['Ntilde'] = 722;
    t['otilde'] = 556;
    t['Rcommaaccent'] = 722;
    t['Lcommaaccent'] = 556;
    t['Atilde'] = 667;
    t['Aogonek'] = 667;
    t['Aring'] = 667;
    t['Otilde'] = 778;
    t['zdotaccent'] = 500;
    t['Ecaron'] = 667;
    t['Iogonek'] = 278;
    t['kcommaaccent'] = 500;
    t['minus'] = 584;
    t['Icircumflex'] = 278;
    t['ncaron'] = 556;
    t['tcommaaccent'] = 278;
    t['logicalnot'] = 584;
    t['odieresis'] = 556;
    t['udieresis'] = 556;
    t['notequal'] = 549;
    t['gcommaaccent'] = 556;
    t['eth'] = 556;
    t['zcaron'] = 500;
    t['ncommaaccent'] = 556;
    t['onesuperior'] = 333;
    t['imacron'] = 278;
    t['Euro'] = 556;
  });
  t['Symbol'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 250;
    t['exclam'] = 333;
    t['universal'] = 713;
    t['numbersign'] = 500;
    t['existential'] = 549;
    t['percent'] = 833;
    t['ampersand'] = 778;
    t['suchthat'] = 439;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asteriskmath'] = 500;
    t['plus'] = 549;
    t['comma'] = 250;
    t['minus'] = 549;
    t['period'] = 250;
    t['slash'] = 278;
    t['zero'] = 500;
    t['one'] = 500;
    t['two'] = 500;
    t['three'] = 500;
    t['four'] = 500;
    t['five'] = 500;
    t['six'] = 500;
    t['seven'] = 500;
    t['eight'] = 500;
    t['nine'] = 500;
    t['colon'] = 278;
    t['semicolon'] = 278;
    t['less'] = 549;
    t['equal'] = 549;
    t['greater'] = 549;
    t['question'] = 444;
    t['congruent'] = 549;
    t['Alpha'] = 722;
    t['Beta'] = 667;
    t['Chi'] = 722;
    t['Delta'] = 612;
    t['Epsilon'] = 611;
    t['Phi'] = 763;
    t['Gamma'] = 603;
    t['Eta'] = 722;
    t['Iota'] = 333;
    t['theta1'] = 631;
    t['Kappa'] = 722;
    t['Lambda'] = 686;
    t['Mu'] = 889;
    t['Nu'] = 722;
    t['Omicron'] = 722;
    t['Pi'] = 768;
    t['Theta'] = 741;
    t['Rho'] = 556;
    t['Sigma'] = 592;
    t['Tau'] = 611;
    t['Upsilon'] = 690;
    t['sigma1'] = 439;
    t['Omega'] = 768;
    t['Xi'] = 645;
    t['Psi'] = 795;
    t['Zeta'] = 611;
    t['bracketleft'] = 333;
    t['therefore'] = 863;
    t['bracketright'] = 333;
    t['perpendicular'] = 658;
    t['underscore'] = 500;
    t['radicalex'] = 500;
    t['alpha'] = 631;
    t['beta'] = 549;
    t['chi'] = 549;
    t['delta'] = 494;
    t['epsilon'] = 439;
    t['phi'] = 521;
    t['gamma'] = 411;
    t['eta'] = 603;
    t['iota'] = 329;
    t['phi1'] = 603;
    t['kappa'] = 549;
    t['lambda'] = 549;
    t['mu'] = 576;
    t['nu'] = 521;
    t['omicron'] = 549;
    t['pi'] = 549;
    t['theta'] = 521;
    t['rho'] = 549;
    t['sigma'] = 603;
    t['tau'] = 439;
    t['upsilon'] = 576;
    t['omega1'] = 713;
    t['omega'] = 686;
    t['xi'] = 493;
    t['psi'] = 686;
    t['zeta'] = 494;
    t['braceleft'] = 480;
    t['bar'] = 200;
    t['braceright'] = 480;
    t['similar'] = 549;
    t['Euro'] = 750;
    t['Upsilon1'] = 620;
    t['minute'] = 247;
    t['lessequal'] = 549;
    t['fraction'] = 167;
    t['infinity'] = 713;
    t['florin'] = 500;
    t['club'] = 753;
    t['diamond'] = 753;
    t['heart'] = 753;
    t['spade'] = 753;
    t['arrowboth'] = 1042;
    t['arrowleft'] = 987;
    t['arrowup'] = 603;
    t['arrowright'] = 987;
    t['arrowdown'] = 603;
    t['degree'] = 400;
    t['plusminus'] = 549;
    t['second'] = 411;
    t['greaterequal'] = 549;
    t['multiply'] = 549;
    t['proportional'] = 713;
    t['partialdiff'] = 494;
    t['bullet'] = 460;
    t['divide'] = 549;
    t['notequal'] = 549;
    t['equivalence'] = 549;
    t['approxequal'] = 549;
    t['ellipsis'] = 1000;
    t['arrowvertex'] = 603;
    t['arrowhorizex'] = 1000;
    t['carriagereturn'] = 658;
    t['aleph'] = 823;
    t['Ifraktur'] = 686;
    t['Rfraktur'] = 795;
    t['weierstrass'] = 987;
    t['circlemultiply'] = 768;
    t['circleplus'] = 768;
    t['emptyset'] = 823;
    t['intersection'] = 768;
    t['union'] = 768;
    t['propersuperset'] = 713;
    t['reflexsuperset'] = 713;
    t['notsubset'] = 713;
    t['propersubset'] = 713;
    t['reflexsubset'] = 713;
    t['element'] = 713;
    t['notelement'] = 713;
    t['angle'] = 768;
    t['gradient'] = 713;
    t['registerserif'] = 790;
    t['copyrightserif'] = 790;
    t['trademarkserif'] = 890;
    t['product'] = 823;
    t['radical'] = 549;
    t['dotmath'] = 250;
    t['logicalnot'] = 713;
    t['logicaland'] = 603;
    t['logicalor'] = 603;
    t['arrowdblboth'] = 1042;
    t['arrowdblleft'] = 987;
    t['arrowdblup'] = 603;
    t['arrowdblright'] = 987;
    t['arrowdbldown'] = 603;
    t['lozenge'] = 494;
    t['angleleft'] = 329;
    t['registersans'] = 790;
    t['copyrightsans'] = 790;
    t['trademarksans'] = 786;
    t['summation'] = 713;
    t['parenlefttp'] = 384;
    t['parenleftex'] = 384;
    t['parenleftbt'] = 384;
    t['bracketlefttp'] = 384;
    t['bracketleftex'] = 384;
    t['bracketleftbt'] = 384;
    t['bracelefttp'] = 494;
    t['braceleftmid'] = 494;
    t['braceleftbt'] = 494;
    t['braceex'] = 494;
    t['angleright'] = 329;
    t['integral'] = 274;
    t['integraltp'] = 686;
    t['integralex'] = 686;
    t['integralbt'] = 686;
    t['parenrighttp'] = 384;
    t['parenrightex'] = 384;
    t['parenrightbt'] = 384;
    t['bracketrighttp'] = 384;
    t['bracketrightex'] = 384;
    t['bracketrightbt'] = 384;
    t['bracerighttp'] = 494;
    t['bracerightmid'] = 494;
    t['bracerightbt'] = 494;
    t['apple'] = 790;
  });
  t['Times-Roman'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 250;
    t['exclam'] = 333;
    t['quotedbl'] = 408;
    t['numbersign'] = 500;
    t['dollar'] = 500;
    t['percent'] = 833;
    t['ampersand'] = 778;
    t['quoteright'] = 333;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 500;
    t['plus'] = 564;
    t['comma'] = 250;
    t['hyphen'] = 333;
    t['period'] = 250;
    t['slash'] = 278;
    t['zero'] = 500;
    t['one'] = 500;
    t['two'] = 500;
    t['three'] = 500;
    t['four'] = 500;
    t['five'] = 500;
    t['six'] = 500;
    t['seven'] = 500;
    t['eight'] = 500;
    t['nine'] = 500;
    t['colon'] = 278;
    t['semicolon'] = 278;
    t['less'] = 564;
    t['equal'] = 564;
    t['greater'] = 564;
    t['question'] = 444;
    t['at'] = 921;
    t['A'] = 722;
    t['B'] = 667;
    t['C'] = 667;
    t['D'] = 722;
    t['E'] = 611;
    t['F'] = 556;
    t['G'] = 722;
    t['H'] = 722;
    t['I'] = 333;
    t['J'] = 389;
    t['K'] = 722;
    t['L'] = 611;
    t['M'] = 889;
    t['N'] = 722;
    t['O'] = 722;
    t['P'] = 556;
    t['Q'] = 722;
    t['R'] = 667;
    t['S'] = 556;
    t['T'] = 611;
    t['U'] = 722;
    t['V'] = 722;
    t['W'] = 944;
    t['X'] = 722;
    t['Y'] = 722;
    t['Z'] = 611;
    t['bracketleft'] = 333;
    t['backslash'] = 278;
    t['bracketright'] = 333;
    t['asciicircum'] = 469;
    t['underscore'] = 500;
    t['quoteleft'] = 333;
    t['a'] = 444;
    t['b'] = 500;
    t['c'] = 444;
    t['d'] = 500;
    t['e'] = 444;
    t['f'] = 333;
    t['g'] = 500;
    t['h'] = 500;
    t['i'] = 278;
    t['j'] = 278;
    t['k'] = 500;
    t['l'] = 278;
    t['m'] = 778;
    t['n'] = 500;
    t['o'] = 500;
    t['p'] = 500;
    t['q'] = 500;
    t['r'] = 333;
    t['s'] = 389;
    t['t'] = 278;
    t['u'] = 500;
    t['v'] = 500;
    t['w'] = 722;
    t['x'] = 500;
    t['y'] = 500;
    t['z'] = 444;
    t['braceleft'] = 480;
    t['bar'] = 200;
    t['braceright'] = 480;
    t['asciitilde'] = 541;
    t['exclamdown'] = 333;
    t['cent'] = 500;
    t['sterling'] = 500;
    t['fraction'] = 167;
    t['yen'] = 500;
    t['florin'] = 500;
    t['section'] = 500;
    t['currency'] = 500;
    t['quotesingle'] = 180;
    t['quotedblleft'] = 444;
    t['guillemotleft'] = 500;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 556;
    t['fl'] = 556;
    t['endash'] = 500;
    t['dagger'] = 500;
    t['daggerdbl'] = 500;
    t['periodcentered'] = 250;
    t['paragraph'] = 453;
    t['bullet'] = 350;
    t['quotesinglbase'] = 333;
    t['quotedblbase'] = 444;
    t['quotedblright'] = 444;
    t['guillemotright'] = 500;
    t['ellipsis'] = 1000;
    t['perthousand'] = 1000;
    t['questiondown'] = 444;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 1000;
    t['AE'] = 889;
    t['ordfeminine'] = 276;
    t['Lslash'] = 611;
    t['Oslash'] = 722;
    t['OE'] = 889;
    t['ordmasculine'] = 310;
    t['ae'] = 667;
    t['dotlessi'] = 278;
    t['lslash'] = 278;
    t['oslash'] = 500;
    t['oe'] = 722;
    t['germandbls'] = 500;
    t['Idieresis'] = 333;
    t['eacute'] = 444;
    t['abreve'] = 444;
    t['uhungarumlaut'] = 500;
    t['ecaron'] = 444;
    t['Ydieresis'] = 722;
    t['divide'] = 564;
    t['Yacute'] = 722;
    t['Acircumflex'] = 722;
    t['aacute'] = 444;
    t['Ucircumflex'] = 722;
    t['yacute'] = 500;
    t['scommaaccent'] = 389;
    t['ecircumflex'] = 444;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 444;
    t['Uacute'] = 722;
    t['uogonek'] = 500;
    t['Edieresis'] = 611;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 760;
    t['Emacron'] = 611;
    t['ccaron'] = 444;
    t['aring'] = 444;
    t['Ncommaaccent'] = 722;
    t['lacute'] = 278;
    t['agrave'] = 444;
    t['Tcommaaccent'] = 611;
    t['Cacute'] = 667;
    t['atilde'] = 444;
    t['Edotaccent'] = 611;
    t['scaron'] = 389;
    t['scedilla'] = 389;
    t['iacute'] = 278;
    t['lozenge'] = 471;
    t['Rcaron'] = 667;
    t['Gcommaaccent'] = 722;
    t['ucircumflex'] = 500;
    t['acircumflex'] = 444;
    t['Amacron'] = 722;
    t['rcaron'] = 333;
    t['ccedilla'] = 444;
    t['Zdotaccent'] = 611;
    t['Thorn'] = 556;
    t['Omacron'] = 722;
    t['Racute'] = 667;
    t['Sacute'] = 556;
    t['dcaron'] = 588;
    t['Umacron'] = 722;
    t['uring'] = 500;
    t['threesuperior'] = 300;
    t['Ograve'] = 722;
    t['Agrave'] = 722;
    t['Abreve'] = 722;
    t['multiply'] = 564;
    t['uacute'] = 500;
    t['Tcaron'] = 611;
    t['partialdiff'] = 476;
    t['ydieresis'] = 500;
    t['Nacute'] = 722;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 611;
    t['adieresis'] = 444;
    t['edieresis'] = 444;
    t['cacute'] = 444;
    t['nacute'] = 500;
    t['umacron'] = 500;
    t['Ncaron'] = 722;
    t['Iacute'] = 333;
    t['plusminus'] = 564;
    t['brokenbar'] = 200;
    t['registered'] = 760;
    t['Gbreve'] = 722;
    t['Idotaccent'] = 333;
    t['summation'] = 600;
    t['Egrave'] = 611;
    t['racute'] = 333;
    t['omacron'] = 500;
    t['Zacute'] = 611;
    t['Zcaron'] = 611;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 667;
    t['lcommaaccent'] = 278;
    t['tcaron'] = 326;
    t['eogonek'] = 444;
    t['Uogonek'] = 722;
    t['Aacute'] = 722;
    t['Adieresis'] = 722;
    t['egrave'] = 444;
    t['zacute'] = 444;
    t['iogonek'] = 278;
    t['Oacute'] = 722;
    t['oacute'] = 500;
    t['amacron'] = 444;
    t['sacute'] = 389;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 722;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 500;
    t['twosuperior'] = 300;
    t['Odieresis'] = 722;
    t['mu'] = 500;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 500;
    t['Eogonek'] = 611;
    t['dcroat'] = 500;
    t['threequarters'] = 750;
    t['Scedilla'] = 556;
    t['lcaron'] = 344;
    t['Kcommaaccent'] = 722;
    t['Lacute'] = 611;
    t['trademark'] = 980;
    t['edotaccent'] = 444;
    t['Igrave'] = 333;
    t['Imacron'] = 333;
    t['Lcaron'] = 611;
    t['onehalf'] = 750;
    t['lessequal'] = 549;
    t['ocircumflex'] = 500;
    t['ntilde'] = 500;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 611;
    t['emacron'] = 444;
    t['gbreve'] = 500;
    t['onequarter'] = 750;
    t['Scaron'] = 556;
    t['Scommaaccent'] = 556;
    t['Ohungarumlaut'] = 722;
    t['degree'] = 400;
    t['ograve'] = 500;
    t['Ccaron'] = 667;
    t['ugrave'] = 500;
    t['radical'] = 453;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 333;
    t['Ntilde'] = 722;
    t['otilde'] = 500;
    t['Rcommaaccent'] = 667;
    t['Lcommaaccent'] = 611;
    t['Atilde'] = 722;
    t['Aogonek'] = 722;
    t['Aring'] = 722;
    t['Otilde'] = 722;
    t['zdotaccent'] = 444;
    t['Ecaron'] = 611;
    t['Iogonek'] = 333;
    t['kcommaaccent'] = 500;
    t['minus'] = 564;
    t['Icircumflex'] = 333;
    t['ncaron'] = 500;
    t['tcommaaccent'] = 278;
    t['logicalnot'] = 564;
    t['odieresis'] = 500;
    t['udieresis'] = 500;
    t['notequal'] = 549;
    t['gcommaaccent'] = 500;
    t['eth'] = 500;
    t['zcaron'] = 444;
    t['ncommaaccent'] = 500;
    t['onesuperior'] = 300;
    t['imacron'] = 278;
    t['Euro'] = 500;
  });
  t['Times-Bold'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 250;
    t['exclam'] = 333;
    t['quotedbl'] = 555;
    t['numbersign'] = 500;
    t['dollar'] = 500;
    t['percent'] = 1000;
    t['ampersand'] = 833;
    t['quoteright'] = 333;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 500;
    t['plus'] = 570;
    t['comma'] = 250;
    t['hyphen'] = 333;
    t['period'] = 250;
    t['slash'] = 278;
    t['zero'] = 500;
    t['one'] = 500;
    t['two'] = 500;
    t['three'] = 500;
    t['four'] = 500;
    t['five'] = 500;
    t['six'] = 500;
    t['seven'] = 500;
    t['eight'] = 500;
    t['nine'] = 500;
    t['colon'] = 333;
    t['semicolon'] = 333;
    t['less'] = 570;
    t['equal'] = 570;
    t['greater'] = 570;
    t['question'] = 500;
    t['at'] = 930;
    t['A'] = 722;
    t['B'] = 667;
    t['C'] = 722;
    t['D'] = 722;
    t['E'] = 667;
    t['F'] = 611;
    t['G'] = 778;
    t['H'] = 778;
    t['I'] = 389;
    t['J'] = 500;
    t['K'] = 778;
    t['L'] = 667;
    t['M'] = 944;
    t['N'] = 722;
    t['O'] = 778;
    t['P'] = 611;
    t['Q'] = 778;
    t['R'] = 722;
    t['S'] = 556;
    t['T'] = 667;
    t['U'] = 722;
    t['V'] = 722;
    t['W'] = 1000;
    t['X'] = 722;
    t['Y'] = 722;
    t['Z'] = 667;
    t['bracketleft'] = 333;
    t['backslash'] = 278;
    t['bracketright'] = 333;
    t['asciicircum'] = 581;
    t['underscore'] = 500;
    t['quoteleft'] = 333;
    t['a'] = 500;
    t['b'] = 556;
    t['c'] = 444;
    t['d'] = 556;
    t['e'] = 444;
    t['f'] = 333;
    t['g'] = 500;
    t['h'] = 556;
    t['i'] = 278;
    t['j'] = 333;
    t['k'] = 556;
    t['l'] = 278;
    t['m'] = 833;
    t['n'] = 556;
    t['o'] = 500;
    t['p'] = 556;
    t['q'] = 556;
    t['r'] = 444;
    t['s'] = 389;
    t['t'] = 333;
    t['u'] = 556;
    t['v'] = 500;
    t['w'] = 722;
    t['x'] = 500;
    t['y'] = 500;
    t['z'] = 444;
    t['braceleft'] = 394;
    t['bar'] = 220;
    t['braceright'] = 394;
    t['asciitilde'] = 520;
    t['exclamdown'] = 333;
    t['cent'] = 500;
    t['sterling'] = 500;
    t['fraction'] = 167;
    t['yen'] = 500;
    t['florin'] = 500;
    t['section'] = 500;
    t['currency'] = 500;
    t['quotesingle'] = 278;
    t['quotedblleft'] = 500;
    t['guillemotleft'] = 500;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 556;
    t['fl'] = 556;
    t['endash'] = 500;
    t['dagger'] = 500;
    t['daggerdbl'] = 500;
    t['periodcentered'] = 250;
    t['paragraph'] = 540;
    t['bullet'] = 350;
    t['quotesinglbase'] = 333;
    t['quotedblbase'] = 500;
    t['quotedblright'] = 500;
    t['guillemotright'] = 500;
    t['ellipsis'] = 1000;
    t['perthousand'] = 1000;
    t['questiondown'] = 500;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 1000;
    t['AE'] = 1000;
    t['ordfeminine'] = 300;
    t['Lslash'] = 667;
    t['Oslash'] = 778;
    t['OE'] = 1000;
    t['ordmasculine'] = 330;
    t['ae'] = 722;
    t['dotlessi'] = 278;
    t['lslash'] = 278;
    t['oslash'] = 500;
    t['oe'] = 722;
    t['germandbls'] = 556;
    t['Idieresis'] = 389;
    t['eacute'] = 444;
    t['abreve'] = 500;
    t['uhungarumlaut'] = 556;
    t['ecaron'] = 444;
    t['Ydieresis'] = 722;
    t['divide'] = 570;
    t['Yacute'] = 722;
    t['Acircumflex'] = 722;
    t['aacute'] = 500;
    t['Ucircumflex'] = 722;
    t['yacute'] = 500;
    t['scommaaccent'] = 389;
    t['ecircumflex'] = 444;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 500;
    t['Uacute'] = 722;
    t['uogonek'] = 556;
    t['Edieresis'] = 667;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 747;
    t['Emacron'] = 667;
    t['ccaron'] = 444;
    t['aring'] = 500;
    t['Ncommaaccent'] = 722;
    t['lacute'] = 278;
    t['agrave'] = 500;
    t['Tcommaaccent'] = 667;
    t['Cacute'] = 722;
    t['atilde'] = 500;
    t['Edotaccent'] = 667;
    t['scaron'] = 389;
    t['scedilla'] = 389;
    t['iacute'] = 278;
    t['lozenge'] = 494;
    t['Rcaron'] = 722;
    t['Gcommaaccent'] = 778;
    t['ucircumflex'] = 556;
    t['acircumflex'] = 500;
    t['Amacron'] = 722;
    t['rcaron'] = 444;
    t['ccedilla'] = 444;
    t['Zdotaccent'] = 667;
    t['Thorn'] = 611;
    t['Omacron'] = 778;
    t['Racute'] = 722;
    t['Sacute'] = 556;
    t['dcaron'] = 672;
    t['Umacron'] = 722;
    t['uring'] = 556;
    t['threesuperior'] = 300;
    t['Ograve'] = 778;
    t['Agrave'] = 722;
    t['Abreve'] = 722;
    t['multiply'] = 570;
    t['uacute'] = 556;
    t['Tcaron'] = 667;
    t['partialdiff'] = 494;
    t['ydieresis'] = 500;
    t['Nacute'] = 722;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 667;
    t['adieresis'] = 500;
    t['edieresis'] = 444;
    t['cacute'] = 444;
    t['nacute'] = 556;
    t['umacron'] = 556;
    t['Ncaron'] = 722;
    t['Iacute'] = 389;
    t['plusminus'] = 570;
    t['brokenbar'] = 220;
    t['registered'] = 747;
    t['Gbreve'] = 778;
    t['Idotaccent'] = 389;
    t['summation'] = 600;
    t['Egrave'] = 667;
    t['racute'] = 444;
    t['omacron'] = 500;
    t['Zacute'] = 667;
    t['Zcaron'] = 667;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 722;
    t['lcommaaccent'] = 278;
    t['tcaron'] = 416;
    t['eogonek'] = 444;
    t['Uogonek'] = 722;
    t['Aacute'] = 722;
    t['Adieresis'] = 722;
    t['egrave'] = 444;
    t['zacute'] = 444;
    t['iogonek'] = 278;
    t['Oacute'] = 778;
    t['oacute'] = 500;
    t['amacron'] = 500;
    t['sacute'] = 389;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 778;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 556;
    t['twosuperior'] = 300;
    t['Odieresis'] = 778;
    t['mu'] = 556;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 500;
    t['Eogonek'] = 667;
    t['dcroat'] = 556;
    t['threequarters'] = 750;
    t['Scedilla'] = 556;
    t['lcaron'] = 394;
    t['Kcommaaccent'] = 778;
    t['Lacute'] = 667;
    t['trademark'] = 1000;
    t['edotaccent'] = 444;
    t['Igrave'] = 389;
    t['Imacron'] = 389;
    t['Lcaron'] = 667;
    t['onehalf'] = 750;
    t['lessequal'] = 549;
    t['ocircumflex'] = 500;
    t['ntilde'] = 556;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 667;
    t['emacron'] = 444;
    t['gbreve'] = 500;
    t['onequarter'] = 750;
    t['Scaron'] = 556;
    t['Scommaaccent'] = 556;
    t['Ohungarumlaut'] = 778;
    t['degree'] = 400;
    t['ograve'] = 500;
    t['Ccaron'] = 722;
    t['ugrave'] = 556;
    t['radical'] = 549;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 444;
    t['Ntilde'] = 722;
    t['otilde'] = 500;
    t['Rcommaaccent'] = 722;
    t['Lcommaaccent'] = 667;
    t['Atilde'] = 722;
    t['Aogonek'] = 722;
    t['Aring'] = 722;
    t['Otilde'] = 778;
    t['zdotaccent'] = 444;
    t['Ecaron'] = 667;
    t['Iogonek'] = 389;
    t['kcommaaccent'] = 556;
    t['minus'] = 570;
    t['Icircumflex'] = 389;
    t['ncaron'] = 556;
    t['tcommaaccent'] = 333;
    t['logicalnot'] = 570;
    t['odieresis'] = 500;
    t['udieresis'] = 556;
    t['notequal'] = 549;
    t['gcommaaccent'] = 500;
    t['eth'] = 500;
    t['zcaron'] = 444;
    t['ncommaaccent'] = 556;
    t['onesuperior'] = 300;
    t['imacron'] = 278;
    t['Euro'] = 500;
  });
  t['Times-BoldItalic'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 250;
    t['exclam'] = 389;
    t['quotedbl'] = 555;
    t['numbersign'] = 500;
    t['dollar'] = 500;
    t['percent'] = 833;
    t['ampersand'] = 778;
    t['quoteright'] = 333;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 500;
    t['plus'] = 570;
    t['comma'] = 250;
    t['hyphen'] = 333;
    t['period'] = 250;
    t['slash'] = 278;
    t['zero'] = 500;
    t['one'] = 500;
    t['two'] = 500;
    t['three'] = 500;
    t['four'] = 500;
    t['five'] = 500;
    t['six'] = 500;
    t['seven'] = 500;
    t['eight'] = 500;
    t['nine'] = 500;
    t['colon'] = 333;
    t['semicolon'] = 333;
    t['less'] = 570;
    t['equal'] = 570;
    t['greater'] = 570;
    t['question'] = 500;
    t['at'] = 832;
    t['A'] = 667;
    t['B'] = 667;
    t['C'] = 667;
    t['D'] = 722;
    t['E'] = 667;
    t['F'] = 667;
    t['G'] = 722;
    t['H'] = 778;
    t['I'] = 389;
    t['J'] = 500;
    t['K'] = 667;
    t['L'] = 611;
    t['M'] = 889;
    t['N'] = 722;
    t['O'] = 722;
    t['P'] = 611;
    t['Q'] = 722;
    t['R'] = 667;
    t['S'] = 556;
    t['T'] = 611;
    t['U'] = 722;
    t['V'] = 667;
    t['W'] = 889;
    t['X'] = 667;
    t['Y'] = 611;
    t['Z'] = 611;
    t['bracketleft'] = 333;
    t['backslash'] = 278;
    t['bracketright'] = 333;
    t['asciicircum'] = 570;
    t['underscore'] = 500;
    t['quoteleft'] = 333;
    t['a'] = 500;
    t['b'] = 500;
    t['c'] = 444;
    t['d'] = 500;
    t['e'] = 444;
    t['f'] = 333;
    t['g'] = 500;
    t['h'] = 556;
    t['i'] = 278;
    t['j'] = 278;
    t['k'] = 500;
    t['l'] = 278;
    t['m'] = 778;
    t['n'] = 556;
    t['o'] = 500;
    t['p'] = 500;
    t['q'] = 500;
    t['r'] = 389;
    t['s'] = 389;
    t['t'] = 278;
    t['u'] = 556;
    t['v'] = 444;
    t['w'] = 667;
    t['x'] = 500;
    t['y'] = 444;
    t['z'] = 389;
    t['braceleft'] = 348;
    t['bar'] = 220;
    t['braceright'] = 348;
    t['asciitilde'] = 570;
    t['exclamdown'] = 389;
    t['cent'] = 500;
    t['sterling'] = 500;
    t['fraction'] = 167;
    t['yen'] = 500;
    t['florin'] = 500;
    t['section'] = 500;
    t['currency'] = 500;
    t['quotesingle'] = 278;
    t['quotedblleft'] = 500;
    t['guillemotleft'] = 500;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 556;
    t['fl'] = 556;
    t['endash'] = 500;
    t['dagger'] = 500;
    t['daggerdbl'] = 500;
    t['periodcentered'] = 250;
    t['paragraph'] = 500;
    t['bullet'] = 350;
    t['quotesinglbase'] = 333;
    t['quotedblbase'] = 500;
    t['quotedblright'] = 500;
    t['guillemotright'] = 500;
    t['ellipsis'] = 1000;
    t['perthousand'] = 1000;
    t['questiondown'] = 500;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 1000;
    t['AE'] = 944;
    t['ordfeminine'] = 266;
    t['Lslash'] = 611;
    t['Oslash'] = 722;
    t['OE'] = 944;
    t['ordmasculine'] = 300;
    t['ae'] = 722;
    t['dotlessi'] = 278;
    t['lslash'] = 278;
    t['oslash'] = 500;
    t['oe'] = 722;
    t['germandbls'] = 500;
    t['Idieresis'] = 389;
    t['eacute'] = 444;
    t['abreve'] = 500;
    t['uhungarumlaut'] = 556;
    t['ecaron'] = 444;
    t['Ydieresis'] = 611;
    t['divide'] = 570;
    t['Yacute'] = 611;
    t['Acircumflex'] = 667;
    t['aacute'] = 500;
    t['Ucircumflex'] = 722;
    t['yacute'] = 444;
    t['scommaaccent'] = 389;
    t['ecircumflex'] = 444;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 500;
    t['Uacute'] = 722;
    t['uogonek'] = 556;
    t['Edieresis'] = 667;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 747;
    t['Emacron'] = 667;
    t['ccaron'] = 444;
    t['aring'] = 500;
    t['Ncommaaccent'] = 722;
    t['lacute'] = 278;
    t['agrave'] = 500;
    t['Tcommaaccent'] = 611;
    t['Cacute'] = 667;
    t['atilde'] = 500;
    t['Edotaccent'] = 667;
    t['scaron'] = 389;
    t['scedilla'] = 389;
    t['iacute'] = 278;
    t['lozenge'] = 494;
    t['Rcaron'] = 667;
    t['Gcommaaccent'] = 722;
    t['ucircumflex'] = 556;
    t['acircumflex'] = 500;
    t['Amacron'] = 667;
    t['rcaron'] = 389;
    t['ccedilla'] = 444;
    t['Zdotaccent'] = 611;
    t['Thorn'] = 611;
    t['Omacron'] = 722;
    t['Racute'] = 667;
    t['Sacute'] = 556;
    t['dcaron'] = 608;
    t['Umacron'] = 722;
    t['uring'] = 556;
    t['threesuperior'] = 300;
    t['Ograve'] = 722;
    t['Agrave'] = 667;
    t['Abreve'] = 667;
    t['multiply'] = 570;
    t['uacute'] = 556;
    t['Tcaron'] = 611;
    t['partialdiff'] = 494;
    t['ydieresis'] = 444;
    t['Nacute'] = 722;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 667;
    t['adieresis'] = 500;
    t['edieresis'] = 444;
    t['cacute'] = 444;
    t['nacute'] = 556;
    t['umacron'] = 556;
    t['Ncaron'] = 722;
    t['Iacute'] = 389;
    t['plusminus'] = 570;
    t['brokenbar'] = 220;
    t['registered'] = 747;
    t['Gbreve'] = 722;
    t['Idotaccent'] = 389;
    t['summation'] = 600;
    t['Egrave'] = 667;
    t['racute'] = 389;
    t['omacron'] = 500;
    t['Zacute'] = 611;
    t['Zcaron'] = 611;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 667;
    t['lcommaaccent'] = 278;
    t['tcaron'] = 366;
    t['eogonek'] = 444;
    t['Uogonek'] = 722;
    t['Aacute'] = 667;
    t['Adieresis'] = 667;
    t['egrave'] = 444;
    t['zacute'] = 389;
    t['iogonek'] = 278;
    t['Oacute'] = 722;
    t['oacute'] = 500;
    t['amacron'] = 500;
    t['sacute'] = 389;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 722;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 500;
    t['twosuperior'] = 300;
    t['Odieresis'] = 722;
    t['mu'] = 576;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 500;
    t['Eogonek'] = 667;
    t['dcroat'] = 500;
    t['threequarters'] = 750;
    t['Scedilla'] = 556;
    t['lcaron'] = 382;
    t['Kcommaaccent'] = 667;
    t['Lacute'] = 611;
    t['trademark'] = 1000;
    t['edotaccent'] = 444;
    t['Igrave'] = 389;
    t['Imacron'] = 389;
    t['Lcaron'] = 611;
    t['onehalf'] = 750;
    t['lessequal'] = 549;
    t['ocircumflex'] = 500;
    t['ntilde'] = 556;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 667;
    t['emacron'] = 444;
    t['gbreve'] = 500;
    t['onequarter'] = 750;
    t['Scaron'] = 556;
    t['Scommaaccent'] = 556;
    t['Ohungarumlaut'] = 722;
    t['degree'] = 400;
    t['ograve'] = 500;
    t['Ccaron'] = 667;
    t['ugrave'] = 556;
    t['radical'] = 549;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 389;
    t['Ntilde'] = 722;
    t['otilde'] = 500;
    t['Rcommaaccent'] = 667;
    t['Lcommaaccent'] = 611;
    t['Atilde'] = 667;
    t['Aogonek'] = 667;
    t['Aring'] = 667;
    t['Otilde'] = 722;
    t['zdotaccent'] = 389;
    t['Ecaron'] = 667;
    t['Iogonek'] = 389;
    t['kcommaaccent'] = 500;
    t['minus'] = 606;
    t['Icircumflex'] = 389;
    t['ncaron'] = 556;
    t['tcommaaccent'] = 278;
    t['logicalnot'] = 606;
    t['odieresis'] = 500;
    t['udieresis'] = 556;
    t['notequal'] = 549;
    t['gcommaaccent'] = 500;
    t['eth'] = 500;
    t['zcaron'] = 389;
    t['ncommaaccent'] = 556;
    t['onesuperior'] = 300;
    t['imacron'] = 278;
    t['Euro'] = 500;
  });
  t['Times-Italic'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 250;
    t['exclam'] = 333;
    t['quotedbl'] = 420;
    t['numbersign'] = 500;
    t['dollar'] = 500;
    t['percent'] = 833;
    t['ampersand'] = 778;
    t['quoteright'] = 333;
    t['parenleft'] = 333;
    t['parenright'] = 333;
    t['asterisk'] = 500;
    t['plus'] = 675;
    t['comma'] = 250;
    t['hyphen'] = 333;
    t['period'] = 250;
    t['slash'] = 278;
    t['zero'] = 500;
    t['one'] = 500;
    t['two'] = 500;
    t['three'] = 500;
    t['four'] = 500;
    t['five'] = 500;
    t['six'] = 500;
    t['seven'] = 500;
    t['eight'] = 500;
    t['nine'] = 500;
    t['colon'] = 333;
    t['semicolon'] = 333;
    t['less'] = 675;
    t['equal'] = 675;
    t['greater'] = 675;
    t['question'] = 500;
    t['at'] = 920;
    t['A'] = 611;
    t['B'] = 611;
    t['C'] = 667;
    t['D'] = 722;
    t['E'] = 611;
    t['F'] = 611;
    t['G'] = 722;
    t['H'] = 722;
    t['I'] = 333;
    t['J'] = 444;
    t['K'] = 667;
    t['L'] = 556;
    t['M'] = 833;
    t['N'] = 667;
    t['O'] = 722;
    t['P'] = 611;
    t['Q'] = 722;
    t['R'] = 611;
    t['S'] = 500;
    t['T'] = 556;
    t['U'] = 722;
    t['V'] = 611;
    t['W'] = 833;
    t['X'] = 611;
    t['Y'] = 556;
    t['Z'] = 556;
    t['bracketleft'] = 389;
    t['backslash'] = 278;
    t['bracketright'] = 389;
    t['asciicircum'] = 422;
    t['underscore'] = 500;
    t['quoteleft'] = 333;
    t['a'] = 500;
    t['b'] = 500;
    t['c'] = 444;
    t['d'] = 500;
    t['e'] = 444;
    t['f'] = 278;
    t['g'] = 500;
    t['h'] = 500;
    t['i'] = 278;
    t['j'] = 278;
    t['k'] = 444;
    t['l'] = 278;
    t['m'] = 722;
    t['n'] = 500;
    t['o'] = 500;
    t['p'] = 500;
    t['q'] = 500;
    t['r'] = 389;
    t['s'] = 389;
    t['t'] = 278;
    t['u'] = 500;
    t['v'] = 444;
    t['w'] = 667;
    t['x'] = 444;
    t['y'] = 444;
    t['z'] = 389;
    t['braceleft'] = 400;
    t['bar'] = 275;
    t['braceright'] = 400;
    t['asciitilde'] = 541;
    t['exclamdown'] = 389;
    t['cent'] = 500;
    t['sterling'] = 500;
    t['fraction'] = 167;
    t['yen'] = 500;
    t['florin'] = 500;
    t['section'] = 500;
    t['currency'] = 500;
    t['quotesingle'] = 214;
    t['quotedblleft'] = 556;
    t['guillemotleft'] = 500;
    t['guilsinglleft'] = 333;
    t['guilsinglright'] = 333;
    t['fi'] = 500;
    t['fl'] = 500;
    t['endash'] = 500;
    t['dagger'] = 500;
    t['daggerdbl'] = 500;
    t['periodcentered'] = 250;
    t['paragraph'] = 523;
    t['bullet'] = 350;
    t['quotesinglbase'] = 333;
    t['quotedblbase'] = 556;
    t['quotedblright'] = 556;
    t['guillemotright'] = 500;
    t['ellipsis'] = 889;
    t['perthousand'] = 1000;
    t['questiondown'] = 500;
    t['grave'] = 333;
    t['acute'] = 333;
    t['circumflex'] = 333;
    t['tilde'] = 333;
    t['macron'] = 333;
    t['breve'] = 333;
    t['dotaccent'] = 333;
    t['dieresis'] = 333;
    t['ring'] = 333;
    t['cedilla'] = 333;
    t['hungarumlaut'] = 333;
    t['ogonek'] = 333;
    t['caron'] = 333;
    t['emdash'] = 889;
    t['AE'] = 889;
    t['ordfeminine'] = 276;
    t['Lslash'] = 556;
    t['Oslash'] = 722;
    t['OE'] = 944;
    t['ordmasculine'] = 310;
    t['ae'] = 667;
    t['dotlessi'] = 278;
    t['lslash'] = 278;
    t['oslash'] = 500;
    t['oe'] = 667;
    t['germandbls'] = 500;
    t['Idieresis'] = 333;
    t['eacute'] = 444;
    t['abreve'] = 500;
    t['uhungarumlaut'] = 500;
    t['ecaron'] = 444;
    t['Ydieresis'] = 556;
    t['divide'] = 675;
    t['Yacute'] = 556;
    t['Acircumflex'] = 611;
    t['aacute'] = 500;
    t['Ucircumflex'] = 722;
    t['yacute'] = 444;
    t['scommaaccent'] = 389;
    t['ecircumflex'] = 444;
    t['Uring'] = 722;
    t['Udieresis'] = 722;
    t['aogonek'] = 500;
    t['Uacute'] = 722;
    t['uogonek'] = 500;
    t['Edieresis'] = 611;
    t['Dcroat'] = 722;
    t['commaaccent'] = 250;
    t['copyright'] = 760;
    t['Emacron'] = 611;
    t['ccaron'] = 444;
    t['aring'] = 500;
    t['Ncommaaccent'] = 667;
    t['lacute'] = 278;
    t['agrave'] = 500;
    t['Tcommaaccent'] = 556;
    t['Cacute'] = 667;
    t['atilde'] = 500;
    t['Edotaccent'] = 611;
    t['scaron'] = 389;
    t['scedilla'] = 389;
    t['iacute'] = 278;
    t['lozenge'] = 471;
    t['Rcaron'] = 611;
    t['Gcommaaccent'] = 722;
    t['ucircumflex'] = 500;
    t['acircumflex'] = 500;
    t['Amacron'] = 611;
    t['rcaron'] = 389;
    t['ccedilla'] = 444;
    t['Zdotaccent'] = 556;
    t['Thorn'] = 611;
    t['Omacron'] = 722;
    t['Racute'] = 611;
    t['Sacute'] = 500;
    t['dcaron'] = 544;
    t['Umacron'] = 722;
    t['uring'] = 500;
    t['threesuperior'] = 300;
    t['Ograve'] = 722;
    t['Agrave'] = 611;
    t['Abreve'] = 611;
    t['multiply'] = 675;
    t['uacute'] = 500;
    t['Tcaron'] = 556;
    t['partialdiff'] = 476;
    t['ydieresis'] = 444;
    t['Nacute'] = 667;
    t['icircumflex'] = 278;
    t['Ecircumflex'] = 611;
    t['adieresis'] = 500;
    t['edieresis'] = 444;
    t['cacute'] = 444;
    t['nacute'] = 500;
    t['umacron'] = 500;
    t['Ncaron'] = 667;
    t['Iacute'] = 333;
    t['plusminus'] = 675;
    t['brokenbar'] = 275;
    t['registered'] = 760;
    t['Gbreve'] = 722;
    t['Idotaccent'] = 333;
    t['summation'] = 600;
    t['Egrave'] = 611;
    t['racute'] = 389;
    t['omacron'] = 500;
    t['Zacute'] = 556;
    t['Zcaron'] = 556;
    t['greaterequal'] = 549;
    t['Eth'] = 722;
    t['Ccedilla'] = 667;
    t['lcommaaccent'] = 278;
    t['tcaron'] = 300;
    t['eogonek'] = 444;
    t['Uogonek'] = 722;
    t['Aacute'] = 611;
    t['Adieresis'] = 611;
    t['egrave'] = 444;
    t['zacute'] = 389;
    t['iogonek'] = 278;
    t['Oacute'] = 722;
    t['oacute'] = 500;
    t['amacron'] = 500;
    t['sacute'] = 389;
    t['idieresis'] = 278;
    t['Ocircumflex'] = 722;
    t['Ugrave'] = 722;
    t['Delta'] = 612;
    t['thorn'] = 500;
    t['twosuperior'] = 300;
    t['Odieresis'] = 722;
    t['mu'] = 500;
    t['igrave'] = 278;
    t['ohungarumlaut'] = 500;
    t['Eogonek'] = 611;
    t['dcroat'] = 500;
    t['threequarters'] = 750;
    t['Scedilla'] = 500;
    t['lcaron'] = 300;
    t['Kcommaaccent'] = 667;
    t['Lacute'] = 556;
    t['trademark'] = 980;
    t['edotaccent'] = 444;
    t['Igrave'] = 333;
    t['Imacron'] = 333;
    t['Lcaron'] = 611;
    t['onehalf'] = 750;
    t['lessequal'] = 549;
    t['ocircumflex'] = 500;
    t['ntilde'] = 500;
    t['Uhungarumlaut'] = 722;
    t['Eacute'] = 611;
    t['emacron'] = 444;
    t['gbreve'] = 500;
    t['onequarter'] = 750;
    t['Scaron'] = 500;
    t['Scommaaccent'] = 500;
    t['Ohungarumlaut'] = 722;
    t['degree'] = 400;
    t['ograve'] = 500;
    t['Ccaron'] = 667;
    t['ugrave'] = 500;
    t['radical'] = 453;
    t['Dcaron'] = 722;
    t['rcommaaccent'] = 389;
    t['Ntilde'] = 667;
    t['otilde'] = 500;
    t['Rcommaaccent'] = 611;
    t['Lcommaaccent'] = 556;
    t['Atilde'] = 611;
    t['Aogonek'] = 611;
    t['Aring'] = 611;
    t['Otilde'] = 722;
    t['zdotaccent'] = 389;
    t['Ecaron'] = 611;
    t['Iogonek'] = 333;
    t['kcommaaccent'] = 444;
    t['minus'] = 675;
    t['Icircumflex'] = 333;
    t['ncaron'] = 500;
    t['tcommaaccent'] = 278;
    t['logicalnot'] = 675;
    t['odieresis'] = 500;
    t['udieresis'] = 500;
    t['notequal'] = 549;
    t['gcommaaccent'] = 500;
    t['eth'] = 500;
    t['zcaron'] = 389;
    t['ncommaaccent'] = 500;
    t['onesuperior'] = 300;
    t['imacron'] = 278;
    t['Euro'] = 500;
  });
  t['ZapfDingbats'] = (0, _util.getLookupTableFactory)(function (t) {
    t['space'] = 278;
    t['a1'] = 974;
    t['a2'] = 961;
    t['a202'] = 974;
    t['a3'] = 980;
    t['a4'] = 719;
    t['a5'] = 789;
    t['a119'] = 790;
    t['a118'] = 791;
    t['a117'] = 690;
    t['a11'] = 960;
    t['a12'] = 939;
    t['a13'] = 549;
    t['a14'] = 855;
    t['a15'] = 911;
    t['a16'] = 933;
    t['a105'] = 911;
    t['a17'] = 945;
    t['a18'] = 974;
    t['a19'] = 755;
    t['a20'] = 846;
    t['a21'] = 762;
    t['a22'] = 761;
    t['a23'] = 571;
    t['a24'] = 677;
    t['a25'] = 763;
    t['a26'] = 760;
    t['a27'] = 759;
    t['a28'] = 754;
    t['a6'] = 494;
    t['a7'] = 552;
    t['a8'] = 537;
    t['a9'] = 577;
    t['a10'] = 692;
    t['a29'] = 786;
    t['a30'] = 788;
    t['a31'] = 788;
    t['a32'] = 790;
    t['a33'] = 793;
    t['a34'] = 794;
    t['a35'] = 816;
    t['a36'] = 823;
    t['a37'] = 789;
    t['a38'] = 841;
    t['a39'] = 823;
    t['a40'] = 833;
    t['a41'] = 816;
    t['a42'] = 831;
    t['a43'] = 923;
    t['a44'] = 744;
    t['a45'] = 723;
    t['a46'] = 749;
    t['a47'] = 790;
    t['a48'] = 792;
    t['a49'] = 695;
    t['a50'] = 776;
    t['a51'] = 768;
    t['a52'] = 792;
    t['a53'] = 759;
    t['a54'] = 707;
    t['a55'] = 708;
    t['a56'] = 682;
    t['a57'] = 701;
    t['a58'] = 826;
    t['a59'] = 815;
    t['a60'] = 789;
    t['a61'] = 789;
    t['a62'] = 707;
    t['a63'] = 687;
    t['a64'] = 696;
    t['a65'] = 689;
    t['a66'] = 786;
    t['a67'] = 787;
    t['a68'] = 713;
    t['a69'] = 791;
    t['a70'] = 785;
    t['a71'] = 791;
    t['a72'] = 873;
    t['a73'] = 761;
    t['a74'] = 762;
    t['a203'] = 762;
    t['a75'] = 759;
    t['a204'] = 759;
    t['a76'] = 892;
    t['a77'] = 892;
    t['a78'] = 788;
    t['a79'] = 784;
    t['a81'] = 438;
    t['a82'] = 138;
    t['a83'] = 277;
    t['a84'] = 415;
    t['a97'] = 392;
    t['a98'] = 392;
    t['a99'] = 668;
    t['a100'] = 668;
    t['a89'] = 390;
    t['a90'] = 390;
    t['a93'] = 317;
    t['a94'] = 317;
    t['a91'] = 276;
    t['a92'] = 276;
    t['a205'] = 509;
    t['a85'] = 509;
    t['a206'] = 410;
    t['a86'] = 410;
    t['a87'] = 234;
    t['a88'] = 234;
    t['a95'] = 334;
    t['a96'] = 334;
    t['a101'] = 732;
    t['a102'] = 544;
    t['a103'] = 544;
    t['a104'] = 910;
    t['a106'] = 667;
    t['a107'] = 760;
    t['a108'] = 760;
    t['a112'] = 776;
    t['a111'] = 595;
    t['a110'] = 694;
    t['a109'] = 626;
    t['a120'] = 788;
    t['a121'] = 788;
    t['a122'] = 788;
    t['a123'] = 788;
    t['a124'] = 788;
    t['a125'] = 788;
    t['a126'] = 788;
    t['a127'] = 788;
    t['a128'] = 788;
    t['a129'] = 788;
    t['a130'] = 788;
    t['a131'] = 788;
    t['a132'] = 788;
    t['a133'] = 788;
    t['a134'] = 788;
    t['a135'] = 788;
    t['a136'] = 788;
    t['a137'] = 788;
    t['a138'] = 788;
    t['a139'] = 788;
    t['a140'] = 788;
    t['a141'] = 788;
    t['a142'] = 788;
    t['a143'] = 788;
    t['a144'] = 788;
    t['a145'] = 788;
    t['a146'] = 788;
    t['a147'] = 788;
    t['a148'] = 788;
    t['a149'] = 788;
    t['a150'] = 788;
    t['a151'] = 788;
    t['a152'] = 788;
    t['a153'] = 788;
    t['a154'] = 788;
    t['a155'] = 788;
    t['a156'] = 788;
    t['a157'] = 788;
    t['a158'] = 788;
    t['a159'] = 788;
    t['a160'] = 894;
    t['a161'] = 838;
    t['a163'] = 1016;
    t['a164'] = 458;
    t['a196'] = 748;
    t['a165'] = 924;
    t['a192'] = 748;
    t['a166'] = 918;
    t['a167'] = 927;
    t['a168'] = 928;
    t['a169'] = 928;
    t['a170'] = 834;
    t['a171'] = 873;
    t['a172'] = 828;
    t['a173'] = 924;
    t['a162'] = 924;
    t['a174'] = 917;
    t['a175'] = 930;
    t['a176'] = 931;
    t['a177'] = 463;
    t['a178'] = 883;
    t['a179'] = 836;
    t['a193'] = 836;
    t['a180'] = 867;
    t['a199'] = 867;
    t['a181'] = 696;
    t['a200'] = 696;
    t['a182'] = 874;
    t['a201'] = 874;
    t['a183'] = 760;
    t['a184'] = 946;
    t['a197'] = 771;
    t['a185'] = 865;
    t['a194'] = 771;
    t['a198'] = 888;
    t['a186'] = 967;
    t['a195'] = 888;
    t['a187'] = 831;
    t['a188'] = 873;
    t['a189'] = 927;
    t['a190'] = 970;
    t['a191'] = 918;
  });
});
exports.getMetrics = getMetrics;

/***/ }),
/* 185 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPDFFunction = isPDFFunction;
exports.PostScriptCompiler = exports.PostScriptEvaluator = exports.PDFFunctionFactory = void 0;

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

var _ps_parser = __w_pdfjs_require__(186);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var IsEvalSupportedCached = {
  get value() {
    return (0, _util.shadow)(this, 'value', (0, _util.isEvalSupported)());
  }

};

var PDFFunctionFactory =
/*#__PURE__*/
function () {
  function PDFFunctionFactory(_ref) {
    var xref = _ref.xref,
        _ref$isEvalSupported = _ref.isEvalSupported,
        isEvalSupported = _ref$isEvalSupported === void 0 ? true : _ref$isEvalSupported;

    _classCallCheck(this, PDFFunctionFactory);

    this.xref = xref;
    this.isEvalSupported = isEvalSupported !== false;
  }

  _createClass(PDFFunctionFactory, [{
    key: "create",
    value: function create(fn) {
      return PDFFunction.parse({
        xref: this.xref,
        isEvalSupported: this.isEvalSupported,
        fn: fn
      });
    }
  }, {
    key: "createFromArray",
    value: function createFromArray(fnObj) {
      return PDFFunction.parseArray({
        xref: this.xref,
        isEvalSupported: this.isEvalSupported,
        fnObj: fnObj
      });
    }
  }]);

  return PDFFunctionFactory;
}();

exports.PDFFunctionFactory = PDFFunctionFactory;

function toNumberArray(arr) {
  if (!Array.isArray(arr)) {
    return null;
  }

  var length = arr.length;

  for (var i = 0; i < length; i++) {
    if (typeof arr[i] !== 'number') {
      var result = new Array(length);

      for (var _i = 0; _i < length; _i++) {
        result[_i] = +arr[_i];
      }

      return result;
    }
  }

  return arr;
}

var PDFFunction = function PDFFunctionClosure() {
  var CONSTRUCT_SAMPLED = 0;
  var CONSTRUCT_INTERPOLATED = 2;
  var CONSTRUCT_STICHED = 3;
  var CONSTRUCT_POSTSCRIPT = 4;
  return {
    getSampleArray: function getSampleArray(size, outputSize, bps, stream) {
      var i, ii;
      var length = 1;

      for (i = 0, ii = size.length; i < ii; i++) {
        length *= size[i];
      }

      length *= outputSize;
      var array = new Array(length);
      var codeSize = 0;
      var codeBuf = 0;
      var sampleMul = 1.0 / (Math.pow(2.0, bps) - 1);
      var strBytes = stream.getBytes((length * bps + 7) / 8);
      var strIdx = 0;

      for (i = 0; i < length; i++) {
        while (codeSize < bps) {
          codeBuf <<= 8;
          codeBuf |= strBytes[strIdx++];
          codeSize += 8;
        }

        codeSize -= bps;
        array[i] = (codeBuf >> codeSize) * sampleMul;
        codeBuf &= (1 << codeSize) - 1;
      }

      return array;
    },
    getIR: function getIR(_ref2) {
      var xref = _ref2.xref,
          isEvalSupported = _ref2.isEvalSupported,
          fn = _ref2.fn;
      var dict = fn.dict;

      if (!dict) {
        dict = fn;
      }

      var types = [this.constructSampled, null, this.constructInterpolated, this.constructStiched, this.constructPostScript];
      var typeNum = dict.get('FunctionType');
      var typeFn = types[typeNum];

      if (!typeFn) {
        throw new _util.FormatError('Unknown type of function');
      }

      return typeFn.call(this, {
        xref: xref,
        isEvalSupported: isEvalSupported,
        fn: fn,
        dict: dict
      });
    },
    fromIR: function fromIR(_ref3) {
      var xref = _ref3.xref,
          isEvalSupported = _ref3.isEvalSupported,
          IR = _ref3.IR;
      var type = IR[0];

      switch (type) {
        case CONSTRUCT_SAMPLED:
          return this.constructSampledFromIR({
            xref: xref,
            isEvalSupported: isEvalSupported,
            IR: IR
          });

        case CONSTRUCT_INTERPOLATED:
          return this.constructInterpolatedFromIR({
            xref: xref,
            isEvalSupported: isEvalSupported,
            IR: IR
          });

        case CONSTRUCT_STICHED:
          return this.constructStichedFromIR({
            xref: xref,
            isEvalSupported: isEvalSupported,
            IR: IR
          });

        default:
          return this.constructPostScriptFromIR({
            xref: xref,
            isEvalSupported: isEvalSupported,
            IR: IR
          });
      }
    },
    parse: function parse(_ref4) {
      var xref = _ref4.xref,
          isEvalSupported = _ref4.isEvalSupported,
          fn = _ref4.fn;
      var IR = this.getIR({
        xref: xref,
        isEvalSupported: isEvalSupported,
        fn: fn
      });
      return this.fromIR({
        xref: xref,
        isEvalSupported: isEvalSupported,
        IR: IR
      });
    },
    parseArray: function parseArray(_ref5) {
      var xref = _ref5.xref,
          isEvalSupported = _ref5.isEvalSupported,
          fnObj = _ref5.fnObj;

      if (!Array.isArray(fnObj)) {
        return this.parse({
          xref: xref,
          isEvalSupported: isEvalSupported,
          fn: fnObj
        });
      }

      var fnArray = [];

      for (var j = 0, jj = fnObj.length; j < jj; j++) {
        fnArray.push(this.parse({
          xref: xref,
          isEvalSupported: isEvalSupported,
          fn: xref.fetchIfRef(fnObj[j])
        }));
      }

      return function (src, srcOffset, dest, destOffset) {
        for (var i = 0, ii = fnArray.length; i < ii; i++) {
          fnArray[i](src, srcOffset, dest, destOffset + i);
        }
      };
    },
    constructSampled: function constructSampled(_ref6) {
      var xref = _ref6.xref,
          isEvalSupported = _ref6.isEvalSupported,
          fn = _ref6.fn,
          dict = _ref6.dict;

      function toMultiArray(arr) {
        var inputLength = arr.length;
        var out = [];
        var index = 0;

        for (var i = 0; i < inputLength; i += 2) {
          out[index] = [arr[i], arr[i + 1]];
          ++index;
        }

        return out;
      }

      var domain = toNumberArray(dict.getArray('Domain'));
      var range = toNumberArray(dict.getArray('Range'));

      if (!domain || !range) {
        throw new _util.FormatError('No domain or range');
      }

      var inputSize = domain.length / 2;
      var outputSize = range.length / 2;
      domain = toMultiArray(domain);
      range = toMultiArray(range);
      var size = toNumberArray(dict.getArray('Size'));
      var bps = dict.get('BitsPerSample');
      var order = dict.get('Order') || 1;

      if (order !== 1) {
        (0, _util.info)('No support for cubic spline interpolation: ' + order);
      }

      var encode = toNumberArray(dict.getArray('Encode'));

      if (!encode) {
        encode = [];

        for (var i = 0; i < inputSize; ++i) {
          encode.push([0, size[i] - 1]);
        }
      } else {
        encode = toMultiArray(encode);
      }

      var decode = toNumberArray(dict.getArray('Decode'));

      if (!decode) {
        decode = range;
      } else {
        decode = toMultiArray(decode);
      }

      var samples = this.getSampleArray(size, outputSize, bps, fn);
      return [CONSTRUCT_SAMPLED, inputSize, domain, encode, decode, samples, size, outputSize, Math.pow(2, bps) - 1, range];
    },
    constructSampledFromIR: function constructSampledFromIR(_ref7) {
      var xref = _ref7.xref,
          isEvalSupported = _ref7.isEvalSupported,
          IR = _ref7.IR;

      function interpolate(x, xmin, xmax, ymin, ymax) {
        return ymin + (x - xmin) * ((ymax - ymin) / (xmax - xmin));
      }

      return function constructSampledFromIRResult(src, srcOffset, dest, destOffset) {
        var m = IR[1];
        var domain = IR[2];
        var encode = IR[3];
        var decode = IR[4];
        var samples = IR[5];
        var size = IR[6];
        var n = IR[7];
        var range = IR[9];
        var cubeVertices = 1 << m;
        var cubeN = new Float64Array(cubeVertices);
        var cubeVertex = new Uint32Array(cubeVertices);
        var i, j;

        for (j = 0; j < cubeVertices; j++) {
          cubeN[j] = 1;
        }

        var k = n,
            pos = 1;

        for (i = 0; i < m; ++i) {
          var domain_2i = domain[i][0];
          var domain_2i_1 = domain[i][1];
          var xi = Math.min(Math.max(src[srcOffset + i], domain_2i), domain_2i_1);
          var e = interpolate(xi, domain_2i, domain_2i_1, encode[i][0], encode[i][1]);
          var size_i = size[i];
          e = Math.min(Math.max(e, 0), size_i - 1);
          var e0 = e < size_i - 1 ? Math.floor(e) : e - 1;
          var n0 = e0 + 1 - e;
          var n1 = e - e0;
          var offset0 = e0 * k;
          var offset1 = offset0 + k;

          for (j = 0; j < cubeVertices; j++) {
            if (j & pos) {
              cubeN[j] *= n1;
              cubeVertex[j] += offset1;
            } else {
              cubeN[j] *= n0;
              cubeVertex[j] += offset0;
            }
          }

          k *= size_i;
          pos <<= 1;
        }

        for (j = 0; j < n; ++j) {
          var rj = 0;

          for (i = 0; i < cubeVertices; i++) {
            rj += samples[cubeVertex[i] + j] * cubeN[i];
          }

          rj = interpolate(rj, 0, 1, decode[j][0], decode[j][1]);
          dest[destOffset + j] = Math.min(Math.max(rj, range[j][0]), range[j][1]);
        }
      };
    },
    constructInterpolated: function constructInterpolated(_ref8) {
      var xref = _ref8.xref,
          isEvalSupported = _ref8.isEvalSupported,
          fn = _ref8.fn,
          dict = _ref8.dict;
      var c0 = toNumberArray(dict.getArray('C0')) || [0];
      var c1 = toNumberArray(dict.getArray('C1')) || [1];
      var n = dict.get('N');
      var length = c0.length;
      var diff = [];

      for (var i = 0; i < length; ++i) {
        diff.push(c1[i] - c0[i]);
      }

      return [CONSTRUCT_INTERPOLATED, c0, diff, n];
    },
    constructInterpolatedFromIR: function constructInterpolatedFromIR(_ref9) {
      var xref = _ref9.xref,
          isEvalSupported = _ref9.isEvalSupported,
          IR = _ref9.IR;
      var c0 = IR[1];
      var diff = IR[2];
      var n = IR[3];
      var length = diff.length;
      return function constructInterpolatedFromIRResult(src, srcOffset, dest, destOffset) {
        var x = n === 1 ? src[srcOffset] : Math.pow(src[srcOffset], n);

        for (var j = 0; j < length; ++j) {
          dest[destOffset + j] = c0[j] + x * diff[j];
        }
      };
    },
    constructStiched: function constructStiched(_ref10) {
      var xref = _ref10.xref,
          isEvalSupported = _ref10.isEvalSupported,
          fn = _ref10.fn,
          dict = _ref10.dict;
      var domain = toNumberArray(dict.getArray('Domain'));

      if (!domain) {
        throw new _util.FormatError('No domain');
      }

      var inputSize = domain.length / 2;

      if (inputSize !== 1) {
        throw new _util.FormatError('Bad domain for stiched function');
      }

      var fnRefs = dict.get('Functions');
      var fns = [];

      for (var i = 0, ii = fnRefs.length; i < ii; ++i) {
        fns.push(this.parse({
          xref: xref,
          isEvalSupported: isEvalSupported,
          fn: xref.fetchIfRef(fnRefs[i])
        }));
      }

      var bounds = toNumberArray(dict.getArray('Bounds'));
      var encode = toNumberArray(dict.getArray('Encode'));
      return [CONSTRUCT_STICHED, domain, bounds, encode, fns];
    },
    constructStichedFromIR: function constructStichedFromIR(_ref11) {
      var xref = _ref11.xref,
          isEvalSupported = _ref11.isEvalSupported,
          IR = _ref11.IR;
      var domain = IR[1];
      var bounds = IR[2];
      var encode = IR[3];
      var fns = IR[4];
      var tmpBuf = new Float32Array(1);
      return function constructStichedFromIRResult(src, srcOffset, dest, destOffset) {
        var clip = function constructStichedFromIRClip(v, min, max) {
          if (v > max) {
            v = max;
          } else if (v < min) {
            v = min;
          }

          return v;
        };

        var v = clip(src[srcOffset], domain[0], domain[1]);

        for (var i = 0, ii = bounds.length; i < ii; ++i) {
          if (v < bounds[i]) {
            break;
          }
        }

        var dmin = domain[0];

        if (i > 0) {
          dmin = bounds[i - 1];
        }

        var dmax = domain[1];

        if (i < bounds.length) {
          dmax = bounds[i];
        }

        var rmin = encode[2 * i];
        var rmax = encode[2 * i + 1];
        tmpBuf[0] = dmin === dmax ? rmin : rmin + (v - dmin) * (rmax - rmin) / (dmax - dmin);
        fns[i](tmpBuf, 0, dest, destOffset);
      };
    },
    constructPostScript: function constructPostScript(_ref12) {
      var xref = _ref12.xref,
          isEvalSupported = _ref12.isEvalSupported,
          fn = _ref12.fn,
          dict = _ref12.dict;
      var domain = toNumberArray(dict.getArray('Domain'));
      var range = toNumberArray(dict.getArray('Range'));

      if (!domain) {
        throw new _util.FormatError('No domain.');
      }

      if (!range) {
        throw new _util.FormatError('No range.');
      }

      var lexer = new _ps_parser.PostScriptLexer(fn);
      var parser = new _ps_parser.PostScriptParser(lexer);
      var code = parser.parse();
      return [CONSTRUCT_POSTSCRIPT, domain, range, code];
    },
    constructPostScriptFromIR: function constructPostScriptFromIR(_ref13) {
      var xref = _ref13.xref,
          isEvalSupported = _ref13.isEvalSupported,
          IR = _ref13.IR;
      var domain = IR[1];
      var range = IR[2];
      var code = IR[3];

      if (isEvalSupported && IsEvalSupportedCached.value) {
        var compiled = new PostScriptCompiler().compile(code, domain, range);

        if (compiled) {
          return new Function('src', 'srcOffset', 'dest', 'destOffset', compiled);
        }
      }

      (0, _util.info)('Unable to compile PS function');
      var numOutputs = range.length >> 1;
      var numInputs = domain.length >> 1;
      var evaluator = new PostScriptEvaluator(code);
      var cache = Object.create(null);
      var MAX_CACHE_SIZE = 2048 * 4;
      var cache_available = MAX_CACHE_SIZE;
      var tmpBuf = new Float32Array(numInputs);
      return function constructPostScriptFromIRResult(src, srcOffset, dest, destOffset) {
        var i, value;
        var key = '';
        var input = tmpBuf;

        for (i = 0; i < numInputs; i++) {
          value = src[srcOffset + i];
          input[i] = value;
          key += value + '_';
        }

        var cachedValue = cache[key];

        if (cachedValue !== undefined) {
          dest.set(cachedValue, destOffset);
          return;
        }

        var output = new Float32Array(numOutputs);
        var stack = evaluator.execute(input);
        var stackIndex = stack.length - numOutputs;

        for (i = 0; i < numOutputs; i++) {
          value = stack[stackIndex + i];
          var bound = range[i * 2];

          if (value < bound) {
            value = bound;
          } else {
            bound = range[i * 2 + 1];

            if (value > bound) {
              value = bound;
            }
          }

          output[i] = value;
        }

        if (cache_available > 0) {
          cache_available--;
          cache[key] = output;
        }

        dest.set(output, destOffset);
      };
    }
  };
}();

function isPDFFunction(v) {
  var fnDict;

  if (_typeof(v) !== 'object') {
    return false;
  } else if ((0, _primitives.isDict)(v)) {
    fnDict = v;
  } else if ((0, _primitives.isStream)(v)) {
    fnDict = v.dict;
  } else {
    return false;
  }

  return fnDict.has('FunctionType');
}

var PostScriptStack = function PostScriptStackClosure() {
  var MAX_STACK_SIZE = 100;

  function PostScriptStack(initialStack) {
    this.stack = !initialStack ? [] : Array.prototype.slice.call(initialStack, 0);
  }

  PostScriptStack.prototype = {
    push: function PostScriptStack_push(value) {
      if (this.stack.length >= MAX_STACK_SIZE) {
        throw new Error('PostScript function stack overflow.');
      }

      this.stack.push(value);
    },
    pop: function PostScriptStack_pop() {
      if (this.stack.length <= 0) {
        throw new Error('PostScript function stack underflow.');
      }

      return this.stack.pop();
    },
    copy: function PostScriptStack_copy(n) {
      if (this.stack.length + n >= MAX_STACK_SIZE) {
        throw new Error('PostScript function stack overflow.');
      }

      var stack = this.stack;

      for (var i = stack.length - n, j = n - 1; j >= 0; j--, i++) {
        stack.push(stack[i]);
      }
    },
    index: function PostScriptStack_index(n) {
      this.push(this.stack[this.stack.length - n - 1]);
    },
    roll: function PostScriptStack_roll(n, p) {
      var stack = this.stack;
      var l = stack.length - n;
      var r = stack.length - 1,
          c = l + (p - Math.floor(p / n) * n),
          i,
          j,
          t;

      for (i = l, j = r; i < j; i++, j--) {
        t = stack[i];
        stack[i] = stack[j];
        stack[j] = t;
      }

      for (i = l, j = c - 1; i < j; i++, j--) {
        t = stack[i];
        stack[i] = stack[j];
        stack[j] = t;
      }

      for (i = c, j = r; i < j; i++, j--) {
        t = stack[i];
        stack[i] = stack[j];
        stack[j] = t;
      }
    }
  };
  return PostScriptStack;
}();

var PostScriptEvaluator = function PostScriptEvaluatorClosure() {
  function PostScriptEvaluator(operators) {
    this.operators = operators;
  }

  PostScriptEvaluator.prototype = {
    execute: function PostScriptEvaluator_execute(initialStack) {
      var stack = new PostScriptStack(initialStack);
      var counter = 0;
      var operators = this.operators;
      var length = operators.length;
      var operator, a, b;

      while (counter < length) {
        operator = operators[counter++];

        if (typeof operator === 'number') {
          stack.push(operator);
          continue;
        }

        switch (operator) {
          case 'jz':
            b = stack.pop();
            a = stack.pop();

            if (!a) {
              counter = b;
            }

            break;

          case 'j':
            a = stack.pop();
            counter = a;
            break;

          case 'abs':
            a = stack.pop();
            stack.push(Math.abs(a));
            break;

          case 'add':
            b = stack.pop();
            a = stack.pop();
            stack.push(a + b);
            break;

          case 'and':
            b = stack.pop();
            a = stack.pop();

            if ((0, _util.isBool)(a) && (0, _util.isBool)(b)) {
              stack.push(a && b);
            } else {
              stack.push(a & b);
            }

            break;

          case 'atan':
            a = stack.pop();
            stack.push(Math.atan(a));
            break;

          case 'bitshift':
            b = stack.pop();
            a = stack.pop();

            if (a > 0) {
              stack.push(a << b);
            } else {
              stack.push(a >> b);
            }

            break;

          case 'ceiling':
            a = stack.pop();
            stack.push(Math.ceil(a));
            break;

          case 'copy':
            a = stack.pop();
            stack.copy(a);
            break;

          case 'cos':
            a = stack.pop();
            stack.push(Math.cos(a));
            break;

          case 'cvi':
            a = stack.pop() | 0;
            stack.push(a);
            break;

          case 'cvr':
            break;

          case 'div':
            b = stack.pop();
            a = stack.pop();
            stack.push(a / b);
            break;

          case 'dup':
            stack.copy(1);
            break;

          case 'eq':
            b = stack.pop();
            a = stack.pop();
            stack.push(a === b);
            break;

          case 'exch':
            stack.roll(2, 1);
            break;

          case 'exp':
            b = stack.pop();
            a = stack.pop();
            stack.push(Math.pow(a, b));
            break;

          case 'false':
            stack.push(false);
            break;

          case 'floor':
            a = stack.pop();
            stack.push(Math.floor(a));
            break;

          case 'ge':
            b = stack.pop();
            a = stack.pop();
            stack.push(a >= b);
            break;

          case 'gt':
            b = stack.pop();
            a = stack.pop();
            stack.push(a > b);
            break;

          case 'idiv':
            b = stack.pop();
            a = stack.pop();
            stack.push(a / b | 0);
            break;

          case 'index':
            a = stack.pop();
            stack.index(a);
            break;

          case 'le':
            b = stack.pop();
            a = stack.pop();
            stack.push(a <= b);
            break;

          case 'ln':
            a = stack.pop();
            stack.push(Math.log(a));
            break;

          case 'log':
            a = stack.pop();
            stack.push(Math.log(a) / Math.LN10);
            break;

          case 'lt':
            b = stack.pop();
            a = stack.pop();
            stack.push(a < b);
            break;

          case 'mod':
            b = stack.pop();
            a = stack.pop();
            stack.push(a % b);
            break;

          case 'mul':
            b = stack.pop();
            a = stack.pop();
            stack.push(a * b);
            break;

          case 'ne':
            b = stack.pop();
            a = stack.pop();
            stack.push(a !== b);
            break;

          case 'neg':
            a = stack.pop();
            stack.push(-a);
            break;

          case 'not':
            a = stack.pop();

            if ((0, _util.isBool)(a)) {
              stack.push(!a);
            } else {
              stack.push(~a);
            }

            break;

          case 'or':
            b = stack.pop();
            a = stack.pop();

            if ((0, _util.isBool)(a) && (0, _util.isBool)(b)) {
              stack.push(a || b);
            } else {
              stack.push(a | b);
            }

            break;

          case 'pop':
            stack.pop();
            break;

          case 'roll':
            b = stack.pop();
            a = stack.pop();
            stack.roll(a, b);
            break;

          case 'round':
            a = stack.pop();
            stack.push(Math.round(a));
            break;

          case 'sin':
            a = stack.pop();
            stack.push(Math.sin(a));
            break;

          case 'sqrt':
            a = stack.pop();
            stack.push(Math.sqrt(a));
            break;

          case 'sub':
            b = stack.pop();
            a = stack.pop();
            stack.push(a - b);
            break;

          case 'true':
            stack.push(true);
            break;

          case 'truncate':
            a = stack.pop();
            a = a < 0 ? Math.ceil(a) : Math.floor(a);
            stack.push(a);
            break;

          case 'xor':
            b = stack.pop();
            a = stack.pop();

            if ((0, _util.isBool)(a) && (0, _util.isBool)(b)) {
              stack.push(a !== b);
            } else {
              stack.push(a ^ b);
            }

            break;

          default:
            throw new _util.FormatError("Unknown operator ".concat(operator));
        }
      }

      return stack.stack;
    }
  };
  return PostScriptEvaluator;
}();

exports.PostScriptEvaluator = PostScriptEvaluator;

var PostScriptCompiler = function PostScriptCompilerClosure() {
  function AstNode(type) {
    this.type = type;
  }

  AstNode.prototype.visit = function (visitor) {
    (0, _util.unreachable)('abstract method');
  };

  function AstArgument(index, min, max) {
    AstNode.call(this, 'args');
    this.index = index;
    this.min = min;
    this.max = max;
  }

  AstArgument.prototype = Object.create(AstNode.prototype);

  AstArgument.prototype.visit = function (visitor) {
    visitor.visitArgument(this);
  };

  function AstLiteral(number) {
    AstNode.call(this, 'literal');
    this.number = number;
    this.min = number;
    this.max = number;
  }

  AstLiteral.prototype = Object.create(AstNode.prototype);

  AstLiteral.prototype.visit = function (visitor) {
    visitor.visitLiteral(this);
  };

  function AstBinaryOperation(op, arg1, arg2, min, max) {
    AstNode.call(this, 'binary');
    this.op = op;
    this.arg1 = arg1;
    this.arg2 = arg2;
    this.min = min;
    this.max = max;
  }

  AstBinaryOperation.prototype = Object.create(AstNode.prototype);

  AstBinaryOperation.prototype.visit = function (visitor) {
    visitor.visitBinaryOperation(this);
  };

  function AstMin(arg, max) {
    AstNode.call(this, 'max');
    this.arg = arg;
    this.min = arg.min;
    this.max = max;
  }

  AstMin.prototype = Object.create(AstNode.prototype);

  AstMin.prototype.visit = function (visitor) {
    visitor.visitMin(this);
  };

  function AstVariable(index, min, max) {
    AstNode.call(this, 'var');
    this.index = index;
    this.min = min;
    this.max = max;
  }

  AstVariable.prototype = Object.create(AstNode.prototype);

  AstVariable.prototype.visit = function (visitor) {
    visitor.visitVariable(this);
  };

  function AstVariableDefinition(variable, arg) {
    AstNode.call(this, 'definition');
    this.variable = variable;
    this.arg = arg;
  }

  AstVariableDefinition.prototype = Object.create(AstNode.prototype);

  AstVariableDefinition.prototype.visit = function (visitor) {
    visitor.visitVariableDefinition(this);
  };

  function ExpressionBuilderVisitor() {
    this.parts = [];
  }

  ExpressionBuilderVisitor.prototype = {
    visitArgument: function visitArgument(arg) {
      this.parts.push('Math.max(', arg.min, ', Math.min(', arg.max, ', src[srcOffset + ', arg.index, ']))');
    },
    visitVariable: function visitVariable(variable) {
      this.parts.push('v', variable.index);
    },
    visitLiteral: function visitLiteral(literal) {
      this.parts.push(literal.number);
    },
    visitBinaryOperation: function visitBinaryOperation(operation) {
      this.parts.push('(');
      operation.arg1.visit(this);
      this.parts.push(' ', operation.op, ' ');
      operation.arg2.visit(this);
      this.parts.push(')');
    },
    visitVariableDefinition: function visitVariableDefinition(definition) {
      this.parts.push('var ');
      definition.variable.visit(this);
      this.parts.push(' = ');
      definition.arg.visit(this);
      this.parts.push(';');
    },
    visitMin: function visitMin(max) {
      this.parts.push('Math.min(');
      max.arg.visit(this);
      this.parts.push(', ', max.max, ')');
    },
    toString: function toString() {
      return this.parts.join('');
    }
  };

  function buildAddOperation(num1, num2) {
    if (num2.type === 'literal' && num2.number === 0) {
      return num1;
    }

    if (num1.type === 'literal' && num1.number === 0) {
      return num2;
    }

    if (num2.type === 'literal' && num1.type === 'literal') {
      return new AstLiteral(num1.number + num2.number);
    }

    return new AstBinaryOperation('+', num1, num2, num1.min + num2.min, num1.max + num2.max);
  }

  function buildMulOperation(num1, num2) {
    if (num2.type === 'literal') {
      if (num2.number === 0) {
        return new AstLiteral(0);
      } else if (num2.number === 1) {
        return num1;
      } else if (num1.type === 'literal') {
        return new AstLiteral(num1.number * num2.number);
      }
    }

    if (num1.type === 'literal') {
      if (num1.number === 0) {
        return new AstLiteral(0);
      } else if (num1.number === 1) {
        return num2;
      }
    }

    var min = Math.min(num1.min * num2.min, num1.min * num2.max, num1.max * num2.min, num1.max * num2.max);
    var max = Math.max(num1.min * num2.min, num1.min * num2.max, num1.max * num2.min, num1.max * num2.max);
    return new AstBinaryOperation('*', num1, num2, min, max);
  }

  function buildSubOperation(num1, num2) {
    if (num2.type === 'literal') {
      if (num2.number === 0) {
        return num1;
      } else if (num1.type === 'literal') {
        return new AstLiteral(num1.number - num2.number);
      }
    }

    if (num2.type === 'binary' && num2.op === '-' && num1.type === 'literal' && num1.number === 1 && num2.arg1.type === 'literal' && num2.arg1.number === 1) {
      return num2.arg2;
    }

    return new AstBinaryOperation('-', num1, num2, num1.min - num2.max, num1.max - num2.min);
  }

  function buildMinOperation(num1, max) {
    if (num1.min >= max) {
      return new AstLiteral(max);
    } else if (num1.max <= max) {
      return num1;
    }

    return new AstMin(num1, max);
  }

  function PostScriptCompiler() {}

  PostScriptCompiler.prototype = {
    compile: function PostScriptCompiler_compile(code, domain, range) {
      var stack = [];
      var i, ii;
      var instructions = [];
      var inputSize = domain.length >> 1,
          outputSize = range.length >> 1;
      var lastRegister = 0;
      var n, j;
      var num1, num2, ast1, ast2, tmpVar, item;

      for (i = 0; i < inputSize; i++) {
        stack.push(new AstArgument(i, domain[i * 2], domain[i * 2 + 1]));
      }

      for (i = 0, ii = code.length; i < ii; i++) {
        item = code[i];

        if (typeof item === 'number') {
          stack.push(new AstLiteral(item));
          continue;
        }

        switch (item) {
          case 'add':
            if (stack.length < 2) {
              return null;
            }

            num2 = stack.pop();
            num1 = stack.pop();
            stack.push(buildAddOperation(num1, num2));
            break;

          case 'cvr':
            if (stack.length < 1) {
              return null;
            }

            break;

          case 'mul':
            if (stack.length < 2) {
              return null;
            }

            num2 = stack.pop();
            num1 = stack.pop();
            stack.push(buildMulOperation(num1, num2));
            break;

          case 'sub':
            if (stack.length < 2) {
              return null;
            }

            num2 = stack.pop();
            num1 = stack.pop();
            stack.push(buildSubOperation(num1, num2));
            break;

          case 'exch':
            if (stack.length < 2) {
              return null;
            }

            ast1 = stack.pop();
            ast2 = stack.pop();
            stack.push(ast1, ast2);
            break;

          case 'pop':
            if (stack.length < 1) {
              return null;
            }

            stack.pop();
            break;

          case 'index':
            if (stack.length < 1) {
              return null;
            }

            num1 = stack.pop();

            if (num1.type !== 'literal') {
              return null;
            }

            n = num1.number;

            if (n < 0 || !Number.isInteger(n) || stack.length < n) {
              return null;
            }

            ast1 = stack[stack.length - n - 1];

            if (ast1.type === 'literal' || ast1.type === 'var') {
              stack.push(ast1);
              break;
            }

            tmpVar = new AstVariable(lastRegister++, ast1.min, ast1.max);
            stack[stack.length - n - 1] = tmpVar;
            stack.push(tmpVar);
            instructions.push(new AstVariableDefinition(tmpVar, ast1));
            break;

          case 'dup':
            if (stack.length < 1) {
              return null;
            }

            if (typeof code[i + 1] === 'number' && code[i + 2] === 'gt' && code[i + 3] === i + 7 && code[i + 4] === 'jz' && code[i + 5] === 'pop' && code[i + 6] === code[i + 1]) {
              num1 = stack.pop();
              stack.push(buildMinOperation(num1, code[i + 1]));
              i += 6;
              break;
            }

            ast1 = stack[stack.length - 1];

            if (ast1.type === 'literal' || ast1.type === 'var') {
              stack.push(ast1);
              break;
            }

            tmpVar = new AstVariable(lastRegister++, ast1.min, ast1.max);
            stack[stack.length - 1] = tmpVar;
            stack.push(tmpVar);
            instructions.push(new AstVariableDefinition(tmpVar, ast1));
            break;

          case 'roll':
            if (stack.length < 2) {
              return null;
            }

            num2 = stack.pop();
            num1 = stack.pop();

            if (num2.type !== 'literal' || num1.type !== 'literal') {
              return null;
            }

            j = num2.number;
            n = num1.number;

            if (n <= 0 || !Number.isInteger(n) || !Number.isInteger(j) || stack.length < n) {
              return null;
            }

            j = (j % n + n) % n;

            if (j === 0) {
              break;
            }

            Array.prototype.push.apply(stack, stack.splice(stack.length - n, n - j));
            break;

          default:
            return null;
        }
      }

      if (stack.length !== outputSize) {
        return null;
      }

      var result = [];
      instructions.forEach(function (instruction) {
        var statementBuilder = new ExpressionBuilderVisitor();
        instruction.visit(statementBuilder);
        result.push(statementBuilder.toString());
      });
      stack.forEach(function (expr, i) {
        var statementBuilder = new ExpressionBuilderVisitor();
        expr.visit(statementBuilder);
        var min = range[i * 2],
            max = range[i * 2 + 1];
        var out = [statementBuilder.toString()];

        if (min > expr.min) {
          out.unshift('Math.max(', min, ', ');
          out.push(')');
        }

        if (max < expr.max) {
          out.unshift('Math.min(', max, ', ');
          out.push(')');
        }

        out.unshift('dest[destOffset + ', i, '] = ');
        out.push(';');
        result.push(out.join(''));
      });
      return result.join('\n');
    }
  };
  return PostScriptCompiler;
}();

exports.PostScriptCompiler = PostScriptCompiler;

/***/ }),
/* 186 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PostScriptParser = exports.PostScriptLexer = void 0;

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var PostScriptParser =
/*#__PURE__*/
function () {
  function PostScriptParser(lexer) {
    _classCallCheck(this, PostScriptParser);

    this.lexer = lexer;
    this.operators = [];
    this.token = null;
    this.prev = null;
  }

  _createClass(PostScriptParser, [{
    key: "nextToken",
    value: function nextToken() {
      this.prev = this.token;
      this.token = this.lexer.getToken();
    }
  }, {
    key: "accept",
    value: function accept(type) {
      if (this.token.type === type) {
        this.nextToken();
        return true;
      }

      return false;
    }
  }, {
    key: "expect",
    value: function expect(type) {
      if (this.accept(type)) {
        return true;
      }

      throw new _util.FormatError("Unexpected symbol: found ".concat(this.token.type, " expected ").concat(type, "."));
    }
  }, {
    key: "parse",
    value: function parse() {
      this.nextToken();
      this.expect(PostScriptTokenTypes.LBRACE);
      this.parseBlock();
      this.expect(PostScriptTokenTypes.RBRACE);
      return this.operators;
    }
  }, {
    key: "parseBlock",
    value: function parseBlock() {
      while (true) {
        if (this.accept(PostScriptTokenTypes.NUMBER)) {
          this.operators.push(this.prev.value);
        } else if (this.accept(PostScriptTokenTypes.OPERATOR)) {
          this.operators.push(this.prev.value);
        } else if (this.accept(PostScriptTokenTypes.LBRACE)) {
          this.parseCondition();
        } else {
          return;
        }
      }
    }
  }, {
    key: "parseCondition",
    value: function parseCondition() {
      var conditionLocation = this.operators.length;
      this.operators.push(null, null);
      this.parseBlock();
      this.expect(PostScriptTokenTypes.RBRACE);

      if (this.accept(PostScriptTokenTypes.IF)) {
        this.operators[conditionLocation] = this.operators.length;
        this.operators[conditionLocation + 1] = 'jz';
      } else if (this.accept(PostScriptTokenTypes.LBRACE)) {
        var jumpLocation = this.operators.length;
        this.operators.push(null, null);
        var endOfTrue = this.operators.length;
        this.parseBlock();
        this.expect(PostScriptTokenTypes.RBRACE);
        this.expect(PostScriptTokenTypes.IFELSE);
        this.operators[jumpLocation] = this.operators.length;
        this.operators[jumpLocation + 1] = 'j';
        this.operators[conditionLocation] = endOfTrue;
        this.operators[conditionLocation + 1] = 'jz';
      } else {
        throw new _util.FormatError('PS Function: error parsing conditional.');
      }
    }
  }]);

  return PostScriptParser;
}();

exports.PostScriptParser = PostScriptParser;
var PostScriptTokenTypes = {
  LBRACE: 0,
  RBRACE: 1,
  NUMBER: 2,
  OPERATOR: 3,
  IF: 4,
  IFELSE: 5
};

var PostScriptToken = function PostScriptTokenClosure() {
  var opCache = Object.create(null);

  var PostScriptToken =
  /*#__PURE__*/
  function () {
    function PostScriptToken(type, value) {
      _classCallCheck(this, PostScriptToken);

      this.type = type;
      this.value = value;
    }

    _createClass(PostScriptToken, null, [{
      key: "getOperator",
      value: function getOperator(op) {
        var opValue = opCache[op];

        if (opValue) {
          return opValue;
        }

        return opCache[op] = new PostScriptToken(PostScriptTokenTypes.OPERATOR, op);
      }
    }, {
      key: "LBRACE",
      get: function get() {
        return (0, _util.shadow)(this, 'LBRACE', new PostScriptToken(PostScriptTokenTypes.LBRACE, '{'));
      }
    }, {
      key: "RBRACE",
      get: function get() {
        return (0, _util.shadow)(this, 'RBRACE', new PostScriptToken(PostScriptTokenTypes.RBRACE, '}'));
      }
    }, {
      key: "IF",
      get: function get() {
        return (0, _util.shadow)(this, 'IF', new PostScriptToken(PostScriptTokenTypes.IF, 'IF'));
      }
    }, {
      key: "IFELSE",
      get: function get() {
        return (0, _util.shadow)(this, 'IFELSE', new PostScriptToken(PostScriptTokenTypes.IFELSE, 'IFELSE'));
      }
    }]);

    return PostScriptToken;
  }();

  return PostScriptToken;
}();

var PostScriptLexer =
/*#__PURE__*/
function () {
  function PostScriptLexer(stream) {
    _classCallCheck(this, PostScriptLexer);

    this.stream = stream;
    this.nextChar();
    this.strBuf = [];
  }

  _createClass(PostScriptLexer, [{
    key: "nextChar",
    value: function nextChar() {
      return this.currentChar = this.stream.getByte();
    }
  }, {
    key: "getToken",
    value: function getToken() {
      var comment = false;
      var ch = this.currentChar;

      while (true) {
        if (ch < 0) {
          return _primitives.EOF;
        }

        if (comment) {
          if (ch === 0x0A || ch === 0x0D) {
            comment = false;
          }
        } else if (ch === 0x25) {
          comment = true;
        } else if (!(0, _util.isSpace)(ch)) {
          break;
        }

        ch = this.nextChar();
      }

      switch (ch | 0) {
        case 0x30:
        case 0x31:
        case 0x32:
        case 0x33:
        case 0x34:
        case 0x35:
        case 0x36:
        case 0x37:
        case 0x38:
        case 0x39:
        case 0x2B:
        case 0x2D:
        case 0x2E:
          return new PostScriptToken(PostScriptTokenTypes.NUMBER, this.getNumber());

        case 0x7B:
          this.nextChar();
          return PostScriptToken.LBRACE;

        case 0x7D:
          this.nextChar();
          return PostScriptToken.RBRACE;
      }

      var strBuf = this.strBuf;
      strBuf.length = 0;
      strBuf[0] = String.fromCharCode(ch);

      while ((ch = this.nextChar()) >= 0 && (ch >= 0x41 && ch <= 0x5A || ch >= 0x61 && ch <= 0x7A)) {
        strBuf.push(String.fromCharCode(ch));
      }

      var str = strBuf.join('');

      switch (str.toLowerCase()) {
        case 'if':
          return PostScriptToken.IF;

        case 'ifelse':
          return PostScriptToken.IFELSE;

        default:
          return PostScriptToken.getOperator(str);
      }
    }
  }, {
    key: "getNumber",
    value: function getNumber() {
      var ch = this.currentChar;
      var strBuf = this.strBuf;
      strBuf.length = 0;
      strBuf[0] = String.fromCharCode(ch);

      while ((ch = this.nextChar()) >= 0) {
        if (ch >= 0x30 && ch <= 0x39 || ch === 0x2D || ch === 0x2E) {
          strBuf.push(String.fromCharCode(ch));
        } else {
          break;
        }
      }

      var value = parseFloat(strBuf.join(''));

      if (isNaN(value)) {
        throw new _util.FormatError("Invalid floating point number: ".concat(value));
      }

      return value;
    }
  }]);

  return PostScriptLexer;
}();

exports.PostScriptLexer = PostScriptLexer;

/***/ }),
/* 187 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MurmurHash3_64 = void 0;

var _util = __w_pdfjs_require__(6);

var MurmurHash3_64 = function MurmurHash3_64Closure(seed) {
  var MASK_HIGH = 0xffff0000;
  var MASK_LOW = 0xffff;

  function MurmurHash3_64(seed) {
    var SEED = 0xc3d2e1f0;
    this.h1 = seed ? seed & 0xffffffff : SEED;
    this.h2 = seed ? seed & 0xffffffff : SEED;
  }

  MurmurHash3_64.prototype = {
    update: function MurmurHash3_64_update(input) {
      var data, length;

      if ((0, _util.isString)(input)) {
        data = new Uint8Array(input.length * 2);
        length = 0;

        for (var i = 0, ii = input.length; i < ii; i++) {
          var code = input.charCodeAt(i);

          if (code <= 0xff) {
            data[length++] = code;
          } else {
            data[length++] = code >>> 8;
            data[length++] = code & 0xff;
          }
        }
      } else if ((0, _util.isArrayBuffer)(input)) {
        data = input;
        length = data.byteLength;
      } else {
        throw new Error('Wrong data format in MurmurHash3_64_update. ' + 'Input must be a string or array.');
      }

      var blockCounts = length >> 2;
      var tailLength = length - blockCounts * 4;
      var dataUint32 = new Uint32Array(data.buffer, 0, blockCounts);
      var k1 = 0;
      var k2 = 0;
      var h1 = this.h1;
      var h2 = this.h2;
      var C1 = 0xcc9e2d51;
      var C2 = 0x1b873593;
      var C1_LOW = C1 & MASK_LOW;
      var C2_LOW = C2 & MASK_LOW;

      for (var _i = 0; _i < blockCounts; _i++) {
        if (_i & 1) {
          k1 = dataUint32[_i];
          k1 = k1 * C1 & MASK_HIGH | k1 * C1_LOW & MASK_LOW;
          k1 = k1 << 15 | k1 >>> 17;
          k1 = k1 * C2 & MASK_HIGH | k1 * C2_LOW & MASK_LOW;
          h1 ^= k1;
          h1 = h1 << 13 | h1 >>> 19;
          h1 = h1 * 5 + 0xe6546b64;
        } else {
          k2 = dataUint32[_i];
          k2 = k2 * C1 & MASK_HIGH | k2 * C1_LOW & MASK_LOW;
          k2 = k2 << 15 | k2 >>> 17;
          k2 = k2 * C2 & MASK_HIGH | k2 * C2_LOW & MASK_LOW;
          h2 ^= k2;
          h2 = h2 << 13 | h2 >>> 19;
          h2 = h2 * 5 + 0xe6546b64;
        }
      }

      k1 = 0;

      switch (tailLength) {
        case 3:
          k1 ^= data[blockCounts * 4 + 2] << 16;

        case 2:
          k1 ^= data[blockCounts * 4 + 1] << 8;

        case 1:
          k1 ^= data[blockCounts * 4];
          k1 = k1 * C1 & MASK_HIGH | k1 * C1_LOW & MASK_LOW;
          k1 = k1 << 15 | k1 >>> 17;
          k1 = k1 * C2 & MASK_HIGH | k1 * C2_LOW & MASK_LOW;

          if (blockCounts & 1) {
            h1 ^= k1;
          } else {
            h2 ^= k1;
          }

      }

      this.h1 = h1;
      this.h2 = h2;
      return this;
    },
    hexdigest: function MurmurHash3_64_hexdigest() {
      var h1 = this.h1;
      var h2 = this.h2;
      h1 ^= h2 >>> 1;
      h1 = h1 * 0xed558ccd & MASK_HIGH | h1 * 0x8ccd & MASK_LOW;
      h2 = h2 * 0xff51afd7 & MASK_HIGH | ((h2 << 16 | h1 >>> 16) * 0xafd7ed55 & MASK_HIGH) >>> 16;
      h1 ^= h2 >>> 1;
      h1 = h1 * 0x1a85ec53 & MASK_HIGH | h1 * 0xec53 & MASK_LOW;
      h2 = h2 * 0xc4ceb9fe & MASK_HIGH | ((h2 << 16 | h1 >>> 16) * 0xb9fe1a85 & MASK_HIGH) >>> 16;
      h1 ^= h2 >>> 1;

      for (var i = 0, arr = [h1, h2], str = ''; i < arr.length; i++) {
        var hex = (arr[i] >>> 0).toString(16);

        while (hex.length < 8) {
          hex = '0' + hex;
        }

        str += hex;
      }

      return str;
    }
  };
  return MurmurHash3_64;
}();

exports.MurmurHash3_64 = MurmurHash3_64;

/***/ }),
/* 188 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFImage = void 0;

var _util = __w_pdfjs_require__(6);

var _primitives = __w_pdfjs_require__(155);

var _colorspace = __w_pdfjs_require__(168);

var _stream = __w_pdfjs_require__(157);

var _jpeg_stream = __w_pdfjs_require__(163);

var _jpx = __w_pdfjs_require__(166);

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var PDFImage = function PDFImageClosure() {
  function handleImageData(image, nativeDecoder) {
    if (nativeDecoder && nativeDecoder.canDecode(image)) {
      return nativeDecoder.decode(image).catch(function (reason) {
        (0, _util.warn)('Native image decoding failed -- trying to recover: ' + (reason && reason.message));
        return image;
      });
    }

    return Promise.resolve(image);
  }

  function decodeAndClamp(value, addend, coefficient, max) {
    value = addend + value * coefficient;
    return value < 0 ? 0 : value > max ? max : value;
  }

  function resizeImageMask(src, bpc, w1, h1, w2, h2) {
    var length = w2 * h2;
    var dest = bpc <= 8 ? new Uint8Array(length) : bpc <= 16 ? new Uint16Array(length) : new Uint32Array(length);
    var xRatio = w1 / w2;
    var yRatio = h1 / h2;
    var i,
        j,
        py,
        newIndex = 0,
        oldIndex;
    var xScaled = new Uint16Array(w2);
    var w1Scanline = w1;

    for (i = 0; i < w2; i++) {
      xScaled[i] = Math.floor(i * xRatio);
    }

    for (i = 0; i < h2; i++) {
      py = Math.floor(i * yRatio) * w1Scanline;

      for (j = 0; j < w2; j++) {
        oldIndex = py + xScaled[j];
        dest[newIndex++] = src[oldIndex];
      }
    }

    return dest;
  }

  function PDFImage(_ref) {
    var xref = _ref.xref,
        res = _ref.res,
        image = _ref.image,
        _ref$isInline = _ref.isInline,
        isInline = _ref$isInline === void 0 ? false : _ref$isInline,
        _ref$smask = _ref.smask,
        smask = _ref$smask === void 0 ? null : _ref$smask,
        _ref$mask = _ref.mask,
        mask = _ref$mask === void 0 ? null : _ref$mask,
        _ref$isMask = _ref.isMask,
        isMask = _ref$isMask === void 0 ? false : _ref$isMask,
        pdfFunctionFactory = _ref.pdfFunctionFactory;
    this.image = image;
    var dict = image.dict;
    var filter = dict.get('Filter');

    if ((0, _primitives.isName)(filter)) {
      switch (filter.name) {
        case 'JPXDecode':
          var jpxImage = new _jpx.JpxImage();
          jpxImage.parseImageProperties(image.stream);
          image.stream.reset();
          image.width = jpxImage.width;
          image.height = jpxImage.height;
          image.bitsPerComponent = jpxImage.bitsPerComponent;
          image.numComps = jpxImage.componentsCount;
          break;

        case 'JBIG2Decode':
          image.bitsPerComponent = 1;
          image.numComps = 1;
          break;
      }
    }

    var width = dict.get('Width', 'W');
    var height = dict.get('Height', 'H');

    if (Number.isInteger(image.width) && image.width > 0 && Number.isInteger(image.height) && image.height > 0 && (image.width !== width || image.height !== height)) {
      (0, _util.warn)('PDFImage - using the Width/Height of the image data, ' + 'rather than the image dictionary.');
      width = image.width;
      height = image.height;
    }

    if (width < 1 || height < 1) {
      throw new _util.FormatError("Invalid image width: ".concat(width, " or ") + "height: ".concat(height));
    }

    this.width = width;
    this.height = height;
    this.interpolate = dict.get('Interpolate', 'I') || false;
    this.imageMask = dict.get('ImageMask', 'IM') || false;
    this.matte = dict.get('Matte') || false;
    var bitsPerComponent = image.bitsPerComponent;

    if (!bitsPerComponent) {
      bitsPerComponent = dict.get('BitsPerComponent', 'BPC');

      if (!bitsPerComponent) {
        if (this.imageMask) {
          bitsPerComponent = 1;
        } else {
          throw new _util.FormatError("Bits per component missing in image: ".concat(this.imageMask));
        }
      }
    }

    this.bpc = bitsPerComponent;

    if (!this.imageMask) {
      var colorSpace = dict.get('ColorSpace', 'CS');

      if (!colorSpace) {
        (0, _util.info)('JPX images (which do not require color spaces)');

        switch (image.numComps) {
          case 1:
            colorSpace = _primitives.Name.get('DeviceGray');
            break;

          case 3:
            colorSpace = _primitives.Name.get('DeviceRGB');
            break;

          case 4:
            colorSpace = _primitives.Name.get('DeviceCMYK');
            break;

          default:
            throw new Error("JPX images with ".concat(image.numComps, " ") + 'color components not supported.');
        }
      }

      var resources = isInline ? res : null;
      this.colorSpace = _colorspace.ColorSpace.parse(colorSpace, xref, resources, pdfFunctionFactory);
      this.numComps = this.colorSpace.numComps;
    }

    this.decode = dict.getArray('Decode', 'D');
    this.needsDecode = false;

    if (this.decode && (this.colorSpace && !this.colorSpace.isDefaultDecode(this.decode, bitsPerComponent) || isMask && !_colorspace.ColorSpace.isDefaultDecode(this.decode, 1))) {
      this.needsDecode = true;
      var max = (1 << bitsPerComponent) - 1;
      this.decodeCoefficients = [];
      this.decodeAddends = [];
      var isIndexed = this.colorSpace && this.colorSpace.name === 'Indexed';

      for (var i = 0, j = 0; i < this.decode.length; i += 2, ++j) {
        var dmin = this.decode[i];
        var dmax = this.decode[i + 1];
        this.decodeCoefficients[j] = isIndexed ? (dmax - dmin) / max : dmax - dmin;
        this.decodeAddends[j] = isIndexed ? dmin : max * dmin;
      }
    }

    if (smask) {
      this.smask = new PDFImage({
        xref: xref,
        res: res,
        image: smask,
        isInline: isInline,
        pdfFunctionFactory: pdfFunctionFactory
      });
    } else if (mask) {
      if ((0, _primitives.isStream)(mask)) {
        var maskDict = mask.dict,
            imageMask = maskDict.get('ImageMask', 'IM');

        if (!imageMask) {
          (0, _util.warn)('Ignoring /Mask in image without /ImageMask.');
        } else {
          this.mask = new PDFImage({
            xref: xref,
            res: res,
            image: mask,
            isInline: isInline,
            isMask: true,
            pdfFunctionFactory: pdfFunctionFactory
          });
        }
      } else {
        this.mask = mask;
      }
    }
  }

  PDFImage.buildImage = function (_ref2) {
    var handler = _ref2.handler,
        xref = _ref2.xref,
        res = _ref2.res,
        image = _ref2.image,
        _ref2$isInline = _ref2.isInline,
        isInline = _ref2$isInline === void 0 ? false : _ref2$isInline,
        _ref2$nativeDecoder = _ref2.nativeDecoder,
        nativeDecoder = _ref2$nativeDecoder === void 0 ? null : _ref2$nativeDecoder,
        pdfFunctionFactory = _ref2.pdfFunctionFactory;
    var imagePromise = handleImageData(image, nativeDecoder);
    var smaskPromise;
    var maskPromise;
    var smask = image.dict.get('SMask');
    var mask = image.dict.get('Mask');

    if (smask) {
      smaskPromise = handleImageData(smask, nativeDecoder);
      maskPromise = Promise.resolve(null);
    } else {
      smaskPromise = Promise.resolve(null);

      if (mask) {
        if ((0, _primitives.isStream)(mask)) {
          maskPromise = handleImageData(mask, nativeDecoder);
        } else if (Array.isArray(mask)) {
          maskPromise = Promise.resolve(mask);
        } else {
          (0, _util.warn)('Unsupported mask format.');
          maskPromise = Promise.resolve(null);
        }
      } else {
        maskPromise = Promise.resolve(null);
      }
    }

    return Promise.all([imagePromise, smaskPromise, maskPromise]).then(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 3),
          imageData = _ref4[0],
          smaskData = _ref4[1],
          maskData = _ref4[2];

      return new PDFImage({
        xref: xref,
        res: res,
        image: imageData,
        isInline: isInline,
        smask: smaskData,
        mask: maskData,
        pdfFunctionFactory: pdfFunctionFactory
      });
    });
  };

  PDFImage.createMask = function (_ref5) {
    var imgArray = _ref5.imgArray,
        width = _ref5.width,
        height = _ref5.height,
        imageIsFromDecodeStream = _ref5.imageIsFromDecodeStream,
        inverseDecode = _ref5.inverseDecode;
    var computedLength = (width + 7 >> 3) * height;
    var actualLength = imgArray.byteLength;
    var haveFullData = computedLength === actualLength;
    var data, i;

    if (imageIsFromDecodeStream && (!inverseDecode || haveFullData)) {
      data = imgArray;
    } else if (!inverseDecode) {
      data = new Uint8ClampedArray(actualLength);
      data.set(imgArray);
    } else {
      data = new Uint8ClampedArray(computedLength);
      data.set(imgArray);

      for (i = actualLength; i < computedLength; i++) {
        data[i] = 0xff;
      }
    }

    if (inverseDecode) {
      for (i = 0; i < actualLength; i++) {
        data[i] ^= 0xFF;
      }
    }

    return {
      data: data,
      width: width,
      height: height
    };
  };

  PDFImage.prototype = {
    get drawWidth() {
      return Math.max(this.width, this.smask && this.smask.width || 0, this.mask && this.mask.width || 0);
    },

    get drawHeight() {
      return Math.max(this.height, this.smask && this.smask.height || 0, this.mask && this.mask.height || 0);
    },

    decodeBuffer: function decodeBuffer(buffer) {
      var bpc = this.bpc;
      var numComps = this.numComps;
      var decodeAddends = this.decodeAddends;
      var decodeCoefficients = this.decodeCoefficients;
      var max = (1 << bpc) - 1;
      var i, ii;

      if (bpc === 1) {
        for (i = 0, ii = buffer.length; i < ii; i++) {
          buffer[i] = +!buffer[i];
        }

        return;
      }

      var index = 0;

      for (i = 0, ii = this.width * this.height; i < ii; i++) {
        for (var j = 0; j < numComps; j++) {
          buffer[index] = decodeAndClamp(buffer[index], decodeAddends[j], decodeCoefficients[j], max);
          index++;
        }
      }
    },
    getComponents: function getComponents(buffer) {
      var bpc = this.bpc;

      if (bpc === 8) {
        return buffer;
      }

      var width = this.width;
      var height = this.height;
      var numComps = this.numComps;
      var length = width * height * numComps;
      var bufferPos = 0;
      var output = bpc <= 8 ? new Uint8Array(length) : bpc <= 16 ? new Uint16Array(length) : new Uint32Array(length);
      var rowComps = width * numComps;
      var max = (1 << bpc) - 1;
      var i = 0,
          ii,
          buf;

      if (bpc === 1) {
        var mask, loop1End, loop2End;

        for (var j = 0; j < height; j++) {
          loop1End = i + (rowComps & ~7);
          loop2End = i + rowComps;

          while (i < loop1End) {
            buf = buffer[bufferPos++];
            output[i] = buf >> 7 & 1;
            output[i + 1] = buf >> 6 & 1;
            output[i + 2] = buf >> 5 & 1;
            output[i + 3] = buf >> 4 & 1;
            output[i + 4] = buf >> 3 & 1;
            output[i + 5] = buf >> 2 & 1;
            output[i + 6] = buf >> 1 & 1;
            output[i + 7] = buf & 1;
            i += 8;
          }

          if (i < loop2End) {
            buf = buffer[bufferPos++];
            mask = 128;

            while (i < loop2End) {
              output[i++] = +!!(buf & mask);
              mask >>= 1;
            }
          }
        }
      } else {
        var bits = 0;
        buf = 0;

        for (i = 0, ii = length; i < ii; ++i) {
          if (i % rowComps === 0) {
            buf = 0;
            bits = 0;
          }

          while (bits < bpc) {
            buf = buf << 8 | buffer[bufferPos++];
            bits += 8;
          }

          var remainingBits = bits - bpc;
          var value = buf >> remainingBits;
          output[i] = value < 0 ? 0 : value > max ? max : value;
          buf = buf & (1 << remainingBits) - 1;
          bits = remainingBits;
        }
      }

      return output;
    },
    fillOpacity: function fillOpacity(rgbaBuf, width, height, actualHeight, image) {
      var smask = this.smask;
      var mask = this.mask;
      var alphaBuf, sw, sh, i, ii, j;

      if (smask) {
        sw = smask.width;
        sh = smask.height;
        alphaBuf = new Uint8ClampedArray(sw * sh);
        smask.fillGrayBuffer(alphaBuf);

        if (sw !== width || sh !== height) {
          alphaBuf = resizeImageMask(alphaBuf, smask.bpc, sw, sh, width, height);
        }
      } else if (mask) {
        if (mask instanceof PDFImage) {
          sw = mask.width;
          sh = mask.height;
          alphaBuf = new Uint8ClampedArray(sw * sh);
          mask.numComps = 1;
          mask.fillGrayBuffer(alphaBuf);

          for (i = 0, ii = sw * sh; i < ii; ++i) {
            alphaBuf[i] = 255 - alphaBuf[i];
          }

          if (sw !== width || sh !== height) {
            alphaBuf = resizeImageMask(alphaBuf, mask.bpc, sw, sh, width, height);
          }
        } else if (Array.isArray(mask)) {
          alphaBuf = new Uint8ClampedArray(width * height);
          var numComps = this.numComps;

          for (i = 0, ii = width * height; i < ii; ++i) {
            var opacity = 0;
            var imageOffset = i * numComps;

            for (j = 0; j < numComps; ++j) {
              var color = image[imageOffset + j];
              var maskOffset = j * 2;

              if (color < mask[maskOffset] || color > mask[maskOffset + 1]) {
                opacity = 255;
                break;
              }
            }

            alphaBuf[i] = opacity;
          }
        } else {
          throw new _util.FormatError('Unknown mask format.');
        }
      }

      if (alphaBuf) {
        for (i = 0, j = 3, ii = width * actualHeight; i < ii; ++i, j += 4) {
          rgbaBuf[j] = alphaBuf[i];
        }
      } else {
        for (i = 0, j = 3, ii = width * actualHeight; i < ii; ++i, j += 4) {
          rgbaBuf[j] = 255;
        }
      }
    },
    undoPreblend: function undoPreblend(buffer, width, height) {
      var matte = this.smask && this.smask.matte;

      if (!matte) {
        return;
      }

      var matteRgb = this.colorSpace.getRgb(matte, 0);
      var matteR = matteRgb[0];
      var matteG = matteRgb[1];
      var matteB = matteRgb[2];
      var length = width * height * 4;

      for (var i = 0; i < length; i += 4) {
        var alpha = buffer[i + 3];

        if (alpha === 0) {
          buffer[i] = 255;
          buffer[i + 1] = 255;
          buffer[i + 2] = 255;
          continue;
        }

        var k = 255 / alpha;
        buffer[i] = (buffer[i] - matteR) * k + matteR;
        buffer[i + 1] = (buffer[i + 1] - matteG) * k + matteG;
        buffer[i + 2] = (buffer[i + 2] - matteB) * k + matteB;
      }
    },
    createImageData: function createImageData() {
      var forceRGBA = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var drawWidth = this.drawWidth;
      var drawHeight = this.drawHeight;
      var imgData = {
        width: drawWidth,
        height: drawHeight,
        kind: 0,
        data: null
      };
      var numComps = this.numComps;
      var originalWidth = this.width;
      var originalHeight = this.height;
      var bpc = this.bpc;
      var rowBytes = originalWidth * numComps * bpc + 7 >> 3;
      var imgArray;

      if (!forceRGBA) {
        var kind;

        if (this.colorSpace.name === 'DeviceGray' && bpc === 1) {
          kind = _util.ImageKind.GRAYSCALE_1BPP;
        } else if (this.colorSpace.name === 'DeviceRGB' && bpc === 8 && !this.needsDecode) {
          kind = _util.ImageKind.RGB_24BPP;
        }

        if (kind && !this.smask && !this.mask && drawWidth === originalWidth && drawHeight === originalHeight) {
          imgData.kind = kind;
          imgArray = this.getImageBytes(originalHeight * rowBytes);

          if (this.image instanceof _stream.DecodeStream) {
            imgData.data = imgArray;
          } else {
            var newArray = new Uint8ClampedArray(imgArray.length);
            newArray.set(imgArray);
            imgData.data = newArray;
          }

          if (this.needsDecode) {
            (0, _util.assert)(kind === _util.ImageKind.GRAYSCALE_1BPP, 'PDFImage.createImageData: The image must be grayscale.');
            var buffer = imgData.data;

            for (var i = 0, ii = buffer.length; i < ii; i++) {
              buffer[i] ^= 0xff;
            }
          }

          return imgData;
        }

        if (this.image instanceof _jpeg_stream.JpegStream && !this.smask && !this.mask) {
          var imageLength = originalHeight * rowBytes;

          switch (this.colorSpace.name) {
            case 'DeviceGray':
              imageLength *= 3;

            case 'DeviceRGB':
            case 'DeviceCMYK':
              imgData.kind = _util.ImageKind.RGB_24BPP;
              imgData.data = this.getImageBytes(imageLength, drawWidth, drawHeight, true);
              return imgData;
          }
        }
      }

      imgArray = this.getImageBytes(originalHeight * rowBytes);
      var actualHeight = 0 | imgArray.length / rowBytes * drawHeight / originalHeight;
      var comps = this.getComponents(imgArray);
      var alpha01, maybeUndoPreblend;

      if (!forceRGBA && !this.smask && !this.mask) {
        imgData.kind = _util.ImageKind.RGB_24BPP;
        imgData.data = new Uint8ClampedArray(drawWidth * drawHeight * 3);
        alpha01 = 0;
        maybeUndoPreblend = false;
      } else {
        imgData.kind = _util.ImageKind.RGBA_32BPP;
        imgData.data = new Uint8ClampedArray(drawWidth * drawHeight * 4);
        alpha01 = 1;
        maybeUndoPreblend = true;
        this.fillOpacity(imgData.data, drawWidth, drawHeight, actualHeight, comps);
      }

      if (this.needsDecode) {
        this.decodeBuffer(comps);
      }

      this.colorSpace.fillRgb(imgData.data, originalWidth, originalHeight, drawWidth, drawHeight, actualHeight, bpc, comps, alpha01);

      if (maybeUndoPreblend) {
        this.undoPreblend(imgData.data, drawWidth, actualHeight);
      }

      return imgData;
    },
    fillGrayBuffer: function fillGrayBuffer(buffer) {
      var numComps = this.numComps;

      if (numComps !== 1) {
        throw new _util.FormatError("Reading gray scale from a color image: ".concat(numComps));
      }

      var width = this.width;
      var height = this.height;
      var bpc = this.bpc;
      var rowBytes = width * numComps * bpc + 7 >> 3;
      var imgArray = this.getImageBytes(height * rowBytes);
      var comps = this.getComponents(imgArray);
      var i, length;

      if (bpc === 1) {
        length = width * height;

        if (this.needsDecode) {
          for (i = 0; i < length; ++i) {
            buffer[i] = comps[i] - 1 & 255;
          }
        } else {
          for (i = 0; i < length; ++i) {
            buffer[i] = -comps[i] & 255;
          }
        }

        return;
      }

      if (this.needsDecode) {
        this.decodeBuffer(comps);
      }

      length = width * height;
      var scale = 255 / ((1 << bpc) - 1);

      for (i = 0; i < length; ++i) {
        buffer[i] = scale * comps[i];
      }
    },
    getImageBytes: function getImageBytes(length, drawWidth, drawHeight) {
      var forceRGB = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      this.image.reset();
      this.image.drawWidth = drawWidth || this.width;
      this.image.drawHeight = drawHeight || this.height;
      this.image.forceRGB = !!forceRGB;
      return this.image.getBytes(length, true);
    }
  };
  return PDFImage;
}();

exports.PDFImage = PDFImage;

/***/ }),
/* 189 */
/***/ (function(module, exports, __w_pdfjs_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageHandler = MessageHandler;

var _regenerator = _interopRequireDefault(__w_pdfjs_require__(2));

var _util = __w_pdfjs_require__(6);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function resolveCall(_x, _x2) {
  return _resolveCall.apply(this, arguments);
}

function _resolveCall() {
  _resolveCall = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(fn, args) {
    var thisArg,
        _args = arguments;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            thisArg = _args.length > 2 && _args[2] !== undefined ? _args[2] : null;

            if (fn) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return");

          case 3:
            return _context.abrupt("return", fn.apply(thisArg, args));

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _resolveCall.apply(this, arguments);
}

function wrapReason(reason) {
  if (_typeof(reason) !== 'object') {
    return reason;
  }

  switch (reason.name) {
    case 'AbortException':
      return new _util.AbortException(reason.message);

    case 'MissingPDFException':
      return new _util.MissingPDFException(reason.message);

    case 'UnexpectedResponseException':
      return new _util.UnexpectedResponseException(reason.message, reason.status);

    default:
      return new _util.UnknownErrorException(reason.message, reason.details);
  }
}

function makeReasonSerializable(reason) {
  if (!(reason instanceof Error) || reason instanceof _util.AbortException || reason instanceof _util.MissingPDFException || reason instanceof _util.UnexpectedResponseException || reason instanceof _util.UnknownErrorException) {
    return reason;
  }

  return new _util.UnknownErrorException(reason.message, reason.toString());
}

function resolveOrReject(capability, success, reason) {
  if (success) {
    capability.resolve();
  } else {
    capability.reject(reason);
  }
}

function finalize(promise) {
  return Promise.resolve(promise).catch(function () {});
}

function MessageHandler(sourceName, targetName, comObj) {
  var _this = this;

  this.sourceName = sourceName;
  this.targetName = targetName;
  this.comObj = comObj;
  this.callbackId = 1;
  this.streamId = 1;
  this.postMessageTransfers = true;
  this.streamSinks = Object.create(null);
  this.streamControllers = Object.create(null);
  var callbacksCapabilities = this.callbacksCapabilities = Object.create(null);
  var ah = this.actionHandler = Object.create(null);

  this._onComObjOnMessage = function (event) {
    var data = event.data;

    if (data.targetName !== _this.sourceName) {
      return;
    }

    if (data.stream) {
      _this._processStreamMessage(data);
    } else if (data.isReply) {
      var callbackId = data.callbackId;

      if (data.callbackId in callbacksCapabilities) {
        var callback = callbacksCapabilities[callbackId];
        delete callbacksCapabilities[callbackId];

        if ('error' in data) {
          callback.reject(wrapReason(data.error));
        } else {
          callback.resolve(data.data);
        }
      } else {
        throw new Error("Cannot resolve callback ".concat(callbackId));
      }
    } else if (data.action in ah) {
      var action = ah[data.action];

      if (data.callbackId) {
        var _sourceName = _this.sourceName;
        var _targetName = data.sourceName;
        Promise.resolve().then(function () {
          return action[0].call(action[1], data.data);
        }).then(function (result) {
          comObj.postMessage({
            sourceName: _sourceName,
            targetName: _targetName,
            isReply: true,
            callbackId: data.callbackId,
            data: result
          });
        }, function (reason) {
          comObj.postMessage({
            sourceName: _sourceName,
            targetName: _targetName,
            isReply: true,
            callbackId: data.callbackId,
            error: makeReasonSerializable(reason)
          });
        });
      } else if (data.streamId) {
        _this._createStreamSink(data);
      } else {
        action[0].call(action[1], data.data);
      }
    } else {
      throw new Error("Unknown action from worker: ".concat(data.action));
    }
  };

  comObj.addEventListener('message', this._onComObjOnMessage);
}

MessageHandler.prototype = {
  on: function on(actionName, handler, scope) {
    var ah = this.actionHandler;

    if (ah[actionName]) {
      throw new Error("There is already an actionName called \"".concat(actionName, "\""));
    }

    ah[actionName] = [handler, scope];
  },
  send: function send(actionName, data, transfers) {
    var message = {
      sourceName: this.sourceName,
      targetName: this.targetName,
      action: actionName,
      data: data
    };
    this.postMessage(message, transfers);
  },
  sendWithPromise: function sendWithPromise(actionName, data, transfers) {
    var callbackId = this.callbackId++;
    var message = {
      sourceName: this.sourceName,
      targetName: this.targetName,
      action: actionName,
      data: data,
      callbackId: callbackId
    };
    var capability = (0, _util.createPromiseCapability)();
    this.callbacksCapabilities[callbackId] = capability;

    try {
      this.postMessage(message, transfers);
    } catch (e) {
      capability.reject(e);
    }

    return capability.promise;
  },
  sendWithStream: function sendWithStream(actionName, data, queueingStrategy, transfers) {
    var _this2 = this;

    var streamId = this.streamId++;
    var sourceName = this.sourceName;
    var targetName = this.targetName;
    return new _util.ReadableStream({
      start: function start(controller) {
        var startCapability = (0, _util.createPromiseCapability)();
        _this2.streamControllers[streamId] = {
          controller: controller,
          startCall: startCapability,
          isClosed: false
        };

        _this2.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          action: actionName,
          streamId: streamId,
          data: data,
          desiredSize: controller.desiredSize
        });

        return startCapability.promise;
      },
      pull: function pull(controller) {
        var pullCapability = (0, _util.createPromiseCapability)();
        _this2.streamControllers[streamId].pullCall = pullCapability;

        _this2.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: 'pull',
          streamId: streamId,
          desiredSize: controller.desiredSize
        });

        return pullCapability.promise;
      },
      cancel: function cancel(reason) {
        var cancelCapability = (0, _util.createPromiseCapability)();
        _this2.streamControllers[streamId].cancelCall = cancelCapability;
        _this2.streamControllers[streamId].isClosed = true;

        _this2.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: 'cancel',
          reason: reason,
          streamId: streamId
        });

        return cancelCapability.promise;
      }
    }, queueingStrategy);
  },
  _createStreamSink: function _createStreamSink(data) {
    var _this3 = this;

    var self = this;
    var action = this.actionHandler[data.action];
    var streamId = data.streamId;
    var desiredSize = data.desiredSize;
    var sourceName = this.sourceName;
    var targetName = data.sourceName;
    var capability = (0, _util.createPromiseCapability)();

    var sendStreamRequest = function sendStreamRequest(_ref) {
      var stream = _ref.stream,
          chunk = _ref.chunk,
          transfers = _ref.transfers,
          success = _ref.success,
          reason = _ref.reason;

      _this3.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        stream: stream,
        streamId: streamId,
        chunk: chunk,
        success: success,
        reason: reason
      }, transfers);
    };

    var streamSink = {
      enqueue: function enqueue(chunk) {
        var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
        var transfers = arguments.length > 2 ? arguments[2] : undefined;

        if (this.isCancelled) {
          return;
        }

        var lastDesiredSize = this.desiredSize;
        this.desiredSize -= size;

        if (lastDesiredSize > 0 && this.desiredSize <= 0) {
          this.sinkCapability = (0, _util.createPromiseCapability)();
          this.ready = this.sinkCapability.promise;
        }

        sendStreamRequest({
          stream: 'enqueue',
          chunk: chunk,
          transfers: transfers
        });
      },
      close: function close() {
        if (this.isCancelled) {
          return;
        }

        this.isCancelled = true;
        sendStreamRequest({
          stream: 'close'
        });
        delete self.streamSinks[streamId];
      },
      error: function error(reason) {
        if (this.isCancelled) {
          return;
        }

        this.isCancelled = true;
        sendStreamRequest({
          stream: 'error',
          reason: reason
        });
      },
      sinkCapability: capability,
      onPull: null,
      onCancel: null,
      isCancelled: false,
      desiredSize: desiredSize,
      ready: null
    };
    streamSink.sinkCapability.resolve();
    streamSink.ready = streamSink.sinkCapability.promise;
    this.streamSinks[streamId] = streamSink;
    resolveCall(action[0], [data.data, streamSink], action[1]).then(function () {
      sendStreamRequest({
        stream: 'start_complete',
        success: true
      });
    }, function (reason) {
      sendStreamRequest({
        stream: 'start_complete',
        success: false,
        reason: reason
      });
    });
  },
  _processStreamMessage: function _processStreamMessage(data) {
    var _this4 = this;

    var sourceName = this.sourceName;
    var targetName = data.sourceName;
    var streamId = data.streamId;

    var sendStreamResponse = function sendStreamResponse(_ref2) {
      var stream = _ref2.stream,
          success = _ref2.success,
          reason = _ref2.reason;

      _this4.comObj.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        stream: stream,
        success: success,
        streamId: streamId,
        reason: reason
      });
    };

    var deleteStreamController = function deleteStreamController() {
      Promise.all([_this4.streamControllers[data.streamId].startCall, _this4.streamControllers[data.streamId].pullCall, _this4.streamControllers[data.streamId].cancelCall].map(function (capability) {
        return capability && finalize(capability.promise);
      })).then(function () {
        delete _this4.streamControllers[data.streamId];
      });
    };

    switch (data.stream) {
      case 'start_complete':
        resolveOrReject(this.streamControllers[data.streamId].startCall, data.success, wrapReason(data.reason));
        break;

      case 'pull_complete':
        resolveOrReject(this.streamControllers[data.streamId].pullCall, data.success, wrapReason(data.reason));
        break;

      case 'pull':
        if (!this.streamSinks[data.streamId]) {
          sendStreamResponse({
            stream: 'pull_complete',
            success: true
          });
          break;
        }

        if (this.streamSinks[data.streamId].desiredSize <= 0 && data.desiredSize > 0) {
          this.streamSinks[data.streamId].sinkCapability.resolve();
        }

        this.streamSinks[data.streamId].desiredSize = data.desiredSize;
        resolveCall(this.streamSinks[data.streamId].onPull).then(function () {
          sendStreamResponse({
            stream: 'pull_complete',
            success: true
          });
        }, function (reason) {
          sendStreamResponse({
            stream: 'pull_complete',
            success: false,
            reason: reason
          });
        });
        break;

      case 'enqueue':
        (0, _util.assert)(this.streamControllers[data.streamId], 'enqueue should have stream controller');

        if (!this.streamControllers[data.streamId].isClosed) {
          this.streamControllers[data.streamId].controller.enqueue(data.chunk);
        }

        break;

      case 'close':
        (0, _util.assert)(this.streamControllers[data.streamId], 'close should have stream controller');

        if (this.streamControllers[data.streamId].isClosed) {
          break;
        }

        this.streamControllers[data.streamId].isClosed = true;
        this.streamControllers[data.streamId].controller.close();
        deleteStreamController();
        break;

      case 'error':
        (0, _util.assert)(this.streamControllers[data.streamId], 'error should have stream controller');
        this.streamControllers[data.streamId].controller.error(wrapReason(data.reason));
        deleteStreamController();
        break;

      case 'cancel_complete':
        resolveOrReject(this.streamControllers[data.streamId].cancelCall, data.success, wrapReason(data.reason));
        deleteStreamController();
        break;

      case 'cancel':
        if (!this.streamSinks[data.streamId]) {
          break;
        }

        resolveCall(this.streamSinks[data.streamId].onCancel, [wrapReason(data.reason)]).then(function () {
          sendStreamResponse({
            stream: 'cancel_complete',
            success: true
          });
        }, function (reason) {
          sendStreamResponse({
            stream: 'cancel_complete',
            success: false,
            reason: reason
          });
        });
        this.streamSinks[data.streamId].sinkCapability.reject(wrapReason(data.reason));
        this.streamSinks[data.streamId].isCancelled = true;
        delete this.streamSinks[data.streamId];
        break;

      default:
        throw new Error('Unexpected stream case');
    }
  },
  postMessage: function postMessage(message, transfers) {
    if (transfers && this.postMessageTransfers) {
      this.comObj.postMessage(message, transfers);
    } else {
      this.comObj.postMessage(message);
    }
  },
  destroy: function destroy() {
    this.comObj.removeEventListener('message', this._onComObjOnMessage);
  }
};

/***/ })
/******/ ]);
});
//# sourceMappingURL=pdf.worker.js.map
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(139).Buffer, __webpack_require__(103), __webpack_require__(306)))

/***/ }),
/* 762 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCommentsCommentsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_comments__ = __webpack_require__(134);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays the count of comments.
 */
var CoreCommentsCommentsComponent = /** @class */ (function () {
    function CoreCommentsCommentsComponent(navCtrl, commentsProvider, sitesProvider, eventsProvider) {
        var _this = this;
        this.navCtrl = navCtrl;
        this.commentsProvider = commentsProvider;
        this.area = '';
        this.page = 0;
        this.displaySpinner = true; // Whether to display the loading spinner.
        this.commentsLoaded = false;
        this.disabled = false;
        this.onLoading = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.disabled = this.commentsProvider.areCommentsDisabledInSite();
        // Update visibility if current site info is updated.
        this.updateSiteObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function () {
            var wasDisabled = _this.disabled;
            _this.disabled = _this.commentsProvider.areCommentsDisabledInSite();
            if (wasDisabled && !_this.disabled) {
                _this.fetchData();
            }
        }, sitesProvider.getCurrentSiteId());
    }
    /**
     * View loaded.
     */
    CoreCommentsCommentsComponent.prototype.ngOnInit = function () {
        this.fetchData();
    };
    /**
     * Listen to changes.
     */
    CoreCommentsCommentsComponent.prototype.ngOnChanges = function (changes) {
        // If something change, update the fields.
        if (changes) {
            this.fetchData();
        }
    };
    CoreCommentsCommentsComponent.prototype.fetchData = function () {
        var _this = this;
        if (this.disabled) {
            return;
        }
        this.commentsLoaded = false;
        this.onLoading.emit(true);
        this.commentsProvider.getComments(this.contextLevel, this.instanceId, this.component, this.itemId, this.area, this.page)
            .then(function (comments) {
            _this.commentsCount = comments && comments.length ? comments.length : 0;
        }).catch(function () {
            _this.commentsCount = -1;
        }).finally(function () {
            _this.commentsLoaded = true;
            _this.onLoading.emit(false);
        });
    };
    /**
     * Opens the comments page.
     */
    CoreCommentsCommentsComponent.prototype.openComments = function () {
        if (!this.disabled && this.commentsCount > 0) {
            // Open a new state with the interpolated contents.
            this.navCtrl.push('CoreCommentsViewerPage', {
                contextLevel: this.contextLevel,
                instanceId: this.instanceId,
                component: this.component,
                itemId: this.itemId,
                area: this.area,
                page: this.page,
                title: this.title,
            });
        }
    };
    /**
     * Component destroyed.
     */
    CoreCommentsCommentsComponent.prototype.ngOnDestroy = function () {
        this.updateSiteObserver && this.updateSiteObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCommentsCommentsComponent.prototype, "contextLevel", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCommentsCommentsComponent.prototype, "instanceId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCommentsCommentsComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCommentsCommentsComponent.prototype, "itemId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCommentsCommentsComponent.prototype, "area", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCommentsCommentsComponent.prototype, "page", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCommentsCommentsComponent.prototype, "title", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCommentsCommentsComponent.prototype, "displaySpinner", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCommentsCommentsComponent.prototype, "onLoading", void 0);
    CoreCommentsCommentsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-comments',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\comments\components\comments\core-comments.html"*/'<core-loading *ngIf="!disabled" [hideUntil]="commentsLoaded || !displaySpinner">\n    <div (click)="openComments()" *ngIf="commentsCount >= 0">\n        {{ \'core.commentscount\' | translate : {\'$a\': commentsCount} }}\n    </div>\n    <div *ngIf="commentsCount < 0">\n        {{ \'core.commentsnotworking\' | translate }}\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\comments\components\comments\core-comments.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_2__providers_comments__["a" /* CoreCommentsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreCommentsCommentsComponent);
    return CoreCommentsCommentsComponent;
}());

//# sourceMappingURL=comments.js.map

/***/ }),
/* 763 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogEntriesComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_blog__ = __webpack_require__(163);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_comments_providers_comments__ = __webpack_require__(134);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component that displays the blog entries.
 */
var AddonBlogEntriesComponent = /** @class */ (function () {
    function AddonBlogEntriesComponent(blogProvider, domUtils, userProvider, sitesProvider, commentsProvider) {
        this.blogProvider = blogProvider;
        this.domUtils = domUtils;
        this.userProvider = userProvider;
        this.commentsProvider = commentsProvider;
        this.filter = {};
        this.pageLoaded = 0;
        this.loaded = false;
        this.canLoadMore = false;
        this.loadMoreError = false;
        this.entries = [];
        this.showMyIssuesToggle = false;
        this.onlyMyEntries = false;
        this.component = __WEBPACK_IMPORTED_MODULE_5__providers_blog__["a" /* AddonBlogProvider */].COMPONENT;
        this.currentUserId = sitesProvider.getCurrentSiteUserId();
    }
    /**
     * Component being initialized.
     */
    AddonBlogEntriesComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.userId) {
            this.filter['userid'] = this.userId;
        }
        if (this.courseId) {
            this.filter['courseid'] = this.courseId;
        }
        if (this.cmId) {
            this.filter['cmid'] = this.cmId;
        }
        if (this.entryId) {
            this.filter['entryid'] = this.entryId;
        }
        if (this.groupId) {
            this.filter['groupid'] = this.groupId;
        }
        if (this.tagId) {
            this.filter['tagid'] = this.tagId;
        }
        this.commentsEnabled = !this.commentsProvider.areCommentsDisabledInSite();
        this.fetchEntries().then(function () {
            _this.blogProvider.logView(_this.filter).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Fetch blog entries.
     *
     * @param {boolean} [refresh] Empty events array first.
     * @return {Promise<any>}         Promise with the entries.
     */
    AddonBlogEntriesComponent.prototype.fetchEntries = function (refresh) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        this.loadMoreError = false;
        if (refresh) {
            this.pageLoaded = 0;
        }
        return this.blogProvider.getEntries(this.filter, this.pageLoaded).then(function (result) {
            var promises = result.entries.map(function (entry) {
                switch (entry.publishstate) {
                    case 'draft':
                        entry.publishTranslated = 'publishtonoone';
                        break;
                    case 'site':
                        entry.publishTranslated = 'publishtosite';
                        break;
                    case 'public':
                        entry.publishTranslated = 'publishtoworld';
                        break;
                    default:
                        entry.publishTranslated = 'privacy:unknown';
                        break;
                }
                return _this.userProvider.getProfile(entry.userid, entry.courseid, true).then(function (user) {
                    entry.user = user;
                }).catch(function () {
                    // Ignore errors.
                });
            });
            if (refresh) {
                _this.showMyIssuesToggle = false;
                _this.entries = result.entries;
            }
            else {
                _this.entries = _this.entries.concat(result.entries);
            }
            _this.canLoadMore = result.totalentries > _this.entries.length;
            _this.pageLoaded++;
            _this.showMyIssuesToggle = !_this.userId;
            return Promise.all(promises);
        }).catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'addon.blog.errorloadentries', true);
            _this.loadMoreError = true; // Set to prevent infinite calls with infinite-loading.
        }).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Function to load more entries.
     *
     * @param {any} [infiniteComplete] Infinite scroll complete function. Only used from core-infinite-loading.
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlogEntriesComponent.prototype.loadMore = function (infiniteComplete) {
        return this.fetchEntries().finally(function () {
            infiniteComplete && infiniteComplete();
        });
    };
    /**
     * Refresh blog entries on PTR.
     *
     * @param {any}     refresher  Refresher instance.
     */
    AddonBlogEntriesComponent.prototype.refresh = function (refresher) {
        var _this = this;
        this.blogProvider.invalidateEntries(this.filter).finally(function () {
            _this.fetchEntries(true).finally(function () {
                if (refresher) {
                    refresher.complete();
                }
            });
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlogEntriesComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlogEntriesComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlogEntriesComponent.prototype, "cmId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlogEntriesComponent.prototype, "entryId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlogEntriesComponent.prototype, "groupId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlogEntriesComponent.prototype, "tagId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */])
    ], AddonBlogEntriesComponent.prototype, "content", void 0);
    AddonBlogEntriesComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-blog-entries',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\blog\components\entries\addon-blog-entries.html"*/'<ion-content>\n    <ion-refresher [enabled]="loaded" (ionRefresh)="refresh($event)">\n        <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n    </ion-refresher>\n    <core-loading [hideUntil]="loaded" class="core-loading-center">\n        <div class="safe-padding-horizontal">\n            <ion-item *ngIf="showMyIssuesToggle">\n                <ion-label>{{ \'addon.blog.showonlyyourentries\' | translate }}</ion-label>\n                <ion-toggle [(ngModel)]="onlyMyEntries"></ion-toggle>\n            </ion-item>\n        </div>\n        <core-empty-box *ngIf="entries && entries.length == 0" icon="fa-newspaper-o" [message]="\'addon.blog.noentriesyet\' | translate"></core-empty-box>\n        <ng-container *ngFor="let entry of entries">\n            <ion-card *ngIf="!onlyMyEntries || entry.userid == currentUserId">\n                <ion-item text-wrap>\n                    <ion-avatar core-user-avatar [user]="entry.user" item-start [courseId]="entry.courseid"></ion-avatar>\n                    <h2>\n                        <core-format-text [text]="entry.subject"></core-format-text>\n                        <ion-note float-end padding-left text-end>\n                            {{ \'addon.blog.\' + entry.publishTranslated | translate}}\n                        </ion-note>\n                    </h2>\n                    <p>\n                        <ion-note float-end padding-left text-end>\n                            {{entry.created | coreDateDayOrTime}}\n                        </ion-note>\n                        {{entry.user && entry.user.fullname}}\n                    </p>\n                </ion-item>\n                <ion-card-content>\n                    <core-format-text [text]="entry.summary" [component]="this.component" [componentId]="entry.id"></core-format-text>\n                    <ion-item *ngIf="commentsEnabled">\n                        <core-comments [component]="this.component" [itemId]="entry.id" area="format_blog" [instanceId]="entry.userid" contextLevel="user"></core-comments>\n                    </ion-item>\n                    <core-file *ngFor="let file of entry.attachmentfiles" [file]="file" [component]="this.component" [componentId]="entry.id"></core-file>\n                    <a ion-item *ngIf="entry.uniquehash" [href]="entry.uniquehash" core-link>{{ \'addon.blog.linktooriginalentry\' | translate }}</a>\n                </ion-card-content>\n                <ion-row text-center>\n                    <ion-col *ngIf="entry.lastmodified > entry.created">\n                        <ion-note>\n                            <ion-icon name="time"></ion-icon> {{entry.lastmodified | coreTimeAgo}}\n                        </ion-note>\n                    </ion-col>\n                </ion-row>\n            </ion-card>\n        </ng-container>\n        <core-infinite-loading [enabled]="canLoadMore" (action)="loadMore($event)" [error]="loadMoreError"></core-infinite-loading>\n    </core-loading>\n</ion-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\blog\components\entries\addon-blog-entries.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_blog__["a" /* AddonBlogProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_comments_providers_comments__["a" /* CoreCommentsProvider */]])
    ], AddonBlogEntriesComponent);
    return AddonBlogEntriesComponent;
}());

//# sourceMappingURL=entries.js.map

/***/ }),
/* 764 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyCourseComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_competency__ = __webpack_require__(98);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_helper__ = __webpack_require__(414);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Component that displays the competencies of a course.
 */
var AddonCompetencyCourseComponent = /** @class */ (function () {
    function AddonCompetencyCourseComponent(navCtrl, appProvider, domUtils, competencyProvider, helperProvider) {
        this.navCtrl = navCtrl;
        this.appProvider = appProvider;
        this.domUtils = domUtils;
        this.competencyProvider = competencyProvider;
        this.helperProvider = helperProvider;
        this.competenciesLoaded = false;
    }
    /**
     * View loaded.
     */
    AddonCompetencyCourseComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.fetchCourseCompetencies().finally(function () {
            _this.competenciesLoaded = true;
        });
    };
    /**
     * Fetches the competencies and updates the view.
     *
     * @return {Promise<void>} Promise resolved when done.
     */
    AddonCompetencyCourseComponent.prototype.fetchCourseCompetencies = function () {
        var _this = this;
        return this.competencyProvider.getCourseCompetencies(this.courseId, this.userId).then(function (competencies) {
            _this.competencies = competencies;
            // Get the user profile image.
            _this.helperProvider.getProfile(_this.userId).then(function (user) {
                _this.user = user;
            });
        }).catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'Error getting course competencies data.');
        });
    };
    /**
     * Opens a competency.
     *
     * @param {number} competencyId
     */
    AddonCompetencyCourseComponent.prototype.openCompetency = function (competencyId) {
        if (this.appProvider.isWide()) {
            this.navCtrl.push('AddonCompetencyCompetenciesPage', { competencyId: competencyId, courseId: this.courseId, userId: this.userId });
        }
        else {
            this.navCtrl.push('AddonCompetencyCompetencyPage', { competencyId: competencyId, courseId: this.courseId, userId: this.userId });
        }
    };
    /**
     * Opens the summary of a competency.
     *
     * @param {number} competencyId
     */
    AddonCompetencyCourseComponent.prototype.openCompetencySummary = function (competencyId) {
        this.navCtrl.push('AddonCompetencyCompetencySummaryPage', { competencyId: competencyId });
    };
    /**
     * Refreshes the competencies.
     *
     * @param {any} refresher Refresher.
     */
    AddonCompetencyCourseComponent.prototype.refreshCourseCompetencies = function (refresher) {
        var _this = this;
        this.competencyProvider.invalidateCourseCompetencies(this.courseId, this.userId).finally(function () {
            _this.fetchCourseCompetencies().finally(function () {
                refresher.complete();
            });
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */])
    ], AddonCompetencyCourseComponent.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonCompetencyCourseComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonCompetencyCourseComponent.prototype, "userId", void 0);
    AddonCompetencyCourseComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-competency-course',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\competency\components\course\addon-competency-course.html"*/'<ion-content>\n    <ion-refresher [enabled]="competenciesLoaded" (ionRefresh)="refreshCourseCompetencies($event)">\n        <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n    </ion-refresher>\n    <core-loading [hideUntil]="competenciesLoaded">\n        <ion-card *ngIf="!user && competencies && competencies.statistics.competencycount > 0">\n            <ng-container *ngIf="competencies.cangradecompetencies">\n                <ion-item text-wrap *ngIf="competencies.settings.pushratingstouserplans">\n                    {{ \'addon.competency.coursecompetencyratingsarepushedtouserplans\' | translate }}\n                </ion-item>\n                <ion-item text-wrap *ngIf="!competencies.settings.pushratingstouserplans" color="danger">\n                    {{ \'addon.competency.coursecompetencyratingsarenotpushedtouserplans\' | translate }}\n                </ion-item>\n            </ng-container>\n            <ion-item text-wrap *ngIf="competencies.statistics.canbegradedincourse">\n                {{ \'addon.competency.xcompetenciesproficientoutofyincourse\' | translate:{$a: {x: competencies.statistics.proficientcompetencycount, y: competencies.statistics.competencycount} } }}\n                <core-progress-bar [progress]="competencies.statistics.proficientcompetencypercentage"></core-progress-bar>\n            </ion-item>\n            <ion-item text-wrap *ngIf="competencies.statistics.canmanagecoursecompetencies && competencies.statistics.leastproficientcount > 0">\n                <strong>{{ \'addon.competency.competenciesmostoftennotproficientincourse\' | translate }}</strong>:\n                <p *ngFor="let comp of competencies.statistics.leastproficient">\n                    <a (click)="openCompetencySummary(comp.id)">\n                        {{ comp.shortname }} - {{ comp.idnumber }}\n                    </a>\n                </p>\n            </ion-item>\n        </ion-card>\n\n        <h3 margin-horizontal *ngIf="competencies && competencies.statistics.competencycount > 0">{{ \'addon.competency.coursecompetencies\' | translate }}</h3>\n        <ion-card *ngIf="user">\n             <ion-item text-wrap>\n                <ion-avatar core-user-avatar [user]="user" item-start></ion-avatar>\n                <h2><core-format-text [text]="user.fullname"></core-format-text></h2>\n            </ion-item>\n        </ion-card>\n        <core-empty-box *ngIf="competencies && competencies.statistics.competencycount == 0" icon="ribbon" message="{{ \'addon.competency.nocompetenciesincourse\' | translate }}"></core-empty-box>\n\n        <div *ngIf="competencies">\n            <ion-card *ngFor="let competency of competencies.competencies">\n                <ion-item text-wrap (click)="openCompetency(competency.competency.id)" [title]="competency.competency.shortname" detail-push>\n                    <h2><strong>{{competency.competency.shortname}} <em>{{competency.competency.idnumber}}</em></strong></h2>\n                    <ion-badge item-end *ngIf="competency.usercompetencycourse && competency.usercompetencycourse.gradename" [color]="competency.usercompetencycourse.proficiency ? \'success\' : \'danger\'">{{ competency.usercompetencycourse.gradename }}</ion-badge>\n                </ion-item>\n                <ion-item text-wrap>\n                    <p *ngIf="competency.competency.description">\n                        <core-format-text [text]=" competency.competency.description "></core-format-text>\n                    </p>\n                    <div>\n                        <strong>{{ \'addon.competency.path\' | translate }}</strong>\n                        <a *ngIf="competency.comppath.showlinks" [href]="competency.comppath.pluginbaseurl + \'/competencies.php?competencyframeworkid=\' + competency.comppath.framework.id + \'&pagecontextid=\' + competency.comppath.pagecontextid" core-link [title]="competency.comppath.framework.name">{{ competency.comppath.framework.name }}</a>\n                        <ng-container *ngIf="!competency.comppath.showlinks">{{ competency.comppath.framework.name }}</ng-container>\n                        &nbsp;/&nbsp;\n                        <span *ngFor="let ancestor of competency.comppath.ancestors">\n                            <a *ngIf="competency.comppath.showlinks" (click)="openCompetencySummary(ancestor.id)">{{ ancestor.name }}</a>\n                            <ng-container *ngIf="!competency.comppath.showlinks">{{ ancestor.name }}</ng-container>\n                            <ng-container *ngIf="!ancestor.last">&nbsp;/&nbsp;</ng-container>\n                        </span>\n                    </div>\n                    <div *ngIf="competencies.statistics.canmanagecoursecompetencies">\n                        <strong>{{ \'addon.competency.uponcoursecompletion\' | translate }}</strong>\n                         <ng-container *ngFor="let ruleoutcome of competency.ruleoutcomeoptions">\n                            <span *ngIf="ruleoutcome.selected">\n                                <core-format-text [text]="ruleoutcome.text"></core-format-text>\n                            </span>\n                        </ng-container>\n                    </div>\n                    <div>\n                        <strong>{{ \'addon.competency.activities\' | translate }}</strong>\n                        <p *ngIf="competency.coursemodules.length == 0">\n                            {{ \'addon.competency.noactivities\' | translate }}\n                        </p>\n                        <a ion-item text-wrap *ngFor="let activity of competency.coursemodules" [href]="activity.url" [title]="activity.name" core-link capture="true" class="core-course-module-handler item-media">\n                            <img item-start [src]="activity.iconurl" core-external-content alt="" role="presentation" *ngIf="activity.iconurl" class="core-module-icon">\n                            <core-format-text [text]="activity.name"></core-format-text>\n                        </a>\n                    </div>\n                    <div *ngIf="competency.plans">\n                        <strong>{{ \'addon.competency.userplans\' | translate }}</strong>\n                        <p *ngIf="competency.plans.length == 0">\n                            {{ \'addon.competency.nouserplanswithcompetency\' | translate }}\n                        </p>\n                        <a ion-item text-wrap *ngFor="let plan of competency.plans" [href]="plan.url" [title]="plan.name" core-link capture="true">\n                            <core-format-text [text]="plan.name"></core-format-text>\n                        </a>\n                    </div>\n                </ion-item>\n            </ion-card>\n        </div>\n    </core-loading>\n</ion-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\competency\components\course\addon-competency-course.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_competency__["a" /* AddonCompetencyProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* AddonCompetencyHelperProvider */]])
    ], AddonCompetencyCourseComponent);
    return AddonCompetencyCourseComponent;
}());

//# sourceMappingURL=course.js.map

/***/ }),
/* 765 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCourseCompletionReportComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_coursecompletion__ = __webpack_require__(146);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component that displays the course completion report.
 */
var AddonCourseCompletionReportComponent = /** @class */ (function () {
    function AddonCourseCompletionReportComponent(sitesProvider, domUtils, courseCompletionProvider) {
        this.sitesProvider = sitesProvider;
        this.domUtils = domUtils;
        this.courseCompletionProvider = courseCompletionProvider;
        this.completionLoaded = false;
        this.tracked = true; // Whether completion is tracked.
    }
    /**
     * Component being initialized.
     */
    AddonCourseCompletionReportComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this.userId) {
            this.userId = this.sitesProvider.getCurrentSiteUserId();
        }
        this.fetchCompletion().finally(function () {
            _this.completionLoaded = true;
        });
    };
    /**
     * Fetch compleiton data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonCourseCompletionReportComponent.prototype.fetchCompletion = function () {
        var _this = this;
        return this.courseCompletionProvider.getCompletion(this.courseId, this.userId).then(function (completion) {
            completion.statusText = _this.courseCompletionProvider.getCompletedStatusText(completion);
            _this.completion = completion;
            _this.showSelfComplete = _this.courseCompletionProvider.canMarkSelfCompleted(_this.userId, completion);
            _this.tracked = true;
        }).catch(function (error) {
            if (error && error.errorcode == 'notenroled') {
                // Not enrolled error, probably a teacher.
                _this.tracked = false;
            }
            else {
                _this.domUtils.showErrorModalDefault(error, 'addon.coursecompletion.couldnotloadreport', true);
            }
        });
    };
    /**
     * Refresh completion data on PTR.
     *
     * @param {any} [refresher] Refresher instance.
     */
    AddonCourseCompletionReportComponent.prototype.refreshCompletion = function (refresher) {
        var _this = this;
        this.courseCompletionProvider.invalidateCourseCompletion(this.courseId, this.userId).finally(function () {
            _this.fetchCompletion().finally(function () {
                refresher && refresher.complete();
            });
        });
    };
    /**
     * Mark course as completed.
     */
    AddonCourseCompletionReportComponent.prototype.completeCourse = function () {
        var _this = this;
        var modal = this.domUtils.showModalLoading('core.sending', true);
        this.courseCompletionProvider.markCourseAsSelfCompleted(this.courseId).then(function () {
            return _this.refreshCompletion();
        }).catch(function (message) {
            _this.domUtils.showErrorModal(message);
        }).finally(function () {
            modal.dismiss();
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonCourseCompletionReportComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonCourseCompletionReportComponent.prototype, "userId", void 0);
    AddonCourseCompletionReportComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-course-completion-report',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\coursecompletion\components\report\addon-course-completion-report.html"*/'<ion-content>\n    <ion-refresher [enabled]="completionLoaded" (ionRefresh)="refreshCompletion($event)">\n        <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n    </ion-refresher>\n    <core-loading [hideUntil]="completionLoaded">\n        <ion-card *ngIf="completion && tracked">\n            <ion-item text-wrap>\n                <h2>{{ \'addon.coursecompletion.status\' | translate }}</h2>\n                <p>{{ completion.statusText | translate }}</p>\n            </ion-item>\n            <ion-item text-wrap>\n                <h2>{{ \'addon.coursecompletion.required\' | translate }}</h2>\n                <p *ngIf="completion.aggregation === 1">{{ \'addon.coursecompletion.criteriarequiredall\' | translate }}</p>\n                <p *ngIf="completion.aggregation === 2">{{ \'addon.coursecompletion.criteriarequiredany\' | translate }}</p>\n            </ion-item>\n        </ion-card>\n        <ion-card *ngIf="completion && tracked">\n            <ion-item-divider>{{ \'addon.coursecompletion.requiredcriteria\' | translate }}</ion-item-divider>\n            <ion-item class="hidden-tablet" text-wrap *ngFor="let criteria of completion.completions">\n                <h2><core-format-text clean="true" [text]="criteria.details.criteria"></core-format-text></h2>\n                <p><core-format-text clean="true" [text]="criteria.details.requirement"></core-format-text></p>\n                <strong item-end>{{ criteria.status }}</strong>\n            </ion-item>\n            <ion-item class="hidden-phone" text-wrap>\n                <ion-row>\n                    <ion-col><strong>{{ \'addon.coursecompletion.criteriagroup\' | translate }}</strong></ion-col>\n                    <ion-col><strong>{{ \'addon.coursecompletion.criteria\' | translate }}</strong></ion-col>\n                    <ion-col><strong>{{ \'addon.coursecompletion.requirement\' | translate }}</strong></ion-col>\n                    <ion-col><strong>{{ \'addon.coursecompletion.status\' | translate }}</strong></ion-col>\n                    <ion-col><strong>{{ \'addon.coursecompletion.complete\' | translate }}</strong></ion-col>\n                    <ion-col><strong>{{ \'addon.coursecompletion.completiondate\' | translate }}</strong></ion-col>\n                </ion-row>\n                <ion-row *ngFor="let criteria of completion.completions">\n                    <ion-col><core-format-text clean="true" [text]="criteria.title"></core-format-text></ion-col>\n                    <ion-col><core-format-text clean="true" [text]="criteria.details.criteria"></core-format-text></ion-col>\n                    <ion-col><core-format-text clean="true" [text]="criteria.details.requirement"></core-format-text></ion-col>\n                    <ion-col><core-format-text [text]="criteria.details.status"></core-format-text></ion-col>\n                    <ion-col>{{ criteria.status }}</ion-col>\n                    <ion-col *ngIf="criteria.timecompleted">{{ criteria.timecompleted * 1000 | coreFormatDate :\'strftimedatetimeshort\' }}</ion-col>\n                    <ion-col *ngIf="!criteria.timecompleted"></ion-col>\n                </ion-row>\n            </ion-item>\n        </ion-card>\n        <ion-card *ngIf="showSelfComplete && tracked">\n            <ion-item-divider>{{ \'addon.coursecompletion.manualselfcompletion\' | translate }}</ion-item-divider>\n            <ion-item>\n                <button ion-button block (click)="completeCourse()">{{ \'addon.coursecompletion.completecourse\' | translate }}</button>\n            </ion-item>\n        </ion-card>\n\n        <div *ngIf="!tracked" class="core-warning-card" icon-start>\n            <ion-icon name="warning"></ion-icon>\n            {{ \'addon.coursecompletion.nottracked\' | translate }}\n        </div>\n    </core-loading>\n</ion-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\coursecompletion\components\report\addon-course-completion-report.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_coursecompletion__["a" /* AddonCourseCompletionProvider */]])
    ], AddonCourseCompletionReportComponent);
    return AddonCourseCompletionReportComponent;
}());

//# sourceMappingURL=report.js.map

/***/ }),
/* 766 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Buffer) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FileTransferErrorMock; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return FileTransferMock; });
/* unused harmony export FileTransferObjectMock */
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_file_transfer__ = __webpack_require__(251);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_file__ = __webpack_require__(33);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Mock the File Transfer Error.
 */
var FileTransferErrorMock = /** @class */ (function () {
    // tslint:disable-next-line: variable-name
    function FileTransferErrorMock(code, source, target, http_status, body, exception) {
        this.code = code;
        this.source = source;
        this.target = target;
        this.http_status = http_status;
        this.body = body;
        this.exception = exception;
    }
    FileTransferErrorMock.FILE_NOT_FOUND_ERR = 1;
    FileTransferErrorMock.INVALID_URL_ERR = 2;
    FileTransferErrorMock.CONNECTION_ERR = 3;
    FileTransferErrorMock.ABORT_ERR = 4;
    FileTransferErrorMock.NOT_MODIFIED_ERR = 5;
    return FileTransferErrorMock;
}());

/**
 * Emulates the Cordova FileTransfer plugin in desktop apps and in browser.
 */
var FileTransferMock = /** @class */ (function (_super) {
    __extends(FileTransferMock, _super);
    function FileTransferMock(appProvider, fileProvider) {
        var _this = _super.call(this) || this;
        _this.appProvider = appProvider;
        _this.fileProvider = fileProvider;
        return _this;
    }
    /**
     * Creates a new FileTransferObjectMock object.
     *
     * @return {FileTransferObjectMock}
     */
    FileTransferMock.prototype.create = function () {
        return new FileTransferObjectMock(this.appProvider, this.fileProvider);
    };
    FileTransferMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_file__["a" /* CoreFileProvider */]])
    ], FileTransferMock);
    return FileTransferMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_file_transfer__["a" /* FileTransfer */]));

/**
 * Emulates the FileTransferObject class in desktop apps and in browser.
 */
var FileTransferObjectMock = /** @class */ (function (_super) {
    __extends(FileTransferObjectMock, _super);
    function FileTransferObjectMock(appProvider, fileProvider) {
        var _this = _super.call(this) || this;
        _this.appProvider = appProvider;
        _this.fileProvider = fileProvider;
        return _this;
    }
    /**
     * Aborts an in-progress transfer. The onerror callback is passed a FileTransferError
     * object which has an error code of FileTransferError.ABORT_ERR.
     */
    FileTransferObjectMock.prototype.abort = function () {
        if (this.xhr) {
            this.xhr.abort();
            this.reject(new FileTransferErrorMock(FileTransferErrorMock.ABORT_ERR, this.source, this.target, null, null, null));
        }
    };
    /**
     * Downloads a file from server.
     *
     * @param {string} source URL of the server to download the file, as encoded by encodeURI().
     * @param {string} target Filesystem url representing the file on the device.
     * @param {boolean} [trustAllHosts] If set to true, it accepts all security certificates.
     * @param {object} [options] Optional parameters, currently only supports headers.
     * @returns {Promise<any>} Returns a Promise that resolves to a FileEntry object.
     */
    FileTransferObjectMock.prototype.download = function (source, target, trustAllHosts, options) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            // Use XMLHttpRequest instead of HttpClient to support onprogress and abort.
            var basicAuthHeader = _this.getBasicAuthHeader(source), xhr = new XMLHttpRequest(), isDesktop = _this.appProvider.isDesktop();
            var headers = null;
            _this.xhr = xhr;
            _this.source = source;
            _this.target = target;
            _this.reject = reject;
            if (basicAuthHeader) {
                source = source.replace(_this.getUrlCredentials(source) + '@', '');
                options = options || {};
                options.headers = options.headers || {};
                options.headers[basicAuthHeader.name] = basicAuthHeader.value;
            }
            if (options) {
                headers = options.headers || null;
            }
            // Prepare the request.
            xhr.open('GET', source, true);
            xhr.responseType = isDesktop ? 'arraybuffer' : 'blob';
            for (var name_1 in headers) {
                xhr.setRequestHeader(name_1, headers[name_1]);
            }
            xhr.onprogress = function (xhr, ev) {
                if (_this.progressListener) {
                    _this.progressListener(ev);
                }
            };
            xhr.onerror = function (err) {
                reject(new FileTransferErrorMock(-1, source, target, xhr.status, xhr.statusText, null));
            };
            xhr.onload = function () {
                // Finished dowloading the file.
                var response = xhr.response || xhr.responseText;
                var status = Math.max(xhr.status === 1223 ? 204 : xhr.status, 0);
                if (status < 200 || status >= 300) {
                    // Request failed. Try to get the error message.
                    _this.parseResponse(response).then(function (response) {
                        reject(new FileTransferErrorMock(-1, source, target, xhr.status, response || xhr.statusText, null));
                    });
                    return;
                }
                if (!response) {
                    reject();
                }
                else {
                    var basePath = _this.fileProvider.getBasePathInstant();
                    target = target.replace(basePath, ''); // Remove basePath from the target.
                    target = target.replace(/%20/g, ' '); // Replace all %20 with spaces.
                    if (isDesktop) {
                        // In desktop we need to convert the arraybuffer into a Buffer.
                        response = Buffer.from(new Uint8Array(response));
                    }
                    _this.fileProvider.writeFile(target, response).then(resolve, reject);
                }
            };
            xhr.send();
        });
    };
    /**
     * Given a URL, check if it has a credentials in it and, if so, return them in a header object.
     * This code is extracted from Cordova FileTransfer plugin.
     *
     * @param {string} urlString The URL to get the credentials from.
     * @return {any} The header with the credentials, null if no credentials.
     */
    FileTransferObjectMock.prototype.getBasicAuthHeader = function (urlString) {
        var header = null;
        // MS Windows doesn't support credentials in http uris so we detect them by regexp and strip off from result url.
        if (window.btoa) {
            var credentials = this.getUrlCredentials(urlString);
            if (credentials) {
                var authHeader = 'Authorization', authHeaderValue = 'Basic ' + window.btoa(credentials);
                header = {
                    name: authHeader,
                    value: authHeaderValue
                };
            }
        }
        return header;
    };
    /**
     * Given an instance of XMLHttpRequest, get the response headers as an object.
     *
     * @param {XMLHttpRequest} xhr XMLHttpRequest instance.
     * @return {{[s: string]: any}} Object with the headers.
     */
    FileTransferObjectMock.prototype.getHeadersAsObject = function (xhr) {
        var headersString = xhr.getAllResponseHeaders(), result = {};
        if (headersString) {
            var headers = headersString.split('\n');
            for (var i in headers) {
                var headerString = headers[i], separatorPos = headerString.indexOf(':');
                if (separatorPos != -1) {
                    result[headerString.substr(0, separatorPos)] = headerString.substr(separatorPos + 1).trim();
                }
            }
        }
        return result;
    };
    /**
     * Get the credentials from a URL.
     * This code is extracted from Cordova FileTransfer plugin.
     *
     * @param {string} urlString The URL to get the credentials from.
     * @return {string} Retrieved credentials.
     */
    FileTransferObjectMock.prototype.getUrlCredentials = function (urlString) {
        var credentialsPattern = /^https?\:\/\/(?:(?:(([^:@\/]*)(?::([^@\/]*))?)?@)?([^:\/?#]*)(?::(\d*))?).*$/, credentials = credentialsPattern.exec(urlString);
        return credentials && credentials[1];
    };
    /**
     * Registers a listener that gets called whenever a new chunk of data is transferred.
     *
     * @param {Function} listener Listener that takes a progress event.
     */
    FileTransferObjectMock.prototype.onProgress = function (listener) {
        this.progressListener = listener;
    };
    /**
     * Same as Javascript's JSON.parse, but it will handle errors.
     *
     * @param {string} json JSON text.
     * @return {any} JSON parsed as object or what it gets.
     */
    FileTransferObjectMock.prototype.parseJSON = function (json) {
        try {
            return JSON.parse(json);
        }
        catch (ex) {
            // Error.
        }
        return json;
    };
    /**
     * Parse a response, converting it into text and the into an object if needed.
     *
     * @param {any} response The response to parse.
     * @return {Promise<any>} Promise resolved with the parsed response.
     */
    FileTransferObjectMock.prototype.parseResponse = function (response) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (!response) {
                resolve('');
            }
            else if (response.toString && response.toString() == '[object Blob]') {
                // Convert the Blob into text.
                var reader_1 = new FileReader();
                reader_1.onloadend = function () {
                    resolve(reader_1.result);
                };
                reader_1.readAsText(response);
            }
            else if (response.toString && response.toString() == '[object ArrayBuffer]') {
                // Convert the ArrayBuffer into text.
                resolve(String.fromCharCode.apply(null, new Uint8Array(response)));
            }
            else {
                resolve(response);
            }
        }).then(function (response) {
            return _this.parseJSON(response);
        });
    };
    /**
     * Sends a file to a server.
     *
     * @param {string} fileUrl Filesystem URL representing the file on the device or a data URI.
     * @param {string} url URL of the server to receive the file, as encoded by encodeURI().
     * @param {FileUploadOptions} [options] Optional parameters.
     * @param {boolean} [trustAllHosts] If set to true, it accepts all security certificates.
     * @returns {Promise<FileUploadResult>} Promise that resolves to a FileUploadResult and rejects with FileTransferError.
     */
    FileTransferObjectMock.prototype.upload = function (fileUrl, url, options, trustAllHosts) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var basicAuthHeader = _this.getBasicAuthHeader(url);
            var fileKey = null, fileName = null, params = null, headers = null, httpMethod = null;
            if (basicAuthHeader) {
                url = url.replace(_this.getUrlCredentials(url) + '@', '');
                options = options || {};
                options.headers = options.headers || {};
                options.headers[basicAuthHeader.name] = basicAuthHeader.value;
            }
            if (options) {
                fileKey = options.fileKey;
                fileName = options.fileName;
                headers = options.headers;
                httpMethod = options.httpMethod || 'POST';
                if (httpMethod.toUpperCase() == 'PUT') {
                    httpMethod = 'PUT';
                }
                else {
                    httpMethod = 'POST';
                }
                if (options.params) {
                    params = options.params;
                }
                else {
                    params = {};
                }
            }
            // Add fileKey and fileName to the headers.
            headers = headers || {};
            if (!headers['Content-Disposition']) {
                headers['Content-Disposition'] = 'form-data;' + (fileKey ? ' name="' + fileKey + '";' : '') +
                    (fileName ? ' filename="' + fileName + '"' : '');
            }
            // Adding a Content-Type header with the mimeType makes the request fail (it doesn't detect the token in the params).
            // Don't include this header, and delete it if it's supplied.
            delete headers['Content-Type'];
            // Get the file to upload.
            _this.fileProvider.getFile(fileUrl).then(function (fileEntry) {
                return _this.fileProvider.getFileObjectFromFileEntry(fileEntry);
            }).then(function (file) {
                // Use XMLHttpRequest instead of HttpClient to support onprogress and abort.
                var xhr = new XMLHttpRequest();
                xhr.open(httpMethod || 'POST', url);
                for (var name_2 in headers) {
                    // Filter "unsafe" headers.
                    if (name_2 != 'Connection') {
                        xhr.setRequestHeader(name_2, headers[name_2]);
                    }
                }
                xhr.onprogress = function (ev) {
                    if (_this.progressListener) {
                        _this.progressListener(ev);
                    }
                };
                _this.xhr = xhr;
                _this.source = fileUrl;
                _this.target = url;
                _this.reject = reject;
                xhr.onerror = function () {
                    reject(new FileTransferErrorMock(-1, fileUrl, url, xhr.status, xhr.statusText, null));
                };
                xhr.onload = function () {
                    // Finished uploading the file.
                    resolve({
                        bytesSent: file.size,
                        responseCode: xhr.status,
                        response: xhr.response,
                        headers: _this.getHeadersAsObject(xhr)
                    });
                };
                // Create a form data to send params and the file.
                var fd = new FormData();
                for (var name_3 in params) {
                    fd.append(name_3, params[name_3]);
                }
                fd.append('file', file);
                xhr.send(fd);
            }).catch(reject);
        });
    };
    return FileTransferObjectMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_file_transfer__["b" /* FileTransferObject */]));

//# sourceMappingURL=file-transfer.js.map
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(139).Buffer))

/***/ }),
/* 767 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignDefaultFeedbackHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_base_feedback_handler__ = __webpack_require__(768);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Default handler used when a feedback plugin doesn't have a specific implementation.
 */
var AddonModAssignDefaultFeedbackHandler = /** @class */ (function (_super) {
    __extends(AddonModAssignDefaultFeedbackHandler, _super);
    function AddonModAssignDefaultFeedbackHandler(translate) {
        var _this = _super.call(this, translate) || this;
        _this.translate = translate;
        _this.name = 'AddonModAssignDefaultFeedbackHandler';
        _this.type = 'default';
        return _this;
    }
    AddonModAssignDefaultFeedbackHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModAssignDefaultFeedbackHandler);
    return AddonModAssignDefaultFeedbackHandler;
}(__WEBPACK_IMPORTED_MODULE_2__classes_base_feedback_handler__["a" /* AddonModAssignBaseFeedbackHandler */]));

//# sourceMappingURL=default-feedback-handler.js.map

/***/ }),
/* 768 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignBaseFeedbackHandler; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base handler for feedback plugins.
 *
 * This class is needed because parent classes cannot have @Injectable in Angular v6, so the default handler cannot be a
 * parent class.
 */
var AddonModAssignBaseFeedbackHandler = /** @class */ (function () {
    function AddonModAssignBaseFeedbackHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModAssignBaseFeedbackHandler';
        this.type = 'base';
    }
    /**
     * Discard the draft data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignBaseFeedbackHandler.prototype.discardDraft = function (assignId, userId, siteId) {
        // Nothing to do.
    };
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignBaseFeedbackHandler.prototype.getComponent = function (injector, plugin) {
        // Nothing to do.
    };
    /**
     * Return the draft saved data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any|Promise<any>} Data (or promise resolved with the data).
     */
    AddonModAssignBaseFeedbackHandler.prototype.getDraft = function (assignId, userId, siteId) {
        // Nothing to do.
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]|Promise<any[]>} The files (or promise resolved with the files).
     */
    AddonModAssignBaseFeedbackHandler.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return [];
    };
    /**
     * Get a readable name to use for the plugin.
     *
     * @param {any} plugin The plugin object.
     * @return {string} The plugin name.
     */
    AddonModAssignBaseFeedbackHandler.prototype.getPluginName = function (plugin) {
        // Check if there's a translated string for the plugin.
        var translationId = 'addon.mod_assign_feedback_' + plugin.type + '.pluginname', translation = this.translate.instant(translationId);
        if (translationId != translation) {
            // Translation found, use it.
            return translation;
        }
        // Fallback to WS string.
        if (plugin.name) {
            return plugin.name;
        }
    };
    /**
     * Check if the feedback data has changed for this plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the feedback.
     * @return {boolean|Promise<boolean>} Boolean (or promise resolved with boolean): whether the data has changed.
     */
    AddonModAssignBaseFeedbackHandler.prototype.hasDataChanged = function (assign, submission, plugin, inputData) {
        return false;
    };
    /**
     * Check whether the plugin has draft data stored.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Boolean or promise resolved with boolean: whether the plugin has draft data.
     */
    AddonModAssignBaseFeedbackHandler.prototype.hasDraftData = function (assignId, userId, siteId) {
        return false;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignBaseFeedbackHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Prefetch any required data for the plugin.
     * This should NOT prefetch files. Files to be prefetched should be returned by the getPluginFiles function.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignBaseFeedbackHandler.prototype.prefetch = function (assign, submission, plugin, siteId) {
        return Promise.resolve();
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the draft data saved.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {any} pluginData Object where to store the data to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignBaseFeedbackHandler.prototype.prepareFeedbackData = function (assignId, userId, plugin, pluginData, siteId) {
        // Nothing to do.
    };
    /**
     * Save draft data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {any} data The data to save.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignBaseFeedbackHandler.prototype.saveDraft = function (assignId, userId, plugin, data, siteId) {
        // Nothing to do.
    };
    return AddonModAssignBaseFeedbackHandler;
}());

//# sourceMappingURL=base-feedback-handler.js.map

/***/ }),
/* 769 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignDefaultSubmissionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_base_submission_handler__ = __webpack_require__(770);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Default handler used when a submission plugin doesn't have a specific implementation.
 */
var AddonModAssignDefaultSubmissionHandler = /** @class */ (function (_super) {
    __extends(AddonModAssignDefaultSubmissionHandler, _super);
    function AddonModAssignDefaultSubmissionHandler(translate) {
        var _this = _super.call(this, translate) || this;
        _this.translate = translate;
        _this.name = 'AddonModAssignDefaultSubmissionHandler';
        _this.type = 'default';
        return _this;
    } // Nothing to do.
    AddonModAssignDefaultSubmissionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModAssignDefaultSubmissionHandler);
    return AddonModAssignDefaultSubmissionHandler;
}(__WEBPACK_IMPORTED_MODULE_2__classes_base_submission_handler__["a" /* AddonModAssignBaseSubmissionHandler */]));

//# sourceMappingURL=default-submission-handler.js.map

/***/ }),
/* 770 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignBaseSubmissionHandler; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base handler for submission plugins.
 *
 * This class is needed because parent classes cannot have @Injectable in Angular v6, so the default handler cannot be a
 * parent class.
 */
var AddonModAssignBaseSubmissionHandler = /** @class */ (function () {
    function AddonModAssignBaseSubmissionHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModAssignBaseSubmissionHandler';
        this.type = 'base';
    }
    /**
     * Whether the plugin can be edited in offline for existing submissions. In general, this should return false if the
     * plugin uses Moodle filters. The reason is that the app only prefetches filtered data, and the user should edit
     * unfiltered data.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @return {boolean|Promise<boolean>} Boolean or promise resolved with boolean: whether it can be edited in offline.
     */
    AddonModAssignBaseSubmissionHandler.prototype.canEditOffline = function (assign, submission, plugin) {
        return false;
    };
    /**
     * Should clear temporary data for a cancelled submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     */
    AddonModAssignBaseSubmissionHandler.prototype.clearTmpData = function (assign, submission, plugin, inputData) {
        // Nothing to do.
    };
    /**
     * This function will be called when the user wants to create a new submission based on the previous one.
     * It should add to pluginData the data to send to server based in the data in plugin (previous attempt).
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @param {any} pluginData Object where to store the data to send.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignBaseSubmissionHandler.prototype.copySubmissionData = function (assign, plugin, pluginData, userId, siteId) {
        // Nothing to do.
    };
    /**
     * Delete any stored data for the plugin and submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} offlineData Offline data stored.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignBaseSubmissionHandler.prototype.deleteOfflineData = function (assign, submission, plugin, offlineData, siteId) {
        // Nothing to do.
    };
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignBaseSubmissionHandler.prototype.getComponent = function (injector, plugin, edit) {
        // Nothing to do.
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]|Promise<any[]>} The files (or promise resolved with the files).
     */
    AddonModAssignBaseSubmissionHandler.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return [];
    };
    /**
     * Get a readable name to use for the plugin.
     *
     * @param {any} plugin The plugin object.
     * @return {string} The plugin name.
     */
    AddonModAssignBaseSubmissionHandler.prototype.getPluginName = function (plugin) {
        // Check if there's a translated string for the plugin.
        var translationId = 'addon.mod_assign_submission_' + plugin.type + '.pluginname', translation = this.translate.instant(translationId);
        if (translationId != translation) {
            // Translation found, use it.
            return translation;
        }
        // Fallback to WS string.
        if (plugin.name) {
            return plugin.name;
        }
    };
    /**
     * Get the size of data (in bytes) this plugin will send to copy a previous submission.
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @return {number|Promise<number>} The size (or promise resolved with size).
     */
    AddonModAssignBaseSubmissionHandler.prototype.getSizeForCopy = function (assign, plugin) {
        return 0;
    };
    /**
     * Get the size of data (in bytes) this plugin will send to add or edit a submission.
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @return {number|Promise<number>} The size (or promise resolved with size).
     */
    AddonModAssignBaseSubmissionHandler.prototype.getSizeForEdit = function (assign, plugin) {
        return 0;
    };
    /**
     * Check if the submission data has changed for this plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {boolean|Promise<boolean>} Boolean (or promise resolved with boolean): whether the data has changed.
     */
    AddonModAssignBaseSubmissionHandler.prototype.hasDataChanged = function (assign, submission, plugin, inputData) {
        return false;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignBaseSubmissionHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether or not the handler is enabled for edit on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled for edit on a site level.
     */
    AddonModAssignBaseSubmissionHandler.prototype.isEnabledForEdit = function () {
        return false;
    };
    /**
     * Prefetch any required data for the plugin.
     * This should NOT prefetch files. Files to be prefetched should be returned by the getPluginFiles function.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignBaseSubmissionHandler.prototype.prefetch = function (assign, submission, plugin, siteId) {
        return Promise.resolve();
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the input data.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @param {any} pluginData Object where to store the data to send.
     * @param {boolean} [offline] Whether the user is editing in offline.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignBaseSubmissionHandler.prototype.prepareSubmissionData = function (assign, submission, plugin, inputData, pluginData, offline, userId, siteId) {
        // Nothing to do.
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the offline data stored.
     * This will be used when performing a synchronization.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} offlineData Offline data stored.
     * @param {any} pluginData Object where to store the data to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignBaseSubmissionHandler.prototype.prepareSyncData = function (assign, submission, plugin, offlineData, pluginData, siteId) {
        // Nothing to do.
    };
    return AddonModAssignBaseSubmissionHandler;
}());

//# sourceMappingURL=base-submission-handler.js.map

/***/ }),
/* 771 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionPluginComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__ = __webpack_require__(162);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays an assignment submission plugin.
 */
var AddonModAssignSubmissionPluginComponent = /** @class */ (function () {
    function AddonModAssignSubmissionPluginComponent(injector, submissionDelegate, assignProvider, assignHelper) {
        this.injector = injector;
        this.submissionDelegate = submissionDelegate;
        this.assignProvider = assignProvider;
        this.assignHelper = assignHelper;
        // Data to render the plugin if it isn't supported.
        this.component = __WEBPACK_IMPORTED_MODULE_1__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        this.text = '';
        this.files = [];
    }
    /**
     * Component being initialized.
     */
    AddonModAssignSubmissionPluginComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this.plugin) {
            return;
        }
        this.plugin.name = this.submissionDelegate.getPluginName(this.plugin);
        if (!this.plugin.name) {
            return;
        }
        this.edit = this.edit && this.edit !== 'false';
        this.allowOffline = this.allowOffline && this.allowOffline !== 'false';
        // Check if the plugin has defined its own component to render itself.
        this.submissionDelegate.getComponentForPlugin(this.injector, this.plugin, this.edit).then(function (component) {
            _this.pluginComponent = component;
            if (component) {
                // Prepare the data to pass to the component.
                _this.data = {
                    assign: _this.assign,
                    submission: _this.submission,
                    plugin: _this.plugin,
                    configs: _this.assignHelper.getPluginConfig(_this.assign, 'assignsubmission', _this.plugin.type),
                    edit: _this.edit,
                    allowOffline: _this.allowOffline
                };
            }
            else {
                // Data to render the plugin.
                _this.text = _this.assignProvider.getSubmissionPluginText(_this.plugin);
                _this.files = _this.assignProvider.getSubmissionPluginAttachments(_this.plugin);
                _this.notSupported = _this.submissionDelegate.isPluginSupported(_this.plugin.type);
                _this.pluginLoaded = true;
            }
        });
    };
    /**
     * Invalidate the plugin data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionPluginComponent.prototype.invalidate = function () {
        return Promise.resolve(this.dynamicComponent && this.dynamicComponent.callComponentFunction('invalidate', []));
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */])
    ], AddonModAssignSubmissionPluginComponent.prototype, "dynamicComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "assign", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "plugin", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignSubmissionPluginComponent.prototype, "allowOffline", void 0);
    AddonModAssignSubmissionPluginComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-submission-plugin',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\submission-plugin\addon-mod-assign-submission-plugin.html"*/'\n<core-dynamic-component [component]="pluginComponent" [data]="data">\n    <!-- This content will be replaced by the component if found. -->\n    <core-loading [hideUntil]="pluginLoaded">\n        <ion-item text-wrap *ngIf="text.length > 0 || files.length > 0">\n            <h2>{{ plugin.name }}</h2>\n            <ion-badge *ngIf="notSupported" color="primary">\n                {{ \'addon.mod_assign.submissionnotsupported\' | translate }}\n            </ion-badge>\n            <p *ngIf="text">\n                <core-format-text [component]="component" [componentId]="assign.cmid" [maxHeight]="80" [fullOnClick]="true" [fullTitle]="plugin.name" [text]="text"></core-format-text>\n            </p>\n            <core-file *ngFor="let file of files" [file]="file" [component]="component" [componentId]="assign.cmid" [alwaysDownload]="true"></core-file>\n        </ion-item>\n    </core-loading>\n</core-dynamic-component>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\submission-plugin\addon-mod-assign-submission-plugin.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_3__providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */],
            __WEBPACK_IMPORTED_MODULE_1__providers_assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonModAssignHelperProvider */]])
    ], AddonModAssignSubmissionPluginComponent);
    return AddonModAssignSubmissionPluginComponent;
}());

//# sourceMappingURL=submission-plugin.js.map

/***/ }),
/* 772 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModBookPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__book__ = __webpack_require__(212);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Handler to prefetch books.
 */
var AddonModBookPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModBookPrefetchHandler, _super);
    function AddonModBookPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, bookProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.bookProvider = bookProvider;
        _this.name = 'AddonModBook';
        _this.modName = 'book';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__book__["a" /* AddonModBookProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^entries$/;
        return _this;
    }
    /**
     * Download or prefetch the content.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files. This is to keep the files
     *                           relative paths and make the package work in an iframe. Undefined to download the files
     *                           in the filepool root folder.
     * @return {Promise<any>} Promise resolved when all content is downloaded. Data returned is not reliable.
     */
    AddonModBookPrefetchHandler.prototype.downloadOrPrefetch = function (module, courseId, prefetch, dirPath) {
        var promises = [];
        promises.push(_super.prototype.downloadOrPrefetch.call(this, module, courseId, prefetch));
        promises.push(this.bookProvider.getBook(courseId, module.id).catch(function () {
            // Ignore errors since this WS isn't available in some Moodle versions.
        }));
        return Promise.all(promises);
    };
    /**
     * Returns module intro files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    AddonModBookPrefetchHandler.prototype.getIntroFiles = function (module, courseId) {
        var _this = this;
        return this.bookProvider.getBook(courseId, module.id).catch(function () {
            // Not found, return undefined so module description is used.
        }).then(function (book) {
            return _this.getIntroFilesFromInstance(module, book);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModBookPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.bookProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModBookPrefetchHandler.prototype.isEnabled = function () {
        return this.bookProvider.isPluginEnabled();
    };
    AddonModBookPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__book__["a" /* AddonModBookProvider */]])
    ], AddonModBookPrefetchHandler);
    return AddonModBookPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__["a" /* CoreCourseResourcePrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 773 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModulePrefetchHandlerBase; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base prefetch handler to be registered in CoreCourseModulePrefetchDelegate. Prefetch handlers should inherit either
 * from CoreCourseModuleActivityPrefetchHandlerBase or CoreCourseModuleResourcePrefetchHandlerBase, depending on whether
 * they are an activity or a resource. It's not recommended to inherit from this class directly.
 */
var CoreCourseModulePrefetchHandlerBase = /** @class */ (function () {
    function CoreCourseModulePrefetchHandlerBase(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) {
        this.translate = translate;
        this.appProvider = appProvider;
        this.utils = utils;
        this.courseProvider = courseProvider;
        this.filepoolProvider = filepoolProvider;
        this.sitesProvider = sitesProvider;
        this.domUtils = domUtils;
        /**
         * Name of the handler.
         * @type {string}
         */
        this.name = 'CoreCourseModulePrefetchHandler';
        /**
         * Name of the module. It should match the "modname" of the module returned in core_course_get_contents.
         * @type {string}
         */
        this.modName = 'default';
        /**
         * The handler's component.
         * @type {string}
         */
        this.component = 'core_module';
        /**
         * The RegExp to check updates. If a module has an update whose name matches this RegExp, the module will be marked
         * as outdated. This RegExp is ignored if hasUpdates function is defined.
         * @type {RegExp}
         */
        this.updatesNames = /^.*files$/;
        /**
         * If true, this module will be ignored when determining the status of a list of modules. The module will
         * still be downloaded when downloading the section/course, it only affects whether the button should be displayed.
         * @type {boolean}
         */
        this.skipListStatus = false;
        /**
         * List of download promises to prevent downloading the module twice at the same time.
         * @type {{[s: string]: {[s: string]: Promise<any>}}}
         */
        this.downloadPromises = {};
    }
    /**
     * Add an ongoing download to the downloadPromises list. When the promise finishes it will be removed.
     *
     * @param {number} id Unique identifier per component.
     * @param {Promise<any>} promise Promise to add.
     * @param {String} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise of the current download.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.addOngoingDownload = function (id, promise, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var uniqueId = this.getUniqueId(id);
        if (!this.downloadPromises[siteId]) {
            this.downloadPromises[siteId] = {};
        }
        this.downloadPromises[siteId][uniqueId] = promise.finally(function () {
            delete _this.downloadPromises[siteId][uniqueId];
        });
        return this.downloadPromises[siteId][uniqueId];
    };
    /**
     * Download the module.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when all content is downloaded.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.download = function (module, courseId, dirPath) {
        // To be overridden.
        return Promise.resolve();
    };
    /**
     * Returns a list of content files that can be downloaded.
     *
     * @param {any} module The module object returned by WS.
     * @return {any[]} List of files.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getContentDownloadableFiles = function (module) {
        var _this = this;
        var files = [];
        if (module.contents && module.contents.length) {
            module.contents.forEach(function (content) {
                if (_this.isFileDownloadable(content)) {
                    files.push(content);
                }
            });
        }
        return files;
    };
    /**
     * Get the download size of a module.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<{size: number, total: boolean}>} Promise resolved with the size and a boolean indicating if it was able
     *                                                   to calculate the total size.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getDownloadSize = function (module, courseId, single) {
        var _this = this;
        return this.getFiles(module, courseId).then(function (files) {
            return _this.utils.sumFileSizes(files);
        }).catch(function () {
            return { size: -1, total: false };
        });
    };
    /**
     * Get the downloaded size of a module. If not defined, we'll use getFiles to calculate it (it can be slow).
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {number|Promise<number>} Size, or promise resolved with the size.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getDownloadedSize = function (module, courseId) {
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.getFilesSizeByComponent(siteId, this.component, module.id);
    };
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getFiles = function (module, courseId, single) {
        // To be overridden.
        return Promise.resolve([]);
    };
    /**
     * Returns module intro files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getIntroFiles = function (module, courseId, ignoreCache) {
        return Promise.resolve(this.getIntroFilesFromInstance(module));
    };
    /**
     * Returns module intro files from instance.
     *
     * @param {any} module The module object returned by WS.
     * @param {any} [instance] The instance to get the intro files (book, assign, ...). If not defined, module will be used.
     * @return {any[]} List of intro files.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getIntroFilesFromInstance = function (module, instance) {
        if (instance) {
            if (typeof instance.introfiles != 'undefined') {
                return instance.introfiles;
            }
            else if (instance.intro) {
                return this.domUtils.extractDownloadableFilesFromHtmlAsFakeFileObjects(instance.intro);
            }
        }
        if (module.description) {
            return this.domUtils.extractDownloadableFilesFromHtmlAsFakeFileObjects(module.description);
        }
        return [];
    };
    /**
     * If there's an ongoing download for a certain identifier return it.
     *
     * @param {number} id Unique identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise of the current download.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getOngoingDownload = function (id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.isDownloading(id, siteId)) {
            // There's already a download ongoing, return the promise.
            return this.downloadPromises[siteId][this.getUniqueId(id)];
        }
        return Promise.resolve();
    };
    /**
     * Create unique identifier using component and id.
     *
     * @param {number} id Unique ID inside component.
     * @return {string} Unique ID.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.getUniqueId = function (id) {
        return this.component + '#' + id;
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.invalidateContent = function (moduleId, courseId) {
        // To be overridden.
        return Promise.resolve();
    };
    /**
     * Invalidate WS calls needed to determine module status (usually, to check if module is downloadable).
     * It doesn't need to invalidate check updates. It should NOT invalidate files nor all the prefetched data.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.invalidateModule = function (module, courseId) {
        return this.courseProvider.invalidateModule(module.id);
    };
    /**
     * Check if a module can be downloaded. If the function is not defined, we assume that all modules are downloadable.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {boolean|Promise<boolean>} Whether the module can be downloaded. The promise should never be rejected.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.isDownloadable = function (module, courseId) {
        // By default, mark all instances as downloadable.
        return true;
    };
    /**
     * Check if a there's an ongoing download for the given identifier.
     *
     * @param {number} id Unique identifier per component.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean} True if downloading, false otherwise.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.isDownloading = function (id, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return !!(this.downloadPromises[siteId] && this.downloadPromises[siteId][this.getUniqueId(id)]);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a file is downloadable.
     *
     * @param {any} file File to check.
     * @return {boolean} Whether the file is downloadable.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.isFileDownloadable = function (file) {
        return file.type === 'file';
    };
    /**
     * Load module contents into module.contents if they aren't loaded already.
     *
     * @param {any} module Module to load the contents.
     * @param {number} [courseId] The course ID. Recommended to speed up the process and minimize data usage.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise}           Promise resolved when loaded.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.loadContents = function (module, courseId, ignoreCache) {
        // To be overridden.
        return Promise.resolve();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.prefetch = function (module, courseId, single, dirPath) {
        // To be overridden.
        return Promise.resolve();
    };
    /**
     * Remove module downloaded files. If not defined, we'll use getFiles to remove them (slow).
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseModulePrefetchHandlerBase.prototype.removeFiles = function (module, courseId) {
        return this.filepoolProvider.removeFilesByComponent(this.sitesProvider.getCurrentSiteId(), this.component, module.id);
    };
    return CoreCourseModulePrefetchHandlerBase;
}());

//# sourceMappingURL=module-prefetch-handler.js.map

/***/ }),
/* 774 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoicePrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__sync__ = __webpack_require__(261);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__choice__ = __webpack_require__(259);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Handler to prefetch choices.
 */
var AddonModChoicePrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModChoicePrefetchHandler, _super);
    function AddonModChoicePrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, choiceProvider, userProvider, injector) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.choiceProvider = choiceProvider;
        _this.userProvider = userProvider;
        _this.injector = injector;
        _this.name = 'AddonModChoice';
        _this.modName = 'choice';
        _this.component = __WEBPACK_IMPORTED_MODULE_11__choice__["a" /* AddonModChoiceProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^answers$/;
        return _this;
    }
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChoicePrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchChoice.bind(this));
    };
    /**
     * Prefetch a choice.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChoicePrefetchHandler.prototype.prefetchChoice = function (module, courseId, single, siteId) {
        var _this = this;
        return this.choiceProvider.getChoice(courseId, module.id, siteId, false, true).then(function (choice) {
            var promises = [];
            // Get the options and results.
            promises.push(_this.choiceProvider.getOptions(choice.id, true, siteId));
            promises.push(_this.choiceProvider.getResults(choice.id, true, siteId).then(function (options) {
                // If we can see the users that answered, prefetch their profile and avatar.
                var subPromises = [];
                options.forEach(function (option) {
                    option.userresponses.forEach(function (response) {
                        if (response.userid) {
                            subPromises.push(_this.userProvider.getProfile(response.userid, courseId, false, siteId));
                        }
                        if (response.profileimageurl) {
                            subPromises.push(_this.filepoolProvider.addToQueueByUrl(siteId, response.profileimageurl).catch(function () {
                                // Ignore failures.
                            }));
                        }
                    });
                });
                return Promise.all(subPromises);
            }));
            // Get the intro files.
            var introFiles = _this.getIntroFilesFromInstance(module, choice);
            promises.push(_this.filepoolProvider.addFilesToQueue(siteId, introFiles, __WEBPACK_IMPORTED_MODULE_11__choice__["a" /* AddonModChoiceProvider */].COMPONENT, module.id));
            return Promise.all(promises);
        });
    };
    /**
     * Returns choice intro files.
     *
     * @param  {any}    module   The module object returned by WS.
     * @param  {number} courseId Course ID.
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    AddonModChoicePrefetchHandler.prototype.getIntroFiles = function (module, courseId) {
        var _this = this;
        return this.choiceProvider.getChoice(courseId, module.id).catch(function () {
            // Not found, return undefined so module description is used.
        }).then(function (choice) {
            return _this.getIntroFilesFromInstance(module, choice);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChoicePrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.choiceProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param  {any}    module   Module.
     * @param  {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModChoicePrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        return this.choiceProvider.invalidateChoiceData(courseId);
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChoicePrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        if (!this.syncProvider) {
            this.syncProvider = this.injector.get(__WEBPACK_IMPORTED_MODULE_10__sync__["a" /* AddonModChoiceSyncProvider */]);
        }
        return this.syncProvider.syncChoice(module.instance, undefined, siteId);
    };
    AddonModChoicePrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_11__choice__["a" /* AddonModChoiceProvider */],
            __WEBPACK_IMPORTED_MODULE_9__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonModChoicePrefetchHandler);
    return AddonModChoicePrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 775 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_BLOCK_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreBlockModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_default_block_handler__ = __webpack_require__(776);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};



// List of providers (without handlers).
var CORE_BLOCK_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_delegate__["a" /* CoreBlockDelegate */]
];
var CoreBlockModule = /** @class */ (function () {
    function CoreBlockModule() {
    }
    CoreBlockModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_delegate__["a" /* CoreBlockDelegate */],
                __WEBPACK_IMPORTED_MODULE_2__providers_default_block_handler__["a" /* CoreBlockDefaultHandler */]
            ],
            exports: []
        })
    ], CoreBlockModule);
    return CoreBlockModule;
}());

//# sourceMappingURL=block.module.js.map

/***/ }),
/* 776 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBlockDefaultHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Default handler used when a block type doesn't have a specific implementation.
 */
var CoreBlockDefaultHandler = /** @class */ (function (_super) {
    __extends(CoreBlockDefaultHandler, _super);
    function CoreBlockDefaultHandler() {
        var _this = _super.call(this) || this;
        _this.name = 'CoreBlockDefault';
        _this.blockName = 'default';
        return _this;
    }
    CoreBlockDefaultHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], CoreBlockDefaultHandler);
    return CoreBlockDefaultHandler;
}(__WEBPACK_IMPORTED_MODULE_1__classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=default-block-handler.js.map

/***/ }),
/* 777 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_CONTENTLINKS_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreContentLinksModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(19);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};



// List of providers.
var CORE_CONTENTLINKS_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_delegate__["a" /* CoreContentLinksDelegate */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreContentLinksHelperProvider */]
];
var CoreContentLinksModule = /** @class */ (function () {
    function CoreContentLinksModule() {
    }
    CoreContentLinksModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: CORE_CONTENTLINKS_PROVIDERS,
            exports: []
        })
    ], CoreContentLinksModule);
    return CoreContentLinksModule;
}());

//# sourceMappingURL=contentlinks.module.js.map

/***/ }),
/* 778 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_COURSE_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreCourseModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_log_helper__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_format_delegate__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_course_offline__ = __webpack_require__(253);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_default_format__ = __webpack_require__(746);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_default_module__ = __webpack_require__(758);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__formats_singleactivity_singleactivity_module__ = __webpack_require__(1433);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__formats_social_social_module__ = __webpack_require__(1434);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__formats_topics_topics_module__ = __webpack_require__(1436);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__formats_weeks_weeks_module__ = __webpack_require__(1438);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_sync__ = __webpack_require__(352);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_sync_cron_handler__ = __webpack_require__(1440);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__providers_log_cron_handler__ = __webpack_require__(1441);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





















// List of providers (without handlers).
var CORE_COURSE_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_4__providers_course__["a" /* CoreCourseProvider */],
    __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* CoreCourseHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_6__providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_7__providers_format_delegate__["a" /* CoreCourseFormatDelegate */],
    __WEBPACK_IMPORTED_MODULE_8__providers_module_delegate__["a" /* CoreCourseModuleDelegate */],
    __WEBPACK_IMPORTED_MODULE_10__providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
    __WEBPACK_IMPORTED_MODULE_11__providers_options_delegate__["a" /* CoreCourseOptionsDelegate */],
    __WEBPACK_IMPORTED_MODULE_9__providers_course_offline__["a" /* CoreCourseOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_18__providers_sync__["a" /* CoreCourseSyncProvider */]
];
var CoreCourseModule = /** @class */ (function () {
    function CoreCourseModule(cronDelegate, syncHandler, logHandler, platform, eventsProvider) {
        cronDelegate.register(syncHandler);
        cronDelegate.register(logHandler);
        platform.resume.subscribe(function () {
            // Log the app is open to keep user in online status.
            setTimeout(function () {
                cronDelegate.forceCronHandlerExecution(logHandler.name);
            }, 1000);
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].LOGIN, function () {
            // Log the app is open to keep user in online status.
            setTimeout(function () {
                cronDelegate.forceCronHandlerExecution(logHandler.name);
            }, 1000);
        });
    }
    CoreCourseModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_14__formats_singleactivity_singleactivity_module__["a" /* CoreCourseFormatSingleActivityModule */],
                __WEBPACK_IMPORTED_MODULE_16__formats_topics_topics_module__["a" /* CoreCourseFormatTopicsModule */],
                __WEBPACK_IMPORTED_MODULE_17__formats_weeks_weeks_module__["a" /* CoreCourseFormatWeeksModule */],
                __WEBPACK_IMPORTED_MODULE_15__formats_social_social_module__["a" /* CoreCourseFormatSocialModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_course__["a" /* CoreCourseProvider */],
                __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* CoreCourseHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_log_helper__["a" /* CoreCourseLogHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_format_delegate__["a" /* CoreCourseFormatDelegate */],
                __WEBPACK_IMPORTED_MODULE_8__providers_module_delegate__["a" /* CoreCourseModuleDelegate */],
                __WEBPACK_IMPORTED_MODULE_10__providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
                __WEBPACK_IMPORTED_MODULE_11__providers_options_delegate__["a" /* CoreCourseOptionsDelegate */],
                __WEBPACK_IMPORTED_MODULE_9__providers_course_offline__["a" /* CoreCourseOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_18__providers_sync__["a" /* CoreCourseSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_12__providers_default_format__["a" /* CoreCourseFormatDefaultHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_default_module__["a" /* CoreCourseModuleDefaultHandler */],
                __WEBPACK_IMPORTED_MODULE_19__providers_sync_cron_handler__["a" /* CoreCourseSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_20__providers_log_cron_handler__["a" /* CoreCourseLogCronHandler */]
            ],
            exports: []
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_19__providers_sync_cron_handler__["a" /* CoreCourseSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_20__providers_log_cron_handler__["a" /* CoreCourseLogCronHandler */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreCourseModule);
    return CoreCourseModule;
}());

//# sourceMappingURL=course.module.js.map

/***/ }),
/* 779 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatSingleActivityHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_singleactivity__ = __webpack_require__(354);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support singleactivity course format.
 */
var CoreCourseFormatSingleActivityHandler = /** @class */ (function () {
    function CoreCourseFormatSingleActivityHandler(moduleDelegate) {
        this.moduleDelegate = moduleDelegate;
        this.name = 'CoreCourseFormatSingleActivity';
        this.format = 'singleactivity';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreCourseFormatSingleActivityHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether it allows seeing all sections at the same time. Defaults to true.
     *
     * @param {any} course The course to check.
     * @type {boolean} Whether it can view all sections.
     */
    CoreCourseFormatSingleActivityHandler.prototype.canViewAllSections = function (course) {
        return false;
    };
    /**
     * Get the title to use in course page. If not defined, course displayname or fullname.
     * This function will be called without sections first, and then call it again when the sections are retrieved.
     *
     * @param {any} course The course.
     * @param {any[]} [sections] List of sections.
     * @return {string} Title.
     */
    CoreCourseFormatSingleActivityHandler.prototype.getCourseTitle = function (course, sections) {
        if (sections && sections[0] && sections[0].modules && sections[0].modules[0]) {
            return sections[0].modules[0].name;
        }
        if (course.displayname) {
            return course.displayname;
        }
        else if (course.fullname) {
            return course.fullname;
        }
        else {
            return '';
        }
    };
    /**
     * Whether the option to enable section/module download should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @return {boolean} Whether the option to enable section/module download should be displayed
     */
    CoreCourseFormatSingleActivityHandler.prototype.displayEnableDownload = function (course) {
        return false;
    };
    /**
     * Whether the default section selector should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @type {boolean} Whether the default section selector should be displayed.
     */
    CoreCourseFormatSingleActivityHandler.prototype.displaySectionSelector = function (course) {
        return false;
    };
    /**
     * Whether the course refresher should be displayed. If it returns false, a refresher must be included in the course format,
     * and the doRefresh method of CoreCourseSectionPage must be called on refresh. Defaults to true.
     *
     * @param {any} course The course to check.
     * @param {any[]} sections List of course sections.
     * @return {boolean} Whether the refresher should be displayed.
     */
    CoreCourseFormatSingleActivityHandler.prototype.displayRefresher = function (course, sections) {
        if (sections && sections[0] && sections[0].modules && sections[0].modules[0]) {
            return this.moduleDelegate.displayRefresherInSingleActivity(sections[0].modules[0].modname);
        }
        else {
            return true;
        }
    };
    /**
     * Return the Component to use to display the course format instead of using the default one.
     * Use it if you want to display a format completely different from the default one.
     * If you want to customize the default format there are several methods to customize parts of it.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreCourseFormatSingleActivityHandler.prototype.getCourseFormatComponent = function (injector, course) {
        return __WEBPACK_IMPORTED_MODULE_2__components_singleactivity__["a" /* CoreCourseFormatSingleActivityComponent */];
    };
    /**
     * Whether the view should be refreshed when completion changes. If your course format doesn't display
     * activity completion then you should return false.
     *
     * @param {any} course The course.
     * @return {boolean|Promise<boolean>} Whether course view should be refreshed when an activity completion changes.
     */
    CoreCourseFormatSingleActivityHandler.prototype.shouldRefreshWhenCompletionChanges = function (course) {
        return false;
    };
    CoreCourseFormatSingleActivityHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_module_delegate__["a" /* CoreCourseModuleDelegate */]])
    ], CoreCourseFormatSingleActivityHandler);
    return CoreCourseFormatSingleActivityHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 780 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_COURSES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreCoursesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(179);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__ = __webpack_require__(781);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_dashboard__ = __webpack_require__(284);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_course_link_handler__ = __webpack_require__(1442);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_courses_index_link_handler__ = __webpack_require__(1443);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_dashboard_link_handler__ = __webpack_require__(1444);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_enrol_push_click_handler__ = __webpack_require__(1445);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_request_push_click_handler__ = __webpack_require__(1446);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













// List of providers (without handlers).
var CORE_COURSES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_courses__["a" /* CoreCoursesProvider */],
    __WEBPACK_IMPORTED_MODULE_4__providers_dashboard__["a" /* CoreCoursesDashboardProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreCoursesHelperProvider */]
];
var CoreCoursesModule = /** @class */ (function () {
    function CoreCoursesModule(mainMenuDelegate, contentLinksDelegate, mainMenuHandler, courseLinkHandler, indexLinkHandler, dashboardLinkHandler, pushNotificationsDelegate, enrolPushClickHandler, requestPushClickHandler) {
        mainMenuDelegate.registerHandler(mainMenuHandler);
        contentLinksDelegate.registerHandler(courseLinkHandler);
        contentLinksDelegate.registerHandler(indexLinkHandler);
        contentLinksDelegate.registerHandler(dashboardLinkHandler);
        pushNotificationsDelegate.registerClickHandler(enrolPushClickHandler);
        pushNotificationsDelegate.registerClickHandler(requestPushClickHandler);
    }
    CoreCoursesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_courses__["a" /* CoreCoursesProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_dashboard__["a" /* CoreCoursesDashboardProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreCoursesHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* CoreDashboardMainMenuHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_course_link_handler__["a" /* CoreCoursesCourseLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_courses_index_link_handler__["a" /* CoreCoursesIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_dashboard_link_handler__["a" /* CoreCoursesDashboardLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_enrol_push_click_handler__["a" /* CoreCoursesEnrolPushClickHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_request_push_click_handler__["a" /* CoreCoursesRequestPushClickHandler */]
            ],
            exports: []
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_10__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_11__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */],
            __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* CoreDashboardMainMenuHandler */], __WEBPACK_IMPORTED_MODULE_5__providers_course_link_handler__["a" /* CoreCoursesCourseLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_6__providers_courses_index_link_handler__["a" /* CoreCoursesIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_7__providers_dashboard_link_handler__["a" /* CoreCoursesDashboardLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_12__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_8__providers_enrol_push_click_handler__["a" /* CoreCoursesEnrolPushClickHandler */],
            __WEBPACK_IMPORTED_MODULE_9__providers_request_push_click_handler__["a" /* CoreCoursesRequestPushClickHandler */]])
    ], CoreCoursesModule);
    return CoreCoursesModule;
}());

//# sourceMappingURL=courses.module.js.map

/***/ }),
/* 781 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDashboardMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_dashboard__ = __webpack_require__(284);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_sitehome_providers_sitehome__ = __webpack_require__(171);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__addon_block_timeline_providers_timeline__ = __webpack_require__(262);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__ = __webpack_require__(88);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Handler to add Dashboard into main menu.
 */
var CoreDashboardMainMenuHandler = /** @class */ (function () {
    function CoreDashboardMainMenuHandler(coursesProvider, dashboardProvider, siteHomeProvider, timelineProvider, blockDelegate, sitesProvider) {
        this.coursesProvider = coursesProvider;
        this.dashboardProvider = dashboardProvider;
        this.siteHomeProvider = siteHomeProvider;
        this.timelineProvider = timelineProvider;
        this.blockDelegate = blockDelegate;
        this.sitesProvider = sitesProvider;
        this.name = 'CoreHome'; // This handler contains several different features, so we use a generic name like "CoreHome".
        this.priority = 1100;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean | Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    CoreDashboardMainMenuHandler.prototype.isEnabled = function () {
        return this.isEnabledForSite();
    };
    /**
     * Check if the handler is enabled on a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean | Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    CoreDashboardMainMenuHandler.prototype.isEnabledForSite = function (siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        var blocksEnabled, dashboardAvailable;
        // Check if blocks and 3.6 dashboard is enabled.
        promises.push(this.blockDelegate.areBlocksDisabled(siteId).then(function (disabled) {
            blocksEnabled = !disabled;
        }));
        promises.push(this.dashboardProvider.isAvailable().then(function (available) {
            dashboardAvailable = available;
        }));
        // Check if 3.6 dashboard is enabled.
        return Promise.all(promises).then(function () {
            if (dashboardAvailable && blocksEnabled) {
                return true;
            }
            // Check if my overview is enabled.
            return _this.timelineProvider.isAvailable().then(function (enabled) {
                if (enabled && blocksEnabled) {
                    return true;
                }
                return _this.siteHomeProvider.isAvailable().then(function (enabled) {
                    // Show in case siteHome is enabled.
                    if (enabled) {
                        return true;
                    }
                    // My overview not enabled, check if my courses is enabled.
                    return !_this.coursesProvider.isMyCoursesDisabledInSite();
                });
            });
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data needed to render the handler.
     */
    CoreDashboardMainMenuHandler.prototype.getDisplayData = function () {
        return {
            icon: 'home',
            title: 'core.courses.mymoodle',
            page: 'CoreCoursesDashboardPage',
            class: 'core-dashboard-handler'
        };
    };
    CoreDashboardMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_dashboard__["a" /* CoreCoursesDashboardProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_sitehome_providers_sitehome__["a" /* CoreSiteHomeProvider */], __WEBPACK_IMPORTED_MODULE_5__addon_block_timeline_providers_timeline__["a" /* AddonBlockTimelineProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreDashboardMainMenuHandler);
    return CoreDashboardMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 782 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_FILEUPLOADER_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreFileUploaderModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(122);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_delegate__ = __webpack_require__(348);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_album_handler__ = __webpack_require__(1447);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_audio_handler__ = __webpack_require__(1448);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_camera_handler__ = __webpack_require__(1449);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_file_handler__ = __webpack_require__(1450);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_video_handler__ = __webpack_require__(1451);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









// List of providers (without handlers).
var CORE_FILEUPLOADER_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_fileuploader__["a" /* CoreFileUploaderProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreFileUploaderHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_3__providers_delegate__["a" /* CoreFileUploaderDelegate */]
];
var CoreFileUploaderModule = /** @class */ (function () {
    function CoreFileUploaderModule(delegate, albumHandler, audioHandler, cameraHandler, videoHandler, fileHandler) {
        delegate.registerHandler(albumHandler);
        delegate.registerHandler(audioHandler);
        delegate.registerHandler(cameraHandler);
        delegate.registerHandler(fileHandler);
        delegate.registerHandler(videoHandler);
    }
    CoreFileUploaderModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_fileuploader__["a" /* CoreFileUploaderProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreFileUploaderHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_delegate__["a" /* CoreFileUploaderDelegate */],
                __WEBPACK_IMPORTED_MODULE_4__providers_album_handler__["a" /* CoreFileUploaderAlbumHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_audio_handler__["a" /* CoreFileUploaderAudioHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_camera_handler__["a" /* CoreFileUploaderCameraHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_file_handler__["a" /* CoreFileUploaderFileHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_video_handler__["a" /* CoreFileUploaderVideoHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_delegate__["a" /* CoreFileUploaderDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_album_handler__["a" /* CoreFileUploaderAlbumHandler */],
            __WEBPACK_IMPORTED_MODULE_5__providers_audio_handler__["a" /* CoreFileUploaderAudioHandler */], __WEBPACK_IMPORTED_MODULE_6__providers_camera_handler__["a" /* CoreFileUploaderCameraHandler */],
            __WEBPACK_IMPORTED_MODULE_8__providers_video_handler__["a" /* CoreFileUploaderVideoHandler */], __WEBPACK_IMPORTED_MODULE_7__providers_file_handler__["a" /* CoreFileUploaderFileHandler */]])
    ], CoreFileUploaderModule);
    return CoreFileUploaderModule;
}());

//# sourceMappingURL=fileuploader.module.js.map

/***/ }),
/* 783 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_GRADES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreGradesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_mainmenu_handler__ = __webpack_require__(1452);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_course_option_handler__ = __webpack_require__(1453);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(979);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_user_link_handler__ = __webpack_require__(1454);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_overview_link_handler__ = __webpack_require__(1455);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_user_handler__ = __webpack_require__(1456);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_user_providers_user__ = __webpack_require__(26);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















// List of providers (without handlers).
var CORE_GRADES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_grades__["a" /* CoreGradesProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreGradesHelperProvider */]
];
var CoreGradesModule = /** @class */ (function () {
    function CoreGradesModule(mainMenuDelegate, gradesMenuHandler, courseOptionHandler, courseOptionsDelegate, contentLinksDelegate, userLinkHandler, overviewLinkHandler, userHandler, userDelegate, eventsProvider, sitesProvider) {
        // Register handlers.
        mainMenuDelegate.registerHandler(gradesMenuHandler);
        courseOptionsDelegate.registerHandler(courseOptionHandler);
        contentLinksDelegate.registerHandler(userLinkHandler);
        contentLinksDelegate.registerHandler(overviewLinkHandler);
        userDelegate.registerHandler(userHandler);
        // Clear user profile handler cache.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_15__core_user_providers_user__["a" /* CoreUserProvider */].PROFILE_REFRESHED, function (data) {
            userHandler.clearViewGradesCache(data.courseId, data.userId);
        }, sitesProvider.getCurrentSiteId());
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_13__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function () {
            userHandler.clearViewGradesCache();
        }, sitesProvider.getCurrentSiteId());
    }
    CoreGradesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreGradesComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_grades__["a" /* CoreGradesProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreGradesHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_mainmenu_handler__["a" /* CoreGradesMainMenuHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_course_option_handler__["a" /* CoreGradesCourseOptionHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_user_link_handler__["a" /* CoreGradesUserLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_overview_link_handler__["a" /* CoreGradesOverviewLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_user_handler__["a" /* CoreGradesUserHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_mainmenu_handler__["a" /* CoreGradesMainMenuHandler */],
            __WEBPACK_IMPORTED_MODULE_5__providers_course_option_handler__["a" /* CoreGradesCourseOptionHandler */], __WEBPACK_IMPORTED_MODULE_7__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */],
            __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_8__providers_user_link_handler__["a" /* CoreGradesUserLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_9__providers_overview_link_handler__["a" /* CoreGradesOverviewLinkHandler */], __WEBPACK_IMPORTED_MODULE_11__providers_user_handler__["a" /* CoreGradesUserHandler */],
            __WEBPACK_IMPORTED_MODULE_12__core_user_providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_13__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_14__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreGradesModule);
    return CoreGradesModule;
}());

//# sourceMappingURL=grades.module.js.map

/***/ }),
/* 784 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesCourseComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_split_view_split_view__ = __webpack_require__(121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};







/**
 * Component that displays a course grades.
 */
var CoreGradesCourseComponent = /** @class */ (function () {
    function CoreGradesCourseComponent(gradesProvider, domUtils, navParams, gradesHelper, navCtrl, appProvider, svComponent) {
        this.gradesProvider = gradesProvider;
        this.domUtils = domUtils;
        this.gradesHelper = gradesHelper;
        this.navCtrl = navCtrl;
        this.appProvider = appProvider;
        this.svComponent = svComponent;
        this.gradesLoaded = false;
    }
    /**
     * View loaded.
     */
    CoreGradesCourseComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.fetchData().then(function () {
            if (_this.gradeId) {
                // There is the grade to load.
                _this.gotoGrade(_this.gradeId);
            }
            // Add log in Moodle.
            return _this.gradesProvider.logCourseGradesView(_this.courseId, _this.userId).catch(function () {
                // Ignore errors.
            });
        }).finally(function () {
            _this.gradesLoaded = true;
        });
    };
    /**
     * Fetch all the data required for the view.
     *
     * @param {boolean} [refresh] Empty events array first.
     * @return {Promise<any>}     Resolved when done.
     */
    CoreGradesCourseComponent.prototype.fetchData = function (refresh) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        return this.gradesProvider.getCourseGradesTable(this.courseId, this.userId).then(function (table) {
            _this.gradesTable = _this.gradesHelper.formatGradesTable(table);
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'Error loading grades');
        });
    };
    /**
     * Refresh data.
     *
     * @param {any} refresher Refresher.
     */
    CoreGradesCourseComponent.prototype.refreshGrades = function (refresher) {
        var _this = this;
        this.gradesProvider.invalidateCourseGradesData(this.courseId, this.userId).finally(function () {
            _this.fetchData().finally(function () {
                refresher.complete();
            });
        });
    };
    /**
     * Navigate to the grade of the selected item.
     * @param {number} gradeId  Grade item ID where to navigate.
     */
    CoreGradesCourseComponent.prototype.gotoGrade = function (gradeId) {
        if (gradeId) {
            this.gradeId = gradeId;
            var whereToPush = void 0, pageName = void 0;
            if (this.svComponent) {
                if (this.svComponent.getMasterNav().getActive().component.name == 'CoreGradesCourseSplitPage') {
                    // Table is on left side. Push on right.
                    whereToPush = this.svComponent;
                    pageName = 'CoreGradesGradePage';
                }
                else {
                    // Table is on right side. Load new split view.
                    whereToPush = this.svComponent.getMasterNav();
                    pageName = 'CoreGradesCourseSplitPage';
                }
            }
            else {
                if (this.appProvider.isWide()) {
                    // Table is full screen and large. Load here.
                    whereToPush = this.navCtrl;
                    pageName = 'CoreGradesCourseSplitPage';
                }
                else {
                    // Table is full screen but on mobile. Load here.
                    whereToPush = this.navCtrl;
                    pageName = 'CoreGradesGradePage';
                }
            }
            whereToPush.push(pageName, { courseId: this.courseId, userId: this.userId, gradeId: gradeId });
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */])
    ], CoreGradesCourseComponent.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreGradesCourseComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreGradesCourseComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreGradesCourseComponent.prototype, "gradeId", void 0);
    CoreGradesCourseComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-grades-course',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\grades\components\course\core-grades-course.html"*/'<ion-content>\n    <ion-refresher [enabled]="gradesLoaded" (ionRefresh)="refreshGrades($event)">\n        <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n    </ion-refresher>\n    <core-loading [hideUntil]="gradesLoaded">\n        <core-empty-box *ngIf="!gradesTable" icon="stats" [message]="\'core.grades.nogradesreturned\' | translate">\n        </core-empty-box>\n\n        <div *ngIf="gradesTable" class="core-grades-container safe-area-page">\n            <table cellspacing="0" cellpadding="0" class="core-grades-table">\n                <thead>\n                    <tr>\n                        <th *ngFor="let column of gradesTable.columns" id="{{column.name}}" [class.hidden-phone]="column.hiddenPhone" [attr.colspan]="column.colspan" text-start>\n                            {{ \'core.grades.\' + column.name | translate }}\n                        </th>\n                    </tr>\n                </thead>\n                <tbody>\n                    <tr *ngFor="let row of gradesTable.rows" (click)="row.itemtype != \'category\' && gotoGrade(row.id)" [class]="row.rowclass">\n                        <ng-container *ngIf="row.itemtype">\n                            <td *ngIf="row.itemtype == \'category\'" class="core-grades-table-category" [attr.rowspan]="row.rowspan">\n                            </td>\n                            <th class="core-grades-table-gradeitem" [class.column-itemname]="row.itemtype == \'category\'" [attr.colspan]="row.colspan" [class.core-split-item-selected]="gradeId == row.id" text-start>\n                                <core-icon *ngIf="row.icon" name="{{row.icon}}" item-start></core-icon>\n                                <img *ngIf="row.image" [src]="row.image" item-start/>\n                                <span [innerHTML]="row.gradeitem"></span>\n                            </th>\n                            <ng-container *ngFor="let column of gradesTable.columns">\n                                <td *ngIf="column.name != \'gradeitem\' && row[column.name] != undefined" [class]="\'core-grades-table-\' + column.name" [innerHTML]="row[column.name]" [class.hidden-phone]="column.hiddenPhone" text-start>\n                                </td>\n                            </ng-container>\n                        </ng-container>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n    </core-loading>\n</ion-content>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\grades\components\course\core-grades-course.html"*/,
        }),
        __param(4, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __param(6, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_grades__["a" /* CoreGradesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_4__providers_helper__["a" /* CoreGradesHelperProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_5__components_split_view_split_view__["a" /* CoreSplitViewComponent */]])
    ], CoreGradesCourseComponent);
    return CoreGradesCourseComponent;
}());

//# sourceMappingURL=course.js.map

/***/ }),
/* 785 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_LOGIN_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreLoginModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_helper__ = __webpack_require__(52);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


// List of providers.
var CORE_LOGIN_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_helper__["a" /* CoreLoginHelperProvider */]
];
var CoreLoginModule = /** @class */ (function () {
    function CoreLoginModule() {
    }
    CoreLoginModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: CORE_LOGIN_PROVIDERS
        })
    ], CoreLoginModule);
    return CoreLoginModule;
}());

//# sourceMappingURL=login.module.js.map

/***/ }),
/* 786 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_MAINMENU_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreMainMenuModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_mainmenu__ = __webpack_require__(980);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};



// List of providers.
var CORE_MAINMENU_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_delegate__["a" /* CoreMainMenuDelegate */],
    __WEBPACK_IMPORTED_MODULE_2__providers_mainmenu__["a" /* CoreMainMenuProvider */]
];
var CoreMainMenuModule = /** @class */ (function () {
    function CoreMainMenuModule() {
    }
    CoreMainMenuModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: CORE_MAINMENU_PROVIDERS
        })
    ], CoreMainMenuModule);
    return CoreMainMenuModule;
}());

//# sourceMappingURL=mainmenu.module.js.map

/***/ }),
/* 787 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_QUESTION_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreQuestionModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_behaviour_delegate__ = __webpack_require__(77);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_default_question_handler__ = __webpack_require__(788);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_default_behaviour_handler__ = __webpack_require__(790);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};







// List of providers (without handlers).
var CORE_QUESTION_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_question__["a" /* CoreQuestionProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_delegate__["a" /* CoreQuestionDelegate */],
    __WEBPACK_IMPORTED_MODULE_3__providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */],
    __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* CoreQuestionHelperProvider */]
];
var CoreQuestionModule = /** @class */ (function () {
    function CoreQuestionModule() {
    }
    CoreQuestionModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_question__["a" /* CoreQuestionProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_delegate__["a" /* CoreQuestionDelegate */],
                __WEBPACK_IMPORTED_MODULE_3__providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */],
                __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* CoreQuestionHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_default_question_handler__["a" /* CoreQuestionDefaultHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_default_behaviour_handler__["a" /* CoreQuestionBehaviourDefaultHandler */]
            ],
            exports: []
        })
    ], CoreQuestionModule);
    return CoreQuestionModule;
}());

//# sourceMappingURL=question.module.js.map

/***/ }),
/* 788 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionDefaultHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_base_question_handler__ = __webpack_require__(789);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Default handler used when the question type doesn't have a specific implementation.
 */
var CoreQuestionDefaultHandler = /** @class */ (function (_super) {
    __extends(CoreQuestionDefaultHandler, _super);
    function CoreQuestionDefaultHandler() {
        var _this = _super.call(this) || this;
        _this.name = 'CoreQuestionDefault';
        _this.type = 'default';
        return _this;
    }
    CoreQuestionDefaultHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], CoreQuestionDefaultHandler);
    return CoreQuestionDefaultHandler;
}(__WEBPACK_IMPORTED_MODULE_1__classes_base_question_handler__["a" /* CoreQuestionBaseHandler */]));

//# sourceMappingURL=default-question-handler.js.map

/***/ }),
/* 789 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionBaseHandler; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base handler for question types.
 *
 * This class is needed because parent classes cannot have @Injectable in Angular v6, so the default handler cannot be a
 * parent class.
 */
var CoreQuestionBaseHandler = /** @class */ (function () {
    function CoreQuestionBaseHandler() {
        this.name = 'CoreQuestionBase';
        this.type = 'base';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreQuestionBaseHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreQuestionBaseHandler.prototype.getComponent = function (injector, question) {
        // There is no default component for questions.
    };
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    CoreQuestionBaseHandler.prototype.getBehaviour = function (question, behaviour) {
        return behaviour;
    };
    /**
     * Check if a question can be submitted.
     * If a question cannot be submitted it should return a message explaining why (translated or not).
     *
     * @param {any} question The question.
     * @return {string} Prevent submit message. Undefined or empty if can be submitted.
     */
    CoreQuestionBaseHandler.prototype.getPreventSubmitMessage = function (question) {
        // Never prevent by default.
        return '';
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    CoreQuestionBaseHandler.prototype.isCompleteResponse = function (question, answers) {
        return -1;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    CoreQuestionBaseHandler.prototype.isGradableResponse = function (question, answers) {
        return -1;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    CoreQuestionBaseHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return false;
    };
    /**
     * Prepare and add to answers the data to send to server based in the input. Return promise if async.
     *
     * @param {any} question Question.
     * @param {any} answers The answers retrieved from the form. Prepared answers must be stored in this object.
     * @param {boolean} [offline] Whether the data should be saved in offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Return a promise resolved when done if async, void if sync.
     */
    CoreQuestionBaseHandler.prototype.prepareAnswers = function (question, answers, offline, siteId) {
        // Nothing to do.
    };
    /**
     * Validate if an offline sequencecheck is valid compared with the online one.
     * This function only needs to be implemented if a specific compare is required.
     *
     * @param {any} question The question.
     * @param {string} offlineSequenceCheck Sequence check stored in offline.
     * @return {boolean} Whether sequencecheck is valid.
     */
    CoreQuestionBaseHandler.prototype.validateSequenceCheck = function (question, offlineSequenceCheck) {
        return question.sequencecheck == offlineSequenceCheck;
    };
    return CoreQuestionBaseHandler;
}());

//# sourceMappingURL=base-question-handler.js.map

/***/ }),
/* 790 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionBehaviourDefaultHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_base_behaviour_handler__ = __webpack_require__(791);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_question__ = __webpack_require__(76);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Default handler used when the question behaviour doesn't have a specific implementation.
 */
var CoreQuestionBehaviourDefaultHandler = /** @class */ (function (_super) {
    __extends(CoreQuestionBehaviourDefaultHandler, _super);
    function CoreQuestionBehaviourDefaultHandler(questionProvider) {
        var _this = _super.call(this, questionProvider) || this;
        _this.questionProvider = questionProvider;
        _this.name = 'CoreQuestionBehaviourDefault';
        _this.type = 'default';
        return _this;
    }
    CoreQuestionBehaviourDefaultHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], CoreQuestionBehaviourDefaultHandler);
    return CoreQuestionBehaviourDefaultHandler;
}(__WEBPACK_IMPORTED_MODULE_1__classes_base_behaviour_handler__["a" /* CoreQuestionBehaviourBaseHandler */]));

//# sourceMappingURL=default-behaviour-handler.js.map

/***/ }),
/* 791 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionBehaviourBaseHandler; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Base handler for question behaviours.
 *
 * This class is needed because parent classes cannot have @Injectable in Angular v6, so the default handler cannot be a
 * parent class.
 */
var CoreQuestionBehaviourBaseHandler = /** @class */ (function () {
    function CoreQuestionBehaviourBaseHandler(questionProvider) {
        this.questionProvider = questionProvider;
        this.name = 'CoreQuestionBehaviourBase';
        this.type = 'base';
    }
    /**
     * Determine a question new state based on its answer(s).
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {CoreQuestionState|Promise<CoreQuestionState>} New state (or promise resolved with state).
     */
    CoreQuestionBehaviourBaseHandler.prototype.determineNewState = function (component, attemptId, question, siteId) {
        // Return the current state.
        return this.questionProvider.getState(question.state);
    };
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    CoreQuestionBehaviourBaseHandler.prototype.handleQuestion = function (injector, question) {
        // Nothing to do.
        return;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreQuestionBehaviourBaseHandler.prototype.isEnabled = function () {
        return true;
    };
    return CoreQuestionBehaviourBaseHandler;
}());

//# sourceMappingURL=base-behaviour-handler.js.map

/***/ }),
/* 792 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_SHAREDFILES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreSharedFilesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sharedfiles__ = __webpack_require__(426);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_helper__ = __webpack_require__(427);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_upload_handler__ = __webpack_require__(1457);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_delegate__ = __webpack_require__(348);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_events__ = __webpack_require__(12);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







// List of providers (without handlers).
var CORE_SHAREDFILES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_2__providers_sharedfiles__["a" /* CoreSharedFilesProvider */],
    __WEBPACK_IMPORTED_MODULE_3__providers_helper__["a" /* CoreSharedFilesHelperProvider */]
];
var CoreSharedFilesModule = /** @class */ (function () {
    function CoreSharedFilesModule(platform, delegate, handler, helper, eventsProvider) {
        // Register the handler.
        delegate.registerHandler(handler);
        if (platform.is('ios')) {
            var lastCheck_1 = 0;
            // Check if there are new files at app start and when the app is resumed.
            helper.searchIOSNewSharedFiles();
            platform.resume.subscribe(function () {
                // Wait a bit to make sure that APP_LAUNCHED_URL is treated before this callback.
                setTimeout(function () {
                    if (Date.now() - lastCheck_1 < 1000) {
                        // Last check less than 1s ago, don't do anything.
                        return;
                    }
                    lastCheck_1 = Date.now();
                    helper.searchIOSNewSharedFiles();
                }, 200);
            });
            eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */].APP_LAUNCHED_URL, function (url) {
                if (url && url.indexOf('file://') === 0) {
                    // We received a file in iOS, it's probably a shared file. Treat it.
                    lastCheck_1 = Date.now();
                    helper.searchIOSNewSharedFiles(url);
                }
            });
        }
    }
    CoreSharedFilesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_sharedfiles__["a" /* CoreSharedFilesProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_helper__["a" /* CoreSharedFilesHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_upload_handler__["a" /* CoreSharedFilesUploadHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_delegate__["a" /* CoreFileUploaderDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_upload_handler__["a" /* CoreSharedFilesUploadHandler */],
            __WEBPACK_IMPORTED_MODULE_3__providers_helper__["a" /* CoreSharedFilesHelperProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreSharedFilesModule);
    return CoreSharedFilesModule;
}());

//# sourceMappingURL=sharedfiles.module.js.map

/***/ }),
/* 793 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_SITEHOME_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreSiteHomeModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sitehome__ = __webpack_require__(171);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_index_link_handler__ = __webpack_require__(1458);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_delegate__ = __webpack_require__(36);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




// List of providers (without handlers).
var CORE_SITEHOME_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_sitehome__["a" /* CoreSiteHomeProvider */]
];
var CoreSiteHomeModule = /** @class */ (function () {
    function CoreSiteHomeModule(contentLinksDelegate, indexLinkHandler) {
        contentLinksDelegate.registerHandler(indexLinkHandler);
    }
    CoreSiteHomeModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_sitehome__["a" /* CoreSiteHomeProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_index_link_handler__["a" /* CoreSiteHomeIndexLinkHandler */]
            ],
            exports: []
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_index_link_handler__["a" /* CoreSiteHomeIndexLinkHandler */]])
    ], CoreSiteHomeModule);
    return CoreSiteHomeModule;
}());

//# sourceMappingURL=sitehome.module.js.map

/***/ }),
/* 794 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_USER_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CoreUserModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_helper__ = __webpack_require__(981);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_user_handler__ = __webpack_require__(1459);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_user_link_handler__ = __webpack_require__(1460);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_course_option_handler__ = __webpack_require__(1461);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_participants_link_handler__ = __webpack_require__(1462);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_components_module__ = __webpack_require__(415);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_offline__ = __webpack_require__(349);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_sync__ = __webpack_require__(796);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_sync_cron_handler__ = __webpack_require__(1464);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















// List of providers (without handlers).
var CORE_USER_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_user_delegate__["a" /* CoreUserDelegate */],
    __WEBPACK_IMPORTED_MODULE_2__providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */],
    __WEBPACK_IMPORTED_MODULE_3__providers_user__["a" /* CoreUserProvider */],
    __WEBPACK_IMPORTED_MODULE_4__providers_helper__["a" /* CoreUserHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_15__providers_offline__["a" /* CoreUserOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_16__providers_sync__["a" /* CoreUserSyncProvider */]
];
var CoreUserModule = /** @class */ (function () {
    function CoreUserModule(userDelegate, userProfileMailHandler, eventsProvider, sitesProvider, userProvider, contentLinksDelegate, userLinkHandler, courseOptionHandler, linkHandler, courseOptionsDelegate, cronDelegate, syncHandler) {
        userDelegate.registerHandler(userProfileMailHandler);
        courseOptionsDelegate.registerHandler(courseOptionHandler);
        contentLinksDelegate.registerHandler(userLinkHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        cronDelegate.register(syncHandler);
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */].USER_DELETED, function (data) {
            // Search for userid in params.
            var params = data.params;
            var userId = 0;
            if (params.userid) {
                userId = params.userid;
            }
            else if (params.userids) {
                userId = params.userids[0];
            }
            else if (params.field === 'id' && params.values && params.values.length) {
                userId = params.values[0];
            }
            else if (params.userlist && params.userlist.length) {
                userId = params.userlist[0].userid;
            }
            if (userId > 0) {
                userProvider.deleteStoredUser(userId, data.siteId);
            }
        }, sitesProvider.getCurrentSiteId());
    }
    CoreUserModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_13__components_components_module__["a" /* CoreUserComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_user_delegate__["a" /* CoreUserDelegate */],
                __WEBPACK_IMPORTED_MODULE_2__providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */],
                __WEBPACK_IMPORTED_MODULE_3__providers_user__["a" /* CoreUserProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_helper__["a" /* CoreUserHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_15__providers_offline__["a" /* CoreUserOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_16__providers_sync__["a" /* CoreUserSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_5__providers_user_handler__["a" /* CoreUserProfileMailHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_user_link_handler__["a" /* CoreUserProfileLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_course_option_handler__["a" /* CoreUserParticipantsCourseOptionHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_participants_link_handler__["a" /* CoreUserParticipantsLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_17__providers_sync_cron_handler__["a" /* CoreUserSyncCronHandler */],
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_user_handler__["a" /* CoreUserProfileMailHandler */],
            __WEBPACK_IMPORTED_MODULE_6__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_user_link_handler__["a" /* CoreUserProfileLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_10__providers_course_option_handler__["a" /* CoreUserParticipantsCourseOptionHandler */], __WEBPACK_IMPORTED_MODULE_11__providers_participants_link_handler__["a" /* CoreUserParticipantsLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_14__providers_cron__["a" /* CoreCronDelegate */],
            __WEBPACK_IMPORTED_MODULE_17__providers_sync_cron_handler__["a" /* CoreUserSyncCronHandler */]])
    ], CoreUserModule);
    return CoreUserModule;
}());

//# sourceMappingURL=user.module.js.map

/***/ }),
/* 795 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserParticipantsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_split_view_split_view__ = __webpack_require__(121);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays the list of course participants.
 */
var CoreUserParticipantsComponent = /** @class */ (function () {
    function CoreUserParticipantsComponent(userProvider, domUtils) {
        this.userProvider = userProvider;
        this.domUtils = domUtils;
        this.participants = [];
        this.canLoadMore = false;
        this.loadMoreError = false;
        this.participantsLoaded = false;
    }
    /**
     * View loaded.
     */
    CoreUserParticipantsComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Get first participants.
        this.fetchData(true).then(function () {
            if (!_this.participantId && _this.splitviewCtrl.isOn() && _this.participants.length > 0) {
                // Take first and load it.
                _this.gotoParticipant(_this.participants[0].id);
            }
            // Add log in Moodle.
            _this.userProvider.logParticipantsView(_this.courseId).catch(function () {
                // Ignore errors.
            });
        }).finally(function () {
            _this.participantsLoaded = true;
            // Call resize to make infinite loading work, in some cases the content dimensions aren't read.
            _this.content && _this.content.resize();
        });
    };
    /**
     * Fetch all the data required for the view.
     *
     * @param {boolean} [refresh] Empty events array first.
     * @return {Promise<any>}     Resolved when done.
     */
    CoreUserParticipantsComponent.prototype.fetchData = function (refresh) {
        var _this = this;
        if (refresh === void 0) { refresh = false; }
        var firstToGet = refresh ? 0 : this.participants.length;
        this.loadMoreError = false;
        return this.userProvider.getParticipants(this.courseId, firstToGet).then(function (data) {
            if (refresh) {
                _this.participants = data.participants;
            }
            else {
                _this.participants = _this.participants.concat(data.participants);
            }
            _this.canLoadMore = data.canLoadMore;
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'Error loading participants');
            _this.loadMoreError = true; // Set to prevent infinite calls with infinite-loading.
        });
    };
    /**
     * Function to load more data.
     *
     * @param {any} [infiniteComplete] Infinite scroll complete function. Only used from core-infinite-loading.
     * @return {Promise<any>} Resolved when done.
     */
    CoreUserParticipantsComponent.prototype.loadMoreData = function (infiniteComplete) {
        return this.fetchData().finally(function () {
            infiniteComplete && infiniteComplete();
        });
    };
    /**
     * Refresh data.
     *
     * @param {any} refresher Refresher.
     */
    CoreUserParticipantsComponent.prototype.refreshParticipants = function (refresher) {
        var _this = this;
        this.userProvider.invalidateParticipantsList(this.courseId).finally(function () {
            _this.fetchData(true).finally(function () {
                refresher.complete();
            });
        });
    };
    /**
     * Navigate to a particular user profile.
     * @param {number} userId  User Id where to navigate.
     */
    CoreUserParticipantsComponent.prototype.gotoParticipant = function (userId) {
        this.participantId = userId;
        this.splitviewCtrl.push('CoreUserProfilePage', { userId: userId, courseId: this.courseId });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */])
    ], CoreUserParticipantsComponent.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_4__components_split_view_split_view__["a" /* CoreSplitViewComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_4__components_split_view_split_view__["a" /* CoreSplitViewComponent */])
    ], CoreUserParticipantsComponent.prototype, "splitviewCtrl", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreUserParticipantsComponent.prototype, "courseId", void 0);
    CoreUserParticipantsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-user-participants',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\user\components\participants\core-user-participants.html"*/'<core-split-view>\n    <ion-content>\n        <ion-refresher [enabled]="participantsLoaded" (ionRefresh)="refreshParticipants($event)">\n            <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n        </ion-refresher>\n        <core-loading [hideUntil]="participantsLoaded">\n            <core-empty-box *ngIf="participants && participants.length == 0" icon="person" [message]="\'core.user.noparticipants\' | translate">\n            </core-empty-box>\n\n            <ion-list *ngIf="participants && participants.length > 0" no-margin>\n                <a ion-item text-wrap *ngFor="let participant of participants" [title]="participant.fullname" (click)="gotoParticipant(participant.id)" [class.core-split-item-selected]="participant.id == participantId">\n                    <ion-avatar core-user-avatar [user]="participant" item-start [userId]="participant.id" [checkOnline]="true"></ion-avatar>\n                    <h2><core-format-text [text]="participant.fullname"></core-format-text></h2>\n                    <p *ngIf="participant.lastcourseaccess"><strong>{{ \'core.lastaccess\' | translate }}: </strong>{{ participant.lastcourseaccess | coreTimeAgo }}</p>\n                    <p *ngIf="participant.lastcourseaccess == null && participant.lastaccess"><strong>{{ \'core.lastaccess\' | translate }}: </strong>{{ participant.lastaccess | coreTimeAgo }}</p>\n                </a>\n            </ion-list>\n            <core-infinite-loading [enabled]="canLoadMore" (action)="loadMoreData($event)" [error]="loadMoreError"></core-infinite-loading>\n        </core-loading>\n    </ion-content>\n</core-split-view>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\user\components\participants\core-user-participants.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], CoreUserParticipantsComponent);
    return CoreUserParticipantsComponent;
}());

//# sourceMappingURL=participants.js.map

/***/ }),
/* 796 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserSyncProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_base_sync__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__offline__ = __webpack_require__(349);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_sync__ = __webpack_require__(46);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Service to sync user preferences.
 */
var CoreUserSyncProvider = /** @class */ (function (_super) {
    __extends(CoreUserSyncProvider, _super);
    function CoreUserSyncProvider(loggerProvider, sitesProvider, appProvider, translate, syncProvider, textUtils, userOffline, userProvider, utils, timeUtils) {
        var _this = _super.call(this, 'CoreUserSync', loggerProvider, sitesProvider, appProvider, syncProvider, textUtils, translate, timeUtils) || this;
        _this.userOffline = userOffline;
        _this.userProvider = userProvider;
        _this.utils = utils;
        return _this;
    }
    /**
     * Try to synchronize user preferences in a certain site or in all sites.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @return {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    CoreUserSyncProvider.prototype.syncPreferences = function (siteId) {
        var syncFunctionLog = 'all user preferences';
        return this.syncOnSites(syncFunctionLog, this.syncPreferencesFunc.bind(this), [], siteId);
    };
    /**
     * Sync user preferences of a site.
     *
     * @param {string} [siteId] Site ID to sync. If not defined, sync all sites.
     * @param {Promise<any>} Promise resolved if sync is successful, rejected if sync fails.
     */
    CoreUserSyncProvider.prototype.syncPreferencesFunc = function (siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var syncId = 'preferences';
        if (this.isSyncing(syncId, siteId)) {
            // There's already a sync ongoing, return the promise.
            return this.getOngoingSync(syncId, siteId);
        }
        var warnings = [];
        this.logger.debug("Try to sync user preferences");
        var syncPromise = this.userOffline.getChangedPreferences(siteId).then(function (preferences) {
            return _this.utils.allPromises(preferences.map(function (preference) {
                return _this.userProvider.getUserPreferenceOnline(preference.name, siteId).then(function (onlineValue) {
                    if (preference.onlinevalue != onlineValue) {
                        // Prefernce was changed on web while the app was offline, do not sync.
                        return _this.userOffline.setPreference(preference.name, onlineValue, onlineValue, siteId);
                    }
                    return _this.userProvider.setUserPreference(preference.name, preference.value, siteId).catch(function (error) {
                        if (_this.utils.isWebServiceError(error)) {
                            warnings.push(_this.textUtils.getErrorMessageFromError(error));
                        }
                        else {
                            // Couldn't connect to server, reject.
                            return Promise.reject(error);
                        }
                    });
                });
            }));
        }).then(function () {
            // All done, return the warnings.
            return warnings;
        });
        return this.addOngoingSync(syncId, syncPromise, siteId);
    };
    CoreUserSyncProvider.AUTO_SYNCED = 'core_user_autom_synced';
    CoreUserSyncProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_11__providers_sync__["a" /* CoreSyncProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__offline__["a" /* CoreUserOfflineProvider */], __WEBPACK_IMPORTED_MODULE_6__user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreUserSyncProvider);
    return CoreUserSyncProvider;
}(__WEBPACK_IMPORTED_MODULE_3__classes_base_sync__["a" /* CoreSyncBaseProvider */]));

//# sourceMappingURL=sync.js.map

/***/ }),
/* 797 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CORE_PUSHNOTIFICATIONS_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return CorePushNotificationsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__ = __webpack_require__(86);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_register_cron_handler__ = __webpack_require__(1465);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_unregister_cron_handler__ = __webpack_require__(1466);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











// List of providers (without handlers).
var CORE_PUSHNOTIFICATIONS_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__["a" /* CorePushNotificationsProvider */],
    __WEBPACK_IMPORTED_MODULE_3__providers_delegate__["a" /* CorePushNotificationsDelegate */]
];
var CorePushNotificationsModule = /** @class */ (function () {
    function CorePushNotificationsModule(platform, pushNotificationsProvider, eventsProvider, localNotificationsProvider, loggerProvider, updateManager, cronDelegate, registerCronHandler, unregisterCronHandler) {
        var logger = loggerProvider.getInstance('CorePushNotificationsModule');
        // Register the handlers.
        cronDelegate.register(registerCronHandler);
        cronDelegate.register(unregisterCronHandler);
        // Register device on GCM or APNS server.
        platform.ready().then(function () {
            pushNotificationsProvider.registerDevice();
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__providers_events__["a" /* CoreEventsProvider */].NOTIFICATION_SOUND_CHANGED, function () {
            // Notification sound has changed, register the device again to update the sound setting.
            pushNotificationsProvider.registerDevice();
        });
        // Register device on Moodle site when login.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__providers_events__["a" /* CoreEventsProvider */].LOGIN, function () {
            pushNotificationsProvider.registerDeviceOnMoodle().catch(function (error) {
                logger.warn('Can\'t register device', error);
            });
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_7__providers_events__["a" /* CoreEventsProvider */].SITE_DELETED, function (site) {
            pushNotificationsProvider.unregisterDeviceOnMoodle(site).catch(function (error) {
                logger.warn('Can\'t unregister device', error);
            });
            pushNotificationsProvider.cleanSiteCounters(site.id);
        });
        // Listen for local notification clicks (generated by the app).
        localNotificationsProvider.registerClick(__WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__["a" /* CorePushNotificationsProvider */].COMPONENT, function (notification) {
            // Log notification open event.
            pushNotificationsProvider.logEvent('moodle_notification_open', notification, true);
            pushNotificationsProvider.notificationClicked(notification);
        });
        // Listen for local notification dismissed events.
        localNotificationsProvider.registerObserver('clear', __WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__["a" /* CorePushNotificationsProvider */].COMPONENT, function (notification) {
            // Log notification dismissed event.
            pushNotificationsProvider.logEvent('moodle_notification_dismiss', notification, true);
        });
        // Allow migrating the table from the old app to the new schema.
        updateManager.registerAppTableMigration({
            name: 'mma_pushnotifications_badge',
            newName: __WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__["a" /* CorePushNotificationsProvider */].BADGE_TABLE,
            fields: [
                {
                    name: 'siteid',
                    newName: 'siteId'
                }
            ]
        });
        // Migrate the component name.
        updateManager.registerLocalNotifComponentMigration('mmaPushNotifications', __WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__["a" /* CorePushNotificationsProvider */].COMPONENT);
    }
    CorePushNotificationsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__["a" /* CorePushNotificationsProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_delegate__["a" /* CorePushNotificationsDelegate */],
                __WEBPACK_IMPORTED_MODULE_4__providers_register_cron_handler__["a" /* CorePushNotificationsRegisterCronHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_unregister_cron_handler__["a" /* CorePushNotificationsUnregisterCronHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_2__providers_pushnotifications__["a" /* CorePushNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_update_manager__["a" /* CoreUpdateManagerProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_cron__["a" /* CoreCronDelegate */],
            __WEBPACK_IMPORTED_MODULE_4__providers_register_cron_handler__["a" /* CorePushNotificationsRegisterCronHandler */],
            __WEBPACK_IMPORTED_MODULE_5__providers_unregister_cron_handler__["a" /* CorePushNotificationsUnregisterCronHandler */]])
    ], CorePushNotificationsModule);
    return CorePushNotificationsModule;
}());

//# sourceMappingURL=pushnotifications.module.js.map

/***/ }),
/* 798 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return IONIC_NATIVE_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreEmulatorModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_badge__ = __webpack_require__(747);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_camera__ = __webpack_require__(256);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_clipboard__ = __webpack_require__(343);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_device__ = __webpack_require__(418);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ionic_native_file__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_file_opener__ = __webpack_require__(250);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_native_file_transfer__ = __webpack_require__(251);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ionic_native_globalization__ = __webpack_require__(337);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ionic_native_in_app_browser__ = __webpack_require__(249);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__ionic_native_keyboard__ = __webpack_require__(339);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_local_notifications__ = __webpack_require__(255);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ionic_native_media_capture__ = __webpack_require__(347);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__ionic_native_push__ = __webpack_require__(254);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__ionic_native_splash_screen__ = __webpack_require__(428);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__ionic_native_status_bar__ = __webpack_require__(183);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__ionic_native_sqlite__ = __webpack_require__(741);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__ionic_native_web_intent__ = __webpack_require__(744);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__ionic_native_zip__ = __webpack_require__(342);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__providers_badge__ = __webpack_require__(1467);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__providers_camera__ = __webpack_require__(1468);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__providers_clipboard__ = __webpack_require__(1469);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__providers_file__ = __webpack_require__(1470);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__providers_file_opener__ = __webpack_require__(1472);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__providers_file_transfer__ = __webpack_require__(766);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__providers_globalization__ = __webpack_require__(1473);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__providers_inappbrowser__ = __webpack_require__(1474);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__providers_local_notifications__ = __webpack_require__(1476);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__providers_media_capture__ = __webpack_require__(1477);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__providers_network__ = __webpack_require__(1478);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__providers_push__ = __webpack_require__(1479);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__providers_zip__ = __webpack_require__(1480);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__providers_helper__ = __webpack_require__(211);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__providers_capture_helper__ = __webpack_require__(258);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__providers_init__ = __webpack_require__(87);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


// Ionic Native services.



















// Services that Mock Ionic Native in browser an desktop.






















// List of Ionic Native providers.
var IONIC_NATIVE_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_2__ionic_native_badge__["a" /* Badge */],
    __WEBPACK_IMPORTED_MODULE_3__ionic_native_camera__["a" /* Camera */],
    __WEBPACK_IMPORTED_MODULE_4__ionic_native_clipboard__["a" /* Clipboard */],
    __WEBPACK_IMPORTED_MODULE_5__ionic_native_device__["a" /* Device */],
    __WEBPACK_IMPORTED_MODULE_6__ionic_native_file__["a" /* File */],
    __WEBPACK_IMPORTED_MODULE_7__ionic_native_file_opener__["a" /* FileOpener */],
    __WEBPACK_IMPORTED_MODULE_8__ionic_native_file_transfer__["a" /* FileTransfer */],
    __WEBPACK_IMPORTED_MODULE_9__ionic_native_globalization__["a" /* Globalization */],
    __WEBPACK_IMPORTED_MODULE_10__ionic_native_in_app_browser__["a" /* InAppBrowser */],
    __WEBPACK_IMPORTED_MODULE_11__ionic_native_keyboard__["a" /* Keyboard */],
    __WEBPACK_IMPORTED_MODULE_12__ionic_native_local_notifications__["a" /* LocalNotifications */],
    __WEBPACK_IMPORTED_MODULE_13__ionic_native_media_capture__["a" /* MediaCapture */],
    __WEBPACK_IMPORTED_MODULE_14__ionic_native_network__["a" /* Network */],
    __WEBPACK_IMPORTED_MODULE_15__ionic_native_push__["a" /* Push */],
    __WEBPACK_IMPORTED_MODULE_16__ionic_native_splash_screen__["a" /* SplashScreen */],
    __WEBPACK_IMPORTED_MODULE_17__ionic_native_status_bar__["a" /* StatusBar */],
    __WEBPACK_IMPORTED_MODULE_18__ionic_native_sqlite__["a" /* SQLite */],
    __WEBPACK_IMPORTED_MODULE_19__ionic_native_web_intent__["a" /* WebIntent */],
    __WEBPACK_IMPORTED_MODULE_20__ionic_native_zip__["a" /* Zip */]
];
/**
 * This module handles the emulation of Cordova plugins in browser and desktop.
 *
 * It includes the "mock" of all the Ionic Native services that should be supported in browser and desktop,
 * otherwise those features would only work in a Cordova environment.
 *
 * This module also determines if the app should use the original service or the mock. In each of the "useFactory"
 * functions we check if the app is running in mobile or not, and then provide the right service to use.
 */
var CoreEmulatorModule = /** @class */ (function () {
    function CoreEmulatorModule(appProvider, initDelegate, helper, platform) {
        var win = window; // Convert the "window" to "any" type to be able to use non-standard properties.
        // Emulate Custom URL Scheme plugin in desktop apps.
        if (appProvider.isDesktop()) {
            __webpack_require__(70).ipcRenderer.on('coreAppLaunched', function (event, url) {
                if (typeof win.handleOpenURL != 'undefined') {
                    win.handleOpenURL(url);
                }
            });
            // Listen for 'resume' events.
            __webpack_require__(70).ipcRenderer.on('coreAppFocused', function () {
                platform.resume.emit();
            });
        }
        if (!appProvider.isMobile()) {
            // Register an init process to load the Mocks that need it.
            initDelegate.registerProcess(helper);
        }
    }
    CoreEmulatorModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                {
                    provide: __WEBPACK_IMPORTED_MODULE_2__ionic_native_badge__["a" /* Badge */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */]],
                    useFactory: function (appProvider) {
                        // Use platform instead of CoreAppProvider to prevent circular dependencies.
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_2__ionic_native_badge__["a" /* Badge */]() : new __WEBPACK_IMPORTED_MODULE_21__providers_badge__["a" /* BadgeMock */](appProvider);
                    }
                },
                __WEBPACK_IMPORTED_MODULE_34__providers_helper__["a" /* CoreEmulatorHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_35__providers_capture_helper__["a" /* CoreEmulatorCaptureHelperProvider */],
                {
                    provide: __WEBPACK_IMPORTED_MODULE_3__ionic_native_camera__["a" /* Camera */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_35__providers_capture_helper__["a" /* CoreEmulatorCaptureHelperProvider */]],
                    useFactory: function (appProvider, captureHelper) {
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_3__ionic_native_camera__["a" /* Camera */]() : new __WEBPACK_IMPORTED_MODULE_22__providers_camera__["a" /* CameraMock */](captureHelper);
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_4__ionic_native_clipboard__["a" /* Clipboard */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */]],
                    useFactory: function (appProvider) {
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_4__ionic_native_clipboard__["a" /* Clipboard */]() : new __WEBPACK_IMPORTED_MODULE_23__providers_clipboard__["a" /* ClipboardMock */](appProvider);
                    }
                },
                __WEBPACK_IMPORTED_MODULE_5__ionic_native_device__["a" /* Device */],
                {
                    provide: __WEBPACK_IMPORTED_MODULE_6__ionic_native_file__["a" /* File */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_39__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_38__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */]],
                    useFactory: function (appProvider, textUtils, mimeUtils) {
                        // Use platform instead of CoreAppProvider to prevent circular dependencies.
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_6__ionic_native_file__["a" /* File */]() : new __WEBPACK_IMPORTED_MODULE_24__providers_file__["a" /* FileMock */](appProvider, textUtils, mimeUtils);
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_7__ionic_native_file_opener__["a" /* FileOpener */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */]],
                    useFactory: function (appProvider) {
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_7__ionic_native_file_opener__["a" /* FileOpener */]() : new __WEBPACK_IMPORTED_MODULE_25__providers_file_opener__["a" /* FileOpenerMock */](appProvider);
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_8__ionic_native_file_transfer__["a" /* FileTransfer */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_37__providers_file__["a" /* CoreFileProvider */]],
                    useFactory: function (appProvider, fileProvider) {
                        // Use platform instead of CoreAppProvider to prevent circular dependencies.
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_8__ionic_native_file_transfer__["a" /* FileTransfer */]() : new __WEBPACK_IMPORTED_MODULE_26__providers_file_transfer__["b" /* FileTransferMock */](appProvider, fileProvider);
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_9__ionic_native_globalization__["a" /* Globalization */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */]],
                    useFactory: function (appProvider) {
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_9__ionic_native_globalization__["a" /* Globalization */]() : new __WEBPACK_IMPORTED_MODULE_27__providers_globalization__["a" /* GlobalizationMock */](appProvider);
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_10__ionic_native_in_app_browser__["a" /* InAppBrowser */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_37__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_40__providers_utils_url__["a" /* CoreUrlUtilsProvider */]],
                    useFactory: function (appProvider, fileProvider, urlUtils) {
                        return !appProvider.isDesktop() ? new __WEBPACK_IMPORTED_MODULE_10__ionic_native_in_app_browser__["a" /* InAppBrowser */]() : new __WEBPACK_IMPORTED_MODULE_28__providers_inappbrowser__["a" /* InAppBrowserMock */](appProvider, fileProvider, urlUtils);
                    }
                },
                __WEBPACK_IMPORTED_MODULE_11__ionic_native_keyboard__["a" /* Keyboard */],
                {
                    provide: __WEBPACK_IMPORTED_MODULE_12__ionic_native_local_notifications__["a" /* LocalNotifications */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_41__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_39__providers_utils_text__["a" /* CoreTextUtilsProvider */]],
                    useFactory: function (appProvider, utils, txtUtils) {
                        // Use platform instead of CoreAppProvider to prevent circular dependencies.
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_12__ionic_native_local_notifications__["a" /* LocalNotifications */]() : new __WEBPACK_IMPORTED_MODULE_29__providers_local_notifications__["a" /* LocalNotificationsMock */](appProvider, utils, txtUtils);
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_13__ionic_native_media_capture__["a" /* MediaCapture */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_35__providers_capture_helper__["a" /* CoreEmulatorCaptureHelperProvider */]],
                    useFactory: function (appProvider, captureHelper) {
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_13__ionic_native_media_capture__["a" /* MediaCapture */]() : new __WEBPACK_IMPORTED_MODULE_30__providers_media_capture__["a" /* MediaCaptureMock */](captureHelper);
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_14__ionic_native_network__["a" /* Network */],
                    deps: [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */]],
                    useFactory: function (platform) {
                        // Use platform instead of CoreAppProvider to prevent circular dependencies.
                        return platform.is('cordova') ? new __WEBPACK_IMPORTED_MODULE_14__ionic_native_network__["a" /* Network */]() : new __WEBPACK_IMPORTED_MODULE_31__providers_network__["a" /* NetworkMock */]();
                    }
                },
                {
                    provide: __WEBPACK_IMPORTED_MODULE_15__ionic_native_push__["a" /* Push */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */]],
                    useFactory: function (appProvider) {
                        // Use platform instead of CoreAppProvider to prevent circular dependencies.
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_15__ionic_native_push__["a" /* Push */]() : new __WEBPACK_IMPORTED_MODULE_32__providers_push__["a" /* PushMock */](appProvider);
                    }
                },
                __WEBPACK_IMPORTED_MODULE_16__ionic_native_splash_screen__["a" /* SplashScreen */],
                __WEBPACK_IMPORTED_MODULE_17__ionic_native_status_bar__["a" /* StatusBar */],
                __WEBPACK_IMPORTED_MODULE_18__ionic_native_sqlite__["a" /* SQLite */],
                __WEBPACK_IMPORTED_MODULE_19__ionic_native_web_intent__["a" /* WebIntent */],
                {
                    provide: __WEBPACK_IMPORTED_MODULE_20__ionic_native_zip__["a" /* Zip */],
                    deps: [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__ionic_native_file__["a" /* File */], __WEBPACK_IMPORTED_MODULE_39__providers_utils_text__["a" /* CoreTextUtilsProvider */]],
                    useFactory: function (appProvider, file, textUtils) {
                        // Use platform instead of CoreAppProvider to prevent circular dependencies.
                        return appProvider.isMobile() ? new __WEBPACK_IMPORTED_MODULE_20__ionic_native_zip__["a" /* Zip */]() : new __WEBPACK_IMPORTED_MODULE_33__providers_zip__["a" /* ZipMock */](file, textUtils);
                    }
                },
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_36__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_42__providers_init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_34__providers_helper__["a" /* CoreEmulatorHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */]])
    ], CoreEmulatorModule);
    return CoreEmulatorModule;
}());

//# sourceMappingURL=emulator.module.js.map

/***/ }),
/* 799 */,
/* 800 */,
/* 801 */,
/* 802 */,
/* 803 */,
/* 804 */,
/* 805 */,
/* 806 */,
/* 807 */,
/* 808 */,
/* 809 */,
/* 810 */,
/* 811 */,
/* 812 */,
/* 813 */,
/* 814 */,
/* 815 */,
/* 816 */,
/* 817 */,
/* 818 */,
/* 819 */,
/* 820 */,
/* 821 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesCourseOptionsMenuComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_courses__ = __webpack_require__(32);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * This component is meant to display a popover with the course options.
 */
var CoreCoursesCourseOptionsMenuComponent = /** @class */ (function () {
    function CoreCoursesCourseOptionsMenuComponent(navParams, viewCtrl, coursesProvider) {
        this.viewCtrl = viewCtrl;
        this.coursesProvider = coursesProvider;
        this.course = navParams.get('course') || {};
        this.prefetch = navParams.get('prefetch') || {};
    }
    /**
     * Component being initialized.
     */
    CoreCoursesCourseOptionsMenuComponent.prototype.ngOnInit = function () {
        this.downloadCourseEnabled = !this.coursesProvider.isDownloadCourseDisabledInSite();
    };
    /**
     * Do an action over the course.
     * @param {string} action Action name to take.
     */
    CoreCoursesCourseOptionsMenuComponent.prototype.action = function (action) {
        this.viewCtrl.dismiss(action);
    };
    CoreCoursesCourseOptionsMenuComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-courses-course-options-menu',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\course-options-menu\core-courses-course-options-menu.html"*/'<ion-item text-wrap (click)="action(\'download\')" *ngIf="downloadCourseEnabled">\n    <ion-icon *ngIf="prefetch.prefetchCourseIcon != \'spinner\'" [name]="prefetch.prefetchCourseIcon" item-start></ion-icon>\n    <ion-spinner *ngIf="prefetch.prefetchCourseIcon == \'spinner\'" item-start></ion-spinner>\n    <h2>{{ prefetch.title | translate }}</h2>\n</ion-item>\n<ion-item text-wrap (click)="action(\'hide\')" *ngIf="!course.hidden">\n    <core-icon name="fa-eye" item-start></core-icon>\n    <h2>{{ \'core.courses.hidecourse\' | translate }}</h2>\n</ion-item>\n<ion-item text-wrap (click)="action(\'show\')" *ngIf="course.hidden">\n    <core-icon name="fa-eye-slash" item-start></core-icon>\n    <h2>{{ \'core.courses.show\' | translate }}</h2>\n</ion-item>\n<ion-item text-wrap (click)="action(\'favourite\')" *ngIf="!course.isfavourite">\n    <core-icon name="fa-star" item-start></core-icon>\n    <h2>{{ \'core.courses.addtofavourites\' | translate }}</h2>\n</ion-item>\n<ion-item text-wrap (click)="action(\'unfavourite\')" *ngIf="course.isfavourite">\n    <core-icon name="fa-star" [slash]="true" item-start></core-icon>\n    <h2>{{ \'core.courses.removefromfavourites\' | translate }}</h2>\n</ion-item>\n\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\course-options-menu\core-courses-course-options-menu.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */], __WEBPACK_IMPORTED_MODULE_2__providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreCoursesCourseOptionsMenuComponent);
    return CoreCoursesCourseOptionsMenuComponent;
}());

//# sourceMappingURL=course-options-menu.js.map

/***/ }),
/* 822 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCallWSOnClickBaseDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__call_ws_directive__ = __webpack_require__(823);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Base class for directives to call a WS when the element is clicked.
 *
 * The directives that inherit from this class will call a WS method when the element is clicked.
 *
 * @see CoreSitePluginsCallWSBaseDirective
 */
var CoreSitePluginsCallWSOnClickBaseDirective = /** @class */ (function (_super) {
    __extends(CoreSitePluginsCallWSOnClickBaseDirective, _super);
    function CoreSitePluginsCallWSOnClickBaseDirective(element, translate, domUtils, sitePluginsProvider, parentContent, utils) {
        var _this = _super.call(this, element, translate, domUtils, sitePluginsProvider, parentContent) || this;
        _this.translate = translate;
        _this.domUtils = domUtils;
        _this.sitePluginsProvider = sitePluginsProvider;
        _this.parentContent = parentContent;
        _this.utils = utils;
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsCallWSOnClickBaseDirective.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.element.addEventListener('click', function (ev) {
            ev.preventDefault();
            ev.stopPropagation();
            if (typeof _this.confirmMessage != 'undefined') {
                // Ask for confirm.
                _this.domUtils.showConfirm(_this.confirmMessage || _this.translate.instant('core.areyousure')).then(function () {
                    _this.callWS();
                }).catch(function () {
                    // User cancelled, ignore.
                });
            }
            else {
                _this.callWS();
            }
        });
    };
    /**
     * Call a WS.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsCallWSOnClickBaseDirective.prototype.callWS = function () {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        return _super.prototype.callWS.call(this).catch(function (error) {
            if (typeof _this.showError == 'undefined' || _this.utils.isTrueOrOne(_this.showError)) {
                // this.domUtils.showErrorModalDefault(error, 'core.serverconnection', true);
            }
        }).finally(function () {
            modal.dismiss();
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCallWSOnClickBaseDirective.prototype, "confirmMessage", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSOnClickBaseDirective.prototype, "showError", void 0);
    return CoreSitePluginsCallWSOnClickBaseDirective;
}(__WEBPACK_IMPORTED_MODULE_1__call_ws_directive__["a" /* CoreSitePluginsCallWSBaseDirective */]));

//# sourceMappingURL=call-ws-click-directive.js.map

/***/ }),
/* 823 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCallWSBaseDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Base class for directives that need to call a WS.
 */
var CoreSitePluginsCallWSBaseDirective = /** @class */ (function () {
    function CoreSitePluginsCallWSBaseDirective(element, translate, domUtils, sitePluginsProvider, parentContent) {
        this.translate = translate;
        this.domUtils = domUtils;
        this.sitePluginsProvider = sitePluginsProvider;
        this.parentContent = parentContent;
        // If supplied and form is found, the form data will be retrieved and sent to the WS.
        this.onSuccess = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"](); // Sends the result when the WS call succeeds.
        this.onError = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"](); // Sends the error when the WS call fails.
        this.onDone = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"](); // Notifies when the WS call is done (either success or fail).
        this.element = element.nativeElement || element;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsCallWSBaseDirective.prototype.ngOnInit = function () {
        var _this = this;
        if (this.parentContent && this.parentContent.invalidateObservable) {
            this.invalidateObserver = this.parentContent.invalidateObservable.subscribe(function () {
                _this.invalidate();
            });
        }
    };
    /**
     * Call a WS.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsCallWSBaseDirective.prototype.callWS = function () {
        var _this = this;
        var params = this.getParamsForWS();
        return this.sitePluginsProvider.callWS(this.name, params, this.preSets).then(function (result) {
            _this.onSuccess.emit(result);
            return _this.wsCallSuccess(result);
        }).catch(function (error) {
            _this.onError.emit(error);
            return Promise.reject(error);
        }).finally(function () {
            _this.onDone.emit();
        });
    };
    /**
     * Get the params for the WS call.
     *
     * @return {any} Params.
     */
    CoreSitePluginsCallWSBaseDirective.prototype.getParamsForWS = function () {
        var params = this.params || {};
        if (this.parentContent) {
            params = this.sitePluginsProvider.loadOtherDataInArgs(params, this.parentContent.otherData, this.useOtherDataForWS);
        }
        if (this.form && document.forms[this.form]) {
            params = Object.assign(params, this.domUtils.getDataFromForm(document.forms[this.form]));
        }
        return params;
    };
    /**
     * Function called when the WS call is successful.
     *
     * @param {any} result Result of the WS call.
     */
    CoreSitePluginsCallWSBaseDirective.prototype.wsCallSuccess = function (result) {
        // Function to be overridden.
    };
    /**
     * Invalidate the WS call.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsCallWSBaseDirective.prototype.invalidate = function () {
        var params = this.getParamsForWS();
        return this.sitePluginsProvider.invalidateCallWS(this.name, params, this.preSets);
    };
    /**
     * Directive destroyed.
     */
    CoreSitePluginsCallWSBaseDirective.prototype.ngOnDestroy = function () {
        this.invalidateObserver && this.invalidateObserver.unsubscribe();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCallWSBaseDirective.prototype, "name", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSBaseDirective.prototype, "params", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSBaseDirective.prototype, "preSets", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreSitePluginsCallWSBaseDirective.prototype, "useOtherDataForWS", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCallWSBaseDirective.prototype, "form", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsCallWSBaseDirective.prototype, "onSuccess", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsCallWSBaseDirective.prototype, "onError", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePluginsCallWSBaseDirective.prototype, "onDone", void 0);
    return CoreSitePluginsCallWSBaseDirective;
}());

//# sourceMappingURL=call-ws-directive.js.map

/***/ }),
/* 824 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_BADGES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonBadgesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_badges__ = __webpack_require__(186);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_user_handler__ = __webpack_require__(1535);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_mybadges_link_handler__ = __webpack_require__(1536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_badge_link_handler__ = __webpack_require__(1537);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_push_click_handler__ = __webpack_require__(1538);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









// List of providers (without handlers).
var ADDON_BADGES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_badges__["a" /* AddonBadgesProvider */]
];
var AddonBadgesModule = /** @class */ (function () {
    function AddonBadgesModule(userDelegate, userHandler, contentLinksDelegate, myBadgesLinkHandler, badgeLinkHandler, pushNotificationsDelegate, pushClickHandler) {
        userDelegate.registerHandler(userHandler);
        contentLinksDelegate.registerHandler(myBadgesLinkHandler);
        contentLinksDelegate.registerHandler(badgeLinkHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
    }
    AddonBadgesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_badges__["a" /* AddonBadgesProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_user_handler__["a" /* AddonBadgesUserHandler */],
                __WEBPACK_IMPORTED_MODULE_3__providers_mybadges_link_handler__["a" /* AddonBadgesMyBadgesLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_badge_link_handler__["a" /* AddonBadgesBadgeLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_push_click_handler__["a" /* AddonBadgesPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_7__core_user_providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_user_handler__["a" /* AddonBadgesUserHandler */],
            __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_mybadges_link_handler__["a" /* AddonBadgesMyBadgesLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_4__providers_badge_link_handler__["a" /* AddonBadgesBadgeLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_8__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_push_click_handler__["a" /* AddonBadgesPushClickHandler */]])
    ], AddonBadgesModule);
    return AddonBadgesModule;
}());

//# sourceMappingURL=badges.module.js.map

/***/ }),
/* 825 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_CALENDAR_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonCalendarModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_calendar__ = __webpack_require__(281);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(978);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__ = __webpack_require__(1539);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









// List of providers (without handlers).
var ADDON_CALENDAR_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_calendar__["a" /* AddonCalendarProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonCalendarHelperProvider */]
];
var AddonCalendarModule = /** @class */ (function () {
    function AddonCalendarModule(mainMenuDelegate, calendarHandler, initDelegate, calendarProvider, loginHelper, localNotificationsProvider, updateManager) {
        mainMenuDelegate.registerHandler(calendarHandler);
        initDelegate.ready().then(function () {
            calendarProvider.scheduleAllSitesEventsNotifications();
        });
        localNotificationsProvider.registerClick(__WEBPACK_IMPORTED_MODULE_1__providers_calendar__["a" /* AddonCalendarProvider */].COMPONENT, function (data) {
            if (data.eventid) {
                initDelegate.ready().then(function () {
                    calendarProvider.isDisabled(data.siteId).then(function (disabled) {
                        if (disabled) {
                            // The calendar is disabled in the site, don't open it.
                            return;
                        }
                        loginHelper.redirect('AddonCalendarListPage', { eventId: data.eventid }, data.siteId);
                    });
                });
            }
        });
        // Allow migrating the table from the old app to the new schema.
        // In the old app some calculated properties were stored when it shouldn't. Filter only the fields we want.
        updateManager.registerSiteTableMigration({
            name: 'calendar_events',
            newName: __WEBPACK_IMPORTED_MODULE_1__providers_calendar__["a" /* AddonCalendarProvider */].EVENTS_TABLE,
            filterFields: ['id', 'name', 'description', 'format', 'eventtype', 'courseid', 'timestart', 'timeduration',
                'categoryid', 'groupid', 'userid', 'instance', 'modulename', 'timemodified', 'repeatid', 'visible', 'uuid',
                'sequence', 'subscriptionid']
        });
        // Migrate the component name.
        updateManager.registerLocalNotifComponentMigration('mmaCalendarComponent', __WEBPACK_IMPORTED_MODULE_1__providers_calendar__["a" /* AddonCalendarProvider */].COMPONENT);
    }
    AddonCalendarModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_calendar__["a" /* AddonCalendarProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonCalendarHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* AddonCalendarMainMenuHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* AddonCalendarMainMenuHandler */],
            __WEBPACK_IMPORTED_MODULE_5__providers_init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_calendar__["a" /* AddonCalendarProvider */], __WEBPACK_IMPORTED_MODULE_7__core_login_providers_helper__["a" /* CoreLoginHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_update_manager__["a" /* CoreUpdateManagerProvider */]])
    ], AddonCalendarModule);
    return AddonCalendarModule;
}());

//# sourceMappingURL=calendar.module.js.map

/***/ }),
/* 826 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_COMPETENCY_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonCompetencyModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_competency__ = __webpack_require__(98);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(414);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_course_option_handler__ = __webpack_require__(1540);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_mainmenu_handler__ = __webpack_require__(1541);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_user_handler__ = __webpack_require__(1542);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_competency_link_handler__ = __webpack_require__(1543);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_plan_link_handler__ = __webpack_require__(1544);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_plans_link_handler__ = __webpack_require__(1545);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_user_competency_link_handler__ = __webpack_require__(1546);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_push_click_handler__ = __webpack_require__(1547);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__components_components_module__ = __webpack_require__(996);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















// List of providers (without handlers).
var ADDON_COMPETENCY_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_competency__["a" /* AddonCompetencyProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonCompetencyHelperProvider */]
];
var AddonCompetencyModule = /** @class */ (function () {
    function AddonCompetencyModule(mainMenuDelegate, mainMenuHandler, courseOptionsDelegate, courseOptionHandler, userDelegate, userHandler, contentLinksDelegate, competencyLinkHandler, planLinkHandler, plansLinkHandler, userComptencyLinkHandler, pushNotificationsDelegate, pushClickHandler) {
        mainMenuDelegate.registerHandler(mainMenuHandler);
        courseOptionsDelegate.registerHandler(courseOptionHandler);
        userDelegate.registerHandler(userHandler);
        contentLinksDelegate.registerHandler(competencyLinkHandler);
        contentLinksDelegate.registerHandler(planLinkHandler);
        contentLinksDelegate.registerHandler(plansLinkHandler);
        contentLinksDelegate.registerHandler(userComptencyLinkHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
    }
    AddonCompetencyModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_11__components_components_module__["a" /* AddonCompetencyComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_competency__["a" /* AddonCompetencyProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonCompetencyHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_course_option_handler__["a" /* AddonCompetencyCourseOptionHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_mainmenu_handler__["a" /* AddonCompetencyMainMenuHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_user_handler__["a" /* AddonCompetencyUserHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_competency_link_handler__["a" /* AddonCompetencyCompetencyLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_plan_link_handler__["a" /* AddonCompetencyPlanLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_plans_link_handler__["a" /* AddonCompetencyPlansLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_user_competency_link_handler__["a" /* AddonCompetencyUserCompetencyLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_push_click_handler__["a" /* AddonCompetencyPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_13__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_mainmenu_handler__["a" /* AddonCompetencyMainMenuHandler */],
            __WEBPACK_IMPORTED_MODULE_12__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_course_option_handler__["a" /* AddonCompetencyCourseOptionHandler */],
            __WEBPACK_IMPORTED_MODULE_14__core_user_providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_user_handler__["a" /* AddonCompetencyUserHandler */],
            __WEBPACK_IMPORTED_MODULE_15__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_competency_link_handler__["a" /* AddonCompetencyCompetencyLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_7__providers_plan_link_handler__["a" /* AddonCompetencyPlanLinkHandler */], __WEBPACK_IMPORTED_MODULE_8__providers_plans_link_handler__["a" /* AddonCompetencyPlansLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_9__providers_user_competency_link_handler__["a" /* AddonCompetencyUserCompetencyLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_16__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_10__providers_push_click_handler__["a" /* AddonCompetencyPushClickHandler */]])
    ], AddonCompetencyModule);
    return AddonCompetencyModule;
}());

//# sourceMappingURL=competency.module.js.map

/***/ }),
/* 827 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_FILES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonFilesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_files__ = __webpack_require__(283);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(998);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__ = __webpack_require__(1548);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_mainmenu_providers_delegate__ = __webpack_require__(114);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





// List of providers (without handlers).
var ADDON_FILES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_files__["a" /* AddonFilesProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonFilesHelperProvider */]
];
var AddonFilesModule = /** @class */ (function () {
    function AddonFilesModule(mainMenuDelegate, filesHandler) {
        mainMenuDelegate.registerHandler(filesHandler);
    }
    AddonFilesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_files__["a" /* AddonFilesProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonFilesHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* AddonFilesMainMenuHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* AddonFilesMainMenuHandler */]])
    ], AddonFilesModule);
    return AddonFilesModule;
}());

//# sourceMappingURL=files.module.js.map

/***/ }),
/* 828 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MESSAGEOUTPUT_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonMessageOutputModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_delegate__ = __webpack_require__(286);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


// List of providers (without handlers).
var ADDON_MESSAGEOUTPUT_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_delegate__["a" /* AddonMessageOutputDelegate */]
];
var AddonMessageOutputModule = /** @class */ (function () {
    function AddonMessageOutputModule() {
    }
    AddonMessageOutputModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_delegate__["a" /* AddonMessageOutputDelegate */]
            ]
        })
    ], AddonMessageOutputModule);
    return AddonMessageOutputModule;
}());

//# sourceMappingURL=messageoutput.module.js.map

/***/ }),
/* 829 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MESSAGES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonMessagesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_messages__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_messages_offline__ = __webpack_require__(282);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sync__ = __webpack_require__(420);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_mainmenu_handler__ = __webpack_require__(1549);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_user_send_message_handler__ = __webpack_require__(1550);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_user_add_contact_handler__ = __webpack_require__(830);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_user_block_contact_handler__ = __webpack_require__(831);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_contact_request_link_handler__ = __webpack_require__(1551);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_discussion_link_handler__ = __webpack_require__(1552);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_index_link_handler__ = __webpack_require__(1553);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__ = __webpack_require__(1554);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_push_click_handler__ = __webpack_require__(1555);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__core_settings_providers_delegate__ = __webpack_require__(223);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__providers_settings_handler__ = __webpack_require__(1556);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



























// List of providers (without handlers).
var ADDON_MESSAGES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_2__providers_messages__["a" /* AddonMessagesProvider */],
    __WEBPACK_IMPORTED_MODULE_3__providers_messages_offline__["a" /* AddonMessagesOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_4__providers_sync__["a" /* AddonMessagesSyncProvider */]
];
var AddonMessagesModule = /** @class */ (function () {
    function AddonMessagesModule(mainMenuDelegate, mainmenuHandler, contentLinksDelegate, indexLinkHandler, discussionLinkHandler, sendMessageHandler, userDelegate, cronDelegate, syncHandler, network, zone, messagesSync, appProvider, localNotifications, messagesProvider, sitesProvider, linkHelper, updateManager, settingsHandler, settingsDelegate, pushNotificationsDelegate, utils, addContactHandler, blockContactHandler, contactRequestLinkHandler, pushClickHandler) {
        // Register handlers.
        mainMenuDelegate.registerHandler(mainmenuHandler);
        contentLinksDelegate.registerHandler(indexLinkHandler);
        contentLinksDelegate.registerHandler(discussionLinkHandler);
        contentLinksDelegate.registerHandler(contactRequestLinkHandler);
        userDelegate.registerHandler(sendMessageHandler);
        userDelegate.registerHandler(addContactHandler);
        userDelegate.registerHandler(blockContactHandler);
        cronDelegate.register(syncHandler);
        cronDelegate.register(mainmenuHandler);
        settingsDelegate.registerHandler(settingsHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
        // Sync some discussions when device goes online.
        network.onConnect().subscribe(function () {
            // Execute the callback in the Angular zone, so change detection doesn't stop working.
            zone.run(function () {
                messagesSync.syncAllDiscussions(undefined, true);
            });
        });
        var notificationClicked = function (notification) {
            messagesProvider.isMessagingEnabledForSite(notification.site).then(function () {
                sitesProvider.isFeatureDisabled('CoreMainMenuDelegate_AddonMessages', notification.site).then(function (disabled) {
                    if (disabled) {
                        // Messages are disabled, stop.
                        return;
                    }
                    messagesProvider.invalidateDiscussionsCache(notification.site).finally(function () {
                        // Check if group messaging is enabled, to determine which page should be loaded.
                        messagesProvider.isGroupMessagingEnabledInSite(notification.site).then(function (enabled) {
                            var pageParams = {};
                            var pageName = 'AddonMessagesIndexPage';
                            if (enabled) {
                                pageName = 'AddonMessagesGroupConversationsPage';
                            }
                            // Check if we have enough information to open the conversation.
                            if (notification.convid && enabled) {
                                pageParams.conversationId = Number(notification.convid);
                            }
                            else if (notification.userfromid || notification.useridfrom) {
                                pageParams.discussionUserId = Number(notification.userfromid || notification.useridfrom);
                            }
                            linkHelper.goInSite(undefined, pageName, pageParams, notification.site);
                        });
                    });
                });
            });
        };
        if (appProvider.isDesktop()) {
            // Listen for clicks in simulated push notifications.
            localNotifications.registerClick(__WEBPACK_IMPORTED_MODULE_2__providers_messages__["a" /* AddonMessagesProvider */].PUSH_SIMULATION_COMPONENT, notificationClicked);
        }
        // Allow migrating the table from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_messages_offline_messages',
            newName: __WEBPACK_IMPORTED_MODULE_3__providers_messages_offline__["a" /* AddonMessagesOfflineProvider */].MESSAGES_TABLE,
            fields: [
                {
                    name: 'textformat',
                    delete: true
                }
            ]
        });
        // Migrate the component name.
        updateManager.registerLocalNotifComponentMigration('mmaMessagesPushSimulation', __WEBPACK_IMPORTED_MODULE_2__providers_messages__["a" /* AddonMessagesProvider */].PUSH_SIMULATION_COMPONENT);
    }
    AddonMessagesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_messages__["a" /* AddonMessagesProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_messages_offline__["a" /* AddonMessagesOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_sync__["a" /* AddonMessagesSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_5__providers_mainmenu_handler__["a" /* AddonMessagesMainMenuHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_user_send_message_handler__["a" /* AddonMessagesSendMessageUserHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_user_add_contact_handler__["a" /* AddonMessagesAddContactUserHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_user_block_contact_handler__["a" /* AddonMessagesBlockContactUserHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_contact_request_link_handler__["a" /* AddonMessagesContactRequestLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_discussion_link_handler__["a" /* AddonMessagesDiscussionLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_index_link_handler__["a" /* AddonMessagesIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__["a" /* AddonMessagesSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_23__providers_settings_handler__["a" /* AddonMessagesSettingsHandler */],
                __WEBPACK_IMPORTED_MODULE_17__providers_push_click_handler__["a" /* AddonMessagesPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_mainmenu_handler__["a" /* AddonMessagesMainMenuHandler */],
            __WEBPACK_IMPORTED_MODULE_7__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_15__providers_index_link_handler__["a" /* AddonMessagesIndexLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_14__providers_discussion_link_handler__["a" /* AddonMessagesDiscussionLinkHandler */], __WEBPACK_IMPORTED_MODULE_10__providers_user_send_message_handler__["a" /* AddonMessagesSendMessageUserHandler */],
            __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__["a" /* AddonMessagesSyncCronHandler */],
            __WEBPACK_IMPORTED_MODULE_1__ionic_native_network__["a" /* Network */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"], __WEBPACK_IMPORTED_MODULE_4__providers_sync__["a" /* AddonMessagesSyncProvider */], __WEBPACK_IMPORTED_MODULE_18__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_20__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_messages__["a" /* AddonMessagesProvider */],
            __WEBPACK_IMPORTED_MODULE_19__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_21__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_26__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_23__providers_settings_handler__["a" /* AddonMessagesSettingsHandler */], __WEBPACK_IMPORTED_MODULE_22__core_settings_providers_delegate__["a" /* CoreSettingsDelegate */],
            __WEBPACK_IMPORTED_MODULE_24__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_25__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_user_add_contact_handler__["a" /* AddonMessagesAddContactUserHandler */], __WEBPACK_IMPORTED_MODULE_12__providers_user_block_contact_handler__["a" /* AddonMessagesBlockContactUserHandler */],
            __WEBPACK_IMPORTED_MODULE_13__providers_contact_request_link_handler__["a" /* AddonMessagesContactRequestLinkHandler */], __WEBPACK_IMPORTED_MODULE_17__providers_push_click_handler__["a" /* AddonMessagesPushClickHandler */]])
    ], AddonMessagesModule);
    return AddonMessagesModule;
}());

//# sourceMappingURL=messages.module.js.map

/***/ }),
/* 830 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesAddContactUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__messages__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__user_block_contact_handler__ = __webpack_require__(831);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Profile add/remove contact handler.
 */
var AddonMessagesAddContactUserHandler = /** @class */ (function () {
    function AddonMessagesAddContactUserHandler(sitesProvider, messagesProvider, eventsProvider, domUtils, translate) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.messagesProvider = messagesProvider;
        this.eventsProvider = eventsProvider;
        this.domUtils = domUtils;
        this.translate = translate;
        this.name = 'AddonMessages:addContact';
        this.priority = 800;
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_ACTION;
        this.disabled = false;
        this.updateObs = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__user_block_contact_handler__["a" /* AddonMessagesBlockContactUserHandler */].UPDATED_EVENT, function (data) {
            _this.checkButton(data.userId);
        });
    }
    AddonMessagesAddContactUserHandler_1 = AddonMessagesAddContactUserHandler;
    /**
     * Check if handler is enabled.
     *
     * @return {Promise<boolean>} Promise resolved with true if enabled, rejected or resolved with false otherwise.
     */
    AddonMessagesAddContactUserHandler.prototype.isEnabled = function () {
        return this.messagesProvider.isPluginEnabled();
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user          User to check.
     * @param {number} courseId   Course ID.
     * @param  {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param  {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return  {boolean|Promise<boolean>}   Promise resolved with true if enabled, resolved with false otherwise.
     */
    AddonMessagesAddContactUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        return user.id != this.sitesProvider.getCurrentSiteUserId();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonMessagesAddContactUserHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        this.checkButton(user.id);
        return {
            icon: '',
            title: '',
            spinner: false,
            class: '',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                if (_this.disabled) {
                    return;
                }
                _this.disabled = true;
                _this.updateButton(user.id, { spinner: true });
                _this.messagesProvider.isContact(user.id).then(function (isContact) {
                    if (isContact) {
                        var message = _this.translate.instant('addon.messages.removecontactconfirm', { $a: user.fullname });
                        var okText = _this.translate.instant('core.remove');
                        return _this.domUtils.showConfirm(message, undefined, okText).then(function () {
                            return _this.messagesProvider.removeContact(user.id);
                        });
                    }
                    else {
                        return _this.addContact(user);
                    }
                }).catch(function (error) {
                    _this.domUtils.showErrorModalDefault(error, 'core.error', true);
                }).finally(function () {
                    _this.eventsProvider.trigger(AddonMessagesAddContactUserHandler_1.UPDATED_EVENT, { userId: user.id });
                    _this.checkButton(user.id).finally(function () {
                        _this.disabled = false;
                    });
                });
            }
        };
    };
    /**
     * Update Button with avalaible data.
     * @param {number} userId User Id to update.
     * @return {Promise<void>}   Promise resolved when done.
     */
    AddonMessagesAddContactUserHandler.prototype.checkButton = function (userId) {
        var _this = this;
        this.updateButton(userId, { spinner: true });
        var groupMessagingEnabled = this.messagesProvider.isGroupMessagingEnabled();
        return this.messagesProvider.isContact(userId).then(function (isContact) {
            if (isContact) {
                _this.updateButton(userId, {
                    title: groupMessagingEnabled ? 'addon.messages.removefromyourcontacts' : 'addon.messages.removecontact',
                    class: 'addon-messages-removecontact-handler',
                    icon: 'remove',
                    hidden: false,
                    spinner: false
                });
            }
            else {
                _this.updateButton(userId, {
                    title: groupMessagingEnabled ? 'addon.messages.addtoyourcontacts' : 'addon.messages.addcontact',
                    class: 'addon-messages-addcontact-handler',
                    icon: 'add',
                    hidden: false,
                    spinner: false
                });
            }
        }).catch(function () {
            // This fails for some reason, let's just hide the button.
            _this.updateButton(userId, { hidden: true });
        });
    };
    /**
     * Triggers the event to update the handler information.
     *
     * @param {number} userId The user ID the handler belongs to.
     * @param {any} data Data that should be updated.
     */
    AddonMessagesAddContactUserHandler.prototype.updateButton = function (userId, data) {
        // This fails for some reason, let's just hide the button.
        this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].UPDATE_HANDLER_EVENT, { handler: this.name, data: data, userId: userId });
    };
    /**
     * Add a contact or send a contact request if group messaging is enabled.
     *
     * @param {any} user User to add as contact.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonMessagesAddContactUserHandler.prototype.addContact = function (user) {
        var _this = this;
        if (!this.messagesProvider.isGroupMessagingEnabled()) {
            return this.messagesProvider.addContact(user.id);
        }
        return this.messagesProvider.getMemberInfo(user.id).then(function (member) {
            var currentUserId = _this.sitesProvider.getCurrentSiteUserId();
            var requestSent = member.contactrequests.some(function (request) {
                return request.userid == currentUserId && request.requesteduserid == user.id;
            });
            if (requestSent) {
                var message_1 = _this.translate.instant('addon.messages.yourcontactrequestpending', { $a: user.fullname });
                return _this.domUtils.showAlert(null, message_1);
            }
            var message = _this.translate.instant('addon.messages.addcontactconfirm', { $a: user.fullname });
            var okText = _this.translate.instant('core.add');
            return _this.domUtils.showConfirm(message, undefined, okText).then(function () {
                return _this.messagesProvider.createContactRequest(user.id);
            }).then(function () {
                var message = _this.translate.instant('addon.messages.contactrequestsent');
                return _this.domUtils.showAlert(null, message);
            });
        });
    };
    /**
     * Destroyed method.
     */
    AddonMessagesAddContactUserHandler.prototype.ngOnDestroy = function () {
        this.updateObs && this.updateObs.off();
    };
    /**
     * Update handler information event.
     * @type {string}
     */
    AddonMessagesAddContactUserHandler.UPDATED_EVENT = 'AddonMessagesAddContactUserHandler_updated_event';
    AddonMessagesAddContactUserHandler = AddonMessagesAddContactUserHandler_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__messages__["a" /* AddonMessagesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonMessagesAddContactUserHandler);
    return AddonMessagesAddContactUserHandler;
    var AddonMessagesAddContactUserHandler_1;
}());

//# sourceMappingURL=user-add-contact-handler.js.map

/***/ }),
/* 831 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesBlockContactUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__messages__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__user_add_contact_handler__ = __webpack_require__(830);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Profile block/unblock contact handler.
 */
var AddonMessagesBlockContactUserHandler = /** @class */ (function () {
    function AddonMessagesBlockContactUserHandler(sitesProvider, messagesProvider, eventsProvider, domUtils, translate) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.messagesProvider = messagesProvider;
        this.eventsProvider = eventsProvider;
        this.domUtils = domUtils;
        this.translate = translate;
        this.name = 'AddonMessages:blockContact';
        this.priority = 600;
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_ACTION;
        this.disabled = false;
        this.updateObs = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__user_add_contact_handler__["a" /* AddonMessagesAddContactUserHandler */].UPDATED_EVENT, function (data) {
            _this.checkButton(data.userId);
        });
    }
    AddonMessagesBlockContactUserHandler_1 = AddonMessagesBlockContactUserHandler;
    /**
     * Check if handler is enabled.
     *
     * @return {Promise<boolean>} Promise resolved with true if enabled, rejected or resolved with false otherwise.
     */
    AddonMessagesBlockContactUserHandler.prototype.isEnabled = function () {
        return this.messagesProvider.isPluginEnabled();
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user          User to check.
     * @param {number} courseId   Course ID.
     * @param  {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param  {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return  {boolean|Promise<boolean>}   Promise resolved with true if enabled, resolved with false otherwise.
     */
    AddonMessagesBlockContactUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        return user.id != this.sitesProvider.getCurrentSiteUserId();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonMessagesBlockContactUserHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        this.checkButton(user.id);
        return {
            icon: '',
            title: '',
            spinner: false,
            class: '',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                if (_this.disabled) {
                    return;
                }
                _this.disabled = true;
                _this.updateButton(user.id, { spinner: true });
                _this.messagesProvider.isBlocked(user.id).then(function (isBlocked) {
                    if (isBlocked) {
                        var template = _this.translate.instant('addon.messages.unblockuserconfirm', { $a: user.fullname });
                        var okText = _this.translate.instant('addon.messages.unblockuser');
                        return _this.domUtils.showConfirm(template, undefined, okText).then(function () {
                            return _this.messagesProvider.unblockContact(user.id);
                        });
                    }
                    else {
                        var template = _this.translate.instant('addon.messages.blockuserconfirm', { $a: user.fullname });
                        var okText = _this.translate.instant('addon.messages.blockuser');
                        return _this.domUtils.showConfirm(template, undefined, okText).then(function () {
                            return _this.messagesProvider.blockContact(user.id);
                        });
                    }
                }).catch(function (error) {
                    _this.domUtils.showErrorModalDefault(error, 'core.error', true);
                }).finally(function () {
                    _this.eventsProvider.trigger(AddonMessagesBlockContactUserHandler_1.UPDATED_EVENT, { userId: user.id });
                    _this.checkButton(user.id).finally(function () {
                        _this.disabled = false;
                    });
                });
            }
        };
    };
    /**
     * Update Button with avalaible data.
     * @param {number} userId User Id to update.
     * @return {Promise<void>}   Promise resolved when done.
     */
    AddonMessagesBlockContactUserHandler.prototype.checkButton = function (userId) {
        var _this = this;
        this.updateButton(userId, { spinner: true });
        return this.messagesProvider.isBlocked(userId).then(function (isBlocked) {
            if (isBlocked) {
                _this.updateButton(userId, {
                    title: 'addon.messages.unblockuser',
                    class: 'addon-messages-unblockcontact-handler',
                    icon: 'checkmark-circle',
                    hidden: false,
                    spinner: false
                });
            }
            else {
                _this.updateButton(userId, {
                    title: 'addon.messages.blockuser',
                    class: 'addon-messages-blockcontact-handler',
                    icon: 'close-circle',
                    hidden: false,
                    spinner: false
                });
            }
        }).catch(function () {
            // This fails for some reason, let's just hide the button.
            _this.updateButton(userId, { hidden: true });
        });
    };
    /**
     * Triggers the event to update the handler information.
     *
     * @param {number} userId The user ID the handler belongs to.
     * @param {any} data Data that should be updated.
     */
    AddonMessagesBlockContactUserHandler.prototype.updateButton = function (userId, data) {
        // This fails for some reason, let's just hide the button.
        this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].UPDATE_HANDLER_EVENT, { handler: this.name, data: data, userId: userId });
    };
    /**
     * Destroyed method.
     */
    AddonMessagesBlockContactUserHandler.prototype.ngOnDestroy = function () {
        this.updateObs && this.updateObs.off();
    };
    /**
     * Update handler information event.
     * @type {string}
     */
    AddonMessagesBlockContactUserHandler.UPDATED_EVENT = 'AddonMessagesBlockContactUserHandler_updated_event';
    AddonMessagesBlockContactUserHandler = AddonMessagesBlockContactUserHandler_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__messages__["a" /* AddonMessagesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonMessagesBlockContactUserHandler);
    return AddonMessagesBlockContactUserHandler;
    var AddonMessagesBlockContactUserHandler_1;
}());

//# sourceMappingURL=user-block-contact-handler.js.map

/***/ }),
/* 832 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_ASSIGN_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModAssignModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_assign_sync__ = __webpack_require__(222);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_default_feedback_handler__ = __webpack_require__(767);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_default_submission_handler__ = __webpack_require__(769);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_module_handler__ = __webpack_require__(1557);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__ = __webpack_require__(1558);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__ = __webpack_require__(1559);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_index_link_handler__ = __webpack_require__(1560);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_list_link_handler__ = __webpack_require__(1561);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_push_click_handler__ = __webpack_require__(1562);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__submission_submission_module__ = __webpack_require__(1563);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__feedback_feedback_module__ = __webpack_require__(1569);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};























// List of providers (without handlers).
var ADDON_MOD_ASSIGN_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_6__providers_assign__["a" /* AddonModAssignProvider */],
    __WEBPACK_IMPORTED_MODULE_7__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_8__providers_assign_sync__["a" /* AddonModAssignSyncProvider */],
    __WEBPACK_IMPORTED_MODULE_9__providers_helper__["a" /* AddonModAssignHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_10__providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */],
    __WEBPACK_IMPORTED_MODULE_11__providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */]
];
var AddonModAssignModule = /** @class */ (function () {
    function AddonModAssignModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, updateManager, contentLinksDelegate, linkHandler, listLinkHandler, pushNotificationsDelegate, pushClickHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTablesMigration([
            {
                name: 'mma_mod_assign_submissions',
                newName: __WEBPACK_IMPORTED_MODULE_7__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */].SUBMISSIONS_TABLE,
                fields: [
                    {
                        name: 'assignmentid',
                        newName: 'assignid'
                    },
                    {
                        name: 'submitted',
                        type: 'boolean'
                    },
                    {
                        name: 'submissionstatement',
                        type: 'boolean'
                    },
                    {
                        name: 'plugindata',
                        type: 'object'
                    }
                ]
            },
            {
                name: 'mma_mod_assign_submissions_grading',
                newName: __WEBPACK_IMPORTED_MODULE_7__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */].SUBMISSIONS_GRADES_TABLE,
                fields: [
                    {
                        name: 'assignmentid',
                        newName: 'assignid'
                    },
                    {
                        name: 'addattempt',
                        type: 'boolean'
                    },
                    {
                        name: 'applytoall',
                        type: 'boolean'
                    },
                    {
                        name: 'outcomes',
                        type: 'object'
                    },
                    {
                        name: 'plugindata',
                        type: 'object'
                    }
                ]
            }
        ]);
    }
    AddonModAssignModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_20__submission_submission_module__["a" /* AddonModAssignSubmissionModule */],
                __WEBPACK_IMPORTED_MODULE_21__feedback_feedback_module__["a" /* AddonModAssignFeedbackModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_assign__["a" /* AddonModAssignProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_assign_sync__["a" /* AddonModAssignSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_9__providers_helper__["a" /* AddonModAssignHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_10__providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */],
                __WEBPACK_IMPORTED_MODULE_11__providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */],
                __WEBPACK_IMPORTED_MODULE_12__providers_default_feedback_handler__["a" /* AddonModAssignDefaultFeedbackHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_default_submission_handler__["a" /* AddonModAssignDefaultSubmissionHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_module_handler__["a" /* AddonModAssignModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__["a" /* AddonModAssignPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__["a" /* AddonModAssignSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_17__providers_index_link_handler__["a" /* AddonModAssignIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_18__providers_list_link_handler__["a" /* AddonModAssignListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_19__providers_push_click_handler__["a" /* AddonModAssignPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_14__providers_module_handler__["a" /* AddonModAssignModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__["a" /* AddonModAssignPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__["a" /* AddonModAssignSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_22__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_17__providers_index_link_handler__["a" /* AddonModAssignIndexLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_18__providers_list_link_handler__["a" /* AddonModAssignListLinkHandler */], __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */],
            __WEBPACK_IMPORTED_MODULE_19__providers_push_click_handler__["a" /* AddonModAssignPushClickHandler */]])
    ], AddonModAssignModule);
    return AddonModAssignModule;
}());

//# sourceMappingURL=assign.module.js.map

/***/ }),
/* 833 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionCommentsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_comments_providers_comments__ = __webpack_require__(134);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_comments_components_comments_comments__ = __webpack_require__(762);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_submission_plugin_component__ = __webpack_require__(369);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to render a comments submission plugin.
 */
var AddonModAssignSubmissionCommentsComponent = /** @class */ (function (_super) {
    __extends(AddonModAssignSubmissionCommentsComponent, _super);
    function AddonModAssignSubmissionCommentsComponent(commentsProvider) {
        var _this = _super.call(this) || this;
        _this.commentsProvider = commentsProvider;
        _this.commentsEnabled = !commentsProvider.areCommentsDisabledInSite();
        return _this;
    }
    /**
     * Invalidate the data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionCommentsComponent.prototype.invalidate = function () {
        return this.commentsProvider.invalidateCommentsData('module', this.assign.cmid, 'assignsubmission_comments', this.submission.id, 'submission_comments');
    };
    /**
     * Show the comments.
     */
    AddonModAssignSubmissionCommentsComponent.prototype.showComments = function () {
        this.commentsComponent && this.commentsComponent.openComments();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2__core_comments_components_comments_comments__["a" /* CoreCommentsCommentsComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2__core_comments_components_comments_comments__["a" /* CoreCommentsCommentsComponent */])
    ], AddonModAssignSubmissionCommentsComponent.prototype, "commentsComponent", void 0);
    AddonModAssignSubmissionCommentsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-submission-comments',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\submission\comments\component\addon-mod-assign-submission-comments.html"*/'<a *ngIf="commentsEnabled" ion-item text-wrap (click)="showComments()" detail-none>\n    <h2>{{plugin.name}}</h2>\n    <core-comments contextLevel="module" [instanceId]="assign.cmid" component="assignsubmission_comments" [itemId]="submission.id" area="submission_comments" [title]="plugin.name"></core-comments>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\submission\comments\component\addon-mod-assign-submission-comments.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_comments_providers_comments__["a" /* CoreCommentsProvider */]])
    ], AddonModAssignSubmissionCommentsComponent);
    return AddonModAssignSubmissionCommentsComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_submission_plugin_component__["a" /* AddonModAssignSubmissionPluginComponent */]));

//# sourceMappingURL=comments.js.map

/***/ }),
/* 834 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__component_file__ = __webpack_require__(835);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Handler for file submission plugin.
 */
var AddonModAssignSubmissionFileHandler = /** @class */ (function () {
    function AddonModAssignSubmissionFileHandler(sitesProvider, wsProvider, assignProvider, assignOfflineProvider, assignHelper, fileSessionProvider, fileUploaderProvider, filepoolProvider, fileProvider, utils) {
        this.sitesProvider = sitesProvider;
        this.wsProvider = wsProvider;
        this.assignProvider = assignProvider;
        this.assignOfflineProvider = assignOfflineProvider;
        this.assignHelper = assignHelper;
        this.fileSessionProvider = fileSessionProvider;
        this.fileUploaderProvider = fileUploaderProvider;
        this.filepoolProvider = filepoolProvider;
        this.fileProvider = fileProvider;
        this.utils = utils;
        this.name = 'AddonModAssignSubmissionFileHandler';
        this.type = 'file';
    }
    AddonModAssignSubmissionFileHandler_1 = AddonModAssignSubmissionFileHandler;
    /**
     * Whether the plugin can be edited in offline for existing submissions. In general, this should return false if the
     * plugin uses Moodle filters. The reason is that the app only prefetches filtered data, and the user should edit
     * unfiltered data.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @return {boolean|Promise<boolean>} Boolean or promise resolved with boolean: whether it can be edited in offline.
     */
    AddonModAssignSubmissionFileHandler.prototype.canEditOffline = function (assign, submission, plugin) {
        // This plugin doesn't use Moodle filters, it can be edited in offline.
        return true;
    };
    /**
     * Should clear temporary data for a cancelled submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     */
    AddonModAssignSubmissionFileHandler.prototype.clearTmpData = function (assign, submission, plugin, inputData) {
        var files = this.fileSessionProvider.getFiles(__WEBPACK_IMPORTED_MODULE_8__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, assign.id);
        // Clear the files in session for this assign.
        this.fileSessionProvider.clearFiles(__WEBPACK_IMPORTED_MODULE_8__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, assign.id);
        // Now delete the local files from the tmp folder.
        this.fileUploaderProvider.clearTmpFiles(files);
    };
    /**
     * This function will be called when the user wants to create a new submission based on the previous one.
     * It should add to pluginData the data to send to server based in the data in plugin (previous attempt).
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @param {any} pluginData Object where to store the data to send.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignSubmissionFileHandler.prototype.copySubmissionData = function (assign, plugin, pluginData, userId, siteId) {
        // We need to re-upload all the existing files.
        var files = this.assignProvider.getSubmissionPluginAttachments(plugin);
        return this.assignHelper.uploadFiles(assign.id, files).then(function (itemId) {
            pluginData.files_filemanager = itemId;
        });
    };
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignSubmissionFileHandler.prototype.getComponent = function (injector, plugin, edit) {
        return __WEBPACK_IMPORTED_MODULE_11__component_file__["a" /* AddonModAssignSubmissionFileComponent */];
    };
    /**
     * Delete any stored data for the plugin and submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} offlineData Offline data stored.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignSubmissionFileHandler.prototype.deleteOfflineData = function (assign, submission, plugin, offlineData, siteId) {
        return this.assignHelper.deleteStoredSubmissionFiles(assign.id, AddonModAssignSubmissionFileHandler_1.FOLDER_NAME, submission.userid, siteId).catch(function () {
            // Ignore errors, maybe the folder doesn't exist.
        });
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]|Promise<any[]>} The files (or promise resolved with the files).
     */
    AddonModAssignSubmissionFileHandler.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return this.assignProvider.getSubmissionPluginAttachments(plugin);
    };
    /**
     * Get the size of data (in bytes) this plugin will send to copy a previous submission.
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @return {number|Promise<number>} The size (or promise resolved with size).
     */
    AddonModAssignSubmissionFileHandler.prototype.getSizeForCopy = function (assign, plugin) {
        var _this = this;
        var files = this.assignProvider.getSubmissionPluginAttachments(plugin), promises = [];
        var totalSize = 0;
        files.forEach(function (file) {
            promises.push(_this.wsProvider.getRemoteFileSize(file.fileurl).then(function (size) {
                if (size == -1) {
                    // Couldn't determine the size, reject.
                    return Promise.reject(null);
                }
                totalSize += size;
            }));
        });
        return Promise.all(promises).then(function () {
            return totalSize;
        });
    };
    /**
     * Get the size of data (in bytes) this plugin will send to add or edit a submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {number|Promise<number>} The size (or promise resolved with size).
     */
    AddonModAssignSubmissionFileHandler.prototype.getSizeForEdit = function (assign, submission, plugin, inputData) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        // Check if there's any change.
        if (this.hasDataChanged(assign, submission, plugin, inputData)) {
            var files = this.fileSessionProvider.getFiles(__WEBPACK_IMPORTED_MODULE_8__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, assign.id), promises_1 = [];
            var totalSize_1 = 0;
            files.forEach(function (file) {
                if (file.filename && !file.name) {
                    // It's a remote file. First check if we have the file downloaded since it's more reliable.
                    promises_1.push(_this.filepoolProvider.getFilePathByUrl(siteId, file.fileurl).then(function (path) {
                        return _this.fileProvider.getFile(path).then(function (fileEntry) {
                            return _this.fileProvider.getFileObjectFromFileEntry(fileEntry);
                        }).then(function (file) {
                            totalSize_1 += file.size;
                        });
                    }).catch(function () {
                        // Error getting the file, maybe it's not downloaded. Get remote size.
                        return _this.wsProvider.getRemoteFileSize(file.fileurl).then(function (size) {
                            if (size == -1) {
                                // Couldn't determine the size, reject.
                                return Promise.reject(null);
                            }
                            totalSize_1 += size;
                        });
                    }));
                }
                else if (file.name) {
                    // It's a local file, get its size.
                    promises_1.push(_this.fileProvider.getFileObjectFromFileEntry(file).then(function (file) {
                        totalSize_1 += file.size;
                    }));
                }
            });
            return Promise.all(promises_1).then(function () {
                return totalSize_1;
            });
        }
        else {
            // Nothing has changed, we won't upload any file.
            return 0;
        }
    };
    /**
     * Check if the submission data has changed for this plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {boolean|Promise<boolean>} Boolean (or promise resolved with boolean): whether the data has changed.
     */
    AddonModAssignSubmissionFileHandler.prototype.hasDataChanged = function (assign, submission, plugin, inputData) {
        var _this = this;
        // Check if there's any offline data.
        return this.assignOfflineProvider.getSubmission(assign.id, submission.userid).catch(function () {
            // No offline data found.
        }).then(function (offlineData) {
            if (offlineData && offlineData.plugindata && offlineData.plugindata.files_filemanager) {
                // Has offline data, return the number of files.
                return offlineData.plugindata.files_filemanager.offline + offlineData.plugindata.files_filemanager.online.length;
            }
            // No offline data, return the number of online files.
            var pluginFiles = _this.assignProvider.getSubmissionPluginAttachments(plugin);
            return pluginFiles && pluginFiles.length;
        }).then(function (numFiles) {
            var currentFiles = _this.fileSessionProvider.getFiles(__WEBPACK_IMPORTED_MODULE_8__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, assign.id);
            if (currentFiles.length != numFiles) {
                // Number of files has changed.
                return true;
            }
            // Search if there is any local file added.
            for (var i = 0; i < currentFiles.length; i++) {
                var file = currentFiles[i];
                if (!file.filename && typeof file.name != 'undefined' && !file.offline) {
                    // There's a local file added, list has changed.
                    return true;
                }
            }
            // No local files and list length is the same, this means the list hasn't changed.
            return false;
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignSubmissionFileHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether or not the handler is enabled for edit on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled for edit on a site level.
     */
    AddonModAssignSubmissionFileHandler.prototype.isEnabledForEdit = function () {
        return true;
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the input data.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @param {any} pluginData Object where to store the data to send.
     * @param {boolean} [offline] Whether the user is editing in offline.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignSubmissionFileHandler.prototype.prepareSubmissionData = function (assign, submission, plugin, inputData, pluginData, offline, userId, siteId) {
        if (this.hasDataChanged(assign, submission, plugin, inputData)) {
            // Data has changed, we need to upload new files and re-upload all the existing files.
            var currentFiles = this.fileSessionProvider.getFiles(__WEBPACK_IMPORTED_MODULE_8__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT, assign.id), error = this.utils.hasRepeatedFilenames(currentFiles);
            if (error) {
                return Promise.reject(error);
            }
            return this.assignHelper.uploadOrStoreFiles(assign.id, AddonModAssignSubmissionFileHandler_1.FOLDER_NAME, currentFiles, offline, userId, siteId).then(function (result) {
                pluginData.files_filemanager = result;
            });
        }
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the offline data stored.
     * This will be used when performing a synchronization.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} offlineData Offline data stored.
     * @param {any} pluginData Object where to store the data to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignSubmissionFileHandler.prototype.prepareSyncData = function (assign, submission, plugin, offlineData, pluginData, siteId) {
        var _this = this;
        var filesData = offlineData && offlineData.plugindata && offlineData.plugindata.files_filemanager;
        if (filesData) {
            // Has some data to sync.
            var files_1 = filesData.online || [], promise = void 0;
            if (filesData.offline) {
                // Has offline files, get them and add them to the list.
                promise = this.assignHelper.getStoredSubmissionFiles(assign.id, AddonModAssignSubmissionFileHandler_1.FOLDER_NAME, submission.userid, siteId).then(function (result) {
                    files_1 = files_1.concat(result);
                }).catch(function () {
                    // Folder not found, no files to add.
                });
            }
            else {
                promise = Promise.resolve();
            }
            return promise.then(function () {
                return _this.assignHelper.uploadFiles(assign.id, files_1, siteId).then(function (itemId) {
                    pluginData.files_filemanager = itemId;
                });
            });
        }
    };
    AddonModAssignSubmissionFileHandler.FOLDER_NAME = 'submission_file';
    AddonModAssignSubmissionFileHandler = AddonModAssignSubmissionFileHandler_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_ws__["a" /* CoreWSProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_helper__["a" /* AddonModAssignHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_file_session__["a" /* CoreFileSessionProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_file__["a" /* CoreFileProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModAssignSubmissionFileHandler);
    return AddonModAssignSubmissionFileHandler;
    var AddonModAssignSubmissionFileHandler_1;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 835 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionFileComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(834);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__classes_submission_plugin_component__ = __webpack_require__(369);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Component to render a file submission plugin.
 */
var AddonModAssignSubmissionFileComponent = /** @class */ (function (_super) {
    __extends(AddonModAssignSubmissionFileComponent, _super);
    function AddonModAssignSubmissionFileComponent(fileSessionprovider, assignProvider, assignOfflineProvider, assignHelper, fileUploaderProvider) {
        var _this = _super.call(this) || this;
        _this.fileSessionprovider = fileSessionprovider;
        _this.assignProvider = assignProvider;
        _this.assignOfflineProvider = assignOfflineProvider;
        _this.assignHelper = assignHelper;
        _this.fileUploaderProvider = fileUploaderProvider;
        _this.component = __WEBPACK_IMPORTED_MODULE_3__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModAssignSubmissionFileComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Get the offline data.
        this.assignOfflineProvider.getSubmission(this.assign.id).catch(function () {
            // Error getting data, assume there's no offline submission.
        }).then(function (offlineData) {
            if (offlineData && offlineData.plugindata && offlineData.plugindata.files_filemanager) {
                // It has offline data.
                var promise = void 0;
                if (offlineData.plugindata.files_filemanager.offline) {
                    promise = _this.assignHelper.getStoredSubmissionFiles(_this.assign.id, __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonModAssignSubmissionFileHandler */].FOLDER_NAME);
                }
                else {
                    promise = Promise.resolve([]);
                }
                return promise.then(function (offlineFiles) {
                    var onlineFiles = offlineData.plugindata.files_filemanager.online || [];
                    offlineFiles = _this.fileUploaderProvider.markOfflineFiles(offlineFiles);
                    _this.files = onlineFiles.concat(offlineFiles);
                });
            }
            else {
                // No offline data, get the online files.
                _this.files = _this.assignProvider.getSubmissionPluginAttachments(_this.plugin);
            }
        }).finally(function () {
            _this.fileSessionprovider.setFiles(_this.component, _this.assign.id, _this.files);
        });
    };
    AddonModAssignSubmissionFileComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-submission-file',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\submission\file\component\addon-mod-assign-submission-file.html"*/'<!-- Read only. -->\n<ion-item text-wrap *ngIf="files && files.length && !edit">\n    <h2>{{plugin.name}}</h2>\n    <div no-lines>\n        <ng-container *ngFor="let file of files">\n            <!-- Files already attached to the submission. -->\n            <core-file *ngIf="!file.name" [file]="file" [component]="component" [componentId]="assign.cmid" [alwaysDownload]="true"></core-file>\n\n            <!-- Files stored in offline to be sent later. -->\n            <core-local-file *ngIf="file.name" [file]="file"></core-local-file>\n        </ng-container>\n    </div>\n</ion-item>\n\n<!-- Edit -->\n<div *ngIf="edit">\n    <ion-item-divider text-wrap>{{plugin.name}}</ion-item-divider>\n    <core-attachments [files]="files" [maxSize]="configs.maxsubmissionsizebytes" [maxSubmissions]="configs.maxfilesubmissions" [component]="component" [componentId]="assign.cmid" [acceptedTypes]="configs.filetypeslist" [allowOffline]="allowOffline"></core-attachments>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\submission\file\component\addon-mod-assign-submission-file.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_file_session__["a" /* CoreFileSessionProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_assign__["a" /* AddonModAssignProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_helper__["a" /* AddonModAssignHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_2__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */]])
    ], AddonModAssignSubmissionFileComponent);
    return AddonModAssignSubmissionFileComponent;
}(__WEBPACK_IMPORTED_MODULE_7__classes_submission_plugin_component__["a" /* AddonModAssignSubmissionPluginComponent */]));

//# sourceMappingURL=file.js.map

/***/ }),
/* 836 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionOnlineTextComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_submission_plugin_component__ = __webpack_require__(369);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component to render an onlinetext submission plugin.
 */
var AddonModAssignSubmissionOnlineTextComponent = /** @class */ (function (_super) {
    __extends(AddonModAssignSubmissionOnlineTextComponent, _super);
    function AddonModAssignSubmissionOnlineTextComponent(fb, domUtils, textUtils, assignProvider, assignOfflineProvider, element) {
        var _this = _super.call(this) || this;
        _this.fb = fb;
        _this.domUtils = domUtils;
        _this.textUtils = textUtils;
        _this.assignProvider = assignProvider;
        _this.assignOfflineProvider = assignOfflineProvider;
        _this.component = __WEBPACK_IMPORTED_MODULE_4__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        _this.element = element.nativeElement;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModAssignSubmissionOnlineTextComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Get the text. Check if we have anything offline.
        this.assignOfflineProvider.getSubmission(this.assign.id).catch(function () {
            // No offline data found.
        }).then(function (offlineData) {
            if (offlineData && offlineData.plugindata && offlineData.plugindata.onlinetext_editor) {
                return offlineData.plugindata.onlinetext_editor.text;
            }
            // No offline data found, return online text.
            return _this.assignProvider.getSubmissionPluginText(_this.plugin);
        }).then(function (text) {
            // We receive them as strings, convert to int.
            _this.configs.wordlimit = parseInt(_this.configs.wordlimit, 10);
            _this.configs.wordlimitenabled = parseInt(_this.configs.wordlimitenabled, 10);
            // Set the text.
            _this.text = text;
            if (!_this.edit) {
                // Not editing, see full text when clicked.
                _this.element.addEventListener('click', function (e) {
                    e.preventDefault();
                    e.stopPropagation();
                    if (text) {
                        // Open a new state with the interpolated contents.
                        _this.textUtils.expandText(_this.plugin.name, text, _this.component, _this.assign.cmid);
                    }
                });
            }
            else {
                // Create and add the control.
                _this.control = _this.fb.control(text);
            }
            // Calculate initial words.
            if (_this.configs.wordlimitenabled) {
                _this.words = _this.textUtils.countWords(text);
            }
        }).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Text changed.
     *
     * @param {string} text The new text.
     */
    AddonModAssignSubmissionOnlineTextComponent.prototype.onChange = function (text) {
        var _this = this;
        // Count words if needed.
        if (this.configs.wordlimitenabled) {
            // Cancel previous wait.
            clearTimeout(this.wordCountTimeout);
            // Wait before calculating, if the user keeps inputing we won't calculate.
            // This is to prevent slowing down devices, this calculation can be slow if the text is long.
            this.wordCountTimeout = setTimeout(function () {
                _this.words = _this.textUtils.countWords(text);
            }, 1500);
        }
    };
    AddonModAssignSubmissionOnlineTextComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-submission-online-text',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\submission\onlinetext\component\addon-mod-assign-submission-onlinetext.html"*/'<!-- Read only -->\n<ion-item text-wrap *ngIf="!edit && text">\n    <h2>{{ plugin.name }}</h2>\n    <p *ngIf="words">{{ \'addon.mod_assign.numwords\' | translate: {\'$a\': words} }}</p>\n    <p>\n        <core-format-text [component]="component" [componentId]="assign.cmid" [maxHeight]="80" [fullOnClick]="true" [fullTitle]="plugin.name" [text]="text"></core-format-text>\n    </p>\n</ion-item>\n\n<!-- Edit -->\n<div *ngIf="edit && loaded">\n    <ion-item-divider text-wrap>{{ plugin.name }}</ion-item-divider>\n    <ion-item text-wrap *ngIf="configs.wordlimitenabled && words >= 0">\n        <h2>{{ \'addon.mod_assign.wordlimit\' | translate }}</h2>\n        <p>{{ \'core.numwords\' | translate: {\'$a\': words + \' / \' + configs.wordlimit} }}</p>\n    </ion-item>\n    <ion-item text-wrap>\n        <core-rich-text-editor item-content [control]="control" [placeholder]="plugin.name" name="onlinetext_editor_text" (contentChanged)="onChange($event)" [component]="component" [componentId]="assign.cmid"></core-rich-text-editor>\n    </ion-item>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\submission\onlinetext\component\addon-mod-assign-submission-onlinetext.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], AddonModAssignSubmissionOnlineTextComponent);
    return AddonModAssignSubmissionOnlineTextComponent;
}(__WEBPACK_IMPORTED_MODULE_6__classes_submission_plugin_component__["a" /* AddonModAssignSubmissionPluginComponent */]));

//# sourceMappingURL=onlinetext.js.map

/***/ }),
/* 837 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackCommentsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_comments__ = __webpack_require__(838);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler for comments feedback plugin.
 */
var AddonModAssignFeedbackCommentsHandler = /** @class */ (function () {
    function AddonModAssignFeedbackCommentsHandler(sitesProvider, textUtils, assignProvider, assignOfflineProvider) {
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.assignProvider = assignProvider;
        this.assignOfflineProvider = assignOfflineProvider;
        this.name = 'AddonModAssignFeedbackCommentsHandler';
        this.type = 'comments';
        this.drafts = {}; // Store the data in this service so it isn't lost if the user performs a PTR in the page.
    }
    AddonModAssignFeedbackCommentsHandler_1 = AddonModAssignFeedbackCommentsHandler;
    /**
     * Discard the draft data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.discardDraft = function (assignId, userId, siteId) {
        var id = this.getDraftId(assignId, userId, siteId);
        if (typeof this.drafts[id] != 'undefined') {
            delete this.drafts[id];
        }
    };
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_5__component_comments__["a" /* AddonModAssignFeedbackCommentsComponent */];
    };
    /**
     * Return the draft saved data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any|Promise<any>} Data (or promise resolved with the data).
     */
    AddonModAssignFeedbackCommentsHandler.prototype.getDraft = function (assignId, userId, siteId) {
        var id = this.getDraftId(assignId, userId, siteId);
        if (typeof this.drafts[id] != 'undefined') {
            return this.drafts[id];
        }
    };
    /**
     * Get a draft ID.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {string} Draft ID.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.getDraftId = function (assignId, userId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return siteId + '#' + assignId + '#' + userId;
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]|Promise<any[]>} The files (or promise resolved with the files).
     */
    AddonModAssignFeedbackCommentsHandler.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return this.assignProvider.getSubmissionPluginAttachments(plugin);
    };
    /**
     * Get the text to submit.
     *
     * @param {CoreTextUtilsProvider} textUtils Text utils instance.
     * @param {any} plugin Plugin.
     * @param {any} inputData Data entered in the feedback edit form.
     * @return {string} Text to submit.
     */
    AddonModAssignFeedbackCommentsHandler.getTextFromInputData = function (textUtils, plugin, inputData) {
        var files = plugin.fileareas && plugin.fileareas[0] ? plugin.fileareas[0].files : [];
        var text = inputData.assignfeedbackcomments_editor;
        // The input data can have a string or an object with text and format. Get the text.
        if (text && text.text) {
            text = text.text;
        }
        return textUtils.restorePluginfileUrls(text, files);
    };
    /**
     * Check if the feedback data has changed for this plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the feedback.
     * @param {number} userId User ID of the submission.
     * @return {boolean|Promise<boolean>} Boolean (or promise resolved with boolean): whether the data has changed.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.hasDataChanged = function (assign, submission, plugin, inputData, userId) {
        var _this = this;
        // Get it from plugin or offline.
        return this.assignOfflineProvider.getSubmissionGrade(assign.id, userId).catch(function () {
            // No offline data found.
        }).then(function (data) {
            if (data && data.plugindata && data.plugindata.assignfeedbackcomments_editor) {
                return data.plugindata.assignfeedbackcomments_editor.text;
            }
            // No offline data found, get text from plugin.
            return _this.assignProvider.getSubmissionPluginText(plugin);
        }).then(function (initialText) {
            var newText = AddonModAssignFeedbackCommentsHandler_1.getTextFromInputData(_this.textUtils, plugin, inputData);
            if (typeof newText == 'undefined') {
                return false;
            }
            // Check if text has changed.
            return initialText != newText;
        });
    };
    /**
     * Check whether the plugin has draft data stored.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Boolean or promise resolved with boolean: whether the plugin has draft data.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.hasDraftData = function (assignId, userId, siteId) {
        var draft = this.getDraft(assignId, userId, siteId);
        return !!draft;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the draft data saved.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {any} pluginData Object where to store the data to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.prepareFeedbackData = function (assignId, userId, plugin, pluginData, siteId) {
        var draft = this.getDraft(assignId, userId, siteId);
        if (draft) {
            // Add some HTML to the text if needed.
            draft.text = this.textUtils.formatHtmlLines(draft.text);
            pluginData.assignfeedbackcomments_editor = draft;
        }
    };
    /**
     * Save draft data of the feedback plugin.
     *
     * @param {number} assignId The assignment ID.
     * @param {number} userId User ID.
     * @param {any} plugin The plugin object.
     * @param {any} data The data to save.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignFeedbackCommentsHandler.prototype.saveDraft = function (assignId, userId, plugin, data, siteId) {
        if (data) {
            this.drafts[this.getDraftId(assignId, userId, siteId)] = data;
        }
    };
    AddonModAssignFeedbackCommentsHandler = AddonModAssignFeedbackCommentsHandler_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */]])
    ], AddonModAssignFeedbackCommentsHandler);
    return AddonModAssignFeedbackCommentsHandler;
    var AddonModAssignFeedbackCommentsHandler_1;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 838 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackCommentsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__classes_feedback_plugin_component__ = __webpack_require__(370);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_handler__ = __webpack_require__(837);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Component to render a comments feedback plugin.
 */
var AddonModAssignFeedbackCommentsComponent = /** @class */ (function (_super) {
    __extends(AddonModAssignFeedbackCommentsComponent, _super);
    function AddonModAssignFeedbackCommentsComponent(modalCtrl, element, domUtils, textUtils, assignOfflineProvider, assignProvider, fb, feedbackDelegate) {
        var _this = _super.call(this, modalCtrl) || this;
        _this.domUtils = domUtils;
        _this.textUtils = textUtils;
        _this.assignOfflineProvider = assignOfflineProvider;
        _this.assignProvider = assignProvider;
        _this.fb = fb;
        _this.feedbackDelegate = feedbackDelegate;
        _this.component = __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        _this.element = element.nativeElement;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModAssignFeedbackCommentsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.getText().then(function (text) {
            _this.text = text;
            if (!_this.canEdit && !_this.edit) {
                // User cannot edit the comment. Show it full when clicked.
                _this.element.addEventListener('click', function (e) {
                    e.preventDefault();
                    e.stopPropagation();
                    if (_this.text) {
                        // Open a new state with the text.
                        _this.textUtils.expandText(_this.plugin.name, _this.text, _this.component, _this.assign.cmid);
                    }
                });
            }
            else if (_this.edit) {
                _this.control = _this.fb.control(text);
            }
        }).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Edit the comment.
     */
    AddonModAssignFeedbackCommentsComponent.prototype.editComment = function () {
        var _this = this;
        this.editFeedback().then(function (inputData) {
            var text = __WEBPACK_IMPORTED_MODULE_9__providers_handler__["a" /* AddonModAssignFeedbackCommentsHandler */].getTextFromInputData(_this.textUtils, _this.plugin, inputData);
            // Update the text and save it as draft.
            _this.isSent = false;
            _this.text = _this.replacePluginfileUrls(text);
            _this.feedbackDelegate.saveFeedbackDraft(_this.assign.id, _this.userId, _this.plugin, {
                text: text,
                format: 1
            });
        }).catch(function () {
            // User cancelled, nothing to do.
        });
    };
    /**
     * Get the text for the plugin.
     *
     * @return {Promise<string>} Promise resolved with the text.
     */
    AddonModAssignFeedbackCommentsComponent.prototype.getText = function () {
        var _this = this;
        // Check if the user already modified the comment.
        return this.feedbackDelegate.getPluginDraftData(this.assign.id, this.userId, this.plugin).then(function (draft) {
            if (draft) {
                _this.isSent = false;
                return _this.replacePluginfileUrls(draft.text);
            }
            else {
                // There is no draft saved. Check if we have anything offline.
                return _this.assignOfflineProvider.getSubmissionGrade(_this.assign.id, _this.userId).catch(function () {
                    // No offline data found.
                }).then(function (offlineData) {
                    if (offlineData && offlineData.plugindata && offlineData.plugindata.assignfeedbackcomments_editor) {
                        // Save offline as draft.
                        _this.isSent = false;
                        _this.feedbackDelegate.saveFeedbackDraft(_this.assign.id, _this.userId, _this.plugin, offlineData.plugindata.assignfeedbackcomments_editor);
                        return _this.replacePluginfileUrls(offlineData.plugindata.assignfeedbackcomments_editor.text);
                    }
                    // No offline data found, return online text.
                    _this.isSent = true;
                    return _this.assignProvider.getSubmissionPluginText(_this.plugin);
                });
            }
        });
    };
    /**
     * Replace @@PLUGINFILE@@ wildcards with the real URL of embedded files.
     *
     * @param {string} Text to treat.
     * @return {string} Treated text.
     */
    AddonModAssignFeedbackCommentsComponent.prototype.replacePluginfileUrls = function (text) {
        var files = this.plugin.fileareas && this.plugin.fileareas[0] && this.plugin.fileareas[0].files;
        return this.textUtils.replacePluginfileUrls(text, files || []);
    };
    AddonModAssignFeedbackCommentsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-feedback-comments',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\feedback\comments\component\addon-mod-assign-feedback-comments.html"*/'<!-- Read only. -->\n<ion-item text-wrap *ngIf="(text || canEdit) && !edit">\n    <h2>{{ plugin.name }}</h2>\n    <p>\n        <core-format-text [component]="component" [componentId]="assign.cmid" [maxHeight]="80" [fullOnClick]="true" [fullTitle]="plugin.name" [text]="text"></core-format-text>\n    </p>\n    <div item-end>\n        <div text-end>\n            <button ion-button icon-only clear *ngIf="canEdit" (click)="editComment()" color="dark">\n                <ion-icon name="create"></ion-icon>\n            </button>\n        </div>\n        <ion-note *ngIf="!isSent" color="dark">\n            <ion-icon name="time"></ion-icon>\n            {{ \'core.notsent\' | translate }}\n        </ion-note>\n    </div>\n</ion-item>\n\n<!-- Edit -->\n<ion-item text-wrap *ngIf="edit && loaded">\n    <core-rich-text-editor item-content [control]="control" [placeholder]="plugin.name" name="assignfeedbackcomments_editor" [component]="component" [componentId]="assign.cmid"></core-rich-text-editor>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\feedback\comments\component\addon-mod-assign-feedback-comments.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_2__angular_forms__["a" /* FormBuilder */],
            __WEBPACK_IMPORTED_MODULE_7__providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */]])
    ], AddonModAssignFeedbackCommentsComponent);
    return AddonModAssignFeedbackCommentsComponent;
}(__WEBPACK_IMPORTED_MODULE_8__classes_feedback_plugin_component__["a" /* AddonModAssignFeedbackPluginComponentBase */]));

//# sourceMappingURL=comments.js.map

/***/ }),
/* 839 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackEditPdfComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_feedback_plugin_component__ = __webpack_require__(370);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to render a edit pdf feedback plugin.
 */
var AddonModAssignFeedbackEditPdfComponent = /** @class */ (function (_super) {
    __extends(AddonModAssignFeedbackEditPdfComponent, _super);
    function AddonModAssignFeedbackEditPdfComponent(modalCtrl, assignProvider) {
        var _this = _super.call(this, modalCtrl) || this;
        _this.assignProvider = assignProvider;
        _this.component = __WEBPACK_IMPORTED_MODULE_2__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModAssignFeedbackEditPdfComponent.prototype.ngOnInit = function () {
        if (this.plugin) {
            this.files = this.assignProvider.getSubmissionPluginAttachments(this.plugin);
        }
    };
    AddonModAssignFeedbackEditPdfComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-feedback-edit-pdf',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\feedback\editpdf\component\addon-mod-assign-feedback-editpdf.html"*/'<!-- Read only. -->\n<ion-item text-wrap *ngIf="files && files.length">\n    <h2>{{plugin.name}}</h2>\n    <div no-lines>\n        <core-file *ngFor="let file of files" [file]="file" [component]="component" [componentId]="assign.cmid" [alwaysDownload]="true"></core-file>\n    </div>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\feedback\editpdf\component\addon-mod-assign-feedback-editpdf.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_2__providers_assign__["a" /* AddonModAssignProvider */]])
    ], AddonModAssignFeedbackEditPdfComponent);
    return AddonModAssignFeedbackEditPdfComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_feedback_plugin_component__["a" /* AddonModAssignFeedbackPluginComponentBase */]));

//# sourceMappingURL=editpdf.js.map

/***/ }),
/* 840 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackFileComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_feedback_plugin_component__ = __webpack_require__(370);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to render a file feedback plugin.
 */
var AddonModAssignFeedbackFileComponent = /** @class */ (function (_super) {
    __extends(AddonModAssignFeedbackFileComponent, _super);
    function AddonModAssignFeedbackFileComponent(modalCtrl, assignProvider) {
        var _this = _super.call(this, modalCtrl) || this;
        _this.assignProvider = assignProvider;
        _this.component = __WEBPACK_IMPORTED_MODULE_2__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonModAssignFeedbackFileComponent.prototype.ngOnInit = function () {
        if (this.plugin) {
            this.files = this.assignProvider.getSubmissionPluginAttachments(this.plugin);
        }
    };
    AddonModAssignFeedbackFileComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-feedback-file',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\feedback\file\component\addon-mod-assign-feedback-file.html"*/'<!-- Read only. -->\n<ion-item text-wrap *ngIf="files && files.length">\n    <h2>{{plugin.name}}</h2>\n    <div no-lines>\n        <core-file *ngFor="let file of files" [file]="file" [component]="component" [componentId]="assign.cmid" [alwaysDownload]="true"></core-file>\n    </div>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\feedback\file\component\addon-mod-assign-feedback-file.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */], __WEBPACK_IMPORTED_MODULE_2__providers_assign__["a" /* AddonModAssignProvider */]])
    ], AddonModAssignFeedbackFileComponent);
    return AddonModAssignFeedbackFileComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_feedback_plugin_component__["a" /* AddonModAssignFeedbackPluginComponentBase */]));

//# sourceMappingURL=file.js.map

/***/ }),
/* 841 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_BOOK_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModBookModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_components_module__ = __webpack_require__(1000);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_book__ = __webpack_require__(212);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_module_handler__ = __webpack_require__(1575);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__ = __webpack_require__(1576);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__ = __webpack_require__(1577);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__ = __webpack_require__(772);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










// List of providers (without handlers).
var ADDON_MOD_BOOK_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_2__providers_book__["a" /* AddonModBookProvider */]
];
var AddonModBookModule = /** @class */ (function () {
    function AddonModBookModule(moduleDelegate, moduleHandler, contentLinksDelegate, linkHandler, prefetchDelegate, prefetchHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
    }
    AddonModBookModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__components_components_module__["a" /* AddonModBookComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_book__["a" /* AddonModBookProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_module_handler__["a" /* AddonModBookModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__["a" /* AddonModBookLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__["a" /* AddonModBookListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__["a" /* AddonModBookPrefetchHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_module_handler__["a" /* AddonModBookModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__["a" /* AddonModBookLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__["a" /* AddonModBookPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__["a" /* AddonModBookListLinkHandler */]])
    ], AddonModBookModule);
    return AddonModBookModule;
}());

//# sourceMappingURL=book.module.js.map

/***/ }),
/* 842 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_CHAT_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModChatModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(977);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_chat__ = __webpack_require__(219);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_link_handler__ = __webpack_require__(1578);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_list_link_handler__ = __webpack_require__(1579);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_module_handler__ = __webpack_require__(1580);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__ = __webpack_require__(1581);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










// List of providers (without handlers).
var ADDON_MOD_CHAT_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_5__providers_chat__["a" /* AddonModChatProvider */]
];
var AddonModChatModule = /** @class */ (function () {
    function AddonModChatModule(moduleDelegate, moduleHandler, contentLinksDelegate, linkHandler, prefetchDelegate, prefetchHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
    }
    AddonModChatModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* AddonModChatComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_chat__["a" /* AddonModChatProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_link_handler__["a" /* AddonModChatLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_list_link_handler__["a" /* AddonModChatListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_module_handler__["a" /* AddonModChatModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__["a" /* AddonModChatPrefetchHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_8__providers_module_handler__["a" /* AddonModChatModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_link_handler__["a" /* AddonModChatLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__["a" /* AddonModChatPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_7__providers_list_link_handler__["a" /* AddonModChatListLinkHandler */]])
    ], AddonModChatModule);
    return AddonModChatModule;
}());

//# sourceMappingURL=chat.module.js.map

/***/ }),
/* 843 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_CHOICE_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModChoiceModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1001);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__ = __webpack_require__(1582);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_choice__ = __webpack_require__(259);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__ = __webpack_require__(1583);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_list_link_handler__ = __webpack_require__(1584);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__ = __webpack_require__(774);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_sync__ = __webpack_require__(261);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_sync_cron_handler__ = __webpack_require__(1585);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_offline__ = __webpack_require__(260);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















// List of providers (without handlers).
var ADDON_MOD_CHOICE_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_7__providers_choice__["a" /* AddonModChoiceProvider */],
    __WEBPACK_IMPORTED_MODULE_11__providers_sync__["a" /* AddonModChoiceSyncProvider */],
    __WEBPACK_IMPORTED_MODULE_13__providers_offline__["a" /* AddonModChoiceOfflineProvider */]
];
var AddonModChoiceModule = /** @class */ (function () {
    function AddonModChoiceModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, cronDelegate, syncHandler, updateManager, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        cronDelegate.register(syncHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_mod_choice_offline_responses',
            newName: __WEBPACK_IMPORTED_MODULE_13__providers_offline__["a" /* AddonModChoiceOfflineProvider */].CHOICE_TABLE,
            fields: [
                {
                    name: 'responses',
                    type: 'object'
                },
                {
                    name: 'deleting',
                    type: 'boolean'
                }
            ]
        });
    }
    AddonModChoiceModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonModChoiceComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_choice__["a" /* AddonModChoiceProvider */],
                __WEBPACK_IMPORTED_MODULE_11__providers_sync__["a" /* AddonModChoiceSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_13__providers_offline__["a" /* AddonModChoiceOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__["a" /* AddonModChoiceModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__["a" /* AddonModChoicePrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__["a" /* AddonModChoiceLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_list_link_handler__["a" /* AddonModChoiceListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_sync_cron_handler__["a" /* AddonModChoiceSyncCronHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__["a" /* AddonModChoiceModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__["a" /* AddonModChoicePrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__["a" /* AddonModChoiceLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_12__providers_sync_cron_handler__["a" /* AddonModChoiceSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_14__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_list_link_handler__["a" /* AddonModChoiceListLinkHandler */]])
    ], AddonModChoiceModule);
    return AddonModChoiceModule;
}());

//# sourceMappingURL=choice.module.js.map

/***/ }),
/* 844 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_FEEDBACK_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModFeedbackModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(975);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_module_handler__ = __webpack_require__(1586);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_link_handler__ = __webpack_require__(1587);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_analysis_link_handler__ = __webpack_require__(1588);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_show_entries_link_handler__ = __webpack_require__(1589);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_show_non_respondents_link_handler__ = __webpack_require__(1590);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_complete_link_handler__ = __webpack_require__(1591);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_print_link_handler__ = __webpack_require__(1592);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_list_link_handler__ = __webpack_require__(1593);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_helper__ = __webpack_require__(184);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_prefetch_handler__ = __webpack_require__(845);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__ = __webpack_require__(1594);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_sync__ = __webpack_require__(224);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__providers_sync_cron_handler__ = __webpack_require__(1595);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__providers_offline__ = __webpack_require__(267);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};























// List of providers (without handlers).
var ADDON_MOD_FEEDBACK_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_8__providers_feedback__["a" /* AddonModFeedbackProvider */],
    __WEBPACK_IMPORTED_MODULE_16__providers_helper__["a" /* AddonModFeedbackHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_19__providers_sync__["a" /* AddonModFeedbackSyncProvider */],
    __WEBPACK_IMPORTED_MODULE_21__providers_offline__["a" /* AddonModFeedbackOfflineProvider */]
];
var AddonModFeedbackModule = /** @class */ (function () {
    function AddonModFeedbackModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, cronDelegate, syncHandler, analysisLinkHandler, updateManager, showEntriesLinkHandler, showNonRespondentsLinkHandler, completeLinkHandler, printLinkHandler, listLinkHandler, pushNotificationsDelegate, pushClickHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(analysisLinkHandler);
        contentLinksDelegate.registerHandler(showEntriesLinkHandler);
        contentLinksDelegate.registerHandler(showNonRespondentsLinkHandler);
        contentLinksDelegate.registerHandler(completeLinkHandler);
        contentLinksDelegate.registerHandler(printLinkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        cronDelegate.register(syncHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_mod_feedback_responses',
            newName: __WEBPACK_IMPORTED_MODULE_21__providers_offline__["a" /* AddonModFeedbackOfflineProvider */].FEEDBACK_TABLE,
            fields: [
                {
                    name: 'responses',
                    type: 'object'
                }
            ]
        });
    }
    AddonModFeedbackModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* AddonModFeedbackComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_8__providers_feedback__["a" /* AddonModFeedbackProvider */],
                __WEBPACK_IMPORTED_MODULE_16__providers_helper__["a" /* AddonModFeedbackHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_19__providers_sync__["a" /* AddonModFeedbackSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_21__providers_offline__["a" /* AddonModFeedbackOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_module_handler__["a" /* AddonModFeedbackModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_17__providers_prefetch_handler__["a" /* AddonModFeedbackPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_link_handler__["a" /* AddonModFeedbackLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_analysis_link_handler__["a" /* AddonModFeedbackAnalysisLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_show_entries_link_handler__["a" /* AddonModFeedbackShowEntriesLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_show_non_respondents_link_handler__["a" /* AddonModFeedbackShowNonRespondentsLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_complete_link_handler__["a" /* AddonModFeedbackCompleteLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_print_link_handler__["a" /* AddonModFeedbackPrintLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_list_link_handler__["a" /* AddonModFeedbackListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_20__providers_sync_cron_handler__["a" /* AddonModFeedbackSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__["a" /* AddonModFeedbackPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_module_handler__["a" /* AddonModFeedbackModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_17__providers_prefetch_handler__["a" /* AddonModFeedbackPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_link_handler__["a" /* AddonModFeedbackLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_20__providers_sync_cron_handler__["a" /* AddonModFeedbackSyncCronHandler */],
            __WEBPACK_IMPORTED_MODULE_10__providers_analysis_link_handler__["a" /* AddonModFeedbackAnalysisLinkHandler */], __WEBPACK_IMPORTED_MODULE_22__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_show_entries_link_handler__["a" /* AddonModFeedbackShowEntriesLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_12__providers_show_non_respondents_link_handler__["a" /* AddonModFeedbackShowNonRespondentsLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_13__providers_complete_link_handler__["a" /* AddonModFeedbackCompleteLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_14__providers_print_link_handler__["a" /* AddonModFeedbackPrintLinkHandler */], __WEBPACK_IMPORTED_MODULE_15__providers_list_link_handler__["a" /* AddonModFeedbackListLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__["a" /* AddonModFeedbackPushClickHandler */]])
    ], AddonModFeedbackModule);
    return AddonModFeedbackModule;
}());

//# sourceMappingURL=feedback.module.js.map

/***/ }),
/* 845 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__helper__ = __webpack_require__(184);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__sync__ = __webpack_require__(224);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Handler to prefetch feedbacks.
 */
var AddonModFeedbackPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackPrefetchHandler, _super);
    function AddonModFeedbackPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, feedbackProvider, feedbackHelper, timeUtils, groupsProvider, injector) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.feedbackProvider = feedbackProvider;
        _this.feedbackHelper = feedbackHelper;
        _this.timeUtils = timeUtils;
        _this.groupsProvider = groupsProvider;
        _this.injector = injector;
        _this.name = 'AddonModFeedback';
        _this.modName = 'feedback';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__feedback__["a" /* AddonModFeedbackProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^attemptsfinished|^attemptsunfinished$/;
        return _this;
    }
    /**
     * Get the list of downloadable files.
     *
     * @param  {any} module       Module to get the files.
     * @param  {number} courseId  Course ID the module belongs to.
     * @param  {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any>}     Promise resolved with the list of files.
     */
    AddonModFeedbackPrefetchHandler.prototype.getFiles = function (module, courseId, single) {
        var _this = this;
        var files = [];
        return this.feedbackProvider.getFeedback(courseId, module.id).then(function (feedback) {
            // Get intro files and page after submit files.
            files = feedback.pageaftersubmitfiles || [];
            files = files.concat(_this.getIntroFilesFromInstance(module, feedback));
            return _this.feedbackProvider.getItems(feedback.id);
        }).then(function (response) {
            response.items.forEach(function (item) {
                files = files.concat(item.itemfiles);
            });
            return files;
        }).catch(function () {
            // Any error, return the list we have.
            return files;
        });
    };
    /**
     * Returns feedback intro files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    AddonModFeedbackPrefetchHandler.prototype.getIntroFiles = function (module, courseId) {
        var _this = this;
        return this.feedbackProvider.getFeedback(courseId, module.id).catch(function () {
            // Not found, return undefined so module description is used.
        }).then(function (feedback) {
            return _this.getIntroFilesFromInstance(module, feedback);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModFeedbackPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.feedbackProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModFeedbackPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        return this.feedbackProvider.invalidateFeedbackData(courseId);
    };
    /**
     * Check if a feedback is downloadable.
     * A feedback isn't downloadable if it's not open yet.
     * Closed feedback are downloadable because teachers can always see the results.
     *
     * @param {any} module    Module to check.
     * @param {number} courseId  Course ID the module belongs to.
     * @return {Promise<any>}         Promise resolved with true if downloadable, resolved with false otherwise.
     */
    AddonModFeedbackPrefetchHandler.prototype.isDownloadable = function (module, courseId) {
        var _this = this;
        return this.feedbackProvider.getFeedback(courseId, module.id, undefined, true).then(function (feedback) {
            var now = _this.timeUtils.timestamp();
            // Check time first if available.
            if (feedback.timeopen && feedback.timeopen > now) {
                return false;
            }
            if (feedback.timeclose && feedback.timeclose < now) {
                return false;
            }
            return _this.feedbackProvider.getFeedbackAccessInformation(feedback.id).then(function (accessData) {
                return accessData.isopen;
            });
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModFeedbackPrefetchHandler.prototype.isEnabled = function () {
        return this.feedbackProvider.isPluginEnabled();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchFeedback.bind(this));
    };
    /**
     * Prefetch a feedback.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackPrefetchHandler.prototype.prefetchFeedback = function (module, courseId, single, siteId) {
        var _this = this;
        // Prefetch the feedback data.
        return this.feedbackProvider.getFeedback(courseId, module.id, siteId, false, true).then(function (feedback) {
            var files = (feedback.pageaftersubmitfiles || []).concat(_this.getIntroFilesFromInstance(module, feedback));
            return _this.feedbackProvider.getFeedbackAccessInformation(feedback.id, false, true, siteId).then(function (accessData) {
                var p2 = [];
                if (accessData.canedititems || accessData.canviewreports) {
                    // Get all groups analysis.
                    p2.push(_this.feedbackProvider.getAnalysis(feedback.id, undefined, true, siteId));
                    p2.push(_this.groupsProvider.getActivityGroupInfo(feedback.coursemodule, true, undefined, siteId, true)
                        .then(function (groupInfo) {
                        var p3 = [];
                        if (!groupInfo.groups || groupInfo.groups.length == 0) {
                            groupInfo.groups = [{ id: 0 }];
                        }
                        groupInfo.groups.forEach(function (group) {
                            p3.push(_this.feedbackProvider.getAnalysis(feedback.id, group.id, true, siteId));
                            p3.push(_this.feedbackProvider.getAllResponsesAnalysis(feedback.id, group.id, true, siteId));
                            if (!accessData.isanonymous) {
                                p3.push(_this.feedbackProvider.getAllNonRespondents(feedback.id, group.id, true, siteId));
                            }
                        });
                        return Promise.all(p3);
                    }));
                }
                p2.push(_this.feedbackProvider.getItems(feedback.id, true, siteId).then(function (response) {
                    response.items.forEach(function (item) {
                        files = files.concat(item.itemfiles);
                    });
                    return _this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id);
                }));
                if (accessData.cancomplete && accessData.cansubmit && !accessData.isempty) {
                    // Send empty data, so it will recover last completed feedback attempt values.
                    p2.push(_this.feedbackProvider.processPageOnline(feedback.id, 0, {}, undefined, siteId).finally(function () {
                        var p4 = [];
                        p4.push(_this.feedbackProvider.getCurrentValues(feedback.id, false, true, siteId));
                        p4.push(_this.feedbackProvider.getResumePage(feedback.id, false, true, siteId));
                        return Promise.all(p4);
                    }));
                }
                return Promise.all(p2);
            });
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        if (!this.syncProvider) {
            this.syncProvider = this.injector.get(__WEBPACK_IMPORTED_MODULE_13__sync__["a" /* AddonModFeedbackSyncProvider */]);
        }
        return this.syncProvider.syncFeedback(module.instance, siteId);
    };
    AddonModFeedbackPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__feedback__["a" /* AddonModFeedbackProvider */],
            __WEBPACK_IMPORTED_MODULE_10__helper__["a" /* AddonModFeedbackHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_12__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonModFeedbackPrefetchHandler);
    return AddonModFeedbackPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 846 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_FOLDER_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModFolderModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_folder__ = __webpack_require__(371);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(847);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_module_handler__ = __webpack_require__(1596);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1003);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__ = __webpack_require__(1597);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_link_handler__ = __webpack_require__(1598);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_list_link_handler__ = __webpack_require__(1599);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_pluginfile_handler__ = __webpack_require__(1600);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_plugin_file_delegate__ = __webpack_require__(177);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













// List of providers (without handlers).
var ADDON_MOD_FOLDER_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_folder__["a" /* AddonModFolderProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonModFolderHelperProvider */]
];
var AddonModFolderModule = /** @class */ (function () {
    function AddonModFolderModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, pluginfileDelegate, pluginfileHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        pluginfileDelegate.registerHandler(pluginfileHandler);
    }
    AddonModFolderModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonModFolderComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_folder__["a" /* AddonModFolderProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonModFolderHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_module_handler__["a" /* AddonModFolderModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__["a" /* AddonModFolderPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_link_handler__["a" /* AddonModFolderLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_list_link_handler__["a" /* AddonModFolderListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_pluginfile_handler__["a" /* AddonModFolderPluginFileHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_module_handler__["a" /* AddonModFolderModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_prefetch_handler__["a" /* AddonModFolderPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_10__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_link_handler__["a" /* AddonModFolderLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_12__providers_plugin_file_delegate__["a" /* CorePluginFileDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_pluginfile_handler__["a" /* AddonModFolderPluginFileHandler */],
            __WEBPACK_IMPORTED_MODULE_8__providers_list_link_handler__["a" /* AddonModFolderListLinkHandler */]])
    ], AddonModFolderModule);
    return AddonModFolderModule;
}());

//# sourceMappingURL=folder.module.js.map

/***/ }),
/* 847 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__ = __webpack_require__(10);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Service that provides some features for folder.
 */
var AddonModFolderHelperProvider = /** @class */ (function () {
    function AddonModFolderHelperProvider(courseProvider) {
        this.courseProvider = courseProvider;
    }
    /**
     * Format folder contents, creating directory structure.
     * Folders found in filepaths are added to the array. Each folder has the properties: name, fileicon,
     * type (folder), filepath and contents (array with files and subfolders).
     *
     * @param {any[]} contents Folder contents.
     * @return {any[]}         Formatted contents.
     */
    AddonModFolderHelperProvider.prototype.formatContents = function (contents) {
        var files = [], folders = [], folderIcon = this.courseProvider.getModuleIconSrc('folder');
        contents.forEach(function (entry) {
            if (entry.filepath !== '/') {
                // It's a file in a subfolder. Lets treat the path to add the subfolders to the array.
                var directories = void 0, currentList_1 = folders, // Start at root level.
                path = entry.filepath, subpath_1 = '';
                // Remove first and last slash if needed.
                if (path.substr(0, 1) === '/') {
                    path = path.substr(1);
                }
                if (path.substr(path.length - 1) === '/') {
                    path = path.slice(0, -1);
                }
                directories = path.split('/');
                directories.forEach(function (directory) {
                    subpath_1 = subpath_1 + '/' + directory;
                    // Search if the directory is already stored in folders array.
                    var foundList = currentList_1.find(function (list) {
                        return list.name === directory;
                    });
                    if (foundList) {
                        currentList_1 = foundList.contents;
                    }
                    else {
                        // Directory not found. Add it to the array.
                        var newFolder = {
                            name: directory,
                            fileicon: folderIcon,
                            contents: [],
                            filepath: subpath_1,
                            type: 'folder'
                        };
                        currentList_1.push(newFolder);
                        currentList_1 = newFolder.contents;
                    }
                });
                currentList_1.push(entry);
            }
            else {
                files.push(entry);
            }
        });
        return folders.concat(files);
    };
    AddonModFolderHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModFolderHelperProvider);
    return AddonModFolderHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 848 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_FORUM_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModForumModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_forum__ = __webpack_require__(100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_offline__ = __webpack_require__(169);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_helper__ = __webpack_require__(220);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_sync__ = __webpack_require__(187);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_module_handler__ = __webpack_require__(1601);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__ = __webpack_require__(849);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_sync_cron_handler__ = __webpack_require__(1602);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_index_link_handler__ = __webpack_require__(1603);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_discussion_link_handler__ = __webpack_require__(1604);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_list_link_handler__ = __webpack_require__(1605);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_push_click_handler__ = __webpack_require__(1606);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__components_components_module__ = __webpack_require__(986);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



















// List of providers (without handlers).
var ADDON_MOD_FORUM_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_6__providers_forum__["a" /* AddonModForumProvider */],
    __WEBPACK_IMPORTED_MODULE_7__providers_offline__["a" /* AddonModForumOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_8__providers_helper__["a" /* AddonModForumHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_9__providers_sync__["a" /* AddonModForumSyncProvider */]
];
var AddonModForumModule = /** @class */ (function () {
    function AddonModForumModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, linksDelegate, indexHandler, discussionHandler, updateManager, listLinkHandler, pushNotificationsDelegate, pushClickHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        linksDelegate.registerHandler(indexHandler);
        linksDelegate.registerHandler(discussionHandler);
        linksDelegate.registerHandler(listLinkHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTablesMigration([
            {
                name: 'mma_mod_forum_offline_discussions',
                newName: __WEBPACK_IMPORTED_MODULE_7__providers_offline__["a" /* AddonModForumOfflineProvider */].DISCUSSIONS_TABLE,
                fields: [
                    {
                        name: 'forumAndUser',
                        delete: true
                    },
                    {
                        name: 'options',
                        type: 'object'
                    }
                ]
            },
            {
                name: 'mma_mod_forum_offline_replies',
                newName: __WEBPACK_IMPORTED_MODULE_7__providers_offline__["a" /* AddonModForumOfflineProvider */].REPLIES_TABLE,
                fields: [
                    {
                        name: 'forumAndUser',
                        delete: true
                    },
                    {
                        name: 'discussionAndUser',
                        delete: true
                    },
                    {
                        name: 'options',
                        type: 'object'
                    }
                ]
            }
        ]);
    }
    AddonModForumModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_17__components_components_module__["a" /* AddonModForumComponentsModule */],
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_forum__["a" /* AddonModForumProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_offline__["a" /* AddonModForumOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_helper__["a" /* AddonModForumHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_9__providers_sync__["a" /* AddonModForumSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_10__providers_module_handler__["a" /* AddonModForumModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__["a" /* AddonModForumPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_sync_cron_handler__["a" /* AddonModForumSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_index_link_handler__["a" /* AddonModForumIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_list_link_handler__["a" /* AddonModForumListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_discussion_link_handler__["a" /* AddonModForumDiscussionLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_16__providers_push_click_handler__["a" /* AddonModForumPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_10__providers_module_handler__["a" /* AddonModForumModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__["a" /* AddonModForumPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_12__providers_sync_cron_handler__["a" /* AddonModForumSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */],
            __WEBPACK_IMPORTED_MODULE_13__providers_index_link_handler__["a" /* AddonModForumIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_14__providers_discussion_link_handler__["a" /* AddonModForumDiscussionLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_18__providers_update_manager__["a" /* CoreUpdateManagerProvider */], __WEBPACK_IMPORTED_MODULE_15__providers_list_link_handler__["a" /* AddonModForumListLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_16__providers_push_click_handler__["a" /* AddonModForumPushClickHandler */]])
    ], AddonModForumModule);
    return AddonModForumModule;
}());

//# sourceMappingURL=forum.module.js.map

/***/ }),
/* 849 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__forum__ = __webpack_require__(100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__sync__ = __webpack_require__(187);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













/**
 * Handler to prefetch forums.
 */
var AddonModForumPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModForumPrefetchHandler, _super);
    function AddonModForumPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, userProvider, groupsProvider, forumProvider, syncProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.userProvider = userProvider;
        _this.groupsProvider = groupsProvider;
        _this.forumProvider = forumProvider;
        _this.syncProvider = syncProvider;
        _this.name = 'AddonModForum';
        _this.modName = 'forum';
        _this.component = __WEBPACK_IMPORTED_MODULE_11__forum__["a" /* AddonModForumProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^discussions$/;
        return _this;
    }
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModForumPrefetchHandler.prototype.getFiles = function (module, courseId, single) {
        var _this = this;
        return this.forumProvider.getForum(courseId, module.id).then(function (forum) {
            var files = _this.getIntroFilesFromInstance(module, forum);
            // Get posts.
            return _this.getPostsForPrefetch(forum).then(function (posts) {
                // Add posts attachments and embedded files.
                return files.concat(_this.getPostsFiles(posts));
            });
        }).catch(function () {
            // Forum not found, return empty list.
            return [];
        });
    };
    /**
     * Given a list of forum posts, return a list with all the files (attachments and embedded files).
     *
     * @param {any[]} posts Forum posts.
     * @return {any[]} Files.
     */
    AddonModForumPrefetchHandler.prototype.getPostsFiles = function (posts) {
        var _this = this;
        var files = [];
        var getInlineFiles = this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.2');
        posts.forEach(function (post) {
            if (post.attachments && post.attachments.length) {
                files = files.concat(post.attachments);
            }
            if (getInlineFiles && post.messageinlinefiles && post.messageinlinefiles.length) {
                files = files.concat(post.messageinlinefiles);
            }
            else if (post.message && !getInlineFiles) {
                files = files.concat(_this.domUtils.extractDownloadableFilesFromHtmlAsFakeFileObjects(post.message));
            }
        });
        return files;
    };
    /**
     * Get the posts to be prefetched.
     *
     * @param {any} forum Forum instance.
     * @return {Promise<any[]>} Promise resolved with array of posts.
     */
    AddonModForumPrefetchHandler.prototype.getPostsForPrefetch = function (forum) {
        var _this = this;
        var promises = this.forumProvider.getAvailableSortOrders().map(function (sortOrder) {
            // Get discussions in first 2 pages.
            return _this.forumProvider.getDiscussionsInPages(forum.id, sortOrder.value, false, 2).then(function (response) {
                if (response.error) {
                    return Promise.reject(null);
                }
                var promises = [];
                response.discussions.forEach(function (discussion) {
                    promises.push(_this.forumProvider.getDiscussionPosts(discussion.discussion));
                });
                return Promise.all(promises);
            });
        });
        return Promise.all(promises).then(function (results) {
            // Each order has returned its own list of posts. Merge all the lists, preventing duplicates.
            var posts = [], postIds = {}; // To make the array unique.
            results.forEach(function (orderResults) {
                orderResults.forEach(function (orderResult) {
                    orderResult.posts.forEach(function (post) {
                        if (!postIds[post.id]) {
                            postIds[post.id] = true;
                            posts.push(post);
                        }
                    });
                });
            });
            return posts;
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModForumPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.forumProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status (usually, to check if module is downloadable).
     * It doesn't need to invalidate check updates. It should NOT invalidate files nor all the prefetched data.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModForumPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        // Invalidate forum data to recalculate unread message count badge.
        var promises = [];
        promises.push(this.forumProvider.invalidateForumData(courseId));
        promises.push(this.courseProvider.invalidateModule(module.id));
        return Promise.all(promises);
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchForum.bind(this));
    };
    /**
     * Prefetch a forum.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumPrefetchHandler.prototype.prefetchForum = function (module, courseId, single, siteId) {
        var _this = this;
        // Get the forum data.
        return this.forumProvider.getForum(courseId, module.id).then(function (forum) {
            var promises = [];
            // Prefetch the posts.
            promises.push(_this.getPostsForPrefetch(forum).then(function (posts) {
                var promises = [];
                // Gather user profile images.
                var avatars = {}; // List of user avatars, preventing duplicates.
                posts.forEach(function (post) {
                    if (post.userpictureurl) {
                        avatars[post.userpictureurl] = true;
                    }
                });
                // Prefetch intro files, attachments, embedded files and user avatars.
                var avatarFiles = Object.keys(avatars).map(function (url) {
                    return { fileurl: url };
                });
                var files = _this.getIntroFilesFromInstance(module, forum).concat(_this.getPostsFiles(posts)).concat(avatarFiles);
                promises.push(_this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id));
                // Prefetch groups data.
                promises.push(_this.prefetchGroupsInfo(forum, courseId, forum.cancreatediscussions));
                return Promise.all(promises);
            }));
            // Prefetch access information.
            promises.push(_this.forumProvider.getAccessInformation(forum.id));
            // Prefetch sort order preference.
            if (_this.forumProvider.isDiscussionListSortingAvailable()) {
                promises.push(_this.userProvider.getUserPreference(__WEBPACK_IMPORTED_MODULE_11__forum__["a" /* AddonModForumProvider */].PREFERENCE_SORTORDER));
            }
            return Promise.all(promises);
        });
    };
    /**
     * Prefetch groups info for a forum.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseI Course ID the module belongs to.
     * @param {boolean} canCreateDiscussions Whether the user can create discussions in the forum.
     * @return {Promise<any>} Promise resolved when group data has been prefetched.
     */
    AddonModForumPrefetchHandler.prototype.prefetchGroupsInfo = function (forum, courseId, canCreateDiscussions) {
        var _this = this;
        // Check group mode.
        return this.groupsProvider.getActivityGroupMode(forum.cmid).then(function (mode) {
            if (mode !== __WEBPACK_IMPORTED_MODULE_10__providers_groups__["a" /* CoreGroupsProvider */].SEPARATEGROUPS && mode !== __WEBPACK_IMPORTED_MODULE_10__providers_groups__["a" /* CoreGroupsProvider */].VISIBLEGROUPS) {
                // Activity doesn't use groups. Prefetch canAddDiscussionToAll to determine if user can pin/attach.
                return _this.forumProvider.canAddDiscussionToAll(forum.id).catch(function () {
                    // Ignore errors.
                });
            }
            // Activity uses groups, prefetch allowed groups.
            return _this.groupsProvider.getActivityAllowedGroups(forum.cmid).then(function (groups) {
                if (mode === __WEBPACK_IMPORTED_MODULE_10__providers_groups__["a" /* CoreGroupsProvider */].SEPARATEGROUPS) {
                    // Groups are already filtered by WS. Prefetch canAddDiscussionToAll to determine if user can pin/attach.
                    return _this.forumProvider.canAddDiscussionToAll(forum.id).catch(function () {
                        // Ignore errors.
                    });
                }
                if (canCreateDiscussions) {
                    // Prefetch data to check the visible groups when creating discussions.
                    return _this.forumProvider.canAddDiscussionToAll(forum.id).catch(function () {
                        // The call failed, let's assume he can't.
                        return {
                            status: false
                        };
                    }).then(function (response) {
                        if (response.status) {
                            // User can post to all groups, nothing else to prefetch.
                            return;
                        }
                        // The user can't post to all groups, let's check which groups he can post to.
                        var groupPromises = [];
                        groups.forEach(function (group) {
                            groupPromises.push(_this.forumProvider.canAddDiscussion(forum.id, group.id).catch(function () {
                                // Ignore errors.
                            }));
                        });
                        return Promise.all(groupPromises);
                    });
                }
            });
        }).catch(function (error) {
            // Ignore errors if cannot create discussions.
            if (canCreateDiscussions) {
                return Promise.reject(error);
            }
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        var promises = [];
        promises.push(this.syncProvider.syncForumDiscussions(module.instance, undefined, siteId));
        promises.push(this.syncProvider.syncForumReplies(module.instance, undefined, siteId));
        promises.push(this.syncProvider.syncRatings(module.id, undefined, true, siteId));
        return Promise.all(promises).then(function (results) {
            return results.reduce(function (a, b) { return ({
                updated: a.updated || b.updated,
                warnings: (a.warnings || []).concat(b.warnings || []),
            }); }, { updated: false });
        });
    };
    AddonModForumPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_11__forum__["a" /* AddonModForumProvider */],
            __WEBPACK_IMPORTED_MODULE_12__sync__["a" /* AddonModForumSyncProvider */]])
    ], AddonModForumPrefetchHandler);
    return AddonModForumPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_9__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 850 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_GLOSSARY_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModGlossaryModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_glossary__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_offline__ = __webpack_require__(188);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_helper__ = __webpack_require__(434);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_sync__ = __webpack_require__(268);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_module_handler__ = __webpack_require__(1610);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__ = __webpack_require__(852);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_sync_cron_handler__ = __webpack_require__(1611);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_index_link_handler__ = __webpack_require__(1612);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_entry_link_handler__ = __webpack_require__(1613);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_list_link_handler__ = __webpack_require__(1614);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__components_components_module__ = __webpack_require__(1004);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















// List of providers (without handlers).
var ADDON_MOD_GLOSSARY_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_5__providers_glossary__["a" /* AddonModGlossaryProvider */],
    __WEBPACK_IMPORTED_MODULE_6__providers_offline__["a" /* AddonModGlossaryOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_7__providers_helper__["a" /* AddonModGlossaryHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_8__providers_sync__["a" /* AddonModGlossarySyncProvider */]
];
var AddonModGlossaryModule = /** @class */ (function () {
    function AddonModGlossaryModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, linksDelegate, indexHandler, discussionHandler, updateManager, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        linksDelegate.registerHandler(indexHandler);
        linksDelegate.registerHandler(discussionHandler);
        linksDelegate.registerHandler(listLinkHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_mod_glossary_add_entry',
            newName: __WEBPACK_IMPORTED_MODULE_6__providers_offline__["a" /* AddonModGlossaryOfflineProvider */].ENTRIES_TABLE,
            fields: [
                {
                    name: 'glossaryAndConcept',
                    delete: true
                },
                {
                    name: 'glossaryAndUser',
                    delete: true
                },
                {
                    name: 'options',
                    type: 'object'
                },
                {
                    name: 'attachments',
                    type: 'object'
                }
            ]
        });
    }
    AddonModGlossaryModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_15__components_components_module__["a" /* AddonModGlossaryComponentsModule */],
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_glossary__["a" /* AddonModGlossaryProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_offline__["a" /* AddonModGlossaryOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_helper__["a" /* AddonModGlossaryHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_sync__["a" /* AddonModGlossarySyncProvider */],
                __WEBPACK_IMPORTED_MODULE_9__providers_module_handler__["a" /* AddonModGlossaryModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__["a" /* AddonModGlossaryPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_sync_cron_handler__["a" /* AddonModGlossarySyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_index_link_handler__["a" /* AddonModGlossaryIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_entry_link_handler__["a" /* AddonModGlossaryEntryLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_list_link_handler__["a" /* AddonModGlossaryListLinkHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_module_handler__["a" /* AddonModGlossaryModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__["a" /* AddonModGlossaryPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_11__providers_sync_cron_handler__["a" /* AddonModGlossarySyncCronHandler */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */],
            __WEBPACK_IMPORTED_MODULE_12__providers_index_link_handler__["a" /* AddonModGlossaryIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_13__providers_entry_link_handler__["a" /* AddonModGlossaryEntryLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_16__providers_update_manager__["a" /* CoreUpdateManagerProvider */], __WEBPACK_IMPORTED_MODULE_14__providers_list_link_handler__["a" /* AddonModGlossaryListLinkHandler */]])
    ], AddonModGlossaryModule);
    return AddonModGlossaryModule;
}());

//# sourceMappingURL=glossary.module.js.map

/***/ }),
/* 851 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryModePickerPopoverComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to display the mode picker.
 */
var AddonModGlossaryModePickerPopoverComponent = /** @class */ (function () {
    function AddonModGlossaryModePickerPopoverComponent(navParams, viewCtrl) {
        var _this = this;
        this.viewCtrl = viewCtrl;
        this.modes = [];
        this.selectedMode = navParams.get('selectedMode');
        var glossary = navParams.get('glossary');
        // Preparing browse modes.
        this.modes = [
            { key: 'search', langkey: 'addon.mod_glossary.bysearch' }
        ];
        glossary.browsemodes.forEach(function (mode) {
            switch (mode) {
                case 'letter':
                    _this.modes.push({ key: 'letter_all', langkey: 'addon.mod_glossary.byalphabet' });
                    break;
                case 'cat':
                    _this.modes.push({ key: 'cat_all', langkey: 'addon.mod_glossary.bycategory' });
                    break;
                case 'date':
                    _this.modes.push({ key: 'newest_first', langkey: 'addon.mod_glossary.bynewestfirst' });
                    _this.modes.push({ key: 'recently_updated', langkey: 'addon.mod_glossary.byrecentlyupdated' });
                    break;
                case 'author':
                    _this.modes.push({ key: 'author_all', langkey: 'addon.mod_glossary.byauthor' });
                    break;
                default:
            }
        });
    }
    /**
     * Function called when a mode is clicked.
     *
     * @param {Event} event Click event.
     * @param {string} key Clicked mode key.
     * @return {boolean} Return true if success, false if error.
     */
    AddonModGlossaryModePickerPopoverComponent.prototype.modePicked = function (event, key) {
        this.viewCtrl.dismiss(key);
        return true;
    };
    AddonModGlossaryModePickerPopoverComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-glossary-mode-picker-popover',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\glossary\components\mode-picker\addon-mod-glossary-mode-picker.html"*/'<ion-list radio-group [(ngModel)]="selectedMode">\n    <ion-item text-wrap *ngFor="let mode of modes" >\n        <ion-label>{{mode.langkey | translate}}</ion-label>\n        <ion-radio [value]="mode.key" (ionSelect)="modePicked($event, mode.key)" ></ion-radio>\n    </ion-item>\n</ion-list>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\glossary\components\mode-picker\addon-mod-glossary-mode-picker.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */]])
    ], AddonModGlossaryModePickerPopoverComponent);
    return AddonModGlossaryModePickerPopoverComponent;
}());

//# sourceMappingURL=mode-picker.js.map

/***/ }),
/* 852 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__glossary__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__sync__ = __webpack_require__(268);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Handler to prefetch forums.
 */
var AddonModGlossaryPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModGlossaryPrefetchHandler, _super);
    function AddonModGlossaryPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, glossaryProvider, syncProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.glossaryProvider = glossaryProvider;
        _this.syncProvider = syncProvider;
        _this.name = 'AddonModGlossary';
        _this.modName = 'glossary';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__glossary__["a" /* AddonModGlossaryProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^entries$/;
        return _this;
    }
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModGlossaryPrefetchHandler.prototype.getFiles = function (module, courseId, single) {
        var _this = this;
        return this.glossaryProvider.getGlossary(courseId, module.id).then(function (glossary) {
            return _this.glossaryProvider.fetchAllEntries(_this.glossaryProvider.getEntriesByLetter, [glossary.id, 'ALL'])
                .then(function (entries) {
                return _this.getFilesFromGlossaryAndEntries(module, glossary, entries);
            });
        }).catch(function () {
            // Glossary not found, return empty list.
            return [];
        });
    };
    /**
     * Get the list of downloadable files. It includes entry embedded files.
     *
     * @param  {any}   module   Module to get the files.
     * @param  {any}   glossary Glossary
     * @param  {any[]} entries  Entries of the Glossary.
     * @return {any[]}          List of Files.
     */
    AddonModGlossaryPrefetchHandler.prototype.getFilesFromGlossaryAndEntries = function (module, glossary, entries) {
        var _this = this;
        var files = this.getIntroFilesFromInstance(module, glossary);
        var getInlineFiles = this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.2');
        // Get entries files.
        entries.forEach(function (entry) {
            files = files.concat(entry.attachments);
            if (getInlineFiles && entry.definitioninlinefiles && entry.definitioninlinefiles.length) {
                files = files.concat(entry.definitioninlinefiles);
            }
            else if (entry.definition && !getInlineFiles) {
                files = files.concat(_this.domUtils.extractDownloadableFilesFromHtmlAsFakeFileObjects(entry.definition));
            }
        });
        return files;
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModGlossaryPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.glossaryProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModGlossaryPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchGlossary.bind(this));
    };
    /**
     * Prefetch a glossary.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModGlossaryPrefetchHandler.prototype.prefetchGlossary = function (module, courseId, single, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Prefetch the glossary data.
        return this.glossaryProvider.getGlossary(courseId, module.id, siteId).then(function (glossary) {
            var promises = [];
            glossary.browsemodes.forEach(function (mode) {
                switch (mode) {
                    case 'letter':// Always done. Look bellow.
                        break;
                    case 'cat':// Not implemented.
                        promises.push(_this.glossaryProvider.fetchAllEntries(_this.glossaryProvider.getEntriesByCategory, [glossary.id, __WEBPACK_IMPORTED_MODULE_9__glossary__["a" /* AddonModGlossaryProvider */].SHOW_ALL_CATERGORIES], false, siteId));
                        break;
                    case 'date':
                        promises.push(_this.glossaryProvider.fetchAllEntries(_this.glossaryProvider.getEntriesByDate, [glossary.id, 'CREATION', 'DESC'], false, siteId));
                        promises.push(_this.glossaryProvider.fetchAllEntries(_this.glossaryProvider.getEntriesByDate, [glossary.id, 'UPDATE', 'DESC'], false, siteId));
                        break;
                    case 'author':
                        promises.push(_this.glossaryProvider.fetchAllEntries(_this.glossaryProvider.getEntriesByAuthor, [glossary.id, 'ALL', 'LASTNAME', 'ASC'], false, siteId));
                        break;
                    default:
                }
            });
            // Fetch all entries to get information from.
            promises.push(_this.glossaryProvider.fetchAllEntries(_this.glossaryProvider.getEntriesByLetter, [glossary.id, 'ALL'], false, siteId).then(function (entries) {
                var promises = [];
                var avatars = {}; // List of user avatars, preventing duplicates.
                entries.forEach(function (entry) {
                    // Fetch individual entries.
                    promises.push(_this.glossaryProvider.getEntry(entry.id, siteId));
                    if (entry.userpictureurl) {
                        avatars[entry.userpictureurl] = true;
                    }
                });
                // Prefetch intro files, entries files and user avatars.
                var avatarFiles = Object.keys(avatars).map(function (url) {
                    return { fileurl: url };
                });
                var files = _this.getFilesFromGlossaryAndEntries(module, glossary, entries).concat(avatarFiles);
                promises.push(_this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id));
                return Promise.all(promises);
            }));
            return Promise.all(promises);
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModGlossaryPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        var promises = [
            this.syncProvider.syncGlossaryEntries(module.instance, undefined, siteId),
            this.syncProvider.syncRatings(module.id, undefined, siteId)
        ];
        return Promise.all(promises).then(function (results) {
            return results.reduce(function (a, b) { return ({
                updated: a.updated || b.updated,
                warnings: (a.warnings || []).concat(b.warnings || []),
            }); }, { updated: false });
        });
    };
    AddonModGlossaryPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__glossary__["a" /* AddonModGlossaryProvider */],
            __WEBPACK_IMPORTED_MODULE_10__sync__["a" /* AddonModGlossarySyncProvider */]])
    ], AddonModGlossaryPrefetchHandler);
    return AddonModGlossaryPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 853 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_IMSCP_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModImscpModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_components_module__ = __webpack_require__(1005);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__ = __webpack_require__(1615);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_imscp__ = __webpack_require__(214);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__ = __webpack_require__(854);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__ = __webpack_require__(1616);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__ = __webpack_require__(1617);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__ = __webpack_require__(1618);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_plugin_file_delegate__ = __webpack_require__(177);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












// List of providers (without handlers).
var ADDON_MOD_IMSCP_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_3__providers_imscp__["a" /* AddonModImscpProvider */]
];
var AddonModImscpModule = /** @class */ (function () {
    function AddonModImscpModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, pluginfileDelegate, pluginfileHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        pluginfileDelegate.registerHandler(pluginfileHandler);
    }
    AddonModImscpModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__components_components_module__["a" /* AddonModImscpComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_imscp__["a" /* AddonModImscpProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModImscpModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModImscpPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__["a" /* AddonModImscpLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__["a" /* AddonModImscpListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__["a" /* AddonModImscpPluginFileHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModImscpModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_10__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModImscpPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__["a" /* AddonModImscpLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_11__providers_plugin_file_delegate__["a" /* CorePluginFileDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__["a" /* AddonModImscpPluginFileHandler */],
            __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__["a" /* AddonModImscpListLinkHandler */]])
    ], AddonModImscpModule);
    return AddonModImscpModule;
}());

//# sourceMappingURL=imscp.module.js.map

/***/ }),
/* 854 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__imscp__ = __webpack_require__(214);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Handler to prefetch IMSCPs.
 */
var AddonModImscpPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModImscpPrefetchHandler, _super);
    function AddonModImscpPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, imscpProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.imscpProvider = imscpProvider;
        _this.name = 'AddonModImscp';
        _this.modName = 'imscp';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__imscp__["a" /* AddonModImscpProvider */].COMPONENT;
        return _this;
    }
    /**
     * Download or prefetch the content.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files. This is to keep the files
     *                           relative paths and make the package work in an iframe. Undefined to download the files
     *                           in the filepool root folder.
     * @return {Promise<any>} Promise resolved when all content is downloaded. Data returned is not reliable.
     */
    AddonModImscpPrefetchHandler.prototype.downloadOrPrefetch = function (module, courseId, prefetch, dirPath) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.getPackageDirPathByUrl(siteId, module.url).then(function (dirPath) {
            var promises = [];
            promises.push(_super.prototype.downloadOrPrefetch.call(_this, module, courseId, prefetch, dirPath));
            promises.push(_this.imscpProvider.getImscp(courseId, module.id, siteId));
            return Promise.all(promises);
        });
    };
    /**
     * Returns module intro files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    AddonModImscpPrefetchHandler.prototype.getIntroFiles = function (module, courseId) {
        var _this = this;
        return this.imscpProvider.getImscp(courseId, module.id).catch(function () {
            // Not found, return undefined so module description is used.
        }).then(function (imscp) {
            return _this.getIntroFilesFromInstance(module, imscp);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModImscpPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.imscpProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModImscpPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var promises = [];
        promises.push(this.imscpProvider.invalidateImscpData(courseId));
        promises.push(this.courseProvider.invalidateModule(module.id));
        return Promise.all(promises);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModImscpPrefetchHandler.prototype.isEnabled = function () {
        return this.imscpProvider.isPluginEnabled();
    };
    /**
     * Check if a file is downloadable.
     *
     * @param  {any} file File to check.
     * @return {boolean} Whether the file is downloadable.
     */
    AddonModImscpPrefetchHandler.prototype.isFileDownloadable = function (file) {
        return this.imscpProvider.isFileDownloadable(file);
    };
    AddonModImscpPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__imscp__["a" /* AddonModImscpProvider */]])
    ], AddonModImscpPrefetchHandler);
    return AddonModImscpPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__["a" /* CoreCourseResourcePrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 855 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpTocPopoverComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to display the TOC of a IMSCP.
 */
var AddonModImscpTocPopoverComponent = /** @class */ (function () {
    function AddonModImscpTocPopoverComponent(navParams, viewCtrl) {
        this.viewCtrl = viewCtrl;
        this.items = [];
        this.items = navParams.get('items') || [];
    }
    /**
     * Function called when an item is clicked.
     *
     * @param {string} id ID of the clicked item.
     */
    AddonModImscpTocPopoverComponent.prototype.loadItem = function (id) {
        this.viewCtrl.dismiss(id);
    };
    /**
     * Get dummy array for padding.
     *
     * @param {number} n Array length.
     * @return {number[]} Dummy array with n elements.
     */
    AddonModImscpTocPopoverComponent.prototype.getNumberForPadding = function (n) {
        return new Array(n);
    };
    AddonModImscpTocPopoverComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-imscp-toc-popover',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\imscp\components\toc-popover\addon-mod-imscp-toc-popover.html"*/'<ion-list>\n    <a ion-item *ngFor="let item of items" (click)="loadItem(item.href)" detail-none [class.core-bold]="!item.href">\n        <span padding-left *ngFor="let i of getNumberForPadding(item.level)"></span>{{item.title}}\n    </a>\n</ion-list>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\imscp\components\toc-popover\addon-mod-imscp-toc-popover.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */]])
    ], AddonModImscpTocPopoverComponent);
    return AddonModImscpTocPopoverComponent;
}());

//# sourceMappingURL=toc-popover.js.map

/***/ }),
/* 856 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_LESSON_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModLessonModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(1006);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_lesson__ = __webpack_require__(102);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_lesson_offline__ = __webpack_require__(225);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_lesson_sync__ = __webpack_require__(226);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_helper__ = __webpack_require__(988);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_module_handler__ = __webpack_require__(1619);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_prefetch_handler__ = __webpack_require__(372);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__ = __webpack_require__(1620);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_index_link_handler__ = __webpack_require__(1621);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_grade_link_handler__ = __webpack_require__(1622);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_report_link_handler__ = __webpack_require__(1623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_list_link_handler__ = __webpack_require__(1624);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__ = __webpack_require__(1625);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




















// List of providers (without handlers).
var ADDON_MOD_LESSON_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_7__providers_lesson__["a" /* AddonModLessonProvider */],
    __WEBPACK_IMPORTED_MODULE_8__providers_lesson_offline__["a" /* AddonModLessonOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_9__providers_lesson_sync__["a" /* AddonModLessonSyncProvider */],
    __WEBPACK_IMPORTED_MODULE_10__providers_helper__["a" /* AddonModLessonHelperProvider */]
];
var AddonModLessonModule = /** @class */ (function () {
    function AddonModLessonModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, linksDelegate, indexHandler, gradeHandler, reportHandler, updateManager, listLinkHandler, pushNotificationsDelegate, pushClickHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        linksDelegate.registerHandler(indexHandler);
        linksDelegate.registerHandler(gradeHandler);
        linksDelegate.registerHandler(reportHandler);
        linksDelegate.registerHandler(listLinkHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTablesMigration([
            {
                name: 'mma_mod_lesson_password',
                newName: __WEBPACK_IMPORTED_MODULE_7__providers_lesson__["a" /* AddonModLessonProvider */].PASSWORD_TABLE,
                fields: [
                    {
                        name: 'id',
                        newName: 'lessonid'
                    }
                ]
            },
            {
                name: 'mma_mod_lesson_retakes',
                newName: __WEBPACK_IMPORTED_MODULE_8__providers_lesson_offline__["a" /* AddonModLessonOfflineProvider */].RETAKES_TABLE,
                fields: [
                    {
                        name: 'finished',
                        type: 'boolean'
                    },
                    {
                        name: 'outoftime',
                        type: 'boolean'
                    }
                ]
            },
            {
                name: 'mma_mod_lesson_page_attempts',
                newName: __WEBPACK_IMPORTED_MODULE_8__providers_lesson_offline__["a" /* AddonModLessonOfflineProvider */].PAGE_ATTEMPTS_TABLE,
                fields: [
                    {
                        name: 'lessonAndPage',
                        delete: true
                    },
                    {
                        name: 'lessonAndRetake',
                        delete: true
                    },
                    {
                        name: 'lessonAndRetakeAndType',
                        delete: true
                    },
                    {
                        name: 'lessonAndRetakeAndPage',
                        delete: true
                    },
                    {
                        name: 'data',
                        type: 'object'
                    },
                    {
                        name: 'correct',
                        type: 'boolean'
                    },
                    {
                        name: 'userAnswer',
                        type: 'object'
                    }
                ]
            },
            {
                name: 'mma_mod_lesson_retakes_finished_sync',
                newName: __WEBPACK_IMPORTED_MODULE_9__providers_lesson_sync__["a" /* AddonModLessonSyncProvider */].RETAKES_FINISHED_TABLE
            }
        ]);
    }
    AddonModLessonModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* AddonModLessonComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_lesson__["a" /* AddonModLessonProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_lesson_offline__["a" /* AddonModLessonOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_9__providers_lesson_sync__["a" /* AddonModLessonSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_10__providers_helper__["a" /* AddonModLessonHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_11__providers_module_handler__["a" /* AddonModLessonModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_prefetch_handler__["a" /* AddonModLessonPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__["a" /* AddonModLessonSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_index_link_handler__["a" /* AddonModLessonIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_grade_link_handler__["a" /* AddonModLessonGradeLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_16__providers_report_link_handler__["a" /* AddonModLessonReportLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_17__providers_list_link_handler__["a" /* AddonModLessonListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__["a" /* AddonModLessonPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_11__providers_module_handler__["a" /* AddonModLessonModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_12__providers_prefetch_handler__["a" /* AddonModLessonPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__["a" /* AddonModLessonSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */],
            __WEBPACK_IMPORTED_MODULE_14__providers_index_link_handler__["a" /* AddonModLessonIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_15__providers_grade_link_handler__["a" /* AddonModLessonGradeLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_16__providers_report_link_handler__["a" /* AddonModLessonReportLinkHandler */], __WEBPACK_IMPORTED_MODULE_19__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_17__providers_list_link_handler__["a" /* AddonModLessonListLinkHandler */], __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */],
            __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__["a" /* AddonModLessonPushClickHandler */]])
    ], AddonModLessonModule);
    return AddonModLessonModule;
}());

//# sourceMappingURL=lesson.module.js.map

/***/ }),
/* 857 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_LTI_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModLtiModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_components_module__ = __webpack_require__(1007);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__ = __webpack_require__(1626);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_lti__ = __webpack_require__(373);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__ = __webpack_require__(1627);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__ = __webpack_require__(1628);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_delegate__ = __webpack_require__(38);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








// List of providers (without handlers).
var ADDON_MOD_LTI_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_3__providers_lti__["a" /* AddonModLtiProvider */]
];
var AddonModLtiModule = /** @class */ (function () {
    function AddonModLtiModule(moduleDelegate, moduleHandler, contentLinksDelegate, linkHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
    }
    AddonModLtiModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__components_components_module__["a" /* AddonModLtiComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_lti__["a" /* AddonModLtiProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModLtiModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__["a" /* AddonModLtiLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__["a" /* AddonModLtiListLinkHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModLtiModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__["a" /* AddonModLtiLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__["a" /* AddonModLtiListLinkHandler */]])
    ], AddonModLtiModule);
    return AddonModLtiModule;
}());

//# sourceMappingURL=lti.module.js.map

/***/ }),
/* 858 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_PAGE_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_components_module__ = __webpack_require__(1008);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__ = __webpack_require__(1629);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_page__ = __webpack_require__(172);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__ = __webpack_require__(859);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__ = __webpack_require__(1630);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__ = __webpack_require__(1631);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__ = __webpack_require__(1632);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_helper__ = __webpack_require__(374);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_plugin_file_delegate__ = __webpack_require__(177);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













// List of providers (without handlers).
var ADDON_MOD_PAGE_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_3__providers_page__["a" /* AddonModPageProvider */],
    __WEBPACK_IMPORTED_MODULE_8__providers_helper__["a" /* AddonModPageHelperProvider */]
];
var AddonModPageModule = /** @class */ (function () {
    function AddonModPageModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, pluginfileDelegate, pluginfileHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        pluginfileDelegate.registerHandler(pluginfileHandler);
    }
    AddonModPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__components_components_module__["a" /* AddonModPageComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_page__["a" /* AddonModPageProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_helper__["a" /* AddonModPageHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModPageModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModPagePrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__["a" /* AddonModPageLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__["a" /* AddonModPageListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__["a" /* AddonModPagePluginFileHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_10__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModPageModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModPagePrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_9__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__["a" /* AddonModPageLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_12__providers_plugin_file_delegate__["a" /* CorePluginFileDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__["a" /* AddonModPagePluginFileHandler */],
            __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__["a" /* AddonModPageListLinkHandler */]])
    ], AddonModPageModule);
    return AddonModPageModule;
}());

//# sourceMappingURL=page.module.js.map

/***/ }),
/* 859 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPagePrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__page__ = __webpack_require__(172);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__helper__ = __webpack_require__(374);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Handler to prefetch pages.
 */
var AddonModPagePrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModPagePrefetchHandler, _super);
    function AddonModPagePrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, pageProvider, pageHelper) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.pageProvider = pageProvider;
        _this.pageHelper = pageHelper;
        _this.name = 'AddonModPage';
        _this.modName = 'page';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__page__["a" /* AddonModPageProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$/;
        return _this;
    }
    /**
     * Download or prefetch the content.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files. This is to keep the files
     *                           relative paths and make the package work in an iframe. Undefined to download the files
     *                           in the filepool root page.
     * @return {Promise<any>} Promise resolved when all content is downloaded. Data returned is not reliable.
     */
    AddonModPagePrefetchHandler.prototype.downloadOrPrefetch = function (module, courseId, prefetch, dirPath) {
        var promises = [];
        promises.push(_super.prototype.downloadOrPrefetch.call(this, module, courseId, prefetch));
        if (this.pageProvider.isGetPageWSAvailable()) {
            promises.push(this.pageProvider.getPageData(courseId, module.id));
        }
        return Promise.all(promises);
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModPagePrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.pageProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModPagePrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var promises = [];
        promises.push(this.pageProvider.invalidatePageData(courseId));
        promises.push(this.courseProvider.invalidateModule(module.id));
        return this.utils.allPromises(promises);
    };
    AddonModPagePrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__page__["a" /* AddonModPageProvider */],
            __WEBPACK_IMPORTED_MODULE_10__helper__["a" /* AddonModPageHelperProvider */]])
    ], AddonModPagePrefetchHandler);
    return AddonModPagePrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__["a" /* CoreCourseResourcePrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 860 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_QUIZ_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModQuizModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_access_rules_delegate__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_quiz__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_quiz_offline__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_helper__ = __webpack_require__(185);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_quiz_sync__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_module_handler__ = __webpack_require__(1633);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_prefetch_handler__ = __webpack_require__(375);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__ = __webpack_require__(1634);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_index_link_handler__ = __webpack_require__(1635);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_grade_link_handler__ = __webpack_require__(1636);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_review_link_handler__ = __webpack_require__(1637);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_list_link_handler__ = __webpack_require__(1638);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__ = __webpack_require__(1639);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__components_components_module__ = __webpack_require__(1009);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__providers_update_manager__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__accessrules_delaybetweenattempts_delaybetweenattempts_module__ = __webpack_require__(1640);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__accessrules_ipaddress_ipaddress_module__ = __webpack_require__(1642);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__accessrules_numattempts_numattempts_module__ = __webpack_require__(1644);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__accessrules_offlineattempts_offlineattempts_module__ = __webpack_require__(1646);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__accessrules_openclosedate_openclosedate_module__ = __webpack_require__(1648);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__accessrules_password_password_module__ = __webpack_require__(1650);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__accessrules_safebrowser_safebrowser_module__ = __webpack_require__(1652);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__accessrules_securewindow_securewindow_module__ = __webpack_require__(1654);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__accessrules_timelimit_timelimit_module__ = __webpack_require__(1656);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





















// Access rules.









// List of providers (without handlers).
var ADDON_MOD_QUIZ_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_6__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */],
    __WEBPACK_IMPORTED_MODULE_7__providers_quiz__["a" /* AddonModQuizProvider */],
    __WEBPACK_IMPORTED_MODULE_8__providers_quiz_offline__["a" /* AddonModQuizOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_9__providers_helper__["a" /* AddonModQuizHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_10__providers_quiz_sync__["a" /* AddonModQuizSyncProvider */]
];
var AddonModQuizModule = /** @class */ (function () {
    function AddonModQuizModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, linksDelegate, indexHandler, gradeHandler, reviewHandler, updateManager, listLinkHandler, pushNotificationsDelegate, pushClickHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        linksDelegate.registerHandler(indexHandler);
        linksDelegate.registerHandler(gradeHandler);
        linksDelegate.registerHandler(reviewHandler);
        linksDelegate.registerHandler(listLinkHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mod_quiz_attempts',
            newName: __WEBPACK_IMPORTED_MODULE_8__providers_quiz_offline__["a" /* AddonModQuizOfflineProvider */].ATTEMPTS_TABLE,
            fields: [
                {
                    name: 'quizAndUser',
                    delete: true
                },
                {
                    name: 'finished',
                    type: 'boolean'
                }
            ]
        });
    }
    AddonModQuizModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_19__components_components_module__["a" /* AddonModQuizComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_21__accessrules_delaybetweenattempts_delaybetweenattempts_module__["a" /* AddonModQuizAccessDelayBetweenAttemptsModule */],
                __WEBPACK_IMPORTED_MODULE_22__accessrules_ipaddress_ipaddress_module__["a" /* AddonModQuizAccessIpAddressModule */],
                __WEBPACK_IMPORTED_MODULE_23__accessrules_numattempts_numattempts_module__["a" /* AddonModQuizAccessNumAttemptsModule */],
                __WEBPACK_IMPORTED_MODULE_24__accessrules_offlineattempts_offlineattempts_module__["a" /* AddonModQuizAccessOfflineAttemptsModule */],
                __WEBPACK_IMPORTED_MODULE_25__accessrules_openclosedate_openclosedate_module__["a" /* AddonModQuizAccessOpenCloseDateModule */],
                __WEBPACK_IMPORTED_MODULE_26__accessrules_password_password_module__["a" /* AddonModQuizAccessPasswordModule */],
                __WEBPACK_IMPORTED_MODULE_27__accessrules_safebrowser_safebrowser_module__["a" /* AddonModQuizAccessSafeBrowserModule */],
                __WEBPACK_IMPORTED_MODULE_28__accessrules_securewindow_securewindow_module__["a" /* AddonModQuizAccessSecureWindowModule */],
                __WEBPACK_IMPORTED_MODULE_29__accessrules_timelimit_timelimit_module__["a" /* AddonModQuizAccessTimeLimitModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */],
                __WEBPACK_IMPORTED_MODULE_7__providers_quiz__["a" /* AddonModQuizProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_quiz_offline__["a" /* AddonModQuizOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_9__providers_helper__["a" /* AddonModQuizHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_10__providers_quiz_sync__["a" /* AddonModQuizSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_11__providers_module_handler__["a" /* AddonModQuizModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_prefetch_handler__["a" /* AddonModQuizPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__["a" /* AddonModQuizSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_index_link_handler__["a" /* AddonModQuizIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_grade_link_handler__["a" /* AddonModQuizGradeLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_16__providers_review_link_handler__["a" /* AddonModQuizReviewLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_17__providers_list_link_handler__["a" /* AddonModQuizListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__["a" /* AddonModQuizPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_11__providers_module_handler__["a" /* AddonModQuizModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_12__providers_prefetch_handler__["a" /* AddonModQuizPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__["a" /* AddonModQuizSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */],
            __WEBPACK_IMPORTED_MODULE_14__providers_index_link_handler__["a" /* AddonModQuizIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_15__providers_grade_link_handler__["a" /* AddonModQuizGradeLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_16__providers_review_link_handler__["a" /* AddonModQuizReviewLinkHandler */], __WEBPACK_IMPORTED_MODULE_20__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_17__providers_list_link_handler__["a" /* AddonModQuizListLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_18__providers_push_click_handler__["a" /* AddonModQuizPushClickHandler */]])
    ], AddonModQuizModule);
    return AddonModQuizModule;
}());

//# sourceMappingURL=quiz.module.js.map

/***/ }),
/* 861 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessOfflineAttemptsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to render the preflight for offline attempts.
 */
var AddonModQuizAccessOfflineAttemptsComponent = /** @class */ (function () {
    function AddonModQuizAccessOfflineAttemptsComponent(fb) {
        this.fb = fb;
    }
    /**
     * Component being initialized.
     */
    AddonModQuizAccessOfflineAttemptsComponent.prototype.ngOnInit = function () {
        // Always set confirmdatasaved to 1. Sending the data means the user accepted.
        this.form.addControl('confirmdatasaved', this.fb.control(1));
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModQuizAccessOfflineAttemptsComponent.prototype, "rule", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModQuizAccessOfflineAttemptsComponent.prototype, "quiz", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModQuizAccessOfflineAttemptsComponent.prototype, "attempt", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModQuizAccessOfflineAttemptsComponent.prototype, "prefetch", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModQuizAccessOfflineAttemptsComponent.prototype, "siteId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonModQuizAccessOfflineAttemptsComponent.prototype, "form", void 0);
    AddonModQuizAccessOfflineAttemptsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-quiz-access-offline-attempts',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\accessrules\offlineattempts\component\addon-mod-quiz-access-offline-attempts.html"*/'<ion-item text-wrap>\n    <p class="item-heading">{{ \'core.settings.synchronization\' | translate }}</p>\n    <p>{{ \'addon.mod_quiz.confirmcontinueoffline\' | translate:{$a: quiz.syncTimeReadable} }}</p>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\accessrules\offlineattempts\component\addon-mod-quiz-access-offline-attempts.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModQuizAccessOfflineAttemptsComponent);
    return AddonModQuizAccessOfflineAttemptsComponent;
}());

//# sourceMappingURL=offlineattempts.js.map

/***/ }),
/* 862 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessPasswordComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to render the preflight for password.
 */
var AddonModQuizAccessPasswordComponent = /** @class */ (function () {
    function AddonModQuizAccessPasswordComponent(fb) {
        this.fb = fb;
    }
    /**
     * Component being initialized.
     */
    AddonModQuizAccessPasswordComponent.prototype.ngOnInit = function () {
        // Add the control for the password.
        this.form.addControl('quizpassword', this.fb.control(''));
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModQuizAccessPasswordComponent.prototype, "rule", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModQuizAccessPasswordComponent.prototype, "quiz", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModQuizAccessPasswordComponent.prototype, "attempt", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModQuizAccessPasswordComponent.prototype, "prefetch", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModQuizAccessPasswordComponent.prototype, "siteId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonModQuizAccessPasswordComponent.prototype, "form", void 0);
    AddonModQuizAccessPasswordComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-quiz-access-password',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\accessrules\password\component\addon-mod-quiz-access-password.html"*/'<ion-item text-wrap>\n    <p class="item-heading">{{ \'addon.mod_quiz.quizpassword\' | translate }}</p>\n    <p>{{ \'addon.mod_quiz.requirepasswordmessage\' | translate}}</p>\n</ion-item>\n<ion-item [formGroup]="form">\n    <core-show-password item-content [name]="\'quizpassword\'">\n        <ion-input id="addon-mod_quiz-accessrule-password-input" name="quizpassword" type="password" placeholder="{{ \'addon.mod_quiz.quizpassword\' | translate }}" [formControlName]="\'quizpassword\'" [clearOnEdit]="false"></ion-input>\n    </core-show-password>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\accessrules\password\component\addon-mod-quiz-access-password.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModQuizAccessPasswordComponent);
    return AddonModQuizAccessPasswordComponent;
}());

//# sourceMappingURL=password.js.map

/***/ }),
/* 863 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessTimeLimitComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to render the preflight for time limit.
 */
var AddonModQuizAccessTimeLimitComponent = /** @class */ (function () {
    function AddonModQuizAccessTimeLimitComponent() {
        // Nothing to do, we don't need to send anything for time limit.
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModQuizAccessTimeLimitComponent.prototype, "rule", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModQuizAccessTimeLimitComponent.prototype, "quiz", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModQuizAccessTimeLimitComponent.prototype, "attempt", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModQuizAccessTimeLimitComponent.prototype, "prefetch", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModQuizAccessTimeLimitComponent.prototype, "siteId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonModQuizAccessTimeLimitComponent.prototype, "form", void 0);
    AddonModQuizAccessTimeLimitComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-quiz-access-time-limit',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\accessrules\timelimit\component\addon-mod-quiz-access-time-limit.html"*/'<ion-item text-wrap>\n    <p class="item-heading">{{ \'addon.mod_quiz.confirmstartheader\' | translate }}</p>\n    <p>{{ \'addon.mod_quiz.confirmstart\' | translate:{$a: quiz.readableTimeLimit} }}</p>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\quiz\accessrules\timelimit\component\addon-mod-quiz-access-time-limit.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessTimeLimitComponent);
    return AddonModQuizAccessTimeLimitComponent;
}());

//# sourceMappingURL=timelimit.js.map

/***/ }),
/* 864 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_RESOURCE_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModResourceModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_components_module__ = __webpack_require__(1011);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__ = __webpack_require__(1658);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_resource__ = __webpack_require__(181);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__ = __webpack_require__(865);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__ = __webpack_require__(1659);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__ = __webpack_require__(1660);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__ = __webpack_require__(1661);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_helper__ = __webpack_require__(269);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_plugin_file_delegate__ = __webpack_require__(177);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













// List of providers (without handlers).
var ADDON_MOD_RESOURCE_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_3__providers_resource__["a" /* AddonModResourceProvider */]
];
var AddonModResourceModule = /** @class */ (function () {
    function AddonModResourceModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, pluginfileDelegate, pluginfileHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        pluginfileDelegate.registerHandler(pluginfileHandler);
    }
    AddonModResourceModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__components_components_module__["a" /* AddonModResourceComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_resource__["a" /* AddonModResourceProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModResourceModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_helper__["a" /* AddonModResourceHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModResourcePrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__["a" /* AddonModResourceLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__["a" /* AddonModResourceListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__["a" /* AddonModResourcePluginFileHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_10__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModResourceModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_11__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModResourcePrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_9__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_link_handler__["a" /* AddonModResourceLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_12__providers_plugin_file_delegate__["a" /* CorePluginFileDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_pluginfile_handler__["a" /* AddonModResourcePluginFileHandler */],
            __WEBPACK_IMPORTED_MODULE_6__providers_list_link_handler__["a" /* AddonModResourceListLinkHandler */]])
    ], AddonModResourceModule);
    return AddonModResourceModule;
}());

//# sourceMappingURL=resource.module.js.map

/***/ }),
/* 865 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourcePrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__resource__ = __webpack_require__(181);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__helper__ = __webpack_require__(269);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Handler to prefetch resources.
 */
var AddonModResourcePrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModResourcePrefetchHandler, _super);
    function AddonModResourcePrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, resourceProvider, resourceHelper) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.resourceProvider = resourceProvider;
        _this.resourceHelper = resourceHelper;
        _this.name = 'AddonModResource';
        _this.modName = 'resource';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__resource__["a" /* AddonModResourceProvider */].COMPONENT;
        return _this;
    }
    /**
     * Return the status to show based on current status.
     *
     * @param {any} module Module.
     * @param {string} status The current status.
     * @param {boolean} canCheck Whether the site allows checking for updates.
     * @return {string} Status to display.
     */
    AddonModResourcePrefetchHandler.prototype.determineStatus = function (module, status, canCheck) {
        if (status == __WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].DOWNLOADED && module) {
            // If the main file is an external file, always display the module as outdated.
            if (module.contentsinfo) {
                if (module.contentsinfo.repositorytype) {
                    // It's an external file.
                    return __WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].OUTDATED;
                }
            }
            else if (module.contents) {
                var mainFile = module.contents[0];
                if (mainFile && mainFile.isexternalfile) {
                    return __WEBPACK_IMPORTED_MODULE_11__core_constants__["a" /* CoreConstants */].OUTDATED;
                }
            }
        }
        return status;
    };
    /**
     * Download or prefetch the content.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files. This is to keep the files
     *                           relative paths and make the package work in an iframe. Undefined to download the files
     *                           in the filepool root folder.
     * @return {Promise<any>} Promise resolved when all content is downloaded. Data returned is not reliable.
     */
    AddonModResourcePrefetchHandler.prototype.downloadOrPrefetch = function (module, courseId, prefetch, dirPath) {
        var _this = this;
        var promise;
        if (this.resourceHelper.isDisplayedInIframe(module)) {
            promise = this.filepoolProvider.getPackageDirPathByUrl(this.sitesProvider.getCurrentSiteId(), module.url);
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function (dirPath) {
            var promises = [];
            promises.push(_super.prototype.downloadOrPrefetch.call(_this, module, courseId, prefetch, dirPath));
            if (_this.resourceProvider.isGetResourceWSAvailable()) {
                promises.push(_this.resourceProvider.getResourceData(courseId, module.id));
            }
            return Promise.all(promises);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModResourcePrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.resourceProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModResourcePrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var promises = [];
        promises.push(this.resourceProvider.invalidateResourceData(courseId));
        promises.push(this.courseProvider.invalidateModule(module.id, undefined, this.modName));
        return Promise.all(promises);
    };
    /**
     * Check if a resource is downloadable.
     *
     * @param {any} module Module to check.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<boolean>} Promise resolved with true if downloadable, resolved with false otherwise.
     */
    AddonModResourcePrefetchHandler.prototype.isDownloadable = function (module, courseId) {
        var _this = this;
        if (this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.7')) {
            // Nextcloud files are downloadable from 3.7 onwards.
            return Promise.resolve(true);
        }
        // Don't allow downloading Nextcloud files in older sites.
        return this.loadContents(module, courseId, false).then(function () {
            return !_this.resourceHelper.isNextcloudFile(module);
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModResourcePrefetchHandler.prototype.isEnabled = function () {
        return this.resourceProvider.isPluginEnabled();
    };
    AddonModResourcePrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__resource__["a" /* AddonModResourceProvider */],
            __WEBPACK_IMPORTED_MODULE_10__helper__["a" /* AddonModResourceHelperProvider */]])
    ], AddonModResourcePrefetchHandler);
    return AddonModResourcePrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__["a" /* CoreCourseResourcePrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 866 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_SCORM_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModScormModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_scorm__ = __webpack_require__(168);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(442);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_scorm_offline__ = __webpack_require__(216);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_module_handler__ = __webpack_require__(1662);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__ = __webpack_require__(376);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_sync_cron_handler__ = __webpack_require__(1663);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_index_link_handler__ = __webpack_require__(1664);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_grade_link_handler__ = __webpack_require__(1665);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_list_link_handler__ = __webpack_require__(1666);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_scorm_sync__ = __webpack_require__(227);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__components_components_module__ = __webpack_require__(1012);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















// List of providers (without handlers).
var ADDON_MOD_SCORM_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */],
    __WEBPACK_IMPORTED_MODULE_7__providers_scorm_offline__["a" /* AddonModScormOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModScormHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_14__providers_scorm_sync__["a" /* AddonModScormSyncProvider */]
];
var AddonModScormModule = /** @class */ (function () {
    function AddonModScormModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, linksDelegate, indexHandler, gradeHandler, updateManager, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        linksDelegate.registerHandler(indexHandler);
        linksDelegate.registerHandler(gradeHandler);
        linksDelegate.registerHandler(listLinkHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTablesMigration([
            {
                name: 'mod_scorm_offline_attempts',
                newName: __WEBPACK_IMPORTED_MODULE_7__providers_scorm_offline__["a" /* AddonModScormOfflineProvider */].ATTEMPTS_TABLE,
                fields: [
                    {
                        name: 'snapshot',
                        type: 'object'
                    },
                    {
                        name: 'scormAndUser',
                        delete: true
                    }
                ]
            },
            {
                name: 'mod_scorm_offline_scos_tracks',
                newName: __WEBPACK_IMPORTED_MODULE_7__providers_scorm_offline__["a" /* AddonModScormOfflineProvider */].TRACKS_TABLE,
                fields: [
                    {
                        name: 'value',
                        type: 'object'
                    },
                    {
                        name: 'scormUserAttempt',
                        delete: true
                    },
                    {
                        name: 'scormUserAttemptSynced',
                        delete: true
                    }
                ]
            }
        ]);
    }
    AddonModScormModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_15__components_components_module__["a" /* AddonModScormComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_scorm__["a" /* AddonModScormProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_scorm_offline__["a" /* AddonModScormOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModScormHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_14__providers_scorm_sync__["a" /* AddonModScormSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_module_handler__["a" /* AddonModScormModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__["a" /* AddonModScormPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_sync_cron_handler__["a" /* AddonModScormSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_index_link_handler__["a" /* AddonModScormIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_grade_link_handler__["a" /* AddonModScormGradeLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_list_link_handler__["a" /* AddonModScormListLinkHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_8__providers_module_handler__["a" /* AddonModScormModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_prefetch_handler__["a" /* AddonModScormPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_10__providers_sync_cron_handler__["a" /* AddonModScormSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */],
            __WEBPACK_IMPORTED_MODULE_11__providers_index_link_handler__["a" /* AddonModScormIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_12__providers_grade_link_handler__["a" /* AddonModScormGradeLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_16__providers_update_manager__["a" /* CoreUpdateManagerProvider */], __WEBPACK_IMPORTED_MODULE_13__providers_list_link_handler__["a" /* AddonModScormListLinkHandler */]])
    ], AddonModScormModule);
    return AddonModScormModule;
}());

//# sourceMappingURL=scorm.module.js.map

/***/ }),
/* 867 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_SURVEY_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModSurveyModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1013);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__ = __webpack_require__(1667);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_survey__ = __webpack_require__(270);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__ = __webpack_require__(1668);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_list_link_handler__ = __webpack_require__(1669);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_helper__ = __webpack_require__(377);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__ = __webpack_require__(868);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_sync__ = __webpack_require__(272);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__ = __webpack_require__(1670);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_offline__ = __webpack_require__(271);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















// List of providers (without handlers).
var ADDON_MOD_SURVEY_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_7__providers_survey__["a" /* AddonModSurveyProvider */],
    __WEBPACK_IMPORTED_MODULE_10__providers_helper__["a" /* AddonModSurveyHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_12__providers_sync__["a" /* AddonModSurveySyncProvider */],
    __WEBPACK_IMPORTED_MODULE_14__providers_offline__["a" /* AddonModSurveyOfflineProvider */]
];
var AddonModSurveyModule = /** @class */ (function () {
    function AddonModSurveyModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, cronDelegate, syncHandler, updateManager, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        cronDelegate.register(syncHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_mod_survey_answers',
            newName: __WEBPACK_IMPORTED_MODULE_14__providers_offline__["a" /* AddonModSurveyOfflineProvider */].SURVEY_TABLE,
            fields: [
                {
                    name: 'answers',
                    type: 'object'
                }
            ]
        });
    }
    AddonModSurveyModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonModSurveyComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_survey__["a" /* AddonModSurveyProvider */],
                __WEBPACK_IMPORTED_MODULE_10__providers_helper__["a" /* AddonModSurveyHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_12__providers_sync__["a" /* AddonModSurveySyncProvider */],
                __WEBPACK_IMPORTED_MODULE_14__providers_offline__["a" /* AddonModSurveyOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__["a" /* AddonModSurveyModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__["a" /* AddonModSurveyPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__["a" /* AddonModSurveyLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_list_link_handler__["a" /* AddonModSurveyListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__["a" /* AddonModSurveySyncCronHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__["a" /* AddonModSurveyModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_11__providers_prefetch_handler__["a" /* AddonModSurveyPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__["a" /* AddonModSurveyLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_13__providers_sync_cron_handler__["a" /* AddonModSurveySyncCronHandler */], __WEBPACK_IMPORTED_MODULE_15__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_list_link_handler__["a" /* AddonModSurveyListLinkHandler */]])
    ], AddonModSurveyModule);
    return AddonModSurveyModule;
}());

//# sourceMappingURL=survey.module.js.map

/***/ }),
/* 868 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__survey__ = __webpack_require__(270);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__sync__ = __webpack_require__(272);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__helper__ = __webpack_require__(377);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Handler to prefetch surveys.
 */
var AddonModSurveyPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModSurveyPrefetchHandler, _super);
    function AddonModSurveyPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, surveyProvider, surveyHelper, injector) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.surveyProvider = surveyProvider;
        _this.surveyHelper = surveyHelper;
        _this.injector = injector;
        _this.name = 'AddonModSurvey';
        _this.modName = 'survey';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__survey__["a" /* AddonModSurveyProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^answers$/;
        return _this;
    }
    /**
     * Returns survey intro files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    AddonModSurveyPrefetchHandler.prototype.getIntroFiles = function (module, courseId) {
        var _this = this;
        return this.surveyProvider.getSurvey(courseId, module.id).catch(function () {
            // Not found, return undefined so module description is used.
        }).then(function (survey) {
            return _this.getIntroFilesFromInstance(module, survey);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModSurveyPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.surveyProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModSurveyPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        return this.surveyProvider.invalidateSurveyData(courseId);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModSurveyPrefetchHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModSurveyPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchSurvey.bind(this));
    };
    /**
     * Prefetch a survey.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModSurveyPrefetchHandler.prototype.prefetchSurvey = function (module, courseId, single, siteId) {
        var _this = this;
        return this.surveyProvider.getSurvey(courseId, module.id, true, siteId).then(function (survey) {
            var promises = [], files = _this.getIntroFilesFromInstance(module, survey);
            // Prefetch files.
            promises.push(_this.filepoolProvider.addFilesToQueue(siteId, files, __WEBPACK_IMPORTED_MODULE_9__survey__["a" /* AddonModSurveyProvider */].COMPONENT, module.id));
            // If survey isn't answered, prefetch the questions.
            if (!survey.surveydone) {
                promises.push(_this.surveyProvider.getQuestions(survey.id, true, siteId));
            }
            return Promise.all(promises);
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModSurveyPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        if (!this.syncProvider) {
            this.syncProvider = this.injector.get(__WEBPACK_IMPORTED_MODULE_10__sync__["a" /* AddonModSurveySyncProvider */]);
        }
        return this.syncProvider.syncSurvey(module.instance, undefined, siteId);
    };
    AddonModSurveyPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__survey__["a" /* AddonModSurveyProvider */],
            __WEBPACK_IMPORTED_MODULE_11__helper__["a" /* AddonModSurveyHelperProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonModSurveyPrefetchHandler);
    return AddonModSurveyPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 869 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_URL_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModUrlModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_components_module__ = __webpack_require__(1014);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__ = __webpack_require__(1671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_url__ = __webpack_require__(378);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__ = __webpack_require__(1672);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__ = __webpack_require__(1673);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(379);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_module_delegate__ = __webpack_require__(38);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









// List of providers (without handlers).
var ADDON_MOD_URL_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_3__providers_url__["a" /* AddonModUrlProvider */],
    __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModUrlHelperProvider */]
];
var AddonModUrlModule = /** @class */ (function () {
    function AddonModUrlModule(moduleDelegate, moduleHandler, contentLinksDelegate, linkHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
    }
    AddonModUrlModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__components_components_module__["a" /* AddonModUrlComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_url__["a" /* AddonModUrlProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* AddonModUrlHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModUrlModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__["a" /* AddonModUrlLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__["a" /* AddonModUrlListLinkHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModUrlModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_7__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_link_handler__["a" /* AddonModUrlLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_5__providers_list_link_handler__["a" /* AddonModUrlListLinkHandler */]])
    ], AddonModUrlModule);
    return AddonModUrlModule;
}());

//# sourceMappingURL=url.module.js.map

/***/ }),
/* 870 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_WIKI_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModWikiModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1015);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_wiki__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_wiki_offline__ = __webpack_require__(228);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__ = __webpack_require__(229);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_module_handler__ = __webpack_require__(1674);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__ = __webpack_require__(1675);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_sync_cron_handler__ = __webpack_require__(1676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_index_link_handler__ = __webpack_require__(1677);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_page_or_map_link_handler__ = __webpack_require__(1678);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_create_link_handler__ = __webpack_require__(1679);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_edit_link_handler__ = __webpack_require__(1680);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_list_link_handler__ = __webpack_require__(1681);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















// List of providers (without handlers).
var ADDON_MOD_WIKI_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_6__providers_wiki__["a" /* AddonModWikiProvider */],
    __WEBPACK_IMPORTED_MODULE_7__providers_wiki_offline__["a" /* AddonModWikiOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__["a" /* AddonModWikiSyncProvider */]
];
var AddonModWikiModule = /** @class */ (function () {
    function AddonModWikiModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, linksDelegate, indexHandler, pageOrMapHandler, createHandler, editHandler, updateManager, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        linksDelegate.registerHandler(indexHandler);
        linksDelegate.registerHandler(pageOrMapHandler);
        linksDelegate.registerHandler(createHandler);
        linksDelegate.registerHandler(editHandler);
        linksDelegate.registerHandler(listLinkHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_mod_wiki_new_pages_store',
            newName: __WEBPACK_IMPORTED_MODULE_7__providers_wiki_offline__["a" /* AddonModWikiOfflineProvider */].NEW_PAGES_TABLE,
            fields: [
                {
                    name: 'subwikiWikiUserGroup',
                    delete: true
                },
                {
                    name: 'caneditpage',
                    type: 'boolean'
                }
            ]
        });
    }
    AddonModWikiModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonModWikiComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_wiki__["a" /* AddonModWikiProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_wiki_offline__["a" /* AddonModWikiOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_8__providers_wiki_sync__["a" /* AddonModWikiSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_9__providers_module_handler__["a" /* AddonModWikiModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__["a" /* AddonModWikiPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_sync_cron_handler__["a" /* AddonModWikiSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_index_link_handler__["a" /* AddonModWikiIndexLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_page_or_map_link_handler__["a" /* AddonModWikiPageOrMapLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_14__providers_create_link_handler__["a" /* AddonModWikiCreateLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_edit_link_handler__["a" /* AddonModWikiEditLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_16__providers_list_link_handler__["a" /* AddonModWikiListLinkHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_module_handler__["a" /* AddonModWikiModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_10__providers_prefetch_handler__["a" /* AddonModWikiPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_11__providers_sync_cron_handler__["a" /* AddonModWikiSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */],
            __WEBPACK_IMPORTED_MODULE_12__providers_index_link_handler__["a" /* AddonModWikiIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_13__providers_page_or_map_link_handler__["a" /* AddonModWikiPageOrMapLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_14__providers_create_link_handler__["a" /* AddonModWikiCreateLinkHandler */], __WEBPACK_IMPORTED_MODULE_15__providers_edit_link_handler__["a" /* AddonModWikiEditLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_17__providers_update_manager__["a" /* CoreUpdateManagerProvider */], __WEBPACK_IMPORTED_MODULE_16__providers_list_link_handler__["a" /* AddonModWikiListLinkHandler */]])
    ], AddonModWikiModule);
    return AddonModWikiModule;
}());

//# sourceMappingURL=wiki.module.js.map

/***/ }),
/* 871 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiSubwikiPickerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to display the a list of subwikis in a wiki.
 */
var AddonModWikiSubwikiPickerComponent = /** @class */ (function () {
    function AddonModWikiSubwikiPickerComponent(navParams, viewCtrl) {
        this.viewCtrl = viewCtrl;
        this.subwikis = navParams.get('subwikis');
        this.currentSubwiki = navParams.get('currentSubwiki');
    }
    /**
     * Checks if the given subwiki is the one currently selected.
     *
     * @param {any} subwiki Subwiki to check.
     * @return {boolean} Whether it's the selected subwiki.
     */
    AddonModWikiSubwikiPickerComponent.prototype.isSubwikiSelected = function (subwiki) {
        var subwikiId = parseInt(subwiki.id, 10) || 0;
        if (subwikiId > 0 && this.currentSubwiki.id > 0) {
            return subwikiId == this.currentSubwiki.id;
        }
        var userId = parseInt(subwiki.userid, 10) || 0, groupId = parseInt(subwiki.groupid, 10) || 0;
        return userId == this.currentSubwiki.userid && groupId == this.currentSubwiki.groupid;
    };
    /**
     * Function called when a subwiki is clicked.
     *
     * @param {any} subwiki The subwiki to open.
     */
    AddonModWikiSubwikiPickerComponent.prototype.openSubwiki = function (subwiki) {
        // Check if the subwiki is disabled.
        if (subwiki.id > 0 || subwiki.canedit) {
            // Check if it isn't current subwiki.
            if (subwiki != this.currentSubwiki) {
                this.viewCtrl.dismiss(subwiki);
            }
        }
    };
    AddonModWikiSubwikiPickerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-wiki-subwiki-picker',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\wiki\components\subwiki-picker\addon-mod-wiki-subwiki-picker.html"*/'<ion-list>\n    <ng-container *ngFor="let group of subwikis">\n        <ion-item-divider *ngIf="group.label">\n            {{ group.label }}\n        </ion-item-divider>\n        <a ion-item text-wrap *ngFor="let subwiki of group.subwikis;" (click)="openSubwiki(subwiki)" [attr.disabled]="!subwiki.canedit && subwiki.id <= 0 ? true : null" [ngClass]="{\'addon-mod_wiki-subwiki-selected\': isSubwikiSelected(subwiki)}" detail-none>\n            {{ subwiki.name }}\n            <ion-icon *ngIf="isSubwikiSelected(subwiki)" name="checkmark" item-end></ion-icon>\n        </a>\n    </ng-container>\n</ion-list>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\wiki\components\subwiki-picker\addon-mod-wiki-subwiki-picker.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */]])
    ], AddonModWikiSubwikiPickerComponent);
    return AddonModWikiSubwikiPickerComponent;
}());

//# sourceMappingURL=subwiki-picker.js.map

/***/ }),
/* 872 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_MOD_WORKSHOP_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonModWorkshopModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__assessment_assessment_module__ = __webpack_require__(1682);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(416);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_module_handler__ = __webpack_require__(1693);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_link_handler__ = __webpack_require__(1694);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_list_link_handler__ = __webpack_require__(1695);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_offline__ = __webpack_require__(133);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_sync__ = __webpack_require__(221);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_helper__ = __webpack_require__(152);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_assessment_strategy_delegate__ = __webpack_require__(129);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__ = __webpack_require__(1696);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__ = __webpack_require__(1697);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















// List of providers (without handlers).
var ADDON_MOD_WORKSHOP_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_8__providers_workshop__["a" /* AddonModWorkshopProvider */],
    __WEBPACK_IMPORTED_MODULE_11__providers_offline__["a" /* AddonModWorkshopOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_12__providers_sync__["a" /* AddonModWorkshopSyncProvider */],
    __WEBPACK_IMPORTED_MODULE_13__providers_helper__["a" /* AddonModWorkshopHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_14__providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */]
];
var AddonModWorkshopModule = /** @class */ (function () {
    function AddonModWorkshopModule(moduleDelegate, moduleHandler, contentLinksDelegate, linkHandler, prefetchDelegate, prefetchHandler, cronDelegate, syncHandler, updateManager, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        cronDelegate.register(syncHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTablesMigration([
            {
                name: 'mma_mod_workshop_offline_submissions',
                newName: __WEBPACK_IMPORTED_MODULE_11__providers_offline__["a" /* AddonModWorkshopOfflineProvider */].SUBMISSIONS_TABLE,
                fields: [
                    {
                        name: 'attachmentsid',
                        type: 'object'
                    }
                ]
            },
            {
                name: 'mma_mod_workshop_offline_assessments',
                newName: __WEBPACK_IMPORTED_MODULE_11__providers_offline__["a" /* AddonModWorkshopOfflineProvider */].ASSESSMENTS_TABLE,
                fields: [
                    {
                        name: 'inputdata',
                        type: 'object'
                    }
                ]
            },
            {
                name: 'mma_mod_workshop_offline_evaluate_submissions',
                newName: __WEBPACK_IMPORTED_MODULE_11__providers_offline__["a" /* AddonModWorkshopOfflineProvider */].EVALUATE_SUBMISSIONS_TABLE,
                fields: [
                    {
                        name: 'gradeover',
                        type: 'object'
                    },
                    {
                        name: 'published',
                        type: 'boolean'
                    }
                ]
            },
            {
                name: 'mma_mod_workshop_offline_evaluate_assessments',
                newName: __WEBPACK_IMPORTED_MODULE_11__providers_offline__["a" /* AddonModWorkshopOfflineProvider */].EVALUATE_ASSESSMENTS_TABLE,
                fields: [
                    {
                        name: 'gradinggradeover',
                        type: 'object'
                    }
                ]
            }
        ]);
    }
    AddonModWorkshopModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* AddonModWorkshopComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__assessment_assessment_module__["a" /* AddonModWorkshopAssessmentStrategyModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_8__providers_workshop__["a" /* AddonModWorkshopProvider */],
                __WEBPACK_IMPORTED_MODULE_7__providers_module_handler__["a" /* AddonModWorkshopModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_link_handler__["a" /* AddonModWorkshopLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_list_link_handler__["a" /* AddonModWorkshopListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_offline__["a" /* AddonModWorkshopOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_12__providers_sync__["a" /* AddonModWorkshopSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_13__providers_helper__["a" /* AddonModWorkshopHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_14__providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */],
                __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__["a" /* AddonModWorkshopPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__["a" /* AddonModWorkshopSyncCronHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_module_handler__["a" /* AddonModWorkshopModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_9__providers_link_handler__["a" /* AddonModWorkshopLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__["a" /* AddonModWorkshopPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_16__providers_sync_cron_handler__["a" /* AddonModWorkshopSyncCronHandler */],
            __WEBPACK_IMPORTED_MODULE_17__providers_update_manager__["a" /* CoreUpdateManagerProvider */], __WEBPACK_IMPORTED_MODULE_10__providers_list_link_handler__["a" /* AddonModWorkshopListLinkHandler */]])
    ], AddonModWorkshopModule);
    return AddonModWorkshopModule;
}());

//# sourceMappingURL=workshop.module.js.map

/***/ }),
/* 873 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyAccumulativeComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__ = __webpack_require__(273);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


/**
 * Component for accumulative assessment strategy.
 */
var AddonModWorkshopAssessmentStrategyAccumulativeComponent = /** @class */ (function (_super) {
    __extends(AddonModWorkshopAssessmentStrategyAccumulativeComponent, _super);
    function AddonModWorkshopAssessmentStrategyAccumulativeComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AddonModWorkshopAssessmentStrategyAccumulativeComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-assessment-strategy-accumulative',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\accumulative\component\addon-mod-workshop-assessment-strategy-accumulative.html"*/'<ng-container *ngFor="let field of assessment.form.fields; let n = index">\n    <ion-card *ngIf="n < assessment.form.dimenssionscount">\n        <ion-item text-wrap>\n            <h2>{{ field.dimtitle }}</h2>\n            <core-format-text [text]="field.description"></core-format-text>\n        </ion-item>\n        <ion-item *ngIf="edit && field.grades">\n            <ion-label [core-mark-required]="true" stacked>{{ \'addon.mod_workshop_assessment_accumulative.dimensiongradefor\' | translate : {\'$a\': field.dimtitle } }}</ion-label>\n            <ion-select [(ngModel)]="selectedValues[n].grade" interface="action-sheet">\n                <ion-option *ngFor="let grade of field.grades" [value]="grade.value">{{grade.label}}</ion-option>\n            </ion-select>\n            <core-input-errors item-content *ngIf="fieldErrors[\'grade_\' + n]" [errorText]="fieldErrors[\'grade_\' + n]"></core-input-errors>\n        </ion-item>\n        <ion-item *ngIf="!edit && field.grades" text-wrap>\n            <h2>{{ \'addon.mod_workshop_assessment_accumulative.dimensiongradefor\' | translate : {\'$a\': field.dimtitle } }}</h2>\n            <ng-container *ngFor="let grade of field.grades">\n                <p *ngIf="grade.value === selectedValues[n].grade">{{grade.label}}</p>\n            </ng-container>\n        </ion-item>\n        <ion-item *ngIf="edit">\n            <ion-label stacked>{{ \'addon.mod_workshop_assessment_accumulative.dimensioncommentfor\' | translate : {\'$a\': field.dimtitle } }}</ion-label>\n            <ion-textarea aria-multiline="true" [(ngModel)]="selectedValues[n].peercomment" core-auto-rows></ion-textarea>\n        </ion-item>\n        <ion-item *ngIf="!edit" text-wrap>\n            <h2>{{ \'addon.mod_workshop_assessment_accumulative.dimensioncommentfor\' | translate : {\'$a\': field.dimtitle } }}</h2>\n            <p><core-format-text [text]="selectedValues[n].peercomment"></core-format-text></p>\n        </ion-item>\n    </ion-card>\n</ng-container>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\accumulative\component\addon-mod-workshop-assessment-strategy-accumulative.html"*/,
        })
    ], AddonModWorkshopAssessmentStrategyAccumulativeComponent);
    return AddonModWorkshopAssessmentStrategyAccumulativeComponent;
}(__WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__["a" /* AddonModWorkshopAssessmentStrategyComponentBase */]));

//# sourceMappingURL=accumulative.js.map

/***/ }),
/* 874 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyCommentsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__ = __webpack_require__(273);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


/**
 * Component for comments assessment strategy.
 */
var AddonModWorkshopAssessmentStrategyCommentsComponent = /** @class */ (function (_super) {
    __extends(AddonModWorkshopAssessmentStrategyCommentsComponent, _super);
    function AddonModWorkshopAssessmentStrategyCommentsComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AddonModWorkshopAssessmentStrategyCommentsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-assessment-strategy-comments',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\comments\component\addon-mod-workshop-assessment-strategy-comments.html"*/'<ng-container *ngFor="let field of assessment.form.fields; let n = index">\n    <ion-card *ngIf="n < assessment.form.dimenssionscount">\n        <ion-item text-wrap>\n            <h2>{{ field.dimtitle }}</h2>\n            <core-format-text [text]="field.description"></core-format-text>\n        </ion-item>\n        <ion-item *ngIf="edit">\n            <ion-label stacked [core-mark-required]="true">{{ \'addon.mod_workshop_assessment_comments.dimensioncommentfor\' | translate : {\'$a\': field.dimtitle } }}</ion-label>\n            <ion-textarea aria-multiline="true" [(ngModel)]="selectedValues[n].peercomment" core-auto-rows></ion-textarea>\n            <core-input-errors item-content *ngIf="fieldErrors[\'peercomment_\' + n]" [errorText]="fieldErrors[\'peercomment_\' + n]"></core-input-errors>\n        </ion-item>\n        <ion-item *ngIf="!edit" text-wrap>\n            <h2>{{ \'addon.mod_workshop_assessment_comments.dimensioncommentfor\' | translate : {\'$a\': field.dimtitle } }}</h2>\n            <p><core-format-text [text]="selectedValues[n].peercomment"></core-format-text></p>\n        </ion-item>\n    </ion-card>\n</ng-container>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\comments\component\addon-mod-workshop-assessment-strategy-comments.html"*/,
        })
    ], AddonModWorkshopAssessmentStrategyCommentsComponent);
    return AddonModWorkshopAssessmentStrategyCommentsComponent;
}(__WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__["a" /* AddonModWorkshopAssessmentStrategyComponentBase */]));

//# sourceMappingURL=comments.js.map

/***/ }),
/* 875 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyNumErrorsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__ = __webpack_require__(273);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


/**
 * Component for numerrors assessment strategy.
 */
var AddonModWorkshopAssessmentStrategyNumErrorsComponent = /** @class */ (function (_super) {
    __extends(AddonModWorkshopAssessmentStrategyNumErrorsComponent, _super);
    function AddonModWorkshopAssessmentStrategyNumErrorsComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AddonModWorkshopAssessmentStrategyNumErrorsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-assessment-strategy-numerrors',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\numerrors\component\addon-mod-workshop-assessment-strategy-numerrors.html"*/'<ng-container *ngFor="let field of assessment.form.fields; let n = index">\n    <ion-card *ngIf="n < assessment.form.dimenssionscount">\n        <ion-item text-wrap>\n            <h2>{{ field.dimtitle }}</h2>\n            <core-format-text [text]="field.description"></core-format-text>\n        </ion-item>\n        <ion-list radio-group [(ngModel)]="selectedValues[n].grade" [name]="\'grade_\' + n">\n            <ion-item>\n                <ion-label stacked [core-mark-required]="edit">{{ \'addon.mod_workshop.yourassessmentfor\' | translate : {\'$a\': field.dimtitle } }}</ion-label>\n                <core-input-errors item-content *ngIf="edit && fieldErrors[\'grade_\' + n]" [errorText]="fieldErrors[\'grade_\' + n]"></core-input-errors>\n            </ion-item>\n            <ion-item>\n                <ion-label><core-format-text [text]="field.grade0"></core-format-text></ion-label>\n                <ion-radio [value]="-1" [disabled]="!edit"></ion-radio>\n            </ion-item>\n            <ion-item>\n                <ion-label><core-format-text [text]="field.grade1"></core-format-text></ion-label>\n                <ion-radio [value]="1" [disabled]="!edit"></ion-radio>\n            </ion-item>\n        </ion-list>\n        <ion-item *ngIf="edit">\n            <ion-label stacked>{{ \'addon.mod_workshop_assessment_numerrors.dimensioncommentfor\' | translate : {\'$a\': field.dimtitle } }}</ion-label>\n            <ion-textarea aria-multiline="true" [(ngModel)]="selectedValues[n].peercomment" [name]="\'peercomment_\' + n" core-auto-rows></ion-textarea>\n        </ion-item>\n        <ion-item *ngIf="!edit" text-wrap>\n            <h2>{{ \'addon.mod_workshop_assessment_numerrors.dimensioncommentfor\' | translate : {\'$a\': field.dimtitle } }}</h2>\n            <p><core-format-text [text]="selectedValues[n].peercomment"></core-format-text></p>\n        </ion-item>\n    </ion-card>\n</ng-container>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\numerrors\component\addon-mod-workshop-assessment-strategy-numerrors.html"*/,
        })
    ], AddonModWorkshopAssessmentStrategyNumErrorsComponent);
    return AddonModWorkshopAssessmentStrategyNumErrorsComponent;
}(__WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__["a" /* AddonModWorkshopAssessmentStrategyComponentBase */]));

//# sourceMappingURL=numerrors.js.map

/***/ }),
/* 876 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyRubricComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__ = __webpack_require__(273);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


/**
 * Component for rubric assessment strategy.
 */
var AddonModWorkshopAssessmentStrategyRubricComponent = /** @class */ (function (_super) {
    __extends(AddonModWorkshopAssessmentStrategyRubricComponent, _super);
    function AddonModWorkshopAssessmentStrategyRubricComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AddonModWorkshopAssessmentStrategyRubricComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-assessment-strategy-rubric',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\rubric\component\addon-mod-workshop-assessment-strategy-rubric.html"*/'<ng-container *ngFor="let field of assessment.form.fields; let n = index">\n    <ion-card *ngIf="n < assessment.form.dimenssionscount">\n        <ion-item text-wrap>\n            <h2 [core-mark-required]="edit">{{ field.dimtitle }}</h2>\n            <core-format-text [text]="field.description"></core-format-text>\n            <core-input-errors *ngIf="edit && fieldErrors[\'chosenlevelid_\' + n]" [errorText]="fieldErrors[\'chosenlevelid_\' + n]"></core-input-errors>\n        </ion-item>\n        <ion-list radio-group [(ngModel)]="selectedValues[n].chosenlevelid" [name]="\'chosenlevelid_\' + n">\n            <ion-item *ngFor="let subfield of field.fields">\n                <ion-label><p><core-format-text [text]="subfield.definition"></core-format-text></p></ion-label>\n                <ion-radio [value]="subfield.levelid" [disabled]="!edit"></ion-radio>\n            </ion-item>\n        </ion-list>\n    </ion-card>\n</ng-container>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\assessment\rubric\component\addon-mod-workshop-assessment-strategy-rubric.html"*/,
        })
    ], AddonModWorkshopAssessmentStrategyRubricComponent);
    return AddonModWorkshopAssessmentStrategyRubricComponent;
}(__WEBPACK_IMPORTED_MODULE_1__classes_assessment_strategy_component__["a" /* AddonModWorkshopAssessmentStrategyComponentBase */]));

//# sourceMappingURL=rubric.js.map

/***/ }),
/* 877 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_NOTES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonNotesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_notes__ = __webpack_require__(190);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_notes_offline__ = __webpack_require__(380);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_notes_sync__ = __webpack_require__(381);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_course_option_handler__ = __webpack_require__(1698);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sync_cron_handler__ = __webpack_require__(1699);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_user_handler__ = __webpack_require__(1700);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(1017);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












// List of providers (without handlers).
var ADDON_NOTES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_notes__["a" /* AddonNotesProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_notes_offline__["a" /* AddonNotesOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_3__providers_notes_sync__["a" /* AddonNotesSyncProvider */]
];
var AddonNotesModule = /** @class */ (function () {
    function AddonNotesModule(courseOptionsDelegate, courseOptionHandler, userDelegate, userHandler, cronDelegate, syncHandler, updateManager) {
        // Register handlers.
        courseOptionsDelegate.registerHandler(courseOptionHandler);
        userDelegate.registerHandler(userHandler);
        cronDelegate.register(syncHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_notes_offline_notes',
            newName: __WEBPACK_IMPORTED_MODULE_2__providers_notes_offline__["a" /* AddonNotesOfflineProvider */].NOTES_TABLE
        });
    }
    AddonNotesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* AddonNotesComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_notes__["a" /* AddonNotesProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_notes_offline__["a" /* AddonNotesOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_notes_sync__["a" /* AddonNotesSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_4__providers_course_option_handler__["a" /* AddonNotesCourseOptionHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_sync_cron_handler__["a" /* AddonNotesSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_user_handler__["a" /* AddonNotesUserHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_course_option_handler__["a" /* AddonNotesCourseOptionHandler */],
            __WEBPACK_IMPORTED_MODULE_10__core_user_providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_user_handler__["a" /* AddonNotesUserHandler */],
            __WEBPACK_IMPORTED_MODULE_9__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_sync_cron_handler__["a" /* AddonNotesSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_11__providers_update_manager__["a" /* CoreUpdateManagerProvider */]])
    ], AddonNotesModule);
    return AddonNotesModule;
}());

//# sourceMappingURL=notes.module.js.map

/***/ }),
/* 878 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesListComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_notes__ = __webpack_require__(190);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_notes_sync__ = __webpack_require__(381);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Component that displays the notes of a course.
 */
var AddonNotesListComponent = /** @class */ (function () {
    function AddonNotesListComponent(domUtils, textUtils, sitesProvider, eventsProvider, modalCtrl, notesProvider, notesSync, userProvider) {
        var _this = this;
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.modalCtrl = modalCtrl;
        this.notesProvider = notesProvider;
        this.notesSync = notesSync;
        this.userProvider = userProvider;
        this.type = 'course';
        this.refreshIcon = 'spinner';
        this.syncIcon = 'spinner';
        this.hasOffline = false;
        this.notesLoaded = false;
        // Refresh data if notes are synchronized automatically.
        this.syncObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_8__providers_notes_sync__["a" /* AddonNotesSyncProvider */].AUTO_SYNCED, function (data) {
            if (data.courseId == _this.courseId) {
                // Show the sync warnings.
                _this.showSyncWarnings(data.warnings);
                // Refresh the data.
                _this.notesLoaded = false;
                _this.refreshIcon = 'spinner';
                _this.syncIcon = 'spinner';
                _this.domUtils.scrollToTop(_this.content);
                _this.fetchNotes(false);
            }
        }, sitesProvider.getCurrentSiteId());
    }
    /**
     * Component being initialized.
     */
    AddonNotesListComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.fetchNotes(true).then(function () {
            _this.notesProvider.logView(_this.courseId, _this.userId).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Fetch notes.
     *
     * @param  {boolean} sync         When to resync notes.
     * @param  {boolean} [showErrors] When to display errors or not.
     * @return {Promise<any>}         Promise with the notes.
     */
    AddonNotesListComponent.prototype.fetchNotes = function (sync, showErrors) {
        var _this = this;
        var promise = sync ? this.syncNotes(showErrors) : Promise.resolve();
        return promise.catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.notesProvider.getNotes(_this.courseId, _this.userId).then(function (notes) {
                notes = notes[_this.type + 'notes'] || [];
                _this.hasOffline = notes.some(function (note) { return note.offline; });
                if (_this.userId) {
                    _this.notes = notes;
                    // Get the user profile to retrieve the user image.
                    return _this.userProvider.getProfile(_this.userId, _this.courseId, true).then(function (user) {
                        _this.user = user;
                    });
                }
                else {
                    return _this.notesProvider.getNotesUserData(notes, _this.courseId).then(function (notes) {
                        _this.notes = notes;
                    });
                }
            });
        }).catch(function (message) {
            _this.domUtils.showErrorModal(message);
        }).finally(function () {
            _this.notesLoaded = true;
            _this.refreshIcon = 'refresh';
            _this.syncIcon = 'sync';
        });
    };
    /**
     * Refresh notes on PTR.
     *
     * @param {boolean} showErrors Whether to display errors or not.
     * @param {any}     refresher  Refresher instance.
     */
    AddonNotesListComponent.prototype.refreshNotes = function (showErrors, refresher) {
        var _this = this;
        this.refreshIcon = 'spinner';
        this.syncIcon = 'spinner';
        this.notesProvider.invalidateNotes(this.courseId, this.userId).finally(function () {
            _this.fetchNotes(true, showErrors).finally(function () {
                if (refresher) {
                    refresher.complete();
                }
            });
        });
    };
    /**
     * Function called when the type has changed.
     */
    AddonNotesListComponent.prototype.typeChanged = function () {
        var _this = this;
        this.notesLoaded = false;
        this.refreshIcon = 'spinner';
        this.syncIcon = 'spinner';
        this.fetchNotes(true).then(function () {
            _this.notesProvider.logView(_this.courseId, _this.userId).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Add a new Note to user and course.
     * @param {Event} e Event.
     */
    AddonNotesListComponent.prototype.addNote = function (e) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        var modal = this.modalCtrl.create('AddonNotesAddPage', { userId: this.userId, courseId: this.courseId, type: this.type });
        modal.onDidDismiss(function (data) {
            if (data && data.sent && data.type) {
                if (data.type != _this.type) {
                    _this.type = data.type;
                    _this.notesLoaded = false;
                }
                _this.refreshNotes(true);
            }
            else if (data && data.type && data.type != _this.type) {
                _this.type = data.type;
                _this.typeChanged();
            }
        });
        modal.present();
    };
    /**
     * Tries to synchronize course notes.
     *
     * @param  {boolean} showErrors Whether to display errors or not.
     * @return {Promise<any>}       Promise resolved if sync is successful, rejected otherwise.
     */
    AddonNotesListComponent.prototype.syncNotes = function (showErrors) {
        var _this = this;
        return this.notesSync.syncNotes(this.courseId).then(function (warnings) {
            _this.showSyncWarnings(warnings);
        }).catch(function (error) {
            if (showErrors) {
                _this.domUtils.showErrorModalDefault(error, 'core.errorsync', true);
            }
            return Promise.reject(null);
        });
    };
    /**
     * Show sync warnings if any.
     *
     * @param {string[]} warnings the warnings
     */
    AddonNotesListComponent.prototype.showSyncWarnings = function (warnings) {
        var message = this.textUtils.buildMessage(warnings);
        if (message) {
            this.domUtils.showErrorModal(message);
        }
    };
    /**
     * Page destroyed.
     */
    AddonNotesListComponent.prototype.ngOnDestroy = function () {
        this.syncObserver && this.syncObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonNotesListComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonNotesListComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */])
    ], AddonNotesListComponent.prototype, "content", void 0);
    AddonNotesListComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-notes-list',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\notes\components\list\addon-notes-list.html"*/'<core-navbar-buttons end>\n    <core-context-menu>\n        <core-context-menu-item [hidden]="!(notesLoaded && !hasOffline)" [priority]="100" [content]="\'core.refresh\' | translate" (action)="refreshNotes(false)" [iconAction]="refreshIcon" [closeOnClick]="true"></core-context-menu-item>\n        <core-context-menu-item [hidden]="!(notesLoaded && hasOffline)" [priority]="100" [content]="\'core.settings.synchronizenow\' | translate" (action)="refreshNotes(true)" [iconAction]="syncIcon" [closeOnClick]="false"></core-context-menu-item>\n    </core-context-menu>\n</core-navbar-buttons>\n\n<ion-content>\n    <ion-refresher [enabled]="notesLoaded" (ionRefresh)="refreshNotes(false, $event)">\n        <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n    </ion-refresher>\n    <core-loading [hideUntil]="notesLoaded" class="core-loading-center">\n        <ion-item text-wrap *ngIf="user">\n            <ion-avatar core-user-avatar [user]="user" [courseId]="courseId" item-start [linkProfile]="false"></ion-avatar>\n            <h2>{{user.fullname}}</h2>\n        </ion-item>\n\n        <div padding>\n            <ion-select [(ngModel)]="type" (ngModelChange)="typeChanged()" interface="popover" class="core-button-select">\n                <ion-option value="site">{{ \'addon.notes.sitenotes\' | translate }}</ion-option>\n                <ion-option value="course">{{ \'addon.notes.coursenotes\' | translate }}</ion-option>\n                <ion-option value="personal">{{ \'addon.notes.personalnotes\' | translate }}</ion-option>\n            </ion-select>\n        </div>\n\n        <div class="core-warning-card" icon-start *ngIf="hasOffline">\n            <ion-icon name="warning"></ion-icon>\n            {{ \'core.thereisdatatosync\' | translate:{$a: \'addon.notes.notes\' | translate | lowercase } }}\n        </div>\n\n        <core-empty-box *ngIf="notes && notes.length == 0" icon="list" [message]="\'addon.notes.nonotes\' | translate"></core-empty-box>\n\n        <ion-list *ngIf="notes && notes.length > 0">\n            <ion-card *ngFor="let note of notes">\n                <ion-item text-wrap>\n                    <ion-avatar core-user-avatar [user]="note" [courseId]="courseId" item-start *ngIf="!userId"></ion-avatar>\n                    <h2 *ngIf="!userId">{{note.userfullname}}</h2>\n                    <p *ngIf="!note.offline" item-end>{{note.lastmodified | coreDateDayOrTime}}</p>\n                    <p *ngIf="note.offline" item-end><ion-icon name="time"></ion-icon> {{ \'core.notsent\' | translate }}</p>\n                </ion-item>\n                <ion-item text-wrap>\n                    <core-format-text [clean]="true" [text]="note.content"></core-format-text>\n                </ion-item>\n            </ion-card>\n        </ion-list>\n\n    </core-loading>\n    <ion-fab core-fab bottom end *ngIf="userId && notesLoaded">\n        <button ion-fab (click)="addNote($event)" [attr.aria-label]="\'addon.notes.addnewnote\' |translate">\n            <ion-icon name="add"></ion-icon>\n        </button>\n    </ion-fab>\n</ion-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\notes\components\list\addon-notes-list.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_7__providers_notes__["a" /* AddonNotesProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_notes_sync__["a" /* AddonNotesSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__["a" /* CoreUserProvider */]])
    ], AddonNotesListComponent);
    return AddonNotesListComponent;
}());

//# sourceMappingURL=list.js.map

/***/ }),
/* 879 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_NOTIFICATIONS_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonNotificationsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_notifications__ = __webpack_require__(170);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(448);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__ = __webpack_require__(1701);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_settings_handler__ = __webpack_require__(1702);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_cron_handler__ = __webpack_require__(1703);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_push_click_handler__ = __webpack_require__(1704);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_settings_providers_delegate__ = __webpack_require__(223);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














// List of providers (without handlers).
var ADDON_NOTIFICATIONS_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_notifications__["a" /* AddonNotificationsProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonNotificationsHelperProvider */]
];
var AddonNotificationsModule = /** @class */ (function () {
    function AddonNotificationsModule(mainMenuDelegate, mainMenuHandler, settingsDelegate, settingsHandler, cronDelegate, cronHandler, zone, appProvider, localNotifications, initDelegate, pushNotificationsDelegate, pushClickHandler) {
        mainMenuDelegate.registerHandler(mainMenuHandler);
        settingsDelegate.registerHandler(settingsHandler);
        cronDelegate.register(cronHandler);
        pushNotificationsDelegate.registerClickHandler(pushClickHandler);
        if (appProvider.isDesktop()) {
            // Listen for clicks in simulated push notifications.
            localNotifications.registerClick(__WEBPACK_IMPORTED_MODULE_1__providers_notifications__["a" /* AddonNotificationsProvider */].PUSH_SIMULATION_COMPONENT, function (notification) {
                initDelegate.ready().then(function () {
                    pushNotificationsDelegate.clicked(notification);
                });
            });
        }
    }
    AddonNotificationsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_notifications__["a" /* AddonNotificationsProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonNotificationsHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* AddonNotificationsMainMenuHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_settings_handler__["a" /* AddonNotificationsSettingsHandler */],
                __WEBPACK_IMPORTED_MODULE_5__providers_cron_handler__["a" /* AddonNotificationsCronHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_push_click_handler__["a" /* AddonNotificationsPushClickHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_9__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_mainmenu_handler__["a" /* AddonNotificationsMainMenuHandler */],
            __WEBPACK_IMPORTED_MODULE_10__core_settings_providers_delegate__["a" /* CoreSettingsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_settings_handler__["a" /* AddonNotificationsSettingsHandler */],
            __WEBPACK_IMPORTED_MODULE_11__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_cron_handler__["a" /* AddonNotificationsCronHandler */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"],
            __WEBPACK_IMPORTED_MODULE_7__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_12__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_13__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */],
            __WEBPACK_IMPORTED_MODULE_6__providers_push_click_handler__["a" /* AddonNotificationsPushClickHandler */]])
    ], AddonNotificationsModule);
    return AddonNotificationsModule;
}());

//# sourceMappingURL=notifications.module.js.map

/***/ }),
/* 880 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ADDON_REMOTETHEMES_PROVIDERS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return AddonRemoteThemesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_remotethemes__ = __webpack_require__(1705);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






// List of providers (without handlers).
var ADDON_REMOTETHEMES_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_remotethemes__["a" /* AddonRemoteThemesProvider */]
];
var AddonRemoteThemesModule = /** @class */ (function () {
    function AddonRemoteThemesModule(initDelegate, remoteThemesProvider, eventsProvider, sitesProvider, loggerProvider) {
        var logger = loggerProvider.getInstance('AddonRemoteThemesModule');
        // Preload the current site styles.
        initDelegate.registerProcess({
            name: 'AddonRemoteThemesPreloadCurrent',
            priority: __WEBPACK_IMPORTED_MODULE_3__providers_init__["a" /* CoreInitDelegate */].MAX_RECOMMENDED_PRIORITY + 250,
            blocking: true,
            load: remoteThemesProvider.preloadCurrentSite.bind(remoteThemesProvider)
        });
        // Preload the styles of the rest of sites.
        initDelegate.registerProcess({
            name: 'AddonRemoteThemesPreload',
            blocking: true,
            load: remoteThemesProvider.preloadSites.bind(remoteThemesProvider)
        });
        var addingSite;
        // When a new site is added to the app, add its styles.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].SITE_ADDED, function (data) {
            addingSite = data.siteId;
            remoteThemesProvider.addSite(data.siteId).catch(function (error) {
                logger.error('Error adding site', error);
            }).then(function () {
                if (addingSite == data.siteId) {
                    addingSite = false;
                }
                // User has logged in, remove tmp styles and enable loaded styles.
                if (data.siteId == sitesProvider.getCurrentSiteId()) {
                    remoteThemesProvider.unloadTmpStyles();
                    remoteThemesProvider.enable(data.siteId);
                }
            });
        });
        // Update styles when current site is updated.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function (data) {
            if (data.siteId === sitesProvider.getCurrentSiteId()) {
                remoteThemesProvider.load(data.siteId).catch(function (error) {
                    logger.error('Error loading site after site update', error);
                });
            }
        });
        // Enable styles of current site on login.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGIN, function (data) {
            remoteThemesProvider.unloadTmpStyles();
            remoteThemesProvider.enable(data.siteId);
        });
        // Disable added styles on logout.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function (data) {
            remoteThemesProvider.clear();
        });
        // Remove site styles when a site is deleted.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].SITE_DELETED, function (site) {
            remoteThemesProvider.removeSite(site.id);
        });
        // Load temporary styles when site config is checked in login.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGIN_SITE_CHECKED, function (data) {
            remoteThemesProvider.loadTmpStyles(data.config.mobilecssurl).catch(function (error) {
                logger.error('Error loading tmp styles', error);
            });
        });
        // Unload temporary styles when site config is "unchecked" in login.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGIN_SITE_UNCHECKED, function (data) {
            if (data.siteId && data.siteId === addingSite) {
                // The tmp styles are from a site that is being added permanently.
                // Wait for the final site styles to be loaded before removing the tmp styles so there is no blink effect.
            }
            else {
                // The tmp styles are from a site that wasn't added in the end. Just remove them.
                remoteThemesProvider.unloadTmpStyles();
            }
        });
    }
    AddonRemoteThemesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_remotethemes__["a" /* AddonRemoteThemesProvider */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_remotethemes__["a" /* AddonRemoteThemesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_logger__["a" /* CoreLoggerProvider */]])
    ], AddonRemoteThemesModule);
    return AddonRemoteThemesModule;
}());

//# sourceMappingURL=remotethemes.module.js.map

/***/ }),
/* 881 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataDefaultFieldHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Default handler used when a field plugin doesn't have a specific implementation.
 */
var AddonModDataDefaultFieldHandler = /** @class */ (function () {
    function AddonModDataDefaultFieldHandler() {
        this.name = 'AddonModDataDefaultFieldHandler';
        this.type = 'default';
    }
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataDefaultFieldHandler.prototype.getFieldSearchData = function (field, inputData) {
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataDefaultFieldHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        return false;
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataDefaultFieldHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        return false;
    };
    /**
     * Get field edit files in the input data.
     *
     * @param  {any} field Defines the field..
     * @return {any}       With name and value of the data to be sent.
     */
    AddonModDataDefaultFieldHandler.prototype.getFieldEditFiles = function (field, inputData, originalFieldData) {
        return [];
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataDefaultFieldHandler.prototype.getFieldsNotifications = function (field, inputData) {
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataDefaultFieldHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataDefaultFieldHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataDefaultFieldHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AddonModDataDefaultFieldHandler);
    return AddonModDataDefaultFieldHandler;
}());

//# sourceMappingURL=default-field-handler.js.map

/***/ }),
/* 882 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_comments_providers_comments__ = __webpack_require__(134);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__sync__ = __webpack_require__(230);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__helper__ = __webpack_require__(153);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















/**
 * Handler to prefetch databases.
 */
var AddonModDataPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModDataPrefetchHandler, _super);
    function AddonModDataPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, dataProvider, timeUtils, dataHelper, groupsProvider, commentsProvider, syncProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.dataProvider = dataProvider;
        _this.timeUtils = timeUtils;
        _this.dataHelper = dataHelper;
        _this.groupsProvider = groupsProvider;
        _this.commentsProvider = commentsProvider;
        _this.syncProvider = syncProvider;
        _this.name = 'AddonModData';
        _this.modName = 'data';
        _this.component = __WEBPACK_IMPORTED_MODULE_12__data__["a" /* AddonModDataProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^entries$|^gradeitems$|^outcomes$|^comments$|^ratings/;
        return _this;
    }
    /**
     * Retrieves all the entries for all the groups and then returns only unique entries.
     *
     * @param  {number}  dataId         Database Id.
     * @param  {any[]}   groups         Array of groups in the activity.
     * @param  {boolean} [forceCache]   True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean} [ignoreCache]  True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]       Site ID.
     * @return {Promise<AddonModDataEntry[]>} All unique entries.
     */
    AddonModDataPrefetchHandler.prototype.getAllUniqueEntries = function (dataId, groups, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        var promises = groups.map(function (group) {
            return _this.dataProvider.fetchAllEntries(dataId, group.id, undefined, undefined, undefined, forceCache, ignoreCache, siteId);
        });
        return Promise.all(promises).then(function (responses) {
            var uniqueEntries = {};
            responses.forEach(function (groupEntries) {
                groupEntries.forEach(function (entry) {
                    uniqueEntries[entry.id] = entry;
                });
            });
            return _this.utils.objectToArray(uniqueEntries);
        });
    };
    /**
     * Helper function to get all database info just once.
     *
     * @param  {any}     module         Module to get the files.
     * @param  {number}  courseId       Course ID the module belongs to.
     * @param  {boolean} [omitFail]     True to always return even if fails. Default false.
     * @param  {boolean} [forceCache]   True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean} [ignoreCache]  True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  siteId         Site ID.
     * @return {Promise<any>}           Promise resolved with the info fetched.
     */
    AddonModDataPrefetchHandler.prototype.getDatabaseInfoHelper = function (module, courseId, omitFail, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (omitFail === void 0) { omitFail = false; }
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        var database, groups = [], entries = [], files = [];
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.dataProvider.getDatabase(courseId, module.id, siteId, forceCache).then(function (data) {
            files = _this.getIntroFilesFromInstance(module, data);
            database = data;
            return _this.groupsProvider.getActivityGroupInfo(module.id, false, undefined, siteId).then(function (groupInfo) {
                if (!groupInfo.groups || groupInfo.groups.length == 0) {
                    groupInfo.groups = [{ id: 0 }];
                }
                groups = groupInfo.groups;
                return _this.getAllUniqueEntries(database.id, groups, forceCache, ignoreCache, siteId);
            });
        }).then(function (uniqueEntries) {
            entries = uniqueEntries;
            files = files.concat(_this.getEntriesFiles(entries));
            return {
                database: database,
                groups: groups,
                entries: entries,
                files: files
            };
        }).catch(function (message) {
            if (omitFail) {
                // Any error, return the info we have.
                return {
                    database: database,
                    groups: groups,
                    entries: entries,
                    files: files
                };
            }
            return Promise.reject(message);
        });
    };
    /**
     * Returns the file contained in the entries.
     *
     * @param {AddonModDataEntry[]} entries List of entries to get files from.
     * @return {any[]} List of files.
     */
    AddonModDataPrefetchHandler.prototype.getEntriesFiles = function (entries) {
        var _this = this;
        var files = [];
        entries.forEach(function (entry) {
            _this.utils.objectToArray(entry.contents).forEach(function (content) {
                files = files.concat(content.files);
            });
        });
        return files;
    };
    /**
     * Get the list of downloadable files.
     *
     * @param  {any} module    Module to get the files.
     * @param  {number} courseId  Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any>}     Promise resolved with the list of files.
     */
    AddonModDataPrefetchHandler.prototype.getFiles = function (module, courseId, single) {
        return this.getDatabaseInfoHelper(module, courseId, true).then(function (info) {
            return info.files;
        });
    };
    /**
     * Returns data intro files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    AddonModDataPrefetchHandler.prototype.getIntroFiles = function (module, courseId) {
        var _this = this;
        return this.dataProvider.getDatabase(courseId, module.id).catch(function () {
            // Not found, return undefined so module description is used.
        }).then(function (data) {
            return _this.getIntroFilesFromInstance(module, data);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModDataPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.dataProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModDataPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var promises = [];
        promises.push(this.dataProvider.invalidateDatabaseData(courseId));
        promises.push(this.dataProvider.invalidateDatabaseAccessInformationData(module.instance));
        return Promise.all(promises);
    };
    /**
     * Check if a database is downloadable.
     * A database isn't downloadable if it's not open yet.
     *
     * @param {any} module       Module to check.
     * @param {number} courseId  Course ID the module belongs to.
     * @return {Promise<any>}    Promise resolved with true if downloadable, resolved with false otherwise.
     */
    AddonModDataPrefetchHandler.prototype.isDownloadable = function (module, courseId) {
        var _this = this;
        return this.dataProvider.getDatabase(courseId, module.id, undefined, true).then(function (database) {
            return _this.dataProvider.getDatabaseAccessInformation(database.id).then(function (accessData) {
                // Check if database is restricted by time.
                if (!accessData.timeavailable) {
                    var time = _this.timeUtils.timestamp();
                    // It is restricted, checking times.
                    if (database.timeavailablefrom && time < database.timeavailablefrom) {
                        return false;
                    }
                    if (database.timeavailableto && time > database.timeavailableto) {
                        return false;
                    }
                }
                return true;
            });
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModDataPrefetchHandler.prototype.isEnabled = function () {
        return this.dataProvider.isPluginEnabled();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModDataPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchDatabase.bind(this));
    };
    /**
     * Prefetch a database.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModDataPrefetchHandler.prototype.prefetchDatabase = function (module, courseId, single, siteId) {
        var _this = this;
        return this.getDatabaseInfoHelper(module, courseId, false, false, true, siteId).then(function (info) {
            // Prefetch the database data.
            var database = info.database, promises = [];
            promises.push(_this.dataProvider.getFields(database.id, false, true, siteId));
            promises.push(_this.filepoolProvider.addFilesToQueue(siteId, info.files, _this.component, module.id));
            info.groups.forEach(function (group) {
                promises.push(_this.dataProvider.getDatabaseAccessInformation(database.id, group.id, false, true, siteId));
            });
            info.entries.forEach(function (entry) {
                promises.push(_this.dataProvider.getEntry(database.id, entry.id, true, siteId));
                if (database.comments) {
                    promises.push(_this.commentsProvider.getComments('module', database.coursemodule, 'mod_data', entry.id, 'database_entry', 0, siteId));
                }
            });
            // Add Basic Info to manage links.
            promises.push(_this.courseProvider.getModuleBasicInfoByInstance(database.id, 'data', siteId));
            return Promise.all(promises);
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModDataPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        var promises = [
            this.syncProvider.syncDatabase(module.instance, siteId),
            this.syncProvider.syncRatings(module.id, true, siteId)
        ];
        return Promise.all(promises).then(function (results) {
            return results.reduce(function (a, b) { return ({
                updated: a.updated || b.updated,
                warnings: (a.warnings || []).concat(b.warnings || []),
            }); }, { updated: false });
        });
    };
    AddonModDataPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_12__data__["a" /* AddonModDataProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_14__helper__["a" /* AddonModDataHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_groups__["a" /* CoreGroupsProvider */], __WEBPACK_IMPORTED_MODULE_9__core_comments_providers_comments__["a" /* CoreCommentsProvider */],
            __WEBPACK_IMPORTED_MODULE_13__sync__["a" /* AddonModDataSyncProvider */]])
    ], AddonModDataPrefetchHandler);
    return AddonModDataPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_11__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 883 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsWorkshopAssessmentStrategyComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__addon_mod_workshop_providers_assessment_strategy_delegate__ = __webpack_require__(129);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays a workshop assessment strategy plugin created using a site plugin.
 */
var CoreSitePluginsWorkshopAssessmentStrategyComponent = /** @class */ (function (_super) {
    __extends(CoreSitePluginsWorkshopAssessmentStrategyComponent, _super);
    function CoreSitePluginsWorkshopAssessmentStrategyComponent(sitePluginsProvider, utils, workshopAssessmentStrategyDelegate) {
        var _this = _super.call(this, sitePluginsProvider, utils) || this;
        _this.workshopAssessmentStrategyDelegate = workshopAssessmentStrategyDelegate;
        return _this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsWorkshopAssessmentStrategyComponent.prototype.ngOnInit = function () {
        // Pass the input and output data to the component.
        this.jsData.workshopId = this.workshopId;
        this.jsData.assessment = this.assessment;
        this.jsData.edit = this.edit;
        this.jsData.selectedValues = this.selectedValues;
        this.jsData.fieldErrors = this.fieldErrors;
        this.jsData.strategy = this.strategy;
        this.getHandlerData(this.workshopAssessmentStrategyDelegate.getHandlerName(this.strategy));
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreSitePluginsWorkshopAssessmentStrategyComponent.prototype, "workshopId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsWorkshopAssessmentStrategyComponent.prototype, "assessment", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreSitePluginsWorkshopAssessmentStrategyComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreSitePluginsWorkshopAssessmentStrategyComponent.prototype, "selectedValues", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsWorkshopAssessmentStrategyComponent.prototype, "fieldErrors", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsWorkshopAssessmentStrategyComponent.prototype, "strategy", void 0);
    CoreSitePluginsWorkshopAssessmentStrategyComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-siteplugins-workshop-assessment-strategy',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\workshop-assessment-strategy\core-siteplugins-workshop-assessment-strategy.html"*/'<core-compile-html [text]="content" [jsData]="jsData" (created)="componentCreated($event)"></core-compile-html>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\siteplugins\components\workshop-assessment-strategy\core-siteplugins-workshop-assessment-strategy.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__addon_mod_workshop_providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */]])
    ], CoreSitePluginsWorkshopAssessmentStrategyComponent);
    return CoreSitePluginsWorkshopAssessmentStrategyComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_compile_init_component__["a" /* CoreSitePluginsCompileInitComponent */]));

//# sourceMappingURL=workshop-assessment-strategy.js.map

/***/ }),
/* 884 */,
/* 885 */,
/* 886 */,
/* 887 */,
/* 888 */,
/* 889 */,
/* 890 */,
/* 891 */,
/* 892 */,
/* 893 */,
/* 894 */,
/* 895 */,
/* 896 */,
/* 897 */,
/* 898 */,
/* 899 */,
/* 900 */,
/* 901 */,
/* 902 */,
/* 903 */,
/* 904 */,
/* 905 */,
/* 906 */,
/* 907 */,
/* 908 */,
/* 909 */,
/* 910 */,
/* 911 */,
/* 912 */,
/* 913 */,
/* 914 */,
/* 915 */,
/* 916 */,
/* 917 */,
/* 918 */,
/* 919 */,
/* 920 */,
/* 921 */,
/* 922 */,
/* 923 */,
/* 924 */,
/* 925 */,
/* 926 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCustomURLSchemesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__init__ = __webpack_require__(87);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_siteplugins_providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/*
 * Provider to handle custom URL schemes.
 */
var CoreCustomURLSchemesProvider = /** @class */ (function () {
    function CoreCustomURLSchemesProvider(logger, appProvider, utils, loginHelper, linksHelper, initDelegate, domUtils, urlUtils, sitesProvider, textUtils, linksDelegate, translate, sitePluginsProvider) {
        this.appProvider = appProvider;
        this.utils = utils;
        this.loginHelper = loginHelper;
        this.linksHelper = linksHelper;
        this.initDelegate = initDelegate;
        this.domUtils = domUtils;
        this.urlUtils = urlUtils;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.linksDelegate = linksDelegate;
        this.translate = translate;
        this.sitePluginsProvider = sitePluginsProvider;
        this.lastUrls = {};
        this.logger = logger.getInstance('CoreCustomURLSchemesProvider');
    }
    /**
     * Handle an URL received by custom URL scheme.
     *
     * @param {string} url URL to treat.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCustomURLSchemesProvider.prototype.handleCustomURL = function (url) {
        var _this = this;
        if (!this.isCustomURL(url)) {
            return Promise.reject(null);
        }
        var modal, isSSOToken = false, data;
        /* First check that this URL hasn't been treated a few seconds ago. The function that handles custom URL schemes already
           does this, but this function is called from other places so we need to handle it in here too. */
        if (this.lastUrls[url] && Date.now() - this.lastUrls[url] < 3000) {
            // Function called more than once, stop.
            return;
        }
        this.lastUrls[url] = Date.now();
        // Wait for app to be ready.
        return this.initDelegate.ready().then(function () {
            url = _this.textUtils.decodeURIComponent(url);
            // Some platforms like Windows add a slash at the end. Remove it.
            // Some sites add a # at the end of the URL. If it's there, remove it.
            url = url.replace(/\/?#?\/?$/, '');
            modal = _this.domUtils.showModalLoading();
            // Get the data from the URL.
            if (_this.isCustomURLToken(url)) {
                isSSOToken = true;
                return _this.getCustomURLTokenData(url);
            }
            else if (_this.isCustomURLLink(url)) {
                // In iOS, the protocol after the scheme doesn't have ":". Add it.
                url = url.replace(/\/\/link=(https?)\/\//, '//link=$1://');
                return _this.getCustomURLLinkData(url);
            }
            else {
                // In iOS, the protocol after the scheme doesn't have ":". Add it.
                url = url.replace(/\/\/(https?)\/\//, '//$1://');
                return _this.getCustomURLData(url);
            }
        }).then(function (result) {
            data = result;
            if (data.redirect && data.redirect.match(/^https?:\/\//) && data.redirect.indexOf(data.siteUrl) == -1) {
                // Redirect URL must belong to the same site. Reject.
                return Promise.reject(_this.translate.instant('core.contentlinks.errorredirectothersite'));
            }
            // First of all, authenticate the user if needed.
            var currentSite = _this.sitesProvider.getCurrentSite();
            if (data.token) {
                if (!currentSite || currentSite.getToken() != data.token) {
                    // Token belongs to a different site, create it. It doesn't matter if it already exists.
                    var promise = void 0;
                    if (!data.siteUrl.match(/^https?:\/\//)) {
                        // URL doesn't have a protocol and it's required to be able to create the site. Check which one to use.
                        promise = _this.sitesProvider.checkSite(data.siteUrl).then(function (result) {
                            data.siteUrl = result.siteUrl;
                        });
                    }
                    else {
                        promise = Promise.resolve();
                    }
                    return promise.then(function () {
                        return _this.sitesProvider.newSite(data.siteUrl, data.token, data.privateToken, isSSOToken);
                    });
                }
                else {
                    // Token belongs to current site, no need to create it.
                    return _this.sitesProvider.getCurrentSiteId();
                }
            }
        }).then(function (siteId) {
            if (isSSOToken) {
                // Site created and authenticated, open the page to go.
                if (data.pageName) {
                    // State defined, go to that state instead of site initial page.
                    _this.appProvider.getRootNavController().push(data.pageName, data.pageParams);
                }
                else {
                    _this.loginHelper.goToSiteInitialPage();
                }
                return;
            }
            if (data.redirect && !data.redirect.match(/^https?:\/\//)) {
                // Redirect is a relative URL. Append the site URL.
                data.redirect = _this.textUtils.concatenatePaths(data.siteUrl, data.redirect);
            }
            var promise;
            if (siteId) {
                // Site created, we know the site to use.
                promise = Promise.resolve([siteId]);
            }
            else {
                // Check if the site is stored.
                promise = _this.sitesProvider.getSiteIdsFromUrl(data.siteUrl, true, data.username);
            }
            return promise.then(function (siteIds) {
                if (siteIds.length > 1) {
                    // More than one site to treat the URL, let the user choose.
                    _this.linksHelper.goToChooseSite(data.redirect || data.siteUrl);
                }
                else if (siteIds.length == 1) {
                    // Only one site, handle the link.
                    return _this.sitesProvider.getSite(siteIds[0]).then(function (site) {
                        if (!data.redirect) {
                            // No redirect, go to the root URL if needed.
                            return _this.linksHelper.handleRootURL(site, false, true);
                        }
                        else {
                            // Handle the redirect link.
                            modal.dismiss(); // Dismiss modal so it doesn't collide with confirms.
                            /* Always use the username from the site in this case. If the link has a username and a token,
                               this will make sure that the link is opened with the user the token belongs to. */
                            var username = site.getInfo().username || data.username;
                            return _this.linksHelper.handleLink(data.redirect, username).then(function (treated) {
                                if (!treated) {
                                    _this.domUtils.showErrorModal('core.contentlinks.errornoactions', true);
                                }
                            });
                        }
                    });
                }
                else {
                    // Site not stored. Try to add the site.
                    return _this.sitesProvider.checkSite(data.siteUrl).then(function (result) {
                        // Site exists. We'll allow to add it.
                        var ssoNeeded = _this.loginHelper.isSSOLoginNeeded(result.code), pageName = 'CoreLoginCredentialsPage', pageParams = {
                            siteUrl: result.siteUrl,
                            username: data.username,
                            urlToOpen: data.redirect,
                            siteConfig: result.config
                        };
                        var promise, hasSitePluginsLoaded = false;
                        modal.dismiss(); // Dismiss modal so it doesn't collide with confirms.
                        if (!_this.sitesProvider.isLoggedIn()) {
                            // Not logged in, no need to confirm. If SSO the confirm will be shown later.
                            promise = Promise.resolve();
                        }
                        else {
                            // Ask the user before changing site.
                            var confirmMsg = _this.translate.instant('core.contentlinks.confirmurlothersite');
                            promise = _this.domUtils.showConfirm(confirmMsg).then(function () {
                                if (!ssoNeeded) {
                                    hasSitePluginsLoaded = _this.sitePluginsProvider.hasSitePluginsLoaded;
                                    if (hasSitePluginsLoaded) {
                                        // Store the redirect since logout will restart the app.
                                        _this.appProvider.storeRedirect(__WEBPACK_IMPORTED_MODULE_15__core_constants__["a" /* CoreConstants */].NO_SITE_ID, pageName, pageParams);
                                    }
                                    return _this.sitesProvider.logout().catch(function () {
                                        // Ignore errors (shouldn't happen).
                                    });
                                }
                            });
                        }
                        return promise.then(function () {
                            if (ssoNeeded) {
                                _this.loginHelper.confirmAndOpenBrowserForSSOLogin(result.siteUrl, result.code, result.service, result.config && result.config.launchurl);
                            }
                            else if (!hasSitePluginsLoaded) {
                                return _this.loginHelper.goToNoSitePage(undefined, pageName, pageParams);
                            }
                        });
                    });
                }
            });
        }).catch(function (error) {
            if (error == 'Duplicated') {
                // Duplicated request
            }
            else if (error && isSSOToken) {
                // An error occurred, display the error and logout the user.
                _this.loginHelper.treatUserTokenError(data.siteUrl, error);
                _this.sitesProvider.logout();
            }
            else {
                _this.domUtils.showErrorModalDefault(error, _this.translate.instant('core.login.invalidsite'));
            }
        }).finally(function () {
            modal.dismiss();
            if (isSSOToken) {
                _this.appProvider.finishSSOAuthentication();
            }
        });
    };
    /**
     * Get the data from a custom URL scheme. The structure of the URL is:
     * moodlemobile://username@domain.com?token=TOKEN&privatetoken=PRIVATETOKEN&redirect=http://domain.com/course/view.php?id=2
     *
     * @param {string} url URL to treat.
     * @return {Promise<CoreCustomURLSchemesParams>} Promise resolved with the data.
     */
    CoreCustomURLSchemesProvider.prototype.getCustomURLData = function (url) {
        var _this = this;
        var urlScheme = __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://';
        if (url.indexOf(urlScheme) == -1) {
            return Promise.reject(null);
        }
        // App opened using custom URL scheme.
        this.logger.debug('Treating custom URL scheme: ' + url);
        // Delete the sso scheme from the URL.
        url = url.replace(urlScheme, '');
        // Detect if there's a user specified.
        var username = this.urlUtils.getUsernameFromUrl(url);
        if (username) {
            url = url.replace(username + '@', ''); // Remove the username from the URL.
        }
        // Get the params of the URL.
        var params = this.urlUtils.extractUrlParams(url);
        // Remove the params to get the site URL.
        if (url.indexOf('?') != -1) {
            url = url.substr(0, url.indexOf('?'));
        }
        var promise;
        if (!url.match(/https?:\/\//)) {
            // Url doesn't have a protocol. Check if the site is stored in the app to be able to determine the protocol.
            promise = this.sitesProvider.getSiteIdsFromUrl(url, true, username).then(function (siteIds) {
                if (siteIds.length) {
                    // There is at least 1 site with this URL. Use it to know the full URL.
                    return _this.sitesProvider.getSite(siteIds[0]).then(function (site) {
                        return site.getURL();
                    });
                }
                else {
                    // No site stored with this URL, just use the URL as it is.
                    return url;
                }
            });
        }
        else {
            promise = Promise.resolve(url);
        }
        return promise.then(function (url) {
            return {
                siteUrl: url,
                username: username,
                token: params.token,
                privateToken: params.privateToken,
                redirect: params.redirect
            };
        });
    };
    /**
     * Get the data from a "link" custom URL scheme. This kind of URL is deprecated.
     *
     * @param {string} url URL to treat.
     * @return {Promise<CoreCustomURLSchemesParams>} Promise resolved with the data.
     */
    CoreCustomURLSchemesProvider.prototype.getCustomURLLinkData = function (url) {
        var _this = this;
        var contentLinksScheme = __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://link=';
        if (url.indexOf(contentLinksScheme) == -1) {
            return Promise.reject(null);
        }
        // App opened using custom URL scheme.
        this.logger.debug('Treating custom URL scheme with link param: ' + url);
        // Delete the sso scheme from the URL.
        url = url.replace(contentLinksScheme, '');
        // Detect if there's a user specified.
        var username = this.urlUtils.getUsernameFromUrl(url);
        if (username) {
            url = url.replace(username + '@', ''); // Remove the username from the URL.
        }
        // First of all, check if it's the root URL of a site.
        return this.sitesProvider.isStoredRootURL(url, username).then(function (data) {
            if (data.site) {
                // Root URL.
                return {
                    siteUrl: data.site.getURL(),
                    username: username
                };
            }
            else if (data.siteIds.length > 0) {
                // Not the root URL, but at least 1 site supports the URL. Get the site URL from the list of sites.
                return _this.sitesProvider.getSite(data.siteIds[0]).then(function (site) {
                    return {
                        siteUrl: site.getURL(),
                        username: username,
                        redirect: url
                    };
                });
            }
            else {
                // Get the site URL.
                var siteUrl = _this.linksDelegate.getSiteUrl(url), redirect = url;
                if (!siteUrl) {
                    // Site URL not found, use the original URL since it could be the root URL of the site.
                    siteUrl = url;
                    redirect = undefined;
                }
                return {
                    siteUrl: siteUrl,
                    username: username,
                    redirect: redirect
                };
            }
        });
    };
    /**
     * Get the data from a "token" custom URL scheme. This kind of URL is deprecated.
     *
     * @param {string} url URL to treat.
     * @return {Promise<CoreCustomURLSchemesParams>} Promise resolved with the data.
     */
    CoreCustomURLSchemesProvider.prototype.getCustomURLTokenData = function (url) {
        var ssoScheme = __WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://token=';
        if (url.indexOf(ssoScheme) == -1) {
            return Promise.reject(null);
        }
        if (this.appProvider.isSSOAuthenticationOngoing()) {
            // Authentication ongoing, probably duplicated request.
            return Promise.reject('Duplicated');
        }
        if (this.appProvider.isDesktop()) {
            // In desktop, make sure InAppBrowser is closed.
            this.utils.closeInAppBrowser(true);
        }
        // App opened using custom URL scheme. Probably an SSO authentication.
        this.appProvider.startSSOAuthentication();
        this.logger.debug('App launched by URL with an SSO');
        // Delete the sso scheme from the URL.
        url = url.replace(ssoScheme, '');
        // Some platforms like Windows add a slash at the end. Remove it.
        // Some sites add a # at the end of the URL. If it's there, remove it.
        url = url.replace(/\/?#?\/?$/, '');
        // Decode from base64.
        try {
            url = atob(url);
        }
        catch (err) {
            // Error decoding the parameter.
            this.logger.error('Error decoding parameter received for login SSO');
            return Promise.reject(null);
        }
        return this.loginHelper.validateBrowserSSOLogin(url);
    };
    /**
     * Check whether a URL is a custom URL scheme.
     *
     * @param {string} url URL to check.
     * @return {boolean} Whether it's a custom URL scheme.
     */
    CoreCustomURLSchemesProvider.prototype.isCustomURL = function (url) {
        if (!url) {
            return false;
        }
        return url.indexOf(__WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://') != -1;
    };
    /**
     * Check whether a URL is a custom URL scheme with the "link" param (deprecated).
     *
     * @param {string} url URL to check.
     * @return {boolean} Whether it's a custom URL scheme.
     */
    CoreCustomURLSchemesProvider.prototype.isCustomURLLink = function (url) {
        if (!url) {
            return false;
        }
        return url.indexOf(__WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://link=') != -1;
    };
    /**
     * Check whether a URL is a custom URL scheme with a "token" param (deprecated).
     *
     * @param {string} url URL to check.
     * @return {boolean} Whether it's a custom URL scheme.
     */
    CoreCustomURLSchemesProvider.prototype.isCustomURLToken = function (url) {
        if (!url) {
            return false;
        }
        return url.indexOf(__WEBPACK_IMPORTED_MODULE_14__configconstants__["a" /* CoreConfigConstants */].customurlscheme + '://token=') != -1;
    };
    CoreCustomURLSchemesProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_9__utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_login_providers_helper__["a" /* CoreLoginHelperProvider */], __WEBPACK_IMPORTED_MODULE_11__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_3__init__["a" /* CoreInitDelegate */], __WEBPACK_IMPORTED_MODULE_6__utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_8__utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_7__utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_12__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_13__core_siteplugins_providers_siteplugins__["a" /* CoreSitePluginsProvider */]])
    ], CoreCustomURLSchemesProvider);
    return CoreCustomURLSchemesProvider;
}());

//# sourceMappingURL=urlschemes.js.map

/***/ }),
/* 927 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldCheckboxComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Directive to render a checkbox user profile field.
 */
var AddonUserProfileFieldCheckboxComponent = /** @class */ (function () {
    function AddonUserProfileFieldCheckboxComponent(fb, utils) {
        this.fb = fb;
        this.utils = utils;
        this.edit = false; // True if editing the field. Defaults to false.
        this.disabled = false; // True if disabled. Defaults to false.
    }
    /**
     * Component being initialized.
     */
    AddonUserProfileFieldCheckboxComponent.prototype.ngOnInit = function () {
        var field = this.field;
        if (field && this.edit && this.form) {
            field.modelName = 'profile_field_' + field.shortname;
            // Initialize the value.
            var formData = {
                value: this.utils.isTrueOrOne(field.defaultdata),
                disabled: this.disabled
            };
            this.form.addControl(field.modelName, this.fb.control(formData, field.required && !field.locked ? __WEBPACK_IMPORTED_MODULE_1__angular_forms__["h" /* Validators */].requiredTrue : null));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldCheckboxComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldCheckboxComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldCheckboxComponent.prototype, "disabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonUserProfileFieldCheckboxComponent.prototype, "form", void 0);
    AddonUserProfileFieldCheckboxComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-user-profile-field-checkbox',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\checkbox\component\addon-user-profile-field-checkbox.html"*/'<!-- Render (no edit). -->\n<ion-item *ngIf="!edit && field && field.name">\n    <h2>{{ field.name }}</h2>\n    <p *ngIf="field.value != \'0\'">\n        {{ \'core.yes\' | translate }}\n    </p>\n    <p *ngIf="field.value == \'0\'">\n        {{ \'core.no\' | translate }}\n    </p>\n</ion-item>\n<!-- Edit. -->\n<ion-item *ngIf="edit && field && field.shortname" [formGroup]="form">\n    <ion-label>\n        <span [core-mark-required]="field.required">{{ field.name }}</span>\n        <core-input-errors [control]="form.controls[field.modelName]"></core-input-errors>\n    </ion-label>\n    <ion-checkbox item-end [formControlName]="field.modelName">\n    </ion-checkbox>\n</ion-item>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\checkbox\component\addon-user-profile-field-checkbox.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonUserProfileFieldCheckboxComponent);
    return AddonUserProfileFieldCheckboxComponent;
}());

//# sourceMappingURL=checkbox.js.map

/***/ }),
/* 928 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldDatetimeComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Directive to render a datetime user profile field.
 */
var AddonUserProfileFieldDatetimeComponent = /** @class */ (function () {
    function AddonUserProfileFieldDatetimeComponent(fb, timeUtils, utils, translate) {
        this.fb = fb;
        this.timeUtils = timeUtils;
        this.utils = utils;
        this.translate = translate;
        this.edit = false; // True if editing the field. Defaults to false.
        this.disabled = false; // True if disabled. Defaults to false.
    }
    /**
     * Component being initialized.
     */
    AddonUserProfileFieldDatetimeComponent.prototype.ngOnInit = function () {
        var field = this.field;
        var year;
        if (field && this.edit && this.form) {
            field.modelName = 'profile_field_' + field.shortname;
            // Check if it's only date or it has time too.
            var hasTime = this.utils.isTrueOrOne(field.param3);
            // Calculate format to use. ion-datetime doesn't support escaping characters ([]), so we remove them.
            field.format = this.timeUtils.convertPHPToMoment(this.translate.instant('core.' +
                (hasTime ? 'strftimedatetimeshort' : 'strftimedatefullshort'))).replace(/[\[\]]/g, '');
            // Check min value.
            if (field.param1) {
                year = parseInt(field.param1, 10);
                if (year) {
                    field.min = year;
                }
            }
            // Check max value.
            if (field.param2) {
                year = parseInt(field.param2, 10);
                if (year) {
                    field.max = year;
                }
            }
            var formData = {
                value: field.defaultdata,
                disabled: this.disabled
            };
            this.form.addControl(field.modelName, this.fb.control(formData, field.required && !field.locked ? __WEBPACK_IMPORTED_MODULE_1__angular_forms__["h" /* Validators */].required : null));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldDatetimeComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldDatetimeComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldDatetimeComponent.prototype, "disabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonUserProfileFieldDatetimeComponent.prototype, "form", void 0);
    AddonUserProfileFieldDatetimeComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-user-profile-field-datetime',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\datetime\component\addon-user-profile-field-datetime.html"*/'<!-- Render (no edit). -->\n<ion-item *ngIf="!edit && field && field.name">\n    <h2>{{ field.name }}</h2>\n    <p>{{ field.value * 1000 | coreFormatDate }}</p>\n</ion-item>\n<!-- Edit. -->\n<ion-item *ngIf="edit && field && field.shortname" text-wrap [formGroup]="form">\n    <ion-label stacked [core-mark-required]="field.required">{{ field.name }}</ion-label>\n    <ion-datetime [formControlName]="field.modelName" [placeholder]="\'core.choosedots\' | translate" [displayFormat]="field.format" [max]="field.max" [min]="field.min"></ion-datetime>\n    <core-input-errors item-content [control]="form.controls[field.modelName]"></core-input-errors>\n</ion-item>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\datetime\component\addon-user-profile-field-datetime.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonUserProfileFieldDatetimeComponent);
    return AddonUserProfileFieldDatetimeComponent;
}());

//# sourceMappingURL=datetime.js.map

/***/ }),
/* 929 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldMenuComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Directive to render a menu user profile field.
 */
var AddonUserProfileFieldMenuComponent = /** @class */ (function () {
    function AddonUserProfileFieldMenuComponent(fb) {
        this.fb = fb;
        this.edit = false; // True if editing the field. Defaults to false.
        this.disabled = false; // True if disabled. Defaults to false.
    }
    /**
     * Component being initialized.
     */
    AddonUserProfileFieldMenuComponent.prototype.ngOnInit = function () {
        var field = this.field;
        if (field && this.edit && this.form) {
            field.modelName = 'profile_field_' + field.shortname;
            // Parse options.
            if (field.param1) {
                field.options = field.param1.split(/\r\n|\r|\n/g);
            }
            else {
                field.options = [];
            }
            var formData = {
                value: field.defaultdata,
                disabled: this.disabled
            };
            // Initialize the value using default data.
            this.form.addControl(field.modelName, this.fb.control(formData, field.required && !field.locked ? __WEBPACK_IMPORTED_MODULE_1__angular_forms__["h" /* Validators */].required : null));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldMenuComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldMenuComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldMenuComponent.prototype, "disabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonUserProfileFieldMenuComponent.prototype, "form", void 0);
    AddonUserProfileFieldMenuComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-user-profile-field-menu',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\menu\component\addon-user-profile-field-menu.html"*/'<!-- Render (no edit). -->\n<ion-item *ngIf="!edit && field && field.name">\n    <h2>{{ field.name }}</h2>\n    <p><core-format-text [text]="field.value"></core-format-text></p>\n</ion-item>\n<!-- Edit. -->\n<ion-item *ngIf="edit && field && field.shortname" text-wrap [formGroup]="form">\n    <ion-label stacked [core-mark-required]="field.required">{{ field.name }}</ion-label>\n    <ion-select [formControlName]="field.modelName" [placeholder]="\'core.choosedots\' | translate" interface="action-sheet">\n        <ion-option value="">{{ \'core.choosedots\' | translate }}</ion-option>\n        <ion-option *ngFor="let option of field.options" [value]="option">{{option}}</ion-option>\n    </ion-select>\n    <core-input-errors item-content [control]="form.controls[field.modelName]"></core-input-errors>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\menu\component\addon-user-profile-field-menu.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonUserProfileFieldMenuComponent);
    return AddonUserProfileFieldMenuComponent;
}());

//# sourceMappingURL=menu.js.map

/***/ }),
/* 930 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldTextComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Directive to render a text user profile field.
 */
var AddonUserProfileFieldTextComponent = /** @class */ (function () {
    function AddonUserProfileFieldTextComponent(fb, utils) {
        this.fb = fb;
        this.utils = utils;
        this.edit = false; // True if editing the field. Defaults to false.
        this.disabled = false; // True if disabled. Defaults to false.
    }
    /**
     * Component being initialized.
     */
    AddonUserProfileFieldTextComponent.prototype.ngOnInit = function () {
        var field = this.field;
        if (field && this.edit && this.form) {
            field.modelName = 'profile_field_' + field.shortname;
            // Check max length.
            if (field.param2) {
                field.maxlength = parseInt(field.param2, 10) || '';
            }
            // Check if it's a password or text.
            field.inputType = this.utils.isTrueOrOne(field.param3) ? 'password' : 'text';
            var formData = {
                value: field.defaultdata,
                disabled: this.disabled
            };
            // Initialize the value using default data.
            this.form.addControl(field.modelName, this.fb.control(formData, field.required && !field.locked ? __WEBPACK_IMPORTED_MODULE_1__angular_forms__["h" /* Validators */].required : null));
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldTextComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldTextComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldTextComponent.prototype, "disabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonUserProfileFieldTextComponent.prototype, "form", void 0);
    AddonUserProfileFieldTextComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-user-profile-field-text',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\text\component\addon-user-profile-field-text.html"*/'<!-- Render (no edit). -->\n<ion-item *ngIf="!edit && field && field.name">\n    <h2>{{ field.name }}</h2>\n    <p><core-format-text [text]="field.value"></core-format-text></p>\n</ion-item>\n<!-- Edit. -->\n<ion-item *ngIf="edit && field && field.shortname" text-wrap [formGroup]="form">\n    <ion-label stacked [core-mark-required]="field.required">{{ field.name }}</ion-label>\n    <ion-input [type]="field.inputType" [formControlName]="field.modelName" [placeholder]="field.name" maxlength="{{field.maxlength}}"></ion-input>\n    <core-input-errors item-content [control]="form.controls[field.modelName]"></core-input-errors>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\text\component\addon-user-profile-field-text.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonUserProfileFieldTextComponent);
    return AddonUserProfileFieldTextComponent;
}());

//# sourceMappingURL=text.js.map

/***/ }),
/* 931 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldTextareaComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Directive to render a textarea user profile field.
 */
var AddonUserProfileFieldTextareaComponent = /** @class */ (function () {
    function AddonUserProfileFieldTextareaComponent() {
        this.edit = false; // True if editing the field. Defaults to false.
        this.disabled = false; // True if disabled. Defaults to false.
        // Nothing to do.
    }
    /**
     * Component being initialized.
     */
    AddonUserProfileFieldTextareaComponent.prototype.ngOnInit = function () {
        var field = this.field;
        if (field && this.edit && this.form) {
            field.modelName = 'profile_field_' + field.shortname;
            var formData = {
                value: field.defaultdata,
                disabled: this.disabled
            };
            this.control = new __WEBPACK_IMPORTED_MODULE_1__angular_forms__["b" /* FormControl */](formData, field.required && !field.locked ? __WEBPACK_IMPORTED_MODULE_1__angular_forms__["h" /* Validators */].required : null);
            this.form.addControl(field.modelName, this.control);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldTextareaComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldTextareaComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonUserProfileFieldTextareaComponent.prototype, "disabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonUserProfileFieldTextareaComponent.prototype, "form", void 0);
    AddonUserProfileFieldTextareaComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-user-profile-field-textarea',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\textarea\component\addon-user-profile-field-textarea.html"*/'<!-- Render (no edit). -->\n<ion-item *ngIf="!edit && field && field.name">\n    <h2>{{ field.name }}</h2>\n    <p><core-format-text [text]="field.value"></core-format-text></p>\n</ion-item>\n<!-- Edit. -->\n<ion-item *ngIf="edit && field && field.shortname" text-wrap [formGroup]="form">\n    <ion-label stacked>\n        <span [core-mark-required]="field.required">{{ field.name }}</span>\n        <core-input-errors [control]="control"></core-input-errors>\n    </ion-label>\n    <core-rich-text-editor item-content [control]="control" [placeholder]="field.name"></core-rich-text-editor>\n</ion-item>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\userprofilefield\textarea\component\addon-user-profile-field-textarea.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], AddonUserProfileFieldTextareaComponent);
    return AddonUserProfileFieldTextareaComponent;
}());

//# sourceMappingURL=textarea.js.map

/***/ }),
/* 932 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockActivityModulesComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_block_classes_base_block_component__ = __webpack_require__(150);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component to render an "activity modules" block.
 */
var AddonBlockActivityModulesComponent = /** @class */ (function (_super) {
    __extends(AddonBlockActivityModulesComponent, _super);
    function AddonBlockActivityModulesComponent(injector, utils, courseProvider, translate, moduleDelegate) {
        var _this = _super.call(this, injector, 'AddonBlockActivityModulesComponent') || this;
        _this.utils = utils;
        _this.courseProvider = courseProvider;
        _this.translate = translate;
        _this.moduleDelegate = moduleDelegate;
        _this.entries = [];
        _this.fetchContentDefaultError = 'Error getting activity modules data.';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonBlockActivityModulesComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlockActivityModulesComponent.prototype.invalidateContent = function () {
        return this.courseProvider.invalidateSections(this.instanceId);
    };
    /**
     * Fetch the data to render the block.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockActivityModulesComponent.prototype.fetchContent = function () {
        var _this = this;
        return this.courseProvider.getSections(this.instanceId, false, true).then(function (sections) {
            _this.entries = [];
            var archetypes = {}, modIcons = {};
            var modFullNames = {};
            sections.forEach(function (section) {
                if (!section.modules) {
                    return;
                }
                section.modules.forEach(function (mod) {
                    if (mod.uservisible === false || !_this.courseProvider.moduleHasView(mod) ||
                        typeof modFullNames[mod.modname] != 'undefined') {
                        // Ignore this module.
                        return;
                    }
                    // Get the archetype of the module type.
                    if (typeof archetypes[mod.modname] == 'undefined') {
                        archetypes[mod.modname] = _this.moduleDelegate.supportsFeature(mod.modname, __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE, __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_OTHER);
                    }
                    // Get the full name of the module type.
                    if (archetypes[mod.modname] == __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE) {
                        // All resources are gathered in a single "Resources" option.
                        if (!modFullNames['resources']) {
                            modFullNames['resources'] = _this.translate.instant('core.resources');
                        }
                    }
                    else {
                        modFullNames[mod.modname] = mod.modplural;
                    }
                    modIcons[mod.modname] = mod.modicon;
                });
            });
            // Sort the modnames alphabetically.
            modFullNames = _this.utils.sortValues(modFullNames);
            for (var modName in modFullNames) {
                var icon = void 0;
                if (modName === 'resources') {
                    icon = _this.courseProvider.getModuleIconSrc('page', modIcons['page']);
                }
                else {
                    icon = _this.moduleDelegate.getModuleIconSrc(modName, modIcons[modName]);
                }
                _this.entries.push({
                    icon: icon,
                    name: modFullNames[modName],
                    modName: modName
                });
            }
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonBlockActivityModulesComponent.prototype, "block", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonBlockActivityModulesComponent.prototype, "contextLevel", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlockActivityModulesComponent.prototype, "instanceId", void 0);
    AddonBlockActivityModulesComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-activitymodules',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\activitymodules\components\activitymodules\addon-block-activitymodules.html"*/'<ion-item-divider>\n    <h2>{{ \'addon.block_activitymodules.pluginname\' | translate }}</h2>\n</ion-item-divider>\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <a ion-item text-wrap *ngFor="let entry of entries" class="item-media" detail-none [navPush]="\'CoreCourseListModTypePage\'" [navParams]="{title: entry.name, courseId: instanceId, modName: entry.modName}">\n        <img item-start [src]="entry.icon" alt="" role="presentation" class="core-module-icon">\n        <core-format-text [text]="entry.name"></core-format-text>\n    </a>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\activitymodules\components\activitymodules\addon-block-activitymodules.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_6__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */]])
    ], AddonBlockActivityModulesComponent);
    return AddonBlockActivityModulesComponent;
}(__WEBPACK_IMPORTED_MODULE_4__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=activitymodules.js.map

/***/ }),
/* 933 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockMyOverviewComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_courses_providers_helper__ = __webpack_require__(179);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__addon_coursecompletion_providers_coursecompletion__ = __webpack_require__(146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_block_classes_base_block_component__ = __webpack_require__(150);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Component to render a my overview block.
 */
var AddonBlockMyOverviewComponent = /** @class */ (function (_super) {
    __extends(AddonBlockMyOverviewComponent, _super);
    function AddonBlockMyOverviewComponent(injector, coursesProvider, courseCompletionProvider, eventsProvider, courseHelper, utils, courseOptionsDelegate, coursesHelper, sitesProvider, timeUtils) {
        var _this = _super.call(this, injector, 'AddonBlockMyOverviewComponent') || this;
        _this.coursesProvider = coursesProvider;
        _this.courseCompletionProvider = courseCompletionProvider;
        _this.eventsProvider = eventsProvider;
        _this.courseHelper = courseHelper;
        _this.utils = utils;
        _this.courseOptionsDelegate = courseOptionsDelegate;
        _this.coursesHelper = coursesHelper;
        _this.sitesProvider = sitesProvider;
        _this.timeUtils = timeUtils;
        _this.courses = {
            filter: '',
            all: [],
            past: [],
            inprogress: [],
            future: [],
            favourite: [],
            hidden: []
        };
        _this.selectedFilter = 'inprogress';
        _this.sort = 'fullname';
        _this.prefetchCoursesData = {
            all: {},
            inprogress: {},
            past: {},
            future: {},
            favourite: {},
            hidden: {}
        };
        _this.showFilter = false;
        _this.showFavourite = false;
        _this.showHidden = false;
        _this.showSelectorFilter = false;
        _this.showSortFilter = false;
        _this.prefetchIconsInitialized = false;
        _this.courseIds = [];
        _this.fetchContentDefaultError = 'Error getting my overview data.';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonBlockMyOverviewComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Refresh the enabled flags if enabled.
        this.downloadButtonObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_DASHBOARD_DOWNLOAD_ENABLED_CHANGED, function (data) {
            var wasEnabled = _this.downloadEnabled;
            _this.downloadEnabled = data.enabled;
            if (!wasEnabled && _this.downloadEnabled && _this.loaded) {
                // Download all courses is enabled now, initialize it.
                _this.initPrefetchCoursesIcons();
            }
        });
        this.downloadCourseEnabled = !this.coursesProvider.isDownloadCourseDisabledInSite();
        this.downloadCoursesEnabled = !this.coursesProvider.isDownloadCoursesDisabledInSite();
        // Refresh the enabled flags if site is updated.
        this.updateSiteObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function () {
            _this.downloadCourseEnabled = !_this.coursesProvider.isDownloadCourseDisabledInSite();
            _this.downloadCoursesEnabled = !_this.coursesProvider.isDownloadCoursesDisabledInSite();
        }, this.sitesProvider.getCurrentSiteId());
        this.coursesObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_MY_COURSES_UPDATED, function () {
            _this.refreshContent();
        }, this.sitesProvider.getCurrentSiteId());
        this.currentSite = this.sitesProvider.getCurrentSite();
        var promises = [];
        promises.push(this.currentSite.getLocalSiteConfig('AddonBlockMyOverviewSort', this.sort).then(function (value) {
            _this.sort = value;
        }));
        promises.push(this.currentSite.getLocalSiteConfig('AddonBlockMyOverviewFilter', this.selectedFilter).then(function (value) {
            _this.selectedFilter = typeof _this.courses[value] == 'undefined' ? 'inprogress' : value;
        }));
        Promise.all(promises).finally(function () {
            _super.prototype.ngOnInit.call(_this);
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlockMyOverviewComponent.prototype.invalidateContent = function () {
        var _this = this;
        var promises = [];
        promises.push(this.coursesProvider.invalidateUserCourses().finally(function () {
            // Invalidate course completion data.
            promises.push(_this.coursesProvider.invalidateUserCourses().finally(function () {
                // Invalidate course completion data.
                return _this.utils.allPromises(_this.courseIds.map(function (courseId) {
                    return _this.courseCompletionProvider.invalidateCourseCompletion(courseId);
                }));
            }));
        }));
        promises.push(this.courseOptionsDelegate.clearAndInvalidateCoursesOptions());
        if (this.courseIds.length > 0) {
            promises.push(this.coursesProvider.invalidateCoursesByField('ids', this.courseIds.join(',')));
        }
        return this.utils.allPromises(promises).finally(function () {
            _this.prefetchIconsInitialized = false;
        });
    };
    /**
     * Fetch the courses for my overview.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockMyOverviewComponent.prototype.fetchContent = function () {
        var _this = this;
        return this.coursesHelper.getUserCoursesWithOptions(this.sort).then(function (courses) {
            _this.courseIds = courses.map(function (course) {
                return course.id;
            });
            _this.showSortFilter = courses.length > 0 && typeof courses[0].lastaccess != 'undefined';
            _this.initCourseFilters(courses);
            _this.courses.filter = '';
            _this.showFilter = false;
            _this.showSelectorFilter = courses.length > 0 && (_this.courses.past.length > 0 || _this.courses.future.length > 0 ||
                typeof courses[0].enddate != 'undefined');
            _this.showHidden = _this.showSelectorFilter && typeof courses[0].hidden != 'undefined';
            _this.showFavourite = _this.showSelectorFilter && typeof courses[0].isfavourite != 'undefined';
            if (!_this.showSelectorFilter) {
                // No selector, show all.
                _this.selectedFilter = 'all';
            }
            _this.filteredCourses = _this.courses[_this.selectedFilter];
            _this.initPrefetchCoursesIcons();
        });
    };
    /**
     * The filter has changed.
     *
     * @param {any} Received Event.
     */
    AddonBlockMyOverviewComponent.prototype.filterChanged = function (event) {
        var newValue = event.target.value && event.target.value.trim().toLowerCase();
        if (!newValue || !this.courses['all']) {
            this.filteredCourses = this.courses['all'];
        }
        else {
            // Use displayname if avalaible, or fullname if not.
            if (this.courses['all'].length > 0 &&
                typeof this.courses['all'][0].displayname != 'undefined') {
                this.filteredCourses = this.courses['all'].filter(function (course) {
                    return course.displayname.toLowerCase().indexOf(newValue) > -1;
                });
            }
            else {
                this.filteredCourses = this.courses['all'].filter(function (course) {
                    return course.fullname.toLowerCase().indexOf(newValue) > -1;
                });
            }
        }
    };
    /**
     * Initialize the prefetch icon for selected courses.
     */
    AddonBlockMyOverviewComponent.prototype.initPrefetchCoursesIcons = function () {
        var _this = this;
        if (this.prefetchIconsInitialized || !this.downloadEnabled) {
            // Already initialized.
            return;
        }
        this.prefetchIconsInitialized = true;
        Object.keys(this.prefetchCoursesData).forEach(function (filter) {
            _this.courseHelper.initPrefetchCoursesIcons(_this.courses[filter], _this.prefetchCoursesData[filter]).then(function (prefetch) {
                _this.prefetchCoursesData[filter] = prefetch;
            });
        });
    };
    /**
     * Prefetch all the shown courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockMyOverviewComponent.prototype.prefetchCourses = function () {
        var _this = this;
        var selected = this.selectedFilter, initialIcon = this.prefetchCoursesData[selected].icon;
        return this.courseHelper.prefetchCourses(this.courses[selected], this.prefetchCoursesData[selected]).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
                _this.prefetchCoursesData[selected].icon = initialIcon;
            }
        });
    };
    /**
     * The selected courses filter have changed.
     */
    AddonBlockMyOverviewComponent.prototype.selectedChanged = function () {
        this.currentSite.setLocalSiteConfig('AddonBlockMyOverviewFilter', this.selectedFilter);
        this.filteredCourses = this.courses[this.selectedFilter];
    };
    /**
     * Init courses filters.
     *
     * @param {any[]} courses Courses to filter.
     */
    AddonBlockMyOverviewComponent.prototype.initCourseFilters = function (courses) {
        var _this = this;
        if (this.showSortFilter) {
            if (this.sort == 'lastaccess') {
                courses.sort(function (a, b) {
                    return b.lastaccess - a.lastaccess;
                });
            }
            else if (this.sort == 'fullname') {
                courses.sort(function (a, b) {
                    var compareA = a.fullname.toLowerCase(), compareB = b.fullname.toLowerCase();
                    return compareA.localeCompare(compareB);
                });
            }
        }
        this.courses.all = [];
        this.courses.past = [];
        this.courses.inprogress = [];
        this.courses.future = [];
        this.courses.favourite = [];
        this.courses.hidden = [];
        var today = this.timeUtils.timestamp();
        courses.forEach(function (course) {
            if (course.hidden) {
                _this.courses.hidden.push(course);
            }
            else {
                _this.courses.all.push(course);
                if ((course.enddate && course.enddate < today) || course.completed) {
                    // Courses that have already ended.
                    _this.courses.past.push(course);
                }
                else if (course.startdate > today) {
                    // Courses that have not started yet.
                    _this.courses.future.push(course);
                }
                else {
                    // Courses still in progress.
                    _this.courses.inprogress.push(course);
                }
                if (course.isfavourite) {
                    _this.courses.favourite.push(course);
                }
            }
        });
        this.filteredCourses = this.courses[this.selectedFilter];
    };
    /**
     * The selected courses sort filter have changed.
     *
     * @param {string} sort New sorting.
     */
    AddonBlockMyOverviewComponent.prototype.switchSort = function (sort) {
        this.sort = sort;
        this.currentSite.setLocalSiteConfig('AddonBlockMyOverviewSort', this.sort);
        this.initCourseFilters(this.courses.all.concat(this.courses.hidden));
    };
    /**
     * Show or hide the filter.
     */
    AddonBlockMyOverviewComponent.prototype.switchFilter = function () {
        var _this = this;
        this.showFilter = !this.showFilter;
        this.courses.filter = '';
        this.filteredCourses = this.courses[this.showFilter ? 'all' : this.selectedFilter];
        if (this.showFilter) {
            setTimeout(function () {
                _this.searchbar.setFocus();
            }, 500);
        }
    };
    /**
     * If switch button that enables the filter input is shown or not.
     *
     * @return {boolean} If switch button that enables the filter input is shown or not.
     */
    AddonBlockMyOverviewComponent.prototype.showFilterSwitchButton = function () {
        return this.loaded && this.courses['all'] && this.courses['all'].length > 5;
    };
    /**
     * Component being destroyed.
     */
    AddonBlockMyOverviewComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.coursesObserver && this.coursesObserver.off();
        this.updateSiteObserver && this.updateSiteObserver.off();
        this.downloadButtonObserver && this.downloadButtonObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('searchbar'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["z" /* Searchbar */])
    ], AddonBlockMyOverviewComponent.prototype, "searchbar", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonBlockMyOverviewComponent.prototype, "downloadEnabled", void 0);
    AddonBlockMyOverviewComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-myoverview',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\myoverview\components\myoverview\addon-block-myoverview.html"*/'<ion-item-divider>\n    <h2>{{ \'addon.block_myoverview.pluginname\' | translate }}</h2>\n    <!-- Download all courses. -->\n    <div *ngIf="downloadCoursesEnabled && downloadEnabled && courses[selectedFilter] && courses[selectedFilter].length > 1 && !showFilter" class="core-button-spinner" item-end>\n        <button *ngIf="prefetchCoursesData[selectedFilter].icon && prefetchCoursesData[selectedFilter].icon != \'spinner\'" ion-button icon-only clear color="dark" (click)="prefetchCourses()">\n            <core-icon [name]="prefetchCoursesData[selectedFilter].icon"></core-icon>\n        </button>\n        <ion-badge class="core-course-download-courses-progress" *ngIf="prefetchCoursesData[selectedFilter].badge">{{prefetchCoursesData[selectedFilter].badge}}</ion-badge>\n        <ion-spinner *ngIf="!prefetchCoursesData[selectedFilter].icon || prefetchCoursesData[selectedFilter].icon == \'spinner\'"></ion-spinner>\n    </div>\n    <core-context-menu item-end>\n        <core-context-menu-item *ngIf="loaded && showFilterSwitchButton()" [priority]="1000" [content]="\'core.courses.filtermycourses\' | translate" (action)="switchFilter()" iconAction="funnel"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && showSortFilter" [priority]="900" content="{{(\'core.sortby\' | translate) + \' \' + (\'addon.block_myoverview.title\' | translate)}}" (action)="switchSort(\'fullname\')" [iconAction]="sort == \'fullname\' ? \'radio-button-on\' : \'radio-button-off\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded && showSortFilter" [priority]="800" content="{{(\'core.sortby\' | translate) + \' \' + (\'addon.block_myoverview.lastaccessed\' | translate)}}" (action)="switchSort(\'lastaccess\')" [iconAction]="sort == \'lastaccess\' ? \'radio-button-on\' : \'radio-button-off\'"></core-context-menu-item>\n    </core-context-menu>\n</ion-item-divider>\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <div padding [hidden]="showFilter || !showSelectorFilter" class="safe-padding-horizontal">\n        <!-- "Time" selector. -->\n        <ion-select text-start [title]="\'core.show\' | translate" [(ngModel)]="selectedFilter" (ngModelChange)="selectedChanged()" interface="popover" class="core-button-select">\n            <ion-option value="all">{{ \'addon.block_myoverview.all\' | translate }}</ion-option>∫\n            <ion-option value="inprogress">{{ \'addon.block_myoverview.inprogress\' | translate }}</ion-option>\n            <ion-option value="future">{{ \'addon.block_myoverview.future\' | translate }}</ion-option>\n            <ion-option value="past">{{ \'addon.block_myoverview.past\' | translate }}</ion-option>\n            <ion-option value="favourite" *ngIf="showFavourite">{{ \'addon.block_myoverview.favourites\' | translate }}</ion-option>\n            <ion-option value="hidden" *ngIf="showHidden">{{ \'addon.block_myoverview.hiddencourses\' | translate }}</ion-option>\n        </ion-select>\n    </div>\n    <core-empty-box *ngIf="courses[selectedFilter].length == 0" image="assets/img/icons/courses.svg" [message]="\'addon.block_myoverview.nocourses\' | translate"></core-empty-box>\n\n    <!-- Filter courses. -->\n    <ion-searchbar #searchbar *ngIf="showFilter" [(ngModel)]="courses.filter" (ionInput)="filterChanged($event)" (ionCancel)="filterChanged()" [placeholder]="\'core.courses.filtermycourses\' | translate">\n    </ion-searchbar>\n    <!-- List of courses. -->\n    <div class="safe-area-page">\n        <ion-grid no-padding>\n            <ion-row no-padding>\n                <ion-col *ngFor="let course of filteredCourses" no-padding col-12 col-sm-6 col-md-6 col-lg-4 col-xl-4 align-self-stretch>\n                    <core-courses-course-progress [course]="course" class="core-courseoverview" showAll="true" [showDownload]="downloadCourseEnabled && downloadEnabled"></core-courses-course-progress>\n                </ion-col>\n            </ion-row>\n        </ion-grid>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\myoverview\components\myoverview\addon-block-myoverview.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_10__addon_coursecompletion_providers_coursecompletion__["a" /* AddonCourseCompletionProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_7__core_courses_providers_helper__["a" /* CoreCoursesHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonBlockMyOverviewComponent);
    return AddonBlockMyOverviewComponent;
}(__WEBPACK_IMPORTED_MODULE_11__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=myoverview.js.map

/***/ }),
/* 934 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockSiteMainMenuComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_sitehome_providers_sitehome__ = __webpack_require__(171);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_block_classes_base_block_component__ = __webpack_require__(150);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component to render a site main menu block.
 */
var AddonBlockSiteMainMenuComponent = /** @class */ (function (_super) {
    __extends(AddonBlockSiteMainMenuComponent, _super);
    function AddonBlockSiteMainMenuComponent(injector, sitesProvider, courseProvider, courseHelper, siteHomeProvider, prefetchDelegate) {
        var _this = _super.call(this, injector, 'AddonBlockSiteMainMenuComponent') || this;
        _this.sitesProvider = sitesProvider;
        _this.courseProvider = courseProvider;
        _this.courseHelper = courseHelper;
        _this.siteHomeProvider = siteHomeProvider;
        _this.prefetchDelegate = prefetchDelegate;
        _this.fetchContentDefaultError = 'Error getting main menu data.';
        _this.siteHomeId = sitesProvider.getCurrentSite().getSiteHomeId();
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonBlockSiteMainMenuComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlockSiteMainMenuComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.courseProvider.invalidateSections(this.siteHomeId));
        promises.push(this.siteHomeProvider.invalidateNewsForum(this.siteHomeId));
        if (this.block && this.block.modules) {
            // Invalidate modules prefetch data.
            promises.push(this.prefetchDelegate.invalidateModules(this.block.modules, this.siteHomeId));
        }
        return Promise.all(promises);
    };
    /**
     * Fetch the data to render the block.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockSiteMainMenuComponent.prototype.fetchContent = function () {
        var _this = this;
        return this.courseProvider.getSections(this.siteHomeId, false, true).then(function (sections) {
            _this.block = sections.find(function (section) { return section.section == 0; });
            if (_this.block) {
                _this.block.hasContent = _this.courseHelper.sectionHasContent(_this.block);
                _this.courseHelper.addHandlerDataForModules([_this.block], _this.siteHomeId);
                // Check if Site Home displays announcements. If so, remove it from the main menu block.
                var currentSite = _this.sitesProvider.getCurrentSite(), config = currentSite ? currentSite.getStoredConfig() || {} : {};
                var hasNewsItem = false;
                if (config.frontpageloggedin) {
                    var items = config.frontpageloggedin.split(',');
                    hasNewsItem = items.find(function (item) { return item == '0'; });
                }
                if (hasNewsItem && _this.block.modules) {
                    // Remove forum activity (news one only) from the main menu block to prevent duplicates.
                    return _this.siteHomeProvider.getNewsForum(_this.siteHomeId).then(function (forum) {
                        // Search the module that belongs to site news.
                        for (var i = 0; i < _this.block.modules.length; i++) {
                            var module_1 = _this.block.modules[i];
                            if (module_1.modname == 'forum' && module_1.instance == forum.id) {
                                _this.block.modules.splice(i, 1);
                                break;
                            }
                        }
                    }).catch(function () {
                        // Ignore errors.
                    });
                }
            }
        });
    };
    AddonBlockSiteMainMenuComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-sitemainmenu',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\sitemainmenu\components\sitemainmenu\addon-block-sitemainmenu.html"*/'<ion-item-divider>\n    <h2>{{ \'addon.block_sitemainmenu.pluginname\' | translate }}</h2>\n</ion-item-divider>\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <ion-item text-wrap *ngIf="block.summary">\n        <core-format-text [text]="block.summary"></core-format-text>\n    </ion-item>\n\n    <core-course-module *ngFor="let module of block.modules" [module]="module" [courseId]="siteHomeId" [downloadEnabled]="true" [section]="block"></core-course-module>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\sitemainmenu\components\sitemainmenu\addon-block-sitemainmenu.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_4__core_sitehome_providers_sitehome__["a" /* CoreSiteHomeProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */]])
    ], AddonBlockSiteMainMenuComponent);
    return AddonBlockSiteMainMenuComponent;
}(__WEBPACK_IMPORTED_MODULE_6__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=sitemainmenu.js.map

/***/ }),
/* 935 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockTimelineComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_helper__ = __webpack_require__(179);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_block_classes_base_block_component__ = __webpack_require__(150);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_timeline__ = __webpack_require__(262);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Component to render a timeline block.
 */
var AddonBlockTimelineComponent = /** @class */ (function (_super) {
    __extends(AddonBlockTimelineComponent, _super);
    function AddonBlockTimelineComponent(injector, coursesProvider, utils, timelineProvider, courseOptionsDelegate, coursesHelper, sitesProvider, timeUtils) {
        var _this = _super.call(this, injector, 'AddonBlockTimelineComponent') || this;
        _this.coursesProvider = coursesProvider;
        _this.utils = utils;
        _this.timelineProvider = timelineProvider;
        _this.courseOptionsDelegate = courseOptionsDelegate;
        _this.coursesHelper = coursesHelper;
        _this.sitesProvider = sitesProvider;
        _this.timeUtils = timeUtils;
        _this.sort = 'sortbydates';
        _this.filter = 'next30days';
        _this.timeline = {
            events: [],
            loaded: false,
            canLoadMore: undefined
        };
        _this.timelineCourses = {
            courses: [],
            loaded: false,
            canLoadMore: false
        };
        _this.courseIds = [];
        _this.fetchContentDefaultError = 'Error getting timeline data.';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonBlockTimelineComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.currentSite = this.sitesProvider.getCurrentSite();
        this.currentSite.getLocalSiteConfig('AddonBlockTimelineFilter', this.filter).then(function (value) {
            _this.filter = value;
            _this.switchFilter();
        });
        this.currentSite.getLocalSiteConfig('AddonBlockTimelineSort', this.sort).then(function (value) {
            _this.sort = value;
            _super.prototype.ngOnInit.call(_this);
        });
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlockTimelineComponent.prototype.invalidateContent = function () {
        var promises = [];
        promises.push(this.timelineProvider.invalidateActionEventsByTimesort());
        promises.push(this.timelineProvider.invalidateActionEventsByCourses());
        promises.push(this.coursesProvider.invalidateUserCourses());
        promises.push(this.courseOptionsDelegate.clearAndInvalidateCoursesOptions());
        if (this.courseIds.length > 0) {
            promises.push(this.coursesProvider.invalidateCoursesByField('ids', this.courseIds.join(',')));
        }
        return this.utils.allPromises(promises);
    };
    /**
     * Fetch the courses for my overview.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockTimelineComponent.prototype.fetchContent = function () {
        var _this = this;
        if (this.sort == 'sortbydates') {
            return this.fetchMyOverviewTimeline().finally(function () {
                _this.timeline.loaded = true;
            });
        }
        else if (this.sort == 'sortbycourses') {
            return this.fetchMyOverviewTimelineByCourses().finally(function () {
                _this.timelineCourses.loaded = true;
            });
        }
    };
    /**
     * Load more events.
     */
    AddonBlockTimelineComponent.prototype.loadMoreTimeline = function () {
        var _this = this;
        return this.fetchMyOverviewTimeline(this.timeline.canLoadMore).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, _this.fetchContentDefaultError);
        });
    };
    /**
     * Load more events.
     *
     * @param {any} course Course.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockTimelineComponent.prototype.loadMoreCourse = function (course) {
        var _this = this;
        return this.timelineProvider.getActionEventsByCourse(course.id, course.canLoadMore).then(function (courseEvents) {
            course.events = course.events.concat(courseEvents.events);
            course.canLoadMore = courseEvents.canLoadMore;
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, _this.fetchContentDefaultError);
        });
    };
    /**
     * Fetch the timeline.
     *
     * @param {number} [afterEventId] The last event id.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockTimelineComponent.prototype.fetchMyOverviewTimeline = function (afterEventId) {
        var _this = this;
        return this.timelineProvider.getActionEventsByTimesort(afterEventId).then(function (events) {
            _this.timeline.events = events.events;
            _this.timeline.canLoadMore = events.canLoadMore;
        });
    };
    /**
     * Fetch the timeline by courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockTimelineComponent.prototype.fetchMyOverviewTimelineByCourses = function () {
        var _this = this;
        return this.coursesHelper.getUserCoursesWithOptions().then(function (courses) {
            var today = _this.timeUtils.timestamp();
            courses = courses.filter(function (course) {
                return course.startdate <= today && (!course.enddate || course.enddate >= today);
            });
            _this.timelineCourses.courses = courses;
            if (courses.length > 0) {
                _this.courseIds = courses.map(function (course) {
                    return course.id;
                });
                return _this.timelineProvider.getActionEventsByCourses(_this.courseIds).then(function (courseEvents) {
                    _this.timelineCourses.courses.forEach(function (course) {
                        course.events = courseEvents[course.id].events;
                        course.canLoadMore = courseEvents[course.id].canLoadMore;
                    });
                });
            }
        });
    };
    /**
     * Change timeline filter being viewed.
     */
    AddonBlockTimelineComponent.prototype.switchFilter = function () {
        this.currentSite.setLocalSiteConfig('AddonBlockTimelineFilter', this.filter);
        switch (this.filter) {
            case 'overdue':
                this.dataFrom = -14;
                this.dataTo = 0;
                break;
            case 'next7days':
                this.dataFrom = 0;
                this.dataTo = 7;
                break;
            case 'next30days':
                this.dataFrom = 0;
                this.dataTo = 30;
                break;
            case 'next3months':
                this.dataFrom = 0;
                this.dataTo = 90;
                break;
            case 'next6months':
                this.dataFrom = 0;
                this.dataTo = 180;
                break;
            default:
            case 'all':
                this.dataFrom = -14;
                this.dataTo = undefined;
                break;
        }
    };
    /**
     * Change timeline sort being viewed.
     *
     * @param {string} sort New sorting.
     */
    AddonBlockTimelineComponent.prototype.switchSort = function (sort) {
        this.sort = sort;
        this.currentSite.setLocalSiteConfig('AddonBlockTimelineSort', this.sort);
        if (!this.timeline.loaded && this.sort == 'sortbydates') {
            this.fetchContent();
        }
        else if (!this.timelineCourses.loaded && this.sort == 'sortbycourses') {
            this.fetchContent();
        }
    };
    AddonBlockTimelineComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-timeline',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\timeline\components\timeline\addon-block-timeline.html"*/'<ion-item-divider>\n    <h2>{{ \'addon.block_timeline.pluginname\' | translate }}</h2>\n    <core-context-menu item-end>\n        <core-context-menu-item *ngIf="loaded" [priority]="900" [content]="\'addon.block_timeline.sortbydates\' | translate" (action)="switchSort(\'sortbydates\')" [iconAction]="sort == \'sortbydates\' ? \'radio-button-on\' : \'radio-button-off\'"></core-context-menu-item>\n        <core-context-menu-item *ngIf="loaded" [priority]="800" [content]="\'addon.block_timeline.sortbycourses\' | translate" (action)="switchSort(\'sortbycourses\')" [iconAction]="sort == \'sortbycourses\' ? \'radio-button-on\' : \'radio-button-off\'"></core-context-menu-item>\n    </core-context-menu>\n</ion-item-divider>\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <div padding class="safe-padding-horizontal">\n        <ion-select text-start [(ngModel)]="filter" (ngModelChange)="switchFilter()" interface="popover" class="core-button-select">\n            <ion-option value="all">{{ \'core.all\' | translate }}</ion-option>\n            <ion-option value="overdue">{{ \'addon.block_timeline.overdue\' | translate }}</ion-option>\n            <ion-option disabled value="disabled">{{ \'addon.block_timeline.duedate\' | translate }}</ion-option>\n            <ion-option value="next7days">{{ \'addon.block_timeline.next7days\' | translate }}</ion-option>\n            <ion-option value="next30days">{{ \'addon.block_timeline.next30days\' | translate }}</ion-option>\n            <ion-option value="next3months">{{ \'addon.block_timeline.next3months\' | translate }}</ion-option>\n            <ion-option value="next6months">{{ \'addon.block_timeline.next6months\' | translate }}</ion-option>\n        </ion-select>\n    </div>\n    <core-loading [hideUntil]="timeline.loaded" [hidden]="sort != \'sortbydates\'" class="core-loading-center">\n        <addon-block-timeline-events [events]="timeline.events" showCourse="true" [canLoadMore]="timeline.canLoadMore" (loadMore)="loadMoreTimeline()" [from]="dataFrom" [to]="dataTo"></addon-block-timeline-events>\n    </core-loading>\n    <core-loading [hideUntil]="timelineCourses.loaded" [hidden]="sort != \'sortbycourses\'" class="core-loading-center">\n        <div class="safe-area-page">\n            <ion-grid no-padding>\n                <ion-row no-padding>\n                    <ion-col *ngFor="let course of timelineCourses.courses" no-padding col-12 col-md-6>\n                        <core-courses-course-progress [course]="course">\n                            <addon-block-timeline-events [events]="course.events" [canLoadMore]="course.canLoadMore" (loadMore)="loadMoreCourse(course)" [from]="dataFrom" [to]="dataTo"></addon-block-timeline-events>\n                        </core-courses-course-progress>\n                    </ion-col>\n                </ion-row>\n            </ion-grid>\n        </div>\n        <core-empty-box *ngIf="timelineCourses.courses.length == 0" image="assets/img/icons/courses.svg" [message]="\'addon.block_timeline.nocoursesinprogress\' | translate"></core-empty-box>\n    </core-loading>\n</core-loading>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\timeline\components\timeline\addon-block-timeline.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_timeline__["a" /* AddonBlockTimelineProvider */], __WEBPACK_IMPORTED_MODULE_6__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */],
            __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_helper__["a" /* CoreCoursesHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonBlockTimelineComponent);
    return AddonBlockTimelineComponent;
}(__WEBPACK_IMPORTED_MODULE_7__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=timeline.js.map

/***/ }),
/* 936 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedCoursesComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_helper__ = __webpack_require__(179);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__addon_coursecompletion_providers_coursecompletion__ = __webpack_require__(146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_block_classes_base_block_component__ = __webpack_require__(150);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Component to render a recent courses block.
 */
var AddonBlockRecentlyAccessedCoursesComponent = /** @class */ (function (_super) {
    __extends(AddonBlockRecentlyAccessedCoursesComponent, _super);
    function AddonBlockRecentlyAccessedCoursesComponent(injector, coursesProvider, courseCompletionProvider, eventsProvider, courseHelper, utils, courseOptionsDelegate, coursesHelper, sitesProvider) {
        var _this = _super.call(this, injector, 'AddonBlockRecentlyAccessedCoursesComponent') || this;
        _this.coursesProvider = coursesProvider;
        _this.courseCompletionProvider = courseCompletionProvider;
        _this.eventsProvider = eventsProvider;
        _this.courseHelper = courseHelper;
        _this.utils = utils;
        _this.courseOptionsDelegate = courseOptionsDelegate;
        _this.coursesHelper = coursesHelper;
        _this.sitesProvider = sitesProvider;
        _this.courses = [];
        _this.prefetchCoursesData = {
            icon: '',
            badge: ''
        };
        _this.prefetchIconsInitialized = false;
        _this.courseIds = [];
        _this.fetchContentDefaultError = 'Error getting recent courses data.';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonBlockRecentlyAccessedCoursesComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Refresh the enabled flags if enabled.
        this.downloadButtonObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_DASHBOARD_DOWNLOAD_ENABLED_CHANGED, function (data) {
            var wasEnabled = _this.downloadEnabled;
            _this.downloadEnabled = data.enabled;
            if (!wasEnabled && _this.downloadEnabled && _this.loaded) {
                // Download all courses is enabled now, initialize it.
                _this.initPrefetchCoursesIcons();
            }
        });
        this.coursesObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_MY_COURSES_UPDATED, function () {
            _this.refreshContent();
        }, this.sitesProvider.getCurrentSiteId());
        _super.prototype.ngOnInit.call(this);
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlockRecentlyAccessedCoursesComponent.prototype.invalidateContent = function () {
        var _this = this;
        var promises = [];
        promises.push(this.coursesProvider.invalidateUserCourses().finally(function () {
            // Invalidate course completion data.
            return _this.utils.allPromises(_this.courseIds.map(function (courseId) {
                return _this.courseCompletionProvider.invalidateCourseCompletion(courseId);
            }));
        }));
        promises.push(this.courseOptionsDelegate.clearAndInvalidateCoursesOptions());
        if (this.courseIds.length > 0) {
            promises.push(this.coursesProvider.invalidateCoursesByField('ids', this.courseIds.join(',')));
        }
        return this.utils.allPromises(promises).finally(function () {
            _this.prefetchIconsInitialized = false;
        });
    };
    /**
     * Fetch the courses for recent courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockRecentlyAccessedCoursesComponent.prototype.fetchContent = function () {
        var _this = this;
        return this.coursesHelper.getUserCoursesWithOptions('lastaccess', 10).then(function (courses) {
            _this.courses = courses;
            _this.initPrefetchCoursesIcons();
        });
    };
    /**
     * Initialize the prefetch icon for selected courses.
     */
    AddonBlockRecentlyAccessedCoursesComponent.prototype.initPrefetchCoursesIcons = function () {
        var _this = this;
        if (this.prefetchIconsInitialized || !this.downloadEnabled) {
            // Already initialized.
            return;
        }
        this.prefetchIconsInitialized = true;
        this.courseHelper.initPrefetchCoursesIcons(this.courses, this.prefetchCoursesData).then(function (prefetch) {
            _this.prefetchCoursesData = prefetch;
        });
    };
    /**
     * Prefetch all the shown courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockRecentlyAccessedCoursesComponent.prototype.prefetchCourses = function () {
        var _this = this;
        var initialIcon = this.prefetchCoursesData.icon;
        return this.courseHelper.prefetchCourses(this.courses, this.prefetchCoursesData).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
                _this.prefetchCoursesData.icon = initialIcon;
            }
        });
    };
    /**
     * Component being destroyed.
     */
    AddonBlockRecentlyAccessedCoursesComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.coursesObserver && this.coursesObserver.off();
        this.downloadButtonObserver && this.downloadButtonObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonBlockRecentlyAccessedCoursesComponent.prototype, "downloadEnabled", void 0);
    AddonBlockRecentlyAccessedCoursesComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-recentlyaccessedcourses',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\recentlyaccessedcourses\components\recentlyaccessedcourses\addon-block-recentlyaccessedcourses.html"*/'<ion-item-divider>\n    <h2>{{ \'addon.block_recentlyaccessedcourses.pluginname\' | translate }}</h2>\n    <div *ngIf="downloadEnabled && courses && courses.length > 1" class="core-button-spinner" item-end>\n        <button *ngIf="prefetchCoursesData.icon && prefetchCoursesData.icon != \'spinner\'" ion-button icon-only clear color="dark" (click)="prefetchCourses()">\n            <core-icon [name]="prefetchCoursesData.icon"></core-icon>\n        </button>\n        <ion-badge class="core-course-download-courses-progress" *ngIf="prefetchCoursesData.badge">{{prefetchCoursesData.badge}}</ion-badge>\n        <ion-spinner *ngIf="!prefetchCoursesData.icon || prefetchCoursesData.icon == \'spinner\'"></ion-spinner>\n    </div>\n</ion-item-divider>\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <core-empty-box *ngIf="courses.length == 0" image="assets/img/icons/courses.svg" [message]="\'addon.block_recentlyaccessedcourses.nocourses\' | translate"></core-empty-box>\n    <!-- List of courses. -->\n    <div class="safe-area-page">\n         <div class="core-horizontal-scroll">\n            <ng-container *ngFor="let course of courses">\n                <core-courses-course-progress [course]="course" class="core-recentlyaccessedcourses" [showDownload]="downloadEnabled"></core-courses-course-progress>\n            </ng-container>\n        </div>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\recentlyaccessedcourses\components\recentlyaccessedcourses\addon-block-recentlyaccessedcourses.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_8__addon_coursecompletion_providers_coursecompletion__["a" /* AddonCourseCompletionProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_helper__["a" /* CoreCoursesHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonBlockRecentlyAccessedCoursesComponent);
    return AddonBlockRecentlyAccessedCoursesComponent;
}(__WEBPACK_IMPORTED_MODULE_9__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=recentlyaccessedcourses.js.map

/***/ }),
/* 937 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedItemsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_block_classes_base_block_component__ = __webpack_require__(150);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_recentlyaccesseditems__ = __webpack_require__(938);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_helper__ = __webpack_require__(19);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};







/**
 * Component to render a recently accessed items block.
 */
var AddonBlockRecentlyAccessedItemsComponent = /** @class */ (function (_super) {
    __extends(AddonBlockRecentlyAccessedItemsComponent, _super);
    function AddonBlockRecentlyAccessedItemsComponent(injector, navCtrl, sitesProvider, textUtils, recentItemsProvider, contentLinksHelper) {
        var _this = _super.call(this, injector, 'AddonBlockRecentlyAccessedItemsComponent') || this;
        _this.navCtrl = navCtrl;
        _this.sitesProvider = sitesProvider;
        _this.textUtils = textUtils;
        _this.recentItemsProvider = recentItemsProvider;
        _this.contentLinksHelper = contentLinksHelper;
        _this.items = [];
        _this.fetchContentDefaultError = 'Error getting recently accessed items data.';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonBlockRecentlyAccessedItemsComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlockRecentlyAccessedItemsComponent.prototype.invalidateContent = function () {
        return this.recentItemsProvider.invalidateRecentItems();
    };
    /**
     * Fetch the data to render the block.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockRecentlyAccessedItemsComponent.prototype.fetchContent = function () {
        var _this = this;
        return this.recentItemsProvider.getRecentItems().then(function (items) {
            _this.items = items;
        });
    };
    /**
     * Event clicked.
     *
     * @param {Event} e    Click event.
     * @param {any} item   Activity item info.
     */
    AddonBlockRecentlyAccessedItemsComponent.prototype.action = function (e, item) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        var url = this.textUtils.decodeHTMLEntities(item.viewurl);
        var modal = this.domUtils.showModalLoading();
        this.contentLinksHelper.handleLink(url, undefined, this.navCtrl).then(function (treated) {
            if (!treated) {
                return _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(url);
            }
        }).finally(function () {
            modal.dismiss();
        });
    };
    AddonBlockRecentlyAccessedItemsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-recentlyaccesseditems',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\recentlyaccesseditems\components\recentlyaccesseditems\addon-block-recentlyaccesseditems.html"*/'<ion-item-divider>\n    <h2>{{ \'addon.block_recentlyaccesseditems.pluginname\' | translate }}</h2>\n</ion-item-divider>\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <div class="core-horizontal-scroll" *ngIf="items && items.length > 0">\n        <div *ngFor="let item of items">\n            <ion-card>\n                <a ion-item text-wrap detail-none class="core-course-module-handler item-media" (click)="action($event, item)" [title]="item.name">\n                    <img item-start [src]="item.iconUrl" alt="" role="presentation" *ngIf="item.iconUrl" class="core-module-icon">\n                    <h2><core-format-text [text]="item.name"></core-format-text></h2>\n                    <p><core-format-text [text]="item.coursename"></core-format-text></p>\n                </a>\n            </ion-card>\n        </div>\n    </div>\n\n    <core-empty-box *ngIf="items.length <= 0" image="assets/img/icons/activities.svg" [message]="\'addon.block_recentlyaccesseditems.noitems\' | translate"></core-empty-box>\n\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\recentlyaccesseditems\components\recentlyaccesseditems\addon-block-recentlyaccesseditems.html"*/
        }),
        __param(1, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_recentlyaccesseditems__["a" /* AddonBlockRecentlyAccessedItemsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], AddonBlockRecentlyAccessedItemsComponent);
    return AddonBlockRecentlyAccessedItemsComponent;
}(__WEBPACK_IMPORTED_MODULE_3__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=recentlyaccesseditems.js.map

/***/ }),
/* 938 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedItemsProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service that provides some features regarding recently accessed items.
 */
var AddonBlockRecentlyAccessedItemsProvider = /** @class */ (function () {
    function AddonBlockRecentlyAccessedItemsProvider(sitesProvider, courseProvider, domUtils) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.domUtils = domUtils;
        this.ROOT_CACHE_KEY = 'AddonBlockRecentlyAccessedItems:';
    }
    /**
     * Get cache key for get last accessed items value WS call.
     *
     * @return {string} Cache key.
     */
    AddonBlockRecentlyAccessedItemsProvider.prototype.getRecentItemsCacheKey = function () {
        return this.ROOT_CACHE_KEY + ':recentitems';
    };
    /**
     * Get last accessed items.
     *
     * @param {string} [siteId] Site ID. If not defined, use current site.
     * @return {Promise<any[]>} Promise resolved when the info is retrieved.
     */
    AddonBlockRecentlyAccessedItemsProvider.prototype.getRecentItems = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var preSets = {
                cacheKey: _this.getRecentItemsCacheKey()
            };
            return site.read('block_recentlyaccesseditems_get_recent_items', undefined, preSets).then(function (items) {
                return items.map(function (item) {
                    var modicon = item.icon && _this.domUtils.getHTMLElementAttribute(item.icon, 'src');
                    item.iconUrl = _this.courseProvider.getModuleIconSrc(item.modname, modicon);
                    return item;
                });
            });
        });
    };
    /**
     * Invalidates get last accessed items WS call.
     *
     * @param {string} [siteId] Site ID to invalidate. If not defined, use current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonBlockRecentlyAccessedItemsProvider.prototype.invalidateRecentItems = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getRecentItemsCacheKey());
        });
    };
    AddonBlockRecentlyAccessedItemsProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonBlockRecentlyAccessedItemsProvider);
    return AddonBlockRecentlyAccessedItemsProvider;
}());

//# sourceMappingURL=recentlyaccesseditems.js.map

/***/ }),
/* 939 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockStarredCoursesComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_helper__ = __webpack_require__(179);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__addon_coursecompletion_providers_coursecompletion__ = __webpack_require__(146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_block_classes_base_block_component__ = __webpack_require__(150);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Component to render a starred courses block.
 */
var AddonBlockStarredCoursesComponent = /** @class */ (function (_super) {
    __extends(AddonBlockStarredCoursesComponent, _super);
    function AddonBlockStarredCoursesComponent(injector, coursesProvider, courseCompletionProvider, eventsProvider, courseHelper, utils, courseOptionsDelegate, coursesHelper, sitesProvider) {
        var _this = _super.call(this, injector, 'AddonBlockStarredCoursesComponent') || this;
        _this.coursesProvider = coursesProvider;
        _this.courseCompletionProvider = courseCompletionProvider;
        _this.eventsProvider = eventsProvider;
        _this.courseHelper = courseHelper;
        _this.utils = utils;
        _this.courseOptionsDelegate = courseOptionsDelegate;
        _this.coursesHelper = coursesHelper;
        _this.sitesProvider = sitesProvider;
        _this.courses = [];
        _this.prefetchCoursesData = {
            icon: '',
            badge: ''
        };
        _this.prefetchIconsInitialized = false;
        _this.courseIds = [];
        _this.fetchContentDefaultError = 'Error getting starred courses data.';
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonBlockStarredCoursesComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Refresh the enabled flags if enabled.
        this.downloadButtonObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_DASHBOARD_DOWNLOAD_ENABLED_CHANGED, function (data) {
            var wasEnabled = _this.downloadEnabled;
            _this.downloadEnabled = data.enabled;
            if (!wasEnabled && _this.downloadEnabled && _this.loaded) {
                // Download all courses is enabled now, initialize it.
                _this.initPrefetchCoursesIcons();
            }
        });
        this.coursesObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_MY_COURSES_UPDATED, function () {
            _this.refreshContent();
        }, this.sitesProvider.getCurrentSiteId());
        _super.prototype.ngOnInit.call(this);
    };
    /**
     * Perform the invalidate content function.
     *
     * @return {Promise<any>} Resolved when done.
     */
    AddonBlockStarredCoursesComponent.prototype.invalidateContent = function () {
        var _this = this;
        var promises = [];
        promises.push(this.coursesProvider.invalidateUserCourses().finally(function () {
            // Invalidate course completion data.
            return _this.utils.allPromises(_this.courseIds.map(function (courseId) {
                return _this.courseCompletionProvider.invalidateCourseCompletion(courseId);
            }));
        }));
        promises.push(this.courseOptionsDelegate.clearAndInvalidateCoursesOptions());
        if (this.courseIds.length > 0) {
            promises.push(this.coursesProvider.invalidateCoursesByField('ids', this.courseIds.join(',')));
        }
        return this.utils.allPromises(promises).finally(function () {
            _this.prefetchIconsInitialized = false;
        });
    };
    /**
     * Fetch the courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockStarredCoursesComponent.prototype.fetchContent = function () {
        var _this = this;
        return this.coursesHelper.getUserCoursesWithOptions('timemodified', 0, 'isfavourite').then(function (courses) {
            _this.courses = courses;
            _this.initPrefetchCoursesIcons();
        });
    };
    /**
     * Initialize the prefetch icon for selected courses.
     */
    AddonBlockStarredCoursesComponent.prototype.initPrefetchCoursesIcons = function () {
        var _this = this;
        if (this.prefetchIconsInitialized || !this.downloadEnabled) {
            // Already initialized.
            return;
        }
        this.prefetchIconsInitialized = true;
        this.courseHelper.initPrefetchCoursesIcons(this.courses, this.prefetchCoursesData).then(function (prefetch) {
            _this.prefetchCoursesData = prefetch;
        });
    };
    /**
     * Prefetch all the shown courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlockStarredCoursesComponent.prototype.prefetchCourses = function () {
        var _this = this;
        var initialIcon = this.prefetchCoursesData.icon;
        return this.courseHelper.prefetchCourses(this.courses, this.prefetchCoursesData).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
                _this.prefetchCoursesData.icon = initialIcon;
            }
        });
    };
    /**
     * Component being destroyed.
     */
    AddonBlockStarredCoursesComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.coursesObserver && this.coursesObserver.off();
        this.downloadButtonObserver && this.downloadButtonObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonBlockStarredCoursesComponent.prototype, "downloadEnabled", void 0);
    AddonBlockStarredCoursesComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-starredcourses',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\starredcourses\components\starredcourses\addon-block-starredcourses.html"*/'<ion-item-divider>\n    <h2>{{ \'addon.block_starredcourses.pluginname\' | translate }}</h2>\n    <div *ngIf="downloadEnabled && courses && courses.length > 1" class="core-button-spinner" item-end>\n        <button *ngIf="prefetchCoursesData.icon && prefetchCoursesData.icon != \'spinner\'" ion-button icon-only clear color="dark" (click)="prefetchCourses()">\n            <core-icon [name]="prefetchCoursesData.icon"></core-icon>\n        </button>\n        <ion-badge class="core-course-download-courses-progress" *ngIf="prefetchCoursesData.badge">{{prefetchCoursesData.badge}}</ion-badge>\n        <ion-spinner *ngIf="!prefetchCoursesData.icon || prefetchCoursesData.icon == \'spinner\'"></ion-spinner>\n    </div>\n</ion-item-divider>\n<core-loading [hideUntil]="loaded" class="core-loading-center">\n    <core-empty-box *ngIf="courses.length == 0" image="assets/img/icons/courses.svg" [message]="\'addon.block_starredcourses.nocourses\' | translate"></core-empty-box>\n    <!-- List of courses. -->\n    <div class="safe-area-page">\n        <div class="core-horizontal-scroll">\n            <ng-container *ngFor="let course of courses">\n                <core-courses-course-progress [course]="course" class="core-block_starredcourses" [showDownload]="downloadEnabled"></core-courses-course-progress>\n            </ng-container>\n        </div>\n    </div>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\starredcourses\components\starredcourses\addon-block-starredcourses.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_4__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_8__addon_coursecompletion_providers_coursecompletion__["a" /* AddonCourseCompletionProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_helper__["a" /* CoreCoursesHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonBlockStarredCoursesComponent);
    return AddonBlockStarredCoursesComponent;
}(__WEBPACK_IMPORTED_MODULE_9__core_block_classes_base_block_component__["a" /* CoreBlockBaseComponent */]));

//# sourceMappingURL=starredcourses.js.map

/***/ }),
/* 940 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldCheckboxComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Component to render data checkbox field.
 */
var AddonModDataFieldCheckboxComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldCheckboxComponent, _super);
    function AddonModDataFieldCheckboxComponent(fb) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.options = [];
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldCheckboxComponent.prototype.init = function () {
        var _this = this;
        if (this.isShowOrListMode()) {
            this.updateValue(this.value);
            return;
        }
        this.options = this.field.param1.split(/\r?\n/).map(function (option) {
            return { key: option, value: option };
        });
        var values = [];
        if (this.mode == 'edit' && this.value && this.value.content) {
            this.value.content.split('##').forEach(function (value) {
                var x = _this.options.findIndex(function (option) { return value == option.key; });
                if (x >= 0) {
                    values.push(value);
                }
            });
        }
        if (this.mode == 'search') {
            this.addControl('f_' + this.field.id + '_allreq');
        }
        this.addControl('f_' + this.field.id, values);
    };
    /**
     * Update value being shown.
     *
     * @param {any} value New value to be set.
     */
    AddonModDataFieldCheckboxComponent.prototype.updateValue = function (value) {
        this.value = value || {};
        this.value.content = value && value.content && value.content.split('##').join('<br>');
    };
    AddonModDataFieldCheckboxComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-checkbox',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\checkbox\component\addon-mod-data-field-checkbox.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-select [formControlName]="\'f_\'+field.id" multiple="true" [placeholder]="\'addon.mod_data.menuchoose\' | translate" [selectOptions]="{title: field.name}" interface="action-sheet">\n        <ion-option *ngFor="let option of options" [value]="option.value">{{option.key}}</ion-option>\n    </ion-select>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n\n    <ion-item *ngIf="mode == \'search\'">\n        <ion-label>{{ \'addon.mod_data.selectedrequired\' | translate }}</ion-label>\n        <ion-checkbox item-end [formControlName]="\'f_\'+field.id+\'_allreq\'" [(ngModel)]="search[\'f_\'+field.id+\'_allreq\']">\n        </ion-checkbox>\n    </ion-item>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value && value.content" [text]="value.content"></core-format-text>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\checkbox\component\addon-mod-data-field-checkbox.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModDataFieldCheckboxComponent);
    return AddonModDataFieldCheckboxComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=checkbox.js.map

/***/ }),
/* 941 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldDateComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





/**
 * Component to render data date field.
 */
var AddonModDataFieldDateComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldDateComponent, _super);
    function AddonModDataFieldDateComponent(fb, timeUtils, translate) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.timeUtils = timeUtils;
        _this.translate = translate;
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldDateComponent.prototype.init = function () {
        if (this.isShowOrListMode()) {
            return;
        }
        var val;
        // Calculate format to use. ion-datetime doesn't support escaping characters ([]), so we remove them.
        this.format = this.timeUtils.convertPHPToMoment(this.translate.instant('core.strftimedatefullshort'))
            .replace(/[\[\]]/g, '');
        if (this.mode == 'search') {
            this.addControl('f_' + this.field.id + '_z');
            val = this.search['f_' + this.field.id + '_y'] ? new Date(this.search['f_' + this.field.id + '_y'] + '-' +
                this.search['f_' + this.field.id + '_m'] + '-' + this.search['f_' + this.field.id + '_d']) : new Date();
            this.search['f_' + this.field.id] = val.toISOString();
        }
        else {
            val = this.value && this.value.content ? new Date(parseInt(this.value.content, 10) * 1000) : new Date();
            val = val.toISOString();
        }
        this.addControl('f_' + this.field.id, val);
    };
    AddonModDataFieldDateComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-date',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\date\component\addon-mod-data-field-date.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-datetime [formControlName]="\'f_\'+field.id" [placeholder]="\'core.date\' | translate" [disabled]="mode == \'search\' && !search[\'f_\'+field.id+\'_z\']" [displayFormat]="format"></ion-datetime>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n\n    <ion-item *ngIf="mode == \'search\'">\n        <ion-label>{{ \'addon.mod_data.usedate\' | translate }}</ion-label>\n        <ion-checkbox item-end [formControlName]="\'f_\'+field.id+\'_z\'" [(ngModel)]="search[\'f_\'+field.id+\'_z\']">\n        </ion-checkbox>\n    </ion-item>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value && value.content" [text]="value.content * 1000 | coreFormatDate:\'strftimedate\'"></core-format-text>\n\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\date\component\addon-mod-data-field-date.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldDateComponent);
    return AddonModDataFieldDateComponent;
}(__WEBPACK_IMPORTED_MODULE_4__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=date.js.map

/***/ }),
/* 942 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldFileComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_data__ = __webpack_require__(64);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





/**
 * Component to render data file field.
 */
var AddonModDataFieldFileComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldFileComponent, _super);
    function AddonModDataFieldFileComponent(fb, fileSessionprovider) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.fileSessionprovider = fileSessionprovider;
        _this.files = [];
        return _this;
    }
    /**
     * Get the files from the input value.
     *
     * @param  {any} value Input value.
     * @return {any}     List of files.
     */
    AddonModDataFieldFileComponent.prototype.getFiles = function (value) {
        var files = (value && value.files) || [];
        // Reduce to first element.
        if (files.length > 0) {
            files = [files[0]];
        }
        return files;
    };
    /**
     * Initialize field.
     */
    AddonModDataFieldFileComponent.prototype.init = function () {
        if (this.mode != 'search') {
            this.component = __WEBPACK_IMPORTED_MODULE_4__providers_data__["a" /* AddonModDataProvider */].COMPONENT;
            this.componentId = this.database.coursemodule;
            this.updateValue(this.value);
            if (this.mode == 'edit') {
                this.maxSizeBytes = parseInt(this.field.param3, 10);
                this.fileSessionprovider.setFiles(this.component, this.database.id + '_' + this.field.id, this.files);
            }
        }
        else {
            this.addControl('f_' + this.field.id);
        }
    };
    /**
     * Update value being shown.
     *
     * @param {any} value New value to be set.
     */
    AddonModDataFieldFileComponent.prototype.updateValue = function (value) {
        this.value = value;
        this.files = this.getFiles(value);
    };
    AddonModDataFieldFileComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-file',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\file\component\addon-mod-data-field-file.html"*/'<span *ngIf="mode == \'edit\'">\n    <span [core-mark-required]="field.required" class="core-mark-required"></span>\n    <core-attachments [files]="files" [maxSize]="maxSizeBytes" maxSubmissions="1" [component]="component" [componentId]="componentId" [allowOffline]="true"></core-attachments>\n    <core-input-errors *ngIf="error" [errorText]="error"></core-input-errors>\n</span>\n\n<span *ngIf="mode == \'search\'" [formGroup]="form">\n    <ion-input type="text" [formControlName]="\'f_\'+field.id" [placeholder]="field.name"></ion-input>\n</span>\n\n<ng-container *ngIf="isShowOrListMode()">\n    <div no-lines>\n        <ng-container *ngFor="let file of files">\n            <!-- Files already attached to the submission. -->\n            <core-file *ngIf="!file.name" [file]="file" [component]="component" [componentId]="componentId" [alwaysDownload]="true"></core-file>\n\n            <!-- Files stored in offline to be sent later. -->\n            <core-local-file *ngIf="file.name" [file]="file"></core-local-file>\n        </ng-container>\n    </div>\n</ng-container>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\file\component\addon-mod-data-field-file.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_3__providers_file_session__["a" /* CoreFileSessionProvider */]])
    ], AddonModDataFieldFileComponent);
    return AddonModDataFieldFileComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=file.js.map

/***/ }),
/* 943 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldLatlongComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.




/**
 * Component to render data latlong field.
 */
var AddonModDataFieldLatlongComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldLatlongComponent, _super);
    function AddonModDataFieldLatlongComponent(fb, platform) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.platform = platform;
        return _this;
    }
    /**
     * Format latitude and longitude in a simple text.
     *
     * @param  {number} north Degrees north.
     * @param  {number} east  Degrees East.
     * @return {string}       Readable Latitude and logitude.
     */
    AddonModDataFieldLatlongComponent.prototype.formatLatLong = function (north, east) {
        if (north !== null || east !== null) {
            var northFixed = north ? Math.abs(north).toFixed(4) : '0.0000', eastFixed = east ? Math.abs(east).toFixed(4) : '0.0000';
            return northFixed + (north < 0 ? '°S' : '°N') + ' ' + eastFixed + (east < 0 ? '°W' : '°E');
        }
    };
    /**
     * Get link to maps from latitude and longitude.
     *
     * @param  {number} north Degrees north.
     * @param  {number} east  Degrees East.
     * @return {string}       Link to maps depending on platform.
     */
    AddonModDataFieldLatlongComponent.prototype.getLatLongLink = function (north, east) {
        if (north !== null || east !== null) {
            var northFixed = north ? north.toFixed(4) : '0.0000', eastFixed = east ? east.toFixed(4) : '0.0000';
            if (this.platform.is('ios')) {
                return 'http://maps.apple.com/?ll=' + northFixed + ',' + eastFixed + '&near=' + northFixed + ',' + eastFixed;
            }
            return 'geo:' + northFixed + ',' + eastFixed;
        }
    };
    /**
     * Initialize field.
     */
    AddonModDataFieldLatlongComponent.prototype.init = function () {
        if (this.value) {
            this.updateValue(this.value);
        }
        if (this.mode == 'edit') {
            this.addControl('f_' + this.field.id + '_0', this.north);
            this.addControl('f_' + this.field.id + '_1', this.east);
        }
        else if (this.mode == 'search') {
            this.addControl('f_' + this.field.id);
        }
    };
    /**
     * Update value being shown.
     *
     * @param {any} value New value to be set.
     */
    AddonModDataFieldLatlongComponent.prototype.updateValue = function (value) {
        this.value = value;
        this.north = (value && parseFloat(value.content)) || null;
        this.east = (value && parseFloat(value.content1)) || null;
    };
    AddonModDataFieldLatlongComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-latlong',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\latlong\component\addon-mod-data-field-latlong.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <ion-input *ngIf="mode == \'search\'" type="text" [placeholder]="field.name" [formControlName]="\'f_\'+field.id"></ion-input>\n\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <div *ngIf="mode == \'edit\'" class="addon-data-lantlong">\n        <ion-input type="text" [formControlName]="\'f_\'+field.id+\'_0\'" maxlength="10"></ion-input>\n        <span class="placeholder-icon" item-right>°N</span>\n    </div>\n    <div *ngIf="mode == \'edit\'" class="addon-data-lantlong">\n        <ion-input type="text" [formControlName]="\'f_\'+field.id+\'_1\'" maxlength="10"></ion-input>\n        <span class="placeholder-icon" item-right>°E</span>\n    </div>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n</span>\n\n\n<span *ngIf="isShowOrListMode() && value">\n    <a [href]="getLatLongLink(north, east)">{{ formatLatLong(north, east) }}</a>\n</span>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\latlong\component\addon-mod-data-field-latlong.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["w" /* Platform */]])
    ], AddonModDataFieldLatlongComponent);
    return AddonModDataFieldLatlongComponent;
}(__WEBPACK_IMPORTED_MODULE_3__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=latlong.js.map

/***/ }),
/* 944 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldMenuComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Component to render data menu field.
 */
var AddonModDataFieldMenuComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldMenuComponent, _super);
    function AddonModDataFieldMenuComponent(fb) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.options = [];
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldMenuComponent.prototype.init = function () {
        if (this.isShowOrListMode()) {
            return;
        }
        this.options = this.field.param1.split('\n');
        var val;
        if (this.mode == 'edit' && this.value) {
            val = this.value.content;
        }
        this.addControl('f_' + this.field.id, val);
    };
    AddonModDataFieldMenuComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-menu',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\menu\component\addon-mod-data-field-menu.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-select [formControlName]="\'f_\'+field.id" [placeholder]="\'addon.mod_data.menuchoose\' | translate" [selectOptions]="{title: field.name}" interface="action-sheet">\n        <ion-option value="">{{ \'addon.mod_data.menuchoose\' | translate }}</ion-option>\n        <ion-option *ngFor="let option of options" [value]="option">{{option}}</ion-option>\n    </ion-select>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value && value.content" [text]="value.content"></core-format-text>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\menu\component\addon-mod-data-field-menu.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModDataFieldMenuComponent);
    return AddonModDataFieldMenuComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=menu.js.map

/***/ }),
/* 945 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldMultimenuComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Component to render data multimenu field.
 */
var AddonModDataFieldMultimenuComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldMultimenuComponent, _super);
    function AddonModDataFieldMultimenuComponent(fb) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.options = [];
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldMultimenuComponent.prototype.init = function () {
        var _this = this;
        if (this.isShowOrListMode()) {
            this.updateValue(this.value);
            return;
        }
        this.options = this.field.param1.split(/\r?\n/).map(function (option) {
            return { key: option, value: option };
        });
        var values = [];
        if (this.mode == 'edit' && this.value && this.value.content) {
            this.value.content.split('##').forEach(function (value) {
                var x = _this.options.findIndex(function (option) { return value == option.key; });
                if (x >= 0) {
                    values.push(value);
                }
            });
        }
        if (this.mode == 'search') {
            this.addControl('f_' + this.field.id + '_allreq');
        }
        this.addControl('f_' + this.field.id, values);
    };
    /**
     * Update value being shown.
     *
     * @param {any} value New value to be set.
     */
    AddonModDataFieldMultimenuComponent.prototype.updateValue = function (value) {
        this.value = value || {};
        this.value.content = value && value.content && value.content.split('##').join('<br>');
    };
    AddonModDataFieldMultimenuComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-multimenu',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\multimenu\component\addon-mod-data-field-multimenu.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-select [formControlName]="\'f_\'+field.id" multiple="true" [placeholder]="\'addon.mod_data.menuchoose\' | translate" [selectOptions]="{title: field.name}" interface="action-sheet">\n        <ion-option *ngFor="let option of options" [value]="option.value">{{option.key}}</ion-option>\n    </ion-select>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n\n\n    <ion-item *ngIf="mode == \'search\'">\n        <ion-label>{{ \'addon.mod_data.selectedrequired\' | translate }}</ion-label>\n        <ion-checkbox item-end [formControlName]="\'f_\'+field.id+\'_allreq\'" [(ngModel)]="search[\'f_\'+field.id+\'_allreq\']">\n        </ion-checkbox>\n    </ion-item>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value && value.content" [text]="value.content"></core-format-text>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\multimenu\component\addon-mod-data-field-multimenu.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModDataFieldMultimenuComponent);
    return AddonModDataFieldMultimenuComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=multimenu.js.map

/***/ }),
/* 946 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldTextComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Component to render data text field.
 */
var AddonModDataFieldTextComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldTextComponent, _super);
    function AddonModDataFieldTextComponent(fb) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldTextComponent.prototype.init = function () {
        if (this.isShowOrListMode()) {
            return;
        }
        var value;
        if (this.mode == 'edit' && this.value) {
            value = this.value.content;
        }
        this.addControl('f_' + this.field.id, value);
    };
    AddonModDataFieldTextComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-text',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\text\component\addon-mod-data-field-text.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-input type="text" [formControlName]="\'f_\'+field.id" [placeholder]="field.name"></ion-input>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value && value.content" [text]="value.content"></core-format-text>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\text\component\addon-mod-data-field-text.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModDataFieldTextComponent);
    return AddonModDataFieldTextComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=text.js.map

/***/ }),
/* 947 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldNumberComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Component to render data number field.
 */
var AddonModDataFieldNumberComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldNumberComponent, _super);
    function AddonModDataFieldNumberComponent(fb) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldNumberComponent.prototype.init = function () {
        if (this.isShowOrListMode()) {
            return;
        }
        var value;
        if (this.mode == 'edit' && this.value) {
            var v = parseFloat(this.value.content);
            value = isNaN(v) ? '' : v;
        }
        this.addControl('f_' + this.field.id, value);
    };
    AddonModDataFieldNumberComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-number',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\number\component\addon-mod-data-field-number.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-input type="number" [formControlName]="\'f_\'+field.id" [placeholder]="field.name"></ion-input>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value && value.content" [text]="value.content"></core-format-text>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\number\component\addon-mod-data-field-number.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModDataFieldNumberComponent);
    return AddonModDataFieldNumberComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=number.js.map

/***/ }),
/* 948 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldPictureComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_field_plugin_component__ = __webpack_require__(97);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_data__ = __webpack_require__(64);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.






/**
 * Component to render data picture field.
 */
var AddonModDataFieldPictureComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldPictureComponent, _super);
    function AddonModDataFieldPictureComponent(fb, fileSessionprovider, domUtils) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.fileSessionprovider = fileSessionprovider;
        _this.domUtils = domUtils;
        _this.files = [];
        return _this;
    }
    /**
     * Get the files from the input value.
     *
     * @param  {any} value Input value.
     * @return {any}     List of files.
     */
    AddonModDataFieldPictureComponent.prototype.getFiles = function (value) {
        var files = (value && value.files) || [];
        // Reduce to first element.
        if (files.length > 0) {
            files = [files[0]];
        }
        return files;
    };
    /**
     * Find file in a list.
     *
     * @param {any[]} files         File list where to search.
     * @param {string} filenameSeek Filename to search.
     * @return {any} File found or false.
     */
    AddonModDataFieldPictureComponent.prototype.findFile = function (files, filenameSeek) {
        return files.find(function (file) { return file.filename == filenameSeek; }) || false;
    };
    /**
     * Initialize field.
     */
    AddonModDataFieldPictureComponent.prototype.init = function () {
        if (this.mode != 'search') {
            this.component = __WEBPACK_IMPORTED_MODULE_5__providers_data__["a" /* AddonModDataProvider */].COMPONENT;
            this.componentId = this.database.coursemodule;
            this.updateValue(this.value);
            if (this.mode == 'edit') {
                this.maxSizeBytes = parseInt(this.field.param3, 10);
                this.fileSessionprovider.setFiles(this.component, this.database.id + '_' + this.field.id, this.files);
                var alttext = (this.value && this.value.content1) || '';
                this.addControl('f_' + this.field.id + '_alttext', alttext);
            }
        }
        else {
            this.addControl('f_' + this.field.id);
        }
    };
    /**
     * Update value being shown.
     *
     * @param {any} value New value to be set.
     */
    AddonModDataFieldPictureComponent.prototype.updateValue = function (value) {
        var _this = this;
        this.value = value;
        // Edit mode, the list shouldn't change so there is no need to watch it.
        var files = value && value.files || [];
        // Get image or thumb.
        if (files.length > 0) {
            var filenameSeek = this.mode == 'list' ? 'thumb_' + value.content : value.content;
            this.image = this.findFile(files, filenameSeek);
            if (!this.image && this.mode == 'list') {
                this.image = this.findFile(files, value.content);
            }
            this.files = [this.image];
        }
        else {
            this.image = false;
            this.files = [];
        }
        if (this.mode != 'edit') {
            this.entryId = (value && value.recordid) || null;
            this.title = (value && value.content1) || '';
            this.imageUrl = null;
            setTimeout(function () {
                if (_this.image) {
                    _this.imageUrl = _this.image.offline ? _this.image.toURL() : _this.image.fileurl;
                }
            }, 1);
            this.width = this.domUtils.formatPixelsSize(this.field.param1);
            this.height = this.domUtils.formatPixelsSize(this.field.param2);
        }
    };
    AddonModDataFieldPictureComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-picture',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\picture\component\addon-mod-data-field-picture.html"*/'<span *ngIf="mode == \'edit\'" [formGroup]="form">\n    <span [core-mark-required]="field.required" class="core-mark-required"></span>\n    <core-attachments [files]="files" [maxSize]="maxSizeBytes" maxSubmissions="1" [component]="component" [componentId]="componentId" [allowOffline]="true" acceptedTypes="image"></core-attachments>\n    <core-input-errors *ngIf="error" [errorText]="error"></core-input-errors>\n\n    <ion-label stacked>{{ \'addon.mod_data.alttext\' | translate }}</ion-label>\n    <ion-input type="text" [formControlName]="\'f_\'+field.id+\'_alttext\'" [placeholder]=" \'addon.mod_data.alttext\' | translate" ></ion-input>\n</span>\n\n<span *ngIf="mode == \'search\'" [formGroup]="form">\n    <ion-input type="text" [formControlName]="\'f_\'+field.id" [placeholder]="field.name"></ion-input>\n</span>\n\n<span *ngIf="mode == \'list\' && imageUrl" (click)="gotoEntry.emit(entryId)"><img [src]="imageUrl" [alt]="title" class="core-media-adapt-width list_picture" core-external-content/></span>\n\n<img *ngIf="mode == \'show\' && imageUrl" [src]="imageUrl" [alt]="title" class="core-media-adapt-width list_picture" [attr.width]="width" [attr.height]="height" core-external-content/>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\picture\component\addon-mod-data-field-picture.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_2__providers_file_session__["a" /* CoreFileSessionProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonModDataFieldPictureComponent);
    return AddonModDataFieldPictureComponent;
}(__WEBPACK_IMPORTED_MODULE_4__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=picture.js.map

/***/ }),
/* 949 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldRadiobuttonComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Component to render data radiobutton field.
 */
var AddonModDataFieldRadiobuttonComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldRadiobuttonComponent, _super);
    function AddonModDataFieldRadiobuttonComponent(fb) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.options = [];
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldRadiobuttonComponent.prototype.init = function () {
        if (this.isShowOrListMode()) {
            return;
        }
        this.options = this.field.param1.split('\n');
        var val;
        if (this.mode == 'edit' && this.value) {
            val = this.value.content;
        }
        this.addControl('f_' + this.field.id, val);
    };
    AddonModDataFieldRadiobuttonComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-radiobutton',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\radiobutton\component\addon-mod-data-field-radiobutton.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-select [formControlName]="\'f_\'+field.id" [placeholder]="\'addon.mod_data.menuchoose\' | translate" [selectOptions]="{title: field.name}" interface="action-sheet">\n        <ion-option value="">{{ \'addon.mod_data.menuchoose\' | translate }}</ion-option>\n        <ion-option *ngFor="let option of options" [value]="option">{{option}}</ion-option>\n    </ion-select>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value && value.content" [text]="value.content"></core-format-text>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\radiobutton\component\addon-mod-data-field-radiobutton.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModDataFieldRadiobuttonComponent);
    return AddonModDataFieldRadiobuttonComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=radiobutton.js.map

/***/ }),
/* 950 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldTextareaComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





/**
 * Component to render data number field.
 */
var AddonModDataFieldTextareaComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldTextareaComponent, _super);
    function AddonModDataFieldTextareaComponent(fb, textUtils) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        _this.textUtils = textUtils;
        return _this;
    }
    /**
     * Format value to be shown. Replacing plugin file Urls.
     *
     * @param  {any}    value Value to replace.
     * @return {string}       Replaced string to be rendered.
     */
    AddonModDataFieldTextareaComponent.prototype.format = function (value) {
        var files = (value && value.files) || [];
        return value ? this.textUtils.replacePluginfileUrls(value.content, files) : '';
    };
    /**
     * Initialize field.
     */
    AddonModDataFieldTextareaComponent.prototype.init = function () {
        if (this.isShowOrListMode()) {
            this.component = __WEBPACK_IMPORTED_MODULE_3__providers_data__["a" /* AddonModDataProvider */].COMPONENT;
            this.componentId = this.database.coursemodule;
            return;
        }
        var text;
        // Check if rich text editor is enabled.
        if (this.mode == 'edit') {
            var files = (this.value && this.value.files) || [];
            text = this.value ? this.textUtils.replacePluginfileUrls(this.value.content, files) : '';
        }
        this.addControl('f_' + this.field.id, text);
    };
    AddonModDataFieldTextareaComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-textarea',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\textarea\component\addon-mod-data-field-textarea.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <ion-input *ngIf="mode == \'search\'" type="text" [placeholder]="field.name" [formControlName]="\'f_\'+field.id"></ion-input>\n\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <core-rich-text-editor *ngIf="mode == \'edit\'" item-content [control]="form.controls[\'f_\'+field.id]" [placeholder]="field.name" [formControlName]="\'f_\'+field.id" [component]="component" [componentId]="componentId"></core-rich-text-editor>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n</span>\n\n<core-format-text *ngIf="isShowOrListMode() && value" [text]="format(value)" [component]="component" [componentId]="componentId"></core-format-text>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\textarea\component\addon-mod-data-field-textarea.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonModDataFieldTextareaComponent);
    return AddonModDataFieldTextareaComponent;
}(__WEBPACK_IMPORTED_MODULE_4__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=textarea.js.map

/***/ }),
/* 951 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldUrlComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__ = __webpack_require__(97);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Component to render data url field.
 */
var AddonModDataFieldUrlComponent = /** @class */ (function (_super) {
    __extends(AddonModDataFieldUrlComponent, _super);
    function AddonModDataFieldUrlComponent(fb) {
        var _this = _super.call(this, fb) || this;
        _this.fb = fb;
        return _this;
    }
    /**
     * Initialize field.
     */
    AddonModDataFieldUrlComponent.prototype.init = function () {
        if (this.isShowOrListMode()) {
            return;
        }
        var value;
        if (this.mode == 'edit' && this.value) {
            value = this.value.content;
        }
        this.addControl('f_' + this.field.id, value);
    };
    AddonModDataFieldUrlComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-url',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\url\component\addon-mod-data-field-url.html"*/'<span *ngIf="!isShowOrListMode()" [formGroup]="form">\n    <span *ngIf="mode == \'edit\'" [core-mark-required]="field.required" class="core-mark-required"></span>\n    <ion-input type="url" [formControlName]="\'f_\'+field.id" [placeholder]="field.name"></ion-input>\n    <core-input-errors *ngIf="error && mode == \'edit\'" [control]="form.controls[\'f_\'+field.id]" [errorText]="error"></core-input-errors>\n</span>\n\n<a *ngIf="isShowOrListMode() && value && value.content" [href]="value.content" core-link capture="true">{{value.content}}</a>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\fields\url\component\addon-mod-data-field-url.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */]])
    ], AddonModDataFieldUrlComponent);
    return AddonModDataFieldUrlComponent;
}(__WEBPACK_IMPORTED_MODULE_2__classes_field_plugin_component__["a" /* AddonModDataFieldPluginComponent */]));

//# sourceMappingURL=url.js.map

/***/ }),
/* 952 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLabelProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_site__ = __webpack_require__(25);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service that provides some features for labels.
 */
var AddonModLabelProvider = /** @class */ (function () {
    function AddonModLabelProvider(sitesProvider, filepoolProvider, utils) {
        this.sitesProvider = sitesProvider;
        this.filepoolProvider = filepoolProvider;
        this.utils = utils;
        this.ROOT_CACHE_KEY = 'mmaModLabel:';
    }
    AddonModLabelProvider_1 = AddonModLabelProvider;
    /**
     * Get cache key for label data WS calls.
     *
     * @param  {number} courseId Course ID.
     * @return {string} Cache key.
     */
    AddonModLabelProvider.prototype.getLabelDataCacheKey = function (courseId) {
        return this.ROOT_CACHE_KEY + 'label:' + courseId;
    };
    /**
     * Get a label with key=value. If more than one is found, only the first will be returned.
     *
     * @param {number} courseId Course ID.
     * @param {string} key Name of the property to check.
     * @param {any} value Value to search.
     * @param {boolean} [forceCache] True to always get the value from cache, false otherwise.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not provided, current site.
     * @return {Promise<any>} Promise resolved when the label is retrieved.
     */
    AddonModLabelProvider.prototype.getLabelByField = function (courseId, key, value, forceCache, ignoreCache, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var params = {
                courseids: [courseId]
            }, preSets = {
                cacheKey: _this.getLabelDataCacheKey(courseId),
                updateFrequency: __WEBPACK_IMPORTED_MODULE_4__classes_site__["a" /* CoreSite */].FREQUENCY_RARELY
            };
            if (forceCache) {
                preSets.omitExpires = true;
            }
            else if (ignoreCache) {
                preSets.getFromCache = false;
                preSets.emergencyCache = false;
            }
            return site.read('mod_label_get_labels_by_courses', params, preSets).then(function (response) {
                if (response && response.labels) {
                    var currentLabel = response.labels.find(function (label) { return label[key] == value; });
                    if (currentLabel) {
                        return currentLabel;
                    }
                }
                return Promise.reject(null);
            });
        });
    };
    /**
     * Get a label by course module ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} cmId Course module ID.
     * @param {boolean} [forceCache] True to always get the value from cache, false otherwise.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the label is retrieved.
     */
    AddonModLabelProvider.prototype.getLabel = function (courseId, cmId, forceCache, ignoreCache, siteId) {
        return this.getLabelByField(courseId, 'coursemodule', cmId, forceCache, ignoreCache, siteId);
    };
    /**
     * Get a label by ID.
     *
     * @param {number} courseId Course ID.
     * @param {number} labelId Label ID.
     * @param {boolean} [forceCache] True to always get the value from cache, false otherwise.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the label is retrieved.
     */
    AddonModLabelProvider.prototype.getLabelById = function (courseId, labelId, forceCache, ignoreCache, siteId) {
        return this.getLabelByField(courseId, 'id', labelId, forceCache, ignoreCache, siteId);
    };
    /**
     * Invalidate label data.
     *
     * @param {number} courseId Course ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLabelProvider.prototype.invalidateLabelData = function (courseId, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(null).then(function (site) {
            return site.invalidateWsCacheForKey(_this.getLabelDataCacheKey(courseId));
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param  {number} moduleId The module ID.
     * @param  {number} courseId Course ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when data is invalidated.
     */
    AddonModLabelProvider.prototype.invalidateContent = function (moduleId, courseId, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        var promises = [];
        promises.push(this.invalidateLabelData(courseId, siteId));
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, AddonModLabelProvider_1.COMPONENT, moduleId, true));
        return this.utils.allPromises(promises);
    };
    /**
     * Check if the site has the WS to get label data.
     *
     * @param  {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<boolean>} Promise resolved with boolean: whether it's available.
     * @since 3.3
     */
    AddonModLabelProvider.prototype.isGetLabelAvailable = function (siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.wsAvailable('mod_label_get_labels_by_courses');
        });
    };
    /**
     * Check if the site has the WS to get label data.
     *
     * @param  {CoreSite} [site] Site. If not defined, current site.
     * @return {boolean} Whether it's available.
     * @since 3.3
     */
    AddonModLabelProvider.prototype.isGetLabelAvailableForSite = function (site) {
        site = site || this.sitesProvider.getCurrentSite();
        return site.wsAvailable('mod_label_get_labels_by_courses');
    };
    AddonModLabelProvider.COMPONENT = 'mmaModLabel';
    AddonModLabelProvider = AddonModLabelProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonModLabelProvider);
    return AddonModLabelProvider;
    var AddonModLabelProvider_1;
}());

//# sourceMappingURL=label.js.map

/***/ }),
/* 953 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourDeferredFeedbackHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_question__ = __webpack_require__(76);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support deferred feedback question behaviour.
 */
var AddonQbehaviourDeferredFeedbackHandler = /** @class */ (function () {
    function AddonQbehaviourDeferredFeedbackHandler(questionDelegate, questionProvider) {
        this.questionDelegate = questionDelegate;
        this.questionProvider = questionProvider;
        this.name = 'AddonQbehaviourDeferredFeedback';
        this.type = 'deferredfeedback';
        // Nothing to do.
    }
    /**
     * Determine a question new state based on its answer(s).
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {CoreQuestionState|Promise<CoreQuestionState>} New state (or promise resolved with state).
     */
    AddonQbehaviourDeferredFeedbackHandler.prototype.determineNewState = function (component, attemptId, question, siteId) {
        return this.determineNewStateDeferred(component, attemptId, question, siteId);
    };
    /**
     * Determine a question new state based on its answer(s) for deferred question behaviour.
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {isCompleteResponseFunction} [isCompleteFn] Function to override the default isCompleteResponse check.
     * @param {isSameResponseFunction} [isSameFn] Function to override the default isSameResponse check.
     * @return {Promise<CoreQuestionState>} Promise resolved with state.
     */
    AddonQbehaviourDeferredFeedbackHandler.prototype.determineNewStateDeferred = function (component, attemptId, question, siteId, isCompleteFn, isSameFn) {
        var _this = this;
        // Check if we have local data for the question.
        return this.questionProvider.getQuestion(component, attemptId, question.slot, siteId).catch(function () {
            // No entry found, use the original data.
            return question;
        }).then(function (dbQuestion) {
            var state = _this.questionProvider.getState(dbQuestion.state);
            if (state.finished || !state.active) {
                // Question is finished, it cannot change.
                return state;
            }
            // We need to check if the answers have changed. Retrieve current stored answers.
            return _this.questionProvider.getQuestionAnswers(component, attemptId, question.slot, false, siteId)
                .then(function (prevAnswers) {
                var newBasicAnswers = _this.questionProvider.getBasicAnswers(question.answers);
                prevAnswers = _this.questionProvider.convertAnswersArrayToObject(prevAnswers, true);
                var prevBasicAnswers = _this.questionProvider.getBasicAnswers(prevAnswers);
                // If answers haven't changed the state is the same.
                if (isSameFn) {
                    if (isSameFn(question, prevAnswers, prevBasicAnswers, question.answers, newBasicAnswers)) {
                        return state;
                    }
                }
                else {
                    if (_this.questionDelegate.isSameResponse(question, prevBasicAnswers, newBasicAnswers)) {
                        return state;
                    }
                }
                // Answers have changed. Now check if the response is complete and calculate the new state.
                var complete, newState;
                if (isCompleteFn) {
                    // Pass all the answers since some behaviours might need the extra data.
                    complete = isCompleteFn(question, question.answers);
                }
                else {
                    // Only pass the basic answers since questions should be independent of extra data.
                    complete = _this.questionDelegate.isCompleteResponse(question, newBasicAnswers);
                }
                if (complete < 0) {
                    newState = 'cannotdeterminestatus';
                }
                else if (complete > 0) {
                    newState = 'complete';
                }
                else {
                    var gradable = _this.questionDelegate.isGradableResponse(question, newBasicAnswers);
                    if (gradable < 0) {
                        newState = 'cannotdeterminestatus';
                    }
                    else if (gradable > 0) {
                        newState = 'invalid';
                    }
                    else {
                        newState = 'todo';
                    }
                }
                return _this.questionProvider.getState(newState);
            });
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourDeferredFeedbackHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourDeferredFeedbackHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], AddonQbehaviourDeferredFeedbackHandler);
    return AddonQbehaviourDeferredFeedbackHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 954 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourInformationItemComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Component to render a "seen" hidden input for informationitem question behaviour.
 */
var AddonQbehaviourInformationItemComponent = /** @class */ (function () {
    function AddonQbehaviourInformationItemComponent() {
        // Nothing to do.
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonQbehaviourInformationItemComponent.prototype, "question", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonQbehaviourInformationItemComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonQbehaviourInformationItemComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonQbehaviourInformationItemComponent.prototype, "attemptId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonQbehaviourInformationItemComponent.prototype, "offlineEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonQbehaviourInformationItemComponent.prototype, "buttonClicked", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonQbehaviourInformationItemComponent.prototype, "onAbort", void 0);
    AddonQbehaviourInformationItemComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qbehaviour-informationitem',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qbehaviour\informationitem\component\addon-qbehaviour-informationitem.html"*/'<input *ngIf="question.behaviourSeenInput" type="hidden" name="{{question.behaviourSeenInput.name}}" value="{{question.behaviourSeenInput.value}}" >\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qbehaviour\informationitem\component\addon-qbehaviour-informationitem.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], AddonQbehaviourInformationItemComponent);
    return AddonQbehaviourInformationItemComponent;
}());

//# sourceMappingURL=informationitem.js.map

/***/ }),
/* 955 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMultichoiceHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_multichoice__ = __webpack_require__(279);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support multichoice question type.
 */
var AddonQtypeMultichoiceHandler = /** @class */ (function () {
    function AddonQtypeMultichoiceHandler(utils) {
        this.utils = utils;
        this.name = 'AddonQtypeMultichoice';
        this.type = 'qtype_multichoice';
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeMultichoiceHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_2__component_multichoice__["a" /* AddonQtypeMultichoiceComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeMultichoiceHandler.prototype.isCompleteResponse = function (question, answers) {
        var isSingle = true, isMultiComplete = false;
        // To know if it's single or multi answer we need to search for answers with "choice" in the name.
        for (var name_1 in answers) {
            if (name_1.indexOf('choice') != -1) {
                isSingle = false;
                if (answers[name_1]) {
                    isMultiComplete = true;
                }
            }
        }
        if (isSingle) {
            // Single.
            return this.isCompleteResponseSingle(answers);
        }
        else {
            // Multi.
            return isMultiComplete ? 1 : 0;
        }
    };
    /**
     * Check if a response is complete. Only for single answer.
     *
     * @param {any} question The question.uestion answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeMultichoiceHandler.prototype.isCompleteResponseSingle = function (answers) {
        return (answers['answer'] && answers['answer'] !== '') ? 1 : 0;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeMultichoiceHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeMultichoiceHandler.prototype.isGradableResponse = function (question, answers) {
        return this.isCompleteResponse(question, answers);
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted. Only for single answer.
     *
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeMultichoiceHandler.prototype.isGradableResponseSingle = function (answers) {
        return this.isCompleteResponseSingle(answers);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeMultichoiceHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        var isSingle = true, isMultiSame = true;
        // To know if it's single or multi answer we need to search for answers with "choice" in the name.
        for (var name_2 in newAnswers) {
            if (name_2.indexOf('choice') != -1) {
                isSingle = false;
                if (!this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, name_2)) {
                    isMultiSame = false;
                }
            }
        }
        if (isSingle) {
            return this.isSameResponseSingle(prevAnswers, newAnswers);
        }
        else {
            return isMultiSame;
        }
    };
    /**
     * Check if two responses are the same. Only for single answer.
     *
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeMultichoiceHandler.prototype.isSameResponseSingle = function (prevAnswers, newAnswers) {
        return this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, 'answer');
    };
    /**
     * Prepare and add to answers the data to send to server based in the input. Return promise if async.
     *
     * @param {any} question Question.
     * @param {any} answers The answers retrieved from the form. Prepared answers must be stored in this object.
     * @param {boolean} [offline] Whether the data should be saved in offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Return a promise resolved when done if async, void if sync.
     */
    AddonQtypeMultichoiceHandler.prototype.prepareAnswers = function (question, answers, offline, siteId) {
        if (question && !question.multi && typeof answers[question.optionsName] != 'undefined' && !answers[question.optionsName]) {
            /* It's a single choice and the user hasn't answered. Delete the answer because
               sending an empty string (default value) will mark the first option as selected. */
            delete answers[question.optionsName];
        }
    };
    AddonQtypeMultichoiceHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonQtypeMultichoiceHandler);
    return AddonQtypeMultichoiceHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 956 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdImageOrTextComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_ddimageortext__ = __webpack_require__(1863);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to render a drag-and-drop onto image question.
 */
var AddonQtypeDdImageOrTextComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeDdImageOrTextComponent, _super);
    function AddonQtypeDdImageOrTextComponent(loggerProvider, injector, element) {
        var _this = _super.call(this, loggerProvider, 'AddonQtypeDdImageOrTextComponent', injector) || this;
        _this.loggerProvider = loggerProvider;
        _this.destroyed = false;
        _this.element = element.nativeElement;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeDdImageOrTextComponent.prototype.ngOnInit = function () {
        if (!this.question) {
            this.logger.warn('Aborting because of no question received.');
            return this.questionHelper.showComponentError(this.onAbort);
        }
        var element = this.domUtils.convertToElement(this.question.html);
        // Get D&D area and question text.
        var ddArea = element.querySelector('.ddarea');
        this.question.text = this.domUtils.getContentsOfElement(element, '.qtext');
        if (!ddArea || typeof this.question.text == 'undefined') {
            this.logger.warn('Aborting because of an error parsing question.', this.question.name);
            return this.questionHelper.showComponentError(this.onAbort);
        }
        // Set the D&D area HTML.
        this.question.ddArea = ddArea.outerHTML;
        this.question.readOnly = false;
        if (this.question.initObjects) {
            // Moodle version <= 3.5.
            if (typeof this.question.initObjects.drops != 'undefined') {
                this.drops = this.question.initObjects.drops;
            }
            if (typeof this.question.initObjects.readonly != 'undefined') {
                this.question.readOnly = this.question.initObjects.readonly;
            }
        }
        else if (this.question.amdArgs) {
            // Moodle version >= 3.6.
            if (typeof this.question.amdArgs[1] != 'undefined') {
                this.question.readOnly = this.question.amdArgs[1];
            }
            if (typeof this.question.amdArgs[2] != 'undefined') {
                this.drops = this.question.amdArgs[2];
            }
        }
        this.question.loaded = false;
    };
    /**
     * The question has been rendered.
     */
    AddonQtypeDdImageOrTextComponent.prototype.questionRendered = function () {
        if (!this.destroyed) {
            // Create the instance.
            this.questionInstance = new __WEBPACK_IMPORTED_MODULE_3__classes_ddimageortext__["a" /* AddonQtypeDdImageOrTextQuestion */](this.loggerProvider, this.domUtils, this.element, this.question, this.question.readOnly, this.drops);
        }
    };
    /**
     * Component being destroyed.
     */
    AddonQtypeDdImageOrTextComponent.prototype.ngOnDestroy = function () {
        this.destroyed = true;
        this.questionInstance && this.questionInstance.destroy();
    };
    AddonQtypeDdImageOrTextComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-ddimageortext',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\ddimageortext\component\addon-qtype-ddimageortext.html"*/'<section ion-list *ngIf="question.text || question.text === \'\'" class="addon-qtype-ddimageortext-container">\n    <!-- Content is outside the core-loading to let the script calculate drag items position -->\n    <core-loading [hideUntil]="question.loaded"></core-loading>\n\n    <ion-item text-wrap [ngClass]="{invisible: !question.loaded}">\n        <p *ngIf="!question.readOnly" class="core-info-card" icon-start>\n            <ion-icon name="information-circle"></ion-icon>\n            {{ \'core.question.howtodraganddrop\' | translate }}\n        </p>\n        <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.text"></core-format-text></p>\n        <core-format-text *ngIf="question.ddArea" [adaptImg]="false" [component]="component" [componentId]="componentId" [text]="question.ddArea" (afterRender)="questionRendered()"></core-format-text>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\ddimageortext\component\addon-qtype-ddimageortext.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], AddonQtypeDdImageOrTextComponent);
    return AddonQtypeDdImageOrTextComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=ddimageortext.js.map

/***/ }),
/* 957 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdMarkerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_ddmarker__ = __webpack_require__(1866);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component to render a drag-and-drop markers question.
 */
var AddonQtypeDdMarkerComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeDdMarkerComponent, _super);
    function AddonQtypeDdMarkerComponent(loggerProvider, injector, element, sitesProvider, urlUtils, filepoolProvider) {
        var _this = _super.call(this, loggerProvider, 'AddonQtypeDdMarkerComponent', injector) || this;
        _this.loggerProvider = loggerProvider;
        _this.sitesProvider = sitesProvider;
        _this.urlUtils = urlUtils;
        _this.filepoolProvider = filepoolProvider;
        _this.destroyed = false;
        _this.element = element.nativeElement;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeDdMarkerComponent.prototype.ngOnInit = function () {
        if (!this.question) {
            this.logger.warn('Aborting because of no question received.');
            return this.questionHelper.showComponentError(this.onAbort);
        }
        var element = this.domUtils.convertToElement(this.question.html);
        // Get D&D area, form and question text.
        var ddArea = element.querySelector('.ddarea'), ddForm = element.querySelector('.ddform');
        this.question.text = this.domUtils.getContentsOfElement(element, '.qtext');
        if (!ddArea || !ddForm || typeof this.question.text == 'undefined') {
            this.logger.warn('Aborting because of an error parsing question.', this.question.name);
            return this.questionHelper.showComponentError(this.onAbort);
        }
        // Build the D&D area HTML.
        this.question.ddArea = ddArea.outerHTML;
        var wrongParts = element.querySelector('.wrongparts');
        if (wrongParts) {
            this.question.ddArea += wrongParts.outerHTML;
        }
        this.question.ddArea += ddForm.outerHTML;
        this.question.readOnly = false;
        if (this.question.initObjects) {
            // Moodle version <= 3.5.
            if (typeof this.question.initObjects.dropzones != 'undefined') {
                this.dropZones = this.question.initObjects.dropzones;
            }
            if (typeof this.question.initObjects.readonly != 'undefined') {
                this.question.readOnly = this.question.initObjects.readonly;
            }
        }
        else if (this.question.amdArgs) {
            // Moodle version >= 3.6.
            if (typeof this.question.amdArgs[1] != 'undefined') {
                this.imgSrc = this.question.amdArgs[1];
            }
            if (typeof this.question.amdArgs[2] != 'undefined') {
                this.question.readOnly = this.question.amdArgs[2];
            }
            if (typeof this.question.amdArgs[3] != 'undefined') {
                this.dropZones = this.question.amdArgs[3];
            }
        }
        this.question.loaded = false;
    };
    /**
     * The question has been rendered.
     */
    AddonQtypeDdMarkerComponent.prototype.questionRendered = function () {
        var _this = this;
        if (!this.destroyed) {
            // Download background image (3.6+ sites).
            var promise = null;
            var site = this.sitesProvider.getCurrentSite();
            if (this.imgSrc && site.canDownloadFiles() && this.urlUtils.isPluginFileUrl(this.imgSrc)) {
                promise = this.filepoolProvider.getSrcByUrl(site.id, this.imgSrc, this.component, this.componentId, 0, true, true);
            }
            else {
                promise = Promise.resolve(this.imgSrc);
            }
            promise.then(function (imgSrc) {
                _this.domUtils.waitForImages(_this.questionTextEl.nativeElement).then(function () {
                    // Create the instance.
                    _this.questionInstance = new __WEBPACK_IMPORTED_MODULE_6__classes_ddmarker__["a" /* AddonQtypeDdMarkerQuestion */](_this.loggerProvider, _this.domUtils, _this.textUtils, _this.element, _this.question, _this.question.readOnly, _this.dropZones, imgSrc);
                });
            });
        }
    };
    /**
     * Component being destroyed.
     */
    AddonQtypeDdMarkerComponent.prototype.ngOnDestroy = function () {
        this.destroyed = true;
        this.questionInstance && this.questionInstance.destroy();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('questiontext'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], AddonQtypeDdMarkerComponent.prototype, "questionTextEl", void 0);
    AddonQtypeDdMarkerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-ddmarker',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\ddmarker\component\addon-qtype-ddmarker.html"*/'<section ion-list *ngIf="question.text || question.text === \'\'" class="addon-qtype-ddmarker-container">\n    <!-- Content is outside the core-loading to let the script calculate drag items position -->\n    <core-loading [hideUntil]="question.loaded"></core-loading>\n\n    <ion-item text-wrap [ngClass]="{invisible: !question.loaded}">\n        <p *ngIf="!question.readOnly" class="core-info-card" icon-start>\n            <ion-icon name="information-circle"></ion-icon>\n            {{ \'core.question.howtodraganddrop\' | translate }}\n        </p>\n        <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.text" #questiontext></core-format-text></p>\n        <core-format-text *ngIf="question.ddArea" [adaptImg]="false" [component]="component" [componentId]="componentId" [text]="question.ddArea" (afterRender)="questionRendered()"></core-format-text>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\ddmarker\component\addon-qtype-ddmarker.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */]])
    ], AddonQtypeDdMarkerComponent);
    return AddonQtypeDdMarkerComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=ddmarker.js.map

/***/ }),
/* 958 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdwtosComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__classes_ddwtos__ = __webpack_require__(1870);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to render a drag-and-drop words into sentences question.
 */
var AddonQtypeDdwtosComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeDdwtosComponent, _super);
    function AddonQtypeDdwtosComponent(loggerProvider, injector, element) {
        var _this = _super.call(this, loggerProvider, 'AddonQtypeDdwtosComponent', injector) || this;
        _this.loggerProvider = loggerProvider;
        _this.inputIds = []; // Ids of the inputs of the question (where the answers will be stored).
        _this.destroyed = false;
        _this.element = element.nativeElement;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeDdwtosComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this.question) {
            this.logger.warn('Aborting because of no question received.');
            return this.questionHelper.showComponentError(this.onAbort);
        }
        var element = this.domUtils.convertToElement(this.question.html);
        // Replace Moodle's correct/incorrect and feedback classes with our own.
        this.questionHelper.replaceCorrectnessClasses(element);
        this.questionHelper.replaceFeedbackClasses(element);
        // Treat the correct/incorrect icons.
        this.questionHelper.treatCorrectnessIcons(element);
        var answerContainer = element.querySelector('.answercontainer');
        if (!answerContainer) {
            this.logger.warn('Aborting because of an error parsing question.', this.question.name);
            return this.questionHelper.showComponentError(this.onAbort);
        }
        this.question.readOnly = answerContainer.classList.contains('readonly');
        this.question.answers = answerContainer.outerHTML;
        this.question.text = this.domUtils.getContentsOfElement(element, '.qtext');
        if (typeof this.question.text == 'undefined') {
            this.logger.warn('Aborting because of an error parsing question.', this.question.name);
            return this.questionHelper.showComponentError(this.onAbort);
        }
        // Get the inputs where the answers will be stored and add them to the question text.
        var inputEls = Array.from(element.querySelectorAll('input[type="hidden"]:not([name*=sequencecheck])'));
        inputEls.forEach(function (inputEl) {
            _this.question.text += inputEl.outerHTML;
            _this.inputIds.push(inputEl.getAttribute('id'));
        });
        this.question.loaded = false;
    };
    /**
     * The question has been rendered.
     */
    AddonQtypeDdwtosComponent.prototype.questionRendered = function () {
        var _this = this;
        if (!this.destroyed) {
            this.domUtils.waitForImages(this.questionTextEl.nativeElement).then(function () {
                // Create the instance.
                _this.questionInstance = new __WEBPACK_IMPORTED_MODULE_3__classes_ddwtos__["a" /* AddonQtypeDdwtosQuestion */](_this.loggerProvider, _this.domUtils, _this.element, _this.question, _this.question.readOnly, _this.inputIds, _this.textUtils);
                _this.questionHelper.treatCorrectnessIconsClicks(_this.element, _this.component, _this.componentId);
                _this.question.loaded = true;
            });
        }
    };
    /**
     * Component being destroyed.
     */
    AddonQtypeDdwtosComponent.prototype.ngOnDestroy = function () {
        this.destroyed = true;
        this.questionInstance && this.questionInstance.destroy();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('questiontext'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], AddonQtypeDdwtosComponent.prototype, "questionTextEl", void 0);
    AddonQtypeDdwtosComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-ddwtos',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\ddwtos\component\addon-qtype-ddwtos.html"*/'<section ion-list *ngIf="question.text || question.text === \'\'">\n    <!-- Content is outside the core-loading to let the script calculate drag items position -->\n    <core-loading [hideUntil]="question.loaded"></core-loading>\n\n    <ion-item text-wrap class="addon-qtype-ddwtos-container" [ngClass]="{invisible: !question.loaded}">\n        <p *ngIf="!question.readOnly" class="core-info-card" icon-start>\n            <ion-icon name="information-circle"></ion-icon>\n            {{ \'core.question.howtodraganddrop\' | translate }}\n        </p>\n        <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.text" #questiontext></core-format-text></p>\n        <core-format-text *ngIf="question.answers" [component]="component" [componentId]="componentId" [text]="question.answers" (afterRender)="questionRendered()"></core-format-text>\n        <div class="drags"></div>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\ddwtos\component\addon-qtype-ddwtos.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], AddonQtypeDdwtosComponent);
    return AddonQtypeDdwtosComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=ddwtos.js.map

/***/ }),
/* 959 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDescriptionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to render a description question.
 */
var AddonQtypeDescriptionComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeDescriptionComponent, _super);
    function AddonQtypeDescriptionComponent(logger, injector) {
        return _super.call(this, logger, 'AddonQtypeDescriptionComponent', injector) || this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeDescriptionComponent.prototype.ngOnInit = function () {
        var questionEl = this.initComponent();
        if (questionEl) {
            // Get the "seen" hidden input.
            var input = questionEl.querySelector('input[type="hidden"][name*=seen]');
            if (input) {
                this.question.seenInput = {
                    name: input.name,
                    value: input.value
                };
            }
        }
    };
    AddonQtypeDescriptionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-description',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\description\component\addon-qtype-description.html"*/'<section ion-list *ngIf="question.text || question.text === \'\'">\n    <!-- "Seen" hidden input -->\n    <input *ngIf="question.seenInput" type="hidden" [name]="question.seenInput.name" [value]="question.seenInput.value" >\n    <ion-item text-wrap class="item item-text-wrap">\n        <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.text"></core-format-text></p>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\description\component\addon-qtype-description.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonQtypeDescriptionComponent);
    return AddonQtypeDescriptionComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=description.js.map

/***/ }),
/* 960 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeEssayComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_forms__ = __webpack_require__(24);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to render an essay question.
 */
var AddonQtypeEssayComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeEssayComponent, _super);
    function AddonQtypeEssayComponent(logger, injector, fb) {
        var _this = _super.call(this, logger, 'AddonQtypeEssayComponent', injector) || this;
        _this.fb = fb;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeEssayComponent.prototype.ngOnInit = function () {
        this.initEssayComponent();
        this.formControl = this.fb.control(this.question.textarea && this.question.textarea.text);
    };
    AddonQtypeEssayComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-essay',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\essay\component\addon-qtype-essay.html"*/'<section ion-list *ngIf="question.text || question.text === \'\'">\n    <!-- Question text. -->\n    <ion-item text-wrap>\n        <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.text"></core-format-text></p>\n    </ion-item>\n\n    <!-- Textarea. -->\n    <ion-item *ngIf="question.textarea && !question.hasDraftFiles">\n        <!-- "Format" hidden input -->\n        <input item-content *ngIf="question.formatInput" type="hidden" [name]="question.formatInput.name" [value]="question.formatInput.value" >\n        <!-- Plain text textarea. -->\n        <ion-textarea *ngIf="question.isPlainText" class="core-question-textarea" [ngClass]=\'{"core-monospaced": question.isMonospaced}\' placeholder="{{ \'core.question.answer\' | translate }}" [attr.name]="question.textarea.name" aria-multiline="true" [ngModel]="question.textarea.text"></ion-textarea>\n        <!-- Rich text editor. -->\n        <core-rich-text-editor item-content *ngIf="!question.isPlainText" placeholder="{{ \'core.question.answer\' | translate }}" [control]="formControl" [name]="question.textarea.name" [component]="component" [componentId]="componentId"></core-rich-text-editor>\n    </ion-item>\n\n    <!-- Draft files not supported. -->\n    <ng-container *ngIf="question.textarea && question.hasDraftFiles">\n        <ion-item text-wrap class="core-danger-item">\n            <p class="core-question-warning">{{ \'core.question.errorinlinefilesnotsupported\' | translate }}</p>\n        </ion-item>\n        <ion-item text-wrap>\n            <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.textarea.text"></core-format-text></p>\n        </ion-item>\n    </ng-container>\n\n    <!-- Attachments not supported in the app yet. -->\n    <ion-item text-wrap *ngIf="question.allowsAttachments" class="core-danger-item">\n        <p class="core-question-warning">{{ \'core.question.errorattachmentsnotsupported\' | translate }}</p>\n    </ion-item>\n\n    <!-- Answer to the question and attachments (reviewing). -->\n    <ion-item text-wrap *ngIf="!question.textarea && (question.answer || (!question.attachments.length && !question.allowsAttachments))">\n        <p><core-format-text [ngClass]=\'{"core-monospaced": question.isMonospaced}\' [component]="component" [componentId]="componentId" [text]="question.answer"></core-format-text></p>\n    </ion-item>\n\n    <ion-item *ngIf="!question.textarea && question.attachments && question.attachments.length">\n        <div no-lines>\n            <core-file *ngFor="let attachment of question.attachments" [file]="attachment" [component]="component" [componentId]="componentId"></core-file>\n        </div>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\essay\component\addon-qtype-essay.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_3__angular_forms__["a" /* FormBuilder */]])
    ], AddonQtypeEssayComponent);
    return AddonQtypeEssayComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=essay.js.map

/***/ }),
/* 961 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeGapSelectComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to render a gap select question.
 */
var AddonQtypeGapSelectComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeGapSelectComponent, _super);
    function AddonQtypeGapSelectComponent(logger, injector, element) {
        var _this = _super.call(this, logger, 'AddonQtypeGapSelectComponent', injector) || this;
        _this.element = element.nativeElement;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeGapSelectComponent.prototype.ngOnInit = function () {
        this.initOriginalTextComponent('.qtext');
    };
    /**
     * The question has been rendered.
     */
    AddonQtypeGapSelectComponent.prototype.questionRendered = function () {
        this.questionHelper.treatCorrectnessIconsClicks(this.element, this.component, this.componentId);
    };
    AddonQtypeGapSelectComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-gapselect',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\gapselect\component\addon-qtype-gapselect.html"*/'<section ion-list class="addon-qtype-gapselect-container" *ngIf="question.text || question.text === \'\'">\n    <ion-item text-wrap>\n        <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.text" (afterRender)="questionRendered()"></core-format-text></p>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\gapselect\component\addon-qtype-gapselect.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], AddonQtypeGapSelectComponent);
    return AddonQtypeGapSelectComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=gapselect.js.map

/***/ }),
/* 962 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMatchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_match__ = __webpack_require__(407);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support match question type.
 */
var AddonQtypeMatchHandler = /** @class */ (function () {
    function AddonQtypeMatchHandler(questionProvider) {
        this.questionProvider = questionProvider;
        this.name = 'AddonQtypeMatch';
        this.type = 'qtype_match';
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeMatchHandler.prototype.getBehaviour = function (question, behaviour) {
        if (behaviour === 'interactive') {
            return 'interactivecountback';
        }
        return behaviour;
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeMatchHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_2__component_match__["a" /* AddonQtypeMatchComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeMatchHandler.prototype.isCompleteResponse = function (question, answers) {
        // We should always get a value for each select so we can assume we receive all the possible answers.
        for (var name_1 in answers) {
            var value = answers[name_1];
            if (!value || value === '0') {
                return 0;
            }
        }
        return 1;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeMatchHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeMatchHandler.prototype.isGradableResponse = function (question, answers) {
        // We should always get a value for each select so we can assume we receive all the possible answers.
        for (var name_2 in answers) {
            var value = answers[name_2];
            if (value && value !== '0') {
                return 1;
            }
        }
        return 0;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeMatchHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.questionProvider.compareAllAnswers(prevAnswers, newAnswers);
    };
    AddonQtypeMatchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], AddonQtypeMatchHandler);
    return AddonQtypeMatchHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 963 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMultiAnswerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to render a multianswer question.
 */
var AddonQtypeMultiAnswerComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeMultiAnswerComponent, _super);
    function AddonQtypeMultiAnswerComponent(logger, injector, element) {
        var _this = _super.call(this, logger, 'AddonQtypeMultiAnswerComponent', injector) || this;
        _this.element = element.nativeElement;
        return _this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeMultiAnswerComponent.prototype.ngOnInit = function () {
        this.initOriginalTextComponent('.formulation');
    };
    /**
     * The question has been rendered.
     */
    AddonQtypeMultiAnswerComponent.prototype.questionRendered = function () {
        this.questionHelper.treatCorrectnessIconsClicks(this.element, this.component, this.componentId);
    };
    AddonQtypeMultiAnswerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-multianswer',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\multianswer\component\addon-qtype-multianswer.html"*/'<section ion-list class="addon-qtype-multianswer-container" *ngIf="question.text || question.text === \'\'">\n    <ion-item text-wrap>\n        <core-format-text [component]="component" [componentId]="componentId" [text]="question.text" (afterRender)="questionRendered()"></core-format-text>\n    </ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\multianswer\component\addon-qtype-multianswer.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], AddonQtypeMultiAnswerComponent);
    return AddonQtypeMultiAnswerComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=multianswer.js.map

/***/ }),
/* 964 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeShortAnswerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__ = __webpack_require__(108);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to render a short answer question.
 */
var AddonQtypeShortAnswerComponent = /** @class */ (function (_super) {
    __extends(AddonQtypeShortAnswerComponent, _super);
    function AddonQtypeShortAnswerComponent(logger, injector) {
        return _super.call(this, logger, 'AddonQtypeShortAnswerComponent', injector) || this;
    }
    /**
     * Component being initialized.
     */
    AddonQtypeShortAnswerComponent.prototype.ngOnInit = function () {
        this.initInputTextComponent();
    };
    AddonQtypeShortAnswerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-qtype-shortanswer',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\shortanswer\component\addon-qtype-shortanswer.html"*/'<section ion-list *ngIf="question.text || question.text === \'\'">\n    <ion-item text-wrap class="addon-qtype-shortanswer-text">\n        <core-format-text [component]="component" [componentId]="componentId" [text]="question.text"></core-format-text>\n    </ion-item>\n    <ion-item *ngIf="!question.input.isInline" text-wrap ngClass="core-{{question.input.correctIconColor}}-item">\n        <ion-label stacked>{{ \'addon.mod_quiz.answercolon\' | translate }}</ion-label>\n        <ion-input padding-left type="text" [placeholder]="question.input.readOnly ? \'\' : \'core.question.answer\' | translate" [attr.name]="question.input.name" [value]="question.input.value" autocorrect="off" [disabled]="question.input.readOnly">\n        </ion-input>\n        <core-icon *ngIf="question.input.correctIcon" class="core-correct-icon" item-content item-end [name]="question.input.correctIcon" [color]="[question.input.correctIconColor]"></core-icon>\n</ion-item>\n</section>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\qtype\shortanswer\component\addon-qtype-shortanswer.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], AddonQtypeShortAnswerComponent);
    return AddonQtypeShortAnswerComponent;
}(__WEBPACK_IMPORTED_MODULE_2__core_question_classes_base_question_component__["a" /* CoreQuestionBaseComponent */]));

//# sourceMappingURL=shortanswer.js.map

/***/ }),
/* 965 */,
/* 966 */,
/* 967 */,
/* 968 */,
/* 969 */,
/* 970 */,
/* 971 */,
/* 972 */,
/* 973 */,
/* 974 */,
/* 975 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(431);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModFeedbackComponentsModule = /** @class */ (function () {
    function AddonModFeedbackComponentsModule() {
    }
    AddonModFeedbackComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModFeedbackIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModFeedbackIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModFeedbackIndexComponent */]
            ]
        })
    ], AddonModFeedbackComponentsModule);
    return AddonModFeedbackComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 976 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__index_index__ = __webpack_require__(421);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__submission_submission__ = __webpack_require__(422);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__submission_plugin_submission_plugin__ = __webpack_require__(771);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__feedback_plugin_feedback_plugin__ = __webpack_require__(1431);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};












var AddonModAssignComponentsModule = /** @class */ (function () {
    function AddonModAssignComponentsModule() {
    }
    AddonModAssignComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModAssignIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__submission_submission__["a" /* AddonModAssignSubmissionComponent */],
                __WEBPACK_IMPORTED_MODULE_10__submission_plugin_submission_plugin__["a" /* AddonModAssignSubmissionPluginComponent */],
                __WEBPACK_IMPORTED_MODULE_11__feedback_plugin_feedback_plugin__["a" /* AddonModAssignFeedbackPluginComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModAssignIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__submission_submission__["a" /* AddonModAssignSubmissionComponent */],
                __WEBPACK_IMPORTED_MODULE_10__submission_plugin_submission_plugin__["a" /* AddonModAssignSubmissionPluginComponent */],
                __WEBPACK_IMPORTED_MODULE_11__feedback_plugin_feedback_plugin__["a" /* AddonModAssignFeedbackPluginComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModAssignIndexComponent */]
            ]
        })
    ], AddonModAssignComponentsModule);
    return AddonModAssignComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 977 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChatComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(424);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModChatComponentsModule = /** @class */ (function () {
    function AddonModChatComponentsModule() {
    }
    AddonModChatComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModChatIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModChatIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModChatIndexComponent */]
            ]
        })
    ], AddonModChatComponentsModule);
    return AddonModChatComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 978 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCalendarHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Service that provides some features regarding lists of courses and categories.
 */
var AddonCalendarHelperProvider = /** @class */ (function () {
    function AddonCalendarHelperProvider(logger, courseProvider) {
        this.courseProvider = courseProvider;
        this.EVENTICONS = {
            course: 'fa-university',
            group: 'people',
            site: 'globe',
            user: 'person',
            category: 'fa-cubes'
        };
        this.logger = logger.getInstance('AddonCalendarHelperProvider');
    }
    /**
     * Convenience function to format some event data to be rendered.
     *
     * @param {any} e Event to format.
     */
    AddonCalendarHelperProvider.prototype.formatEventData = function (e) {
        e.icon = this.EVENTICONS[e.eventtype] || false;
        if (!e.icon) {
            e.icon = this.courseProvider.getModuleIconSrc(e.modulename);
            e.moduleIcon = e.icon;
        }
    };
    AddonCalendarHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonCalendarHelperProvider);
    return AddonCalendarHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 979 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__course_course__ = __webpack_require__(784);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__pipes_pipes_module__ = __webpack_require__(63);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var CoreGradesComponentsModule = /** @class */ (function () {
    function CoreGradesComponentsModule() {
    }
    CoreGradesComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__course_course__["a" /* CoreGradesCourseComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_7__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__course_course__["a" /* CoreGradesCourseComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__course_course__["a" /* CoreGradesCourseComponent */]
            ]
        })
    ], CoreGradesComponentsModule);
    return CoreGradesComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 980 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreMainMenuProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__configconstants__ = __webpack_require__(66);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Service that provides some features regarding Main Menu.
 */
var CoreMainMenuProvider = /** @class */ (function () {
    function CoreMainMenuProvider(langProvider, sitesProvider) {
        this.langProvider = langProvider;
        this.sitesProvider = sitesProvider;
        this.tablet = false;
        this.tablet = window && window.innerWidth && window.innerWidth >= 576 && window.innerHeight >= 576;
    }
    CoreMainMenuProvider_1 = CoreMainMenuProvider;
    /**
     * Get a list of custom menu items for a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<CoreMainMenuCustomItem[]>} List of custom menu items.
     */
    CoreMainMenuProvider.prototype.getCustomMenuItems = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var itemsString = site.getStoredConfig('tool_mobile_custommenuitems'), map = {}, result = [];
            var items, position = 0; // Position of each item, to keep the same order as it's configured.
            if (!itemsString || typeof itemsString != 'string') {
                // Setting not valid.
                return result;
            }
            // Add items to the map.
            items = itemsString.split(/(?:\r\n|\r|\n)/);
            items.forEach(function (item) {
                var values = item.split('|'), label = values[0] ? values[0].trim() : values[0], url = values[1] ? values[1].trim() : values[1], type = values[2] ? values[2].trim() : values[2], lang = (values[3] ? values[3].trim() : values[3]) || 'none';
                var id, icon = values[4] ? values[4].trim() : values[4];
                if (!label || !url || !type) {
                    // Invalid item, ignore it.
                    return;
                }
                id = url + '#' + type;
                if (!icon) {
                    // Icon not defined, use default one.
                    icon = type == 'embedded' ? 'qr-scanner' : 'link';
                }
                if (!map[id]) {
                    // New entry, add it to the map.
                    map[id] = {
                        url: url,
                        type: type,
                        position: position,
                        labels: {}
                    };
                    position++;
                }
                map[id].labels[lang.toLowerCase()] = {
                    label: label,
                    icon: icon
                };
            });
            if (!position) {
                // No valid items found, stop.
                return result;
            }
            return _this.langProvider.getCurrentLanguage().then(function (currentLang) {
                var fallbackLang = __WEBPACK_IMPORTED_MODULE_3__configconstants__["a" /* CoreConfigConstants */].default_lang || 'en';
                // Get the right label for each entry and add it to the result.
                for (var id in map) {
                    var entry = map[id];
                    var data = entry.labels[currentLang] || entry.labels[currentLang + '_only'] ||
                        entry.labels.none || entry.labels[fallbackLang];
                    if (!data) {
                        // No valid label found, get the first one that is not "_only".
                        for (var lang in entry.labels) {
                            if (lang.indexOf('_only') == -1) {
                                data = entry.labels[lang];
                                break;
                            }
                        }
                        if (!data) {
                            // No valid label, ignore this entry.
                            continue;
                        }
                    }
                    result[entry.position] = {
                        url: entry.url,
                        type: entry.type,
                        label: data.label,
                        icon: data.icon
                    };
                }
                // Remove undefined values.
                return result.filter(function (entry) {
                    return typeof entry != 'undefined';
                });
            });
        });
    };
    /**
     * Get the number of items to be shown on the main menu bar.
     *
     * @return {number} Number of items depending on the device width.
     */
    CoreMainMenuProvider.prototype.getNumItems = function () {
        if (!this.isResponsiveMainMenuItemsDisabledInCurrentSite() && window && window.innerWidth) {
            var numElements = void 0;
            if (this.tablet) {
                // Tablet, menu will be displayed vertically.
                numElements = Math.floor(window.innerHeight / CoreMainMenuProvider_1.ITEM_MIN_WIDTH);
            }
            else {
                numElements = Math.floor(window.innerWidth / CoreMainMenuProvider_1.ITEM_MIN_WIDTH);
                // Set a maximum elements to show and skip more button.
                numElements = numElements >= 5 ? 5 : numElements;
            }
            // Set a mínimum elements to show and skip more button.
            return numElements > 1 ? numElements - 1 : 1;
        }
        return CoreMainMenuProvider_1.NUM_MAIN_HANDLERS;
    };
    /**
     * Get tabs placement depending on the device size.
     *
     * @param  {NavController} navCtrl  NavController to resize the content.
     * @return {string}                Tabs placement including side value.
     */
    CoreMainMenuProvider.prototype.getTabPlacement = function (navCtrl) {
        var tablet = window && window.innerWidth && window.innerWidth >= 576 && window.innerHeight >= 576;
        if (tablet != this.tablet) {
            this.tablet = tablet;
            // Resize so content margins can be updated.
            setTimeout(function () {
                navCtrl.resize();
            }, 500);
        }
        return tablet ? 'side' : 'bottom';
    };
    /**
     * Check if responsive main menu items is disabled in the current site.
     *
     * @return {boolean} Whether it's disabled.
     */
    CoreMainMenuProvider.prototype.isResponsiveMainMenuItemsDisabledInCurrentSite = function () {
        var site = this.sitesProvider.getCurrentSite();
        return site && site.isFeatureDisabled('NoDelegate_ResponsiveMainMenuItems');
    };
    CoreMainMenuProvider.NUM_MAIN_HANDLERS = 4;
    CoreMainMenuProvider.ITEM_MIN_WIDTH = 72; // Min with of every item, based on 5 items on a 360 pixel wide screen.
    CoreMainMenuProvider = CoreMainMenuProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreMainMenuProvider);
    return CoreMainMenuProvider;
    var CoreMainMenuProvider_1;
}());

//# sourceMappingURL=mainmenu.js.map

/***/ }),
/* 981 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Service that provides some features regarding users information.
 */
var CoreUserHelperProvider = /** @class */ (function () {
    function CoreUserHelperProvider(logger, translate) {
        this.translate = translate;
        this.logger = logger.getInstance('CoreUserHelperProvider');
    }
    /**
     * Formats a user address, concatenating address, city and country.
     *
     * @param {string} address Address.
     * @param {string} city    City.
     * @param {string} country Country.
     * @return {string} Formatted address.
     */
    CoreUserHelperProvider.prototype.formatAddress = function (address, city, country) {
        var separator = this.translate.instant('core.listsep');
        var values = [address, city, country];
        values = values.filter(function (value) {
            return value && value.length > 0;
        });
        return values.join(separator + ' ');
    };
    /**
     * Formats a user role list, translating and concatenating them.
     *
     * @param {any[]} [roles] List of user roles.
     * @return {string} The formatted roles.
     */
    CoreUserHelperProvider.prototype.formatRoleList = function (roles) {
        var _this = this;
        if (!roles || roles.length <= 0) {
            return '';
        }
        var separator = this.translate.instant('core.listsep');
        return roles.map(function (value) {
            var translation = _this.translate.instant('core.user.' + value.shortname);
            return translation.indexOf('core.user.') < 0 ? translation : value.shortname;
        }).join(separator + ' ');
    };
    CoreUserHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], CoreUserHelperProvider);
    return CoreUserHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 982 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesMyCoursesComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_helper__ = __webpack_require__(179);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_options_delegate__ = __webpack_require__(72);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Component that displays the list of courses the user is enrolled in.
 */
var CoreCoursesMyCoursesComponent = /** @class */ (function () {
    function CoreCoursesMyCoursesComponent(coursesProvider, domUtils, eventsProvider, sitesProvider, courseHelper, courseOptionsDelegate, coursesHelper) {
        this.coursesProvider = coursesProvider;
        this.domUtils = domUtils;
        this.eventsProvider = eventsProvider;
        this.sitesProvider = sitesProvider;
        this.courseHelper = courseHelper;
        this.courseOptionsDelegate = courseOptionsDelegate;
        this.coursesHelper = coursesHelper;
        this.filter = '';
        this.showFilter = false;
        this.coursesLoaded = false;
        this.prefetchCoursesData = {};
        this.prefetchIconInitialized = false;
        this.isDestroyed = false;
        this.courseIds = '';
    }
    /**
     * Component being initialized.
     */
    CoreCoursesMyCoursesComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.searchEnabled = !this.coursesProvider.isSearchCoursesDisabledInSite();
        this.downloadAllCoursesEnabled = !this.coursesProvider.isDownloadCoursesDisabledInSite();
        this.fetchCourses().finally(function () {
            _this.coursesLoaded = true;
        });
        this.myCoursesObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_courses__["a" /* CoreCoursesProvider */].EVENT_MY_COURSES_UPDATED, function () {
            _this.fetchCourses();
        }, this.sitesProvider.getCurrentSiteId());
        // Refresh the enabled flags if site is updated.
        this.siteUpdatedObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function () {
            var wasEnabled = _this.downloadAllCoursesEnabled;
            _this.searchEnabled = !_this.coursesProvider.isSearchCoursesDisabledInSite();
            _this.downloadAllCoursesEnabled = !_this.coursesProvider.isDownloadCoursesDisabledInSite();
            if (!wasEnabled && _this.downloadAllCoursesEnabled && _this.coursesLoaded) {
                // Download all courses is enabled now, initialize it.
                _this.initPrefetchCoursesIcon();
            }
        }, this.sitesProvider.getCurrentSiteId());
    };
    /**
     * Fetch the user courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCoursesMyCoursesComponent.prototype.fetchCourses = function () {
        var _this = this;
        return this.coursesProvider.getUserCourses().then(function (courses) {
            var promises = [], courseIds = courses.map(function (course) {
                return course.id;
            });
            _this.courseIds = courseIds.join(',');
            promises.push(_this.coursesHelper.loadCoursesExtraInfo(courses));
            if (_this.coursesProvider.canGetAdminAndNavOptions()) {
                promises.push(_this.coursesProvider.getCoursesAdminAndNavOptions(courseIds).then(function (options) {
                    courses.forEach(function (course) {
                        course.navOptions = options.navOptions[course.id];
                        course.admOptions = options.admOptions[course.id];
                    });
                }));
            }
            return Promise.all(promises).then(function () {
                _this.courses = courses;
                _this.filteredCourses = _this.courses;
                _this.filter = '';
                _this.initPrefetchCoursesIcon();
            });
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.courses.errorloadcourses', true);
        });
    };
    /**
     * Refresh the courses.
     *
     * @param {any} refresher Refresher.
     */
    CoreCoursesMyCoursesComponent.prototype.refreshCourses = function (refresher) {
        var _this = this;
        var promises = [];
        promises.push(this.coursesProvider.invalidateUserCourses());
        promises.push(this.courseOptionsDelegate.clearAndInvalidateCoursesOptions());
        if (this.courseIds) {
            promises.push(this.coursesProvider.invalidateCoursesByField('ids', this.courseIds));
        }
        Promise.all(promises).finally(function () {
            _this.prefetchIconInitialized = false;
            _this.fetchCourses().finally(function () {
                refresher.complete();
            });
        });
    };
    /**
     * Show or hide the filter.
     */
    CoreCoursesMyCoursesComponent.prototype.switchFilter = function () {
        var _this = this;
        this.filter = '';
        this.showFilter = !this.showFilter;
        this.filteredCourses = this.courses;
        if (this.showFilter) {
            setTimeout(function () {
                _this.searchbar.setFocus();
            }, 500);
        }
    };
    /**
     * The filter has changed.
     *
     * @param {any} Received Event.
     */
    CoreCoursesMyCoursesComponent.prototype.filterChanged = function (event) {
        var newValue = event.target.value && event.target.value.trim().toLowerCase();
        if (!newValue || !this.courses) {
            this.filteredCourses = this.courses;
        }
        else {
            // Use displayname if avalaible, or fullname if not.
            if (this.courses.length > 0 && typeof this.courses[0].displayname != 'undefined') {
                this.filteredCourses = this.courses.filter(function (course) {
                    return course.displayname.toLowerCase().indexOf(newValue) > -1;
                });
            }
            else {
                this.filteredCourses = this.courses.filter(function (course) {
                    return course.fullname.toLowerCase().indexOf(newValue) > -1;
                });
            }
        }
    };
    /**
     * Prefetch all the courses.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCoursesMyCoursesComponent.prototype.prefetchCourses = function () {
        var _this = this;
        var initialIcon = this.prefetchCoursesData.icon;
        this.prefetchCoursesData.icon = 'spinner';
        this.prefetchCoursesData.badge = '';
        return this.courseHelper.confirmAndPrefetchCourses(this.courses, function (progress) {
            _this.prefetchCoursesData.badge = progress.count + ' / ' + progress.total;
        }).then(function () {
            _this.prefetchCoursesData.icon = 'ion-android-refresh';
        }).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
                _this.prefetchCoursesData.icon = initialIcon;
            }
        }).finally(function () {
            _this.prefetchCoursesData.badge = '';
        });
    };
    /**
     * Initialize the prefetch icon for the list of courses.
     */
    CoreCoursesMyCoursesComponent.prototype.initPrefetchCoursesIcon = function () {
        var _this = this;
        if (this.prefetchIconInitialized || !this.downloadAllCoursesEnabled) {
            // Already initialized.
            return;
        }
        this.prefetchIconInitialized = true;
        if (!this.courses || this.courses.length < 2) {
            // Not enough courses.
            this.prefetchCoursesData.icon = '';
            return;
        }
        this.courseHelper.determineCoursesStatus(this.courses).then(function (status) {
            var icon = _this.courseHelper.getCourseStatusIconAndTitleFromStatus(status).icon;
            if (icon == 'spinner') {
                // It seems all courses are being downloaded, show a download button instead.
                icon = 'cloud-download';
            }
            _this.prefetchCoursesData.icon = icon;
        });
    };
    /**
     * Page destroyed.
     */
    CoreCoursesMyCoursesComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.myCoursesObserver && this.myCoursesObserver.off();
        this.siteUpdatedObserver && this.siteUpdatedObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('searchbar'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["z" /* Searchbar */])
    ], CoreCoursesMyCoursesComponent.prototype, "searchbar", void 0);
    CoreCoursesMyCoursesComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-courses-my-courses',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\my-courses\my-courses.html"*/'<core-loading [hideUntil]="coursesLoaded">\n    <ion-searchbar #searchbar *ngIf="showFilter" [(ngModel)]="filter" (ionInput)="filterChanged($event)" (ionCancel)="filterChanged()" [placeholder]="\'core.courses.filtermycourses\' | translate">\n    </ion-searchbar>\n    <ion-grid no-padding>\n        <ion-row no-padding>\n            <ion-col *ngFor="let course of filteredCourses" no-padding col-12 col-sm-6 col-md-6 col-lg-4 col-xl-4 align-self-stretch>\n                <core-courses-course-progress [course]="course" class="core-courseoverview" showAll="true"></core-courses-course-progress>\n            </ion-col>\n        </ion-row>\n    </ion-grid>\n    <core-empty-box *ngIf="!courses || !courses.length" icon="ionic" [message]="\'core.courses.nocourses\' | translate">\n        <p *ngIf="searchEnabled">{{ \'core.courses.searchcoursesadvice\' | translate }}</p>\n    </core-empty-box>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\my-courses\my-courses.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_helper__["a" /* CoreCoursesHelperProvider */]])
    ], CoreCoursesMyCoursesComponent);
    return CoreCoursesMyCoursesComponent;
}());

//# sourceMappingURL=my-courses.js.map

/***/ }),
/* 983 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_block_components_components_module__ = __webpack_require__(429);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__index_index__ = __webpack_require__(984);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__all_course_list_all_course_list__ = __webpack_require__(1530);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__categories_categories__ = __webpack_require__(1531);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__course_search_course_search__ = __webpack_require__(1532);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__enrolled_course_list_enrolled_course_list__ = __webpack_require__(1533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__news_news__ = __webpack_require__(1534);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};














var CoreSiteHomeComponentsModule = /** @class */ (function () {
    function CoreSiteHomeComponentsModule() {
    }
    CoreSiteHomeComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* CoreSiteHomeIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__all_course_list_all_course_list__["a" /* CoreSiteHomeAllCourseListComponent */],
                __WEBPACK_IMPORTED_MODULE_10__categories_categories__["a" /* CoreSiteHomeCategoriesComponent */],
                __WEBPACK_IMPORTED_MODULE_11__course_search_course_search__["a" /* CoreSiteHomeCourseSearchComponent */],
                __WEBPACK_IMPORTED_MODULE_12__enrolled_course_list_enrolled_course_list__["a" /* CoreSiteHomeEnrolledCourseListComponent */],
                __WEBPACK_IMPORTED_MODULE_13__news_news__["a" /* CoreSiteHomeNewsComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_block_components_components_module__["a" /* CoreBlockComponentsModule */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* CoreSiteHomeIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__all_course_list_all_course_list__["a" /* CoreSiteHomeAllCourseListComponent */],
                __WEBPACK_IMPORTED_MODULE_10__categories_categories__["a" /* CoreSiteHomeCategoriesComponent */],
                __WEBPACK_IMPORTED_MODULE_11__course_search_course_search__["a" /* CoreSiteHomeCourseSearchComponent */],
                __WEBPACK_IMPORTED_MODULE_12__enrolled_course_list_enrolled_course_list__["a" /* CoreSiteHomeEnrolledCourseListComponent */],
                __WEBPACK_IMPORTED_MODULE_13__news_news__["a" /* CoreSiteHomeNewsComponent */]
            ]
        })
    ], CoreSiteHomeComponentsModule);
    return CoreSiteHomeComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 984 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeIndexComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_block_components_block_block__ = __webpack_require__(430);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Component that displays site home index.
 */
var CoreSiteHomeIndexComponent = /** @class */ (function () {
    function CoreSiteHomeIndexComponent(domUtils, sitesProvider, courseProvider, courseHelper, prefetchDelegate, blockDelegate) {
        this.domUtils = domUtils;
        this.courseProvider = courseProvider;
        this.courseHelper = courseHelper;
        this.prefetchDelegate = prefetchDelegate;
        this.blockDelegate = blockDelegate;
        this.dataLoaded = false;
        this.items = [];
        this.blocks = [];
        this.currentSite = sitesProvider.getCurrentSite();
        this.siteHomeId = this.currentSite.getSiteHomeId();
    }
    /**
     * Component being initialized.
     */
    CoreSiteHomeIndexComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.downloadEnabled = !this.currentSite.isOfflineDisabled();
        this.loadContent().finally(function () {
            _this.dataLoaded = true;
        });
    };
    /**
     * Refresh the data.
     *
     * @param {any} refresher Refresher.
     */
    CoreSiteHomeIndexComponent.prototype.doRefresh = function (refresher) {
        var _this = this;
        var promises = [];
        promises.push(this.courseProvider.invalidateSections(this.siteHomeId));
        promises.push(this.currentSite.invalidateConfig().then(function () {
            // Config invalidated, fetch it again.
            return _this.currentSite.getConfig().then(function (config) {
                _this.currentSite.setConfig(config);
            });
        }));
        if (this.section && this.section.modules) {
            // Invalidate modules prefetch data.
            promises.push(this.prefetchDelegate.invalidateModules(this.section.modules, this.siteHomeId));
        }
        if (this.courseProvider.canGetCourseBlocks()) {
            promises.push(this.courseProvider.invalidateCourseBlocks(this.siteHomeId));
        }
        // Invalidate the blocks.
        this.blocksComponents.forEach(function (blockComponent) {
            promises.push(blockComponent.invalidate().catch(function () {
                // Ignore errors.
            }));
        });
        Promise.all(promises).finally(function () {
            _this.loadContent().finally(function () {
                refresher.complete();
            });
        });
    };
    /**
     * Convenience function to fetch the data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSiteHomeIndexComponent.prototype.loadContent = function () {
        var _this = this;
        this.hasContent = false;
        var config = this.currentSite.getStoredConfig() || { numsections: 1 };
        if (config.frontpageloggedin) {
            // Items with index 1 and 3 were removed on 2.5 and not being supported in the app.
            var frontpageItems_1 = [
                'news',
                false,
                'categories',
                false,
                'categories',
                'enrolled-course-list',
                'all-course-list',
                'course-search' // Course search box.
            ], items = config.frontpageloggedin.split(',');
            this.items = [];
            items.forEach(function (itemNumber) {
                // Get the frontpage item "name".
                var item = frontpageItems_1[parseInt(itemNumber, 10)];
                if (!item || _this.items.indexOf(item) >= 0) {
                    return;
                }
                _this.hasContent = true;
                _this.items.push(item);
            });
        }
        return this.courseProvider.getSections(this.siteHomeId, false, true).then(function (sections) {
            // Check "Include a topic section" setting from numsections.
            _this.section = config.numsections ? sections.find(function (section) { return section.section == 1; }) : false;
            if (_this.section) {
                _this.section.hasContent = _this.courseHelper.sectionHasContent(_this.section);
                _this.hasContent = _this.courseHelper.addHandlerDataForModules([_this.section], _this.siteHomeId) || _this.hasContent;
            }
            // Add log in Moodle.
            _this.courseProvider.logView(_this.siteHomeId, undefined, undefined, _this.currentSite && _this.currentSite.getInfo().sitename).catch(function () {
                // Ignore errors.
            });
            // Get site home blocks.
            var canGetBlocks = _this.courseProvider.canGetCourseBlocks(), promise = canGetBlocks ? _this.courseProvider.getCourseBlocks(_this.siteHomeId) : Promise.reject(null);
            return promise.then(function (blocks) {
                _this.blocks = blocks;
                _this.hasSupportedBlock = _this.blockDelegate.hasSupportedBlock(blocks);
            }).catch(function (error) {
                if (canGetBlocks) {
                    _this.domUtils.showErrorModal(error);
                }
                _this.blocks = [];
                // Cannot get the blocks, just show site main menu if needed.
                var section = sections.find(function (section) { return section.section == 0; });
                if (section && _this.courseHelper.sectionHasContent(section)) {
                    _this.blocks.push({
                        name: 'site_main_menu'
                    });
                    _this.hasSupportedBlock = true;
                }
                else {
                    _this.hasSupportedBlock = false;
                }
            });
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.course.couldnotloadsectioncontent', true);
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChildren"])(__WEBPACK_IMPORTED_MODULE_7__core_block_components_block_block__["a" /* CoreBlockComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["QueryList"])
    ], CoreSiteHomeIndexComponent.prototype, "blocksComponents", void 0);
    CoreSiteHomeIndexComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-sitehome-index',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\index\core-sitehome-index.html"*/'<core-loading [hideUntil]="dataLoaded">\n\n    <ion-list>\n        <!-- Site home main contents. -->\n        <ng-container *ngIf="section && section.hasContent">\n            <ion-item text-wrap *ngIf="section.summary">\n                <core-format-text [text]="section.summary"></core-format-text>\n            </ion-item>\n\n            <core-course-module *ngFor="let module of section.modules" [module]="module" [courseId]="siteHomeId" [downloadEnabled]="downloadEnabled" [section]="section"></core-course-module>\n        </ng-container>\n\n        <!-- Site home items: news, categories, courses, etc. -->\n        <ng-container *ngIf="items.length > 0">\n            <ion-item-divider *ngIf="section && section.hasContent"></ion-item-divider>\n            <ng-container *ngFor="let item of items">\n                <core-sitehome-all-course-list class="item" *ngIf="item == \'all-course-list\'"></core-sitehome-all-course-list>\n                <core-sitehome-categories  *ngIf="item == \'categories\'"></core-sitehome-categories>\n                <core-sitehome-course-search *ngIf="item == \'course-search\'"></core-sitehome-course-search>\n                <core-sitehome-enrolled-course-list *ngIf="item == \'enrolled-course-list\'"></core-sitehome-enrolled-course-list>\n                <core-sitehome-news *ngIf="item == \'news\'"></core-sitehome-news>\n            </ng-container>\n        </ng-container>\n\n        <!-- Site home blocks. -->\n        <ng-container *ngFor="let block of blocks">\n            <core-block [block]="block" contextLevel="course" [instanceId]="siteHomeId"></core-block>\n        </ng-container>\n    </ion-list>\n\n    <core-empty-box *ngIf="!hasContent && !hasSupportedBlock" icon="qr-scanner" [message]="\'core.course.nocontentavailable\' | translate"></core-empty-box>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\index\core-sitehome-index.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__["a" /* CoreBlockDelegate */]])
    ], CoreSiteHomeIndexComponent);
    return CoreSiteHomeIndexComponent;
}());

//# sourceMappingURL=index.js.map

/***/ }),
/* 985 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__question_question__ = __webpack_require__(1002);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};







var CoreQuestionComponentsModule = /** @class */ (function () {
    function CoreQuestionComponentsModule() {
    }
    CoreQuestionComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__question_question__["a" /* CoreQuestionComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__question_question__["a" /* CoreQuestionComponent */]
            ]
        })
    ], CoreQuestionComponentsModule);
    return CoreQuestionComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 986 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_rating_components_components_module__ = __webpack_require__(987);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__index_index__ = __webpack_require__(433);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__post_post__ = __webpack_require__(1609);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};











var AddonModForumComponentsModule = /** @class */ (function () {
    function AddonModForumComponentsModule() {
    }
    AddonModForumComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_9__index_index__["a" /* AddonModForumIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_10__post_post__["a" /* AddonModForumPostComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__core_rating_components_components_module__["a" /* CoreRatingComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_9__index_index__["a" /* AddonModForumIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_10__post_post__["a" /* AddonModForumPostComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_9__index_index__["a" /* AddonModForumIndexComponent */]
            ]
        })
    ], AddonModForumComponentsModule);
    return AddonModForumComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 987 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRatingComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__aggregate_aggregate__ = __webpack_require__(1607);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__rate_rate__ = __webpack_require__(1608);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};






var CoreRatingComponentsModule = /** @class */ (function () {
    function CoreRatingComponentsModule() {
    }
    CoreRatingComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__aggregate_aggregate__["a" /* CoreRatingAggregateComponent */],
                __WEBPACK_IMPORTED_MODULE_5__rate_rate__["a" /* CoreRatingRateComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__aggregate_aggregate__["a" /* CoreRatingAggregateComponent */],
                __WEBPACK_IMPORTED_MODULE_5__rate_rate__["a" /* CoreRatingRateComponent */]
            ]
        })
    ], CoreRatingComponentsModule);
    return CoreRatingComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 988 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__lesson__ = __webpack_require__(102);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Helper service that provides some features for quiz.
 */
var AddonModLessonHelperProvider = /** @class */ (function () {
    function AddonModLessonHelperProvider(domUtils, fb, translate, textUtils, timeUtils, lessonProvider) {
        this.domUtils = domUtils;
        this.fb = fb;
        this.translate = translate;
        this.textUtils = textUtils;
        this.timeUtils = timeUtils;
        this.lessonProvider = lessonProvider;
    }
    /**
     * Given the HTML of next activity link, format it to extract the href and the text.
     *
     * @param {string} activityLink HTML of the activity link.
     * @return {{formatted: boolean, label: string, href: string}} Formatted data.
     */
    AddonModLessonHelperProvider.prototype.formatActivityLink = function (activityLink) {
        var element = this.domUtils.convertToElement(activityLink), anchor = element.querySelector('a');
        if (!anchor) {
            // Anchor not found, return the original HTML.
            return {
                formatted: false,
                label: activityLink,
                href: ''
            };
        }
        return {
            formatted: true,
            label: anchor.innerHTML,
            href: anchor.href
        };
    };
    /**
     * Given the HTML of an answer from a content page, extract the data to render the answer.
     *
     * @param  {String} html Answer's HTML.
     * @return {{buttonText: string, content: string}} Data to render the answer.
     */
    AddonModLessonHelperProvider.prototype.getContentPageAnswerDataFromHtml = function (html) {
        var data = {
            buttonText: '',
            content: ''
        }, element = this.domUtils.convertToElement(html);
        // Search the input button.
        var button = element.querySelector('input[type="button"]');
        if (button) {
            // Extract the button content and remove it from the HTML.
            data.buttonText = button.value;
            button.remove();
        }
        data.content = element.innerHTML.trim();
        return data;
    };
    /**
     * Get the buttons to change pages.
     *
     * @param {string} html Page's HTML.
     * @return {any[]} List of buttons.
     */
    AddonModLessonHelperProvider.prototype.getPageButtonsFromHtml = function (html) {
        var buttons = [], element = this.domUtils.convertToElement(html);
        // Get the container of the buttons if it exists.
        var buttonsContainer = element.querySelector('.branchbuttoncontainer');
        if (!buttonsContainer) {
            // Button container not found, might be a legacy lesson (from 1.9).
            if (!element.querySelector('form input[type="submit"]')) {
                // No buttons found.
                return buttons;
            }
            buttonsContainer = element;
        }
        var forms = Array.from(buttonsContainer.querySelectorAll('form'));
        forms.forEach(function (form) {
            var buttonSelector = 'input[type="submit"], button[type="submit"]', buttonEl = form.querySelector(buttonSelector), inputs = Array.from(form.querySelectorAll('input'));
            if (!buttonEl || !inputs || !inputs.length) {
                // Button not found or no inputs, ignore it.
                return;
            }
            var button = {
                id: buttonEl.id,
                title: buttonEl.title || buttonEl.value,
                content: buttonEl.tagName == 'INPUT' ? buttonEl.value : buttonEl.innerHTML.trim(),
                data: {}
            };
            inputs.forEach(function (input) {
                if (input.type != 'submit') {
                    button.data[input.name] = input.value;
                }
            });
            buttons.push(button);
        });
        return buttons;
    };
    /**
     * Given a page data (result of getPageData), get the page contents.
     *
     * @param {any} data Page data.
     * @return {string} Page contents.
     */
    AddonModLessonHelperProvider.prototype.getPageContentsFromPageData = function (data) {
        // Search the page contents inside the whole page HTML. Use data.pagecontent because it's filtered.
        var element = this.domUtils.convertToElement(data.pagecontent), contents = element.querySelector('.contents');
        if (contents) {
            return contents.innerHTML.trim();
        }
        // Cannot find contents element.
        if (this.lessonProvider.isQuestionPage(data.page.type) ||
            data.page.qtype == __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_BRANCHTABLE) {
            // Return page.contents to prevent having duplicated elements (some elements like videos might not work).
            return data.page.contents;
        }
        else {
            // It's an end of cluster, end of branch, etc. Return the whole pagecontent to match what's displayed in web.
            return data.pagecontent;
        }
    };
    /**
     * Get a question and all the data required to render it from the page data (result of AddonModLessonProvider.getPageData).
     *
     * @param {FormGroup} questionForm The form group where to add the controls.
     * @param {any} pageData Page data (result of $mmaModLesson#getPageData).
     * @return {any} Question data.
     */
    AddonModLessonHelperProvider.prototype.getQuestionFromPageData = function (questionForm, pageData) {
        var _this = this;
        var question = {}, element = this.domUtils.convertToElement(pageData.pagecontent);
        // Get the container of the question answers if it exists.
        var fieldContainer = element.querySelector('.fcontainer');
        // Get hidden inputs and add their data to the form group.
        var hiddenInputs = Array.from(element.querySelectorAll('input[type="hidden"]'));
        hiddenInputs.forEach(function (input) {
            questionForm.addControl(input.name, _this.fb.control(input.value));
        });
        // Get the submit button and extract its value.
        var submitButton = element.querySelector('input[type="submit"]');
        question.submitLabel = submitButton ? submitButton.value : this.translate.instant('addon.mod_lesson.submit');
        if (!fieldContainer) {
            // Element not found, return.
            return question;
        }
        var type;
        switch (pageData.page.qtype) {
            case __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_TRUEFALSE:
            case __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_MULTICHOICE:
                question.template = 'multichoice';
                question.options = [];
                // Get all the inputs. Search radio first.
                var inputs = Array.from(fieldContainer.querySelectorAll('input[type="radio"]'));
                if (!inputs || !inputs.length) {
                    // Radio buttons not found, it might be a multi answer. Search for checkbox.
                    question.multi = true;
                    inputs = Array.from(fieldContainer.querySelectorAll('input[type="checkbox"]'));
                    if (!inputs || !inputs.length) {
                        // No checkbox found either. Stop.
                        return question;
                    }
                }
                var controlAdded_1 = false;
                inputs.forEach(function (input) {
                    var option = {
                        id: input.id,
                        name: input.name,
                        value: input.value,
                        checked: !!input.checked,
                        disabled: !!input.disabled
                    }, parent = input.parentElement;
                    if (option.checked || question.multi) {
                        // Add the control.
                        var value = question.multi ? { value: option.checked, disabled: option.disabled } : option.value;
                        questionForm.addControl(option.name, _this.fb.control(value));
                        controlAdded_1 = true;
                    }
                    // Remove the input and use the rest of the parent contents as the label.
                    input.remove();
                    option.text = parent.innerHTML.trim();
                    question.options.push(option);
                });
                if (!question.multi) {
                    question.controlName = inputs[0].name; // All option have the same name in single choice.
                    if (!controlAdded_1) {
                        // No checked option for single choice, add the control with an empty value.
                        questionForm.addControl(question.controlName, this.fb.control(''));
                    }
                }
                break;
            case __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_NUMERICAL:
                type = 'number';
            case __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_SHORTANSWER:
                question.template = 'shortanswer';
                // Get the input.
                var input = fieldContainer.querySelector('input[type="text"], input[type="number"]');
                if (!input) {
                    return question;
                }
                question.input = {
                    id: input.id,
                    name: input.name,
                    maxlength: input.maxLength,
                    type: type || 'text'
                };
                // Init the control.
                questionForm.addControl(input.name, this.fb.control({ value: input.value, disabled: input.readOnly }));
                break;
            case __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_ESSAY:
                question.template = 'essay';
                // Get the textarea.
                var textarea = fieldContainer.querySelector('textarea');
                if (!textarea) {
                    // Textarea not found, probably review mode.
                    var answerEl = fieldContainer.querySelector('.reviewessay');
                    if (!answerEl) {
                        // Answer not found, stop.
                        return question;
                    }
                    question.useranswer = answerEl.innerHTML;
                }
                else {
                    question.textarea = {
                        id: textarea.id,
                        name: textarea.name || 'answer[text]'
                    };
                    // Init the control.
                    question.control = this.fb.control('');
                    questionForm.addControl(question.textarea.name, question.control);
                }
                break;
            case __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */].LESSON_PAGE_MATCHING:
                question.template = 'matching';
                var rows = Array.from(fieldContainer.querySelectorAll('.answeroption'));
                question.rows = [];
                rows.forEach(function (row) {
                    var label = row.querySelector('label'), select = row.querySelector('select'), options = Array.from(row.querySelectorAll('option')), rowData = {};
                    if (!label || !select || !options || !options.length) {
                        return;
                    }
                    // Get the row's text (label).
                    rowData.text = label.innerHTML.trim();
                    rowData.id = select.id;
                    rowData.name = select.name;
                    rowData.options = [];
                    // Treat each option.
                    var controlAdded = false;
                    options.forEach(function (option) {
                        if (typeof option.value == 'undefined') {
                            // Option not valid, ignore it.
                            return;
                        }
                        var opt = {
                            value: option.value,
                            label: option.innerHTML.trim(),
                            selected: option.selected
                        };
                        if (opt.selected) {
                            controlAdded = true;
                            questionForm.addControl(rowData.name, _this.fb.control({ value: opt.value, disabled: !!select.disabled }));
                        }
                        rowData.options.push(opt);
                    });
                    if (!controlAdded) {
                        // No selected option, add the control with an empty value.
                        questionForm.addControl(rowData.name, _this.fb.control({ value: '', disabled: !!select.disabled }));
                    }
                    question.rows.push(rowData);
                });
                break;
            default:
        }
        return question;
    };
    /**
     * Given the HTML of an answer from a question page, extract the data to render the answer.
     *
     * @param {string} html Answer's HTML.
     * @return {any} Object with the data to render the answer. If the answer doesn't require any parsing, return a string with
     *               the HTML.
     */
    AddonModLessonHelperProvider.prototype.getQuestionPageAnswerDataFromHtml = function (html) {
        var data = {}, element = this.domUtils.convertToElement(html);
        // Check if it has a checkbox.
        var input = element.querySelector('input[type="checkbox"][name*="answer"]');
        if (input) {
            // Truefalse or multichoice.
            data.isCheckbox = true;
            data.checked = !!input.checked;
            data.name = input.name;
            data.highlight = !!element.querySelector('.highlight');
            input.remove();
            data.content = element.innerHTML.trim();
            return data;
        }
        // Check if it has an input text or number.
        input = element.querySelector('input[type="number"],input[type="text"]');
        if (input) {
            // Short answer or numeric.
            data.isText = true;
            data.value = input.value;
            return data;
        }
        // Check if it has a select.
        var select = element.querySelector('select');
        if (select && select.options) {
            // Matching.
            var selectedOption = select.options[select.selectedIndex];
            data.isSelect = true;
            data.id = select.id;
            if (selectedOption) {
                data.value = selectedOption.value;
            }
            else {
                data.value = '';
            }
            select.remove();
            data.content = element.innerHTML.trim();
            return data;
        }
        // The answer doesn't need any parsing, return the HTML as it is.
        return html;
    };
    /**
     * Get a label to identify a retake (lesson attempt).
     *
     * @param {any} retake Retake object.
     * @param {boolean} [includeDuration] Whether to include the duration of the retake.
     * @return {string} Retake label.
     */
    AddonModLessonHelperProvider.prototype.getRetakeLabel = function (retake, includeDuration) {
        var data = {
            retake: retake.try + 1,
            grade: '',
            timestart: '',
            duration: ''
        }, hasGrade = retake.grade != null;
        if (hasGrade || retake.end) {
            // Retake finished with or without grade (if the lesson only has content pages, it has no grade).
            if (hasGrade) {
                data.grade = this.translate.instant('core.percentagenumber', { $a: retake.grade });
            }
            data.timestart = this.timeUtils.userDate(retake.timestart * 1000);
            if (includeDuration) {
                data.duration = this.timeUtils.formatTime(retake.timeend - retake.timestart);
            }
        }
        else {
            // The user has not completed the retake.
            data.grade = this.translate.instant('addon.mod_lesson.notcompleted');
            if (retake.timestart) {
                data.timestart = this.timeUtils.userDate(retake.timestart * 1000);
            }
        }
        return this.translate.instant('addon.mod_lesson.retakelabel' + (includeDuration ? 'full' : 'short'), data);
    };
    /**
     * Prepare the question data to be sent to server.
     *
     * @param {any} question Question to prepare.
     * @param {any} data Data to prepare.
     * @return {any} Data to send.
     */
    AddonModLessonHelperProvider.prototype.prepareQuestionData = function (question, data) {
        if (question.template == 'essay' && question.textarea) {
            // Add some HTML to the answer if needed.
            data[question.textarea.name] = this.textUtils.formatHtmlLines(data[question.textarea.name]);
        }
        else if (question.template == 'multichoice' && question.multi) {
            // Only send the options with value set to true.
            for (var name_1 in data) {
                if (name_1.match(/answer\[\d+\]/) && data[name_1] == false) {
                    delete data[name_1];
                }
            }
        }
        return data;
    };
    /**
     * Given the feedback of a process page in HTML, remove the question text.
     *
     * @param {string} html Feedback's HTML.
     * @return {string} Feedback without the question text.
     */
    AddonModLessonHelperProvider.prototype.removeQuestionFromFeedback = function (html) {
        var element = this.domUtils.convertToElement(html);
        // Remove the question text.
        this.domUtils.removeElement(element, '.generalbox:not(.feedback):not(.correctanswer)');
        return element.innerHTML.trim();
    };
    AddonModLessonHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__angular_forms__["a" /* FormBuilder */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */]])
    ], AddonModLessonHelperProvider);
    return AddonModLessonHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 989 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSettingsHelper; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Settings helper service.
 */
var CoreSettingsHelper = /** @class */ (function () {
    function CoreSettingsHelper(loggerProvider, appProvider, cronDelegate, eventsProvider, filePoolProvider, sitesProvider, utils, translate) {
        this.appProvider = appProvider;
        this.cronDelegate = cronDelegate;
        this.eventsProvider = eventsProvider;
        this.filePoolProvider = filePoolProvider;
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.translate = translate;
        this.syncPromises = {};
        this.logger = loggerProvider.getInstance('CoreSettingsHelper');
    }
    /**
     * Get a certain processor from a list of processors.
     *
     * @param {any[]} processors List of processors.
     * @param {string} name Name of the processor to get.
     * @param {boolean} [fallback=true] True to return first processor if not found, false to not return any. Defaults to true.
     * @return {any} Processor.
     */
    CoreSettingsHelper.prototype.getProcessor = function (processors, name, fallback) {
        if (fallback === void 0) { fallback = true; }
        if (!processors || !processors.length) {
            return;
        }
        for (var i = 0; i < processors.length; i++) {
            if (processors[i].name == name) {
                return processors[i];
            }
        }
        // Processor not found, return first if requested.
        if (fallback) {
            return processors[0];
        }
    };
    /**
     * Return the components and notifications that have a certain processor.
     *
     * @param {string} processor Name of the processor to filter.
     * @param {any[]} components Array of components.
     * @return {any[]} Filtered components.
     */
    CoreSettingsHelper.prototype.getProcessorComponents = function (processor, components) {
        var _this = this;
        var result = [];
        components.forEach(function (component) {
            // Create a copy of the component with an empty list of notifications.
            var componentCopy = _this.utils.clone(component);
            componentCopy.notifications = [];
            component.notifications.forEach(function (notification) {
                var hasProcessor = false;
                for (var i = 0; i < notification.processors.length; i++) {
                    var proc = notification.processors[i];
                    if (proc.name == processor) {
                        hasProcessor = true;
                        notification.currentProcessor = proc;
                        break;
                    }
                }
                if (hasProcessor) {
                    // Add the notification.
                    componentCopy.notifications.push(notification);
                }
            });
            if (componentCopy.notifications.length) {
                // At least 1 notification added, add the component to the result.
                result.push(componentCopy);
            }
        });
        return result;
    };
    /**
     * Get the synchronization promise of a site.
     *
     * @param {string} siteId ID of the site.
     * @return {Promise<any> | null} Sync promise or null if site is not being syncrhonized.
     */
    CoreSettingsHelper.prototype.getSiteSyncPromise = function (siteId) {
        if (this.syncPromises[siteId]) {
            return this.syncPromises[siteId];
        }
        else {
            return null;
        }
    };
    /**
     * Synchronize a site.
     *
     * @param {boolean} syncOnlyOnWifi True to sync only on wifi, false otherwise.
     * @param {string} siteId ID of the site to synchronize.
     * @return {Promise<any>} Promise resolved when synchronized, rejected if failure.
     */
    CoreSettingsHelper.prototype.synchronizeSite = function (syncOnlyOnWifi, siteId) {
        var _this = this;
        if (this.syncPromises[siteId]) {
            // There's already a sync ongoing for this site, return the promise.
            return this.syncPromises[siteId];
        }
        var promises = [];
        var hasSyncHandlers = this.cronDelegate.hasManualSyncHandlers();
        if (hasSyncHandlers && !this.appProvider.isOnline()) {
            // We need connection to execute sync.
            return Promise.reject(this.translate.instant('core.settings.cannotsyncoffline'));
        }
        else if (hasSyncHandlers && syncOnlyOnWifi && this.appProvider.isNetworkAccessLimited()) {
            return Promise.reject(this.translate.instant('core.settings.cannotsyncwithoutwifi'));
        }
        // Invalidate all the site files so they are re-downloaded.
        promises.push(this.filePoolProvider.invalidateAllFiles(siteId).catch(function () {
            // Ignore errors.
        }));
        // Get the site to invalidate data.
        promises.push(this.sitesProvider.getSite(siteId).then(function (site) {
            // Invalidate the WS cache.
            return site.invalidateWsCache().then(function () {
                var subPromises = [];
                // Check if local_mobile was installed in Moodle.
                subPromises.push(site.checkIfLocalMobileInstalledAndNotUsed().then(function () {
                    // Local mobile was added. Throw invalid session to force reconnect and create a new token.
                    _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SESSION_EXPIRED, {}, siteId);
                    return Promise.reject(_this.translate.instant('core.lostconnection'));
                }, function () {
                    // Update site info.
                    return _this.sitesProvider.updateSiteInfo(siteId);
                }));
                // Execute cron if needed.
                subPromises.push(_this.cronDelegate.forceSyncExecution(siteId));
                return Promise.all(subPromises);
            });
        }));
        var syncPromise = Promise.all(promises);
        this.syncPromises[siteId] = syncPromise;
        syncPromise.finally(function () {
            delete _this.syncPromises[siteId];
        });
        return syncPromise;
    };
    CoreSettingsHelper = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_cron__["a" /* CoreCronDelegate */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_8__ngx_translate_core__["c" /* TranslateService */]])
    ], CoreSettingsHelper);
    return CoreSettingsHelper;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 990 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_compile_components_compile_html_compile_html_module__ = __webpack_require__(413);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__plugin_content_plugin_content__ = __webpack_require__(126);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__module_index_module_index__ = __webpack_require__(285);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__course_option_course_option__ = __webpack_require__(361);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__course_format_course_format__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__user_profile_field_user_profile_field__ = __webpack_require__(365);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__question_question__ = __webpack_require__(363);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__question_behaviour_question_behaviour__ = __webpack_require__(364);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__quiz_access_rule_quiz_access_rule__ = __webpack_require__(366);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__assign_feedback_assign_feedback__ = __webpack_require__(367);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__assign_submission_assign_submission__ = __webpack_require__(368);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__workshop_assessment_strategy_workshop_assessment_strategy__ = __webpack_require__(883);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__core_siteplugins_components_block_block__ = __webpack_require__(360);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


















var CoreSitePluginsComponentsModule = /** @class */ (function () {
    function CoreSitePluginsComponentsModule() {
    }
    CoreSitePluginsComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */],
                __WEBPACK_IMPORTED_MODULE_7__module_index_module_index__["a" /* CoreSitePluginsModuleIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_17__core_siteplugins_components_block_block__["a" /* CoreSitePluginsBlockComponent */],
                __WEBPACK_IMPORTED_MODULE_8__course_option_course_option__["a" /* CoreSitePluginsCourseOptionComponent */],
                __WEBPACK_IMPORTED_MODULE_9__course_format_course_format__["a" /* CoreSitePluginsCourseFormatComponent */],
                __WEBPACK_IMPORTED_MODULE_10__user_profile_field_user_profile_field__["a" /* CoreSitePluginsUserProfileFieldComponent */],
                __WEBPACK_IMPORTED_MODULE_11__question_question__["a" /* CoreSitePluginsQuestionComponent */],
                __WEBPACK_IMPORTED_MODULE_12__question_behaviour_question_behaviour__["a" /* CoreSitePluginsQuestionBehaviourComponent */],
                __WEBPACK_IMPORTED_MODULE_13__quiz_access_rule_quiz_access_rule__["a" /* CoreSitePluginsQuizAccessRuleComponent */],
                __WEBPACK_IMPORTED_MODULE_14__assign_feedback_assign_feedback__["a" /* CoreSitePluginsAssignFeedbackComponent */],
                __WEBPACK_IMPORTED_MODULE_15__assign_submission_assign_submission__["a" /* CoreSitePluginsAssignSubmissionComponent */],
                __WEBPACK_IMPORTED_MODULE_16__workshop_assessment_strategy_workshop_assessment_strategy__["a" /* CoreSitePluginsWorkshopAssessmentStrategyComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__core_compile_components_compile_html_compile_html_module__["a" /* CoreCompileHtmlComponentModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */],
                __WEBPACK_IMPORTED_MODULE_7__module_index_module_index__["a" /* CoreSitePluginsModuleIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_17__core_siteplugins_components_block_block__["a" /* CoreSitePluginsBlockComponent */],
                __WEBPACK_IMPORTED_MODULE_8__course_option_course_option__["a" /* CoreSitePluginsCourseOptionComponent */],
                __WEBPACK_IMPORTED_MODULE_9__course_format_course_format__["a" /* CoreSitePluginsCourseFormatComponent */],
                __WEBPACK_IMPORTED_MODULE_10__user_profile_field_user_profile_field__["a" /* CoreSitePluginsUserProfileFieldComponent */],
                __WEBPACK_IMPORTED_MODULE_11__question_question__["a" /* CoreSitePluginsQuestionComponent */],
                __WEBPACK_IMPORTED_MODULE_12__question_behaviour_question_behaviour__["a" /* CoreSitePluginsQuestionBehaviourComponent */],
                __WEBPACK_IMPORTED_MODULE_13__quiz_access_rule_quiz_access_rule__["a" /* CoreSitePluginsQuizAccessRuleComponent */],
                __WEBPACK_IMPORTED_MODULE_14__assign_feedback_assign_feedback__["a" /* CoreSitePluginsAssignFeedbackComponent */],
                __WEBPACK_IMPORTED_MODULE_15__assign_submission_assign_submission__["a" /* CoreSitePluginsAssignSubmissionComponent */],
                __WEBPACK_IMPORTED_MODULE_16__workshop_assessment_strategy_workshop_assessment_strategy__["a" /* CoreSitePluginsWorkshopAssessmentStrategyComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__module_index_module_index__["a" /* CoreSitePluginsModuleIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_17__core_siteplugins_components_block_block__["a" /* CoreSitePluginsBlockComponent */],
                __WEBPACK_IMPORTED_MODULE_8__course_option_course_option__["a" /* CoreSitePluginsCourseOptionComponent */],
                __WEBPACK_IMPORTED_MODULE_9__course_format_course_format__["a" /* CoreSitePluginsCourseFormatComponent */],
                __WEBPACK_IMPORTED_MODULE_10__user_profile_field_user_profile_field__["a" /* CoreSitePluginsUserProfileFieldComponent */],
                __WEBPACK_IMPORTED_MODULE_11__question_question__["a" /* CoreSitePluginsQuestionComponent */],
                __WEBPACK_IMPORTED_MODULE_12__question_behaviour_question_behaviour__["a" /* CoreSitePluginsQuestionBehaviourComponent */],
                __WEBPACK_IMPORTED_MODULE_13__quiz_access_rule_quiz_access_rule__["a" /* CoreSitePluginsQuizAccessRuleComponent */],
                __WEBPACK_IMPORTED_MODULE_14__assign_feedback_assign_feedback__["a" /* CoreSitePluginsAssignFeedbackComponent */],
                __WEBPACK_IMPORTED_MODULE_15__assign_submission_assign_submission__["a" /* CoreSitePluginsAssignSubmissionComponent */],
                __WEBPACK_IMPORTED_MODULE_16__workshop_assessment_strategy_workshop_assessment_strategy__["a" /* CoreSitePluginsWorkshopAssessmentStrategyComponent */]
            ]
        })
    ], CoreSitePluginsComponentsModule);
    return CoreSitePluginsComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 991 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return coreShowHideAnimation; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return coreSlideInOut; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_animations__ = __webpack_require__(310);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

var coreShowHideAnimation = Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["j" /* trigger */])('coreShowHideAnimation', [
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["i" /* transition */])(':enter', [
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 0 }),
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["e" /* animate */])('500ms ease-in-out', Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1 }))
    ]),
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["i" /* transition */])(':leave', [
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1 }),
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["e" /* animate */])('500ms ease-in-out', Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 0 }))
    ])
]);
var coreSlideInOut = Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["j" /* trigger */])('coreSlideInOut', [
    // Enter animation.
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["i" /* transition */])('void => fromLeft', [
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ transform: 'translateX(0)', opacity: 1 }),
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["e" /* animate */])(300, Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["f" /* keyframes */])([
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 0, transform: 'translateX(-100%)', offset: 0 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(5%)', offset: 0.7 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(0)', offset: 1.0 })
        ]))
    ]),
    // Leave animation.
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["i" /* transition */])('fromLeft => void', [
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ transform: 'translateX(-100%)', opacity: 0 }),
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["e" /* animate */])(300, Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["f" /* keyframes */])([
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(0)', offset: 0 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(5%)', offset: 0.3 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 0, transform: 'translateX(-100%)', offset: 1.0 })
        ]))
    ]),
    // Enter animation.
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["i" /* transition */])('void => fromRight', [
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ transform: 'translateX(0)', opacity: 1 }),
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["e" /* animate */])(300, Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["f" /* keyframes */])([
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 0, transform: 'translateX(100%)', offset: 0 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(-5%)', offset: 0.7 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(0)', offset: 1.0 })
        ]))
    ]),
    // Leave animation.
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["i" /* transition */])('fromRight => void', [
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ transform: 'translateX(-100%)', opacity: 0 }),
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["e" /* animate */])(300, Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["f" /* keyframes */])([
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(0)', offset: 0 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 1, transform: 'translateX(-5%)', offset: 0.3 }),
            Object(__WEBPACK_IMPORTED_MODULE_0__angular_animations__["h" /* style */])({ opacity: 0, transform: 'translateX(100%)', offset: 1.0 })
        ]))
    ])
]);
//# sourceMappingURL=animations.js.map

/***/ }),
/* 992 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursePickerMenuPopoverComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to display a list of courses.
 */
var CoreCoursePickerMenuPopoverComponent = /** @class */ (function () {
    function CoreCoursePickerMenuPopoverComponent(navParams, viewCtrl) {
        this.viewCtrl = viewCtrl;
        this.courseId = -1;
        this.courses = navParams.get('courses') || [];
        this.courseId = navParams.get('courseId') || -1;
    }
    /**
     * Function called when a course is clicked.
     *
     * @param {Event} event Click event.
     * @param {any} course Course object clicked.
     * @return {boolean} Return true if success, false if error.
     */
    CoreCoursePickerMenuPopoverComponent.prototype.coursePicked = function (event, course) {
        this.viewCtrl.dismiss(course);
        return true;
    };
    CoreCoursePickerMenuPopoverComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-course-picker-menu-popover',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\course-picker-menu\core-course-picker-menu-popover.html"*/'<ion-list radio-group [(ngModel)]="courseId">\n    <ion-item text-wrap *ngFor="let course of courses" >\n        <ion-label><core-format-text [text]="course.fullname"></core-format-text></ion-label>\n        <ion-radio value="{{course.id}}" (ionSelect)="coursePicked($event, course)" ></ion-radio>\n    </ion-item>\n</ion-list>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\course-picker-menu\core-course-picker-menu-popover.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */]])
    ], CoreCoursePickerMenuPopoverComponent);
    return CoreCoursePickerMenuPopoverComponent;
}());

//# sourceMappingURL=course-picker-menu-popover.js.map

/***/ }),
/* 993 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRichTextEditorComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__angular_forms__ = __webpack_require__(24);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};









/**
 * Directive to display a rich text editor if enabled.
 *
 * If enabled, this directive will show a rich text editor. Otherwise it'll show a regular textarea.
 *
 * This directive requires an OBJECT model. The text written in the editor or textarea will be stored inside
 * a "text" property in that object. This is to ensure 2-way data-binding, since using a string as a model
 * could be easily broken.
 *
 * Example:
 * <core-rich-text-editor item-content [control]="control" [placeholder]="field.name"></core-rich-text-editor>
 *
 * In the example above, the text written in the editor will be stored in newpost.text.
 */
var CoreRichTextEditorComponent = /** @class */ (function () {
    function CoreRichTextEditorComponent(domUtils, urlUtils, sitesProvider, filepoolProvider, content, elementRef, events, utils, platform) {
        this.domUtils = domUtils;
        this.urlUtils = urlUtils;
        this.sitesProvider = sitesProvider;
        this.filepoolProvider = filepoolProvider;
        this.content = content;
        this.events = events;
        this.utils = utils;
        this.platform = platform;
        // Based on: https://github.com/judgewest2000/Ionic3RichText/
        // @todo: Anchor button, fullscreen...
        // @todo: Textarea height is not being updated when editor is resized. Height is calculated if any css is changed.
        this.placeholder = ''; // Placeholder to set in textarea.
        this.name = 'core-rich-text-editor'; // Name to set to the textarea.
        this.kbHeight = 0; // Last known keyboard height.
        this.minHeight = 200; // Minimum height of the editor.
        this.rteEnabled = false;
        this.editorSupported = true;
        this.contentChanged = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.element = elementRef.nativeElement;
    }
    /**
     * Init editor
     */
    CoreRichTextEditorComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.domUtils.isRichTextEditorEnabled().then(function (enabled) {
            _this.rteEnabled = !!enabled;
        });
        this.editorSupported = this.domUtils.isRichTextEditorSupported();
        // Setup the editor.
        this.editorElement = this.editor.nativeElement;
        this.setContent(this.control.value);
        this.editorElement.onchange = this.onChange.bind(this);
        this.editorElement.onkeyup = this.onChange.bind(this);
        this.editorElement.onpaste = this.onChange.bind(this);
        this.editorElement.oninput = this.onChange.bind(this);
        this.editorElement.onkeydown = this.moveCursor.bind(this);
        // Listen for changes on the control to update the editor (if it is updated from outside of this component).
        this.valueChangeSubscription = this.control.valueChanges.subscribe(function (param) {
            _this.setContent(param);
        });
        // Use paragraph on enter.
        document.execCommand('DefaultParagraphSeparator', false, 'p');
        this.resizeFunction = this.maximizeEditorSize.bind(this);
        window.addEventListener('resize', this.resizeFunction);
        var i = 0;
        this.initHeightInterval = setInterval(function () {
            _this.maximizeEditorSize().then(function (height) {
                if (i >= 5 || height != 0) {
                    clearInterval(_this.initHeightInterval);
                }
                i++;
            });
        }, 750);
        this.keyboardObs = this.events.on(__WEBPACK_IMPORTED_MODULE_7__providers_events__["a" /* CoreEventsProvider */].KEYBOARD_CHANGE, function (kbHeight) {
            _this.kbHeight = kbHeight;
            _this.maximizeEditorSize();
        });
    };
    /**
     * Resize editor to maximize the space occupied.
     *
     * @return {Promise<number>} Resolved with calculated editor size.
     */
    CoreRichTextEditorComponent.prototype.maximizeEditorSize = function () {
        var _this = this;
        this.content.resize();
        var deferred = this.utils.promiseDefer();
        setTimeout(function () {
            var contentVisibleHeight = _this.domUtils.getContentHeight(_this.content) - _this.kbHeight;
            if (contentVisibleHeight <= 0) {
                deferred.resolve(0);
                return;
            }
            setTimeout(function () {
                // Editor is ready, adjust Height if needed.
                var height;
                if (_this.platform.is('android')) {
                    // Android, ignore keyboard height because web view is resized.
                    height = _this.domUtils.getContentHeight(_this.content) - _this.getSurroundingHeight(_this.element);
                }
                else if (_this.platform.is('ios') && _this.kbHeight > 0) {
                    // Keyboard open in iOS.
                    // In this case, the header disappears or is scrollable, so we need to adjust the calculations.
                    height = window.innerHeight - _this.getSurroundingHeight(_this.element);
                    if (_this.element.getBoundingClientRect().top < 40) {
                        // In iOS sometimes the editor is placed below the status bar. Move the scroll a bit so it doesn't happen.
                        window.scrollTo(window.scrollX, window.scrollY - 40);
                    }
                }
                else {
                    // Header is fixed, use the content to calculate the editor height.
                    height = _this.domUtils.getContentHeight(_this.content) - _this.kbHeight - _this.getSurroundingHeight(_this.element);
                }
                if (height > _this.minHeight) {
                    _this.element.style.height = _this.domUtils.formatPixelsSize(height);
                }
                else {
                    _this.element.style.height = '';
                }
                deferred.resolve(height);
            }, 100);
        }, 100);
        return deferred.promise;
    };
    /**
     * Get the height of the surrounding elements from the current to the top element.
     *
     * @param  {any} element Directive DOM element to get surroundings elements from.
     * @return {number}      Surrounding height in px.
     */
    CoreRichTextEditorComponent.prototype.getSurroundingHeight = function (element) {
        var height = 0;
        while (element.parentNode && element.parentNode.tagName != 'ION-CONTENT') {
            var parent_1 = element.parentNode;
            if (element.tagName && element.tagName != 'CORE-LOADING') {
                for (var x = 0; x < parent_1.childNodes.length; x++) {
                    var child = parent_1.childNodes[x];
                    if (child.tagName && child != element) {
                        height += this.domUtils.getElementHeight(child, false, true, true);
                    }
                }
            }
            element = parent_1;
        }
        var cs = getComputedStyle(element);
        height += this.domUtils.getComputedStyleMeasure(cs, 'paddingTop') +
            this.domUtils.getComputedStyleMeasure(cs, 'paddingBottom');
        if (element && element.parentNode && element.parentNode.tagName == 'ION-CONTENT') {
            var cs2 = getComputedStyle(element);
            height -= this.domUtils.getComputedStyleMeasure(cs2, 'paddingTop') +
                this.domUtils.getComputedStyleMeasure(cs2, 'paddingBottom');
        }
        return height;
    };
    /**
     * On change function to sync with form data.
     *
     * @param {Event} $event The event.
     */
    CoreRichTextEditorComponent.prototype.onChange = function ($event) {
        if (this.rteEnabled) {
            if (this.isNullOrWhiteSpace(this.editorElement.innerText)) {
                this.clearText();
            }
            else {
                // The textarea and the form control must receive the original URLs.
                this.restoreExternalContent();
                // Don't emit event so our valueChanges doesn't get notified by this change.
                this.control.setValue(this.editorElement.innerHTML, { emitEvent: false });
                this.control.markAsDirty();
                this.textarea.value = this.editorElement.innerHTML;
                // Treat URLs again for the editor.
                this.treatExternalContent();
            }
        }
        else {
            if (this.isNullOrWhiteSpace(this.textarea.value)) {
                this.clearText();
            }
            else {
                // Don't emit event so our valueChanges doesn't get notified by this change.
                this.control.setValue(this.textarea.value, { emitEvent: false });
                this.control.markAsDirty();
            }
        }
        this.contentChanged.emit(this.control.value);
    };
    /**
     * On key down function to move the cursor.
     * https://stackoverflow.com/questions/6249095/how-to-set-caretcursor-position-in-contenteditable-element-div
     *
     * @param {Event} $event The event.
     */
    CoreRichTextEditorComponent.prototype.moveCursor = function ($event) {
        if (!this.rteEnabled) {
            return;
        }
        if ($event['key'] != 'ArrowLeft' && $event['key'] != 'ArrowRight') {
            return;
        }
        $event.preventDefault();
        $event.stopPropagation();
        var move = $event['key'] == 'ArrowLeft' ? -1 : +1, cursor = this.getCurrentCursorPosition(this.editorElement);
        this.setCurrentCursorPosition(this.editorElement, cursor + move);
    };
    /**
     * Returns the number of chars from the beggining where is placed the cursor.
     *
     * @param  {Node}   parent Parent where to get the position from.
     * @return {number}        Position in chars.
     */
    CoreRichTextEditorComponent.prototype.getCurrentCursorPosition = function (parent) {
        var selection = window.getSelection();
        var charCount = -1, node;
        if (selection.focusNode) {
            if (parent.contains(selection.focusNode)) {
                node = selection.focusNode;
                charCount = selection.focusOffset;
                while (node) {
                    if (node.isSameNode(parent)) {
                        break;
                    }
                    if (node.previousSibling) {
                        node = node.previousSibling;
                        charCount += node.textContent.length;
                    }
                    else {
                        node = node.parentNode;
                        if (node === null) {
                            break;
                        }
                    }
                }
            }
        }
        return charCount;
    };
    /**
     * Set the caret position on the character number.
     *
     * @param {Node}   parent   Parent where to set the position.
     * @param {number} [chars]  Number of chars where to place the caret. If not defined it will go to the end.
     */
    CoreRichTextEditorComponent.prototype.setCurrentCursorPosition = function (parent, chars) {
        /**
         * Loops round all the child text nodes within the supplied node and sets a range from the start of the initial node to
         * the characters.
         *
         * @param  {Node}  node  Node where to start.
         * @param  {Range} range Previous calculated range.
         * @param  {any}   chars Object with counting of characters (input-output param).
         * @return {Range}       Selection range.
         */
        var setRange = function (node, range, chars) {
            if (chars.count === 0) {
                range.setEnd(node, 0);
            }
            else if (node && chars.count > 0) {
                if (node.hasChildNodes()) {
                    // Navigate through children.
                    for (var lp = 0; lp < node.childNodes.length; lp++) {
                        range = setRange(node.childNodes[lp], range, chars);
                        if (chars.count === 0) {
                            break;
                        }
                    }
                }
                else if (node.textContent.length < chars.count) {
                    // Jump this node.
                    // @todo: empty nodes will be omitted.
                    chars.count -= node.textContent.length;
                }
                else {
                    // The cursor will be placed in this element.
                    range.setEnd(node, chars.count);
                    chars.count = 0;
                }
            }
            return range;
        };
        var range = document.createRange();
        if (typeof chars === 'undefined') {
            // Select all so it will go to the end.
            range.selectNode(parent);
            range.selectNodeContents(parent);
        }
        else if (chars < 0 || chars > parent.textContent.length) {
            return;
        }
        else {
            range.selectNode(parent);
            range.setStart(parent, 0);
            range = setRange(parent, range, { count: chars });
        }
        if (range) {
            var selection = window.getSelection();
            range.collapse(false);
            selection.removeAllRanges();
            selection.addRange(range);
        }
    };
    /**
     * Toggle from rte editor to textarea syncing values.
     *
     * @param {Event} $event The event.
     */
    CoreRichTextEditorComponent.prototype.toggleEditor = function ($event) {
        var _this = this;
        $event.preventDefault();
        $event.stopPropagation();
        this.setContent(this.control.value);
        this.rteEnabled = !this.rteEnabled;
        // Set focus and cursor at the end.
        setTimeout(function () {
            if (_this.rteEnabled) {
                _this.editorElement.focus();
            }
            else {
                _this.textarea.setFocus();
            }
        });
    };
    /**
     * Treat elements that can contain external content.
     * We only search for images because the editor should receive unfiltered text, so the multimedia filter won't be applied.
     * Treating videos and audios in here is complex, so if a user manually adds one he won't be able to play it in the editor.
     */
    CoreRichTextEditorComponent.prototype.treatExternalContent = function () {
        var _this = this;
        if (!this.sitesProvider.isLoggedIn()) {
            // Only treat external content if the user is logged in.
            return;
        }
        var elements = Array.from(this.editorElement.querySelectorAll('img')), siteId = this.sitesProvider.getCurrentSiteId(), canDownloadFiles = this.sitesProvider.getCurrentSite().canDownloadFiles();
        elements.forEach(function (el) {
            if (el.getAttribute('data-original-src')) {
                // Already treated.
                return;
            }
            var url = el.src;
            if (!url || !_this.urlUtils.isDownloadableUrl(url) || (!canDownloadFiles && _this.urlUtils.isPluginFileUrl(url))) {
                // Nothing to treat.
                return;
            }
            // Check if it's downloaded.
            return _this.filepoolProvider.getSrcByUrl(siteId, url, _this.component, _this.componentId).then(function (finalUrl) {
                // Check again if it's already treated, this function can be called concurrently more than once.
                if (!el.getAttribute('data-original-src')) {
                    el.setAttribute('data-original-src', el.src);
                    el.setAttribute('src', finalUrl);
                }
            });
        });
    };
    /**
     * Reverts changes made by treatExternalContent.
     */
    CoreRichTextEditorComponent.prototype.restoreExternalContent = function () {
        var elements = Array.from(this.editorElement.querySelectorAll('img'));
        elements.forEach(function (el) {
            var originalUrl = el.getAttribute('data-original-src');
            if (originalUrl) {
                el.setAttribute('src', originalUrl);
                el.removeAttribute('data-original-src');
            }
        });
    };
    /**
     * Check if text is empty.
     * @param {string} value text
     */
    CoreRichTextEditorComponent.prototype.isNullOrWhiteSpace = function (value) {
        if (value == null || typeof value == 'undefined') {
            return true;
        }
        value = value.replace(/[\n\r]/g, '');
        value = value.split(' ').join('');
        return value.length === 0;
    };
    /**
     * Set the content of the textarea and the editor element.
     *
     * @param {string} value New content.
     */
    CoreRichTextEditorComponent.prototype.setContent = function (value) {
        if (this.isNullOrWhiteSpace(value)) {
            this.editorElement.innerHTML = '<p></p>';
            this.textarea.value = '';
        }
        else {
            this.editorElement.innerHTML = value;
            this.textarea.value = value;
            this.treatExternalContent();
        }
    };
    /**
     * Clear the text.
     */
    CoreRichTextEditorComponent.prototype.clearText = function () {
        var _this = this;
        this.setContent(null);
        // Don't emit event so our valueChanges doesn't get notified by this change.
        this.control.setValue(null, { emitEvent: false });
        setTimeout(function () {
            if (_this.rteEnabled) {
                _this.setCurrentCursorPosition(_this.editorElement);
            }
        }, 1);
    };
    /**
     * Execute an action over the selected text.
     *  API docs: https://developer.mozilla.org/en-US/docs/Web/API/Document/execCommand
     *
     * @param {any} $event Event data
     * @param {string} command Command to execute.
     */
    CoreRichTextEditorComponent.prototype.buttonAction = function ($event, command) {
        $event.preventDefault();
        $event.stopPropagation();
        if (command) {
            if (command.includes('|')) {
                var parameters = command.split('|')[1];
                command = command.split('|')[0];
                document.execCommand(command, false, parameters);
            }
            else {
                document.execCommand(command, false);
            }
        }
    };
    /**
     * Component being destroyed.
     */
    CoreRichTextEditorComponent.prototype.ngOnDestroy = function () {
        this.valueChangeSubscription && this.valueChangeSubscription.unsubscribe();
        window.removeEventListener('resize', this.resizeFunction);
        clearInterval(this.initHeightInterval);
        this.keyboardObs && this.keyboardObs.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreRichTextEditorComponent.prototype, "placeholder", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_8__angular_forms__["b" /* FormControl */])
    ], CoreRichTextEditorComponent.prototype, "control", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreRichTextEditorComponent.prototype, "name", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreRichTextEditorComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRichTextEditorComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreRichTextEditorComponent.prototype, "contentChanged", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('editor'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreRichTextEditorComponent.prototype, "editor", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('textarea'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["D" /* TextInput */])
    ], CoreRichTextEditorComponent.prototype, "textarea", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('decorate'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreRichTextEditorComponent.prototype, "decorate", void 0);
    CoreRichTextEditorComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-rich-text-editor',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\rich-text-editor\core-rich-text-editor.html"*/'<div [hidden]="!rteEnabled">\n    <div #editor contenteditable="true" class="core-rte-editor" tappable [attr.data-placeholder-text]="placeholder" role="textbox">\n    </div>\n\n    <!-- https://developer.mozilla.org/en-US/docs/Web/API/Document/execCommand -->\n    <div #decorate class="core-rte-toolbar">\n        <div class="core-rte-buttons">\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'bold\')"><core-icon name="fa-bold"></core-icon></button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'italic\')"><core-icon name="fa-italic"></core-icon></button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'underline\')"><core-icon name="fa-underline"></core-icon></button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'strikeThrough\')"><core-icon name="fa-strikethrough"></core-icon></button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'formatBlock|<p>\')"><core-icon name="fa-paragraph"></core-icon></button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'formatBlock|<h1>\')"><core-icon name="fa-header"></core-icon>1</button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'formatBlock|<h2>\')"><core-icon name="fa-header"></core-icon>2</button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'formatBlock|<h3>\')"><core-icon name="fa-header"></core-icon>3</button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'insertUnorderedList\')"><core-icon name="fa-list-ul"></core-icon></button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'insertOrderedList\')"><core-icon name="fa-list-ol"></core-icon></button>\n            <button [core-suppress-events] (onClick)="buttonAction($event, \'removeFormat\')"><core-icon name="fa-eraser"></core-icon></button>\n            <button [core-suppress-events] (onClick)="toggleEditor($event)"><core-icon name="fa-code"></core-icon> {{ \'core.viewcode\' | translate }}</button>\n        </div>\n    </div>\n</div>\n\n<div [hidden]="rteEnabled">\n    <ion-textarea #textarea class="core-textarea" [placeholder]="placeholder" [attr.name]="name" ngControl="control" (ionChange)="onChange($event)" role="textbox"></ion-textarea>\n    <div class="core-rte-toolbar" [hidden]="!editorSupported">\n        <div #decorate class="core-rte-buttons">\n            <button tappable [core-suppress-events] (onClick)="toggleEditor($event)"><core-icon name="fa-pencil-square-o"></core-icon> {{ \'core.vieweditor\' | translate }}</button>\n        </div>\n    </div>\n</div>\n\n\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\rich-text-editor\core-rich-text-editor.html"*/
        }),
        __param(4, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_7__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */]])
    ], CoreRichTextEditorComponent);
    return CoreRichTextEditorComponent;
}());

//# sourceMappingURL=rich-text-editor.js.map

/***/ }),
/* 994 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreInfiniteLoadingComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};



/**
 * Component to show a infinite loading trigger and spinner while more data is being loaded.
 *
 * Usage:
 * <core-infinite-loading [action]="loadingAction" [enabled]="dataLoaded"></core-inifinite-loading>
 */
var CoreInfiniteLoadingComponent = /** @class */ (function () {
    function CoreInfiniteLoadingComponent(content, domUtils) {
        this.content = content;
        this.domUtils = domUtils;
        this.error = false;
        this.position = 'bottom';
        this.loadingMore = false; // Hide button and avoid loading more.
        this.action = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Detect changes on input properties.
     *
     * @param {SimpleChange}} changes Changes.
     */
    CoreInfiniteLoadingComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        if (changes.enabled && this.enabled && this.position == 'bottom') {
            // Infinite scroll enabled. If the list doesn't fill the full height, infinite scroll isn't triggered automatically.
            // Send a fake scroll event to make infinite scroll check if it should load more items.
            setTimeout(function () {
                var event = new Event('scroll');
                _this.content.ionScroll.emit(event);
            }, 400);
        }
    };
    /**
     * Load More items calling the action provided.
     *
     * @param {InfiniteScroll} [infiniteScroll] Infinite scroll object only if triggered from the scroll.
     */
    CoreInfiniteLoadingComponent.prototype.loadMore = function (infiniteScroll) {
        if (this.loadingMore) {
            return;
        }
        if (infiniteScroll) {
            this.infiniteScroll = infiniteScroll;
        }
        this.loadingMore = true;
        this.action.emit(this.complete.bind(this));
    };
    /**
     * Complete loading.
     */
    CoreInfiniteLoadingComponent.prototype.complete = function () {
        if (this.position == 'top') {
            // Wait a bit before allowing loading more, otherwise it could be re-triggered automatically when it shouldn't.
            setTimeout(this.completeLoadMore.bind(this), 400);
        }
        else {
            this.completeLoadMore();
        }
    };
    /**
     * Complete loading.
     */
    CoreInfiniteLoadingComponent.prototype.completeLoadMore = function () {
        var _this = this;
        this.loadingMore = false;
        this.infiniteScroll && this.infiniteScroll.complete();
        this.infiniteScroll = undefined;
        // More items loaded. If the list doesn't fill the full height, infinite scroll isn't triggered automatically.
        // Send a fake scroll event to make infinite scroll check if it should load more items.
        setTimeout(function () {
            var event = new Event('scroll');
            _this.content.ionScroll.emit(event);
        });
    };
    /**
     * Get the height of the element.
     *
     * @return {number} Height.
     */
    CoreInfiniteLoadingComponent.prototype.getHeight = function () {
        return this.getElementHeight(this.topButton) + this.getElementHeight(this.infiniteEl) +
            this.getElementHeight(this.bottomButton) + this.getElementHeight(this.spinnerContainer);
    };
    /**
     * Get the height of an element.
     *
     * @param {ElementRef} element Element ref.
     * @return {number} Height.
     */
    CoreInfiniteLoadingComponent.prototype.getElementHeight = function (element) {
        if (element && element.nativeElement) {
            return this.domUtils.getElementHeight(element.nativeElement, true, true, true);
        }
        return 0;
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreInfiniteLoadingComponent.prototype, "enabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreInfiniteLoadingComponent.prototype, "error", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreInfiniteLoadingComponent.prototype, "position", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreInfiniteLoadingComponent.prototype, "action", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('topbutton'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreInfiniteLoadingComponent.prototype, "topButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('infinitescroll'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreInfiniteLoadingComponent.prototype, "infiniteEl", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('bottombutton'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreInfiniteLoadingComponent.prototype, "bottomButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('spinnercontainer'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreInfiniteLoadingComponent.prototype, "spinnerContainer", void 0);
    CoreInfiniteLoadingComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-infinite-loading',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\infinite-loading\core-infinite-loading.html"*/'<ng-container *ngIf="!loadingMore && position != \'top\'">\n    <div *ngIf="enabled || error" padding-horizontal #bottombutton>\n        <button *ngIf="!error" ion-button block (click)="loadMore()" color="light">\n            {{ \'core.loadmore\' | translate }}\n        </button>\n        <button *ngIf="error" ion-button block (click)="loadMore()" color="light">\n            {{ \'core.tryagain\' | translate }}\n        </button>\n    </div>\n</ng-container>\n\n<ion-infinite-scroll [enabled]="enabled && !error && !loadingMore" (ionInfinite)="loadMore($event)" [position]="position" #infinitescroll>\n    <ion-infinite-scroll-content></ion-infinite-scroll-content>\n</ion-infinite-scroll>\n\n<ng-container *ngIf="!loadingMore && position == \'top\'">\n    <div *ngIf="enabled || error" padding-horizontal #topbutton>\n        <button *ngIf="!error" ion-button block (click)="loadMore()" color="light">\n            {{ \'core.loadmore\' | translate }}\n        </button>\n        <button *ngIf="error" ion-button block (click)="loadMore()" color="light">\n            {{ \'core.tryagain\' | translate }}\n        </button>\n    </div>\n</ng-container>\n\n<div *ngIf="loadingMore" padding text-center #spinnercontainer>\n    <ion-spinner></ion-spinner>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\infinite-loading\core-infinite-loading.html"*/,
        }),
        __param(0, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], CoreInfiniteLoadingComponent);
    return CoreInfiniteLoadingComponent;
}());

//# sourceMappingURL=infinite-loading.js.map

/***/ }),
/* 995 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_comments_components_components_module__ = __webpack_require__(280);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__entries_entries__ = __webpack_require__(763);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









var AddonBlogComponentsModule = /** @class */ (function () {
    function AddonBlogComponentsModule() {
    }
    AddonBlogComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__entries_entries__["a" /* AddonBlogEntriesComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_comments_components_components_module__["a" /* CoreCommentsComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__entries_entries__["a" /* AddonBlogEntriesComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_8__entries_entries__["a" /* AddonBlogEntriesComponent */]
            ]
        })
    ], AddonBlogComponentsModule);
    return AddonBlogComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 996 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__course_course__ = __webpack_require__(764);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonCompetencyComponentsModule = /** @class */ (function () {
    function AddonCompetencyComponentsModule() {
    }
    AddonCompetencyComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__course_course__["a" /* AddonCompetencyCourseComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__course_course__["a" /* AddonCompetencyCourseComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__course_course__["a" /* AddonCompetencyCourseComponent */]
            ]
        })
    ], AddonCompetencyComponentsModule);
    return AddonCompetencyComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 997 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCourseCompletionComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__report_report__ = __webpack_require__(765);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonCourseCompletionComponentsModule = /** @class */ (function () {
    function AddonCourseCompletionComponentsModule() {
    }
    AddonCourseCompletionComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__report_report__["a" /* AddonCourseCompletionReportComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__report_report__["a" /* AddonCourseCompletionReportComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__report_report__["a" /* AddonCourseCompletionReportComponent */]
            ]
        })
    ], AddonCourseCompletionComponentsModule);
    return AddonCourseCompletionComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 998 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonFilesHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_fileuploader_providers_helper__ = __webpack_require__(122);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__files__ = __webpack_require__(283);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Service that provides some features regarding private and site files.
 */
var AddonFilesHelperProvider = /** @class */ (function () {
    function AddonFilesHelperProvider(sitesProvider, fileUploaderHelper, filesProvider, domUtils) {
        this.sitesProvider = sitesProvider;
        this.fileUploaderHelper = fileUploaderHelper;
        this.filesProvider = filesProvider;
        this.domUtils = domUtils;
    }
    /**
     * Select a file, upload it and move it to private files.
     *
     * @param {any} [info] Private files info. See AddonFilesProvider.getPrivateFilesInfo.
     * @return {Promise<any>} Promise resolved when a file is uploaded, rejected otherwise.
     */
    AddonFilesHelperProvider.prototype.uploadPrivateFile = function (info) {
        var _this = this;
        // Calculate the max size.
        var currentSite = this.sitesProvider.getCurrentSite();
        var maxSize = currentSite.getInfo().usermaxuploadfilesize, userQuota = currentSite.getInfo().userquota;
        if (userQuota === 0) {
            // 0 means ignore user quota. In the app it is -1.
            userQuota = -1;
        }
        else if (userQuota > 0 && typeof info != 'undefined') {
            userQuota = userQuota - info.filesizewithoutreferences;
        }
        if (typeof userQuota != 'undefined') {
            // Use the minimum value.
            maxSize = Math.min(maxSize, userQuota);
        }
        // Select and upload the file.
        return this.fileUploaderHelper.selectAndUploadFile(maxSize).then(function (result) {
            if (!result) {
                return Promise.reject(null);
            }
            // File uploaded. Move it to private files.
            var modal = _this.domUtils.showModalLoading('core.fileuploader.uploading', true);
            return _this.filesProvider.moveFromDraftToPrivate(result.itemid).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'core.fileuploader.errorwhileuploading', true);
                return Promise.reject(null);
            }).finally(function () {
                modal.dismiss();
            });
        }).then(function () {
            _this.domUtils.showToast('core.fileuploader.fileuploaded', true, undefined, 'core-toast-success');
        });
    };
    AddonFilesHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__core_fileuploader_providers_helper__["a" /* CoreFileUploaderHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_4__files__["a" /* AddonFilesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonFilesHelperProvider);
    return AddonFilesHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 999 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseSectionPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_format_delegate__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_sync__ = __webpack_require__(352);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__components_format_format__ = __webpack_require__(350);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__components_tabs_tabs__ = __webpack_require__(151);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_oucrest_oucrest__ = __webpack_require__(90);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


















/**
 * Page that displays the list of courses the user is enrolled in.
 */
var CoreCourseSectionPage = /** @class */ (function () {
    function CoreCourseSectionPage(navParams, courseProvider, domUtils, courseFormatDelegate, courseOptionsDelegate, translate, courseHelper, eventsProvider, textUtils, coursesProvider, sitesProvider, navCtrl, injector, prefetchDelegate, syncProvider, utils, rest, event) {
        var _this = this;
        this.courseProvider = courseProvider;
        this.domUtils = domUtils;
        this.courseFormatDelegate = courseFormatDelegate;
        this.courseOptionsDelegate = courseOptionsDelegate;
        this.translate = translate;
        this.courseHelper = courseHelper;
        this.textUtils = textUtils;
        this.coursesProvider = coursesProvider;
        this.navCtrl = navCtrl;
        this.injector = injector;
        this.prefetchDelegate = prefetchDelegate;
        this.syncProvider = syncProvider;
        this.utils = utils;
        this.rest = rest;
        this.event = event;
        this.courseMenuHandlers = [];
        this.downloadEnabled = false;
        this.downloadEnabledIcon = 'square-outline'; // Disabled by default.
        this.prefetchCourseData = {
            prefetchCourseIcon: 'spinner',
            title: 'core.course.downloadcourse'
        };
        this.isDestroyed = false;
        this.titleList = [];
        this.course = navParams.get('course');
        this.sectionId = navParams.get('sectionId');
        this.sectionNumber = navParams.get('sectionNumber');
        this.module = navParams.get('module');
        this.firstTabName = navParams.get('selectedTab');
        this.modParams = navParams.get('modParams');
        // Get the title to display. We dont't have sections yet.
        this.title = courseFormatDelegate.getCourseTitle(this.course);
        this.displayEnableDownload = !sitesProvider.getCurrentSite().isOfflineDisabled() &&
            courseFormatDelegate.displayEnableDownload(this.course);
        this.downloadCourseEnabled = !this.coursesProvider.isDownloadCourseDisabledInSite();
        this.token = sitesProvider.getCurrentSite().getToken();
        this.siteUrl = sitesProvider.getCurrentSite().getURL();
        // Check if the course format requires the view to be refreshed when completion changes.
        courseFormatDelegate.shouldRefreshWhenCompletionChanges(this.course).then(function (shouldRefresh) {
            if (shouldRefresh) {
                _this.completionObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].COMPLETION_MODULE_VIEWED, function (data) {
                    if (data && data.courseId == _this.course.id) {
                        _this.refreshAfterCompletionChange(true);
                    }
                });
                _this.syncObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* CoreCourseSyncProvider */].AUTO_SYNCED, function (data) {
                    if (data && data.courseId == _this.course.id) {
                        _this.refreshAfterCompletionChange(false);
                        if (data.warnings && data.warnings[0]) {
                            _this.domUtils.showErrorModal(data.warnings[0]);
                        }
                    }
                });
            }
        });
        if (this.downloadCourseEnabled) {
            // Listen for changes in course status.
            this.courseStatusObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].COURSE_STATUS_CHANGED, function (data) {
                if (data.courseId == _this.course.id || data.courseId == __WEBPACK_IMPORTED_MODULE_8__providers_course__["a" /* CoreCourseProvider */].ALL_COURSES_CLEARED) {
                    _this.updateCourseStatus(data.status);
                }
            }, sitesProvider.getCurrentSiteId());
        }
        var expanid = -1;
        this.event.subscribe('openexpends', function (userEventData) {
            _this.sections.forEach(function (element, index) {
                if (element.id == userEventData.id) {
                    expanid = index;
                    element.isShowExpands = !element.isShowExpands;
                }
            });
            for (var i = expanid + 1; i < _this.sections.length; i++) {
                if (_this.sections[i].isThemTitle) {
                    return;
                }
                else {
                    _this.sections[i].isShowExpands = !_this.sections[i].isShowExpands;
                }
            }
        });
    }
    CoreCourseSectionPage.prototype.doLoadFirstTitle = function () {
        var _this = this;
        var param = {
            // wstoke:'8d2f5c6dd3eaf86749111c5e9ad70d0d',
            courseid: this.course.id
        };
        if (this.siteUrl != null) {
            this.getCourseId = this.siteUrl + '/get_course_sections.php';
        }
        else {
            this.getCourseId = 'http://zongbu.ouchn.cn/get_course_sections.php';
        }
        this.rest.httpOucPost(this.getCourseId, param, function (d) {
            //   console.log(JSON.parse(d.parentIDs));
            //   this.titleList=JSON.parse(d.parentIDs);
            _this.titleList = d.parentIDs;
            // this.params = this.params || {};
            // Object.assign(this.params, { course: d.courses[0] });
            // this.navCtrl.push('CoreCourseSectionPage', this.params);
        }, false);
    };
    /**
     * View loaded.
     */
    CoreCourseSectionPage.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.doLoadFirstTitle();
        if (this.module) {
            this.moduleId = this.module.id;
            this.courseHelper.openModule(this.navCtrl, this.module, this.course.id, this.sectionId, this.modParams);
        }
        this.loadData(false, true).finally(function () {
            var DeleteIndex = -1;
            _this.sections.forEach(function (element, index) {
                if (element.section === 0) {
                    DeleteIndex = index;
                }
                _this.titleList.forEach(function (titles) {
                    if (titles.sectionid == element.id) {
                        element.isShowExpands = true;
                        element.isThemTitle = true;
                    }
                });
            });
            _this.sections.splice(DeleteIndex, 1);
            for (var i = 1; i < _this.sections.length; i++) {
                if (_this.sections[i].isThemTitle) {
                    break;
                }
                else {
                    _this.sections[i].isShowExpands = true;
                }
            }
            console.log(_this.sections);
            _this.dataLoaded = true;
            if (!_this.downloadCourseEnabled) {
                // Cannot download the whole course, stop.
                return;
            }
            // Determine the course prefetch status.
            _this.determineCoursePrefetchIcon().then(function () {
                if (_this.prefetchCourseData.prefetchCourseIcon == 'spinner') {
                    // Course is being downloaded. Get the download promise.
                    var promise = _this.courseHelper.getCourseDownloadPromise(_this.course.id);
                    if (promise) {
                        // There is a download promise. Show an error if it fails.
                        promise.catch(function (error) {
                            if (!_this.isDestroyed) {
                                _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
                            }
                        });
                    }
                    else {
                        // No download, this probably means that the app was closed while downloading. Set previous status.
                        _this.courseProvider.setCoursePreviousStatus(_this.course.id).then(function (status) {
                            _this.updateCourseStatus(status);
                        });
                    }
                }
            });
        });
        this.doRefresh();
    };
    /**
     * Fetch and load all the data required for the view.
     *
     * @param {boolean} [refresh] If it's refreshing content.
     * @param {boolean} [sync] If it should try to sync.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseSectionPage.prototype.loadData = function (refresh, sync) {
        var _this = this;
        // First of all, get the course because the data might have changed.
        return this.courseHelper.getCourse(this.course.id).then(function (result) {
            return result.course;
        }).catch(function () {
            // Error getting the course, probably guest access.
        }).then(function (course) {
            if (course) {
                if (_this.course.id === course.id && _this.course.hasOwnProperty('displayname')
                    && !course.hasOwnProperty('displayname')) {
                    course.displayname = _this.course.displayname;
                }
                _this.course = course;
            }
            if (sync) {
                // Try to synchronize the course data.
                return _this.syncProvider.syncCourse(_this.course.id).then(function (result) {
                    if (result.warnings && result.warnings.length) {
                        _this.domUtils.showErrorModal(result.warnings[0]);
                    }
                }).catch(function () {
                    // For now we don't allow manual syncing, so ignore errors.
                });
            }
        }).then(function () {
            var promises = [];
            // Get all the sections.
            promises.push(_this.courseProvider.getSections(_this.course.id, false, true).then(function (sections) {
                if (refresh) {
                    // Invalidate the recently downloaded module list. To ensure info can be prefetched.
                    var modules = _this.courseProvider.getSectionsModules(sections);
                    return _this.prefetchDelegate.invalidateModules(modules, _this.course.id).then(function () {
                        return sections;
                    });
                }
                else {
                    return sections;
                }
            }).then(function (sections) {
                var promise;
                // Add log in Moodle.
                _this.courseProvider.logView(_this.course.id, _this.sectionNumber, undefined, _this.course.fullname).catch(function () {
                    // Ignore errors.
                });
                // Get the completion status.
                if (_this.course.enablecompletion === false) {
                    // Completion not enabled.
                    promise = Promise.resolve({});
                }
                else {
                    var sectionWithModules = sections.find(function (section) {
                        return section.modules.length > 0;
                    });
                    if (sectionWithModules && typeof sectionWithModules.modules[0].completion != 'undefined') {
                        // The module already has completion (3.6 onwards). Load the offline completion.
                        promise = _this.courseHelper.loadOfflineCompletion(_this.course.id, sections).catch(function () {
                            // It shouldn't happen.
                        }).then(function () {
                            return {};
                        });
                    }
                    else {
                        promise = _this.courseProvider.getActivitiesCompletionStatus(_this.course.id).catch(function () {
                            // It failed, don't use completion.
                            return {};
                        });
                    }
                }
                return promise.then(function (completionStatus) {
                    _this.courseHelper.addHandlerDataForModules(sections, _this.course.id, completionStatus, _this.course.fullname);
                    // Format the name of each section and check if it has content.
                    _this.sections = sections.map(function (section) {
                        _this.textUtils.formatText(section.name.trim(), true, true).then(function (name) {
                            section.formattedName = name;
                        });
                        section.hasContent = _this.courseHelper.sectionHasContent(section);
                        return section;
                    });
                    if (_this.courseFormatDelegate.canViewAllSections(_this.course)) {
                        // Add a fake first section (all sections).
                        _this.sections.unshift({
                            name: _this.translate.instant('core.course.allsections'),
                            id: __WEBPACK_IMPORTED_MODULE_8__providers_course__["a" /* CoreCourseProvider */].ALL_SECTIONS_ID,
                            hasContent: true
                        });
                    }
                    // Get the title again now that we have sections.
                    _this.title = _this.courseFormatDelegate.getCourseTitle(_this.course, _this.sections);
                    // Get whether to show the refresher now that we have sections.
                    _this.displayRefresher = _this.courseFormatDelegate.displayRefresher(_this.course, _this.sections);
                });
            }));
            // Get the overview files.
            if (_this.course.overviewfiles) {
                _this.course.imageThumb = _this.course.overviewfiles[0] && _this.course.overviewfiles[0].fileurl;
            }
            // Load the course handlers.
            promises.push(_this.courseOptionsDelegate.getHandlersToDisplay(_this.injector, _this.course, refresh, false)
                .then(function (handlers) {
                var tabToLoad;
                // Add the courseId to the handler component data.
                handlers.forEach(function (handler, index) {
                    handler.data.componentData = handler.data.componentData || {};
                    handler.data.componentData.courseId = _this.course.id;
                    // Check if this handler should be the first selected tab.
                    if (_this.firstTabName && handler.name == _this.firstTabName) {
                        tabToLoad = index + 1;
                    }
                });
                _this.courseHandlers = handlers;
                // Select the tab if needed.
                _this.firstTabName = undefined;
                if (tabToLoad) {
                    setTimeout(function () {
                        _this.tabsComponent.selectTab(tabToLoad);
                    });
                }
            }));
            // Load the course menu handlers.
            promises.push(_this.courseOptionsDelegate.getMenuHandlersToDisplay(_this.injector, _this.course).then(function (handlers) {
                _this.courseMenuHandlers = handlers;
            }));
            // Load the course format options when course completion is enabled to show completion progress on sections.
            if (_this.course.enablecompletion && _this.coursesProvider.isGetCoursesByFieldAvailable()) {
                promises.push(_this.coursesProvider.getCourseByField('id', _this.course.id).catch(function () {
                    // Ignore errors.
                }).then(function (course) {
                    course && Object.assign(_this.course, course);
                    if (_this.course.courseformatoptions) {
                        _this.course.courseformatoptions = _this.utils.objectToKeyValueMap(_this.course.courseformatoptions, 'name', 'value');
                    }
                }));
            }
            return Promise.all(promises).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'core.course.couldnotloadsectioncontent', true);
            });
        });
    };
    /**
     * Refresh the data.
     *
     * @param  {any} [refresher] Refresher.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCourseSectionPage.prototype.doRefresh = function (refresher) {
        var _this = this;
        return this.invalidateData().finally(function () {
            return _this.loadData(true, true).finally(function () {
                var DeleteIndex = -1;
                _this.sections.forEach(function (element, index) {
                    if (element.section === 0) {
                        DeleteIndex = index;
                    }
                    _this.titleList.forEach(function (titles) {
                        if (titles.sectionid == element.id) {
                            element.isThemTitle = true;
                        }
                    });
                });
                _this.sections.splice(DeleteIndex, 1);
                for (var i = 1; i < _this.sections.length; i++) {
                    if (_this.sections[i].isThemTitle) {
                        break;
                    }
                    else {
                        _this.sections[i].isShowExpands = true;
                    }
                }
                console.log(_this.sections);
                /* Do not call doRefresh on the format component if the refresher is defined in the format component
                   to prevent an inifinite loop. */
                var promise;
                if (_this.displayRefresher) {
                    promise = _this.formatComponent.doRefresh(refresher);
                }
                else {
                    promise = Promise.resolve();
                }
                return promise.finally(function () {
                    refresher && refresher.complete();
                });
            });
        });
    };
    /**
     * The completion of any of the modules have changed.
     */
    CoreCourseSectionPage.prototype.onCompletionChange = function (completionData) {
        var _this = this;
        var shouldReload = !completionData.hasOwnProperty('valueused') || completionData.valueused;
        this.invalidateData().finally(function () {
            if (shouldReload) {
                _this.refreshAfterCompletionChange(true);
            }
        });
    };
    /**
     * Invalidate the data.
     */
    CoreCourseSectionPage.prototype.invalidateData = function () {
        var promises = [];
        promises.push(this.courseProvider.invalidateSections(this.course.id));
        promises.push(this.coursesProvider.invalidateUserCourses());
        promises.push(this.courseFormatDelegate.invalidateData(this.course, this.sections));
        if (this.sections) {
            promises.push(this.prefetchDelegate.invalidateCourseUpdates(this.course.id));
        }
        return Promise.all(promises);
    };
    /**
     * Refresh list after a completion change since there could be new activities.
     *
     * @param {boolean} [sync] If it should try to sync.
     */
    CoreCourseSectionPage.prototype.refreshAfterCompletionChange = function (sync) {
        var _this = this;
        // Save scroll position to restore it once done.
        var scrollElement = this.content.getScrollElement(), scrollTop = scrollElement.scrollTop || 0, scrollLeft = scrollElement.scrollLeft || 0;
        this.dataLoaded = false;
        this.domUtils.scrollToTop(this.content); // Scroll top so the spinner is seen.
        this.loadData(true, sync).then(function () {
            var DeleteIndex = -1;
            _this.sections.forEach(function (element, index) {
                if (element.section === 0) {
                    DeleteIndex = index;
                }
                _this.titleList.forEach(function (titles) {
                    if (titles.sectionid == element.id) {
                        element.isShowExpands = true;
                        element.isThemTitle = true;
                    }
                });
            });
            _this.sections.splice(DeleteIndex, 1);
            for (var i = 1; i < _this.sections.length; i++) {
                if (_this.sections[i].isThemTitle) {
                    break;
                }
                else {
                    _this.sections[i].isShowExpands = true;
                }
            }
            return _this.formatComponent.doRefresh(undefined, undefined, true);
        }).finally(function () {
            _this.dataLoaded = true;
            // Wait for new content height to be calculated and scroll without animation.
            setTimeout(function () {
                _this.content.scrollTo(scrollLeft, scrollTop, 0);
            });
        });
    };
    /**
     * Determines the prefetch icon of the course.
     *
     * @return {Promise<void>} Promise resolved when done.
     */
    CoreCourseSectionPage.prototype.determineCoursePrefetchIcon = function () {
        var _this = this;
        return this.courseHelper.getCourseStatusIconAndTitle(this.course.id).then(function (data) {
            _this.prefetchCourseData.prefetchCourseIcon = data.icon;
            _this.prefetchCourseData.title = data.title;
        });
    };
    /**
     * Prefetch the whole course.
     */
    CoreCourseSectionPage.prototype.prefetchCourse = function () {
        var _this = this;
        this.courseHelper.confirmAndPrefetchCourse(this.prefetchCourseData, this.course, this.sections, this.courseHandlers, this.courseMenuHandlers)
            .then(function () {
            if (_this.downloadEnabled) {
                // Recalculate the status.
                _this.courseHelper.calculateSectionsStatus(_this.sections, _this.course.id).catch(function () {
                    // Ignore errors (shouldn't happen).
                });
            }
        }).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
            }
        });
    };
    /**
     * Toggle download enabled.
     */
    CoreCourseSectionPage.prototype.toggleDownload = function () {
        this.downloadEnabled = !this.downloadEnabled;
        this.downloadEnabledIcon = this.downloadEnabled ? 'checkbox-outline' : 'square-outline';
    };
    /**
     * Update the course status icon and title.
     *
     * @param {string} status Status to show.
     */
    CoreCourseSectionPage.prototype.updateCourseStatus = function (status) {
        var statusData = this.courseHelper.getCourseStatusIconAndTitleFromStatus(status);
        this.prefetchCourseData.prefetchCourseIcon = statusData.icon;
        this.prefetchCourseData.title = statusData.title;
    };
    /**
     * Open the course summary
     */
    CoreCourseSectionPage.prototype.openCourseSummary = function () {
        this.navCtrl.push('CoreCoursesCoursePreviewPage', { course: this.course, avoidOpenCourse: true });
    };
    /**
     * Opens a menu item registered to the delegate.
     *
     * @param {CoreCourseMenuHandlerToDisplay} item Item to open
     */
    CoreCourseSectionPage.prototype.openMenuItem = function (item) {
        var params = Object.assign({ course: this.course }, item.data.pageParams);
        this.navCtrl.push(item.data.page, params);
    };
    /**
     * Page destroyed.
     */
    CoreCourseSectionPage.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        if (this.completionObserver) {
            this.completionObserver.off();
        }
    };
    /**
     * User entered the page.
     */
    CoreCourseSectionPage.prototype.ionViewDidEnter = function () {
        this.formatComponent && this.formatComponent.ionViewDidEnter();
        this.tabsComponent && this.tabsComponent.ionViewDidEnter();
    };
    /**
     * User left the page.
     */
    CoreCourseSectionPage.prototype.ionViewDidLeave = function () {
        this.formatComponent && this.formatComponent.ionViewDidLeave();
        this.tabsComponent && this.tabsComponent.ionViewDidLeave();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('courseSectionContent'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */])
    ], CoreCourseSectionPage.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_14__components_format_format__["a" /* CoreCourseFormatComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_14__components_format_format__["a" /* CoreCourseFormatComponent */])
    ], CoreCourseSectionPage.prototype, "formatComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_16__components_tabs_tabs__["a" /* CoreTabsComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_16__components_tabs_tabs__["a" /* CoreTabsComponent */])
    ], CoreCourseSectionPage.prototype, "tabsComponent", void 0);
    CoreCourseSectionPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-core-course-section',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\pages\section\section.html"*/'<ion-header>\n    <ion-navbar core-back-button>\n        <ion-title><core-format-text [text]="title"></core-format-text></ion-title>\n\n        <ion-buttons end></ion-buttons>\n    </ion-navbar>\n</ion-header>\n<ion-content>\n    <core-tabs>\n        <!-- Course contents tab. -->\n        <core-tab [title]="\'core.course.contents\' | translate">\n            <ng-template>\n                <core-navbar-buttons>\n                    <core-context-menu>\n                        <core-context-menu-item *ngIf="displayEnableDownload" [priority]="2000" [content]="\'core.settings.showdownloadoptions\' | translate" (action)="toggleDownload()" [iconAction]="downloadEnabledIcon"></core-context-menu-item>\n                        <core-context-menu-item [hidden]="!downloadCourseEnabled" [priority]="1900" [content]="prefetchCourseData.title | translate" (action)="prefetchCourse()" [iconAction]="prefetchCourseData.prefetchCourseIcon" [closeOnClick]="false"></core-context-menu-item>\n                        <core-context-menu-item [priority]="1800" [content]="\'core.course.coursesummary\' | translate" (action)="openCourseSummary()" iconAction="fa-graduation-cap"></core-context-menu-item>\n                        <core-context-menu-item *ngFor="let item of courseMenuHandlers" [priority]="item.priority" (action)="openMenuItem(item)" [content]="item.data.title | translate" [iconAction]="item.data.icon" [class]="item.data.class"></core-context-menu-item>\n                    </core-context-menu>\n                </core-navbar-buttons>\n                <ion-content #courseSectionContent>\n                    <ion-refresher [enabled]="dataLoaded && displayRefresher" (ionRefresh)="doRefresh($event)">\n                        <ion-refresher-content pullingText="{{ \'core.pulltorefresh\' | translate }}"></ion-refresher-content>\n                    </ion-refresher>\n\n                    <core-loading [hideUntil]="dataLoaded">\n                        <core-course-format [course]="course" [sections]="sections" [initialSectionId]="sectionId" [initialSectionNumber]="sectionNumber" [downloadEnabled]="downloadEnabled" [moduleId]="moduleId" (completionChanged)="onCompletionChange($event)"></core-course-format>\n                    </core-loading>\n                </ion-content>\n            </ng-template>\n        </core-tab>\n        <!-- One tab per handler. -->\n        <core-tab *ngFor="let handler of courseHandlers" [title]="handler.data.title | translate" class="{{handler.data.class}}">\n            <ng-template>\n                <core-dynamic-component [component]="handler.data.component" [data]="handler.data.componentData"></core-dynamic-component>\n            </ng-template>\n        </core-tab>\n    </core-tabs>\n</ion-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\pages\section\section.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_8__providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_12__providers_options_delegate__["a" /* CoreCourseOptionsDelegate */],
            __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_9__providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_15__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_11__providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_13__providers_sync__["a" /* CoreCourseSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_17__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["i" /* Events */]])
    ], CoreCourseSectionPage);
    return CoreCourseSectionPage;
}());

//# sourceMappingURL=section.js.map

/***/ }),
/* 1000 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModBookComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(423);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModBookComponentsModule = /** @class */ (function () {
    function AddonModBookComponentsModule() {
    }
    AddonModBookComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModBookIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModBookIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModBookIndexComponent */]
            ]
        })
    ], AddonModBookComponentsModule);
    return AddonModBookComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1001 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(425);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModChoiceComponentsModule = /** @class */ (function () {
    function AddonModChoiceComponentsModule() {
    }
    AddonModChoiceComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModChoiceIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModChoiceIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModChoiceIndexComponent */]
            ]
        })
    ], AddonModChoiceComponentsModule);
    return AddonModChoiceComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1002 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreQuestionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_behaviour_delegate__ = __webpack_require__(77);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Component to render a question.
 */
var CoreQuestionComponent = /** @class */ (function () {
    function CoreQuestionComponent(logger, injector, questionDelegate, utils, behaviourDelegate, questionHelper, translate, questionProvider, domUtils, cdr) {
        this.injector = injector;
        this.questionDelegate = questionDelegate;
        this.utils = utils;
        this.behaviourDelegate = behaviourDelegate;
        this.questionHelper = questionHelper;
        this.translate = translate;
        this.questionProvider = questionProvider;
        this.domUtils = domUtils;
        this.cdr = cdr;
        this.data = {}; // Data to pass to the component.
        this.behaviourComponents = []; // Components to render the question behaviour.
        this.loaded = false;
        logger = logger.getInstance('CoreQuestionComponent');
        this.buttonClicked = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.onAbort = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    CoreQuestionComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.offlineEnabled = this.utils.isTrueOrOne(this.offlineEnabled);
        if (!this.question) {
            this.loaded = true;
            return;
        }
        // Get the component to render the question.
        this.questionDelegate.getComponentForQuestion(this.injector, this.question).then(function (componentClass) {
            _this.componentClass = componentClass;
            if (componentClass) {
                // Set up the data needed by the question and behaviour components.
                _this.data = {
                    question: _this.question,
                    component: _this.component,
                    componentId: _this.componentId,
                    attemptId: _this.attemptId,
                    offlineEnabled: _this.offlineEnabled,
                    buttonClicked: _this.buttonClicked,
                    onAbort: _this.onAbort
                };
                // Treat the question.
                _this.questionHelper.extractQuestionScripts(_this.question, _this.usageId);
                // Handle question behaviour.
                var behaviour = _this.questionDelegate.getBehaviourForQuestion(_this.question, _this.question.preferredBehaviour);
                if (!_this.behaviourDelegate.isBehaviourSupported(behaviour)) {
                    // Behaviour not supported, abort.
                    _this.logger.warn('Aborting question because the behaviour is not supported.', _this.question.name);
                    _this.questionHelper.showComponentError(_this.onAbort, _this.translate.instant('addon.mod_quiz.errorbehaviournotsupported') + ' ' + behaviour);
                    return;
                }
                // Get the sequence check (hidden input). This is required.
                _this.seqCheck = _this.questionHelper.getQuestionSequenceCheckFromHtml(_this.question.html);
                if (!_this.seqCheck) {
                    _this.logger.warn('Aborting question because couldn\'t retrieve sequence check.', _this.question.name);
                    _this.questionHelper.showComponentError(_this.onAbort);
                    return;
                }
                // Load local answers if offline is enabled.
                var promise = void 0;
                if (_this.offlineEnabled) {
                    promise = _this.questionProvider.getQuestionAnswers(_this.component, _this.attemptId, _this.question.slot)
                        .then(function (answers) {
                        _this.question.localAnswers = _this.questionProvider.convertAnswersArrayToObject(answers, true);
                    }).catch(function () {
                        _this.question.localAnswers = {};
                    });
                }
                else {
                    _this.question.localAnswers = {};
                    promise = Promise.resolve();
                }
                promise.then(function () {
                    // Handle behaviour.
                    _this.behaviourDelegate.handleQuestion(_this.injector, _this.question.preferredBehaviour, _this.question)
                        .then(function (comps) {
                        _this.behaviourComponents = comps;
                    }).finally(function () {
                        _this.question.html = _this.domUtils.removeElementFromHtml(_this.question.html, '.im-controls');
                        _this.loaded = true;
                    });
                    _this.questionHelper.extractQbehaviourRedoButton(_this.question);
                    // Extract the validation error of the question.
                    _this.question.validationError = _this.questionHelper.getValidationErrorFromHtml(_this.question.html);
                    // Load the local answers in the HTML.
                    _this.questionHelper.loadLocalAnswersInHtml(_this.question);
                    // Try to extract the feedback and comment for the question.
                    _this.questionHelper.extractQuestionFeedback(_this.question);
                    _this.questionHelper.extractQuestionComment(_this.question);
                });
            }
        }).catch(function () {
            // Ignore errors.
        });
    };
    /**
     * Update the sequence check of the question.
     *
     * @param {any} sequenceChecks Object with sequence checks. The keys are the question slot.
     */
    CoreQuestionComponent.prototype.updateSequenceCheck = function (sequenceChecks) {
        if (sequenceChecks[this.question.slot]) {
            this.seqCheck = sequenceChecks[this.question.slot];
            this.cdr.detectChanges();
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreQuestionComponent.prototype, "question", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreQuestionComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreQuestionComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreQuestionComponent.prototype, "attemptId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreQuestionComponent.prototype, "usageId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreQuestionComponent.prototype, "offlineEnabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreQuestionComponent.prototype, "buttonClicked", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreQuestionComponent.prototype, "onAbort", void 0);
    CoreQuestionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-question',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\question\components\question\core-question.html"*/'\n<!-- Question contents. -->\n<core-dynamic-component *ngIf="loaded" [component]="componentClass" [data]="data" class="core-question-{{question.slot}}">\n    <!-- This content will only be shown if there\'s no component to render the question. -->\n    <p padding>{{ \'core.question.errorquestionnotsupported\' | translate:{$a: question.type} }}</p>\n</core-dynamic-component>\n\n<!-- Sequence check input. -->\n<input *ngIf="seqCheck" type="hidden" name="{{seqCheck.name}}" value="{{seqCheck.value}}" >\n\n<!-- Question behaviour components. -->\n<core-dynamic-component *ngFor="let componentClass of behaviourComponents" [component]="componentClass" [data]="data"></core-dynamic-component>\n\n<!-- Question validation error. -->\n<ion-item text-wrap class="core-danger-item" *ngIf="question.validationError">\n    <p>{{ question.validationError }}</p>\n</ion-item>\n\n<!-- Question behaviour buttons. -->\n<ion-item text-wrap *ngFor="let button of question.behaviourButtons">\n    <button ion-button block (click)="buttonClicked.emit(button)" [disabled]="button.disabled">{{ button.value }}</button>\n</ion-item>\n\n<!-- Question feedback. -->\n<ion-item text-wrap class="core-question-feedback-container" *ngIf="question.feedbackHtml">\n    <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.feedbackHtml"></core-format-text></p>\n</ion-item>\n\n<!-- Question comment. -->\n<ion-item text-wrap class="core-question-comment" *ngIf="question.commentHtml">\n    <p><core-format-text [component]="component" [componentId]="componentId" [text]="question.commentHtml"></core-format-text></p>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\question\components\question\core-question.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_6__providers_delegate__["a" /* CoreQuestionDelegate */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */],
            __WEBPACK_IMPORTED_MODULE_8__providers_helper__["a" /* CoreQuestionHelperProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_5__providers_question__["a" /* CoreQuestionProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectorRef"]])
    ], CoreQuestionComponent);
    return CoreQuestionComponent;
}());

//# sourceMappingURL=question.js.map

/***/ }),
/* 1003 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__index_index__ = __webpack_require__(432);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};







var AddonModFolderComponentsModule = /** @class */ (function () {
    function AddonModFolderComponentsModule() {
    }
    AddonModFolderComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__index_index__["a" /* AddonModFolderIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__index_index__["a" /* AddonModFolderIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__index_index__["a" /* AddonModFolderIndexComponent */]
            ]
        })
    ], AddonModFolderComponentsModule);
    return AddonModFolderComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1004 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__index_index__ = __webpack_require__(435);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__mode_picker_mode_picker__ = __webpack_require__(851);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};










var AddonModGlossaryComponentsModule = /** @class */ (function () {
    function AddonModGlossaryComponentsModule() {
    }
    AddonModGlossaryComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModGlossaryIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__mode_picker_mode_picker__["a" /* AddonModGlossaryModePickerPopoverComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModGlossaryIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__mode_picker_mode_picker__["a" /* AddonModGlossaryModePickerPopoverComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModGlossaryIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_9__mode_picker_mode_picker__["a" /* AddonModGlossaryModePickerPopoverComponent */]
            ]
        })
    ], AddonModGlossaryComponentsModule);
    return AddonModGlossaryComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1005 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(436);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__toc_popover_toc_popover__ = __webpack_require__(855);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









var AddonModImscpComponentsModule = /** @class */ (function () {
    function AddonModImscpComponentsModule() {
    }
    AddonModImscpComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModImscpIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__toc_popover_toc_popover__["a" /* AddonModImscpTocPopoverComponent */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModImscpIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__toc_popover_toc_popover__["a" /* AddonModImscpTocPopoverComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModImscpIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__toc_popover_toc_popover__["a" /* AddonModImscpTocPopoverComponent */]
            ]
        })
    ], AddonModImscpComponentsModule);
    return AddonModImscpComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1006 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(437);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModLessonComponentsModule = /** @class */ (function () {
    function AddonModLessonComponentsModule() {
    }
    AddonModLessonComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModLessonIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModLessonIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModLessonIndexComponent */]
            ]
        })
    ], AddonModLessonComponentsModule);
    return AddonModLessonComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1007 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLtiComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(438);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModLtiComponentsModule = /** @class */ (function () {
    function AddonModLtiComponentsModule() {
    }
    AddonModLtiComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModLtiIndexComponent */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModLtiIndexComponent */],
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModLtiIndexComponent */],
            ]
        })
    ], AddonModLtiComponentsModule);
    return AddonModLtiComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1008 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPageComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__index_index__ = __webpack_require__(439);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









var AddonModPageComponentsModule = /** @class */ (function () {
    function AddonModPageComponentsModule() {
    }
    AddonModPageComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModPageIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModPageIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_8__index_index__["a" /* AddonModPageIndexComponent */]
            ]
        })
    ], AddonModPageComponentsModule);
    return AddonModPageComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1009 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(440);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__connection_error_connection_error__ = __webpack_require__(1010);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









var AddonModQuizComponentsModule = /** @class */ (function () {
    function AddonModQuizComponentsModule() {
    }
    AddonModQuizComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModQuizIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__connection_error_connection_error__["a" /* AddonModQuizConnectionErrorComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModQuizIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__connection_error_connection_error__["a" /* AddonModQuizConnectionErrorComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModQuizIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__connection_error_connection_error__["a" /* AddonModQuizConnectionErrorComponent */]
            ]
        })
    ], AddonModQuizComponentsModule);
    return AddonModQuizComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1010 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizConnectionErrorComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Component that displays a quiz entry page.
 */
var AddonModQuizConnectionErrorComponent = /** @class */ (function () {
    function AddonModQuizConnectionErrorComponent() {
        // Nothing to do.
    }
    AddonModQuizConnectionErrorComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-quiz-connection-error',
            template: '<ion-item text-wrap>{{ "addon.mod_quiz.connectionerror" | translate }}</ion-item>',
        }),
        __metadata("design:paramtypes", [])
    ], AddonModQuizConnectionErrorComponent);
    return AddonModQuizConnectionErrorComponent;
}());

//# sourceMappingURL=connection-error.js.map

/***/ }),
/* 1011 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourceComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(441);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModResourceComponentsModule = /** @class */ (function () {
    function AddonModResourceComponentsModule() {
    }
    AddonModResourceComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModResourceIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModResourceIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModResourceIndexComponent */]
            ]
        })
    ], AddonModResourceComponentsModule);
    return AddonModResourceComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1012 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(443);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModScormComponentsModule = /** @class */ (function () {
    function AddonModScormComponentsModule() {
    }
    AddonModScormComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModScormIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModScormIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModScormIndexComponent */]
            ]
        })
    ], AddonModScormComponentsModule);
    return AddonModScormComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1013 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(444);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModSurveyComponentsModule = /** @class */ (function () {
    function AddonModSurveyComponentsModule() {
    }
    AddonModSurveyComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModSurveyIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModSurveyIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModSurveyIndexComponent */]
            ]
        })
    ], AddonModSurveyComponentsModule);
    return AddonModSurveyComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1014 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModUrlComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(445);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonModUrlComponentsModule = /** @class */ (function () {
    function AddonModUrlComponentsModule() {
    }
    AddonModUrlComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModUrlIndexComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModUrlIndexComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModUrlIndexComponent */]
            ]
        })
    ], AddonModUrlComponentsModule);
    return AddonModUrlComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1015 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__ = __webpack_require__(41);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__index_index__ = __webpack_require__(446);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__subwiki_picker_subwiki_picker__ = __webpack_require__(871);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









var AddonModWikiComponentsModule = /** @class */ (function () {
    function AddonModWikiComponentsModule() {
    }
    AddonModWikiComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModWikiIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__subwiki_picker_subwiki_picker__["a" /* AddonModWikiSubwikiPickerComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModWikiIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__subwiki_picker_subwiki_picker__["a" /* AddonModWikiSubwikiPickerComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__index_index__["a" /* AddonModWikiIndexComponent */],
                __WEBPACK_IMPORTED_MODULE_8__subwiki_picker_subwiki_picker__["a" /* AddonModWikiSubwikiPickerComponent */]
            ]
        })
    ], AddonModWikiComponentsModule);
    return AddonModWikiComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1016 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_helper__ = __webpack_require__(152);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_offline__ = __webpack_require__(133);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_assessment_strategy_delegate__ = __webpack_require__(129);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















/**
 * Component that displays workshop assessment strategy form.
 */
var AddonModWorkshopAssessmentStrategyComponent = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyComponent(translate, injector, eventsProvider, fileSessionProvider, syncProvider, domUtils, textUtils, utils, sitesProvider, uploaderProvider, workshopProvider, workshopHelper, workshopOffline, strategyDelegate) {
        this.translate = translate;
        this.injector = injector;
        this.eventsProvider = eventsProvider;
        this.fileSessionProvider = fileSessionProvider;
        this.syncProvider = syncProvider;
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.utils = utils;
        this.sitesProvider = sitesProvider;
        this.uploaderProvider = uploaderProvider;
        this.workshopProvider = workshopProvider;
        this.workshopHelper = workshopHelper;
        this.workshopOffline = workshopOffline;
        this.strategyDelegate = strategyDelegate;
        this.data = {
            workshopId: 0,
            assessment: null,
            edit: false,
            selectedValues: [],
            fieldErrors: {},
            strategy: ''
        };
        this.assessmentStrategyLoaded = false;
        this.notSupported = false;
        this.feedbackText = '';
        this.feedbackControl = new __WEBPACK_IMPORTED_MODULE_1__angular_forms__["b" /* FormControl */]();
        this.overallFeedkback = false;
        this.overallFeedkbackRequired = false;
        this.component = __WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */].COMPONENT;
        this.originalData = {
            text: '',
            files: [],
            weight: 1,
            selectedValues: []
        };
    }
    /**
     * Component being initialized.
     */
    AddonModWorkshopAssessmentStrategyComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this.assessmentId || !this.strategy) {
            this.assessmentStrategyLoaded = true;
            return;
        }
        this.data.workshopId = this.workshop.id;
        this.data.edit = this.edit;
        this.data.strategy = this.strategy;
        this.componentClass = this.strategyDelegate.getComponentForPlugin(this.injector, this.strategy);
        if (this.componentClass) {
            this.overallFeedkback = !!this.workshop.overallfeedbackmode;
            this.overallFeedkbackRequired = this.workshop.overallfeedbackmode == 2;
            this.componentId = this.workshop.coursemodule;
            // Load Weights selector.
            if (this.edit && this.access.canallocate) {
                this.weights = [];
                for (var i = 16; i >= 0; i--) {
                    this.weights[i] = i;
                }
            }
            // Check if rich text editor is enabled.
            if (this.edit) {
                // Block the workshop.
                this.syncProvider.blockOperation(__WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, this.workshop.id);
            }
            this.load().then(function () {
                _this.obsInvalidated = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */].ASSESSMENT_INVALIDATED, _this.load.bind(_this), _this.sitesProvider.getCurrentSiteId());
            }).finally(function () {
                _this.assessmentStrategyLoaded = true;
            });
        }
        else {
            // Helper data and fallback.
            this.notSupported = !this.strategyDelegate.isPluginSupported(this.strategy);
            this.assessmentStrategyLoaded = true;
        }
    };
    /**
     * Convenience function to load the assessment data.
     *
     * @return {Promise<any>} Promised resvoled when data is loaded.
     */
    AddonModWorkshopAssessmentStrategyComponent.prototype.load = function () {
        var _this = this;
        return this.workshopHelper.getReviewerAssessmentById(this.workshop.id, this.assessmentId, this.userId)
            .then(function (assessmentData) {
            _this.data.assessment = assessmentData;
            var promise;
            if (_this.edit) {
                promise = _this.workshopOffline.getAssessment(_this.workshop.id, _this.assessmentId).then(function (offlineAssessment) {
                    var offlineData = offlineAssessment.inputdata;
                    _this.hasOffline = true;
                    assessmentData.feedbackauthor = offlineData.feedbackauthor;
                    if (_this.access.canallocate) {
                        assessmentData.weight = offlineData.weight;
                    }
                    // Override assessment plugins values.
                    assessmentData.form.current = _this.workshopProvider.parseFields(_this.utils.objectToArrayOfObjects(offlineData, 'name', 'value'));
                    // Override offline files.
                    if (offlineData) {
                        return _this.workshopHelper.getAssessmentFilesFromOfflineFilesObject(offlineData.feedbackauthorattachmentsid, _this.workshop.id, _this.assessmentId)
                            .then(function (files) {
                            assessmentData.feedbackattachmentfiles = files;
                        });
                    }
                }).catch(function () {
                    _this.hasOffline = false;
                    // Ignore errors.
                }).finally(function () {
                    _this.feedbackText = assessmentData.feedbackauthor;
                    _this.feedbackControl.setValue(_this.feedbackText);
                    _this.originalData.text = _this.data.assessment.feedbackauthor;
                    if (_this.access.canallocate) {
                        _this.originalData.weight = assessmentData.weight;
                    }
                    _this.originalData.files = [];
                    assessmentData.feedbackattachmentfiles.forEach(function (file) {
                        var filename;
                        if (file.filename) {
                            filename = file.filename;
                        }
                        else {
                            // We don't have filename, extract it from the path.
                            filename = file.filepath[0] == '/' ? file.filepath.substr(1) : file.filepath;
                        }
                        _this.originalData.files.push({
                            filename: filename,
                            fileurl: file.fileurl
                        });
                    });
                });
            }
            else {
                promise = Promise.resolve();
            }
            return promise.then(function () {
                return _this.strategyDelegate.getOriginalValues(_this.strategy, assessmentData.form, _this.workshop.id)
                    .then(function (values) {
                    _this.data.selectedValues = values;
                }).finally(function () {
                    _this.originalData.selectedValues = _this.utils.clone(_this.data.selectedValues);
                    if (_this.edit) {
                        _this.fileSessionProvider.setFiles(__WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, _this.workshop.id + '_' + _this.assessmentId, assessmentData.feedbackattachmentfiles);
                        if (_this.access.canallocate) {
                            _this.weight = assessmentData.weight;
                        }
                    }
                });
            });
        });
    };
    /**
     * Check if data has changed.
     *
     * @return {boolean} True if data has changed.
     */
    AddonModWorkshopAssessmentStrategyComponent.prototype.hasDataChanged = function () {
        if (!this.assessmentStrategyLoaded) {
            return false;
        }
        // Compare feedback text.
        var text = this.textUtils.restorePluginfileUrls(this.feedbackText, this.data.assessment.feedbackcontentfiles || []);
        if (this.originalData.text != text) {
            return true;
        }
        if (this.access.canallocate && this.originalData.weight != this.weight) {
            return true;
        }
        // Compare feedback files.
        var files = this.fileSessionProvider.getFiles(__WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, this.workshop.id + '_' + this.assessmentId) || [];
        if (this.uploaderProvider.areFileListDifferent(files, this.originalData.files)) {
            return true;
        }
        return this.strategyDelegate.hasDataChanged(this.workshop, this.originalData.selectedValues, this.data.selectedValues);
    };
    /**
     * Save the assessment.
     *
     * @return {Promise<any>} Promise resolved when done, rejected if assessment could not be saved.
     */
    AddonModWorkshopAssessmentStrategyComponent.prototype.saveAssessment = function () {
        var _this = this;
        var files = this.fileSessionProvider.getFiles(__WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, this.workshop.id + '_' + this.assessmentId) || [];
        var saveOffline = false;
        var allowOffline = !files.length;
        var modal = this.domUtils.showModalLoading('core.sending', true);
        this.data.fieldErrors = {};
        // Upload attachments first if any.
        return this.workshopHelper.uploadOrStoreAssessmentFiles(this.workshop.id, this.assessmentId, files, saveOffline).catch(function () {
            // Cannot upload them in online, save them in offline.
            saveOffline = true;
            allowOffline = true;
            return _this.workshopHelper.uploadOrStoreAssessmentFiles(_this.workshop.id, _this.assessmentId, files, saveOffline);
        }).then(function (attachmentsId) {
            var text = _this.textUtils.restorePluginfileUrls(_this.feedbackText, _this.data.assessment.feedbackcontentfiles || []);
            return _this.workshopHelper.prepareAssessmentData(_this.workshop, _this.data.selectedValues, text, files, _this.data.assessment.form, attachmentsId).catch(function (errors) {
                _this.data.fieldErrors = errors;
                return Promise.reject(_this.translate.instant('core.errorinvalidform'));
            });
        }).then(function (assessmentData) {
            if (saveOffline) {
                // Save assessment in offline.
                return _this.workshopOffline.saveAssessment(_this.workshop.id, _this.assessmentId, _this.workshop.course, assessmentData).then(function () {
                    // Don't return anything.
                });
            }
            // Try to send it to server.
            // Don't allow offline if there are attachments since they were uploaded fine.
            return _this.workshopProvider.updateAssessment(_this.workshop.id, _this.assessmentId, _this.workshop.course, assessmentData, false, allowOffline);
        }).then(function (grade) {
            var promises = [];
            // If sent to the server, invalidate and clean.
            if (grade) {
                promises.push(_this.workshopHelper.deleteAssessmentStoredFiles(_this.workshop.id, _this.assessmentId));
                promises.push(_this.workshopProvider.invalidateAssessmentFormData(_this.workshop.id, _this.assessmentId));
                promises.push(_this.workshopProvider.invalidateAssessmentData(_this.workshop.id, _this.assessmentId));
            }
            return Promise.all(promises).catch(function () {
                // Ignore errors.
            }).finally(function () {
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */].ASSESSMENT_SAVED, {
                    workshopId: _this.workshop.id,
                    assessmentId: _this.assessmentId,
                    userId: _this.sitesProvider.getCurrentSiteUserId(),
                }, _this.sitesProvider.getCurrentSiteId());
                if (files) {
                    // Delete the local files from the tmp folder.
                    _this.uploaderProvider.clearTmpFiles(files);
                }
            });
        }).catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'Error saving assessment.');
            return Promise.reject(null);
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Feedback text changed.
     *
     * @param {string} text The new text.
     */
    AddonModWorkshopAssessmentStrategyComponent.prototype.onFeedbackChange = function (text) {
        this.feedbackText = text;
    };
    /**
     * Component destroyed.
     */
    AddonModWorkshopAssessmentStrategyComponent.prototype.ngOnDestroy = function () {
        this.obsInvalidated && this.obsInvalidated.off();
        if (this.data.assessment.feedbackattachmentfiles) {
            // Delete the local files from the tmp folder.
            this.uploaderProvider.clearTmpFiles(this.data.assessment.feedbackattachmentfiles);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentStrategyComponent.prototype, "workshop", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentStrategyComponent.prototype, "access", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWorkshopAssessmentStrategyComponent.prototype, "assessmentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWorkshopAssessmentStrategyComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModWorkshopAssessmentStrategyComponent.prototype, "strategy", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModWorkshopAssessmentStrategyComponent.prototype, "edit", void 0);
    AddonModWorkshopAssessmentStrategyComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-assessment-strategy',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\assessment-strategy\addon-mod-workshop-assessment-strategy.html"*/'<h3 padding>{{ \'addon.mod_workshop.assessmentform\' | translate }}</h3>\n\n<form name="mma-mod_workshop-assessment-form">\n    <core-loading [hideUntil]="assessmentStrategyLoaded">\n        <ng-container *ngIf="componentClass && assessmentStrategyLoaded">\n            <core-dynamic-component [component]="componentClass" [data]="data"></core-dynamic-component>\n        </ng-container>\n\n        <div class="core-info-card" *ngIf="notSupported">\n            {{ \'addon.mod_workshop.assessmentstrategynotsupported\' | translate:{$a: strategy} }}\n        </div>\n\n        <ion-card *ngIf="assessmentStrategyLoaded && overallFeedkback && (edit || data.assessment.feedbackauthor || data.assessment.feedbackattachmentfiles && data.assessment.feedbackattachmentfiles.length) ">\n            <ion-item text-wrap>\n                <h2>{{ \'addon.mod_workshop.overallfeedback\' | translate }}</h2>\n            </ion-item>\n            <ion-item stacked *ngIf="edit">\n                <ion-label stacked [core-mark-required]="overallFeedkbackRequired">{{ \'addon.mod_workshop.feedbackauthor\' | translate }}</ion-label>\n                <core-rich-text-editor item-content [control]="feedbackControl" [component]="component" [componentId]="workshop.coursemodule" (contentChanged)="onFeedbackChange($event)"></core-rich-text-editor>\n                <core-input-errors item-content *ngIf="overallFeedkbackRequired && fieldErrors && fieldErrors[\'feedbackauthor\']" [errorText]="fieldErrors[\'feedbackauthor\']"></core-input-errors>\n            </ion-item>\n            <core-attachments *ngIf="edit && workshop.overallfeedbackfiles" [files]="data.assessment.feedbackattachmentfiles" [maxSize]="workshop.overallfeedbackmaxbytes"\n                [maxSubmissions]="workshop.overallfeedbackfiles" [component]="component" [componentId]="componentId" [allowOffline]="true"></core-attachments>\n            <ion-item *ngIf="edit && access && access.canallocate">\n                <ion-label stacked [core-mark-required]="true">{{ \'addon.mod_workshop.assessmentweight\' | translate }}</ion-label>\n                <ion-select [(ngModel)]="weight" interface="action-sheet">\n                    <ion-option *ngFor="let w of weights" [value]="w">{{w}}</ion-option>\n                </ion-select>\n            </ion-item>\n            <ion-item text-wrap *ngIf="!edit && data.assessment.feedbackauthor">\n                <core-format-text [component]="component" [componentId]="componentId" [text]="data.assessment.feedbackauthor"></core-format-text>\n            </ion-item>\n            <ion-item *ngIf="!edit && workshop.overallfeedbackfiles && data.assessment.feedbackattachmentfiles && data.assessment.feedbackattachmentfiles.length">\n                <div no-lines>\n                    <ng-container *ngFor="let attachment of data.assessment.feedbackattachmentfiles">\n                        <!-- Files already attached to the submission. -->\n                        <core-file *ngIf="!attachment.name" [file]="attachment" [component]="component" [componentId]="componentId"></core-file>\n                        <!-- Files stored in offline to be sent later. -->\n                        <core-local-file *ngIf="attachment.name" [file]="attachment"></core-local-file>\n                    </ng-container>\n                </div>\n            </ion-item>\n        </ion-card>\n    </core-loading>\n</form>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\assessment-strategy\addon-mod-workshop-assessment-strategy.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"],
            __WEBPACK_IMPORTED_MODULE_7__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_file_session__["a" /* CoreFileSessionProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sync__["a" /* CoreSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_workshop__["a" /* AddonModWorkshopProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_helper__["a" /* AddonModWorkshopHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_13__providers_offline__["a" /* AddonModWorkshopOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_14__providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */]])
    ], AddonModWorkshopAssessmentStrategyComponent);
    return AddonModWorkshopAssessmentStrategyComponent;
}());

//# sourceMappingURL=assessment-strategy.js.map

/***/ }),
/* 1017 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__list_list__ = __webpack_require__(878);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonNotesComponentsModule = /** @class */ (function () {
    function AddonNotesComponentsModule() {
    }
    AddonNotesComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__list_list__["a" /* AddonNotesListComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__list_list__["a" /* AddonNotesListComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__list_list__["a" /* AddonNotesListComponent */]
            ]
        })
    ], AddonNotesComponentsModule);
    return AddonNotesComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1018 */,
/* 1019 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__ = __webpack_require__(287);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__app_module__ = __webpack_require__(463);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_promise_prototype_finally__ = __webpack_require__(1892);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_promise_prototype_finally___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_promise_prototype_finally__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_web_animations_js__ = __webpack_require__(1908);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_web_animations_js___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_web_animations_js__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



 // This is needed to make animations work in Android 5.0.
Object(__WEBPACK_IMPORTED_MODULE_2_promise_prototype_finally__["shim"])(); // Support promise.finally.
Object(__WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__["b" /* platformBrowserDynamic */])().bootstrapModule(__WEBPACK_IMPORTED_MODULE_1__app_module__["a" /* AppModule */]);
//# sourceMappingURL=main.js.map

/***/ }),
/* 1020 */,
/* 1021 */,
/* 1022 */,
/* 1023 */,
/* 1024 */,
/* 1025 */,
/* 1026 */,
/* 1027 */,
/* 1028 */,
/* 1029 */,
/* 1030 */,
/* 1031 */,
/* 1032 */,
/* 1033 */,
/* 1034 */,
/* 1035 */,
/* 1036 */,
/* 1037 */,
/* 1038 */,
/* 1039 */,
/* 1040 */,
/* 1041 */,
/* 1042 */,
/* 1043 */,
/* 1044 */,
/* 1045 */,
/* 1046 */,
/* 1047 */,
/* 1048 */,
/* 1049 */,
/* 1050 */,
/* 1051 */,
/* 1052 */,
/* 1053 */,
/* 1054 */,
/* 1055 */,
/* 1056 */,
/* 1057 */,
/* 1058 */,
/* 1059 */,
/* 1060 */,
/* 1061 */,
/* 1062 */,
/* 1063 */,
/* 1064 */,
/* 1065 */,
/* 1066 */,
/* 1067 */,
/* 1068 */,
/* 1069 */,
/* 1070 */,
/* 1071 */,
/* 1072 */,
/* 1073 */,
/* 1074 */,
/* 1075 */,
/* 1076 */,
/* 1077 */,
/* 1078 */,
/* 1079 */,
/* 1080 */,
/* 1081 */,
/* 1082 */,
/* 1083 */,
/* 1084 */,
/* 1085 */,
/* 1086 */,
/* 1087 */,
/* 1088 */,
/* 1089 */,
/* 1090 */,
/* 1091 */,
/* 1092 */,
/* 1093 */,
/* 1094 */,
/* 1095 */,
/* 1096 */,
/* 1097 */,
/* 1098 */,
/* 1099 */,
/* 1100 */,
/* 1101 */,
/* 1102 */,
/* 1103 */,
/* 1104 */,
/* 1105 */,
/* 1106 */,
/* 1107 */,
/* 1108 */,
/* 1109 */,
/* 1110 */,
/* 1111 */,
/* 1112 */,
/* 1113 */,
/* 1114 */,
/* 1115 */,
/* 1116 */,
/* 1117 */,
/* 1118 */,
/* 1119 */,
/* 1120 */,
/* 1121 */,
/* 1122 */,
/* 1123 */,
/* 1124 */,
/* 1125 */,
/* 1126 */,
/* 1127 */,
/* 1128 */,
/* 1129 */,
/* 1130 */,
/* 1131 */,
/* 1132 */,
/* 1133 */,
/* 1134 */,
/* 1135 */,
/* 1136 */,
/* 1137 */,
/* 1138 */,
/* 1139 */,
/* 1140 */,
/* 1141 */,
/* 1142 */,
/* 1143 */,
/* 1144 */,
/* 1145 */,
/* 1146 */,
/* 1147 */,
/* 1148 */,
/* 1149 */,
/* 1150 */,
/* 1151 */,
/* 1152 */,
/* 1153 */,
/* 1154 */,
/* 1155 */,
/* 1156 */,
/* 1157 */,
/* 1158 */,
/* 1159 */,
/* 1160 */,
/* 1161 */,
/* 1162 */,
/* 1163 */,
/* 1164 */,
/* 1165 */,
/* 1166 */,
/* 1167 */,
/* 1168 */,
/* 1169 */,
/* 1170 */,
/* 1171 */,
/* 1172 */,
/* 1173 */,
/* 1174 */,
/* 1175 */,
/* 1176 */,
/* 1177 */,
/* 1178 */,
/* 1179 */,
/* 1180 */,
/* 1181 */,
/* 1182 */,
/* 1183 */,
/* 1184 */,
/* 1185 */,
/* 1186 */,
/* 1187 */,
/* 1188 */,
/* 1189 */,
/* 1190 */,
/* 1191 */,
/* 1192 */,
/* 1193 */,
/* 1194 */,
/* 1195 */,
/* 1196 */,
/* 1197 */,
/* 1198 */,
/* 1199 */,
/* 1200 */,
/* 1201 */,
/* 1202 */,
/* 1203 */,
/* 1204 */,
/* 1205 */,
/* 1206 */,
/* 1207 */,
/* 1208 */,
/* 1209 */,
/* 1210 */,
/* 1211 */,
/* 1212 */,
/* 1213 */,
/* 1214 */,
/* 1215 */,
/* 1216 */,
/* 1217 */,
/* 1218 */,
/* 1219 */,
/* 1220 */,
/* 1221 */,
/* 1222 */,
/* 1223 */,
/* 1224 */,
/* 1225 */,
/* 1226 */,
/* 1227 */,
/* 1228 */,
/* 1229 */,
/* 1230 */,
/* 1231 */,
/* 1232 */,
/* 1233 */,
/* 1234 */,
/* 1235 */,
/* 1236 */,
/* 1237 */,
/* 1238 */,
/* 1239 */,
/* 1240 */,
/* 1241 */,
/* 1242 */,
/* 1243 */,
/* 1244 */,
/* 1245 */,
/* 1246 */,
/* 1247 */,
/* 1248 */,
/* 1249 */,
/* 1250 */,
/* 1251 */,
/* 1252 */,
/* 1253 */,
/* 1254 */,
/* 1255 */,
/* 1256 */,
/* 1257 */,
/* 1258 */,
/* 1259 */,
/* 1260 */,
/* 1261 */,
/* 1262 */,
/* 1263 */,
/* 1264 */,
/* 1265 */,
/* 1266 */,
/* 1267 */,
/* 1268 */,
/* 1269 */,
/* 1270 */,
/* 1271 */,
/* 1272 */,
/* 1273 */,
/* 1274 */,
/* 1275 */,
/* 1276 */,
/* 1277 */,
/* 1278 */,
/* 1279 */,
/* 1280 */,
/* 1281 */,
/* 1282 */,
/* 1283 */,
/* 1284 */,
/* 1285 */,
/* 1286 */,
/* 1287 */,
/* 1288 */,
/* 1289 */,
/* 1290 */,
/* 1291 */,
/* 1292 */,
/* 1293 */,
/* 1294 */,
/* 1295 */,
/* 1296 */,
/* 1297 */,
/* 1298 */,
/* 1299 */,
/* 1300 */,
/* 1301 */,
/* 1302 */,
/* 1303 */,
/* 1304 */,
/* 1305 */,
/* 1306 */,
/* 1307 */,
/* 1308 */,
/* 1309 */,
/* 1310 */,
/* 1311 */,
/* 1312 */,
/* 1313 */,
/* 1314 */,
/* 1315 */,
/* 1316 */,
/* 1317 */,
/* 1318 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreAutoFocusDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};




/**
 * Directive to auto focus an element when a view is loaded.
 *
 * You can apply it conditionallity assigning it a boolean value: <ion-input [core-auto-focus]="{{showKeyboard}}">
 */
var CoreAutoFocusDirective = /** @class */ (function () {
    function CoreAutoFocusDirective(element, domUtils, utils, navCtrl) {
        this.domUtils = domUtils;
        this.utils = utils;
        this.navCtrl = navCtrl;
        this.coreAutoFocus = true;
        this.element = element.nativeElement || element;
    }
    /**
     * Component being initialized.
     */
    CoreAutoFocusDirective.prototype.ngOnInit = function () {
        var _this = this;
        if (this.navCtrl.isTransitioning()) {
            // Navigating to a new page. Wait for the transition to be over.
            var subscription_1 = this.navCtrl.viewDidEnter.subscribe(function () {
                _this.autoFocus();
                subscription_1.unsubscribe();
            });
        }
        else {
            this.autoFocus();
        }
    };
    /**
     * Function after the view is initialized.
     */
    CoreAutoFocusDirective.prototype.autoFocus = function () {
        var _this = this;
        var autoFocus = this.utils.isTrueOrOne(this.coreAutoFocus);
        if (autoFocus) {
            // Wait a bit to make sure the view is loaded.
            setTimeout(function () {
                // If it's a ion-input or ion-textarea, search the right input to use.
                var element = _this.element;
                if (_this.element.tagName == 'ION-INPUT') {
                    element = _this.element.querySelector('input') || element;
                }
                else if (_this.element.tagName == 'ION-TEXTAREA') {
                    element = _this.element.querySelector('textarea') || element;
                }
                _this.domUtils.focusElement(element);
            }, 200);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('core-auto-focus'),
        __metadata("design:type", Object)
    ], CoreAutoFocusDirective.prototype, "coreAutoFocus", void 0);
    CoreAutoFocusDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-auto-focus]'
        }),
        __param(3, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], CoreAutoFocusDirective);
    return CoreAutoFocusDirective;
}());

//# sourceMappingURL=auto-focus.js.map

/***/ }),
/* 1319 */,
/* 1320 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./af": 617,
	"./af.js": 617,
	"./ar": 618,
	"./ar-dz": 619,
	"./ar-dz.js": 619,
	"./ar-kw": 620,
	"./ar-kw.js": 620,
	"./ar-ly": 621,
	"./ar-ly.js": 621,
	"./ar-ma": 622,
	"./ar-ma.js": 622,
	"./ar-sa": 623,
	"./ar-sa.js": 623,
	"./ar-tn": 624,
	"./ar-tn.js": 624,
	"./ar.js": 618,
	"./az": 625,
	"./az.js": 625,
	"./be": 626,
	"./be.js": 626,
	"./bg": 627,
	"./bg.js": 627,
	"./bm": 628,
	"./bm.js": 628,
	"./bn": 629,
	"./bn.js": 629,
	"./bo": 630,
	"./bo.js": 630,
	"./br": 631,
	"./br.js": 631,
	"./bs": 632,
	"./bs.js": 632,
	"./ca": 633,
	"./ca.js": 633,
	"./cs": 634,
	"./cs.js": 634,
	"./cv": 635,
	"./cv.js": 635,
	"./cy": 636,
	"./cy.js": 636,
	"./da": 637,
	"./da.js": 637,
	"./de": 638,
	"./de-at": 639,
	"./de-at.js": 639,
	"./de-ch": 640,
	"./de-ch.js": 640,
	"./de.js": 638,
	"./dv": 641,
	"./dv.js": 641,
	"./el": 642,
	"./el.js": 642,
	"./en-au": 643,
	"./en-au.js": 643,
	"./en-ca": 644,
	"./en-ca.js": 644,
	"./en-gb": 645,
	"./en-gb.js": 645,
	"./en-ie": 646,
	"./en-ie.js": 646,
	"./en-il": 647,
	"./en-il.js": 647,
	"./en-nz": 648,
	"./en-nz.js": 648,
	"./eo": 649,
	"./eo.js": 649,
	"./es": 650,
	"./es-do": 651,
	"./es-do.js": 651,
	"./es-us": 652,
	"./es-us.js": 652,
	"./es.js": 650,
	"./et": 653,
	"./et.js": 653,
	"./eu": 654,
	"./eu.js": 654,
	"./fa": 655,
	"./fa.js": 655,
	"./fi": 656,
	"./fi.js": 656,
	"./fo": 657,
	"./fo.js": 657,
	"./fr": 658,
	"./fr-ca": 659,
	"./fr-ca.js": 659,
	"./fr-ch": 660,
	"./fr-ch.js": 660,
	"./fr.js": 658,
	"./fy": 661,
	"./fy.js": 661,
	"./gd": 662,
	"./gd.js": 662,
	"./gl": 663,
	"./gl.js": 663,
	"./gom-latn": 664,
	"./gom-latn.js": 664,
	"./gu": 665,
	"./gu.js": 665,
	"./he": 666,
	"./he.js": 666,
	"./hi": 667,
	"./hi.js": 667,
	"./hr": 668,
	"./hr.js": 668,
	"./hu": 669,
	"./hu.js": 669,
	"./hy-am": 670,
	"./hy-am.js": 670,
	"./id": 671,
	"./id.js": 671,
	"./is": 672,
	"./is.js": 672,
	"./it": 673,
	"./it.js": 673,
	"./ja": 674,
	"./ja.js": 674,
	"./jv": 675,
	"./jv.js": 675,
	"./ka": 676,
	"./ka.js": 676,
	"./kk": 677,
	"./kk.js": 677,
	"./km": 678,
	"./km.js": 678,
	"./kn": 679,
	"./kn.js": 679,
	"./ko": 680,
	"./ko.js": 680,
	"./ky": 681,
	"./ky.js": 681,
	"./lb": 682,
	"./lb.js": 682,
	"./lo": 683,
	"./lo.js": 683,
	"./lt": 684,
	"./lt.js": 684,
	"./lv": 685,
	"./lv.js": 685,
	"./me": 686,
	"./me.js": 686,
	"./mi": 687,
	"./mi.js": 687,
	"./mk": 688,
	"./mk.js": 688,
	"./ml": 689,
	"./ml.js": 689,
	"./mn": 690,
	"./mn.js": 690,
	"./mr": 691,
	"./mr.js": 691,
	"./ms": 692,
	"./ms-my": 693,
	"./ms-my.js": 693,
	"./ms.js": 692,
	"./mt": 694,
	"./mt.js": 694,
	"./my": 695,
	"./my.js": 695,
	"./nb": 696,
	"./nb.js": 696,
	"./ne": 697,
	"./ne.js": 697,
	"./nl": 698,
	"./nl-be": 699,
	"./nl-be.js": 699,
	"./nl.js": 698,
	"./nn": 700,
	"./nn.js": 700,
	"./pa-in": 701,
	"./pa-in.js": 701,
	"./pl": 702,
	"./pl.js": 702,
	"./pt": 703,
	"./pt-br": 704,
	"./pt-br.js": 704,
	"./pt.js": 703,
	"./ro": 705,
	"./ro.js": 705,
	"./ru": 706,
	"./ru.js": 706,
	"./sd": 707,
	"./sd.js": 707,
	"./se": 708,
	"./se.js": 708,
	"./si": 709,
	"./si.js": 709,
	"./sk": 710,
	"./sk.js": 710,
	"./sl": 711,
	"./sl.js": 711,
	"./sq": 712,
	"./sq.js": 712,
	"./sr": 713,
	"./sr-cyrl": 714,
	"./sr-cyrl.js": 714,
	"./sr.js": 713,
	"./ss": 715,
	"./ss.js": 715,
	"./sv": 716,
	"./sv.js": 716,
	"./sw": 717,
	"./sw.js": 717,
	"./ta": 718,
	"./ta.js": 718,
	"./te": 719,
	"./te.js": 719,
	"./tet": 720,
	"./tet.js": 720,
	"./tg": 721,
	"./tg.js": 721,
	"./th": 722,
	"./th.js": 722,
	"./tl-ph": 723,
	"./tl-ph.js": 723,
	"./tlh": 724,
	"./tlh.js": 724,
	"./tr": 725,
	"./tr.js": 725,
	"./tzl": 726,
	"./tzl.js": 726,
	"./tzm": 727,
	"./tzm-latn": 728,
	"./tzm-latn.js": 728,
	"./tzm.js": 727,
	"./ug-cn": 729,
	"./ug-cn.js": 729,
	"./uk": 730,
	"./uk.js": 730,
	"./ur": 731,
	"./ur.js": 731,
	"./uz": 732,
	"./uz-latn": 733,
	"./uz-latn.js": 733,
	"./uz.js": 732,
	"./vi": 734,
	"./vi.js": 734,
	"./x-pseudo": 735,
	"./x-pseudo.js": 735,
	"./yo": 736,
	"./yo.js": 736,
	"./zh-cn": 737,
	"./zh-cn.js": 737,
	"./zh-hk": 738,
	"./zh-hk.js": 738,
	"./zh-tw": 739,
	"./zh-tw.js": 739
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 1320;

/***/ }),
/* 1321 */,
/* 1322 */,
/* 1323 */,
/* 1324 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SQLiteDBMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__classes_sqlitedb__ = __webpack_require__(742);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/* tslint:disable:no-console */

/**
 * Class to mock the interaction with the SQLite database.
 */
var SQLiteDBMock = /** @class */ (function (_super) {
    __extends(SQLiteDBMock, _super);
    /**
     * Create and open the database.
     *
     * @param {string} name Database name.
     */
    function SQLiteDBMock(name) {
        var _this = _super.call(this, name, null, null) || this;
        _this.name = name;
        return _this;
    }
    /**
     * Close the database.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDBMock.prototype.close = function () {
        // WebSQL databases aren't closed.
        return Promise.resolve();
    };
    /**
     * Drop all the data in the database.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDBMock.prototype.emptyDatabase = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.db.transaction(function (tx) {
                // Query all tables from sqlite_master that we have created and can modify.
                var args = [], query = "SELECT * FROM sqlite_master\n                            WHERE name NOT LIKE 'sqlite\\_%' escape '\\' AND name NOT LIKE '\\_%' escape '\\'";
                tx.executeSql(query, args, function (tx, result) {
                    if (result.rows.length <= 0) {
                        // No tables to delete, stop.
                        resolve();
                        return;
                    }
                    // Drop all the tables.
                    var promises = [];
                    var _loop_1 = function (i) {
                        promises.push(new Promise(function (resolve, reject) {
                            // Drop the table.
                            var name = JSON.stringify(result.rows.item(i).name);
                            tx.executeSql('DROP TABLE ' + name, [], resolve, reject);
                        }));
                    };
                    for (var i = 0; i < result.rows.length; i++) {
                        _loop_1(i);
                    }
                    Promise.all(promises).then(resolve, reject);
                }, reject);
            });
        });
    };
    /**
     * Execute a SQL query.
     * IMPORTANT: Use this function only if you cannot use any of the other functions in this API. Please take into account that
     * these query will be run in SQLite (Mobile) and Web SQL (desktop), so your query should work in both environments.
     *
     * @param {string} sql SQL query to execute.
     * @param {any[]} params Query parameters.
     * @return {Promise<any>} Promise resolved with the result.
     */
    SQLiteDBMock.prototype.execute = function (sql, params) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            // With WebSQL, all queries must be run in a transaction.
            _this.db.transaction(function (tx) {
                tx.executeSql(sql, params, function (tx, results) {
                    resolve(results);
                }, function (tx, error) {
                    console.error(sql, params, error);
                    reject(error);
                });
            });
        });
    };
    /**
     * Execute a set of SQL queries. This operation is atomic.
     * IMPORTANT: Use this function only if you cannot use any of the other functions in this API. Please take into account that
     * these query will be run in SQLite (Mobile) and Web SQL (desktop), so your query should work in both environments.
     *
     * @param {any[]} sqlStatements SQL statements to execute.
     * @return {Promise<any>} Promise resolved with the result.
     */
    SQLiteDBMock.prototype.executeBatch = function (sqlStatements) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            // Create a transaction to execute the queries.
            _this.db.transaction(function (tx) {
                var promises = [];
                // Execute all the queries. Each statement can be a string or an array.
                sqlStatements.forEach(function (statement) {
                    promises.push(new Promise(function (resolve, reject) {
                        var query, params;
                        if (Array.isArray(statement)) {
                            query = statement[0];
                            params = statement[1];
                        }
                        else {
                            query = statement;
                            params = null;
                        }
                        tx.executeSql(query, params, function (tx, results) {
                            resolve(results);
                        }, function (tx, error) {
                            console.error(query, params, error);
                            reject(error);
                        });
                    }));
                });
                Promise.all(promises).then(resolve, reject);
            });
        });
    };
    /**
     * Initialize the database.
     */
    SQLiteDBMock.prototype.init = function () {
        // This DB is for desktop apps, so use a big size to be sure it isn't filled.
        this.db = window.openDatabase(this.name, '1.0', this.name, 500 * 1024 * 1024);
        this.promise = Promise.resolve();
    };
    /**
     * Open the database. Only needed if it was closed before, a database is automatically opened when created.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    SQLiteDBMock.prototype.open = function () {
        // WebSQL databases can't closed, so the open method isn't needed.
        return Promise.resolve();
    };
    return SQLiteDBMock;
}(__WEBPACK_IMPORTED_MODULE_0__classes_sqlitedb__["a" /* SQLiteDB */]));

//# sourceMappingURL=sqlitedb.js.map

/***/ }),
/* 1325 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDownloadFileDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_file_helper__ = __webpack_require__(252);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Directive to allow downloading and open a file. When the item with this directive is clicked, the file will be
 * downloaded (if needed) and opened.
 */
var CoreDownloadFileDirective = /** @class */ (function () {
    function CoreDownloadFileDirective(element, domUtils, fileHelper) {
        this.domUtils = domUtils;
        this.fileHelper = fileHelper;
        this.element = element.nativeElement || element;
    }
    /**
     * Component being initialized.
     */
    CoreDownloadFileDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.element.addEventListener('click', function (ev) {
            if (!_this.file) {
                return;
            }
            ev.preventDefault();
            ev.stopPropagation();
            var modal = _this.domUtils.showModalLoading();
            _this.fileHelper.downloadAndOpenFile(_this.file, _this.component, _this.componentId).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
            }).finally(function () {
                modal.dismiss();
            });
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('core-download-file'),
        __metadata("design:type", Object)
    ], CoreDownloadFileDirective.prototype, "file", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreDownloadFileDirective.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreDownloadFileDirective.prototype, "componentId", void 0);
    CoreDownloadFileDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-download-file]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_file_helper__["a" /* CoreFileHelperProvider */]])
    ], CoreDownloadFileDirective);
    return CoreDownloadFileDirective;
}());

//# sourceMappingURL=download-file.js.map

/***/ }),
/* 1326 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFabDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Directive to move ion-fab components as direct children of the nearest ion-content.
 *
 * Example usage:
 *
 * <ion-fab core-fab>
 */
var CoreFabDirective = /** @class */ (function () {
    function CoreFabDirective(el, content) {
        this.content = content;
        this.element = el.nativeElement;
    }
    /**
     * Initialize Component.
     */
    CoreFabDirective.prototype.ngOnInit = function () {
        if (this.content) {
            this.content.getNativeElement().classList.add('has-fab');
            this.content.getFixedElement().appendChild(this.element);
        }
    };
    /**
     * Destroy component.
     */
    CoreFabDirective.prototype.ngOnDestroy = function () {
        if (this.content) {
            this.content.getNativeElement().classList.remove('has-fab');
        }
    };
    CoreFabDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: 'ion-fab[core-fab]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */]])
    ], CoreFabDirective);
    return CoreFabDirective;
}());

//# sourceMappingURL=fab.js.map

/***/ }),
/* 1327 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFormatTextDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_iframe__ = __webpack_require__(346);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__directives_link__ = __webpack_require__(748);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__directives_external_content__ = __webpack_require__(745);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__components_split_view_split_view__ = __webpack_require__(121);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};

















/**
 * Directive to format text rendered. It renders the HTML and treats all links and media, using CoreLinkDirective
 * and CoreExternalContentDirective.
 *
 * Example usage:
 * <core-format-text [text]="myText" [component]="component" [componentId]="componentId"></core-format-text>
 *
 */
var CoreFormatTextDirective = /** @class */ (function () {
    function CoreFormatTextDirective(element, sitesProvider, domUtils, textUtils, translate, platform, utils, urlUtils, loggerProvider, filepoolProvider, appProvider, contentLinksHelper, navCtrl, content, svComponent, iframeUtils, eventsProvider) {
        this.sitesProvider = sitesProvider;
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.translate = translate;
        this.platform = platform;
        this.utils = utils;
        this.urlUtils = urlUtils;
        this.loggerProvider = loggerProvider;
        this.filepoolProvider = filepoolProvider;
        this.appProvider = appProvider;
        this.contentLinksHelper = contentLinksHelper;
        this.navCtrl = navCtrl;
        this.content = content;
        this.svComponent = svComponent;
        this.iframeUtils = iframeUtils;
        this.eventsProvider = eventsProvider;
        this.adaptImg = true; // Whether to adapt images to screen width.
        this.element = element.nativeElement;
        this.element.classList.add('opacity-hide'); // Hide contents until they're treated.
        this.afterRender = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.element.addEventListener('click', this.elementClicked.bind(this));
    }
    /**
     * Detect changes on input properties.
     */
    CoreFormatTextDirective.prototype.ngOnChanges = function (changes) {
        if (changes.text) {
            this.hideShowMore();
            this.formatAndRenderContents();
        }
    };
    /**
     * Apply CoreExternalContentDirective to a certain element.
     *
     * @param {HTMLElement} element Element to add the attributes to.
     */
    CoreFormatTextDirective.prototype.addExternalContent = function (element) {
        // Angular 2 doesn't let adding directives dynamically. Create the CoreExternalContentDirective manually.
        var extContent = new __WEBPACK_IMPORTED_MODULE_14__directives_external_content__["a" /* CoreExternalContentDirective */](element, this.loggerProvider, this.filepoolProvider, this.platform, this.sitesProvider, this.domUtils, this.urlUtils, this.appProvider, this.utils);
        extContent.component = this.component;
        extContent.componentId = this.componentId;
        extContent.siteId = this.siteId;
        extContent.src = element.getAttribute('src');
        extContent.href = element.getAttribute('href');
        extContent.targetSrc = element.getAttribute('target-src');
        extContent.poster = element.getAttribute('poster');
        extContent.ngAfterViewInit();
    };
    /**
     * Add class to adapt media to a certain element.
     *
     * @param {HTMLElement} element Element to add the class to.
     */
    CoreFormatTextDirective.prototype.addMediaAdaptClass = function (element) {
        element.classList.add('core-media-adapt-width');
    };
    /**
     * Wrap an image with a container to adapt its width and, if needed, add an anchor to view it in full size.
     *
     * @param {number} elWidth Width of the directive's element.
     * @param {HTMLElement} img Image to adapt.
     */
    CoreFormatTextDirective.prototype.adaptImage = function (elWidth, img) {
        var imgWidth = this.getElementWidth(img), 
        // Element to wrap the image.
        container = document.createElement('span'), originalWidth = img.attributes.getNamedItem('width');
        var forcedWidth = parseInt(originalWidth && originalWidth.value);
        if (!isNaN(forcedWidth)) {
            if (originalWidth.value.indexOf('%') < 0) {
                img.style.width = forcedWidth + 'px';
            }
            else {
                img.style.width = forcedWidth + '%';
            }
        }
        container.classList.add('core-adapted-img-container');
        container.style.cssFloat = img.style.cssFloat; // Copy the float to correctly position the search icon.
        if (img.classList.contains('atto_image_button_right')) {
            container.classList.add('atto_image_button_right');
        }
        else if (img.classList.contains('atto_image_button_left')) {
            container.classList.add('atto_image_button_left');
        }
        else if (img.classList.contains('atto_image_button_text-top')) {
            container.classList.add('atto_image_button_text-top');
        }
        else if (img.classList.contains('atto_image_button_middle')) {
            container.classList.add('atto_image_button_middle');
        }
        else if (img.classList.contains('atto_image_button_text-bottom')) {
            container.classList.add('atto_image_button_text-bottom');
        }
        this.domUtils.wrapElement(img, container);
        if (imgWidth > elWidth) {
            // The image has been adapted, add an anchor to view it in full size.
            this.addMagnifyingGlass(container, img);
        }
    };
    /**
     * Add a magnifying glass icon to view an image at full size.
     *
     * @param {HTMLElement} container The container of the image.
     * @param {HTMLElement} img The image.
     */
    CoreFormatTextDirective.prototype.addMagnifyingGlass = function (container, img) {
        var _this = this;
        var imgSrc = this.textUtils.escapeHTML(img.getAttribute('src')), label = this.textUtils.escapeHTML(this.translate.instant('core.openfullimage')), anchor = document.createElement('a');
        anchor.classList.add('core-image-viewer-icon');
        anchor.setAttribute('aria-label', label);
        // Add an ion-icon item to apply the right styles, but the ion-icon component won't be executed.
        anchor.innerHTML = '<ion-icon name="search" class="icon icon-md ion-md-search"></ion-icon>';
        anchor.addEventListener('click', function (e) {
            e.preventDefault();
            e.stopPropagation();
            _this.domUtils.viewImage(imgSrc, img.getAttribute('alt'), _this.component, _this.componentId);
        });
        container.appendChild(anchor);
    };
    /**
     * Calculate the height and check if we need to display show more or not.
     */
    CoreFormatTextDirective.prototype.calculateHeight = function () {
        // @todo: Work on calculate this height better.
        // Remove max-height (if any) to calculate the real height.
        var initialMaxHeight = this.element.style.maxHeight;
        this.element.style.maxHeight = null;
        var height = this.getElementHeight(this.element);
        // Restore the max height now.
        this.element.style.maxHeight = initialMaxHeight;
        // If cannot calculate height, shorten always.
        if (!height || height > this.maxHeight) {
            if (!this.showMoreDisplayed) {
                this.displayShowMore();
            }
        }
        else if (this.showMoreDisplayed) {
            this.hideShowMore();
        }
    };
    /**
     * Display the "Show more" in the element.
     */
    CoreFormatTextDirective.prototype.displayShowMore = function () {
        var expandInFullview = this.utils.isTrueOrOne(this.fullOnClick) || false, showMoreDiv = document.createElement('div');
        showMoreDiv.classList.add('core-show-more');
        showMoreDiv.innerHTML = this.translate.instant('core.showmore');
        this.element.appendChild(showMoreDiv);
        if (expandInFullview) {
            this.element.classList.add('core-expand-in-fullview');
        }
        this.element.classList.add('core-text-formatted');
        this.element.classList.add('core-shortened');
        this.element.style.maxHeight = this.maxHeight + 'px';
        this.showMoreDisplayed = true;
    };
    /**
     * Listener to call when the element is clicked.
     *
     * @param {MouseEvent} e Click event.
     */
    CoreFormatTextDirective.prototype.elementClicked = function (e) {
        if (e.defaultPrevented) {
            // Ignore it if the event was prevented by some other listener.
            return;
        }
        var expandInFullview = this.utils.isTrueOrOne(this.fullOnClick) || false;
        if (!expandInFullview && !this.showMoreDisplayed) {
            // Nothing to do on click, just stop.
            return;
        }
        e.preventDefault();
        e.stopPropagation();
        if (!expandInFullview) {
            // Change class.
            this.element.classList.toggle('core-shortened');
            return;
        }
        else {
            // Open a new state with the contents.
            this.textUtils.expandText(this.fullTitle || this.translate.instant('core.description'), this.text, this.component, this.componentId);
        }
    };
    /**
     * Finish the rendering, displaying the element again and calling afterRender.
     */
    CoreFormatTextDirective.prototype.finishRender = function () {
        // Show the element again.
        this.element.classList.remove('opacity-hide');
        // Emit the afterRender output.
        this.afterRender.emit();
    };
    /**
     * Format contents and render.
     */
    CoreFormatTextDirective.prototype.formatAndRenderContents = function () {
        var _this = this;
        if (!this.text) {
            this.element.innerHTML = ''; // Remove current contents.
            this.finishRender();
            return;
        }
        // In AOT the inputs and ng-reflect aren't in the DOM sometimes. Add them so styles are applied.
        if (this.maxHeight && !this.element.getAttribute('maxHeight')) {
            this.element.setAttribute('maxHeight', String(this.maxHeight));
        }
        if (!this.element.getAttribute('singleLine')) {
            this.element.setAttribute('singleLine', String(this.utils.isTrueOrOne(this.singleLine)));
        }
        this.text = this.text ? this.text.trim() : '';
        this.formatContents().then(function (div) {
            // Disable media adapt to correctly calculate the height.
            _this.element.classList.add('core-disable-media-adapt');
            _this.element.innerHTML = ''; // Remove current contents.
            if (_this.maxHeight && div.innerHTML != '') {
                // Move the children to the current element to be able to calculate the height.
                _this.domUtils.moveChildren(div, _this.element);
                // Calculate the height now.
                _this.calculateHeight();
                // Wait for images to load and calculate the height again if needed.
                _this.domUtils.waitForImages(_this.element).then(function (hasImgToLoad) {
                    if (hasImgToLoad) {
                        _this.calculateHeight();
                    }
                });
                if (!_this.loadingChangedListener) {
                    // Recalculate the height if a parent core-loading displays the content.
                    _this.loadingChangedListener = _this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].CORE_LOADING_CHANGED, function (data) {
                        if (data.loaded && _this.domUtils.closest(_this.element.parentElement, '#' + data.uniqueId)) {
                            // The format-text is inside the loading, re-calculate the height.
                            _this.calculateHeight();
                        }
                    });
                }
            }
            else {
                _this.domUtils.moveChildren(div, _this.element);
            }
            _this.element.classList.remove('core-disable-media-adapt');
            _this.finishRender();
        });
    };
    /**
     * Apply formatText and set sub-directives.
     *
     * @return {Promise<HTMLElement>} Promise resolved with a div element containing the code.
     */
    CoreFormatTextDirective.prototype.formatContents = function () {
        var _this = this;
        var site;
        // Retrieve the site since it might be needed later.
        return this.sitesProvider.getSite(this.siteId).catch(function () {
            // Error getting the site. This probably means that there is no current site and no siteId was supplied.
        }).then(function (siteInstance) {
            site = siteInstance;
            // Apply format text function.
            return _this.textUtils.formatText(_this.text, _this.utils.isTrueOrOne(_this.clean), _this.utils.isTrueOrOne(_this.singleLine), undefined, _this.highlight);
        }).then(function (formatted) {
            var div = document.createElement('div'), canTreatVimeo = site && site.isVersionGreaterEqualThan(['3.3.4', '3.4']);
            var images, anchors, audios, videos, iframes, buttons, elementsWithInlineStyles, stopClicksElements, frames;
            div.innerHTML = formatted;
            images = Array.from(div.querySelectorAll('img'));
            anchors = Array.from(div.querySelectorAll('a'));
            audios = Array.from(div.querySelectorAll('audio'));
            videos = Array.from(div.querySelectorAll('video'));
            iframes = Array.from(div.querySelectorAll('iframe'));
            buttons = Array.from(div.querySelectorAll('.button'));
            elementsWithInlineStyles = Array.from(div.querySelectorAll('*[style]'));
            stopClicksElements = Array.from(div.querySelectorAll('button,input,select,textarea'));
            frames = Array.from(div.querySelectorAll(__WEBPACK_IMPORTED_MODULE_9__providers_utils_iframe__["a" /* CoreIframeUtilsProvider */].FRAME_TAGS.join(',').replace(/iframe,?/, '')));
            // Walk through the content to find the links and add our directive to it.
            // Important: We need to look for links first because in 'img' we add new links without core-link.
            anchors.forEach(function (anchor) {
                // Angular 2 doesn't let adding directives dynamically. Create the CoreLinkDirective manually.
                var linkDir = new __WEBPACK_IMPORTED_MODULE_13__directives_link__["a" /* CoreLinkDirective */](anchor, _this.domUtils, _this.utils, _this.sitesProvider, _this.urlUtils, _this.contentLinksHelper, _this.navCtrl, _this.content, _this.svComponent);
                linkDir.capture = true;
                linkDir.ngOnInit();
                _this.addExternalContent(anchor);
            });
            if (images && images.length > 0) {
                // If cannot calculate element's width, use a medium number to avoid false adapt image icons appearing.
                var elWidth_1 = _this.getElementWidth(_this.element) || 100;
                // Walk through the content to find images, and add our directive.
                images.forEach(function (img) {
                    _this.addMediaAdaptClass(img);
                    _this.addExternalContent(img);
                    if (_this.utils.isTrueOrOne(_this.adaptImg) && !img.classList.contains('icon')) {
                        _this.adaptImage(elWidth_1, img);
                    }
                });
            }
            audios.forEach(function (audio) {
                _this.treatMedia(audio);
            });
            videos.forEach(function (video) {
                _this.treatVideoFilters(video);
                _this.treatMedia(video);
            });
            iframes.forEach(function (iframe) {
                _this.treatIframe(iframe, site, canTreatVimeo);
            });
            // Handle buttons with inner links.
            buttons.forEach(function (button) {
                // Check if it has a link inside.
                if (button.querySelector('a')) {
                    button.classList.add('core-button-with-inner-link');
                }
            });
            // Handle inline styles.
            elementsWithInlineStyles.forEach(function (el) {
                // Only add external content for tags that haven't been treated already.
                if (el.tagName != 'A' && el.tagName != 'IMG' && el.tagName != 'AUDIO' && el.tagName != 'VIDEO'
                    && el.tagName != 'SOURCE' && el.tagName != 'TRACK') {
                    _this.addExternalContent(el);
                }
            });
            // Stop propagating click events.
            stopClicksElements.forEach(function (element) {
                element.addEventListener('click', function (e) {
                    e.stopPropagation();
                });
            });
            // Handle all kind of frames.
            frames.forEach(function (frame) {
                _this.iframeUtils.treatFrame(frame);
            });
            _this.domUtils.handleBootstrapTooltips(div);
            return div;
        });
    };
    /**
     * Returns the element width in pixels.
     *
     * @param {HTMLElement} element Element to get width from.
     * @return {number} The width of the element in pixels. When 0 is returned it means the element is not visible.
     */
    CoreFormatTextDirective.prototype.getElementWidth = function (element) {
        var width = this.domUtils.getElementWidth(element);
        if (!width) {
            // All elements inside are floating or inline. Change display mode to allow calculate the width.
            var parentWidth = this.domUtils.getElementWidth(element.parentNode, true, false, false, true), previousDisplay = getComputedStyle(element, null).display;
            element.style.display = 'inline-block';
            width = this.domUtils.getElementWidth(element);
            // If width is incorrectly calculated use parent width instead.
            if (parentWidth > 0 && (!width || width > parentWidth)) {
                width = parentWidth;
            }
            element.style.display = previousDisplay;
        }
        return width;
    };
    /**
     * Returns the element height in pixels.
     *
     * @param {HTMLElement} elementAng Element to get height from.
     * @return {number} The height of the element in pixels. When 0 is returned it means the element is not visible.
     */
    CoreFormatTextDirective.prototype.getElementHeight = function (element) {
        return this.domUtils.getElementHeight(element) || 0;
    };
    /**
     * "Hide" the "Show more" in the element if it's shown.
     */
    CoreFormatTextDirective.prototype.hideShowMore = function () {
        var showMoreDiv = this.element.querySelector('div.core-show-more');
        if (showMoreDiv) {
            showMoreDiv.remove();
        }
        this.element.classList.remove('core-expand-in-fullview');
        this.element.classList.remove('core-text-formatted');
        this.element.classList.remove('core-shortened');
        this.element.style.maxHeight = null;
        this.showMoreDisplayed = false;
    };
    /**
     * Treat video filters. Currently only treating youtube video using video JS.
     *
     * @param {HTMLElement} el Video element.
     */
    CoreFormatTextDirective.prototype.treatVideoFilters = function (video) {
        // Treat Video JS Youtube video links and translate them to iframes.
        if (!video.classList.contains('video-js')) {
            return;
        }
        var data = this.textUtils.parseJSON(video.getAttribute('data-setup') || video.getAttribute('data-setup-lazy') || '{}'), youtubeData = data.techOrder && data.techOrder[0] && data.techOrder[0] == 'youtube' &&
            this.parseYoutubeUrl(data.sources && data.sources[0] && data.sources[0].src);
        if (!youtubeData || !youtubeData.videoId) {
            return;
        }
        var iframe = document.createElement('iframe');
        iframe.id = video.id;
        iframe.src = 'https://www.youtube.com/embed/' + youtubeData.videoId; // Don't apply other params to align with Moodle web.
        iframe.setAttribute('frameborder', '0');
        iframe.setAttribute('allowfullscreen', '1');
        iframe.width = '100%';
        iframe.height = '300';
        // Replace video tag by the iframe.
        video.parentNode.replaceChild(iframe, video);
        this.iframeUtils.treatFrame(iframe);
    };
    /**
     * Add media adapt class and apply CoreExternalContentDirective to the media element and its sources and tracks.
     *
     * @param {HTMLElement} element Video or audio to treat.
     */
    CoreFormatTextDirective.prototype.treatMedia = function (element) {
        var _this = this;
        this.addMediaAdaptClass(element);
        this.addExternalContent(element);
        var sources = Array.from(element.querySelectorAll('source')), tracks = Array.from(element.querySelectorAll('track'));
        sources.forEach(function (source) {
            source.setAttribute('target-src', source.getAttribute('src'));
            source.removeAttribute('src');
            _this.addExternalContent(source);
        });
        tracks.forEach(function (track) {
            _this.addExternalContent(track);
        });
        // Stop propagating click events.
        element.addEventListener('click', function (e) {
            e.stopPropagation();
        });
    };
    /**
     * Add media adapt class and treat the iframe source.
     *
     * @param {HTMLIFrameElement} iframe Iframe to treat.
     * @param {CoreSite} site Site instance.
     * @param {boolean} canTreatVimeo Whether Vimeo videos can be treated in the site.
     */
    CoreFormatTextDirective.prototype.treatIframe = function (iframe, site, canTreatVimeo) {
        var _this = this;
        var src = iframe.src, currentSite = this.sitesProvider.getCurrentSite();
        this.addMediaAdaptClass(iframe);
        if (currentSite && currentSite.containsUrl(src)) {
            // URL points to current site, try to use auto-login.
            currentSite.getAutoLoginUrl(src, false).then(function (finalUrl) {
                iframe.src = finalUrl;
                _this.iframeUtils.treatFrame(iframe);
            });
            return;
        }
        if (src && canTreatVimeo) {
            // Check if it's a Vimeo video. If it is, use the wsplayer script instead to make restricted videos work.
            var matches = iframe.src.match(/https?:\/\/player\.vimeo\.com\/video\/([0-9]+)/);
            if (matches && matches[1]) {
                var newUrl = this.textUtils.concatenatePaths(site.getURL(), '/media/player/vimeo/wsplayer.php?video=') +
                    matches[1] + '&token=' + site.getToken();
                // Width and height are mandatory, we need to calculate them.
                var width = void 0, height = void 0;
                if (iframe.width) {
                    width = iframe.width;
                }
                else {
                    width = this.getElementWidth(iframe);
                    if (!width) {
                        width = window.innerWidth;
                    }
                }
                if (iframe.height) {
                    height = iframe.height;
                }
                else {
                    height = this.getElementHeight(iframe);
                    if (!height) {
                        height = width;
                    }
                }
                // Width and height parameters are required in 3.6 and older sites.
                if (!site.isVersionGreaterEqualThan('3.7')) {
                    newUrl += '&width=' + width + '&height=' + height;
                }
                iframe.src = newUrl;
                if (!iframe.width) {
                    iframe.width = width;
                }
                if (!iframe.height) {
                    iframe.height = height;
                }
                // Do the iframe responsive.
                if (iframe.parentElement.classList.contains('embed-responsive')) {
                    iframe.addEventListener('load', function () {
                        if (iframe.contentDocument) {
                            var css = document.createElement('style');
                            css.setAttribute('type', 'text/css');
                            css.innerHTML = 'iframe {width: 100%;height: 100%;}';
                            iframe.contentDocument.head.appendChild(css);
                        }
                    });
                }
            }
        }
        this.iframeUtils.treatFrame(iframe);
    };
    /**
     * Parse a YouTube URL.
     * Based on Youtube.parseUrl from Moodle media/player/videojs/amd/src/Youtube-lazy.js
     *
     * @param {string} url URL of the video.
     */
    CoreFormatTextDirective.prototype.parseYoutubeUrl = function (url) {
        var result = {
            videoId: null,
            listId: null,
            start: null
        };
        if (!url) {
            return result;
        }
        url = this.textUtils.decodeHTML(url);
        // Get the video ID.
        var match = url.match(/^.*(youtu.be\/|v\/|u\/\w\/|embed\/|watch\?v=|\&v=)([^#\&\?]*).*/);
        if (match && match[2].length === 11) {
            result.videoId = match[2];
        }
        // Now get the playlist (if any).
        match = url.match(/[?&]list=([^#\&\?]+)/);
        if (match && match[1]) {
            result.listId = match[1];
        }
        // Now get the start time (if any).
        match = url.match(/[?&]start=(\d+)/);
        if (match && match[1]) {
            result.start = parseInt(match[1], 10);
        }
        else {
            // No start param, but it could have a time param.
            match = url.match(/[?&]t=(\d+h)?(\d+m)?(\d+s)?/);
            if (match) {
                result.start = (match[1] ? parseInt(match[1], 10) * 3600 : 0) + (match[2] ? parseInt(match[2], 10) * 60 : 0) +
                    (match[3] ? parseInt(match[3], 10) : 0);
            }
        }
        return result;
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreFormatTextDirective.prototype, "text", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreFormatTextDirective.prototype, "siteId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreFormatTextDirective.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFormatTextDirective.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFormatTextDirective.prototype, "adaptImg", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFormatTextDirective.prototype, "clean", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFormatTextDirective.prototype, "singleLine", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreFormatTextDirective.prototype, "maxHeight", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFormatTextDirective.prototype, "fullOnClick", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreFormatTextDirective.prototype, "fullTitle", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreFormatTextDirective.prototype, "highlight", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreFormatTextDirective.prototype, "afterRender", void 0);
    CoreFormatTextDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: 'core-format-text'
        }),
        __param(12, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __param(13, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()), __param(14, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_7__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_11__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_logger__["a" /* CoreLoggerProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_15__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* Content */], __WEBPACK_IMPORTED_MODULE_16__components_split_view_split_view__["a" /* CoreSplitViewComponent */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_iframe__["a" /* CoreIframeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreFormatTextDirective);
    return CoreFormatTextDirective;
}());

//# sourceMappingURL=format-text.js.map

/***/ }),
/* 1328 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreKeepKeyboardDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * IMPORTANT: This directive is deprecated because it causes a weird effect (the keyboard closes and opens again).
 * We recommend using core-suppress-events directive for a better user experience.
 *
 * Directive to keep the keyboard open when clicking a certain element (usually a button).
 *
 * @description
 *
 * This directive needs to be applied to an input or textarea. The value of the directive needs to be a selector
 * to identify the element to listen for clicks (usually a button).
 *
 * When that element is clicked, the input that has this directive will keep the focus if it has it already and the keyboard
 * won't be closed.
 *
 * Example usage:
 *
 * <textarea [core-keep-keyboard]="'#mma-messages-send-message-button'"></textarea>
 * <button id="mma-messages-send-message-button">Send</button>
 *
 * Alternatively, this directive can be applied to the button. The value of the directive needs to be a selector to identify
 * the input element. In this case, you need to set [inButton]="true".
 *
 * Example usage:
 *
 * <textarea id="send-message-input"></textarea>
 * <button [core-keep-keyboard]="'#send-message-input'" [inButton]="true">Send</button>
 *
 * @deprecated v3.5.2
 */
var CoreKeepKeyboardDirective = /** @class */ (function () {
    function CoreKeepKeyboardDirective(element, domUtils, utils) {
        this.domUtils = domUtils;
        this.utils = utils;
        this.lastFocusOut = 0; // Last time the input was focused out.
        this.element = element.nativeElement;
    }
    /**
     * View has been initialized.
     */
    CoreKeepKeyboardDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        // Use a setTimeout because to make sure that child components have been treated.
        setTimeout(function () {
            var inButton = _this.utils.isTrueOrOne(_this.inButton);
            var candidateEls, selectedEl;
            if (typeof _this.selector != 'string' || !_this.selector) {
                // Not a valid selector, stop.
                return;
            }
            // Get the selected element. Get the last one found.
            candidateEls = document.querySelectorAll(_this.selector);
            selectedEl = candidateEls[candidateEls.length - 1];
            if (!selectedEl) {
                // Element not found.
                return;
            }
            if (inButton) {
                // The directive is applied to the button.
                _this.button = _this.element;
                _this.input = selectedEl;
            }
            else {
                // The directive is applied to the input.
                _this.button = selectedEl;
                if (_this.element.tagName == 'ION-INPUT') {
                    // Search the inner input.
                    _this.input = _this.element.querySelector('input');
                }
                else if (_this.element.tagName == 'ION-TEXTAREA') {
                    // Search the inner textarea.
                    _this.input = _this.element.querySelector('textarea');
                }
                else {
                    _this.input = _this.element;
                }
                if (!_this.input) {
                    // Input not found, stop.
                    return;
                }
            }
            // Listen for focusout event. This is to be able to check if previous focus was on this element.
            _this.focusOutListener = _this.focusOut.bind(_this);
            _this.input.addEventListener('focusout', _this.focusOutListener);
            // Listen for clicks in the button.
            _this.clickListener = _this.buttonClicked.bind(_this);
            _this.button.addEventListener('click', _this.clickListener);
        });
    };
    /**
     * Component destroyed.
     */
    CoreKeepKeyboardDirective.prototype.ngOnDestroy = function () {
        if (this.button && this.clickListener) {
            this.button.removeEventListener('click', this.clickListener);
        }
        if (this.input && this.focusOutListener) {
            this.input.removeEventListener('focusout', this.focusOutListener);
        }
    };
    /**
     * The button we're interested in was clicked.
     */
    CoreKeepKeyboardDirective.prototype.buttonClicked = function () {
        if (document.activeElement == this.input) {
            // Directive's element is focused at the time the button is clicked. Listen for focusout to focus it again.
            this.focusAgainListener = this.focusElementAgain.bind(this);
            this.input.addEventListener('focusout', this.focusAgainListener);
        }
        else if (document.activeElement == this.button && Date.now() - this.lastFocusOut < 200) {
            // Last focused element was the directive's element, focus it again.
            setTimeout(this.focusElementAgain.bind(this), 0);
        }
    };
    /**
     * If keyboard is open, focus the input again and stop listening focusout to focus again if needed.
     */
    CoreKeepKeyboardDirective.prototype.focusElementAgain = function () {
        var _this = this;
        this.domUtils.focusElement(this.input);
        if (this.focusAgainListener) {
            // Sometimes we can receive more than 1 focus out event.
            // If we spend 1 second without receiving any, stop listening for them.
            var listener_1 = this.focusAgainListener; // Store it in a local variable, in case it changes.
            clearTimeout(this.stopFocusAgainTimeout);
            this.stopFocusAgainTimeout = setTimeout(function () {
                _this.input.removeEventListener('focusout', listener_1);
                if (listener_1 == _this.focusAgainListener) {
                    delete _this.focusAgainListener;
                }
            }, 1000);
        }
    };
    /**
     * Input was focused out, save the time it was done.
     */
    CoreKeepKeyboardDirective.prototype.focusOut = function () {
        this.lastFocusOut = Date.now();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('core-keep-keyboard'),
        __metadata("design:type", String)
    ], CoreKeepKeyboardDirective.prototype, "selector", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreKeepKeyboardDirective.prototype, "inButton", void 0);
    CoreKeepKeyboardDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-keep-keyboard]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreKeepKeyboardDirective);
    return CoreKeepKeyboardDirective;
}());

//# sourceMappingURL=keep-keyboard.js.map

/***/ }),
/* 1329 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserLinkDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};


/**
 * Directive to go to user profile on click.
 */
var CoreUserLinkDirective = /** @class */ (function () {
    function CoreUserLinkDirective(element, navCtrl) {
        this.navCtrl = navCtrl;
        // This directive can be added dynamically. In that case, the first param is the anchor HTMLElement.
        this.element = element.nativeElement || element;
    }
    /**
     * Function executed when the component is initialized.
     */
    CoreUserLinkDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.element.addEventListener('click', function (event) {
            // If the event prevented default action, do nothing.
            if (!event.defaultPrevented) {
                event.preventDefault();
                event.stopPropagation();
                _this.navCtrl.push('CoreUserProfilePage', { userId: _this.userId, courseId: _this.courseId });
            }
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreUserLinkDirective.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreUserLinkDirective.prototype, "courseId", void 0);
    CoreUserLinkDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-user-link]'
        }),
        __param(1, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], CoreUserLinkDirective);
    return CoreUserLinkDirective;
}());

//# sourceMappingURL=user-link.js.map

/***/ }),
/* 1330 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreAutoRowsDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Directive to adapt a textarea rows depending on the input text. It's based on Moodle's data-auto-rows.
 *
 * @description
 * Usage:
 * <textarea class="core-textarea" [(ngModel)]="message" rows="1" core-auto-rows></textarea>
 */
var CoreAutoRowsDirective = /** @class */ (function () {
    function CoreAutoRowsDirective(element) {
        this.element = element;
        this.height = 0;
        this.onResize = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    CoreAutoRowsDirective.prototype.onInput = function () {
        this.resize();
    };
    CoreAutoRowsDirective.prototype.onChange = function () {
        var _this = this;
        // Fired on reset. Wait to the change to be finished.
        setTimeout(function () {
            _this.resize();
        }, 300);
    };
    /**
     * Resize after content.
     */
    CoreAutoRowsDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        // Wait for rendering of child views.
        setTimeout(function () {
            _this.resize();
        }, 300);
    };
    /**
     * Resize the textarea.
     * @param {any} $event Event fired.
     */
    CoreAutoRowsDirective.prototype.resize = function ($event) {
        var nativeElement = this.element.nativeElement;
        if (nativeElement.tagName == 'ION-TEXTAREA') {
            // The first child of ion-textarea is the actual textarea element.
            nativeElement = nativeElement.firstElementChild;
        }
        // Set height to 1px to force scroll height to calculate correctly.
        nativeElement.style.height = '1px';
        nativeElement.style.height = nativeElement.scrollHeight + 'px';
        // Emit event when resizing.
        if (this.height != nativeElement.scrollHeight) {
            this.height = nativeElement.scrollHeight;
            this.onResize.emit();
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreAutoRowsDirective.prototype, "onResize", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["HostListener"])('input'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], CoreAutoRowsDirective.prototype, "onInput", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["HostListener"])('change'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], CoreAutoRowsDirective.prototype, "onChange", null);
    CoreAutoRowsDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: 'textarea[core-auto-rows], ion-textarea[core-auto-rows]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], CoreAutoRowsDirective);
    return CoreAutoRowsDirective;
}());

//# sourceMappingURL=auto-rows.js.map

/***/ }),
/* 1331 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLongPressDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular_gestures_gesture__ = __webpack_require__(749);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// Based on http://roblouie.com/article/198/using-gestures-in-the-ionic-2-beta/


/**
 * Directive to add long press actions to html elements.
 */
var CoreLongPressDirective = /** @class */ (function () {
    function CoreLongPressDirective(el) {
        this.longPress = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.el = el.nativeElement;
        this.el.setAttribute('tappable', '');
    }
    /**
     * Initialize gesture listening.
     */
    CoreLongPressDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.pressGesture = new __WEBPACK_IMPORTED_MODULE_1_ionic_angular_gestures_gesture__["a" /* Gesture */](this.el);
        this.pressGesture.listen();
        this.pressGesture.on('press', function (e) {
            _this.longPress.emit(e);
        });
    };
    /**
     * Destroy gesture listening.
     */
    CoreLongPressDirective.prototype.ngOnDestroy = function () {
        this.pressGesture.destroy();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", Object)
    ], CoreLongPressDirective.prototype, "longPress", void 0);
    CoreLongPressDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[longPress]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], CoreLongPressDirective);
    return CoreLongPressDirective;
}());

//# sourceMappingURL=long-press.js.map

/***/ }),
/* 1332 */,
/* 1333 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBackButtonDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Directive to tramslate the back button of navigation bars in iOS.
 *
 * @description
 * Usage:
 * <ion-navbar core-back-button> ... </ion-navbar>
 */
var CoreBackButtonDirective = /** @class */ (function () {
    function CoreBackButtonDirective(host, platform, translate, eventsProvider) {
        this.host = host;
        this.platform = platform;
        this.translate = translate;
        this.eventsProvider = eventsProvider;
    }
    /**
     * Component being initialized.
     */
    CoreBackButtonDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.setTranslatedBackButtonText();
        this.languageObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].LANGUAGE_CHANGED, function () {
            _this.setTranslatedBackButtonText();
        });
    };
    /**
     * Component being destroyed.
     */
    CoreBackButtonDirective.prototype.ngOnDestroy = function () {
        if (this.languageObserver) {
            this.languageObserver.off();
        }
    };
    /**
     * Set the trasnlated back button text in iOS.
     */
    CoreBackButtonDirective.prototype.setTranslatedBackButtonText = function () {
        if (this.host && this.platform.is('ios')) {
            this.host.setBackButtonText(this.translate.instant('core.back'));
        }
    };
    CoreBackButtonDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: 'ion-navbar[core-back-button]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["v" /* Navbar */], __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreBackButtonDirective);
    return CoreBackButtonDirective;
}());

//# sourceMappingURL=back-button.js.map

/***/ }),
/* 1334 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSupressEventsDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// Based on http://roblouie.com/article/198/using-gestures-in-the-ionic-2-beta/

/**
 * Directive to suppress all events on an element. This is useful to prevent keyboard closing when clicking this element.
 *
 * This directive is based on some code posted by johnthackstonanderson in
 * https://github.com/ionic-team/ionic-plugin-keyboard/issues/81
 *
 * @description
 *
 * If nothing is supplied or string 'all', then all the default events will be suppressed. This is the recommended usage.
 *
 * If you only want to suppress a single event just pass the name of the event. If you want to suppress a set of events,
 * pass an array with the names of the events to suppress.
 *
 * Example usage:
 *
 * <a ion-button [core-suppress-events] (onClick)="toggle($event)">
 */
var CoreSupressEventsDirective = /** @class */ (function () {
    function CoreSupressEventsDirective(el) {
        this.onClick = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.element = el.nativeElement;
    }
    /**
     * Initialize event listeners.
     */
    CoreSupressEventsDirective.prototype.ngOnInit = function () {
        var _this = this;
        var events;
        if (this.suppressEvents == 'all' || typeof this.suppressEvents == 'undefined' || this.suppressEvents === null) {
            // Suppress all events.
            events = ['click', 'mousedown', 'touchdown', 'touchmove', 'touchstart'];
        }
        else if (typeof this.suppressEvents == 'string') {
            // It's a string, just suppress this event.
            events = [this.suppressEvents];
        }
        else if (Array.isArray(this.suppressEvents)) {
            // Array supplied.
            events = this.suppressEvents;
        }
        else {
            events = [];
        }
        // Suppress the events.
        for (var _i = 0, events_1 = events; _i < events_1.length; _i++) {
            var evName = events_1[_i];
            this.element.addEventListener(evName, this.stopBubble.bind(this));
        }
        // Now listen to "click" events.
        this.element.addEventListener('mouseup', function (event) {
            _this.onClick.emit(event);
        });
        this.element.addEventListener('touchend', function (event) {
            _this.stopBubble(event);
            _this.onClick.emit(event);
        });
    };
    /**
     * Stop event default and propagation.
     *
     * @param {Event} event Event.
     */
    CoreSupressEventsDirective.prototype.stopBubble = function (event) {
        event.preventDefault();
        event.stopPropagation();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('core-suppress-events'),
        __metadata("design:type", Object)
    ], CoreSupressEventsDirective.prototype, "suppressEvents", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", Object)
    ], CoreSupressEventsDirective.prototype, "onClick", void 0);
    CoreSupressEventsDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-suppress-events]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], CoreSupressEventsDirective);
    return CoreSupressEventsDirective;
}());

//# sourceMappingURL=supress-events.js.map

/***/ }),
/* 1335 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreBytesToSizePipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Pipe to turn a number in bytes to a human readable size (e.g. 5,25 MB).
 */
var CoreBytesToSizePipe = /** @class */ (function () {
    function CoreBytesToSizePipe(logger, textUtils) {
        this.textUtils = textUtils;
        this.logger = logger.getInstance('CoreBytesToSizePipe');
    }
    /**
     * Takes a number and turns it to a human readable size.
     *
     * @param {number|string} value The bytes to convert.
     * @return {string} Readable bytes.
     */
    CoreBytesToSizePipe.prototype.transform = function (value) {
        if (typeof value == 'string') {
            // Convert the value to a number.
            var numberValue = parseInt(value, 10);
            if (isNaN(numberValue)) {
                this.logger.error('Invalid value received', value);
                return value;
            }
            value = numberValue;
        }
        return this.textUtils.bytesToSize(value);
    };
    CoreBytesToSizePipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreBytesToSize',
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], CoreBytesToSizePipe);
    return CoreBytesToSizePipe;
}());

//# sourceMappingURL=bytes-to-size.js.map

/***/ }),
/* 1336 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCreateLinksPipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

/**
 * Pipe to search URLs that are not inside <a> tags and add the corresponding <a> tags.
 */
var CoreCreateLinksPipe = /** @class */ (function () {
    function CoreCreateLinksPipe() {
        this.replacePattern = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])(?![^<]*>|[^<>]*<\/)/gim;
    }
    /**
     * Takes some text and adds anchor tags to all links that aren't inside anchors.
     *
     * @param {string} text Text to treat.
     * @return {string} Treated text.
     */
    CoreCreateLinksPipe.prototype.transform = function (text) {
        return text.replace(this.replacePattern, '<a href="$1">$1</a>');
    };
    CoreCreateLinksPipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreCreateLinks',
        })
    ], CoreCreateLinksPipe);
    return CoreCreateLinksPipe;
}());

//# sourceMappingURL=create-links.js.map

/***/ }),
/* 1337 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDateDayOrTimePipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_moment__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Filter to display a date using the day, or the time.
 *
 * This shows a short version of a date. Use this filter when you want
 * the user to visualise when the action was done relatively to today's date.
 *
 * For instance, if the action happened during this day it will display the time,
 * but when the action happened few days ago, it will display the day of the week.
 *
 * The older the date is, the more information about it will be displayed.
 *
 * This filter expects a timestamp NOT including milliseconds.
 */
var CoreDateDayOrTimePipe = /** @class */ (function () {
    function CoreDateDayOrTimePipe(logger, translate, timeUtils) {
        this.translate = translate;
        this.timeUtils = timeUtils;
        this.logger = logger.getInstance('CoreDateDayOrTimePipe');
    }
    /**
     * Format a timestamp.
     *
     * @param {number|string} timestamp The UNIX timestamp (without milliseconds).
     * @return {string} Formatted time.
     */
    CoreDateDayOrTimePipe.prototype.transform = function (timestamp) {
        if (typeof timestamp == 'string') {
            // Convert the value to a number.
            var numberTimestamp = parseInt(timestamp, 10);
            if (isNaN(numberTimestamp)) {
                this.logger.error('Invalid value received', timestamp);
                return timestamp;
            }
            timestamp = numberTimestamp;
        }
        return __WEBPACK_IMPORTED_MODULE_4_moment__(timestamp * 1000).calendar(null, {
            sameDay: this.timeUtils.convertPHPToMoment(this.translate.instant('core.strftimetime')),
            lastDay: this.translate.instant('core.dflastweekdate'),
            lastWeek: this.translate.instant('core.dflastweekdate'),
            sameElse: this.timeUtils.convertPHPToMoment(this.translate.instant('core.strftimedatefullshort'))
        });
    };
    CoreDateDayOrTimePipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreDateDayOrTime',
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreDateDayOrTimePipe);
    return CoreDateDayOrTimePipe;
}());

//# sourceMappingURL=date-day-or-time.js.map

/***/ }),
/* 1338 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDurationPipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Filter to turn a number of seconds to a duration. E.g. 60 -> 1 minute.
 */
var CoreDurationPipe = /** @class */ (function () {
    function CoreDurationPipe(logger, timeUtils) {
        this.timeUtils = timeUtils;
        this.logger = logger.getInstance('CoreBytesToSizePipe');
    }
    /**
     * Turn a number of seconds to a duration. E.g. 60 -> 1 minute.
     *
     * @param {number|string} seconds The number of seconds.
     * @return {string} Formatted duration.
     */
    CoreDurationPipe.prototype.transform = function (seconds) {
        if (typeof seconds == 'string') {
            // Convert the value to a number.
            var numberSeconds = parseInt(seconds, 10);
            if (isNaN(numberSeconds)) {
                this.logger.error('Invalid value received', seconds);
                return seconds;
            }
            seconds = numberSeconds;
        }
        return this.timeUtils.formatTime(seconds);
    };
    CoreDurationPipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreDuration',
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreDurationPipe);
    return CoreDurationPipe;
}());

//# sourceMappingURL=duration.js.map

/***/ }),
/* 1339 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFormatDatePipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Filter to format a date.
 */
var CoreFormatDatePipe = /** @class */ (function () {
    function CoreFormatDatePipe(logger, timeUtils) {
        this.timeUtils = timeUtils;
        this.logger = logger.getInstance('CoreFormatDatePipe');
    }
    /**
     * Format a date.
     *
     * @param {string|number} timestamp Timestamp to format (in milliseconds). If not defined, use current time.
     * @param {string} [format] Format to use. It should be a string code to handle i18n (e.g. core.strftimetime).
     *                          Defaults to strftimedaydatetime.
     * @param {boolean} [convert] If true, convert the format from PHP to Moment. Set it to false for Moment formats.
     * @return {string} Formatted date.
     */
    CoreFormatDatePipe.prototype.transform = function (timestamp, format, convert) {
        timestamp = timestamp || Date.now();
        format = format || 'strftimedaydatetime';
        if (typeof timestamp == 'string') {
            // Convert the value to a number.
            var numberTimestamp = parseInt(timestamp, 10);
            if (isNaN(numberTimestamp)) {
                this.logger.error('Invalid value received', timestamp);
                return timestamp;
            }
            timestamp = numberTimestamp;
        }
        // Add "core." if needed.
        if (format.indexOf('strf') == 0 || format.indexOf('df') == 0) {
            format = 'core.' + format;
        }
        if (typeof convert == 'undefined') {
            // Initialize convert param. Set it to false if it's a core.df format, set it to true otherwise.
            convert = format.indexOf('core.df') != 0;
        }
        return this.timeUtils.userDate(timestamp, format, convert);
    };
    CoreFormatDatePipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreFormatDate',
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreFormatDatePipe);
    return CoreFormatDatePipe;
}());

//# sourceMappingURL=format-date.js.map

/***/ }),
/* 1340 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreNoTagsPipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

/**
 * Pipe to remove HTML tags.
 */
var CoreNoTagsPipe = /** @class */ (function () {
    function CoreNoTagsPipe() {
    }
    /**
     * Takes a text and removes HTML tags.
     *
     * @param {string} text The text to treat.
     * @return {string} Treated text.
     */
    CoreNoTagsPipe.prototype.transform = function (text) {
        return text.replace(/(<([^>]+)>)/ig, '');
    };
    CoreNoTagsPipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreNoTags',
        })
    ], CoreNoTagsPipe);
    return CoreNoTagsPipe;
}());

//# sourceMappingURL=no-tags.js.map

/***/ }),
/* 1341 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSecondsToHMSPipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Pipe to convert a number of seconds to Hours:Minutes:Seconds.
 *
 * This converts a number of seconds to Hours:Minutes:Seconds. If the number of seconds is negative, returns 00:00:00.
 */
var CoreSecondsToHMSPipe = /** @class */ (function () {
    function CoreSecondsToHMSPipe(logger, textUtils) {
        this.textUtils = textUtils;
        this.logger = logger.getInstance('CoreSecondsToHMSPipe');
    }
    /**
     * Convert a number of seconds to Hours:Minutes:Seconds.
     *
     * @param {number|string} seconds Number of seconds.
     * @return {string} Formatted seconds.
     */
    CoreSecondsToHMSPipe.prototype.transform = function (seconds) {
        var hours, minutes;
        if (!seconds || seconds < 0) {
            seconds = 0;
        }
        else if (typeof seconds == 'string') {
            // Convert the value to a number.
            var numberSeconds = parseInt(seconds, 10);
            if (isNaN(numberSeconds)) {
                this.logger.error('Invalid value received', seconds);
                return seconds;
            }
            seconds = numberSeconds;
        }
        // Don't allow decimals.
        seconds = Math.floor(seconds);
        hours = Math.floor(seconds / __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_HOUR);
        seconds -= hours * __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_HOUR;
        minutes = Math.floor(seconds / __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_MINUTE);
        seconds -= minutes * __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].SECONDS_MINUTE;
        return this.textUtils.twoDigits(hours) + ':' + this.textUtils.twoDigits(minutes) + ':' + this.textUtils.twoDigits(seconds);
    };
    CoreSecondsToHMSPipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreSecondsToHMS',
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], CoreSecondsToHMSPipe);
    return CoreSecondsToHMSPipe;
}());

//# sourceMappingURL=seconds-to-hms.js.map

/***/ }),
/* 1342 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreTimeAgoPipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_moment__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Pipe to turn a UNIX timestamp to "time ago".
 */
var CoreTimeAgoPipe = /** @class */ (function () {
    function CoreTimeAgoPipe(logger, translate) {
        this.translate = translate;
        this.logger = logger.getInstance('CoreTimeAgoPipe');
    }
    /**
     * Turn a UNIX timestamp to "time ago".
     *
     * @param {number|string} timestamp The UNIX timestamp (without milliseconds).
     * @return {string} Formatted time.
     */
    CoreTimeAgoPipe.prototype.transform = function (timestamp) {
        if (typeof timestamp == 'string') {
            // Convert the value to a number.
            var numberTimestamp = parseInt(timestamp, 10);
            if (isNaN(numberTimestamp)) {
                this.logger.error('Invalid value received', timestamp);
                return timestamp;
            }
            timestamp = numberTimestamp;
        }
        return this.translate.instant('core.ago', { $a: __WEBPACK_IMPORTED_MODULE_3_moment__(timestamp * 1000).fromNow(true) });
    };
    CoreTimeAgoPipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreTimeAgo',
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], CoreTimeAgoPipe);
    return CoreTimeAgoPipe;
}());

//# sourceMappingURL=time-ago.js.map

/***/ }),
/* 1343 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreToLocaleStringPipe; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Filter to format a timestamp to a locale string. Timestamp can be in seconds or milliseconds.
 * @deprecated since 3.6. Use coreFormatDate instead.
 */
var CoreToLocaleStringPipe = /** @class */ (function () {
    function CoreToLocaleStringPipe(logger, timeUtils) {
        this.timeUtils = timeUtils;
        this.logger = logger.getInstance('CoreToLocaleStringPipe');
    }
    /**
     * Format a timestamp to a locale string.
     *
     * @param {number|string} timestamp The timestamp (can be in seconds or milliseconds).
     * @return {string} Formatted time.
     */
    CoreToLocaleStringPipe.prototype.transform = function (timestamp) {
        if (typeof timestamp == 'string') {
            // Convert the value to a number.
            var numberTimestamp = parseInt(timestamp, 10);
            if (isNaN(numberTimestamp)) {
                this.logger.error('Invalid value received', timestamp);
                return timestamp;
            }
            timestamp = numberTimestamp;
        }
        if (timestamp < 0) {
            // Date not valid.
            return '';
        }
        if (timestamp < 100000000000) {
            // Timestamp is in seconds, convert it to milliseconds.
            timestamp = timestamp * 1000;
        }
        return this.timeUtils.userDate(timestamp, 'core.strftimedatetimeshort');
    };
    CoreToLocaleStringPipe = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Pipe"])({
            name: 'coreToLocaleString',
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreToLocaleStringPipe);
    return CoreToLocaleStringPipe;
}());

//# sourceMappingURL=to-locale-string.js.map

/***/ }),
/* 1344 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLoadingComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__classes_animations__ = __webpack_require__(991);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component to show a loading spinner and message while data is being loaded.
 *
 * It will show a spinner with a message and hide all the content until 'dataLoaded' variable is set to true.
 * If 'message' and 'dynMessage' attributes aren't set, default message "Loading" is shown.
 * 'message' attribute accepts hardcoded strings, variables, filters, etc. E.g. message="'core.loading' | translate".
 *
 * Usage:
 * <core-loading [message]="loadingMessage" [hideUntil]="dataLoaded">
 *     <!-- CONTENT TO HIDE UNTIL LOADED -->
 * </core-loading>
 *
 * IMPORTANT: Due to how ng-content works in Angular, the content of core-loading will be executed as soon as your view
 * is loaded, even if the content hidden. So if you have the following code:
 * <core-loading [hideUntil]="dataLoaded"><my-component></my-component></core-loading>
 *
 * The component "my-component" will be initialized immediately, even if dataLoaded is false, but it will be hidden. If you want
 * your component to be initialized only if dataLoaded is true, then you should use ngIf:
 * <core-loading [hideUntil]="dataLoaded"><my-component *ngIf="dataLoaded"></my-component></core-loading>
 */
var CoreLoadingComponent = /** @class */ (function () {
    function CoreLoadingComponent(translate, element, eventsProvider, utils) {
        this.translate = translate;
        this.eventsProvider = eventsProvider;
        this.element = element.nativeElement;
        // Calculate the unique ID.
        this.uniqueId = 'core-loading-content-' + utils.getUniqueId('CoreLoadingComponent');
    }
    /**
     * Component being initialized.
     */
    CoreLoadingComponent.prototype.ngOnInit = function () {
        if (!this.message) {
            // Default loading message.
            this.message = this.translate.instant('core.loading');
        }
        // Add class if loaded on init.
        if (this.hideUntil) {
            this.element.classList.add('core-loading-loaded');
            this.content.nativeElement.classList.add('core-loading-content');
        }
    };
    CoreLoadingComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        if (changes.hideUntil) {
            if (changes.hideUntil.currentValue === true) {
                setTimeout(function () {
                    // Content is loaded so, center the spinner on the content itself.
                    _this.element.classList.add('core-loading-loaded');
                    setTimeout(function () {
                        // Change CSS to force calculate height.
                        _this.content.nativeElement.classList.add('core-loading-content');
                    }, 500);
                });
            }
            else {
                this.element.classList.remove('core-loading-loaded');
                this.content.nativeElement.classList.remove('core-loading-content');
            }
            // Trigger the event after a timeout since the elements inside ngIf haven't been added to DOM yet.
            setTimeout(function () {
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].CORE_LOADING_CHANGED, {
                    loaded: changes.hideUntil.currentValue,
                    uniqueId: _this.uniqueId
                });
            });
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreLoadingComponent.prototype, "hideUntil", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreLoadingComponent.prototype, "message", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('content'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreLoadingComponent.prototype, "content", void 0);
    CoreLoadingComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-loading',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\loading\core-loading.html"*/'<div [@coreShowHideAnimation] class="core-loading-container" *ngIf="!hideUntil" role="status">\n    <span class="core-loading-spinner">\n        <ion-spinner></ion-spinner>\n        <p class="core-loading-message" *ngIf="message" role="status">{{message}}</p>\n    </span>\n</div>\n<div #content class="core-loading-content" [id]="uniqueId" [attr.aria-busy]="hideUntil">\n    <ng-content [@coreShowHideAnimation] *ngIf="hideUntil">\n    </ng-content>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\loading\core-loading.html"*/,
            animations: [__WEBPACK_IMPORTED_MODULE_2__classes_animations__["a" /* coreShowHideAnimation */]]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreLoadingComponent);
    return CoreLoadingComponent;
}());

//# sourceMappingURL=loading.js.map

/***/ }),
/* 1345 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreMarkRequiredComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Directive to add a red asterisk for required input fields.
 *
 * @description
 * For forms with required and not required fields, it is recommended to use this directive to mark the required ones.
 *
 * This directive should be applied in the label. Example:
 *
 * <ion-label core-mark-required="{{field.required}}">{{ 'core.login.username' | translate }}</ion-label>
 */
var CoreMarkRequiredComponent = /** @class */ (function () {
    function CoreMarkRequiredComponent(element, translate, textUtils, utils) {
        this.translate = translate;
        this.textUtils = textUtils;
        this.utils = utils;
        this.coreMarkRequired = true;
        this.element = element.nativeElement;
        this.requiredLabel = this.translate.instant('core.required');
    }
    /**
     * Component being initialized.
     */
    CoreMarkRequiredComponent.prototype.ngOnInit = function () {
        this.coreMarkRequired = this.utils.isTrueOrOne(this.coreMarkRequired);
    };
    /**
     * Called after the view is initialized.
     */
    CoreMarkRequiredComponent.prototype.ngAfterViewInit = function () {
        if (this.coreMarkRequired) {
            // Add the "required" to the aria-label.
            var ariaLabel = this.element.getAttribute('aria-label') || this.textUtils.cleanTags(this.element.innerHTML, true);
            if (ariaLabel) {
                this.element.setAttribute('aria-label', ariaLabel + ' ' + this.requiredLabel);
            }
        }
        else {
            // Remove the "required" from the aria-label.
            var ariaLabel = this.element.getAttribute('aria-label');
            if (ariaLabel) {
                this.element.setAttribute('aria-label', ariaLabel.replace(' ' + this.requiredLabel, ''));
            }
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('core-mark-required'),
        __metadata("design:type", Object)
    ], CoreMarkRequiredComponent.prototype, "coreMarkRequired", void 0);
    CoreMarkRequiredComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: '[core-mark-required]',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\mark-required\core-mark-required.html"*/'<ng-content></ng-content>\n<ion-icon *ngIf="coreMarkRequired" class="core-input-required-asterisk" name="medical" md="ios-medical" [title]="requiredLabel"></ion-icon> <!-- Use iOS icon because it\'s more narrow, so it looks better since it\'s small. -->\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\mark-required\core-mark-required.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreMarkRequiredComponent);
    return CoreMarkRequiredComponent;
}());

//# sourceMappingURL=mark-required.js.map

/***/ }),
/* 1346 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreInputErrorsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to show errors if an input isn't valid.
 *
 * @description
 * The purpose of this component is to make easier and consistent the validation of forms.
 *
 * It should be applied next to the input element (ion-input, ion-select, ...). In case of ion-checkbox, it should be in another
 * item, placing it in the same item as the checkbox will cause problems.
 *
 * Please notice that the inputs need to have a FormControl to make it work. That FormControl needs to be passed to this component.
 *
 * If this component is placed in the same ion-item as a ion-label or ion-input, then it should have the attribute "item-content",
 * otherwise Ionic will remove it.
 *
 * Example usage:
 *
 * <ion-item text-wrap>
 *     <ion-label stacked core-mark-required="true">{{ 'core.login.username' | translate }}</ion-label>
 *     <ion-input type="text" name="username" formControlName="username"></ion-input>
 *     <core-input-errors item-content [control]="myForm.controls.username" [errorMessages]="usernameErrors"></core-input-errors>
 * </ion-item>
 */
var CoreInputErrorsComponent = /** @class */ (function () {
    function CoreInputErrorsComponent(translate) {
        this.translate = translate;
    }
    /**
     * Component is being initialized.
     */
    CoreInputErrorsComponent.prototype.ngOnInit = function () {
        if (this.formControl) {
            this.initErrorMessages();
            this.errorKeys = Object.keys(this.errorMessages);
        }
    };
    /**
     * Initialize some common errors if they aren't set.
     */
    CoreInputErrorsComponent.prototype.initErrorMessages = function () {
        this.errorMessages = this.errorMessages || {};
        this.errorMessages.required = this.errorMessages.required || this.translate.instant('core.required');
        this.errorMessages.email = this.errorMessages.email || this.translate.instant('core.login.invalidemail');
        this.errorMessages.date = this.errorMessages.date || this.translate.instant('core.login.invaliddate');
        this.errorMessages.datetime = this.errorMessages.datetime || this.translate.instant('core.login.invaliddate');
        this.errorMessages.datetimelocal = this.errorMessages.datetimelocal || this.translate.instant('core.login.invaliddate');
        this.errorMessages.time = this.errorMessages.time || this.translate.instant('core.login.invalidtime');
        this.errorMessages.url = this.errorMessages.url || this.translate.instant('core.login.invalidurl');
        // Set empty values by default, the default error messages will be built in the template when needed.
        this.errorMessages.max = this.errorMessages.max || '';
        this.errorMessages.min = this.errorMessages.min || '';
    };
    /**
     * Component being changed.
     */
    CoreInputErrorsComponent.prototype.ngOnChanges = function (changes) {
        if (changes.errorText) {
            this.errorText = changes.errorText.currentValue;
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('control'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["b" /* FormControl */])
    ], CoreInputErrorsComponent.prototype, "formControl", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreInputErrorsComponent.prototype, "errorMessages", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreInputErrorsComponent.prototype, "errorText", void 0);
    CoreInputErrorsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-input-errors',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\input-errors\core-input-errors.html"*/'<div class="core-input-error-container" role="alert" *ngIf="(formControl && formControl.dirty && !formControl.valid) || errorText">\n    <ng-container *ngIf="formControl && formControl.dirty && !formControl.valid">\n        <ng-container *ngFor="let error of errorKeys">\n            <div *ngIf="formControl.hasError(error)" class="core-input-error">\n                <span *ngIf="errorMessages[error]">{{errorMessages[error]}}</span>\n                <span *ngIf="!errorMessages[error] && error == \'max\' && formControl.errors.max">\n                    {{ \'core.login.invalidvaluemax\' | translate:{$a: formControl.errors.max.max} }}\n                </span>\n                <span *ngIf="!errorMessages[error] && error == \'min\' && formControl.errors.min">\n                    {{ \'core.login.invalidvaluemin\' | translate:{$a: formControl.errors.min.min} }}\n                </span>\n            </div>\n        </ng-container>\n    </ng-container>\n    <div *ngIf="errorText" class="core-input-error" aria-live="assertive">{{ errorText }}</div>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\input-errors\core-input-errors.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */]])
    ], CoreInputErrorsComponent);
    return CoreInputErrorsComponent;
}());

//# sourceMappingURL=input-errors.js.map

/***/ }),
/* 1347 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreShowPasswordComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to allow showing and hiding a password. The affected input MUST have a name to identify it.
 *
 * @description
 * This directive needs to surround the input with the password.
 *
 * You need to supply the name of the input.
 *
 * Example:
 *
 * <core-show-password item-content [name]="'password'">
 *     <ion-input type="password" name="password"></ion-input>
 * </core-show-password>
 */
var CoreShowPasswordComponent = /** @class */ (function () {
    function CoreShowPasswordComponent(element, utils, domUtils, platform) {
        this.utils = utils;
        this.domUtils = domUtils;
        this.platform = platform;
        this.selector = ''; // Selector to identify the input.
        this.element = element.nativeElement;
    }
    /**
     * Component being initialized.
     */
    CoreShowPasswordComponent.prototype.ngOnInit = function () {
        this.shown = this.utils.isTrueOrOne(this.initialShown);
        this.selector = 'input[name="' + this.name + '"]';
        this.setData();
    };
    /**
     * View has been initialized.
     */
    CoreShowPasswordComponent.prototype.ngAfterViewInit = function () {
        this.searchInput();
    };
    /**
     * Search the input to show/hide.
     */
    CoreShowPasswordComponent.prototype.searchInput = function () {
        // Search the input.
        this.input = this.element.querySelector(this.selector);
        if (this.input) {
            // Input found. Set the right type.
            this.input.type = this.shown ? 'text' : 'password';
            // By default, don't autocapitalize and autocorrect.
            if (!this.input.getAttribute('autocorrect')) {
                this.input.setAttribute('autocorrect', 'off');
            }
            if (!this.input.getAttribute('autocapitalize')) {
                this.input.setAttribute('autocapitalize', 'none');
            }
        }
    };
    /**
     * Set label, icon name and input type.
     */
    CoreShowPasswordComponent.prototype.setData = function () {
        this.label = this.shown ? 'core.hide' : 'core.show';
        this.iconName = this.shown ? 'eye-off' : 'eye';
        if (this.input) {
            this.input.type = this.shown ? 'text' : 'password';
        }
    };
    /**
     * Toggle show/hide password.
     *
     * @param {Event} event The mouse event.
     */
    CoreShowPasswordComponent.prototype.toggle = function (event) {
        var _this = this;
        event.preventDefault();
        event.stopPropagation();
        var isFocused = document.activeElement === this.input;
        this.shown = !this.shown;
        this.setData();
        if (isFocused && this.platform.is('android')) {
            // In Android, the keyboard is closed when the input type changes. Focus it again.
            setTimeout(function () {
                _this.domUtils.focusElement(_this.input);
            }, 400);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreShowPasswordComponent.prototype, "name", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreShowPasswordComponent.prototype, "initialShown", void 0);
    CoreShowPasswordComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-show-password',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\show-password\core-show-password.html"*/'<ng-content></ng-content>\n<a ion-button icon-only clear [attr.aria-label]="label | translate" [core-suppress-events] (onClick)="toggle($event)">\n    <core-icon [name]="iconName"></core-icon>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\show-password\core-show-password.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["w" /* Platform */]])
    ], CoreShowPasswordComponent);
    return CoreShowPasswordComponent;
}());

//# sourceMappingURL=show-password.js.map

/***/ }),
/* 1348 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreIframeComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__ = __webpack_require__(83);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_iframe__ = __webpack_require__(346);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 */
var CoreIframeComponent = /** @class */ (function () {
    function CoreIframeComponent(logger, iframeUtils, domUtils, sanitizer) {
        this.iframeUtils = iframeUtils;
        this.domUtils = domUtils;
        this.sanitizer = sanitizer;
        this.loaded = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.IFRAME_TIMEOUT = 15000;
        this.logger = logger.getInstance('CoreIframe');
        this.loaded = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    CoreIframeComponent.prototype.ngOnInit = function () {
        var _this = this;
        var iframe = this.iframe && this.iframe.nativeElement;
        this.iframeWidth = this.domUtils.formatPixelsSize(this.iframeWidth) || '100%';
        this.iframeHeight = this.domUtils.formatPixelsSize(this.iframeHeight) || '100%';
        // Show loading only with external URLs.
        this.loading = !this.src || !!this.src.match(/^https?:\/\//i);
        this.iframeUtils.treatFrame(iframe);
        if (this.loading) {
            iframe.addEventListener('load', function () {
                _this.loading = false;
                _this.loaded.emit(iframe); // Notify iframe was loaded.
            });
            iframe.addEventListener('error', function () {
                _this.loading = false;
                _this.domUtils.showErrorModal('core.errorloadingcontent', true);
            });
            setTimeout(function () {
                _this.loading = false;
            }, this.IFRAME_TIMEOUT);
        }
    };
    /**
     * Detect changes on input properties.
     */
    CoreIframeComponent.prototype.ngOnChanges = function (changes) {
        if (changes.src) {
            this.safeUrl = this.sanitizer.bypassSecurityTrustResourceUrl(changes.src.currentValue);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('iframe'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreIframeComponent.prototype, "iframe", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreIframeComponent.prototype, "src", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreIframeComponent.prototype, "iframeWidth", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreIframeComponent.prototype, "iframeHeight", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreIframeComponent.prototype, "loaded", void 0);
    CoreIframeComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-iframe',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\iframe\core-iframe.html"*/'<div [class.core-loading-container]="loading">\n    <iframe #iframe [hidden]="loading" class="core-iframe" [ngStyle]="{\'width\': iframeWidth, \'height\': iframeHeight}" [src]="safeUrl"></iframe>\n    <span class="core-loading-spinner">\n        <ion-spinner *ngIf="loading"></ion-spinner>\n    </span>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\iframe\core-iframe.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_iframe__["a" /* CoreIframeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__["c" /* DomSanitizer */]])
    ], CoreIframeComponent);
    return CoreIframeComponent;
}());

//# sourceMappingURL=iframe.js.map

/***/ }),
/* 1349 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreProgressBarComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__ = __webpack_require__(83);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to show a progress bar and its value.
 *
 * Example usage:
 * <core-progress-bar [progress]="percentage"></core-progress-bar>
 */
var CoreProgressBarComponent = /** @class */ (function () {
    function CoreProgressBarComponent(sanitizer) {
        this.sanitizer = sanitizer;
        this.textSupplied = false;
    }
    /**
     * Detect changes on input properties.
     */
    CoreProgressBarComponent.prototype.ngOnChanges = function (changes) {
        if (changes.text && typeof changes.text.currentValue != 'undefined') {
            // User provided a custom text, don't use default.
            this.textSupplied = true;
        }
        if (changes.progress) {
            // Progress has changed.
            if (typeof this.progress == 'string') {
                this.progress = parseInt(this.progress, 10);
            }
            if (this.progress < 0 || isNaN(this.progress)) {
                this.progress = -1;
            }
            if (this.progress != -1) {
                // Remove decimals.
                this.progress = Math.floor(this.progress);
                if (!this.textSupplied) {
                    this.text = String(this.progress);
                }
                this.width = this.sanitizer.bypassSecurityTrustStyle(this.progress + '%');
            }
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreProgressBarComponent.prototype, "progress", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreProgressBarComponent.prototype, "text", void 0);
    CoreProgressBarComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-progress-bar',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\progress-bar\core-progress-bar.html"*/'<div *ngIf="progress >= 0">\n    <progress max="100" [value]="progress" role="progressbar" aria-valuemin="0" aria-valuemax="100" [attr.aria-valuenow]="progress">\n        <div class="progress-bar-fallback" role="progressbar" aria-valuemin="0" aria-valuemax="100" [attr.aria-valuenow]="progress">\n            <span [style.width]="width"></span>\n        </div>\n    </progress>\n    <span class="core-progress-text">{{ \'core.percentagenumber\' | translate: {$a: text} }}</span>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\progress-bar\core-progress-bar.html"*/,
            changeDetection: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectionStrategy"].OnPush
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__["c" /* DomSanitizer */]])
    ], CoreProgressBarComponent);
    return CoreProgressBarComponent;
}());

//# sourceMappingURL=progress-bar.js.map

/***/ }),
/* 1350 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreEmptyBoxComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Component to show an empty box message. It will show an optional icon or image and a text centered on page.
 *
 * Use class="core-empty-box-clickable" if you want to add some clickable elements to the box.
 *
 * Usage:
 * <core-empty-box *ngIf="empty" icon="bell" [message]="'core.emptymessage' | translate"></core-empty-box>
 */
var CoreEmptyBoxComponent = /** @class */ (function () {
    // If image or icon is not supplied, it's true by default.
    function CoreEmptyBoxComponent() {
        // Nothing to do.
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreEmptyBoxComponent.prototype, "message", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreEmptyBoxComponent.prototype, "icon", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreEmptyBoxComponent.prototype, "image", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreEmptyBoxComponent.prototype, "inline", void 0);
    CoreEmptyBoxComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-empty-box',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\empty-box\core-empty-box.html"*/'<div class="core-empty-box" [class.core-empty-box-inline]="(!image && !icon) || inline">\n    <div class="core-empty-box-content" padding>\n        <img *ngIf="image && !icon" [src]="image" role="presentation">\n        <core-icon *ngIf="icon" [name]="icon"></core-icon>\n        <p *ngIf="message" [class.padding-top]="image || icon">{{ message }}</p>\n        <ng-content></ng-content>\n    </div>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\empty-box\core-empty-box.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], CoreEmptyBoxComponent);
    return CoreEmptyBoxComponent;
}());

//# sourceMappingURL=empty-box.js.map

/***/ }),
/* 1351 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSearchBoxComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Component to display a "search box".
 *
 * @description
 * This component will display a standalone search box with its search button in order to have a better UX.
 *
 * Example usage:
 * <core-search-box (onSubmit)="search($event)" [placeholder]="'core.courses.search' | translate"
 *     [searchLabel]="'core.courses.search' | translate" autoFocus="true"></core-search-box>
 */
var CoreSearchBoxComponent = /** @class */ (function () {
    function CoreSearchBoxComponent(translate, utils) {
        this.translate = translate;
        this.utils = utils;
        this.autocorrect = 'on'; // Enables/disable Autocorrection on search text input.
        this.spellcheck = true; // Enables/disable Spellchecker on search text input.
        this.lengthCheck = 3; // Check value length before submit. If 0, any string will be submitted.
        this.showClear = true; // Show/hide clear button.
        this.disabled = false; // Disables the input text.
        this.searched = false;
        this.searchText = '';
        this.onSubmit = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.onClear = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    CoreSearchBoxComponent.prototype.ngOnInit = function () {
        this.searchLabel = this.searchLabel || this.translate.instant('core.search');
        this.placeholder = this.placeholder || this.translate.instant('core.search');
        this.spellcheck = this.utils.isTrueOrOne(this.spellcheck);
        this.showClear = this.utils.isTrueOrOne(this.showClear);
    };
    /**
     * Form submitted.
     *
     * @param {Event} e Event.
     */
    CoreSearchBoxComponent.prototype.submitForm = function (e) {
        e.preventDefault();
        e.stopPropagation();
        if (this.searchText.length < this.lengthCheck) {
            // The view should handle this case, but we check it here too just in case.
            return;
        }
        this.searched = true;
        this.onSubmit.emit(this.searchText);
    };
    /**
     * Form submitted.
     */
    CoreSearchBoxComponent.prototype.clearForm = function () {
        this.searched = false;
        this.searchText = '';
        this.onClear.emit();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSearchBoxComponent.prototype, "searchLabel", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSearchBoxComponent.prototype, "placeholder", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSearchBoxComponent.prototype, "autocorrect", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSearchBoxComponent.prototype, "spellcheck", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSearchBoxComponent.prototype, "autoFocus", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSearchBoxComponent.prototype, "lengthCheck", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSearchBoxComponent.prototype, "showClear", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSearchBoxComponent.prototype, "disabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSearchBoxComponent.prototype, "onSubmit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSearchBoxComponent.prototype, "onClear", void 0);
    CoreSearchBoxComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-search-box',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\search-box\core-search-box.html"*/'<ion-card>\n    <form #f="ngForm" (ngSubmit)="submitForm($event)" role="search">\n        <ion-item>\n            <ion-input type="search" name="search" [(ngModel)]="searchText" [placeholder]="placeholder" [autocorrect]="autocorrect" [spellcheck]="spellcheck" [core-auto-focus]="autoFocus" [disabled]="disabled" role="searchbox"></ion-input>\n            <button item-end ion-button clear icon-only type="submit" class="button-small" [attr.aria-label]="searchLabel" [disabled]="!searchText || (searchText.length < lengthCheck)" [disabled]="disabled">\n                <ion-icon name="search"></ion-icon>\n            </button>\n            <button *ngIf="showClear" item-end ion-button clear icon-only class="button-small" [attr.aria-label]="\'core.clearsearch\' | translate" [disabled]="!searched" (click)="clearForm()" [disabled]="disabled">\n                <ion-icon name="close"></ion-icon>\n            </button>\n        </ion-item>\n    </form>\n</ion-card>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\search-box\core-search-box.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreSearchBoxComponent);
    return CoreSearchBoxComponent;
}());

//# sourceMappingURL=search-box.js.map

/***/ }),
/* 1352 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_file_helper__ = __webpack_require__(252);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Component to handle a remote file. Shows the file name, icon (depending on mimetype) and a button
 * to download/refresh it.
 */
var CoreFileComponent = /** @class */ (function () {
    function CoreFileComponent(sitesProvider, utils, domUtils, filepoolProvider, appProvider, fileHelper, mimeUtils, eventsProvider, textUtils) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.domUtils = domUtils;
        this.filepoolProvider = filepoolProvider;
        this.appProvider = appProvider;
        this.fileHelper = fileHelper;
        this.mimeUtils = mimeUtils;
        this.eventsProvider = eventsProvider;
        this.textUtils = textUtils;
        // Use it for files that you cannot determine if they're outdated or not.
        this.canDownload = true; // Whether file can be downloaded.
        this.showSize = true; // Whether show filesize.
        this.showTime = true; // Whether show file time modified.
        this.onDelete = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    CoreFileComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.canDelete = this.utils.isTrueOrOne(this.canDelete);
        this.alwaysDownload = this.utils.isTrueOrOne(this.alwaysDownload);
        this.canDownload = this.utils.isTrueOrOne(this.canDownload);
        this.fileUrl = this.fileHelper.getFileUrl(this.file);
        this.timemodified = this.fileHelper.getFileTimemodified(this.file);
        this.siteId = this.sitesProvider.getCurrentSiteId();
        this.fileSize = this.file.filesize;
        this.fileName = this.file.filename;
        if (this.utils.isTrueOrOne(this.showSize) && this.fileSize >= 0) {
            this.fileSizeReadable = this.textUtils.bytesToSize(this.fileSize, 2);
        }
        this.showTime = this.utils.isTrueOrOne(this.showTime) && this.timemodified > 0;
        if (this.file.isexternalfile) {
            this.alwaysDownload = true; // Always show the download button in external files.
        }
        this.fileIcon = this.mimeUtils.getFileIcon(this.file.filename);
        if (this.canDownload) {
            this.calculateState();
            // Update state when receiving events about this file.
            this.filepoolProvider.getFileEventNameByUrl(this.siteId, this.fileUrl).then(function (eventName) {
                _this.observer = _this.eventsProvider.on(eventName, function () {
                    _this.calculateState();
                });
            });
        }
    };
    /**
     * Convenience function to get the file state and set variables based on it.
     *
     * @return {Promise<void>} Promise resolved when state has been calculated.
     */
    CoreFileComponent.prototype.calculateState = function () {
        var _this = this;
        return this.filepoolProvider.getFileStateByUrl(this.siteId, this.fileUrl, this.timemodified).then(function (state) {
            _this.canDownload = _this.sitesProvider.getCurrentSite().canDownloadFiles();
            _this.state = state;
            _this.isDownloading = _this.canDownload && state === __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].DOWNLOADING;
        });
    };
    /**
     * Convenience function to open a file, downloading it if needed.
     *
     * @return {Promise<string>} Promise resolved when file is opened.
     */
    CoreFileComponent.prototype.openFile = function () {
        var _this = this;
        return this.fileHelper.downloadAndOpenFile(this.file, this.component, this.componentId, this.state, function (event) {
            if (event && event.calculating) {
                // The process is calculating some data required for the download, show the spinner.
                _this.isDownloading = true;
            }
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
        });
    };
    /**
     * Download a file and, optionally, open it afterwards.
     *
     * @param {Event} [e] Click event.
     * @param {boolean} openAfterDownload Whether the file should be opened after download.
     */
    CoreFileComponent.prototype.download = function (e, openAfterDownload) {
        var _this = this;
        if (openAfterDownload === void 0) { openAfterDownload = false; }
        e && e.preventDefault();
        e && e.stopPropagation();
        var promise;
        if (this.isDownloading && !openAfterDownload) {
            return;
        }
        if (!this.canDownload) {
            // File cannot be downloaded, just open it.
            if (this.file.toURL) {
                // Local file.
                this.utils.openFile(this.file.toURL());
            }
            else if (this.fileUrl) {
                if (this.fileUrl.indexOf('http') === 0) {
                    this.utils.openOnlineFile(this.fileUrl);
                }
                else {
                    this.utils.openFile(this.fileUrl);
                }
            }
            return;
        }
        if (!this.appProvider.isOnline() && (!openAfterDownload || (openAfterDownload &&
            !(this.state === __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].DOWNLOADED || this.state === __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].OUTDATED)))) {
            this.domUtils.showErrorModal('core.networkerrormsg', true);
            return;
        }
        if (openAfterDownload) {
            // File needs to be opened now.
            this.openFile().catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
            });
        }
        else {
            // File doesn't need to be opened (it's a prefetch). Show confirm modal if file size is defined and it's big.
            promise = this.fileSize ? this.domUtils.confirmDownloadSize({ size: this.fileSize, total: true }) : Promise.resolve();
            promise.then(function () {
                // User confirmed, add the file to queue.
                return _this.filepoolProvider.invalidateFileByUrl(_this.siteId, _this.fileUrl).finally(function () {
                    _this.isDownloading = true;
                    _this.filepoolProvider.addToQueueByUrl(_this.siteId, _this.fileUrl, _this.component, _this.componentId, _this.timemodified, undefined, undefined, 0, _this.file).catch(function (error) {
                        _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
                        _this.calculateState();
                    });
                });
            }).catch(function () {
                // Ignore error.
            });
        }
    };
    /**
     * Delete the file.
     *
     * @param {Event} e Click event.
     */
    CoreFileComponent.prototype.delete = function (e) {
        e.preventDefault();
        e.stopPropagation();
        if (this.canDelete) {
            this.onDelete.emit();
        }
    };
    /**
     * Component destroyed.
     */
    CoreFileComponent.prototype.ngOnDestroy = function () {
        this.observer && this.observer.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFileComponent.prototype, "file", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreFileComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFileComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFileComponent.prototype, "canDelete", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFileComponent.prototype, "alwaysDownload", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFileComponent.prototype, "canDownload", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFileComponent.prototype, "showSize", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreFileComponent.prototype, "showTime", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreFileComponent.prototype, "onDelete", void 0);
    CoreFileComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-file',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\file\core-file.html"*/'<a ion-item text-wrap class="item-media" (click)="download($event, true)" detail-none>\n    <img [src]="fileIcon" alt="" role="presentation" item-start />\n    <h2>{{fileName}}</h2>\n    <p *ngIf="fileSizeReadable">{{ fileSizeReadable }}</p>\n    <p *ngIf="showTime">{{ timemodified * 1000 | coreFormatDate }}</p>\n\n    <div class="buttons" item-end>\n        <core-download-refresh [status]="state" [enabled]="canDownload" [loading]="isDownloading" [canTrustDownload]="!alwaysDownload" (action)="download()"></core-download-refresh>\n\n        <button ion-button clear icon-only (click)="delete($event)" *ngIf="!isDownloading && canDelete" [attr.aria-label]="\'core.delete\' | translate" color="danger">\n            <ion-icon name="trash"></ion-icon>\n        </button>\n    </div>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\file\core-file.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_file_helper__["a" /* CoreFileHelperProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], CoreFileComponent);
    return CoreFileComponent;
}());

//# sourceMappingURL=file.js.map

/***/ }),
/* 1353 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreIconComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Core Icon is a component that enabled a posibility to add fontawesome icon to the html. It's recommended if both fontawesome
 * or ionicons can be used in the name attribute. To use fontawesome just place the full icon name with the fa- prefix and
 * the component will detect it.
 * Check available icons https://fontawesome.com/v4.7.0/icons/.
 */
var CoreIconComponent = /** @class */ (function () {
    function CoreIconComponent(el, config) {
        this.config = config;
        this.element = el.nativeElement;
    }
    /**
     * Detect changes on input properties.
     */
    CoreIconComponent.prototype.ngOnChanges = function (changes) {
        if (!changes.name || !this.name) {
            return;
        }
        var oldElement = this.newElement ? this.newElement : this.element;
        // Use a new created element to avoid ion-icon working.
        // This is necessary to make the FontAwesome stuff work.
        // It is also required to stop Ionic overriding the aria-label attribute.
        this.newElement = document.createElement('ion-icon');
        if (this.name.startsWith('fa-')) {
            this.newElement.classList.add('icon');
            this.newElement.classList.add('fa');
            this.newElement.classList.add(this.name);
            if (this.isTrueProperty(this.fixedWidth)) {
                this.newElement.classList.add('fa-fw');
            }
            if (this.color) {
                this.newElement.classList.add('fa-' + this.color);
            }
        }
        else {
            var mode = this.config.get('iconMode');
            this.newElement.classList.add('icon');
            this.newElement.classList.add('icon-' + mode);
            this.newElement.classList.add('ion-' + mode + '-' + this.name);
        }
        !this.ariaLabel && this.newElement.setAttribute('aria-hidden', 'true');
        !this.ariaLabel && this.newElement.setAttribute('role', 'presentation');
        this.ariaLabel && this.newElement.setAttribute('aria-label', this.ariaLabel);
        var attrs = this.element.attributes;
        for (var i = attrs.length - 1; i >= 0; i--) {
            if (attrs[i].name == 'class') {
                // We don't want to override the classes we already added. Add them one by one.
                if (attrs[i].value) {
                    var classes = attrs[i].value.split(' ');
                    for (var j = 0; j < classes.length; j++) {
                        if (classes[j]) {
                            this.newElement.classList.add(classes[j]);
                        }
                    }
                }
            }
            else {
                this.newElement.setAttribute(attrs[i].name, attrs[i].value);
            }
        }
        if (this.slash) {
            this.newElement.classList.add('icon-slash');
        }
        oldElement.parentElement.replaceChild(this.newElement, oldElement);
    };
    /**
     * Check if the value is true or on.
     *
     * @param  {any}     val value to be checked.
     * @return {boolean}     If has a value equivalent to true.
     */
    CoreIconComponent.prototype.isTrueProperty = function (val) {
        if (typeof val === 'string') {
            val = val.toLowerCase().trim();
            return (val === 'true' || val === 'on' || val === '');
        }
        return !!val;
    };
    /**
     * Component destroyed.
     */
    CoreIconComponent.prototype.ngOnDestroy = function () {
        if (this.newElement) {
            this.newElement.remove();
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreIconComponent.prototype, "name", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('color'),
        __metadata("design:type", String)
    ], CoreIconComponent.prototype, "color", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('slash'),
        __metadata("design:type", Boolean)
    ], CoreIconComponent.prototype, "slash", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('isActive'),
        __metadata("design:type", Boolean)
    ], CoreIconComponent.prototype, "isActive", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('md'),
        __metadata("design:type", String)
    ], CoreIconComponent.prototype, "md", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('ios'),
        __metadata("design:type", String)
    ], CoreIconComponent.prototype, "ios", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('fixed-width'),
        __metadata("design:type", String)
    ], CoreIconComponent.prototype, "fixedWidth", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('label'),
        __metadata("design:type", String)
    ], CoreIconComponent.prototype, "ariaLabel", void 0);
    CoreIconComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-icon',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\icon\core-icon.html"*/'<div></div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\icon\core-icon.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Config */]])
    ], CoreIconComponent);
    return CoreIconComponent;
}());

//# sourceMappingURL=icon.js.map

/***/ }),
/* 1354 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreContextMenuItemComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__context_menu__ = __webpack_require__(750);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * This directive adds a item to the Context Menu popover.
 *
 * @description
 * This directive defines and item to be added to the popover generated in CoreContextMenu.
 *
 * It is required to place this tag inside a core-context-menu tag.
 *
 * <core-context-menu>
 *     <core-context-menu-item [hidden]="showGrid" [priority]="601" [content]="'core.layoutgrid' | translate"
 *         (action)="switchGrid()" [iconAction]="'apps'"></core-context-menu-item>
 * </core-context-menu>
 */
var CoreContextMenuItemComponent = /** @class */ (function () {
    function CoreContextMenuItemComponent(ctxtMenu) {
        this.ctxtMenu = ctxtMenu;
        this.closeOnClick = true; // Whether to close the popover when the item is clicked.
        this.hasAction = false;
        this.destroyed = false;
        this.action = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    CoreContextMenuItemComponent.prototype.ngOnInit = function () {
        // Initialize values.
        this.priority = this.priority || 1;
        this.closeOnClick = this.getBooleanValue(this.closeOnClick, true);
        this.hasAction = this.action.observers.length > 0;
        this.ariaAction = this.ariaAction || this.content;
        if (this.hasAction) {
            this.href = '';
        }
        // Navigation help if href provided.
        this.captureLink = this.href && this.captureLink ? this.captureLink : false;
        this.autoLogin = this.autoLogin || 'check';
        if (!this.destroyed) {
            this.ctxtMenu.addItem(this);
        }
    };
    /**
     * Get a boolean value from item.
     *
     * @param {any} value Value to check.
     * @param {boolean} defaultValue Value to use if undefined.
     * @return {boolean} Boolean value.
     */
    CoreContextMenuItemComponent.prototype.getBooleanValue = function (value, defaultValue) {
        if (typeof value == 'undefined') {
            return defaultValue;
        }
        return value && value !== 'false';
    };
    /**
     * Component destroyed.
     */
    CoreContextMenuItemComponent.prototype.ngOnDestroy = function () {
        this.destroyed = true;
        this.ctxtMenu.removeItem(this);
    };
    /**
     * Detect changes on input properties.
     */
    CoreContextMenuItemComponent.prototype.ngOnChanges = function (changes) {
        if (changes.hidden && !changes.hidden.firstChange) {
            this.ctxtMenu.itemsChanged();
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "iconDescription", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "iconAction", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreContextMenuItemComponent.prototype, "iconSlash", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "ariaDescription", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "ariaAction", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "href", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreContextMenuItemComponent.prototype, "captureLink", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "autoLogin", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreContextMenuItemComponent.prototype, "closeOnClick", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreContextMenuItemComponent.prototype, "priority", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreContextMenuItemComponent.prototype, "badge", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreContextMenuItemComponent.prototype, "badgeClass", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreContextMenuItemComponent.prototype, "hidden", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreContextMenuItemComponent.prototype, "action", void 0);
    CoreContextMenuItemComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-context-menu-item',
            template: ''
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__context_menu__["a" /* CoreContextMenuComponent */]])
    ], CoreContextMenuItemComponent);
    return CoreContextMenuItemComponent;
}());

//# sourceMappingURL=context-menu-item.js.map

/***/ }),
/* 1355 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreChartComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_chart_js__ = __webpack_require__(1356);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_chart_js___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_chart_js__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * This component shows a chart using chart.js.
 * Documentation can be found at http://www.chartjs.org/docs/.
 * It only supports changes on these properties: data and labels.
 *
 * Example usage:
 * <core-chart [data]="data" [labels]="labels" [type]="type" [legend]="legend"></core-chart>
 */
var CoreChartComponent = /** @class */ (function () {
    function CoreChartComponent() {
        this.labels = []; // Labels of the data.
        this.height = 300; // Height of the chart element.
        // Nothing to do.
    }
    CoreChartComponent_1 = CoreChartComponent;
    /**
     * Component being initialized.
     */
    CoreChartComponent.prototype.ngOnInit = function () {
        var legend = {};
        if (typeof this.legend == 'undefined') {
            legend = {
                display: false,
                labels: {
                    generateLabels: function (chart) {
                        var data = chart.data;
                        if (data.labels.length && data.labels.length) {
                            var datasets_1 = data.datasets[0];
                            return data.labels.map(function (label, i) {
                                return {
                                    text: label + ': ' + datasets_1.data[i],
                                    fillStyle: datasets_1.backgroundColor[i]
                                };
                            });
                        }
                        return [];
                    }
                }
            };
        }
        else {
            legend = Object.assign({}, this.legend);
        }
        if (this.type == 'bar' && this.data.length >= 5) {
            this.type = 'horizontalBar';
        }
        var context = this.canvas.nativeElement.getContext('2d');
        this.chart = new __WEBPACK_IMPORTED_MODULE_1_chart_js__["Chart"](context, {
            type: this.type,
            data: {
                labels: this.labels,
                datasets: [{
                        data: this.data,
                        backgroundColor: this.getRandomColors(this.data.length)
                    }]
            },
            options: { legend: legend }
        });
    };
    /**
     * Listen to chart changes.
     */
    CoreChartComponent.prototype.ngOnChanges = function () {
        if (this.chart) {
            this.chart.data.datasets[0] = {
                data: this.data,
                backgroundColor: this.getRandomColors(this.data.length)
            };
            this.chart.data.labels = this.labels;
            this.chart.update();
        }
    };
    /**
     * Generate random colors if needed.
     *
     * @param  {number} n Number of colors needed.
     * @return {any[]}    Array with the number of background colors requested.
     */
    CoreChartComponent.prototype.getRandomColors = function (n) {
        while (CoreChartComponent_1.backgroundColors.length < n) {
            var red = Math.floor(Math.random() * 255), green = Math.floor(Math.random() * 255), blue = Math.floor(Math.random() * 255);
            CoreChartComponent_1.backgroundColors.push('rgba(' + red + ', ' + green + ', ' + blue + ', 0.6)');
        }
        return CoreChartComponent_1.backgroundColors.slice(0, n);
    };
    /**
     * Component being destroyed.
     */
    CoreChartComponent.prototype.ngOnDestroy = function () {
        if (this.chart) {
            this.chart.destroy();
            this.chart = false;
        }
    };
    // The first 6 colors will be the app colors, the following will be randomly generated.
    // It will use the same colors in the whole session.
    CoreChartComponent.backgroundColors = [
        'rgba(0,100,210, 0.6)',
        'rgba(203,61,77, 0.6)',
        'rgba(0,121,130, 0.6)',
        'rgba(249,128,18, 0.6)',
        'rgba(94,129,0, 0.6)',
        'rgba(251,173,26, 0.6)'
    ];
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreChartComponent.prototype, "data", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreChartComponent.prototype, "labels", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreChartComponent.prototype, "type", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreChartComponent.prototype, "legend", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreChartComponent.prototype, "height", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('canvas'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreChartComponent.prototype, "canvas", void 0);
    CoreChartComponent = CoreChartComponent_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-chart',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\chart\core-chart.html"*/'<canvas #canvas [attr.height]="height"></canvas>\n\n<ion-list *ngIf="chart" inset>\n    <ion-item *ngFor="let data of chart.legend.legendItems">\n        <ion-icon name="square" item-start [style.color]="data.fillStyle"></ion-icon>\n        {{data.text}}\n    </ion-item>\n</ion-list>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\chart\core-chart.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], CoreChartComponent);
    return CoreChartComponent;
    var CoreChartComponent_1;
}());

//# sourceMappingURL=chart.js.map

/***/ }),
/* 1356 */,
/* 1357 */,
/* 1358 */,
/* 1359 */,
/* 1360 */,
/* 1361 */,
/* 1362 */,
/* 1363 */,
/* 1364 */,
/* 1365 */,
/* 1366 */,
/* 1367 */,
/* 1368 */,
/* 1369 */,
/* 1370 */,
/* 1371 */,
/* 1372 */,
/* 1373 */,
/* 1374 */,
/* 1375 */,
/* 1376 */,
/* 1377 */,
/* 1378 */,
/* 1379 */,
/* 1380 */,
/* 1381 */,
/* 1382 */,
/* 1383 */,
/* 1384 */,
/* 1385 */,
/* 1386 */,
/* 1387 */,
/* 1388 */,
/* 1389 */,
/* 1390 */,
/* 1391 */,
/* 1392 */,
/* 1393 */,
/* 1394 */,
/* 1395 */,
/* 1396 */,
/* 1397 */,
/* 1398 */,
/* 1399 */,
/* 1400 */,
/* 1401 */,
/* 1402 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreChronoComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * This component shows a chronometer in format HH:MM:SS.
 *
 * If no startTime is provided, it will start at 00:00:00.
 * If an endTime is provided, the chrono will stop and emit an event in the onEnd output when that number of milliseconds is
 * reached. E.g. if startTime=60000 and endTime=120000, the chrono will start at 00:01:00 and end when it reaches 00:02:00.
 *
 * This component has 2 boolean inputs to control the timer: running (to start and stop it) and reset.
 *
 * Example usage:
 * <core-chrono [running]="running" [reset]="reset" [endTime]="maxTime" (onEnd)="stopCapturing()"></core-chrono>
 */
var CoreChronoComponent = /** @class */ (function () {
    function CoreChronoComponent(cdr) {
        this.cdr = cdr;
        this.startTime = 0; // Number of milliseconds to put in the chrono before starting.
        this.time = 0;
        this.onEnd = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    CoreChronoComponent.prototype.ngOnInit = function () {
        this.time = this.startTime || 0;
    };
    /**
     * Component being changed.
     */
    CoreChronoComponent.prototype.ngOnChanges = function (changes) {
        if (changes && changes.running) {
            if (changes.running.currentValue) {
                this.start();
            }
            else {
                this.stop();
            }
        }
        if (changes && changes.reset && changes.reset.currentValue) {
            this.resetChrono();
        }
    };
    /**
     * Reset the chrono, stopping it and setting it to startTime.
     */
    CoreChronoComponent.prototype.resetChrono = function () {
        this.stop();
        this.time = this.startTime || 0;
    };
    /**
     * Start the chrono if it isn't running.
     */
    CoreChronoComponent.prototype.start = function () {
        var _this = this;
        if (this.interval) {
            // Already setup.
            return;
        }
        var lastExecTime = Date.now();
        this.interval = setInterval(function () {
            // Increase the chrono.
            _this.time += Date.now() - lastExecTime;
            lastExecTime = Date.now();
            if (typeof _this.endTime != 'undefined' && _this.time > _this.endTime) {
                // End time reached, stop the timer and call the end function.
                _this.stop();
                _this.onEnd.emit();
            }
            // Force change detection. Angular doesn't detect these async operations.
            _this.cdr.detectChanges();
        }, 200);
    };
    /**
     * Stop the chrono, leaving the same time it has.
     */
    CoreChronoComponent.prototype.stop = function () {
        clearInterval(this.interval);
        delete this.interval;
    };
    CoreChronoComponent.prototype.ngOnDestroy = function () {
        this.stop();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreChronoComponent.prototype, "running", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreChronoComponent.prototype, "startTime", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreChronoComponent.prototype, "endTime", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreChronoComponent.prototype, "reset", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreChronoComponent.prototype, "onEnd", void 0);
    CoreChronoComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-chrono',
            template: '<span role="timer">{{ time / 1000 | coreSecondsToHMS }}</span>'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectorRef"]])
    ], CoreChronoComponent);
    return CoreChronoComponent;
}());

//# sourceMappingURL=chrono.js.map

/***/ }),
/* 1403 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreDownloadRefreshComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to show a download button with refresh option, the spinner and the status of it.
 *
 * Usage:
 * <core-download-refresh [status]="status" enabled="true" canCheckUpdates="true" action="download()"></core-download-refresh>
 */
var CoreDownloadRefreshComponent = /** @class */ (function () {
    function CoreDownloadRefreshComponent() {
        this.enabled = false; // Whether the download is enabled.
        this.loading = true; // Force loading status when is not downloading.
        this.canTrustDownload = false; // If false, refresh will be shown if downloaded.
        this.statusDownloaded = __WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].DOWNLOADED;
        this.statusNotDownloaded = __WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        this.statusOutdated = __WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].OUTDATED;
        this.statusDownloading = __WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].DOWNLOADING;
        this.action = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Download clicked.
     *
     * @param {Event} e Click event.
     * @param {boolean} refresh Whether it's refreshing.
     */
    CoreDownloadRefreshComponent.prototype.download = function (e, refresh) {
        e.preventDefault();
        e.stopPropagation();
        this.action.emit(refresh);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreDownloadRefreshComponent.prototype, "status", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreDownloadRefreshComponent.prototype, "enabled", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreDownloadRefreshComponent.prototype, "loading", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreDownloadRefreshComponent.prototype, "canTrustDownload", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreDownloadRefreshComponent.prototype, "action", void 0);
    CoreDownloadRefreshComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-download-refresh',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\download-refresh\core-download-refresh.html"*/'<ng-container *ngIf="enabled && !(loading || status === statusDownloading)">\n    <!-- Download button. -->\n    <button *ngIf="status == statusNotDownloaded" ion-button icon-only clear (click)="download($event, false)" color="dark" class="core-animate-show-hide" [attr.aria-label]="\'core.download\' | translate">\n        <ion-icon name="cloud-download"></ion-icon>\n    </button>\n\n    <!-- Refresh button. -->\n    <button *ngIf="status == statusOutdated || (status == statusDownloaded && !canTrustDownload)" ion-button icon-only clear (click)="download($event, true)" color="dark" class="core-animate-show-hide" [attr.aria-label]="\'core.refresh\' | translate">\n        <ion-icon name="refresh"></ion-icon>\n    </button>\n\n    <!-- Downloaded status icon. -->\n    <ion-icon *ngIf="status == statusDownloaded && canTrustDownload" class="core-icon-downloaded" color="success" name="cloud-done" [attr.aria-label]="\'core.downloaded\' | translate" role="status"></ion-icon>\n</ng-container>\n\n<!-- Spinner. -->\n<ion-spinner *ngIf="loading || status === statusDownloading" class="core-animate-show-hide"></ion-spinner>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\download-refresh\core-download-refresh.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], CoreDownloadRefreshComponent);
    return CoreDownloadRefreshComponent;
}());

//# sourceMappingURL=download-refresh.js.map

/***/ }),
/* 1404 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreLocalFileComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Component to handle a local file. Only files inside the app folder can be managed.
 *
 * Shows the file name, icon (depending on extension), size and time modified.
 * Also, if managing is enabled it will also show buttons to rename and delete the file.
 */
var CoreLocalFileComponent = /** @class */ (function () {
    function CoreLocalFileComponent(mimeUtils, utils, translate, textUtils, fileProvider, domUtils, timeUtils) {
        this.mimeUtils = mimeUtils;
        this.utils = utils;
        this.translate = translate;
        this.textUtils = textUtils;
        this.fileProvider = fileProvider;
        this.domUtils = domUtils;
        this.timeUtils = timeUtils;
        this.newFileName = '';
        this.onDelete = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.onRename = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.onClick = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    CoreLocalFileComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.manage = this.utils.isTrueOrOne(this.manage);
        this.loadFileBasicData();
        // Get the size and timemodified.
        this.fileProvider.getMetadata(this.file).then(function (metadata) {
            if (metadata.size >= 0) {
                _this.size = _this.textUtils.bytesToSize(metadata.size, 2);
            }
            _this.timemodified = _this.timeUtils.userDate(metadata.modificationTime, 'core.strftimedatetimeshort');
        });
    };
    /**
     * Load the basic data for the file.
     */
    CoreLocalFileComponent.prototype.loadFileBasicData = function () {
        this.fileName = this.file.name;
        this.fileIcon = this.mimeUtils.getFileIcon(this.file.name);
        this.fileExtension = this.mimeUtils.getFileExtension(this.file.name);
        // Let's calculate the relative path for the file.
        this.relativePath = this.fileProvider.removeBasePath(this.file.toURL());
        if (!this.relativePath) {
            // Didn't find basePath, use fullPath but if the user tries to manage the file it'll probably fail.
            this.relativePath = this.file.fullPath;
        }
    };
    /**
     * File clicked.
     *
     * @param {Event} e Click event.
     */
    CoreLocalFileComponent.prototype.fileClicked = function (e) {
        if (this.editMode) {
            return;
        }
        e.preventDefault();
        e.stopPropagation();
        if (this.utils.isTrueOrOne(this.overrideClick) && this.onClick.observers.length) {
            this.onClick.emit();
        }
        else {
            this.utils.openFile(this.file.toURL());
        }
    };
    /**
     * Activate the edit mode.
     *
     * @param {Event} e Click event.
     */
    CoreLocalFileComponent.prototype.activateEdit = function (e) {
        e.preventDefault();
        e.stopPropagation();
        this.editMode = true;
        this.newFileName = this.file.name;
    };
    /**
     * Rename the file.
     *
     * @param {string} newName New name.
     * @param {Event}  e       Click event.
     */
    CoreLocalFileComponent.prototype.changeName = function (newName, e) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        if (newName == this.file.name) {
            // Name hasn't changed, stop.
            this.editMode = false;
            return;
        }
        var modal = this.domUtils.showModalLoading(), fileAndDir = this.fileProvider.getFileAndDirectoryFromPath(this.relativePath), newPath = this.textUtils.concatenatePaths(fileAndDir.directory, newName);
        // Check if there's a file with this name.
        this.fileProvider.getFile(newPath).then(function () {
            // There's a file with this name, show error and stop.
            _this.domUtils.showErrorModal('core.errorfileexistssamename', true);
        }).catch(function () {
            // File doesn't exist, move it.
            return _this.fileProvider.moveFile(_this.relativePath, newPath).then(function (fileEntry) {
                _this.editMode = false;
                _this.file = fileEntry;
                _this.loadFileBasicData();
                _this.onRename.emit({ file: _this.file });
            }).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'core.errorrenamefile', true);
            });
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Delete the file.
     *
     * @param {Event} e Click event.
     */
    CoreLocalFileComponent.prototype.deleteFile = function (e) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        // Ask confirmation.
        this.domUtils.showConfirm(this.translate.instant('core.confirmdeletefile')).then(function () {
            var modal = _this.domUtils.showModalLoading();
            return _this.fileProvider.removeFile(_this.relativePath).then(function () {
                _this.onDelete.emit();
            }).finally(function () {
                modal.dismiss();
            });
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.errordeletefile', true);
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreLocalFileComponent.prototype, "file", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreLocalFileComponent.prototype, "manage", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreLocalFileComponent.prototype, "overrideClick", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreLocalFileComponent.prototype, "onDelete", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreLocalFileComponent.prototype, "onRename", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreLocalFileComponent.prototype, "onClick", void 0);
    CoreLocalFileComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-local-file',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\local-file\core-local-file.html"*/'<form (ngSubmit)="changeName(newFileName, $event)">\n    <a ion-item text-wrap stacked class="item-media" [class.item-input]="editMode" (click)="fileClicked($event)" detail-none>\n        <img [src]="fileIcon" alt="{{fileExtension}}" role="presentation" item-start />\n\n        <!-- File name and edit button (if editable). -->\n        <h2 *ngIf="!editMode">{{fileName}}</h2>\n        <!-- More data about the file. -->\n        <p *ngIf="size && !editMode">{{ size }}</p>\n        <p *ngIf="timemodified && !editMode">{{ timemodified }}</p>\n\n        <!-- Form to edit the file\'s name. -->\n        <ion-input type="text" name="filename" [placeholder]="\'core.filename\' | translate" autocapitalize="none" autocorrect="off" (click)="$event.stopPropagation()" [core-auto-focus] [(ngModel)]="newFileName" *ngIf="editMode"></ion-input>\n\n        <div class="buttons" item-end *ngIf="manage">\n            <button *ngIf="!editMode" ion-button icon-only clear [core-suppress-events] (onClick)="activateEdit($event)" [attr.aria-label]="\'core.edit\' | translate" color="dark">\n                <ion-icon name="create" ios="md-create"></ion-icon>\n            </button>\n\n            <button *ngIf="editMode" ion-button icon-only clear [attr.aria-label]="\'core.save\' | translate" color="success" type="submit">\n                <ion-icon name="checkmark" ios="md-checkmark"></ion-icon>\n            </button>\n\n            <button ion-button clear icon-only (click)="deleteFile($event)" [attr.aria-label]="\'core.delete\' | translate" color="danger">\n                <ion-icon name="trash"></ion-icon>\n            </button>\n        </div>\n    </a>\n</form>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\local-file\core-local-file.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreLocalFileComponent);
    return CoreLocalFileComponent;
}());

//# sourceMappingURL=local-file.js.map

/***/ }),
/* 1405 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePickerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to display a site selector. It will display a select with the list of sites. If the selected site changes,
 * an output will be emitted with the site ID.
 *
 * Example usage:
 * <core-site-picker (siteSelected)="changeSite($event)"></core-site-picker>
 */
var CoreSitePickerComponent = /** @class */ (function () {
    function CoreSitePickerComponent(translate, sitesProvider, textUtils) {
        this.translate = translate;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.siteSelected = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    CoreSitePickerComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.selectedSite = this.initialSite || this.sitesProvider.getCurrentSiteId();
        // Load the sites.
        this.sitesProvider.getSites().then(function (sites) {
            var promises = [];
            sites.forEach(function (site) {
                // Format the site name.
                promises.push(_this.textUtils.formatText(site.siteName, true, true).catch(function () {
                    return site.siteName;
                }).then(function (formatted) {
                    site.fullNameAndSiteName = _this.translate.instant('core.fullnameandsitename', { fullname: site.fullName, sitename: formatted });
                }));
            });
            if (!_this.selectedSite && sites.length) {
                // There is no current site, select the first one.
                _this.selectedSite = sites[0].id;
                _this.siteSelected.emit(_this.selectedSite);
            }
            return Promise.all(promises).then(function () {
                _this.sites = sites;
            });
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePickerComponent.prototype, "initialSite", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSitePickerComponent.prototype, "siteSelected", void 0);
    CoreSitePickerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-site-picker',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\site-picker\core-site-picker.html"*/'<ion-item>\n    <ion-label>{{ \'core.site\' | translate }}</ion-label>\n    <ion-select [(ngModel)]="selectedSite" (ngModelChange)="siteSelected.emit(selectedSite)" interface="action-sheet">\n        <ion-option *ngFor="let site of sites" [value]="site.id">{{ site.fullNameAndSiteName }}</ion-option>\n    </ion-select>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\site-picker\core-site-picker.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], CoreSitePickerComponent);
    return CoreSitePickerComponent;
}());

//# sourceMappingURL=site-picker.js.map

/***/ }),
/* 1406 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreNavBarButtonsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Component to add buttons to the app's header without having to place them inside the header itself. This is meant for
 * pages that are loaded inside a sub ion-nav, so they don't have a header.
 *
 * If this component indicates a position (start/end), the buttons will only be added if the header has some buttons in that
 * position. If no start/end is specified, then the buttons will be added to the first <ion-buttons> found in the header.
 *
 * You can use the [hidden] input to hide all the inner buttons if a certain condition is met.
 *
 * IMPORTANT: Do not use *ngIf in the buttons inside this component, it can cause problems. Please use [hidden] instead.
 *
 * Example usage:
 *
 * <core-navbar-buttons end>
 *     <button ion-button icon-only [hidden]="!buttonShown" [attr.aria-label]="Do something" (click)="action()">
 *         <ion-icon name="funnel"></ion-icon>
 *     </button>
 * </core-navbar-buttons>
 */
var CoreNavBarButtonsComponent = /** @class */ (function () {
    function CoreNavBarButtonsComponent(element, logger, domUtils) {
        this.domUtils = domUtils;
        this.BUTTON_HIDDEN_CLASS = 'core-navbar-button-hidden';
        this.forceHidden = false;
        this.element = element.nativeElement;
        this.logger = logger.getInstance('CoreNavBarButtonsComponent');
        this.instanceId = this.domUtils.storeInstanceByElement(this.element, this);
    }
    Object.defineProperty(CoreNavBarButtonsComponent.prototype, "hidden", {
        // If the hidden input is true, hide all buttons.
        set: function (value) {
            this._hidden = value;
            this.showHideAllElements();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CoreNavBarButtonsComponent.prototype, "buttons", {
        // Get all the ion-buttons inside this directive and apply the role bar-button.
        set: function (buttons) {
            buttons.forEach(function (button) {
                button.setRole('bar-button');
            });
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Component being initialized.
     */
    CoreNavBarButtonsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.searchHeader().then(function (header) {
            if (header) {
                // Search the right buttons container (start, end or any).
                var selector = 'ion-buttons', buttonsContainer = void 0;
                if (_this.element.hasAttribute('start')) {
                    selector += '[start]';
                }
                else if (_this.element.hasAttribute('end')) {
                    selector += '[end]';
                }
                buttonsContainer = header.querySelector(selector);
                if (buttonsContainer) {
                    _this.mergeContextMenus(buttonsContainer);
                    _this.movedChildren = _this.domUtils.moveChildren(_this.element, buttonsContainer);
                    _this.showHideAllElements();
                }
                else {
                    _this.logger.warn('The header was found, but it didn\'t have the right ion-buttons.', selector);
                }
            }
        }).catch(function () {
            // Header not found.
            _this.logger.warn('Header not found.');
        });
    };
    /**
     * Force or unforce hiding all buttons. If this is true, it will override the "hidden" input.
     *
     * @param {boolean} value The value to set.
     */
    CoreNavBarButtonsComponent.prototype.forceHide = function (value) {
        this.forceHidden = value;
        this.showHideAllElements();
    };
    /**
     * If both button containers have a context menu, merge them into a single one.
     *
     * @param {HTMLElement} buttonsContainer The container where the buttons will be moved.
     */
    CoreNavBarButtonsComponent.prototype.mergeContextMenus = function (buttonsContainer) {
        // Check if both button containers have a context menu.
        var mainContextMenu = buttonsContainer.querySelector('core-context-menu');
        if (!mainContextMenu) {
            return;
        }
        var secondaryContextMenu = this.element.querySelector('core-context-menu');
        if (!secondaryContextMenu) {
            return;
        }
        // Both containers have a context menu. Merge them to prevent having 2 menus at the same time.
        var mainContextMenuInstance = this.domUtils.getInstanceByElement(mainContextMenu), secondaryContextMenuInstance = this.domUtils.getInstanceByElement(secondaryContextMenu);
        // Check that both context menus belong to the same core-tab. We shouldn't merge menus from different tabs.
        if (mainContextMenuInstance && secondaryContextMenuInstance &&
            mainContextMenuInstance.coreTab === secondaryContextMenuInstance.coreTab) {
            this.mergedContextMenu = secondaryContextMenuInstance;
            this.mergedContextMenu.mergeContextMenus(mainContextMenuInstance);
            // Remove the empty context menu from the DOM.
            secondaryContextMenu.parentElement.removeChild(secondaryContextMenu);
        }
    };
    /**
     * Search the ion-header where the buttons should be added.
     *
     * @param {number} [retries] Number of retries so far.
     * @return {Promise<HTMLElement>} Promise resolved with the header element.
     */
    CoreNavBarButtonsComponent.prototype.searchHeader = function (retries) {
        var _this = this;
        if (retries === void 0) { retries = 0; }
        var parentPage = this.element;
        while (parentPage) {
            if (!parentPage.parentElement) {
                // No parent, stop.
                break;
            }
            // Get the next parent page.
            parentPage = this.domUtils.closest(parentPage.parentElement, '.ion-page');
            if (parentPage) {
                // Check if the page has a header. If it doesn't, search the next parent page.
                var header = this.searchHeaderInPage(parentPage);
                if (header && getComputedStyle(header, null).display != 'none') {
                    return Promise.resolve(header);
                }
            }
        }
        // Header not found.
        if (retries < 5) {
            // If the component or any of its parent is inside a ng-content or similar it can be detached when it's initialized.
            // Try again after a while.
            return new Promise(function (resolve, reject) {
                setTimeout(function () {
                    _this.searchHeader(retries + 1).then(resolve, reject);
                }, 200);
            });
        }
        // We've waited enough time, reject.
        return Promise.reject(null);
    };
    /**
     * Search ion-header inside a page. The header should be a direct child.
     *
     * @param  {HTMLElement} page Page to search in.
     * @return {HTMLElement} Header element. Undefined if not found.
     */
    CoreNavBarButtonsComponent.prototype.searchHeaderInPage = function (page) {
        for (var i = 0; i < page.children.length; i++) {
            var child = page.children[i];
            if (child.tagName == 'ION-HEADER') {
                return child;
            }
        }
    };
    /**
     * Show or hide all the elements.
     */
    CoreNavBarButtonsComponent.prototype.showHideAllElements = function () {
        var _this = this;
        // Show or hide all moved children.
        if (this.movedChildren) {
            this.movedChildren.forEach(function (child) {
                _this.showHideElement(child);
            });
        }
        // Show or hide all the context menu items that were merged to another context menu.
        if (this.mergedContextMenu) {
            if (this.forceHidden || this._hidden) {
                this.mergedContextMenu.removeMergedItems();
            }
            else {
                this.mergedContextMenu.restoreMergedItems();
            }
        }
    };
    /**
     * Show or hide an element.
     *
     * @param {Node} element Element to show or hide.
     */
    CoreNavBarButtonsComponent.prototype.showHideElement = function (element) {
        // Check if it's an HTML Element
        if (element instanceof Element) {
            if (this.forceHidden || this._hidden) {
                element.classList.add(this.BUTTON_HIDDEN_CLASS);
            }
            else {
                element.classList.remove(this.BUTTON_HIDDEN_CLASS);
            }
        }
    };
    /**
     * Component destroyed.
     */
    CoreNavBarButtonsComponent.prototype.ngOnDestroy = function () {
        this.domUtils.removeInstanceById(this.instanceId);
        // This component was destroyed, remove all the buttons that were moved.
        // The buttons can be moved outside of the current page, that's why we need to manually destroy them.
        // There's no need to destroy context menu items that were merged because they weren't moved from their DOM position.
        if (this.movedChildren) {
            this.movedChildren.forEach(function (child) {
                if (child.parentElement) {
                    child.parentElement.removeChild(child);
                }
            });
        }
        if (this.mergedContextMenu) {
            this.mergedContextMenu.removeMergedItems();
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('hidden'),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], CoreNavBarButtonsComponent.prototype, "hidden", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ContentChildren"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["d" /* Button */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["QueryList"]),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["QueryList"]])
    ], CoreNavBarButtonsComponent.prototype, "buttons", null);
    CoreNavBarButtonsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-navbar-buttons',
            template: '<ng-content></ng-content>'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_2__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], CoreNavBarButtonsComponent);
    return CoreNavBarButtonsComponent;
}());

//# sourceMappingURL=navbar-buttons.js.map

/***/ }),
/* 1407 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSendMessageFormComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_config__ = __webpack_require__(109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Component to display a "send message form".
 *
 * @description
 * This component will display a standalone send message form in order to have a better UX.
 *
 * Example usage:
 * <core-send-message-form (onSubmit)="sendMessage($event)" [placeholder]="'core.messages.newmessage' | translate"
 * [show-keyboard]="showKeyboard"></core-send-message-form>
 */
var CoreSendMessageFormComponent = /** @class */ (function () {
    function CoreSendMessageFormComponent(utils, textUtils, configProvider, eventsProvider, sitesProvider, appProvider) {
        var _this = this;
        this.utils = utils;
        this.textUtils = textUtils;
        this.appProvider = appProvider;
        this.placeholder = ''; // Placeholder for the input area.
        this.showKeyboard = false; // If keyboard is shown or not.
        this.onSubmit = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.onResize = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        configProvider.get(__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].SETTINGS_SEND_ON_ENTER, !this.appProvider.isMobile()).then(function (sendOnEnter) {
            _this.sendOnEnter = !!sendOnEnter;
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SEND_ON_ENTER_CHANGED, function (newValue) {
            _this.sendOnEnter = newValue;
        }, sitesProvider.getCurrentSiteId());
    }
    CoreSendMessageFormComponent.prototype.ngOnInit = function () {
        this.showKeyboard = this.utils.isTrueOrOne(this.showKeyboard);
    };
    /**
     * Form submitted.
     *
     * @param {Event} $event Mouse event.
     */
    CoreSendMessageFormComponent.prototype.submitForm = function ($event) {
        $event.preventDefault();
        $event.stopPropagation();
        var value = this.message.trim();
        if (!value) {
            // Silent error.
            return;
        }
        this.message = ''; // Reset the form.
        value = this.textUtils.replaceNewLines(value, '<br>');
        this.onSubmit.emit(value);
    };
    /**
     * Textarea resized.
     */
    CoreSendMessageFormComponent.prototype.textareaResized = function () {
        this.onResize.emit();
    };
    /**
     * Enter key clicked.
     *
     * @param {Event} e Event.
     * @param {string} other The name of the other key that was clicked, undefined if no other key.
     */
    CoreSendMessageFormComponent.prototype.enterClicked = function (e, other) {
        if (this.sendOnEnter && !other) {
            // Enter clicked, send the message.
            this.submitForm(e);
        }
        else if (!this.sendOnEnter && !this.appProvider.isMobile()) {
            if ((this.appProvider.isMac() && other == 'meta') || (!this.appProvider.isMac() && other == 'control')) {
                // Cmd+Enter or Ctrl+Enter, send message.
                this.submitForm(e);
            }
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSendMessageFormComponent.prototype, "message", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSendMessageFormComponent.prototype, "placeholder", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSendMessageFormComponent.prototype, "showKeyboard", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSendMessageFormComponent.prototype, "onSubmit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreSendMessageFormComponent.prototype, "onResize", void 0);
    CoreSendMessageFormComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-send-message-form',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\send-message-form\core-send-message-form.html"*/'<form>\n    <textarea class="core-send-message-input" [core-auto-focus]="showKeyboard" [placeholder]="placeholder" rows="1" core-auto-rows [(ngModel)]="message" name="message" (onResize)="textareaResized()" (keydown.enter)="enterClicked($event)" (keydown.control.enter)="enterClicked($event, \'control\')" (keydown.meta.enter)="enterClicked($event, \'meta\')" aria-multiline="true"></textarea>\n    <ion-buttons end>\n        <button ion-button icon-only clear="true" type="submit" [disabled]="!message" [attr.aria-label]="\'core.send\' | translate" [core-suppress-events] (onClick)="submitForm($event)">\n            <ion-icon name="send" color="dark"></ion-icon>\n        </button>\n    </ion-buttons>\n</form>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\send-message-form\core-send-message-form.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_config__["a" /* CoreConfigProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */]])
    ], CoreSendMessageFormComponent);
    return CoreSendMessageFormComponent;
}());

//# sourceMappingURL=send-message-form.js.map

/***/ }),
/* 1408 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreTimerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_time__ = __webpack_require__(17);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * This directive shows a timer in format HH:MM:SS. When the countdown reaches 0, a function is called.
 *
 * Usage:
 * <core-timer [endTime]="endTime" (finished)="timeUp()" [timerText]="'addon.mod_quiz.timeleft' | translate"></core-timer>
 */
var CoreTimerComponent = /** @class */ (function () {
    function CoreTimerComponent(timeUtils) {
        this.timeUtils = timeUtils;
        this.finished = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    CoreTimerComponent.prototype.ngOnInit = function () {
        var _this = this;
        var timeLeftClass = this.timeLeftClass || 'core-timer-timeleft-', endTime = Math.round(Number(this.endTime)), container = this.containerRef && this.containerRef.nativeElement;
        if (!endTime) {
            return;
        }
        // Check time left every 200ms.
        this.timeInterval = setInterval(function () {
            _this.timeLeft = endTime - _this.timeUtils.timestamp();
            if (_this.timeLeft < 0) {
                // Time is up! Stop the timer and call the finish function.
                clearInterval(_this.timeInterval);
                _this.finished.emit();
                return;
            }
            // If the time has nearly expired, change the color.
            if (_this.timeLeft < 100 && !container.classList.contains(timeLeftClass + _this.timeLeft)) {
                // Time left has changed. Remove previous classes and add the new one.
                container.classList.remove(timeLeftClass + (_this.timeLeft + 1));
                container.classList.remove(timeLeftClass + (_this.timeLeft + 2));
                container.classList.add(timeLeftClass + _this.timeLeft);
            }
        }, 200);
    };
    /**
     * Component destroyed.
     */
    CoreTimerComponent.prototype.ngOnDestroy = function () {
        clearInterval(this.timeInterval);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreTimerComponent.prototype, "endTime", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTimerComponent.prototype, "timerText", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTimerComponent.prototype, "timeLeftClass", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreTimerComponent.prototype, "align", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreTimerComponent.prototype, "finished", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('container', { read: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"] }),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"])
    ], CoreTimerComponent.prototype, "containerRef", void 0);
    CoreTimerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-timer',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\timer\core-timer.html"*/'<ion-item #container class="core-timer" [attr.text-center]="align == \'center\' ? true : null" [attr.text-end]="align == \'right\' ? true : null" role="timer">\n    <ion-icon name="timer" item-start role="presentation"></ion-icon>\n    <label *ngIf="timeLeft > 0 && timerText">{{ timerText }}</label>\n    <span *ngIf="timeLeft > 0">{{ timeLeft | coreSecondsToHMS }}</span>\n    <span class="core-timesup" *ngIf="timeLeft <= 0">{{ \'core.timesup\' | translate }}</span>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\timer\core-timer.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreTimerComponent);
    return CoreTimerComponent;
}());

//# sourceMappingURL=timer.js.map

/***/ }),
/* 1409 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRecaptchaComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__recaptchamodal__ = __webpack_require__(757);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Component that allows answering a recaptcha.
 */
var CoreRecaptchaComponent = /** @class */ (function () {
    function CoreRecaptchaComponent(sitesProvider, langProvider, textUtils, modalCtrl) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.textUtils = textUtils;
        this.modalCtrl = modalCtrl;
        this.modelValueName = 'recaptcharesponse'; // Name of the model property where to store the response.
        this.expired = false;
        // Get the current language of the app.
        langProvider.getCurrentLanguage().then(function (lang) {
            _this.lang = lang;
        });
    }
    /**
     * Component being initialized.
     */
    CoreRecaptchaComponent.prototype.ngOnInit = function () {
        this.siteUrl = this.siteUrl || this.sitesProvider.getCurrentSite().getURL();
    };
    /**
     * Open the recaptcha modal.
     */
    CoreRecaptchaComponent.prototype.answerRecaptcha = function () {
        var _this = this;
        // Set the iframe src. We use an iframe because reCaptcha V2 doesn't work with file:// protocol.
        var src = this.textUtils.concatenatePaths(this.siteUrl, 'webservice/recaptcha.php?lang=' + this.lang);
        // Modal to answer the recaptcha.
        // This is because the size of the recaptcha is dynamic, so it could cause problems if it was displayed inline.
        var modal = this.modalCtrl.create(__WEBPACK_IMPORTED_MODULE_5__recaptchamodal__["a" /* CoreRecaptchaModalComponent */], { src: src }, { cssClass: 'core-modal-fullscreen' });
        modal.onDidDismiss(function (data) {
            _this.expired = data.expired;
            _this.model[_this.modelValueName] = data.value;
        });
        modal.present();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreRecaptchaComponent.prototype, "model", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreRecaptchaComponent.prototype, "publicKey", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreRecaptchaComponent.prototype, "modelValueName", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreRecaptchaComponent.prototype, "siteUrl", void 0);
    CoreRecaptchaComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-recaptcha',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\recaptcha\core-recaptcha.html"*/'<!-- ReCAPTCHA V2 -->\n<div *ngIf="publicKey">\n    <!-- A button to open the recaptcha modal. -->\n    <!-- Use anchor instead of button to prevent marking form as submitted. -->\n    <button ion-button block *ngIf="!model[modelValueName]" (click)="answerRecaptcha()" type="button">{{ \'core.resourcedisplayopen\' | translate }}</button>\n    <p *ngIf="model[modelValueName]" class="text-success">{{ \'core.answered\' | translate }}</p>\n    <p *ngIf="expired" class="text-danger">{{ \'core.login.recaptchaexpired\' | translate }}</p>\n</div>\n\n<!-- Error that happens sometimes with reCaptcha V1, probably due to deprecation warnings. -->\n<div class="core-warning-card" icon-start *ngIf="!challengehash && challengeimage" >\n    <ion-icon name="warning"></ion-icon>\n    {{ \'core.errorloadingcontent\' | translate }}\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\recaptcha\core-recaptcha.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_lang__["a" /* CoreLangProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */]])
    ], CoreRecaptchaComponent);
    return CoreRecaptchaComponent;
}());

//# sourceMappingURL=recaptcha.js.map

/***/ }),
/* 1410 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreNavigationBarComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to show a "bar" with arrows to navigate forward/backward and a "info" icon to display more data.
 *
 * This directive will show two arrows at the left and right of the screen to navigate to previous/next item when clicked.
 * If no previous/next item is defined, that arrow won't be shown. It will also show a button to show more info.
 *
 * Example usage:
 * <core-navigation-bar [previous]="prevItem" [next]="nextItem" (action)="goTo($event)"></core-navigation-bar>
 */
var CoreNavigationBarComponent = /** @class */ (function () {
    function CoreNavigationBarComponent(textUtils) {
        this.textUtils = textUtils;
        this.action = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    CoreNavigationBarComponent.prototype.showInfo = function () {
        this.textUtils.expandText(this.title, this.info, this.component, this.componentId);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreNavigationBarComponent.prototype, "previous", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreNavigationBarComponent.prototype, "next", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreNavigationBarComponent.prototype, "info", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreNavigationBarComponent.prototype, "title", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreNavigationBarComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreNavigationBarComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreNavigationBarComponent.prototype, "action", void 0);
    CoreNavigationBarComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-navigation-bar',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\navigation-bar\core-navigation-bar.html"*/'<ion-grid no-padding *ngIf="previous || info || next">\n    <ion-row>\n        <ion-col text-start>\n            <a ion-button icon-only clear *ngIf="previous" (click)="action.emit(previous)" [title]="\'core.previous\' | translate">\n                <ion-icon name="arrow-back" md="ios-arrow-back"></ion-icon>\n            </a>\n        </ion-col>\n        <ion-col text-center>\n            <a ion-button icon-only clear *ngIf="info" (click)="showInfo()" [title]="title">\n                <ion-icon name="information-circle"></ion-icon>\n            </a>\n        </ion-col>\n        <ion-col text-end>\n            <a ion-button icon-only clear *ngIf="next" (click)="action.emit(next)" [title]="\'core.next\' | translate">\n                <ion-icon name="arrow-forward" md="ios-arrow-forward"></ion-icon>\n            </a>\n        </ion-col>\n    </ion-row>\n</ion-grid>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\navigation-bar\core-navigation-bar.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], CoreNavigationBarComponent);
    return CoreNavigationBarComponent;
}());

//# sourceMappingURL=navigation-bar.js.map

/***/ }),
/* 1411 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreAttachmentsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_fileuploader_providers_helper__ = __webpack_require__(122);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component to render attachments, allow adding more and delete the current ones.
 *
 * All the changes done will be applied to the "files" input array, no file will be uploaded. The component using this
 * component should be the one uploading and moving the files.
 *
 * All the files added will be copied to the app temporary folder, so they should be deleted after uploading them
 * or if the user cancels the action.
 *
 * <core-attachments [files]="files" [maxSize]="configs.maxsubmissionsizebytes" [maxSubmissions]="configs.maxfilesubmissions"
 *     [component]="component" [componentId]="assign.cmid" [acceptedTypes]="configs.filetypeslist" [allowOffline]="allowOffline">
 * </core-attachments>
 */
var CoreAttachmentsComponent = /** @class */ (function () {
    function CoreAttachmentsComponent(appProvider, domUtils, textUtils, fileUploaderProvider, translate, fileUploaderHelper) {
        this.appProvider = appProvider;
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.fileUploaderProvider = fileUploaderProvider;
        this.translate = translate;
        this.fileUploaderHelper = fileUploaderHelper;
    }
    /**
     * Component being initialized.
     */
    CoreAttachmentsComponent.prototype.ngOnInit = function () {
        this.maxSize = Number(this.maxSize); // Make sure it's defined and it's a number.
        this.maxSize = !isNaN(this.maxSize) && this.maxSize > 0 ? this.maxSize : -1;
        if (this.maxSize == -1) {
            this.maxSizeReadable = this.translate.instant('core.unknown');
        }
        else {
            this.maxSizeReadable = this.textUtils.bytesToSize(this.maxSize, 2);
        }
        if (typeof this.maxSubmissions == 'undefined' || this.maxSubmissions < 0) {
            this.maxSubmissionsReadable = this.translate.instant('core.unknown');
            this.unlimitedFiles = true;
        }
        else {
            this.maxSubmissionsReadable = String(this.maxSubmissions);
        }
        this.acceptedTypes = this.acceptedTypes && this.acceptedTypes.trim();
        if (this.acceptedTypes && this.acceptedTypes != '*') {
            this.fileTypes = this.fileUploaderProvider.prepareFiletypeList(this.acceptedTypes);
        }
    };
    /**
     * Add a new attachment.
     */
    CoreAttachmentsComponent.prototype.add = function () {
        var _this = this;
        var allowOffline = this.allowOffline && this.allowOffline !== 'false';
        if (!allowOffline && !this.appProvider.isOnline()) {
            this.domUtils.showErrorModal('core.fileuploader.errormustbeonlinetoupload', true);
        }
        else {
            var mimetypes = this.fileTypes && this.fileTypes.mimetypes;
            this.fileUploaderHelper.selectFile(this.maxSize, allowOffline, undefined, mimetypes).then(function (result) {
                _this.files.push(result);
            }).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'Error selecting file.');
            });
        }
    };
    /**
     * Delete a file from the list.
     *
     * @param {number} index The index of the file.
     * @param {boolean} [askConfirm] Whether to ask confirm.
     */
    CoreAttachmentsComponent.prototype.delete = function (index, askConfirm) {
        var _this = this;
        var promise;
        if (askConfirm) {
            promise = this.domUtils.showConfirm(this.translate.instant('core.confirmdeletefile'));
        }
        else {
            promise = Promise.resolve();
        }
        promise.then(function () {
            // Remove the file from the list.
            _this.files.splice(index, 1);
        }).catch(function () {
            // User cancelled.
        });
    };
    /**
     * A file was renamed.
     *
     * @param {number} index Index of the file.
     * @param {any} data The data received.
     */
    CoreAttachmentsComponent.prototype.renamed = function (index, data) {
        this.files[index] = data.file;
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreAttachmentsComponent.prototype, "files", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreAttachmentsComponent.prototype, "maxSize", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreAttachmentsComponent.prototype, "maxSubmissions", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreAttachmentsComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreAttachmentsComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreAttachmentsComponent.prototype, "allowOffline", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreAttachmentsComponent.prototype, "acceptedTypes", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], CoreAttachmentsComponent.prototype, "required", void 0);
    CoreAttachmentsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-attachments',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\attachments\core-attachments.html"*/'<ion-item text-wrap>\n    {{ \'core.maxsizeandattachments\' | translate:{$a: {size: maxSizeReadable, attachments: maxSubmissionsReadable} } }}\n    <span [core-mark-required]="required" class="core-mark-required"></span>\n</ion-item>\n<ion-item text-wrap *ngIf="fileTypes && fileTypes.mimetypes && fileTypes.mimetypes.length">\n    <p>{{ \'core.fileuploader.filesofthesetypes\' | translate }}</p>\n    <ul class="list-with-style">\n        <li *ngFor="let typeInfo of fileTypes.info">\n            <strong *ngIf="typeInfo.name">{{typeInfo.name}} </strong>{{typeInfo.extlist}}\n        </li>\n    </ul>\n</ion-item>\n<div *ngFor="let file of files; let index=index">\n    <!-- Files already attached to the submission, either in online or in offline. -->\n    <core-file *ngIf="!file.name || file.offline" [file]="file" [component]="component" [componentId]="componentId" [canDelete]="true" (onDelete)="delete(index, true)" [canDownload]="!file.offline"></core-file>\n\n    <!-- Files added to draft but not attached to submission yet. -->\n    <core-local-file *ngIf="file.name && !file.offline" [file]="file" [manage]="true" (onDelete)="delete(index, false)" (onRename)="renamed(index, $event)"></core-local-file>\n</div>\n<!-- Button to add more files. -->\n<ion-item text-wrap *ngIf="unlimitedFiles || (maxSubmissions >= 0 && files && files.length < maxSubmissions)">\n    <a ion-button block icon-start (click)="add()">\n        <ion-icon name="add"></ion-icon>\n        {{ \'core.fileuploader.addfiletext\' | translate }}\n    </a>\n</ion-item>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\attachments\core-attachments.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_6__core_fileuploader_providers_helper__["a" /* CoreFileUploaderHelperProvider */]])
    ], CoreAttachmentsComponent);
    return CoreAttachmentsComponent;
}());

//# sourceMappingURL=attachments.js.map

/***/ }),
/* 1412 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreIonTabComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular_transitions_transition_controller__ = __webpack_require__(203);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ion_tabs__ = __webpack_require__(417);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};




/**
 * Equivalent to ion-tab, but to be used inside core-ion-tabs.
 */
var CoreIonTabComponent = /** @class */ (function (_super) {
    __extends(CoreIonTabComponent, _super);
    function CoreIonTabComponent(parent, app, config, plt, elementRef, zone, renderer, cfr, _cd, gestureCtrl, transCtrl, linker, _dom, errHandler) {
        return _super.call(this, parent, app, config, plt, elementRef, zone, renderer, cfr, _cd, gestureCtrl, transCtrl, linker, _dom, errHandler) || this;
    }
    /**
     * Component being initialized.
     */
    CoreIonTabComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.parent.add(this, true);
    };
    /**
     * Component destroyed.
     */
    CoreIonTabComponent.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
        this.parent.remove(this);
    };
    CoreIonTabComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-ion-tab',
            template: '<div #viewport></div><div class="nav-decor"></div>',
            host: {
                '[attr.id]': '_tabId',
                '[attr.aria-labelledby]': '_btnId',
                'role': 'tabpanel'
            },
            encapsulation: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewEncapsulation"].None,
        }),
        __param(11, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__ion_tabs__["a" /* CoreIonTabsComponent */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["c" /* App */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Config */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["Renderer"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ComponentFactoryResolver"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectorRef"], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["j" /* GestureController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular_transitions_transition_controller__["a" /* TransitionController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* DeepLinker */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["h" /* DomController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ErrorHandler"]])
    ], CoreIonTabComponent);
    return CoreIonTabComponent;
}(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["B" /* Tab */]));

//# sourceMappingURL=ion-tab.js.map

/***/ }),
/* 1413 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserAvatarComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__ = __webpack_require__(26);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component to display a "user avatar".
 *
 * Example: <ion-avatar core-user-avatar [user]="participant"></ion-avatar>
 */
var CoreUserAvatarComponent = /** @class */ (function () {
    function CoreUserAvatarComponent(navCtrl, sitesProvider, utils, appProvider, eventsProvider) {
        var _this = this;
        this.navCtrl = navCtrl;
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.appProvider = appProvider;
        this.linkProfile = true; // Avoid linking to the profile if wanted.
        this.checkOnline = false; // If want to check and show online status.
        // Variable to check if we consider this user online or not.
        // @TODO: Use setting when available (see MDL-63972) so we can use site setting.
        this.timetoshowusers = 300000; // Miliseconds default.
        this.currentUserId = this.sitesProvider.getCurrentSiteUserId();
        this.pictureObs = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_6__core_user_providers_user__["a" /* CoreUserProvider */].PROFILE_PICTURE_UPDATED, function (data) {
            if (data.userId == _this.userId) {
                _this.avatarUrl = data.picture;
            }
        }, this.sitesProvider.getCurrentSiteId());
    }
    /**
     * Component being initialized.
     */
    CoreUserAvatarComponent.prototype.ngOnInit = function () {
        this.setFields();
    };
    /**
     * Listen to changes.
     */
    CoreUserAvatarComponent.prototype.ngOnChanges = function (changes) {
        // If something change, update the fields.
        if (changes) {
            this.setFields();
        }
    };
    /**
     * Set fields from user.
     */
    CoreUserAvatarComponent.prototype.setFields = function () {
        var profileUrl = this.profileUrl || (this.user && (this.user.profileimageurl || this.user.userprofileimageurl ||
            this.user.userpictureurl || this.user.profileimageurlsmall));
        if (typeof profileUrl == 'string') {
            this.avatarUrl = profileUrl;
        }
        this.fullname = this.fullname || (this.user && (this.user.fullname || this.user.userfullname));
        this.userId = this.userId || (this.user && (this.user.userid || this.user.id));
        this.courseId = this.courseId || (this.user && this.user.courseid);
    };
    /**
     * Helper function for checking the time meets the 'online' condition.
     *
     * @return boolean
     */
    CoreUserAvatarComponent.prototype.isOnline = function () {
        if (this.utils.isFalseOrZero(this.user.isonline)) {
            return false;
        }
        if (this.user.lastaccess) {
            // If the time has passed, don't show the online status.
            var time = new Date().getTime() - this.timetoshowusers;
            return this.user.lastaccess * 1000 >= time;
        }
        else {
            // You have to have Internet access first.
            return this.user.isonline && this.appProvider.isOnline();
        }
    };
    /**
     * Function executed image clicked.
     */
    CoreUserAvatarComponent.prototype.gotoProfile = function (event) {
        if (this.linkProfile && this.userId) {
            event.preventDefault();
            event.stopPropagation();
            this.navCtrl.push('CoreUserProfilePage', { userId: this.userId, courseId: this.courseId });
        }
    };
    /**
     * Component destroyed.
     */
    CoreUserAvatarComponent.prototype.ngOnDestroy = function () {
        this.pictureObs && this.pictureObs.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreUserAvatarComponent.prototype, "user", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreUserAvatarComponent.prototype, "profileUrl", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreUserAvatarComponent.prototype, "linkProfile", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreUserAvatarComponent.prototype, "fullname", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreUserAvatarComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreUserAvatarComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreUserAvatarComponent.prototype, "checkOnline", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreUserAvatarComponent.prototype, "extraIcon", void 0);
    CoreUserAvatarComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ion-avatar[core-user-avatar]',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\user-avatar\core-user-avatar.html"*/'<img *ngIf="avatarUrl" [src]="avatarUrl" [alt]="\'core.pictureof\' | translate:{$a: fullname}" core-external-content onError="this.src=\'assets/img/user-avatar.png\'" role="presentation" [siteId]="siteId || null" (click)="gotoProfile($event)">\n<img *ngIf="!avatarUrl" src="assets/img/user-avatar.png" [alt]="\'core.pictureof\' | translate:{$a: fullname}" role="presentation" (click)="gotoProfile($event)">\n<span *ngIf="checkOnline && isOnline()" class="contact-status online"></span>\n<img *ngIf="extraIcon" [src]="extraIcon" alt="" role="presentation" class="core-avatar-extra-icon">\n<ng-content></ng-content>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\user-avatar\core-user-avatar.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_events__["a" /* CoreEventsProvider */]])
    ], CoreUserAvatarComponent);
    return CoreUserAvatarComponent;
}());

//# sourceMappingURL=user-avatar.js.map

/***/ }),
/* 1414 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreStyleComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Component to add a <style> tag.
 *
 * @description
 * This component will include a <style> tag with some CSS rules that can optionally be pefixed.
 *
 * Example:
 *
 * <core-style [css]="'p { color: red; }'" prefix=".custom-rules"></core-style>
 */
var CoreStyleComponent = /** @class */ (function () {
    function CoreStyleComponent(element) {
        this.element = element;
    }
    /**
     * Component being changed.
     */
    CoreStyleComponent.prototype.ngOnChanges = function (changes) {
        if (this.element && this.element.nativeElement) {
            var style = document.createElement('style');
            style.innerText = this.prefixCSS(this.css, this.prefix);
            this.element.nativeElement.innerHTML = '';
            this.element.nativeElement.appendChild(style);
        }
    };
    /**
     * Add a prefix to all rules in a CSS string.
     *
     * @param {string} css CSS code to be prefixed.
     * @param {string} prefix Prefix css selector.
     * @return {string} Prefixed CSS.
     */
    CoreStyleComponent.prototype.prefixCSS = function (css, prefix) {
        if (!css) {
            return '';
        }
        if (!prefix) {
            return css;
        }
        // Remove comments first.
        var regExp = /\/\*[\s\S]*?\*\/|([^:]|^)\/\/.*$/gm;
        css = css.replace(regExp, '');
        // Add prefix.
        regExp = /([^]*?)({[^]*?}|,)/g;
        return css.replace(regExp, prefix + ' $1 $2');
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreStyleComponent.prototype, "css", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreStyleComponent.prototype, "prefix", void 0);
    CoreStyleComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-style',
            template: ''
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"]])
    ], CoreStyleComponent);
    return CoreStyleComponent;
}());

//# sourceMappingURL=style.js.map

/***/ }),
/* 1415 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucProgressBarComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Generated class for the OucProgressBarComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucProgressBarComponent = /** @class */ (function () {
    function OucProgressBarComponent() {
        this.length = {
            'width': '0%',
            'transition': 'width 1s',
            '-webkit-transition': 'width 1s'
        };
    }
    OucProgressBarComponent.prototype.ngOnInit = function () {
        this.setData();
    };
    /**
     * 设置数据
     */
    OucProgressBarComponent.prototype.setData = function () {
        var _this = this;
        this.proportion = Math.round(this.amount / this.total * 100);
        if (this.proportion) {
            this.proportion += '%';
        }
        else {
            this.proportion = '0%';
        }
        setTimeout(function () {
            _this.length.width = _this.proportion;
        }, 200); //设置延迟，让动画动起来
    };
    /**
     * 数据变化
     */
    OucProgressBarComponent.prototype.ngOnChanges = function () {
        //重新更新数据
        this.setData();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucProgressBarComponent.prototype, "total", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucProgressBarComponent.prototype, "amount", void 0);
    OucProgressBarComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-progress-bar',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-progress-bar\ouc-progress-bar.html"*/'<div class="Bars"> \n  <div [ngStyle]="length"> \n      <span>{{proportion}}</span> \n  </div> \n</div> '/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-progress-bar\ouc-progress-bar.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], OucProgressBarComponent);
    return OucProgressBarComponent;
}());

//# sourceMappingURL=ouc-progress-bar.js.map

/***/ }),
/* 1416 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucHomeBannerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Generated class for the OucHomeBannerComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucHomeBannerComponent = /** @class */ (function () {
    // slidesItems = [
    //   {
    //     title: '国开云课堂',
    //     img: 'http://eefile.download.eenet.com/files2/xlims/file/1deceb4c6655de22ded92a1e2cbda201.png',
    //     src: 'http://www.ouc-online.com.cn/'
    //   },
    //   {
    //     title: '医护心理学',
    //     img: 'http://eefile.download.eenet.com/files2/xlims/file/21c06d8f6f683ae8e9392892483edcc3.jpg',
    //     src: 'http://zongbu.ouchn.cn/course/view.php?id=2566'
    //   }
    // ];
    // text: string;
    function OucHomeBannerComponent(rest, sitesProvider, courseHelper, navCtrl) {
        this.rest = rest;
        this.sitesProvider = sitesProvider;
        this.courseHelper = courseHelper;
        this.navCtrl = navCtrl;
    }
    OucHomeBannerComponent.prototype.ngOnInit = function () {
        this.banners = JSON.parse(this.banners);
        this.banners = this.banners.Items;
        console.log(this.banners);
    };
    OucHomeBannerComponent.prototype.liulanqi = function (url) {
        var options = {
            statusbar: {
                color: '#004DFF'
            },
            toolbar: {
                height: 44,
                color: '#004DFF'
            },
            title: {
                color: '#ffffffff',
                showPageTitle: true
            },
            backButton: {
                wwwImage: 'assets/ouc/back.png',
                wwwImagePressed: 'assets/ouc/back.png',
                align: 'left',
                event: 'backPressed'
            },
            backButtonCanClose: true
        };
        __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__["a" /* ThemeableBrowser */].create(url, '_blank', options);
    };
    // banner图链接
    OucHomeBannerComponent.prototype.openAds = function (item) {
        var _this = this;
        //打开浏览器
        if (item.TargetType == 'Url') {
            // this.liulanqi(item.Target);
            this.doopenIapp(item.Target);
        }
        else if (item.TargetType == 'Local') {
            if (item.Target != null && item.Target.indexOf(':') != -1) {
                var type = item.Target.split(':')[0].toLowerCase();
                var id_1 = item.Target.split(':')[1];
                if (type == 'page') {
                    this.navCtrl.push('HomenewdetailPage', {
                        articleId: id_1
                    });
                }
                else if (type == 'apppage') {
                    this.navCtrl.push('OuccommonPage', {
                        title: item.Message,
                        id: id_1
                    });
                }
                else if (type == 'moddle') {
                    var siteUrl_1 = 'http://zongbu.ouchn.cn';
                    this.sitesProvider.newSite('http://zongbu.ouchn.cn', '1ac9a888ca122e57fdc2bec4ffe65536', '', false).then(function () {
                        var param = {
                            wstoken: '1ac9a888ca122e57fdc2bec4ffe65536',
                            field: 'idnumber',
                            value: id_1
                        };
                        var getCourseId = siteUrl_1 +
                            '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=core_course_get_courses_by_field';
                        _this.rest.httpOucPost(getCourseId, param, function (d) {
                            _this.courseHelper.openCourse(_this.navCtrl, d.courses[0]);
                            // this.params = this.params || {};
                            // Object.assign(this.params, { course: d.courses[0] });
                            // // this.navCtrl.push('CoreCourseSectionPage', this.params);
                            // this.modalCtrl.create('CoreCourseSectionPage',this.params).present
                            // this
                        }, true);
                    });
                }
            }
        }
        else if (item.TargetType == 'None') {
        }
    };
    OucHomeBannerComponent.prototype.doopenIapp = function (url) {
        // const browser = window.cordova.InAppBrowser.open(url, '_blank');
        var browser = window.cordova.InAppBrowser.open(url, '_blank', 'location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucHomeBannerComponent.prototype, "banners", void 0);
    OucHomeBannerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-home-banner',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-banner\ouc-home-banner.html"*/'<!-- Generated template for the OucHomeBannerComponent component -->\n<div style="margin-right: 15px;margin-left: 15px;">\n  <ion-slides class="ion-slides-banner" autoplay="2000" loop=true pager>\n    <ion-slide *ngFor="let item of banners" (click)="openAds(item)">\n        <img src="{{item.ImageUrl}}" class="slide-image-banner">\n    </ion-slide>\n</ion-slides>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-banner\ouc-home-banner.html"*/
        })
        // /**
        //  * 目标类型：地址
        //  */
        // export const TARGET_TYPE_URL = "Url"; 
        // /**
        //  * 目标类型：本地
        //  */
        // export const TARGET_TYPE_LOCAL = "Local";  
        // /**
        //  * 目标类型：无
        //  */
        // export const TARGET_TYPE_NONE = "None";
        ,
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["t" /* NavController */]])
    ], OucHomeBannerComponent);
    return OucHomeBannerComponent;
}());

//# sourceMappingURL=ouc-home-banner.js.map

/***/ }),
/* 1417 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucHomeCircleComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_status_bar__ = __webpack_require__(183);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_storage__ = __webpack_require__(131);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Generated class for the OucHomeCircleComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucHomeCircleComponent = /** @class */ (function () {
    function OucHomeCircleComponent(rest, sitesProvider, courseHelper, navCtrl, statusBar, appProvider, storage) {
        this.rest = rest;
        this.sitesProvider = sitesProvider;
        this.courseHelper = courseHelper;
        this.navCtrl = navCtrl;
        this.statusBar = statusBar;
        this.appProvider = appProvider;
        this.storage = storage;
    }
    OucHomeCircleComponent.prototype.ngOnInit = function () {
        this.buttonlist = JSON.parse(this.buttonlist);
        this.buttonlist = this.buttonlist.Items;
        console.log(this.buttonlist);
    };
    OucHomeCircleComponent.prototype.liulanqi = function (url) {
        var options = {
            statusbar: {
                color: '#004DFF'
            },
            toolbar: {
                height: 44,
                color: '#004DFF'
            },
            title: {
                color: '#ffffffff',
                showPageTitle: true
            },
            backButton: {
                wwwImage: 'assets/ouc/back.png',
                wwwImagePressed: 'assets/ouc/back.png',
                align: 'left',
                event: 'backPressed'
            },
            backButtonCanClose: true
        };
        __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__["a" /* ThemeableBrowser */].create(url, '_blank', options);
    };
    OucHomeCircleComponent.prototype.GetImageUrl = function (icon) {
        var pictureUrl = '';
        if (icon.indexOf('http') != -1) {
            pictureUrl = icon;
        }
        else {
            if (icon === '公开课') {
                pictureUrl = 'assets/ouc/qinzijiaoyu.svg';
            }
            else if (icon == '经典课') {
                pictureUrl = 'assets/ouc/zhishifuwu.svg';
            }
            else if (icon == '五分钟课') {
                pictureUrl = 'assets/ouc/peixun.svg';
            }
            else if (icon == '师生风采') {
                pictureUrl = 'assets/ouc/zhiyefazhan.svg';
            }
            else if (icon == '云课堂') {
                pictureUrl = 'assets/ouc/yunketnag.svg';
            }
        }
        console.log(pictureUrl);
        return pictureUrl;
    };
    OucHomeCircleComponent.prototype.openDetail = function (item) {
        var _this = this;
        // item.Title='公开课';
        // item.TargetType='Local';
        // item.Target='Target=APPHome';
        //打开浏览器
        if (item.TargetType == 'Url') {
            this.doopenIapp(item.Target);
            // this.liulanqi(item.Target);
        }
        else if (item.TargetType == 'Local') {
            if (item.Target != null && item.Target.indexOf(':') != -1) {
                var type = item.Target.split(':')[0].toLowerCase();
                var id_1 = item.Target.split(':')[1];
                if (type == 'page') {
                    this.navCtrl.push('HomenewdetailPage', {
                        articleId: id_1
                    });
                }
                else if (type == 'apppage') {
                    this.navCtrl.push('OuccommonPage', {
                        title: item.Message,
                        id: id_1
                    });
                }
                else if (type == 'moddle') {
                    this.storage.set('oucUsername', null);
                    var siteUrl_1 = 'http://zongbu.ouchn.cn';
                    this.sitesProvider.newSite('http://zongbu.ouchn.cn', '1ac9a888ca122e57fdc2bec4ffe65536', '', false).then(function () {
                        var param = {
                            wstoken: '1ac9a888ca122e57fdc2bec4ffe65536',
                            field: 'idnumber',
                            value: id_1
                        };
                        var getCourseId = siteUrl_1 +
                            '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=core_course_get_courses_by_field';
                        _this.rest.httpOucPost(getCourseId, param, function (d) {
                            _this.courseHelper.openCourse(_this.navCtrl, d.courses[0]);
                            // this.params = this.params || {};
                            // Object.assign(this.params, { course: d.courses[0] });
                            // // this.navCtrl.push('CoreCourseSectionPage', this.params);
                            // this.modalCtrl.create('CoreCourseSectionPage',this.params).present
                            // this
                        }, true);
                    });
                }
            }
        }
        else if (item.TargetType == 'None') {
        }
    };
    /**
   * ios打开注释
   * @param url
   */
    //  doopenIapp(url){
    //   this.appProvider.setStatusBarColor();
    //   this.statusBar.show();
    //   const a=this.statusBar
    //    // const browser = window.cordova.InAppBrowser.open(url, '_blank');
    //    const browser = window.cordova.InAppBrowser.open(url, '_blank','location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
    //    browser.addEventListener('exit', function (event) {
    //     a.overlaysWebView(true);
    //     a.hide();
    //   });
    //  }
    /**
     * android打开注释
     * @param url
     */
    OucHomeCircleComponent.prototype.doopenIapp = function (url) {
        // const browser = window.cordova.InAppBrowser.open(url, '_blank');
        var browser = window.cordova.InAppBrowser.open(url, '_blank', 'location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucHomeCircleComponent.prototype, "buttonlist", void 0);
    OucHomeCircleComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-home-circle',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-circle\ouc-home-circle.html"*/'<!-- Generated template for the OucHomeCircleComponent component -->\n<div style="width: auto;height: auto;display: flex;flex-wrap: wrap;justify-content: space-between;margin-left: 15px;margin-right: 15px;margin-top: 12px;">\n  <div *ngFor="let f of buttonlist" (click)="openDetail(f)" style="text-align: center;">\n    <img class="img-grid-size" src="{{this.GetImageUrl(f.Icon)}}">\n    <div class="ouc-div-center">\n      {{f.Title}}\n    </div>\n  </div>\n  <!-- <div>\n    <img class="img-grid-size" src="assets/ouc/peixun.svg">\n    <div class="ouc-div-center">\n      就业培训\n    </div>\n  </div>\n  <div>\n    <img class="img-grid-size" src="assets/ouc/qinzijiaoyu.svg">\n    <div class="ouc-div-center">\n      亲子教育\n    </div>\n  </div>\n  <div>\n    <img class="img-grid-size" src="assets/ouc/zhishifuwu.svg">\n    <div class="ouc-div-center">\n      知识服务\n    </div>\n  </div>\n  <div>\n    <img class="img-grid-size" src="assets/ouc/yunketnag.svg">\n    <div class="ouc-div-center">\n      云课堂\n    </div>\n  </div> -->\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-circle\ouc-home-circle.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_7__ionic_native_status_bar__["a" /* StatusBar */], __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_8__ionic_storage__["b" /* Storage */]])
    ], OucHomeCircleComponent);
    return OucHomeCircleComponent;
}());

//# sourceMappingURL=ouc-home-circle.js.map

/***/ }),
/* 1418 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucHomeLineCardComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_storage__ = __webpack_require__(131);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Generated class for the OucHomeLineCardComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucHomeLineCardComponent = /** @class */ (function () {
    function OucHomeLineCardComponent(event, navCtrl, navParams, rest, storage) {
        var _this = this;
        this.event = event;
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.rest = rest;
        this.storage = storage;
        this.items = [];
        this.pageSize = '15';
        this.loadLists = [];
        this.event.subscribe('infinite', function (userEventData) {
            console.log('上拉加载中，，，，，，，');
            console.log(_this.dataSource);
            // this.dataSource=JSON.parse(this.dataSource);
            // setTimeout(() => {
            //   // this.rest.httpMyGet(this.dataSource,'',pages =>{
            //     userEventData.complete();
            //     userEventData.enable=false;
            //   // },false);
            // }, 500);
            _this.storage.get('homeDataSourceUrl').then(function (value) {
                if (value != null) {
                    _this.storage.get('datasourcesPageNum').then(function (num) {
                        if (num != null) {
                            _this.doLoad(value, num, userEventData);
                        }
                    });
                }
            });
        }); // 监听事件 相当于iOS中的 监听通知。 执行通知动作。
    }
    OucHomeLineCardComponent.prototype.ngOnInit = function () {
        this.pageNum = 1;
        this.dataSource = JSON.parse(this.dataSource);
        this.dataSource = this.dataSource.DataSourceUrl;
        this.storage.set('homeDataSourceUrl', this.dataSource);
        this.doLoad(this.dataSource, this.pageNum, null);
    };
    OucHomeLineCardComponent.prototype.openDeatil = function (f) {
        this.navCtrl.push('HomenewdetailPage', {
            articleId: f.Id
        });
    };
    OucHomeLineCardComponent.prototype.doLoad = function (data, num, userEventData) {
        var _this = this;
        var url = data + "&PageNum=" + num;
        console.log(this.dataSource);
        this.rest.httpMyGet(url, '', function (pages) {
            _this.pageData = pages.Data.PagingData;
            _this.loadLists = _this.loadLists.concat(pages.Data.PagingData.PageListInfos);
            if (_this.pageData.PageNum != _this.pageData.PageCount) {
                _this.pageNum++;
                _this.storage.set('datasourceIsMoreLoad', true);
                _this.storage.set('datasourcesPageNum', _this.pageNum);
            }
            else {
                _this.storage.set('datasourceIsMoreLoad', false);
            }
            if (userEventData != null) {
                userEventData.complete();
            }
        }, false);
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucHomeLineCardComponent.prototype, "dataSource", void 0);
    OucHomeLineCardComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-home-line-card',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-line-card\ouc-home-line-card.html"*/'<!-- Generated template for the OucHomeListCardComponent component -->\n\n<div>\n    <div style="display: flex;align-items: center;margin-top: 30px;">\n        <div style="margin-left: 15px;margin-right: 7px;">\n      <div style="width: 2px;height: 17px;background-color: #546BEE ;"></div>\n    </div>\n      <div style="font-size: 18px;color: #000;">\n        推荐\n      </div>\n      </div>\n      <div style="margin-left: 15px;margin-right: 15px;margin-top: 15px;border-radius: 8px;border:#eee solid 0.4px;box-shadow: 5px 10px 10px #eee;" *ngFor="let f of loadLists" (click)="openDeatil(f)">\n            <div>\n                <img style="width: 100%;height: 175px;border-top-left-radius: 8px ;border-top-right-radius: 8px;" src="{{f.Picture}}">\n            </div>\n            <div style="font-size: 16px;color: #000;padding-left: 15px;padding-top: 10px;margin-bottom: 15px">\n                {{f.Title}}\n            </div>\n            <div hidden style="display: flex;justify-content: space-between;margin-top: 10px;margin-bottom: 20px;">\n                <div style="color: #999;font-size: 12px;padding-left: 15px;">\n                    {{f.Author}}\n                </div>\n                <div style="color: #999;font-size: 12px;padding-right: 15px;">2020-8-3</div>\n            </div>\n      </div>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-line-card\ouc-home-line-card.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["i" /* Events */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_3__ionic_storage__["b" /* Storage */]])
    ], OucHomeLineCardComponent);
    return OucHomeLineCardComponent;
}());

//# sourceMappingURL=ouc-home-line-card.js.map

/***/ }),
/* 1419 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucHomeListCardComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Generated class for the OucHomeListCardComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucHomeListCardComponent = /** @class */ (function () {
    // speciality = [
    //   {
    //     name: '国开云课堂',
    //     icon: 'http://eefile.download.eenet.com/files2/xlims/file/1deceb4c6655de22ded92a1e2cbda201.png',
    //     src: 'http://www.ouc-online.com.cn/'
    //   },
    //   {
    //     name: '医护心理学',
    //     icon: 'http://eefile.download.eenet.com/files2/xlims/file/21c06d8f6f683ae8e9392892483edcc3.jpg',
    //     src: 'http://zongbu.ouchn.cn/course/view.php?id=2566'
    //   }
    // ];
    function OucHomeListCardComponent(rest, sitesProvider, courseHelper, navCtrl, modalCtrl) {
        this.rest = rest;
        this.sitesProvider = sitesProvider;
        this.courseHelper = courseHelper;
        this.navCtrl = navCtrl;
        this.modalCtrl = modalCtrl;
    }
    OucHomeListCardComponent.prototype.ngOnInit = function () {
        this.listData = JSON.parse(this.listData);
        this.listData = this.listData.Items;
        console.log(this.listData);
    };
    OucHomeListCardComponent.prototype.liulanqi = function (url) {
        var options = {
            statusbar: {
                color: '#004DFF'
            },
            toolbar: {
                height: 44,
                color: '#004DFF'
            },
            title: {
                color: '#ffffffff',
                showPageTitle: true
            },
            backButton: {
                wwwImage: 'assets/ouc/back.png',
                wwwImagePressed: 'assets/ouc/back.png',
                align: 'left',
                event: 'backPressed'
            },
            backButtonCanClose: true
        };
        __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__["a" /* ThemeableBrowser */].create(url, '_blank', options);
    };
    OucHomeListCardComponent.prototype.openOucCourse = function (item) {
        var _this = this;
        //打开浏览器
        if (item.TargetType == 'Url') {
            this.liulanqi(item.Target);
        }
        else if (item.TargetType == 'Local') {
            if (item.Target != null && item.Target.indexOf(':') != -1) {
                var type = item.Target.split(':')[0].toLowerCase();
                var id_1 = item.Target.split(':')[1];
                if (type == 'page') {
                    this.navCtrl.push('HomenewdetailPage', {
                        articleId: id_1
                    });
                }
                else if (type == 'apppage') {
                    this.navCtrl.push('OuccommonPage', {
                        title: item.Message,
                        id: id_1
                    });
                }
                else if (type == 'moddle') {
                    // const siteUrl = 'http://zongbu.ouchn.cn';
                    // this.sitesProvider.newSite('http://zongbu.ouchn.cn', '1ac9a888ca122e57fdc2bec4ffe65536', '', false).then(() => {
                    //   const param = {
                    //     wstoken: '1ac9a888ca122e57fdc2bec4ffe65536',
                    //     field: 'idnumber',
                    //     value: id
                    //   };
                    //   const getCourseId = siteUrl +
                    //     '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=core_course_get_courses_by_field';
                    //   this.rest.httpOucPost(getCourseId, param, d => {
                    //     this.courseHelper.openCourse(this.navCtrl, d.courses[0]);
                    //   }, true);
                    // });
                    var siteUrl_1 = 'http://zongbu.ouchn.cn';
                    this.sitesProvider.newSite('http://zongbu.ouchn.cn', '1ac9a888ca122e57fdc2bec4ffe65536', '', false).then(function () {
                        var param = {
                            wstoken: '1ac9a888ca122e57fdc2bec4ffe65536',
                            field: 'idnumber',
                            value: id_1
                        };
                        var getCourseId = siteUrl_1 +
                            '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=core_course_get_courses_by_field';
                        _this.rest.httpOucPost(getCourseId, param, function (d) {
                            _this.courseHelper.openCourse(_this.navCtrl, d.courses[0]);
                            // this.params = this.params || {};
                            // Object.assign(this.params, { course: d.courses[0] });
                            // // this.navCtrl.push('CoreCourseSectionPage', this.params);
                            // this.modalCtrl.create('CoreCourseSectionPage',this.params).present
                            // this
                        }, true);
                    });
                }
            }
        }
        else if (item.TargetType == 'None') {
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucHomeListCardComponent.prototype, "listData", void 0);
    OucHomeListCardComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-home-list-card',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-list-card\ouc-home-list-card.html"*/'<!-- Generated template for the OucHomeListCardComponent component -->\n<div>\n    <div style="display: flex;align-items: center;margin-top: 27px;">\n        <div style="margin-left: 15px;margin-right: 7px;">\n      <div style="width: 2px;height: 17px;background-color: #546BEE ;"></div>\n    </div>\n      <div style="font-size: 18px;color: #000;">\n        热门课程\n      </div>\n      </div>\n      <div *ngFor="let f of listData" (click)="openOucCourse(f)" style="display: flex;width: 100%; margin-left: 15px;margin-right: 15px;margin-top: 15px;height: 95px;">\n          <div style="width: 40%;">\n            <img  class="img-list-size" src="{{f.ImageUrl}}">\n          </div>\n          <div style="width: 50%;margin-left: 10px;"> \n            <div style="font-size: 15px; color: #000;padding-top: 5px;">{{f.Title}}</div>\n            <div class="ouc-div-content" >{{f.Description}}</div>\n          </div>\n      </div>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-list-card\ouc-home-list-card.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["r" /* ModalController */]])
    ], OucHomeListCardComponent);
    return OucHomeListCardComponent;
}());

//# sourceMappingURL=ouc-home-list-card.js.map

/***/ }),
/* 1420 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucHomeImageComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_status_bar__ = __webpack_require__(183);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_storage__ = __webpack_require__(131);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Generated class for the OucHomeImageComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucHomeImageComponent = /** @class */ (function () {
    function OucHomeImageComponent(rest, sitesProvider, courseHelper, navCtrl, appProvider, statusBar, storage) {
        this.rest = rest;
        this.sitesProvider = sitesProvider;
        this.courseHelper = courseHelper;
        this.navCtrl = navCtrl;
        this.appProvider = appProvider;
        this.statusBar = statusBar;
        this.storage = storage;
    }
    OucHomeImageComponent.prototype.ngOnInit = function () {
        this.imagesList = JSON.parse(this.imagesList);
        console.log(this.imagesList);
        this.imageUrl = this.imagesList.ImageUrl;
        console.log(this.imageUrl);
    };
    OucHomeImageComponent.prototype.liulanqi = function (url) {
        var options = {
            statusbar: {
                color: '#004DFF'
            },
            toolbar: {
                height: 44,
                color: '#004DFF'
            },
            title: {
                color: '#ffffffff',
                showPageTitle: true
            },
            backButton: {
                wwwImage: 'assets/ouc/back.png',
                wwwImagePressed: 'assets/ouc/back.png',
                wwwImageDensity: 2,
                align: 'left',
                event: 'backPressed'
            },
            backButtonCanClose: true
        };
        __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__["a" /* ThemeableBrowser */].create(url, '_blank', options);
    };
    OucHomeImageComponent.prototype.openItem = function () {
        var _this = this;
        this.doopenIapp(this.imagesList.Target);
        // this.navCtrl.push('OucwebviewPage',{
        //   url:this.imagesList.Target
        // });
        //打开浏览器
        if (this.imagesList.TargetType == 'Url') {
            // this.liulanqi(this.imagesList.Target);
            this.doopenIapp(this.imagesList.Target);
        }
        else if (this.imagesList.TargetType == 'Local') {
            if (this.imagesList.Target != null && this.imagesList.Target.indexOf(':') != -1) {
                var type = this.imagesList.Target.split(':')[0].toLowerCase();
                var id_1 = this.imagesList.Target.split(':')[1];
                if (type == 'page') {
                    this.navCtrl.push('HomenewdetailPage', {
                        articleId: id_1
                    });
                }
                else if (type == 'apppage') {
                    this.navCtrl.push('OuccommonPage', {
                        title: this.imagesList.Message,
                        id: id_1
                    });
                }
                else if (type == 'moddle') {
                    this.storage.set('oucUsername', null);
                    var siteUrl_1 = 'http://zongbu.ouchn.cn';
                    this.sitesProvider.newSite('http://zongbu.ouchn.cn', '1ac9a888ca122e57fdc2bec4ffe65536', '', false).then(function () {
                        var param = {
                            wstoken: '1ac9a888ca122e57fdc2bec4ffe65536',
                            field: 'idnumber',
                            value: id_1
                        };
                        var getCourseId = siteUrl_1 +
                            '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=core_course_get_courses_by_field';
                        _this.rest.httpOucPost(getCourseId, param, function (d) {
                            _this.courseHelper.openCourse(_this.navCtrl, d.courses[0]);
                            // this.params = this.params || {};
                            // Object.assign(this.params, { course: d.courses[0] });
                            // // this.navCtrl.push('CoreCourseSectionPage', this.params);
                            // this.modalCtrl.create('CoreCourseSectionPage',this.params).present
                            // this
                        }, true);
                    });
                }
            }
        }
        else if (this.imagesList.TargetType == 'None') {
        }
    };
    /**
  * ios打开注释
  * @param url
  */
    //  doopenIapp(url){
    //   this.appProvider.setStatusBarColor();
    //   this.statusBar.show();
    //   const a=this.statusBar
    //    // const browser = window.cordova.InAppBrowser.open(url, '_blank');
    //    const browser = window.cordova.InAppBrowser.open(url, '_blank','location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
    //    browser.addEventListener('exit', function (event) {
    //     a.overlaysWebView(true);
    //     a.hide();
    //   });
    //  }
    /**
     * android打开注释
     * @param url
     */
    OucHomeImageComponent.prototype.doopenIapp = function (url) {
        // const browser = window.cordova.InAppBrowser.open(url, '_blank');
        var browser = window.cordova.InAppBrowser.open(url, '_blank', 'location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucHomeImageComponent.prototype, "imagesList", void 0);
    OucHomeImageComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-home-image',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-image\ouc-home-image.html"*/'<!-- Generated template for the OucHomeImageComponent component -->\n  <img src="{{imageUrl}}" style="max-height: 120px;height: 120px;;width: 88%;border-radius: 8px;" (click)="openItem()">\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-image\ouc-home-image.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_6__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_7__ionic_native_status_bar__["a" /* StatusBar */], __WEBPACK_IMPORTED_MODULE_8__ionic_storage__["b" /* Storage */]])
    ], OucHomeImageComponent);
    return OucHomeImageComponent;
}());

//# sourceMappingURL=ouc-home-image.js.map

/***/ }),
/* 1421 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucHomeNoticeComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_themeable_browser__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Generated class for the OucHomeNoticeComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucHomeNoticeComponent = /** @class */ (function () {
    function OucHomeNoticeComponent(navCtrl, rest, sitesProvider, courseHelper) {
        this.navCtrl = navCtrl;
        this.rest = rest;
        this.sitesProvider = sitesProvider;
        this.courseHelper = courseHelper;
    }
    OucHomeNoticeComponent.prototype.ngOnInit = function () {
        // throw new Error("Method not implemented.");
        this.notices = JSON.parse(this.notices);
        console.log(this.notices);
        if (this.notices.MoreType != '' && this.notices.MoreType == 'Local') {
            this.isShowMore = true;
        }
        else {
            this.isShowMore = false;
        }
        // this.notices=this.notices.Items;
        this.firstNotices = this.notices.Items[0];
        if (this.firstNotices != null) {
            this.title = this.firstNotices.Message;
        }
        console.log(this.notices);
    };
    OucHomeNoticeComponent.prototype.liulanqi = function (url) {
        var options = {
            statusbar: {
                color: '#004DFF'
            },
            toolbar: {
                height: 44,
                color: '#004DFF'
            },
            title: {
                color: '#ffffffff',
                showPageTitle: true
            },
            backButton: {
                wwwImage: 'assets/ouc/back.png',
                wwwImagePressed: 'assets/ouc/back.png',
                align: 'left',
                event: 'backPressed'
            },
            backButtonCanClose: true
        };
        __WEBPACK_IMPORTED_MODULE_2__ionic_native_themeable_browser__["a" /* ThemeableBrowser */].create(url, '_blank', options);
    };
    OucHomeNoticeComponent.prototype.openMore = function () {
        this.navCtrl.push('NewlistPage', {
            url: this.notices.More
        });
    };
    OucHomeNoticeComponent.prototype.openNoticeDetail = function () {
        // this.liulanqi(this.firstNotices.Target);
        var _this = this;
        //打开浏览器
        if (this.firstNotices.TargetType == 'Url') {
            this.liulanqi(this.firstNotices.Target);
        }
        else if (this.firstNotices.TargetType == 'Local') {
            if (this.firstNotices.Target != null && this.firstNotices.Target.indexOf(':') != -1) {
                var type = this.firstNotices.Target.split(':')[0].toLowerCase();
                var id_1 = this.firstNotices.Target.split(':')[1];
                if (type == 'page') {
                    this.navCtrl.push('HomenewdetailPage', {
                        articleId: id_1
                    });
                }
                else if (type == 'apppage') {
                    this.navCtrl.push('OuccommonPage', {
                        title: this.firstNotices.Message,
                        id: id_1
                    });
                }
                else if (type == 'moddle') {
                    var siteUrl_1 = 'http://zongbu.ouchn.cn';
                    this.sitesProvider.newSite('http://zongbu.ouchn.cn', '1ac9a888ca122e57fdc2bec4ffe65536', '', false).then(function () {
                        var param = {
                            wstoken: '1ac9a888ca122e57fdc2bec4ffe65536',
                            field: 'idnumber',
                            value: id_1
                        };
                        var getCourseId = siteUrl_1 +
                            '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=core_course_get_courses_by_field';
                        _this.rest.httpOucPost(getCourseId, param, function (d) {
                            _this.courseHelper.openCourse(_this.navCtrl, d.courses[0]);
                            // this.params = this.params || {};
                            // Object.assign(this.params, { course: d.courses[0] });
                            // // this.navCtrl.push('CoreCourseSectionPage', this.params);
                            // this.modalCtrl.create('CoreCourseSectionPage',this.params).present
                            // this
                        }, true);
                    });
                }
            }
        }
        else if (this.firstNotices.TargetType == 'None') {
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucHomeNoticeComponent.prototype, "notices", void 0);
    OucHomeNoticeComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-home-notice',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-notice\ouc-home-notice.html"*/'<!-- Generated template for the OucHomeNoticeComponent component -->\n<div>\n<div style="width: 100%;margin-top: 10px;margin-bottom: 13px;height: 20px;">\n  <div style="position: absolute;left: 15px;right: 60px;">\n    <div style="display: flex;" (click)="openNoticeDetail()">\n      <div style="display: flex;align-items: center;">\n      <img src="assets/ouc/gonggao.svg" style="width: 13px;height: 11.9px;">\n    </div>\n      <div style="display: inline-block;white-space: nowrap;overflow: hidden;text-overflow:ellipsis;font-size: 14px;color: #000;margin-left: 5px;">\n        {{title}}\n      </div>\n    </div>\n    \n  </div>\n  <div *ngIf="isShowMore" style="position: absolute; right: 15px;" (click)="openMore()">\n    <img style="width: 20px;height: 6px;" src="assets/ouc/ouc-home-more.svg">\n  </div>\n</div>\n<div style="width: 100%;height: 1px;background-color: #000000;opacity: 0.04;">\n</div>\n</div>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-notice\ouc-home-notice.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_4__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], OucHomeNoticeComponent);
    return OucHomeNoticeComponent;
}());

//# sourceMappingURL=ouc-home-notice.js.map

/***/ }),
/* 1422 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NgxExtendedPdfViewerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__default_options__ = __webpack_require__(1423);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


__webpack_require__(760);
__webpack_require__(761);
__webpack_require__(1425);
var NgxExtendedPdfViewerComponent = /** @class */ (function () {
    function NgxExtendedPdfViewerComponent(zone) {
        this.zone = zone;
        this.resizeTimeout = null;
        /**
         * Number of milliseconds to wait between initializing the PDF viewer and loading the PDF file.
         * Most users can let this parameter safely at it's default value of zero.
         * Set this to 1000 or higher if you run into timing problems (typically caused by loading the locale files
         * after the PDF files, so they are not available when the PDF viewer is initialized).
         */
        this.delayFirstView = 0;
        this.primaryMenuVisible = true;
        this.minHeight = undefined;
        this._height = '100%';
        /**
         * If this flag is true, this components adds a link to the locale assets. The pdf viewer
         * sees this link and uses it to load the locale files automatically.
         * @param useBrowserLocale boolean
         */
        this.useBrowserLocale = false;
        this.backgroundColor = '#e8e8eb';
        /** Allows the user to define the name of the file after clicking "download" */
        this.filenameForDownload = 'document.pdf';
        /** Override the default locale. This must be the complete locale name, such as "es-ES". The string is allowed to be all lowercase.
         */
        this.language = undefined;
        /** By default, listening to the URL is deactivated because often the anchor tag is used for the Angular router */
        this.listenToURL = false;
        /** Navigate to a certain "named destination" */
        this.nameddest = undefined;
        /** allows you to pass a password to read password-protected files */
        this.password = undefined;
        this._showSidebarButton = true;
        this.viewerPositionTop = '32px';
        /** If [showSideBarButton]="true", do you want the sidebar to be shown by default ([showSidebarOnLoad])="true")
         * or not? By default, this flag is undefined, telling the PDF viewer to use the last setting used with this particular
         * document, or to hide the sidebar if the document is opened for the first time.
         */
        this.showSidebarOnLoad = undefined;
        this.showFindButton = true;
        this.showPagingButtons = true;
        this.showZoomButtons = true;
        this.showPresentationModeButton = false;
        this.showOpenFileButton = true;
        this.showPrintButton = true;
        this.showDownloadButton = true;
        this.showBookmarkButton = true;
        this.showSecondaryToolbarButton = true;
        this.showRotateButton = true;
        this.handTool = true;
        this.showHandToolButton = false;
        this.showScrollingButton = true;
        this.showSpreadButton = true;
        this.showPropertiesButton = true;
        this.spreadChange = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.page = undefined;
        this.pageChange = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.pagesLoaded = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.pageRendered = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        /** Legal values: undefined, 'auto', 'page-actual', 'page_fit', 'page-width', or '50' (or any other percentage) */
        this.zoom = undefined;
        this.zoomChange = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        /** This attributes allows you to increase the size of the UI elements so you can use them on small mobile devices.
         * This attribute is a string with a percent character at the end (e.g. "150%").
         */
        this._mobileFriendlyZoom = '100%';
        this.toolbarWidth = '100%';
        // dirty IE11 hack - temporary solution
        this.findbarTop = undefined;
        // dirty IE11 hack - temporary solution
        this.findbarLeft = undefined;
        // dirty IE11 hack - temporary solution
        this.secondaryToolbarRight = undefined;
        this._top = undefined;
    }
    NgxExtendedPdfViewerComponent_1 = NgxExtendedPdfViewerComponent;
    Object.defineProperty(NgxExtendedPdfViewerComponent.prototype, "src", {
        set: function (url) {
            if (url instanceof Uint8Array) {
                this._src = url.buffer;
            }
            else if (url instanceof Blob) {
                this._src = URL.createObjectURL(url);
            }
            else if (typeof url === 'string') {
                this._src = url;
                if (url.length > 980) {
                    // minimal length of a base64 encoded PDF
                    if (url.length % 4 === 0) {
                        if (/^[a-zA-Z\d\/+]+={0,2}$/.test(url)) {
                            console.warn('The URL looks like a base64 encoded string. If so, please use the attribute base64 instead of src');
                        }
                    }
                }
            }
            else {
                this._src = url;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxExtendedPdfViewerComponent.prototype, "base64Src", {
        set: function (base64) {
            var binary_string = window.atob(base64);
            var len = binary_string.length;
            var bytes = new Uint8Array(len);
            for (var i = 0; i < len; i++) {
                bytes[i] = binary_string.charCodeAt(i);
            }
            this.src = bytes.buffer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxExtendedPdfViewerComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (h) {
            var _this = this;
            this.minHeight = undefined;
            if (h) {
                this._height = h;
            }
            else {
                this.height = '100%';
            }
            setTimeout(function () {
                _this.checkHeight();
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxExtendedPdfViewerComponent.prototype, "showSidebarButton", {
        get: function () {
            return this._showSidebarButton;
        },
        set: function (show) {
            this._showSidebarButton = show;
            var isIE = /msie\s|trident\//i.test(window.navigator.userAgent);
            var factor = 1;
            if (isIE) {
                factor = Number((this._mobileFriendlyZoom || '100').replace('%', '')) / 100;
            }
            if (this._showSidebarButton) {
                this.findbarLeft = (68 * factor).toString() + 'px';
            }
            else {
                this.findbarLeft = '0px';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxExtendedPdfViewerComponent.prototype, "mobileFriendlyZoom", {
        get: function () {
            return this._mobileFriendlyZoom;
        },
        /*
         * This attributes allows you to increase the size of the UI elements so you can use them on small mobile devices.
         * This attribute is a string with a percent character at the end (e.g. "150%").*/
        set: function (zoom) {
            // tslint:disable-next-line:triple-equals - the type conversion is intended
            if (zoom == 'true') {
                zoom = '150%';
                // tslint:disable-next-line:triple-equals - the type conversion is intended
            }
            else if (zoom == 'false') {
                zoom = '100%';
            }
            this._mobileFriendlyZoom = zoom;
            var isIE = /msie\s|trident\//i.test(window.navigator.userAgent);
            var factor = 1;
            if (isIE) {
                factor = Number((zoom || '100').replace('%', '')) / 100;
            }
            if (this.showSidebarButton) {
                this.findbarLeft = (68 * factor).toString() + 'px';
            }
            else {
                this.findbarLeft = '0px';
            }
            if (isIE) {
                // dirty, temporary hack
                this.toolbarWidth = (100 / factor).toString() + '%';
                this.findbarTop = (32 * factor).toString() + 'px';
                this.secondaryToolbarRight = (252 * (factor - 1)).toString() + 'px';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxExtendedPdfViewerComponent.prototype, "mobileZoom", {
        /** Deprecated. Please use [mobileFriendlyZoom] instead.
         * This attributes allows you to increase the size of the UI elements so you can use them on small mobile devices.
         * This attribute is a string with a percent character at the end (e.g. "150%").*/
        set: function (mobileFriendlyZoom) {
            this.mobileFriendlyZoom = mobileFriendlyZoom;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxExtendedPdfViewerComponent.prototype, "sidebarPositionTop", {
        get: function () {
            if (this._top) {
                return this._top;
            }
            if (this.mobileFriendlyZoom) {
                if (this.mobileFriendlyZoom.endsWith('%')) {
                    var zoom = Number(this.mobileFriendlyZoom.substring(0, this.mobileFriendlyZoom.length - 1));
                    return (0.32 * zoom).toString() + 'px';
                }
                if (this.mobileFriendlyZoom.endsWith('px')) {
                    return this.mobileFriendlyZoom;
                }
            }
            return '32px';
        },
        enumerable: true,
        configurable: true
    });
    NgxExtendedPdfViewerComponent.prototype.calcViewerPositionTop = function () {
        if (this._top) {
            this.viewerPositionTop = this._top;
            return;
        }
        if (this.mobileFriendlyZoom) {
            if (this.mobileFriendlyZoom.endsWith('%')) {
                var zoom = Number(this.mobileFriendlyZoom.substring(0, this.mobileFriendlyZoom.length - 1));
                if (!this.isPrimaryMenuVisible()) {
                    this.viewerPositionTop = '0';
                }
                else {
                    this.viewerPositionTop = (1 + 0.32 * zoom).toString() + 'px';
                }
                return;
            }
            if (this.mobileFriendlyZoom.endsWith('px')) {
                this.viewerPositionTop = this.mobileFriendlyZoom;
                return;
            }
        }
        if (this.isPrimaryMenuVisible()) {
            this.viewerPositionTop = '32px';
        }
        else {
            this.viewerPositionTop = '0';
        }
    };
    NgxExtendedPdfViewerComponent.prototype.dispatchFindInput = function (input) {
        console.log('Input');
        this.zone.runOutsideAngular(function () {
            var e = new Event('meow');
            input.dispatchEvent(e);
        });
    };
    NgxExtendedPdfViewerComponent.prototype.emitZoomChange = function () {
        var selectedIndex = this.sizeSelector.nativeElement.selectedIndex;
        if (selectedIndex) {
            var s = this.sizeSelector.nativeElement.options[selectedIndex];
            var value = s.label;
            if (value.endsWith('%')) {
                value = Number(value.replace('%', ''));
            }
            else {
                value = s.value;
            }
            this.zoomChange.emit(value);
        }
    };
    NgxExtendedPdfViewerComponent.prototype.emitZoomChangeAfterDelay = function () {
        var _this = this;
        setTimeout(function () {
            _this.emitZoomChange();
        }, 10);
    };
    NgxExtendedPdfViewerComponent.prototype.ngOnInit = function () {
        var _this = this;
        var langLinks = document.querySelectorAll('link[type="application/l10n"]');
        var langCount = langLinks.length;
        if (langCount === 0) {
            var dict = document.querySelector('script[type="application/l10n"]');
            if (!dict) {
                if (!this.useBrowserLocale) {
                    console.error("If you set the attribute 'useBrowserLocale' to false, you must provide the translations yourself in a script or link tag.");
                    console.error('The easiest way to do this is to add them to the index.html.');
                }
            }
            else if (this.useBrowserLocale) {
                console.error("Please set the attribute 'useBrowserLocale' to false if you provide the translations yourself in a script or link tag.");
            }
        }
        else if (this.useBrowserLocale) {
            var o = langLinks[0].attributes['origin'];
            if (o && o.value !== 'ngx-extended-pdf-viewer') {
                console.error("Please set the attribute 'useBrowserLocale' to false if you provide the translations yourself in a script or link tag.");
            }
        }
        var callback = function (e) {
            document.removeEventListener('localized', callback);
            _this.initTimeout = setTimeout(function () {
                _this.openPDF();
            }, _this.delayFirstView);
        };
        document.addEventListener('localized', callback);
        if (NgxExtendedPdfViewerComponent_1.ngxExtendedPdfViewerInitialized) {
            console.error("You're trying to open two instances of the PDF viewer. Most likely, this will result in errors.");
        }
        document.addEventListener('webviewerloaded', function () {
            _this.overrideDefaultSettings();
        });
        setTimeout(function () {
            // This initializes the webviewer, the file may be passed in to it to initialize the viewer with a pdf directly
            _this.primaryMenuVisible = true;
            if (!_this.isSecondaryMenuVisible()) {
                _this.showSecondaryToolbarButton = false;
            }
            if (!_this.showSecondaryToolbarButton) {
                if (!_this.isPrimaryMenuVisible()) {
                    _this.primaryMenuVisible = false;
                }
            }
            _this.calcViewerPositionTop();
            window.webViewerLoad();
            window.PDFViewerApplication.appConfig.defaultUrl = ''; // IE bugfix
            window.PDFViewerApplicationOptions.set('locale', _this.language);
            window.PDFViewerApplication.isViewerEmbedded = true;
            var pc = document.getElementById('printContainer');
            if (pc) {
                document.getElementsByTagName('body')[0].appendChild(pc);
            }
        }, 0);
    };
    NgxExtendedPdfViewerComponent.prototype.checkHeight = function () {
        var container = document.getElementsByClassName('zoom')[0];
        if (container.clientHeight === 0 && this._height.includes('%')) {
            var available = window.innerHeight;
            var rect = container.getBoundingClientRect();
            var top_1 = rect.top;
            var mh = available - top_1;
            var factor = Number(this._height.replace('%', ''));
            mh = (mh * factor) / 100;
            if (mh > 100) {
                this.minHeight = mh + 'px';
            }
            else {
                this.minHeight = '100px';
            }
        }
    };
    NgxExtendedPdfViewerComponent.prototype.onPageChange = function () {
        var _this = this;
        setTimeout(function () {
            var inputField = document.getElementById('pageNumber');
            var page = Number(inputField.value);
            if (isNaN(page)) {
                page = undefined;
            }
            _this.pageChange.emit(page);
        });
    };
    NgxExtendedPdfViewerComponent.prototype.onSpreadChange = function (newSpread) {
        this.spreadChange.emit(newSpread);
    };
    NgxExtendedPdfViewerComponent.prototype.overrideDefaultSettings = function () {
        var options = window.PDFViewerApplicationOptions;
        // tslint:disable-next-line:forin
        for (var key in __WEBPACK_IMPORTED_MODULE_1__default_options__["a" /* defaultOptions */]) {
            options.set(key, __WEBPACK_IMPORTED_MODULE_1__default_options__["a" /* defaultOptions */][key]);
        }
        options.set('disablePreferences', true);
        this.setZoom();
        if (window.PDFViewerApplication.appConfig) {
            window.PDFViewerApplication.appConfig.filenameForDownload = this.filenameForDownload;
        }
        else {
            options.set('filenameForDownload', this.filenameForDownload);
        }
        options.set('textLayerMode', this.showHandToolButton ? 1 : 0);
        if (this.showSidebarButton) {
            if (this.showSidebarOnLoad !== undefined) {
                window.PDFViewerApplication.sidebarViewOnLoad = this.showSidebarOnLoad ? 1 : 0;
                if (window.PDFViewerApplication.appConfig) {
                    window.PDFViewerApplication.appConfig.sidebarViewOnLoad = this.showSidebarOnLoad ? 1 : 0;
                }
                options.set('sidebarViewOnLoad', this.showSidebarOnLoad ? 1 : 0);
            }
        }
        else {
            window.PDFViewerApplication.sidebarViewOnLoad = 0;
            options.set('sidebarViewOnLoad', 0);
            if (window.PDFViewerApplication.appConfig) {
                window.PDFViewerApplication.appConfig.sidebarViewOnLoad = 0;
            }
        }
        if (this.spread === 'even') {
            options.set('spreadModeOnLoad', 2);
            if (window.PDFViewerApplication.pdfViewer) {
                window.PDFViewerApplication.pdfViewer.spreadMode = 2;
            }
            this.onSpreadChange('even');
        }
        else if (this.spread === 'odd') {
            options.set('spreadModeOnLoad', 1);
            if (window.PDFViewerApplication.pdfViewer) {
                window.PDFViewerApplication.pdfViewer.spreadMode = 1;
            }
            this.onSpreadChange('odd');
        }
        else {
            options.set('spreadModeOnLoad', 0);
            if (window.PDFViewerApplication.pdfViewer) {
                window.PDFViewerApplication.pdfViewer.spreadMode = 0;
            }
            this.onSpreadChange('off');
        }
    };
    NgxExtendedPdfViewerComponent.prototype.openPDF = function () {
        var _this = this;
        NgxExtendedPdfViewerComponent_1.ngxExtendedPdfViewerInitialized = true;
        this.onResize();
        if (!this.listenToURL) {
            window.PDFViewerApplication.pdfLinkService.setHash = function () { };
        }
        this.initTimeout = null;
        this.selectCursorTool();
        window.PDFViewerApplication.eventBus.on('pagesloaded', function (x) {
            _this.pagesLoaded.emit(x);
            if (_this.nameddest) {
                window.PDFViewerApplication.pdfLinkService.navigateTo(_this.nameddest);
            }
            _this.setZoom();
        });
        window.PDFViewerApplication.eventBus.on('pagerendered', function (x) {
            _this.pageRendered.emit(x);
        });
        this.checkHeight();
        // open a file in the viewer
        if (!!this._src) {
            var options = {
                password: this.password
            };
            window.PDFViewerApplication.open(this._src, options);
        }
        setTimeout(function () {
            if (_this.page) {
                window.PDFViewerApplication.page = _this.page;
            }
        }, 100);
    };
    NgxExtendedPdfViewerComponent.prototype.selectCursorTool = function () {
        window.PDFViewerApplication.eventBus.dispatch('switchcursortool', { tool: this.handTool ? 1 : 0 });
    };
    NgxExtendedPdfViewerComponent.prototype.ngOnDestroy = function () {
        NgxExtendedPdfViewerComponent_1.ngxExtendedPdfViewerInitialized = false;
        if (this.initTimeout) {
            clearTimeout(this.initTimeout);
            this.initTimeout = undefined;
        }
        var app = window.PDFViewerApplication;
        if (app) {
            app.cleanup();
            app.close();
            if (app._boundEvents) {
                app.unbindWindowEvents();
            }
            var bus = app.eventBus;
            if (bus) {
                app.unbindEvents();
                for (var key in bus._listeners) {
                    if (bus._listeners[key]) {
                        bus._listeners[key] = undefined;
                    }
                }
            }
            app.eventBus = null;
        }
        var body = document.getElementsByTagName('body');
        if (body[0]) {
            var topLevelElements = body[0].children;
            for (var i = topLevelElements.length - 1; i >= 0; i--) {
                var e = topLevelElements.item(i);
                if (e && e.id === 'printContainer') {
                    body[0].removeChild(e);
                }
                else if (e && e.id === 'fileInput') {
                    body[0].removeChild(e);
                }
            }
        }
    };
    NgxExtendedPdfViewerComponent.prototype.isSecondaryMenuVisible = function () {
        var visible = this.showHandToolButton ||
            this.showPagingButtons ||
            this.showPropertiesButton ||
            this.showRotateButton ||
            this.showScrollingButton ||
            this.showRotateButton ||
            this.showSpreadButton;
        if (visible) {
            return true;
        }
        return false;
    };
    NgxExtendedPdfViewerComponent.prototype.isPrimaryMenuVisible = function () {
        var visible = this.showBookmarkButton ||
            this.showDownloadButton ||
            this.showFindButton ||
            this.showOpenFileButton ||
            this.showPagingButtons ||
            this.showPresentationModeButton ||
            this.showPrintButton ||
            this.showPropertiesButton ||
            this.showSidebarButton ||
            this.showSecondaryToolbarButton ||
            this.showZoomButtons;
        if (visible) {
            return true;
        }
        return false;
    };
    NgxExtendedPdfViewerComponent.prototype.ngOnChanges = function (changes) {
        if (NgxExtendedPdfViewerComponent_1.ngxExtendedPdfViewerInitialized) {
            if ('src' in changes) {
                if (!!this._src) {
                    this.overrideDefaultSettings();
                    window.PDFViewerApplication.open(this._src);
                }
            }
            if ('zoom' in changes) {
                this.setZoom();
            }
            if ('handTool' in changes) {
                this.selectCursorTool();
            }
            if ('page' in changes) {
                if (this.page) {
                    window.PDFViewerApplication.page = this.page;
                }
            }
            if ('filenameForDownload' in changes) {
                window.PDFViewerApplication.appConfig.filenameForDownload = this.filenameForDownload;
            }
            if ('nameddest' in changes) {
                if (this.nameddest) {
                    window.PDFViewerApplication.pdfLinkService.navigateTo(this.nameddest);
                }
            }
            if ('spread' in changes) {
                if (this.spread === 'even') {
                    window.PDFViewerApplication.spreadModeOnLoad = 2;
                    window.PDFViewerApplication.pdfViewer.spreadMode = 2;
                    this.onSpreadChange('even');
                }
                else if (this.spread === 'odd') {
                    window.PDFViewerApplication.spreadModeOnLoad = 1;
                    window.PDFViewerApplication.pdfViewer.spreadMode = 1;
                    this.onSpreadChange('odd');
                }
                else {
                    window.PDFViewerApplication.spreadModeOnLoad = 0;
                    window.PDFViewerApplication.pdfViewer.spreadMode = 0;
                    this.onSpreadChange('off');
                }
            }
            this.primaryMenuVisible = true;
            if (!this.isSecondaryMenuVisible()) {
                this.showSecondaryToolbarButton = false;
            }
            if (!this.showSecondaryToolbarButton) {
                if (!this.isPrimaryMenuVisible()) {
                    this.primaryMenuVisible = false;
                }
            }
            this.calcViewerPositionTop();
        }
    };
    NgxExtendedPdfViewerComponent.prototype.setZoom = function () {
        var zoomAsNumber = this.zoom;
        if (String(zoomAsNumber).endsWith('%')) {
            zoomAsNumber = Number(String(zoomAsNumber).replace('%', '')) / 100;
        }
        else if (!isNaN(Number(zoomAsNumber))) {
            zoomAsNumber = Number(zoomAsNumber) / 100;
        }
        if (!zoomAsNumber) {
            zoomAsNumber = 'auto';
        }
        if (window.PDFViewerApplication) {
            window.PDFViewerApplicationOptions.set('defaultZoomValue', zoomAsNumber);
        }
        if (window.PDFViewerApplication.pdfViewer) {
            window.PDFViewerApplication.pdfViewer.currentScaleValue = zoomAsNumber;
        }
    };
    NgxExtendedPdfViewerComponent.prototype.onResize = function () {
        clearTimeout(this.resizeTimeout);
        this.resizeTimeout = setTimeout(this.doResize, 100);
    };
    NgxExtendedPdfViewerComponent.prototype.doResize = function () {
        var pdfViewer = document.getElementsByClassName('html');
        if (pdfViewer && pdfViewer.length > 0) {
            var toolbar_1 = pdfViewer[0].getElementsByClassName('toolbar');
            if (toolbar_1 && toolbar_1.length > 0) {
                var width = toolbar_1[0].clientWidth;
                if (window.innerWidth - width > 50) {
                    var mediumElements = toolbar_1[0].getElementsByClassName('hiddenMediumView');
                    for (var i = 0; i < mediumElements.length; i++) {
                        var elt = mediumElements[i];
                        if (width < 650) {
                            elt.classList.add('hidden');
                        }
                        else {
                            elt.classList.remove('hidden');
                        }
                    }
                    var smallElements = toolbar_1[0].getElementsByClassName('hiddenSmallView');
                    for (var i = 0; i < smallElements.length; i++) {
                        var elt = smallElements[i];
                        if (width < 590) {
                            elt.classList.add('hidden');
                        }
                        else {
                            elt.classList.remove('hidden');
                        }
                    }
                    var tinyElement = document.getElementById('scaleSelectContainer');
                    var tiny = tinyElement;
                    if (width < 485) {
                        // not perfect, but good first approximation
                        tiny.classList.add('hidden');
                    }
                    else {
                        tiny.classList.remove('hidden');
                    }
                }
            }
            /* TODO: this is the complete list of items to consider:
          @media all and (max-width: 700px) {
            #outerContainer .hiddenMediumView {
              display: none;
            }
            #outerContainer .visibleMediumView {
              display: inherit;
            }
          }
      
          @media all and (max-width: 640px) {
            .hiddenSmallView, .hiddenSmallView * {
              display: none;
            }
            .visibleSmallView {
              display: inherit;
            }
            .toolbarButtonSpacer {
              width: 0;
            }
            html[dir='ltr'] .findbar {
              left: 38px;
            }
            html[dir='rtl'] .findbar {
              right: 38px;
            }
          }
      
          @media all and (max-width: 535px) {
            #scaleSelectContainer {
              display: none;
            }
          }
          */
        }
    };
    NgxExtendedPdfViewerComponent.ngxExtendedPdfViewerInitialized = false;
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "delayFirstView", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], NgxExtendedPdfViewerComponent.prototype, "src", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], NgxExtendedPdfViewerComponent.prototype, "base64Src", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], NgxExtendedPdfViewerComponent.prototype, "height", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "useBrowserLocale", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "backgroundColor", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "filenameForDownload", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], NgxExtendedPdfViewerComponent.prototype, "language", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "listenToURL", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], NgxExtendedPdfViewerComponent.prototype, "nameddest", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], NgxExtendedPdfViewerComponent.prototype, "password", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], NgxExtendedPdfViewerComponent.prototype, "showSidebarButton", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], NgxExtendedPdfViewerComponent.prototype, "showSidebarOnLoad", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showFindButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showPagingButtons", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showZoomButtons", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showPresentationModeButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showOpenFileButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showPrintButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showDownloadButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showBookmarkButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showSecondaryToolbarButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showRotateButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "handTool", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showHandToolButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showScrollingButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showSpreadButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "showPropertiesButton", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], NgxExtendedPdfViewerComponent.prototype, "spread", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "spreadChange", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], NgxExtendedPdfViewerComponent.prototype, "page", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "pageChange", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "pagesLoaded", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "pageRendered", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "zoom", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "zoomChange", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "_mobileFriendlyZoom", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], NgxExtendedPdfViewerComponent.prototype, "mobileFriendlyZoom", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], NgxExtendedPdfViewerComponent.prototype, "mobileZoom", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('sizeSelector'),
        __metadata("design:type", Object)
    ], NgxExtendedPdfViewerComponent.prototype, "sizeSelector", void 0);
    NgxExtendedPdfViewerComponent = NgxExtendedPdfViewerComponent_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ngx-extended-pdf-viewer',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ngx-extended-pdf-viewer\ngx-extended-pdf-viewer.component.html"*/'<link\n  *ngIf="useBrowserLocale"\n  rel="resource"\n  type="application/l10n"\n  href="assets/locale/locale.properties"\n  origin="ngx-extended-pdf-viewer"\n/>\n<div class="zoom" [style.height]="height" [style.minHeight]="minHeight">\n  <div class="html">\n    <div\n      tabindex="1"\n      class="loadingInProgress body"\n      [style.backgroundColor]="backgroundColor"\n    >\n      <div id="outerContainer">\n        <div id="sidebarContainer" [style.top]="sidebarPositionTop">\n          <div\n            id="additionalSidebarContainer"\n            [class.invisible]="!showSidebarButton"\n          >\n            <div id="toolbarSidebar">\n              <div class="splitToolbarButton toggled">\n                <button\n                  id="viewThumbnail"\n                  class="toolbarButton toggled"\n                  title="Show Thumbnails"\n                  tabindex="2"\n                  data-l10n-id="thumbs"\n                >\n                  <span data-l10n-id="thumbs_label">Thumbnails</span>\n                </button>\n                <button\n                  id="viewOutline"\n                  class="toolbarButton"\n                  title="Show Document Outline (double-click to expand/collapse all items)"\n                  tabindex="3"\n                  data-l10n-id="document_outline"\n                >\n                  <span data-l10n-id="document_outline_label"\n                    >Document Outline</span\n                  >\n                </button>\n                <button\n                  id="viewAttachments"\n                  class="toolbarButton"\n                  title="Show Attachments"\n                  tabindex="4"\n                  data-l10n-id="attachments"\n                >\n                  <span data-l10n-id="attachments_label">Attachments</span>\n                </button>\n              </div>\n            </div>\n          </div>\n          <div id="sidebarContent">\n            <div id="thumbnailView"></div>\n            <div id="outlineView" class="hidden"></div>\n            <div id="attachmentsView" class="hidden"></div>\n          </div>\n          <div id="sidebarResizer" class="hidden"></div>\n        </div>\n        <!-- sidebarContainer -->\n\n        <div id="mainContainer">\n          <div\n            class="findbar hidden doorHanger"\n            id="findbar"\n            [style.zoom]="mobileFriendlyZoom"\n            [style.top]="findbarTop"\n            [style.left]="findbarLeft"\n          >\n            <div id="findbarInputContainer">\n              <input\n                autocomplete="search-input-field"\n                id="findInput"\n                class="toolbarField"\n                title="Find"\n                placeholder="Find in document…"\n                tabindex="91"\n                data-l10n-id="find_input"\n                name="search-input-field"\n                (input)="dispatchFindInput($event.target)"\n              />\n              <div class="splitToolbarButton">\n                <button\n                  id="findPrevious"\n                  class="toolbarButton findPrevious"\n                  title="Find the previous occurrence of the phrase"\n                  tabindex="92"\n                  data-l10n-id="find_previous"\n                >\n                  <span data-l10n-id="find_previous_label">Previous</span>\n                </button>\n                <div class="splitToolbarButtonSeparator"></div>\n                <button\n                  id="findNext"\n                  class="toolbarButton findNext"\n                  title="Find the next occurrence of the phrase"\n                  tabindex="93"\n                  data-l10n-id="find_next"\n                >\n                  <span data-l10n-id="find_next_label">Next</span>\n                </button>\n              </div>\n            </div>\n\n            <div id="findbarOptionsOneContainer">\n              <input\n                type="checkbox"\n                id="findHighlightAll"\n                class="toolbarField"\n                tabindex="94"\n              />\n              <label\n                for="findHighlightAll"\n                class="toolbarLabel"\n                data-l10n-id="find_highlight"\n                >Highlight all</label\n              >\n              <input\n                type="checkbox"\n                id="findMatchCase"\n                class="toolbarField"\n                tabindex="95"\n              />\n              <label\n                for="findMatchCase"\n                class="toolbarLabel"\n                data-l10n-id="find_match_case_label"\n                >Match case</label\n              >\n            </div>\n            <div id="findbarOptionsTwoContainer">\n              <input\n                type="checkbox"\n                id="findEntireWord"\n                class="toolbarField"\n                tabindex="96"\n              />\n              <label\n                for="findEntireWord"\n                class="toolbarLabel"\n                data-l10n-id="find_entire_word_label"\n                >Whole words</label\n              >\n              <span id="findResultsCount" class="toolbarLabel hidden"></span>\n            </div>\n\n            <div id="findbarMessageContainer">\n              <span id="findMsg" class="toolbarLabel"></span>\n            </div>\n          </div>\n          <!-- findbar -->\n\n          <div\n            id="secondaryToolbar"\n            class="secondaryToolbar hidden doorHangerRight"\n            [style.zoom]="mobileFriendlyZoom"\n            [style.top]="findbarTop"\n            [style.right]="secondaryToolbarRight"\n          >\n            <div id="secondaryToolbarButtonContainer">\n              <button\n                id="secondaryPresentationMode"\n                class="secondaryToolbarButton presentationMode visibleLargeView"\n                title="Switch to Presentation Mode"\n                tabindex="51"\n                data-l10n-id="presentation_mode"\n              >\n                <span data-l10n-id="presentation_mode_label"\n                  >Presentation Mode</span\n                >\n              </button>\n\n              <button\n                id="secondaryOpenFile"\n                class="secondaryToolbarButton openFile visibleLargeView"\n                title="Open File"\n                tabindex="52"\n                data-l10n-id="open_file"\n              >\n                <span data-l10n-id="open_file_label">Open</span>\n              </button>\n\n              <button\n                id="secondaryPrint"\n                class="secondaryToolbarButton print visibleMediumView"\n                [class.invisible]="!showPrintButton"\n                title="Print"\n                tabindex="53"\n                data-l10n-id="print"\n              >\n                <span data-l10n-id="print_label">Print</span>\n              </button>\n\n              <button\n                id="secondaryDownload"\n                class="secondaryToolbarButton download visibleMediumView"\n                [class.invisible]="!showDownloadButton"\n                title="Download"\n                tabindex="54"\n                data-l10n-id="download"\n              >\n                <span data-l10n-id="download_label">Download</span>\n              </button>\n\n              <a\n                href="#"\n                id="secondaryViewBookmark"\n                class="secondaryToolbarButton bookmark visibleSmallView"\n                [class.invisible]="!showBookmarkButton"\n                title="Current view (copy or open in new window)"\n                tabindex="55"\n                data-l10n-id="bookmark"\n              >\n                <span data-l10n-id="bookmark_label">Current View</span>\n              </a>\n\n              <div class="horizontalToolbarSeparator visibleLargeView"></div>\n\n              <button\n                [class.invisible]="!showPagingButtons"\n                id="firstPage"\n                class="secondaryToolbarButton firstPage"\n                title="Go to First Page"\n                tabindex="56"\n                data-l10n-id="first_page"\n              >\n                <span data-l10n-id="first_page_label">Go to First Page</span>\n              </button>\n              <button\n                [class.invisible]="!showPagingButtons"\n                id="lastPage"\n                class="secondaryToolbarButton lastPage"\n                title="Go to Last Page"\n                tabindex="57"\n                data-l10n-id="last_page"\n              >\n                <span data-l10n-id="last_page_label">Go to Last Page</span>\n              </button>\n\n              <div\n                [class.invisible]="!showRotateButton"\n                class="horizontalToolbarSeparator"\n              ></div>\n\n              <button\n                [class.invisible]="!showRotateButton"\n                id="pageRotateCw"\n                class="secondaryToolbarButton rotateCw"\n                title="Rotate Clockwise"\n                tabindex="58"\n                data-l10n-id="page_rotate_cw"\n              >\n                <span data-l10n-id="page_rotate_cw_label"\n                  >Rotate Clockwise</span\n                >\n              </button>\n              <button\n                [class.invisible]="!showRotateButton"\n                id="pageRotateCcw"\n                class="secondaryToolbarButton rotateCcw"\n                title="Rotate Counterclockwise"\n                tabindex="59"\n                data-l10n-id="page_rotate_ccw"\n              >\n                <span data-l10n-id="page_rotate_ccw_label"\n                  >Rotate Counterclockwise</span\n                >\n              </button>\n\n              <div class="horizontalToolbarSeparator" [class.invisible]="!showHandToolButton"></div>\n\n              <button\n                [class.invisible]="!showHandToolButton"\n                id="cursorSelectTool"\n                class="secondaryToolbarButton selectTool toggled"\n                title="Enable Text Selection Tool"\n                tabindex="60"\n                data-l10n-id="cursor_text_select_tool"\n              >\n                <span data-l10n-id="cursor_text_select_tool_label"\n                  >Text Selection Tool</span\n                >\n              </button>\n              <button\n                [class.invisible]="!showHandToolButton"\n                id="cursorHandTool"\n                class="secondaryToolbarButton handTool"\n                title="Enable Hand Tool"\n                tabindex="61"\n                data-l10n-id="cursor_hand_tool"\n              >\n                <span data-l10n-id="cursor_hand_tool_label">Hand Tool</span>\n              </button>\n\n              <div\n                [class.invisible]="!showScrollingButton"\n                class="horizontalToolbarSeparator"\n              ></div>\n\n              <button\n                [class.invisible]="!showScrollingButton"\n                id="scrollVertical"\n                class="secondaryToolbarButton scrollVertical toggled"\n                title="Use Vertical Scrolling"\n                tabindex="62"\n                data-l10n-id="scroll_vertical"\n              >\n                <span data-l10n-id="scroll_vertical_label"\n                  >Vertical Scrolling</span\n                >\n              </button>\n              <button\n                [class.invisible]="!showScrollingButton"\n                id="scrollHorizontal"\n                class="secondaryToolbarButton scrollHorizontal"\n                title="Use Horizontal Scrolling"\n                tabindex="63"\n                data-l10n-id="scroll_horizontal"\n              >\n                <span data-l10n-id="scroll_horizontal_label"\n                  >Horizontal Scrolling</span\n                >\n              </button>\n              <button\n                [class.invisible]="!showScrollingButton"\n                id="scrollWrapped"\n                class="secondaryToolbarButton scrollWrapped"\n                title="Use Wrapped Scrolling"\n                tabindex="64"\n                data-l10n-id="scroll_wrapped"\n              >\n                <span data-l10n-id="scroll_wrapped_label"\n                  >Wrapped Scrolling</span\n                >\n              </button>\n\n              <div\n                [class.invisible]="!showSpreadButton"\n                class="horizontalToolbarSeparator"\n              ></div>\n\n              <button\n                [class.invisible]="!showSpreadButton"\n                id="spreadNone"\n                class="secondaryToolbarButton spreadNone toggled"\n                title="Do not join page spreads"\n                tabindex="65"\n                data-l10n-id="spread_none"\n                (click)="onSpreadChange(\'off\')"\n              >\n                <span data-l10n-id="spread_none_label">No Spreads</span>\n              </button>\n              <button\n                [class.invisible]="!showSpreadButton"\n                id="spreadOdd"\n                class="secondaryToolbarButton spreadOdd"\n                title="Join page spreads starting with odd-numbered pages"\n                tabindex="66"\n                data-l10n-id="spread_odd"\n                (click)="onSpreadChange(\'odd\')"\n\n              >\n                <span data-l10n-id="spread_odd_label">Odd Spreads</span>\n              </button>\n              <button\n                [class.invisible]="!showSpreadButton"\n                id="spreadEven"\n                class="secondaryToolbarButton spreadEven"\n                title="Join page spreads starting with even-numbered pages"\n                tabindex="67"\n                data-l10n-id="spread_even"\n                (click)="onSpreadChange(\'even\')"\n\n              >\n                <span data-l10n-id="spread_even_label">Even Spreads</span>\n              </button>\n\n              <div\n                [class.invisible]="!showPropertiesButton"\n                class="horizontalToolbarSeparator spreadModeButtons"\n              ></div>\n\n              <button\n                [class.invisible]="!showPropertiesButton"\n                id="documentProperties"\n                class="secondaryToolbarButton documentProperties"\n                title="Document Properties…"\n                tabindex="68"\n                data-l10n-id="document_properties"\n              >\n                <span data-l10n-id="document_properties_label"\n                  >Document Properties…</span\n                >\n              </button>\n            </div>\n          </div>\n          <!-- secondaryToolbar -->\n\n          <div class="toolbar" [class.invisible]="!primaryMenuVisible" (window:resize)="onResize()">\n            <div\n              id="toolbarContainer"\n              [style.zoom]="mobileFriendlyZoom"\n              [style.width]="toolbarWidth"\n            >\n              <div id="toolbarViewer">\n                <div id="toolbarViewerLeft">\n                  <button\n                    [class.invisible]="!showSidebarButton"\n                    id="sidebarToggle"\n                    class="toolbarButton"\n                    title="Toggle Sidebar"\n                    tabindex="11"\n                    data-l10n-id="toggle_sidebar"\n                  >\n                    <span data-l10n-id="toggle_sidebar_label"\n                      >Toggle Sidebar</span\n                    >\n                  </button>\n                  <div\n                    [class.invisible]="!showSidebarButton"\n                    class="toolbarButtonSpacer"\n                  ></div>\n                  <button\n                    [class.invisible]="!showFindButton"\n                    id="viewFind"\n                    class="toolbarButton"\n                    title="Find in Document"\n                    tabindex="12"\n                    data-l10n-id="findbar"\n                  >\n                    <span data-l10n-id="findbar_label">Find</span>\n                  </button>\n                  <div\n                    [class.invisible]="!showPagingButtons"\n                    class="splitToolbarButton hiddenSmallView"\n                  >\n                    <button\n                      class="toolbarButton pageUp"\n                      title="Previous Page"\n                      id="previous"\n                      tabindex="13"\n                      data-l10n-id="previous"\n                      (click)="onPageChange()"\n                    >\n                      <span data-l10n-id="previous_label">Previous</span>\n                    </button>\n                    <div class="splitToolbarButtonSeparator"></div>\n                    <button\n                      class="toolbarButton pageDown"\n                      title="Next Page"\n                      id="next"\n                      tabindex="14"\n                      data-l10n-id="next"\n                      (click)="onPageChange()"\n                    >\n                      <span data-l10n-id="next_label">Next</span>\n                    </button>\n                  </div>\n                  <input\n                    [class.invisible]="!showPagingButtons"\n                    type="number"\n                    id="pageNumber"\n                    class="toolbarField pageNumber"\n                    title="Page"\n                    value="1"\n                    size="4"\n                    min="1"\n                    tabindex="15"\n                    data-l10n-id="page"\n                    (change)="onPageChange()"\n                    (page-change)="onPageChange()"\n                  />\n                  <span\n                    [class.invisible]="!showPagingButtons"\n                    id="numPages"\n                    class="toolbarLabel"\n                  ></span>\n                </div>\n                <div id="toolbarViewerRight">\n                  <button\n                    [class.invisible]="!showPresentationModeButton"\n                    id="presentationMode"\n                    class="toolbarButton presentationMode hiddenLargeView"\n                    title="Switch to Presentation Mode"\n                    tabindex="31"\n                    data-l10n-id="presentation_mode"\n                  >\n                    <span data-l10n-id="presentation_mode_label"\n                      >Presentation Mode</span\n                    >\n                  </button>\n\n                  <button\n                    [class.invisible]="!showOpenFileButton"\n                    id="openFile"\n                    class="toolbarButton openFile hiddenLargeView"\n                    title="Open File"\n                    tabindex="32"\n                    data-l10n-id="open_file"\n                  >\n                    <span data-l10n-id="open_file_label">Open</span>\n                  </button>\n                  <button\n                    [class.invisible]="!showPrintButton"\n                    id="print"\n                    class="toolbarButton print hiddenMediumView"\n                    title="Print"\n                    tabindex="33"\n                    data-l10n-id="print"\n                  >\n                    <span data-l10n-id="print_label">Print</span>\n                  </button>\n\n                  <button\n                  id="download"\n                  class="toolbarButton download hiddenMediumView"\n                  [class.invisible]="!showDownloadButton"\n                    title="Download"\n                    tabindex="34"\n                    data-l10n-id="download"\n                  >\n                    <span data-l10n-id="download_label">Download</span>\n                  </button>\n                  <a\n                    href="#"\n                    [class.invisible]="!showBookmarkButton"\n                    id="viewBookmark"\n                    class="toolbarButton bookmark hiddenSmallView"\n                    title="Current view (copy or open in new window)"\n                    tabindex="35"\n                    data-l10n-id="bookmark"\n                  >\n                    <span data-l10n-id="bookmark_label">Current View</span>\n                  </a>\n\n                  <div\n                    [class.invisible]="!showSecondaryToolbarButton"\n                    class="verticalToolbarSeparator hiddenSmallView"\n                  ></div>\n\n                  <button\n                    [class.invisible]="!showSecondaryToolbarButton"\n                    id="secondaryToolbarToggle"\n                    class="toolbarButton"\n                    title="Tools"\n                    tabindex="36"\n                    data-l10n-id="tools"\n                  >\n                    <span data-l10n-id="tools_label">Tools</span>\n                  </button>\n                </div>\n                <div [class.invisible]="!showZoomButtons" id="toolbarViewerMiddle">\n                  <div class="splitToolbarButton">\n                    <button\n                      id="zoomOut"\n                      class="toolbarButton zoomOut"\n                      title="Zoom Out"\n                      tabindex="21"\n                      data-l10n-id="zoom_out"\n                      (click)="emitZoomChangeAfterDelay()"\n                    >\n                      <span data-l10n-id="zoom_out_label">Zoom Out</span>\n                    </button>\n                    <div class="splitToolbarButtonSeparator"></div>\n                    <button\n                      id="zoomIn"\n                      class="toolbarButton zoomIn"\n                      title="Zoom In"\n                      tabindex="22"\n                      data-l10n-id="zoom_in"\n                      (click)="emitZoomChangeAfterDelay()"\n                    >\n                      <span data-l10n-id="zoom_in_label">Zoom In</span>\n                    </button>\n                  </div>\n                  <span id="scaleSelectContainer" class="dropdownToolbarButton">\n                    <select\n                      id="scaleSelect"\n                      title="Zoom"\n                      tabindex="23"\n                      data-l10n-id="zoom"\n                      (change)="emitZoomChange()"\n                      #sizeSelector\n                    >\n                      <option\n                        id="pageAutoOption"\n                        title=""\n                        value="auto"\n                        selected="selected"\n                        data-l10n-id="page_scale_auto"\n                        >Automatic Zoom</option\n                      >\n                      <option\n                        id="pageActualOption"\n                        title=""\n                        value="page-actual"\n                        data-l10n-id="page_scale_actual"\n                        >Actual Size</option\n                      >\n                      <option\n                        id="pageFitOption"\n                        title=""\n                        value="page-fit"\n                        data-l10n-id="page_scale_fit"\n                        >Page Fit</option\n                      >\n                      <option\n                        id="pageWidthOption"\n                        title=""\n                        value="page-width"\n                        data-l10n-id="page_scale_width"\n                        >Page Width</option\n                      >\n                      <option\n                        id="customScaleOption"\n                        title=""\n                        value="custom"\n                        disabled="disabled"\n                        hidden="true"\n                      ></option>\n                      <option\n                        title=""\n                        value="0.5"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 50 }"\n                        >50%</option\n                      >\n                      <option\n                        title=""\n                        value="0.75"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 75 }"\n                        >75%</option\n                      >\n                      <option\n                        title=""\n                        value="1"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 100 }"\n                        >100%</option\n                      >\n                      <option\n                        title=""\n                        value="1.25"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 125 }"\n                        >125%</option\n                      >\n                      <option\n                        title=""\n                        value="1.5"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 150 }"\n                        >150%</option\n                      >\n                      <option\n                        title=""\n                        value="2"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 200 }"\n                        >200%</option\n                      >\n                      <option\n                        title=""\n                        value="3"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 300 }"\n                        >300%</option\n                      >\n                      <option\n                        title=""\n                        value="4"\n                        data-l10n-id="page_scale_percent"\n                        data-l10n-args="{ &quot;scale&quot;: 400 }"\n                        >400%</option\n                      >\n                    </select>\n                  </span>\n                </div>\n              </div>\n              <div id="loadingBar">\n                <div class="progress"><div class="glimmer"></div></div>\n              </div>\n            </div>\n          </div>\n\n          <menu\n            [class.invisible]="!showRotateButton"\n            type="context"\n            id="viewerContextMenu"\n          >\n            <menuitem\n              id="contextFirstPage"\n              label="First Page"\n              data-l10n-id="first_page"\n            >\n            </menuitem>\n            <menuitem\n              id="contextLastPage"\n              label="Last Page"\n              data-l10n-id="last_page"\n            >\n            </menuitem>\n            <menuitem\n              id="contextPageRotateCw"\n              label="Rotate Clockwise"\n              data-l10n-id="page_rotate_cw"\n            >\n            </menuitem>\n            <menuitem\n              id="contextPageRotateCcw"\n              label="Rotate Counter-Clockwise"\n              data-l10n-id="page_rotate_ccw"\n            >\n            </menuitem>\n          </menu>\n\n          <div\n            id="viewerContainer"\n            tabindex="0"\n            [style.top]="viewerPositionTop"\n          >\n            <div id="viewer" class="pdfViewer" [style.backgroundColor]="backgroundColor"></div>\n          </div>\n\n          <div id="errorWrapper" hidden="true">\n            <div id="errorMessageLeft">\n              <span id="errorMessage"></span>\n              <button id="errorShowMore" data-l10n-id="error_more_info">\n                More Information\n              </button>\n              <button\n                id="errorShowLess"\n                data-l10n-id="error_less_info"\n                hidden="true"\n              >\n                Less Information\n              </button>\n            </div>\n            <div id="errorMessageRight">\n              <button id="errorClose" data-l10n-id="error_close">Close</button>\n            </div>\n            <div class="clearBoth"></div>\n            <textarea\n              id="errorMoreInfo"\n              hidden="true"\n              readonly="readonly"\n            ></textarea>\n          </div>\n        </div>\n        <!-- mainContainer -->\n\n        <div id="overlayContainer" class="hidden">\n          <div id="passwordOverlay" class="container hidden">\n            <div class="dialog">\n              <div class="row">\n                <p id="passwordText" data-l10n-id="password_label">\n                  Enter the password to open this PDF file:\n                </p>\n              </div>\n              <div class="row">\n                <input type="password" id="password" class="toolbarField" />\n              </div>\n              <div class="buttonRow">\n                <button id="passwordCancel" class="overlayButton">\n                  <span data-l10n-id="password_cancel">Cancel</span>\n                </button>\n                <button id="passwordSubmit" class="overlayButton">\n                  <span data-l10n-id="password_ok">OK</span>\n                </button>\n              </div>\n            </div>\n          </div>\n          <div id="documentPropertiesOverlay" class="container hidden">\n            <div class="dialog">\n              <div class="row">\n                <span data-l10n-id="document_properties_file_name"\n                  >File name:</span\n                >\n                <p id="fileNameField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_file_size"\n                  >File size:</span\n                >\n                <p id="fileSizeField">-</p>\n              </div>\n              <div class="separator"></div>\n              <div class="row">\n                <span data-l10n-id="document_properties_title">Title:</span>\n                <p id="titleField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_author">Author:</span>\n                <p id="authorField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_subject">Subject:</span>\n                <p id="subjectField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_keywords"\n                  >Keywords:</span\n                >\n                <p id="keywordsField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_creation_date"\n                  >Creation Date:</span\n                >\n                <p id="creationDateField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_modification_date"\n                  >Modification Date:</span\n                >\n                <p id="modificationDateField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_creator">Creator:</span>\n                <p id="creatorField">-</p>\n              </div>\n              <div class="separator"></div>\n              <div class="row">\n                <span data-l10n-id="document_properties_producer"\n                  >PDF Producer:</span\n                >\n                <p id="producerField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_version"\n                  >PDF Version:</span\n                >\n                <p id="versionField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_page_count"\n                  >Page Count:</span\n                >\n                <p id="pageCountField">-</p>\n              </div>\n              <div class="row">\n                <span data-l10n-id="document_properties_page_size"\n                  >Page Size:</span\n                >\n                <p id="pageSizeField">-</p>\n              </div>\n              <div class="separator"></div>\n              <div class="row">\n                <span data-l10n-id="document_properties_linearized"\n                  >Fast Web View:</span\n                >\n                <p id="linearizedField">-</p>\n              </div>\n              <div class="buttonRow">\n                <button id="documentPropertiesClose" class="overlayButton">\n                  <span data-l10n-id="document_properties_close">Close</span>\n                </button>\n              </div>\n            </div>\n          </div>\n          <!-- #if !(FIREFOX || MOZCENTRAL) -->\n          <div id="printServiceOverlay" class="container hidden">\n            <div class="dialog">\n              <div class="row">\n                <span data-l10n-id="print_progress_message"\n                  >Preparing document for printing…</span\n                >\n              </div>\n              <div class="row">\n                <progress value="0" max="100"></progress>\n                <span\n                  data-l10n-id="print_progress_percent"\n                  data-l10n-args="{ &quot;progress&quot;: 0 }"\n                  class="relative-progress"\n                  >0%</span\n                >\n              </div>\n              <div class="buttonRow">\n                <button id="printCancel" class="overlayButton">\n                  <span data-l10n-id="print_progress_close">Cancel</span>\n                </button>\n              </div>\n            </div>\n          </div>\n          <!-- #endif -->\n          <!-- #if CHROME -->\n          <!-- #include viewer-snippet-chrome-overlays.html -->\n          <!-- #endif -->\n        </div>\n        <!-- overlayContainer -->\n      </div>\n      <!-- outerContainer -->\n      <div id="printContainer"></div>\n    </div>\n  </div>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ngx-extended-pdf-viewer\ngx-extended-pdf-viewer.component.html"*/,
            encapsulation: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewEncapsulation"].None
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"]])
    ], NgxExtendedPdfViewerComponent);
    return NgxExtendedPdfViewerComponent;
    var NgxExtendedPdfViewerComponent_1;
}());

//# sourceMappingURL=ngx-extended-pdf-viewer.component.js.map

/***/ }),
/* 1423 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return defaultOptions; });
var defaultOptions = {
    cursorToolOnLoad: 0,
    defaultUrl: '',
    defaultZoomValue: '',
    disableHistory: false,
    disablePageLabels: false,
    enablePrintAutoRotate: false,
    enableWebGL: false,
    eventBusDispatchToDOM: false,
    externalLinkRel: 'noopener noreferrer nofollow',
    externalLinkTarget: 0,
    historyUpdateUrl: false,
    imageResourcesPath: './images/',
    maxCanvasPixels: 16777216,
    pdfBugEnabled: false,
    renderer: 'canvas',
    renderInteractiveForms: false,
    sidebarViewOnLoad: -1,
    scrollModeOnLoad: -1,
    spreadModeOnLoad: -1,
    textLayerMode: 1,
    useOnlyCssZoom: false,
    viewOnLoad: 0,
    cMapPacked: true,
    cMapUrl: '../web/cmaps/',
    disableAutoFetch: false,
    disableCreateObjectURL: false,
    disableFontFace: false,
    disableRange: false,
    disableStream: false,
    isEvalSupported: true,
    maxImageSize: -1,
    pdfBug: false,
    postMessageTransfers: true,
    verbosity: 1,
    workerPort: null,
    workerSrc: '../build/pdf.worker.js'
};
//# sourceMappingURL=default-options.js.map

/***/ }),
/* 1424 */
/***/ (function(module, exports) {

module.exports = require('url');

/***/ }),
/* 1425 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * @licstart The following is the entire license notice for the
 * Javascript code in this page
 *
 * Copyright 2018 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * Javascript code in this page
 */

/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


;
var pdfjsWebApp, pdfjsWebAppOptions;
{
  pdfjsWebApp = __webpack_require__(1);
  pdfjsWebAppOptions = __webpack_require__(12);
}
;
{
  __webpack_require__(37);
}
;
{
  __webpack_require__(42);
}

function getViewerConfiguration() {
  return {
    appContainer: document.body,
    mainContainer: document.getElementById('viewerContainer'),
    viewerContainer: document.getElementById('viewer'),
    eventBus: null,
    toolbar: {
      container: document.getElementById('toolbarViewer'),
      numPages: document.getElementById('numPages'),
      pageNumber: document.getElementById('pageNumber'),
      scaleSelectContainer: document.getElementById('scaleSelectContainer'),
      scaleSelect: document.getElementById('scaleSelect'),
      customScaleOption: document.getElementById('customScaleOption'),
      previous: document.getElementById('previous'),
      next: document.getElementById('next'),
      zoomIn: document.getElementById('zoomIn'),
      zoomOut: document.getElementById('zoomOut'),
      viewFind: document.getElementById('viewFind'),
      openFile: document.getElementById('openFile'),
      print: document.getElementById('print'),
      presentationModeButton: document.getElementById('presentationMode'),
      download: document.getElementById('download'),
      viewBookmark: document.getElementById('viewBookmark')
    },
    secondaryToolbar: {
      toolbar: document.getElementById('secondaryToolbar'),
      toggleButton: document.getElementById('secondaryToolbarToggle'),
      toolbarButtonContainer: document.getElementById('secondaryToolbarButtonContainer'),
      presentationModeButton: document.getElementById('secondaryPresentationMode'),
      openFileButton: document.getElementById('secondaryOpenFile'),
      printButton: document.getElementById('secondaryPrint'),
      downloadButton: document.getElementById('secondaryDownload'),
      viewBookmarkButton: document.getElementById('secondaryViewBookmark'),
      firstPageButton: document.getElementById('firstPage'),
      lastPageButton: document.getElementById('lastPage'),
      pageRotateCwButton: document.getElementById('pageRotateCw'),
      pageRotateCcwButton: document.getElementById('pageRotateCcw'),
      cursorSelectToolButton: document.getElementById('cursorSelectTool'),
      cursorHandToolButton: document.getElementById('cursorHandTool'),
      scrollVerticalButton: document.getElementById('scrollVertical'),
      scrollHorizontalButton: document.getElementById('scrollHorizontal'),
      scrollWrappedButton: document.getElementById('scrollWrapped'),
      spreadNoneButton: document.getElementById('spreadNone'),
      spreadOddButton: document.getElementById('spreadOdd'),
      spreadEvenButton: document.getElementById('spreadEven'),
      documentPropertiesButton: document.getElementById('documentProperties')
    },
    fullscreen: {
      contextFirstPage: document.getElementById('contextFirstPage'),
      contextLastPage: document.getElementById('contextLastPage'),
      contextPageRotateCw: document.getElementById('contextPageRotateCw'),
      contextPageRotateCcw: document.getElementById('contextPageRotateCcw')
    },
    sidebar: {
      outerContainer: document.getElementById('outerContainer'),
      viewerContainer: document.getElementById('viewerContainer'),
      toggleButton: document.getElementById('sidebarToggle'),
      thumbnailButton: document.getElementById('viewThumbnail'),
      outlineButton: document.getElementById('viewOutline'),
      attachmentsButton: document.getElementById('viewAttachments'),
      thumbnailView: document.getElementById('thumbnailView'),
      outlineView: document.getElementById('outlineView'),
      attachmentsView: document.getElementById('attachmentsView')
    },
    sidebarResizer: {
      outerContainer: document.getElementById('outerContainer'),
      resizer: document.getElementById('sidebarResizer')
    },
    findBar: {
      bar: document.getElementById('findbar'),
      toggleButton: document.getElementById('viewFind'),
      findField: document.getElementById('findInput'),
      highlightAllCheckbox: document.getElementById('findHighlightAll'),
      caseSensitiveCheckbox: document.getElementById('findMatchCase'),
      entireWordCheckbox: document.getElementById('findEntireWord'),
      findMsg: document.getElementById('findMsg'),
      findResultsCount: document.getElementById('findResultsCount'),
      findPreviousButton: document.getElementById('findPrevious'),
      findNextButton: document.getElementById('findNext')
    },
    passwordOverlay: {
      overlayName: 'passwordOverlay',
      container: document.getElementById('passwordOverlay'),
      label: document.getElementById('passwordText'),
      input: document.getElementById('password'),
      submitButton: document.getElementById('passwordSubmit'),
      cancelButton: document.getElementById('passwordCancel')
    },
    documentProperties: {
      overlayName: 'documentPropertiesOverlay',
      container: document.getElementById('documentPropertiesOverlay'),
      closeButton: document.getElementById('documentPropertiesClose'),
      fields: {
        'fileName': document.getElementById('fileNameField'),
        'fileSize': document.getElementById('fileSizeField'),
        'title': document.getElementById('titleField'),
        'author': document.getElementById('authorField'),
        'subject': document.getElementById('subjectField'),
        'keywords': document.getElementById('keywordsField'),
        'creationDate': document.getElementById('creationDateField'),
        'modificationDate': document.getElementById('modificationDateField'),
        'creator': document.getElementById('creatorField'),
        'producer': document.getElementById('producerField'),
        'version': document.getElementById('versionField'),
        'pageCount': document.getElementById('pageCountField'),
        'pageSize': document.getElementById('pageSizeField'),
        'linearized': document.getElementById('linearizedField')
      }
    },
    errorWrapper: {
      container: document.getElementById('errorWrapper'),
      errorMessage: document.getElementById('errorMessage'),
      closeButton: document.getElementById('errorClose'),
      errorMoreInfo: document.getElementById('errorMoreInfo'),
      moreInfoButton: document.getElementById('errorShowMore'),
      lessInfoButton: document.getElementById('errorShowLess')
    },
    printContainer: document.getElementById('printContainer'),
    openFileInputName: 'fileInput',
    debuggerScriptPath: './debugger.js'
  };
}

function webViewerLoad() {
  var config = getViewerConfiguration();
  window.PDFViewerApplication = pdfjsWebApp.PDFViewerApplication;
  window.PDFViewerApplicationOptions = pdfjsWebAppOptions.AppOptions;
  var event = document.createEvent('CustomEvent');
  event.initCustomEvent('webviewerloaded', true, true, {});
  document.dispatchEvent(event);
  pdfjsWebApp.PDFViewerApplication.run(config);
}

window.webViewerLoad = webViewerLoad;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFPrintServiceFactory = exports.DefaultExternalServices = exports.PDFViewerApplication = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

var _ui_utils = __webpack_require__(6);

var _pdfjsLib = __webpack_require__(7);

var _pdf_cursor_tools = __webpack_require__(8);

var _pdf_rendering_queue = __webpack_require__(10);

var _pdf_sidebar = __webpack_require__(11);

var _app_options = __webpack_require__(12);

var _overlay_manager = __webpack_require__(14);

var _password_prompt = __webpack_require__(15);

var _pdf_attachment_viewer = __webpack_require__(16);

var _pdf_document_properties = __webpack_require__(17);

var _pdf_find_bar = __webpack_require__(18);

var _pdf_find_controller = __webpack_require__(19);

var _pdf_history = __webpack_require__(21);

var _pdf_link_service = __webpack_require__(22);

var _pdf_outline_viewer = __webpack_require__(23);

var _pdf_presentation_mode = __webpack_require__(24);

var _pdf_sidebar_resizer = __webpack_require__(25);

var _pdf_thumbnail_viewer = __webpack_require__(26);

var _pdf_viewer = __webpack_require__(28);

var _secondary_toolbar = __webpack_require__(33);

var _toolbar = __webpack_require__(35);

var _view_history = __webpack_require__(36);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var DEFAULT_SCALE_DELTA = 1.1;
var DISABLE_AUTO_FETCH_LOADING_BAR_TIMEOUT = 5000;
var FORCE_PAGES_LOADED_TIMEOUT = 10000;
var WHEEL_ZOOM_DISABLED_TIMEOUT = 1000;
var ViewOnLoad = {
  UNKNOWN: -1,
  PREVIOUS: 0,
  INITIAL: 1
};
var DefaultExternalServices = {
  updateFindControlState: function updateFindControlState(data) {},
  updateFindMatchesCount: function updateFindMatchesCount(data) {},
  initPassiveLoading: function initPassiveLoading(callbacks) {},
  fallback: function fallback(data, callback) {},
  reportTelemetry: function reportTelemetry(data) {},
  createDownloadManager: function createDownloadManager(options) {
    throw new Error('Not implemented: createDownloadManager');
  },
  createPreferences: function createPreferences() {
    throw new Error('Not implemented: createPreferences');
  },
  createL10n: function createL10n(options) {
    throw new Error('Not implemented: createL10n');
  },
  supportsIntegratedFind: false,
  supportsDocumentFonts: true,
  supportsDocumentColors: true,
  supportedMouseWheelZoomModifierKeys: {
    ctrlKey: true,
    metaKey: true
  }
};
exports.DefaultExternalServices = DefaultExternalServices;
var PDFViewerApplication = {
  initialBookmark: document.location.hash.substring(1),
  initialized: false,
  fellback: false,
  appConfig: null,
  pdfDocument: null,
  pdfLoadingTask: null,
  printService: null,
  pdfViewer: null,
  pdfThumbnailViewer: null,
  pdfRenderingQueue: null,
  pdfPresentationMode: null,
  pdfDocumentProperties: null,
  pdfLinkService: null,
  pdfHistory: null,
  pdfSidebar: null,
  pdfSidebarResizer: null,
  pdfOutlineViewer: null,
  pdfAttachmentViewer: null,
  pdfCursorTools: null,
  store: null,
  downloadManager: null,
  overlayManager: null,
  preferences: null,
  toolbar: null,
  secondaryToolbar: null,
  eventBus: null,
  l10n: null,
  isInitialViewSet: false,
  downloadComplete: false,
  isViewerEmbedded: window.parent !== window,
  url: '',
  baseUrl: '',
  externalServices: DefaultExternalServices,
  _boundEvents: {},
  contentDispositionFilename: null,
  initialize: function () {
    var _initialize = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee(appConfig) {
      var _this = this;

      var appContainer;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              this.preferences = this.externalServices.createPreferences();
              this.appConfig = appConfig;
              _context.next = 4;
              return this._readPreferences();

            case 4:
              _context.next = 6;
              return this._parseHashParameters();

            case 6:
              _context.next = 8;
              return this._initializeL10n();

            case 8:
              if (this.isViewerEmbedded && _app_options.AppOptions.get('externalLinkTarget') === _pdfjsLib.LinkTarget.NONE) {
                _app_options.AppOptions.set('externalLinkTarget', _pdfjsLib.LinkTarget.TOP);
              }

              _context.next = 11;
              return this._initializeViewerComponents();

            case 11:
              this.bindEvents();
              this.bindWindowEvents();
              appContainer = appConfig.appContainer || document.documentElement;
              this.l10n.translate(appContainer).then(function () {
                _this.eventBus.dispatch('localized', {
                  source: _this
                });
              });
              this.initialized = true;

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function initialize(_x) {
      return _initialize.apply(this, arguments);
    }

    return initialize;
  }(),
  _readPreferences: function () {
    var _readPreferences2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2() {
      var prefs, name;
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(_app_options.AppOptions.get('disablePreferences') === true)) {
                _context2.next = 2;
                break;
              }

              return _context2.abrupt("return");

            case 2:
              _context2.prev = 2;
              _context2.next = 5;
              return this.preferences.getAll();

            case 5:
              prefs = _context2.sent;

              for (name in prefs) {
                _app_options.AppOptions.set(name, prefs[name]);
              }

              _context2.next = 11;
              break;

            case 9:
              _context2.prev = 9;
              _context2.t0 = _context2["catch"](2);

            case 11:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this, [[2, 9]]);
    }));

    function _readPreferences() {
      return _readPreferences2.apply(this, arguments);
    }

    return _readPreferences;
  }(),
  _parseHashParameters: function () {
    var _parseHashParameters2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee3() {
      var waitOn, hash, hashParams, viewer, enabled;
      return _regenerator.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (_app_options.AppOptions.get('pdfBugEnabled')) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return");

            case 2:
              waitOn = [];
              hash = document.location.hash.substring(1);
              hashParams = (0, _ui_utils.parseQueryString)(hash);

              if ('disableworker' in hashParams && hashParams['disableworker'] === 'true') {
                waitOn.push(loadFakeWorker());
              }

              if ('disablerange' in hashParams) {
                _app_options.AppOptions.set('disableRange', hashParams['disablerange'] === 'true');
              }

              if ('disablestream' in hashParams) {
                _app_options.AppOptions.set('disableStream', hashParams['disablestream'] === 'true');
              }

              if ('disableautofetch' in hashParams) {
                _app_options.AppOptions.set('disableAutoFetch', hashParams['disableautofetch'] === 'true');
              }

              if ('disablefontface' in hashParams) {
                _app_options.AppOptions.set('disableFontFace', hashParams['disablefontface'] === 'true');
              }

              if ('disablehistory' in hashParams) {
                _app_options.AppOptions.set('disableHistory', hashParams['disablehistory'] === 'true');
              }

              if ('webgl' in hashParams) {
                _app_options.AppOptions.set('enableWebGL', hashParams['webgl'] === 'true');
              }

              if ('useonlycsszoom' in hashParams) {
                _app_options.AppOptions.set('useOnlyCssZoom', hashParams['useonlycsszoom'] === 'true');
              }

              if ('verbosity' in hashParams) {
                _app_options.AppOptions.set('verbosity', hashParams['verbosity'] | 0);
              }

              if (!('textlayer' in hashParams)) {
                _context3.next = 23;
                break;
              }

              _context3.t0 = hashParams['textlayer'];
              _context3.next = _context3.t0 === 'off' ? 18 : _context3.t0 === 'visible' ? 20 : _context3.t0 === 'shadow' ? 20 : _context3.t0 === 'hover' ? 20 : 23;
              break;

            case 18:
              _app_options.AppOptions.set('textLayerMode', _ui_utils.TextLayerMode.DISABLE);

              return _context3.abrupt("break", 23);

            case 20:
              viewer = this.appConfig.viewerContainer;
              viewer.classList.add('textLayer-' + hashParams['textlayer']);
              return _context3.abrupt("break", 23);

            case 23:
              if ('pdfbug' in hashParams) {
                _app_options.AppOptions.set('pdfBug', true);

                enabled = hashParams['pdfbug'].split(',');
                waitOn.push(loadAndEnablePDFBug(enabled));
              }

              if ('locale' in hashParams) {
                _app_options.AppOptions.set('locale', hashParams['locale']);
              }

              return _context3.abrupt("return", Promise.all(waitOn).catch(function (reason) {
                console.error("_parseHashParameters: \"".concat(reason.message, "\"."));
              }));

            case 26:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function _parseHashParameters() {
      return _parseHashParameters2.apply(this, arguments);
    }

    return _parseHashParameters;
  }(),
  _initializeL10n: function () {
    var _initializeL10n2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee4() {
      var dir;
      return _regenerator.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              this.l10n = this.externalServices.createL10n({
                locale: _app_options.AppOptions.get('locale')
              });
              _context4.next = 3;
              return this.l10n.getDirection();

            case 3:
              dir = _context4.sent;
              document.getElementsByTagName('html')[0].dir = dir;

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function _initializeL10n() {
      return _initializeL10n2.apply(this, arguments);
    }

    return _initializeL10n;
  }(),
  _initializeViewerComponents: function () {
    var _initializeViewerComponents2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee5() {
      var appConfig, dispatchToDOM, eventBus, pdfRenderingQueue, pdfLinkService, downloadManager, findController, container, viewer, thumbnailContainer, sidebarConfig;
      return _regenerator.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              appConfig = this.appConfig;
              this.overlayManager = new _overlay_manager.OverlayManager();
              dispatchToDOM = _app_options.AppOptions.get('eventBusDispatchToDOM');
              eventBus = appConfig.eventBus || (0, _ui_utils.getGlobalEventBus)(dispatchToDOM);
              this.eventBus = eventBus;
              pdfRenderingQueue = new _pdf_rendering_queue.PDFRenderingQueue();
              pdfRenderingQueue.onIdle = this.cleanup.bind(this);
              this.pdfRenderingQueue = pdfRenderingQueue;
              pdfLinkService = new _pdf_link_service.PDFLinkService({
                eventBus: eventBus,
                externalLinkTarget: _app_options.AppOptions.get('externalLinkTarget'),
                externalLinkRel: _app_options.AppOptions.get('externalLinkRel')
              });
              this.pdfLinkService = pdfLinkService;
              downloadManager = this.externalServices.createDownloadManager({
                disableCreateObjectURL: _app_options.AppOptions.get('disableCreateObjectURL')
              });
              this.downloadManager = downloadManager;
              findController = new _pdf_find_controller.PDFFindController({
                linkService: pdfLinkService,
                eventBus: eventBus
              });
              this.findController = findController;
              container = appConfig.mainContainer;
              viewer = appConfig.viewerContainer;
              this.pdfViewer = new _pdf_viewer.PDFViewer({
                container: container,
                viewer: viewer,
                eventBus: eventBus,
                renderingQueue: pdfRenderingQueue,
                linkService: pdfLinkService,
                downloadManager: downloadManager,
                findController: findController,
                renderer: _app_options.AppOptions.get('renderer'),
                enableWebGL: _app_options.AppOptions.get('enableWebGL'),
                l10n: this.l10n,
                textLayerMode: _app_options.AppOptions.get('textLayerMode'),
                imageResourcesPath: _app_options.AppOptions.get('imageResourcesPath'),
                renderInteractiveForms: _app_options.AppOptions.get('renderInteractiveForms'),
                enablePrintAutoRotate: _app_options.AppOptions.get('enablePrintAutoRotate'),
                useOnlyCssZoom: _app_options.AppOptions.get('useOnlyCssZoom'),
                maxCanvasPixels: _app_options.AppOptions.get('maxCanvasPixels')
              });
              pdfRenderingQueue.setViewer(this.pdfViewer);
              pdfLinkService.setViewer(this.pdfViewer);
              thumbnailContainer = appConfig.sidebar.thumbnailView;
              this.pdfThumbnailViewer = new _pdf_thumbnail_viewer.PDFThumbnailViewer({
                container: thumbnailContainer,
                renderingQueue: pdfRenderingQueue,
                linkService: pdfLinkService,
                l10n: this.l10n
              });
              pdfRenderingQueue.setThumbnailViewer(this.pdfThumbnailViewer);
              this.pdfHistory = new _pdf_history.PDFHistory({
                linkService: pdfLinkService,
                eventBus: eventBus
              });
              pdfLinkService.setHistory(this.pdfHistory);
              this.findBar = new _pdf_find_bar.PDFFindBar(appConfig.findBar, eventBus, this.l10n);
              this.pdfDocumentProperties = new _pdf_document_properties.PDFDocumentProperties(appConfig.documentProperties, this.overlayManager, eventBus, this.l10n);
              this.pdfCursorTools = new _pdf_cursor_tools.PDFCursorTools({
                container: container,
                eventBus: eventBus,
                cursorToolOnLoad: _app_options.AppOptions.get('cursorToolOnLoad')
              });
              this.toolbar = new _toolbar.Toolbar(appConfig.toolbar, eventBus, this.l10n);
              this.secondaryToolbar = new _secondary_toolbar.SecondaryToolbar(appConfig.secondaryToolbar, container, eventBus);

              if (this.supportsFullscreen) {
                this.pdfPresentationMode = new _pdf_presentation_mode.PDFPresentationMode({
                  container: container,
                  viewer: viewer,
                  pdfViewer: this.pdfViewer,
                  eventBus: eventBus,
                  contextMenuItems: appConfig.fullscreen
                });
              }

              this.passwordPrompt = new _password_prompt.PasswordPrompt(appConfig.passwordOverlay, this.overlayManager, this.l10n);
              this.pdfOutlineViewer = new _pdf_outline_viewer.PDFOutlineViewer({
                container: appConfig.sidebar.outlineView,
                eventBus: eventBus,
                linkService: pdfLinkService
              });
              this.pdfAttachmentViewer = new _pdf_attachment_viewer.PDFAttachmentViewer({
                container: appConfig.sidebar.attachmentsView,
                eventBus: eventBus,
                downloadManager: downloadManager
              });
              sidebarConfig = Object.create(appConfig.sidebar);
              sidebarConfig.pdfViewer = this.pdfViewer;
              sidebarConfig.pdfThumbnailViewer = this.pdfThumbnailViewer;
              this.pdfSidebar = new _pdf_sidebar.PDFSidebar(sidebarConfig, eventBus, this.l10n);
              this.pdfSidebar.onToggled = this.forceRendering.bind(this);
              this.pdfSidebarResizer = new _pdf_sidebar_resizer.PDFSidebarResizer(appConfig.sidebarResizer, eventBus, this.l10n);

            case 39:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function _initializeViewerComponents() {
      return _initializeViewerComponents2.apply(this, arguments);
    }

    return _initializeViewerComponents;
  }(),
  run: function run(config) {
    this.initialize(config).then(webViewerInitialized);
  },
  zoomIn: function zoomIn(ticks) {
    var newScale = this.pdfViewer.currentScale;

    do {
      newScale = (newScale * DEFAULT_SCALE_DELTA).toFixed(2);
      newScale = Math.ceil(newScale * 10) / 10;
      newScale = Math.min(_ui_utils.MAX_SCALE, newScale);
    } while (--ticks > 0 && newScale < _ui_utils.MAX_SCALE);

    this.pdfViewer.currentScaleValue = newScale;
  },
  zoomOut: function zoomOut(ticks) {
    var newScale = this.pdfViewer.currentScale;

    do {
      newScale = (newScale / DEFAULT_SCALE_DELTA).toFixed(2);
      newScale = Math.floor(newScale * 10) / 10;
      newScale = Math.max(_ui_utils.MIN_SCALE, newScale);
    } while (--ticks > 0 && newScale > _ui_utils.MIN_SCALE);

    this.pdfViewer.currentScaleValue = newScale;
  },

  get pagesCount() {
    return this.pdfDocument ? this.pdfDocument.numPages : 0;
  },

  set page(val) {
    this.pdfViewer.currentPageNumber = val;
  },

  get page() {
    return this.pdfViewer.currentPageNumber;
  },

  get printing() {
    return !!this.printService;
  },

  get supportsPrinting() {
    return PDFPrintServiceFactory.instance.supportsPrinting;
  },

  get supportsFullscreen() {
    var support;
    var doc = document.documentElement;
    support = !!(doc.requestFullscreen || doc.mozRequestFullScreen || doc.webkitRequestFullScreen || doc.msRequestFullscreen);

    if (document.fullscreenEnabled === false || document.mozFullScreenEnabled === false || document.webkitFullscreenEnabled === false || document.msFullscreenEnabled === false) {
      support = false;
    }

    return (0, _pdfjsLib.shadow)(this, 'supportsFullscreen', support);
  },

  get supportsIntegratedFind() {
    return this.externalServices.supportsIntegratedFind;
  },

  get supportsDocumentFonts() {
    return this.externalServices.supportsDocumentFonts;
  },

  get supportsDocumentColors() {
    return this.externalServices.supportsDocumentColors;
  },

  get loadingBar() {
    var bar = new _ui_utils.ProgressBar('#loadingBar');
    return (0, _pdfjsLib.shadow)(this, 'loadingBar', bar);
  },

  get supportedMouseWheelZoomModifierKeys() {
    return this.externalServices.supportedMouseWheelZoomModifierKeys;
  },

  initPassiveLoading: function initPassiveLoading() {
    throw new Error('Not implemented: initPassiveLoading');
  },
  setTitleUsingUrl: function setTitleUsingUrl() {
    var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    this.url = url;
    this.baseUrl = url.split('#')[0];
    var title = (0, _ui_utils.getPDFFileNameFromURL)(url, '');

    if (!title) {
      try {
        title = decodeURIComponent((0, _pdfjsLib.getFilenameFromUrl)(url)) || url;
      } catch (ex) {
        title = url;
      }
    }

    this.setTitle(title);
  },
  setTitle: function setTitle(title) {
    if (this.isViewerEmbedded) {
      return;
    }

    document.title = title;
  },
  close: function () {
    var _close = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee6() {
      var errorWrapper, promise;
      return _regenerator.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              errorWrapper = this.appConfig.errorWrapper.container;
              errorWrapper.setAttribute('hidden', 'true');

              if (this.pdfLoadingTask) {
                _context6.next = 4;
                break;
              }

              return _context6.abrupt("return");

            case 4:
              promise = this.pdfLoadingTask.destroy();
              this.pdfLoadingTask = null;

              if (this.pdfDocument) {
                this.pdfDocument = null;
                this.pdfThumbnailViewer.setDocument(null);
                this.pdfViewer.setDocument(null);
                this.pdfLinkService.setDocument(null);
                this.pdfDocumentProperties.setDocument(null);
              }

              this.store = null;
              this.isInitialViewSet = false;
              this.downloadComplete = false;
              this.url = '';
              this.baseUrl = '';
              this.contentDispositionFilename = null;
              this.pdfSidebar.reset();
              this.pdfOutlineViewer.reset();
              this.pdfAttachmentViewer.reset();
              this.findBar.reset();
              this.toolbar.reset();
              this.secondaryToolbar.reset();

              if (typeof PDFBug !== 'undefined') {
                PDFBug.cleanup();
              }

              return _context6.abrupt("return", promise);

            case 21:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function close() {
      return _close.apply(this, arguments);
    }

    return close;
  }(),
  open: function () {
    var _open = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee7(file, args) {
      var _this2 = this;

      var workerParameters, key, parameters, apiParameters, _key, prop, loadingTask;

      return _regenerator.default.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (!this.pdfLoadingTask) {
                _context7.next = 3;
                break;
              }

              _context7.next = 3;
              return this.close();

            case 3:
              workerParameters = _app_options.AppOptions.getAll('worker');

              for (key in workerParameters) {
                _pdfjsLib.GlobalWorkerOptions[key] = workerParameters[key];
              }

              parameters = Object.create(null);

              if (typeof file === 'string') {
                this.setTitleUsingUrl(file);
                parameters.url = file;
              } else if (file && 'byteLength' in file) {
                parameters.data = file;
              } else if (file.url && file.originalUrl) {
                this.setTitleUsingUrl(file.originalUrl);
                parameters.url = file.url;
              }

              apiParameters = _app_options.AppOptions.getAll('api');

              for (_key in apiParameters) {
                parameters[_key] = apiParameters[_key];
              }

              if (args) {
                for (prop in args) {
                  if (prop === 'length') {
                    this.pdfDocumentProperties.setFileSize(args[prop]);
                  }

                  parameters[prop] = args[prop];
                }
              }

              loadingTask = (0, _pdfjsLib.getDocument)(parameters);
              this.pdfLoadingTask = loadingTask;

              loadingTask.onPassword = function (updateCallback, reason) {
                _this2.passwordPrompt.setUpdateCallback(updateCallback, reason);

                _this2.passwordPrompt.open();
              };

              loadingTask.onProgress = function (_ref) {
                var loaded = _ref.loaded,
                    total = _ref.total;

                _this2.progress(loaded / total);
              };

              loadingTask.onUnsupportedFeature = this.fallback.bind(this);
              return _context7.abrupt("return", loadingTask.promise.then(function (pdfDocument) {
                _this2.load(pdfDocument);
              }, function (exception) {
                if (loadingTask !== _this2.pdfLoadingTask) {
                  return;
                }

                var message = exception && exception.message;
                var loadingErrorMessage;

                if (exception instanceof _pdfjsLib.InvalidPDFException) {
                  loadingErrorMessage = _this2.l10n.get('invalid_file_error', null, 'Invalid or corrupted PDF file.');
                } else if (exception instanceof _pdfjsLib.MissingPDFException) {
                  loadingErrorMessage = _this2.l10n.get('missing_file_error', null, 'Missing PDF file.');
                } else if (exception instanceof _pdfjsLib.UnexpectedResponseException) {
                  loadingErrorMessage = _this2.l10n.get('unexpected_response_error', null, 'Unexpected server response.');
                } else {
                  loadingErrorMessage = _this2.l10n.get('loading_error', null, 'An error occurred while loading the PDF.');
                }

                return loadingErrorMessage.then(function (msg) {
                  _this2.error(msg, {
                    message: message
                  });

                  throw new Error(msg);
                });
              }));

            case 16:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function open(_x2, _x3) {
      return _open.apply(this, arguments);
    }

    return open;
  }(),
  download: function download() {
    var _this3 = this;

    function downloadByUrl() {
      downloadManager.downloadUrl(url, filename);
    }

    var url = this.baseUrl;
    var filename = this.contentDispositionFilename || (0, _ui_utils.getPDFFileNameFromURL)(this.url);
    var downloadManager = this.downloadManager;

    downloadManager.onerror = function (err) {
      _this3.error("PDF failed to download: ".concat(err));
    };

    if (!this.pdfDocument || !this.downloadComplete) {
      downloadByUrl();
      return;
    }

    this.pdfDocument.getData().then(function (data) {
      var blob = new Blob([data], {
        type: 'application/pdf'
      });
      downloadManager.download(blob, url, filename);
    }).catch(downloadByUrl);
  },
  fallback: function fallback(featureId) {},
  error: function error(message, moreInfo) {
    var moreInfoText = [this.l10n.get('error_version_info', {
      version: _pdfjsLib.version || '?',
      build: _pdfjsLib.build || '?'
    }, 'PDF.js v{{version}} (build: {{build}})')];

    if (moreInfo) {
      moreInfoText.push(this.l10n.get('error_message', {
        message: moreInfo.message
      }, 'Message: {{message}}'));

      if (moreInfo.stack) {
        moreInfoText.push(this.l10n.get('error_stack', {
          stack: moreInfo.stack
        }, 'Stack: {{stack}}'));
      } else {
        if (moreInfo.filename) {
          moreInfoText.push(this.l10n.get('error_file', {
            file: moreInfo.filename
          }, 'File: {{file}}'));
        }

        if (moreInfo.lineNumber) {
          moreInfoText.push(this.l10n.get('error_line', {
            line: moreInfo.lineNumber
          }, 'Line: {{line}}'));
        }
      }
    }

    var errorWrapperConfig = this.appConfig.errorWrapper;
    var errorWrapper = errorWrapperConfig.container;
    errorWrapper.removeAttribute('hidden');
    var errorMessage = errorWrapperConfig.errorMessage;
    errorMessage.textContent = message;
    var closeButton = errorWrapperConfig.closeButton;

    closeButton.onclick = function () {
      errorWrapper.setAttribute('hidden', 'true');
    };

    var errorMoreInfo = errorWrapperConfig.errorMoreInfo;
    var moreInfoButton = errorWrapperConfig.moreInfoButton;
    var lessInfoButton = errorWrapperConfig.lessInfoButton;

    moreInfoButton.onclick = function () {
      errorMoreInfo.removeAttribute('hidden');
      moreInfoButton.setAttribute('hidden', 'true');
      lessInfoButton.removeAttribute('hidden');
      errorMoreInfo.style.height = errorMoreInfo.scrollHeight + 'px';
    };

    lessInfoButton.onclick = function () {
      errorMoreInfo.setAttribute('hidden', 'true');
      moreInfoButton.removeAttribute('hidden');
      lessInfoButton.setAttribute('hidden', 'true');
    };

    moreInfoButton.oncontextmenu = _ui_utils.noContextMenuHandler;
    lessInfoButton.oncontextmenu = _ui_utils.noContextMenuHandler;
    closeButton.oncontextmenu = _ui_utils.noContextMenuHandler;
    moreInfoButton.removeAttribute('hidden');
    lessInfoButton.setAttribute('hidden', 'true');
    Promise.all(moreInfoText).then(function (parts) {
      errorMoreInfo.value = parts.join('\n');
    });
  },
  progress: function progress(level) {
    var _this4 = this;

    if (this.downloadComplete) {
      return;
    }

    var percent = Math.round(level * 100);

    if (percent > this.loadingBar.percent || isNaN(percent)) {
      this.loadingBar.percent = percent;
      var disableAutoFetch = this.pdfDocument ? this.pdfDocument.loadingParams['disableAutoFetch'] : _app_options.AppOptions.get('disableAutoFetch');

      if (disableAutoFetch && percent) {
        if (this.disableAutoFetchLoadingBarTimeout) {
          clearTimeout(this.disableAutoFetchLoadingBarTimeout);
          this.disableAutoFetchLoadingBarTimeout = null;
        }

        this.loadingBar.show();
        this.disableAutoFetchLoadingBarTimeout = setTimeout(function () {
          _this4.loadingBar.hide();

          _this4.disableAutoFetchLoadingBarTimeout = null;
        }, DISABLE_AUTO_FETCH_LOADING_BAR_TIMEOUT);
      }
    }
  },
  load: function load(pdfDocument) {
    var _this5 = this;

    this.pdfDocument = pdfDocument;
    pdfDocument.getDownloadInfo().then(function () {
      _this5.downloadComplete = true;

      _this5.loadingBar.hide();

      firstPagePromise.then(function () {
        _this5.eventBus.dispatch('documentloaded', {
          source: _this5
        });
      });
    });
    var pageModePromise = pdfDocument.getPageMode().catch(function () {});
    var openActionDestPromise = pdfDocument.getOpenActionDestination().catch(function () {});
    this.toolbar.setPagesCount(pdfDocument.numPages, false);
    this.secondaryToolbar.setPagesCount(pdfDocument.numPages);
    var store = this.store = new _view_history.ViewHistory(pdfDocument.fingerprint);
    var baseDocumentUrl;
    baseDocumentUrl = null;
    this.pdfLinkService.setDocument(pdfDocument, baseDocumentUrl);
    this.pdfDocumentProperties.setDocument(pdfDocument, this.url);
    var pdfViewer = this.pdfViewer;
    pdfViewer.setDocument(pdfDocument);
    var firstPagePromise = pdfViewer.firstPagePromise;
    var pagesPromise = pdfViewer.pagesPromise;
    var onePageRendered = pdfViewer.onePageRendered;
    var pdfThumbnailViewer = this.pdfThumbnailViewer;
    pdfThumbnailViewer.setDocument(pdfDocument);
    firstPagePromise.then(function (pdfPage) {
      _this5.loadingBar.setWidth(_this5.appConfig.viewerContainer);

      var storePromise = store.getMultiple({
        page: null,
        zoom: _ui_utils.DEFAULT_SCALE_VALUE,
        scrollLeft: '0',
        scrollTop: '0',
        rotation: null,
        sidebarView: _pdf_sidebar.SidebarView.UNKNOWN,
        scrollMode: _ui_utils.ScrollMode.UNKNOWN,
        spreadMode: _ui_utils.SpreadMode.UNKNOWN
      }).catch(function () {});
      Promise.all([storePromise, pageModePromise, openActionDestPromise]).then(
      /*#__PURE__*/
      function () {
        var _ref3 = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee8(_ref2) {
          var _ref4, _ref4$, values, pageMode, openActionDest, viewOnLoad, initialBookmark, zoom, hash, rotation, sidebarView, scrollMode, spreadMode;

          return _regenerator.default.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  _ref4 = _slicedToArray(_ref2, 3), _ref4$ = _ref4[0], values = _ref4$ === void 0 ? {} : _ref4$, pageMode = _ref4[1], openActionDest = _ref4[2];
                  viewOnLoad = _app_options.AppOptions.get('viewOnLoad');

                  _this5._initializePdfHistory({
                    fingerprint: pdfDocument.fingerprint,
                    viewOnLoad: viewOnLoad,
                    initialDest: openActionDest
                  });

                  initialBookmark = _this5.initialBookmark;
                  zoom = _app_options.AppOptions.get('defaultZoomValue');
                   hash = zoom ? "zoom=".concat(zoom) : null;
                  rotation = null;
                  sidebarView = _app_options.AppOptions.get('sidebarViewOnLoad');
                  scrollMode = _app_options.AppOptions.get('scrollModeOnLoad');
                  spreadMode = _app_options.AppOptions.get('spreadModeOnLoad');

                  if (values.page && viewOnLoad !== ViewOnLoad.INITIAL) {
                    hash = "page=".concat(values.page, "&zoom=").concat(zoom || values.zoom, ",") + "".concat(values.scrollLeft, ",").concat(values.scrollTop);
                    rotation = parseInt(values.rotation, 10);

                    if (sidebarView === _pdf_sidebar.SidebarView.UNKNOWN) {
                      sidebarView = values.sidebarView | 0;
                    }

                    if (scrollMode === _ui_utils.ScrollMode.UNKNOWN) {
                      scrollMode = values.scrollMode | 0;
                    }

                    if (spreadMode === _ui_utils.SpreadMode.UNKNOWN) {
                      spreadMode = values.spreadMode | 0;
                    }
                  }

                  if (pageMode && sidebarView === _pdf_sidebar.SidebarView.UNKNOWN) {
                    sidebarView = apiPageModeToSidebarView(pageMode);
                  }

                  _this5.setInitialView(hash, {
                    rotation: rotation,
                    sidebarView: sidebarView,
                    scrollMode: scrollMode,
                    spreadMode: spreadMode
                  });

                  _this5.eventBus.dispatch('documentinit', {
                    source: _this5
                  });

                  if (!_this5.isViewerEmbedded) {
                    pdfViewer.focus();
                  }

                  _context8.next = 17;
                  return Promise.race([pagesPromise, new Promise(function (resolve) {
                    setTimeout(resolve, FORCE_PAGES_LOADED_TIMEOUT);
                  })]);

                case 17:
                  if (!(!initialBookmark && !hash)) {
                    _context8.next = 19;
                    break;
                  }

                  return _context8.abrupt("return");

                case 19:
                  if (!pdfViewer.hasEqualPageSizes) {
                    _context8.next = 21;
                    break;
                  }

                  return _context8.abrupt("return");

                case 21:
                  _this5.initialBookmark = initialBookmark;
                  pdfViewer.currentScaleValue = pdfViewer.currentScaleValue;

                  _this5.setInitialView(hash);

                case 24:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee8, this);
        }));

        return function (_x4) {
          return _ref3.apply(this, arguments);
        };
      }()).catch(function () {
        _this5.setInitialView();
      }).then(function () {
        pdfViewer.update();
      });
    });
    pdfDocument.getPageLabels().then(function (labels) {
      if (!labels || _app_options.AppOptions.get('disablePageLabels')) {
        return;
      }

      var i = 0,
          numLabels = labels.length;

      if (numLabels !== _this5.pagesCount) {
        console.error('The number of Page Labels does not match ' + 'the number of pages in the document.');
        return;
      }

      while (i < numLabels && labels[i] === (i + 1).toString()) {
        i++;
      }

      if (i === numLabels) {
        return;
      }

      pdfViewer.setPageLabels(labels);
      pdfThumbnailViewer.setPageLabels(labels);

      _this5.toolbar.setPagesCount(pdfDocument.numPages, true);

      _this5.toolbar.setPageNumber(pdfViewer.currentPageNumber, pdfViewer.currentPageLabel);
    });
    pagesPromise.then(function () {
      if (!_this5.supportsPrinting) {
        return;
      }

      pdfDocument.getJavaScript().then(function (javaScript) {
        if (!javaScript) {
          return;
        }

        javaScript.some(function (js) {
          if (!js) {
            return false;
          }

          console.warn('Warning: JavaScript is not supported');

          _this5.fallback(_pdfjsLib.UNSUPPORTED_FEATURES.javaScript);

          return true;
        });
        var regex = /\bprint\s*\(/;

        for (var i = 0, ii = javaScript.length; i < ii; i++) {
          var js = javaScript[i];

          if (js && regex.test(js)) {
            setTimeout(function () {
              window.print();
            });
            return;
          }
        }
      });
    });
    Promise.all([onePageRendered, _ui_utils.animationStarted]).then(function () {
      pdfDocument.getOutline().then(function (outline) {
        _this5.pdfOutlineViewer.render({
          outline: outline
        });
      });
      pdfDocument.getAttachments().then(function (attachments) {
        _this5.pdfAttachmentViewer.render({
          attachments: attachments
        });
      });
    });
    pdfDocument.getMetadata().then(function (_ref5) {
      var info = _ref5.info,
          metadata = _ref5.metadata,
          contentDispositionFilename = _ref5.contentDispositionFilename;
      _this5.documentInfo = info;
      _this5.metadata = metadata;
      _this5.contentDispositionFilename = contentDispositionFilename;
      console.log('PDF ' + pdfDocument.fingerprint + ' [' + info.PDFFormatVersion + ' ' + (info.Producer || '-').trim() + ' / ' + (info.Creator || '-').trim() + ']' + ' (PDF.js: ' + (_pdfjsLib.version || '-') + (_app_options.AppOptions.get('enableWebGL') ? ' [WebGL]' : '') + ')');
      var pdfTitle;

      if (metadata && metadata.has('dc:title')) {
        var title = metadata.get('dc:title');

        if (title !== 'Untitled') {
          pdfTitle = title;
        }
      }

      if (!pdfTitle && info && info['Title']) {
        pdfTitle = info['Title'];
      }

      if (pdfTitle) {
        _this5.setTitle("".concat(pdfTitle, " - ").concat(contentDispositionFilename || document.title));
      } else if (contentDispositionFilename) {
        _this5.setTitle(contentDispositionFilename);
      }

      if (info.IsAcroFormPresent) {
        console.warn('Warning: AcroForm/XFA is not supported');

        _this5.fallback(_pdfjsLib.UNSUPPORTED_FEATURES.forms);
      }
    });
  },
  _initializePdfHistory: function _initializePdfHistory(_ref6) {
    var fingerprint = _ref6.fingerprint,
        viewOnLoad = _ref6.viewOnLoad,
        _ref6$initialDest = _ref6.initialDest,
        initialDest = _ref6$initialDest === void 0 ? null : _ref6$initialDest;

    if (_app_options.AppOptions.get('disableHistory') || this.isViewerEmbedded) {
      return;
    }

    this.pdfHistory.initialize({
      fingerprint: fingerprint,
      resetHistory: viewOnLoad === ViewOnLoad.INITIAL,
      updateUrl: _app_options.AppOptions.get('historyUpdateUrl')
    });

    if (this.pdfHistory.initialBookmark) {
      this.initialBookmark = this.pdfHistory.initialBookmark;
      this.initialRotation = this.pdfHistory.initialRotation;
    }

    if (initialDest && !this.initialBookmark && viewOnLoad === ViewOnLoad.UNKNOWN) {
      this.initialBookmark = JSON.stringify(initialDest);
      this.pdfHistory.push({
        explicitDest: initialDest,
        pageNumber: null
      });
    }
  },
  setInitialView: function setInitialView(storedHash) {
    var _this6 = this;

    var _ref7 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        rotation = _ref7.rotation,
        sidebarView = _ref7.sidebarView,
        scrollMode = _ref7.scrollMode,
        spreadMode = _ref7.spreadMode;

    var setRotation = function setRotation(angle) {
      if ((0, _ui_utils.isValidRotation)(angle)) {
        _this6.pdfViewer.pagesRotation = angle;
      }
    };

    var setViewerModes = function setViewerModes(scroll, spread) {
      if ((0, _ui_utils.isValidScrollMode)(scroll)) {
        _this6.pdfViewer.scrollMode = scroll;
      }

      if ((0, _ui_utils.isValidSpreadMode)(spread)) {
        _this6.pdfViewer.spreadMode = spread;
      }
    };

    this.isInitialViewSet = true;
    this.pdfSidebar.setInitialView(sidebarView);
    setViewerModes(scrollMode, spreadMode);

    if (this.initialBookmark) {
      setRotation(this.initialRotation);
      delete this.initialRotation;
      this.pdfLinkService.setHash(this.initialBookmark);
      this.initialBookmark = null;
    } else if (storedHash) {
      setRotation(rotation);
      this.pdfLinkService.setHash(storedHash);
    }

    this.toolbar.setPageNumber(this.pdfViewer.currentPageNumber, this.pdfViewer.currentPageLabel);
    this.secondaryToolbar.setPageNumber(this.pdfViewer.currentPageNumber);

    if (!this.pdfViewer.currentScaleValue) {
      this.pdfViewer.currentScaleValue = _ui_utils.DEFAULT_SCALE_VALUE;
    }
  },
  cleanup: function cleanup() {
    if (!this.pdfDocument) {
      return;
    }

    this.pdfViewer.cleanup();
    this.pdfThumbnailViewer.cleanup();

    if (this.pdfViewer.renderer !== _ui_utils.RendererType.SVG) {
      this.pdfDocument.cleanup();
    }
  },
  forceRendering: function forceRendering() {
    this.pdfRenderingQueue.printing = this.printing;
    this.pdfRenderingQueue.isThumbnailViewEnabled = this.pdfSidebar.isThumbnailViewVisible;
    this.pdfRenderingQueue.renderHighestPriority();
  },
  beforePrint: function beforePrint() {
    var _this7 = this;

    if (this.printService) {
      return;
    }

    if (!this.supportsPrinting) {
      this.l10n.get('printing_not_supported', null, 'Warning: Printing is not fully supported by ' + 'this browser.').then(function (printMessage) {
        _this7.error(printMessage);
      });
      return;
    }

    if (!this.pdfViewer.pageViewsReady) {
      this.l10n.get('printing_not_ready', null, 'Warning: The PDF is not fully loaded for printing.').then(function (notReadyMessage) {
        window.alert(notReadyMessage);
      });
      return;
    }

    var pagesOverview = this.pdfViewer.getPagesOverview();
    var printContainer = this.appConfig.printContainer;
    var printService = PDFPrintServiceFactory.instance.createPrintService(this.pdfDocument, pagesOverview, printContainer, this.l10n);
    this.printService = printService;
    this.forceRendering();
    printService.layout();
  },
  afterPrint: function pdfViewSetupAfterPrint() {
    if (this.printService) {
      this.printService.destroy();
      this.printService = null;
    }

    this.forceRendering();
  },
  rotatePages: function rotatePages(delta) {
    if (!this.pdfDocument) {
      return;
    }

    var newRotation = (this.pdfViewer.pagesRotation + 360 + delta) % 360;
    this.pdfViewer.pagesRotation = newRotation;
  },
  requestPresentationMode: function requestPresentationMode() {
    if (!this.pdfPresentationMode) {
      return;
    }

    this.pdfPresentationMode.request();
  },
  bindEvents: function bindEvents() {
    var eventBus = this.eventBus,
        _boundEvents = this._boundEvents;
    _boundEvents.beforePrint = this.beforePrint.bind(this);
    _boundEvents.afterPrint = this.afterPrint.bind(this);
    eventBus.on('resize', webViewerResize);
    eventBus.on('hashchange', webViewerHashchange);
    eventBus.on('beforeprint', _boundEvents.beforePrint);
    eventBus.on('afterprint', _boundEvents.afterPrint);
    eventBus.on('pagerendered', webViewerPageRendered);
    eventBus.on('textlayerrendered', webViewerTextLayerRendered);
    eventBus.on('updateviewarea', webViewerUpdateViewarea);
    eventBus.on('pagechanging', webViewerPageChanging);
    eventBus.on('scalechanging', webViewerScaleChanging);
    eventBus.on('rotationchanging', webViewerRotationChanging);
    eventBus.on('sidebarviewchanged', webViewerSidebarViewChanged);
    eventBus.on('pagemode', webViewerPageMode);
    eventBus.on('namedaction', webViewerNamedAction);
    eventBus.on('presentationmodechanged', webViewerPresentationModeChanged);
    eventBus.on('presentationmode', webViewerPresentationMode);
    eventBus.on('openfile', webViewerOpenFile);
    eventBus.on('print', webViewerPrint);
    eventBus.on('download', webViewerDownload);
    eventBus.on('firstpage', webViewerFirstPage);
    eventBus.on('lastpage', webViewerLastPage);
    eventBus.on('nextpage', webViewerNextPage);
    eventBus.on('previouspage', webViewerPreviousPage);
    eventBus.on('zoomin', webViewerZoomIn);
    eventBus.on('zoomout', webViewerZoomOut);
    eventBus.on('pagenumberchanged', webViewerPageNumberChanged);
    eventBus.on('scalechanged', webViewerScaleChanged);
    eventBus.on('rotatecw', webViewerRotateCw);
    eventBus.on('rotateccw', webViewerRotateCcw);
    eventBus.on('switchscrollmode', webViewerSwitchScrollMode);
    eventBus.on('scrollmodechanged', webViewerScrollModeChanged);
    eventBus.on('switchspreadmode', webViewerSwitchSpreadMode);
    eventBus.on('spreadmodechanged', webViewerSpreadModeChanged);
    eventBus.on('documentproperties', webViewerDocumentProperties);
    eventBus.on('find', webViewerFind);
    eventBus.on('findfromurlhash', webViewerFindFromUrlHash);
    eventBus.on('updatefindmatchescount', webViewerUpdateFindMatchesCount);
    eventBus.on('updatefindcontrolstate', webViewerUpdateFindControlState);
    eventBus.on('fileinputchange', webViewerFileInputChange);
  },
  bindWindowEvents: function bindWindowEvents() {
    var eventBus = this.eventBus,
        _boundEvents = this._boundEvents;

    _boundEvents.windowResize = function () {
      eventBus.dispatch('resize', {
        source: window
      });
    };

    _boundEvents.windowHashChange = function () {
      eventBus.dispatch('hashchange', {
        source: window,
        hash: document.location.hash.substring(1)
      });
    };

    _boundEvents.windowBeforePrint = function () {
      eventBus.dispatch('beforeprint', {
        source: window
      });
    };

    _boundEvents.windowAfterPrint = function () {
      eventBus.dispatch('afterprint', {
        source: window
      });
    };

    window.addEventListener('visibilitychange', webViewerVisibilityChange);
    window.addEventListener('wheel', webViewerWheel);
    window.addEventListener('click', webViewerClick);
    window.addEventListener('keydown', webViewerKeyDown);
    window.addEventListener('resize', _boundEvents.windowResize);
    window.addEventListener('hashchange', _boundEvents.windowHashChange);
    window.addEventListener('beforeprint', _boundEvents.windowBeforePrint);
    window.addEventListener('afterprint', _boundEvents.windowAfterPrint);
  },
  unbindEvents: function unbindEvents() {
    var eventBus = this.eventBus,
        _boundEvents = this._boundEvents;
    eventBus.off('resize', webViewerResize);
    eventBus.off('hashchange', webViewerHashchange);
    eventBus.off('beforeprint', _boundEvents.beforePrint);
    eventBus.off('afterprint', _boundEvents.afterPrint);
    eventBus.off('pagerendered', webViewerPageRendered);
    eventBus.off('textlayerrendered', webViewerTextLayerRendered);
    eventBus.off('updateviewarea', webViewerUpdateViewarea);
    eventBus.off('pagechanging', webViewerPageChanging);
    eventBus.off('scalechanging', webViewerScaleChanging);
    eventBus.off('rotationchanging', webViewerRotationChanging);
    eventBus.off('sidebarviewchanged', webViewerSidebarViewChanged);
    eventBus.off('pagemode', webViewerPageMode);
    eventBus.off('namedaction', webViewerNamedAction);
    eventBus.off('presentationmodechanged', webViewerPresentationModeChanged);
    eventBus.off('presentationmode', webViewerPresentationMode);
    eventBus.off('openfile', webViewerOpenFile);
    eventBus.off('print', webViewerPrint);
    eventBus.off('download', webViewerDownload);
    eventBus.off('firstpage', webViewerFirstPage);
    eventBus.off('lastpage', webViewerLastPage);
    eventBus.off('nextpage', webViewerNextPage);
    eventBus.off('previouspage', webViewerPreviousPage);
    eventBus.off('zoomin', webViewerZoomIn);
    eventBus.off('zoomout', webViewerZoomOut);
    eventBus.off('pagenumberchanged', webViewerPageNumberChanged);
    eventBus.off('scalechanged', webViewerScaleChanged);
    eventBus.off('rotatecw', webViewerRotateCw);
    eventBus.off('rotateccw', webViewerRotateCcw);
    eventBus.off('switchscrollmode', webViewerSwitchScrollMode);
    eventBus.off('scrollmodechanged', webViewerScrollModeChanged);
    eventBus.off('switchspreadmode', webViewerSwitchSpreadMode);
    eventBus.off('spreadmodechanged', webViewerSpreadModeChanged);
    eventBus.off('documentproperties', webViewerDocumentProperties);
    eventBus.off('find', webViewerFind);
    eventBus.off('findfromurlhash', webViewerFindFromUrlHash);
    eventBus.off('updatefindmatchescount', webViewerUpdateFindMatchesCount);
    eventBus.off('updatefindcontrolstate', webViewerUpdateFindControlState);
    eventBus.off('fileinputchange', webViewerFileInputChange);
    _boundEvents.beforePrint = null;
    _boundEvents.afterPrint = null;
  },
  unbindWindowEvents: function unbindWindowEvents() {
    var _boundEvents = this._boundEvents;
    window.removeEventListener('visibilitychange', webViewerVisibilityChange);
    window.removeEventListener('wheel', webViewerWheel);
    window.removeEventListener('click', webViewerClick);
    window.removeEventListener('keydown', webViewerKeyDown);
    window.removeEventListener('resize', _boundEvents.windowResize);
    window.removeEventListener('hashchange', _boundEvents.windowHashChange);
    window.removeEventListener('beforeprint', _boundEvents.windowBeforePrint);
    window.removeEventListener('afterprint', _boundEvents.windowAfterPrint);
    _boundEvents.windowResize = null;
    _boundEvents.windowHashChange = null;
    _boundEvents.windowBeforePrint = null;
    _boundEvents.windowAfterPrint = null;
  }
};
exports.PDFViewerApplication = PDFViewerApplication;
var validateFileURL;
{
  var HOSTED_VIEWER_ORIGINS = ['null', 'http://mozilla.github.io', 'https://mozilla.github.io'];

  validateFileURL = function validateFileURL(file) {
    if (file === undefined) {
      return;
    }

    try {
      var viewerOrigin = new _pdfjsLib.URL(window.location.href).origin || 'null';

      if (HOSTED_VIEWER_ORIGINS.includes(viewerOrigin)) {
        return;
      }

      var _ref8 = new _pdfjsLib.URL(file, window.location.href),
          origin = _ref8.origin,
          protocol = _ref8.protocol;

      if (origin !== viewerOrigin && protocol !== 'blob:') {
        throw new Error('file origin does not match viewer\'s');
      }
    } catch (ex) {
      var message = ex && ex.message;
      PDFViewerApplication.l10n.get('loading_error', null, 'An error occurred while loading the PDF.').then(function (loadingErrorMessage) {
        PDFViewerApplication.error(loadingErrorMessage, {
          message: message
        });
      });
      throw ex;
    }
  };
}

function loadFakeWorker() {
  if (!_pdfjsLib.GlobalWorkerOptions.workerSrc) {
    _pdfjsLib.GlobalWorkerOptions.workerSrc = _app_options.AppOptions.get('workerSrc');
  }

  return (0, _pdfjsLib.loadScript)(_pdfjsLib.PDFWorker.getWorkerSrc());
}

function loadAndEnablePDFBug(enabledTabs) {
  var appConfig = PDFViewerApplication.appConfig;
  return (0, _pdfjsLib.loadScript)(appConfig.debuggerScriptPath).then(function () {
    PDFBug.enable(enabledTabs);
    PDFBug.init({
      OPS: _pdfjsLib.OPS,
      createObjectURL: _pdfjsLib.createObjectURL
    }, appConfig.mainContainer);
  });
}

function webViewerInitialized() {
  var appConfig = PDFViewerApplication.appConfig;
  var file;
  var queryString = document.location.search.substring(1);
  var params = (0, _ui_utils.parseQueryString)(queryString);
  file = 'file' in params ? params.file : _app_options.AppOptions.get('defaultUrl');
  validateFileURL(file);
  var fileInput = document.createElement('input');
  fileInput.id = appConfig.openFileInputName;
  fileInput.className = 'fileInput';
  fileInput.setAttribute('type', 'file');
  fileInput.oncontextmenu = _ui_utils.noContextMenuHandler;
  document.body.appendChild(fileInput);

  if (!window.File || !window.FileReader || !window.FileList || !window.Blob) {
    appConfig.toolbar.openFile.setAttribute('hidden', 'true');
    appConfig.secondaryToolbar.openFileButton.setAttribute('hidden', 'true');
  } else {
    fileInput.value = null;
  }

  fileInput.addEventListener('change', function (evt) {
    var files = evt.target.files;

    if (!files || files.length === 0) {
      return;
    }

    PDFViewerApplication.eventBus.dispatch('fileinputchange', {
      source: this,
      fileInput: evt.target
    });
  });
  appConfig.mainContainer.addEventListener('dragover', function (evt) {
    evt.preventDefault();
    evt.dataTransfer.dropEffect = 'move';
  });
  appConfig.mainContainer.addEventListener('drop', function (evt) {
    evt.preventDefault();
    var files = evt.dataTransfer.files;

    if (!files || files.length === 0) {
      return;
    }

    PDFViewerApplication.eventBus.dispatch('fileinputchange', {
      source: this,
      fileInput: evt.dataTransfer
    });
  });

  if (!PDFViewerApplication.supportsPrinting) {
    appConfig.toolbar.print.classList.add('hidden');
    appConfig.secondaryToolbar.printButton.classList.add('hidden');
  }

  if (!PDFViewerApplication.supportsFullscreen) {
    appConfig.toolbar.presentationModeButton.classList.add('hidden');
    appConfig.secondaryToolbar.presentationModeButton.classList.add('hidden');
  }

  if (PDFViewerApplication.supportsIntegratedFind) {
    appConfig.toolbar.viewFind.classList.add('hidden');
  }

  appConfig.mainContainer.addEventListener('transitionend', function (evt) {
    if (evt.target === this) {
      PDFViewerApplication.eventBus.dispatch('resize', {
        source: this
      });
    }
  }, true);
  appConfig.sidebar.toggleButton.addEventListener('click', function () {
    PDFViewerApplication.pdfSidebar.toggle();
  });

  try {
    webViewerOpenFileViaURL(file);
  } catch (reason) {
    PDFViewerApplication.l10n.get('loading_error', null, 'An error occurred while loading the PDF.').then(function (msg) {
      PDFViewerApplication.error(msg, reason);
    });
  }
}

var webViewerOpenFileViaURL;
{
  webViewerOpenFileViaURL = function webViewerOpenFileViaURL(file) {
    if (file && file.lastIndexOf('file:', 0) === 0) {
      PDFViewerApplication.setTitleUsingUrl(file);
      var xhr = new XMLHttpRequest();

      xhr.onload = function () {
        PDFViewerApplication.open(new Uint8Array(xhr.response));
      };

      xhr.open('GET', file);
      xhr.responseType = 'arraybuffer';
      xhr.send();
      return;
    }

    if (file) {
      PDFViewerApplication.open(file);
    }
  };
}

function webViewerPageRendered(evt) {
  var pageNumber = evt.pageNumber;
  var pageIndex = pageNumber - 1;
  var pageView = PDFViewerApplication.pdfViewer.getPageView(pageIndex);

  if (pageNumber === PDFViewerApplication.page) {
    PDFViewerApplication.toolbar.updateLoadingIndicatorState(false);
  }

  if (!pageView) {
    return;
  }

  if (PDFViewerApplication.pdfSidebar.isThumbnailViewVisible) {
    var thumbnailView = PDFViewerApplication.pdfThumbnailViewer.getThumbnail(pageIndex);
    thumbnailView.setImage(pageView);
  }

  if (typeof Stats !== 'undefined' && Stats.enabled && pageView.stats) {
    Stats.add(pageNumber, pageView.stats);
  }

  if (pageView.error) {
    PDFViewerApplication.l10n.get('rendering_error', null, 'An error occurred while rendering the page.').then(function (msg) {
      PDFViewerApplication.error(msg, pageView.error);
    });
  }
}

function webViewerTextLayerRendered(evt) {}

function webViewerPageMode(evt) {
  var mode = evt.mode,
      view;

  switch (mode) {
    case 'thumbs':
      view = _pdf_sidebar.SidebarView.THUMBS;
      break;

    case 'bookmarks':
    case 'outline':
      view = _pdf_sidebar.SidebarView.OUTLINE;
      break;

    case 'attachments':
      view = _pdf_sidebar.SidebarView.ATTACHMENTS;
      break;

    case 'none':
      view = _pdf_sidebar.SidebarView.NONE;
      break;

    default:
      console.error('Invalid "pagemode" hash parameter: ' + mode);
      return;
  }

  PDFViewerApplication.pdfSidebar.switchView(view, true);
}

function webViewerNamedAction(evt) {
  var action = evt.action;

  switch (action) {
    case 'GoToPage':
      PDFViewerApplication.appConfig.toolbar.pageNumber.select();
      break;

    case 'Find':
      if (!PDFViewerApplication.supportsIntegratedFind) {
        PDFViewerApplication.findBar.toggle();
      }

      break;
  }
}

function webViewerPresentationModeChanged(evt) {
  var active = evt.active,
      switchInProgress = evt.switchInProgress;
  PDFViewerApplication.pdfViewer.presentationModeState = switchInProgress ? _ui_utils.PresentationModeState.CHANGING : active ? _ui_utils.PresentationModeState.FULLSCREEN : _ui_utils.PresentationModeState.NORMAL;
}

function webViewerSidebarViewChanged(evt) {
  PDFViewerApplication.pdfRenderingQueue.isThumbnailViewEnabled = PDFViewerApplication.pdfSidebar.isThumbnailViewVisible;
  var store = PDFViewerApplication.store;

  if (store && PDFViewerApplication.isInitialViewSet) {
    store.set('sidebarView', evt.view).catch(function () {});
  }
}

function webViewerUpdateViewarea(evt) {
  var location = evt.location,
      store = PDFViewerApplication.store;

  if (store && PDFViewerApplication.isInitialViewSet) {
    store.setMultiple({
      'page': location.pageNumber,
      'zoom': location.scale,
      'scrollLeft': location.left,
      'scrollTop': location.top,
      'rotation': location.rotation
    }).catch(function () {});
  }

  var href = PDFViewerApplication.pdfLinkService.getAnchorUrl(location.pdfOpenParams);
  PDFViewerApplication.appConfig.toolbar.viewBookmark.href = href;
  PDFViewerApplication.appConfig.secondaryToolbar.viewBookmarkButton.href = href;
  var currentPage = PDFViewerApplication.pdfViewer.getPageView(PDFViewerApplication.page - 1);
  var loading = currentPage.renderingState !== _pdf_rendering_queue.RenderingStates.FINISHED;
  PDFViewerApplication.toolbar.updateLoadingIndicatorState(loading);
}

function webViewerScrollModeChanged(evt) {
  var store = PDFViewerApplication.store;

  if (store && PDFViewerApplication.isInitialViewSet) {
    store.set('scrollMode', evt.mode).catch(function () {});
  }
}

function webViewerSpreadModeChanged(evt) {
  var store = PDFViewerApplication.store;

  if (store && PDFViewerApplication.isInitialViewSet) {
    store.set('spreadMode', evt.mode).catch(function () {});
  }
}

function webViewerResize() {
  var pdfDocument = PDFViewerApplication.pdfDocument,
      pdfViewer = PDFViewerApplication.pdfViewer;

  if (!pdfDocument) {
    return;
  }

  var currentScaleValue = pdfViewer.currentScaleValue;

  if (currentScaleValue === 'auto' || currentScaleValue === 'page-fit' || currentScaleValue === 'page-width') {
    pdfViewer.currentScaleValue = currentScaleValue;
  }

  pdfViewer.update();
}

function webViewerHashchange(evt) {
  var hash = evt.hash;

  if (!hash) {
    return;
  }

  if (!PDFViewerApplication.isInitialViewSet) {
    PDFViewerApplication.initialBookmark = hash;
  } else if (!PDFViewerApplication.pdfHistory.popStateInProgress) {
    PDFViewerApplication.pdfLinkService.setHash(hash);
  }
}

var webViewerFileInputChange;
{
  webViewerFileInputChange = function webViewerFileInputChange(evt) {
    if (PDFViewerApplication.pdfViewer && PDFViewerApplication.pdfViewer.isInPresentationMode) {
      return;
    }

    var file = evt.fileInput.files[0];

    if (_pdfjsLib.URL.createObjectURL && !_app_options.AppOptions.get('disableCreateObjectURL')) {
      var url = _pdfjsLib.URL.createObjectURL(file);

      if (file.name) {
        url = {
          url: url,
          originalUrl: file.name
        };
      }

      PDFViewerApplication.open(url);
    } else {
      PDFViewerApplication.setTitleUsingUrl(file.name);
      var fileReader = new FileReader();

      fileReader.onload = function webViewerChangeFileReaderOnload(evt) {
        var buffer = evt.target.result;
        PDFViewerApplication.open(new Uint8Array(buffer));
      };

      fileReader.readAsArrayBuffer(file);
    }

    var appConfig = PDFViewerApplication.appConfig;
    appConfig.toolbar.viewBookmark.setAttribute('hidden', 'true');
    appConfig.secondaryToolbar.viewBookmarkButton.setAttribute('hidden', 'true');
    appConfig.toolbar.download.setAttribute('hidden', 'true');
    appConfig.secondaryToolbar.downloadButton.setAttribute('hidden', 'true');
  };
}

function webViewerPresentationMode() {
  PDFViewerApplication.requestPresentationMode();
}

function webViewerOpenFile() {
  var openFileInputName = PDFViewerApplication.appConfig.openFileInputName;
  document.getElementById(openFileInputName).click();
}

function webViewerPrint() {
  window.print();
}

function webViewerDownload() {
  PDFViewerApplication.download();
}

function webViewerFirstPage() {
  if (PDFViewerApplication.pdfDocument) {
    PDFViewerApplication.page = 1;
  }
}

function webViewerLastPage() {
  if (PDFViewerApplication.pdfDocument) {
    PDFViewerApplication.page = PDFViewerApplication.pagesCount;
  }
}

function webViewerNextPage() {
  PDFViewerApplication.page++;
}

function webViewerPreviousPage() {
  PDFViewerApplication.page--;
}

function webViewerZoomIn() {
  PDFViewerApplication.zoomIn();
}

function webViewerZoomOut() {
  PDFViewerApplication.zoomOut();
}

function webViewerPageNumberChanged(evt) {
  var pdfViewer = PDFViewerApplication.pdfViewer;

  if (evt.value !== '') {
    pdfViewer.currentPageLabel = evt.value;
  }

  if (evt.value !== pdfViewer.currentPageNumber.toString() && evt.value !== pdfViewer.currentPageLabel) {
    PDFViewerApplication.toolbar.setPageNumber(pdfViewer.currentPageNumber, pdfViewer.currentPageLabel);
  }
}

function webViewerScaleChanged(evt) {
  PDFViewerApplication.pdfViewer.currentScaleValue = evt.value;
}

function webViewerRotateCw() {
  PDFViewerApplication.rotatePages(90);
}

function webViewerRotateCcw() {
  PDFViewerApplication.rotatePages(-90);
}

function webViewerSwitchScrollMode(evt) {
  PDFViewerApplication.pdfViewer.scrollMode = evt.mode;
}

function webViewerSwitchSpreadMode(evt) {
  PDFViewerApplication.pdfViewer.spreadMode = evt.mode;
}

function webViewerDocumentProperties() {
  PDFViewerApplication.pdfDocumentProperties.open();
}

function webViewerFind(evt) {
  PDFViewerApplication.findController.executeCommand('find' + evt.type, {
    query: evt.query,
    phraseSearch: evt.phraseSearch,
    caseSensitive: evt.caseSensitive,
    entireWord: evt.entireWord,
    highlightAll: evt.highlightAll,
    findPrevious: evt.findPrevious
  });
}

function webViewerFindFromUrlHash(evt) {
  PDFViewerApplication.findController.executeCommand('find', {
    query: evt.query,
    phraseSearch: evt.phraseSearch,
    caseSensitive: false,
    entireWord: false,
    highlightAll: true,
    findPrevious: false
  });
}

function webViewerUpdateFindMatchesCount(_ref9) {
  var matchesCount = _ref9.matchesCount;

  if (PDFViewerApplication.supportsIntegratedFind) {
    PDFViewerApplication.externalServices.updateFindMatchesCount(matchesCount);
  } else {
    PDFViewerApplication.findBar.updateResultsCount(matchesCount);
  }
}

function webViewerUpdateFindControlState(_ref10) {
  var state = _ref10.state,
      previous = _ref10.previous,
      matchesCount = _ref10.matchesCount;

  if (PDFViewerApplication.supportsIntegratedFind) {
    PDFViewerApplication.externalServices.updateFindControlState({
      result: state,
      findPrevious: previous,
      matchesCount: matchesCount
    });
  } else {
    PDFViewerApplication.findBar.updateUIState(state, previous, matchesCount);
  }
}

function webViewerScaleChanging(evt) {
  PDFViewerApplication.toolbar.setPageScale(evt.presetValue, evt.scale);
  PDFViewerApplication.pdfViewer.update();
}

function webViewerRotationChanging(evt) {
  PDFViewerApplication.pdfThumbnailViewer.pagesRotation = evt.pagesRotation;
  PDFViewerApplication.forceRendering();
  PDFViewerApplication.pdfViewer.currentPageNumber = evt.pageNumber;
}

function webViewerPageChanging(evt) {
  var page = evt.pageNumber;
  PDFViewerApplication.toolbar.setPageNumber(page, evt.pageLabel || null);
  PDFViewerApplication.secondaryToolbar.setPageNumber(page);

  if (PDFViewerApplication.pdfSidebar.isThumbnailViewVisible) {
    PDFViewerApplication.pdfThumbnailViewer.scrollThumbnailIntoView(page);
  }

  if (typeof Stats !== 'undefined' && Stats.enabled) {
    var pageView = PDFViewerApplication.pdfViewer.getPageView(page - 1);

    if (pageView && pageView.stats) {
      Stats.add(page, pageView.stats);
    }
  }
  let pageNumberInput = document.getElementById('pageNumber');
  if (pageNumberInput) {
    var pageScrollEvent = new CustomEvent('page-change');
    pageNumberInput.dispatchEvent(pageScrollEvent);
  }
}

function webViewerVisibilityChange(evt) {
  if (document.visibilityState === 'visible') {
    setZoomDisabledTimeout();
  }
}

var zoomDisabledTimeout = null;

function setZoomDisabledTimeout() {
  if (zoomDisabledTimeout) {
    clearTimeout(zoomDisabledTimeout);
  }

  zoomDisabledTimeout = setTimeout(function () {
    zoomDisabledTimeout = null;
  }, WHEEL_ZOOM_DISABLED_TIMEOUT);
}

function webViewerWheel(evt) {
  var pdfViewer = PDFViewerApplication.pdfViewer;

  if (pdfViewer.isInPresentationMode) {
    return;
  }

  if (evt.ctrlKey || evt.metaKey) {
    var support = PDFViewerApplication.supportedMouseWheelZoomModifierKeys;

    if (evt.ctrlKey && !support.ctrlKey || evt.metaKey && !support.metaKey) {
      return;
    }

    evt.preventDefault();

    if (zoomDisabledTimeout || document.visibilityState === 'hidden') {
      return;
    }

    var previousScale = pdfViewer.currentScale;
    var delta = (0, _ui_utils.normalizeWheelEventDelta)(evt);
    var MOUSE_WHEEL_DELTA_PER_PAGE_SCALE = 3.0;
    var ticks = delta * MOUSE_WHEEL_DELTA_PER_PAGE_SCALE;

    if (ticks < 0) {
      PDFViewerApplication.zoomOut(-ticks);
    } else {
      PDFViewerApplication.zoomIn(ticks);
    }

    var currentScale = pdfViewer.currentScale;

    if (previousScale !== currentScale) {
      var scaleCorrectionFactor = currentScale / previousScale - 1;
      var rect = pdfViewer.container.getBoundingClientRect();
      var dx = evt.clientX - rect.left;
      var dy = evt.clientY - rect.top;
      pdfViewer.container.scrollLeft += dx * scaleCorrectionFactor;
      pdfViewer.container.scrollTop += dy * scaleCorrectionFactor;
    }
  } else {
    setZoomDisabledTimeout();
  }
}

function webViewerClick(evt) {
  if (!PDFViewerApplication.secondaryToolbar.isOpen) {
    return;
  }

  var appConfig = PDFViewerApplication.appConfig;

  if (PDFViewerApplication.pdfViewer.containsElement(evt.target) || appConfig.toolbar.container.contains(evt.target) && evt.target !== appConfig.secondaryToolbar.toggleButton) {
    PDFViewerApplication.secondaryToolbar.close();
  }
}

function webViewerKeyDown(evt) {
  if (PDFViewerApplication.overlayManager.active) {
    return;
  }

  var handled = false,
      ensureViewerFocused = false;
  var cmd = (evt.ctrlKey ? 1 : 0) | (evt.altKey ? 2 : 0) | (evt.shiftKey ? 4 : 0) | (evt.metaKey ? 8 : 0);
  var pdfViewer = PDFViewerApplication.pdfViewer;
  var isViewerInPresentationMode = pdfViewer && pdfViewer.isInPresentationMode;

  if (cmd === 1 || cmd === 8 || cmd === 5 || cmd === 12) {
    switch (evt.keyCode) {
      case 70:
        if (!PDFViewerApplication.supportsIntegratedFind) {
          PDFViewerApplication.findBar.open();
          handled = true;
        }

        break;

      case 71:
        if (!PDFViewerApplication.supportsIntegratedFind) {
          var findState = PDFViewerApplication.findController.state;

          if (findState) {
            PDFViewerApplication.findController.executeCommand('findagain', {
              query: findState.query,
              phraseSearch: findState.phraseSearch,
              caseSensitive: findState.caseSensitive,
              entireWord: findState.entireWord,
              highlightAll: findState.highlightAll,
              findPrevious: cmd === 5 || cmd === 12
            });
          }

          handled = true;
        }

        break;

      case 61:
      case 107:
      case 187:
      case 171:
        if (!isViewerInPresentationMode) {
          PDFViewerApplication.zoomIn();
        }

        handled = true;
        break;

      case 173:
      case 109:
      case 189:
        if (!isViewerInPresentationMode) {
          PDFViewerApplication.zoomOut();
        }

        handled = true;
        break;

      case 48:
      case 96:
        if (!isViewerInPresentationMode) {
          setTimeout(function () {
            pdfViewer.currentScaleValue = _ui_utils.DEFAULT_SCALE_VALUE;
          });
          handled = false;
        }

        break;

      case 38:
        if (isViewerInPresentationMode || PDFViewerApplication.page > 1) {
          PDFViewerApplication.page = 1;
          handled = true;
          ensureViewerFocused = true;
        }

        break;

      case 40:
        if (isViewerInPresentationMode || PDFViewerApplication.page < PDFViewerApplication.pagesCount) {
          PDFViewerApplication.page = PDFViewerApplication.pagesCount;
          handled = true;
          ensureViewerFocused = true;
        }

        break;
    }
  }

  if (cmd === 1 || cmd === 8) {
    switch (evt.keyCode) {
      case 83:
        PDFViewerApplication.download();
        handled = true;
        break;
    }
  }

  if (cmd === 3 || cmd === 10) {
    switch (evt.keyCode) {
      case 80:
        PDFViewerApplication.requestPresentationMode();
        handled = true;
        break;

      case 71:
        PDFViewerApplication.appConfig.toolbar.pageNumber.select();
        handled = true;
        break;
    }
  }

  if (handled) {
    if (ensureViewerFocused && !isViewerInPresentationMode) {
      pdfViewer.focus();
    }

    evt.preventDefault();
    return;
  }

  var curElement = document.activeElement || document.querySelector(':focus');
  var curElementTagName = curElement && curElement.tagName.toUpperCase();

  if (curElementTagName === 'INPUT' || curElementTagName === 'TEXTAREA' || curElementTagName === 'SELECT') {
    if (evt.keyCode !== 27) {
      return;
    }
  }

  if (cmd === 0) {
    var turnPage = 0,
        turnOnlyIfPageFit = false;

    switch (evt.keyCode) {
      case 38:
      case 33:
        if (pdfViewer.isVerticalScrollbarEnabled) {
          turnOnlyIfPageFit = true;
        }

        turnPage = -1;
        break;

      case 8:
        if (!isViewerInPresentationMode) {
          turnOnlyIfPageFit = true;
        }

        turnPage = -1;
        break;

      case 37:
        if (pdfViewer.isHorizontalScrollbarEnabled) {
          turnOnlyIfPageFit = true;
        }

      case 75:
      case 80:
        turnPage = -1;
        break;

      case 27:
        if (PDFViewerApplication.secondaryToolbar.isOpen) {
          PDFViewerApplication.secondaryToolbar.close();
          handled = true;
        }

        if (!PDFViewerApplication.supportsIntegratedFind && PDFViewerApplication.findBar.opened) {
          PDFViewerApplication.findBar.close();
          handled = true;
        }

        break;

      case 40:
      case 34:
        if (pdfViewer.isVerticalScrollbarEnabled) {
          turnOnlyIfPageFit = true;
        }

        turnPage = 1;
        break;

      case 13:
      case 32:
        if (!isViewerInPresentationMode) {
          turnOnlyIfPageFit = true;
        }

        turnPage = 1;
        break;

      case 39:
        if (pdfViewer.isHorizontalScrollbarEnabled) {
          turnOnlyIfPageFit = true;
        }

      case 74:
      case 78:
        turnPage = 1;
        break;

      case 36:
        if (isViewerInPresentationMode || PDFViewerApplication.page > 1) {
          PDFViewerApplication.page = 1;
          handled = true;
          ensureViewerFocused = true;
        }

        break;

      case 35:
        if (isViewerInPresentationMode || PDFViewerApplication.page < PDFViewerApplication.pagesCount) {
          PDFViewerApplication.page = PDFViewerApplication.pagesCount;
          handled = true;
          ensureViewerFocused = true;
        }

        break;

      case 83:
        PDFViewerApplication.pdfCursorTools.switchTool(_pdf_cursor_tools.CursorTool.SELECT);
        break;

      case 72:
        PDFViewerApplication.pdfCursorTools.switchTool(_pdf_cursor_tools.CursorTool.HAND);
        break;

      case 82:
        PDFViewerApplication.rotatePages(90);
        break;

      case 115:
        PDFViewerApplication.pdfSidebar.toggle();
        break;
    }

    if (turnPage !== 0 && (!turnOnlyIfPageFit || pdfViewer.currentScaleValue === 'page-fit')) {
      if (turnPage > 0) {
        if (PDFViewerApplication.page < PDFViewerApplication.pagesCount) {
          PDFViewerApplication.page++;
        }
      } else {
        if (PDFViewerApplication.page > 1) {
          PDFViewerApplication.page--;
        }
      }

      handled = true;
    }
  }

  if (cmd === 4) {
    switch (evt.keyCode) {
      case 13:
      case 32:
        if (!isViewerInPresentationMode && pdfViewer.currentScaleValue !== 'page-fit') {
          break;
        }

        if (PDFViewerApplication.page > 1) {
          PDFViewerApplication.page--;
        }

        handled = true;
        break;

      case 82:
        PDFViewerApplication.rotatePages(-90);
        break;
    }
  }

  if (!handled && !isViewerInPresentationMode) {
    if (evt.keyCode >= 33 && evt.keyCode <= 40 || evt.keyCode === 32 && curElementTagName !== 'BUTTON') {
      ensureViewerFocused = true;
    }
  }

  if (ensureViewerFocused && !pdfViewer.containsElement(curElement)) {
    pdfViewer.focus();
  }

  if (handled) {
    evt.preventDefault();
  }
}

function apiPageModeToSidebarView(mode) {
  switch (mode) {
    case 'UseNone':
      return _pdf_sidebar.SidebarView.NONE;

    case 'UseThumbs':
      return _pdf_sidebar.SidebarView.THUMBS;

    case 'UseOutlines':
      return _pdf_sidebar.SidebarView.OUTLINE;

    case 'UseAttachments':
      return _pdf_sidebar.SidebarView.ATTACHMENTS;

    case 'UseOC':
  }

  return _pdf_sidebar.SidebarView.NONE;
}

var PDFPrintServiceFactory = {
  instance: {
    supportsPrinting: false,
    createPrintService: function createPrintService() {
      throw new Error('Not implemented: createPrintService');
    }
  }
};
exports.PDFPrintServiceFactory = PDFPrintServiceFactory;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = __webpack_require__(3);

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var g = function () {
  return this || (typeof self === "undefined" ? "undefined" : _typeof(self)) === "object" && self;
}() || Function("return this")();

var hadRuntime = g.regeneratorRuntime && Object.getOwnPropertyNames(g).indexOf("regeneratorRuntime") >= 0;
var oldRuntime = hadRuntime && g.regeneratorRuntime;
g.regeneratorRuntime = undefined;
module.exports = __webpack_require__(4);

if (hadRuntime) {
  g.regeneratorRuntime = oldRuntime;
} else {
  try {
    delete g.regeneratorRuntime;
  } catch (e) {
    g.regeneratorRuntime = undefined;
  }
}

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(module) {

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

!function (global) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined;
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  var inModule = ( false ? undefined : _typeof(module)) === "object";
  var runtime = global.regeneratorRuntime;

  if (runtime) {
    if (inModule) {
      module.exports = runtime;
    }

    return;
  }

  runtime = global.regeneratorRuntime = inModule ? module.exports : {};

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);
    generator._invoke = makeInvokeMethod(innerFn, self, context);
    return generator;
  }

  runtime.wrap = wrap;

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};

  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

  if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      prototype[method] = function (arg) {
        return this._invoke(method, arg);
      };
    });
  }

  runtime.isGeneratorFunction = function (genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
  };

  runtime.mark = function (genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;

      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }

    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  runtime.awrap = function (arg) {
    return {
      __await: arg
    };
  };

  function AsyncIterator(generator) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;

        if (value && _typeof(value) === "object" && hasOwn.call(value, "__await")) {
          return Promise.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return Promise.resolve(value).then(function (unwrapped) {
          result.value = unwrapped;
          resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new Promise(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    }

    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);

  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };

  runtime.AsyncIterator = AsyncIterator;

  runtime.async = function (innerFn, outerFn, self, tryLocsList) {
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
    return runtime.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;
    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;

        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);

          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          context.sent = context._sent = context.arg;
        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);
        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;
        var record = tryCatch(innerFn, self, context);

        if (record.type === "normal") {
          state = context.done ? GenStateCompleted : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };
        } else if (record.type === "throw") {
          state = GenStateCompleted;
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (method === undefined) {
      context.delegate = null;

      if (context.method === "throw") {
        if (delegate.iterator.return) {
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (!info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      context[delegate.resultName] = info.value;
      context.next = delegate.nextLoc;

      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }
    } else {
      return info;
    }

    context.delegate = null;
    return ContinueSentinel;
  }

  defineIteratorMethods(Gp);
  Gp[toStringTagSymbol] = "Generator";

  Gp[iteratorSymbol] = function () {
    return this;
  };

  Gp.toString = function () {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  runtime.keys = function (object) {
    var keys = [];

    for (var key in object) {
      keys.push(key);
    }

    keys.reverse();
    return function next() {
      while (keys.length) {
        var key = keys.pop();

        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];

      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;
          return next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  runtime.values = values;

  function doneResult() {
    return {
      value: undefined,
      done: true
    };
  }

  Context.prototype = {
    constructor: Context,
    reset: function reset(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;
      this.method = "next";
      this.arg = undefined;
      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },
    stop: function stop() {
      this.done = true;
      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;

      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },
    dispatchException: function dispatchException(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;

      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          context.method = "next";
          context.arg = undefined;
        }

        return !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }
          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },
    abrupt: function abrupt(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },
    complete: function complete(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" || record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },
    finish: function finish(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },
    "catch": function _catch(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };
}(function () {
  return this || (typeof self === "undefined" ? "undefined" : _typeof(self)) === "object" && self;
}() || Function("return this")());
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(5)(module)))

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = function (module) {
  if (!module.webpackPolyfill) {
    module.deprecate = function () {};

    module.paths = [];
    if (!module.children) module.children = [];
    Object.defineProperty(module, "loaded", {
      enumerable: true,
      get: function get() {
        return module.l;
      }
    });
    Object.defineProperty(module, "id", {
      enumerable: true,
      get: function get() {
        return module.i;
      }
    });
    module.webpackPolyfill = 1;
  }

  return module;
};

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isValidRotation = isValidRotation;
exports.isValidScrollMode = isValidScrollMode;
exports.isValidSpreadMode = isValidSpreadMode;
exports.isPortraitOrientation = isPortraitOrientation;
exports.getGlobalEventBus = getGlobalEventBus;
exports.getPDFFileNameFromURL = getPDFFileNameFromURL;
exports.noContextMenuHandler = noContextMenuHandler;
exports.parseQueryString = parseQueryString;
exports.backtrackBeforeAllVisibleElements = backtrackBeforeAllVisibleElements;
exports.getVisibleElements = getVisibleElements;
exports.roundToDivide = roundToDivide;
exports.getPageSizeInches = getPageSizeInches;
exports.approximateFraction = approximateFraction;
exports.getOutputScale = getOutputScale;
exports.scrollIntoView = scrollIntoView;
exports.watchScroll = watchScroll;
exports.binarySearchFirstItem = binarySearchFirstItem;
exports.normalizeWheelEventDelta = normalizeWheelEventDelta;
exports.waitOnEventOrTimeout = waitOnEventOrTimeout;
exports.moveToEndOfArray = moveToEndOfArray;
exports.WaitOnType = exports.animationStarted = exports.ProgressBar = exports.EventBus = exports.NullL10n = exports.SpreadMode = exports.ScrollMode = exports.TextLayerMode = exports.RendererType = exports.PresentationModeState = exports.VERTICAL_PADDING = exports.SCROLLBAR_PADDING = exports.MAX_AUTO_SCALE = exports.UNKNOWN_SCALE = exports.MAX_SCALE = exports.MIN_SCALE = exports.DEFAULT_SCALE = exports.DEFAULT_SCALE_VALUE = exports.CSS_UNITS = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var CSS_UNITS = 96.0 / 72.0;
exports.CSS_UNITS = CSS_UNITS;
var DEFAULT_SCALE_VALUE = 'auto';
exports.DEFAULT_SCALE_VALUE = DEFAULT_SCALE_VALUE;
var DEFAULT_SCALE = 1.0;
exports.DEFAULT_SCALE = DEFAULT_SCALE;
var MIN_SCALE = 0.10;
exports.MIN_SCALE = MIN_SCALE;
var MAX_SCALE = 10.0;
exports.MAX_SCALE = MAX_SCALE;
var UNKNOWN_SCALE = 0;
exports.UNKNOWN_SCALE = UNKNOWN_SCALE;
var MAX_AUTO_SCALE = 1.25;
exports.MAX_AUTO_SCALE = MAX_AUTO_SCALE;
var SCROLLBAR_PADDING = 40;
exports.SCROLLBAR_PADDING = SCROLLBAR_PADDING;
var VERTICAL_PADDING = 5;
exports.VERTICAL_PADDING = VERTICAL_PADDING;
var PresentationModeState = {
  UNKNOWN: 0,
  NORMAL: 1,
  CHANGING: 2,
  FULLSCREEN: 3
};
exports.PresentationModeState = PresentationModeState;
var RendererType = {
  CANVAS: 'canvas',
  SVG: 'svg'
};
exports.RendererType = RendererType;
var TextLayerMode = {
  DISABLE: 0,
  ENABLE: 1,
  ENABLE_ENHANCE: 2
};
exports.TextLayerMode = TextLayerMode;
var ScrollMode = {
  UNKNOWN: -1,
  VERTICAL: 0,
  HORIZONTAL: 1,
  WRAPPED: 2
};
exports.ScrollMode = ScrollMode;
var SpreadMode = {
  UNKNOWN: -1,
  NONE: 0,
  ODD: 1,
  EVEN: 2
};
exports.SpreadMode = SpreadMode;

function formatL10nValue(text, args) {
  if (!args) {
    return text;
  }

  return text.replace(/\{\{\s*(\w+)\s*\}\}/g, function (all, name) {
    return name in args ? args[name] : '{{' + name + '}}';
  });
}

var NullL10n = {
  getLanguage: function () {
    var _getLanguage = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", 'en-us');

            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function getLanguage() {
      return _getLanguage.apply(this, arguments);
    }

    return getLanguage;
  }(),
  getDirection: function () {
    var _getDirection = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2() {
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", 'ltr');

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function getDirection() {
      return _getDirection.apply(this, arguments);
    }

    return getDirection;
  }(),
  get: function () {
    var _get = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee3(property, args, fallback) {
      return _regenerator.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.abrupt("return", formatL10nValue(fallback, args));

            case 1:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function get(_x, _x2, _x3) {
      return _get.apply(this, arguments);
    }

    return get;
  }(),
  translate: function () {
    var _translate = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee4(element) {
      return _regenerator.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function translate(_x4) {
      return _translate.apply(this, arguments);
    }

    return translate;
  }()
};
exports.NullL10n = NullL10n;

function getOutputScale(ctx) {
  var devicePixelRatio = window.devicePixelRatio || 1;
  var backingStoreRatio = ctx.webkitBackingStorePixelRatio || ctx.mozBackingStorePixelRatio || ctx.msBackingStorePixelRatio || ctx.oBackingStorePixelRatio || ctx.backingStorePixelRatio || 1;
  var pixelRatio = devicePixelRatio / backingStoreRatio;
  return {
    sx: pixelRatio,
    sy: pixelRatio,
    scaled: pixelRatio !== 1
  };
}

function scrollIntoView(element, spot) {
  var skipOverflowHiddenElements = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var parent = element.offsetParent;

  if (!parent) {
    console.error('offsetParent is not set -- cannot scroll');
    return;
  }

  var offsetY = element.offsetTop + element.clientTop;
  var offsetX = element.offsetLeft + element.clientLeft;

  while (parent.clientHeight === parent.scrollHeight && parent.clientWidth === parent.scrollWidth || skipOverflowHiddenElements && getComputedStyle(parent).overflow === 'hidden') {
    if (parent.dataset._scaleY) {
      offsetY /= parent.dataset._scaleY;
      offsetX /= parent.dataset._scaleX;
    }

    offsetY += parent.offsetTop;
    offsetX += parent.offsetLeft;
    parent = parent.offsetParent;

    if (!parent) {
      return;
    }
  }

  if (spot) {
    if (spot.top !== undefined) {
      offsetY += spot.top;
    }

    if (spot.left !== undefined) {
      offsetX += spot.left;
      parent.scrollLeft = offsetX;
    }
  }

  parent.scrollTop = offsetY;
}

function watchScroll(viewAreaElement, callback) {
  var debounceScroll = function debounceScroll(evt) {
    if (rAF) {
      return;
    }

    rAF = window.requestAnimationFrame(function viewAreaElementScrolled() {
      rAF = null;
      var currentX = viewAreaElement.scrollLeft;
      var lastX = state.lastX;

      if (currentX !== lastX) {
        state.right = currentX > lastX;
      }

      state.lastX = currentX;
      var currentY = viewAreaElement.scrollTop;
      var lastY = state.lastY;

      if (currentY !== lastY) {
        state.down = currentY > lastY;
      }

      state.lastY = currentY;
      callback(state);
    });
  };

  var state = {
    right: true,
    down: true,
    lastX: viewAreaElement.scrollLeft,
    lastY: viewAreaElement.scrollTop,
    _eventHandler: debounceScroll
  };
  var rAF = null;
  viewAreaElement.addEventListener('scroll', debounceScroll, true);
  return state;
}

function parseQueryString(query) {
  var parts = query.split('&');
  var params = Object.create(null);

  for (var i = 0, ii = parts.length; i < ii; ++i) {
    var param = parts[i].split('=');
    var key = param[0].toLowerCase();
    var value = param.length > 1 ? param[1] : null;
    params[decodeURIComponent(key)] = decodeURIComponent(value);
  }

  return params;
}

function binarySearchFirstItem(items, condition) {
  var minIndex = 0;
  var maxIndex = items.length - 1;

  if (items.length === 0 || !condition(items[maxIndex])) {
    return items.length;
  }

  if (condition(items[minIndex])) {
    return minIndex;
  }

  while (minIndex < maxIndex) {
    var currentIndex = minIndex + maxIndex >> 1;
    var currentItem = items[currentIndex];

    if (condition(currentItem)) {
      maxIndex = currentIndex;
    } else {
      minIndex = currentIndex + 1;
    }
  }

  return minIndex;
}

function approximateFraction(x) {
  if (Math.floor(x) === x) {
    return [x, 1];
  }

  var xinv = 1 / x;
  var limit = 8;

  if (xinv > limit) {
    return [1, limit];
  } else if (Math.floor(xinv) === xinv) {
    return [1, xinv];
  }

  var x_ = x > 1 ? xinv : x;
  var a = 0,
      b = 1,
      c = 1,
      d = 1;

  while (true) {
    var p = a + c,
        q = b + d;

    if (q > limit) {
      break;
    }

    if (x_ <= p / q) {
      c = p;
      d = q;
    } else {
      a = p;
      b = q;
    }
  }

  var result;

  if (x_ - a / b < c / d - x_) {
    result = x_ === x ? [a, b] : [b, a];
  } else {
    result = x_ === x ? [c, d] : [d, c];
  }

  return result;
}

function roundToDivide(x, div) {
  var r = x % div;
  return r === 0 ? x : Math.round(x - r + div);
}

function getPageSizeInches(_ref) {
  var view = _ref.view,
      userUnit = _ref.userUnit,
      rotate = _ref.rotate;

  var _view = _slicedToArray(view, 4),
      x1 = _view[0],
      y1 = _view[1],
      x2 = _view[2],
      y2 = _view[3];

  var changeOrientation = rotate % 180 !== 0;
  var width = (x2 - x1) / 72 * userUnit;
  var height = (y2 - y1) / 72 * userUnit;
  return {
    width: changeOrientation ? height : width,
    height: changeOrientation ? width : height
  };
}

function backtrackBeforeAllVisibleElements(index, views, top) {
  if (index < 2) {
    return index;
  }

  var elt = views[index].div;
  var pageTop = elt.offsetTop + elt.clientTop;

  if (pageTop >= top) {
    elt = views[index - 1].div;
    pageTop = elt.offsetTop + elt.clientTop;
  }

  for (var i = index - 2; i >= 0; --i) {
    elt = views[i].div;

    if (elt.offsetTop + elt.clientTop + elt.clientHeight <= pageTop) {
      break;
    }

    index = i;
  }

  return index;
}

function getVisibleElements(scrollEl, views) {
  var sortByVisibility = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var horizontal = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  var top = scrollEl.scrollTop,
      bottom = top + scrollEl.clientHeight;
  var left = scrollEl.scrollLeft,
      right = left + scrollEl.clientWidth;

  function isElementBottomAfterViewTop(view) {
    var element = view.div;
    var elementBottom = element.offsetTop + element.clientTop + element.clientHeight;
    return elementBottom > top;
  }

  function isElementRightAfterViewLeft(view) {
    var element = view.div;
    var elementRight = element.offsetLeft + element.clientLeft + element.clientWidth;
    return elementRight > left;
  }

  var visible = [],
      numViews = views.length;
  var firstVisibleElementInd = numViews === 0 ? 0 : binarySearchFirstItem(views, horizontal ? isElementRightAfterViewLeft : isElementBottomAfterViewTop);

  if (firstVisibleElementInd > 0 && firstVisibleElementInd < numViews && !horizontal) {
    firstVisibleElementInd = backtrackBeforeAllVisibleElements(firstVisibleElementInd, views, top);
  }

  var lastEdge = horizontal ? right : -1;

  for (var i = firstVisibleElementInd; i < numViews; i++) {
    var view = views[i],
        element = view.div;
    var currentWidth = element.offsetLeft + element.clientLeft;
    var currentHeight = element.offsetTop + element.clientTop;
    var viewWidth = element.clientWidth,
        viewHeight = element.clientHeight;
    var viewRight = currentWidth + viewWidth;
    var viewBottom = currentHeight + viewHeight;

    if (lastEdge === -1) {
      if (viewBottom >= bottom) {
        lastEdge = viewBottom;
      }
    } else if ((horizontal ? currentWidth : currentHeight) > lastEdge) {
      break;
    }

    if (viewBottom <= top || currentHeight >= bottom || viewRight <= left || currentWidth >= right) {
      continue;
    }

    var hiddenHeight = Math.max(0, top - currentHeight) + Math.max(0, viewBottom - bottom);
    var hiddenWidth = Math.max(0, left - currentWidth) + Math.max(0, viewRight - right);
    var percent = (viewHeight - hiddenHeight) * (viewWidth - hiddenWidth) * 100 / viewHeight / viewWidth | 0;
    visible.push({
      id: view.id,
      x: currentWidth,
      y: currentHeight,
      view: view,
      percent: percent
    });
  }

  var first = visible[0],
      last = visible[visible.length - 1];

  if (sortByVisibility) {
    visible.sort(function (a, b) {
      var pc = a.percent - b.percent;

      if (Math.abs(pc) > 0.001) {
        return -pc;
      }

      return a.id - b.id;
    });
  }

  return {
    first: first,
    last: last,
    views: visible
  };
}

function noContextMenuHandler(evt) {
  evt.preventDefault();
}

function isDataSchema(url) {
  var i = 0,
      ii = url.length;

  while (i < ii && url[i].trim() === '') {
    i++;
  }

  return url.substring(i, i + 5).toLowerCase() === 'data:';
}

function getPDFFileNameFromURL(url) {
  var defaultFilename = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : PDFViewerApplication.appConfig.filenameForDownload;
  if (PDFViewerApplication.appConfig.filenameForDownload) return PDFViewerApplication.appConfig.filenameForDownload;

  if (typeof url !== 'string') {
    return defaultFilename;
  }

  if (isDataSchema(url)) {
    console.warn('getPDFFileNameFromURL: ' + 'ignoring "data:" URL for performance reasons.');
    return defaultFilename;
  }

  var reURI = /^(?:(?:[^:]+:)?\/\/[^\/]+)?([^?#]*)(\?[^#]*)?(#.*)?$/;
  var reFilename = /[^\/?#=]+\.pdf\b(?!.*\.pdf\b)/i;
  var splitURI = reURI.exec(url);
  var suggestedFilename = reFilename.exec(splitURI[1]) || reFilename.exec(splitURI[2]) || reFilename.exec(splitURI[3]);

  if (suggestedFilename) {
    suggestedFilename = suggestedFilename[0];

    if (suggestedFilename.includes('%')) {
      try {
        suggestedFilename = reFilename.exec(decodeURIComponent(suggestedFilename))[0];
      } catch (ex) {}
    }
  }

  return suggestedFilename || defaultFilename;
}

function normalizeWheelEventDelta(evt) {
  var delta = Math.sqrt(evt.deltaX * evt.deltaX + evt.deltaY * evt.deltaY);
  var angle = Math.atan2(evt.deltaY, evt.deltaX);

  if (-0.25 * Math.PI < angle && angle < 0.75 * Math.PI) {
    delta = -delta;
  }

  var MOUSE_DOM_DELTA_PIXEL_MODE = 0;
  var MOUSE_DOM_DELTA_LINE_MODE = 1;
  var MOUSE_PIXELS_PER_LINE = 30;
  var MOUSE_LINES_PER_PAGE = 30;

  if (evt.deltaMode === MOUSE_DOM_DELTA_PIXEL_MODE) {
    delta /= MOUSE_PIXELS_PER_LINE * MOUSE_LINES_PER_PAGE;
  } else if (evt.deltaMode === MOUSE_DOM_DELTA_LINE_MODE) {
    delta /= MOUSE_LINES_PER_PAGE;
  }

  return delta;
}

function isValidRotation(angle) {
  return Number.isInteger(angle) && angle % 90 === 0;
}

function isValidScrollMode(mode) {
  return Number.isInteger(mode) && Object.values(ScrollMode).includes(mode) && mode !== ScrollMode.UNKNOWN;
}

function isValidSpreadMode(mode) {
  return Number.isInteger(mode) && Object.values(SpreadMode).includes(mode) && mode !== SpreadMode.UNKNOWN;
}

function isPortraitOrientation(size) {
  return size.width <= size.height;
}

var WaitOnType = {
  EVENT: 'event',
  TIMEOUT: 'timeout'
};
exports.WaitOnType = WaitOnType;

function waitOnEventOrTimeout(_ref2) {
  var target = _ref2.target,
      name = _ref2.name,
      _ref2$delay = _ref2.delay,
      delay = _ref2$delay === void 0 ? 0 : _ref2$delay;
  return new Promise(function (resolve, reject) {
    if (_typeof(target) !== 'object' || !(name && typeof name === 'string') || !(Number.isInteger(delay) && delay >= 0)) {
      throw new Error('waitOnEventOrTimeout - invalid parameters.');
    }

    function handler(type) {
      if (target instanceof EventBus) {
        target.off(name, eventHandler);
      } else {
        target.removeEventListener(name, eventHandler);
      }

      if (timeout) {
        clearTimeout(timeout);
      }

      resolve(type);
    }

    var eventHandler = handler.bind(null, WaitOnType.EVENT);

    if (target instanceof EventBus) {
      target.on(name, eventHandler);
    } else {
      target.addEventListener(name, eventHandler);
    }

    var timeoutHandler = handler.bind(null, WaitOnType.TIMEOUT);
    var timeout = setTimeout(timeoutHandler, delay);
  });
}

var animationStarted = new Promise(function (resolve) {
  window.requestAnimationFrame(resolve);
});
exports.animationStarted = animationStarted;

var EventBus =
/*#__PURE__*/
function () {
  function EventBus() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref3$dispatchToDOM = _ref3.dispatchToDOM,
        dispatchToDOM = _ref3$dispatchToDOM === void 0 ? false : _ref3$dispatchToDOM;

    _classCallCheck(this, EventBus);

    this._listeners = Object.create(null);
    this._dispatchToDOM = dispatchToDOM === true;
  }

  _createClass(EventBus, [{
    key: "on",
    value: function on(eventName, listener) {
      var eventListeners = this._listeners[eventName];

      if (!eventListeners) {
        eventListeners = [];
        this._listeners[eventName] = eventListeners;
      }

      eventListeners.push(listener);
    }
  }, {
    key: "off",
    value: function off(eventName, listener) {
      var eventListeners = this._listeners[eventName];
      var i;

      if (!eventListeners || (i = eventListeners.indexOf(listener)) < 0) {
        return;
      }

      eventListeners.splice(i, 1);
    }
  }, {
    key: "dispatch",
    value: function dispatch(eventName) {
      var eventListeners = this._listeners[eventName];

      if (!eventListeners || eventListeners.length === 0) {
        if (this._dispatchToDOM) {
          var _args5 = Array.prototype.slice.call(arguments, 1);

          this._dispatchDOMEvent(eventName, _args5);
        }

        return;
      }

      var args = Array.prototype.slice.call(arguments, 1);
      eventListeners.slice(0).forEach(function (listener) {
        listener.apply(null, args);
      });

      if (this._dispatchToDOM) {
        this._dispatchDOMEvent(eventName, args);
      }
    }
  }, {
    key: "_dispatchDOMEvent",
    value: function _dispatchDOMEvent(eventName) {
      var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var details = Object.create(null);

      if (args && args.length > 0) {
        var obj = args[0];

        for (var key in obj) {
          var value = obj[key];

          if (key === 'source') {
            if (value === window || value === document) {
              return;
            }

            continue;
          }

          details[key] = value;
        }
      }

      var event = document.createEvent('CustomEvent');
      event.initCustomEvent(eventName, true, true, details);
      document.dispatchEvent(event);
    }
  }]);

  return EventBus;
}();

exports.EventBus = EventBus;
var globalEventBus = null;

function getGlobalEventBus() {
  var dispatchToDOM = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

  if (!globalEventBus) {
    globalEventBus = new EventBus({
      dispatchToDOM: dispatchToDOM
    });
  }

  return globalEventBus;
}

function clamp(v, min, max) {
  return Math.min(Math.max(v, min), max);
}

var ProgressBar =
/*#__PURE__*/
function () {
  function ProgressBar(id) {
    var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        height = _ref4.height,
        width = _ref4.width,
        units = _ref4.units;

    _classCallCheck(this, ProgressBar);

    this.visible = true;
    this.div = document.querySelector(id + ' .progress');
    if (this.div) {
      this.bar = this.div.parentNode;
    }
    this.height = height || 100;
    this.width = width || 100;
    this.units = units || '%';
    if (this.div) {
      this.div.style.height = this.height + this.units;
    }
    this.percent = 0;
  }

  _createClass(ProgressBar, [{
    key: "_updateBar",
    value: function _updateBar() {
      if (this._indeterminate) {
        this.div.classList.add('indeterminate');
        this.div.style.width = this.width + this.units;
        return;
      }

      if (this.div) {
        this.div.classList.remove('indeterminate');
      }
      var progressSize = this.width * this._percent / 100;
      if (this.div) {
        this.div.style.width = progressSize + this.units;
      }
    }
  }, {
    key: "setWidth",
    value: function setWidth(viewer) {
      if (!viewer) {
        return;
      }

      var container = viewer.parentNode;
      var scrollbarWidth = container.offsetWidth - viewer.offsetWidth;

      if (scrollbarWidth > 0) {
        this.bar.setAttribute('style', 'width: calc(100% - ' + scrollbarWidth + 'px);');
      }
    }
  }, {
    key: "hide",
    value: function hide() {
      // if (!this.visible) { // commented
      // return; // commented
      // } // uncommented
      this.visible = false;
      this.div = document.querySelector('.progress'); // always set this new instead of trying to cache this value
      if (this.div) {
        this.bar = this.div.parentNode; // always set this new instead of trying to cache this value
        this.bar.classList.add('hidden');
      }
      document.body.classList.remove('loadingInProgress');
    }
  }, {
    key: "show",
    value: function show() {
      if (this.visible) {
        return;
      }

      this.visible = true;
      document.body.classList.add('loadingInProgress');
      this.bar.classList.remove('hidden');
    }
  }, {
    key: "percent",
    get: function get() {
      return this._percent;
    },
    set: function set(val) {
      this._indeterminate = isNaN(val);
      this._percent = clamp(val, 0, 100);

      this._updateBar();
    }
  }]);

  return ProgressBar;
}();

exports.ProgressBar = ProgressBar;

function moveToEndOfArray(arr, condition) {
  var moved = [],
      len = arr.length;
  var write = 0;

  for (var read = 0; read < len; ++read) {
    if (condition(arr[read])) {
      moved.push(arr[read]);
    } else {
      arr[write] = arr[read];
      ++write;
    }
  }

  for (var _read = 0; write < len; ++_read, ++write) {
    arr[write] = moved[_read];
  }
}

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var pdfjsLib;

if (typeof window !== 'undefined' && window['pdfjs-dist/build/pdf']) {
  pdfjsLib = window['pdfjs-dist/build/pdf'];
} else {
  pdfjsLib = __webpack_require__(760);
}

module.exports = pdfjsLib;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFCursorTools = exports.CursorTool = void 0;

var _grab_to_pan = __webpack_require__(9);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var CursorTool = {
  SELECT: 0,
  HAND: 1,
  ZOOM: 2
};
exports.CursorTool = CursorTool;

var PDFCursorTools =
/*#__PURE__*/
function () {
  function PDFCursorTools(_ref) {
    var _this = this;

    var container = _ref.container,
        eventBus = _ref.eventBus,
        _ref$cursorToolOnLoad = _ref.cursorToolOnLoad,
        cursorToolOnLoad = _ref$cursorToolOnLoad === void 0 ? CursorTool.SELECT : _ref$cursorToolOnLoad;

    _classCallCheck(this, PDFCursorTools);

    this.container = container;
    this.eventBus = eventBus;
    this.active = CursorTool.SELECT;
    this.activeBeforePresentationMode = null;
    this.handTool = new _grab_to_pan.GrabToPan({
      element: this.container
    });

    this._addEventListeners();

    Promise.resolve().then(function () {
      _this.switchTool(cursorToolOnLoad);
    });
  }

  _createClass(PDFCursorTools, [{
    key: "switchTool",
    value: function switchTool(tool) {
      var _this2 = this;

      if (this.activeBeforePresentationMode !== null) {
        return;
      }

      if (tool === this.active) {
        return;
      }

      var disableActiveTool = function disableActiveTool() {
        switch (_this2.active) {
          case CursorTool.SELECT:
            break;

          case CursorTool.HAND:
            _this2.handTool.deactivate();

            break;

          case CursorTool.ZOOM:
        }
      };

      switch (tool) {
        case CursorTool.SELECT:
          disableActiveTool();
          break;

        case CursorTool.HAND:
          disableActiveTool();
          this.handTool.activate();
          break;

        case CursorTool.ZOOM:
        default:
          console.error("switchTool: \"".concat(tool, "\" is an unsupported value."));
          return;
      }

      this.active = tool;

      this._dispatchEvent();
    }
  }, {
    key: "_dispatchEvent",
    value: function _dispatchEvent() {
      this.eventBus.dispatch('cursortoolchanged', {
        source: this,
        tool: this.active
      });
    }
  }, {
    key: "_addEventListeners",
    value: function _addEventListeners() {
      var _this3 = this;

      this.eventBus.on('switchcursortool', function (evt) {
        _this3.switchTool(evt.tool);
      });
      this.eventBus.on('presentationmodechanged', function (evt) {
        if (evt.switchInProgress) {
          return;
        }

        var previouslyActive;

        if (evt.active) {
          previouslyActive = _this3.active;

          _this3.switchTool(CursorTool.SELECT);

          _this3.activeBeforePresentationMode = previouslyActive;
        } else {
          previouslyActive = _this3.activeBeforePresentationMode;
          _this3.activeBeforePresentationMode = null;

          _this3.switchTool(previouslyActive);
        }
      });
    }
  }, {
    key: "activeTool",
    get: function get() {
      return this.active;
    }
  }]);

  return PDFCursorTools;
}();

exports.PDFCursorTools = PDFCursorTools;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GrabToPan = GrabToPan;

function GrabToPan(options) {
  this.element = options.element;
  this.document = options.element.ownerDocument;

  if (typeof options.ignoreTarget === 'function') {
    this.ignoreTarget = options.ignoreTarget;
  }

  this.onActiveChanged = options.onActiveChanged;
  this.activate = this.activate.bind(this);
  this.deactivate = this.deactivate.bind(this);
  this.toggle = this.toggle.bind(this);
  this._onmousedown = this._onmousedown.bind(this);
  this._onmousemove = this._onmousemove.bind(this);
  this._endPan = this._endPan.bind(this);
  var overlay = this.overlay = document.createElement('div');
  overlay.className = 'grab-to-pan-grabbing';
}

GrabToPan.prototype = {
  CSS_CLASS_GRAB: 'grab-to-pan-grab',
  activate: function GrabToPan_activate() {
    if (!this.active) {
      this.active = true;
      this.element.addEventListener('mousedown', this._onmousedown, true);
      this.element.classList.add(this.CSS_CLASS_GRAB);

      if (this.onActiveChanged) {
        this.onActiveChanged(true);
      }
    }
  },
  deactivate: function GrabToPan_deactivate() {
    if (this.active) {
      this.active = false;
      this.element.removeEventListener('mousedown', this._onmousedown, true);

      this._endPan();

      this.element.classList.remove(this.CSS_CLASS_GRAB);

      if (this.onActiveChanged) {
        this.onActiveChanged(false);
      }
    }
  },
  toggle: function GrabToPan_toggle() {
    if (this.active) {
      this.deactivate();
    } else {
      this.activate();
    }
  },
  ignoreTarget: function GrabToPan_ignoreTarget(node) {
    return node[matchesSelector]('a[href], a[href] *, input, textarea, button, button *, select, option');
  },
  _onmousedown: function GrabToPan__onmousedown(event) {
    if (event.button !== 0 || this.ignoreTarget(event.target)) {
      return;
    }

    if (event.originalTarget) {
      try {
        event.originalTarget.tagName;
      } catch (e) {
        return;
      }
    }

    this.scrollLeftStart = this.element.scrollLeft;
    this.scrollTopStart = this.element.scrollTop;
    this.clientXStart = event.clientX;
    this.clientYStart = event.clientY;
    this.document.addEventListener('mousemove', this._onmousemove, true);
    this.document.addEventListener('mouseup', this._endPan, true);
    this.element.addEventListener('scroll', this._endPan, true);
    event.preventDefault();
    event.stopPropagation();
    var focusedElement = document.activeElement;

    if (focusedElement && !focusedElement.contains(event.target)) {
      focusedElement.blur();
    }
  },
  _onmousemove: function GrabToPan__onmousemove(event) {
    this.element.removeEventListener('scroll', this._endPan, true);

    if (isLeftMouseReleased(event)) {
      this._endPan();

      return;
    }

    var xDiff = event.clientX - this.clientXStart;
    var yDiff = event.clientY - this.clientYStart;
    var scrollTop = this.scrollTopStart - yDiff;
    var scrollLeft = this.scrollLeftStart - xDiff;

    if (this.element.scrollTo) {
      this.element.scrollTo({
        top: scrollTop,
        left: scrollLeft,
        behavior: 'instant'
      });
    } else {
      this.element.scrollTop = scrollTop;
      this.element.scrollLeft = scrollLeft;
    }

    if (!this.overlay.parentNode) {
      document.body.appendChild(this.overlay);
    }
  },
  _endPan: function GrabToPan__endPan() {
    this.element.removeEventListener('scroll', this._endPan, true);
    this.document.removeEventListener('mousemove', this._onmousemove, true);
    this.document.removeEventListener('mouseup', this._endPan, true);
    this.overlay.remove();
  }
};
var matchesSelector;
['webkitM', 'mozM', 'msM', 'oM', 'm'].some(function (prefix) {
  var name = prefix + 'atches';

  if (name in document.documentElement) {
    matchesSelector = name;
  }

  name += 'Selector';

  if (name in document.documentElement) {
    matchesSelector = name;
  }

  return matchesSelector;
});
var isNotIEorIsIE10plus = !document.documentMode || document.documentMode > 9;
var chrome = window.chrome;
var isChrome15OrOpera15plus = chrome && (chrome.webstore || chrome.app);
var isSafari6plus = /Apple/.test(navigator.vendor) && /Version\/([6-9]\d*|[1-5]\d+)/.test(navigator.userAgent);

function isLeftMouseReleased(event) {
  if ('buttons' in event && isNotIEorIsIE10plus) {
    return !(event.buttons & 1);
  }

  if (isChrome15OrOpera15plus || isSafari6plus) {
    return event.which === 0;
  }
}

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFRenderingQueue = exports.RenderingStates = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var CLEANUP_TIMEOUT = 30000;
var RenderingStates = {
  INITIAL: 0,
  RUNNING: 1,
  PAUSED: 2,
  FINISHED: 3
};
exports.RenderingStates = RenderingStates;

var PDFRenderingQueue =
/*#__PURE__*/
function () {
  function PDFRenderingQueue() {
    _classCallCheck(this, PDFRenderingQueue);

    this.pdfViewer = null;
    this.pdfThumbnailViewer = null;
    this.onIdle = null;
    this.highestPriorityPage = null;
    this.idleTimeout = null;
    this.printing = false;
    this.isThumbnailViewEnabled = false;
  }

  _createClass(PDFRenderingQueue, [{
    key: "setViewer",
    value: function setViewer(pdfViewer) {
      this.pdfViewer = pdfViewer;
    }
  }, {
    key: "setThumbnailViewer",
    value: function setThumbnailViewer(pdfThumbnailViewer) {
      this.pdfThumbnailViewer = pdfThumbnailViewer;
    }
  }, {
    key: "isHighestPriority",
    value: function isHighestPriority(view) {
      return this.highestPriorityPage === view.renderingId;
    }
  }, {
    key: "renderHighestPriority",
    value: function renderHighestPriority(currentlyVisiblePages) {
      if (this.idleTimeout) {
        clearTimeout(this.idleTimeout);
        this.idleTimeout = null;
      }

      if (this.pdfViewer.forceRendering(currentlyVisiblePages)) {
        return;
      }

      if (this.pdfThumbnailViewer && this.isThumbnailViewEnabled) {
        if (this.pdfThumbnailViewer.forceRendering()) {
          return;
        }
      }

      if (this.printing) {
        return;
      }

      if (this.onIdle) {
        this.idleTimeout = setTimeout(this.onIdle.bind(this), CLEANUP_TIMEOUT);
      }
    }
  }, {
    key: "getHighestPriority",
    value: function getHighestPriority(visible, views, scrolledDown) {
      var visibleViews = visible.views;
      var numVisible = visibleViews.length;

      if (numVisible === 0) {
        return false;
      }

      for (var i = 0; i < numVisible; ++i) {
        var view = visibleViews[i].view;

        if (!this.isViewFinished(view)) {
          return view;
        }
      }

      if (scrolledDown) {
        var nextPageIndex = visible.last.id;

        if (views[nextPageIndex] && !this.isViewFinished(views[nextPageIndex])) {
          return views[nextPageIndex];
        }
      } else {
        var previousPageIndex = visible.first.id - 2;

        if (views[previousPageIndex] && !this.isViewFinished(views[previousPageIndex])) {
          return views[previousPageIndex];
        }
      }

      return null;
    }
  }, {
    key: "isViewFinished",
    value: function isViewFinished(view) {
      return view.renderingState === RenderingStates.FINISHED;
    }
  }, {
    key: "renderView",
    value: function renderView(view) {
      var _this = this;

      switch (view.renderingState) {
        case RenderingStates.FINISHED:
          return false;

        case RenderingStates.PAUSED:
          this.highestPriorityPage = view.renderingId;
          view.resume();
          break;

        case RenderingStates.RUNNING:
          this.highestPriorityPage = view.renderingId;
          break;

        case RenderingStates.INITIAL:
          this.highestPriorityPage = view.renderingId;

          var continueRendering = function continueRendering() {
            _this.renderHighestPriority();
          };

          view.draw().then(continueRendering, continueRendering);
          break;
      }

      return true;
    }
  }]);

  return PDFRenderingQueue;
}();

exports.PDFRenderingQueue = PDFRenderingQueue;

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFSidebar = exports.SidebarView = void 0;

var _ui_utils = __webpack_require__(6);

var _pdf_rendering_queue = __webpack_require__(10);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var UI_NOTIFICATION_CLASS = 'pdfSidebarNotification';
var SidebarView = {
  UNKNOWN: -1,
  NONE: 0,
  THUMBS: 1,
  OUTLINE: 2,
  ATTACHMENTS: 3,
  LAYERS: 4
};
exports.SidebarView = SidebarView;

var PDFSidebar =
/*#__PURE__*/
function () {
  function PDFSidebar(options, eventBus) {
    var l10n = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _ui_utils.NullL10n;

    _classCallCheck(this, PDFSidebar);

    this.isOpen = false;
    this.active = SidebarView.THUMBS;
    this.isInitialViewSet = false;
    this.onToggled = null;
    this.pdfViewer = options.pdfViewer;
    this.pdfThumbnailViewer = options.pdfThumbnailViewer;
    this.outerContainer = options.outerContainer;
    this.viewerContainer = options.viewerContainer;
    this.toggleButton = options.toggleButton;
    this.thumbnailButton = options.thumbnailButton;
    this.outlineButton = options.outlineButton;
    this.attachmentsButton = options.attachmentsButton;
    this.thumbnailView = options.thumbnailView;
    this.outlineView = options.outlineView;
    this.attachmentsView = options.attachmentsView;
    this.disableNotification = options.disableNotification || false;
    this.eventBus = eventBus;
    this.l10n = l10n;

    this._addEventListeners();
  }

  _createClass(PDFSidebar, [{
    key: "reset",
    value: function reset() {
      this.isInitialViewSet = false;

      this._hideUINotification(null);

      this.switchView(SidebarView.THUMBS);
      this.outlineButton.disabled = false;
      this.attachmentsButton.disabled = false;
    }
  }, {
    key: "setInitialView",
    value: function setInitialView() {
      var view = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : SidebarView.NONE;

      if (this.isInitialViewSet) {
        return;
      }

      this.isInitialViewSet = true;

      if (view === SidebarView.NONE || view === SidebarView.UNKNOWN) {
        this._dispatchEvent();

        return;
      }

      if (!this._switchView(view, true)) {
        this._dispatchEvent();
      }
    }
  }, {
    key: "switchView",
    value: function switchView(view) {
      var forceOpen = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      this._switchView(view, forceOpen);
    }
  }, {
    key: "_switchView",
    value: function _switchView(view) {
      var forceOpen = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var isViewChanged = view !== this.active;
      var shouldForceRendering = false;

      switch (view) {
        case SidebarView.NONE:
          if (this.isOpen) {
            this.close();
            return true;
          }

          return false;

        case SidebarView.THUMBS:
          if (this.isOpen && isViewChanged) {
            shouldForceRendering = true;
          }

          break;

        case SidebarView.OUTLINE:
          if (this.outlineButton.disabled) {
            return false;
          }

          break;

        case SidebarView.ATTACHMENTS:
          if (this.attachmentsButton.disabled) {
            return false;
          }

          break;

        default:
          console.error("PDFSidebar._switchView: \"".concat(view, "\" is not a valid view."));
          return false;
      }

      this.active = view;
      this.thumbnailButton.classList.toggle('toggled', view === SidebarView.THUMBS);
      this.outlineButton.classList.toggle('toggled', view === SidebarView.OUTLINE);
      this.attachmentsButton.classList.toggle('toggled', view === SidebarView.ATTACHMENTS);
      this.thumbnailView.classList.toggle('hidden', view !== SidebarView.THUMBS);
      this.outlineView.classList.toggle('hidden', view !== SidebarView.OUTLINE);
      this.attachmentsView.classList.toggle('hidden', view !== SidebarView.ATTACHMENTS);

      if (forceOpen && !this.isOpen) {
        this.open();
        return true;
      }

      if (shouldForceRendering) {
        this._updateThumbnailViewer();

        this._forceRendering();
      }

      if (isViewChanged) {
        this._dispatchEvent();
      }

      this._hideUINotification(this.active);

      return isViewChanged;
    }
  }, {
    key: "open",
    value: function open() {
      if (this.isOpen) {
        return;
      }

      this.isOpen = true;
      this.toggleButton.classList.add('toggled');
      this.outerContainer.classList.add('sidebarMoving', 'sidebarOpen');

      if (this.active === SidebarView.THUMBS) {
        this._updateThumbnailViewer();
      }

      this._forceRendering();

      this._dispatchEvent();

      this._hideUINotification(this.active);
    }
  }, {
    key: "close",
    value: function close() {
      if (!this.isOpen) {
        return;
      }

      this.isOpen = false;
      this.toggleButton.classList.remove('toggled');
      this.outerContainer.classList.add('sidebarMoving');
      this.outerContainer.classList.remove('sidebarOpen');

      this._forceRendering();

      this._dispatchEvent();
    }
  }, {
    key: "toggle",
    value: function toggle() {
      if (this.isOpen) {
        this.close();
      } else {
        this.open();
      }
    }
  }, {
    key: "_dispatchEvent",
    value: function _dispatchEvent() {
      this.eventBus.dispatch('sidebarviewchanged', {
        source: this,
        view: this.visibleView
      });
    }
  }, {
    key: "_forceRendering",
    value: function _forceRendering() {
      if (this.onToggled) {
        this.onToggled();
      } else {
        this.pdfViewer.forceRendering();
        this.pdfThumbnailViewer.forceRendering();
      }
    }
  }, {
    key: "_updateThumbnailViewer",
    value: function _updateThumbnailViewer() {
      var pdfViewer = this.pdfViewer,
          pdfThumbnailViewer = this.pdfThumbnailViewer;
      var pagesCount = pdfViewer.pagesCount;

      for (var pageIndex = 0; pageIndex < pagesCount; pageIndex++) {
        var pageView = pdfViewer.getPageView(pageIndex);

        if (pageView && pageView.renderingState === _pdf_rendering_queue.RenderingStates.FINISHED) {
          var thumbnailView = pdfThumbnailViewer.getThumbnail(pageIndex);
          thumbnailView.setImage(pageView);
        }
      }

      pdfThumbnailViewer.scrollThumbnailIntoView(pdfViewer.currentPageNumber);
    }
  }, {
    key: "_showUINotification",
    value: function _showUINotification(view) {
      var _this = this;

      if (this.disableNotification) {
        return;
      }

      this.l10n.get('toggle_sidebar_notification.title', null, 'Toggle Sidebar (document contains outline/attachments)').then(function (msg) {
        _this.toggleButton.title = msg;
      });

      if (!this.isOpen) {
        this.toggleButton.classList.add(UI_NOTIFICATION_CLASS);
      } else if (view === this.active) {
        return;
      }

      switch (view) {
        case SidebarView.OUTLINE:
          this.outlineButton.classList.add(UI_NOTIFICATION_CLASS);
          break;

        case SidebarView.ATTACHMENTS:
          this.attachmentsButton.classList.add(UI_NOTIFICATION_CLASS);
          break;
      }
    }
  }, {
    key: "_hideUINotification",
    value: function _hideUINotification(view) {
      var _this2 = this;

      if (this.disableNotification) {
        return;
      }

      var removeNotification = function removeNotification(view) {
        switch (view) {
          case SidebarView.OUTLINE:
            _this2.outlineButton.classList.remove(UI_NOTIFICATION_CLASS);

            break;

          case SidebarView.ATTACHMENTS:
            _this2.attachmentsButton.classList.remove(UI_NOTIFICATION_CLASS);

            break;
        }
      };

      if (!this.isOpen && view !== null) {
        return;
      }

      this.toggleButton.classList.remove(UI_NOTIFICATION_CLASS);

      if (view !== null) {
        removeNotification(view);
        return;
      }

      for (view in SidebarView) {
        removeNotification(SidebarView[view]);
      }

      this.l10n.get('toggle_sidebar.title', null, 'Toggle Sidebar').then(function (msg) {
        _this2.toggleButton.title = msg;
      });
    }
  }, {
    key: "_addEventListeners",
    value: function _addEventListeners() {
      var _this3 = this;

      this.viewerContainer.addEventListener('transitionend', function (evt) {
        if (evt.target === _this3.viewerContainer) {
          _this3.outerContainer.classList.remove('sidebarMoving');
        }
      });
      this.thumbnailButton.addEventListener('click', function () {
        _this3.switchView(SidebarView.THUMBS);
      });
      this.outlineButton.addEventListener('click', function () {
        _this3.switchView(SidebarView.OUTLINE);
      });
      this.outlineButton.addEventListener('dblclick', function () {
        _this3.eventBus.dispatch('toggleoutlinetree', {
          source: _this3
        });
      });
      this.attachmentsButton.addEventListener('click', function () {
        _this3.switchView(SidebarView.ATTACHMENTS);
      });
      this.eventBus.on('outlineloaded', function (evt) {
        var outlineCount = evt.outlineCount;
        _this3.outlineButton.disabled = !outlineCount;

        if (outlineCount) {
          _this3._showUINotification(SidebarView.OUTLINE);
        } else if (_this3.active === SidebarView.OUTLINE) {
          _this3.switchView(SidebarView.THUMBS);
        }
      });
      this.eventBus.on('attachmentsloaded', function (evt) {
        if (evt.attachmentsCount) {
          _this3.attachmentsButton.disabled = false;

          _this3._showUINotification(SidebarView.ATTACHMENTS);

          return;
        }

        Promise.resolve().then(function () {
          if (_this3.attachmentsView.hasChildNodes()) {
            return;
          }

          _this3.attachmentsButton.disabled = true;

          if (_this3.active === SidebarView.ATTACHMENTS) {
            _this3.switchView(SidebarView.THUMBS);
          }
        });
      });
      this.eventBus.on('presentationmodechanged', function (evt) {
        if (!evt.active && !evt.switchInProgress && _this3.isThumbnailViewVisible) {
          _this3._updateThumbnailViewer();
        }
      });
    }
  }, {
    key: "visibleView",
    get: function get() {
      return this.isOpen ? this.active : SidebarView.NONE;
    }
  }, {
    key: "isThumbnailViewVisible",
    get: function get() {
      return this.isOpen && this.active === SidebarView.THUMBS;
    }
  }, {
    key: "isOutlineViewVisible",
    get: function get() {
      return this.isOpen && this.active === SidebarView.OUTLINE;
    }
  }, {
    key: "isAttachmentsViewVisible",
    get: function get() {
      return this.isOpen && this.active === SidebarView.ATTACHMENTS;
    }
  }]);

  return PDFSidebar;
}();

exports.PDFSidebar = PDFSidebar;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptionKind = exports.AppOptions = void 0;

var _pdfjsLib = __webpack_require__(7);

var _viewer_compatibility = __webpack_require__(13);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var OptionKind = {
  VIEWER: 'viewer',
  API: 'api',
  WORKER: 'worker'
};
exports.OptionKind = OptionKind;
var defaultOptions = {
  cursorToolOnLoad: {
    value: 0,
    kind: OptionKind.VIEWER
  },
  defaultUrl: {
    value: '',
    kind: OptionKind.VIEWER
  },
  defaultZoomValue: {
    value: '',
    kind: OptionKind.VIEWER
  },
  disableHistory: {
    value: false,
    kind: OptionKind.VIEWER
  },
  disablePageLabels: {
    value: false,
    kind: OptionKind.VIEWER
  },
  enablePrintAutoRotate: {
    value: false,
    kind: OptionKind.VIEWER
  },
  enableWebGL: {
    value: false,
    kind: OptionKind.VIEWER
  },
  eventBusDispatchToDOM: {
    value: false,
    kind: OptionKind.VIEWER
  },
  externalLinkRel: {
    value: 'noopener noreferrer nofollow',
    kind: OptionKind.VIEWER
  },
  externalLinkTarget: {
    value: 0,
    kind: OptionKind.VIEWER
  },
  historyUpdateUrl: {
    value: false,
    kind: OptionKind.VIEWER
  },
  imageResourcesPath: {
    value: './images/',
    kind: OptionKind.VIEWER
  },
  maxCanvasPixels: {
    value: 16777216,
    compatibility: _viewer_compatibility.viewerCompatibilityParams.maxCanvasPixels,
    kind: OptionKind.VIEWER
  },
  pdfBugEnabled: {
    value: false,
    kind: OptionKind.VIEWER
  },
  renderer: {
    value: 'canvas',
    kind: OptionKind.VIEWER
  },
  renderInteractiveForms: {
    value: false,
    kind: OptionKind.VIEWER
  },
  sidebarViewOnLoad: {
    value: -1,
    kind: OptionKind.VIEWER
  },
  scrollModeOnLoad: {
    value: -1,
    kind: OptionKind.VIEWER
  },
  spreadModeOnLoad: {
    value: -1,
    kind: OptionKind.VIEWER
  },
  textLayerMode: {
    value: 1,
    kind: OptionKind.VIEWER
  },
  useOnlyCssZoom: {
    value: false,
    kind: OptionKind.VIEWER
  },
  viewOnLoad: {
    value: 0,
    kind: OptionKind.VIEWER
  },
  cMapPacked: {
    value: true,
    kind: OptionKind.API
  },
  cMapUrl: {
    value: '../web/cmaps/',
    kind: OptionKind.API
  },
  disableAutoFetch: {
    value: false,
    kind: OptionKind.API
  },
  disableCreateObjectURL: {
    value: false,
    compatibility: _pdfjsLib.apiCompatibilityParams.disableCreateObjectURL,
    kind: OptionKind.API
  },
  disableFontFace: {
    value: false,
    kind: OptionKind.API
  },
  disableRange: {
    value: false,
    kind: OptionKind.API
  },
  disableStream: {
    value: false,
    kind: OptionKind.API
  },
  isEvalSupported: {
    value: true,
    kind: OptionKind.API
  },
  maxImageSize: {
    value: -1,
    kind: OptionKind.API
  },
  pdfBug: {
    value: false,
    kind: OptionKind.API
  },
  postMessageTransfers: {
    value: true,
    kind: OptionKind.API
  },
  verbosity: {
    value: 1,
    kind: OptionKind.API
  },
  workerPort: {
    value: null,
    kind: OptionKind.WORKER
  },
  workerSrc: {
    value: '../build/pdf.worker.js',
    kind: OptionKind.WORKER
  }
};
{
  defaultOptions.disablePreferences = {
    value: false,
    kind: OptionKind.VIEWER
  };
  defaultOptions.locale = {
    value: typeof navigator !== 'undefined' ? navigator.language : 'en-US',
    kind: OptionKind.VIEWER
  };
}
var userOptions = Object.create(null);

var AppOptions =
/*#__PURE__*/
function () {
  function AppOptions() {
    _classCallCheck(this, AppOptions);

    throw new Error('Cannot initialize AppOptions.');
  }

  _createClass(AppOptions, null, [{
    key: "get",
    value: function get(name) {
      var userOption = userOptions[name];

      if (userOption !== undefined) {
        return userOption;
      }

      var defaultOption = defaultOptions[name];

      if (defaultOption !== undefined) {
        return defaultOption.compatibility || defaultOption.value;
      }

      return undefined;
    }
  }, {
    key: "getAll",
    value: function getAll() {
      var kind = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var options = Object.create(null);

      for (var name in defaultOptions) {
        var defaultOption = defaultOptions[name];

        if (kind && kind !== defaultOption.kind) {
          continue;
        }

        var userOption = userOptions[name];
        options[name] = userOption !== undefined ? userOption : defaultOption.compatibility || defaultOption.value;
      }

      return options;
    }
  }, {
    key: "set",
    value: function set(name, value) {
      userOptions[name] = value;
    }
  }, {
    key: "remove",
    value: function remove(name) {
      delete userOptions[name];
    }
  }]);

  return AppOptions;
}();

exports.AppOptions = AppOptions;

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var compatibilityParams = Object.create(null);
{
  var userAgent = typeof navigator !== 'undefined' && navigator.userAgent || '';
  var isAndroid = /Android/.test(userAgent);
  var isIOS = /\b(iPad|iPhone|iPod)(?=;)/.test(userAgent);

  (function checkCanvasSizeLimitation() {
    if (isIOS || isAndroid) {
      compatibilityParams.maxCanvasPixels = 5242880;
    }
  })();
}
exports.viewerCompatibilityParams = Object.freeze(compatibilityParams);

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OverlayManager = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var OverlayManager =
/*#__PURE__*/
function () {
  function OverlayManager() {
    _classCallCheck(this, OverlayManager);

    this._overlays = {};
    this._active = null;
    this._keyDownBound = this._keyDown.bind(this);
  }

  _createClass(OverlayManager, [{
    key: "register",
    value: function () {
      var _register = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(name, element) {
        var callerCloseMethod,
            canForceClose,
            container,
            _args = arguments;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                callerCloseMethod = _args.length > 2 && _args[2] !== undefined ? _args[2] : null;
                canForceClose = _args.length > 3 && _args[3] !== undefined ? _args[3] : false;

                if (!(!name || !element || !(container = element.parentNode))) {
                  _context.next = 6;
                  break;
                }

                throw new Error('Not enough parameters.');

              case 6:
                if (!this._overlays[name]) {
                  _context.next = 8;
                  break;
                }

                throw new Error('The overlay is already registered.');

              case 8:
                this._overlays[name] = {
                  element: element,
                  container: container,
                  callerCloseMethod: callerCloseMethod,
                  canForceClose: canForceClose
                };

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function register(_x, _x2) {
        return _register.apply(this, arguments);
      }

      return register;
    }()
  }, {
    key: "unregister",
    value: function () {
      var _unregister = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(name) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (this._overlays[name]) {
                  _context2.next = 4;
                  break;
                }

                throw new Error('The overlay does not exist.');

              case 4:
                if (!(this._active === name)) {
                  _context2.next = 6;
                  break;
                }

                throw new Error('The overlay cannot be removed while it is active.');

              case 6:
                delete this._overlays[name];

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function unregister(_x3) {
        return _unregister.apply(this, arguments);
      }

      return unregister;
    }()
  }, {
    key: "open",
    value: function () {
      var _open = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(name) {
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (this._overlays[name]) {
                  _context3.next = 4;
                  break;
                }

                throw new Error('The overlay does not exist.');

              case 4:
                if (!this._active) {
                  _context3.next = 14;
                  break;
                }

                if (!this._overlays[name].canForceClose) {
                  _context3.next = 9;
                  break;
                }

                this._closeThroughCaller();

                _context3.next = 14;
                break;

              case 9:
                if (!(this._active === name)) {
                  _context3.next = 13;
                  break;
                }

                throw new Error('The overlay is already active.');

              case 13:
                throw new Error('Another overlay is currently active.');

              case 14:
                this._active = name;

                this._overlays[this._active].element.classList.remove('hidden');

                this._overlays[this._active].container.classList.remove('hidden');

                window.addEventListener('keydown', this._keyDownBound);

              case 18:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function open(_x4) {
        return _open.apply(this, arguments);
      }

      return open;
    }()
  }, {
    key: "close",
    value: function () {
      var _close = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(name) {
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (this._overlays[name]) {
                  _context4.next = 4;
                  break;
                }

                throw new Error('The overlay does not exist.');

              case 4:
                if (this._active) {
                  _context4.next = 8;
                  break;
                }

                throw new Error('The overlay is currently not active.');

              case 8:
                if (!(this._active !== name)) {
                  _context4.next = 10;
                  break;
                }

                throw new Error('Another overlay is currently active.');

              case 10:
                this._overlays[this._active].container.classList.add('hidden');

                this._overlays[this._active].element.classList.add('hidden');

                this._active = null;
                window.removeEventListener('keydown', this._keyDownBound);

              case 14:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function close(_x5) {
        return _close.apply(this, arguments);
      }

      return close;
    }()
  }, {
    key: "_keyDown",
    value: function _keyDown(evt) {
      if (this._active && evt.keyCode === 27) {
        this._closeThroughCaller();

        evt.preventDefault();
      }
    }
  }, {
    key: "_closeThroughCaller",
    value: function _closeThroughCaller() {
      if (this._overlays[this._active].callerCloseMethod) {
        this._overlays[this._active].callerCloseMethod();
      }

      if (this._active) {
        this.close(this._active);
      }
    }
  }, {
    key: "active",
    get: function get() {
      return this._active;
    }
  }]);

  return OverlayManager;
}();

exports.OverlayManager = OverlayManager;

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PasswordPrompt = void 0;

var _ui_utils = __webpack_require__(6);

var _pdfjsLib = __webpack_require__(7);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var PasswordPrompt =
/*#__PURE__*/
function () {
  function PasswordPrompt(options, overlayManager) {
    var _this = this;

    var l10n = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _ui_utils.NullL10n;

    _classCallCheck(this, PasswordPrompt);

    this.overlayName = options.overlayName;
    this.container = options.container;
    this.label = options.label;
    this.input = options.input;
    this.submitButton = options.submitButton;
    this.cancelButton = options.cancelButton;
    this.overlayManager = overlayManager;
    this.l10n = l10n;
    this.updateCallback = null;
    this.reason = null;
    this.submitButton.addEventListener('click', this.verify.bind(this));
    this.cancelButton.addEventListener('click', this.close.bind(this));
    this.input.addEventListener('keydown', function (e) {
      if (e.keyCode === 13) {
        _this.verify();
      }
    });
    this.overlayManager.register(this.overlayName, this.container, this.close.bind(this), true);
  }

  _createClass(PasswordPrompt, [{
    key: "open",
    value: function open() {
      var _this2 = this;

      this.overlayManager.open(this.overlayName).then(function () {
        _this2.input.focus();

        var promptString;

        if (_this2.reason === _pdfjsLib.PasswordResponses.INCORRECT_PASSWORD) {
          promptString = _this2.l10n.get('password_invalid', null, 'Invalid password. Please try again.');
        } else {
          promptString = _this2.l10n.get('password_label', null, 'Enter the password to open this PDF file.');
        }

        promptString.then(function (msg) {
          _this2.label.textContent = msg;
        });
      });
    }
  }, {
    key: "close",
    value: function close() {
      var _this3 = this;

      this.overlayManager.close(this.overlayName).then(function () {
        _this3.input.value = '';
      });
    }
  }, {
    key: "verify",
    value: function verify() {
      var password = this.input.value;

      if (password && password.length > 0) {
        this.close();
        return this.updateCallback(password);
      }
    }
  }, {
    key: "setUpdateCallback",
    value: function setUpdateCallback(updateCallback, reason) {
      this.updateCallback = updateCallback;
      this.reason = reason;
    }
  }]);

  return PasswordPrompt;
}();

exports.PasswordPrompt = PasswordPrompt;

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFAttachmentViewer = void 0;

var _pdfjsLib = __webpack_require__(7);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var PDFAttachmentViewer =
/*#__PURE__*/
function () {
  function PDFAttachmentViewer(_ref) {
    var container = _ref.container,
        eventBus = _ref.eventBus,
        downloadManager = _ref.downloadManager;

    _classCallCheck(this, PDFAttachmentViewer);

    this.container = container;
    this.eventBus = eventBus;
    this.downloadManager = downloadManager;
    this.reset();
    this.eventBus.on('fileattachmentannotation', this._appendAttachment.bind(this));
  }

  _createClass(PDFAttachmentViewer, [{
    key: "reset",
    value: function reset() {
      var keepRenderedCapability = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.attachments = null;
      this.container.textContent = '';

      if (!keepRenderedCapability) {
        this._renderedCapability = (0, _pdfjsLib.createPromiseCapability)();
      }
    }
  }, {
    key: "_dispatchEvent",
    value: function _dispatchEvent(attachmentsCount) {
      this._renderedCapability.resolve();

      this.eventBus.dispatch('attachmentsloaded', {
        source: this,
        attachmentsCount: attachmentsCount
      });
    }
  }, {
    key: "_bindPdfLink",
    value: function _bindPdfLink(button, content, filename) {
      if (this.downloadManager.disableCreateObjectURL) {
        throw new Error('bindPdfLink: Unsupported "disableCreateObjectURL" value.');
      }

      var blobUrl;

      button.onclick = function () {
        if (!blobUrl) {
          blobUrl = (0, _pdfjsLib.createObjectURL)(content, 'application/pdf');
        }

        var viewerUrl;
        viewerUrl = '?file=' + encodeURIComponent(blobUrl + '#' + filename);
        window.open(viewerUrl);
        return false;
      };
    }
  }, {
    key: "_bindLink",
    value: function _bindLink(button, content, filename) {
      var _this = this;

      button.onclick = function () {
        _this.downloadManager.downloadData(content, filename, '');

        return false;
      };
    }
  }, {
    key: "render",
    value: function render(_ref2) {
      var attachments = _ref2.attachments,
          _ref2$keepRenderedCap = _ref2.keepRenderedCapability,
          keepRenderedCapability = _ref2$keepRenderedCap === void 0 ? false : _ref2$keepRenderedCap;
      var attachmentsCount = 0;

      if (this.attachments) {
        this.reset(keepRenderedCapability === true);
      }

      this.attachments = attachments || null;

      if (!attachments) {
        this._dispatchEvent(attachmentsCount);

        return;
      }

      var names = Object.keys(attachments).sort(function (a, b) {
        return a.toLowerCase().localeCompare(b.toLowerCase());
      });
      attachmentsCount = names.length;

      for (var i = 0; i < attachmentsCount; i++) {
        var item = attachments[names[i]];
        var filename = (0, _pdfjsLib.removeNullCharacters)((0, _pdfjsLib.getFilenameFromUrl)(item.filename));
        var div = document.createElement('div');
        div.className = 'attachmentsItem';
        var button = document.createElement('button');
        button.textContent = filename;

        if (/\.pdf$/i.test(filename) && !this.downloadManager.disableCreateObjectURL) {
          this._bindPdfLink(button, item.content, filename);
        } else {
          this._bindLink(button, item.content, filename);
        }

        div.appendChild(button);
        this.container.appendChild(div);
      }

      this._dispatchEvent(attachmentsCount);
    }
  }, {
    key: "_appendAttachment",
    value: function _appendAttachment(_ref3) {
      var _this2 = this;

      var id = _ref3.id,
          filename = _ref3.filename,
          content = _ref3.content;

      this._renderedCapability.promise.then(function () {
        var attachments = _this2.attachments;

        if (!attachments) {
          attachments = Object.create(null);
        } else {
          for (var name in attachments) {
            if (id === name) {
              return;
            }
          }
        }

        attachments[id] = {
          filename: filename,
          content: content
        };

        _this2.render({
          attachments: attachments,
          keepRenderedCapability: true
        });
      });
    }
  }]);

  return PDFAttachmentViewer;
}();

exports.PDFAttachmentViewer = PDFAttachmentViewer;

/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFDocumentProperties = void 0;

var _ui_utils = __webpack_require__(6);

var _pdfjsLib = __webpack_require__(7);

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEFAULT_FIELD_CONTENT = '-';
var NON_METRIC_LOCALES = ['en-us', 'en-lr', 'my'];
var US_PAGE_NAMES = {
  '8.5x11': 'Letter',
  '8.5x14': 'Legal'
};
var METRIC_PAGE_NAMES = {
  '297x420': 'A3',
  '210x297': 'A4'
};

function getPageName(size, isPortrait, pageNames) {
  var width = isPortrait ? size.width : size.height;
  var height = isPortrait ? size.height : size.width;
  return pageNames["".concat(width, "x").concat(height)];
}

var PDFDocumentProperties =
/*#__PURE__*/
function () {
  function PDFDocumentProperties(_ref, overlayManager, eventBus) {
    var _this = this;

    var overlayName = _ref.overlayName,
        fields = _ref.fields,
        container = _ref.container,
        closeButton = _ref.closeButton;
    var l10n = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _ui_utils.NullL10n;

    _classCallCheck(this, PDFDocumentProperties);

    this.overlayName = overlayName;
    this.fields = fields;
    this.container = container;
    this.overlayManager = overlayManager;
    this.l10n = l10n;

    this._reset();

    if (closeButton) {
      closeButton.addEventListener('click', this.close.bind(this));
    }

    this.overlayManager.register(this.overlayName, this.container, this.close.bind(this));

    if (eventBus) {
      eventBus.on('pagechanging', function (evt) {
        _this._currentPageNumber = evt.pageNumber;
      });
      eventBus.on('rotationchanging', function (evt) {
        _this._pagesRotation = evt.pagesRotation;
      });
    }

    this._isNonMetricLocale = true;
    l10n.getLanguage().then(function (locale) {
      _this._isNonMetricLocale = NON_METRIC_LOCALES.includes(locale);
    });
  }

  _createClass(PDFDocumentProperties, [{
    key: "open",
    value: function open() {
      var _this2 = this;

      var freezeFieldData = function freezeFieldData(data) {
        Object.defineProperty(_this2, 'fieldData', {
          value: Object.freeze(data),
          writable: false,
          enumerable: true,
          configurable: true
        });
      };

      Promise.all([this.overlayManager.open(this.overlayName), this._dataAvailableCapability.promise]).then(function () {
        var currentPageNumber = _this2._currentPageNumber;
        var pagesRotation = _this2._pagesRotation;

        if (_this2.fieldData && currentPageNumber === _this2.fieldData['_currentPageNumber'] && pagesRotation === _this2.fieldData['_pagesRotation']) {
          _this2._updateUI();

          return;
        }

        _this2.pdfDocument.getMetadata().then(function (_ref2) {
          var info = _ref2.info,
              metadata = _ref2.metadata,
              contentDispositionFilename = _ref2.contentDispositionFilename;
          return Promise.all([info, metadata, contentDispositionFilename || (0, _ui_utils.getPDFFileNameFromURL)(_this2.url || ''), _this2._parseFileSize(_this2.maybeFileSize), _this2._parseDate(info.CreationDate), _this2._parseDate(info.ModDate), _this2.pdfDocument.getPage(currentPageNumber).then(function (pdfPage) {
            return _this2._parsePageSize((0, _ui_utils.getPageSizeInches)(pdfPage), pagesRotation);
          }), _this2._parseLinearization(info.IsLinearized)]);
        }).then(function (_ref3) {
          var _ref4 = _slicedToArray(_ref3, 8),
              info = _ref4[0],
              metadata = _ref4[1],
              fileName = _ref4[2],
              fileSize = _ref4[3],
              creationDate = _ref4[4],
              modDate = _ref4[5],
              pageSize = _ref4[6],
              isLinearized = _ref4[7];

          freezeFieldData({
            'fileName': fileName,
            'fileSize': fileSize,
            'title': info.Title,
            'author': info.Author,
            'subject': info.Subject,
            'keywords': info.Keywords,
            'creationDate': creationDate,
            'modificationDate': modDate,
            'creator': info.Creator,
            'producer': info.Producer,
            'version': info.PDFFormatVersion,
            'pageCount': _this2.pdfDocument.numPages,
            'pageSize': pageSize,
            'linearized': isLinearized,
            '_currentPageNumber': currentPageNumber,
            '_pagesRotation': pagesRotation
          });

          _this2._updateUI();

          return _this2.pdfDocument.getDownloadInfo();
        }).then(function (_ref5) {
          var length = _ref5.length;
          _this2.maybeFileSize = length;
          return _this2._parseFileSize(length);
        }).then(function (fileSize) {
          if (fileSize === _this2.fieldData['fileSize']) {
            return;
          }

          var data = Object.assign(Object.create(null), _this2.fieldData);
          data['fileSize'] = fileSize;
          freezeFieldData(data);

          _this2._updateUI();
        });
      });
    }
  }, {
    key: "close",
    value: function close() {
      this.overlayManager.close(this.overlayName);
    }
  }, {
    key: "setDocument",
    value: function setDocument(pdfDocument) {
      var url = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (this.pdfDocument) {
        this._reset();

        this._updateUI(true);
      }

      if (!pdfDocument) {
        return;
      }

      this.pdfDocument = pdfDocument;
      this.url = url;

      this._dataAvailableCapability.resolve();
    }
  }, {
    key: "setFileSize",
    value: function setFileSize(fileSize) {
      if (Number.isInteger(fileSize) && fileSize > 0) {
        this.maybeFileSize = fileSize;
      }
    }
  }, {
    key: "_reset",
    value: function _reset() {
      this.pdfDocument = null;
      this.url = null;
      this.maybeFileSize = 0;
      delete this.fieldData;
      this._dataAvailableCapability = (0, _pdfjsLib.createPromiseCapability)();
      this._currentPageNumber = 1;
      this._pagesRotation = 0;
    }
  }, {
    key: "_updateUI",
    value: function _updateUI() {
      var reset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (reset || !this.fieldData) {
        for (var id in this.fields) {
          this.fields[id].textContent = DEFAULT_FIELD_CONTENT;
        }

        return;
      }

      if (this.overlayManager.active !== this.overlayName) {
        return;
      }

      for (var _id in this.fields) {
        var content = this.fieldData[_id];
        this.fields[_id].textContent = content || content === 0 ? content : DEFAULT_FIELD_CONTENT;
      }
    }
  }, {
    key: "_parseFileSize",
    value: function _parseFileSize() {
      var fileSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var kb = fileSize / 1024;

      if (!kb) {
        return Promise.resolve(undefined);
      } else if (kb < 1024) {
        return this.l10n.get('document_properties_kb', {
          size_kb: (+kb.toPrecision(3)).toLocaleString(),
          size_b: fileSize.toLocaleString()
        }, '{{size_kb}} KB ({{size_b}} bytes)');
      }

      return this.l10n.get('document_properties_mb', {
        size_mb: (+(kb / 1024).toPrecision(3)).toLocaleString(),
        size_b: fileSize.toLocaleString()
      }, '{{size_mb}} MB ({{size_b}} bytes)');
    }
  }, {
    key: "_parsePageSize",
    value: function _parsePageSize(pageSizeInches, pagesRotation) {
      var _this3 = this;

      if (!pageSizeInches) {
        return Promise.resolve(undefined);
      }

      if (pagesRotation % 180 !== 0) {
        pageSizeInches = {
          width: pageSizeInches.height,
          height: pageSizeInches.width
        };
      }

      var isPortrait = (0, _ui_utils.isPortraitOrientation)(pageSizeInches);
      var sizeInches = {
        width: Math.round(pageSizeInches.width * 100) / 100,
        height: Math.round(pageSizeInches.height * 100) / 100
      };
      var sizeMillimeters = {
        width: Math.round(pageSizeInches.width * 25.4 * 10) / 10,
        height: Math.round(pageSizeInches.height * 25.4 * 10) / 10
      };
      var pageName = null;
      var name = getPageName(sizeInches, isPortrait, US_PAGE_NAMES) || getPageName(sizeMillimeters, isPortrait, METRIC_PAGE_NAMES);

      if (!name && !(Number.isInteger(sizeMillimeters.width) && Number.isInteger(sizeMillimeters.height))) {
        var exactMillimeters = {
          width: pageSizeInches.width * 25.4,
          height: pageSizeInches.height * 25.4
        };
        var intMillimeters = {
          width: Math.round(sizeMillimeters.width),
          height: Math.round(sizeMillimeters.height)
        };

        if (Math.abs(exactMillimeters.width - intMillimeters.width) < 0.1 && Math.abs(exactMillimeters.height - intMillimeters.height) < 0.1) {
          name = getPageName(intMillimeters, isPortrait, METRIC_PAGE_NAMES);

          if (name) {
            sizeInches = {
              width: Math.round(intMillimeters.width / 25.4 * 100) / 100,
              height: Math.round(intMillimeters.height / 25.4 * 100) / 100
            };
            sizeMillimeters = intMillimeters;
          }
        }
      }

      if (name) {
        pageName = this.l10n.get('document_properties_page_size_name_' + name.toLowerCase(), null, name);
      }

      return Promise.all([this._isNonMetricLocale ? sizeInches : sizeMillimeters, this.l10n.get('document_properties_page_size_unit_' + (this._isNonMetricLocale ? 'inches' : 'millimeters'), null, this._isNonMetricLocale ? 'in' : 'mm'), pageName, this.l10n.get('document_properties_page_size_orientation_' + (isPortrait ? 'portrait' : 'landscape'), null, isPortrait ? 'portrait' : 'landscape')]).then(function (_ref6) {
        var _ref7 = _slicedToArray(_ref6, 4),
            _ref7$ = _ref7[0],
            width = _ref7$.width,
            height = _ref7$.height,
            unit = _ref7[1],
            name = _ref7[2],
            orientation = _ref7[3];

        return _this3.l10n.get('document_properties_page_size_dimension_' + (name ? 'name_' : '') + 'string', {
          width: width.toLocaleString(),
          height: height.toLocaleString(),
          unit: unit,
          name: name,
          orientation: orientation
        }, '{{width}} × {{height}} {{unit}} (' + (name ? '{{name}}, ' : '') + '{{orientation}})');
      });
    }
  }, {
    key: "_parseDate",
    value: function _parseDate(inputDate) {
      if (!inputDate) {
        return;
      }

      var dateToParse = inputDate;

      if (dateToParse.substring(0, 2) === 'D:') {
        dateToParse = dateToParse.substring(2);
      }

      var year = parseInt(dateToParse.substring(0, 4), 10);
      var month = parseInt(dateToParse.substring(4, 6), 10) - 1;
      var day = parseInt(dateToParse.substring(6, 8), 10);
      var hours = parseInt(dateToParse.substring(8, 10), 10);
      var minutes = parseInt(dateToParse.substring(10, 12), 10);
      var seconds = parseInt(dateToParse.substring(12, 14), 10);
      var utRel = dateToParse.substring(14, 15);
      var offsetHours = parseInt(dateToParse.substring(15, 17), 10);
      var offsetMinutes = parseInt(dateToParse.substring(18, 20), 10);

      if (utRel === '-') {
        hours += offsetHours;
        minutes += offsetMinutes;
      } else if (utRel === '+') {
        hours -= offsetHours;
        minutes -= offsetMinutes;
      }

      var date = new Date(Date.UTC(year, month, day, hours, minutes, seconds));
      var dateString = date.toLocaleDateString();
      var timeString = date.toLocaleTimeString();
      return this.l10n.get('document_properties_date_string', {
        date: dateString,
        time: timeString
      }, '{{date}}, {{time}}');
    }
  }, {
    key: "_parseLinearization",
    value: function _parseLinearization(isLinearized) {
      return this.l10n.get('document_properties_linearized_' + (isLinearized ? 'yes' : 'no'), null, isLinearized ? 'Yes' : 'No');
    }
  }]);

  return PDFDocumentProperties;
}();

exports.PDFDocumentProperties = PDFDocumentProperties;

/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFFindBar = void 0;

var _ui_utils = __webpack_require__(6);

var _pdf_find_controller = __webpack_require__(19);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var MATCHES_COUNT_LIMIT = 1000;

var PDFFindBar =
/*#__PURE__*/
function () {
  function PDFFindBar(options) {
    var _this = this;

    var eventBus = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _ui_utils.getGlobalEventBus)();
    var l10n = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _ui_utils.NullL10n;

    _classCallCheck(this, PDFFindBar);

    this.opened = false;
    this.bar = options.bar || null;
    this.toggleButton = options.toggleButton || null;
    this.findField = options.findField || null;
    this.highlightAll = options.highlightAllCheckbox || null;
    this.caseSensitive = options.caseSensitiveCheckbox || null;
    this.entireWord = options.entireWordCheckbox || null;
    this.findMsg = options.findMsg || null;
    this.findResultsCount = options.findResultsCount || null;
    this.findPreviousButton = options.findPreviousButton || null;
    this.findNextButton = options.findNextButton || null;
    this.eventBus = eventBus;
    this.l10n = l10n;
    this.toggleButton.addEventListener('click', function () {
      _this.toggle();
    });
    this.findField.addEventListener('input', function () {
      _this.dispatchEvent('');
    });
    this.bar.addEventListener('keydown', function (e) {
      switch (e.keyCode) {
        case 13:
          if (e.target === _this.findField) {
            _this.dispatchEvent('again', e.shiftKey);
          }

          break;

        case 27:
          _this.close();

          break;
      }
    });
    this.findPreviousButton.addEventListener('click', function () {
      _this.dispatchEvent('again', true);
    });
    this.findNextButton.addEventListener('click', function () {
      _this.dispatchEvent('again', false);
    });
    this.highlightAll.addEventListener('click', function () {
      _this.dispatchEvent('highlightallchange');
    });
    this.caseSensitive.addEventListener('click', function () {
      _this.dispatchEvent('casesensitivitychange');
    });
    this.entireWord.addEventListener('click', function () {
      _this.dispatchEvent('entirewordchange');
    });
    this.eventBus.on('resize', this._adjustWidth.bind(this));
  }

  _createClass(PDFFindBar, [{
    key: "reset",
    value: function reset() {
      this.updateUIState();
    }
  }, {
    key: "dispatchEvent",
    value: function dispatchEvent(type, findPrev) {
      this.eventBus.dispatch('find', {
        source: this,
        type: type,
        query: this.findField.value,
        phraseSearch: true,
        caseSensitive: this.caseSensitive.checked,
        entireWord: this.entireWord.checked,
        highlightAll: this.highlightAll.checked,
        findPrevious: findPrev
      });
    }
  }, {
    key: "updateUIState",
    value: function updateUIState(state, previous, matchesCount) {
      var _this2 = this;

      var notFound = false;
      var findMsg = '';
      var status = '';

      switch (state) {
        case _pdf_find_controller.FindState.FOUND:
          break;

        case _pdf_find_controller.FindState.PENDING:
          status = 'pending';
          break;

        case _pdf_find_controller.FindState.NOT_FOUND:
          findMsg = this.l10n.get('find_not_found', null, 'Phrase not found');
          notFound = true;
          break;

        case _pdf_find_controller.FindState.WRAPPED:
          if (previous) {
            findMsg = this.l10n.get('find_reached_top', null, 'Reached top of document, continued from bottom');
          } else {
            findMsg = this.l10n.get('find_reached_bottom', null, 'Reached end of document, continued from top');
          }

          break;
      }

      this.findField.classList.toggle('notFound', notFound);
      this.findField.setAttribute('data-status', status);
      Promise.resolve(findMsg).then(function (msg) {
        _this2.findMsg.textContent = msg;

        _this2._adjustWidth();
      });
      this.updateResultsCount(matchesCount);
    }
  }, {
    key: "updateResultsCount",
    value: function updateResultsCount() {
      var _this3 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$current = _ref.current,
          current = _ref$current === void 0 ? 0 : _ref$current,
          _ref$total = _ref.total,
          total = _ref$total === void 0 ? 0 : _ref$total;

      if (!this.findResultsCount) {
        return;
      }

      var matchesCountMsg = '',
          limit = MATCHES_COUNT_LIMIT;

      if (total > 0) {
        if (total > limit) {
          matchesCountMsg = this.l10n.get('find_match_count_limit', {
            limit: limit
          }, 'More than {{limit}} match' + (limit !== 1 ? 'es' : ''));
        } else {
          matchesCountMsg = this.l10n.get('find_match_count', {
            current: current,
            total: total
          }, '{{current}} of {{total}} match' + (total !== 1 ? 'es' : ''));
        }
      }

      Promise.resolve(matchesCountMsg).then(function (msg) {
        _this3.findResultsCount.textContent = msg;

        _this3.findResultsCount.classList.toggle('hidden', !total);

        _this3._adjustWidth();
      });
    }
  }, {
    key: "open",
    value: function open() {
      if (!this.opened) {
        this.opened = true;
        this.toggleButton.classList.add('toggled');
        this.bar.classList.remove('hidden');
      }

      this.findField.select();
      this.findField.focus();

      this._adjustWidth();
    }
  }, {
    key: "close",
    value: function close() {
      if (!this.opened) {
        return;
      }

      this.opened = false;
      this.toggleButton.classList.remove('toggled');
      this.bar.classList.add('hidden');
      this.eventBus.dispatch('findbarclose', {
        source: this
      });
    }
  }, {
    key: "toggle",
    value: function toggle() {
      if (this.opened) {
        this.close();
      } else {
        this.open();
      }
    }
  }, {
    key: "_adjustWidth",
    value: function _adjustWidth() {
      if (!this.opened) {
        return;
      }

      this.bar.classList.remove('wrapContainers');
      var findbarHeight = this.bar.clientHeight;
      var inputContainerHeight = this.bar.firstElementChild.clientHeight;

      if (findbarHeight > inputContainerHeight) {
        this.bar.classList.add('wrapContainers');
      }
    }
  }]);

  return PDFFindBar;
}();

exports.PDFFindBar = PDFFindBar;

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFFindController = exports.FindState = void 0;

var _ui_utils = __webpack_require__(6);

var _pdfjsLib = __webpack_require__(7);

var _pdf_find_utils = __webpack_require__(20);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var FindState = {
  FOUND: 0,
  NOT_FOUND: 1,
  WRAPPED: 2,
  PENDING: 3
};
exports.FindState = FindState;
var FIND_TIMEOUT = 250;
var MATCH_SCROLL_OFFSET_TOP = -50;
var MATCH_SCROLL_OFFSET_LEFT = -400;
var CHARACTERS_TO_NORMALIZE = {
  "\u2018": '\'',
  "\u2019": '\'',
  "\u201A": '\'',
  "\u201B": '\'',
  "\u201C": '"',
  "\u201D": '"',
  "\u201E": '"',
  "\u201F": '"',
  "\xBC": '1/4',
  "\xBD": '1/2',
  "\xBE": '3/4'
};
var normalizationRegex = null;

function normalize(text) {
  if (!normalizationRegex) {
    var replace = Object.keys(CHARACTERS_TO_NORMALIZE).join('');
    normalizationRegex = new RegExp("[".concat(replace, "]"), 'g');
  }

  return text.replace(normalizationRegex, function (ch) {
    return CHARACTERS_TO_NORMALIZE[ch];
  });
}

var PDFFindController =
/*#__PURE__*/
function () {
  function PDFFindController(_ref) {
    var linkService = _ref.linkService,
        _ref$eventBus = _ref.eventBus,
        eventBus = _ref$eventBus === void 0 ? (0, _ui_utils.getGlobalEventBus)() : _ref$eventBus;

    _classCallCheck(this, PDFFindController);

    this._linkService = linkService;
    this._eventBus = eventBus;

    this._reset();

    eventBus.on('findbarclose', this._onFindBarClose.bind(this));
  }

  _createClass(PDFFindController, [{
    key: "setDocument",
    value: function setDocument(pdfDocument) {
      if (this._pdfDocument) {
        this._reset();
      }

      if (!pdfDocument) {
        return;
      }

      this._pdfDocument = pdfDocument;

      this._firstPageCapability.resolve();
    }
  }, {
    key: "executeCommand",
    value: function executeCommand(cmd, state) {
      var _this = this;

      if (!state) {
        return;
      }

      var pdfDocument = this._pdfDocument;

      if (this._state === null || this._shouldDirtyMatch(cmd, state)) {
        this._dirtyMatch = true;
      }

      this._state = state;

      if (cmd !== 'findhighlightallchange') {
        this._updateUIState(FindState.PENDING);
      }

      this._firstPageCapability.promise.then(function () {
        if (!_this._pdfDocument || pdfDocument && _this._pdfDocument !== pdfDocument) {
          return;
        }

        _this._extractText();

        var findbarClosed = !_this._highlightMatches;
        var pendingTimeout = !!_this._findTimeout;

        if (_this._findTimeout) {
          clearTimeout(_this._findTimeout);
          _this._findTimeout = null;
        }

        if (cmd === 'find') {
          _this._findTimeout = setTimeout(function () {
            _this._nextMatch();

            _this._findTimeout = null;
          }, FIND_TIMEOUT);
        } else if (_this._dirtyMatch) {
          _this._nextMatch();
        } else if (cmd === 'findagain') {
          _this._nextMatch();

          if (findbarClosed && _this._state.highlightAll) {
            _this._updateAllPages();
          }
        } else if (cmd === 'findhighlightallchange') {
          if (pendingTimeout) {
            _this._nextMatch();
          } else {
            _this._highlightMatches = true;
          }

          _this._updateAllPages();
        } else {
          _this._nextMatch();
        }
      });
    }
  }, {
    key: "scrollMatchIntoView",
    value: function scrollMatchIntoView(_ref2) {
      var _ref2$element = _ref2.element,
          element = _ref2$element === void 0 ? null : _ref2$element,
          _ref2$pageIndex = _ref2.pageIndex,
          pageIndex = _ref2$pageIndex === void 0 ? -1 : _ref2$pageIndex,
          _ref2$matchIndex = _ref2.matchIndex,
          matchIndex = _ref2$matchIndex === void 0 ? -1 : _ref2$matchIndex;

      if (!this._scrollMatches || !element) {
        return;
      } else if (matchIndex === -1 || matchIndex !== this._selected.matchIdx) {
        return;
      } else if (pageIndex === -1 || pageIndex !== this._selected.pageIdx) {
        return;
      }

      this._scrollMatches = false;
      var spot = {
        top: MATCH_SCROLL_OFFSET_TOP,
        left: MATCH_SCROLL_OFFSET_LEFT
      };
      (0, _ui_utils.scrollIntoView)(element, spot, true);
    }
  }, {
    key: "_reset",
    value: function _reset() {
      this._highlightMatches = false;
      this._scrollMatches = false;
      this._pdfDocument = null;
      this._pageMatches = [];
      this._pageMatchesLength = [];
      this._state = null;
      this._selected = {
        pageIdx: -1,
        matchIdx: -1
      };
      this._offset = {
        pageIdx: null,
        matchIdx: null,
        wrapped: false
      };
      this._extractTextPromises = [];
      this._pageContents = [];
      this._matchesCountTotal = 0;
      this._pagesToSearch = null;
      this._pendingFindMatches = Object.create(null);
      this._resumePageIdx = null;
      this._dirtyMatch = false;
      clearTimeout(this._findTimeout);
      this._findTimeout = null;
      this._firstPageCapability = (0, _pdfjsLib.createPromiseCapability)();
    }
  }, {
    key: "_shouldDirtyMatch",
    value: function _shouldDirtyMatch(cmd, state) {
      if (state.query !== this._state.query) {
        return true;
      }

      switch (cmd) {
        case 'findagain':
          var pageNumber = this._selected.pageIdx + 1;
          var linkService = this._linkService;

          if (pageNumber >= 1 && pageNumber <= linkService.pagesCount && linkService.page !== pageNumber && linkService.isPageVisible && !linkService.isPageVisible(pageNumber)) {
            break;
          }

          return false;

        case 'findhighlightallchange':
          return false;
      }

      return true;
    }
  }, {
    key: "_prepareMatches",
    value: function _prepareMatches(matchesWithLength, matches, matchesLength) {
      function isSubTerm(matchesWithLength, currentIndex) {
        var currentElem = matchesWithLength[currentIndex];
        var nextElem = matchesWithLength[currentIndex + 1];

        if (currentIndex < matchesWithLength.length - 1 && currentElem.match === nextElem.match) {
          currentElem.skipped = true;
          return true;
        }

        for (var i = currentIndex - 1; i >= 0; i--) {
          var prevElem = matchesWithLength[i];

          if (prevElem.skipped) {
            continue;
          }

          if (prevElem.match + prevElem.matchLength < currentElem.match) {
            break;
          }

          if (prevElem.match + prevElem.matchLength >= currentElem.match + currentElem.matchLength) {
            currentElem.skipped = true;
            return true;
          }
        }

        return false;
      }

      matchesWithLength.sort(function (a, b) {
        return a.match === b.match ? a.matchLength - b.matchLength : a.match - b.match;
      });

      for (var i = 0, len = matchesWithLength.length; i < len; i++) {
        if (isSubTerm(matchesWithLength, i)) {
          continue;
        }

        matches.push(matchesWithLength[i].match);
        matchesLength.push(matchesWithLength[i].matchLength);
      }
    }
  }, {
    key: "_isEntireWord",
    value: function _isEntireWord(content, startIdx, length) {
      if (startIdx > 0) {
        var first = content.charCodeAt(startIdx);
        var limit = content.charCodeAt(startIdx - 1);

        if ((0, _pdf_find_utils.getCharacterType)(first) === (0, _pdf_find_utils.getCharacterType)(limit)) {
          return false;
        }
      }

      var endIdx = startIdx + length - 1;

      if (endIdx < content.length - 1) {
        var last = content.charCodeAt(endIdx);

        var _limit = content.charCodeAt(endIdx + 1);

        if ((0, _pdf_find_utils.getCharacterType)(last) === (0, _pdf_find_utils.getCharacterType)(_limit)) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "_calculatePhraseMatch",
    value: function _calculatePhraseMatch(query, pageIndex, pageContent, entireWord) {
      var matches = [];
      var queryLen = query.length;
      var matchIdx = -queryLen;

      while (true) {
        matchIdx = pageContent.indexOf(query, matchIdx + queryLen);

        if (matchIdx === -1) {
          break;
        }

        if (entireWord && !this._isEntireWord(pageContent, matchIdx, queryLen)) {
          continue;
        }

        matches.push(matchIdx);
      }

      this._pageMatches[pageIndex] = matches;
    }
  }, {
    key: "_calculateWordMatch",
    value: function _calculateWordMatch(query, pageIndex, pageContent, entireWord) {
      var matchesWithLength = [];
      var queryArray = query.match(/\S+/g);

      for (var i = 0, len = queryArray.length; i < len; i++) {
        var subquery = queryArray[i];
        var subqueryLen = subquery.length;
        var matchIdx = -subqueryLen;

        while (true) {
          matchIdx = pageContent.indexOf(subquery, matchIdx + subqueryLen);

          if (matchIdx === -1) {
            break;
          }

          if (entireWord && !this._isEntireWord(pageContent, matchIdx, subqueryLen)) {
            continue;
          }

          matchesWithLength.push({
            match: matchIdx,
            matchLength: subqueryLen,
            skipped: false
          });
        }
      }

      this._pageMatchesLength[pageIndex] = [];
      this._pageMatches[pageIndex] = [];

      this._prepareMatches(matchesWithLength, this._pageMatches[pageIndex], this._pageMatchesLength[pageIndex]);
    }
  }, {
    key: "_calculateMatch",
    value: function _calculateMatch(pageIndex) {
      var pageContent = this._pageContents[pageIndex];
      var query = this._query;
      var _this$_state = this._state,
          caseSensitive = _this$_state.caseSensitive,
          entireWord = _this$_state.entireWord,
          phraseSearch = _this$_state.phraseSearch;

      if (query.length === 0) {
        return;
      }

      if (!caseSensitive) {
        pageContent = pageContent.toLowerCase();
        query = query.toLowerCase();
      }

      if (phraseSearch) {
        this._calculatePhraseMatch(query, pageIndex, pageContent, entireWord);
      } else {
        this._calculateWordMatch(query, pageIndex, pageContent, entireWord);
      }

      if (this._state.highlightAll) {
        this._updatePage(pageIndex);
      }

      if (this._resumePageIdx === pageIndex) {
        this._resumePageIdx = null;

        this._nextPageMatch();
      }

      var pageMatchesCount = this._pageMatches[pageIndex].length;

      if (pageMatchesCount > 0) {
        this._matchesCountTotal += pageMatchesCount;

        this._updateUIResultsCount();
      }
    }
  }, {
    key: "_extractText",
    value: function _extractText() {
      var _this2 = this;

      if (this._extractTextPromises.length > 0) {
        return;
      }

      var promise = Promise.resolve();

      var _loop = function _loop(i, ii) {
        var extractTextCapability = (0, _pdfjsLib.createPromiseCapability)();
        _this2._extractTextPromises[i] = extractTextCapability.promise;
        promise = promise.then(function () {
          return _this2._pdfDocument.getPage(i + 1).then(function (pdfPage) {
            return pdfPage.getTextContent({
              normalizeWhitespace: true
            });
          }).then(function (textContent) {
            var textItems = textContent.items;
            var strBuf = [];

            for (var j = 0, jj = textItems.length; j < jj; j++) {
              strBuf.push(textItems[j].str);
            }

            _this2._pageContents[i] = normalize(strBuf.join(''));
            extractTextCapability.resolve(i);
          }, function (reason) {
            console.error("Unable to get text content for page ".concat(i + 1), reason);
            _this2._pageContents[i] = '';
            extractTextCapability.resolve(i);
          });
        });
      };

      for (var i = 0, ii = this._linkService.pagesCount; i < ii; i++) {
        _loop(i, ii);
      }
    }
  }, {
    key: "_updatePage",
    value: function _updatePage(index) {
      if (this._scrollMatches && this._selected.pageIdx === index) {
        this._linkService.page = index + 1;
      }

      this._eventBus.dispatch('updatetextlayermatches', {
        source: this,
        pageIndex: index
      });
    }
  }, {
    key: "_updateAllPages",
    value: function _updateAllPages() {
      this._eventBus.dispatch('updatetextlayermatches', {
        source: this,
        pageIndex: -1
      });
    }
  }, {
    key: "_nextMatch",
    value: function _nextMatch() {
      var _this3 = this;

      var previous = this._state.findPrevious;
      var currentPageIndex = this._linkService.page - 1;
      var numPages = this._linkService.pagesCount;
      this._highlightMatches = true;

      if (this._dirtyMatch) {
        this._dirtyMatch = false;
        this._selected.pageIdx = this._selected.matchIdx = -1;
        this._offset.pageIdx = currentPageIndex;
        this._offset.matchIdx = null;
        this._offset.wrapped = false;
        this._resumePageIdx = null;
        this._pageMatches.length = 0;
        this._pageMatchesLength.length = 0;
        this._matchesCountTotal = 0;

        this._updateAllPages();

        for (var i = 0; i < numPages; i++) {
          if (this._pendingFindMatches[i] === true) {
            continue;
          }

          this._pendingFindMatches[i] = true;

          this._extractTextPromises[i].then(function (pageIdx) {
            delete _this3._pendingFindMatches[pageIdx];

            _this3._calculateMatch(pageIdx);
          });
        }
      }

      if (this._query === '') {
        this._updateUIState(FindState.FOUND);

        return;
      }

      if (this._resumePageIdx) {
        return;
      }

      var offset = this._offset;
      this._pagesToSearch = numPages;

      if (offset.matchIdx !== null) {
        var numPageMatches = this._pageMatches[offset.pageIdx].length;

        if (!previous && offset.matchIdx + 1 < numPageMatches || previous && offset.matchIdx > 0) {
          offset.matchIdx = previous ? offset.matchIdx - 1 : offset.matchIdx + 1;

          this._updateMatch(true);

          return;
        }

        this._advanceOffsetPage(previous);
      }

      this._nextPageMatch();
    }
  }, {
    key: "_matchesReady",
    value: function _matchesReady(matches) {
      var offset = this._offset;
      var numMatches = matches.length;
      var previous = this._state.findPrevious;

      if (numMatches) {
        offset.matchIdx = previous ? numMatches - 1 : 0;

        this._updateMatch(true);

        return true;
      }

      this._advanceOffsetPage(previous);

      if (offset.wrapped) {
        offset.matchIdx = null;

        if (this._pagesToSearch < 0) {
          this._updateMatch(false);

          return true;
        }
      }

      return false;
    }
  }, {
    key: "_nextPageMatch",
    value: function _nextPageMatch() {
      if (this._resumePageIdx !== null) {
        console.error('There can only be one pending page.');
      }

      var matches = null;

      do {
        var pageIdx = this._offset.pageIdx;
        matches = this._pageMatches[pageIdx];

        if (!matches) {
          this._resumePageIdx = pageIdx;
          break;
        }
      } while (!this._matchesReady(matches));
    }
  }, {
    key: "_advanceOffsetPage",
    value: function _advanceOffsetPage(previous) {
      var offset = this._offset;
      var numPages = this._linkService.pagesCount;
      offset.pageIdx = previous ? offset.pageIdx - 1 : offset.pageIdx + 1;
      offset.matchIdx = null;
      this._pagesToSearch--;

      if (offset.pageIdx >= numPages || offset.pageIdx < 0) {
        offset.pageIdx = previous ? numPages - 1 : 0;
        offset.wrapped = true;
      }
    }
  }, {
    key: "_updateMatch",
    value: function _updateMatch() {
      var found = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var state = FindState.NOT_FOUND;
      var wrapped = this._offset.wrapped;
      this._offset.wrapped = false;

      if (found) {
        var previousPage = this._selected.pageIdx;
        this._selected.pageIdx = this._offset.pageIdx;
        this._selected.matchIdx = this._offset.matchIdx;
        state = wrapped ? FindState.WRAPPED : FindState.FOUND;

        if (previousPage !== -1 && previousPage !== this._selected.pageIdx) {
          this._updatePage(previousPage);
        }
      }

      this._updateUIState(state, this._state.findPrevious);

      if (this._selected.pageIdx !== -1) {
        this._scrollMatches = true;

        this._updatePage(this._selected.pageIdx);
      }
    }
  }, {
    key: "_onFindBarClose",
    value: function _onFindBarClose(evt) {
      var _this4 = this;

      var pdfDocument = this._pdfDocument;

      this._firstPageCapability.promise.then(function () {
        if (!_this4._pdfDocument || pdfDocument && _this4._pdfDocument !== pdfDocument) {
          return;
        }

        if (_this4._findTimeout) {
          clearTimeout(_this4._findTimeout);
          _this4._findTimeout = null;
        }

        if (_this4._resumePageIdx) {
          _this4._resumePageIdx = null;
          _this4._dirtyMatch = true;
        }

        _this4._updateUIState(FindState.FOUND);

        _this4._highlightMatches = false;

        _this4._updateAllPages();
      });
    }
  }, {
    key: "_requestMatchesCount",
    value: function _requestMatchesCount() {
      var _this$_selected = this._selected,
          pageIdx = _this$_selected.pageIdx,
          matchIdx = _this$_selected.matchIdx;
      var current = 0,
          total = this._matchesCountTotal;

      if (matchIdx !== -1) {
        for (var i = 0; i < pageIdx; i++) {
          current += this._pageMatches[i] && this._pageMatches[i].length || 0;
        }

        current += matchIdx + 1;
      }

      if (current < 1 || current > total) {
        current = total = 0;
      }

      return {
        current: current,
        total: total
      };
    }
  }, {
    key: "_updateUIResultsCount",
    value: function _updateUIResultsCount() {
      this._eventBus.dispatch('updatefindmatchescount', {
        source: this,
        matchesCount: this._requestMatchesCount()
      });
    }
  }, {
    key: "_updateUIState",
    value: function _updateUIState(state, previous) {
      this._eventBus.dispatch('updatefindcontrolstate', {
        source: this,
        state: state,
        previous: previous,
        matchesCount: this._requestMatchesCount()
      });
    }
  }, {
    key: "highlightMatches",
    get: function get() {
      return this._highlightMatches;
    }
  }, {
    key: "pageMatches",
    get: function get() {
      return this._pageMatches;
    }
  }, {
    key: "pageMatchesLength",
    get: function get() {
      return this._pageMatchesLength;
    }
  }, {
    key: "selected",
    get: function get() {
      return this._selected;
    }
  }, {
    key: "state",
    get: function get() {
      return this._state;
    }
  }, {
    key: "_query",
    get: function get() {
      if (this._state.query !== this._rawQuery) {
        this._rawQuery = this._state.query;
        this._normalizedQuery = normalize(this._state.query);
      }

      return this._normalizedQuery;
    }
  }]);

  return PDFFindController;
}();

exports.PDFFindController = PDFFindController;

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCharacterType = getCharacterType;
exports.CharacterType = void 0;
var CharacterType = {
  SPACE: 0,
  ALPHA_LETTER: 1,
  PUNCT: 2,
  HAN_LETTER: 3,
  KATAKANA_LETTER: 4,
  HIRAGANA_LETTER: 5,
  HALFWIDTH_KATAKANA_LETTER: 6,
  THAI_LETTER: 7
};
exports.CharacterType = CharacterType;

function isAlphabeticalScript(charCode) {
  return charCode < 0x2E80;
}

function isAscii(charCode) {
  return (charCode & 0xFF80) === 0;
}

function isAsciiAlpha(charCode) {
  return charCode >= 0x61 && charCode <= 0x7A || charCode >= 0x41 && charCode <= 0x5A;
}

function isAsciiDigit(charCode) {
  return charCode >= 0x30 && charCode <= 0x39;
}

function isAsciiSpace(charCode) {
  return charCode === 0x20 || charCode === 0x09 || charCode === 0x0D || charCode === 0x0A;
}

function isHan(charCode) {
  return charCode >= 0x3400 && charCode <= 0x9FFF || charCode >= 0xF900 && charCode <= 0xFAFF;
}

function isKatakana(charCode) {
  return charCode >= 0x30A0 && charCode <= 0x30FF;
}

function isHiragana(charCode) {
  return charCode >= 0x3040 && charCode <= 0x309F;
}

function isHalfwidthKatakana(charCode) {
  return charCode >= 0xFF60 && charCode <= 0xFF9F;
}

function isThai(charCode) {
  return (charCode & 0xFF80) === 0x0E00;
}

function getCharacterType(charCode) {
  if (isAlphabeticalScript(charCode)) {
    if (isAscii(charCode)) {
      if (isAsciiSpace(charCode)) {
        return CharacterType.SPACE;
      } else if (isAsciiAlpha(charCode) || isAsciiDigit(charCode) || charCode === 0x5F) {
        return CharacterType.ALPHA_LETTER;
      }

      return CharacterType.PUNCT;
    } else if (isThai(charCode)) {
      return CharacterType.THAI_LETTER;
    } else if (charCode === 0xA0) {
      return CharacterType.SPACE;
    }

    return CharacterType.ALPHA_LETTER;
  }

  if (isHan(charCode)) {
    return CharacterType.HAN_LETTER;
  } else if (isKatakana(charCode)) {
    return CharacterType.KATAKANA_LETTER;
  } else if (isHiragana(charCode)) {
    return CharacterType.HIRAGANA_LETTER;
  } else if (isHalfwidthKatakana(charCode)) {
    return CharacterType.HALFWIDTH_KATAKANA_LETTER;
  }

  return CharacterType.ALPHA_LETTER;
}

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isDestHashesEqual = isDestHashesEqual;
exports.isDestArraysEqual = isDestArraysEqual;
exports.PDFHistory = void 0;

var _ui_utils = __webpack_require__(6);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var HASH_CHANGE_TIMEOUT = 1000;
var POSITION_UPDATED_THRESHOLD = 50;
var UPDATE_VIEWAREA_TIMEOUT = 1000;

function getCurrentHash() {
  return document.location.hash;
}

function parseCurrentHash(linkService) {
  var hash = unescape(getCurrentHash()).substring(1);
  var params = (0, _ui_utils.parseQueryString)(hash);
  var page = params.page | 0;

  if (!(Number.isInteger(page) && page > 0 && page <= linkService.pagesCount)) {
    page = null;
  }

  return {
    hash: hash,
    page: page,
    rotation: linkService.rotation
  };
}

var PDFHistory =
/*#__PURE__*/
function () {
  function PDFHistory(_ref) {
    var _this = this;

    var linkService = _ref.linkService,
        eventBus = _ref.eventBus;

    _classCallCheck(this, PDFHistory);

    this.linkService = linkService;
    this.eventBus = eventBus || (0, _ui_utils.getGlobalEventBus)();
    this.initialized = false;
    this.initialBookmark = null;
    this.initialRotation = null;
    this._boundEvents = Object.create(null);
    this._isViewerInPresentationMode = false;
    this._isPagesLoaded = false;
    this.eventBus.on('presentationmodechanged', function (evt) {
      _this._isViewerInPresentationMode = evt.active || evt.switchInProgress;
    });
    this.eventBus.on('pagesloaded', function (evt) {
      _this._isPagesLoaded = !!evt.pagesCount;
    });
  }

  _createClass(PDFHistory, [{
    key: "initialize",
    value: function initialize(_ref2) {
      var fingerprint = _ref2.fingerprint,
          _ref2$resetHistory = _ref2.resetHistory,
          resetHistory = _ref2$resetHistory === void 0 ? false : _ref2$resetHistory,
          _ref2$updateUrl = _ref2.updateUrl,
          updateUrl = _ref2$updateUrl === void 0 ? false : _ref2$updateUrl;

      if (!fingerprint || typeof fingerprint !== 'string') {
        console.error('PDFHistory.initialize: The "fingerprint" must be a non-empty string.');
        return;
      }

      var reInitialized = this.initialized && this.fingerprint !== fingerprint;
      this.fingerprint = fingerprint;
      this._updateUrl = updateUrl === true;

      if (!this.initialized) {
        this._bindEvents();
      }

      var state = window.history.state;
      this.initialized = true;
      this.initialBookmark = null;
      this.initialRotation = null;
      this._popStateInProgress = false;
      this._blockHashChange = 0;
      this._currentHash = getCurrentHash();
      this._numPositionUpdates = 0;
      this._uid = this._maxUid = 0;
      this._destination = null;
      this._position = null;

      if (!this._isValidState(state, true) || resetHistory) {
        var _parseCurrentHash = parseCurrentHash(this.linkService),
            hash = _parseCurrentHash.hash,
            page = _parseCurrentHash.page,
            rotation = _parseCurrentHash.rotation;

        if (!hash || reInitialized || resetHistory) {
          this._pushOrReplaceState(null, true);

          return;
        }

        this._pushOrReplaceState({
          hash: hash,
          page: page,
          rotation: rotation
        }, true);

        return;
      }

      var destination = state.destination;

      this._updateInternalState(destination, state.uid, true);

      if (this._uid > this._maxUid) {
        this._maxUid = this._uid;
      }

      if (destination.rotation !== undefined) {
        this.initialRotation = destination.rotation;
      }

      if (destination.dest) {
        this.initialBookmark = JSON.stringify(destination.dest);
        this._destination.page = null;
      } else if (destination.hash) {
        this.initialBookmark = destination.hash;
      } else if (destination.page) {
        this.initialBookmark = "page=".concat(destination.page);
      }
    }
  }, {
    key: "push",
    value: function push(_ref3) {
      var _this2 = this;

      var _ref3$namedDest = _ref3.namedDest,
          namedDest = _ref3$namedDest === void 0 ? null : _ref3$namedDest,
          explicitDest = _ref3.explicitDest,
          pageNumber = _ref3.pageNumber;

      if (!this.initialized) {
        return;
      }

      if (namedDest && typeof namedDest !== 'string') {
        console.error('PDFHistory.push: ' + "\"".concat(namedDest, "\" is not a valid namedDest parameter."));
        return;
      } else if (!Array.isArray(explicitDest)) {
        console.error('PDFHistory.push: ' + "\"".concat(explicitDest, "\" is not a valid explicitDest parameter."));
        return;
      } else if (!(Number.isInteger(pageNumber) && pageNumber > 0 && pageNumber <= this.linkService.pagesCount)) {
        if (pageNumber !== null || this._destination) {
          console.error('PDFHistory.push: ' + "\"".concat(pageNumber, "\" is not a valid pageNumber parameter."));
          return;
        }
      }

      var hash = namedDest || JSON.stringify(explicitDest);

      if (!hash) {
        return;
      }

      var forceReplace = false;

      if (this._destination && (isDestHashesEqual(this._destination.hash, hash) || isDestArraysEqual(this._destination.dest, explicitDest))) {
        if (this._destination.page) {
          return;
        }

        forceReplace = true;
      }

      if (this._popStateInProgress && !forceReplace) {
        return;
      }

      this._pushOrReplaceState({
        dest: explicitDest,
        hash: hash,
        page: pageNumber,
        rotation: this.linkService.rotation
      }, forceReplace);

      if (!this._popStateInProgress) {
        this._popStateInProgress = true;
        Promise.resolve().then(function () {
          _this2._popStateInProgress = false;
        });
      }
    }
  }, {
    key: "pushCurrentPosition",
    value: function pushCurrentPosition() {
      if (!this.initialized || this._popStateInProgress) {
        return;
      }

      this._tryPushCurrentPosition();
    }
  }, {
    key: "back",
    value: function back() {
      if (!this.initialized || this._popStateInProgress) {
        return;
      }

      var state = window.history.state;

      if (this._isValidState(state) && state.uid > 0) {
        window.history.back();
      }
    }
  }, {
    key: "forward",
    value: function forward() {
      if (!this.initialized || this._popStateInProgress) {
        return;
      }

      var state = window.history.state;

      if (this._isValidState(state) && state.uid < this._maxUid) {
        window.history.forward();
      }
    }
  }, {
    key: "_pushOrReplaceState",
    value: function _pushOrReplaceState(destination) {
      var forceReplace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var shouldReplace = forceReplace || !this._destination;
      var newState = {
        fingerprint: this.fingerprint,
        uid: shouldReplace ? this._uid : this._uid + 1,
        destination: destination
      };

      this._updateInternalState(destination, newState.uid);

      var newUrl;

      if (this._updateUrl && destination && destination.hash) {
        var baseUrl = document.location.href.split('#')[0];

        if (!baseUrl.startsWith('file://')) {
          newUrl = "".concat(baseUrl, "#").concat(destination.hash);
        }
      }

      if (shouldReplace) {
        if (newUrl) {
          window.history.replaceState(newState, '', newUrl);
        } else {
          window.history.replaceState(newState, '');
        }
      } else {
        this._maxUid = this._uid;

        if (newUrl) {
          window.history.pushState(newState, '', newUrl);
        } else {
          window.history.pushState(newState, '');
        }
      }
    }
  }, {
    key: "_tryPushCurrentPosition",
    value: function _tryPushCurrentPosition() {
      var temporary = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!this._position) {
        return;
      }

      var position = this._position;

      if (temporary) {
        position = Object.assign(Object.create(null), this._position);
        position.temporary = true;
      }

      if (!this._destination) {
        this._pushOrReplaceState(position);

        return;
      }

      if (this._destination.temporary) {
        this._pushOrReplaceState(position, true);

        return;
      }

      if (this._destination.hash === position.hash) {
        return;
      }

      if (!this._destination.page && (POSITION_UPDATED_THRESHOLD <= 0 || this._numPositionUpdates <= POSITION_UPDATED_THRESHOLD)) {
        return;
      }

      var forceReplace = false;

      if (this._destination.page >= position.first && this._destination.page <= position.page) {
        if (this._destination.dest || !this._destination.first) {
          return;
        }

        forceReplace = true;
      }

      this._pushOrReplaceState(position, forceReplace);
    }
  }, {
    key: "_isValidState",
    value: function _isValidState(state) {
      var checkReload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (!state) {
        return false;
      }

      if (state.fingerprint !== this.fingerprint) {
        if (checkReload) {
          if (typeof state.fingerprint !== 'string' || state.fingerprint.length !== this.fingerprint.length) {
            return false;
          }

          var _performance$getEntri = performance.getEntriesByType('navigation'),
              _performance$getEntri2 = _slicedToArray(_performance$getEntri, 1),
              perfEntry = _performance$getEntri2[0];

          if (!perfEntry || perfEntry.type !== 'reload') {
            return false;
          }
        } else {
          return false;
        }
      }

      if (!Number.isInteger(state.uid) || state.uid < 0) {
        return false;
      }

      if (state.destination === null || _typeof(state.destination) !== 'object') {
        return false;
      }

      return true;
    }
  }, {
    key: "_updateInternalState",
    value: function _updateInternalState(destination, uid) {
      var removeTemporary = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (this._updateViewareaTimeout) {
        clearTimeout(this._updateViewareaTimeout);
        this._updateViewareaTimeout = null;
      }

      if (removeTemporary && destination && destination.temporary) {
        delete destination.temporary;
      }

      this._destination = destination;
      this._uid = uid;
      this._numPositionUpdates = 0;
    }
  }, {
    key: "_updateViewarea",
    value: function _updateViewarea(_ref4) {
      var _this3 = this;

      var location = _ref4.location;

      if (this._updateViewareaTimeout) {
        clearTimeout(this._updateViewareaTimeout);
        this._updateViewareaTimeout = null;
      }

      this._position = {
        hash: this._isViewerInPresentationMode ? "page=".concat(location.pageNumber) : location.pdfOpenParams.substring(1),
        page: this.linkService.page,
        first: location.pageNumber,
        rotation: location.rotation
      };

      if (this._popStateInProgress) {
        return;
      }

      if (POSITION_UPDATED_THRESHOLD > 0 && this._isPagesLoaded && this._destination && !this._destination.page) {
        this._numPositionUpdates++;
      }

      if (UPDATE_VIEWAREA_TIMEOUT > 0) {
        this._updateViewareaTimeout = setTimeout(function () {
          if (!_this3._popStateInProgress) {
            _this3._tryPushCurrentPosition(true);
          }

          _this3._updateViewareaTimeout = null;
        }, UPDATE_VIEWAREA_TIMEOUT);
      }
    }
  }, {
    key: "_popState",
    value: function _popState(_ref5) {
      var _this4 = this;

      var state = _ref5.state;
      var newHash = getCurrentHash(),
          hashChanged = this._currentHash !== newHash;
      this._currentHash = newHash;

      if (!state || false) {
        this._uid++;

        var _parseCurrentHash2 = parseCurrentHash(this.linkService),
            hash = _parseCurrentHash2.hash,
            page = _parseCurrentHash2.page,
            rotation = _parseCurrentHash2.rotation;

        this._pushOrReplaceState({
          hash: hash,
          page: page,
          rotation: rotation
        }, true);

        return;
      }

      if (!this._isValidState(state)) {
        return;
      }

      this._popStateInProgress = true;

      if (hashChanged) {
        this._blockHashChange++;
        (0, _ui_utils.waitOnEventOrTimeout)({
          target: window,
          name: 'hashchange',
          delay: HASH_CHANGE_TIMEOUT
        }).then(function () {
          _this4._blockHashChange--;
        });
      }

      var destination = state.destination;

      this._updateInternalState(destination, state.uid, true);

      if (this._uid > this._maxUid) {
        this._maxUid = this._uid;
      }

      if ((0, _ui_utils.isValidRotation)(destination.rotation)) {
        this.linkService.rotation = destination.rotation;
      }

      if (destination.dest) {
        this.linkService.navigateTo(destination.dest);
      } else if (destination.hash) {
        this.linkService.setHash(destination.hash);
      } else if (destination.page) {
        this.linkService.page = destination.page;
      }

      Promise.resolve().then(function () {
        _this4._popStateInProgress = false;
      });
    }
  }, {
    key: "_bindEvents",
    value: function _bindEvents() {
      var _this5 = this;

      var _boundEvents = this._boundEvents,
          eventBus = this.eventBus;
      _boundEvents.updateViewarea = this._updateViewarea.bind(this);
      _boundEvents.popState = this._popState.bind(this);

      _boundEvents.pageHide = function (evt) {
        if (!_this5._destination || _this5._destination.temporary) {
          _this5._tryPushCurrentPosition();
        }
      };

      eventBus.on('updateviewarea', _boundEvents.updateViewarea);
      window.addEventListener('popstate', _boundEvents.popState);
      window.addEventListener('pagehide', _boundEvents.pageHide);
    }
  }, {
    key: "popStateInProgress",
    get: function get() {
      return this.initialized && (this._popStateInProgress || this._blockHashChange > 0);
    }
  }]);

  return PDFHistory;
}();

exports.PDFHistory = PDFHistory;

function isDestHashesEqual(destHash, pushHash) {
  if (typeof destHash !== 'string' || typeof pushHash !== 'string') {
    return false;
  }

  if (destHash === pushHash) {
    return true;
  }

  var _parseQueryString = (0, _ui_utils.parseQueryString)(destHash),
      nameddest = _parseQueryString.nameddest;

  if (nameddest === pushHash) {
    return true;
  }

  return false;
}

function isDestArraysEqual(firstDest, secondDest) {
  function isEntryEqual(first, second) {
    if (_typeof(first) !== _typeof(second)) {
      return false;
    }

    if (Array.isArray(first) || Array.isArray(second)) {
      return false;
    }

    if (first !== null && _typeof(first) === 'object' && second !== null) {
      if (Object.keys(first).length !== Object.keys(second).length) {
        return false;
      }

      for (var key in first) {
        if (!isEntryEqual(first[key], second[key])) {
          return false;
        }
      }

      return true;
    }

    return first === second || Number.isNaN(first) && Number.isNaN(second);
  }

  if (!(Array.isArray(firstDest) && Array.isArray(secondDest))) {
    return false;
  }

  if (firstDest.length !== secondDest.length) {
    return false;
  }

  for (var i = 0, ii = firstDest.length; i < ii; i++) {
    if (!isEntryEqual(firstDest[i], secondDest[i])) {
      return false;
    }
  }

  return true;
}

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SimpleLinkService = exports.PDFLinkService = void 0;

var _ui_utils = __webpack_require__(6);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var PDFLinkService =
/*#__PURE__*/
function () {
  function PDFLinkService() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        eventBus = _ref.eventBus,
        _ref$externalLinkTarg = _ref.externalLinkTarget,
        externalLinkTarget = _ref$externalLinkTarg === void 0 ? null : _ref$externalLinkTarg,
        _ref$externalLinkRel = _ref.externalLinkRel,
        externalLinkRel = _ref$externalLinkRel === void 0 ? null : _ref$externalLinkRel;

    _classCallCheck(this, PDFLinkService);

    this.eventBus = eventBus || (0, _ui_utils.getGlobalEventBus)();
    this.externalLinkTarget = externalLinkTarget;
    this.externalLinkRel = externalLinkRel;
    this.baseUrl = null;
    this.pdfDocument = null;
    this.pdfViewer = null;
    this.pdfHistory = null;
    this._pagesRefCache = null;
  }

  _createClass(PDFLinkService, [{
    key: "setDocument",
    value: function setDocument(pdfDocument) {
      var baseUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      this.baseUrl = baseUrl;
      this.pdfDocument = pdfDocument;
      this._pagesRefCache = Object.create(null);
    }
  }, {
    key: "setViewer",
    value: function setViewer(pdfViewer) {
      this.pdfViewer = pdfViewer;
    }
  }, {
    key: "setHistory",
    value: function setHistory(pdfHistory) {
      this.pdfHistory = pdfHistory;
    }
  }, {
    key: "navigateTo",
    value: function navigateTo(dest) {
      var _this = this;

      var goToDestination = function goToDestination(_ref2) {
        var namedDest = _ref2.namedDest,
            explicitDest = _ref2.explicitDest;
        var destRef = explicitDest[0],
            pageNumber;

        if (destRef instanceof Object) {
          pageNumber = _this._cachedPageNumber(destRef);

          if (pageNumber === null) {
            _this.pdfDocument.getPageIndex(destRef).then(function (pageIndex) {
              _this.cachePageRef(pageIndex + 1, destRef);

              goToDestination({
                namedDest: namedDest,
                explicitDest: explicitDest
              });
            }).catch(function () {
              console.error("PDFLinkService.navigateTo: \"".concat(destRef, "\" is not ") + "a valid page reference, for dest=\"".concat(dest, "\"."));
            });

            return;
          }
        } else if (Number.isInteger(destRef)) {
          pageNumber = destRef + 1;
        } else {
          console.error("PDFLinkService.navigateTo: \"".concat(destRef, "\" is not ") + "a valid destination reference, for dest=\"".concat(dest, "\"."));
          return;
        }

        if (!pageNumber || pageNumber < 1 || pageNumber > _this.pagesCount) {
          console.error("PDFLinkService.navigateTo: \"".concat(pageNumber, "\" is not ") + "a valid page number, for dest=\"".concat(dest, "\"."));
          return;
        }

        if (_this.pdfHistory) {
          _this.pdfHistory.pushCurrentPosition();

          _this.pdfHistory.push({
            namedDest: namedDest,
            explicitDest: explicitDest,
            pageNumber: pageNumber
          });
        }

        _this.pdfViewer.scrollPageIntoView({
          pageNumber: pageNumber,
          destArray: explicitDest
        });
      };

      new Promise(function (resolve, reject) {
        if (typeof dest === 'string') {
          _this.pdfDocument.getDestination(dest).then(function (destArray) {
            resolve({
              namedDest: dest,
              explicitDest: destArray
            });
          });

          return;
        }

        resolve({
          namedDest: '',
          explicitDest: dest
        });
      }).then(function (data) {
        if (!Array.isArray(data.explicitDest)) {
          console.error("PDFLinkService.navigateTo: \"".concat(data.explicitDest, "\" is") + " not a valid destination array, for dest=\"".concat(dest, "\"."));
          return;
        }

        goToDestination(data);
      });
    }
  }, {
    key: "getDestinationHash",
    value: function getDestinationHash(dest) {
      if (typeof dest === 'string') {
        return this.getAnchorUrl('#' + escape(dest));
      }

      if (Array.isArray(dest)) {
        var str = JSON.stringify(dest);
        return this.getAnchorUrl('#' + escape(str));
      }

      return this.getAnchorUrl('');
    }
  }, {
    key: "getAnchorUrl",
    value: function getAnchorUrl(anchor) {
      return (this.baseUrl || '') + anchor;
    }
  }, {
    key: "setHash",
    value: function setHash(hash) {
      var pageNumber, dest;

      if (hash.includes('=')) {
        var params = (0, _ui_utils.parseQueryString)(hash);

        if ('search' in params) {
          this.eventBus.dispatch('findfromurlhash', {
            source: this,
            query: params['search'].replace(/"/g, ''),
            phraseSearch: params['phrase'] === 'true'
          });
        }

        if ('nameddest' in params) {
          this.navigateTo(params.nameddest);
          return;
        }

        if ('page' in params) {
          pageNumber = params.page | 0 || 1;
        }

        if ('zoom' in params) {
          var zoomArgs = params.zoom.split(',');
          var zoomArg = zoomArgs[0];
          var zoomArgNumber = parseFloat(zoomArg);

          if (!zoomArg.includes('Fit')) {
            dest = [null, {
              name: 'XYZ'
            }, zoomArgs.length > 1 ? zoomArgs[1] | 0 : null, zoomArgs.length > 2 ? zoomArgs[2] | 0 : null, zoomArgNumber ? zoomArgNumber / 100 : zoomArg];
          } else {
            if (zoomArg === 'Fit' || zoomArg === 'FitB') {
              dest = [null, {
                name: zoomArg
              }];
            } else if (zoomArg === 'FitH' || zoomArg === 'FitBH' || zoomArg === 'FitV' || zoomArg === 'FitBV') {
              dest = [null, {
                name: zoomArg
              }, zoomArgs.length > 1 ? zoomArgs[1] | 0 : null];
            } else if (zoomArg === 'FitR') {
              if (zoomArgs.length !== 5) {
                console.error('PDFLinkService.setHash: Not enough parameters for "FitR".');
              } else {
                dest = [null, {
                  name: zoomArg
                }, zoomArgs[1] | 0, zoomArgs[2] | 0, zoomArgs[3] | 0, zoomArgs[4] | 0];
              }
            } else {
              console.error("PDFLinkService.setHash: \"".concat(zoomArg, "\" is not ") + 'a valid zoom value.');
            }
          }
        }

        if (dest) {
          this.pdfViewer.scrollPageIntoView({
            pageNumber: pageNumber || this.page,
            destArray: dest,
            allowNegativeOffset: true
          });
        } else if (pageNumber) {
          this.page = pageNumber;
        }

        if ('pagemode' in params) {
          this.eventBus.dispatch('pagemode', {
            source: this,
            mode: params.pagemode
          });
        }
      } else {
        dest = unescape(hash);

        try {
          dest = JSON.parse(dest);

          if (!Array.isArray(dest)) {
            dest = dest.toString();
          }
        } catch (ex) {}

        if (typeof dest === 'string' || isValidExplicitDestination(dest)) {
          this.navigateTo(dest);
          return;
        }

        console.error("PDFLinkService.setHash: \"".concat(unescape(hash), "\" is not ") + 'a valid destination.');
      }
    }
  }, {
    key: "executeNamedAction",
    value: function executeNamedAction(action) {
      switch (action) {
        case 'GoBack':
          if (this.pdfHistory) {
            this.pdfHistory.back();
          }

          break;

        case 'GoForward':
          if (this.pdfHistory) {
            this.pdfHistory.forward();
          }

          break;

        case 'NextPage':
          if (this.page < this.pagesCount) {
            this.page++;
          }

          break;

        case 'PrevPage':
          if (this.page > 1) {
            this.page--;
          }

          break;

        case 'LastPage':
          this.page = this.pagesCount;
          break;

        case 'FirstPage':
          this.page = 1;
          break;

        default:
          break;
      }

      this.eventBus.dispatch('namedaction', {
        source: this,
        action: action
      });
    }
  }, {
    key: "cachePageRef",
    value: function cachePageRef(pageNum, pageRef) {
      if (!pageRef) {
        return;
      }

      var refStr = pageRef.num + ' ' + pageRef.gen + ' R';
      this._pagesRefCache[refStr] = pageNum;
    }
  }, {
    key: "_cachedPageNumber",
    value: function _cachedPageNumber(pageRef) {
      var refStr = pageRef.num + ' ' + pageRef.gen + ' R';
      return this._pagesRefCache && this._pagesRefCache[refStr] || null;
    }
  }, {
    key: "isPageVisible",
    value: function isPageVisible(pageNumber) {
      return this.pdfViewer.isPageVisible(pageNumber);
    }
  }, {
    key: "pagesCount",
    get: function get() {
      return this.pdfDocument ? this.pdfDocument.numPages : 0;
    }
  }, {
    key: "page",
    get: function get() {
      return this.pdfViewer.currentPageNumber;
    },
    set: function set(value) {
      this.pdfViewer.currentPageNumber = value;
    }
  }, {
    key: "rotation",
    get: function get() {
      return this.pdfViewer.pagesRotation;
    },
    set: function set(value) {
      this.pdfViewer.pagesRotation = value;
    }
  }]);

  return PDFLinkService;
}();

exports.PDFLinkService = PDFLinkService;

function isValidExplicitDestination(dest) {
  if (!Array.isArray(dest)) {
    return false;
  }

  var destLength = dest.length,
      allowNull = true;

  if (destLength < 2) {
    return false;
  }

  var page = dest[0];

  if (!(_typeof(page) === 'object' && Number.isInteger(page.num) && Number.isInteger(page.gen)) && !(Number.isInteger(page) && page >= 0)) {
    return false;
  }

  var zoom = dest[1];

  if (!(_typeof(zoom) === 'object' && typeof zoom.name === 'string')) {
    return false;
  }

  switch (zoom.name) {
    case 'XYZ':
      if (destLength !== 5) {
        return false;
      }

      break;

    case 'Fit':
    case 'FitB':
      return destLength === 2;

    case 'FitH':
    case 'FitBH':
    case 'FitV':
    case 'FitBV':
      if (destLength !== 3) {
        return false;
      }

      break;

    case 'FitR':
      if (destLength !== 6) {
        return false;
      }

      allowNull = false;
      break;

    default:
      return false;
  }

  for (var i = 2; i < destLength; i++) {
    var param = dest[i];

    if (!(typeof param === 'number' || allowNull && param === null)) {
      return false;
    }
  }

  return true;
}

var SimpleLinkService =
/*#__PURE__*/
function () {
  function SimpleLinkService() {
    _classCallCheck(this, SimpleLinkService);

    this.externalLinkTarget = null;
    this.externalLinkRel = null;
  }

  _createClass(SimpleLinkService, [{
    key: "navigateTo",
    value: function navigateTo(dest) {}
  }, {
    key: "getDestinationHash",
    value: function getDestinationHash(dest) {
      return '#';
    }
  }, {
    key: "getAnchorUrl",
    value: function getAnchorUrl(hash) {
      return '#';
    }
  }, {
    key: "setHash",
    value: function setHash(hash) {}
  }, {
    key: "executeNamedAction",
    value: function executeNamedAction(action) {}
  }, {
    key: "cachePageRef",
    value: function cachePageRef(pageNum, pageRef) {}
  }, {
    key: "isPageVisible",
    value: function isPageVisible(pageNumber) {
      return true;
    }
  }, {
    key: "pagesCount",
    get: function get() {
      return 0;
    }
  }, {
    key: "page",
    get: function get() {
      return 0;
    },
    set: function set(value) {}
  }, {
    key: "rotation",
    get: function get() {
      return 0;
    },
    set: function set(value) {}
  }]);

  return SimpleLinkService;
}();

exports.SimpleLinkService = SimpleLinkService;

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFOutlineViewer = void 0;

var _pdfjsLib = __webpack_require__(7);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEFAULT_TITLE = "\u2013";

var PDFOutlineViewer =
/*#__PURE__*/
function () {
  function PDFOutlineViewer(_ref) {
    var container = _ref.container,
        linkService = _ref.linkService,
        eventBus = _ref.eventBus;

    _classCallCheck(this, PDFOutlineViewer);

    this.container = container;
    this.linkService = linkService;
    this.eventBus = eventBus;
    this.reset();
    eventBus.on('toggleoutlinetree', this.toggleOutlineTree.bind(this));
  }

  _createClass(PDFOutlineViewer, [{
    key: "reset",
    value: function reset() {
      this.outline = null;
      this.lastToggleIsShow = true;
      this.container.textContent = '';
      this.container.classList.remove('outlineWithDeepNesting');
    }
  }, {
    key: "_dispatchEvent",
    value: function _dispatchEvent(outlineCount) {
      this.eventBus.dispatch('outlineloaded', {
        source: this,
        outlineCount: outlineCount
      });
    }
  }, {
    key: "_bindLink",
    value: function _bindLink(element, _ref2) {
      var url = _ref2.url,
          newWindow = _ref2.newWindow,
          dest = _ref2.dest;
      var linkService = this.linkService;

      if (url) {
        (0, _pdfjsLib.addLinkAttributes)(element, {
          url: url,
          target: newWindow ? _pdfjsLib.LinkTarget.BLANK : linkService.externalLinkTarget,
          rel: linkService.externalLinkRel
        });
        return;
      }

      element.href = linkService.getDestinationHash(dest);

      element.onclick = function () {
        if (dest) {
          linkService.navigateTo(dest);
        }

        return false;
      };
    }
  }, {
    key: "_setStyles",
    value: function _setStyles(element, _ref3) {
      var bold = _ref3.bold,
          italic = _ref3.italic;
      var styleStr = '';

      if (bold) {
        styleStr += 'font-weight: bold;';
      }

      if (italic) {
        styleStr += 'font-style: italic;';
      }

      if (styleStr) {
        element.setAttribute('style', styleStr);
      }
    }
  }, {
    key: "_addToggleButton",
    value: function _addToggleButton(div) {
      var _this = this;

      var toggler = document.createElement('div');
      toggler.className = 'outlineItemToggler';

      toggler.onclick = function (evt) {
        evt.stopPropagation();
        toggler.classList.toggle('outlineItemsHidden');

        if (evt.shiftKey) {
          var shouldShowAll = !toggler.classList.contains('outlineItemsHidden');

          _this._toggleOutlineItem(div, shouldShowAll);
        }
      };

      div.insertBefore(toggler, div.firstChild);
    }
  }, {
    key: "_toggleOutlineItem",
    value: function _toggleOutlineItem(root) {
      var show = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      this.lastToggleIsShow = show;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = root.querySelectorAll('.outlineItemToggler')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var toggler = _step.value;
          toggler.classList.toggle('outlineItemsHidden', !show);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: "toggleOutlineTree",
    value: function toggleOutlineTree() {
      if (!this.outline) {
        return;
      }

      this._toggleOutlineItem(this.container, !this.lastToggleIsShow);
    }
  }, {
    key: "render",
    value: function render(_ref4) {
      var outline = _ref4.outline;
      var outlineCount = 0;

      if (this.outline) {
        this.reset();
      }

      this.outline = outline || null;

      if (!outline) {
        this._dispatchEvent(outlineCount);

        return;
      }

      var fragment = document.createDocumentFragment();
      var queue = [{
        parent: fragment,
        items: this.outline
      }];
      var hasAnyNesting = false;

      while (queue.length > 0) {
        var levelData = queue.shift();

        for (var i = 0, len = levelData.items.length; i < len; i++) {
          var item = levelData.items[i];
          var div = document.createElement('div');
          div.className = 'outlineItem';
          var element = document.createElement('a');

          this._bindLink(element, item);

          this._setStyles(element, item);

          element.textContent = (0, _pdfjsLib.removeNullCharacters)(item.title) || DEFAULT_TITLE;
          div.appendChild(element);

          if (item.items.length > 0) {
            hasAnyNesting = true;

            this._addToggleButton(div);

            var itemsDiv = document.createElement('div');
            itemsDiv.className = 'outlineItems';
            div.appendChild(itemsDiv);
            queue.push({
              parent: itemsDiv,
              items: item.items
            });
          }

          levelData.parent.appendChild(div);
          outlineCount++;
        }
      }

      if (hasAnyNesting) {
        this.container.classList.add('outlineWithDeepNesting');
      }

      this.container.appendChild(fragment);

      this._dispatchEvent(outlineCount);
    }
  }]);

  return PDFOutlineViewer;
}();

exports.PDFOutlineViewer = PDFOutlineViewer;

/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFPresentationMode = void 0;

var _ui_utils = __webpack_require__(6);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DELAY_BEFORE_RESETTING_SWITCH_IN_PROGRESS = 1500;
var DELAY_BEFORE_HIDING_CONTROLS = 3000;
var ACTIVE_SELECTOR = 'pdfPresentationMode';
var CONTROLS_SELECTOR = 'pdfPresentationModeControls';
var MOUSE_SCROLL_COOLDOWN_TIME = 50;
var PAGE_SWITCH_THRESHOLD = 0.1;
var SWIPE_MIN_DISTANCE_THRESHOLD = 50;
var SWIPE_ANGLE_THRESHOLD = Math.PI / 6;

var PDFPresentationMode =
/*#__PURE__*/
function () {
  function PDFPresentationMode(_ref) {
    var _this = this;

    var container = _ref.container,
        _ref$viewer = _ref.viewer,
        viewer = _ref$viewer === void 0 ? null : _ref$viewer,
        pdfViewer = _ref.pdfViewer,
        eventBus = _ref.eventBus,
        _ref$contextMenuItems = _ref.contextMenuItems,
        contextMenuItems = _ref$contextMenuItems === void 0 ? null : _ref$contextMenuItems;

    _classCallCheck(this, PDFPresentationMode);

    this.container = container;
    this.viewer = viewer || container.firstElementChild;
    this.pdfViewer = pdfViewer;
    this.eventBus = eventBus;
    this.active = false;
    this.args = null;
    this.contextMenuOpen = false;
    this.mouseScrollTimeStamp = 0;
    this.mouseScrollDelta = 0;
    this.touchSwipeState = null;

    if (contextMenuItems) {
      contextMenuItems.contextFirstPage.addEventListener('click', function () {
        _this.contextMenuOpen = false;

        _this.eventBus.dispatch('firstpage', {
          source: _this
        });
      });
      contextMenuItems.contextLastPage.addEventListener('click', function () {
        _this.contextMenuOpen = false;

        _this.eventBus.dispatch('lastpage', {
          source: _this
        });
      });
      contextMenuItems.contextPageRotateCw.addEventListener('click', function () {
        _this.contextMenuOpen = false;

        _this.eventBus.dispatch('rotatecw', {
          source: _this
        });
      });
      contextMenuItems.contextPageRotateCcw.addEventListener('click', function () {
        _this.contextMenuOpen = false;

        _this.eventBus.dispatch('rotateccw', {
          source: _this
        });
      });
    }
  }

  _createClass(PDFPresentationMode, [{
    key: "request",
    value: function request() {
      if (this.switchInProgress || this.active || !this.viewer.hasChildNodes()) {
        return false;
      }

      this._addFullscreenChangeListeners();

      this._setSwitchInProgress();

      this._notifyStateChange();

      if (this.container.requestFullscreen) {
        this.container.requestFullscreen();
      } else if (this.container.mozRequestFullScreen) {
        this.container.mozRequestFullScreen();
      } else if (this.container.webkitRequestFullscreen) {
        this.container.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
      } else if (this.container.msRequestFullscreen) {
        this.container.msRequestFullscreen();
      } else {
        return false;
      }

      this.args = {
        page: this.pdfViewer.currentPageNumber,
        previousScale: this.pdfViewer.currentScaleValue
      };
      return true;
    }
  }, {
    key: "_mouseWheel",
    value: function _mouseWheel(evt) {
      if (!this.active) {
        return;
      }

      evt.preventDefault();
      var delta = (0, _ui_utils.normalizeWheelEventDelta)(evt);
      var currentTime = new Date().getTime();
      var storedTime = this.mouseScrollTimeStamp;

      if (currentTime > storedTime && currentTime - storedTime < MOUSE_SCROLL_COOLDOWN_TIME) {
        return;
      }

      if (this.mouseScrollDelta > 0 && delta < 0 || this.mouseScrollDelta < 0 && delta > 0) {
        this._resetMouseScrollState();
      }

      this.mouseScrollDelta += delta;

      if (Math.abs(this.mouseScrollDelta) >= PAGE_SWITCH_THRESHOLD) {
        var totalDelta = this.mouseScrollDelta;

        this._resetMouseScrollState();

        var success = totalDelta > 0 ? this._goToPreviousPage() : this._goToNextPage();

        if (success) {
          this.mouseScrollTimeStamp = currentTime;
        }
      }
    }
  }, {
    key: "_goToPreviousPage",
    value: function _goToPreviousPage() {
      var page = this.pdfViewer.currentPageNumber;

      if (page <= 1) {
        return false;
      }

      this.pdfViewer.currentPageNumber = page - 1;
      return true;
    }
  }, {
    key: "_goToNextPage",
    value: function _goToNextPage() {
      var page = this.pdfViewer.currentPageNumber;

      if (page >= this.pdfViewer.pagesCount) {
        return false;
      }

      this.pdfViewer.currentPageNumber = page + 1;
      return true;
    }
  }, {
    key: "_notifyStateChange",
    value: function _notifyStateChange() {
      this.eventBus.dispatch('presentationmodechanged', {
        source: this,
        active: this.active,
        switchInProgress: !!this.switchInProgress
      });
    }
  }, {
    key: "_setSwitchInProgress",
    value: function _setSwitchInProgress() {
      var _this2 = this;

      if (this.switchInProgress) {
        clearTimeout(this.switchInProgress);
      }

      this.switchInProgress = setTimeout(function () {
        _this2._removeFullscreenChangeListeners();

        delete _this2.switchInProgress;

        _this2._notifyStateChange();
      }, DELAY_BEFORE_RESETTING_SWITCH_IN_PROGRESS);
    }
  }, {
    key: "_resetSwitchInProgress",
    value: function _resetSwitchInProgress() {
      if (this.switchInProgress) {
        clearTimeout(this.switchInProgress);
        delete this.switchInProgress;
      }
    }
  }, {
    key: "_enter",
    value: function _enter() {
      var _this3 = this;

      this.active = true;

      this._resetSwitchInProgress();

      this._notifyStateChange();

      this.container.classList.add(ACTIVE_SELECTOR);
      setTimeout(function () {
        _this3.pdfViewer.currentPageNumber = _this3.args.page;
        _this3.pdfViewer.currentScaleValue = 'page-fit';
      }, 0);

      this._addWindowListeners();

      this._showControls();

      this.contextMenuOpen = false;
      this.container.setAttribute('contextmenu', 'viewerContextMenu');
      window.getSelection().removeAllRanges();
    }
  }, {
    key: "_exit",
    value: function _exit() {
      var _this4 = this;

      var page = this.pdfViewer.currentPageNumber;
      this.container.classList.remove(ACTIVE_SELECTOR);
      setTimeout(function () {
        _this4.active = false;

        _this4._removeFullscreenChangeListeners();

        _this4._notifyStateChange();

        _this4.pdfViewer.currentScaleValue = _this4.args.previousScale;
        _this4.pdfViewer.currentPageNumber = page;
        _this4.args = null;
      }, 0);

      this._removeWindowListeners();

      this._hideControls();

      this._resetMouseScrollState();

      this.container.removeAttribute('contextmenu');
      this.contextMenuOpen = false;
    }
  }, {
    key: "_mouseDown",
    value: function _mouseDown(evt) {
      if (this.contextMenuOpen) {
        this.contextMenuOpen = false;
        evt.preventDefault();
        return;
      }

      if (evt.button === 0) {
        var isInternalLink = evt.target.href && evt.target.classList.contains('internalLink');

        if (!isInternalLink) {
          evt.preventDefault();

          if (evt.shiftKey) {
            this._goToPreviousPage();
          } else {
            this._goToNextPage();
          }
        }
      }
    }
  }, {
    key: "_contextMenu",
    value: function _contextMenu() {
      this.contextMenuOpen = true;
    }
  }, {
    key: "_showControls",
    value: function _showControls() {
      var _this5 = this;

      if (this.controlsTimeout) {
        clearTimeout(this.controlsTimeout);
      } else {
        this.container.classList.add(CONTROLS_SELECTOR);
      }

      this.controlsTimeout = setTimeout(function () {
        _this5.container.classList.remove(CONTROLS_SELECTOR);

        delete _this5.controlsTimeout;
      }, DELAY_BEFORE_HIDING_CONTROLS);
    }
  }, {
    key: "_hideControls",
    value: function _hideControls() {
      if (!this.controlsTimeout) {
        return;
      }

      clearTimeout(this.controlsTimeout);
      this.container.classList.remove(CONTROLS_SELECTOR);
      delete this.controlsTimeout;
    }
  }, {
    key: "_resetMouseScrollState",
    value: function _resetMouseScrollState() {
      this.mouseScrollTimeStamp = 0;
      this.mouseScrollDelta = 0;
    }
  }, {
    key: "_touchSwipe",
    value: function _touchSwipe(evt) {
      if (!this.active) {
        return;
      }

      if (evt.touches.length > 1) {
        this.touchSwipeState = null;
        return;
      }

      switch (evt.type) {
        case 'touchstart':
          this.touchSwipeState = {
            startX: evt.touches[0].pageX,
            startY: evt.touches[0].pageY,
            endX: evt.touches[0].pageX,
            endY: evt.touches[0].pageY
          };
          break;

        case 'touchmove':
          if (this.touchSwipeState === null) {
            return;
          }

          this.touchSwipeState.endX = evt.touches[0].pageX;
          this.touchSwipeState.endY = evt.touches[0].pageY;
          evt.preventDefault();
          break;

        case 'touchend':
          if (this.touchSwipeState === null) {
            return;
          }

          var delta = 0;
          var dx = this.touchSwipeState.endX - this.touchSwipeState.startX;
          var dy = this.touchSwipeState.endY - this.touchSwipeState.startY;
          var absAngle = Math.abs(Math.atan2(dy, dx));

          if (Math.abs(dx) > SWIPE_MIN_DISTANCE_THRESHOLD && (absAngle <= SWIPE_ANGLE_THRESHOLD || absAngle >= Math.PI - SWIPE_ANGLE_THRESHOLD)) {
            delta = dx;
          } else if (Math.abs(dy) > SWIPE_MIN_DISTANCE_THRESHOLD && Math.abs(absAngle - Math.PI / 2) <= SWIPE_ANGLE_THRESHOLD) {
            delta = dy;
          }

          if (delta > 0) {
            this._goToPreviousPage();
          } else if (delta < 0) {
            this._goToNextPage();
          }

          break;
      }
    }
  }, {
    key: "_addWindowListeners",
    value: function _addWindowListeners() {
      this.showControlsBind = this._showControls.bind(this);
      this.mouseDownBind = this._mouseDown.bind(this);
      this.mouseWheelBind = this._mouseWheel.bind(this);
      this.resetMouseScrollStateBind = this._resetMouseScrollState.bind(this);
      this.contextMenuBind = this._contextMenu.bind(this);
      this.touchSwipeBind = this._touchSwipe.bind(this);
      window.addEventListener('mousemove', this.showControlsBind);
      window.addEventListener('mousedown', this.mouseDownBind);
      window.addEventListener('wheel', this.mouseWheelBind);
      window.addEventListener('keydown', this.resetMouseScrollStateBind);
      window.addEventListener('contextmenu', this.contextMenuBind);
      window.addEventListener('touchstart', this.touchSwipeBind);
      window.addEventListener('touchmove', this.touchSwipeBind);
      window.addEventListener('touchend', this.touchSwipeBind);
    }
  }, {
    key: "_removeWindowListeners",
    value: function _removeWindowListeners() {
      window.removeEventListener('mousemove', this.showControlsBind);
      window.removeEventListener('mousedown', this.mouseDownBind);
      window.removeEventListener('wheel', this.mouseWheelBind);
      window.removeEventListener('keydown', this.resetMouseScrollStateBind);
      window.removeEventListener('contextmenu', this.contextMenuBind);
      window.removeEventListener('touchstart', this.touchSwipeBind);
      window.removeEventListener('touchmove', this.touchSwipeBind);
      window.removeEventListener('touchend', this.touchSwipeBind);
      delete this.showControlsBind;
      delete this.mouseDownBind;
      delete this.mouseWheelBind;
      delete this.resetMouseScrollStateBind;
      delete this.contextMenuBind;
      delete this.touchSwipeBind;
    }
  }, {
    key: "_fullscreenChange",
    value: function _fullscreenChange() {
      if (this.isFullscreen) {
        this._enter();
      } else {
        this._exit();
      }
    }
  }, {
    key: "_addFullscreenChangeListeners",
    value: function _addFullscreenChangeListeners() {
      this.fullscreenChangeBind = this._fullscreenChange.bind(this);
      window.addEventListener('fullscreenchange', this.fullscreenChangeBind);
      window.addEventListener('mozfullscreenchange', this.fullscreenChangeBind);
      window.addEventListener('webkitfullscreenchange', this.fullscreenChangeBind);
      window.addEventListener('MSFullscreenChange', this.fullscreenChangeBind);
    }
  }, {
    key: "_removeFullscreenChangeListeners",
    value: function _removeFullscreenChangeListeners() {
      window.removeEventListener('fullscreenchange', this.fullscreenChangeBind);
      window.removeEventListener('mozfullscreenchange', this.fullscreenChangeBind);
      window.removeEventListener('webkitfullscreenchange', this.fullscreenChangeBind);
      window.removeEventListener('MSFullscreenChange', this.fullscreenChangeBind);
      delete this.fullscreenChangeBind;
    }
  }, {
    key: "isFullscreen",
    get: function get() {
      return !!(document.fullscreenElement || document.mozFullScreen || document.webkitIsFullScreen || document.msFullscreenElement);
    }
  }]);

  return PDFPresentationMode;
}();

exports.PDFPresentationMode = PDFPresentationMode;

/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFSidebarResizer = void 0;

var _ui_utils = __webpack_require__(6);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var SIDEBAR_WIDTH_VAR = '--sidebar-width';
var SIDEBAR_MIN_WIDTH = 200;
var SIDEBAR_RESIZING_CLASS = 'sidebarResizing';

var PDFSidebarResizer =
/*#__PURE__*/
function () {
  function PDFSidebarResizer(options, eventBus) {
    var _this = this;

    var l10n = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _ui_utils.NullL10n;

    _classCallCheck(this, PDFSidebarResizer);

    this.enabled = false;
    this.isRTL = false;
    this.sidebarOpen = false;
    this.doc = document.documentElement;
    this._width = null;
    this._outerContainerWidth = null;
    this._boundEvents = Object.create(null);
    this.outerContainer = options.outerContainer;
    this.resizer = options.resizer;
    this.eventBus = eventBus;
    this.l10n = l10n;

    if (typeof CSS === 'undefined' || typeof CSS.supports !== 'function' || !CSS.supports(SIDEBAR_WIDTH_VAR, "calc(-1 * ".concat(SIDEBAR_MIN_WIDTH, "px)"))) {
      console.warn('PDFSidebarResizer: ' + 'The browser does not support resizing of the sidebar.');
      return;
    }

    this.enabled = true;
    this.resizer.classList.remove('hidden');
    this.l10n.getDirection().then(function (dir) {
      _this.isRTL = dir === 'rtl';
    });

    this._addEventListeners();
  }

  _createClass(PDFSidebarResizer, [{
    key: "_updateWidth",
    value: function _updateWidth() {
      var width = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (!this.enabled) {
        return false;
      }

      var maxWidth = Math.floor(this.outerContainerWidth / 2);

      if (width > maxWidth) {
        width = maxWidth;
      }

      if (width < SIDEBAR_MIN_WIDTH) {
        width = SIDEBAR_MIN_WIDTH;
      }

      if (width === this._width) {
        return false;
      }

      this._width = width;
      this.doc.style.setProperty(SIDEBAR_WIDTH_VAR, "".concat(width, "px"));
      return true;
    }
  }, {
    key: "_mouseMove",
    value: function _mouseMove(evt) {
      var width = evt.clientX;

      if (this.isRTL) {
        width = this.outerContainerWidth - width;
      }

      this._updateWidth(width);
    }
  }, {
    key: "_mouseUp",
    value: function _mouseUp(evt) {
      this.outerContainer.classList.remove(SIDEBAR_RESIZING_CLASS);
      this.eventBus.dispatch('resize', {
        source: this
      });
      var _boundEvents = this._boundEvents;
      window.removeEventListener('mousemove', _boundEvents.mouseMove);
      window.removeEventListener('mouseup', _boundEvents.mouseUp);
    }
  }, {
    key: "_addEventListeners",
    value: function _addEventListeners() {
      var _this2 = this;

      if (!this.enabled) {
        return;
      }

      var _boundEvents = this._boundEvents;
      _boundEvents.mouseMove = this._mouseMove.bind(this);
      _boundEvents.mouseUp = this._mouseUp.bind(this);
      this.resizer.addEventListener('mousedown', function (evt) {
        if (evt.button !== 0) {
          return;
        }

        _this2.outerContainer.classList.add(SIDEBAR_RESIZING_CLASS);

        window.addEventListener('mousemove', _boundEvents.mouseMove);
        window.addEventListener('mouseup', _boundEvents.mouseUp);
      });
      this.eventBus.on('sidebarviewchanged', function (evt) {
        _this2.sidebarOpen = !!(evt && evt.view);
      });
      this.eventBus.on('resize', function (evt) {
        if (evt && evt.source === window) {
          _this2._outerContainerWidth = null;

          if (_this2._width) {
            if (_this2.sidebarOpen) {
              _this2.outerContainer.classList.add(SIDEBAR_RESIZING_CLASS);

              var updated = _this2._updateWidth(_this2._width);

              Promise.resolve().then(function () {
                _this2.outerContainer.classList.remove(SIDEBAR_RESIZING_CLASS);

                if (updated) {
                  _this2.eventBus.dispatch('resize', {
                    source: _this2
                  });
                }
              });
            } else {
              _this2._updateWidth(_this2._width);
            }
          }
        }
      });
    }
  }, {
    key: "outerContainerWidth",
    get: function get() {
      if (!this._outerContainerWidth) {
        this._outerContainerWidth = this.outerContainer.clientWidth;
      }

      return this._outerContainerWidth;
    }
  }]);

  return PDFSidebarResizer;
}();

exports.PDFSidebarResizer = PDFSidebarResizer;

/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFThumbnailViewer = void 0;

var _ui_utils = __webpack_require__(6);

var _pdf_thumbnail_view = __webpack_require__(27);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var THUMBNAIL_SCROLL_MARGIN = -19;
var THUMBNAIL_SELECTED_CLASS = 'selected';

var PDFThumbnailViewer =
/*#__PURE__*/
function () {
  function PDFThumbnailViewer(_ref) {
    var container = _ref.container,
        linkService = _ref.linkService,
        renderingQueue = _ref.renderingQueue,
        _ref$l10n = _ref.l10n,
        l10n = _ref$l10n === void 0 ? _ui_utils.NullL10n : _ref$l10n;

    _classCallCheck(this, PDFThumbnailViewer);

    this.container = container;
    this.linkService = linkService;
    this.renderingQueue = renderingQueue;
    this.l10n = l10n;
    this.scroll = (0, _ui_utils.watchScroll)(this.container, this._scrollUpdated.bind(this));

    this._resetView();
  }

  _createClass(PDFThumbnailViewer, [{
    key: "_scrollUpdated",
    value: function _scrollUpdated() {
      this.renderingQueue.renderHighestPriority();
    }
  }, {
    key: "getThumbnail",
    value: function getThumbnail(index) {
      return this._thumbnails[index];
    }
  }, {
    key: "_getVisibleThumbs",
    value: function _getVisibleThumbs() {
      return (0, _ui_utils.getVisibleElements)(this.container, this._thumbnails);
    }
  }, {
    key: "scrollThumbnailIntoView",
    value: function scrollThumbnailIntoView(pageNumber) {
      if (!this.pdfDocument) {
        return;
      }

      var thumbnailView = this._thumbnails[pageNumber - 1];

      if (!thumbnailView) {
        console.error('scrollThumbnailIntoView: Invalid "pageNumber" parameter.');
        return;
      }

      if (pageNumber !== this._currentPageNumber) {
        var prevThumbnailView = this._thumbnails[this._currentPageNumber - 1];
        prevThumbnailView.div.classList.remove(THUMBNAIL_SELECTED_CLASS);
        thumbnailView.div.classList.add(THUMBNAIL_SELECTED_CLASS);
      }

      var visibleThumbs = this._getVisibleThumbs();

      var numVisibleThumbs = visibleThumbs.views.length;

      if (numVisibleThumbs > 0) {
        var first = visibleThumbs.first.id;
        var last = numVisibleThumbs > 1 ? visibleThumbs.last.id : first;
        var shouldScroll = false;

        if (pageNumber <= first || pageNumber >= last) {
          shouldScroll = true;
        } else {
          visibleThumbs.views.some(function (view) {
            if (view.id !== pageNumber) {
              return false;
            }

            shouldScroll = view.percent < 100;
            return true;
          });
        }

        if (shouldScroll) {
          (0, _ui_utils.scrollIntoView)(thumbnailView.div, {
            top: THUMBNAIL_SCROLL_MARGIN
          });
        }
      }

      this._currentPageNumber = pageNumber;
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      _pdf_thumbnail_view.PDFThumbnailView.cleanup();
    }
  }, {
    key: "_resetView",
    value: function _resetView() {
      this._thumbnails = [];
      this._currentPageNumber = 1;
      this._pageLabels = null;
      this._pagesRotation = 0;
      this._pagesRequests = [];
      this.container.textContent = '';
    }
  }, {
    key: "setDocument",
    value: function setDocument(pdfDocument) {
      var _this = this;

      if (this.pdfDocument) {
        this._cancelRendering();

        this._resetView();
      }

      this.pdfDocument = pdfDocument;

      if (!pdfDocument) {
        return;
      }

      pdfDocument.getPage(1).then(function (firstPage) {
        var pagesCount = pdfDocument.numPages;
        var viewport = firstPage.getViewport({
          scale: 1
        });

        for (var pageNum = 1; pageNum <= pagesCount; ++pageNum) {
          var thumbnail = new _pdf_thumbnail_view.PDFThumbnailView({
            container: _this.container,
            id: pageNum,
            defaultViewport: viewport.clone(),
            linkService: _this.linkService,
            renderingQueue: _this.renderingQueue,
            disableCanvasToImageConversion: false,
            l10n: _this.l10n
          });

          _this._thumbnails.push(thumbnail);
        }

        var thumbnailView = _this._thumbnails[_this._currentPageNumber - 1];
        thumbnailView.div.classList.add(THUMBNAIL_SELECTED_CLASS);
      }).catch(function (reason) {
        console.error('Unable to initialize thumbnail viewer', reason);
      });
    }
  }, {
    key: "_cancelRendering",
    value: function _cancelRendering() {
      for (var i = 0, ii = this._thumbnails.length; i < ii; i++) {
        if (this._thumbnails[i]) {
          this._thumbnails[i].cancelRendering();
        }
      }
    }
  }, {
    key: "setPageLabels",
    value: function setPageLabels(labels) {
      if (!this.pdfDocument) {
        return;
      }

      if (!labels) {
        this._pageLabels = null;
      } else if (!(Array.isArray(labels) && this.pdfDocument.numPages === labels.length)) {
        this._pageLabels = null;
        console.error('PDFThumbnailViewer_setPageLabels: Invalid page labels.');
      } else {
        this._pageLabels = labels;
      }

      for (var i = 0, ii = this._thumbnails.length; i < ii; i++) {
        var label = this._pageLabels && this._pageLabels[i];

        this._thumbnails[i].setPageLabel(label);
      }
    }
  }, {
    key: "_ensurePdfPageLoaded",
    value: function _ensurePdfPageLoaded(thumbView) {
      var _this2 = this;

      if (thumbView.pdfPage) {
        return Promise.resolve(thumbView.pdfPage);
      }

      var pageNumber = thumbView.id;

      if (this._pagesRequests[pageNumber]) {
        return this._pagesRequests[pageNumber];
      }

      var promise = this.pdfDocument.getPage(pageNumber).then(function (pdfPage) {
        thumbView.setPdfPage(pdfPage);
        _this2._pagesRequests[pageNumber] = null;
        return pdfPage;
      }).catch(function (reason) {
        console.error('Unable to get page for thumb view', reason);
        _this2._pagesRequests[pageNumber] = null;
      });
      this._pagesRequests[pageNumber] = promise;
      return promise;
    }
  }, {
    key: "forceRendering",
    value: function forceRendering() {
      var _this3 = this;

      var visibleThumbs = this._getVisibleThumbs();

      var thumbView = this.renderingQueue.getHighestPriority(visibleThumbs, this._thumbnails, this.scroll.down);

      if (thumbView) {
        this._ensurePdfPageLoaded(thumbView).then(function () {
          _this3.renderingQueue.renderView(thumbView);
        });

        return true;
      }

      return false;
    }
  }, {
    key: "pagesRotation",
    get: function get() {
      return this._pagesRotation;
    },
    set: function set(rotation) {
      if (!(0, _ui_utils.isValidRotation)(rotation)) {
        throw new Error('Invalid thumbnails rotation angle.');
      }

      if (!this.pdfDocument) {
        return;
      }

      if (this._pagesRotation === rotation) {
        return;
      }

      this._pagesRotation = rotation;

      for (var i = 0, ii = this._thumbnails.length; i < ii; i++) {
        this._thumbnails[i].update(rotation);
      }
    }
  }]);

  return PDFThumbnailViewer;
}();

exports.PDFThumbnailViewer = PDFThumbnailViewer;

/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFThumbnailView = void 0;

var _pdfjsLib = __webpack_require__(7);

var _ui_utils = __webpack_require__(6);

var _pdf_rendering_queue = __webpack_require__(10);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var MAX_NUM_SCALING_STEPS = 3;
var THUMBNAIL_CANVAS_BORDER_WIDTH = 1;
var THUMBNAIL_WIDTH = 98;

var TempImageFactory = function TempImageFactoryClosure() {
  var tempCanvasCache = null;
  return {
    getCanvas: function getCanvas(width, height) {
      var tempCanvas = tempCanvasCache;

      if (!tempCanvas) {
        tempCanvas = document.createElement('canvas');
        tempCanvasCache = tempCanvas;
      }

      tempCanvas.width = width;
      tempCanvas.height = height;
      tempCanvas.mozOpaque = true;
      var ctx = tempCanvas.getContext('2d', {
        alpha: false
      });
      ctx.save();
      ctx.fillStyle = 'rgb(255, 255, 255)';
      ctx.fillRect(0, 0, width, height);
      ctx.restore();
      return tempCanvas;
    },
    destroyCanvas: function destroyCanvas() {
      var tempCanvas = tempCanvasCache;

      if (tempCanvas) {
        tempCanvas.width = 0;
        tempCanvas.height = 0;
      }

      tempCanvasCache = null;
    }
  };
}();

var PDFThumbnailView =
/*#__PURE__*/
function () {
  function PDFThumbnailView(_ref) {
    var container = _ref.container,
        id = _ref.id,
        defaultViewport = _ref.defaultViewport,
        linkService = _ref.linkService,
        renderingQueue = _ref.renderingQueue,
        _ref$disableCanvasToI = _ref.disableCanvasToImageConversion,
        disableCanvasToImageConversion = _ref$disableCanvasToI === void 0 ? false : _ref$disableCanvasToI,
        _ref$l10n = _ref.l10n,
        l10n = _ref$l10n === void 0 ? _ui_utils.NullL10n : _ref$l10n;

    _classCallCheck(this, PDFThumbnailView);

    this.id = id;
    this.renderingId = 'thumbnail' + id;
    this.pageLabel = null;
    this.pdfPage = null;
    this.rotation = 0;
    this.viewport = defaultViewport;
    this.pdfPageRotate = defaultViewport.rotation;
    this.linkService = linkService;
    this.renderingQueue = renderingQueue;
    this.renderTask = null;
    this.renderingState = _pdf_rendering_queue.RenderingStates.INITIAL;
    this.resume = null;
    this.disableCanvasToImageConversion = disableCanvasToImageConversion;
    this.pageWidth = this.viewport.width;
    this.pageHeight = this.viewport.height;
    this.pageRatio = this.pageWidth / this.pageHeight;
    this.canvasWidth = THUMBNAIL_WIDTH;
    this.canvasHeight = this.canvasWidth / this.pageRatio | 0;
    this.scale = this.canvasWidth / this.pageWidth;
    this.l10n = l10n;
    var anchor = document.createElement('a');
    anchor.href = linkService.getAnchorUrl('#page=' + id);
    this.l10n.get('thumb_page_title', {
      page: id
    }, 'Page {{page}}').then(function (msg) {
      anchor.title = msg;
    });

    anchor.onclick = function () {
      linkService.page = id;
      return false;
    };

    this.anchor = anchor;
    var div = document.createElement('div');
    div.className = 'thumbnail';
    div.setAttribute('data-page-number', this.id);
    this.div = div;
    var ring = document.createElement('div');
    ring.className = 'thumbnailSelectionRing';
    var borderAdjustment = 2 * THUMBNAIL_CANVAS_BORDER_WIDTH;
    ring.style.width = this.canvasWidth + borderAdjustment + 'px';
    ring.style.height = this.canvasHeight + borderAdjustment + 'px';
    this.ring = ring;
    div.appendChild(ring);
    anchor.appendChild(div);
    container.appendChild(anchor);
  }

  _createClass(PDFThumbnailView, [{
    key: "setPdfPage",
    value: function setPdfPage(pdfPage) {
      this.pdfPage = pdfPage;
      this.pdfPageRotate = pdfPage.rotate;
      var totalRotation = (this.rotation + this.pdfPageRotate) % 360;
      this.viewport = pdfPage.getViewport({
        scale: 1,
        rotation: totalRotation
      });
      this.reset();
    }
  }, {
    key: "reset",
    value: function reset() {
      this.cancelRendering();
      this.pageWidth = this.viewport.width;
      this.pageHeight = this.viewport.height;
      this.pageRatio = this.pageWidth / this.pageHeight;
      this.canvasHeight = this.canvasWidth / this.pageRatio | 0;
      this.scale = this.canvasWidth / this.pageWidth;
      this.div.removeAttribute('data-loaded');
      var ring = this.ring;
      var childNodes = ring.childNodes;

      for (var i = childNodes.length - 1; i >= 0; i--) {
        ring.removeChild(childNodes[i]);
      }

      var borderAdjustment = 2 * THUMBNAIL_CANVAS_BORDER_WIDTH;
      ring.style.width = this.canvasWidth + borderAdjustment + 'px';
      ring.style.height = this.canvasHeight + borderAdjustment + 'px';

      if (this.canvas) {
        this.canvas.width = 0;
        this.canvas.height = 0;
        delete this.canvas;
      }

      if (this.image) {
        this.image.removeAttribute('src');
        delete this.image;
      }
    }
  }, {
    key: "update",
    value: function update(rotation) {
      if (typeof rotation !== 'undefined') {
        this.rotation = rotation;
      }

      var totalRotation = (this.rotation + this.pdfPageRotate) % 360;
      this.viewport = this.viewport.clone({
        scale: 1,
        rotation: totalRotation
      });
      this.reset();
    }
  }, {
    key: "cancelRendering",
    value: function cancelRendering() {
      if (this.renderTask) {
        this.renderTask.cancel();
        this.renderTask = null;
      }

      this.renderingState = _pdf_rendering_queue.RenderingStates.INITIAL;
      this.resume = null;
    }
  }, {
    key: "_getPageDrawContext",
    value: function _getPageDrawContext() {
      var noCtxScale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var canvas = document.createElement('canvas');
      this.canvas = canvas;
      canvas.mozOpaque = true;
      var ctx = canvas.getContext('2d', {
        alpha: false
      });
      var outputScale = (0, _ui_utils.getOutputScale)(ctx);
      canvas.width = this.canvasWidth * outputScale.sx | 0;
      canvas.height = this.canvasHeight * outputScale.sy | 0;
      canvas.style.width = this.canvasWidth + 'px';
      canvas.style.height = this.canvasHeight + 'px';

      if (!noCtxScale && outputScale.scaled) {
        ctx.scale(outputScale.sx, outputScale.sy);
      }

      return ctx;
    }
  }, {
    key: "_convertCanvasToImage",
    value: function _convertCanvasToImage() {
      var _this = this;

      if (!this.canvas) {
        return;
      }

      if (this.renderingState !== _pdf_rendering_queue.RenderingStates.FINISHED) {
        return;
      }

      var id = this.renderingId;
      var className = 'thumbnailImage';

      if (this.disableCanvasToImageConversion) {
        this.canvas.id = id;
        this.canvas.className = className;
        this.l10n.get('thumb_page_canvas', {
          page: this.pageId
        }, 'Thumbnail of Page {{page}}').then(function (msg) {
          _this.canvas.setAttribute('aria-label', msg);
        });
        this.div.setAttribute('data-loaded', true);
        this.ring.appendChild(this.canvas);
        return;
      }

      var image = document.createElement('img');
      image.id = id;
      image.className = className;
      this.l10n.get('thumb_page_canvas', {
        page: this.pageId
      }, 'Thumbnail of Page {{page}}').then(function (msg) {
        image.setAttribute('aria-label', msg);
      });
      image.style.width = this.canvasWidth + 'px';
      image.style.height = this.canvasHeight + 'px';
      image.src = this.canvas.toDataURL();
      this.image = image;
      this.div.setAttribute('data-loaded', true);
      this.ring.appendChild(image);
      this.canvas.width = 0;
      this.canvas.height = 0;
      delete this.canvas;
    }
  }, {
    key: "draw",
    value: function draw() {
      var _this2 = this;

      if (this.renderingState !== _pdf_rendering_queue.RenderingStates.INITIAL) {
        console.error('Must be in new state before drawing');
        return Promise.resolve(undefined);
      }

      this.renderingState = _pdf_rendering_queue.RenderingStates.RUNNING;
      var renderCapability = (0, _pdfjsLib.createPromiseCapability)();

      var finishRenderTask = function finishRenderTask(error) {
        if (renderTask === _this2.renderTask) {
          _this2.renderTask = null;
        }

        if (error instanceof _pdfjsLib.RenderingCancelledException) {
          renderCapability.resolve(undefined);
          return;
        }

        _this2.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;

        _this2._convertCanvasToImage();

        if (!error) {
          renderCapability.resolve(undefined);
        } else {
          renderCapability.reject(error);
        }
      };

      var ctx = this._getPageDrawContext();

      var drawViewport = this.viewport.clone({
        scale: this.scale
      });

      var renderContinueCallback = function renderContinueCallback(cont) {
        if (!_this2.renderingQueue.isHighestPriority(_this2)) {
          _this2.renderingState = _pdf_rendering_queue.RenderingStates.PAUSED;

          _this2.resume = function () {
            _this2.renderingState = _pdf_rendering_queue.RenderingStates.RUNNING;
            cont();
          };

          return;
        }

        cont();
      };

      var renderContext = {
        canvasContext: ctx,
        viewport: drawViewport
      };
      var renderTask = this.renderTask = this.pdfPage.render(renderContext);
      renderTask.onContinue = renderContinueCallback;
      renderTask.promise.then(function () {
        finishRenderTask(null);
      }, function (error) {
        finishRenderTask(error);
      });
      return renderCapability.promise;
    }
  }, {
    key: "setImage",
    value: function setImage(pageView) {
      if (this.renderingState !== _pdf_rendering_queue.RenderingStates.INITIAL) {
        return;
      }

      var img = pageView.canvas;

      if (!img) {
        return;
      }

      if (!this.pdfPage) {
        this.setPdfPage(pageView.pdfPage);
      }

      this.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;

      var ctx = this._getPageDrawContext(true);

      var canvas = ctx.canvas;

      if (img.width <= 2 * canvas.width) {
        ctx.drawImage(img, 0, 0, img.width, img.height, 0, 0, canvas.width, canvas.height);

        this._convertCanvasToImage();

        return;
      }

      var reducedWidth = canvas.width << MAX_NUM_SCALING_STEPS;
      var reducedHeight = canvas.height << MAX_NUM_SCALING_STEPS;
      var reducedImage = TempImageFactory.getCanvas(reducedWidth, reducedHeight);
      var reducedImageCtx = reducedImage.getContext('2d');

      while (reducedWidth > img.width || reducedHeight > img.height) {
        reducedWidth >>= 1;
        reducedHeight >>= 1;
      }

      reducedImageCtx.drawImage(img, 0, 0, img.width, img.height, 0, 0, reducedWidth, reducedHeight);

      while (reducedWidth > 2 * canvas.width) {
        reducedImageCtx.drawImage(reducedImage, 0, 0, reducedWidth, reducedHeight, 0, 0, reducedWidth >> 1, reducedHeight >> 1);
        reducedWidth >>= 1;
        reducedHeight >>= 1;
      }

      ctx.drawImage(reducedImage, 0, 0, reducedWidth, reducedHeight, 0, 0, canvas.width, canvas.height);

      this._convertCanvasToImage();
    }
  }, {
    key: "setPageLabel",
    value: function setPageLabel(label) {
      var _this3 = this;

      this.pageLabel = typeof label === 'string' ? label : null;
      this.l10n.get('thumb_page_title', {
        page: this.pageId
      }, 'Page {{page}}').then(function (msg) {
        _this3.anchor.title = msg;
      });

      if (this.renderingState !== _pdf_rendering_queue.RenderingStates.FINISHED) {
        return;
      }

      this.l10n.get('thumb_page_canvas', {
        page: this.pageId
      }, 'Thumbnail of Page {{page}}').then(function (ariaLabel) {
        if (_this3.image) {
          _this3.image.setAttribute('aria-label', ariaLabel);
        } else if (_this3.disableCanvasToImageConversion && _this3.canvas) {
          _this3.canvas.setAttribute('aria-label', ariaLabel);
        }
      });
    }
  }, {
    key: "pageId",
    get: function get() {
      return this.pageLabel !== null ? this.pageLabel : this.id;
    }
  }], [{
    key: "cleanup",
    value: function cleanup() {
      TempImageFactory.destroyCanvas();
    }
  }]);

  return PDFThumbnailView;
}();

exports.PDFThumbnailView = PDFThumbnailView;

/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFViewer = void 0;

var _base_viewer = __webpack_require__(29);

var _pdfjsLib = __webpack_require__(7);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PDFViewer =
/*#__PURE__*/
function (_BaseViewer) {
  _inherits(PDFViewer, _BaseViewer);

  function PDFViewer() {
    _classCallCheck(this, PDFViewer);

    return _possibleConstructorReturn(this, _getPrototypeOf(PDFViewer).apply(this, arguments));
  }

  _createClass(PDFViewer, [{
    key: "_scrollIntoView",
    value: function _scrollIntoView(_ref) {
      var pageDiv = _ref.pageDiv,
          _ref$pageSpot = _ref.pageSpot,
          pageSpot = _ref$pageSpot === void 0 ? null : _ref$pageSpot,
          _ref$pageNumber = _ref.pageNumber,
          pageNumber = _ref$pageNumber === void 0 ? null : _ref$pageNumber;

      if (!pageSpot && !this.isInPresentationMode) {
        var left = pageDiv.offsetLeft + pageDiv.clientLeft;
        var right = left + pageDiv.clientWidth;
        var _this$container = this.container,
            scrollLeft = _this$container.scrollLeft,
            clientWidth = _this$container.clientWidth;

        if (this._isScrollModeHorizontal || left < scrollLeft || right > scrollLeft + clientWidth) {
          pageSpot = {
            left: 0,
            top: 0
          };
        }
      }

      _get(_getPrototypeOf(PDFViewer.prototype), "_scrollIntoView", this).call(this, {
        pageDiv: pageDiv,
        pageSpot: pageSpot,
        pageNumber: pageNumber
      });
    }
  }, {
    key: "_getVisiblePages",
    value: function _getVisiblePages() {
      if (this.isInPresentationMode) {
        return this._getCurrentVisiblePage();
      }

      return _get(_getPrototypeOf(PDFViewer.prototype), "_getVisiblePages", this).call(this);
    }
  }, {
    key: "_updateHelper",
    value: function _updateHelper(visiblePages) {
      if (this.isInPresentationMode) {
        return;
      }

      var currentId = this._currentPageNumber;
      var stillFullyVisible = false;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = visiblePages[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var page = _step.value;

          if (page.percent < 100) {
            break;
          }

          if (page.id === currentId) {
            stillFullyVisible = true;
            break;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (!stillFullyVisible) {
        currentId = visiblePages[0].id;
      }

      this._setCurrentPageNumber(currentId);
    }
  }, {
    key: "_setDocumentViewerElement",
    get: function get() {
      return (0, _pdfjsLib.shadow)(this, '_setDocumentViewerElement', this.viewer);
    }
  }]);

  return PDFViewer;
}(_base_viewer.BaseViewer);

exports.PDFViewer = PDFViewer;

/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseViewer = void 0;

var _ui_utils = __webpack_require__(6);

var _pdf_rendering_queue = __webpack_require__(10);

var _annotation_layer_builder = __webpack_require__(30);

var _pdfjsLib = __webpack_require__(7);

var _pdf_page_view = __webpack_require__(31);

var _pdf_link_service = __webpack_require__(22);

var _text_layer_builder = __webpack_require__(32);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEFAULT_CACHE_SIZE = 10;

function PDFPageViewBuffer(size) {
  var data = [];

  this.push = function (view) {
    var i = data.indexOf(view);

    if (i >= 0) {
      data.splice(i, 1);
    }

    data.push(view);

    if (data.length > size) {
      data.shift().destroy();
    }
  };

  this.resize = function (newSize, pagesToKeep) {
    size = newSize;

    if (pagesToKeep) {
      var pageIdsToKeep = new Set();

      for (var i = 0, iMax = pagesToKeep.length; i < iMax; ++i) {
        pageIdsToKeep.add(pagesToKeep[i].id);
      }

      (0, _ui_utils.moveToEndOfArray)(data, function (page) {
        return pageIdsToKeep.has(page.id);
      });
    }

    while (data.length > size) {
      data.shift().destroy();
    }
  };
}

function isSameScale(oldScale, newScale) {
  if (newScale === oldScale) {
    return true;
  }

  if (Math.abs(newScale - oldScale) < 1e-15) {
    return true;
  }

  return false;
}

var BaseViewer =
/*#__PURE__*/
function () {
  function BaseViewer(options) {
    var _this = this;

    _classCallCheck(this, BaseViewer);

    if (this.constructor === BaseViewer) {
      throw new Error('Cannot initialize BaseViewer.');
    }

    this._name = this.constructor.name;
    this.container = options.container;
    this.viewer = options.viewer || options.container.firstElementChild;
    this.eventBus = options.eventBus || (0, _ui_utils.getGlobalEventBus)();
    this.linkService = options.linkService || new _pdf_link_service.SimpleLinkService();
    this.downloadManager = options.downloadManager || null;
    this.findController = options.findController || null;
    this.removePageBorders = options.removePageBorders || false;
    this.textLayerMode = Number.isInteger(options.textLayerMode) ? options.textLayerMode : _ui_utils.TextLayerMode.ENABLE;
    this.imageResourcesPath = options.imageResourcesPath || '';
    this.renderInteractiveForms = options.renderInteractiveForms || false;
    this.enablePrintAutoRotate = options.enablePrintAutoRotate || false;
    this.renderer = options.renderer || _ui_utils.RendererType.CANVAS;
    this.enableWebGL = options.enableWebGL || false;
    this.useOnlyCssZoom = options.useOnlyCssZoom || false;
    this.maxCanvasPixels = options.maxCanvasPixels;
    this.l10n = options.l10n || _ui_utils.NullL10n;
    this.defaultRenderingQueue = !options.renderingQueue;

    if (this.defaultRenderingQueue) {
      this.renderingQueue = new _pdf_rendering_queue.PDFRenderingQueue();
      this.renderingQueue.setViewer(this);
    } else {
      this.renderingQueue = options.renderingQueue;
    }

    this.scroll = (0, _ui_utils.watchScroll)(this.container, this._scrollUpdate.bind(this));
    this.presentationModeState = _ui_utils.PresentationModeState.UNKNOWN;

    this._resetView();

    if (this.removePageBorders) {
      this.viewer.classList.add('removePageBorders');
    }

    Promise.resolve().then(function () {
      _this.eventBus.dispatch('baseviewerinit', {
        source: _this
      });
    });
  }

  _createClass(BaseViewer, [{
    key: "getPageView",
    value: function getPageView(index) {
      return this._pages[index];
    }
  }, {
    key: "_setCurrentPageNumber",
    value: function _setCurrentPageNumber(val) {
      var resetCurrentPageView = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (this._currentPageNumber === val) {
        if (resetCurrentPageView) {
          this._resetCurrentPageView();
        }

        return true;
      }

      if (!(0 < val && val <= this.pagesCount)) {
        return false;
      }

      this._currentPageNumber = val;
      this.eventBus.dispatch('pagechanging', {
        source: this,
        pageNumber: val,
        pageLabel: this._pageLabels && this._pageLabels[val - 1]
      });

      if (resetCurrentPageView) {
        this._resetCurrentPageView();
      }

      return true;
    }
  }, {
    key: "setDocument",
    value: function setDocument(pdfDocument) {
      var _this2 = this;

      if (this.pdfDocument) {
        this._cancelRendering();

        this._resetView();

        if (this.findController) {
          this.findController.setDocument(null);
        }
      }

      this.pdfDocument = pdfDocument;

      if (!pdfDocument) {
        return;
      }

      var pagesCount = pdfDocument.numPages;
      var pagesCapability = (0, _pdfjsLib.createPromiseCapability)();
      this.pagesPromise = pagesCapability.promise;
      pagesCapability.promise.then(function () {
        _this2._pageViewsReady = true;

        _this2.eventBus.dispatch('pagesloaded', {
          source: _this2,
          pagesCount: pagesCount
        });
      });
      var onePageRenderedCapability = (0, _pdfjsLib.createPromiseCapability)();
      this.onePageRendered = onePageRenderedCapability.promise;

      var bindOnAfterAndBeforeDraw = function bindOnAfterAndBeforeDraw(pageView) {
        pageView.onBeforeDraw = function () {
          _this2._buffer.push(pageView);
        };

        pageView.onAfterDraw = function () {
          if (!onePageRenderedCapability.settled) {
            onePageRenderedCapability.resolve();
          }
        };
      };

      var firstPagePromise = pdfDocument.getPage(1);
      this.firstPagePromise = firstPagePromise;
      firstPagePromise.then(function (pdfPage) {
        var scale = _this2.currentScale;
        var viewport = pdfPage.getViewport({
          scale: scale * _ui_utils.CSS_UNITS
        });

        for (var pageNum = 1; pageNum <= pagesCount; ++pageNum) {
          var textLayerFactory = null;

          if (_this2.textLayerMode !== _ui_utils.TextLayerMode.DISABLE) {
            textLayerFactory = _this2;
          }

          var pageView = new _pdf_page_view.PDFPageView({
            container: _this2._setDocumentViewerElement,
            eventBus: _this2.eventBus,
            id: pageNum,
            scale: scale,
            defaultViewport: viewport.clone(),
            renderingQueue: _this2.renderingQueue,
            textLayerFactory: textLayerFactory,
            textLayerMode: _this2.textLayerMode,
            annotationLayerFactory: _this2,
            imageResourcesPath: _this2.imageResourcesPath,
            renderInteractiveForms: _this2.renderInteractiveForms,
            renderer: _this2.renderer,
            enableWebGL: _this2.enableWebGL,
            useOnlyCssZoom: _this2.useOnlyCssZoom,
            maxCanvasPixels: _this2.maxCanvasPixels,
            l10n: _this2.l10n
          });
          bindOnAfterAndBeforeDraw(pageView);

          _this2._pages.push(pageView);
        }

        if (_this2._spreadMode !== _ui_utils.SpreadMode.NONE) {
          _this2._updateSpreadMode();
        }

        onePageRenderedCapability.promise.then(function () {
          if (pdfDocument.loadingParams['disableAutoFetch']) {
            pagesCapability.resolve();
            return;
          }

          var getPagesLeft = pagesCount;

          var _loop = function _loop(_pageNum) {
            pdfDocument.getPage(_pageNum).then(function (pdfPage) {
              var pageView = _this2._pages[_pageNum - 1];

              if (!pageView.pdfPage) {
                pageView.setPdfPage(pdfPage);
              }

              _this2.linkService.cachePageRef(_pageNum, pdfPage.ref);

              if (--getPagesLeft === 0) {
                pagesCapability.resolve();
              }
            }, function (reason) {
              console.error("Unable to get page ".concat(_pageNum, " to initialize viewer"), reason);

              if (--getPagesLeft === 0) {
                pagesCapability.resolve();
              }
            });
          };

          for (var _pageNum = 1; _pageNum <= pagesCount; ++_pageNum) {
            _loop(_pageNum);
          }
        });

        _this2.eventBus.dispatch('pagesinit', {
          source: _this2
        });

        if (_this2.findController) {
          _this2.findController.setDocument(pdfDocument);
        }

        if (_this2.defaultRenderingQueue) {
          _this2.update();
        }
      }).catch(function (reason) {
        console.error('Unable to initialize viewer', reason);
      });
    }
  }, {
    key: "setPageLabels",
    value: function setPageLabels(labels) {
      if (!this.pdfDocument) {
        return;
      }

      if (!labels) {
        this._pageLabels = null;
      } else if (!(Array.isArray(labels) && this.pdfDocument.numPages === labels.length)) {
        this._pageLabels = null;
        console.error("".concat(this._name, ".setPageLabels: Invalid page labels."));
      } else {
        this._pageLabels = labels;
      }

      for (var i = 0, ii = this._pages.length; i < ii; i++) {
        var pageView = this._pages[i];
        var label = this._pageLabels && this._pageLabels[i];
        pageView.setPageLabel(label);
      }
    }
  }, {
    key: "_resetView",
    value: function _resetView() {
      this._pages = [];
      this._currentPageNumber = 1;
      this._currentScale = _ui_utils.UNKNOWN_SCALE;
      this._currentScaleValue = null;
      this._pageLabels = null;
      this._buffer = new PDFPageViewBuffer(DEFAULT_CACHE_SIZE);
      this._location = null;
      this._pagesRotation = 0;
      this._pagesRequests = [];
      this._pageViewsReady = false;
      this._scrollMode = _ui_utils.ScrollMode.VERTICAL;
      this._spreadMode = _ui_utils.SpreadMode.NONE;
      this.viewer.textContent = '';

      this._updateScrollMode();
    }
  }, {
    key: "_scrollUpdate",
    value: function _scrollUpdate() {
      if (this.pagesCount === 0) {
        return;
      }

      this.update();
    }
  }, {
    key: "_scrollIntoView",
    value: function _scrollIntoView(_ref) {
      var pageDiv = _ref.pageDiv,
          _ref$pageSpot = _ref.pageSpot,
          pageSpot = _ref$pageSpot === void 0 ? null : _ref$pageSpot,
          _ref$pageNumber = _ref.pageNumber,
          pageNumber = _ref$pageNumber === void 0 ? null : _ref$pageNumber;
      (0, _ui_utils.scrollIntoView)(pageDiv, pageSpot);
    }
  }, {
    key: "_setScaleUpdatePages",
    value: function _setScaleUpdatePages(newScale, newValue) {
      var noScroll = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var preset = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      this._currentScaleValue = newValue.toString();

      if (isSameScale(this._currentScale, newScale)) {
        if (preset) {
          this.eventBus.dispatch('scalechanging', {
            source: this,
            scale: newScale,
            presetValue: newValue
          });
        }

        return;
      }

      for (var i = 0, ii = this._pages.length; i < ii; i++) {
        this._pages[i].update(newScale);
      }

      this._currentScale = newScale;

      if (!noScroll) {
        var page = this._currentPageNumber,
            dest;

        if (this._location && !(this.isInPresentationMode || this.isChangingPresentationMode)) {
          page = this._location.pageNumber;
          dest = [null, {
            name: 'XYZ'
          }, this._location.left, this._location.top, null];
        }

        this.scrollPageIntoView({
          pageNumber: page,
          destArray: dest,
          allowNegativeOffset: true
        });
      }

      this.eventBus.dispatch('scalechanging', {
        source: this,
        scale: newScale,
        presetValue: preset ? newValue : undefined
      });

      if (this.defaultRenderingQueue) {
        this.update();
      }
    }
  }, {
    key: "_setScale",
    value: function _setScale(value) {
      var noScroll = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var scale = parseFloat(value);

      if (scale > 0) {
        this._setScaleUpdatePages(scale, value, noScroll, false);
      } else {
        var currentPage = this._pages[this._currentPageNumber - 1];

        if (!currentPage) {
          return;
        }

        var noPadding = this.isInPresentationMode || this.removePageBorders;
        var hPadding = noPadding ? 0 : _ui_utils.SCROLLBAR_PADDING;
        var vPadding = noPadding ? 0 : _ui_utils.VERTICAL_PADDING;

        if (!noPadding && this._isScrollModeHorizontal) {
          var _ref2 = [vPadding, hPadding];
          hPadding = _ref2[0];
          vPadding = _ref2[1];
        }

        var pageWidthScale = (this.container.clientWidth - hPadding) / currentPage.width * currentPage.scale;
        var pageHeightScale = (this.container.clientHeight - vPadding) / currentPage.height * currentPage.scale;

        switch (value) {
          case 'page-actual':
            scale = 1;
            break;

          case 'page-width':
            scale = pageWidthScale;
            break;

          case 'page-height':
            scale = pageHeightScale;
            break;

          case 'page-fit':
            scale = Math.min(pageWidthScale, pageHeightScale);
            break;

          case 'auto':
            var horizontalScale = (0, _ui_utils.isPortraitOrientation)(currentPage) ? pageWidthScale : Math.min(pageHeightScale, pageWidthScale);
            scale = Math.min(_ui_utils.MAX_AUTO_SCALE, horizontalScale);
            break;

          default:
            console.error("".concat(this._name, "._setScale: \"").concat(value, "\" is an unknown zoom value."));
            return;
        }

        this._setScaleUpdatePages(scale, value, noScroll, true);
      }
    }
  }, {
    key: "_resetCurrentPageView",
    value: function _resetCurrentPageView() {
      if (this.isInPresentationMode) {
        this._setScale(this._currentScaleValue, true);
      }

      var pageView = this._pages[this._currentPageNumber - 1];

      this._scrollIntoView({
        pageDiv: pageView.div
      });
    }
  }, {
    key: "scrollPageIntoView",
    value: function scrollPageIntoView(_ref3) {
      var pageNumber = _ref3.pageNumber,
          _ref3$destArray = _ref3.destArray,
          destArray = _ref3$destArray === void 0 ? null : _ref3$destArray,
          _ref3$allowNegativeOf = _ref3.allowNegativeOffset,
          allowNegativeOffset = _ref3$allowNegativeOf === void 0 ? false : _ref3$allowNegativeOf;

      if (!this.pdfDocument) {
        return;
      }

      var pageView = Number.isInteger(pageNumber) && this._pages[pageNumber - 1];

      if (!pageView) {
        console.error("".concat(this._name, ".scrollPageIntoView: ") + "\"".concat(pageNumber, "\" is not a valid pageNumber parameter."));
        return;
      }

      if (this.isInPresentationMode || !destArray) {
        this._setCurrentPageNumber(pageNumber, true);

        return;
      }

      var x = 0,
          y = 0;
      var width = 0,
          height = 0,
          widthScale,
          heightScale;
      var changeOrientation = pageView.rotation % 180 === 0 ? false : true;
      var pageWidth = (changeOrientation ? pageView.height : pageView.width) / pageView.scale / _ui_utils.CSS_UNITS;
      var pageHeight = (changeOrientation ? pageView.width : pageView.height) / pageView.scale / _ui_utils.CSS_UNITS;
      var scale = 0;

      switch (destArray[1].name) {
        case 'XYZ':
          x = destArray[2];
          y = destArray[3];
          scale = destArray[4];
          x = x !== null ? x : 0;
          y = y !== null ? y : pageHeight;
          break;

        case 'Fit':
        case 'FitB':
          scale = 'page-fit';
          break;

        case 'FitH':
        case 'FitBH':
          y = destArray[2];
          scale = 'page-width';

          if (y === null && this._location) {
            x = this._location.left;
            y = this._location.top;
          }

          break;

        case 'FitV':
        case 'FitBV':
          x = destArray[2];
          width = pageWidth;
          height = pageHeight;
          scale = 'page-height';
          break;

        case 'FitR':
          x = destArray[2];
          y = destArray[3];
          width = destArray[4] - x;
          height = destArray[5] - y;
          var hPadding = this.removePageBorders ? 0 : _ui_utils.SCROLLBAR_PADDING;
          var vPadding = this.removePageBorders ? 0 : _ui_utils.VERTICAL_PADDING;
          widthScale = (this.container.clientWidth - hPadding) / width / _ui_utils.CSS_UNITS;
          heightScale = (this.container.clientHeight - vPadding) / height / _ui_utils.CSS_UNITS;
          scale = Math.min(Math.abs(widthScale), Math.abs(heightScale));
          break;

        default:
          console.error("".concat(this._name, ".scrollPageIntoView: ") + "\"".concat(destArray[1].name, "\" is not a valid destination type."));
          return;
      }

      if (scale && scale !== this._currentScale) {
        this.currentScaleValue = scale;
      } else if (this._currentScale === _ui_utils.UNKNOWN_SCALE) {
        this.currentScaleValue = _ui_utils.DEFAULT_SCALE_VALUE;
      }

      if (scale === 'page-fit' && !destArray[4]) {
        this._scrollIntoView({
          pageDiv: pageView.div,
          pageNumber: pageNumber
        });

        return;
      }

      var boundingRect = [pageView.viewport.convertToViewportPoint(x, y), pageView.viewport.convertToViewportPoint(x + width, y + height)];
      var left = Math.min(boundingRect[0][0], boundingRect[1][0]);
      var top = Math.min(boundingRect[0][1], boundingRect[1][1]);

      if (!allowNegativeOffset) {
        left = Math.max(left, 0);
        top = Math.max(top, 0);
      }

      this._scrollIntoView({
        pageDiv: pageView.div,
        pageSpot: {
          left: left,
          top: top
        },
        pageNumber: pageNumber
      });
    }
  }, {
    key: "_updateLocation",
    value: function _updateLocation(firstPage) {
      var currentScale = this._currentScale;
      var currentScaleValue = this._currentScaleValue;
      var normalizedScaleValue = parseFloat(currentScaleValue) === currentScale ? Math.round(currentScale * 10000) / 100 : currentScaleValue;
      var pageNumber = firstPage.id;
      var pdfOpenParams = '#page=' + pageNumber;
      pdfOpenParams += '&zoom=' + normalizedScaleValue;
      var currentPageView = this._pages[pageNumber - 1];
      var container = this.container;
      var topLeft = currentPageView.getPagePoint(container.scrollLeft - firstPage.x, container.scrollTop - firstPage.y);
      var intLeft = Math.round(topLeft[0]);
      var intTop = Math.round(topLeft[1]);
      pdfOpenParams += ',' + intLeft + ',' + intTop;
      this._location = {
        pageNumber: pageNumber,
        scale: normalizedScaleValue,
        top: intTop,
        left: intLeft,
        rotation: this._pagesRotation,
        pdfOpenParams: pdfOpenParams
      };
    }
  }, {
    key: "_updateHelper",
    value: function _updateHelper(visiblePages) {
      throw new Error('Not implemented: _updateHelper');
    }
  }, {
    key: "update",
    value: function update() {
      var visible = this._getVisiblePages();

      var visiblePages = visible.views,
          numVisiblePages = visiblePages.length;

      if (numVisiblePages === 0) {
        return;
      }

      var newCacheSize = Math.max(DEFAULT_CACHE_SIZE, 2 * numVisiblePages + 1);

      this._buffer.resize(newCacheSize, visiblePages);

      this.renderingQueue.renderHighestPriority(visible);

      this._updateHelper(visiblePages);

      this._updateLocation(visible.first);

      this.eventBus.dispatch('updateviewarea', {
        source: this,
        location: this._location
      });
    }
  }, {
    key: "containsElement",
    value: function containsElement(element) {
      return this.container.contains(element);
    }
  }, {
    key: "focus",
    value: function focus() {
      this.container.focus();
    }
  }, {
    key: "_getCurrentVisiblePage",
    value: function _getCurrentVisiblePage() {
      if (!this.pagesCount) {
        return {
          views: []
        };
      }

      var pageView = this._pages[this._currentPageNumber - 1];
      var element = pageView.div;
      var view = {
        id: pageView.id,
        x: element.offsetLeft + element.clientLeft,
        y: element.offsetTop + element.clientTop,
        view: pageView
      };
      return {
        first: view,
        last: view,
        views: [view]
      };
    }
  }, {
    key: "_getVisiblePages",
    value: function _getVisiblePages() {
      return (0, _ui_utils.getVisibleElements)(this.container, this._pages, true, this._isScrollModeHorizontal);
    }
  }, {
    key: "isPageVisible",
    value: function isPageVisible(pageNumber) {
      if (!this.pdfDocument) {
        return false;
      }

      if (this.pageNumber < 1 || pageNumber > this.pagesCount) {
        console.error("".concat(this._name, ".isPageVisible: \"").concat(pageNumber, "\" is out of bounds."));
        return false;
      }

      return this._getVisiblePages().views.some(function (view) {
        return view.id === pageNumber;
      });
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      for (var i = 0, ii = this._pages.length; i < ii; i++) {
        if (this._pages[i] && this._pages[i].renderingState !== _pdf_rendering_queue.RenderingStates.FINISHED) {
          this._pages[i].reset();
        }
      }
    }
  }, {
    key: "_cancelRendering",
    value: function _cancelRendering() {
      for (var i = 0, ii = this._pages.length; i < ii; i++) {
        if (this._pages[i]) {
          this._pages[i].cancelRendering();
        }
      }
    }
  }, {
    key: "_ensurePdfPageLoaded",
    value: function _ensurePdfPageLoaded(pageView) {
      var _this3 = this;

      if (pageView.pdfPage) {
        return Promise.resolve(pageView.pdfPage);
      }

      var pageNumber = pageView.id;

      if (this._pagesRequests[pageNumber]) {
        return this._pagesRequests[pageNumber];
      }

      var promise = this.pdfDocument.getPage(pageNumber).then(function (pdfPage) {
        if (!pageView.pdfPage) {
          pageView.setPdfPage(pdfPage);
        }

        _this3._pagesRequests[pageNumber] = null;
        return pdfPage;
      }).catch(function (reason) {
        console.error('Unable to get page for page view', reason);
        _this3._pagesRequests[pageNumber] = null;
      });
      this._pagesRequests[pageNumber] = promise;
      return promise;
    }
  }, {
    key: "forceRendering",
    value: function forceRendering(currentlyVisiblePages) {
      var _this4 = this;

      var visiblePages = currentlyVisiblePages || this._getVisiblePages();

      var scrollAhead = this._isScrollModeHorizontal ? this.scroll.right : this.scroll.down;
      var pageView = this.renderingQueue.getHighestPriority(visiblePages, this._pages, scrollAhead);

      if (pageView) {
        this._ensurePdfPageLoaded(pageView).then(function () {
          _this4.renderingQueue.renderView(pageView);
        });

        return true;
      }

      return false;
    }
  }, {
    key: "createTextLayerBuilder",
    value: function createTextLayerBuilder(textLayerDiv, pageIndex, viewport) {
      var enhanceTextSelection = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      return new _text_layer_builder.TextLayerBuilder({
        textLayerDiv: textLayerDiv,
        eventBus: this.eventBus,
        pageIndex: pageIndex,
        viewport: viewport,
        findController: this.isInPresentationMode ? null : this.findController,
        enhanceTextSelection: this.isInPresentationMode ? false : enhanceTextSelection
      });
    }
  }, {
    key: "createAnnotationLayerBuilder",
    value: function createAnnotationLayerBuilder(pageDiv, pdfPage) {
      var imageResourcesPath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
      var renderInteractiveForms = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var l10n = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : _ui_utils.NullL10n;
      return new _annotation_layer_builder.AnnotationLayerBuilder({
        pageDiv: pageDiv,
        pdfPage: pdfPage,
        imageResourcesPath: imageResourcesPath,
        renderInteractiveForms: renderInteractiveForms,
        linkService: this.linkService,
        downloadManager: this.downloadManager,
        l10n: l10n
      });
    }
  }, {
    key: "getPagesOverview",
    value: function getPagesOverview() {
      var pagesOverview = this._pages.map(function (pageView) {
        var viewport = pageView.pdfPage.getViewport({
          scale: 1
        });
        return {
          width: viewport.width,
          height: viewport.height,
          rotation: viewport.rotation
        };
      });

      if (!this.enablePrintAutoRotate) {
        return pagesOverview;
      }

      var isFirstPagePortrait = (0, _ui_utils.isPortraitOrientation)(pagesOverview[0]);
      return pagesOverview.map(function (size) {
        if (isFirstPagePortrait === (0, _ui_utils.isPortraitOrientation)(size)) {
          return size;
        }

        return {
          width: size.height,
          height: size.width,
          rotation: (size.rotation + 90) % 360
        };
      });
    }
  }, {
    key: "_updateScrollMode",
    value: function _updateScrollMode() {
      var pageNumber = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var scrollMode = this._scrollMode,
          viewer = this.viewer;
      viewer.classList.toggle('scrollHorizontal', scrollMode === _ui_utils.ScrollMode.HORIZONTAL);
      viewer.classList.toggle('scrollWrapped', scrollMode === _ui_utils.ScrollMode.WRAPPED);

      if (!this.pdfDocument || !pageNumber) {
        return;
      }

      if (this._currentScaleValue && isNaN(this._currentScaleValue)) {
        this._setScale(this._currentScaleValue, true);
      }

      this._setCurrentPageNumber(pageNumber, true);

      this.update();
    }
  }, {
    key: "_updateSpreadMode",
    value: function _updateSpreadMode() {
      var pageNumber = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (!this.pdfDocument) {
        return;
      }

      var viewer = this.viewer,
          pages = this._pages;
      viewer.textContent = '';

      if (this._spreadMode === _ui_utils.SpreadMode.NONE) {
        for (var i = 0, iMax = pages.length; i < iMax; ++i) {
          viewer.appendChild(pages[i].div);
        }
      } else {
        var parity = this._spreadMode - 1;
        var spread = null;

        for (var _i = 0, _iMax = pages.length; _i < _iMax; ++_i) {
          if (spread === null) {
            spread = document.createElement('div');
            spread.className = 'spread';
            viewer.appendChild(spread);
          } else if (_i % 2 === parity) {
            spread = spread.cloneNode(false);
            viewer.appendChild(spread);
          }

          spread.appendChild(pages[_i].div);
        }
      }

      if (!pageNumber) {
        return;
      }

      this._setCurrentPageNumber(pageNumber, true);

      this.update();
    }
  }, {
    key: "pagesCount",
    get: function get() {
      return this._pages.length;
    }
  }, {
    key: "pageViewsReady",
    get: function get() {
      return this._pageViewsReady;
    }
  }, {
    key: "currentPageNumber",
    get: function get() {
      return this._currentPageNumber;
    },
    set: function set(val) {
      if (!Number.isInteger(val)) {
        throw new Error('Invalid page number.');
      }

      if (!this.pdfDocument) {
        return;
      }

      if (!this._setCurrentPageNumber(val, true)) {
        console.error("".concat(this._name, ".currentPageNumber: \"").concat(val, "\" is not a valid page."));
      }
    }
  }, {
    key: "currentPageLabel",
    get: function get() {
      return this._pageLabels && this._pageLabels[this._currentPageNumber - 1];
    },
    set: function set(val) {
      if (!this.pdfDocument) {
        return;
      }

      var page = val | 0;

      if (this._pageLabels) {
        var i = this._pageLabels.indexOf(val);

        if (i >= 0) {
          page = i + 1;
        }
      }

      if (!this._setCurrentPageNumber(page, true)) {
        console.error("".concat(this._name, ".currentPageLabel: \"").concat(val, "\" is not a valid page."));
      }
    }
  }, {
    key: "currentScale",
    get: function get() {
      return this._currentScale !== _ui_utils.UNKNOWN_SCALE ? this._currentScale : _ui_utils.DEFAULT_SCALE;
    },
    set: function set(val) {
      if (isNaN(val)) {
        throw new Error('Invalid numeric scale.');
      }

      if (!this.pdfDocument) {
        return;
      }

      this._setScale(val, false);
    }
  }, {
    key: "currentScaleValue",
    get: function get() {
      return this._currentScaleValue;
    },
    set: function set(val) {
      if (!this.pdfDocument) {
        return;
      }

      this._setScale(val, false);
    }
  }, {
    key: "pagesRotation",
    get: function get() {
      return this._pagesRotation;
    },
    set: function set(rotation) {
      if (!(0, _ui_utils.isValidRotation)(rotation)) {
        throw new Error('Invalid pages rotation angle.');
      }

      if (!this.pdfDocument) {
        return;
      }

      if (this._pagesRotation === rotation) {
        return;
      }

      this._pagesRotation = rotation;
      var pageNumber = this._currentPageNumber;

      for (var i = 0, ii = this._pages.length; i < ii; i++) {
        var pageView = this._pages[i];
        pageView.update(pageView.scale, rotation);
      }

      if (this._currentScaleValue) {
        this._setScale(this._currentScaleValue, true);
      }

      this.eventBus.dispatch('rotationchanging', {
        source: this,
        pagesRotation: rotation,
        pageNumber: pageNumber
      });

      if (this.defaultRenderingQueue) {
        this.update();
      }
    }
  }, {
    key: "_setDocumentViewerElement",
    get: function get() {
      throw new Error('Not implemented: _setDocumentViewerElement');
    }
  }, {
    key: "_isScrollModeHorizontal",
    get: function get() {
      return this.isInPresentationMode ? false : this._scrollMode === _ui_utils.ScrollMode.HORIZONTAL;
    }
  }, {
    key: "isInPresentationMode",
    get: function get() {
      return this.presentationModeState === _ui_utils.PresentationModeState.FULLSCREEN;
    }
  }, {
    key: "isChangingPresentationMode",
    get: function get() {
      return this.presentationModeState === _ui_utils.PresentationModeState.CHANGING;
    }
  }, {
    key: "isHorizontalScrollbarEnabled",
    get: function get() {
      return this.isInPresentationMode ? false : this.container.scrollWidth > this.container.clientWidth;
    }
  }, {
    key: "isVerticalScrollbarEnabled",
    get: function get() {
      return this.isInPresentationMode ? false : this.container.scrollHeight > this.container.clientHeight;
    }
  }, {
    key: "hasEqualPageSizes",
    get: function get() {
      var firstPageView = this._pages[0];

      for (var i = 1, ii = this._pages.length; i < ii; ++i) {
        var pageView = this._pages[i];

        if (pageView.width !== firstPageView.width || pageView.height !== firstPageView.height) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "scrollMode",
    get: function get() {
      return this._scrollMode;
    },
    set: function set(mode) {
      if (this._scrollMode === mode) {
        return;
      }

      if (!(0, _ui_utils.isValidScrollMode)(mode)) {
        throw new Error("Invalid scroll mode: ".concat(mode));
      }

      this._scrollMode = mode;
      this.eventBus.dispatch('scrollmodechanged', {
        source: this,
        mode: mode
      });

      this._updateScrollMode(this._currentPageNumber);
    }
  }, {
    key: "spreadMode",
    get: function get() {
      return this._spreadMode;
    },
    set: function set(mode) {
      if (this._spreadMode === mode) {
        return;
      }

      if (!(0, _ui_utils.isValidSpreadMode)(mode)) {
        throw new Error("Invalid spread mode: ".concat(mode));
      }

      this._spreadMode = mode;
      this.eventBus.dispatch('spreadmodechanged', {
        source: this,
        mode: mode
      });

      this._updateSpreadMode(this._currentPageNumber);
    }
  }]);

  return BaseViewer;
}();

exports.BaseViewer = BaseViewer;

/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DefaultAnnotationLayerFactory = exports.AnnotationLayerBuilder = void 0;

var _pdfjsLib = __webpack_require__(7);

var _ui_utils = __webpack_require__(6);

var _pdf_link_service = __webpack_require__(22);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var AnnotationLayerBuilder =
/*#__PURE__*/
function () {
  function AnnotationLayerBuilder(_ref) {
    var pageDiv = _ref.pageDiv,
        pdfPage = _ref.pdfPage,
        linkService = _ref.linkService,
        downloadManager = _ref.downloadManager,
        _ref$imageResourcesPa = _ref.imageResourcesPath,
        imageResourcesPath = _ref$imageResourcesPa === void 0 ? '' : _ref$imageResourcesPa,
        _ref$renderInteractiv = _ref.renderInteractiveForms,
        renderInteractiveForms = _ref$renderInteractiv === void 0 ? false : _ref$renderInteractiv,
        _ref$l10n = _ref.l10n,
        l10n = _ref$l10n === void 0 ? _ui_utils.NullL10n : _ref$l10n;

    _classCallCheck(this, AnnotationLayerBuilder);

    this.pageDiv = pageDiv;
    this.pdfPage = pdfPage;
    this.linkService = linkService;
    this.downloadManager = downloadManager;
    this.imageResourcesPath = imageResourcesPath;
    this.renderInteractiveForms = renderInteractiveForms;
    this.l10n = l10n;
    this.div = null;
    this._cancelled = false;
  }

  _createClass(AnnotationLayerBuilder, [{
    key: "render",
    value: function render(viewport) {
      var _this = this;

      var intent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'display';
      this.pdfPage.getAnnotations({
        intent: intent
      }).then(function (annotations) {
        if (_this._cancelled) {
          return;
        }

        var parameters = {
          viewport: viewport.clone({
            dontFlip: true
          }),
          div: _this.div,
          annotations: annotations,
          page: _this.pdfPage,
          imageResourcesPath: _this.imageResourcesPath,
          renderInteractiveForms: _this.renderInteractiveForms,
          linkService: _this.linkService,
          downloadManager: _this.downloadManager
        };

        if (_this.div) {
          _pdfjsLib.AnnotationLayer.update(parameters);
        } else {
          if (annotations.length === 0) {
            return;
          }

          _this.div = document.createElement('div');
          _this.div.className = 'annotationLayer';

          _this.pageDiv.appendChild(_this.div);

          parameters.div = _this.div;

          _pdfjsLib.AnnotationLayer.render(parameters);

          _this.l10n.translate(_this.div);
        }
      });
    }
  }, {
    key: "cancel",
    value: function cancel() {
      this._cancelled = true;
    }
  }, {
    key: "hide",
    value: function hide() {
      if (!this.div) {
        return;
      }

      this.div.setAttribute('hidden', 'true');
    }
  }]);

  return AnnotationLayerBuilder;
}();

exports.AnnotationLayerBuilder = AnnotationLayerBuilder;

var DefaultAnnotationLayerFactory =
/*#__PURE__*/
function () {
  function DefaultAnnotationLayerFactory() {
    _classCallCheck(this, DefaultAnnotationLayerFactory);
  }

  _createClass(DefaultAnnotationLayerFactory, [{
    key: "createAnnotationLayerBuilder",
    value: function createAnnotationLayerBuilder(pageDiv, pdfPage) {
      var imageResourcesPath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
      var renderInteractiveForms = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var l10n = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : _ui_utils.NullL10n;
      return new AnnotationLayerBuilder({
        pageDiv: pageDiv,
        pdfPage: pdfPage,
        imageResourcesPath: imageResourcesPath,
        renderInteractiveForms: renderInteractiveForms,
        linkService: new _pdf_link_service.SimpleLinkService(),
        l10n: l10n
      });
    }
  }]);

  return DefaultAnnotationLayerFactory;
}();

exports.DefaultAnnotationLayerFactory = DefaultAnnotationLayerFactory;

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFPageView = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

var _ui_utils = __webpack_require__(6);

var _pdfjsLib = __webpack_require__(7);

var _pdf_rendering_queue = __webpack_require__(10);

var _viewer_compatibility = __webpack_require__(13);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var MAX_CANVAS_PIXELS = _viewer_compatibility.viewerCompatibilityParams.maxCanvasPixels || 16777216;

var PDFPageView =
/*#__PURE__*/
function () {
  function PDFPageView(options) {
    _classCallCheck(this, PDFPageView);

    var container = options.container;
    var defaultViewport = options.defaultViewport;
    this.id = options.id;
    this.renderingId = 'page' + this.id;
    this.pdfPage = null;
    this.pageLabel = null;
    this.rotation = 0;
    this.scale = options.scale || _ui_utils.DEFAULT_SCALE;
    this.viewport = defaultViewport;
    this.pdfPageRotate = defaultViewport.rotation;
    this.hasRestrictedScaling = false;
    this.textLayerMode = Number.isInteger(options.textLayerMode) ? options.textLayerMode : _ui_utils.TextLayerMode.ENABLE;
    this.imageResourcesPath = options.imageResourcesPath || '';
    this.renderInteractiveForms = options.renderInteractiveForms || false;
    this.useOnlyCssZoom = options.useOnlyCssZoom || false;
    this.maxCanvasPixels = options.maxCanvasPixels || MAX_CANVAS_PIXELS;
    this.eventBus = options.eventBus || (0, _ui_utils.getGlobalEventBus)();
    this.renderingQueue = options.renderingQueue;
    this.textLayerFactory = options.textLayerFactory;
    this.annotationLayerFactory = options.annotationLayerFactory;
    this.renderer = options.renderer || _ui_utils.RendererType.CANVAS;
    this.enableWebGL = options.enableWebGL || false;
    this.l10n = options.l10n || _ui_utils.NullL10n;
    this.paintTask = null;
    this.paintedViewportMap = new WeakMap();
    this.renderingState = _pdf_rendering_queue.RenderingStates.INITIAL;
    this.resume = null;
    this.error = null;
    this.onBeforeDraw = null;
    this.onAfterDraw = null;
    this.annotationLayer = null;
    this.textLayer = null;
    this.zoomLayer = null;
    var div = document.createElement('div');
    div.className = 'page';
    div.style.width = Math.floor(this.viewport.width) + 'px';
    div.style.height = Math.floor(this.viewport.height) + 'px';
    div.setAttribute('data-page-number', this.id);
    this.div = div;
    container.appendChild(div);
  }

  _createClass(PDFPageView, [{
    key: "setPdfPage",
    value: function setPdfPage(pdfPage) {
      this.pdfPage = pdfPage;
      this.pdfPageRotate = pdfPage.rotate;
      var totalRotation = (this.rotation + this.pdfPageRotate) % 360;
      this.viewport = pdfPage.getViewport({
        scale: this.scale * _ui_utils.CSS_UNITS,
        rotation: totalRotation
      });
      this.stats = pdfPage.stats;
      this.reset();
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.reset();

      if (this.pdfPage) {
        this.pdfPage.cleanup();
      }
    }
  }, {
    key: "_resetZoomLayer",
    value: function _resetZoomLayer() {
      var removeFromDOM = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!this.zoomLayer) {
        return;
      }

      var zoomLayerCanvas = this.zoomLayer.firstChild;
      this.paintedViewportMap.delete(zoomLayerCanvas);
      zoomLayerCanvas.width = 0;
      zoomLayerCanvas.height = 0;

      if (removeFromDOM) {
        this.zoomLayer.remove();
      }

      this.zoomLayer = null;
    }
  }, {
    key: "reset",
    value: function reset() {
      var keepZoomLayer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var keepAnnotations = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      this.cancelRendering(keepAnnotations);
      var div = this.div;
      div.style.width = Math.floor(this.viewport.width) + 'px';
      div.style.height = Math.floor(this.viewport.height) + 'px';
      var childNodes = div.childNodes;
      var currentZoomLayerNode = keepZoomLayer && this.zoomLayer || null;
      var currentAnnotationNode = keepAnnotations && this.annotationLayer && this.annotationLayer.div || null;

      for (var i = childNodes.length - 1; i >= 0; i--) {
        var node = childNodes[i];

        if (currentZoomLayerNode === node || currentAnnotationNode === node) {
          continue;
        }

        div.removeChild(node);
      }

      div.removeAttribute('data-loaded');

      if (currentAnnotationNode) {
        this.annotationLayer.hide();
      } else if (this.annotationLayer) {
        this.annotationLayer.cancel();
        this.annotationLayer = null;
      }

      if (!currentZoomLayerNode) {
        if (this.canvas) {
          this.paintedViewportMap.delete(this.canvas);
          this.canvas.width = 0;
          this.canvas.height = 0;
          delete this.canvas;
        }

        this._resetZoomLayer();
      }

      if (this.svg) {
        this.paintedViewportMap.delete(this.svg);
        delete this.svg;
      }

      this.loadingIconDiv = document.createElement('div');
      this.loadingIconDiv.className = 'loadingIcon';
      div.appendChild(this.loadingIconDiv);
    }
  }, {
    key: "update",
    value: function update(scale, rotation) {
      this.scale = scale || this.scale;

      if (typeof rotation !== 'undefined') {
        this.rotation = rotation;
      }

      var totalRotation = (this.rotation + this.pdfPageRotate) % 360;
      this.viewport = this.viewport.clone({
        scale: this.scale * _ui_utils.CSS_UNITS,
        rotation: totalRotation
      });

      if (this.svg) {
        this.cssTransform(this.svg, true);
        this.eventBus.dispatch('pagerendered', {
          source: this,
          pageNumber: this.id,
          cssTransform: true
        });
        return;
      }

      var isScalingRestricted = false;

      if (this.canvas && this.maxCanvasPixels > 0) {
        var outputScale = this.outputScale;

        if ((Math.floor(this.viewport.width) * outputScale.sx | 0) * (Math.floor(this.viewport.height) * outputScale.sy | 0) > this.maxCanvasPixels) {
          isScalingRestricted = true;
        }
      }

      if (this.canvas) {
        if (this.useOnlyCssZoom || this.hasRestrictedScaling && isScalingRestricted) {
          this.cssTransform(this.canvas, true);
          this.eventBus.dispatch('pagerendered', {
            source: this,
            pageNumber: this.id,
            cssTransform: true
          });
          return;
        }

        if (!this.zoomLayer && !this.canvas.hasAttribute('hidden')) {
          this.zoomLayer = this.canvas.parentNode;
          this.zoomLayer.style.position = 'absolute';
        }
      }

      if (this.zoomLayer) {
        this.cssTransform(this.zoomLayer.firstChild);
      }

      this.reset(true, true);
    }
  }, {
    key: "cancelRendering",
    value: function cancelRendering() {
      var keepAnnotations = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var renderingState = this.renderingState;

      if (this.paintTask) {
        this.paintTask.cancel();
        this.paintTask = null;
      }

      this.renderingState = _pdf_rendering_queue.RenderingStates.INITIAL;
      this.resume = null;

      if (this.textLayer) {
        this.textLayer.cancel();
        this.textLayer = null;
      }

      if (!keepAnnotations && this.annotationLayer) {
        this.annotationLayer.cancel();
        this.annotationLayer = null;
      }

      if (renderingState !== _pdf_rendering_queue.RenderingStates.INITIAL) {
        this.eventBus.dispatch('pagecancelled', {
          source: this,
          pageNumber: this.id,
          renderingState: renderingState
        });
      }
    }
  }, {
    key: "cssTransform",
    value: function cssTransform(target) {
      var redrawAnnotations = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var width = this.viewport.width;
      var height = this.viewport.height;
      var div = this.div;
      target.style.width = target.parentNode.style.width = div.style.width = Math.floor(width) + 'px';
      target.style.height = target.parentNode.style.height = div.style.height = Math.floor(height) + 'px';
      var relativeRotation = this.viewport.rotation - this.paintedViewportMap.get(target).rotation;
      var absRotation = Math.abs(relativeRotation);
      var scaleX = 1,
          scaleY = 1;

      if (absRotation === 90 || absRotation === 270) {
        scaleX = height / width;
        scaleY = width / height;
      }

      var cssTransform = 'rotate(' + relativeRotation + 'deg) ' + 'scale(' + scaleX + ',' + scaleY + ')';
      target.style.transform = cssTransform;

      if (this.textLayer) {
        var textLayerViewport = this.textLayer.viewport;
        var textRelativeRotation = this.viewport.rotation - textLayerViewport.rotation;
        var textAbsRotation = Math.abs(textRelativeRotation);
        var scale = width / textLayerViewport.width;

        if (textAbsRotation === 90 || textAbsRotation === 270) {
          scale = width / textLayerViewport.height;
        }

        var textLayerDiv = this.textLayer.textLayerDiv;
        var transX, transY;

        switch (textAbsRotation) {
          case 0:
            transX = transY = 0;
            break;

          case 90:
            transX = 0;
            transY = '-' + textLayerDiv.style.height;
            break;

          case 180:
            transX = '-' + textLayerDiv.style.width;
            transY = '-' + textLayerDiv.style.height;
            break;

          case 270:
            transX = '-' + textLayerDiv.style.width;
            transY = 0;
            break;

          default:
            console.error('Bad rotation value.');
            break;
        }

        textLayerDiv.style.transform = 'rotate(' + textAbsRotation + 'deg) ' + 'scale(' + scale + ', ' + scale + ') ' + 'translate(' + transX + ', ' + transY + ')';
        textLayerDiv.style.transformOrigin = '0% 0%';
      }

      if (redrawAnnotations && this.annotationLayer) {
        this.annotationLayer.render(this.viewport, 'display');
      }
    }
  }, {
    key: "getPagePoint",
    value: function getPagePoint(x, y) {
      return this.viewport.convertToPdfPoint(x, y);
    }
  }, {
    key: "draw",
    value: function draw() {
      var _this = this;

      if (this.renderingState !== _pdf_rendering_queue.RenderingStates.INITIAL) {
        console.error('Must be in new state before drawing');
        this.reset();
      }

      if (!this.pdfPage) {
        this.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;
        return Promise.reject(new Error('Page is not loaded'));
      }

      this.renderingState = _pdf_rendering_queue.RenderingStates.RUNNING;
      var pdfPage = this.pdfPage;
      var div = this.div;
      var canvasWrapper = document.createElement('div');
      canvasWrapper.style.width = div.style.width;
      canvasWrapper.style.height = div.style.height;
      canvasWrapper.classList.add('canvasWrapper');

      if (this.annotationLayer && this.annotationLayer.div) {
        div.insertBefore(canvasWrapper, this.annotationLayer.div);
      } else {
        div.appendChild(canvasWrapper);
      }

      var textLayer = null;

      if (this.textLayerMode !== _ui_utils.TextLayerMode.DISABLE && this.textLayerFactory) {
        var textLayerDiv = document.createElement('div');
        textLayerDiv.className = 'textLayer';
        textLayerDiv.style.width = canvasWrapper.style.width;
        textLayerDiv.style.height = canvasWrapper.style.height;

        if (this.annotationLayer && this.annotationLayer.div) {
          div.insertBefore(textLayerDiv, this.annotationLayer.div);
        } else {
          div.appendChild(textLayerDiv);
        }

        textLayer = this.textLayerFactory.createTextLayerBuilder(textLayerDiv, this.id - 1, this.viewport, this.textLayerMode === _ui_utils.TextLayerMode.ENABLE_ENHANCE);
      }

      this.textLayer = textLayer;
      var renderContinueCallback = null;

      if (this.renderingQueue) {
        renderContinueCallback = function renderContinueCallback(cont) {
          if (!_this.renderingQueue.isHighestPriority(_this)) {
            _this.renderingState = _pdf_rendering_queue.RenderingStates.PAUSED;

            _this.resume = function () {
              _this.renderingState = _pdf_rendering_queue.RenderingStates.RUNNING;
              cont();
            };

            return;
          }

          cont();
        };
      }

      var finishPaintTask =
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee(error) {
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (paintTask === _this.paintTask) {
                    _this.paintTask = null;
                  }

                  if (!(error instanceof _pdfjsLib.RenderingCancelledException)) {
                    _context.next = 4;
                    break;
                  }

                  _this.error = null;
                  return _context.abrupt("return");

                case 4:
                  _this.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;

                  if (_this.loadingIconDiv) {
                    div.removeChild(_this.loadingIconDiv);
                    delete _this.loadingIconDiv;
                  }

                  _this._resetZoomLayer(true);

                  _this.error = error;
                  _this.stats = pdfPage.stats;

                  if (_this.onAfterDraw) {
                    _this.onAfterDraw();
                  }

                  _this.eventBus.dispatch('pagerendered', {
                    source: _this,
                    pageNumber: _this.id,
                    cssTransform: false
                  });

                  if (!error) {
                    _context.next = 13;
                    break;
                  }

                  throw error;

                case 13:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function finishPaintTask(_x) {
          return _ref.apply(this, arguments);
        };
      }();

      var paintTask = this.renderer === _ui_utils.RendererType.SVG ? this.paintOnSvg(canvasWrapper) : this.paintOnCanvas(canvasWrapper);
      paintTask.onRenderContinue = renderContinueCallback;
      this.paintTask = paintTask;
      var resultPromise = paintTask.promise.then(function () {
        return finishPaintTask(null).then(function () {
          if (textLayer) {
            var readableStream = pdfPage.streamTextContent({
              normalizeWhitespace: true
            });
            textLayer.setTextContentStream(readableStream);
            textLayer.render();
          }
        });
      }, function (reason) {
        return finishPaintTask(reason);
      });

      if (this.annotationLayerFactory) {
        if (!this.annotationLayer) {
          this.annotationLayer = this.annotationLayerFactory.createAnnotationLayerBuilder(div, pdfPage, this.imageResourcesPath, this.renderInteractiveForms, this.l10n);
        }

        this.annotationLayer.render(this.viewport, 'display');
      }

      div.setAttribute('data-loaded', true);

      if (this.onBeforeDraw) {
        this.onBeforeDraw();
      }

      return resultPromise;
    }
  }, {
    key: "paintOnCanvas",
    value: function paintOnCanvas(canvasWrapper) {
      var renderCapability = (0, _pdfjsLib.createPromiseCapability)();
      var result = {
        promise: renderCapability.promise,
        onRenderContinue: function onRenderContinue(cont) {
          cont();
        },
        cancel: function cancel() {
          renderTask.cancel();
        }
      };
      var viewport = this.viewport;
      var canvas = document.createElement('canvas');
      canvas.id = this.renderingId;
      canvas.setAttribute('hidden', 'hidden');
      var isCanvasHidden = true;

      var showCanvas = function showCanvas() {
        if (isCanvasHidden) {
          canvas.removeAttribute('hidden');
          isCanvasHidden = false;
        }
      };

      canvasWrapper.appendChild(canvas);
      this.canvas = canvas;
      canvas.mozOpaque = true;
      var ctx = canvas.getContext('2d', {
        alpha: false
      });
      var outputScale = (0, _ui_utils.getOutputScale)(ctx);
      this.outputScale = outputScale;

      if (this.useOnlyCssZoom) {
        var actualSizeViewport = viewport.clone({
          scale: _ui_utils.CSS_UNITS
        });
        outputScale.sx *= actualSizeViewport.width / viewport.width;
        outputScale.sy *= actualSizeViewport.height / viewport.height;
        outputScale.scaled = true;
      }

      if (this.maxCanvasPixels > 0) {
        var pixelsInViewport = viewport.width * viewport.height;
        var maxScale = Math.sqrt(this.maxCanvasPixels / pixelsInViewport);

        if (outputScale.sx > maxScale || outputScale.sy > maxScale) {
          outputScale.sx = maxScale;
          outputScale.sy = maxScale;
          outputScale.scaled = true;
          this.hasRestrictedScaling = true;
        } else {
          this.hasRestrictedScaling = false;
        }
      }

      var sfx = (0, _ui_utils.approximateFraction)(outputScale.sx);
      var sfy = (0, _ui_utils.approximateFraction)(outputScale.sy);
      canvas.width = (0, _ui_utils.roundToDivide)(viewport.width * outputScale.sx, sfx[0]);
      canvas.height = (0, _ui_utils.roundToDivide)(viewport.height * outputScale.sy, sfy[0]);
      canvas.style.width = (0, _ui_utils.roundToDivide)(viewport.width, sfx[1]) + 'px';
      canvas.style.height = (0, _ui_utils.roundToDivide)(viewport.height, sfy[1]) + 'px';
      this.paintedViewportMap.set(canvas, viewport);
      var transform = !outputScale.scaled ? null : [outputScale.sx, 0, 0, outputScale.sy, 0, 0];
      var renderContext = {
        canvasContext: ctx,
        transform: transform,
        viewport: this.viewport,
        enableWebGL: this.enableWebGL,
        renderInteractiveForms: this.renderInteractiveForms
      };
      var renderTask = this.pdfPage.render(renderContext);

      renderTask.onContinue = function (cont) {
        showCanvas();

        if (result.onRenderContinue) {
          result.onRenderContinue(cont);
        } else {
          cont();
        }
      };

      renderTask.promise.then(function () {
        showCanvas();
        renderCapability.resolve(undefined);
      }, function (error) {
        showCanvas();
        renderCapability.reject(error);
      });
      return result;
    }
  }, {
    key: "paintOnSvg",
    value: function paintOnSvg(wrapper) {
      var _this2 = this;

      var cancelled = false;

      var ensureNotCancelled = function ensureNotCancelled() {
        if (cancelled) {
          throw new _pdfjsLib.RenderingCancelledException('Rendering cancelled, page ' + _this2.id, 'svg');
        }
      };

      var pdfPage = this.pdfPage;
      var actualSizeViewport = this.viewport.clone({
        scale: _ui_utils.CSS_UNITS
      });
      var promise = pdfPage.getOperatorList().then(function (opList) {
        ensureNotCancelled();
        var svgGfx = new _pdfjsLib.SVGGraphics(pdfPage.commonObjs, pdfPage.objs);
        return svgGfx.getSVG(opList, actualSizeViewport).then(function (svg) {
          ensureNotCancelled();
          _this2.svg = svg;

          _this2.paintedViewportMap.set(svg, actualSizeViewport);

          svg.style.width = wrapper.style.width;
          svg.style.height = wrapper.style.height;
          _this2.renderingState = _pdf_rendering_queue.RenderingStates.FINISHED;
          wrapper.appendChild(svg);
        });
      });
      return {
        promise: promise,
        onRenderContinue: function onRenderContinue(cont) {
          cont();
        },
        cancel: function cancel() {
          cancelled = true;
        }
      };
    }
  }, {
    key: "setPageLabel",
    value: function setPageLabel(label) {
      this.pageLabel = typeof label === 'string' ? label : null;

      if (this.pageLabel !== null) {
        this.div.setAttribute('data-page-label', this.pageLabel);
      } else {
        this.div.removeAttribute('data-page-label');
      }
    }
  }, {
    key: "width",
    get: function get() {
      return this.viewport.width;
    }
  }, {
    key: "height",
    get: function get() {
      return this.viewport.height;
    }
  }]);

  return PDFPageView;
}();

exports.PDFPageView = PDFPageView;

/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DefaultTextLayerFactory = exports.TextLayerBuilder = void 0;

var _ui_utils = __webpack_require__(6);

var _pdfjsLib = __webpack_require__(7);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var EXPAND_DIVS_TIMEOUT = 300;

var TextLayerBuilder =
/*#__PURE__*/
function () {
  function TextLayerBuilder(_ref) {
    var textLayerDiv = _ref.textLayerDiv,
        eventBus = _ref.eventBus,
        pageIndex = _ref.pageIndex,
        viewport = _ref.viewport,
        _ref$findController = _ref.findController,
        findController = _ref$findController === void 0 ? null : _ref$findController,
        _ref$enhanceTextSelec = _ref.enhanceTextSelection,
        enhanceTextSelection = _ref$enhanceTextSelec === void 0 ? false : _ref$enhanceTextSelec;

    _classCallCheck(this, TextLayerBuilder);

    this.textLayerDiv = textLayerDiv;
    this.eventBus = eventBus || (0, _ui_utils.getGlobalEventBus)();
    this.textContent = null;
    this.textContentItemsStr = [];
    this.textContentStream = null;
    this.renderingDone = false;
    this.pageIdx = pageIndex;
    this.pageNumber = this.pageIdx + 1;
    this.matches = [];
    this.viewport = viewport;
    this.textDivs = [];
    this.findController = findController;
    this.textLayerRenderTask = null;
    this.enhanceTextSelection = enhanceTextSelection;
    this._boundEvents = Object.create(null);

    this._bindEvents();

    this._bindMouse();
  }

  _createClass(TextLayerBuilder, [{
    key: "_finishRendering",
    value: function _finishRendering() {
      this.renderingDone = true;

      if (!this.enhanceTextSelection) {
        var endOfContent = document.createElement('div');
        endOfContent.className = 'endOfContent';
        this.textLayerDiv.appendChild(endOfContent);
      }

      this.eventBus.dispatch('textlayerrendered', {
        source: this,
        pageNumber: this.pageNumber,
        numTextDivs: this.textDivs.length
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (!(this.textContent || this.textContentStream) || this.renderingDone) {
        return;
      }

      this.cancel();
      this.textDivs = [];
      var textLayerFrag = document.createDocumentFragment();
      this.textLayerRenderTask = (0, _pdfjsLib.renderTextLayer)({
        textContent: this.textContent,
        textContentStream: this.textContentStream,
        container: textLayerFrag,
        viewport: this.viewport,
        textDivs: this.textDivs,
        textContentItemsStr: this.textContentItemsStr,
        timeout: timeout,
        enhanceTextSelection: this.enhanceTextSelection
      });
      this.textLayerRenderTask.promise.then(function () {
        _this.textLayerDiv.appendChild(textLayerFrag);

        _this._finishRendering();

        _this._updateMatches();
      }, function (reason) {});
    }
  }, {
    key: "cancel",
    value: function cancel() {
      if (this.textLayerRenderTask) {
        this.textLayerRenderTask.cancel();
        this.textLayerRenderTask = null;
      }
    }
  }, {
    key: "setTextContentStream",
    value: function setTextContentStream(readableStream) {
      this.cancel();
      this.textContentStream = readableStream;
    }
  }, {
    key: "setTextContent",
    value: function setTextContent(textContent) {
      this.cancel();
      this.textContent = textContent;
    }
  }, {
    key: "_convertMatches",
    value: function _convertMatches(matches, matchesLength) {
      if (!matches) {
        return [];
      }

      var findController = this.findController,
          textContentItemsStr = this.textContentItemsStr;
      var i = 0,
          iIndex = 0;
      var end = textContentItemsStr.length - 1;
      var queryLen = findController.state.query.length;
      var result = [];

      for (var m = 0, mm = matches.length; m < mm; m++) {
        var matchIdx = matches[m];

        while (i !== end && matchIdx >= iIndex + textContentItemsStr[i].length) {
          iIndex += textContentItemsStr[i].length;
          i++;
        }

        if (i === textContentItemsStr.length) {
          console.error('Could not find a matching mapping');
        }

        var match = {
          begin: {
            divIdx: i,
            offset: matchIdx - iIndex
          }
        };

        if (matchesLength) {
          matchIdx += matchesLength[m];
        } else {
          matchIdx += queryLen;
        }

        while (i !== end && matchIdx > iIndex + textContentItemsStr[i].length) {
          iIndex += textContentItemsStr[i].length;
          i++;
        }

        match.end = {
          divIdx: i,
          offset: matchIdx - iIndex
        };
        result.push(match);
      }

      return result;
    }
  }, {
    key: "_renderMatches",
    value: function _renderMatches(matches) {
      if (matches.length === 0) {
        return;
      }

      var findController = this.findController,
          pageIdx = this.pageIdx,
          textContentItemsStr = this.textContentItemsStr,
          textDivs = this.textDivs;
      var isSelectedPage = pageIdx === findController.selected.pageIdx;
      var selectedMatchIdx = findController.selected.matchIdx;
      var highlightAll = findController.state.highlightAll;
      var prevEnd = null;
      var infinity = {
        divIdx: -1,
        offset: undefined
      };

      function beginText(begin, className) {
        var divIdx = begin.divIdx;
        textDivs[divIdx].textContent = '';
        appendTextToDiv(divIdx, 0, begin.offset, className);
      }

      function appendTextToDiv(divIdx, fromOffset, toOffset, className) {
        var div = textDivs[divIdx];
        var content = textContentItemsStr[divIdx].substring(fromOffset, toOffset);
        var node = document.createTextNode(content);

        if (className) {
          var span = document.createElement('span');
          span.className = className;
          span.appendChild(node);
          div.appendChild(span);
          return;
        }

        div.appendChild(node);
      }

      var i0 = selectedMatchIdx,
          i1 = i0 + 1;

      if (highlightAll) {
        i0 = 0;
        i1 = matches.length;
      } else if (!isSelectedPage) {
        return;
      }

      for (var i = i0; i < i1; i++) {
        var match = matches[i];
        var begin = match.begin;
        var end = match.end;
        var isSelected = isSelectedPage && i === selectedMatchIdx;
        var highlightSuffix = isSelected ? ' selected' : '';

        if (isSelected) {
          findController.scrollMatchIntoView({
            element: textDivs[begin.divIdx],
            pageIndex: pageIdx,
            matchIndex: selectedMatchIdx
          });
        }

        if (!prevEnd || begin.divIdx !== prevEnd.divIdx) {
          if (prevEnd !== null) {
            appendTextToDiv(prevEnd.divIdx, prevEnd.offset, infinity.offset);
          }

          beginText(begin);
        } else {
          appendTextToDiv(prevEnd.divIdx, prevEnd.offset, begin.offset);
        }

        if (begin.divIdx === end.divIdx) {
          appendTextToDiv(begin.divIdx, begin.offset, end.offset, 'highlight' + highlightSuffix);
        } else {
          appendTextToDiv(begin.divIdx, begin.offset, infinity.offset, 'highlight begin' + highlightSuffix);

          for (var n0 = begin.divIdx + 1, n1 = end.divIdx; n0 < n1; n0++) {
            textDivs[n0].className = 'highlight middle' + highlightSuffix;
          }

          beginText(end, 'highlight end' + highlightSuffix);
        }

        prevEnd = end;
      }

      if (prevEnd) {
        appendTextToDiv(prevEnd.divIdx, prevEnd.offset, infinity.offset);
      }
    }
  }, {
    key: "_updateMatches",
    value: function _updateMatches() {
      if (!this.renderingDone) {
        return;
      }

      var findController = this.findController,
          matches = this.matches,
          pageIdx = this.pageIdx,
          textContentItemsStr = this.textContentItemsStr,
          textDivs = this.textDivs;
      var clearedUntilDivIdx = -1;

      for (var i = 0, ii = matches.length; i < ii; i++) {
        var match = matches[i];
        var begin = Math.max(clearedUntilDivIdx, match.begin.divIdx);

        for (var n = begin, end = match.end.divIdx; n <= end; n++) {
          var div = textDivs[n];
          div.textContent = textContentItemsStr[n];
          div.className = '';
        }

        clearedUntilDivIdx = match.end.divIdx + 1;
      }

      if (!findController || !findController.highlightMatches) {
        return;
      }

      var pageMatches = findController.pageMatches[pageIdx] || null;
      var pageMatchesLength = findController.pageMatchesLength[pageIdx] || null;
      this.matches = this._convertMatches(pageMatches, pageMatchesLength);

      this._renderMatches(this.matches);
    }
  }, {
    key: "_bindEvents",
    value: function _bindEvents() {
      var _this2 = this;

      var eventBus = this.eventBus,
          _boundEvents = this._boundEvents;

      _boundEvents.pageCancelled = function (evt) {
        if (evt.pageNumber !== _this2.pageNumber) {
          return;
        }

        if (_this2.textLayerRenderTask) {
          console.error('TextLayerBuilder._bindEvents: `this.cancel()` should ' + 'have been called when the page was reset, or rendering cancelled.');
          return;
        }

        for (var name in _boundEvents) {
          eventBus.off(name.toLowerCase(), _boundEvents[name]);
          delete _boundEvents[name];
        }
      };

      _boundEvents.updateTextLayerMatches = function (evt) {
        if (evt.pageIndex !== _this2.pageIdx && evt.pageIndex !== -1) {
          return;
        }

        _this2._updateMatches();
      };

      eventBus.on('pagecancelled', _boundEvents.pageCancelled);
      eventBus.on('updatetextlayermatches', _boundEvents.updateTextLayerMatches);
    }
  }, {
    key: "_bindMouse",
    value: function _bindMouse() {
      var _this3 = this;

      var div = this.textLayerDiv;
      var expandDivsTimer = null;
      div.addEventListener('mousedown', function (evt) {
        if (_this3.enhanceTextSelection && _this3.textLayerRenderTask) {
          _this3.textLayerRenderTask.expandTextDivs(true);

          if (expandDivsTimer) {
            clearTimeout(expandDivsTimer);
            expandDivsTimer = null;
          }

          return;
        }

        var end = div.querySelector('.endOfContent');

        if (!end) {
          return;
        }

        var adjustTop = evt.target !== div;
        adjustTop = adjustTop && window.getComputedStyle(end).getPropertyValue('-moz-user-select') !== 'none';

        if (adjustTop) {
          var divBounds = div.getBoundingClientRect();
          var r = Math.max(0, (evt.pageY - divBounds.top) / divBounds.height);
          end.style.top = (r * 100).toFixed(2) + '%';
        }

        end.classList.add('active');
      });
      div.addEventListener('mouseup', function () {
        if (_this3.enhanceTextSelection && _this3.textLayerRenderTask) {
          expandDivsTimer = setTimeout(function () {
            if (_this3.textLayerRenderTask) {
              _this3.textLayerRenderTask.expandTextDivs(false);
            }

            expandDivsTimer = null;
          }, EXPAND_DIVS_TIMEOUT);
          return;
        }

        var end = div.querySelector('.endOfContent');

        if (!end) {
          return;
        }

        end.style.top = '';
        end.classList.remove('active');
      });
    }
  }]);

  return TextLayerBuilder;
}();

exports.TextLayerBuilder = TextLayerBuilder;

var DefaultTextLayerFactory =
/*#__PURE__*/
function () {
  function DefaultTextLayerFactory() {
    _classCallCheck(this, DefaultTextLayerFactory);
  }

  _createClass(DefaultTextLayerFactory, [{
    key: "createTextLayerBuilder",
    value: function createTextLayerBuilder(textLayerDiv, pageIndex, viewport) {
      var enhanceTextSelection = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      return new TextLayerBuilder({
        textLayerDiv: textLayerDiv,
        pageIndex: pageIndex,
        viewport: viewport,
        enhanceTextSelection: enhanceTextSelection
      });
    }
  }]);

  return DefaultTextLayerFactory;
}();

exports.DefaultTextLayerFactory = DefaultTextLayerFactory;

/***/ }),
/* 33 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SecondaryToolbar = void 0;

var _ui_utils = __webpack_require__(6);

var _pdf_cursor_tools = __webpack_require__(8);

var _pdf_single_page_viewer = __webpack_require__(34);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var SecondaryToolbar =
/*#__PURE__*/
function () {
  function SecondaryToolbar(options, mainContainer, eventBus) {
    var _this = this;

    _classCallCheck(this, SecondaryToolbar);

    this.toolbar = options.toolbar;
    this.toggleButton = options.toggleButton;
    this.toolbarButtonContainer = options.toolbarButtonContainer;
    this.buttons = [{
      element: options.presentationModeButton,
      eventName: 'presentationmode',
      close: true
    }, {
      element: options.openFileButton,
      eventName: 'openfile',
      close: true
    }, {
      element: options.printButton,
      eventName: 'print',
      close: true
    }, {
      element: options.downloadButton,
      eventName: 'download',
      close: true
    }, {
      element: options.viewBookmarkButton,
      eventName: null,
      close: true
    }, {
      element: options.firstPageButton,
      eventName: 'firstpage',
      close: true
    }, {
      element: options.lastPageButton,
      eventName: 'lastpage',
      close: true
    }, {
      element: options.pageRotateCwButton,
      eventName: 'rotatecw',
      close: false
    }, {
      element: options.pageRotateCcwButton,
      eventName: 'rotateccw',
      close: false
    }, {
      element: options.cursorSelectToolButton,
      eventName: 'switchcursortool',
      eventDetails: {
        tool: _pdf_cursor_tools.CursorTool.SELECT
      },
      close: true
    }, {
      element: options.cursorHandToolButton,
      eventName: 'switchcursortool',
      eventDetails: {
        tool: _pdf_cursor_tools.CursorTool.HAND
      },
      close: true
    }, {
      element: options.scrollVerticalButton,
      eventName: 'switchscrollmode',
      eventDetails: {
        mode: _ui_utils.ScrollMode.VERTICAL
      },
      close: true
    }, {
      element: options.scrollHorizontalButton,
      eventName: 'switchscrollmode',
      eventDetails: {
        mode: _ui_utils.ScrollMode.HORIZONTAL
      },
      close: true
    }, {
      element: options.scrollWrappedButton,
      eventName: 'switchscrollmode',
      eventDetails: {
        mode: _ui_utils.ScrollMode.WRAPPED
      },
      close: true
    }, {
      element: options.spreadNoneButton,
      eventName: 'switchspreadmode',
      eventDetails: {
        mode: _ui_utils.SpreadMode.NONE
      },
      close: true
    }, {
      element: options.spreadOddButton,
      eventName: 'switchspreadmode',
      eventDetails: {
        mode: _ui_utils.SpreadMode.ODD
      },
      close: true
    }, {
      element: options.spreadEvenButton,
      eventName: 'switchspreadmode',
      eventDetails: {
        mode: _ui_utils.SpreadMode.EVEN
      },
      close: true
    }, {
      element: options.documentPropertiesButton,
      eventName: 'documentproperties',
      close: true
    }];
    this.items = {
      firstPage: options.firstPageButton,
      lastPage: options.lastPageButton,
      pageRotateCw: options.pageRotateCwButton,
      pageRotateCcw: options.pageRotateCcwButton
    };
    this.mainContainer = mainContainer;
    this.eventBus = eventBus;
    this.opened = false;
    this.containerHeight = null;
    this.previousContainerHeight = null;
    this.reset();

    this._bindClickListeners();

    this._bindCursorToolsListener(options);

    this._bindScrollModeListener(options);

    this._bindSpreadModeListener(options);

    this.eventBus.on('resize', this._setMaxHeight.bind(this));
    this.eventBus.on('baseviewerinit', function (evt) {
      if (evt.source instanceof _pdf_single_page_viewer.PDFSinglePageViewer) {
        _this.toolbarButtonContainer.classList.add('hiddenScrollModeButtons', 'hiddenSpreadModeButtons');
      } else {
        _this.toolbarButtonContainer.classList.remove('hiddenScrollModeButtons', 'hiddenSpreadModeButtons');
      }
    });
  }

  _createClass(SecondaryToolbar, [{
    key: "setPageNumber",
    value: function setPageNumber(pageNumber) {
      this.pageNumber = pageNumber;

      this._updateUIState();
    }
  }, {
    key: "setPagesCount",
    value: function setPagesCount(pagesCount) {
      this.pagesCount = pagesCount;

      this._updateUIState();
    }
  }, {
    key: "reset",
    value: function reset() {
      this.pageNumber = 0;
      this.pagesCount = 0;

      this._updateUIState();

      this.eventBus.dispatch('secondarytoolbarreset', {
        source: this
      });
    }
  }, {
    key: "_updateUIState",
    value: function _updateUIState() {
      this.items.firstPage.disabled = this.pageNumber <= 1;
      this.items.lastPage.disabled = this.pageNumber >= this.pagesCount;
      this.items.pageRotateCw.disabled = this.pagesCount === 0;
      this.items.pageRotateCcw.disabled = this.pagesCount === 0;
    }
  }, {
    key: "_bindClickListeners",
    value: function _bindClickListeners() {
      var _this2 = this;

      this.toggleButton.addEventListener('click', this.toggle.bind(this));

      var _loop = function _loop(button) {
        if (!isNaN(button)) {
          var _this2$buttons$button = _this2.buttons[button],
              element = _this2$buttons$button.element,
              eventName = _this2$buttons$button.eventName,
              close = _this2$buttons$button.close,
              eventDetails = _this2$buttons$button.eventDetails;
          element.addEventListener('click', function (evt) {
            if (eventName !== null) {
              var details = {
                source: _this2
              };

              for (var property in eventDetails) {
                details[property] = eventDetails[property];
              }

              _this2.eventBus.dispatch(eventName, details);
            }

            if (close) {
              _this2.close();
            }
          });
        }
      };

      for (var button in this.buttons) {
        _loop(button);
      }
    }
  }, {
    key: "_bindCursorToolsListener",
    value: function _bindCursorToolsListener(buttons) {
      this.eventBus.on('cursortoolchanged', function (_ref) {
        var tool = _ref.tool;
        buttons.cursorSelectToolButton.classList.toggle('toggled', tool === _pdf_cursor_tools.CursorTool.SELECT);
        buttons.cursorHandToolButton.classList.toggle('toggled', tool === _pdf_cursor_tools.CursorTool.HAND);
      });
    }
  }, {
    key: "_bindScrollModeListener",
    value: function _bindScrollModeListener(buttons) {
      var _this3 = this;

      function scrollModeChanged(_ref2) {
        var mode = _ref2.mode;
        buttons.scrollVerticalButton.classList.toggle('toggled', mode === _ui_utils.ScrollMode.VERTICAL);
        buttons.scrollHorizontalButton.classList.toggle('toggled', mode === _ui_utils.ScrollMode.HORIZONTAL);
        buttons.scrollWrappedButton.classList.toggle('toggled', mode === _ui_utils.ScrollMode.WRAPPED);
        var isScrollModeHorizontal = mode === _ui_utils.ScrollMode.HORIZONTAL;
        buttons.spreadNoneButton.disabled = isScrollModeHorizontal;
        buttons.spreadOddButton.disabled = isScrollModeHorizontal;
        buttons.spreadEvenButton.disabled = isScrollModeHorizontal;
      }

      this.eventBus.on('scrollmodechanged', scrollModeChanged);
      this.eventBus.on('secondarytoolbarreset', function (evt) {
        if (evt.source === _this3) {
          scrollModeChanged({
            mode: _ui_utils.ScrollMode.VERTICAL
          });
        }
      });
    }
  }, {
    key: "_bindSpreadModeListener",
    value: function _bindSpreadModeListener(buttons) {
      var _this4 = this;

      function spreadModeChanged(_ref3) {
        var mode = _ref3.mode;
        buttons.spreadNoneButton.classList.toggle('toggled', mode === _ui_utils.SpreadMode.NONE);
        buttons.spreadOddButton.classList.toggle('toggled', mode === _ui_utils.SpreadMode.ODD);
        buttons.spreadEvenButton.classList.toggle('toggled', mode === _ui_utils.SpreadMode.EVEN);
      }

      this.eventBus.on('spreadmodechanged', spreadModeChanged);
      this.eventBus.on('secondarytoolbarreset', function (evt) {
        if (evt.source === _this4) {
          spreadModeChanged({
            mode: _ui_utils.SpreadMode.NONE
          });
        }
      });
    }
  }, {
    key: "open",
    value: function open() {
      if (this.opened) {
        return;
      }

      this.opened = true;

      this._setMaxHeight();

      this.toggleButton.classList.add('toggled');
      this.toolbar.classList.remove('hidden');
    }
  }, {
    key: "close",
    value: function close() {
      if (!this.opened) {
        return;
      }

      this.opened = false;
      this.toolbar.classList.add('hidden');
      this.toggleButton.classList.remove('toggled');
    }
  }, {
    key: "toggle",
    value: function toggle() {
      if (this.opened) {
        this.close();
      } else {
        this.open();
      }
    }
  }, {
    key: "_setMaxHeight",
    value: function _setMaxHeight() {
      if (!this.opened) {
        return;
      }

      this.containerHeight = this.mainContainer.clientHeight;

      if (this.containerHeight === this.previousContainerHeight) {
        return;
      }

      this.toolbarButtonContainer.setAttribute('style', 'max-height: ' + (this.containerHeight - _ui_utils.SCROLLBAR_PADDING) + 'px;');
      this.previousContainerHeight = this.containerHeight;
    }
  }, {
    key: "isOpen",
    get: function get() {
      return this.opened;
    }
  }]);

  return SecondaryToolbar;
}();

exports.SecondaryToolbar = SecondaryToolbar;

/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFSinglePageViewer = void 0;

var _base_viewer = __webpack_require__(29);

var _pdfjsLib = __webpack_require__(7);

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PDFSinglePageViewer =
/*#__PURE__*/
function (_BaseViewer) {
  _inherits(PDFSinglePageViewer, _BaseViewer);

  function PDFSinglePageViewer(options) {
    var _this;

    _classCallCheck(this, PDFSinglePageViewer);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PDFSinglePageViewer).call(this, options));

    _this.eventBus.on('pagesinit', function (evt) {
      _this._ensurePageViewVisible();
    });

    return _this;
  }

  _createClass(PDFSinglePageViewer, [{
    key: "_resetView",
    value: function _resetView() {
      _get(_getPrototypeOf(PDFSinglePageViewer.prototype), "_resetView", this).call(this);

      this._previousPageNumber = 1;
      this._shadowViewer = document.createDocumentFragment();
      this._updateScrollDown = null;
    }
  }, {
    key: "_ensurePageViewVisible",
    value: function _ensurePageViewVisible() {
      var pageView = this._pages[this._currentPageNumber - 1];
      var previousPageView = this._pages[this._previousPageNumber - 1];
      var viewerNodes = this.viewer.childNodes;

      switch (viewerNodes.length) {
        case 0:
          this.viewer.appendChild(pageView.div);
          break;

        case 1:
          if (viewerNodes[0] !== previousPageView.div) {
            throw new Error('_ensurePageViewVisible: Unexpected previously visible page.');
          }

          if (pageView === previousPageView) {
            break;
          }

          this._shadowViewer.appendChild(previousPageView.div);

          this.viewer.appendChild(pageView.div);
          this.container.scrollTop = 0;
          break;

        default:
          throw new Error('_ensurePageViewVisible: Only one page should be visible at a time.');
      }

      this._previousPageNumber = this._currentPageNumber;
    }
  }, {
    key: "_scrollUpdate",
    value: function _scrollUpdate() {
      if (this._updateScrollDown) {
        this._updateScrollDown();
      }

      _get(_getPrototypeOf(PDFSinglePageViewer.prototype), "_scrollUpdate", this).call(this);
    }
  }, {
    key: "_scrollIntoView",
    value: function _scrollIntoView(_ref) {
      var _this2 = this;

      var pageDiv = _ref.pageDiv,
          _ref$pageSpot = _ref.pageSpot,
          pageSpot = _ref$pageSpot === void 0 ? null : _ref$pageSpot,
          _ref$pageNumber = _ref.pageNumber,
          pageNumber = _ref$pageNumber === void 0 ? null : _ref$pageNumber;

      if (pageNumber) {
        this._setCurrentPageNumber(pageNumber);
      }

      var scrolledDown = this._currentPageNumber >= this._previousPageNumber;

      this._ensurePageViewVisible();

      this.update();

      _get(_getPrototypeOf(PDFSinglePageViewer.prototype), "_scrollIntoView", this).call(this, {
        pageDiv: pageDiv,
        pageSpot: pageSpot,
        pageNumber: pageNumber
      });

      this._updateScrollDown = function () {
        _this2.scroll.down = scrolledDown;
        _this2._updateScrollDown = null;
      };
    }
  }, {
    key: "_getVisiblePages",
    value: function _getVisiblePages() {
      return this._getCurrentVisiblePage();
    }
  }, {
    key: "_updateHelper",
    value: function _updateHelper(visiblePages) {}
  }, {
    key: "_updateScrollMode",
    value: function _updateScrollMode() {}
  }, {
    key: "_updateSpreadMode",
    value: function _updateSpreadMode() {}
  }, {
    key: "_setDocumentViewerElement",
    get: function get() {
      return (0, _pdfjsLib.shadow)(this, '_setDocumentViewerElement', this._shadowViewer);
    }
  }, {
    key: "_isScrollModeHorizontal",
    get: function get() {
      return (0, _pdfjsLib.shadow)(this, '_isScrollModeHorizontal', false);
    }
  }]);

  return PDFSinglePageViewer;
}(_base_viewer.BaseViewer);

exports.PDFSinglePageViewer = PDFSinglePageViewer;

/***/ }),
/* 35 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Toolbar = void 0;

var _ui_utils = __webpack_require__(6);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var PAGE_NUMBER_LOADING_INDICATOR = 'visiblePageIsLoading';
var SCALE_SELECT_CONTAINER_PADDING = 8;
var SCALE_SELECT_PADDING = 22;

var Toolbar =
/*#__PURE__*/
function () {
  function Toolbar(options, eventBus) {
    var l10n = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _ui_utils.NullL10n;

    _classCallCheck(this, Toolbar);

    this.toolbar = options.container;
    this.eventBus = eventBus;
    this.l10n = l10n;
    this.items = options;
    this._wasLocalized = false;
    this.reset();

    this._bindListeners();
  }

  _createClass(Toolbar, [{
    key: "setPageNumber",
    value: function setPageNumber(pageNumber, pageLabel) {
      this.pageNumber = pageNumber;
      this.pageLabel = pageLabel;

      this._updateUIState(false);
    }
  }, {
    key: "setPagesCount",
    value: function setPagesCount(pagesCount, hasPageLabels) {
      this.pagesCount = pagesCount;
      this.hasPageLabels = hasPageLabels;

      this._updateUIState(true);
    }
  }, {
    key: "setPageScale",
    value: function setPageScale(pageScaleValue, pageScale) {
      this.pageScaleValue = (pageScaleValue || pageScale).toString();
      this.pageScale = pageScale;

      this._updateUIState(false);
    }
  }, {
    key: "reset",
    value: function reset() {
      this.pageNumber = 0;
      this.pageLabel = null;
      this.hasPageLabels = false;
      this.pagesCount = 0;
      this.pageScaleValue = _ui_utils.DEFAULT_SCALE_VALUE;
      this.pageScale = _ui_utils.DEFAULT_SCALE;

      this._updateUIState(true);
    }
  }, {
    key: "_bindListeners",
    value: function _bindListeners() {
      var _this = this;

      var eventBus = this.eventBus,
          items = this.items;
      var self = this;
      items.previous.addEventListener('click', function () {
        eventBus.dispatch('previouspage', {
          source: self
        });
      });
      items.next.addEventListener('click', function () {
        eventBus.dispatch('nextpage', {
          source: self
        });
      });
      items.zoomIn.addEventListener('click', function () {
        eventBus.dispatch('zoomin', {
          source: self
        });
      });
      items.zoomOut.addEventListener('click', function () {
        eventBus.dispatch('zoomout', {
          source: self
        });
      });
      items.pageNumber.addEventListener('click', function () {
        this.select();
      });
      items.pageNumber.addEventListener('change', function () {
        eventBus.dispatch('pagenumberchanged', {
          source: self,
          value: this.value
        });
      });
      items.scaleSelect.addEventListener('change', function () {
        if (this.value === 'custom') {
          return;
        }

        eventBus.dispatch('scalechanged', {
          source: self,
          value: this.value
        });
      });
      items.presentationModeButton.addEventListener('click', function () {
        eventBus.dispatch('presentationmode', {
          source: self
        });
      });
      items.openFile.addEventListener('click', function () {
        eventBus.dispatch('openfile', {
          source: self
        });
      });
      items.print.addEventListener('click', function () {
        eventBus.dispatch('print', {
          source: self
        });
      });
      items.download.addEventListener('click', function () {
        eventBus.dispatch('download', {
          source: self
        });
      });
      items.scaleSelect.oncontextmenu = _ui_utils.noContextMenuHandler;
      eventBus.on('localized', function () {
        _this._localized();
      });
    }
  }, {
    key: "_localized",
    value: function _localized() {
      this._wasLocalized = true;

      this._adjustScaleWidth();

      this._updateUIState(true);
    }
  }, {
    key: "_updateUIState",
    value: function _updateUIState() {
      var resetNumPages = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!this._wasLocalized) {
        return;
      }

      var pageNumber = this.pageNumber,
          pagesCount = this.pagesCount,
          pageScaleValue = this.pageScaleValue,
          pageScale = this.pageScale,
          items = this.items;

      if (resetNumPages) {
        if (this.hasPageLabels) {
          items.pageNumber.type = 'text';
        } else {
          items.pageNumber.type = 'number';
          this.l10n.get('of_pages', {
            pagesCount: pagesCount
          }, 'of {{pagesCount}}').then(function (msg) {
            items.numPages.textContent = msg;
          });
        }

        items.pageNumber.max = pagesCount;
      }

      if (this.hasPageLabels) {
        items.pageNumber.value = this.pageLabel;
        this.l10n.get('page_of_pages', {
          pageNumber: pageNumber,
          pagesCount: pagesCount
        }, '({{pageNumber}} of {{pagesCount}})').then(function (msg) {
          items.numPages.textContent = msg;
        });
      } else {
        items.pageNumber.value = pageNumber;
      }

      items.previous.disabled = pageNumber <= 1;
      items.next.disabled = pageNumber >= pagesCount;
      items.zoomOut.disabled = pageScale <= _ui_utils.MIN_SCALE;
      items.zoomIn.disabled = pageScale >= _ui_utils.MAX_SCALE;
      var customScale = Math.round(pageScale * 10000) / 100;
      this.l10n.get('page_scale_percent', {
        scale: customScale
      }, '{{scale}}%').then(function (msg) {
        var options = items.scaleSelect.options;
        var predefinedValueFound = false;

        for (var i = 0, ii = options.length; i < ii; i++) {
          var option = options[i];

          if (option.value !== pageScaleValue) {
            option.selected = false;
            continue;
          }

          option.selected = true;
          predefinedValueFound = true;
        }

        if (!predefinedValueFound) {
          items.customScaleOption.textContent = msg;
          items.customScaleOption.selected = true;
        }
      });
    }
  }, {
    key: "updateLoadingIndicatorState",
    value: function updateLoadingIndicatorState() {
      var loading = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var pageNumberInput = this.items.pageNumber;
      pageNumberInput.classList.toggle(PAGE_NUMBER_LOADING_INDICATOR, loading);
    }
  }, {
    key: "_adjustScaleWidth",
    value: function _adjustScaleWidth() {
      var container = this.items.scaleSelectContainer;
      var select = this.items.scaleSelect;

      _ui_utils.animationStarted.then(function () {
        if (container.clientWidth === 0) {
          container.setAttribute('style', 'display: inherit;');
        }

        if (container.clientWidth > 0) {
          select.setAttribute('style', 'min-width: inherit;');
          var width = select.clientWidth + SCALE_SELECT_CONTAINER_PADDING;
          select.setAttribute('style', 'min-width: ' + (width + SCALE_SELECT_PADDING) + 'px;');
          container.setAttribute('style', 'min-width: ' + width + 'px; ' + 'max-width: ' + width + 'px;');
        }
      });
    }
  }]);

  return Toolbar;
}();

exports.Toolbar = Toolbar;

/***/ }),
/* 36 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ViewHistory = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DEFAULT_VIEW_HISTORY_CACHE_SIZE = 20;

var ViewHistory =
/*#__PURE__*/
function () {
  function ViewHistory(fingerprint) {
    var _this = this;

    var cacheSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_VIEW_HISTORY_CACHE_SIZE;

    _classCallCheck(this, ViewHistory);

    this.fingerprint = fingerprint;
    this.cacheSize = cacheSize;
    this._initializedPromise = this._readFromStorage().then(function (databaseStr) {
      var database = JSON.parse(databaseStr || '{}');

      if (!('files' in database)) {
        database.files = [];
      } else {
        while (database.files.length >= _this.cacheSize) {
          database.files.shift();
        }
      }

      var index = -1;

      for (var i = 0, length = database.files.length; i < length; i++) {
        var branch = database.files[i];

        if (branch.fingerprint === _this.fingerprint) {
          index = i;
          break;
        }
      }

      if (index === -1) {
        index = database.files.push({
          fingerprint: _this.fingerprint
        }) - 1;
      }

      _this.file = database.files[index];
      _this.database = database;
    });
  }

  _createClass(ViewHistory, [{
    key: "_writeToStorage",
    value: function () {
      var _writeToStorage2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var databaseStr;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                databaseStr = JSON.stringify(this.database);
                localStorage.setItem('pdfjs.history', databaseStr);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _writeToStorage() {
        return _writeToStorage2.apply(this, arguments);
      }

      return _writeToStorage;
    }()
  }, {
    key: "_readFromStorage",
    value: function () {
      var _readFromStorage2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", localStorage.getItem('pdfjs.history'));

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _readFromStorage() {
        return _readFromStorage2.apply(this, arguments);
      }

      return _readFromStorage;
    }()
  }, {
    key: "set",
    value: function () {
      var _set = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(name, val) {
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._initializedPromise;

              case 2:
                this.file[name] = val;
                return _context3.abrupt("return", this._writeToStorage());

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function set(_x, _x2) {
        return _set.apply(this, arguments);
      }

      return set;
    }()
  }, {
    key: "setMultiple",
    value: function () {
      var _setMultiple = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(properties) {
        var name;
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._initializedPromise;

              case 2:
                for (name in properties) {
                  this.file[name] = properties[name];
                }

                return _context4.abrupt("return", this._writeToStorage());

              case 4:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function setMultiple(_x3) {
        return _setMultiple.apply(this, arguments);
      }

      return setMultiple;
    }()
  }, {
    key: "get",
    value: function () {
      var _get = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5(name, defaultValue) {
        var val;
        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._initializedPromise;

              case 2:
                val = this.file[name];
                return _context5.abrupt("return", val !== undefined ? val : defaultValue);

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function get(_x4, _x5) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: "getMultiple",
    value: function () {
      var _getMultiple = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee6(properties) {
        var values, name, val;
        return _regenerator.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this._initializedPromise;

              case 2:
                values = Object.create(null);

                for (name in properties) {
                  val = this.file[name];
                  values[name] = val !== undefined ? val : properties[name];
                }

                return _context6.abrupt("return", values);

              case 5:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getMultiple(_x6) {
        return _getMultiple.apply(this, arguments);
      }

      return getMultiple;
    }()
  }]);

  return ViewHistory;
}();

exports.ViewHistory = ViewHistory;

/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GenericCom = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

var _app = __webpack_require__(1);

var _preferences = __webpack_require__(38);

var _download_manager = __webpack_require__(39);

var _genericl10n = __webpack_require__(40);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

;
var GenericCom = {};
exports.GenericCom = GenericCom;

var GenericPreferences =
/*#__PURE__*/
function (_BasePreferences) {
  _inherits(GenericPreferences, _BasePreferences);

  function GenericPreferences() {
    _classCallCheck(this, GenericPreferences);

    return _possibleConstructorReturn(this, _getPrototypeOf(GenericPreferences).apply(this, arguments));
  }

  _createClass(GenericPreferences, [{
    key: "_writeToStorage",
    value: function () {
      var _writeToStorage2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(prefObj) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                localStorage.setItem('pdfjs.preferences', JSON.stringify(prefObj));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _writeToStorage(_x) {
        return _writeToStorage2.apply(this, arguments);
      }

      return _writeToStorage;
    }()
  }, {
    key: "_readFromStorage",
    value: function () {
      var _readFromStorage2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(prefObj) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", JSON.parse(localStorage.getItem('pdfjs.preferences')));

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _readFromStorage(_x2) {
        return _readFromStorage2.apply(this, arguments);
      }

      return _readFromStorage;
    }()
  }]);

  return GenericPreferences;
}(_preferences.BasePreferences);

var GenericExternalServices = Object.create(_app.DefaultExternalServices);

GenericExternalServices.createDownloadManager = function (options) {
  return new _download_manager.DownloadManager(options);
};

GenericExternalServices.createPreferences = function () {
  return new GenericPreferences();
};

GenericExternalServices.createL10n = function (_ref) {
  var _ref$locale = _ref.locale,
      locale = _ref$locale === void 0 ? 'en-US' : _ref$locale;
  return new _genericl10n.GenericL10n(locale);
};

_app.PDFViewerApplication.externalServices = GenericExternalServices;

/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BasePreferences = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var defaultPreferences = null;

function getDefaultPreferences() {
  if (!defaultPreferences) {
    defaultPreferences = Promise.resolve({
      "viewOnLoad": 0,
      "defaultZoomValue": "",
      "sidebarViewOnLoad": -1,
      "cursorToolOnLoad": 0,
      "enableWebGL": false,
      "eventBusDispatchToDOM": false,
      "pdfBugEnabled": false,
      "disableRange": false,
      "disableStream": false,
      "disableAutoFetch": false,
      "disableFontFace": false,
      "textLayerMode": 1,
      "useOnlyCssZoom": false,
      "externalLinkTarget": 0,
      "renderer": "canvas",
      "renderInteractiveForms": false,
      "enablePrintAutoRotate": false,
      "disablePageLabels": false,
      "historyUpdateUrl": false,
      "scrollModeOnLoad": -1,
      "spreadModeOnLoad": -1
    });
  }

  return defaultPreferences;
}

var BasePreferences =
/*#__PURE__*/
function () {
  function BasePreferences() {
    var _this = this;

    _classCallCheck(this, BasePreferences);

    if (this.constructor === BasePreferences) {
      throw new Error('Cannot initialize BasePreferences.');
    }

    this.prefs = null;
    this._initializedPromise = getDefaultPreferences().then(function (defaults) {
      Object.defineProperty(_this, 'defaults', {
        value: Object.freeze(defaults),
        writable: false,
        enumerable: true,
        configurable: false
      });
      _this.prefs = Object.assign(Object.create(null), defaults);
      return _this._readFromStorage(defaults);
    }).then(function (prefs) {
      if (!prefs) {
        return;
      }

      for (var name in prefs) {
        var defaultValue = _this.defaults[name],
            prefValue = prefs[name];

        if (defaultValue === undefined || _typeof(prefValue) !== _typeof(defaultValue)) {
          continue;
        }

        _this.prefs[name] = prefValue;
      }
    });
  }

  _createClass(BasePreferences, [{
    key: "_writeToStorage",
    value: function () {
      var _writeToStorage2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(prefObj) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                throw new Error('Not implemented: _writeToStorage');

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _writeToStorage(_x) {
        return _writeToStorage2.apply(this, arguments);
      }

      return _writeToStorage;
    }()
  }, {
    key: "_readFromStorage",
    value: function () {
      var _readFromStorage2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(prefObj) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                throw new Error('Not implemented: _readFromStorage');

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _readFromStorage(_x2) {
        return _readFromStorage2.apply(this, arguments);
      }

      return _readFromStorage;
    }()
  }, {
    key: "reset",
    value: function () {
      var _reset = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3() {
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._initializedPromise;

              case 2:
                this.prefs = Object.assign(Object.create(null), this.defaults);
                return _context3.abrupt("return", this._writeToStorage(this.defaults));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function reset() {
        return _reset.apply(this, arguments);
      }

      return reset;
    }()
  }, {
    key: "set",
    value: function () {
      var _set = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(name, value) {
        var defaultValue, valueType, defaultType;
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._initializedPromise;

              case 2:
                defaultValue = this.defaults[name];

                if (!(defaultValue === undefined)) {
                  _context4.next = 7;
                  break;
                }

                throw new Error("Set preference: \"".concat(name, "\" is undefined."));

              case 7:
                if (!(value === undefined)) {
                  _context4.next = 9;
                  break;
                }

                throw new Error('Set preference: no value is specified.');

              case 9:
                valueType = _typeof(value);
                defaultType = _typeof(defaultValue);

                if (!(valueType !== defaultType)) {
                  _context4.next = 19;
                  break;
                }

                if (!(valueType === 'number' && defaultType === 'string')) {
                  _context4.next = 16;
                  break;
                }

                value = value.toString();
                _context4.next = 17;
                break;

              case 16:
                throw new Error("Set preference: \"".concat(value, "\" is a ").concat(valueType, ", ") + "expected a ".concat(defaultType, "."));

              case 17:
                _context4.next = 21;
                break;

              case 19:
                if (!(valueType === 'number' && !Number.isInteger(value))) {
                  _context4.next = 21;
                  break;
                }

                throw new Error("Set preference: \"".concat(value, "\" must be an integer."));

              case 21:
                this.prefs[name] = value;
                return _context4.abrupt("return", this._writeToStorage(this.prefs));

              case 23:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function set(_x3, _x4) {
        return _set.apply(this, arguments);
      }

      return set;
    }()
  }, {
    key: "get",
    value: function () {
      var _get = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5(name) {
        var defaultValue, prefValue;
        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._initializedPromise;

              case 2:
                defaultValue = this.defaults[name];

                if (!(defaultValue === undefined)) {
                  _context5.next = 7;
                  break;
                }

                throw new Error("Get preference: \"".concat(name, "\" is undefined."));

              case 7:
                prefValue = this.prefs[name];

                if (!(prefValue !== undefined)) {
                  _context5.next = 10;
                  break;
                }

                return _context5.abrupt("return", prefValue);

              case 10:
                return _context5.abrupt("return", defaultValue);

              case 11:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function get(_x5) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: "getAll",
    value: function () {
      var _getAll = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee6() {
        return _regenerator.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this._initializedPromise;

              case 2:
                return _context6.abrupt("return", Object.assign(Object.create(null), this.defaults, this.prefs));

              case 3:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getAll() {
        return _getAll.apply(this, arguments);
      }

      return getAll;
    }()
  }]);

  return BasePreferences;
}();

exports.BasePreferences = BasePreferences;

/***/ }),
/* 39 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DownloadManager = void 0;

var _pdfjsLib = __webpack_require__(7);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

;
var DISABLE_CREATE_OBJECT_URL = _pdfjsLib.apiCompatibilityParams.disableCreateObjectURL || false;

function _download(blobUrl, filename) {
  var a = document.createElement('a');

  if (!a.click) {
    throw new Error('DownloadManager: "a.click()" is not supported.');
  }

  a.href = blobUrl;
  a.target = '_parent';

  if ('download' in a) {
    a.download = filename;
  }

  (document.body || document.documentElement).appendChild(a);
  a.click();
  a.remove();
}

var DownloadManager =
/*#__PURE__*/
function () {
  function DownloadManager(_ref) {
    var _ref$disableCreateObj = _ref.disableCreateObjectURL,
        disableCreateObjectURL = _ref$disableCreateObj === void 0 ? DISABLE_CREATE_OBJECT_URL : _ref$disableCreateObj;

    _classCallCheck(this, DownloadManager);

    this.disableCreateObjectURL = disableCreateObjectURL;
  }

  _createClass(DownloadManager, [{
    key: "downloadUrl",
    value: function downloadUrl(url, filename) {
      if (!(0, _pdfjsLib.createValidAbsoluteUrl)(url, 'http://example.com')) {
        return;
      }

      _download(url + '#pdfjs.action=download', filename);
    }
  }, {
    key: "downloadData",
    value: function downloadData(data, filename, contentType) {
      if (navigator.msSaveBlob) {
        return navigator.msSaveBlob(new Blob([data], {
          type: contentType
        }), filename);
      }

      var blobUrl = (0, _pdfjsLib.createObjectURL)(data, contentType, this.disableCreateObjectURL);

      _download(blobUrl, filename);
    }
  }, {
    key: "download",
    value: function download(blob, url, filename) {
      if (navigator.msSaveBlob) {
        if (!navigator.msSaveBlob(blob, filename)) {
          this.downloadUrl(url, filename);
        }

        return;
      }

      if (this.disableCreateObjectURL) {
        this.downloadUrl(url, filename);
        return;
      }

      var blobUrl = _pdfjsLib.URL.createObjectURL(blob);

      _download(blobUrl, filename);
    }
  }]);

  return DownloadManager;
}();

exports.DownloadManager = DownloadManager;

/***/ }),
/* 40 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GenericL10n = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(2));

__webpack_require__(41);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var webL10n = document.webL10n;

var GenericL10n =
/*#__PURE__*/
function () {
  function GenericL10n(lang) {
    _classCallCheck(this, GenericL10n);

    this._lang = lang;
    this._ready = new Promise(function (resolve, reject) {
      webL10n.setLanguage(lang, function () {
        resolve(webL10n);
      });
    });
  }

  _createClass(GenericL10n, [{
    key: "getLanguage",
    value: function () {
      var _getLanguage = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var l10n;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._ready;

              case 2:
                l10n = _context.sent;
                return _context.abrupt("return", l10n.getLanguage());

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getLanguage() {
        return _getLanguage.apply(this, arguments);
      }

      return getLanguage;
    }()
  }, {
    key: "getDirection",
    value: function () {
      var _getDirection = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var l10n;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._ready;

              case 2:
                l10n = _context2.sent;
                return _context2.abrupt("return", l10n.getDirection());

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getDirection() {
        return _getDirection.apply(this, arguments);
      }

      return getDirection;
    }()
  }, {
    key: "get",
    value: function () {
      var _get = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(property, args, fallback) {
        var l10n;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._ready;

              case 2:
                l10n = _context3.sent;
                return _context3.abrupt("return", l10n.get(property, args, fallback));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function get(_x, _x2, _x3) {
        return _get.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: "translate",
    value: function () {
      var _translate = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(element) {
        var l10n;
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._ready;

              case 2:
                l10n = _context4.sent;
                return _context4.abrupt("return", l10n.translate(element));

              case 4:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function translate(_x4) {
        return _translate.apply(this, arguments);
      }

      return translate;
    }()
  }]);

  return GenericL10n;
}();

exports.GenericL10n = GenericL10n;

/***/ }),
/* 41 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


document.webL10n = function (window, document, undefined) {
  var gL10nData = {};
  var gTextData = '';
  var gTextProp = 'textContent';
  var gLanguage = '';
  var gMacros = {};
  var gReadyState = 'loading';
  var gAsyncResourceLoading = true;

  function getL10nResourceLinks() {
    return document.querySelectorAll('link[type="application/l10n"]');
  }

  function getL10nDictionary() {
    var script = document.querySelector('script[type="application/l10n"]');
    return script ? JSON.parse(script.innerHTML) : null;
  }

  function getTranslatableChildren(element) {
    return element ? element.querySelectorAll('*[data-l10n-id]') : [];
  }

  function getL10nAttributes(element) {
    if (!element) return {};
    var l10nId = element.getAttribute('data-l10n-id');
    var l10nArgs = element.getAttribute('data-l10n-args');
    var args = {};

    if (l10nArgs) {
      try {
        args = JSON.parse(l10nArgs);
      } catch (e) {
        console.warn('could not parse arguments for #' + l10nId);
      }
    }

    return {
      id: l10nId,
      args: args
    };
  }

  function fireL10nReadyEvent(lang) {
    var evtObject = document.createEvent('Event');
    evtObject.initEvent('localized', true, false);
    evtObject.language = lang;
    document.dispatchEvent(evtObject);
  }

  function xhrLoadText(url, onSuccess, onFailure) {
    onSuccess = onSuccess || function _onSuccess(data) {};

    onFailure = onFailure || function _onFailure() {};

    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, gAsyncResourceLoading);

    if (xhr.overrideMimeType) {
      xhr.overrideMimeType('text/plain; charset=utf-8');
    }

    xhr.onreadystatechange = function () {
      if (xhr.readyState == 4) {
        if (xhr.status == 200 || xhr.status === 0) {
          onSuccess(xhr.responseText);
        } else {
          onFailure();
        }
      }
    };

    xhr.onerror = onFailure;
    xhr.ontimeout = onFailure;

    try {
      xhr.send(null);
    } catch (e) {
      onFailure();
    }
  }

  function parseResource(href, lang, successCallback, failureCallback) {
    var baseURL = href.replace(/[^\/]*$/, '') || './';

    function evalString(text) {
      if (text.lastIndexOf('\\') < 0) return text;
      return text.replace(/\\\\/g, '\\').replace(/\\n/g, '\n').replace(/\\r/g, '\r').replace(/\\t/g, '\t').replace(/\\b/g, '\b').replace(/\\f/g, '\f').replace(/\\{/g, '{').replace(/\\}/g, '}').replace(/\\"/g, '"').replace(/\\'/g, "'");
    }

    function parseProperties(text, parsedPropertiesCallback) {
      var dictionary = {};
      var reBlank = /^\s*|\s*$/;
      var reComment = /^\s*#|^\s*$/;
      var reSection = /^\s*\[(.*)\]\s*$/;
      var reImport = /^\s*@import\s+url\((.*)\)\s*$/i;
      var reSplit = /^([^=\s]*)\s*=\s*(.+)$/;

      function parseRawLines(rawText, extendedSyntax, parsedRawLinesCallback) {
        var entries = rawText.replace(reBlank, '').split(/[\r\n]+/);
        var currentLang = '*';
        var genericLang = lang.split('-', 1)[0];
        var skipLang = false;
        var match = '';

        function nextEntry() {
          while (true) {
            if (!entries.length) {
              parsedRawLinesCallback();
              return;
            }

            var line = entries.shift();
            if (reComment.test(line)) continue;

            if (extendedSyntax) {
              match = reSection.exec(line);

              if (match) {
                currentLang = match[1].toLowerCase();
                skipLang = currentLang !== '*' && currentLang !== lang && currentLang !== genericLang;
                continue;
              } else if (skipLang) {
                continue;
              }

              match = reImport.exec(line);

              if (match) {
                loadImport(baseURL + match[1], nextEntry);
                return;
              }
            }

            var tmp = line.match(reSplit);

            if (tmp && tmp.length == 3) {
              dictionary[tmp[1]] = evalString(tmp[2]);
            }
          }
        }

        nextEntry();
      }

      function loadImport(url, callback) {
        xhrLoadText(url, function (content) {
          parseRawLines(content, false, callback);
        }, function () {
          console.warn(url + ' not found.');
          callback();
        });
      }

      parseRawLines(text, true, function () {
        parsedPropertiesCallback(dictionary);
      });
    }

    xhrLoadText(href, function (response) {
      gTextData += response;
      parseProperties(response, function (data) {
        for (var key in data) {
          var id,
              prop,
              index = key.lastIndexOf('.');

          if (index > 0) {
            id = key.substring(0, index);
            prop = key.substring(index + 1);
          } else {
            id = key;
            prop = gTextProp;
          }

          if (!gL10nData[id]) {
            gL10nData[id] = {};
          }

          gL10nData[id][prop] = data[key];
        }

        if (successCallback) {
          successCallback();
        }
      });
    }, failureCallback);
  }

  function loadLocale(lang, callback) {
    if (lang) {
      lang = lang.toLowerCase();
    }

    callback = callback || function _callback() {};

    clear();
    gLanguage = lang;
    var langLinks = getL10nResourceLinks();
    var langCount = langLinks.length;

    if (langCount === 0) {
      var dict = getL10nDictionary();

      if (dict && dict.locales && dict.default_locale) {
        console.log('using the embedded JSON directory, early way out');
        gL10nData = dict.locales[lang];

        if (!gL10nData) {
          var defaultLocale = dict.default_locale.toLowerCase();

          for (var anyCaseLang in dict.locales) {
            const originalCase = anyCaseLang; // added line
            anyCaseLang = anyCaseLang.toLowerCase();
            if (anyCaseLang === lang) {
              gL10nData = dict.locales[originalCase];
              break;
            } else if (anyCaseLang === defaultLocale) {
              gL10nData = dict.locales[originalCase]; // modified line
            }
          }
        }

        callback();
      } else {
        console.log('no resource to load, early way out');
      }

      fireL10nReadyEvent(lang);
      gReadyState = 'complete';
      return;
    }

    var onResourceLoaded = null;
    var gResourceCount = 0;

    onResourceLoaded = function onResourceLoaded() {
      gResourceCount++;

      if (gResourceCount >= langCount) {
        callback();
        fireL10nReadyEvent(lang);
        gReadyState = 'complete';
      }
    };

    function L10nResourceLink(link) {
      var href = link.href;

      this.load = function (lang, callback) {
        parseResource(href, lang, callback, function () {
          console.warn(href + ' not found.');
          console.warn('"' + lang + '" resource not found');
          gLanguage = '';
          callback();
        });
      };
    }

    for (var i = 0; i < langCount; i++) {
      var resource = new L10nResourceLink(langLinks[i]);
      resource.load(lang, onResourceLoaded);
    }
  }

  function clear() {
    gL10nData = {};
    gTextData = '';
    gLanguage = '';
  }

  function getPluralRules(lang) {
    var locales2rules = {
      'af': 3,
      'ak': 4,
      'am': 4,
      'ar': 1,
      'asa': 3,
      'az': 0,
      'be': 11,
      'bem': 3,
      'bez': 3,
      'bg': 3,
      'bh': 4,
      'bm': 0,
      'bn': 3,
      'bo': 0,
      'br': 20,
      'brx': 3,
      'bs': 11,
      'ca': 3,
      'cgg': 3,
      'chr': 3,
      'cs': 12,
      'cy': 17,
      'da': 3,
      'de': 3,
      'dv': 3,
      'dz': 0,
      'ee': 3,
      'el': 3,
      'en': 3,
      'eo': 3,
      'es': 3,
      'et': 3,
      'eu': 3,
      'fa': 0,
      'ff': 5,
      'fi': 3,
      'fil': 4,
      'fo': 3,
      'fr': 5,
      'fur': 3,
      'fy': 3,
      'ga': 8,
      'gd': 24,
      'gl': 3,
      'gsw': 3,
      'gu': 3,
      'guw': 4,
      'gv': 23,
      'ha': 3,
      'haw': 3,
      'he': 2,
      'hi': 4,
      'hr': 11,
      'hu': 0,
      'id': 0,
      'ig': 0,
      'ii': 0,
      'is': 3,
      'it': 3,
      'iu': 7,
      'ja': 0,
      'jmc': 3,
      'jv': 0,
      'ka': 0,
      'kab': 5,
      'kaj': 3,
      'kcg': 3,
      'kde': 0,
      'kea': 0,
      'kk': 3,
      'kl': 3,
      'km': 0,
      'kn': 0,
      'ko': 0,
      'ksb': 3,
      'ksh': 21,
      'ku': 3,
      'kw': 7,
      'lag': 18,
      'lb': 3,
      'lg': 3,
      'ln': 4,
      'lo': 0,
      'lt': 10,
      'lv': 6,
      'mas': 3,
      'mg': 4,
      'mk': 16,
      'ml': 3,
      'mn': 3,
      'mo': 9,
      'mr': 3,
      'ms': 0,
      'mt': 15,
      'my': 0,
      'nah': 3,
      'naq': 7,
      'nb': 3,
      'nd': 3,
      'ne': 3,
      'nl': 3,
      'nn': 3,
      'no': 3,
      'nr': 3,
      'nso': 4,
      'ny': 3,
      'nyn': 3,
      'om': 3,
      'or': 3,
      'pa': 3,
      'pap': 3,
      'pl': 13,
      'ps': 3,
      'pt': 3,
      'rm': 3,
      'ro': 9,
      'rof': 3,
      'ru': 11,
      'rwk': 3,
      'sah': 0,
      'saq': 3,
      'se': 7,
      'seh': 3,
      'ses': 0,
      'sg': 0,
      'sh': 11,
      'shi': 19,
      'sk': 12,
      'sl': 14,
      'sma': 7,
      'smi': 7,
      'smj': 7,
      'smn': 7,
      'sms': 7,
      'sn': 3,
      'so': 3,
      'sq': 3,
      'sr': 11,
      'ss': 3,
      'ssy': 3,
      'st': 3,
      'sv': 3,
      'sw': 3,
      'syr': 3,
      'ta': 3,
      'te': 3,
      'teo': 3,
      'th': 0,
      'ti': 4,
      'tig': 3,
      'tk': 3,
      'tl': 4,
      'tn': 3,
      'to': 0,
      'tr': 0,
      'ts': 3,
      'tzm': 22,
      'uk': 11,
      'ur': 3,
      've': 3,
      'vi': 0,
      'vun': 3,
      'wa': 4,
      'wae': 3,
      'wo': 0,
      'xh': 3,
      'xog': 3,
      'yo': 0,
      'zh': 0,
      'zu': 3
    };

    function isIn(n, list) {
      return list.indexOf(n) !== -1;
    }

    function isBetween(n, start, end) {
      return start <= n && n <= end;
    }

    var pluralRules = {
      '0': function _(n) {
        return 'other';
      },
      '1': function _(n) {
        if (isBetween(n % 100, 3, 10)) return 'few';
        if (n === 0) return 'zero';
        if (isBetween(n % 100, 11, 99)) return 'many';
        if (n == 2) return 'two';
        if (n == 1) return 'one';
        return 'other';
      },
      '2': function _(n) {
        if (n !== 0 && n % 10 === 0) return 'many';
        if (n == 2) return 'two';
        if (n == 1) return 'one';
        return 'other';
      },
      '3': function _(n) {
        if (n == 1) return 'one';
        return 'other';
      },
      '4': function _(n) {
        if (isBetween(n, 0, 1)) return 'one';
        return 'other';
      },
      '5': function _(n) {
        if (isBetween(n, 0, 2) && n != 2) return 'one';
        return 'other';
      },
      '6': function _(n) {
        if (n === 0) return 'zero';
        if (n % 10 == 1 && n % 100 != 11) return 'one';
        return 'other';
      },
      '7': function _(n) {
        if (n == 2) return 'two';
        if (n == 1) return 'one';
        return 'other';
      },
      '8': function _(n) {
        if (isBetween(n, 3, 6)) return 'few';
        if (isBetween(n, 7, 10)) return 'many';
        if (n == 2) return 'two';
        if (n == 1) return 'one';
        return 'other';
      },
      '9': function _(n) {
        if (n === 0 || n != 1 && isBetween(n % 100, 1, 19)) return 'few';
        if (n == 1) return 'one';
        return 'other';
      },
      '10': function _(n) {
        if (isBetween(n % 10, 2, 9) && !isBetween(n % 100, 11, 19)) return 'few';
        if (n % 10 == 1 && !isBetween(n % 100, 11, 19)) return 'one';
        return 'other';
      },
      '11': function _(n) {
        if (isBetween(n % 10, 2, 4) && !isBetween(n % 100, 12, 14)) return 'few';
        if (n % 10 === 0 || isBetween(n % 10, 5, 9) || isBetween(n % 100, 11, 14)) return 'many';
        if (n % 10 == 1 && n % 100 != 11) return 'one';
        return 'other';
      },
      '12': function _(n) {
        if (isBetween(n, 2, 4)) return 'few';
        if (n == 1) return 'one';
        return 'other';
      },
      '13': function _(n) {
        if (isBetween(n % 10, 2, 4) && !isBetween(n % 100, 12, 14)) return 'few';
        if (n != 1 && isBetween(n % 10, 0, 1) || isBetween(n % 10, 5, 9) || isBetween(n % 100, 12, 14)) return 'many';
        if (n == 1) return 'one';
        return 'other';
      },
      '14': function _(n) {
        if (isBetween(n % 100, 3, 4)) return 'few';
        if (n % 100 == 2) return 'two';
        if (n % 100 == 1) return 'one';
        return 'other';
      },
      '15': function _(n) {
        if (n === 0 || isBetween(n % 100, 2, 10)) return 'few';
        if (isBetween(n % 100, 11, 19)) return 'many';
        if (n == 1) return 'one';
        return 'other';
      },
      '16': function _(n) {
        if (n % 10 == 1 && n != 11) return 'one';
        return 'other';
      },
      '17': function _(n) {
        if (n == 3) return 'few';
        if (n === 0) return 'zero';
        if (n == 6) return 'many';
        if (n == 2) return 'two';
        if (n == 1) return 'one';
        return 'other';
      },
      '18': function _(n) {
        if (n === 0) return 'zero';
        if (isBetween(n, 0, 2) && n !== 0 && n != 2) return 'one';
        return 'other';
      },
      '19': function _(n) {
        if (isBetween(n, 2, 10)) return 'few';
        if (isBetween(n, 0, 1)) return 'one';
        return 'other';
      },
      '20': function _(n) {
        if ((isBetween(n % 10, 3, 4) || n % 10 == 9) && !(isBetween(n % 100, 10, 19) || isBetween(n % 100, 70, 79) || isBetween(n % 100, 90, 99))) return 'few';
        if (n % 1000000 === 0 && n !== 0) return 'many';
        if (n % 10 == 2 && !isIn(n % 100, [12, 72, 92])) return 'two';
        if (n % 10 == 1 && !isIn(n % 100, [11, 71, 91])) return 'one';
        return 'other';
      },
      '21': function _(n) {
        if (n === 0) return 'zero';
        if (n == 1) return 'one';
        return 'other';
      },
      '22': function _(n) {
        if (isBetween(n, 0, 1) || isBetween(n, 11, 99)) return 'one';
        return 'other';
      },
      '23': function _(n) {
        if (isBetween(n % 10, 1, 2) || n % 20 === 0) return 'one';
        return 'other';
      },
      '24': function _(n) {
        if (isBetween(n, 3, 10) || isBetween(n, 13, 19)) return 'few';
        if (isIn(n, [2, 12])) return 'two';
        if (isIn(n, [1, 11])) return 'one';
        return 'other';
      }
    };
    var index = locales2rules[lang.replace(/-.*$/, '')];

    if (!(index in pluralRules)) {
      console.warn('plural form unknown for [' + lang + ']');
      return function () {
        return 'other';
      };
    }

    return pluralRules[index];
  }

  gMacros.plural = function (str, param, key, prop) {
    var n = parseFloat(param);
    if (isNaN(n)) return str;
    if (prop != gTextProp) return str;

    if (!gMacros._pluralRules) {
      gMacros._pluralRules = getPluralRules(gLanguage);
    }

    var index = '[' + gMacros._pluralRules(n) + ']';

    if (n === 0 && key + '[zero]' in gL10nData) {
      str = gL10nData[key + '[zero]'][prop];
    } else if (n == 1 && key + '[one]' in gL10nData) {
      str = gL10nData[key + '[one]'][prop];
    } else if (n == 2 && key + '[two]' in gL10nData) {
      str = gL10nData[key + '[two]'][prop];
    } else if (key + index in gL10nData) {
      str = gL10nData[key + index][prop];
    } else if (key + '[other]' in gL10nData) {
      str = gL10nData[key + '[other]'][prop];
    }

    return str;
  };

  function getL10nData(key, args, fallback) {
    var data = gL10nData[key];

    if (!data) {
      console.warn('#' + key + ' is undefined.');

      if (!fallback) {
        return null;
      }

      data = fallback;
    }

    var rv = {};

    for (var prop in data) {
      var str = data[prop];
      str = substIndexes(str, args, key, prop);
      str = substArguments(str, args, key);
      rv[prop] = str;
    }

    return rv;
  }

  function substIndexes(str, args, key, prop) {
    var reIndex = /\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/;
    var reMatch = reIndex.exec(str);
    if (!reMatch || !reMatch.length) return str;
    var macroName = reMatch[1];
    var paramName = reMatch[2];
    var param;

    if (args && paramName in args) {
      param = args[paramName];
    } else if (paramName in gL10nData) {
      param = gL10nData[paramName];
    }

    if (macroName in gMacros) {
      var macro = gMacros[macroName];
      str = macro(str, param, key, prop);
    }

    return str;
  }

  function substArguments(str, args, key) {
    var reArgs = /\{\{\s*(.+?)\s*\}\}/g;
    return str.replace(reArgs, function (matched_text, arg) {
      if (args && arg in args) {
        return args[arg];
      }

      if (arg in gL10nData) {
        return gL10nData[arg];
      }

      console.log('argument {{' + arg + '}} for #' + key + ' is undefined.');
      return matched_text;
    });
  }

  function translateElement(element) {
    var l10n = getL10nAttributes(element);
    if (!l10n.id) return;
    var data = getL10nData(l10n.id, l10n.args);

    if (!data) {
      console.warn('#' + l10n.id + ' is undefined.');
      return;
    }

    if (data[gTextProp]) {
      if (getChildElementCount(element) === 0) {
        element[gTextProp] = data[gTextProp];
      } else {
        var children = element.childNodes;
        var found = false;

        for (var i = 0, l = children.length; i < l; i++) {
          if (children[i].nodeType === 3 && /\S/.test(children[i].nodeValue)) {
            if (found) {
              children[i].nodeValue = '';
            } else {
              children[i].nodeValue = data[gTextProp];
              found = true;
            }
          }
        }

        if (!found) {
          var textNode = document.createTextNode(data[gTextProp]);
          element.insertBefore(textNode, element.firstChild);
        }
      }

      delete data[gTextProp];
    }

    for (var k in data) {
      element[k] = data[k];
    }
  }

  function getChildElementCount(element) {
    if (element.children) {
      return element.children.length;
    }

    if (typeof element.childElementCount !== 'undefined') {
      return element.childElementCount;
    }

    var count = 0;

    for (var i = 0; i < element.childNodes.length; i++) {
      count += element.nodeType === 1 ? 1 : 0;
    }

    return count;
  }

  function translateFragment(element) {
    element = element || document.documentElement;
    var children = getTranslatableChildren(element);
    var elementCount = children.length;

    for (var i = 0; i < elementCount; i++) {
      translateElement(children[i]);
    }

    translateElement(element);
  }

  return {
    get: function get(key, args, fallbackString) {
      var index = key.lastIndexOf('.');
      var prop = gTextProp;

      if (index > 0) {
        prop = key.substring(index + 1);
        key = key.substring(0, index);
      }

      var fallback;

      if (fallbackString) {
        fallback = {};
        fallback[prop] = fallbackString;
      }

      var data = getL10nData(key, args, fallback);

      if (data && prop in data) {
        return data[prop];
      }

      return '{{' + key + '}}';
    },
    getData: function getData() {
      return gL10nData;
    },
    getText: function getText() {
      return gTextData;
    },
    getLanguage: function getLanguage() {
      return gLanguage;
    },
    setLanguage: function setLanguage(lang, callback) {
      loadLocale(lang, function () {
        if (callback) callback();
      });
    },
    getDirection: function getDirection() {
      var rtlList = ['ar', 'he', 'fa', 'ps', 'ur'];
      var shortCode = gLanguage.split('-', 1)[0];
      return rtlList.indexOf(shortCode) >= 0 ? 'rtl' : 'ltr';
    },
    translate: translateFragment,
    getReadyState: function getReadyState() {
      return gReadyState;
    },
    ready: function ready(callback) {
      if (!callback) {
        return;
      } else if (gReadyState == 'complete' || gReadyState == 'interactive') {
        window.setTimeout(function () {
          callback();
        });
      } else if (document.addEventListener) {
        document.addEventListener('localized', function once() {
          document.removeEventListener('localized', once);
          callback();
        });
      }
    }
  };
}(window, document);

/***/ }),
/* 42 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PDFPrintService = PDFPrintService;

var _ui_utils = __webpack_require__(6);

var _app = __webpack_require__(1);

var _pdfjsLib = __webpack_require__(7);

var activeService = null;
var overlayManager = null;

function renderPage(activeServiceOnEntry, pdfDocument, pageNumber, size) {
  var scratchCanvas = activeService.scratchCanvas;
  var PRINT_RESOLUTION = 150;
  var PRINT_UNITS = PRINT_RESOLUTION / 72.0;
  scratchCanvas.width = Math.floor(size.width * PRINT_UNITS);
  scratchCanvas.height = Math.floor(size.height * PRINT_UNITS);
  var width = Math.floor(size.width * _ui_utils.CSS_UNITS) + 'px';
  var height = Math.floor(size.height * _ui_utils.CSS_UNITS) + 'px';
  var ctx = scratchCanvas.getContext('2d');
  ctx.save();
  ctx.fillStyle = 'rgb(255, 255, 255)';
  ctx.fillRect(0, 0, scratchCanvas.width, scratchCanvas.height);
  ctx.restore();
  return pdfDocument.getPage(pageNumber).then(function (pdfPage) {
    var renderContext = {
      canvasContext: ctx,
      transform: [PRINT_UNITS, 0, 0, PRINT_UNITS, 0, 0],
      viewport: pdfPage.getViewport({
        scale: 1,
        rotation: size.rotation
      }),
      intent: 'print'
    };
    return pdfPage.render(renderContext).promise;
  }).then(function () {
    return {
      width: width,
      height: height
    };
  });
}

function PDFPrintService(pdfDocument, pagesOverview, printContainer, l10n) {
  this.pdfDocument = pdfDocument;
  this.pagesOverview = pagesOverview;
  this.printContainer = printContainer;
  this.l10n = l10n || _ui_utils.NullL10n;
  this.disableCreateObjectURL = pdfDocument.loadingParams['disableCreateObjectURL'];
  this.currentPage = -1;
  this.scratchCanvas = document.createElement('canvas');
}

PDFPrintService.prototype = {
  layout: function layout() {
    this.throwIfInactive();
    var body = document.querySelector('body');
    body.setAttribute('data-pdfjsprinting', true);
    var hasEqualPageSizes = this.pagesOverview.every(function (size) {
      return size.width === this.pagesOverview[0].width && size.height === this.pagesOverview[0].height;
    }, this);

    if (!hasEqualPageSizes) {
      console.warn('Not all pages have the same size. The printed ' + 'result may be incorrect!');
    }

    this.pageStyleSheet = document.createElement('style');
    var pageSize = this.pagesOverview[0];
    this.pageStyleSheet.textContent = '@supports ((size:A4) and (size:1pt 1pt)) {' + '@page { size: ' + pageSize.width + 'pt ' + pageSize.height + 'pt;}' + '}';
    body.appendChild(this.pageStyleSheet);
  },
  destroy: function destroy() {
    if (activeService !== this) {
      return;
    }

    this.printContainer.textContent = '';

    if (this.pageStyleSheet) {
      this.pageStyleSheet.remove();
      this.pageStyleSheet = null;
    }

    this.scratchCanvas.width = this.scratchCanvas.height = 0;
    this.scratchCanvas = null;
    activeService = null;
    ensureOverlay().then(function () {
      if (overlayManager.active !== 'printServiceOverlay') {
        return;
      }

      overlayManager.close('printServiceOverlay');
    });
  },
  renderPages: function renderPages() {
    var _this = this;

    var pageCount = this.pagesOverview.length;

    var renderNextPage = function renderNextPage(resolve, reject) {
      _this.throwIfInactive();

      if (++_this.currentPage >= pageCount) {
        renderProgress(pageCount, pageCount, _this.l10n);
        resolve();
        return;
      }

      var index = _this.currentPage;
      renderProgress(index, pageCount, _this.l10n);
      renderPage(_this, _this.pdfDocument, index + 1, _this.pagesOverview[index]).then(_this.useRenderedPage.bind(_this)).then(function () {
        renderNextPage(resolve, reject);
      }, reject);
    };

    return new Promise(renderNextPage);
  },
  useRenderedPage: function useRenderedPage(printItem) {
    this.throwIfInactive();
    var img = document.createElement('img');
    img.style.width = printItem.width;
    img.style.height = printItem.height;
    var scratchCanvas = this.scratchCanvas;

    if ('toBlob' in scratchCanvas && !this.disableCreateObjectURL) {
      scratchCanvas.toBlob(function (blob) {
        img.src = _pdfjsLib.URL.createObjectURL(blob);
      });
    } else {
      img.src = scratchCanvas.toDataURL();
    }

    var wrapper = document.createElement('div');
    wrapper.appendChild(img);
    this.printContainer.appendChild(wrapper);
    return new Promise(function (resolve, reject) {
      img.onload = resolve;
      img.onerror = reject;
    });
  },
  performPrint: function performPrint() {
    var _this2 = this;

    this.throwIfInactive();
    return new Promise(function (resolve) {
      setTimeout(function () {
        if (!_this2.active) {
          resolve();
          return;
        }

        print.call(window);
        setTimeout(resolve, 20);
      }, 0);
    });
  },

  get active() {
    return this === activeService;
  },

  throwIfInactive: function throwIfInactive() {
    if (!this.active) {
      throw new Error('This print request was cancelled or completed.');
    }
  }
};
var print = window.print;

window.print = function print() {
  if (activeService) {
    console.warn('Ignored window.print() because of a pending print job.');
    return;
  }

  ensureOverlay().then(function () {
    if (activeService) {
      overlayManager.open('printServiceOverlay');
    }
  });

  try {
    dispatchEvent('beforeprint');
  } finally {
    if (!activeService) {
      console.error('Expected print service to be initialized.');
      ensureOverlay().then(function () {
        if (overlayManager.active === 'printServiceOverlay') {
          overlayManager.close('printServiceOverlay');
        }
      });
      return;
    }

    var activeServiceOnEntry = activeService;
    activeService.renderPages().then(function () {
      return activeServiceOnEntry.performPrint();
    }).catch(function () {}).then(function () {
      if (activeServiceOnEntry.active) {
        abort();
      }
    });
  }
};

function dispatchEvent(eventType) {
  var event = document.createEvent('CustomEvent');
  event.initCustomEvent(eventType, false, false, 'custom');
  window.dispatchEvent(event);
}

function abort() {
  if (activeService) {
    activeService.destroy();
    dispatchEvent('afterprint');
  }
}

function renderProgress(index, total, l10n) {
  var progressContainer = document.getElementById('printServiceOverlay');
  var progress = Math.round(100 * index / total);
  var progressBar = progressContainer.querySelector('progress');
  var progressPerc = progressContainer.querySelector('.relative-progress');
  progressBar.value = progress;
  l10n.get('print_progress_percent', {
    progress: progress
  }, progress + '%').then(function (msg) {
    progressPerc.textContent = msg;
  });
}

var hasAttachEvent = !!document.attachEvent;
window.addEventListener('keydown', function (event) {
  if (event.keyCode === 80 && (event.ctrlKey || event.metaKey) && !event.altKey && (!event.shiftKey || window.chrome || window.opera)) {
    window.print();

    if (hasAttachEvent) {
      return;
    }

    event.preventDefault();

    if (event.stopImmediatePropagation) {
      event.stopImmediatePropagation();
    } else {
      event.stopPropagation();
    }

    return;
  }
}, true);

if (hasAttachEvent) {
  document.attachEvent('onkeydown', function (event) {
    event = event || window.event;

    if (event.keyCode === 80 && event.ctrlKey) {
      event.keyCode = 0;
      return false;
    }
  });
}

if ('onbeforeprint' in window) {
  var stopPropagationIfNeeded = function stopPropagationIfNeeded(event) {
    if (event.detail !== 'custom' && event.stopImmediatePropagation) {
      event.stopImmediatePropagation();
    }
  };

  window.addEventListener('beforeprint', stopPropagationIfNeeded);
  window.addEventListener('afterprint', stopPropagationIfNeeded);
}

var overlayPromise;

function ensureOverlay() {
  if (!overlayPromise) {
    overlayManager = _app.PDFViewerApplication.overlayManager;

    if (!overlayManager) {
      throw new Error('The overlay manager has not yet been initialized.');
    }

    overlayPromise = overlayManager.register('printServiceOverlay', document.getElementById('printServiceOverlay'), abort, true);
    document.getElementById('printCancel').onclick = abort;
  }

  return overlayPromise;
}

_app.PDFPrintServiceFactory.instance = {
  supportsPrinting: true,
  createPrintService: function createPrintService(pdfDocument, pagesOverview, printContainer, l10n) {
    if (activeService) {
      throw new Error('The print service is created and active.');
    }

    activeService = new PDFPrintService(pdfDocument, pagesOverview, printContainer, l10n);
    return activeService;
  }
};

/***/ })
/******/ ]);
//# sourceMappingURL=viewer.js.map


/***/ }),
/* 1426 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucCreditProgressBarComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Generated class for the OucCreditProgressBarComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucCreditProgressBarComponent = /** @class */ (function () {
    function OucCreditProgressBarComponent() {
        this.length = {
            'width': '0%',
            'transition': 'width 1s',
            '-webkit-transition': 'width 1s'
        };
    }
    OucCreditProgressBarComponent.prototype.ngOnInit = function () {
        this.setData();
    };
    /**
     * 设置数据
     */
    OucCreditProgressBarComponent.prototype.setData = function () {
        var _this = this;
        this.proportion = Math.round(this.amount / this.total * 100);
        if (this.proportion > 100) {
            this.proportion = 100;
        }
        if (this.proportion) {
            this.proportion += '%';
        }
        else {
            this.proportion = '0%';
        }
        setTimeout(function () {
            _this.length.width = _this.proportion;
        }, 200); //设置延迟，让动画动起来
    };
    /**
     * 数据变化
     */
    OucCreditProgressBarComponent.prototype.ngOnChanges = function () {
        //重新更新数据
        this.setData();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucCreditProgressBarComponent.prototype, "total", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucCreditProgressBarComponent.prototype, "amount", void 0);
    OucCreditProgressBarComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-credit-progress-bar',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-credit-progress-bar\ouc-credit-progress-bar.html"*/'<div class="Bars"> \n  <div [ngStyle]="length"> \n  </div> \n</div> '/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-credit-progress-bar\ouc-credit-progress-bar.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], OucCreditProgressBarComponent);
    return OucCreditProgressBarComponent;
}());

//# sourceMappingURL=ouc-credit-progress-bar.js.map

/***/ }),
/* 1427 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OucHomeBigBannerComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ionic_native_status_bar__ = __webpack_require__(183);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_storage__ = __webpack_require__(131);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Generated class for the OucHomeBigBannerComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var OucHomeBigBannerComponent = /** @class */ (function () {
    // slidesItems = [
    //   {
    //     title: '国开云课堂',
    //     img: 'http://eefile.download.eenet.com/files2/xlims/file/1deceb4c6655de22ded92a1e2cbda201.png',
    //     src: 'http://www.ouc-online.com.cn/'
    //   },
    //   {
    //     title: '医护心理学',
    //     img: 'http://eefile.download.eenet.com/files2/xlims/file/21c06d8f6f683ae8e9392892483edcc3.jpg',
    //     src: 'http://zongbu.ouchn.cn/course/view.php?id=2566'
    //   }
    // ];
    // text: string;
    function OucHomeBigBannerComponent(rest, sitesProvider, events, courseHelper, navCtrl, statusBar, appProvider, storage) {
        this.rest = rest;
        this.sitesProvider = sitesProvider;
        this.events = events;
        this.courseHelper = courseHelper;
        this.navCtrl = navCtrl;
        this.statusBar = statusBar;
        this.appProvider = appProvider;
        this.storage = storage;
    }
    OucHomeBigBannerComponent.prototype.ngOnInit = function () {
        this.banners = JSON.parse(this.banners);
        this.banners = this.banners.Items;
        console.log(this.banners);
    };
    OucHomeBigBannerComponent.prototype.liulanqi = function (url) {
        var options = {
            statusbar: {
                color: '#004DFF'
            },
            toolbar: {
                height: 44,
                color: '#004DFF'
            },
            title: {
                color: '#ffffffff',
                showPageTitle: true
            },
            backButton: {
                wwwImage: 'assets/ouc/back.png',
                wwwImagePressed: 'assets/ouc/back.png',
                align: 'left',
                event: 'backPressed'
            },
            backButtonCanClose: true
        };
        __WEBPACK_IMPORTED_MODULE_1__ionic_native_themeable_browser__["a" /* ThemeableBrowser */].create(url, '_blank', options);
    };
    // banner图链接
    OucHomeBigBannerComponent.prototype.openAds = function (item) {
        var _this = this;
        //打开浏览器
        if (item.TargetType == 'Url') {
            // this.liulanqi(item.Target);
            this.doopenIapp(item.Target);
        }
        else if (item.TargetType == 'Local') {
            if (item.Target != null && item.Target.indexOf(':') != -1) {
                var type = item.Target.split(':')[0].toLowerCase();
                var id_1 = item.Target.split(':')[1];
                if (type == 'page') {
                    this.navCtrl.push('HomenewdetailPage', {
                        articleId: id_1
                    });
                }
                else if (type == 'apppage') {
                    this.navCtrl.push('OuccommonPage', {
                        title: item.Message,
                        id: id_1
                    });
                }
                else if (type == 'moddle') {
                    this.storage.set('oucUsername', null);
                    var siteUrl_1 = 'http://zongbu.ouchn.cn';
                    this.sitesProvider.newSite('http://zongbu.ouchn.cn', '1ac9a888ca122e57fdc2bec4ffe65536', '', false).then(function () {
                        var param = {
                            wstoken: '1ac9a888ca122e57fdc2bec4ffe65536',
                            field: 'idnumber',
                            value: id_1
                        };
                        var getCourseId = siteUrl_1 +
                            '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=core_course_get_courses_by_field';
                        _this.rest.httpOucPost(getCourseId, param, function (d) {
                            _this.courseHelper.openCourse(_this.navCtrl, d.courses[0]);
                            // this.params = this.params || {};
                            // Object.assign(this.params, { course: d.courses[0] });
                            // // this.navCtrl.push('CoreCourseSectionPage', this.params);
                            // this.modalCtrl.create('CoreCourseSectionPage',this.params).present
                            // this
                        }, true);
                    });
                }
            }
        }
        else if (item.TargetType == 'None') {
        }
    };
    /**
     * ios打开注释
     * @param url
     */
    //  doopenIapp(url){
    //   this.appProvider.setStatusBarColor();
    //   this.statusBar.show();
    //   const a=this.statusBar
    //    // const browser = window.cordova.InAppBrowser.open(url, '_blank');
    //    const browser = window.cordova.InAppBrowser.open(url, '_blank','location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
    //    browser.addEventListener('exit', function (event) {
    //     a.overlaysWebView(true);
    //     a.hide();
    //   });
    //  }
    /**
     * android打开注释
     * @param url
     */
    OucHomeBigBannerComponent.prototype.doopenIapp = function (url) {
        // const browser = window.cordova.InAppBrowser.open(url, '_blank');
        var browser = window.cordova.InAppBrowser.open(url, '_blank', 'location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], OucHomeBigBannerComponent.prototype, "banners", void 0);
    OucHomeBigBannerComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'ouc-home-big-banner',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-big-banner\ouc-home-big-banner.html"*/'<!-- Generated template for the OucHomeBigBannerComponent component -->\n<div>\n  <ion-slides class="ion-slides-banner" autoplay="2000" loop=true pager>\n    <ion-slide *ngFor="let item of banners" (click)="openAds(item)">\n        <img src="{{item.ImageUrl}}" class="slide-image-banner">\n    </ion-slide>\n</ion-slides>\n<div class="div-white-bg" >\n</div>\n</div>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\components\ouc-home-big-banner\ouc-home-big-banner.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["i" /* Events */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_6__ionic_native_status_bar__["a" /* StatusBar */],
            __WEBPACK_IMPORTED_MODULE_7__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_8__ionic_storage__["b" /* Storage */]])
    ], OucHomeBigBannerComponent);
    return OucHomeBigBannerComponent;
}());

//# sourceMappingURL=ouc-home-big-banner.js.map

/***/ }),
/* 1428 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModuleComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ionic_storage__ = __webpack_require__(131);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};










/**
 * Component to display a module entry in a list of modules.
 *
 * Example usage:
 *
 * <core-course-module [module]="module" [courseId]="courseId" (completionChanged)="onCompletionChange()"></core-course-module>
 */
var CoreCourseModuleComponent = /** @class */ (function () {
    function CoreCourseModuleComponent(navCtrl, prefetchDelegate, domUtils, courseHelper, eventsProvider, sitesProvider, courseProvider, rest, storage) {
        this.navCtrl = navCtrl;
        this.prefetchDelegate = prefetchDelegate;
        this.domUtils = domUtils;
        this.courseHelper = courseHelper;
        this.eventsProvider = eventsProvider;
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.rest = rest;
        this.storage = storage;
        this.statusCalculated = false;
        this.isDestroyed = false;
        this.completionChanged = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    Object.defineProperty(CoreCourseModuleComponent.prototype, "enabled", {
        set: function (value) {
            this.downloadEnabled = value;
            if (this.module.handlerData.showDownloadButton && this.downloadEnabled && !this.statusCalculated) {
                // First time that the download is enabled. Initialize the data.
                this.statusCalculated = true;
                this.spinner = true; // Show spinner while calculating the status.
                // Get current status to decide which icon should be shown.
                this.prefetchDelegate.getModuleStatus(this.module, this.courseId).then(this.showStatus.bind(this));
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Component being initialized.
     */
    CoreCourseModuleComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Handler data must be defined. If it isn't, set it to prevent errors.
        if (this.module && !this.module.handlerData) {
            this.module.handlerData = {};
        }
        if (this.module.handlerData.showDownloadButton) {
            // Listen for changes on this module status, even if download isn't enabled.
            this.prefetchHandler = this.prefetchDelegate.getPrefetchHandlerFor(this.module);
            this.canCheckUpdates = this.prefetchDelegate.canCheckUpdates();
            this.statusObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].PACKAGE_STATUS_CHANGED, function (data) {
                if (data.componentId === _this.module.id && _this.prefetchHandler &&
                    data.component === _this.prefetchHandler.component) {
                    // Call determineModuleStatus to get the right status to display.
                    var status_1 = _this.prefetchDelegate.determineModuleStatus(_this.module, data.status);
                    if (_this.downloadEnabled) {
                        // Download is enabled, show the status.
                        _this.showStatus(status_1);
                    }
                    else if (_this.module.handlerData.updateStatus) {
                        // Download isn't enabled but the handler defines a updateStatus function, call it anyway.
                        _this.module.handlerData.updateStatus(status_1);
                    }
                }
            }, this.sitesProvider.getCurrentSiteId());
        }
        this.module.handlerData.a11yTitle = typeof this.module.handlerData.a11yTitle != 'undefined' ?
            this.module.handlerData.a11yTitle : this.module.handlerData.title;
        this.module.modnametranslated = this.courseProvider.translateModuleName(this.module.modname) || '';
        if (this.module.availabilityinfo != null) {
            this.module.availabilityinfo = '章节有学习顺序要求，请先完成前置章节';
        }
    };
    /**
     * Function called when the module is clicked.
     *
     * @param {Event} event Click event.
     */
    CoreCourseModuleComponent.prototype.moduleClicked = function (event) {
        if (this.module.uservisible !== false && this.module.handlerData.action) {
            if (this.module.modname == 'page') {
                this.navCtrl.push('HtmlpagePage', {
                    cmid: this.module.id,
                    siturl: this.sitesProvider.getCurrentSite().getURL(),
                });
            }
            else if (this.module.modname == 'polyv') {
                this.doOpenLive(this.module.id);
            }
            else {
                this.module.handlerData.action(event, this.navCtrl, this.module, this.courseId);
            }
        }
    };
    CoreCourseModuleComponent.prototype.doOpenLive = function (cmid) {
        var _this = this;
        var url = this.sitesProvider.getCurrentSite().getURL() +
            '/webservice/rest/server.php?moodlewsrestformat=json&wsfunction=polyv_view';
        this.storage.get('oucUsername').then(function (value) {
            var param = {
                wstoken: _this.sitesProvider.getCurrentSite().getToken(),
                cmid: cmid,
                username: value
            };
            _this.rest.httpOucPost(url, param, function (d) {
                // PLVLiveStreamerPlugin.loginChannel('111','222');
                if (d != null) {
                    if (d.type != null && d.type == 0) {
                        var data = JSON.parse(d.data);
                        console.log(data);
                        console.log(data.channelId);
                        console.log(data.password);
                        console.log(data.appId);
                        console.log(data.appSecret);
                        PLVLiveStreamerPlugin.loginChannel(data.channelId, data.password);
                    }
                    else if (d.type != null && d.type == 1) {
                        var data = JSON.parse(d.data);
                        var browser = window.cordova.InAppBrowser.open(data.url, '_system', 'clearcache=yes,clearsessioncache=yes,location=yes,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,toolbarcolor=#336efa,closebuttoncolor=#ffffff,navigationbuttoncolor=#ffffff,toolbartranslucent=no,hideurlbar=yes');
                    }
                    else {
                    }
                }
                console.log(d);
            }, true);
        });
    };
    /**
     * Function called when a button is clicked.
     *
     * @param {Event} event Click event.
     * @param {CoreCourseModuleHandlerButton} button The clicked button.
     */
    CoreCourseModuleComponent.prototype.buttonClicked = function (event, button) {
        if (button && button.action) {
            event.preventDefault();
            event.stopPropagation();
            button.action(event, this.navCtrl, this.module, this.courseId);
        }
    };
    /**
     * Download the module.
     *
     * @param {boolean} refresh Whether it's refreshing.
     */
    CoreCourseModuleComponent.prototype.download = function (refresh) {
        var _this = this;
        if (!this.prefetchHandler) {
            return;
        }
        // Show spinner since this operation might take a while.
        this.spinner = true;
        // Get download size to ask for confirm if it's high.
        this.prefetchHandler.getDownloadSize(this.module, this.courseId, true).then(function (size) {
            return _this.courseHelper.prefetchModule(_this.prefetchHandler, _this.module, size, _this.courseId, refresh);
        }).catch(function (error) {
            // Error, hide spinner.
            _this.spinner = false;
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
            }
        });
    };
    /**
     * Show download buttons according to module status.
     *
     * @param {string} status Module status.
     */
    CoreCourseModuleComponent.prototype.showStatus = function (status) {
        if (status) {
            this.spinner = false;
            this.downloadStatus = status;
            if (this.module.handlerData.updateStatus) {
                this.module.handlerData.updateStatus(status);
            }
        }
    };
    /**
     * Component destroyed.
     */
    CoreCourseModuleComponent.prototype.ngOnDestroy = function () {
        this.statusObserver && this.statusObserver.off();
        this.module && this.module.handlerData && this.module.handlerData.onDestroy && this.module.handlerData.onDestroy();
        this.isDestroyed = true;
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseModuleComponent.prototype, "module", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreCourseModuleComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseModuleComponent.prototype, "section", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])('downloadEnabled'),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], CoreCourseModuleComponent.prototype, "enabled", null);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCourseModuleComponent.prototype, "completionChanged", void 0);
    CoreCourseModuleComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-course-module',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\module\core-course-module.html"*/'<a style="padding-left: 35px;" *ngIf="module && module.visibleoncoursepage !== 0" ion-item text-wrap id="core-course-module-{{module.id}}" class="core-course-module-handler {{module.handlerData.class}}" (click)="moduleClicked($event)" [ngClass]="{\'item-media\': module.handlerData.icon, \'core-not-clickable\': !module.handlerData.action || !module.uservisible === false, \'item-dimmed\': module.visible === 0 || module.uservisible === false}" [title]="module.handlerData.a11yTitle" detail-none>\n\n    <img style="width: 18px;height: 20px;margin: auto;" item-start *ngIf="module.handlerData.icon" [src]="module.handlerData.icon" [alt]="module.modnametranslated" class="core-module-icon">\n    <div class="core-module-title">\n        <core-format-text [text]="module.handlerData.title"></core-format-text>\n\n        <!-- Buttons. -->\n        <div style="margin-right: 28px;padding-top: 10px;" item-end *ngIf="module.uservisible !== false" class="buttons core-module-buttons" [ngClass]="{\'core-button-completion\': module.completiondata}">\n            <!-- Module completion. -->\n            <core-course-module-completion *ngIf="module.completiondata" [completion]="module.completiondata" [moduleName]="module.name" (completionChanged)="completionChanged.emit($event)"></core-course-module-completion>\n\n            <div hidden class="core-module-buttons-more">\n                <core-download-refresh [status]="downloadStatus" [enabled]="downloadEnabled" [loading]="spinner || module.handlerData.spinner" [canTrustDownload]="canCheckUpdates" (action)="download($event)"></core-download-refresh>\n\n                <!-- Buttons defined by the module handler. -->\n                <div *ngFor="let button of module.handlerData.buttons">\n                    <button *ngIf="!button.icon==link" ion-button icon-only clear  [hidden]="button.hidden || spinner || module.handlerData.spinner" (click)="buttonClicked($event, button)" color="dark" class="core-animate-show-hide" [attr.aria-label]="button.label | translate">\n                        <core-icon [name]="button.icon" [ios]="button.iosIcon || \'\'" [md]="button.mdIcon || \'\'"></core-icon>\n                    </button>\n                  </div>\n            </div>\n        </div>\n    </div>\n    <div class="core-module-more-info">\n        <ion-badge item-end *ngIf="module.handlerData.extraBadge" [color]="module.handlerData.extraBadgeColor" text-wrap text-start>\n            <core-format-text [text]="module.handlerData.extraBadge"></core-format-text>\n        </ion-badge>\n        <ion-badge item-end *ngIf="module.visible === 0 && (!section || section.visible)" text-wrap>{{ \'core.course.hiddenfromstudents\' | translate }}</ion-badge>\n        <ion-badge item-end *ngIf="module.visible !== 0 && module.isStealth" text-wrap>{{ \'core.course.hiddenoncoursepage\' | translate }}</ion-badge>\n        <div class="core-module-availabilityinfo" *ngIf="module.availabilityinfo" item-end>\n            <ion-badge hidden text-wrap>{{ \'core.restricted\' | translate }}</ion-badge>\n            <core-format-text [text]="module.availabilityinfo" text-wrap></core-format-text>\n        </div>\n        <ion-badge item-end *ngIf="module.completiondata && module.completiondata.offline" color="warning" text-wrap>{{ \'core.course.manualcompletionnotsynced\' | translate }}</ion-badge>\n    </div>\n    <core-format-text class="core-module-description" *ngIf="module.description" maxHeight="80" [text]="module.description"></core-format-text>\n</a>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\module\core-course-module.html"*/
        }),
        __param(0, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_7__providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_9__ionic_storage__["b" /* Storage */]])
    ], CoreCourseModuleComponent);
    return CoreCourseModuleComponent;
}());

//# sourceMappingURL=module.js.map

/***/ }),
/* 1429 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModuleCompletionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_course__ = __webpack_require__(10);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Component to handle activity completion. It shows a checkbox with the current status, and allows manually changing
 * the completion if it's allowed.
 *
 * Example usage:
 *
 * <core-course-module-completion [completion]="module.completiondata" [moduleName]="module.name"
 *     (completionChanged)="completionChanged()"></core-course-module-completion>
 */
var CoreCourseModuleCompletionComponent = /** @class */ (function () {
    function CoreCourseModuleCompletionComponent(textUtils, domUtils, translate, courseProvider, userProvider) {
        this.textUtils = textUtils;
        this.domUtils = domUtils;
        this.translate = translate;
        this.courseProvider = courseProvider;
        this.userProvider = userProvider;
        this.completionChanged = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Detect changes on input properties.
     */
    CoreCourseModuleCompletionComponent.prototype.ngOnChanges = function (changes) {
        if (changes.completion && this.completion) {
            this.showStatus();
        }
    };
    /**
     * Completion clicked.
     *
     * @param {Event} e The click event.
     */
    CoreCourseModuleCompletionComponent.prototype.completionClicked = function (e) {
        var _this = this;
        if (this.completion) {
            if (typeof this.completion.cmid == 'undefined' || this.completion.tracking !== 1) {
                return;
            }
            e.preventDefault();
            e.stopPropagation();
            var modal_1 = this.domUtils.showModalLoading();
            this.completion.state = this.completion.state === 1 ? 0 : 1;
            this.courseProvider.markCompletedManually(this.completion.cmid, this.completion.state, this.completion.courseId, this.completion.courseName).then(function (response) {
                if (!response.status) {
                    return Promise.reject(null);
                }
                if (_this.completion.hasOwnProperty('valueused') && !_this.completion.valueused) {
                    _this.showStatus();
                    if (response.offline) {
                        _this.completion.offline = true;
                    }
                }
                _this.completionChanged.emit(_this.completion);
            }).catch(function (error) {
                _this.completion.state = _this.completion.state === 1 ? 0 : 1;
                _this.domUtils.showErrorModalDefault(error, 'core.errorchangecompletion', true);
            }).finally(function () {
                modal_1.dismiss();
            });
        }
    };
    /**
     * Set image and description to show as completion icon.
     */
    CoreCourseModuleCompletionComponent.prototype.showStatus = function () {
        var _this = this;
        var moduleName = this.moduleName || '';
        var langKey, image;
        if (this.completion.tracking === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_TRACKING_MANUAL &&
            this.completion.state === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_INCOMPLETE) {
            image = 'completion-manual-n';
            langKey = 'core.completion-alt-manual-n';
        }
        else if (this.completion.tracking === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_TRACKING_MANUAL &&
            this.completion.state === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_COMPLETE) {
            image = 'completion-manual-y';
            langKey = 'core.completion-alt-manual-y';
        }
        else if (this.completion.tracking === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_TRACKING_AUTOMATIC &&
            this.completion.state === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_INCOMPLETE) {
            image = 'completion-auto-n';
            langKey = 'core.completion-alt-auto-n';
        }
        else if (this.completion.tracking === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_TRACKING_AUTOMATIC &&
            this.completion.state === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_COMPLETE) {
            image = 'completion-auto-y';
            langKey = 'core.completion-alt-auto-y';
        }
        else if (this.completion.tracking === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_TRACKING_AUTOMATIC &&
            this.completion.state === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_COMPLETE_PASS) {
            image = 'completion-auto-pass';
            langKey = 'core.completion-alt-auto-pass';
        }
        else if (this.completion.tracking === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_TRACKING_AUTOMATIC &&
            this.completion.state === __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */].COMPLETION_COMPLETE_FAIL) {
            image = 'completion-auto-fail';
            langKey = 'core.completion-alt-auto-fail';
        }
        if (image) {
            if (this.completion.overrideby > 0) {
                image += '-override';
            }
            this.completionImage = 'assets/img/completion/' + image + '.svg';
        }
        if (moduleName) {
            this.textUtils.formatText(moduleName, true, true, 50).then(function (modNameFormatted) {
                var promise;
                if (_this.completion.overrideby > 0) {
                    langKey += '-override';
                    promise = _this.userProvider.getProfile(_this.completion.overrideby, _this.completion.courseId, true).then(function (profile) {
                        return {
                            overrideuser: profile.fullname,
                            modname: modNameFormatted
                        };
                    });
                }
                else {
                    promise = Promise.resolve(modNameFormatted);
                }
                return promise.then(function (translateParams) {
                    _this.completionDescription = _this.translate.instant(langKey, { $a: translateParams });
                });
            });
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseModuleCompletionComponent.prototype, "completion", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCourseModuleCompletionComponent.prototype, "moduleName", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCourseModuleCompletionComponent.prototype, "completionChanged", void 0);
    CoreCourseModuleCompletionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-course-module-completion',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\module-completion\core-course-module-completion.html"*/'<a *ngIf="completion" (click)="completionClicked($event)">\n    <img [src]="completionImage" [alt]="completionDescription" style="width: 25px;">\n</a>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\module-completion\core-course-module-completion.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user__["a" /* CoreUserProvider */]])
    ], CoreCourseModuleCompletionComponent);
    return CoreCourseModuleCompletionComponent;
}());

//# sourceMappingURL=module-completion.js.map

/***/ }),
/* 1430 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseModuleDescriptionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Component to display the description of a module.
 *
 * This directive is meant to display a module description in a similar way throughout all the app.
 *
 * You can add a note at the right side of the description by using the 'note' attribute.
 *
 * You can also pass a component and componentId to be used in format-text.
 *
 * Module descriptions are shortened by default, allowing the user to see the full description by clicking in it.
 * If you want the whole description to be shown you can use the 'showFull' attribute.
 *
 * Example usage:
 *
 * <core-course-module-description [description]="myDescription"></core-course-module-description
 */
var CoreCourseModuleDescriptionComponent = /** @class */ (function () {
    function CoreCourseModuleDescriptionComponent() {
        // Nothing to do.
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCourseModuleDescriptionComponent.prototype, "description", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCourseModuleDescriptionComponent.prototype, "note", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCourseModuleDescriptionComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseModuleDescriptionComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseModuleDescriptionComponent.prototype, "showFull", void 0);
    CoreCourseModuleDescriptionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-course-module-description',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\module-description\core-course-module-description.html"*/'<ion-card *ngIf="description">\n    <ion-item text-wrap>\n        <core-format-text [text]="description" [component]="component" [componentId]="componentId" [maxHeight]="showFull && showFull !== \'false\' ? 0 : 120" fullOnClick="true"></core-format-text>\n    </ion-item>\n    <ion-item text-wrap *ngIf="note">\n        <ion-note item-end>{{ note }}</ion-note>\n    </ion-item>\n</ion-card>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\course\components\module-description\core-course-module-description.html"*/
        }),
        __metadata("design:paramtypes", [])
    ], CoreCourseModuleDescriptionComponent);
    return CoreCourseModuleDescriptionComponent;
}());

//# sourceMappingURL=module-description.js.map

/***/ }),
/* 1431 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackPluginComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__ = __webpack_require__(162);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays an assignment feedback plugin.
 */
var AddonModAssignFeedbackPluginComponent = /** @class */ (function () {
    function AddonModAssignFeedbackPluginComponent(injector, feedbackDelegate, assignProvider, assignHelper) {
        this.injector = injector;
        this.feedbackDelegate = feedbackDelegate;
        this.assignProvider = assignProvider;
        this.assignHelper = assignHelper;
        // Data to render the plugin if it isn't supported.
        this.component = __WEBPACK_IMPORTED_MODULE_1__providers_assign__["a" /* AddonModAssignProvider */].COMPONENT;
        this.text = '';
        this.files = [];
    }
    /**
     * Component being initialized.
     */
    AddonModAssignFeedbackPluginComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this.plugin) {
            this.pluginLoaded = true;
            return;
        }
        this.plugin.name = this.feedbackDelegate.getPluginName(this.plugin);
        if (!this.plugin.name) {
            this.pluginLoaded = true;
            return;
        }
        this.edit = this.edit && this.edit !== 'false';
        this.canEdit = this.canEdit && this.canEdit !== 'false';
        // Check if the plugin has defined its own component to render itself.
        this.feedbackDelegate.getComponentForPlugin(this.injector, this.plugin).then(function (component) {
            _this.pluginComponent = component;
            if (component) {
                // Prepare the data to pass to the component.
                _this.data = {
                    assign: _this.assign,
                    submission: _this.submission,
                    plugin: _this.plugin,
                    userId: _this.userId,
                    configs: _this.assignHelper.getPluginConfig(_this.assign, 'assignfeedback', _this.plugin.type),
                    edit: _this.edit,
                    canEdit: _this.canEdit
                };
            }
            else {
                // Data to render the plugin.
                _this.text = _this.assignProvider.getSubmissionPluginText(_this.plugin);
                _this.files = _this.assignProvider.getSubmissionPluginAttachments(_this.plugin);
                _this.notSupported = _this.feedbackDelegate.isPluginSupported(_this.plugin.type);
                _this.pluginLoaded = true;
            }
        });
    };
    /**
     * Invalidate the plugin data.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignFeedbackPluginComponent.prototype.invalidate = function () {
        return Promise.resolve(this.dynamicComponent && this.dynamicComponent.callComponentFunction('invalidate', []));
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */])
    ], AddonModAssignFeedbackPluginComponent.prototype, "dynamicComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponent.prototype, "assign", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponent.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponent.prototype, "plugin", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModAssignFeedbackPluginComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponent.prototype, "canEdit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModAssignFeedbackPluginComponent.prototype, "edit", void 0);
    AddonModAssignFeedbackPluginComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-assign-feedback-plugin',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\feedback-plugin\addon-mod-assign-feedback-plugin.html"*/'\n<core-dynamic-component [component]="pluginComponent" [data]="data">\n    <!-- This content will be replaced by the component if found. -->\n    <core-loading [hideUntil]="pluginLoaded">\n        <ion-item text-wrap *ngIf="text.length > 0 || files.length > 0">\n            <h2>{{ plugin.name }}</h2>\n            <ion-badge *ngIf="notSupported" color="primary">\n                {{ \'addon.mod_assign.feedbacknotsupported\' | translate }}\n            </ion-badge>\n            <p *ngIf="text">\n                <core-format-text [component]="component" [componentId]="assign.cmid" [maxHeight]="80" [fullOnClick]="true" [fullTitle]="plugin.name" [text]="text"></core-format-text>\n            </p>\n            <core-file *ngFor="let file of files" [file]="file" [component]="component" [componentId]="assign.cmid" [alwaysDownload]="true"></core-file>\n        </ion-item>\n    </core-loading>\n</core-dynamic-component>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\assign\components\feedback-plugin\addon-mod-assign-feedback-plugin.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_3__providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */],
            __WEBPACK_IMPORTED_MODULE_1__providers_assign__["a" /* AddonModAssignProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* AddonModAssignHelperProvider */]])
    ], AddonModAssignFeedbackPluginComponent);
    return AddonModAssignFeedbackPluginComponent;
}());

//# sourceMappingURL=feedback-plugin.js.map

/***/ }),
/* 1432 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCompileHtmlComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_compile__ = __webpack_require__(353);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};





/**
 * This component has a behaviour similar to $compile for AngularJS. Given an HTML code, it will compile it so all its
 * components and directives are instantiated.
 *
 * IMPORTANT: Use this component only if it is a must. It will create and compile a new component and module everytime this
 * component is used, so it can slow down the app.
 *
 * This component has its own module to prevent circular dependencies. If you want to use it,
 * you need to import CoreCompileHtmlComponentModule.
 *
 * You can provide some Javascript code (as text) to be executed inside the component. The context of the javascript code (this)
 * will be the component instance created to compile the template. This means your javascript code can interact with the template.
 * The component instance will have most of the providers so you can use them in the javascript code. E.g. if you want to use
 * CoreAppProvider, you can do it with "this.CoreAppProvider".
 */
var CoreCompileHtmlComponent = /** @class */ (function () {
    function CoreCompileHtmlComponent(compileProvider, cdr, element, navCtrl, differs, domUtils, utils) {
        this.compileProvider = compileProvider;
        this.cdr = cdr;
        this.navCtrl = navCtrl;
        this.domUtils = domUtils;
        this.utils = utils;
        this.extraImports = []; // Extra import modules.
        this.extraProviders = []; // Extra providers.
        this.created = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"](); // Will emit an event when the component is instantiated.
        this.compiling = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"](); // Event that indicates whether the template is being compiled.
        this.creatingComponent = false;
        this.element = element.nativeElement;
        this.differ = differs.find([]).create();
    }
    /**
     * Detect and act upon changes that Angular can’t or won’t detect on its own (objects and arrays).
     */
    CoreCompileHtmlComponent.prototype.ngDoCheck = function () {
        if (this.componentInstance && !this.creatingComponent) {
            // Check if there's any change in the jsData object.
            var changes = this.differ.diff(this.jsData);
            if (changes) {
                this.setInputData();
                if (this.componentInstance.ngOnChanges) {
                    this.componentInstance.ngOnChanges(this.domUtils.createChangesFromKeyValueDiff(changes));
                }
            }
        }
    };
    /**
     * Detect changes on input properties.
     */
    CoreCompileHtmlComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        // Only compile if text/javascript has changed or the forceCompile flag has been set to true.
        if ((changes.text || changes.javascript || (changes.forceCompile && this.utils.isTrueOrOne(this.forceCompile))) &&
            this.text) {
            // Create a new component and a new module.
            this.creatingComponent = true;
            this.compiling.emit(true);
            this.compileProvider.createAndCompileComponent(this.text, this.getComponentClass(), this.extraImports)
                .then(function (factory) {
                // Destroy previous components.
                _this.componentRef && _this.componentRef.destroy();
                if (factory) {
                    // Create the component.
                    _this.componentRef = _this.container.createComponent(factory);
                    _this.created.emit(_this.componentRef.instance);
                }
                _this.loaded = true;
            }).catch(function (error) {
                _this.domUtils.showErrorModal(error);
                _this.loaded = true;
            }).finally(function () {
                _this.creatingComponent = false;
                _this.compiling.emit(false);
            });
        }
    };
    /**
     * Component destroyed.
     */
    CoreCompileHtmlComponent.prototype.ngOnDestroy = function () {
        this.componentRef && this.componentRef.destroy();
    };
    /**
     * Get a class that defines the dynamic component.
     *
     * @return {any} The component class.
     */
    CoreCompileHtmlComponent.prototype.getComponentClass = function () {
        // tslint:disable: no-this-assignment
        var compileInstance = this;
        // Create the component, using the text as the template.
        return /** @class */ (function () {
            function CoreCompileHtmlFakeComponent() {
                // Store this instance so it can be accessed by the outer component.
                compileInstance.componentInstance = this;
                // Create 2 empty properties that can be used by the template to store data.
                this['dataObject'] = {};
                this['dataArray'] = [];
                // Inject the libraries.
                compileInstance.compileProvider.injectLibraries(this, compileInstance.extraProviders);
                // Always add these elements, they could be needed on component init (componentObservable).
                this['ChangeDetectorRef'] = compileInstance.cdr;
                this['NavController'] = compileInstance.navCtrl;
                this['componentContainer'] = compileInstance.element;
                // Add the data passed to the component.
                compileInstance.setInputData();
            }
            /**
             * Component being initialized.
             */
            CoreCompileHtmlFakeComponent.prototype.ngOnInit = function () {
                // If there is some javascript to run, do it now.
                if (compileInstance.javascript) {
                    compileInstance.compileProvider.executeJavascript(this, compileInstance.javascript);
                }
            };
            /**
             * Content has been initialized.
             */
            CoreCompileHtmlFakeComponent.prototype.ngAfterContentInit = function () {
                // To be overridden.
            };
            /**
             * View has been initialized.
             */
            CoreCompileHtmlFakeComponent.prototype.ngAfterViewInit = function () {
                // To be overridden.
            };
            /**
             * Component destroyed.
             */
            CoreCompileHtmlFakeComponent.prototype.ngOnDestroy = function () {
                // To be overridden.
            };
            return CoreCompileHtmlFakeComponent;
        }());
    };
    /**
     * Set the JS data as input data of the component instance.
     */
    CoreCompileHtmlComponent.prototype.setInputData = function () {
        if (this.componentInstance) {
            for (var name_1 in this.jsData) {
                this.componentInstance[name_1] = this.jsData[name_1];
            }
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCompileHtmlComponent.prototype, "text", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCompileHtmlComponent.prototype, "javascript", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCompileHtmlComponent.prototype, "jsData", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreCompileHtmlComponent.prototype, "extraImports", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreCompileHtmlComponent.prototype, "extraProviders", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCompileHtmlComponent.prototype, "forceCompile", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCompileHtmlComponent.prototype, "created", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreCompileHtmlComponent.prototype, "compiling", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('dynamicComponent', { read: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewContainerRef"] }),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewContainerRef"])
    ], CoreCompileHtmlComponent.prototype, "container", void 0);
    CoreCompileHtmlComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-compile-html',
            template: '<core-loading [hideUntil]="loaded"><ng-container #dynamicComponent></ng-container></core-loading>'
        }),
        __param(3, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_compile__["a" /* CoreCompileProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectorRef"], __WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["KeyValueDiffers"], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreCompileHtmlComponent);
    return CoreCompileHtmlComponent;
}());

//# sourceMappingURL=compile-html.js.map

/***/ }),
/* 1433 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatSingleActivityModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_singleactivity__ = __webpack_require__(354);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_handler__ = __webpack_require__(779);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_format_delegate__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var CoreCourseFormatSingleActivityModule = /** @class */ (function () {
    function CoreCourseFormatSingleActivityModule(formatDelegate, handler) {
        formatDelegate.registerHandler(handler);
    }
    CoreCourseFormatSingleActivityModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_1__components_singleactivity__["a" /* CoreCourseFormatSingleActivityComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* CoreCourseFormatSingleActivityHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_1__components_singleactivity__["a" /* CoreCourseFormatSingleActivityComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_1__components_singleactivity__["a" /* CoreCourseFormatSingleActivityComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* CoreCourseFormatSingleActivityHandler */]])
    ], CoreCourseFormatSingleActivityModule);
    return CoreCourseFormatSingleActivityModule;
}());

//# sourceMappingURL=singleactivity.module.js.map

/***/ }),
/* 1434 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatSocialModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1435);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_format_delegate__ = __webpack_require__(113);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var CoreCourseFormatSocialModule = /** @class */ (function () {
    function CoreCourseFormatSocialModule(formatDelegate, handler) {
        formatDelegate.registerHandler(handler);
    }
    CoreCourseFormatSocialModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* CoreCourseFormatSocialHandler */]
            ],
            exports: []
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* CoreCourseFormatSocialHandler */]])
    ], CoreCourseFormatSocialModule);
    return CoreCourseFormatSocialModule;
}());

//# sourceMappingURL=social.module.js.map

/***/ }),
/* 1435 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatSocialHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__singleactivity_providers_handler__ = __webpack_require__(779);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


/**
 * Handler to support social course format.
 * This format is like singleactivity in the mobile app, so we'll use the same implementation for both.
 */
var CoreCourseFormatSocialHandler = /** @class */ (function (_super) {
    __extends(CoreCourseFormatSocialHandler, _super);
    function CoreCourseFormatSocialHandler() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'CoreCourseFormatSocial';
        _this.format = 'social';
        return _this;
    }
    CoreCourseFormatSocialHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], CoreCourseFormatSocialHandler);
    return CoreCourseFormatSocialHandler;
}(__WEBPACK_IMPORTED_MODULE_1__singleactivity_providers_handler__["a" /* CoreCourseFormatSingleActivityHandler */]));

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1436 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatTopicsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1437);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_format_delegate__ = __webpack_require__(113);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var CoreCourseFormatTopicsModule = /** @class */ (function () {
    function CoreCourseFormatTopicsModule(formatDelegate, handler) {
        formatDelegate.registerHandler(handler);
    }
    CoreCourseFormatTopicsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* CoreCourseFormatTopicsHandler */]
            ],
            exports: []
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* CoreCourseFormatTopicsHandler */]])
    ], CoreCourseFormatTopicsModule);
    return CoreCourseFormatTopicsModule;
}());

//# sourceMappingURL=topics.module.js.map

/***/ }),
/* 1437 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatTopicsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Handler to support topics course format.
 */
var CoreCourseFormatTopicsHandler = /** @class */ (function () {
    function CoreCourseFormatTopicsHandler() {
        this.name = 'CoreCourseFormatTopics';
        this.format = 'topics';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreCourseFormatTopicsHandler.prototype.isEnabled = function () {
        return true;
    };
    CoreCourseFormatTopicsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], CoreCourseFormatTopicsHandler);
    return CoreCourseFormatTopicsHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1438 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatWeeksModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1439);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_format_delegate__ = __webpack_require__(113);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var CoreCourseFormatWeeksModule = /** @class */ (function () {
    function CoreCourseFormatWeeksModule(formatDelegate, handler) {
        formatDelegate.registerHandler(handler);
    }
    CoreCourseFormatWeeksModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* CoreCourseFormatWeeksHandler */]
            ],
            exports: []
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* CoreCourseFormatWeeksHandler */]])
    ], CoreCourseFormatWeeksModule);
    return CoreCourseFormatWeeksModule;
}());

//# sourceMappingURL=weeks.module.js.map

/***/ }),
/* 1439 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseFormatWeeksHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support weeks course format.
 */
var CoreCourseFormatWeeksHandler = /** @class */ (function () {
    function CoreCourseFormatWeeksHandler(timeUtils) {
        this.timeUtils = timeUtils;
        this.name = 'CoreCourseFormatWeeks';
        this.format = 'weeks';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreCourseFormatWeeksHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Given a list of sections, get the "current" section that should be displayed first.
     *
     * @param {any} course The course to get the title.
     * @param {any[]} sections List of sections.
     * @return {any|Promise<any>} Current section (or promise resolved with current section).
     */
    CoreCourseFormatWeeksHandler.prototype.getCurrentSection = function (course, sections) {
        var now = this.timeUtils.timestamp();
        if (now < course.startdate || (course.enddate && now > course.enddate)) {
            // Course hasn't started yet or it has ended already. Return all sections.
            return sections[0];
        }
        for (var i = 0; i < sections.length; i++) {
            var section = sections[i];
            if (typeof section.section == 'undefined' || section.section < 1) {
                continue;
            }
            var dates = this.getSectionDates(section, course.startdate);
            if ((now >= dates.start) && (now < dates.end)) {
                return section;
            }
        }
        // The section wasn't found, return all sections.
        return sections[0];
    };
    /**
     * Return the start and end date of a section.
     *
     * @param {any} section The section to treat.
     * @param {number} startDate The course start date (in seconds).
     * @return {{start: number, end: number}} An object with the start and end date of the section.
     */
    CoreCourseFormatWeeksHandler.prototype.getSectionDates = function (section, startDate) {
        // Hack alert. We add 2 hours to avoid possible DST problems. (e.g. we go into daylight savings and the date changes).
        startDate = startDate + 7200;
        var dates = {
            start: startDate + (__WEBPACK_IMPORTED_MODULE_2__constants__["a" /* CoreConstants */].SECONDS_WEEK * (section.section - 1)),
            end: 0
        };
        dates.end = dates.start + __WEBPACK_IMPORTED_MODULE_2__constants__["a" /* CoreConstants */].SECONDS_WEEK;
        return dates;
    };
    CoreCourseFormatWeeksHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], CoreCourseFormatWeeksHandler);
    return CoreCourseFormatWeeksHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1440 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(352);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var CoreCourseSyncCronHandler = /** @class */ (function () {
    function CoreCourseSyncCronHandler(courseSync) {
        this.courseSync = courseSync;
        this.name = 'CoreCourseSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    CoreCourseSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.courseSync.syncAllCourses(siteId);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    CoreCourseSyncCronHandler.prototype.getInterval = function () {
        return this.courseSync.syncInterval;
    };
    CoreCourseSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* CoreCourseSyncProvider */]])
    ], CoreCourseSyncCronHandler);
    return CoreCourseSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1441 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseLogCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Log cron handler. It will update last access of the user while app is open.
 */
var CoreCourseLogCronHandler = /** @class */ (function () {
    function CoreCourseLogCronHandler(courseProvider, sitesProvider) {
        this.courseProvider = courseProvider;
        this.sitesProvider = sitesProvider;
        this.name = 'CoreCourseLogCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    CoreCourseLogCronHandler.prototype.execute = function (siteId, force) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return _this.courseProvider.logView(site.getSiteHomeId(), undefined, site.getId(), site.getInfo().sitename);
        });
    };
    /**
     * Check whether it's a synchronization process or not.
     *
     * @return {boolean} Whether it's a synchronization process or not.
     */
    CoreCourseLogCronHandler.prototype.isSync = function () {
        return false;
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    CoreCourseLogCronHandler.prototype.getInterval = function () {
        return 240000; // 4 minutes. By default platform will see the user as online if lastaccess is less than 5 minutes.
    };
    CoreCourseLogCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreCourseLogCronHandler);
    return CoreCourseLogCronHandler;
}());

//# sourceMappingURL=log-cron-handler.js.map

/***/ }),
/* 1442 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesCourseLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__courses__ = __webpack_require__(32);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Handler to treat links to course view or enrol (except site home).
 */
var CoreCoursesCourseLinkHandler = /** @class */ (function (_super) {
    __extends(CoreCoursesCourseLinkHandler, _super);
    function CoreCoursesCourseLinkHandler(sitesProvider, coursesProvider, domUtils, translate, courseProvider, textUtils, courseHelper) {
        var _this = _super.call(this) || this;
        _this.sitesProvider = sitesProvider;
        _this.coursesProvider = coursesProvider;
        _this.domUtils = domUtils;
        _this.translate = translate;
        _this.courseProvider = courseProvider;
        _this.textUtils = textUtils;
        _this.courseHelper = courseHelper;
        _this.name = 'CoreCoursesCourseLinkHandler';
        _this.pattern = /((\/enrol\/index\.php)|(\/course\/enrol\.php)|(\/course\/view\.php)).*([\?\&]id=\d+)/;
        _this.waitStart = 0;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreCoursesCourseLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = parseInt(params.id, 10);
        var sectionId = params.sectionid ? parseInt(params.sectionid, 10) : null, pageParams = {
            sectionId: sectionId || null
        };
        var sectionNumber = typeof params.section != 'undefined' ? parseInt(params.section, 10) : NaN;
        if (!sectionId && !sectionNumber) {
            // Check if the URL has a hash to navigate to the section.
            var matches = url.match(/#section-(\d+)/);
            if (matches && matches[1]) {
                sectionNumber = parseInt(matches[1], 10);
            }
        }
        if (!isNaN(sectionNumber)) {
            pageParams.sectionNumber = sectionNumber;
        }
        return [{
                action: function (siteId, navCtrl) {
                    siteId = siteId || _this.sitesProvider.getCurrentSiteId();
                    if (siteId == _this.sitesProvider.getCurrentSiteId()) {
                        _this.actionEnrol(courseId, url, pageParams).catch(function () {
                            // Ignore errors.
                        });
                    }
                    else {
                        // Don't pass the navCtrl to make the course the new history root (to avoid "loops" in history).
                        _this.courseHelper.getAndOpenCourse(undefined, courseId, pageParams, siteId);
                    }
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreCoursesCourseLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        courseId = parseInt(params.id, 10);
        if (!courseId) {
            return false;
        }
        // Get the course id of Site Home.
        return this.sitesProvider.getSiteHomeId(siteId).then(function (siteHomeId) {
            return courseId != siteHomeId;
        });
    };
    /**
     * Action to perform when an enrol link is clicked.
     *
     * @param {number} courseId Course ID.
     * @param {string} url Treated URL.
     * @param {any} pageParams Params to send to the new page.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCoursesCourseLinkHandler.prototype.actionEnrol = function (courseId, url, pageParams) {
        var _this = this;
        var modal = this.domUtils.showModalLoading(), isEnrolUrl = !!url.match(/(\/enrol\/index\.php)|(\/course\/enrol\.php)/);
        var course;
        // Check if user is enrolled in the course.
        return this.coursesProvider.getUserCourse(courseId).then(function (courseObj) {
            course = courseObj;
        }).catch(function () {
            // User is not enrolled in the course. Check if can self enrol.
            return _this.canSelfEnrol(courseId).then(function () {
                modal.dismiss();
                // The user can self enrol. If it's not a enrolment URL we'll ask for confirmation.
                var promise = isEnrolUrl ? Promise.resolve() :
                    _this.domUtils.showConfirm(_this.translate.instant('core.courses.confirmselfenrol'));
                return promise.then(function () {
                    // Enrol URL or user confirmed.
                    return _this.selfEnrol(courseId).then(function (courseObj) {
                        course = courseObj;
                    }).catch(function (error) {
                        if (error) {
                            _this.domUtils.showErrorModal(error);
                        }
                        return Promise.reject(null);
                    });
                }, function () {
                    // User cancelled. Check if the user can view the course contents (guest access or similar).
                    return _this.courseProvider.getSections(courseId, false, true);
                });
            }, function (error) {
                // Can't self enrol. Check if the user can view the course contents (guest access or similar).
                return _this.courseProvider.getSections(courseId, false, true).catch(function () {
                    // Error. Show error message and allow the user to open the link in browser.
                    modal.dismiss();
                    if (error) {
                        error = _this.textUtils.getErrorMessageFromError(error) || error;
                    }
                    if (!error) {
                        error = _this.translate.instant('core.courses.notenroled');
                    }
                    var body = _this.translate.instant('core.twoparagraphs', { p1: error, p2: _this.translate.instant('core.confirmopeninbrowser') });
                    _this.domUtils.showConfirm(body).then(function () {
                        _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLogin(url);
                    }).catch(function () {
                        // User cancelled.
                    });
                    return Promise.reject(null);
                });
            });
        }).then(function () {
            // Check if we need to retrieve the course.
            if (!course) {
                return _this.courseHelper.getCourse(courseId).then(function (data) {
                    return data.course;
                }).catch(function () {
                    // Cannot get course, return a "fake".
                    return { id: courseId };
                });
            }
            return course;
        }).then(function (course) {
            modal.dismiss();
            // Now open the course.
            _this.courseHelper.openCourse(undefined, course, pageParams);
        });
    };
    /**
     * Check if a user can be "automatically" self enrolled in a course.
     *
     * @param {number} courseId Course ID.
     * @return {Promise<any>} Promise resolved if user can be enrolled in a course, rejected otherwise.
     */
    CoreCoursesCourseLinkHandler.prototype.canSelfEnrol = function (courseId) {
        // Check that the course has self enrolment enabled.
        return this.coursesProvider.getCourseEnrolmentMethods(courseId).then(function (methods) {
            var isSelfEnrolEnabled = false, instances = 0;
            methods.forEach(function (method) {
                if (method.type == 'self' && method.status) {
                    isSelfEnrolEnabled = true;
                    instances++;
                }
            });
            if (!isSelfEnrolEnabled || instances != 1) {
                // Self enrol not enabled or more than one instance.
                return Promise.reject(null);
            }
        });
    };
    /**
     * Try to self enrol a user in a course.
     *
     * @param {number} courseId Course ID.
     * @param {string} [password] Password.
     * @return {Promise<any>} Promise resolved when the user is enrolled, rejected otherwise.
     */
    CoreCoursesCourseLinkHandler.prototype.selfEnrol = function (courseId, password) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        return this.coursesProvider.selfEnrol(courseId, password).then(function () {
            // Success self enrolling the user, invalidate the courses list.
            return _this.coursesProvider.invalidateUserCourses().catch(function () {
                // Ignore errors.
            }).then(function () {
                // Sometimes the list of enrolled courses takes a while to be updated. Wait for it.
                return _this.waitForEnrolled(courseId, true).finally(function () {
                    modal.dismiss();
                });
            });
        }).catch(function (error) {
            modal.dismiss();
            if (error && error.code === __WEBPACK_IMPORTED_MODULE_8__courses__["a" /* CoreCoursesProvider */].ENROL_INVALID_KEY) {
                // Invalid password. Allow the user to input password.
                var title = _this.translate.instant('core.courses.selfenrolment'), body = ' ', // Empty message.
                placeholder = _this.translate.instant('core.courses.password');
                if (typeof password != 'undefined') {
                    // The user attempted a password. Show an error message.
                    _this.domUtils.showErrorModal(error);
                }
                return _this.domUtils.showPrompt(body, title, placeholder).then(function (password) {
                    return _this.selfEnrol(courseId, password);
                });
            }
            else {
                return Promise.reject(error);
            }
        });
    };
    /**
     * Wait for the user to be enrolled in a course.
     *
     * @param {number} courseId The course ID.
     * @param {boolean} first If it's the first call (true) or it's a recursive call (false).
     * @return {Promise<any>} Promise resolved when enrolled or timeout.
     */
    CoreCoursesCourseLinkHandler.prototype.waitForEnrolled = function (courseId, first) {
        var _this = this;
        if (first) {
            this.waitStart = Date.now();
        }
        // Check if user is enrolled in the course.
        return this.coursesProvider.invalidateUserCourses().catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.coursesProvider.getUserCourse(courseId);
        }).catch(function () {
            // Not enrolled, wait a bit and try again.
            if (Date.now() - _this.waitStart > 60000) {
                // Max time reached, stop.
                return;
            }
            return new Promise(function (resolve, reject) {
                setTimeout(function () {
                    _this.waitForEnrolled(courseId).then(resolve);
                }, 5000);
            });
        });
    };
    CoreCoursesCourseLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_8__courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_6__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], CoreCoursesCourseLinkHandler);
    return CoreCoursesCourseLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_5__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=course-link-handler.js.map

/***/ }),
/* 1443 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__courses__ = __webpack_require__(32);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to course index (list of courses).
 */
var CoreCoursesIndexLinkHandler = /** @class */ (function (_super) {
    __extends(CoreCoursesIndexLinkHandler, _super);
    function CoreCoursesIndexLinkHandler(coursesProvider, loginHelper) {
        var _this = _super.call(this) || this;
        _this.coursesProvider = coursesProvider;
        _this.loginHelper = loginHelper;
        _this.name = 'CoreCoursesIndexLinkHandler';
        _this.featureName = 'CoreMainMenuDelegate_CoreCourses';
        _this.pattern = /\/course\/?(index\.php.*)?$/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[] | Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreCoursesIndexLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var page = 'CoreCoursesMyCoursesPage'; // By default, go to My Courses.
                    var pageParams = {};
                    if (_this.coursesProvider.isGetCoursesByFieldAvailable()) {
                        if (params.categoryid) {
                            page = 'CoreCoursesCategoriesPage';
                            pageParams.categoryId = parseInt(params.categoryid, 10);
                        }
                        else {
                            page = 'CoreCoursesAvailableCoursesPage';
                        }
                    }
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.loginHelper.redirect(page, pageParams, siteId);
                }
            }];
    };
    CoreCoursesIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], CoreCoursesIndexLinkHandler);
    return CoreCoursesIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=courses-index-link-handler.js.map

/***/ }),
/* 1444 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesDashboardLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__mainmenu_handler__ = __webpack_require__(781);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to my overview.
 */
var CoreCoursesDashboardLinkHandler = /** @class */ (function (_super) {
    __extends(CoreCoursesDashboardLinkHandler, _super);
    function CoreCoursesDashboardLinkHandler(loginHelper, mainMenuHandler) {
        var _this = _super.call(this) || this;
        _this.loginHelper = loginHelper;
        _this.mainMenuHandler = mainMenuHandler;
        _this.name = 'CoreCoursesMyOverviewLinkHandler';
        _this.pattern = /\/my\/?$/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreCoursesDashboardLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.loginHelper.redirect('CoreCoursesDashboardPage', undefined, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreCoursesDashboardLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.mainMenuHandler.isEnabledForSite(siteId);
    };
    CoreCoursesDashboardLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__mainmenu_handler__["a" /* CoreDashboardMainMenuHandler */]])
    ], CoreCoursesDashboardLinkHandler);
    return CoreCoursesDashboardLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=dashboard-link-handler.js.map

/***/ }),
/* 1445 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesEnrolPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_login_providers_helper__ = __webpack_require__(52);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler for enrol push notifications clicks.
 */
var CoreCoursesEnrolPushClickHandler = /** @class */ (function () {
    function CoreCoursesEnrolPushClickHandler(utils, domUtils, courseHelper, loginHelper) {
        this.utils = utils;
        this.domUtils = domUtils;
        this.courseHelper = courseHelper;
        this.loginHelper = loginHelper;
        this.name = 'CoreCoursesEnrolPushClickHandler';
        this.priority = 200;
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    CoreCoursesEnrolPushClickHandler.prototype.handles = function (notification) {
        return this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent.indexOf('enrol_') === 0 &&
            notification.name == 'expiry_notification';
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCoursesEnrolPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var courseId = Number(notification.courseid), modal = this.domUtils.showModalLoading();
        return this.courseHelper.getCourse(courseId, notification.site).then(function (result) {
            var params = {
                course: result.course
            };
            var page;
            if (notification.contexturl && notification.contexturl.indexOf('user/index.php') != -1) {
                // Open the participants tab.
                page = 'CoreCourseSectionPage';
                params.selectedTab = 'CoreUserParticipants';
            }
            else if (result.enrolled) {
                // User is still enrolled, open the course.
                page = 'CoreCourseSectionPage';
            }
            else {
                // User not enrolled anymore, open the preview page.
                page = 'CoreCoursesCoursePreviewPage';
            }
            return _this.loginHelper.redirect(page, params, notification.site);
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'Error getting course.');
        }).finally(function () {
            modal.dismiss();
        });
    };
    CoreCoursesEnrolPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_4__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], CoreCoursesEnrolPushClickHandler);
    return CoreCoursesEnrolPushClickHandler;
}());

//# sourceMappingURL=enrol-push-click-handler.js.map

/***/ }),
/* 1446 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesRequestPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_login_providers_helper__ = __webpack_require__(52);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Handler for course request push notifications clicks.
 */
var CoreCoursesRequestPushClickHandler = /** @class */ (function () {
    function CoreCoursesRequestPushClickHandler(utils, domUtils, sitesProvider, courseHelper, loginHelper, textUtils, coursesProvider) {
        this.utils = utils;
        this.domUtils = domUtils;
        this.sitesProvider = sitesProvider;
        this.courseHelper = courseHelper;
        this.loginHelper = loginHelper;
        this.textUtils = textUtils;
        this.coursesProvider = coursesProvider;
        this.name = 'CoreCoursesRequestPushClickHandler';
        this.priority = 200;
        this.SUPPORTED_NAMES = ['courserequested', 'courserequestapproved', 'courserequestrejected'];
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    CoreCoursesRequestPushClickHandler.prototype.handles = function (notification) {
        // Don't support 'courserequestrejected', that way the app will open the notifications page.
        return this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'moodle' &&
            (notification.name == 'courserequested' || notification.name == 'courserequestapproved');
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreCoursesRequestPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var courseId = Number(notification.courseid);
        if (notification.name == 'courserequested') {
            // Feature not supported in the app, open in browser.
            return this.sitesProvider.getSite(notification.site).then(function (site) {
                var url = _this.textUtils.concatenatePaths(site.getURL(), 'course/pending.php');
                return site.openInBrowserWithAutoLogin(url);
            });
        }
        else {
            // Open the course.
            var modal_1 = this.domUtils.showModalLoading();
            return this.coursesProvider.invalidateUserCourses(notification.site).catch(function () {
                // Ignore errors.
            }).then(function () {
                return _this.courseHelper.getCourse(courseId, notification.site);
            }).then(function (result) {
                var params = {
                    course: result.course
                };
                var page;
                if (result.enrolled) {
                    // User is still enrolled, open the course.
                    page = 'CoreCourseSectionPage';
                }
                else {
                    // User not enrolled (shouldn't happen), open the preview page.
                    page = 'CoreCoursesCoursePreviewPage';
                }
                return _this.loginHelper.redirect(page, params, notification.site);
            }).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'Error getting course.');
            }).finally(function () {
                modal_1.dismiss();
            });
        }
    };
    CoreCoursesRequestPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_7__core_login_providers_helper__["a" /* CoreLoginHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreCoursesRequestPushClickHandler);
    return CoreCoursesRequestPushClickHandler;
}());

//# sourceMappingURL=request-push-click-handler.js.map

/***/ }),
/* 1447 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderAlbumHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(122);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to upload files from the album.
 */
var CoreFileUploaderAlbumHandler = /** @class */ (function () {
    function CoreFileUploaderAlbumHandler(appProvider, utils, uploaderHelper) {
        this.appProvider = appProvider;
        this.utils = utils;
        this.uploaderHelper = uploaderHelper;
        this.name = 'CoreFileUploaderAlbum';
        this.priority = 2000;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreFileUploaderAlbumHandler.prototype.isEnabled = function () {
        return this.appProvider.isMobile();
    };
    /**
     * Given a list of mimetypes, return the ones that are supported by the handler.
     *
     * @param {string[]} [mimetypes] List of mimetypes.
     * @return {string[]} Supported mimetypes.
     */
    CoreFileUploaderAlbumHandler.prototype.getSupportedMimetypes = function (mimetypes) {
        // Album allows picking images and videos.
        return this.utils.filterByRegexp(mimetypes, /^(image|video)\//);
    };
    /**
     * Get the data to display the handler.
     *
     * @return {CoreFileUploaderHandlerData} Data.
     */
    CoreFileUploaderAlbumHandler.prototype.getData = function () {
        var _this = this;
        return {
            title: 'core.fileuploader.photoalbums',
            class: 'core-fileuploader-album-handler',
            icon: 'images',
            action: function (maxSize, upload, allowOffline, mimetypes) {
                return _this.uploaderHelper.uploadImage(true, maxSize, upload, mimetypes).then(function (result) {
                    return {
                        treated: true,
                        result: result
                    };
                });
            }
        };
    };
    CoreFileUploaderAlbumHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* CoreFileUploaderHelperProvider */]])
    ], CoreFileUploaderAlbumHandler);
    return CoreFileUploaderAlbumHandler;
}());

//# sourceMappingURL=album-handler.js.map

/***/ }),
/* 1448 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderAudioHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__helper__ = __webpack_require__(122);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to record an audio to upload it.
 */
var CoreFileUploaderAudioHandler = /** @class */ (function () {
    function CoreFileUploaderAudioHandler(appProvider, utils, platform, uploaderHelper) {
        this.appProvider = appProvider;
        this.utils = utils;
        this.platform = platform;
        this.uploaderHelper = uploaderHelper;
        this.name = 'CoreFileUploaderAudio';
        this.priority = 1600;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreFileUploaderAudioHandler.prototype.isEnabled = function () {
        return this.appProvider.isMobile() || (this.appProvider.canGetUserMedia() && this.appProvider.canRecordMedia());
    };
    /**
     * Given a list of mimetypes, return the ones that are supported by the handler.
     *
     * @param {string[]} [mimetypes] List of mimetypes.
     * @return {string[]} Supported mimetypes.
     */
    CoreFileUploaderAudioHandler.prototype.getSupportedMimetypes = function (mimetypes) {
        if (this.platform.is('ios')) {
            // In iOS it's recorded as WAV.
            return this.utils.filterByRegexp(mimetypes, /^audio\/wav$/);
        }
        else if (this.platform.is('android')) {
            // In Android we don't know the format the audio will be recorded, so accept any audio mimetype.
            return this.utils.filterByRegexp(mimetypes, /^audio\//);
        }
        else {
            // In desktop, support audio formats that are supported by MediaRecorder.
            var mediaRecorder_1 = window.MediaRecorder;
            if (mediaRecorder_1) {
                return mimetypes.filter(function (type) {
                    var matches = type.match(/^audio\//);
                    return matches && matches.length && mediaRecorder_1.isTypeSupported(type);
                });
            }
        }
        return [];
    };
    /**
     * Get the data to display the handler.
     *
     * @return {CoreFileUploaderHandlerData} Data.
     */
    CoreFileUploaderAudioHandler.prototype.getData = function () {
        var _this = this;
        return {
            title: 'core.fileuploader.audio',
            class: 'core-fileuploader-audio-handler',
            icon: 'microphone',
            action: function (maxSize, upload, allowOffline, mimetypes) {
                return _this.uploaderHelper.uploadAudioOrVideo(true, maxSize, upload, mimetypes).then(function (result) {
                    return {
                        treated: true,
                        result: result
                    };
                });
            }
        };
    };
    CoreFileUploaderAudioHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_4__helper__["a" /* CoreFileUploaderHelperProvider */]])
    ], CoreFileUploaderAudioHandler);
    return CoreFileUploaderAudioHandler;
}());

//# sourceMappingURL=audio-handler.js.map

/***/ }),
/* 1449 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderCameraHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(122);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to take a picture to upload it.
 */
var CoreFileUploaderCameraHandler = /** @class */ (function () {
    function CoreFileUploaderCameraHandler(appProvider, utils, uploaderHelper) {
        this.appProvider = appProvider;
        this.utils = utils;
        this.uploaderHelper = uploaderHelper;
        this.name = 'CoreFileUploaderCamera';
        this.priority = 1800;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreFileUploaderCameraHandler.prototype.isEnabled = function () {
        return this.appProvider.isMobile() || this.appProvider.canGetUserMedia();
    };
    /**
     * Given a list of mimetypes, return the ones that are supported by the handler.
     *
     * @param {string[]} [mimetypes] List of mimetypes.
     * @return {string[]} Supported mimetypes.
     */
    CoreFileUploaderCameraHandler.prototype.getSupportedMimetypes = function (mimetypes) {
        // Camera only supports JPEG and PNG.
        return this.utils.filterByRegexp(mimetypes, /^image\/(jpeg|png)$/);
    };
    /**
     * Get the data to display the handler.
     *
     * @return {CoreFileUploaderHandlerData} Data.
     */
    CoreFileUploaderCameraHandler.prototype.getData = function () {
        var _this = this;
        return {
            title: 'core.fileuploader.camera',
            class: 'core-fileuploader-camera-handler',
            icon: 'camera',
            action: function (maxSize, upload, allowOffline, mimetypes) {
                return _this.uploaderHelper.uploadImage(false, maxSize, upload, mimetypes).then(function (result) {
                    return {
                        treated: true,
                        result: result
                    };
                });
            }
        };
    };
    CoreFileUploaderCameraHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* CoreFileUploaderHelperProvider */]])
    ], CoreFileUploaderCameraHandler);
    return CoreFileUploaderCameraHandler;
}());

//# sourceMappingURL=camera-handler.js.map

/***/ }),
/* 1450 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__helper__ = __webpack_require__(122);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__fileuploader__ = __webpack_require__(54);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Handler to upload any type of file.
 */
var CoreFileUploaderFileHandler = /** @class */ (function () {
    function CoreFileUploaderFileHandler(appProvider, platform, timeUtils, uploaderHelper, uploaderProvider, domUtils) {
        this.appProvider = appProvider;
        this.platform = platform;
        this.timeUtils = timeUtils;
        this.uploaderHelper = uploaderHelper;
        this.uploaderProvider = uploaderProvider;
        this.domUtils = domUtils;
        this.name = 'CoreFileUploaderFile';
        this.priority = 1200;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreFileUploaderFileHandler.prototype.isEnabled = function () {
        return this.platform.is('android') || !this.appProvider.isMobile() ||
            (this.platform.is('ios') && this.platform.version().major >= 9);
    };
    /**
     * Given a list of mimetypes, return the ones that are supported by the handler.
     *
     * @param {string[]} [mimetypes] List of mimetypes.
     * @return {string[]} Supported mimetypes.
     */
    CoreFileUploaderFileHandler.prototype.getSupportedMimetypes = function (mimetypes) {
        return mimetypes;
    };
    /**
     * Get the data to display the handler.
     *
     * @return {CoreFileUploaderHandlerData} Data.
     */
    CoreFileUploaderFileHandler.prototype.getData = function () {
        var _this = this;
        var isIOS = this.platform.is('ios');
        return {
            title: isIOS ? 'core.fileuploader.more' : 'core.fileuploader.file',
            class: 'core-fileuploader-file-handler',
            icon: isIOS ? 'more' : 'folder',
            afterRender: function (maxSize, upload, allowOffline, mimetypes) {
                // Add an invisible file input in the file handler.
                // It needs to be done like this because the action sheet items don't accept inputs.
                var element = document.querySelector('.core-fileuploader-file-handler');
                if (element) {
                    var input_1 = document.createElement('input');
                    input_1.setAttribute('type', 'file');
                    input_1.classList.add('core-fileuploader-file-handler-input');
                    if (mimetypes && mimetypes.length && (!_this.platform.is('android') || mimetypes.length == 1)) {
                        // Don't use accept attribute in Android with several mimetypes, it's not supported.
                        input_1.setAttribute('accept', mimetypes.join(', '));
                    }
                    input_1.addEventListener('change', function (evt) {
                        var file = input_1.files[0];
                        var fileName;
                        input_1.value = ''; // Unset input.
                        if (!file) {
                            return;
                        }
                        // Verify that the mimetype of the file is supported, in case the accept attribute isn't supported.
                        var error = _this.uploaderProvider.isInvalidMimetype(mimetypes, file.name, file.type);
                        if (error) {
                            _this.domUtils.showErrorModal(error);
                            return;
                        }
                        fileName = file.name;
                        if (isIOS) {
                            // Check the name of the file and add a timestamp if needed (take picture).
                            var matches = fileName.match(/image\.(jpe?g|png)/);
                            if (matches) {
                                fileName = 'image_' + _this.timeUtils.readableTimestamp() + '.' + matches[1];
                            }
                        }
                        // Upload the picked file.
                        _this.uploaderHelper.uploadFileObject(file, maxSize, upload, allowOffline, fileName).then(function (result) {
                            _this.uploaderHelper.fileUploaded(result);
                        }).catch(function (error) {
                            if (error) {
                                _this.domUtils.showErrorModal(error);
                            }
                        });
                    });
                    if (_this.platform.is('ios')) {
                        // In iOS, the click on the input stopped working for some reason. We need to put it 1 level higher.
                        element.parentElement.appendChild(input_1);
                        // Animate the button when the input is clicked.
                        input_1.addEventListener('mousedown', function () {
                            element.classList.add('activated');
                        });
                        input_1.addEventListener('mouseup', function () {
                            _this.platform.timeout(function () {
                                element.classList.remove('activated');
                            }, 80);
                        });
                    }
                    else {
                        element.appendChild(input_1);
                    }
                }
            }
        };
    };
    CoreFileUploaderFileHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_time__["a" /* CoreTimeUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__helper__["a" /* CoreFileUploaderHelperProvider */], __WEBPACK_IMPORTED_MODULE_6__fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], CoreFileUploaderFileHandler);
    return CoreFileUploaderFileHandler;
}());

//# sourceMappingURL=file-handler.js.map

/***/ }),
/* 1451 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreFileUploaderVideoHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__helper__ = __webpack_require__(122);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to record a video to upload it.
 */
var CoreFileUploaderVideoHandler = /** @class */ (function () {
    function CoreFileUploaderVideoHandler(appProvider, utils, platform, uploaderHelper) {
        this.appProvider = appProvider;
        this.utils = utils;
        this.platform = platform;
        this.uploaderHelper = uploaderHelper;
        this.name = 'CoreFileUploaderVideo';
        this.priority = 1400;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreFileUploaderVideoHandler.prototype.isEnabled = function () {
        return this.appProvider.isMobile() || (this.appProvider.canGetUserMedia() && this.appProvider.canRecordMedia());
    };
    /**
     * Given a list of mimetypes, return the ones that are supported by the handler.
     *
     * @param {string[]} [mimetypes] List of mimetypes.
     * @return {string[]} Supported mimetypes.
     */
    CoreFileUploaderVideoHandler.prototype.getSupportedMimetypes = function (mimetypes) {
        if (this.platform.is('ios')) {
            // In iOS it's recorded as MOV.
            return this.utils.filterByRegexp(mimetypes, /^video\/quicktime$/);
        }
        else if (this.platform.is('android')) {
            // In Android we don't know the format the video will be recorded, so accept any video mimetype.
            return this.utils.filterByRegexp(mimetypes, /^video\//);
        }
        else {
            // In desktop, support video formats that are supported by MediaRecorder.
            var mediaRecorder_1 = window.MediaRecorder;
            if (mediaRecorder_1) {
                return mimetypes.filter(function (type) {
                    var matches = type.match(/^video\//);
                    return matches && matches.length && mediaRecorder_1.isTypeSupported(type);
                });
            }
        }
        return [];
    };
    /**
     * Get the data to display the handler.
     *
     * @return {CoreFileUploaderHandlerData} Data.
     */
    CoreFileUploaderVideoHandler.prototype.getData = function () {
        var _this = this;
        return {
            title: 'core.fileuploader.video',
            class: 'core-fileuploader-video-handler',
            icon: 'videocam',
            action: function (maxSize, upload, allowOffline, mimetypes) {
                return _this.uploaderHelper.uploadAudioOrVideo(false, maxSize, upload, mimetypes).then(function (result) {
                    return {
                        treated: true,
                        result: result
                    };
                });
            }
        };
    };
    CoreFileUploaderVideoHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_4__helper__["a" /* CoreFileUploaderHelperProvider */]])
    ], CoreFileUploaderVideoHandler);
    return CoreFileUploaderVideoHandler;
}());

//# sourceMappingURL=video-handler.js.map

/***/ }),
/* 1452 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__grades__ = __webpack_require__(101);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to inject an option into main menu.
 */
var CoreGradesMainMenuHandler = /** @class */ (function () {
    function CoreGradesMainMenuHandler(gradesProvider) {
        this.gradesProvider = gradesProvider;
        this.name = 'CoreGrades';
        this.priority = 600;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean | Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    CoreGradesMainMenuHandler.prototype.isEnabled = function () {
        return this.gradesProvider.isCourseGradesEnabled();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data needed to render the handler.
     */
    CoreGradesMainMenuHandler.prototype.getDisplayData = function () {
        return {
            icon: 'stats',
            title: 'core.grades.grades',
            page: 'CoreGradesCoursesPage',
            class: 'core-grades-coursesgrades-handler'
        };
    };
    CoreGradesMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__grades__["a" /* CoreGradesProvider */]])
    ], CoreGradesMainMenuHandler);
    return CoreGradesMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 1453 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesCourseOptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_course_course__ = __webpack_require__(784);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Course nav handler.
 */
var CoreGradesCourseOptionHandler = /** @class */ (function () {
    function CoreGradesCourseOptionHandler(gradesProvider, coursesProvider) {
        this.gradesProvider = gradesProvider;
        this.coursesProvider = coursesProvider;
        this.name = 'CoreGrades';
        this.priority = 400;
    }
    /**
     * Should invalidate the data to determine if the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreGradesCourseOptionHandler.prototype.invalidateEnabledForCourse = function (courseId, navOptions, admOptions) {
        if (navOptions && typeof navOptions.grades != 'undefined') {
            // No need to invalidate anything.
            return Promise.resolve();
        }
        return this.coursesProvider.invalidateUserCourses();
    };
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    CoreGradesCourseOptionHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether or not the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreGradesCourseOptionHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        if (accessData && accessData.type == __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__["a" /* CoreCourseProvider */].ACCESS_GUEST) {
            return false; // Not enabled for guests.
        }
        if (navOptions && typeof navOptions.grades != 'undefined') {
            return navOptions.grades;
        }
        return this.gradesProvider.isPluginEnabledForCourse(courseId);
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {Injector} injector Injector.
     * @param {number} courseId The course ID.
     * @return {CoreCourseOptionsHandlerData|Promise<CoreCourseOptionsHandlerData>} Data or promise resolved with the data.
     */
    CoreGradesCourseOptionHandler.prototype.getDisplayData = function (injector, courseId) {
        return {
            title: 'core.grades.grades',
            class: 'core-grades-course-handler',
            component: __WEBPACK_IMPORTED_MODULE_4__components_course_course__["a" /* CoreGradesCourseComponent */]
        };
    };
    /**
     * Called when a course is downloaded. It should prefetch all the data to be able to see the addon in offline.
     *
     * @param {any} course The course.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreGradesCourseOptionHandler.prototype.prefetch = function (course) {
        return this.gradesProvider.getCourseGradesTable(course.id, undefined, undefined, true);
    };
    CoreGradesCourseOptionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__grades__["a" /* CoreGradesProvider */], __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreGradesCourseOptionHandler);
    return CoreGradesCourseOptionHandler;
}());

//# sourceMappingURL=course-option-handler.js.map

/***/ }),
/* 1454 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesUserLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(110);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to user grades.
 */
var CoreGradesUserLinkHandler = /** @class */ (function (_super) {
    __extends(CoreGradesUserLinkHandler, _super);
    function CoreGradesUserLinkHandler(gradesProvider, gradesHelper) {
        var _this = _super.call(this) || this;
        _this.gradesProvider = gradesProvider;
        _this.gradesHelper = gradesHelper;
        _this.name = 'CoreGradesUserLinkHandler';
        _this.pattern = /\/grade\/report\/user\/index.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @param {any} [data] Extra data to handle the URL.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreGradesUserLinkHandler.prototype.getActions = function (siteIds, url, params, courseId, data) {
        var _this = this;
        courseId = courseId || params.id;
        data = data || {};
        return [{
                action: function (siteId, navCtrl) {
                    var userId = params.userid && parseInt(params.userid, 10), moduleId = data.cmid && parseInt(data.cmid, 10);
                    _this.gradesHelper.goToGrades(courseId, userId, moduleId, navCtrl, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreGradesUserLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (!courseId && !params.id) {
            return false;
        }
        return this.gradesProvider.isPluginEnabledForCourse(courseId || params.id, siteId);
    };
    CoreGradesUserLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__grades__["a" /* CoreGradesProvider */], __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* CoreGradesHelperProvider */]])
    ], CoreGradesUserLinkHandler);
    return CoreGradesUserLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=user-link-handler.js.map

/***/ }),
/* 1455 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesOverviewLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__grades__ = __webpack_require__(101);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to overview courses grades.
 */
var CoreGradesOverviewLinkHandler = /** @class */ (function (_super) {
    __extends(CoreGradesOverviewLinkHandler, _super);
    function CoreGradesOverviewLinkHandler(linkHelper, gradesProvider) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.gradesProvider = gradesProvider;
        _this.name = 'CoreGradesOverviewLinkHandler';
        _this.pattern = /\/grade\/report\/overview\/index.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreGradesOverviewLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, 'CoreGradesCoursesPage', undefined, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreGradesOverviewLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.gradesProvider.isCourseGradesEnabled(siteId);
    };
    CoreGradesOverviewLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__grades__["a" /* CoreGradesProvider */]])
    ], CoreGradesOverviewLinkHandler);
    return CoreGradesOverviewLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=overview-link-handler.js.map

/***/ }),
/* 1456 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreGradesUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__grades__ = __webpack_require__(101);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Profile grades handler.
 */
var CoreGradesUserHandler = /** @class */ (function () {
    function CoreGradesUserHandler(linkHelper, sitesProvider, gradesProvider) {
        this.linkHelper = linkHelper;
        this.sitesProvider = sitesProvider;
        this.gradesProvider = gradesProvider;
        this.name = 'CoreGrades:viewGrades';
        this.priority = 400;
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_NEW_PAGE;
        this.viewGradesEnabledCache = {};
    }
    /**
     * Clear view grades cache.
     * If a courseId and userId are specified, it will only delete the entry for that user and course.
     *
     * @param  {number} [courseId] Course ID.
     * @param  {number} [userId]   User ID.
     */
    CoreGradesUserHandler.prototype.clearViewGradesCache = function (courseId, userId) {
        if (courseId && userId) {
            delete this.viewGradesEnabledCache[this.getCacheKey(courseId, userId)];
        }
        else {
            this.viewGradesEnabledCache = {};
        }
    };
    /**
     * Get a cache key to identify a course and a user.
     *
     * @param  {number} courseId Course ID.
     * @param  {number} userId   User ID.
     * @return {string}          Cache key.
     */
    CoreGradesUserHandler.prototype.getCacheKey = function (courseId, userId) {
        return courseId + '#' + userId;
    };
    /**
     * Check if handler is enabled.
     *
     * @return {boolean} Always enabled.
     */
    CoreGradesUserHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user     User to check.
     * @param {number} courseId Course ID.
     * @param  {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param  {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return  {boolean|Promise<boolean>}   Promise resolved with true if enabled, resolved with false otherwise.
     */
    CoreGradesUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        var _this = this;
        var cacheKey = this.getCacheKey(courseId, user.id), cache = this.viewGradesEnabledCache[cacheKey];
        if (typeof cache != 'undefined') {
            return cache;
        }
        return this.gradesProvider.isPluginEnabledForCourse(courseId).then(function () {
            return _this.gradesProvider.getCourseGradesTable(courseId, user.id).then(function () {
                _this.viewGradesEnabledCache[cacheKey] = true;
                return true;
            }).catch(function () {
                _this.viewGradesEnabledCache[cacheKey] = false;
                return false;
            });
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    CoreGradesUserHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        return {
            icon: 'stats',
            title: 'core.grades.grades',
            class: 'core-grades-user-handler',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                var pageParams = {
                    courseId: courseId,
                    userId: user.id
                };
                // Always use redirect to make it the new history root (to avoid "loops" in history).
                _this.linkHelper.goInSite(navCtrl, 'CoreGradesCoursePage', pageParams);
            }
        };
    };
    CoreGradesUserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__grades__["a" /* CoreGradesProvider */]])
    ], CoreGradesUserHandler);
    return CoreGradesUserHandler;
}());

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1457 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSharedFilesUploadHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__helper__ = __webpack_require__(427);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to upload files from the album.
 */
var CoreSharedFilesUploadHandler = /** @class */ (function () {
    function CoreSharedFilesUploadHandler(sharedFilesHelper, platform) {
        this.sharedFilesHelper = sharedFilesHelper;
        this.platform = platform;
        this.name = 'CoreSharedFilesUpload';
        this.priority = 1300;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreSharedFilesUploadHandler.prototype.isEnabled = function () {
        return this.platform.is('ios');
    };
    /**
     * Given a list of mimetypes, return the ones that are supported by the handler.
     *
     * @param {string[]} [mimetypes] List of mimetypes.
     * @return {string[]} Supported mimetypes.
     */
    CoreSharedFilesUploadHandler.prototype.getSupportedMimetypes = function (mimetypes) {
        return mimetypes;
    };
    /**
     * Get the data to display the handler.
     *
     * @return {CoreFileUploaderHandlerData} Data.
     */
    CoreSharedFilesUploadHandler.prototype.getData = function () {
        var _this = this;
        return {
            title: 'core.sharedfiles.sharedfiles',
            class: 'core-sharedfiles-fileuploader-handler',
            icon: 'folder',
            action: function (maxSize, upload, allowOffline, mimetypes) {
                // Don't use the params because the file won't be uploaded, it is returned to the fileuploader.
                return _this.sharedFilesHelper.pickSharedFile(mimetypes);
            }
        };
    };
    CoreSharedFilesUploadHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__helper__["a" /* CoreSharedFilesHelperProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */]])
    ], CoreSharedFilesUploadHandler);
    return CoreSharedFilesUploadHandler;
}());

//# sourceMappingURL=upload-handler.js.map

/***/ }),
/* 1458 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__sitehome__ = __webpack_require__(171);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to site home index.
 */
var CoreSiteHomeIndexLinkHandler = /** @class */ (function (_super) {
    __extends(CoreSiteHomeIndexLinkHandler, _super);
    function CoreSiteHomeIndexLinkHandler(sitesProvider, siteHomeProvider, loginHelper) {
        var _this = _super.call(this) || this;
        _this.sitesProvider = sitesProvider;
        _this.siteHomeProvider = siteHomeProvider;
        _this.loginHelper = loginHelper;
        _this.name = 'CoreSiteHomeIndexLinkHandler';
        _this.featureName = 'CoreMainMenuDelegate_CoreSiteHome';
        _this.pattern = /\/course\/view\.php.*([\?\&]id=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreSiteHomeIndexLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.loginHelper.redirect('CoreSiteHomeIndexPage', undefined, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreSiteHomeIndexLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        var _this = this;
        courseId = parseInt(params.id, 10);
        if (!courseId) {
            return false;
        }
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (courseId != site.getSiteHomeId()) {
                // The course is not site home.
                return false;
            }
            return _this.siteHomeProvider.isAvailable(siteId).then(function () {
                return true;
            }).catch(function () {
                return false;
            });
        });
    };
    CoreSiteHomeIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_4__sitehome__["a" /* CoreSiteHomeProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], CoreSiteHomeIndexLinkHandler);
    return CoreSiteHomeIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1459 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserProfileMailHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Profile links email handler.
 */
var CoreUserProfileMailHandler = /** @class */ (function () {
    function CoreUserProfileMailHandler(sitesProvider, utils) {
        this.sitesProvider = sitesProvider;
        this.utils = utils;
        this.name = 'CoreUserProfileMail';
        this.priority = 700;
        this.type = __WEBPACK_IMPORTED_MODULE_1__user_delegate__["a" /* CoreUserDelegate */].TYPE_COMMUNICATION;
    }
    /**
     * Check if handler is enabled.
     *
     * @return {boolean} Always enabled.
     */
    CoreUserProfileMailHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user     User to check.
     * @param {number} courseId Course ID.
     * @param  {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param  {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return  {boolean|Promise<boolean>}   Promise resolved with true if enabled, resolved with false otherwise.
     */
    CoreUserProfileMailHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        // Not current user required.
        return user.id != this.sitesProvider.getCurrentSite().getUserId() && !!user.email;
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    CoreUserProfileMailHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        return {
            icon: 'mail',
            title: 'core.user.sendemail',
            class: 'core-user-profile-mail',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                _this.utils.openInBrowser('mailto:' + user.email);
            }
        };
    };
    CoreUserProfileMailHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], CoreUserProfileMailHandler);
    return CoreUserProfileMailHandler;
}());

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1460 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserProfileLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to user profiles.
 */
var CoreUserProfileLinkHandler = /** @class */ (function (_super) {
    __extends(CoreUserProfileLinkHandler, _super);
    function CoreUserProfileLinkHandler(linkHelper) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.name = 'CoreUserProfileLinkHandler';
        // Match user/view.php and user/profile.php but NOT grade/report/user/.
        _this.pattern = /((\/user\/view\.php)|(\/user\/profile\.php)).*([\?\&]id=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreUserProfileLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var pageParams = {
                        courseId: params.course,
                        userId: parseInt(params.id, 10)
                    };
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, 'CoreUserProfilePage', pageParams, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreUserProfileLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return url.indexOf('/grade/report/') == -1;
    };
    CoreUserProfileLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], CoreUserProfileLinkHandler);
    return CoreUserProfileLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=user-link-handler.js.map

/***/ }),
/* 1461 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserParticipantsCourseOptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_participants_participants__ = __webpack_require__(795);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Course nav handler.
 */
var CoreUserParticipantsCourseOptionHandler = /** @class */ (function () {
    function CoreUserParticipantsCourseOptionHandler(userProvider) {
        this.userProvider = userProvider;
        this.name = 'CoreUserParticipants';
        this.priority = 600;
    }
    /**
     * Should invalidate the data to determine if the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUserParticipantsCourseOptionHandler.prototype.invalidateEnabledForCourse = function (courseId, navOptions, admOptions) {
        if (navOptions && typeof navOptions.participants != 'undefined') {
            // No need to invalidate anything.
            return Promise.resolve();
        }
        return this.userProvider.invalidateParticipantsList(courseId);
    };
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    CoreUserParticipantsCourseOptionHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether or not the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreUserParticipantsCourseOptionHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        if (accessData && accessData.type == __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__["a" /* CoreCourseProvider */].ACCESS_GUEST) {
            return false; // Not enabled for guests.
        }
        if (navOptions && typeof navOptions.participants != 'undefined') {
            return navOptions.participants;
        }
        return this.userProvider.isPluginEnabledForCourse(courseId);
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {Injector} injector Injector.
     * @param {number} courseId The course ID.
     * @return {CoreCourseOptionsHandlerData|Promise<CoreCourseOptionsHandlerData>} Data or promise resolved with the data.
     */
    CoreUserParticipantsCourseOptionHandler.prototype.getDisplayData = function (injector, courseId) {
        return {
            title: 'core.user.participants',
            class: 'core-user-participants-handler',
            component: __WEBPACK_IMPORTED_MODULE_3__components_participants_participants__["a" /* CoreUserParticipantsComponent */]
        };
    };
    /**
     * Called when a course is downloaded. It should prefetch all the data to be able to see the addon in offline.
     *
     * @param {any} course The course.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUserParticipantsCourseOptionHandler.prototype.prefetch = function (course) {
        return this.getParticipantsPage(course.id, 0);
    };
    /**
     * Get a participant page and, if there are more participants, call the function again to get it too.
     *
     * @param {number} courseId Course ID.
     * @param {number} limitFrom The number of participants already loaded.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreUserParticipantsCourseOptionHandler.prototype.getParticipantsPage = function (courseId, limitFrom) {
        var _this = this;
        return this.userProvider.getParticipants(courseId, limitFrom, undefined, undefined, true).then(function (result) {
            if (result.canLoadMore) {
                // There are more participants, load the next ones.
                return _this.getParticipantsPage(courseId, limitFrom + result.participants.length);
            }
        });
    };
    CoreUserParticipantsCourseOptionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__user__["a" /* CoreUserProvider */]])
    ], CoreUserParticipantsCourseOptionHandler);
    return CoreUserParticipantsCourseOptionHandler;
}());

//# sourceMappingURL=course-option-handler.js.map

/***/ }),
/* 1462 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserParticipantsLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__user__ = __webpack_require__(26);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Handler to treat links to user participants page.
 */
var CoreUserParticipantsLinkHandler = /** @class */ (function (_super) {
    __extends(CoreUserParticipantsLinkHandler, _super);
    function CoreUserParticipantsLinkHandler(userProvider, loginHelper, courseHelper, domUtils, linkHelper) {
        var _this = _super.call(this) || this;
        _this.userProvider = userProvider;
        _this.loginHelper = loginHelper;
        _this.courseHelper = courseHelper;
        _this.domUtils = domUtils;
        _this.linkHelper = linkHelper;
        _this.name = 'CoreUserParticipants';
        _this.featureName = 'CoreCourseOptionsDelegate_CoreUserParticipants';
        _this.pattern = /\/user\/index\.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    CoreUserParticipantsLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = parseInt(params.id, 10) || courseId;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading();
                    _this.courseHelper.getCourse(courseId, siteId).then(function (result) {
                        var params = {
                            course: result.course,
                            selectedTab: 'CoreUserParticipants'
                        };
                        // Always use redirect to make it the new history root (to avoid "loops" in history).
                        return _this.loginHelper.redirect('CoreCourseSectionPage', params, siteId);
                    }).catch(function () {
                        // Cannot get course for some reason, just open the participants page.
                        return _this.linkHelper.goInSite(navCtrl, 'CoreUserParticipantsPage', { courseId: courseId }, siteId);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    CoreUserParticipantsLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        courseId = parseInt(params.id, 10) || courseId;
        if (!courseId || url.indexOf('/grade/report/') != -1) {
            return false;
        }
        return this.userProvider.isPluginEnabledForCourse(courseId, siteId);
    };
    CoreUserParticipantsLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_3__core_login_providers_helper__["a" /* CoreLoginHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], CoreUserParticipantsLinkHandler);
    return CoreUserParticipantsLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=participants-link-handler.js.map

/***/ }),
/* 1463 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserProfileFieldComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Directive to render user profile field.
 */
var CoreUserProfileFieldComponent = /** @class */ (function () {
    function CoreUserProfileFieldComponent(ufDelegate, utilsProvider, injector) {
        this.ufDelegate = ufDelegate;
        this.utilsProvider = utilsProvider;
        this.injector = injector;
        this.signup = false; // True if editing the field in signup. Defaults to false.
        this.edit = false; // True if editing the field. Defaults to false.
        this.data = {}; // Data to pass to the component.
    }
    /**
     * Component being initialized.
     */
    CoreUserProfileFieldComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.ufDelegate.getComponent(this.injector, this.field, this.signup).then(function (component) {
            _this.componentClass = component;
        });
        this.data.field = this.field;
        this.data.edit = this.utilsProvider.isTrueOrOne(this.edit);
        if (this.edit) {
            this.data.signup = this.utilsProvider.isTrueOrOne(this.signup);
            this.data.disabled = this.utilsProvider.isTrueOrOne(this.field.locked);
            this.data.form = this.form;
            this.data.registerAuth = this.registerAuth;
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreUserProfileFieldComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreUserProfileFieldComponent.prototype, "signup", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreUserProfileFieldComponent.prototype, "edit", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreUserProfileFieldComponent.prototype, "form", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreUserProfileFieldComponent.prototype, "registerAuth", void 0);
    CoreUserProfileFieldComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-user-profile-field',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\user\components\user-profile-field\core-user-profile-field.html"*/'<core-dynamic-component [component]="componentClass" [data]="data"></core-dynamic-component>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\user\components\user-profile-field\core-user-profile-field.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"]])
    ], CoreUserProfileFieldComponent);
    return CoreUserProfileFieldComponent;
}());

//# sourceMappingURL=user-profile-field.js.map

/***/ }),
/* 1464 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreUserSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(796);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var CoreUserSyncCronHandler = /** @class */ (function () {
    function CoreUserSyncCronHandler(userSync) {
        this.userSync = userSync;
        this.name = 'CoreUserSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>} Promise resolved when done, rejected if failure.
     */
    CoreUserSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.userSync.syncPreferences(siteId);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    CoreUserSyncCronHandler.prototype.getInterval = function () {
        return 300000; // 5 minutes.
    };
    CoreUserSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* CoreUserSyncProvider */]])
    ], CoreUserSyncCronHandler);
    return CoreUserSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1465 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CorePushNotificationsRegisterCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__pushnotifications__ = __webpack_require__(86);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Cron handler to force a register on a Moodle site when a site is manually synchronized.
 */
var CorePushNotificationsRegisterCronHandler = /** @class */ (function () {
    function CorePushNotificationsRegisterCronHandler(pushNotificationsProvider) {
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.name = 'CorePushNotificationsRegisterCronHandler';
    }
    /**
     * Check whether the sync can be executed manually. Call isSync if not defined.
     *
     * @return {boolean} Whether the sync can be executed manually.
     */
    CorePushNotificationsRegisterCronHandler.prototype.canManualSync = function () {
        return true; // Execute the handler when the site is manually synchronized.
    };
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    CorePushNotificationsRegisterCronHandler.prototype.execute = function (siteId) {
        if (!siteId || !this.pushNotificationsProvider.canRegisterOnMoodle()) {
            // It's not a specific site, don't do anything.
            return Promise.resolve();
        }
        // Register the device again.
        return this.pushNotificationsProvider.registerDeviceOnMoodle(siteId, true);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    CorePushNotificationsRegisterCronHandler.prototype.getInterval = function () {
        return 86400000; // 1 day. We won't do anything with automatic execution, so use a big number.
    };
    /**
     * Check whether it's a synchronization process or not. True if not defined.
     *
     * @return {boolean} Whether it's a synchronization process or not.
     */
    CorePushNotificationsRegisterCronHandler.prototype.isSync = function () {
        return false;
    };
    CorePushNotificationsRegisterCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], CorePushNotificationsRegisterCronHandler);
    return CorePushNotificationsRegisterCronHandler;
}());

//# sourceMappingURL=register-cron-handler.js.map

/***/ }),
/* 1466 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CorePushNotificationsUnregisterCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__pushnotifications__ = __webpack_require__(86);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Cron handler to retry pending unregisters.
 */
var CorePushNotificationsUnregisterCronHandler = /** @class */ (function () {
    function CorePushNotificationsUnregisterCronHandler(pushNotificationsProvider) {
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.name = 'CorePushNotificationsUnregisterCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @return {Promise<any>} Promise resolved when done, rejected if failure.
     */
    CorePushNotificationsUnregisterCronHandler.prototype.execute = function (siteId) {
        return this.pushNotificationsProvider.retryUnregisters(siteId);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    CorePushNotificationsUnregisterCronHandler.prototype.getInterval = function () {
        return 300000;
    };
    CorePushNotificationsUnregisterCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__pushnotifications__["a" /* CorePushNotificationsProvider */]])
    ], CorePushNotificationsUnregisterCronHandler);
    return CorePushNotificationsUnregisterCronHandler;
}());

//# sourceMappingURL=unregister-cron-handler.js.map

/***/ }),
/* 1467 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return BadgeMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Emulates the Cordova Push plugin in desktop apps and in browser.
 */
var BadgeMock = /** @class */ (function () {
    function BadgeMock(appProvider) {
        this.appProvider = appProvider;
    }
    /**
     * Clear the badge of the app icon.
     *
     * @returns {Promise<boolean>}
     */
    BadgeMock.prototype.clear = function () {
        return Promise.reject('clear is only supported in mobile devices');
    };
    /**
     * Set the badge of the app icon.
     * @param {number} badgeNumber  The new badge number.
     * @returns {Promise<any>}
     */
    BadgeMock.prototype.set = function (badgeNumber) {
        if (!this.appProvider.isDesktop()) {
            return Promise.reject('set is not supported in browser');
        }
        try {
            var app = __webpack_require__(70).remote.app;
            if (app.setBadgeCount(badgeNumber)) {
                return Promise.resolve();
            }
            else {
                return Promise.reject(null);
            }
        }
        catch (ex) {
            return Promise.reject(ex);
        }
    };
    /**
     * Get the badge of the app icon.
     *
     * @returns {Promise<any>}
     */
    BadgeMock.prototype.get = function () {
        if (!this.appProvider.isDesktop()) {
            return Promise.reject('get is not supported in browser');
        }
        try {
            var app = __webpack_require__(70).remote.app;
            return Promise.resolve(app.getBadgeCount());
        }
        catch (ex) {
            return Promise.reject(ex);
        }
    };
    /**
     * Increase the badge number.
     *
     * @param {number} increaseBy  Count to add to the current badge number
     * @returns {Promise<any>}
     */
    BadgeMock.prototype.increase = function (increaseBy) {
        return Promise.reject('increase is only supported in mobile devices');
    };
    /**
     * Decrease the badge number.
     *
     * @param {number} decreaseBy  Count to subtract from the current badge number
     * @returns {Promise<any>}
     */
    BadgeMock.prototype.decrease = function (decreaseBy) {
        return Promise.reject('decrease is only supported in mobile devices');
    };
    /**
     * Check support to show badges.
     *
     * @returns {Promise<any>}
     */
    BadgeMock.prototype.isSupported = function () {
        return Promise.reject('isSupported is only supported in mobile devices');
    };
    /**
     * Determine if the app has permission to show badges.
     *
     * @returns {Promise<any>}
     */
    BadgeMock.prototype.hasPermission = function () {
        return Promise.reject('hasPermission is only supported in mobile devices');
    };
    /**
     * Register permission to set badge notifications
     *
     * @returns {Promise<any>}
     */
    BadgeMock.prototype.requestPermission = function () {
        return Promise.reject('requestPermission is only supported in mobile devices');
    };
    BadgeMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */]])
    ], BadgeMock);
    return BadgeMock;
}());

//# sourceMappingURL=badge.js.map

/***/ }),
/* 1468 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CameraMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_camera__ = __webpack_require__(256);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__capture_helper__ = __webpack_require__(258);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Emulates the Cordova Camera plugin in desktop apps and in browser.
 */
var CameraMock = /** @class */ (function (_super) {
    __extends(CameraMock, _super);
    function CameraMock(captureHelper) {
        var _this = _super.call(this) || this;
        _this.captureHelper = captureHelper;
        return _this;
    }
    /**
     * Remove intermediate image files that are kept in temporary storage after calling camera.getPicture.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    CameraMock.prototype.cleanup = function () {
        // This function is iOS only, nothing to do.
        return Promise.resolve();
    };
    /**
     * Take a picture.
     *
     * @param {CameraOptions} options Options that you want to pass to the camera.
     * @return {Promise<any>} Promise resolved when captured.
     */
    CameraMock.prototype.getPicture = function (options) {
        return this.captureHelper.captureMedia('image', options);
    };
    CameraMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__capture_helper__["a" /* CoreEmulatorCaptureHelperProvider */]])
    ], CameraMock);
    return CameraMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_camera__["a" /* Camera */]));

//# sourceMappingURL=camera.js.map

/***/ }),
/* 1469 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ClipboardMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_clipboard__ = __webpack_require__(343);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Emulates the Cordova Clipboard plugin in desktop apps and in browser.
 */
var ClipboardMock = /** @class */ (function (_super) {
    __extends(ClipboardMock, _super);
    function ClipboardMock(appProvider) {
        var _this = _super.call(this) || this;
        _this.isDesktop = appProvider.isDesktop();
        if (_this.isDesktop) {
            _this.clipboard = __webpack_require__(70).clipboard;
        }
        else {
            // In browser the text must be selected in order to copy it. Create a hidden textarea to put the text in it.
            _this.copyTextarea = document.createElement('textarea');
            _this.copyTextarea.className = 'core-browser-copy-area';
            _this.copyTextarea.setAttribute('aria-hidden', 'true');
            document.body.appendChild(_this.copyTextarea);
        }
        return _this;
    }
    /**
     * Copy some text to the clipboard.
     *
     * @param {string} text The text to copy.
     * @return {Promise<any>} Promise resolved when copied.
     */
    ClipboardMock.prototype.copy = function (text) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (_this.isDesktop) {
                _this.clipboard.writeText(text);
                resolve();
            }
            else {
                // Put the text in the hidden textarea and select it.
                _this.copyTextarea.innerHTML = text;
                _this.copyTextarea.select();
                try {
                    if (document.execCommand('copy')) {
                        resolve();
                    }
                    else {
                        reject();
                    }
                }
                catch (err) {
                    reject();
                }
                _this.copyTextarea.innerHTML = '';
            }
        });
    };
    /*
     * Get the text stored in the clipboard.
     *
     * @return {Promise<any>} Promise resolved with the text.
     */
    ClipboardMock.prototype.paste = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (_this.isDesktop) {
                resolve(_this.clipboard.readText());
            }
            else {
                // Paste the text in the hidden textarea and get it.
                _this.copyTextarea.innerHTML = '';
                _this.copyTextarea.select();
                try {
                    if (document.execCommand('paste')) {
                        resolve(_this.copyTextarea.innerHTML);
                    }
                    else {
                        reject();
                    }
                }
                catch (err) {
                    reject();
                }
                _this.copyTextarea.innerHTML = '';
            }
        });
    };
    ClipboardMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */]])
    ], ClipboardMock);
    return ClipboardMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_clipboard__["a" /* Clipboard */]));

//# sourceMappingURL=clipboard.js.map

/***/ }),
/* 1470 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FileMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_file__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_filesystem__ = __webpack_require__(1471);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Emulates the Cordova File plugin in desktop apps and in browser.
 * Most of the code is extracted from the File class of Ionic Native.
 */
var FileMock = /** @class */ (function (_super) {
    __extends(FileMock, _super);
    function FileMock(appProvider, textUtils, mimeUtils) {
        var _this = _super.call(this) || this;
        _this.appProvider = appProvider;
        _this.textUtils = textUtils;
        _this.mimeUtils = mimeUtils;
        return _this;
    }
    /**
     * Check if a directory exists in a certain path, directory.
     *
     * @param {string} path Base FileSystem.
     * @param {string} dir Name of directory to check
     * @returns {Promise<boolean>} Returns a Promise that resolves to true if the directory exists or rejects with an error.
     */
    FileMock.prototype.checkDir = function (path, dir) {
        var fullPath = this.textUtils.concatenatePaths(path, dir);
        return this.resolveDirectoryUrl(fullPath).then(function () {
            return true;
        });
    };
    /**
     * Check if a file exists in a certain path, directory.
     *
     * @param {string} path Base FileSystem.
     * @param {string} file Name of file to check.
     * @returns {Promise<boolean>} Returns a Promise that resolves with a boolean or rejects with an error.
     */
    FileMock.prototype.checkFile = function (path, file) {
        return this.resolveLocalFilesystemUrl(this.textUtils.concatenatePaths(path, file)).then(function (fse) {
            if (fse.isFile) {
                return true;
            }
            else {
                var err = new __WEBPACK_IMPORTED_MODULE_1__ionic_native_file__["FileError"](13);
                err.message = 'input is not a file';
                return Promise.reject(err);
            }
        });
    };
    /**
     * Copy a file or directory.
     *
     * @param {Entry} srce The Entry to copy.
     * @param {DirectoryEntry} destDir The directory where to put the copy.
     * @param {string} newName New name of the file/dir.
     * @returns {Promise<Entry>} Returns a Promise that resolves to the new Entry object or rejects with an error.
     */
    FileMock.prototype.copyMock = function (srce, destDir, newName) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            newName = newName.replace(/%20/g, ' '); // Replace all %20 with spaces.
            srce.copyTo(destDir, newName, function (deste) {
                resolve(deste);
            }, function (err) {
                _this.fillErrorMessageMock(err);
                reject(err);
            });
        });
    };
    /**
     * Copy a directory in various methods. If destination directory exists, will fail to copy.
     *
     * @param {string} path Base FileSystem. Please refer to the iOS and Android filesystems above.
     * @param {string} dirName Name of directory to copy.
     * @param {string} newPath Base FileSystem of new location.
     * @param {string} newDirName New name of directory to copy to (leave blank to remain the same).
     * @returns {Promise<Entry>} Returns a Promise that resolves to the new Entry object or rejects with an error.
     */
    FileMock.prototype.copyDir = function (path, dirName, newPath, newDirName) {
        var _this = this;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getDirectory(fse, dirName, { create: false });
        }).then(function (srcde) {
            return _this.resolveDirectoryUrl(newPath).then(function (deste) {
                return _this.copyMock(srcde, deste, newDirName);
            });
        });
    };
    /**
     * Copy a file in various methods. If file exists, will fail to copy.
     *
     * @param {string} path Base FileSystem. Please refer to the iOS and Android filesystems above
     * @param {string} fileName Name of file to copy
     * @param {string} newPath Base FileSystem of new location
     * @param {string} newFileName New name of file to copy to (leave blank to remain the same)
     * @returns {Promise<Entry>} Returns a Promise that resolves to an Entry or rejects with an error.
     */
    FileMock.prototype.copyFile = function (path, fileName, newPath, newFileName) {
        var _this = this;
        newFileName = newFileName || fileName;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getFile(fse, fileName, { create: false });
        }).then(function (srcfe) {
            return _this.resolveDirectoryUrl(newPath).then(function (deste) {
                return _this.copyMock(srcfe, deste, newFileName);
            });
        });
    };
    /**
     * Creates a new directory in the specific path.
     * The replace boolean value determines whether to replace an existing directory with the same name.
     * If an existing directory exists and the replace value is false, the promise will fail and return an error.
     *
     * @param {string} path Base FileSystem.
     * @param {string} dirName Name of directory to create
     * @param {boolean} replace If true, replaces file with same name. If false returns error
     * @returns {Promise<DirectoryEntry>} Returns a Promise that resolves with a DirectoryEntry or rejects with an error.
     */
    FileMock.prototype.createDir = function (path, dirName, replace) {
        var _this = this;
        var options = {
            create: true
        };
        if (!replace) {
            options.exclusive = true;
        }
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getDirectory(fse, dirName, options);
        });
    };
    /**
     * Creates a new file in the specific path.
     * The replace boolean value determines whether to replace an existing file with the same name.
     * If an existing file exists and the replace value is false, the promise will fail and return an error.
     *
     * @param {string} path  Base FileSystem.
     * @param {string} fileName Name of file to create.
     * @param {boolean} replace If true, replaces file with same name. If false returns error.
     * @returns {Promise<FileEntry>} Returns a Promise that resolves to a FileEntry or rejects with an error.
     */
    FileMock.prototype.createFile = function (path, fileName, replace) {
        var _this = this;
        var options = {
            create: true
        };
        if (!replace) {
            options.exclusive = true;
        }
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getFile(fse, fileName, options);
        });
    };
    /**
     * Create a file writer for a certain file.
     *
     * @param {FileEntry} fe File entry object.
     * @returns {Promise<FileWriter>} Promise resolved with the FileWriter.
     */
    FileMock.prototype.createWriterMock = function (fe) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            fe.createWriter(function (writer) {
                resolve(writer);
            }, function (err) {
                _this.fillErrorMessageMock(err);
                reject(err);
            });
        });
    };
    /**
     * Emulate Cordova file plugin using NodeJS functions. This is only for NodeJS environments,
     * browser works with the default resolveLocalFileSystemURL.
     *
     * @param {any} fs Node module 'fs'.
     */
    FileMock.prototype.emulateCordovaFileForDesktop = function (fs) {
        var _this = this;
        if (!this.appProvider.isDesktop()) {
            return;
        }
        // Implement resolveLocalFileSystemURL.
        window.resolveLocalFileSystemURL = function (path, successCallback, errorCallback) {
            // Check that the file/dir exists.
            fs.stat(path, function (err, stats) {
                if (err) {
                    errorCallback && errorCallback(err);
                }
                else {
                    // The file/dir exists, return an instance.
                    var constructor = stats.isDirectory() ? __WEBPACK_IMPORTED_MODULE_6__classes_filesystem__["a" /* DirectoryEntryMock */] : __WEBPACK_IMPORTED_MODULE_6__classes_filesystem__["b" /* FileEntryMock */], fileName = path.substr(path.lastIndexOf('/') + 1);
                    successCallback && successCallback(new constructor(_this.textUtils, _this.mimeUtils, fileName, path));
                }
            });
        };
    };
    /**
     * Fill the message for an error.
     *
     * @param {any} err Error.
     */
    FileMock.prototype.fillErrorMessageMock = function (err) {
        try {
            err.message = this.cordovaFileError[err.code];
        }
        catch (e) {
            // Ignore errors.
        }
    };
    /**
     * Get a directory.
     *
     * @param directoryEntry {DirectoryEntry} Directory entry, obtained by resolveDirectoryUrl method
     * @param directoryName {string} Directory name
     * @param flags {Flags} Options
     * @returns {Promise<DirectoryEntry>}
     */
    FileMock.prototype.getDirectory = function (directoryEntry, directoryName, flags) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            try {
                directoryName = directoryName.replace(/%20/g, ' '); // Replace all %20 with spaces.
                directoryEntry.getDirectory(directoryName, flags, function (de) {
                    resolve(de);
                }, function (err) {
                    _this.fillErrorMessageMock(err);
                    reject(err);
                });
            }
            catch (xc) {
                _this.fillErrorMessageMock(xc);
                reject(xc);
            }
        });
    };
    /**
     * Get a file
     * @param directoryEntry {DirectoryEntry} Directory entry, obtained by resolveDirectoryUrl method
     * @param fileName {string} File name
     * @param flags {Flags} Options
     * @returns {Promise<FileEntry>}
     */
    FileMock.prototype.getFile = function (directoryEntry, fileName, flags) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            try {
                fileName = fileName.replace(/%20/g, ' '); // Replace all %20 with spaces.
                directoryEntry.getFile(fileName, flags, resolve, function (err) {
                    _this.fillErrorMessageMock(err);
                    reject(err);
                });
            }
            catch (xc) {
                _this.fillErrorMessageMock(xc);
                reject(xc);
            }
        });
    };
    /**
     * Get free disk space.
     *
     * @return {Promise<number>} Promise resolved with the free space.
     */
    FileMock.prototype.getFreeDiskSpace = function () {
        // FRequest a file system instance with a minimum size until we get an error.
        if (window.requestFileSystem) {
            return new Promise(function (resolve, reject) {
                var iterations = 0, maxIterations = 50;
                var calculateByRequest = function (size, ratio) {
                    return new Promise(function (resolve, reject) {
                        window.requestFileSystem(LocalFileSystem.PERSISTENT, size, function () {
                            iterations++;
                            if (iterations > maxIterations) {
                                resolve(size);
                                return;
                            }
                            calculateByRequest(size * ratio, ratio).then(resolve);
                        }, function () {
                            resolve(size / ratio);
                        });
                    });
                };
                // General calculation, base 1MB and increasing factor 1.3.
                calculateByRequest(1048576, 1.3).then(function (size) {
                    iterations = 0;
                    maxIterations = 10;
                    // More accurate. Factor is 1.1.
                    calculateByRequest(size, 1.1).then(function (size) {
                        resolve(size / 1024); // Return size in KB.
                    });
                });
            });
        }
        else {
            return Promise.reject(null);
        }
    };
    /**
     * List files and directory from a given path.
     *
     * @param {string} path Base FileSystem. Please refer to the iOS and Android filesystems above
     * @param {string} dirName Name of directory
     * @returns {Promise<Entry[]>} Returns a Promise that resolves to an array of Entry objects or rejects with an error.
     */
    FileMock.prototype.listDir = function (path, dirName) {
        var _this = this;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getDirectory(fse, dirName, { create: false, exclusive: false });
        }).then(function (de) {
            var reader = de.createReader();
            return _this.readEntriesMock(reader);
        });
    };
    /**
     * Loads an initialize the API for browser and desktop.
     *
     * @return {Promise<any>} Promise resolved when loaded.
     */
    FileMock.prototype.load = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var win = window; // Convert to <any> to be able to use non-standard properties.
            var basePath;
            if (typeof win.requestFileSystem == 'undefined') {
                win.requestFileSystem = win.webkitRequestFileSystem;
            }
            if (typeof win.resolveLocalFileSystemURL == 'undefined') {
                win.resolveLocalFileSystemURL = win.webkitResolveLocalFileSystemURL;
            }
            win.LocalFileSystem = {
                PERSISTENT: 1
            };
            if (_this.appProvider.isDesktop()) {
                var fs = __webpack_require__(263), app = __webpack_require__(70).remote.app;
                _this.emulateCordovaFileForDesktop(fs);
                // Initialize File System. Get the path to use.
                basePath = app.getPath('documents') || app.getPath('home');
                if (!basePath) {
                    reject('Cannot calculate base path for file system.');
                    return;
                }
                basePath = _this.textUtils.concatenatePaths(basePath.replace(/\\/g, '/'), __WEBPACK_IMPORTED_MODULE_5__configconstants__["a" /* CoreConfigConstants */].app_id) + '/';
                // Create the folder if needed.
                fs.mkdir(basePath, function (e) {
                    if (!e || (e && e.code === 'EEXIST')) {
                        // Create successful or it already exists. Resolve.
                        resolve(basePath);
                    }
                    else {
                        reject('Error creating base path.');
                    }
                });
            }
            else {
                // It's browser, request a quota to use. Request 500MB.
                navigator.webkitPersistentStorage.requestQuota(500 * 1024 * 1024, function (granted) {
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, granted, function (entry) {
                        basePath = entry.root.toURL();
                        resolve(basePath);
                    }, reject);
                }, reject);
            }
        });
    };
    /**
     * Move a file or directory.
     *
     * @param {Entry} srce The Entry to copy.
     * @param {DirectoryEntry} destDir The directory where to move the file/dir.
     * @param {string} newName New name of the file/dir.
     * @returns {Promise<Entry>} Returns a Promise that resolves to the new Entry object or rejects with an error.
     */
    FileMock.prototype.moveMock = function (srce, destDir, newName) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            newName = newName.replace(/%20/g, ' '); // Replace all %20 with spaces.
            srce.moveTo(destDir, newName, function (deste) {
                resolve(deste);
            }, function (err) {
                _this.fillErrorMessageMock(err);
                reject(err);
            });
        });
    };
    /**
     * Move a directory to a given path.
     *
     * @param {string} path The source path to the directory.
     * @param {string} dirName The source directory name.
     * @param {string} newPath The destionation path to the directory.
     * @param {string} newDirName The destination directory name.
     * @returns {Promise<DirectoryEntry|Entry>} Returns a Promise that resolves to the new DirectoryEntry object or rejects with
     *                                          an error.
     */
    FileMock.prototype.moveDir = function (path, dirName, newPath, newDirName) {
        var _this = this;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getDirectory(fse, dirName, { create: false });
        }).then(function (srcde) {
            return _this.resolveDirectoryUrl(newPath).then(function (deste) {
                return _this.moveMock(srcde, deste, newDirName);
            });
        });
    };
    /**
     * Move a file to a given path.
     *
     * @param {string} path Base FileSystem. Please refer to the iOS and Android filesystems above
     * @param {string} fileName Name of file to move
     * @param {string} newPath Base FileSystem of new location
     * @param {string} newFileName New name of file to move to (leave blank to remain the same)
     * @returns {Promise<Entry>} Returns a Promise that resolves to the new Entry or rejects with an error.
     */
    FileMock.prototype.moveFile = function (path, fileName, newPath, newFileName) {
        var _this = this;
        newFileName = newFileName || fileName;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getFile(fse, fileName, { create: false });
        }).then(function (srcfe) {
            return _this.resolveDirectoryUrl(newPath).then(function (deste) {
                return _this.moveMock(srcfe, deste, newFileName);
            });
        });
    };
    /**
     * Read file and return data as an ArrayBuffer.
     * @param {string} path Base FileSystem.
     * @param {string} file Name of file, relative to path.
     * @returns {Promise<ArrayBuffer>} Returns a Promise that resolves with the contents of the file as ArrayBuffer or rejects
     *                                 with an error.
     */
    FileMock.prototype.readAsArrayBuffer = function (path, file) {
        return this.readFileMock(path, file, 'ArrayBuffer');
    };
    /**
     * Read file and return data as a binary data.
     * @param {string} path Base FileSystem.
     * @param {string} file Name of file, relative to path.
     * @returns {Promise<string>} Returns a Promise that resolves with the contents of the file as string rejects with an error.
     */
    FileMock.prototype.readAsBinaryString = function (path, file) {
        return this.readFileMock(path, file, 'BinaryString');
    };
    /**
     * Read file and return data as a base64 encoded data url.
     * A data url is of the form:
     *      data: [<mediatype>][;base64],<data>
     * @param {string} path Base FileSystem.
     * @param {string} file Name of file, relative to path.
     * @returns {Promise<string>} Returns a Promise that resolves with the contents of the file as data URL or rejects
     *                            with an error.
     */
    FileMock.prototype.readAsDataURL = function (path, file) {
        return this.readFileMock(path, file, 'DataURL');
    };
    /**
     * Read the contents of a file as text.
     *
     * @param {string} path Base FileSystem.
     * @param {string} file Name of file, relative to path.
     * @returns {Promise<string>} Returns a Promise that resolves with the contents of the file as string or rejects with an error.
     */
    FileMock.prototype.readAsText = function (path, file) {
        return this.readFileMock(path, file, 'Text');
    };
    /**
     * Read all the files and directories inside a directory.
     *
     * @param {DirectoryReader} dr The directory reader.
     * @return {Promise<Entry[]>} Promise resolved with the list of files/dirs.
     */
    FileMock.prototype.readEntriesMock = function (dr) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            dr.readEntries(function (entries) {
                resolve(entries);
            }, function (err) {
                _this.fillErrorMessageMock(err);
                reject(err);
            });
        });
    };
    /**
     * Read the contents of a file.
     *
     * @param {string} path Base FileSystem.
     * @param {string} file Name of file, relative to path.
     * @param {string} readAs Format to read as.
     * @returns {Promise<string>} Returns a Promise that resolves with the contents of the file or rejects with an error.
     */
    FileMock.prototype.readFileMock = function (path, file, readAs) {
        var _this = this;
        return this.resolveDirectoryUrl(path).then(function (directoryEntry) {
            return _this.getFile(directoryEntry, file, { create: false });
        }).then(function (fileEntry) {
            var reader = new FileReader();
            return new Promise(function (resolve, reject) {
                reader.onloadend = function () {
                    if (reader.result !== undefined || reader.result !== null) {
                        resolve(reader.result);
                    }
                    else if (reader.error !== undefined || reader.error !== null) {
                        reject(reader.error);
                    }
                    else {
                        reject({ code: null, message: 'READER_ONLOADEND_ERR' });
                    }
                };
                fileEntry.file(function (file) {
                    reader["readAs" + readAs].call(reader, file);
                }, function (error) {
                    reject(error);
                });
            });
        });
    };
    /**
     * Delete a file.
     *
     * @param {Entry} fe The file to remove.
     * @return {Promise<any>} Promise resolved when done.
     */
    FileMock.prototype.removeMock = function (fe) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            fe.remove(function () {
                resolve({ success: true, fileRemoved: fe });
            }, function (err) {
                _this.fillErrorMessageMock(err);
                reject(err);
            });
        });
    };
    /**
     * Remove a directory at a given path.
     *
     * @param {string} path The path to the directory.
     * @param {string} dirName The directory name.
     * @returns {Promise<RemoveResult>} Returns a Promise that resolves to a RemoveResult or rejects with an error.
     */
    FileMock.prototype.removeDir = function (path, dirName) {
        var _this = this;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getDirectory(fse, dirName, { create: false });
        }).then(function (de) {
            return _this.removeMock(de);
        });
    };
    /**
     * Removes a file from a desired location.
     *
     * @param {string} path  Base FileSystem.
     * @param {string} fileName Name of file to remove.
     * @returns {Promise<RemoveResult>} Returns a Promise that resolves to a RemoveResult or rejects with an error.
     */
    FileMock.prototype.removeFile = function (path, fileName) {
        var _this = this;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getFile(fse, fileName, { create: false });
        }).then(function (fe) {
            return _this.removeMock(fe);
        });
    };
    /**
     * Removes all files and the directory from a desired location.
     *
     * @param {string} path Base FileSystem. Please refer to the iOS and Android filesystems above
     * @param {string} dirName Name of directory
     * @returns {Promise<RemoveResult>} Returns a Promise that resolves with a RemoveResult or rejects with an error.
     */
    FileMock.prototype.removeRecursively = function (path, dirName) {
        var _this = this;
        return this.resolveDirectoryUrl(path).then(function (fse) {
            return _this.getDirectory(fse, dirName, { create: false });
        }).then(function (de) {
            return _this.rimrafMock(de);
        });
    };
    /**
     * Resolves a local directory url
     * @param directoryUrl {string} directory system url
     * @returns {Promise<DirectoryEntry>}
     */
    FileMock.prototype.resolveDirectoryUrl = function (directoryUrl) {
        return this.resolveLocalFilesystemUrl(directoryUrl).then(function (de) {
            if (de.isDirectory) {
                return de;
            }
            else {
                var err = new __WEBPACK_IMPORTED_MODULE_1__ionic_native_file__["FileError"](13);
                err.message = 'input is not a directory';
                return Promise.reject(err);
            }
        });
    };
    /**
     * Resolves a local file system URL
     * @param fileUrl {string} file system url
     * @returns {Promise<Entry>}
     */
    FileMock.prototype.resolveLocalFilesystemUrl = function (fileUrl) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            try {
                window.resolveLocalFileSystemURL(fileUrl, function (entry) {
                    resolve(entry);
                }, function (err) {
                    _this.fillErrorMessageMock(err);
                    reject(err);
                });
            }
            catch (xc) {
                _this.fillErrorMessageMock(xc);
                reject(xc);
            }
        });
    };
    /**
     * Remove a directory and all its contents.
     *
     * @param {DirectoryEntry} de Directory to remove.
     * @return {Promise<any>} Promise resolved when done.
     */
    FileMock.prototype.rimrafMock = function (de) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            de.removeRecursively(function () {
                resolve({ success: true, fileRemoved: de });
            }, function (err) {
                _this.fillErrorMessageMock(err);
                reject(err);
            });
        });
    };
    /**
     * Write some data in a file.
     *
     * @param {FileWriter} writer File writer.
     * @param {any} data The data to write.
     * @return {Promise<any>} Promise resolved when done.
     */
    FileMock.prototype.writeMock = function (writer, data) {
        if (data instanceof Blob) {
            return this.writeFileInChunksMock(writer, data);
        }
        return new Promise(function (resolve, reject) {
            writer.onwriteend = function (evt) {
                if (writer.error) {
                    reject(writer.error);
                }
                else {
                    resolve(evt);
                }
            };
            writer.write(data);
        });
    };
    /**
     * Write to an existing file.
     *
     * @param {string} path Base FileSystem.
     * @param {string} fileName path relative to base path.
     * @param {string | Blob} text content or blob to write.
     * @returns {Promise<void>} Returns a Promise that resolves or rejects with an error.
     */
    FileMock.prototype.writeExistingFile = function (path, fileName, text) {
        return this.writeFile(path, fileName, text, { replace: true });
    };
    /**
     * Write a new file to the desired location.
     *
     * @param {string} path Base FileSystem. Please refer to the iOS and Android filesystems above
     * @param {string} fileName path relative to base path
     * @param {string | Blob} text content or blob to write
     * @param {any} options replace file if set to true. See WriteOptions for more information.
     * @returns {Promise<any>} Returns a Promise that resolves to updated file entry or rejects with an error.
     */
    FileMock.prototype.writeFile = function (path, fileName, text, options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        var getFileOpts = {
            create: !options.append,
            exclusive: !options.replace
        };
        return this.resolveDirectoryUrl(path).then(function (directoryEntry) {
            return _this.getFile(directoryEntry, fileName, getFileOpts);
        }).then(function (fileEntry) {
            return _this.writeFileEntryMock(fileEntry, text, options);
        });
    };
    /**
     * Write content to FileEntry.
     *
     * @param {FileEntry} fe File entry object.
     * @param {string | Blob} text Content or blob to write.
     * @param {IWriteOptions} options replace file if set to true. See WriteOptions for more information.
     * @returns {Promise<FileEntry>} Returns a Promise that resolves to updated file entry or rejects with an error.
     */
    FileMock.prototype.writeFileEntryMock = function (fe, text, options) {
        var _this = this;
        return this.createWriterMock(fe).then(function (writer) {
            if (options.append) {
                writer.seek(writer.length);
            }
            if (options.truncate) {
                writer.truncate(options.truncate);
            }
            return _this.writeMock(writer, text);
        }).then(function () { return fe; });
    };
    /**
     * Write a file in chunks.
     *
     * @param {FileWriter} writer File writer.
     * @param {Blob} data Data to write.
     * @return {Promise<any>} Promise resolved when done.
     */
    FileMock.prototype.writeFileInChunksMock = function (writer, data) {
        var writtenSize = 0;
        var BLOCK_SIZE = 1024 * 1024, writeNextChunk = function () {
            var size = Math.min(BLOCK_SIZE, data.size - writtenSize);
            var chunk = data.slice(writtenSize, writtenSize + size);
            writtenSize += size;
            writer.write(chunk);
        };
        return new Promise(function (resolve, reject) {
            writer.onerror = reject;
            writer.onwriteend = function () {
                if (writtenSize < data.size) {
                    writeNextChunk();
                }
                else {
                    resolve();
                }
            };
            writeNextChunk();
        });
    };
    FileMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */]])
    ], FileMock);
    return FileMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_file__["a" /* File */]));

//# sourceMappingURL=file.js.map

/***/ }),
/* 1471 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Buffer) {/* unused harmony export EntryMock */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DirectoryEntryMock; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return FileEntryMock; });
/* unused harmony export DirectoryReaderMock */
/* unused harmony export FileWriterMock */
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * This file includes all the classes needed to emulate file system in NodeJS (desktop apps).
 */
/**
 * Emulate Entry object of the Cordova file plugin using NodeJS functions.
 * It includes fileSystem and nativeURL as the Cordova plugin does, but they aren't used.
 */
var EntryMock = /** @class */ (function () {
    function EntryMock(textUtils, mimeUtils, isFile, isDirectory, name, fullPath, fileSystem, nativeURL) {
        if (name === void 0) { name = ''; }
        if (fullPath === void 0) { fullPath = ''; }
        this.textUtils = textUtils;
        this.mimeUtils = mimeUtils;
        this.isFile = isFile;
        this.isDirectory = isDirectory;
        this.name = name;
        this.fullPath = fullPath;
        this.fileSystem = fileSystem;
        this.nativeURL = nativeURL;
        this.fs = __webpack_require__(263);
    }
    /**
     * Copy the file or directory.
     *
     * @param {Entry} parent The folder where to move the file to.
     * @param {string} newName The new name for the file.
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    EntryMock.prototype.copyTo = function (parent, newName, successCallback, errorCallback) {
        var _this = this;
        newName = newName || this.name;
        // There is no function to copy a file, read the source and write the dest.
        var srcPath = this.fullPath, destPath = this.textUtils.concatenatePaths(parent.fullPath, newName), reader = this.fs.createReadStream(srcPath), writer = this.fs.createWriteStream(destPath);
        // Use a promise to make sure only one callback is called.
        new Promise(function (resolve, reject) {
            reader.on('error', reject);
            writer.on('error', reject);
            writer.on('close', resolve);
            reader.pipe(writer);
        }).then(function () {
            var constructor = _this.isDirectory ? DirectoryEntryMock : FileEntryMock;
            successCallback && successCallback(new constructor(_this.textUtils, _this.mimeUtils, newName, destPath));
        }).catch(function (error) {
            errorCallback && errorCallback(error);
        });
    };
    /**
     * Get the entry's metadata.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    EntryMock.prototype.getMetadata = function (successCallback, errorCallback) {
        this.fs.stat(this.fullPath, function (err, stats) {
            if (err) {
                errorCallback && errorCallback(err);
            }
            else {
                successCallback && successCallback({
                    size: stats.size,
                    modificationTime: stats.mtime
                });
            }
        });
    };
    /**
     * Get the parent directory.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    EntryMock.prototype.getParent = function (successCallback, errorCallback) {
        var _this = this;
        // Remove last slash if present and get the path of the parent.
        var fullPath = this.fullPath.slice(-1) == '/' ? this.fullPath.slice(0, -1) : this.fullPath, parentPath = fullPath.substr(0, fullPath.lastIndexOf('/'));
        // Check that parent exists.
        this.fs.stat(parentPath, function (err, stats) {
            if (err || !stats.isDirectory()) {
                errorCallback && errorCallback(err);
            }
            else {
                var fileName = parentPath.substr(parentPath.lastIndexOf('/') + 1);
                successCallback && successCallback(new DirectoryEntryMock(_this.textUtils, _this.mimeUtils, fileName, parentPath));
            }
        });
    };
    /**
     * Move the file or directory.
     *
     * @param {Entry} parent The folder where to move the file to.
     * @param {string} newName The new name for the file.
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    EntryMock.prototype.moveTo = function (parent, newName, successCallback, errorCallback) {
        var _this = this;
        newName = newName || this.name;
        var srcPath = this.fullPath, destPath = this.textUtils.concatenatePaths(parent.fullPath, newName);
        this.fs.rename(srcPath, destPath, function (err) {
            if (err) {
                errorCallback && errorCallback(err);
            }
            else {
                var constructor = _this.isDirectory ? DirectoryEntryMock : FileEntryMock;
                successCallback && successCallback(new constructor(_this.textUtils, _this.mimeUtils, newName, destPath));
            }
        });
    };
    /**
     * Remove the entry.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    EntryMock.prototype.remove = function (successCallback, errorCallback) {
        var removeFn = this.isDirectory ? this.fs.rmdir : this.fs.unlink;
        removeFn(this.fullPath, function (err) {
            if (err < 0) {
                errorCallback && errorCallback(err);
            }
            else {
                successCallback && successCallback();
            }
        });
    };
    /**
     * Set the entry's metadata.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     * @param {any} metadataObject The metadata to set.
     */
    EntryMock.prototype.setMetadata = function (successCallback, errorCallback, metadataObject) {
        // Not supported.
        errorCallback && errorCallback('Not supported');
    };
    /**
     * Get the internal URL of the Entry.
     *
     * @return {string} Internal URL.
     */
    EntryMock.prototype.toInternalURL = function () {
        return 'file://' + this.fullPath;
    };
    /**
     * Get the URL of the Entry.
     *
     * @return {string} URL.
     */
    EntryMock.prototype.toURL = function () {
        return this.fullPath;
    };
    return EntryMock;
}());

/**
 * Emulate DirectoryEntry object of the Cordova file plugin using NodeJS functions.
 */
var DirectoryEntryMock = /** @class */ (function (_super) {
    __extends(DirectoryEntryMock, _super);
    function DirectoryEntryMock(textUtils, mimeUtils, name, fullPath, fileSystem, nativeURL) {
        if (name === void 0) { name = ''; }
        if (fullPath === void 0) { fullPath = ''; }
        var _this = _super.call(this, textUtils, mimeUtils, false, true, name, fullPath, fileSystem, nativeURL) || this;
        // Add trailing slash if it is missing.
        if ((_this.fullPath) && !/\/$/.test(_this.fullPath)) {
            _this.fullPath += '/';
        }
        if (_this.nativeURL && !/\/$/.test(_this.nativeURL)) {
            _this.nativeURL += '/';
        }
        return _this;
    }
    /**
     * Create reader.
     *
     * @return {DirectoryReader} Reader.
     */
    DirectoryEntryMock.prototype.createReader = function () {
        return new DirectoryReaderMock(this.textUtils, this.mimeUtils, this.fullPath);
    };
    /**
     * Delete an empty folder.
     *
     * @param {string} path Path of the folder.
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    DirectoryEntryMock.prototype.deleteEmptyFolder = function (path, successCallback, errorCallback) {
        this.fs.rmdir(path, function (err) {
            if (err) {
                // Error removing directory.
                errorCallback && errorCallback(err);
            }
            else {
                successCallback && successCallback();
            }
        });
    };
    /**
     * Get a directory inside this directory entry.
     *
     * @param {string} path Path of the dir.
     * @param {any} options Options.
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    DirectoryEntryMock.prototype.getDirectory = function (path, options, successCallback, errorCallback) {
        this.getDirOrFile(true, path, options, successCallback, errorCallback);
    };
    /**
     * Helper function for getDirectory and getFile.
     *
     * @param {boolean} isDir True if getting a directory, false if getting a file.
     * @param {string} path Path of the file or dir.
     * @param {any} options Options.
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    DirectoryEntryMock.prototype.getDirOrFile = function (isDir, path, options, successCallback, errorCallback) {
        var _this = this;
        // Success, return the DirectoryEntry or FileEntry.
        var success = function () {
            var constructor = isDir ? DirectoryEntryMock : FileEntryMock;
            successCallback && successCallback(new constructor(_this.textUtils, _this.mimeUtils, fileName, fileDirPath));
        };
        // Create the file/dir.
        var create = function (done) {
            if (isDir) {
                _this.fs.mkdir(fileDirPath, done);
            }
            else {
                _this.fs.writeFile(fileDirPath, '', done);
            }
        };
        var fileName = path.substr(path.lastIndexOf('/') + 1), fileDirPath = this.textUtils.concatenatePaths(this.fullPath, path);
        // Check if file/dir exists.
        this.fs.stat(fileDirPath, function (err) {
            if (err) {
                if (options.create) {
                    // File/Dir probably doesn't exist, create it.
                    create(function (error2) {
                        if (!error2) {
                            // File created successfully, return it.
                            success();
                        }
                        else if (error2.code === 'EEXIST') {
                            // File exists, success.
                            success();
                        }
                        else if (error2.code === 'ENOENT') {
                            // Seems like the parent doesn't exist, create it too.
                            var parent_1 = fileDirPath.substring(0, fileDirPath.lastIndexOf('/'));
                            if (parent_1) {
                                _this.getDirectory(parent_1, options, function () {
                                    // Parent created, try to create the child again.
                                    create(function (error3) {
                                        if (!error3) {
                                            success();
                                        }
                                        else {
                                            errorCallback && errorCallback(error3);
                                        }
                                    });
                                }, errorCallback);
                            }
                            else {
                                errorCallback && errorCallback(error2);
                            }
                        }
                        else {
                            errorCallback && errorCallback(error2);
                        }
                    });
                }
                else {
                    errorCallback && errorCallback(err);
                }
            }
            else {
                success();
            }
        });
    };
    /**
     * Get a file inside this directory entry.
     *
     * @param {string} path Path of the dir.
     * @param {any} options Options.
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    DirectoryEntryMock.prototype.getFile = function (path, options, successCallback, errorCallback) {
        this.getDirOrFile(false, path, options, successCallback, errorCallback);
    };
    /**
     * Remove the directory and all its contents.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    DirectoryEntryMock.prototype.removeRecursively = function (successCallback, errorCallback) {
        var _this = this;
        // Use a promise to make sure only one callback is called.
        new Promise(function (resolve, reject) {
            _this.removeRecursiveFn(_this.fullPath, resolve, reject);
        }).then(function () {
            successCallback && successCallback();
        }).catch(function (error) {
            errorCallback && errorCallback(error);
        });
    };
    /**
     * Delete a file or folder recursively.
     *
     * @param {string} path Path of the folder.
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    DirectoryEntryMock.prototype.removeRecursiveFn = function (path, successCallback, errorCallback) {
        var _this = this;
        // Check if it exists.
        this.fs.stat(path, function (err, stats) {
            if (err) {
                // File not found, reject.
                errorCallback && errorCallback(err);
            }
            else if (stats.isFile()) {
                // It's a file, remove it.
                _this.fs.unlink(path, function (err) {
                    if (err) {
                        // Error removing file, reject.
                        errorCallback && errorCallback(err);
                    }
                    else {
                        successCallback && successCallback();
                    }
                });
            }
            else {
                // It's a directory, read the contents.
                _this.fs.readdir(path, function (err, files) {
                    if (err) {
                        // Error reading directory contents, reject.
                        errorCallback && errorCallback(err);
                    }
                    else if (!files.length) {
                        // No files to delete, delete the folder.
                        _this.deleteEmptyFolder(path, successCallback, errorCallback);
                    }
                    else {
                        // Remove all the files and directories.
                        var removed_1 = 0;
                        files.forEach(function (filename) {
                            _this.removeRecursiveFn(_this.textUtils.concatenatePaths(path, filename), function () {
                                // Success deleting the file/dir.
                                removed_1++;
                                if (removed_1 == files.length) {
                                    // All files deleted, delete the folder.
                                    _this.deleteEmptyFolder(path, successCallback, errorCallback);
                                }
                            }, errorCallback);
                        });
                    }
                });
            }
        });
    };
    return DirectoryEntryMock;
}(EntryMock));

/**
 * Emulate FileEntry object of the Cordova file plugin using NodeJS functions.
 */
var FileEntryMock = /** @class */ (function (_super) {
    __extends(FileEntryMock, _super);
    function FileEntryMock(textUtils, mimeUtils, name, fullPath, fileSystem, nativeURL) {
        if (name === void 0) { name = ''; }
        if (fullPath === void 0) { fullPath = ''; }
        var _this = _super.call(this, textUtils, mimeUtils, true, false, name, fullPath, fileSystem, nativeURL) || this;
        // Remove trailing slash if it is present.
        if (_this.fullPath && /\/$/.test(_this.fullPath)) {
            _this.fullPath = _this.fullPath.substring(0, _this.fullPath.length - 1);
        }
        if (_this.nativeURL && /\/$/.test(_this.nativeURL)) {
            _this.nativeURL = _this.nativeURL.substring(0, _this.nativeURL.length - 1);
        }
        return _this;
    }
    /**
     * Create writer.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    FileEntryMock.prototype.createWriter = function (successCallback, errorCallback) {
        var _this = this;
        this.file(function (file) {
            successCallback && successCallback(new FileWriterMock(_this.textUtils, _this.mimeUtils, file));
        }, errorCallback);
    };
    /**
     * Get the file data.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    FileEntryMock.prototype.file = function (successCallback, errorCallback) {
        var _this = this;
        // Get the metadata to know the time modified.
        this.getMetadata(function (metadata) {
            // Read the file.
            _this.fs.readFile(_this.fullPath, function (err, data) {
                if (err) {
                    errorCallback && errorCallback(err);
                }
                else {
                    // Create a File instance and return it.
                    data = Uint8Array.from(data).buffer; // Convert the NodeJS Buffer to ArrayBuffer.
                    var file = new File([data], _this.name || '', {
                        lastModified: metadata.modificationTime || null,
                        type: _this.mimeUtils.getMimeType(_this.mimeUtils.getFileExtension(_this.name)) || null
                    });
                    file.localURL = _this.fullPath;
                    file.start = 0;
                    file.end = file.size;
                    successCallback && successCallback(file);
                }
            });
        }, errorCallback);
    };
    return FileEntryMock;
}(EntryMock));

/**
 * Emulate DirectoryReader object of the Cordova file plugin using NodeJS functions.
 */
var DirectoryReaderMock = /** @class */ (function () {
    function DirectoryReaderMock(textUtils, mimeUtils, localURL) {
        if (localURL === void 0) { localURL = null; }
        this.textUtils = textUtils;
        this.mimeUtils = mimeUtils;
        this.localURL = localURL;
        this.fs = __webpack_require__(263);
    }
    /**
     * Read entries inside a folder.
     *
     * @param {Function} successCallback Success callback.
     * @param {Function} errorCallback Error callback.
     */
    DirectoryReaderMock.prototype.readEntries = function (successCallback, errorCallback) {
        var _this = this;
        this.fs.readdir(this.localURL, function (err, files) {
            if (err) {
                errorCallback && errorCallback(err);
            }
            else {
                // Use try/catch because it includes sync calls.
                try {
                    var entries = [];
                    for (var i = 0; i < files.length; i++) {
                        var fileName = files[i], filePath = _this.textUtils.concatenatePaths(_this.localURL, fileName), stats = _this.fs.statSync(filePath); // Use sync function to make code simpler.
                        if (stats.isDirectory()) {
                            entries.push(new DirectoryEntryMock(_this.textUtils, _this.mimeUtils, fileName, filePath));
                        }
                        else if (stats.isFile()) {
                            entries.push(new FileEntryMock(_this.textUtils, _this.mimeUtils, fileName, filePath));
                        }
                    }
                    successCallback && successCallback(entries);
                }
                catch (ex) {
                    errorCallback && errorCallback(ex);
                }
            }
        });
    };
    return DirectoryReaderMock;
}());

/**
 * Emulate FileWriter object of the Cordova file plugin using NodeJS functions.
 */
var FileWriterMock = /** @class */ (function () {
    function FileWriterMock(textUtils, mimeUtils, file) {
        this.textUtils = textUtils;
        this.mimeUtils = mimeUtils;
        this.file = file;
        this.fs = __webpack_require__(263);
        this.fileName = '';
        this.length = 0;
        this.size = 0;
        this.position = 0; // Default is to write at the beginning of the file.
        this.readyState = 0; // EMPTY.
        this.result = null;
        this.error = null;
        if (file) {
            this.localURL = file.localURL || file;
            this.length = file.size || 0;
        }
    }
    /**
     * Terminate file operation.
     */
    FileWriterMock.prototype.abort = function () {
        // Not supported.
    };
    /**
     * The file position at which the next write will occur.
     *
     * @param {number} offset If nonnegative, an absolute byte offset into the file.
     *                        If negative, an offset back from the end of the file.
     */
    FileWriterMock.prototype.seek = function (offset) {
        this.position = offset;
    };
    /**
     * Changes the length of the file to that specified. If shortening the file, data beyond the new length
     * will be discarded. If extending the file, the existing data will be zero-padded up to the new length.
     *
     * @param {number} size The size to which the length of the file is to be adjusted, measured in bytes.
     */
    FileWriterMock.prototype.truncate = function (size) {
        this.size = size;
    };
    /**
     * Write some data into the file.
     *
     * @param {any} data The data to write.
     */
    FileWriterMock.prototype.write = function (data) {
        var _this = this;
        if (data && data.toString() == '[object Blob]') {
            // Can't write Blobs, convert it to a Buffer.
            var reader_1 = new FileReader();
            reader_1.onload = function () {
                if (reader_1.readyState == 2) {
                    _this.writeFile(new Buffer(reader_1.result));
                }
            };
            reader_1.readAsArrayBuffer(data);
        }
        else if (data && data.toString() == '[object ArrayBuffer]') {
            // Convert it to a Buffer.
            data = new Uint8Array(data);
            this.writeFile(Buffer.from(data));
        }
        else {
            this.writeFile(data);
        }
    };
    /**
     * Write some data into the file.
     *
     * @param {Buffer} data The data to write.
     */
    FileWriterMock.prototype.writeFile = function (data) {
        var _this = this;
        /* Create a write stream so we can specify where to start writing. Node's Writable stream doesn't allow specifying the
           position once it's been created, that's why we need to create it everytime write is called. */
        var stream = this.fs.createWriteStream(this.localURL, { flags: 'r+', start: this.position });
        stream.on('error', function (err) {
            _this.onerror && _this.onerror(err);
        });
        stream.end(data, function () {
            // Update the position.
            _this.position += data.length;
            _this.onwrite && _this.onwrite();
            _this.onwriteend && _this.onwriteend();
            stream.destroy();
        });
        this.onwritestart && this.onwritestart();
    };
    return FileWriterMock;
}());

//# sourceMappingURL=filesystem.js.map
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(139).Buffer))

/***/ }),
/* 1472 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FileOpenerMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_file_opener__ = __webpack_require__(250);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Emulates the FileOpener plugin in desktop apps and in browser.
 */
var FileOpenerMock = /** @class */ (function (_super) {
    __extends(FileOpenerMock, _super);
    function FileOpenerMock(appProvider) {
        var _this = _super.call(this) || this;
        _this.appProvider = appProvider;
        return _this;
    }
    /**
     * Check if an app is already installed.
     *
     * @param {string} packageId Package ID.
     * @returns {Promise<any>} Promise resolved when done.
     */
    FileOpenerMock.prototype.appIsInstalled = function (packageId) {
        return Promise.reject('appIsInstalled not supported in browser or dekstop.');
    };
    /**
     * Open an file.
     *
     * @param {string} filePath File path.
     * @param {string} fileMIMEType File MIME type.
     * @returns {Promise<any>} Promise resolved when done.
     */
    FileOpenerMock.prototype.open = function (filePath, fileMIMEType) {
        if (this.appProvider.isDesktop()) {
            // It's a desktop app, send an event so the file is opened.
            // Opening the file from here (renderer process) doesn't focus the opened app, that's why an event is needed.
            // Use sendSync so we can receive the result.
            if (!__webpack_require__(70).ipcRenderer.sendSync('openItem', filePath)) {
                return Promise.reject('Error opening file');
            }
        }
        else {
            window.open(filePath, '_blank');
        }
        return Promise.resolve();
    };
    /**
     * Uninstalls a package.
     *
     * @param {string} packageId Package ID.
     * @returns {Promise<any>} Promise resolved when done.
     */
    FileOpenerMock.prototype.uninstall = function (packageId) {
        return Promise.reject('uninstall not supported in browser or dekstop.');
    };
    FileOpenerMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */]])
    ], FileOpenerMock);
    return FileOpenerMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_file_opener__["a" /* FileOpener */]));

//# sourceMappingURL=file-opener.js.map

/***/ }),
/* 1473 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export GlobalizationErrorMock */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GlobalizationMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_globalization__ = __webpack_require__(337);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Mock the Globalization Error.
 */
var GlobalizationErrorMock = /** @class */ (function () {
    function GlobalizationErrorMock(code, message) {
        this.code = code;
        this.message = message;
    }
    GlobalizationErrorMock.UNKNOWN_ERROR = 0;
    GlobalizationErrorMock.FORMATTING_ERROR = 1;
    GlobalizationErrorMock.PARSING_ERROR = 2;
    GlobalizationErrorMock.PATTERN_ERROR = 3;
    return GlobalizationErrorMock;
}());

/**
 * Emulates the Cordova Globalization plugin in desktop apps and in browser.
 */
var GlobalizationMock = /** @class */ (function (_super) {
    __extends(GlobalizationMock, _super);
    function GlobalizationMock(appProvider) {
        var _this = _super.call(this) || this;
        _this.appProvider = appProvider;
        return _this;
    }
    /**
     * Converts date to string.
     *
     * @param {Date} date Date you wish to convert
     * @param options Options for the converted date. Length, selector.
     * @returns {Promise<{value: string}>} Returns a promise when the date has been converted.
     */
    GlobalizationMock.prototype.dateToString = function (date, options) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     * Returns a pattern string to format and parse currency values according to the client's user preferences and ISO 4217
     * currency code.
     *
     * @param {string} currencyCode Currency Code.
     * @returns {Promise<any>}
     */
    GlobalizationMock.prototype.getCurrencyPattern = function (currencyCode) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     * Get the current locale.
     *
     * @return {string} Locale name.
     */
    GlobalizationMock.prototype.getCurrentlocale = function () {
        // Get browser language.
        var navLang = navigator.userLanguage || navigator.language;
        try {
            if (this.appProvider.isDesktop()) {
                return __webpack_require__(70).remote.app.getLocale() || navLang;
            }
            else {
                return navLang;
            }
        }
        catch (ex) {
            // Something went wrong, return browser language.
            return navLang;
        }
    };
    /**
     * Returns an array of the names of the months or days of the week, depending on the client's user preferences and calendar.
     *
     * @param options Object with type (narrow or wide) and item (month or days).
     * @returns {Promise<{value: Array<string>}>} Returns a promise.
     */
    GlobalizationMock.prototype.getDateNames = function (options) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     * Returns a pattern string to format and parse dates according to the client's user preferences.
     *
     * @param options Object with the format length and selector
     * @returns {Promise<any>} Returns a promise.
     */
    GlobalizationMock.prototype.getDatePattern = function (options) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     * Returns the first day of the week according to the client's user preferences and calendar.
     *
     * @returns {Promise<{value: string}>} returns a promise with the value
     */
    GlobalizationMock.prototype.getFirstDayOfWeek = function () {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     * Get the current locale name.
     *
     * @return {Promise<{value: string}>} Promise resolved with an object with the language string.
     */
    GlobalizationMock.prototype.getLocaleName = function () {
        var locale = this.getCurrentlocale();
        if (locale) {
            return Promise.resolve({ value: locale });
        }
        else {
            var error = new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Cannot get language');
            return Promise.reject(error);
        }
    };
    /**
     * Returns a pattern string to format and parse numbers according to the client's user preferences.
     * @param options Can be decimal, percent, or currency.
     * @returns {Promise<any>}
     */
    GlobalizationMock.prototype.getNumberPattern = function (options) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /*
     * Get the current preferred language.
     *
     * @return {Promise<{value: string}>} Promise resolved with an object with the language string.
     */
    GlobalizationMock.prototype.getPreferredLanguage = function () {
        return this.getLocaleName();
    };
    /**
     * Indicates whether daylight savings time is in effect for a given date using the client's time zone and calendar.
     *
     * @param {data} date Date to process.
     * @returns {Promise<{dst: string}>} reutrns a promise with the value
     */
    GlobalizationMock.prototype.isDayLightSavingsTime = function (date) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     * Returns a number formatted as a string according to the client's user preferences.
     * @param numberToConvert {Number} The number to convert
     * @param options {Object} Object with property `type` that can be set to: decimal, percent, or currency.
     */
    GlobalizationMock.prototype.numberToString = function (numberToConvert, options) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     * Parses a date formatted as a string, according to the client's user preferences and calendar using the time zone of the
     * client, and returns the corresponding date object.
     *
     * @param {string} dateString Date as a string to be converted
     * @param options Options for the converted date. Length, selector.
     * @returns {Promise<any>} Returns a promise when the date has been converted.
     */
    GlobalizationMock.prototype.stringToDate = function (dateString, options) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    /**
     *
     * @param {string} stringToConvert String you want to conver to a number.
     *
     * @param options The type of number you want to return. Can be decimal, percent, or currency.
     * @returns {Promise<{ value: number | string }>} Returns a promise with the value.
     */
    GlobalizationMock.prototype.stringToNumber = function (stringToConvert, options) {
        return Promise.reject(new GlobalizationErrorMock(GlobalizationErrorMock.UNKNOWN_ERROR, 'Not supported.'));
    };
    GlobalizationMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */]])
    ], GlobalizationMock);
    return GlobalizationMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_globalization__["a" /* Globalization */]));

//# sourceMappingURL=globalization.js.map

/***/ }),
/* 1474 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InAppBrowserMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_in_app_browser__ = __webpack_require__(249);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__classes_inappbrowserobject__ = __webpack_require__(1475);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Emulates the Cordova InAppBrowser plugin in desktop apps.
 */
var InAppBrowserMock = /** @class */ (function (_super) {
    __extends(InAppBrowserMock, _super);
    function InAppBrowserMock(appProvider, fileProvider, urlUtils) {
        var _this = _super.call(this) || this;
        _this.appProvider = appProvider;
        _this.fileProvider = fileProvider;
        _this.urlUtils = urlUtils;
        return _this;
    }
    /**
     * Opens a URL in a new InAppBrowser instance, the current browser instance, or the system browser.
     *
     * @param {string} url The URL to load.
     * @param {string} [target] The target in which to load the URL, an optional parameter that defaults to _self.
     * @param {string} [options] Options for the InAppBrowser.
     * @return {any} The new instance.
     */
    InAppBrowserMock.prototype.create = function (url, target, options) {
        if (options === void 0) { options = 'location=yes'; }
        if (options && typeof options !== 'string') {
            // Convert to string.
            options = Object.keys(options).map(function (key) {
                return key + '=' + options[key];
            }).join(',');
        }
        if (!this.appProvider.isDesktop()) {
            return _super.prototype.create.call(this, url, target, options);
        }
        return new __WEBPACK_IMPORTED_MODULE_5__classes_inappbrowserobject__["a" /* InAppBrowserObjectMock */](this.appProvider, this.fileProvider, this.urlUtils, url, target, options);
    };
    InAppBrowserMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_url__["a" /* CoreUrlUtilsProvider */]])
    ], InAppBrowserMock);
    return InAppBrowserMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_in_app_browser__["a" /* InAppBrowser */]));

//# sourceMappingURL=inappbrowser.js.map

/***/ }),
/* 1475 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InAppBrowserObjectMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Emulates the Cordova InAppBrowserObject in desktop apps.
 * We aren't extending InAppBrowserObject because its constructor also opens a window, so we'd end up with 2 windows.
 */
var InAppBrowserObjectMock = /** @class */ (function () {
    function InAppBrowserObjectMock(appProvider, fileProvider, urlUtils, url, target, options) {
        if (options === void 0) { options = 'location=yes'; }
        this.fileProvider = fileProvider;
        this.urlUtils = urlUtils;
        this.url = url;
        if (!appProvider.isDesktop()) {
            // This plugin is only supported in desktop.
            return;
        }
        this.browserWindow = __webpack_require__(70).remote.BrowserWindow;
        this.screen = __webpack_require__(70).screen;
        this.isSSO = !!(url && url.match(/\/launch\.php\?service=.+&passport=/));
        var width = 800, height = 600, display;
        var bwOptions = {
            webPreferences: {}
        };
        try {
            // Create a separate session for inappbrowser so we can clear its data without affecting the app.
            bwOptions.webPreferences.session = __webpack_require__(70).remote.session.fromPartition('inappbrowsersession');
        }
        catch (ex) {
            // Ignore errors.
        }
        if (screen) {
            display = this.screen.getPrimaryDisplay();
            if (display && display.workArea) {
                width = display.workArea.width || width;
                height = display.workArea.height || height;
            }
        }
        // Create the BrowserWindow options based on the received options.
        bwOptions.width = width;
        bwOptions.height = height;
        if (options.indexOf('hidden=yes') != -1) {
            bwOptions.show = false;
        }
        if (options.indexOf('location=no') != -1) {
            bwOptions.frame = false;
        }
        if (options.indexOf('fullscreen=yes') != -1) {
            bwOptions.fullscreen = true;
        }
        if (options.indexOf('clearsessioncache=yes') != -1 && bwOptions.webPreferences.session) {
            bwOptions.webPreferences.session.clearStorageData({ storages: 'cookies' });
        }
        this.window = new this.browserWindow(bwOptions);
        this.window.loadURL(url);
        if (this.isSSO) {
            // SSO in Linux. Simulate it's an iOS device so we can retrieve the launch URL.
            // This is needed because custom URL scheme is not supported in Linux.
            var userAgent = 'Mozilla/5.0 (iPad) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60';
            this.window.webContents.setUserAgent(userAgent);
        }
    }
    /**
     * Close the window.
     */
    InAppBrowserObjectMock.prototype.close = function () {
        if (this.window.isDestroyed()) {
            // Window already closed, nothing to do.
            return;
        }
        try {
            this.window.close();
        }
        catch (ex) {
            // Ignore errors.
        }
    };
    /**
     * Execute a JS script.
     *
     * @param {any} details Details of the script to run, specifying either a file or code key.
     * @return {Promise<any>} Promise resolved when done.
     */
    InAppBrowserObjectMock.prototype.executeScript = function (details) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (details.code) {
                _this.window.webContents.executeJavaScript(details.code, false, resolve);
            }
            else if (details.file) {
                _this.fileProvider.readFile(details.file).then(function (code) {
                    _this.window.webContents.executeJavaScript(code, false, resolve);
                }).catch(reject);
            }
            else {
                reject('executeScript requires exactly one of code or file to be specified');
            }
        });
    };
    /**
     * Recursive function to get the launch URL from the contents of a BrowserWindow.
     *
     * @param {number} [retry=0] Retry number.
     * @return {Promise<string>} Promise resolved with the launch URL.
     */
    InAppBrowserObjectMock.prototype.getLaunchUrl = function (retry) {
        var _this = this;
        if (retry === void 0) { retry = 0; }
        if (this.window.isDestroyed()) {
            // Window is destroyed, stop.
            return Promise.reject(null);
        }
        return new Promise(function (resolve, reject) {
            // Execute Javascript to retrieve the launch link.
            var jsCode = 'var el = document.querySelector("#launchapp"); el && el.href;';
            var found = false;
            _this.window.webContents.executeJavaScript(jsCode).then(function (launchUrl) {
                found = true;
                resolve(launchUrl);
            });
            setTimeout(function () {
                if (found) {
                    // URL found, stop.
                }
                else if (retry > 5) {
                    // Waited enough, stop.
                    reject();
                }
                else {
                    _this.getLaunchUrl(retry + 1).then(resolve, reject);
                }
            }, 300);
        });
    };
    /**
     * Hide the window.
     */
    InAppBrowserObjectMock.prototype.hide = function () {
        this.window.hide();
    };
    /**
     * Insert CSS.
     *
     * @param {any} details Details of the CSS to insert, specifying either a file or code key.
     * @return {Promise<any>} Promise resolved when done.
     */
    InAppBrowserObjectMock.prototype.insertCSS = function (details) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (details.code) {
                _this.window.webContents.insertCSS(details.code);
                resolve();
            }
            else if (details.file) {
                _this.fileProvider.readFile(details.file).then(function (code) {
                    _this.window.webContents.insertCSS(code);
                    resolve();
                }).catch(reject);
            }
            else {
                reject('insertCSS requires exactly one of code or file to be specified');
            }
        });
    };
    /**
     * Listen to events happening.
     *
     * @param {string} name Name of the event.
     * @return {Observable<InAppBrowserEvent>} Observable that will listen to the event on subscribe, and will stop listening
     *                                         to the event on unsubscribe.
     */
    InAppBrowserObjectMock.prototype.on = function (name) {
        var _this = this;
        // Create the observable.
        return new __WEBPACK_IMPORTED_MODULE_0_rxjs__["Observable"](function (observer) {
            // Helper functions to handle events.
            var received = function (event, url) {
                try {
                    event.url = url || (_this.window.isDestroyed() ? '' : _this.window.getURL());
                    event.type = name;
                    observer.next(event);
                }
                catch (ex) {
                    // Ignore errors.
                }
            }, finishLoad = function (event) {
                // Check if user is back to launch page.
                if (_this.urlUtils.removeUrlParams(_this.url) == _this.urlUtils.removeUrlParams(_this.window.getURL())) {
                    // The launch page was loaded. Search for the launch link.
                    _this.getLaunchUrl().then(function (launchUrl) {
                        if (launchUrl) {
                            // Launch URL retrieved, send it and stop listening.
                            received(event, launchUrl);
                        }
                    });
                }
            };
            if (!_this.window.isDestroyed() && !_this.window.webContents.isDestroyed()) {
                switch (name) {
                    case 'loadstart':
                        _this.window.webContents.on('did-start-loading', received);
                        if (_this.isSSO) {
                            // Linux doesn't support custom URL Schemes. Check if launch page is loaded.
                            _this.window.webContents.on('did-finish-load', finishLoad);
                        }
                        break;
                    case 'loadstop':
                        _this.window.webContents.on('did-finish-load', received);
                        break;
                    case 'loaderror':
                        _this.window.webContents.on('did-fail-load', received);
                        break;
                    case 'exit':
                        _this.window.on('close', received);
                        break;
                    default:
                }
            }
            return function () {
                // Unsubscribing. We need to remove the listeners.
                if (_this.window.isDestroyed() || _this.window.webContents.isDestroyed()) {
                    // Page has been destroyed already, no need to remove listeners.
                    return;
                }
                switch (name) {
                    case 'loadstart':
                        _this.window.webContents.removeListener('did-start-loading', received);
                        _this.window.webContents.removeListener('did-finish-load', finishLoad);
                        break;
                    case 'loadstop':
                        _this.window.webContents.removeListener('did-finish-load', received);
                        break;
                    case 'loaderror':
                        _this.window.webContents.removeListener('did-fail-load', received);
                        break;
                    case 'exit':
                        _this.window.removeListener('close', received);
                        break;
                    default:
                }
            };
        });
    };
    /**
     * Show the window.
     */
    InAppBrowserObjectMock.prototype.show = function () {
        this.window.show();
    };
    return InAppBrowserObjectMock;
}());

//# sourceMappingURL=inappbrowserobject.js.map

/***/ }),
/* 1476 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LocalNotificationsMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_local_notifications__ = __webpack_require__(255);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__configconstants__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_moment__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Emulates the Cordova Globalization plugin in desktop apps and in browser.
 */
var LocalNotificationsMock = /** @class */ (function (_super) {
    __extends(LocalNotificationsMock, _super);
    function LocalNotificationsMock(appProvider, utils, textUtils) {
        var _this = _super.call(this) || this;
        _this.appProvider = appProvider;
        _this.utils = utils;
        _this.textUtils = textUtils;
        // Templates for Windows ToastNotifications and TileNotifications.
        _this.toastTemplate = '<toast><visual><binding template="ToastText02"><text id="1" hint-wrap="true">%s</text>' +
            '<text id="2" hint-wrap="true">%s</text></binding></visual></toast>';
        _this.tileBindingTemplate = '<text hint-style="base" hint-wrap="true">%s</text>' +
            '<text hint-style="captionSubtle" hint-wrap="true">%s</text>';
        _this.tileTemplate = '<tile><visual branding="nameAndLogo">' +
            '<binding template="TileMedium">' + _this.tileBindingTemplate + '</binding>' +
            '<binding template="TileWide">' + _this.tileBindingTemplate + '</binding>' +
            '<binding template="TileLarge">' + _this.tileBindingTemplate + '</binding>' +
            '</visual></tile>';
        // Variables for database.
        _this.DESKTOP_NOTIFS_TABLE = 'desktop_local_notifications';
        _this.tableSchema = {
            name: _this.DESKTOP_NOTIFS_TABLE,
            columns: [
                {
                    name: 'id',
                    type: 'INTEGER',
                    primaryKey: true
                },
                {
                    name: 'title',
                    type: 'TEXT'
                },
                {
                    name: 'text',
                    type: 'TEXT'
                },
                {
                    name: 'at',
                    type: 'INTEGER'
                },
                {
                    name: 'data',
                    type: 'TEXT'
                },
                {
                    name: 'triggered',
                    type: 'INTEGER'
                }
            ]
        };
        _this.scheduled = {};
        _this.triggered = {};
        _this.defaults = {
            actions: [],
            attachments: [],
            autoClear: true,
            badge: null,
            channel: null,
            clock: true,
            color: null,
            data: null,
            defaults: 0,
            foreground: null,
            group: null,
            groupSummary: false,
            icon: null,
            id: 0,
            launch: true,
            led: true,
            lockscreen: true,
            mediaSession: null,
            number: 0,
            priority: 0,
            progressBar: false,
            silent: false,
            smallIcon: 'res://icon',
            sound: true,
            sticky: false,
            summary: null,
            text: '',
            timeoutAfter: false,
            title: '',
            trigger: { type: 'calendar' },
            vibrate: false,
            wakeup: true
        };
        _this.appDB = appProvider.getDB();
        _this.appDB.createTableFromSchema(_this.tableSchema);
        // Initialize observers.
        _this.observers = {
            schedule: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
            trigger: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
            click: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
            update: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
            clear: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
            clearall: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
            cancel: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
            cancelall: new __WEBPACK_IMPORTED_MODULE_8_rxjs__["Subject"](),
        };
        return _this;
    }
    /**
     * Adds a group of actions.
     *
     * @param {any} groupId The id of the action group
     * @param {ILocalNotificationAction[]} actions The actions of this group
     * @returns {Promise<any>}
     */
    LocalNotificationsMock.prototype.addActions = function (groupId, actions) {
        return Promise.reject('Not supported in desktop apps.');
    };
    /**
     * Cancels single or multiple notifications.
     *
     * @param {any} notificationId A single notification id, or an array of notification ids.
     * @returns {Promise<any>} Returns a promise when the notification is canceled
     */
    LocalNotificationsMock.prototype.cancel = function (notificationId) {
        var _this = this;
        var promises = [];
        notificationId = Array.isArray(notificationId) ? notificationId : [notificationId];
        notificationId = this.convertIds(notificationId);
        // Cancel the notifications.
        notificationId.forEach(function (id) {
            if (_this.scheduled[id]) {
                promises.push(_this.cancelNotification(id, false, 'cancel'));
            }
        });
        return Promise.all(promises);
    };
    /**
     * Cancels all notifications.
     *
     * @returns {Promise<any>} Returns a promise when all notifications are canceled.
     */
    LocalNotificationsMock.prototype.cancelAll = function () {
        var _this = this;
        return this.cancel(Object.keys(this.scheduled)).then(function () {
            _this.fireEvent('cancelall', {
                event: 'cancelall',
                foreground: true,
                queued: false
            });
        });
    };
    /**
     * Cancel a local notification.
     *
     * @param {number} id Notification ID.
     * @param {boolean} omitEvent If true, the clear/cancel event won't be triggered.
     * @param {string} eventName Name of the event to trigger.
     * @return {Void}
     */
    LocalNotificationsMock.prototype.cancelNotification = function (id, omitEvent, eventName) {
        if (!this.scheduled[id]) {
            return;
        }
        var notification = this.scheduled[id].notification;
        clearTimeout(this.scheduled[id].timeout);
        clearInterval(this.scheduled[id].interval);
        delete this.scheduled[id];
        delete this.triggered[id];
        this.removeNotification(id);
        if (!omitEvent) {
            this.fireEvent(eventName, notification);
        }
    };
    /**
     * Clears single or multiple notifications.
     *
     * @param {any} notificationId A single notification id, or an array of notification ids.
     * @returns {Promise<any>} Returns a promise when the notification had been cleared.
     */
    LocalNotificationsMock.prototype.clear = function (notificationId) {
        var _this = this;
        var promises = [];
        notificationId = Array.isArray(notificationId) ? notificationId : [notificationId];
        notificationId = this.convertIds(notificationId);
        // Clear the notifications.
        notificationId.forEach(function (id) {
            // Cancel only the notifications that aren't repeating.
            if (_this.scheduled[id] && _this.scheduled[id].notification &&
                (!_this.scheduled[id].notification.trigger || !_this.scheduled[id].notification.trigger.every)) {
                promises.push(_this.cancelNotification(id, false, 'clear'));
            }
        });
        return Promise.all(promises);
    };
    /**
     * Clears all notifications.
     *
     * @returns {Promise<any>} Returns a promise when all notifications have cleared
     */
    LocalNotificationsMock.prototype.clearAll = function () {
        var _this = this;
        return this.clear(Object.keys(this.scheduled)).then(function () {
            _this.fireEvent('clearall', {
                event: 'clearall',
                foreground: true,
                queued: false
            });
        });
    };
    /**
     * Convert a list of IDs to numbers.
     * Code extracted from the Cordova plugin.
     *
     * @param {any[]} ids List of IDs.
     * @return {number[]} List of IDs as numbers.
     */
    LocalNotificationsMock.prototype.convertIds = function (ids) {
        var convertedIds = [];
        for (var i = 0; i < ids.length; i++) {
            convertedIds.push(Number(ids[i]));
        }
        return convertedIds;
    };
    /**
     * Convert the notification options to their required type.
     * Code extracted from the Cordova plugin.
     *
     * @param {ILocalNotification} notification Notification.
     * @return {ILocalNotification} Converted notification.
     */
    LocalNotificationsMock.prototype.convertProperties = function (notification) {
        if (notification.id) {
            notification.id = this.parseToInt('id', notification);
        }
        if (notification.title) {
            notification.title = notification.title.toString();
        }
        if (notification.badge) {
            notification.badge = this.parseToInt('badge', notification);
        }
        if (notification.defaults) {
            notification.defaults = this.parseToInt('defaults', notification);
        }
        if (typeof notification.timeoutAfter === 'boolean') {
            notification.timeoutAfter = notification.timeoutAfter ? 3600000 : null;
        }
        if (notification.timeoutAfter) {
            notification.timeoutAfter = this.parseToInt('timeoutAfter', notification);
        }
        this.convertPriority(notification);
        this.convertTrigger(notification);
        this.convertActions(notification);
        this.convertProgressBar(notification);
        return notification;
    };
    /**
     * Parse a property to number, returning the default value if not valid.
     * Code extracted from the Cordova plugin.
     *
     * @param {string} prop Name of property to convert.
     * @param {any} notification Notification where to search the property.
     * @return {number} Converted number or default value.
     */
    LocalNotificationsMock.prototype.parseToInt = function (prop, notification) {
        if (isNaN(notification[prop])) {
            return this.defaults[prop];
        }
        else {
            return Number(notification[prop]);
        }
    };
    /**
     * Convert the priority of a notification.
     * Code extracted from the Cordova plugin.
     *
     * @param {any} notification Notification.
     * @return {any} Notification.
     */
    LocalNotificationsMock.prototype.convertPriority = function (notification) {
        var prio = notification.priority || notification.prio || 0;
        if (typeof prio === 'string') {
            prio = { min: -2, low: -1, high: 1, max: 2 }[prio] || 0;
        }
        if (notification.foreground === true) {
            prio = Math.max(prio, 1);
        }
        if (notification.foreground === false) {
            prio = Math.min(prio, 0);
        }
        notification.priority = prio;
        return notification;
    };
    /**
     * Convert the actions of a notification.
     * Code extracted from the Cordova plugin.
     *
     * @param {any} notification Notification.
     * @return {any} Notification.
     */
    LocalNotificationsMock.prototype.convertActions = function (notification) {
        var actions = [];
        if (!notification.actions || typeof notification.actions === 'string') {
            return notification;
        }
        for (var i = 0, len = notification.actions.length; i < len; i++) {
            var action = notification.actions[i];
            if (!action.id) {
                // Ignore action, it has no ID.
                continue;
            }
            action.id = action.id.toString();
            actions.push(action);
        }
        notification.actions = actions;
        return notification;
    };
    /**
     * Convert the trigger of a notification.
     * Code extracted from the Cordova plugin.
     *
     * @param {any} notification Notification.
     * @return {any} Notification.
     */
    LocalNotificationsMock.prototype.convertTrigger = function (notification) {
        var trigger = notification.trigger || {};
        var date = this.getValueFor(trigger, 'at', 'firstAt', 'date');
        var dateToNum = function (date) {
            var num = typeof date == 'object' ? date.getTime() : date;
            return Math.round(num);
        };
        if (!notification.trigger) {
            return notification;
        }
        if (!trigger.type) {
            trigger.type = trigger.center ? 'location' : 'calendar';
        }
        var isCal = trigger.type == 'calendar';
        if (isCal && !date) {
            date = this.getValueFor(notification, 'at', 'firstAt', 'date');
        }
        if (isCal && !trigger.every && notification.every) {
            trigger.every = notification.every;
        }
        if (isCal && (trigger.in || trigger.every)) {
            date = null;
        }
        if (isCal && date) {
            trigger.at = dateToNum(date);
        }
        if (isCal && trigger.firstAt) {
            trigger.firstAt = dateToNum(trigger.firstAt);
        }
        if (isCal && trigger.before) {
            trigger.before = dateToNum(trigger.before);
        }
        if (isCal && trigger.after) {
            trigger.after = dateToNum(trigger.after);
        }
        if (!trigger.count) {
            trigger.count = trigger.every ? 5 : 1;
        }
        if (!isCal) {
            trigger.notifyOnEntry = !!trigger.notifyOnEntry;
            trigger.notifyOnExit = trigger.notifyOnExit === true;
            trigger.radius = trigger.radius || 5;
            trigger.single = !!trigger.single;
        }
        if (!isCal || trigger.at) {
            delete trigger.every;
        }
        delete notification.every;
        delete notification.at;
        delete notification.firstAt;
        delete notification.date;
        notification.trigger = trigger;
        return notification;
    };
    /**
     * Convert the progress bar of a notification.
     * Code extracted from the Cordova plugin.
     *
     * @param {any} notification Notification.
     * @return {any} Notification.
     */
    LocalNotificationsMock.prototype.convertProgressBar = function (notification) {
        var cfg = notification.progressBar;
        if (cfg === undefined) {
            return notification;
        }
        if (typeof cfg === 'boolean') {
            cfg = notification.progressBar = { enabled: cfg };
        }
        if (typeof cfg.enabled !== 'boolean') {
            cfg.enabled = !!(cfg.value || cfg.maxValue || cfg.indeterminate !== null);
        }
        cfg.value = cfg.value || 0;
        cfg.enabled = !!cfg.enabled;
        if (cfg.enabled && notification.clock === true) {
            notification.clock = 'chronometer';
        }
        return notification;
    };
    /**
     * Not an official interface, however its possible to manually fire events.
     *
     * @param {string} eventName The name of the event. Available events: schedule, trigger, click, update, clear, clearall, cancel,
     *                  cancelall. Custom event names are possible for actions
     * @param {any} args Optional arguments
     */
    LocalNotificationsMock.prototype.fireEvent = function (eventName, args) {
        if (this.observers[eventName]) {
            this.observers[eventName].next(args);
        }
    };
    /**
     * Fire queued events once the device is ready and all listeners are registered.
     *
     * @returns {Promise<any>}
     */
    LocalNotificationsMock.prototype.fireQueuedEvents = function () {
        return Promise.resolve();
    };
    /**
     * Get a notification object.
     *
     * @param {any} notificationId The id of the notification to get.
     * @returns {Promise<ILocalNotification>}
     */
    LocalNotificationsMock.prototype.get = function (notificationId) {
        return Promise.resolve(this.getNotifications([Number(notificationId)], true, true)[0]);
    };
    /**
     * Get all notification objects.
     *
     * @returns {Promise<Array<ILocalNotification>>}
     */
    LocalNotificationsMock.prototype.getAll = function () {
        return Promise.resolve(this.getNotifications(undefined, true, true));
    };
    /**
     * Gets the (platform specific) default settings.
     *
     * @returns {Promise<any>} An object with all default settings
     */
    LocalNotificationsMock.prototype.getDefaults = function () {
        return Promise.resolve(this.defaults);
    };
    /**
     * Get all the notification ids.
     *
     * @returns {Promise<Array<number>>}
     */
    LocalNotificationsMock.prototype.getIds = function () {
        var ids = this.utils.mergeArraysWithoutDuplicates(Object.keys(this.scheduled), Object.keys(this.triggered));
        ids = ids.map(function (id) {
            return Number(id);
        });
        return Promise.resolve(ids);
    };
    /**
     * Get all the notification stored in local DB.
     *
     * @return {Promise<any>} Promise resolved with the notifications.
     */
    LocalNotificationsMock.prototype.getAllNotifications = function () {
        var _this = this;
        return this.appDB.getAllRecords(this.DESKTOP_NOTIFS_TABLE).then(function (notifications) {
            notifications.forEach(function (notification) {
                notification.trigger = {
                    at: new Date(notification.at)
                };
                notification.data = _this.textUtils.parseJSON(notification.data);
                notification.triggered = !!notification.triggered;
                _this.mergeWithDefaults(notification);
            });
            return notifications;
        });
    };
    /**
     * Get all scheduled notification objects.
     *
     * @returns {Promise<Array<ILocalNotification>>}
     */
    LocalNotificationsMock.prototype.getScheduled = function () {
        return Promise.resolve(this.getNotifications(undefined, true, false));
    };
    /**
     * Get all triggered notification objects.
     *
     * @returns {Promise<Array<ILocalNotification>>}
     */
    LocalNotificationsMock.prototype.getTriggered = function () {
        return Promise.resolve(this.getNotifications(undefined, false, true));
    };
    /**
     * Get a set of notifications. If ids isn't specified, return all the notifications.
     *
     * @param {number[]} [ids] Ids of notifications to get. If not specified, get all notifications.
     * @param {boolean} [getScheduled] Get scheduled notifications.
     * @param {boolean} [getTriggered] Get triggered notifications.
     * @return {ILocalNotification[]} List of notifications.
     */
    LocalNotificationsMock.prototype.getNotifications = function (ids, getScheduled, getTriggered) {
        var notifications = [];
        if (getScheduled) {
            for (var id in this.scheduled) {
                if (!ids || ids.indexOf(Number(id)) != -1) {
                    notifications.push(this.scheduled[id].notification);
                }
            }
        }
        if (getTriggered) {
            for (var id in this.triggered) {
                if ((!getScheduled || !this.scheduled[id]) && (!ids || ids.indexOf(Number(id)) != -1)) {
                    notifications.push(this.triggered[id].notification);
                }
            }
        }
        return notifications;
    };
    /**
     * Get the trigger "at" in milliseconds.
     *
     * @param {ILocalNotification} notification Notification to get the trigger from.
     * @return {number} Trigger time.
     */
    LocalNotificationsMock.prototype.getNotificationTriggerAt = function (notification) {
        var triggerAt = (notification.trigger && notification.trigger.at) || new Date();
        if (typeof triggerAt != 'number') {
            return triggerAt.getTime();
        }
        return triggerAt;
    };
    /**
     * Get the ids of scheduled notifications.
     *
     * @returns {Promise<Array<number>>} Returns a promise
     */
    LocalNotificationsMock.prototype.getScheduledIds = function () {
        var ids = Object.keys(this.scheduled).map(function (id) {
            return Number(id);
        });
        return Promise.resolve(ids);
    };
    /**
     * Get the ids of triggered notifications.
     *
     * @returns {Promise<Array<number>>}
     */
    LocalNotificationsMock.prototype.getTriggeredIds = function () {
        var ids = Object.keys(this.triggered).map(function (id) {
            return Number(id);
        });
        return Promise.resolve(ids);
    };
    /**
     * Get the type (triggered, scheduled) for the notification.
     *
     * @param {number} id The ID of the notification.
     * @return {Promise<boolean>}
     */
    LocalNotificationsMock.prototype.getType = function (id) {
        if (this.scheduled[id]) {
            return Promise.resolve('scheduled');
        }
        else if (this.triggered[id]) {
            return Promise.resolve('triggered');
        }
        else {
            return Promise.resolve('unknown');
        }
    };
    /**
     * Given an object of options and a list of properties, return the first property that exists.
     * Code extracted from the Cordova plugin.
     *
     * @param {ILocalNotification} notification Notification.
     * @param {any[]} ...args List of keys to check.
     * @return {any} First value found.
     */
    LocalNotificationsMock.prototype.getValueFor = function (notification) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        for (var i in args) {
            var key = args[i];
            if (notification.hasOwnProperty(key)) {
                return notification[key];
            }
        }
    };
    /**
     * Checks if a group of actions is defined.
     *
     * @param {any} groupId The id of the action group
     * @returns {Promise<boolean>} Whether the group is defined.
     */
    LocalNotificationsMock.prototype.hasActions = function (groupId) {
        return Promise.resolve(false);
    };
    /**
     * Informs if the app has the permission to show notifications.
     *
     * @returns {Promise<boolean>}
     */
    LocalNotificationsMock.prototype.hasPermission = function () {
        return Promise.resolve(true);
    };
    /**
     * Check if a notification has a given type.
     *
     * @param {number} id The ID of the notification.
     * @param {string} type  The type of the notification.
     * @returns {Promise<boolean>} Promise resolved with boolean: whether it has the type.
     */
    LocalNotificationsMock.prototype.hasType = function (id, type) {
        return this.getType(id).then(function (notifType) {
            return type == notifType;
        });
    };
    /**
     * Checks presence of a notification.
     *
     * @param {number} notificationId Notification ID.
     * @returns {Promise<boolean>}
     */
    LocalNotificationsMock.prototype.isPresent = function (notificationId) {
        return Promise.resolve(!!this.scheduled[notificationId] || !!this.triggered[notificationId]);
    };
    /**
     * Checks is a notification is scheduled.
     *
     * @param {number} notificationId Notification ID.
     * @returns {Promise<boolean>}
     */
    LocalNotificationsMock.prototype.isScheduled = function (notificationId) {
        return Promise.resolve(!!this.scheduled[notificationId]);
    };
    /**
     * Checks if a notification is triggered.
     *
     * @param {number} notificationId Notification ID.
     * @returns {Promise<boolean>}
     */
    LocalNotificationsMock.prototype.isTriggered = function (notificationId) {
        return Promise.resolve(!!this.triggered[notificationId]);
    };
    /**
     * Loads an initialize the API for desktop.
     *
     * @return {Promise<any>} Promise resolved when done.
     */
    LocalNotificationsMock.prototype.load = function () {
        var _this = this;
        if (!this.appProvider.isDesktop()) {
            return Promise.resolve();
        }
        if (this.appProvider.isWindows()) {
            try {
                this.winNotif = __webpack_require__(!(function webpackMissingModule() { var e = new Error("Cannot find module \"electron-windows-notifications\""); e.code = 'MODULE_NOT_FOUND'; throw e; }()));
            }
            catch (ex) {
                // Ignore errors.
            }
        }
        // App is being loaded, re-schedule all the notifications that were scheduled before.
        return this.getAllNotifications().catch(function () {
            return [];
        }).then(function (notifications) {
            notifications.forEach(function (notification) {
                if (notification.triggered) {
                    // Notification was triggered already, store it in memory but don't schedule it again.
                    delete notification.triggered;
                    _this.scheduled[notification.id] = {
                        notification: notification
                    };
                    _this.triggered[notification.id] = notification;
                }
                else {
                    // Schedule the notification again unless it should have been triggered more than an hour ago.
                    delete notification.triggered;
                    notification.at = notification.at * 1000;
                    if (notification.at - Date.now() > -__WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_HOUR * 1000) {
                        _this.schedule(notification);
                    }
                }
            });
        });
    };
    /**
     * Merge notification options with default values.
     * Code extracted from the Cordova plugin.
     *
     * @param {ILocalNotification} notification Notification.
     * @return {ILocalNotification} Treated notification.
     */
    LocalNotificationsMock.prototype.mergeWithDefaults = function (notification) {
        var values = this.getDefaults();
        if (values.hasOwnProperty('sticky')) {
            notification.sticky = this.getValueFor(notification, 'sticky', 'ongoing');
        }
        if (notification.sticky && notification.autoClear !== true) {
            notification.autoClear = false;
        }
        Object.assign(values, notification);
        for (var key in values) {
            if (values[key] !== null) {
                notification[key] = values[key];
            }
            else {
                delete notification[key];
            }
        }
        return notification;
    };
    /**
     * Function called when a notification is clicked.
     *
     * @param {ILocalNotification} notification Clicked notification.
     */
    LocalNotificationsMock.prototype.notificationClicked = function (notification) {
        this.fireEvent('click', notification);
        // Focus the app.
        __webpack_require__(70).ipcRenderer.send('focusApp');
    };
    /**
     * Sets a callback for a specific event.
     *
     * @param {string} eventName The name of the event. Events: schedule, trigger, click, update, clear, clearall, cancel,
     *                           cancelall. Custom event names are possible for actions.
     * @return {Observable<any>} Observable
     */
    LocalNotificationsMock.prototype.on = function (eventName) {
        return this.observers[eventName];
    };
    /**
     * Parse a interval and convert it to a number of milliseconds (0 if not valid).
     *
     * @param {string} every Interval to convert.
     * @return {number} Number of milliseconds of the interval-
     */
    LocalNotificationsMock.prototype.parseInterval = function (every) {
        var interval;
        every = String(every).toLowerCase();
        if (!every || every == 'undefined') {
            interval = 0;
        }
        else if (every == 'second') {
            interval = 1000;
        }
        else if (every == 'minute') {
            interval = __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_MINUTE * 1000;
        }
        else if (every == 'hour') {
            interval = __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_HOUR * 1000;
        }
        else if (every == 'day') {
            interval = __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_DAY * 1000;
        }
        else if (every == 'week') {
            interval = __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_DAY * 7 * 1000;
        }
        else if (every == 'month') {
            interval = __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_DAY * 31 * 1000;
        }
        else if (every == 'quarter') {
            interval = __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_HOUR * 2190 * 1000;
        }
        else if (every == 'year') {
            interval = __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_YEAR * 1000;
        }
        else {
            interval = parseInt(every, 10);
            if (isNaN(interval)) {
                interval = 0;
            }
            else {
                interval *= 60000;
            }
        }
        return interval;
    };
    /**
     * Removes a group of actions.
     *
     * @param {any} groupId The id of the action group
     * @returns {Promise<any>}
     */
    LocalNotificationsMock.prototype.removeActions = function (groupId) {
        return Promise.reject('Not supported in desktop apps.');
    };
    /**
     * Remove a notification from local DB.
     *
     * @param {number} id ID of the notification.
     * @return {Promise<any>} Promise resolved when done.
     */
    LocalNotificationsMock.prototype.removeNotification = function (id) {
        return this.appDB.deleteRecords(this.DESKTOP_NOTIFS_TABLE, { id: id });
    };
    /**
     * Request permission to show notifications if not already granted.
     *
     * @returns {Promise<boolean>}
     */
    LocalNotificationsMock.prototype.requestPermission = function () {
        return Promise.resolve(true);
    };
    /**
     * Schedules a single or multiple notifications.
     *
     * @param {ILocalNotification | Array<ILocalNotification>} [options] Notification or notifications.
     */
    LocalNotificationsMock.prototype.schedule = function (options) {
        this.scheduleOrUpdate(options);
    };
    /**
     * Schedules or updates a single or multiple notifications.
     * We only support using the "at" property to trigger the notification. Other properties like "in" or "every"
     * aren't supported yet.
     *
     * @param {ILocalNotification | Array<ILocalNotification>} [options] Notification or notifications.
     * @param {string} [eventName] Name of the event: schedule or update.
     */
    LocalNotificationsMock.prototype.scheduleOrUpdate = function (options, eventName) {
        var _this = this;
        if (eventName === void 0) { eventName = 'schedule'; }
        options = Array.isArray(options) ? options : [options];
        options.forEach(function (notification) {
            _this.mergeWithDefaults(notification);
            _this.convertProperties(notification);
            // Cancel current notification if exists.
            _this.cancelNotification(notification.id, true, 'cancel');
            // Store the notification in the scheduled list and in the DB.
            _this.scheduled[notification.id] = {
                notification: notification
            };
            _this.storeNotification(notification, false);
            var triggerAt = _this.getNotificationTriggerAt(notification);
            if (Math.abs(__WEBPACK_IMPORTED_MODULE_7_moment__().diff(triggerAt, 'days')) > 15) {
                // Notification should trigger more than 15 days from now, don't schedule it.
                return;
            }
            // Schedule the notification.
            var toTriggerTime = triggerAt - Date.now(), trigger = function () {
                // Trigger the notification.
                _this.triggerNotification(notification);
                // Store the notification as triggered. Don't remove it from scheduled, it's how the plugin works.
                _this.triggered[notification.id] = notification;
                _this.storeNotification(notification, true);
                // Launch the trigger event.
                _this.fireEvent('trigger', notification);
            };
            _this.scheduled[notification.id].timeout = setTimeout(trigger, toTriggerTime);
            // Launch the scheduled/update event.
            _this.fireEvent(eventName, notification);
        });
    };
    /**
     * Overwrites the (platform specific) default settings.
     *
     * @param {any} defaults The defaults to set.
     * @returns {Promise<any>}
     */
    LocalNotificationsMock.prototype.setDefaults = function (defaults) {
        this.defaults = defaults;
        return Promise.resolve();
    };
    /**
     * Store a notification in local DB.
     *
     * @param {ILocalNotification} notification Notification to store.
     * @param {boolean} triggered Whether the notification has been triggered.
     * @return {Promise<any>} Promise resolved when stored.
     */
    LocalNotificationsMock.prototype.storeNotification = function (notification, triggered) {
        // Only store some of the properties.
        var entry = {
            id: notification.id,
            title: notification.title,
            text: notification.text,
            at: this.getNotificationTriggerAt(notification),
            data: notification.data ? JSON.stringify(notification.data) : '{}',
            triggered: triggered ? 1 : 0
        };
        return this.appDB.insertRecord(this.DESKTOP_NOTIFS_TABLE, entry);
    };
    /**
     * Trigger a notification, using the best method depending on the OS.
     *
     * @param {ILocalNotification} notification Notification to trigger.
     */
    LocalNotificationsMock.prototype.triggerNotification = function (notification) {
        var _this = this;
        if (this.winNotif) {
            // Use Windows notifications.
            var notifInstance = new this.winNotif.ToastNotification({
                appId: __WEBPACK_IMPORTED_MODULE_6__configconstants__["a" /* CoreConfigConstants */].app_id,
                template: this.toastTemplate,
                strings: [notification.title, notification.text]
            });
            // Listen for click events.
            notifInstance.on('activated', function () {
                _this.notificationClicked(notification);
            });
            notifInstance.show();
            try {
                // Show it in Tile too.
                var tileNotif = new this.winNotif.TileNotification({
                    tag: notification.id + '',
                    template: this.tileTemplate,
                    strings: [notification.title, notification.text, notification.title, notification.text, notification.title,
                        notification.text],
                    expirationTime: new Date(Date.now() + __WEBPACK_IMPORTED_MODULE_5__core_constants__["a" /* CoreConstants */].SECONDS_HOUR * 1000) // Expire in 1 hour.
                });
                tileNotif.show();
            }
            catch (ex) {
                // tslint:disable-next-line
                console.warn('Error showing TileNotification. Please notice they only work with the app installed.', ex);
            }
        }
        else {
            // Use Electron default notifications.
            var notifInstance = new Notification(notification.title, {
                body: notification.text
            });
            // Listen for click events.
            notifInstance.onclick = function () {
                _this.notificationClicked(notification);
            };
        }
    };
    /**
     * Updates a previously scheduled notification. Must include the id in the options parameter.
     *
     * @param {ILocalNotification} [options] Notification.
     */
    LocalNotificationsMock.prototype.update = function (options) {
        return this.scheduleOrUpdate(options, 'update');
    };
    LocalNotificationsMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], LocalNotificationsMock);
    return LocalNotificationsMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_local_notifications__["a" /* LocalNotifications */]));

//# sourceMappingURL=local-notifications.js.map

/***/ }),
/* 1477 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MediaCaptureMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_media_capture__ = __webpack_require__(347);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__capture_helper__ = __webpack_require__(258);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Emulates the Cordova MediaCapture plugin in desktop apps and in browser.
 */
var MediaCaptureMock = /** @class */ (function (_super) {
    __extends(MediaCaptureMock, _super);
    function MediaCaptureMock(captureHelper) {
        var _this = _super.call(this) || this;
        _this.captureHelper = captureHelper;
        return _this;
    }
    /**
     * Start the audio recorder application and return information about captured audio clip files.
     *
     * @param {CaptureAudioOptions} options Options.
     * @return {Promise<any>} Promise resolved when captured.
     */
    MediaCaptureMock.prototype.captureAudio = function (options) {
        return this.captureHelper.captureMedia('audio', options);
    };
    /**
     * Start the camera application and return information about captured image files.
     *
     * @param {CaptureImageOptions} options Options.
     * @return {Promise<any>} Promise resolved when captured.
     */
    MediaCaptureMock.prototype.captureImage = function (options) {
        return this.captureHelper.captureMedia('captureimage', options);
    };
    /**
     * Start the video recorder application and return information about captured video clip files.
     *
     * @param {CaptureVideoOptions} options Options.
     * @return {Promise<any>} Promise resolved when captured.
     */
    MediaCaptureMock.prototype.captureVideo = function (options) {
        return this.captureHelper.captureMedia('video', options);
    };
    MediaCaptureMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__capture_helper__["a" /* CoreEmulatorCaptureHelperProvider */]])
    ], MediaCaptureMock);
    return MediaCaptureMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_media_capture__["a" /* MediaCapture */]));

//# sourceMappingURL=media-capture.js.map

/***/ }),
/* 1478 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NetworkMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_network__ = __webpack_require__(132);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Emulates the Cordova Globalization plugin in desktop apps and in browser.
 */
var NetworkMock = /** @class */ (function (_super) {
    __extends(NetworkMock, _super);
    function NetworkMock() {
        var _this = _super.call(this) || this;
        window.Connection = {
            UNKNOWN: 'unknown',
            ETHERNET: 'ethernet',
            WIFI: 'wifi',
            CELL_2G: '2g',
            CELL_3G: '3g',
            CELL_4G: '4g',
            CELL: 'cellular',
            NONE: 'none'
        };
        return _this;
    }
    /**
     * Returns an observable to watch connection changes.
     *
     * @return {Observable<any>} Observable.
     */
    NetworkMock.prototype.onchange = function () {
        return __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"].merge(this.onConnect(), this.onDisconnect());
    };
    /**
     * Returns an observable to notify when the app is connected.
     *
     * @return {Observable<any>} Observable.
     */
    NetworkMock.prototype.onConnect = function () {
        var observable = new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Subject"]();
        window.addEventListener('online', function (ev) {
            observable.next(ev);
        }, false);
        return observable;
    };
    /**
     * Returns an observable to notify when the app is disconnected.
     *
     * @return {Observable<any>} Observable.
     */
    NetworkMock.prototype.onDisconnect = function () {
        var observable = new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Subject"]();
        window.addEventListener('offline', function (ev) {
            observable.next(ev);
        }, false);
        return observable;
    };
    NetworkMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], NetworkMock);
    return NetworkMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_network__["a" /* Network */]));

//# sourceMappingURL=network.js.map

/***/ }),
/* 1479 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PushMock; });
/* unused harmony export PushObjectMock */
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_push__ = __webpack_require__(254);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Emulates the Cordova Push plugin in desktop apps and in browser.
 */
var PushMock = /** @class */ (function () {
    function PushMock(appProvider) {
        this.appProvider = appProvider;
    }
    /**
     * Init push notifications
     *
     * @param {PushOptions} options
     * @return {PushObject}
     */
    PushMock.prototype.init = function (options) {
        return new PushObjectMock(this.appProvider);
    };
    /**
     * Check whether the push notification permission has been granted.
     *
     * @return {Promise<{isEnabled: boolean}>} Returns a Promise that resolves with an object with one property: isEnabled, a
     *                                         boolean that indicates if permission has been granted.
     */
    PushMock.prototype.hasPermission = function () {
        return Promise.reject('hasPermission is only supported in mobile devices');
    };
    /**
     * Create a new notification channel for Android O and above.
     *
     * @param {Channel} channel
     */
    PushMock.prototype.createChannel = function (channel) {
        return Promise.reject('createChannel is only supported in mobile devices');
    };
    /**
     * Delete a notification channel for Android O and above.
     *
     * @param {string} id
     */
    PushMock.prototype.deleteChannel = function (id) {
        return Promise.reject('deleteChannel is only supported in mobile devices');
    };
    /**
     * Returns a list of currently configured channels.
     *
     * @return {Promise<Channel[]>}
     */
    PushMock.prototype.listChannels = function () {
        return Promise.reject('listChannels is only supported in mobile devices');
    };
    PushMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */]])
    ], PushMock);
    return PushMock;
}());

/**
 * Emulates the PushObject class in desktop apps and in browser.
 */
var PushObjectMock = /** @class */ (function (_super) {
    __extends(PushObjectMock, _super);
    function PushObjectMock(appProvider) {
        var _this = _super.call(this, {}) || this;
        _this.appProvider = appProvider;
        return _this;
    }
    /**
     * Adds an event listener
     * @param event {string}
     * @return {Observable<EventResponse>}
     */
    PushObjectMock.prototype.on = function (event) {
        return __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].empty();
    };
    /**
     * The unregister method is used when the application no longer wants to receive push notifications.
     * Beware that this cleans up all event handlers previously registered,
     * so you will need to re-register them if you want them to function again without an application reload.
     */
    PushObjectMock.prototype.unregister = function () {
        return Promise.reject('unregister is only supported in mobile devices');
    };
    /**
     * Set the badge count visible when the app is not running
     *
     * The count is an integer indicating what number should show up in the badge.
     * Passing 0 will clear the badge.
     * Each notification event contains a data.count value which can be used to set the badge to correct number.
     *
     * @param count
     */
    PushObjectMock.prototype.setApplicationIconBadgeNumber = function (count) {
        if (!this.appProvider.isDesktop()) {
            return Promise.reject('setApplicationIconBadgeNumber is not supported in browser');
        }
        try {
            var app = __webpack_require__(70).remote.app;
            if (app.setBadgeCount(count)) {
                return Promise.resolve();
            }
            else {
                return Promise.reject(null);
            }
        }
        catch (ex) {
            return Promise.reject(ex);
        }
    };
    /**
     * Get the current badge count visible when the app is not running
     * successHandler gets called with an integer which is the current badge count
     */
    PushObjectMock.prototype.getApplicationIconBadgeNumber = function () {
        if (!this.appProvider.isDesktop()) {
            return Promise.reject('getApplicationIconBadgeNumber is not supported in browser');
        }
        try {
            var app = __webpack_require__(70).remote.app;
            return Promise.resolve(app.getBadgeCount());
        }
        catch (ex) {
            return Promise.reject(ex);
        }
    };
    /**
     * iOS only
     * Tells the OS that you are done processing a background push notification.
     * successHandler gets called when background push processing is successfully completed.
     * @param [id]
     */
    PushObjectMock.prototype.finish = function (id) {
        return Promise.reject('finish is only supported in mobile devices');
    };
    /**
     * Tells the OS to clear all notifications from the Notification Center
     */
    PushObjectMock.prototype.clearAllNotifications = function () {
        return Promise.reject('clearAllNotifications is only supported in mobile devices');
    };
    /**
     * The subscribe method is used when the application wants to subscribe a new topic to receive push notifications.
     * @param topic {string} Topic to subscribe to.
     * @return {Promise<any>}
     */
    PushObjectMock.prototype.subscribe = function (topic) {
        return Promise.reject('subscribe is only supported in mobile devices');
    };
    /**
     * The unsubscribe method is used when the application no longer wants to receive push notifications from a specific topic but
     * continue to receive other push messages.
     *
     * @param topic {string} Topic to unsubscribe from.
     * @return {Promise<any>}
     */
    PushObjectMock.prototype.unsubscribe = function (topic) {
        return Promise.reject('unsubscribe is only supported in mobile devices');
    };
    return PushObjectMock;
}(__WEBPACK_IMPORTED_MODULE_2__ionic_native_push__["b" /* PushObject */]));

//# sourceMappingURL=push.js.map

/***/ }),
/* 1480 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ZipMock; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_zip__ = __webpack_require__(342);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_jszip__ = __webpack_require__(1481);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_jszip___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_jszip__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_file__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Emulates the Cordova Zip plugin in desktop apps and in browser.
 */
var ZipMock = /** @class */ (function (_super) {
    __extends(ZipMock, _super);
    function ZipMock(file, textUtils) {
        var _this = _super.call(this) || this;
        _this.file = file;
        _this.textUtils = textUtils;
        return _this;
    }
    /**
     * Create a directory. It creates all the foldes in dirPath 1 by 1 to prevent errors.
     *
     * @param {string} destination Destination parent folder.
     * @param {string} dirPath Relative path to the folder.
     * @return {Promise<void>} Promise resolved when done.
     */
    ZipMock.prototype.createDir = function (destination, dirPath) {
        var _this = this;
        // Create all the folders 1 by 1 in order, otherwise it fails.
        var folders = dirPath.split('/');
        var promise = Promise.resolve();
        var _loop_1 = function (i) {
            var folder = folders[i];
            promise = promise.then(function () {
                return _this.file.createDir(destination, folder, true).then(function () {
                    // Folder created, add it to the destination path.
                    destination = _this.textUtils.concatenatePaths(destination, folder);
                });
            });
        };
        for (var i = 0; i < folders.length; i++) {
            _loop_1(i);
        }
        return promise;
    };
    /**
     * Extracts files from a ZIP archive.
     *
     * @param {string} source Path to the source ZIP file.
     * @param {string} destination Destination folder.
     * @param {Function} [onProgress] Optional callback to be called on progress update
     * @return {Promise<number>} Promise that resolves with a number. 0 is success, -1 is error.
     */
    ZipMock.prototype.unzip = function (source, destination, onProgress) {
        var _this = this;
        // Replace all %20 with spaces.
        source = source.replace(/%20/g, ' ');
        destination = destination.replace(/%20/g, ' ');
        var sourceDir = source.substring(0, source.lastIndexOf('/')), sourceName = source.substr(source.lastIndexOf('/') + 1), zip = new __WEBPACK_IMPORTED_MODULE_2_jszip__();
        // Read the file first.
        return this.file.readAsArrayBuffer(sourceDir, sourceName).then(function (data) {
            // Now load the file using the JSZip library.
            return zip.loadAsync(data);
        }).then(function () {
            if (!zip.files || !Object.keys(zip.files).length) {
                // Nothing to extract.
                return 0;
            }
            // First of all, create the directory where the files will be unzipped.
            var destParent = destination.substring(0, source.lastIndexOf('/')), destFolderName = destination.substr(source.lastIndexOf('/') + 1);
            return _this.file.createDir(destParent, destFolderName, false);
        }).then(function () {
            var promises = [], total = Object.keys(zip.files).length;
            var loaded = 0;
            var _loop_2 = function (name_1) {
                var file = zip.files[name_1];
                var promise = void 0;
                if (!file.dir) {
                    // It's a file.
                    var fileDir_1 = name_1.substring(0, name_1.lastIndexOf('/')), fileName_1 = name_1.substr(name_1.lastIndexOf('/') + 1), filePromises = [];
                    var fileData_1;
                    if (fileDir_1) {
                        // The file is in a subfolder, create it first.
                        filePromises.push(_this.createDir(destination, fileDir_1));
                    }
                    // Read the file contents as a Blob.
                    filePromises.push(file.async('blob').then(function (data) {
                        fileData_1 = data;
                    }));
                    promise = Promise.all(filePromises).then(function () {
                        // File read and parent folder created, now write the file.
                        var parentFolder = _this.textUtils.concatenatePaths(destination, fileDir_1);
                        return _this.file.writeFile(parentFolder, fileName_1, fileData_1, { replace: true });
                    });
                }
                else {
                    // It's a folder, create it if it doesn't exist.
                    promise = _this.createDir(destination, name_1);
                }
                promises.push(promise.then(function () {
                    // File unzipped, call the progress.
                    loaded++;
                    onProgress && onProgress({ loaded: loaded, total: total });
                }));
            };
            for (var name_1 in zip.files) {
                _loop_2(name_1);
            }
            return Promise.all(promises).then(function () {
                return 0;
            });
        }).catch(function () {
            // Error.
            return -1;
        });
    };
    ZipMock = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__ionic_native_file__["a" /* File */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], ZipMock);
    return ZipMock;
}(__WEBPACK_IMPORTED_MODULE_1__ionic_native_zip__["a" /* Zip */]));

//# sourceMappingURL=zip.js.map

/***/ }),
/* 1481 */,
/* 1482 */,
/* 1483 */
/***/ (function(module, exports) {

module.exports = require('stream');

/***/ }),
/* 1484 */,
/* 1485 */,
/* 1486 */,
/* 1487 */,
/* 1488 */,
/* 1489 */,
/* 1490 */,
/* 1491 */,
/* 1492 */,
/* 1493 */,
/* 1494 */,
/* 1495 */,
/* 1496 */,
/* 1497 */,
/* 1498 */,
/* 1499 */,
/* 1500 */,
/* 1501 */,
/* 1502 */,
/* 1503 */,
/* 1504 */,
/* 1505 */,
/* 1506 */,
/* 1507 */,
/* 1508 */,
/* 1509 */,
/* 1510 */,
/* 1511 */,
/* 1512 */,
/* 1513 */,
/* 1514 */,
/* 1515 */,
/* 1516 */,
/* 1517 */,
/* 1518 */,
/* 1519 */,
/* 1520 */,
/* 1521 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseDirectivesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__download_module_main_file__ = __webpack_require__(1522);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


var CoreCourseDirectivesModule = /** @class */ (function () {
    function CoreCourseDirectivesModule() {
    }
    CoreCourseDirectivesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_1__download_module_main_file__["a" /* CoreCourseDownloadModuleMainFileDirective */]
            ],
            imports: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_1__download_module_main_file__["a" /* CoreCourseDownloadModuleMainFileDirective */]
            ]
        })
    ], CoreCourseDirectivesModule);
    return CoreCourseDirectivesModule;
}());

//# sourceMappingURL=directives.module.js.map

/***/ }),
/* 1522 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCourseDownloadModuleMainFileDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Directive to allow downloading and open the main file of a module.
 * When the item with this directive is clicked, the module will be downloaded (if needed) and opened.
 * This is meant for modules like mod_resource.
 *
 * This directive must receive either a module or a moduleId. If no files are provided, it will use module.contents.
 */
var CoreCourseDownloadModuleMainFileDirective = /** @class */ (function () {
    function CoreCourseDownloadModuleMainFileDirective(element, domUtils, courseHelper, courseProvider) {
        this.domUtils = domUtils;
        this.courseHelper = courseHelper;
        this.courseProvider = courseProvider;
        this.element = element.nativeElement || element;
    }
    /**
     * Component being initialized.
     */
    CoreCourseDownloadModuleMainFileDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.element.addEventListener('click', function (ev) {
            if (!_this.module && !_this.moduleId) {
                return;
            }
            ev.preventDefault();
            ev.stopPropagation();
            var modal = _this.domUtils.showModalLoading(), courseId = typeof _this.courseId == 'string' ? parseInt(_this.courseId, 10) : _this.courseId;
            var promise;
            if (_this.module) {
                // We already have the module.
                promise = Promise.resolve(_this.module);
            }
            else {
                // Try to get the module from cache.
                _this.moduleId = typeof _this.moduleId == 'string' ? parseInt(_this.moduleId, 10) : _this.moduleId;
                promise = _this.courseProvider.getModule(_this.moduleId, courseId);
            }
            promise.then(function (module) {
                var componentId = _this.componentId || module.id;
                return _this.courseHelper.downloadModuleAndOpenFile(module, courseId, _this.component, componentId, _this.files);
            }).catch(function (error) {
                _this.domUtils.showErrorModalDefault(error, 'core.errordownloading', true);
            }).finally(function () {
                modal.dismiss();
            });
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseDownloadModuleMainFileDirective.prototype, "module", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseDownloadModuleMainFileDirective.prototype, "moduleId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseDownloadModuleMainFileDirective.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreCourseDownloadModuleMainFileDirective.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCourseDownloadModuleMainFileDirective.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreCourseDownloadModuleMainFileDirective.prototype, "files", void 0);
    CoreCourseDownloadModuleMainFileDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-course-download-module-main-file]'
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_course__["a" /* CoreCourseProvider */]])
    ], CoreCourseDownloadModuleMainFileDirective);
    return CoreCourseDownloadModuleMainFileDirective;
}());

//# sourceMappingURL=download-module-main-file.js.map

/***/ }),
/* 1523 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesCourseProgressComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__course_options_menu_course_options_menu__ = __webpack_require__(821);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};










/**
 * This component is meant to display a course for a list of courses with progress.
 *
 * Example usage:
 *
 * <core-courses-course-progress [course]="course">
 * </core-courses-course-progress>
 */
var CoreCoursesCourseProgressComponent = /** @class */ (function () {
    function CoreCoursesCourseProgressComponent(navCtrl, courseHelper, domUtils, courseProvider, eventsProvider, sitesProvider, coursesProvider, popoverCtrl, userProvider) {
        this.navCtrl = navCtrl;
        this.courseHelper = courseHelper;
        this.domUtils = domUtils;
        this.courseProvider = courseProvider;
        this.eventsProvider = eventsProvider;
        this.sitesProvider = sitesProvider;
        this.coursesProvider = coursesProvider;
        this.popoverCtrl = popoverCtrl;
        this.userProvider = userProvider;
        this.showAll = false; // If true, will show all actions, options, star and progress.
        this.showDownload = true; // If true, will show download button. Only works if the options menu is not shown.
        this.prefetchCourseData = {
            downloadSucceeded: false,
            prefetchCourseIcon: 'spinner',
            title: 'core.course.downloadcourse'
        };
        this.showSpinner = false;
        this.isDestroyed = false;
    }
    /**
     * Component being initialized.
     */
    CoreCoursesCourseProgressComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.downloadCourseEnabled = !this.coursesProvider.isDownloadCourseDisabledInSite();
        if (this.downloadCourseEnabled) {
            this.initPrefetchCourse();
        }
        // This field is only available from 3.6 onwards.
        this.courseOptionMenuEnabled = this.showAll && typeof this.course.isfavourite != 'undefined';
        // Refresh the enabled flag if site is updated.
        this.siteUpdatedObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function () {
            var wasEnabled = _this.downloadCourseEnabled;
            _this.downloadCourseEnabled = !_this.coursesProvider.isDownloadCourseDisabledInSite();
            if (!wasEnabled && _this.downloadCourseEnabled) {
                // Download course is enabled now, initialize it.
                _this.initPrefetchCourse();
            }
        }, this.sitesProvider.getCurrentSiteId());
    };
    /**
     * Initialize prefetch course.
     */
    CoreCoursesCourseProgressComponent.prototype.initPrefetchCourse = function () {
        var _this = this;
        if (typeof this.courseStatusObserver != 'undefined') {
            // Already initialized.
            return;
        }
        // Listen for status change in course.
        this.courseStatusObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].COURSE_STATUS_CHANGED, function (data) {
            if (data.courseId == _this.course.id || data.courseId == __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */].ALL_COURSES_CLEARED) {
                _this.updateCourseStatus(data.status);
            }
        }, this.sitesProvider.getCurrentSiteId());
        // Determine course prefetch icon.
        this.courseHelper.getCourseStatusIconAndTitle(this.course.id).then(function (data) {
            _this.prefetchCourseData.prefetchCourseIcon = data.icon;
            _this.prefetchCourseData.title = data.title;
            if (data.icon == 'spinner') {
                // Course is being downloaded. Get the download promise.
                var promise = _this.courseHelper.getCourseDownloadPromise(_this.course.id);
                if (promise) {
                    // There is a download promise. If it fails, show an error.
                    promise.catch(function (error) {
                        if (!_this.isDestroyed) {
                            _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
                        }
                    });
                }
                else {
                    // No download, this probably means that the app was closed while downloading. Set previous status.
                    _this.courseProvider.setCoursePreviousStatus(_this.course.id);
                }
            }
        });
    };
    /**
     * Open a course.
     *
     * @param {any} course The course to open.
     */
    CoreCoursesCourseProgressComponent.prototype.openCourse = function (course) {
        this.courseHelper.openCourse(this.navCtrl, course);
    };
    /**
     * Prefetch the course.
     *
     * @param {Event} e Click event.
     */
    CoreCoursesCourseProgressComponent.prototype.prefetchCourse = function (e) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        this.courseHelper.confirmAndPrefetchCourse(this.prefetchCourseData, this.course).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'core.course.errordownloadingcourse', true);
            }
        });
    };
    /**
     * Update the course status icon and title.
     *
     * @param {string} status Status to show.
     */
    CoreCoursesCourseProgressComponent.prototype.updateCourseStatus = function (status) {
        var statusData = this.courseHelper.getCourseStatusIconAndTitleFromStatus(status);
        this.prefetchCourseData.prefetchCourseIcon = statusData.icon;
        this.prefetchCourseData.title = statusData.title;
    };
    /**
     * Show the context menu.
     *
     * @param {Event} e Click Event.
     */
    CoreCoursesCourseProgressComponent.prototype.showCourseOptionsMenu = function (e) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        var popover = this.popoverCtrl.create(__WEBPACK_IMPORTED_MODULE_9__course_options_menu_course_options_menu__["a" /* CoreCoursesCourseOptionsMenuComponent */], {
            course: this.course,
            prefetch: this.prefetchCourseData
        });
        popover.onDidDismiss(function (action) {
            if (action) {
                switch (action) {
                    case 'download':
                        if (_this.prefetchCourseData.prefetchCourseIcon != 'spinner') {
                            _this.prefetchCourse(e);
                        }
                        break;
                    case 'hide':
                        _this.setCourseHidden(true);
                        break;
                    case 'show':
                        _this.setCourseHidden(false);
                        break;
                    case 'favourite':
                        _this.setCourseFavourite(true);
                        break;
                    case 'unfavourite':
                        _this.setCourseFavourite(false);
                        break;
                    default:
                        break;
                }
            }
        });
        popover.present({
            ev: e
        });
    };
    /**
     * Hide/Unhide the course from the course list.
     *
     * @param {boolean} hide True to hide and false to show.
     */
    CoreCoursesCourseProgressComponent.prototype.setCourseHidden = function (hide) {
        var _this = this;
        this.showSpinner = true;
        // We should use null to unset the preference.
        this.userProvider.updateUserPreference('block_myoverview_hidden_course_' + this.course.id, hide ? 1 : null).then(function () {
            _this.course.hidden = hide;
            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_MY_COURSES_UPDATED, { course: _this.course }, _this.sitesProvider.getCurrentSiteId());
        }).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'Error changing course visibility.');
            }
        }).finally(function () {
            _this.showSpinner = false;
        });
    };
    /**
     * Favourite/Unfavourite the course from the course list.
     *
     * @param {boolean} favourite True to favourite and false to unfavourite.
     */
    CoreCoursesCourseProgressComponent.prototype.setCourseFavourite = function (favourite) {
        var _this = this;
        this.showSpinner = true;
        this.coursesProvider.setFavouriteCourse(this.course.id, favourite).then(function () {
            _this.course.isfavourite = favourite;
            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */].EVENT_MY_COURSES_UPDATED, { course: _this.course }, _this.sitesProvider.getCurrentSiteId());
        }).catch(function (error) {
            if (!_this.isDestroyed) {
                _this.domUtils.showErrorModalDefault(error, 'Error changing course favourite attribute.');
            }
        }).finally(function () {
            _this.showSpinner = false;
        });
    };
    /**
     * Component destroyed.
     */
    CoreCoursesCourseProgressComponent.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.siteUpdatedObserver && this.siteUpdatedObserver.off();
        this.courseStatusObserver && this.courseStatusObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCoursesCourseProgressComponent.prototype, "course", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCoursesCourseProgressComponent.prototype, "showAll", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCoursesCourseProgressComponent.prototype, "showDownload", void 0);
    CoreCoursesCourseProgressComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-courses-course-progress',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\course-progress\core-courses-course-progress.html"*/'<ion-card [attr.course-color]="course.id % 10">\n    <div (click)="openCourse(course)" class="core-course-thumb" [class.core-course-color-img]="course.courseImage">\n        <img *ngIf="course.courseImage" [src]="course.courseImage" core-external-content alt=""/>\n    </div>\n    <ion-item tappable text-wrap detail-none (click)="openCourse(course)" [title]="course.displayname || course.fullname" class="core-course-link" [class.item-disabled]="course.visible == 0" [class.core-course-more-than-title]="(course.progress != null && course.progress >= 0)">\n        <div class="core-course-title" [class.core-course-with-buttons]="courseOptionMenuEnabled || (downloadCourseEnabled && showDownload)">\n            <p *ngIf="course.displayname && course.shortname && course.fullname != course.displayname" class="core-course-shortname"><core-format-text [text]="course.shortname"></core-format-text></p>\n            <h2>\n                <core-icon name="fa-star" *ngIf="course.isfavourite"></core-icon>\n                <core-format-text [text]="course.fullname"></core-format-text>\n            </h2>\n        </div>\n\n        <div class="core-button-spinner" *ngIf="downloadCourseEnabled && !courseOptionMenuEnabled && showDownload">\n            <!-- Download course. -->\n            <button *ngIf="prefetchCourseData.prefetchCourseIcon != \'spinner\'" ion-button icon-only clear color="dark" (click)="prefetchCourse($event)" [attr.aria-label]="prefetchCourseData.title | translate">\n                <core-icon *ngIf="!prefetchCourseData.downloadSucceeded" [name]="prefetchCourseData.prefetchCourseIcon"></core-icon>\n                <ion-icon *ngIf="prefetchCourseData.downloadSucceeded" name="cloud-done" color="success" [attr.aria-label]="\'core.downloaded\' | translate" role="status"></ion-icon>\n            </button>\n            <!-- Download course spinner. -->\n            <ion-spinner *ngIf="prefetchCourseData.prefetchCourseIcon == \'spinner\'"></ion-spinner>\n        </div>\n\n        <div class="core-button-spinner" *ngIf="courseOptionMenuEnabled">\n            <!-- Download course spinner. -->\n            <ion-spinner *ngIf="(downloadCourseEnabled && prefetchCourseData.prefetchCourseIcon == \'spinner\') || showSpinner"></ion-spinner>\n\n            <!-- Downloaded icon. -->\n             <ion-icon *ngIf="downloadCourseEnabled && prefetchCourseData.downloadSucceeded && !showSpinner" class="core-icon-downloaded" name="cloud-done" color="success" [attr.aria-label]="\'core.downloaded\' | translate" role="status"></ion-icon>\n\n            <!-- Options menu. -->\n            <button ion-button icon-only clear color="dark" (click)="showCourseOptionsMenu($event)" *ngIf="!showSpinner">\n                <core-icon name="more"></core-icon>\n            </button>\n        </div>\n    </ion-item>\n    <ion-item *ngIf="showAll && course.progress != null && course.progress >= 0 && course.completionusertracked !== false">\n        <core-progress-bar [progress]="course.progress"></core-progress-bar>\n    </ion-item>\n    <ng-content></ng-content>\n</ion-card>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\course-progress\core-courses-course-progress.html"*/
        }),
        __param(0, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_8__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_6__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["x" /* PopoverController */], __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__["a" /* CoreUserProvider */]])
    ], CoreCoursesCourseProgressComponent);
    return CoreCoursesCourseProgressComponent;
}());

//# sourceMappingURL=course-progress.js.map

/***/ }),
/* 1524 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCoursesCourseListItemComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};





/**
 * This directive is meant to display an item for a list of courses.
 *
 * Example usage:
 *
 * <core-courses-course-list-item [course]="course"></core-courses-course-list-item>
 */
var CoreCoursesCourseListItemComponent = /** @class */ (function () {
    function CoreCoursesCourseListItemComponent(navCtrl, translate, coursesProvider, courseHelper) {
        this.navCtrl = navCtrl;
        this.translate = translate;
        this.coursesProvider = coursesProvider;
        this.courseHelper = courseHelper;
    }
    /**
     * Component being initialized.
     */
    CoreCoursesCourseListItemComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Check if the user is enrolled in the course.
        this.coursesProvider.getUserCourse(this.course.id).then(function () {
            _this.course.isEnrolled = true;
        }).catch(function () {
            _this.course.isEnrolled = false;
            _this.course.enrollment = [];
            _this.course.enrollmentmethods.forEach(function (instance) {
                if (instance === 'self') {
                    _this.course.enrollment.push({
                        name: _this.translate.instant('core.courses.selfenrolment'),
                        icon: 'unlock'
                    });
                }
                else if (instance === 'guest') {
                    _this.course.enrollment.push({
                        name: _this.translate.instant('core.courses.allowguests'),
                        icon: 'person'
                    });
                }
                else if (instance === 'paypal') {
                    _this.course.enrollment.push({
                        name: _this.translate.instant('core.courses.paypalaccepted'),
                        img: 'assets/img/icons/paypal.png'
                    });
                }
            });
            if (_this.course.enrollment.length == 0) {
                _this.course.enrollment.push({
                    name: _this.translate.instant('core.courses.notenrollable'),
                    icon: 'lock'
                });
            }
        });
    };
    /**
     * Open a course.
     *
     * @param {any} course The course to open.
     */
    CoreCoursesCourseListItemComponent.prototype.openCourse = function (course) {
        if (course.isEnrolled) {
            this.courseHelper.openCourse(this.navCtrl, course);
        }
        else {
            this.navCtrl.push('CoreCoursesCoursePreviewPage', { course: course });
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreCoursesCourseListItemComponent.prototype, "course", void 0);
    CoreCoursesCourseListItemComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-courses-course-list-item',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\course-list-item\core-courses-course-list-item.html"*/'<a ion-item text-wrap (click)="openCourse(course)" [class.item-disabled]="course.visible == 0" [title]="course.displayname || course.fullname">\n    <core-icon name="fa-graduation-cap" fixed-width item-start></core-icon>\n    <h2><core-format-text [text]="course.displayname || course.fullname"></core-format-text></h2>\n    <div item-end>\n        <span *ngIf="!course.isEnrolled">\n            <span ion-button icon-only clear color="gray" *ngFor="let instance of course.enrollment" [attr.aria-label]=" instance.name | translate">\n                <core-icon *ngIf="instance.icon" [name]="instance.icon"></core-icon>\n                <img *ngIf="instance.img && !instance.icon" [src]="instance.img" class="core-course-enrollment-img">\n            </span>\n        </span>\n    </div>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\courses\components\course-list-item\core-courses-course-list-item.html"*/
        }),
        __param(0, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_3__providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], CoreCoursesCourseListItemComponent);
    return CoreCoursesCourseListItemComponent;
}());

//# sourceMappingURL=course-list-item.js.map

/***/ }),
/* 1525 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsDirectivesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__call_ws__ = __webpack_require__(1526);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__call_ws_new_content__ = __webpack_require__(1527);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__call_ws_on_load__ = __webpack_require__(1528);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__new_content__ = __webpack_require__(1529);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var CoreSitePluginsDirectivesModule = /** @class */ (function () {
    function CoreSitePluginsDirectivesModule() {
    }
    CoreSitePluginsDirectivesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_1__call_ws__["a" /* CoreSitePluginsCallWSDirective */],
                __WEBPACK_IMPORTED_MODULE_2__call_ws_new_content__["a" /* CoreSitePluginsCallWSNewContentDirective */],
                __WEBPACK_IMPORTED_MODULE_3__call_ws_on_load__["a" /* CoreSitePluginsCallWSOnLoadDirective */],
                __WEBPACK_IMPORTED_MODULE_4__new_content__["a" /* CoreSitePluginsNewContentDirective */]
            ],
            imports: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_1__call_ws__["a" /* CoreSitePluginsCallWSDirective */],
                __WEBPACK_IMPORTED_MODULE_2__call_ws_new_content__["a" /* CoreSitePluginsCallWSNewContentDirective */],
                __WEBPACK_IMPORTED_MODULE_3__call_ws_on_load__["a" /* CoreSitePluginsCallWSOnLoadDirective */],
                __WEBPACK_IMPORTED_MODULE_4__new_content__["a" /* CoreSitePluginsNewContentDirective */]
            ]
        })
    ], CoreSitePluginsDirectivesModule);
    return CoreSitePluginsDirectivesModule;
}());

//# sourceMappingURL=directives.module.js.map

/***/ }),
/* 1526 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCallWSDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_call_ws_click_directive__ = __webpack_require__(822);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_plugin_content_plugin_content__ = __webpack_require__(126);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};








/**
 * Directive to call a WS when the element is clicked. The action to do when the WS call is successful depends on the input data:
 * display a message, go back or refresh current view.
 *
 * If you want to load a new content when the WS call is done, @see CoreSitePluginsCallWSNewContentDirective.
 *
 * @see CoreSitePluginsCallWSOnClickBaseDirective.
 *
 * Example usages:
 *
 * A button to send some data to the server without using cache, displaying default messages and refreshing on success:
 *
 * <button ion-button core-site-plugins-call-ws name="mod_certificate_view_certificate"
 *             [params]="{certificateid: <% certificate.id %>}" [preSets]="{getFromCache: 0, saveToCache: 0}" confirmMessage
 *             successMessage refreshOnSuccess="true">
 *     {{ 'plugin.mod_certificate_coursecertificate.senddata' | translate }}
 * </button>
 *
 * A button to send some data to the server using cache, without confirm, going back on success and using userid from otherdata:
 *
 * <button ion-button core-site-plugins-call-ws name="mod_certificate_view_certificate"
 *             [params]="{certificateid: <% certificate.id %>}" goBackOnSuccess="true" [useOtherData]="['userid']">
 *     {{ 'plugin.mod_certificate_coursecertificate.senddata' | translate }}
 * </button>
 */
var CoreSitePluginsCallWSDirective = /** @class */ (function (_super) {
    __extends(CoreSitePluginsCallWSDirective, _super);
    function CoreSitePluginsCallWSDirective(element, translate, domUtils, sitePluginsProvider, parentContent, utils, navCtrl) {
        var _this = _super.call(this, element, translate, domUtils, sitePluginsProvider, parentContent, utils) || this;
        _this.navCtrl = navCtrl;
        return _this;
    }
    /**
     * Function called when the WS call is successful.
     *
     * @param {any} result Result of the WS call.
     */
    CoreSitePluginsCallWSDirective.prototype.wsCallSuccess = function (result) {
        if (typeof this.successMessage != 'undefined') {
            // Display the success message.
            this.domUtils.showToast(this.successMessage || this.translate.instant('core.success'));
        }
        if (this.utils.isTrueOrOne(this.goBackOnSuccess)) {
            this.navCtrl.pop();
        }
        else if (this.utils.isTrueOrOne(this.refreshOnSuccess) && this.parentContent) {
            this.parentContent.refreshContent(true);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCallWSDirective.prototype, "successMessage", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSDirective.prototype, "goBackOnSuccess", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSDirective.prototype, "refreshOnSuccess", void 0);
    CoreSitePluginsCallWSDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-site-plugins-call-ws]'
        }),
        __param(4, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_7__components_plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], CoreSitePluginsCallWSDirective);
    return CoreSitePluginsCallWSDirective;
}(__WEBPACK_IMPORTED_MODULE_6__classes_call_ws_click_directive__["a" /* CoreSitePluginsCallWSOnClickBaseDirective */]));

//# sourceMappingURL=call-ws.js.map

/***/ }),
/* 1527 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCallWSNewContentDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__classes_call_ws_click_directive__ = __webpack_require__(822);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_plugin_content_plugin_content__ = __webpack_require__(126);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};








/**
 * Directive to call a WS when the element is clicked and load a new content passing the WS result as args. This new content
 * can be displayed in a new page or in the same page (only if current page is already displaying a site plugin content).
 *
 * If you don't need to load some new content when done, @see CoreSitePluginsCallWSDirective.
 *
 * @see CoreSitePluginsCallWSOnClickBaseDirective.
 *
 * Example usages:
 *
 * A button to get some data from the server without using cache, showing default confirm and displaying a new page:
 *
 * <button ion-button core-site-plugins-call-ws-new-content name="mod_certificate_get_issued_certificates"
 *             [params]="{certificateid: <% certificate.id %>}" [preSets]="{getFromCache: 0, saveToCache: 0}" confirmMessage
 *             title="<% certificate.name %>" component="mod_certificate" method="mobile_issues_view"
 *             [args]="{cmid: <% cmid %>, courseid: <% courseid %>}">
 *     {{ 'plugin.mod_certificate_coursecertificate.getissued' | translate }}
 * </button>
 *
 * A button to get some data from the server using cache, without confirm, displaying new content in same page and using
 * userid from otherdata:
 *
 * <button ion-button core-site-plugins-call-ws-new-content name="mod_certificate_get_issued_certificates"
 *             [params]="{certificateid: <% certificate.id %>}" component="mod_certificate" method="mobile_issues_view"
 *             [args]="{cmid: <% cmid %>, courseid: <% courseid %>}" samePage="true" [useOtherData]="['userid']">
 *     {{ 'plugin.mod_certificate_coursecertificate.getissued' | translate }}
 * </button>
 */
var CoreSitePluginsCallWSNewContentDirective = /** @class */ (function (_super) {
    __extends(CoreSitePluginsCallWSNewContentDirective, _super);
    function CoreSitePluginsCallWSNewContentDirective(element, translate, domUtils, sitePluginsProvider, parentContent, utils, navCtrl) {
        var _this = _super.call(this, element, translate, domUtils, sitePluginsProvider, parentContent, utils) || this;
        _this.navCtrl = navCtrl;
        return _this;
    }
    /**
     * Function called when the WS call is successful.
     *
     * @param {any} result Result of the WS call.
     */
    CoreSitePluginsCallWSNewContentDirective.prototype.wsCallSuccess = function (result) {
        var args = this.args || {};
        if (this.parentContent) {
            args = this.sitePluginsProvider.loadOtherDataInArgs(this.args, this.parentContent.otherData, this.useOtherData);
        }
        // Add the properties from the WS call result to the args.
        args = Object.assign(args, result);
        if (this.utils.isTrueOrOne(this.samePage)) {
            // Update the parent content (if it exists).
            if (this.parentContent) {
                this.parentContent.updateContent(args, this.component, this.method, this.jsData);
            }
        }
        else {
            var jsData = this.jsData;
            if (jsData === true && this.parentContent) {
                jsData = this.parentContent.data;
            }
            this.navCtrl.push('CoreSitePluginsPluginPage', {
                title: this.title,
                component: this.component || (this.parentContent && this.parentContent.component),
                method: this.method || (this.parentContent && this.parentContent.method),
                args: args,
                initResult: this.parentContent && this.parentContent.initResult,
                jsData: jsData,
                preSets: this.newContentPreSets
            });
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "method", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "args", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "title", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "samePage", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "useOtherData", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "jsData", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsCallWSNewContentDirective.prototype, "newContentPreSets", void 0);
    CoreSitePluginsCallWSNewContentDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-site-plugins-call-ws-new-content]'
        }),
        __param(4, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __param(6, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_7__components_plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */]])
    ], CoreSitePluginsCallWSNewContentDirective);
    return CoreSitePluginsCallWSNewContentDirective;
}(__WEBPACK_IMPORTED_MODULE_6__classes_call_ws_click_directive__["a" /* CoreSitePluginsCallWSOnClickBaseDirective */]));

//# sourceMappingURL=call-ws-new-content.js.map

/***/ }),
/* 1528 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCallWSOnLoadDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__classes_call_ws_directive__ = __webpack_require__(823);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_plugin_content_plugin_content__ = __webpack_require__(126);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};






/**
 * Directive to call a WS as soon as its loaded.
 * This directive is meant for actions to do in the background, like calling logging WebServices.
 *
 * If you want to call a WS when the user clicks on a certain element, @see CoreSitePluginsCallWSDirective.
 *
 * @see CoreSitePluginsCallWSBaseDirective.
 *
 * Example usage:
 *
 * <span core-site-plugins-call-ws-on-load name="mod_certificate_view_certificate" [params]="{certificateid: <% certificate.id %>}"
 *     [preSets]="{getFromCache: 0, saveToCache: 0}"></span>
 */
var CoreSitePluginsCallWSOnLoadDirective = /** @class */ (function (_super) {
    __extends(CoreSitePluginsCallWSOnLoadDirective, _super);
    function CoreSitePluginsCallWSOnLoadDirective(element, translate, domUtils, sitePluginsProvider, parentContent) {
        return _super.call(this, element, translate, domUtils, sitePluginsProvider, parentContent) || this;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsCallWSOnLoadDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        // Call the WS immediately.
        this.callWS().catch(function () {
            // Ignore errors.
        });
    };
    CoreSitePluginsCallWSOnLoadDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-site-plugins-call-ws-on-load]'
        }),
        __param(4, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_5__components_plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */]])
    ], CoreSitePluginsCallWSOnLoadDirective);
    return CoreSitePluginsCallWSOnLoadDirective;
}(__WEBPACK_IMPORTED_MODULE_4__classes_call_ws_directive__["a" /* CoreSitePluginsCallWSBaseDirective */]));

//# sourceMappingURL=call-ws-on-load.js.map

/***/ }),
/* 1529 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsNewContentDirective; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_plugin_content_plugin_content__ = __webpack_require__(126);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};






/**
 * Directive to display a new site plugin content when clicked. This new content can be displayed in a new page or in the
 * current page (only if the current page is already displaying a site plugin content).
 *
 * Example usages:
 *
 * A button to go to a new content page:
 *
 * <button ion-button core-site-plugins-new-content title="<% certificate.name %>" component="mod_certificate"
 *             method="mobile_issues_view" [args]="{cmid: <% cmid %>, courseid: <% courseid %>}">
 *     {{ 'plugin.mod_certificate_coursecertificate.viewissued' | translate }}
 * </button>
 *
 * A button to load new content in current page using a param from otherdata:
 *
 * <button ion-button core-site-plugins-new-content component="mod_certificate" method="mobile_issues_view"
 *         [args]="{cmid: <% cmid %>, courseid: <% courseid %>}" samePage="true" [useOtherData]="['userid']">
 *     {{ 'plugin.mod_certificate_coursecertificate.viewissued' | translate }}
 * </button>
 */
var CoreSitePluginsNewContentDirective = /** @class */ (function () {
    function CoreSitePluginsNewContentDirective(element, utils, navCtrl, parentContent, domUtils, sitePluginsProvider) {
        this.utils = utils;
        this.navCtrl = navCtrl;
        this.parentContent = parentContent;
        this.domUtils = domUtils;
        this.sitePluginsProvider = sitePluginsProvider;
        this.element = element.nativeElement || element;
    }
    /**
     * Component being initialized.
     */
    CoreSitePluginsNewContentDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.element.addEventListener('click', function (ev) {
            ev.preventDefault();
            ev.stopPropagation();
            var args = _this.args || {};
            if (_this.parentContent) {
                args = _this.sitePluginsProvider.loadOtherDataInArgs(_this.args, _this.parentContent.otherData, _this.useOtherData);
            }
            if (_this.form && document.forms[_this.form]) {
                args = Object.assign(args, _this.domUtils.getDataFromForm(document.forms[_this.form]));
            }
            if (_this.utils.isTrueOrOne(_this.samePage)) {
                // Update the parent content (if it exists).
                if (_this.parentContent) {
                    _this.parentContent.updateContent(args, _this.component, _this.method, _this.jsData);
                }
            }
            else {
                var jsData = _this.jsData;
                if (jsData === true) {
                    jsData = _this.parentContent && _this.parentContent.data || {};
                }
                _this.navCtrl.push('CoreSitePluginsPluginPage', {
                    title: _this.title,
                    component: _this.component || (_this.parentContent && _this.parentContent.component),
                    method: _this.method || (_this.parentContent && _this.parentContent.method),
                    args: args,
                    initResult: _this.parentContent && _this.parentContent.initResult,
                    jsData: jsData,
                    preSets: _this.preSets
                });
            }
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsNewContentDirective.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsNewContentDirective.prototype, "method", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsNewContentDirective.prototype, "args", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsNewContentDirective.prototype, "title", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsNewContentDirective.prototype, "samePage", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Array)
    ], CoreSitePluginsNewContentDirective.prototype, "useOtherData", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreSitePluginsNewContentDirective.prototype, "form", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsNewContentDirective.prototype, "jsData", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreSitePluginsNewContentDirective.prototype, "preSets", void 0);
    CoreSitePluginsNewContentDirective = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Directive"])({
            selector: '[core-site-plugins-new-content]'
        }),
        __param(2, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __param(3, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["ElementRef"], __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_5__components_plugin_content_plugin_content__["a" /* CoreSitePluginsPluginContentComponent */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_siteplugins__["a" /* CoreSitePluginsProvider */]])
    ], CoreSitePluginsNewContentDirective);
    return CoreSitePluginsNewContentDirective;
}());

//# sourceMappingURL=new-content.js.map

/***/ }),
/* 1530 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeAllCourseListComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__ = __webpack_require__(32);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to open the page to view the list of all courses.
 */
var CoreSiteHomeAllCourseListComponent = /** @class */ (function () {
    function CoreSiteHomeAllCourseListComponent(coursesProvider) {
        this.show = coursesProvider.isGetCoursesByFieldAvailable();
    }
    CoreSiteHomeAllCourseListComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-sitehome-all-course-list',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\all-course-list\core-sitehome-all-course-list.html"*/'<a *ngIf="show" ion-item text-wrap [navPush]="\'CoreCoursesAvailableCoursesPage\'">\n    <core-icon name="fa-graduation-cap" fixed-width item-start></core-icon>\n    <h2>{{ \'core.courses.availablecourses\' | translate}}</h2>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\all-course-list\core-sitehome-all-course-list.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreSiteHomeAllCourseListComponent);
    return CoreSiteHomeAllCourseListComponent;
}());

//# sourceMappingURL=all-course-list.js.map

/***/ }),
/* 1531 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeCategoriesComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__ = __webpack_require__(32);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to open the page to view the list of categories.
 */
var CoreSiteHomeCategoriesComponent = /** @class */ (function () {
    function CoreSiteHomeCategoriesComponent(coursesProvider) {
        this.show = coursesProvider.isGetCoursesByFieldAvailable();
    }
    CoreSiteHomeCategoriesComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-sitehome-categories',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\categories\core-sitehome-categories.html"*/'<a *ngIf="show" ion-item text-wrap [navPush]="\'CoreCoursesCategoriesPage\'">\n    <ion-icon name="folder" item-start></ion-icon>\n    <h2>{{ \'core.courses.categories\' | translate}}</h2>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\categories\core-sitehome-categories.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreSiteHomeCategoriesComponent);
    return CoreSiteHomeCategoriesComponent;
}());

//# sourceMappingURL=categories.js.map

/***/ }),
/* 1532 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeCourseSearchComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__ = __webpack_require__(32);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to open the page to search courses.
 */
var CoreSiteHomeCourseSearchComponent = /** @class */ (function () {
    function CoreSiteHomeCourseSearchComponent(coursesProvider) {
        this.show = !coursesProvider.isSearchCoursesDisabledInSite();
    }
    CoreSiteHomeCourseSearchComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-sitehome-course-search',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\course-search\core-sitehome-course-search.html"*/'<a *ngIf="show" ion-item text-wrap [navPush]="\'CoreCoursesSearchPage\'">\n    <ion-icon name="search" item-start></ion-icon>\n    <h2>{{ \'core.courses.searchcourses\' | translate}}</h2>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\course-search\core-sitehome-course-search.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreSiteHomeCourseSearchComponent);
    return CoreSiteHomeCourseSearchComponent;
}());

//# sourceMappingURL=course-search.js.map

/***/ }),
/* 1533 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeEnrolledCourseListComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__ = __webpack_require__(32);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Component to open the page to view the list of courses the user is enrolled in.
 */
var CoreSiteHomeEnrolledCourseListComponent = /** @class */ (function () {
    function CoreSiteHomeEnrolledCourseListComponent(coursesProvider) {
        this.coursesProvider = coursesProvider;
    }
    /**
     * Component being initialized.
     */
    CoreSiteHomeEnrolledCourseListComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.coursesProvider.isMyCoursesDisabledInSite()) {
            this.show = false;
        }
        else {
            this.coursesProvider.getUserCourses().then(function (courses) {
                _this.show = courses.length > 0;
            });
        }
    };
    CoreSiteHomeEnrolledCourseListComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-sitehome-enrolled-course-list',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\enrolled-course-list\core-sitehome-enrolled-course-list.html"*/'<a *ngIf="show" ion-item text-wrap [navPush]="\'CoreCoursesMyCoursesPage\'">\n    <core-icon name="fa-graduation-cap" fixed-width item-start></core-icon>\n    <h2>{{ \'core.courses.mycourses\' | translate}}</h2>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\enrolled-course-list\core-sitehome-enrolled-course-list.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_courses_providers_courses__["a" /* CoreCoursesProvider */]])
    ], CoreSiteHomeEnrolledCourseListComponent);
    return CoreSiteHomeEnrolledCourseListComponent;
}());

//# sourceMappingURL=enrolled-course-list.js.map

/***/ }),
/* 1534 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSiteHomeNewsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sitehome__ = __webpack_require__(171);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays site home news.
 */
var CoreSiteHomeNewsComponent = /** @class */ (function () {
    function CoreSiteHomeNewsComponent(sitesProvider, courseProvider, moduleDelegate, siteHomeProvider) {
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.moduleDelegate = moduleDelegate;
        this.siteHomeProvider = siteHomeProvider;
        this.siteHomeId = sitesProvider.getCurrentSite().getSiteHomeId();
    }
    /**
     * Component being initialized.
     */
    CoreSiteHomeNewsComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Get number of news items to show.
        var currentSite = this.sitesProvider.getCurrentSite(), newsItems = currentSite.getStoredConfig('newsitems') || 0;
        if (!newsItems) {
            return;
        }
        var siteHomeId = currentSite.getSiteHomeId();
        // Get the news forum.
        this.siteHomeProvider.getNewsForum(siteHomeId).then(function (forum) {
            return _this.courseProvider.getModuleBasicInfo(forum.cmid).then(function (module) {
                _this.show = true;
                _this.module = module;
                module.handlerData = _this.moduleDelegate.getModuleDataFor(module.modname, module, siteHomeId, module.section);
            });
        }).catch(function () {
            // Ignore errors.
        });
    };
    CoreSiteHomeNewsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-sitehome-news',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\news\core-sitehome-news.html"*/'<core-course-module class="core-sitehome-news" *ngIf="show" [module]="module" [courseId]="siteHomeId"></core-course-module>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\sitehome\components\news\core-sitehome-news.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_sitehome__["a" /* CoreSiteHomeProvider */]])
    ], CoreSiteHomeNewsComponent);
    return CoreSiteHomeNewsComponent;
}());

//# sourceMappingURL=news.js.map

/***/ }),
/* 1535 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBadgesUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__badges__ = __webpack_require__(186);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Profile badges handler.
 */
var AddonBadgesUserHandler = /** @class */ (function () {
    function AddonBadgesUserHandler(badgesProvider) {
        this.badgesProvider = badgesProvider;
        this.name = 'AddonBadges';
        this.priority = 50;
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_NEW_PAGE;
    }
    /**
     * Check if handler is enabled.
     *
     * @return {Promise<boolean>} Always enabled.
     */
    AddonBadgesUserHandler.prototype.isEnabled = function () {
        return this.badgesProvider.isPluginEnabled();
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user     User to check.
     * @param {number} courseId Course ID.
     * @param  {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param  {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return  {boolean}   True if enabled, false otherwise.
     */
    AddonBadgesUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        if (navOptions && typeof navOptions.badges != 'undefined') {
            return navOptions.badges;
        }
        // If we reach here, it means we are opening the user site profile.
        return true;
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonBadgesUserHandler.prototype.getDisplayData = function (user, courseId) {
        return {
            icon: 'trophy',
            title: 'addon.badges.badges',
            class: '',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                navCtrl.push('AddonBadgesUserBadgesPage', { courseId: courseId, userId: user.id });
            }
        };
    };
    AddonBadgesUserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__badges__["a" /* AddonBadgesProvider */]])
    ], AddonBadgesUserHandler);
    return AddonBadgesUserHandler;
}());

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1536 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBadgesMyBadgesLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__badges__ = __webpack_require__(186);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to user badges page.
 */
var AddonBadgesMyBadgesLinkHandler = /** @class */ (function (_super) {
    __extends(AddonBadgesMyBadgesLinkHandler, _super);
    function AddonBadgesMyBadgesLinkHandler(badgesProvider, loginHelper) {
        var _this = _super.call(this) || this;
        _this.badgesProvider = badgesProvider;
        _this.loginHelper = loginHelper;
        _this.name = 'AddonBadgesMyBadgesLinkHandler';
        _this.featureName = 'CoreUserDelegate_AddonBadges';
        _this.pattern = /\/badges\/mybadges\.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonBadgesMyBadgesLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.loginHelper.redirect('AddonBadgesUserBadgesPage', {}, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonBadgesMyBadgesLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.badgesProvider.isPluginEnabled(siteId);
    };
    AddonBadgesMyBadgesLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__badges__["a" /* AddonBadgesProvider */], __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], AddonBadgesMyBadgesLinkHandler);
    return AddonBadgesMyBadgesLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=mybadges-link-handler.js.map

/***/ }),
/* 1537 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBadgesBadgeLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__badges__ = __webpack_require__(186);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to user participants page.
 */
var AddonBadgesBadgeLinkHandler = /** @class */ (function (_super) {
    __extends(AddonBadgesBadgeLinkHandler, _super);
    function AddonBadgesBadgeLinkHandler(badgesProvider, loginHelper) {
        var _this = _super.call(this) || this;
        _this.badgesProvider = badgesProvider;
        _this.loginHelper = loginHelper;
        _this.name = 'AddonBadgesBadgeLinkHandler';
        _this.pattern = /\/badges\/badge\.php.*([\?\&]hash=)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonBadgesBadgeLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.loginHelper.redirect('AddonBadgesIssuedBadgePage', { courseId: 0, badgeHash: params.hash }, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonBadgesBadgeLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.badgesProvider.isPluginEnabled(siteId);
    };
    AddonBadgesBadgeLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__badges__["a" /* AddonBadgesProvider */], __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], AddonBadgesBadgeLinkHandler);
    return AddonBadgesBadgeLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=badge-link-handler.js.map

/***/ }),
/* 1538 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBadgesPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__badges__ = __webpack_require__(186);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler for badges push notifications clicks.
 */
var AddonBadgesPushClickHandler = /** @class */ (function () {
    function AddonBadgesPushClickHandler(utils, badgesProvider, loginHelper) {
        this.utils = utils;
        this.badgesProvider = badgesProvider;
        this.loginHelper = loginHelper;
        this.name = 'AddonBadgesPushClickHandler';
        this.priority = 200;
        this.featureName = 'CoreUserDelegate_AddonBadges';
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonBadgesPushClickHandler.prototype.handles = function (notification) {
        var data = notification.customdata || {};
        if (this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'moodle' &&
            (notification.name == 'badgerecipientnotice' || (notification.name == 'badgecreatornotice' && data.hash))) {
            return this.badgesProvider.isPluginEnabled(notification.site);
        }
        return false;
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBadgesPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var data = notification.customdata || {};
        if (data.hash) {
            // We have the hash, open the badge directly.
            return this.loginHelper.redirect('AddonBadgesIssuedBadgePage', { courseId: 0, badgeHash: data.hash }, notification.site);
        }
        // No hash, open the list of user badges.
        return this.badgesProvider.invalidateUserBadges(0, Number(notification.usertoid), notification.site).catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.loginHelper.redirect('AddonBadgesUserBadgesPage', {}, notification.site);
        });
    };
    AddonBadgesPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__badges__["a" /* AddonBadgesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], AddonBadgesPushClickHandler);
    return AddonBadgesPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1539 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCalendarMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__calendar__ = __webpack_require__(281);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to inject an option into main menu.
 */
var AddonCalendarMainMenuHandler = /** @class */ (function () {
    function AddonCalendarMainMenuHandler(calendarProvider) {
        this.calendarProvider = calendarProvider;
        this.name = 'AddonCalendar';
        this.priority = 900;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonCalendarMainMenuHandler.prototype.isEnabled = function () {
        return !this.calendarProvider.isCalendarDisabledInSite();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data needed to render the handler.
     */
    AddonCalendarMainMenuHandler.prototype.getDisplayData = function () {
        return {
            icon: 'calendar',
            title: 'addon.calendar.calendar',
            page: 'AddonCalendarListPage',
            class: 'addon-calendar-handler'
        };
    };
    AddonCalendarMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__calendar__["a" /* AddonCalendarProvider */]])
    ], AddonCalendarMainMenuHandler);
    return AddonCalendarMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 1540 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyCourseOptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_course_course__ = __webpack_require__(764);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Course nav handler.
 */
var AddonCompetencyCourseOptionHandler = /** @class */ (function () {
    function AddonCompetencyCourseOptionHandler(competencyProvider) {
        this.competencyProvider = competencyProvider;
        this.name = 'AddonCompetency';
        this.priority = 300;
    }
    /**
     * Whether or not the handler is enabled ona site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonCompetencyCourseOptionHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether or not the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonCompetencyCourseOptionHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        if (accessData && accessData.type == __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__["a" /* CoreCourseProvider */].ACCESS_GUEST) {
            return false; // Not enabled for guests.
        }
        if (navOptions && typeof navOptions.competencies != 'undefined') {
            return navOptions.competencies;
        }
        return this.competencyProvider.isPluginForCourseEnabled(courseId).then(function (competencies) {
            return competencies ? !competencies.canmanagecoursecompetencies : false;
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {Injector} injector Injector.
     * @param {number} courseId The course ID.
     * @return {CoreCourseOptionsHandlerData|Promise<CoreCourseOptionsHandlerData>} Data or promise resolved with the data.
     */
    AddonCompetencyCourseOptionHandler.prototype.getDisplayData = function (injector, courseId) {
        return {
            title: 'addon.competency.competencies',
            class: 'addon-competency-course-handler',
            component: __WEBPACK_IMPORTED_MODULE_2__components_course_course__["a" /* AddonCompetencyCourseComponent */]
        };
    };
    /**
     * Should invalidate the data to determine if the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonCompetencyCourseOptionHandler.prototype.invalidateEnabledForCourse = function (courseId, navOptions, admOptions) {
        if (navOptions && typeof navOptions.competencies != 'undefined') {
            // No need to invalidate anything.
            return Promise.resolve();
        }
        return this.competencyProvider.invalidateCourseCompetencies(courseId);
    };
    /**
     * Called when a course is downloaded. It should prefetch all the data to be able to see the addon in offline.
     *
     * @param {any} course The course.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonCompetencyCourseOptionHandler.prototype.prefetch = function (course) {
        var _this = this;
        // Get the competencies in the course.
        return this.competencyProvider.getCourseCompetencies(course.id, undefined, undefined, true).then(function (competencies) {
            var promises = [];
            // Prefetch all the competencies.
            if (competencies && competencies.competencies) {
                competencies.competencies.forEach(function (competency) {
                    promises.push(_this.competencyProvider.getCompetencyInCourse(course.id, competency.competency.id, undefined, undefined, true));
                    promises.push(_this.competencyProvider.getCompetencySummary(competency.competency.id, undefined, undefined, true));
                });
            }
            return Promise.all(promises);
        });
    };
    AddonCompetencyCourseOptionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_competency__["a" /* AddonCompetencyProvider */]])
    ], AddonCompetencyCourseOptionHandler);
    return AddonCompetencyCourseOptionHandler;
}());

//# sourceMappingURL=course-option-handler.js.map

/***/ }),
/* 1541 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to inject an option into main menu.
 */
var AddonCompetencyMainMenuHandler = /** @class */ (function () {
    function AddonCompetencyMainMenuHandler(competencyProvider) {
        this.competencyProvider = competencyProvider;
        this.name = 'AddonCompetency';
        this.priority = 500;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonCompetencyMainMenuHandler.prototype.isEnabled = function () {
        // Check the user has at least one learn plan available.
        return this.competencyProvider.getLearningPlans().then(function (plans) {
            return plans.length > 0;
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data needed to render the handler.
     */
    AddonCompetencyMainMenuHandler.prototype.getDisplayData = function () {
        return {
            icon: 'map',
            title: 'addon.competency.myplans',
            page: 'AddonCompetencyPlanListPage',
            class: 'addon-competency-handler'
        };
    };
    AddonCompetencyMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__competency__["a" /* AddonCompetencyProvider */]])
    ], AddonCompetencyMainMenuHandler);
    return AddonCompetencyMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 1542 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Profile competencies handler.
 */
var AddonCompetencyUserHandler = /** @class */ (function () {
    function AddonCompetencyUserHandler(linkHelper, sitesProvider, competencyProvider, eventsProvider) {
        this.linkHelper = linkHelper;
        this.sitesProvider = sitesProvider;
        this.competencyProvider = competencyProvider;
        this.name = 'AddonCompetency:learningPlan';
        this.priority = 900;
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_NEW_PAGE;
        this.participantsNavEnabledCache = {};
        this.usersNavEnabledCache = {};
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].LOGOUT, this.clearUsersNavCache.bind(this));
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__core_user_providers_user__["a" /* CoreUserProvider */].PROFILE_REFRESHED, this.clearUsersNavCache.bind(this));
    }
    /**
     * Clear users nav cache.
     */
    AddonCompetencyUserHandler.prototype.clearUsersNavCache = function () {
        this.participantsNavEnabledCache = {};
        this.usersNavEnabledCache = {};
    };
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonCompetencyUserHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user     User to check.
     * @param {number} courseId Course ID.
     * @param  {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param  {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return  {boolean|Promise<boolean>}   Promise resolved with true if enabled, resolved with false otherwise.
     */
    AddonCompetencyUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        var _this = this;
        if (courseId) {
            var cacheKey_1 = courseId + '.' + user.id;
            // Link on a user course profile.
            if (typeof this.participantsNavEnabledCache[cacheKey_1] != 'undefined') {
                return this.participantsNavEnabledCache[cacheKey_1];
            }
            return this.competencyProvider.getCourseCompetencies(courseId, user.id).then(function (response) {
                var enabled = response.competencies.length > 0;
                _this.participantsNavEnabledCache[cacheKey_1] = enabled;
                return enabled;
            }).catch(function (message) {
                _this.participantsNavEnabledCache[cacheKey_1] = false;
                return false;
            });
        }
        else {
            // Link on a user site profile.
            if (typeof this.usersNavEnabledCache[user.id] != 'undefined') {
                return this.usersNavEnabledCache[user.id];
            }
            return this.competencyProvider.getLearningPlans(user.id).then(function (plans) {
                // Check the user has at least one learn plan available.
                var enabled = plans.length > 0;
                _this.usersNavEnabledCache[user.id] = enabled;
                return enabled;
            });
        }
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonCompetencyUserHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        if (courseId) {
            return {
                icon: 'ribbon',
                title: 'addon.competency.competencies',
                class: 'addon-competency-handler',
                action: function (event, navCtrl, user, courseId) {
                    event.preventDefault();
                    event.stopPropagation();
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, 'AddonCompetencyCourseCompetenciesPage', { courseId: courseId, userId: user.id });
                }
            };
        }
        else {
            return {
                icon: 'map',
                title: 'addon.competency.learningplans',
                class: 'addon-competency-handler',
                action: function (event, navCtrl, user, courseId) {
                    event.preventDefault();
                    event.stopPropagation();
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, 'AddonCompetencyPlanListPage', { userId: user.id });
                }
            };
        }
    };
    AddonCompetencyUserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__competency__["a" /* AddonCompetencyProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */]])
    ], AddonCompetencyUserHandler);
    return AddonCompetencyUserHandler;
}());

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1543 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyCompetencyLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to a competency in a plan or in a course.
 */
var AddonCompetencyCompetencyLinkHandler = /** @class */ (function (_super) {
    __extends(AddonCompetencyCompetencyLinkHandler, _super);
    function AddonCompetencyCompetencyLinkHandler(linkHelper, competencyProvider) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.competencyProvider = competencyProvider;
        _this.name = 'AddonCompetencyCompetencyLinkHandler';
        _this.pattern = /\/admin\/tool\/lp\/(user_competency_in_course|user_competency_in_plan)\.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonCompetencyCompetencyLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    _this.linkHelper.goInSite(navCtrl, 'AddonCompetencyCompetencyPage', {
                        planId: params.planid,
                        competencyId: params.competencyid,
                        courseId: courseId,
                        userId: params.userid
                    }, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonCompetencyCompetencyLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        // Handler is disabled if all competency features are disabled.
        return this.competencyProvider.allCompetenciesDisabled(siteId).then(function (disabled) {
            return !disabled;
        });
    };
    AddonCompetencyCompetencyLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__competency__["a" /* AddonCompetencyProvider */]])
    ], AddonCompetencyCompetencyLinkHandler);
    return AddonCompetencyCompetencyLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=competency-link-handler.js.map

/***/ }),
/* 1544 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyPlanLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to a plan.
 */
var AddonCompetencyPlanLinkHandler = /** @class */ (function (_super) {
    __extends(AddonCompetencyPlanLinkHandler, _super);
    function AddonCompetencyPlanLinkHandler(linkHelper, competencyProvider) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.competencyProvider = competencyProvider;
        _this.name = 'AddonCompetencyPlanLinkHandler';
        _this.pattern = /\/admin\/tool\/lp\/plan\.php.*([\?\&]id=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonCompetencyPlanLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    _this.linkHelper.goInSite(navCtrl, 'AddonCompetencyPlanPage', { planId: params.id }, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonCompetencyPlanLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        // Handler is disabled if all competency features are disabled.
        return this.competencyProvider.allCompetenciesDisabled(siteId).then(function (disabled) {
            return !disabled;
        });
    };
    AddonCompetencyPlanLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__competency__["a" /* AddonCompetencyProvider */]])
    ], AddonCompetencyPlanLinkHandler);
    return AddonCompetencyPlanLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=plan-link-handler.js.map

/***/ }),
/* 1545 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyPlansLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to user plans.
 */
var AddonCompetencyPlansLinkHandler = /** @class */ (function (_super) {
    __extends(AddonCompetencyPlansLinkHandler, _super);
    function AddonCompetencyPlansLinkHandler(loginHelper, competencyProvider) {
        var _this = _super.call(this) || this;
        _this.loginHelper = loginHelper;
        _this.competencyProvider = competencyProvider;
        _this.name = 'AddonCompetencyPlansLinkHandler';
        _this.pattern = /\/admin\/tool\/lp\/plans\.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonCompetencyPlansLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.loginHelper.redirect('AddonCompetencyPlanListPage', { userId: params.userid }, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonCompetencyPlansLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        // Handler is disabled if all competency features are disabled.
        return this.competencyProvider.allCompetenciesDisabled(siteId).then(function (disabled) {
            return !disabled;
        });
    };
    AddonCompetencyPlansLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__competency__["a" /* AddonCompetencyProvider */]])
    ], AddonCompetencyPlansLinkHandler);
    return AddonCompetencyPlansLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=plans-link-handler.js.map

/***/ }),
/* 1546 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyUserCompetencyLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to a usr competency.
 */
var AddonCompetencyUserCompetencyLinkHandler = /** @class */ (function (_super) {
    __extends(AddonCompetencyUserCompetencyLinkHandler, _super);
    function AddonCompetencyUserCompetencyLinkHandler(linkHelper, competencyProvider) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.competencyProvider = competencyProvider;
        _this.name = 'AddonCompetencyUserCompetencyLinkHandler';
        _this.pattern = /\/admin\/tool\/lp\/user_competency\.php.*([\?\&]id=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonCompetencyUserCompetencyLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    _this.linkHelper.goInSite(navCtrl, 'AddonCompetencyCompetencySummaryPage', { competencyId: params.id }, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonCompetencyUserCompetencyLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        // Handler is disabled if all competency features are disabled.
        return this.competencyProvider.allCompetenciesDisabled(siteId).then(function (disabled) {
            return !disabled;
        });
    };
    AddonCompetencyUserCompetencyLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__competency__["a" /* AddonCompetencyProvider */]])
    ], AddonCompetencyUserCompetencyLinkHandler);
    return AddonCompetencyUserCompetencyLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=user-competency-link-handler.js.map

/***/ }),
/* 1547 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCompetencyPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__competency__ = __webpack_require__(98);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler for competencies push notifications clicks.
 */
var AddonCompetencyPushClickHandler = /** @class */ (function () {
    function AddonCompetencyPushClickHandler(utils, urlUtils, competencyProvider, loginHelper) {
        this.utils = utils;
        this.urlUtils = urlUtils;
        this.competencyProvider = competencyProvider;
        this.loginHelper = loginHelper;
        this.name = 'AddonCompetencyPushClickHandler';
        this.priority = 200;
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonCompetencyPushClickHandler.prototype.handles = function (notification) {
        if (this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'moodle' &&
            (notification.name == 'competencyplancomment' || notification.name == 'competencyusercompcomment')) {
            // If all competency features are disabled, don't handle the click.
            return this.competencyProvider.allCompetenciesDisabled(notification.site).then(function (disabled) {
                return !disabled;
            });
        }
        return false;
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonCompetencyPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var contextUrlParams = this.urlUtils.extractUrlParams(notification.contexturl);
        if (notification.name == 'competencyplancomment') {
            // Open the learning plan.
            var planId_1 = Number(contextUrlParams.id);
            return this.competencyProvider.invalidateLearningPlan(planId_1, notification.site).catch(function () {
                // Ignore errors.
            }).then(function () {
                return _this.loginHelper.redirect('AddonCompetencyPlanPage', { planId: planId_1 }, notification.site);
            });
        }
        else {
            if (notification.contexturl && notification.contexturl.indexOf('user_competency_in_plan.php') != -1) {
                // Open the competency.
                var courseId_1 = Number(notification.course), competencyId_1 = Number(contextUrlParams.competencyid), planId_2 = Number(contextUrlParams.planid), userId_1 = Number(contextUrlParams.userid);
                return this.competencyProvider.invalidateCompetencyInPlan(planId_2, competencyId_1, notification.site).catch(function () {
                    // Ignore errors.
                }).then(function () {
                    return _this.loginHelper.redirect('AddonCompetencyCompetencyPage', {
                        planId: planId_2,
                        competencyId: competencyId_1,
                        courseId: courseId_1,
                        userId: userId_1
                    }, notification.site);
                });
            }
            else {
                // Open the list of plans.
                var userId_2 = Number(contextUrlParams.userid);
                return this.competencyProvider.invalidateLearningPlans(userId_2, notification.site).catch(function () {
                    // Ignore errors.
                }).then(function () {
                    return _this.loginHelper.redirect('AddonCompetencyPlanListPage', { userId: userId_2 }, notification.site);
                });
            }
        }
    };
    AddonCompetencyPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__competency__["a" /* AddonCompetencyProvider */], __WEBPACK_IMPORTED_MODULE_3__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], AddonCompetencyPushClickHandler);
    return AddonCompetencyPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1548 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonFilesMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__files__ = __webpack_require__(283);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to inject an option into main menu.
 */
var AddonFilesMainMenuHandler = /** @class */ (function () {
    function AddonFilesMainMenuHandler(filesProvider) {
        this.filesProvider = filesProvider;
        this.name = 'AddonFiles';
        this.priority = 400;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonFilesMainMenuHandler.prototype.isEnabled = function () {
        return this.filesProvider.isPluginEnabled();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data needed to render the handler.
     */
    AddonFilesMainMenuHandler.prototype.getDisplayData = function () {
        return {
            icon: 'folder',
            title: 'addon.files.files',
            page: 'AddonFilesListPage',
            class: 'addon-files-handler'
        };
    };
    AddonFilesMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__files__["a" /* AddonFilesProvider */]])
    ], AddonFilesMainMenuHandler);
    return AddonFilesMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 1549 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__messages__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_emulator_providers_helper__ = __webpack_require__(211);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Handler to inject an option into main menu.
 */
var AddonMessagesMainMenuHandler = /** @class */ (function () {
    function AddonMessagesMainMenuHandler(messagesProvider, sitesProvider, eventsProvider, appProvider, localNotificationsProvider, textUtils, pushNotificationsProvider, utils, pushNotificationsDelegate, emulatorHelper) {
        var _this = this;
        this.messagesProvider = messagesProvider;
        this.sitesProvider = sitesProvider;
        this.appProvider = appProvider;
        this.localNotificationsProvider = localNotificationsProvider;
        this.textUtils = textUtils;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.emulatorHelper = emulatorHelper;
        this.name = 'AddonMessages';
        this.priority = 800;
        this.handler = {
            icon: 'chatbubbles',
            title: 'addon.messages.messages',
            page: 'AddonMessagesIndexPage',
            class: 'addon-messages-handler',
            showBadge: true,
            badge: '',
            loading: true
        };
        this.unreadCount = 0;
        this.contactRequestsCount = 0;
        this.orMore = false;
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__messages__["a" /* AddonMessagesProvider */].UNREAD_CONVERSATION_COUNTS_EVENT, function (data) {
            _this.unreadCount = data.favourites + data.individual + data.group + data.self;
            _this.orMore = data.orMore;
            _this.updateBadge(data.siteId);
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__messages__["a" /* AddonMessagesProvider */].CONTACT_REQUESTS_COUNT_EVENT, function (data) {
            _this.contactRequestsCount = data.count;
            _this.updateBadge(data.siteId);
        });
        // Reset info on logout.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function (data) {
            _this.unreadCount = 0;
            _this.contactRequestsCount = 0;
            _this.orMore = false;
            _this.handler.badge = '';
            _this.handler.loading = true;
        });
        // If a message push notification is received, refresh the count.
        pushNotificationsDelegate.on('receive').subscribe(function (notification) {
            // New message received. If it's from current site, refresh the data.
            var isMessage = utils.isFalseOrZero(notification.notif) || notification.name == 'messagecontactrequests';
            if (isMessage && _this.sitesProvider.isCurrentSite(notification.site)) {
                _this.refreshBadge(notification.site);
            }
        });
        // Register Badge counter.
        pushNotificationsDelegate.registerCounterHandler('AddonMessages');
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonMessagesMainMenuHandler.prototype.isEnabled = function () {
        return this.messagesProvider.isPluginEnabled();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerToDisplay} Data needed to render the handler.
     */
    AddonMessagesMainMenuHandler.prototype.getDisplayData = function () {
        this.handler.page = this.messagesProvider.isGroupMessagingEnabled() ?
            'AddonMessagesGroupConversationsPage' : 'AddonMessagesIndexPage';
        if (this.handler.loading) {
            this.refreshBadge();
        }
        return this.handler;
    };
    /**
     * Refreshes badge number.
     *
     * @param {string} [siteId] Site ID or current Site if undefined.
     * @param {boolean} [unreadOnly] If true only the unread conversations count is refreshed.
     * @return {Promise<any>} Resolve when done.
     */
    AddonMessagesMainMenuHandler.prototype.refreshBadge = function (siteId, unreadOnly) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!siteId) {
            return;
        }
        var promises = [];
        promises.push(this.messagesProvider.refreshUnreadConversationCounts(siteId).catch(function () {
            _this.unreadCount = 0;
            _this.orMore = false;
        }));
        // Refresh the number of contact requests in 3.6+ sites.
        if (!unreadOnly && this.messagesProvider.isGroupMessagingEnabled()) {
            promises.push(this.messagesProvider.refreshContactRequestsCount(siteId).catch(function () {
                _this.contactRequestsCount = 0;
            }));
        }
        return Promise.all(promises).finally(function () {
            _this.updateBadge(siteId);
            _this.handler.loading = false;
        });
    };
    /**
     * Update badge number and push notifications counter from loaded data.
     *
     * @param {string} siteId Site ID.
     */
    AddonMessagesMainMenuHandler.prototype.updateBadge = function (siteId) {
        var totalCount = this.unreadCount + (this.contactRequestsCount || 0);
        if (totalCount > 0) {
            this.handler.badge = totalCount + (this.orMore ? '+' : '');
        }
        else {
            this.handler.badge = '';
        }
        // Update push notifications badge.
        this.pushNotificationsProvider.updateAddonCounter('AddonMessages', totalCount, siteId);
    };
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonMessagesMainMenuHandler.prototype.execute = function (siteId, force) {
        if (this.sitesProvider.isCurrentSite(siteId)) {
            this.refreshBadge();
        }
        if (this.appProvider.isDesktop() && this.localNotificationsProvider.isAvailable()) {
            this.emulatorHelper.checkNewNotifications(__WEBPACK_IMPORTED_MODULE_1__messages__["a" /* AddonMessagesProvider */].PUSH_SIMULATION_COMPONENT, this.fetchMessages.bind(this), this.getTitleAndText.bind(this), siteId);
        }
        return Promise.resolve();
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonMessagesMainMenuHandler.prototype.getInterval = function () {
        if (this.appProvider.isDesktop()) {
            return 60000; // Desktop usually has a WiFi connection, check it every minute.
        }
        else if (this.messagesProvider.isGroupMessagingEnabled() || this.messagesProvider.isMessageCountEnabled()) {
            return 300000; // We have a WS to check the number, check it every 5 minutes.
        }
        else {
            return 600000; // Check it every 10 minutes.
        }
    };
    /**
     * Whether it's a synchronization process or not.
     *
     * @return {boolean} True if is a sync process, false otherwise.
     */
    AddonMessagesMainMenuHandler.prototype.isSync = function () {
        // This is done to use only wifi if using the fallback function.
        if (this.appProvider.isDesktop()) {
            // In desktop it is always sync, since it fetches messages to see if there's a new one.
            return true;
        }
        return !this.messagesProvider.isMessageCountEnabled() && !this.messagesProvider.isGroupMessagingEnabled();
    };
    /**
     * Whether the process should be executed during a manual sync.
     *
     * @return {boolean} True if is a manual sync process, false otherwise.
     */
    AddonMessagesMainMenuHandler.prototype.canManualSync = function () {
        return true;
    };
    /**
     * Get the latest unread received messages from a site.
     *
     * @param  {string} [siteId] Site ID. Default current.
     * @return {Promise<any>}    Promise resolved with the notifications.
     */
    AddonMessagesMainMenuHandler.prototype.fetchMessages = function (siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (site.isVersionGreaterEqualThan('3.7')) {
                // Use get conversations WS to be able to get group conversations messages.
                return _this.messagesProvider.getConversations(undefined, undefined, 0, site.id, undefined, false, true)
                    .then(function (result) {
                    // Find the first unmuted conversation.
                    var conv = result.conversations.find(function (conversation) {
                        return !conversation.ismuted;
                    });
                    if (conv.isread) {
                        // The conversation is read, no unread messages.
                        return [];
                    }
                    var currentUserId = site.getUserId(), message = conv.messages[0]; // Treat only the last message, is the one we're interested.
                    if (!message || message.useridfrom == currentUserId) {
                        // No last message or not from current user. Return empty list.
                        return [];
                    }
                    // Add some calculated data.
                    message.contexturl = '';
                    message.contexturlname = '';
                    message.convid = conv.id;
                    message.fullmessage = message.text;
                    message.fullmessageformat = 0;
                    message.fullmessagehtml = '';
                    message.notification = 0;
                    message.read = 0;
                    message.smallmessage = message.smallmessage || message.text;
                    message.subject = conv.name;
                    message.timecreated = message.timecreated * 1000;
                    message.timeread = 0;
                    message.useridto = currentUserId;
                    message.usertofullname = site.getInfo().fullname;
                    var userFrom = conv.members.find(function (member) {
                        return member.id == message.useridfrom;
                    });
                    message.userfromfullname = userFrom && userFrom.fullname;
                    return [message];
                });
            }
            else {
                return _this.messagesProvider.getUnreadReceivedMessages(true, false, true, siteId).then(function (response) {
                    return response.messages;
                });
            }
        });
    };
    /**
     * Given a message, return the title and the text for the message.
     *
     * @param  {any} message Message.
     * @return {Promise<any>}        Promise resolved with an object with title and text.
     */
    AddonMessagesMainMenuHandler.prototype.getTitleAndText = function (message) {
        var data = {
            title: message.name || message.userfromfullname,
        };
        return this.textUtils.formatText(message.text, true, true).catch(function () {
            return message.text;
        }).then(function (formattedText) {
            data['text'] = formattedText;
            return data;
        });
    };
    AddonMessagesMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__messages__["a" /* AddonMessagesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */], __WEBPACK_IMPORTED_MODULE_10__core_emulator_providers_helper__["a" /* CoreEmulatorHelperProvider */]])
    ], AddonMessagesMainMenuHandler);
    return AddonMessagesMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 1550 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesSendMessageUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__messages__ = __webpack_require__(91);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Profile send message handler.
 */
var AddonMessagesSendMessageUserHandler = /** @class */ (function () {
    function AddonMessagesSendMessageUserHandler(linkHelper, sitesProvider, messagesProvider) {
        this.linkHelper = linkHelper;
        this.sitesProvider = sitesProvider;
        this.messagesProvider = messagesProvider;
        this.name = 'AddonMessages:sendMessage';
        this.priority = 1000;
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_COMMUNICATION;
    }
    /**
     * Check if handler is enabled.
     *
     * @return {Promise<any>} Promise resolved with true if enabled, rejected or resolved with false otherwise.
     */
    AddonMessagesSendMessageUserHandler.prototype.isEnabled = function () {
        return this.messagesProvider.isPluginEnabled();
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user          User to check.
     * @param {number} courseId   Course ID.
     * @param  {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param  {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return  {boolean|Promise<boolean>}   Promise resolved with true if enabled, resolved with false otherwise.
     */
    AddonMessagesSendMessageUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        var currentSite = this.sitesProvider.getCurrentSite();
        if (!currentSite) {
            return false;
        }
        // From 3.7 you can send messages to yourself.
        return user.id != currentSite.getUserId() || currentSite.isVersionGreaterEqualThan('3.7');
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonMessagesSendMessageUserHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        return {
            icon: 'send',
            title: 'addon.messages.message',
            class: 'addon-messages-send-message-handler',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                var pageParams = {
                    showKeyboard: true,
                    userId: user.id
                };
                // Always use redirect to make it the new history root (to avoid "loops" in history).
                _this.linkHelper.goInSite(navCtrl, 'AddonMessagesDiscussionPage', pageParams);
            }
        };
    };
    AddonMessagesSendMessageUserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__messages__["a" /* AddonMessagesProvider */]])
    ], AddonMessagesSendMessageUserHandler);
    return AddonMessagesSendMessageUserHandler;
}());

//# sourceMappingURL=user-send-message-handler.js.map

/***/ }),
/* 1551 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesContactRequestLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__messages__ = __webpack_require__(91);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Content links handler for a contact requests.
 */
var AddonMessagesContactRequestLinkHandler = /** @class */ (function (_super) {
    __extends(AddonMessagesContactRequestLinkHandler, _super);
    function AddonMessagesContactRequestLinkHandler(linkHelper, messagesProvider) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.messagesProvider = messagesProvider;
        _this.name = 'AddonMessagesContactRequestLinkHandler';
        _this.pattern = /\/message\/pendingcontactrequests\.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonMessagesContactRequestLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, 'AddonMessagesContactsPage', {}, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonMessagesContactRequestLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        var _this = this;
        return this.messagesProvider.isPluginEnabled(siteId).then(function (enabled) {
            if (!enabled) {
                return false;
            }
            return _this.messagesProvider.isGroupMessagingEnabled();
        });
    };
    AddonMessagesContactRequestLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__messages__["a" /* AddonMessagesProvider */]])
    ], AddonMessagesContactRequestLinkHandler);
    return AddonMessagesContactRequestLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=contact-request-link-handler.js.map

/***/ }),
/* 1552 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesDiscussionLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__messages__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Content links handler for a discussion.
 * Match message index URL with params id, user1 or user2.
 */
var AddonMessagesDiscussionLinkHandler = /** @class */ (function (_super) {
    __extends(AddonMessagesDiscussionLinkHandler, _super);
    function AddonMessagesDiscussionLinkHandler(linkHelper, messagesProvider, sitesProvider) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.messagesProvider = messagesProvider;
        _this.sitesProvider = sitesProvider;
        _this.name = 'AddonMessagesDiscussionLinkHandler';
        _this.pattern = /\/message\/index\.php.*([\?\&](id|user1|user2)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonMessagesDiscussionLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var stateParams = {
                        userId: parseInt(params.id || params.user2, 10)
                    };
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, 'AddonMessagesDiscussionPage', stateParams, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonMessagesDiscussionLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        var _this = this;
        return this.messagesProvider.isPluginEnabled(siteId).then(function (enabled) {
            if (!enabled) {
                return false;
            }
            if (typeof params.id == 'undefined' && typeof params.user2 == 'undefined') {
                // Other user not defined, cannot treat the URL.
                return false;
            }
            if (typeof params.user1 != 'undefined') {
                // Check if user1 is the current user, since the app only supports current user.
                return _this.sitesProvider.getSite(siteId).then(function (site) {
                    return parseInt(params.user1, 10) == site.getUserId();
                });
            }
            return true;
        });
    };
    AddonMessagesDiscussionLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__messages__["a" /* AddonMessagesProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonMessagesDiscussionLinkHandler);
    return AddonMessagesDiscussionLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=discussion-link-handler.js.map

/***/ }),
/* 1553 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__messages__ = __webpack_require__(91);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Content links handler for messaging index.
 * Match message index URL without params id, user1 or user2.
 */
var AddonMessagesIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonMessagesIndexLinkHandler, _super);
    function AddonMessagesIndexLinkHandler(linkHelper, messagesProvider) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.messagesProvider = messagesProvider;
        _this.name = 'AddonMessagesIndexLinkHandler';
        _this.pattern = /\/message\/index\.php((?![\?\&](id|user1|user2)=\d+).)*$/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonMessagesIndexLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var pageName = 'AddonMessagesIndexPage';
                    if (_this.messagesProvider.isGroupMessagingEnabled()) {
                        pageName = 'AddonMessagesGroupConversationsPage';
                    }
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.linkHelper.goInSite(navCtrl, pageName, undefined, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonMessagesIndexLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.messagesProvider.isPluginEnabled(siteId);
    };
    AddonMessagesIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__messages__["a" /* AddonMessagesProvider */]])
    ], AddonMessagesIndexLinkHandler);
    return AddonMessagesIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1554 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(420);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonMessagesSyncCronHandler = /** @class */ (function () {
    function AddonMessagesSyncCronHandler(messagesSync) {
        this.messagesSync = messagesSync;
        this.name = 'AddonMessagesSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonMessagesSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.messagesSync.syncAllDiscussions(siteId);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonMessagesSyncCronHandler.prototype.getInterval = function () {
        return 300000; // 5 minutes.
    };
    AddonMessagesSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonMessagesSyncProvider */]])
    ], AddonMessagesSyncCronHandler);
    return AddonMessagesSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1555 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__messages__ = __webpack_require__(91);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler for messaging push notifications clicks.
 */
var AddonMessagesPushClickHandler = /** @class */ (function () {
    function AddonMessagesPushClickHandler(utils, messagesProvider, loginHelper) {
        this.utils = utils;
        this.messagesProvider = messagesProvider;
        this.loginHelper = loginHelper;
        this.name = 'AddonMessagesPushClickHandler';
        this.priority = 200;
        this.featureName = 'CoreMainMenuDelegate_AddonMessages';
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonMessagesPushClickHandler.prototype.handles = function (notification) {
        if (this.utils.isTrueOrOne(notification.notif) && notification.name != 'messagecontactrequests') {
            return false;
        }
        // Check that messaging is enabled.
        return this.messagesProvider.isPluginEnabled(notification.site);
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonMessagesPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        return this.messagesProvider.invalidateDiscussionsCache(notification.site).catch(function () {
            // Ignore errors.
        }).then(function () {
            // Check if group messaging is enabled, to determine which page should be loaded.
            return _this.messagesProvider.isGroupMessagingEnabledInSite(notification.site).then(function (enabled) {
                var pageParams = {};
                var pageName = 'AddonMessagesIndexPage';
                if (enabled) {
                    pageName = 'AddonMessagesGroupConversationsPage';
                }
                // Check if we have enough information to open the conversation.
                if (notification.convid && enabled) {
                    pageParams.conversationId = Number(notification.convid);
                }
                else if (notification.userfromid) {
                    pageParams.discussionUserId = Number(notification.userfromid);
                }
                return _this.loginHelper.redirect(pageName, pageParams, notification.site);
            });
        });
    };
    AddonMessagesPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__messages__["a" /* AddonMessagesProvider */],
            __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], AddonMessagesPushClickHandler);
    return AddonMessagesPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1556 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessagesSettingsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__messages__ = __webpack_require__(91);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Message settings handler.
 */
var AddonMessagesSettingsHandler = /** @class */ (function () {
    function AddonMessagesSettingsHandler(messagesProvider) {
        this.messagesProvider = messagesProvider;
        this.name = 'AddonMessages';
        this.priority = 600;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean | Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonMessagesSettingsHandler.prototype.isEnabled = function () {
        return this.messagesProvider.isMessagePreferencesEnabled();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreSettingsHandlerData} Data needed to render the handler.
     */
    AddonMessagesSettingsHandler.prototype.getDisplayData = function () {
        return {
            icon: 'chatbubbles',
            title: 'addon.messages.messagepreferences',
            page: 'AddonMessagesSettingsPage',
            class: 'addon-messages-settings-handler'
        };
    };
    AddonMessagesSettingsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__messages__["a" /* AddonMessagesProvider */]])
    ], AddonMessagesSettingsHandler);
    return AddonMessagesSettingsHandler;
}());

//# sourceMappingURL=settings-handler.js.map

/***/ }),
/* 1557 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_index_index__ = __webpack_require__(421);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support assign modules.
 */
var AddonModAssignModuleHandler = /** @class */ (function () {
    function AddonModAssignModuleHandler(courseProvider, assignProvider) {
        this.courseProvider = courseProvider;
        this.assignProvider = assignProvider;
        this.name = 'AddonModAssign';
        this.modName = 'assign';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_ADVANCED_GRADING] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_PLAGIARISM] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMMENT] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModAssignModuleHandler.prototype.isEnabled = function () {
        return this.assignProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModAssignModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_assign-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModAssignIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModAssignModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_3__components_index_index__["a" /* AddonModAssignIndexComponent */];
    };
    AddonModAssignModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_2__assign__["a" /* AddonModAssignProvider */]])
    ], AddonModAssignModuleHandler);
    return AddonModAssignModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1558 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_grades_providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__assign_sync__ = __webpack_require__(222);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__submission_delegate__ = __webpack_require__(107);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



















/**
 * Handler to prefetch assigns.
 */
var AddonModAssignPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModAssignPrefetchHandler, _super);
    function AddonModAssignPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, assignProvider, textUtils, feedbackDelegate, submissionDelegate, courseHelper, groupsProvider, gradesHelper, userProvider, assignHelper, syncProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.assignProvider = assignProvider;
        _this.textUtils = textUtils;
        _this.feedbackDelegate = feedbackDelegate;
        _this.submissionDelegate = submissionDelegate;
        _this.courseHelper = courseHelper;
        _this.groupsProvider = groupsProvider;
        _this.gradesHelper = gradesHelper;
        _this.userProvider = userProvider;
        _this.assignHelper = assignHelper;
        _this.syncProvider = syncProvider;
        _this.name = 'AddonModAssign';
        _this.modName = 'assign';
        _this.component = __WEBPACK_IMPORTED_MODULE_14__assign__["a" /* AddonModAssignProvider */].COMPONENT;
        _this.updatesNames = /^configuration$|^.*files$|^submissions$|^grades$|^gradeitems$|^outcomes$|^comments$/;
        return _this;
    }
    /**
     * Check if a certain module can use core_course_check_updates to check if it has updates.
     * If not defined, it will assume all modules can be checked.
     * The modules that return false will always be shown as outdated when they're downloaded.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {boolean|Promise<boolean>} Whether the module can use check_updates. The promise should never be rejected.
     */
    AddonModAssignPrefetchHandler.prototype.canUseCheckUpdates = function (module, courseId) {
        var _this = this;
        // Teachers cannot use the WS because it doesn't check student submissions.
        return this.assignProvider.getAssignment(courseId, module.id).then(function (assign) {
            return _this.assignProvider.getSubmissions(assign.id).then(function (data) {
                if (data.canviewsubmissions) {
                    return false;
                }
                // Check if the user can view their own submission.
                return _this.assignProvider.getSubmissionStatus(assign.id).then(function () {
                    return true;
                });
            });
        }).catch(function () {
            return false;
        });
    };
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModAssignPrefetchHandler.prototype.getFiles = function (module, courseId, single, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.assignProvider.getAssignment(courseId, module.id, false, siteId).then(function (assign) {
            // Get intro files and attachments.
            var files = assign.introattachments || [];
            files = files.concat(_this.getIntroFilesFromInstance(module, assign));
            // Now get the files in the submissions.
            return _this.assignProvider.getSubmissions(assign.id, false, siteId).then(function (data) {
                var blindMarking = assign.blindmarking && !assign.revealidentities;
                if (data.canviewsubmissions) {
                    // Teacher, get all submissions.
                    return _this.assignHelper.getSubmissionsUserData(assign, data.submissions, 0, false, siteId)
                        .then(function (submissions) {
                        var promises = [];
                        // Get all the files in the submissions.
                        submissions.forEach(function (submission) {
                            promises.push(_this.getSubmissionFiles(assign, submission.submitid, !!submission.blindid, siteId)
                                .then(function (submissionFiles) {
                                files = files.concat(submissionFiles);
                            }).catch(function (error) {
                                if (error && error.errorcode == 'nopermission') {
                                    // The user does not have persmission to view this submission, ignore it.
                                    return Promise.resolve();
                                }
                                return Promise.reject(error);
                            }));
                        });
                        return Promise.all(promises).then(function () {
                            return files;
                        });
                    });
                }
                else {
                    // Student, get only his/her submissions.
                    var userId = _this.sitesProvider.getCurrentSiteUserId();
                    return _this.getSubmissionFiles(assign, userId, blindMarking, siteId).then(function (submissionFiles) {
                        files = files.concat(submissionFiles);
                        return files;
                    });
                }
            });
        }).catch(function () {
            // Error getting data, return empty list.
            return [];
        });
    };
    /**
     * Get submission files.
     *
     * @param {any} assign Assign.
     * @param {number} submitId User ID of the submission to get.
     * @param {boolean} blindMarking True if blind marking, false otherwise.
     * @param {string} siteId Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with array of files.
     */
    AddonModAssignPrefetchHandler.prototype.getSubmissionFiles = function (assign, submitId, blindMarking, siteId) {
        var _this = this;
        return this.assignProvider.getSubmissionStatusWithRetry(assign, submitId, undefined, blindMarking, true, false, siteId)
            .then(function (response) {
            var promises = [];
            if (response.lastattempt) {
                var userSubmission_1 = _this.assignProvider.getSubmissionObjectFromAttempt(assign, response.lastattempt);
                if (userSubmission_1 && userSubmission_1.plugins) {
                    // Add submission plugin files.
                    userSubmission_1.plugins.forEach(function (plugin) {
                        promises.push(_this.submissionDelegate.getPluginFiles(assign, userSubmission_1, plugin, siteId));
                    });
                }
            }
            if (response.feedback && response.feedback.plugins) {
                // Add feedback plugin files.
                response.feedback.plugins.forEach(function (plugin) {
                    promises.push(_this.feedbackDelegate.getPluginFiles(assign, response, plugin, siteId));
                });
            }
            return Promise.all(promises);
        }).then(function (filesLists) {
            var files = [];
            filesLists.forEach(function (filesList) {
                files = files.concat(filesList);
            });
            return files;
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModAssignPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.assignProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param  {any}    module   Module.
     * @param  {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModAssignPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        return this.assignProvider.invalidateAssignmentData(courseId);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModAssignPrefetchHandler.prototype.isEnabled = function () {
        return this.assignProvider.isPluginEnabled();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchAssign.bind(this));
    };
    /**
     * Prefetch an assignment.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {String} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignPrefetchHandler.prototype.prefetchAssign = function (module, courseId, single, siteId) {
        var _this = this;
        var userId = this.sitesProvider.getCurrentSiteUserId(), promises = [];
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Get assignment to retrieve all its submissions.
        promises.push(this.assignProvider.getAssignment(courseId, module.id, true, siteId).then(function (assign) {
            var subPromises = [], blindMarking = assign.blindmarking && !assign.revealidentities;
            if (blindMarking) {
                subPromises.push(_this.assignProvider.getAssignmentUserMappings(assign.id, undefined, true, siteId).catch(function () {
                    // Ignore errors.
                }));
            }
            subPromises.push(_this.prefetchSubmissions(assign, courseId, module.id, userId, siteId));
            subPromises.push(_this.courseHelper.getModuleCourseIdByInstance(assign.id, 'assign', siteId));
            // Download intro files and attachments. Do not call getFiles because it'd call some WS twice.
            var files = assign.introattachments || [];
            files = files.concat(_this.getIntroFilesFromInstance(module, assign));
            subPromises.push(_this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id));
            return Promise.all(subPromises);
        }));
        return Promise.all(promises);
    };
    /**
     * Prefetch assign submissions.
     *
     * @param {any} assign Assign.
     * @param {number} courseId Course ID.
     * @param {number} moduleId Module ID.
     * @param {number} userId User ID. If not defined, site's current user.
     * @param {string} siteId Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when prefetched, rejected otherwise.
     */
    AddonModAssignPrefetchHandler.prototype.prefetchSubmissions = function (assign, courseId, moduleId, userId, siteId) {
        var _this = this;
        // Get submissions.
        return this.assignProvider.getSubmissions(assign.id, true, siteId).then(function (data) {
            var promises = [];
            if (data.canviewsubmissions) {
                // Teacher, prefetch all submissions.
                promises.push(_this.groupsProvider.getActivityGroupInfo(assign.cmid, false, undefined, siteId).then(function (groupInfo) {
                    var groupProms = [];
                    if (!groupInfo.groups || groupInfo.groups.length == 0) {
                        groupInfo.groups = [{ id: 0 }];
                    }
                    groupInfo.groups.forEach(function (group) {
                        groupProms.push(_this.assignHelper.getSubmissionsUserData(assign, data.submissions, group.id, true, siteId)
                            .then(function (submissions) {
                            var subPromises = [];
                            submissions.forEach(function (submission) {
                                subPromises.push(_this.assignProvider.getSubmissionStatusWithRetry(assign, submission.submitid, group.id, !!submission.blindid, true, true, siteId).then(function (subm) {
                                    return _this.prefetchSubmission(assign, courseId, moduleId, subm, submission.submitid, siteId);
                                }).catch(function (error) {
                                    if (error && error.errorcode == 'nopermission') {
                                        // The user does not have persmission to view this submission, ignore it.
                                        return Promise.resolve();
                                    }
                                    return Promise.reject(error);
                                }));
                            });
                            if (!assign.markingworkflow) {
                                // Get assignment grades only if workflow is not enabled to check grading date.
                                subPromises.push(_this.assignProvider.getAssignmentGrades(assign.id, true, siteId));
                            }
                            // Prefetch the submission of the current user even if it does not exist, this will be create it.
                            if (!data.submissions || !data.submissions.find(function (subm) { return subm.submitid == userId; })) {
                                subPromises.push(_this.assignProvider.getSubmissionStatusWithRetry(assign, userId, group.id, false, true, true, siteId).then(function (subm) {
                                    return _this.prefetchSubmission(assign, courseId, moduleId, subm, userId, siteId);
                                }));
                            }
                            return Promise.all(subPromises);
                        }).then(function () {
                            // Participiants already fetched, we don't need to ignore cache now.
                            return _this.assignHelper.getParticipants(assign, group.id, false, siteId).then(function (participants) {
                                var promises = [];
                                participants.forEach(function (participant) {
                                    if (participant.profileimageurl) {
                                        promises.push(_this.filepoolProvider.addToQueueByUrl(siteId, participant.profileimageurl));
                                    }
                                });
                                return Promise.all(promises);
                            }).catch(function () {
                                // Fail silently (Moodle < 3.2).
                            });
                        }));
                    });
                    return Promise.all(groupProms);
                }));
            }
            // Prefetch own submission, we need to do this for teachers too so the response with error is cached.
            promises.push(_this.assignProvider.getSubmissionStatusWithRetry(assign, userId, undefined, false, true, true, siteId)
                .then(function (subm) {
                return _this.prefetchSubmission(assign, courseId, moduleId, subm, userId, siteId);
            }).catch(function (error) {
                // Ignore if the user can't view their own submission.
                if (error.errorcode != 'nopermission') {
                    return Promise.reject(error);
                }
            }));
            promises.push(_this.groupsProvider.activityHasGroups(assign.cmid, siteId, true));
            promises.push(_this.groupsProvider.getActivityAllowedGroups(assign.cmid, undefined, siteId, true));
            return Promise.all(promises);
        });
    };
    /**
     * Prefetch a submission.
     *
     * @param {any} assign Assign.
     * @param {number} courseId Course ID.
     * @param {number} moduleId Module ID.
     * @param {any} submission Data returned by AddonModAssignProvider.getSubmissionStatus.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when prefetched, rejected otherwise.
     */
    AddonModAssignPrefetchHandler.prototype.prefetchSubmission = function (assign, courseId, moduleId, submission, userId, siteId) {
        var _this = this;
        var promises = [], blindMarking = assign.blindmarking && !assign.revealidentities;
        var userIds = [];
        if (submission.lastattempt) {
            var userSubmission_2 = this.assignProvider.getSubmissionObjectFromAttempt(assign, submission.lastattempt);
            // Get IDs of the members who need to submit.
            if (!blindMarking && submission.lastattempt.submissiongroupmemberswhoneedtosubmit) {
                userIds = userIds.concat(submission.lastattempt.submissiongroupmemberswhoneedtosubmit);
            }
            if (userSubmission_2 && userSubmission_2.id) {
                // Prefetch submission plugins data.
                if (userSubmission_2.plugins) {
                    userSubmission_2.plugins.forEach(function (plugin) {
                        // Prefetch the plugin WS data.
                        promises.push(_this.submissionDelegate.prefetch(assign, userSubmission_2, plugin, siteId));
                        // Prefetch the plugin files.
                        promises.push(_this.submissionDelegate.getPluginFiles(assign, userSubmission_2, plugin, siteId)
                            .then(function (files) {
                            return _this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.i);
                        }).catch(function () {
                            // Ignore errors.
                        }));
                    });
                }
                // Get ID of the user who did the submission.
                if (userSubmission_2.userid) {
                    userIds.push(userSubmission_2.userid);
                }
            }
        }
        // Prefetch grade items.
        if (userId) {
            promises.push(this.gradesHelper.getGradeModuleItems(courseId, moduleId, userId, undefined, siteId, true));
        }
        // Prefetch feedback.
        if (submission.feedback) {
            // Get profile and image of the grader.
            if (submission.feedback.grade && submission.feedback.grade.grader > 0) {
                userIds.push(submission.feedback.grade.grader);
            }
            // Prefetch feedback plugins data.
            if (submission.feedback.plugins) {
                submission.feedback.plugins.forEach(function (plugin) {
                    // Prefetch the plugin WS data.
                    promises.push(_this.feedbackDelegate.prefetch(assign, submission, plugin, siteId));
                    // Prefetch the plugin files.
                    promises.push(_this.feedbackDelegate.getPluginFiles(assign, submission, plugin, siteId).then(function (files) {
                        return _this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.i);
                    }).catch(function () {
                        // Ignore errors.
                    }));
                });
            }
        }
        // Prefetch user profiles.
        promises.push(this.userProvider.prefetchProfiles(userIds, courseId, siteId));
        return Promise.all(promises);
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        return this.syncProvider.syncAssign(module.instance, siteId);
    };
    AddonModAssignPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_14__assign__["a" /* AddonModAssignProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_17__feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */],
            __WEBPACK_IMPORTED_MODULE_18__submission_delegate__["a" /* AddonModAssignSubmissionDelegate */], __WEBPACK_IMPORTED_MODULE_11__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_groups__["a" /* CoreGroupsProvider */], __WEBPACK_IMPORTED_MODULE_12__core_grades_providers_helper__["a" /* CoreGradesHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_13__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_15__helper__["a" /* AddonModAssignHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_16__assign_sync__["a" /* AddonModAssignSyncProvider */]])
    ], AddonModAssignPrefetchHandler);
    return AddonModAssignPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_9__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 1559 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__assign_sync__ = __webpack_require__(222);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModAssignSyncCronHandler = /** @class */ (function () {
    function AddonModAssignSyncCronHandler(assignSync) {
        this.assignSync = assignSync;
        this.name = 'AddonModAssignSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModAssignSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.assignSync.syncAllAssignments(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModAssignSyncCronHandler.prototype.getInterval = function () {
        return this.assignSync.syncInterval;
    };
    AddonModAssignSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__assign_sync__["a" /* AddonModAssignSyncProvider */]])
    ], AddonModAssignSyncCronHandler);
    return AddonModAssignSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1560 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to assign index page.
 */
var AddonModAssignIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModAssignIndexLinkHandler, _super);
    function AddonModAssignIndexLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModAssign', 'assign') || this;
        _this.name = 'AddonModAssignIndexLinkHandler';
        return _this;
    }
    AddonModAssignIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModAssignIndexLinkHandler);
    return AddonModAssignIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1561 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__assign__ = __webpack_require__(53);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to assign list page.
 */
var AddonModAssignListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModAssignListLinkHandler, _super);
    function AddonModAssignListLinkHandler(linkHelper, translate, assignProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModAssign', 'assign') || this;
        _this.assignProvider = assignProvider;
        _this.name = 'AddonModAssignListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModAssignListLinkHandler.prototype.isEnabled = function () {
        return this.assignProvider.isPluginEnabled();
    };
    AddonModAssignListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__assign__["a" /* AddonModAssignProvider */]])
    ], AddonModAssignListLinkHandler);
    return AddonModAssignListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1562 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__assign__ = __webpack_require__(53);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler for assign push notifications clicks.
 */
var AddonModAssignPushClickHandler = /** @class */ (function () {
    function AddonModAssignPushClickHandler(utils, assignProvider, urlUtils, courseHelper) {
        this.utils = utils;
        this.assignProvider = assignProvider;
        this.urlUtils = urlUtils;
        this.courseHelper = courseHelper;
        this.name = 'AddonModAssignPushClickHandler';
        this.priority = 200;
        this.featureName = 'CoreCourseModuleDelegate_AddonModAssign';
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonModAssignPushClickHandler.prototype.handles = function (notification) {
        return this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'mod_assign' &&
            notification.name == 'assign_notification';
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var contextUrlParams = this.urlUtils.extractUrlParams(notification.contexturl), courseId = Number(notification.courseid), moduleId = Number(contextUrlParams.id);
        return this.assignProvider.invalidateContent(moduleId, courseId, notification.site).catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.courseHelper.navigateToModule(moduleId, notification.site, courseId);
        });
    };
    AddonModAssignPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__assign__["a" /* AddonModAssignProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModAssignPushClickHandler);
    return AddonModAssignPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1563 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__comments_comments_module__ = __webpack_require__(1564);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__file_file_module__ = __webpack_require__(1566);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__onlinetext_onlinetext_module__ = __webpack_require__(1567);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var AddonModAssignSubmissionModule = /** @class */ (function () {
    function AddonModAssignSubmissionModule() {
    }
    AddonModAssignSubmissionModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__comments_comments_module__["a" /* AddonModAssignSubmissionCommentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__file_file_module__["a" /* AddonModAssignSubmissionFileModule */],
                __WEBPACK_IMPORTED_MODULE_3__onlinetext_onlinetext_module__["a" /* AddonModAssignSubmissionOnlineTextModule */]
            ],
            providers: [],
            exports: []
        })
    ], AddonModAssignSubmissionModule);
    return AddonModAssignSubmissionModule;
}());

//# sourceMappingURL=submission.module.js.map

/***/ }),
/* 1564 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionCommentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1565);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_comments__ = __webpack_require__(833);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_comments_components_components_module__ = __webpack_require__(280);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonModAssignSubmissionCommentsModule = /** @class */ (function () {
    function AddonModAssignSubmissionCommentsModule(submissionDelegate, handler) {
        submissionDelegate.registerHandler(handler);
    }
    AddonModAssignSubmissionCommentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_comments__["a" /* AddonModAssignSubmissionCommentsComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__core_comments_components_components_module__["a" /* CoreCommentsComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignSubmissionCommentsHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_comments__["a" /* AddonModAssignSubmissionCommentsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_comments__["a" /* AddonModAssignSubmissionCommentsComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignSubmissionCommentsHandler */]])
    ], AddonModAssignSubmissionCommentsModule);
    return AddonModAssignSubmissionCommentsModule;
}());

//# sourceMappingURL=comments.module.js.map

/***/ }),
/* 1565 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionCommentsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_comments_providers_comments__ = __webpack_require__(134);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_comments__ = __webpack_require__(833);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler for comments submission plugin.
 */
var AddonModAssignSubmissionCommentsHandler = /** @class */ (function () {
    function AddonModAssignSubmissionCommentsHandler(commentsProvider) {
        this.commentsProvider = commentsProvider;
        this.name = 'AddonModAssignSubmissionCommentsHandler';
        this.type = 'comments';
    }
    /**
     * Whether the plugin can be edited in offline for existing submissions. In general, this should return false if the
     * plugin uses Moodle filters. The reason is that the app only prefetches filtered data, and the user should edit
     * unfiltered data.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @return {boolean|Promise<boolean>} Boolean or promise resolved with boolean: whether it can be edited in offline.
     */
    AddonModAssignSubmissionCommentsHandler.prototype.canEditOffline = function (assign, submission, plugin) {
        // This plugin is read only, but return true to prevent blocking the edition.
        return true;
    };
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignSubmissionCommentsHandler.prototype.getComponent = function (injector, plugin, edit) {
        return edit ? undefined : __WEBPACK_IMPORTED_MODULE_2__component_comments__["a" /* AddonModAssignSubmissionCommentsComponent */];
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignSubmissionCommentsHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether or not the handler is enabled for edit on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled for edit on a site level.
     */
    AddonModAssignSubmissionCommentsHandler.prototype.isEnabledForEdit = function () {
        return true;
    };
    /**
     * Prefetch any required data for the plugin.
     * This should NOT prefetch files. Files to be prefetched should be returned by the getPluginFiles function.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModAssignSubmissionCommentsHandler.prototype.prefetch = function (assign, submission, plugin, siteId) {
        return this.commentsProvider.getComments('module', assign.cmid, 'assignsubmission_comments', submission.id, 'submission_comments', 0, siteId).catch(function () {
            // Fail silently (Moodle < 3.1.1, 3.2)
        });
    };
    AddonModAssignSubmissionCommentsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_comments_providers_comments__["a" /* CoreCommentsProvider */]])
    ], AddonModAssignSubmissionCommentsHandler);
    return AddonModAssignSubmissionCommentsHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1566 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionFileModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(834);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_file__ = __webpack_require__(835);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModAssignSubmissionFileModule = /** @class */ (function () {
    function AddonModAssignSubmissionFileModule(submissionDelegate, handler) {
        submissionDelegate.registerHandler(handler);
    }
    AddonModAssignSubmissionFileModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_file__["a" /* AddonModAssignSubmissionFileComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignSubmissionFileHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_file__["a" /* AddonModAssignSubmissionFileComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_file__["a" /* AddonModAssignSubmissionFileComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignSubmissionFileHandler */]])
    ], AddonModAssignSubmissionFileModule);
    return AddonModAssignSubmissionFileModule;
}());

//# sourceMappingURL=file.module.js.map

/***/ }),
/* 1567 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionOnlineTextModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1568);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_onlinetext__ = __webpack_require__(836);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModAssignSubmissionOnlineTextModule = /** @class */ (function () {
    function AddonModAssignSubmissionOnlineTextModule(submissionDelegate, handler) {
        submissionDelegate.registerHandler(handler);
    }
    AddonModAssignSubmissionOnlineTextModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_onlinetext__["a" /* AddonModAssignSubmissionOnlineTextComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignSubmissionOnlineTextHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_onlinetext__["a" /* AddonModAssignSubmissionOnlineTextComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_onlinetext__["a" /* AddonModAssignSubmissionOnlineTextComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignSubmissionOnlineTextHandler */]])
    ], AddonModAssignSubmissionOnlineTextModule);
    return AddonModAssignSubmissionOnlineTextModule;
}());

//# sourceMappingURL=onlinetext.module.js.map

/***/ }),
/* 1568 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignSubmissionOnlineTextHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_ws__ = __webpack_require__(135);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_assign_offline__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_helper__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__component_onlinetext__ = __webpack_require__(836);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Handler for online text submission plugin.
 */
var AddonModAssignSubmissionOnlineTextHandler = /** @class */ (function () {
    function AddonModAssignSubmissionOnlineTextHandler(translate, sitesProvider, wsProvider, textUtils, assignProvider, assignOfflineProvider, assignHelper) {
        this.translate = translate;
        this.sitesProvider = sitesProvider;
        this.wsProvider = wsProvider;
        this.textUtils = textUtils;
        this.assignProvider = assignProvider;
        this.assignOfflineProvider = assignOfflineProvider;
        this.assignHelper = assignHelper;
        this.name = 'AddonModAssignSubmissionOnlineTextHandler';
        this.type = 'onlinetext';
    }
    /**
     * Whether the plugin can be edited in offline for existing submissions. In general, this should return false if the
     * plugin uses Moodle filters. The reason is that the app only prefetches filtered data, and the user should edit
     * unfiltered data.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @return {boolean|Promise<boolean>} Boolean or promise resolved with boolean: whether it can be edited in offline.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.canEditOffline = function (assign, submission, plugin) {
        // This plugin uses Moodle filters, it cannot be edited in offline.
        return false;
    };
    /**
     * This function will be called when the user wants to create a new submission based on the previous one.
     * It should add to pluginData the data to send to server based in the data in plugin (previous attempt).
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @param {any} pluginData Object where to store the data to send.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.copySubmissionData = function (assign, plugin, pluginData, userId, siteId) {
        var text = this.assignProvider.getSubmissionPluginText(plugin, true), files = this.assignProvider.getSubmissionPluginAttachments(plugin);
        var promise;
        if (!files.length) {
            // No files to copy, no item ID.
            promise = Promise.resolve(0);
        }
        else {
            // Re-upload the files.
            promise = this.assignHelper.uploadFiles(assign.id, files, siteId);
        }
        return promise.then(function (itemId) {
            pluginData.onlinetext_editor = {
                text: text,
                format: 1,
                itemid: itemId
            };
        });
    };
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.getComponent = function (injector, plugin, edit) {
        return __WEBPACK_IMPORTED_MODULE_8__component_onlinetext__["a" /* AddonModAssignSubmissionOnlineTextComponent */];
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]|Promise<any[]>} The files (or promise resolved with the files).
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return this.assignProvider.getSubmissionPluginAttachments(plugin);
    };
    /**
     * Get the size of data (in bytes) this plugin will send to copy a previous submission.
     *
     * @param {any} assign The assignment.
     * @param {any} plugin The plugin object.
     * @return {number|Promise<number>} The size (or promise resolved with size).
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.getSizeForCopy = function (assign, plugin) {
        var _this = this;
        var text = this.assignProvider.getSubmissionPluginText(plugin, true), files = this.assignProvider.getSubmissionPluginAttachments(plugin), promises = [];
        var totalSize = text.length;
        if (!files.length) {
            return totalSize;
        }
        files.forEach(function (file) {
            promises.push(_this.wsProvider.getRemoteFileSize(file.fileurl).then(function (size) {
                if (size == -1) {
                    // Couldn't determine the size, reject.
                    return Promise.reject(null);
                }
                totalSize += size;
            }));
        });
        return Promise.all(promises).then(function () {
            return totalSize;
        });
    };
    /**
     * Get the size of data (in bytes) this plugin will send to add or edit a submission.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {number|Promise<number>} The size (or promise resolved with size).
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.getSizeForEdit = function (assign, submission, plugin, inputData) {
        var text = this.assignProvider.getSubmissionPluginText(plugin, true);
        return text.length;
    };
    /**
     * Get the text to submit.
     *
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {string} Text to submit.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.getTextToSubmit = function (plugin, inputData) {
        var text = inputData.onlinetext_editor_text, files = plugin.fileareas && plugin.fileareas[0] ? plugin.fileareas[0].files : [];
        return this.textUtils.restorePluginfileUrls(text, files);
    };
    /**
     * Check if the submission data has changed for this plugin.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @return {boolean|Promise<boolean>} Boolean (or promise resolved with boolean): whether the data has changed.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.hasDataChanged = function (assign, submission, plugin, inputData) {
        var _this = this;
        // Get the original text from plugin or offline.
        return this.assignOfflineProvider.getSubmission(assign.id, submission.userid).catch(function () {
            // No offline data found.
        }).then(function (data) {
            if (data && data.plugindata && data.plugindata.onlinetext_editor) {
                return data.plugindata.onlinetext_editor.text;
            }
            // No offline data found, get text from plugin.
            return plugin.editorfields && plugin.editorfields[0] ? plugin.editorfields[0].text : '';
        }).then(function (initialText) {
            // Check if text has changed.
            return initialText != _this.getTextToSubmit(plugin, inputData);
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether or not the handler is enabled for edit on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled for edit on a site level.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.isEnabledForEdit = function () {
        // There's a bug in Moodle 3.1.0 that doesn't allow submitting HTML, so we'll disable this plugin in that case.
        // Bug was fixed in 3.1.1 minor release and in 3.2.
        var currentSite = this.sitesProvider.getCurrentSite();
        return currentSite.isVersionGreaterEqualThan('3.1.1') || currentSite.checkIfAppUsesLocalMobile();
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the input data.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} inputData Data entered by the user for the submission.
     * @param {any} pluginData Object where to store the data to send.
     * @param {boolean} [offline] Whether the user is editing in offline.
     * @param {number} [userId] User ID. If not defined, site's current user.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.prepareSubmissionData = function (assign, submission, plugin, inputData, pluginData, offline, userId, siteId) {
        var text = this.getTextToSubmit(plugin, inputData);
        // Check word limit.
        var configs = this.assignHelper.getPluginConfig(assign, 'assignsubmission', plugin.type);
        if (parseInt(configs.wordlimitenabled, 10)) {
            var words = this.textUtils.countWords(text);
            var wordlimit = parseInt(configs.wordlimit, 10);
            if (words > wordlimit) {
                var params = { $a: { count: words, limit: wordlimit } };
                var message = this.translate.instant('addon.mod_assign_submission_onlinetext.wordlimitexceeded', params);
                return Promise.reject(message);
            }
        }
        // Add some HTML to the text if needed.
        text = this.textUtils.formatHtmlLines(text);
        pluginData.onlinetext_editor = {
            text: text,
            format: 1,
            itemid: 0 // Can't add new files yet, so we use a fake itemid.
        };
    };
    /**
     * Prepare and add to pluginData the data to send to the server based on the offline data stored.
     * This will be used when performing a synchronization.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {any} offlineData Offline data stored.
     * @param {any} pluginData Object where to store the data to send.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} If the function is async, it should return a Promise resolved when done.
     */
    AddonModAssignSubmissionOnlineTextHandler.prototype.prepareSyncData = function (assign, submission, plugin, offlineData, pluginData, siteId) {
        var textData = offlineData && offlineData.plugindata && offlineData.plugindata.onlinetext_editor;
        if (textData) {
            // Has some data to sync.
            pluginData.onlinetext_editor = textData;
        }
    };
    AddonModAssignSubmissionOnlineTextHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_ws__["a" /* CoreWSProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_assign__["a" /* AddonModAssignProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_assign_offline__["a" /* AddonModAssignOfflineProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_helper__["a" /* AddonModAssignHelperProvider */]])
    ], AddonModAssignSubmissionOnlineTextHandler);
    return AddonModAssignSubmissionOnlineTextHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1569 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__comments_comments_module__ = __webpack_require__(1570);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__editpdf_editpdf_module__ = __webpack_require__(1571);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__file_file_module__ = __webpack_require__(1573);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var AddonModAssignFeedbackModule = /** @class */ (function () {
    function AddonModAssignFeedbackModule() {
    }
    AddonModAssignFeedbackModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__comments_comments_module__["a" /* AddonModAssignFeedbackCommentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__editpdf_editpdf_module__["a" /* AddonModAssignFeedbackEditPdfModule */],
                __WEBPACK_IMPORTED_MODULE_3__file_file_module__["a" /* AddonModAssignFeedbackFileModule */]
            ],
            providers: [],
            exports: []
        })
    ], AddonModAssignFeedbackModule);
    return AddonModAssignFeedbackModule;
}());

//# sourceMappingURL=feedback.module.js.map

/***/ }),
/* 1570 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackCommentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(837);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_comments__ = __webpack_require__(838);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModAssignFeedbackCommentsModule = /** @class */ (function () {
    function AddonModAssignFeedbackCommentsModule(feedbackDelegate, handler) {
        feedbackDelegate.registerHandler(handler);
    }
    AddonModAssignFeedbackCommentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_comments__["a" /* AddonModAssignFeedbackCommentsComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignFeedbackCommentsHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_comments__["a" /* AddonModAssignFeedbackCommentsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_comments__["a" /* AddonModAssignFeedbackCommentsComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignFeedbackCommentsHandler */]])
    ], AddonModAssignFeedbackCommentsModule);
    return AddonModAssignFeedbackCommentsModule;
}());

//# sourceMappingURL=comments.module.js.map

/***/ }),
/* 1571 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackEditPdfModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1572);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_editpdf__ = __webpack_require__(839);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModAssignFeedbackEditPdfModule = /** @class */ (function () {
    function AddonModAssignFeedbackEditPdfModule(feedbackDelegate, handler) {
        feedbackDelegate.registerHandler(handler);
    }
    AddonModAssignFeedbackEditPdfModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_editpdf__["a" /* AddonModAssignFeedbackEditPdfComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignFeedbackEditPdfHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_editpdf__["a" /* AddonModAssignFeedbackEditPdfComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_editpdf__["a" /* AddonModAssignFeedbackEditPdfComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignFeedbackEditPdfHandler */]])
    ], AddonModAssignFeedbackEditPdfModule);
    return AddonModAssignFeedbackEditPdfModule;
}());

//# sourceMappingURL=editpdf.module.js.map

/***/ }),
/* 1572 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackEditPdfHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_editpdf__ = __webpack_require__(839);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler for edit pdf feedback plugin.
 */
var AddonModAssignFeedbackEditPdfHandler = /** @class */ (function () {
    function AddonModAssignFeedbackEditPdfHandler(assignProvider) {
        this.assignProvider = assignProvider;
        this.name = 'AddonModAssignFeedbackEditPdfHandler';
        this.type = 'editpdf';
    }
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignFeedbackEditPdfHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_editpdf__["a" /* AddonModAssignFeedbackEditPdfComponent */];
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]|Promise<any[]>} The files (or promise resolved with the files).
     */
    AddonModAssignFeedbackEditPdfHandler.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return this.assignProvider.getSubmissionPluginAttachments(plugin);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignFeedbackEditPdfHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModAssignFeedbackEditPdfHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_assign__["a" /* AddonModAssignProvider */]])
    ], AddonModAssignFeedbackEditPdfHandler);
    return AddonModAssignFeedbackEditPdfHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1573 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackFileModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1574);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_file__ = __webpack_require__(840);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModAssignFeedbackFileModule = /** @class */ (function () {
    function AddonModAssignFeedbackFileModule(feedbackDelegate, handler) {
        feedbackDelegate.registerHandler(handler);
    }
    AddonModAssignFeedbackFileModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_file__["a" /* AddonModAssignFeedbackFileComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignFeedbackFileHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_file__["a" /* AddonModAssignFeedbackFileComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_file__["a" /* AddonModAssignFeedbackFileComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModAssignFeedbackFileHandler */]])
    ], AddonModAssignFeedbackFileModule);
    return AddonModAssignFeedbackFileModule;
}());

//# sourceMappingURL=file.module.js.map

/***/ }),
/* 1574 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModAssignFeedbackFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_assign__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_file__ = __webpack_require__(840);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler for file feedback plugin.
 */
var AddonModAssignFeedbackFileHandler = /** @class */ (function () {
    function AddonModAssignFeedbackFileHandler(assignProvider) {
        this.assignProvider = assignProvider;
        this.name = 'AddonModAssignFeedbackFileHandler';
        this.type = 'file';
    }
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModAssignFeedbackFileHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_file__["a" /* AddonModAssignFeedbackFileComponent */];
    };
    /**
     * Get files used by this plugin.
     * The files returned by this function will be prefetched when the user prefetches the assign.
     *
     * @param {any} assign The assignment.
     * @param {any} submission The submission.
     * @param {any} plugin The plugin object.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {any[]|Promise<any[]>} The files (or promise resolved with the files).
     */
    AddonModAssignFeedbackFileHandler.prototype.getPluginFiles = function (assign, submission, plugin, siteId) {
        return this.assignProvider.getSubmissionPluginAttachments(plugin);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModAssignFeedbackFileHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModAssignFeedbackFileHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_assign__["a" /* AddonModAssignProvider */]])
    ], AddonModAssignFeedbackFileHandler);
    return AddonModAssignFeedbackFileHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1575 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModBookModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__book__ = __webpack_require__(212);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_index_index__ = __webpack_require__(423);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support book modules.
 */
var AddonModBookModuleHandler = /** @class */ (function () {
    function AddonModBookModuleHandler(bookProvider, courseProvider) {
        this.bookProvider = bookProvider;
        this.courseProvider = courseProvider;
        this.name = 'AddonModBook';
        this.modName = 'book';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE] = __WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModBookModuleHandler.prototype.isEnabled = function () {
        return this.bookProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModBookModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_book-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModBookIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModBookModuleHandler.prototype.getMainComponent = function (injector, course, module) {
        return __WEBPACK_IMPORTED_MODULE_2__components_index_index__["a" /* AddonModBookIndexComponent */];
    };
    AddonModBookModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__book__["a" /* AddonModBookProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModBookModuleHandler);
    return AddonModBookModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1576 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModBookLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to book.
 */
var AddonModBookLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModBookLinkHandler, _super);
    function AddonModBookLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModBook', 'book') || this;
        _this.name = 'AddonModBookLinkHandler';
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModBookLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        var modParams = params.chapterid ? { chapterId: params.chapterid } : undefined;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    _this.courseHelper.navigateToModule(parseInt(params.id, 10), siteId, courseId, undefined, _this.useModNameToGetModule ? _this.modName : undefined, modParams);
                }
            }];
    };
    AddonModBookLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModBookLinkHandler);
    return AddonModBookLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1577 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModBookListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__book__ = __webpack_require__(212);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to book list page.
 */
var AddonModBookListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModBookListLinkHandler, _super);
    function AddonModBookListLinkHandler(linkHelper, translate, bookProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModBook', 'book') || this;
        _this.bookProvider = bookProvider;
        _this.name = 'AddonModBookListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModBookListLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.bookProvider.isPluginEnabled();
    };
    AddonModBookListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__book__["a" /* AddonModBookProvider */]])
    ], AddonModBookListLinkHandler);
    return AddonModBookListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1578 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChatLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to chat.
 */
var AddonModChatLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModChatLinkHandler, _super);
    function AddonModChatLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModChat', 'chat') || this;
        _this.name = 'AddonModChatLinkHandler';
        return _this;
    }
    AddonModChatLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModChatLinkHandler);
    return AddonModChatLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1579 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChatListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to chat list page.
 */
var AddonModChatListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModChatListLinkHandler, _super);
    function AddonModChatListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModChat', 'chat') || this;
        _this.name = 'AddonModChatListLinkHandler';
        return _this;
    }
    AddonModChatListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModChatListLinkHandler);
    return AddonModChatListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1580 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChatModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(424);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__chat__ = __webpack_require__(219);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support chat modules.
 */
var AddonModChatModuleHandler = /** @class */ (function () {
    function AddonModChatModuleHandler(courseProvider, chatProvider) {
        this.courseProvider = courseProvider;
        this.chatProvider = chatProvider;
        this.name = 'AddonModChat';
        this.modName = 'chat';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModChatModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param  {any}    module    The module object.
     * @param  {number} courseId  The course ID.
     * @param  {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModChatModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        var data = {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_chat-handler',
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModChatIndexPage', pageParams, options);
            }
        };
        this.chatProvider.areSessionsAvailable().then(function (available) {
            data.showDownloadButton = available;
        });
        return data;
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param  {any} course The course object.
     * @param  {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModChatModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModChatIndexComponent */];
    };
    AddonModChatModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_4__chat__["a" /* AddonModChatProvider */]])
    ], AddonModChatModuleHandler);
    return AddonModChatModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1581 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChatPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__chat__ = __webpack_require__(219);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












/**
 * Handler to prefetch chats.
 */
var AddonModChatPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModChatPrefetchHandler, _super);
    function AddonModChatPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, groupsProvider, userProvider, chatProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.groupsProvider = groupsProvider;
        _this.userProvider = userProvider;
        _this.chatProvider = chatProvider;
        _this.name = 'AddonModChat';
        _this.modName = 'chat';
        _this.component = __WEBPACK_IMPORTED_MODULE_11__chat__["a" /* AddonModChatProvider */].COMPONENT;
        return _this;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModChatPrefetchHandler.prototype.isEnabled = function () {
        return this.chatProvider.areSessionsAvailable();
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModChatPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        var _this = this;
        return this.chatProvider.getChat(courseId, moduleId).then(function (chat) {
            var promises = [
                _this.chatProvider.invalidateAllSessions(chat.id),
                _this.chatProvider.invalidateAllSessionMessages(chat.id)
            ];
            return _this.utils.allPromises(promises);
        });
    };
    /**
     * Invalidate WS calls needed to determine module status (usually, to check if module is downloadable).
     * It doesn't need to invalidate check updates. It should NOT invalidate files nor all the prefetched data.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModChatPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var promises = [
            this.chatProvider.invalidateChats(courseId),
            this.courseProvider.invalidateModule(module.id)
        ];
        return this.utils.allPromises(promises);
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChatPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchChat.bind(this));
    };
    /**
     * Prefetch a chat.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChatPrefetchHandler.prototype.prefetchChat = function (module, courseId, single, siteId) {
        var _this = this;
        // Prefetch chat and group info.
        var promises = [
            this.chatProvider.getChat(courseId, module.id, siteId),
            this.groupsProvider.getActivityGroupInfo(module.id, false, undefined, siteId)
        ];
        return Promise.all(promises).then(function (_a) {
            var chat = _a[0], groupInfo = _a[1];
            var promises = [];
            var groupIds = [0];
            if (groupInfo.groups && groupInfo.groups.length > 0) {
                groupIds = groupInfo.groups.map(function (group) { return group.id; });
            }
            groupIds.forEach(function (groupId) {
                // Prefetch complete sessions.
                promises.push(_this.chatProvider.getSessions(chat.id, groupId, false, true, siteId).catch(function (error) {
                    // Ignore group error.
                    if (error.errorcode != 'notingroup') {
                        return Promise.reject(error);
                    }
                }));
                // Prefetch all sessions.
                promises.push(_this.chatProvider.getSessions(chat.id, groupId, true, true, siteId).then(function (sessions) {
                    var promises = sessions.map(function (session) { return _this.prefetchSession(chat.id, session, 0, courseId, siteId); });
                    return Promise.all(promises);
                }).catch(function (error) {
                    // Ignore group error.
                    if (error.errorcode != 'notingroup') {
                        return Promise.reject(error);
                    }
                }));
            });
            return Promise.all(promises);
        });
    };
    /**
     * Prefetch chat session messages and user profiles.
     *
     * @param {number} chatId Chat ID.
     * @param {any} session Session object.
     * @param {number} groupId Group ID.
     * @param {number} courseId Course ID the module belongs to.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModChatPrefetchHandler.prototype.prefetchSession = function (chatId, session, groupId, courseId, siteId) {
        var _this = this;
        return this.chatProvider.getSessionMessages(chatId, session.sessionstart, session.sessionend, groupId, true, siteId)
            .then(function (messages) {
            var users = {};
            session.sessionusers.forEach(function (user) {
                users[user.userid] = true;
            });
            messages.forEach(function (message) {
                users[message.userid] = true;
            });
            var userIds = Object.keys(users).map(Number);
            return _this.userProvider.prefetchProfiles(userIds, courseId, siteId).catch(function () {
                // Ignore errors, some users might not exist.
            });
        });
    };
    AddonModChatPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_11__chat__["a" /* AddonModChatProvider */]])
    ], AddonModChatPrefetchHandler);
    return AddonModChatPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_9__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 1582 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(425);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support choice modules.
 */
var AddonModChoiceModuleHandler = /** @class */ (function () {
    function AddonModChoiceModuleHandler(courseProvider) {
        this.courseProvider = courseProvider;
        this.name = 'AddonModChoice';
        this.modName = 'choice';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModChoiceModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param  {any}    module    The module object.
     * @param  {number} courseId  The course ID.
     * @param  {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModChoiceModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_choice-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModChoiceIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param  {any} course The course object.
     * @param  {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModChoiceModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModChoiceIndexComponent */];
    };
    AddonModChoiceModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModChoiceModuleHandler);
    return AddonModChoiceModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1583 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to choice.
 */
var AddonModChoiceLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModChoiceLinkHandler, _super);
    function AddonModChoiceLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModChoice', 'choice') || this;
        _this.name = 'AddonModChoiceLinkHandler';
        return _this;
    }
    AddonModChoiceLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModChoiceLinkHandler);
    return AddonModChoiceLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1584 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to choice list page.
 */
var AddonModChoiceListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModChoiceListLinkHandler, _super);
    function AddonModChoiceListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModChoice', 'choice') || this;
        _this.name = 'AddonModChoiceListLinkHandler';
        return _this;
    }
    AddonModChoiceListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModChoiceListLinkHandler);
    return AddonModChoiceListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1585 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModChoiceSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(261);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModChoiceSyncCronHandler = /** @class */ (function () {
    function AddonModChoiceSyncCronHandler(choiceSync) {
        this.choiceSync = choiceSync;
        this.name = 'AddonModChoiceSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModChoiceSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.choiceSync.syncAllChoices(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModChoiceSyncCronHandler.prototype.getInterval = function () {
        return this.choiceSync.syncInterval;
    };
    AddonModChoiceSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonModChoiceSyncProvider */]])
    ], AddonModChoiceSyncCronHandler);
    return AddonModChoiceSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1586 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(431);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support feedback modules.
 */
var AddonModFeedbackModuleHandler = /** @class */ (function () {
    function AddonModFeedbackModuleHandler(courseProvider, feedbackProvider) {
        this.courseProvider = courseProvider;
        this.feedbackProvider = feedbackProvider;
        this.name = 'AddonModFeedback';
        this.modName = 'feedback';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModFeedbackModuleHandler.prototype.isEnabled = function () {
        return this.feedbackProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModFeedbackModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_feedback-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModFeedbackIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModFeedbackModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModFeedbackIndexComponent */];
    };
    AddonModFeedbackModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__feedback__["a" /* AddonModFeedbackProvider */]])
    ], AddonModFeedbackModuleHandler);
    return AddonModFeedbackModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1587 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to feedback.
 */
var AddonModFeedbackLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackLinkHandler, _super);
    function AddonModFeedbackLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModFeedback', 'feedback') || this;
        _this.name = 'AddonModFeedbackLinkHandler';
        return _this;
    }
    AddonModFeedbackLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModFeedbackLinkHandler);
    return AddonModFeedbackLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1588 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackAnalysisLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Content links handler for a feedback analysis.
 * Match mod/feedback/analysis.php with a valid feedback id.
 */
var AddonModFeedbackAnalysisLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackAnalysisLinkHandler, _super);
    function AddonModFeedbackAnalysisLinkHandler(linkHelper, feedbackProvider, courseProvider, domUtils) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.feedbackProvider = feedbackProvider;
        _this.courseProvider = courseProvider;
        _this.domUtils = domUtils;
        _this.name = 'AddonModFeedbackAnalysisLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModFeedback';
        _this.pattern = /\/mod\/feedback\/analysis\.php.*([\&\?]id=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModFeedbackAnalysisLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), moduleId = params.id;
                    _this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
                        var stateParams = {
                            module: module,
                            courseId: module.course,
                            tab: 'analysis'
                        };
                        return _this.linkHelper.goInSite(navCtrl, 'AddonModFeedbackIndexPage', stateParams, siteId);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModFeedbackAnalysisLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.feedbackProvider.isPluginEnabled(siteId).then(function (enabled) {
            if (!enabled) {
                return false;
            }
            if (typeof params.id == 'undefined') {
                // Cannot treat the URL.
                return false;
            }
            return true;
        });
    };
    AddonModFeedbackAnalysisLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__feedback__["a" /* AddonModFeedbackProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonModFeedbackAnalysisLinkHandler);
    return AddonModFeedbackAnalysisLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=analysis-link-handler.js.map

/***/ }),
/* 1589 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackShowEntriesLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(184);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Content links handler for feedback show entries questions.
 * Match mod/feedback/show_entries.php with a valid feedback id.
 */
var AddonModFeedbackShowEntriesLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackShowEntriesLinkHandler, _super);
    function AddonModFeedbackShowEntriesLinkHandler(feedbackProvider, feedbackHelper) {
        var _this = _super.call(this) || this;
        _this.feedbackProvider = feedbackProvider;
        _this.feedbackHelper = feedbackHelper;
        _this.name = 'AddonModFeedbackShowEntriesLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModFeedback';
        _this.pattern = /\/mod\/feedback\/show_entries\.php.*([\?\&](id|showcompleted)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModFeedbackShowEntriesLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    _this.feedbackHelper.handleShowEntriesLink(navCtrl, params, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModFeedbackShowEntriesLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.feedbackProvider.isPluginEnabled(siteId).then(function (enabled) {
            if (!enabled) {
                return false;
            }
            if (typeof params.id == 'undefined') {
                // Cannot treat the URL.
                return false;
            }
            return true;
        });
    };
    AddonModFeedbackShowEntriesLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__feedback__["a" /* AddonModFeedbackProvider */], __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* AddonModFeedbackHelperProvider */]])
    ], AddonModFeedbackShowEntriesLinkHandler);
    return AddonModFeedbackShowEntriesLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=show-entries-link-handler.js.map

/***/ }),
/* 1590 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackShowNonRespondentsLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Content links handler for feedback show non respondents.
 * Match mod/feedback/show_nonrespondents.php with a valid feedback id.
 */
var AddonModFeedbackShowNonRespondentsLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackShowNonRespondentsLinkHandler, _super);
    function AddonModFeedbackShowNonRespondentsLinkHandler(linkHelper, feedbackProvider, courseProvider, domUtils) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.feedbackProvider = feedbackProvider;
        _this.courseProvider = courseProvider;
        _this.domUtils = domUtils;
        _this.name = 'AddonModFeedbackShowNonRespondentsLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModFeedback';
        _this.pattern = /\/mod\/feedback\/show_nonrespondents\.php.*([\?\&](id)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModFeedbackShowNonRespondentsLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), moduleId = params.id;
                    _this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
                        var stateParams = {
                            module: module,
                            moduleId: module.id,
                            courseId: module.course
                        };
                        return _this.linkHelper.goInSite(navCtrl, 'AddonModFeedbackNonRespondentsPage', stateParams, siteId);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModFeedbackShowNonRespondentsLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.feedbackProvider.isPluginEnabled(siteId).then(function (enabled) {
            if (!enabled) {
                return false;
            }
            if (typeof params.id == 'undefined') {
                // Cannot treat the URL.
                return false;
            }
            return true;
        });
    };
    AddonModFeedbackShowNonRespondentsLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__feedback__["a" /* AddonModFeedbackProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonModFeedbackShowNonRespondentsLinkHandler);
    return AddonModFeedbackShowNonRespondentsLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=show-non-respondents-link-handler.js.map

/***/ }),
/* 1591 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackCompleteLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Content links handler for feedback complete questions.
 * Match mod/feedback/complete.php with a valid feedback id.
 */
var AddonModFeedbackCompleteLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackCompleteLinkHandler, _super);
    function AddonModFeedbackCompleteLinkHandler(linkHelper, feedbackProvider, courseProvider, domUtils) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.feedbackProvider = feedbackProvider;
        _this.courseProvider = courseProvider;
        _this.domUtils = domUtils;
        _this.name = 'AddonModFeedbackCompleteLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModFeedback';
        _this.pattern = /\/mod\/feedback\/complete\.php.*([\?\&](id|gopage)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModFeedbackCompleteLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), moduleId = params.id;
                    _this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
                        var stateParams = {
                            module: module,
                            moduleId: module.id,
                            courseId: module.course
                        };
                        if (typeof params.gopage == 'undefined') {
                            stateParams['page'] = parseInt(params.gopage, 10);
                        }
                        return _this.linkHelper.goInSite(navCtrl, 'AddonModFeedbackFormPage', stateParams, siteId);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModFeedbackCompleteLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (typeof params.id == 'undefined') {
            return false;
        }
        return this.feedbackProvider.isPluginEnabled(siteId);
    };
    AddonModFeedbackCompleteLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__feedback__["a" /* AddonModFeedbackProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonModFeedbackCompleteLinkHandler);
    return AddonModFeedbackCompleteLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=complete-link-handler.js.map

/***/ }),
/* 1592 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackPrintLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Content links handler for feedback print questions.
 * Match mod/feedback/print.php with a valid feedback id.
 */
var AddonModFeedbackPrintLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackPrintLinkHandler, _super);
    function AddonModFeedbackPrintLinkHandler(linkHelper, feedbackProvider, courseProvider, domUtils) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.feedbackProvider = feedbackProvider;
        _this.courseProvider = courseProvider;
        _this.domUtils = domUtils;
        _this.name = 'AddonModFeedbackPrintLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModFeedback';
        _this.pattern = /\/mod\/feedback\/print\.php.*([\?\&](id)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModFeedbackPrintLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), moduleId = params.id;
                    _this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
                        var stateParams = {
                            module: module,
                            moduleId: module.id,
                            courseId: module.course,
                            preview: true
                        };
                        return _this.linkHelper.goInSite(navCtrl, 'AddonModFeedbackFormPage', stateParams, siteId);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModFeedbackPrintLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (typeof params.id == 'undefined') {
            return false;
        }
        return this.feedbackProvider.isPluginEnabled(siteId);
    };
    AddonModFeedbackPrintLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__feedback__["a" /* AddonModFeedbackProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonModFeedbackPrintLinkHandler);
    return AddonModFeedbackPrintLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=print-link-handler.js.map

/***/ }),
/* 1593 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__feedback__ = __webpack_require__(85);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to feedback list page.
 */
var AddonModFeedbackListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFeedbackListLinkHandler, _super);
    function AddonModFeedbackListLinkHandler(linkHelper, translate, feedbackProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModFeedback', 'feedback') || this;
        _this.feedbackProvider = feedbackProvider;
        _this.name = 'AddonModFeedbackListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModFeedbackListLinkHandler.prototype.isEnabled = function () {
        return this.feedbackProvider.isPluginEnabled();
    };
    AddonModFeedbackListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__feedback__["a" /* AddonModFeedbackProvider */]])
    ], AddonModFeedbackListLinkHandler);
    return AddonModFeedbackListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1594 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__feedback__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__helper__ = __webpack_require__(184);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler for feedback push notifications clicks.
 */
var AddonModFeedbackPushClickHandler = /** @class */ (function () {
    function AddonModFeedbackPushClickHandler(utils, feedbackHelper, urlUtils, courseHelper, feedbackProvider) {
        this.utils = utils;
        this.feedbackHelper = feedbackHelper;
        this.urlUtils = urlUtils;
        this.courseHelper = courseHelper;
        this.feedbackProvider = feedbackProvider;
        this.name = 'AddonModFeedbackPushClickHandler';
        this.priority = 200;
        this.featureName = 'CoreCourseModuleDelegate_AddonModFeedback';
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonModFeedbackPushClickHandler.prototype.handles = function (notification) {
        if (this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'mod_feedback' &&
            (notification.name == 'submission' || notification.name == 'message')) {
            return this.feedbackProvider.isPluginEnabled(notification.site);
        }
        return false;
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModFeedbackPushClickHandler.prototype.handleClick = function (notification) {
        var contextUrlParams = this.urlUtils.extractUrlParams(notification.contexturl), courseId = Number(notification.courseid), moduleId = Number(contextUrlParams.id);
        if (notification.name == 'submission') {
            return this.feedbackHelper.handleShowEntriesLink(undefined, contextUrlParams, notification.site);
        }
        else {
            return this.courseHelper.navigateToModule(moduleId, notification.site, courseId);
        }
    };
    AddonModFeedbackPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__helper__["a" /* AddonModFeedbackHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_4__feedback__["a" /* AddonModFeedbackProvider */]])
    ], AddonModFeedbackPushClickHandler);
    return AddonModFeedbackPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1595 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFeedbackSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(224);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModFeedbackSyncCronHandler = /** @class */ (function () {
    function AddonModFeedbackSyncCronHandler(feedbackSync) {
        this.feedbackSync = feedbackSync;
        this.name = 'AddonModFeedbackSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModFeedbackSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.feedbackSync.syncAllFeedbacks(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModFeedbackSyncCronHandler.prototype.getInterval = function () {
        return this.feedbackSync.syncInterval;
    };
    AddonModFeedbackSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonModFeedbackSyncProvider */]])
    ], AddonModFeedbackSyncCronHandler);
    return AddonModFeedbackSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1596 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(432);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support folder modules.
 */
var AddonModFolderModuleHandler = /** @class */ (function () {
    function AddonModFolderModuleHandler(courseProvider) {
        this.courseProvider = courseProvider;
        this.name = 'AddonModFolder';
        this.modName = 'folder';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE] = __WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModFolderModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModFolderModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_folder-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModFolderIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModFolderModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModFolderIndexComponent */];
    };
    AddonModFolderModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModFolderModuleHandler);
    return AddonModFolderModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1597 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__folder__ = __webpack_require__(371);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Handler to prefetch folders.
 */
var AddonModFolderPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModFolderPrefetchHandler, _super);
    function AddonModFolderPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, folderProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.folderProvider = folderProvider;
        _this.name = 'AddonModFolder';
        _this.modName = 'folder';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__folder__["a" /* AddonModFolderProvider */].COMPONENT;
        return _this;
    }
    /**
     * Download or prefetch the content.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files. This is to keep the files
     *                           relative paths and make the package work in an iframe. Undefined to download the files
     *                           in the filepool root folder.
     * @return {Promise<any>} Promise resolved when all content is downloaded. Data returned is not reliable.
     */
    AddonModFolderPrefetchHandler.prototype.downloadOrPrefetch = function (module, courseId, prefetch, dirPath) {
        var promises = [];
        promises.push(_super.prototype.downloadOrPrefetch.call(this, module, courseId, prefetch));
        if (this.folderProvider.isGetFolderWSAvailable()) {
            promises.push(this.folderProvider.getFolder(courseId, module.id));
        }
        return Promise.all(promises);
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModFolderPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.folderProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModFolderPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var promises = [];
        promises.push(this.folderProvider.invalidateFolderData(courseId));
        promises.push(this.courseProvider.invalidateModule(module.id));
        return Promise.all(promises);
    };
    AddonModFolderPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__folder__["a" /* AddonModFolderProvider */]])
    ], AddonModFolderPrefetchHandler);
    return AddonModFolderPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__["a" /* CoreCourseResourcePrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 1598 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to resource.
 */
var AddonModFolderLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFolderLinkHandler, _super);
    function AddonModFolderLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModFolder', 'folder') || this;
        _this.name = 'AddonModFolderLinkHandler';
        return _this;
    }
    AddonModFolderLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModFolderLinkHandler);
    return AddonModFolderLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1599 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to folder list page.
 */
var AddonModFolderListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModFolderListLinkHandler, _super);
    function AddonModFolderListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModFolder', 'folder') || this;
        _this.name = 'AddonModFolderListLinkHandler';
        return _this;
    }
    AddonModFolderListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModFolderListLinkHandler);
    return AddonModFolderListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1600 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModFolderPluginFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

/**
 * Handler to treat links to folder.
 */
var AddonModFolderPluginFileHandler = /** @class */ (function () {
    function AddonModFolderPluginFileHandler() {
        this.name = 'AddonModFolderPluginFileHandler';
        this.component = 'mod_folder';
    }
    /**
     * Return the RegExp to match the revision on pluginfile URLs.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {RegExp} RegExp to match the revision on pluginfile URLs.
     */
    AddonModFolderPluginFileHandler.prototype.getComponentRevisionRegExp = function (args) {
        // Check filearea.
        if (args[2] == 'content') {
            // Component + Filearea + Revision
            return new RegExp('/mod_folder/content/([0-9]+)/');
        }
    };
    /**
     * Should return the string to remove the revision on pluginfile url.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {string} String to remove the revision on pluginfile url.
     */
    AddonModFolderPluginFileHandler.prototype.getComponentRevisionReplace = function (args) {
        // Component + Filearea + Revision
        return '/mod_folder/content/0/';
    };
    AddonModFolderPluginFileHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AddonModFolderPluginFileHandler);
    return AddonModFolderPluginFileHandler;
}());

//# sourceMappingURL=pluginfile-handler.js.map

/***/ }),
/* 1601 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__forum__ = __webpack_require__(100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_index_index__ = __webpack_require__(433);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Handler to support forum modules.
 */
var AddonModForumModuleHandler = /** @class */ (function () {
    function AddonModForumModuleHandler(courseProvider, forumProvider, translate, eventsProvider, sitesProvider) {
        this.courseProvider = courseProvider;
        this.forumProvider = forumProvider;
        this.translate = translate;
        this.eventsProvider = eventsProvider;
        this.sitesProvider = sitesProvider;
        this.name = 'AddonModForum';
        this.modName = 'forum';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_RATE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_PLAGIARISM] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModForumModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModForumModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        var _this = this;
        var data = {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_forum-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModForumIndexPage', pageParams, options);
            }
        };
        if (typeof module.afterlink != 'undefined') {
            data.extraBadgeColor = '';
            var match = />(\d+)[^<]+/.exec(module.afterlink);
            data.extraBadge = match ? this.translate.instant('addon.mod_forum.unreadpostsnumber', { $a: match[1] }) : '';
        }
        else {
            this.updateExtraBadge(data, courseId, module.id);
        }
        var event = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__forum__["a" /* AddonModForumProvider */].MARK_READ_EVENT, function (eventData) {
            if (eventData.courseId == courseId && eventData.moduleId == module.id) {
                _this.updateExtraBadge(data, eventData.courseId, eventData.moduleId, eventData.siteId);
            }
        }, this.sitesProvider.getCurrentSiteId());
        data.onDestroy = function () {
            event && event.off();
        };
        return data;
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModForumModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_6__components_index_index__["a" /* AddonModForumIndexComponent */];
    };
    /**
     * Whether to display the course refresher in single activity course format. If it returns false, a refresher must be
     * included in the template that calls the doRefresh method of the component. Defaults to true.
     *
     * @return {boolean} Whether the refresher should be displayed.
     */
    AddonModForumModuleHandler.prototype.displayRefresherInSingleActivity = function () {
        return false;
    };
    /**
     * Triggers an update for the extra badge text.
     *
     * @param  {CoreCourseModuleHandlerData} data Course Module Handler data.
     * @param  {number} courseId Course ID.
     * @param  {number} moduleId Course module ID.
     * @param  {string} [siteId] Site ID. If not defined, current site.
     */
    AddonModForumModuleHandler.prototype.updateExtraBadge = function (data, courseId, moduleId, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!siteId) {
            return;
        }
        data.extraBadge = this.translate.instant('core.loading');
        data.extraBadgeColor = 'light';
        this.forumProvider.invalidateForumData(courseId).finally(function () {
            // Handle unread posts.
            _this.forumProvider.getForum(courseId, moduleId, siteId).then(function (forumData) {
                data.extraBadgeColor = '';
                data.extraBadge = forumData.unreadpostscount ? _this.translate.instant('addon.mod_forum.unreadpostsnumber', { $a: forumData.unreadpostscount }) : '';
            }).catch(function () {
                data.extraBadgeColor = '';
                data.extraBadge = '';
                // Ignore errors.
            });
        });
    };
    AddonModForumModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__forum__["a" /* AddonModForumProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModForumModuleHandler);
    return AddonModForumModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1602 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(187);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModForumSyncCronHandler = /** @class */ (function () {
    function AddonModForumSyncCronHandler(forumSync) {
        this.forumSync = forumSync;
        this.name = 'AddonModForumSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModForumSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.forumSync.syncAllForums(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModForumSyncCronHandler.prototype.getInterval = function () {
        return this.forumSync.syncInterval;
    };
    AddonModForumSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonModForumSyncProvider */]])
    ], AddonModForumSyncCronHandler);
    return AddonModForumSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1603 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__forum__ = __webpack_require__(100);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to forum index.
 */
var AddonModForumIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModForumIndexLinkHandler, _super);
    function AddonModForumIndexLinkHandler(courseHelper, forumProvider) {
        var _this = _super.call(this, courseHelper, 'AddonModForum', 'forum') || this;
        _this.forumProvider = forumProvider;
        _this.name = 'AddonModForumIndexLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModForumIndexLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return true;
    };
    AddonModForumIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__forum__["a" /* AddonModForumProvider */]])
    ], AddonModForumIndexLinkHandler);
    return AddonModForumIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1604 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumDiscussionLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to forum review.
 */
var AddonModForumDiscussionLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModForumDiscussionLinkHandler, _super);
    function AddonModForumDiscussionLinkHandler(domUtils, linkHelper) {
        var _this = _super.call(this) || this;
        _this.domUtils = domUtils;
        _this.linkHelper = linkHelper;
        _this.name = 'AddonModForumDiscussionLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModForum';
        _this.pattern = /\/mod\/forum\/discuss\.php.*([\&\?]d=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @param {any} [data] Extra data to handle the URL.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModForumDiscussionLinkHandler.prototype.getActions = function (siteIds, url, params, courseId, data) {
        var _this = this;
        data = data || {};
        return [{
                action: function (siteId, navCtrl) {
                    var pageParams = {
                        courseId: courseId || parseInt(params.courseid, 10) || parseInt(params.cid, 10),
                        discussionId: parseInt(params.d, 10),
                        cmId: data.cmid && parseInt(data.cmid, 10),
                        forumId: data.instance && parseInt(data.instance, 10)
                    };
                    if (data.postid || params.urlHash) {
                        pageParams.postId = parseInt(data.postid || params.urlHash.replace('p', ''));
                    }
                    _this.linkHelper.goInSite(navCtrl, 'AddonModForumDiscussionPage', pageParams, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModForumDiscussionLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return true;
    };
    AddonModForumDiscussionLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], AddonModForumDiscussionLinkHandler);
    return AddonModForumDiscussionLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=discussion-link-handler.js.map

/***/ }),
/* 1605 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to forum list page.
 */
var AddonModForumListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModForumListLinkHandler, _super);
    function AddonModForumListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModForum', 'forum') || this;
        _this.name = 'AddonModForumListLinkHandler';
        return _this;
    }
    AddonModForumListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModForumListLinkHandler);
    return AddonModForumListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1606 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__forum__ = __webpack_require__(100);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler for forum push notifications clicks.
 */
var AddonModForumPushClickHandler = /** @class */ (function () {
    function AddonModForumPushClickHandler(utils, forumProvider, urlUtils, linkHelper) {
        this.utils = utils;
        this.forumProvider = forumProvider;
        this.urlUtils = urlUtils;
        this.linkHelper = linkHelper;
        this.name = 'AddonModForumPushClickHandler';
        this.priority = 200;
        this.featureName = 'CoreCourseModuleDelegate_AddonModForum';
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonModForumPushClickHandler.prototype.handles = function (notification) {
        return this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'mod_forum' &&
            notification.name == 'posts';
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModForumPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var contextUrlParams = this.urlUtils.extractUrlParams(notification.contexturl), data = notification.customdata || {}, pageParams = {
            courseId: Number(notification.courseid),
            discussionId: Number(contextUrlParams.d || data.discussionid),
            cmId: Number(data.cmid),
            forumId: Number(data.instance)
        };
        if (data.postid || contextUrlParams.urlHash) {
            pageParams.postId = Number(data.postid || contextUrlParams.urlHash.replace('p', ''));
        }
        return this.forumProvider.invalidateDiscussionPosts(pageParams.discussionId, notification.site).catch(function () {
            // Ignore errors.
        }).then(function () {
            return _this.linkHelper.goInSite(undefined, 'AddonModForumDiscussionPage', pageParams, notification.site);
        });
    };
    AddonModForumPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__forum__["a" /* AddonModForumProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], AddonModForumPushClickHandler);
    return AddonModForumPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1607 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRatingAggregateComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Component that displays the aggregation of a rating item.
 */
var CoreRatingAggregateComponent = /** @class */ (function () {
    function CoreRatingAggregateComponent(eventsProvider, modalCtrl, ratingProvider, sitesProvider) {
        var _this = this;
        this.eventsProvider = eventsProvider;
        this.modalCtrl = modalCtrl;
        this.ratingProvider = ratingProvider;
        this.disabled = false;
        this.disabled = this.ratingProvider.isRatingDisabledInSite();
        // Update visibility if current site info is updated.
        this.updateSiteObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function () {
            _this.disabled = _this.ratingProvider.isRatingDisabledInSite();
        }, sitesProvider.getCurrentSiteId());
    }
    /**
     * Detect changes on input properties.
     */
    CoreRatingAggregateComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        this.aggregateObserver && this.aggregateObserver.off();
        this.item = (this.ratingInfo.ratings || []).find(function (rating) { return rating.itemid == _this.itemId; });
        if (!this.item) {
            return;
        }
        if (this.aggregateMethod == __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */].AGGREGATE_AVERAGE) {
            this.labelKey = 'core.rating.aggregateavg';
        }
        else if (this.aggregateMethod == __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */].AGGREGATE_COUNT) {
            this.labelKey = 'core.rating.aggregatecount';
        }
        else if (this.aggregateMethod == __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */].AGGREGATE_MAXIMUM) {
            this.labelKey = 'core.rating.aggregatemax';
        }
        else if (this.aggregateMethod == __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */].AGGREGATE_MINIMUM) {
            this.labelKey = 'core.rating.aggregatemin';
        }
        else if (this.aggregateMethod == __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */].AGGREGATE_SUM) {
            this.labelKey = 'core.rating.aggregatesum';
        }
        else {
            this.labelKey = '';
            return;
        }
        this.showCount = (this.aggregateMethod != __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */].AGGREGATE_COUNT);
        // Update aggrgate when the user adds or edits a rating.
        this.aggregateObserver = this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */].AGGREGATE_CHANGED_EVENT, function (data) {
            if (data.contextLevel == _this.contextLevel &&
                data.instanceId == _this.instanceId &&
                data.component == _this.ratingInfo.component &&
                data.ratingArea == _this.ratingInfo.ratingarea &&
                data.itemId == _this.itemId) {
                _this.item.aggregatestr = data.aggregate;
                _this.item.count = data.count;
            }
        });
    };
    /**
     * Open the individual ratings page.
     */
    CoreRatingAggregateComponent.prototype.openRatings = function () {
        if (!this.ratingInfo.canviewall || !this.item.count || this.disabled) {
            return;
        }
        var params = {
            contextLevel: this.contextLevel,
            instanceId: this.instanceId,
            ratingComponent: this.ratingInfo.component,
            ratingArea: this.ratingInfo.ratingarea,
            itemId: this.itemId,
            scaleId: this.scaleId,
            courseId: this.courseId
        };
        var modal = this.modalCtrl.create('CoreRatingRatingsPage', params);
        modal.present();
    };
    /**
     * Component being destroyed.
     */
    CoreRatingAggregateComponent.prototype.ngOnDestroy = function () {
        this.aggregateObserver && this.aggregateObserver.off();
        this.updateSiteObserver && this.updateSiteObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreRatingAggregateComponent.prototype, "ratingInfo", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreRatingAggregateComponent.prototype, "contextLevel", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingAggregateComponent.prototype, "instanceId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingAggregateComponent.prototype, "itemId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingAggregateComponent.prototype, "aggregateMethod", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingAggregateComponent.prototype, "scaleId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingAggregateComponent.prototype, "courseId", void 0);
    CoreRatingAggregateComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-rating-aggregate',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\rating\components\aggregate\core-rating-aggregate.html"*/'<a *ngIf="item && item.canviewaggregate && labelKey && !disabled" ion-item text-wrap [attr.detail-none]="ratingInfo.canviewall && item.count ? null : true" (click)="openRatings()">\n    {{ labelKey | translate }}{{ \'core.labelsep\' | translate }} {{ item.aggregatestr || \'-\' }}\n    <span *ngIf="showCount && item.count > 0">({{ item.count }})</span>\n</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\rating\components\aggregate\core-rating-aggregate.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["r" /* ModalController */],
            __WEBPACK_IMPORTED_MODULE_3__core_rating_providers_rating__["a" /* CoreRatingProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreRatingAggregateComponent);
    return CoreRatingAggregateComponent;
}());

//# sourceMappingURL=aggregate.js.map

/***/ }),
/* 1608 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRatingRateComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_rating_providers_rating__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_rating_providers_offline__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component that displays the user rating select.
 */
var CoreRatingRateComponent = /** @class */ (function () {
    function CoreRatingRateComponent(domUtils, translate, eventsProvider, ratingProvider, ratingOffline, sitesProvider) {
        var _this = this;
        this.domUtils = domUtils;
        this.translate = translate;
        this.ratingProvider = ratingProvider;
        this.ratingOffline = ratingOffline;
        this.disabled = false;
        this.onLoading = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.onUpdate = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
        this.disabled = this.ratingProvider.isRatingDisabledInSite();
        // Update visibility if current site info is updated.
        this.updateSiteObserver = eventsProvider.on(__WEBPACK_IMPORTED_MODULE_5__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function () {
            _this.disabled = _this.ratingProvider.isRatingDisabledInSite();
        }, sitesProvider.getCurrentSiteId());
    }
    /**
     * Detect changes on input properties.
     */
    CoreRatingRateComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        this.item = (this.ratingInfo.ratings || []).find(function (rating) { return rating.itemid == _this.itemId; });
        this.scale = (this.ratingInfo.scales || []).find(function (scale) { return scale.id == _this.scaleId; });
        if (!this.item || !this.scale || !this.ratingProvider.isAddRatingWSAvailable()) {
            this.item = null;
            return;
        }
        // Set numeric scale items.
        if (!this.scale.items) {
            this.scale.items = [];
            if (this.scale.isnumeric) {
                for (var n = 0; n <= this.scale.max; n++) {
                    this.scale.items.push({ name: String(n), value: n });
                }
            }
        }
        // Add "No rating" item to the scale.
        if (!this.scale.items[0] || this.scale.items[0].value != __WEBPACK_IMPORTED_MODULE_2__core_rating_providers_rating__["a" /* CoreRatingProvider */].UNSET_RATING) {
            this.scale.items.unshift({
                name: this.translate.instant('core.none'),
                value: __WEBPACK_IMPORTED_MODULE_2__core_rating_providers_rating__["a" /* CoreRatingProvider */].UNSET_RATING
            });
        }
        this.onLoading.emit(true);
        this.ratingOffline.getRating(this.contextLevel, this.instanceId, this.ratingInfo.component, this.ratingInfo.ratingarea, this.itemId).then(function (rating) {
            _this.rating = rating.rating;
        }).catch(function () {
            if (_this.item && _this.item.rating != null) {
                _this.rating = _this.item.rating;
            }
            else {
                _this.rating = __WEBPACK_IMPORTED_MODULE_2__core_rating_providers_rating__["a" /* CoreRatingProvider */].UNSET_RATING;
            }
        }).finally(function () {
            _this.onLoading.emit(false);
        });
    };
    /**
     * Send or save the user rating when changed.
     */
    CoreRatingRateComponent.prototype.userRatingChanged = function () {
        var _this = this;
        var modal = this.domUtils.showModalLoading('core.sending', true);
        this.ratingProvider.addRating(this.ratingInfo.component, this.ratingInfo.ratingarea, this.contextLevel, this.instanceId, this.itemId, this.itemSetId, this.courseId, this.scaleId, this.rating, this.userId, this.aggregateMethod)
            .then(function (response) {
            if (response == null) {
                _this.domUtils.showToast('core.datastoredoffline', true, 3000);
            }
            else {
                _this.onUpdate.emit();
            }
        }).catch(function (error) {
            _this.domUtils.showErrorModal(error);
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Component being destroyed.
     */
    CoreRatingRateComponent.prototype.ngOnDestroy = function () {
        this.updateSiteObserver && this.updateSiteObserver.off();
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], CoreRatingRateComponent.prototype, "ratingInfo", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], CoreRatingRateComponent.prototype, "contextLevel", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingRateComponent.prototype, "instanceId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingRateComponent.prototype, "itemId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingRateComponent.prototype, "itemSetId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingRateComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingRateComponent.prototype, "aggregateMethod", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingRateComponent.prototype, "scaleId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], CoreRatingRateComponent.prototype, "userId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreRatingRateComponent.prototype, "onLoading", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], CoreRatingRateComponent.prototype, "onUpdate", void 0);
    CoreRatingRateComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'core-rating-rate',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\rating\components\rate\core-rating-rate.html"*/'<ion-item text-wrap *ngIf="item && (item.canrate || item.rating != null) && !disabled">\n    <ion-label>{{ \'core.rating.rating\' | translate }}</ion-label>\n    <ion-select text-start [(ngModel)]="rating" (ngModelChange)="userRatingChanged()" interface="action-sheet" [disabled]="!item.canrate">\n        <ion-option *ngFor="let scaleItem of scale.items" [value]="scaleItem.value">{{ scaleItem.name }}</ion-option>\n    </ion-select>\n</ion-item>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\core\rating\components\rate\core-rating-rate.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_5__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__core_rating_providers_rating__["a" /* CoreRatingProvider */], __WEBPACK_IMPORTED_MODULE_4__core_rating_providers_offline__["a" /* CoreRatingOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */]])
    ], CoreRatingRateComponent);
    return CoreRatingRateComponent;
}());

//# sourceMappingURL=rate.js.map

/***/ }),
/* 1609 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModForumPostComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_split_view_split_view__ = __webpack_require__(121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sync__ = __webpack_require__(46);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_forum__ = __webpack_require__(100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_helper__ = __webpack_require__(220);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_offline__ = __webpack_require__(169);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_sync__ = __webpack_require__(187);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};













/**
 * Components that shows a discussion post, its attachments and the action buttons allowed (reply, etc.).
 */
var AddonModForumPostComponent = /** @class */ (function () {
    function AddonModForumPostComponent(navCtrl, uploaderProvider, syncProvider, domUtils, textUtils, translate, forumProvider, forumHelper, forumOffline, forumSync, svComponent, content) {
        this.navCtrl = navCtrl;
        this.uploaderProvider = uploaderProvider;
        this.syncProvider = syncProvider;
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.translate = translate;
        this.forumProvider = forumProvider;
        this.forumHelper = forumHelper;
        this.forumOffline = forumOffline;
        this.forumSync = forumSync;
        this.svComponent = svComponent;
        this.content = content;
        this.messageControl = new __WEBPACK_IMPORTED_MODULE_1__angular_forms__["b" /* FormControl */]();
        this.advanced = false; // Display all form fields.
        this.onPostChange = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    AddonModForumPostComponent.prototype.ngOnInit = function () {
        this.uniqueId = this.post.id ? 'reply' + this.post.id : 'edit' + this.post.parent;
    };
    /**
     * Opens the profile of a user.
     *
     * @param {number} userId
     */
    AddonModForumPostComponent.prototype.openUserProfile = function (userId) {
        // Decide which navCtrl to use. If this page is inside a split view, use the split view's master nav.
        var navCtrl = this.svComponent ? this.svComponent.getMasterNav() : this.navCtrl;
        navCtrl.push('CoreUserProfilePage', { userId: userId, courseId: this.courseId });
    };
    /**
     * Set data to new post, clearing temporary files and updating original data.
     *
     * @param {number} [replyingTo] Id of post beeing replied.
     * @param {boolean} [isEditing] True it's an offline reply beeing edited, false otherwise.
     * @param {string} [subject] Subject of the reply.
     * @param {string} [message] Message of the reply.
     * @param {boolean} [isPrivate] True if it's private reply.
     * @param {any[]} [files] Reply attachments.
     */
    AddonModForumPostComponent.prototype.setReplyData = function (replyingTo, isEditing, subject, message, files, isPrivate) {
        // Delete the local files from the tmp folder if any.
        this.uploaderProvider.clearTmpFiles(this.replyData.files);
        this.replyData.replyingTo = replyingTo || 0;
        this.replyData.isEditing = !!isEditing;
        this.replyData.subject = subject || this.defaultSubject || '';
        this.replyData.message = message || null;
        this.replyData.files = files || [];
        this.replyData.isprivatereply = !!isPrivate;
        // Update rich text editor.
        this.messageControl.setValue(this.replyData.message);
        // Update original data.
        this.originalData.subject = this.replyData.subject;
        this.originalData.message = this.replyData.message;
        this.originalData.files = this.replyData.files.slice();
        this.originalData.isprivatereply = this.replyData.isprivatereply;
        // Show advanced fields if any of them has not the default value.
        this.advanced = this.replyData.files.length > 0;
    };
    /**
     * Set this post as being replied to.
     */
    AddonModForumPostComponent.prototype.showReply = function () {
        var _this = this;
        if (this.replyData.isEditing) {
            // User is editing a post, data needs to be resetted. Ask confirm if there is unsaved data.
            this.confirmDiscard().then(function () {
                _this.setReplyData(_this.post.id);
                if (_this.content) {
                    setTimeout(function () {
                        _this.content.resize();
                        _this.domUtils.scrollToElementBySelector(_this.content, '#addon-forum-reply-edit-form-' + _this.uniqueId);
                    });
                }
            }).catch(function () {
                // Cancelled.
            });
            return;
        }
        else if (!this.replyData.replyingTo) {
            // User isn't replying, it's a brand new reply. Initialize the data.
            this.setReplyData(this.post.id);
        }
        else {
            // The post being replied has changed but the data will be kept.
            this.replyData.replyingTo = this.post.id;
            this.messageControl.setValue(this.replyData.message);
        }
        if (this.content) {
            setTimeout(function () {
                _this.content.resize();
                _this.domUtils.scrollToElementBySelector(_this.content, '#addon-forum-reply-edit-form-' + _this.uniqueId);
            });
        }
    };
    /**
     * Set this post as being edited to.
     */
    AddonModForumPostComponent.prototype.editReply = function () {
        var _this = this;
        // Ask confirm if there is unsaved data.
        this.confirmDiscard().then(function () {
            _this.syncId = _this.forumSync.getDiscussionSyncId(_this.discussionId);
            _this.syncProvider.blockOperation(__WEBPACK_IMPORTED_MODULE_9__providers_forum__["a" /* AddonModForumProvider */].COMPONENT, _this.syncId);
            _this.setReplyData(_this.post.parent, true, _this.post.subject, _this.post.message, _this.post.attachments, _this.post.isprivatereply);
        }).catch(function () {
            // Cancelled.
        });
    };
    /**
     * Message changed.
     *
     * @param {string} text The new text.
     */
    AddonModForumPostComponent.prototype.onMessageChange = function (text) {
        this.replyData.message = text;
    };
    /**
     * Reply to this post.
     */
    AddonModForumPostComponent.prototype.reply = function () {
        var _this = this;
        if (!this.replyData.subject) {
            this.domUtils.showErrorModal('addon.mod_forum.erroremptysubject', true);
            return;
        }
        if (!this.replyData.message) {
            this.domUtils.showErrorModal('addon.mod_forum.erroremptymessage', true);
            return;
        }
        var saveOffline = false;
        var message = this.replyData.message;
        var subject = this.replyData.subject;
        var replyingTo = this.replyData.replyingTo;
        var files = this.replyData.files || [];
        var options = {};
        var modal = this.domUtils.showModalLoading('core.sending', true);
        var promise;
        // Add some HTML to the message if needed.
        message = this.textUtils.formatHtmlLines(message);
        // Set private option if checked.
        if (this.replyData.isprivatereply) {
            options.private = true;
        }
        // Upload attachments first if any.
        if (files.length) {
            promise = this.forumHelper.uploadOrStoreReplyFiles(this.forum.id, replyingTo, files, false).catch(function (error) {
                // Cannot upload them in online, save them in offline.
                if (!_this.forum.id) {
                    // Cannot store them in offline without the forum ID. Reject.
                    return Promise.reject(error);
                }
                saveOffline = true;
                return _this.forumHelper.uploadOrStoreReplyFiles(_this.forum.id, replyingTo, files, true);
            });
        }
        else {
            promise = Promise.resolve();
        }
        promise.then(function (attach) {
            if (attach) {
                options.attachmentsid = attach;
            }
            if (saveOffline) {
                // Save post in offline.
                return _this.forumOffline.replyPost(replyingTo, _this.discussionId, _this.forum.id, _this.forum.name, _this.courseId, subject, message, options).then(function () {
                    // Return false since it wasn't sent to server.
                    return false;
                });
            }
            else {
                // Try to send it to server.
                // Don't allow offline if there are attachments since they were uploaded fine.
                return _this.forumProvider.replyPost(replyingTo, _this.discussionId, _this.forum.id, _this.forum.name, _this.courseId, subject, message, options, undefined, !files.length);
            }
        }).then(function (sent) {
            if (sent && _this.forum.id) {
                // Data sent to server, delete stored files (if any).
                _this.forumHelper.deleteReplyStoredFiles(_this.forum.id, replyingTo);
            }
            // Reset data.
            _this.setReplyData();
            _this.onPostChange.emit();
            if (_this.syncId) {
                _this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_9__providers_forum__["a" /* AddonModForumProvider */].COMPONENT, _this.syncId);
            }
        }).catch(function (message) {
            _this.domUtils.showErrorModalDefault(message, 'addon.mod_forum.couldnotadd', true);
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Cancel reply.
     */
    AddonModForumPostComponent.prototype.cancel = function () {
        var _this = this;
        this.confirmDiscard().then(function () {
            // Reset data.
            _this.setReplyData();
            if (_this.syncId) {
                _this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_9__providers_forum__["a" /* AddonModForumProvider */].COMPONENT, _this.syncId);
            }
        }).catch(function () {
            // Cancelled.
        });
    };
    /**
     * Discard offline reply.
     */
    AddonModForumPostComponent.prototype.discard = function () {
        var _this = this;
        this.domUtils.showConfirm(this.translate.instant('core.areyousure')).then(function () {
            var promises = [];
            promises.push(_this.forumOffline.deleteReply(_this.post.parent));
            if (_this.forum.id) {
                promises.push(_this.forumHelper.deleteReplyStoredFiles(_this.forum.id, _this.post.parent).catch(function () {
                    // Ignore errors, maybe there are no files.
                }));
            }
            return Promise.all(promises).finally(function () {
                // Reset data.
                _this.setReplyData();
                _this.onPostChange.emit();
                if (_this.syncId) {
                    _this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_9__providers_forum__["a" /* AddonModForumProvider */].COMPONENT, _this.syncId);
                }
            });
        }).catch(function () {
            // Cancelled.
        });
    };
    /**
     * Function called when rating is updated online.
     */
    AddonModForumPostComponent.prototype.ratingUpdated = function () {
        this.forumProvider.invalidateDiscussionPosts(this.discussionId);
    };
    /**
     * Show or hide advanced form fields.
     */
    AddonModForumPostComponent.prototype.toggleAdvanced = function () {
        this.advanced = !this.advanced;
    };
    /**
     * Component being destroyed.
     */
    AddonModForumPostComponent.prototype.ngOnDestroy = function () {
        if (this.syncId) {
            this.syncProvider.unblockOperation(__WEBPACK_IMPORTED_MODULE_9__providers_forum__["a" /* AddonModForumProvider */].COMPONENT, this.syncId);
        }
    };
    /**
     * Confirm discard changes if any.
     *
     * @return {Promise<void>} Promise resolved if the user confirms or data was not changed and rejected otherwise.
     */
    AddonModForumPostComponent.prototype.confirmDiscard = function () {
        if (this.forumHelper.hasPostDataChanged(this.replyData, this.originalData)) {
            // Show confirmation if some data has been modified.
            return this.domUtils.showConfirm(this.translate.instant('core.confirmloss'));
        }
        else {
            return Promise.resolve();
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModForumPostComponent.prototype, "post", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModForumPostComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModForumPostComponent.prototype, "discussionId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModForumPostComponent.prototype, "component", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModForumPostComponent.prototype, "componentId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModForumPostComponent.prototype, "replyData", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModForumPostComponent.prototype, "originalData", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModForumPostComponent.prototype, "trackPosts", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModForumPostComponent.prototype, "forum", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModForumPostComponent.prototype, "accessInfo", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModForumPostComponent.prototype, "defaultSubject", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModForumPostComponent.prototype, "ratingInfo", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonModForumPostComponent.prototype, "onPostChange", void 0);
    AddonModForumPostComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-forum-post',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\forum\components\post\addon-mod-forum-post.html"*/'<ion-card-header text-wrap no-padding id="addon-mod_forum-post-{{post.id}}">\n    <ion-item text-wrap>\n        <ion-avatar core-user-avatar [user]="post" item-start (click)="openUserProfile(post.userid)"></ion-avatar>\n        <h2>\n            <core-icon name="fa-map-pin" *ngIf="post.parent == 0 && post.pinned"></core-icon>\n            <core-icon name="fa-star" class="addon-forum-star" *ngIf="post.parent == 0 && !post.pinned && post.starred"></core-icon>\n            <span [class.core-bold]="post.parent == 0"><core-format-text [text]="post.subject"></core-format-text></span>\n        </h2>\n        <p>\n            <ion-note float-end padding-left *ngIf="!post.modified"><ion-icon name="time"></ion-icon> {{ \'core.notsent\' | translate }}</ion-note>\n            <ion-note float-end padding-left text-end *ngIf="post.modified">\n                {{post.modified | coreDateDayOrTime}}\n                <div *ngIf="trackPosts && !post.postread"><core-icon name="fa-circle" color="primary"></core-icon> {{ \'addon.mod_forum.unread\' | translate }}</div>\n            </ion-note>\n            {{post.userfullname}}\n        </p>\n    </ion-item>\n</ion-card-header>\n<ion-card-content padding-top>\n    <div padding-bottom *ngIf="post.isprivatereply">\n        <ion-note>{{ \'addon.mod_forum.postisprivatereply\' | translate }}</ion-note>\n    </div>\n    <core-format-text [component]="component" [componentId]="componentId" [text]="post.message"></core-format-text>\n    <div no-lines>\n        <ng-container *ngFor="let attachment of post.attachments">\n            <!-- Files already attached to the submission. -->\n            <core-file *ngIf="!attachment.name" [file]="attachment" [component]="component" [componentId]="componentId"></core-file>\n            <!-- Files stored in offline to be sent later. -->\n            <core-local-file *ngIf="attachment.name" [file]="attachment"></core-local-file>\n        </ng-container>\n    </div>\n</ion-card-content>\n<core-rating-rate *ngIf="forum && ratingInfo" [ratingInfo]="ratingInfo" contextLevel="module" [instanceId]="componentId" [itemId]="post.id" [itemSetId]="discussionId" [courseId]="courseId" [aggregateMethod]="forum.assessed" [scaleId]="forum.scale" [userId]="post.userid" (onUpdate)="ratingUpdated()"></core-rating-rate>\n<core-rating-aggregate *ngIf="forum && ratingInfo" [ratingInfo]="ratingInfo" contextLevel="module" [instanceId]="componentId" [itemId]="post.id" [courseId]="courseId" [aggregateMethod]="forum.assessed" [scaleId]="forum.scale"></core-rating-aggregate>\n<ion-item no-padding text-end *ngIf="post.id && post.canreply && !post.isprivatereply" class="addon-forum-reply-button">\n    <button ion-button icon-left clear small (click)="showReply()" [attr.aria-controls]="\'addon-forum-reply-edit-form-\' + uniqueId" [attr.aria-expanded]="replyData.replyingTo === post.id">\n        <ion-icon name="undo"></ion-icon> {{ \'addon.mod_forum.reply\' | translate }}\n    </button>\n</ion-item>\n<ion-item text-end *ngIf="!post.id && (!replyData.isEditing || replyData.replyingTo != post.parent)">\n    <button ion-button icon-left clear small (click)="editReply()" [attr.aria-controls]="\'addon-forum-reply-edit-form-\' + uniqueId" [attr.aria-expanded]="replyData.replyingTo === post.parent">\n        <ion-icon name="create"></ion-icon> {{ \'addon.mod_forum.edit\' | translate }}\n    </button>\n</ion-item>\n<ion-list [id]="\'addon-forum-reply-edit-form-\' + uniqueId" *ngIf="(post.id && !replyData.isEditing && replyData.replyingTo == post.id) || (!post.id && replyData.isEditing && replyData.replyingTo == post.parent)">\n    <ion-item>\n        <ion-label stacked>{{ \'addon.mod_forum.subject\' | translate }}</ion-label>\n        <ion-input type="text" [placeholder]="\'addon.mod_forum.subject\' | translate" [(ngModel)]="replyData.subject"></ion-input>\n    </ion-item>\n    <ion-item>\n        <ion-label stacked>{{ \'addon.mod_forum.message\' | translate }}</ion-label>\n        <core-rich-text-editor item-content [control]="messageControl" (contentChanged)="onMessageChange($event)" [placeholder]="\'addon.mod_forum.replyplaceholder\' | translate" [name]="\'mod_forum_reply_\' + post.id" [component]="component" [componentId]="componentId"></core-rich-text-editor>\n    </ion-item>\n    <ion-item text-wrap *ngIf="accessInfo.canpostprivatereply">\n        <ion-label>{{ \'addon.mod_forum.privatereply\' | translate }}</ion-label>\n        <ion-checkbox item-end [(ngModel)]="replyData.isprivatereply"></ion-checkbox>\n    </ion-item>\n    <ion-item-divider text-wrap (click)="toggleAdvanced()" class="core-expandable">\n        <core-icon *ngIf="!advanced" name="fa-caret-right" item-start></core-icon>\n        <core-icon *ngIf="advanced" name="fa-caret-down" item-start></core-icon>\n        {{ \'addon.mod_forum.advanced\' | translate }}\n    </ion-item-divider>\n    <ng-container *ngIf="advanced">\n        <core-attachments *ngIf="forum.id && forum.maxattachments > 0" [files]="replyData.files" [maxSize]="forum.maxbytes" [maxSubmissions]="forum.maxattachments" [component]="component" [componentId]="forum.cmid" [allowOffline]="true"></core-attachments>\n    </ng-container>\n    <ion-grid>\n        <ion-row>\n            <ion-col>\n                <button ion-button block (click)="reply()" [disabled]="replyData.subject == \'\' || replyData.message == null">{{ \'addon.mod_forum.posttoforum\' | translate }}</button>\n            </ion-col>\n            <ion-col>\n                <button ion-button block color="light" (click)="cancel()">{{ \'core.cancel\' | translate }}</button>\n            </ion-col>\n        </ion-row>\n        <ion-row *ngIf="replyData.isEditing">\n            <ion-col>\n                <button ion-button block color="light" (click)="discard()">{{ \'core.discard\' | translate }}</button>\n            </ion-col>\n        </ion-row>\n    </ion-grid>\n</ion-list>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\forum\components\post\addon-mod-forum-post.html"*/,
        }),
        __param(10, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __param(11, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_4__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sync__["a" /* CoreSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_7__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_9__providers_forum__["a" /* AddonModForumProvider */],
            __WEBPACK_IMPORTED_MODULE_10__providers_helper__["a" /* AddonModForumHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_11__providers_offline__["a" /* AddonModForumOfflineProvider */],
            __WEBPACK_IMPORTED_MODULE_12__providers_sync__["a" /* AddonModForumSyncProvider */],
            __WEBPACK_IMPORTED_MODULE_5__components_split_view_split_view__["a" /* CoreSplitViewComponent */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["f" /* Content */]])
    ], AddonModForumPostComponent);
    return AddonModForumPostComponent;
}());

//# sourceMappingURL=post.js.map

/***/ }),
/* 1610 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(435);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support glossary modules.
 */
var AddonModGlossaryModuleHandler = /** @class */ (function () {
    function AddonModGlossaryModuleHandler(courseProvider) {
        this.courseProvider = courseProvider;
        this.name = 'AddonModGlossary';
        this.modName = 'glossary';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_RATE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_PLAGIARISM] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModGlossaryModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModGlossaryModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_glossary-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModGlossaryIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModGlossaryModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModGlossaryIndexComponent */];
    };
    /**
     * Whether to display the course refresher in single activity course format. If it returns false, a refresher must be
     * included in the template that calls the doRefresh method of the component. Defaults to true.
     *
     * @return {boolean} Whether the refresher should be displayed.
     */
    AddonModGlossaryModuleHandler.prototype.displayRefresherInSingleActivity = function () {
        return false;
    };
    AddonModGlossaryModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModGlossaryModuleHandler);
    return AddonModGlossaryModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1611 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossarySyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(268);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModGlossarySyncCronHandler = /** @class */ (function () {
    function AddonModGlossarySyncCronHandler(glossarySync) {
        this.glossarySync = glossarySync;
        this.name = 'AddonModGlossarySyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModGlossarySyncCronHandler.prototype.execute = function (siteId, force) {
        return this.glossarySync.syncAllGlossaries(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModGlossarySyncCronHandler.prototype.getInterval = function () {
        return this.glossarySync.syncInterval;
    };
    AddonModGlossarySyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonModGlossarySyncProvider */]])
    ], AddonModGlossarySyncCronHandler);
    return AddonModGlossarySyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1612 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__glossary__ = __webpack_require__(155);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to glossary index.
 */
var AddonModGlossaryIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModGlossaryIndexLinkHandler, _super);
    function AddonModGlossaryIndexLinkHandler(courseHelper, glossaryProvider) {
        var _this = _super.call(this, courseHelper, 'AddonModGlossary', 'glossary') || this;
        _this.glossaryProvider = glossaryProvider;
        _this.name = 'AddonModGlossaryIndexLinkHandler';
        return _this;
    }
    AddonModGlossaryIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__glossary__["a" /* AddonModGlossaryProvider */]])
    ], AddonModGlossaryIndexLinkHandler);
    return AddonModGlossaryIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1613 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryEntryLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__glossary__ = __webpack_require__(155);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler to treat links to glossary entries.
 */
var AddonModGlossaryEntryLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModGlossaryEntryLinkHandler, _super);
    function AddonModGlossaryEntryLinkHandler(domUtils, linkHelper, glossaryProvider, courseHelper) {
        var _this = _super.call(this) || this;
        _this.domUtils = domUtils;
        _this.linkHelper = linkHelper;
        _this.glossaryProvider = glossaryProvider;
        _this.courseHelper = courseHelper;
        _this.name = 'AddonModGlossaryEntryLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModGlossary';
        _this.pattern = /\/mod\/glossary\/showentry\.php.*([\&\?]eid=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModGlossaryEntryLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading();
                    var entryId = parseInt(params.eid, 10);
                    var promise;
                    if (courseId) {
                        promise = Promise.resolve(courseId);
                    }
                    else {
                        promise = _this.glossaryProvider.getEntry(entryId, siteId).catch(function (error) {
                            _this.domUtils.showErrorModalDefault(error, 'addon.mod_glossary.errorloadingentry', true);
                            return Promise.reject(null);
                        }).then(function (response) {
                            return _this.courseHelper.getModuleCourseIdByInstance(response.entry.glossaryid, 'glossary', siteId);
                        });
                    }
                    return promise.then(function (courseId) {
                        _this.linkHelper.goInSite(navCtrl, 'AddonModGlossaryEntryPage', { courseId: courseId, entryId: entryId }, siteId);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    AddonModGlossaryEntryLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_5__glossary__["a" /* AddonModGlossaryProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModGlossaryEntryLinkHandler);
    return AddonModGlossaryEntryLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=entry-link-handler.js.map

/***/ }),
/* 1614 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModGlossaryListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to glossary list page.
 */
var AddonModGlossaryListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModGlossaryListLinkHandler, _super);
    function AddonModGlossaryListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModGlossary', 'glossary') || this;
        _this.name = 'AddonModGlossaryListLinkHandler';
        return _this;
    }
    AddonModGlossaryListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModGlossaryListLinkHandler);
    return AddonModGlossaryListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1615 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_index_index__ = __webpack_require__(436);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__imscp__ = __webpack_require__(214);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support IMSCP modules.
 */
var AddonModImscpModuleHandler = /** @class */ (function () {
    function AddonModImscpModuleHandler(courseProvider, imscpProvider) {
        this.courseProvider = courseProvider;
        this.imscpProvider = imscpProvider;
        this.name = 'AddonModImscp';
        this.modName = 'imscp';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE] = __WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModImscpModuleHandler.prototype.isEnabled = function () {
        return this.imscpProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModImscpModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_imscp-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModImscpIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModImscpModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_2__components_index_index__["a" /* AddonModImscpIndexComponent */];
    };
    AddonModImscpModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__imscp__["a" /* AddonModImscpProvider */]])
    ], AddonModImscpModuleHandler);
    return AddonModImscpModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1616 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to IMSCP.
 */
var AddonModImscpLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModImscpLinkHandler, _super);
    function AddonModImscpLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModImscp', 'imscp') || this;
        _this.name = 'AddonModImscpLinkHandler';
        return _this;
    }
    AddonModImscpLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModImscpLinkHandler);
    return AddonModImscpLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1617 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__imscp__ = __webpack_require__(214);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to IMSCP list page.
 */
var AddonModImscpListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModImscpListLinkHandler, _super);
    function AddonModImscpListLinkHandler(linkHelper, translate, imscpProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModImscp', 'imscp') || this;
        _this.imscpProvider = imscpProvider;
        _this.name = 'AddonModImscpListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModImscpListLinkHandler.prototype.isEnabled = function () {
        return this.imscpProvider.isPluginEnabled();
    };
    AddonModImscpListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__imscp__["a" /* AddonModImscpProvider */]])
    ], AddonModImscpListLinkHandler);
    return AddonModImscpListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1618 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModImscpPluginFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

/**
 * Handler to treat links to IMSCP.
 */
var AddonModImscpPluginFileHandler = /** @class */ (function () {
    function AddonModImscpPluginFileHandler() {
        this.name = 'AddonModImscpPluginFileHandler';
        this.component = 'mod_imscp';
    }
    /**
     * Return the RegExp to match the revision on pluginfile URLs.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {RegExp} RegExp to match the revision on pluginfile URLs.
     */
    AddonModImscpPluginFileHandler.prototype.getComponentRevisionRegExp = function (args) {
        // Check filearea.
        if (args[2] == 'content') {
            // Component + Filearea + Revision
            return new RegExp('/mod_imscp/content/([0-9]+)/');
        }
        if (args[2] == 'backup') {
            // Component + Filearea + Revision
            return new RegExp('/mod_imscp/backup/([0-9]+)/');
        }
        return null;
    };
    /**
     * Should return the string to remove the revision on pluginfile url.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {string} String to remove the revision on pluginfile url.
     */
    AddonModImscpPluginFileHandler.prototype.getComponentRevisionReplace = function (args) {
        // Component + Filearea + Revision
        return '/mod_imscp/' + args[2] + '/0/';
    };
    AddonModImscpPluginFileHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AddonModImscpPluginFileHandler);
    return AddonModImscpPluginFileHandler;
}());

//# sourceMappingURL=pluginfile-handler.js.map

/***/ }),
/* 1619 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(437);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__lesson__ = __webpack_require__(102);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support quiz modules.
 */
var AddonModLessonModuleHandler = /** @class */ (function () {
    function AddonModLessonModuleHandler(courseProvider, lessonProvider) {
        this.courseProvider = courseProvider;
        this.lessonProvider = lessonProvider;
        this.name = 'AddonModLesson';
        this.modName = 'lesson';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Promise resolved with boolean: whether or not the handler is enabled on a site level.
     */
    AddonModLessonModuleHandler.prototype.isEnabled = function () {
        return this.lessonProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModLessonModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_lesson-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModLessonIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModLessonModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModLessonIndexComponent */];
    };
    AddonModLessonModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__lesson__["a" /* AddonModLessonProvider */]])
    ], AddonModLessonModuleHandler);
    return AddonModLessonModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1620 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__lesson_sync__ = __webpack_require__(226);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModLessonSyncCronHandler = /** @class */ (function () {
    function AddonModLessonSyncCronHandler(lessonSync) {
        this.lessonSync = lessonSync;
        this.name = 'AddonModLessonSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModLessonSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.lessonSync.syncAllLessons(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModLessonSyncCronHandler.prototype.getInterval = function () {
        return this.lessonSync.syncInterval;
    };
    AddonModLessonSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__lesson_sync__["a" /* AddonModLessonSyncProvider */]])
    ], AddonModLessonSyncCronHandler);
    return AddonModLessonSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1621 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__lesson__ = __webpack_require__(102);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler to treat links to lesson index.
 */
var AddonModLessonIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModLessonIndexLinkHandler, _super);
    function AddonModLessonIndexLinkHandler(courseHelper, lessonProvider, domUtils, courseProvider) {
        var _this = _super.call(this, courseHelper, 'AddonModLesson', 'lesson') || this;
        _this.lessonProvider = lessonProvider;
        _this.domUtils = domUtils;
        _this.courseProvider = courseProvider;
        _this.name = 'AddonModLessonIndexLinkHandler';
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModLessonIndexLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    /* Ignore the pageid param. If we open the lesson player with a certain page and the user hasn't started
                       the lesson, an error is thrown: could not find lesson_timer records. */
                    if (params.userpassword) {
                        _this.navigateToModuleWithPassword(parseInt(params.id, 10), courseId, params.userpassword, siteId);
                    }
                    else {
                        _this.courseHelper.navigateToModule(parseInt(params.id, 10), siteId, courseId);
                    }
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModLessonIndexLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.lessonProvider.isPluginEnabled();
    };
    /**
     * Navigate to a lesson module (index page) with a fixed password.
     *
     * @param {number} moduleId Module ID.
     * @param {number} courseId Course ID.
     * @param {string} password Password.
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when navigated.
     */
    AddonModLessonIndexLinkHandler.prototype.navigateToModuleWithPassword = function (moduleId, courseId, password, siteId) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        // Get the module.
        return this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
            courseId = courseId || module.course;
            // Store the password so it's automatically used.
            return _this.lessonProvider.storePassword(parseInt(module.instance, 10), password, siteId).catch(function () {
                // Ignore errors.
            }).then(function () {
                return _this.courseHelper.navigateToModule(moduleId, siteId, courseId, module.section);
            });
        }).catch(function () {
            // Error, go to index page.
            return _this.courseHelper.navigateToModule(moduleId, siteId, courseId);
        }).finally(function () {
            modal.dismiss();
        });
    };
    AddonModLessonIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_5__lesson__["a" /* AddonModLessonProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModLessonIndexLinkHandler);
    return AddonModLessonIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1622 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonGradeLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_classes_module_grade_handler__ = __webpack_require__(266);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__lesson__ = __webpack_require__(102);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Handler to treat links to lesson grade.
 */
var AddonModLessonGradeLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModLessonGradeLinkHandler, _super);
    function AddonModLessonGradeLinkHandler(courseHelper, domUtils, sitesProvider, lessonProvider, courseProvider, linkHelper) {
        var _this = _super.call(this, courseHelper, domUtils, sitesProvider, 'AddonModLesson', 'lesson') || this;
        _this.lessonProvider = lessonProvider;
        _this.courseProvider = courseProvider;
        _this.linkHelper = linkHelper;
        _this.name = 'AddonModLessonGradeLinkHandler';
        _this.canReview = true;
        return _this;
    }
    /**
     * Go to the page to review.
     *
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} courseId Course ID related to the URL.
     * @param {string} siteId Site to use.
     * @param {NavController} [navCtrl] Nav Controller to use to navigate.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonGradeLinkHandler.prototype.goToReview = function (url, params, courseId, siteId, navCtrl) {
        var _this = this;
        var moduleId = parseInt(params.id, 10), modal = this.domUtils.showModalLoading();
        var module;
        return this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (mod) {
            module = mod;
            courseId = module.course || courseId || params.courseid || params.cid;
            // Check if the user can see the user reports in the lesson.
            return _this.lessonProvider.getAccessInformation(module.instance);
        }).then(function (info) {
            if (info.canviewreports) {
                // User can view reports, go to view the report.
                var pageParams = {
                    courseId: Number(courseId),
                    lessonId: module.instance,
                    userId: parseInt(params.userid, 10)
                };
                _this.linkHelper.goInSite(navCtrl, 'AddonModLessonUserRetakePage', pageParams, siteId);
            }
            else {
                // User cannot view the report, go to lesson index.
                _this.courseHelper.navigateToModule(moduleId, siteId, courseId, module.section);
            }
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'core.course.errorgetmodule', true);
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModLessonGradeLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.lessonProvider.isPluginEnabled();
    };
    AddonModLessonGradeLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_7__lesson__["a" /* AddonModLessonProvider */], __WEBPACK_IMPORTED_MODULE_5__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], AddonModLessonGradeLinkHandler);
    return AddonModLessonGradeLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_classes_module_grade_handler__["a" /* CoreContentLinksModuleGradeHandler */]));

//# sourceMappingURL=grade-link-handler.js.map

/***/ }),
/* 1623 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonReportLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__lesson__ = __webpack_require__(102);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Handler to treat links to lesson report.
 */
var AddonModLessonReportLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModLessonReportLinkHandler, _super);
    function AddonModLessonReportLinkHandler(domUtils, lessonProvider, courseHelper, linkHelper, courseProvider) {
        var _this = _super.call(this) || this;
        _this.domUtils = domUtils;
        _this.lessonProvider = lessonProvider;
        _this.courseHelper = courseHelper;
        _this.linkHelper = linkHelper;
        _this.courseProvider = courseProvider;
        _this.name = 'AddonModLessonReportLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModLesson';
        _this.pattern = /\/mod\/lesson\/report\.php.*([\&\?]id=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModLessonReportLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    if (!params.action || params.action == 'reportoverview') {
                        // Go to overview.
                        _this.openReportOverview(parseInt(params.id, 10), courseId, parseInt(params.group, 10), siteId, navCtrl);
                    }
                    else if (params.action == 'reportdetail') {
                        _this.openUserRetake(parseInt(params.id, 10), parseInt(params.userid, 10), courseId, parseInt(params.try, 10), siteId, navCtrl);
                    }
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModLessonReportLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (params.action == 'reportdetail' && !params.userid) {
            // Individual details are only available if the teacher is seeing a certain user.
            return false;
        }
        return this.lessonProvider.isPluginEnabled();
    };
    /**
     * Open report overview.
     *
     * @param {number} moduleId Module ID.
     * @param {number} courseId Course ID.
     * @param {string} groupId Group ID.
     * @param {string} siteId Site ID.
     * @param {NavController} [navCtrl] The NavController to use to navigate.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonReportLinkHandler.prototype.openReportOverview = function (moduleId, courseId, groupId, siteId, navCtrl) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        // Get the module object.
        return this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
            courseId = courseId || module.course;
            var pageParams = {
                module: module,
                courseId: Number(courseId),
                action: 'report',
                group: isNaN(groupId) ? null : groupId
            };
            _this.linkHelper.goInSite(navCtrl, 'AddonModLessonIndexPage', pageParams, siteId);
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'Error processing link.');
        }).finally(function () {
            modal.dismiss();
        });
    };
    /**
     * Open a user's retake.
     *
     * @param {number} moduleId Module ID.
     * @param {number} userId User ID.
     * @param {number} courseId Course ID.
     * @param {number} retake Retake to open.
     * @param {string} groupId Group ID.
     * @param {string} siteId Site ID.
     * @param {NavController} [navCtrl] The NavController to use to navigate.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonReportLinkHandler.prototype.openUserRetake = function (moduleId, userId, courseId, retake, siteId, navCtrl) {
        var _this = this;
        var modal = this.domUtils.showModalLoading();
        // Get the module object.
        return this.courseProvider.getModuleBasicInfo(moduleId, siteId).then(function (module) {
            courseId = courseId || module.course;
            var pageParams = {
                lessonId: module.instance,
                courseId: Number(courseId),
                userId: userId,
                retake: retake || 0
            };
            _this.linkHelper.goInSite(navCtrl, 'AddonModLessonUserRetakePage', pageParams, siteId);
        }).catch(function (error) {
            _this.domUtils.showErrorModalDefault(error, 'Error processing link.');
        }).finally(function () {
            modal.dismiss();
        });
    };
    AddonModLessonReportLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__lesson__["a" /* AddonModLessonProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModLessonReportLinkHandler);
    return AddonModLessonReportLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=report-link-handler.js.map

/***/ }),
/* 1624 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__lesson__ = __webpack_require__(102);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to lesson list page.
 */
var AddonModLessonListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModLessonListLinkHandler, _super);
    function AddonModLessonListLinkHandler(linkHelper, translate, lessonProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModLesson', 'lesson') || this;
        _this.lessonProvider = lessonProvider;
        _this.name = 'AddonModLessonListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Promise resolved with boolean: whether or not the handler is enabled on a site level.
     */
    AddonModLessonListLinkHandler.prototype.isEnabled = function () {
        return this.lessonProvider.isPluginEnabled();
    };
    AddonModLessonListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__lesson__["a" /* AddonModLessonProvider */]])
    ], AddonModLessonListLinkHandler);
    return AddonModLessonListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1625 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLessonPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_grades_providers_grades__ = __webpack_require__(101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_grades_providers_helper__ = __webpack_require__(110);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler for lesson push notifications clicks.
 */
var AddonModLessonPushClickHandler = /** @class */ (function () {
    function AddonModLessonPushClickHandler(utils, gradesHelper, gradesProvider) {
        this.utils = utils;
        this.gradesHelper = gradesHelper;
        this.gradesProvider = gradesProvider;
        this.name = 'AddonModLessonPushClickHandler';
        this.priority = 200;
        this.featureName = 'CoreCourseModuleDelegate_AddonModLesson';
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonModLessonPushClickHandler.prototype.handles = function (notification) {
        if (this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'mod_lesson' &&
            notification.name == 'graded_essay') {
            return this.gradesProvider.isPluginEnabledForCourse(Number(notification.courseid), notification.site);
        }
        return false;
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModLessonPushClickHandler.prototype.handleClick = function (notification) {
        var data = notification.customdata || {}, courseId = Number(notification.courseid), moduleId = Number(data.cmid);
        return this.gradesHelper.goToGrades(courseId, undefined, moduleId, undefined, notification.site);
    };
    AddonModLessonPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__core_grades_providers_helper__["a" /* CoreGradesHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_2__core_grades_providers_grades__["a" /* CoreGradesProvider */]])
    ], AddonModLessonPushClickHandler);
    return AddonModLessonPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1626 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLtiModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__ = __webpack_require__(83);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_index_index__ = __webpack_require__(438);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__lti__ = __webpack_require__(373);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Handler to support LTI modules.
 */
var AddonModLtiModuleHandler = /** @class */ (function () {
    function AddonModLtiModuleHandler(appProvider, courseProvider, domUtils, filepoolProvider, sitesProvider, ltiProvider, sanitizer) {
        this.appProvider = appProvider;
        this.courseProvider = courseProvider;
        this.domUtils = domUtils;
        this.filepoolProvider = filepoolProvider;
        this.sitesProvider = sitesProvider;
        this.ltiProvider = ltiProvider;
        this.sanitizer = sanitizer;
        this.name = 'AddonModLti';
        this.modName = 'lti';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_9__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModLtiModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModLtiModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        var _this = this;
        var data = {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_lti-handler',
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModLtiIndexPage', pageParams, options);
            },
            buttons: [{
                    icon: 'link',
                    label: 'addon.mod_lti.launchactivity',
                    action: function (event, navCtrl, module, courseId) {
                        var modal = _this.domUtils.showModalLoading();
                        // Get LTI and launch data.
                        _this.ltiProvider.getLti(courseId, module.id).then(function (ltiData) {
                            return _this.ltiProvider.getLtiLaunchData(ltiData.id).then(function (launchData) {
                                // "View" LTI.
                                _this.ltiProvider.logView(ltiData.id, ltiData.name).then(function () {
                                    _this.courseProvider.checkModuleCompletion(courseId, module.completiondata);
                                }).catch(function () {
                                    // Ignore errors.
                                });
                                // Launch LTI.
                                return _this.ltiProvider.launch(launchData.endpoint, launchData.parameters);
                            });
                        }).catch(function (message) {
                            _this.domUtils.showErrorModalDefault(message, 'addon.mod_lti.errorgetlti', true);
                        }).finally(function () {
                            modal.dismiss();
                        });
                    }
                }]
        };
        // Handle custom icons.
        this.ltiProvider.getLti(courseId, module.id).then(function (ltiData) {
            var icon = ltiData.secureicon || ltiData.icon;
            if (icon) {
                var siteId_1 = _this.sitesProvider.getCurrentSiteId();
                _this.filepoolProvider.downloadUrl(siteId_1, icon, false, __WEBPACK_IMPORTED_MODULE_8__lti__["a" /* AddonModLtiProvider */].COMPONENT, module.id).then(function () {
                    // Get the internal URL.
                    return _this.filepoolProvider.getSrcByUrl(siteId_1, icon, __WEBPACK_IMPORTED_MODULE_8__lti__["a" /* AddonModLtiProvider */].COMPONENT, module.id);
                }).then(function (url) {
                    data.icon = _this.sanitizer.bypassSecurityTrustUrl(url);
                }).catch(function () {
                    // Error downloading. If we're online we'll set the online url.
                    if (_this.appProvider.isOnline()) {
                        data.icon = _this.sanitizer.bypassSecurityTrustUrl(icon);
                    }
                });
            }
        }).catch(function () {
            // Ignore errors.
        });
        return data;
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModLtiModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_7__components_index_index__["a" /* AddonModLtiIndexComponent */];
    };
    AddonModLtiModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_8__lti__["a" /* AddonModLtiProvider */],
            __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser__["c" /* DomSanitizer */]])
    ], AddonModLtiModuleHandler);
    return AddonModLtiModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1627 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLtiLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to LTI.
 */
var AddonModLtiLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModLtiLinkHandler, _super);
    function AddonModLtiLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModLti', 'lti') || this;
        _this.name = 'AddonModLtiLinkHandler';
        return _this;
    }
    AddonModLtiLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModLtiLinkHandler);
    return AddonModLtiLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1628 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLtiListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to LTI list page.
 */
var AddonModLtiListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModLtiListLinkHandler, _super);
    function AddonModLtiListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModLti', 'lti') || this;
        _this.name = 'AddonModLtiListLinkHandler';
        return _this;
    }
    AddonModLtiListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModLtiListLinkHandler);
    return AddonModLtiListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1629 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPageModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__page__ = __webpack_require__(172);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_index_index__ = __webpack_require__(439);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support page modules.
 */
var AddonModPageModuleHandler = /** @class */ (function () {
    function AddonModPageModuleHandler(courseProvider, pageProvider) {
        this.courseProvider = courseProvider;
        this.pageProvider = pageProvider;
        this.name = 'AddonModPage';
        this.modName = 'page';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE] = __WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModPageModuleHandler.prototype.isEnabled = function () {
        return this.pageProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModPageModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_page-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModPageIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModPageModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_2__components_index_index__["a" /* AddonModPageIndexComponent */];
    };
    AddonModPageModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_1__page__["a" /* AddonModPageProvider */]])
    ], AddonModPageModuleHandler);
    return AddonModPageModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1630 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPageLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to resource.
 */
var AddonModPageLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModPageLinkHandler, _super);
    function AddonModPageLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModPage', 'page') || this;
        _this.name = 'AddonModPageLinkHandler';
        return _this;
    }
    AddonModPageLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModPageLinkHandler);
    return AddonModPageLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1631 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPageListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__page__ = __webpack_require__(172);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to page list page.
 */
var AddonModPageListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModPageListLinkHandler, _super);
    function AddonModPageListLinkHandler(linkHelper, translate, pageProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModPage', 'page') || this;
        _this.pageProvider = pageProvider;
        _this.name = 'AddonModPageListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModPageListLinkHandler.prototype.isEnabled = function () {
        return this.pageProvider.isPluginEnabled();
    };
    AddonModPageListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__page__["a" /* AddonModPageProvider */]])
    ], AddonModPageListLinkHandler);
    return AddonModPageListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1632 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModPagePluginFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

/**
 * Handler to treat links to page.
 */
var AddonModPagePluginFileHandler = /** @class */ (function () {
    function AddonModPagePluginFileHandler() {
        this.name = 'AddonModPagePluginFileHandler';
        this.component = 'mod_page';
    }
    /**
     * Return the RegExp to match the revision on pluginfile URLs.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {RegExp} RegExp to match the revision on pluginfile URLs.
     */
    AddonModPagePluginFileHandler.prototype.getComponentRevisionRegExp = function (args) {
        // Check filearea.
        if (args[2] == 'content') {
            // Component + Filearea + Revision
            return new RegExp('/mod_page/content/([0-9]+)/');
        }
    };
    /**
     * Should return the string to remove the revision on pluginfile url.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {string} String to remove the revision on pluginfile url.
     */
    AddonModPagePluginFileHandler.prototype.getComponentRevisionReplace = function (args) {
        // Component + Filearea + Revision
        return '/mod_page/content/0/';
    };
    AddonModPagePluginFileHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AddonModPagePluginFileHandler);
    return AddonModPagePluginFileHandler;
}());

//# sourceMappingURL=pluginfile-handler.js.map

/***/ }),
/* 1633 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(440);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support quiz modules.
 */
var AddonModQuizModuleHandler = /** @class */ (function () {
    function AddonModQuizModuleHandler(courseProvider) {
        this.courseProvider = courseProvider;
        this.name = 'AddonModQuiz';
        this.modName = 'quiz';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_CONTROLS_GRADE_VISIBILITY] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_USES_QUESTIONS] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModQuizModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModQuizModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_quiz-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModQuizIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModQuizModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModQuizIndexComponent */];
    };
    AddonModQuizModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModQuizModuleHandler);
    return AddonModQuizModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1634 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__quiz_sync__ = __webpack_require__(189);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModQuizSyncCronHandler = /** @class */ (function () {
    function AddonModQuizSyncCronHandler(quizSync) {
        this.quizSync = quizSync;
        this.name = 'AddonModQuizSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModQuizSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.quizSync.syncAllQuizzes(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModQuizSyncCronHandler.prototype.getInterval = function () {
        return this.quizSync.syncInterval;
    };
    AddonModQuizSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__quiz_sync__["a" /* AddonModQuizSyncProvider */]])
    ], AddonModQuizSyncCronHandler);
    return AddonModQuizSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1635 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__quiz__ = __webpack_require__(99);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to quiz index.
 */
var AddonModQuizIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModQuizIndexLinkHandler, _super);
    function AddonModQuizIndexLinkHandler(courseHelper, quizProvider) {
        var _this = _super.call(this, courseHelper, 'AddonModQuiz', 'quiz') || this;
        _this.quizProvider = quizProvider;
        _this.name = 'AddonModQuizIndexLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModQuizIndexLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.quizProvider.isPluginEnabled();
    };
    AddonModQuizIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__quiz__["a" /* AddonModQuizProvider */]])
    ], AddonModQuizIndexLinkHandler);
    return AddonModQuizIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1636 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizGradeLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_classes_module_grade_handler__ = __webpack_require__(266);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__quiz__ = __webpack_require__(99);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler to treat links to quiz grade.
 */
var AddonModQuizGradeLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModQuizGradeLinkHandler, _super);
    function AddonModQuizGradeLinkHandler(courseHelper, domUtils, sitesProvider, quizProvider) {
        var _this = _super.call(this, courseHelper, domUtils, sitesProvider, 'AddonModQuiz', 'quiz') || this;
        _this.quizProvider = quizProvider;
        _this.name = 'AddonModQuizGradeLinkHandler';
        _this.canReview = false;
        return _this;
    }
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModQuizGradeLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.quizProvider.isPluginEnabled();
    };
    AddonModQuizGradeLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__quiz__["a" /* AddonModQuizProvider */]])
    ], AddonModQuizGradeLinkHandler);
    return AddonModQuizGradeLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_classes_module_grade_handler__["a" /* CoreContentLinksModuleGradeHandler */]));

//# sourceMappingURL=grade-link-handler.js.map

/***/ }),
/* 1637 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizReviewLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__quiz__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(185);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to quiz review.
 */
var AddonModQuizReviewLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModQuizReviewLinkHandler, _super);
    function AddonModQuizReviewLinkHandler(quizProvider, quizHelper) {
        var _this = _super.call(this) || this;
        _this.quizProvider = quizProvider;
        _this.quizHelper = quizHelper;
        _this.name = 'AddonModQuizReviewLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModQuiz';
        _this.pattern = /\/mod\/quiz\/review\.php.*([\&\?]attempt=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @param {any} [data] Extra data to handle the URL.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModQuizReviewLinkHandler.prototype.getActions = function (siteIds, url, params, courseId, data) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        data = data || {};
        return [{
                action: function (siteId, navCtrl) {
                    var attemptId = parseInt(params.attempt, 10), page = parseInt(params.page, 10), quizId = data.instance && parseInt(data.instance, 10);
                    _this.quizHelper.handleReviewLink(navCtrl, attemptId, page, courseId, quizId, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModQuizReviewLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.quizProvider.isPluginEnabled();
    };
    AddonModQuizReviewLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__quiz__["a" /* AddonModQuizProvider */], __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* AddonModQuizHelperProvider */]])
    ], AddonModQuizReviewLinkHandler);
    return AddonModQuizReviewLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=review-link-handler.js.map

/***/ }),
/* 1638 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to quiz list page.
 */
var AddonModQuizListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModQuizListLinkHandler, _super);
    function AddonModQuizListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModQuiz', 'quiz') || this;
        _this.name = 'AddonModQuizListLinkHandler';
        return _this;
    }
    AddonModQuizListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModQuizListLinkHandler);
    return AddonModQuizListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1639 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__quiz__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__helper__ = __webpack_require__(185);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler for quiz push notifications clicks.
 */
var AddonModQuizPushClickHandler = /** @class */ (function () {
    function AddonModQuizPushClickHandler(utils, quizProvider, urlUtils, courseHelper, quizHelper) {
        this.utils = utils;
        this.quizProvider = quizProvider;
        this.urlUtils = urlUtils;
        this.courseHelper = courseHelper;
        this.quizHelper = quizHelper;
        this.name = 'AddonModQuizPushClickHandler';
        this.priority = 200;
        this.featureName = 'CoreCourseModuleDelegate_AddonModQuiz';
        this.SUPPORTED_NAMES = ['submission', 'confirmation', 'attempt_overdue'];
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonModQuizPushClickHandler.prototype.handles = function (notification) {
        return this.utils.isTrueOrOne(notification.notif) && notification.moodlecomponent == 'mod_quiz' &&
            this.SUPPORTED_NAMES.indexOf(notification.name) != -1;
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var contextUrlParams = this.urlUtils.extractUrlParams(notification.contexturl), data = notification.customdata || {}, courseId = Number(notification.courseid);
        if (notification.name == 'submission') {
            // A student made a submission, go to view the attempt.
            return this.quizHelper.handleReviewLink(undefined, Number(contextUrlParams.attempt), Number(contextUrlParams.page), courseId, Number(data.instance), notification.site);
        }
        else {
            // Open the activity.
            var moduleId_1 = Number(contextUrlParams.id);
            return this.quizProvider.invalidateContent(moduleId_1, courseId, notification.site).catch(function () {
                // Ignore errors.
            }).then(function () {
                return _this.courseHelper.navigateToModule(moduleId_1, notification.site, courseId);
            });
        }
    };
    AddonModQuizPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__quiz__["a" /* AddonModQuizProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_5__helper__["a" /* AddonModQuizHelperProvider */]])
    ], AddonModQuizPushClickHandler);
    return AddonModQuizPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1640 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessDelayBetweenAttemptsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1641);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonModQuizAccessDelayBetweenAttemptsModule = /** @class */ (function () {
    function AddonModQuizAccessDelayBetweenAttemptsModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessDelayBetweenAttemptsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessDelayBetweenAttemptsHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessDelayBetweenAttemptsHandler */]])
    ], AddonModQuizAccessDelayBetweenAttemptsModule);
    return AddonModQuizAccessDelayBetweenAttemptsModule;
}());

//# sourceMappingURL=delaybetweenattempts.module.js.map

/***/ }),
/* 1641 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessDelayBetweenAttemptsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Handler to support delay between attempts access rule.
 */
var AddonModQuizAccessDelayBetweenAttemptsHandler = /** @class */ (function () {
    function AddonModQuizAccessDelayBetweenAttemptsHandler() {
        this.name = 'AddonModQuizAccessDelayBetweenAttempts';
        this.ruleName = 'quizaccess_delaybetweenattempts';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessDelayBetweenAttemptsHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessDelayBetweenAttemptsHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        return false;
    };
    AddonModQuizAccessDelayBetweenAttemptsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessDelayBetweenAttemptsHandler);
    return AddonModQuizAccessDelayBetweenAttemptsHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1642 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessIpAddressModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1643);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonModQuizAccessIpAddressModule = /** @class */ (function () {
    function AddonModQuizAccessIpAddressModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessIpAddressModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessIpAddressHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessIpAddressHandler */]])
    ], AddonModQuizAccessIpAddressModule);
    return AddonModQuizAccessIpAddressModule;
}());

//# sourceMappingURL=ipaddress.module.js.map

/***/ }),
/* 1643 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessIpAddressHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Handler to support IP address access rule.
 */
var AddonModQuizAccessIpAddressHandler = /** @class */ (function () {
    function AddonModQuizAccessIpAddressHandler() {
        this.name = 'AddonModQuizAccessIpAddress';
        this.ruleName = 'quizaccess_ipaddress';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessIpAddressHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessIpAddressHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        return false;
    };
    AddonModQuizAccessIpAddressHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessIpAddressHandler);
    return AddonModQuizAccessIpAddressHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1644 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessNumAttemptsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1645);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonModQuizAccessNumAttemptsModule = /** @class */ (function () {
    function AddonModQuizAccessNumAttemptsModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessNumAttemptsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessNumAttemptsHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessNumAttemptsHandler */]])
    ], AddonModQuizAccessNumAttemptsModule);
    return AddonModQuizAccessNumAttemptsModule;
}());

//# sourceMappingURL=numattempts.module.js.map

/***/ }),
/* 1645 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessNumAttemptsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Handler to support num attempts access rule.
 */
var AddonModQuizAccessNumAttemptsHandler = /** @class */ (function () {
    function AddonModQuizAccessNumAttemptsHandler() {
        this.name = 'AddonModQuizAccessNumAttempts';
        this.ruleName = 'quizaccess_numattempts';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessNumAttemptsHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessNumAttemptsHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        return false;
    };
    AddonModQuizAccessNumAttemptsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessNumAttemptsHandler);
    return AddonModQuizAccessNumAttemptsHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1646 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessOfflineAttemptsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1647);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_offlineattempts__ = __webpack_require__(861);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonModQuizAccessOfflineAttemptsModule = /** @class */ (function () {
    function AddonModQuizAccessOfflineAttemptsModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessOfflineAttemptsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_offlineattempts__["a" /* AddonModQuizAccessOfflineAttemptsComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModQuizAccessOfflineAttemptsHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_offlineattempts__["a" /* AddonModQuizAccessOfflineAttemptsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_offlineattempts__["a" /* AddonModQuizAccessOfflineAttemptsComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModQuizAccessOfflineAttemptsHandler */]])
    ], AddonModQuizAccessOfflineAttemptsModule);
    return AddonModQuizAccessOfflineAttemptsModule;
}());

//# sourceMappingURL=offlineattempts.module.js.map

/***/ }),
/* 1647 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessOfflineAttemptsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_quiz_sync__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_offlineattempts__ = __webpack_require__(861);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support offline attempts access rule.
 */
var AddonModQuizAccessOfflineAttemptsHandler = /** @class */ (function () {
    function AddonModQuizAccessOfflineAttemptsHandler(quizSync) {
        this.quizSync = quizSync;
        this.name = 'AddonModQuizAccessOfflineAttempts';
        this.ruleName = 'quizaccess_offlineattempts';
        // Nothing to do.
    }
    /**
     * Add preflight data that doesn't require user interaction. The data should be added to the preflightData param.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} preflightData Object where to add the preflight data.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Promise resolved when done if async, void if it's synchronous.
     */
    AddonModQuizAccessOfflineAttemptsHandler.prototype.getFixedPreflightData = function (quiz, preflightData, attempt, prefetch, siteId) {
        preflightData.confirmdatasaved = 1;
    };
    /**
     * Return the Component to use to display the access rule preflight.
     * Implement this if your access rule requires a preflight check with user interaction.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModQuizAccessOfflineAttemptsHandler.prototype.getPreflightComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_2__component_offlineattempts__["a" /* AddonModQuizAccessOfflineAttemptsComponent */];
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessOfflineAttemptsHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessOfflineAttemptsHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        if (prefetch) {
            // Don't show the warning if the user is prefetching.
            return false;
        }
        if (!attempt) {
            // User is starting a new attempt, show the warning.
            return true;
        }
        // Show warning if last sync was a while ago.
        return Date.now() - this.quizSync.syncInterval > quiz.syncTime;
    };
    AddonModQuizAccessOfflineAttemptsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_quiz_sync__["a" /* AddonModQuizSyncProvider */]])
    ], AddonModQuizAccessOfflineAttemptsHandler);
    return AddonModQuizAccessOfflineAttemptsHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1648 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessOpenCloseDateModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1649);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonModQuizAccessOpenCloseDateModule = /** @class */ (function () {
    function AddonModQuizAccessOpenCloseDateModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessOpenCloseDateModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessOpenCloseDateHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessOpenCloseDateHandler */]])
    ], AddonModQuizAccessOpenCloseDateModule);
    return AddonModQuizAccessOpenCloseDateModule;
}());

//# sourceMappingURL=openclosedate.module.js.map

/***/ }),
/* 1649 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessOpenCloseDateHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_quiz__ = __webpack_require__(99);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support open/close date access rule.
 */
var AddonModQuizAccessOpenCloseDateHandler = /** @class */ (function () {
    function AddonModQuizAccessOpenCloseDateHandler() {
        this.name = 'AddonModQuizAccessOpenCloseDate';
        this.ruleName = 'quizaccess_openclosedate';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessOpenCloseDateHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessOpenCloseDateHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        return false;
    };
    /**
     * Whether or not the time left of an attempt should be displayed.
     *
     * @param {any} attempt The attempt.
     * @param {number} endTime The attempt end time (in seconds).
     * @param {number} timeNow The current time in seconds.
     * @return {boolean} Whether it should be displayed.
     */
    AddonModQuizAccessOpenCloseDateHandler.prototype.shouldShowTimeLeft = function (attempt, endTime, timeNow) {
        // If this is a teacher preview after the close date, do not show the time.
        if (attempt.preview && timeNow > endTime) {
            return false;
        }
        // Show the time left only if it's less than QUIZ_SHOW_TIME_BEFORE_DEADLINE.
        if (timeNow > endTime - __WEBPACK_IMPORTED_MODULE_1__providers_quiz__["a" /* AddonModQuizProvider */].QUIZ_SHOW_TIME_BEFORE_DEADLINE) {
            return true;
        }
        return false;
    };
    AddonModQuizAccessOpenCloseDateHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessOpenCloseDateHandler);
    return AddonModQuizAccessOpenCloseDateHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1650 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessPasswordModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_handler__ = __webpack_require__(1651);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_password__ = __webpack_require__(862);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_access_rules_delegate__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModQuizAccessPasswordModule = /** @class */ (function () {
    function AddonModQuizAccessPasswordModule(accessRuleDelegate, handler, updateManager) {
        accessRuleDelegate.registerHandler(handler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mod_quiz_access_password',
            newName: __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonModQuizAccessPasswordHandler */].PASSWORD_TABLE
        });
    }
    AddonModQuizAccessPasswordModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_password__["a" /* AddonModQuizAccessPasswordComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonModQuizAccessPasswordHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_password__["a" /* AddonModQuizAccessPasswordComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_password__["a" /* AddonModQuizAccessPasswordComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_7__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonModQuizAccessPasswordHandler */],
            __WEBPACK_IMPORTED_MODULE_8__providers_update_manager__["a" /* CoreUpdateManagerProvider */]])
    ], AddonModQuizAccessPasswordModule);
    return AddonModQuizAccessPasswordModule;
}());

//# sourceMappingURL=password.module.js.map

/***/ }),
/* 1651 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessPasswordHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_password__ = __webpack_require__(862);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support password access rule.
 */
var AddonModQuizAccessPasswordHandler = /** @class */ (function () {
    function AddonModQuizAccessPasswordHandler(sitesProvider) {
        this.sitesProvider = sitesProvider;
        this.siteSchema = {
            name: 'AddonModQuizAccessPasswordHandler',
            version: 1,
            tables: [
                {
                    name: AddonModQuizAccessPasswordHandler_1.PASSWORD_TABLE,
                    columns: [
                        {
                            name: 'id',
                            type: 'INTEGER',
                            primaryKey: true
                        },
                        {
                            name: 'password',
                            type: 'TEXT'
                        },
                        {
                            name: 'timemodified',
                            type: 'INTEGER'
                        }
                    ]
                }
            ]
        };
        this.name = 'AddonModQuizAccessPassword';
        this.ruleName = 'quizaccess_password';
        this.sitesProvider.registerSiteSchema(this.siteSchema);
    }
    AddonModQuizAccessPasswordHandler_1 = AddonModQuizAccessPasswordHandler;
    /**
     * Add preflight data that doesn't require user interaction. The data should be added to the preflightData param.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} preflightData Object where to add the preflight data.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Promise resolved when done if async, void if it's synchronous.
     */
    AddonModQuizAccessPasswordHandler.prototype.getFixedPreflightData = function (quiz, preflightData, attempt, prefetch, siteId) {
        if (quiz && quiz.id && typeof preflightData.quizpassword == 'undefined') {
            // Try to get a password stored. If it's found, use it.
            return this.getPasswordEntry(quiz.id, siteId).then(function (entry) {
                preflightData.quizpassword = entry.password;
            }).catch(function () {
                // Don't reject.
            });
        }
    };
    /**
     * Get a password stored in DB.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved with the DB entry on success.
     */
    AddonModQuizAccessPasswordHandler.prototype.getPasswordEntry = function (quizId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().getRecord(AddonModQuizAccessPasswordHandler_1.PASSWORD_TABLE, { id: quizId });
        });
    };
    /**
     * Return the Component to use to display the access rule preflight.
     * Implement this if your access rule requires a preflight check with user interaction.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModQuizAccessPasswordHandler.prototype.getPreflightComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_2__component_password__["a" /* AddonModQuizAccessPasswordComponent */];
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessPasswordHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessPasswordHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        // If there's a password stored don't require the preflight since we'll use the stored one.
        return this.getPasswordEntry(quiz.id, siteId).then(function () {
            return false;
        }).catch(function () {
            // Not stored.
            return true;
        });
    };
    /**
     * Function called when the preflight check has passed. This is a chance to record that fact in some way.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} attempt The attempt started/continued.
     * @param {any} preflightData Preflight data gathered.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Promise resolved when done if async, void if it's synchronous.
     */
    AddonModQuizAccessPasswordHandler.prototype.notifyPreflightCheckPassed = function (quiz, attempt, preflightData, prefetch, siteId) {
        // The password is right, store it to use it automatically in following executions.
        if (quiz && quiz.id && typeof preflightData.quizpassword != 'undefined') {
            return this.storePassword(quiz.id, preflightData.quizpassword, siteId);
        }
    };
    /**
     * Function called when the preflight check fails. This is a chance to record that fact in some way.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} attempt The attempt started/continued.
     * @param {any} preflightData Preflight data gathered.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Promise resolved when done if async, void if it's synchronous.
     */
    AddonModQuizAccessPasswordHandler.prototype.notifyPreflightCheckFailed = function (quiz, attempt, preflightData, prefetch, siteId) {
        // The password is wrong, remove it from DB if it's there.
        if (quiz && quiz.id) {
            return this.removePassword(quiz.id, siteId);
        }
    };
    /**
     * Remove a password from DB.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizAccessPasswordHandler.prototype.removePassword = function (quizId, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            return site.getDb().deleteRecords(AddonModQuizAccessPasswordHandler_1.PASSWORD_TABLE, { id: quizId });
        });
    };
    /**
     * Store a password in DB.
     *
     * @param {number} quizId Quiz ID.
     * @param {string} password Password.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModQuizAccessPasswordHandler.prototype.storePassword = function (quizId, password, siteId) {
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var entry = {
                id: quizId,
                password: password,
                timemodified: Date.now()
            };
            return site.getDb().insertRecord(AddonModQuizAccessPasswordHandler_1.PASSWORD_TABLE, entry);
        });
    };
    // Variables for database.
    AddonModQuizAccessPasswordHandler.PASSWORD_TABLE = 'addon_mod_quiz_access_password';
    AddonModQuizAccessPasswordHandler = AddonModQuizAccessPasswordHandler_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModQuizAccessPasswordHandler);
    return AddonModQuizAccessPasswordHandler;
    var AddonModQuizAccessPasswordHandler_1;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1652 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessSafeBrowserModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1653);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonModQuizAccessSafeBrowserModule = /** @class */ (function () {
    function AddonModQuizAccessSafeBrowserModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessSafeBrowserModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessSafeBrowserHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessSafeBrowserHandler */]])
    ], AddonModQuizAccessSafeBrowserModule);
    return AddonModQuizAccessSafeBrowserModule;
}());

//# sourceMappingURL=safebrowser.module.js.map

/***/ }),
/* 1653 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessSafeBrowserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Handler to support safe address access rule.
 */
var AddonModQuizAccessSafeBrowserHandler = /** @class */ (function () {
    function AddonModQuizAccessSafeBrowserHandler() {
        this.name = 'AddonModQuizAccessSafeBrowser';
        this.ruleName = 'quizaccess_safebrowser';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessSafeBrowserHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessSafeBrowserHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        return false;
    };
    AddonModQuizAccessSafeBrowserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessSafeBrowserHandler);
    return AddonModQuizAccessSafeBrowserHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1654 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessSecureWindowModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1655);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonModQuizAccessSecureWindowModule = /** @class */ (function () {
    function AddonModQuizAccessSecureWindowModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessSecureWindowModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessSecureWindowHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonModQuizAccessSecureWindowHandler */]])
    ], AddonModQuizAccessSecureWindowModule);
    return AddonModQuizAccessSecureWindowModule;
}());

//# sourceMappingURL=securewindow.module.js.map

/***/ }),
/* 1655 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessSecureWindowHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * Handler to support secure window access rule.
 */
var AddonModQuizAccessSecureWindowHandler = /** @class */ (function () {
    function AddonModQuizAccessSecureWindowHandler() {
        this.name = 'AddonModQuizAccessSecureWindow';
        this.ruleName = 'quizaccess_securewindow';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessSecureWindowHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessSecureWindowHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        return false;
    };
    AddonModQuizAccessSecureWindowHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessSecureWindowHandler);
    return AddonModQuizAccessSecureWindowHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1656 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessTimeLimitModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1657);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_timelimit__ = __webpack_require__(863);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_access_rules_delegate__ = __webpack_require__(79);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonModQuizAccessTimeLimitModule = /** @class */ (function () {
    function AddonModQuizAccessTimeLimitModule(accessRuleDelegate, handler) {
        accessRuleDelegate.registerHandler(handler);
    }
    AddonModQuizAccessTimeLimitModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_timelimit__["a" /* AddonModQuizAccessTimeLimitComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModQuizAccessTimeLimitHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_timelimit__["a" /* AddonModQuizAccessTimeLimitComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_timelimit__["a" /* AddonModQuizAccessTimeLimitComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModQuizAccessTimeLimitHandler */]])
    ], AddonModQuizAccessTimeLimitModule);
    return AddonModQuizAccessTimeLimitModule;
}());

//# sourceMappingURL=timelimit.module.js.map

/***/ }),
/* 1657 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModQuizAccessTimeLimitHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__component_timelimit__ = __webpack_require__(863);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support time limit access rule.
 */
var AddonModQuizAccessTimeLimitHandler = /** @class */ (function () {
    function AddonModQuizAccessTimeLimitHandler() {
        this.name = 'AddonModQuizAccessTimeLimit';
        this.ruleName = 'quizaccess_timelimit';
        // Nothing to do.
    }
    /**
     * Return the Component to use to display the access rule preflight.
     * Implement this if your access rule requires a preflight check with user interaction.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModQuizAccessTimeLimitHandler.prototype.getPreflightComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__component_timelimit__["a" /* AddonModQuizAccessTimeLimitComponent */];
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModQuizAccessTimeLimitHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    AddonModQuizAccessTimeLimitHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        // Warning only required if the attempt is not already started.
        return !attempt;
    };
    /**
     * Whether or not the time left of an attempt should be displayed.
     *
     * @param {any} attempt The attempt.
     * @param {number} endTime The attempt end time (in seconds).
     * @param {number} timeNow The current time in seconds.
     * @return {boolean} Whether it should be displayed.
     */
    AddonModQuizAccessTimeLimitHandler.prototype.shouldShowTimeLeft = function (attempt, endTime, timeNow) {
        // If this is a teacher preview after the time limit expires, don't show the time left.
        return !(attempt.preview && timeNow > endTime);
    };
    AddonModQuizAccessTimeLimitHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModQuizAccessTimeLimitHandler);
    return AddonModQuizAccessTimeLimitHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1658 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourceModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__resource__ = __webpack_require__(181);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(269);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_index_index__ = __webpack_require__(441);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_mimetype__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











/**
 * Handler to support resource modules.
 */
var AddonModResourceModuleHandler = /** @class */ (function () {
    function AddonModResourceModuleHandler(resourceProvider, courseProvider, mimetypeUtils, resourceHelper, prefetchDelegate, textUtils, translate, timeUtils) {
        this.resourceProvider = resourceProvider;
        this.courseProvider = courseProvider;
        this.mimetypeUtils = mimetypeUtils;
        this.resourceHelper = resourceHelper;
        this.prefetchDelegate = prefetchDelegate;
        this.textUtils = textUtils;
        this.translate = translate;
        this.timeUtils = timeUtils;
        this.name = 'AddonModResource';
        this.modName = 'resource';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE] = __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModResourceModuleHandler.prototype.isEnabled = function () {
        return this.resourceProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModResourceModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        var _this = this;
        var updateStatus = function (status) {
            handlerData.buttons[0].hidden = status !== __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].DOWNLOADED ||
                _this.resourceHelper.isDisplayedInIframe(module);
        };
        var handlerData = {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_resource-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModResourceIndexPage', pageParams, options);
            },
            updateStatus: updateStatus.bind(this),
            buttons: [{
                    hidden: true,
                    icon: 'document',
                    label: 'addon.mod_resource.openthefile',
                    action: function (event, navCtrl, module, courseId) {
                        _this.hideOpenButton(module, courseId).then(function (hide) {
                            if (!hide) {
                                _this.resourceHelper.openModuleFile(module, courseId);
                            }
                        });
                    }
                }]
        };
        this.getResourceData(module, courseId, handlerData).then(function (data) {
            handlerData.icon = data.icon;
            handlerData.extraBadge = data.extra;
            handlerData.extraBadgeColor = 'light';
        });
        return handlerData;
    };
    /**
     * Returns if contents are loaded to show open button.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @return {Promise<boolean>} Resolved when done.
     */
    AddonModResourceModuleHandler.prototype.hideOpenButton = function (module, courseId) {
        var _this = this;
        var promise;
        if (module.contentsinfo) {
            // No need to load contents.
            promise = Promise.resolve();
        }
        else {
            promise = this.courseProvider.loadModuleContents(module, courseId, undefined, false, false, undefined, this.modName);
        }
        return promise.then(function () {
            return _this.prefetchDelegate.getModuleStatus(module, courseId).then(function (status) {
                return status !== __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].DOWNLOADED || _this.resourceHelper.isDisplayedInIframe(module);
            });
        });
    };
    /**
     * Returns the activity icon and data.
     *
     * @param {any} module        The module object.
     * @param {number} courseId   The course ID.
     * @return {Promise<any>}     Resource data.
     */
    AddonModResourceModuleHandler.prototype.getResourceData = function (module, courseId, handlerData) {
        var _this = this;
        var promises = [];
        var infoFiles = [], options = {};
        // Check if the button needs to be shown or not.
        promises.push(this.hideOpenButton(module, courseId).then(function (hideOpenButton) {
            handlerData.buttons[0].hidden = hideOpenButton;
        }));
        if (typeof module.customdata != 'undefined') {
            options = this.textUtils.unserialize(this.textUtils.parseJSON(module.customdata));
        }
        else if (this.resourceProvider.isGetResourceWSAvailable()) {
            // Get the resource data.
            promises.push(this.resourceProvider.getResourceData(courseId, module.id).then(function (info) {
                infoFiles = info.contentfiles;
                options = _this.textUtils.unserialize(info.displayoptions);
            }));
        }
        return Promise.all(promises).then(function () {
            var files = module.contents && module.contents.length ? module.contents : infoFiles, resourceData = {
                icon: '',
                extra: ''
            }, extra = [];
            if (module.contentsinfo) {
                // No need to use the list of files.
                var mimetype = module.contentsinfo.mimetypes[0];
                if (mimetype) {
                    resourceData.icon = _this.mimetypeUtils.getMimetypeIcon(mimetype);
                }
                resourceData.extra = _this.textUtils.cleanTags(module.afterlink);
            }
            else if (files && files.length) {
                var file = files[0];
                resourceData.icon = _this.mimetypeUtils.getFileIcon(file.filename);
                if (options.showsize) {
                    var size = void 0;
                    if (options.filedetails) {
                        size = options.filedetails.size;
                    }
                    else {
                        size = files.reduce(function (result, file) {
                            return result + file.filesize;
                        }, 0);
                    }
                    extra.push(_this.textUtils.bytesToSize(size, 1));
                }
                if (options.showtype) {
                    // We should take it from options.filedetails.size if avalaible but it's already translated.
                    extra.push(_this.mimetypeUtils.getMimetypeDescription(file));
                }
                if (options.showdate) {
                    if (options.filedetails && options.filedetails.modifieddate) {
                        extra.push(_this.translate.instant('addon.mod_resource.modifieddate', { $a: _this.timeUtils.userDate(options.filedetails.modifieddate * 1000, 'core.strftimedatetimeshort') }));
                    }
                    else if (options.filedetails && options.filedetails.uploadeddate) {
                        extra.push(_this.translate.instant('addon.mod_resource.uploadeddate', { $a: _this.timeUtils.userDate(options.filedetails.uploadeddate * 1000, 'core.strftimedatetimeshort') }));
                    }
                    else if (file.timemodified > file.timecreated + __WEBPACK_IMPORTED_MODULE_10__core_constants__["a" /* CoreConstants */].SECONDS_MINUTE * 5) {
                        /* Modified date may be up to several minutes later than uploaded date just because
                           teacher did not submit the form promptly. Give teacher up to 5 minutes to do it. */
                        extra.push(_this.translate.instant('addon.mod_resource.modifieddate', { $a: _this.timeUtils.userDate(file.timemodified * 1000, 'core.strftimedatetimeshort') }));
                    }
                    else {
                        extra.push(_this.translate.instant('addon.mod_resource.uploadeddate', { $a: _this.timeUtils.userDate(file.timecreated * 1000, 'core.strftimedatetimeshort') }));
                    }
                }
                if (resourceData.icon == '') {
                    resourceData.icon = _this.courseProvider.getModuleIconSrc(_this.modName, module.modicon);
                }
                resourceData.extra += extra.join(' ');
            }
            else {
                // No files, just set the icon.
                resourceData.icon = _this.courseProvider.getModuleIconSrc(_this.modName, module.modicon);
            }
            return resourceData;
        });
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModResourceModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_4__components_index_index__["a" /* AddonModResourceIndexComponent */];
    };
    AddonModResourceModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__resource__["a" /* AddonModResourceProvider */], __WEBPACK_IMPORTED_MODULE_5__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_mimetype__["a" /* CoreMimetypeUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* AddonModResourceHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_9__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_8__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonModResourceModuleHandler);
    return AddonModResourceModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1659 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourceLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to resource.
 */
var AddonModResourceLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModResourceLinkHandler, _super);
    function AddonModResourceLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModResource', 'resource') || this;
        _this.name = 'AddonModResourceLinkHandler';
        return _this;
    }
    AddonModResourceLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModResourceLinkHandler);
    return AddonModResourceLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1660 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourceListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__resource__ = __webpack_require__(181);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to resource list page.
 */
var AddonModResourceListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModResourceListLinkHandler, _super);
    function AddonModResourceListLinkHandler(linkHelper, translate, resourceProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModResource', 'resource') || this;
        _this.resourceProvider = resourceProvider;
        _this.name = 'AddonModResourceListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModResourceListLinkHandler.prototype.isEnabled = function () {
        return this.resourceProvider.isPluginEnabled();
    };
    AddonModResourceListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__resource__["a" /* AddonModResourceProvider */]])
    ], AddonModResourceListLinkHandler);
    return AddonModResourceListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1661 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModResourcePluginFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

/**
 * Handler to treat links to resource.
 */
var AddonModResourcePluginFileHandler = /** @class */ (function () {
    function AddonModResourcePluginFileHandler() {
        this.name = 'AddonModResourcePluginFileHandler';
        this.component = 'mod_resource';
    }
    /**
     * Return the RegExp to match the revision on pluginfile URLs.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {RegExp} RegExp to match the revision on pluginfile URLs.
     */
    AddonModResourcePluginFileHandler.prototype.getComponentRevisionRegExp = function (args) {
        // Check filearea.
        if (args[2] == 'content') {
            // Component + Filearea + Revision
            return new RegExp('/mod_resource/content/([0-9]+)/');
        }
    };
    /**
     * Should return the string to remove the revision on pluginfile url.
     *
     * @param {string[]} args Arguments of the pluginfile URL defining component and filearea at least.
     * @return {string} String to remove the revision on pluginfile url.
     */
    AddonModResourcePluginFileHandler.prototype.getComponentRevisionReplace = function (args) {
        // Component + Filearea + Revision
        return '/mod_resource/content/0/';
    };
    AddonModResourcePluginFileHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AddonModResourcePluginFileHandler);
    return AddonModResourcePluginFileHandler;
}());

//# sourceMappingURL=pluginfile-handler.js.map

/***/ }),
/* 1662 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(443);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support SCORM modules.
 */
var AddonModScormModuleHandler = /** @class */ (function () {
    function AddonModScormModuleHandler(courseProvider) {
        this.courseProvider = courseProvider;
        this.name = 'AddonModScorm';
        this.modName = 'scorm';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModScormModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModScormModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_scorm-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModScormIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModScormModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModScormIndexComponent */];
    };
    AddonModScormModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModScormModuleHandler);
    return AddonModScormModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1663 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__scorm_sync__ = __webpack_require__(227);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModScormSyncCronHandler = /** @class */ (function () {
    function AddonModScormSyncCronHandler(scormSync) {
        this.scormSync = scormSync;
        this.name = 'AddonModScormSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModScormSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.scormSync.syncAllScorms(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModScormSyncCronHandler.prototype.getInterval = function () {
        return this.scormSync.syncInterval;
    };
    AddonModScormSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__scorm_sync__["a" /* AddonModScormSyncProvider */]])
    ], AddonModScormSyncCronHandler);
    return AddonModScormSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1664 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to SCORM index.
 */
var AddonModScormIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModScormIndexLinkHandler, _super);
    function AddonModScormIndexLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModScorm', 'scorm') || this;
        _this.name = 'AddonModScormIndexLinkHandler';
        return _this;
    }
    AddonModScormIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModScormIndexLinkHandler);
    return AddonModScormIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1665 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormGradeLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_classes_module_grade_handler__ = __webpack_require__(266);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to SCORM grade.
 */
var AddonModScormGradeLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModScormGradeLinkHandler, _super);
    function AddonModScormGradeLinkHandler(courseHelper, domUtils, sitesProvider) {
        var _this = _super.call(this, courseHelper, domUtils, sitesProvider, 'AddonModScorm', 'scorm') || this;
        _this.name = 'AddonModScormGradeLinkHandler';
        _this.canReview = false;
        return _this;
    }
    AddonModScormGradeLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModScormGradeLinkHandler);
    return AddonModScormGradeLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_classes_module_grade_handler__["a" /* CoreContentLinksModuleGradeHandler */]));

//# sourceMappingURL=grade-link-handler.js.map

/***/ }),
/* 1666 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModScormListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to SCORM list page.
 */
var AddonModScormListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModScormListLinkHandler, _super);
    function AddonModScormListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModScorm', 'scorm') || this;
        _this.name = 'AddonModScormListLinkHandler';
        return _this;
    }
    AddonModScormListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModScormListLinkHandler);
    return AddonModScormListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1667 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(444);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support survey modules.
 */
var AddonModSurveyModuleHandler = /** @class */ (function () {
    function AddonModSurveyModuleHandler(courseProvider) {
        this.courseProvider = courseProvider;
        this.name = 'AddonModSurvey';
        this.modName = 'survey';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModSurveyModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModSurveyModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_survey-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModSurveyIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModSurveyModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModSurveyIndexComponent */];
    };
    AddonModSurveyModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModSurveyModuleHandler);
    return AddonModSurveyModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1668 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to survey.
 */
var AddonModSurveyLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModSurveyLinkHandler, _super);
    function AddonModSurveyLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModSurvey', 'survey') || this;
        _this.name = 'AddonModSurveyLinkHandler';
        return _this;
    }
    AddonModSurveyLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModSurveyLinkHandler);
    return AddonModSurveyLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1669 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveyListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to survey list page.
 */
var AddonModSurveyListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModSurveyListLinkHandler, _super);
    function AddonModSurveyListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModSurvey', 'survey') || this;
        _this.name = 'AddonModSurveyListLinkHandler';
        return _this;
    }
    AddonModSurveyListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModSurveyListLinkHandler);
    return AddonModSurveyListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1670 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModSurveySyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(272);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModSurveySyncCronHandler = /** @class */ (function () {
    function AddonModSurveySyncCronHandler(surveySync) {
        this.surveySync = surveySync;
        this.name = 'AddonModSurveySyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModSurveySyncCronHandler.prototype.execute = function (siteId, force) {
        return this.surveySync.syncAllSurveys(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModSurveySyncCronHandler.prototype.getInterval = function () {
        return this.surveySync.syncInterval;
    };
    AddonModSurveySyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonModSurveySyncProvider */]])
    ], AddonModSurveySyncCronHandler);
    return AddonModSurveySyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1671 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModUrlModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_index_index__ = __webpack_require__(445);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__url__ = __webpack_require__(378);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__helper__ = __webpack_require__(379);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Handler to support url modules.
 */
var AddonModUrlModuleHandler = /** @class */ (function () {
    function AddonModUrlModuleHandler(courseProvider, urlProvider, urlHelper, domUtils, contentLinksHelper) {
        this.courseProvider = courseProvider;
        this.urlProvider = urlProvider;
        this.urlHelper = urlHelper;
        this.domUtils = domUtils;
        this.contentLinksHelper = contentLinksHelper;
        this.name = 'AddonModUrl';
        this.modName = 'url';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE] = __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModUrlModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModUrlModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        var _this = this;
        // tslint:disable: no-this-assignment
        var handler = this;
        var handlerData = {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_url-handler',
            showDownloadButton: false,
            action: function (event, navCtrl, module, courseId, options, params) {
                var modal = handler.domUtils.showModalLoading();
                // First of all, make sure module contents are loaded.
                handler.courseProvider.loadModuleContents(module, courseId, undefined, false, false, undefined, handler.modName)
                    .then(function () {
                    // Check if the URL can be handled by the app. If so, always open it directly.
                    return handler.contentLinksHelper.canHandleLink(module.contents[0].fileurl, courseId, undefined, true);
                }).then(function (canHandle) {
                    if (canHandle) {
                        // URL handled by the app, open it directly.
                        return true;
                    }
                    // Not handled by the app, check the display type.
                    if (handler.urlProvider.isGetUrlWSAvailable()) {
                        return handler.urlProvider.getUrl(courseId, module.id).catch(function () {
                            // Ignore errors.
                        }).then(function (url) {
                            if (url != null) {
                                var displayType = handler.urlProvider.getFinalDisplayType(url);
                                return displayType == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_OPEN ||
                                    displayType == __WEBPACK_IMPORTED_MODULE_7__core_constants__["a" /* CoreConstants */].RESOURCELIB_DISPLAY_POPUP;
                            }
                            else {
                            }
                        });
                    }
                    else {
                        return false;
                    }
                }).then(function (shouldOpen) {
                    if (shouldOpen) {
                        handler.openUrl(module, courseId);
                    }
                    else {
                        var pageParams = { module: module, courseId: courseId };
                        if (params) {
                            Object.assign(pageParams, params);
                        }
                        navCtrl.push('AddonModUrlIndexPage', pageParams, options);
                    }
                }).finally(function () {
                    modal.dismiss();
                });
            },
            buttons: [{
                    hidden: true,
                    icon: 'link',
                    label: 'core.openinbrowser',
                    action: function (event, navCtrl, module, courseId) {
                        handler.openUrl(module, courseId);
                    }
                }]
        };
        this.hideLinkButton(module, courseId).then(function (hideButton) {
            handlerData.buttons[0].hidden = hideButton;
            if (module.contents && module.contents[0]) {
                // Calculate the icon to use.
                handlerData.icon = _this.urlProvider.guessIcon(module.contents[0].fileurl) ||
                    _this.courseProvider.getModuleIconSrc(_this.modName, module.modicon);
            }
        });
        return handlerData;
    };
    /**
     * Returns if contents are loaded to show link button.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @return {Promise<boolean>} Resolved when done.
     */
    AddonModUrlModuleHandler.prototype.hideLinkButton = function (module, courseId) {
        return this.courseProvider.loadModuleContents(module, courseId, undefined, false, false, undefined, this.modName)
            .then(function () {
            return !(module.contents && module.contents[0] && module.contents[0].fileurl);
        }).catch(function () {
            // Module contents could not be loaded, most probably device is offline.
            return true;
        });
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModUrlModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_2__components_index_index__["a" /* AddonModUrlIndexComponent */];
    };
    /**
     * Open the URL.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     */
    AddonModUrlModuleHandler.prototype.openUrl = function (module, courseId) {
        var _this = this;
        this.urlProvider.logView(module.instance, module.name).then(function () {
            _this.courseProvider.checkModuleCompletion(courseId, module.completiondata);
        }).catch(function () {
            // Ignore errors.
        });
        this.urlHelper.open(module.contents[0].fileurl);
    };
    AddonModUrlModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__url__["a" /* AddonModUrlProvider */],
            __WEBPACK_IMPORTED_MODULE_6__helper__["a" /* AddonModUrlHelperProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], AddonModUrlModuleHandler);
    return AddonModUrlModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1672 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModUrlLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to url.
 */
var AddonModUrlLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModUrlLinkHandler, _super);
    function AddonModUrlLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModUrl', 'url') || this;
        _this.name = 'AddonModUrlLinkHandler';
        _this.useModNameToGetModule = true;
        return _this;
    }
    AddonModUrlLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModUrlLinkHandler);
    return AddonModUrlLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1673 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModUrlListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to URL list page.
 */
var AddonModUrlListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModUrlListLinkHandler, _super);
    function AddonModUrlListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModUrl', 'url') || this;
        _this.name = 'AddonModUrlListLinkHandler';
        return _this;
    }
    AddonModUrlListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModUrlListLinkHandler);
    return AddonModUrlListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1674 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(446);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support wiki modules.
 */
var AddonModWikiModuleHandler = /** @class */ (function () {
    function AddonModWikiModuleHandler(courseProvider) {
        this.courseProvider = courseProvider;
        this.name = 'AddonModWiki';
        this.modName = 'wiki';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_RATE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_3__core_constants__["a" /* CoreConstants */].FEATURE_COMMENT] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModWikiModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModWikiModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_wiki-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModWikiIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModWikiModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModWikiIndexComponent */];
    };
    AddonModWikiModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModWikiModuleHandler);
    return AddonModWikiModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1675 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__core_grades_providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__wiki__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__wiki_sync__ = __webpack_require__(229);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
















/**
 * Handler to prefetch wikis.
 */
var AddonModWikiPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModWikiPrefetchHandler, _super);
    function AddonModWikiPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, wikiProvider, userProvider, textUtils, courseHelper, groupsProvider, gradesHelper, syncProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.wikiProvider = wikiProvider;
        _this.userProvider = userProvider;
        _this.textUtils = textUtils;
        _this.courseHelper = courseHelper;
        _this.groupsProvider = groupsProvider;
        _this.gradesHelper = gradesHelper;
        _this.syncProvider = syncProvider;
        _this.name = 'AddonModWiki';
        _this.modName = 'wiki';
        _this.component = __WEBPACK_IMPORTED_MODULE_14__wiki__["a" /* AddonModWikiProvider */].COMPONENT;
        _this.updatesNames = /^.*files$|^pages$/;
        return _this;
    }
    /**
     * Returns a list of pages that can be downloaded.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId The course ID.
     * @param {boolean} [offline] Whether it should return cached data. Has priority over ignoreCache.
     * @param {boolean} [ignoreCache] Whether it should ignore cached data (it will always fail in offline or server down).
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} List of pages.
     */
    AddonModWikiPrefetchHandler.prototype.getAllPages = function (module, courseId, offline, ignoreCache, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.wikiProvider.getWiki(courseId, module.id, offline, siteId).then(function (wiki) {
            return _this.wikiProvider.getWikiPageList(wiki, offline, ignoreCache, siteId);
        }).catch(function () {
            // Wiki not found, return empty list.
            return [];
        });
    };
    /**
     * Get the download size of a module.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<{size: number, total: boolean}>} Promise resolved with the size and a boolean indicating if it was able
     *                                                   to calculate the total size.
     */
    AddonModWikiPrefetchHandler.prototype.getDownloadSize = function (module, courseId, single) {
        var _this = this;
        var promises = [], siteId = this.sitesProvider.getCurrentSiteId();
        promises.push(this.getFiles(module, courseId, single, siteId).then(function (files) {
            return _this.utils.sumFileSizes(files);
        }));
        promises.push(this.getAllPages(module, courseId, false, true, siteId).then(function (pages) {
            var size = 0;
            pages.forEach(function (page) {
                if (page.contentsize) {
                    size = size + page.contentsize;
                }
            });
            return { size: size, total: true };
        }));
        return Promise.all(promises).then(function (sizes) {
            // Sum values in the array.
            return sizes.reduce(function (a, b) {
                return { size: a.size + b.size, total: a.total && b.total };
            }, { size: 0, total: true });
        });
    };
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModWikiPrefetchHandler.prototype.getFiles = function (module, courseId, single, siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.wikiProvider.getWiki(courseId, module.id, false, siteId).then(function (wiki) {
            var introFiles = _this.getIntroFilesFromInstance(module, wiki);
            return _this.wikiProvider.getWikiFileList(wiki, false, false, siteId).then(function (files) {
                return introFiles.concat(files);
            });
        }).catch(function () {
            // Wiki not found, return empty list.
            return [];
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModWikiPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.wikiProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWikiPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        var _this = this;
        // Get the download time of the package before starting the download (otherwise we'd always get current time).
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.filepoolProvider.getPackageData(siteId, this.component, module.id).catch(function () {
            // No package data yet.
        }).then(function (data) {
            var downloadTime = (data && data.downloadTime) || 0;
            return _this.prefetchPackage(module, courseId, single, _this.prefetchWiki.bind(_this), siteId, [downloadTime]);
        });
    };
    /**
     * Prefetch a wiki.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} single True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} siteId Site ID.
     * @param {number} downloadTime The previous download time, 0 if no previous download.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWikiPrefetchHandler.prototype.prefetchWiki = function (module, courseId, single, siteId, downloadTime) {
        var _this = this;
        var userId = this.sitesProvider.getCurrentSiteUserId();
        // Get the list of pages.
        return this.getAllPages(module, courseId, false, true, siteId).then(function (pages) {
            var promises = [];
            pages.forEach(function (page) {
                // Fetch page contents if it needs to be fetched.
                if (page.timemodified > downloadTime) {
                    promises.push(_this.wikiProvider.getPageContents(page.id, false, true, siteId));
                }
            });
            // Fetch group data.
            promises.push(_this.groupsProvider.getActivityGroupMode(module.id, siteId).then(function (groupMode) {
                if (groupMode === __WEBPACK_IMPORTED_MODULE_8__providers_groups__["a" /* CoreGroupsProvider */].SEPARATEGROUPS || groupMode === __WEBPACK_IMPORTED_MODULE_8__providers_groups__["a" /* CoreGroupsProvider */].VISIBLEGROUPS) {
                    // Get the groups available for the user.
                    return _this.groupsProvider.getActivityAllowedGroups(module.id, userId, siteId);
                }
            }));
            // Fetch info to provide wiki links.
            promises.push(_this.wikiProvider.getWiki(courseId, module.id, false, siteId).then(function (wiki) {
                return _this.courseHelper.getModuleCourseIdByInstance(wiki.id, 'wiki', siteId);
            }));
            // Get related page files and fetch them.
            promises.push(_this.getFiles(module, courseId, single, siteId).then(function (files) {
                return _this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id);
            }));
            return Promise.all(promises);
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWikiPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        return this.syncProvider.syncWiki(module.instance, module.course, module.id, siteId);
    };
    AddonModWikiPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_14__wiki__["a" /* AddonModWikiProvider */], __WEBPACK_IMPORTED_MODULE_13__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_11__core_course_providers_helper__["a" /* CoreCourseHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_groups__["a" /* CoreGroupsProvider */], __WEBPACK_IMPORTED_MODULE_12__core_grades_providers_helper__["a" /* CoreGradesHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_15__wiki_sync__["a" /* AddonModWikiSyncProvider */]])
    ], AddonModWikiPrefetchHandler);
    return AddonModWikiPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_10__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 1676 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__wiki_sync__ = __webpack_require__(229);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModWikiSyncCronHandler = /** @class */ (function () {
    function AddonModWikiSyncCronHandler(wikiSync) {
        this.wikiSync = wikiSync;
        this.name = 'AddonModWikiSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModWikiSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.wikiSync.syncAllWikis(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModWikiSyncCronHandler.prototype.getInterval = function () {
        return this.wikiSync.syncInterval;
    };
    AddonModWikiSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__wiki_sync__["a" /* AddonModWikiSyncProvider */]])
    ], AddonModWikiSyncCronHandler);
    return AddonModWikiSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1677 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to wiki index.
 */
var AddonModWikiIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModWikiIndexLinkHandler, _super);
    function AddonModWikiIndexLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModWiki', 'wiki') || this;
        _this.name = 'AddonModWikiIndexLinkHandler';
        return _this;
    }
    AddonModWikiIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModWikiIndexLinkHandler);
    return AddonModWikiIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1678 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiPageOrMapLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__wiki__ = __webpack_require__(173);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler to treat links to a wiki page or the wiki map.
 */
var AddonModWikiPageOrMapLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModWikiPageOrMapLinkHandler, _super);
    function AddonModWikiPageOrMapLinkHandler(domUtils, wikiProvider, courseHelper, linkHelper) {
        var _this = _super.call(this) || this;
        _this.domUtils = domUtils;
        _this.wikiProvider = wikiProvider;
        _this.courseHelper = courseHelper;
        _this.linkHelper = linkHelper;
        _this.name = 'AddonModWikiPageOrMapLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModWiki';
        _this.pattern = /\/mod\/wiki\/(view|map)\.php.*([\&\?]pageid=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModWikiPageOrMapLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), pageId = parseInt(params.pageid, 10), action = url.indexOf('mod/wiki/map.php') != -1 ? 'map' : 'page';
                    // Get the page data to obtain wikiId, subwikiId, etc.
                    _this.wikiProvider.getPageContents(pageId, false, false, siteId).then(function (page) {
                        var promise;
                        if (courseId) {
                            promise = Promise.resolve(courseId);
                        }
                        else {
                            promise = _this.courseHelper.getModuleCourseIdByInstance(page.wikiid, 'wiki', siteId);
                        }
                        return promise.then(function (courseId) {
                            var pageParams = {
                                courseId: courseId,
                                pageId: page.id,
                                pageTitle: page.title,
                                wikiId: page.wikiid,
                                subwikiId: page.subwikiid,
                                action: action
                            };
                            _this.linkHelper.goInSite(navCtrl, 'AddonModWikiIndexPage', pageParams, siteId);
                        });
                    }).catch(function (error) {
                        _this.domUtils.showErrorModalDefault(error, 'addon.mod_wiki.errorloadingpage', true);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModWikiPageOrMapLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        var isMap = url.indexOf('mod/wiki/map.php') != -1;
        if (params.id && !isMap) {
            // ID param is more prioritary than pageid in index page, it's a index URL.
            return false;
        }
        else if (isMap && typeof params.option != 'undefined' && params.option != 5) {
            // Map link but the option isn't "Page list", not supported.
            return false;
        }
        return true;
    };
    AddonModWikiPageOrMapLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__wiki__["a" /* AddonModWikiProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */]])
    ], AddonModWikiPageOrMapLinkHandler);
    return AddonModWikiPageOrMapLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=page-or-map-link-handler.js.map

/***/ }),
/* 1679 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiCreateLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__wiki__ = __webpack_require__(173);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Handler to treat links to create a wiki page.
 */
var AddonModWikiCreateLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModWikiCreateLinkHandler, _super);
    function AddonModWikiCreateLinkHandler(domUtils, wikiProvider, courseHelper, linkHelper, courseProvider) {
        var _this = _super.call(this) || this;
        _this.domUtils = domUtils;
        _this.wikiProvider = wikiProvider;
        _this.courseHelper = courseHelper;
        _this.linkHelper = linkHelper;
        _this.courseProvider = courseProvider;
        _this.name = 'AddonModWikiCreateLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModWiki';
        _this.pattern = /\/mod\/wiki\/create\.php.*([\&\?]swid=\d+)/;
        return _this;
    }
    /**
     * Check if the current view is a wiki page of the same wiki.
     *
     * @param {ViewController} activeView Active view.
     * @param {number} subwikiId Subwiki ID to check.
     * @param {string} siteId Site ID.
     * @return {Promise<boolean>} Promise resolved with boolean: whether current view belongs to the same wiki.
     */
    AddonModWikiCreateLinkHandler.prototype.currentStateIsSameWiki = function (activeView, subwikiId, siteId) {
        var _this = this;
        if (activeView && activeView.component.name == 'AddonModWikiIndexPage') {
            if (activeView.data.subwikiId == subwikiId) {
                // Same subwiki, so it's same wiki.
                return Promise.resolve(true);
            }
            else if (activeView.data.pageId) {
                // Get the page contents to check the subwiki.
                return this.wikiProvider.getPageContents(activeView.data.pageId, false, false, siteId).then(function (page) {
                    return page.subwikiid == subwikiId;
                }).catch(function () {
                    // Not found, return false.
                    return false;
                });
            }
            else if (activeView.data.wikiId) {
                // Check if the subwiki belongs to this wiki.
                return this.wikiProvider.wikiHasSubwiki(activeView.data.wikiId, subwikiId, false, false, siteId);
            }
            else if (activeView.data.courseId && activeView.data.module) {
                var moduleId = activeView.data.module && activeView.data.module.id;
                if (moduleId) {
                    // Get the wiki.
                    return this.wikiProvider.getWiki(activeView.data.courseId, moduleId, false, siteId).then(function (wiki) {
                        // Check if the subwiki belongs to this wiki.
                        return _this.wikiProvider.wikiHasSubwiki(wiki.id, subwikiId, false, false, siteId);
                    }).catch(function () {
                        // Not found, return false.
                        return false;
                    });
                }
            }
        }
        return Promise.resolve(false);
    };
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModWikiCreateLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), subwikiId = parseInt(params.swid, 10), activeView = navCtrl && navCtrl.getActive();
                    // Check if the link is inside the same wiki.
                    _this.currentStateIsSameWiki(activeView, subwikiId, siteId).then(function (isSameWiki) {
                        if (isSameWiki) {
                            // User is seeing the wiki, we can get the module from the wiki params.
                            if (activeView && activeView.data.module && activeView.data.module.id) {
                                // We already have it in the params.
                                return activeView.data.module;
                            }
                            else if (activeView && activeView.data.wikiId) {
                                return _this.courseProvider.getModuleBasicInfoByInstance(activeView.data.wikiId, 'wiki', siteId)
                                    .catch(function () {
                                    // Not found.
                                });
                            }
                        }
                    }).then(function (module) {
                        // Return the params.
                        var pageParams = {
                            module: module,
                            courseId: courseId || (module && module.course) || (activeView && activeView.data.courseId),
                            pageTitle: params.title,
                            subwikiId: subwikiId
                        };
                        _this.linkHelper.goInSite(navCtrl, 'AddonModWikiEditPage', pageParams, siteId);
                    }).finally(function () {
                        modal.dismiss();
                    });
                }
            }];
    };
    AddonModWikiCreateLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_6__wiki__["a" /* AddonModWikiProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */]])
    ], AddonModWikiCreateLinkHandler);
    return AddonModWikiCreateLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=create-link-handler.js.map

/***/ }),
/* 1680 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiEditLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to edit a wiki page.
 */
var AddonModWikiEditLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModWikiEditLinkHandler, _super);
    function AddonModWikiEditLinkHandler(linkHelper, textUtils) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.textUtils = textUtils;
        _this.name = 'AddonModWikiEditLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModWiki';
        _this.pattern = /\/mod\/wiki\/edit\.php.*([\&\?]pageid=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModWikiEditLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        courseId = courseId || params.courseid || params.cid;
        return [{
                action: function (siteId, navCtrl) {
                    var section = '';
                    if (typeof params.section != 'undefined') {
                        section = _this.textUtils.decodeURIComponent(params.section.replace(/\+/g, ' '));
                    }
                    var pageParams = {
                        courseId: courseId,
                        section: section,
                        pageId: parseInt(params.pageid, 10)
                    };
                    _this.linkHelper.goInSite(navCtrl, 'AddonModWikiEditPage', pageParams, siteId);
                }
            }];
    };
    AddonModWikiEditLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonModWikiEditLinkHandler);
    return AddonModWikiEditLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=edit-link-handler.js.map

/***/ }),
/* 1681 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWikiListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to wiki list page.
 */
var AddonModWikiListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModWikiListLinkHandler, _super);
    function AddonModWikiListLinkHandler(linkHelper, translate) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModWiki', 'wiki') || this;
        _this.name = 'AddonModWikiListLinkHandler';
        return _this;
    }
    AddonModWikiListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModWikiListLinkHandler);
    return AddonModWikiListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1682 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__accumulative_accumulative_module__ = __webpack_require__(1683);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__comments_comments_module__ = __webpack_require__(1685);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__numerrors_numerrors_module__ = __webpack_require__(1687);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__rubric_rubric_module__ = __webpack_require__(1689);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};





var AddonModWorkshopAssessmentStrategyModule = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyModule() {
    }
    AddonModWorkshopAssessmentStrategyModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__accumulative_accumulative_module__["a" /* AddonModWorkshopAssessmentStrategyAccumulativeModule */],
                __WEBPACK_IMPORTED_MODULE_2__comments_comments_module__["a" /* AddonModWorkshopAssessmentStrategyCommentsModule */],
                __WEBPACK_IMPORTED_MODULE_3__numerrors_numerrors_module__["a" /* AddonModWorkshopAssessmentStrategyNumErrorsModule */],
                __WEBPACK_IMPORTED_MODULE_4__rubric_rubric_module__["a" /* AddonModWorkshopAssessmentStrategyRubricModule */],
            ]
        })
    ], AddonModWorkshopAssessmentStrategyModule);
    return AddonModWorkshopAssessmentStrategyModule;
}());

//# sourceMappingURL=assessment.module.js.map

/***/ }),
/* 1683 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyAccumulativeModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_accumulative__ = __webpack_require__(873);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_handler__ = __webpack_require__(1684);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__ = __webpack_require__(129);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModWorkshopAssessmentStrategyAccumulativeModule = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyAccumulativeModule(strategyDelegate, strategyHandler) {
        strategyDelegate.registerHandler(strategyHandler);
    }
    AddonModWorkshopAssessmentStrategyAccumulativeModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_accumulative__["a" /* AddonModWorkshopAssessmentStrategyAccumulativeComponent */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyAccumulativeHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_accumulative__["a" /* AddonModWorkshopAssessmentStrategyAccumulativeComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_accumulative__["a" /* AddonModWorkshopAssessmentStrategyAccumulativeComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */],
            __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyAccumulativeHandler */]])
    ], AddonModWorkshopAssessmentStrategyAccumulativeModule);
    return AddonModWorkshopAssessmentStrategyAccumulativeModule;
}());

//# sourceMappingURL=accumulative.module.js.map

/***/ }),
/* 1684 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyAccumulativeHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_grades_providers_helper__ = __webpack_require__(110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_accumulative__ = __webpack_require__(873);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler for accumulative assessment strategy plugin.
 */
var AddonModWorkshopAssessmentStrategyAccumulativeHandler = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyAccumulativeHandler(translate, gradesHelper) {
        this.translate = translate;
        this.gradesHelper = gradesHelper;
        this.name = 'AddonModWorkshopAssessmentStrategyAccumulative';
        this.strategyName = 'accumulative';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModWorkshopAssessmentStrategyAccumulativeHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Return the Component to render the plugin.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModWorkshopAssessmentStrategyAccumulativeHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_3__component_accumulative__["a" /* AddonModWorkshopAssessmentStrategyAccumulativeComponent */];
    };
    /**
     * Prepare original values to be shown and compared.
     *
     * @param  {any}    form       Original data of the form.
     * @param  {number} workshopId WorkShop Id
     * @return {Promise<any[]>}    Promise resolved with original values sorted.
     */
    AddonModWorkshopAssessmentStrategyAccumulativeHandler.prototype.getOriginalValues = function (form, workshopId) {
        var _this = this;
        var defaultGrade = this.translate.instant('core.choosedots'), originalValues = [], promises = [];
        form.fields.forEach(function (field, n) {
            field.dimtitle = _this.translate.instant('addon.mod_workshop_assessment_accumulative.dimensionnumber', { $a: field.number });
            if (!form.current[n]) {
                form.current[n] = {};
            }
            originalValues[n] = {
                peercomment: form.current[n].peercomment || '',
                number: field.number
            };
            form.current[n].grade = form.current[n].grade ? parseInt(form.current[n].grade, 10) : -1;
            var gradingType = parseInt(field.grade, 10);
            var dimension = form.dimensionsinfo.find(function (dimension) { return dimension.id == field.dimensionid; });
            var scale = dimension && gradingType < 0 ? dimension.scale : null;
            promises.push(_this.gradesHelper.makeGradesMenu(gradingType, undefined, defaultGrade, -1, scale).then(function (grades) {
                field.grades = grades;
                originalValues[n].grade = form.current[n].grade;
            }));
        });
        return Promise.all(promises).then(function () {
            return originalValues;
        });
    };
    /**
     * Check if the assessment data has changed for a certain submission and workshop for a this strategy plugin.
     *
     * @param  {any[]} originalValues Original values of the form.
     * @param  {any[]} currentValues  Current values of the form.
     * @return {boolean}              True if data has changed, false otherwise.
     */
    AddonModWorkshopAssessmentStrategyAccumulativeHandler.prototype.hasDataChanged = function (originalValues, currentValues) {
        for (var x in originalValues) {
            if (originalValues[x].grade != currentValues[x].grade) {
                return true;
            }
            if (originalValues[x].peercomment != currentValues[x].peercomment) {
                return true;
            }
        }
        return false;
    };
    /**
     * Prepare assessment data to be sent to the server depending on the strategy selected.
     *
     * @param  {any{}} currentValues Current values of the form.
     * @param  {any}   form          Assessment form data.
     * @return {Promise<any>}        Promise resolved with the data to be sent. Or rejected with the input errors object.
     */
    AddonModWorkshopAssessmentStrategyAccumulativeHandler.prototype.prepareAssessmentData = function (currentValues, form) {
        var _this = this;
        var data = {};
        var errors = {};
        var hasErrors = false;
        form.fields.forEach(function (field, idx) {
            if (idx < form.dimenssionscount) {
                var grade = parseInt(currentValues[idx].grade, 10);
                if (!isNaN(grade) && grade >= 0) {
                    data['grade__idx_' + idx] = grade;
                }
                else {
                    errors['grade_' + idx] = _this.translate.instant('addon.mod_workshop_assessment_accumulative.mustchoosegrade');
                    hasErrors = true;
                }
                if (currentValues[idx].peercomment) {
                    data['peercomment__idx_' + idx] = currentValues[idx].peercomment;
                }
                data['gradeid__idx_' + idx] = parseInt(form.current[idx].gradeid, 10) || 0;
                data['dimensionid__idx_' + idx] = parseInt(field.dimensionid, 10);
                data['weight__idx_' + idx] = parseInt(field.weight, 10) || 0;
            }
        });
        if (hasErrors) {
            return Promise.reject(errors);
        }
        return Promise.resolve(data);
    };
    AddonModWorkshopAssessmentStrategyAccumulativeHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__core_grades_providers_helper__["a" /* CoreGradesHelperProvider */]])
    ], AddonModWorkshopAssessmentStrategyAccumulativeHandler);
    return AddonModWorkshopAssessmentStrategyAccumulativeHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1685 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyCommentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_comments__ = __webpack_require__(874);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_handler__ = __webpack_require__(1686);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__ = __webpack_require__(129);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModWorkshopAssessmentStrategyCommentsModule = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyCommentsModule(strategyDelegate, strategyHandler) {
        strategyDelegate.registerHandler(strategyHandler);
    }
    AddonModWorkshopAssessmentStrategyCommentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_comments__["a" /* AddonModWorkshopAssessmentStrategyCommentsComponent */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyCommentsHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_comments__["a" /* AddonModWorkshopAssessmentStrategyCommentsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_comments__["a" /* AddonModWorkshopAssessmentStrategyCommentsComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */],
            __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyCommentsHandler */]])
    ], AddonModWorkshopAssessmentStrategyCommentsModule);
    return AddonModWorkshopAssessmentStrategyCommentsModule;
}());

//# sourceMappingURL=comments.module.js.map

/***/ }),
/* 1686 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyCommentsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_comments__ = __webpack_require__(874);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler for comments assessment strategy plugin.
 */
var AddonModWorkshopAssessmentStrategyCommentsHandler = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyCommentsHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModWorkshopAssessmentStrategyComments';
        this.strategyName = 'comments';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModWorkshopAssessmentStrategyCommentsHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Return the Component to render the plugin.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModWorkshopAssessmentStrategyCommentsHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_2__component_comments__["a" /* AddonModWorkshopAssessmentStrategyCommentsComponent */];
    };
    /**
     * Prepare original values to be shown and compared.
     *
     * @param  {any}    form       Original data of the form.
     * @param  {number} workshopId Workshop Id
     * @return {Promise<any[]>}    Promise resolved with original values sorted.
     */
    AddonModWorkshopAssessmentStrategyCommentsHandler.prototype.getOriginalValues = function (form, workshopId) {
        var _this = this;
        var originalValues = [];
        form.fields.forEach(function (field, n) {
            field.dimtitle = _this.translate.instant('addon.mod_workshop_assessment_comments.dimensionnumber', { $a: field.number });
            if (!form.current[n]) {
                form.current[n] = {};
            }
            originalValues[n] = {
                peercomment: form.current[n].peercomment || '',
                number: field.number
            };
        });
        return Promise.resolve(originalValues);
    };
    /**
     * Check if the assessment data has changed for a certain submission and workshop for a this strategy plugin.
     *
     * @param  {any[]} originalValues Original values of the form.
     * @param  {any[]} currentValues  Current values of the form.
     * @return {boolean}              True if data has changed, false otherwise.
     */
    AddonModWorkshopAssessmentStrategyCommentsHandler.prototype.hasDataChanged = function (originalValues, currentValues) {
        for (var x in originalValues) {
            if (originalValues[x].peercomment != currentValues[x].peercomment) {
                return true;
            }
        }
        return false;
    };
    /**
     * Prepare assessment data to be sent to the server depending on the strategy selected.
     *
     * @param  {any{}} currentValues Current values of the form.
     * @param  {any}   form          Assessment form data.
     * @return {Promise<any>}        Promise resolved with the data to be sent. Or rejected with the input errors object.
     */
    AddonModWorkshopAssessmentStrategyCommentsHandler.prototype.prepareAssessmentData = function (currentValues, form) {
        var _this = this;
        var data = {};
        var errors = {};
        var hasErrors = false;
        form.fields.forEach(function (field, idx) {
            if (idx < form.dimenssionscount) {
                if (currentValues[idx].peercomment) {
                    data['peercomment__idx_' + idx] = currentValues[idx].peercomment;
                }
                else {
                    errors['peercomment_' + idx] = _this.translate.instant('core.err_required');
                    hasErrors = true;
                }
                data['gradeid__idx_' + idx] = parseInt(form.current[idx].gradeid, 10) || 0;
                data['dimensionid__idx_' + idx] = parseInt(field.dimensionid, 10);
            }
        });
        if (hasErrors) {
            return Promise.reject(errors);
        }
        return Promise.resolve(data);
    };
    AddonModWorkshopAssessmentStrategyCommentsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModWorkshopAssessmentStrategyCommentsHandler);
    return AddonModWorkshopAssessmentStrategyCommentsHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1687 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyNumErrorsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_numerrors__ = __webpack_require__(875);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_handler__ = __webpack_require__(1688);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__ = __webpack_require__(129);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModWorkshopAssessmentStrategyNumErrorsModule = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyNumErrorsModule(strategyDelegate, strategyHandler) {
        strategyDelegate.registerHandler(strategyHandler);
    }
    AddonModWorkshopAssessmentStrategyNumErrorsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_numerrors__["a" /* AddonModWorkshopAssessmentStrategyNumErrorsComponent */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyNumErrorsHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_numerrors__["a" /* AddonModWorkshopAssessmentStrategyNumErrorsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_numerrors__["a" /* AddonModWorkshopAssessmentStrategyNumErrorsComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */],
            __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyNumErrorsHandler */]])
    ], AddonModWorkshopAssessmentStrategyNumErrorsModule);
    return AddonModWorkshopAssessmentStrategyNumErrorsModule;
}());

//# sourceMappingURL=numerrors.module.js.map

/***/ }),
/* 1688 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyNumErrorsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_numerrors__ = __webpack_require__(875);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler for numerrors assessment strategy plugin.
 */
var AddonModWorkshopAssessmentStrategyNumErrorsHandler = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyNumErrorsHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModWorkshopAssessmentStrategyNumErrors';
        this.strategyName = 'numerrors';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModWorkshopAssessmentStrategyNumErrorsHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Return the Component to render the plugin.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModWorkshopAssessmentStrategyNumErrorsHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_2__component_numerrors__["a" /* AddonModWorkshopAssessmentStrategyNumErrorsComponent */];
    };
    /**
     * Prepare original values to be shown and compared.
     *
     * @param  {any}    form       Original data of the form.
     * @param  {number} workshopId Workshop Id
     * @return {Promise<any[]>}    Promise resolved with original values sorted.
     */
    AddonModWorkshopAssessmentStrategyNumErrorsHandler.prototype.getOriginalValues = function (form, workshopId) {
        var _this = this;
        var originalValues = [];
        form.fields.forEach(function (field, n) {
            field.dimtitle = _this.translate.instant('addon.mod_workshop_assessment_numerrors.dimensionnumber', { $a: field.number });
            if (!form.current[n]) {
                form.current[n] = {};
            }
            originalValues[n] = {
                peercomment: form.current[n].peercomment || '',
                number: field.number,
                grade: form.current[n].grade || ''
            };
        });
        return Promise.resolve(originalValues);
    };
    /**
     * Check if the assessment data has changed for a certain submission and workshop for a this strategy plugin.
     *
     * @param  {any[]} originalValues Original values of the form.
     * @param  {any[]} currentValues  Current values of the form.
     * @return {boolean}              True if data has changed, false otherwise.
     */
    AddonModWorkshopAssessmentStrategyNumErrorsHandler.prototype.hasDataChanged = function (originalValues, currentValues) {
        for (var x in originalValues) {
            if (originalValues[x].grade != currentValues[x].grade) {
                return true;
            }
            if (originalValues[x].peercomment != currentValues[x].peercomment) {
                return true;
            }
        }
        return false;
    };
    /**
     * Prepare assessment data to be sent to the server depending on the strategy selected.
     *
     * @param  {any{}} currentValues Current values of the form.
     * @param  {any}   form          Assessment form data.
     * @return {Promise<any>}        Promise resolved with the data to be sent. Or rejected with the input errors object.
     */
    AddonModWorkshopAssessmentStrategyNumErrorsHandler.prototype.prepareAssessmentData = function (currentValues, form) {
        var _this = this;
        var data = {};
        var errors = {};
        var hasErrors = false;
        form.fields.forEach(function (field, idx) {
            if (idx < form.dimenssionscount) {
                var grade = parseInt(currentValues[idx].grade);
                if (!isNaN(grade) && (grade == 1 || grade == -1)) {
                    data['grade__idx_' + idx] = grade;
                }
                else {
                    errors['grade_' + idx] = _this.translate.instant('core.required');
                    hasErrors = true;
                }
                if (currentValues[idx].peercomment) {
                    data['peercomment__idx_' + idx] = currentValues[idx].peercomment;
                }
                data['gradeid__idx_' + idx] = parseInt(form.current[idx].gradeid, 10) || 0;
                data['dimensionid__idx_' + idx] = parseInt(field.dimensionid, 10);
                data['weight__idx_' + idx] = parseInt(field.weight, 10) || 0;
            }
        });
        if (hasErrors) {
            return Promise.reject(errors);
        }
        return Promise.resolve(data);
    };
    AddonModWorkshopAssessmentStrategyNumErrorsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModWorkshopAssessmentStrategyNumErrorsHandler);
    return AddonModWorkshopAssessmentStrategyNumErrorsHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1689 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyRubricModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_rubric__ = __webpack_require__(876);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_handler__ = __webpack_require__(1690);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__ = __webpack_require__(129);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









var AddonModWorkshopAssessmentStrategyRubricModule = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyRubricModule(strategyDelegate, strategyHandler) {
        strategyDelegate.registerHandler(strategyHandler);
    }
    AddonModWorkshopAssessmentStrategyRubricModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_rubric__["a" /* AddonModWorkshopAssessmentStrategyRubricComponent */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyRubricHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_rubric__["a" /* AddonModWorkshopAssessmentStrategyRubricComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_rubric__["a" /* AddonModWorkshopAssessmentStrategyRubricComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */],
            __WEBPACK_IMPORTED_MODULE_7__providers_handler__["a" /* AddonModWorkshopAssessmentStrategyRubricHandler */]])
    ], AddonModWorkshopAssessmentStrategyRubricModule);
    return AddonModWorkshopAssessmentStrategyRubricModule;
}());

//# sourceMappingURL=rubric.module.js.map

/***/ }),
/* 1690 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentStrategyRubricHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_rubric__ = __webpack_require__(876);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler for rubric assessment strategy plugin.
 */
var AddonModWorkshopAssessmentStrategyRubricHandler = /** @class */ (function () {
    function AddonModWorkshopAssessmentStrategyRubricHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModWorkshopAssessmentStrategyRubric';
        this.strategyName = 'rubric';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModWorkshopAssessmentStrategyRubricHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Return the Component to render the plugin.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModWorkshopAssessmentStrategyRubricHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_2__component_rubric__["a" /* AddonModWorkshopAssessmentStrategyRubricComponent */];
    };
    /**
     * Prepare original values to be shown and compared.
     *
     * @param  {any}    form       Original data of the form.
     * @param  {number} workshopId Workshop Id
     * @return {Promise<any[]>}    Promise resolved with original values sorted.
     */
    AddonModWorkshopAssessmentStrategyRubricHandler.prototype.getOriginalValues = function (form, workshopId) {
        var _this = this;
        var originalValues = [];
        form.fields.forEach(function (field, n) {
            field.dimtitle = _this.translate.instant('addon.mod_workshop_assessment_rubric.dimensionnumber', { $a: field.number });
            if (!form.current[n]) {
                form.current[n] = {};
            }
            originalValues[n] = {
                chosenlevelid: form.current[n].chosenlevelid || '',
                number: field.number
            };
        });
        return Promise.resolve(originalValues);
    };
    /**
     * Check if the assessment data has changed for a certain submission and workshop for a this strategy plugin.
     *
     * @param  {any[]} originalValues Original values of the form.
     * @param  {any[]} currentValues  Current values of the form.
     * @return {boolean}              True if data has changed, false otherwise.
     */
    AddonModWorkshopAssessmentStrategyRubricHandler.prototype.hasDataChanged = function (originalValues, currentValues) {
        for (var x in originalValues) {
            if (originalValues[x].chosenlevelid != (currentValues[x].chosenlevelid || '')) {
                return true;
            }
        }
        return false;
    };
    /**
     * Prepare assessment data to be sent to the server depending on the strategy selected.
     *
     * @param  {any{}} currentValues Current values of the form.
     * @param  {any}   form          Assessment form data.
     * @return {Promise<any>}        Promise resolved with the data to be sent. Or rejected with the input errors object.
     */
    AddonModWorkshopAssessmentStrategyRubricHandler.prototype.prepareAssessmentData = function (currentValues, form) {
        var _this = this;
        var data = {};
        var errors = {};
        var hasErrors = false;
        form.fields.forEach(function (field, idx) {
            if (idx < form.dimenssionscount) {
                var id = parseInt(currentValues[idx].chosenlevelid, 10);
                if (!isNaN(id) && id >= 0) {
                    data['chosenlevelid__idx_' + idx] = id;
                }
                else {
                    errors['chosenlevelid_' + idx] = _this.translate.instant('addon.mod_workshop_assessment_rubric.mustchooseone');
                    hasErrors = true;
                }
                data['gradeid__idx_' + idx] = parseInt(form.current[idx].gradeid, 10) || 0;
                data['dimensionid__idx_' + idx] = parseInt(field.dimensionid, 10);
            }
        });
        if (hasErrors) {
            return Promise.reject(errors);
        }
        return Promise.resolve(data);
    };
    AddonModWorkshopAssessmentStrategyRubricHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModWorkshopAssessmentStrategyRubricHandler);
    return AddonModWorkshopAssessmentStrategyRubricHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1691 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopSubmissionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_helper__ = __webpack_require__(152);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_offline__ = __webpack_require__(133);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component that displays workshop submission.
 */
var AddonModWorkshopSubmissionComponent = /** @class */ (function () {
    function AddonModWorkshopSubmissionComponent(workshopOffline, workshopHelper, navCtrl, userProvider, sitesProvider) {
        this.workshopOffline = workshopOffline;
        this.workshopHelper = workshopHelper;
        this.navCtrl = navCtrl;
        this.userProvider = userProvider;
        this.component = __WEBPACK_IMPORTED_MODULE_4__providers_workshop__["a" /* AddonModWorkshopProvider */].COMPONENT;
        this.loaded = false;
        this.offline = false;
        this.viewDetails = false;
        this.userId = sitesProvider.getCurrentSiteUserId();
        this.showGrade = this.workshopHelper.showGrade;
    }
    /**
     * Component being initialized.
     */
    AddonModWorkshopSubmissionComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.componentId = this.module.instance;
        this.userId = this.submission.authorid || this.submission.userid || this.userId;
        this.submission.title = this.submission.title || this.submission.submissiontitle;
        this.submission.timemodified = this.submission.timemodified || this.submission.submissionmodified;
        this.submission.id = this.submission.id || this.submission.submissionid;
        if (this.workshop.phase == __WEBPACK_IMPORTED_MODULE_4__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_ASSESSMENT) {
            if (this.submission.reviewedby && this.submission.reviewedby.length) {
                this.submission.reviewedbycount = this.submission.reviewedby.reduce(function (a, b) {
                    return a + (b.grade ? 1 : 0);
                }, 0);
            }
            if (this.submission.reviewerof && this.submission.reviewerof.length) {
                this.submission.reviewerofcount = this.submission.reviewerof.reduce(function (a, b) {
                    return a + (b.grade ? 1 : 0);
                }, 0);
            }
        }
        var promises = [];
        this.offline = (this.submission && this.submission.offline) || (this.assessment && this.assessment.offline);
        if (this.submission.id) {
            promises.push(this.workshopOffline.getEvaluateSubmission(this.workshop.id, this.submission.id)
                .then(function (offlineSubmission) {
                _this.submission.submissiongradeover = offlineSubmission.gradeover;
                _this.offline = true;
            }).catch(function () {
                // Ignore errors.
            }));
        }
        if (this.userId) {
            promises.push(this.userProvider.getProfile(this.userId, this.courseId, true).then(function (profile) {
                _this.profile = profile;
            }));
        }
        this.viewDetails = !this.summary && this.workshop.phase == __WEBPACK_IMPORTED_MODULE_4__providers_workshop__["a" /* AddonModWorkshopProvider */].PHASE_CLOSED &&
            this.navCtrl.getActive().name !== 'AddonModWorkshopSubmissionPage';
        if (this.viewDetails && this.submission.gradeoverby) {
            promises.push(this.userProvider.getProfile(this.submission.gradeoverby, this.courseId, true).then(function (profile) {
                _this.evaluateByProfile = profile;
            }));
        }
        Promise.all(promises).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Navigate to the submission.
     */
    AddonModWorkshopSubmissionComponent.prototype.gotoSubmission = function () {
        if (this.submission.timemodified) {
            var params = {
                module: this.module,
                workshop: this.workshop,
                access: this.access,
                courseId: this.courseId,
                profile: this.profile,
                submission: this.submission,
                assessment: this.assessment,
            };
            this.navCtrl.push('AddonModWorkshopSubmissionPage', params);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopSubmissionComponent.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopSubmissionComponent.prototype, "module", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopSubmissionComponent.prototype, "workshop", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopSubmissionComponent.prototype, "access", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWorkshopSubmissionComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopSubmissionComponent.prototype, "assessment", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModWorkshopSubmissionComponent.prototype, "summary", void 0);
    AddonModWorkshopSubmissionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-submission',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\submission\addon-mod-workshop-submission.html"*/'<core-loading [hideUntil]="loaded">\n    <div *ngIf="!summary">\n        <ion-list-header text-wrap>\n            <ion-avatar core-user-avatar [user]="profile" [courseId]="courseId" [userId]="profile && profile.id" item-start></ion-avatar>\n            <h2>{{submission.title}}</h2>\n            <p *ngIf="profile && profile.fullname">{{profile.fullname}}</p>\n            <p *ngIf="showGrade(submission.submissiongrade)" [class.addon-has-overriden-grade]="showGrade(submission.submissiongradeover)">\n                {{ \'addon.mod_workshop.submissiongradeof\' | translate:{$a: workshop.grade } }}: {{submission.submissiongrade}}\n            </p>\n            <p *ngIf="showGrade(submission.submissiongradeover)" class="addon-overriden-grade">\n                {{ \'addon.mod_workshop.gradeover\' | translate }}: {{submission.submissiongradeover}}\n            </p>\n            <p *ngIf="access.canviewallsubmissions && showGrade(submission.gradinggrade)">\n                {{ \'addon.mod_workshop.gradinggradeof\' | translate:{$a: workshop.gradinggrade } }}: {{submission.gradinggrade}}\n            </p>\n            <ion-note item-end *ngIf="!submission.timemodified">\n                <ion-icon name="time"></ion-icon> {{ \'core.notsent\' | translate }}\n            </ion-note>\n            <ion-note item-end *ngIf="submission.timemodified">\n                {{submission.timemodified | coreDateDayOrTime}}\n                <ng-container *ngIf="submission.offline"><ion-icon name="time"></ion-icon> {{ \'core.notsent\' | translate }}</ng-container>\n                <ng-container *ngIf="submission.deleted"><ion-icon name="trash"></ion-icon> {{ \'core.deletedoffline\' | translate }}</ng-container>\n            </ion-note>\n        </ion-list-header>\n        <ion-item text-wrap *ngIf="submission.content">\n            <core-format-text [component]="component" [componentId]="componentId" [text]="submission.content"></core-format-text>\n        </ion-item>\n        <ion-item *ngFor="let attachment of submission.attachmentfiles">\n            <!-- Files already attached to the submission. -->\n            <core-file *ngIf="!attachment.name" [file]="attachment" [component]="component" [componentId]="componentId"></core-file>\n            <!-- Files stored in offline to be sent later. -->\n            <core-local-file *ngIf="attachment.name" [file]="attachment"></core-local-file>\n        </ion-item>\n        <ion-item text-wrap *ngIf="viewDetails && submission.feedbackauthor">\n            <ion-avatar *ngIf="evaluateByProfile" core-user-avatar [user]="evaluateByProfile" item-start [courseId]="courseId" [userId]="evaluateByProfile.id"></ion-avatar>\n\n            <h2 *ngIf="evaluateByProfile && evaluateByProfile.fullname">{{ \'addon.mod_workshop.feedbackby\' | translate : {$a: evaluateByProfile.fullname} }}</h2>\n            <core-format-text [text]="submission.feedbackauthor"></core-format-text>\n        </ion-item>\n        <ion-item *ngIf="viewDetails">\n            <button ion-button block (click)="gotoSubmission()">\n                {{ \'core.showmore\' | translate }}\n                <ion-icon name="arrow-forward" item-end></ion-icon>\n            </button>\n        </ion-item>\n    </div>\n\n    <a ion-item text-wrap *ngIf="summary" [attr.detail-none]="submission.timemodified ? null : true" (click)="gotoSubmission()">\n        <ion-avatar core-user-avatar [user]="profile" item-start [courseId]="courseId" [userId]="profile && profile.id"></ion-avatar>\n\n        <h2>{{submission.title}}</h2>\n        <p *ngIf="profile && profile.fullname">{{profile.fullname}}</p>\n        <p *ngIf="submission.reviewedbycount">\n            {{ \'addon.mod_workshop.receivedgrades\' | translate }}: {{submission.reviewedbycount}} / {{submission.reviewedby.length}}\n        </p>\n        <p *ngIf="submission.reviewerofcount">\n            {{ \'addon.mod_workshop.givengrades\' | translate }}: {{submission.reviewerofcount}} / {{submission.reviewerof.length}}\n        </p>\n        <p *ngIf="!showGrade(submission.submissiongradeover) && showGrade(submission.submissiongrade)">\n            {{ \'addon.mod_workshop.submissiongradeof\' | translate:{$a: workshop.grade } }}: {{submission.submissiongrade}}\n        </p>\n        <p *ngIf="showGrade(submission.submissiongradeover)" class="addon-overriden-grade">\n            {{ \'addon.mod_workshop.submissiongradeof\' | translate:{$a: workshop.grade } }}: {{submission.submissiongradeover}}\n        </p>\n        <p *ngIf="access.canviewallsubmissions && showGrade(submission.gradinggrade)">\n            {{ \'addon.mod_workshop.gradinggradeof\' | translate:{$a: workshop.gradinggrade } }}: {{submission.gradinggrade}}\n        </p>\n\n        <ion-badge *ngIf="assessment && (showGrade(assessment.grade) || assessment.offline)" color="success">{{ \'addon.mod_workshop.assessedsubmission\' | translate }}</ion-badge>\n        <ion-badge *ngIf="assessment && !showGrade(assessment.grade) && !assessment.offline" color="danger">{{ \'addon.mod_workshop.notassessed\' | translate }}</ion-badge>\n\n        <ion-note item-end *ngIf="submission.timemodified">\n            {{submission.timemodified | coreDateDayOrTime}}\n            <div *ngIf="offline"><ion-icon name="time"></ion-icon> {{ \'core.notsent\' | translate }}</div>\n            <div *ngIf="submission.deleted"><ion-icon name="trash"></ion-icon> {{ \'core.deletedoffline\' | translate }}</div>\n        </ion-note>\n    </a>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\submission\addon-mod-workshop-submission.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_offline__["a" /* AddonModWorkshopOfflineProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* AddonModWorkshopHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModWorkshopSubmissionComponent);
    return AddonModWorkshopSubmissionComponent;
}());

//# sourceMappingURL=submission.js.map

/***/ }),
/* 1692 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopAssessmentComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_helper__ = __webpack_require__(152);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_offline__ = __webpack_require__(133);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Component that displays workshop assessment.
 */
var AddonModWorkshopAssessmentComponent = /** @class */ (function () {
    function AddonModWorkshopAssessmentComponent(workshopOffline, workshopHelper, navCtrl, userProvider, domUtils, sitesProvider) {
        this.workshopOffline = workshopOffline;
        this.workshopHelper = workshopHelper;
        this.navCtrl = navCtrl;
        this.userProvider = userProvider;
        this.domUtils = domUtils;
        this.canViewAssessment = false;
        this.canSelfAssess = false;
        this.offline = false;
        this.loaded = false;
        this.currentUserId = sitesProvider.getCurrentSiteUserId();
        this.showGrade = this.workshopHelper.showGrade;
    }
    /**
     * Component being initialized.
     */
    AddonModWorkshopAssessmentComponent.prototype.ngOnInit = function () {
        var _this = this;
        var canAssess = this.access && this.access.assessingallowed, userId = this.assessment.userid || this.assessment.reviewerid, promises = [];
        this.assessmentId = this.assessment.assessmentid || this.assessment.id;
        this.canViewAssessment = this.assessment.grade;
        this.canSelfAssess = canAssess && userId == this.currentUserId;
        if (userId) {
            promises.push(this.userProvider.getProfile(userId, this.courseId, true).then(function (profile) {
                _this.profile = profile;
            }));
        }
        var assessOffline;
        if (userId == this.currentUserId) {
            assessOffline = this.workshopOffline.getAssessment(this.workshop.id, this.assessmentId).then(function (offlineAssess) {
                _this.offline = true;
                _this.assessment.weight = offlineAssess.inputdata.weight;
            });
        }
        else {
            assessOffline = this.workshopOffline.getEvaluateAssessment(this.workshop.id, this.assessmentId)
                .then(function (offlineAssess) {
                _this.offline = true;
                _this.assessment.gradinggradeover = offlineAssess.gradinggradeover;
                _this.assessment.weight = offlineAssess.weight;
            });
        }
        promises.push(assessOffline.catch(function () {
            _this.offline = false;
            // Ignore errors.
        }));
        Promise.all(promises).finally(function () {
            _this.loaded = true;
        });
    };
    /**
     * Navigate to the assessment.
     */
    AddonModWorkshopAssessmentComponent.prototype.gotoAssessment = function () {
        var _this = this;
        if (!this.canSelfAssess && this.canViewAssessment) {
            var params_1 = {
                assessment: this.assessment,
                submission: this.submission,
                profile: this.profile,
                courseId: this.courseId,
                assessmentId: this.assessmentId
            };
            if (!this.submission) {
                var modal_1 = this.domUtils.showModalLoading('core.sending', true);
                this.workshopHelper.getSubmissionById(this.workshop.id, this.assessment.submissionid)
                    .then(function (submissionData) {
                    params_1.submission = submissionData;
                    _this.navCtrl.push('AddonModWorkshopAssessmentPage', params_1);
                }).catch(function (message) {
                    _this.domUtils.showErrorModalDefault(message, 'Cannot load submission');
                }).finally(function () {
                    modal_1.dismiss();
                });
            }
            else {
                this.navCtrl.push('AddonModWorkshopAssessmentPage', params_1);
            }
        }
    };
    /**
     * Navigate to my own assessment.
     */
    AddonModWorkshopAssessmentComponent.prototype.gotoOwnAssessment = function () {
        if (this.canSelfAssess) {
            var params = {
                module: this.module,
                workshop: this.workshop,
                access: this.access,
                courseId: this.courseId,
                profile: this.profile,
                submission: this.submission,
                assessment: this.assessment
            };
            this.navCtrl.push('AddonModWorkshopSubmissionPage', params);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentComponent.prototype, "assessment", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonModWorkshopAssessmentComponent.prototype, "summary", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModWorkshopAssessmentComponent.prototype, "courseId", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentComponent.prototype, "submission", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentComponent.prototype, "module", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentComponent.prototype, "workshop", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModWorkshopAssessmentComponent.prototype, "access", void 0);
    AddonModWorkshopAssessmentComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-workshop-assessment',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\assessment\addon-mod-workshop-assessment.html"*/'<core-loading [hideUntil]="loaded">\n    <a ion-item *ngIf="summary" text-wrap [attr.detail-none]="canViewAssessment && !canSelfAssess? null : true" (click)="gotoAssessment()">\n        <ion-avatar core-user-avatar [user]="profile" item-start [courseId]="courseId" [userId]="profile && profile.id"></ion-avatar>\n\n        <h2 *ngIf="profile && profile.fullname">{{profile.fullname}}</h2>\n        <p *ngIf="showGrade(assessment.grade)">\n            {{ \'addon.mod_workshop.submissiongradeof\' | translate:{$a: workshop.grade } }}: {{assessment.grade}}\n        </p>\n        <p *ngIf="access.canviewallsubmissions && !showGrade(assessment.gradinggradeover) && showGrade(assessment.gradinggrade)">\n            {{ \'addon.mod_workshop.gradinggradeof\' | translate:{$a: workshop.gradinggrade } }}: {{assessment.gradinggrade}}\n        </p>\n        <p *ngIf="access.canviewallsubmissions && showGrade(assessment.gradinggradeover)" class="core-overriden-grade">\n            {{ \'addon.mod_workshop.gradinggradeof\' | translate:{$a: workshop.gradinggrade } }}: {{assessment.gradinggradeover}}\n        </p>\n        <p *ngIf="assessment.weight && assessment.weight != 1">\n            {{ \'addon.mod_workshop.weightinfo\' | translate:{$a: assessment.weight } }}\n        </p>\n        <ion-badge *ngIf="!assessment.grade" color="danger">{{ \'addon.mod_workshop.notassessed\' | translate }}</ion-badge>\n        <button ion-button block *ngIf="canSelfAssess && !showGrade(assessment.grade)" (click)="gotoOwnAssessment()">{{ \'addon.mod_workshop.assess\' | translate }}</button>\n        <button ion-button block *ngIf="canSelfAssess && showGrade(assessment.grade)" (click)="gotoOwnAssessment()">{{ \'addon.mod_workshop.reassess\' | translate }}</button>\n        <ion-note item-end *ngIf="offline">\n            <ion-icon name="time"></ion-icon>{{ \'core.notsent\' | translate }}\n        </ion-note>\n    </a>\n</core-loading>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\workshop\components\assessment\addon-mod-workshop-assessment.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__providers_offline__["a" /* AddonModWorkshopOfflineProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_helper__["a" /* AddonModWorkshopHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonModWorkshopAssessmentComponent);
    return AddonModWorkshopAssessmentComponent;
}());

//# sourceMappingURL=assessment.js.map

/***/ }),
/* 1693 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(447);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support workshop modules.
 */
var AddonModWorkshopModuleHandler = /** @class */ (function () {
    function AddonModWorkshopModuleHandler(courseProvider, workshopProvider) {
        this.courseProvider = courseProvider;
        this.workshopProvider = workshopProvider;
        this.name = 'AddonModWorkshop';
        this.modName = 'workshop';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_PLAGIARISM] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModWorkshopModuleHandler.prototype.isEnabled = function () {
        return this.workshopProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModWorkshopModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_workshop-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModWorkshopIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModWorkshopModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModWorkshopIndexComponent */];
    };
    AddonModWorkshopModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__workshop__["a" /* AddonModWorkshopProvider */]])
    ], AddonModWorkshopModuleHandler);
    return AddonModWorkshopModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1694 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__workshop__ = __webpack_require__(111);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to workshop.
 */
var AddonModWorkshopLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModWorkshopLinkHandler, _super);
    function AddonModWorkshopLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, __WEBPACK_IMPORTED_MODULE_3__workshop__["a" /* AddonModWorkshopProvider */].COMPONENT, 'workshop') || this;
        _this.name = 'AddonModWorkshopLinkHandler';
        return _this;
    }
    AddonModWorkshopLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModWorkshopLinkHandler);
    return AddonModWorkshopLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1695 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__workshop__ = __webpack_require__(111);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to workshop list page.
 */
var AddonModWorkshopListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModWorkshopListLinkHandler, _super);
    function AddonModWorkshopListLinkHandler(linkHelper, translate, workshopProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModWorkshop', 'workshop') || this;
        _this.workshopProvider = workshopProvider;
        _this.name = 'AddonModWorkshopListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModWorkshopListLinkHandler.prototype.isEnabled = function () {
        return this.workshopProvider.isPluginEnabled();
    };
    AddonModWorkshopListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__workshop__["a" /* AddonModWorkshopProvider */]])
    ], AddonModWorkshopListLinkHandler);
    return AddonModWorkshopListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1696 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_groups__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__workshop__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__sync__ = __webpack_require__(221);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__helper__ = __webpack_require__(152);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














/**
 * Handler to prefetch workshops.
 */
var AddonModWorkshopPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModWorkshopPrefetchHandler, _super);
    function AddonModWorkshopPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, groupsProvider, userProvider, workshopProvider, workshopHelper, syncProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.groupsProvider = groupsProvider;
        _this.userProvider = userProvider;
        _this.workshopProvider = workshopProvider;
        _this.workshopHelper = workshopHelper;
        _this.syncProvider = syncProvider;
        _this.name = 'AddonModWorkshop';
        _this.modName = 'workshop';
        _this.component = __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].COMPONENT;
        _this.updatesNames = new RegExp('^configuration$|^.*files$|^completion|^gradeitems$|^outcomes$|^submissions$|^assessments$' +
            '|^assessmentgrades$|^usersubmissions$|^userassessments$|^userassessmentgrades$|^userassessmentgrades$');
        return _this;
    }
    /**
     * Get list of files. If not defined, we'll assume they're in module.contents.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<any[]>} Promise resolved with the list of files.
     */
    AddonModWorkshopPrefetchHandler.prototype.getFiles = function (module, courseId, single) {
        return this.getWorkshopInfoHelper(module, courseId, true).then(function (info) {
            return info.files;
        });
    };
    /**
     * Helper function to get all workshop info just once.
     *
     * @param  {any}     module              Module to get the files.
     * @param  {number}  courseId            Course ID the module belongs to.
     * @param  {boolean} [omitFail=false]    True to always return even if fails. Default false.
     * @param  {boolean} [forceCache=false]  True to always get the value from cache, false otherwise. Default false.
     * @param  {boolean} [ignoreCache=false] True if it should ignore cached data (it will always fail in offline or server down).
     * @param  {string}  [siteId]            Site ID. If not defined, current site.
     * @return {Promise<any>}                Promise resolved with the info fetched.
     */
    AddonModWorkshopPrefetchHandler.prototype.getWorkshopInfoHelper = function (module, courseId, omitFail, forceCache, ignoreCache, siteId) {
        var _this = this;
        if (omitFail === void 0) { omitFail = false; }
        if (forceCache === void 0) { forceCache = false; }
        if (ignoreCache === void 0) { ignoreCache = false; }
        var workshop, groups = [], files = [], access;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var userId = site.getUserId();
            return _this.workshopProvider.getWorkshop(courseId, module.id, siteId, forceCache).then(function (data) {
                files = _this.getIntroFilesFromInstance(module, data);
                files = files.concat(data.instructauthorsfiles).concat(data.instructreviewersfiles);
                workshop = data;
                return _this.workshopProvider.getWorkshopAccessInformation(workshop.id, false, true, siteId).then(function (accessData) {
                    access = accessData;
                    if (access.canviewallsubmissions) {
                        return _this.groupsProvider.getActivityGroupInfo(module.id, false, undefined, siteId).then(function (groupInfo) {
                            if (!groupInfo.groups || groupInfo.groups.length == 0) {
                                groupInfo.groups = [{ id: 0 }];
                            }
                            groups = groupInfo.groups;
                        });
                    }
                });
            }).then(function () {
                return _this.workshopProvider.getUserPlanPhases(workshop.id, false, true, siteId).then(function (phases) {
                    // Get submission phase info.
                    var submissionPhase = phases[__WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_SUBMISSION], canSubmit = _this.workshopHelper.canSubmit(workshop, access, submissionPhase.tasks), canAssess = _this.workshopHelper.canAssess(workshop, access), promises = [];
                    if (canSubmit) {
                        promises.push(_this.workshopHelper.getUserSubmission(workshop.id, userId).then(function (submission) {
                            if (submission) {
                                files = files.concat(submission.contentfiles).concat(submission.attachmentfiles);
                            }
                        }));
                    }
                    if (access.canviewallsubmissions && workshop.phase >= __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_SUBMISSION) {
                        promises.push(_this.workshopProvider.getSubmissions(workshop.id).then(function (submissions) {
                            var promises2 = [];
                            submissions.forEach(function (submission) {
                                files = files.concat(submission.contentfiles).concat(submission.attachmentfiles);
                                promises2.push(_this.workshopProvider.getSubmissionAssessments(workshop.id, submission.id)
                                    .then(function (assessments) {
                                    assessments.forEach(function (assessment) {
                                        files = files.concat(assessment.feedbackattachmentfiles)
                                            .concat(assessment.feedbackcontentfiles);
                                    });
                                }));
                            });
                            return Promise.all(promises2);
                        }));
                    }
                    // Get assessment files.
                    if (workshop.phase >= __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_ASSESSMENT && canAssess) {
                        promises.push(_this.workshopHelper.getReviewerAssessments(workshop.id).then(function (assessments) {
                            assessments.forEach(function (assessment) {
                                files = files.concat(assessment.feedbackattachmentfiles).concat(assessment.feedbackcontentfiles);
                            });
                        }));
                    }
                    return Promise.all(promises);
                });
            });
        }).then(function () {
            return {
                workshop: workshop,
                groups: groups,
                files: files.filter(function (file) { return typeof file !== 'undefined'; })
            };
        }).catch(function (message) {
            if (omitFail) {
                // Any error, return the info we have.
                return {
                    workshop: workshop,
                    groups: groups,
                    files: files.filter(function (file) { return typeof file !== 'undefined'; })
                };
            }
            return Promise.reject(message);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId The course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModWorkshopPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.workshopProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Check if a module can be downloaded. If the function is not defined, we assume that all modules are downloadable.
     *
     * @param  {any} module Module.
     * @param  {number} courseId Course ID the module belongs to.
     * @return {boolean|Promise<boolean>} Whether the module can be downloaded. The promise should never be rejected.
     */
    AddonModWorkshopPrefetchHandler.prototype.isDownloadable = function (module, courseId) {
        var _this = this;
        return this.workshopProvider.getWorkshop(courseId, module.id, undefined, true).then(function (workshop) {
            return _this.workshopProvider.getWorkshopAccessInformation(workshop.id).then(function (accessData) {
                // Check if workshop is setup by phase.
                return accessData.canswitchphase || workshop.phase > __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_SETUP;
            });
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    AddonModWorkshopPrefetchHandler.prototype.isEnabled = function () {
        return this.workshopProvider.isPluginEnabled();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWorkshopPrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, single, this.prefetchWorkshop.bind(this));
    };
    /**
     * Retrieves all the grades reports for all the groups and then returns only unique grades.
     *
     * @param  {number}  workshopId Workshop ID.
     * @param  {any[]}   groups     Array of groups in the activity.
     * @param  {string}  siteId     Site ID. If not defined, current site.
     * @return {Promise<any[]>}       All unique entries.
     */
    AddonModWorkshopPrefetchHandler.prototype.getAllGradesReport = function (workshopId, groups, siteId) {
        var _this = this;
        var promises = [];
        groups.forEach(function (group) {
            promises.push(_this.workshopProvider.fetchAllGradeReports(workshopId, group.id, undefined, false, false, siteId));
        });
        return Promise.all(promises).then(function (grades) {
            var uniqueGrades = {};
            grades.forEach(function (groupGrades) {
                groupGrades.forEach(function (grade) {
                    if (grade.submissionid) {
                        uniqueGrades[grade.submissionid] = grade;
                    }
                });
            });
            return _this.utils.objectToArray(uniqueGrades);
        });
    };
    /**
     * Prefetch a workshop.
     *
     * @param  {any}     module   The module object returned by WS.
     * @param  {number}  courseId Course ID the module belongs to.
     * @param  {boolean} single   True if we're downloading a single module, false if we're downloading a whole section.
     * @param  {string}  siteId   Site ID.
     * @return {Promise<any>}     Promise resolved when done.
     */
    AddonModWorkshopPrefetchHandler.prototype.prefetchWorkshop = function (module, courseId, single, siteId) {
        var _this = this;
        var userIds = [];
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var currentUserId = site.getUserId();
            // Prefetch the workshop data.
            return _this.getWorkshopInfoHelper(module, courseId, false, false, true, siteId).then(function (info) {
                var workshop = info.workshop, promises = [], assessments = [];
                promises.push(_this.filepoolProvider.addFilesToQueue(siteId, info.files, _this.component, module.id));
                promises.push(_this.workshopProvider.getWorkshopAccessInformation(workshop.id, false, true, siteId)
                    .then(function (access) {
                    return _this.workshopProvider.getUserPlanPhases(workshop.id, false, true, siteId).then(function (phases) {
                        // Get submission phase info.
                        var submissionPhase = phases[__WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_SUBMISSION], canSubmit = _this.workshopHelper.canSubmit(workshop, access, submissionPhase.tasks), canAssess = _this.workshopHelper.canAssess(workshop, access), promises2 = [];
                        if (canSubmit) {
                            promises2.push(_this.workshopProvider.getSubmissions(workshop.id));
                            // Add userId to the profiles to prefetch.
                            userIds.push(currentUserId);
                        }
                        var reportPromise = Promise.resolve();
                        if (access.canviewallsubmissions && workshop.phase >= __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_SUBMISSION) {
                            reportPromise = _this.getAllGradesReport(workshop.id, info.groups, siteId)
                                .then(function (grades) {
                                grades.forEach(function (grade) {
                                    userIds.push(grade.userid);
                                    userIds.push(grade.gradeoverby);
                                    grade.reviewedby && grade.reviewedby.forEach(function (assessment) {
                                        userIds.push(assessment.userid);
                                        userIds.push(assessment.gradinggradeoverby);
                                        assessments[assessment.assessmentid] = assessment;
                                    });
                                    grade.reviewerof && grade.reviewerof.forEach(function (assessment) {
                                        userIds.push(assessment.userid);
                                        userIds.push(assessment.gradinggradeoverby);
                                        assessments[assessment.assessmentid] = assessment;
                                    });
                                });
                            });
                        }
                        if (workshop.phase >= __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_ASSESSMENT && canAssess) {
                            // Wait the report promise to finish to override assessments array if needed.
                            reportPromise = reportPromise.finally(function () {
                                return _this.workshopHelper.getReviewerAssessments(workshop.id, currentUserId, undefined, undefined, siteId).then(function (revAssessments) {
                                    var promises = [];
                                    var files = []; // Files in each submission.
                                    revAssessments.forEach(function (assessment) {
                                        if (assessment.submission.authorid == currentUserId) {
                                            promises.push(_this.workshopProvider.getAssessment(workshop.id, assessment.id));
                                        }
                                        userIds.push(assessment.reviewerid);
                                        userIds.push(assessment.gradinggradeoverby);
                                        assessments[assessment.id] = assessment;
                                        files = files.concat(assessment.submission.attachmentfiles || [])
                                            .concat(assessment.submission.contentfiles || []);
                                    });
                                    promises.push(_this.filepoolProvider.addFilesToQueue(siteId, files, _this.component, module.id));
                                    return Promise.all(promises);
                                });
                            });
                        }
                        reportPromise = reportPromise.finally(function () {
                            if (assessments.length > 0) {
                                return Promise.all(assessments.map(function (assessment, id) {
                                    return _this.workshopProvider.getAssessmentForm(workshop.id, id, undefined, undefined, undefined, siteId);
                                }));
                            }
                        });
                        promises2.push(reportPromise);
                        if (workshop.phase == __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */].PHASE_CLOSED) {
                            promises2.push(_this.workshopProvider.getGrades(workshop.id));
                            if (access.canviewpublishedsubmissions) {
                                promises2.push(_this.workshopProvider.getSubmissions(workshop.id));
                            }
                        }
                        return Promise.all(promises2);
                    });
                }));
                // Add Basic Info to manage links.
                promises.push(_this.courseProvider.getModuleBasicInfoByInstance(workshop.id, 'workshop', siteId));
                promises.push(_this.courseProvider.getModuleBasicGradeInfo(module.id, siteId));
                return Promise.all(promises);
            });
        }).then(function () {
            // Prefetch user profiles.
            return _this.userProvider.prefetchProfiles(userIds, courseId, siteId).catch(function () {
                // Ignore errors.
            });
        });
    };
    /**
     * Sync a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonModWorkshopPrefetchHandler.prototype.sync = function (module, courseId, siteId) {
        return this.syncProvider.syncWorkshop(module.instance, siteId);
    };
    AddonModWorkshopPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_groups__["a" /* CoreGroupsProvider */],
            __WEBPACK_IMPORTED_MODULE_10__core_user_providers_user__["a" /* CoreUserProvider */],
            __WEBPACK_IMPORTED_MODULE_11__workshop__["a" /* AddonModWorkshopProvider */],
            __WEBPACK_IMPORTED_MODULE_13__helper__["a" /* AddonModWorkshopHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_12__sync__["a" /* AddonModWorkshopSyncProvider */]])
    ], AddonModWorkshopPrefetchHandler);
    return AddonModWorkshopPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 1697 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModWorkshopSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(221);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModWorkshopSyncCronHandler = /** @class */ (function () {
    function AddonModWorkshopSyncCronHandler(workshopSync) {
        this.workshopSync = workshopSync;
        this.name = 'AddonModWorkshopSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModWorkshopSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.workshopSync.syncAllWorkshops(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModWorkshopSyncCronHandler.prototype.getInterval = function () {
        return this.workshopSync.syncInterval;
    };
    AddonModWorkshopSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonModWorkshopSyncProvider */]])
    ], AddonModWorkshopSyncCronHandler);
    return AddonModWorkshopSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1698 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesCourseOptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__notes__ = __webpack_require__(190);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_list_list__ = __webpack_require__(878);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to inject an option into the course main menu.
 */
var AddonNotesCourseOptionHandler = /** @class */ (function () {
    function AddonNotesCourseOptionHandler(notesProvider) {
        this.notesProvider = notesProvider;
        this.name = 'AddonNotes';
        this.priority = 200;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonNotesCourseOptionHandler.prototype.isEnabled = function () {
        return this.notesProvider.isPluginEnabled();
    };
    /**
     * Whether or not the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonNotesCourseOptionHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        if (accessData && accessData.type == __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */].ACCESS_GUEST) {
            return false; // Not enabled for guests.
        }
        if (navOptions && typeof navOptions.notes != 'undefined') {
            return navOptions.notes;
        }
        return this.notesProvider.isPluginViewNotesEnabledForCourse(courseId);
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {number} courseId The course ID.
     * @return {CoreCourseOptionsHandlerData} Data.
     */
    AddonNotesCourseOptionHandler.prototype.getDisplayData = function (injector, courseId) {
        return {
            title: 'addon.notes.notes',
            class: 'addon-notes-course-handler',
            component: __WEBPACK_IMPORTED_MODULE_3__components_list_list__["a" /* AddonNotesListComponent */],
        };
    };
    /**
     * Called when a course is downloaded. It should prefetch all the data to be able to see the addon in offline.
     *
     * @param {any} course The course.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonNotesCourseOptionHandler.prototype.prefetch = function (course) {
        return this.notesProvider.getNotes(course.id, undefined, true);
    };
    AddonNotesCourseOptionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__notes__["a" /* AddonNotesProvider */]])
    ], AddonNotesCourseOptionHandler);
    return AddonNotesCourseOptionHandler;
}());

//# sourceMappingURL=course-option-handler.js.map

/***/ }),
/* 1699 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__notes_sync__ = __webpack_require__(381);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonNotesSyncCronHandler = /** @class */ (function () {
    function AddonNotesSyncCronHandler(notesSync) {
        this.notesSync = notesSync;
        this.name = 'AddonNotesSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonNotesSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.notesSync.syncAllNotes(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonNotesSyncCronHandler.prototype.getInterval = function () {
        return 300000; // 5 minutes.
    };
    AddonNotesSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__notes_sync__["a" /* AddonNotesSyncProvider */]])
    ], AddonNotesSyncCronHandler);
    return AddonNotesSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1700 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotesUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__notes__ = __webpack_require__(190);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Profile notes handler.
 */
var AddonNotesUserHandler = /** @class */ (function () {
    function AddonNotesUserHandler(linkHelper, sitesProvider, notesProvider, eventsProvider) {
        var _this = this;
        this.linkHelper = linkHelper;
        this.sitesProvider = sitesProvider;
        this.notesProvider = notesProvider;
        this.name = 'AddonNotes:notes';
        this.priority = 100;
        this.type = __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_NEW_PAGE;
        this.noteEnabledCache = {};
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */].LOGOUT, this.clearNoteCache.bind(this));
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__core_user_providers_user__["a" /* CoreUserProvider */].PROFILE_REFRESHED, function (data) {
            _this.clearNoteCache(data.courseId);
        });
    }
    /**
     * Clear note cache.
     * If a courseId is specified, it will only delete the entry for that course.
     *
     * @param {number} [courseId] Course ID.
     */
    AddonNotesUserHandler.prototype.clearNoteCache = function (courseId) {
        if (courseId) {
            delete this.noteEnabledCache[courseId];
        }
        else {
            this.noteEnabledCache = {};
        }
    };
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonNotesUserHandler.prototype.isEnabled = function () {
        return this.notesProvider.isPluginEnabled();
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user User to check.
     * @param {number} courseId Course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} Promise resolved with true if enabled, resolved with false otherwise.
     */
    AddonNotesUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        var _this = this;
        // Active course required.
        if (!courseId || user.id == this.sitesProvider.getCurrentSiteUserId()) {
            return false;
        }
        if (typeof this.noteEnabledCache[courseId] != 'undefined') {
            return this.noteEnabledCache[courseId];
        }
        return this.notesProvider.isPluginViewNotesEnabledForCourse(courseId).then(function (enabled) {
            _this.noteEnabledCache[courseId] = enabled;
            return enabled;
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonNotesUserHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        return {
            icon: 'list',
            title: 'addon.notes.notes',
            class: 'addon-notes-handler',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                // Always use redirect to make it the new history root (to avoid "loops" in history).
                _this.linkHelper.goInSite(navCtrl, 'AddonNotesListPage', { userId: user.id, courseId: courseId });
            }
        };
    };
    AddonNotesUserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_6__notes__["a" /* AddonNotesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */]])
    ], AddonNotesUserHandler);
    return AddonNotesUserHandler;
}());

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1701 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotificationsMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__notifications__ = __webpack_require__(170);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_pushnotifications__ = __webpack_require__(86);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_pushnotifications_providers_delegate__ = __webpack_require__(82);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Handler to inject an option into main menu.
 */
var AddonNotificationsMainMenuHandler = /** @class */ (function () {
    function AddonNotificationsMainMenuHandler(eventsProvider, sitesProvider, utils, notificationsProvider, pushNotificationsProvider, pushNotificationsDelegate) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.notificationsProvider = notificationsProvider;
        this.pushNotificationsProvider = pushNotificationsProvider;
        this.name = 'AddonNotifications';
        this.priority = 700;
        this.handler = {
            icon: 'notifications',
            title: 'addon.notifications.notifications',
            page: 'AddonNotificationsListPage',
            class: 'addon-notifications-handler',
            showBadge: true,
            badge: '',
            loading: true,
        };
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__notifications__["a" /* AddonNotificationsProvider */].READ_CHANGED_EVENT, function (data) {
            _this.updateBadge(data.siteId);
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__notifications__["a" /* AddonNotificationsProvider */].READ_CRON_EVENT, function (data) {
            _this.updateBadge(data.siteId);
        });
        // Reset info on logout.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function (data) {
            _this.handler.badge = '';
            _this.handler.loading = true;
        });
        // If a push notification is received, refresh the count.
        pushNotificationsDelegate.on('receive').subscribe(function (notification) {
            // New notification received. If it's from current site, refresh the data.
            if (utils.isTrueOrOne(notification.notif) && _this.sitesProvider.isCurrentSite(notification.site)) {
                _this.updateBadge(notification.site);
            }
        });
        // Register Badge counter.
        pushNotificationsDelegate.registerCounterHandler('AddonNotifications');
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonNotificationsMainMenuHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data needed to render the handler.
     */
    AddonNotificationsMainMenuHandler.prototype.getDisplayData = function () {
        if (this.handler.loading) {
            this.updateBadge();
        }
        return this.handler;
    };
    /**
     * Triggers an update for the badge number and loading status. Mandatory if showBadge is enabled.
     *
     * @param {string} [siteId] Site ID or current Site if undefined.
     */
    AddonNotificationsMainMenuHandler.prototype.updateBadge = function (siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (!siteId) {
            return;
        }
        this.notificationsProvider.getUnreadNotificationsCount(null, siteId).then(function (unread) {
            _this.handler.badge = unread > 0 ? String(unread) : '';
            _this.pushNotificationsProvider.updateAddonCounter('AddonNotifications', unread, siteId);
        }).catch(function () {
            _this.handler.badge = '';
        }).finally(function () {
            _this.handler.loading = false;
        });
    };
    AddonNotificationsMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__notifications__["a" /* AddonNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_pushnotifications_providers_pushnotifications__["a" /* CorePushNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_pushnotifications_providers_delegate__["a" /* CorePushNotificationsDelegate */]])
    ], AddonNotificationsMainMenuHandler);
    return AddonNotificationsMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 1702 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotificationsSettingsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__notifications__ = __webpack_require__(170);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_local_notifications__ = __webpack_require__(92);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Notifications settings handler.
 */
var AddonNotificationsSettingsHandler = /** @class */ (function () {
    function AddonNotificationsSettingsHandler(appProvider, localNotificationsProvider, notificationsProvider) {
        this.appProvider = appProvider;
        this.localNotificationsProvider = localNotificationsProvider;
        this.notificationsProvider = notificationsProvider;
        this.name = 'AddonNotifications';
        this.priority = 500;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean | Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonNotificationsSettingsHandler.prototype.isEnabled = function () {
        // Preferences or notification sound setting available.
        return (this.notificationsProvider.isNotificationPreferencesEnabled() ||
            this.localNotificationsProvider.isAvailable() && !this.appProvider.isDesktop());
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreSettingsHandlerData} Data needed to render the handler.
     */
    AddonNotificationsSettingsHandler.prototype.getDisplayData = function () {
        return {
            icon: 'notifications',
            title: 'addon.notifications.notificationpreferences',
            page: 'AddonNotificationsSettingsPage',
            class: 'addon-notifications-settings-handler'
        };
    };
    AddonNotificationsSettingsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_1__notifications__["a" /* AddonNotificationsProvider */]])
    ], AddonNotificationsSettingsHandler);
    return AddonNotificationsSettingsHandler;
}());

//# sourceMappingURL=settings-handler.js.map

/***/ }),
/* 1703 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotificationsCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_local_notifications__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_emulator_providers_helper__ = __webpack_require__(211);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__notifications__ = __webpack_require__(170);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__helper__ = __webpack_require__(448);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









/**
 * Notifications cron handler.
 */
var AddonNotificationsCronHandler = /** @class */ (function () {
    function AddonNotificationsCronHandler(appProvider, eventsProvider, sitesProvider, localNotifications, notificationsProvider, textUtils, emulatorHelper, notificationsHelper) {
        this.appProvider = appProvider;
        this.eventsProvider = eventsProvider;
        this.sitesProvider = sitesProvider;
        this.localNotifications = localNotifications;
        this.notificationsProvider = notificationsProvider;
        this.textUtils = textUtils;
        this.emulatorHelper = emulatorHelper;
        this.notificationsHelper = notificationsHelper;
        this.name = 'AddonNotificationsCronHandler';
    }
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonNotificationsCronHandler.prototype.getInterval = function () {
        return this.appProvider.isDesktop() ? 60000 : 600000; // 1 or 10 minutes.
    };
    /**
     * Check whether it's a synchronization process or not. True if not defined.
     *
     * @return {boolean} Whether it's a synchronization process or not.
     */
    AddonNotificationsCronHandler.prototype.isSync = function () {
        // This is done to use only wifi if using the fallback function.
        // In desktop it is always sync, since it fetches notification to see if there's a new one.
        return !this.notificationsProvider.isPreciseNotificationCountEnabled() || this.appProvider.isDesktop();
    };
    /**
     * Check whether the sync can be executed manually. Call isSync if not defined.
     *
     * @return {boolean} Whether the sync can be executed manually.
     */
    AddonNotificationsCronHandler.prototype.canManualSync = function () {
        return true;
    };
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure. If the promise is rejected, this function
     *                                will be called again often, it shouldn't be abused.
     */
    AddonNotificationsCronHandler.prototype.execute = function (siteId, force) {
        if (this.sitesProvider.isCurrentSite(siteId)) {
            this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_7__notifications__["a" /* AddonNotificationsProvider */].READ_CRON_EVENT, {}, this.sitesProvider.getCurrentSiteId());
        }
        if (this.appProvider.isDesktop() && this.localNotifications.isAvailable()) {
            this.emulatorHelper.checkNewNotifications(__WEBPACK_IMPORTED_MODULE_7__notifications__["a" /* AddonNotificationsProvider */].PUSH_SIMULATION_COMPONENT, this.fetchNotifications.bind(this), this.getTitleAndText.bind(this), siteId);
        }
        return Promise.resolve(null);
    };
    /**
     * Get the latest unread notifications from a site.
     *
     * @param  {string} siteId  Site ID.
     * @return {Promise<any[]>} Promise resolved with the notifications.
     */
    AddonNotificationsCronHandler.prototype.fetchNotifications = function (siteId) {
        return this.notificationsHelper.getNotifications([], undefined, true, false, true, siteId).then(function (result) {
            return result.notifications;
        });
    };
    /**
     * Given a notification, return the title and the text for the notification.
     *
     * @param  {any} notification Notification.
     * @return {Promise<any>} Promise resvoled with an object with title and text.
     */
    AddonNotificationsCronHandler.prototype.getTitleAndText = function (notification) {
        var data = {
            title: notification.subject || notification.userfromfullname,
            text: notification.mobiletext.replace(/-{4,}/ig, '')
        };
        data.text = this.textUtils.replaceNewLines(data.text, '<br>');
        return Promise.resolve(data);
    };
    AddonNotificationsCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_local_notifications__["a" /* CoreLocalNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__notifications__["a" /* AddonNotificationsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_text__["a" /* CoreTextUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__core_emulator_providers_helper__["a" /* CoreEmulatorHelperProvider */], __WEBPACK_IMPORTED_MODULE_8__helper__["a" /* AddonNotificationsHelperProvider */]])
    ], AddonNotificationsCronHandler);
    return AddonNotificationsCronHandler;
}());

//# sourceMappingURL=cron-handler.js.map

/***/ }),
/* 1704 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonNotificationsPushClickHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__notifications__ = __webpack_require__(170);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler for non-messaging push notifications clicks.
 */
var AddonNotificationsPushClickHandler = /** @class */ (function () {
    function AddonNotificationsPushClickHandler(utils, notificationsProvider, linkHelper, eventsProvider) {
        this.utils = utils;
        this.notificationsProvider = notificationsProvider;
        this.linkHelper = linkHelper;
        this.eventsProvider = eventsProvider;
        this.name = 'AddonNotificationsPushClickHandler';
        this.priority = 0; // Low priority so it's used as a fallback if no other handler treats the notification.
        this.featureName = 'CoreMainMenuDelegate_AddonNotifications';
    }
    /**
     * Check if a notification click is handled by this handler.
     *
     * @param {any} notification The notification to check.
     * @return {boolean} Whether the notification click is handled by this handler
     */
    AddonNotificationsPushClickHandler.prototype.handles = function (notification) {
        var _this = this;
        if (this.utils.isTrueOrOne(notification.notif)) {
            // Notification clicked, mark as read. Don't block for this.
            var notifId = notification.savedmessageid || notification.id;
            this.notificationsProvider.markNotificationRead(notifId, notification.site).then(function () {
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__notifications__["a" /* AddonNotificationsProvider */].READ_CHANGED_EVENT, null, notification.site);
            }).catch(function () {
                // Ignore errors.
            });
            return true;
        }
        return false;
    };
    /**
     * Handle the notification click.
     *
     * @param {any} notification The notification to check.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonNotificationsPushClickHandler.prototype.handleClick = function (notification) {
        var _this = this;
        var promise;
        // Try to handle the appurl first.
        if (notification.customdata && notification.customdata.appurl) {
            promise = this.linkHelper.handleLink(notification.customdata.appurl, undefined, undefined, true);
        }
        else {
            promise = Promise.resolve(false);
        }
        return promise.then(function (treated) {
            if (!treated) {
                // No link or cannot be handled by the app. Try to handle the contexturl now.
                if (notification.contexturl) {
                    return _this.linkHelper.handleLink(notification.contexturl);
                }
                else {
                    return false;
                }
            }
            return true;
        }).then(function (treated) {
            if (!treated) {
                // No link or cannot be handled by the app. Open the notifications page.
                return _this.notificationsProvider.invalidateNotificationsList(notification.site).catch(function () {
                    // Ignore errors.
                }).then(function () {
                    return _this.linkHelper.goInSite(undefined, 'AddonNotificationsListPage', undefined, notification.site);
                });
            }
        });
    };
    AddonNotificationsPushClickHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__notifications__["a" /* AddonNotificationsProvider */],
            __WEBPACK_IMPORTED_MODULE_3__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_events__["a" /* CoreEventsProvider */]])
    ], AddonNotificationsPushClickHandler);
    return AddonNotificationsPushClickHandler;
}());

//# sourceMappingURL=push-click-handler.js.map

/***/ }),
/* 1705 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonRemoteThemesProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_file__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_constants__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_ts_md5_dist_md5__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_ts_md5_dist_md5___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_9_ts_md5_dist_md5__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Service to handle remote themes. A remote theme is a CSS sheet stored in the site that allows customising the Mobile app.
 */
var AddonRemoteThemesProvider = /** @class */ (function () {
    function AddonRemoteThemesProvider(logger, sitesProvider, fileProvider, filepoolProvider, http, utils, appProvider) {
        this.sitesProvider = sitesProvider;
        this.fileProvider = fileProvider;
        this.filepoolProvider = filepoolProvider;
        this.http = http;
        this.utils = utils;
        this.appProvider = appProvider;
        this.SEPARATOR_35 = /\/\*\*? *3\.5(\.0)? *styles? *\*\//i; // A comment like "/* 3.5 styles */".
        this.stylesEls = {};
        this.logger = logger.getInstance('AddonRemoteThemesProvider');
    }
    AddonRemoteThemesProvider_1 = AddonRemoteThemesProvider;
    /**
     * Add a style element for a site and load the styles for that element. The style will be disabled.
     *
     * @param {string} siteId Site ID.
     * @return {Promise<any>} Promise resolved when added and loaded.
     */
    AddonRemoteThemesProvider.prototype.addSite = function (siteId) {
        var _this = this;
        if (!siteId || this.stylesEls[siteId]) {
            // Invalid site ID or style already added.
            return Promise.resolve();
        }
        // Create the style and add it to the header.
        var styleEl = document.createElement('style');
        styleEl.setAttribute('id', 'mobilecssurl-' + siteId);
        this.disableElement(styleEl, true);
        document.head.appendChild(styleEl);
        this.stylesEls[siteId] = {
            element: styleEl,
            hash: ''
        };
        return this.load(siteId, true).catch(function (error) {
            _this.logger.error('Error loading site after site init', error);
        });
    };
    /**
     * Clear styles added to the DOM, disabling them all.
     */
    AddonRemoteThemesProvider.prototype.clear = function () {
        var _this = this;
        // Disable all the styles.
        var styles = Array.from(document.querySelectorAll('style[id*=mobilecssurl]'));
        styles.forEach(function (style) {
            _this.disableElement(style, true);
        });
        // Set StatusBar properties.
        this.appProvider.setStatusBarColor();
    };
    /**
     * Enabled or disable a certain style element.
     *
     * @param {HTMLStyleElement} element The element to enable or disable.
     * @param {boolean} disable Whether to disable or enable the element.
     */
    AddonRemoteThemesProvider.prototype.disableElement = function (element, disable) {
        // Setting disabled should be enough, but we also set the attribute so it can be seen in the DOM which ones are disabled.
        if (disable) {
            element.disabled = true;
            element.setAttribute('disabled', 'disabled');
        }
        else {
            element.disabled = false;
            element.removeAttribute('disabled');
            if (element.innerHTML != '') {
                this.appProvider.resetStatusBarColor();
            }
        }
    };
    /**
     * Downloads a CSS file and remove old files if needed.
     *
     * @param {string} siteId Site ID.
     * @param {string} url File URL.
     * @return {Promise<any>} Promise resolved when the file is downloaded.
     */
    AddonRemoteThemesProvider.prototype.downloadFileAndRemoveOld = function (siteId, url) {
        var _this = this;
        // Check if the file is downloaded.
        return this.filepoolProvider.getFileStateByUrl(siteId, url).then(function (state) {
            return state !== __WEBPACK_IMPORTED_MODULE_8__core_constants__["a" /* CoreConstants */].NOT_DOWNLOADED;
        }).catch(function () {
            return true; // An error occurred while getting state (shouldn't happen). Don't delete downloaded file.
        }).then(function (isDownloaded) {
            if (!isDownloaded) {
                // File not downloaded, URL has changed or first time. Delete downloaded CSS files.
                return _this.filepoolProvider.removeFilesByComponent(siteId, AddonRemoteThemesProvider_1.COMPONENT, 1);
            }
        }).then(function () {
            return _this.filepoolProvider.downloadUrl(siteId, url, false, AddonRemoteThemesProvider_1.COMPONENT, 1);
        });
    };
    /**
     * Enable the styles of a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     */
    AddonRemoteThemesProvider.prototype.enable = function (siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        if (this.stylesEls[siteId]) {
            this.disableElement(this.stylesEls[siteId].element, false);
        }
    };
    /**
     * Get remote styles of a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<{fileUrl: string, styles: string}>} Promise resolved with the styles and the URL of the CSS file,
     *                                                      resolved with undefined if no styles to load.
     */
    AddonRemoteThemesProvider.prototype.get = function (siteId) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var infos = site.getInfo();
            var promise, fileUrl;
            if (infos && infos.mobilecssurl) {
                fileUrl = infos.mobilecssurl;
                if (_this.fileProvider.isAvailable()) {
                    // The file system is available. Download the file and remove old CSS files if needed.
                    promise = _this.downloadFileAndRemoveOld(siteId, fileUrl);
                }
                else {
                    // Return the online URL.
                    promise = Promise.resolve(fileUrl);
                }
            }
            else {
                if (infos && infos.mobilecssurl === '') {
                    // CSS URL is empty. Delete downloaded files (if any).
                    _this.filepoolProvider.removeFilesByComponent(siteId, AddonRemoteThemesProvider_1.COMPONENT, 1);
                }
                return;
            }
            return promise.then(function (url) {
                _this.logger.debug('Loading styles from: ', url);
                // Get the CSS content using HTTP because we will treat the styles before saving them in the file.
                return _this.http.get(url).toPromise();
            }).then(function (response) {
                var text = response && response.text();
                if (typeof text == 'string') {
                    return { fileUrl: fileUrl, styles: _this.get35Styles(text) };
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Check if the CSS code has a separator for 3.5 styles. If it does, get only the styles after the separator.
     *
     * @param {string} cssCode The CSS code to check.
     * @return {string} The filtered styles.
     */
    AddonRemoteThemesProvider.prototype.get35Styles = function (cssCode) {
        var separatorPos = cssCode.search(this.SEPARATOR_35);
        if (separatorPos > -1) {
            return cssCode.substr(separatorPos).replace(this.SEPARATOR_35, '');
        }
        return cssCode;
    };
    /**
     * Load styles for a certain site.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [disabled] Whether loaded styles should be disabled.
     * @return {Promise<any>} Promise resolved when styles are loaded.
     */
    AddonRemoteThemesProvider.prototype.load = function (siteId, disabled) {
        var _this = this;
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        disabled = !!disabled;
        this.logger.debug('Load site', siteId, disabled);
        if (siteId && this.stylesEls[siteId]) {
            // Enable or disable the styles.
            this.disableElement(this.stylesEls[siteId].element, disabled);
            return this.get(siteId).then(function (data) {
                if (typeof data == 'undefined') {
                    // Nothing to load.
                    return;
                }
                var hash = __WEBPACK_IMPORTED_MODULE_9_ts_md5_dist_md5__["Md5"].hashAsciiStr(data.styles);
                // Update the styles only if they have changed.
                if (_this.stylesEls[siteId].hash !== hash) {
                    _this.stylesEls[siteId].element.innerHTML = data.styles;
                    _this.stylesEls[siteId].hash = hash;
                    // Adding styles to a style element automatically enables it. Disable it again.
                    if (disabled) {
                        _this.disableElement(_this.stylesEls[siteId].element, true);
                    }
                }
                // Styles have been loaded, now treat the CSS.
                _this.filepoolProvider.treatCSSCode(siteId, data.fileUrl, data.styles, AddonRemoteThemesProvider_1.COMPONENT, 2)
                    .catch(function () {
                    // Ignore errors.
                });
            });
        }
        return Promise.reject(null);
    };
    /**
     * Load styles for a temporary site. These styles aren't prefetched.
     *
     * @param {string} url URL to get the styles from.
     * @return {Promise<any>} Promise resolved when loaded.
     */
    AddonRemoteThemesProvider.prototype.loadTmpStyles = function (url) {
        var _this = this;
        if (!url) {
            return Promise.resolve();
        }
        return this.http.get(url).toPromise().then(function (response) {
            var text = response && response.text();
            if (typeof text == 'string') {
                text = _this.get35Styles(text);
                var styleEl = document.createElement('style');
                styleEl.setAttribute('id', 'mobilecssurl-tmpsite');
                styleEl.innerHTML = text;
                document.head.appendChild(styleEl);
                _this.stylesEls.tmpsite = {
                    element: styleEl,
                    hash: ''
                };
            }
            else {
                return Promise.reject(null);
            }
        });
    };
    /**
     * Preload the styles of the current site (stored in DB).
     *
     * @return {Promise<any>} Promise resolved when loaded.
     */
    AddonRemoteThemesProvider.prototype.preloadCurrentSite = function () {
        var _this = this;
        return this.sitesProvider.getStoredCurrentSiteId().then(function (siteId) {
            return _this.addSite(siteId);
        }, function () {
            // No current site stored.
        });
    };
    /**
     * Preload the styles of all the stored sites.
     *
     * @return {Promise<any>} Promise resolved when loaded.
     */
    AddonRemoteThemesProvider.prototype.preloadSites = function () {
        var _this = this;
        return this.sitesProvider.getSitesIds().then(function (ids) {
            var promises = [];
            ids.forEach(function (siteId) {
                promises.push(_this.addSite(siteId));
            });
            return _this.utils.allPromises(promises);
        });
    };
    /**
     * Remove the styles of a certain site.
     *
     * @param {string} siteId Site ID.
     */
    AddonRemoteThemesProvider.prototype.removeSite = function (siteId) {
        if (siteId && this.stylesEls[siteId]) {
            document.head.removeChild(this.stylesEls[siteId].element);
            delete this.stylesEls[siteId];
        }
    };
    /**
     * Unload styles for a temporary site.
     */
    AddonRemoteThemesProvider.prototype.unloadTmpStyles = function () {
        return this.removeSite('tmpsite');
    };
    AddonRemoteThemesProvider.COMPONENT = 'mmaRemoteStyles';
    AddonRemoteThemesProvider = AddonRemoteThemesProvider_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_file__["a" /* CoreFileProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_1__angular_http__["b" /* Http */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */]])
    ], AddonRemoteThemesProvider);
    return AddonRemoteThemesProvider;
    var AddonRemoteThemesProvider_1;
}());

//# sourceMappingURL=remotethemes.js.map

/***/ }),
/* 1706 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldPluginComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__ = __webpack_require__(162);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





/**
 * Component that displays a database field plugin.
 */
var AddonModDataFieldPluginComponent = /** @class */ (function () {
    function AddonModDataFieldPluginComponent(injector, dataDelegate, dataProvider) {
        this.injector = injector;
        this.dataDelegate = dataDelegate;
        this.dataProvider = dataProvider;
        this.gotoEntry = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Component being initialized.
     */
    AddonModDataFieldPluginComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this.field) {
            this.fieldLoaded = true;
            return;
        }
        // Check if the plugin has defined its own component to render itself.
        this.dataDelegate.getComponentForField(this.injector, this.field).then(function (component) {
            _this.fieldComponent = component;
            if (component) {
                // Prepare the data to pass to the component.
                _this.data = {
                    mode: _this.mode,
                    field: _this.field,
                    value: _this.value,
                    database: _this.database,
                    error: _this.error,
                    gotoEntry: _this.gotoEntry,
                    form: _this.form,
                    search: _this.search
                };
            }
        }).finally(function () {
            _this.fieldLoaded = true;
        });
    };
    /**
     * Component being changed.
     */
    AddonModDataFieldPluginComponent.prototype.ngOnChanges = function (changes) {
        if (this.fieldLoaded && this.data) {
            if (this.mode == 'edit' && changes.error) {
                this.data.error = changes.error.currentValue;
            }
            if ((this.mode == 'show' || this.mode == 'list') && changes.value) {
                this.data.value = changes.value.currentValue;
            }
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_4__components_dynamic_component_dynamic_component__["a" /* CoreDynamicComponent */])
    ], AddonModDataFieldPluginComponent.prototype, "dynamicComponent", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModDataFieldPluginComponent.prototype, "mode", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "field", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "value", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "database", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModDataFieldPluginComponent.prototype, "error", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonModDataFieldPluginComponent.prototype, "gotoEntry", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1__angular_forms__["c" /* FormGroup */])
    ], AddonModDataFieldPluginComponent.prototype, "form", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataFieldPluginComponent.prototype, "search", void 0);
    AddonModDataFieldPluginComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-field-plugin',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\components\field-plugin\addon-mod-data-field-plugin.html"*/'<core-dynamic-component [component]="fieldComponent" [data]="data">\n    <!-- This content will be replaced by the component if found. -->\n    <core-loading [hideUntil]="fieldLoaded">\n    </core-loading>\n</core-dynamic-component>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\components\field-plugin\addon-mod-data-field-plugin.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_3__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */],
            __WEBPACK_IMPORTED_MODULE_2__providers_data__["a" /* AddonModDataProvider */]])
    ], AddonModDataFieldPluginComponent);
    return AddonModDataFieldPluginComponent;
}());

//# sourceMappingURL=field-plugin.js.map

/***/ }),
/* 1707 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataActionComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_helper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_offline__ = __webpack_require__(191);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user__ = __webpack_require__(26);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









/**
 * Component that displays a database action.
 */
var AddonModDataActionComponent = /** @class */ (function () {
    function AddonModDataActionComponent(injector, dataProvider, dataOffline, eventsProvider, sitesProvider, userProvider, navCtrl, linkHelper, dataHelper) {
        this.injector = injector;
        this.dataProvider = dataProvider;
        this.dataOffline = dataOffline;
        this.eventsProvider = eventsProvider;
        this.userProvider = userProvider;
        this.navCtrl = navCtrl;
        this.linkHelper = linkHelper;
        this.dataHelper = dataHelper;
        this.rootUrl = sitesProvider.getCurrentSite().getURL();
        this.siteId = sitesProvider.getCurrentSiteId();
    }
    /**
     * Component being initialized.
     */
    AddonModDataActionComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.action == 'userpicture') {
            this.userProvider.getProfile(this.entry.userid, this.database.courseid).then(function (profile) {
                _this.userPicture = profile.profileimageurl;
            });
        }
    };
    /**
     * Approve the entry.
     */
    AddonModDataActionComponent.prototype.approveEntry = function () {
        this.dataHelper.approveOrDisapproveEntry(this.database.id, this.entry.id, true, this.database.courseid);
    };
    /**
     * Show confirmation modal for deleting the entry.
     */
    AddonModDataActionComponent.prototype.deleteEntry = function () {
        this.dataHelper.showDeleteEntryModal(this.database.id, this.entry.id, this.database.courseid);
    };
    /**
     * Disapprove the entry.
     */
    AddonModDataActionComponent.prototype.disapproveEntry = function () {
        this.dataHelper.approveOrDisapproveEntry(this.database.id, this.entry.id, false, this.database.courseid);
    };
    /**
     * Go to the edit page of the entry.
     */
    AddonModDataActionComponent.prototype.editEntry = function () {
        var pageParams = {
            courseId: this.database.course,
            module: this.module,
            entryId: this.entry.id
        };
        this.linkHelper.goInSite(this.navCtrl, 'AddonModDataEditPage', pageParams);
    };
    /**
     * Go to the view page of the entry.
     */
    AddonModDataActionComponent.prototype.viewEntry = function () {
        var pageParams = {
            courseId: this.database.course,
            module: this.module,
            entryId: this.entry.id,
            group: this.group,
            offset: this.offset
        };
        this.linkHelper.goInSite(this.navCtrl, 'AddonModDataEntryPage', pageParams);
    };
    /**
     * Undo delete action.
     *
     * @return {Promise<any>} Solved when done.
     */
    AddonModDataActionComponent.prototype.undoDelete = function () {
        var _this = this;
        var dataId = this.database.id, entryId = this.entry.id;
        return this.dataOffline.getEntry(dataId, entryId, 'delete', this.siteId).then(function () {
            // Found. Just delete the action.
            return _this.dataOffline.deleteEntry(dataId, entryId, 'delete', _this.siteId);
        }).then(function () {
            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__providers_data__["a" /* AddonModDataProvider */].ENTRY_CHANGED, { dataId: dataId, entryId: entryId }, _this.siteId);
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModDataActionComponent.prototype, "mode", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", String)
    ], AddonModDataActionComponent.prototype, "action", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataActionComponent.prototype, "entry", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataActionComponent.prototype, "database", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonModDataActionComponent.prototype, "module", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModDataActionComponent.prototype, "group", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonModDataActionComponent.prototype, "offset", void 0);
    AddonModDataActionComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-mod-data-action',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\components\action\addon-mod-data-action.html"*/'<a *ngIf="action == \'more\'" ion-button icon-only clear (click)="viewEntry()" [title]="\'addon.mod_data.more\' | translate">\n    <ion-icon name="search"></ion-icon>\n</a>\n\n<a *ngIf="action == \'edit\'" ion-button icon-only clear (click)="editEntry()"  [title]="\'core.edit\' | translate">\n    <ion-icon name="cog"></ion-icon>\n</a>\n\n<a *ngIf="action == \'delete\' && !entry.deleted" ion-button icon-only clear (click)="deleteEntry()" [title]="\'core.delete\' | translate">\n    <ion-icon name="trash"></ion-icon>\n</a>\n\n<a *ngIf="action == \'delete\' && entry.deleted" ion-button icon-only clear (click)="undoDelete()" [title]="\'core.restore\' | translate">\n    <ion-icon name="undo"></ion-icon>\n</a>\n\n<a *ngIf="action == \'approve\'" ion-button icon-only clear (click)="approveEntry()" [title]="\'addon.mod_data.approve\' | translate">\n    <ion-icon name="thumbs-up"></ion-icon>\n</a>\n\n<a *ngIf="action == \'disapprove\'" ion-button icon-only clear (click)="disapproveEntry()" [title]="\'addon.mod_data.disapprove\' | translate">\n    <ion-icon name="thumbs-down"></ion-icon>\n</a>\n\n<core-comments *ngIf="action == \'comments\' && mode == \'list\'" contextLevel="module" [instanceId]="database.coursemodule" component="mod_data" [itemId]="entry.id" area="database_entry"></core-comments>\n\n<span *ngIf="action == \'timeadded\'">{{ entry.timecreated * 1000 |  coreFormatDate }}</span>\n<span *ngIf="action == \'timemodified\'">{{ entry.timemodified * 1000 |  coreFormatDate }}</span>\n\n<a *ngIf="action == \'userpicture\'" core-user-link [courseId]="database.courseid" [userId]="entry.userid" [title]="entry.fullname">\n    <img class="avatar-round" [src]="userPicture" [alt]="\'core.pictureof\' | translate:{$a: entry.fullname}" core-external-content onError="this.src=\'assets/img/user-avatar.png\'" role="presentation">\n</a>\n\n<a *ngIf="action == \'user\' && entry" core-user-link [courseId]="database.courseid" [userId]="entry.userid" [title]="entry.fullname">{{entry.fullname}}</a>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\mod\data\components\action\addon-mod-data-action.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injector"], __WEBPACK_IMPORTED_MODULE_3__providers_data__["a" /* AddonModDataProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_offline__["a" /* AddonModDataOfflineProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_8__core_user_providers_user__["a" /* CoreUserProvider */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_7__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_helper__["a" /* AddonModDataHelperProvider */]])
    ], AddonModDataActionComponent);
    return AddonModDataActionComponent;
}());

//# sourceMappingURL=action.js.map

/***/ }),
/* 1708 */,
/* 1709 */,
/* 1710 */,
/* 1711 */,
/* 1712 */,
/* 1713 */,
/* 1714 */,
/* 1715 */,
/* 1716 */,
/* 1717 */,
/* 1718 */,
/* 1719 */,
/* 1720 */,
/* 1721 */,
/* 1722 */,
/* 1723 */,
/* 1724 */,
/* 1725 */,
/* 1726 */,
/* 1727 */,
/* 1728 */,
/* 1729 */,
/* 1730 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MoodleMobileApp; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_urlschemes__ = __webpack_require__(926);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__ionic_native_keyboard__ = __webpack_require__(339);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_screen_orientation__ = __webpack_require__(925);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_angular_oauth2_oidc__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__ionic_native_splash_screen__ = __webpack_require__(428);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_native_service_native_service__ = __webpack_require__(451);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















var MoodleMobileApp = /** @class */ (function () {
    function MoodleMobileApp(platform, logger, keyboard, eventsProvider, loginHelper, zone, appProvider, langProvider, sitesProvider, screenOrientation, app, urlSchemesProvider, utils, urlUtils, oauthService, splashScreen, rest, nativeService) {
        var _this = this;
        this.platform = platform;
        this.eventsProvider = eventsProvider;
        this.loginHelper = loginHelper;
        this.zone = zone;
        this.appProvider = appProvider;
        this.langProvider = langProvider;
        this.sitesProvider = sitesProvider;
        this.screenOrientation = screenOrientation;
        this.urlSchemesProvider = urlSchemesProvider;
        this.utils = utils;
        this.urlUtils = urlUtils;
        this.oauthService = oauthService;
        this.splashScreen = splashScreen;
        this.rest = rest;
        this.nativeService = nativeService;
        // Use page name (string) because the page is lazy loaded (Ionic feature). That way we can load pages without importing them.
        // The downside is that each page needs to implement a ngModule.
        this.rootPage = 'CoreLoginInitPage';
        this.lastUrls = {};
        this.getversionurl = 'http://ag.ouc-online.com.cn/APP/APP/Versions';
        this.logger = logger.getInstance('AppComponent');
        platform.ready().then(function () {
            // Okay, so the platform is ready and our plugins are available.
            // Here you can do any higher level native things you might need.
            // Set StatusBar properties.
            // this.appProvider.setStatusBarColor();
            setTimeout(function () {
                _this.splashScreen.hide();
            }, 1000);
            keyboard.hideFormAccessoryBar(false);
            if (_this.appProvider.isDesktop()) {
                app.setElementClass('platform-desktop', true);
                if (_this.appProvider.isMac()) {
                    app.setElementClass('platform-mac', true);
                }
                else if (_this.appProvider.isLinux()) {
                    app.setElementClass('platform-linux', true);
                }
                else if (_this.appProvider.isWindows()) {
                    app.setElementClass('platform-windows', true);
                }
            }
            if (platform.is('ios')) {
                _this.getversionurl = 'http://ag.ouc-online.com.cn/APP/Versions?DependentId=ouchniosapp&DependentType=OuchnAPP';
            }
            else if (platform.is('android')) {
                _this.getversionurl = 'http://ag.ouc-online.com.cn/APP/Versions?DependentId=ouchnandroidapp&DependentType=OuchnAPP';
            }
            else {
                _this.getversionurl = 'http://ag.ouc-online.com.cn/APP/Versions?DependentId=ouchnandroidapp&DependentType=OuchnAPP';
            }
            _this.rest.httpMyGet(_this.getversionurl, '', function (d) {
                //把获取到的版本信息存储起来
                localStorage.setItem("shandaversion", d.Data.Version);
                localStorage.setItem("shandadownLoadUrl", d.Data.HistoryData);
                //调用nativeService 检查是否需要更新
                if (platform.is('android')) {
                    _this.nativeService.detectionUpgrade();
                }
            }, false);
            if (platform.is('android')) {
                MobclickAgent.init("5f9fca121c520d30739e4578", "myself");
            }
            else if (platform.is('ios')) {
                MobclickAgent.init("5fa0dc7945b2b751a9225c8a", "myself");
            }
        });
    }
    /**
     * Component being initialized.
     */
    MoodleMobileApp.prototype.ngOnInit = function () {
        var _this = this;
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function () {
            // Go to sites page when user is logged out.
            _this.appProvider.getRootNavController().setRoot('CoreLoginSitesPage');
            // Unload lang custom strings.
            _this.langProvider.clearCustomStrings();
            // Remove version classes from body.
            _this.removeVersionClass();
        });
        // Listen for session expired events.
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SESSION_EXPIRED, function (data) {
            _this.loginHelper.sessionExpired(data);
        });
        // Listen for passwordchange and usernotfullysetup events to open InAppBrowser.
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].PASSWORD_CHANGE_FORCED, function (data) {
            _this.loginHelper.openInAppForEdit(data.siteId, '/login/change_password.php', 'core.forcepasswordchangenotice', true);
        });
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].USER_NOT_FULLY_SETUP, function (data) {
            _this.loginHelper.openInAppForEdit(data.siteId, '/user/edit.php', 'core.usernotfullysetup');
        });
        // Listen for sitepolicynotagreed event to accept the site policy.
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SITE_POLICY_NOT_AGREED, function (data) {
            _this.loginHelper.sitePolicyNotAgreed(data.siteId);
        });
        // Check URLs loaded in any InAppBrowser.
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].IAB_LOAD_START, function (event) {
            // URLs with a custom scheme can be prefixed with "http://" or "https://", we need to remove this.
            var url = event.url.replace(/^https?:\/\//, '');
            if (_this.urlSchemesProvider.isCustomURL(url)) {
                // Close the browser if it's a valid SSO URL.
                _this.urlSchemesProvider.handleCustomURL(url);
                _this.utils.closeInAppBrowser(false);
            }
            else if (_this.platform.is('android')) {
                // Check if the URL has a custom URL scheme. In Android they need to be opened manually.
                var urlScheme = _this.urlUtils.getUrlProtocol(url);
                if (urlScheme && urlScheme !== 'file' && urlScheme !== 'cdvfile') {
                    // Open in browser should launch the right app if found and do nothing if not found.
                    _this.utils.openInBrowser(url);
                    // At this point the InAppBrowser is showing a "Webpage not available" error message.
                    // Try to navigate to last loaded URL so this error message isn't found.
                    if (_this.lastInAppUrl) {
                        _this.utils.openInApp(_this.lastInAppUrl);
                    }
                    else {
                        // No last URL loaded, close the InAppBrowser.
                        _this.utils.closeInAppBrowser(false);
                    }
                }
                else {
                    _this.lastInAppUrl = url;
                }
            }
        });
        // Check InAppBrowser closed.
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].IAB_EXIT, function () {
            _this.loginHelper.waitingForBrowser = false;
            _this.lastInAppUrl = '';
            _this.loginHelper.checkLogout();
        });
        this.platform.resume.subscribe(function () {
            // Wait a second before setting it to false since in iOS there could be some frozen WS calls.
            setTimeout(function () {
                _this.loginHelper.waitingForBrowser = false;
                _this.loginHelper.checkLogout();
            }, 1000);
        });
        // Handle app launched with a certain URL (custom URL scheme).
        window.handleOpenURL = function (url) {
            // Execute the callback in the Angular zone, so change detection doesn't stop working.
            _this.zone.run(function () {
                // First check that the URL hasn't been treated a few seconds ago. Sometimes this function is called more than once.
                if (_this.lastUrls[url] && Date.now() - _this.lastUrls[url] < 3000) {
                    // Function called more than once, stop.
                    return;
                }
                _this.logger.debug('App launched by URL ', url);
                _this.lastUrls[url] = Date.now();
                _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].APP_LAUNCHED_URL, url);
                _this.urlSchemesProvider.handleCustomURL(url);
            });
        };
        // Load custom lang strings. This cannot be done inside the lang provider because it causes circular dependencies.
        var loadCustomStrings = function () {
            var currentSite = _this.sitesProvider.getCurrentSite(), customStrings = currentSite && currentSite.getStoredConfig('tool_mobile_customlangstrings');
            if (typeof customStrings != 'undefined') {
                _this.langProvider.loadCustomStrings(customStrings);
            }
        };
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].LOGIN, function (data) {
            if (data.siteId) {
                _this.sitesProvider.getSite(data.siteId).then(function (site) {
                    var info = site.getInfo();
                    if (info) {
                        // Add version classes to body.
                        _this.removeVersionClass();
                        _this.addVersionClass(_this.sitesProvider.getReleaseNumber(info.release || ''));
                    }
                });
            }
            loadCustomStrings();
        });
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SITE_UPDATED, function (data) {
            if (data.siteId == _this.sitesProvider.getCurrentSiteId()) {
                loadCustomStrings();
                // Add version classes to body.
                _this.removeVersionClass();
                _this.addVersionClass(_this.sitesProvider.getReleaseNumber(data.release || ''));
            }
        });
        this.eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].SITE_ADDED, function (data) {
            if (data.siteId == _this.sitesProvider.getCurrentSiteId()) {
                loadCustomStrings();
                // Add version classes to body.
                _this.removeVersionClass();
                _this.addVersionClass(_this.sitesProvider.getReleaseNumber(data.release || ''));
            }
        });
        // Pause Youtube videos in Android when app is put in background or screen is locked.
        this.platform.pause.subscribe(function () {
            if (!_this.platform.is('android')) {
                return;
            }
            var pauseVideos = function (window) {
                // Search videos in iframes recursively.
                for (var i = 0; i < window.length; i++) {
                    pauseVideos(window[i]);
                }
                if (window.location.hostname.match(/^www\.youtube(-nocookie)?\.com$/)) {
                    // Embedded Youtube video, pause it.
                    var videos = window.document.querySelectorAll('video');
                    for (var i = 0; i < videos.length; i++) {
                        videos[i].pause();
                    }
                }
            };
            pauseVideos(window);
        });
        // Detect orientation changes.
        this.screenOrientation.onChange().subscribe(function () {
            if (_this.platform.is('ios')) {
                // Force ios to recalculate safe areas when rotating.
                // This can be erased when https://issues.apache.org/jira/browse/CB-13448 issue is solved or
                // After switching to WkWebview.
                var viewport_1 = document.querySelector('meta[name=viewport]');
                viewport_1.setAttribute('content', viewport_1.getAttribute('content').replace('viewport-fit=cover,', ''));
                setTimeout(function () {
                    viewport_1.setAttribute('content', 'viewport-fit=cover,' + viewport_1.getAttribute('content'));
                });
            }
            _this.eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */].ORIENTATION_CHANGE);
        });
    };
    /**
     * Convenience function to add version to body classes.
     *
     * @param {string} release Current release number of the site.
     */
    MoodleMobileApp.prototype.addVersionClass = function (release) {
        var parts = release.split('.');
        parts[1] = parts[1] || '0';
        parts[2] = parts[2] || '0';
        document.body.classList.add('version-' + parts[0], 'version-' + parts[0] + '-' + parts[1], 'version-' + parts[0] + '-' + parts[1] + '-' + parts[2]);
    };
    /**
     * Convenience function to remove all version classes form body.
     */
    MoodleMobileApp.prototype.removeVersionClass = function () {
        var remove = [];
        Array.from(document.body.classList).forEach(function (tempClass) {
            if (tempClass.substring(0, 8) == 'version-') {
                remove.push(tempClass);
            }
        });
        remove.forEach(function (tempClass) {
            document.body.classList.remove(tempClass);
        });
    };
    MoodleMobileApp = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\app\app.html"*/'<ion-nav [root]="rootPage"></ion-nav>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\app\app.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["w" /* Platform */], __WEBPACK_IMPORTED_MODULE_5__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_11__ionic_native_keyboard__["a" /* Keyboard */],
            __WEBPACK_IMPORTED_MODULE_3__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_10__core_login_providers_helper__["a" /* CoreLoginHelperProvider */], __WEBPACK_IMPORTED_MODULE_0__angular_core__["NgZone"],
            __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_12__ionic_native_screen_orientation__["a" /* ScreenOrientation */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["k" /* IonicApp */], __WEBPACK_IMPORTED_MODULE_9__providers_urlschemes__["a" /* CoreCustomURLSchemesProvider */],
            __WEBPACK_IMPORTED_MODULE_8__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_7__providers_utils_url__["a" /* CoreUrlUtilsProvider */], __WEBPACK_IMPORTED_MODULE_13_angular_oauth2_oidc__["b" /* OAuthService */],
            __WEBPACK_IMPORTED_MODULE_14__ionic_native_splash_screen__["a" /* SplashScreen */], __WEBPACK_IMPORTED_MODULE_15__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_16__providers_native_service_native_service__["a" /* NativeServiceProvider */]])
    ], MoodleMobileApp);
    return MoodleMobileApp;
}());

//# sourceMappingURL=app.component.js.map

/***/ }),
/* 1731 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CorePageTransition; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular_util_util__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular_transitions_page_transition__ = __webpack_require__(141);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();



var DURATION = 500;
var EASING = 'cubic-bezier(0.36,0.66,0.04,1)';
var OPACITY = 'opacity';
var TRANSFORM = 'transform';
var TRANSLATEX = 'translateX';
var CENTER = '0%';
var OFF_OPACITY = 0.8;
var SHOW_BACK_BTN_CSS = 'show-back-button';
/**
 * This class overrides the default transition to avoid glitches with new tabs and split view.
 * Is based on IOSTransition class but it has some changes:
 *  - The animation is done to the full page not header, footer and content separetely.
 *  - On the Navbar only the back button is animated (title and other buttons will be done as a whole). Otherwise back button won't
 *  appear.
 */
var CorePageTransition = /** @class */ (function (_super) {
    __extends(CorePageTransition, _super);
    function CorePageTransition() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CorePageTransition.prototype.init = function () {
        _super.prototype.init.call(this);
        var plt = this.plt;
        var OFF_RIGHT = plt.isRTL ? '-99.5%' : '99.5%';
        var OFF_LEFT = plt.isRTL ? '33%' : '-33%';
        var enteringView = this.enteringView;
        var leavingView = this.leavingView;
        var opts = this.opts;
        this.duration(Object(__WEBPACK_IMPORTED_MODULE_1_ionic_angular_util_util__["m" /* isPresent */])(opts.duration) ? opts.duration : DURATION);
        this.easing(Object(__WEBPACK_IMPORTED_MODULE_1_ionic_angular_util_util__["m" /* isPresent */])(opts.easing) ? opts.easing : EASING);
        var backDirection = (opts.direction === 'back');
        var enteringHasNavbar = (enteringView && enteringView.hasNavbar());
        var leavingHasNavbar = (leavingView && leavingView.hasNavbar());
        if (enteringView) {
            // Get the native element for the entering page.
            var enteringPageEle = enteringView.pageRef().nativeElement;
            // Entering content.
            var enteringContent = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, enteringPageEle);
            this.add(enteringContent);
            if (backDirection) {
                // Entering content, back direction.
                enteringContent
                    .fromTo(TRANSLATEX, OFF_LEFT, CENTER, true)
                    .fromTo(OPACITY, OFF_OPACITY, 1, true);
            }
            else {
                // Entering content, forward direction.
                enteringContent
                    .beforeClearStyles([OPACITY])
                    .fromTo(TRANSLATEX, OFF_RIGHT, CENTER, true);
            }
            if (enteringHasNavbar) {
                // Entering page has a navbar.
                var enteringNavbarEle = enteringPageEle.querySelector('ion-navbar');
                var enteringNavBar = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, enteringNavbarEle);
                this.add(enteringNavBar);
                var enteringBackButton = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, enteringNavbarEle.querySelector('.back-button'));
                enteringNavBar
                    .add(enteringBackButton);
                // Set properties depending on direction.
                if (backDirection) {
                    // Entering navbar, back direction.
                    if (enteringView.enableBack()) {
                        // Back direction, entering page has a back button.
                        enteringBackButton
                            .beforeAddClass(SHOW_BACK_BTN_CSS)
                            .fromTo(OPACITY, 0.01, 1, true);
                    }
                }
                else {
                    // Entering navbar, forward direction.
                    if (enteringView.enableBack()) {
                        // Forward direction, entering page has a back button.
                        enteringBackButton
                            .beforeAddClass(SHOW_BACK_BTN_CSS)
                            .fromTo(OPACITY, 0.01, 1, true);
                        var enteringBackBtnText = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, enteringNavbarEle.querySelector('.back-button-text'));
                        enteringBackBtnText.fromTo(TRANSLATEX, (plt.isRTL ? '-100px' : '100px'), '0px');
                        enteringNavBar.add(enteringBackBtnText);
                    }
                    else {
                        enteringBackButton.beforeRemoveClass(SHOW_BACK_BTN_CSS);
                    }
                }
            }
        }
        // Setup leaving view.
        if (leavingView && leavingView.pageRef()) {
            // Leaving content.
            var leavingPageEle = leavingView.pageRef().nativeElement;
            var leavingContent = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, leavingPageEle);
            this.add(leavingContent);
            if (backDirection) {
                // Leaving content, back direction.
                leavingContent
                    .beforeClearStyles([OPACITY])
                    .fromTo(TRANSLATEX, CENTER, (plt.isRTL ? '-100%' : '100%'));
            }
            else {
                // Leaving content, forward direction.
                leavingContent
                    .fromTo(TRANSLATEX, CENTER, OFF_LEFT)
                    .fromTo(OPACITY, 1, OFF_OPACITY)
                    .afterClearStyles([TRANSFORM, OPACITY]);
            }
            if (leavingHasNavbar) {
                // Leaving page has a navbar.
                var leavingNavbarEle = leavingPageEle.querySelector('ion-navbar');
                var leavingNavBar = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, leavingNavbarEle);
                var leavingBackButton = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, leavingNavbarEle.querySelector('.back-button'));
                leavingNavBar
                    .add(leavingBackButton);
                this.add(leavingNavBar);
                // Fade out leaving navbar items.
                leavingBackButton.fromTo(OPACITY, 0.99, 0);
                if (backDirection) {
                    var leavingBackBtnText = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](plt, leavingNavbarEle.querySelector('.back-button-text'));
                    leavingBackBtnText.fromTo(TRANSLATEX, CENTER, (plt.isRTL ? -300 : 300) + 'px');
                    leavingNavBar.add(leavingBackBtnText);
                }
                else {
                    // Leaving navbar, forward direction.
                    leavingBackButton.afterClearStyles([OPACITY]);
                }
            }
        }
    };
    return CorePageTransition;
}(__WEBPACK_IMPORTED_MODULE_2_ionic_angular_transitions_page_transition__["a" /* PageTransition */]));

//# sourceMappingURL=page-transition.js.map

/***/ }),
/* 1732 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreModalLateralTransition; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular_transitions_page_transition__ = __webpack_require__(141);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Sliding transition for lateral modals.
 */
var CoreModalLateralTransition = /** @class */ (function (_super) {
    __extends(CoreModalLateralTransition, _super);
    function CoreModalLateralTransition() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Animation.
     */
    CoreModalLateralTransition.prototype.init = function () {
        var enteringView = this.enteringView;
        var leavingView = this.leavingView;
        var plt = this.plt;
        var OFF_RIGHT = plt.isRTL ? '-100%' : '100%';
        if (enteringView && enteringView.pageRef()) {
            var ele = enteringView.pageRef().nativeElement;
            var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](this.plt, ele.querySelector('.modal-wrapper'));
            var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](this.plt, ele.querySelector('ion-backdrop'));
            wrapper.beforeStyles({ transform: 'translateX(' + OFF_RIGHT + ')', opacity: 0.8 });
            wrapper.fromTo('transform', 'translateX(' + OFF_RIGHT + ')', 'translateX(0)');
            wrapper.fromTo('opacity', 0.8, 1);
            backdrop.fromTo('opacity', 0.01, 0.4);
            this
                .element(enteringView.pageRef())
                .duration(300)
                .easing('cubic-bezier(0.36,0.66,0.04,1)')
                .add(wrapper)
                .add(backdrop);
        }
        if (leavingView && leavingView.pageRef()) {
            var ele = this.leavingView.pageRef().nativeElement;
            var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](this.plt, ele.querySelector('.modal-wrapper'));
            var contentWrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](this.plt, ele.querySelector('.wrapper'));
            var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular_animations_animation__["a" /* Animation */](this.plt, ele.querySelector('ion-backdrop'));
            wrapper.beforeStyles({ transform: 'translateX(0)', opacity: 1 });
            wrapper.fromTo('transform', 'translateX(0)', 'translateX(' + OFF_RIGHT + ')');
            wrapper.fromTo('opacity', 1, 0.8);
            contentWrapper.fromTo('opacity', 1, 0);
            backdrop.fromTo('opacity', 0.4, 0);
            this
                .element(leavingView.pageRef())
                .duration(300)
                .easing('cubic-bezier(0.36,0.66,0.04,1)')
                .add(contentWrapper)
                .add(wrapper)
                .add(backdrop);
        }
    };
    return CoreModalLateralTransition;
}(__WEBPACK_IMPORTED_MODULE_1_ionic_angular_transitions_page_transition__["a" /* PageTransition */]));

//# sourceMappingURL=modal-lateral-transition.js.map

/***/ }),
/* 1733 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSettingsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_delegate__ = __webpack_require__(223);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_helper__ = __webpack_require__(989);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var CoreSettingsModule = /** @class */ (function () {
    function CoreSettingsModule() {
    }
    CoreSettingsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__directives_directives_module__["a" /* CoreDirectivesModule */],
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_delegate__["a" /* CoreSettingsDelegate */],
                __WEBPACK_IMPORTED_MODULE_3__providers_helper__["a" /* CoreSettingsHelper */]
            ]
        })
    ], CoreSettingsModule);
    return CoreSettingsModule;
}());

//# sourceMappingURL=settings.module.js.map

/***/ }),
/* 1734 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export CORE_SITEPLUGINS_PROVIDERS */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_helper__ = __webpack_require__(1735);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(990);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




// List of providers.
var CORE_SITEPLUGINS_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_1__providers_siteplugins__["a" /* CoreSitePluginsProvider */],
    __WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreSitePluginsHelperProvider */]
];
var CoreSitePluginsModule = /** @class */ (function () {
    function CoreSitePluginsModule(helper) {
        // Inject the helper even if it isn't used so it's instantiated.
    }
    CoreSitePluginsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* CoreSitePluginsComponentsModule */]
            ],
            providers: CORE_SITEPLUGINS_PROVIDERS
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_helper__["a" /* CoreSitePluginsHelperProvider */]])
    ], CoreSitePluginsModule);
    return CoreSitePluginsModule;
}());

//# sourceMappingURL=siteplugins.module.js.map

/***/ }),
/* 1735 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsHelperProvider; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_http__ = __webpack_require__(124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_lang__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_logger__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_utils_url__ = __webpack_require__(40);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__siteplugins__ = __webpack_require__(45);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_compile_providers_compile__ = __webpack_require__(353);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__core_course_providers_format_delegate__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__core_user_providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__core_settings_providers_delegate__ = __webpack_require__(223);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__addon_messageoutput_providers_delegate__ = __webpack_require__(286);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__addon_mod_quiz_providers_access_rules_delegate__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__addon_mod_assign_providers_feedback_delegate__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__addon_mod_assign_providers_submission_delegate__ = __webpack_require__(107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__addon_mod_workshop_providers_assessment_strategy_delegate__ = __webpack_require__(129);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__classes_handlers_course_format_handler__ = __webpack_require__(1736);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__classes_handlers_course_option_handler__ = __webpack_require__(1737);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__classes_handlers_module_handler__ = __webpack_require__(1738);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__classes_handlers_module_prefetch_handler__ = __webpack_require__(1739);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__classes_handlers_main_menu_handler__ = __webpack_require__(1740);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__classes_handlers_user_handler__ = __webpack_require__(1741);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__classes_handlers_user_profile_field_handler__ = __webpack_require__(1742);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__classes_handlers_settings_handler__ = __webpack_require__(1743);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__classes_handlers_question_handler__ = __webpack_require__(1744);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__classes_handlers_question_behaviour_handler__ = __webpack_require__(1745);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__classes_handlers_message_output_handler__ = __webpack_require__(1746);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__classes_handlers_quiz_access_rule_handler__ = __webpack_require__(1747);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_44__classes_handlers_assign_feedback_handler__ = __webpack_require__(1748);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_45__classes_handlers_assign_submission_handler__ = __webpack_require__(1749);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_46__classes_handlers_workshop_assessment_strategy_handler__ = __webpack_require__(1750);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_47__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_48__core_siteplugins_classes_handlers_block_handler__ = __webpack_require__(1751);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

















// Delegates















// Handler classes.

















/**
 * Helper service to provide functionalities regarding site plugins. It basically has the features to load and register site
 * plugin.
 *
 * This code is split from CoreSitePluginsProvider to prevent circular dependencies.
 *
 * @todo: Support ViewChild and similar in site plugins. Possible solution: make components and directives inject the instance
 * inside the host DOM element?
 */
var CoreSitePluginsHelperProvider = /** @class */ (function () {
    function CoreSitePluginsHelperProvider(logger, sitesProvider, domUtils, mainMenuDelegate, moduleDelegate, userDelegate, langProvider, http, sitePluginsProvider, prefetchDelegate, compileProvider, utils, urlUtils, courseOptionsDelegate, eventsProvider, courseFormatDelegate, profileFieldDelegate, textUtils, filepoolProvider, settingsDelegate, questionDelegate, questionBehaviourDelegate, questionProvider, messageOutputDelegate, accessRulesDelegate, assignSubmissionDelegate, translate, assignFeedbackDelegate, appProvider, workshopAssessmentStrategyDelegate, courseProvider, blockDelegate) {
        var _this = this;
        this.sitesProvider = sitesProvider;
        this.domUtils = domUtils;
        this.mainMenuDelegate = mainMenuDelegate;
        this.moduleDelegate = moduleDelegate;
        this.userDelegate = userDelegate;
        this.langProvider = langProvider;
        this.http = http;
        this.sitePluginsProvider = sitePluginsProvider;
        this.prefetchDelegate = prefetchDelegate;
        this.compileProvider = compileProvider;
        this.utils = utils;
        this.urlUtils = urlUtils;
        this.courseOptionsDelegate = courseOptionsDelegate;
        this.courseFormatDelegate = courseFormatDelegate;
        this.profileFieldDelegate = profileFieldDelegate;
        this.textUtils = textUtils;
        this.filepoolProvider = filepoolProvider;
        this.settingsDelegate = settingsDelegate;
        this.questionDelegate = questionDelegate;
        this.questionBehaviourDelegate = questionBehaviourDelegate;
        this.questionProvider = questionProvider;
        this.messageOutputDelegate = messageOutputDelegate;
        this.accessRulesDelegate = accessRulesDelegate;
        this.assignSubmissionDelegate = assignSubmissionDelegate;
        this.translate = translate;
        this.assignFeedbackDelegate = assignFeedbackDelegate;
        this.appProvider = appProvider;
        this.workshopAssessmentStrategyDelegate = workshopAssessmentStrategyDelegate;
        this.courseProvider = courseProvider;
        this.blockDelegate = blockDelegate;
        this.logger = logger.getInstance('CoreSitePluginsHelperProvider');
        // Fetch the plugins on login.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].LOGIN, function (data) {
            _this.fetchSitePlugins(data.siteId).then(function (plugins) {
                // Plugins fetched, check that site hasn't changed.
                if (data.siteId == _this.sitesProvider.getCurrentSiteId() && plugins.length) {
                    // Site is still the same. Load the plugins and trigger the event.
                    _this.loadSitePlugins(plugins).catch(function (error) {
                        _this.logger.error(error);
                    }).finally(function () {
                        eventsProvider.trigger(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].SITE_PLUGINS_LOADED, {}, data.siteId);
                    });
                }
            }).finally(function () {
                _this.sitePluginsProvider.setPluginsFetched();
            });
        });
        // Unload plugins on logout if any.
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function () {
            if (_this.sitePluginsProvider.hasSitePluginsLoaded) {
                // Temporary fix. Reload the page to unload all plugins.
                window.location.reload();
            }
        });
    }
    /**
     * Download the styles for a handler (if any).
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {string} [siteId] Site ID. If not provided, current site.
     * @return {Promise<string>} Promise resolved with the CSS code.
     */
    CoreSitePluginsHelperProvider.prototype.downloadStyles = function (plugin, handlerName, handlerSchema, siteId) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            // Get the absolute URL. If it's a relative URL, add the site URL to it.
            var url = handlerSchema.styles && handlerSchema.styles.url;
            if (url && !_this.urlUtils.isAbsoluteURL(url)) {
                url = _this.textUtils.concatenatePaths(site.getURL(), url);
            }
            var uniqueName = _this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), componentId = uniqueName + '#main';
            // Remove the CSS files for this handler that aren't used anymore. Don't block the call for this.
            _this.filepoolProvider.getFilesByComponent(site.id, __WEBPACK_IMPORTED_MODULE_13__siteplugins__["a" /* CoreSitePluginsProvider */].COMPONENT, componentId).then(function (files) {
                files.forEach(function (file) {
                    if (file.url != url) {
                        // It's not the current file, delete it.
                        _this.filepoolProvider.removeFileByUrl(site.id, file.url).catch(function () {
                            // Ignore errors.
                        });
                    }
                });
            }).catch(function () {
                // Ignore errors.
            });
            if (!url) {
                // No styles.
                return '';
            }
            // Download the file if not downloaded or the version changed.
            return _this.filepoolProvider.downloadUrl(site.id, url, false, __WEBPACK_IMPORTED_MODULE_13__siteplugins__["a" /* CoreSitePluginsProvider */].COMPONENT, componentId, 0, undefined, undefined, undefined, handlerSchema.styles.version).then(function (url) {
                // File is downloaded, get the contents.
                return _this.http.get(url).toPromise();
            }).then(function (response) {
                var text = response && response.text();
                if (typeof text == 'string') {
                    return text;
                }
                else {
                    return Promise.reject(null);
                }
            });
        });
    };
    /**
     * Execute a handler's init method if it has any.
     *
     * @param {any} plugin Data of the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {Promise<any>} Promise resolved when done. It returns the results of the getContent call and the data returned by
     *                        the init JS (if any).
     */
    CoreSitePluginsHelperProvider.prototype.executeHandlerInit = function (plugin, handlerSchema) {
        if (!handlerSchema.init) {
            return Promise.resolve({});
        }
        return this.executeMethodAndJS(plugin, handlerSchema.init, true);
    };
    /**
     * Execute a get_content method and run its javascript (if any).
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} method The method to call.
     * @param {boolean} [isInit] Whether it's the init method.
     * @return {Promise<any>} Promise resolved when done. It returns the results of the getContent call and the data returned by
     *                        the JS (if any).
     */
    CoreSitePluginsHelperProvider.prototype.executeMethodAndJS = function (plugin, method, isInit) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId(), preSets = {
            getFromCache: false,
            deleteCacheIfWSError: isInit // If the init WS call returns an exception we won't use cached data.
        };
        return this.sitePluginsProvider.getContent(plugin.component, method, {}, preSets).then(function (result) {
            if (!result.javascript || _this.sitesProvider.getCurrentSiteId() != siteId) {
                // No javascript or site has changed, stop.
                return result;
            }
            // Create a "fake" instance to hold all the libraries.
            var instance = {};
            _this.compileProvider.injectLibraries(instance);
            // Add some data of the WS call result.
            var jsData = _this.sitePluginsProvider.createDataForJS(result);
            for (var name_1 in jsData) {
                instance[name_1] = jsData[name_1];
            }
            // Now execute the javascript using this instance.
            result.jsResult = _this.compileProvider.executeJavascript(instance, result.javascript);
            return result;
        });
    };
    /**
     * Fetch site plugins.
     *
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {Promise<any[]>} Promise resolved when done. Returns the list of plugins to load.
     */
    CoreSitePluginsHelperProvider.prototype.fetchSitePlugins = function (siteId) {
        var _this = this;
        var plugins = [];
        return this.sitesProvider.getSite(siteId).then(function (site) {
            if (!_this.sitePluginsProvider.isGetContentAvailable(site)) {
                // Cannot load site plugins, so there's no point to fetch them.
                return plugins;
            }
            // Get the list of plugins. Try not to use cache.
            return site.read('tool_mobile_get_plugins_supporting_mobile', {}, { getFromCache: false }).then(function (data) {
                data.plugins.forEach(function (plugin) {
                    // Check if it's a site plugin and it's enabled.
                    if (_this.isSitePluginEnabled(plugin, site)) {
                        plugins.push(plugin);
                    }
                });
                return plugins;
            });
        });
    };
    /**
     * Given an addon name, return the prefix to add to its string keys.
     *
     * @param {string} addon Name of the addon (plugin.addon).
     * @return {string} Prefix.
     */
    CoreSitePluginsHelperProvider.prototype.getPrefixForStrings = function (addon) {
        if (addon) {
            return 'plugin.' + addon + '.';
        }
        return '';
    };
    /**
     * Given an addon name and the key of a string, return the full string key (prefixed).
     *
     * @param {string} addon Name of the addon (plugin.addon).
     * @param {string} key The key of the string.
     * @return {string} Full string key.
     */
    CoreSitePluginsHelperProvider.prototype.getPrefixedString = function (addon, key) {
        return this.getPrefixForStrings(addon) + key;
    };
    /**
     * Check if a certain plugin is a site plugin and it's enabled in a certain site.
     *
     * @param {any} plugin Data of the plugin.
     * @param {CoreSite} site Site affected.
     * @return {boolean} Whether it's a site plugin and it's enabled.
     */
    CoreSitePluginsHelperProvider.prototype.isSitePluginEnabled = function (plugin, site) {
        if (!site.isFeatureDisabled('sitePlugin_' + plugin.component + '_' + plugin.addon) && plugin.handlers) {
            // Site plugin not disabled. Check if it has handlers.
            if (!plugin.parsedHandlers) {
                plugin.parsedHandlers = this.textUtils.parseJSON(plugin.handlers, null, this.logger.error.bind(this.logger, 'Error parsing site plugin handlers'));
            }
            return !!(plugin.parsedHandlers && Object.keys(plugin.parsedHandlers).length);
        }
        return false;
    };
    /**
     * Load the lang strings for a plugin.
     *
     * @param {any} plugin Data of the plugin.
     */
    CoreSitePluginsHelperProvider.prototype.loadLangStrings = function (plugin) {
        if (!plugin.parsedLang) {
            return;
        }
        for (var lang in plugin.parsedLang) {
            var prefix = this.getPrefixForStrings(plugin.addon);
            this.langProvider.addSitePluginsStrings(lang, plugin.parsedLang[lang], prefix);
        }
    };
    /**
     * Load a site plugin.
     *
     * @param {any} plugin Data of the plugin.
     * @return {Promise<any>} Promise resolved when loaded.
     */
    CoreSitePluginsHelperProvider.prototype.loadSitePlugin = function (plugin) {
        var promises = [];
        this.logger.debug('Load site plugin:', plugin);
        if (!plugin.parsedHandlers) {
            plugin.parsedHandlers = this.textUtils.parseJSON(plugin.handlers, null, this.logger.error.bind(this.logger, 'Error parsing site plugin handlers'));
        }
        if (!plugin.parsedLang && plugin.lang) {
            plugin.parsedLang = this.textUtils.parseJSON(plugin.lang, null, this.logger.error.bind(this.logger, 'Error parsing site plugin lang'));
        }
        this.sitePluginsProvider.hasSitePluginsLoaded = true;
        // Register lang strings.
        this.loadLangStrings(plugin);
        // Register all the handlers.
        for (var name_2 in plugin.parsedHandlers) {
            promises.push(this.registerHandler(plugin, name_2, plugin.parsedHandlers[name_2]));
        }
        return this.utils.allPromises(promises);
    };
    /**
     * Load site plugins.
     *
     * @param {any[]} plugins The plugins to load.
     * @return {Promise<any>} Promise resolved when loaded.
     */
    CoreSitePluginsHelperProvider.prototype.loadSitePlugins = function (plugins) {
        var _this = this;
        var promises = [];
        plugins.forEach(function (plugin) {
            var pluginPromise = _this.loadSitePlugin(plugin);
            promises.push(pluginPromise);
            _this.sitePluginsProvider.registerSitePluginPromise(plugin.component, pluginPromise);
        });
        return this.utils.allPromises(promises);
    };
    /**
     * Load the styles for a handler.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {string} fileUrl CSS file URL.
     * @param {string} cssCode CSS code.
     * @param {number} [version] Styles version.
     * @param {string} [siteId] Site ID. If not provided, current site.
     */
    CoreSitePluginsHelperProvider.prototype.loadStyles = function (plugin, handlerName, fileUrl, cssCode, version, siteId) {
        siteId = siteId || this.sitesProvider.getCurrentSiteId();
        // Create the style and add it to the header.
        var styleEl = document.createElement('style'), uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName);
        styleEl.setAttribute('id', 'siteplugin-' + uniqueName);
        styleEl.innerHTML = cssCode;
        document.head.appendChild(styleEl);
        // Styles have been loaded, now treat the CSS.
        this.filepoolProvider.treatCSSCode(siteId, fileUrl, cssCode, __WEBPACK_IMPORTED_MODULE_13__siteplugins__["a" /* CoreSitePluginsProvider */].COMPONENT, uniqueName, version)
            .catch(function () {
            // Ignore errors.
        });
    };
    /**
     * Register a site plugin handler in the right delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsHelperProvider.prototype.registerHandler = function (plugin, handlerName, handlerSchema) {
        var _this = this;
        // Wait for the init JS to be executed and for the styles to be downloaded.
        var promises = [], siteId = this.sitesProvider.getCurrentSiteId();
        var result, cssCode;
        promises.push(this.downloadStyles(plugin, handlerName, handlerSchema, siteId).then(function (code) {
            cssCode = code;
        }).catch(function (error) {
            _this.logger.error('Error getting styles for plugin', handlerName, handlerSchema, error);
        }));
        promises.push(this.executeHandlerInit(plugin, handlerSchema).then(function (initResult) {
            result = initResult;
        }));
        return Promise.all(promises).then(function () {
            if (cssCode) {
                // Load the styles.
                _this.loadStyles(plugin, handlerName, handlerSchema.styles.url, cssCode, handlerSchema.styles.version, siteId);
            }
            var promise;
            switch (handlerSchema.delegate) {
                case 'CoreMainMenuDelegate':
                    promise = Promise.resolve(_this.registerMainMenuHandler(plugin, handlerName, handlerSchema, result));
                    break;
                case 'CoreCourseModuleDelegate':
                    promise = Promise.resolve(_this.registerModuleHandler(plugin, handlerName, handlerSchema, result));
                    break;
                case 'CoreUserDelegate':
                    promise = Promise.resolve(_this.registerUserProfileHandler(plugin, handlerName, handlerSchema, result));
                    break;
                case 'CoreCourseOptionsDelegate':
                    promise = Promise.resolve(_this.registerCourseOptionHandler(plugin, handlerName, handlerSchema, result));
                    break;
                case 'CoreCourseFormatDelegate':
                    promise = Promise.resolve(_this.registerCourseFormatHandler(plugin, handlerName, handlerSchema));
                    break;
                case 'CoreUserProfileFieldDelegate':
                    promise = Promise.resolve(_this.registerUserProfileFieldHandler(plugin, handlerName, handlerSchema));
                    break;
                case 'CoreSettingsDelegate':
                    promise = Promise.resolve(_this.registerSettingsHandler(plugin, handlerName, handlerSchema, result));
                    break;
                case 'CoreQuestionDelegate':
                    promise = Promise.resolve(_this.registerQuestionHandler(plugin, handlerName, handlerSchema));
                    break;
                case 'CoreQuestionBehaviourDelegate':
                    promise = Promise.resolve(_this.registerQuestionBehaviourHandler(plugin, handlerName, handlerSchema));
                    break;
                case 'CoreBlockDelegate':
                    promise = Promise.resolve(_this.registerBlockHandler(plugin, handlerName, handlerSchema, result));
                    break;
                case 'AddonMessageOutputDelegate':
                    promise = Promise.resolve(_this.registerMessageOutputHandler(plugin, handlerName, handlerSchema, result));
                    break;
                case 'AddonModQuizAccessRuleDelegate':
                    promise = Promise.resolve(_this.registerQuizAccessRuleHandler(plugin, handlerName, handlerSchema));
                    break;
                case 'AddonModAssignFeedbackDelegate':
                    promise = Promise.resolve(_this.registerAssignFeedbackHandler(plugin, handlerName, handlerSchema));
                    break;
                case 'AddonModAssignSubmissionDelegate':
                    promise = Promise.resolve(_this.registerAssignSubmissionHandler(plugin, handlerName, handlerSchema));
                    break;
                case 'AddonWorkshopAssessmentStrategyDelegate':
                    promise = Promise.resolve(_this.registerWorkshopAssessmentStrategyHandler(plugin, handlerName, handlerSchema));
                    break;
                default:
                    // Nothing to do.
                    promise = Promise.resolve();
            }
            return promise.then(function (uniqueName) {
                if (uniqueName) {
                    // Store the handler data.
                    _this.sitePluginsProvider.setSitePluginHandler(uniqueName, {
                        plugin: plugin,
                        handlerName: handlerName,
                        handlerSchema: handlerSchema,
                        initResult: result
                    });
                }
            });
        }).catch(function (err) {
            return Promise.reject('Error executing init method ' + handlerSchema.init + ': ' + err.message);
        });
    };
    /**
     * Register a handler that relies in a "componentInit" function in a certain delegate.
     * These type of handlers will return a generic template and its JS in the main method, so it will be called
     * before registering the handler.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerComponentInitHandler = function (plugin, handlerName, handlerSchema, delegate, createHandlerFn) {
        var _this = this;
        if (!handlerSchema.method) {
            // Required data not provided, stop.
            this.logger.warn('Ignore site plugin because it doesn\'t provide method', plugin, handlerSchema);
            return;
        }
        this.logger.debug('Register site plugin', plugin, handlerSchema);
        // Execute the main method and its JS. The template returned will be used in the right component.
        return this.executeMethodAndJS(plugin, handlerSchema.method).then(function (result) {
            // Create and register the handler.
            var uniqueName = _this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), handler = createHandlerFn(uniqueName, result);
            // Store in handlerSchema some data required by the component.
            handlerSchema.methodTemplates = result.templates;
            handlerSchema.methodJSResult = result.jsResult;
            handlerSchema.methodOtherdata = result.otherdata;
            if (result && result.jsResult) {
                // Override default handler functions with the result of the method JS.
                for (var property in handler) {
                    if (property != 'constructor' && typeof handler[property] == 'function' &&
                        typeof result.jsResult[property] == 'function') {
                        handler[property] = result.jsResult[property].bind(handler);
                    }
                }
            }
            delegate.registerHandler(handler);
            return uniqueName;
        }).catch(function (err) {
            _this.logger.error('Error executing main method', plugin.component, handlerSchema.method, err);
        });
    };
    /**
     * Given a handler in a plugin, register it in the assign feedback delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerAssignFeedbackHandler = function (plugin, handlerName, handlerSchema) {
        var _this = this;
        return this.registerComponentInitHandler(plugin, handlerName, handlerSchema, this.assignFeedbackDelegate, function (uniqueName, result) {
            var type = (handlerSchema.moodlecomponent || plugin.component).replace('assignfeedback_', ''), prefix = _this.getPrefixForStrings(plugin.addon);
            return new __WEBPACK_IMPORTED_MODULE_44__classes_handlers_assign_feedback_handler__["a" /* CoreSitePluginsAssignFeedbackHandler */](_this.translate, uniqueName, type, prefix);
        });
    };
    /**
     * Given a handler in a plugin, register it in the assign submission delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerAssignSubmissionHandler = function (plugin, handlerName, handlerSchema) {
        var _this = this;
        return this.registerComponentInitHandler(plugin, handlerName, handlerSchema, this.assignSubmissionDelegate, function (uniqueName, result) {
            var type = (handlerSchema.moodlecomponent || plugin.component).replace('assignsubmission_', ''), prefix = _this.getPrefixForStrings(plugin.addon);
            return new __WEBPACK_IMPORTED_MODULE_45__classes_handlers_assign_submission_handler__["a" /* CoreSitePluginsAssignSubmissionHandler */](_this.translate, uniqueName, type, prefix);
        });
    };
    /**
     * Given a handler in a plugin, register it in the block delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {any} initResult Result of init function.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerBlockHandler = function (plugin, handlerName, handlerSchema, initResult) {
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), blockName = (handlerSchema.moodlecomponent || plugin.component).replace('block_', '');
        this.blockDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_48__core_siteplugins_classes_handlers_block_handler__["a" /* CoreSitePluginsBlockHandler */](uniqueName, blockName, handlerSchema, initResult));
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the course format delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string} A string to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerCourseFormatHandler = function (plugin, handlerName, handlerSchema) {
        this.logger.debug('Register site plugin in course format delegate:', plugin, handlerSchema);
        // Create and register the handler.
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), formatName = (handlerSchema.moodlecomponent || plugin.component).replace('format_', '');
        this.courseFormatDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_32__classes_handlers_course_format_handler__["a" /* CoreSitePluginsCourseFormatHandler */](uniqueName, formatName, handlerSchema));
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the course options delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {any} initResult Result of the init WS call.
     * @return {string} A string to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerCourseOptionHandler = function (plugin, handlerName, handlerSchema, initResult) {
        if (!handlerSchema.displaydata) {
            // Required data not provided, stop.
            this.logger.warn('Ignore site plugin because it doesn\'t provide displaydata', plugin, handlerSchema);
            return;
        }
        this.logger.debug('Register site plugin in course option delegate:', plugin, handlerSchema, initResult);
        // Create and register the handler.
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), prefixedTitle = this.getPrefixedString(plugin.addon, handlerSchema.displaydata.title);
        this.courseOptionsDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_33__classes_handlers_course_option_handler__["a" /* CoreSitePluginsCourseOptionHandler */](uniqueName, prefixedTitle, plugin, handlerSchema, initResult, this.sitePluginsProvider));
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the main menu delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {any} initResult Result of the init WS call.
     * @return {string} A string to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerMainMenuHandler = function (plugin, handlerName, handlerSchema, initResult) {
        if (!handlerSchema.displaydata) {
            // Required data not provided, stop.
            this.logger.warn('Ignore site plugin because it doesn\'t provide displaydata', plugin, handlerSchema);
            return;
        }
        this.logger.debug('Register site plugin in main menu delegate:', plugin, handlerSchema, initResult);
        // Create and register the handler.
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), prefixedTitle = this.getPrefixedString(plugin.addon, handlerSchema.displaydata.title);
        this.mainMenuDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_36__classes_handlers_main_menu_handler__["a" /* CoreSitePluginsMainMenuHandler */](uniqueName, prefixedTitle, plugin, handlerSchema, initResult));
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the message output delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {any} initResult Result of the init WS call.
     * @return {string} A string to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerMessageOutputHandler = function (plugin, handlerName, handlerSchema, initResult) {
        if (!handlerSchema.displaydata) {
            // Required data not provided, stop.
            this.logger.warn('Ignore site plugin because it doesn\'t provide displaydata', plugin, handlerSchema);
            return;
        }
        this.logger.debug('Register site plugin in message output delegate:', plugin, handlerSchema, initResult);
        // Create and register the handler.
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), prefixedTitle = this.getPrefixedString(plugin.addon, handlerSchema.displaydata.title), processorName = (handlerSchema.moodlecomponent || plugin.component).replace('message_', '');
        this.messageOutputDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_42__classes_handlers_message_output_handler__["a" /* CoreSitePluginsMessageOutputHandler */](uniqueName, processorName, prefixedTitle, plugin, handlerSchema, initResult));
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the module delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {any} initResult Result of the init WS call.
     * @return {string} A string to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerModuleHandler = function (plugin, handlerName, handlerSchema, initResult) {
        if (!handlerSchema.displaydata) {
            // Required data not provided, stop.
            this.logger.warn('Ignore site plugin because it doesn\'t provide displaydata', plugin, handlerSchema);
            return;
        }
        this.logger.debug('Register site plugin in module delegate:', plugin, handlerSchema, initResult);
        // Create and register the handler.
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), modName = (handlerSchema.moodlecomponent || plugin.component).replace('mod_', '');
        this.moduleDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_34__classes_handlers_module_handler__["a" /* CoreSitePluginsModuleHandler */](uniqueName, modName, handlerSchema, initResult));
        if (handlerSchema.offlinefunctions && Object.keys(handlerSchema.offlinefunctions).length) {
            // Register the prefetch handler.
            this.prefetchDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_35__classes_handlers_module_prefetch_handler__["a" /* CoreSitePluginsModulePrefetchHandler */](this.translate, this.appProvider, this.utils, this.courseProvider, this.filepoolProvider, this.sitesProvider, this.domUtils, this.sitePluginsProvider, plugin.component, uniqueName, modName, handlerSchema));
        }
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the question delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerQuestionHandler = function (plugin, handlerName, handlerSchema) {
        return this.registerComponentInitHandler(plugin, handlerName, handlerSchema, this.questionDelegate, function (uniqueName, result) {
            return new __WEBPACK_IMPORTED_MODULE_40__classes_handlers_question_handler__["a" /* CoreSitePluginsQuestionHandler */](uniqueName, handlerSchema.moodlecomponent || plugin.component);
        });
    };
    /**
     * Given a handler in a plugin, register it in the question behaviour delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerQuestionBehaviourHandler = function (plugin, handlerName, handlerSchema) {
        var _this = this;
        return this.registerComponentInitHandler(plugin, handlerName, handlerSchema, this.questionBehaviourDelegate, function (uniqueName, result) {
            var type = (handlerSchema.moodlecomponent || plugin.component).replace('qbehaviour_', '');
            return new __WEBPACK_IMPORTED_MODULE_41__classes_handlers_question_behaviour_handler__["a" /* CoreSitePluginsQuestionBehaviourHandler */](_this.questionProvider, uniqueName, type, result.templates.length);
        });
    };
    /**
     * Given a handler in a plugin, register it in the quiz access rule delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerQuizAccessRuleHandler = function (plugin, handlerName, handlerSchema) {
        return this.registerComponentInitHandler(plugin, handlerName, handlerSchema, this.accessRulesDelegate, function (uniqueName, result) {
            return new __WEBPACK_IMPORTED_MODULE_43__classes_handlers_quiz_access_rule_handler__["a" /* CoreSitePluginsQuizAccessRuleHandler */](uniqueName, handlerSchema.moodlecomponent || plugin.component, result.templates.length);
        });
    };
    /**
     * Given a handler in a plugin, register it in the settings delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {any} initResult Result of the init WS call.
     * @return {string} A string to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerSettingsHandler = function (plugin, handlerName, handlerSchema, initResult) {
        if (!handlerSchema.displaydata) {
            // Required data not provided, stop.
            this.logger.warn('Ignore site plugin because it doesn\'t provide displaydata', plugin, handlerSchema);
            return;
        }
        this.logger.debug('Register site plugin in settings delegate:', plugin, handlerSchema, initResult);
        // Create and register the handler.
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), prefixedTitle = this.getPrefixedString(plugin.addon, handlerSchema.displaydata.title);
        this.settingsDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_39__classes_handlers_settings_handler__["a" /* CoreSitePluginsSettingsHandler */](uniqueName, prefixedTitle, plugin, handlerSchema, initResult));
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the user profile delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @param {any} initResult Result of the init WS call.
     * @return {string} A string to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerUserProfileHandler = function (plugin, handlerName, handlerSchema, initResult) {
        if (!handlerSchema.displaydata) {
            // Required data not provided, stop.
            this.logger.warn('Ignore site plugin because it doesn\'t provide displaydata', plugin, handlerSchema);
            return;
        }
        this.logger.debug('Register site plugin in user profile delegate:', plugin, handlerSchema, initResult);
        // Create and register the handler.
        var uniqueName = this.sitePluginsProvider.getHandlerUniqueName(plugin, handlerName), prefixedTitle = this.getPrefixedString(plugin.addon, handlerSchema.displaydata.title);
        this.userDelegate.registerHandler(new __WEBPACK_IMPORTED_MODULE_37__classes_handlers_user_handler__["a" /* CoreSitePluginsUserProfileHandler */](uniqueName, prefixedTitle, plugin, handlerSchema, initResult, this.sitePluginsProvider));
        return uniqueName;
    };
    /**
     * Given a handler in a plugin, register it in the user profile field delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerUserProfileFieldHandler = function (plugin, handlerName, handlerSchema) {
        return this.registerComponentInitHandler(plugin, handlerName, handlerSchema, this.profileFieldDelegate, function (uniqueName, result) {
            var fieldType = (handlerSchema.moodlecomponent || plugin.component).replace('profilefield_', '');
            return new __WEBPACK_IMPORTED_MODULE_38__classes_handlers_user_profile_field_handler__["a" /* CoreSitePluginsUserProfileFieldHandler */](uniqueName, fieldType);
        });
    };
    /**
     * Given a handler in a plugin, register it in the workshop assessment strategy delegate.
     *
     * @param {any} plugin Data of the plugin.
     * @param {string} handlerName Name of the handler in the plugin.
     * @param {any} handlerSchema Data about the handler.
     * @return {string|Promise<string>} A string (or a promise resolved with a string) to identify the handler.
     */
    CoreSitePluginsHelperProvider.prototype.registerWorkshopAssessmentStrategyHandler = function (plugin, handlerName, handlerSchema) {
        return this.registerComponentInitHandler(plugin, handlerName, handlerSchema, this.workshopAssessmentStrategyDelegate, function (uniqueName, result) {
            var strategyName = (handlerSchema.moodlecomponent || plugin.component).replace('workshopform_', '');
            return new __WEBPACK_IMPORTED_MODULE_46__classes_handlers_workshop_assessment_strategy_handler__["a" /* CoreSitePluginsWorkshopAssessmentStrategyHandler */](uniqueName, strategyName);
        });
    };
    CoreSitePluginsHelperProvider = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_7__providers_logger__["a" /* CoreLoggerProvider */], __WEBPACK_IMPORTED_MODULE_8__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_9__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_17__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_18__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */],
            __WEBPACK_IMPORTED_MODULE_22__core_user_providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_lang__["a" /* CoreLangProvider */], __WEBPACK_IMPORTED_MODULE_1__angular_http__["b" /* Http */],
            __WEBPACK_IMPORTED_MODULE_13__siteplugins__["a" /* CoreSitePluginsProvider */], __WEBPACK_IMPORTED_MODULE_19__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */],
            __WEBPACK_IMPORTED_MODULE_14__core_compile_providers_compile__["a" /* CoreCompileProvider */], __WEBPACK_IMPORTED_MODULE_12__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_11__providers_utils_url__["a" /* CoreUrlUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_20__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_events__["a" /* CoreEventsProvider */],
            __WEBPACK_IMPORTED_MODULE_21__core_course_providers_format_delegate__["a" /* CoreCourseFormatDelegate */], __WEBPACK_IMPORTED_MODULE_23__core_user_providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */],
            __WEBPACK_IMPORTED_MODULE_10__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_filepool__["a" /* CoreFilepoolProvider */],
            __WEBPACK_IMPORTED_MODULE_24__core_settings_providers_delegate__["a" /* CoreSettingsDelegate */], __WEBPACK_IMPORTED_MODULE_25__core_question_providers_delegate__["a" /* CoreQuestionDelegate */],
            __WEBPACK_IMPORTED_MODULE_26__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_15__core_question_providers_question__["a" /* CoreQuestionProvider */],
            __WEBPACK_IMPORTED_MODULE_27__addon_messageoutput_providers_delegate__["a" /* AddonMessageOutputDelegate */], __WEBPACK_IMPORTED_MODULE_28__addon_mod_quiz_providers_access_rules_delegate__["a" /* AddonModQuizAccessRuleDelegate */],
            __WEBPACK_IMPORTED_MODULE_30__addon_mod_assign_providers_submission_delegate__["a" /* AddonModAssignSubmissionDelegate */], __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_29__addon_mod_assign_providers_feedback_delegate__["a" /* AddonModAssignFeedbackDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_app__["a" /* CoreAppProvider */],
            __WEBPACK_IMPORTED_MODULE_31__addon_mod_workshop_providers_assessment_strategy_delegate__["a" /* AddonWorkshopAssessmentStrategyDelegate */],
            __WEBPACK_IMPORTED_MODULE_16__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_47__core_block_providers_delegate__["a" /* CoreBlockDelegate */]])
    ], CoreSitePluginsHelperProvider);
    return CoreSitePluginsHelperProvider;
}());

//# sourceMappingURL=helper.js.map

/***/ }),
/* 1736 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCourseFormatHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_course_format_course_format__ = __webpack_require__(362);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to support a course format using a site plugin.
 */
var CoreSitePluginsCourseFormatHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsCourseFormatHandler, _super);
    function CoreSitePluginsCourseFormatHandler(name, format, handlerSchema) {
        var _this = _super.call(this, name) || this;
        _this.format = format;
        _this.handlerSchema = handlerSchema;
        return _this;
    }
    /**
     * Whether it allows seeing all sections at the same time. Defaults to true.
     *
     * @param {any} course The course to check.
     * @type {boolean} Whether it can view all sections.
     */
    CoreSitePluginsCourseFormatHandler.prototype.canViewAllSections = function (course) {
        return typeof this.handlerSchema.canviewallsections != 'undefined' ? this.handlerSchema.canviewallsections : true;
    };
    /**
     * Whether the option to enable section/module download should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @type {boolean} Whether the option to enable section/module download should be displayed.
     */
    CoreSitePluginsCourseFormatHandler.prototype.displayEnableDownload = function (course) {
        return typeof this.handlerSchema.displayenabledownload != 'undefined' ? this.handlerSchema.displayenabledownload : true;
    };
    /**
     * Whether the default section selector should be displayed. Defaults to true.
     *
     * @param {any} course The course to check.
     * @type {boolean} Whether the default section selector should be displayed.
     */
    CoreSitePluginsCourseFormatHandler.prototype.displaySectionSelector = function (course) {
        return typeof this.handlerSchema.displaysectionselector != 'undefined' ? this.handlerSchema.displaysectionselector : true;
    };
    /**
     * Return the Component to use to display the course format instead of using the default one.
     * Use it if you want to display a format completely different from the default one.
     * If you want to customize the default format there are several methods to customize parts of it.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsCourseFormatHandler.prototype.getCourseFormatComponent = function (injector, course) {
        if (this.handlerSchema.method) {
            return __WEBPACK_IMPORTED_MODULE_1__components_course_format_course_format__["a" /* CoreSitePluginsCourseFormatComponent */];
        }
    };
    return CoreSitePluginsCourseFormatHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=course-format-handler.js.map

/***/ }),
/* 1737 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsCourseOptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_course_option_course_option__ = __webpack_require__(361);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to display a site plugin in course options.
 */
var CoreSitePluginsCourseOptionHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsCourseOptionHandler, _super);
    function CoreSitePluginsCourseOptionHandler(name, title, plugin, handlerSchema, initResult, sitePluginsProvider) {
        var _this = _super.call(this, name) || this;
        _this.title = title;
        _this.plugin = plugin;
        _this.handlerSchema = handlerSchema;
        _this.initResult = initResult;
        _this.sitePluginsProvider = sitePluginsProvider;
        _this.priority = handlerSchema.priority;
        return _this;
    }
    /**
     * Whether or not the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    CoreSitePluginsCourseOptionHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        return this.sitePluginsProvider.isHandlerEnabledForCourse(courseId, this.handlerSchema.restricttoenrolledcourses, this.initResult.restrict);
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {Injector} injector Injector.
     * @param {number} courseId The course ID.
     * @return {CoreCourseOptionsHandlerData|Promise<CoreCourseOptionsHandlerData>} Data or promise resolved with the data.
     */
    CoreSitePluginsCourseOptionHandler.prototype.getDisplayData = function (injector, courseId) {
        return {
            title: this.title,
            class: this.handlerSchema.displaydata.class,
            component: __WEBPACK_IMPORTED_MODULE_1__components_course_option_course_option__["a" /* CoreSitePluginsCourseOptionComponent */],
            componentData: {
                handlerUniqueName: this.name
            }
        };
    };
    /**
     * Called when a course is downloaded. It should prefetch all the data to be able to see the plugin in offline.
     *
     * @param {any} course The course.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsCourseOptionHandler.prototype.prefetch = function (course) {
        var args = {
            courseid: course.id,
        }, component = this.plugin.component;
        return this.sitePluginsProvider.prefetchFunctions(component, args, this.handlerSchema, course.id, undefined, true);
    };
    return CoreSitePluginsCourseOptionHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=course-option-handler.js.map

/***/ }),
/* 1738 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_module_index_module_index__ = __webpack_require__(285);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to support a module using a site plugin.
 */
var CoreSitePluginsModuleHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsModuleHandler, _super);
    function CoreSitePluginsModuleHandler(name, modName, handlerSchema, initResult) {
        var _this = _super.call(this, name) || this;
        _this.modName = modName;
        _this.handlerSchema = handlerSchema;
        _this.initResult = initResult;
        _this.supportedFeatures = handlerSchema.supportedfeatures;
        if (initResult && initResult.jsResult && initResult.jsResult.supportsFeature) {
            // The init result defines a function to check if a feature is supported, use it.
            _this.supportsFeature = initResult.jsResult.supportsFeature.bind(initResult.jsResult);
        }
        return _this;
    }
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    CoreSitePluginsModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        var hasOffline = !!(this.handlerSchema.offlinefunctions && Object.keys(this.handlerSchema.offlinefunctions).length), showDowloadButton = this.handlerSchema.downloadbutton;
        return {
            title: module.name,
            icon: this.handlerSchema.displaydata.icon,
            class: this.handlerSchema.displaydata.class,
            showDownloadButton: typeof showDowloadButton != 'undefined' ? showDowloadButton : hasOffline,
            action: function (event, navCtrl, module, courseId, options) {
                event.preventDefault();
                event.stopPropagation();
                navCtrl.push('CoreSitePluginsModuleIndexPage', {
                    title: module.name,
                    module: module,
                    courseId: courseId
                }, options);
            }
        };
    };
    /**
     * Get the icon src for the module.
     *
     * @return {string} The icon src.
     */
    CoreSitePluginsModuleHandler.prototype.getIconSrc = function () {
        return this.handlerSchema.displaydata.icon;
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsModuleHandler.prototype.getMainComponent = function (injector, course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_module_index_module_index__["a" /* CoreSitePluginsModuleIndexComponent */];
    };
    return CoreSitePluginsModuleHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1739 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsModulePrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__core_course_classes_activity_prefetch_handler__ = __webpack_require__(81);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Handler to prefetch a module site plugin.
 */
var CoreSitePluginsModulePrefetchHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsModulePrefetchHandler, _super);
    function CoreSitePluginsModulePrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, sitePluginsProvider, component, name, modName, handlerSchema) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.sitePluginsProvider = sitePluginsProvider;
        _this.handlerSchema = handlerSchema;
        _this.ROOT_CACHE_KEY = 'CoreSitePluginsModulePrefetchHandler:';
        _this.component = component;
        _this.name = name;
        _this.modName = modName;
        _this.isResource = handlerSchema.isresource;
        if (handlerSchema.updatesnames) {
            try {
                _this.updatesNames = new RegExp(handlerSchema.updatesnames);
            }
            catch (ex) {
                // Ignore errors.
            }
        }
        return _this;
    }
    /**
     * Download the module.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when all content is downloaded.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.download = function (module, courseId, dirPath) {
        return this.prefetchPackage(module, courseId, false, this.downloadPrefetchPlugin.bind(this), undefined, false, dirPath);
    };
    /**
     * Download or prefetch the plugin, downloading the files and calling the needed WS.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.downloadPrefetchPlugin = function (module, courseId, single, siteId, prefetch, dirPath) {
        var _this = this;
        return this.sitesProvider.getSite(siteId).then(function (site) {
            var promises = [], args = {
                courseid: courseId,
                cmid: module.id,
                userid: site.getUserId()
            };
            // Download the files (if any).
            promises.push(_this.downloadOrPrefetchFiles(site.id, module, courseId, prefetch, dirPath));
            // Call all the offline functions.
            promises.push(_this.sitePluginsProvider.prefetchFunctions(_this.component, args, _this.handlerSchema, courseId, module, prefetch, dirPath, site));
            return Promise.all(promises);
        });
    };
    /**
     * Download or prefetch the plugin files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [prefetch] True to prefetch, false to download right away.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.downloadOrPrefetchFiles = function (siteId, module, courseId, prefetch, dirPath) {
        var _this = this;
        // Load module contents (ignore cache so we always have the latest data).
        return this.loadContents(module, courseId, true).then(function () {
            // Get the intro files.
            return _this.getIntroFiles(module, courseId);
        }).then(function (introFiles) {
            var contentFiles = _this.getContentDownloadableFiles(module), promises = [];
            if (dirPath) {
                // Download intro files in filepool root folder.
                promises.push(_this.filepoolProvider.downloadOrPrefetchFiles(siteId, introFiles, prefetch, false, _this.component, module.id));
                // Download content files inside dirPath.
                promises.push(_this.filepoolProvider.downloadOrPrefetchFiles(siteId, contentFiles, prefetch, false, _this.component, module.id, dirPath));
            }
            else {
                // No dirPath, download everything in filepool root folder.
                var files = introFiles.concat(contentFiles);
                promises.push(_this.filepoolProvider.downloadOrPrefetchFiles(siteId, files, prefetch, false, _this.component, module.id));
            }
            return Promise.all(promises);
        });
    };
    /**
     * Get the download size of a module.
     *
     * @param {any} module Module.
     * @param {Number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @return {Promise<{size: number, total: boolean}>} Promise resolved with the size and a boolean indicating if it was able
     *                                                   to calculate the total size.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.getDownloadSize = function (module, courseId, single) {
        // In most cases, to calculate the size we'll have to do all the WS calls. Just return unknown size.
        return Promise.resolve({ size: -1, total: false });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        var promises = [], currentSite = this.sitesProvider.getCurrentSite(), siteId = currentSite.getId(), args = {
            courseid: courseId,
            cmid: moduleId,
            userid: currentSite.getUserId()
        };
        // Invalidate files and the module.
        promises.push(this.filepoolProvider.invalidateFilesByComponent(siteId, this.component, moduleId));
        promises.push(this.courseProvider.invalidateModule(moduleId, siteId));
        // Also invalidate all the WS calls.
        for (var method in this.handlerSchema.offlinefunctions) {
            if (currentSite.wsAvailable(method)) {
                // The method is a WS.
                promises.push(currentSite.invalidateWsCacheForKey(this.sitePluginsProvider.getCallWSCacheKey(method, args)));
            }
            else {
                // It's a method to get content.
                promises.push(this.sitePluginsProvider.invalidateContent(this.component, method, args));
            }
        }
        return this.utils.allPromises(promises);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} A boolean, or a promise resolved with a boolean, indicating if the handler is enabled.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Load module contents into module.contents if they aren't loaded already.
     *
     * @param {any} module Module to load the contents.
     * @param {number} [courseId] The course ID. Recommended to speed up the process and minimize data usage.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise}           Promise resolved when loaded.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.loadContents = function (module, courseId, ignoreCache) {
        if (this.isResource) {
            return this.courseProvider.loadModuleContents(module, courseId, undefined, false, ignoreCache);
        }
        return Promise.resolve();
    };
    /**
     * Prefetch a module.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @param {boolean} [single] True if we're downloading a single module, false if we're downloading a whole section.
     * @param {string} [dirPath] Path of the directory where to store all the content files.
     * @return {Promise<any>} Promise resolved when done.
     */
    CoreSitePluginsModulePrefetchHandler.prototype.prefetch = function (module, courseId, single, dirPath) {
        return this.prefetchPackage(module, courseId, false, this.downloadPrefetchPlugin.bind(this), undefined, true, dirPath);
    };
    return CoreSitePluginsModulePrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_0__core_course_classes_activity_prefetch_handler__["a" /* CoreCourseActivityPrefetchHandlerBase */]));

//# sourceMappingURL=module-prefetch-handler.js.map

/***/ }),
/* 1740 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Handler to display a site plugin in the main menu.
 */
var CoreSitePluginsMainMenuHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsMainMenuHandler, _super);
    function CoreSitePluginsMainMenuHandler(name, title, plugin, handlerSchema, initResult) {
        var _this = _super.call(this, name) || this;
        _this.title = title;
        _this.plugin = plugin;
        _this.handlerSchema = handlerSchema;
        _this.initResult = initResult;
        _this.priority = handlerSchema.priority;
        return _this;
    }
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data.
     */
    CoreSitePluginsMainMenuHandler.prototype.getDisplayData = function () {
        return {
            title: this.title,
            icon: this.handlerSchema.displaydata.icon,
            class: this.handlerSchema.displaydata.class,
            page: 'CoreSitePluginsPluginPage',
            pageParams: {
                title: this.title,
                component: this.plugin.component,
                method: this.handlerSchema.method,
                initResult: this.initResult
            },
            onlyInMore: true
        };
    };
    return CoreSitePluginsMainMenuHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=main-menu-handler.js.map

/***/ }),
/* 1741 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsUserProfileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_handler__ = __webpack_require__(130);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to display a site plugin in the user profile.
 */
var CoreSitePluginsUserProfileHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsUserProfileHandler, _super);
    function CoreSitePluginsUserProfileHandler(name, title, plugin, handlerSchema, initResult, sitePluginsProvider) {
        var _this = _super.call(this, name) || this;
        _this.title = title;
        _this.plugin = plugin;
        _this.handlerSchema = handlerSchema;
        _this.initResult = initResult;
        _this.sitePluginsProvider = sitePluginsProvider;
        _this.priority = handlerSchema.priority;
        // Only support TYPE_COMMUNICATION and TYPE_NEW_PAGE.
        _this.type = handlerSchema.type != __WEBPACK_IMPORTED_MODULE_0__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_COMMUNICATION ?
            __WEBPACK_IMPORTED_MODULE_0__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_NEW_PAGE : __WEBPACK_IMPORTED_MODULE_0__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_COMMUNICATION;
        return _this;
    }
    /**
     * Whether or not the handler is enabled for a user.
     * @param  {any}     user       User object.
     * @param  {number}  courseId   Course ID where to show.
     * @param  {any}     [navOptions] Navigation options for the course.
     * @param  {any}     [admOptions] Admin options for the course.
     * @return {boolean|Promise<boolean>}            Whether or not the handler is enabled for a user.
     */
    CoreSitePluginsUserProfileHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        // First check if it's enabled for the user.
        var enabledForUser = this.sitePluginsProvider.isHandlerEnabledForUser(user.id, this.handlerSchema.restricttocurrentuser, this.initResult.restrict);
        if (!enabledForUser) {
            return false;
        }
        // Enabled for user, check if it's enabled for the course.
        return this.sitePluginsProvider.isHandlerEnabledForCourse(courseId, this.handlerSchema.restricttoenrolledcourses, this.initResult.restrict);
    };
    /**
     * Returns the data needed to render the handler.
     * @param  {any}     user       User object.
     * @param  {number}  courseId   Course ID where to show.
     * @return {CoreUserProfileHandlerData}    Data to be shown.
     */
    CoreSitePluginsUserProfileHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        return {
            title: this.title,
            icon: this.handlerSchema.displaydata.icon,
            class: this.handlerSchema.displaydata.class,
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                navCtrl.push('CoreSitePluginsPluginPage', {
                    title: _this.title,
                    component: _this.plugin.component,
                    method: _this.handlerSchema.method,
                    args: {
                        courseid: courseId,
                        userid: user.id
                    },
                    initResult: _this.initResult
                });
            }
        };
    };
    return CoreSitePluginsUserProfileHandler;
}(__WEBPACK_IMPORTED_MODULE_1__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1742 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsUserProfileFieldHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_user_profile_field_user_profile_field__ = __webpack_require__(365);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to display a site plugin in the user profile.
 */
var CoreSitePluginsUserProfileFieldHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsUserProfileFieldHandler, _super);
    function CoreSitePluginsUserProfileFieldHandler(name, type) {
        var _this = _super.call(this, name) || this;
        _this.type = type;
        return _this;
    }
    /**
     * Return the Component to use to display the user profile field.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsUserProfileFieldHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__components_user_profile_field_user_profile_field__["a" /* CoreSitePluginsUserProfileFieldComponent */];
    };
    /**
     * Get the data to send for the field based on the input data.
     * @param  {any}     field          User field to get the data for.
     * @param  {boolean} signup         True if user is in signup page.
     * @param  {string}  [registerAuth] Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form Values.
     * @return {Promise<CoreUserProfileFieldHandlerData>|CoreUserProfileFieldHandlerData}  Data to send for the field.
     */
    CoreSitePluginsUserProfileFieldHandler.prototype.getData = function (field, signup, registerAuth, formValues) {
        // No getData function implemented, use a default behaviour.
        var name = 'profile_field_' + field.shortname;
        return {
            type: field.type || field.datatype,
            name: name,
            value: formValues[name]
        };
    };
    return CoreSitePluginsUserProfileFieldHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=user-profile-field-handler.js.map

/***/ }),
/* 1743 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsSettingsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Handler to display a site plugin in the settings.
 */
var CoreSitePluginsSettingsHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsSettingsHandler, _super);
    function CoreSitePluginsSettingsHandler(name, title, plugin, handlerSchema, initResult) {
        var _this = _super.call(this, name) || this;
        _this.title = title;
        _this.plugin = plugin;
        _this.handlerSchema = handlerSchema;
        _this.initResult = initResult;
        _this.priority = handlerSchema.priority;
        return _this;
    }
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreSettingsHandlerData} Data.
     */
    CoreSitePluginsSettingsHandler.prototype.getDisplayData = function () {
        return {
            title: this.title,
            icon: this.handlerSchema.displaydata.icon,
            class: this.handlerSchema.displaydata.class,
            page: 'CoreSitePluginsPluginPage',
            params: {
                title: this.title,
                component: this.plugin.component,
                method: this.handlerSchema.method,
                initResult: this.initResult
            }
        };
    };
    return CoreSitePluginsSettingsHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=settings-handler.js.map

/***/ }),
/* 1744 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsQuestionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__core_question_classes_base_question_handler__ = __webpack_require__(789);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_question_question__ = __webpack_require__(363);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to display a question site plugin.
 */
var CoreSitePluginsQuestionHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsQuestionHandler, _super);
    function CoreSitePluginsQuestionHandler(name, type) {
        var _this = _super.call(this) || this;
        _this.name = name;
        _this.type = type;
        return _this;
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsQuestionHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__components_question_question__["a" /* CoreSitePluginsQuestionComponent */];
    };
    return CoreSitePluginsQuestionHandler;
}(__WEBPACK_IMPORTED_MODULE_0__core_question_classes_base_question_handler__["a" /* CoreQuestionBaseHandler */]));

//# sourceMappingURL=question-handler.js.map

/***/ }),
/* 1745 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsQuestionBehaviourHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__core_question_classes_base_behaviour_handler__ = __webpack_require__(791);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_question_behaviour_question_behaviour__ = __webpack_require__(364);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to display a question behaviour site plugin.
 */
var CoreSitePluginsQuestionBehaviourHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsQuestionBehaviourHandler, _super);
    function CoreSitePluginsQuestionBehaviourHandler(questionProvider, name, type, hasTemplate) {
        var _this = _super.call(this, questionProvider) || this;
        _this.name = name;
        _this.type = type;
        _this.hasTemplate = hasTemplate;
        return _this;
    }
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    CoreSitePluginsQuestionBehaviourHandler.prototype.handleQuestion = function (injector, question) {
        if (this.hasTemplate) {
            return [__WEBPACK_IMPORTED_MODULE_1__components_question_behaviour_question_behaviour__["a" /* CoreSitePluginsQuestionBehaviourComponent */]];
        }
    };
    return CoreSitePluginsQuestionBehaviourHandler;
}(__WEBPACK_IMPORTED_MODULE_0__core_question_classes_base_behaviour_handler__["a" /* CoreQuestionBehaviourBaseHandler */]));

//# sourceMappingURL=question-behaviour-handler.js.map

/***/ }),
/* 1746 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsMessageOutputHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * Handler to display a message output settings option.
 */
var CoreSitePluginsMessageOutputHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsMessageOutputHandler, _super);
    function CoreSitePluginsMessageOutputHandler(name, processorName, title, plugin, handlerSchema, initResult) {
        var _this = _super.call(this, name) || this;
        _this.processorName = processorName;
        _this.title = title;
        _this.plugin = plugin;
        _this.handlerSchema = handlerSchema;
        _this.initResult = initResult;
        return _this;
    }
    /**
     * Returns the data needed to render the handler.
     *
     * @return {AddonMessageOutputHandlerData} Data.
     */
    CoreSitePluginsMessageOutputHandler.prototype.getDisplayData = function () {
        return {
            priority: this.handlerSchema.priority,
            label: this.title,
            icon: this.handlerSchema.displaydata.icon,
            page: 'CoreSitePluginsPluginPage',
            pageParams: {
                title: this.title,
                component: this.plugin.component,
                method: this.handlerSchema.method,
                initResult: this.initResult
            }
        };
    };
    return CoreSitePluginsMessageOutputHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=message-output-handler.js.map

/***/ }),
/* 1747 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsQuizAccessRuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__components_quiz_access_rule_quiz_access_rule__ = __webpack_require__(366);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Handler to display a quiz access rule site plugin.
 */
var CoreSitePluginsQuizAccessRuleHandler = /** @class */ (function () {
    function CoreSitePluginsQuizAccessRuleHandler(name, ruleName, hasTemplate) {
        this.name = name;
        this.ruleName = ruleName;
        this.hasTemplate = hasTemplate;
    }
    /**
     * Whether the rule requires a preflight check when prefetch/start/continue an attempt.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {boolean|Promise<boolean>} Whether the rule requires a preflight check.
     */
    CoreSitePluginsQuizAccessRuleHandler.prototype.isPreflightCheckRequired = function (quiz, attempt, prefetch, siteId) {
        return this.hasTemplate;
    };
    /**
     * Add preflight data that doesn't require user interaction. The data should be added to the preflightData param.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} preflightData Object where to add the preflight data.
     * @param {any} [attempt] The attempt started/continued. If not supplied, user is starting a new attempt.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Promise resolved when done if async, void if it's synchronous.
     */
    CoreSitePluginsQuizAccessRuleHandler.prototype.getFixedPreflightData = function (quiz, preflightData, attempt, prefetch, siteId) {
        // Nothing to do.
    };
    /**
     * Return the Component to use to display the access rule preflight.
     * Implement this if your access rule requires a preflight check with user interaction.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsQuizAccessRuleHandler.prototype.getPreflightComponent = function (injector) {
        if (this.hasTemplate) {
            return __WEBPACK_IMPORTED_MODULE_0__components_quiz_access_rule_quiz_access_rule__["a" /* CoreSitePluginsQuizAccessRuleComponent */];
        }
    };
    /**
     * Function called when the preflight check has passed. This is a chance to record that fact in some way.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} attempt The attempt started/continued.
     * @param {any} preflightData Preflight data gathered.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Promise resolved when done if async, void if it's synchronous.
     */
    CoreSitePluginsQuizAccessRuleHandler.prototype.notifyPreflightCheckPassed = function (quiz, attempt, preflightData, prefetch, siteId) {
        // Nothing to do.
    };
    /**
     * Function called when the preflight check fails. This is a chance to record that fact in some way.
     *
     * @param {any} quiz The quiz the rule belongs to.
     * @param {any} attempt The attempt started/continued.
     * @param {any} preflightData Preflight data gathered.
     * @param {boolean} [prefetch] Whether the user is prefetching the quiz.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Promise resolved when done if async, void if it's synchronous.
     */
    CoreSitePluginsQuizAccessRuleHandler.prototype.notifyPreflightCheckFailed = function (quiz, attempt, preflightData, prefetch, siteId) {
        // Nothing to do.
    };
    /**
     * Whether or not the time left of an attempt should be displayed.
     *
     * @param {any} attempt The attempt.
     * @param {number} endTime The attempt end time (in seconds).
     * @param {number} timeNow The current time in seconds.
     * @return {boolean} Whether it should be displayed.
     */
    CoreSitePluginsQuizAccessRuleHandler.prototype.shouldShowTimeLeft = function (attempt, endTime, timeNow) {
        return false;
    };
    return CoreSitePluginsQuizAccessRuleHandler;
}());

//# sourceMappingURL=quiz-access-rule-handler.js.map

/***/ }),
/* 1748 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsAssignFeedbackHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__addon_mod_assign_classes_base_feedback_handler__ = __webpack_require__(768);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_assign_feedback_assign_feedback__ = __webpack_require__(367);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to display an assign feedback site plugin.
 */
var CoreSitePluginsAssignFeedbackHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsAssignFeedbackHandler, _super);
    function CoreSitePluginsAssignFeedbackHandler(translate, name, type, prefix) {
        var _this = _super.call(this, translate) || this;
        _this.name = name;
        _this.type = type;
        _this.prefix = prefix;
        return _this;
    }
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsAssignFeedbackHandler.prototype.getComponent = function (injector, plugin, edit) {
        return __WEBPACK_IMPORTED_MODULE_1__components_assign_feedback_assign_feedback__["a" /* CoreSitePluginsAssignFeedbackComponent */];
    };
    /**
     * Get a readable name to use for the plugin.
     *
     * @param {any} plugin The plugin object.
     * @return {string} The plugin name.
     */
    CoreSitePluginsAssignFeedbackHandler.prototype.getPluginName = function (plugin) {
        // Check if there's a translated string for the plugin.
        var translationId = this.prefix + 'pluginname', translation = this.translate.instant(translationId);
        if (translationId != translation) {
            // Translation found, use it.
            return translation;
        }
        // Fallback to WS string.
        if (plugin.name) {
            return plugin.name;
        }
    };
    return CoreSitePluginsAssignFeedbackHandler;
}(__WEBPACK_IMPORTED_MODULE_0__addon_mod_assign_classes_base_feedback_handler__["a" /* AddonModAssignBaseFeedbackHandler */]));

//# sourceMappingURL=assign-feedback-handler.js.map

/***/ }),
/* 1749 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsAssignSubmissionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__addon_mod_assign_classes_base_submission_handler__ = __webpack_require__(770);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_assign_submission_assign_submission__ = __webpack_require__(368);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to display an assign submission site plugin.
 */
var CoreSitePluginsAssignSubmissionHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsAssignSubmissionHandler, _super);
    function CoreSitePluginsAssignSubmissionHandler(translate, name, type, prefix) {
        var _this = _super.call(this, translate) || this;
        _this.name = name;
        _this.type = type;
        _this.prefix = prefix;
        return _this;
    }
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsAssignSubmissionHandler.prototype.getComponent = function (injector, plugin, edit) {
        return __WEBPACK_IMPORTED_MODULE_1__components_assign_submission_assign_submission__["a" /* CoreSitePluginsAssignSubmissionComponent */];
    };
    /**
     * Get a readable name to use for the plugin.
     *
     * @param {any} plugin The plugin object.
     * @return {string} The plugin name.
     */
    CoreSitePluginsAssignSubmissionHandler.prototype.getPluginName = function (plugin) {
        // Check if there's a translated string for the plugin.
        var translationId = this.prefix + 'pluginname', translation = this.translate.instant(translationId);
        if (translationId != translation) {
            // Translation found, use it.
            return translation;
        }
        // Fallback to WS string.
        if (plugin.name) {
            return plugin.name;
        }
    };
    /**
     * Whether or not the handler is enabled for edit on a site level.
     *
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled for edit on a site level.
     */
    CoreSitePluginsAssignSubmissionHandler.prototype.isEnabledForEdit = function () {
        return true;
    };
    return CoreSitePluginsAssignSubmissionHandler;
}(__WEBPACK_IMPORTED_MODULE_0__addon_mod_assign_classes_base_submission_handler__["a" /* AddonModAssignBaseSubmissionHandler */]));

//# sourceMappingURL=assign-submission-handler.js.map

/***/ }),
/* 1750 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsWorkshopAssessmentStrategyHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__components_workshop_assessment_strategy_workshop_assessment_strategy__ = __webpack_require__(883);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Handler to display a workshop assessment strategy site plugin.
 */
var CoreSitePluginsWorkshopAssessmentStrategyHandler = /** @class */ (function () {
    function CoreSitePluginsWorkshopAssessmentStrategyHandler(name, strategyName) {
        this.name = name;
        this.strategyName = strategyName;
    }
    /**
     * Return the Component to use to display the plugin data, either in read or in edit mode.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} plugin The plugin object.
     * @param {boolean} [edit] Whether the user is editing.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    CoreSitePluginsWorkshopAssessmentStrategyHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_0__components_workshop_assessment_strategy_workshop_assessment_strategy__["a" /* CoreSitePluginsWorkshopAssessmentStrategyComponent */];
    };
    /**
     * Prepare original values to be shown and compared.
     *
     * @param  {any}    form       Original data of the form.
     * @param  {number} workshopId WorkShop Id
     * @return {Promise<any[]>}    Promise resolved with original values sorted.
     */
    CoreSitePluginsWorkshopAssessmentStrategyHandler.prototype.getOriginalValues = function (form, workshopId) {
        return Promise.resolve([]);
    };
    /**
     * Check if the assessment data has changed for a certain submission and workshop for a this strategy plugin.
     *
     * @param  {any[]} originalValues Original values of the form.
     * @param  {any[]} currentValues  Current values of the form.
     * @return {boolean}              True if data has changed, false otherwise.
     */
    CoreSitePluginsWorkshopAssessmentStrategyHandler.prototype.hasDataChanged = function (originalValues, currentValues) {
        return false;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    CoreSitePluginsWorkshopAssessmentStrategyHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Prepare assessment data to be sent to the server depending on the strategy selected.
     *
     * @param  {any{}} currentValues Current values of the form.
     * @param  {any}   form          Assessment form data.
     * @return {Promise<any>}        Promise resolved with the data to be sent. Or rejected with the input errors object.
     */
    CoreSitePluginsWorkshopAssessmentStrategyHandler.prototype.prepareAssessmentData = function (currentValues, form) {
        return Promise.resolve({});
    };
    return CoreSitePluginsWorkshopAssessmentStrategyHandler;
}());

//# sourceMappingURL=workshop-assessment-strategy-handler.js.map

/***/ }),
/* 1751 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreSitePluginsBlockHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__base_handler__ = __webpack_require__(130);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_siteplugins_components_block_block__ = __webpack_require__(360);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


/**
 * Handler to support a block using a site plugin.
 */
var CoreSitePluginsBlockHandler = /** @class */ (function (_super) {
    __extends(CoreSitePluginsBlockHandler, _super);
    function CoreSitePluginsBlockHandler(name, blockName, handlerSchema, initResult) {
        var _this = _super.call(this, name) || this;
        _this.blockName = blockName;
        _this.handlerSchema = handlerSchema;
        _this.initResult = initResult;
        return _this;
    }
    /**
     * Gets display data for this block. The class and title can be provided either by data from
     * the handler schema (mobile.php) or using default values.
     *
     * @param {Injector} injector Injector
     * @param {any} block Block data
     * @param {string} contextLevel Context level (not used)
     * @param {number} instanceId Instance id (not used)
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data
     */
    CoreSitePluginsBlockHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        var title, className;
        if (this.handlerSchema.displaydata && this.handlerSchema.displaydata.title) {
            title = this.handlerSchema.displaydata.title;
        }
        else {
            title = 'plugins.block_' + block.name + '.pluginname';
        }
        if (this.handlerSchema.displaydata && this.handlerSchema.displaydata.class) {
            className = this.handlerSchema.displaydata.class;
        }
        else {
            className = 'block_' + block.name;
        }
        return {
            title: title,
            class: className,
            component: __WEBPACK_IMPORTED_MODULE_1__core_siteplugins_components_block_block__["a" /* CoreSitePluginsBlockComponent */]
        };
    };
    return CoreSitePluginsBlockHandler;
}(__WEBPACK_IMPORTED_MODULE_0__base_handler__["a" /* CoreSitePluginsBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1752 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCompileModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_compile__ = __webpack_require__(353);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


var CoreCompileModule = /** @class */ (function () {
    function CoreCompileModule() {
    }
    CoreCompileModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_compile__["a" /* CoreCompileProvider */]
            ]
        })
    ], CoreCompileModule);
    return CoreCompileModule;
}());

//# sourceMappingURL=compile.module.js.map

/***/ }),
/* 1753 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreCommentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_comments__ = __webpack_require__(134);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


var CoreCommentsModule = /** @class */ (function () {
    function CoreCommentsModule() {
    }
    CoreCommentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_comments__["a" /* CoreCommentsProvider */]
            ]
        })
    ], CoreCommentsModule);
    return CoreCommentsModule;
}());

//# sourceMappingURL=comments.module.js.map

/***/ }),
/* 1754 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CoreRatingModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_rating__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_offline__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_sync__ = __webpack_require__(156);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var CoreRatingModule = /** @class */ (function () {
    function CoreRatingModule() {
    }
    CoreRatingModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_rating__["a" /* CoreRatingProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_offline__["a" /* CoreRatingOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_sync__["a" /* CoreRatingSyncProvider */]
            ]
        })
    ], CoreRatingModule);
    return CoreRatingModule;
}());

//# sourceMappingURL=rating.module.js.map

/***/ }),
/* 1755 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_mainmenu_providers_delegate__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_blog__ = __webpack_require__(163);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_mainmenu_handler__ = __webpack_require__(1756);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_user_handler__ = __webpack_require__(1757);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_course_option_handler__ = __webpack_require__(1758);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_components_module__ = __webpack_require__(995);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_index_link_handler__ = __webpack_require__(1759);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











var AddonBlogModule = /** @class */ (function () {
    function AddonBlogModule(mainMenuDelegate, menuHandler, userHandler, userDelegate, courseOptionHandler, courseOptionsDelegate, linkHandler, contentLinksDelegate) {
        mainMenuDelegate.registerHandler(menuHandler);
        userDelegate.registerHandler(userHandler);
        courseOptionsDelegate.registerHandler(courseOptionHandler);
        contentLinksDelegate.registerHandler(linkHandler);
    }
    AddonBlogModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_9__components_components_module__["a" /* AddonBlogComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_blog__["a" /* AddonBlogProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_mainmenu_handler__["a" /* AddonBlogMainMenuHandler */],
                __WEBPACK_IMPORTED_MODULE_7__providers_user_handler__["a" /* AddonBlogUserHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_course_option_handler__["a" /* AddonBlogCourseOptionHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_index_link_handler__["a" /* AddonBlogIndexLinkHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_mainmenu_providers_delegate__["a" /* CoreMainMenuDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_mainmenu_handler__["a" /* AddonBlogMainMenuHandler */],
            __WEBPACK_IMPORTED_MODULE_7__providers_user_handler__["a" /* AddonBlogUserHandler */], __WEBPACK_IMPORTED_MODULE_2__core_user_providers_user_delegate__["a" /* CoreUserDelegate */],
            __WEBPACK_IMPORTED_MODULE_8__providers_course_option_handler__["a" /* AddonBlogCourseOptionHandler */], __WEBPACK_IMPORTED_MODULE_3__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */],
            __WEBPACK_IMPORTED_MODULE_10__providers_index_link_handler__["a" /* AddonBlogIndexLinkHandler */], __WEBPACK_IMPORTED_MODULE_4__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */]])
    ], AddonBlogModule);
    return AddonBlogModule;
}());

//# sourceMappingURL=blog.module.js.map

/***/ }),
/* 1756 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__blog__ = __webpack_require__(163);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to inject an option into main menu.
 */
var AddonBlogMainMenuHandler = /** @class */ (function () {
    function AddonBlogMainMenuHandler(blogProvider) {
        this.blogProvider = blogProvider;
        this.name = 'AddonBlog';
        this.priority = 450;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonBlogMainMenuHandler.prototype.isEnabled = function () {
        return this.blogProvider.isPluginEnabled();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreMainMenuHandlerData} Data needed to render the handler.
     */
    AddonBlogMainMenuHandler.prototype.getDisplayData = function () {
        return {
            icon: 'fa-newspaper-o',
            title: 'addon.blog.siteblogheading',
            page: 'AddonBlogEntriesPage',
            class: 'addon-blog-handler'
        };
    };
    AddonBlogMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__blog__["a" /* AddonBlogProvider */]])
    ], AddonBlogMainMenuHandler);
    return AddonBlogMainMenuHandler;
}());

//# sourceMappingURL=mainmenu-handler.js.map

/***/ }),
/* 1757 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__blog__ = __webpack_require__(163);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Profile item handler.
 */
var AddonBlogUserHandler = /** @class */ (function () {
    function AddonBlogUserHandler(linkHelper, blogProvider) {
        this.linkHelper = linkHelper;
        this.blogProvider = blogProvider;
        this.name = 'AddonBlog:blogs';
        this.priority = 300;
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_NEW_PAGE;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonBlogUserHandler.prototype.isEnabled = function () {
        return this.blogProvider.isPluginEnabled();
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user User to check.
     * @param {number} courseId Course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} Promise resolved with true if enabled, resolved with false otherwise.
     */
    AddonBlogUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        return true;
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonBlogUserHandler.prototype.getDisplayData = function (user, courseId) {
        var _this = this;
        return {
            icon: 'fa-newspaper-o',
            title: 'addon.blog.blogentries',
            class: 'addon-blog-handler',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                // Always use redirect to make it the new history root (to avoid "loops" in history).
                _this.linkHelper.goInSite(navCtrl, 'AddonBlogEntriesPage', { userId: user.id, courseId: courseId });
            }
        };
    };
    AddonBlogUserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__blog__["a" /* AddonBlogProvider */]])
    ], AddonBlogUserHandler);
    return AddonBlogUserHandler;
}());

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1758 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogCourseOptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_helper__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_entries_entries__ = __webpack_require__(763);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__blog__ = __webpack_require__(163);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








/**
 * Course nav handler.
 */
var AddonBlogCourseOptionHandler = /** @class */ (function () {
    function AddonBlogCourseOptionHandler(coursesProvider, blogProvider, courseHelper, courseProvider, sitesProvider, filepoolProvider) {
        this.coursesProvider = coursesProvider;
        this.blogProvider = blogProvider;
        this.courseHelper = courseHelper;
        this.courseProvider = courseProvider;
        this.sitesProvider = sitesProvider;
        this.filepoolProvider = filepoolProvider;
        this.name = 'AddonBlog';
        this.priority = 100;
    }
    /**
     * Should invalidate the data to determine if the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlogCourseOptionHandler.prototype.invalidateEnabledForCourse = function (courseId, navOptions, admOptions) {
        return this.courseProvider.invalidateCourseBlocks(courseId);
    };
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonBlogCourseOptionHandler.prototype.isEnabled = function () {
        return this.blogProvider.isPluginEnabled();
    };
    /**
     * Whether or not the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonBlogCourseOptionHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        return this.courseHelper.hasABlockNamed(courseId, 'blog_menu').then(function (enabled) {
            if (enabled && navOptions && typeof navOptions.blogs != 'undefined') {
                return navOptions.blogs;
            }
            return enabled;
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {Injector} injector Injector.
     * @param {number} courseId The course ID.
     * @return {CoreCourseOptionsHandlerData|Promise<CoreCourseOptionsHandlerData>} Data or promise resolved with the data.
     */
    AddonBlogCourseOptionHandler.prototype.getDisplayData = function (injector, courseId) {
        return {
            title: 'addon.blog.blog',
            class: 'addon-blog-handler',
            component: __WEBPACK_IMPORTED_MODULE_6__components_entries_entries__["a" /* AddonBlogEntriesComponent */]
        };
    };
    /**
     * Called when a course is downloaded. It should prefetch all the data to be able to see the addon in offline.
     *
     * @param {any} course The course.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonBlogCourseOptionHandler.prototype.prefetch = function (course) {
        var _this = this;
        var siteId = this.sitesProvider.getCurrentSiteId();
        return this.blogProvider.getEntries({ courseid: course.id }).then(function (result) {
            return result.entries.map(function (entry) {
                var files = [];
                if (entry.attachmentfiles && entry.attachmentfiles.length) {
                    files = entry.attachmentfiles;
                }
                if (entry.summaryfiles && entry.summaryfiles.length) {
                    files = files.concat(entry.summaryfiles);
                }
                if (files.length > 0) {
                    return _this.filepoolProvider.addFilesToQueue(siteId, files, entry.module, entry.id);
                }
                return Promise.resolve();
            });
        });
    };
    AddonBlogCourseOptionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_7__blog__["a" /* AddonBlogProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_course_providers_helper__["a" /* CoreCourseHelperProvider */], __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_filepool__["a" /* CoreFilepoolProvider */]])
    ], AddonBlogCourseOptionHandler);
    return AddonBlogCourseOptionHandler;
}());

//# sourceMappingURL=course-option-handler.js.map

/***/ }),
/* 1759 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlogIndexLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__ = __webpack_require__(52);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__blog__ = __webpack_require__(163);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to treat links to blog page.
 */
var AddonBlogIndexLinkHandler = /** @class */ (function (_super) {
    __extends(AddonBlogIndexLinkHandler, _super);
    function AddonBlogIndexLinkHandler(blogProvider, loginHelper) {
        var _this = _super.call(this) || this;
        _this.blogProvider = blogProvider;
        _this.loginHelper = loginHelper;
        _this.name = 'AddonBlogIndexLinkHandler';
        _this.featureName = 'CoreUserDelegate_AddonBlog:blogs';
        _this.pattern = /\/blog\/index\.php/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonBlogIndexLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        var pageParams = {};
        params.userid ? pageParams['userId'] = parseInt(params.userid, 10) : null;
        params.modid ? pageParams['cmId'] = parseInt(params.modid, 10) : null;
        params.courseid ? pageParams['courseId'] = parseInt(params.courseid, 10) : null;
        params.entryid ? pageParams['entryId'] = parseInt(params.entryid, 10) : null;
        params.groupid ? pageParams['groupId'] = parseInt(params.groupid, 10) : null;
        params.tagid ? pageParams['tagId'] = parseInt(params.tagid, 10) : null;
        return [{
                action: function (siteId, navCtrl) {
                    // Always use redirect to make it the new history root (to avoid "loops" in history).
                    _this.loginHelper.redirect('AddonBlogEntriesPage', pageParams, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonBlogIndexLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        return this.blogProvider.isPluginEnabled(siteId);
    };
    AddonBlogIndexLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__blog__["a" /* AddonBlogProvider */], __WEBPACK_IMPORTED_MODULE_2__core_login_providers_helper__["a" /* CoreLoginHelperProvider */]])
    ], AddonBlogIndexLinkHandler);
    return AddonBlogIndexLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=index-link-handler.js.map

/***/ }),
/* 1760 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCourseCompletionModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_coursecompletion__ = __webpack_require__(146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_course_option_handler__ = __webpack_require__(1761);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_user_handler__ = __webpack_require__(1762);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(997);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_options_delegate__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user_delegate__ = __webpack_require__(55);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonCourseCompletionModule = /** @class */ (function () {
    function AddonCourseCompletionModule(courseOptionsDelegate, courseOptionHandler, userDelegate, userHandler) {
        // Register handlers.
        courseOptionsDelegate.registerHandler(courseOptionHandler);
        userDelegate.registerHandler(userHandler);
    }
    AddonCourseCompletionModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* AddonCourseCompletionComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_coursecompletion__["a" /* AddonCourseCompletionProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_course_option_handler__["a" /* AddonCourseCompletionCourseOptionHandler */],
                __WEBPACK_IMPORTED_MODULE_3__providers_user_handler__["a" /* AddonCourseCompletionUserHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_course_option_handler__["a" /* AddonCourseCompletionCourseOptionHandler */],
            __WEBPACK_IMPORTED_MODULE_6__core_user_providers_user_delegate__["a" /* CoreUserDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_user_handler__["a" /* AddonCourseCompletionUserHandler */]])
    ], AddonCourseCompletionModule);
    return AddonCourseCompletionModule;
}());

//# sourceMappingURL=coursecompletion.module.js.map

/***/ }),
/* 1761 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCourseCompletionCourseOptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__coursecompletion__ = __webpack_require__(146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_report_report__ = __webpack_require__(765);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to inject an option into the course main menu.
 */
var AddonCourseCompletionCourseOptionHandler = /** @class */ (function () {
    function AddonCourseCompletionCourseOptionHandler(courseCompletionProvider) {
        this.courseCompletionProvider = courseCompletionProvider;
        this.name = 'AddonCourseCompletion';
        this.priority = 200;
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonCourseCompletionCourseOptionHandler.prototype.isEnabled = function () {
        return this.courseCompletionProvider.isPluginViewEnabled();
    };
    /**
     * Whether or not the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} accessData Access type and data. Default, guest, ...
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonCourseCompletionCourseOptionHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        var _this = this;
        if (accessData && accessData.type == __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */].ACCESS_GUEST) {
            return false; // Not enabled for guests.
        }
        return this.courseCompletionProvider.isPluginViewEnabledForCourse(courseId).then(function (courseEnabled) {
            // If is not enabled in the course, is not enabled for the user.
            if (!courseEnabled) {
                return false;
            }
            // Check if the user can see his own report, teachers can't.
            return _this.courseCompletionProvider.isPluginViewEnabledForUser(courseId);
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {number} courseId The course ID.
     * @return {CoreCourseOptionsHandlerData} Data.
     */
    AddonCourseCompletionCourseOptionHandler.prototype.getDisplayData = function (injector, courseId) {
        return {
            title: 'addon.coursecompletion.completionmenuitem',
            class: 'addon-coursecompletion-course-handler',
            component: __WEBPACK_IMPORTED_MODULE_3__components_report_report__["a" /* AddonCourseCompletionReportComponent */],
        };
    };
    /**
     * Should invalidate the data to determine if the handler is enabled for a certain course.
     *
     * @param {number} courseId The course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonCourseCompletionCourseOptionHandler.prototype.invalidateEnabledForCourse = function (courseId, navOptions, admOptions) {
        return this.courseCompletionProvider.invalidateCourseCompletion(courseId);
    };
    /**
     * Called when a course is downloaded. It should prefetch all the data to be able to see the addon in offline.
     *
     * @param {any} course The course.
     * @return {Promise<any>} Promise resolved when done.
     */
    AddonCourseCompletionCourseOptionHandler.prototype.prefetch = function (course) {
        return this.courseCompletionProvider.getCompletion(course.id, undefined, {
            getFromCache: false,
            emergencyCache: false
        });
    };
    AddonCourseCompletionCourseOptionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__coursecompletion__["a" /* AddonCourseCompletionProvider */]])
    ], AddonCourseCompletionCourseOptionHandler);
    return AddonCourseCompletionCourseOptionHandler;
}());

//# sourceMappingURL=course-option-handler.js.map

/***/ }),
/* 1762 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonCourseCompletionUserHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_events__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__coursecompletion__ = __webpack_require__(146);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Profile course completion handler.
 */
var AddonCourseCompletionUserHandler = /** @class */ (function () {
    function AddonCourseCompletionUserHandler(eventsProvider, courseCompletionProvider) {
        var _this = this;
        this.courseCompletionProvider = courseCompletionProvider;
        this.name = 'AddonCourseCompletion';
        this.type = __WEBPACK_IMPORTED_MODULE_1__core_user_providers_user_delegate__["a" /* CoreUserDelegate */].TYPE_NEW_PAGE;
        this.priority = 200;
        this.enabledCache = {};
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */].LOGOUT, function () {
            _this.enabledCache = {};
        });
        eventsProvider.on(__WEBPACK_IMPORTED_MODULE_3__core_user_providers_user__["a" /* CoreUserProvider */].PROFILE_REFRESHED, function (data) {
            var cacheKey = data.userId + '-' + data.courseId;
            delete _this.enabledCache[cacheKey];
        });
    }
    /**
     * Whether or not the handler is enabled on a site level.
     * @return {boolean|Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonCourseCompletionUserHandler.prototype.isEnabled = function () {
        return this.courseCompletionProvider.isPluginViewEnabled();
    };
    /**
     * Check if handler is enabled for this user in this context.
     *
     * @param {any} user User to check.
     * @param {number} courseId Course ID.
     * @param {any} [navOptions] Course navigation options for current user. See CoreCoursesProvider.getUserNavigationOptions.
     * @param {any} [admOptions] Course admin options for current user. See CoreCoursesProvider.getUserAdministrationOptions.
     * @return {boolean|Promise<boolean>} Promise resolved with true if enabled, resolved with false otherwise.
     */
    AddonCourseCompletionUserHandler.prototype.isEnabledForUser = function (user, courseId, navOptions, admOptions) {
        var _this = this;
        if (!courseId) {
            return false;
        }
        return this.courseCompletionProvider.isPluginViewEnabledForCourse(courseId).then(function (courseEnabled) {
            // If is not enabled in the course, is not enabled for the user.
            if (!courseEnabled) {
                return false;
            }
            var cacheKey = user.id + '-' + courseId;
            if (typeof _this.enabledCache[cacheKey] !== 'undefined') {
                return _this.enabledCache[cacheKey];
            }
            return _this.courseCompletionProvider.isPluginViewEnabledForUser(courseId, user.id).then(function (enabled) {
                _this.enabledCache[cacheKey] = enabled;
                return enabled;
            });
        });
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreUserProfileHandlerData} Data needed to render the handler.
     */
    AddonCourseCompletionUserHandler.prototype.getDisplayData = function (user, courseId) {
        return {
            icon: 'checkbox-outline',
            title: 'addon.coursecompletion.coursecompletion',
            class: 'addon-coursecompletion-handler',
            action: function (event, navCtrl, user, courseId) {
                event.preventDefault();
                event.stopPropagation();
                navCtrl.push('AddonCourseCompletionReportPage', { courseId: courseId, userId: user.id });
            }
        };
    };
    AddonCourseCompletionUserHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_events__["a" /* CoreEventsProvider */], __WEBPACK_IMPORTED_MODULE_4__coursecompletion__["a" /* AddonCourseCompletionProvider */]])
    ], AddonCourseCompletionUserHandler);
    return AddonCourseCompletionUserHandler;
}());

//# sourceMappingURL=user-handler.js.map

/***/ }),
/* 1763 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__checkbox_checkbox_module__ = __webpack_require__(1764);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__datetime_datetime_module__ = __webpack_require__(1766);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__menu_menu_module__ = __webpack_require__(1768);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__text_text_module__ = __webpack_require__(1770);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__textarea_textarea_module__ = __webpack_require__(1772);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.






var AddonUserProfileFieldModule = /** @class */ (function () {
    function AddonUserProfileFieldModule() {
    }
    AddonUserProfileFieldModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__checkbox_checkbox_module__["a" /* AddonUserProfileFieldCheckboxModule */],
                __WEBPACK_IMPORTED_MODULE_2__datetime_datetime_module__["a" /* AddonUserProfileFieldDatetimeModule */],
                __WEBPACK_IMPORTED_MODULE_3__menu_menu_module__["a" /* AddonUserProfileFieldMenuModule */],
                __WEBPACK_IMPORTED_MODULE_4__text_text_module__["a" /* AddonUserProfileFieldTextModule */],
                __WEBPACK_IMPORTED_MODULE_5__textarea_textarea_module__["a" /* AddonUserProfileFieldTextareaModule */]
            ],
            providers: [],
            exports: []
        })
    ], AddonUserProfileFieldModule);
    return AddonUserProfileFieldModule;
}());

//# sourceMappingURL=userprofilefield.module.js.map

/***/ }),
/* 1764 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldCheckboxModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_handler__ = __webpack_require__(1765);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_checkbox__ = __webpack_require__(927);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(13);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonUserProfileFieldCheckboxModule = /** @class */ (function () {
    function AddonUserProfileFieldCheckboxModule(userProfileFieldDelegate, handler) {
        userProfileFieldDelegate.registerHandler(handler);
    }
    AddonUserProfileFieldCheckboxModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_checkbox__["a" /* AddonUserProfileFieldCheckboxComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreComponentsModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldCheckboxHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_checkbox__["a" /* AddonUserProfileFieldCheckboxComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_checkbox__["a" /* AddonUserProfileFieldCheckboxComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldCheckboxHandler */]])
    ], AddonUserProfileFieldCheckboxModule);
    return AddonUserProfileFieldCheckboxModule;
}());

//# sourceMappingURL=checkbox.module.js.map

/***/ }),
/* 1765 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldCheckboxHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__component_checkbox__ = __webpack_require__(927);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Checkbox user profile field handlers.
 */
var AddonUserProfileFieldCheckboxHandler = /** @class */ (function () {
    function AddonUserProfileFieldCheckboxHandler() {
        this.name = 'AddonUserProfileFieldCheckbox';
        this.type = 'checkbox';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonUserProfileFieldCheckboxHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data to send for the field based on the input data.
     *
     * @param  {any}     field          User field to get the data for.
     * @param  {boolean} signup         True if user is in signup page.
     * @param  {string}  [registerAuth] Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form Values.
     * @return {CoreUserProfileFieldHandlerData}  Data to send for the field.
     */
    AddonUserProfileFieldCheckboxHandler.prototype.getData = function (field, signup, registerAuth, formValues) {
        var name = 'profile_field_' + field.shortname;
        if (typeof formValues[name] != 'undefined') {
            return {
                type: 'checkbox',
                name: name,
                value: formValues[name] ? 1 : 0
            };
        }
    };
    /**
     * Return the Component to use to display the user profile field.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonUserProfileFieldCheckboxHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__component_checkbox__["a" /* AddonUserProfileFieldCheckboxComponent */];
    };
    AddonUserProfileFieldCheckboxHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonUserProfileFieldCheckboxHandler);
    return AddonUserProfileFieldCheckboxHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1766 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldDatetimeModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_handler__ = __webpack_require__(1767);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_datetime__ = __webpack_require__(928);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__pipes_pipes_module__ = __webpack_require__(63);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonUserProfileFieldDatetimeModule = /** @class */ (function () {
    function AddonUserProfileFieldDatetimeModule(userProfileFieldDelegate, handler) {
        userProfileFieldDelegate.registerHandler(handler);
    }
    AddonUserProfileFieldDatetimeModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_datetime__["a" /* AddonUserProfileFieldDatetimeComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_7__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldDatetimeHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_datetime__["a" /* AddonUserProfileFieldDatetimeComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_datetime__["a" /* AddonUserProfileFieldDatetimeComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldDatetimeHandler */]])
    ], AddonUserProfileFieldDatetimeModule);
    return AddonUserProfileFieldDatetimeModule;
}());

//# sourceMappingURL=datetime.module.js.map

/***/ }),
/* 1767 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldDatetimeHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__component_datetime__ = __webpack_require__(928);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Datetime user profile field handlers.
 */
var AddonUserProfileFieldDatetimeHandler = /** @class */ (function () {
    function AddonUserProfileFieldDatetimeHandler() {
        this.name = 'AddonUserProfileFieldDatetime';
        this.type = 'datetime';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonUserProfileFieldDatetimeHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data to send for the field based on the input data.
     *
     * @param  {any}     field          User field to get the data for.
     * @param  {boolean} signup         True if user is in signup page.
     * @param  {string}  [registerAuth] Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form Values.
     * @return {CoreUserProfileFieldHandlerData}  Data to send for the field.
     */
    AddonUserProfileFieldDatetimeHandler.prototype.getData = function (field, signup, registerAuth, formValues) {
        var name = 'profile_field_' + field.shortname;
        if (formValues[name]) {
            var milliseconds = new Date(formValues[name]).getTime();
            return {
                type: 'datetime',
                name: 'profile_field_' + field.shortname,
                value: Math.round(milliseconds / 1000)
            };
        }
    };
    /**
     * Return the Component to use to display the user profile field.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonUserProfileFieldDatetimeHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__component_datetime__["a" /* AddonUserProfileFieldDatetimeComponent */];
    };
    AddonUserProfileFieldDatetimeHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonUserProfileFieldDatetimeHandler);
    return AddonUserProfileFieldDatetimeHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1768 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldMenuModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_handler__ = __webpack_require__(1769);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_menu__ = __webpack_require__(929);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonUserProfileFieldMenuModule = /** @class */ (function () {
    function AddonUserProfileFieldMenuModule(userProfileFieldDelegate, handler) {
        userProfileFieldDelegate.registerHandler(handler);
    }
    AddonUserProfileFieldMenuModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_menu__["a" /* AddonUserProfileFieldMenuComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldMenuHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_menu__["a" /* AddonUserProfileFieldMenuComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_menu__["a" /* AddonUserProfileFieldMenuComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldMenuHandler */]])
    ], AddonUserProfileFieldMenuModule);
    return AddonUserProfileFieldMenuModule;
}());

//# sourceMappingURL=menu.module.js.map

/***/ }),
/* 1769 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__component_menu__ = __webpack_require__(929);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Menu user profile field handlers.
 */
var AddonUserProfileFieldMenuHandler = /** @class */ (function () {
    function AddonUserProfileFieldMenuHandler() {
        this.name = 'AddonUserProfileFieldMenu';
        this.type = 'menu';
        // Nothing to do.
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonUserProfileFieldMenuHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data to send for the field based on the input data.
     *
     * @param  {any}     field          User field to get the data for.
     * @param  {boolean} signup         True if user is in signup page.
     * @param  {string}  [registerAuth] Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form Values.
     * @return {CoreUserProfileFieldHandlerData}  Data to send for the field.
     */
    AddonUserProfileFieldMenuHandler.prototype.getData = function (field, signup, registerAuth, formValues) {
        var name = 'profile_field_' + field.shortname;
        if (formValues[name]) {
            return {
                type: 'menu',
                name: name,
                value: formValues[name]
            };
        }
    };
    /**
     * Return the Component to use to display the user profile field.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonUserProfileFieldMenuHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__component_menu__["a" /* AddonUserProfileFieldMenuComponent */];
    };
    AddonUserProfileFieldMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonUserProfileFieldMenuHandler);
    return AddonUserProfileFieldMenuHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1770 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldTextModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_handler__ = __webpack_require__(1771);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_text__ = __webpack_require__(930);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonUserProfileFieldTextModule = /** @class */ (function () {
    function AddonUserProfileFieldTextModule(userProfileFieldDelegate, handler) {
        userProfileFieldDelegate.registerHandler(handler);
    }
    AddonUserProfileFieldTextModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_text__["a" /* AddonUserProfileFieldTextComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldTextHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_text__["a" /* AddonUserProfileFieldTextComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_text__["a" /* AddonUserProfileFieldTextComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldTextHandler */]])
    ], AddonUserProfileFieldTextModule);
    return AddonUserProfileFieldTextModule;
}());

//# sourceMappingURL=text.module.js.map

/***/ }),
/* 1771 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldTextHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__component_text__ = __webpack_require__(930);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Text user profile field handlers.
 */
var AddonUserProfileFieldTextHandler = /** @class */ (function () {
    function AddonUserProfileFieldTextHandler(textUtils) {
        this.textUtils = textUtils;
        this.name = 'AddonUserProfileFieldText';
        this.type = 'text';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonUserProfileFieldTextHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data to send for the field based on the input data.
     *
     * @param  {any}     field          User field to get the data for.
     * @param  {boolean} signup         True if user is in signup page.
     * @param  {string}  [registerAuth] Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form Values.
     * @return {CoreUserProfileFieldHandlerData}  Data to send for the field.
     */
    AddonUserProfileFieldTextHandler.prototype.getData = function (field, signup, registerAuth, formValues) {
        var name = 'profile_field_' + field.shortname;
        return {
            type: 'text',
            name: name,
            value: this.textUtils.cleanTags(formValues[name])
        };
    };
    /**
     * Return the Component to use to display the user profile field.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonUserProfileFieldTextHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__component_text__["a" /* AddonUserProfileFieldTextComponent */];
    };
    AddonUserProfileFieldTextHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonUserProfileFieldTextHandler);
    return AddonUserProfileFieldTextHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1772 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldTextareaModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_handler__ = __webpack_require__(1773);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_textarea__ = __webpack_require__(931);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__ = __webpack_require__(15);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonUserProfileFieldTextareaModule = /** @class */ (function () {
    function AddonUserProfileFieldTextareaModule(userProfileFieldDelegate, handler) {
        userProfileFieldDelegate.registerHandler(handler);
    }
    AddonUserProfileFieldTextareaModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__component_textarea__["a" /* AddonUserProfileFieldTextareaComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldTextareaHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__component_textarea__["a" /* AddonUserProfileFieldTextareaComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__component_textarea__["a" /* AddonUserProfileFieldTextareaComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_user_providers_user_profile_field_delegate__["a" /* CoreUserProfileFieldDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonUserProfileFieldTextareaHandler */]])
    ], AddonUserProfileFieldTextareaModule);
    return AddonUserProfileFieldTextareaModule;
}());

//# sourceMappingURL=textarea.module.js.map

/***/ }),
/* 1773 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonUserProfileFieldTextareaHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__component_textarea__ = __webpack_require__(931);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_text__ = __webpack_require__(11);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Textarea user profile field handlers.
 */
var AddonUserProfileFieldTextareaHandler = /** @class */ (function () {
    function AddonUserProfileFieldTextareaHandler(textUtils) {
        this.textUtils = textUtils;
        this.name = 'AddonUserProfileFieldTextarea';
        this.type = 'textarea';
    }
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonUserProfileFieldTextareaHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data to send for the field based on the input data.
     *
     * @param  {any}     field          User field to get the data for.
     * @param  {boolean} signup         True if user is in signup page.
     * @param  {string}  [registerAuth] Register auth method. E.g. 'email'.
     * @param  {any}     formValues     Form Values.
     * @return {CoreUserProfileFieldHandlerData}  Data to send for the field.
     */
    AddonUserProfileFieldTextareaHandler.prototype.getData = function (field, signup, registerAuth, formValues) {
        var name = 'profile_field_' + field.shortname;
        if (formValues[name]) {
            var text = formValues[name] || '';
            // Add some HTML to the message in case the user edited with textarea.
            text = this.textUtils.formatHtmlLines(text);
            return {
                type: 'textarea',
                name: name,
                value: JSON.stringify({
                    text: text,
                    format: 1 // Always send this format.
                })
            };
        }
    };
    /**
     * Return the Component to use to display the user profile field.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonUserProfileFieldTextareaHandler.prototype.getComponent = function (injector) {
        return __WEBPACK_IMPORTED_MODULE_1__component_textarea__["a" /* AddonUserProfileFieldTextareaComponent */];
    };
    AddonUserProfileFieldTextareaHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonUserProfileFieldTextareaHandler);
    return AddonUserProfileFieldTextareaHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1774 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockActivityModulesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1775);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_block_handler__ = __webpack_require__(1776);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonBlockActivityModulesModule = /** @class */ (function () {
    function AddonBlockActivityModulesModule(blockDelegate, blockHandler) {
        blockDelegate.registerHandler(blockHandler);
    }
    AddonBlockActivityModulesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonBlockActivityModulesComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            exports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_block_handler__["a" /* AddonBlockActivityModulesHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_block_handler__["a" /* AddonBlockActivityModulesHandler */]])
    ], AddonBlockActivityModulesModule);
    return AddonBlockActivityModulesModule;
}());

//# sourceMappingURL=activitymodules.module.js.map

/***/ }),
/* 1775 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockActivityModulesComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__activitymodules_activitymodules__ = __webpack_require__(932);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonBlockActivityModulesComponentsModule = /** @class */ (function () {
    function AddonBlockActivityModulesComponentsModule() {
    }
    AddonBlockActivityModulesComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__activitymodules_activitymodules__["a" /* AddonBlockActivityModulesComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__activitymodules_activitymodules__["a" /* AddonBlockActivityModulesComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__activitymodules_activitymodules__["a" /* AddonBlockActivityModulesComponent */]
            ]
        })
    ], AddonBlockActivityModulesComponentsModule);
    return AddonBlockActivityModulesComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1776 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockActivityModulesHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_activitymodules_activitymodules__ = __webpack_require__(932);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Block handler.
 */
var AddonBlockActivityModulesHandler = /** @class */ (function (_super) {
    __extends(AddonBlockActivityModulesHandler, _super);
    function AddonBlockActivityModulesHandler() {
        var _this = _super.call(this) || this;
        _this.name = 'AddonBlockActivityModules';
        _this.blockName = 'activity_modules';
        return _this;
    }
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    AddonBlockActivityModulesHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        return {
            title: 'addon.block_activitymodules.pluginname',
            class: 'addon-block-activitymodules',
            component: __WEBPACK_IMPORTED_MODULE_1__components_activitymodules_activitymodules__["a" /* AddonBlockActivityModulesComponent */]
        };
    };
    AddonBlockActivityModulesHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonBlockActivityModulesHandler);
    return AddonBlockActivityModulesHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1777 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockMyOverviewModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(1778);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_block_handler__ = __webpack_require__(1779);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






var AddonBlockMyOverviewModule = /** @class */ (function () {
    function AddonBlockMyOverviewModule(blockDelegate, blockHandler) {
        blockDelegate.registerHandler(blockHandler);
    }
    AddonBlockMyOverviewModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* AddonBlockMyOverviewComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            exports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_block_handler__["a" /* AddonBlockMyOverviewHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_block_handler__["a" /* AddonBlockMyOverviewHandler */]])
    ], AddonBlockMyOverviewModule);
    return AddonBlockMyOverviewModule;
}());

//# sourceMappingURL=myoverview.module.js.map

/***/ }),
/* 1778 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockMyOverviewComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_courses_components_components_module__ = __webpack_require__(182);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__myoverview_myoverview__ = __webpack_require__(933);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_components_components_module__ = __webpack_require__(41);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









var AddonBlockMyOverviewComponentsModule = /** @class */ (function () {
    function AddonBlockMyOverviewComponentsModule() {
    }
    AddonBlockMyOverviewComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_5__myoverview_myoverview__["a" /* AddonBlockMyOverviewComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_6__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_7__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_4__core_courses_components_components_module__["a" /* CoreCoursesComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_5__myoverview_myoverview__["a" /* AddonBlockMyOverviewComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_5__myoverview_myoverview__["a" /* AddonBlockMyOverviewComponent */]
            ]
        })
    ], AddonBlockMyOverviewComponentsModule);
    return AddonBlockMyOverviewComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1779 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockMyOverviewHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_myoverview_myoverview__ = __webpack_require__(933);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_block_classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Block  handler.
 */
var AddonBlockMyOverviewHandler = /** @class */ (function (_super) {
    __extends(AddonBlockMyOverviewHandler, _super);
    function AddonBlockMyOverviewHandler(coursesProvider, sitesProvider) {
        var _this = _super.call(this) || this;
        _this.coursesProvider = coursesProvider;
        _this.sitesProvider = sitesProvider;
        _this.name = 'AddonBlockMyOverview';
        _this.blockName = 'myoverview';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonBlockMyOverviewHandler.prototype.isEnabled = function () {
        return this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.6') ||
            !this.coursesProvider.isMyCoursesDisabledInSite();
    };
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    AddonBlockMyOverviewHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        return {
            title: 'addon.block_myoverview.pluginname',
            class: 'addon-block-myoverview',
            component: __WEBPACK_IMPORTED_MODULE_3__components_myoverview_myoverview__["a" /* AddonBlockMyOverviewComponent */]
        };
    };
    AddonBlockMyOverviewHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_courses_providers_courses__["a" /* CoreCoursesProvider */], __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonBlockMyOverviewHandler);
    return AddonBlockMyOverviewHandler;
}(__WEBPACK_IMPORTED_MODULE_4__core_block_classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1780 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockSiteMainMenuModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1781);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_block_handler__ = __webpack_require__(1782);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonBlockSiteMainMenuModule = /** @class */ (function () {
    function AddonBlockSiteMainMenuModule(blockDelegate, blockHandler) {
        blockDelegate.registerHandler(blockHandler);
    }
    AddonBlockSiteMainMenuModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonBlockSiteMainMenuComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            exports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_block_handler__["a" /* AddonBlockSiteMainMenuHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_7__providers_block_handler__["a" /* AddonBlockSiteMainMenuHandler */]])
    ], AddonBlockSiteMainMenuModule);
    return AddonBlockSiteMainMenuModule;
}());

//# sourceMappingURL=sitemainmenu.module.js.map

/***/ }),
/* 1781 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockSiteMainMenuComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__sitemainmenu_sitemainmenu__ = __webpack_require__(934);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonBlockSiteMainMenuComponentsModule = /** @class */ (function () {
    function AddonBlockSiteMainMenuComponentsModule() {
    }
    AddonBlockSiteMainMenuComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__sitemainmenu_sitemainmenu__["a" /* AddonBlockSiteMainMenuComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__sitemainmenu_sitemainmenu__["a" /* AddonBlockSiteMainMenuComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__sitemainmenu_sitemainmenu__["a" /* AddonBlockSiteMainMenuComponent */]
            ]
        })
    ], AddonBlockSiteMainMenuComponentsModule);
    return AddonBlockSiteMainMenuComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1782 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockSiteMainMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_sitemainmenu_sitemainmenu__ = __webpack_require__(934);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Block handler.
 */
var AddonBlockSiteMainMenuHandler = /** @class */ (function (_super) {
    __extends(AddonBlockSiteMainMenuHandler, _super);
    function AddonBlockSiteMainMenuHandler() {
        var _this = _super.call(this) || this;
        _this.name = 'AddonBlockSiteMainMenu';
        _this.blockName = 'site_main_menu';
        return _this;
    }
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    AddonBlockSiteMainMenuHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        return {
            title: 'addon.block_sitemainmenu.pluginname',
            class: 'addon-block-sitemainmenu',
            component: __WEBPACK_IMPORTED_MODULE_1__components_sitemainmenu_sitemainmenu__["a" /* AddonBlockSiteMainMenuComponent */]
        };
    };
    AddonBlockSiteMainMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonBlockSiteMainMenuHandler);
    return AddonBlockSiteMainMenuHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1783 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockTimelineModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(1784);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_timeline__ = __webpack_require__(262);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__ = __webpack_require__(1786);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonBlockTimelineModule = /** @class */ (function () {
    function AddonBlockTimelineModule(blockDelegate, blockHandler) {
        blockDelegate.registerHandler(blockHandler);
    }
    AddonBlockTimelineModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* AddonBlockTimelineComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            exports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_timeline__["a" /* AddonBlockTimelineProvider */],
                __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__["a" /* AddonBlockTimelineHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__["a" /* AddonBlockTimelineHandler */]])
    ], AddonBlockTimelineModule);
    return AddonBlockTimelineModule;
}());

//# sourceMappingURL=timeline.module.js.map

/***/ }),
/* 1784 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockTimelineComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_courses_components_components_module__ = __webpack_require__(182);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__timeline_timeline__ = __webpack_require__(935);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__events_events__ = __webpack_require__(1785);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_course_components_components_module__ = __webpack_require__(41);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};











var AddonBlockTimelineComponentsModule = /** @class */ (function () {
    function AddonBlockTimelineComponentsModule() {
    }
    AddonBlockTimelineComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_8__timeline_timeline__["a" /* AddonBlockTimelineComponent */],
                __WEBPACK_IMPORTED_MODULE_9__events_events__["a" /* AddonBlockTimelineEventsComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_6__pipes_pipes_module__["a" /* CorePipesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_courses_components_components_module__["a" /* CoreCoursesComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_10__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_8__timeline_timeline__["a" /* AddonBlockTimelineComponent */],
                __WEBPACK_IMPORTED_MODULE_9__events_events__["a" /* AddonBlockTimelineEventsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_8__timeline_timeline__["a" /* AddonBlockTimelineComponent */],
                __WEBPACK_IMPORTED_MODULE_9__events_events__["a" /* AddonBlockTimelineEventsComponent */]
            ]
        })
    ], AddonBlockTimelineComponentsModule);
    return AddonBlockTimelineComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1785 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockTimelineEventsComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_moment__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_9_moment__);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};










/**
 * Directive to render a list of events in course overview.
 */
var AddonBlockTimelineEventsComponent = /** @class */ (function () {
    function AddonBlockTimelineEventsComponent(navCtrl, utils, textUtils, domUtils, sitesProvider, courseProvider, contentLinksHelper, timeUtils) {
        this.navCtrl = navCtrl;
        this.utils = utils;
        this.textUtils = textUtils;
        this.domUtils = domUtils;
        this.sitesProvider = sitesProvider;
        this.courseProvider = courseProvider;
        this.contentLinksHelper = contentLinksHelper;
        this.timeUtils = timeUtils;
        this.events = []; // The events to render.
        this.filteredEvents = [];
        this.loadMore = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"]();
    }
    /**
     * Detect changes on input properties.
     */
    AddonBlockTimelineEventsComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        this.showCourse = this.utils.isTrueOrOne(this.showCourse);
        if (changes.events || changes.from || changes.to) {
            if (this.events && this.events.length > 0) {
                var filteredEvents = this.filterEventsByTime(this.from, this.to);
                this.empty = !filteredEvents || filteredEvents.length <= 0;
                var eventsByDay_1 = {};
                filteredEvents.forEach(function (event) {
                    var dayTimestamp = _this.timeUtils.getMidnightForTimestamp(event.timesort);
                    if (eventsByDay_1[dayTimestamp]) {
                        eventsByDay_1[dayTimestamp].push(event);
                    }
                    else {
                        eventsByDay_1[dayTimestamp] = [event];
                    }
                });
                var todaysMidnight_1 = this.timeUtils.getMidnightForTimestamp();
                this.filteredEvents = [];
                Object.keys(eventsByDay_1).forEach(function (key) {
                    var dayTimestamp = parseInt(key);
                    _this.filteredEvents.push({
                        color: dayTimestamp < todaysMidnight_1 ? 'danger' : 'light',
                        dayTimestamp: dayTimestamp,
                        events: eventsByDay_1[dayTimestamp]
                    });
                });
            }
            else {
                this.empty = true;
            }
        }
    };
    /**
     * Filter the events by time.
     *
     * @param {number} start Number of days to start getting events from today. E.g. -1 will get events from yesterday.
     * @param {number} [end] Number of days after the start.
     * @return {any[]} Filtered events.
     */
    AddonBlockTimelineEventsComponent.prototype.filterEventsByTime = function (start, end) {
        var _this = this;
        start = __WEBPACK_IMPORTED_MODULE_9_moment__().add(start, 'days').startOf('day').unix();
        end = typeof end != 'undefined' ? __WEBPACK_IMPORTED_MODULE_9_moment__().add(end, 'days').startOf('day').unix() : end;
        return this.events.filter(function (event) {
            if (end) {
                return start <= event.timesort && event.timesort < end;
            }
            return start <= event.timesort;
        }).map(function (event) {
            event.iconUrl = _this.courseProvider.getModuleIconSrc(event.icon.component);
            return event;
        });
    };
    /**
     * Load more events clicked.
     */
    AddonBlockTimelineEventsComponent.prototype.loadMoreEvents = function () {
        this.loadingMore = true;
        this.loadMore.emit();
    };
    /**
     * Action clicked.
     *
     * @param {Event} e     Click event.
     * @param {string} url  Url of the action.
     */
    AddonBlockTimelineEventsComponent.prototype.action = function (e, url) {
        var _this = this;
        e.preventDefault();
        e.stopPropagation();
        // Fix URL format.
        url = this.textUtils.decodeHTMLEntities(url);
        var modal = this.domUtils.showModalLoading();
        this.contentLinksHelper.handleLink(url, undefined, this.navCtrl).then(function (treated) {
            if (!treated) {
                return _this.sitesProvider.getCurrentSite().openInBrowserWithAutoLoginIfSameSite(url);
            }
        }).finally(function () {
            modal.dismiss();
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonBlockTimelineEventsComponent.prototype, "events", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Object)
    ], AddonBlockTimelineEventsComponent.prototype, "showCourse", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlockTimelineEventsComponent.prototype, "from", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Number)
    ], AddonBlockTimelineEventsComponent.prototype, "to", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Input"])(),
        __metadata("design:type", Boolean)
    ], AddonBlockTimelineEventsComponent.prototype, "canLoadMore", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Output"])(),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["EventEmitter"])
    ], AddonBlockTimelineEventsComponent.prototype, "loadMore", void 0);
    AddonBlockTimelineEventsComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'addon-block-timeline-events',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\timeline\components\events\addon-block-timeline-events.html"*/'<ion-item-group *ngFor="let dayEvents of filteredEvents">\n    <ion-item-divider [color]="dayEvents.color">\n        <h2>{{ dayEvents.dayTimestamp * 1000 | coreFormatDate:"strftimedayshort" }}</h2>\n    </ion-item-divider>\n    <ng-container *ngFor="let event of dayEvents.events">\n        <a ion-item text-wrap detail-none class="core-course-module-handler item-media" (click)="action($event, event.url)" [title]="event.name">\n            <img item-start [src]="event.iconUrl" core-external-content alt="" role="presentation" *ngIf="event.iconUrl" class="core-module-icon">\n            <h2><core-format-text [text]="event.name"></core-format-text></h2>\n            <p *ngIf="showCourse">\n                <core-format-text [text]="event.course.fullnamedisplay"></core-format-text>\n            </p>\n\n            <button ion-button clear class="hidden-tablet" (click)="action($event, event.action.url)" [title]="event.action.name" [disabled]="!event.action.actionable" *ngIf="event.action">\n                {{event.action.name}}\n                <ion-badge item-end margin-start *ngIf="event.action.showitemcount">{{event.action.itemcount}}</ion-badge>\n            </button>\n\n            <ion-badge color="light" item-end>{{event.timesort * 1000 | coreFormatDate:"strftimetime24" }}</ion-badge>\n\n            <button ion-button clear item-end class="hidden-phone" (click)="action($event, event.action.url)" [title]="event.action.name" [disabled]="!event.action.actionable" *ngIf="event.action">\n                {{event.action.name}}\n                <ion-badge item-end margin-start *ngIf="event.action.showitemcount">{{event.action.itemcount}}</ion-badge>\n            </button>\n        </a>\n    </ng-container>\n</ion-item-group>\n\n<div padding text-center *ngIf="canLoadMore && !empty">\n    <!-- Button and spinner to show more attempts. -->\n    <button ion-button block (click)="loadMoreEvents()" color="light" *ngIf="!loadingMore">\n        {{ \'core.loadmore\' | translate }}\n    </button>\n    <ion-spinner *ngIf="loadingMore"></ion-spinner>\n</div>\n\n<core-empty-box *ngIf="empty" image="assets/img/icons/activities.svg" [message]="\'addon.block_timeline.noevents\' | translate" [inline]="!showCourse"></core-empty-box>'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\addon\block\timeline\components\events\addon-block-timeline-events.html"*/
        }),
        __param(0, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Optional"])()),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_utils_dom__["a" /* CoreDomUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_sites__["a" /* CoreSitesProvider */], __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */],
            __WEBPACK_IMPORTED_MODULE_8__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_time__["a" /* CoreTimeUtilsProvider */]])
    ], AddonBlockTimelineEventsComponent);
    return AddonBlockTimelineEventsComponent;
}());

//# sourceMappingURL=events.js.map

/***/ }),
/* 1786 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockTimelineHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_courses_providers_courses__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__addon_block_timeline_providers_timeline__ = __webpack_require__(262);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_timeline_timeline__ = __webpack_require__(935);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_block_classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Block handler.
 */
var AddonBlockTimelineHandler = /** @class */ (function (_super) {
    __extends(AddonBlockTimelineHandler, _super);
    function AddonBlockTimelineHandler(timelineProvider, coursesProvider, sitesProvider) {
        var _this = _super.call(this) || this;
        _this.timelineProvider = timelineProvider;
        _this.coursesProvider = coursesProvider;
        _this.sitesProvider = sitesProvider;
        _this.name = 'AddonBlockTimeline';
        _this.blockName = 'timeline';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonBlockTimelineHandler.prototype.isEnabled = function () {
        var _this = this;
        return this.timelineProvider.isAvailable().then(function (enabled) {
            return enabled && (_this.sitesProvider.getCurrentSite().isVersionGreaterEqualThan('3.6') ||
                !_this.coursesProvider.isMyCoursesDisabledInSite());
        });
    };
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    AddonBlockTimelineHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        return {
            title: 'addon.block_timeline.pluginname',
            class: 'addon-block-timeline',
            component: __WEBPACK_IMPORTED_MODULE_4__components_timeline_timeline__["a" /* AddonBlockTimelineComponent */]
        };
    };
    AddonBlockTimelineHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__addon_block_timeline_providers_timeline__["a" /* AddonBlockTimelineProvider */], __WEBPACK_IMPORTED_MODULE_2__core_courses_providers_courses__["a" /* CoreCoursesProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_sites__["a" /* CoreSitesProvider */]])
    ], AddonBlockTimelineHandler);
    return AddonBlockTimelineHandler;
}(__WEBPACK_IMPORTED_MODULE_5__core_block_classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1787 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedCoursesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1788);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__ = __webpack_require__(1789);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonBlockRecentlyAccessedCoursesModule = /** @class */ (function () {
    function AddonBlockRecentlyAccessedCoursesModule(blockDelegate, blockHandler) {
        blockDelegate.registerHandler(blockHandler);
    }
    AddonBlockRecentlyAccessedCoursesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonBlockRecentlyAccessedCoursesComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__["a" /* AddonBlockRecentlyAccessedCoursesHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__["a" /* AddonBlockRecentlyAccessedCoursesHandler */]])
    ], AddonBlockRecentlyAccessedCoursesModule);
    return AddonBlockRecentlyAccessedCoursesModule;
}());

//# sourceMappingURL=recentlyaccessedcourses.module.js.map

/***/ }),
/* 1788 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedCoursesComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__recentlyaccessedcourses_recentlyaccessedcourses__ = __webpack_require__(936);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_courses_components_components_module__ = __webpack_require__(182);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonBlockRecentlyAccessedCoursesComponentsModule = /** @class */ (function () {
    function AddonBlockRecentlyAccessedCoursesComponentsModule() {
    }
    AddonBlockRecentlyAccessedCoursesComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__recentlyaccessedcourses_recentlyaccessedcourses__["a" /* AddonBlockRecentlyAccessedCoursesComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_courses_components_components_module__["a" /* CoreCoursesComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__recentlyaccessedcourses_recentlyaccessedcourses__["a" /* AddonBlockRecentlyAccessedCoursesComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__recentlyaccessedcourses_recentlyaccessedcourses__["a" /* AddonBlockRecentlyAccessedCoursesComponent */]
            ]
        })
    ], AddonBlockRecentlyAccessedCoursesComponentsModule);
    return AddonBlockRecentlyAccessedCoursesComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1789 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedCoursesHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_recentlyaccessedcourses_recentlyaccessedcourses__ = __webpack_require__(936);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Block handler.
 */
var AddonBlockRecentlyAccessedCoursesHandler = /** @class */ (function (_super) {
    __extends(AddonBlockRecentlyAccessedCoursesHandler, _super);
    function AddonBlockRecentlyAccessedCoursesHandler() {
        var _this = _super.call(this) || this;
        _this.name = 'AddonBlockRecentlyAccessedCourses';
        _this.blockName = 'recentlyaccessedcourses';
        return _this;
    }
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    AddonBlockRecentlyAccessedCoursesHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        return {
            title: 'addon.block_recentlyaccessedcourses.pluginname',
            class: 'addon-block-recentlyaccessedcourses',
            component: __WEBPACK_IMPORTED_MODULE_1__components_recentlyaccessedcourses_recentlyaccessedcourses__["a" /* AddonBlockRecentlyAccessedCoursesComponent */]
        };
    };
    AddonBlockRecentlyAccessedCoursesHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonBlockRecentlyAccessedCoursesHandler);
    return AddonBlockRecentlyAccessedCoursesHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1790 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedItemsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(1791);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_block_handler__ = __webpack_require__(1792);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_recentlyaccesseditems__ = __webpack_require__(938);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonBlockRecentlyAccessedItemsModule = /** @class */ (function () {
    function AddonBlockRecentlyAccessedItemsModule(blockDelegate, blockHandler) {
        blockDelegate.registerHandler(blockHandler);
    }
    AddonBlockRecentlyAccessedItemsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* AddonBlockRecentlyAccessedItemsComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            exports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_block_handler__["a" /* AddonBlockRecentlyAccessedItemsHandler */],
                __WEBPACK_IMPORTED_MODULE_6__providers_recentlyaccesseditems__["a" /* AddonBlockRecentlyAccessedItemsProvider */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_block_handler__["a" /* AddonBlockRecentlyAccessedItemsHandler */]])
    ], AddonBlockRecentlyAccessedItemsModule);
    return AddonBlockRecentlyAccessedItemsModule;
}());

//# sourceMappingURL=recentlyaccesseditems.module.js.map

/***/ }),
/* 1791 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedItemsComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__recentlyaccesseditems_recentlyaccesseditems__ = __webpack_require__(937);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__ = __webpack_require__(41);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonBlockRecentlyAccessedItemsComponentsModule = /** @class */ (function () {
    function AddonBlockRecentlyAccessedItemsComponentsModule() {
    }
    AddonBlockRecentlyAccessedItemsComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__recentlyaccesseditems_recentlyaccesseditems__["a" /* AddonBlockRecentlyAccessedItemsComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_course_components_components_module__["a" /* CoreCourseComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__recentlyaccesseditems_recentlyaccesseditems__["a" /* AddonBlockRecentlyAccessedItemsComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__recentlyaccesseditems_recentlyaccesseditems__["a" /* AddonBlockRecentlyAccessedItemsComponent */]
            ]
        })
    ], AddonBlockRecentlyAccessedItemsComponentsModule);
    return AddonBlockRecentlyAccessedItemsComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1792 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockRecentlyAccessedItemsHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_recentlyaccesseditems_recentlyaccesseditems__ = __webpack_require__(937);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Block handler.
 */
var AddonBlockRecentlyAccessedItemsHandler = /** @class */ (function (_super) {
    __extends(AddonBlockRecentlyAccessedItemsHandler, _super);
    function AddonBlockRecentlyAccessedItemsHandler() {
        var _this = _super.call(this) || this;
        _this.name = 'AddonBlockRecentlyAccessedItems';
        _this.blockName = 'recentlyaccesseditems';
        return _this;
    }
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    AddonBlockRecentlyAccessedItemsHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        return {
            title: 'addon.block_recentlyaccesseditems.pluginname',
            class: 'addon-block-recentlyaccesseditems',
            component: __WEBPACK_IMPORTED_MODULE_1__components_recentlyaccesseditems_recentlyaccesseditems__["a" /* AddonBlockRecentlyAccessedItemsComponent */]
        };
    };
    AddonBlockRecentlyAccessedItemsHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonBlockRecentlyAccessedItemsHandler);
    return AddonBlockRecentlyAccessedItemsHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1793 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockStarredCoursesModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__ = __webpack_require__(88);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(1794);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__ = __webpack_require__(1795);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonBlockStarredCoursesModule = /** @class */ (function () {
    function AddonBlockStarredCoursesModule(blockDelegate, blockHandler) {
        blockDelegate.registerHandler(blockHandler);
    }
    AddonBlockStarredCoursesModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonBlockStarredCoursesComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild()
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__["a" /* AddonBlockStarredCoursesHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__core_block_providers_delegate__["a" /* CoreBlockDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_block_handler__["a" /* AddonBlockStarredCoursesHandler */]])
    ], AddonBlockStarredCoursesModule);
    return AddonBlockStarredCoursesModule;
}());

//# sourceMappingURL=starredcourses.module.js.map

/***/ }),
/* 1794 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockStarredCoursesComponentsModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__starredcourses_starredcourses__ = __webpack_require__(939);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_courses_components_components_module__ = __webpack_require__(182);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};








var AddonBlockStarredCoursesComponentsModule = /** @class */ (function () {
    function AddonBlockStarredCoursesComponentsModule() {
    }
    AddonBlockStarredCoursesComponentsModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__starredcourses_starredcourses__["a" /* AddonBlockStarredCoursesComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_6__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_7__core_courses_components_components_module__["a" /* CoreCoursesComponentsModule */]
            ],
            providers: [],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__starredcourses_starredcourses__["a" /* AddonBlockStarredCoursesComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__starredcourses_starredcourses__["a" /* AddonBlockStarredCoursesComponent */]
            ]
        })
    ], AddonBlockStarredCoursesComponentsModule);
    return AddonBlockStarredCoursesComponentsModule;
}());

//# sourceMappingURL=components.module.js.map

/***/ }),
/* 1795 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonBlockStarredCoursesHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_starredcourses_starredcourses__ = __webpack_require__(939);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__ = __webpack_require__(147);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Block handler.
 */
var AddonBlockStarredCoursesHandler = /** @class */ (function (_super) {
    __extends(AddonBlockStarredCoursesHandler, _super);
    function AddonBlockStarredCoursesHandler() {
        var _this = _super.call(this) || this;
        _this.name = 'AddonBlockStarredCourses';
        _this.blockName = 'starredcourses';
        return _this;
    }
    /**
     * Returns the data needed to render the block.
     *
     * @param {Injector} injector Injector.
     * @param {any} block The block to render.
     * @param {string} contextLevel The context where the block will be used.
     * @param {number} instanceId The instance ID associated with the context level.
     * @return {CoreBlockHandlerData|Promise<CoreBlockHandlerData>} Data or promise resolved with the data.
     */
    AddonBlockStarredCoursesHandler.prototype.getDisplayData = function (injector, block, contextLevel, instanceId) {
        return {
            title: 'addon.starredcourses.pluginname',
            class: 'addon-block-starredcourses',
            component: __WEBPACK_IMPORTED_MODULE_1__components_starredcourses_starredcourses__["a" /* AddonBlockStarredCoursesComponent */]
        };
    };
    AddonBlockStarredCoursesHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonBlockStarredCoursesHandler);
    return AddonBlockStarredCoursesHandler;
}(__WEBPACK_IMPORTED_MODULE_2__core_block_classes_base_block_handler__["a" /* CoreBlockBaseHandler */]));

//# sourceMappingURL=block-handler.js.map

/***/ }),
/* 1796 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export ADDON_MOD_DATA_PROVIDERS */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_cron__ = __webpack_require__(58);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(412);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__ = __webpack_require__(1797);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__ = __webpack_require__(1798);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__providers_approve_link_handler__ = __webpack_require__(1799);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__providers_delete_link_handler__ = __webpack_require__(1800);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__providers_show_link_handler__ = __webpack_require__(1801);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__providers_edit_link_handler__ = __webpack_require__(1802);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_list_link_handler__ = __webpack_require__(1803);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__providers_helper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__ = __webpack_require__(882);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__providers_sync__ = __webpack_require__(230);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__providers_sync_cron_handler__ = __webpack_require__(1804);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__providers_offline__ = __webpack_require__(191);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__providers_default_field_handler__ = __webpack_require__(881);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__fields_field_module__ = __webpack_require__(1805);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__providers_update_manager__ = __webpack_require__(65);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};























// List of providers (without handlers).
var ADDON_MOD_DATA_PROVIDERS = [
    __WEBPACK_IMPORTED_MODULE_7__providers_data__["a" /* AddonModDataProvider */],
    __WEBPACK_IMPORTED_MODULE_14__providers_helper__["a" /* AddonModDataHelperProvider */],
    __WEBPACK_IMPORTED_MODULE_16__providers_sync__["a" /* AddonModDataSyncProvider */],
    __WEBPACK_IMPORTED_MODULE_18__providers_offline__["a" /* AddonModDataOfflineProvider */],
    __WEBPACK_IMPORTED_MODULE_19__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */]
];
var AddonModDataModule = /** @class */ (function () {
    function AddonModDataModule(moduleDelegate, moduleHandler, prefetchDelegate, prefetchHandler, contentLinksDelegate, linkHandler, cronDelegate, syncHandler, updateManager, approveLinkHandler, deleteLinkHandler, showLinkHandler, editLinkHandler, listLinkHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        contentLinksDelegate.registerHandler(approveLinkHandler);
        contentLinksDelegate.registerHandler(deleteLinkHandler);
        contentLinksDelegate.registerHandler(showLinkHandler);
        contentLinksDelegate.registerHandler(editLinkHandler);
        contentLinksDelegate.registerHandler(listLinkHandler);
        cronDelegate.register(syncHandler);
        // Allow migrating the tables from the old app to the new schema.
        updateManager.registerSiteTableMigration({
            name: 'mma_mod_data_entry',
            newName: __WEBPACK_IMPORTED_MODULE_18__providers_offline__["a" /* AddonModDataOfflineProvider */].DATA_ENTRY_TABLE,
            fields: [
                {
                    name: 'fields',
                    type: 'object'
                },
                {
                    name: 'dataAndEntry',
                    delete: true
                }
            ]
        });
    }
    AddonModDataModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* AddonModDataComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_21__fields_field_module__["a" /* AddonModDataFieldModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_7__providers_data__["a" /* AddonModDataProvider */],
                __WEBPACK_IMPORTED_MODULE_14__providers_helper__["a" /* AddonModDataHelperProvider */],
                __WEBPACK_IMPORTED_MODULE_16__providers_sync__["a" /* AddonModDataSyncProvider */],
                __WEBPACK_IMPORTED_MODULE_18__providers_offline__["a" /* AddonModDataOfflineProvider */],
                __WEBPACK_IMPORTED_MODULE_19__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */],
                __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__["a" /* AddonModDataModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__["a" /* AddonModDataPrefetchHandler */],
                __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__["a" /* AddonModDataLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_9__providers_approve_link_handler__["a" /* AddonModDataApproveLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_10__providers_delete_link_handler__["a" /* AddonModDataDeleteLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_11__providers_show_link_handler__["a" /* AddonModDataShowLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_12__providers_edit_link_handler__["a" /* AddonModDataEditLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_13__providers_list_link_handler__["a" /* AddonModDataListLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_17__providers_sync_cron_handler__["a" /* AddonModDataSyncCronHandler */],
                __WEBPACK_IMPORTED_MODULE_20__providers_default_field_handler__["a" /* AddonModDataDefaultFieldHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_module_handler__["a" /* AddonModDataModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_15__providers_prefetch_handler__["a" /* AddonModDataPrefetchHandler */],
            __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_8__providers_link_handler__["a" /* AddonModDataLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_1__providers_cron__["a" /* CoreCronDelegate */], __WEBPACK_IMPORTED_MODULE_17__providers_sync_cron_handler__["a" /* AddonModDataSyncCronHandler */], __WEBPACK_IMPORTED_MODULE_22__providers_update_manager__["a" /* CoreUpdateManagerProvider */],
            __WEBPACK_IMPORTED_MODULE_9__providers_approve_link_handler__["a" /* AddonModDataApproveLinkHandler */], __WEBPACK_IMPORTED_MODULE_10__providers_delete_link_handler__["a" /* AddonModDataDeleteLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_11__providers_show_link_handler__["a" /* AddonModDataShowLinkHandler */], __WEBPACK_IMPORTED_MODULE_12__providers_edit_link_handler__["a" /* AddonModDataEditLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_13__providers_list_link_handler__["a" /* AddonModDataListLinkHandler */]])
    ], AddonModDataModule);
    return AddonModDataModule;
}());

//# sourceMappingURL=data.module.js.map

/***/ }),
/* 1797 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_index_index__ = __webpack_require__(449);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support data modules.
 */
var AddonModDataModuleHandler = /** @class */ (function () {
    function AddonModDataModuleHandler(courseProvider, dataProvider) {
        this.courseProvider = courseProvider;
        this.dataProvider = dataProvider;
        this.name = 'AddonModData';
        this.modName = 'data';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_HAS_RULES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_RATE] = true,
            _a[__WEBPACK_IMPORTED_MODULE_4__core_constants__["a" /* CoreConstants */].FEATURE_COMMENT] = true,
            _a);
        var _a;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModDataModuleHandler.prototype.isEnabled = function () {
        return this.dataProvider.isPluginEnabled();
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModDataModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        return {
            icon: this.courseProvider.getModuleIconSrc(this.modName, module.modicon),
            title: module.name,
            class: 'addon-mod_data-handler',
            showDownloadButton: true,
            action: function (event, navCtrl, module, courseId, options, params) {
                var pageParams = { module: module, courseId: courseId };
                if (params) {
                    Object.assign(pageParams, params);
                }
                navCtrl.push('AddonModDataIndexPage', pageParams, options);
            }
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     *
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any} The component to use, undefined if not found.
     */
    AddonModDataModuleHandler.prototype.getMainComponent = function (course, module) {
        return __WEBPACK_IMPORTED_MODULE_1__components_index_index__["a" /* AddonModDataIndexComponent */];
    };
    AddonModDataModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__data__["a" /* AddonModDataProvider */]])
    ], AddonModDataModuleHandler);
    return AddonModDataModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1798 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to data.
 */
var AddonModDataLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModDataLinkHandler, _super);
    function AddonModDataLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModData', 'data') || this;
        _this.name = 'AddonModDataLinkHandler';
        return _this;
    }
    AddonModDataLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModDataLinkHandler);
    return AddonModDataLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1799 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataApproveLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(153);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Content links handler for database approve/disapprove entry.
 * Match mod/data/view.php?d=6&approve=5 with a valid data id and entryid.
 */
var AddonModDataApproveLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModDataApproveLinkHandler, _super);
    function AddonModDataApproveLinkHandler(dataProvider, dataHelper) {
        var _this = _super.call(this) || this;
        _this.dataProvider = dataProvider;
        _this.dataHelper = dataHelper;
        _this.name = 'AddonModDataApproveLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModData';
        _this.pattern = /\/mod\/data\/view\.php.*([\?\&](d|approve|disapprove)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModDataApproveLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var dataId = parseInt(params.d, 10), entryId = parseInt(params.approve, 10) || parseInt(params.disapprove, 10), approve = parseInt(params.approve, 10) ? true : false;
                    _this.dataHelper.approveOrDisapproveEntry(dataId, entryId, approve, courseId, siteId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModDataApproveLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (typeof params.d == 'undefined' || (typeof params.approve == 'undefined' && typeof params.disapprove == 'undefined')) {
            // Required fields not defined. Cannot treat the URL.
            return false;
        }
        return this.dataProvider.isPluginEnabled(siteId);
    };
    AddonModDataApproveLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__data__["a" /* AddonModDataProvider */], __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* AddonModDataHelperProvider */]])
    ], AddonModDataApproveLinkHandler);
    return AddonModDataApproveLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=approve-link-handler.js.map

/***/ }),
/* 1800 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataDeleteLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__helper__ = __webpack_require__(153);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Content links handler for database delete entry.
 * Match mod/data/view.php?d=6&delete=5 with a valid data id and entryid.
 */
var AddonModDataDeleteLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModDataDeleteLinkHandler, _super);
    function AddonModDataDeleteLinkHandler(dataProvider, dataHelper) {
        var _this = _super.call(this) || this;
        _this.dataProvider = dataProvider;
        _this.dataHelper = dataHelper;
        _this.name = 'AddonModDataDeleteLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModData';
        _this.pattern = /\/mod\/data\/view\.php.*([\?\&](d|delete)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModDataDeleteLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var dataId = parseInt(params.d, 10);
                    var entryId = parseInt(params.delete, 10);
                    _this.dataHelper.showDeleteEntryModal(dataId, entryId, courseId);
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModDataDeleteLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (typeof params.d == 'undefined' || typeof params.delete == 'undefined') {
            // Required fields not defined. Cannot treat the URL.
            return false;
        }
        return this.dataProvider.isPluginEnabled(siteId);
    };
    AddonModDataDeleteLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__data__["a" /* AddonModDataProvider */], __WEBPACK_IMPORTED_MODULE_3__helper__["a" /* AddonModDataHelperProvider */]])
    ], AddonModDataDeleteLinkHandler);
    return AddonModDataDeleteLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=delete-link-handler.js.map

/***/ }),
/* 1801 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataShowLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Content links handler for database show entry.
 * Match mod/data/view.php?d=6&rid=5 with a valid data id and entryid.
 */
var AddonModDataShowLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModDataShowLinkHandler, _super);
    function AddonModDataShowLinkHandler(linkHelper, dataProvider, courseProvider, domUtils) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.dataProvider = dataProvider;
        _this.courseProvider = courseProvider;
        _this.domUtils = domUtils;
        _this.name = 'AddonModDataShowLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModData';
        _this.pattern = /\/mod\/data\/view\.php.*([\?\&](d|rid|page|group|mode)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModDataShowLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), dataId = parseInt(params.d, 10), rId = parseInt(params.rid, 10) || false, group = parseInt(params.group, 10) || false, page = parseInt(params.page, 10) || false;
                    _this.courseProvider.getModuleBasicInfoByInstance(dataId, 'data', siteId).then(function (module) {
                        var pageParams = {
                            module: module,
                            courseId: module.course
                        };
                        if (group) {
                            pageParams['group'] = group;
                        }
                        if (params.mode && params.mode == 'single') {
                            pageParams['offset'] = page || 0;
                        }
                        else if (rId) {
                            pageParams['entryId'] = rId;
                        }
                        return _this.linkHelper.goInSite(navCtrl, 'AddonModDataEntryPage', pageParams, siteId);
                    }).finally(function () {
                        // Just in case. In fact we need to dismiss the modal before showing a toast or error message.
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModDataShowLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (typeof params.d == 'undefined') {
            // Id not defined. Cannot treat the URL.
            return false;
        }
        if ((!params.mode || params.mode != 'single') && typeof params.rid == 'undefined') {
            return false;
        }
        return this.dataProvider.isPluginEnabled(siteId);
    };
    AddonModDataShowLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__data__["a" /* AddonModDataProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonModDataShowLinkHandler);
    return AddonModDataShowLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=show-link-handler.js.map

/***/ }),
/* 1802 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataEditLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Content links handler for database add or edit entry.
 * Match mod/data/edit.php?d=6&rid=6 with a valid data and optional record id.
 */
var AddonModDataEditLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModDataEditLinkHandler, _super);
    function AddonModDataEditLinkHandler(linkHelper, dataProvider, courseProvider, domUtils) {
        var _this = _super.call(this) || this;
        _this.linkHelper = linkHelper;
        _this.dataProvider = dataProvider;
        _this.courseProvider = courseProvider;
        _this.domUtils = domUtils;
        _this.name = 'AddonModDataEditLinkHandler';
        _this.featureName = 'CoreCourseModuleDelegate_AddonModData';
        _this.pattern = /\/mod\/data\/edit\.php.*([\?\&](d|rid)=\d+)/;
        return _this;
    }
    /**
     * Get the list of actions for a link (url).
     *
     * @param {string[]} siteIds List of sites the URL belongs to.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {CoreContentLinksAction[]|Promise<CoreContentLinksAction[]>} List of (or promise resolved with list of) actions.
     */
    AddonModDataEditLinkHandler.prototype.getActions = function (siteIds, url, params, courseId) {
        var _this = this;
        return [{
                action: function (siteId, navCtrl) {
                    var modal = _this.domUtils.showModalLoading(), dataId = parseInt(params.d, 10), rId = parseInt(params.rid, 10) || false;
                    _this.courseProvider.getModuleBasicInfoByInstance(dataId, 'data', siteId).then(function (module) {
                        var pageParams = {
                            module: module,
                            courseId: module.course
                        };
                        if (rId) {
                            pageParams['entryId'] = rId;
                        }
                        return _this.linkHelper.goInSite(navCtrl, 'AddonModDataEditPage', pageParams, siteId);
                    }).finally(function () {
                        // Just in case. In fact we need to dismiss the modal before showing a toast or error message.
                        modal.dismiss();
                    });
                }
            }];
    };
    /**
     * Check if the handler is enabled for a certain site (site + user) and a URL.
     * If not defined, defaults to true.
     *
     * @param {string} siteId The site ID.
     * @param {string} url The URL to treat.
     * @param {any} params The params of the URL. E.g. 'mysite.com?id=1' -> {id: 1}
     * @param {number} [courseId] Course ID related to the URL. Optional but recommended.
     * @return {boolean|Promise<boolean>} Whether the handler is enabled for the URL and site.
     */
    AddonModDataEditLinkHandler.prototype.isEnabled = function (siteId, url, params, courseId) {
        if (typeof params.d == 'undefined') {
            // Id not defined. Cannot treat the URL.
            return false;
        }
        return this.dataProvider.isPluginEnabled(siteId);
    };
    AddonModDataEditLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__data__["a" /* AddonModDataProvider */],
            __WEBPACK_IMPORTED_MODULE_4__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonModDataEditLinkHandler);
    return AddonModDataEditLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_base_handler__["a" /* CoreContentLinksHandlerBase */]));

//# sourceMappingURL=edit-link-handler.js.map

/***/ }),
/* 1803 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataListLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__data__ = __webpack_require__(64);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to treat links to data list page.
 */
var AddonModDataListLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModDataListLinkHandler, _super);
    function AddonModDataListLinkHandler(linkHelper, translate, dataProvider) {
        var _this = _super.call(this, linkHelper, translate, 'AddonModData', 'data') || this;
        _this.dataProvider = dataProvider;
        _this.name = 'AddonModDataListLinkHandler';
        return _this;
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonModDataListLinkHandler.prototype.isEnabled = function () {
        return this.dataProvider.isPluginEnabled();
    };
    AddonModDataListLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_contentlinks_providers_helper__["a" /* CoreContentLinksHelperProvider */], __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
            __WEBPACK_IMPORTED_MODULE_4__data__["a" /* AddonModDataProvider */]])
    ], AddonModDataListLinkHandler);
    return AddonModDataListLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_list_handler__["a" /* CoreContentLinksModuleListHandler */]));

//# sourceMappingURL=list-link-handler.js.map

/***/ }),
/* 1804 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataSyncCronHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__sync__ = __webpack_require__(230);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Synchronization cron handler.
 */
var AddonModDataSyncCronHandler = /** @class */ (function () {
    function AddonModDataSyncCronHandler(dataSync) {
        this.dataSync = dataSync;
        this.name = 'AddonModDataSyncCronHandler';
    }
    /**
     * Execute the process.
     * Receives the ID of the site affected, undefined for all sites.
     *
     * @param  {string} [siteId] ID of the site affected, undefined for all sites.
     * @param {boolean} [force] Wether the execution is forced (manual sync).
     * @return {Promise<any>}         Promise resolved when done, rejected if failure.
     */
    AddonModDataSyncCronHandler.prototype.execute = function (siteId, force) {
        return this.dataSync.syncAllDatabases(siteId, force);
    };
    /**
     * Get the time between consecutive executions.
     *
     * @return {number} Time between consecutive executions (in ms).
     */
    AddonModDataSyncCronHandler.prototype.getInterval = function () {
        return this.dataSync.syncInterval;
    };
    AddonModDataSyncCronHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__sync__["a" /* AddonModDataSyncProvider */]])
    ], AddonModDataSyncCronHandler);
    return AddonModDataSyncCronHandler;
}());

//# sourceMappingURL=sync-cron-handler.js.map

/***/ }),
/* 1805 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__checkbox_checkbox_module__ = __webpack_require__(1806);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__date_date_module__ = __webpack_require__(1808);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__file_file_module__ = __webpack_require__(1810);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__latlong_latlong_module__ = __webpack_require__(1812);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__menu_menu_module__ = __webpack_require__(1814);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__multimenu_multimenu_module__ = __webpack_require__(1816);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__number_number_module__ = __webpack_require__(1818);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__picture_picture_module__ = __webpack_require__(1820);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__radiobutton_radiobutton_module__ = __webpack_require__(1822);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__text_text_module__ = __webpack_require__(1824);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__textarea_textarea_module__ = __webpack_require__(1825);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__url_url_module__ = __webpack_require__(1827);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};













var AddonModDataFieldModule = /** @class */ (function () {
    function AddonModDataFieldModule() {
    }
    AddonModDataFieldModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__checkbox_checkbox_module__["a" /* AddonModDataFieldCheckboxModule */],
                __WEBPACK_IMPORTED_MODULE_2__date_date_module__["a" /* AddonModDataFieldDateModule */],
                __WEBPACK_IMPORTED_MODULE_3__file_file_module__["a" /* AddonModDataFieldFileModule */],
                __WEBPACK_IMPORTED_MODULE_4__latlong_latlong_module__["a" /* AddonModDataFieldLatlongModule */],
                __WEBPACK_IMPORTED_MODULE_5__menu_menu_module__["a" /* AddonModDataFieldMenuModule */],
                __WEBPACK_IMPORTED_MODULE_6__multimenu_multimenu_module__["a" /* AddonModDataFieldMultimenuModule */],
                __WEBPACK_IMPORTED_MODULE_7__number_number_module__["a" /* AddonModDataFieldNumberModule */],
                __WEBPACK_IMPORTED_MODULE_8__picture_picture_module__["a" /* AddonModDataFieldPictureModule */],
                __WEBPACK_IMPORTED_MODULE_9__radiobutton_radiobutton_module__["a" /* AddonModDataFieldRadiobuttonModule */],
                __WEBPACK_IMPORTED_MODULE_10__text_text_module__["a" /* AddonModDataFieldTextModule */],
                __WEBPACK_IMPORTED_MODULE_11__textarea_textarea_module__["a" /* AddonModDataFieldTextareaModule */],
                __WEBPACK_IMPORTED_MODULE_12__url_url_module__["a" /* AddonModDataFieldUrlModule */]
            ],
            providers: [],
            exports: []
        })
    ], AddonModDataFieldModule);
    return AddonModDataFieldModule;
}());

//# sourceMappingURL=field.module.js.map

/***/ }),
/* 1806 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldCheckboxModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1807);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_checkbox__ = __webpack_require__(940);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldCheckboxModule = /** @class */ (function () {
    function AddonModDataFieldCheckboxModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldCheckboxModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_checkbox__["a" /* AddonModDataFieldCheckboxComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldCheckboxHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_checkbox__["a" /* AddonModDataFieldCheckboxComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_checkbox__["a" /* AddonModDataFieldCheckboxComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldCheckboxHandler */]])
    ], AddonModDataFieldCheckboxModule);
    return AddonModDataFieldCheckboxModule;
}());

//# sourceMappingURL=checkbox.module.js.map

/***/ }),
/* 1807 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldCheckboxHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_checkbox__ = __webpack_require__(940);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Handler for checkbox data field plugin.
 */
var AddonModDataFieldCheckboxHandler = /** @class */ (function () {
    function AddonModDataFieldCheckboxHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModDataFieldCheckboxHandler';
        this.type = 'checkbox';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldCheckboxHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_checkbox__["a" /* AddonModDataFieldCheckboxComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldCheckboxHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id, reqName = 'f_' + field.id + '_allreq';
        var values = [];
        if (inputData[fieldName] && inputData[fieldName].length > 0) {
            values.push({
                name: fieldName,
                value: inputData[fieldName]
            });
            if (inputData[reqName]) {
                values.push({
                    name: reqName,
                    value: true
                });
            }
            return values;
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldCheckboxHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        return [{
                fieldid: field.id,
                value: inputData[fieldName] || []
            }];
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldCheckboxHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        originalFieldData = (originalFieldData && originalFieldData.content) || '';
        return inputData[fieldName].join('##') != originalFieldData;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldCheckboxHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || !inputData[0].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldCheckboxHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        originalContent.content = (offlineContent[''] && offlineContent[''].join('##')) || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldCheckboxHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldCheckboxHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldCheckboxHandler);
    return AddonModDataFieldCheckboxHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1808 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldDateModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1809);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_date__ = __webpack_require__(941);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__pipes_pipes_module__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.










var AddonModDataFieldDateModule = /** @class */ (function () {
    function AddonModDataFieldDateModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldDateModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_date__["a" /* AddonModDataFieldDateComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */],
                __WEBPACK_IMPORTED_MODULE_9__pipes_pipes_module__["a" /* CorePipesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldDateHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_date__["a" /* AddonModDataFieldDateComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_date__["a" /* AddonModDataFieldDateComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldDateHandler */]])
    ], AddonModDataFieldDateModule);
    return AddonModDataFieldDateModule;
}());

//# sourceMappingURL=date.module.js.map

/***/ }),
/* 1809 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldDateHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_date__ = __webpack_require__(941);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Handler for date data field plugin.
 */
var AddonModDataFieldDateHandler = /** @class */ (function () {
    function AddonModDataFieldDateHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModDataFieldDateHandler';
        this.type = 'date';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldDateHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_date__["a" /* AddonModDataFieldDateComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldDateHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id, enabledName = 'f_' + field.id + '_z';
        if (inputData[enabledName] && typeof inputData[fieldName] == 'string') {
            var values = [], date = inputData[fieldName].substr(0, 10).split('-'), year = date[0], month = date[1], day = date[2];
            values.push({
                name: fieldName + '_y',
                value: year
            });
            values.push({
                name: fieldName + '_m',
                value: month
            });
            values.push({
                name: fieldName + '_d',
                value: day
            });
            values.push({
                name: enabledName,
                value: 1
            });
            return values;
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldDateHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        if (typeof inputData[fieldName] == 'string') {
            var values = [], date = inputData[fieldName].substr(0, 10).split('-'), year = date[0], month = date[1], day = date[2];
            values.push({
                fieldid: field.id,
                subfield: 'year',
                value: year
            });
            values.push({
                fieldid: field.id,
                subfield: 'month',
                value: month
            });
            values.push({
                fieldid: field.id,
                subfield: 'day',
                value: day
            });
            return values;
        }
        return false;
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldDateHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id, input = inputData[fieldName] && inputData[fieldName].substr(0, 10) || '';
        originalFieldData = (originalFieldData && originalFieldData.content &&
            new Date(originalFieldData.content * 1000).toISOString().substr(0, 10)) || '';
        return input != originalFieldData;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldDateHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required &&
            (!inputData || inputData.length < 2 || !inputData[0].value || !inputData[1].value || !inputData[2].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldDateHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        var date = Date.UTC(offlineContent['year'] || '', offlineContent['month'] ? offlineContent['month'] - 1 : null, offlineContent['day'] || null);
        date = Math.floor(date / 1000);
        originalContent.content = date || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldDateHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldDateHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldDateHandler);
    return AddonModDataFieldDateHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1810 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldFileModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1811);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_file__ = __webpack_require__(942);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldFileModule = /** @class */ (function () {
    function AddonModDataFieldFileModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldFileModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_file__["a" /* AddonModDataFieldFileComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */],
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldFileHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_file__["a" /* AddonModDataFieldFileComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_file__["a" /* AddonModDataFieldFileComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldFileHandler */]])
    ], AddonModDataFieldFileModule);
    return AddonModDataFieldFileModule;
}());

//# sourceMappingURL=file.module.js.map

/***/ }),
/* 1811 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldFileHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__component_file__ = __webpack_require__(942);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.






/**
 * Handler for file data field plugin.
 */
var AddonModDataFieldFileHandler = /** @class */ (function () {
    function AddonModDataFieldFileHandler(translate, fileSessionprovider, fileUploaderProvider) {
        this.translate = translate;
        this.fileSessionprovider = fileSessionprovider;
        this.fileUploaderProvider = fileUploaderProvider;
        this.name = 'AddonModDataFieldFileHandler';
        this.type = 'file';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldFileHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_4__component_file__["a" /* AddonModDataFieldFileComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldFileHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id;
        if (inputData[fieldName]) {
            return [{
                    name: fieldName,
                    value: inputData[fieldName]
                }];
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldFileHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var files = this.getFieldEditFiles(field);
        return [{
                fieldid: field.id,
                subfield: 'file',
                files: files
            }];
    };
    /**
     * Get field edit files in the input data.
     *
     * @param  {any} field        Defines the field..
     * @return {any}             With name and value of the data to be sent.
     */
    AddonModDataFieldFileHandler.prototype.getFieldEditFiles = function (field) {
        return this.fileSessionprovider.getFiles(__WEBPACK_IMPORTED_MODULE_3__providers_data__["a" /* AddonModDataProvider */].COMPONENT, field.dataid + '_' + field.id);
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldFileHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var files = this.fileSessionprovider.getFiles(__WEBPACK_IMPORTED_MODULE_3__providers_data__["a" /* AddonModDataProvider */].COMPONENT, field.dataid + '_' + field.id) || [];
        var originalFiles = (originalFieldData && originalFieldData.files) || [];
        if (originalFiles.length) {
            originalFiles = [originalFiles[0]];
        }
        return this.fileUploaderProvider.areFileListDifferent(files, originalFiles);
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldFileHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || !inputData[0].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldFileHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        if (offlineContent && offlineContent.file && offlineContent.file.offline > 0 && offlineFiles && offlineFiles.length > 0) {
            originalContent.content = offlineFiles[0].filename;
            originalContent.files = [offlineFiles[0]];
        }
        else if (offlineContent && offlineContent.file && offlineContent.file.online && offlineContent.file.online.length > 0) {
            originalContent.content = offlineContent.file.online[0].filename;
            originalContent.files = [offlineContent.file.online[0]];
        }
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldFileHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldFileHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_file_session__["a" /* CoreFileSessionProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */]])
    ], AddonModDataFieldFileHandler);
    return AddonModDataFieldFileHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1812 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldLatlongModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1813);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_latlong__ = __webpack_require__(943);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldLatlongModule = /** @class */ (function () {
    function AddonModDataFieldLatlongModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldLatlongModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_latlong__["a" /* AddonModDataFieldLatlongComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldLatlongHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_latlong__["a" /* AddonModDataFieldLatlongComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_latlong__["a" /* AddonModDataFieldLatlongComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldLatlongHandler */]])
    ], AddonModDataFieldLatlongModule);
    return AddonModDataFieldLatlongModule;
}());

//# sourceMappingURL=latlong.module.js.map

/***/ }),
/* 1813 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldLatlongHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_latlong__ = __webpack_require__(943);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Handler for latlong data field plugin.
 */
var AddonModDataFieldLatlongHandler = /** @class */ (function () {
    function AddonModDataFieldLatlongHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModDataFieldLatlongHandler';
        this.type = 'latlong';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldLatlongHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_latlong__["a" /* AddonModDataFieldLatlongComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldLatlongHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id;
        if (inputData[fieldName]) {
            return [{
                    name: fieldName,
                    value: inputData[fieldName]
                }];
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldLatlongHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        return [
            {
                fieldid: field.id,
                subfield: '0',
                value: inputData[fieldName + '_0'] || ''
            },
            {
                fieldid: field.id,
                subfield: '1',
                value: inputData[fieldName + '_1'] || ''
            }
        ];
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldLatlongHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id, lat = inputData[fieldName + '_0'] || '', long = inputData[fieldName + '_1'] || '', originalLat = (originalFieldData && originalFieldData.content) || '', originalLong = (originalFieldData && originalFieldData.content1) || '';
        return lat != originalLat || long != originalLong;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldLatlongHandler.prototype.getFieldsNotifications = function (field, inputData) {
        var valueCount = 0;
        // The lat long class has two values that need to be checked.
        inputData.forEach(function (value) {
            if (typeof value.value != 'undefined' && value.value != '') {
                valueCount++;
            }
        });
        // If we get here then only one field has been filled in.
        if (valueCount == 1) {
            return this.translate.instant('addon.mod_data.latlongboth');
        }
        else if (field.required && valueCount == 0) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldLatlongHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        originalContent.content = offlineContent[0] || '';
        originalContent.content1 = offlineContent[1] || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldLatlongHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldLatlongHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldLatlongHandler);
    return AddonModDataFieldLatlongHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1814 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldMenuModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1815);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_menu__ = __webpack_require__(944);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldMenuModule = /** @class */ (function () {
    function AddonModDataFieldMenuModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldMenuModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_menu__["a" /* AddonModDataFieldMenuComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldMenuHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_menu__["a" /* AddonModDataFieldMenuComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_menu__["a" /* AddonModDataFieldMenuComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldMenuHandler */]])
    ], AddonModDataFieldMenuModule);
    return AddonModDataFieldMenuModule;
}());

//# sourceMappingURL=menu.module.js.map

/***/ }),
/* 1815 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_menu__ = __webpack_require__(944);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Handler for menu data field plugin.
 */
var AddonModDataFieldMenuHandler = /** @class */ (function () {
    function AddonModDataFieldMenuHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModDataFieldMenuHandler';
        this.type = 'menu';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldMenuHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_menu__["a" /* AddonModDataFieldMenuComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldMenuHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id;
        if (inputData[fieldName]) {
            return [{
                    name: fieldName,
                    value: inputData[fieldName]
                }];
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldMenuHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        if (inputData[fieldName]) {
            return [{
                    fieldid: field.id,
                    value: inputData[fieldName]
                }];
        }
        return false;
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldMenuHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id, input = inputData[fieldName] || '';
        originalFieldData = (originalFieldData && originalFieldData.content) || '';
        return input != originalFieldData;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldMenuHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || !inputData[0].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldMenuHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        originalContent.content = offlineContent[''] || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldMenuHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldMenuHandler);
    return AddonModDataFieldMenuHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1816 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldMultimenuModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1817);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_multimenu__ = __webpack_require__(945);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldMultimenuModule = /** @class */ (function () {
    function AddonModDataFieldMultimenuModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldMultimenuModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_multimenu__["a" /* AddonModDataFieldMultimenuComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldMultimenuHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_multimenu__["a" /* AddonModDataFieldMultimenuComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_multimenu__["a" /* AddonModDataFieldMultimenuComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldMultimenuHandler */]])
    ], AddonModDataFieldMultimenuModule);
    return AddonModDataFieldMultimenuModule;
}());

//# sourceMappingURL=multimenu.module.js.map

/***/ }),
/* 1817 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldMultimenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_multimenu__ = __webpack_require__(945);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Handler for multimenu data field plugin.
 */
var AddonModDataFieldMultimenuHandler = /** @class */ (function () {
    function AddonModDataFieldMultimenuHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModDataFieldMultimenuHandler';
        this.type = 'multimenu';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldMultimenuHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_multimenu__["a" /* AddonModDataFieldMultimenuComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldMultimenuHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id, reqName = 'f_' + field.id + '_allreq';
        if (inputData[fieldName] && inputData[fieldName].length > 0) {
            var values = [];
            values.push({
                name: fieldName,
                value: inputData[fieldName]
            });
            if (inputData[reqName]) {
                values.push({
                    name: reqName,
                    value: true
                });
            }
            return values;
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldMultimenuHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        return [{
                fieldid: field.id,
                value: inputData[fieldName] || []
            }];
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldMultimenuHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        originalFieldData = (originalFieldData && originalFieldData.content) || '';
        return inputData[fieldName].join('##') != originalFieldData;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldMultimenuHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || !inputData[0].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldMultimenuHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        originalContent.content = (offlineContent[''] && offlineContent[''].join('###')) || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldMultimenuHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldMultimenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldMultimenuHandler);
    return AddonModDataFieldMultimenuHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1818 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldNumberModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1819);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_number__ = __webpack_require__(947);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldNumberModule = /** @class */ (function () {
    function AddonModDataFieldNumberModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldNumberModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_number__["a" /* AddonModDataFieldNumberComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldNumberHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_number__["a" /* AddonModDataFieldNumberComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_number__["a" /* AddonModDataFieldNumberComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldNumberHandler */]])
    ], AddonModDataFieldNumberModule);
    return AddonModDataFieldNumberModule;
}());

//# sourceMappingURL=number.module.js.map

/***/ }),
/* 1819 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldNumberHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__text_providers_handler__ = __webpack_require__(278);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_number__ = __webpack_require__(947);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.




/**
 * Handler for number data field plugin.
 */
var AddonModDataFieldNumberHandler = /** @class */ (function (_super) {
    __extends(AddonModDataFieldNumberHandler, _super);
    function AddonModDataFieldNumberHandler(translate) {
        var _this = _super.call(this, translate) || this;
        _this.translate = translate;
        _this.name = 'AddonModDataFieldNumberHandler';
        _this.type = 'number';
        return _this;
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldNumberHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_3__component_number__["a" /* AddonModDataFieldNumberComponent */];
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldNumberHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        var input = inputData[fieldName] || '';
        originalFieldData = originalFieldData && originalFieldData.content || '';
        return input != originalFieldData;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldNumberHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || inputData[0].value == '')) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    AddonModDataFieldNumberHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldNumberHandler);
    return AddonModDataFieldNumberHandler;
}(__WEBPACK_IMPORTED_MODULE_2__text_providers_handler__["a" /* AddonModDataFieldTextHandler */]));

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1820 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldPictureModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1821);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_picture__ = __webpack_require__(948);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldPictureModule = /** @class */ (function () {
    function AddonModDataFieldPictureModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldPictureModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_picture__["a" /* AddonModDataFieldPictureComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */],
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldPictureHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_picture__["a" /* AddonModDataFieldPictureComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_picture__["a" /* AddonModDataFieldPictureComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldPictureHandler */]])
    ], AddonModDataFieldPictureModule);
    return AddonModDataFieldPictureModule;
}());

//# sourceMappingURL=picture.module.js.map

/***/ }),
/* 1821 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldPictureHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_file_session__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_data__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__component_picture__ = __webpack_require__(948);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__ = __webpack_require__(54);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.






/**
 * Handler for picture data field plugin.
 */
var AddonModDataFieldPictureHandler = /** @class */ (function () {
    function AddonModDataFieldPictureHandler(translate, fileSessionprovider, fileUploaderProvider) {
        this.translate = translate;
        this.fileSessionprovider = fileSessionprovider;
        this.fileUploaderProvider = fileUploaderProvider;
        this.name = 'AddonModDataFieldPictureHandler';
        this.type = 'picture';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldPictureHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_4__component_picture__["a" /* AddonModDataFieldPictureComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldPictureHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id;
        if (inputData[fieldName]) {
            return [{
                    name: fieldName,
                    value: inputData[fieldName]
                }];
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldPictureHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var files = this.getFieldEditFiles(field);
        var fieldName = 'f_' + field.id + '_alttext';
        return [
            {
                fieldid: field.id,
                subfield: 'file',
                files: files
            },
            {
                fieldid: field.id,
                subfield: 'alttext',
                value: inputData[fieldName]
            }
        ];
    };
    /**
     * Get field edit files in the input data.
     *
     * @param  {any} field        Defines the field..
     * @return {any}             With name and value of the data to be sent.
     */
    AddonModDataFieldPictureHandler.prototype.getFieldEditFiles = function (field) {
        return this.fileSessionprovider.getFiles(__WEBPACK_IMPORTED_MODULE_3__providers_data__["a" /* AddonModDataProvider */].COMPONENT, field.dataid + '_' + field.id);
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldPictureHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id + '_alttext', altText = inputData[fieldName] || '', originalAltText = (originalFieldData && originalFieldData.content1) || '', files = this.getFieldEditFiles(field) || [];
        var originalFiles = (originalFieldData && originalFieldData.files) || [];
        // Get image.
        if (originalFiles.length > 0) {
            var filenameSeek_1 = (originalFieldData && originalFieldData.content) || '', file = originalFiles.find(function (file) { return file.filename == filenameSeek_1; });
            if (file) {
                originalFiles = [file];
            }
        }
        else {
            originalFiles = [];
        }
        return altText != originalAltText || this.fileUploaderProvider.areFileListDifferent(files, originalFiles);
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldPictureHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required) {
            if (!inputData || !inputData.length) {
                return this.translate.instant('addon.mod_data.errormustsupplyvalue');
            }
            var found = inputData.some(function (input) {
                if (typeof input.subfield != 'undefined' && input.subfield == 'file') {
                    return !!input.value;
                }
                return false;
            });
            if (!found) {
                return this.translate.instant('addon.mod_data.errormustsupplyvalue');
            }
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldPictureHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        if (offlineContent && offlineContent.file && offlineContent.file.offline > 0 && offlineFiles && offlineFiles.length > 0) {
            originalContent.content = offlineFiles[0].filename;
            originalContent.files = [offlineFiles[0]];
        }
        else if (offlineContent && offlineContent.file && offlineContent.file.online && offlineContent.file.online.length > 0) {
            originalContent.content = offlineContent.file.online[0].filename;
            originalContent.files = [offlineContent.file.online[0]];
        }
        originalContent.content1 = offlineContent.alttext || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldPictureHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldPictureHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_file_session__["a" /* CoreFileSessionProvider */],
            __WEBPACK_IMPORTED_MODULE_5__core_fileuploader_providers_fileuploader__["a" /* CoreFileUploaderProvider */]])
    ], AddonModDataFieldPictureHandler);
    return AddonModDataFieldPictureHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1822 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldRadiobuttonModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1823);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_radiobutton__ = __webpack_require__(949);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldRadiobuttonModule = /** @class */ (function () {
    function AddonModDataFieldRadiobuttonModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldRadiobuttonModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_radiobutton__["a" /* AddonModDataFieldRadiobuttonComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldRadiobuttonHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_radiobutton__["a" /* AddonModDataFieldRadiobuttonComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_radiobutton__["a" /* AddonModDataFieldRadiobuttonComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldRadiobuttonHandler */]])
    ], AddonModDataFieldRadiobuttonModule);
    return AddonModDataFieldRadiobuttonModule;
}());

//# sourceMappingURL=radiobutton.module.js.map

/***/ }),
/* 1823 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldRadiobuttonHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_radiobutton__ = __webpack_require__(949);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Handler for checkbox data field plugin.
 */
var AddonModDataFieldRadiobuttonHandler = /** @class */ (function () {
    function AddonModDataFieldRadiobuttonHandler(translate) {
        this.translate = translate;
        this.name = 'AddonModDataFieldRadiobuttonHandler';
        this.type = 'radiobutton';
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldRadiobuttonHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_2__component_radiobutton__["a" /* AddonModDataFieldRadiobuttonComponent */];
    };
    /**
     * Get field search data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the search form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldRadiobuttonHandler.prototype.getFieldSearchData = function (field, inputData) {
        var fieldName = 'f_' + field.id;
        if (inputData[fieldName]) {
            return [{
                    name: fieldName,
                    value: inputData[fieldName]
                }];
        }
        return false;
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldRadiobuttonHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        return [{
                fieldid: field.id,
                value: inputData[fieldName] || ''
            }];
    };
    /**
     * Get field data in changed.
     *
     * @param  {any} field                  Defines the field to be rendered.
     * @param  {any} inputData              Data entered in the edit form.
     * @param  {any} originalFieldData      Original field entered data.
     * @return {Promise<boolean> | boolean} If the field has changes.
     */
    AddonModDataFieldRadiobuttonHandler.prototype.hasFieldDataChanged = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id, input = inputData[fieldName] || '';
        originalFieldData = (originalFieldData && originalFieldData.content) || '';
        return input != originalFieldData;
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldRadiobuttonHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || !inputData[0].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldRadiobuttonHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        originalContent.content = offlineContent[''] || '';
        return originalContent;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonModDataFieldRadiobuttonHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonModDataFieldRadiobuttonHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldRadiobuttonHandler);
    return AddonModDataFieldRadiobuttonHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1824 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldTextModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(278);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_text__ = __webpack_require__(946);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldTextModule = /** @class */ (function () {
    function AddonModDataFieldTextModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldTextModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_text__["a" /* AddonModDataFieldTextComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldTextHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_text__["a" /* AddonModDataFieldTextComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_text__["a" /* AddonModDataFieldTextComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldTextHandler */]])
    ], AddonModDataFieldTextModule);
    return AddonModDataFieldTextModule;
}());

//# sourceMappingURL=text.module.js.map

/***/ }),
/* 1825 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldTextareaModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1826);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_textarea__ = __webpack_require__(950);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldTextareaModule = /** @class */ (function () {
    function AddonModDataFieldTextareaModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldTextareaModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_textarea__["a" /* AddonModDataFieldTextareaComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldTextareaHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_textarea__["a" /* AddonModDataFieldTextareaComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_textarea__["a" /* AddonModDataFieldTextareaComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldTextareaHandler */]])
    ], AddonModDataFieldTextareaModule);
    return AddonModDataFieldTextareaModule;
}());

//# sourceMappingURL=textarea.module.js.map

/***/ }),
/* 1826 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldTextareaHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__text_providers_handler__ = __webpack_require__(278);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_textarea__ = __webpack_require__(950);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__ = __webpack_require__(11);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





/**
 * Handler for textarea data field plugin.
 */
var AddonModDataFieldTextareaHandler = /** @class */ (function (_super) {
    __extends(AddonModDataFieldTextareaHandler, _super);
    function AddonModDataFieldTextareaHandler(translate, textUtils) {
        var _this = _super.call(this, translate) || this;
        _this.translate = translate;
        _this.textUtils = textUtils;
        _this.name = 'AddonModDataFieldTextareaHandler';
        _this.type = 'textarea';
        return _this;
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldTextareaHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_3__component_textarea__["a" /* AddonModDataFieldTextareaComponent */];
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldTextareaHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        var files = this.getFieldEditFiles(field, inputData, originalFieldData);
        var text = this.textUtils.restorePluginfileUrls(inputData[fieldName] || '', files);
        // Add some HTML to the text if needed.
        text = this.textUtils.formatHtmlLines(text);
        // WS does not properly check if HTML content is blank when the field is required.
        if (this.textUtils.htmlIsBlank(text)) {
            text = '';
        }
        return [
            {
                fieldid: field.id,
                value: text
            },
            {
                fieldid: field.id,
                subfield: 'content1',
                value: 1
            },
            {
                fieldid: field.id,
                subfield: 'itemid',
                files: files
            }
        ];
    };
    /**
     * Get field edit files in the input data.
     *
     * @param  {any} field               Defines the field..
     * @param  {any} inputData           Data entered in the edit form.
     * @param  {any} originalFieldData   Original field entered data.
     * @return {any}                     With name and value of the data to be sent.
     */
    AddonModDataFieldTextareaHandler.prototype.getFieldEditFiles = function (field, inputData, originalFieldData) {
        return (originalFieldData && originalFieldData.files) || [];
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldTextareaHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required) {
            if (!inputData || !inputData.length) {
                return this.translate.instant('addon.mod_data.errormustsupplyvalue');
            }
            var value = inputData.find(function (value) { return value.subfield == ''; });
            if (!value || this.textUtils.htmlIsBlank(value.value)) {
                return this.translate.instant('addon.mod_data.errormustsupplyvalue');
            }
        }
        return false;
    };
    /**
     * Override field content data with offline submission.
     *
     * @param  {any}  originalContent    Original data to be overriden.
     * @param  {any}  offlineContent     Array with all the offline data to override.
     * @param  {any}  [offlineFiles]     Array with all the offline files in the field.
     * @return {any}                     Data overriden
     */
    AddonModDataFieldTextareaHandler.prototype.overrideData = function (originalContent, offlineContent, offlineFiles) {
        originalContent.content = offlineContent[''] || '';
        if (originalContent.content.length > 0 && originalContent.files && originalContent.files.length > 0) {
            // Take the original files since we cannot edit them on the app.
            originalContent.content = this.textUtils.replacePluginfileUrls(originalContent.content, originalContent.files);
        }
        return originalContent;
    };
    AddonModDataFieldTextareaHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_4__providers_utils_text__["a" /* CoreTextUtilsProvider */]])
    ], AddonModDataFieldTextareaHandler);
    return AddonModDataFieldTextareaHandler;
}(__WEBPACK_IMPORTED_MODULE_2__text_providers_handler__["a" /* AddonModDataFieldTextHandler */]));

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1827 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldUrlModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_handler__ = __webpack_require__(1828);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_url__ = __webpack_require__(951);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









var AddonModDataFieldUrlModule = /** @class */ (function () {
    function AddonModDataFieldUrlModule(fieldDelegate, handler) {
        fieldDelegate.registerHandler(handler);
    }
    AddonModDataFieldUrlModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_url__["a" /* AddonModDataFieldUrlComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__angular_common__["CommonModule"],
                __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_7__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_8__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldUrlHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_url__["a" /* AddonModDataFieldUrlComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_url__["a" /* AddonModDataFieldUrlComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__providers_fields_delegate__["a" /* AddonModDataFieldsDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_handler__["a" /* AddonModDataFieldUrlHandler */]])
    ], AddonModDataFieldUrlModule);
    return AddonModDataFieldUrlModule;
}());

//# sourceMappingURL=url.module.js.map

/***/ }),
/* 1828 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModDataFieldUrlHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__text_providers_handler__ = __webpack_require__(278);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_url__ = __webpack_require__(951);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.




/**
 * Handler for url data field plugin.
 */
var AddonModDataFieldUrlHandler = /** @class */ (function (_super) {
    __extends(AddonModDataFieldUrlHandler, _super);
    function AddonModDataFieldUrlHandler(translate) {
        var _this = _super.call(this, translate) || this;
        _this.translate = translate;
        _this.name = 'AddonModDataFieldUrlHandler';
        _this.type = 'url';
        return _this;
    }
    /**
     * Return the Component to use to display the plugin data.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} field         The field object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModDataFieldUrlHandler.prototype.getComponent = function (injector, plugin) {
        return __WEBPACK_IMPORTED_MODULE_3__component_url__["a" /* AddonModDataFieldUrlComponent */];
    };
    /**
     * Get field edit data in the input data.
     *
     * @param  {any} field      Defines the field to be rendered.
     * @param  {any} inputData  Data entered in the edit form.
     * @return {any}            With name and value of the data to be sent.
     */
    AddonModDataFieldUrlHandler.prototype.getFieldEditData = function (field, inputData, originalFieldData) {
        var fieldName = 'f_' + field.id;
        return [
            {
                fieldid: field.id,
                subfield: '0',
                value: (inputData[fieldName] && inputData[fieldName].trim()) || ''
            }
        ];
    };
    /**
     * Check and get field requeriments.
     *
     * @param  {any} field               Defines the field to be rendered.
     * @param  {any} inputData           Data entered in the edit form.
     * @return {string | false}                  String with the notification or false.
     */
    AddonModDataFieldUrlHandler.prototype.getFieldsNotifications = function (field, inputData) {
        if (field.required && (!inputData || !inputData.length || !inputData[0].value)) {
            return this.translate.instant('addon.mod_data.errormustsupplyvalue');
        }
        return false;
    };
    AddonModDataFieldUrlHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
    ], AddonModDataFieldUrlHandler);
    return AddonModDataFieldUrlHandler;
}(__WEBPACK_IMPORTED_MODULE_2__text_providers_handler__["a" /* AddonModDataFieldTextHandler */]));

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1829 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLabelModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_label__ = __webpack_require__(952);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__ = __webpack_require__(1830);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_link_handler__ = __webpack_require__(1831);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__ = __webpack_require__(1832);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_delegate__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_delegate__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_prefetch_delegate__ = __webpack_require__(27);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonModLabelModule = /** @class */ (function () {
    function AddonModLabelModule(moduleDelegate, moduleHandler, contentLinksDelegate, linkHandler, prefetchDelegate, prefetchHandler) {
        moduleDelegate.registerHandler(moduleHandler);
        contentLinksDelegate.registerHandler(linkHandler);
        prefetchDelegate.registerHandler(prefetchHandler);
    }
    AddonModLabelModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_label__["a" /* AddonModLabelProvider */],
                __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModLabelModuleHandler */],
                __WEBPACK_IMPORTED_MODULE_3__providers_link_handler__["a" /* AddonModLabelLinkHandler */],
                __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModLabelPrefetchHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__core_course_providers_module_delegate__["a" /* CoreCourseModuleDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_module_handler__["a" /* AddonModLabelModuleHandler */],
            __WEBPACK_IMPORTED_MODULE_6__core_contentlinks_providers_delegate__["a" /* CoreContentLinksDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_link_handler__["a" /* AddonModLabelLinkHandler */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_module_prefetch_delegate__["a" /* CoreCourseModulePrefetchDelegate */], __WEBPACK_IMPORTED_MODULE_4__providers_prefetch_handler__["a" /* AddonModLabelPrefetchHandler */]])
    ], AddonModLabelModule);
    return AddonModLabelModule;
}());

//# sourceMappingURL=label.module.js.map

/***/ }),
/* 1830 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLabelModuleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_constants__ = __webpack_require__(21);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support label modules.
 */
var AddonModLabelModuleHandler = /** @class */ (function () {
    function AddonModLabelModuleHandler() {
        this.name = 'AddonModLabel';
        this.modName = 'label';
        this.supportedFeatures = (_a = {},
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_MOD_ARCHETYPE] = __WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].MOD_ARCHETYPE_RESOURCE,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_IDNUMBER] = true,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_GROUPS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_GROUPINGS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_MOD_INTRO] = true,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_COMPLETION_TRACKS_VIEWS] = false,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_HAS_GRADE] = false,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_GRADE_OUTCOMES] = false,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_BACKUP_MOODLE2] = true,
            _a[__WEBPACK_IMPORTED_MODULE_1__core_constants__["a" /* CoreConstants */].FEATURE_SHOW_DESCRIPTION] = true,
            _a);
        var _a;
        // Nothing to do.
    }
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean} Whether or not the handler is enabled on a site level.
     */
    AddonModLabelModuleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Get the data required to display the module in the course contents view.
     *
     * @param {any} module The module object.
     * @param {number} courseId The course ID.
     * @param {number} sectionId The section ID.
     * @return {CoreCourseModuleHandlerData} Data to render the module.
     */
    AddonModLabelModuleHandler.prototype.getData = function (module, courseId, sectionId) {
        // Remove the description from the module so it isn't rendered twice.
        var title = module.description;
        module.description = '';
        return {
            icon: '',
            title: title,
            a11yTitle: '',
            class: 'addon-mod-label-handler'
        };
    };
    /**
     * Get the component to render the module. This is needed to support singleactivity course format.
     * The component returned must implement CoreCourseModuleMainComponent.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} course The course object.
     * @param {any} module The module object.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonModLabelModuleHandler.prototype.getMainComponent = function (injector, course, module) {
        // There's no need to implement this because label cannot be used in singleactivity course format.
    };
    AddonModLabelModuleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonModLabelModuleHandler);
    return AddonModLabelModuleHandler;
}());

//# sourceMappingURL=module-handler.js.map

/***/ }),
/* 1831 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLabelLinkHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__ = __webpack_require__(51);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__ = __webpack_require__(20);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to treat links to label.
 */
var AddonModLabelLinkHandler = /** @class */ (function (_super) {
    __extends(AddonModLabelLinkHandler, _super);
    function AddonModLabelLinkHandler(courseHelper) {
        var _this = _super.call(this, courseHelper, 'AddonModLabel', 'label') || this;
        _this.name = 'AddonModLabelLinkHandler';
        return _this;
    }
    AddonModLabelLinkHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_helper__["a" /* CoreCourseHelperProvider */]])
    ], AddonModLabelLinkHandler);
    return AddonModLabelLinkHandler;
}(__WEBPACK_IMPORTED_MODULE_1__core_contentlinks_classes_module_index_handler__["a" /* CoreContentLinksModuleIndexHandler */]));

//# sourceMappingURL=link-handler.js.map

/***/ }),
/* 1832 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonModLabelPrefetchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_app__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_filepool__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__providers_sites__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__label__ = __webpack_require__(952);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










/**
 * Handler to prefetch labels.
 */
var AddonModLabelPrefetchHandler = /** @class */ (function (_super) {
    __extends(AddonModLabelPrefetchHandler, _super);
    function AddonModLabelPrefetchHandler(translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils, labelProvider) {
        var _this = _super.call(this, translate, appProvider, utils, courseProvider, filepoolProvider, sitesProvider, domUtils) || this;
        _this.labelProvider = labelProvider;
        _this.name = 'AddonModLabel';
        _this.modName = 'label';
        _this.component = __WEBPACK_IMPORTED_MODULE_9__label__["a" /* AddonModLabelProvider */].COMPONENT;
        _this.updatesNames = /^.*files$/;
        _this.skipListStatus = true;
        return _this;
    }
    /**
     * Returns module intro files.
     *
     * @param {any} module The module object returned by WS.
     * @param {number} courseId Course ID.
     * @param {boolean} [ignoreCache] True if it should ignore cached data (it will always fail in offline or server down).
     * @return {Promise<any[]>} Promise resolved with list of intro files.
     */
    AddonModLabelPrefetchHandler.prototype.getIntroFiles = function (module, courseId, ignoreCache) {
        var _this = this;
        var promise;
        if (this.labelProvider.isGetLabelAvailableForSite()) {
            promise = this.labelProvider.getLabel(courseId, module.id, false, ignoreCache);
        }
        else {
            promise = Promise.resolve();
        }
        return promise.then(function (label) {
            return _this.getIntroFilesFromInstance(module, label);
        });
    };
    /**
     * Invalidate the prefetched content.
     *
     * @param {number} moduleId The module ID.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when the data is invalidated.
     */
    AddonModLabelPrefetchHandler.prototype.invalidateContent = function (moduleId, courseId) {
        return this.labelProvider.invalidateContent(moduleId, courseId);
    };
    /**
     * Invalidate WS calls needed to determine module status.
     *
     * @param {any} module Module.
     * @param {number} courseId Course ID the module belongs to.
     * @return {Promise<any>} Promise resolved when invalidated.
     */
    AddonModLabelPrefetchHandler.prototype.invalidateModule = function (module, courseId) {
        var promises = [];
        promises.push(this.labelProvider.invalidateLabelData(courseId));
        promises.push(this.courseProvider.invalidateModule(module.id));
        return this.utils.allPromises(promises);
    };
    AddonModLabelPrefetchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */], __WEBPACK_IMPORTED_MODULE_2__providers_app__["a" /* CoreAppProvider */], __WEBPACK_IMPORTED_MODULE_6__providers_utils_utils__["a" /* CoreUtilsProvider */],
            __WEBPACK_IMPORTED_MODULE_7__core_course_providers_course__["a" /* CoreCourseProvider */], __WEBPACK_IMPORTED_MODULE_3__providers_filepool__["a" /* CoreFilepoolProvider */], __WEBPACK_IMPORTED_MODULE_4__providers_sites__["a" /* CoreSitesProvider */],
            __WEBPACK_IMPORTED_MODULE_5__providers_utils_dom__["a" /* CoreDomUtilsProvider */], __WEBPACK_IMPORTED_MODULE_9__label__["a" /* AddonModLabelProvider */]])
    ], AddonModLabelPrefetchHandler);
    return AddonModLabelPrefetchHandler;
}(__WEBPACK_IMPORTED_MODULE_8__core_course_classes_resource_prefetch_handler__["a" /* CoreCourseResourcePrefetchHandlerBase */]));

//# sourceMappingURL=prefetch-handler.js.map

/***/ }),
/* 1833 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessageOutputAirnotifierModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__addon_messageoutput_providers_delegate__ = __webpack_require__(286);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_airnotifier__ = __webpack_require__(419);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_handler__ = __webpack_require__(1834);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var AddonMessageOutputAirnotifierModule = /** @class */ (function () {
    function AddonMessageOutputAirnotifierModule(messageOutputDelegate, airnotifierHandler) {
        messageOutputDelegate.registerHandler(airnotifierHandler);
    }
    AddonMessageOutputAirnotifierModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_airnotifier__["a" /* AddonMessageOutputAirnotifierProvider */],
                __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonMessageOutputAirnotifierHandler */],
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__addon_messageoutput_providers_delegate__["a" /* AddonMessageOutputDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonMessageOutputAirnotifierHandler */]])
    ], AddonMessageOutputAirnotifierModule);
    return AddonMessageOutputAirnotifierModule;
}());

//# sourceMappingURL=airnotifier.module.js.map

/***/ }),
/* 1834 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonMessageOutputAirnotifierHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__airnotifier__ = __webpack_require__(419);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Airnotifier message output handler.
 */
var AddonMessageOutputAirnotifierHandler = /** @class */ (function () {
    function AddonMessageOutputAirnotifierHandler(airnotifierProvider) {
        this.airnotifierProvider = airnotifierProvider;
        this.name = 'AddonMessageOutputAirnotifier';
        this.processorName = 'airnotifier';
    }
    /**
     * Whether or not the module is enabled for the site.
     *
     * @return {boolean} True if enabled, false otherwise.
     */
    AddonMessageOutputAirnotifierHandler.prototype.isEnabled = function () {
        return this.airnotifierProvider.isEnabled();
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @param {any} processor The processor object.
     * @return {CoreMainMenuHandlerData} Data.
     */
    AddonMessageOutputAirnotifierHandler.prototype.getDisplayData = function (processor) {
        return {
            priority: 600,
            label: 'addon.messageoutput_airnotifier.processorsettingsdesc',
            icon: 'settings',
            page: 'AddonMessageOutputAirnotifierDevicesPage',
        };
    };
    AddonMessageOutputAirnotifierHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__airnotifier__["a" /* AddonMessageOutputAirnotifierProvider */]])
    ], AddonMessageOutputAirnotifierHandler);
    return AddonMessageOutputAirnotifierHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1835 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__adaptive_adaptive_module__ = __webpack_require__(1836);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__adaptivenopenalty_adaptivenopenalty_module__ = __webpack_require__(1838);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__deferredcbm_deferredcbm_module__ = __webpack_require__(1840);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__deferredfeedback_deferredfeedback_module__ = __webpack_require__(1842);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__immediatecbm_immediatecbm_module__ = __webpack_require__(1843);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__immediatefeedback_immediatefeedback_module__ = __webpack_require__(1845);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__informationitem_informationitem_module__ = __webpack_require__(1847);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__interactive_interactive_module__ = __webpack_require__(1849);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__interactivecountback_interactivecountback_module__ = __webpack_require__(1851);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__manualgraded_manualgraded_module__ = __webpack_require__(1853);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.











var AddonQbehaviourModule = /** @class */ (function () {
    function AddonQbehaviourModule() {
    }
    AddonQbehaviourModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__adaptive_adaptive_module__["a" /* AddonQbehaviourAdaptiveModule */],
                __WEBPACK_IMPORTED_MODULE_2__adaptivenopenalty_adaptivenopenalty_module__["a" /* AddonQbehaviourAdaptiveNoPenaltyModule */],
                __WEBPACK_IMPORTED_MODULE_3__deferredcbm_deferredcbm_module__["a" /* AddonQbehaviourDeferredCBMModule */],
                __WEBPACK_IMPORTED_MODULE_4__deferredfeedback_deferredfeedback_module__["a" /* AddonQbehaviourDeferredFeedbackModule */],
                __WEBPACK_IMPORTED_MODULE_5__immediatecbm_immediatecbm_module__["a" /* AddonQbehaviourImmediateCBMModule */],
                __WEBPACK_IMPORTED_MODULE_6__immediatefeedback_immediatefeedback_module__["a" /* AddonQbehaviourImmediateFeedbackModule */],
                __WEBPACK_IMPORTED_MODULE_7__informationitem_informationitem_module__["a" /* AddonQbehaviourInformationItemModule */],
                __WEBPACK_IMPORTED_MODULE_8__interactive_interactive_module__["a" /* AddonQbehaviourInteractiveModule */],
                __WEBPACK_IMPORTED_MODULE_9__interactivecountback_interactivecountback_module__["a" /* AddonQbehaviourInteractiveCountbackModule */],
                __WEBPACK_IMPORTED_MODULE_10__manualgraded_manualgraded_module__["a" /* AddonQbehaviourManualGradedModule */]
            ],
            providers: [],
            exports: []
        })
    ], AddonQbehaviourModule);
    return AddonQbehaviourModule;
}());

//# sourceMappingURL=qbehaviour.module.js.map

/***/ }),
/* 1836 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourAdaptiveModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1837);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourAdaptiveModule = /** @class */ (function () {
    function AddonQbehaviourAdaptiveModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourAdaptiveModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourAdaptiveHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourAdaptiveHandler */]])
    ], AddonQbehaviourAdaptiveModule);
    return AddonQbehaviourAdaptiveModule;
}());

//# sourceMappingURL=adaptive.module.js.map

/***/ }),
/* 1837 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourAdaptiveHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support adaptive question behaviour.
 */
var AddonQbehaviourAdaptiveHandler = /** @class */ (function () {
    function AddonQbehaviourAdaptiveHandler(questionHelper) {
        this.questionHelper = questionHelper;
        this.name = 'AddonQbehaviourAdaptive';
        this.type = 'adaptive';
        // Nothing to do.
    }
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourAdaptiveHandler.prototype.handleQuestion = function (injector, question) {
        // Just extract the button, it doesn't need any specific component.
        this.questionHelper.extractQbehaviourButtons(question);
        return;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourAdaptiveHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourAdaptiveHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQbehaviourAdaptiveHandler);
    return AddonQbehaviourAdaptiveHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1838 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourAdaptiveNoPenaltyModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1839);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourAdaptiveNoPenaltyModule = /** @class */ (function () {
    function AddonQbehaviourAdaptiveNoPenaltyModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourAdaptiveNoPenaltyModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourAdaptiveNoPenaltyHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourAdaptiveNoPenaltyHandler */]])
    ], AddonQbehaviourAdaptiveNoPenaltyModule);
    return AddonQbehaviourAdaptiveNoPenaltyModule;
}());

//# sourceMappingURL=adaptivenopenalty.module.js.map

/***/ }),
/* 1839 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourAdaptiveNoPenaltyHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support adaptive no penalty question behaviour.
 */
var AddonQbehaviourAdaptiveNoPenaltyHandler = /** @class */ (function () {
    function AddonQbehaviourAdaptiveNoPenaltyHandler(questionHelper) {
        this.questionHelper = questionHelper;
        this.name = 'AddonQbehaviourAdaptiveNoPenalty';
        this.type = 'adaptivenopenalty';
        // Nothing to do.
    }
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourAdaptiveNoPenaltyHandler.prototype.handleQuestion = function (injector, question) {
        // Just extract the button, it doesn't need any specific component.
        this.questionHelper.extractQbehaviourButtons(question);
        return;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourAdaptiveNoPenaltyHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourAdaptiveNoPenaltyHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQbehaviourAdaptiveNoPenaltyHandler);
    return AddonQbehaviourAdaptiveNoPenaltyHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1840 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourDeferredCBMModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_handler__ = __webpack_require__(1841);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_deferredcbm__ = __webpack_require__(404);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonQbehaviourDeferredCBMModule = /** @class */ (function () {
    function AddonQbehaviourDeferredCBMModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourDeferredCBMModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_deferredcbm__["a" /* AddonQbehaviourDeferredCBMComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQbehaviourDeferredCBMHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_deferredcbm__["a" /* AddonQbehaviourDeferredCBMComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_deferredcbm__["a" /* AddonQbehaviourDeferredCBMComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQbehaviourDeferredCBMHandler */]])
    ], AddonQbehaviourDeferredCBMModule);
    return AddonQbehaviourDeferredCBMModule;
}());

//# sourceMappingURL=deferredcbm.module.js.map

/***/ }),
/* 1841 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourDeferredCBMHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__addon_qbehaviour_deferredfeedback_providers_handler__ = __webpack_require__(953);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__component_deferredcbm__ = __webpack_require__(404);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Handler to support deferred CBM question behaviour.
 */
var AddonQbehaviourDeferredCBMHandler = /** @class */ (function () {
    function AddonQbehaviourDeferredCBMHandler(questionDelegate, questionHelper, deferredFeedbackHandler) {
        this.questionDelegate = questionDelegate;
        this.questionHelper = questionHelper;
        this.deferredFeedbackHandler = deferredFeedbackHandler;
        this.name = 'AddonQbehaviourDeferredCBM';
        this.type = 'deferredcbm';
        // Nothing to do.
    }
    /**
     * Determine a question new state based on its answer(s).
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {CoreQuestionState|Promise<CoreQuestionState>} New state (or promise resolved with state).
     */
    AddonQbehaviourDeferredCBMHandler.prototype.determineNewState = function (component, attemptId, question, siteId) {
        // Depends on deferredfeedback.
        return this.deferredFeedbackHandler.determineNewStateDeferred(component, attemptId, question, siteId, this.isCompleteResponse.bind(this), this.isSameResponse.bind(this));
    };
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourDeferredCBMHandler.prototype.handleQuestion = function (injector, question) {
        if (this.questionHelper.extractQbehaviourCBM(question)) {
            return [__WEBPACK_IMPORTED_MODULE_4__component_deferredcbm__["a" /* AddonQbehaviourDeferredCBMComponent */]];
        }
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQbehaviourDeferredCBMHandler.prototype.isCompleteResponse = function (question, answers) {
        // First check if the question answer is complete.
        var complete = this.questionDelegate.isCompleteResponse(question, answers);
        if (complete > 0) {
            // Answer is complete, check the user answered CBM too.
            return answers['-certainty'] ? 1 : 0;
        }
        return complete;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourDeferredCBMHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} prevBasicAnswers Object with the previous basic" answers (without sequencecheck, certainty, ...).
     * @param {any} newAnswers Object with the new question answers.
     * @param {any} newBasicAnswers Object with the previous basic" answers (without sequencecheck, certainty, ...).
     * @return {boolean} Whether they're the same.
     */
    AddonQbehaviourDeferredCBMHandler.prototype.isSameResponse = function (question, prevAnswers, prevBasicAnswers, newAnswers, newBasicAnswers) {
        // First check if the question answer is the same.
        var same = this.questionDelegate.isSameResponse(question, prevBasicAnswers, newBasicAnswers);
        if (same) {
            // Same response, check the CBM is the same too.
            return prevAnswers['-certainty'] == newAnswers['-certainty'];
        }
        return same;
    };
    AddonQbehaviourDeferredCBMHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_3__addon_qbehaviour_deferredfeedback_providers_handler__["a" /* AddonQbehaviourDeferredFeedbackHandler */]])
    ], AddonQbehaviourDeferredCBMHandler);
    return AddonQbehaviourDeferredCBMHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1842 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourDeferredFeedbackModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(953);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourDeferredFeedbackModule = /** @class */ (function () {
    function AddonQbehaviourDeferredFeedbackModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourDeferredFeedbackModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourDeferredFeedbackHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourDeferredFeedbackHandler */]])
    ], AddonQbehaviourDeferredFeedbackModule);
    return AddonQbehaviourDeferredFeedbackModule;
}());

//# sourceMappingURL=deferredfeedback.module.js.map

/***/ }),
/* 1843 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourImmediateCBMModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1844);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourImmediateCBMModule = /** @class */ (function () {
    function AddonQbehaviourImmediateCBMModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourImmediateCBMModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourImmediateCBMHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourImmediateCBMHandler */]])
    ], AddonQbehaviourImmediateCBMModule);
    return AddonQbehaviourImmediateCBMModule;
}());

//# sourceMappingURL=immediatecbm.module.js.map

/***/ }),
/* 1844 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourImmediateCBMHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__addon_qbehaviour_deferredcbm_component_deferredcbm__ = __webpack_require__(404);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support immediate CBM question behaviour.
 */
var AddonQbehaviourImmediateCBMHandler = /** @class */ (function () {
    function AddonQbehaviourImmediateCBMHandler(questionHelper) {
        this.questionHelper = questionHelper;
        this.name = 'AddonQbehaviourImmediateCBM';
        this.type = 'immediatecbm';
        // Nothing to do.
    }
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourImmediateCBMHandler.prototype.handleQuestion = function (injector, question) {
        // Just extract the button, it doesn't need any specific component.
        this.questionHelper.extractQbehaviourButtons(question);
        if (this.questionHelper.extractQbehaviourCBM(question)) {
            // Depends on deferredcbm.
            return [__WEBPACK_IMPORTED_MODULE_2__addon_qbehaviour_deferredcbm_component_deferredcbm__["a" /* AddonQbehaviourDeferredCBMComponent */]];
        }
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourImmediateCBMHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourImmediateCBMHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQbehaviourImmediateCBMHandler);
    return AddonQbehaviourImmediateCBMHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1845 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourImmediateFeedbackModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1846);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourImmediateFeedbackModule = /** @class */ (function () {
    function AddonQbehaviourImmediateFeedbackModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourImmediateFeedbackModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourImmediateFeedbackHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourImmediateFeedbackHandler */]])
    ], AddonQbehaviourImmediateFeedbackModule);
    return AddonQbehaviourImmediateFeedbackModule;
}());

//# sourceMappingURL=immediatefeedback.module.js.map

/***/ }),
/* 1846 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourImmediateFeedbackHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support immediate feedback question behaviour.
 */
var AddonQbehaviourImmediateFeedbackHandler = /** @class */ (function () {
    function AddonQbehaviourImmediateFeedbackHandler(questionHelper) {
        this.questionHelper = questionHelper;
        this.name = 'AddonQbehaviourImmediateFeedback';
        this.type = 'immediatefeedback';
        // Nothing to do.
    }
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourImmediateFeedbackHandler.prototype.handleQuestion = function (injector, question) {
        // Just extract the button, it doesn't need any specific component.
        this.questionHelper.extractQbehaviourButtons(question);
        return;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourImmediateFeedbackHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourImmediateFeedbackHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQbehaviourImmediateFeedbackHandler);
    return AddonQbehaviourImmediateFeedbackHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1847 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourInformationItemModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_handler__ = __webpack_require__(1848);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__component_informationitem__ = __webpack_require__(954);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var AddonQbehaviourInformationItemModule = /** @class */ (function () {
    function AddonQbehaviourInformationItemModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourInformationItemModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_4__component_informationitem__["a" /* AddonQbehaviourInformationItemComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonQbehaviourInformationItemHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_4__component_informationitem__["a" /* AddonQbehaviourInformationItemComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_4__component_informationitem__["a" /* AddonQbehaviourInformationItemComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_3__providers_handler__["a" /* AddonQbehaviourInformationItemHandler */]])
    ], AddonQbehaviourInformationItemModule);
    return AddonQbehaviourInformationItemModule;
}());

//# sourceMappingURL=informationitem.module.js.map

/***/ }),
/* 1848 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourInformationItemHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_informationitem__ = __webpack_require__(954);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support information item question behaviour.
 */
var AddonQbehaviourInformationItemHandler = /** @class */ (function () {
    function AddonQbehaviourInformationItemHandler(questionHelper, questionProvider) {
        this.questionHelper = questionHelper;
        this.questionProvider = questionProvider;
        this.name = 'AddonQbehaviourInformationItem';
        this.type = 'informationitem';
    }
    /**
     * Determine a question new state based on its answer(s).
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {CoreQuestionState|Promise<CoreQuestionState>} New state (or promise resolved with state).
     */
    AddonQbehaviourInformationItemHandler.prototype.determineNewState = function (component, attemptId, question, siteId) {
        if (question.answers['-seen']) {
            return this.questionProvider.getState('complete');
        }
        return this.questionProvider.getState(question.state || 'todo');
    };
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourInformationItemHandler.prototype.handleQuestion = function (injector, question) {
        if (this.questionHelper.extractQbehaviourSeenInput(question)) {
            return [__WEBPACK_IMPORTED_MODULE_3__component_informationitem__["a" /* AddonQbehaviourInformationItemComponent */]];
        }
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourInformationItemHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourInformationItemHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */], __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], AddonQbehaviourInformationItemHandler);
    return AddonQbehaviourInformationItemHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1849 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourInteractiveModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1850);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourInteractiveModule = /** @class */ (function () {
    function AddonQbehaviourInteractiveModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourInteractiveModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourInteractiveHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourInteractiveHandler */]])
    ], AddonQbehaviourInteractiveModule);
    return AddonQbehaviourInteractiveModule;
}());

//# sourceMappingURL=interactive.module.js.map

/***/ }),
/* 1850 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourInteractiveHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support interactive question behaviour.
 */
var AddonQbehaviourInteractiveHandler = /** @class */ (function () {
    function AddonQbehaviourInteractiveHandler(questionHelper) {
        this.questionHelper = questionHelper;
        this.name = 'AddonQbehaviourInteractive';
        this.type = 'interactive';
        // Nothing to do.
    }
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourInteractiveHandler.prototype.handleQuestion = function (injector, question) {
        // Just extract the button, it doesn't need any specific component.
        this.questionHelper.extractQbehaviourButtons(question);
        return;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourInteractiveHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourInteractiveHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQbehaviourInteractiveHandler);
    return AddonQbehaviourInteractiveHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1851 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourInteractiveCountbackModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1852);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourInteractiveCountbackModule = /** @class */ (function () {
    function AddonQbehaviourInteractiveCountbackModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourInteractiveCountbackModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourInteractiveCountbackHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourInteractiveCountbackHandler */]])
    ], AddonQbehaviourInteractiveCountbackModule);
    return AddonQbehaviourInteractiveCountbackModule;
}());

//# sourceMappingURL=interactivecountback.module.js.map

/***/ }),
/* 1852 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourInteractiveCountbackHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__ = __webpack_require__(78);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support interactive countback question behaviour.
 */
var AddonQbehaviourInteractiveCountbackHandler = /** @class */ (function () {
    function AddonQbehaviourInteractiveCountbackHandler(questionHelper) {
        this.questionHelper = questionHelper;
        this.name = 'AddonQbehaviourInteractiveCountback';
        this.type = 'interactivecountback';
        // Nothing to do.
    }
    /**
     * Handle a question behaviour.
     * If the behaviour requires a submit button, it should add it to question.behaviourButtons.
     * If the behaviour requires to show some extra data, it should return the components to render it.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question.
     * @return {any[]|Promise<any[]>} Components (or promise resolved with components) to render some extra data in the question
     *                                (e.g. certainty options). Don't return anything if no extra data is required.
     */
    AddonQbehaviourInteractiveCountbackHandler.prototype.handleQuestion = function (injector, question) {
        // Just extract the button, it doesn't need any specific component.
        this.questionHelper.extractQbehaviourButtons(question);
        return;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourInteractiveCountbackHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourInteractiveCountbackHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQbehaviourInteractiveCountbackHandler);
    return AddonQbehaviourInteractiveCountbackHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1853 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourManualGradedModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_handler__ = __webpack_require__(1854);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__ = __webpack_require__(77);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQbehaviourManualGradedModule = /** @class */ (function () {
    function AddonQbehaviourManualGradedModule(behaviourDelegate, handler) {
        behaviourDelegate.registerHandler(handler);
    }
    AddonQbehaviourManualGradedModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourManualGradedHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_question_providers_behaviour_delegate__["a" /* CoreQuestionBehaviourDelegate */], __WEBPACK_IMPORTED_MODULE_1__providers_handler__["a" /* AddonQbehaviourManualGradedHandler */]])
    ], AddonQbehaviourManualGradedModule);
    return AddonQbehaviourManualGradedModule;
}());

//# sourceMappingURL=manualgraded.module.js.map

/***/ }),
/* 1854 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQbehaviourManualGradedHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_question__ = __webpack_require__(76);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support manual graded question behaviour.
 */
var AddonQbehaviourManualGradedHandler = /** @class */ (function () {
    function AddonQbehaviourManualGradedHandler(questionDelegate, questionProvider) {
        this.questionDelegate = questionDelegate;
        this.questionProvider = questionProvider;
        this.name = 'AddonQbehaviourManualGraded';
        this.type = 'manualgraded';
        // Nothing to do.
    }
    /**
     * Determine a question new state based on its answer(s).
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {CoreQuestionState|Promise<CoreQuestionState>} New state (or promise resolved with state).
     */
    AddonQbehaviourManualGradedHandler.prototype.determineNewState = function (component, attemptId, question, siteId) {
        return this.determineNewStateManualGraded(component, attemptId, question, siteId);
    };
    /**
     * Determine a question new state based on its answer(s) for manual graded question behaviour.
     *
     * @param {string} component Component the question belongs to.
     * @param {number} attemptId Attempt ID the question belongs to.
     * @param {any} question The question.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @param {isCompleteResponseFunction} [isCompleteFn] Function to override the default isCompleteResponse check.
     * @param {isSameResponseFunction} [isSameFn] Function to override the default isSameResponse check.
     * @return {Promise<CoreQuestionState>} Promise resolved with state.
     */
    AddonQbehaviourManualGradedHandler.prototype.determineNewStateManualGraded = function (component, attemptId, question, siteId, isCompleteFn, isSameFn) {
        var _this = this;
        // Check if we have local data for the question.
        return this.questionProvider.getQuestion(component, attemptId, question.slot, siteId).catch(function () {
            // No entry found, use the original data.
            return question;
        }).then(function (dbQuestion) {
            var state = _this.questionProvider.getState(dbQuestion.state);
            if (state.finished || !state.active) {
                // Question is finished, it cannot change.
                return state;
            }
            // We need to check if the answers have changed. Retrieve current stored answers.
            return _this.questionProvider.getQuestionAnswers(component, attemptId, question.slot, false, siteId)
                .then(function (prevAnswers) {
                var newBasicAnswers = _this.questionProvider.getBasicAnswers(question.answers);
                prevAnswers = _this.questionProvider.convertAnswersArrayToObject(prevAnswers, true);
                var prevBasicAnswers = _this.questionProvider.getBasicAnswers(prevAnswers);
                // If answers haven't changed the state is the same.
                if (isSameFn) {
                    if (isSameFn(question, prevAnswers, prevBasicAnswers, question.answers, newBasicAnswers)) {
                        return state;
                    }
                }
                else {
                    if (_this.questionDelegate.isSameResponse(question, prevBasicAnswers, newBasicAnswers)) {
                        return state;
                    }
                }
                // Answers have changed. Now check if the response is complete and calculate the new state.
                var complete, newState;
                if (isCompleteFn) {
                    // Pass all the answers since some behaviours might need the extra data.
                    complete = isCompleteFn(question, question.answers);
                }
                else {
                    // Only pass the basic answers since questions should be independent of extra data.
                    complete = _this.questionDelegate.isCompleteResponse(question, newBasicAnswers);
                }
                if (complete < 0) {
                    newState = 'cannotdeterminestatus';
                }
                else if (complete > 0) {
                    newState = 'complete';
                }
                else {
                    newState = 'todo';
                }
                return _this.questionProvider.getState(newState);
            });
        });
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQbehaviourManualGradedHandler.prototype.isEnabled = function () {
        return true;
    };
    AddonQbehaviourManualGradedHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], AddonQbehaviourManualGradedHandler);
    return AddonQbehaviourManualGradedHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1855 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__calculated_calculated_module__ = __webpack_require__(1856);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__calculatedmulti_calculatedmulti_module__ = __webpack_require__(1857);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__calculatedsimple_calculatedsimple_module__ = __webpack_require__(1859);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ddimageortext_ddimageortext_module__ = __webpack_require__(1861);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ddmarker_ddmarker_module__ = __webpack_require__(1864);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ddwtos_ddwtos_module__ = __webpack_require__(1868);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__description_description_module__ = __webpack_require__(1871);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__essay_essay_module__ = __webpack_require__(1873);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__gapselect_gapselect_module__ = __webpack_require__(1875);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__match_match_module__ = __webpack_require__(1877);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__multianswer_multianswer_module__ = __webpack_require__(1878);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__multichoice_multichoice_module__ = __webpack_require__(1880);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__numerical_numerical_module__ = __webpack_require__(1881);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__randomsamatch_randomsamatch_module__ = __webpack_require__(1883);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__shortanswer_shortanswer_module__ = __webpack_require__(1885);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__truefalse_truefalse_module__ = __webpack_require__(1887);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

















var AddonQtypeModule = /** @class */ (function () {
    function AddonQtypeModule() {
    }
    AddonQtypeModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1__calculated_calculated_module__["a" /* AddonQtypeCalculatedModule */],
                __WEBPACK_IMPORTED_MODULE_2__calculatedmulti_calculatedmulti_module__["a" /* AddonQtypeCalculatedMultiModule */],
                __WEBPACK_IMPORTED_MODULE_3__calculatedsimple_calculatedsimple_module__["a" /* AddonQtypeCalculatedSimpleModule */],
                __WEBPACK_IMPORTED_MODULE_4__ddimageortext_ddimageortext_module__["a" /* AddonQtypeDdImageOrTextModule */],
                __WEBPACK_IMPORTED_MODULE_5__ddmarker_ddmarker_module__["a" /* AddonQtypeDdMarkerModule */],
                __WEBPACK_IMPORTED_MODULE_6__ddwtos_ddwtos_module__["a" /* AddonQtypeDdwtosModule */],
                __WEBPACK_IMPORTED_MODULE_7__description_description_module__["a" /* AddonQtypeDescriptionModule */],
                __WEBPACK_IMPORTED_MODULE_8__essay_essay_module__["a" /* AddonQtypeEssayModule */],
                __WEBPACK_IMPORTED_MODULE_9__gapselect_gapselect_module__["a" /* AddonQtypeGapSelectModule */],
                __WEBPACK_IMPORTED_MODULE_10__match_match_module__["a" /* AddonQtypeMatchModule */],
                __WEBPACK_IMPORTED_MODULE_11__multianswer_multianswer_module__["a" /* AddonQtypeMultiAnswerModule */],
                __WEBPACK_IMPORTED_MODULE_12__multichoice_multichoice_module__["a" /* AddonQtypeMultichoiceModule */],
                __WEBPACK_IMPORTED_MODULE_13__numerical_numerical_module__["a" /* AddonQtypeNumericalModule */],
                __WEBPACK_IMPORTED_MODULE_14__randomsamatch_randomsamatch_module__["a" /* AddonQtypeRandomSaMatchModule */],
                __WEBPACK_IMPORTED_MODULE_15__shortanswer_shortanswer_module__["a" /* AddonQtypeShortAnswerModule */],
                __WEBPACK_IMPORTED_MODULE_16__truefalse_truefalse_module__["a" /* AddonQtypeTrueFalseModule */]
            ],
            providers: [],
            exports: []
        })
    ], AddonQtypeModule);
    return AddonQtypeModule;
}());

//# sourceMappingURL=qtype.module.js.map

/***/ }),
/* 1856 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeCalculatedModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(405);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_calculated__ = __webpack_require__(406);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeCalculatedModule = /** @class */ (function () {
    function AddonQtypeCalculatedModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeCalculatedModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_calculated__["a" /* AddonQtypeCalculatedComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeCalculatedHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_calculated__["a" /* AddonQtypeCalculatedComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_calculated__["a" /* AddonQtypeCalculatedComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeCalculatedHandler */]])
    ], AddonQtypeCalculatedModule);
    return AddonQtypeCalculatedModule;
}());

//# sourceMappingURL=calculated.module.js.map

/***/ }),
/* 1857 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeCalculatedMultiModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_handler__ = __webpack_require__(1858);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQtypeCalculatedMultiModule = /** @class */ (function () {
    function AddonQtypeCalculatedMultiModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeCalculatedMultiModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeCalculatedMultiHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeCalculatedMultiHandler */]])
    ], AddonQtypeCalculatedMultiModule);
    return AddonQtypeCalculatedMultiModule;
}());

//# sourceMappingURL=calculatedmulti.module.js.map

/***/ }),
/* 1858 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeCalculatedMultiHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__addon_qtype_multichoice_providers_handler__ = __webpack_require__(955);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__addon_qtype_multichoice_component_multichoice__ = __webpack_require__(279);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support calculated multi question type.
 */
var AddonQtypeCalculatedMultiHandler = /** @class */ (function () {
    function AddonQtypeCalculatedMultiHandler(multichoiceHandler) {
        this.multichoiceHandler = multichoiceHandler;
        this.name = 'AddonQtypeCalculatedMulti';
        this.type = 'qtype_calculatedmulti';
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeCalculatedMultiHandler.prototype.getComponent = function (injector, question) {
        // Calculated multi behaves like a multichoice, use the same component.
        return __WEBPACK_IMPORTED_MODULE_2__addon_qtype_multichoice_component_multichoice__["a" /* AddonQtypeMultichoiceComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeCalculatedMultiHandler.prototype.isCompleteResponse = function (question, answers) {
        // This question type depends on multichoice.
        return this.multichoiceHandler.isCompleteResponseSingle(answers);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeCalculatedMultiHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeCalculatedMultiHandler.prototype.isGradableResponse = function (question, answers) {
        // This question type depends on multichoice.
        return this.multichoiceHandler.isGradableResponseSingle(answers);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeCalculatedMultiHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        // This question type depends on multichoice.
        return this.multichoiceHandler.isSameResponseSingle(prevAnswers, newAnswers);
    };
    AddonQtypeCalculatedMultiHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__addon_qtype_multichoice_providers_handler__["a" /* AddonQtypeMultichoiceHandler */]])
    ], AddonQtypeCalculatedMultiHandler);
    return AddonQtypeCalculatedMultiHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1859 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeCalculatedSimpleModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_handler__ = __webpack_require__(1860);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQtypeCalculatedSimpleModule = /** @class */ (function () {
    function AddonQtypeCalculatedSimpleModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeCalculatedSimpleModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeCalculatedSimpleHandler */]
            ],
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeCalculatedSimpleHandler */]])
    ], AddonQtypeCalculatedSimpleModule);
    return AddonQtypeCalculatedSimpleModule;
}());

//# sourceMappingURL=calculatedsimple.module.js.map

/***/ }),
/* 1860 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeCalculatedSimpleHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__addon_qtype_calculated_providers_handler__ = __webpack_require__(405);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__addon_qtype_calculated_component_calculated__ = __webpack_require__(406);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support calculated simple question type.
 */
var AddonQtypeCalculatedSimpleHandler = /** @class */ (function () {
    function AddonQtypeCalculatedSimpleHandler(calculatedHandler) {
        this.calculatedHandler = calculatedHandler;
        this.name = 'AddonQtypeCalculatedSimple';
        this.type = 'qtype_calculatedsimple';
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeCalculatedSimpleHandler.prototype.getComponent = function (injector, question) {
        // Calculated simple behaves like a calculated, use the same component.
        return __WEBPACK_IMPORTED_MODULE_2__addon_qtype_calculated_component_calculated__["a" /* AddonQtypeCalculatedComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeCalculatedSimpleHandler.prototype.isCompleteResponse = function (question, answers) {
        // This question type depends on calculated.
        return this.calculatedHandler.isCompleteResponse(question, answers);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeCalculatedSimpleHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeCalculatedSimpleHandler.prototype.isGradableResponse = function (question, answers) {
        // This question type depends on calculated.
        return this.calculatedHandler.isGradableResponse(question, answers);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeCalculatedSimpleHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        // This question type depends on calculated.
        return this.calculatedHandler.isSameResponse(question, prevAnswers, newAnswers);
    };
    AddonQtypeCalculatedSimpleHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__addon_qtype_calculated_providers_handler__["a" /* AddonQtypeCalculatedHandler */]])
    ], AddonQtypeCalculatedSimpleHandler);
    return AddonQtypeCalculatedSimpleHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1861 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdImageOrTextModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(1862);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_ddimageortext__ = __webpack_require__(956);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeDdImageOrTextModule = /** @class */ (function () {
    function AddonQtypeDdImageOrTextModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeDdImageOrTextModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddimageortext__["a" /* AddonQtypeDdImageOrTextComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeDdImageOrTextHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddimageortext__["a" /* AddonQtypeDdImageOrTextComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddimageortext__["a" /* AddonQtypeDdImageOrTextComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeDdImageOrTextHandler */]])
    ], AddonQtypeDdImageOrTextModule);
    return AddonQtypeDdImageOrTextModule;
}());

//# sourceMappingURL=ddimageortext.module.js.map

/***/ }),
/* 1862 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdImageOrTextHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_ddimageortext__ = __webpack_require__(956);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support drag-and-drop onto image question type.
 */
var AddonQtypeDdImageOrTextHandler = /** @class */ (function () {
    function AddonQtypeDdImageOrTextHandler(questionProvider) {
        this.questionProvider = questionProvider;
        this.name = 'AddonQtypeDdImageOrText';
        this.type = 'qtype_ddimageortext';
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeDdImageOrTextHandler.prototype.getBehaviour = function (question, behaviour) {
        if (behaviour === 'interactive') {
            return 'interactivecountback';
        }
        return behaviour;
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeDdImageOrTextHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_2__component_ddimageortext__["a" /* AddonQtypeDdImageOrTextComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeDdImageOrTextHandler.prototype.isCompleteResponse = function (question, answers) {
        // An answer is complete if all drop zones have an answer.
        // We should always receive all the drop zones with their value ('' if not answered).
        for (var name_1 in answers) {
            var value = answers[name_1];
            if (!value || value === '0') {
                return 0;
            }
        }
        return 1;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeDdImageOrTextHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeDdImageOrTextHandler.prototype.isGradableResponse = function (question, answers) {
        for (var name_2 in answers) {
            var value = answers[name_2];
            if (value && value !== '0') {
                return 1;
            }
        }
        return 0;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeDdImageOrTextHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.questionProvider.compareAllAnswers(prevAnswers, newAnswers);
    };
    AddonQtypeDdImageOrTextHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], AddonQtypeDdImageOrTextHandler);
    return AddonQtypeDdImageOrTextHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1863 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdImageOrTextQuestion; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Class to make a question of ddimageortext type work.
 */
var AddonQtypeDdImageOrTextQuestion = /** @class */ (function () {
    /**
     * Create the this.
     *
     * @param {CoreLoggerProvider} logger Logger provider.
     * @param {CoreDomUtilsProvider} domUtils Dom Utils provider.
     * @param {HTMLElement} container The container HTMLElement of the question.
     * @param {any} question The question this.
     * @param {boolean} readOnly Whether it's read only.
     * @param {any[]} drops The drop zones received in the init object of the question.
     */
    function AddonQtypeDdImageOrTextQuestion(logger, domUtils, container, question, readOnly, drops) {
        this.domUtils = domUtils;
        this.container = container;
        this.question = question;
        this.readOnly = readOnly;
        this.drops = drops;
        this.toLoad = 0;
        this.afterImageLoadDone = false;
        this.proportion = 1;
        this.logger = logger.getInstance('AddonQtypeDdImageOrTextQuestion');
        this.initializer(question);
    }
    /**
     * Calculate image proportion to make easy conversions.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.calculateImgProportion = function () {
        var bgImg = this.doc.bgImg();
        // Render the position related to the current image dimensions.
        this.proportion = 1;
        if (bgImg.width != bgImg.naturalWidth) {
            this.proportion = bgImg.width / bgImg.naturalWidth;
        }
    };
    /**
     * Convert the X and Y position of the BG IMG to a position relative to the window.
     *
     * @param {number[]} bgImgXY X and Y of the BG IMG relative position.
     * @return {number[]} Position relative to the window.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.convertToWindowXY = function (bgImgXY) {
        var bgImg = this.doc.bgImg(), position = this.domUtils.getElementXY(bgImg, null, 'ddarea');
        // Render the position related to the current image dimensions.
        bgImgXY[0] *= this.proportion;
        bgImgXY[1] *= this.proportion;
        return [Number(bgImgXY[0]) + position[0] + 1, Number(bgImgXY[1]) + position[1] + 1];
    };
    /**
     * Create and initialize all draggable elements and drop zones.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.createAllDragAndDrops = function () {
        // Initialize drop zones.
        this.initDrops();
        // Initialize drag items area.
        var dragItemsArea = this.doc.dragItemsArea();
        dragItemsArea.classList.add('clearfix');
        this.makeDragAreaClickable();
        var dragItemHomes = this.doc.dragItemHomes();
        var i = 0;
        // Create the draggable items.
        for (var x = 0; x < dragItemHomes.length; x++) {
            var dragItemHome = dragItemHomes[x], dragItemNo = this.doc.getClassnameNumericSuffix(dragItemHome, 'dragitemhomes'), choice = this.doc.getClassnameNumericSuffix(dragItemHome, 'choice'), group = this.doc.getClassnameNumericSuffix(dragItemHome, 'group');
            // Images need to be inside a div element to admit padding with width and height.
            if (dragItemHome.tagName == 'IMG') {
                var wrap = document.createElement('div');
                wrap.className = dragItemHome.className;
                dragItemHome.className = '';
                // Insert wrapper before the image in the DOM tree.
                dragItemHome.parentNode.insertBefore(wrap, dragItemHome);
                // Move the image into wrapper.
                wrap.appendChild(dragItemHome);
            }
            // Create a new drag item for this home.
            var dragNode = this.doc.cloneNewDragItem(i, dragItemNo);
            i++;
            if (!this.readOnly) {
                // Make the item draggable.
                this.draggableForQuestion(dragNode, group, choice);
            }
            // If the draggable item needs to be created more than once, create the rest of copies.
            if (dragNode.classList.contains('infinite')) {
                var groupSize = this.doc.dropZoneGroup(group).length;
                var dragsToCreate = groupSize - 1;
                while (dragsToCreate > 0) {
                    var newDragNode = this.doc.cloneNewDragItem(i, dragItemNo);
                    i++;
                    if (!this.readOnly) {
                        this.draggableForQuestion(newDragNode, group, choice);
                    }
                    dragsToCreate--;
                }
            }
        }
        // All drag items have been created, position them.
        this.repositionDragsForQuestion();
        if (!this.readOnly) {
            var dropZones = this.doc.dropZones();
            dropZones.forEach(function (dropZone) {
                dropZone.setAttribute('tabIndex', '0');
            });
        }
    };
    /**
     * Deselect all drags.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.deselectDrags = function () {
        var drags = this.doc.dragItems();
        drags.forEach(function (drag) {
            drag.classList.remove('beingdragged');
        });
        this.selected = null;
    };
    /**
     * Function to call when the instance is no longer needed.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.destroy = function () {
        this.stopPolling();
        if (this.resizeFunction) {
            window.removeEventListener('resize', this.resizeFunction);
        }
    };
    /**
     * Returns an object to encapsulate operations on dd area.
     *
     * @param {number} slot The question slot.
     * @return {AddonQtypeDdImageOrTextQuestionDocStructure} The object.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.docStructure = function (slot) {
        var _this = this;
        var topNode = this.container.querySelector('.addon-qtype-ddimageortext-container'), doc = {};
        var dragItemsArea = topNode.querySelector('div.draghomes');
        if (dragItemsArea) {
            // 3.6+ site, transform HTML so it has the same structure as in Moodle 3.5.
            // Remove empty div.dragitems.
            topNode.querySelector('div.dragitems').remove();
            var ddArea = topNode.querySelector('div.ddarea');
            // Move div.dropzones to div.ddarea.
            ddArea.appendChild(topNode.querySelector('div.dropzones'));
            // Move div.draghomes to div.ddarea and rename the class to .dragitems.
            ddArea.appendChild(dragItemsArea);
            dragItemsArea.classList.remove('draghomes');
            dragItemsArea.classList.add('dragitems');
            // Add .dragitemhomesNNN class to drag items.
            Array.from(dragItemsArea.querySelectorAll('.draghome')).forEach(function (draghome, index) {
                draghome.classList.add('dragitemhomes' + index);
            });
        }
        else {
            dragItemsArea = topNode.querySelector('div.dragitems');
        }
        doc.topNode = function () {
            return topNode;
        };
        doc.dragItemsArea = function () {
            return dragItemsArea;
        };
        doc.dragItems = function () {
            return Array.from(dragItemsArea.querySelectorAll('.drag'));
        };
        doc.dropZones = function () {
            return Array.from(topNode.querySelectorAll('div.dropzones div.dropzone'));
        };
        doc.dropZoneGroup = function (groupNo) {
            return Array.from(topNode.querySelectorAll('div.dropzones div.group' + groupNo));
        };
        doc.dragItemsClonedFrom = function (dragItemNo) {
            return Array.from(dragItemsArea.querySelectorAll('.dragitems' + dragItemNo));
        };
        doc.dragItem = function (dragInstanceNo) {
            return dragItemsArea.querySelector('.draginstance' + dragInstanceNo);
        };
        doc.dragItemsInGroup = function (groupNo) {
            return Array.from(dragItemsArea.querySelectorAll('.drag.group' + groupNo));
        };
        doc.dragItemHomes = function () {
            return Array.from(dragItemsArea.querySelectorAll('.draghome'));
        };
        doc.bgImg = function () {
            return topNode.querySelector('.dropbackground');
        };
        doc.dragItemHome = function (dragItemNo) {
            return dragItemsArea.querySelector('.dragitemhomes' + dragItemNo);
        };
        doc.getClassnameNumericSuffix = function (node, prefix) {
            if (node.classList && node.classList.length) {
                var patt1 = new RegExp('^' + prefix + '([0-9])+$'), patt2 = new RegExp('([0-9])+$');
                for (var index = 0; index < node.classList.length; index++) {
                    if (patt1.test(node.classList[index])) {
                        var match = patt2.exec(node.classList[index]);
                        return Number(match[0]);
                    }
                }
            }
            _this.logger.warn('Prefix "' + prefix + '" not found in class names.');
        };
        doc.cloneNewDragItem = function (dragInstanceNo, dragItemNo) {
            var dragHome = doc.dragItemHome(dragItemNo);
            if (dragHome === null) {
                return null;
            }
            var dragHomeImg = dragHome.querySelector('img');
            var divDrag;
            // Images need to be inside a div element to admit padding with width and height.
            if (dragHomeImg) {
                // Clone the image.
                var drag = dragHomeImg.cloneNode(true);
                // Create a div and put the image in it.
                divDrag = document.createElement('div');
                divDrag.appendChild(drag);
                divDrag.className = dragHome.className;
                drag.className = '';
            }
            else {
                // The drag item doesn't have an image, just clone it.
                divDrag = dragHome.cloneNode(true);
            }
            // Set the right classes and styles.
            divDrag.classList.remove('dragitemhomes' + dragItemNo);
            divDrag.classList.remove('draghome');
            divDrag.classList.add('dragitems' + dragItemNo);
            divDrag.classList.add('draginstance' + dragInstanceNo);
            divDrag.classList.add('drag');
            divDrag.style.visibility = 'inherit';
            divDrag.style.position = 'absolute';
            divDrag.setAttribute('draginstanceno', String(dragInstanceNo));
            divDrag.setAttribute('dragitemno', String(dragItemNo));
            // Insert the new drag after the dragHome.
            dragHome.parentElement.insertBefore(divDrag, dragHome.nextSibling);
            return divDrag;
        };
        return doc;
    };
    /**
     * Make an element draggable.
     *
     * @param {HTMLElement} drag Element to make draggable.
     * @param {number} group Group the element belongs to.
     * @param {number} choice Choice the element belongs to.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.draggableForQuestion = function (drag, group, choice) {
        var _this = this;
        // Set attributes.
        drag.setAttribute('group', String(group));
        drag.setAttribute('choice', String(choice));
        // Listen to click events.
        drag.addEventListener('click', function (e) {
            e.preventDefault();
            e.stopPropagation();
            if (drag.classList.contains('beingdragged')) {
                _this.deselectDrags();
            }
            else {
                _this.selectDrag(drag);
            }
        });
    };
    /**
     * Function called when a drop zone is clicked.
     *
     * @param {HTMLElement} dropNode Drop element.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.dropClick = function (dropNode) {
        var drag = this.selected;
        if (!drag) {
            // No selected item, nothing to do.
            return;
        }
        // Deselect the drag and place it in the position of this drop zone if it belongs to the same group.
        this.deselectDrags();
        if (Number(dropNode.getAttribute('group')) === Number(drag.getAttribute('group'))) {
            this.placeDragInDrop(drag, dropNode);
        }
    };
    /**
     * Get all the draggable elements for a choice and a drop zone.
     *
     * @param {number} choice Choice number.
     * @param {HTMLElement} drop Drop zone.
     * @return {HTMLElement[]} Draggable elements.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.getChoicesForDrop = function (choice, drop) {
        return Array.from(this.doc.topNode().querySelectorAll('div.dragitemgroup' + drop.getAttribute('group') + ' .choice' + choice + '.drag'));
    };
    /**
     * Get an unplaced draggable element that belongs to a certain choice and drop zone.
     *
     * @param {number} choice Choice number.
     * @param {HTMLElement} drop Drop zone.
     * @return {HTMLElement} Unplaced draggable element.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.getUnplacedChoiceForDrop = function (choice, drop) {
        var dragItems = this.getChoicesForDrop(choice, drop);
        for (var x = 0; x < dragItems.length; x++) {
            var dragItem = dragItems[x];
            if (this.readOnly || (!dragItem.classList.contains('placed') && !dragItem.classList.contains('beingdragged'))) {
                return dragItem;
            }
        }
        return null;
    };
    /**
     * Initialize drop zones.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.initDrops = function () {
        var _this = this;
        var dropAreas = this.doc.topNode().querySelector('div.dropzones'), groupNodes = {};
        // Create all group nodes and add them to the drop area.
        for (var groupNo = 1; groupNo <= 8; groupNo++) {
            var groupNode = document.createElement('div');
            groupNode.className = 'dropzonegroup' + groupNo;
            dropAreas.appendChild(groupNode);
            groupNodes[groupNo] = groupNode;
        }
        var _loop_1 = function (dropNo) {
            var drop = this_1.drops[dropNo], nodeClass = 'dropzone group' + drop.group + ' place' + dropNo, title = drop.text.replace('"', '\"'), dropNode = document.createElement('div');
            dropNode.setAttribute('title', title);
            dropNode.className = nodeClass;
            groupNodes[drop.group].appendChild(dropNode);
            dropNode.style.opacity = '0.5';
            dropNode.setAttribute('xy', drop.xy);
            dropNode.setAttribute('aria-label', drop.text);
            dropNode.setAttribute('place', dropNo);
            dropNode.setAttribute('inputid', drop.fieldname.replace(':', '_'));
            dropNode.setAttribute('group', drop.group);
            dropNode.addEventListener('click', function (e) {
                e.preventDefault();
                e.stopPropagation();
                _this.dropClick(dropNode);
            });
        };
        var this_1 = this;
        // Create the drops specified by the init object.
        for (var dropNo in this.drops) {
            _loop_1(dropNo);
        }
    };
    /**
     * Initialize the question.
     *
     * @param {any} question Question.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.initializer = function (question) {
        var _this = this;
        this.doc = this.docStructure(question.slot);
        if (this.readOnly) {
            var container = this.doc.topNode();
            container.classList.add('readonly');
        }
        // Wait the DOM to be rendered.
        setTimeout(function () {
            var bgImg = _this.doc.bgImg();
            // Wait for background image to be loaded.
            // On iOS, complete is mistakenly true, check also naturalWidth for compatibility.
            if (!bgImg.complete || !bgImg.naturalWidth) {
                _this.toLoad++;
                bgImg.addEventListener('load', function () {
                    _this.toLoad--;
                });
            }
            var itemHomes = _this.doc.dragItemHomes();
            itemHomes.forEach(function (item) {
                if (item.tagName == 'IMG') {
                    // Wait for drag images to be loaded.
                    // On iOS, complete is mistakenly true, check also naturalWidth for compatibility.
                    var itemImg = item;
                    if (!itemImg.complete || !itemImg.naturalWidth) {
                        _this.toLoad++;
                        itemImg.addEventListener('load', function () {
                            _this.toLoad--;
                        });
                    }
                }
            });
            _this.pollForImageLoad();
        });
        this.resizeFunction = this.repositionDragsForQuestion.bind(this);
        window.addEventListener('resize', this.resizeFunction);
    };
    /**
     * Make the drag items area clickable.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.makeDragAreaClickable = function () {
        var _this = this;
        if (this.readOnly) {
            return;
        }
        var home = this.doc.dragItemsArea();
        home.addEventListener('click', function (e) {
            var drag = _this.selected;
            if (!drag) {
                // No element selected, nothing to do.
                return false;
            }
            // An element was selected. Deselect it and move it back to the area if needed.
            _this.deselectDrags();
            _this.removeDragFromDrop(drag);
            e.preventDefault();
            e.stopPropagation();
        });
    };
    /**
     * Place a draggable element into a certain drop zone.
     *
     * @param {HTMLElement} drag Draggable element.
     * @param {HTMLElement} drop Drop zone element.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.placeDragInDrop = function (drag, drop) {
        // Search the input related to the drop zone.
        var targetInputId = drop.getAttribute('inputid'), inputNode = this.doc.topNode().querySelector('input#' + targetInputId);
        // Check if the draggable item is already assigned to an input and if it's the same as the one of the drop zone.
        var originInputId = drag.getAttribute('inputid');
        if (originInputId && originInputId != targetInputId) {
            // Remove it from the previous place.
            var originInputNode = this.doc.topNode().querySelector('input#' + originInputId);
            originInputNode.setAttribute('value', '');
        }
        // Now position the draggable and set it to the input.
        var position = this.domUtils.getElementXY(drop, null, 'ddarea');
        drag.style.left = position[0] - 1 + 'px';
        drag.style.top = position[1] - 1 + 'px';
        drag.classList.add('placed');
        inputNode.setAttribute('value', drag.getAttribute('choice'));
        drag.setAttribute('inputid', targetInputId);
    };
    /**
     * Wait for images to be loaded.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.pollForImageLoad = function () {
        var _this = this;
        if (this.afterImageLoadDone) {
            // Already done, stop.
            return;
        }
        if (this.toLoad <= 0) {
            // All images loaded.
            this.createAllDragAndDrops();
            this.afterImageLoadDone = true;
            this.question.loaded = true;
        }
        // Try again after a while.
        setTimeout(function () {
            _this.pollForImageLoad();
        }, 1000);
    };
    /**
     * Remove a draggable element from the drop zone where it is.
     *
     * @param {HTMLElement} drag Draggable element to remove.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.removeDragFromDrop = function (drag) {
        // Check if the draggable element is assigned to an input. If so, empty the input's value.
        var inputId = drag.getAttribute('inputid');
        if (inputId) {
            var inputNode = this.doc.topNode().querySelector('input#' + inputId);
            inputNode.setAttribute('value', '');
        }
        // Move the element to its original position.
        var dragItemHome = this.doc.dragItemHome(Number(drag.getAttribute('dragitemno'))), position = this.domUtils.getElementXY(dragItemHome, null, 'ddarea');
        drag.style.left = position[0] + 'px';
        drag.style.top = position[1] + 'px';
        drag.classList.remove('placed');
        drag.setAttribute('inputid', '');
    };
    /**
     * Reposition all the draggable elements and drop zones.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.repositionDragsForQuestion = function () {
        var dragItems = this.doc.dragItems();
        // Mark all draggable items as "unplaced", they will be placed again later.
        dragItems.forEach(function (dragItem) {
            dragItem.classList.remove('placed');
            dragItem.setAttribute('inputid', '');
        });
        // Calculate the proportion to apply to images.
        this.calculateImgProportion();
        // Apply the proportion to all images in drag item homes.
        var dragItemHomes = this.doc.dragItemHomes();
        var _loop_2 = function (x) {
            var dragItemHome = dragItemHomes[x], dragItemHomeImg = dragItemHome.querySelector('img');
            if (dragItemHomeImg && dragItemHomeImg.naturalWidth > 0) {
                var widthHeight_1 = [Math.round(dragItemHomeImg.naturalWidth * this_2.proportion),
                    Math.round(dragItemHomeImg.naturalHeight * this_2.proportion)];
                dragItemHomeImg.style.width = widthHeight_1[0] + 'px';
                dragItemHomeImg.style.height = widthHeight_1[1] + 'px';
                // Apply the proportion to all the images cloned from this home.
                var dragItemNo = this_2.doc.getClassnameNumericSuffix(dragItemHome, 'dragitemhomes'), groupNo = this_2.doc.getClassnameNumericSuffix(dragItemHome, 'group'), dragsImg = Array.from(this_2.doc.topNode().querySelectorAll('.drag.group' + groupNo + '.dragitems' + dragItemNo + '  img'));
                dragsImg.forEach(function (dragImg) {
                    dragImg.style.width = widthHeight_1[0] + 'px';
                    dragImg.style.height = widthHeight_1[1] + 'px';
                });
            }
        };
        var this_2 = this;
        for (var x = 0; x < dragItemHomes.length; x++) {
            _loop_2(x);
        }
        // Update the padding of all draggable elements.
        this.updatePaddingSizesAll();
        var dropZones = this.doc.dropZones();
        for (var x = 0; x < dropZones.length; x++) {
            // Re-position the drop zone based on the proportion.
            var dropZone = dropZones[x], dropZoneXY = dropZone.getAttribute('xy').split(',').map(function (i) {
                return Number(i);
            }), relativeXY = this.convertToWindowXY(dropZoneXY);
            dropZone.style.left = relativeXY[0] + 'px';
            dropZone.style.top = relativeXY[1] + 'px';
            // Re-place items got from the inputs.
            var inputCss = 'input#' + dropZone.getAttribute('inputid'), input = this.doc.topNode().querySelector(inputCss), choice = Number(input.value);
            if (choice > 0) {
                var dragItem = this.getUnplacedChoiceForDrop(choice, dropZone);
                if (dragItem !== null) {
                    this.placeDragInDrop(dragItem, dropZone);
                }
            }
        }
        // Re-place draggable items not placed drop zones (they will be placed in the original position).
        for (var x = 0; x < dragItems.length; x++) {
            var dragItem = dragItems[x];
            if (!dragItem.classList.contains('placed') && !dragItem.classList.contains('beingdragged')) {
                this.removeDragFromDrop(dragItem);
            }
        }
    };
    /**
     * Mark a draggable element as selected.
     *
     * @param {HTMLElement} drag Element to select.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.selectDrag = function (drag) {
        // Deselect previous ones.
        this.deselectDrags();
        this.selected = drag;
        drag.classList.add('beingdragged');
    };
    /**
     * Stop waiting for images to be loaded.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.stopPolling = function () {
        this.afterImageLoadDone = true;
    };
    /**
     * Update the padding of all items in a group to make them all have the same width and height.
     *
     * @param {number} groupNo The group number.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.updatePaddingSizeForGroup = function (groupNo) {
        // Get all the items for this group.
        var groupItems = Array.from(this.doc.topNode().querySelectorAll('.draghome.group' + groupNo));
        if (groupItems.length !== 0) {
            // Get the max width and height of the items.
            var maxWidth_1 = 0, maxHeight_1 = 0;
            for (var x = 0; x < groupItems.length; x++) {
                // Check if the item has an img.
                var item = groupItems[x], img = item.querySelector('img');
                if (img) {
                    maxWidth_1 = Math.max(maxWidth_1, Math.round(this.proportion * img.naturalWidth));
                    maxHeight_1 = Math.max(maxHeight_1, Math.round(this.proportion * img.naturalHeight));
                }
                else {
                    // Remove the padding to calculate the size.
                    var originalPadding = item.style.padding;
                    item.style.padding = '';
                    // Text is not affected by the proportion.
                    maxWidth_1 = Math.max(maxWidth_1, Math.round(item.clientWidth));
                    maxHeight_1 = Math.max(maxHeight_1, Math.round(item.clientHeight));
                    // Restore the padding.
                    item.style.padding = originalPadding;
                }
            }
            if (maxWidth_1 <= 0 || maxHeight_1 <= 0) {
                return;
            }
            // Add a variable padding to the image or text.
            maxWidth_1 = Math.round(maxWidth_1 + this.proportion * 8);
            maxHeight_1 = Math.round(maxHeight_1 + this.proportion * 8);
            var _loop_3 = function (x) {
                // Check if the item has an img and calculate its width and height.
                var item = groupItems[x], img = item.querySelector('img');
                var width = void 0, height = void 0;
                if (img) {
                    width = Math.round(img.naturalWidth * this_3.proportion);
                    height = Math.round(img.naturalHeight * this_3.proportion);
                }
                else {
                    // Remove the padding to calculate the size.
                    var originalPadding = item.style.padding;
                    item.style.padding = '';
                    // Text is not affected by the proportion.
                    width = Math.round(item.clientWidth);
                    height = Math.round(item.clientHeight);
                    // Restore the padding.
                    item.style.padding = originalPadding;
                }
                // Now set the right padding to make this item have the max height and width.
                var marginTopBottom = Math.round((maxHeight_1 - height) / 2), marginLeftRight = Math.round((maxWidth_1 - width) / 2);
                // Correction for the roundings.
                var widthCorrection = maxWidth_1 - (width + marginLeftRight * 2), heightCorrection = maxHeight_1 - (height + marginTopBottom * 2);
                item.style.padding = marginTopBottom + 'px ' + marginLeftRight + 'px ' +
                    (marginTopBottom + heightCorrection) + 'px ' + (marginLeftRight + widthCorrection) + 'px';
                var dragItemNo = this_3.doc.getClassnameNumericSuffix(item, 'dragitemhomes'), drags = Array.from(this_3.doc.topNode().querySelectorAll('.drag.group' + groupNo + '.dragitems' + dragItemNo));
                drags.forEach(function (drag) {
                    drag.style.padding = marginTopBottom + 'px ' + marginLeftRight + 'px ' +
                        (marginTopBottom + heightCorrection) + 'px ' + (marginLeftRight + widthCorrection) + 'px';
                });
            };
            var this_3 = this;
            for (var x = 0; x < groupItems.length; x++) {
                _loop_3(x);
            }
            // It adds the border of 1px to the width.
            var zoneGroups = this.doc.dropZoneGroup(groupNo);
            zoneGroups.forEach(function (zone) {
                zone.style.width = maxWidth_1 + 2 + 'px ';
                zone.style.height = maxHeight_1 + 2 + 'px ';
            });
        }
    };
    /**
     * Update the padding of all items in all groups.
     */
    AddonQtypeDdImageOrTextQuestion.prototype.updatePaddingSizesAll = function () {
        for (var groupNo = 1; groupNo <= 8; groupNo++) {
            this.updatePaddingSizeForGroup(groupNo);
        }
    };
    return AddonQtypeDdImageOrTextQuestion;
}());

//# sourceMappingURL=ddimageortext.js.map

/***/ }),
/* 1864 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdMarkerModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(1865);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_ddmarker__ = __webpack_require__(957);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeDdMarkerModule = /** @class */ (function () {
    function AddonQtypeDdMarkerModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeDdMarkerModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddmarker__["a" /* AddonQtypeDdMarkerComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeDdMarkerHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddmarker__["a" /* AddonQtypeDdMarkerComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddmarker__["a" /* AddonQtypeDdMarkerComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeDdMarkerHandler */]])
    ], AddonQtypeDdMarkerModule);
    return AddonQtypeDdMarkerModule;
}());

//# sourceMappingURL=ddmarker.module.js.map

/***/ }),
/* 1865 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdMarkerHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_ddmarker__ = __webpack_require__(957);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support drag-and-drop markers question type.
 */
var AddonQtypeDdMarkerHandler = /** @class */ (function () {
    function AddonQtypeDdMarkerHandler(questionProvider, questionHelper) {
        this.questionProvider = questionProvider;
        this.questionHelper = questionHelper;
        this.name = 'AddonQtypeDdMarker';
        this.type = 'qtype_ddmarker';
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeDdMarkerHandler.prototype.getBehaviour = function (question, behaviour) {
        if (behaviour === 'interactive') {
            return 'interactivecountback';
        }
        return behaviour;
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeDdMarkerHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_3__component_ddmarker__["a" /* AddonQtypeDdMarkerComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeDdMarkerHandler.prototype.isCompleteResponse = function (question, answers) {
        // If 1 dragitem is set we assume the answer is complete (like Moodle does).
        for (var name_1 in answers) {
            if (answers[name_1]) {
                return 1;
            }
        }
        return 0;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeDdMarkerHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeDdMarkerHandler.prototype.isGradableResponse = function (question, answers) {
        return this.isCompleteResponse(question, answers);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeDdMarkerHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.questionProvider.compareAllAnswers(prevAnswers, newAnswers);
    };
    /**
     * Get the list of files that needs to be downloaded in addition to the files embedded in the HTML.
     *
     * @param {any} question Question.
     * @param {number} usageId Usage ID.
     * @return {string[]} List of URLs.
     */
    AddonQtypeDdMarkerHandler.prototype.getAdditionalDownloadableFiles = function (question, usageId) {
        this.questionHelper.extractQuestionScripts(question, usageId);
        if (question.amdArgs && typeof question.amdArgs[1] !== 'undefined') {
            // Moodle 3.6+.
            return [question.amdArgs[1]];
        }
        return [];
    };
    AddonQtypeDdMarkerHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__["a" /* CoreQuestionProvider */], __WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQtypeDdMarkerHandler);
    return AddonQtypeDdMarkerHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1866 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdMarkerQuestion; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__graphics_api__ = __webpack_require__(1867);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Class to make a question of ddmarker type work.
 */
var AddonQtypeDdMarkerQuestion = /** @class */ (function () {
    /**
     * Create the instance.
     *
     * @param {CoreLoggerProvider} logger Logger provider.
     * @param {CoreDomUtilsProvider} domUtils Dom Utils provider.
     * @param {CoreTextUtilsProvider} textUtils Text Utils provider.
     * @param {HTMLElement} container The container HTMLElement of the question.
     * @param {any} question The question instance.
     * @param {boolean} readOnly Whether it's read only.
     * @param {any[]} dropZones The drop zones received in the init object of the question.
     * @param {string} [imgSrc] Background image source (3.6+ sites).
     */
    function AddonQtypeDdMarkerQuestion(logger, domUtils, textUtils, container, question, readOnly, dropZones, imgSrc) {
        this.domUtils = domUtils;
        this.textUtils = textUtils;
        this.container = container;
        this.question = question;
        this.readOnly = readOnly;
        this.dropZones = dropZones;
        this.imgSrc = imgSrc;
        this.COLOURS = ['#FFFFFF', '#B0C4DE', '#DCDCDC', '#D8BFD8', '#87CEFA', '#DAA520', '#FFD700', '#F0E68C'];
        this.afterImageLoadDone = false;
        this.nextColourIndex = 0;
        this.proportion = 1;
        this.shapes = [];
        this.logger = logger.getInstance('AddonQtypeDdMarkerQuestion');
        this.graphics = new __WEBPACK_IMPORTED_MODULE_0__graphics_api__["a" /* AddonQtypeDdMarkerGraphicsApi */](this, this.domUtils);
        this.initializer(question);
    }
    /**
     * Calculate image proportion to make easy conversions.
     */
    AddonQtypeDdMarkerQuestion.prototype.calculateImgProportion = function () {
        var bgImg = this.doc.bgImg();
        // Render the position related to the current image dimensions.
        this.proportion = 1;
        if (bgImg.width != bgImg.naturalWidth) {
            this.proportion = bgImg.width / bgImg.naturalWidth;
        }
    };
    /**
     * Create a new draggable element cloning a certain element.
     *
     * @param {HTMLElement} dragHome The element to clone.
     * @param {number} itemNo The number of the new item.
     * @return {HTMLElement} The new element.
     */
    AddonQtypeDdMarkerQuestion.prototype.cloneNewDragItem = function (dragHome, itemNo) {
        var marker = dragHome.querySelector('span.markertext');
        marker.style.opacity = '0.6';
        // Clone the element and add the right classes.
        var drag = dragHome.cloneNode(true);
        drag.classList.remove('draghome');
        drag.classList.add('dragitem');
        drag.classList.add('item' + itemNo);
        // Insert the new drag after the dragHome.
        dragHome.parentElement.insertBefore(drag, dragHome.nextSibling);
        if (!this.readOnly) {
            this.draggable(drag);
        }
        return drag;
    };
    /**
     * Convert the X and Y position of the BG IMG to a position relative to the window.
     *
     * @param {number[]} bgImgXY X and Y of the BG IMG relative position.
     * @return {number[]} Position relative to the window.
     */
    AddonQtypeDdMarkerQuestion.prototype.convertToWindowXY = function (bgImgXY) {
        var bgImg = this.doc.bgImg(), position = this.domUtils.getElementXY(bgImg, null, 'ddarea');
        // Render the position related to the current image dimensions.
        bgImgXY[0] *= this.proportion;
        bgImgXY[1] *= this.proportion;
        return [Number(bgImgXY[0]) + position[0], Number(bgImgXY[1]) + position[1]];
    };
    /**
     * Check if some coordinates (X, Y) are inside the background image.
     *
     * @param {number[]} coords Coordinates to check.
     * @return {boolean} Whether they're inside the background image.
     */
    AddonQtypeDdMarkerQuestion.prototype.coordsInImg = function (coords) {
        var bgImg = this.doc.bgImg();
        return (coords[0] * this.proportion <= bgImg.width && coords[1] * this.proportion <= bgImg.height);
    };
    /**
     * Deselect all draggable items.
     */
    AddonQtypeDdMarkerQuestion.prototype.deselectDrags = function () {
        var drags = this.doc.dragItems();
        drags.forEach(function (drag) {
            drag.classList.remove('beingdragged');
        });
        this.selected = null;
    };
    /**
     * Function to call when the instance is no longer needed.
     */
    AddonQtypeDdMarkerQuestion.prototype.destroy = function () {
        if (this.resizeFunction) {
            window.removeEventListener('resize', this.resizeFunction);
        }
    };
    /**
     * Returns an object to encapsulate operations on dd area.
     *
     * @param {number} slot The question slot.
     * @return {AddonQtypeDdMarkerQuestionDocStructure} The object.
     */
    AddonQtypeDdMarkerQuestion.prototype.docStructure = function (slot) {
        var _this = this;
        var topNode = this.container.querySelector('.addon-qtype-ddmarker-container'), dragItemsArea = topNode.querySelector('div.dragitems');
        return {
            topNode: function () {
                return topNode;
            },
            bgImg: function () {
                return topNode.querySelector('.dropbackground');
            },
            dragItemsArea: function () {
                return dragItemsArea;
            },
            dragItems: function () {
                return Array.from(dragItemsArea.querySelectorAll('.dragitem'));
            },
            dragItemsForChoice: function (choiceNo) {
                return Array.from(dragItemsArea.querySelectorAll('span.dragitem.choice' + choiceNo));
            },
            dragItemForChoice: function (choiceNo, itemNo) {
                return dragItemsArea.querySelector('span.dragitem.choice' + choiceNo + '.item' + itemNo);
            },
            dragItemBeingDragged: function (choiceNo) {
                return dragItemsArea.querySelector('span.dragitem.beingdragged.choice' + choiceNo);
            },
            dragItemHome: function (choiceNo) {
                return dragItemsArea.querySelector('span.draghome.choice' + choiceNo);
            },
            dragItemHomes: function () {
                return Array.from(dragItemsArea.querySelectorAll('span.draghome'));
            },
            getClassnameNumericSuffix: function (node, prefix) {
                if (node.classList && node.classList.length) {
                    var patt1 = new RegExp('^' + prefix + '([0-9])+$'), patt2 = new RegExp('([0-9])+$');
                    for (var index = 0; index < node.classList.length; index++) {
                        if (patt1.test(node.classList[index])) {
                            var match = patt2.exec(node.classList[index]);
                            return Number(match[0]);
                        }
                    }
                }
                _this.logger.warn('Prefix "' + prefix + '" not found in class names.');
            },
            inputsForChoices: function () {
                return Array.from(topNode.querySelectorAll('input.choices'));
            },
            inputForChoice: function (choiceNo) {
                return topNode.querySelector('input.choice' + choiceNo);
            },
            markerTexts: function () {
                return topNode.querySelector('div.markertexts');
            }
        };
    };
    /**
     * Make an element "draggable". In the mobile app, items are "dragged" using tap and drop.
     *
     * @param {HTMLElement} drag Element.
     */
    AddonQtypeDdMarkerQuestion.prototype.draggable = function (drag) {
        var _this = this;
        drag.addEventListener('click', function (e) {
            e.preventDefault();
            e.stopPropagation();
            var dragging = _this.selected;
            if (dragging && !drag.classList.contains('unplaced')) {
                var position = _this.domUtils.getElementXY(drag, null, 'ddarea'), bgImg = _this.doc.bgImg(), bgImgPos = _this.domUtils.getElementXY(bgImg, null, 'ddarea');
                position[0] = position[0] - bgImgPos[0] + e.offsetX;
                position[1] = position[1] - bgImgPos[1] + e.offsetY;
                // Ensure the we click on a placed dragitem.
                if (position[0] <= bgImg.width && position[1] <= bgImg.height) {
                    _this.deselectDrags();
                    _this.dropDrag(dragging, position);
                    return;
                }
            }
            if (drag.classList.contains('beingdragged')) {
                _this.deselectDrags();
            }
            else {
                _this.selectDrag(drag);
            }
        });
    };
    /**
     * Get the coordinates of the drag home of a certain choice.
     *
     * @param {number} choiceNo Choice number.
     * @return {number[]} Coordinates.
     */
    AddonQtypeDdMarkerQuestion.prototype.dragHomeXY = function (choiceNo) {
        var dragItemHome = this.doc.dragItemHome(choiceNo), position = this.domUtils.getElementXY(dragItemHome, null, 'ddarea');
        return [position[0], position[1]];
    };
    /**
     * Draw a drop zone.
     *
     * @param {number} dropZoneNo Number of the drop zone.
     * @param {string} markerText The marker text to set.
     * @param {string} shape Name of the shape of the drop zone (circle, rectangle, polygon).
     * @param {string} coords Coordinates of the shape.
     * @param {string} colour Colour of the shape.
     */
    AddonQtypeDdMarkerQuestion.prototype.drawDropZone = function (dropZoneNo, markerText, shape, coords, colour) {
        var _this = this;
        var existingMarkerText;
        var markerTexts = this.doc.markerTexts();
        // Check if there is already a marker text for this drop zone.
        existingMarkerText = markerTexts.querySelector('span.markertext' + dropZoneNo);
        if (existingMarkerText) {
            // Marker text already exists. Update it or remove it if empty.
            if (markerText !== '') {
                existingMarkerText.innerHTML = markerText;
            }
            else {
                existingMarkerText.remove();
            }
        }
        else if (markerText !== '') {
            // Create and add the marker text.
            var classNames = 'markertext markertext' + dropZoneNo, span = document.createElement('span');
            span.className = classNames;
            span.innerHTML = markerText;
            markerTexts.appendChild(span);
        }
        // Check that a function to draw this shape exists.
        var drawFunc = 'drawShape' + this.textUtils.ucFirst(shape);
        if (this[drawFunc] instanceof Function) {
            // Call the function.
            var xyForText = this[drawFunc](dropZoneNo, coords, colour);
            if (xyForText !== null) {
                // Search the marker for the drop zone.
                var markerSpan = this.doc.topNode().querySelector('div.ddarea div.markertexts span.markertext' + dropZoneNo);
                if (markerSpan !== null) {
                    xyForText[0] = (xyForText[0] - markerSpan.offsetWidth / 2) * this.proportion;
                    xyForText[1] = (xyForText[1] - markerSpan.offsetHeight / 2) * this.proportion;
                    markerSpan.style.opacity = '0.6';
                    markerSpan.style.left = xyForText[0] + 'px';
                    markerSpan.style.top = xyForText[1] + 'px';
                    var markerSpanAnchor = markerSpan.querySelector('a');
                    if (markerSpanAnchor !== null) {
                        markerSpanAnchor.addEventListener('click', function (e) {
                            e.preventDefault();
                            e.stopPropagation();
                            _this.shapes.forEach(function (elem) {
                                elem.css('fill-opacity', 0.5);
                            });
                            _this.shapes[dropZoneNo].css('fill-opacity', 1);
                            setTimeout(function () {
                                _this.shapes[dropZoneNo].css('fill-opacity', 0.5);
                            }, 2000);
                        });
                        markerSpanAnchor.setAttribute('tabIndex', '0');
                    }
                }
            }
        }
    };
    /**
     * Draw a circle in a drop zone.
     *
     * @param {number} dropZoneNo Number of the drop zone.
     * @param {string} coords Coordinates of the circle.
     * @param {string} colour Colour of the circle.
     * @return {number[]} X and Y position of the center of the circle.
     */
    AddonQtypeDdMarkerQuestion.prototype.drawShapeCircle = function (dropZoneNo, coords, colour) {
        // Extract the numbers in the coordinates.
        var coordsParts = coords.match(/(\d+),(\d+);(\d+)/);
        if (coordsParts && coordsParts.length === 4) {
            // Remove first element and convert them to number.
            coordsParts.shift();
            var coordsPartsNum = coordsParts.map(function (i) {
                return Number(i);
            });
            // Calculate circle limits and check it's inside the background image.
            var circleLimit = [coordsPartsNum[0] - coordsPartsNum[2], coordsPartsNum[1] - coordsPartsNum[2]];
            if (this.coordsInImg(circleLimit)) {
                // All good, create the shape.
                this.shapes[dropZoneNo] = this.graphics.addShape({
                    type: 'circle',
                    color: colour
                }, {
                    cx: coordsPartsNum[0] * this.proportion,
                    cy: coordsPartsNum[1] * this.proportion,
                    r: coordsPartsNum[2] * this.proportion
                });
                // Return the center.
                return [coordsPartsNum[0], coordsPartsNum[1]];
            }
        }
        return null;
    };
    /**
     * Draw a rectangle in a drop zone.
     *
     * @param {number} dropZoneNo Number of the drop zone.
     * @param {string} coords Coordinates of the rectangle.
     * @param {string} colour Colour of the rectangle.
     * @return {number[]} X and Y position of the center of the rectangle.
     */
    AddonQtypeDdMarkerQuestion.prototype.drawShapeRectangle = function (dropZoneNo, coords, colour) {
        // Extract the numbers in the coordinates.
        var coordsParts = coords.match(/(\d+),(\d+);(\d+),(\d+)/);
        if (coordsParts && coordsParts.length === 5) {
            // Remove first element and convert them to number.
            coordsParts.shift();
            var coordsPartsNum = coordsParts.map(function (i) {
                return Number(i);
            });
            // Calculate rectangle limits and check it's inside the background image.
            var rectLimits = [coordsPartsNum[0] + coordsPartsNum[2], coordsPartsNum[1] + coordsPartsNum[3]];
            if (this.coordsInImg(rectLimits)) {
                // All good, create the shape.
                this.shapes[dropZoneNo] = this.graphics.addShape({
                    type: 'rect',
                    color: colour
                }, {
                    x: coordsPartsNum[0] * this.proportion,
                    y: coordsPartsNum[1] * this.proportion,
                    width: coordsPartsNum[2] * this.proportion,
                    height: coordsPartsNum[3] * this.proportion
                });
                // Return the center.
                return [coordsPartsNum[0] + coordsPartsNum[2] / 2, coordsPartsNum[1] + coordsPartsNum[3] / 2];
            }
        }
        return null;
    };
    /**
     * Draw a polygon in a drop zone.
     *
     * @param {number} dropZoneNo Number of the drop zone.
     * @param {string} coords Coordinates of the polygon.
     * @param {string} colour Colour of the polygon.
     * @return {number[]} X and Y position of the center of the polygon.
     */
    AddonQtypeDdMarkerQuestion.prototype.drawShapePolygon = function (dropZoneNo, coords, colour) {
        var coordsParts = coords.split(';'), points = [], bgImg = this.doc.bgImg(), maxXY = [0, 0], minXY = [bgImg.width, bgImg.height];
        for (var i in coordsParts) {
            // Extract the X and Y of this point.
            var partsString = coordsParts[i].match(/^(\d+),(\d+)$/), parts = partsString && partsString.map(function (part) {
                return Number(part);
            });
            if (parts !== null && this.coordsInImg([parts[1], parts[2]])) {
                parts[1] *= this.proportion;
                parts[2] *= this.proportion;
                // Calculate min and max points to find center to show marker on.
                minXY[0] = Math.min(parts[1], minXY[0]);
                minXY[1] = Math.min(parts[2], minXY[1]);
                maxXY[0] = Math.max(parts[1], maxXY[0]);
                maxXY[1] = Math.max(parts[2], maxXY[1]);
                points.push(parts[1] + ',' + parts[2]);
            }
        }
        if (points.length > 2) {
            this.shapes[dropZoneNo] = this.graphics.addShape({
                type: 'polygon',
                color: colour
            }, {
                points: points.join(' ')
            });
            // Return the center.
            return [(minXY[0] + maxXY[0]) / 2, (minXY[1] + maxXY[1]) / 2];
        }
        return null;
    };
    /**
     * Drop a drag element into a certain position.
     *
     * @param {HTMLElement} drag The element to drop.
     * @param {number[]} position Position to drop to (X, Y).
     */
    AddonQtypeDdMarkerQuestion.prototype.dropDrag = function (drag, position) {
        var choiceNo = this.getChoiceNoForNode(drag);
        if (position) {
            // Set the position related to the natural image dimensions.
            if (this.proportion < 1) {
                position[0] = Math.round(position[0] / this.proportion);
            }
            if (this.proportion < 1) {
                position[1] = Math.round(position[1] / this.proportion);
            }
        }
        this.saveAllXYForChoice(choiceNo, drag, position);
        this.redrawDragsAndDrops();
    };
    /**
     * Determine which drag items need to be shown and return coords of all drag items except any that are currently being
     * dragged based on contents of hidden inputs and whether drags are 'infinite' or how many drags should be shown.
     *
     * @param {HTMLElement} input The input element.
     * @return {number[][]} List of coordinates.
     */
    AddonQtypeDdMarkerQuestion.prototype.getCoords = function (input) {
        var choiceNo = this.getChoiceNoForNode(input), fv = input.getAttribute('value'), infinite = input.classList.contains('infinite'), noOfDrags = this.getNoOfDragsForNode(input), dragging = (this.doc.dragItemBeingDragged(choiceNo) !== null), coords = [];
        if (fv !== '' && typeof fv != 'undefined' && fv !== null) {
            // Get all the coordinates in the input and add them to the coords list.
            var coordsStrings = fv.split(';');
            for (var i = 0; i < coordsStrings.length; i++) {
                var coordsNumbers = coordsStrings[i].split(',').map(function (i) {
                    return Number(i);
                });
                coords[coords.length] = this.convertToWindowXY(coordsNumbers);
            }
        }
        var displayedDrags = coords.length + (dragging ? 1 : 0);
        if (infinite || (displayedDrags < noOfDrags)) {
            coords[coords.length] = this.dragHomeXY(choiceNo);
        }
        return coords;
    };
    /**
     * Get the choice number from an HTML element.
     *
     * @param {HTMLElement} node Element to check.
     * @return {number} Choice number.
     */
    AddonQtypeDdMarkerQuestion.prototype.getChoiceNoForNode = function (node) {
        return Number(this.doc.getClassnameNumericSuffix(node, 'choice'));
    };
    /**
     * Get the coordinates (X, Y) of a draggable element.
     *
     * @param {HTMLElement} dragItem The draggable item.
     * @return {number[]} Coordinates.
     */
    AddonQtypeDdMarkerQuestion.prototype.getDragXY = function (dragItem) {
        var position = this.domUtils.getElementXY(dragItem, null, 'ddarea'), bgImg = this.doc.bgImg(), bgImgXY = this.domUtils.getElementXY(bgImg, null, 'ddarea');
        position[0] -= bgImgXY[0];
        position[1] -= bgImgXY[1];
        // Set the position related to the natural image dimensions.
        if (this.proportion < 1) {
            position[0] = Math.round(position[0] / this.proportion);
        }
        if (this.proportion < 1) {
            position[1] = Math.round(position[1] / this.proportion);
        }
        return position;
    };
    /**
     * Get the item number from an HTML element.
     *
     * @param {HTMLElement} node Element to check.
     * @return {number} Choice number.
     */
    AddonQtypeDdMarkerQuestion.prototype.getItemNoForNode = function (node) {
        return Number(this.doc.getClassnameNumericSuffix(node, 'item'));
    };
    /**
     * Get the next colour.
     *
     * @return {string} Colour.
     */
    AddonQtypeDdMarkerQuestion.prototype.getNextColour = function () {
        var colour = this.COLOURS[this.nextColourIndex];
        this.nextColourIndex++;
        // If we reached the end of the list, start again.
        if (this.nextColourIndex === this.COLOURS.length) {
            this.nextColourIndex = 0;
        }
        return colour;
    };
    /**
     * Get the number of drags from an HTML element.
     *
     * @param {HTMLElement} node Element to check.
     * @return {number} Choice number.
     */
    AddonQtypeDdMarkerQuestion.prototype.getNoOfDragsForNode = function (node) {
        return Number(this.doc.getClassnameNumericSuffix(node, 'noofdrags'));
    };
    /**
     * Initialize the question.
     *
     * @param {any} question Question.
     */
    AddonQtypeDdMarkerQuestion.prototype.initializer = function (question) {
        var _this = this;
        this.doc = this.docStructure(question.slot);
        // Wait the DOM to be rendered.
        setTimeout(function () {
            _this.pollForImageLoad();
        });
        this.resizeFunction = this.redrawDragsAndDrops.bind(this);
        window.addEventListener('resize', this.resizeFunction);
    };
    /**
     * Make background image and home zone dropable.
     */
    AddonQtypeDdMarkerQuestion.prototype.makeImageDropable = function () {
        var _this = this;
        if (this.readOnly) {
            return;
        }
        // Listen for click events in the background image to make it dropable.
        var bgImg = this.doc.bgImg();
        bgImg.addEventListener('click', function (e) {
            var drag = _this.selected;
            if (!drag) {
                // No draggable element selected, nothing to do.
                return false;
            }
            // There's an element being dragged. Deselect it and drop it in the position.
            var position = [e.offsetX, e.offsetY];
            _this.deselectDrags();
            _this.dropDrag(drag, position);
            e.preventDefault();
            e.stopPropagation();
        });
        var home = this.doc.dragItemsArea();
        home.addEventListener('click', function (e) {
            var drag = _this.selected;
            if (!drag) {
                // No draggable element selected, nothing to do.
                return false;
            }
            // There's an element being dragged but it's not placed yet, deselect.
            if (drag.classList.contains('unplaced')) {
                _this.deselectDrags();
                return false;
            }
            // There's an element being dragged and it's placed somewhere. Move it back to the home area.
            _this.deselectDrags();
            _this.dropDrag(drag, null);
            e.preventDefault();
            e.stopPropagation();
        });
    };
    /**
     * Wait for the background image to be loaded.
     */
    AddonQtypeDdMarkerQuestion.prototype.pollForImageLoad = function () {
        var _this = this;
        if (this.afterImageLoadDone) {
            // Already treated.
            return;
        }
        var bgImg = this.doc.bgImg();
        if (!bgImg.src && this.imgSrc) {
            bgImg.src = this.imgSrc;
        }
        var imgLoaded = function () {
            bgImg.removeEventListener('load', imgLoaded);
            _this.makeImageDropable();
            setTimeout(function () {
                _this.redrawDragsAndDrops();
            });
            _this.afterImageLoadDone = true;
            _this.question.loaded = true;
        };
        bgImg.addEventListener('load', imgLoaded);
        // Try again after a while.
        setTimeout(function () {
            _this.pollForImageLoad();
        }, 500);
    };
    /**
     * Redraw all draggables and drop zones.
     */
    AddonQtypeDdMarkerQuestion.prototype.redrawDragsAndDrops = function () {
        // Mark all the draggable items as not placed.
        var drags = this.doc.dragItems();
        drags.forEach(function (drag) {
            drag.classList.add('unneeded', 'unplaced');
        });
        // Re-calculate the image proportion.
        this.calculateImgProportion();
        // Get all the inputs.
        var inputs = this.doc.inputsForChoices();
        for (var x = 0; x < inputs.length; x++) {
            // Get all the drag items for the choice.
            var input = inputs[x], choiceNo = this.getChoiceNoForNode(input), coords = this.getCoords(input), dragItemHome = this.doc.dragItemHome(choiceNo), homePosition = this.dragHomeXY(choiceNo);
            for (var i = 0; i < coords.length; i++) {
                var dragItem = this.doc.dragItemForChoice(choiceNo, i);
                if (!dragItem || dragItem.classList.contains('beingdragged')) {
                    dragItem = this.cloneNewDragItem(dragItemHome, i);
                }
                else {
                    dragItem.classList.remove('unneeded');
                }
                // Remove the class only if is placed on the image.
                if (homePosition[0] != coords[i][0] || homePosition[1] != coords[i][1]) {
                    dragItem.classList.remove('unplaced');
                }
                dragItem.style.left = coords[i][0] + 'px';
                dragItem.style.top = coords[i][1] + 'px';
            }
        }
        // Remove unneeded draggable items.
        for (var y = 0; y < drags.length; y++) {
            var item = drags[y];
            if (item.classList.contains('unneeded') && !item.classList.contains('beingdragged')) {
                item.remove();
            }
        }
        // Re-draw drop zones.
        if (this.dropZones && this.dropZones.length !== 0) {
            this.graphics.clear();
            this.restartColours();
            for (var dropZoneNo in this.dropZones) {
                var colourForDropZone = this.getNextColour(), dropZone = this.dropZones[dropZoneNo], dzNo = Number(dropZoneNo);
                this.drawDropZone(dzNo, dropZone.markertext, dropZone.shape, dropZone.coords, colourForDropZone);
            }
        }
    };
    /**
     * Reset the coordinates stored for a choice.
     *
     * @param {number} choiceNo Choice number.
     */
    AddonQtypeDdMarkerQuestion.prototype.resetDragXY = function (choiceNo) {
        this.setFormValue(choiceNo, '');
    };
    /**
     * Restart the colour index.
     */
    AddonQtypeDdMarkerQuestion.prototype.restartColours = function () {
        this.nextColourIndex = 0;
    };
    /**
     * Save all the coordinates of a choice into the right input.
     *
     * @param {number} choiceNo Number of the choice.
     * @param {HTMLElement} dropped Element being dropped.
     * @param {number[]} position Position where the element is dropped.
     */
    AddonQtypeDdMarkerQuestion.prototype.saveAllXYForChoice = function (choiceNo, dropped, position) {
        var coords = [];
        var bgImgXY;
        // Calculate the coords for the choice.
        var dragItemsChoice = this.doc.dragItemsForChoice(choiceNo);
        for (var i = 0; i < dragItemsChoice.length; i++) {
            var dragItem = this.doc.dragItemForChoice(choiceNo, i);
            if (dragItem) {
                dragItem.classList.remove('item' + i);
                bgImgXY = this.getDragXY(dragItem);
                dragItem.classList.add('item' + coords.length);
                coords.push(bgImgXY);
            }
        }
        if (position !== null) {
            // Element dropped into a certain position. Mark it as placed and save the position.
            dropped.classList.remove('unplaced');
            dropped.classList.add('item' + coords.length);
            coords.push(position);
        }
        else {
            // Element back at home, mark it as unplaced.
            dropped.classList.add('unplaced');
        }
        if (coords.length > 0) {
            // Save the coordinates in the input.
            this.setFormValue(choiceNo, coords.join(';'));
        }
        else {
            // Empty the input.
            this.resetDragXY(choiceNo);
        }
    };
    /**
     * Save a certain value in the input of a choice.
     *
     * @param {number} choiceNo Choice number.
     * @param {string} value The value to set.
     */
    AddonQtypeDdMarkerQuestion.prototype.setFormValue = function (choiceNo, value) {
        this.doc.inputForChoice(choiceNo).setAttribute('value', value);
    };
    /**
     * Select a draggable element.
     *
     * @param {HTMLElement} drag Element.
     */
    AddonQtypeDdMarkerQuestion.prototype.selectDrag = function (drag) {
        // Deselect previous drags.
        this.deselectDrags();
        this.selected = drag;
        drag.classList.add('beingdragged');
        var itemNo = this.getItemNoForNode(drag);
        if (itemNo !== null) {
            drag.classList.remove('item' + itemNo);
        }
    };
    return AddonQtypeDdMarkerQuestion;
}());

//# sourceMappingURL=ddmarker.js.map

/***/ }),
/* 1867 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdMarkerGraphicsApi; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Graphics API for drag-and-drop markers question type.
 */
var AddonQtypeDdMarkerGraphicsApi = /** @class */ (function () {
    /**
     * Create the instance.
     *
     * @param {AddonQtypeDdMarkerQuestion} instance Question instance.
     * @param {CoreDomUtilsProvider} domUtils Dom Utils provider.
     */
    function AddonQtypeDdMarkerGraphicsApi(instance, domUtils) {
        this.instance = instance;
        this.domUtils = domUtils;
        this.NS = 'http://www.w3.org/2000/svg';
    }
    /**
     * Add a shape.
     *
     * @param {{type: string, color: string}} shapeAttribs Attributes for the shape: type and color.
     * @param {{[name: string]: number|string} styles Object with the styles for the shape (name -> value).
     * @return {Element} The new shape.
     */
    AddonQtypeDdMarkerGraphicsApi.prototype.addShape = function (shapeAttribs, styles) {
        var shape = document.createElementNS(this.NS, shapeAttribs.type);
        shape.setAttribute('fill', shapeAttribs.color);
        shape.setAttribute('fill-opacity', '0.5');
        shape.setAttribute('stroke', 'black');
        for (var x in styles) {
            shape.setAttribute(x, String(styles[x]));
        }
        this.dropZone.appendChild(shape);
        return shape;
    };
    /**
     * Clear the shapes.
     */
    AddonQtypeDdMarkerGraphicsApi.prototype.clear = function () {
        var bgImg = this.instance.doc.bgImg(), position = this.domUtils.getElementXY(bgImg, null, 'ddarea'), dropZones = this.instance.doc.topNode().querySelector('div.ddarea div.dropzones');
        dropZones.style.left = position[0] + 'px';
        dropZones.style.top = position[1] + 'px';
        dropZones.style.width = bgImg.width + 'px';
        dropZones.style.height = bgImg.height + 'px';
        var markerTexts = this.instance.doc.markerTexts();
        markerTexts.style.left = position[0] + 'px';
        markerTexts.style.top = position[1] + 'px';
        markerTexts.style.width = bgImg.width + 'px';
        markerTexts.style.height = bgImg.height + 'px';
        if (!this.dropZone) {
            this.dropZone = document.createElementNS(this.NS, 'svg');
            dropZones.appendChild(this.dropZone);
        }
        else {
            // Remove all children.
            while (this.dropZone.firstChild) {
                this.dropZone.removeChild(this.dropZone.firstChild);
            }
        }
        this.dropZone.style.width = bgImg.width + 'px';
        this.dropZone.style.height = bgImg.height + 'px';
        this.instance.shapes = [];
    };
    return AddonQtypeDdMarkerGraphicsApi;
}());

//# sourceMappingURL=graphics_api.js.map

/***/ }),
/* 1868 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdwtosModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(1869);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_ddwtos__ = __webpack_require__(958);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeDdwtosModule = /** @class */ (function () {
    function AddonQtypeDdwtosModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeDdwtosModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddwtos__["a" /* AddonQtypeDdwtosComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeDdwtosHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddwtos__["a" /* AddonQtypeDdwtosComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_ddwtos__["a" /* AddonQtypeDdwtosComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeDdwtosHandler */]])
    ], AddonQtypeDdwtosModule);
    return AddonQtypeDdwtosModule;
}());

//# sourceMappingURL=ddwtos.module.js.map

/***/ }),
/* 1869 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdwtosHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_ddwtos__ = __webpack_require__(958);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support drag-and-drop words into sentences question type.
 */
var AddonQtypeDdwtosHandler = /** @class */ (function () {
    function AddonQtypeDdwtosHandler(questionProvider) {
        this.questionProvider = questionProvider;
        this.name = 'AddonQtypeDdwtos';
        this.type = 'qtype_ddwtos';
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeDdwtosHandler.prototype.getBehaviour = function (question, behaviour) {
        if (behaviour === 'interactive') {
            return 'interactivecountback';
        }
        return behaviour;
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeDdwtosHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_2__component_ddwtos__["a" /* AddonQtypeDdwtosComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeDdwtosHandler.prototype.isCompleteResponse = function (question, answers) {
        for (var name_1 in answers) {
            var value = answers[name_1];
            if (!value || value === '0') {
                return 0;
            }
        }
        return 1;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeDdwtosHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeDdwtosHandler.prototype.isGradableResponse = function (question, answers) {
        for (var name_2 in answers) {
            var value = answers[name_2];
            if (value && value !== '0') {
                return 1;
            }
        }
        return 0;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeDdwtosHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.questionProvider.compareAllAnswers(prevAnswers, newAnswers);
    };
    AddonQtypeDdwtosHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], AddonQtypeDdwtosHandler);
    return AddonQtypeDdwtosHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1870 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDdwtosQuestion; });
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Class to make a question of ddwtos type work.
 */
var AddonQtypeDdwtosQuestion = /** @class */ (function () {
    /**
     * Create the instance.
     *
     * @param {CoreLoggerProvider} logger Logger provider.
     * @param {CoreDomUtilsProvider} domUtils Dom Utils provider.
     * @param {HTMLElement} container The container HTMLElement of the question.
     * @param {any} question The question instance.
     * @param {boolean} readOnly Whether it's read only.
     * @param {string[]} inputIds Ids of the inputs of the question (where the answers will be stored).
     */
    function AddonQtypeDdwtosQuestion(logger, domUtils, container, question, readOnly, inputIds, textUtils) {
        this.domUtils = domUtils;
        this.container = container;
        this.question = question;
        this.readOnly = readOnly;
        this.inputIds = inputIds;
        this.textUtils = textUtils;
        this.nextDragItemNo = 1;
        this.logger = logger.getInstance('AddonQtypeDdwtosQuestion');
        this.initializer(question);
    }
    /**
     * Clone a drag item and add it to the drag container.
     *
     * @param {HTMLElement} dragHome Item to clone
     */
    AddonQtypeDdwtosQuestion.prototype.cloneDragItem = function (dragHome) {
        var drag = dragHome.cloneNode(true);
        drag.classList.remove('draghome');
        drag.classList.add('drag');
        drag.classList.add('no' + this.nextDragItemNo);
        this.nextDragItemNo++;
        drag.style.visibility = 'visible';
        drag.style.position = 'absolute';
        var container = this.container.querySelector(this.selectors.dragContainer());
        container.appendChild(drag);
        if (!this.readOnly) {
            this.makeDraggable(drag);
        }
    };
    /**
     * Clone the 'drag homes'.
     * Invisible 'drag homes' are output in the question. These have the same properties as the drag items but are invisible.
     * We clone these invisible elements to make the actual drag items.
     */
    AddonQtypeDdwtosQuestion.prototype.cloneDragItems = function () {
        var dragHomes = Array.from(this.container.querySelectorAll(this.selectors.dragHomes()));
        for (var x = 0; x < dragHomes.length; x++) {
            this.cloneDragItemsForOneChoice(dragHomes[x]);
        }
    };
    /**
     * Clone a certain 'drag home'. If it's an "infinite" drag, clone it several times.
     *
     * @param {HTMLElement} dragHome Element to clone.
     */
    AddonQtypeDdwtosQuestion.prototype.cloneDragItemsForOneChoice = function (dragHome) {
        if (dragHome.classList.contains('infinite')) {
            var groupNo = this.getGroup(dragHome), noOfDrags = this.container.querySelectorAll(this.selectors.dropsInGroup(groupNo)).length;
            for (var x = 0; x < noOfDrags; x++) {
                this.cloneDragItem(dragHome);
            }
        }
        else {
            this.cloneDragItem(dragHome);
        }
    };
    /**
     * Get an object with a set of functions to get the CSS selectors.
     *
     * @param {number} slot Question slot.
     * @return {AddonQtypeDdwtosQuestionCSSSelectors} Object with the functions to get the selectors.
     */
    AddonQtypeDdwtosQuestion.prototype.cssSelectors = function (slot) {
        var topNode = '.addon-qtype-ddwtos-container', selectors = {};
        selectors.topNode = function () {
            return topNode;
        };
        selectors.dragContainer = function () {
            return topNode + ' div.drags';
        };
        selectors.drags = function () {
            return selectors.dragContainer() + ' span.drag';
        };
        selectors.drag = function (no) {
            return selectors.drags() + '.no' + no;
        };
        selectors.dragsInGroup = function (groupNo) {
            return selectors.drags() + '.group' + groupNo;
        };
        selectors.unplacedDragsInGroup = function (groupNo) {
            return selectors.dragsInGroup(groupNo) + '.unplaced';
        };
        selectors.dragsForChoiceInGroup = function (choiceNo, groupNo) {
            return selectors.dragsInGroup(groupNo) + '.choice' + choiceNo;
        };
        selectors.unplacedDragsForChoiceInGroup = function (choiceNo, groupNo) {
            return selectors.unplacedDragsInGroup(groupNo) + '.choice' + choiceNo;
        };
        selectors.drops = function () {
            return topNode + ' span.drop';
        };
        selectors.dropForPlace = function (placeNo) {
            return selectors.drops() + '.place' + placeNo;
        };
        selectors.dropsInGroup = function (groupNo) {
            return selectors.drops() + '.group' + groupNo;
        };
        selectors.dragHomes = function () {
            return topNode + ' span.draghome';
        };
        selectors.dragHomesGroup = function (groupNo) {
            return topNode + ' .draggrouphomes' + groupNo + ' span.draghome';
        };
        selectors.dragHome = function (groupNo, choiceNo) {
            return topNode + ' .draggrouphomes' + groupNo + ' span.draghome.choice' + choiceNo;
        };
        selectors.dropsGroup = function (groupNo) {
            return topNode + ' span.drop.group' + groupNo;
        };
        return selectors;
    };
    /**
     * Deselect all drags.
     */
    AddonQtypeDdwtosQuestion.prototype.deselectDrags = function () {
        // Remove the selected class from all drags.
        var drags = Array.from(this.container.querySelectorAll(this.selectors.drags()));
        drags.forEach(function (drag) {
            drag.classList.remove('selected');
        });
        this.selected = null;
    };
    /**
     * Function to call when the instance is no longer needed.
     */
    AddonQtypeDdwtosQuestion.prototype.destroy = function () {
        if (this.resizeFunction) {
            window.removeEventListener('resize', this.resizeFunction);
        }
    };
    /**
     * Get the choice number of an element. It is extracted from the classes.
     *
     * @param {HTMLElement} node Element to check.
     * @return {number} Choice number.
     */
    AddonQtypeDdwtosQuestion.prototype.getChoice = function (node) {
        return this.getClassnameNumericSuffix(node, 'choice');
    };
    /**
     * Get the number in a certain class name of an element.
     *
     * @param {HTMLElement} node The element to check.
     * @param {string} prefix Prefix of the class to check.
     * @return {number} The number in the class.
     */
    AddonQtypeDdwtosQuestion.prototype.getClassnameNumericSuffix = function (node, prefix) {
        if (node.classList && node.classList.length) {
            var patt1 = new RegExp('^' + prefix + '([0-9])+$'), patt2 = new RegExp('([0-9])+$');
            for (var index = 0; index < node.classList.length; index++) {
                if (patt1.test(node.classList[index])) {
                    var match = patt2.exec(node.classList[index]);
                    return Number(match[0]);
                }
            }
        }
        this.logger.warn('Prefix "' + prefix + '" not found in class names.');
    };
    /**
     * Get the group number of an element. It is extracted from the classes.
     *
     * @param {HTMLElement} node Element to check.
     * @return {number} Group number.
     */
    AddonQtypeDdwtosQuestion.prototype.getGroup = function (node) {
        return this.getClassnameNumericSuffix(node, 'group');
    };
    /**
     * Get the number of an element ('no'). It is extracted from the classes.
     *
     * @param {HTMLElement} node Element to check.
     * @return {number} Number.
     */
    AddonQtypeDdwtosQuestion.prototype.getNo = function (node) {
        return this.getClassnameNumericSuffix(node, 'no');
    };
    /**
     * Get the place number of an element. It is extracted from the classes.
     *
     * @param {HTMLElement} node Element to check.
     * @return {number} Place number.
     */
    AddonQtypeDdwtosQuestion.prototype.getPlace = function (node) {
        return this.getClassnameNumericSuffix(node, 'place');
    };
    /**
     * Initialize the question.
     *
     * @param {any} question Question.
     */
    AddonQtypeDdwtosQuestion.prototype.initializer = function (question) {
        var _this = this;
        this.selectors = this.cssSelectors(question.slot);
        var container = this.container.querySelector(this.selectors.topNode());
        if (this.readOnly) {
            container.classList.add('readonly');
        }
        else {
            container.classList.add('notreadonly');
        }
        this.setPaddingSizesAll();
        this.cloneDragItems();
        this.initialPlaceOfDragItems();
        this.makeDropZones();
        // Wait the DOM to be rendered.
        setTimeout(function () {
            _this.positionDragItems();
        });
        this.resizeFunction = this.positionDragItems.bind(this);
        window.addEventListener('resize', this.resizeFunction);
    };
    /**
     * Initialize drag items, putting them in their initial place.
     */
    AddonQtypeDdwtosQuestion.prototype.initialPlaceOfDragItems = function () {
        var drags = Array.from(this.container.querySelectorAll(this.selectors.drags()));
        // Add the class 'unplaced' to all elements.
        drags.forEach(function (drag) {
            drag.classList.add('unplaced');
        });
        this.placed = {};
        for (var placeNo in this.inputIds) {
            var inputId = this.inputIds[placeNo], inputNode = this.container.querySelector('input#' + inputId), choiceNo = Number(inputNode.getAttribute('value'));
            if (choiceNo !== 0) {
                var drop = this.container.querySelector(this.selectors.dropForPlace(parseInt(placeNo, 10) + 1)), groupNo = this.getGroup(drop), drag = this.container.querySelector(this.selectors.unplacedDragsForChoiceInGroup(choiceNo, groupNo));
                this.placeDragInDrop(drag, drop);
                this.positionDragItem(drag);
            }
        }
    };
    /**
     * Make an element "draggable". In the mobile app, items are "dragged" using tap and drop.
     *
     * @param {HTMLElement} drag Element.
     */
    AddonQtypeDdwtosQuestion.prototype.makeDraggable = function (drag) {
        var _this = this;
        drag.addEventListener('click', function () {
            if (drag.classList.contains('selected')) {
                _this.deselectDrags();
            }
            else {
                _this.selectDrag(drag);
            }
        });
    };
    /**
     * Convert an element into a drop zone.
     *
     * @param {HTMLElement} drop Element.
     */
    AddonQtypeDdwtosQuestion.prototype.makeDropZone = function (drop) {
        var _this = this;
        drop.addEventListener('click', function () {
            var drag = _this.selected;
            if (!drag) {
                // No element selected, nothing to do.
                return false;
            }
            // Place it only if the same group is selected.
            if (_this.getGroup(drag) === _this.getGroup(drop)) {
                _this.placeDragInDrop(drag, drop);
                _this.deselectDrags();
                _this.positionDragItem(drag);
            }
        });
    };
    /**
     * Create all drop zones.
     */
    AddonQtypeDdwtosQuestion.prototype.makeDropZones = function () {
        var _this = this;
        if (this.readOnly) {
            return;
        }
        // Create all the drop zones.
        var drops = Array.from(this.container.querySelectorAll(this.selectors.drops()));
        drops.forEach(function (drop) {
            _this.makeDropZone(drop);
        });
        // If home answer zone is clicked, return drag home.
        var home = this.container.querySelector(this.selectors.topNode() + ' .answercontainer');
        home.addEventListener('click', function () {
            var drag = _this.selected;
            if (!drag) {
                // No element selected, nothing to do.
                return;
            }
            // Not placed yet, deselect.
            if (drag.classList.contains('unplaced')) {
                _this.deselectDrags();
                return;
            }
            // Remove, deselect and move back home in this order.
            _this.removeDragFromDrop(drag);
            _this.deselectDrags();
            _this.positionDragItem(drag);
        });
    };
    /**
     * Set the width and height of an element.
     *
     * @param {HTMLElement} node Element.
     * @param {number} width Width to set.
     * @param {number} height Height to set.
     */
    AddonQtypeDdwtosQuestion.prototype.padToWidthHeight = function (node, width, height) {
        node.style.width = width + 'px';
        node.style.height = height + 'px';
        // Originally lineHeight was set as height to center the text but it comes on too height lines on multiline elements.
    };
    /**
     * Place a draggable element inside a drop zone.
     *
     * @param {HTMLElement} drag Draggable element.
     * @param {HTMLElement} drop Drop zone.
     */
    AddonQtypeDdwtosQuestion.prototype.placeDragInDrop = function (drag, drop) {
        var placeNo = this.getPlace(drop), inputId = this.inputIds[placeNo - 1], inputNode = this.container.querySelector('input#' + inputId);
        // Set the value of the drag element in the input of the drop zone.
        if (drag !== null) {
            inputNode.setAttribute('value', String(this.getChoice(drag)));
        }
        else {
            inputNode.setAttribute('value', '0');
        }
        // Remove the element from the "placed" map if it's there.
        for (var alreadyThereDragNo in this.placed) {
            if (this.placed[alreadyThereDragNo] === placeNo) {
                delete this.placed[alreadyThereDragNo];
            }
        }
        if (drag !== null) {
            // Add the element in the "placed" map.
            this.placed[this.getNo(drag)] = placeNo;
        }
    };
    /**
     * Position a drag element in the right drop zone or in the home zone.
     *
     * @param {HTMLElement} drag Drag element.
     */
    AddonQtypeDdwtosQuestion.prototype.positionDragItem = function (drag) {
        var position;
        var placeNo = this.placed[this.getNo(drag)];
        if (!placeNo) {
            // Not placed, put it in home zone.
            var groupNo = this.getGroup(drag), choiceNo = this.getChoice(drag);
            position = this.domUtils.getElementXY(this.container, this.selectors.dragHome(groupNo, choiceNo), 'answercontainer');
            drag.classList.add('unplaced');
        }
        else {
            // Get the drop zone position.
            position = this.domUtils.getElementXY(this.container, this.selectors.dropForPlace(placeNo), 'addon-qtype-ddwtos-container');
            drag.classList.remove('unplaced');
        }
        if (position) {
            drag.style.left = position[0] + 'px';
            drag.style.top = position[1] + 'px';
        }
    };
    /**
     * Postition, or reposition, all the drag items. They're placed in the right drop zone or in the home zone.
     */
    AddonQtypeDdwtosQuestion.prototype.positionDragItems = function () {
        var _this = this;
        var drags = Array.from(this.container.querySelectorAll(this.selectors.drags()));
        drags.forEach(function (drag) {
            _this.positionDragItem(drag);
        });
    };
    /**
     * Remove a draggable element from a drop zone.
     *
     * @param {HTMLElement} drag The draggable element.
     */
    AddonQtypeDdwtosQuestion.prototype.removeDragFromDrop = function (drag) {
        var placeNo = this.placed[this.getNo(drag)], drop = this.container.querySelector(this.selectors.dropForPlace(placeNo));
        this.placeDragInDrop(null, drop);
    };
    /**
     * Select a certain element as being "dragged".
     *
     * @param {HTMLElement} drag Element.
     */
    AddonQtypeDdwtosQuestion.prototype.selectDrag = function (drag) {
        // Deselect previous drags, only 1 can be selected.
        this.deselectDrags();
        this.selected = drag;
        drag.classList.add('selected');
    };
    /**
     * Set the padding size for all groups.
     */
    AddonQtypeDdwtosQuestion.prototype.setPaddingSizesAll = function () {
        for (var groupNo = 1; groupNo <= 8; groupNo++) {
            this.setPaddingSizeForGroup(groupNo);
        }
    };
    /**
     * Set the padding size for a certain group.
     *
     * @param {number} groupNo Group number.
     */
    AddonQtypeDdwtosQuestion.prototype.setPaddingSizeForGroup = function (groupNo) {
        var _this = this;
        var groupItems = Array.from(this.container.querySelectorAll(this.selectors.dragHomesGroup(groupNo)));
        if (groupItems.length !== 0) {
            var maxWidth_1 = 0, maxHeight_1 = 0;
            // Find max height and width.
            groupItems.forEach(function (item) {
                item.innerHTML = _this.textUtils.decodeHTML(item.innerHTML);
                maxWidth_1 = Math.max(maxWidth_1, Math.ceil(item.offsetWidth));
                maxHeight_1 = Math.max(maxHeight_1, Math.ceil(item.offsetHeight));
            });
            maxWidth_1 += 8;
            maxHeight_1 += 2;
            groupItems.forEach(function (item) {
                _this.padToWidthHeight(item, maxWidth_1, maxHeight_1);
            });
            var dropsGroup = Array.from(this.container.querySelectorAll(this.selectors.dropsGroup(groupNo)));
            dropsGroup.forEach(function (item) {
                _this.padToWidthHeight(item, maxWidth_1 + 2, maxHeight_1 + 2);
            });
        }
    };
    return AddonQtypeDdwtosQuestion;
}());

//# sourceMappingURL=ddwtos.js.map

/***/ }),
/* 1871 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDescriptionModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_handler__ = __webpack_require__(1872);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_description__ = __webpack_require__(959);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonQtypeDescriptionModule = /** @class */ (function () {
    function AddonQtypeDescriptionModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeDescriptionModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_description__["a" /* AddonQtypeDescriptionComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQtypeDescriptionHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_description__["a" /* AddonQtypeDescriptionComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_description__["a" /* AddonQtypeDescriptionComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQtypeDescriptionHandler */]])
    ], AddonQtypeDescriptionModule);
    return AddonQtypeDescriptionModule;
}());

//# sourceMappingURL=description.module.js.map

/***/ }),
/* 1872 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeDescriptionHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__component_description__ = __webpack_require__(959);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Handler to support description question type.
 */
var AddonQtypeDescriptionHandler = /** @class */ (function () {
    function AddonQtypeDescriptionHandler() {
        this.name = 'AddonQtypeDescription';
        this.type = 'qtype_description';
        // Nothing to do.
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeDescriptionHandler.prototype.getBehaviour = function (question, behaviour) {
        return 'informationitem';
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeDescriptionHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_1__component_description__["a" /* AddonQtypeDescriptionComponent */];
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeDescriptionHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Validate if an offline sequencecheck is valid compared with the online one.
     * This function only needs to be implemented if a specific compare is required.
     *
     * @param {any} question The question.
     * @param {string} offlineSequenceCheck Sequence check stored in offline.
     * @return {boolean} Whether sequencecheck is valid.
     */
    AddonQtypeDescriptionHandler.prototype.validateSequenceCheck = function (question, offlineSequenceCheck) {
        // Descriptions don't have any answer so we'll always treat them as valid.
        return true;
    };
    AddonQtypeDescriptionHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], AddonQtypeDescriptionHandler);
    return AddonQtypeDescriptionHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1873 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeEssayModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(1874);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_essay__ = __webpack_require__(960);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeEssayModule = /** @class */ (function () {
    function AddonQtypeEssayModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeEssayModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_essay__["a" /* AddonQtypeEssayComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeEssayHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_essay__["a" /* AddonQtypeEssayComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_essay__["a" /* AddonQtypeEssayComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeEssayHandler */]])
    ], AddonQtypeEssayModule);
    return AddonQtypeEssayModule;
}());

//# sourceMappingURL=essay.module.js.map

/***/ }),
/* 1874 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeEssayHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_text__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__core_question_providers_helper__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__component_essay__ = __webpack_require__(960);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Handler to support essay question type.
 */
var AddonQtypeEssayHandler = /** @class */ (function () {
    function AddonQtypeEssayHandler(utils, questionHelper, textUtils, domUtils) {
        this.utils = utils;
        this.questionHelper = questionHelper;
        this.textUtils = textUtils;
        this.domUtils = domUtils;
        this.name = 'AddonQtypeEssay';
        this.type = 'qtype_essay';
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeEssayHandler.prototype.getBehaviour = function (question, behaviour) {
        return 'manualgraded';
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeEssayHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_5__component_essay__["a" /* AddonQtypeEssayComponent */];
    };
    /**
     * Check if a question can be submitted.
     * If a question cannot be submitted it should return a message explaining why (translated or not).
     *
     * @param {any} question The question.
     * @return {string} Prevent submit message. Undefined or empty if can be submitted.
     */
    AddonQtypeEssayHandler.prototype.getPreventSubmitMessage = function (question) {
        var element = this.domUtils.convertToElement(question.html);
        if (element.querySelector('div[id*=filemanager]')) {
            // The question allows attachments. Since the app cannot attach files yet we will prevent submitting the question.
            return 'core.question.errorattachmentsnotsupported';
        }
        if (this.questionHelper.hasDraftFileUrls(element.innerHTML)) {
            return 'core.question.errorinlinefilesnotsupported';
        }
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeEssayHandler.prototype.isCompleteResponse = function (question, answers) {
        var element = this.domUtils.convertToElement(question.html);
        var hasInlineText = answers['answer'] && answers['answer'] !== '', allowsAttachments = !!element.querySelector('div[id*=filemanager]');
        if (!allowsAttachments) {
            return hasInlineText ? 1 : 0;
        }
        // We can't know if the attachments are required or if the user added any in web.
        return -1;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeEssayHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeEssayHandler.prototype.isGradableResponse = function (question, answers) {
        return 0;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeEssayHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, 'answer');
    };
    /**
     * Prepare and add to answers the data to send to server based in the input. Return promise if async.
     *
     * @param {any} question Question.
     * @param {any} answers The answers retrieved from the form. Prepared answers must be stored in this object.
     * @param {boolean} [offline] Whether the data should be saved in offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Return a promise resolved when done if async, void if sync.
     */
    AddonQtypeEssayHandler.prototype.prepareAnswers = function (question, answers, offline, siteId) {
        var element = this.domUtils.convertToElement(question.html);
        // Search the textarea to get its name.
        var textarea = element.querySelector('textarea[name*=_answer]');
        if (textarea && typeof answers[textarea.name] != 'undefined') {
            // Add some HTML to the text if needed.
            answers[textarea.name] = this.textUtils.formatHtmlLines(answers[textarea.name]);
        }
    };
    AddonQtypeEssayHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__providers_utils_utils__["a" /* CoreUtilsProvider */], __WEBPACK_IMPORTED_MODULE_4__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */],
            __WEBPACK_IMPORTED_MODULE_1__providers_utils_text__["a" /* CoreTextUtilsProvider */], __WEBPACK_IMPORTED_MODULE_2__providers_utils_dom__["a" /* CoreDomUtilsProvider */]])
    ], AddonQtypeEssayHandler);
    return AddonQtypeEssayHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1875 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeGapSelectModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_handler__ = __webpack_require__(1876);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_gapselect__ = __webpack_require__(961);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonQtypeGapSelectModule = /** @class */ (function () {
    function AddonQtypeGapSelectModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeGapSelectModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_gapselect__["a" /* AddonQtypeGapSelectComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQtypeGapSelectHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_gapselect__["a" /* AddonQtypeGapSelectComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_gapselect__["a" /* AddonQtypeGapSelectComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQtypeGapSelectHandler */]])
    ], AddonQtypeGapSelectModule);
    return AddonQtypeGapSelectModule;
}());

//# sourceMappingURL=gapselect.module.js.map

/***/ }),
/* 1876 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeGapSelectHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_gapselect__ = __webpack_require__(961);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support gapselect question type.
 */
var AddonQtypeGapSelectHandler = /** @class */ (function () {
    function AddonQtypeGapSelectHandler(questionProvider) {
        this.questionProvider = questionProvider;
        this.name = 'AddonQtypeGapSelect';
        this.type = 'qtype_gapselect';
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeGapSelectHandler.prototype.getBehaviour = function (question, behaviour) {
        if (behaviour === 'interactive') {
            return 'interactivecountback';
        }
        return behaviour;
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeGapSelectHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_2__component_gapselect__["a" /* AddonQtypeGapSelectComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeGapSelectHandler.prototype.isCompleteResponse = function (question, answers) {
        // We should always get a value for each select so we can assume we receive all the possible answers.
        for (var name_1 in answers) {
            var value = answers[name_1];
            if (!value || value === '0') {
                return 0;
            }
        }
        return 1;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeGapSelectHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeGapSelectHandler.prototype.isGradableResponse = function (question, answers) {
        // We should always get a value for each select so we can assume we receive all the possible answers.
        for (var name_2 in answers) {
            var value = answers[name_2];
            if (value) {
                return 1;
            }
        }
        return 0;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeGapSelectHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.questionProvider.compareAllAnswers(prevAnswers, newAnswers);
    };
    AddonQtypeGapSelectHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__["a" /* CoreQuestionProvider */]])
    ], AddonQtypeGapSelectHandler);
    return AddonQtypeGapSelectHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1877 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMatchModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_match__ = __webpack_require__(407);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeMatchModule = /** @class */ (function () {
    function AddonQtypeMatchModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeMatchModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_match__["a" /* AddonQtypeMatchComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeMatchHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_match__["a" /* AddonQtypeMatchComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_match__["a" /* AddonQtypeMatchComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeMatchHandler */]])
    ], AddonQtypeMatchModule);
    return AddonQtypeMatchModule;
}());

//# sourceMappingURL=match.module.js.map

/***/ }),
/* 1878 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMultiAnswerModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_handler__ = __webpack_require__(1879);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__component_multianswer__ = __webpack_require__(963);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var AddonQtypeMultiAnswerModule = /** @class */ (function () {
    function AddonQtypeMultiAnswerModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeMultiAnswerModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_6__component_multianswer__["a" /* AddonQtypeMultiAnswerComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQtypeMultiAnswerHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_6__component_multianswer__["a" /* AddonQtypeMultiAnswerComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_6__component_multianswer__["a" /* AddonQtypeMultiAnswerComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_5__providers_handler__["a" /* AddonQtypeMultiAnswerHandler */]])
    ], AddonQtypeMultiAnswerModule);
    return AddonQtypeMultiAnswerModule;
}());

//# sourceMappingURL=multianswer.module.js.map

/***/ }),
/* 1879 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMultiAnswerHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__ = __webpack_require__(78);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__component_multianswer__ = __webpack_require__(963);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Handler to support multianswer question type.
 */
var AddonQtypeMultiAnswerHandler = /** @class */ (function () {
    function AddonQtypeMultiAnswerHandler(questionProvider, questionHelper) {
        this.questionProvider = questionProvider;
        this.questionHelper = questionHelper;
        this.name = 'AddonQtypeMultiAnswer';
        this.type = 'qtype_multianswer';
    }
    /**
     * Return the name of the behaviour to use for the question.
     * If the question should use the default behaviour you shouldn't implement this function.
     *
     * @param {any} question The question.
     * @param {string} behaviour The default behaviour.
     * @return {string} The behaviour to use.
     */
    AddonQtypeMultiAnswerHandler.prototype.getBehaviour = function (question, behaviour) {
        if (behaviour === 'interactive') {
            return 'interactivecountback';
        }
        return behaviour;
    };
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeMultiAnswerHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_3__component_multianswer__["a" /* AddonQtypeMultiAnswerComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeMultiAnswerHandler.prototype.isCompleteResponse = function (question, answers) {
        // Get all the inputs in the question to check if they've all been answered.
        var names = this.questionProvider.getBasicAnswers(this.questionHelper.getAllInputNamesFromHtml(question.html));
        for (var name_1 in names) {
            var value = answers[name_1];
            if (!value && value !== false && value !== 0) {
                return 0;
            }
        }
        return 1;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeMultiAnswerHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeMultiAnswerHandler.prototype.isGradableResponse = function (question, answers) {
        // We should always get a value for each select so we can assume we receive all the possible answers.
        for (var name_2 in answers) {
            var value = answers[name_2];
            if (value || value === false) {
                return 1;
            }
        }
        return 0;
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeMultiAnswerHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.questionProvider.compareAllAnswers(prevAnswers, newAnswers);
    };
    /**
     * Validate if an offline sequencecheck is valid compared with the online one.
     * This function only needs to be implemented if a specific compare is required.
     *
     * @param {any} question The question.
     * @param {string} offlineSequenceCheck Sequence check stored in offline.
     * @return {boolean} Whether sequencecheck is valid.
     */
    AddonQtypeMultiAnswerHandler.prototype.validateSequenceCheck = function (question, offlineSequenceCheck) {
        if (question.sequencecheck == offlineSequenceCheck) {
            return true;
        }
        // For some reason, viewing a multianswer for the first time without answering it creates a new step "todo".
        // We'll treat this case as valid.
        if (question.sequencecheck == 2 && question.state == 'todo' && offlineSequenceCheck == '1') {
            return true;
        }
        return false;
    };
    AddonQtypeMultiAnswerHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_question__["a" /* CoreQuestionProvider */], __WEBPACK_IMPORTED_MODULE_2__core_question_providers_helper__["a" /* CoreQuestionHelperProvider */]])
    ], AddonQtypeMultiAnswerHandler);
    return AddonQtypeMultiAnswerHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1880 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeMultichoiceModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(955);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_multichoice__ = __webpack_require__(279);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeMultichoiceModule = /** @class */ (function () {
    function AddonQtypeMultichoiceModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeMultichoiceModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_multichoice__["a" /* AddonQtypeMultichoiceComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_5__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_4__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeMultichoiceHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_multichoice__["a" /* AddonQtypeMultichoiceComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_multichoice__["a" /* AddonQtypeMultichoiceComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeMultichoiceHandler */]])
    ], AddonQtypeMultichoiceModule);
    return AddonQtypeMultichoiceModule;
}());

//# sourceMappingURL=multichoice.module.js.map

/***/ }),
/* 1881 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeNumericalModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_handler__ = __webpack_require__(1882);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQtypeNumericalModule = /** @class */ (function () {
    function AddonQtypeNumericalModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeNumericalModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeNumericalHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeNumericalHandler */]])
    ], AddonQtypeNumericalModule);
    return AddonQtypeNumericalModule;
}());

//# sourceMappingURL=numerical.module.js.map

/***/ }),
/* 1882 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeNumericalHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__addon_qtype_calculated_providers_handler__ = __webpack_require__(405);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


/**
 * Handler to support numerical question type.
 * This question type depends on calculated question type.
 */
var AddonQtypeNumericalHandler = /** @class */ (function (_super) {
    __extends(AddonQtypeNumericalHandler, _super);
    function AddonQtypeNumericalHandler() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'AddonQtypeNumerical';
        _this.type = 'qtype_numerical';
        return _this;
    }
    AddonQtypeNumericalHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AddonQtypeNumericalHandler);
    return AddonQtypeNumericalHandler;
}(__WEBPACK_IMPORTED_MODULE_1__addon_qtype_calculated_providers_handler__["a" /* AddonQtypeCalculatedHandler */]));

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1883 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeRandomSaMatchModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_handler__ = __webpack_require__(1884);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQtypeRandomSaMatchModule = /** @class */ (function () {
    function AddonQtypeRandomSaMatchModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeRandomSaMatchModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeRandomSaMatchHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeRandomSaMatchHandler */]])
    ], AddonQtypeRandomSaMatchModule);
    return AddonQtypeRandomSaMatchModule;
}());

//# sourceMappingURL=randomsamatch.module.js.map

/***/ }),
/* 1884 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeRandomSaMatchHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__addon_qtype_match_providers_handler__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__addon_qtype_match_component_match__ = __webpack_require__(407);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support random short-answer matching question type.
 */
var AddonQtypeRandomSaMatchHandler = /** @class */ (function () {
    function AddonQtypeRandomSaMatchHandler(matchHandler) {
        this.matchHandler = matchHandler;
        this.name = 'AddonQtypeRandomSaMatch';
        this.type = 'qtype_randomsamatch';
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeRandomSaMatchHandler.prototype.getComponent = function (injector, question) {
        // Random behaves like a match question, use the same component.
        return __WEBPACK_IMPORTED_MODULE_2__addon_qtype_match_component_match__["a" /* AddonQtypeMatchComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeRandomSaMatchHandler.prototype.isCompleteResponse = function (question, answers) {
        // This question behaves like a match question.
        return this.matchHandler.isCompleteResponse(question, answers);
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeRandomSaMatchHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeRandomSaMatchHandler.prototype.isGradableResponse = function (question, answers) {
        // This question behaves like a match question.
        return this.matchHandler.isGradableResponse(question, answers);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeRandomSaMatchHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        // This question behaves like a match question.
        return this.matchHandler.isSameResponse(question, prevAnswers, newAnswers);
    };
    AddonQtypeRandomSaMatchHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__addon_qtype_match_providers_handler__["a" /* AddonQtypeMatchHandler */]])
    ], AddonQtypeRandomSaMatchHandler);
    return AddonQtypeRandomSaMatchHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1885 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeShortAnswerModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_components_module__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__providers_handler__ = __webpack_require__(1886);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__component_shortanswer__ = __webpack_require__(964);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var AddonQtypeShortAnswerModule = /** @class */ (function () {
    function AddonQtypeShortAnswerModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeShortAnswerModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__component_shortanswer__["a" /* AddonQtypeShortAnswerComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["l" /* IonicModule */],
                __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["b" /* TranslateModule */].forChild(),
                __WEBPACK_IMPORTED_MODULE_4__components_components_module__["a" /* CoreComponentsModule */],
                __WEBPACK_IMPORTED_MODULE_5__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeShortAnswerHandler */]
            ],
            exports: [
                __WEBPACK_IMPORTED_MODULE_7__component_shortanswer__["a" /* AddonQtypeShortAnswerComponent */]
            ],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__component_shortanswer__["a" /* AddonQtypeShortAnswerComponent */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_6__providers_handler__["a" /* AddonQtypeShortAnswerHandler */]])
    ], AddonQtypeShortAnswerModule);
    return AddonQtypeShortAnswerModule;
}());

//# sourceMappingURL=shortanswer.module.js.map

/***/ }),
/* 1886 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeShortAnswerHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__component_shortanswer__ = __webpack_require__(964);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support short answer question type.
 */
var AddonQtypeShortAnswerHandler = /** @class */ (function () {
    function AddonQtypeShortAnswerHandler(utils) {
        this.utils = utils;
        this.name = 'AddonQtypeShortAnswer';
        this.type = 'qtype_shortanswer';
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeShortAnswerHandler.prototype.getComponent = function (injector, question) {
        return __WEBPACK_IMPORTED_MODULE_2__component_shortanswer__["a" /* AddonQtypeShortAnswerComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeShortAnswerHandler.prototype.isCompleteResponse = function (question, answers) {
        return (answers['answer'] || answers['answer'] === 0) ? 1 : 0;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeShortAnswerHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeShortAnswerHandler.prototype.isGradableResponse = function (question, answers) {
        return this.isCompleteResponse(question, answers);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeShortAnswerHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, 'answer');
    };
    AddonQtypeShortAnswerHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonQtypeShortAnswerHandler);
    return AddonQtypeShortAnswerHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1887 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeTrueFalseModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_handler__ = __webpack_require__(1888);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonQtypeTrueFalseModule = /** @class */ (function () {
    function AddonQtypeTrueFalseModule(questionDelegate, handler) {
        questionDelegate.registerHandler(handler);
    }
    AddonQtypeTrueFalseModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeTrueFalseHandler */]
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__core_question_providers_delegate__["a" /* CoreQuestionDelegate */], __WEBPACK_IMPORTED_MODULE_2__providers_handler__["a" /* AddonQtypeTrueFalseHandler */]])
    ], AddonQtypeTrueFalseModule);
    return AddonQtypeTrueFalseModule;
}());

//# sourceMappingURL=truefalse.module.js.map

/***/ }),
/* 1888 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonQtypeTrueFalseHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__addon_qtype_multichoice_component_multichoice__ = __webpack_require__(279);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/**
 * Handler to support true/false question type.
 */
var AddonQtypeTrueFalseHandler = /** @class */ (function () {
    function AddonQtypeTrueFalseHandler(utils) {
        this.utils = utils;
        this.name = 'AddonQtypeTrueFalse';
        this.type = 'qtype_truefalse';
    }
    /**
     * Return the Component to use to display the question.
     * It's recommended to return the class of the component, but you can also return an instance of the component.
     *
     * @param {Injector} injector Injector.
     * @param {any} question The question to render.
     * @return {any|Promise<any>} The component (or promise resolved with component) to use, undefined if not found.
     */
    AddonQtypeTrueFalseHandler.prototype.getComponent = function (injector, question) {
        // True/false behaves like a multichoice, use the same component.
        return __WEBPACK_IMPORTED_MODULE_2__addon_qtype_multichoice_component_multichoice__["a" /* AddonQtypeMultichoiceComponent */];
    };
    /**
     * Check if a response is complete.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if complete, 0 if not complete, -1 if cannot determine.
     */
    AddonQtypeTrueFalseHandler.prototype.isCompleteResponse = function (question, answers) {
        return answers['answer'] ? 1 : 0;
    };
    /**
     * Whether or not the handler is enabled on a site level.
     *
     * @return {boolean|Promise<boolean>} True or promise resolved with true if enabled.
     */
    AddonQtypeTrueFalseHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Check if a student has provided enough of an answer for the question to be graded automatically,
     * or whether it must be considered aborted.
     *
     * @param {any} question The question.
     * @param {any} answers Object with the question answers (without prefix).
     * @return {number} 1 if gradable, 0 if not gradable, -1 if cannot determine.
     */
    AddonQtypeTrueFalseHandler.prototype.isGradableResponse = function (question, answers) {
        return this.isCompleteResponse(question, answers);
    };
    /**
     * Check if two responses are the same.
     *
     * @param {any} question Question.
     * @param {any} prevAnswers Object with the previous question answers.
     * @param {any} newAnswers Object with the new question answers.
     * @return {boolean} Whether they're the same.
     */
    AddonQtypeTrueFalseHandler.prototype.isSameResponse = function (question, prevAnswers, newAnswers) {
        return this.utils.sameAtKeyMissingIsBlank(prevAnswers, newAnswers, 'answer');
    };
    /**
     * Prepare and add to answers the data to send to server based in the input. Return promise if async.
     *
     * @param {any} question Question.
     * @param {any} answers The answers retrieved from the form. Prepared answers must be stored in this object.
     * @param {boolean} [offline] Whether the data should be saved in offline.
     * @param {string} [siteId] Site ID. If not defined, current site.
     * @return {void|Promise<any>} Return a promise resolved when done if async, void if sync.
     */
    AddonQtypeTrueFalseHandler.prototype.prepareAnswers = function (question, answers, offline, siteId) {
        if (question && typeof answers[question.optionsName] != 'undefined' && !answers[question.optionsName]) {
            // The user hasn't answered. Delete the answer to prevent marking one of the answers automatically.
            delete answers[question.optionsName];
        }
    };
    AddonQtypeTrueFalseHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__providers_utils_utils__["a" /* CoreUtilsProvider */]])
    ], AddonQtypeTrueFalseHandler);
    return AddonQtypeTrueFalseHandler;
}());

//# sourceMappingURL=handler.js.map

/***/ }),
/* 1889 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonStorageManagerModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__addon_storagemanager_providers_coursemenu_handler__ = __webpack_require__(1890);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__core_course_providers_options_delegate__ = __webpack_require__(72);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var AddonStorageManagerModule = /** @class */ (function () {
    function AddonStorageManagerModule(courseOptionsDelegate, courseMenuHandler) {
        this.courseOptionsDelegate = courseOptionsDelegate;
        this.courseMenuHandler = courseMenuHandler;
        // Register handlers.
        this.courseOptionsDelegate.registerHandler(this.courseMenuHandler);
    }
    AddonStorageManagerModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [],
            imports: [],
            providers: [
                __WEBPACK_IMPORTED_MODULE_1__addon_storagemanager_providers_coursemenu_handler__["a" /* AddonStorageManagerCourseMenuHandler */]
            ],
            exports: []
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__core_course_providers_options_delegate__["a" /* CoreCourseOptionsDelegate */],
            __WEBPACK_IMPORTED_MODULE_1__addon_storagemanager_providers_coursemenu_handler__["a" /* AddonStorageManagerCourseMenuHandler */]])
    ], AddonStorageManagerModule);
    return AddonStorageManagerModule;
}());

//# sourceMappingURL=storagemanager.module.js.map

/***/ }),
/* 1890 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddonStorageManagerCourseMenuHandler; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
// (C) Copyright 2015 Martin Dougiamas
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

/**
 * Handler to inject an option into course menu so that user can get to the manage storage page.
 */
var AddonStorageManagerCourseMenuHandler = /** @class */ (function () {
    function AddonStorageManagerCourseMenuHandler() {
        this.name = 'AddonStorageManager';
        this.priority = 500;
        this.isMenuHandler = true;
    }
    /**
     * Checks if the handler is enabled for specified course. This handler is always available.
     *
     * @param {number} courseId Course id
     * @param {any} accessData Access data
     * @param {any} [navOptions] Navigation options if any
     * @param {any} [admOptions] Admin options if any
     * @return {boolean | Promise<boolean>} True
     */
    AddonStorageManagerCourseMenuHandler.prototype.isEnabledForCourse = function (courseId, accessData, navOptions, admOptions) {
        return true;
    };
    /**
     * Check if the handler is enabled on a site level.
     *
     * @return {boolean | Promise<boolean>} Whether or not the handler is enabled on a site level.
     */
    AddonStorageManagerCourseMenuHandler.prototype.isEnabled = function () {
        return true;
    };
    /**
     * Returns the data needed to render the handler.
     *
     * @return {CoreCourseOptionsMenuHandlerData} Data needed to render the handler.
     */
    AddonStorageManagerCourseMenuHandler.prototype.getMenuDisplayData = function () {
        return {
            icon: 'cube',
            title: 'addon.storagemanager.managestorage',
            page: 'AddonStorageManagerCourseStoragePage',
            class: 'addon-storagemanager-coursemenu-handler'
        };
    };
    AddonStorageManagerCourseMenuHandler = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], AddonStorageManagerCourseMenuHandler);
    return AddonStorageManagerCourseMenuHandler;
}());

//# sourceMappingURL=coursemenu-handler.js.map

/***/ }),
/* 1891 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShowpdfPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


/**
 * Generated class for the ShowpdfPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */
var ShowpdfPage = /** @class */ (function () {
    function ShowpdfPage(navParams) {
        this.navParams = navParams;
        this.displayData = {};
        this.displayData = this.navParams.get('displayData');
    }
    ShowpdfPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-showpdf',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\pages\showpdf\showpdf.html"*/'<!--\n  Generated template for the ShowpdfPage page.\n\n  See http://ionicframework.com/docs/components/#navigation for more info on\n  Ionic pages and navigation.\n-->\n<ion-header>\n  <ion-navbar>\n    <ion-title>showpdf</ion-title>\n  </ion-navbar>\n</ion-header>\n\n<ion-content padding>\n  <!-- <pdf-viewer [src]="displayData.pdfSource"\n  [show-all]="true"\n  [original-size]="false"\n  [zoom]=1\n  [render-text]="false"\n  [autoresize]="true"\n  style="display: block" >\n</pdf-viewer> -->\n\n</ion-content>\n'/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\pages\showpdf\showpdf.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */]])
    ], ShowpdfPage);
    return ShowpdfPage;
}());

//# sourceMappingURL=showpdf.js.map

/***/ })
],[1019]);
//# sourceMappingURL=main.js.map